# -*- coding: iso8859_2 -*-
import re
from signal import *

#configuration of processes


# operations
FORCE        = "01"
STOP         = "02"
LIST         = "03"
HZRELOAD     = "04"
KOMSERRELOAD = "05"
SERVERRELOAD = "15"
HZRETRIES    = 40

service_options = {
    'FORCE': FORCE,
    'STOP': STOP,
    'LIST': LIST,
    'HZRELOAD': HZRELOAD,
    'KOMSERRELOAD': KOMSERRELOAD,
    'RELOAD': SERVERRELOAD,
}

CONN_END	= "KONIEC"
SELECT		= "SELECT"
SELECTN		= "SELECTN"
SELECTI     = "SELECTI"
SELECTT     = "SELECTT"
DELETE		= "DELETE"
BEGIN		= "BEGIN"
ROLLBACK	= "ROLLBACK"
COMMIT		= "COMMIT"
UPDATE 		= "UPDATE"
PREPARE_UPDATE = "PREPARE_UPDATE"
AUTH        = "AUTH"
INSERT		= "INSERT"
CREATEU		= "CREATEU"
DROPU		= "DROPU"
ALTERU		= "ALTERU"
LISTAFIRM   = "LISTAFIRM"
FIRMA       = "FIRMA "
LISTAODDZ   = "LISTAODDZ"
ODDZIAL     = "ODDZIAL "
MENUUPR     = "MENUUPR"
FUNCTION    = "FUNCTION"
ZAPISZBIN   = "ZAPISZBIN"
WCZYTAJBIN  = "WCZYTAJBIN"
OKRES       = "OKRES"
#CONNECT	= "04"
#DISCONNECT	= "05"
NO_SUCH_OPTION	= "06"
# odpowiedzi na opcje
FORCE_OK	= "07"
FORCE_NOK	= "08"
STOP_OK		= "09"
STOP_NOK	= "10"
LIST_OK		= "11"
#LIST_NOK	= "12"
# rezultaty
POLSQL		= "13"
BLPOLSQL	= "-1"
RECEIVED	= "RECEIVED"
RELOAD_OK	= "14"
SERVERRELOAD_OK = "16"
SERVERRELOAD_NOK = "17"


# polecenia bazodanowe
SQL_GET_USER = "SELECT rsf_getuserid()"
SQL_MAX_CONN = "SELECT nextval('rs_polaczenia_id');"
SQL_INSERT_CONN = "INSERT INTO rs_polaczenia (pol_id, op_id, nr_ip) VALUES (%s, %s,'%s')"
SQL_END_CONN = "UPDATE rs_polaczenia SET koniec = clock_timestamp(),typ='P' \
WHERE pol_id=%s"
SQL_SUDDEN_END_CONN = "UPDATE rs_polaczenia SET koniec = (SELECT clock_timestamp()),\
typ='R' WHERE pol_id=%s"
SQL_INCORRECT_END_CONN = "UPDATE rs_polaczenia SET koniec = (SELECT clock_timestamp()),\
typ='N' WHERE pol_id=%s"
SQL_FORCE_END_CONN = "UPDATE rs_polaczenia SET koniec = (SELECT clock_timestamp()),\
typ='S' WHERE pol_id=%s"

# varia
#AB 25.04.22r
PLIK_KONFIGURACJI = 'rs-and.conf'
MAIL_SERWISOWY = 'admin-rs@recordsystem.com.pl'  #AB 26.08.22r
OPTION_LEN=2
STANDARD_OPERATOR = 'anakonda'
STANDARD_OPERATOR_ID = '0'
OPOZNIENIE_RESTARTU_KOMSERA = 180  # (sekund)
TIMEOUT_POBIERANIA_KURSOW_WALUT = 20  # (sekund, z tym, e bd 3 prby)
DOZWOLONE_PROTO_POBIERANIA_KURSOW = 'http', 'https', 'ftp'
DOM_MAXFD = 1024  # domylna oczekiwana max. liczba deskryptorw dla danego procesu
DOMYSLNA_KOMENDA_ITERPRETERA = 'python'
NAZWA_KATALOGU_BACKENDOW = '.pgbackends'  # nazwa katalogu z plikami z pidami
                                          # i hostami/portami postgresowych backendw
                                          # -- musi by zgodna z analogiczn zmienn
                                          # w agata/classes/layer/AgataPgsql.class
                                          # (patrz mantis #0001904)
IGNOROWANE_NAZWY_PRZY_AKTUALIZACJI_PAN = ('.svn', 'pan.log', '.kopia_zapasowa_zrodel_PAN',
                                          'konfig.ini', 'logging.ini')
MAX_LICZBA_ZCACHEOWANYCH_AKTUALIZACJI_PAN = 5
DOMYSLNA_MIN_DLUGOSC_KODU_DOSTEPU_PAN = 6
OPOZNIENIE_POCZATKU_OBSLUGI_KLIENTA_PAN = 5   # w sekundach, dla bezpieczestwa (utrudnia ominicie
                                              # opnie w przypadku bdnego podawania kodw dostpu)
SPODZIEWANY_ODSTEP_PRZED_AKT_PAN = 30   # w sekundach -- spodziewany odstep midzy daniem
                                        # przygotowania aktualizacji a daniem waciwej
                                        # aktualizacji (realny odstp zaley od klienta PAN)

SQL_OK = 'OK'

# dla obiektow AnakondaSocket z przyleglosciami:
ASOCK_DLUGOSC_PIERW = 4 # dawniej TCP_LEN_LEN [patrz nizej]
                        # -- okresla dlugosc pierwszej informacji przesylanej
                        # miedzy socketami AnakondaSocket (metody send/recv i towarzyszace)
                        # UWAGA: TA WARTOSC MUSI BYC IDENTYCZNA DLA KLIENTA I SERWERA!
                        # DLA ZGODNOSCI ZE STARYM KLIENTEM/SERWEREM POWINNA BYC ROWNA 4

LIMIT_WIELKOSCI_STAREGO_PAKIETU = int(ASOCK_DLUGOSC_PIERW * '9')
                        # TEGO ROWNIEZ NIE ZMIENIAC! (stary klient/serwer nie obsluguje
                        # prawidlowo pakietow wiekszych niz 9999 znakow)

MAX_DLUGOSC_INFO_O_DLUGOSCI = 20  # 2 ** 64 ma 20 cyfr, wicej na pewno nie trzeba :)
                                  # -- to musi by tak samo tu i util/RSConst.py w kliencie

RE_LOKAL_ADR = re.compile(  # wyraenie regularne: lokalny adres IP
    r'('
        r'(127|10)\.\d{1,3}'           # 127.n... lub 10.n...
    r'|'
        r'172\.(1[6-9]|2[0-9]|3[01])'  # od 172.16... do 172.31...
    r'|'
        r'192\.168'                    # 192.168...
    r')'
    r'\.\d{1,3}\.\d{1,3}$'             # .n.n
)

ODSTEP_SPR_POLACZENIA = 5  # co ile sekund ma si budzi wtek sprawdzajcy cigo
                           # poczenia, gdy akurat nie ma adnego przesyu -- ma to
                           # zastosowanie tylko jeeli na serwerowym anakondowym sockecie
                           # wykonano metod wlacz_sprawdzanie_polaczenia() (z argumentem
                           # akcja_w_razie_zerwania bdcym funkcj/metod)

# 2 ustawienia do optymalizacji socketow:
SOCK_BUF_OPTIMUM = 4096  # argument dla socket.recv (odbieramy porcjami po tyle bajtow)
                         # wg dokumentacji pythona powinna to byc mala potega 2
                         # (np. 4096 lub 8192);
                         # 0 oznacza, ze nie dzielimy -- lecimy calymi pakietami

SSL_BUF_DLA_KLIENTA = True  # jezeli prawda, SOCK_BUF_OPTIMUM ma zastosowanie rowniez do
                            # polaczen SSL (w przeciwnym wypadku lecimy calymi pakietami)

SOCK_BUF_WYSYL_PLIK = 256 * 1024  # dugo ksw danych odczytywanych z pliku i wysyanych przez
                                  # AnakondaSocket.wyslij_plik (warto by byo rednio due, np. 256 KB)

# zaszosci (patrz ponizsze opisy):
TCP_LEN_LEN = 4  # to juz nie dotyczy AnakondaSocket'ow -- bylo natomiast i JEST NADAL
                 # uzywane na serwerze w kontekscie pipe'ow

UPD_TCP_LEN_LEN = 4  # to przedtem bylo TCP_LEN_LEN (zostalo rozdzielone od powyzszych),
                     # wystepuje w as2.4/rs_anakonda_server_update.py (serwer) oraz
                     # w as25/admin/RSUpdate.py (klient)
                     # (ale w tym ostatnim za return, wiec jako atrapa)
                     # FIXME: te miejsca w tych 2 modulach sa do przejrzenia/wyczyszczenia

# rczne killowanie procesw:
ODSTEP_SPR_KILLOWANIA = 3  # po ilu sekundach ma by sprawdzane czy prba killowania
                           # procesu danym sygnaem udaa si (w razie niepowodzenia
                           # niezwocznie podejmowana jest prba kolejnym sygnaem...)

# reload serwera:
NAZWA_BLOKADY_RELOADU = '.plik_blokady_reloadu.lock'
PRZYROSTEK_NAZWY_PLIKU_STANU = 'RELOADTYMCZAS'

# sygnaly pod wplywem ktorych rozsadnie jest czysto sie konczyc
#terminatingSigs = [SIGHUP, SIGINT, SIGQUIT, SIGABRT, SIGKILL, SIGTERM, SIGSTOP, SIGTSTP, SIGTTIN, SIGTTOU, SIGPOLL, SIGPROF, SIGVTALRM, SIGIO, SIGPWR]
terminatingSigs = [SIGTERM, SIGHUP]
#wywalony SIGTERM

ZALEGLE_POMIN = 'Z'
ZALEGLE_JEDNO = 'J'
ZALEGLE_WSZYSTKIE = 'W'
TRAKTOWANIE_ZALEGLYCH = (ZALEGLE_POMIN, ZALEGLE_JEDNO, ZALEGLE_WSZYSTKIE)
