# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:        fs_amortyzacje.py
# Purpose:     wyswietla, dodaje,usuwa amortyzacje operujac na tabeli rs_arkusze_amortyzacji
# Author:      Pawel Wojcikowski
# Created:     2008/11/12
# RCS-ID:      $Id: fs_amortyzacje.py$
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
#2009.01.26 Micha Raburski - tworzenie dowodu ksigowego podczas zamykania amortyzacji
#2011.03.07 Mariusz Rajfura - dodanie konta umorzenia podat przy zamykaniu amortyzacji (4338)
#2017.03.24 Konrad Opieka (10402) refaktoryzacja
#2021-11-10 Aleksander Bargie (12702) Eval po stronie serwera

stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'GrupaF':[1,5,11], 'StanF':[1,5,11], 'DataF':[1,5,11], 'Grupa':[1,6,7,11], 'Data':[1,6,7,11],
           'Numer':[6,11], 'KluczDowodu':[11]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga: wywoanie funkcji fs_amortyzacje z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1,5,6,11]:
        DataF = klucze['DataF']
        GrupaF = klucze['GrupaF']
        StanF = klucze['StanF']
    if Funkcja in [1,6,7,11]:
        Data = klucze['Data']
        Grupa = klucze['Grupa']
    if Funkcja in [6,11]:
        Numer = klucze['Numer']
    if Funkcja in [11]:
        klucz_dowodu = klucze['KluczDowodu']

dane = []
wyn1 = []
wyn2 = []

#klucze_id=klucze[6]

UprDodawanie = (((self.oddzial_id,'174213') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie  = (((self.oddzial_id,'174214') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZamykanie = (((self.oddzial_id,'174216') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if Funkcja in [1,5,6,11]:
    if (not rsglobal.SprawdzCzyToData(DataF)) and DataF != "    -  -  ":
        stat = "BL_DATA"
        dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#---- OKIENKO DODAWANIA ---(7)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 7 and stat== 'OK':
    if Data == "    -  -  ":
        stat = "BR_DATA"
        dane.append(stat)
    elif (not rsglobal.SprawdzCzyToData(Data)):
        stat = "BL_DATA"
        dane.append(stat)
    if Grupa != '' :
        sql = "SELECT kod FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+Grupa+"';"
        dump,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if len(d) == 0:
            stat = "BL_GRUPA"
            dane.append(stat)
    else:
        stat = "BR_GRUPA"
        dane.append(stat)
        
        
#-----------------------------------------------------------------------------------------------------------------------
#--- Tworzenie nowego arkusza amortyzacji (1)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if not UprDodawanie:
        stat = 'UPR INS'
        
    # sprawdzenie, czy poprzednie miesice s umorzone
    if stat == 'OK':
        spr ="SELECT stp.srodek_id,stp.miesiac||'/'||stp.rok FROM rs_srodki_trwale_plan stp "
        spr+="INNER JOIN rs_srodki_trwale st ON (st.firma_id=stp.firma_id AND st.srodek_id=stp.srodek_id) "
        spr+="WHERE stp.firma_id='"+self.firma_id+"' "
        spr+="AND ((stp.miesiac<'"+str(Data[5:7])+"' AND stp.rok='"+str(Data[0:4])+"') OR "
        spr+="(stp.rok<'"+str(Data[0:4])+"')) AND st.grupa='"+str(Grupa)+"' AND stp.umorzone=FALSE;"
        stat,dane,dump,dump = self.PolSQL.Execute(spr,3)
        if stat=='OK':
            if len(dane) > 0:
                stat = "rodek trway "+dane[0][0].strip()+" nie zosta umorzony w miesicu "+dane[0][1]
    
    if stat == 'OK':
        spr ="SELECT stp.firma_id, stp.srodek_id , stp.rach_kwota, stp.rach_kwota, stp.podat_kwota, stp.podat_kwota "
        spr+="FROM rs_srodki_trwale_plan stp "
        spr+="INNER JOIN rs_srodki_trwale st ON (st.firma_id=stp.firma_id AND st.srodek_id=stp.srodek_id) "
        spr+="WHERE stp.firma_id='"+self.firma_id+"' AND stp.miesiac='"+str(Data[5:7])+"' "
        spr+="AND stp.rok='"+str(Data[0:4])+"' AND st.grupa='"+str(Grupa)+"' AND stp.umorzone=FALSE;"
        stat,dane,dump,dump = self.PolSQL.Execute(spr,3)
    
        if stat == 'OK':
            if len(dane) == 0:
                stat = "BR POZ AMORT"
            
        if stat == 'OK':
            Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND data=\\\'"+Data+"\\\'"
            Select  = "SELECT rsf_klucz_where_new('rs_arkusze_amortyzacji','"+Warunek+"','numer');"
            stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
            Numer = str(dane[0][0])
        
        if stat == 'OK':
            query ="INSERT INTO rs_arkusze_amortyzacji (firma_id, numer, data, grupa, stan) "
            query+="VALUES ('"+self.firma_id+"','"+str(Numer)+"','"+str(Data)+"','"+str(Grupa)+"','W');"
            stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
            if stat != 'OK':
                stat = u"Bd wstawienia arkusza : "+stat
                dane.append(stat)
        
        if stat == 'OK':
            wyn2 = Numer
            #klucze_id.append([str(Grupa),str(Data),str(Numer)+'.0'])
            
            query1 ="INSERT INTO rs_arkusze_amortyzacji_pozycje (firma_id,data,numer,srodek_id,"
            query1+="rach_przed,rach_umorz,rach_po,podat_przed,podat_umorz,podat_po) "
            query1+="SELECT stp.firma_id,'"+str(Data)+"','"+str(Numer)+"', stp.srodek_id, "
            query1+="st.wartosc_aktualna, stp.rach_kwota, st.wartosc_aktualna-stp.rach_kwota, "
            query1+="st.wartosc_aktualna_p, stp.podat_kwota, st.wartosc_aktualna_p-stp.podat_kwota "
            query1+="FROM rs_srodki_trwale_plan stp INNER JOIN rs_srodki_trwale st "
            query1+="ON (st.firma_id=stp.firma_id AND st.srodek_id=stp.srodek_id) "
            query1+="WHERE stp.firma_id='"+self.firma_id+"' "
            query1+="AND stp.miesiac='"+str(Data[5:7])+"' AND stp.rok='"+str(Data[0:4])+"' "
            query1+="AND st.grupa='"+str(Grupa)+"' AND stp.umorzone=FALSE;"
            stat,dump,dump,dump = self.PolSQL.Execute(query1 ,1) 
            if stat != 'OK':
                stat = "BL INS AMORT"
                dane.append(stat)
                
        if stat == 'OK':
            query2 ="UPDATE rs_srodki_trwale_plan "
            query2+="SET umorzone=TRUE WHERE firma_id='"+self.firma_id+"' AND rok='"+str(Data[0:4])+"' "
            query2+="AND miesiac='"+str(Data[5:7])+"' "
            query2+="AND srodek_id IN (SELECT stp.srodek_id FROM rs_srodki_trwale_plan stp INNER JOIN "
            query2+="rs_srodki_trwale st ON (stp.firma_id=st.firma_id AND stp.srodek_id=st.srodek_id) "
            query2+="WHERE stp.firma_id='"+self.firma_id+"' AND st.grupa='"+str(Grupa)+"');"
            stat,dump,dump,dump = self.PolSQL.Execute(query2 ,1)
            if stat != 'OK':
                stat="BL UPD_STP"   
                dane.append(stat)
                    
                    
#-----------------------------------------------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat = 'UPR DEL'
        
    if stat == 'OK':
        if stat == 'OK':
            sql ="SELECT stan FROM rs_arkusze_amortyzacji "
            sql+="WHERE firma_id='"+self.firma_id+"' AND numer="+str(Numer)+" AND data='"+str(Data)+"';"
            stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(dane) == 0:
                stat = 'BR ARK AM'
        if stat == 'OK':
            if dane[0][0] == 'Z':
                stat = 'ST ARK AM'

        SQL ="UPDATE rs_srodki_trwale_plan SET umorzone=FALSE WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND rok='"+str(Data[0:4])+"' AND miesiac='"+str(Data[5:7])+"' AND umorzone='TRUE' "
        SQL+="AND srodek_id IN (SELECT srodek_id FROM rs_arkusze_amortyzacji_pozycje "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND numer="+str(Numer)+" AND data='"+str(Data)+"');"
        
        SQL+="DELETE FROM rs_arkusze_amortyzacji_pozycje WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND numer="+str(Numer)+" AND data='"+str(Data)+"';"
        SQL+="DELETE FROM rs_arkusze_amortyzacji WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND data='"+str(Data)+"' AND numer="+str(Numer)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat != 'OK':
            stat = "BL DEL_UMORZ"
            dane.append(stat)        

       
#-----------------------------------------------------------------------------------------------------------------------
#---   ZAMYKANIE DOKUMENTU AMORTYZACJI (11)   
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    if not UprZamykanie:
        stat = 'UPR ZAM'
        
    #sprawdzenie czy wybrany klucz dowodu ksiegowego jest ok
    if stat == 'OK':
        DowodD = rsglobal.Dekoduj(klucz_dowodu[0])
        NazwaD = rsglobal.Dekoduj(klucz_dowodu[1])
        DataD  = rsglobal.Dekoduj(klucz_dowodu[2])
        NumerD = klucz_dowodu[3]

        sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"',"
        sql+="'[\\\'"+self.okres_id+"\\\',\\\'"+DowodD+"\\\',\\\'"+NazwaD+"\\\',\\\'"+DataD+"\\\']','D');"
        stat,Test,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat=='OK':        
        if Test[0][0]<>'OK':
            stat=="PO DOK"
        
    if stat=='OK':
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        sql+="'[\\\'"+self.okres_id+"\\\',\\\'"+DowodD+"\\\',\\\'"+NazwaD+"\\\',\\\'"+DataD+"\\\']','D');"
        stat,DNr,dump,dump = self.PolSQL.Execute(sql, 3)
        if DNr[0][0] in (None,'None',''):
            stat == "PO DOK"
        else:
            if DNr[0][0] > NumerD:
                NumerD = rsglobal.Dekoduj(DNr[0][0])
        
    #dowd jest ok wic tworzymy sam dowd 
    if stat == 'OK':
        #pobranie danych ze srodkow trwalych
        Select ="SELECT aa.srodek_id,aa.rach_umorz,aa.podat_umorz,st.czy_podatkowa, "
        Select+="st.konto_umorz,st.konto_amort,st.konto_amort_p,st.nazwa,st.konto_umorz_p "
        Select+="FROM rs_arkusze_amortyzacji_pozycje aa INNER JOIN rs_srodki_trwale st USING (firma_id,srodek_id) "
        Select+="WHERE aa.firma_id='"+self.firma_id+"' AND aa.data='"+Data+"' AND aa.numer="+str(Numer)+" ORDER BY aa.srodek_id;"
        stat,DaneSr,dump,dump = self.PolSQL.Execute(Select,3)
    if stat == 'OK':
        if len(DaneSr) == 0:
            stat = 'BR POZ SR'
    
    if stat == 'OK':
        SQL = ''
        #dodanie nagwka dowodu ksiegowego
        SQLDK ="INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer,stan) VALUES "
        SQLDK+="('"+self.firma_id+"','"+self.okres_id+"','"+DowodD+"','"+NazwaD+"','"+DataD+"',"+str(NumerD)+",'W');"
        NrPoz=0
        for srodek in DaneSr:
            #dekrety tylko dla srodkow, ktore posiadaja kwoty wieksze od zera
            #w ten sposob omijamy srodki zawieszone
            if stat == 'OK':
                if srodek[1] > 0 or srodek[2] > 0:
                    Dekretowac = True
                else:
                    Dekretowac = False
            
            if stat == 'OK' and Dekretowac:
                SrodekId=rsglobal.Dekoduj(srodek[0])
                UmorzRach=str(srodek[1])
                UmorzPodat=str(srodek[2])
                CzyPodatkowa=srodek[3]
                KontoUmorz=rsglobal.Dekoduj(srodek[4]).strip()
                KontoAmort=rsglobal.Dekoduj(srodek[5]).strip()
                KontoAmortPod=rsglobal.Dekoduj(srodek[6]).strip()
                Tresc="Amort. rodka "+SrodekId.strip()+' - '+rsglobal.Dekoduj(srodek[7]).strip()
                KontoUmorzPod=rsglobal.Dekoduj(srodek[8]).strip()
                Tresc=Tresc[:100]
                
                #-----------------------------
                #zapis danych do tabeli rs_srodki_trwale_dekrety
                #-----------------------------
                
                SQLDK+="INSERT INTO rs_srodki_trwale_dekrety (firma_id,srodek_id,typ,okres_id,"
                SQLDK+="dowod_id,nazwa_id,data,numer) VALUES ('"+self.firma_id+"','"+SrodekId+"','UM',"
                SQLDK+="'"+self.okres_id+"','"+DowodD+"','"+NazwaD+"','"+DataD+"',"+str(NumerD)+");"
            
                #-----------------------------
                #testy poprawnoci danych
                #-----------------------------
                Select="SELECT srodek_id FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"';"
                stat,DaneTest,dump,dump = self.PolSQL.Execute(Select, 3)
                
            if stat == 'OK' and Dekretowac:
                if len(DaneTest) == 0:
                    stat = 'Brak rodka trwaego '+SrodekId
            
            #konto umorze
            if stat == 'OK' and Dekretowac:
                if KontoUmorz in (None,'None','0','0.0'):
                    stat = 'Brak konta umorzenia dla rodka '+SrodekId
                else:
                    Select="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoUmorz+"');"
                    stat,DaneTmp,dump,dump = self.PolSQL.Execute(Select, 3)
                    if stat=='OK':
                        if (DaneTmp == []) or (DaneTmp == None):
                            stat='Bdy pobierania konta umorzenia dla rodka '+SrodekId
                    
                    if stat == 'OK':
                        #AB 10.11.21r
                        rsglobal.ZapiszDoLogow("rseval {}".format(DaneTmp[0][0]))
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat = 'Niepoprawne konto umorzenia dla rodka '+SrodekId
                        elif not Dane[2]:
                            stat = 'Konto umorzenia rodka '+SrodekId+' nie jest ksigowane'

            #konto amortyzacji
            if stat == 'OK' and Dekretowac:
                if KontoAmort in (None,'None','0','0.0'):
                    stat = 'Brak konta amortyzacji dla rodka '+SrodekId
                else:
                    Select="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoAmort+"');"
                    stat,DaneTmp,dump,dump = self.PolSQL.Execute(Select, 3)
                    if stat == 'OK':
                        if (DaneTmp == []) or (DaneTmp == None):
                            stat='Bdy pobierania konta amortyzacji dla rodka '+SrodekId
                            wyn2.append(stat)
                    
                    if stat=='OK':
                        #AB 10.11.21r
                        rsglobal.ZapiszDoLogow("rseval {}".format(DaneTmp[0][0]))
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat = 'Niepoprawne konto amortyzacji dla rodka '+SrodekId
                            wyn2.append(stat)
                        elif not Dane[2]:
                            stat = 'Konto amortyzacji rodka '+SrodekId+' nie jest ksigowane'
                            wyn2.append(stat)

            #konto umorzenia podatkowego
            if stat == 'OK' and Dekretowac and CzyPodatkowa:
                if KontoUmorzPod in (None,'None','0','0.0'):
                    stat='Brak konta umorzenia podatkowego dla rodka '+SrodekId
                    wyn2.append(stat)
                else:
                    Select="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoUmorzPod+"');"
                    stat,DaneTmp,dump,dump = self.PolSQL.Execute(Select,3)
                    if stat=='OK':
                        if (DaneTmp == []) or (DaneTmp == None):
                            stat='Bdy pobierania konta umorzenia podatkowego dla rodka '+SrodekId
                            wyn2.append(stat)
                    
                    if stat=='OK':
                        #AB 10.11.21r
                        rsglobal.ZapiszDoLogow("rseval {}".format(DaneTmp[0][0]))
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='Niepoprawne konto umorzenia podatkowego dla rodka '+SrodekId
                            wyn2.append(stat)
                        elif not Dane[2]:
                            stat='Konto umorzenia podatkowego rodka '+SrodekId+' nie jest ksigowane'
                            wyn2.append(stat)
                        #elif not Dane[4]:
                        #    stat='Konto umorzenia podatkowego rodka '+SrodekId+' jest bilansowe'
                        #    wyn2.append(stat)

            #konto amortyzacji podatkowej
            if stat=='OK' and Dekretowac and CzyPodatkowa:
                if KontoAmortPod in (None,'None','0','0.0'):
                    stat='Brak konta amortyzacji podatkowej dla rodka '+SrodekId
                    wyn2.append(stat)
                else:
                    Select="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoAmortPod+"');"
                    stat,DaneTmp,dump,dump = self.PolSQL.Execute(Select,3)
                    if stat=='OK':
                        if (DaneTmp == []) or (DaneTmp == None):
                            stat='Bdy pobierania konta amortyzacji podatkowej dla rodka '+SrodekId
                            wyn2.append(stat)
                    
                    if stat=='OK':
                        #AB 10.11.21r
                        rsglobal.ZapiszDoLogow("rseval {}".format(DaneTmp[0][0]))
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='Niepoprawne konto amortyzacji podatkowej dla rodka '+SrodekId
                            wyn2.append(stat)
                        elif not Dane[2]:
                            stat='Konto amortyzacji podatkowej rodka '+SrodekId+' nie jest ksigowane'
                            wyn2.append(stat)
                            
            #-----------------------------
            #dodanie pozycji rachunkowej
            #-----------------------------
            if stat == 'OK' and Dekretowac:
                if not UmorzRach in (None,'None','0','0.0'):
                    NrPoz=NrPoz+1
                    SQLDK+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                    SQLDK+="nr_poz,nr_ppoz,nr_pozw, konto_wn, kwota_wn, tresc_wn,waluta_wn, kurs_wn, kwota_wal_wn, "
                    SQLDK+="konto_ma, kwota_ma, tresc_ma,waluta_ma, kurs_ma, kwota_wal_ma,sposob_rozl) VALUES "
                    SQLDK+="('"+self.firma_id+"','"+self.okres_id+"','"+DowodD+"','"+NazwaD+"','"+DataD+"',"+str(NumerD)+","
                    SQLDK+=str(NrPoz)+",0,1,'"+KontoAmort+"',"+UmorzRach+",'"+Tresc+"','PLN',1,"+UmorzRach+","
                    SQLDK+="'"+KontoUmorz+"',"+UmorzRach+",'"+Tresc+"','PLN',1,"+UmorzRach+",'');"
                
            #-----------------------------
            #dodanie pozycji podatkowej
            #-----------------------------
                if CzyPodatkowa and (not UmorzPodat in (None,'None','0','0.0')):
                    NrPoz=NrPoz+1
    
                    SQLDK+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                    SQLDK+="nr_poz,nr_ppoz,nr_pozw,konto_wn,kwota_wn,tresc_wn,waluta_wn,kurs_wn,kwota_wal_wn,sposob_rozl,"
                    SQLDK+="konto_ma,kwota_ma,tresc_ma,waluta_ma,kurs_ma,kwota_wal_ma) VALUES "
                    SQLDK+="('"+self.firma_id+"','"+self.okres_id+"','"+DowodD+"','"+NazwaD+"','"+DataD+"',"+str(NumerD)+","
                    SQLDK+=str(NrPoz)+",0,1,'"+KontoAmortPod+"',"+UmorzPodat+",'"+Tresc+"','PLN',1,"+UmorzPodat+",'',"
                    SQLDK+="'"+KontoUmorzPod+"',"+UmorzPodat+",'"+Tresc+"','PLN',1,"+UmorzPodat+");"
    
    if stat=='OK':
        #zmiana wartoci rodkw trwaych
        WartAkt="wartosc_aktualna-aa.rach_umorz"
        WartUm="COALESCE(wartosc_umorzenia,0)+aa.rach_umorz"
        WartAktP="wartosc_aktualna_p-aa.podat_umorz"
        WartUmP="COALESCE(wartosc_umorzenia_p,0)+aa.podat_umorz"
        RoznWart="CASE WHEN wartosc_poczatkowa-wartosc_koncowa=0 THEN 100 ELSE wartosc_poczatkowa-wartosc_koncowa END"
        RoznWartP="CASE WHEN wartosc_poczatkowa_p-wartosc_koncowa_p=0 THEN 100 ELSE wartosc_poczatkowa_p-wartosc_koncowa_p END"
        
        if NrPoz > 0:
            #jesli byla jakas dekretacja, to zakladamy dowod ksiegowy z pozycjami
            SQL+=SQLDK
        
        #aktualizacja srodka
        SQL+="UPDATE rs_srodki_trwale SET data_odpisu=aa.data,"
        SQL+=" wartosc_aktualna="+WartAkt+","
        SQL+=" wartosc_umorzenia="+WartUm+","
        SQL+=" procent_umorzenia=ROUND((("+WartUm+")/("+RoznWart+"))*100,2),"
        SQL+=" wartosc_aktualna_p="+WartAktP+","
        SQL+=" wartosc_umorzenia_p="+WartUmP+","
        SQL+=" procent_umorzenia_p=ROUND((("+WartUmP+")/("+RoznWartP+"))*100,2)"
        SQL+=" FROM rs_arkusze_amortyzacji_pozycje aa WHERE aa.firma_id='"+self.firma_id+"' "
        SQL+=" AND aa.data='"+Data+"' AND aa.numer="+str(Numer)+" AND rs_srodki_trwale.firma_id=aa.firma_id "
        SQL+=" AND rs_srodki_trwale.srodek_id=aa.srodek_id;"
        
        #dodanie zmian do logw amortyzacji rodka
        SQL+="INSERT INTO rs_srodki_trwale_umorzenia (firma_id,srodek_id,rok,miesiac,"
        SQL+="rach_przed,rach_umorz,rach_po,podat_przed,podat_umorz,podat_po)"
        SQL+=" SELECT firma_id, srodek_id, SUBSTR(data::text ,1,4), SUBSTR(data::text ,6,2), "
        SQL+="rach_przed,rach_umorz,rach_po,podat_przed,podat_umorz,podat_po"
        SQL+=" FROM rs_arkusze_amortyzacji_pozycje aa WHERE aa.firma_id='"+self.firma_id+"' "
        SQL+=" AND aa.data='"+Data+"' AND aa.numer="+str(Numer)+";"
        
        #zmiana stanu arkusza amortyzacji
        SQL+="UPDATE rs_arkusze_amortyzacji SET stan='Z' WHERE firma_id='"+self.firma_id+"' AND grupa='"+Grupa+"' "
        SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat != 'OK':
            stat="BL ZAM"   

 
#-----------------------------------------------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja in [1,5,6,11] and stat == 'OK':
    SELECT ="SELECT stan,grupa,data,numer FROM rs_arkusze_amortyzacji WHERE firma_id='"+self.firma_id+"'"
    if GrupaF != '':
        SELECT+=" AND grupa='"+str(GrupaF)+"'"
    if StanF != '':
        SELECT+=" AND stan='"+str(StanF)+"'"
    if DataF != '    -  -  ':
        SELECT+=" AND data='"+str(DataF)+"'"
    SELECT+=" ORDER BY grupa,data DESC,numer;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        dane.append(u'Bd pobrania danych.')
