#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_analiza_rozliczen.py
# Purpose:          pobiera/cofa rozrachunki i operacje
# Author:           Piotr Witkowski
# Created:          2016/03/24
# RCS-ID:           $Id: fs_analiza_rozliczen.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
#2007.02.12 Micha Raburski Okno analiza rozlicze
#2009.02.11 Micha Raburski (1746) Poprawki w kwotach_bo_*
#2009.02.20 Dariusz Boduch (1796) Zdjecie blokady na salda = 0
#2021-11-10 Aleksander Bargie (12702) Eval po stronie serwera
#2023-08-08 Jan Raburski (13505) dodanie waluta,kwota_wal_wn,kwota_wal_ma,saldo_wal_wn,saldo_wal_ma,rozliczone_wal_wn,rozliczone_wal_ma do grida

from funkcje import fs_rozrachunki_pom

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Konto':[1,2],'Kontr':[1,2],'Rozliczone':[1,2],'Oper':[1,2,3,8,9]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_analiza_rozliczen z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [1,2]:
            Konto = (klucze['Konto'])
            Kontr = (klucze['Kontr'])
            Rozliczone = (klucze['Rozliczone'])

        if Funkcja in [1,2,3,8,9]:
            Oper = klucze['Oper']

if stat=='OK':
    dane = []

#wstpne sprawdzenie danych ktre przyszy
if Funkcja in [1,2]:
    if Konto=='' and Kontr=='':
        stat="BR FILTRA"
    
#----------------------------------------------
# COFANIE ROZRACHUNKW - 8,9
#----------------------------------------------

if stat=='OK' and Funkcja in [8,9]:
    if not (((self.oddzial_id,'076107') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='Brak uprawnie do cofania rozrachunkw'
        
    LRozr=[]
    # cofanie pojedynczego rozrachunku
    if stat=='OK' and Funkcja==8:
        LRozr=[int(Oper)]
        SQL="SELECT konto FROM rs_rozrachunki WHERE seria="+str(Oper)
        stat,DaneR,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania listy rozrachunkw do cofnicia'
            
    # cofanie rozrachunkow dla danej operacji
    else:
        SQL="SELECT r.konto,r.seria "
        SQL+=" FROM rs_operacje o LEFT OUTER JOIN rs_rozrachunki r "
        SQL+=" ON (r.firma_id=o.firma_id AND r.okres_id = o.okres_id AND r.dowod_id = o.dowod_id"
        SQL+=" AND r.nazwa_id=o.nazwa_id AND r.data=o.data AND r.numer = o.numer AND r.nr_poz=o.nr_poz"
        SQL+=" AND r.nr_ppoz= o.nr_ppoz AND COALESCE(r.kwota_bo_wn,r.kwota_wn) = o.kwota_wn"
        SQL+=" AND COALESCE(r.kwota_bo_ma,r.kwota_ma) = o.kwota_ma) "
        SQL+=" WHERE o.seria="+str(Oper)+" AND NOT r.data_rozlicz IS NULL;"
        stat,DaneR,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania listy rozrachunkw do cofnicia'
        if stat=='OK':
            for rozr in DaneR:
                LRozr.append(rozr[1])
    
    # cofnicie listy rozrachunkow
    if stat=='OK' and len(LRozr)>0:
        stat=fs_rozrachunki_pom.CofnijRozrachunki(self,LRozr,DaneR[0][0])


#----------------------------------------------
# POBIERANIE DANYCH - OPERACJE
#----------------------------------------------

if Funkcja==1 and stat=='OK':
    stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,self.okres_id)
    
    if stat=='OK':
        LOkr=LOkr[0]
        SQL="SELECT o.konto,COALESCE(o.kontrahent_id,''),o.dowod_id||'/'||o.data||'/'||CAST(o.numer AS TEXT)||'/'||CAST(o.nr_poz AS TEXT)||'/'||CAST(o.nr_ppoz AS TEXT),"
        SQL+="o.symbol_dok,o.data,o.data_wyst,o.kwota_wn,o.kwota_ma,r.saldo_wn-r.rozliczone_wn,r.saldo_ma-r.rozliczone_ma,"
        SQL+="o.tresc,o.waluta,o.kwota_wal_wn,o.kwota_wal_ma,r.saldo_wal_wn-r.rozliczone_wal_wn,r.saldo_wal_ma-r.rozliczone_wal_ma,o.seria "
        SQL+=" FROM rs_operacje o LEFT OUTER JOIN rs_rozrachunki r "
        SQL+=" ON (r.firma_id=o.firma_id AND r.okres_id = o.okres_id AND r.dowod_id = o.dowod_id"
        SQL+=" AND r.nazwa_id=o.nazwa_id AND r.data=o.data AND r.numer = o.numer AND r.nr_poz=o.nr_poz"
        SQL+=" AND r.nr_ppoz= o.nr_ppoz AND CASE WHEN COALESCE(r.kwota_bo_wn,0) != 0 THEN r.kwota_bo_wn ELSE r.kwota_wn END = o.kwota_wn"
        SQL+=" AND CASE WHEN COALESCE(r.kwota_bo_ma,0) != 0 THEN r.kwota_bo_ma ELSE r.kwota_ma END = o.kwota_ma) "
        SQL+=" WHERE o.firma_id='"+self.firma_id+"' AND o.okres_id IN ("+LOkr+") "
        if Konto != '':
            SQL+=" AND o.konto LIKE '"+Konto+"%'"
        if Kontr != '':
            SQL+=" AND '"+Kontr.strip()+"'=regexp_replace(o.konto,'^.*-','')"
            SQL+=" AND rsf_sprawdz_czy_kontrahent_w_koncie(o.firma_id,o.okres_id,o.konto)<>'0' "
        
        SQL+=" AND (r.data_rozlicz IS NULL OR ((r.saldo_wn=r.rozliczone_wn AND r.saldo_ma=r.rozliczone_ma) AND "
        SQL+=" (r.saldo_wal_wn=r.rozliczone_wal_wn AND r.saldo_wal_ma=r.rozliczone_wal_ma)))"
        if Rozliczone:
            SQL+=" AND ((r.kwota_wn!=r.saldo_wn OR r.kwota_ma!=r.saldo_ma) OR (r.saldo_wn=r.rozliczone_wn AND r.saldo_ma=r.rozliczone_ma))"
        SQL+=" ORDER BY o.konto,o.dowod_id||'/'||o.data||'/'||CAST(o.numer AS TEXT)||'/'||CAST(o.nr_poz AS TEXT)||'/'||CAST(o.nr_ppoz AS TEXT)"
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        #pobranie opisu konta i kontrahenta
        wyn1=['','']
        if Konto != '':
            stat,DK,dump,dump=self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+Konto+"');",3)
            if stat=='OK':
                #AB 10.11.21r
                rsglobal.ZapiszDoLogow("rseval {}".format(DK[0][0]))
                wyn1[0]=rsglobal.rseval(DK[0][0])[1]
        if Kontr != '' and stat=='OK':
            SQL="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
            stat,DK,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DK)>0:
                    wyn1[1]=DK[0][0]
            
#----------------------------------------------
# POBIERANIE DANYCH - ROZLICZENIA
#----------------------------------------------
    
if Funkcja==2 and stat=='OK':
    stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,self.okres_id)
    
    if stat=='OK':
        LOkr=LOkr[0]
        
        SQL="SELECT rp.okres_id,rp.symbol_dok,rp.data,rp.rozliczone_wn,rp.rozliczone_ma,"
        SQL+=" CASE WHEN rp.kwota_wn != 0 THEN rp.kwota_wn ELSE rp.kwota_ma END,rp.tresc, "
        SQL+=" rp.dowod_id||'/'||rp.data||'/'||CAST(rp.numer AS TEXT)||'/'||CAST(rp.nr_poz AS TEXT)||'/'||CAST(rp.nr_ppoz AS TEXT),"
        #SQL+=" rp.data_rozlicz,rp.seria"  #JR 2023-08-02 (13505)
        SQL+=" rp.data_rozlicz,rp.seria,rp.waluta,rp.kwota_wal_wn,rp.kwota_wal_ma,rp.saldo_wal_wn,rp.saldo_wal_ma,rp.rozliczone_wal_wn,rp.rozliczone_wal_ma"
        SQL+=" FROM rs_operacje o LEFT OUTER JOIN rs_rozrachunki r "
        SQL+=" ON (r.firma_id=o.firma_id AND r.okres_id = o.okres_id AND r.dowod_id = o.dowod_id"
        SQL+=" AND r.nazwa_id=o.nazwa_id AND r.data=o.data AND r.numer = o.numer AND r.nr_poz=o.nr_poz"
        SQL+=" AND r.nr_ppoz= o.nr_ppoz AND CASE WHEN COALESCE(r.kwota_bo_wn,0) != 0 THEN r.kwota_bo_wn ELSE r.kwota_wn END = o.kwota_wn"
        SQL+=" AND CASE WHEN COALESCE(r.kwota_bo_ma,0) != 0 THEN r.kwota_bo_ma ELSE r.kwota_ma END = o.kwota_ma)"
        SQL+=" LEFT OUTER JOIN rs_rozrachunki rp ON "
        SQL+=" ((rp.seria=r.seria_prz OR (r.seria_prz=0 AND rp.seria_prz=0)) AND rp.data_rozlicz=r.data_rozlicz) "
        SQL+=" WHERE o.seria="+str(Oper)+" AND NOT r.data_rozlicz IS NULL AND rp.okres_id IN ("+LOkr+")"
        SQL+=" ORDER BY o.konto,o.dowod_id||'/'||o.data||'/'||CAST(o.numer AS TEXT)||'/'||CAST(o.nr_poz AS TEXT)||'/'||CAST(o.nr_ppoz AS TEXT)"
            
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    
#----------------------------------------------
# POBIERANIE RZECZYWISTEGO KLUCZA DOKUMENTU DO WYWIETLENIA W OPARCIU O NR OPERACJI
#----------------------------------------------

if Funkcja==3 and stat=='OK':
    SQL="SELECT dowod_id,nazwa_id,data,numer,okres_id FROM rs_operacje WHERE firma_id='"+self.firma_id+"' AND seria="+str(Oper)+";"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)