#!/usr/bin/python
# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:			fs_analiza_stanow.py
# Purpose:		zmienia analiza stanow
# Author:		Micha Raburski
# Created:		2008/08/19
# RCS-ID:		$Id: fs_analiza_stanow.py $
# Copyright:	(c) 2004-2009 RecordSystem
# Licence:		GNU GPL
# -----------------------------------------------------------------------------
import rsglobal

# 2011.10.10 MR                  (5053) Dodatkowy grid w analizie stanw dla Alabu ze zuyciem
# 2023.09.25 Aleksander Bargie (13561) Analiza stanw, ostrzega o 5000 artykuach tylko, jeli magazyn przekracza t liczb

MagF = klucze[0]
KategF = klucze[1]
ArtF = klucze[2]
NazwaF = klucze[3]
CzyZamF = klucze[4]
SumZamF = klucze[5]
DniZuzF = klucze[6]
DniDoStMinF = klucze[7]
ProcPowMinF = klucze[8]
SztPowMinF = klucze[9]
ZamBezPokrF = klucze[10]
DokDodF = klucze[11]
CzyPonizejMinF = klucze[12]
CzyPowyzejMaxF = klucze[13]
CzyZamowioneF = klucze[14]
DostawcaF = klucze[15]
HandlowiecF = klucze[16]
ZamowieniaMlodszeNizF = klucze[17]
SrednieZuzycieF = klucze[18]
DodatniMinMaxF = klucze[19]
Zuzycie13F = klucze[20]
CechaOpis = klucze[21].strip()
CechaOd = klucze[22].strip()
CechaDo = klucze[23].strip()
MagazynyF = klucze[24]
Fun = klucze[-1]

stat = 'OK'
wyn2 = []
dane = []

# UWAGA - robic zmiany w algorytmach 1/3 naley te zajrze do fs_zamowienia_odbiorcy_analiza_stanow

# jeli liczymy zuycie 1/3 to magazyn musi by podany
if Zuzycie13F:
    if MagF == '':
        stat = 'BR_MAG_Z13'
    else:
        SQL = " SELECT magazyn_id FROM rs_magazyny WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagF + "';"
        stat, DMagTest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat == 'OK':
            if len(DMagTest) == 0:
                stat = 'BL_MAG_Z13'

if (Fun in [1]) and stat == 'OK':
    Update = klucze[-2]
    Insert = klucze[-3]
    Delete = klucze[-4]

    if stat == 'OK':
        sql = ''
        for i in xrange(len(Update[0])):  # petla po ilosci wierszy updatowanych
            PrzerwacBoCecha = False
            UPDATE = "UPDATE rs_artykuly_magazyny "
            SET = 'SET '
            SETZAM = 'SET '
            for j in xrange(len(Update[0][i])):  # petla po pozycjach do zmiany
                pole = Update[0][i][j]
                wart = Update[1][i][j]

                if pole in ['min1', 'min2', 'max1', 'max2']:
                    SET += 'zapas_' + pole + "=" + str(wart) + ","
                    SETZAM += 'zapas_' + pole + "=0,"

            SET = SET.strip(",")
            SETZAM = SETZAM.strip(",")
            WHERE = " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagF + "'"
            Art = ''
            for j in xrange(len(Update[2][i])):  # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])
                if pole == 'artykul_id':
                    Art = wart

                if pole == 'cecha1_wartosc':
                    if wart != '':
                        PrzerwacBoCecha = True
                else:
                    WHERE += " AND " + pole + "='" + wart + "'"

            if PrzerwacBoCecha:
                continue

            # Upewniamy si, e wybrany rekord, ktry bdziemy update'owa istnieje
            # w zmiennej wart jest umieszczony artykul, ktory jest w liscie kluczy jedynym polem
            try:
                SelPom = "SELECT artykul_id FROM rs_artykuly_magazyny " + WHERE
                stat, DPom, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SelPom), 3)
                if stat == 'OK':
                    if len(DPom) == 0:
                        InsPom = "INSERT INTO rs_artykuly_magazyny (firma_id,magazyn_id,artykul_id) "
                        InsPom += " VALUES ('" + self.firma_id + "','" + MagF + "','" + Art + "')"
                        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(InsPom), 1)
                        self.PolSQL.Commit()
            except:
                pass

                # jeli wybrane jest sumowanie zamiennikw to czyscimy zapasy w zamiennikach
            if SumZamF:
                UPDZAM = UPDATE + SETZAM + " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagF + "'"
                UPDZAM += " AND artykul_id IN (SELECT artykul_id FROM rs_artykuly WHERE zamiennik_id='" + Art + "' AND artykul_id != '" + Art + "');"
            else:
                UPDZAM = ''

            sql += UPDATE + SET + WHERE + ";" + UPDZAM

        if sql != '':
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)

# -------------------------------------------------------------------------------
# POBIERANIE DANYCH
# -------------------------------------------------------------------------------

if (Fun in [1, 5, 6]) and (stat == 'OK'):
    if ProcPowMinF != 0 and SztPowMinF != 0:
        stat = 'BL FIL POW MIN'

    # ----------------------------------------------------------
    # pobranie listy artykulow, ktore beda analizowane
    # UWAGA - jeli wczone "zamwiono" to lista artykuw pobierana z zamwie.
    # inaczej  z artykuw. Pobierane na razie wsplnie dla obu gridw
    # ----------------------------------------------------------

    if stat == 'OK' and MagF:
        SQL = "SELECT 1 FROM rs_magazyny WHERE firma_id='" + self.firma_id + "' and magazyn_id='" + MagF + "';"
        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia magazynu.'
        elif len(d) == 0:
            stat = 'Magazyn ' + MagF + ' nie istnieje'
        elif MagazynyF:
            if MagF not in MagazynyF:
                stat = 'Brak uprawnie do magazynu ' + MagF

    if stat == 'OK':
        # ten sownik trzyma docelowego grida w sobie (jeli nie uwzgldniamy cech)
        SArt = {}
        # ten sownik trzyma docelowego grida w sobie (jeli uwzgldniamy cechy)
        SArtCechy = {}
        # ten sownik pozwala atwo znale artyku, ktry odpowiada zamiennikowi
        SZamArt = {}

        # jeli s uwzgldniane jakie filtry cech to deklarujemy odpowiednie zmienne
        UwzgledniacCechy = (CechaOpis.strip() != '' or CechaOd.strip() != '' or CechaDo.strip() != '')
        if UwzgledniacCechy:
            PoleCechaA = "COALESCE(a.cecha1_opis,'')"
            PoleCecha = "COALESCE(cecha1_opis,'')"
            PoleCechaWartO = ",COALESCE(om.cecha1_wartosc,'')"
            PoleCechaWartZDP = ",COALESCE(zdp.cecha1_wartosc,'')"
        else:
            PoleCechaA = "''"
            PoleCecha = "''"
            PoleCechaWartO = ""
            PoleCechaWartZDP = ""

        # -----------------------------
        # pobieranie z zamwie
        # -----------------------------
        if CzyZamowioneF:
            SQL = "SELECT TRIM(zop.artykul_id),a.nazwa,COALESCE(a.zamiennik_id, a.artykul_id),a.jm1,a.jm2,"
            SQL += "a.przelicznik,COALESCE(a.dostawca_id,'')," + PoleCechaA
            SQL += " FROM rs_zamowienia_odbiorcy_pozycje zop "
            SQL += " INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer) "
            SQL += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
            SQL += " WHERE zop.firma_id='" + self.firma_id + "' AND a.aktywny "
            if HandlowiecF != '':
                SQL += " AND zo.handlowiec ='" + HandlowiecF + "'"
            if self.handlowiec_id != None:
                SQL += " AND zo.handlowiec ='" + self.handlowiec_id + "'"
            if rsglobal.SprawdzCzyToData(ZamowieniaMlodszeNizF):
                SQL += " AND zo.data >='" + ZamowieniaMlodszeNizF + "'"
            if KategF != "":
                SQL += " AND a.kateg_artykulu LIKE '" + KategF + "%'"
            if ArtF != "":
                SQL += " AND a.artykul_id LIKE '" + ArtF + "%'"
            if NazwaF != "":
                SQL += " AND UPPER(a.nazwa) LIKE UPPER('" + NazwaF + "%')"
            if DostawcaF != "":
                SQL += " AND a.dostawca_id LIKE '" + DostawcaF + "%'"
            if CechaOpis != "":
                SQL += " AND a.cecha1_opis LIKE '" + CechaOpis.strip('%') + "%'"
            if MagF != '':  #AB 2023-09-25
                SQL += " AND artykul_id IN (SELECT DISTINCT artykul_id FROM rs_obroty_magazynowe_sumy_dni rdm WHERE " \
                       "firma_id='"+self.firma_id+"' AND magazyn_id='"+MagF+"') "
            # magazyn uwzgldniany przy zuyciu 1/3
            if Zuzycie13F:
                if MagF != '':
                    SQL += " AND zo.magazyn_id = '" + MagF + "'"

            SQL += " AND zo.stan != 'W' AND NOT a.typ_artykulu IN ('31','99') ORDER BY artykul_id;"
        else:
            # -----------------------------
            # pobranie danych z artykuw
            # -----------------------------
            CaseZam = "COALESCE(zamiennik_id, artykul_id)"

            SQL = "SELECT TRIM(artykul_id),nazwa," + CaseZam + ",jm1,jm2,przelicznik,COALESCE(dostawca_id,'')," + PoleCecha + " FROM rs_artykuly"

            SQL += " WHERE firma_id='" + self.firma_id + "' AND aktywny"
            if KategF != "":
                SQL += " AND kateg_artykulu LIKE '" + KategF + "%'"
            if ArtF != "":
                SQL += " AND artykul_id LIKE '" + ArtF + "%'"
            if NazwaF != "":
                SQL += " AND UPPER(nazwa) LIKE UPPER('" + NazwaF + "%')"
            if DostawcaF != "":
                SQL += " AND dostawca_id LIKE '" + DostawcaF + "%'"
            if CechaOpis != "":
                SQL += " AND cecha1_opis LIKE '" + CechaOpis.strip('%') + "%'"
            if MagF != '':  #AB 2023-09-25
                SQL += " AND artykul_id IN (SELECT DISTINCT artykul_id FROM rs_obroty_magazynowe_sumy_dni rdm WHERE " \
                       "firma_id='"+self.firma_id+"' AND magazyn_id='"+MagF+"') "

            SQL += " AND NOT typ_artykulu IN ('31','99') ORDER BY artykul_id;"
        rsglobal.ZapiszDoLogow("AnStanow:" + SQL)
        stat, DArt, dump, dump = self.PolSQL.Execute(SQL, 3)

    if stat == 'OK':
        if len(DArt) == 0:
            stat = 'Brak artykuw do pobrania'

        # -##############################################################################
        # POBIERANIE DANYCH DO GRIDA ZUYCIA
        # -##############################################################################
        if Zuzycie13F:
            # stworzenie sownika i listy artykuw, ktrych dane nas interesuj
            # SArt[symbol artykuu] = 
            #     0           1         2          3         4        5          6         7          8
            # [nazwa art, Stan mag, stan spisu, zu 1 mc, zu 3mc, suger zam, zam. odb, ilo zam, dostawca, 
            #          9
            # zamwienia dostawcy]

            if stat == 'OK':
                SArt = {}
                SZamDost = {}
                LArt = []
                for poz in DArt:
                    art = rsglobal.Dekoduj(poz[0])
                    if not art in SArt:
                        LArt.append(art)
                        SArt[art] = [poz[1], 0, 0, 0, 0, 0, 0, 0, poz[6], 0]

                # pobranie daty ostatniego spisu z natury
                SQL = "SELECT data FROM rs_inwentaryzacja WHERE firma_id='" + self.firma_id + "'"
                SQL += " AND magazyn_id='" + MagF + "' AND stan='Z'"
                SQL += " ORDER BY data DESC LIMIT 1"
                stat, DSpis, wyn, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych inwentaryzacji :' + stat
                elif len(DSpis) == 0:
                    stat = "Brak inwentaryzacji w wybranym magazynie "
                else:
                    DataSpisu = rsglobal.Dekoduj(DSpis[0][0])

            if stat == 'OK':
                # sprawdzenie z ktrego algorytmu (z jedynk czy bez) bdziemy korzysta
                # jeli Spis z poprzedniego miesica jest zamknity to 0, jeli otwarty lub brak to 1
                WspWzoru = 1

                SQL = "SELECT stan FROM rs_inwentaryzacja WHERE firma_id= '" + self.firma_id + "'"
                SQL += " AND magazyn_id='" + MagF + "'"
                SQL += " AND EXTRACT(YEAR FROM NOW() - INTERVAL '1 MONTH')::INT = EXTRACT(YEAR FROM data)::INT"
                SQL += " AND EXTRACT(MONTH FROM NOW() - INTERVAL '1 MONTH')::INT = EXTRACT(MONTH FROM data)::INT"
                stat, DSpisWz, wyn, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych inwentaryzacji do wzoru :' + stat
                elif len(DSpisWz) > 0:
                    if DSpisWz[0][0] == 'Z':
                        WspWzoru = 0

            # pobranie danych aktualnego stanu magazynu
            if stat == 'OK':
                SQL = "SELECT TRIM(artykul_id),ilosc1 FROM rs_artykuly_magazyny "
                SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagF + "'"
                SQL += " AND artykul_id IN (" + str(LArt)[1:-1] + ");"
                stat, DObr, wyn, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych o stanach magazynowych :' + stat

            if stat == 'OK':
                for poz in DObr:
                    art = rsglobal.Dekoduj(poz[0])
                    if art in SArt:
                        SArt[art][1] = poz[1]

            # pobranie danych ze spisu z natury
            if stat == 'OK':
                SQL = "SELECT TRIM(artykul_id),ilosc1 FROM rs_inwentaryzacja_pozycje "
                SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagF + "' AND data='" + DataSpisu + "'"
                SQL += " AND artykul_id IN (" + str(LArt)[1:-1] + ") ORDER BY artykul_id;"
                stat, DSpis, wyn, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych spisu z natury :' + stat
                if stat == 'OK':
                    for poz in DSpis:
                        art = rsglobal.Dekoduj(poz[0])
                        if art in SArt:
                            SArt[art][2] = poz[1]

            # pobranie danych zuycia z dokumentw RW
            if stat == 'OK':
                DataPoczM = DataSpisu[0:8] + '01'
                SQL = "SELECT TRIM(artykul_id),SUM(CASE WHEN data>='" + DataPoczM + "' THEN ilosc1 ELSE 0 END),"
                SQL += " SUM(ilosc1)"
                SQL += " FROM rs_dokumenty_magazynowe_pozycje "
                SQL += " WHERE firma_id='" + self.firma_id + "' AND dokument_id='RW' AND magazyn_id='" + MagF + "'"
                SQL += " AND data<='" + DataSpisu + "' AND data>=date '" + DataPoczM + "' - interval '2 months'"
                SQL += " AND artykul_id IN (" + str(LArt)[1:-1] + ") GROUP BY artykul_id ORDER BY artykul_id;"
                stat, DRW, wyn, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych z dokumentw RW :' + stat

                if stat == 'OK':
                    for poz in DRW:
                        art = rsglobal.Dekoduj(poz[0])
                        if art in SArt:
                            # zuycie 1 mc
                            SArt[art][3] = poz[1]
                            # rednie zuycie 3 mc
                            SArt[art][4] = rsglobal.RSRound(poz[2] / 3, 4)

            # pobranie danych z pozycji zamwie odbiorcw
            if stat == 'OK':
                SQL = "SELECT TRIM(zop.artykul_id),"
                SQL += "SUM(CASE WHEN zop.ilosc1-zop.dostarczono1-zop.anulowano1 > 0 THEN zop.ilosc1-zop.dostarczono1-zop.anulowano1 ELSE 0 END)"
                SQL += " FROM rs_zamowienia_odbiorcy_pozycje zop "
                SQL += " INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer) "
                SQL += " WHERE zop.firma_id='" + self.firma_id + "' AND zop.artykul_id IN (" + str(LArt)[1:-1] + ") "
                SQL += " AND zo.magazyn_id ='" + MagF + "'"
                if HandlowiecF != '':
                    SQL += " AND zo.handlowiec ='" + HandlowiecF + "'"
                if self.handlowiec_id != None:
                    SQL += " AND zo.handlowiec ='" + self.handlowiec_id + "'"
                if rsglobal.SprawdzCzyToData(ZamowieniaMlodszeNizF):
                    SQL += " AND zo.data >='" + ZamowieniaMlodszeNizF + "'"
                SQL += " AND zo.stan != 'W' GROUP BY zop.artykul_id ORDER BY artykul_id;"
                stat, DZamOdb, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych zamwie odbiorcw :' + stat
                if stat == 'OK':
                    for poz in DZamOdb:
                        art = rsglobal.Dekoduj(poz[0])
                        if art in SArt:
                            SArt[art][6] += poz[1]

            if stat == 'OK':
                # pobranie danych o zamwieniach dostawcw
                SQL = "SELECT TRIM(zdp.artykul_id),SUM(zdp.ilosc1-zdp.dostarczono1-zdp.anulowano1) "
                SQL += " FROM rs_zamowienia_dostawcy_pozycje zdp "
                SQL += " INNER JOIN rs_zamowienia_dostawcy zd USING(firma_id,wyznacznik_id,data,numer)"
                SQL += " WHERE zdp.firma_id='" + self.firma_id + "' AND zd.stan = 'A' AND zdp.artykul_id IN (" + str(
                    LArt)[1:-1] + ")"
                if HandlowiecF != '':
                    SQL += " AND zd.handlowiec ='" + HandlowiecF + "'"

                if self.handlowiec_id != None:
                    SQL += " AND zd.handlowiec ='" + self.handlowiec_id + "'"
                SQL += " GROUP BY zdp.artykul_id;"

                stat, DZamDost, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobierania danych zamwie do dostawcw :' + stat
                if stat == 'OK':
                    for poz in DZamDost:
                        art = rsglobal.Dekoduj(poz[0])
                        if art in SArt:
                            SArt[art][9] = poz[1]

            # wyznaczenie obecnego stanu i faktycznego sugerowanego zamwienia wzgldem aktualnej dzisiejszej daty
            # najnowsze wzory z Alabu (6512)
            # obecny stan = Stan mag + Zamwienia do dost. - (rednie zuycie 3 mc * (WspWzoru+((dzie mies+6)/30))
            # Sugerowane zamwienie = (rednie zuycie 3 mc * 1.2) - obecny stan
            if stat == 'OK':
                for art in LArt:
                    ObecnyStan = SArt[art][1] + SArt[art][9] - (
                                SArt[art][4] * (WspWzoru + ((int(rsglobal.PodajDzis()[8:]) + 6.0) / 30.0)))
                    ObecnyStan = rsglobal.RSRound(ObecnyStan, 4)
                    if ObecnyStan < 0:
                        ObecnyStan = 0

                    SArt[art][5] = (SArt[art][4] * 1.2) - ObecnyStan
                    if SArt[art][5] < 0:
                        SArt[art][5] = 0
                    SArt[art][5] = rsglobal.RSRound(SArt[art][5], 4)
                    SArt[art][7] = SArt[art][5]

            if stat == 'OK':
                dane = []
                for art in LArt:
                    dane.append([art] + SArt[art])

        # -##############################################################################
        # POBIERANIE DANYCH DO GRIDA PODSTAWOWEGO
        # -##############################################################################
        else:
            if CzyZamF:
                # ptla sprawdzajca zamienniki
                for art in DArt:
                    if stat == 'OK':
                        SQL = "SELECT TRIM(artykul_id),nazwa," + CaseZam + ",jm1,jm2,przelicznik,COALESCE(dostawca_id,'')," + PoleCecha + " FROM rs_artykuly"
                        SQL += " WHERE firma_id='" + self.firma_id + "' AND aktywny AND (artykul_id='" + rsglobal.Dekoduj(
                                art[0]) + "' "
                        if rsglobal.Dekoduj(art[2]) in ('', 'None', None):
                            SQL += " OR zamiennik_id ='" + rsglobal.Dekoduj(art[0]) + "')"
                        else:
                            SQL += " OR artykul_id='" + rsglobal.Dekoduj(
                                    art[2]) + "' OR zamiennik_id ='" + rsglobal.Dekoduj(art[2]) + "')"
                        SQL += " AND NOT typ_artykulu IN ('31','99')"
                        if CechaOpis != "":
                            SQL += " AND cecha1_opis LIKE '" + CechaOpis.strip('%') + "%'"

                        stat, DZam, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat == 'OK':
                        for zam in DZam:
                            ArtPom = rsglobal.Dekoduj(zam[0])
                            ZamPom = rsglobal.Dekoduj(zam[2])

                            # jeli sumujemy zamienniki
                            if SumZamF:
                                # jesli nie ma podanego zamiennika
                                if ZamPom == '':
                                    # i jesli go jeszcze nie ma w slowniku
                                    if not ArtPom in SArt:
                                        # dodaje do slownika artykul bez zamiennikow
                                        SArt[ArtPom] = [[ArtPom], ZamPom, rsglobal.Dekoduj(zam[1]),
                                                        rsglobal.Dekoduj(zam[3]),
                                                        rsglobal.Dekoduj(zam[4]), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                                        0, 0, 0, rsglobal.Dekoduj(zam[5]), rsglobal.Dekoduj(zam[6]),
                                                        rsglobal.Dekoduj(zam[7])]
                                        SZamArt[ArtPom] = ArtPom
                                # podany jest zamiennik
                                else:
                                    # jesli zamiennika nie ma w slowniku
                                    if not ZamPom in SArt:
                                        SArt[ZamPom] = [[ZamPom, ArtPom], ZamPom, rsglobal.Dekoduj(zam[1]),
                                                        rsglobal.Dekoduj(zam[3]), rsglobal.Dekoduj(zam[4]), 0, 0, 0, 0,
                                                        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, rsglobal.Dekoduj(zam[5]),
                                                        rsglobal.Dekoduj(zam[6]), rsglobal.Dekoduj(zam[7])]
                                        SZamArt[ArtPom] = ZamPom
                                        SZamArt[ZamPom] = ZamPom

                                        # dodajemy tylko zamiennik do listy zamiennikow
                                    else:
                                        if not ArtPom in SArt[ZamPom][0]:
                                            SArt[ZamPom][0].append(ArtPom)
                                            SZamArt[ArtPom] = ZamPom

                            # zamienniki nie s sumowane i wchodz jako oddzielne artykuy
                            else:
                                if not ArtPom in SArt:
                                    SArt[ArtPom] = [[ArtPom], ZamPom, rsglobal.Dekoduj(zam[1]),
                                                    rsglobal.Dekoduj(zam[3]),
                                                    rsglobal.Dekoduj(zam[4]), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                                    0, 0, rsglobal.Dekoduj(zam[5]), rsglobal.Dekoduj(zam[6]),
                                                    rsglobal.Dekoduj(zam[7])]
                                    SZamArt[ArtPom] = ArtPom

            # jeli jest po prostu bez zamiennikw
            else:
                for art in DArt:
                    SArt[rsglobal.Dekoduj(art[0])] = [[rsglobal.Dekoduj(art[0])], rsglobal.Dekoduj(art[2]),
                                                      rsglobal.Dekoduj(art[1]),
                                                      rsglobal.Dekoduj(art[3]), rsglobal.Dekoduj(art[4]), 0, 0, 0, 0, 0,
                                                      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, rsglobal.Dekoduj(art[5]),
                                                      rsglobal.Dekoduj(art[6]), rsglobal.Dekoduj(art[7])]
                    SZamArt[rsglobal.Dekoduj(art[0])] = rsglobal.Dekoduj(art[0])

            # ----------------------------------------------------------
            # utworzenie listy artykuw dla ktrych naley pobiera dane 
            # w zalenoci od tego czy jest sumowanie zamiennikw czy nie
            # trzymane jest to w zmiennej    LArtDoF
            # ----------------------------------------------------------
            if stat == 'OK':
                KluczeArt = SArt.keys()
                KluczeArt.sort()
                LArtDoF = []
                if SumZamF:
                    for kl in KluczeArt:
                        poz = SArt[kl]
                        for zam in poz[0]:
                            if not zam in LArtDoF:
                                LArtDoF.append(zam)
                else:
                    LArtDoF = KluczeArt
                LArtDoF.sort()

            if stat == 'OK':
                if len(LArtDoF) == 0:
                    stat = 'BR D'

            if stat=='OK':
                if len(LArtDoF)>5000:
                    stat='ZA DUZO DANYCH'

            # ----------------------------------------------------------
            # pobranie stanw min,max, akt i pozost w magazynie (jeli bez cech)
            # ----------------------------------------------------------
            if not UwzgledniacCechy:
                if stat == 'OK':
                    # pobranie wszystkich danych, ktre bd uywane
                    SQL = "SELECT TRIM(am.artykul_id),TRIM(am.magazyn_id),COALESCE(am.ilosc1-rezerwacja1,0),COALESCE(am.ilosc2-rezerwacja2,0),"
                    SQL += "COALESCE(am.zapas_min1,0),COALESCE(am.zapas_min2,0),COALESCE(am.zapas_max1,0),COALESCE(am.zapas_max2,0)"
                    SQL += " FROM rs_artykuly_magazyny am INNER JOIN rs_magazyny m USING (firma_id,magazyn_id)"
                    SQL += " WHERE am.firma_id='" + self.firma_id + "' AND artykul_id IN (" + str(LArtDoF)[1:-1] + ") "
                    SQL += " AND (NOT m.brakow OR m.brakow IS NULL) ORDER BY artykul_id,magazyn_id;"
                    stat, DMagaz, dump, dump = self.PolSQL.Execute(SQL, 3)

                if stat == 'OK':
                    for poz in DMagaz:
                        if rsglobal.Dekoduj(poz[0]) in SZamArt:
                            # pobranie pozycji z grida, ktr naley edytowa
                            pozart = SArt[SZamArt[rsglobal.Dekoduj(poz[0])]]

                            # jesli magazyn pasuje do filtra
                            if MagF == poz[1][:len(MagF)]:
                                # stan min
                                pozart[5] += poz[4]
                                pozart[13] += poz[5]
                                # stan max
                                pozart[6] += poz[6]
                                pozart[14] += poz[7]
                                # stan akt
                                pozart[7] += poz[2]
                                pozart[15] += poz[3]
                            else:
                                # stan pozost
                                pozart[8] += poz[2]
                                pozart[16] += poz[3]

            elif stat == 'OK':
                # wyznaczamy stan aktualny i pozostay dla wersji z cechami (na podstawie art przyj)
                SQL = "SELECT TRIM(ap.artykul_id),COALESCE(TRIM(ap.cecha1_wartosc),''),TRIM(ap.magazyn_id),SUM(COALESCE(ap.ilosc1-ap.rezerwacja1,0)),SUM(COALESCE(ap.ilosc2-ap.rezerwacja2,0))"
                SQL += " FROM rs_artykuly_przyjecia ap INNER JOIN rs_magazyny m USING (firma_id,magazyn_id)"
                SQL += " WHERE ap.firma_id='" + self.firma_id + "' AND ap.artykul_id IN (" + str(LArtDoF)[1:-1] + ") "
                SQL += " AND (NOT m.brakow OR m.brakow IS NULL) AND (ap.ilosc1 >0 OR ap.ilosc2 >0) "
                SQL += rsglobal.WyznaczFiltrNaCeche(CechaOd, CechaDo, 'ap')
                SQL += " GROUP BY TRIM(ap.artykul_id),COALESCE(TRIM(ap.cecha1_wartosc),''),TRIM(ap.magazyn_id)"
                SQL += " ORDER BY TRIM(ap.artykul_id),COALESCE(TRIM(ap.cecha1_wartosc),''),TRIM(ap.magazyn_id);"
                stat, DMagaz, dump, dump = self.PolSQL.Execute(SQL, 3)

                if stat == 'OK':
                    for poz in DMagaz:
                        klpoz = (poz[0], poz[1])
                        if not klpoz in SArtCechy:
                            rsglobal.ZapiszDoLogow("rseval {}".format(SArt[poz[0]]))
                            SArtCechy[klpoz] = rsglobal.rseval(str(SArt[poz[0]]))

                        pozart = SArtCechy[klpoz]

                        # jesli magazyn pasuje do filtra
                        if MagF == poz[2][:len(MagF)]:
                            # stan akt
                            pozart[7] += poz[3]
                            pozart[15] += poz[4]
                        else:
                            # stan pozost
                            pozart[8] += poz[3]
                            pozart[16] += poz[4]

            # ----------------------------------------------------------
            # policzenie redniego zuycia
            # ----------------------------------------------------------

            if stat == 'OK':
                if DniZuzF > 0:
                    DokumentyZuz = "('WZ','ZW')"
                    if DokDodF != '':
                        LDokZuz = DokDodF.split('/')
                        DokumentyZuz = "("
                        for dok in LDokZuz:
                            DokumentyZuz += "'" + rsglobal.Dekoduj(dok) + "',"
                        DokumentyZuz = DokumentyZuz.strip(',') + ")"

                    DataZuz = "(now()-interval '" + str(DniZuzF) + " days')"

                    if SrednieZuzycieF:
                        SQL = "SELECT DISTINCT TRIM(om.artykul_id),a.przelicznik,"
                        SQL += "SUM("
                        SQL += " CASE WHEN (" + DataZuz + ">=ap.data) THEN ((-1*om.ilosc1*om.typ_znak)/" + str(
                            DniZuzF) + ") "
                        SQL += " WHEN (" + DataZuz + "<ap.data) AND current_date!=ap.data THEN (-1*om.ilosc1*om.typ_znak)/(current_date - ap.data) "
                        SQL += "  WHEN (" + DataZuz + "<ap.data) AND now()=ap.data THEN (-1*om.ilosc1*om.typ_znak) END"
                        SQL += ")" + PoleCechaWartO
                        SQL += " FROM rs_obroty_magazynowe om"
                        SQL += " LEFT OUTER JOIN rs_artykuly_przyjecia ap ON (om.firma_id=ap.firma_id AND om.magazyn_id=ap.magazyn_id AND om.artykul_id=ap.artykul_id) "
                        SQL += " LEFT OUTER JOIN rs_artykuly_magazyny am ON (om.firma_id=am.firma_id and om.magazyn_id=am.magazyn_id and om.artykul_id=am.artykul_id) "
                        SQL += " LEFT OUTER JOIN rs_magazyny m ON (om.firma_id=m.firma_id AND om.magazyn_id=m.magazyn_id) "
                        SQL += " INNER JOIN rs_artykuly a ON (om.firma_id=a.firma_id AND om.artykul_id=a.artykul_id) "
                        SQL += " WHERE om.firma_id='" + self.firma_id + "' AND om.data<=now() AND om.data> " + DataZuz + " AND (om.dokument_id IN " + DokumentyZuz + " AND om.ilosc1>0) "
                        SQL += " AND (ap.data, ap.artykul_id, ap.magazyn_id) IN (SELECT min(apa.data), apa.artykul_id, apa.magazyn_id "
                        SQL += "     FROM rs_artykuly_przyjecia apa WHERE apa.firma_id='" + self.firma_id + "' AND NOT apa.wirtualne GROUP BY apa.artykul_id, apa.magazyn_id) "
                        SQL += " AND om.magazyn_id like '" + MagF + "%' AND (NOT m.brakow OR m.brakow IS NULL) AND om.artykul_id IN (" + str(
                            LArtDoF)[1:-1] + ") AND NOT ap.wirtualne"
                        SQL += rsglobal.WyznaczFiltrNaCeche(CechaOd, CechaDo, 'om')
                        SQL += " GROUP BY om.artykul_id, ap.nr_poz, ap.data, am.ilosc1, ap.numer, ap.nr_ppoz, om.magazyn_id,a.przelicznik" + PoleCechaWartO + " ORDER BY TRIM(om.artykul_id)"
                    else:
                        SQL = "SELECT DISTINCT TRIM(om.artykul_id),a.przelicznik,"
                        SQL += "SUM(-1*om.ilosc1*om.typ_znak)" + PoleCechaWartO
                        SQL += " FROM rs_obroty_magazynowe om"
                        SQL += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
                        SQL += " LEFT OUTER JOIN rs_magazyny m ON (om.firma_id=m.firma_id AND om.magazyn_id=m.magazyn_id) "
                        SQL += " WHERE om.firma_id='" + self.firma_id + "' AND om.data<=now() AND om.data> " + DataZuz + " AND (om.dokument_id IN " + DokumentyZuz + " AND om.ilosc1>0)"
                        SQL += " AND om.magazyn_id like '" + MagF + "%' AND (NOT m.brakow OR m.brakow IS NULL) AND om.artykul_id IN (" + str(
                            LArtDoF)[1:-1] + ")"
                        SQL += rsglobal.WyznaczFiltrNaCeche(CechaOd, CechaDo, 'om')
                        SQL += " GROUP BY om.artykul_id,a.przelicznik" + PoleCechaWartO + " ORDER BY TRIM(om.artykul_id)"

                    stat, DZuzycie, dump, dump = self.PolSQL.Execute(SQL, 3)

                    if stat == 'OK':
                        for poz in DZuzycie:
                            if UwzgledniacCechy:
                                klpoz = (poz[0], poz[3])
                                if not klpoz in SArtCechy:
                                    rsglobal.ZapiszDoLogow("rseval {}".format(SArt[poz[0]]))
                                    SArtCechy[klpoz] = rsglobal.rseval(str(SArt[poz[0]]))

                                pozart = SArtCechy[klpoz]
                                # stan zuycia na dzien
                                pozart[9] += poz[2]
                                pozart[17] += rsglobal.RSRound(poz[2] * poz[1], 2)
                            else:
                                if rsglobal.Dekoduj(poz[0]) in SZamArt:
                                    # pobranie pozycji z grida, ktr naley edytowa
                                    pozart = SArt[SZamArt[rsglobal.Dekoduj(poz[0])]]
                                    # stan zuycia na dzien
                                    pozart[9] += poz[2]
                                    pozart[17] += rsglobal.RSRound(poz[2] * poz[1], 2)

            # ----------------------------------------------------------
            # policzenie iloci z zamwie dostawcw
            # ----------------------------------------------------------

            if stat == 'OK':
                # pobranie wszystkich danych, ktre bd uywane
                SQL = "SELECT TRIM(zdp.artykul_id),"
                SQL += "SUM(CASE WHEN zdp.ilosc1-zdp.dostarczono1-zdp.anulowano1 > 0 THEN zdp.ilosc1-zdp.dostarczono1-zdp.anulowano1 ELSE 0 END),"
                SQL += "SUM(CASE WHEN zdp.ilosc2-zdp.dostarczono2-zdp.anulowano2 > 0 THEN zdp.ilosc2-zdp.dostarczono2-zdp.anulowano2 ELSE 0 END)"
                SQL += PoleCechaWartZDP
                SQL += " FROM rs_zamowienia_dostawcy_pozycje zdp "
                SQL += " INNER JOIN rs_zamowienia_dostawcy zd USING (firma_id,wyznacznik_id,data,numer) "
                SQL += " WHERE zdp.firma_id='" + self.firma_id + "' AND zdp.artykul_id IN (" + str(LArtDoF)[1:-1] + ") "
                if HandlowiecF != '':
                    SQL += " AND zd.handlowiec ='" + HandlowiecF + "'"
                if self.handlowiec_id != None:
                    SQL += " AND zd.handlowiec ='" + self.handlowiec_id + "'"
                SQL += rsglobal.WyznaczFiltrNaCeche(CechaOd, CechaDo, 'zdp')
                SQL += " AND zd.stan != 'W' GROUP BY zdp.artykul_id" + PoleCechaWartZDP + " ORDER BY artykul_id;"
                stat, DZamDost, dump, dump = self.PolSQL.Execute(SQL, 3)

            if stat == 'OK':
                for poz in DZamDost:
                    if UwzgledniacCechy:
                        klpoz = (poz[0], poz[3])
                        if not klpoz in SArtCechy:
                            rsglobal.ZapiszDoLogow("rseval {}".format(SArt[poz[0]]))
                            SArtCechy[klpoz] = rsglobal.rseval(str(SArt[poz[0]]))

                        pozart = SArtCechy[klpoz]
                        # stan zamwie dostawcow
                        pozart[10] += poz[1]
                        pozart[18] += poz[2]
                    else:
                        if rsglobal.Dekoduj(poz[0]) in SZamArt:
                            # pobranie pozycji z grida, ktr naley edytowa
                            pozart = SArt[SZamArt[rsglobal.Dekoduj(poz[0])]]
                            # stan zamwie dostawcow
                            pozart[10] += poz[1]
                            pozart[18] += poz[2]

            # ----------------------------------------------------------
            # policzenie iloci z zamwie odbiorcw
            # ----------------------------------------------------------

            if stat == 'OK':
                # pobranie wszystkich danych, ktre bd uywane
                SQL = "SELECT TRIM(zop.artykul_id),"
                SQL += "SUM(CASE WHEN zop.ilosc1-zop.dostarczono1-zop.anulowano1 > 0 THEN zop.ilosc1-zop.dostarczono1-zop.anulowano1 ELSE 0 END),"
                SQL += "SUM(CASE WHEN zop.ilosc2-zop.dostarczono2-zop.anulowano2 > 0 THEN zop.ilosc2-zop.dostarczono2-zop.anulowano2 ELSE 0 END)"
                SQL += " FROM rs_zamowienia_odbiorcy_pozycje zop "
                SQL += " INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer) "
                SQL += " WHERE firma_id='" + self.firma_id + "' AND artykul_id IN (" + str(LArtDoF)[1:-1] + ") "
                if HandlowiecF != '':
                    SQL += " AND zo.handlowiec ='" + HandlowiecF + "'"
                if self.handlowiec_id != None:
                    SQL += " AND zo.handlowiec ='" + self.handlowiec_id + "'"
                if rsglobal.SprawdzCzyToData(ZamowieniaMlodszeNizF):
                    SQL += " AND zo.data >='" + ZamowieniaMlodszeNizF + "'"
                SQL += " AND zo.stan != 'W' GROUP BY zop.artykul_id ORDER BY artykul_id;"
                stat, DZamOdb, dump, dump = self.PolSQL.Execute(SQL, 3)

            if stat == 'OK':
                if UwzgledniacCechy:
                    # to do uzupenienia po zmianach w zamwieniach odbiorcw
                    pass
                else:
                    for poz in DZamOdb:
                        if rsglobal.Dekoduj(poz[0]) in SZamArt:
                            # pobranie pozycji z grida, ktr naley edytowa
                            pozart = SArt[SZamArt[rsglobal.Dekoduj(poz[0])]]
                            # stan zamwie odbiorcw
                            pozart[11] += poz[1]
                            pozart[19] += poz[2]

            # ----------------------------------------------------------
            # proponowane iloci zamwienia do dostawcy
            # ----------------------------------------------------------

            if stat == 'OK' and not UwzgledniacCechy:
                for poz in SZamArt:
                    pozart = SArt[SZamArt[poz]]
                    pozart[12] = max(pozart[5] - pozart[10] + pozart[11] - pozart[7], 0)
                    pozart[20] = max(pozart[13] - pozart[18] + pozart[19] - pozart[15], 0)

            # ----------------------------------------------------------
            # wstawienie danych po wszystkich obliczeniach
            # ----------------------------------------------------------

            if stat == 'OK':
                if UwzgledniacCechy:
                    ZmiennaTestu = SArtCechy
                else:
                    ZmiennaTestu = KluczeArt

                for kl in ZmiennaTestu:
                    if stat == 'OK':
                        if UwzgledniacCechy:
                            poz = SArtCechy[kl]
                        else:
                            poz = SArt[kl]

                        # zostao zaoy konkretne filtry i sprawdzi, czy wszystko si zgadza
                        Zaakceptowany = True

                        if ZamBezPokrF:
                            # jesli akt+zam.dost.-zam.odb >0 (jest pokrycie) to odpada
                            if poz[7] + poz[10] - poz[11]:
                                Zaakceptowany = False

                        if DniDoStMinF > 0 and DniZuzF:  # uwaga! aby to dziaao musi by podana ilo dni zuycia
                            # jeli zuycie przez x dni jest mniejsze ni zapas nad stanem minimalnym
                            if (poz[9] * DniDoStMinF) < (poz[7] - poz[5]):
                                Zaakceptowany = False

                        if ProcPowMinF > 0:
                            # jeli stan minimalny*(100+x)% jest mniejszy ni aktualny to odpada
                            if poz[5] * (100 + ProcPowMinF) * 0.01 < poz[7]:
                                Zaakceptowany = False

                        if SztPowMinF > 0:
                            # jeli stan minimalny+x jest mniejszy ni aktualny to odpada
                            if poz[5] + SztPowMinF < poz[7]:
                                Zaakceptowany = False

                        if CzyPonizejMinF:
                            # jesli aktualny >= minimalny to odpada
                            if poz[7] >= poz[5]:
                                Zaakceptowany = False

                        if CzyPowyzejMaxF:
                            # jesli aktualny >= minimalny to odpada
                            if poz[7] <= poz[6]:
                                Zaakceptowany = False

                        if CzyZamowioneF:
                            # jesli zamwione <0 to odpada
                            if poz[11] <= 0:
                                Zaakceptowany = False

                        if DodatniMinMaxF:
                            if poz[5] == 0 and poz[6] == 0:
                                Zaakceptowany = False

                        # jesli sie zgadza to trafia do grida
                        if Zaakceptowany:
                            if UwzgledniacCechy:
                                # pobranie opisu cechy
                                SQL = "SELECT rsf_podaj_parametry_cechy('" + self.firma_id + "','" + poz[-1] + "','" + \
                                      kl[1] + "','opis')"
                                stat, DCechyOpis, dump, dump = self.PolSQL.Execute(SQL, 3)
                                if stat == "OK":
                                    CechaOpisTmp = DCechyOpis[0][0]
                                    if self.dwie_jm:
                                        dane.append(
                                            [kl[0], poz[2], poz[23], kl[1], CechaOpisTmp, poz[1], MagF, poz[3]] + poz[
                                                                                                                  5:13] + [
                                                poz[4]] + poz[13:23])
                                    else:
                                        dane.append(
                                            [kl[0], poz[2], poz[23], kl[1], CechaOpisTmp, poz[1], MagF, poz[3]] + poz[
                                                                                                                  5:13] + [
                                                poz[22]])
                            else:
                                if self.dwie_jm:
                                    dane.append(
                                        [kl, poz[2], '', '', '', poz[1], MagF, poz[3]] + poz[5:13] + [poz[4]] + poz[
                                                                                                                13:23])
                                else:
                                    dane.append([kl, poz[2], '', '', '', poz[1], MagF, poz[3]] + poz[5:13] + [poz[22]])

    # -##############################################################################
    # -- KONIEC POBIERANIA DANYCH DO WSZYSTKICH GRIDW. DALEJ JEST WSPLNY KOD
    # -##############################################################################

    if stat == 'OK':
        # sprawdzenie czy jest to konkretny magazyn czy nie
        SQL = " SELECT magazyn_id FROM rs_magazyny WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagF + "';"
        stat, DMagTest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat == 'OK':
            wyn2 = [len(DMagTest) > 0]
    else:
        wyn2 = [False]
        
