# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_analiza_zlecen.py
# Purpose:     funkcja obsugujca okno analizy zlece
# Author:      Micha Raburski
# Created:     2014/12/09
# RCS-ID:      $Id: fs_analiza_zlecen.py $
# Copyright:   (c) 2014 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# FUNKCJE 
# 5 - pobranie danych
# 11 - rezerwacja na zleceniu
# 12 - zlecenie wykonania produkcji 
# 13 - akceptacja produkcji
# 14 - wykonanie produkcji
# 15 - zgoszenie brakw

from funkcje import fs_artykuly_wzory_parametry_pom
from funkcje import fs_dokumenty_magazynowe_pom

stat='OK'
dane=[]
wyn1 = []
wyn2 = []
UprProd=((self.oddzial_id,'241002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprRezerw=((self.oddzial_id,'241003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
rsglobal.ZapiszDoLogow('klucze '+str(klucze),1)
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'FWyzn':[5,11,12,13,14,15], 'FDataOd':[5,11,12,13,14,15], 'FDataDo':[5,11,12,13,14,15], 'FNrZam':[5,11,12,13,14,15], 'FKontr':[5,11,12,13,14,15], 
          'FKateg':[5,11,12,13,14,15], 'FArt':[5,11,12,13,14,15], 'FNazwa':[5,11,12,13,14,15], 'FCecha':[5,11,12,13,14,15], 'FCechaWartOd':[5,11,12,13,14,15], 
          'FCechaWartDo':[5,11,12,13,14,15], 'FZlecenie':[5,11,12,13,14,15], 'FZamowione':[5,11,12,13,14,15], 'FRealizowane':[5,11,12,13,14,15], 
          'FZarezerwowane':[5,11,12,13,14,15], 'FZrealizowane':[5,11,12,13,14,15], 'FPoszczegolneZlecenia':[5,11,12,13,14,15], 'FSumyZlecen':[5,11,12,13,14,15], 
          'Zlecenie':[11,12,13,14,15],'Ilosc':[11,12,13,14,15],'PozAP':[11], 'LMag':[13], 'KluczDM':[14], 'Cena':[14]}    
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_analiza_zlecen z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
    if Funkcja in [5,11,12,13,14,15]:
        FWyzn = rsglobal.Dekoduj(klucze['FWyzn'])
        FDataOd = rsglobal.Dekoduj(klucze['FDataOd'])
        FDataDo = rsglobal.Dekoduj(klucze['FDataDo'])
        FNrZam = rsglobal.Dekoduj(klucze['FNrZam'])
        FKontr = rsglobal.Dekoduj(klucze['FKontr'])
        FKateg = rsglobal.Dekoduj(klucze['FKateg'])
        FArt = rsglobal.Dekoduj(klucze['FArt'])
        FNazwa = rsglobal.Dekoduj(klucze['FNazwa'])
        FCecha = rsglobal.Dekoduj(klucze['FCecha'])
        FCechaWartOd = rsglobal.Dekoduj(klucze['FCechaWartOd'])
        FCechaWartDo = rsglobal.Dekoduj(klucze['FCechaWartDo'])
        FZlecenie = klucze['FZlecenie']
        FZamowione = klucze['FZamowione']
        FRealizowane = klucze['FRealizowane']
        FZarezerwowane = klucze['FZarezerwowane']
        FZrealizowane = klucze['FZrealizowane']
        FPoszczegolneZlecenia = klucze['FPoszczegolneZlecenia']
        FSumyZlecen = klucze['FSumyZlecen']
    if Funkcja == 11:
        PozAP = klucze['PozAP']
    if Funkcja in [11,12,13,14,15]:
        Zlecenie = klucze['Zlecenie']
        Ilosc = klucze['Ilosc']
    if Funkcja == 13:
        LMag = klucze["LMag"]
    if Funkcja == 14:
        KluczDM = klucze["KluczDM"]
        Cena = klucze["Cena"]

#-------------------------------------------------------------------------------
# REZERWACJA NA ZLECENIU  (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    # ze zlecenia i artykuw  pobieramy artyku,cech i parametr, przelicznik i opis cechy
    KlZlec = Zlecenie.split('/')
    if len(KlZlec) <> 6:
        stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
    if stat == 'OK':
        SQL="SELECT zoz.artykul_id,zoz.cecha1_wartosc,a.przelicznik,a.cecha1_opis"
        SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz"
        SQL+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        SQL+=" WHERE zoz.firma_id='"+self.firma_id+"' AND zoz.wyznacznik_id = '"+KlZlec[0]+"'"
        SQL+=" AND zoz.data = '"+KlZlec[1]+"'"
        SQL+=" AND zoz.numer = "+str(KlZlec[2])+" AND zoz.nr_poz = "+str(KlZlec[3])
        SQL+=" AND zoz.nr_ppoz = "+str(KlZlec[4])+" AND zoz.nr_zlec = '"+KlZlec[5]+"'"
        stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania danych artykuu dla zlecenia '+Zlecenie+' :'+stat
    
    if stat == 'OK':
        if len(DArt) == 0:
            stat = 'Podano nieprawidowy klucz zlecenia :'+KlZlec
    
    # sprawdzamy, czy z wybranych magazynw da si pobra ilo do zarezerwowania
    if stat == 'OK':
        Art = DArt[0][0]
        CechaWart = DArt[0][1]
        Przel = DArt[0][2]
        Cecha = DArt[0][3]

        # Dla kadego rekordu z AP wyznaczamy tyle iloci ile trzeba a do uzyskania iloci
        SMag = {}

        for pozAP in PozAP:
            if Ilosc == 0:
                continue
            
            DataAP = pozAP[1]
            MagAP = pozAP[2]
            DokAP = pozAP[3]
            NrAP = pozAP[4]
            NrPozAP = pozAP[5]
            NrPPozAP = pozAP[6]
            IloscAP = pozAP[11]
            
            if IloscAP == 0:
                continue
            
            if not MagAP in SMag:
                SMag[MagAP] = []
            
            SymbolAP = fs_dokumenty_magazynowe_pom.PodajNumerPrzyjecia(self,MagAP,DokAP,DataAP,NrAP,NrPozAP,NrPPozAP)
            
            IloscBuf = min(Ilosc,IloscAP)
            Ilosc = Ilosc - IloscBuf
            SMag[MagAP].append([SymbolAP,IloscBuf])
            
            
        # dla kolejnych magazynw tworzymy RW i staramy si je zamkn do G.
        for mag in SMag:
            # wyznaczenie iloci na dokument
            if stat == 'OK':
                LPozAP = SMag[mag]
                
                # pobranie numeru dokumentu
                Magazyn = mag
                Typ = 'RW'
                Data = rsglobal.PodajDzis()                
                
                stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)            
                if stat <> 'OK':
                    stat = 'Bdy spawdzania monoci dodania dokumentu :'+stat
                    
            if stat =='OK':
                if test[0][0]<>'OK':    
                    stat = 'Nie mona doda dokumentu '+Typ+' z powodu :'+test[0][0]
        
            if stat =='OK':
                stat,DNum,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)        
                if stat<>'OK':
                    stat ='Bdy podawania nowego numeru dokumentu '+Typ+': '+stat
            
            if stat =='OK':
                if DNum[0][0] in (None,'None',''):
                    stat = 'Bdy numerowania dokumentu '+Typ 
            
            if stat =='OK':  
                NrDok=DNum[0][0]

            # stworzenie nagwka DM
            INS="INSERT INTO rs_dokumenty_magazynowe"
            INS+=" (firma_id,magazyn_id,dokument_id,data,numer,"
            INS+="magazyn_skad ,waluta)"
            INS+=" VALUES"
            INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+str(Data)+"',"+str(NrDok)+","
            INS+="  '"+Magazyn+"','PLN');"
                
            # stworzenie pozycji DM
            LP = 1
            for poz in LPozAP:
                SymbAP = poz[0]
                IlDm = poz[1]
                
                Ilosc2 = rsglobal.RSRound(IlDm * Przel,4)
                CechaWart = "''"
                if Cecha == '':
                    CechaWart = 'NULL'
                
                INS+= "INSERT INTO rs_dokumenty_magazynowe_pozycje "
                INS+= "(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,cecha1_opis,cecha1_wartosc,dokument_przych,"
                INS+=" ilosc1,ilosc2,zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,zo_nr_zlec,typ_zlec) " 
                INS+= " VALUES('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+Data+"',"+str(NrDok)+","
                INS+= str(LP)+",0,'"+rsglobal.Dekoduj(Art)+"','"+Cecha+"',"+CechaWart+",'"+SymbAP+"',"+str(IlDm)+","+str(Ilosc2)+","
                INS+="'"+KlZlec[0]+"','"+KlZlec[1]+"',"+str(KlZlec[2])+","+str(KlZlec[3])+","+str(KlZlec[4])+",'"+KlZlec[5]+"','R'); "
                
                LP+=1
                
            stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
            if stat <> 'OK':
                stat ='Wystpiy bdy podczas tworzenia dokumentu '+Magazyn+'/'+Typ+'/'+Data+'/'+str(NrDok)+' :'+stat        
                    
            # zamknicie dokumentu z W na G
            if stat == 'OK':
                KluczeDok=['','','','','','','','','','',[],False,False,False,False,Magazyn,Typ,Data,NrDok,18]
                spom='rs_artykuly'
                while spom.find('rs_artykuly')>-1:
                    spom, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)
                    rsglobal.ZapiszDoLogow('!!! spom '+spom,1)
                    if spom.find('rs_artykuly')>-1:
                        time.sleep(1)
                if spom <> 'OK':
                    stat = 'Bd przygotowywania dokumentu '+Magazyn+'/'+Typ+'/'+Data+'/'+str(NrDok)+' :'+spom

    
#-------------------------------------------------------------------------------
# ZLECENIE DO PRODUKCJI  (12)
#-------------------------------------------------------------------------------

if Funkcja == 12 and stat == 'OK':
    KlZlec = Zlecenie.split('/')
    if len(KlZlec) <> 6:
        stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
        
    SQL = "SELECT ilosc_calk, ilosc_do_produkcji "
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
    SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
    SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
    SQL+=" AND nr_zlec='"+KlZlec[5]+"'"
    stat,DZlec,dump,dump = self.PolSQL.Execute(SQL,3)   
    if stat <> 'OK':
        stat = 'Bd pobierania informacji o zleceniu: '+stat
    
    if stat == 'OK':
        if len(DZlec) == 0:
            stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
    
    if stat == 'OK':
        # update na zleceniu gwnym - dodajemy po prostu ilo do produkcji
        SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_do_produkcji = ilosc_do_produkcji + "+str(Ilosc)
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
        SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
        SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
        SQL+=" AND nr_zlec ='"+KlZlec[5]+"'"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd zmiany iloci zlecanej do produkcji na zleceniu: '+stat
        
    if stat == 'OK' and Ilosc > 0:
        # update na podzleceniach 
        
        # wzr na sum produkcji podzlecenia to (stara produkcja zlecenia + nowa ilo zlecenia) / caa ilo
        # tyle czci ma by wyprodukowane. Wwczas produkcja podzlecenia to przeliczona ilo - rezerwacja
        # np. Robimy 10 kanaw i do nich 100 wpustw. Najpierw zarezerwowalimy 10 wpustw. Potem produkujemy 5 kanaw.
        # Liczymy, e mamy mie dostpne (100 * (5/ 10)) = 50 wpustw. 50 - 10 zarezerwow, daje 40 wpustw do produkcji.
        WspIl = '(('+str(Ilosc)+'+'+str(DZlec[0][1])+')/'+str(DZlec[0][0])+')'
        
        SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_do_produkcji = "
        SQL+= "CASE WHEN ilosc_do_produkcji > ilosc_calk * "+WspIl+" - ilosc_rezerwacja THEN ilosc_do_produkcji ELSE ilosc_calk * "+WspIl+" - ilosc_rezerwacja END"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
        SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
        SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
        SQL+=" AND TRIM(nr_zlec) LIKE '"+KlZlec[5].strip()+".%'"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd zmiany iloci zlecanej do produkcji na podzleceniach: '+stat


#-------------------------------------------------------------------------------
# AKCEPTACJA PRODUKCJI  (13)
#-------------------------------------------------------------------------------

if Funkcja == 13 and stat == 'OK':
    KlZlec = Zlecenie.split('/')
    if len(KlZlec) <> 6:
        stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
    
    # pobranie iloci do wspczynnika produkcyjnego
    SQL = "SELECT ilosc_calk, ilosc_produkowana"
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
    SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
    SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
    SQL+=" AND nr_zlec='"+KlZlec[5]+"'"
    stat,DZlec,dump,dump = self.PolSQL.Execute(SQL,3)   
    if stat <> 'OK':
        stat = 'Bd pobierania informacji o zleceniu: '+stat
    
    if stat == 'OK':
        if len(DZlec) == 0:
            stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
            
    if stat == 'OK':
        # update na zleceniu gwnym - dodajemy po prostu ilo produkowan
        SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_produkowana = ilosc_produkowana + "+str(Ilosc)
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
        SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
        SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
        SQL+=" AND nr_zlec ='"+KlZlec[5]+"'"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd zmiany iloci produkowanej na zleceniu: '+stat
    
    if stat == 'OK' and Ilosc > 0:
        # pobieramy surowce wykonywane - stan aktualny
        SQL = "SELECT zoz.wyznacznik_id,zoz.data,zoz.numer,zoz.nr_poz,zoz.nr_ppoz,zoz.nr_zlec,"
        SQL+=" zoz.artykul_id, zoz.cecha1_wartosc, zoz.ilosc_produkowana, a.przelicznik,COALESCE(a.cecha1_opis,'') "
        SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz "
        SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE zoz.firma_id='"+self.firma_id+"' AND zoz.wyznacznik_id='"+KlZlec[0]+"'"
        SQL+=" AND zoz.data='"+KlZlec[1]+"' AND zoz.numer="+str(KlZlec[2])
        SQL+=" AND zoz.nr_poz="+KlZlec[3]+" AND zoz.nr_ppoz="+str(KlZlec[4])
        SQL+=" AND zoz.nr_zlec LIKE '"+KlZlec[5]+".%' AND a.typ_artykulu = '04'" 
        stat,DSurS,dump,dump = self.PolSQL.Execute(SQL,3)   
        if stat <> 'OK':
            stat = 'Bd pobierania informacji o surowcach podzlece: '+stat
                
        if stat == 'OK':
            # update na podzleceniach 
            
            # wzr na sum produkcji podzlecenia to (stara produkcja zlecenia + nowa ilo zlecenia) / caa ilo
            # tyle czci ma by wyprodukowane. Wwczas produkcja podzlecenia to przeliczona ilo - rezerwacja
            # np. Robimy 10 kanaw i do nich 100 wpustw. Najpierw zarezerwowalimy 10 wpustw. Potem produkujemy 5 kanaw.
            # Liczymy, e mamy mie dostpne (100 * (5/ 10)) = 50 wpustw. 50 - 10 zarezerwow, daje 40 wpustw do produkcji.
            WspIl = '(('+str(Ilosc)+'+'+str(DZlec[0][1])+')/'+str(DZlec[0][0])+')'
            
            SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_produkowana = "
            SQL+= "CASE WHEN ilosc_produkowana > ilosc_calk * "+WspIl+" - ilosc_rezerwacja THEN ilosc_produkowana ELSE ilosc_calk * "+WspIl+" - ilosc_rezerwacja END"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
            SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
            SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
            SQL+=" AND TRIM(nr_zlec) LIKE '"+KlZlec[5].strip()+".%'"
            rsglobal.ZapiszDoLogow('SQL '+SQL,1)
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat = 'Bd zmiany iloci zlecanej do produkcji na podzleceniach: '+stat

        # pobieramy surowce wykonywane - stan po zmianach
        if stat == 'OK':
            SQL = "SELECT zoz.wyznacznik_id,zoz.data,zoz.numer,zoz.nr_poz,zoz.nr_ppoz,zoz.nr_zlec,"
            SQL+=" zoz.artykul_id, zoz.cecha1_wartosc, zoz.ilosc_produkowana,a.przelicznik,COALESCE(a.cecha1_opis,'') "
            SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz "
            SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+=" WHERE zoz.firma_id='"+self.firma_id+"' AND zoz.wyznacznik_id='"+KlZlec[0]+"'"
            SQL+=" AND zoz.data='"+KlZlec[1]+"' AND zoz.numer="+str(KlZlec[2])
            SQL+=" AND zoz.nr_poz="+KlZlec[3]+" AND zoz.nr_ppoz="+str(KlZlec[4])
            SQL+=" AND zoz.nr_zlec LIKE '"+KlZlec[5]+".%' AND a.typ_artykulu = '04'" 
            rsglobal.ZapiszDoLogow('SQLSN '+SQL,1)
            stat,DSurN,dump,dump = self.PolSQL.Execute(SQL,3)   
            rsglobal.ZapiszDoLogow('DSurN '+str(DSurN),1)
            if stat <> 'OK':
                stat = 'Bd pobierania informacji o surowcach podzlece: '+stat
        
        # wystawienie RW na surowce
        if stat == 'OK':
            # porwnanie informacji o surowcach w celu wyznaczenia faktycznych iloci koniecznych do wystawienia na RW
            SSurZlec = {} # Sownik ze zleceniami
            # to s nowe wartoci
            for poz in DSurN:
                kl = (poz[6], poz[7], poz[0],poz[1], poz[2], poz[3],poz[4], poz[5], poz[9], poz[10]) # art, cecha, klucz zlecenia, przelicznik, cecha
                if not kl in SSurZlec:
                    SSurZlec[kl] = 0
                SSurZlec[kl] += poz[8]
            
            # odejmujemy od nich stare
            for poz in DSurS:
                kl = (poz[6], poz[7], poz[0],poz[1], poz[2], poz[3],poz[4], poz[5], poz[9], poz[10]) # art, cecha, klucz zlecenia, przelicznik, cecha
                if kl in SSurZlec:
                    SSurZlec[kl] -= poz[8]
                    
            SSur = {} # pomocnicza suma surowcw do sprawdzenia czy da si to wyda z wybranych przez operatora magazynw
                      # element to ile do wydania, ile w sumie dostpne, sownik z konkretnymi magazynami
            for kl in SSurZlec:
                if SSurZlec[kl] > 0:
                    klsur = (kl[0],kl[1])
                    if not klsur in SSur:
                        SSur[klsur] = [0,0,{}]
                    SSur[klsur][0] += SSurZlec[kl]
                    
            # sprawdzamy czy da si to wyda z artykuw przyj
            FiltrMag = ''
            LMagS = LMag.split(',')
            for mag in LMagS:
                FiltrMag+="'"+mag+"',"
            FiltrMag = FiltrMag.strip(",")
            
            # przy okazji uzupeniamy iloci dostpne w magazynach
            for kl in SSur:
                if stat == 'OK':
                    Art = kl[0]
                    CechaWart = kl[1].strip()
                    
                    SQL = "SELECT magazyn_id,SUM(ilosc1 - rezerwacja1) FROM rs_artykuly_przyjecia "
                    SQL+= " WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Art+"'"
                    SQL+= " AND TRIM(cecha1_wartosc) = '"+CechaWart+"' AND data <= '"+rsglobal.PodajDzis()+"'"
                    SQL+= " AND magazyn_id IN ("+FiltrMag+") AND NOT wirtualne GROUP BY magazyn_id ORDER BY magazyn_id;" 
                    stat,DSurAP,dump,dump = self.PolSQL.Execute(SQL,3)   
                    if stat <> 'OK':
                        stat = 'Bd pobierania informacji o surowcach na artykuach przyjcia: '+stat
        
                if stat == 'OK':
                    for poz in DSurAP:
                        SSur[kl][1] += poz[1] # dodanie do oglnej sumy
                        SSur[kl][2][poz[0]] = poz[1] # dodanie konkretnego magazynu
                    # sprawdzenie konkretnego surowca
                    if SSur[kl][0] > SSur[kl][1]:
                        stat = 'Nie mona wyda surowca '+Art.strip()
                        if CechaWart <> '':
                            stat+= 'z cech '+CechaWart
                        stat += '. \n Do wydania : '+str(SSur[kl][0])
                        stat += '   w magazynach '+LMag+" : "+str(SSur[kl][1])
        
        # powinno wszystko da si wyda. Przypisujemy do zlece odpowiednie iloci i magazyny
        if stat == 'OK':      
            SPozMag = {}
        
            for klzlec in SSurZlec:
                Ilosc = SSurZlec[klzlec]
                
                SIlMag = SSur[(klzlec[0],klzlec[1])][2]
                for mag in SIlMag:
                    if Ilosc > 0:
                        IlMax = min(Ilosc,SIlMag[mag])
                        if IlMax > 0:
                            if not mag in SPozMag:
                                SPozMag[mag] = []
                            SPozMag[mag].append([klzlec,IlMax])
                            Ilosc -= IlMax
                            SSur[(klzlec[0],klzlec[1])][2][mag] -= IlMax
        
        # Tworzymy odpowiednie RW
        if stat == 'OK':    
            KomunikatRW = ''  
            for Mag in SPozMag:
                LPoz = SPozMag[Mag]
                LPoz.sort()
                
                # pobranie numeru dokumentu
                Magazyn = Mag
                Typ = 'RW'
                Data = rsglobal.PodajDzis()                
                
                stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)            
                if stat <> 'OK':
                    stat = 'Bdy spawdzania monoci dodania dokumentu :'+stat
                    
                if stat =='OK':
                    if test[0][0]<>'OK':    
                        stat = 'Nie mona doda dokumentu '+Typ+' z powodu :'+test[0][0]
            
                if stat == 'OK':
                    stat,DNum,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)        
                    if stat<>'OK':
                        stat ='Bdy podawania nowego numeru dokumentu '+Typ+': '+stat
                
                if stat == 'OK':
                    if DNum[0][0] in (None,'None',''):
                        stat = 'Bdy numerowania dokumentu '+Typ 
                
                if stat == 'OK':  
                    NrDok=DNum[0][0]
                
                    # dodanie nagwka RW
                    INS="INSERT INTO rs_dokumenty_magazynowe"
                    INS+=" (firma_id,magazyn_id,dokument_id,data,numer,"
                    INS+="magazyn_skad ,waluta)"
                    INS+=" VALUES"
                    INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+str(Data)+"',"+str(NrDok)+","
                    INS+="  '"+Magazyn+"','PLN');"
                    
                    # dodanie pozycji RW
                    LP = 1
                    for poz in LPoz:
                        Art = poz[0][0]
                        CechaWart = poz[0][1]
                        Przel = poz[0][8]
                        Cecha = poz[0][9]
                        IlDm = poz[1]
                        
                        Ilosc2 = rsglobal.RSRound(IlDm * Przel,4)
                        
                        INS+= "INSERT INTO rs_dokumenty_magazynowe_pozycje "
                        INS+= "(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,cecha1_opis,cecha1_wartosc,"
                        INS+=" ilosc1,ilosc2,zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,zo_nr_zlec,typ_zlec) " 
                        INS+= " VALUES('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+Data+"',"+str(NrDok)+","
                        INS+= str(LP)+",0,'"+rsglobal.Dekoduj(Art)+"','"+Cecha+"','"+CechaWart+"',"+str(IlDm)+","+str(Ilosc2)+","
                        INS+="'"+poz[0][2]+"','"+poz[0][3]+"',"+str(poz[0][4])+","+str(poz[0][5])+","+str(poz[0][6])+",'"+poz[0][7]+"','A'); "
                        
                        LP+=1
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
                    if stat <> 'OK':
                        stat ='Wystpiy bdy podczas tworzenia dokumentu '+Magazyn+'/'+Typ+'/'+Data+' '+str(NrDok)+' :'+stat        
                            
                    
                # zamknicie dokumentu z W na G
                if stat == 'OK':
                    # zapisujemy utworzenie dokumentu
                    self.PolSQL.Commit()
                    
                    KluczeDok=['','','','','','','','','','',[],False,False,False,False,Magazyn,Typ,Data,NrDok,18]
                    spom='rs_artykuly'
                    while spom.find('rs_artykuly')>-1:
                        spom, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)
                        if spom.find('rs_artykuly')>-1:
                            time.sleep(1)

                    if len(spom) < 10:
                        KomunikatRW+="Dokument "+Magazyn+'/'+Typ+'/'+Data+'/'+str(NrDok)+' : '+spom+'\n\n'
                    else:
                        KomunikatRW+="Dokument "+Magazyn+'/'+Typ+'/'+Data+'/'+str(NrDok)+' :\n '+spom+'\n\n'

                if stat == 'OK':      
                    wyn1 = [KomunikatRW]
                else:
                    wyn1 = []

#-------------------------------------------------------------------------------
# WYKONANIE PRODUKCJI  (14)
#-------------------------------------------------------------------------------

if Funkcja == 14 and stat == 'OK':
    KlZlec = Zlecenie.split('/')
    if len(KlZlec) <> 6:
        stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
    
    # pobranie iloci do wspczynnika produkcyjnego
    SQL = "SELECT zoz.ilosc_calk, zoz.ilosc_wykonana, zoz.artykul_id,zoz.cecha1_wartosc,"
    SQL+=" a.przelicznik,a.cecha1_opis"
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+=" WHERE zoz.firma_id='"+self.firma_id+"' AND zoz.wyznacznik_id='"+KlZlec[0]+"'"
    SQL+=" AND zoz.data='"+KlZlec[1]+"' AND zoz.numer="+str(KlZlec[2])
    SQL+=" AND zoz.nr_poz="+KlZlec[3]+" AND zoz.nr_ppoz="+str(KlZlec[4])
    SQL+=" AND zoz.nr_zlec='"+KlZlec[5]+"'"
    stat,DZlec,dump,dump = self.PolSQL.Execute(SQL,3)   
    if stat <> 'OK':
        stat = 'Bd pobierania informacji o zleceniu: '+stat
    
    if stat == 'OK':
        if len(DZlec) == 0:
            stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie

    if stat == 'OK' and KluczDM == []:
        # update na zleceniu gwnym - dodajemy po prostu ilo produkowan
        SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_wykonana = ilosc_wykonana + "+str(Ilosc)+","
        SQL+=" ilosc_zrealizowana = ilosc_zrealizowana + "+str(Ilosc)
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
        SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
        SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
        SQL+=" AND nr_zlec ='"+KlZlec[5]+"'"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd zmiany iloci produkowanej na zleceniu: '+stat
            
    if stat == 'OK':
        # update na podzleceniach 
        
        # wzr na sum produkcji podzlecenia to (stara produkcja zlecenia + nowa ilo zlecenia) / caa ilo
        # tyle czci ma by wyprodukowane. Wwczas produkcja podzlecenia to przeliczona ilo - rezerwacja
        # np. Robimy 10 kanaw i do nich 100 wpustw. Najpierw zarezerwowalimy 10 wpustw. Potem produkujemy 5 kanaw.
        # Liczymy, e mamy mie dostpne (100 * (5/ 10)) = 50 wpustw. 50 - 10 zarezerwow, daje 40 wpustw do produkcji.
        WspIl = '(('+str(Ilosc)+'+'+str(DZlec[0][1])+')/'+str(DZlec[0][0])+')'
        
        SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_wykonana = "
        SQL+= "CASE WHEN ilosc_wykonana > ilosc_calk * "+WspIl+" - ilosc_rezerwacja THEN ilosc_wykonana ELSE ilosc_calk * "+WspIl+" - ilosc_rezerwacja END,"
        SQL+=" ilosc_zrealizowana = ilosc_zrealizowana + CASE WHEN ilosc_wykonana > ilosc_calk * "+WspIl+" - ilosc_rezerwacja THEN 0 ELSE (ilosc_calk * "+WspIl+" - ilosc_rezerwacja) - ilosc_wykonana END "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
        SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
        SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
        SQL+=" AND TRIM(nr_zlec) LIKE '"+KlZlec[5].strip()+".%'"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd zmiany iloci wykonanej do produkcji na podzleceniach: '+stat
    
    # dodajemy dokument przychodowy na najwyyszym poziomie zlece
    if stat == 'OK' and KluczDM <> []:
        Magazyn = KluczDM[0]
        Typ = KluczDM[1]
        Data = KluczDM[2]
        
        # sprawdzenie czy typ jest przychodowy
        SQL= "SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id = '"+Typ+"';"
        stat,DTestM,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia typu dokumentu magazynowego: '+stat
        
        if stat == 'OK':
            if len(DTestM) == 0:
                stat = 'Podano niewaciwy typ dokumentu magazynowego :'+Typ
        
        if stat == 'OK':
            if DTestM[0][0] <> 'P':
                stat = 'Przy wykonywaniu produkcji naley poda przychodowy typ dokumentu magazynowego'
                
        if stat == 'OK':
            stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)            
            if stat <> 'OK':
                stat = 'Bdy spawdzania monoci dodania dokumentu :'+stat
            
        if stat =='OK':
            if test[0][0]<>'OK':    
                stat = 'Nie mona doda dokumentu '+Typ+' z powodu :'+test[0][0]
    
        if stat == 'OK':
            stat,DNum,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)        
            if stat<>'OK':
                stat ='Bdy podawania nowego numeru dokumentu '+Typ+': '+stat
        
        if stat == 'OK':
            if DNum[0][0] in (None,'None',''):
                stat = 'Bdy numerowania dokumentu '+Typ 
        
        if stat == 'OK':  
            NrDok=DNum[0][0]
        
            # dodanie nagwka dokumentu przychodowego
            INS="INSERT INTO rs_dokumenty_magazynowe"
            INS+=" (firma_id,magazyn_id,dokument_id,data,numer,"
            INS+="magazyn_dokad ,waluta)"
            INS+=" VALUES"
            INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+str(Data)+"',"+str(NrDok)+","
            INS+="  '"+Magazyn+"','PLN');"
            
            # dodanie pozycji dokumentu przychodowego
            Art = DZlec[0][2]
            CechaWart = DZlec[0][3]
            Przel = DZlec[0][4]
            Cecha = DZlec[0][5]
                        
            Ilosc2 = rsglobal.RSRound(Ilosc * Przel,4)
            Cena2 = rsglobal.RSRound(Cena / Przel,2)
            
            INS+= "INSERT INTO rs_dokumenty_magazynowe_pozycje "
            INS+= "(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,cecha1_opis,cecha1_wartosc,"
            INS+=" ilosc1,ilosc2,cena1,cena2,cena_wal1,cena_wal2,"
            INS+=" zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,zo_nr_zlec,typ_zlec) " 
            INS+= " VALUES('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+Data+"',"+str(NrDok)+","
            INS+= "1,0,'"+rsglobal.Dekoduj(Art)+"','"+Cecha+"','"+CechaWart+"',"+str(Ilosc)+","+str(Ilosc2)+","
            INS+= str(Cena)+","+str(Cena2)+","+str(Cena)+","+str(Cena2)+","
            INS+="'"+KlZlec[0]+"','"+KlZlec[1]+"',"+str(KlZlec[2])+","+str(KlZlec[3])+","+str(KlZlec[4])+",'"+KlZlec[5]+"','W'); "

            stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
            if stat <> 'OK':
                stat ='Wystpiy bdy podczas tworzenia dokumentu '+Magazyn+'/'+Typ+'/'+Data+' '+str(NrDok)+' :'+stat        
                    
        if stat == 'OK':        
            # zapisujemy utworzenie dokumentu
            self.PolSQL.Commit()
                    
            # zamknicie dokumentu z W na G
            KluczeDok=['','','','','','','','','','',[],False,False,False,False,Magazyn,Typ,Data,NrDok,18]
            spom='rs_artykuly'
            while spom.find('rs_artykuly')>-1:
                spom, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)
                rsglobal.ZapiszDoLogow('!!! spom '+spom,1)
                if spom.find('rs_artykuly')>-1:
                    time.sleep(1)
                    
                    
            if spom <> 'OK':
                wyn1 = [u'Bd przygotowywania dokumentu '+Magazyn+'/'+Typ+'/'+Data+' '+str(NrDok)+' :'+spom+'\nProdukcja zostanie wykonana dopiero po rcznym zamkniciu dokumentu magazynowego.']
                

#-------------------------------------------------------------------------------
# ZGOSZENIE BRAKW (15)
#-------------------------------------------------------------------------------

if Funkcja == 15 and stat == 'OK':
    KlZlec = Zlecenie.split('/')
    if len(KlZlec) <> 6:
        stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
        
    SQL = "SELECT ilosc_calk, ilosc_braki "
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"'"
    SQL+=" AND data='"+KlZlec[1]+"' AND numer="+str(KlZlec[2])
    SQL+=" AND nr_poz="+KlZlec[3]+" AND nr_ppoz="+str(KlZlec[4])
    SQL+=" AND nr_zlec='"+KlZlec[5]+"'"
    stat,DZlec,dump,dump = self.PolSQL.Execute(SQL,3)   
    if stat <> 'OK':
        stat = 'Bd pobierania informacji o zleceniu: '+stat
    
    if stat == 'OK':
        if len(DZlec) == 0:
            stat = 'Podano nieprawidowy numer zlecenia :'+Zlecenie
            
    if stat == 'OK':
        # Wspczynnik iloci wzgldem caoci pozwala atwo dziaa na podzleceniach
        WspIl = '('+str(Ilosc)+'/'+str(DZlec[0][0])+')'
        
        UPD = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_braki = ilosc_braki + (ilosc_calk * "+WspIl+")"
        UPD += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlZlec[0]+"' AND data='"+KlZlec[1]+"'"
        UPD += " AND numer="+str(KlZlec[2])+" AND nr_poz="+str(KlZlec[3])+" AND nr_ppoz="+str(KlZlec[4])
        UPD += " AND TRIM(nr_zlec) LIKE '"+KlZlec[5].strip()+"%';"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)   
        if stat <> 'OK':
            stat = 'Bd zmiany brakw na zleceniu: '+stat
            
#-------------------------------------------------------------------------------
# sprawdzenie poprawnoci zlece, ktre zostay zmienione
#-------------------------------------------------------------------------------

if Funkcja in [11,12,13,14,15] and stat =='OK':
    from funkcje import fs_zamowienia_odbiorcy_pozycje_zlecenia_pom
    stat = fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.SprawdzPoprawnoscZlecen(self,KlZlec[0],KlZlec[1],str(KlZlec[2]),str(KlZlec[3]),str(KlZlec[4]),KlZlec[5].strip())
        
#-------------------------------------------------------------------------------
# POBIERANIE DANYCH  (5)
#-------------------------------------------------------------------------------
    
if Funkcja in [5,11,12,13,14,15] and stat == 'OK':
    if FPoszczegolneZlecenia:
        SQL="SELECT zoz.wyznacznik_id||'/'||zoz.data||'/'||zoz.numer||'/'||zoz.nr_poz||'/'||zoz.nr_ppoz||'/'||zoz.nr_zlec,"
        SQL+="zoz.artykul_id,a.nazwa,zoz.cecha1_wartosc,rsf_podaj_parametry_cechy(zoz.firma_id,zoz.cecha1_opis,zoz.cecha1_wartosc,'opis'),"
        SQL+="zoz.parametry, zoz.ilosc_calk, zoz.ilosc_do_produkcji, zoz.ilosc_produkowana,zoz.ilosc_wykonana,zoz.ilosc_braki,"
        SQL+="zoz.ilosc_rezerwacja, zoz.ilosc_zrealizowana,"
        SQL+="zoz.ilosc_calk - zoz.ilosc_zrealizowana - (zoz.ilosc_do_produkcji - zoz.ilosc_wykonana),0"
    elif FSumyZlecen:
        SQL="SELECT '',zoz.artykul_id,a.nazwa,zoz.cecha1_wartosc,rsf_podaj_parametry_cechy(zoz.firma_id,zoz.cecha1_opis,zoz.cecha1_wartosc,'opis'),"
        SQL+="zoz.parametry, SUM(zoz.ilosc_calk), SUM(zoz.ilosc_do_produkcji), SUM(zoz.ilosc_produkowana),"
        SQL+="SUM(zoz.ilosc_wykonana),SUM(zoz.ilosc_braki),SUM(zoz.ilosc_rezerwacja),SUM(zoz.ilosc_zrealizowana),"
        SQL+="SUM(zoz.ilosc_calk - zoz.ilosc_zrealizowana - (zoz.ilosc_do_produkcji - zoz.ilosc_wykonana)),0"
        
    # jeli zlecenie podane, to reszta pl jest nadmiarowa i nieistotna
    if FZlecenie <> '':
        if FPoszczegolneZlecenia:    
            SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz"
            SQL+=" INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer)"
            SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+=" WHERE zoz.firma_id = '"+self.firma_id+"'"    
            KluczZlec = FZlecenie.split('/')
            SQL+=" AND zoz.wyznacznik_id = '"+KluczZlec[0]+"' AND zoz.data = '"+KluczZlec[1]+"'"
            SQL+=" AND zoz.numer = "+str(KluczZlec[2])+" AND zoz.nr_poz = "+str(KluczZlec[3])
            SQL+=" AND zoz.nr_ppoz = "+str(KluczZlec[4])+" AND TRIM(zoz.nr_zlec) LIKE '"+str(KluczZlec[5])+".__'"
        elif FSumyZlecen:
            SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz "
            SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+=" INNER JOIN rs_zamowienia_odbiorcy_pozycje_zlecenia zozp ON (zozp.firma_id=zoz.firma_id "
            SQL+=" AND zozp.wyznacznik_id = zoz.wyznacznik_id AND zozp.data = zoz.data "
            SQL+=" AND zozp.numer = zoz.numer AND zozp.nr_poz = zoz.nr_poz AND zozp.nr_ppoz = zoz.nr_ppoz "
            SQL+=" AND zozp.nr_zlec = zoz.nr_zlec_rodzic)"
            SQL+=" WHERE zoz.firma_id = '"+self.firma_id+"'"    
            KluczArt = FZlecenie.split('/')
            SQL+=" AND zozp.artykul_id = '"+KluczArt[0]+"' AND zozp.cecha1_wartosc = '"+KluczArt[1]+"'"
            SQL+=" AND COALESCE(zozp.parametry,'') = '"+str(KluczArt[2])+"'"
    else:
        SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zoz"
        SQL+=" INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer)"
        SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE zoz.firma_id = '"+self.firma_id+"'"    
        
        if FWyzn <> '':
            SQL+=" AND zoz.wyznacznik_id='"+FWyzn+"'"
        if FDataOd.strip() <> '-  -':
            SQL+=" AND zoz.data>='"+FDataOd+"'"
        if FDataDo.strip() <> '-  -':
            SQL+=" AND zoz.data<='"+FDataDo+"'"
        if FNrZam <> 0:
            SQL+=" AND zoz.numer = "+str(FNrZam)
        if FKontr <> '':
            SQL+=" AND zo.kontrahent_id LIKE '"+FKontr+"%'"
        if FKateg <> '':
            SQL+=" AND a.kateg_artykulu LIKE '"+FKateg+"%'"
        if FArt <> '':
            SQL+=" AND zoz.artykul_id LIKE '"+FArt+"%'"
        if FNazwa <> '':
            SQL+=" AND a.nazwa LIKE '"+FNazwa+"%'"
        if FCecha <> '':
            SQL+=" AND zoz.cecha1_opis LIKE '"+FCecha+"%'"
        if FCechaWartOd <> '' or FCechaWartDo <> '':
            SQL+=rsglobal.WyznaczFiltrNaCeche(FCechaWartOd,FCechaWartDo,'zoz')
        if FZamowione or FRealizowane or FZarezerwowane or FZrealizowane:
            SQL+=" AND ("
            if FZamowione:
                SQL+="(zoz.ilosc_calk <> zoz.ilosc_zrealizowana) OR"
            if FRealizowane:
                SQL+="(zoz.ilosc_produkowana <> 0) OR"
            if FZarezerwowane:
                SQL+="(zoz.ilosc_rezerwacja <> 0) OR"
            if FZrealizowane:
                SQL+="(zoz.ilosc_calk = zoz.ilosc_zrealizowana) OR"
            SQL = SQL[:-2]+')'
        
        # jeli nie podano danych artykuu to pokazywany jest tylko pierwszy poziom
        if FKateg == '' and FArt == '' and FNazwa == '' and FCecha == '' and FCechaWartOd == '' and FCechaWartDo == '':
            SQL+=" AND TRIM(zoz.nr_zlec) LIKE '__'"
        
    if FPoszczegolneZlecenia:    
        SQL+=" ORDER BY zoz.wyznacznik_id,zoz.data,zoz.numer,zoz.nr_poz,zoz.nr_ppoz,zoz.nr_zlec"
    elif FSumyZlecen:
        SQL+=" GROUP BY zoz.artykul_id,a.nazwa,zoz.cecha1_wartosc,"
        SQL+=" rsf_podaj_parametry_cechy(zoz.firma_id,zoz.cecha1_opis,zoz.cecha1_wartosc,'opis'),zoz.parametry"
        SQL+=" ORDER BY zoz.artykul_id,cecha1_wartosc"
            
    rsglobal.ZapiszDoLogow('SQL NA DANE '+SQL,1)
    stat,DPom,dump,dump=self.PolSQL.Execute(SQL,3)
    
    # pobranie iloci na magazynie z uwgldnieniem cech i parametrw
    if stat == 'OK':
        SIlosci = {}
        for poz in DPom:
            if stat =='OK':
                Kl = (poz[1],poz[3],poz[5])
                if not Kl in SIlosci:
                    rsglobal.ZapiszDoLogow('Pobranie iloci '+str(Kl),1)
                    stat,Ile = fs_artykuly_wzory_parametry_pom.PodajStanArtykuluZCechaIParametrem(self,poz[1],poz[3],poz[5])
                    rsglobal.ZapiszDoLogow('Wynik '+stat+' '+str(Ile),1)
                    if stat =='OK':
                        SIlosci[Kl] = Ile
            if stat =='OK':
                pozpom = eval(str(poz))
                pozpom[14] = SIlosci[Kl]
                dane.append(pozpom)