# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_archiwum_lista_tabel.py
# Purpose:     pobiera liste tabel z archiwum, usuwa dane do dnia
#
# Author:      Mariusz Rajfura
#
# Created:     2009/05/14
# RCS-ID:      $Id: fs_archiwum_lista_tabel.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Fun = klucze[-1]
stat='OK'
dane=[]

#-------------------------------------------------------------------------------
# Fun == 5 pobranie listy tabel archiwalnych
#-------------------------------------------------------------------------------
if Fun == 5:
    sql="SELECT tablename FROM pg_tables WHERE tablename LIKE 'rsa_%' ORDER BY tablename;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,2)
    if stat<>'OK':
        stat='Bd pobrania listy tabel archiwalnych: '+stat

#-------------------------------------------------------------------------------
# Fun == 6  usuniecie danych z tabel archiwalnych do podanej daty
# Nie ma potrzeby pobierania danych
#-------------------------------------------------------------------------------
if Fun == 6:
    SQL = ''
    if self.operator_id <> STANDARD_OPERATOR_ID:
        stat = "Brak uprawnie do usuwania danych archiwalnych."
        
    if stat == 'OK':
        Data = rsglobal.Dekoduj(klucze[0])
        if not rsglobal.SprawdzCzyToData(Data):
            stat = 'Bdnie podana data : '+Data

    if stat=='OK':
        sql = "SELECT tablename FROM pg_tables WHERE tablename LIKE 'rsa_%' ORDER BY tablename;"
        stat,tabele,dump,dump = self.PolSQL.Execute(sql,2)
        if stat<> 'OK':    
            stat='Bd pobrania nazw tabel: '+stat
            
    if stat=='OK':
            
        for linia in tabele:
            tabela = str(linia[0])
                
            sql = "SELECT oid FROM pg_class WHERE relname='"+tabela+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
            if stat<>'OK':
                stat='Bd pobrania OID dla tabeli '+tabela+' : '+stat
                break
                    
            sql ="SELECT atr.attname"
            sql+=" FROM pg_attribute atr"
            sql+=" INNER JOIN pg_type typ ON atr.atttypid=typ.oid"
            sql+=" WHERE atr.attrelid="+str(d[0][0])+" AND atr.attstattarget=-1"
            sql+=" AND atr.attname='firma_id';"
            
            stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
            if stat<>'OK':
                stat='Bd pobrania struktury tabeli '+tabela+' : '+stat
                break
            
            SQL+=" DELETE FROM "+tabela+" WHERE ("
            if len(d) > 0:
                SQL+="firma_id = '"+self.firma_id+"' AND "
            SQL+= "z_arch_czas < '"+Data+"');"
            
    if stat=='OK' and SQL<>'':
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'Bd usuwania danych archiwalnych : '+stat
