# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_cechy_pomocnicza.py
# Purpose:     sprawdzanie wystpowania wartoci w innych tabelach
# Author:      Konrad Opieka
# Created:     2014-04-09
# RCS-ID:      $Id: fs_artykuly_cechy_pomocnicza $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

import rsglobal

def SprawdzenieDlaCechyWartosci(self,Cecha,Sekcja,wart):
    # tebela potrzebna do sprawdzenia czy pozycje mozna edytowac
    LTabel=['rs_dokumenty_magazynowe_pozycje','rs_dostawy_pozycje','rs_faktury_pozycje','rs_zamowienia_dostawcy_pozycje']

    SQL= "SELECT SUM(COALESCE(dlugosc,0)) FROM rs_artykuly_cechy_sekcje "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp<"+Sekcja
    stat,DDlugosci,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <>'OK':
        return stat
    
    DlugPocz=DDlugosci[0][0]

    for tabela in LTabel:
        SPR ="SELECT cecha1_wartosc FROM "+tabela
        SPR+=" WHERE firma_id='"+self.firma_id+"' AND cecha1_opis='"+Cecha.strip()+"'"
        SPR+=" AND substring(cecha1_wartosc FROM "+str(DlugPocz+1)+" FOR "+str(len(wart.strip()))+") ='"+wart.strip()+"' LIMIT 1"    
        stat,DCech,dump,dump = self.PolSQL.Execute(SPR,3)
        if stat<>'OK':
            return stat
        
        pozycja=''
        
        if len(DCech)>0:
            if tabela=='rs_dokumenty_magazynowe_pozycje':
                pozycja='dokumentw magazynowych'
            elif tabela=='rs_dostawy_pozycje':
                pozycja='dostawy'
            elif tabela=='rs_faktury_pozycje':
                pozycja='faktur'
            elif tabela=='rs_zamowienia_dostawcy_pozycje':
                pozycja='zamowienia dostawcy'
        if pozycja<>'':
            stat = 'Cecha '+wart.strip()+' jest uyta w pozycjach '+pozycja+'. Nie mona zmieni wartoci'
            return stat
        
    return 'OK'

#-------------------------------------------------------------------------------
        
def SprawdzanieDlaCechySekcje(self,Cecha):
    # tebela potrzebna do sprawdzenia czy pozycje mozna edytowac
    LTabel=['rs_dokumenty_magazynowe_pozycje','rs_dostawy_pozycje','rs_faktury_pozycje','rs_zamowienia_dostawcy_pozycje']

    for tabela in LTabel:
        SQL ="SELECT cecha1_opis FROM "+tabela
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND cecha1_opis='"+Cecha.strip()+"'"
        stat,DCech,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return stat

        pozycja=''
        
        if len(DCech)>0:
            if tabela=='rs_dokumenty_magazynowe_pozycje':
                pozycja='dokumentw magazynowych'
            elif tabela=='rs_dostawy_pozycje':
                pozycja='dostawy'
            elif tabela=='rs_faktury_pozycje':
                pozycja='faktur'
            elif tabela=='rs_zamowienia_dostawcy_pozycje':
                pozycja='zamowienia dostawcy'
        if pozycja<>'':
            stat = 'Cecha '+Cecha.strip()+' jest uyta w pozycjach '+pozycja+'. Nie mona zmieni wartoci'
            return stat
        
    return 'OK'
    
#-------------------------------------------------------------------------------
        
def PodajDomyslnaCeche(self,Cecha):
    SQL="SELECT lp,wartosc,domyslna FROM rs_artykuly_cechy_wartosci "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' ORDER BY lp,wartosc,domyslna"
    stat,DWartCechy,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bd pobrania wartoci cechy artykuu : '+stat,''
        
    Dom=True    
    Domyslna=''
    Wczesniejsza = 0
    for poz in DWartCechy:
        if Wczesniejsza <> poz[0]:
            if not Dom:
                Domyslna=''
                break
            Dom=False
            Wczesniejsza=poz[0]
            if poz[2]:
                Domyslna+=poz[1].strip()
                Dom =True
        else:
            if poz[2]:
                Domyslna+=poz[1].strip()
                Dom =True
    
    return 'OK',Domyslna

#-------------------------------------------------------------------------------
#   pobranie informacji o cechach 
#   # wraca [cecha, opis cechy, liczba wartoci, domylna warto]
#-------------------------------------------------------------------------------

def PodajDaneCechyArtykulu(self,Artykul):
    Wynik =['','',0,'']
    
    SQL ="SELECT TRIM(COALESCE(cecha1_opis,'')) FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"

    stat,DCecha,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat <> 'OK':
        return u'Bdy pobierania danych cechy artykuu : '+stat,['','',0,'']

    if len(DCecha)==0:
        return 'OK',['','',0,'']
    
    if DCecha[0][0] == '':
        return 'OK',['','',0,'']
        
    Wynik[0]=DCecha[0][0]
    if ((self.oddzial_id,'017010') in self.uprawnienia) or (self.operator_id == '0'):
        SQL = "SELECT TRIM(COALESCE(opis,'')) FROM rs_artykuly_cechy WHERE firma_id='"+self.firma_id+"' AND kod='"+DCecha[0][0]+"';"
        stat,DOpisyCechy,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bd pobrania opisu cechy artykuu : '+stat,['','',0,'']
        if len(DOpisyCechy) == 0:
            return 'Brak cechy '+DCecha[0][0].strip()+' wystpujcej na artykule '+Artykul.strip(),['','',0,'']
        
        Wynik[1] = DOpisyCechy[0][0]
    else:
        Wynik[1] = 'Brak uprawnie do cech artykuu'
        
    SQL="SELECT lp,wartosc,domyslna FROM rs_artykuly_cechy_wartosci WHERE firma_id='"+self.firma_id+"' AND kod='"+DCecha[0][0]+"' ORDER BY lp,wartosc,domyslna"
    stat,DWartCechy,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bd pobrania wartoci cechy artykuu : '+stat,['','',0,'']

    Wynik[2] = len(DWartCechy)

    Dom=True    
    Domyslna=''
    Wczesniejsza = 0
    for poz in DWartCechy:
        if Wczesniejsza <> poz[0]:
            if not Dom:
                Domyslna=''
                break
            Dom=False
            Wczesniejsza=poz[0]
            if poz[2]:
                Domyslna+=poz[1].strip()
                Dom =True
        else:
            if poz[2]:
                Domyslna+=poz[1].strip()
                Dom =True
    Wynik[3] = Domyslna
    return 'OK',Wynik

#-------------------------------------------------------------------------------
#- funkcja sprawdzajca czy mona zmieni cech artykuu. DOtyczy to sytuacji gdy np. na fakturze 
#- artyku jest ju wykorzystywany z cech, a kto prbuje j zmieni, co jest niedozwolone
#-------------------------------------------------------------------------------

def SprawdzCzyMoznaZmienicCecheArtykulu(self,Art):
    # sprawdzenie czy artyku wystpuje na fakturach
    SQL="SELECT artykul_id FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' LIMIT 1"
    stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bd pobierania danych o fakturach w sprawdzaniu wystpowania cech'
    if len(DFakt) > 0:
        return 'Nie mona zmieni cechy artykuu '+Art.strip()+' poniewa widnieje on na pozycji faktury'
    
    return 'OK'