# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_cechy_wartosci.py
# Purpose:     obsluga grida edytowalnego wartosci dla cechy artykulu
# Author:      Mariusz Rajfura, Micha Raburski
# Created:     2013/05/31
# RCS-ID:      $Id: fs_artykuly_cechy_wartosci $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_artykuly_cechy_pom
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Cecha':[1,5,9,10,11,13],'Sekcja':[1,5], 'Wartosc':[9,10,11,13], 'Artykul':[10,13]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_cechy_wartosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Sekcja=str(klucze['Sekcja'])
        
    if Funkcja in [1,5,9,10,11,13]: 
        Cecha=rsglobal.Dekoduj(klucze['Cecha'])
        
    if Funkcja in [9,10,11,13]:
        Wartosc = rsglobal.Dekoduj(klucze['Wartosc'])
        
    if Funkcja in [10,13]:
        Artykul = rsglobal.Dekoduj(klucze['Artykul'])

dane = []
wyn1 = []
wyn2 = []

            
# tebela potrzebna do sprawdzenia czy pozycje mozna edytowac
tabele=['rs_dokumenty_magazynowe_pozycje','rs_dostawy_pozycje','rs_faktury_pozycje','rs_zamowienia_dostawcy_pozycje']

# maksymalne dlugosci pol opisowych
dlugosci = {'wartosc':30,'opis':50}

UprIns=((self.oddzial_id,'017023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'017022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'017024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU WARTOSCI CECHY (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+Wartosc+"','opis')"

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu opisu wartosci: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  POBRANIE POCZTKU CECHY ORAZ SEKCJI DO OBROBIENIA (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat == "OK":
    # sprawdzenie czy cecha istnieje
    SQL = "SELECT ac.kod,COALESCE(acs.lp,0) FROM rs_artykuly_cechy ac "
    SQL+=" LEFT OUTER JOIN rs_artykuly_cechy_sekcje acs USING (firma_id,kod) "
    SQL+=" WHERE ac.firma_id ='"+self.firma_id+"' AND ac.kod ='"+Cecha+"'"
    rsglobal.ZapiszDoLogow('!!'+SQL,1)
    stat,wyn1,dump,dump = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('!!'+str(wyn2),1)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu informacji o istnieniu cechy: '+stat
        
    if stat == 'OK':    
        SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+Wartosc+"','szukanie')"
        
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd przy pobieraniu informacji o wyszukiwaniu wartosci: '+stat


#-------------------------------------------------------------------------------
#-------  POBRANIE MASKI DLA WARTOCI (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == "OK":
    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+Wartosc+"','maska')"

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu informacji o pobraniu maski cechy: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  POBRANIE POCZTKU CECHY ORAZ SEKCJI DO OBROBIENIA (13)
#-------------------------------------------------------------------------------

if Funkcja == 13 and stat == "OK":
    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+Wartosc+"','szukaniemaska')"

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu informacji o wyszukiwaniu wartosci: '+stat
        dane.append(stat)

# pobranie cechy standardowej. Jeli jest to pobieramy te jej klucz pocztkujcy podmian
if Funkcja in [10,13] and stat == "OK":
    if Artykul == '':
        wyn2 = ['','']
    else:
        SQL = "SELECT COALESCE(cecha_standard,'') FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Artykul+"'"
        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania standardowej wartoci cechy : '+stat
        else:
            wyn2 = ['',DArt[0][0]]
            if DArt[0][0] <> '':
                SQL = "SELECT TRIM(wartosc) FROM rs_artykuly_cechy_wartosci WHERE firma_id ='"+self.firma_id+"'"
                SQL+=" AND kod ='"+Cecha+"' AND lp = 1 AND TRIM(opis) = 'standard'"
                stat,DSekPocz,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd pobierania standardowej sekcji pocztkowej : '+stat
                elif len(DSekPocz) > 0:
                    wyn2[0] = DSekPocz[0][0]

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and not Funkcja in [9,10,11,13]:
    # pobranie dugoci wartoci cechy
    SQL="SELECT dlugosc FROM rs_artykuly_cechy_sekcje WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
    stat,DDlug,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia dugoci sekcji cechy: '+stat
        dane.append(stat)
    elif len(DDlug)==0:
        stat = 'Podana sekcja dla cechy nie istnieje'
        dane.append(stat)
    else:
        dlugosci['wartosc'] = DDlug[0][0]
        

#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT wartosc FROM rs_artykuly_cechy_wartosci"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
                DELETE = "DELETE FROM rs_artykuly_cechy_wartosci "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['wartosc']:
                        stat=fs_artykuly_cechy_pom.SprawdzenieDlaCechyWartosci(self,Cecha,Sekcja,wart)
                        if stat <> "OK":
                            break
                        
                        else:    
                            WHERE += " AND "+pole+"='"+wart+"'"
                            SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT wartosc,opis,domyslna FROM rs_artykuly_cechy_wartosci"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j].strip())
                    nowepole = Update[0][i][j]
                    nowawart = rsglobal.Dekoduj(Update[1][i][j])
                    if pole in ('wartosc'):
                        stat=fs_artykuly_cechy_pom.SprawdzenieDlaCechyWartosci(self,Cecha,Sekcja,wart)
                        if stat <> "OK":
                            break
                        
                        else:   
                            SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '' and stat == "OK":
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'wartosc':
                        WartoscNowa = str(wart)
                        if wart.strip() == '':
                            stat = 'BR WARTOSC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip()) > dlugosci[pole]:
                            stat = 'BL WARTOSC DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    elif pole == 'opis':
                        if wart.strip() == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip()) > dlugosci[pole]:
                            stat = 'BL OPIS DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_artykuly_cechy_wartosci "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['wartosc','opis']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['domyslna']:
                        SET+=pole+"="+str(wart==1)+","

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['wartosc']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                WartoscNowa = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'wartosc':
                        WartoscNowa = str(wart)
                        if wart.strip() == '':
                            stat = 'BR WARTOSC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip()) <> dlugosci[pole]:
                            stat = 'BL WARTOSC DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)        
                        else:
                            sql ="SELECT wartosc FROM rs_artykuly_cechy_wartosci"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
                            sql+=" AND wartosc='"+WartoscNowa+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia nowej wartosci: '+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL WARTOSC IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'opis':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart) > dlugosci[pole]:
                            stat = 'BL OPIS DLG'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_artykuly_cechy_wartosci "
                KOLUMNY="(firma_id,kod,lp"
                VALUES=" VALUES ('"+self.firma_id+"','"+Cecha+"',"+Sekcja
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['wartosc','opis']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['domyslna']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart==1)+""

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


if Funkcja == 1 and stat == 'OK':
    # po zmianach kontrola, czy jest maksymalnie tylko jedna
    # wartosc zaznaczona jako domyslna
    sql ="SELECT wartosc FROM rs_artykuly_cechy_wartosci"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
    sql+=" AND domyslna;"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenie domylnej wartosci: '+stat
    elif len(d) > 1:
        stat = 'BL DOMYSLNA ZA DUZO'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT wartosc,COALESCE(opis,''),domyslna"
    SQL+=" FROM rs_artykuly_cechy_wartosci"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' AND lp="+Sekcja
    SQL+=" ORDER BY wartosc;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
    else:
        wyn2=[dlugosci['wartosc']]