# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_artykuly_ceny_dane.py
# Purpose:     pobiera liste cen
# Author:      Jarek Plawgo
# Created:     2006/08/30
# RCS-ID:      $Id: fs_artykuly_ceny_dane.py $
# Copyright:   (c) 2004 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# Marcin Natkaski 2011-02-09; refaktoryzacja (4156)
# Mariusz Rajfura 2011-02-22 - pobranie inf.z wersji cenowej 'czy_cena_brutto' (4283)
# 2017-10=09 Rafa Woniak Dodanie kodu bdu (10747)

import rsglobal

def SetWart(value):
    if value<>"" and value<>'NULL' and value<>'null' :
        return "'"+str(value)+"'"
    else:
        return 'NULL'

#-------------------------------------------------------------------------------

def PobierzDaneDodatkowe(self, Fun, artykul_id, wersja, wersja_opis, waluta,data):
    # przelicznik, vat, opis wersji, opis waluty, [[wersja, po_przecinku,czy_cena_brutto]...]
    wyn = [0, 0, '', '', []]
    DataOK=True
    data=data.strip("'")
    if data=="    -  -  ":
        SVOpis="'Brak daty - pobranie VAT niemoliwe'"
        DataOK=False
    elif not rsglobal.SprawdzCzyToData(data):  
        SVOpis="'Bdna data - pobranie VAT niemoliwe'"
        DataOK=False
    if not DataOK:
        SQL ="SELECT a.przelicznik,"+SVOpis+", av.stawka_vat"
    else:
        SQL = "SELECT a.przelicznik, av.stawka_vat"
    SQL+=" FROM rs_artykuly a LEFT JOIN rs_artykuly_stawki_vat av ON (a.firma_id=av.firma_id AND a.artykul_id=av.artykul_id "
    if DataOK:
        SQL+=" AND av.od_dnia<='"+data+"'"
    SQL+=") WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+artykul_id+"'"
    if DataOK:
        SQL+=" ORDER BY av.od_dnia DESC"
    SQL += ";"
    stat, dane, none, none = self.PolSQL.Execute(SQL, 3)

    if stat <> "OK":
        stat = "BL_SQL ART"
    elif len(dane)==0:
        stat = "BL BR ART"
    else:
        wyn[0] = dane[0][0]
        if DataOK:
            stawka_vat = dane[0][1]
        else:
            stawka_vat = dane[0][2]
        if stawka_vat in [None,'None']:
            #RW dodany kod bdu
            stat='BL_BR_VAT'
        else:
            wyn[1]=dane[0][1]

    if wersja_opis:
        wyn[2] = wersja_opis
    elif stat == "OK" and wersja and wersja != "''":
        if Fun not in (1, 2, 3, 4, 5):
            wersja = "'"+wersja+"'"
        query = "SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod="+wersja+";"
        stat, txt, none, none = self.PolSQL.Execute(query, 3)
        if stat == "OK":
            wyn[2] = txt[0][0]
        else:
            stat = "BL_SQL WER OP"

    if stat == "OK" and waluta and waluta != "''":
        if Fun not in (1, 2, 3, 4, 5):
            waluta = "'"+waluta+"'"
        query = "SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod="+waluta+";"
        stat, txt, none, none = self.PolSQL.Execute(query, 3)
        if stat == "OK":
            wyn[3] = txt[0][0]
        else:
            stat = "BL_SQL WAL OP"

    if stat == "OK":
        query = "SELECT kod, po_przecinku, czy_cena_brutto"
        query+=" FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"';"
        stat, d, none, none = self.PolSQL.Execute(query, 3)
        if stat == "OK":
            wyn[4] = d
        else:
            stat = "BL_SQL WERS"

    return stat, wyn


#-------------------------------------------------------------------------------
#-- WACIWA FUNKCJA
#-------------------------------------------------------------------------------

artykul_id = rsglobal.Dekoduj(klucze[0]).strip()
wersja = rsglobal.Dekoduj(klucze[1]).strip()
data = rsglobal.Dekoduj(klucze[2])
waluta = rsglobal.Dekoduj(klucze[3]).strip()
Fun = klucze[-1]

CenaN1='null'
CenaB1='null'
CenaN2='null'
CenaB2='null'
wersja_opis=''
stat="OK"
dane=[]

UprDodawanie = (((self.oddzial_id,'013033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'013032') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'
        dane.append(stat)

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--SPRAWDZENIE DANYCH (1,2,3,4,5)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in (1, 2, 3, 4, 5) and stat=='OK':
    if wersja=='' :
        stat="BR_WER"   
        dane.append(stat)
    
    if stat=='OK':
        sql ="SELECT kod, opis FROM rs_wersje_cenowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kod = '"+wersja+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if d == []:
                stat="BL_WER"   
                dane.append(stat)
            else:
                wersja_opis = d[0][1]
            wersja=SetWart(wersja)   

    if stat=='OK':
        if data=="    -  -  ":
            stat="BR_DATA"   
            dane.append(stat)
        else:  
            data=SetWart(data)
            
    if stat=='OK':
        if artykul_id == '':
            stat="BR_SYMBOL"   
            dane.append(stat)
        else:    
            sql ="SELECT artykul_id FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bd sprawdzenia artykuu: '+stat
                dane.append(stat)
                
            elif len(d)==0:
                stat="BL_SYMBOL1"   
                dane.append(stat)   
                
    if stat=='OK':
        if waluta=='' :
            stat="BR_WALUTA"   
            dane.append(stat)
        else:    
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod = '"+waluta+"';",3)
            if stat=='OK':
                if d == []:
                    stat="BL_WALUTA"   
                    dane.append(stat)
    if stat=='OK':            
        waluta=SetWart(waluta)
        
    if stat=='OK':
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ["wersja","data_od","waluta",
                        "cena_netto1","cena_brutto1",
                        "cena_netto2","cena_brutto2"]:
                            
                if wart=='':
                    wart='null'
    
                if pole=="cena_netto1":
                    if wart<0 :
                        stat="BL_NETTO1"   
                        dane.append(stat)
                    CenaN1=SetWart(wart)   
    
                if pole=="cena_brutto1":
                    if wart<0 :
                        stat="BL_BRUTO1"   
                        dane.append(stat)
                    CenaB1=SetWart(wart)   
    
                if pole=="cena_netto2":
                    if wart<0 :
                        stat="BL_NETTO2"   
                        dane.append(stat)
                    CenaN2=SetWart(wart)   
    
                if pole=="cena_brutto2":
                    if wart<0 :
                        stat="BL_BRUTO2"   
                        dane.append(stat)
                    CenaB2=SetWart(wart)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    if stat == 'OK' and Fun in (1,2,3,4):
        puste = ('null',SetWart(float(0)),SetWart(0))
        if CenaN1 in puste and CenaN2 in puste and CenaB1 in puste and CenaB2 in puste:
            stat = 'Zapis wszystkich cen zerowych jest niemoliwy.'
            dane.append(stat)

    if stat == 'OK':
        #sprawdzanie, czy istnieje jaka cena w konkretnej wersji dla artykuu od konkretnego dnia
        sql =" SELECT artykul_id FROM rs_artykuly_ceny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"'"
        sql+="  AND wersja="+wersja+" AND waluta="+waluta+" AND data_od="+data+" ;"

        stat,il_cen,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat <> "OK":
            stat="Bd pobierania artykuu : "+stat
            dane.append(stat) 


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat=='OK':
    if len(il_cen)==0: 
        INS ="INSERT INTO rs_artykuly_ceny"
        INS+=" (firma_id,artykul_id,wersja,data_od,waluta,"
        INS+="  cena_netto1,cena_brutto1,cena_netto2,cena_brutto2)"  
        INS+=" VALUES ("
        INS+=" '"+self.firma_id+"','"+artykul_id+"',"+wersja+","+data+","+waluta+","
        INS+=" "+CenaN1+","+CenaB1+","+CenaN2+","+CenaB2+");"
        
        stat,d,wyn1,dump = self.PolSQL.Execute(INS,1)
        if stat<>"OK":
            stat="BL_SQL_spr"   
            dane.append(stat) 
    else:        
        stat="BL_CENA_IST"   
        dane.append(stat) 


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat=='OK': 
    if len(il_cen)==0: 
        stat="BL_CENA_NIE_IST"   
        dane.append(stat) 
            
    if stat=='OK':
        upd="UPDATE rs_artykuly_ceny SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if wart=='':
                wart='NULL'
            else:
                wart= "'"+str(wart)+"'"   
            upd=upd+pole+"="+str(wart)+","
        upd = upd[0:len(upd)-1]
        sql=upd+" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"' "
        sql+=" AND wersja="+wersja+" AND data_od="+data+" AND waluta="+waluta+" ;"

        stat,d,wyn1,dump = self.PolSQL.Execute(sql,1)
        if stat<>"OK":
            stat="BL_SQL_spr"   
            dane.append(stat) 

            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#   ODPYTANIE O DODATKOWE DANE (6)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 6:
    stat, dane = PobierzDaneDodatkowe(self, Fun, artykul_id, wersja, wersja_opis, waluta,data)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in (1,5,3) and stat=='OK':
    sql ="SELECT * FROM rs_artykuly_ceny"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"'"
    sql+=" AND wersja="+wersja+" AND data_od="+data+" AND waluta="+waluta+" ;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>"OK":
        stat="BL_SQL SEL"
        dane.append(stat) 
    else:
        stat, wyn2 = PobierzDaneDodatkowe(self, Fun, artykul_id, wersja, wersja_opis, waluta,data)

#----------------  komser: przesanie modyfikacji danych dalej jeli tak ustawiono

if stat == "OK" and Fun in (1,2,3,4) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    # bez selecta
    if Fun in (1,3):
        klucze[-1] += 1
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_artykuly_ceny'", 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje " + stat
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], ["fs_komser_artykuly_ceny", klucze, pola, wartosci])