# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_dane.py
# Purpose:      
# Author:      Jarek Plawgo, Micha Raburski
# Created:     2006/07/25
# RCS-ID:      $Id: fs_artykuly_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2010-12-17 Mariusz Rajfura     (4146)  dodanie pola 'produkt_wiodacy'  - przy okazji uporzadkowanie kodu
#2011-01-24 Mariusz Rajfura     (4222)  dodanie pola 'dni_karencji'
#2011-08-03 Mariusz Rajfura     (4222)  dodanie pola 'oplata_reprograficzna'
#2012-05-15 Micha Raburski     (5724)  dodanie pola 'oplata_reprograficzna'
#2012-09-17 Mariusz Rajfura     (6083)  stawka vat do stawka_vat_import przy INSERT nowego art
#2013-06-04 Mariusz Rajfura     (6900)  zmiana numeru uprawnien do rs_artykuly_cechy
#2013-07-15 Mariusz Rajfura     (7030)  nowe pola: 'dynamiczny_przelicznik', 'sledzenie_transakcji'
#2014-01-09 Micha Raburski     (7550)  pole 'faktura_w_jm2'
#2014-03-31 Micha Raburski     (7752)  pole 'wydanie_proporcjonalne'
#2014-11-14 Micha Raburski     (8373)  pole 'wzor_zlecenia'
#2014-12-01 Micha Raburski     (8579)  pole 'tylko_w_opakowaniach'
#2019-06-26 Wojciech Skowron    (11525) obsuga tylko_detal przy dodawaniu
#2019-07-25 Wojciech Skowron    (11552) pole 'nazwa_skrocona' (zalene od 'czy_detal'),
#                                       sprawdzenie unikalnoci pary nazwa skrcona - stawka wrd aktywnych artykuw
# 2020-09-09 Aleksander Bargie (12106) Doda checkbox 'na dd' w danych artykuu, na dd drukowa tylko opakowania,
#                                       ktre maj to zaznaczone
# 2020-09-22 Wojciech Skowron   (12127) Dla artykuu bez czy_detal zamiennik nie moe mie tylko_detal
# 2021-11-17 Wojciech Skowron   (11552) Poprawka kontroli na par stawka VAT + nazwa skrcona,
#                                       pominicie pl nazwa_skrocona, stawka_vat i sww_pkwiu przy UPDATE

from funkcje import fs_artykuly_cechy_pom

def SetWart(value):
    if value<>"" and value<>'NULL' :
        return "'"+str(value)+"'"
    else:
        return 'NULL'

#-------------------------------------------------------------------------------

Symbol = rsglobal.Dekoduj(klucze[0]).strip()
Fun = klucze[-1]

Typ = 'NULL'
VAT = 'NULL'
PKWIU = 'NULL'
Zamiennik = 'NULL'
ProduktWiodacy = 'NULL'
TypArtykulu = 'NULL'
ProdWiod = 'NULL'
Model = 'NULL'
JM1 = 'NULL'
JM2 = 'NULL'

stat = 'OK'
dane = []
wyn2 = []

SprawdzacJmIDp = False

UprDodawanie=((self.oddzial_id,'013013') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdytowanie=((self.oddzial_id,'013012') in self.uprawnienia or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

if Fun in (1,2) and not UprDodawanie:
    stat = 'BR UPR INS'
    dane.append(stat)

if Fun in (3,4) and not UprEdytowanie:
    stat = 'BR UPR MOD'
    dane.append(stat)


#-------------------------------------------------------------------------------
# POBRANIE DODATKOWYCH INFORMACJI - 10
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    sql ="SELECT dynam_przel FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania informacji o dynamicznym przeliczniku: '+stat
    elif len(dane) == 0:
        stat = 'Brak firmy o podanym kluczu'


#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------
if stat == 'OK' and Fun in (1,2,3,4):
    SprawdzacDynamPrzelIZamiennik = False
    CzyDetal = None #WS 2019-07-23
    NazwaSkr = None   #WS 2019-07-23
    sql = "SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat!="OK":
        stat="BL_SQL_spr",Symbol
        dane.append(stat)
    else:
        DwieJednMiar=d[0][0]
        
    if stat == 'OK':    
        if Symbol == '':
            stat = 'BR_SYMBOL'
            dane.append(stat)
        else:
            #WS 2019-06-26
            sql ="SELECT artykul_id,typ_artykulu,produkt_wiodacy,tylko_detal FROM rs_artykuly"
            # sql ="SELECT artykul_id,typ_artykulu,produkt_wiodacy FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"' FOR UPDATE NOWAIT;"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia kodu artykuu: '+stat
                dane.append(stat)
            else:
                if Fun in (3,4,7):
                    if len(d) == 0:
                        stat="BL_SYMBOL1"   
                        dane.append(stat)
                    else:
                        TypArtykulu = rsglobal.Dekoduj(d[0][1]).strip()
                        ProduktWiodacy = rsglobal.Dekoduj(d[0][2]).strip()
        
                elif Fun in (1,2) and len(d) > 0:
                    #WS 2019-06-26
                    if d[0][3] == True:
                        stat="BL_SYMBOL3"
                        dane.append(stat)
                    else:
                        stat="BL_SYMBOL2"
                        dane.append(stat)

    if stat == 'OK':    
    #--- analiza sww_pkwiu w zalenoci od VAT-u
        if "stawka_vat" in pola:
            for index,item in enumerate(pola): 
                if item == "stawka_vat" : 
                    sql ="SELECT kod FROM rs_stawki_vat WHERE kod='"+wartosci[index]+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd pobrania kodu stawki VAT: '+stat
                        dane.append(stat)
                    elif len(d) == 0:    
                        stat="BL_STA_VAT"   
                        dane.append(stat)
                    else:
                        VAT = wartosci[index]
                            
                    if stat == 'OK':
                        #sprawdzenie stawki z biezaco obowiazujacymi stawkami
                        sqlp ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                        sqlp+=" WHERE stawka_vat='"+wartosci[index]+"'"
                        sqlp+=" AND NOW()::DATE>=od_dnia"
                        sqlp+=" AND CASE WHEN do_dnia IS NULL"
                        sqlp+=" THEN TRUE ELSE NOW()::DATE<=do_dnia END;"
                        stat,ds,dump,dump = self.PolSQL.Execute(sqlp,3)
                        if stat != 'OK':
                            stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                            dane.append(stat)
                        elif len(ds)==0:
                            stat = 'BL BIEZACA STAWKA'
                            dane.append(stat)
                         
        else:
            sql ="SELECT stawka_vat FROM rs_artykuly"
            sql+=" WHERE firma_id ='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania stawki VAT z artykuu: '+stat
                dane.append(stat)
            else:
                if len(d) > 0:
                    VAT = rsglobal.Dekoduj(d[0][0])
                else:
                    VAT = '00'
    
    if stat == 'OK':
        if VAT not in ('22','23'):
            if "sww_pkwiu" in pola:
                for index,item in enumerate(pola): 
                    if item=="sww_pkwiu" : 
                       if wartosci[index]<>'NULL' or wartosci[index]<>'':
                            PKWIU=wartosci[index].strip()
                            if PKWIU == '':
                                stat="BR_PKWIU"
                                dane.append(stat)
                                
            else:
                sql ="SELECT sww_pkwiu FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania PKWiU dla artykuu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat="BR_PKWIU"
                    dane.append(stat)
                else:
                    PKWIU = rsglobal.Dekoduj(d[0][0])
                    if PKWIU in ('','None'):            
                        stat = 'BR_PKWIU'
                        dane.append(stat)
                        
    if stat == 'OK':            
        PKWIU = SetWart(PKWIU)
        VAT = SetWart(VAT)        
        
        #--- sprawdzenie wymagalnoci modelu w kategorii
        ModelPom = ''
        CzyModel = False
        
        if Fun in (3,4):
            SQL="SELECT a.model_id,COALESCE(a.kateg_artykulu,''),COALESCE(ka.czy_model,FALSE)"
            SQL+=" FROM rs_artykuly a"
            SQL+=" LEFT OUTER JOIN rs_kateg_artykulow ka ON (a.firma_id=ka.firma_id AND a.kateg_artykulu=ka.kod)"
            SQL+=" WHERE a.artykul_id='"+Symbol+"' AND a.firma_id='"+self.firma_id+"';"

            stat,DPom,dump,dump = self.PolSQL.Execute(SQL,3)
            rsglobal.ZapiszDoLogow('Akt '+str(DPom),3)
            if stat != 'OK':
                stat = 'Bd pobrania modelu dla artykuu: '+stat
                dane.append(stat)
            elif len(DPom)>0:
                ModelPom = rsglobal.Dekoduj(DPom[0][0])
                CzyModel = DPom[0][2]

            #WS 2019-07-23
            # SQL="SELECT czy_detal, nazwa_skrocona"
            # SQL+=" FROM rs_artykuly"
            # SQL+=" WHERE artykul_id='"+Symbol+"' AND firma_id='"+self.firma_id+"';"
            # stat,DPom2,dump,dump = self.PolSQL.Execute(SQL,3)
            # if stat != 'OK':
            #     stat = 'Bd pobrania czy_detal i nazwa_skrocona dla artykuu: '+stat
            #     dane.append(stat)
            # elif len(DPom2)>0:
            #     CzyDetal = DPom2[0][0]
            #     NazwaSkr = rsglobal.Dekoduj(DPom2[0][1])
                    
    if stat == 'OK':        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'kateg_artykulu':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart == '' :
                    stat = 'BR_KAT_ART'
                    dane.append(stat)
                else:    
                    sql ="SELECT kod,czy_model FROM rs_kateg_artykulow"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kod w kategorii artykuw: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_KAT_ART'
                        dane.append(stat)
                    else:
                        CzyModel = d[0][1]
                    
            elif pole == 'model_id':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart == '' :
                    ModelPom = wart
                else:
                    sql ="SELECT kod FROM rs_modele"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu modelu: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL MODEL'
                        dane.append(stat)
                    else:
                        ModelPom = wart
                        Model = SetWart(wart)
        
    if stat == 'OK':
        if CzyModel:
            if ModelPom in ('',None,'None','NULL'):
                stat = 'WYM MODEL'
                dane.append(stat)
                
    
    # sprawdzenie pozostaych danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'typ_artykulu':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart == '' :
                stat = 'BR_TYP_ART'
                dane.append(stat)
            else:
                TypArtykulu = wart
                sql ="SELECT typ FROM rs_typy_artykulow"
                sql+=" WHERE typ='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bad sprawdzenia typu artykuu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_TYP_ART'
                    dane.append(stat)
            
            if stat == 'OK':
                if SetWart(wart) in ["'31'","'99'"] and Fun in (3,4):
                    SQL="SELECT ost_przychod IS NULL AND ost_rozchod IS NULL FROM rs_artykuly "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = ''+stat
                        dane.append(stat)
                    elif not d[0][0]:
                        stat = 'TYP_ART_Z_ROZCH'
                        dane.append(stat)
                
        elif pole == 'nazwa':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart == '' :
                stat = 'BR_NAZWA'
                dane.append(stat)

        elif pole == 'producent_id':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart != '' :
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia producenta: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_PRODU'
                    dane.append(stat)
                
        elif pole == 'dostawca_id':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart != '' :
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia kodu dostawcy: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_DOST'
                    dane.append(stat)

        elif pole == 'cecha1_opis':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart != '' :
                sql ="SELECT kod FROM rs_artykuly_cechy"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia kodu cechy: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_CECHA1OPIS'
                    dane.append(stat)
                # sprawdzenie czy artyku ju wystpuje na dokumentach. 
                # jeli tak to nie mona mu zmieni cechy
                else:
                    stat = fs_artykuly_cechy_pom.SprawdzCzyMoznaZmienicCecheArtykulu(self,Symbol)

        elif pole == 'jm1':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart == '' :
                stat = 'BR_JM1'
                dane.append(stat)
            else:    
                sql ="SELECT kod FROM rs_jednostki_miar"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia kodu JM1: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_JM1'
                    dane.append(stat)
                    
            JM1 = "'"+ wart +"'"
            if not DwieJednMiar:
                JM2 = JM1

        elif pole == 'jm2':
            wart = rsglobal.Dekoduj(wart).strip()
            if DwieJednMiar:
                if wart == '':
                    stat = 'BR_JM2'
                    dane.append(stat)
                else:    
                    sql ="SELECT kod FROM rs_jednostki_miar"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu JM2: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_JM2'
                        dane.append(stat)
                JM2 = "'"+wart+"'"
            else:            
                JM2 = JM1

        elif pole == 'przelicznik':
            if DwieJednMiar:
                if float(wart) == 0:
                    stat = 'BL_PRZEL' 
                    dane.append(stat)

        elif pole == 'przelicznik_odwr':
            if DwieJednMiar:
                if float(wart) == 0:
                    stat = 'BL_PRZEL_ODWR'
                    dane.append(stat)

        elif pole == 'jm_kalk':
            wart = rsglobal.Dekoduj(wart).strip()
            if DwieJednMiar:
                if wart == '' :
                    stat = 'BR_KALKU'
                    dane.append(stat)
                else :
                    if not wart in ('1','2'):    
                        stat = 'BL_KALKU'
                        dane.append(stat)

        elif pole == 'jm_zlecen':
            wart = rsglobal.Dekoduj(wart).strip()
            if DwieJednMiar:
                if wart == '' :
                    stat = 'BR_JMZLEC'
                    dane.append(stat)
                else :
                    if not wart in ('1','2'):    
                        stat = 'BL_JMZLEC'
                        dane.append(stat)

        elif pole == 'akcyza_pr':
            if wart >= 100.00:
                stat = 'BL_AKCYZY'
                dane.append(stat)

        elif pole == 'aktywny':
            if not wart: 
                sql  ="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                sql +="AND artykul_id='"+Symbol+"' AND ilosc1>0;"
                stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    stat = 'Bd sprawdzenia iloci artykuu na stanie: ' + stat
                    dane.append(stat)                    
                elif len(d) != 0:
                    stat = 'NA STANIE'
                    dane.append(stat)
                    
        elif pole == 'zamiennik_id':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart != '' :
                SprawdzacDynamPrzelIZamiennik = True
                sql ="SELECT zamiennik_id FROM rs_artykuly"
                sql+=" WHERE artykul_id='"+wart+"' AND firma_id='"+self.firma_id+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia kodu zamiennika: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL ZAMIENNIK'
                    dane.append(stat)
                else:
                    Zam = rsglobal.Dekoduj(d[0][0])
                    # rsglobal.ZapiszDoLogow('Zam='+str(Zam),1)
                    if Zam == 'None':
                        Zamiennik = SetWart(wart)
                        #rsglobal.ZapiszDoLogow('N Zam='+str(Zam),1)
                    else:
                        wartosci[i] = Zam
                        Zamiennik = "'"+Zam+"'"
                        
        elif pole == 'dynamiczny_przelicznik':
            SprawdzacDynamPrzelIZamiennik = True

        elif pole == 'produkt_wiodacy':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart == '' :
                ProduktWiodacy = 'NULL'
                #jesli kasujemy produkt wiodacy, to sprawdzamy, czy nie jestesmy
                #dla innego artykulu artykulem wiodacym
                sql ="SELECT artykul_id FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND produkt_wiodacy='"+Symbol+"'"
                sql+=" AND artykul_id<>'"+Symbol+"';"

                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia produktu wiodcego w artykuach: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = 'BL PROD_WIOD_WSKAZYWANY'
                    dane.append(stat)
                
            else:
                sql ="SELECT produkt_wiodacy,typ_artykulu FROM rs_artykuly"
                sql+=" WHERE artykul_id='"+wart+"' AND firma_id='"+self.firma_id+"';"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia kodu produktu wiodcego: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL PRODUKT_WIODACY'
                    dane.append(stat)
                elif not rsglobal.Dekoduj(d[0][1]) in ('01','02','03'):
                    stat = 'BL PROD_WIOD_TYP'
                    dane.append(stat)
                else:
                    ProduktWiodacy = rsglobal.Dekoduj(d[0][0])
                    if ProduktWiodacy == 'None':
                        ProduktWiodacy = SetWart(wart)
                    else:
                        wartosci[i] = ProduktWiodacy
                        ProduktWiodacy = "'"+ProduktWiodacy+"'"

        elif pole == 'dni_karencji':
            if wart < 0 or wart > 999:
                stat = 'BL DNI_KARENCJI'
                dane.append(stat)
                
        elif pole == 'dni_przydatnosci':
            if wart < 0 or wart > 9999:
                stat = 'BL DNI_PRZYDATNOSCI'
                dane.append(stat)
            DniPrzydatnosci = wart
                

        elif pole == 'oplata_reprograficzna':
            if wart < 0 or wart > 99.99:
                stat = 'BL OPLATA_REPROGRAFICZNA'
                dane.append(stat)

        elif pole == 'hdi':
            if wart not in ['','1','3'] :
                stat = 'BL HDI'
                dane.append(stat)

        #WS 2019-07-23
        elif pole == 'czy_detal':
            CzyDetal = wart

        elif pole == 'nazwa_skrocona':
            NazwaSkr = rsglobal.Dekoduj(wart).strip()

        SprawdzacJmIDp = (pole in ('dynamiczny_przelicznik','jm1','jm2')) or SprawdzacJmIDp

    #WS 2019-07-31
    if CzyDetal is None:
        SEL = """SELECT czy_detal
                 FROM rs_artykuly
                 WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania informacji o edytowanym artykule: '+stat
        elif len(d) == 0:
            #stat = 'Bd pobierania informacji o edytowanym artykule'  #JR (13429)
            CzyDetal = False
        else:
            CzyDetal = d[0][0]

    #WS 2020-09-22 - sprawdzenie, czy zamiennik nie jest tylko_detal
    if not CzyDetal:
        Zam = None

        if Zamiennik != 'NULL':
            Zam = Zamiennik
        else:
            SEL = """SELECT zamiennik_id
                     FROM rs_artykuly
                     WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
            stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd pobierania informacji o edytowanym artykule: '+stat
                dane.append(stat)
            elif len(d) == 0:
                #stat = 'Bd pobierania informacji o edytowanym artykule'  #JR (13429)
                #dane.append(stat)
                Zam = 'NULL'
            else:
                Zam = rsglobal.ZmienNaNULL(d[0][0])

        if Zam is not None and Zam != 'NULL':
            SEL = """SELECT tylko_detal
                     FROM rs_artykuly
                     WHERE firma_id='{}' AND artykul_id={};""".format(self.firma_id, Zam)
            stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd pobierania informacji o zamienniku: '+stat
                dane.append(stat)
            elif len(d) == 0:
                stat = 'Bd pobierania informacji o zamienniku'
                dane.append(stat)
            elif d[0][0]:
                stat = 'BL ZAM DETAL'
                dane.append(stat)

    #WS 2019-07-25
    if CzyDetal and NazwaSkr is None:
        SEL = """SELECT nazwa_skrocona
                 FROM rs_artykuly
                 WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania informacji o edytowanym artykule: '+stat
            dane.append(stat)
        elif len(d) == 0:
            #stat = 'Bd pobierania informacji o edytowanym artykule'  #JR (13429)
            #dane.append(stat)
            NazwaSkr = ''
        else:
            NazwaSkr = rsglobal.Dekoduj(d[0][0]).strip()

    #WS 2019-07-23
    if CzyDetal and NazwaSkr in ('','None',None):
        stat = 'BR NAZWA SKR'
        dane.append(stat)

    #WS 2019-07-25
    #WS 2021-11-17 - poprawka kontroli na par stawka VAT + nazwa skrcona
    if NazwaSkr not in ('','None',None):
        SEL = """SELECT artykul_id
                 FROM rs_artykuly_stawki_vat
                 WHERE firma_id='{}' AND nazwa_skrocona='{}' AND artykul_id!='{}' AND stawka_vat!='{}';"""
        SEL = SEL.format(self.firma_id, NazwaSkr, Symbol, VAT.strip("'"))
        # SEL = """SELECT artykul_id
        #          FROM rs_artykuly
        #          WHERE firma_id='{}' AND aktywny=TRUE AND nazwa_skrocona='{}' AND artykul_id!='{}';""".format(self.firma_id, NazwaSkr, Symbol)
        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania informacji o artykuach: '+stat
            dane.append(stat)
        elif len(d) != 0:
            #WS 2021-11-17
            stat = 'Podana nazwa skrcona wystpuje w parze z inn stawk VAT dla artykuw: '+', '.join(dane[0].strip() for dane in d)
            # stat = 'Istniej inne aktywne artykuy o tej samej stawce VAT i nazwie skrconej: '+', '.join(d[0])
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
            
    if stat == 'OK' and not ProduktWiodacy in ('NULL','','None'):
        if ProduktWiodacy != Symbol:
            if not TypArtykulu in ('02','03'):
                stat = 'BL PROD_WIOD_TYP_ART'
                dane.append(stat)
        

#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -insert z pobraniem, 2 -insert)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2) and UprDodawanie: 
    INS ="INSERT INTO rs_artykuly (firma_id,stawka_vat_import,"
    for i in xrange(len(pola)):
        INS += pola[i]
        if i < len(pola)-1:
            INS+=","
            
    INS += ") VALUES ('"+self.firma_id+"',"+VAT+","
    for i in xrange(len(wartosci)):
        wart = wartosci[i]
        if wart == '':
            wart = 'NULL'
        elif type(wart) == type(''):
            wart = "'"+wart+"'"
        else:
            wart = str(wart)
            
        INS += wart
        if i < len(wartosci)-1:
            INS += ","
            
    INS += "); "
    
    INS+=" INSERT INTO rs_artykuly_stawki_vat"
    #WS 2019-07-25
    INS+=" (firma_id,artykul_id,stawka_vat,od_dnia,sww_pkwiu,stawka_vat_import,nazwa_skrocona)"
    # INS+=" (firma_id,artykul_id,stawka_vat,od_dnia,sww_pkwiu,stawka_vat_import)"
    INS+=" VALUES "
    INS+=" ('"+self.firma_id+"','"+Symbol+"',"+VAT+",NOW()::DATE,"+PKWIU+","+VAT+",'"+NazwaSkr+"');"
    # INS+=" ('"+self.firma_id+"','"+Symbol+"',"+VAT+",NOW()::DATE,"+PKWIU+","+VAT+");"
    
    stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
    if stat != 'OK':
        stat = 'BL_SQL_INS'
        dane.append(stat) 

    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-update z pobraniem, 4 -update)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (3,4) and UprEdytowanie:
    UPD = "UPDATE rs_artykuly SET "
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        #WS 2021-11-17
        if pole in ('nazwa_skrocona', 'stawka_vat', 'sww_pkwiu'):
            continue

        #jeeli wypenione s limity przydatnoci to nie moemy zerowa kontrolki
        if pole=='dni_przydatnosci' and wart==0:
            SQL= "SELECT limit_procent FROM rs_artykuly_limity_przydatnosci "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"' ORDER BY limit_procent LIMIT 1;"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy sprawdzania limitu procentowego artykuu'
                dane.append(stat)
            elif len(d)<>0 and d[0]<>0:
                stat = 'Nie mona zerowa dni przydatnoci, poniewa dla artykuu wypenione s limity przydatnoci'
                dane.append(stat)
            else:
                wart= str(wart)
                
        # testy przy ciganiu terminu wanoci        
        if pole == 'czy_termin' and wart==False:
            SQL= "SELECT artykul_id FROM rs_artykuly_limity_przydatnosci "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"' ;"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy sprawdzania terminu_waznosci artykuu'
                dane.append(stat)
            elif len(d)<>0:
                stat = 'Nie mona zdj terminu wanoci, poniewa dla artykuu wypenione s limity przydatnoci'
                dane.append(stat)
            else:
                wart= str(wart)
        
        if wart=='':
            wart='NULL'
        elif type(wart) == type(''):
            wart = "'"+wart+"'"
        else:
            wart= str(wart)
            
        UPD += pole+"="+str(wart)+","

    UPD = UPD[:-1]
    UPD+= " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
    if stat=='OK':
        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat != 'OK':
           stat = 'BL_SQL_spr'
           dane.append(stat)

if stat =='OK' and Fun in (1,2,3,4):
    if SprawdzacDynamPrzelIZamiennik:
        # pobieramy dane artykuu. Jeli sam artyku lub jego zamiennik ma dynamiczny przelicznik 
        # to cofamy zmiany i wracamy z komunikatem bdu
        SQL="SELECT a.dynamiczny_przelicznik,COALESCE(a.zamiennik_id,''),COALESCE(a2.dynamiczny_przelicznik,FALSE) "
        SQL+=" FROM rs_artykuly a LEFT OUTER JOIN rs_artykuly a2 ON (a2.firma_id=a.firma_id AND a2.artykul_id=a.zamiennik_id) "
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+Symbol+"'"
        stat,DTestPrzel,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat= 'Bd sprawdzania danych o zamiennikach i dynamicznym przeliczniku :'+stat
        elif DTestPrzel[0][0] and DTestPrzel[0][1] <>'':
            stat= 'Artyku z dynamicznym przelicznikiem nie moe mie przypisanego zamiennika'
        elif DTestPrzel[0][2] and DTestPrzel[0][1] <>'':
            stat= 'Artyku z dynamicznym przelicznikiem nie moe by przypisany jako zamiennik'
        elif DTestPrzel[0][0]:
            # sprawdzamy czy artyku nie jest zamiennikiem dla jakiego innego artykuu
            SQL="SELECT zamiennik_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND zamiennik_id='"+Symbol+"'"
            stat,DTestZam,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat= 'Bd sprawdzania danych o zamiennikach :'+stat
            elif len(DTestZam)>0:
                stat= 'Artyku z dynamicznym przelicznikiem nie moe by przypisany jako zamiennik do innych artykuw'
    
    if SprawdzacJmIDp:
        # pobieramy dane artykuu. Jeli artyku ma dynamiczny przelicznik i takie same jednostki miar
        # to zgaszamy bd.
        SQL="SELECT dynamiczny_przelicznik,jm1,jm2 FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND artykul_id='"+Symbol+"';"
        stat,DTestJm,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat= 'Bd sprawdzania danych o dynamicznym przeliczniku i jednostkach miar:'+stat
        elif DTestJm[0][0] and DTestJm[0][1] == DTestJm[0][2]:
            stat= 'Artyku z dynamicznym przelicznikiem nie moe mie takich samych jednostek miar'


#wykonanie zmian w pozostalych artykulach odnosnie zamiennika i produktu wiodacego
if stat=='OK' and Fun in (1,2,3,4):
    sql = ''
    if 'zamiennik_id' in pola:
        #rsglobal.ZapiszDoLogow('ROBIE ZAMIENNIK '+Zamiennik,3)
        sql+="UPDATE rs_artykuly SET zamiennik_id="+Zamiennik
        sql+=" WHERE firma_id='"+self.firma_id+"' AND zamiennik_id='"+Symbol+"';"
        
    if 'produkt_wiodacy' in pola and ProduktWiodacy != 'NULL':
        #rsglobal.ZapiszDoLogow('ROBIE PRODUKT WIODACY '+ProduktWiodacy,3)
        sql+="UPDATE rs_artykuly SET produkt_wiodacy="+ProduktWiodacy
        sql+=" WHERE firma_id='"+self.firma_id+"' AND produkt_wiodacy='"+Symbol+"';"
        
    if sql != '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,1)
        if stat != 'OK':
            stat = 'Bd modyfikacji zamiennikw/produktw wiodacych: '+stat
            dane.append(stat)

    # Po modyfikacjach zamiennikow ustawienie i kontrola opcji dynamicznego przelicznika
    # oraz sledzenia dostaw w ramach grupy zamiennikow
    
    if stat == 'OK':
        # pobranie aktualnego ustawienia
        sql ="SELECT COALESCE(zamiennik_id,''),dynamiczny_przelicznik,sledzenie_dostaw"
        sql+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
        stat,Dyn,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = "Bd pobrania danych po modyfikacji: "+stat
            
    if stat == 'OK':
        # czy wsrod zamiennikow istnieja takie artykuly, ktore maja inne ustawienie
        # opcji dynamicznego przelicznika lub sledzenia dostaw i musza byc zmodyfikowane,
        # a juz byly w uzyciu
        
        sql ="SELECT artykul_id FROM rs_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND"
        
        if Dyn[0][0] == '':
            sql+=" zamiennik_id='"+Symbol+"'"
        else:
            sql+=" (zamiennik_id='"+Symbol+"' OR zamiennik_id='"+rsglobal.Dekoduj(Dyn[0][0])+"' OR artykul_id='"+rsglobal.Dekoduj(Dyn[0][0])+"')"
        
        sql+=" AND sledzenie_dostaw<>"+str(Dyn[0][2])
        sql+=" AND (ost_przychod IS NOT NULL OR ost_rozchod IS NOT NULL);"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia ledzenia dostaw w zamiennikach: '+stat
        elif len(d) > 0:
            stat = 'BL DYN_PRZEL_ZAMIENNIKI_W_UZYCIU'
        else:
            # modyfikacja ustawien zamiennikow
            upd ="UPDATE rs_artykuly SET sledzenie_dostaw="+str(Dyn[0][2])
            upd+=" WHERE firma_id='"+self.firma_id+"' AND"
            if Dyn[0][0] == '':
                upd+=" zamiennik_id='"+Symbol+"'"
            else:
                upd+=" (zamiennik_id='"+Symbol+"' OR zamiennik_id='"+rsglobal.Dekoduj(Dyn[0][0])+"' OR artykul_id='"+rsglobal.Dekoduj(Dyn[0][0])+"')"
            upd += ";"    
            
            stat,d,dump,dump = self.PolSQL.Execute(upd,1)
            if stat != 'OK':
                stat = 'Bd modyfikacji ledzenia dostaw w zamiennikach: '+stat


#-------------------------------------------------------------------------------
# Jesli wiodacy ma puste pole 'produkt_wiodacy', to wpisujemy go w 'samego siebie'
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2,3,4) and 'produkt_wiodacy' in pola and not ProduktWiodacy in ('NULL',None,'None'):
    upd ="UPDATE rs_artykuly SET produkt_wiodacy="+ProduktWiodacy
    upd+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id="+ProduktWiodacy
    upd+=" AND produkt_wiodacy IS NULL OR produkt_wiodacy='';"
    stat,d,dump,dump = self.PolSQL.Execute(upd,1)
    
    if stat != 'OK':
        stat = 'Bd modyfikacji produktu wiodcego: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- Badamy czy zaznaczona kontrolka z terminem przydatnosci
#-------------------------------------------------------------------------------

if stat=='OK' and 'dni_przydatnosci' in pola and DniPrzydatnosci!=0:
    SQL= "SELECT czy_termin FROM rs_artykuly "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy sprawdzania limitu procentowego artykuu'
        dane.append(stat)
    elif d==[[False]]:
        stat = 'Jeeli Dni przydatnoci s wypenione to kontrolka termin przydatnoci powinna by zaznaczona.'
        dane.append(stat)
                
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (5,3,1):
    Typ = ''
    Kategoria = ''
    StawkaVat = ''
    Producent = ''
    Dostawca = ''
    Jm1 = ''
    Jm2 = ''
    Model = ''
    Zamiennik = ''
    Cecha1Opis = ''
    ProduktWiodacy = ''
    
    sql ="SELECT * FROM rs_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat="BL_SQL_spr"   
        dane.append(stat) 
    else:
        for i in xrange(len(dane[0])):
            pole = wyn1[i][0]
            wart = str(dane[0][i])
            
            if pole == 'producent_id' and wart != 'None':
                if ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Producent = 'Bd pobrania opisu producenta z katalogu : '+stat
                    else:
                        if len(d) == 0:
                            Producent = 'Bdny kod producenta.'
                        else:
                            Producent = d[0][0]
                else:
                    Producent = 'Brak uprawnie do katalogu. Poinformuj administratora.'
                    
            elif pole == 'dostawca_id' and wart != 'None':
                if ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Dostawca = 'Bd pobrania opisu dostawcy z katalogu : '+stat
                    else:
                        if len(d) == 0:
                            Dostawca = 'Bdny kod dostawcy.'
                        else:
                            Dostawca = d[0][0]
                else:
                    Dostawca = 'Brak uprawnie do katalogu. Poinformuj administratora.'
            
            elif pole == 'typ_artykulu':
                if ((self.oddzial_id,'011160') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_typy_artykulow WHERE typ = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Typ = 'Bd pobrania opisu typu artykuu : '+stat
                    else:
                        if len(d) == 0:
                            Typ = 'Bdny kod typu artykuu.'
                        else:
                            Typ = d[0][0]
                else:
                    Typ = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'kateg_artykulu':
                if ((self.oddzial_id,'011060') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_kateg_artykulow WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Kategoria = 'Bd pobrania opisu kategorii artykuu : '+stat
                    else:
                        if len(d) == 0:
                            Kategoria = 'Bdny kod kategorii artykuu.'
                        else:
                            Kategoria = d[0][0]
                else:
                    Kategoria = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'stawka_vat':
                if ((self.oddzial_id,'011120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_stawki_vat WHERE kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        StawkaVat = 'Bd pobrania opisu stawki VAT : '+stat
                    else:
                        if len(d) == 0:
                            StawkaVat = 'Bdny kod stawki VAT.'
                        else:
                            StawkaVat = d[0][0]
                else:
                    StawkaVat = 'Brak uprawnie do sownika. Poinformuj administratora.'
                    
            elif pole == 'jm1':
                if ((self.oddzial_id,'011110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_jednostki_miar WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Jm1 = 'Bd pobrania opisu jed.miary 1 : '+stat
                    else:
                        if len(d) == 0:
                            Jm1 = 'Bdny kod jed.miary 1'
                        else:
                            Jm1 = d[0][0]
                else:
                    Jm1 = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'jm2':
                if ((self.oddzial_id,'011110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_jednostki_miar WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Jm2 = 'Bd pobrania opisu jed.miary 2 : '+stat
                    else:
                        if len(d) == 0:
                            Jm2 = 'Bdny kod jed.miary 2'
                        else:
                            Jm2 = d[0][0]
                else:
                    Jm2 = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'zamiennik_id' and wart != 'None':
                sql = "SELECT nazwa FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    Zamiennik = 'Bd pobrania nazwy zamiennika : '+stat
                else:
                    if len(d) == 0:
                        Zamiennik = 'Bdny kod zamiennika'
                    else:
                        Zamiennik = d[0][0]
            
            elif pole == 'model_id' and wart != 'None':
                if ((self.oddzial_id,'011570') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_modele WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Model = 'Bd pobrania opisu modelu : '+stat
                    else:
                        if len(d) == 0:
                            Model = 'Bdny kod modelu'
                        else:
                            Model = d[0][0]
                else:
                    Model = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'cecha1_opis' and wart != 'None':
                if ((self.oddzial_id,'017010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    sql = "SELECT opis FROM rs_artykuly_cechy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Cecha1Opis = 'Bd pobrania opisu cechy : '+stat
                    else:
                        if len(d) == 0:
                            Cecha1Opis = 'Bdny kod cechy'
                        else:
                            Cecha1Opis = str(d[0][0])
                else:
                    Cecha1Opis = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'produkt_wiodacy' and wart != 'None':
                sql = "SELECT nazwa FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    ProduktWiodacy = 'Bd pobrania nazwy produktu wiodcego : '+stat
                else:
                    if len(d) == 0:
                        ProduktWiodacy = 'Bdny kod produktu wiodcego'
                    else:
                        ProduktWiodacy = d[0][0]

        wyn2 = [Typ,Kategoria,StawkaVat,Producent,Dostawca,Jm1,Jm2,
                Zamiennik,Model,Cecha1Opis,ProduktWiodacy]


if stat=='OK' and Fun==7:
    sql="SELECT rsf_klucz_max('rs_artykuly','%s','artykul_id',20,'%s');"%(self.firma_id,Symbol)
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)

    if stat!="OK":
        stat="BL_KLUCZ_MAX"   
        dane.append(stat) 


#----------------  komser: przesanie modyfikacji danych dalej jeli tak ustawiono
if stat == "OK" and Fun in (1,2,3,4) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], ['fs_komser_artykuly', klucze, pola, wartosci])
