# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_dane_import.py
# Purpose:     dane artykulu dotyczace importu 
# Author:      Mariusz Rajfura
# Created:     2009/05/18
# RCS-ID:      $Id: fs_artykuly_dane_import.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2014-02-17 Marcin Natkaski (7613) dodana obsuga 'nazwa_dluga' artykulu
# 2019-07-01  Mikoaj Kozowski - Dodanie zasilania pola minimum_logistyczne (11524)
# 2021-06-29 Aleksander Bargie - Plik certyfikatu w danych dodatkowych artykuu (12554)
# 2023-09-20 Aleksander Bargie - Sprzeda - Dodanie do faktury pozycji dla artykuu z cech (13174)

Symbol = klucze[0].strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

UprEdyt = (self.oddzial_id,'013022') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID
UprSlow = (self.oddzial_id,'011000') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID

if Fun == 3 and not UprEdyt:
    stat = 'Brak uprawnie do edycji danych importowych artykuu.'


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-update )
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==3:
    upd = "UPDATE rs_artykuly SET "
    where = " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
    for i in range(len(pola)):
        if stat == 'OK':
            pole = pola[i].lower()
            wart = wartosci[i]
            if pole == 'cecha_standard':
                if wart != '':
                    SQL = "SELECT rsf_podaj_parametry_cechy(firma_id,cecha1_opis,'"+wart+"','poprawna') FROM rs_artykuly "+where
                    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia poprawnoci cechy "standard" : '+stat
                    else:
                        rsglobal.ZapiszDoLogow("rseval {}".format(d[0][0]))
                        LCecha = rsglobal.rseval(d[0][0])
                        if not LCecha[0]:
                            stat = LCecha[1]                        
                        
            elif pole == 'stawka_vat_import':
                if len(wart.strip()) != 2:
                    stat = 'BL_ST_VAT'
                    dane.append(stat)
                else:    
                    sql="SELECT kod FROM rs_stawki_vat WHERE kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd odczytu stawek VAT: '+stat
                    else:
                        if len(d) != 1:
                            stat = 'BL_ST_VAT'
                            dane.append(stat) 
                        
        if stat == 'OK':
            if pole in ('waga','clo_p','clo_w','minimum_logistyczne'):
                wart = str(wart)
            if pole in ('stawka_vat_import','kod_cn','taryfa_celna','deklaracja_zgodnosci_przeznaczenie',
                        'deklaracja_zgodnosci_dokumenty','deklaracja_zgodnosci_partia','nazwa_dluga','cecha_standard',
                        'plik_certyfikatu'):  #AB 29.06.21r
                if wart == '':
                    wart = 'NULL'
                else:
                    wart = "'"+wart.replace("\\'", "`").replace("\\\\", "/")+"'"  #AB 2023-09-20
            upd += pole + "=" + str(wart)+","    
            
    if stat == 'OK':
        upd = upd[0:len(upd)-1]
        sql = upd+where  
        stat,d,dump,dump = self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat = 'Bd aktualizacji danych dodatkowych art. '+Symbol+':'+stat

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (3,5):
    sql="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bd pobrania danych importowych artykuu '+Symbol+':'+stat

if stat=='OK':
    if UprSlow:
        for pole in range(len(wyn1)):
            if wyn1[pole][0] == 'stawka_vat_import':
                if dane[0][pole] != '':
                    sql = "SELECT opis FROM rs_stawki_vat WHERE kod='"+str(dane[0][pole])+"';"
                    st,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if st=='OK':
                        if len(d) == 0:
                            wyn2.append('')
                        else:
                            wyn2.append(d[0][0])
                    else:
                        wyn2.append('Bd pobrania opisu stawki VAT.')
    else:
        wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    from funkcje import fs_artykuly_pom

    stat, DArt = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self, Symbol, '', rsglobal.PodajDzis(), 0, '', '', '', 1, '',
                                                           True)
    if stat == 'OK':
        wyn2.append(DArt)

if stat == 'OK':
        for pole in range(len(wyn1)):
            if wyn1[pole][0] == 'jm1':
                if dane[0][pole] != '':
                    sql = "SELECT calkowita FROM rs_jednostki_miar WHERE firma_id='"+self.firma_id+"' and kod='"+str(dane[0][pole])+"';"
                    st,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if st=='OK':
                        if len(d) == 0:
                            wyn2.append('')
                        else:
                            wyn2.append(d[0][0])
                    else:
                        wyn2.append('Bd pobrania jednostki miary.')

#----------------  komser: przesanie modyfikacji danych dalej jeli tak ustawiono
if stat == "OK" and Fun in (3,) and self.firma_id == '01':  #WS 2020-12-16  - self.firma_id
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], [funkcja, klucze, pola, wartosci])
