# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_artykuly_pliki.py
# Purpose:     wyswietla, dodaje, usuwa pliki binarne dla artykuw
# Author:      Wojciech Skowron
# Created:     2019/06/28
# RCS-ID:      $Id: fs_artykuly_pliki.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-07-18 Wojciech Skowron (11539) - [HD] Pliki binarne w artykuach - Typ 'H'

from funkcje import fs_pliki_global
import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    
    SlPar = {'ArtykulId':[1,2,5,6], 'PlikId':[2,6], 'NazwaPliku':[1], 'TrescPliku':[1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_artykuly_pliki z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    if Funkcja in [1,2,5,6]:
        ArtykulId  = rsglobal.Dekoduj(klucze['ArtykulId'])
        TypUpr     = rsglobal.Dekoduj(klucze['TypUpr'])
    if Funkcja in [2,6]:
        PlikId     = rsglobal.Dekoduj(klucze['PlikId'])
    if Funkcja == 1:
        NazwaPliku = rsglobal.Dekoduj(klucze['NazwaPliku'])
        TrescPliku = rsglobal.Dekoduj(klucze['TrescPliku'])
        TypPliku   = rsglobal.Dekoduj(klucze['TypPliku'])

dane = []
LPlik = []

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

#WS 2019-07-18 - TypUpr, A - artykuy, H - artykuy w handlu
if TypUpr == 'A':
    UprSel = ((self.oddzial_id,'013161') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprUpd = ((self.oddzial_id,'013162') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprIns = ((self.oddzial_id,'013163') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprDel = ((self.oddzial_id,'013164') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
elif TypUpr == 'H':
    UprSel = ((self.oddzial_id,'092121') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprUpd = ((self.oddzial_id,'092122') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprIns = ((self.oddzial_id,'092123') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprDel = ((self.oddzial_id,'092124') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
else:
    UprSel = UprUpd = UprIns = UprDel = False
    stat = 'Niewaciwy typ: '+TypUpr

if stat == 'OK':
    SEL = """SELECT artykul_id 
             FROM rs_artykuly 
             WHERE firma_id='{}' AND artykul_id = '{}';
          """.format(self.firma_id, ArtykulId)

    stat,DTest,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzania poprawnoci artykuu: '+stat
    else:
        if len(DTest) == 0:
            stat = 'BR_ART'
    
#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------
    
if stat == 'OK' and Funkcja == 1:
    if not UprIns:
        stat = 'UPR_INS'

    if stat == 'OK' and TypPliku != '':
        SEL = """SELECT kod
                 FROM rs_typy_plikow_binarnych 
                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, TypPliku)

        stat,DTyp,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania typu pliku binarnego: '+stat
        else:
            if len(DTyp) == 0:
                stat = 'BL_TYP'

    if stat == 'OK':
        INS = """INSERT INTO rs_pliki (  firma_id,    nazwa,   tabela,            kompresja)
                               VALUES ('{firma_id}','{nazwa}','rs_artykuly_pliki',FALSE    );"""
        INS = INS.format(firma_id = self.firma_id,
                         nazwa    = NazwaPliku)

        rsglobal.ZapiszDoLogow(INS,5)
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd wstawiania rekordu: '+stat

    if stat == 'OK':
        SEL = """SELECT max(plik_id) 
                 FROM rs_pliki 
                 WHERE firma_id='{}' AND tabela='rs_artykuly_pliki';""".format(self.firma_id)

        stat,DNum,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania numeru nowego pliku: '+stat

    if stat == 'OK':
        NrPliku = DNum[0][0]
        stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)

    if stat == 'OK':
        INS = """INSERT INTO rs_artykuly_pliki
                             (  firma_id,    artykul_id,    artykul_plik,   nr_pliku,   typ_pliku  )
                      VALUES ('{firma_id}','{artykul_id}','{artykul_plik}',{nr_pliku},'{typ_pliku}');"""
        INS = INS.format(firma_id     = self.firma_id,
                         artykul_id   = ArtykulId,
                         artykul_plik = NazwaPliku,
                         nr_pliku     = NrPliku,
                         typ_pliku    = TypPliku)

        rsglobal.ZapiszDoLogow(INS,5)
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd dodawania rekordu o nowym pliku: '+stat
       
#-------------------------------------------------------------------------------
#---   POBRANIE/USUWANIE PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------
    
if stat == 'OK' and Funkcja in [2,6]:
    SEL = """SELECT nr_pliku 
             FROM rs_artykuly_pliki 
             WHERE firma_id='{}' AND artykul_id='{}' AND plik_id={};
          """.format(self.firma_id, ArtykulId, PlikId)

    rsglobal.ZapiszDoLogow(SEL,5)
    stat,DNrPliku,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania numeru pliku: '+stat
    else:
        if len(DNrPliku) == 0:
            stat = """Brak pliku o numerze {} dla artykuu {}""".format(PlikId, ArtykulId)
 
#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if stat == 'OK' and Funkcja == 2:
    if not UprSel:
        stat = 'UPR_SEL'
    else:
        stat,Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DNrPliku[0][0])
        dane = [Tresc]
                
#-------------------------------------------------------------------------------
#---   DELETE (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprDel:
        stat = 'UPR_DEL'
    else:
        stat = fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DNrPliku[0][0])
        
    if stat == 'OK':
        DEL = """DELETE FROM rs_artykuly_pliki WHERE plik_id={};""".format(PlikId)
        DEL+= """DELETE FROM rs_pliki          WHERE plik_id={};""".format(DNrPliku[0][0])

        rsglobal.ZapiszDoLogow(DEL,5)
        stat,dump,dump,dump = self.PolSQL.Execute(DEL,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd przy usuwaniu pliku: '+stat
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 - select, 6 - delete)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,5,6]:
    if not UprSel:
        stat = 'UPR_SEL'
    else:
        SEL = """SELECT plik_id, typ_pliku, '', artykul_plik 
                 FROM rs_artykuly_pliki 
                 WHERE artykul_id='{}';""".format(ArtykulId)

        stat,dane,wyn1,tr = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd przy pobieraniu danych: '+stat
