# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_stawki_vat.py
# Purpose:     obsluga grida edytowalnego okreslajacego stawki vat dla artykulu
# Author:      mariusz rajfura
# Created:     2010/11/12
# RCS-ID:      $Id: fs_artykuly_stawki_vat $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-09-06 Mariusz Rajfura (4188) nowe pole 'stawka_vat_import'
# 2012-11-15 Mariusz Rajfura (6257) komunikat bledy przy modyfikacji
# 2019-07-25 Wojciech Skowron (11552) obsuga nazwy skrconej
# 2020-03-16 Mikoaj Kozowski (11904) obsuga pola "kod_cn" + skrcenie WHERE w Delete i Update
# 2020-04-02 Aleksander Bargie (11926) Podtabela artykuy - stawki vat - bdy przy wprowadzaniu nazwy skrconej
# 2021-11-17 Wojciech Skowron (11727) Poprawka kontroli na par stawka VAT + nazwa skrcona
# 2021-12-06 Wojciech Skowron (11727) Grupowanie komunikatw (zakomentowane zapisywanie do stat, zmienna StawkaVatBlad),
#                                     poprawka sprawdzania terminu stawki i pkwiu przy update (zmniejszone wcicie)

import rsglobal

Artykul = rsglobal.Dekoduj(klucze[0]).strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien
#-------------------------------------------------------------------------------

UprIns=((self.oddzial_id,'013013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'013012') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'013014') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
# Pobranie aktualnej stawki VAT i pkwiu na podstawie rs_artykuly_stawki_vat (10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    sql ="SELECT asv.stawka_vat, sv.opis, COALESCE(asv.sww_pkwiu,''::TEXT)"
    sql+=" FROM rs_artykuly_stawki_vat asv"
    sql+=" LEFT JOIN rs_stawki_vat sv ON (sv.kod=asv.stawka_vat)"
    sql+=" WHERE asv.firma_id='"+self.firma_id+"' AND asv.artykul_id='"+Artykul+"'"
    sql+=" AND asv.od_dnia<=NOW()::DATE ORDER BY asv.od_dnia DESC LIMIT 1;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania aktualnej stawki VAT dla artykuu'
        dane.append(stat)
        
    
#-------------------------------------------------------------------------------
# Obsluga edytowalnego grida (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0]) > 0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT artykul_id,stawka_vat,od_dnia,sww_pkwiu,stawka_vat_import,kod_cn"  #MK 2020-03-16
                SQLFU+=" FROM rs_artykuly_stawki_vat"
                DELETE = "DELETE FROM rs_artykuly_stawki_vat "
                WHERE = " WHERE firma_id='"+self.firma_id+"'"
                WHERE+= " AND artykul_id='"+Artykul+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = rsglobal.Dekoduj(Delete[0][i][j])
                    if pole == 'od_dnia':  #MK 2020-03-17
                        WHERE += " AND "+pole+"='"+wart+"'"
                        
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += WHERE+" FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,dDEL,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
                elif len(dDEL) == 0:
                    stat = 'Bdny zakres danych do usunicia'
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT artykul_id,stawka_vat,od_dnia,sww_pkwiu,stawka_vat_import,kod_cn" #MK 2020-03-16
                SQLFU+=" FROM rs_artykuly_stawki_vat"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                SQLFU+=" AND artykul_id='"+Artykul+"'"

                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                       #MK 2020-03-17
                    if pole == 'od_dnia':
                        SQLFU += " AND "+pole+"='"+wart+"'"

                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dUPD,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
                elif len(dUPD) == 0:
                    stat = 'Bdny zakres danych do modyfikacji'
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
        
            for i in xrange(len(Update[0])):
                StawkaVat = None
                StawkaVatBlad = False  #WS 2021-12-06
                OdDnia = None
                SwwPkwiu = None
                NazwaSkr = None  #WS 2019-07-25
                
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = rsglobal.Dekoduj(Update[1][i][j])
                    
                    if pole == 'stawka_vat':
                        wart = wart.strip()
                        StawkaVat = wart
                        if wart == '':
                            # stat = 'BR STAWKA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR STAWKA')
                            StawkaVatBlad = True
                        else:
                            sql ="SELECT kod FROM rs_stawki_vat"
                            sql+=" WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia stawki VAT'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                # stat = 'BL STAWKA'
                                wyn2.append((WierszeNr[i],0))
                                dane.append('BL STAWKA')
                                StawkaVatBlad = True

                    #WS 2019-07-25
                    elif pole == 'nazwa_skrocona':
                        NazwaSkr = wart.strip()
                        #AB 02.04.20r
                        if len(NazwaSkr) > 35:
                            # stat = 'Nazwa skrcona {} przekracza 35 znakw.'.format(NazwaSkr)
                            dane.append('Nazwa skrcona {} przekracza 35 znakw.'.format(NazwaSkr))
                            wyn2.append((WierszeNr[i], 2))
                        else:
                            SEL = """SELECT czy_detal OR tylko_detal
                                     FROM rs_artykuly
                                     WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Artykul)
                            stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd pobierania informacji o edytowanym artykule: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],2))
                            elif len(d) == 0:
                                # stat = 'BL ART'
                                dane.append('BL ART')
                                wyn2.append((WierszeNr[i],2))
                            else:
                                if d[0][0]:
                                    if wart.strip() in ('', 'None', None):
                                        # stat = 'BR NAZWA SKR'
                                        dane.append('BR NAZWA SKR')
                                        wyn2.append((WierszeNr[i],2))

                    elif pole == 'od_dnia':
                        OdDnia = wart
                        #WS 2019-07-25
                        if wart.strip() in ('','None',None):
                            # stat = 'BR STAWKA OD_DNIA'
                            dane.append('BR STAWKA OD_DNIA')
                            wyn2.append((WierszeNr[i],3))
                        elif not rsglobal.SprawdzCzyToData(wart):
                            # stat = 'BL STAWKA OD_DNIA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append('BL STAWKA OD_DNIA')
                    
                    elif pole == 'sww_pkwiu':
                        wart = wart.strip()
                        SwwPkwiu = wart
                        if len(SwwPkwiu) > 20:
                            # stat = 'BL PKWIU DL'
                            wyn2.append((WierszeNr[i],4))
                            dane.append('BL PKWIU DL')

                    elif pole == 'kod_cn':  #MK 2020-03-16
                        wart = wart.strip()
                        KodCN = wart
                        if len(KodCN) > 8:
                            # stat = 'BL CN DL'
                            wyn2.append((WierszeNr[i],5))
                            dane.append('BL CN DL')

                    if pole == 'stawka_vat_import':
                        wart = wart.strip()
                        if wart <> '':
                            sql ="SELECT kod FROM rs_stawki_vat"
                            sql+=" WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia stawki VAT import'
                                wyn2.append((WierszeNr[i],6))  #MK 2020-03-16
                                dane.append(stat)
                            elif len(d) == 0:
                                # stat = 'BL STAWKA IMPORT'
                                wyn2.append((WierszeNr[i],6)) #MK 2020-03-16
                                dane.append('BL STAWKA IMPORT')

                # if stat == 'OK':
                #     if len(dane) > 0:
                #         stat = dane[0]
                        
                if stat == 'OK' and (StawkaVat == None or OdDnia == None or SwwPkwiu == None):
                    #sprawdzenie kompletu danych z wykorzystaniem kluczy
                    #bo nie wszystkie pola moga byc aktualizowane

                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole = Update[3][j]
                        wart = rsglobal.Dekoduj(Update[2][i][j])
                    
                        if pole == 'stawka_vat':
                            if StawkaVat == None:
                                StawkaVat = wart
                            
                        elif pole == 'od_dnia':
                            if OdDnia == None:
                                OdDnia = wart
                                
                        elif pole == 'sww_pkwiu':
                            if SwwPkwiu == None:
                                if wart.strip() == '':
                                    SwwPkwiu = "NULL"
                                else:
                                    SwwPkwiu = wart

                if not StawkaVat in ('22','23') and not StawkaVatBlad:  #WS 2021-12-06
                    #WS 2021-11-17
                    if SwwPkwiu.strip() in ("NULL", ''):
                    # if SwwPkwiu == "NULL":
                        # stat = 'BR PKWIU'
                        wyn2.append((WierszeNr[i],4))
                        dane.append('BR PKWIU')

                if stat == 'OK' and not StawkaVatBlad:  #WS 2021-12-06
                    sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                    sql+=" WHERE stawka_vat='"+StawkaVat+"'"
                    sql+=" AND '"+OdDnia+"'>=od_dnia"
                    sql+=" AND CASE WHEN do_dnia IS NULL"
                    sql+=" THEN TRUE ELSE '"+OdDnia+"'<=do_dnia END;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia okresu obowizywania stawki VAT.'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                    elif len(d) <> 1:
                        # stat = 'BL STAWKA TERMIN'
                        wyn2.append((WierszeNr[i],3))
                        dane.append('BL STAWKA TERMIN')

                #WS 2021-11-17 - poprawka kontroli na par stawka VAT + nazwa skrcona
                if stat == 'OK':
                    if NazwaSkr is None:
                        SEL = "SELECT nazwa_skrocona FROM rs_artykuly_stawki_vat WHERE firma_id='{}'"
                        SEL = SEL.format(self.firma_id)
                        pola_klucz = Update[3]
                        wartosci_klucz = Update[2][i]
                        for pole, wart in zip(pola_klucz, wartosci_klucz):  # petla po kluczu
                            if pole in ('stawka_vat', 'od_dnia'):
                                SEL += " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"
                        rsglobal.ZapiszDoLogow(SEL)
                        stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
                        if stat != 'OK':
                            stat = 'Bd pobrania nazwy skrconej: '+stat
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            NazwaSkr = d[0][0]

                    if NazwaSkr not in ('None', ''):
                        SEL = """SELECT artykul_id
                                 FROM rs_artykuly_stawki_vat
                                 WHERE firma_id='{}' AND nazwa_skrocona='{}' AND artykul_id!='{}' AND stawka_vat!='{}';"""
                        SEL = SEL.format(self.firma_id, NazwaSkr, Artykul, StawkaVat)
                        rsglobal.ZapiszDoLogow(SEL)
                        stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
                        if stat != 'OK':
                            stat = 'Bd pobierania informacji o artykuach: '+stat
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(d) > 0:
                            # stat = 'Podana nazwa skrcona wystpuje w parze z inn stawkVAT dla artykuw: '+', '.join(dane[0].strip() for dane in d)
                            dane.append('Podana nazwa skrcona wystpuje w parze z inn stawkVAT dla artykuw: '+', '.join(dane[0].strip() for dane in d))
                            wyn2.append((WierszeNr[i], 0))
                            wyn2.append((WierszeNr[i], 2))

        # if stat == 'OK':
        #     if len(dane) > 0:
        #         stat = dane[0]

        #WS 2021-11-17 - zakomentowane
        # if stat == 'OK':
        #     if NazwaSkr not in ('','None',None):
        #         SEL = """SELECT artykul_id
        #                  FROM rs_artykuly
        #                  WHERE firma_id='{}' AND aktywny=TRUE AND nazwa_skrocona='{}';""".format(self.firma_id, NazwaSkr)
        #         rsglobal.ZapiszDoLogow(SEL)
        #         stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        #         if stat != 'OK':
        #             stat = 'Bd pobierania informacji o artykuach: '+stat
        #             dane.append(stat)
        #             wyn2.append((WierszeNr[i],2))
        #         elif len(d) != 0:
        #             stat = 'Istniej inne aktywne artykuy o tej samej stawce VAT i nazwie skrconej: '+', '.join(d[0])
        #             dane.append(stat)
        #             wyn2.append((WierszeNr[i],2))


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat == "OK":
    if len(Insert[0]) > 0:
        if not UprIns:
            stat = 'BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            
            for i in xrange(len(Insert[0])):
                StawkVatNowa = None
                StawkaVatBlad = False  #WS 2021-12-06
                OdKiedyNowa = None
                SwwPkwiuNowa = None
                StawkVatImportNowa = None
                NazwaSkr = None #WS 2019-07-25
                
                for j in xrange(len(Insert[0][i])): 
                    pole = Insert[1][j]
                    wart = rsglobal.Dekoduj(Insert[0][i][j])

                    if pole == 'stawka_vat':
                        wart = wart.strip()
                        StawkaVatNowa = wart
                        if wart == '':
                            # stat = 'BR STAWKA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR STAWKA')
                            StawkaVatBlad = True
                        else:
                            StawkaVatNowa = wart
                            sql ="SELECT kod FROM rs_stawki_vat"
                            sql+=" WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia stawki VAT'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                # stat = 'BL STAWKA'
                                wyn2.append((WierszeNr[i],0))
                                dane.append('BL STAWKA')
                                StawkaVatBlad = True

                    #WS 2019-07-25
                    elif pole == 'nazwa_skrocona':
                        NazwaSkr = wart.strip()
                        #AB 02.04.20r
                        if len(NazwaSkr) > 35:
                            # stat = 'Nazwa skrcona {} przekracza 35 znakw.'.format(NazwaSkr)
                            dane.append('Nazwa skrcona {} przekracza 35 znakw.'.format(NazwaSkr))
                            wyn2.append((WierszeNr[i], 2))
                        else:
                            SEL = """SELECT czy_detal OR tylko_detal
                                     FROM rs_artykuly
                                     WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Artykul)
                            stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd pobierania informacji o edytowanym artykule: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],2))
                            elif len(d) == 0:
                                # stat = 'BL ART'
                                dane.append('BL ART')
                                wyn2.append((WierszeNr[i],2))
                            else:
                                if d[0][0]:
                                    if wart.strip() in ('', 'None', None):
                                        # stat = 'BR NAZWA SKR'
                                        dane.append('BR NAZWA SKR')
                                        wyn2.append((WierszeNr[i],2))


                    elif pole == 'od_dnia':
                        wart = wart.strip()  #WS 2021-12-06
                        OdDniaNowa = wart
                        #WS 2019-07-25
                        if wart in ('','None',None):
                            # stat = 'BR STAWKA OD_DNIA'
                            dane.append('BR STAWKA OD_DNIA')
                            wyn2.append((WierszeNr[i],3))
                        elif not rsglobal.SprawdzCzyToData(wart):
                            # stat = 'BL STAWKA OD_DNIA'
                            dane.append('BL STAWKA OD_DNIA')
                            wyn2.append((WierszeNr[i],3))
                        else:
                            #czy jest juz stawka dla podanej daty
                            sql ="SELECT od_dnia FROM rs_artykuly_stawki_vat"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                            sql+=" AND od_dnia='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia daty obowizywania stawki VAT: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],3))
                            elif len(d) > 0:
                                # stat = 'BL KLUCZ IST'
                                dane.append('BL KLUCZ IST')
                                wyn2.append((WierszeNr[i],3))

                    elif pole == 'sww_pkwiu':
                        wart = wart.strip()
                        SwwPkwiuNowa = wart
                        if len(SwwPkwiuNowa) > 20:
                            # stat = 'BL PKWIU DL'
                            wyn2.append((WierszeNr[i],4))
                            dane.append('BL PKWIU DL')

                    elif pole == 'kod_cn':  #MK 2020-03-16
                        wart = wart.strip()
                        KodCNNowy = wart
                        if len(KodCNNowy) > 8:
                            # stat = 'BL CN DL'
                            wyn2.append((WierszeNr[i],5))
                            dane.append('BL CN DL')

                    if pole == 'stawka_vat_import':
                        wart = wart.strip()
                        StawkaVatImportNowa = wart
                        if wart <> '':
                            StawkaVatImportNowa = wart
                            sql ="SELECT kod FROM rs_stawki_vat"
                            sql+=" WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia stawki VAT import'
                                wyn2.append((WierszeNr[i],6)) #MK 2020-03-16
                                dane.append(stat)
                            elif len(d) == 0:
                                # stat = 'BL STAWKA IMPORT'
                                wyn2.append((WierszeNr[i],6)) #MK 2020-03-16
                                dane.append('BL STAWKA IMPORT')

                #WS 2021-11-17 - poprawka kontroli na par stawka VAT + nazwa skrcona
                if stat == 'OK':
                    if NazwaSkr not in ('None', ''):
                        SEL = """SELECT artykul_id
                                 FROM rs_artykuly_stawki_vat
                                 WHERE firma_id='{}' AND nazwa_skrocona='{}' AND artykul_id!='{}' AND stawka_vat!='{}';"""
                        SEL = SEL.format(self.firma_id, NazwaSkr, Artykul, StawkaVatNowa)
                        rsglobal.ZapiszDoLogow(SEL)
                        stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
                        if stat != 'OK':
                            stat = 'Bd pobierania informacji o artykuach: '+stat
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(d) > 0:
                            # stat = 'Podana nazwa skrcona wystpuje w parze z inn stawkVAT dla artykuw: '+', '.join(dane[0].strip() for dane in d)
                            dane.append('Podana nazwa skrcona wystpuje w parze z inn stawkVAT dla artykuw: '+', '.join(dane[0].strip() for dane in d))
                            wyn2.append((WierszeNr[i], 0))
                            wyn2.append((WierszeNr[i], 2))

                # if stat == 'OK':
                #     if len(dane) > 0:
                #         stat = dane[0]

                #WS 2021-11-17 - zakomentowane
                # if stat == 'OK':
                #     if NazwaSkr not in ('','None',None):
                #         SEL = """SELECT artykul_id
                #                  FROM rs_artykuly
                #                  WHERE firma_id='{}' AND aktywny=TRUE AND nazwa_skrocona='{}' AND artykul_id!='{}';""".format(self.firma_id, NazwaSkr, Artykul)
                #         stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                #         if stat != 'OK':
                #             stat = 'Bd pobierania informacji o artykuach: '+stat
                #             dane.append(stat)
                #             wyn2.append((WierszeNr[i],2))
                #         elif len(d) != 0:
                #             stat = 'Istniej inne aktywne artykuy o tej samej stawce VAT i nazwie skrconej: '+', '.join(d[0])
                #             dane.append(stat)
                #             wyn2.append((WierszeNr[i],2))

                if stat == 'OK':
                    if not StawkaVatNowa in ('22','23') and not StawkaVatBlad:  #WS 2021-12-06
                        #WS 2021-11-17
                        if SwwPkwiuNowa.strip() in ("NULL", ''):
                        # if SwwPkwiuNowa == '':
                            # stat = 'BR PKWIU'
                            wyn2.append((WierszeNr[i],4))
                            dane.append('BR PKWIU')

                #sprawdzenie nowej stawki stawki z obowiazujacymi terminami
                if stat == 'OK' and not StawkaVatBlad and rsglobal.SprawdzCzyToData(OdDniaNowa):  #WS 2021-12-06
                    sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                    sql+=" WHERE stawka_vat='"+StawkaVatNowa+"'"
                    sql+=" AND '"+OdDniaNowa+"'>=od_dnia"
                    sql+=" AND CASE WHEN do_dnia IS NULL"
                    sql+=" THEN TRUE ELSE '"+OdDniaNowa+"'<=do_dnia END;"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia okresu obowizywania stawki VAT.'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                    elif len(d) <> 1:
                        # stat = 'BL STAWKA TERMIN'
                        wyn2.append((WierszeNr[i],3))
                        dane.append('BL STAWKA TERMIN')

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#---------Wykonanie Update------
#-------------------------------------------------------------------------------

#WS 2021-12-06 - update przeniesiony z wyej
if Fun == 1 and stat == "OK":
    if len(Update[0]) > 0:
        SQLUPD = ''
        for i in xrange(len(Update[0])):
            UPDATE = "UPDATE rs_artykuly_stawki_vat"
            SET = " SET "
            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = rsglobal.Dekoduj(Update[1][i][j])
                if pole in ('stawka_vat','od_dnia'):
                    SET += pole+"='"+wart+"',"
                elif pole in ('sww_pkwiu','nazwa_skrocona', 'kod_cn'): #WS 2019-07-25  #MK2020-03-16
                    SET += pole+"='"+wart.strip()+"',"
                elif pole in ('stawka_vat_import',):
                    wart = wart.strip()
                    if wart == '':
                        SET += pole+"=NULL,"
                    else:
                        SET += pole+"='"+wart.strip()+"',"

            SET = SET[:-1]
            WHERE = " WHERE firma_id='"+self.firma_id+"'"
            WHERE+= " AND artykul_id='"+Artykul+"'"
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])

                if pole in ('stawka_vat','od_dnia'):
                    WHERE += " AND "+pole+"='"+str(wart)+"'"

                elif pole in ('sww_pkwiu','stawka_vat_import', 'kod_cn'):  #MK 2020-03-16
                    if wart.strip() == '':
                        WHERE += " AND ("+pole+" IS NULL OR "+pole+"='')"
                    else:
                        WHERE += " AND "+pole+"='"+str(wart)+"'"

            SQLUPD += UPDATE+SET+WHERE+";"

        if SQLUPD <> '':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQLUPD),1)
            if stat <> 'OK':
                stat = 'Istniej dwie stawki VAT, ktrych data pocztku obowizywania jest identyczna.'
                dane.append(stat)

#-------------------------------------------------------------------------------
#---------Wykonanie Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat == "OK":
    if len(Insert[0]) > 0:
        SQLINS = ''
        for i in xrange(len(Insert[0])):
            INSERT = "INSERT INTO rs_artykuly_stawki_vat "
            KOLUMNY = "(firma_id,artykul_id"
            VALUES = " VALUES ('"+self.firma_id+"','"+Artykul+"'"

            for j in xrange(len(Insert[0][i])):
                pole = Insert[1][j]
                wart = rsglobal.Dekoduj(Insert[0][i][j])
                if pole in ('stawka_vat','od_dnia'):
                    KOLUMNY+=","+pole
                    VALUES+=",'"+wart+"'"
                elif pole in ('sww_pkwiu','nazwa_skrocona','kod_cn'): #WS 2019-07-25 #MK 2020-03-16
                    KOLUMNY += ","+pole
                    VALUES+=",'"+wart.strip()+"'"
                elif pole in ('stawka_vat_import',):
                    wart = wart.strip()
                    KOLUMNY += ","+pole
                    if wart == '':
                        VALUES+=",NULL"
                    else:
                        VALUES+=",'"+wart.strip()+"'"

            KOLUMNY+=")"
            VALUES+=");"
            SQLINS += INSERT+KOLUMNY+VALUES

        if SQLINS <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLINS),1)
            if stat <> 'OK':
                stat = "Bd przy dodawaniu danych: "+stat
                dane.append(stat)


if Fun == 1 and stat == 'OK' and len(Delete[0])+len(Update[0])+len(Insert[0])>0 :
    #jesli byla udana modyfikcja grida ze stawkami vat, to aktualizujemy
    #pole stawka_vat i sww_pkwiu w rs_artykuly na aktualna, obowiazujaca stawke
    #WS 2019-07-25
    sql ="SELECT stawka_vat,COALESCE(sww_pkwiu,''::TEXT),COALESCE(stawka_vat_import,''::TEXT),COALESCE(nazwa_skrocona,''::TEXT),COALESCE(kod_cn,''::TEXT)"  #MK 2020-03-16
    # sql ="SELECT stawka_vat,COALESCE(sww_pkwiu,''::TEXT),COALESCE(stawka_vat_import,''::TEXT)"
    sql+=" FROM rs_artykuly_stawki_vat"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    sql+=" AND od_dnia<=NOW()::DATE ORDER BY od_dnia DESC LIMIT 1;"
    stat,dStawka,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania aktualnej stawki VAT dla artykuu: '+stat
        dane.append(stat)
    elif len(dStawka) == 0:
        #to troche niepokojaca sytuacja
        StawkaVat = 'NULL'
        SwwPkwiu = 'NULL'
        StawkaVatImport = 'NULL'
        NazwaSkrocona = 'NULL' #WS 2019-07-25
        KodCN = 'NULL' #MK 2020-03-16
    else:
        StawkaVat = "'"+rsglobal.Dekoduj(dStawka[0][0])+"'"
        SwwPkwiu = "'"+rsglobal.Dekoduj(dStawka[0][1]).strip()+"'"
        # jesli stawka_vat_import niewypeniona, to NULL, bo jest kluczem obcym
        if rsglobal.Dekoduj(dStawka[0][2]).strip() == '':
            StawkaVatImport = "NULL"
        else:
            StawkaVatImport = "'"+rsglobal.Dekoduj(dStawka[0][2])+"'"
        NazwaSkrocona = "'"+rsglobal.Dekoduj(dStawka[0][3]).strip()+"'" #WS 2019-07-25
        KodCN = "'" + rsglobal.Dekoduj(dStawka[0][4]).strip() + "'"  #MK 2020-03-16
        
    if stat == 'OK':
        sql ="UPDATE rs_artykuly SET stawka_vat="+StawkaVat+",sww_pkwiu="+SwwPkwiu+","  #MK 2020-03-16
        #WS 2019-07-25
        sql+=" stawka_vat_import="+StawkaVatImport+",nazwa_skrocona="+NazwaSkrocona+",kod_cn="+KodCN #MK 2020-03-16
        # sql+=" stawka_vat_import="+StawkaVatImport
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
        if stat <> 'OK':
            stat = 'Bd aktualizacji stawki VAT dla artykuu: '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat == 'OK':
    #WS 2019-07-24
    SQL ="SELECT asv.stawka_vat, sv.opis, COALESCE(asv.nazwa_skrocona,''), asv.od_dnia, COALESCE(asv.sww_pkwiu,''::TEXT) AS sww_pkiwu,COALESCE(asv.kod_cn,''::TEXT) AS kod_cn," #MK 2020-03-16
    # SQL ="SELECT asv.stawka_vat, sv.opis, asv.od_dnia, COALESCE(asv.sww_pkwiu,''::TEXT) AS sww_pkiwu,"
    SQL+=" COALESCE(asv.stawka_vat_import,''::TEXT), COALESCE(svi.opis,''::TEXT)"
    SQL+=" FROM rs_artykuly_stawki_vat asv"
    SQL+=" LEFT JOIN rs_stawki_vat sv ON (sv.kod=asv.stawka_vat)"
    SQL+=" LEFT JOIN rs_stawki_vat svi ON (svi.kod=asv.stawka_vat_import)"
    SQL+=" WHERE asv.firma_id='"+self.firma_id+"' AND asv.artykul_id='"+Artykul+"'"
    SQL+=" ORDER BY asv.od_dnia DESC;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu stawek VAT dla artykuu: "+stat
        dane.append(stat)