# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_artykuly_wzory_parametry_pom.py
# Purpose:     funkcje pomocnicze do wzorw z artykuw
# Author:      Micha Raburski
# Created:     2014/11/20
# RCS-ID:      $Id: fs_artykuly_wzory_parametry_pom.py $
# Copyright:   (c) 2014 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# Funkcja podajca wiersze do wstawienia w oparciu o podan pozycj zlecenia z parametrami.
# Parametry funkcji:
# KlPozZam  - lista [wyznacznik, data ,numer, nr poz, nr ppoz zamwienia odbiorcy
# Zlec - numer zlecenia, ktre ma by wstawione,
# Artykul - artyku, ktry ma by analizowany,
# Cecha - cecha analizowanego artykuu,
# Parametry - parametry przychodzce z okienka z podawaniem parametrw,
# Brakujace - czy funkcja ma zwrci list, czy tylko brakujce parametry

def PodajPodzleceniaDlaArtykuluZeWzorem(self,KlPozZam,Zlec,Artykul,Cecha,Parametry,Brakujace=False):
    import rsglobal
    LPodpoz = []
    LBrakujacych = [[],[]] # - pierwsze to artyku,nazwa i cecha a drugie to lista parametrw do pobrania
    # jeli artyku nie jest podany to nastpuje prba pobrania ich z pozycji zlecenia
    if Artykul == '':
        SQL = "SELECT artykul_id,cecha1_wartosc FROM rs_zamowienia_odbiorcy_pozycje_zlecenia"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"'"
        SQL+=" AND data='"+KlPozZam[1]+"' AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])
        SQL+=" AND nr_ppoz="+str(KlPozZam[4])+" AND nr_zlec='"+Zlec+"'"
        stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return u'Bd pobierania danych artykuu z pozycji zlecenia :'+stat,[]
        if len(DArt) == 0:
            KlPozZam.append(Zlec)
            return u'Podano nieistniejcy numer numer zlecenia :'+str(KlPozZam)[1:-1],[]
        Artykul = DArt[0][0]
        Cecha = DArt[0][1]
    
    # pobranie nazwy artykuu do opisu okna z parametrami
    if Brakujace:
        SQL="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+Artykul+"'"
        stat,DArtNazwa,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return u'Bd pobierania nazwy artykuu :'+stat,[]
        LBrakujacych[0] = [Artykul,DArtNazwa[0][0],Cecha]
        
    # pobranie wzoru
    SQL = "SELECT COALESCE(wzor_zlecenia,'') FROM rs_artykuly "
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Artykul+"';"
    stat,DWzor,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania wzoru z artykuu :'+stat,[]
    
    # pobranie parametrw ze staych oddziau
    SParamS = {}
    SQL = "SELECT COALESCE(stale_wzorow_zlecen,'') FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"';"
    rsglobal.ZapiszDoLogow('SQL S '+SQL,1)
    stat,DParam,dump,dump=self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('DParam S '+str(DParam),1)
    if stat <> 'OK':
        return u'Bd pobierania parametrw staych z oddziau :'+stat,[]

    if DParam[0][0] <> '':
        LParamPoz = DParam[0][0].split(';')
        for parpoz in LParamPoz:
            param = parpoz.split('=')
            if len(param) == 2:
                if not param[0].strip() in SParamS:
                    SParamS[param[0].strip()] = eval(param[1].strip().replace("\\"+"'","'"))
    rsglobal.ZapiszDoLogow('SParamS '+str(SParamS),1)
    
    # pobranie parametrw z rodzicw pozycji # KlPozZam to Wyzn,Data,Nr,NrPoz
    # nisze parametry maj wikszy priorytet
    ZlecPom = Zlec
    if ZlecPom.rfind('.') == -1:
        ZlecPom = ''
    SParamR = {}
    while ZlecPom <> '':
        ZlecPom = ZlecPom[:ZlecPom.rfind('.')]
        if ZlecPom <> '':
            SQL = "SELECT COALESCE(parametry,'') FROM rs_zamowienia_odbiorcy_pozycje_zlecenia"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"'"
            SQL+=" AND data='"+KlPozZam[1]+"' AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])
            SQL+=" AND nr_ppoz="+str(KlPozZam[4])+" AND nr_zlec='"+ZlecPom+"'"
            stat,DParam,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                return u'Bd pobierania parametrw z pozycji zlecenia :'+stat,[]
        
            if DParam[0][0] <> '':
                LParamPoz = DParam[0][0].split(';')
                for parpoz in LParamPoz:
                    param = parpoz.split('=')
                    if len(param) == 2:
                        if not param[0].strip() in SParamR:
                            rsglobal.ZapiszDoLogow('!!! '+str(param[1].strip().replace("\\"+"'","'")),1)
                            SParamR[param[0].strip()] = eval(param[1].strip().replace("\\"+"'","'"))
                            
        if ZlecPom.rfind('.') == -1:
            ZlecPom = ''
            
    rsglobal.ZapiszDoLogow('SParamR '+str(SParamR),1)   
             
    # wstawienie do sownika parametrw, ktre przyszy (maj posta parametr = wartosc; par2 = wart2; .... parn=wartn)
    SParam = {}
    if Parametry <> '':
        LParamPoz = Parametry.split(';')
        for parpoz in LParamPoz:
            param = parpoz.split('=')
            if len(param) == 2:
                if not param[0].strip() in SParam:
                    SParam[param[0].strip()] = eval(param[1].strip().replace("\\"+"'","'"))
                    
    # prba wyliczenia odpowiednich skadnikw
    LWzoru = DWzor[0][0].splitlines()
    # analizujemy sytuacj linia po linii. W zalenoci od typu linii robimy inne rzeczy
    # linie musz by w odpowiedniej kolejnoci, by dao si wszystko przeliczy. 
    for w in LWzoru:
        try:
            # wiersz z parametrem. Jeli parametr ma podane, e jest pobierany z operatora to 
            # sprawdzamy, czy jego warto nie jest pobrana z rodzica/podanych parametrw
            # jeli nie, to zwracamy informacj, e si nie da go policzy i koniec.
            # w innym wypadku podany jest wzr, ktry staramy si wykona. Jeli si nie uda to 
            # rwnie zwracamy bd wykonania
            
            # omijamy puste wiersze
            if w.strip() == '':
                continue
            elif w[0] == '#':
                continue
            elif w[0] == '$':
                if w.find('=') == -1:
                    return 'BLWZ Bdna skadnia wiersza - brak znaku = :\n'+w,[]
                zmienna = w[:w.find('=')].strip().strip('$$')
                wzor = w[w.find('=')+1:].strip()

                # pomijamy parametry podawane przez operatora rcznie
                if not wzor[:3] in ['(L)','(N)','(T)','(W)','(D)']:
                    # uzupenienie parametrw z parametrw podanych/wyliczonych
                    for param in SParam:
                        if isinstance(SParam[param],float) or isinstance(SParam[param],int):
                            wzor = wzor.replace('$$'+param+'$$',str(SParam[param]))
                        else:
                            wzor = wzor.replace('$$'+param+'$$',"'"+SParam[param]+"'")
                    
                    # uzupenienie z parametrw rodzicw
                    for param in SParamR:
                        if isinstance(SParamR[param],float) or isinstance(SParamR[param],int):
                            wzor = wzor.replace('$$'+param+'$$',str(SParamR[param]))
                        else:
                            wzor = wzor.replace('$$'+param+'$$',"'"+SParamR[param]+"'")

                    # uzupenienie z parametrw stalych
                    for param in SParamS:
                        if isinstance(SParamS[param],float) or isinstance(SParamS[param],int):
                            wzor = wzor.replace('$$'+param+'$$',str(SParamS[param]))
                        else:
                            wzor = wzor.replace('$$'+param+'$$',"'"+SParamS[param]+"'")
                            
                    # wyznaczamy wartosc parametru
                    SParam[zmienna] = eval(wzor)
                    
                    if Parametry.find(zmienna) == -1:
                        WynTmp = eval(wzor)
                        if isinstance(WynTmp,float) or isinstance(WynTmp,int):
                            Parametry+=";"+zmienna+" = "+str(WynTmp)
                        else:
                            Parametry+=";"+zmienna+" = '"+str(WynTmp)+"'"
                        Parametry = Parametry.strip(';')
                        
                # pobieramy brakujce na list
                else:
                    #rsglobal.ZapiszDoLogow('!!! Pobranie '+str(Brakujace)+' !'+Parametry+'!'
                    if Brakujace:
                        # podanie parametrw do formularza
                        LBrakujacych[1].append([zmienna,wzor[1:2],wzor[4:].strip()])
                    elif Parametry == '':
                        # parametry nie byy podane
                        return 'BLWZ Nie podano parametrw',[]
        
            # wiersz ze skadnikiem. Podstawiamy parametry i wykonujemy kod. Jeli nie zadziaa to zgaszamy
            # bd wykonania. Skadamy w tym procesie list podpozycji do dodania. Parametry wprowadzamy tylko 
            # te podane. Operator ma wiadomie je poda.
            elif w[0] == '[' and not Brakujace:
                if w.find('=') == -1:
                    return 'BLWZ Bdna skadnia wiersza - brak znaku = :\n'+w,[]
                LSkladnika = eval(w[:w.find('=')].strip())
                if len(LSkladnika) < 2:
                    return 'BLWZ Bdnie zdefiniowany skadnik '+w[:w.find('=')].strip()+':\n'+w,[]
                
                wzor = w[w.find('=')+1:].strip()
                # uzupenienie parametrw z parametrw podanych/wyliczonych
                for param in SParam:
                    if isinstance(SParam[param],float) or isinstance(SParam[param],int):
                        wzor = wzor.replace('$$'+param+'$$',str(SParam[param]))
                    else:
                        wzor = wzor.replace('$$'+param+'$$',"'"+SParam[param]+"'")
                
                # uzupenienie z parametrw rodzicw
                for param in SParamR:
                    if isinstance(SParamR[param],float) or isinstance(SParamR[param],int):
                        wzor = wzor.replace('$$'+param+'$$',str(SParamR[param]))
                    else:
                        wzor = wzor.replace('$$'+param+'$$',"'"+SParamR[param]+"'")
                
                # uzupenienie z parametrw staych
                for param in SParamS:
                    if isinstance(SParamS[param],float) or isinstance(SParamS[param],int):
                        wzor = wzor.replace('$$'+param+'$$',str(SParamS[param]))
                    else:
                        wzor = wzor.replace('$$'+param+'$$',"'"+SParamS[param]+"'")
                        
                rsglobal.ZapiszDoLogow('1 '+wzor,1)
                Ilosc = eval(wzor)
                rsglobal.ZapiszDoLogow('2 '+str(Ilosc),1)
                if Ilosc > 0:
                    # sprawdzenie spjnoci danych
                    SQL = "SELECT COALESCE(cecha1_opis,'') FROM rs_artykuly "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+LSkladnika[0]+"'"
                    stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat <> 'OK':
                        return 'Bdy pobierania danych artykuu z wiersza:\n '+w,[]
                    if len(DArt) == 0:
                        return 'Bdnie zdefiniowany artyku w wierszu:\n '+w,[]
                    if DArt[0][0] <> '' and LSkladnika[1] == '':
                        return 'Nie podano cechy dla artykuu z cech w wierszu:\n '+w,[]
                    if DArt[0][0] == '' and LSkladnika[1] <> '':
                        return 'Podano cech dla artykuu bez cechy w wierszu:\n '+w,[]
                    # sprawdzenie poprawnoci cechy
                    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+DArt[0][0]+"','"+LSkladnika[1]+"','poprawna')"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat <> 'OK':
                        return 'Bd sprawdzenia wartoci cechy: '+stat+' dla wiersza :\n'+w,[]
                    else:
                        Wynik=eval(d[0][0])
                        if not Wynik[0]:
                            return Wynik[1]+' w wierszu :\n'+w,[]
                
                    # art, cecha, wart cechy, ilosc,zrodlo
                    LPodpoz.append([LSkladnika[0],DArt[0][0],LSkladnika[1],Ilosc,u'wzr artykuu '+Artykul])
            
        except Exception, e:
            # jeli si nie udao to zwracamy stat z bdem
            return 'BLWZ Bd wyliczenia wzoru w wierszu:\n '+w+'\n '+str(e),[]

    # jeli zbieramy parametry do podania to teraz wracamy z wynikiem
    if Brakujace:
        return 'OK',LBrakujacych

    # jeli si udao to wpisujemy parametry do pozycji
    if Zlec <>'':
        SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET parametry='"+Parametry.replace("'","\\"+"'").replace("\\\\","\\")+"' "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"'"
        SQL+=" AND data='"+KlPozZam[1]+"' AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])
        SQL+=" AND nr_ppoz="+str(KlPozZam[4])+" AND nr_zlec='"+Zlec+"'"
        rsglobal.ZapiszDoLogow('PARAMETRY UPD '+SQL,1)
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            return u'Bd wstawiania parametrw do pozycji zlecenia :'+stat,[]
    
    return 'OK',LPodpoz

#-------------------------------------------------------------------------------

# Funkcja porwnuje dwa niekoniecznie identyczne cigi parametrw czy ich wartoci s identyczne
def CzyIdentyczneParametry(Param1,Param2):
    import rsglobal
    try:
        if Param1.strip() == Param2.strip():
            return True
        
        if Param1.strip() == '' or Param2.strip() == '':
            return False
        
        LPar1 = Param1.split(';')
        LPar2 = Param2.split(';')
        # sprawdzamy czy jest tyle samo parametrw
        if len(LPar1) <> len(LPar2):
            return False
        
        SPar1 = {}
        for poz in LPar1:
            buf = poz.split('=')
            if len(buf) <> 2:
                return False
            SPar1[buf[0].strip()] = eval(buf[1])
        
        SPar2 = {}
        for poz in LPar2:
            buf = poz.split('=')
            if len(buf) <> 2:
                return False
            SPar2[buf[0].strip()] = eval(buf[1])
        
        # sprawdzamy czy odpowiednie wartoci s rwne
        for kl in SPar1.keys():
            if not kl in SPar2:
                return False
            if SPar1[kl] <> SPar2[kl]:
                return False
        
        return True
        
    except Exception,e:
        rsglobal.ZapiszDoLogow(u'Bd porwnania parametrw :'+str(e),1)
        return False

#-------------------------------------------------------------------------------
# podaje stan artykuu z uwzgldnieniem cechy i parametru
# pusty parametr to te parametr i pusta cecha to te cecha
# aby ich nie uwzgldnia naley poda None

def PodajStanArtykuluZCechaIParametrem(self,Art,Cecha,Parametr,Magazyn=''):
    import rsglobal
    Suma = 0
    
    # pobieramy przyjcia bez uwzgldnienia parametrw
    SQL = "SELECT magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,ilosc1 - rezerwacja1 "
    SQL+= " FROM rs_artykuly_przyjecia WHERE firma_id='"+self.firma_id+"'"
    SQL+= " AND artykul_id='"+Art+"' AND ilosc1 - rezerwacja1 >0"
    if not Cecha in [None,'None','']:
        SQL+=" AND COALESCE(cecha1_wartosc,'') = '"+Cecha+"' "
    if Magazyn <> '':
        SQL+=" AND magazyn_id = '"+Magazyn+"'"
    
    stat,DPrzyj,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania przyj podczas wyznaczania stanu artykuu :'+stat,0
    
    if Parametr in [None,'None']:
        for poz in DPrzyj:
            Suma+=poz[6]
        return 'OK',Suma
    
    # dla kadego wiersza sprawdzamy czy jego parametr jest zgodny z podanym
    for poz in DPrzyj:
        SQL =" SELECT COALESCE(zoz.parametry,'') FROM rs_dokumenty_magazynowe_pozycje dmp"
        SQL+=" INNER JOIN rs_zamowienia_odbiorcy_pozycje_zlecenia zoz ON (zoz.firma_id = dmp.firma_id"
        SQL+=" AND zoz.wyznacznik_id = dmp.zo_wyznacznik_id AND zoz.data = dmp.zo_data"
        SQL+=" AND zoz.numer = dmp.zo_numer AND zoz.nr_poz = dmp.zo_nr_poz AND zoz.nr_ppoz = dmp.zo_nr_ppoz"
        SQL+=" AND zoz.nr_zlec = dmp.zo_nr_zlec)"
        SQL+=" WHERE dmp.firma_id = '"+self.firma_id+"' AND dmp.magazyn_id ='"+poz[0]+"'"
        SQL+=" AND dmp.dokument_id='"+poz[1]+"' AND dmp.data = '"+poz[2]+"'"
        SQL+=" AND dmp.numer="+str(poz[3])+" AND dmp.nr_poz="+str(poz[4])+" AND dmp.nr_ppoz="+str(poz[5])+";"
        stat,DParam,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return u'Bd pobierania parametru podczas wyznaczania stanu artykuu :'+stat,0
        if len(DParam) == 0:
            ParamAP = ''
        else:
            ParamAP = DParam[0][0]
        rsglobal.ZapiszDoLogow('Czyidentyczne'+Parametr+' '+ParamAP,1)
        if CzyIdentyczneParametry(Parametr,ParamAP):
            Suma+=poz[6]
            
    return 'OK',Suma
            
        
        
