# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_zestawy_czesci.py
# Purpose:     obsluga grida edytowalnego z czciami dla zestaww artykuu i kontrahenta
# Author:      Micha Raburski
# Created:     2014/05/05
# RCS-ID:      $Id: fs_artykuly_zestawy_czesci $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Artykul':[1,5],'Kontrahent':[1,5],'Cecha':[1,5,7],'WartCechy':[1,5,7],'Element':[11]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_zestawy_czesci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Artykul=str(klucze['Artykul'])
        Kontr=str(klucze['Kontrahent'])
    if Funkcja in [1,5,7]: 
        Cecha=str(klucze['Cecha'])
        WartCechy=str(klucze['WartCechy'])
    if Funkcja in [11]: 
        Element=str(klucze['Element'])
        
dane = []
wyn1 = []
wyn2 = []

UprModyf=((self.oddzial_id,'013112') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- POBRANIE OPISU CECHY (7)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 7: 
    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+WartCechy+"','poprawna'),"
    SQL+="rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+WartCechy+"','opis');"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bdy pobierania danych artykuu : '+stat


#-------------------------------------------------------------------------------
#-------- POBRANIE DANYCH ARTYKUU (11)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 11: 
    SQL="SELECT a.nazwa,COALESCE(a.cecha1_opis,''),COALESCE(ac.opis,''),COALESCE(acs.lp,0),"
    SQL+="CASE WHEN a.jm_kalk='1' THEN a.jm1 ELSE a.jm2 END "
    SQL+=" FROM rs_artykuly a "
    SQL+=" LEFT OUTER JOIN rs_artykuly_cechy ac ON (ac.firma_id=a.firma_id AND ac.kod = a.cecha1_opis)"
    SQL+=" LEFT OUTER JOIN rs_artykuly_cechy_sekcje acs ON (acs.firma_id=a.firma_id AND acs.kod=a.cecha1_opis)"
    SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+Element+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bdy pobierania danych artykuu : '+stat
        
    if stat=='OK' and len(dane)>0:
        Domyslna=''
        if dane[0][3] > 0:
            from funkcje import fs_artykuly_cechy_pom
            stat,Domyslna = fs_artykuly_cechy_pom.PodajDomyslnaCeche(self,dane[0][1])

        dane[0].append(Domyslna)

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT zestaw_id FROM rs_artykuly_zestawy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Artykul+"' AND kontrahent_id='"+Kontr+"'"
                SQLFU+=" AND cecha1_opis_z='"+Cecha+"' AND cecha1_wartosc_z='"+WartCechy+"'"
                DELETE = "DELETE FROM rs_artykuly_zestawy "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Artykul+"' AND kontrahent_id='"+Kontr+"'"
                WHERE+=" AND cecha1_opis_z='"+Cecha+"' AND cecha1_wartosc_z='"+WartCechy+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"='"+wart+"'"
                    SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'artykul_id':
                        if wart.strip() == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR ART')
                        else:
                            SQL="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"';"
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat =='OK':
                                if len(DTest) == 0:
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append('BL ART')    
                            
                    elif pole == 'ilosc1':
                        if wart <= 0:
                            wyn2.append((WierszeNr[i],6))
                            dane.append('BL ILOSC')
                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_artykuly_zestawy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['artykul_id','cecha1_opis_a','cecha1_wartosc_a']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['ilosc1']:
                        SET+=pole+"="+str(wart)+","

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Artykul+"' AND kontrahent_id='"+Kontr+"'"
                WHERE+=" AND cecha1_opis_z='"+Cecha+"' AND cecha1_wartosc_z='"+WartCechy+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['artykul_id']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'artykul_id':
                        if wart.strip() == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR ART')
                        else:
                            SQL="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"';"
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat =='OK':
                                if len(DTest) == 0:
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append('BL ART')    
                            
                    elif pole == 'ilosc1':
                        if wart <= 0:
                            wyn2.append((WierszeNr[i],6))
                            dane.append('BL ILOSC')
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_artykuly_zestawy "
                KOLUMNY="(firma_id,zestaw_id,kontrahent_id,cecha1_opis_z,cecha1_wartosc_z"
                VALUES=" VALUES ('"+self.firma_id+"','"+Artykul+"','"+Kontr+"','"+Cecha+"','"+WartCechy+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['artykul_id','cecha1_opis_a','cecha1_wartosc_a']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['ilosc1']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)+""

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                rsglobal.ZapiszDoLogow('SQLIns '+sqlIns,1)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

if Funkcja == 1 and stat=="OK":
    # sprawdzenie czy wszystkie pary cecha1_opis_a i cecha1_wartosc_a s zgodne i poprawne
    SQL="SELECT az.artykul_id,az.cecha1_opis_a,az.cecha1_wartosc_a,"
    SQL+="rsf_podaj_parametry_cechy(az.firma_id,az.cecha1_opis_a,az.cecha1_wartosc_a,'poprtech')"
    SQL+=" FROM rs_artykuly_zestawy az"
    SQL+=" WHERE az.firma_id='"+self.firma_id+"' AND az.zestaw_id='"+Artykul+"'"
    SQL+=" AND az.kontrahent_id='"+Kontr+"'"
    SQL+=" AND az.cecha1_opis_z='"+Cecha+"' AND az.cecha1_wartosc_z='"+WartCechy+"'"
    SQL+=" AND rsf_podaj_parametry_cechy(az.firma_id,az.cecha1_opis_a,az.cecha1_wartosc_a,'poprtech') = 'FALSE'"
    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if len(DTest)>0:
        stat='Bdne pary cecha/warto w zestawie dla artykuw/par:\n'
        for poz in DTest:
            stat+=poz[0].strip()+" / "+poz[1].strip()+" / "+poz[2].strip()+"\n"


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT az.artykul_id,a.nazwa,"
    SQL+=" az.cecha1_opis_a,COALESCE(ac.opis,''),az.cecha1_wartosc_a,"
    SQL+=" rsf_podaj_parametry_cechy(az.firma_id,az.cecha1_opis_a,az.cecha1_wartosc_a,'opis'),"
    SQL+=" az.ilosc1,CASE WHEN a.jm_kalk='1' THEN a.jm1 ELSE a.jm2 END AS jm"
    SQL+=" FROM rs_artykuly_zestawy az"
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+=" LEFT OUTER JOIN rs_artykuly_cechy ac ON (ac.firma_id=az.firma_id AND ac.kod=az.cecha1_opis_a)"
    SQL+=" WHERE az.firma_id='"+self.firma_id+"' AND az.zestaw_id='"+Artykul+"'"
    SQL+=" AND az.kontrahent_id='"+Kontr+"'"
    SQL+=" AND az.cecha1_opis_z='"+Cecha+"' AND az.cecha1_wartosc_z='"+WartCechy+"'"
    SQL+=" ORDER BY az.artykul_id,az.cecha1_opis_a,az.cecha1_wartosc_a;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)