# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_boksy_trasy.py
# Purpose:     obsluga grida edytowalnego
# Author:      mariusz rajfura
# Created:     2010/07/16
# RCS-ID:      $Id: fs_boksy_trasy.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2012-10-05 Mariusz Rajfura (6136) nowe pole 'osobny_przerzut'
# 2012-11-16 Mariusz Rajfura (6269) nowe pole 'data_do' i wynikajace stad konsekwecje


#-------------------------------------------------------------------------------

def SprNakladanieDat(self, Fun, Oddzial, Boks, Trasa, TrybDostawy, Data_Od, Data_Do, KluczUpd):
    stat = 'OK'
    SELECT ="SELECT oddzial_id,boks_id,trasa,tryb_dostawy,data,data_do"
    SELECT+=" FROM rs_boksy_trasy_dni"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    SELECT+=" AND boks_id='"+Boks+"' AND trasa='"+Trasa+"' AND tryb_dostawy='"+TrybDostawy+"'"

    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        SELECT+=" AND ("
        SELECT+=" ( data_do IS NOT NULL AND '"+Data_Od+"' >= data AND '"+Data_Od+"' <= data_do )"

        #jesli podano date do
        if Data_Do <> 'NULL':
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            SELECT+=" OR (data_do IS NULL AND data>'"+Data_Od+"' AND data<='"+Data_Do+"' )"

            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            SELECT+=" OR (data_do IS NOT NULL AND data_do>='"+Data_Od+"' AND data_do<='"+Data_Do+"' )"

            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            SELECT+=" OR (data_do IS NOT NULL AND '"+Data_Do+"'>=data AND '"+Data_Do+"'<=data_do)"

        SELECT+=");"

    #sprawdzenie unikalnosci zakresow przed UPDATE
    if Fun in (3,4):
        #wykluczenie z SELECT modyfikowanej pozycji
        # KluczUpd to slownik dla wygody

        SELECT+=" AND NOT (oddzial_id,boks_id,trasa,tryb_dostawy,data,data_do)"
        SELECT+=" IN (('"+KluczUpd['oddzial_id']+"','"+KluczUpd['boks_id']+"',"
        SELECT+=" '"+KluczUpd['trasa']+"','"+KluczUpd['tryb_dostawy']+"',"
        SELECT+=" '"+KluczUpd['data']+"',"
        if KluczUpd['data_do'] in ('    -  -  ','NULL',None,''):
            SELECT+="NULL"
        else:
            SELECT+="'"+KluczUpd['data_do']+"'"
        SELECT += "))"
            
        SELECT+=" AND ("
        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        SELECT+="( data_do IS NOT NULL AND '"+Data_Od+"' >= data AND '"+Data_Od+"' <= data_do )"

        if Data_Do <> 'NULL':
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            SELECT+=" OR (data_do IS NOT NULL AND data >= '"+Data_Od+"' AND data <= '"+Data_Do+"' )"

            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            SELECT+=" OR (data_do IS NOT NULL AND data_do >= '"+Data_Od+"' AND data_do <= '"+Data_Do+"' )"

            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            SELECT+=" OR (data_do IS NOT NULL AND data >= '"+Data_Do+"' AND data_do <= '"+Data_Do+"')"

        SELECT+=");"

    stat,d,dump,dump = self.PolSQL.Execute(SELECT,2)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia pokrywania si zakresw dat w boksach-trasach-dniach: '+stat

    if stat == 'OK':
        if len(d) > 0:
            stat = 'BL DATY_POKRYWAJA'

    return stat

#-------------------------------------------------------------------------------


Oddzial = rsglobal.Dekoduj(klucze[0][0]).strip()
Boks = rsglobal.Dekoduj(klucze[0][1]).strip()
Trasa = rsglobal.Dekoduj(klucze[0][2]).strip()
TrybDostawy = rsglobal.Dekoduj(klucze[0][3]).strip()
Data = rsglobal.Dekoduj(klucze[0][4])

OddzialF = rsglobal.Dekoduj(klucze[1][0]).strip()
BoksF = rsglobal.Dekoduj(klucze[1][1]).strip()
TrasaF = rsglobal.Dekoduj(klucze[1][2]).strip()
TrybDostawyF = rsglobal.Dekoduj(klucze[1][3]).strip()
DataF = rsglobal.Dekoduj(klucze[1][4])

Fun = klucze[-1]

Puste = (None,'')
stat = 'OK'
dane = []

UprIns=((self.oddzial_id,'014233') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'014232') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'014234') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]

rsglobal.ZapiszDoLogow('UPDATE '+str(Update),1)
rsglobal.ZapiszDoLogow('INSERT '+str(Insert),1)
rsglobal.ZapiszDoLogow('DELETE '+str(Delete),1)

#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU TRASY (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat == "OK":
    sql ="SELECT opis FROM rs_trasy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Trasa+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu trasy: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
# POBRANIE LISTY DOZWOLONYCH ODDZIALOW (10)
# Wykorzystane na oknie do informacji o dozwolonym uzyciu filtrowania wg oddzialow
# Wykorzystywane takze przy zwyklym pobieraniu do grida (1,5)
# oraz kopiowaniu (11)
#-------------------------------------------------------------------------------

if Fun in (1,5,10,11) and stat == 'OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
    else:
        sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
        sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
        sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
        sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
        sql+=" ORDER BY o.oddzial_id;"

    stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
    else:
        if len(oddz) == 0:
            stat = 'Brak oddzialw, do ktrych operator ma prawa.'
        else:
            UprOddzialy = '('
            for i in oddz:
                UprOddzialy += "'"+str(i[0])+"',"

            UprOddzialy = UprOddzialy[:-1]+")"

    if Fun == 10 and stat == 'OK':
        dane = oddz


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_boksy_trasy_dni "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                SQLFU = "SELECT boks_id FROM rs_boksy_trasy_dni"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['oddzial_id','boks_id','trasa','tryb_dostawy','data','data_do']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT boks_id FROM rs_boksy_trasy_dni"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                
                #pobranie klucza (oddzial,boks) dla sprawdzenia:
                # - boksu w rs_boksy
                # - poprawnosci dat od-do
                # - zakresu pokrywania sie dat

                sql = "SELECT * FROM rs_boksy_trasy_dni"
                sql+= " WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    sql += " AND "+pole+"='"+str(wart)+"'"
                sql += ";"

                stat,dWiersz,dNagl,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania modyfikowanych danych: '+stat
                    dane.append(stat)
                    break
                elif len(dWiersz) == 0:
                    stat = 'Brak modyfikowanego wiersza w tabeli: '+stat
                    dane.append(stat)
                    break
                elif len(dWiersz) > 1:
                    stat = 'Niejednoznaczny klucz: '+stat
                    dane.append(stat)
                    break
                    
                tr = rssql.RSTableRowset(dWiersz,dNagl)
                
                Oddzial = tr.GetVal(0,'oddzial_id')
                Boks = tr.GetVal(0,'boks_id')
                Trasa = tr.GetVal(0,'trasa')
                TrybDostawy = tr.GetVal(0,'tryb_dostawy')
                Data = tr.GetVal(0,'data')
                DataDo = tr.GetVal(0,'data_do')
                if DataDo == 'None':
                    DataDo = ''
                    
                SprOddzial = Oddzial
                SprBoks = Boks
                SprTrasa = Trasa
                SprTrybDostawy = TrybDostawy
                SprData = Data
                SprDataDo = DataDo
                
                OddzialNowy = None
                BoksNowy = None
                TrasaNowy = None
                TrybDostawyNowy = None
                DataNowy = None
                DataDoNowy = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        OddzialNowy = str(wart)
                        SprOddzial = OddzialNowy
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+Oddzial+"'"
                            sql+=" AND oddzial_id IN "+UprOddzialy+";" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'boks_id':
                        wart = wart.strip()
                        BoksNowy = str(wart)
                        SprBoks = BoksNowy
                        if wart == '':
                            stat = 'BR BOKS'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    elif pole == 'trasa':
                        if wart.strip() == '':
                            stat = 'BR TRASA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            TrasaNowy = wart
                            SprTrasa = TrasaNowy
                            sql ="SELECT kod FROM rs_trasy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)

                    elif pole == 'tryb_dostawy':
                        if wart.strip() == '':
                            stat = 'BR TRYB_DOSTAWY'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        else:
                            TrybDostawyNowy = wart
                            SprTrybDostawy = TrybDostawyNowy
                            sql ="SELECT kod FROM rs_tryby_dostaw"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TRYBY_DOSTAW'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TRYB_DOSTAWY'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)

                    elif pole == 'data':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR DATA'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'BL DATA'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)
                        else:
                            DataNowy = wart
                            SprData = wart

                    elif pole == 'data_do':
                        wart = wart.strip()
                        if wart <> '':
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = 'BL DATA_DO'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)
                            else:
                                DataDoNowy = wart
                                SprDataDo = wart


                #sprawdzenie poprawnosci klucza dla boksu (oddzial,boks)
                #w przypadku zmiany oddzialu lub boksa z uwzgl.uprawnien do oddzialow
                if len(dane) == 0 and (OddzialNowy <> None or BoksNowy <> None):
                    sql ="SELECT boks_id FROM rs_boksy"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    if OddzialNowy <> None:
                        sql+=" AND oddzial_id='"+OddzialNowy+"'"
                    else:
                        sql+=" AND oddzial_id='"+Oddzial+"'"
                    if BoksNowy <> None:
                        sql+=" AND boks_id='"+str(BoksNowy)+"'"
                    else:
                        sql+=" AND boks_id='"+str(Boks)+"'"
                    sql+=" AND oddzial_id IN "+UprOddzialy+";"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                        
                # sprawdzenie poprawnosci dat od-do
                if stat == 'OK' and len(dane) == 0 and not (SprData in Puste or SprDataDo in Puste):
                    if SprData > SprDataDo:
                        dane.append('BL DATA_OD_DO')
                        wyn2.append((WierszeNr[i],7))
                        wyn2.append((WierszeNr[i],8))
                    else:
                        KluczeUpd = {}
                        KluczeUpd['oddzial_id'] = Oddzial
                        KluczeUpd['boks_id'] = Boks
                        KluczeUpd['trasa'] = Trasa
                        KluczeUpd['tryb_dostawy'] = TrybDostawy
                        KluczeUpd['data'] = Data
                        KluczeUpd['data_do'] = DataDo

                        stat = SprNakladanieDat(self,3,SprOddzial,SprBoks,SprTrasa,SprTrybDostawy,SprData,SprDataDo,KluczeUpd)
                        if stat <> 'OK':
                            if stat == 'BL DATY_POKRYWAJA':
                                wyn2.append((WierszeNr[i],7))
                                wyn2.append((WierszeNr[i],8))
                            dane.append(stat)

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_boksy_trasy_dni "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['oddzial_id', 'boks_id', 'trasa', 'tryb_dostawy','data']:
                            SET+=pole+"='"+wart+"',"
    
                        elif pole in ['data_do']:
                            if wart.strip() == '':
                                SET+=pole+"=NULL,"
                            else:
                                SET+=pole+"='"+wart+"',"
                                
                        elif pole in ['osobny_przerzut']:
                            SET+=pole+"="
                            if wart == 0:
                                SET+="FALSE,"
                            else:
                                SET+="TRUE,"
                        
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['oddzial_id', 'boks_id', 'trasa', 'tryb_dostawy','data']:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                OddzialNowy = None
                BoksNowy = None
                TrasaNowy = None
                TrybDostawyNowy = None
                DataNowy = None
                DataDoNowy = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        OddzialNowy = str(wart)
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"'" 
                            sql+=" AND oddzial_id IN "+UprOddzialy+";" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'boks_id':
                        wart = wart.strip()
                        BoksNowy = str(wart)
                        if wart == '':
                            stat = 'BR BOKS'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    elif pole == 'trasa':
                        wart = wart.strip()
                        TrasaNowy = str(wart)
                        if wart == '':
                            stat = 'BR TRASA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_trasy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)

                    elif pole == 'tryb_dostawy':
                        wart = wart.strip()
                        TrybDostawyNowy = str(wart)
                        if wart == '':
                            stat = 'BR TRYB_DOSTAWY'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_tryby_dostaw"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TRYBY_DOSTAW'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TRYB_DOSTAWY'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)

                    elif pole == 'data':
                        wart = wart.strip()
                        DataNowy = str(wart)
                        if wart == '':
                            stat = 'BR DATA'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'BL DATA'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)

                    elif pole == 'data_do':
                        wart = wart.strip()
                        DataDoNowy = str(wart)
                        if wart <> '':
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = 'BL DATA_DO'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)


                #sprawdzam istnienie boksu w podanym oddziale
                # z uwzgl.uprawnien do oddzialow
                if stat == 'OK' and len(dane) == 0 and not (OddzialNowy in Puste or BoksNowy in Puste):
                    sql ="SELECT boks_id FROM rs_boksy"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND oddzial_id='"+OddzialNowy+"'"
                    sql+=" AND boks_id='"+BoksNowy+"'"
                    sql+=" AND oddzial_id IN "+UprOddzialy+";"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                
                #sprawdzam przed dodawaniem, czy podany klucz juz istnieje,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje
                if len(dane) == 0 and not (OddzialNowy in Puste or BoksNowy in Puste or \
                    TrasaNowy in Puste or TrybDostawyNowy in Puste or DataNowy in Puste):
                    sql ="SELECT * FROM rs_boksy_trasy_dni"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND oddzial_id='"+OddzialNowy+"'"
                    sql+=" AND boks_id='"+BoksNowy+"'"
                    sql+=" AND trasa='"+TrasaNowy+"'"
                    sql+=" AND tryb_dostawy='"+TrybDostawyNowy+"'"
                    sql+=" AND data='"+DataNowy+"';"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        wyn2.append((WierszeNr[i],3))
                        wyn2.append((WierszeNr[i],5))
                        wyn2.append((WierszeNr[i],7))
                    elif len(d) > 0:
                        stat = 'BL KLUCZ IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        wyn2.append((WierszeNr[i],3))
                        wyn2.append((WierszeNr[i],5))
                        wyn2.append((WierszeNr[i],7))

                if stat == 'OK' and not (DataNowy in Puste or DataDoNowy in Puste):
                    if DataNowy > DataDoNowy:
                        dane.append('BL DATA_OD_DO')
                        wyn2.append((WierszeNr[i],7))
                        wyn2.append((WierszeNr[i],8))
                        
                    elif not (OddzialNowy in Puste or BoksNowy in Puste or TrasaNowy in Puste or TrybDostawyNowy in Puste):
                        stat = SprNakladanieDat(self,1,OddzialNowy,BoksNowy,TrasaNowy,TrybDostawyNowy,DataNowy,DataDoNowy,{})
                        if stat <> 'OK':
                            if stat == 'BL DATY_POKRYWAJA':
                                wyn2.append((WierszeNr[i],7))
                                wyn2.append((WierszeNr[i],8))
                            dane.append(stat)

                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_boksy_trasy_dni "
                    KOLUMNY="(firma_id"
                    VALUES=" VALUES ('"+self.firma_id+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['oddzial_id','boks_id','trasa','tryb_dostawy','data']:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
    
                        elif pole in ['data_do']:
                            KOLUMNY+=","+pole
                            if wart.strip() == '':
                                VALUES+=",NULL"
                            else:
                                VALUES+=",'"+wart+"'"
    
                        elif pole in ['osobny_przerzut']:
                            KOLUMNY+=","+pole
                            if wart == 0:
                                VALUES+=",FALSE"
                            else:
                                VALUES+=",TRUE"
                        
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                    
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)



#-------------------------------------------------------------------------------
# POBRANIE DO GRIDA DANYCH Z rs_boksy_trasy - kopiowanie z dnia tygodnia (11)
# Data = data_na_kiedy - jest wstawiane od razu do SELECTA
# DataF = dzien_tygodnia 
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    SQL ="SELECT bt.oddzial_id, o.opis, bt.boks_id, bt.trasa, t.opis,"
    SQL+=" bt.tryb_dostawy, td.opis, '"+Data+"'::TEXT"
    SQL+=" FROM rs_boksy_trasy bt"
    SQL+=" LEFT OUTER JOIN rs_oddzialy o USING(firma_id,oddzial_id)"
    SQL+=" LEFT OUTER JOIN rs_trasy t ON (t.firma_id=bt.firma_id AND t.kod=bt.trasa)"
    SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (td.firma_id=bt.firma_id AND td.kod=bt.tryb_dostawy)"
    SQL+=" WHERE bt.firma_id='"+self.firma_id+"'"
    
    if self.operator_id <> STANDARD_OPERATOR:
        SQL+=" AND bt.oddzial_id IN "+UprOddzialy

    #pole DataF zawiera dzien_tygodnia
    SQL+=" AND dzien_tygodnia="+str(DataF)

    if OddzialF <> '':
        SQL+=" AND bt.oddzial_id LIKE '"+OddzialF+"%'"
        
    if BoksF <> '':
        SQL+=" AND bt.boks_id LIKE '"+BoksF+"%'"
        
    if TrasaF <> '':
        SQL+=" AND bt.trasa LIKE '"+TrasaF+"%'"

    if TrybDostawyF <> '':
        SQL+=" AND bt.tryb_dostawy LIKE '"+TrybDostawyF+"%'"

    SQL+=" ORDER BY bt.oddzial_id, bt.boks_id, bt.trasa, bt.tryb_dostawy;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat == 'OK':
    SQL ="SELECT btd.oddzial_id, o.opis, btd.boks_id, btd.trasa, t.opis,"
    SQL+=" btd.tryb_dostawy, td.opis, btd.data, COALESCE(btd.data_do::TEXT,''::TEXT),"
    SQL+=" btd.osobny_przerzut"
    SQL+=" FROM rs_boksy_trasy_dni btd"
    SQL+=" LEFT OUTER JOIN rs_oddzialy o USING(firma_id,oddzial_id)"
    SQL+=" LEFT OUTER JOIN rs_trasy t ON (t.firma_id=btd.firma_id AND t.kod=btd.trasa)"
    SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (td.firma_id=btd.firma_id AND td.kod=btd.tryb_dostawy)"
    SQL+=" WHERE btd.firma_id='"+self.firma_id+"'"
    
    if self.operator_id <> STANDARD_OPERATOR:
        SQL+=" AND btd.oddzial_id IN "+UprOddzialy

    #dane filtru uzywane tylko przy zwyklym odczycie do grida
    if OddzialF <> '':
        SQL+=" AND btd.oddzial_id LIKE '"+OddzialF+"%'"
        
    if BoksF <> '':
        SQL+=" AND btd.boks_id LIKE '"+BoksF+"%'"
        
    if TrasaF <> '':
        SQL+=" AND btd.trasa LIKE '"+TrasaF+"%'"

    if TrybDostawyF <> '':
        SQL+=" AND btd.tryb_dostawy LIKE '"+TrybDostawyF+"%'"

    if DataF <> '    -  -  ':
        SQL+=" AND btd.data='"+DataF+"'"

    SQL+=" ORDER BY btd.oddzial_id, btd.boks_id, btd.trasa, btd.tryb_dostawy, btd.data;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)