# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_cennik.py
# Purpose:     pobiera ceny dla wersji/kontrahenta
# Author:      Marcin Grzeda, Micha Raburski
# Created:     2007/01/13
# Modified:    2010/12/04
# RCS-ID:      $Id: fs_cennik.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2010.12.04 Micha Raburski (4124) dodanie kontrahenta w filtrach i dodatkowe kolumny. Cakowita przerbka funkcji
# 2012-06-25 Mariusz Rajfura "profesjonalny" wydruk cennika ;-)
# 2022-03-17 Wojciech Skowron (12940) ceny dla kontrahenta

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if isinstance(klucze, list):
    Wersja = rsglobal.Dekoduj(klucze[0]).strip()
    Kontr = rsglobal.Dekoduj(klucze[1]).strip()
    Waluta = rsglobal.Dekoduj(klucze[2]).strip()
    Data = rsglobal.Dekoduj(klucze[3])
    Kateg = rsglobal.Dekoduj(klucze[4]).strip()
    AktywneNaDowodach = klucze[5]
    TypyArtykulow = rsglobal.Dekoduj(klucze[6]).strip()
    Niezerowe = klucze[7]
    Fun = klucze[-1]
else:
    #WS 2022-03-17
    if 'Funkcja' not in klucze:
        stat = 'Brak podanej funkcji w kluczach'
    if stat == 'OK':
        Fun = klucze['Funkcja']
        SlPar = {'Nagl': [11], 'Dane': [11]}
        Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
        if Lista != '':
            stat = 'Uwaga : wywoanie funkcji fs_cenniki '+str(Fun)+' bez parametrw: '+Lista

    if stat == 'OK' and Fun in [11]:
        Dane = klucze['Dane']
        Nagl = klucze['Nagl']

#-------------------------------------------------------------------------------
#---- Sprawdzenie
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 1:
    if Wersja=='' and Kontr=='':
        stat='BR WER KONTR'
    elif Waluta=='':
        stat='BR WAL'
    elif Data=='':
        stat='BR DAT'
    elif not rsglobal.SprawdzCzyToData(Data):
        stat='BL DAT'
        dane.append(stat)
    elif Wersja <>'':
        SQL= "SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+Wersja+"';"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest)==0:
                stat='BL WER'
    elif Kontr <>'':
        SQL= "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest)==0:
                stat='BL KONTR'
    else:
        SQL= "SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+Waluta+"';"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest)==0:
                stat='BL WAL'

    if stat=='OK':
        SQL="SELECT a.artykul_id,a.nazwa,'"+Waluta+"',"

        if Wersja<> '':
            SQL+="ac.wersja,ac.data_od,ac.cena_netto1,ac.cena_brutto1,"
            SQL+="ac.cena_netto2,ac.cena_brutto2,"
        else:
            SQL+="COALESCE(kf.wersja,''),kf.data_od,"
            SQL+="rsf_podaj_cene_dla_kontrahenta(a.firma_id,'"+Kontr+"','"+Waluta+"','"+Data+"',a.artykul_id,'n1u','',-1),"
            SQL+="rsf_podaj_cene_dla_kontrahenta(a.firma_id,'"+Kontr+"','"+Waluta+"','"+Data+"',a.artykul_id,'b1u','',-1),"
            SQL+="rsf_podaj_cene_dla_kontrahenta(a.firma_id,'"+Kontr+"','"+Waluta+"','"+Data+"',a.artykul_id,'n2u','',-1),"
            SQL+="rsf_podaj_cene_dla_kontrahenta(a.firma_id,'"+Kontr+"','"+Waluta+"','"+Data+"',a.artykul_id,'b2u','',-1),"

        SQL+="COALESCE(av.stawka_vat,''),COALESCE(av.sww_pkwiu,''),COALESCE(ao1.obcy_id,ao2.obcy_id,''),COALESCE(aean.ean,''),COALESCE(aop.ilosc1,0)"

        SQL+=",oz.opis, aop.pojemnosc_paletowa "
        SQL+=" FROM rs_artykuly a "
        if Wersja<>'':
            SQL+=" INNER JOIN rs_artykuly_ceny ac ON (a.firma_id=ac.firma_id AND a.artykul_id=ac.artykul_id "
            SQL+=" AND ac.data_od=(SELECT max(k.data_od) FROM rs_artykuly_ceny k WHERE k.firma_id=ac.firma_id AND k.artykul_id=ac.artykul_id AND k.wersja=ac.wersja AND k.waluta=ac.waluta AND k.data_od<='"+Data+"')) "
        else:
            SQL+=" LEFT OUTER JOIN rs_kontrahenci_fakturowanie kf ON (kf.firma_id='"+self.firma_id+"' AND kf.kontrahent_id='"+Kontr+"'"
            SQL+=" AND kf.data_od=(SELECT max(k.data_od) FROM rs_kontrahenci_fakturowanie k WHERE k.firma_id=kf.firma_id AND k.kontrahent_id=kf.kontrahent_id AND k.data_od<='"+Data+"')) "

        SQL+=" LEFT OUTER JOIN rs_artykuly_stawki_vat av ON (a.firma_id=av.firma_id AND a.artykul_id=av.artykul_id"
        SQL+=" AND av.od_dnia=(SELECT max(k.od_dnia) FROM rs_artykuly_stawki_vat k WHERE k.firma_id=av.firma_id AND k.artykul_id=av.artykul_id AND k.od_dnia<='"+Data+"'))"

        SQL+=" LEFT OUTER JOIN rs_artykuly_obce ao1 ON (a.firma_id=ao1.firma_id AND a.artykul_id=ao1.artykul_id "
        SQL+=" AND ao1.kontrahent_id=(SELECT platnik_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"'))"
        SQL+=" LEFT OUTER JOIN rs_artykuly_obce ao2 ON (a.firma_id=ao2.firma_id AND a.artykul_id=ao2.artykul_id AND ao2.kontrahent_id='"+Kontr+"')"

        SQL+=" LEFT OUTER JOIN rs_artykuly_ean aean ON (a.firma_id=aean.firma_id AND a.artykul_id=aean.artykul_id AND aean.glowny)"

    #    SQL+=" LEFT OUTER JOIN rs_artykuly_opakowania_zbiorcze aop ON (a.firma_id=aop.firma_id AND a.artykul_id=aop.artykul_id AND aop.opakowanie_id='01')"
        SQL+=" LEFT OUTER JOIN rs_artykuly_opakowania_zbiorcze aop ON (a.firma_id=aop.firma_id AND a.artykul_id=aop.artykul_id)"
        SQL+=" LEFT OUTER JOIN rs_opakowania_zbiorcze oz ON (a.firma_id=oz.firma_id AND oz.kod=aop.opakowanie_id) "

        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.aktywny "

        if Wersja<>'':
            SQL+=" AND ac.wersja='"+Wersja+"' AND ac.waluta='"+Waluta+"' "
        else:
            SQL+=" AND kf.kontrahent_id='"+Kontr+"' "

        if Kateg<>'':
            SQL+=" AND a.kateg_artykulu='"+Kateg+"' "

        if AktywneNaDowodach:
            SQL+=" AND a.artykul_id IN ("
            if Kontr<>'':
                SQL+="SELECT DISTINCT ddp.artykul_id FROM rs_dowody_dostaw_pozycje ddp"
                SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)"
                SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND dd.kontrahent_id='"+Kontr+"'"
                SQL+=" AND ddp.data BETWEEN '"+Data+"'::DATE-INTERVAL '30 DAYS' AND '"+Data+"'::DATE"
            else:
                SQL+="SELECT DISTINCT artykul_id FROM rs_dowody_dostaw_pozycje"
                SQL+=" WHERE firma_id='"+self.firma_id+"'"
                SQL+" AND data BETWEEN '"+Data+"'::DATE-INTERVAL '30 DAYS' AND '"+Data+"'::DATE"
            SQL+=")"

        if TypyArtykulow<>'':
            SQL+=" AND a.typ_artykulu IN ("
            typy = TypyArtykulow.split(',')
            for i in xrange(len(typy)):
                if i > 0:
                    SQL+=","
                SQL+="'"+typy[i]+"'"
            SQL+=")"

        SQL+=" ORDER BY artykul_id;"

        stat,dane1,wyn1,tr = self.PolSQL.Execute(SQL,3)

        if stat == 'OK':
            if Niezerowe:
                # pobranie pozycji z cenami niezerowymi
                dane = []
                for i in xrange(len(dane1)):
                    if dane1[i][5] <> 0:
                        # jesli cena netto 1 (ogolna lub pobrana przez funkcje rsf) <> 0
                        dane.append(dane1[i])
            else:
                dane = dane1

        if stat == 'OK':
            wyn2 = [-1]
            if Wersja <> '':
                sql = "SELECT po_przecinku FROM rs_wersje_cenowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Wersja+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sql,2 )
                if stat=='OK':
                    if d:
                        wyn2 = d[0]

        if stat == 'OK':
            # lista artykulow objetych promocja czyli posiadajace upust / rabat
            # (do kolorowania grida, wytluszczenia druku)
            # nie podajemy numerow wierszy tylko symbole artykulow,
            # bo moze byc zmiana sortowania grida w oknie
            ArtProm = []

            if Kontr<>'':
                # artykuly z promocjami / upustami / rabatami
                sql = "SELECT a.artykul_id FROM rs_artykuly a"
                sql+=" WHERE a.firma_id='"+self.firma_id+"' AND a.aktywny"
                sql+=" AND ("

                # artykuly posiadajace upust dla klienta z okresie od-do
                sql+=" a.artykul_id IN ("
                sql+="  SELECT DISTINCT artykul_id FROM rs_kontrahenci_upusty"
                sql+="  WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"'"
                sql+="  AND '"+Data+"'::DATE>=data_od"
                sql+="  AND CASE WHEN data_do IS NULL THEN TRUE ELSE '"+Data+"'::DATE<=data_do END)"

                # lub ;-)
                sql+=" OR "

                # artykuly z kategorii posiadajacej upust w okresie od-do
                sql+=" a.kateg_artykulu IN ("
                sql+="  SELECT DISTINCT kateg_artykulu FROM rs_kontrahenci_upusty_kateg"
                sql+="  WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"'"
                sql+="  AND '"+Data+"'::DATE>=data_od"
                sql+="  AND CASE WHEN data_do IS NULL THEN TRUE ELSE '"+Data+"'::DATE<=data_do END)"

                sql+=");"

                stat,ArtProm,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania artykuw z promocjami: '+stat

        if stat == 'OK':
            wyn2.append(ArtProm)

#-------------------------------------------------------------------------------
#---- Ceny dla kontrahenta - pobranie danych
#-------------------------------------------------------------------------------

#WS 2022-03-17
if stat == 'OK' and Fun == 15:
    SEL = """SELECT DISTINCT ON (firma_id, oddzial_id, kontrahent_id, artykul_id) 
                    c.kontrahent_id, k.nazwa as nazwa_kontrahenta, c.artykul_id, a.nazwa as nazwa_art, 
                    c.oddzial_id, c.cena_netto1, 0::NUMERIC(16,2) as nowa_cena, '' as data_od
             FROM rs_kontrahenci_ceny c
             JOIN rs_artykuly a USING (firma_id, artykul_id)
             JOIN rs_kontrahenci k USING (firma_id, kontrahent_id)
             WHERE firma_id='{self.firma_id}' AND a.aktywny AND k.aktywny 
             ORDER BY firma_id, oddzial_id, kontrahent_id, artykul_id, c.data_od DESC;""".format(**locals())
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3)

#-------------------------------------------------------------------------------
#---- Ceny dla kontrahenta - zapis danych
#-------------------------------------------------------------------------------

#WS 2022-03-17
if stat == 'OK' and Fun == 11:
    nieudane = 0

    dane_zapis = rssql.RSTableRowset2(Dane, Nagl)
    for wiersz in dane_zapis:
        if stat == 'OK' and wiersz['nowa_cena'] > 0 and wiersz['data_od'] not in ('', '    -  -  '):
            przelicznik = 0
            stawka_vat = 0

            SEL_VAT = """SELECT rsf_podaj_vat_artykulu('{firma_id}','{artykul_id}','{data_od}');
                      """.format(firma_id=self.firma_id,
                                 artykul_id=wiersz['artykul_id'],
                                 data_od=wiersz['data_od'])
            stat, d_vat, dump, dump = self.PolSQL.Execute(SEL_VAT, 3)
            if stat != 'OK':
                stat = 'Bd pobrania stawki VAT dla artykuu: '+stat

            if stat == 'OK':
                SEL_PRZEL = """SELECT przelicznik 
                               FROM rs_artykuly 
                               WHERE firma_id='{firma_id}' AND artykul_id='{artykul_id}';
                            """.format(firma_id=self.firma_id,
                                       artykul_id=wiersz['artykul_id'])
                stat, d_przel, dump, dump = self.PolSQL.Execute(SEL_PRZEL, 3)
                if stat != 'OK':
                    stat = 'Bd pobrania przelicznika dla artykuu: '+stat

            if stat == 'OK':
                stawka_vat = int(d_vat[0][0]) if d_vat[0][0].isdigit() else 0
                przelicznik = d_przel[0][0]
                VALUES = """('{firma_id}', '{kontrahent_id}', '{artykul_id}', '{oddzial_id}', '{data_od}', 
                              {cena_netto1}, {cena_brutto1}, {cena_netto2}, {cena_brutto2}); 
                         """.format(firma_id=self.firma_id,
                                    kontrahent_id=wiersz['kontrahent_id'],
                                    artykul_id=wiersz['artykul_id'],
                                    oddzial_id=wiersz['oddzial_id'],
                                    data_od=wiersz['data_od'],
                                    cena_netto1=wiersz['nowa_cena'],
                                    cena_brutto1=rsglobal.RSRound(wiersz['nowa_cena']*(100+stawka_vat)*0.01, 2),
                                    cena_netto2=rsglobal.RSRound(wiersz['nowa_cena']*przelicznik, 2),
                                    cena_brutto2=rsglobal.RSRound(wiersz['nowa_cena']*przelicznik*(100+stawka_vat)*0.01, 2))

            if stat == 'OK':
                INS = "INSERT INTO rs_kontrahenci_ceny (firma_id, kontrahent_id, artykul_id, oddzial_id, data_od, " \
                      "cena_netto1, cena_brutto1, cena_netto2, cena_brutto2) VALUES "+VALUES+";"
                rsglobal.ZapiszDoLogow(INS)
                stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    nieudane += 1
                    wyn2.append([wiersz['kontrahent_id'], wiersz['artykul_id'], wiersz['oddzial_id']])
                    stat = 'OK'
                else:
                    self.PolSQL.Commit()
