#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_cennik_przeliczanie.py
# Purpose:          przelicza cennik
# Author:           Marcin Grzeda
# Created:          2007/05/10
# RCS-ID:           $Id: fs_cennik_przeliczanie.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------
# Marcin Natkaski 2012-10-12 - refaktoryzacja (mantis: 4158)
# Mariusz Rajfura 2011-02-22 - uwzglednienie ceny netto/brutto wg wersji cenowej (4283)

PoPrzecinku = 2
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'KategArtykulu':[1],'WersjaWejsciowa':[1],'WalutaWejsciowa':[1],'WersjaWyjsciowa':[1],
            'WalutaWyjsciowa':[1],'Przelicznik':[1],'DataOd':[1] }    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_cennik_przeliczanie z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    
    if Fun in [1,]:
        KategArtykulu = rsglobal.Dekoduj(klucze['KategArtykulu'])
        WersjaWejsciowa = rsglobal.Dekoduj(klucze['WersjaWejsciowa'])
        WalutaWejsciowa = rsglobal.Dekoduj(klucze['WalutaWejsciowa'])
        WersjaWyjsciowa = rsglobal.Dekoduj(klucze['WersjaWyjsciowa'])
        WalutaWyjsciowa = rsglobal.Dekoduj(klucze['WalutaWyjsciowa'])
        Przelicznik = klucze['Przelicznik']
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        
dane = []

if not (((self.oddzial_id,'016014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
    stat='UPR PRZELI'
    
if Fun==1 and stat=='OK':
    if KategArtykulu<>'':
        sql ="SELECT kod FROM rs_kateg_artykulow"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+KategArtykulu+"';"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(d)<1:
                stat='BL KATEG'
                dane.append(stat)
        else:
            stat='BL SQL KATEG'
            dane.append(stat)
        
    if WersjaWejsciowa=='':
        stat='BR WERSJA1'
        dane.append(stat)
    if stat=='OK':
        sql ="SELECT kod FROM rs_wersje_cenowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+WersjaWejsciowa+"';"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL SQL WERSJA1$'+stat 
            dane.append(stat)
        if stat=='OK':
            if len(d)==0:
                stat='BL WERSJA1'
                dane.append(stat)
                
    if WalutaWejsciowa=='':
        stat='BR WALUTA1'
        dane.append(stat)
    if stat=='OK':
        sql="SELECT kod FROM rs_waluty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+WalutaWejsciowa+"';"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3) 
        if stat<>'OK':
            stat='BL SQL WALUTA1$'+stat
            dane.append(stat)        
        if stat=='OK':
            if len(d)==0:
                stat='BL WALUTA1'
                dane.append(stat)
        
    if WersjaWyjsciowa=='':
        stat='BR WERSJA2'
        dane.append(stat)
    if stat=='OK':               
        sql ="SELECT kod, po_przecinku, czy_cena_brutto"
        sql+=" FROM rs_wersje_cenowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+WersjaWyjsciowa+"';"
        stat,dWersjaWyj,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL SQL WERSJA2'
            dane.append(stat)           
        if stat=='OK':
            if len(dWersjaWyj)==0:
                stat='BL WERSJA2'
                dane.append(stat)
            elif 0 <= dWersjaWyj[0][1] <= 4:
                PoPrzecinku = dWersjaWyj[0][1]
            
    if WalutaWyjsciowa=='':
        stat='BR WALUTA2'
        dane.append(stat)
    if stat=='OK':     
        sql ="SELECT kod FROM rs_waluty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+WalutaWyjsciowa+"';"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL SQL WALUTA2'
            dane.append(stat)
        if stat=='OK':
            if len(d)==0:
                stat='BL WALUTA2'
                dane.append(stat)
        
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat='BL DAT'
        dane.append(stat)
        
    if stat=='OK':
        SelectKateg=''
        if KategArtykulu.strip()<>'':
            SelectKateg="AND art.kateg_artykulu LIKE '"+KategArtykulu+"' "
        
        SelectDataOd="(SELECT MAX(data_od) FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"'"
        SelectDataOd+=" AND artykul_id=a.artykul_id AND wersja='"+WersjaWejsciowa+"' AND waluta='"+WalutaWejsciowa+"'"
        SelectDataOd+=" AND data_od<='"+DataOd+"')"
        
        StawkaVAT="COALESCE((SELECT stawka_vat FROM rs_artykuly_stawki_vat WHERE firma_id=art.firma_id "
        StawkaVAT+=" AND artykul_id=art.artykul_id AND od_dnia<='"+DataOd+"' ORDER BY od_dnia DESC LIMIT 1),'BRAK')"
        
        SEL ="SELECT artykul_id,round(cena_netto1*"+str(Przelicznik)+","+str(PoPrzecinku)+"),"
        SEL+=" round(cena_brutto1*"+str(Przelicznik)+","+str(PoPrzecinku)+"),art.przelicznik,"+StawkaVAT
        SEL+=" FROM rs_artykuly_ceny a INNER JOIN rs_artykuly art USING (firma_id,artykul_id) "
        SEL+=" WHERE firma_id='"+self.firma_id+"' AND wersja='"+WersjaWejsciowa+"'"
        SEL+=" AND waluta='"+WalutaWejsciowa+"' "+SelectKateg+" AND "+SelectDataOd+"=a.data_od;"
        stat,DaneCen,dump,dump=self.PolSQL.Execute(SEL,3)    
        if stat=='OK':
            if len(DaneCen)==0:
                stat='BRAK DANYCH'
                dane.append(stat)
        if stat=='OK':
            for w in DaneCen:
                Art = rsglobal.Dekoduj(w[0]).strip()
                CenaN1 = w[1]
                CenaB1 = w[2]
                Przel = w[3]
                StVAT = w[4]
                
                if StVAT=='BRAK':
                    stat='Nie mona wyznaczy stawki VAT dla artykuu : '+Art
                    dane.append(stat)
                    break
                    
                if stat=='OK':
                    if StVAT in self.ListaStawekZn:
                        Stawka = 0
                    else:
                        Stawka = int(StVAT)
    
                    if dWersjaWyj[0][2]:
                        # wg cen brutto
                        CenaB1=rsglobal.RSRound(CenaB1, PoPrzecinku)
                        CenaB2=rsglobal.RSRound(CenaB1/Przel, PoPrzecinku)
                    
                        CenaN1=rsglobal.RSRound(CenaB1*100/(100+Stawka), PoPrzecinku)
                        CenaN2=rsglobal.RSRound(CenaB2*100/(100+Stawka), PoPrzecinku)
    
                    else:
                        # wg cen netto
                        CenaN1=rsglobal.RSRound(CenaN1, PoPrzecinku)
                        CenaN2=rsglobal.RSRound(CenaN1/Przel, PoPrzecinku)
                    
                        CenaB1=rsglobal.RSRound(CenaN1*(100+Stawka)*0.01, PoPrzecinku)
                        CenaB2=rsglobal.RSRound(CenaN2*(100+Stawka)*0.01, PoPrzecinku)
                    
                    
                    Sql ="SELECT artykul_id FROM rs_artykuly_ceny"
                    Sql+=" WHERE firma_id='"+self.firma_id+"' AND wersja='"+WersjaWyjsciowa+"'" 
                    Sql+=" AND waluta='"+WalutaWyjsciowa+"' AND artykul_id='"+Art+"'"
                    Sql+=" AND data_od='"+DataOd+"';"
                    
                    stat,d_f,dump,dump=self.PolSQL.Execute(Sql,3)
                    if stat <> 'OK':
                        stat = "Bd pobrania ceny dla artykuu "+Art+": "+stat
                        dane.append(stat)
                        break
                    
                    if len(d_f)>0:
                        Upd ="UPDATE rs_artykuly_ceny SET cena_netto1="+str(CenaN1)+","
                        Upd+=" cena_brutto1="+str(CenaB1)+",cena_netto2="+str(CenaN2)+","
                        Upd+=" cena_brutto2="+str(CenaB2)
                        Upd+=" WHERE firma_id='"+self.firma_id+"' AND wersja='"+WersjaWyjsciowa+"'"
                        Upd+=" AND waluta='"+WalutaWyjsciowa+"' AND artykul_id='"+Art+"'"
                        Upd+=" AND data_od='"+DataOd+"';"
                        
                        stat,dump,dump,dump=self.PolSQL.Execute(Upd,1)
                        if stat<>'OK':
                            stat='Wystpiy bdy modyfikacji ceny artykuu '+Art+' : '+stat
                            dane.append(stat)
                            break
                        
                    else:
                        Ins ="INSERT INTO rs_artykuly_ceny"
                        Ins+=" (firma_id,artykul_id,wersja,"
                        Ins+="  waluta,data_od,cena_netto1,"
                        Ins+="  cena_brutto1,cena_netto2,cena_brutto2) "
                        Ins+=" VALUES"
                        Ins+=" ('"+self.firma_id+"','"+Art+"','"+WersjaWyjsciowa+"',"
                        Ins+="  '"+WalutaWyjsciowa+"','"+DataOd+"',"+str(CenaN1)+","
                        Ins+="  "+str(CenaB1)+","+str(CenaN2)+","+str(CenaB2)+");"
                        
                        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
                        if stat <> 'OK':
                            stat = 'Wystpiy bdy z dodaniem ceny artykuu '+Art+' : '+stat
                            dane.append(stat)
                            break