#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_cennik_przeliczanie_wzgl_vat.py
# Purpose:          przelicza artykuy wzgldem vat
# Author:           Micha Raburski
# Created:          2012/07/10
# RCS-ID:           $Id: fs_cennik_przeliczanie_wzgl_vat.py $
# Copyright:        (c) 2012 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
#-- FUNKCJA POBIERAJCA DANE STAWEK VAT ARTYKUU
#-------------------------------------------------------------------------------

def PodajDaneVATArtykulu(self,Art):
    # (s do sortowania bo vat musi by pierwszy w dacie)
    SQL="SELECT od_dnia,'s',"
    SQL+=" CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE stawka_vat::INTEGER END "
    SQL+=" FROM rs_artykuly_stawki_vat "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
    SQL+=" ORDER BY od_dnia"
    stat,DaneVAT,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd pobrania stawek vat dla artykuu "+Art.strip()+": "+stat
    return stat,DaneVAT
                    

#-------------------------------------------------------------------------------
#-- FUNKCJA DO ZMIANY CEN DlA JEDNEGO ARTYKUU I WERSJI/KONTRAHENTW
#-------------------------------------------------------------------------------

def PrzeliczCenyDlaArtykuluWersji(self,Artykul,Tabela,WerLubKontr,Waluta,PoPrzecinku,CzyBrutto,Przelicznik,DaneCen,DaneVAT):
    # struktura DaneCen to data_od,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2
    # struktura DaneVAT to od_dnia,stawka_vat
    # na razie zakadam, e relacja odpowiednich cen netto lub brutto wzgldem siebie jest poprawna i mog zignorowa
    # przelicznik
    if len(DaneVAT)==0:
        return "Brak danych o stawkach VAT w artykule "+Artykul.strip()
    if len(DaneCen)==0:
        return "OK"

    # zalepkowa data dodana by ewentualna zmiana vat si wykonaa nawet jeli nie ma po niej zmiany ceny
    DaneCen.append(['3999-01-01','w',0,0,0,0])
    
    # pobieramy pierwszy VAT dla artykuu i zakadamy e by obowizujcy od poczatku wiata.
    ZmianaVAT=False
    VAT=DaneVAT[0][2]
    DataVAT=''
    DataOd=''
    
    # czymy dane z Cen I VAT. Ustawione jest to datami i jeli zmiana vat jest tego samego dnia 
    # co zmiana ceny to pierwszy jest vat, ktry tego dnia ju powinien obowizywa
    LDane=DaneVAT+DaneCen
    LDane.sort()
    
    for poz in LDane:
        # zmiana stawki vat
        if poz[1]=='s':
            # jeli zmieni si vat liczbowo (np. 0 na zw nie zmieni)
            if VAT <> poz[2]:
                DataVAT=poz[0]
                VAT=poz[2]
                ZmianaVAT=True
                
        if poz[1]=='w':
            # to zmiana cen dla wersji lub kontrahenta.
            # jeli dodatkowo przed chwil zmieni si VAT to jeli aktualna cena jest pniejsza ni zmiana VAT to
            # trzeba doda cen ze zmienionym VATem pomidzy cenami. Jeli jest rwna zmianie VAT
            # to wystarczy normalne sprawdzenie czy ceny s zgodne z vatem (i tak je trzeba zrobi)
            if ZmianaVAT:
                ZmianaVAT=False
                # jeli nie byo adnej ceny wczeniej to te nie przeliczamy
                if DataVAT<poz[0] and DataOd<>'':
                    # dodatkowy insert na ceny (zmiana VAT daje pewno e ceny si zmieniaj)
                    # Zmienne NCena s po poprzedniej pozycji i s aktualne
            
                    # przeliczenie cen
                    if CzyBrutto:
                        # dla wersji brutto
                        NCenaN1=rsglobal.RSRound((NCenaB1*100)/(100+VAT),PoPrzecinku)
                        NCenaN2=rsglobal.RSRound((NCenaB2*100)/(100+VAT),PoPrzecinku)
                    else:
                        # dla wersji netto/kontrahenta
                        NCenaB1=rsglobal.RSRound(NCenaN1*(100+VAT)*0.01,PoPrzecinku)
                        NCenaB2=rsglobal.RSRound(NCenaN2*(100+VAT)*0.01,PoPrzecinku)
                
                    SQL="INSERT INTO "+Tabela+" (firma_id,artykul_id,"
                    if Tabela=='rs_artykuly_ceny':
                        SQL+="wersja,"
                    else:
                        SQL+="kontrahent_id,"
                    SQL+="waluta,data_od,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2)"
                    SQL+=" VALUES ('"+self.firma_id+"','"+Artykul+"','"+WerLubKontr+"','"+Waluta+"','"+DataVAT+"',"
                    SQL+=str(NCenaN1)+","+str(NCenaN2)+","+str(NCenaB1)+","+str(NCenaB2)+");"
                    
                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    if stat <> 'OK':
                        return "Bd inserta zwizanego ze zmian VAT dla artykuu "+Artykul.strip()+" na dzie "+DataVAT+" dla wersji/kontrahenta "+WerLubKontr+": "+stat
                    
            #-------------------
            # sprawdzenie czy cena jest zgodna z obowizujcym VATem a jeli nie to zmiana
            #-------------------
            if not poz[0]=='3999-01-01':
                # aktualne data i ceny w bazie
                DataOd=poz[0]
                CenaN1=rsglobal.RSRound(poz[2],PoPrzecinku)
                CenaN2=rsglobal.RSRound(poz[3],PoPrzecinku)
                CenaB1=rsglobal.RSRound(poz[4],PoPrzecinku)
                CenaB2=rsglobal.RSRound(poz[5],PoPrzecinku)
                
                # te zmienne su do przeliczenia i porwnania czy trzeba zmienia cen
                NCenaN1=rsglobal.RSRound(poz[2],PoPrzecinku)
                NCenaN2=rsglobal.RSRound(poz[3],PoPrzecinku)
                NCenaB1=rsglobal.RSRound(poz[4],PoPrzecinku)
                NCenaB2=rsglobal.RSRound(poz[5],PoPrzecinku)
                
                # przeliczenie cen
                if CzyBrutto:
                    # dla wersji brutto
                    NCenaN1=rsglobal.RSRound((NCenaB1*100)/(100+VAT),PoPrzecinku)
                    NCenaN2=rsglobal.RSRound((NCenaB2*100)/(100+VAT),PoPrzecinku)
                else:
                    # dla wersji netto/kontrahenta
                    NCenaB1=rsglobal.RSRound(NCenaN1*(100+VAT)*0.01,PoPrzecinku)
                    NCenaB2=rsglobal.RSRound(NCenaN2*(100+VAT)*0.01,PoPrzecinku)
                    
                # jeli s rnice to robimy update
                if CenaN1<>NCenaN1 or CenaN2<>NCenaN2 or CenaB1<>NCenaB1 or CenaB2<>NCenaB2:
                    SQL="UPDATE "+Tabela+" SET cena_netto1="+str(NCenaN1)+",cena_netto2="+str(NCenaN2)+","
                    SQL+="cena_brutto1="+str(NCenaB1)+",cena_brutto2="+str(NCenaB2)
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND data_od='"+DataOd+"' AND waluta='"+Waluta+"'"
                    SQL+=" AND artykul_id='"+Artykul+"'"
                    if Tabela=='rs_artykuly_ceny':
                        SQL+=" AND wersja='"+WerLubKontr+"';"
                    else:
                        SQL+=" AND kontrahent_id='"+WerLubKontr+"';"
                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    if stat <> 'OK':
                        return "Bd update na cenach dla artykuu "+Artykul.strip()+" na dzie "+DataOd+" dla wersji/kontrahenta "+WerLubKontr+": "+stat
            
    return 'OK'





#-##############################################################################
#--  GWNA CZʦ OKNA 
#-##############################################################################

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Artykul':[1]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_cennik_przeliczanie_wzgl_vat z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1]:
        Artykul=rsglobal.Dekoduj(klucze['Artykul'])


if not self.operator_id == STANDARD_OPERATOR_ID and Artykul=='':
    stat='Brak uprawnie do przeliczenia cennikw wzgldem vat - moe to robi tylko administrator'

#-------------------------------------------------------------------------------
#-- PRZELICZENIE CENNIKW DLA ARTYKUU (LUB WSZYSTKICH) WZGLDEM VAT (1)
#-------------------------------------------------------------------------------
        
if stat=='OK' and Fun==1:
    # na pocztek pobieramy pary artyku/wersja gdy kad z nich zajmiemy si oddzielnie
    SQL="SELECT DISTINCT ac.artykul_id,ac.wersja,ac.waluta,wc.po_przecinku,wc.czy_cena_brutto,a.przelicznik" 
    SQL+=" FROM rs_artykuly_ceny ac "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+=" INNER JOIN rs_wersje_cenowe wc ON (ac.firma_id=wc.firma_id AND ac.wersja=wc.kod)"
    SQL+=" WHERE ac.firma_id='"+self.firma_id+"' AND a.aktywny"
    if Artykul<>'':
        SQL+=" AND ac.artykul_id='"+Artykul+"'"
    SQL+=" ORDER BY ac.artykul_id,ac.wersja"
    
    stat,DArtWer,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd pobrania artykuw i wersji: "+stat
    
    if stat=='OK':
        # dla kazdego wiersza robimy osobne przetwarzanie
        ArtS=''
        DaneVAT=[]
        for poz in DArtWer:
            if stat=='OK':
                Art=rsglobal.Dekoduj(poz[0])
                if Art<>ArtS:
                    stat,DaneVAT=PodajDaneVATArtykulu(self,Art)
                        
            if stat=='OK':    
                Wersja=rsglobal.Dekoduj(poz[1])
                Waluta=rsglobal.Dekoduj(poz[2])
                PoPrzecinku=poz[3]
                CzyBrutto=poz[4]
                Przelicznik=poz[5]

                # pobranie danych do wersji cenowej (w do sortowania bo vat musi by pierwszy w dacie)
                SQL="SELECT data_od,'w',cena_netto1,cena_netto2,cena_brutto1,cena_brutto2"
                SQL+=" FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
                SQL+=" AND wersja='"+Wersja+"' AND waluta='"+Waluta+"' ORDER BY data_od"
                stat,DaneCen,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = "Bd pobrania cen dla wersji cenowej: "+stat
            
            if stat=='OK':
                stat=PrzeliczCenyDlaArtykuluWersji(self,Art,'rs_artykuly_ceny',Wersja,Waluta,PoPrzecinku,CzyBrutto,Przelicznik,DaneCen,DaneVAT)
                
    if stat=='OK':        
        # pobranie artykuw/kontrahentw do przeliczenia cen kontrahentow
        # ceny kontrahentw traktujemy jak wersje netto
        SQL="SELECT DISTINCT kc.artykul_id,kc.kontrahent_id,kc.waluta,2,FALSE,a.przelicznik" 
        SQL+=" FROM rs_kontrahenci_ceny kc "
        SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE kc.firma_id='"+self.firma_id+"' AND a.aktywny"
        if Artykul<>'':
            SQL+=" AND kc.artykul_id='"+Artykul+"'"
        SQL+=" ORDER BY kc.artykul_id,kc.kontrahent_id"
    
        stat,DArtKontr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd pobrania artykuw i wersji: "+stat

                
    if stat=='OK':
        for poz in DArtKontr:
            if stat=='OK':
                Art=rsglobal.Dekoduj(poz[0])
                stat,DaneVAT=PodajDaneVATArtykulu(self,Art)

            if stat=='OK':    
                Kontr=rsglobal.Dekoduj(poz[1])
                Waluta=rsglobal.Dekoduj(poz[2])
                PoPrzecinku=poz[3]
                CzyBrutto=poz[4]
                Przelicznik=poz[5]

                # pobranie danych do cen kontrahenta (w do sortowania bo vat musi by pierwszy w dacie)
                SQL="SELECT data_od,'w',cena_netto1,cena_netto2,cena_brutto1,cena_brutto2"
                SQL+=" FROM rs_kontrahenci_ceny WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
                SQL+=" AND kontrahent_id='"+Kontr+"' AND waluta='"+Waluta+"' ORDER BY data_od"
                
                stat,DaneCen,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = "Bd pobrania cen dla kontrahenta: "+stat
            
            if stat=='OK':
                stat=PrzeliczCenyDlaArtykuluWersji(self,Art,'rs_kontrahenci_ceny',Kontr,Waluta,PoPrzecinku,CzyBrutto,Przelicznik,DaneCen,DaneVAT)                        
                
                
                
