# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_crm_rozliczenie_prowizji
# Purpose:     Raport rozliczenia prowizji
#
# Author:      Micha Raburski
#
# Created:     2016/06/22
# RCS-ID:      $Id: fs_crm_rozliczenie_prowizji.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2022-10-04 Wojciech Skowron - (12174) Poprawiona obsuga pliku
# 2024-02-20 Wojciech Skowron - (13695) Przyjmowany stat z ZapiszXLSZDanych

import binascii
import os.path
import tempfile

from funkcje import fs_pliki_office
import rsglobal

stat = "OK"
dane=[]
wyn2=[]

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {'Platnik':[1,], 'Artykul': [1,], 'Kateg': [1,], 'Typy':[1,],
             'TerminOd': [1,], 'TerminDo':[1,], 'DataOd': [1,], 'DataDo': [1,]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_crm_rozliczenie_prowizji z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

    if stat == 'OK':
        if Funkcja in [1,]:
            Plat = str(klucze['Platnik'])
            Art = str(klucze['Artykul'])
            Kateg = str(klucze['Kateg'])
            Typy = str(klucze['Typy'])
            TerminOd = str(klucze['TerminOd'])
            TerminDo = str(klucze['TerminDo'])
            DataOd = str(klucze['DataOd'])
            DataDo = str(klucze['DataDo'])

if stat == 'OK' and Funkcja == 1:
    # sprawdzenie patnika
    if Plat != '':
        SQL = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id= '"+Plat+"'"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat =u'Bd sprawdzania patnika : '+stat
        elif len(DTest) == 0:
            stat ='PLAT BL'

    # sprawdzenie artykuu
    if stat == 'OK':
        if Art != '':
            SQL = "SELECT artykul_id FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id= '"+Art+"'"
            stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat =u'Bd sprawdzania artykuu : '+stat
            elif len(DTest) == 0:
                stat ='ART BL'

    # sprawdzenie kategorii
    if stat == 'OK':
        if Kateg != '':
            SQL = "SELECT kod FROM rs_kateg_artykulow WHERE firma_id = '"+self.firma_id+"' AND kod= '"+Kateg+"'"
            stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat =u'Bd sprawdzania kategorii : '+stat
            elif len(DTest) == 0:
                stat ='KATEG BL'

    # sprawdzenie typw
    if stat == 'OK':
        if Typy != '':
            for typ in Typy.split(','):
                SQL = "SELECT typ FROM rs_typy_artykulow WHERE typ= '"+typ+"'"
                stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat != 'OK':
                    stat =u'Bd sprawdzania typu artykulu : '+stat
                elif len(DTest) == 0:
                    stat ='TYPY BL'

    # sprawdzenie dat
    if stat == 'OK':
        if TerminOd != '-  -':
            if not rsglobal.SprawdzCzyToData(TerminOd):
                stat='TERM OD BL'
        if TerminDo != '-  -':
            if not rsglobal.SprawdzCzyToData(TerminDo):
                stat='TERM DO BL'
        if DataOd != '-  -':
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat='DATA OD BL'
        if DataDo != '-  -':
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat='DATA DO BL'

    if stat == 'OK':
        Nagl = u"ROZLICZENIE PROWIZJI z dnia "+rsglobal.PodajDzis()

        SQL = "SELECT f.wyznacznik_id,f.data,f.numer,f.termin_zaplaty,f.kwota_netto,f.do_zaplaty,SUM(fp.wartosc_netto),SUM(fp.wartosc_brutto) " \
              " FROM rs_faktury f INNER JOIN rs_faktury_pozycje fp USING (firma_id,wyznacznik_id,data,numer) " \
              " INNER JOIN rs_artykuly a USING (firma_id,artykul_id)" \
              "  WHERE f.firma_id='"+self.firma_id+"' "

        if Plat != '':
            Nagl +=u'; dla patnika '+Plat
            SQL += " AND f.platnik_id = '"+Plat+"'"
        if Art != '':
            Nagl +=u'; dla artykuu '+Art
            SQL += " AND fp.artykul_id = '"+Art+"'"
        if Kateg != '':
            Nagl +=u'; dla kategorii '+Kateg
            SQL += " AND a.kateg_artykulu LIKE '"+Kateg+"%'"
        if Typy != '':
            Nagl +=u'; dla typw '+Typy
            SQL += " AND a.typ_artykulu IN ("+str(Typy.split(','))[1:-1]+")"
        if TerminOd != '-  -':
            Nagl +=u'; dla terminu patnoci od '+TerminOd+' do '+TerminDo
            SQL += " AND f.termin_zaplaty >= '"+TerminOd+"'"
        if TerminDo != '-  -':
            SQL += " AND f.termin_zaplaty <= '"+TerminDo+"'"
        if DataOd != '-  -':
            Nagl +=u'; dla dat faktury od '+DataOd+' do '+DataDo
            SQL += " AND f.data >= '"+DataOd+"'"
        if DataDo != '-  -':
            SQL += " AND f.data <= '"+DataDo+"'"

        SQL+="GROUP BY f.wyznacznik_id,f.data,f.numer,f.termin_zaplaty,f.kwota_netto,f.do_zaplaty"
        stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow('SQLRAP '+SQL,1)
        rsglobal.ZapiszDoLogow('wyn1 '+str(wyn1),1)
        rsglobal.ZapiszDoLogow('ile '+str(len(dane)),1)
        if stat != 'OK':
            stat = 'Bdy pobierania listy faktur: '+stat
        if stat == 'OK':
            if len(dane) == 0:
                stat = 'DANE BR'

    if stat == 'OK':
        Dane = []
        for poz in dane:
            rsglobal.ZapiszDoLogow('poz '+str(poz),1)
            # pobranie numeru faktury
            KlPom=str([poz[0],poz[1],poz[2]]).replace("'",'"')
            SQL = "SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','"+KlPom+"','F')"
            stat,DNum,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat = 'Bdy pobierania numeru faktury: '+stat
            if stat =='OK':
                if poz[5] != 0:
                    WspNetBr = poz[4]/poz[5] # razy to trzeba pomnoy brutto by wyyszo netto (kw netto/kw. brutto)
                else:
                    WspNetBr = 0

                w = [DNum[0][0],poz[1],poz[3],poz[6],poz[7]]    # numer fakt, data, termin, kwota fakt netto, kwota fakt brutto

                # pobranie danych rozrachunku (bierzemy ostatni pozycj i j analizujemy)
                SQL = "SELECT MAX(data_rozlicz),kwota_wn,SUM(rozliczone_wn) FROM rs_rozrachunki " \
                      " WHERE firma_id='"+self.firma_id+"' AND f_wyznacznik_id='"+poz[0]+"' AND f_data='"+poz[1]+"'" \
                      "  AND f_numer="+str(poz[2])+" GROUP BY kwota_wn HAVING kwota_wn > 0"

                rsglobal.ZapiszDoLogow('SQL R '+SQL,1)
                stat,DRozr,dump,dump=self.PolSQL.Execute(SQL,3)
                rsglobal.ZapiszDoLogow('stat '+stat,1)
                rsglobal.ZapiszDoLogow('DRozr '+str(DRozr),1)
                if stat != 'OK':
                    stat = 'Bd pobierania rozrachunkw dla faktury: '+stat

            if stat == 'OK':
                # jeli brak danych to wstawiamy zalepkowe informacje
                if len(DRozr) == 0:
                    w += [0,0,0,'',-w[4]]
                else:
                    # wstawienie danych rozrachunku i wyliczenie rnicy
                    w += [DRozr[0][1], rsglobal.RSRound(DRozr[0][2]*WspNetBr,2) ,DRozr[0][2],DRozr[0][0],DRozr[0][2] - w[4]]

                # pozbycie si zaokrglenia (do 3 groszy rnicy przepisujemy kwotrozrachunku do wartoci btutto faktury)
                if abs(rsglobal.RSRound(w[4],2)- rsglobal.RSRound(w[5],2)) <=0.05:
                    w[4] = w[5]
                    w[9] = w[7] - w[4]


            # wstawienie przygotowanego wiersza do danych
            if stat == 'OK':
                rsglobal.ZapiszDoLogow('w '+str(w),1)
                Dane.append(w)

    if stat == 'OK':
        Kolumny = [u'Faktura',u'Data',u'Termin',u'Netto fakt.',u'Brutto fakt.',u'Kwota rozr.',u'Zapata netto',u'Zapata brutto',u'Data zapaty',u'Rnica']
        TypyKol = [('','str'),('','date'),('','date'),('','numeric'),('','numeric'),('','numeric'),('','numeric'),('','numeric'),('','date'),('','numeric')]
        Kodowanie = 'iso8859_2'
        Plik = tempfile.mktemp('.xlsx')
        stat = fs_pliki_office.ZapiszXLSZDanych(Dane,Plik,TypyKol,[Nagl],Kodowanie,Kolumny)  #WS 2024-02-20 - stat=
        if stat == 'OK':
            if os.path.isfile(Plik):
                #WS 2022-10-04
                try:
                    with open(Plik, 'rb') as p:
                        dane = [binascii.hexlify(buffer(p.read()))]
                except Exception, e:
                    stat = 'Bd odczytu pliku: '+str(e)
                # dane = [binascii.hexlify(buffer(open(Plik, 'rb').read()))]
            else:
                stat = 'Nie utworzono pliku - sprawd logi serwera'