# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_crm_sprzedaz
# Purpose:     Obsuga zapyta z sekcji Sprzeda w oknie CRM
#
# Author:      Micha Raburski
#
# Created:     2010/08/22
# RCS-ID:      $Id: fs_crm_sprzedaz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2018-10-08 Aleksander Bargie (11256) [SP] Zmiany w rentownoci
#2018-10-11 Aleksander Bargie (11261) [SP] rozbicie rentownosci dla kontrahentow
#2018-10-15 Aleksander Bargie (11262) [CRM] zmiany w spoosbie wywietlania
#2018-10-23 Aleksander Bargie (11268) [CRM} rzut w rentownoci
#2019-02-06 Aleksander Bargie (11393) Zmiana w obliczaniu rentownoci tras.
#2019-03-01 Aleksander Bargie (11427) Crm - rentowno: doda kolumn 'Kategoria kontrahenta'
#2020-09-24 Aleksander Bargie (12131) [SP] dodatek w sprzeda->crm->rentowno
#2021-11-23 Wojciech Skowron   (12718) Pobranie kontrahent_id z operatora (funkcja 100) i wpisanie go w filtr
#2022-02-11 Wojciech Skowron   (12865) Kateg_kontrahentow w operatorze
#2024-02-28 Wojciech Skowron   (13274) Dostpne filtrowanie po artykule gdy wpisane kategorie w operatora


# lista skrtw :
# SPDD  - Sprzeda -> Dowody Dostaw
# SPRT  - Sprzeda -> Rentowno

stat='OK'
dane=[]
wyn2=[]
Fun=klucze[-1]
KontrOp = ''  #WS 2021-11-23
KategKontrOp = []  #WS 2022-02-11

UprSPDD=(self.operator_id == STANDARD_OPERATOR_ID) or (self.oddzial_id,'111110') in self.uprawnienia
UprSPRT=(self.operator_id == STANDARD_OPERATOR_ID) or (self.oddzial_id,'111120') in self.uprawnienia

#WS 2021-11-23 - pobranie kontrahent_id z rs_operatorzy
#WS 2022-02-11 - i dodatkowo kateg_kontrahentow
if Fun in (1,100):
    SQL = "SELECT COALESCE(kontrahent_id,''), COALESCE(kateg_kontrahentow, '') FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania kontrahenta i listy kategorii kontrahentw dla zalogowanego operatora: '+stat
    else:
        KontrOp = dane[0][0]
        KategKontrOp = [str(kateg).strip() for kateg in dane[0][1].split(',') if str(kateg).strip() != '']

#-##############################################################################
#  SPRZEDA -> DOWODY DOSTAW
#-##############################################################################

if Fun==1:
    if not UprSPDD:
        stat='UPR SPDD'

    if stat=='OK':
        #WS 2021-11-23
        if KontrOp == '' and len(KategKontrOp) == 0:
            Kontr=rsglobal.Dekoduj(klucze[0]).strip()
            KategKontr=rsglobal.Dekoduj(klucze[1]).strip()
            Art=rsglobal.Dekoduj(klucze[4]).strip()
            KategArt=rsglobal.Dekoduj(klucze[5]).strip()
            Opiekun=str(klucze[6]).strip()
            Handlowiec=str(klucze[7]).strip()
        elif KontrOp == '' and len(KategKontrOp) > 0:
            #WS 2022-02-11 - gdy kategorie wpisane w op, mona odfiltrowa po kontrahencie jeli zgodny z kategoriami
            #WS 2024-02-28 - i po artykule
            Kontr = rsglobal.Dekoduj(klucze[0]).strip()
            Art = rsglobal.Dekoduj(klucze[4]).strip()
            KategKontr=KategArt=Opiekun=Handlowiec=''
        else:  # wszystkie filtry oprcz dat puste, gdy kontrahent wpisany w operatorze
            Kontr=KategKontr=Art=KategArt=Opiekun=Handlowiec=''

        DrugaJM=klucze[8]
        DataOd=rsglobal.Dekoduj(klucze[2])
        DataDo=rsglobal.Dekoduj(klucze[3])
        DataOdPor=rsglobal.Dekoduj(klucze[9])
        DataDoPor=rsglobal.Dekoduj(klucze[10])
        if DataOdPor=='    -  -  ':
            DataOdPor=DataOd
        if DataDoPor=='    -  -  ':
            DataDoPor=DataDo
        # Kontr=rsglobal.Dekoduj(klucze[0])
        # KategKontr=rsglobal.Dekoduj(klucze[1])
        # DataOd=rsglobal.Dekoduj(klucze[2])
        # DataDo=rsglobal.Dekoduj(klucze[3])
        # Art=rsglobal.Dekoduj(klucze[4])
        # KategArt=rsglobal.Dekoduj(klucze[5])
        # Opiekun=str(klucze[6])
        # Handlowiec=str(klucze[7])
        # DrugaJM=klucze[8]
        # DataOdPor=rsglobal.Dekoduj(klucze[9])
        # DataDoPor=rsglobal.Dekoduj(klucze[10])
        # if DataOdPor=='    -  -  ':
        #     DataOdPor=DataOd
        # if DataDoPor=='    -  -  ':
        #     DataDoPor=DataDo
            
        OddzialF=''
        
        if DrugaJM:
            JM='2'
        else:
            JM='1'
        
        # sprawdzenie dat
        if DataOd != '    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat='BL DATA OD'
    
    if stat=='OK':    
        if DataDo != '    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat='BL DATA DO'
                
    if stat=='OK':
        if DataOdPor != '    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataOdPor):
                stat='BL DATA OD POR'
    
    if stat=='OK':    
        if DataDoPor != '    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataDoPor):
                stat='BL DATA DO POR'

    #WS 2022-02-11 - w operatora wpisana lista kategorii kontrahentw - sprawdzamy czy kontrahent z filtra si z ni zgadza
    if stat=='OK' and KontrOp == '' and len(KategKontrOp) > 0 and Kontr not in ['', '%']:
        SQL = "SELECT 1 FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"'"
        SQL+= " AND kateg_kontrahenta IN ('"+"','".join(KategKontrOp)+"');"
        stat,DKategKontr,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd weryfikacji kontrahenta w filtrze z list kategorii kontrahentw przydzielon operatorowi: '+stat
        elif len(DKategKontr) == 0:
            stat = 'BL KONTR KATEG'
        
    # ewentualne pobranie oddziau z danych operatora
    if stat=='OK':        
        if self.operator_id != STANDARD_OPERATOR_ID:
            SQL="SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
            SQL+=" AND NOT generator_oddzial_id IS NULL AND generator_oddzial_id != '' AND generator_oddzial_id<>'**'"
            stat,DOddz,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DOddz)>0:
                    if not DOddz[0][0] in (None,'None',''):
                        OddzialF=rsglobal.Dekoduj(DOddz[0][0])
        
        # zoenie zapytania
    if stat=='OK':
        CaDaP="CASE WHEN ddp.data >= '"+DataOd+"' AND ddp.data <= '"+DataDo+"' THEN "
        CaDaK=" ELSE 0 END"
        CaDaPorP="CASE WHEN ddp.data >= '"+DataOdPor+"' AND ddp.data <= '"+DataDoPor+"' THEN "
        CaDaPorK=" ELSE 0 END"

        #WS 2021-11-23 - dodane aliasy
        SQL="SELECT dd.kontrahent_id,k.nazwa,ddp.artykul_id,a.nazwa AS opis," # 0-3 kontr,nazwa,art,opis
        
        SQL+="SUM("+CaDaP+"ddp.ilosc_dost"+JM+CaDaK+") AS il_dost,SUM("+CaDaP+"ddp.ilosc_dost"+JM+"*ddp.cena_upust"+JM+CaDaK+") AS wart_dost," # 4-5 ilo dost,wart dost
        SQL+="SUM("+CaDaP+"ddp.ilosc_zwr"+JM+CaDaK+") AS il_zwr,SUM("+CaDaP+"ddp.ilosc_zwr"+JM+"*ddp.cena_upust"+JM+CaDaK+") AS wart_zwr," # 6-7 ilo zwr, wart zwr
        SQL+="SUM("+CaDaP+"ddp.ilosc_rozl"+JM+CaDaK+") AS il_zwr_uzn,SUM("+CaDaP+"ddp.ilosc_rozl"+JM+"*ddp.cena_upust"+JM+CaDaK+") AS wart_zwr_uzn," # 8-9 ilo zwr uznana, wart zwr uznana
        SQL+="SUM("+CaDaP+"ddp.ilosc_dost"+JM+"-ddp.ilosc_zwr"+JM+CaDaK+") AS il_realna,SUM("+CaDaP+"(ddp.ilosc_dost"+JM+"-ddp.ilosc_zwr"+JM+")*ddp.cena_upust"+JM+CaDaK+") AS wart_realna," # 10-11 ilo realna,wart realna
        SQL+="CASE WHEN SUM("+CaDaP+"ddp.ilosc_dost"+JM+CaDaK+")=0 THEN 0 ELSE ROUND(SUM("+CaDaP+"ddp.ilosc_zwr"+JM+CaDaK+")/SUM("+CaDaP+"ddp.ilosc_dost"+JM+CaDaK+")*100,2) END AS proc_zwr," # 12 % zwr
        SQL+="CASE WHEN SUM("+CaDaP+"ddp.ilosc_dost"+JM+CaDaK+")=0 THEN 0 ELSE ROUND(SUM("+CaDaP+"ddp.ilosc_rozl"+JM+CaDaK+")/SUM("+CaDaP+"ddp.ilosc_dost"+JM+CaDaK+")*100,2) END AS proc_zwr_uzn," # 13 % zwr uznana

        SQL+="SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+CaDaPorK+") AS il_dost_por,SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+"*ddp.cena_upust"+JM+CaDaPorK+") AS wart_dost_por," # 14-15 ilo dost por,wart dost por
        SQL+="SUM("+CaDaPorP+"ddp.ilosc_zwr"+JM+CaDaPorK+") AS il_zwr_por,SUM("+CaDaPorP+"ddp.ilosc_zwr"+JM+"*ddp.cena_upust"+JM+CaDaPorK+") AS wart_zwr_por," # 16-17 ilo zwr por, wart zwr por
        SQL+="SUM("+CaDaPorP+"ddp.ilosc_rozl"+JM+CaDaPorK+") AS il_zwr_uzn_por,SUM("+CaDaPorP+"ddp.ilosc_rozl"+JM+"*ddp.cena_upust"+JM+CaDaPorK+") AS wart_zwr_uzn_por," # 18-19 ilo zwr realna por, wart zwr realna por
        SQL+="SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+"-ddp.ilosc_zwr"+JM+CaDaPorK+") AS il_realna_por,SUM("+CaDaPorP+"(ddp.ilosc_dost"+JM+"-ddp.ilosc_zwr"+JM+")*ddp.cena_upust"+JM+CaDaPorK+") AS wart_realna_por," # 20-21 ilo realna por, wart realna por
        SQL+="CASE WHEN SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+CaDaPorK+")=0 THEN 0 ELSE ROUND(SUM("+CaDaPorP+"ddp.ilosc_zwr"+JM+CaDaPorK+")/SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+CaDaPorK+")*100,2) END AS proc_zwr_por," # 22 % zwr por
        SQL+="CASE WHEN SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+CaDaPorK+")=0 THEN 0 ELSE ROUND(SUM("+CaDaPorP+"ddp.ilosc_rozl"+JM+CaDaPorK+")/SUM("+CaDaPorP+"ddp.ilosc_dost"+JM+CaDaPorK+")*100,2) END AS proc_zwr_por_uzn," # 23 % zwr por uznana
        
        SQL+=" COALESCE(o.operator_id||' - '||TRIM(o.imie)||' '||TRIM(o.nazwisko),'') AS opiekun," # 24 opiekun
        SQL+="dd.kontrahent_id AS kontrahent_id_2,k.nazwa AS nazwa_2,ddp.artykul_id AS artykul_id_2,a.nazwa AS opis_2" # 25-28 kontr,nazwa,art,opis
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
        SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
        SQL+=" INNER JOIN rs_kontrahenci k ON (dd.firma_id=k.firma_id AND dd.kontrahent_id=k.kontrahent_id)"
        SQL+=" INNER JOIN rs_artykuly a ON (ddp.firma_id=a.firma_id AND ddp.artykul_id=a.artykul_id)"
        SQL+=" LEFT OUTER JOIN rs_operatorzy o ON (o.operator_id=rsf_podaj_opiekuna(ddp.firma_id,dd.kontrahent_id,dd.oddzial_id))"
        SQL+=" WHERE dd.firma_id='"+self.firma_id+"'"
        if OddzialF <>'':
            SQL+=" AND dd.oddzial_id='"+OddzialF+"'"
            
        #zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
        SQL+=" AND ((ddp.data >= '"+DataOd+"' AND ddp.data <= '"+DataDo+"') OR (ddp.data >= '"+DataOdPor+"' AND ddp.data <= '"+DataDoPor+"'))"

        if KontrOp == '' and len(KategKontrOp) == 0:  #WS 2021-11-23  #WS 2022-02-11
            if (not Kontr in ['','%']) or (not self.handlowiec_id in [None,'None','']) or (not Handlowiec in ('',self.handlowiec_id)) \
                or Opiekun <>'':
                # pobranie konkretnych kontrahentw i filtr
                SQLKontr="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                if Kontr<>'':
                    SQLKontr+=" AND kontrahent_id LIKE '"+Kontr+"%'"
                if self.handlowiec_id != None:
                    SQLKontr+=" AND TRIM(rsf_podaj_pole_z_danych_do_fakturowania(firma_id,kontrahent_id,current_date,'handlowiec')) ='"+self.handlowiec_id.strip()+"'"
                elif not Handlowiec in ('',self.handlowiec_id):
                    SQLKontr+=" AND TRIM(rsf_podaj_pole_z_danych_do_fakturowania(firma_id,kontrahent_id,current_date,'handlowiec'))='"+Handlowiec.strip()+"'"
                stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQLKontr,3)
                if stat=='OK':
                    if len(dane)==0:
                        stat='BR KONTR'
                if stat=='OK':
                    LKontr=[]
                    for poz in dane:
                        LKontr.append(rsglobal.Dekoduj(poz[0]))

                    SQL+=" AND dd.kontrahent_id IN ("+str(LKontr)[1:-1]+")"
                
    if stat=='OK':
        if not KategKontr in ['','%']:
            SQL+=" AND k.kateg_kontrahenta LIKE '"+KategKontr+"%'"
            
        if not Art in ['','%']:
            # pobranie konkretnych artykuw i filtr
            SQLArt="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id LIKE '"+Art+"%'"
            stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQLArt,3)
            if stat=='OK':
                if len(dane)==0:
                    stat='BR ART'
            if stat=='OK':
                LArt=[]
                for poz in dane:
                    LArt.append(rsglobal.Dekoduj(poz[0]))
                SQL+=" AND ddp.artykul_id IN ("+str(LArt)[1:-1]+")"
                
    if stat=='OK':
        if KategArt != '':
            SQL+=" AND a.kateg_artykulu LIKE '"+KategArt+"%'"

        if Opiekun != '':
            SQL+=" AND rsf_podaj_opiekuna(ddp.firma_id,dd.kontrahent_id,dd.oddzial_id)="+Opiekun

        #WS 2021-11-23
        if KontrOp != '':
            SQL+=" AND dd.kontrahent_id='"+KontrOp+"'"
        #WS 2022-02-11
        elif len(KategKontrOp) > 0:
            SQL+=" AND dd.kontrahent_id IN (SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta IN ('"+"','".join(KategKontrOp)+"')"
            if Kontr not in ['', '%']:
                SQL += " INTERSECT SELECT '"+Kontr+"')"
            else:
                SQL += ")"

        SQL+=" GROUP BY dd.kontrahent_id,k.nazwa,ddp.artykul_id,a.nazwa,o.operator_id,o.imie,o.nazwisko"
        SQL+=" ORDER BY dd.kontrahent_id,ddp.artykul_id"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="BL UPD"

# -##############################################################################
#  SPRZEDA -> RENTOWNO
# -##############################################################################

if Fun == 2:
    if not UprSPRT:
        stat = 'UPR SPRT'

    if stat == 'OK':
        klucze = rsglobal.Dekoduj(klucze[0])

        if not 'Funkcja' in klucze:
            stat='Brak podanej funkcji w kluczach'

    if stat=='OK':
        Funkcja = klucze['Funkcja']                                         #AB 11.10.18r
        SlPar={'Trasa':[2,],'DataOd':[2,],'DataDo':[2,],'Przewoznik':[2,], 'Kontrahenci': [2, ]}

        Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
        if Lista<>'':
            stat='Uwaga : wywoanie funkcji fs_crm_sprzedaz z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

    if stat == 'OK':
        if Funkcja in [2,]:
            Trasa       = klucze['Trasa']
            DataOd      = klucze['DataOd']
            DataDo      = klucze['DataDo']
            Przewoznik  = klucze['Przewoznik']
            #AB 11.10.18r
            Kontrahenci = klucze['Kontrahenci']
            #AB 23.10.18r
            Rzut        = klucze['Rzut']
            rz1         = ", '' as rzut "
            rz2         = ''
            rz3         = ', 4 '
            if Rzut not in (None, '', 'None'):
                rz1 = ', rzut as rzutt'
                rz2 = " AND rzut = '"+Rzut+"' "
                rz3 = ', rzutt '
            #AB 01.03.19r
            k1 = " kontrahent_id, k.nazwa AS kontrahent_opis, COALESCE(k.kateg_kontrahenta, '') AS kateg_kontrahenta, k.adr_kod, trim(k.adr_miej)  || ', ' || trim(k.adr_ulica) || ' ' || trim(k.adr_nry) AS adres, "
            k2 = " , kontrahent_id, k.nazwa, k.kateg_kontrahenta, k.adr_kod, adres "
            k3 = " k.nazwa, "
            if not Kontrahenci:
                k1 = " '' AS kontrahent_id, '' AS kontrahent_opis, '' AS  kateg_kontrahenta, '' AS adr_kod, '' AS adres, "
                k2 = ""
                k3 = ""


    # ewentualne pobranie oddziau z danych operatora
    if stat=='OK':
        OddzialF = ''
        if self.operator_id != STANDARD_OPERATOR_ID:
            SQL = "SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id=" + str(self.operator_id)
            SQL += " AND NOT generator_oddzial_id IS NULL AND generator_oddzial_id != '' AND generator_oddzial_id<>'**'"
            stat, DOddz, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat == 'OK':
                if len(DOddz) > 0:
                    if not DOddz[0][0] in (None, 'None', ''):
                        OddzialF = rsglobal.Dekoduj(DOddz[0][0])
    #AB 06.02.19r Pobieranie z tabel _rzut jeli Rzut w argumentach
    if not Rzut in (None, '', 'None'):
        if stat == 'OK' and Kontrahenci:  # AB 23.10.18r                                       #AB 15.10.18r
            SQL = "SELECT r.oddzial_id,r.trasa,t.opis" + rz1 + ", " + k1
            SQL += "'' as data, SUM(r.liczba),"
            SQL += "SUM(COALESCE(sprzedaz,0)-COALESCE(zwroty,0)) as sprzedaz,SUM(r.transport),"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) != 0 THEN SUM(COALESCE(r.transport,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu1,"
            SQL += "SUM(COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)) as dodatki,"
            SQL += "SUM(r.dod_got) as dod_got,"
            SQL += "SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0)) as koszt_z_dodatkami,"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0))<>0 "
            SQL += "THEN SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu2, r.dystans_km, r.opis, r.dodatek "  #AB 24.09.20r
            SQL += "FROM rs_dowody_dostaw_rentownosc_kontrahenci_rzut r "
            SQL += "JOIN rs_kontrahenci k USING (firma_id, kontrahent_id) "
            SQL += "JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod "
            SQL += " WHERE r.firma_id='" + self.firma_id + "' and rzut='"+Rzut+"' "
            if OddzialF != '':
                SQL += " AND r.oddzial_id='" + OddzialF + "'"
            if Przewoznik != '':
                SQL += " AND r.przewoznik_id='" + Przewoznik + "'"
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            # AB 15.10.18r
            if Trasa.strip() != '':
                SQL += " AND trasa = '" + Trasa + "'"
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            SQL += " AND (r.data >= '" + DataOd + "' AND r.data <= '" + DataDo + "') " + rz2  # AB 23.10.18r
            SQL += " GROUP BY r.oddzial_id, r.trasa,t.opis,r.dystans_km, r.opis, r.dodatek " + k2 + rz3  #AB 24.09.20r
            # AB 15.10.18r
            SQL += " ORDER BY " + k3 + " r.oddzial_id, r.trasa;"

        elif stat == 'OK' and Trasa == '':  #AB 01.03.19r
            SQL = "SELECT r.oddzial_id,r.trasa,t.opis" + rz1 + ", " + k1
            SQL += " '' as data,SUM(r.liczba),SUM(COALESCE(sprzedaz,0)-COALESCE(zwroty,0)) as sprzedaz,SUM(r.transport),"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) != 0 THEN SUM(COALESCE(r.transport,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu1,"
            SQL += "SUM(COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)) as dodatki,"
            SQL += "SUM(r.dod_got) as dod_got,"
            SQL += "SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0)) as koszt_z_dodatkami,"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0))<>0 "
            SQL += "THEN SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu2, r.dystans_km, r.opis, r.dodatek "  #AB 24.09.20r
            SQL += "FROM rs_dowody_dostaw_rentownosc_rzut r JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod "
            SQL += " WHERE r.firma_id='" + self.firma_id + "'and rzut='"+Rzut+"' "
            if OddzialF != '':
                SQL += " AND r.oddzial_id='" + OddzialF + "'"
            if Przewoznik != '':
                SQL += " AND r.przewoznik_id='" + Przewoznik + "'"
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            SQL += " AND (r.data >= '" + DataOd + "' AND r.data <= '" + DataDo + "') " + rz2  # AB 23.10.18r
            SQL += " GROUP BY r.oddzial_id, r.trasa,t.opis,r.dystans_km, r.opis, r.dodatek " + rz3  #AB 24.09.20r
            SQL += " ORDER BY r.oddzial_id, r.trasa "

        elif stat == 'OK' and Trasa != '':  #AB 01.03.19r
            SQL = "SELECT r.oddzial_id,r.trasa,t.opis" + rz1 + ", " + k1
            SQL += " r.data,r.liczba,COALESCE(sprzedaz,0)-COALESCE(zwroty,0) as sprzedaz,r.transport,"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) != 0 THEN SUM(COALESCE(r.transport,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu1,"
            SQL += "COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0) as dodatki,"
            SQL += "r.dod_got,"
            SQL += "COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0) as koszt_z_dodatkami,"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0))<>0 "
            SQL += "THEN SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu2, r.dystans_km, r.opis, r.dodatek "  #AB 24.09.20r
            SQL += "FROM rs_dowody_dostaw_rentownosc_rzut r JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod "
            SQL += " WHERE r.firma_id='" + self.firma_id + "'and rzut='"+Rzut+"' AND r.trasa='" + Trasa + "'"  ##"' AND r.oddzial_id='" + Oddzial + jeli trzeba bdzie doda oddzia_id
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            if OddzialF != '':
                SQL += " AND r.oddzial_id='" + OddzialF + "'"
            if Przewoznik != '':
                SQL += " AND r.przewoznik_id='" + Przewoznik + "'"
            SQL += " AND (r.data >= '" + DataOd + "' AND r.data <= '" + DataDo + "') " + rz2  # AB 23.10.18r
            SQL += "GROUP bY r.oddzial_id,r.trasa,t.opis,r.data,r.liczba,sprzedaz,zwroty,r.transport,"
            SQL += "r.dod_godz,r.dod_km,r.dod_proc,r.ryczalt,r.dod_godz,r.dod_km,r.dod_proc,r.ryczalt,r.dystans_km, r.opis, r.dodatek,r.dod_got" + rz3  #AB 24.09.20r
            SQL += " ORDER BY r.oddzial_id, r.trasa;"
    else:
        if stat == 'OK' and Kontrahenci:          #AB 23.10.18r                                       #AB 15.10.18r
            SQL = "SELECT r.oddzial_id,r.trasa,t.opis"+rz1+", " + k1
            SQL += "'' as data, SUM(r.liczba),"
            SQL += "SUM(COALESCE(sprzedaz,0)-COALESCE(zwroty,0)) as sprzedaz,SUM(r.transport),"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) != 0 THEN SUM(COALESCE(r.transport,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu1,"
            SQL += "SUM(COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)) as dodatki,"
            SQL += "SUM(r.dod_got) as dod_got,"
            SQL += "SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0)) as koszt_z_dodatkami,"
            SQL += "ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0))<>0 "
            SQL += "THEN SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0))*100/"
            SQL += "SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu2, r.dystans_km, r.opis, r.dodatek "  #AB 24.09.20r
            SQL += "FROM rs_dowody_dostaw_rentownosc_kontrahenci r "
            SQL += "JOIN rs_kontrahenci k USING (firma_id, kontrahent_id) "
            SQL += "JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod "
            SQL += " WHERE r.firma_id='" + self.firma_id + "'"
            if OddzialF != '':
                SQL += " AND r.oddzial_id='" + OddzialF + "'"
            if Przewoznik != '':
                SQL += " AND r.przewoznik_id='" + Przewoznik + "'"
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            #AB 15.10.18r
            if Trasa.strip() != '':
                SQL+= " AND trasa = '" + Trasa + "'"
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            SQL+= " AND (r.data >= '" + DataOd + "' AND r.data <= '" + DataDo + "') " + rz2   #AB 23.10.18r
            SQL+= " GROUP BY r.oddzial_id, r.trasa,t.opis,r.dystans_km, r.dodatek, r.opis" + k2 + rz3  #AB 24.09.20r
                              #AB 15.10.18r
            SQL+= " ORDER BY "+k3+" r.oddzial_id, r.trasa;"

        elif stat == 'OK' and Trasa == '':       #AB 01.03.19r
            SQL= "SELECT r.oddzial_id,r.trasa,t.opis"+rz1 + ", " + k1
            SQL+=" '' as data,SUM(r.liczba),SUM(COALESCE(sprzedaz,0)-COALESCE(zwroty,0)) as sprzedaz,SUM(r.transport),"
            SQL+="ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) != 0 THEN SUM(COALESCE(r.transport,0))*100/"
            SQL+="SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu1,"
            SQL+="SUM(COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)) as dodatki,"
            SQL+="SUM(r.dod_got) as dod_got,"
            SQL+="SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL+=" + COALESCE(r.dod_got,0)) as koszt_z_dodatkami,"
            SQL+="ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0))<>0 "
            SQL+="THEN SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL+=" + COALESCE(r.dod_got,0))*100/"
            SQL+="SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu2, r.dystans_km, r.opis, r.dodatek "  #AB 24.09.20r
            SQL+="FROM rs_dowody_dostaw_rentownosc r JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod "
            SQL += " WHERE r.firma_id='" + self.firma_id + "'"
            if OddzialF != '':
                SQL += " AND r.oddzial_id='" + OddzialF + "'"
            if Przewoznik != '':
                SQL += " AND r.przewoznik_id='" + Przewoznik + "'"
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            SQL += " AND (r.data >= '" + DataOd + "' AND r.data <= '" + DataDo + "') " + rz2  #AB 23.10.18r
            SQL += " GROUP BY r.oddzial_id, r.trasa,t.opis,r.dystans_km, r.dodatek, r.opis" + rz3  #AB 24.09.20r
            SQL += " ORDER BY r.oddzial_id, r.trasa "

        elif stat == 'OK' and Trasa != '':        #AB 01.03.19r
            SQL= "SELECT r.oddzial_id,r.trasa,t.opis"+rz1 + ", " + k1
            SQL+=" r.data,r.liczba,COALESCE(sprzedaz,0)-COALESCE(zwroty,0) as sprzedaz,r.transport,"
            SQL+="ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) != 0 THEN SUM(COALESCE(r.transport,0))*100/"
            SQL+="SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu1,"
            SQL+="COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0) as dodatki,"
            SQL+="r.dod_got,"
            SQL+="COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL += " + COALESCE(r.dod_got,0) as koszt_z_dodatkami,"
            SQL+="ROUND((CASE WHEN SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0))<>0 "
            SQL+="THEN SUM(COALESCE(r.transport,0)+COALESCE(r.dod_godz,0)+COALESCE(r.dod_km,0)+COALESCE(r.dod_proc,0)+COALESCE(r.ryczalt,0)"
            SQL+=" + COALESCE(r.dod_got,0))*100/"
            SQL+="SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) ELSE 0 END),2) as do_obrotu2 ,r.dystans_km, r.opis, r.dodatek "  #AB 24.09.20r
            SQL+="FROM rs_dowody_dostaw_rentownosc r JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod "
            SQL+= " WHERE r.firma_id='" + self.firma_id +  "' AND r.trasa='" + Trasa + "'"  ##"' AND r.oddzial_id='" + Oddzial + jeli trzeba bdzie doda oddzia_id
            # zaoenie mwi, e podane s obie daty. Daty porwnawcze s albo im rwne albo oddzielnie podane.
            if OddzialF != '':
                SQL += " AND r.oddzial_id='" + OddzialF + "'"
            if Przewoznik != '':
                SQL += " AND r.przewoznik_id='" + Przewoznik + "'"
            SQL+=" AND (r.data >= '" + DataOd + "' AND r.data <= '" + DataDo + "') " + rz2  #AB 23.10.18r
            SQL+="GROUP bY r.oddzial_id,r.trasa,t.opis,r.data,r.liczba,sprzedaz,zwroty,r.transport,"
            SQL+="r.dod_godz,r.dod_km,r.dod_proc,r.ryczalt,r.dod_godz,r.dod_km,r.dod_proc,r.ryczalt,r.dystans_km, r.dodatek, r.opis,r.dod_got" + rz3  #AB 24.09.20r
            SQL+=" ORDER BY r.oddzial_id, r.trasa;"

    if stat == 'OK':
        rsglobal.ZapiszDoLogow('Rentownosc zapytanie SQL:' + SQL, 5)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = "Bd pobrania dokumentu"


#-##############################################################################
#  POBRANIE HANDLOWCA DO CRM
#-##############################################################################

if Fun==98:
    SQL= " SELECT DISTINCT p.przewoznik_id,p.przewoznik_id||' - '||k.nazwa "
    SQL+=" FROM rs_trasy_przewoznicy p JOIN rs_kontrahenci k ON k.firma_id=p.firma_id "
    SQL+=" and p.przewoznik_id=k.kontrahent_id WHERE p.firma_id='"+str(self.firma_id)+"';"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat=u"Bd pobrania nazwy przewonika."

if Fun==99:
    SQL=" SELECT COALESCE(handlowiec_id,'') FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="BL POB HANDLOWCA"
