# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_definicje_bankow_w_kursach_walut_dane.py
# Purpose:     dodawanie i edycja bankw - rde pobierania kursw walut
# Author:      Jan Kaliszewski, niektre elementy z fs_konta_bankowe_dane
# Created:     2009/10/24
# RCS-ID:      $Id: fs_definicje_bankow_w_kursach_walut_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------


from rs_pobieranie_kursow_walut import usunImporterKursow

#-------------------------------------------------------------------------------
# Funkcja, klucze i zmienne stanu:

Fun = klucze[-1]

for i, _klucz in enumerate(klucze[:-1]):
    klucze[i] = _klucz.strip()
for i, _wart in enumerate(wartosci):
    wartosci[i] = _wart.strip()
    
if Fun in (1, 2):
    pola_na_wartosci = dict(zip(pola, wartosci))
    bank_id = pola_na_wartosci['bank_id']
else:
    bank_id = klucze[0]
    
firma_id = self.firma_id

stat = 'OK'
dane = []

#-------------------------------------------------------------------------------
# Ustalenie uprawnie:

if self.operator_id != STANDARD_OPERATOR_ID:
    UprPrz = (self.oddzial_id, '014013') in self.uprawnienia  # moe dod. kursy
    UprMod = False  # tylko anakonda
    UprDod = False  # tylko anakonda
else:
    UprPrz = True
    UprMod = True
    UprDod = True

#-------------------------------------------------------------------------------
#--- INSERT: 1 - z pobieraniem, 2 - bez pobierania
#-------------------------------------------------------------------------------

if Fun in (1, 2) and stat == 'OK':
    if UprDod:
        dump, _dane, dump, dump = self.PolSQL.Execute(
                "SELECT * FROM rs_definicje_bankow_w_kursach_walut"
                " WHERE firma_id='" + firma_id + "'"
                " AND bank_id='" + bank_id + "'", 3
        )
        if _dane:
            stat = 'BANK ISTN'
        else:
            pola_str = ','.join(['firma_id'] + pola)
            wartosci_str = ','.join("'%s'" % wart
                                    for wart in [firma_id] + wartosci)
            stat, dump, dump, dump = self.PolSQL.Execute(
                    "INSERT INTO rs_definicje_bankow_w_kursach_walut"
                    " (" + pola_str + ") VALUES (" + wartosci_str + ")",
                    1
            )
            if stat != 'OK':
                stat = 'Wystpi bd podczas dodawania danych ("%s").' % stat
    else:
        stat = 'Brak uprawnie do dodawania bankw - rde kursw walut.'

#-------------------------------------------------------------------------------
#--- UPDATE: 3 - z pobieraniem, 4 - bez pobierania
#-------------------------------------------------------------------------------

if Fun in (3, 4) and stat == 'OK':
    if UprMod:
        usunImporterKursow(bank_id)  # zmiana info o banku, trzeba usun importer
        pola_wartosci_str = ','.join("%s='%s'" % (pole, wart)
                                     for pole, wart in zip(pola, wartosci))
        stat, dump, dump, dump = self.PolSQL.Execute(
                "UPDATE rs_definicje_bankow_w_kursach_walut"
                " SET " + pola_wartosci_str + " WHERE"
                " firma_id='" + firma_id + "'"
                " AND bank_id='" + bank_id + "'",
                1
        )
        if stat != 'OK':
            stat = 'Wystpi bd podczas modyfikowania danych ("%s").' % stat
    else:
        stat = 'Brak uprawnie do edycji bankw - rde kursw walut.'

#-------------------------------------------------------------------------------
#--- SELECT: sam (5) lub po INSERT (1) bd UPDATE (3)
#-------------------------------------------------------------------------------

if Fun in (1, 3, 5) and stat == 'OK':
    if UprPrz:
        stat, dane, wyn1, tr = self.PolSQL.Execute(
                "SELECT * FROM rs_definicje_bankow_w_kursach_walut"
                " WHERE firma_id='" + firma_id + "'"
                " AND bank_id='" + bank_id + "'",
                3
        )
        if stat != 'OK':
            stat = 'Wystpi bd podczas pobierania danych ("%s").' % stat
    else:
        stat = 'Brak uprawnie do przegldania bankw - rde kursw walut.'
