# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dekretacja_automatyczna.py
# Purpose:     Dekretuje dokumenty w zalenoci od wybranego wzoru
# Author:      Micha Raburski    
# Created:     2007/03/08
# RCS-ID:      $Id: fs_dekretacja_automatyczna.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2016-12-20 JR dekretacja dostaw
# 2019-05-22 WS dekretacja pac
# 2019-06-18 WS dekretacja pac - warunek na szablon listy
# 2020-04-05 WS dekretacja dostaw - pobranie oznacze dla JPK_V7 z nagwka dostaw (11920)
# 2020-04-15 WS dekretacja faktur - pobranie oznacze dla JPK_V7 z nagwka faktur/korekt (11918)
# 2020-06-23 WS dekretacja faktur/korekt - MPP (12023)
# 2021-11-09 WS dekretacja pac - obsuga warunku na szablon listy i grup pracownikw (12701)
# 2024-02-23 WS dekretacja faktur/korekt - Sprzeda usug (13700)

#przychodza parametry: KLUCZ,NIC,NIC 
#gdzie KLUCZ = [Dowod,Nazwa,DataOd,DataDo, czasem OkresDekr ( w harmonogramie)]

from funkcje import fs_dekretacja_automatyczna_pom
#Status i bledy
lista_bledow = []
stat = "OK"
dane=[]

Dowod = klucze[0]
Nazwa = klucze[1]
DataOd = klucze[2]
DataDo = klucze[3]
 
CzyAutomat=False 
OkresDekr=self.okres_id
if len(klucze)==5: 
    OkresDekr=klucze[4]
    CzyAutomat=True
 
#Pobranie uprawnien do dokumentw ksigowych dla operatora
UprTotal=True

if self.operator_id == STANDARD_OPERATOR_ID or CzyAutomat:
    UprDodawanie=True       
    LDod=[]
else:
    Sel="SELECT dowod_id,nazwa_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie "
    Sel+="FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id in "
    Sel+=""+str(self.operatorzy).replace("[","(").replace("]",")")+" AND okres_id='"+OkresDekr+"'; "
    stat,daneupr,dump,dump = self.PolSQL.Execute(Sel,3)
    if stat<>'OK':
        stat = 'BL SPR UPR'
        dane.append(stat)                        
    if stat=='OK':
        if len(daneupr)>0:
            UprTotal=False
        else:
            UprTotal=True
        LDod=[]

        UprDodawanie=(self.oddzial_id,'075013') in self.uprawnienia
        if UprDodawanie:
            for d in daneupr:
                if d[2]:
                    LDod.append((rsglobal.Dekoduj(d[0]).strip(),rsglobal.Dekoduj(d[1]).strip()))

if not UprDodawanie:
    stat='UPR DOD'
    dane.append(stat)
if stat=='OK' and not UprTotal:
    if (not(str(Dowod),Nazwa) in LDod) and self.operator_id!=STANDARD_OPERATOR_ID:
        stat='UPR DOD'
        dane.append(stat)

if stat=='OK':  
    #pobranie dat pocztku i koca okresu obrachunkowego
    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT data_od,data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"'" ,3)

if stat=='OK':
    if len(dane_wyn)==0:
        stat='BR OKR'
        dane.append(stat)  
    else:
        DataPocz=dane_wyn[0][0]
        DataKonca=dane_wyn[0][1]

if stat=='OK':
    if Dowod=='':
        stat='BR DOWOD'
        dane.append(stat)  
        
if stat=='OK':        
    if Nazwa=='':
        stat='BR NAZWA'
        dane.append(stat)  
        
if stat=='OK':    
    if DataOd=='    -  -  ':
        stat='BR DATAOD'
        dane.append(stat)  
    else:
        if not rsglobal.SprawdzCzyToData(DataOd):
            stat='BL DATAOD'
            dane.append(stat)                  
        else:
            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+"\',\'"+DataOd+"\',3);" ,3)
            if stat=='OK':
                if dane_wyn[0][0]<> 1:
                    stat="ZK DATAOD"
                    dane.append(stat)
                else:
                    #sprawdzenie czy data jest w zakresie dat okresu obrachunkowego
                    if DataOd<DataPocz or DataOd >DataKonca:
                        stat="OKR DATAOD"
                        dane.append(stat)
           
if stat=='OK':
    if DataDo=='    -  -  ':
        stat='BR DATADO'
        dane.append(stat)  
    else:
        if not rsglobal.SprawdzCzyToData(DataDo):
            stat='BL DATADO'
            dane.append(stat)                  
        else:
            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+"\',\'"+DataDo+"\',3);" ,3)
            if stat=='OK':
                if dane_wyn[0][0] != 1:
                    stat="ZK DATADO"
                    dane.append(stat)
                else:
                    #sprawdzenie czy data jest w zakresie dat okresu obrachunkowego
                    if DataDo<DataPocz or DataDo >DataKonca:
                        stat="OKR DATADO"
                        dane.append(stat)
              
if stat=='OK':      
    if DataOd>DataDo:
        stat="OD WIE DO"
        dane.append(stat)

#SPRAWDZENIE CZY W ZAKRESIE DAT NIE MA ZAMKNIETYCH MIESIECY
if stat=='OK':
    SQL="SELECT zamkniety FROM rs_definicje_okresow_miesiace "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND rok || '-' || miesiac  "
    SQL+="BETWEEN substring('"+DataOd+"' FROM 1 FOR 7) AND substring('"+DataDo+"' FROM 1 FOR 7) "
    SQL+=" AND okres_id='"+OkresDekr+"' ORDER BY rok, miesiac ;"   
    stat,dmc,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(dmc)==0:
            stat="BR DAT"
            dane.append(stat)
        else:
            for w in dmc:
                if w[0] and stat=='OK':
                    stat='ZAM MC'
                    dane.append(stat)
        
if stat=='OK':
    SQL = "SELECT typ_wzoru,rejestr,magazyn_id,dokument_id,czy_zw,COALESCE(konto_id,'') FROM rs_wzory_dekretacji " \
          "WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,dn,dump,dump = self.PolSQL.Execute(SQL,3)
    
if stat=='OK':    
    if len(dn)==0:
        stat="BR WZORU"
        dane.append(stat)                  
        
if stat=='OK':
    TypWzoru=dn[0][0]
    MagId=rsglobal.Dekoduj(dn[0][2])
    DokId=rsglobal.Dekoduj(dn[0][3])

    #WSM
    if TypWzoru not in ("F","K","M","W","D","P"):
    # if TypWzoru not in ("F","K","M","W","D"):
        stat="BL TYP"
        dane.append(stat)                  
    else:
        Rejestr=dn[0][1]
        if Rejestr=='None':
            Rejestr='NULL'
        else:
            Rejestr="'"+Rejestr+"'"
    
if stat=='OK':
    if TypWzoru in ['F','K']:
        # FAKTURY I KOREKTY
        #sprawdzenie czy s zaksigowane wszystkie dokumenty do pocztku podanego okresu rozliczania        
        SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','F') "
        SQL+=" FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND data>='"+DataPocz+"'"
        SQL+=" AND data<'"+DataOd+"' AND stan <>'K'"
        SQL+=" AND wyznacznik_id IN (SELECT DISTINCT wyznacznik_id FROM rs_wzory_dekretacji_faktur "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"');"
        stat,df,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            for fakt in df:
                stat='NZK FAKT$'+fakt[0]
                dane.append('NZK FAKT$'+fakt[0])
                
        if stat=='OK':
            SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','K') "
            SQL+=" FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND data>='"+DataPocz+"'"
            SQL+=" AND data<'"+DataOd+"' AND stan <>'K' "
            SQL+=" AND COALESCE(wyznacznik_id_o,wyznacznik_id) IN (SELECT DISTINCT wyznacznik_id FROM rs_wzory_dekretacji_faktur "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"'"
            SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"');"
            stat,dk,dump,dump = self.PolSQL.Execute(SQL,3)                
            if stat=='OK':
                for kor in dk:
                    stat='NZK KOR$'+kor[0]
                    dane.append('NZK KOR$'+kor[0])
        
        #sprawdzenie czy s zamknite dokumenty od pocztku do koca podanego zakresu
        if stat=='OK':
            SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','F') "
            SQL+=" FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan IN ('W','G')"
            SQL+=" AND wyznacznik_id IN (SELECT DISTINCT wyznacznik_id FROM rs_wzory_dekretacji_faktur "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"'"
            SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"');"
            stat,df,dump,dump = self.PolSQL.Execute(SQL,3)                
            if stat=='OK':
                for fakt in df:
                    stat='NZAM FAKT$'+fakt[0]
                    dane.append('NZAM FAKT$'+fakt[0])
                
        if stat=='OK':
            SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','K') "
            SQL+=" FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan IN ('W','G')"
            SQL+=" AND COALESCE(wyznacznik_id_o,wyznacznik_id) IN (SELECT DISTINCT wyznacznik_id FROM rs_wzory_dekretacji_faktur "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"'"
            SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"');"

            stat,dk,dump,dump = self.PolSQL.Execute(SQL,3)                
            if stat=='OK':
                for kor in dk:
                    stat='NZAM KOR$'+kor[0]
                    dane.append('NZAM KOR$'+kor[0])

    elif TypWzoru=='M':
        # DOKUMENTY MAGAZYNOWE
        #pobranie typu dokumentu
        FiltrDok=''
        if DokId not in ('', None,'None'):
            FiltrDok+=" AND dokument_id='"+DokId+"'"
        if MagId not in ('', None,'None'):
            FiltrDok+=" AND magazyn_id='"+MagId+"'"
        
        
        #sprawdzenie czy s zaksigowane wszystkie dokumenty do pocztku podanego okresu rozliczania        
        SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| magazyn_id ||'\",\"'|| dokument_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','M') "
        SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND data>='"+DataPocz+"' AND data<'"+DataOd+"' AND stan <>'K'"+FiltrDok+";"
        stat,dm,dump,dump = self.PolSQL.Execute(SQL,3)                
        if stat=='OK':
            for dmag in dm:
                stat='NZK MAG$'+dmag[0]
                dane.append('NZK MAG$'+dmag[0])
                
        #sprawdzenie czy s zamknite dokumenty od pocztku do koca podanego zakresu                
        if stat=='OK':
            SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| magazyn_id ||'\",\"'|| dokument_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','M') "
            SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan IN ('W','G') "+FiltrDok+";"
            stat,dm,dump,dump = self.PolSQL.Execute(SQL,3)                
            if stat=='OK':
                for dmag in dm:
                    stat='NZAM MAG$'+dmag[0]
                    dane.append('NZAM MAG$'+dmag[0])

    elif TypWzoru=='D':
        # DOSTAWY

        #sprawdzenie czy s zaksigowane wszystkie dokumenty do pocztku podanego okresu rozliczania
        SQL = "SELECT data,numer "
        SQL += " FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data>='"+DataPocz+"' AND data<'"+DataOd+"' AND stan <>'K'"
        if MagId not in ('', None,'None'):
            SQL += " AND d_magazyn_id='"+MagId+"';"
        else:
            SQL += ";"
        stat,ds,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            for dost in ds:
                stat='NZK DOST$ z dnia '+str(dost[0])+' numer '+str(dost[1])
                dane.append('NZK DOST$ z dnia '+str(dost[0])+' numer '+str(dost[1]))
                
        #sprawdzenie czy s zamknite dokumenty od pocztku do koca podanego zakresu
        if stat=='OK':
            SQL="SELECT data,numer "
            SQL+=" FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan IN ('W','G')"
            if MagId not in ('', None, 'None'):
                SQL += " AND d_magazyn_id='" + MagId + "';"
            else:
                SQL += ";"
            stat,ds,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                for dost in ds:
                    stat='NZAM DOST$ z dnia '+str(dost[0])+' numer '+str(dost[1])
                    dane.append('NZAM DOST$ z dnia '+str(dost[0])+' numer '+str(dost[1]))

    #WS 2019-05-22
    elif TypWzoru=='P':
        # PACE

        Warunek = ''
        SQL = "SELECT COALESCE(warunek,'') FROM rs_wzory_dekretacji"
        SQL += " WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+OkresDekr+"'"  #WS 2021-11-09 - podmiana self.okres_id na OkresDekr
        SQL += " AND dowod_id = '"+Dowod+"' AND nazwa_id = '"+Nazwa+"';"
        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania warunku ze wzoru dekretacji'
            dane.append(stat)
        else:
            Warunek = d[0][0].strip()
            #WS 2021-11-09
            if 'UPDATE' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera UPDATE"
                dane.append(stat)
            elif 'DELETE' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera DELETE"
                dane.append(stat)
            elif 'INSERT' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera INSERT"
                dane.append(stat)
            elif 'DROP' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera DROP"
                dane.append(stat)
            elif 'ALTER' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera ALTER"
                dane.append(stat)
            elif 'TRUNCATE' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera TRUNCATE"
                dane.append(stat)
            elif 'COMMIT' in Warunek.upper():
                stat = u"Warunek wzoru dekretacji zawiera COMMIT"
                dane.append(stat)

        if stat == 'OK':
            #sprawdzenie czy wszystkie listy pac o dacie wypaty starszej od podanego okresu s w stanie 'K'
            SQL ="SELECT numer_listy_id, lista_id FROM rs_kp_listy_plac"
            SQL += " WHERE firma_id = '"+self.firma_id+"' AND data_do >= '"+DataPocz+"' AND data_do<'"+DataOd+"' AND stan != 'K'"
            if Warunek != '':
                SQL += " AND ("+Warunek+")"
            stat, lp, dump, dump = self.PolSQL.Execute(SQL,3)
            #WS 2021-11-09
            if stat != 'OK':
                stat = u"Bd pobrania list pac lub nieprawidowy warunek we wzorze dekretacji"
                dane.append(stat)
            else:
                for lista in lp:
                    stat = 'NZK LP$ '+str(lista[0])
                    dane.append(stat)

        #sprawdzenie czy wszystkie listy pac z podanego okresu s w stanie 'Z' lub 'K'
        if stat == 'OK':
            SQL ="SELECT numer_listy_id, lista_id FROM rs_kp_listy_plac"
            SQL += " WHERE firma_id = '"+self.firma_id+"' AND data_do >= '"+DataOd+"' AND data_do <= '"+DataDo+"' AND stan NOT IN ('Z','K')"
            if Warunek != '':
                SQL += " AND ("+Warunek+")"
            stat, lp, dump, dump = self.PolSQL.Execute(SQL, 3)
            #WS 2021-11-09
            if stat != 'OK':
                stat = u"Bd pobrania list pac lub nieprawidowy warunek we wzorze dekretacji"
                dane.append(stat)
            else:
                for lista in lp:
                    stat = 'NZAM LP$ '+str(lista[0])
                    dane.append(stat)
    
if stat == 'OK':
    
    #---------------------------------------------------------------------------
    #---- OBSUGA FAKTUR/KOREKT
    #---------------------------------------------------------------------------
    
    if TypWzoru in ("F","K"):
        #sprawdzenie czy wszystkie wyznaczniki maj zdefiniowane dla siebie wzory dekretacji
        SQL="SELECT DISTINCT wyznacznik_id FROM rs_wzory_dekretacji_faktur "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"';"
        stat,DaneWyznF,dump,dump = self.PolSQL.Execute(SQL,3)                    
        if stat=='OK':
            ListaWyzn=[]
            for poz in DaneWyznF:
                ListaWyzn.append(poz[0])
            
            ListaWyznBr=[]
            
            SQL="SELECT DISTINCT wyznacznik_id FROM rs_faktury "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"';"
            stat,DaneWyznF,dump,dump = self.PolSQL.Execute(SQL,3)                        
        if stat=='OK':
            for poz in DaneWyznF:
                if not poz[0] in ListaWyzn:
                    ListaWyznBr.append(rsglobal.Dekoduj(poz[0]))
            
                   
            SQL="SELECT DISTINCT COALESCE(wyznacznik_id_o,wyznacznik_id) FROM rs_korekty "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"';"
            stat,DaneWyznF,dump,dump = self.PolSQL.Execute(SQL,3)                    
        if stat=='OK':
            for poz in DaneWyznF:
                if not poz[0] in ListaWyzn:
                    ListaWyznBr.append(rsglobal.Dekoduj(poz[0]))

            if len(ListaWyznBr)>0:
                stat='BR WZDEK$'+str(ListaWyznBr)[1:-1]

        if stat=='OK':
            #pobranie oddziau z nagwka wzoru dekretacji
            stat,DOddz,dump,dump = self.PolSQL.Execute("SELECT COALESCE(oddzial_id,'') FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';",3)            
            
        if stat=='OK':
            if len(DOddz)==0:
                stat="BR WZORU"
                dane.append(stat)                  
        
        if stat=='OK':
            FiltrOddz=''
            if DOddz[0][0]<>'':
                FiltrOddz=" AND oddzial_id='"+rsglobal.Dekoduj(DOddz[0][0])+"' "
        
        if stat=='OK':
            #pobranie wyznacznikow
            stat,wyzn,dump,dump = self.PolSQL.Execute("SELECT DISTINCT wyznacznik_id FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDekr+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND NOT wyznacznik_id IS NULL;",3)
        if stat=='OK':
            if len(wyzn)==0:
                stat="BR WYZN"
                dane.append(stat)                  
        
        if stat=='OK':
            #Wygenerowanie listy wyznacznikw
            LWyzn=[]
            for w in wyzn:
                if w[0]<>'None':
                    LWyzn.append(rsglobal.Dekoduj(w[0]))
            
            #Pobranie listy faktur do zadekretowania
            #WS 2020-04-15 - pobranie ozn_trans, ozn_sprzedaz
            #WS 2020-06-23 - czy_mpp
            #WS 2024-02-23 - sprzedaz_uslug
            SQL="SELECT wyznacznik_id,data,numer,termin_zaplaty,platnik_id,waluta,kurs,do_zaplaty,"
            SQL+="do_zaplaty_wal,projekt_id,'',kontrahent_id,zamawiajacy_id,sposob_zaplaty,kierowca,"
            SQL+="handlowiec,wersja,COALESCE(data_przychodu,data),ozn_trans,ozn_sprzedaz,COALESCE(czy_mpp,FALSE),"
            SQL+="COALESCE(sprzedaz_uslug,FALSE)"
            SQL+=" FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND wyznacznik_id IN ("+str(LWyzn)[1:-1]+") AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
            SQL+=FiltrOddz+" AND stan='Z' ORDER BY data,wyznacznik_id,numer FOR UPDATE NOWAIT;"
            stat,dnf,dump,dump = self.PolSQL.Execute(SQL,3)

        if stat=='OK':
            #Pobranie listy korekt do zadekretowania
            #WS 2020-04-15 - pobranie ozn_trans, ozn_sprzedaz
            #WS 2020-06-23 - czy_mpp
            #WS 2024-02-23 - sprzedaz_uslug
            SQL="SELECT wyznacznik_id,data,numer,termin_zaplaty,platnik_id,waluta,kurs,do_zaplaty - do_zaplaty_p,"
            SQL+="do_zaplaty_wal - do_zaplaty_wal_p,projekt_id,COALESCE(wyznacznik_id_o,wyznacznik_id),kontrahent_id,zamawiajacy_id,"
            SQL+="sposob_zaplaty,kierowca,handlowiec,wersja,COALESCE(data_przychodu,data),ozn_trans,ozn_sprzedaz,COALESCE(czy_mpp,FALSE),"
            SQL+="COALESCE(sprzedaz_uslug,FALSE)"
            SQL+=" FROM rs_korekty "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND COALESCE(wyznacznik_id_o,wyznacznik_id) IN ("+str(LWyzn)[1:-1]+")"
            SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' "+FiltrOddz+" AND stan='Z'"
            SQL+=" ORDER BY data,wyznacznik_id,numer FOR UPDATE NOWAIT;"
            stat,dnk,dump,dump = self.PolSQL.Execute(SQL,3)                
        if stat=='OK':
            if len(dnf)+len(dnk)==0:
                stat="BR DOK"
                dane.append(stat)                  
        
        if stat=='OK' and len(dane)==0:    
            Data=DataOd
            Robic=True
            while Robic and stat=='OK':
                if Data==DataDo:
                    Robic=False
                    
                #Ptla po licie faktur
                for f in dnf:
                    if f[1]==Data:
                        dane = fs_dekretacja_automatyczna_pom.ZapiszFaktureKorekteDoPozycjiDowoduKsiegowego(self,klucze,f,dane,'rs_faktury','F-ra',Rejestr)
        
                #Ptla po licie korekt
                for k in dnk:
                    if k[1]==Data:
                        dane = fs_dekretacja_automatyczna_pom.ZapiszFaktureKorekteDoPozycjiDowoduKsiegowego(self,klucze,k,dane,'rs_korekty','Kor.',Rejestr)

                #pobranie nastpnego dnia        
                stat,DaneDnia,dump,dump = self.PolSQL.Execute("SELECT date '"+Data+"'+ INTEGER '1';",3)                                
                if stat == 'OK':
                    Data=DaneDnia[0][0]
                    
                if len(dane)>0:
                    stat = dane[0]
                    Robic=False

    #---------------------------------------------------------------------------
    #---- OBSUGA DOKUMENTW MAGAZYNOWYCH
    #---------------------------------------------------------------------------
                    
    elif TypWzoru=="M":
        Wybrany=None
        SlKTypow={}
        Rej=rsglobal.Dekoduj(dn[0][1])
        if Rej=='None':
            Rej='NULL'
            DataRej='NULL'
        else:
            Rej="'"+Rej+"'"

        #sprawdzenie magazynu/typu dokumentu z nagwka wzoru oraz czy jest to ZW
        MagN=rsglobal.Dekoduj(dn[0][2])
        DokN=rsglobal.Dekoduj(dn[0][3])
        CzyZW=dn[0][4]
        
        Filtr="dm.firma_id='"+self.firma_id+"' AND dm.stan='Z' AND dm.data>='"+DataOd+"' AND dm.data<='"+DataDo+"'"
        if MagN not in ('','None'):
            Filtr+=" AND dm.magazyn_id='"+MagN+"'"
        if DokN not in ('','None'):
            Filtr+=" AND COALESCE(dm.kor_dm_dokument_id,dm.dokument_id) ='"+DokN+"'"
            
        #pobranie listy dokumentw do zadekretowania
        SQL="SELECT dm.magazyn_id,dm.dokument_id,dm.data,dm.numer "
        SQL+=" FROM rs_dokumenty_magazynowe dm "
        SQL+=" WHERE "+Filtr+" ORDER BY dm.data,dm.magazyn_id,dm.dokument_id,dm.numer FOR UPDATE NOWAIT;"
        stat,DokMag,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            if 'blokady' in stat:
                stat = 'Bd pobrania listy dokumentw do zadekretowania+ - nie mona zablokowa wymaganych dokumentw. Sprbuj jeszcze raz za chwil.'
        
        #pobranie listy mozliwych pozycji wzoru do zadekretowania
        #jesli ZW to korzysta ze wzorw WZ (ale dostaje nagwek ZW)
        if stat=='OK':
            stat,DanePoz=fs_dekretacja_automatyczna_pom.PodajPozycjeWzorowDekretacjiDM(self.PolSQL,self.firma_id,OkresDekr,Dowod,Nazwa)
                    
        if stat=='OK':
            PozWz,CzyRozbicieWn,CzyRozbicieMa,CzyRozbicie=DanePoz
            if CzyRozbicie:
                stat,SlKTypow=fs_dekretacja_automatyczna_pom.PodajSlownikTypowArtykulow(self.PolSQL,self.firma_id,OkresDekr)
            
        #ptla po dokumentach magazynowych
        #rsglobal.ZapiszDoLogow('SLKL '+str(SlKTypow),1)
        if stat == 'OK':
            for dok in DokMag:
                if stat=='OK':
                    Mag=rsglobal.Dekoduj(dok[0])
                    DokId=rsglobal.Dekoduj(dok[1])
                    Data=rsglobal.Dekoduj(dok[2])
                    Numer=rsglobal.Dekoduj(str(dok[3]))

                    stat,dump=fs_dekretacja_automatyczna_pom.ZadekretujDokumentMagazynowy(self.PolSQL,self.firma_id,OkresDekr,Dowod,Nazwa,Data,
                        Mag,DokId,Data,Numer,PozWz,SlKTypow,CzyRozbicieWn,CzyRozbicieMa,CzyRozbicie,Rejestr,DataRej,False)

    #---------------------------------------------------------------------------
    #---- OBSUGA DOSTAW
    #---------------------------------------------------------------------------
                    
    elif TypWzoru=="D":
        Rej=rsglobal.Dekoduj(dn[0][1])
        if Rej=='None':
            Rej='NULL'
            DataRej='NULL'
        else:
            Rej="'"+Rej+"'"
        KontoId = rsglobal.Dekoduj(dn[0][5])
        if KontoId in ['None','']:
            KontoId='NULL'
        else:
            KontoId="'"+KontoId+"'"

        #pobranie listy dostaw do zadekretowania
        #WS 2020-04-05 - pobranie ozn_trans, ozn_nabycie, import
        SQL="SELECT data,numer,termin_plat,kontrahent_id,waluta,kurs,do_zaplaty," \
            " wersja,COALESCE(data_wplywu,data),COALESCE(nr_faktury,''),data_wystawienia, " \
            " rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| d_magazyn_id ||'\",\"'|| d_dokument_id ||'\",\"'|| d_data ||'\",\"'|| d_numer ||'\"]','M')," \
            " COALESCE(d_magazyn_id,''),ozn_trans,ozn_nabycie,import" \
            " FROM rs_dostawy WHERE firma_id='"+self.firma_id+"'" \
            " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan='Z' "
        if MagId not in ('', None, 'None'):
            SQL += " AND d_magazyn_id='" + MagId + "' "
        SQL += " ORDER BY data,numer FOR UPDATE NOWAIT;"
        stat,DokDost,dump,dump = self.PolSQL.Execute(SQL,3)

        if stat != 'OK':
            if 'blokady' in stat:
                stat = 'Bd pobrania listy dostaw do zadekretowania+ - nie mona zablokowa wymaganych dokumentw. Sprbuj jeszcze raz za chwil.'
        
        #ptla po dostawach (robione s wszystkie dostawy z dnia i jeli cay dzie jest OK to przechodzimy do nastpnego
        if stat=='OK' and len(dane)==0:
            Data=DataOd
            Robic=True
            while Robic and stat=='OK':
                if Data==DataDo:
                    Robic=False

                #Ptla po licie dostaw
                for dok in DokDost:
                    if dok[0]==Data:
                        dane = fs_dekretacja_automatyczna_pom.ZadekretujDostawe(self,dane,klucze,dok,Rej, KontoId)

                #pobranie nastpnego dnia
                stat,DaneDnia,dump,dump = self.PolSQL.Execute("SELECT date '"+Data+"'+ INTEGER '1';",3)
                if stat == 'OK':
                    Data=DaneDnia[0][0]

                if len(dane)>0:
                    stat = dane[0]
                    Robic=False

    #---------------------------------------------------------------------------
    #---- OBSUGA RӯNIC KURSOWYCH
    #---------------------------------------------------------------------------

    elif TypWzoru == 'W':
        stat = fs_dekretacja_automatyczna_pom.DekretacjaAutomatycznaRoznicKursowych(self,Dowod,Nazwa,DataOd,DataDo)

    #---------------------------------------------------------------------------
    #---- OBSUGA PAC
    #---------------------------------------------------------------------------

    #WS 2019-05-22
    elif TypWzoru == 'P':
        #pobranie z podanego okresu list pac w stanie 'Z'
        #WS 2019-06-18
        SQL ="SELECT numer_listy_id, data_do, lista_id FROM rs_kp_listy_plac"
        # SQL ="SELECT numer_listy_id, data_wyplaty FROM rs_kp_listy_plac"
        SQL += " WHERE firma_id = '"+self.firma_id+"' AND data_do >= '"+DataOd+"' AND data_do <= '" + DataDo + "' AND stan = 'Z'"
        #WS 2021-11-09
        if Warunek != '':
            SQL += " AND ("+Warunek+")"
        SQL += " ORDER BY data_do FOR UPDATE NOWAIT;"
        stat, ListyPlac, dump, dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

        if stat != 'OK':
            if 'blokady' in stat:
                stat = 'Nie mona zablokowa wymaganych list pac. Sprbuj jeszcze raz za chwil.'
            else:
                stat = 'Bd pobierania list pac : ' + stat
        else:
            if len(dane) == 0:
                if len(ListyPlac) == 0:
                    stat = 'Brak list pac do dekretacji.'
                else:
                    #WS 2021-11-09 - dodany OkresDekr w arg (dla harmonogramu)
                    stat, dane = fs_dekretacja_automatyczna_pom.DekretacjaAutomatycznaPlac(self, Dowod, Nazwa, ListyPlac, OkresDekr)

            if len(dane) > 0:
                stat = dane[0]
