#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_dok_mag_dostawy_tworz_dokument.py
# Purpose:		
# Author:		Dariusz Boduch , Micha Raburski
# Created:		2009/04/16
# RCS-ID:		$Id: fs_dok_mag_dostawy_tworz_dokument.py $
# Copyright:	(c) 2004-2009 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

#2011-05-13 Mariusz Rajfura kontrola tworzenia dok.mag z parametrami dla dokumentow w podanych magazynach (4578)
#2011-05-23 Mariusz Rajfura (4612) popr obslugi pustych parametrow dla kontrahenta i wersji 
#2011-07-26 Micha Raburski (7064) wprowadzenie opcji 'osobny_dokument' - przerobienie wszystkiego od nowa
#2017-10-11 Piotr Witkowski (10769) Tworzenie dokumentw magazynowych z dowodw dostaw - dodatkowe parametry
# 2019-02-06 Aleksander Bargie (11391) Funkcja 'Twrz dokumenty z dowodw dostaw' moe nie do koca sprawdzi, czy na wczeniejszych dowodach s dokumenty magazynowe
# 2020-04-05 Wojciech Skowron (11419) Uwzgldnienie kontrahenta przy sprawdzaniu, czy dla wczeniejszych dowodw dostaw utworzono dokumenty

import rsglobal
from funkcje import fs_dokumenty_magazynowe_pom

Data = klucze[0]
Zmiana = klucze[1]
MagazynWZP = klucze[2].strip()
MagazynRWP = klucze[3].strip()

Fun=klucze[-1]

stat='OK'

if Data in ('','    -  -  '):
    stat='BR DATY'
    dane.append(stat)
elif not rsglobal.SprawdzCzyToData(Data):
    stat='BL DATA'
    dane.append(stat)



ListaKontr = []
Kontrahenci = ''

#-------------------------------------------------------------------------------
#---TWORZENIE DOKUMENTOW DLA KONTRAHENTOW
#-------------------------------------------------------------------------------

if stat=='OK':
    #pobranie danych do tworzenia dok. mag dla danego oddzialu
    sql= "SELECT COALESCE(magazyn_id,''), COALESCE(magazyn_zw_id,''), COALESCE(kontrahent_id,'')," # 0-2
    sql+=" tryby_dostaw, osobne_dokumenty, COALESCE(magazyn_rw_id,'') " # 3-5
    sql+="FROM rs_dokumenty_magazynowe_dowody_dostaw "
    sql+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND zmiana='"+Zmiana+"' "
    if MagazynWZP <> '' and MagazynRWP <> '':
        sql += "AND (magazyn_id='"+MagazynWZP+"' OR magazyn_rw_id='"+MagazynRWP+"') "
    elif MagazynWZP <> '':
        sql += "AND magazyn_id='"+MagazynWZP+"' "
    elif MagazynRWP <> '':
        sql += "AND magazyn_rw_id='"+MagazynRWP+"' "
    sql+="ORDER BY CASE WHEN kontrahent_id IS NULL THEN 2 ELSE 1 END,kontrahent_id;"
    rsglobal.ZapiszDoLogow('JR SQL:' + sql, 5)
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    #rsglobal.ZapiszDoLogow('JR dane:' + str(dane), 1)
    if stat<>'OK':
        stat='BL SQL DM'
        dane.append(stat)
    elif len(dane)==0:
        stat='Dla podanych parametrw brak definicji w tabeli dokumenty magazynowe - dostawy.'
    
    if stat == 'OK':
        ByloSprawdzaniePoprzedniejDaty=False
        for w in dane:
            if stat == 'OK':
                Tryby = w[3]
                STryby = str(w[3])
                LstTryby=[]
                LTryby="(" 
        
                while len(Tryby)>0:
                    Ile = Tryby.rfind(',')
                    LTryby +="'"+str(Tryby[Ile+1:])+"',"
                    LstTryby.append(str(Tryby[Ile+1:]))
                    if Ile<0:
                        break
                    Tryby = Tryby[:Ile]
                LTryby = LTryby.rstrip(',')
                LTryby = LTryby+")"
        
            if stat == 'OK':
                MagazynWZ = (str(w[0])+'    ')[0:4]
                MagazynZW = (str(w[1])+'    ')[0:4]
                Kontrahent = str(w[2]).strip()
                OsobneDokumenty = w[4]
                MagazynRW = (str(w[5])+'    ')[0:4]
                
                # test czy w poprzednim dniu na danej zmianie s wpisane wszystkie dowody dostaw
                if OsobneDokumenty:
                    # pobranie daty wczeniejszych dowodw dostaw
                    SQL="SELECT MAX(data) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
                    #AB 06.02.19r. uwzgldnienie trybw
                    SQL+=" AND tryb_dostawy IN "+LTryby+" AND oddzial_id='"+self.oddzial_id+"' AND data<'"+Data+"'"
                    if Kontrahent != '':
                        SQL+=" AND kontrahent_id='"+Kontrahent+"'"  #WS 2020-04-05
                    stat,DData,dump,dump = self.PolSQL.Execute(SQL,3)
                    rsglobal.ZapiszDoLogow('DData SQL:' + SQL, 5)
                    if stat <>'OK':
                        stat = 'Bdy pobierania maksymalnej daty z dowodw dostaw : '+stat
                    elif str(DData[0][0]) not in ('None',''):
                        # sprawdzenie czy wszystkie dowody z tej daty maj uzupenione jedno z dwch pl wz_dokument_id/zw
                        SQL="SELECT dd.firma_id FROM rs_dowody_dostaw dd "
                        SQL+=" INNER JOIN rs_dowody_dostaw_pozycje ddp USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
                        SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' "
                        SQL+=" AND dd.data='"+DData[0][0]+"' AND dd.data>='2019-01-01'" # ostatnia data wstawiona na si na potrzeby SPC. Potem mona to wywali za tydzie
                        if MagazynWZP <> '' or MagazynRWP <> '':
                            SQL += "AND dd.tryb_dostawy IN "+LTryby+" "
                        if Kontrahent != '':
                            SQL+=" AND dd.kontrahent_id='"+Kontrahent+"'"  #WS 2020-04-05
                        SQL+=" AND COALESCE(dd.wz_dokument_id,dd.zw_dokument_id,'')='' "
                        SQL+=" AND (ddp.ilosc_dost1 >0 OR ddp.ilosc_zwr1>0) LIMIT 1;"
                        rsglobal.ZapiszDoLogow('DTest SQL:' + SQL, 5)
                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <>'OK':
                            stat = 'Bdy pobierania danych na dzie z dowodw dostaw : '+stat
                        elif len(DTest)>0:
                            stat = 'UWAGA, nie wszystkie dowody dostaw z dnia '+DData[0][0]+' maj wystawione dokumenty WZ/ZW'
                
            if stat == 'OK':
                if Kontrahent == '':
                    Kontrahenci = str(ListaKontr).replace('[','(').replace(']',')')
                else:
                    ListaKontr.append(Kontrahent)
            #Sprawdzenie poprawnosci danych
            if stat=='OK' and MagazynRW <>'    ':   
                stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynRW+"';",3)
                if stat=='OK':
                    if len(wyn)==0:
                        stat='Bdny magazyn WZ: '+MagazynWZ
                        
            if stat=='OK' and MagazynWZ <>'    ':   
                stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynWZ+"';",3)
                if stat=='OK':
                    if len(wyn)==0:
                        stat='Bdny magazyn WZ: '+MagazynWZ

            if stat=='OK' and MagazynZW <>'    ':   
                stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynZW+"';",3)
                if stat=='OK':
                    if len(wyn)==0:
                        stat='Bdny magazyn ZW: '+MagazynZW

            if stat == 'OK':
                if Kontrahent<>'':
                    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';",3)
                    if stat=='OK':
                        if len(wyn)==0:
                            stat='Bdny kontrahent: '+Kontrahent

            if stat == 'OK':
                for w in LstTryby:
                    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+w+"';",3)
                    if stat=='OK':    
                        if len(wyn)==0:
                            stat='Bdny tryb dostawy: '+str(w)
                            
            #Uprawnienia dla dokumentu w magazynie        
            if stat == 'OK':
                if self.operator_id <> STANDARD_OPERATOR_ID and stat=='OK' and MagazynWZ.strip() <>'':
                    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+MagazynWZ+"','WZ',4);",3)
                    if stat=='OK':
                        if len(wyn)==0:
                            stat='Brak uprawnie dodawania dokumentu WZ w magazynie: '+MagazynWZ
                        else:
                            if not wyn[0][0]:
                                stat='Brak uprawnie dodawania dokumentu WZ w magazynie: '+MagazynWZ

                if self.operator_id <> STANDARD_OPERATOR_ID and stat=='OK' and MagazynZW.strip() <>'':
                    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+MagazynZW+"','ZW',4);",3)
                    if stat=='OK':
                        if len(wyn)==0:
                            stat='Brak uprawnie dodawania dokumentu ZW w magazynie: '+MagazynZW
                        else:
                            if not wyn[0][0]:
                                stat='Brak uprawnie dodawania dokumentu ZW w magazynie: '+MagazynZW

                if self.operator_id <> STANDARD_OPERATOR_ID and stat=='OK' and MagazynRW.strip() <>'':
                    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+MagazynRW+"','RW',4);",3)
                    if stat=='OK':
                        if len(wyn)==0:
                            stat='Brak uprawnie dodawania dokumentu RW w magazynie: '+MagazynRW
                        else:
                            if not wyn[0][0]:
                                stat='Brak uprawnie dodawania dokumentu RW w magazynie: '+MagazynRW
            

            #-------------------------------------------------------------------------------
            #--   DOKUMENT RW
            #-------------------------------------------------------------------------------
            
            if stat=='OK' and MagazynRW<>'    ':
                stat = fs_dokumenty_magazynowe_pom.UtworzDokumentyMagazynoweZDokumentyMagazynoweDowodyDostaw(self,
                       'RW',Data,MagazynRW,Kontrahent,Kontrahenci,OsobneDokumenty,STryby)
                rsglobal.ZapiszDoLogow('10 '+stat,1)
                if stat<>'OK':
                    self.PolSQL.Rollback()
                
            #-------------------------------------------------------------------------------
            #--   DOKUMENT WZ
            #-------------------------------------------------------------------------------
            
            if stat=='OK' and MagazynWZ<>'    ':
                stat = fs_dokumenty_magazynowe_pom.UtworzDokumentyMagazynoweZDokumentyMagazynoweDowodyDostaw(self,
                       'WZ',Data,MagazynWZ,Kontrahent,Kontrahenci,OsobneDokumenty,STryby)
                rsglobal.ZapiszDoLogow('11 '+stat,1)
                if stat<>'OK':
                    self.PolSQL.Rollback()
                    
          
            #-------------------------------------------------------------------------------
            #--   DOKUMENT ZW
            #-------------------------------------------------------------------------------

            if stat=='OK' and MagazynZW<>'    ':
                stat = fs_dokumenty_magazynowe_pom.UtworzDokumentyMagazynoweZDokumentyMagazynoweDowodyDostaw(self,
                       'ZW',Data,MagazynZW,Kontrahent,Kontrahenci,OsobneDokumenty,STryby)
                rsglobal.ZapiszDoLogow('12 '+stat,1)
                if stat<>'OK':
                    self.PolSQL.Rollback()

            #-------------------------------------------------------------------------------
            #--   KOREKTY DOKUMENTW MAGAZYNOWYCH
            #-------------------------------------------------------------------------------

            if stat=='OK' and OsobneDokumenty:
                stat = fs_dokumenty_magazynowe_pom.UtworzKorektyDMZDokumentyMagazynoweDowodyDostaw(self,
                       Data,MagazynWZ,MagazynZW,MagazynRW,Kontrahent,Kontrahenci,STryby)
                rsglobal.ZapiszDoLogow('13 '+stat,1)
                if stat<>'OK':
                    self.PolSQL.Rollback()