# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_kontrahenci.py
# Purpose:     grid dokumentow dla kontrahentow
#
# Author:      Mariusz Rajfura
# Created:     2012/01/16
# RCS-ID:      $Id: fs_dokumenty_kontrahenci.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

import rsglobal
from funkcje import fs_pliki_global

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    Klucze_Id=klucze['Klucze_Id']
    SlPar ={'DataUtw':[2, 3, 6], 'Typ':[2, 3, 5, 6],
            'Szablon':[2, 3, 5, 6],  'Numer':[2, 3, 5, 6], 'OperatorF':[5,6],
            'DataDoF':[5,6], 'DataOdF':[5,6], 'KategKontrF':[5,6], 'KontrahentF':[5,6],
            'NumerOd':[5,6],'NumerDo':[5,6], 'TypF':[5,6],'SposPrzek':[3]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_dokumenty_kontrahenci z numerem ' + str(Funkcja) + ' bez parametrw: ' + Lista

if stat=='OK':
    if Funkcja in [2, 3, 6]:
        DataUtw= klucze['DataUtw']
        Typ= klucze['Typ']
        Szablon= klucze['Szablon']
        Numer= klucze['Numer']

    if Funkcja == 3:
        SposPrzek= klucze['SposPrzek']

    if Funkcja in [5,6]:
        TypF =klucze['TypF']
        SzablonF =klucze['SzablonF']
        NumerOd =klucze['NumerOd']
        NumerDo = klucze['NumerDo']
        OperatorF =klucze['OperatorF']
        DataDoF =klucze['DataDoF']
        DataOdF =klucze['DataOdF']
        KategKontrF =klucze['KategKontrF']
        KontrahentF=klucze['KontrahentF']

stat='OK'
dane = []
wyn1 = []

UprUsuwanie = ((self.oddzial_id,'076904') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
# POBRANIE NUMERU PLIKU - 2,6
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [2,6]:
    SQL="SELECT plik_id FROM rs_dokumenty_kontrahenci WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"'"
    SQL+=" AND szablon_id='"+Szablon+"' AND data_utworzenia='"+DataUtw+"' AND numer="+str(Numer)+";"
    stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK' and len(DPlik)==0:
        stat="Brak pliku przypisanego do dokumentu "+Typ+"/"+Szablon+"/"+DataUtw+"/"+str(Numer)


#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if stat=='OK' and Funkcja==2:
    stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
    dane=[Tresc]


#-------------------------------------------------------------------------------
#---   ZAPIS SPOSOBU PRZEKAZANIA DO DOKUMENTU (3)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==3:
    SQL="UPDATE rs_dokumenty_kontrahenci SET sposob_wyslania='"+SposPrzek+"'"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"' AND szablon_id='"+Szablon+"'"
    SQL+=" AND data_utworzenia='"+DataUtw+"' AND numer="+str(Numer)+";"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        
           
#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania szablonw'
            
    if stat=='OK':
        sql ="SELECT typ FROM rs_dokumenty_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"' AND szablon_id='"+Szablon+"'"
        sql+="AND data_utworzenia='"+DataUtw+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o dokumencie: '+stat
        elif len(d) == 0:
            stat = 'Dokument o podanym kluczu nie istnieje.'

    if stat=='OK':
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DPlik[0][0])

    if stat=='OK':
        DELETE ="DELETE FROM rs_dokumenty_kontrahenci"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"' AND szablon_id='"+Szablon+"'"
        DELETE+=" AND data_utworzenia='"+DataUtw+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat = 'Dokument uywany w innych tabelach. Usunicie niemoliwe.'


#-------------------------------------------------------------------------------
# SELECT 5,6
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6]:
    SELECT ="SELECT dk.kontrahent_id,COALESCE(k.nazwa,''::TEXT),dk.typ,dk.szablon_id,"
    SELECT+=" COALESCE(dks.opis,''::TEXT),COALESCE(dk.na_dzien::TEXT,''),dk.data_utworzenia,dk.numer,dk.operator_id,COALESCE(dk.sposob_wyslania,'')"
    SELECT+=" FROM rs_dokumenty_kontrahenci dk"
    SELECT+=" LEFT OUTER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
    SELECT+=" INNER JOIN rs_dokumenty_kontrahenci_szablony dks USING (firma_id,typ,szablon_id)"
    SELECT+=" WHERE dk.firma_id='"+self.firma_id+"'"
    if KontrahentF <> '':
        SELECT += " AND dk.kontrahent_id='"+KontrahentF+"'"
    if KategKontrF <> '':
        SELECT += " AND k.kateg_kontrahenta='"+KategKontrF+"'"
    if TypF <> '':
        SELECT += " AND dk.typ='"+TypF+"'"
    if SzablonF <> '':
        SELECT += " AND dk.szablon_id='"+SzablonF+"'"
    if DataOdF <> '':
        SELECT += " AND dk.data_utworzenia>='"+DataOdF+"'"
    if DataDoF <> '':
        SELECT += " AND dk.data_utworzenia<='"+DataDoF+"'"
    if OperatorF <> '' :
        SELECT += " AND dk.operator_id="+str(OperatorF)
    if not(NumerDo == 0 and NumerOd == 0):
        if NumerOd <> '' or NumerOd >= 0:
            SELECT += " AND dk.numer>="+str(NumerOd)
        if NumerDo <> '' or NumerDo >= 0:
            SELECT += " AND dk.numer<="+str(NumerDo)
    #uzupelnienie podgladu o klucze dodane lub zmienione
    if len(Klucze_Id) > 0:
        SELECT += " OR (dk.firma_id='"+self.firma_id+"' AND (dk.typ,dk.numer) IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                SELECT += ","
            SELECT += "('"+rsglobal.Dekoduj(Klucze_Id[i][0])+"',"+str(Klucze_Id[i][1])+")"
        SELECT += "))"
    
    SELECT+=" ORDER BY dk.typ,dk.numer;"
    rsglobal.ZapiszDoLogow('aaaaaaaaaaaaa '+str(SELECT),1)
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy szablonw : '+stat
