# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_kontrahenci_dane.py
# Purpose:     dodawanie dokumentow dla kontrahentow
# Author:      Mariusz Rajfura
# Created:     2012/01/16
# RCS-ID:      $Id: fs_dokumenty_kontrahenci_dane_dane.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------


stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

Fun=-1

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']

    SlPar={'Typ':[1,5],'Data':[1,5],'Numer':[5],'Szablon':[1,5],'Kontrahent':[1],'Konto':[1],'DataUtw':[1],'NaDzien':[1],
           'SaldaZero':[1],'WplatyOd':[1],'WplatyDo':[1],'ListaZaleglosci':[1],'MinKwota':[1],'Karencja':[1],
           'StronaMa':[1],'DrukowacOdsetki':[1],'OdsetkiNa':[1]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_kontrahenci_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if Fun in [1,5]:
    # zapis i pobranie danych
    Typ=klucze['Typ']
    Szablon=klucze['Szablon']
    Data=klucze['Data']

if Fun in [5]:
    Numer=klucze['Numer']    
    
# sprawdzamy dodatkowe klucze tylko dla dokumentw typu K
if stat=='OK':    
    if 'Typ' in SlPar:
        if klucze['Typ']=='K':
            SlPar={'DowodD':[1],'NazwaD':[1],'DataD':[1],'NumerD':[1]}
            Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
            if Lista<>'':
                stat='Uwaga : wywoanie funkcji fs_dokumenty_kontrahenci_dane z numerem '+str(Fun)+' i typem K bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1]:
        # utworzenie dokumentw
        Kontr=klucze['Kontrahent']
        Konto=klucze['Konto']
        DataUtw=klucze['DataUtw']
        DataNaDzien=klucze['NaDzien']
        CzySaldaZero=(klucze['SaldaZero']=='True')
        WplatyOd=klucze['WplatyOd']
        WplatyDo=klucze['WplatyDo']
        CzyZaleglosci=(klucze['ListaZaleglosci']=='True')
        MinKwota=klucze['MinKwota']
        DniKarencji=klucze['Karencja']
        CzyStronaMa=(klucze['StronaMa']=='True')
        Odsetki=(klucze['DrukowacOdsetki']=='True')
        DataOdsetek=klucze['OdsetkiNa']
        if Typ=='K':
            DowodD=klucze['DowodD']
            NazwaD=klucze['NazwaD']
            DataD=klucze['DataD']
            NumerD=klucze['NumerD']
        else:
            DowodD=''
            NazwaD=''
            DataD=''
            NumerD=0
if Fun==1 and stat=='OK':
    UprDodawanie = ((self.oddzial_id,'076903') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    if not UprDodawanie:
        stat = 'BR_UPR_INS'


#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -insert, 2 -update z pobraniem)
#-------------------------------------------------------------------------------
        
    if stat == 'OK':
        # sprawdzenie poprawnoci danych
        if Typ == '':
            stat = 'BR_TYP'
        else:
            # to jest rwnoczenie zabezpieczenie, e nikt nie doda w tym czasie tego typu dokumentu
            SQLForUpdate="SELECT kod FROM rs_dokumenty_kontrahenci_typy WHERE kod='"+Typ+"' FOR UPDATE NOWAIT;"
            stat,d,wyn1,dump = self.PolSQL.Execute(SQLForUpdate, 3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia typu dokumentu: '+stat
            elif len(d) == 0:
                stat = 'BL_TYP'

    if stat == 'OK':
        if Szablon == '':
            stat = 'BR_SZABLON'
        else:
            # sprawdzamy istnienie i przy okazji pobieramy dane konfiguracyjne
            SQL = "SELECT naglowek,COALESCE(tekst_pod_naglowkiem,''),COALESCE(tekst_pod_tabela,''),czy_numer_na_dokumencie "
            SQL+=" FROM rs_dokumenty_kontrahenci_szablony WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND typ='"+Typ+"' AND szablon_id='"+Szablon+"';"
            stat,DSzablony,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia szablonu dokumentu: '+stat
            elif len(DSzablony) == 0:
                stat = 'BL_SZABLON'
    if stat == 'OK':
        if Konto=='' and Typ <>'K':
            stat='BR_KONTA'
    if stat=='OK':
        if Kontr<>'':
            SQL = "SELECT nazwa FROM rs_kontrahenci"
            SQL+=" WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND kontrahent_id='"+Kontr+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy pobierania danych kontrahenta : '+stat
            elif len(d)==0:
                stat='BL_KONTR'
    if stat=='OK' and Typ<>'K':
        if DataUtw in ['','    -  -  ',None]:
            stat='BR_DATA_UTW'
        elif not rsglobal.SprawdzCzyToData(DataUtw):
            stat='BL_DATA_UTW'
    if stat=='OK' and Typ=='P':
        if DataNaDzien in ['','    -  -  ',None]:
            stat='BR_DATA_NA_DZIEN'
        elif not rsglobal.SprawdzCzyToData(DataNaDzien):
            stat='BL_DATA_NA_DZIEN'
    if stat=='OK' and Typ=='N':
        if WplatyOd in ['','    -  -  ',None]:
            stat='BR_WPLATY_OD'
        elif not rsglobal.SprawdzCzyToData(WplatyOd):
            stat='BL_WPLATY_OD'
            
        if stat=='OK':
            if WplatyDo in ['','    -  -  ',None]:
                stat='BR_WPLATY_DO'
            elif not rsglobal.SprawdzCzyToData(WplatyDo):
                stat='BL_WPLATY_DO'
        
        if stat=='OK':
            if WplatyOd>WplatyDo:
                stat='BL_WPLATY_ZAKR'
    if stat=='OK' and Typ=='W' and Odsetki:
        if DataOdsetek in ['','    -  -  ',None]:
            stat='BR_DATY_ODS'
        elif not rsglobal.SprawdzCzyToData(DataOdsetek):
            stat='BL_DATY_ODS'
            

    # Mamy DSzablony i tworzymy pliki. Wraca stat (czy si udao) oraz liczba utworzonych plikw
    #RW Dodany warunek sprawdzajcy czy uytkownik wybra jaki dokument
    if stat=='OK':
        if DataUtw == "" or DataUtw == '    -  -  ':
            stat ="BL_WYB"
        else:
            from funkcje import fs_dokumenty_kontrahenci_pdf
            ModulWydrukow=fs_dokumenty_kontrahenci_pdf.RSDokumentyKontrahenciPDF(self)
            stat,dane=ModulWydrukow.UtworzDokumentyPDF(Typ,Szablon,Kontr,Konto,DataUtw,DataNaDzien,
                 CzySaldaZero,WplatyOd,WplatyDo,CzyZaleglosci, MinKwota,DniKarencji,CzyStronaMa,Odsetki,DataOdsetek,
                 DSzablony,SQLForUpdate,DowodD,NazwaD,DataD,NumerD)
    if stat<>'OK':
        dane=[[0]]
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 1-insert z pobraniem )
#-------------------------------------------------------------------------------

if Fun in [5] and stat == 'OK':
    SELECT ="SELECT * FROM rs_dokumenty_kontrahenci"
    SELECT+=" WHERE firma_id='"+self.firma_id+"'"
    SELECT+=" AND typ='"+Typ+"' AND szablon_id='"+Szablon+"' AND data_utworzenia='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych szablonu.'

    if stat=='OK' and len(dane)==1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # typ [0]
        if (self.oddzial_id,'011960') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_dokumenty_kontrahenci_typy WHERE kod='"+tr.GetVal(0,"typ")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu ze typw dokumentw: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        # szablon_id [1]
        if (self.oddzial_id,'175000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT opis FROM rs_dokumenty_kontrahenci_szablony"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND typ='"+tr.GetVal(0,"typ")+"' AND szablon_id='"+tr.GetVal(0,"szablon_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu szablonw dokumentu: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do kartoteki szablonw. Poinformuj administratora.')

        # kontrahent_id [2]
        if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_kontrahenci"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania nazwy kontrahenta: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do kartoteki szablonw. Poinformuj administratora.')

        # operator_id [3]
        sql ="SELECT login FROM rs_operatorzy"
        sql+=" WHERE operator_id="+str(tr.GetVal(0,"operator_id"))+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            wyn2.append('Bd pobrania opisu operatora: '+stat)
        elif len(d) == 0:
            wyn2.append('')
        else:
            wyn2.append(rsglobal.Dekoduj(d[0][0]))
