# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_kontrahenci_pdf.py
# Purpose:     tworzenie i zapisywanie pdf dla dokumentow dla kontrahentow
# Author:      Micha Raburski
# Created:     2012/01/24
# RCS-ID:      $Id: fs_dokumenty_kontrahenci_pdf.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#2017-10-24 Rafa Woniak      (10722) dodanie sprawdzania stanu dokumentw
#2021-08-12 Aleksander Bargie (10870) Dokumenty - kontrahenci - zawijanie wierszy w szablonach
#                                        (przerbka nagwka by nadawca i odbiorca byli obok siebie)
#2021-08-31 Aleksander Bargie (12626) Bd funkcji wewn. przy generowaniu noty odsetkowej
#2022-07-13 Aleksander Bargie (12989) Komunikat gdy tworzenie raportu pdf nie powiedzie si

from string import *
import os
import rsglobal
import rs_print_util
from funkcje import fs_pliki_global

#Klasa, ktra pobiera dane do odpowiedniego rodzaju dokumentw, w oparciu o podane parametry, a 
# potem pozwala na odpowiednie ich wykorzystanie w tworzeniu plikw PDF

class RSDokumentyKontrahenciPDF:
    def __init__(self,parent=None):
        self.dane={}
        #self.maxlinii = RSLogin.MaxLinii
        #if self.maxlinii<30:
        self.maxlinii=56
        self.szer=136
        #self.rsp=RSPrintUtil.RSLinePrint(self.szer,parent)
        self.parent=parent
        self.PolSQL=parent.PolSQL

    #-##############################################################################
    # Tworzenie dokumentw w wersji pdf
    #-##############################################################################

    def UtworzDokumentyPDF(self,Typ,Szablon,Kontr,Konto,DataUtw,DataNaDzien,CzySaldaZero,WplatyOd,WplatyDo,
        CzyZaleglosci, MinKwota,DniKarencji,CzyStronaMa,Odsetki,DataOdsetek,DaneSzablon=None,SQLForUpdate='',DowodD='',
        NazwaD='',DataD='',NumerD=0):
        # UWAGA - poprawno kluczy bya zweryfikowana wczeniej
        stat='OK'
        LDok=0
        
        # pobranie najnowszego numeru dla szablonu
        SQL ="SELECT MAX(numer) FROM rs_dokumenty_kontrahenci"
        SQL+=" WHERE firma_id='"+self.parent.firma_id+"' AND typ='"+Typ+"' AND szablon_id='"+Szablon+"'"
        SQL+=" AND DATE_PART('YEAR',data_utworzenia)=DATE_PART('YEAR','"+DataUtw+"'::DATE);"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bd pobrania numeru dla nowego dokumentu: '+stat,[[0]]
        Numer = d[0][0]+1
        
        # pobranie danych szablonu jeli to potrzebne:
        if DaneSzablon in [[],None]:
            stat,DaneSzablon=self.PobierzDaneSzablonu(Szablon)  # todo
            if stat<>'OK':
                return stat,[[0]]
        
        #----------------------------
        # WYDRUK WEZWANIA DO ZAPATY 
        #----------------------------
        if Typ=='W':
            # pobranie danych do wydrukw
            stat,Dane=self.PobierzDaneWezwan(DataUtw,DniKarencji,Konto,Kontr,CzyStronaMa,Odsetki,DataOdsetek)
            if stat<>'OK':
                return stat,[[0]]
            
            # ptla po kontrahentach w danych
            #rsglobal.ZapiszDoLogow('! dane '+str(Dane),1)
            DaneR=Dane[0]
            SSumyKontr=Dane[1]
            for kl in SSumyKontr:
                try:
                    NrPliku=0
                    PlikPDF=None
                    if CzyStronaMa:
                        Suma=SSumyKontr[kl][0]-SSumyKontr[kl][1]
                    else:
                        Suma=SSumyKontr[kl][0]
                    if Suma <>0:
                        DaneK=[]
                        for poz in DaneR:
                            if poz[12]==kl:
                                DaneK.append(poz)

                        if len(DaneK)>0:
                            # jeli s dane to tworzymy plik PDF
                            stat,PlikPDF=self.StworzWezwaniePDF(DaneK,DaneSzablon,DataUtw,SSumyKontr[kl],CzyStronaMa,
                                           Konto,Numer,Odsetki,Szablon)
                            if stat=='OK' and PlikPDF <> None:
                                stat,LDok,Numer=self.StworzDokument(PlikPDF,SQLForUpdate,Typ,Szablon,Numer,kl,"'"+DataUtw+"'","NULL",Konto,LDok)
                                if stat<>'OK':
                                    rsglobal.ZapiszDoLogow('Bdy tworzenia dokumentu :'+stat,1)
                                    stat='OK'
                                
                except Exception,e:
                    rsglobal.ZapiszDoLogow('Bd wyjtku :'+str(e),1)
                    stat='OK'
                    self.WyczyscDokument(PlikPDF,NrPliku,SQLForUpdate)

        #----------------------------
        # WYDRUK POTWIERDZENIA SALD
        #----------------------------
        elif Typ=='P':
            # pobranie danych do wydrukw
            stat,SDane=self.PobierzDanePotwierdzenSald(DataUtw,DataNaDzien,Konto,Kontr)
            if stat<>'OK':
                return stat,[[0]]
            # lista kontrahentw
            KluczeKontr=SDane.keys()
            KluczeKontr.sort()
            for kontr in KluczeKontr:
                try:
                    NrPliku=0
                    PlikPDF=None
                    
                    # w zalenoci od ustawie sald i czy rozrachunki odpowiednio jeszcze segregujemy dane
                    DOddzialu=SDane[kontr][2]
                    SKont=SDane[kontr][0]
                    LKont=[]
                    KluczeKont=SKont.keys()
                    KluczeKont.sort()
                    for KlKonta in KluczeKont:
                        if CzySaldaZero:
                            # jeli strona wn = ma
                            if SKont[KlKonta][0]==SKont[KlKonta][1]:
                                LKont.append([KlKonta]+SKont[KlKonta])
                        else:
                            # jeli konto ma rozrachunki
                            if SKont[KlKonta][0]<>0 or SKont[KlKonta][1]<>0:
                                LKont.append([KlKonta]+SKont[KlKonta])
                        
                    LRozrach=[]
                    # jeli zaznaczono zalegoci i salda nie tylko zerowe
                    if (not CzySaldaZero) and CzyZaleglosci:
                        LRozrach=SDane[kontr][1]

                    if len(LKont)>0:
                        # jeli s dane to mona stworzy plik PDF
                        stat,PlikPDF=self.StworzPotwierdzenieSaldPDF(DOddzialu,LKont,LRozrach,DaneSzablon,DataUtw,
                                DataNaDzien,Numer,Szablon)
                        if stat=='OK' and PlikPDF<>None:
                            stat,LDok,Numer=self.StworzDokument(PlikPDF,SQLForUpdate,Typ,Szablon,Numer,kontr,"'"+DataUtw+"'","'"+DataNaDzien+"'",Konto,LDok)
                            if stat<>'OK':
                                rsglobal.ZapiszDoLogow('Bdy tworzenia dokumentu :'+stat,1)
                                stat='OK'
        
                except Exception,e:
                    rsglobal.ZapiszDoLogow('Bd wyjtku :'+str(e),1)
                    stat='OK'
                    self.WyczyscDokument(PlikPDF,NrPliku,SQLForUpdate)


        #----------------------------
        # WYDRUK NOTY ODSETKOWEJ
        #----------------------------
        elif Typ=='N':
            # pobranie danych do wydrukw
            stat,SDane=self.PobierzDaneNotyOdsetkowe(Kontr,Konto,WplatyOd,WplatyDo,DniKarencji,MinKwota)
            if stat<>'OK':
                return stat,[[0]]
            
            # lista kontrahentw
            KluczeKontr=SDane.keys()
            KluczeKontr.sort()
            for kontr in KluczeKontr:
                try:
                    NrPliku=0
                    PlikPDF=None

                    DOddzialu=SDane[kontr][3]
                    LFaktur=SDane[kontr][2]
                    Kwota=SDane[kontr][0]
                    Slownie=SDane[kontr][1]
                    
                    stat,PlikPDF=self.StworzNoteOdsetkowaPDF(DaneSzablon,DOddzialu,LFaktur,Kwota,Slownie,DataUtw,DniKarencji,Numer,Szablon)
                    if stat=='OK' and PlikPDF<>None:
                        stat,LDok,Numer=self.StworzDokument(PlikPDF,SQLForUpdate,Typ,Szablon,Numer,kontr,"'"+DataUtw+"'","NULL",Konto,LDok)
                        if stat<>'OK':
                            rsglobal.ZapiszDoLogow('Bdy tworzenia dokumentu :'+stat,1)
                            stat='OK'
        
                except Exception,e:
                    rsglobal.ZapiszDoLogow('Bd wyjtku :'+str(e),1)
                    stat='OK'
                    self.WyczyscDokument(PlikPDF,NrPliku,SQLForUpdate)

        #----------------------------
        # WYDRUK KOMPENSATY
        #----------------------------
        elif Typ=='K':
            # pobranie danych do wydrukw
            stat,Dane=self.PobierzDaneKompensaty(DowodD,NazwaD,DataD,NumerD)
            #[DaneO,DaneK,DNaleznosci,DZobowiazania,Suma]
            #stat=stat+' '+str(Dane)
            if stat<>'OK':
                return stat,[[0]]
            
            try:
                NrPliku=0
                PlikPDF=None

                DOddzialu=Dane[0]
                DKontr=Dane[1]
                DNaleznosci=Dane[2]
                DZobowiazania=Dane[3]
                Suma=Dane[4]
                Slownie=Dane[5]
                    
                stat,PlikPDF=self.StworzKompensatePDF(DaneSzablon,DOddzialu,DKontr,DNaleznosci,DZobowiazania,Suma,Slownie,DataD,Numer,Szablon)
                if stat=='OK' and PlikPDF<>None:
                    stat,LDok,Numer=self.StworzDokument(PlikPDF,SQLForUpdate,Typ,Szablon,Numer,DKontr[6],"'"+DataD+"'","NULL",'',LDok)
                    if stat<>'OK':
                        rsglobal.ZapiszDoLogow('Bdy tworzenia dokumentu kompensaty :'+stat,1)
    
            except Exception,e:
                rsglobal.ZapiszDoLogow('Bd wyjtku w tworzeniu kompensaty :'+str(e),1)
                self.WyczyscDokument(PlikPDF,NrPliku,SQLForUpdate)
            
        # wraca z wynikiem dla wszystkich typw dokumentw
        return stat,[[LDok]]

#-------------------------------------------------------------------------------
        
    #-##############################################################################
    # Pobranie danych szablonu dokumentu
    #-##############################################################################
    
    def PobierzDaneSzablonu(self,Szablon):
        return 'OK',[]
    
    
    #-##############################################################################
    # WEZWANIE DO ZAPATY
    #-##############################################################################
    
    def PobierzDaneWezwan(self,Data,Karencja,Konto,Kontrahent,CzyStrMa,Odsetki,DataOdsetek):
        from funkcje import fs_rozrachunki_pom
        stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self.parent,self.parent.okres_id)
        if stat <> 'OK':
            return stat,[]
        
        LOkr=LOkr[0]
        
        if CzyStrMa:
            PoleData='r.data'
        else:
            PoleData='r.data_wyst'
        
        KwotaWn="COALESCE(kwota_bo_wn,kwota_wn)-SUM(CASE WHEN data_rozlicz <= '"+Data+"' THEN " 
        KwotaWn+="rozliczone_wn ELSE 0 END)"
        KwotaMa="COALESCE(kwota_bo_ma,kwota_ma)-SUM(CASE WHEN data_rozlicz <= '"+Data+"' THEN "
        KwotaMa+="rozliczone_ma ELSE 0 END)"
        
        SQL="SELECT o.nazwa, o.adr_kod, o.adr_miej, o.adr_ulica, o.adr_nry, o.konto_bank, o.konto_nr," # 0-6
        SQL+="k.nazwa, k.adr_kod, k.adr_miej, k.adr_ulica, k.adr_nry,k.kontrahent_id, " # 7-12
        SQL+=" CASE WHEN r.symbol_dok IS NULL OR r.symbol_dok like' %' OR length(r.symbol_dok)=0 "
        SQL+=" THEN r.tresc ELSE r.symbol_dok END AS dokument," # 13
        SQL+=PoleData+", "+KwotaWn+" AS Winien,"+KwotaMa+" AS Ma," # 14-16
        SQL+=" CASE WHEN (COALESCE(kwota_bo_wn,kwota_wn)-sum(CASE WHEN data_rozlicz <= '"+Data+"' THEN " #
        SQL+=" rozliczone_wn ELSE 0 END) >0) THEN r.termin_plat::TEXT ELSE '' END AS Term_platn, " # 17
        SQL+=" CASE WHEN (COALESCE(kwota_bo_wn,kwota_wn)-sum(CASE WHEN data_rozlicz <= '"+Data+"' THEN "
        SQL+=" rozliczone_wn ELSE 0 END) >0) THEN ('"+Data+"'::DATE - r.termin_plat)::TEXT ELSE '' END AS Dni, " #18
        if Odsetki and not CzyStrMa:
            SQL+=" CASE WHEN r.termin_plat IS NULL OR "+KwotaWn+"<=0 THEN 0 ELSE "
            SQL+="rsf_podaj_odsetki(r.firma_id, r.termin_plat::TEXT,'"+DataOdsetek+"', "+KwotaWn+") END AS odsetki " #19
        else:
            SQL+=" 0" #19 
 
        SQL+=" FROM rs_rozrachunki r INNER JOIN rs_kontrahenci k  ON (k.firma_id=r.firma_id "
        SQL+=" AND k.kontrahent_id= regexp_replace(r.konto,'^.*-','' )) "
        SQL+=" LEFT OUTER JOIN rs_oddzialy o ON (o.firma_id=r.firma_id AND o.oddzial_id='"+self.parent.oddzial_id+"') "
        SQL+=" WHERE r.firma_id='"+self.parent.firma_id+"' AND r.okres_id IN ("+LOkr+")"
        SQL+=" AND (r.termin_plat + INTEGER '"+str(Karencja)+"' < '"+Data+"' OR r.termin_plat IS NULL) "
        if Kontrahent <> '':
            SQL+=" AND k.kontrahent_id='"+Kontrahent+"'"
        if Konto <> '':
            SQL+=" AND r.konto LIKE '"+Konto+"%' "
        
        SQL+=" GROUP BY o.nazwa, o.adr_kod, o.adr_miej, o.adr_ulica, o.adr_nry, o.konto_bank, o.konto_nr,"
        SQL+=" k.nazwa, k.adr_kod, k.adr_miej, k.adr_ulica, k.adr_nry, k.kontrahent_id,r.symbol_dok, r.tresc,"
        SQL+=PoleData+", r.kwota_wn, r.kwota_ma,r.kwota_bo_wn,r.kwota_bo_ma,r.firma_id,r.termin_plat, "
        SQL+=" r.dowod_id,r.nazwa_id,r.data,r.numer,r.nr_poz,r.nr_ppoz"
        SQL+=" HAVING "+KwotaWn+" <>0 OR "+KwotaMa+" <>0 "
        SQL+=" ORDER BY k.nazwa,"+PoleData
        
        stat,daneR,naglR,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return stat,[]
        if len(daneR)==0:
            stat='Brak danych do raportu '
            return stat,[]

        #------ Sownik z sumami dla poszczeglnych kontrahentw (suma wn, suma ma, slownie, odsetki)

        SSumyKontr={}
        for w in daneR:
            # kluczem jest symbol kontrahenta
            kl=w[12]
            if kl in SSumyKontr:
                poz=SSumyKontr[kl]
            else:
                poz=[0,0,'',0,0,'']
            # dodanie stron wn, ma i odsetek, sumy odsetek
            poz[0]+=w[15]
            poz[1]+=w[16]
            poz[3]+=w[19]
            

            SSumyKontr[kl]=poz
         
        for kl in SSumyKontr:
            if CzyStrMa:     
                liczba=SSumyKontr[kl][0]-SSumyKontr[kl][1]
            else:
                liczba=SSumyKontr[kl][0]
            # sownie kwota
            stat,daneS,naglS,dump=self.PolSQL.Execute("SELECT rsf_slownie("+str(liczba)+")" ,3)
            if stat<>'OK':
                return stat,[]
            SSumyKontr[kl][2]=daneS[0][0]
            
            # sownie kwota+odsetki
            liczba=rsglobal.RSRound(liczba+SSumyKontr[kl][3],2)
            SSumyKontr[kl][4]=liczba
            stat,daneS,naglS,dump=self.PolSQL.Execute("SELECT rsf_slownie("+str(liczba)+")" ,3)
            if stat<>'OK':
                return stat,[]
            SSumyKontr[kl][5]=daneS[0][0]
            if liczba<0:
                SSumyKontr[kl][5]='minus '+SSumyKontr[kl][5]
        
        return 'OK',[daneR,SSumyKontr]  

#-------------------------------------------------------------------------------

    def StworzWezwaniePDF(self,Dane,DaneSzablon,Data,LSumy,CzyStrMa,Konto,Numer,Odsetki,Szablon):
        Upr=(self.parent.oddzial_id,'076400') in self.parent.uprawnienia or (self.parent.operator_id == '0')
        if not Upr:
            return 'Brak uprawnie do tworzenia wezwa do zapaty',None
        try:
            rs_print_util.PrzygotujCzcionki()        
            OddzNazwa=Dane[0][0].strip();        OddzKod=Dane[0][1].strip();        OddzMiej=Dane[0][2].strip()
            OddzUlica=Dane[0][3].strip();        OddzNr=Dane[0][4].strip();  
            KontoBank=Dane[0][5].strip();        KontoNr=Dane[0][6].strip()
            KontrNazwa=Dane[0][7].strip();       KontrAdrKod=Dane[0][8].strip();    KontrAdrMiej=Dane[0][9].strip();
            KontrAdrUlica=Dane[0][10].strip();   KontrAdrNr=Dane[0][11].strip();    KontrKod=Dane[0][12].strip();
            
            Naglowek=DaneSzablon[0][0]
            TekstPodNagl=DaneSzablon[0][1]
            TekstPodTabelka=DaneSzablon[0][2]
            CzyNumer=DaneSzablon[0][3]
            if CzyNumer:
                Naglowek+=" W/"+Szablon.strip()+'/'+Data[:4]+"/"+rsglobal.UsunKropkaZero(Numer)

            # funkcja pomocnicza przekazywana dalej jako parametr do tworzenia PDFa
            # na razie nie zaburzam struktury, zwraca tekst "Warszawa dnia 2011-12-12"
            def zrobNaglowek(canvas, doc):
                Text=u""+OddzMiej+" dnia: " +Data+"   "
                xpos = rs_print_util.PAGE_WIDTH - (len(Text)*5) 
                ypos = rs_print_util.PAGE_HEIGHT - 2 * rs_print_util.cm
                canvas.setFont("DejaVu", 8)
                canvas.drawString(xpos,ypos,Text)
    
            Tresc=[]
            SumaWn=LSumy[0]
            SumaMa=LSumy[1]
            if CzyStrMa:
                Suma=SumaWn-SumaMa
            else:
                Suma=SumaWn
            
            Slownie=LSumy[2]
            SumaOds=LSumy[3]
            SumaWnZOds=LSumy[4]
            SlownieWnZOds=LSumy[5]

            for i in range(2):
                #-------------------------
                # OBRBKA TRECI
                #-------------------------
                
                # nagwek
                nagl=[]
                if i==0:
                    nagl.append([u"   ODCINEK A "])
                if i==1:
                    nagl.append([u"   ODCINEK B "])
                nagl.append([""])

                pocz=110-len(KontrNazwa)  #AB 12.08.21r
                wiersz = "Nadawca:"
                nagl.append([wiersz])
                wiersz = OddzNazwa
                nagl.append([wiersz])
                wiersz = OddzUlica+" "+OddzNr
                nagl.append([wiersz])
                wiersz = OddzKod+" "+OddzMiej
                nagl.append([wiersz + " "*(pocz-len(wiersz))+"Odbiorca:"])
                wiersz = KontoBank
                nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrNazwa])
                wiersz = u"Konto nr: "+KontoNr
                nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrAdrUlica+" "+KontrAdrNr])
                nagl.append([" "*(pocz)+KontrAdrKod+" "+KontrAdrMiej])
                nagl.append([' '*(pocz)+Konto+"/ /"+KontrKod])
                nagl.append([""])
                nagl.append([""])
                nagl.append([""])
                nagl.append([""])

                nagl.append([u""+Naglowek])
                
                TextW=u"<para font='DejaVu'>"
                TextW+= "<br/>&nbsp;&nbsp;&nbsp;&nbsp;"
                TextW+=TekstPodNagl.replace(' ','&nbsp;').replace('\n','<br/>').replace('##kwota##',str(Suma)).replace('##slownie##',Slownie).replace('##kwotazods##',str(SumaWnZOds)).replace('##slowniezods##',SlownieWnZOds)
                TextW+="<br/><br/></para>"
                    
                nagl.append([rs_print_util.Paragraph(TextW, rs_print_util.normalnyStyl)])

                # Tabelka z pozycjami
                DanePoz=[]
                    
                if Odsetki:
                    DanePoz.append([u"TRE / NR FAKTURY",u"Z DNIA",u"WINIEN",u"MA",u"TERMIN PAT.",u"DNI PO","ODSETKI"])                      
                else:
                    DanePoz.append([u"TRE / NR FAKTURY",u"Z DNIA",u"WINIEN",u"MA",u"TERMIN PAT.",u"DNI PO"])                      
                for w in Dane:
                    wiersz=[]
                    wiersz.append(u""+ljust(w[13].strip(),30))
                    wiersz.append(rjust(w[14].strip(),12))
                    wiersz.append(rs_print_util.PFloat(w[15],11,2))
                    wiersz.append(rs_print_util.PFloat(w[16],11,2))
                    wiersz.append(rjust(w[17],12))
                    wiersz.append(rjust(w[18],7))
                    if Odsetki:
                        wiersz.append(rs_print_util.PFloat(w[19],7,2))
                        
                    DanePoz.append(wiersz)
    
                # Suma pozycji
                Sumy=[""]*6
                if Odsetki:
                    Sumy+=[""]
                Sumy[1]="Razem: "
                Sumy[2]=rs_print_util.PFloat(SumaWn,12,2).lstrip()
                Sumy[3]=rs_print_util.PFloat(SumaMa,12,2).lstrip()
                if Odsetki:
                    Sumy[6]=rs_print_util.PFloat(SumaOds,9,2).lstrip()
                DanePoz.append(Sumy)
      
                # Tre pod tabelk
                if TekstPodTabelka.strip()<>'':
                    Paragraf="<para font='DejaVu'><br/>"+TekstPodTabelka.replace(' ','&nbsp;').replace('\n','<br/>').replace('##kwota##',str(Suma)).replace('##slownie##',Slownie).replace('##kwotazods##',str(SumaWnZOds)).replace('##slowniezods##',SlownieWnZOds)+"</para>"            
                    NaDole=[[rs_print_util.Paragraph(Paragraf, rs_print_util.normalnyStyl)]]

                Podpis=[]
                Podpis.append([""])
                Podpis.append([""])
                Podpis.append([80*" "+"Podpis wystawcy:"])
                Podpis.append([""])
    
                #-------------------------
                # OBRBKA WIZUALNA
                #-------------------------
                
                # Nagowek i tre
                tnagl=rs_print_util.Table(nagl)
                tnagl.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
                    ('FONT', (0,0), (-1,-1), 'DejaVuSansMono', 7),  #AB 12.08.21r
                    # ('FONT', (0,10), (-1,14), 'DejaVu', 10),
                    ('ALIGN', (0,14), (-1,14),'CENTER'),
                    ('FONT', (0,14), (-1,14), 'DejaVu-Bold', 10)]))
    
                # Pozycje tabelki
                KolumnyTabelki=[6*rs_print_util.cm,2*rs_print_util.cm,2.7*rs_print_util.cm,2.7*rs_print_util.cm,2*rs_print_util.cm,
                1*rs_print_util.cm,1.6*rs_print_util.cm]
                pozycje=rs_print_util.Table(DanePoz,KolumnyTabelki,repeatRows=1)
                pozycje.setStyle(rs_print_util.TableStyle(
                [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                 ('INNERGRID', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
                 ('BOX', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
                 ('ALIGN', (0,0), (-1,0),'CENTER'),
                 ('ALIGN', (1,1), (1,-1),'CENTER'),
                 ('ALIGN', (0,1), (0,-1),'LEFT'),
                 ('FONT', (0,0), (-1,-1), 'DejaVu', 8),
                 ('FONT', (0,0), (-1,0), 'DejaVu-Bold', 6),
                 ('FONT', (2,1), (3,-1), 'Courier', 8),
                 ('ALIGN', (2,1), (3,-1),'RIGHT'),
                 ('FONT', (0,-1), (-1,-1), 'Courier-Bold', 10),
                 ('FONT', (2,1), (-1,-1), 'Courier', 8),
                 ('ALIGN', (2,1), (-1,-1),'RIGHT'),
                 ('ALIGN', (0,-1), (-1,-1),'RIGHT')]))
                
                # Tre pod tabelk
                if TekstPodTabelka.strip()<>'':
                    Dol=rs_print_util.Table(NaDole)
                    Dol.setStyle(rs_print_util.TableStyle(
                    [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                     ('ALIGN', (0,0), (-1,-1),'RIGHT'),
                     ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))
                
                # Podpis
                Podp=rs_print_util.Table(Podpis)
                Podp.setStyle(rs_print_util.TableStyle(
                [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                 ('ALIGN', (0,0), (-1,-1),'LEFT'),
                 ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))
    
                # ZOENIE STRONY W CAO
                Tresc.append(tnagl)
                Tresc.append(pozycje)
                Tresc.append(rs_print_util.Spacer(1,1*rs_print_util.cm))
                if TekstPodTabelka.strip()<>'':
                    Tresc.append(Dol)
                Tresc.append(Podp)
                Tresc.append(rs_print_util.PageBreak())
                
            NazwaPliku='W_'+rsglobal.UsunKropkaZero(Numer)+'.pdf'
            #AB 13.07.22r dodana zwrotka z ZrobPdf
            stat = rs_print_util.ZrobPdf(self.parent.firma_id,NazwaPliku,'',Tresc,zrobNaglowek,
                                         rysujNaKolejnych=zrobNaglowek,ozdobniki=3)
            if stat != 'OK':
                return "Wystpi problem podczas generowania pliku w formacie PDF", None
        except Exception,e:
            import traceback
            rsglobal.ZapiszDoLogow(traceback.format_exc())
            return 'Bd :'+str(e),None

        return 'OK',NazwaPliku


    #-##############################################################################
    # POTWIERDZENIA SALD
    #-##############################################################################
    
    def PobierzDanePotwierdzenSald(self,Data,NaDzien,Konto,Kontrahent):
        from funkcje import fs_rozrachunki_pom
        stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self.parent,self.parent.okres_id)
        if stat <> 'OK':
            return stat,{}
        
        LOkr=LOkr[0]
        
        # pobranie kontrahentw i ich zalegoci
        KwotaWn="COALESCE(kwota_bo_wn,kwota_wn)-SUM(CASE WHEN data_rozlicz <= '"+NaDzien+"' THEN " 
        KwotaWn+="rozliczone_wn ELSE 0 END)"
        KwotaMa="COALESCE(kwota_bo_ma,kwota_ma)-SUM(CASE WHEN data_rozlicz <= '"+NaDzien+"' THEN "
        KwotaMa+="rozliczone_ma ELSE 0 END)"
        
        SQL="SELECT o.nazwa, o.adr_kod, o.adr_miej, o.adr_ulica, o.adr_nry, o.konto_bank, o.konto_nr," # 0-6
        SQL+="k.nazwa, k.adr_kod, k.adr_miej, k.adr_ulica, k.adr_nry,k.kontrahent_id,r.konto, " # 7-13
        SQL+=" CASE WHEN r.symbol_dok IS NULL OR r.symbol_dok like' %' OR length(r.symbol_dok)=0 "
        SQL+=" THEN r.tresc ELSE r.symbol_dok END AS dokument," # 14
        SQL+=KwotaWn+" AS Winien,"+KwotaMa+" AS Ma,r.data," # 15-17
        SQL+=" r.data_wyst " #18

        SQL+=" FROM rs_rozrachunki r INNER JOIN rs_kontrahenci k  ON (k.firma_id=r.firma_id "
        SQL+=" AND k.kontrahent_id= regexp_replace(r.konto,'^.*-','' )) "
        SQL+=" LEFT OUTER JOIN rs_oddzialy o ON (o.firma_id=r.firma_id AND o.oddzial_id='"+self.parent.oddzial_id+"') "
        SQL+=" WHERE r.firma_id='"+self.parent.firma_id+"' AND r.okres_id IN ("+LOkr+")"
        if Kontrahent <> '':
            SQL+=" AND k.kontrahent_id='"+Kontrahent+"'"
        if Konto <> '':
            SQL+=" AND r.konto LIKE '"+Konto+"%' "
        SQL+=" AND r.data<='"+NaDzien+"' AND k.potwierdzenie_sald"
        SQL+=" GROUP BY o.nazwa, o.adr_kod, o.adr_miej, o.adr_ulica, o.adr_nry, o.konto_bank, o.konto_nr,"
        SQL+=" k.nazwa, k.adr_kod, k.adr_miej, k.adr_ulica, k.adr_nry, k.kontrahent_id,r.symbol_dok, r.tresc,"
        SQL+=" r.kwota_wn, r.kwota_ma,r.kwota_bo_wn,r.kwota_bo_ma,r.termin_plat,r.konto,r.data, "
        SQL+=" r.dowod_id,r.nazwa_id,r.numer,r.nr_poz,r.nr_ppoz,r.data_wyst"
        SQL+=" ORDER BY k.nazwa,r.data"
        stat,daneR,naglR,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return stat,{}
        if len(daneR)==0:
            stat='Brak danych do raportu '
            return stat,{}
        
        #podzielenie danych na kontrahentw, zrobienie od razu sum odpowiednich danych do tabelek
        # klucz = kontrahent
        # dane [Sownik kont, Lista rozrachunkw, lista z danymi oddziau/kontrahenta
        SKontrWezwSald={}
        for poz in daneR:
            Kontr=poz[12]
            # jeli nie ma kontrahenta w sowniku to dodajemy jego list z danymi oddziau/kontrahenta
            if not Kontr in SKontrWezwSald:
                SKontrWezwSald[Kontr]=[{},[],poz[0:13]]

            # sprawdzamy konto - jeli nie ma to dodajemy do sownika wynikowego pierwszego parametru,
            # jeli jest to dodajemy do jego wyniku odpowiednie kwoty
            Konto=poz[13]
            KwotaWn=poz[15]
            KwotaMa=poz[16]
            if not Konto in SKontrWezwSald[Kontr][0]:
                SKontrWezwSald[Kontr][0][Konto]=[KwotaWn,KwotaMa]
            else:
                SKontrWezwSald[Kontr][0][Konto][0]+=KwotaWn
                SKontrWezwSald[Kontr][0][Konto][1]+=KwotaMa

            # dodanie pozycji do rozrachunkw nierozliczonych (tre/symbol dokumentu, data, kwota wn, kwota ma)
            if KwotaWn<> 0 or KwotaMa<>0:
                SKontrWezwSald[Kontr][1].append([poz[14],poz[17],KwotaWn,KwotaMa,poz[18]])

        return stat,SKontrWezwSald
    
#-------------------------------------------------------------------------------

    def StworzPotwierdzenieSaldPDF(self,Dane,DKonta,DRozrach,DaneSzablon,Data,NaDzien,Numer,Szablon):
        Upr=(self.parent.oddzial_id,'076600') in self.parent.uprawnienia or (self.parent.operator_id == '0')
        if not Upr:
            return 'Brak uprawnie do tworzenia wezwa do potwierdzenia sald',None
        
        try:
            rs_print_util.PrzygotujCzcionki()        
            OddzNazwa=Dane[0].strip();        OddzKod=Dane[1].strip();        OddzMiej=Dane[2].strip()
            OddzUlica=Dane[3].strip();        OddzNr=Dane[4].strip();  
            KontoBank=Dane[5].strip();        KontoNr=Dane[6].strip()
            KontrNazwa=Dane[7].strip();       KontrAdrKod=Dane[8].strip();    KontrAdrMiej=Dane[9].strip();
            KontrAdrUlica=Dane[10].strip();   KontrAdrNr=Dane[11].strip();    KontrKod=Dane[12].strip();
            
            Naglowek=DaneSzablon[0][0].strip()
            TekstPodNagl=DaneSzablon[0][1]
            TekstPodTabelka=DaneSzablon[0][2]
            CzyNumer=DaneSzablon[0][3]
            if CzyNumer:
                Naglowek+=" P/"+Szablon.strip()+'/'+Data[:4]+"/"+rsglobal.UsunKropkaZero(Numer)

            # funkcja pomocnicza przekazywana dalej jako parametr do tworzenia PDFa
            # na razie nie zaburzam struktury, zwraca tekst "Warszawa dnia 2011-12-12"
            def zrobNaglowek(canvas, doc):
                Text=u""+OddzMiej+" dnia: " +Data+"   "
                xpos = rs_print_util.PAGE_WIDTH - (len(Text)*5) 
                ypos = rs_print_util.PAGE_HEIGHT - 2 * rs_print_util.cm
                canvas.setFont("DejaVu", 8)
                canvas.drawString(xpos,ypos,Text)
    
            
            # policzenie sum
            SumaKontWn=0
            SumaKontMa=0
            for poz in DKonta:
                SumaKontWn+=poz[1]
                SumaKontMa+=poz[2]
                
            SumaRozrachWn=0
            SumaRozrachMa=0
            for poz in DRozrach:
                SumaRozrachWn+=poz[2]
                SumaRozrachMa+=poz[3]
            
            Tresc=[]
            
            for i in range(2):
                #-------------------------
                # OBRBKA TRECI
                #-------------------------
                
                # nagwek
                nagl=[]
                if i==0:
                    nagl.append([u"    ODCINEK A "])
                if i==1:
                    nagl.append([u"    ODCINEK B "])
                nagl.append([""])

                pocz=110-len(KontrNazwa)  #AB 12.08.21r
                wiersz = "Nadawca:"
                nagl.append([wiersz])
                wiersz = OddzNazwa
                nagl.append([wiersz])
                wiersz = OddzUlica+" "+OddzNr
                nagl.append([wiersz])
                wiersz = OddzKod+" "+OddzMiej
                nagl.append([wiersz + " "*(pocz-len(wiersz))+"Odbiorca:"])
                wiersz = KontoBank
                nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrNazwa])
                wiersz = u"Konto nr: "+KontoNr
                nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrAdrUlica+" "+KontrAdrNr])
                nagl.append([" "*(pocz)+KontrAdrKod+" "+KontrAdrMiej])
                nagl.append([" "*(pocz)+KontrKod])
                nagl.append([""])
                nagl.append([""])
                nagl.append([""])
                nagl.append([""])
                nagl.append([Naglowek])
                
                TextW=u"<para font='DejaVu'>"
                TextW+= "<br/>&nbsp;"
                TextW+=TekstPodNagl.replace(' ','&nbsp;').replace('\n','<br/>').replace('##NaDzien##',NaDzien)
                TextW+="</para>"
                
                nagl.append([rs_print_util.Paragraph(TextW, rs_print_util.normalnyStyl)])

                # Tabelka z kontami
                DaneKont=[]
                DaneKont.append([u"NR KONTA",u"NASZE",u"NA DOBRO",u"WASZE"])                      
                for w in DKonta:
                    wiersz=[]
                    wiersz.append(u""+ljust(w[0].strip(),25))
                    wiersz.append(rs_print_util.PFloat(w[1],11,2))
                    wiersz.append(rjust('',12))
                    wiersz.append(rs_print_util.PFloat(w[2],11,2))
                    DaneKont.append(wiersz)
    
                # Suma pozycji kont
                SumyK=[""]*4
                SumyK[0]="Razem: "
                SumyK[1]=rs_print_util.PFloat(SumaKontWn,12,2).lstrip()
                SumyK[3]=rs_print_util.PFloat(SumaKontMa,12,2).lstrip()
                DaneKont.append(SumyK)
                # jeli s rozrachunki to trzeba je wydrukowa
                DaneRozr=[]
                if len(DRozrach)>0:
                    TekstRozr=[[u"Podane powyej salda wynikaj z nastpujcych pozycji :"]]
                    
                    DaneRozr.append([u"TRE / NR FAKTURY",u"DATA KSIG.",u"DATA WYST.",u"WINIEN",u"MA"])
                    for w in DRozrach:
                        wiersz=[]
                        wiersz.append(u""+ljust(w[0].strip(),25))
                        wiersz.append(rjust(w[1].strip(),12))
                        if rsglobal.SprawdzCzyToData(w[4]):
                            wiersz.append(rjust(w[4].strip(),2))
                        else:
                            wiersz.append(rjust('',4))

                        wiersz.append(rs_print_util.PFloat(w[2],11,2))
                        wiersz.append(rs_print_util.PFloat(w[3],11,2))
                        DaneRozr.append(wiersz)

                    # Suma pozycji rozrachunkw
                    SumyR=[""]*5
                    SumyR[1]=" "
                    SumyR[2]="Razem: "
                    SumyR[3]=rs_print_util.PFloat(SumaRozrachWn,12,2).lstrip()
                    SumyR[4]=rs_print_util.PFloat(SumaRozrachMa,12,2).lstrip()
                    DaneRozr.append(SumyR)

                # Tre pod tabelk
                if TekstPodTabelka.strip()<>'':
                    Paragraf="<para font='DejaVu'><br/>"+TekstPodTabelka.replace(' ','&nbsp;').replace('\n','<br/>').replace('##NaDzien##',NaDzien)+"</para>"            
                    NaDole=[[rs_print_util.Paragraph(Paragraf, rs_print_util.normalnyStyl)]]

                Podpis=[]
                Podpis.append([""])
                Podpis.append([""])
                Podpis.append([80*" "+"Podpis wystawcy:"])
                Podpis.append([""])
    
                #-------------------------
                # OBRBKA WIZUALNA
                #-------------------------
                
                # Nagowek i tre
                tnagl=rs_print_util.Table(nagl)
                tnagl.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
                    ('FONT', (0,0), (-1,-1), 'DejaVuSansMono', 7),
                    # ('FONT', (0,10), (-1,14), 'DejaVu', 10),
                    ('ALIGN', (0,14), (-1,14),'CENTER'),           # tekst wezwanie do potwierdzenia sald
                    ('FONT', (0,14), (-1,14), 'DejaVu-Bold', 10)   # tekst wezwanie do potwierdzenia sald
                    ]))
    
                # Pozycje tabelki kont
                KolumnyTabelkiK=[7*rs_print_util.cm,2.7*rs_print_util.cm,4*rs_print_util.cm,4*rs_print_util.cm]
                PozK=rs_print_util.Table(DaneKont,KolumnyTabelkiK,repeatRows=1)
                PozK.setStyle(rs_print_util.TableStyle(
                [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                 ('INNERGRID', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
                 ('BOX', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
                 ('ALIGN', (0,0), (-1,0),'CENTER'),             # nagwek tabeli
                 ('ALIGN', (0,1), (0,-2),'LEFT'),               # kolumna konto bez "RAZEM"
                 ('ALIGN', (0,-1), (0,-1),'RIGHT'),             # "RAZEM"
                 ('ALIGN', (1,1), (3,-1),'RIGHT'),              # kwoty nasze i wasze
                 ('FONT', (0,0), (-1,0), 'DejaVu-Bold', 7),     # nagwek tabeli
                 ('FONT', (0,1), (0,-2), 'DejaVu', 8),          # kolumna konto bez "RAZEM" 
                 ('FONT', (0,-1), (0,-1), 'DejaVu-Bold', 8),    # "RAZEM"
                 ('FONT', (1,1), (3,-2), 'Courier', 8),         # kwoty nasze i wasze bez sum
                 ('FONT', (1,-1), (3,-1), 'Courier-Bold', 8)])) # sumy kwot naszych i waszych
                 

                # jeli s pozycje rozrachunkw do wydrukowania
                if DaneRozr<>[]:
                    # Nagowek i tre
                    trozr=rs_print_util.Table(TekstRozr)
                    trozr.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
                    ('FONT', (0,0), (-1,-1), 'DejaVu', 10) ]))
                    
                    # Pozycje tabelki rozrachunkw
                    KolumnyTabelkiR=[6*rs_print_util.cm,2.35*rs_print_util.cm,2.35*rs_print_util.cm,3.5*rs_print_util.cm,3.5*rs_print_util.cm]
                    PozR=rs_print_util.Table(DaneRozr,KolumnyTabelkiR,repeatRows=1)
                    PozR.setStyle(rs_print_util.TableStyle(
                    [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                     ('INNERGRID', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
                     ('BOX', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
                     ('ALIGN', (0,0), (-1,0),'CENTER'),               # nagwek tabeli  
                     ('ALIGN', (0,1), (0,-1),'LEFT'),                 # kolumna faktury
                     ('ALIGN', (1,1), (1,-2),'CENTER'),               # kolumna data bez "RAZEM" 
                     ('ALIGN', (1,-1), (1,-1),'RIGHT'),               # "RAZEM"
                     ('ALIGN', (2,1), (4,-1),'RIGHT'),                # kwoty wn i ma z sumami
                     ('FONT', (0,0), (-1,0), 'DejaVu-Bold', 7),       # nagwek tabeli
                     ('FONT', (0,1), (2,-2), 'DejaVu', 8),            # kolumna faktury i daty bez "RAZEM"
                     ('FONT', (1,-1), (1,-1), 'DejaVu-Bold', 8),      # "RAZEM"
                     ('FONT', (3,1), (4,-2), 'Courier', 8),           # kwoty wn i ma bez sumami
                     ('FONT', (3,-1), (4,-1), 'Courier-Bold', 8)]))  # sumy kwoty wn i ma
                
                # Tre pod tabelk
                if TekstPodTabelka.strip()<>'':
                    Dol=rs_print_util.Table(NaDole)
                    Dol.setStyle(rs_print_util.TableStyle(
                    [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                     ('ALIGN', (0,0), (-1,-1),'RIGHT'),
                     ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))
                
                # Podpis
                Podp=rs_print_util.Table(Podpis)
                Podp.setStyle(rs_print_util.TableStyle(
                [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                 ('ALIGN', (0,0), (-1,-1),'LEFT'),
                 ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))
    
                # ZOENIE STRONY W CAO
                Tresc.append(tnagl)
                Tresc.append(rs_print_util.Spacer(1,0.4*rs_print_util.cm))
                Tresc.append(PozK)
                if len(DRozrach)>0:
                    Tresc.append(rs_print_util.Spacer(1,0.4*rs_print_util.cm))
                    Tresc.append(trozr)
                    Tresc.append(rs_print_util.Spacer(1,0.4*rs_print_util.cm))
                    Tresc.append(PozR)
                Tresc.append(rs_print_util.Spacer(1,1*rs_print_util.cm))
                if TekstPodTabelka.strip()<>'':
                    Tresc.append(Dol)
                Tresc.append(Podp)
                Tresc.append(rs_print_util.PageBreak())
                
            NazwaPliku='P_'+rsglobal.UsunKropkaZero(Numer)+'.pdf'
            #AB 13.07.22r dodana zwrotka z ZrobPdf
            stat = rs_print_util.ZrobPdf(self.parent.firma_id,NazwaPliku,'',Tresc,zrobNaglowek,
                                         rysujNaKolejnych=zrobNaglowek,ozdobniki=3)
            if stat != 'OK':
                return "Wystpi problem podczas generowania pliku w formacie PDF", None
        except Exception,e:
            return 'Bd :'+str(e),None

        return 'OK',NazwaPliku
    
        
    #-##############################################################################
    # NOTA ODSETKOWA
    #-##############################################################################
    
    def PobierzDaneNotyOdsetkowe(self,Kontrahent,Konto,DataOd,DataDo,Karencja,MinKwota):
        # pobranie kontrahentw i ich zapaconych faktur
        SQL="SELECT o.nazwa AS onazwa, o.adr_kod AS okod, o.adr_miej AS omiej, o.adr_ulica AS oulica, " # 0-3
        SQL+="o.adr_nry AS onum, o.konto_bank AS obank, o.konto_nr AS okontonum, k.nazwa AS knazwa, "   # 4-7
        SQL+="k.adr_kod AS kkod, k.adr_miej AS kmiej, k.adr_ulica AS kulica, k.adr_nry AS knum,r.konto,k.kontrahent_id, "  # 8-13
        SQL+="CASE WHEN r.f_wyznacznik_id is null THEN (CASE WHEN r.tresc like 'faktura%' "
        SQL+="THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.parent.firma_id+"','[\"'||f.wyznacznik_id||'\",\"'||f.data::TEXT||'\",'||f.numer::TEXT||']', 'F') ELSE r.tresc END) "
        SQL+="ELSE rsf_podaj_numer_dokumentu_na_wydruk('"+self.parent.firma_id+"','[\"'||ff.wyznacznik_id||'\",\"'||ff.data::TEXT||'\",'||ff.numer::TEXT||']', 'F') END  AS faktura,"                    # 14
        SQL+=" COALESCE(ff.do_zaplaty,f.do_zaplaty),r.termin_plat, r2.data_zapl, r2.rozliczone_ma, "      # 15-18
        SQL+=" rsf_podaj_odsetki(r.firma_id, (r.termin_plat::TEXT), (r2.data_zapl::TEXT), r2.rozliczone_ma) AS odsetki " # 19
        
        SQL+="FROM rs_rozrachunki r "
        SQL+="LEFT OUTER JOIN rs_oddzialy o ON (r.firma_id=o.firma_id) "
        SQL+="LEFT OUTER JOIN rs_kontrahenci k ON (k.firma_id=r.firma_id "
        SQL+=" AND k.kontrahent_id= regexp_replace(r.konto,'^.*-','' )) "
        SQL+="LEFT OUTER JOIN rs_faktury ff ON (r.firma_id=ff.firma_id AND r.f_wyznacznik_id=ff.wyznacznik_id "
        SQL+="AND r.f_data=ff.data AND r.f_numer=ff.numer) "
        SQL+="LEFT OUTER JOIN rs_faktury f ON "
        SQL+="(r.firma_id=f.firma_id AND (CASE WHEN r.tresc LIKE 'faktura%' THEN "
        SQL+="f.wyznacznik_id=substring(r.tresc from 9 for 1) AND (f.data::TEXT)=substring(r.tresc from 11 for 10) AND "
        SQL+="f.numer=CAST(substring(r.tresc from 22) AS NUMERIC) END) OR (CASE WHEN r.tresc like 'faktura%' THEN "
        SQL+="f.wyznacznik_id=trim(substring(r.tresc from 9 FOR 2)) AND (f.data::TEXT)=substring(r.tresc FROM 12 for 10) AND "
        SQL+="f.numer=ROUND(CAST(substring(r.tresc from 23) AS NUMERIC))END)) "
        SQL+="INNER JOIN rs_rozrachunki r2 ON (r2.seria=r.seria_prz) "
        SQL+="WHERE r.firma_id='"+self.parent.firma_id+"' "
        SQL+="AND o.oddzial_id='"+self.parent.oddzial_id+"' "
        if Kontrahent <> '':
            SQL+=" AND k.kontrahent_id='"+Kontrahent+"'"
        if Konto <> '':
            SQL+=" AND r.konto LIKE '"+Konto+"%' "
        SQL+="AND r.termin_plat + INTEGER '"+str(Karencja)+"' < r2.data_zapl "
        SQL+="AND r2.data_zapl>= '"+DataOd+"' "
        SQL+="AND r2.data_zapl<='"+DataDo+"' "
        SQL+="AND r2.data_zapl>r.termin_plat "
        SQL+="AND k.nazwa IS NOT NULL "
        SQL+="AND (f.data>='2007-01-01' OR ff.data>='2007-01-01') "
        SQL+="AND r.rozliczone_wn<>0 "
        SQL+="ORDER BY k.kontrahent_id,r.data,r2.termin_plat,r2.data_zapl; "

        stat,Dane,dump,dump=self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)
        
        if stat<>'OK':
            return stat,{}
        if len(Dane)==0:
            stat='Brak danych do raportu '
            return stat,{}
        
        # stworzenie sownika z danymi do wydrukw. Klucz to Kontrahent.
        # warto to lista = [suma odsetek, odsetki sownie, [pozycje konkretnych faktur], [lista danych oddziau i kontrahenta]]
        SKontr={}
        for poz in Dane:
            Kontr=poz[13]
            Odsetki=rsglobal.RSRound(poz[19],2)
            if not Kontr in SKontr:
                SKontr[Kontr]=[0,'',[],poz[0:13]]
                
            if Odsetki>0:
                SKontr[Kontr][0]+=Odsetki
                SKontr[Kontr][2].append(poz[14:19]+[Odsetki])
        
        # podanie wartoci sownie i sprawdzenie czy dane przekraczaj kwot minimaln
        #AB 31.08.21r zamiast usuwa elementy z SKontr o zbyt niskiej kwocie dodany tymczasowy sownik do ktrego
        # wpisywane s tylko pasujce elementy
        tmp_slownik = {}
        rsglobal.ZapiszDoLogow(SKontr)
        for kl in SKontr:
            stat,daneS,dump,dump=self.PolSQL.Execute("SELECT rsf_slownie("+str(SKontr[kl][0])+")" ,3)
            if stat<>'OK':
                return stat,{}
            #  Odsetki > 0          odsetki >= kwota minimalna(moze byc 0, dlatego 1 warunek jest niezbedny)
            if SKontr[kl][0] > 0 and SKontr[kl][0] >= MinKwota:
                tmp_slownik[kl] = SKontr[kl]
                tmp_slownik[kl][1] = daneS[0][0]

        SKontr = tmp_slownik
        return 'OK', SKontr
    
#-------------------------------------------------------------------------------

    def StworzNoteOdsetkowaPDF(self,DaneSzablon,DOddzialu,LFaktur,Kwota,Slownie,DataUtw,DniKarencji,Numer,Szablon):
        Upr=(self.parent.oddzial_id,'076500') in self.parent.uprawnienia or (self.parent.operator_id == '0')
        if not Upr:
            return 'Brak uprawnie do tworzenia not odsetkowych',None
        try:
            rs_print_util.PrzygotujCzcionki()        
            OddzNazwa=DOddzialu[0].strip();        OddzKod=DOddzialu[1].strip();        OddzMiej=DOddzialu[2].strip()
            OddzUlica=DOddzialu[3].strip();        OddzNr=DOddzialu[4].strip();  
            KontoBank=DOddzialu[5].strip();        KontoNr=DOddzialu[6].strip()
            KontrNazwa=DOddzialu[7].strip();       KontrAdrKod=DOddzialu[8].strip();    KontrAdrMiej=DOddzialu[9].strip();
            KontrAdrUlica=DOddzialu[10].strip();   KontrAdrNr=DOddzialu[11].strip();    KontrKonto=DOddzialu[12].strip();
            
            Naglowek=DaneSzablon[0][0]
            TekstPodNagl=DaneSzablon[0][1]
            TekstPodTabelka=DaneSzablon[0][2]
            CzyNumer=DaneSzablon[0][3]
            if CzyNumer:
                Naglowek+=" N/"+Szablon.strip()+'/'+DataUtw[:4]+"/"+rsglobal.UsunKropkaZero(Numer)


            # funkcja pomocnicza przekazywana dalej jako parametr do tworzenia PDFa
            # na razie nie zaburzam struktury, zwraca tekst "Warszawa dnia 2011-12-12"
            def zrobNaglowek(canvas, doc):
                Text=u""+OddzMiej+" dnia: " +DataUtw+"   "
                xpos = rs_print_util.PAGE_WIDTH - (len(Text)*5) 
                ypos = rs_print_util.PAGE_HEIGHT - 2 * rs_print_util.cm
                canvas.setFont("DejaVu", 8)
                canvas.drawString(xpos,ypos,Text)
    
            Tresc=[]

            #-------------------------
            # OBRBKA TRECI
            #-------------------------
            
            # nagwek
            nagl=[]

            wiersz = "Nadawca:"
            pocz=110-len(KontrNazwa)  #AB 12.08.21r
            nagl.append([wiersz])
            wiersz = OddzNazwa
            nagl.append([wiersz])
            wiersz = OddzUlica+" "+OddzNr
            nagl.append([wiersz])
            wiersz = OddzKod+" "+OddzMiej
            nagl.append([wiersz])
            wiersz = KontoBank
            nagl.append([wiersz])
            wiersz = u"Konto nr: "+KontoNr
            nagl.append([wiersz + " "*(pocz-len(wiersz))+"Odbiorca:"])
            wiersz = ''
            nagl.append([" "*(pocz-len(wiersz))+KontrNazwa])
            nagl.append([" "*(pocz-len(wiersz))+KontrAdrUlica+" "+KontrAdrNr])
            nagl.append([" "*(pocz-len(wiersz))+KontrAdrKod+" "+KontrAdrMiej])
            nagl.append([" "*(pocz-len(wiersz))+KontrKonto])
            nagl.append([""])
            nagl.append([""])
            nagl.append([""])
            nagl.append([""])

            nagl.append([u""+Naglowek])
            
            TextW=u"<para font='DejaVu'>"
            TextW+= "<br/>&nbsp;&nbsp;&nbsp;&nbsp;"
            TextW+=TekstPodNagl.replace(' ','&nbsp;').replace('\n','<br/>').replace('##kwota##',str(Kwota)).replace('##slownie##',Slownie).replace('##dnikarencji##',str(DniKarencji))
            TextW+="<br/><br/></para>"
                
            nagl.append([rs_print_util.Paragraph(TextW, rs_print_util.normalnyStyl)])

            # Tabelka z pozycjami
            DanePoz=[]
                
            DanePoz.append([u"FAKTURA",u"KWOTA FAKTURY",u"TERMIN ZAPATY",u"DATA ZAPATY",u"KWOTA ZAPATY",u"KWOTA ODSETEK"])                      
            for w in LFaktur:
                wiersz=[]
                wiersz.append(u""+ljust(w[0].strip(),30))
                wiersz.append(rs_print_util.PFloat(w[1],14,2))
                wiersz.append(u""+w[2])
                wiersz.append(u""+w[3])
                wiersz.append(rs_print_util.PFloat(w[4],14,2))
                wiersz.append(rs_print_util.PFloat(w[5],14,2))
                    
                DanePoz.append(wiersz)
            
            # teksty o sumie do uregulowania
            TekstSum=[]
            TekstSum.append([u"RAZEM DO UREGULOWANIA: "+str(Kwota)+(" "*100)])
            TekstSum.append([""])
            TekstSum.append([u"SOWNIE: "+Slownie])
            TekstSum.append([""])

            # Tre pod tabelk (z tekstem karencji) lub sam tekst karencji
            if TekstPodTabelka.strip()<>'':
                Paragraf="<para font='DejaVu'><br/>"+TekstPodTabelka.replace(' ','&nbsp;').replace('\n','<br/>').replace('##kwota##',str(Kwota)).replace('##slownie##',Slownie).replace('##dnikarencji##',str(DniKarencji))+"<br/>"
                Paragraf+=u"Przy obliczaniu odsetek uwzgldniono "+str(DniKarencji)+u" dni karencji                                                                                                                                     </para>"  
                NaDole=[[rs_print_util.Paragraph(Paragraf, rs_print_util.normalnyStyl)]]
            else:
                # teksty o karencji
                TekstKarencji=[]
                TekstKarencji.append([u"Przy obliczaniu odsetek uwzgldniono "+str(DniKarencji)+u' dni karencji                                                                                                                                     '])
            
            Podpis=[]
            Podpis.append([""])
            Podpis.append([""])
            Podpis.append([80*" "+"Podpis wystawcy:"])
            Podpis.append([""])

            #-------------------------
            # OBRBKA WIZUALNA
            #-------------------------
            
            # Nagowek i tre
            tnagl=rs_print_util.Table(nagl)
            tnagl.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
                ('FONT', (0,0), (-1,-1), 'DejaVuSansMono', 7),
                # ('FONT', (0,8), (-1,12), 'DejaVu', 10),
                ('ALIGN', (0,14), (-1,14),'CENTER'),
                ('FONT', (0,14), (-1,14), 'DejaVu-Bold', 10)]))

            # Pozycje tabelki
            KolumnyTabelki=[5.7*rs_print_util.cm,3*rs_print_util.cm,2.9*rs_print_util.cm,2.6*rs_print_util.cm,2.9*rs_print_util.cm,
                            2.9*rs_print_util.cm]
            pozycje=rs_print_util.Table(DanePoz,KolumnyTabelki,repeatRows=1)
            pozycje.setStyle(rs_print_util.TableStyle(
            [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
             ('INNERGRID', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
             ('BOX', (0,0), (-1,0), 0.25, rs_print_util.colors.black),
             ('ALIGN', (0,0), (-1,0),'CENTER'),               # nagwek tabeli  
             ('ALIGN', (0,1), (0,-1),'LEFT'),                 # kolumna faktury
             ('ALIGN', (1,1), (1,-1),'RIGHT'),                # kolumna kwoty faktury
             ('ALIGN', (2,1), (3,-1),'CENTER'),               # kolumny dat 
             ('ALIGN', (4,1), (5,-1),'RIGHT'),                # kolumny kwoty zapaconej i odsetek
             ('FONT', (0,0), (-1,0), 'DejaVu-Bold', 7),       # nagwek tabeli
             ('FONT', (0,1), (1,-1), 'DejaVu', 8),            # kolumna faktury 
             ('FONT', (1,1), (1,-1), 'Courier', 8),           # kolumna kwoty faktury
             ('FONT', (2,1), (3,-1), 'DejaVu', 8),            # kolumny dat
             ('FONT', (4,1), (5,-1), 'Courier', 8)]))        # kolumny kwoty zapaconej i odsetek
            
            # Teksty podsumowania kwot
            TSum=rs_print_util.Table(TekstSum)
            TSum.setStyle(rs_print_util.TableStyle(
            [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
             ('ALIGN', (0,0), (-1,-1),'LEFT'),
             ('FONT', (0,0), (-1,-1), 'DejaVu', 9)]))
             
            # Tre pod tabelk z tekstem karencji
            if TekstPodTabelka.strip()<>'':
                Dol=rs_print_util.Table(NaDole)
                Dol.setStyle(rs_print_util.TableStyle(
                [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                 ('ALIGN', (0,0), (-1,-1),'RIGHT'),
                 ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))
            else:
                # lub sam tekst karencji
                TKarencji=rs_print_util.Table(TekstKarencji)
                TKarencji.setStyle(rs_print_util.TableStyle(
                [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
                 ('ALIGN', (0,0), (-1,-1),'LEFT'),
                 ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))
            
            # Podpis
            Podp=rs_print_util.Table(Podpis)
            Podp.setStyle(rs_print_util.TableStyle(
            [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
             ('ALIGN', (0,0), (-1,-1),'LEFT'),
             ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))

            # ZOENIE STRONY W CAO
            Tresc.append(tnagl)
            Tresc.append(pozycje)
            Tresc.append(rs_print_util.Spacer(1,1*rs_print_util.cm))
            Tresc.append(TSum)
            if TekstPodTabelka.strip()<>'':
                Tresc.append(Dol)
            else:
                Tresc.append(TKarencji)                
            Tresc.append(Podp)
                
            NazwaPliku='N_'+rsglobal.UsunKropkaZero(Numer)+'.pdf'
            #AB 13.07.22r dodana zwrotka z ZrobPdf
            stat = rs_print_util.ZrobPdf(self.parent.firma_id,NazwaPliku,'',Tresc,zrobNaglowek,
                                         rysujNaKolejnych=zrobNaglowek,ozdobniki=3)
            if stat != 'OK':
                return "Wystpi problem podczas generowania pliku w formacie PDF", None
        except Exception,e:
            return 'Bd :'+str(e),None

        return 'OK',NazwaPliku

    
    #-##############################################################################
    # KOMPENSATA
    #-##############################################################################
    
    def PobierzDaneKompensaty(self,DowodD,NazwaD,DataD,NumerD):
        # pobranie kontrahenta z dowodu ksigowego
        SQL="SELECT COALESCE(TRIM(kontrahent_id),''),stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.parent.firma_id+"'"
        SQL+=" AND dowod_id='"+DowodD+"' AND nazwa_id='"+NazwaD+"' AND data='"+DataD+"' AND numer="+str(NumerD)
        stat,DaneK,dump,dump=self.PolSQL.Execute(SQL,3)
        #RW Sprawdzanie stanu dokumentw
        if DaneK[0][1] not in ["Z","K"]:
            stat="NIE_ZAM"
        if stat=='OK':
            if len(DaneK)==0:
                stat='Brak wybranego dowodu ksigowego'
            elif DaneK[0][0]=='':
                stat='Na dowodzie ksigowym nie podano kontrahenta w nagwku'
        
        if stat=='OK':    
            # pobranie danych oddziau
            SQL="SELECT nazwa, adr_kod, adr_miej, adr_ulica, adr_nry, nip FROM rs_oddzialy "
            SQL+=" WHERE firma_id='"+self.parent.firma_id+"' AND oddzial_id='"+self.parent.oddzial_id+"';"
            stat,DaneO,dump,dump=self.PolSQL.Execute(SQL,3)
            
        if stat=='OK':    
            SQL="SELECT nazwa, adr_kod,adr_miej,adr_ulica,adr_nry,nip,TRIM(kontrahent_id) FROM rs_kontrahenci"
            SQL+=" WHERE firma_id='"+self.parent.firma_id+"' AND kontrahent_id='"+DaneK[0][0]+"';"
            stat,DaneK,dump,dump=self.PolSQL.Execute(SQL,3)
        
        if stat=='OK':
            # pobranie pozycji dowodu ksigowego oraz rozrachunkw do nich przypitych
            SQL="SELECT dp.tresc_ma,COALESCE(dp.data_wyst::TEXT,''),dp.kwota_ma,"
            SQL+=" COALESCE(r.tresc,''),COALESCE(r.data_wyst::TEXT,''),r.saldo_wn"
            SQL+=" FROM rs_dowody_ksiegowe_pozycje dp "
            SQL+=" LEFT OUTER JOIN rs_rozrachunki r ON (r.firma_id=dp.firma_id AND r.okres_id=dp.okres_id "
            SQL+=" AND r.seria::TEXT = ANY(STRING_TO_ARRAY(REPLACE(dp.seria_ma,' ',''),',')))"
            SQL+=" WHERE dp.firma_id='"+self.parent.firma_id+"' AND dp.dowod_id='"+DowodD+"'"
            SQL+=" AND dp.nazwa_id='"+NazwaD+"' AND dp.data='"+DataD+"' AND dp.numer="+str(NumerD)
            SQL+=" AND dp.kwota_ma<>0 ORDER BY dp.data_wyst,r.data_wyst"
            stat,DanePoz,dump,dump=self.PolSQL.Execute(SQL,3)
        
        if stat=='OK':
            # sprawdzenie czy kwoty umieszczone na rozrachunkach w sumie s wiksze ni kwota pozycji.
            # Przy okazji formatujemy dane
            DNaleznosci=[]
            DZobowiazania=[]
            KontrFaktS=''
            Suma=0
            for poz in DanePoz:
                KontrFakt=strip(poz[0].split(' ')[-1])
                
                if KontrFakt<>KontrFaktS:
                    if KontrFaktS<>'':
                        # sprawdzenie kwot
                        if Zostalo>0:
                            return 'Za mae saldo wn dla faktury kontrahenta '+KontrFaktS,[]
                        DZobowiazania.append([KontrFaktS,DataFakt,KwotaFakt])
                    KontrFaktS=KontrFakt
                    DataFakt=poz[1]
                    KwotaFakt=poz[2]
                    Zostalo=poz[2]
                    Suma+=poz[2]
            
                # zmniejszenie tego co zostao po stronie ma o stron wn
                if Zostalo>0:
                    DNaleznosci.append([poz[3],poz[4],min(Zostalo,poz[5])])
                Zostalo=Zostalo-poz[5]
                
                
            # sprawdzenie i zapisanie po ostatniej pozycji
            if Zostalo>0:
                return 'Za mae saldo wn dla faktury kontrahenta '+KontrFaktS,[]
            DZobowiazania.append([KontrFaktS,DataFakt,KwotaFakt])
            
        if stat=='OK':
            stat,daneS,dump,dump=self.PolSQL.Execute("SELECT rsf_slownie("+str(Suma)+")" ,3)
            
        if stat<>'OK':
            return stat,[]
        
        Slownie=daneS[0][0]
                            
        return 'OK',[DaneO[0],DaneK[0],DNaleznosci,DZobowiazania,Suma,Slownie]
        
#-------------------------------------------------------------------------------

    def StworzKompensatePDF(self,DaneSzablon,DOddzialu,DKontr,DNaleznosci,DZobowiazania,Suma,Slownie,DataD,Numer,Szablon):
        Upr=(self.parent.oddzial_id,'076931') in self.parent.uprawnienia or (self.parent.operator_id == '0')
        if not Upr:
            return 'Brak uprawnie do tworzenia kompensat',None
        try:
            rs_print_util.PrzygotujCzcionki()        
            OddzNazwa=DOddzialu[0].strip();        OddzKod=DOddzialu[1].strip();        OddzMiej=DOddzialu[2].strip()
            OddzUlica=DOddzialu[3].strip();        OddzNr=DOddzialu[4].strip();         OddzNIP=DOddzialu[5].strip();  
            KontrNazwa=DKontr[0].strip();          KontrAdrKod=DKontr[1].strip();       KontrAdrMiej=DKontr[2].strip();
            KontrAdrUlica=DKontr[3].strip();       KontrAdrNr=DKontr[4].strip();        KontrNIP=DKontr[5].strip();
            
            Naglowek=DaneSzablon[0][0]
            TekstPodNagl=DaneSzablon[0][1]
            CzyNumer=DaneSzablon[0][3]
            if CzyNumer:
                Naglowek+=" K/"+Szablon.strip()+'/'+DataD[:4]+"/"+rsglobal.UsunKropkaZero(Numer)
                
            # funkcja pomocnicza przekazywana dalej jako parametr do tworzenia PDFa
            # na razie nie zaburzam struktury, zwraca tekst "Warszawa dnia 2011-12-12"
            def zrobNaglowek(canvas, doc):
                Text=u""+OddzMiej+" dnia: " +DataD+"   "
                xpos = rs_print_util.PAGE_WIDTH - (len(Text)*5) 
                ypos = rs_print_util.PAGE_HEIGHT - 2 * rs_print_util.cm
                canvas.setFont("DejaVu", 8)
                canvas.drawString(xpos,ypos,Text)
    
            Tresc=[]

            #-------------------------
            # OBRBKA TRECI
            #-------------------------
            
            # nagwek
            nagl=[]

            pocz=80-len(KontrNazwa)  #AB 12.08.21r
            wiersz = "Nadawca:"
            nagl.append([wiersz + " "*(pocz-len(wiersz))+"Odbiorca:"])
            wiersz = OddzNazwa
            nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrNazwa])
            wiersz = OddzUlica+" "+OddzNr
            nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrAdrUlica+" "+KontrAdrNr])
            wiersz = OddzKod+" "+OddzMiej
            nagl.append([wiersz + " "*(pocz-len(wiersz))+KontrAdrKod+" "+KontrAdrMiej])
            wiersz = u"NIP: "+OddzNIP
            nagl.append([wiersz])
            nagl.append([""])
            nagl.append([""])

            nagl.append([u""+Naglowek])
            
            TextW=u"<para font='DejaVu'>"
            TextW+= "<br/>&nbsp;&nbsp;&nbsp;&nbsp;"
            TextW+=TekstPodNagl.replace(' ','&nbsp;').replace('\n','<br/>').replace('##kwota##',str(Suma)).replace('##slownie##',Slownie).replace('##data##',str(DataD))
            TextW+="<br/><br/></para>"
                
            nagl.append([rs_print_util.Paragraph(TextW, rs_print_util.normalnyStyl)])

            # Tabelka z pozycjami
            DanePoz=[]
                
            DanePoz.append([u"Nalenoci","","","",u"Zobowizania","",""])                      
            DanePoz.append(["Symbol.dok","Data wyst.","Saldo wn","","Symbol.dok","Data wyst.","Saldo ma"])
            
            # na pewno nr serii jest wicej lub tyle samo co pozycji
            i=0
            for poz in DNaleznosci:
                wiersz=[]
                wiersz.append(u""+ljust(poz[0].strip(),30))
                wiersz.append(u""+ljust(poz[1].strip(),10))
                wiersz.append(rs_print_util.PFloat(poz[2],14,2))
                wiersz.append(u"")
                if len(DZobowiazania)>i:
                    wiersz.append(u""+ljust(DZobowiazania[i][0].strip(),30))
                    wiersz.append(u""+ljust(DZobowiazania[i][1].strip(),10))
                    wiersz.append(rs_print_util.PFloat(DZobowiazania[i][2],14,2))
                else:
                    wiersz+=["","",""]
                i+=1
                    
                DanePoz.append(wiersz)
                
            # wiersz z sum
            DanePoz.append(["SUMA","",rs_print_util.PFloat(Suma,14,2),"","SUMA","",rs_print_util.PFloat(Suma,14,2)])
            
            Podpis=[]
            Podpis.append([""])
            Podpis.append([""])
            Podpis.append([80*" "+"Podpis wystawcy:"])
            Podpis.append([""])

            #-------------------------
            # OBRBKA WIZUALNA
            #-------------------------
            
            # Nagowek i tre
            tnagl=rs_print_util.Table(nagl)
            tnagl.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
                ('FONT', (0,0), (-1,-1), 'DejaVuSansMono', 10),
                # ('FONT', (0,6), (-1,12), 'DejaVu', 10),
                ('ALIGN',(0,7), (-1,7),'CENTER'),
                ('FONT', (0,7), (-1,7), 'DejaVu-Bold', 10)]))

            # Pozycje tabelki
            KolumnyTabelki=[4*rs_print_util.cm,2*rs_print_util.cm,2.9*rs_print_util.cm,1.5*rs_print_util.cm,
                            4*rs_print_util.cm,2*rs_print_util.cm,2.9*rs_print_util.cm]
            pozycje=rs_print_util.Table(DanePoz,KolumnyTabelki,repeatRows=1)
            pozycje.setStyle(rs_print_util.TableStyle(
            [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
             ('INNERGRID', (0,1), (2,1), 0.25, rs_print_util.colors.black),
             ('INNERGRID', (4,1), (6,1), 0.25, rs_print_util.colors.black),
             ('BOX', (0,1), (2,1), 0.25, rs_print_util.colors.black),
             ('BOX', (4,1), (6,1), 0.25, rs_print_util.colors.black),
             ('ALIGN', (0,0), (-1,0),'CENTER'),               # nagwek tabeli  
             ('ALIGN', (0,1), (0,-1),'LEFT'),                 # kolumna dokumentu nalenoci
             ('ALIGN', (1,1), (1,-1),'CENTER'),               # kolumna daty nalenoci
             ('ALIGN', (2,1), (2,-1),'RIGHT'),                # kolumna kwoty nalenoci
             ('ALIGN', (4,1), (4,-1),'LEFT'),                 # kolumna dokumentu zobowiza
             ('ALIGN', (5,1), (5,-1),'CENTER'),               # kolumna daty zobowiza
             ('ALIGN', (6,1), (6,-1),'RIGHT'),                # kolumna kwoty zobowiza
             ('FONT', (0,0), (-1,0), 'DejaVu-Bold', 8),       # napisy Nalenoci i Zobowizania
             ('FONT', (0,1), (-1,1), 'DejaVu-Bold', 7),       # nagwek tabeli
             ('FONT', (0,2), (1,-1), 'DejaVu', 8),            # kolumna dokumentu i daty nalenoci
             ('FONT', (2,2), (2,-1), 'Courier', 8),           # kolumna kwoty faktury nalenoci
             ('FONT', (4,2), (5,-1), 'DejaVu', 8),            # kolumna dokumentu i daty zobowiza
             ('FONT', (6,2), (6,-1), 'Courier', 8),           # kolumna kwoty faktury zobowiza
             ('FONT', (0,-1), (0,-1), 'DejaVu-Bold', 8),      # wiersz z sumami - SUMA Nal
             ('FONT', (2,-1), (2,-1), 'Courier-Bold', 8),     # wiersz z sumami - kwota Nal
             ('FONT', (4,-1), (4,-1), 'DejaVu-Bold', 8),      # wiersz z sumami - SUMA Zob
             ('FONT', (6,-1), (6,-1), 'Courier-Bold', 8)]))   # wiersz z sumami - kwota Zob
            
                    
            # Podpis
            Podp=rs_print_util.Table(Podpis)
            Podp.setStyle(rs_print_util.TableStyle(
            [('TEXTCOLOR',(0,0),(-1,0),rs_print_util.colors.black),
             ('ALIGN', (0,0), (-1,-1),'LEFT'),
             ('FONT', (0,0), (-1,-1), 'DejaVu', 8)]))

            # ZOENIE STRONY W CAO
            Tresc.append(tnagl)
            Tresc.append(pozycje)
            Tresc.append(Podp)
                
            NazwaPliku='K_'+rsglobal.UsunKropkaZero(Numer)+'.pdf'
            #AB 13.07.22r dodana zwrotka z ZrobPdf
            stat = rs_print_util.ZrobPdf(self.parent.firma_id,NazwaPliku,'',Tresc,zrobNaglowek,
                                         rysujNaKolejnych=zrobNaglowek,ozdobniki=3)
            if stat != 'OK':
                return "Wystpi problem podczas generowania pliku w formacie PDF", None
        except Exception,e:
            return 'Bd :'+str(e),None

        return 'OK',NazwaPliku




#-------------------------------------------------------------------------------
#- OBSUGA PLIKW PDF
#-------------------------------------------------------------------------------

    #-- funkcja pomocnicza zapisujca plik PDF na odpowiednim miejscu dysku, tworzca dokument o podanych parametrach 
    # oraz czca plik z rs_pliki z odpowiednim dokumentem w rs_dokumenty_kontrahenci
    def StworzDokument(self,PlikPDF,SQLForUpdate,Typ,Szablon,Numer,Kontr,DataUtw,DataNaDzien,Konto,LDok):
        try:
            try:
                stat='OK'
                NrPliku=0
                TrescPliku=fs_pliki_global.PodajTrescPliku(PlikPDF)
                if TrescPliku==None:
                     return 'Bdy pobierania treci pliku',LDok,Numer
                                        
                #zabezpieczenie by nikt inny nic nie wstawia w dokumentach
                SQL="SELECT * FROM rs_pliki WHERE firma_id='"+self.parent.firma_id+"'"
                SQL+=" AND tabela='rs_dokumenty_kontrahenci' FOR UPDATE NOWAIT;"
                #wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i poczenie klucza z obu tabel.
                SQL+="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
                SQL+="('"+self.parent.firma_id+"','"+PlikPDF+"','rs_dokumenty_kontrahenci',FALSE);"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    
                if stat<>'OK':
                    return 'Bd wstawiania pliku: '+stat,LDok,Numer
                
                SQL="SELECT max(plik_id) FROM rs_pliki WHERE firma_id='"+self.parent.firma_id+"' AND tabela='rs_dokumenty_kontrahenci';"
                stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
    
                if stat<>'OK':
                    return 'Bd pobrania numeru pliku: '+stat,LDok,Numer
                        
                NrPliku=str(DNum[0][0])
                #wrzucamy plik na serwer
                stat=fs_pliki_global.WstawPlikNaSerwer(self.parent.KatalogPlikow,NrPliku,TrescPliku)
    
                if stat<>'OK':
                    return 'Bd wsatawienia pliku na serwer: '+stat,LDok,Numer
    
                # wstawienie dokumentu
                SQL ="INSERT INTO rs_dokumenty_kontrahenci (firma_id,typ,szablon_id,numer,kontrahent_id,data_utworzenia,"
                SQL+=" na_dzien,operator_id,konto,plik_id) VALUES ('"+self.parent.firma_id+"','"+Typ+"','"+Szablon+"',"
                SQL+=str(Numer)+" ,'"+Kontr+"',"+DataUtw+","+DataNaDzien+","+str(self.parent.operator_id)+",'"+Konto+"',"+str(NrPliku)+");"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
                if stat<>'OK':
                    return 'Bd wstawienia dokumentu kontrahenta: '+stat,LDok,Numer
                
                os.remove(PlikPDF)
                self.PolSQL.Commit()
                LDok+=1
                Numer+=1
                return 'OK',LDok,Numer
            
            finally:
                if stat<>'OK':
                    # operator tego nie zobaczy, ale my zobaczymy w logach
                    self.PolSQL.Rollback()
                    rsglobal.ZapiszDoLogow('Bd tworzenia dokumentu PDF :'+stat,1)
                    stat='OK'
                    self.WyczyscDokument(PlikPDF,NrPliku,'')    
                    
                if SQLForUpdate <>'':
                    stat,dump,dump,dump=self.PolSQL.Execute(SQLForUpdate,1)        
                    if stat<>'OK':
                        return 'Bdy blokowania dokumentw :'+stat,LDok,Numer
                    
        except Exception,e:
            self.WyczyscDokument(PlikPDF,NrPliku,SQLForUpdate)
            return 'Bd wyjtku w tworzeniu dokumentu :'+str(e),LDok,Numer
        
#-------------------------------------------------------------------------------

    def WyczyscDokument(self,PlikPDF,NrPliku,SQLForUpdate):
        if PlikPDF <> None:
            os.remove(PlikPDF)
        if NrPliku>0:
            fs_pliki_global.UsunPlikZSerwera(self.parent.KatalogPlikow,NrPliku)

        self.PolSQL.Rollback()

        if SQLForUpdate <>'':
            stat,dump,dump,dump=self.PolSQL.Execute(SQLForUpdate,1)        
            if stat<>'OK':
                return 'Bdy blokowania dokumentw :'+stat,[[LDok]]