# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_kontrahenci_szablony_dane.py
# Purpose:     szablony dokumentow dla kontrahentow - edycja
# Author:      Mariusz Rajfura
# Created:     2012/01/10
# RCS-ID:      $Id: fs_dokumenty_kontrahenci_szablony_dane_dane.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2012-01-18 Mariusz Rajfura  nowe pole 'czy_numer_na_dokumencie' (5397)

Typ = rsglobal.Dekoduj(klucze[0]).strip()
Szablon = rsglobal.Dekoduj(klucze[1]).strip()
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = ((self.oddzial_id,'175003') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = ((self.oddzial_id,'175002') in self.uprawnienia or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat = 'BR_UPR_INS'
        
    if stat == 'OK':
        if Typ == '':
            stat = 'BR_TYP'

    if stat == 'OK':
        if Szablon == '':
            stat = 'BR_SZABLON'
    
    if stat == 'OK':
        sql ="SELECT kod FROM rs_dokumenty_kontrahenci_typy WHERE kod='"+Typ+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia typu dokumentu: '+stat
        elif len(d) == 0:
            stat = 'BL_TYP'

    if stat == 'OK':
        sql ="SELECT typ,szablon_id FROM rs_dokumenty_kontrahenci_szablony"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"'"
        sql+=" AND szablon_id='"+Szablon+"';"
        
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia szablonu: '+stat
        elif len(d) > 0:
            stat = 'BL_KLUCZ_IST'
    
    if stat == 'OK':        
        inspola = 'firma_id'
        inswart = "'"+self.firma_id+"'"
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ('typ','szablon_id','opis','naglowek',
                        'tekst_pod_naglowkiem','tekst_pod_tabela'):
                if wart.strip() == '':
                    wart = 'NULL'
                else:
                    wart = "'"+wart+"'"
                
            elif pole in ('karencja_dni','kwota_minimum','kontrahent_od_miejsca'):
                wart = str(wart)
            
            elif pole in ('czy_strona_ma','czy_numer_na_dokumencie'):
                if wart:
                    wart = 'TRUE'
                else:
                    wart = 'FALSE'

            inspola += ","+pole
            inswart += ","+wart
        
        if stat == 'OK':
            INSERT = "INSERT INTO rs_dokumenty_kontrahenci_szablony ("+inspola+") VALUES ("+inswart+");"
            stat,d,dump,dump = self.PolSQL.Execute(INSERT, 1)
            if stat <> 'OK':
                stat = 'Bd dodawania nowego szablonu: '+stat


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR_UPR_UPD'

    if stat == 'OK':
        sql ="SELECT typ,szablon_id FROM rs_dokumenty_kontrahenci_szablony"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"'"
        sql+=" AND szablon_id='"+Szablon+"' FOR UPDATE NOWAIT;"
        
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia szablonu: '+stat
        elif len(d) == 0:
            stat = 'BL_KLUCZ_NIST'

    if stat == 'OK':             
        sqlupd = ''
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ('opis','naglowek','tekst_pod_naglowkiem','tekst_pod_tabela'):
                if wart.strip() == '':
                    wart = 'NULL'
                else:
                    wart = "'"+wart+"'"

            elif pole in ('czy_strona_ma','czy_numer_na_dokumencie'):
                if wart:
                    wart = 'TRUE'
                else:
                    wart = 'FALSE'

            elif pole in ('karencja_dni','kwota_minimum','kontrahent_od_miejsca'):
                wart = str(wart)
                    
            sqlupd += pole+"="+wart+","
            
        if stat == 'OK' and len(sqlupd) > 0:
            sqlupd = sqlupd[:-1]
            UPDATE ="UPDATE rs_dokumenty_kontrahenci_szablony SET "+sqlupd
            UPDATE+=" WHERE firma_id='"+self.firma_id+"'"
            UPDATE+=" AND typ='"+Typ+"' AND szablon_id='"+Szablon+"';"
            
            stat,d,dump,dump = self.PolSQL.Execute(UPDATE, 1)
            if stat <> 'OK':
                stat = 'Bd aktualizacji danych szablonu: '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem  1-insert z pobraniem )
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    SELECT ="SELECT * FROM rs_dokumenty_kontrahenci_szablony"
    SELECT+=" WHERE firma_id='"+self.firma_id+"'"
    SELECT+=" AND typ='"+Typ+"' AND szablon_id='"+Szablon+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych szablonu.'

    if stat=='OK' and len(dane)==1:
        tr = rssql.RSTableRowset(dane,wyn1)
        if (self.oddzial_id,'011960') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_dokumenty_kontrahenci_typy WHERE kod='"+tr.GetVal(0,"typ")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu ze typw dokumentw: '+stat)
            elif len(d) == 0:
                wyn2.append('Bdny typ dokumentu dla kontrahenta.')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
