# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_ceny_zmiany.py
# Purpose:     obsuga zmian cen w dokumentach magazynowych
# Author:      Micha Raburski
# Created:     2014/02/06
# RCS-ID:      $Id: fs_dokumenty_magazynowe_ceny_zmiany.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

# Funkcje:
#  5 - sprawdzenie danych przed wejciem w okienko zmiany cen
#  6 - sprawdzenie danych dla dokumentu (czy aktywowa funkcj)
#  9 - pobranie listy dokumentw dla pojedynczego dokumentu pierwotnego
# 10 - zmiana ceny dla pojedynczego dokumentu pierwotnego

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Magazyn':[5,6,9,10],'Dokument':[5,6,9,10],'Data':[5,6,9,10],'Numer':[5,6,9,10],
    'NrPoz':[5,9,10],'NrPPoz':[5,9,10],'Cena1':[9,10],'Cena2':[9,10],'ListaDokumentow':[10],'ListaKorekt':[10]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_ceny_zmiany z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [5,6,9,10]:
        Mag = rsglobal.Dekoduj(klucze['Magazyn'])
        Dok = rsglobal.Dekoduj(klucze['Dokument'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = str(klucze['Numer'])
    if Fun in [5,9,10]:
        NrPoz = str(klucze['NrPoz'])
        NrPPoz = str(klucze['NrPPoz'])
    if Fun in [9,10]:
        Cena1 = klucze['Cena1']
        Cena2 = klucze['Cena2']
    if Fun == 10:
        LDok = klucze['ListaDokumentow'] 
        LKor = klucze['ListaKorekt'] 

if Fun in [5,6,9] and stat == 'OK':
    # sprawdzenie czy dokument jest w stanie Z/K i czy ma typ P
    SQL="SELECT dm.stan, td.typ_dokumentu "
    SQL+=" FROM rs_dokumenty_magazynowe dm INNER JOIN rs_typy_dokumentow_m td USING (firma_id,dokument_id) "
    SQL+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Mag+"'"
    SQL+=" AND dm.dokument_id='"+Dok+"' AND dm.data='"+Data+"' AND dm.numer="+Numer
    stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobierania danych dokumentu : '+stat
    elif len(wyn) == 0:
        stat= 'Brak dokumentu o podanych parametrach'
    elif not wyn[0][0] in ['Z','K']:
        stat= 'Zmian cen mona wykonywa tylko na dokumentach w stanie "Z" lub "K"'
    elif not wyn[0][1] =='P':
        stat= 'Zmian cen mona wykonywa tylko na dokumentach przychodowych'

    # sprawdzenie uprawnie do zmiany ceny w magazynie na dokumencie
    if stat == 'OK' and self.operator_id <> STANDARD_OPERATOR_ID:
        SQL="SELECT zmiana_ceny FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND operator_id="+str(self.operator_id)+" AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania uprawnie do dokumentu : '+stat
        elif len(wyn) == 0:
            stat= 'Brak uprawnie do zmiany ceny - brak dokumentu '+Dok+' na licie dokumentw uprawnionych operatora'
        elif not wyn[0][0]:
            stat= 'Brak uprawnie do zmiany ceny - wyczona opcja na uprawnieniach dokumentw uprawnionych operatora'

#-------------------------------------------------------------------------------
# pobranie przelicznika i dynamicznego przelicznika na okienko z podawaniem cen (5)
#-------------------------------------------------------------------------------

if Fun == 5 and stat == 'OK':
    SQL="SELECT a.przelicznik,a.dynamiczny_przelicznik "
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Mag+"'"
    SQL+=" AND dmp.dokument_id='"+Dok+"' AND dmp.data='"+Data+"' AND dmp.numer="+Numer
    SQL+=" AND dmp.nr_poz="+str(NrPoz)+" AND dmp.nr_ppoz="+str(NrPPoz)
    stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat='Bdy pobrania danych artykuu : '+stat
    elif len(wyn)==0:
        stat='Brak artykuu o kodzie '+Art
    else:
        dane=[wyn[0][0],wyn[0][1]]

#-------------------------------------------------------------------------------
# pobranie listy dokumentw dla zmiany ceny na jednym dokumencie (9)
#-------------------------------------------------------------------------------
        
if Fun == 9 and stat == 'OK':
    # przygotowanie listy dokumentw do obrbki
    from funkcje import fs_dokumenty_magazynowe_ciagnione
    KluczDok=[Mag,Dok,Data,Numer,NrPoz,NrPPoz]
    stat,Listy = fs_dokumenty_magazynowe_ciagnione.PodajDokumentyPochodne(self.PolSQL,self.firma_id,KluczDok)
    if stat =='OK':
        dane=Listy
        
#-------------------------------------------------------------------------------
# zmiana ceny na jednym dokumencie (10)
#-------------------------------------------------------------------------------
        
if Fun == 10 and stat == 'OK':
    from funkcje import fs_dokumenty_magazynowe_ciagnione
    KluczDok=[Mag,Dok,Data,Numer,NrPoz,NrPPoz]
    # zmiana ceny - dane magazynowe
    stat = fs_dokumenty_magazynowe_ciagnione.CiagnionaZmianaCenyNaPozycjachDM(self.PolSQL,self.firma_id,KluczDok,LDok,Cena1,Cena2,LKor)
    if stat =='OK':
        # zmiana ceny w oparciu o zmiany na DM - dane ksigowe
        wyn2=False
        stat = fs_dokumenty_magazynowe_ciagnione.UtworzDowodyKsiegoweWOparciuOZmianyDM(self.PolSQL,self.firma_id,LDok)
        if stat == 'KOMUNIKAT BK':
            wyn2=True
            stat='OK'