# -*- coding: ISO8859-2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_dokumenty_magazynowe_ciagnione.py
# Purpose:          proste funkcje testujce w dokumentach magazynowych
# Author:           Micha Raburski
# Created:          2010/10/29
# Copyright:        (c) 2010 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------
# 2023-07-17 Aleksander Bargie (11242) - Dokumenty magazynowe - zmiana ceny - brak updatu na rs_artykuly_magazyny

import rsglobal
from funkcje import fs_dekretacja_automatyczna_pom
from funkcje import fs_dowody_ksiegowe_pom

#-##############################################################################
#--- FUNKCJA WYLICZAJCA UREDNIENIE CENY
#-##############################################################################


#-##############################################################################
#--- FUNKCJA PODAJCA LIST DOKUMENTW DO ZMIANY W OPARCIU O DOKUMENT PIERWOTNY
#-##############################################################################

# PARAMETRY
# PolSQL - parametr techniczny. Obiekt umoliwiajcy wykonywanie zapyta
# Firma - symbol firmy, ktrej dotyczy przetwarzanie
# KluczDok - klucz dokumentu pierwotnego, ktrego dotyczy przetwarzanie

def PodajDokumentyPochodne(PolSQL,Firma,KluczDok):
    # pobranie w ptli dokumentw pochodnych do dokumentu pierwotnego
    
    LDokOstat = [KluczDok] # lista kocowa uytych dokumentw - wiadomo, e pierwotny na niej bdzie
    LKorekt = []           # lista korekt przychodowych, ktre zostay znalezione
    
    KluczStr=KluczDok[0]+'/'+KluczDok[1]+'/'+KluczDok[2]+'/'+str(KluczDok[3])
    # pobranie artykuu i cen, w celach sprawdzenia czy bya korekta przychodowa na ten artyku w tej cenie
    SQL="SELECT artykul_id,cena1,cena2 FROM rs_dokumenty_magazynowe_pozycje "
    SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+KluczDok[0]+"'"
    SQL+=" AND dokument_id='"+KluczDok[1]+"' AND data='"+KluczDok[2]+"' AND numer="+str(KluczDok[3])
    SQL+=" AND nr_poz="+str(KluczDok[4])+" AND nr_ppoz="+str(KluczDok[5])
    stat,DPoz,dump,dump = PolSQL.Execute(SQL,3)
    if stat != 'OK':
        return 'Bd pobierania danych pozycji pierwotnej dokumentu: '+KluczStr+' - '+stat,[]
    
    if len(DPoz) == 0:
        return 'Brak dokumentu o podanych parametrach: '+KluczStr,[]

    Art = rsglobal.Dekoduj(DPoz[0][0])
    Cena1 = str(DPoz[0][1])
    Cena2 = str(DPoz[0][2])
    
    LDok=[KluczDok]  # lista pomocnicza do przebiegu sprawdzenia
    LNowe=[] # lista pomocnicza do przebiegu sprawdzenia
    while len(LDok)>0:
        LNowe=[]
        for dok in LDok:
            Mag=dok[0]
            Dok=dok[1]
            Data=dok[2]
            Nr=str(dok[3])
            NrPoz=str(dok[4])
            NrPPoz=str(dok[5])

            #KluczStr=KluczDok[0]+'/'+KluczDok[1]+'/'+KluczDok[2]+'/'+rsglobal.UsunKropkaZero(KluczDok[3])
            KluczStr=Mag+'/'+Dok+'/'+str(Data)+'/'+rsglobal.UsunKropkaZero(Nr)
            # pobranie danych testowych dla dokumentu
            SQL="SELECT dm.stan, td.typ_dokumentu,COALESCE(magazyn_dokad,magazyn_id),COALESCE(numer_dokad,numer) "
            SQL+=" FROM rs_dokumenty_magazynowe dm INNER JOIN rs_typy_dokumentow_m td USING (firma_id,dokument_id) "
            SQL+=" WHERE dm.firma_id='"+Firma+"' AND dm.magazyn_id='"+Mag+"'"
            SQL+=" AND dm.dokument_id='"+Dok+"' AND dm.data='"+Data+"' AND dm.numer="+Nr
            stat,DPoz,dump,dump = PolSQL.Execute(SQL,3)
            if stat != 'OK':
                return 'Bd pobierania danych dokumentu: '+KluczStr+' - '+stat,[]
            
            if len(DPoz) == 0:
                return 'Brak dokumentu o podanych parametrach: '+KluczStr,[]
            
            # sprawdzenie stanu dokumentu (Z/K)
            if not DPoz[0][0] in ['Z','K']:
                return 'Zmian cen mona wykonywa tylko na dokumentach w stanie "Z" lub "K" - dotyczy dokumentu: '+KluczStr,[]
            
            # jeli to dokument pierwotny to sprawdzamy te czy jest typu P
            if not DPoz[0][1] == 'P' and dok == KluczDok:
                return 'Zmian cen mona wykonywa tylko na dokumentach przychodowych - dotyczy dokumentu: '+KluczStr,[]
        
            # pobranie listy potencjalnych dokumentw, ktre mog by pobrane dalej
            # (nie dotyczy dokumentw typu Zmiana Ceny - zakadamy, e zmiana bya wiadoma i czym podyktowana)
            if DPoz[0][1] in ['M','P']:
                MagDokad=DPoz[0][2]
                NrDokad=str(DPoz[0][3])

                nrtmp = "0000"+NrDokad
                nrtmp = nrtmp[len(nrtmp)-6:len(nrtmp)-2]
                poztmp = "0000"+NrPoz
                poztmp = poztmp[len(poztmp)-6:len(poztmp)-2]
                ppoztmp = "0000"+NrPPoz
                ppoztmp = ppoztmp[len(ppoztmp)-6:len(ppoztmp)-2]
                magtmp=MagDokad+'    '

                NrPrzyj=Firma+magtmp[:4]+Dok+str(Data)+nrtmp+poztmp+ppoztmp
                
                SQL="SELECT dmp.magazyn_id,dmp.dokument_id,dmp.data,dmp.numer,dmp.nr_poz,dmp.nr_ppoz,td.typ_dokumentu"
                SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp "
                SQL+=" INNER JOIN rs_typy_dokumentow_m td USING (firma_id,dokument_id) "
                SQL+=" WHERE dmp.firma_id='"+Firma+"' AND dmp.dokument_przych='"+NrPrzyj+"' AND dmp.cena1="+Cena1+" AND dmp.cena2="+Cena2
                stat,DDok,dump,dump = PolSQL.Execute(SQL,3)
                if stat != 'OK':
                    return 'Bd pobierania danych o pobraniach z dokumentu: '+KluczStr+' - '+stat,[]
                
                for dn in DDok:
                    # wyrzucamy zmiany cech ze zmian cen
                    if dn[6] <>'C':
                        KluczTmp=[rsglobal.Dekoduj(dn[0]),rsglobal.Dekoduj(dn[1]),rsglobal.Dekoduj(dn[2]),str(dn[3]),str(dn[4]),str(dn[5])]
                        LNowe.append(KluczTmp)
                        if not KluczTmp in LDokOstat:
                            LDokOstat.append(KluczTmp)
                
            # pobranie listy korekt przychodowych, ktre si tu mog znale. S zapisywane do osobnej listy
            SQL="SELECT DISTINCT magazyn_id,dokument_id,data,numer FROM rs_dokumenty_magazynowe_pozycje dmp "
            SQL+=" INNER JOIN rs_dokumenty_magazynowe dm USING (firma_id,magazyn_id,dokument_id,data,numer) "
            SQL+=" INNER JOIN rs_typy_dokumentow_m td USING (firma_id,dokument_id) "
            SQL+=" WHERE dm.firma_id='"+Firma+"' AND dm.kor_dm_magazyn_id='"+Mag+"'"
            SQL+=" AND dm.kor_dm_dokument_id='"+Dok+"' AND dm.kor_dm_data='"+Data+"' AND dm.kor_dm_numer="+Nr
            SQL+=" AND dmp.artykul_id='"+Art+"' AND dmp.cena1="+Cena1+" AND dmp.cena2="+Cena2
            SQL+=" AND td.typ_dokumentu='P'"
            stat,DKor,dump,dump = PolSQL.Execute(SQL,3)
            if stat != 'OK':
                return 'Bd pobierania danych o korektach przychodowych dokumentu: '+KluczStr+' - '+stat,[]
            
            for dn in DKor:
                KluczTmp=[rsglobal.Dekoduj(dn[0]),rsglobal.Dekoduj(dn[1]),rsglobal.Dekoduj(dn[2]),str(dn[3])]
                if not KluczTmp in LKorekt:
                    LKorekt.append(KluczTmp)
        rsglobal.ZapiszDoLogow("rseval: {}".format(str(LNowe)))
        LDok=rsglobal.rseval(str(LNowe))

    return 'OK',[LDokOstat,LKorekt]


#-##############################################################################
#--- FUNKCJA KORYGUJCA CENY NA PODANYCH POZYCJACH DOKUMENTW MAGAZYNOWYCH
#-##############################################################################

def CiagnionaZmianaCenyNaPozycjachDM(PolSQL,Firma,DokPierwotny,ListaPozycji,Cena1,Cena2,LKorekt):
    
    # lista dokumentw dla zapisu zmiany w dokumencie pierwotnym
    LDokZmiany='ZMIENIONE DOKUMENTY: \n\n'
    
    ListaPozycji.sort()
    
    for poz in ListaPozycji:
        LDokZmiany+=poz[0].strip()+'/'+poz[1].strip()+'/'+poz[2]+'/'+rsglobal.UsunKropkaZero(poz[3])+'/'+rsglobal.UsunKropkaZero(poz[4])+'/'+rsglobal.UsunKropkaZero(poz[5])+'\n'
    
    if LKorekt != []:
        LDokZmiany+="\nZNALEZIONE KOREKTY PRZYCHODOWE:\n"
        LDokZmiany+="(Stwierdzono istnienie nastpujcych korekt przychodowych dokumentu,\n dla ktrych naley dodatkowo uy funkcji zmiany ceny)\n\n"
        for poz in LKorekt:
            LDokZmiany+=poz[0].strip()+'/'+poz[1].strip()+'/'+poz[2]+'/'+rsglobal.UsunKropkaZero(poz[3])+'\n'
    
    # ustalenie nowego numeru grupy ( i przy okazji zablokowanie go na kolejne cignienia)
    SQL="SELECT nr_grupy FROM rs_dokumenty_magazynowe_pozycje_zmiany WHERE firma_id='"+Firma+"'"
    SQL+=" AND NOT nr_grupy IS NULL "
    SQL+=" ORDER BY nr_grupy DESC LIMIT 1 FOR UPDATE;"
    stat,DNr,dump,dump = PolSQL.Execute(SQL,3)
    if stat != 'OK':
        return 'Bd pobierania numeru grupy dla procesu zmiany ceny: - '+stat
    
    if len(DNr)==0:
        NrGrupy=1
    else:
        NrGrupy=DNr[0][0]+1    
    
    # ptla po pozycjach dokumentw do zmiany
    for poz in ListaPozycji:
        Mag=poz[0]
        Dok=poz[1]
        Data=poz[2]
        Nr=rsglobal.UsunKropkaZero(poz[3])
        NrPoz=rsglobal.UsunKropkaZero(poz[4])
        NrPPoz=rsglobal.UsunKropkaZero(poz[5])
        
        KluczStr=Mag.strip()+'/'+Dok.strip()+'/'+Data+'/'+Nr+'/'+NrPoz+'/'+NrPPoz
        
        # blokada dokumentu na wyczno
        SQL="SELECT * FROM rs_dokumenty_magazynowe WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' "
        SQL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Nr+" FOR UPDATE;"
        stat,dump,dump,dump = PolSQL.Execute(SQL,3)
        if stat != 'OK':
            return 'Bd blokady na wyczno dokumentu: '+KluczStr+' - '+stat
        
        # pobranie typu dokumentu. Jeli M to bdziemy uwzgldnia te dat dokd i numer dokd
        SQL="SELECT dm.stan, td.typ_dokumentu,COALESCE(dm.magazyn_dokad,dm.magazyn_id),COALESCE(dm.numer_dokad,dm.numer) "
        SQL+=" FROM rs_dokumenty_magazynowe dm INNER JOIN rs_typy_dokumentow_m td USING (firma_id,dokument_id) "
        SQL+=" WHERE dm.firma_id='"+Firma+"' AND dm.magazyn_id='"+Mag+"'"
        SQL+=" AND dm.dokument_id='"+Dok+"' AND dm.data='"+Data+"' AND dm.numer="+Nr
        stat,DDok,dump,dump = PolSQL.Execute(SQL,3)
        if stat != 'OK':
            return 'Bd pobierania danych dokumentu: '+KluczStr+' - '+stat
            
        if len(DDok) == 0:
            return 'Brak dokumentu o podanych parametrach: '+KluczStr
        
        Stan=DDok[0][0]    
        # sprawdzenie stanu dokumentu (Z/K)
        if not Stan in ['Z','K']:
            return 'Zmian cen mona wykonywa tylko na dokumentach w stanie "Z" lub "K" - dotyczy dokumentu: '+KluczStr
            
        Typ=DDok[0][1]
        MagDokad=DDok[0][2]
        NrDokad=str(DDok[0][3])
        
        
        # pobranie starych wartoci : artykuu, obu cen, starej wartoci i  iloci1 z obrotw
        SQL="SELECT ob.artykul_id,ob.cena1,ob.cena2, ob.wartosc, ob.ilosc1,ob.ilosc2,a.jm_kalk FROM rs_obroty_magazynowe ob"
        SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE ob.firma_id='"+Firma+"' AND ob.magazyn_id='"+Mag+"' AND ob.dokument_id='"+Dok+"'"
        SQL+=" AND ob.data='"+Data+"' AND ob.numer="+Nr+" AND ob.nr_poz="+NrPoz+" AND ob.nr_ppoz="+NrPPoz
        rsglobal.ZapiszDoLogow('SQL Stare '+str(SQL),1)
        stat,DObr,dump,dump = PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow('DObr '+str(DObr),1)
        if stat != 'OK':
            return 'Bd pobierania danych obrotu dokumentu: '+KluczStr+' - '+stat
            
        if len(DObr) == 0:
            return 'Brak obrotw dokumentu o podanych parametrach: '+KluczStr
        
        Artykul=rsglobal.Dekoduj(DObr[0][0])
        CenaS1=DObr[0][1]
        CenaS2=DObr[0][2]
        JmKalk=DObr[0][6]
        
        # jeli ceny si nie zmieniaj to jest OK
        if CenaS1 == Cena1 and CenaS2 == Cena2:
            return 'OK'
        
        WartS=DObr[0][3]
        if JmKalk=='1':
            Ilosc=float(DObr[0][4])
        else:
            Ilosc=float(DObr[0][5])
            
        # dla przeceny bierzemy ilo i warto na minus 
        if Typ=='R':
            WartS=-1*WartS
            Ilosc=-1*Ilosc
            
        if JmKalk=='1':
            Wart=rsglobal.RSRound(float(Cena1)*Ilosc,2)
        else:
            Wart=rsglobal.RSRound(float(Cena2)*Ilosc,2)
        
        RoznWart=str(Wart-WartS)
        Cena1=str(Cena1)
        CenaS1=str(CenaS1)
        Cena2=str(Cena2)
        CenaS2=str(CenaS2)
        Wart=str(Wart)
        WartS=str(WartS)
        
        # rs_dokumenty magazynowe pozycje
        SQL="UPDATE rs_dokumenty_magazynowe_pozycje SET cena1="+Cena1+",cena2="+Cena2+","
        SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            return 'Bd zmiany danych pozycji dokumentu: '+KluczStr+' - '+stat
        
        # rs_artykuly_przyjecia
        SQL="UPDATE rs_artykuly_przyjecia SET cena1="+Cena1+",cena2="+Cena2+","
        SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+MagDokad+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+NrDokad+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            return 'Bd zmiany artykuw przyjcia dokumentu: '+KluczStr+' - '+stat

        # rs_obroty_magazynowe
        SQL="UPDATE rs_obroty_magazynowe SET cena1="+Cena1+",cena2="+Cena2+","
        SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2+","
        if Typ=='R':
            SQL+="wartosc=-1*"+Wart+",wartosc_wal=-1*"+Wart
        else:
            SQL+="wartosc="+Wart+",wartosc_wal="+Wart
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
        SQL+=" AND cena1="+str(CenaS1)+" AND cena2="+str(CenaS2)
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            return 'Bd zmiany obrotw dokumentu: '+KluczStr+' - '+stat
        
        # jeli dokument MM to dodatkowo trzeba zmieni drugi obrt z danymi dokd
        if Typ=='M':
            SQL="UPDATE rs_obroty_magazynowe SET cena1="+Cena1+",cena2="+Cena2+","
            SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2+","
            SQL+="wartosc="+Wart+",wartosc_wal="+Wart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+MagDokad+"' AND dokument_id='"+Dok+"'"
            SQL+=" AND data='"+Data+"' AND numer="+NrDokad+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany obrotw dokd dokumentu: '+KluczStr+' - '+stat
            
        # rs_obroty_magazynowe_sumy
        # (rs_obroty_magazynowe_sumy_dni dziaaj na triggerach)
        Rok=Data[:4]
        Mc=Data[5:7]
        # cz przychodowa
        if Typ in ['C','P','M']:
            SQL="UPDATE rs_obroty_magazynowe_sumy SET przychody_wart = przychody_wart + "+RoznWart+","
            SQL+=" stan_konc_wart = stan_konc_wart + "+RoznWart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND artykul_id='"+Artykul+"'"
            SQL+=" AND rok='"+Rok+"' AND miesiac='"+Mc+"';"
            SQL+="UPDATE rs_obroty_magazynowe_sumy SET stan_pocz_wart = stan_pocz_wart + "+RoznWart+","
            SQL+=" stan_konc_wart = stan_konc_wart + "+RoznWart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND artykul_id='"+Artykul+"'"
            SQL+=" AND ((rok="+Rok+" AND miesiac>"+Mc+") OR rok > "+Rok+") ;"
            #AB 2023-07-17
            SQL+=" UPDATE rs_artykuly_magazyny "
            SQL+=" SET ost_cena1="+Cena1+", ost_cena2="+Cena2
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND artykul_id='"+Artykul+"' AND "
            SQL+=" ost_przychod='"+Data+"' ;"
            rsglobal.ZapiszDoLogow(SQL)
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany sum obrotw - cz przychodowa dla dokumentu : '+KluczStr+' - '+stat
        
        # cz rozchodowa
        if Typ in ['C','W','M','R']:
            SQL="UPDATE rs_obroty_magazynowe_sumy SET rozchody_wart = rozchody_wart + "+RoznWart+","
            SQL+=" stan_konc_wart = stan_konc_wart - "+RoznWart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+MagDokad+"' AND artykul_id='"+Artykul+"'"
            SQL+=" AND rok="+Rok+" AND miesiac="+Mc+";"
            SQL+="UPDATE rs_obroty_magazynowe_sumy SET stan_pocz_wart = stan_pocz_wart - "+RoznWart+","
            SQL+=" stan_konc_wart = stan_konc_wart - "+RoznWart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+MagDokad+"' AND artykul_id='"+Artykul+"'"
            SQL+=" AND ((rok="+Rok+" AND miesiac>"+Mc+") OR rok > "+Rok+") ;"
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany sum obrotw - cz rozchodowa dla dokumentu : '+KluczStr+' - '+stat
        
        # rs_dokumenty_magazynowe
        SQL="UPDATE rs_dokumenty_magazynowe SET zmieniony=TRUE,"
        SQL+="kwota = kwota + "+RoznWart+", kwota_wal = kwota_wal + "+RoznWart
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            return 'Bd zmiany dokumentu magazynowego : '+KluczStr+' - '+stat
        
        # jeli dokument przeceny to zmieniamy te przecen
        if Typ == 'R':
            # nagwek przeceny
            SQL="UPDATE rs_przeceny SET kwota_przeceny= kwota_przeceny +"+RoznWart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND data_przec='"+Data+"' AND numer_przec="+Nr+";"
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany nagowka przeceny : '+KluczStr+' - '+stat
            
            # pozycja przeceny
            SQL="SELECT dokument_przych FROM rs_dokumenty_magazynowe_pozycje "
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
            SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
            stat,DPrzec,dump,dump = PolSQL.Execute(SQL,3)
            if stat != 'OK':
                return 'Bd pobierania danych o pozycji przeceny z pozycji dokumentu: '+KluczStr+' - '+stat
            
            DokPrzych = rsglobal.Dekoduj(DPrzec[0][0])
            DokAP = DokPrzych[6:8]
            DataAP = DokPrzych[8:18]
            NumerAP = DokPrzych[18:22]
            PozAP = DokPrzych[22:26]
            PPozAP = DokPrzych[26:30]  
            
            SQL="UPDATE rs_przeceny_pozycje SET cena1="+Cena1+",cena2="+Cena2+","
            SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND data_przec='"+Data+"'"
            SQL+=" AND numer_przec="+Nr+" AND data='"+DataAP+"' AND dokument_id='"+DokAP+"'"
            SQL+=" AND numer="+NumerAP+" AND nr_poz="+PozAP+" AND nr_ppoz="+PPozAP
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany pozycji przeceny z pozycji dokumentu: '+KluczStr+' - '+stat
        
        # rs_gr_sprzedaz_pozycje 
        
        # pobranie faktury/korekty z dokumentu magazynowego
        SQL="SELECT COALESCE(f_wyznacznik_id,''),f_data,f_numer,COALESCE(k_wyznacznik_id,''),k_data,k_numer"
        SQL+=" FROM rs_dokumenty_magazynowe "
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr
        stat,DGrSprzedaz,dump,dump = PolSQL.Execute(SQL,3)
        if stat != 'OK':
            return 'Bd pobierania danych dla gr_sprzedaz_pozycje z dokumentu : '+KluczStr+' - '+stat
        
        if len(DGrSprzedaz)==0:
            return "Brak dokumentu "+KluczStr
        
        if DGrSprzedaz[0][0] != '':
            FWyzn=rsglobal.Dekoduj(DGrSprzedaz[0][0])
            FData=DGrSprzedaz[0][1]
            FNr=str(DGrSprzedaz[0][2])
            
            SQL="UPDATE rs_gr_sprzedaz_pozycje SET "
            SQL+="d_wartosc1=CAST (rsf_gr_podaj_dane_z_dokumentu_mag(firma_id,f_wyznacznik_id,data,f_numer,artykul_id,2,\'f\') AS NUMERIC),"
            SQL+="d_wartosc_wal1=CAST (rsf_gr_podaj_dane_z_dokumentu_mag(firma_id,f_wyznacznik_id,data,f_numer,artykul_id,3,\'f\') AS NUMERIC)"
            SQL+=" WHERE firma_id='"+Firma+"' AND f_wyznacznik_id='"+FWyzn+"' AND data ='"+FData+"'"
            SQL+=" AND f_numer="+FNr+";"
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany gr_sprzedaz_pozycje dla faktury '+FWyzn+'/'+FData+'/'+FNr+' z dokumentu : '+KluczStr+' - '+stat
        
        if DGrSprzedaz[0][3] != '':
            KWyzn=rsglobal.Dekoduj(DGrSprzedaz[0][3])
            KData=DGrSprzedaz[0][4]
            KNr=str(DGrSprzedaz[0][5])

            SQL="UPDATE rs_gr_sprzedaz_pozycje SET "
            SQL+="d_wartosc1=-1*CAST (rsf_gr_podaj_dane_z_dokumentu_mag(firma_id,f_wyznacznik_id_kor,data,f_numer,artykul_id,2,\'k\') AS NUMERIC),"
            SQL+="d_wartosc_wal1=-1*CAST (rsf_gr_podaj_dane_z_dokumentu_mag(firma_id,f_wyznacznik_id_kor,data,f_numer,artykul_id,3,\'k\') AS NUMERIC)"
            SQL+=" WHERE firma_id='"+Firma+"' AND f_wyznacznik_id_kor='"+KWyzn+"' AND data ='"+KData+"'"
            SQL+=" AND f_numer="+KNr+";"
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany gr_sprzedaz_pozycje dla korekty '+KWyzn+'/'+KData+'/'+KNr+' z dokumentu : '+KluczStr+' - '+stat
        
        # rs_gr_obroty_magazynowe 
        SQL="UPDATE rs_gr_obroty_magazynowe SET cena1="+Cena1+",cena2="+Cena2+","
        SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2+","
        SQL+="wartosc="+Wart+",wartosc_wal="+Wart
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
        SQL+=" AND cena1="+str(CenaS1)+" AND cena2="+str(CenaS2)
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            return 'Bd zmiany obrotw w rs_gr_obroty_magazynowe dla dokumentu: '+KluczStr+' - '+stat
        
        # jeli dokument MM to dodatkowo trzeba zmieni drugi zapis o obrocie z danymi dokd
        if Typ=='M':
            SQL="UPDATE rs_gr_obroty_magazynowe SET cena1="+Cena1+",cena2="+Cena2+","
            SQL+=" cena_wal1="+Cena1+",cena_wal2="+Cena2+","
            SQL+="wartosc="+Wart+",wartosc_wal="+Wart
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+MagDokad+"' AND dokument_id='"+Dok+"'"
            SQL+=" AND data='"+Data+"' AND numer="+NrDokad+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)
            if stat != 'OK':
                return 'Bd zmiany obrotw dokd w rs_gr_obroty_magazynowe dla dokumentu: '+KluczStr+' - '+stat
        
        # rs_dokumenty_magazynowe_pozycje_zmiany
        
        # zapis wielu informacji na dokumencie pierwotnym
        if poz == DokPierwotny:
            Opis = LDokZmiany
            Pierw = 'TRUE'
        else:
        # zapis pojedynczej informacji na dokumencie pochodnym
            Opis = 'Zmieniono pozycj '+poz[0].strip()+'/'+poz[1].strip()+'/'+poz[2]+'/'+rsglobal.UsunKropkaZero(poz[3])+'/'+rsglobal.UsunKropkaZero(poz[4])+'/'+rsglobal.UsunKropkaZero(poz[5])
            Pierw = 'FALSE'

        SQL="INSERT INTO rs_dokumenty_magazynowe_pozycje_zmiany (firma_id,magazyn_id,dokument_id,data,numer,"
        SQL+="nr_poz,nr_ppoz,artykul_id,cena_n1,cena_n2,cena_s1,cena_s2,wartosc_n,wartosc_s,"
        SQL+="opis,zmieniajacy_id,pobrane_do_ksieg,nr_grupy,pierwotna) VALUES "
        SQL+="('"+Firma+"','"+Mag+"','"+Dok+"','"+Data+"',"+Nr+","
        SQL+=NrPoz+","+NrPPoz+",'"+Artykul+"',"+Cena1+","+Cena2+","+CenaS1+","+CenaS2+","+Wart+","+WartS+","
        SQL+="'"+Opis+"',rsf_getuserid(),"+str(Stan == 'Z')+","+str(NrGrupy)+","+Pierw+")"
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            return 'Bd stworzenia pozycji ze zmianami dla dokumentu: '+KluczStr+' - '+stat
        
    return 'OK'

#-##############################################################################
#--- FUNKCJA TWORZCA DOWODY KSIGOWE W OPARCIU O ZMIANY NA DOKUMENTACH MAGAZYNOWYCH
#-##############################################################################

def UtworzDowodyKsiegoweWOparciuOZmianyDM(PolSQL,Firma,LDokumPoz):
    # pogrupowanie pozycji dokumentami
    LDok=[]
    for dok in LDokumPoz:
        if not dok[:4] in LDok:
            LDok.append(dok[:4])
    
    # deklaracja sownikw - z pozycjami wzoru i z tabel kont i typw
    SPozWzWOkr={}
    STypow={}
    MinData='3000-01-01'
    
    # ptla po poszczeglnych dokumentach
    for dok in LDok:
        Mag=dok[0]
        Dok=dok[1]
        Data=dok[2]
        Nr=str(dok[3])

        
        KluczStr=Mag.strip()+'/'+Dok.strip()+'/'+Data+'/'+Nr
        
        # pobieramy stan, magazyn i numer dokd dokumentu
        SQL="SELECT stan,magazyn_dokad,numer_dokad FROM rs_dokumenty_magazynowe"
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr
        stat,DaneDok,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania danych z nagwka dokumentu '+KluczStr+' : '+stat
        
        if len(DaneDok)==0:
            return 'Brak dokumentu '+KluczStr
        
        # sprawdzenie czy dokument jest zaksigowany
        if DaneDok[0][0] != 'K':
            # jeli nie jest to zmieniamy jego zmiany na zmienione 
            SQL="UPDATE rs_dokumenty_magazynowe_pozycje_zmiany SET pobrane_do_ksieg=TRUE"
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
            SQL+=" AND data='"+Data+"' AND numer="+Nr
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)                
            if stat<>'OK':
                return 'Bd zapisu o wykorzystaniu zmian pozycji dokumentu magazynowego '+KluczStr+' : '+stat
            
            # i bierzemy nastpny dokument do analizy
            
            continue
        
        MagD=DaneDok[0][1]
        NrD=rsglobal.UsunKropkaZero(DaneDok[0][2])

        # pobranie okresu dekretacji na podstawie daty
        SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+Firma+"'"
        SQL+=" AND '"+Data+"' >=data_od AND '"+Data+"'<= data_do;"
        stat,DaneOkr,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania okresu obrachunkowego dla dokumentu '+KluczStr+' : '+stat
        
        if len(DaneOkr)==0:
            return 'Dla daty '+Data+' nie znaleziono okresu, ktry by j zawiera'
        
        Okres=DaneOkr[0][0]
        
        # sprawdzenie czy w tym okresie dany miesic dla wyliczonej daty nie jest ju zamknity
        SQL="SELECT zamkniety FROM rs_definicje_okresow_miesiace WHERE firma_id='"+Firma+"'"
        SQL+=" AND okres_id='"+Okres+"' AND rok='"+Data[:4]+"' AND miesiac='"+Data[5:7]+"';"
        stat,DaneOkrMc,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania miesicy okresu obrachunkowego dla okresu '+Okres+' i daty '+Data+' : '+stat
        
        if len(DaneOkr)==0:
            return 'Dla daty '+Data+' nie znaleziono miesica okresu, ktry by j zawiera'
        
        
        # zoenie symbolu dokumentu, ktrego bdziemy szuka na dowodzie ksigowym
        KlPom=str([Mag,Dok,Data,Nr]).replace("'",'"')
        SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','M') "
        stat,DaneM,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania numeru dokumentu na wydruk : '+stat
        
        NrDokM=str(DaneM[0][0])
        
        if Dok=='MM':
            NrDokM+=" "+MagD+"/"+NrD
            
        # pobieramy dowd ksigowy, ktry zosta stworzony dla pierwotnego dokumentu
        SQL="SELECT dowod_id,nazwa_id,COALESCE(rejestr,'NULL') FROM rs_dowody_ksiegowe WHERE firma_id='"+Firma+"' "
        SQL+=" AND okres_id='"+Okres+"' AND symbol_dok='"+NrDokM+"'"
        stat,DaneDK,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania dowodu ksigowego dla dokumentu '+KluczStr+' i symbolu '+NrDokM+' : '+stat
        # zakadamy, e to nie bd a przypadek gdy nie wystawiano dokumentu z powodu zerowej kwoty
        # przechodzimy do nastpnego dokumentu
        if len(DaneDK)==0:
            continue
        
        Dowod=DaneDK[0][0]
        Nazwa=DaneDK[0][1]
        Rejestr=DaneDK[0][2]
        
        if Rejestr=='NULL':
            DataRej='NULL'
        else:
            Rejestr="'"+Rejestr+"'"
            DataRej="'"+Data+"'"
                    
        # pobieramy rodzaj numeracji dowodw ksigowych
        SQL="SELECT spos_dowody FROM rs_firmy_numeracja WHERE firma_id='"+Firma+"' AND data_od <= '"+Data+"'"
        SQL+=" ORDER BY data_od DESC LIMIT 1"
        stat,DNumeracji,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania informacji o numeracji : '+stat
        
        if len(DNumeracji)==0:
            Numeracja='D'
        else:
            Numeracja=DNumeracji[0][0]
        
        # jeli numeracja dzienna to bierzemy dat po prostu
        if Numeracja == 'D':
            DataDK = Data
        else:
            # pobieramy najmniejsz moliw dat dowodu tak, by dao si zadekretowa dowd
            Rok=Data[:4]
            if Numeracja == 'R':
                Rok=str(int(Rok)+1)
                Mc='01'
            else:
                Mc=Data[5:7]    
                if Mc=='12':
                    Rok=str(int(Rok)+1)
                    Mc='01'
                else:
                    Mc='0'+str(int(Mc)+1)
                    Mc=Mc[-2:]
                    
            SQL="SELECT MAX(data) FROM rs_dowody_ksiegowe WHERE firma_id='"+Firma+"'"
            SQL+=" AND okres_id='"+Okres+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
            SQL+=" AND data>='"+Data+"' AND data<'"+Rok+'-'+Mc+"-01'"
            stat,DaneData,dump,dump = PolSQL.Execute(SQL,3)                
            if stat<>'OK':
                return 'Bd pobrania daty dowodu ksigowego dla dokumentu '+KluczStr+' : '+stat
            
            DataDK= DaneData[0][0]
            
        if DataDK<MinData:
            MinData=DataDK

        # pobranie informacji o wzorze dekretacji dla typu dokumentu (w tym o podziale na typy)
        
        if (Okres,Dowod,Nazwa) in SPozWzWOkr:
            Dane = SPozWzWOkr[(Okres,Dowod,Nazwa)]
        else:
            stat,Dane=fs_dekretacja_automatyczna_pom.PodajPozycjeWzorowDekretacjiDM(PolSQL,Firma,Okres,Dowod,Nazwa)
            if stat == 'BR POZ':
                return 'Brak pozycji dla wzoru dekretacji '+Dowod+'/'+Nazwa+' w okresie '+Okres
            elif stat =='BR GWMWN':
                return 'Niektre pozycje wzoru dekretacji '+Dowod+'/'+Nazwa+' w okresie '+Okres+' nie maj * w czsci wn, mimo e jest rozbicie na typy'
            elif stat =='BR GWMMA':
                return 'Niektre pozycje wzoru dekretacji '+Dowod+'/'+Nazwa+' w okresie '+Okres+' nie maj * w czsci ma, mimo e jest rozbicie na typy'
            elif stat != 'OK':                
                return 'Bd pobierania informacji o pozycjach wzoru dekretacji :'+stat
            
            SPozWzWOkr[(Okres,Dowod,Nazwa)]=Dane
            
        SPozWz,CzyRozbicie,CzyRozbicieWn,CzyRozbicieMa = Dane
        
        # jeli w podziale na typy to pobieramy list kont dla typw artykuw
        SlKTypow={}
        
        if CzyRozbicie:
            if Okres in STypow:
                SlKTypow=STypow[Okres]
            else:
                stat,SlKTypow=fs_dekretacja_automatyczna_pom.PodajSlownikTypowArtykulow(PolSQL,Firma,Okres)
                if stat == 'BR KTM':
                    return 'Brak podziau na konta dla typw artykuw w okresie '+Okres
                elif stat != 'OK':                
                    return 'Bd pobierania informacji o podziale na konta dla typw artykuw w okresie '+Okres+' : '+stat
                STypow[Okres]=SlKTypow
    
        # utworzenie dokumentu w oparciu o wyliczone pozycje
        stat,Dokument=fs_dekretacja_automatyczna_pom.ZadekretujDokumentMagazynowy(PolSQL,Firma,Okres,Dowod,Nazwa,DataDK,
             Mag,Dok,Data,Nr,SPozWz,SlKTypow,CzyRozbicieWn,CzyRozbicieMa,CzyRozbicie,Rejestr,DataRej,True)
        if stat[:7] == 'BR KOR$':
            return 'Brak korekty z dokumentu magazynowego '+KluczStr+': '+stat[7:]
        if stat[:10] == 'BR POZWZM$':
            return 'Brak pasujcej pozycji ze wzoru dekretacji dla dokumentu '+KluczStr
        if stat == 'PO DOK':
            return 'Nie mona tworzy dowodw - istniej dowody z pniejsz dat'
        elif stat != 'OK':                
            return 'Bdy dekretacji dokumentu magazynowego '+KluczStr+' : '+stat
        rsglobal.ZapiszDoLogow('S D '+stat+' '+str(Dokument),1)  
        
        # jeli OK a dokument pusty to znaczy, e by to dokument o kwocie 0
        if Dokument == []:
            # zmieniamy tre jego zmian
            SQL="UPDATE rs_dokumenty_magazynowe_pozycje_zmiany SET pobrane_do_ksieg=TRUE"
            SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
            SQL+=" AND data='"+Data+"' AND numer="+Nr
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)                
            if stat<>'OK':
                return 'Bd zapisu o wykorzystaniu zmian pozycji dokumentu magazynowego '+KluczStr+' : '+stat
            
            # i bierzemy nastpny dokument do analizy
            
            continue
              
        AtrapaSelfa = rsglobal.StworzAtrapeSelfa(Firma,PolSQL,Okres)
        # zmiana stanu dokumentu z W na G
        stat=fs_dowody_ksiegowe_pom.SprawdzProjektyNaDokumencie(Firma,Okres,Dowod,Nazwa,DataDK,Dokument[4],PolSQL)        
        if stat != 'OK':    
            return 'Bd sprawdzania projektw na dowodzie ksigowym dla dokumentu magazynowego '+KluczStr+': '+stat
        
        LBledow=fs_dowody_ksiegowe_pom.SprawdzDowodKsiegowy(AtrapaSelfa,Dowod,Nazwa,DataDK,Dokument[4],Okres)
        stat=LBledow[0]
        if stat != 'OK':    
            return 'Bd przygotowania dowodu ksigowego dla dokumentu magazynowego '+KluczStr+': '+stat
        
        # zmiana stanu dokumentu z G na Z
        stat=fs_dowody_ksiegowe_pom.ZamknijDowodKsiegowy(AtrapaSelfa,Dowod,Nazwa,DataDK,Dokument[4])
        if stat != 'OK':    
            return 'Bd zamykania dowodu ksigowego dla dokumentu magazynowego '+KluczStr+': '+stat
        
        # zapis informacji o dekretacji do opisu zmiany dokumentu magazynowego
        OpisDekr='\n\nDOWD KSIGOWY\n\n'+Dowod.strip()+'/'+Nazwa.strip()+'/'+DataDK+'/'+rsglobal.UsunKropkaZero(Dokument[4])
        
        SQL="UPDATE rs_dokumenty_magazynowe_pozycje_zmiany SET pobrane_do_ksieg=TRUE,opis = opis||'"+OpisDekr+"'"
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr
        rsglobal.ZapiszDoLogow('SQL Zmian DK '+SQL,1)
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)                
        if stat<>'OK':
            return 'Bd zapisu o dowodzie ksigowym do zmian pozycji dokumentu magazynowego '+KluczStr+' : '+stat

    #--- koniec ptli po poszczeglnych dokumentach
    
    # uzupenienie opisw zmian
    stat=UzupelnijOpisyZmianWOparciuOZmianyDM(PolSQL,Firma,LDokumPoz)
    
    # sprawdzamy czy dla najmodszego utworzonego dowodu istnieje po nim BO
    if stat =='OK':
        if MinData<>'3000-01-01':
            SQL="SELECT DISTINCT dowod_id FROM rs_dowody_ksiegowe " 
            SQL+=" WHERE firma_id='"+Firma+"' AND dowod_id='BO' AND data>'"+MinData+"';"
            stat,DTest,dump,dump = PolSQL.Execute(SQL,3)                
            if stat<>'OK':
                return 'Bd sprawdzenia istnienia BO : '+stat
            if len(DTest)>0:
                return "KOMUNIKAT BK"
    
    return stat

#-##############################################################################
#--- FUNKCJA UZUPENIAJCA OPISY W LOGACH ZMIAN DOTYCZCE ZMIENIONYCH DOWODW KSIGOWYCH
#-##############################################################################

def UzupelnijOpisyZmianWOparciuOZmianyDM(PolSQL,Firma,LDokumPoz):
    LGrup=[]
    # ptla po pozycjach
    for poz in LDokumPoz:
        Mag=poz[0]
        Dok=poz[1]
        Data=poz[2]
        Nr=rsglobal.UsunKropkaZero(poz[3])
        NrPoz=rsglobal.UsunKropkaZero(poz[4])
        NrPPoz=rsglobal.UsunKropkaZero(poz[5])
        
        KluczStr=Mag+'/'+Dok+'/'+Data+'/'+Nr+'/'+NrPoz+'/'+NrPPoz
        
        # pobieramy pozycje pierwotne dotyczce zmian tej pozycji dokumentu magazynowego
        # od razu sprawdzamy czy nie bya ju zmieniana
        SQL="SELECT nr_grupy FROM rs_dokumenty_magazynowe_pozycje_zmiany "
        SQL+=" WHERE firma_id='"+Firma+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz
        SQL+=" AND pierwotna AND POSITION('POCHODNE DOWODY' IN opis)=0"
        stat,DGrup,dump,dump = PolSQL.Execute(SQL,3)                
        if stat<>'OK':
            return 'Bd pobrania informacji o pierwotnej zmianie dla pozycji '+KluczStr+' : '+stat        

        for grupa in DGrup:
            # pobieramy informacje o dowodach ksigowych z grupy tej zmiany
            SQL="SELECT SUBSTRING(opis FROM POSITION('DOWD KSIGOWY' IN opis)+16) FROM rs_dokumenty_magazynowe_pozycje_zmiany WHERE firma_id='"+Firma+"'"
            SQL+="AND nr_grupy="+str(grupa[0])+" AND NOT pierwotna AND POSITION('DOWD KSIGOWY' IN opis)>0"
            stat,DPoz,dump,dump = PolSQL.Execute(SQL,3)                
            if stat<>'OK':
                return 'Bd pobrania informacji o pochodnych zmianach dla pozycji '+KluczStr+' : '+stat        
            
            if len(DPoz)==0:
                continue
            
            Opis='\n\nPOCHODNE DOWODY KSIGOWE\n\n'
            
            for dok in DPoz:
                Opis+=dok[0]+"\n"
            
            # wkadamy informacj o dowodach ksigowych grupy na zmian pierwotn
            SQL="UPDATE rs_dokumenty_magazynowe_pozycje_zmiany SET opis=opis||'"+Opis+"'"
            SQL+="WHERE firma_id='"+Firma+"' AND nr_grupy="+str(grupa[0])+" AND pierwotna"
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)                
            if stat<>'OK':
                return 'Bd zmiany opisu na zmianie pierwotnej dla pozycji '+KluczStr+' : '+stat        
        
    return 'OK'

#-##############################################################################
#--- FUNKCJA WYLICZAJCA NA JAKIE I NA KTRYCH DOKUMENTACH POWINNY SI ZMIENI CENY
#-##############################################################################
