# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_dane.py
# Purpose:     wczytuje/edytuje dane dokumentu magazynowego 
# Author:      Micha Raburski
# Created:     2005/11/08
# RCS-ID:      $Id: fs_dokumenty_magazynowe_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#dodanie pobierania danych opisowych nr zlecen i kont kosztow do slownika Dariusz Boduch mantis: 1663 / 2009-01-28
#dorbne poprawki P.W -> mantis zagadnienie 2893
# 2011-04-09 Mariusz Rajfura - kontrola zaleglosci tylko dla dokumentow typu 'W' (4472)
# 2011-05-11 Mariusz Rajfura - kontrola domyslnych parametrow dla dokumentu z magazynu (4578)
# 2011-10-26 Mariusz Rajfura - kontrola stanu przed zapisem (5076)
# 2011-11-06 Mariusz Rajfura - zawsze dozwolona edycji pola 'opis' (5178)
# 2012-12-16 Mariusz Rajfura (6366) aktualiz.poz.dok.na pdst.pola cecha1_wartosc_dm kontrahenta/platnika

from funkcje import fs_zaleglosci_sprawdzenie
from funkcje import fs_magazyny_parametry_dokumentow_pom

DokumentPowt=''

stat='OK'
dane=[]
wyn2=['']

Magazyn = rsglobal.Dekoduj(klucze[0])
DokumentId = rsglobal.Dekoduj(klucze[1])
Data = rsglobal.Dekoduj(klucze[2])
Numer = str(klucze[3])
Fun = klucze[-1]

UprUsuwanie=((self.oddzial_id,'032012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobieraniem,4- bez pobierania)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprUsuwanie:
        stat='UPR UPD'

    # kontrola stanu
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+DokumentId+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak dokumentu o podanym kluczu.'
        dane.append(stat)
    elif d[0][0] <> 'W':
        if d[0][0] == 'G':
            # w stanie G dozwolona edycja pol: list_przewozowy, opis
            for i in xrange(len(pola)):
                if not pola[i] in ['list_przewozowy','opis']:
                    stat = 'Dokument w stanie '+d[0][0]+'. Zapis zmian niemoliwy.'
                    dane.append(stat)
                    break
        else:
            # w pozostalych stanach dozwolona edycja pol: opis
            for i in xrange(len(pola)):
                if not pola[i] in ['opis']:
                    stat = 'Dokument w stanie '+d[0][0]+'. Zapis zmian niemoliwy.'
                    dane.append(stat)
                    break

        
    #---------------------------------
    #---   Sprawdzenie danych
    #---------------------------------
    
    if stat=='OK':
        DaneI=[]
        DaneD=[]
        
        # slownik kontrolowanych parametrow dokumentu w magazynie
        SDomyslne = {}
        SDomyslne['wersja']=''
        SDomyslne['kontrahent_id']=''
        
        
        where = " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"' AND "
        where +="dokument_id='"+str(DokumentId)+"' AND data='"+str(Data)+"' AND numer ="+str(Numer)     
        Select ="SELECT waluta,kontrahent_id,nr_faktury,COALESCE(wersja,''::TEXT)"
        Select+=" FROM rs_dokumenty_magazynowe "+where+";"
        
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat='BL SQL SPR'
            dane.append(stat)
            
    if stat=='OK':
        Waluta=rsglobal.Dekoduj(d[0][0])
        KontrTemp=rsglobal.Dekoduj(d[0][1])
        if KontrTemp in ('None',None):
            KontrTemp=''
        FaktTemp=rsglobal.Dekoduj(d[0][2])
        if FaktTemp in ('None',None):
            FaktTemp=''
        
        SDomyslne['wersja']=rsglobal.Dekoduj(d[0][3]).strip()
        SDomyslne['kontrahent_id']=KontrTemp.strip()
   
        #sprawdzenie, czy symbol faktury jest unikalny w ramach kontrahenta i roku
        CzySprawdzac=False
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole == 'kontrahent_id':
                CzySprawdzac=True
                KontrTemp=wart
            elif pole == 'nr_faktury':
                CzySprawdzac=True
                FaktTemp=wart
                
        if CzySprawdzac:
            if KontrTemp <> '' and FaktTemp <> '':
                RokTemp=str(Data)[0:4]
                SQL="SELECT magazyn_id||'/'||dokument_id||'/'||data||'/'||numer FROM rs_dokumenty_magazynowe "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND data >='"+RokTemp+"-01-01'"
                SQL+=" AND data <='"+RokTemp+"-12-31' AND kontrahent_id='"+KontrTemp+"' AND nr_faktury='"+FaktTemp+"'"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)    
                if stat<>'OK':    
                    stat="Bdy przy sprawdzaniu kontrahenta : "+stat   
                    dane.append(stat)             
                else:
                    if len(d)>0:
                        DokumentPowt=d[0][0]
                        if Fun==4:
                            wyn2=[DokumentPowt]
    
    # nowy numer kontrahenta dla pobrania wpisania wartosci pola cecha1_wartosc_dm
    # na pozycje dokumentu magazynowego
    NowyKontrahent = None
    
    if stat=='OK':
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
    
            if pole == 'magazyn_dokad':
                if wart == '':
                    stat = "BR MAGD"
                    dane.append(stat)
                else:
                    Select="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';" 
                    stat,d,dump,dump = self.PolSQL.Execute(Select,3)
                    if stat<>'OK':    
                        stat="Bdy przy sprawdzaniu magazynu : "+stat   
                        dane.append(stat)  
                    else:
                        if len(d) == 0:
                            stat = "BL MAGD"
                            dane.append(stat)
    
            elif pole == 'kontrahent_id':
                SDomyslne[pole] = wartosci[i].strip()
                NowyKontrahent = wart.strip()
                
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if stat<>'OK':    
                        stat="Bdy przy sprawdzaniu id kontrahenta : "+stat   
                        dane.append(stat)  
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                        if len(d) == 0:
                            stat = "BL KONTR"
                            dane.append(stat)
                        if len(d) <> 0:   
                            SqL = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND aktywny='TRUE';"
                            stat,D,dump,dump = self.PolSQL.Execute(SqL ,3)
                            if stat<>'OK':    
                                stat="Bdy podczas sprawdzania kontrahenta : "+stat   
                                dane.append(stat)  
                            else:
                                for i in xrange(len(D)):
                                    for x in D[i]:
                                        DaneI.append(str(x.strip()))  
                            
                                if wart not in DaneI:
                                    stat = "NA KONTR"
                                    dane.append(stat)  
                              
            elif pole == 'miejsce_dostawy':
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if stat<>'OK':    
                        stat="Bdy podczas sprawdzania id kontrahenta : "+stat   
                        dane.append(stat)  
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                        if len(d) == 0:
                            stat = "BL MIEJ"
                            dane.append(stat)
                        
            elif pole == 'dostawca_id':
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    SELECT="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(SELECT ,3)
                    if st=='OK':
                        wartosci[i]="'"+wartosci[i]+"'"
                        if len(d) == 0:
                            stat = "BL DOST"
                            dane.append(stat)
                        if len(d) <> 0:   
                            SqL = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND aktywny='TRUE';"
                            st,D,dump,dump = self.PolSQL.Execute(SqL ,3)
                            if st<>'OK':    
                                stat="Bdy przy sprawdzaniu dostawcy : "+stat   
                                dane.append(stat)  
                            else:
                                for i in xrange(len(D)):
                                    for x in D[i]:
                                        DaneD.append(str(x.strip()))  
                                
                                if wart not in DaneD:
                                    stat = "NA DOST"
                                    dane.append(stat)                    
                                                                  
            elif pole == 'waluta':
                if wart == '':
                    stat = "BR WALUTA"
                    dane.append(stat)                
                else:
                    SQL="SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if st<>'OK':    
                        stat="Bdy przy sprawdzaniu waluty : "+stat   
                        dane.append(stat)  
                    else:
                        if len(d) == 0:
                            stat = "BL WALUTA"
                            dane.append(stat)
                        else:
                            Waluta=d[0][0]
                    
            elif pole == 'wersja':
                SDomyslne[pole] = wartosci[i].strip()                
                
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    SEL="SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(SEL ,3)
                    if st<>'OK':    
                        stat="Bdy przy sprawdzaniu wersji : "+stat   
                        dane.append(stat)  
                    else:
                        if len(d) == 0:
                            stat = "BL WERSJA"
                            dane.append(stat)
                        else:
                            #sprawdzenie czy mozliwa jest zmiana wersji cenowej
                            where = " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"' AND dokument_id='"+str(DokumentId)+"' AND data='"+str(Data)+"' AND numer ="+str(Numer)
                            cenan1="rsf_podaj_cene_n1('"+self.firma_id+"',artykul_id,'"+wart+"','PLN','"+str(Data)+"')"
                            cenan2="rsf_podaj_cene_n2('"+self.firma_id+"',artykul_id,'"+wart+"','PLN','"+str(Data)+"')"
                            cenawn1="rsf_podaj_cene_n1('"+self.firma_id+"',artykul_id,'"+wart+"','"+Waluta+"','"+str(Data)+"')"
                            cenawn2="rsf_podaj_cene_n2('"+self.firma_id+"',artykul_id,'"+wart+"','"+Waluta+"','"+str(Data)+"')"
                            
                            SQL="SELECT firma_id FROM rs_dokumenty_magazynowe_pozycje "+rsglobal.Dekoduj(where)+" AND "+rsglobal.Dekoduj(cenawn1)+"=0;"
                            st,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if st<>'OK':    
                                stat="Bdy przy sprawdzaniu firmy : "+stat   
                                dane.append(stat)  
                            else:
                                if d <> None:
                                    if len(d) <> 0:
                                        stat = "CE WERSJA"
                                        dane.append(stat)
                                                                    
                            if stat == 'OK':       
                                UPD="UPDATE rs_dokumenty_magazynowe_pozycje SET cena1="+rsglobal.Dekoduj(cenan1)+","
                                UPD+="cena2="+rsglobal.Dekoduj(cenan2)+",cena_wal1="+rsglobal.Dekoduj(cenawn1)+","
                                UPD+="cena_wal2="+rsglobal.Dekoduj(cenawn2)+" "+rsglobal.Dekoduj(where)+";"
                                st,dump,dump,dump = self.PolSQL.Execute(UPD,1)
                                if st<>'OK':    
                                    stat='BL UPD CENY'
                                    dane.append(stat)
                            wartosci[i]="'"+wartosci[i]+"'"
                        
            elif pole == 'nr_zlecenia':
                if wart == '':
                    stat = "BR NR ZLEC"
                    dane.append(stat)
                else:
                    Select="SELECT kod FROM rs_numery_zlecen  WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(Select ,3)
                    rsglobal.ZapiszDoLogow(d,0)
                    rsglobal.ZapiszDoLogow(stat,0)
                    if st<>'OK':    
                        stat="Bdy przy sprawdzaniu nr zlecenia : "+stat   
                        dane.append(stat)  
                    else:
                        if d == []:
                            stat = "BL NR ZLEC"
                            dane.append(stat)
                    
            elif pole == 'kierowca':
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    SEL="SELECT kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(SEL ,3)
                    if st<>'OK':    
                        stat="Bdy przy sprawdzaniu kierowcy : "+stat   
                        dane.append(stat)  
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                        if len(d) == 0:
                            stat = "BL KIER"
                            dane.append(stat)
                        
            elif pole == 'projekt_id':
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    SQL="SELECT data_od,data_do FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if st<>'OK':    
                        stat="Bdy przy sprawdzaniu projektu : "+stat   
                        dane.append(stat)  
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                        if len(d) == 0:
                            stat = "BL PROJ"
                            dane.append(stat)
                        else:
                            if d[0][0] <> 'None':
                                if Data < d[0][0]:
                                    stat = 'BL_PROJ_DATAOD'
                                    dane.append(stat)
                            if d[0][1] <> 'None':
                                if Data > d[0][1]:
                                    stat = 'BL_PROJ_DATADO'
                                    dane.append(stat)
            
            elif pole == 'konto_kosztow':
                SEL="SELECT * FROM rs_konta_kosztow WHERE firma_id='"+self.firma_id+"' AND kod='"+rsglobal.Dekoduj(wart)+"';"
                st,d,dump,dump = self.PolSQL.Execute(SEL,3)
                if st=='OK':
                    if len(d)<1:
                        stat="BL KONT"
                        dane.append(stat)
                else:
                    stat="BL SQL KONT"
                    dane.append(stat)    

            elif pole in ('czy_nocny','lifo'):
                if wart:
                    wartosci[i]='TRUE'
                else:
                    wartosci[i]='FALSE'

            # sprawdzenie poprawnoci wpisanego kolejkowania
            elif pole == 'kolejkowanie':
                if wart<>'':
                    from funkcje import fs_kolejkowanie_pom
                    stat,wartk=fs_kolejkowanie_pom.SprawdzPoprawnoscListyKolejkowania(wart)
                    if stat=='OK':
                        wartosci[i]=wartk

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        if stat == 'OK':
            stat = fs_magazyny_parametry_dokumentow_pom.SprawdzParametryDlaDokumentu(self,Magazyn,DokumentId,SDomyslne)
            if stat <> 'OK':
                dane.append(stat)
                
                    
        #--- jak stat - 'OK' i lista = [] to nie ma bledow, inaczej wracac z bledami          
        if stat == 'OK' and dane == []:
            where = " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"' AND dokument_id='"+str(DokumentId)+"' AND data='"+str(Data)+"' AND numer ="+str(Numer)+";"
            upd = "UPDATE rs_dokumenty_magazynowe SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['magazyn_skad','magazyn_dokad','waluta','nr_zlecenia','nr_faktury','opis',
                            'konto_kosztow','list_przewozowy','kolejkowanie']:
                    upd=upd+pole+"='"+wart+"',"
    
                elif pole in ['wersja','kontrahent_id','kierowca','projekt_id','miejsce_dostawy','dostawca_id','czy_nocny','lifo']:
                    upd=upd+pole+"="+wart+","
            upd = upd[0:len(upd)-1]+where
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
            if stat<>'OK':
                stat='BL UPD'
                dane.append(stat)
                
        # obsluga pola cecha1_wartosc w pozycjach dokumentu na podstawie
        # pola cecha1_wartosc_dm w rs_kontrahenci jesli zmieniano kontrahenta
        if stat == 'OK' and NowyKontrahent <> None:
            Cecha1WartoscDm = ''

            if NowyKontrahent <> '':
                sql ="SELECT COALESCE(cecha1_wartosc_dm,''::TEXT),kontrahent_id, COALESCE(platnik_id,''::TEXT)"
                sql+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kontrahent_id='"+NowyKontrahent+"';"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania danych kontrahenta: '+stat
                elif d[0][0] == '':
                    # nowy kontrahent nie ma wpisanej cechy
                    if rsglobal.Dekoduj(d[0][1]) <> rsglobal.Dekoduj(d[0][2]) and rsglobal.Dekoduj(d[0][2]) <> '':
                        # to moze platnik ma wpisana
                        sql ="SELECT COALESCE(cecha1_wartosc_dm,''::TEXT)"
                        sql+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND platnik_id='"+rsglobal.Dekoduj(d[0][2])+"';"

                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd pobrania danych patnika: '+stat
                        elif len(d) > 0:
                            Cecha1WartoscDm = rsglobal.Dekoduj(d[0][0])
                else:
                    Cecha1WartoscDm = rsglobal.Dekoduj(d[0][0])

            if stat == 'OK':
                # pobieramy pozycje dokumentu, ktore maj artykul umozliwiajacy
                # wpisanie pola cecha1_wartosc
                sql ="SELECT nr_poz,nr_ppoz,artykul_id,cecha1_wartosc"
                sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp "
                sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
                sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Magazyn+"'"
                sql+=" AND dokument_id='"+DokumentId+"' AND data='"+Data+"' AND numer="+str(Numer)
                sql+=" AND a.cecha1_opis IS NOT NULL"
                sql+=" ORDER BY dmp.nr_poz, dmp.nr_ppoz;"
                
                stat,PozDm,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania pozycji dok.magazynowego: '+stat
            
            if stat == 'OK' and len(PozDm) > 0:
                if Cecha1WartoscDm == '':
                    Cecha1WartoscDm = 'NULL'
                else:
                    Cecha1WartoscDm = "'"+Cecha1WartoscDm+"'"
                UPD = ''
                
                for p in PozDm:
                    UPD+="UPDATE rs_dokumenty_magazynowe_pozycje SET cecha1_wartosc="+Cecha1WartoscDm
                    UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
                    UPD+=" AND dokument_id='"+DokumentId+"' AND data='"+Data+"' AND numer="+str(Numer)
                    UPD+=" AND nr_poz="+str(p[0])+" AND nr_ppoz="+str(p[1])+"; "
                
                stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
                if stat <> 'OK':
                    stat = 'Bd aktualizacji pozycji dokumentu: '+stat

                    
                
#-------------------------------------------------------------------------------
#---   POBIERANIE DANYCH POMOCNICZYCH (9)
#-------------------------------------------------------------------------------

if Fun ==9 and stat=='OK':
    SQL="SELECT czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_miejsce,czy_dostawca,typ_dokumentu "
    SQL+="FROM rs_typy_dokumentow_m WHERE firma_id = '"+self.firma_id+"' AND dokument_id='"+str(DokumentId)+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy pobierania danych pomocniczych : '+stat
        dane.append(stat)
        
    #informacja, czy stosowac ceny w magazynie
    if stat == 'OK':
        sql="SELECT czy_ceny FROM rs_magazyny WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu cen w magazynie: '+stat
            dane = []
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Bdny numer magazynu: '+Magazyn+' Po zapytaniu :'+sql
            dane = []
            dane.append(stat)
        else:
            dane.append(d[0][0])
    
    if stat == 'OK':
        stat,SDomyslne = fs_magazyny_parametry_dokumentow_pom.PodajDomyslneParametryDlaDokumentu(self,Magazyn,DokumentId)
        if stat == 'OK':
            # przekazanie slownika domyslnych parametrow dokumentu
            # jako listy tupli - wymog serwera
            # latwo odtworzyc slownik przez uzycie dict()
            dane.append(SDomyslne.items())
        
                        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if ((Fun in [3,5]) and (stat=='OK') and (dane==[])):
    wyn2=[]
    # pobranie danych magazynowych
    
    sql="SELECT * FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND"
    sql+=" magazyn_id='"+str(Magazyn)+"' AND dokument_id='"+str(DokumentId)+"' AND "
    sql+="data='"+str(Data)+"' " 
    if Numer not in ['',None,'None']:
        sql+="AND numer="+str(Numer)+" "
    sql+=";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)    
    if stat<>'OK':
        stat = 'BL SQL DANE'
        dane.append(stat)
    else:
        #--------------------------
        #pobranie danych do opisow
        #--------------------------
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)
            #--- magazyn skad
            if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+rsglobal.Dekoduj(tr.GetVal(0,"magazyn_skad"))+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            #--- magazyn dokad
            if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_dokad")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            #--- kontrahent
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- waluta
            if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- wersja
            if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- kierowca
            if ((self.oddzial_id,'011250') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"kierowca")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- projekt
            if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- miejsce dostawy
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"miejsce_dostawy")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- dostawca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"dostawca_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
            #--- nr zlecenia
            if ((self.oddzial_id,'011140') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_numery_zlecen WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"nr_zlecenia")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  
            #--- konto kosztow
            if ((self.oddzial_id,'011150') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_konta_kosztow WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"konto_kosztow")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  
            #pobranie ewentualnej informacji o tym, ze nr faktury sie powtarza
            wyn2.append(DokumentPowt)

            #kontrola limitu zaleglosci (12)
            sql ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+rsglobal.Dekoduj(DokumentId)+"';"
            stat,dTyp,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat='Bd pobierania danych typu dokumentu: '+stat
                dane.append(stat)
            elif len(dTyp) == 0:
                stat = 'Brak definicji dokumentu magazynowego '+DokumentId
                dane.append(stat)
            elif rsglobal.Dekoduj(dTyp[0][0]) == 'W':
                Stan = tr.GetVal(0,"stan")
                Kontrahent = tr.GetVal(0,"kontrahent_id").strip()
                Kwota = tr.GetVal(0,"kwota")
                if Stan == 'W' and not Kontrahent in ('','None'):
                    limit = fs_zaleglosci_sprawdzenie.SprawdzLimitKontrahenta(self,Kontrahent,Kwota,Data)
                    wyn2.append(limit)
                else:
                    wyn2.append('')
            else:
                 wyn2.append('')
                 
            # numer zamwienia z dostaw (13)
            NrZam=''
            SQL="SELECT COALESCE(zd_wyznacznik||'/'||zd_data||'/'||zd_numer,'') FROM rs_dostawy "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND d_magazyn_id='"+Magazyn+"'"
            SQL+=" AND d_dokument_id='"+DokumentId+"' AND d_data='"+Data+"' AND d_numer="+str(Numer)
            stat,DNrZam,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat='Bd pobierania danych o numerze zamwienia z dostaw: '+stat
                dane.append(stat)
            elif len(DNrZam)>0:
                NrZam=DNrZam[0][0]
            wyn2.append(NrZam)                