# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_import_poz_z_zamowienia.py
# Purpose:     pobiera pozycje z zamowienia odbiorcy do pozycji dokumentu magazynowego
#
# Author:      Micha Raburski
# Created:     2008/08/05
# RCS-ID:      $Id: fs_dokumenty_magazynowe_import.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#obecnie mechanizm zbiorczego pobierania jest traktowany jak
#multiselect po wszystkich zamowienach, nadajacych sie do pobrania
#zamowienia z blokada cen mozna pobrac TYLKO POJEDYNCZO
# 2010/09/13 mantis:3845  mariusz rajfura

Mag = rsglobal.Dekoduj(klucze[0])
Dok = rsglobal.Dekoduj(klucze[1])
Data = rsglobal.Dekoduj(klucze[2])
Numer = str(klucze[3])
DaneZO = klucze[4]

Fun = klucze[-1]

stat = "OK"
dane = []
wyn1 = []   # wyn1[] = lista zamowien z blokada cen, ktore uniemozliwiaja pobranie
wyn2 = []   # wyn2[[0]] = ilosc zamowien

#parametry do wpisania do naglowka dok.mag,
#jesli wynikiem wyboru jest tylko jedno zamowienia
ZO_Wyznacznik = None
ZO_Data = None
ZO_Numer = None

#SPRAWDZANIE DANYCH Z KLUCZA
#DOKUMENT MAGAZYNOWY - DODATKOWO BLOKADA
if stat=='OK':
    sql ="SELECT kontrahent_id,stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
    sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer
    sql+=" FOR UPDATE NOWAIT;"
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if len(dane)==0:
        stat='BR DOKMAG'
        dane.append(stat)
    else:
        KontrId=rsglobal.Dekoduj(dane[0][0])

if stat == 'OK':
    if dane[0][1] <> 'W':
        stat = "Dokument nie jest w stanie 'W'"
        dane.append(stat)

if stat == 'OK':
    #jesli wyznacznik jest pusty, sami tworzymy liste zamowien do zrealizowania
    if DaneZO[0][0] == '':
        sql ="SELECT wyznacznik_id,data,numer,blokada_cen"
        sql+=" FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND stan='G'"
        sql+=" AND kontrahent_id='"+KontrId+"'"
        sql+=" ORDER BY wyznacznik_id,data,numer FOR UPDATE NOWAIT;"
        stat,DaneZO,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania wszystkich, niezrealizowanych zamwie: '+stat
        else:
            wyn2.append([len(DaneZO)])
            if len(DaneZO) == 1:
                ZO_Wyznacznik = rsglobal.Dekoduj(DaneZO[0][0])
                ZO_Data = rsglobal.Dekoduj(DaneZO[0][1])
                ZO_Numer = DaneZO[0][2]
                
            if len(DaneZO) > 0:
                #zapisujemy ilosc zamowien z blokada cen
                for i in xrange(len(DaneZO)):
                    if DaneZO[i][3]:
                        wyn1.append(' -  wyznacznik: '+rsglobal.Dekoduj(DaneZO[i][0])+\
                                    '   data: '+rsglobal.Dekoduj(DaneZO[i][1])+\
                                    '   numer: '+str(int(DaneZO[i][2])))
                                    
    else:
        wyn2.append([len(DaneZO)])
        #sprawdzamy kontrahenta i stan i blokade cen na wybranych zamowieniach
        sql ="SELECT kontrahent_id,stan,wyznacznik_id,data,numer,blokada_cen"
        sql+=" FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND ("
        for i in xrange(len(DaneZO)):
            if i > 0:
                sql+=" OR "
            sql+=" (wyznacznik_id='"+rsglobal.Dekoduj(DaneZO[i][0])+"' AND"
            sql+="  data='"+rsglobal.Dekoduj(DaneZO[i][1])+"' AND"
            sql+="  numer='"+str(DaneZO[i][2])+"')"
        sql+=") FOR UPDATE NOWAIT;"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if len(d) <> len(DaneZO):
            stat='BL POBRANIA ZO'
            dane.append(stat)
        
        if stat == 'OK':
            if len(d) == 1:
                #jesli tylko jedno zamowienie
                ZO_Wyznacznik = rsglobal.Dekoduj(d[0][2])
                ZO_Data = rsglobal.Dekoduj(d[0][3])
                ZO_Numer = d[0][4]
            
            for zam in d:
                if zam[5]:
                    #zapisujemy ilosc zamowien z blokada cen
                    wyn1.append(' -  wyznacznik: '+rsglobal.Dekoduj(zam[2])+\
                                '   data: '+rsglobal.Dekoduj(zam[3])+\
                                '   numer: '+str(int(zam[4])))
                
                if rsglobal.Dekoduj(zam[0]) <> KontrId:
                    stat = 'NG KONTR'
                    dane.append(stat)
                    break
                if zam[1] <> 'G':
                    stat='BL STAN ZO'
                    dane.append(stat)
                    break


if stat == 'OK' and len(DaneZO) > 1:
    if len(wyn1) > 0:
        stat = 'BL MULTI BLOKADA'

if stat == 'OK' and len(DaneZO) > 0:
    #pobranie niezrealizowanych pozycji w podanych zamowien
    sql ="SELECT zop.artykul_id,zop.wyznacznik_id,zop.data,zop.numer,zop.nr_poz,zop.nr_ppoz,"
    sql+=" zop.ilosc1-zop.anulowano1-zop.dostarczono1,"
    sql+=" zop.ilosc2-zop.anulowano2-zop.dostarczono2"
    sql+=" FROM rs_zamowienia_odbiorcy_pozycje zop INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    sql+=" WHERE zop.firma_id='"+self.firma_id+"' AND NOT a.typ_artykulu IN ('31','99')"
    sql+=" AND zop.ilosc1-zop.anulowano1-zop.dostarczono1>0"
    sql+=" AND zop.ilosc2-zop.anulowano2-zop.dostarczono2>0"
    sql+=" AND ("
    for i in xrange(len(DaneZO)):
        if i > 0:
            sql+=" OR "
        sql+=" (zop.wyznacznik_id='"+rsglobal.Dekoduj(DaneZO[i][0])+"' AND"
        sql+="  zop.data='"+rsglobal.Dekoduj(DaneZO[i][1])+"' AND"
        sql+="  zop.numer="+str(DaneZO[i][2])+")"
    
    sql+=") ORDER BY zop.wyznacznik_id,zop.data,zop.numer,zop.nr_poz;"

    stat,pozZO,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania pozycji z wybranych zamwie: '+stat
        dane.append(stat)
    
    if stat == 'OK':
        if len(pozZO) == 0:
            stat = 'Na wybranych zamwieniach brak niezrealizowanych pozycji.'
            dane.append(stat)

    if stat == 'OK':
        #sprawdzamy, czy ktores z pobieranych zamowien wystepuje
        #na pozycjach dokumentu magazynowego
        sql ="SELECT DISTINCT zo_wyznacznik_id,zo_data,zo_numer"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer
        sql+=" AND ("
        for i in xrange(len(DaneZO)):
            if i > 0:
                sql+=" OR "
            sql+=" (zo_wyznacznik_id='"+rsglobal.Dekoduj(DaneZO[i][0])+"' AND"
            sql+="  zo_data='"+rsglobal.Dekoduj(DaneZO[i][1])+"' AND"
            sql+="  zo_numer="+str(DaneZO[i][2])+")"
        sql+=") ORDER BY zo_wyznacznik_id,zo_data,zo_numer;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia powtrzonych zamwie: '+stat
        elif len(d) > 0:
            stat = '\nPowtrzone zamwienia:\n\n'
            for i in xrange(len(d)):
                stat += " - zamwienie "+str(d[i][0])
                stat += " "+str(d[i][2]).split('.')[0]
                stat += " z dnia "+str(d[i][1])+"\n"
                
            stat += "\nImport niemoliwy."
            dane.append(stat)

    if stat == 'OK':
        #pobranie numeru ostatniej pozycji z dokumentu magazynowego
        sql ="SELECT MAX(nr_poz) FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pozycji dokumentu magazynowego: '+stat
            dane.append(stat)
        elif len(d) > 0:
            PozStart = d[0][0]
        else:
            PozStart = 0

    INS = ''
    if stat == 'OK':
        #petla po dodawanych pozycjach
        NrPoz = PozStart + 1
        for i in xrange(len(pozZO)):
            INS+="INSERT INTO rs_dokumenty_magazynowe_pozycje ("
            INS+=" firma_id,magazyn_id,dokument_id,data,numer,"
            INS+=" nr_poz,nr_ppoz,artykul_id,"
            INS+=" ilosc1,ilosc2,"
            INS+=" zo_wyznacznik_id,zo_data,"
            INS+="zo_numer,zo_nr_poz,zo_nr_ppoz"
            INS+=")"
            INS+=" VALUES ("
            INS+=" '"+self.firma_id+"','"+Mag+"','"+Dok+"','"+Data+"',"+Numer+","
            INS+=" "+str(NrPoz)+",0,'"+rsglobal.Dekoduj(pozZO[i][0])+"',"
            INS+=" "+str(pozZO[i][6])+","+str(pozZO[i][7])+","
            INS+=" '"+rsglobal.Dekoduj(pozZO[i][1])+"','"+pozZO[i][2]+"',"
            INS+=" "+str(pozZO[i][3])+","+str(pozZO[i][4])+","+str(pozZO[i][5])
            INS+="); "
            NrPoz += 1
            
        if INS <> '':
            #aktualizacja naglowka dokumentu
            INS+="UPDATE rs_dokumenty_magazynowe SET czy_pobrane_z_zamowien=TRUE,"
            INS+=" zo_wyznacznik_id=NULL, zo_data=NULL, zo_numer=0"
            INS+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
            INS+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+";"

    if stat == 'OK' and INS <> '':
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
        if stat <> 'OK':
            stat = 'Bd dopisania pozycji z zamowie: '+stat
            dane.append(stat)
            

    #sprawdzimy, czy na dokumencie sa pozycje tylko z jednego zamowienia
    #z pominieciem pozycji wpisanych 'z reki', ktore nie maja
    #danych zamowienia zrodlowego
    if stat == 'OK' and INS <> '':
        sql ="SELECT DISTINCT zo_wyznacznik_id,zo_data,zo_numer"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer
        sql+=" AND zo_wyznacznik_id IS NOT NULL and zo_data IS NOT NULL"
        sql+=" AND zo_numer>0;"
                
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z pozycji modyfikowanego dokumentu magazynowego: '+stat
        elif len(d) == 1:
            #jesli tylko zapis, to oznacza, ze dane pochodza tylko z jednego zamowienia,
            #wiec wpisujemy dane tego konkretnego zamowienia

            UPD ="UPDATE rs_dokumenty_magazynowe SET"
            UPD+=" zo_wyznacznik_id='"+rsglobal.Dekoduj(d[0][0])+"',"
            UPD+=" zo_data='"+rsglobal.Dekoduj(d[0][1])+"',"
            UPD+=" zo_numer="+str(d[0][2])
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
            UPD+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+";"

            stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
            if stat <> 'OK':
                stat = 'Bd zapisania danych zamwienia w nagwku dokumentu: '+stat