# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_import_pozycji_z_sum_zamowien.py
# Purpose:     Importuje pozycje dokumentu magazynowego z rs_sumy_zamowien
# Author:      Mariusz Rajfura
# Created:     2012/09/26
# RCS-ID:      $Id: fs_dokumenty_magazynowe_import_pozycji_z_sum_zamowien.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2012-10-09 Mariusz Rajfura (6042) opcja 'osobny_przerzut' w pobieraniu pozycji z sum zamowien

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Magazyn':[9], 'Dokument':[9], 'Data':[9], 'Numer':[9], 'ZmianaSprzedajaca':[9], 'OsobnyPrzerzut':[9]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_import_pozycji_z_sum_zamowien z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [9]: 
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])
        ZmianaSprzedajaca = rsglobal.Dekoduj(klucze['ZmianaSprzedajaca']).strip()
        OsobnyPrzerzut = rsglobal.Dekoduj(klucze['OsobnyPrzerzut'])
        
dane = []
wyn1 = []
wyn2 = []

UprIns = ((self.oddzial_id,'032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#------ import pozycji na dok.MM (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == 'OK':
    if not UprIns:
        stat = 'UPR INS'
        dane.append(stat)
    
    if stat == 'OK':
        if ZmianaSprzedajaca == '':
            stat = 'BR ZMIANA SPRZED'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT dm.stan,COALESCE(dm.magazyn_skad,''::TEXT),m1.oddzial_id,"
        sql+=" COALESCE(dm.magazyn_dokad,''::TEXT),m2.oddzial_id"
        sql+=" FROM rs_dokumenty_magazynowe dm"
        sql+=" LEFT JOIN rs_magazyny m1 ON (m1.firma_id=dm.firma_id AND m1.magazyn_id=dm.magazyn_skad)"
        sql+=" LEFT JOIN rs_magazyny m2 ON (m2.firma_id=dm.firma_id AND m2.magazyn_id=dm.magazyn_dokad)"
        sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Magazyn+"'"
        sql+=" AND dm.dokument_id='"+Dokument+"' AND dm.data='"+Data+"' AND dm.numer="+str(Numer)+";"
        
        stat,dm,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania stanu dokumentu: '+stat
            dane.append(stat)
        elif len(dm) == 0:
            stat = 'BR DOK MAG'
            dane.append(stat)
        elif dm[0][0] <> 'W':
            stat = 'BL STAN N-W'
            dane.append(stat)
        elif dm[0][1] == '':
            stat = 'BR MAG SKAD'
        elif dm[0][3] == '':
            stat = 'BR MAG DOKAD'

    if stat == 'OK':
        sql ="SELECT artykul_id FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji z dokumentu: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'ISTN POZ'
            dane.append(stat)

    if stat == 'OK':
        # lista (oddzial,trasa,tryb_dostawy) z oddzialu zamawiajacego,
        # ktory jest obslugiwany przez inne oddzialy i ma checkbox 'osobny_przerzut'
        sql ="SELECT DISTINCT btd.oddzial_id,btd.trasa,btd.tryb_dostawy,CASE WHEN data_do IS NULL THEN 2 ELSE 1 END"
        sql+=" FROM rs_boksy_trasy_dni btd"
        sql+=" WHERE btd.firma_id='"+self.firma_id+"' AND btd.data<='"+Data+"' AND (btd.data_do>='"+Data+"' OR data_do IS NULL)"
        sql+=" AND btd.oddzial_id='"+rsglobal.Dekoduj(dm[0][2])+"' AND btd.osobny_przerzut"
        sql+=" AND btd.trasa IN ("
        sql+="  SELECT trasa FROM rs_trasy WHERE firma_id='"+self.firma_id+"'"
        sql+="  AND oddzial_id='"+rsglobal.Dekoduj(dm[0][4])+"'"
        sql+=") ORDER BY CASE WHEN data_do IS NULL THEN 2 ELSE 1 END;"
        
        stat,TrasyZamawiajacego,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy tras z zastpstw.'
            dane.append(stat)
            
    if stat == 'OK':
        LTrasPom=[]
        if len(TrasyZamawiajacego) > 0:
            Trasy = "("
            for i in xrange(len(TrasyZamawiajacego)):
                # dziki temu dwie daty bd miay priorytet przed jedn dat
                # brane jest tylko pierwsze wystpienie trasy
                if (not rsglobal.Dekoduj(TrasyZamawiajacego[i][1]) in LTrasPom):
                    if i > 0:
                        Trasy += ","
                    # dowody dla oddzialu zamawiajacego
                    Trasy += "("+\
                             "'"+rsglobal.Dekoduj(dm[0][4])+"',"+\
                             "'"+rsglobal.Dekoduj(TrasyZamawiajacego[i][1])+"',"+\
                             "'"+rsglobal.Dekoduj(TrasyZamawiajacego[i][2])+"')"
                    LTrasPom.append(rsglobal.Dekoduj(TrasyZamawiajacego[i][1]))
            Trasy += ")"
        else:
            Trasy = "(('','',''))"

        # lista pozycji z dowodow dla wybranych wczesniej tras
        sql = "SELECT ddp.artykul_id,SUM(ddp.ilosc_pobr1),SUM(ddp.ilosc_pobr2)"
        sql+=" FROM rs_dowody_dostaw_pozycje ddp"
        sql+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.data='"+Data+"'"
        sql+=" AND (ddp.oddzial_id,ddp.trasa,ddp.tryb_dostawy) IN "+Trasy
        sql+=" GROUP BY ddp.artykul_id "
        sql+=" HAVING SUM(ddp.ilosc_pobr1)<>0 AND SUM(ddp.ilosc_pobr2)<>0"
        sql+=" ORDER BY ddp.artykul_id;"
        stat,PozycjeDowodow,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji z dowodw dla osobnego przerzutu'
            dane.append(stat)
    
    if stat == 'OK' and not OsobnyPrzerzut:
        # jesli OsobnyPrzerzut, to pozycje pobierane z dowodow dostaw
        # wiec to zapytanie nie jest potrzebne
        sql ="SELECT ps.artykul_id,SUM(ps.zamowione1),SUM(ps.zamowione2)"
        sql+=" FROM rs_produkcja_sumy ps"
        sql+=" WHERE ps.firma_id='"+self.firma_id+"' AND ps.data='"+Data+"' AND ps.zmiana='"+ZmianaSprzedajaca+"'"
        sql+=" AND ps.oddzial_prod='"+rsglobal.Dekoduj(dm[0][2])+"' AND ps.oddzial_zam='"+rsglobal.Dekoduj(dm[0][4])+"'"
        sql+=" GROUP BY ps.artykul_id ORDER BY ps.artykul_id;"
        
        stat,dsum,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania sum zamwie: '+stat
            dane.append(stat)

    if stat == 'OK':
        if OsobnyPrzerzut:
            # Dla osobnego przerzutu tworze zawartosc listy dsum[]
            # na pozycje pobrane z dowodow dostaw.
            # Dzieki temu nie trzeba zmieniac kodu tworzacego pozycje MM-ki :-)
            dsum = []
            for poz in PozycjeDowodow:
                dsum.append(poz)

        else:
            for i in xrange(len(PozycjeDowodow)):
                Art = PozycjeDowodow[i][0]
                IlPobr1 = PozycjeDowodow[i][1]
                IlPobr2 = PozycjeDowodow[i][2]
                
                Jest = False
                for j in xrange(len(dsum)):
                    if dsum[j][0] == Art:
                        Jest = True
                        dsum[j][1] -= IlPobr1
                        dsum[j][2] -= IlPobr2
                        break
                
                if not Jest:
                    stat = 'Artyku '+Art.strip()+' jest w osobnych przerzutach, a nie ma go w zamwieniach.'
                    dane.append(stat)
    
            if stat == 'OK':
                # czy byly bledy odnajdywania artykulow pomniejszajacych ilosci z sum zamowien
                if len(dane) > 0:
                    stat = dane[0]

            if stat == 'OK':
                # kontrola, czy ilosci pobrane (czyli odejmowane) nie sa wieksze od ilosci zamowionych
                for i in xrange(len(dsum)):
                    if dsum[i][1] < 0 or dsum[i][2] < 0:
                        dane.append('Artyku '+dsum[i][0].strip()+' ilo na osobnych przerzutach przekraca ilo pobran z sum zamwie')
                
            if stat == 'OK':
                # czy byly bledy pomniejszania ilosci z sum zamowien
                if len(dane) > 0:
                    stat = dane[0]

    lp = 0
    if stat == 'OK' and len(dsum) > 0:
        # Tworzenie pozycji MM-ki
        INS = ''
        for i in xrange(len(dsum)):
            if dsum[i][1] == 0 and dsum[i][2] == 0:
                # ominiecie pozycji z ilosciami zerowymi, ktore moga wynikac 
                continue
            
            lp += 1
            
            INS+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
            INS+=" (firma_id,magazyn_id,dokument_id,data,numer,"
            INS+="  nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2)"
            INS+=" VALUES"
            INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"','"+Data+"',"+str(Numer)+","
            INS+=" "+str(lp)+",0,'"+rsglobal.Dekoduj(dsum[i][0])+"',"+str(dsum[i][1])+","+str(dsum[i][2])+"); "
        
        if INS <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
            if stat <> 'OK':
                stat = 'Bd dodawania importowanych pozycji z sum zamwie: '+stat
                dane.append(stat)
        
    if stat == 'OK':
        # zwracamy ilosc dodanych pozycji
        dane.append([lp])
