# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_klucz.py
# Purpose:     zapisuje nowy dokument lub zmienia klucz dokumentu magazynowego uwzgldniajc uprawnienia operatora 
#
# Author:      Jan Raburski
# Created:     2005/10/28
# RCS-ID:      $Id: fs_dokumenty_magazynowe_klucz.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# dodawanie z rs_oddzialy wersja_magazyn (jesli jest) (przy dodawaniu nowego dokumentu magazynowego) - Dariusz Boduch 2009-02-16 - mantis:1726
#02.04.2009 Dariusz Boduch - wstawianie symbolu magazynu "na sztywno" jesli operator ma uprawnienia do jednego magazynu mantis: 1950
#11.01.2011 Mariusz Rajfura - sprawdzenie stanu dok.mag. przed zmiana klucza (4180)
#02.02.2011 Mariusz Rajfura - nowe pole 'produkt_id' (4223)
#27.02.2011 Mariusz Rajfura - pominiecie pola 'produkt_id' przy kopiowaniu (4318)
#27.02.2011 Mariusz Rajfura - zachowanie kolejnosci pozycji przy kopiowaniu dokumentu (4309)
#29.04.2011 Mariusz Rajfura - kopiowanie 'cecha_opis','cecha1_wartosc' przy kopiowaniu dokumentu (4550)
#11.05.2011 Mariusz Rajfura - pobranie domyslnych parametrow dla dok: tworzenia,kopiowanie,zmiana klucza (4578)
#2012-09-27 Mariusz Rajfura (6111) scalanie pozycji przy kopiowaniu dokumentu
#2012-10-01 Mariusz Rajfura (6121) popr blad petli przepisania niescalonych pozpozycji
#2013-07-31 Mariusz Rajfura (7075,7114) tworzenie korekty dokumentu magazynowego
#2016-11-16 Piotr Witkowski (10122)  Nie mona zamkn dokumentu MM
#2017-08-22 Piotr Witkowski (10679)  Sprawdzi czy wpisanie daty_do w projektach blokuje mozliwosc wprowadzania
#2023-01-02 Jan Raburski (13285) - dokument BH - czyszczenie mieci w magazynach ddetalicznych
#2023-01-30 Jan Raburski (13318) - dokument typ 'I' - kompenaty ilosciowe' plus poprawki

from funkcje import fs_dokumenty_magazynowe_lokacje_pom
from funkcje import fs_magazyny_parametry_dokumentow_pom

# -------------------------------------------------------------------------------
# OBSUGA DOKUMENTU TYP I
# -------------------------------------------------------------------------------

def WykonajKompensateIlosciowa(self, Magazyn, Typ, Data, Numer, ArtykulyIlosci):
    from funkcje import fs_dokumenty_magazynowe_pom
    from funkcje import fs_spis_z_natury_pom
    dane = []
    rsglobal.ZapiszDoLogow('AI:'+str(ArtykulyIlosci), 1)

    # sprawdzenie czy oba detaliczne
    SQL = "SELECT COALESCE(detaliczny,FALSE) FROM rs_magazyny WHERE firma_id='%s' AND magazyn_id IN ('%s');" % (self.firma_id, Magazyn)
    stat, wyn, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return u"Bdy w sprawdzaniu czy detaliczny magazyn " + stat, dane
    if len(wyn) != 1:
        return u"Brak magazynu ", dane
    if not wyn[0][0]:
        return u"Magazyn musi by detaliczny ", dane

    # sprawdzenie istnienia dokumentow
    SQL = "SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='%s' AND magazyn_id = '%s'" % (self.firma_id, Magazyn)
    SQL += " AND ((data>'" + str(Data) + "' AND stan != 'W') OR (data<'" + str(Data) + "' AND stan = 'W'))"
    stat, wyn, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return u"Bdy w sprawdzaniu istnienia dokumentw " + stat, dane
    if wyn[0][0] > 0:
        return u"W magazynie " + Magazyn + " istniej wczeniejsze niezamknite lub pniejsze zamknite dokumenty", dane

    pozycje = []
    kwota = 0
    for w in ArtykulyIlosci:  # tworzenie pozycji dla dokumentu magazynowego
        if w[1] < 0:
            ArtMinus = w[0]
            IlMinus = w[1]
            ArtPlus = w[2]
            IlPlus = w[3]
        else:
            ArtMinus = w[2]
            IlMinus = w[3]
            ArtPlus = w[0]
            IlPlus = w[1]
        ilosc1 = round(w[1], 3)

        # stan ujemny przyjmujemy po ostatniej cenie
        SQL = "SELECT zamiennik_id, przelicznik,a.dynamiczny_przelicznik FROM rs_artykuly a "
        SQL += " WHERE a.firma_id='" + self.firma_id + "' AND a.artykul_id='" + rsglobal.Dekoduj(ArtMinus) + "'"
        stat, daneartykulu, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych artykuu: ' + stat
            return stat, dane
        przelicznik = daneartykulu[0][1]
        SQL = "SELECT ost_cena1, ost_cena2 FROM rs_artykuly_magazyny "
        SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "'"
        SQL += " AND artykul_id='" + rsglobal.Dekoduj(ArtMinus) + "';"
        stat, ceny, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania cen z magazynu: ' + stat
            return stat, dane
        if len(ceny) > 0:  # bylo kiedys w magazynie wydajemy reszte towaru
            pozycje.append([rsglobal.Dekoduj(ArtMinus), IlMinus, rsglobal.RSRound(IlMinus * przelicznik, 3), ceny[0][0], ceny[0][1], '',2])
            kwota += rsglobal.RSRound(IlMinus * ceny[0][0], 2)
        else:  # wydajemy reszte po cenach z artykulu
            SQL = "SELECT ost_cena1, ost_cena2 FROM rs_artykuly "
            SQL += " WHERE firma_id='" + self.firma_id + "' "
            SQL += " AND artykul_id='" + rsglobal.Dekoduj(ArtMinus) + "';"
            stat, ceny, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd pobrania cen z artykuw: ' + stat
                return stat, dane
            pozycje.append([rsglobal.Dekoduj(ArtMinus), IlMinus, rsglobal.RSRound(IlMinus * przelicznik, 3), ceny[0][0], ceny[0][1], '',2])
            kwota += rsglobal.RSRound(IlMinus * ceny[0][0], 2)

        # wydajemy standardowo dla magazynow detalicznych
        stat, wydania = fs_dokumenty_magazynowe_pom.HDWydajArtykul(self, rsglobal.Dekoduj(ArtPlus), Magazyn, Data, IlPlus, 0, '', True)
        if stat != 'OK':
            return u"Bd wydania artykuu " + w[0] + " " + stat, dane
        pozycje.extend(wydania)
        for p in wydania:
            kwota += rsglobal.RSRound(p[1] * p[3], 2)

    if pozycje == []:
        return "Brak pozycji do utworzenia dokumentu. M:"+Magazyn+" T:"+Typ+" D:"+str(Data)+" N:"+str(Numer)+" AI:"+str(ArtykulyIlosci), dane


    # wstawienie nagwka dokumentu
    SQL = "INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,"
    SQL += "magazyn_dokad,numer_dokad, waluta, kwota, kwota_wal, stan)"
    SQL += " VALUES ('" + self.firma_id + "','" + Magazyn + "','" + Typ + "','" + Data + "'," + str(Numer) + ",'" + Magazyn
    SQL += "','" + Magazyn+"',1,'PLN'," + str(kwota) + "," + str(kwota) + ",'Z');"
    rsglobal.ZapiszDoLogow('Insert 122')

    # wstawienie pozycji dokumentu
    NrPoz = 0
    for poz in pozycje:
        NrPoz += 1
        SQL += "INSERT INTO rs_dokumenty_magazynowe_pozycje"
        SQL += " (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
        SQL += " artykul_id,ilosc1,ilosc2,"
        SQL += " cena1,cena2,cena_wal1,cena_wal2,dokument_przych)"
        SQL += " VALUES ('" + self.firma_id + "','" + Magazyn + "','" + Typ + "','" + Data + "'," + str(Numer) + "," + str(NrPoz) + ",0,"
        SQL += "'" + rsglobal.Dekoduj(poz[0]) + "'," + str(poz[1]) + "," + str(poz[2]) + ","
        SQL += "" + str(poz[3]) + "," + str(poz[4]) + ","
        SQL += "" + str(poz[3]) + "," + str(poz[4]) + ",'" + poz[5] + "');"

    # utworzenie dokumentu
    rsglobal.ZapiszDoLogow('7dm ' + SQL, 1)
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
    if stat != 'OK':
        return u"Bdy tworzenia dokumentu " + Typ + " : " + stat, dane

    # zapis do obrotow
    InsertOM =" INSERT INTO rs_obroty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,typ,typ_znak,nr_poz,nr_ppoz, artykul_id,ilosc1,ilosc2,cena1,cena2,wartosc,wartosc_wal,cena_wal1,cena_wal2,wejscie_data,wejscie_magazyn,magazyn_przeciwny,numer_przeciwny,waluta,dokument_przych) VALUES('%s','%s','%s','%s',%s,'%s',%s,%s,%s,'%s',%s,%s,%s,%s,%s,%s,%s,%s,'%s','%s','%s',%s,'%s','%s');"
    NrPoz = 0
    for poz in pozycje:
        NrPoz += 1
        P = str(NrPoz)
        Art = rsglobal.Dekoduj(poz[0])
        cena1 = str(poz[3])
        cena2 = str(poz[4])
        wartosc = rsglobal.RSRound(poz[1] * poz[3], 2)
        if poz[1] > 0:
            # zapis do magazynu ilosci dodatniej
            ilosc1 = str(poz[1])
            ilosc2 = str(poz[2])
            stat,dump,dump,dump = self.PolSQL.Execute(InsertOM %(self.firma_id,Magazyn,Typ,str(Data),str(Numer),'W','-1',P,'0',Art,ilosc1,ilosc2,cena1,cena2,str(wartosc),str(wartosc),cena1,cena2,Data,Magazyn,Magazyn,'1','PLN',poz[5]),1)
            if stat != 'OK':
                return u"Bdy zapisu do obrotw iloci dodatniej " + Typ + " : " + stat, dane
        else:
            # zapis do magazynu ilosci ujemnej
            ilosc1 = str(-poz[1])
            ilosc2 = str(-poz[2])
            wartosc = -wartosc
            stat,dump,dump,dump = self.PolSQL.Execute(InsertOM %(self.firma_id,Magazyn,Typ,str(Data),str(Numer),'P','1',P,'0',Art,ilosc1,ilosc2,cena1,cena2,str(wartosc),str(wartosc),cena1,cena2,Data,Magazyn,Magazyn,'1','PLN',''),1)
            if stat != 'OK':
                return u"Bdy zapisu do obrotw iloci ujemnej" + Typ + " : " + stat, dane


    # zapis do artykuly magazyny
    for poz in pozycje:
        #if poz[1] > 0:  # dodatnia ilosc
        Art = rsglobal.Dekoduj(poz[0])
        ilosc1 = str(poz[1])
        ilosc2 = str(poz[2])
        cena1 = str(poz[3])
        cena2 = str(poz[4])
        if float(ilosc1) < 0:
            SQL = "UPDATE rs_artykuly_magazyny SET ilosc1=ilosc1- " + ilosc1 + ",ilosc2=ilosc2- " + ilosc2
            SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "' AND artykul_id='" + Art + "'"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                return u"Bdy dodawania do artykuy magazyny " + stat, dane
            SQL = "UPDATE rs_artykuly SET ilosc1=ilosc1- " + ilosc1 + ",ilosc2=ilosc2- " + ilosc2
            SQL += " WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + Art + "'"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                return u"Bdy dodawania do artykuy " + stat, dane

    # zmiana ilosci na spisach z natury
    for poz in pozycje:
        Art = rsglobal.Dekoduj(poz[0])
        # na artykuach przyjecia
        # sprawdzamy czy istnieje spis, ktry warto zmienia
        stat, LDataKat = fs_spis_z_natury_pom.PodajDatyIKategorieSpisow(self, Magazyn, Data, Art)
        if stat == 'OK':
            # dla kadego pasujcego spisu
            for spis in LDataKat:
                if stat == 'OK':
                    DataSpisu = spis[0]
                    KategSpisu = spis[1]
                    # odwieamy przyjcia spisu dla naszego artykuu
                    stat = fs_spis_z_natury_pom.OdswiezPozycjeArtykulowPrzyjecWSpisieZNatury(self, DataSpisu, Magazyn,
                                                                                             KategSpisu, Art)

                    # przeliczamy iloci stwierdzone na pozycjach spisu
                    if stat == 'OK':
                        stat, dump = fs_spis_z_natury_pom.WstawIlosciStwierdzoneDoPozycjiArtykulowPrzyjeciaNaSpisieZNatury(
                            self, DataSpisu, Magazyn, KategSpisu, Art)

    return stat, dane

# -------------------------------------------------------------------------------
# OBSUGA DOKUMENTU TYP H
# -------------------------------------------------------------------------------

def WykonajOtwarcieNowegoMagazynu(self, Magazyn, Typ, Data, Numer, MagazynDokad):
    from funkcje import fs_dokumenty_magazynowe_pom
    dane = []
    rsglobal.ZapiszDoLogow('1', 1)

    # sprawdzenie czy oba detaliczne
    SQL = "SELECT COALESCE(detaliczny,FALSE) FROM rs_magazyny WHERE firma_id='%s' AND magazyn_id IN ('%s','%s');" % (self.firma_id, Magazyn, MagazynDokad)
    stat, wyn, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return u"Bdy w sprawdzaniu czy detaliczne magazyny " + stat, dane
    if len(wyn) != 2:
        return u"Brak magazynu ", dane
    if not wyn[0][0] or not wyn[1][0]:
        return u"Obydwa magazyny musz by detaliczne ", dane

    # sprawdzenie istnienia dokumentow skad
    SQL = "SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='%s' AND magazyn_id = '%s'" % (self.firma_id, Magazyn)
    SQL += " AND (data>'" + str(Data) + "' OR (data<='" + str(Data) + "' AND stan NOT IN ('Z','K')) )"
    stat, wyn, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return u"Bdy w sprawdzaniu istnienia dokumentw " + stat, dane
    if wyn[0][0] > 0:
        return u"W magazynie " + Magazyn + " istniej pniejsze lub niezamknite dokumenty", dane

    # sprawdzenie istnienia dokumentow dokad
    SQL = "SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='%s' AND magazyn_id = '%s'" % (self.firma_id, MagazynDokad)
    SQL += " AND ((data>='" + str(Data) + "' AND stan != 'W') OR data<'" + str(Data) + "')"
    stat, wyn, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return u"Bdy w sprawdzaniu istnienia dokumentw " + stat, dane
    if wyn[0][0] > 0:
        return u"W magazynie " + MagazynDokad + " istniej wczeniejsze lub zamknite dokumenty", dane

    SQL = "SELECT artykul_id, sum(ilosc1 * typ_znak), sum(ilosc2 * typ_znak) FROM rs_obroty_magazynowe "
    SQL += " WHERE firma_id='%s' AND magazyn_id = '%s'" % (self.firma_id, Magazyn)
    SQL += " GROUP BY artykul_id ORDER BY artykul_id"
    stat, lista, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return u"Bdy w pobieraniu danych do dokumentu " + stat, dane

    pozycje = []
    kwota = 0
    for w in lista:  # tworzenie pozycji dla dokumentu magazynowego
        ilosc1 = round(w[1], 3)
        #ilosc2 = round(w[2], 3)

        if ilosc1 == 0:  # nie obslugujemy
            continue

        elif ilosc1 < 0:  # stan ujemny przyjmujemy po ostatniej cenie
            SQL = "SELECT zamiennik_id, przelicznik,a.dynamiczny_przelicznik,j1.calkowita,j2.calkowita FROM rs_artykuly a "
            SQL += " LEFT OUTER JOIN rs_jednostki_miar j1 ON (j1.firma_id=a.firma_id AND j1.kod=a.jm1)"
            SQL += " LEFT OUTER JOIN rs_jednostki_miar j2 ON (j2.firma_id=a.firma_id AND j2.kod=a.jm2)"
            SQL += " WHERE a.firma_id='" + self.firma_id + "' AND a.artykul_id='" + rsglobal.Dekoduj(w[0]) + "'"
            stat, daneartykulu, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd pobrania danych artykuu: ' + stat
                return stat, dane
            #zamiennik = daneartykulu[0][0]
            przelicznik = daneartykulu[0][1]
            #calkowita1 = daneartykulu[0][3]
            #calkowita2 = daneartykulu[0][2]
            SQL = "SELECT ost_cena1, ost_cena2 FROM rs_artykuly_magazyny "
            SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "'"
            SQL += " AND artykul_id='" + rsglobal.Dekoduj(w[0]) + "';"
            stat, ceny, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd pobrania cen z magazynu: ' + stat
                return stat, dane
            if len(ceny) > 0:  # bylo kiedys w magazynie wydajemy reszte towaru
                pozycje.append([rsglobal.Dekoduj(w[0]), ilosc1, rsglobal.RSRound(ilosc1 * przelicznik, 3), ceny[0][0], ceny[0][1], '',2])
                kwota += rsglobal.RSRound(ilosc1 * ceny[0][0], 2)
            else:  # wydajemy reszte po cenach z artykulu
                SQL = "SELECT ost_cena1, ost_cena2 FROM rs_artykuly "
                SQL += " WHERE firma_id='" + self.firma_id + "' "
                SQL += " AND artykul_id='" + rsglobal.Dekoduj(w[0]) + "';"
                stat, ceny, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd pobrania cen z artykuw: ' + stat
                    return stat, dane
                pozycje.append([rsglobal.Dekoduj(w[0]), ilosc1, rsglobal.RSRound(ilosc1 * przelicznik, 3), ceny[0][0], ceny[0][1], '',3])
                kwota += rsglobal.RSRound(ilosc1 * ceny[0][0], 2)

        else:  # wydajemy standardowo dla magazynow detalicznych
            stat, wydania = fs_dokumenty_magazynowe_pom.HDWydajArtykul(self, rsglobal.Dekoduj(w[0]), Magazyn, Data, ilosc1, 0, '', True)
            if stat != 'OK':
                return u"Bd wydania artykuu " + w[0] + " " + stat, dane
            pozycje.extend(wydania)
            for p in wydania:
                kwota += rsglobal.RSRound(p[1] * p[3], 2)

    if pozycje == []:
        return "Brak pozycji do utworzenia dokumentu", dane

    #return stat, dane

    # wstawienie nagwka dokumentu
    SQL = "INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,"
    SQL += "magazyn_dokad,numer_dokad, waluta, kwota, kwota_wal, stan)"
    SQL += " VALUES ('" + self.firma_id + "','" + Magazyn + "','" + Typ + "','" + Data + "'," + str(Numer) + ",'" + Magazyn
    SQL += "','" + MagazynDokad+"',1,'PLN'," + str(kwota) + "," + str(kwota) + ",'Z');"

    # wstawienie pozycji dokumentu
    NrPoz = 0
    for poz in pozycje:
        NrPoz += 1
        SQL += "INSERT INTO rs_dokumenty_magazynowe_pozycje"
        SQL += " (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
        SQL += " artykul_id,ilosc1,ilosc2,"
        SQL += " cena1,cena2,cena_wal1,cena_wal2,dokument_przych)"
        SQL += " VALUES ('" + self.firma_id + "','" + Magazyn + "','" + Typ + "','" + Data + "'," + str(Numer) + "," + str(NrPoz) + ",0,"
        SQL += "'" + rsglobal.Dekoduj(poz[0]) + "'," + str(poz[1]) + "," + str(poz[2]) + ","
        SQL += "" + str(poz[3]) + "," + str(poz[4]) + ","
        SQL += "" + str(poz[3]) + "," + str(poz[4]) + ",'" + poz[5] + "');"

    # utworzenie dokumentu
    rsglobal.ZapiszDoLogow('7dm ' + SQL, 1)
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
    if stat != 'OK':
        return u"Bdy tworzenia dokumentu " + Typ + " : " + stat, dane

    # zapis do obrotow
    InsertOM =" INSERT INTO rs_obroty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,typ,typ_znak,nr_poz,nr_ppoz, artykul_id,ilosc1,ilosc2,cena1,cena2,wartosc,wartosc_wal,cena_wal1,cena_wal2,wejscie_data,wejscie_magazyn,magazyn_przeciwny,numer_przeciwny) VALUES('%s','%s','%s','%s',%s,'%s',%s,%s,%s,'%s',%s,%s,%s,%s,%s,%s,%s,%s,'%s','%s','%s',%s);"
    NrPoz = 0
    for poz in pozycje:
        NrPoz += 1
        P = str(NrPoz)
        Art = rsglobal.Dekoduj(poz[0])
        ilosc1 = str(poz[1])
        ilosc2 = str(poz[2])
        cena1 = str(poz[3])
        cena2 = str(poz[4])
        wartosc = rsglobal.RSRound(poz[1] * poz[3], 2)
        # zapis do magazynu skad
        stat,dump,dump,dump = self.PolSQL.Execute(InsertOM %(self.firma_id,Magazyn,Typ,str(Data),str(Numer),'W','-1',P,'0',Art,ilosc1,ilosc2,cena1,cena2,str(wartosc),str(wartosc),cena1,cena2,Data,Magazyn,MagazynDokad,'1'),1)
        if stat != 'OK':
            return u"Bdy zapisu do obrotw skd " + Typ + " : " + stat, dane
        # zapis do magazynu dokad
        stat,dump,dump,dump = self.PolSQL.Execute(InsertOM %(self.firma_id,MagazynDokad,Typ,str(Data),'1','P','1',P,'0',Art,ilosc1,ilosc2,cena1,cena2,str(wartosc),str(wartosc),cena1,cena2,Data,Magazyn,Magazyn,'1'),1)
        if stat != 'OK':
            return u"Bdy zapisu do obrotw dokd" + Typ + " : " + stat, dane

    # zapis do artykuly przyjecia - tylko dodatnie
    NrPoz = 0
    for poz in pozycje:
        NrPoz += 1
        if poz[1] > 0:  # dodatnia ilosc
            Art = rsglobal.Dekoduj(poz[0])
            ilosc1 = str(poz[1])
            ilosc2 = str(poz[2])
            cena1 = str(poz[3])
            cena2 = str(poz[4])
            SQL = "INSERT INTO rs_artykuly_przyjecia  (firma_id,magazyn_id,data,dokument_id,numer,nr_poz,nr_ppoz," \
                  "dostawca_id,nr_faktury,nr_serii,termin_przyd,artykul_id,ilosc_prz1,ilosc_prz2,cena1,cena2,cena_pierw1,cena_pierw2,waluta," \
                  "cena_wal1,cena_wal2,cena_pierw_wal1,cena_pierw_wal2,ilosc1,ilosc2,rezerwacja1,rezerwacja2,wejscie_data,wejscie_magazyn," \
                  "opis,cecha1_opis,cecha1_wartosc,wirtualne,opakowanie_id,paleta_id,wsp_ilosci_opakowanie,wsp_ilosci_paleta) VALUES " \
                  " ('" + self.firma_id + "','" + MagazynDokad + "','" + Data + "','" + Typ + "'," + str(Numer) + "," + str(NrPoz) + ",0," \
                                               "NULL,NULL,NULL,NULL,'" + Art + "'," + \
                  ilosc1 + "," + ilosc2 + "," + cena1 + "," + cena2 + "," + cena1 + "," + cena2 + ",'PLN'," \
                  + cena1 + "," + cena2 + "," + cena1 + "," + cena2 + "," + ilosc1 + "," + ilosc2 + ",0,0,NOW(),'" + Magazyn + "'," \
                  + "NULL,NULL,NULL,FALSE,NULL,NULL,0,0);"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                return u"Bdy zapisu do artykuw przyjcia "  + stat, dane

    # zapis do artykuly magazyny
    for poz in pozycje:
        #if poz[1] > 0:  # dodatnia ilosc
        Art = rsglobal.Dekoduj(poz[0])
        ilosc1 = str(poz[1])
        ilosc2 = str(poz[2])
        cena1 = str(poz[3])
        cena2 = str(poz[4])
        SQL = "SELECT * FROM rs_artykuly_magazyny WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagazynDokad
        SQL += "' AND artykul_id='" + Art + "'"
        stat, czyjest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            return u"Bdy sprawdzania artykuw przyjcia "  + stat, dane
        if len(czyjest) == 0:  # nie ma - wstawiamy
            SQL = "INSERT INTO rs_artykuly_magazyny (firma_id,magazyn_id,artykul_id,ilosc1,ilosc2,ost_cena1,ost_cena2,"
            SQL += "ost_przychod) VALUES ('" + self.firma_id + "','" + MagazynDokad + "','" + Art + "',"
            SQL += ilosc1 + "," + ilosc2 + "," + cena1 + "," + cena2 + ",'" + Data + "');"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                return u"Bdy wstawienia do artykuy magazyny " + stat, dane
        else:  # dodajemy ilosci
            SQL = "UPDATE rs_artykuly_magazyny SET ilosc1=ilosc1+" + ilosc1 + ",ilosc2=ilosc2+" + ilosc2
            SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + MagazynDokad + "' AND artykul_id='" + Art + "'"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                return u"Bdy dodawania do artykuy magazyny " + stat, dane

    # czyszczenie magazynu skd
    SQL = "UPDATE rs_artykuly_przyjecia SET ilosc1=0, ilosc2=0 "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "'"
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
    if stat != 'OK':
        return u"Bdy czyszczenia artykuy przyjcia " + stat, dane
    SQL = "UPDATE rs_artykuly_magazyny SET ilosc1=0, ilosc2=0 "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "'"
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
    if stat != 'OK':
        return u"Bdy czyszczenia artykuy magazyny " + stat, dane

    return 'OK', dane

#-------------------------------------------------------------------------------
# OBSUGA DOKUMENTU TYP D
#-------------------------------------------------------------------------------

def WykonajKorektePrzyjec(self,Magazyn,Typ):
    #czy podana data jest ostatnim dniem miesica
    Data='2000-01-01'
    Klucz=[Magazyn,Typ,'',0]
    rsglobal.ZapiszDoLogow('1',1)
    
    # pobranie daty z maksymalnym dniem dla typu i magazynu
    SQL = "SELECT data FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"'"
    SQL+= " AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Typ+"' ORDER BY data DESC LIMIT 1;"
    stat,DaneDok,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat!='OK':
        return u"Bdy w pobieraniu daty dokumentw "+Typ+" : "+stat,Klucz
    if len(DaneDok)>0:
        Data=DaneDok[0][0]
    rsglobal.ZapiszDoLogow('2',1)    

    # pobranie pozycji z artykuw przyj, ktre maj zwyky przelicznik lub dynamiczny z kontrol przyj
    SQL = "SELECT ap.data,ap.dokument_id,ap.numer,ap.nr_poz,ap.nr_ppoz,ap.artykul_id,"
    SQL+= " ap.ilosc1-ap.rezerwacja1,ap.ilosc2-ap.rezerwacja2,COALESCE(ap.cecha1_opis,''),COALESCE(ap.cecha1_wartosc,'') "
    SQL+= " FROM rs_artykuly_przyjecia ap INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    SQL+= " AND ((ap.ilosc1-ap.rezerwacja1 = 0 AND ap.ilosc2-ap.rezerwacja2>0)"
    SQL+= " OR (ap.ilosc2-ap.rezerwacja2 = 0 AND ap.ilosc1-ap.rezerwacja1>0)) AND NOT wirtualne"
    SQL+= " AND ((NOT a.dynamiczny_przelicznik) OR (a.dynamiczny_przelicznik AND a.sledzenie_dostaw));"
    stat,DaneAP,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat!='OK':
        return u"Bdy w pobieraniu normalnych danych z przyje : "+stat,Klucz
    rsglobal.ZapiszDoLogow('3',1)

    # pobranie artykuw, ktre maj dynamiczny przelicznik bez kontroli przyj i maj zerow jedn stron
    SQL = "SELECT artykul_id FROM rs_artykuly_przyjecia ap INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    SQL+= " AND a.dynamiczny_przelicznik AND NOT a.sledzenie_dostaw AND NOT WIRTUALNE GROUP BY ap.artykul_id"
    SQL+= " HAVING ((SUM(ap.ilosc1-ap.rezerwacja1) = 0 AND SUM(ap.ilosc2-ap.rezerwacja2) >0)"
    SQL+= " OR (SUM(ap.ilosc2-ap.rezerwacja2) = 0 AND SUM(ap.ilosc1-ap.rezerwacja1) >0)) "
    stat,DaneArt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat!='OK':
        return u"Bdy w pobieraniu danych artykuw z dynamicznym przelicznikiem : "+stat,Klucz
    rsglobal.ZapiszDoLogow('1',1)
    DaneAPD=[]

    # pobranie pozycji z artykuw przyj, ktre maj dynamiczny przelicznik bez kontroli przyj
    if len(DaneArt)>0:
        LArt=''
        for art in DaneArt:
            LArt+="'"+rsglobal.Dekoduj(art[0])+"',"
        LArt = LArt.strip(",")
                
        SQL = "SELECT ap.data,ap.dokument_id,ap.numer,ap.nr_poz,ap.nr_ppoz,ap.artykul_id,"
        SQL+= " ap.ilosc1-ap.rezerwacja1,ap.ilosc2-ap.rezerwacja2,COALESCE(ap.cecha1_opis,''),COALESCE(ap.cecha1_wartosc,'') "
        SQL+= " FROM rs_artykuly_przyjecia ap "
        SQL+= " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND NOT wirtualne"
        SQL+= " AND artykul_id IN ("+LArt+") AND (ap.ilosc2-ap.rezerwacja2 >0 OR ap.ilosc1-ap.rezerwacja1 > 0)"
        stat,DaneAPD,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat!='OK':
            return u"Bdy w pobieraniu danych z przyje z dynamicznym przelicznikiem : "+stat,Klucz
    rsglobal.ZapiszDoLogow('4',1)
    if len(DaneAP) == 0 and len(DaneAPD) == 0:
        return 'Brak danych do umieszczenia na dokumencie '+Typ,Klucz 
    rsglobal.ZapiszDoLogow('2',1)

    # wybranie najwikszej daty (to bdzie data dokumentu)
    for poz in DaneAP:
        if poz[0] > Data:
            Data = poz[0]
    
    for poz in DaneAPD:
        if poz[0] > Data:
            Data = poz[0]
    rsglobal.ZapiszDoLogow('5 '+Data,1)            

    # wybranie numeru dokumentu
    stat,DNr,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');",3)        
    rsglobal.ZapiszDoLogow('6',1)
    if stat!='OK':
        return 'Bdy pobierania numeru dokumentu : '+stat,Klucz
    if DNr[0][0] in (None,'None',''):
        return 'Bdy pobierania numeru dokumentu',Klucz

    NrDok=str(DNr[0][0])
    
    NrPoz=1
    magtmp=Magazyn+'    '
    
    # poczenie list (maj identyczn struktur)
    DaneP = DaneAP + DaneAPD
        
    # wstawienie nagwka dokumentu
    SQL="INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad)"
    SQL+=" VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+Data+"',"+NrDok+",'"+Magazyn+"');"
    rsglobal.ZapiszDoLogow('7 '+SQL,1)

    # wstawienie pozycji dokumentu 
    for poz in DaneP:
        rsglobal.ZapiszDoLogow('77 Pozycja '+str(poz),1)
        nr = "0000"+str(poz[2])
        nr = nr[len(nr)-6:len(nr)-2]
        poztmp = "0000"+str(poz[3])
        poztmp = poztmp[len(poztmp)-6:len(poztmp)-2]
        ppoztmp = "0000"+str(poz[4])
        ppoztmp = ppoztmp[len(ppoztmp)-6:len(ppoztmp)-2]
                                    
        DokPrz = self.firma_id+magtmp[:4]+poz[1]+poz[0]+nr+poztmp+ppoztmp
        rsglobal.ZapiszDoLogow('8 poz '+str(poz)+' DP '+DokPrz,1)
        
        SQL+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
        SQL+=" (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
        SQL+=" artykul_id,ilosc1,ilosc2,"
        SQL+=" cecha1_opis,cecha1_wartosc,dokument_przych)"        
        SQL+=" VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+Data+"',"+NrDok+","+str(NrPoz)+",0,"
        SQL+="'"+rsglobal.Dekoduj(poz[5])+"',"+str(poz[6])+","+str(poz[7])+","
        SQL+="'"+rsglobal.Dekoduj(poz[8])+"','"+rsglobal.Dekoduj(poz[9])+"','"+DokPrz+"');"
        NrPoz+=1

    # utworzenie dokumentu
    rsglobal.ZapiszDoLogow('5 '+SQL,1)
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat!='OK':
        return u"Bdy tworzenia dokumentu "+Typ+" : "+stat,Klucz
    rsglobal.ZapiszDoLogow('6  W na G',1)
    # zamknicie dokumentu z W na G
    Klucze={}     
    Klucze['Mag'] = Magazyn
    Klucze['Typ'] = Typ
    Klucze['Data'] = Data
    Klucze['Numer'] = NrDok
    Klucze['Funkcja'] = 18
        
    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [],False)
    if stat!='OK':
        return 'Bd zamknicia dokumentu '+Typ+' z W na G : '+stat,Klucz
    rsglobal.ZapiszDoLogow('7 G na Z',1)
    # zamknicie dokumentu z G na Z
    Klucze['Funkcja'] = 29
    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [],False)
    if stat!='OK':
        return 'Bd zamknicia dokumentu '+Typ+' z G na Z : '+stat,Klucz
    rsglobal.ZapiszDoLogow('8 ',1)
    Klucz[2]=Data
    Klucz[3]=NrDok
    
    return 'OK',Klucz


#-------------------------------------------------------------------------------
# OBSUGA DOKUMENTU TYP K
#-------------------------------------------------------------------------------

def WykonajKorekteZaokraglen(self,Magazyn,Typ,Data,Numer,MaksIlosc,MaksWartosc):
    #czy podana data jest ostatnim dniem miesica
    stat,data,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_ostatni_dzien_miesiaca('"+Data+"');",3)
    if stat!='OK':
        stat='BL SPR DATY'
        return stat
    if stat=='OK':
        if data[0][0]!=Data:
            stat='N O D M'
            return stat
    
    #stan magazynu na podany dzien 
    #jako pozycje dokumentu magazynowego podawane te, dla ktorych w jednej jm jest 0 a w drugiej nie 
    #i te dla ktorych ilosc wynosi zero, a wartosc != 0
    if stat=='OK':
        SQL="SELECT om.artykul_id, sum(om.ilosc1*om.typ_znak), sum(om.ilosc2*om.typ_znak), "
        SQL+="sum(om.wartosc*om.typ_znak), sum(om.wartosc_wal*om.typ_znak) " 
        SQL+="FROM rs_obroty_magazynowe om "
        SQL+="WHERE om.firma_id='"+self.firma_id+"' AND om.data <= '"+Data+"' AND om.magazyn_id = '"+Magazyn+"' "
        SQL+="GROUP BY om.artykul_id "
        SQL+="HAVING (((sum(om.ilosc1*om.typ_znak)=0 AND sum(om.ilosc2*om.typ_znak)!=0) "
        SQL+="OR (sum(om.ilosc1*om.typ_znak)!=0 AND sum(om.ilosc2*om.typ_znak)=0)) "
        SQL+="OR (sum(om.ilosc1*om.typ_znak)=0 AND sum(om.ilosc2*om.typ_znak)=0 AND (sum(om.wartosc*om.typ_znak)!=0 AND ABS(sum(om.wartosc*om.typ_znak)) <= "+str(MaksWartosc)+" ) "
        SQL+="OR (sum(om.ilosc1*om.typ_znak)!=0 AND sum(om.ilosc2*om.typ_znak)!=0 AND (sum(om.wartosc*om.typ_znak)=0 AND ABS(sum(om.ilosc1*om.typ_znak)) <= "+str(MaksIlosc)+" )))) "
        SQL+="AND (ABS(sum(om.wartosc*om.typ_znak)) <= "+str(MaksWartosc)+" "
        SQL+="OR ABS(sum(om.ilosc1*om.typ_znak)) <= "+str(MaksIlosc)+") ;"
        stat,DaneP,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat!='OK':
            stat = 'BL DANEP'
            return stat
        if len(DaneP)==0:
            stat='BR DANEP'
            return stat
   
   #tworzenie dokumentu
    if stat=='OK':
        rsglobal.ZapiszDoLogow('nroid-1')
        stat,nroid,dump,dump = self.PolSQL.Execute("INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,magazyn_dokad) VALUES ('%s','%s','%s','%s',%s,'%s','%s');" % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),Magazyn,Magazyn),1)
        if stat!='OK':
            stat='BL INS K'
            return stat
    if stat=='OK':
        Insert = "INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2) VALUES ('%s','%s','%s','%s',%s,%s,%s,'%s',%s,%s);"
        InsertOM =" INSERT INTO rs_obroty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,typ,typ_znak,nr_poz,nr_ppoz, artykul_id,ilosc1,ilosc2,wartosc,wartosc_wal) VALUES('%s','%s','%s','%s',%s,'%s',%s,%s,%s,'%s',%s,%s,%s,%s);"
        i=1
        Wartosc=0
        Wartosc_wal=0
        for pozycja in DaneP:
            P=str(i)
            Pp=0
            Art=rsglobal.Dekoduj(pozycja[0])
            Il1=str(pozycja[1]*-1)
            Il2=str(pozycja[2]*-1)
            wartosc=pozycja[3]
            wartosc_wal=pozycja[4]    
            stat,dump,dump,dump = self.PolSQL.Execute(Insert % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),P,Pp,Art,Il1,Il2),1)                            
            if stat!='OK':
                stat='BL INS POZ K' 
                return stat
            stat,dump,dump,dump = self.PolSQL.Execute(InsertOM %(self.firma_id,Magazyn,Typ,str(Data),str(Numer),'K',str(1),P,Pp,Art,Il1,Il2,str(wartosc*-1),str(wartosc_wal*-1)),1)
            if stat!='OK':
                stat='BL INS POZ K OM'
                return stat
            i=i+1
            Wartosc=Wartosc+wartosc 
            Wartosc_wal=Wartosc_wal+wartosc_wal 
            
    
    #uzupelnienie naglowka
    if stat=='OK':
        UPD="UPDATE rs_dokumenty_magazynowe SET kwota="+str(Wartosc*-1)+" , kwota_wal="+str(Wartosc_wal*-1)+", stan='Z' "
        
        #
        # FIXME: pobranie domyslnych parametrow dla dokumentu w magazynie
        #
        
        UPD+="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Typ+"' AND data='"+Data+"' AND numer="+str(Numer)+" ;"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat!='OK':
            stat='BL UPD K'
            return stat
        return 'OK'
    

#-------------------------------------------------------------------------------
#  ALGORYTM GLOWNY
#-------------------------------------------------------------------------------

# klucze[0] - 1-insert, 2-update, 3-kopiowanie, 33-tworzenie korekty, 34-pobranie info o dokumencie, 35-MM z analizy
#             36 - pobranie ilosci z obrotow
# klucze[1] - magazyn
# klucze[2] - typ dokumentu
# klucze[3] - magazyn dokad lub lista artykulow dla kompensaty dla dokumentu typu 'I'
# klucze[4] - data
# klucze[5] - numer

#pola to wartosci klucza starego (przy zmianie) lub kopiowanego (przy kopii) dokumentu magazynowego

# wraca z OK lub opisem bledu

Magazyn = rsglobal.Dekoduj(klucze[1]).strip()
Typ = rsglobal.Dekoduj(klucze[2]).strip()
MagazynDokad = rsglobal.Dekoduj(klucze[3])  # zawiera ArtykulyIlosci dla typu 'I'
Data = rsglobal.Dekoduj(klucze[4])
Numer = klucze[5]
MaksIlosc = klucze[6]
MaksWartosc = klucze[7]

stat = 'OK'
wart = []
dane = []
if klucze[0] == 36:
    # pobranie ilosci dla dokumentu typu I
    SQL = "SELECT om.artykul_id, ar.nazwa, sum(om.ilosc1*typ_znak) FROM rs_obroty_magazynowe om"
    SQL += " INNER JOIN rs_artykuly ar USING(firma_id, artykul_id)"
    SQL += " WHERE om.firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "'"
    SQL += " GROUP BY om.artykul_id, ar.nazwa HAVING sum(om.ilosc1*typ_znak)!=0 ORDER BY abs(sum(om.ilosc1*typ_znak))"
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = "Bd pobierania iloci do kompensaty " + stat
        dane.append(stat)

if klucze[0] == 35:
    # tworzenie MM z analizy stanow
    # data dzisiejsza, numer kolejny, stosowac Dekoduj dla symboli artykulow
    ArtykulyIlosci = klucze[8]
    
    # pobranie dzisiejszej daty, pobranie numerow dla magazynu skad i dokad      #MK
    Data = rsglobal.PodajDzis()
    Typ = rsglobal.Dekoduj(klucze[9]).strip()

    # sprawdzenie czy podany typ dokumentu jest rodzaju 'M'         #MK
    SQLTYP = "SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='%s' AND dokument_id='%s';"  % (self.firma_id,Typ)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLTYP, 1)
    stat, dane_typ, dump, dump = self.PolSQL.Execute(SQLTYP, 3)
    if stat == 'OK':
        if len(dane_typ) == 0:
            stat = 'Bdny typ dokumentu'
            wart.append(stat)
        elif dane_typ[0][0] !='M':
            stat='Bdny typ dokumentu'
            wart.append(stat)
    if stat == 'OK':
        SQL = "SELECT rsf_podaj_nowy_numer_dokumentu('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\']','MM');" % (self.firma_id,Magazyn,Typ,str(Data))
        #rsglobal.ZapiszDoLogow('MAGDA SQL:'+SQL,1)
        stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat == 'OK':
            if len(dane) == 0:
                stat = 'Bd wyznaczania numeru dokumentu'
                wart.append(stat)
            else:
                Numer = dane[0][0]

    if stat == 'OK':
        SQL = "SELECT rsf_podaj_nowy_numer_dokumentu('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\']','MM');" % (self.firma_id,MagazynDokad,Typ,str(Data))
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
        stat, dane, dump, dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(dane) == 0:
                stat = 'Bd wyznaczania numeru dokumentu'
                wart.append(stat)
            else:
                NumerDokad = dane[0][0]

    # dodanie naglowka    #MK
    if stat == 'OK':
        SQL = "INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,magazyn_dokad,numer_dokad) VALUES ('%s','%s','%s','%s',%s,'%s','%s',%s);" % (
        self.firma_id, Magazyn, Typ, str(Data), str(Numer), Magazyn, MagazynDokad, str(NumerDokad))
        rsglobal.ZapiszDoLogow('nroid-2')
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
        stat, nroid, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd dodawania dokumentu magazynowego'
            wart.append(stat)

    # petla po artykulach -dodawanie pozycji    #MK
    if stat == 'OK':
        SQL = "INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2) VALUES ('%s','%s','%s','%s',%s,%s,%s,'%s',%s,%s);"
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)

        # pobranie przelicznika    #MK
        SQLPRZEL = "SELECT przelicznik FROM rs_artykuly where firma_id='%s' AND artykul_id='%s';"
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLPRZEL, 1)

        nr_poz = 0
        for w in ArtykulyIlosci:
            Artykul = rsglobal.Dekoduj(w[0])

            if stat =='OK':
                Ilosc = w[1]
                nr_poz+=1
                stat,dane,dump,dump = self.PolSQL.Execute(SQLPRZEL % (self.firma_id,Artykul),3)
                if stat == 'OK':
                    if len(dane) == 0:
                        stat = 'Bd pobierania przelicznika'
                        wart.append(stat)
                        break
                    else:
                        Przelicznik = dane[0][0]
                if stat == 'OK':
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),str(nr_poz),'0',Artykul,str(Ilosc),str(round(Ilosc*Przelicznik,4))),1)
                    if stat!='OK':
                        stat='Bd dodawania pozycji dokumentu'
                        wart.append(stat)
                        break

    # wrocic z numerem dokumentu magazynowego zlozonego jak na wydruk     #MK
    if stat == 'OK':
        SQL = "SELECT rsf_podaj_numer_dokumentu_na_wydruk ('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\',%s]','M');"  % (self.firma_id,Magazyn,Typ,str(Data),str(Numer))
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
        stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat == 'OK':
            if len(dane) == 0:
                stat = 'Bd pobrania symbolu dokumentu'
                wart.append(stat)

if not klucze[0] in (8,34,35):
    # magazyn
    if Magazyn == '':
        stat = 'BR MAG'
        wart.append(stat)
    
    Magazyn = (Magazyn+'    ')[0:4]
    if stat == 'OK':
        stat, wyn, dump, dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='%s' AND magazyn_id='%s';" % (self.firma_id,Magazyn),3)
        if stat == 'OK':
            if len(wyn) == 0:
                stat='BL MAG'
                wart.append(stat)
  
    if stat == 'OK':
        # typ dokumentu
        if Typ == '':
            stat = 'BR TYP'
            wart.append(stat)
                
        if self.operator_id != STANDARD_OPERATOR_ID and stat == 'OK':
            stat, wyn, dump, dump = self.PolSQL.Execute("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Magazyn+"','"+Typ+"',4);",3)
            if stat == 'OK':
                if len(wyn) == 0:
                    stat='UP TYP'
                    wart.append(stat)
                else:
                    if not wyn[0][0]:
                        stat = 'UP TYP'
                        wart.append(stat)
                        

if klucze[0] == 34:
    # pobranie informacji o dokumencie
    sql = "SELECT COALESCE(dm.magazyn_dokad,''),COALESCE(tdm.korekta,FALSE),tdm.typ_dokumentu"
    sql += " FROM rs_dokumenty_magazynowe dm"
    sql += " INNER JOIN rs_typy_dokumentow_m tdm USING (firma_id,dokument_id)"
    sql += " WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Magazyn+"'"
    sql += " AND dm.dokument_id='"+Typ+"' AND dm.data='"+Data+"' AND dm.numer="+str(Numer)+";"
    stat, dane, dump, dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych korygowanego dokumentu: '+stat
    elif len(dane) == 0:
        stat = 'Brak dokumentu o podanym kluczu'


if klucze[0] in (1, 2, 3, 33) and stat == 'OK':
    # rodzaj dokumentu i inne dane
    sql = "SELECT typ_dokumentu,COALESCE(korekta,FALSE) FROM rs_typy_dokumentow_m"
    sql += " WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Typ+"';"
    stat, wyn, dump, dump = self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        if len(wyn) == 0:
            stat = 'BL TYP'
            wart.append(stat)
        else:
            if not wyn[0][0] in ['M', 'W', 'P', 'K', 'L', 'C', 'D', 'H', 'I']:
                stat = 'BL TYP'
                wart.append(stat)
            else:
                Rodzaj = wyn[0][0]
                Korekta = wyn[0][1]
                
                #sprawdzamy w przypadku dokumentu rodzaju L, czy magazyn obsluguje lokacje
                if Rodzaj == 'L':
                    sql ="SELECT czy_lokacje FROM rs_magazyny"
                    sql += " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn.strip()+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd pobrania danych magazynu: '+stat
                    elif len(d) == 0:
                        stat = 'Bdny numer magazynu'
                    elif not d[0][0]:
                        stat = "Magazyn "+Magazyn.strip()+" nie obsuguje dokumentw typu 'L'"

    if stat=='OK':
        if klucze[0] in [1,3]:
            if Korekta:
                stat = 'BL KOREKTA TYLKO DO DOKUMENTU'
                
    if stat=="OK":
        if Rodzaj == "M":
            TypD = "MM"
        else:
            TypD = "M"

    # sprawdzenie daty jeli typ !='D'
    if stat == 'OK' and Rodzaj != 'D':
        #data
        if Data in ('','    -  -  '):
            stat = 'BR DATY'
        else:
            if not rsglobal.SprawdzCzyToData(Data):
                stat = 'BL DATA'
                wart.append(stat)
                
    #sprawdzenie czy mona wystawic dokument z t dat
        if stat == 'OK':
            stat, test, dump, dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','"+TypD+"');",3)
            ##if test[0][0]!='OK' or stat!='OK':    
            ##    stat='N M D D'
            if stat != 'OK':
                stat = 'N M D D'
            else:
                if test[0][0] != 'OK':
                    stat = test[0][0]
                
    if stat == 'OK':
        if Rodzaj == 'W':
            MagP ='NULL'
            MagW = Magazyn
        elif Rodzaj == 'P':
            MagP = Magazyn
            MagW = 'NULL'
        elif Rodzaj == 'L':
            MagP = Magazyn
            MagW = Magazyn
            MagazynDokad = Magazyn
            NumerDokad = Numer
        elif Rodzaj == 'K':
            stat=WykonajKorekteZaokraglen(self, Magazyn, Typ, Data, Numer, MaksIlosc, MaksWartosc)
        elif Rodzaj == 'D':
            stat, dane = WykonajKorektePrzyjec(self, Magazyn, Typ)
        elif Rodzaj == 'H':  #JR 2023-01-07
            if MagazynDokad == '':
                stat = 'BR MAGD'
                wart.append(stat)
            MagazynDokad = (MagazynDokad+'    ')[0:4]
            if Magazyn == MagazynDokad:
                stat = 'MM MAG TEN SAM'
                wart.append(stat)
            if stat == 'OK':
                stat, dane = WykonajOtwarcieNowegoMagazynu(self, Magazyn, Typ, Data, Numer, MagazynDokad)
        elif Rodzaj == 'I':  # JR 2023-01-30 (13318)
            if stat == 'OK':
                stat, dane = WykonajKompensateIlosciowa(self, Magazyn, Typ, Data, Numer, MagazynDokad)
        elif Rodzaj == 'M':
            if MagazynDokad=='':
                stat='BR MAGD'
                wart.append(stat)
            MagazynDokad = (MagazynDokad+'    ')[0:4]
            if Magazyn==MagazynDokad:
                stat='MM MAG TEN SAM'
                wart.append(stat)
            
            if stat == 'OK':
                sql = "SELECT magazyn_id FROM rs_magazyny"
                sql += " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynDokad+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia magazynu docelowego: '+stat
                elif len(d) == 0:
                    stat = 'BL MAGD'
                
        elif Rodzaj == 'C':
            MagP = Magazyn
            MagW = Magazyn
            MagazynDokad=Magazyn
            NumerDokad=Numer


    if stat == 'OK':
        #pobieramy domyslne wartosci dla dokumentu w magazynie
        stat, SDomyslne = fs_magazyny_parametry_dokumentow_pom.PodajDomyslneParametryDlaDokumentu(self,Magazyn,Typ)
        #print 'SDomyslne', SDomyslne

    if stat=='OK':
        #JESLI TYP DOKUMENTU INNY NIZ K, D, H i I TO KONTYNUUJEMY
        if not Rodzaj in ('K', 'D', 'H', 'I'):
            if test[0][0] == 'OK':
                stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='%s' AND magazyn_id='%s';" % (self.firma_id,MagazynDokad),3)
                if stat=='OK':
                    if len(wyn)==0:
                        stat='BL MAGD'
                        wart.append(stat)
                MagP = MagazynDokad
                MagW = Magazyn
     
                #sprawdzenie czy dodawanie z dat do magazynu dokad jest ok
                stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+MagazynDokad+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','"+TypD+"');",3)            
                if test[0][0]!='OK':    
                    ##stat='N M D D' # nie mozna doda dokumentu
                    wart.append(stat)
                if stat=='OK':
                    stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+MagazynDokad+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','"+TypD+"');",3)        
    
                    if dane[0][0] in (None,'None',''):
                        stat=u'B N D' # bdy numeracji dokumentu
                        wart.append(stat)
                    else:
                        NumerDokad=dane[0][0]
                        
            else:
                stat='BL TYP'
                wart.append(stat)
            
            if Numer < 1:
                stat='BL NUM'
                wart.append(stat)
            
            if klucze[0]==1 and stat=='OK': #WSTAWIENIE DOKUMENTU
                stat,wyn,dump,dump = self.PolSQL.Execute("SELECT dokument_id FROM rs_dokumenty_magazynowe WHERE firma_id='%s' AND magazyn_id='%s' AND dokument_id='%s' AND data='%s' AND numer=%s;" % (self.firma_id,Magazyn,Typ,Data,str(Numer)),3)
                if stat=='OK':
                    if len(wyn)>0:
                        stat='BL DOK'
                        wart.append(stat)
                if Rodzaj=='M' and stat=='OK':
                    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT dokument_id FROM rs_dokumenty_magazynowe WHERE firma_id='%s' AND magazyn_id='%s' AND dokument_id='%s' AND data='%s' AND numer=%s;" % (self.firma_id,MagazynDokad,Typ,Data,str(NumerDokad)),3)
                    if stat=='OK':
                        if len(wyn)>0:
                            stat='BL DOK'
                            wart.append(stat)
                
                if stat=='OK':
                    # insert dokumentu
                    if Rodzaj=='W':
                        rsglobal.ZapiszDoLogow('nroid')
                        stat,nroid,dump,dump = self.PolSQL.Execute("INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad) VALUES ('%s','%s','%s','%s',%s,'%s');" % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),Magazyn),1)
                    elif Rodzaj=='P':
                        stat,wersjam,dump,dump = self.PolSQL.Execute("SELECT wersja_magazyn FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"';", 3)
                        if len(wersjam) == 1:
                            if str(wersjam[0][0]).strip() not in ('None',None,''):
                                stat,wersjac,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod = '"+str(wersjam[0][0])+"';", 3)    
                                if len(wersjac)==0:
                                    stat='BL WERSJA CEN'
                                    dane.append(stat) 
                                else:
                                    WersjaM = "'"+str(wersjam[0][0])+"'"
                            else:
                                WersjaM = 'NULL'
                        if stat=='OK':
                            rsglobal.ZapiszDoLogow('nroid2')
                            SQL="INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_dokad,wersja) VALUES ('%s','%s','%s','%s',%s,'%s',%s);" % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),Magazyn,WersjaM)
                            stat,nroid,dump,dump = self.PolSQL.Execute(SQL,1)
                    elif Rodzaj=='L':
                        rsglobal.ZapiszDoLogow('nroid3')
                        stat,nroid,dump,dump = self.PolSQL.Execute("INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,magazyn_dokad,numer_dokad) VALUES ('%s','%s','%s','%s',%s,'%s','%s',%s);" % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),Magazyn,Magazyn,str(Numer)),1)
                    elif Rodzaj=='C':
                        rsglobal.ZapiszDoLogow('nroid4')
                        stat,nroid,dump,dump = self.PolSQL.Execute("INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,magazyn_dokad,numer_dokad) VALUES ('%s','%s','%s','%s',%s,'%s','%s',%s);" % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),Magazyn,Magazyn,str(Numer)),1)
                    else:
                        if stat=='OK':
                            rsglobal.ZapiszDoLogow('nroid5')
                            stat,nroid,dump,dump = self.PolSQL.Execute("INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,magazyn_dokad,numer_dokad) VALUES ('%s','%s','%s','%s',%s,'%s','%s',%s);" % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),Magazyn,MagazynDokad,str(NumerDokad)),1)
                    
                    if stat=='OK':
                        # wpisanie domyslnych parametrow dla dokumentu w magazynie
                        UpdDomyslne = fs_magazyny_parametry_dokumentow_pom.UtworzSqlUpdZParametrow(self.firma_id,Magazyn,Typ,str(Data),Numer,SDomyslne)
                        rsglobal.ZapiszDoLogow('UpdDomyslne '+UpdDomyslne,1)
                        if UpdDomyslne != '':
                            stat,dump,dump,dump = self.PolSQL.Execute(UpdDomyslne,1)
                            rsglobal.ZapiszDoLogow('stat '+stat,1)                                                    
                    if stat=='OK':
                        self.PolSQL.Commit()
                    else:
                        self.PolSQL.Rollback()
                    rsglobal.ZapiszDoLogow('2 stat '+stat,1)

            elif klucze[0]==2 and stat=='OK': #ZMIANA KLUCZA
                mag_skad = ''
                mag_dokad_st = ''
                sql_mm=''
                
                MagazynS = rsglobal.Dekoduj(pola[0]).strip()
                TypS = rsglobal.Dekoduj(pola[1]).strip()
                DataS = rsglobal.Dekoduj(pola[2])
                NumerS = str(pola[3])

                #przyblokowanie SELECT FOR UPDATE modyfikowanego dokumentu
                sql ="SELECT dokument_id,magazyn_skad,magazyn_dokad,stan"
                sql+=" FROM rs_dokumenty_magazynowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynS+"'"
                sql+=" AND dokument_id='"+TypS+"' AND data='"+DataS+"' AND numer="+NumerS+" FOR UPDATE NOWAIT;"
                stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)

                if 'nie mona naoy blokady' in stat:
                    stat = 'Dokument jest zablokowany przez innego uytkownika'
                elif stat == 'OK':
                    if len(wyn)==0:
                        stat='BL DOKN'
                        wart.append(stat)
                    else:
                        mag_skad=wyn[0][1]
                        mag_dokad_st=wyn[0][2]
                        MagazynDokadS = rsglobal.Dekoduj(wyn[0][2]).strip()
                
                if stat=='OK':
                    if rsglobal.Dekoduj(wyn[0][3]) != 'W':
                        stat = "Dokument w stanie '"+rsglobal.Dekoduj(wyn[0][3])+"'. Zmiana klucza niemoliwa."

                if stat=='OK': #sprawdzenie projektu PW 2017-08-22
                    sql ="SELECT projekt_id FROM rs_dokumenty_magazynowe WHERE firma_id='" + self.firma_id + "' "
                    sql+="AND magazyn_id='" + Magazyn + "' AND dokument_id = '" + Typ + "' AND data='" + Data + "'"
                    sql+="AND numer='" + str(Numer) + "';"
                    stat, dd, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        stat = u'Bdy przy pobraniu projektu z dokumentu magazynowego:' + stat
                    elif stat == 'OK' and len(dd) > 0:
                        sql = "SELECT data_do>='" + DataS + "' FROM rs_projekty WHERE firma_id='" + self.firma_id + "' "
                        sql += "AND projekt_id='"+dd[0][0]+"' and data_do is not null;"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            stat = 'Bdy przy sprawdzaniu daty projektu :' + stat
                        else:
                            if len(d) == 1 and d[0][0] == False:
                                stat = "BL PROJ"

                if stat=='OK':
                    # sprawdzamy czy dokument mial przypisane korekty,
                    # ktorych daty moga byc wczesniejsze od nowej daty dokumentu
                    # pobieramy wszystkie korekty, bo beda wykorzystane do UPDATE dla powiazania
                    sql ="SELECT magazyn_id,dokument_id,data,numer"
                    sql+=" FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND kor_dm_magazyn_id='"+MagazynS+"' AND kor_dm_dokument_id='"+TypS+"'"
                    sql+=" AND kor_dm_data='"+DataS+"' AND kor_dm_numer="+NumerS+";"
                    stat,Korekty,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia korekt przypisanych do dokumentu: '+stat
                    elif len(Korekty) > 0:
                        for i in xrange(len(Korekty)):
                            if rsglobal.Dekoduj(Korekty[i][2]) < Data:
                                stat = 'BL WCZESNIEJSZE KOREKTY'
                                break
                        
                if stat=='OK':
                    #sprawdzimy, czy dokument posiada lokacje w rs_dokumenty_magazynowe_lokacje
                    sql = "SELECT COUNT(*) FROM rs_dokumenty_magazynowe_lokacje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynS+"'"
                    sql+=" AND dokument_id='"+TypS+"' AND data='"+DataS+"' AND numer="+NumerS+";"
                    stat,daneLOK1,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        stat = 'Bd pobrania informacji o lokacjach dla pozycji: '+stat
                        dane.append(stat)
                        
                if stat=='OK':
                    #sprawdzimy, czy dokument posiada lokacje w rs_dokumenty_magazynowe_pozycje
                    sql = "SELECT COUNT(*) FROM rs_dokumenty_magazynowe_pozycje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynS+"'"
                    sql+=" AND dokument_id='"+TypS+"' AND data='"+DataS+"' AND numer="+NumerS
                    sql+=" AND (lokacja_skad IS NOT NULL OR lokacja_dokad IS NOT NULL);"
                    stat,daneLOK2,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        stat = 'Bd pobrania informacji o lokacjach w pozycjach: '+stat
                        dane.append(stat)
                
                if Typ != TypS:
                    # jesli zmienil sie typ dokumentu, to sprawdzamy, czy zmiana klucza
                    # odbywa sie w ramach korekty lub w ramach dokumentu
                    sql ="SELECT COALESCE(korekta,FALSE) FROM rs_typy_dokumentow_m"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+TypS+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        stat = 'Bd pobrania rodzaju dokumentu '+TypS+': '+stat
                        dane.append(stat)
                    elif Korekta != d[0][0]:
                        if d[0][0]:
                            # jesli zmieniamy klucz korekty
                            stat = 'BL ZMIANA KLUCZA KOREKTA'
                        else:
                            # zmieniamy klucz zwyklego dokumentu
                            stat = 'BL ZMIANA KLUCZA NIEKOREKTA'
                
                if stat == 'OK':
                    if daneLOK1[0][0] > 0 or daneLOK2[0][0] > 0:
                        #w dokumencie istnieja lokacje
                        #wiec zmiany klucza maja obostrzenia
                        
                        if stat == 'OK':
                            if Typ != TypS:
                                #jesli zmienil sie typ dokumentu,
                                #to pobieramy rodzaj dokumentu
                                sql ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
                                sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+TypS+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                                if stat != 'OK':
                                    stat = 'Bd pobrania rodzaju dokumentu '+TypS+': '+stat
                                    dane.append(stat)
                                RodzajS = rsglobal.Dekoduj(d[0][0]).strip()
                            else:
                                RodzajS = Rodzaj
                        
                        if stat == 'OK':
                            #zmiana rodzaju dokumentu niedozwolona
                            if RodzajS != Rodzaj.strip():
                                stat = 'Dokument posiada lokacje. Zmiana rodzaju dokumentu z '
                                stat+= RodzajS+' na '+Rodzaj+' niemoliwa.'
                                dane.append(stat)

                        if stat == 'OK':
                            #zmiana magazynow jest niedozwolona
                            if Magazyn.strip() != MagazynS:
                                stat = 'Dokument posiada lokacje. Zmiana magazynu z '
                                stat+= MagazynS+' na '+Magazyn.strip()+' niemoliwa.'
                                dane.append(stat)

                        if stat == 'OK' and Rodzaj == 'M':
                            #zmiana magazynow jest niedozwolona
                            if MagazynDokad.strip() != MagazynDokadS:
                                stat = 'Dokument posiada lokacje. Zmiana magazynu dokd z '
                                stat+= MagazynDokadS+' na '+MagazynDokad.strip()+' niemoliwa.'
                                dane.append(stat)

                if stat=='OK':
                    #sprawdzimy, czy juz istnieje dokument o podanym kluczu
                    sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"'"
                    sql+=" AND dokument_id = '"+Typ+"' AND data='"+str(Data)+"' AND numer = "+str(Numer)+";"
                    stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                    
                    if stat != 'OK':
                        stat = 'Bd sprawdzeniu nowego klucza : '+stat
                    else:
                        if len(wyn) == 1:
                            stat = 'BL DOK'
                    
                if stat == 'OK':
                    # zmiana klucza
                    if Rodzaj=='W':
                        MagazynSkad="'"+Magazyn+"'"
                        MagazynDokad='NULL'
                        NumerDokad='NULL'
                    elif Rodzaj=='P':
                        MagazynSkad='NULL'
                        MagazynDokad="'"+Magazyn+"'"
                        NumerDokad='NULL'
                    else:
                        MagazynSkad="'"+Magazyn+"'"
                        MagazynDokad="'"+MagazynDokad+"'"
                
                    if stat=='OK':
                        fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,MagazynS,TypS,DataS,NumerS,0,True)
                        
                        Upd ="UPDATE rs_dokumenty_magazynowe"
                        Upd+=" SET magazyn_id='"+Magazyn+"', dokument_id='"+Typ+"', data='"+str(Data)+"',"
                        Upd+=" numer="+str(Numer)+", magazyn_skad="+MagazynSkad+", magazyn_dokad="+MagazynDokad+","
                        Upd+=" numer_dokad="+str(NumerDokad)
                        Upd+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynS+"'"
                        Upd+=" AND dokument_id='"+TypS+"' AND data='"+DataS+"' AND numer="+NumerS+";"
                        if sql_mm!='':
                            Upd=Upd+sql_mm
                            
                        SQLTermin='UPDATE rs_dokumenty_magazynowe_pozycje SET '
                        # jeli dokument z PW na inny
                        if Typ!='PW' and TypS=='PW':
                            SQLTermin+="termin_przyd=NULL"
                        # jeli dokument na PW lub data PW zmieniana    
                        elif Typ=='PW' and (TypS!='PW' or Data!=DataS):
                            DniPrzyd="(SELECT dni_przydatnosci::INTEGER FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
                            DniPrzyd+=" AND artykul_id=rs_dokumenty_magazynowe_pozycje.artykul_id)"
                            DataPrzyd="'"+Data+"'::DATE + "+DniPrzyd
                            SQLTermin+="termin_przyd=CASE WHEN data="+DataPrzyd+" THEN NULL ELSE "+DataPrzyd+" END "
                        else:
                            SQLTermin=''

                        if SQLTermin!='':
                            SQLTermin+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
                            SQLTermin+=" AND dokument_id='"+Typ+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
                            
                        stat,dump,dump,dump = self.PolSQL.Execute(Upd+SQLTermin,1)                   
                        if stat=='OK':
                            stat = fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Magazyn,Typ,Data,Numer)

                        if stat=='OK' and len(Korekty) > 0:
                            upd = ''
                            for k in Korekty:
                                upd+="UPDATE rs_dokumenty_magazynowe SET"
                                upd+=" kor_dm_magazyn_id='"+Magazyn+"',kor_dm_dokument_id='"+Typ+"',"
                                upd+=" kor_dm_data='"+Data+"',kor_dm_numer="+rsglobal.UsunKropkaZero(Numer)
                                upd+=" WHERE firma_id='"+self.firma_id+"'"
                                upd+=" AND magazyn_id='"+rsglobal.Dekoduj(k[0])+"'"
                                upd+=" AND dokument_id='"+rsglobal.Dekoduj(k[1])+"'"
                                upd+=" AND data='"+rsglobal.Dekoduj(k[2])+"'"
                                upd+=" AND numer="+str(k[3])+";"
                            stat,dump,dump,dump = self.PolSQL.Execute(upd,1)
                            if stat != 'OK':
                                stat = 'Bd modyfikacji korekt zwizanych z dokumentem: '+stat

                        if stat=='OK':
                            # wpisanie domyslnych parametrow dla dokumentu w magazynie
                            UpdDomyslne = fs_magazyny_parametry_dokumentow_pom.UtworzSqlUpdZParametrow(self.firma_id,Magazyn,Typ,Data,Numer,SDomyslne)
                            if UpdDomyslne != '':
                                stat,dump,dump,dump = self.PolSQL.Execute(UpdDomyslne,1)

                       
            elif klucze[0]==3 and stat=='OK':  #KOPIOWANIE
                MagazynS = rsglobal.Dekoduj(pola[0])
                TypS = rsglobal.Dekoduj(pola[1])
                DataS = rsglobal.Dekoduj(pola[2])
                NumerS = str(pola[3])
                #print ' '
                #print 1, 'pola', pola

                #przyblokowanie SELECT FOR UPDATE kopiowanego dokumentu aby nie zniknal
                sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynS+"'"
                sql+=" AND dokument_id='"+TypS+"' AND data='"+DataS+"' AND numer="+NumerS+" FOR UPDATE NOWAIT;"
                #print 2, sql
                stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
                if 'nie mona naoy blokady' in stat:
                    stat = 'Dokument jest zablokowany przez innego uytkownika'
                elif stat == 'OK':
                    if len(wyn)==0:
                        stat='BL DOKN'
                        wart.append(stat)
                        
                if stat=='OK':
                    #sprawdzimy, czy juz istnieje dokument o podanym, nowym kluczu
                    sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"'"
                    sql+=" AND dokument_id = '"+Typ+"' AND data='"+str(Data)+"' AND numer = "+str(Numer)+";"
                    stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                    #print 3, sql
                    if stat != 'OK':
                        stat = 'Bd sprawdzeniu nowego numeru : '+stat
                    else:
                        if len(wyn) == 1:
                            stat = 'BL DOK'
                            
                if stat == 'OK':
                    sql = "SELECT kontrahent_id,kierowca,konto_kosztow,waluta,wersja,nr_zlecenia,projekt_id,"
                    sql+=" miejsce_dostawy, dostawca_id FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+MagazynS+"'"
                    sql+=" AND dokument_id = '"+TypS+"' AND data = '"+DataS+"' AND numer = "+NumerS+";"
                    #print 4, sql
                    stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(wyn)==0:
                            stat='BR DOK'
                            wart.append(stat)
            
                if stat=='OK':
                    #wstawienie nagwka
                    
                    if Rodzaj=='W':
                        MagazynSkad="'"+Magazyn+"'"
                        MagazynDokad='NULL'
                        NumerDokad='NULL'
                    elif Rodzaj=='P':
                        MagazynSkad='NULL'
                        MagazynDokad="'"+Magazyn+"'"
                        NumerDokad='NULL'
                    else:
                        MagazynDokad="'"+MagazynDokad+"'"
                        MagazynSkad="'"+Magazyn+"'"
                        
                    Kontrahent=rsglobal.Dekoduj(wyn[0][0])    
                    if Kontrahent!='None':
                        Kontrahent="'"+Kontrahent+"'"
                    else:
                        Kontrahent='NULL'
                        
                    Kierowca=rsglobal.Dekoduj(wyn[0][1])    
                    if Kierowca!='None':
                        Kierowca="'"+Kierowca+"'"
                    else:
                        Kierowca='NULL'
                        
                    KontoK=rsglobal.Dekoduj(wyn[0][2])    
                    if KontoK!='None':
                        KontoK="'"+KontoK+"'"
                    else:
                        KontoK='NULL'
                        
                    Waluta=rsglobal.Dekoduj(wyn[0][3])    
                    if Waluta!='None':
                       Waluta="'"+Waluta+"'"
                    else:
                        Waluta='NULL'   
                        
                    Wersja=rsglobal.Dekoduj(wyn[0][4])    
                    if Wersja!='None':
                        Wersja="'"+Wersja+"'"
                    else:
                        Wersja= 'NULL'    
                        
                    # sprawdzenie czy w parametrach dokumentw nie ma wpisanej wersji dla tego rodzaju dokumentu
                    if Kontrahent != 'NULL':
                        SParam = {}
                        SParam['wersja'] = ''
                        SParam['kontrahent_id'] = Kontrahent.strip("'")
                        #print 5, SParam
                        stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Magazyn,Typ,SParam)
                        #print 6, SParam
                        if SParam["wersja"]!='':
                            Wersja="'"+SParam["wersja"]+"'"
                        
                    NrZlecenia=rsglobal.Dekoduj(wyn[0][5])    
                    if NrZlecenia!='None':
                        NrZlecenia="'"+NrZlecenia+"'"
                    else:
                        NrZlecenia= 'NULL'    

                    Projekt=rsglobal.Dekoduj(wyn[0][6])    
                    if Projekt!='None':
                        Projekt="'"+Projekt+"'"
                    else:
                        Projekt= 'NULL'    
                        
                    MiejDost=rsglobal.Dekoduj(wyn[0][7])    
                    if MiejDost!='None':
                        MiejDost="'"+MiejDost+"'"
                    else:
                        MiejDost= 'NULL'    
                    
                    Dostawca=rsglobal.Dekoduj(wyn[0][8])    
                    if Dostawca!='None':
                        Dostawca="'"+Dostawca+"'"
                    else:
                        Dostawca= 'NULL'    

                    INSERT ="INSERT INTO rs_dokumenty_magazynowe ("
                    INSERT+=" firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,"
                    INSERT+=" magazyn_dokad,numer_dokad,kontrahent_id,kierowca,konto_kosztow,waluta,"
                    INSERT+=" wersja,nr_zlecenia,projekt_id,miejsce_dostawy,dostawca_id)"
                    INSERT+=" VALUES ("
                    INSERT+=" '"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+str(Data)+"',"+str(Numer)+","+MagazynSkad+","
                    INSERT+=" "+MagazynDokad+","+str(NumerDokad)+","+Kontrahent+","+Kierowca+","+KontoK+","+Waluta+","
                    INSERT+=" "+Wersja+","+NrZlecenia+","+Projekt+","+MiejDost+","+Dostawca+");"
                    #print 7, INSERT
                    rsglobal.ZapiszDoLogow('Insert 1409')
                    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
                    
                    if stat=='OK':
                        # wpisanie domyslnych parametrow dla dokumentu w magazynie
                        UpdDomyslne = fs_magazyny_parametry_dokumentow_pom.UtworzSqlUpdZParametrow(self.firma_id,Magazyn,Typ,Data,Numer,SDomyslne)
                        if UpdDomyslne != '':
                            stat,dump,dump,dump = self.PolSQL.Execute(UpdDomyslne,1)
                            if 'wersja' in SDomyslne:
                                Wersja="'"+SDomyslne['wersja']+"'"
                            

                    #kopiowanie pozycji (z potencjalnym uwzgldnieniem przeliczenia terminu patnoci na PW)
                    if stat=='OK': ##JR and TypS!='MM':
                        
                        #                0           1            2             3         4          5        6 
                        sql ="SELECT dmp.nr_poz,dmp.nr_ppoz,dmp.artykul_id,dmp.ilosc1,dmp.ilosc2,dmp.cena1,dmp.cena2," # 0-6
                        #        7                  8                9             10             11              12 
                        sql+=" dmp.nr_serii,dmp.termin_przyd,dmp.cena_wal1,dmp.cena_wal2,dmp.cecha1_opis,dmp.cecha1_wartosc," # 7-12
                        #                 13
                        sql+=" '"+Data+"'::DATE + a.dni_przydatnosci::INTEGER,"
                        # 14 - 16
                        sql+=" COALESCE(opakowanie_id,''),COALESCE(paleta_id,''),COALESCE(wsp_ilosci_opakowanie,0),"
                        # 17 - 18
                        sql+=" COALESCE(wsp_ilosci_paleta,0),COALESCE(wsp_ilosci_lokacja,0)"
                        sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
                        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                        sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+MagazynS+"'"
                        sql+=" AND dmp.dokument_id='"+TypS+"' AND dmp.data='"+DataS+"' AND dmp.numer="+str(NumerS)
                        sql+=" ORDER BY dmp.nr_poz,dmp.nr_ppoz;"
                        #print 'kopiowanie pozycji (z potencjalnym uwzgldnieniem przeliczenia terminu patnoci na PW)'
                        #print sql
                        #print ' '
                        stat,POZ,dump,dump = self.PolSQL.Execute(sql,3)

                        if stat=='OK':
                            # wypelnieniamy pozycje nowymi wartosciami przed proba scalenia podpozycji
                            # gdyz niektore dane dla nowego dokumentu moga byc inne
                            # niz dla kopiowanego, a tym samym wplywac na mozliwosc scalenia pozycji
                            
                            # poz[] to pozycje przed scaleniem ale z aktualnymi wartosciami
                            poz = []
                            
                            for i in xrange(len(POZ)):
                                npozycja = list(POZ[i])

                                Art=rsglobal.Dekoduj(npozycja[2])
                                
                                if Wersja != 'NULL':
                                    
                                    ostpoz = len(poz)-1
                                    
                                    if ostpoz>-1 and poz[ostpoz][0] == npozycja[0] and Art == rsglobal.Dekoduj(poz[ostpoz][2]):
                                        # jesli to nastepna podpozycja dla pozycji, to kopiujemy cene
                                        # zamiast ja ponownie pobierac
                                        npozycja[5] = poz[ostpoz][5]
                                        npozycja[6] = poz[ostpoz][6]
                                        npozycja[9] = poz[ostpoz][9]
                                        npozycja[10] = poz[ostpoz][10]

                                    else:
                                        # pobranie aktualnych cen dla wersji cenowej
                                        sql ="SELECT"
                                        sql+=" rsf_podaj_cene_n1('"+self.firma_id+"','"+Art+"',"+Wersja+",'PLN','"+Data+"'),"
                                        sql+=" rsf_podaj_cene_n2('"+self.firma_id+"','"+Art+"',"+Wersja+",'PLN','"+Data+"'),"
                                        sql+=" rsf_podaj_cene_n1('"+self.firma_id+"','"+Art+"',"+Wersja+","+Waluta+",'"+Data+"'),"
                                        sql+=" rsf_podaj_cene_n2('"+self.firma_id+"','"+Art+"',"+Wersja+","+Waluta+",'"+Data+"');"
                                        
                                        stat,ceny,dump,dump = self.PolSQL.Execute(sql,3)
                                        if stat == 'OK':
                                            npozycja[5] = ceny[0][0]
                                            npozycja[6] = ceny[0][1]
                                            npozycja[9] = ceny[0][2]
                                            npozycja[10] = ceny[0][3]
                                        else:
                                            stat = 'Bd pobrania cen dla pozycji: '+stat
                                            break

                                    
                                # dla PW przeliczamy termin
                                if Typ=='PW':
                                    if npozycja[13]!=Data:
                                        npozycja[13] ="'"+npozycja[13]+"'"
                                    else:
                                        npozycja[13]='NULL'
                                        
                                # dla reszty go zostawiamy
                                elif npozycja[8]=='None':
                                    npozycja[8]='NULL'
                                else:
                                    npozycja[8]="'"+npozycja[8]+"'"
                                    
                                cecha1_opis = rsglobal.Dekoduj(npozycja[11]).strip()
                                cecha1_wartosc = rsglobal.Dekoduj(npozycja[12]).strip()
                                
                                if cecha1_opis in ('None',''):
                                    npozycja[11] = 'NULL'
                                else:
                                    npozycja[11] = "'"+cecha1_opis+"'"
                                    
                                if cecha1_wartosc in ('None',''):
                                    npozycja[12] = 'NULL'
                                else:
                                    npozycja[12] = "'"+cecha1_wartosc+"'"
                            
                                # opakowanie
                                if npozycja[14] == '':
                                    npozycja[14] = 'NULL'
                                else:
                                    npozycja[14] = "'"+npozycja[14]+"'"
                                    
                                # paleta
                                if npozycja[15] == '':
                                    npozycja[15] = 'NULL'
                                else:
                                    npozycja[15] = "'"+npozycja[15]+"'"
                            
                                poz.append(npozycja)
                                i += 1

                            if stat == 'OK':
                                # teraz scalanie podpozycji
                                # npoz[] to pozycje dokumentu po ewentualnym scaleniu podpozycji
                                npoz = []
                                
                                # kolumny, ktore sprawdzamy czy sa jednakowe aby scalic pozycje
                                if TypS=='MM':
                                    KolSpr = [0,2,5,6,7,9,10,11,12]      #
                                else:
                                    KolSpr = [5,6,7,9,10,11,12]
                                
                                # kontrola daty w zaleznosci od typu dokumentu
                                if Typ == 'PW':
                                    KolSpr.append(13)
                                else:
                                    KolSpr.append(8)
                                    
                                
                                i = 0
                                
                                while i < len(poz):
                                    biezpoz = poz[i]
                                    NrPoz = biezpoz[0]
                                    NrPPoz = biezpoz[1]
                                    
                                    if NrPPoz > 0:
                                        # pierwsza podpozycja w pozycji
                                        ispr = i
                                        
                                        # jesli to podpozycja, to sprawdzamy, czy mozna scalic od razu sumujac
                                        # nowa, scalona pozycja
                                        
                                        # WAZNE: nowo inicjowana lista zamiast nbiezpos = biezpos
                                        # bo wskazuje na to samo i wtedy zerowanie dziala jakby dla obu
                                        nbiezpoz = list(biezpoz)
                                        
                                        # zerujemy ilosci
                                        nbiezpoz[3] = 0
                                        nbiezpoz[4] = 0
                                        
                                        # sprawdzamy, czy wybrane pola sa takie same
                                        # od razu naliczamy sumy ilosci z podpozycji
                                        
                                        TakieSame = True
                                        
                                        while ispr < len(poz) and poz[ispr][0] == NrPoz:
                                            biezpoz = poz[ispr]
        
                                            for j in KolSpr:
                                                if biezpoz[j] != nbiezpoz[j]:
                                                    # roznica w ktorejs ze sprawdzanych kolumn
                                                    TakieSame = False
                                                    break
                                            
                                            if not TakieSame:
                                                # przerywamy dalsze sprawdzanie podpozycji
                                                break
                                            
                                            # takie same kolumny, wiec podpozycja do scalenia (sumowania)
                                            nbiezpoz[3] += biezpoz[3]
                                            nbiezpoz[4] += biezpoz[4]
                                            
                                            ispr+=1
                                            
                                        if TakieSame:
                                            # nowa, scalona pozycja
                                            npoz.append(nbiezpoz)
                                            
                                            # nowe ustawienie licznika po scalonej pozycji
                                            # i powrot do analizy dalszych pozycji dokumentu
                                            i = ispr
                                            
                                        else:
                                            # pozycja nie mogla byc scalona, musimy przepisac 
                                            # wszystkie podpozycje
                                            biezpoz = poz[i]
                                            
                                            while i < len(poz) and biezpoz[0] == NrPoz:
                                                npoz.append(poz[i])
                                                i+=1
                                                if i < len(poz)-1:
                                                    biezpoz = poz[i]
                                                
                                    
                                    else:
                                        # zwykla pozycja, wiec przepisujemy
                                        npoz.append(biezpoz)
                                        i+=1
    
                                # teraz w npoz mamy dokument ze scalonymi pozycjami,
                                # ktory ma identyczna strukture jak poz
                            
                                Insert = "INSERT INTO rs_dokumenty_magazynowe_pozycje"
                                Insert+=" (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
                                Insert+="  artykul_id,ilosc1,ilosc2,cena1,cena2,nr_serii,"
                                Insert+="  termin_przyd,cena_wal1,cena_wal2,cecha1_opis,cecha1_wartosc,"
                                Insert+=" opakowanie_id,paleta_id,wsp_ilosci_opakowanie,"
                                Insert+=" wsp_ilosci_paleta,wsp_ilosci_lokacja)"
                                Insert+=" VALUES"
                                Insert+=" ('%s','%s','%s','%s',%s,%s,%s,"
                                Insert+="  '%s',%s,%s,%s,%s,'%s',"
                                Insert+="  %s,%s,%s,%s,%s,"
                                Insert+="  %s,%s,%s,%s,%s);"
                            
                                
                                i=1
                                
                                # do tworzenia pozycji uzyjemy wersji ze scaleniem pozycji
                                for pozycja in npoz:
                                    P=str(i)
                                    Pp=0
                                    Art=rsglobal.Dekoduj(pozycja[2])
                                    Il1=str(pozycja[3])
                                    Il2=str(pozycja[4])
                                    
                                    cena1=str(pozycja[5])
                                    cena2=str(pozycja[6])
                                    cenaw1=str(pozycja[9])
                                    cenaw2=str(pozycja[10])

                                    nr_serii=rsglobal.Dekoduj(pozycja[7])
                                    
                                    if Typ=='PW':
                                        # dla PW termin
                                        termin=pozycja[13]
                                    else:
                                        # dla reszty
                                        termin=pozycja[8]
                                   
                                    cecha1_opis = pozycja[11]
                                    cecha1_wartosc = pozycja[12]
                                    
                                    Opak = pozycja[14]
                                    Paleta = pozycja[15]
                                    WspOpak = pozycja[16]
                                    WspPaleta = pozycja[17]
                                    WspLokacja = pozycja[18]
    
                                    stat,dump,dump,dump = self.PolSQL.Execute(Insert % (self.firma_id,Magazyn,Typ,str(Data),str(Numer),
                                                                                        P,Pp,Art,Il1,Il2,cena1,cena2,nr_serii,termin,
                                                                                        cenaw1,cenaw2,cecha1_opis,cecha1_wartosc,
                                                                                        Opak,Paleta,WspOpak,WspPaleta,WspLokacja),1)                            
                                    i=i+1


                    
                    if stat=='OK':
                        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjachNaCalymDokumencie(self,Magazyn,Typ,str(Data),Numer,'-')   
                    # ewentualne wstawienie wirtualnych artykuw przyjcia
                    if stat=='OK':
                        stat=fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Magazyn,Typ,Data,str(Numer))

                    if stat=='OK':
                        # wpisanie domyslnych parametrow dla dokumentu w magazynie
                        UpdDomyslne = fs_magazyny_parametry_dokumentow_pom.UtworzSqlUpdZParametrow(self.firma_id,Magazyn,Typ,Data,Numer,SDomyslne)
                        if UpdDomyslne != '':
                            stat,dump,dump,dump = self.PolSQL.Execute(UpdDomyslne,1)

            elif klucze[0]==33 and stat=='OK':  #KOREKTA DO DOKUMENTU
                MagazynS = rsglobal.Dekoduj(pola[0])
                TypS = rsglobal.Dekoduj(pola[1])
                DataS = rsglobal.Dekoduj(pola[2])
                NumerS = str(pola[3])
                
                #przyblokowanie SELECT FOR UPDATE korygowanego dokumentu aby nie zniknal
                sql ="SELECT stan,COALESCE(magazyn_dokad,'')"
                sql+=" FROM rs_dokumenty_magazynowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynS+"'"
                sql+=" AND dokument_id='"+TypS+"' AND data='"+DataS+"' AND numer="+NumerS+" FOR UPDATE NOWAIT;"
                
                stat,DokStary,dump,dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
                if 'nie mona naoy blokady' in stat:
                    stat = 'Dokument jest zablokowany przez innego uytkownika'
                elif stat == 'OK':
                    if len(DokStary)==0:
                        stat='BL DOKN'
                        wart.append(stat)
                    elif not DokStary[0][0] in ('Z','K'):
                        stat = 'BL KOREKTA DO OTWARTEGO'

                if stat=='OK':
                    if Data < DataS:
                        stat = 'BL KOREKTA WCZESNIEJSZA OD DOKUMENTU'

                if stat=='OK':
                    if Magazyn != MagazynS:
                        stat = 'BL KOREKTA INNY MAGAZYN'
                        
                if stat=='OK':
                    # czy na pewno tworzymy korekte
                    sql ="SELECT COALESCE(korekta,FALSE),COALESCE(korekta_do,''),typ_dokumentu"
                    sql+=" FROM rs_typy_dokumentow_m"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Typ+"';"
                    stat,TypNowego,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia typu dokumentu korekty: '+stat
                    elif not TypNowego[0][0]:
                        stat = 'BL NOWY TO NIE KOREKTA'
                    elif TypNowego[0][1] != '':
                        # poniewaz korekta ma wpisane symbole korygowanych dokumentow
                        # sprawdzamy, czy korygowany symbol znajduje sie na tej liscie
                        if not TypS in rsglobal.Dekoduj(TypNowego[0][1]).split(','):
                            stat = 'BL BRAK KORYGOWANEGO NA LISCIE'

                if stat=='OK':
                    # czy nie probujemy korygowac korekty
                    sql ="SELECT COALESCE(korekta,FALSE),typ_dokumentu"
                    sql+=" FROM rs_typy_dokumentow_m"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+TypS+"';"
                    stat,TypStarego,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia typu dokumentu korygowanego: '+stat
                    elif TypStarego[0][0]:
                        stat = 'BL KORYGOWANY TO KOREKTA'
                    elif not TypStarego[0][1] in ('P','W'):
                        stat = 'BL KOREKTA BLEDNY TYP'

                if stat=='OK':
                    #sprawdzimy, czy juz istnieje dokument o podanym, nowym kluczu
                    sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"'"
                    sql+=" AND dokument_id = '"+Typ+"' AND data='"+str(Data)+"' AND numer = "+str(Numer)+";"
                    stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                    
                    if stat != 'OK':
                        stat = 'Bd sprawdzeniu nowego numeru : '+stat
                    else:
                        if len(wyn) == 1:
                            stat = 'BL DOK'
                            
                if stat == 'OK':
                    sql = "SELECT kontrahent_id,kierowca,konto_kosztow,waluta,wersja,nr_zlecenia,projekt_id"
                    sql+=" FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+MagazynS+"'"
                    sql+=" AND dokument_id = '"+TypS+"' AND data = '"+DataS+"' AND numer = "+NumerS+";"
                    
                    stat,wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(wyn)==0:
                            stat='BR DOK'
                            wart.append(stat)
            
                if stat=='OK':
                    #wstawienie nagwka
                    
                    if Rodzaj=='W':
                        MagazynSkad="'"+Magazyn+"'"
                        MagazynDokad='NULL'
                        NumerDokad='NULL'
                    elif Rodzaj=='P':
                        MagazynSkad='NULL'
                        MagazynDokad="'"+Magazyn+"'"
                        NumerDokad='NULL'
                    else:
                        MagazynDokad="'"+MagazynDokad+"'"
                        MagazynSkad="'"+Magazyn+"'"
                        
                    Kontrahent=rsglobal.Dekoduj(wyn[0][0])    
                    if Kontrahent!='None':
                        Kontrahent="'"+Kontrahent+"'"
                    else:
                        Kontrahent='NULL'
                        
                    Kierowca=rsglobal.Dekoduj(wyn[0][1])    
                    if Kierowca!='None':
                        Kierowca="'"+Kierowca+"'"
                    else:
                        Kierowca='NULL'
                        
                    KontoK=rsglobal.Dekoduj(wyn[0][2])    
                    if KontoK!='None':
                        KontoK="'"+KontoK+"'"
                    else:
                        KontoK='NULL'
                        
                    Waluta=rsglobal.Dekoduj(wyn[0][3])    
                    if Waluta!='None':
                       Waluta="'"+Waluta+"'"
                    else:
                        Waluta='NULL'   
                        
                    Wersja=rsglobal.Dekoduj(wyn[0][4])    
                    if Wersja!='None':
                        Wersja="'"+Wersja+"'"
                    else:
                        Wersja= 'NULL'    
                        
                    NrZlecenia=rsglobal.Dekoduj(wyn[0][5])    
                    if NrZlecenia!='None':
                        NrZlecenia="'"+NrZlecenia+"'"
                    else:
                        NrZlecenia= 'NULL'    

                    Projekt=rsglobal.Dekoduj(wyn[0][6])    
                    if Projekt!='None':
                        Projekt="'"+Projekt+"'"
                    else:
                        Projekt= 'NULL'    

                    INSERT ="INSERT INTO rs_dokumenty_magazynowe ("
                    INSERT+=" firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad,"
                    INSERT+=" magazyn_dokad,numer_dokad,kontrahent_id,kierowca,konto_kosztow,waluta,"
                    INSERT+=" wersja,nr_zlecenia,projekt_id,"
                    INSERT+=" kor_dm_magazyn_id,kor_dm_dokument_id,kor_dm_data,kor_dm_numer)"
                    INSERT+=" VALUES ("
                    INSERT+=" '"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+str(Data)+"',"+str(Numer)+","+MagazynSkad+","
                    INSERT+=" "+MagazynDokad+","+str(NumerDokad)+","+Kontrahent+","+Kierowca+","+KontoK+","+Waluta+","
                    INSERT+=" "+Wersja+","+NrZlecenia+","+Projekt+","
                    INSERT+=" '"+MagazynS+"','"+TypS+"','"+DataS+"',"+str(NumerS)+");"

                    rsglobal.ZapiszDoLogow('Insert 1838')
                    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
                    
                    if stat=='OK':
                        # wpisanie domyslnych parametrow dla dokumentu w magazynie
                        UpdDomyslne = fs_magazyny_parametry_dokumentow_pom.UtworzSqlUpdZParametrow(self.firma_id,Magazyn,Typ,Data,Numer,SDomyslne)
                        if UpdDomyslne != '':
                            stat,dump,dump,dump = self.PolSQL.Execute(UpdDomyslne,1)
                            if 'wersja' in SDomyslne:
                                Wersja="'"+SDomyslne['wersja']+"'"

                    if stat=='OK':
                        # wpisanie domyslnych parametrow dla dokumentu w magazynie
                        UpdDomyslne = fs_magazyny_parametry_dokumentow_pom.UtworzSqlUpdZParametrow(self.firma_id,Magazyn,Typ,Data,Numer,SDomyslne)
                        if UpdDomyslne != '':
                            stat,dump,dump,dump = self.PolSQL.Execute(UpdDomyslne,1)



            elif stat == 'OK':
                stat = 'BL KOD'
                wart.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and not klucze[0] in (1,2,3,8,35):
    #data
    if Data in ('', '    -  -  '):
        stat = 'BR DATY'
    else:
        if not rsglobal.SprawdzCzyToData(Data):
            stat = 'BL DATA'
            wart.append(stat)


#-------------------------------------------------------------------------------
#podanie nowego numeru dokumentu
#-------------------------------------------------------------------------------

if klucze[0] == 7:
    #sprawdzenie czy wogole jest sens
    select = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\',\\\'"+MagazynDokad+"\\\']','"+klucze[-1]+"');"
    select1 = "SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','"+klucze[-1]+"');"
    stat, dane, dump, dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\',\\\'"+MagazynDokad+"\\\']','"+klucze[-1]+"');",3)
    if stat == 'OK':
        if dane[0][0] == 'OK':
            stat, dane, dump, dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','"+klucze[-1]+"');",3)
            if stat == 'OK':
                if dane[0][0] in (None, 'None', ''):
                    stat = u'Bdy w wyznaczaniu nowego numeru dokumentu'
            else:
                stat = u'Bdy w wyznaczaniu nowego numeru dokumentu - stat'
        else:
            stat = dane[0][0]


#-------------------------------------------------------------------------------
#czy operator ma uprawnienia do 1 magazynu
#-------------------------------------------------------------------------------
#rsglobal.ZapiszDoLogow(' 3 stat '+stat,1)
if klucze[0] == 8:
    dane = []
    if self.operator_id != STANDARD_OPERATOR_ID:
        stat, dane, dump, dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny_upr WHERE firma_id='"+self.firma_id+"' AND operator_id in "+str(self.operatorzy)+" ;",3)
        if stat != 'OK':
            stat = 'BL CZY MAG'
            wart.append(stat)
