# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_lokacje.py
# Purpose:     obsluga grida edytowalnego z list lokacji w pozycjach dokumentw magazynowych
# Author:      Pawe Wjcikowski
# Created:     2010/02/04
# RCS-ID:      $Id: fs_dokumenty_magazynowe_lokacje.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2013-07-16 Mariusz Rajfura (7032) dynamiczny przelicznik


from funkcje import fs_dokumenty_magazynowe_lokacje_pom

def DoCalkWGore(Ilosc):
    Wynik = float(int(Ilosc))
    if Wynik == Ilosc:
        return Wynik
    elif Ilosc - Wynik > 0:
        return Wynik+1
    else:
        return Wynik+1.0

#-------------------------------------------------------------------------------

from funkcje import fs_dokumenty_magazynowe_lokacje_pom

Mag = rsglobal.Dekoduj(klucze[0]).strip()
Dok = rsglobal.Dekoduj(klucze[1]).strip()
Data = rsglobal.Dekoduj(klucze[2]).strip()
Numer = klucze[3]
NrPoz = klucze[4]
NrPPoz = klucze[5]

Fun = klucze[-1]

WHERE = " firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' "
WHERE+= " AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)
WHERE+= " AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
LLokacji=[]            

UprIns=((self.oddzial_id,'032023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'032022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'032024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []    


#-------------------------------------------------------------------------------
#--- POBRANIE MAGAZYNW I CZY LOKACJE Z DOKUMENTU MAGAZYNOWEGO
#-------------------------------------------------------------------------------

SQL="SELECT dm.magazyn_skad,dm.magazyn_dokad,ms.czy_lokacje,md.czy_lokacje FROM rs_dokumenty_magazynowe dm "
SQL+=" LEFT OUTER JOIN rs_magazyny ms ON (dm.firma_id=ms.firma_id AND dm.magazyn_skad=ms.magazyn_id)"
SQL+=" LEFT OUTER JOIN rs_magazyny md ON (dm.firma_id=md.firma_id AND dm.magazyn_dokad=md.magazyn_id)"
SQL+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Mag+"' AND dm.dokument_id='"+Dok+"'"
SQL+=" AND dm.data='"+Data+"' AND dm.numer="+str(Numer)+";"
stat,daneM,dump,dump=self.PolSQL.Execute(SQL,3)
if stat<>'OK':
    stat="Bd przy pobieraniu danych o magazynach: "+stat   
    dane.append(stat)
else:
    MagSkad = str(daneM[0][0])
    MagDokad = str(daneM[0][1])
    CzyLokacjeSkad = daneM[0][2]
    CzyLokacjeDokad = daneM[0][3]


#-------------------------------------------------------------------------------
#--- POBRANIE TYPU DOKUMENTU - DO TESTW LOKACJI
#-------------------------------------------------------------------------------

SQL="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
stat,daneTD,dump,dump=self.PolSQL.Execute(SQL,3)
if stat<>'OK':
    stat="Bd przy pobieraniu danych o typach dokumentw: "+stat   
    dane.append(stat)
else:
    TypDokumentu = daneTD[0][0]


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE CZY POZYCJA MOZE MIEC GRID Z LOKACJAMI - 10
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    if float(NrPPoz) <> 0:
        stat = 'Podpozycja nie moe mie rozbitych lokacji'
        dane.append(stat)
    else:
        sql ="SELECT lokacja_skad,lokacja_dokad,ilosc"+self.lokacje_jm+" FROM rs_dokumenty_magazynowe_pozycje WHERE "+WHERE+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania lokacji dot.pozycji: '+stat
            dane.append(stat)
            
        elif len(d) <> 1:
            stat = 'Brak pozycji o podanym kluczu.'
            dane.append(stat)

        elif not ( d[0][0] == 'None' and d[0][1] == 'None' ):
            stat = 'Pozycja posiada wpisan lokacj przy artykule. Rozbicie niemoliwe.'
            dane.append(stat)

         
#-------------------------------------------------------------------------------
#--- Porownanie biezacej ilosci z pozycji dokumentu - 11
#-------------------------------------------------------------------------------

if Fun == 11:
    sql ="SELECT ilosc"+self.lokacje_jm+" FROM rs_dokumenty_magazynowe_pozycje WHERE "+WHERE+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z pozycji dokumentu: '+stat
        dane.append(stat)
    elif len(dane) <> 1:
        stat = 'Brak pozycji o podanym kluczu: '+stat
        dane = append(stat)
    

#-------------------------------------------------------------------------------
#--- POBRANIE INFORMACJI CZY POZYCJA MOZE MIEC GRID Z LOKACJAMI - 12
#--- W ODROZNIENIU OD FUN==10 WYNIK NIE JEST BLEDEM 
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    sql ="SELECT lokacja_skad IS NULL AND lokacja_dokad IS NULL"
    sql+=" FROM rs_dokumenty_magazynowe_pozycje WHERE "+WHERE+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania lokacji dot.pozycji: '+stat
        dane.append(stat)

    if stat=='OK' and dane[0][0]:
        # skoro grid moze miec lokacje, to sprawdzamy
        # czy artykul z pozycji ma dynamiczny przelicznik
        sql ="SELECT dmp.artykul_id,a.dynamiczny_przelicznik"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
        sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND"
        sql+=" dmp.magazyn_id='"+Mag+"' AND dmp.dokument_id='"+Dok+"'"
        sql+=" AND dmp.data='"+Data+"' AND dmp.numer="+str(Numer)
        sql+=" AND dmp.nr_poz="+str(NrPoz)+" AND dmp.nr_ppoz="+str(NrPPoz)+";"
        stat,daneA,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobierania informacji o dynamicznym przeliczniku: '+stat
        else:
            # jesli ma przelicznik dynamiczny, to pozycja nie moze miec grida
            dane[0][0] = not daneA[0][1]


#-------------------------------------------------------------------------------
# POBRANIE DANYCH POZYCJI, POTRZEBNYCH DO WYPELNIENIA WYWOLANIA RSLokacje.Wybierz
#-------------------------------------------------------------------------------

if Fun == 14 and stat == 'OK':
    sql ="SELECT artykul_id,COALESCE(termin_przyd::TEXT,''::TEXT),COALESCE(nr_serii,''::TEXT),COALESCE(cecha1_opis,''::TEXT)"
    sql+=" FROM rs_dokumenty_magazynowe_pozycje WHERE "+WHERE+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych pozycji: '+stat
        dane.append(stat)

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH O MAGAZYNACH, WCZONYCH W NICH LOKACJACH, DYNAM.PRZEL (6) 
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    RodzajDok=''
    CzyMagSkad=False
    CzyMagDokad=False
    DynamicznyPrzelicznik = False
    
    sql="SELECT magazyn_skad,magazyn_dokad FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND"
    sql+=" magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,daneM,dump,dump=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych o magazynach: "+stat   
        dane.append(stat)
    else:
        MagSkad = str(daneM[0][0])
        MagDokad = str(daneM[0][1])
        
        if MagSkad not in ['',None,'None'] and stat=='OK':
            sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagSkad+"';"
            stat,daneS,dump,dump = self.PolSQL.Execute(sql ,3)        
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu danych o lokacjach :'+stat
                dane.append(stat) 
            else:
                CzyMagSkad = daneS[0][0]
                
        if MagDokad not in ['',None,'None'] and stat=='OK':
            sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagDokad+"';"
            stat,daneD,dump,dump = self.PolSQL.Execute(sql ,3)        
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu danych o lokacjach :'+stat
                dane.append(stat) 
            else:
                CzyMagDokad = daneD[0][0]          
                 
        if stat=='OK':  # dodatkowo pobieram rodzaj dokumentu - do ustawienia kolumn edytowalnych       
            sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
            stat,daneT,dump,dump = self.PolSQL.Execute(sql ,3)        
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu danych o rodzaju dokumentu mag. :'+stat
                dane.append(stat)
            else:
                RodzajDok = daneT[0][0]
    
        if stat=='OK':
            # pobranie informacji o dynamicznym przeliczniku
            sql ="SELECT dmp.artykul_id,a.dynamiczny_przelicznik"
            sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
            sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
            sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND"
            sql+=" dmp.magazyn_id='"+Mag+"' AND dmp.dokument_id='"+Dok+"'"
            sql+=" AND dmp.data='"+Data+"' AND dmp.numer="+str(Numer)
            sql+=" AND dmp.nr_poz="+str(NrPoz)+" AND dmp.nr_ppoz="+str(NrPPoz)+";"
            stat,daneA,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobierania informacji o dynamicznym przeliczniku: '+stat
            elif len(daneA) == 0:
                stat = 'Brak pozycji o podanym kluczu.'
            else:
                DynamicznyPrzelicznik = daneA[0][1]

        if stat == 'OK':
            #          0        1          2         3           4            5
            dane = [MagSkad,CzyMagSkad,MagDokad,CzyMagDokad,RodzajDok,DynamicznyPrzelicznik]


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY MAGAZYN MA WCZONE LOKACJE /w celu ustawienia grida/ 13 
#---   oraz spr. typu dokumentu                                                 
#-------------------------------------------------------------------------------

if Fun in [13,5]:
    sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
    stat,daneL,dump,dump = self.PolSQL.Execute(sql ,3)        
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu danych o lokacjach :'+stat
        dane.append(stat) 
    else:         
        sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
        stat,daneT,dump,dump = self.PolSQL.Execute(sql ,3)        
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych o rodzaju dokumentu mag. :'+stat
            dane.append(stat)
        else:
            dane=[daneL[0][0],daneT[0][0]]
                             

#-------------------------------------------------------------------------------
#--- INSERT, UPDATE, DELETE - 1
#-------------------------------------------------------------------------------

if Fun == 1:
    Update = klucze[-2]
    Insert = klucze[-3]
    Delete = klucze[-4]
    
    #moga przydac sie do SELECT FOR UPDATE
    Operacje = []
    
    #blokada pozycji dokumentu da nam pewnosc, ze nikt inny nie modyfikuje pozycji
    #a tym samym nie zmieni sie ilosc, lokacje itp
    #dodatkowo mamy dane do kontroli lokacji
    sql ="SELECT ilosc"+self.lokacje_jm+" FROM rs_dokumenty_magazynowe_pozycje WHERE "+WHERE+" FOR UPDATE NOWAIT;"
    stat,danePOZ,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych pozycji dokumentu: '+stat
        dane.append(stat)
    elif len(danePOZ) <> 1:
        stat = 'Nie znaleziono pozycji dokumentu: '+stat
        dane.append(stat)
    
    # zdjcie iloci do pobrania i zajete z lokacji
    if stat=='OK' :
        # pobranie listy lokacji, ktre bd sprawdzane (wszystkie z pozycji)
        stat,dump,dump,LLokacji=fs_dokumenty_magazynowe_lokacje_pom.PodajLokacjeDokumentuLubPozycji(self,Mag,Dok,Data,Numer,NrPoz)
    if stat=='OK':
        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Numer,NrPoz,'-')   
    
    #mam nadzieje, ze blokada pozycji nie pozwoli zmienic stanu dokumentu
    #a nie chcialbym blokowac bez potrzeby naglowka 
    if stat == 'OK':
        sql ="SELECT stan,magazyn_skad,magazyn_dokad FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' "
        sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,daneNAG,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych nagwka dokumentu: '+stat
            dane.append(stat)
        elif len(daneNAG) <> 1:
            stat = 'Nie znaleziono dokumentu o podanym kluczu: '+stat
            dane.append(stat)
        elif daneNAG[0][0] <> 'W':
            stat = 'Dokument nie jest w stanie W'
            dane.append(stat)
    
    #pobierzemy typ dokumentu 
    if stat == 'OK':
        sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
        stat,daneTYPD,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych o typie dokumentu: '+stat
            dane.append(stat)
        elif len(daneTYPD) <> 1:
            stat = 'Brak danych o typie dokumentu'
            dane.append(stat)
    
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)              
        if stat == 'OK':
            DELETE = ''
            for i in xrange(len(Delete[0])):
                #jesli lokacja_skad jest kluczem na gridzie, to LokacjaSkad dostanie wartosc
                LokacjaSkad = None
                LokacjaDokad = None
                Ilosc = 0
                
                for j in xrange(len(Delete[0][i])): 
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    
                    if pole == 'lokacja_skad':
                        wart = str(wart).strip()
                        if wart == '':
                            LokacjaSkad = 'NULL'
                        else:
                            LokacjaSkad = "'"+wart+"'"
                            if not wart in LLokacji:
                                LLokacji.append(wart)
                            
                    elif pole == 'lokacja_dokad':
                        wart = str(wart).strip()
                        if wart == '':
                            LokacjaDokad = 'NULL'
                        else:
                            LokacjaDokad = "'"+wart+"'"
                            if not wart in LLokacji:
                                LLokacji.append(wart)
                        
                #musimy pobrac ilosc jaka byla dla tego klucza, aby wiedziec ile wycofac z lokacji
                sql ="SELECT ilosc FROM rs_dokumenty_magazynowe_lokacje WHERE "+WHERE
                if LokacjaSkad <> None:
                    if LokacjaSkad == 'NULL':
                        sql+=" AND lokacja_skad IS NULL"
                    else:
                        sql+=" AND lokacja_skad="+LokacjaSkad
                    
                if LokacjaDokad <> None:
                    if LokacjaDokad == 'NULL':
                        sql+=" AND lokacja_dokad IS NULL"
                    else:
                        sql+=" AND lokacja_dokad="+LokacjaDokad
                    
                sql+=";"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania usuwanej iloci: '+stat
                    dane.append(stat)
                elif len(d) <> 1:
                    stat = 'Brak usuwanej pozycji lokacji na dokumencie: '+stat
                    dane.append(stat)
                else:
                    Ilosc = d[0][0]    
                
                if stat == 'OK' and not LokacjaDokad in [None,'None','NULL','']:
                    sql ="SELECT magazyn_id,rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete')::NUMERIC"
                    sql+=" FROM rs_lokacje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id="+LokacjaDokad+" FOR UPDATE NOWAIT;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania danych lokacji '+LokacjaDokad
                        dane.append(stat)
                    elif len(d) <> 1:
                        stat = 'Brak lokacji '+Lokacja
                        dane.append(stat)
                    elif not rsglobal.Dekoduj(d[0][0]).strip() in [None,'None','',MagDokad.strip()]:
                        stat = 'Brak lokacji '+LokacjaDokad+' z magazynu '+MagDokad
                
                if stat == 'OK':
                    DELETE+="DELETE FROM rs_dokumenty_magazynowe_lokacje WHERE "+WHERE
                    if LokacjaSkad <> None:
                        if LokacjaSkad == 'NULL':
                            DELETE +=" AND lokacja_skad IS NULL"
                        else:
                            DELETE +=" AND lokacja_skad="+LokacjaSkad
                            
                    if LokacjaDokad <> None:
                        if LokacjaDokad == 'NULL':
                            DELETE+=" AND lokacja_dokad IS NULL"
                        else:
                            DELETE+=" AND lokacja_dokad="+LokacjaDokad

                    DELETE+=";"
                        
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]            
            
        # wykonanie UPDATE+DELETE 
        if stat=='OK':
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE,1)
            if stat <> 'OK':
                stat = 'Bd usuwania danych: '+stat

            
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)            
        
        UPDLOK = ''
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                Ilosc = 0
                
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'lokacja_skad':
                        wart = rsglobal.Dekoduj(wart.strip())
                        if wart == '':
                            if CzyLokacjeSkad:
                                stat = 'Nie podano lokacji skd'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                                
                        elif len(wart)>10:
                            stat = 'Zbyt dugi symbol lokacji skd'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_lokacje"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(wart)+"' FOR UPDATE NOWAIT;"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd pobrania danych lokacji skd: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif len(d) <> 1:
                                stat = 'Bdna lokacja skd'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif not d[0][0] in [None,'None','',MagSkad]:
                                stat = 'Lokacja skd niezgodna z magazynem skd dokumentu'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif not wart in LLokacji:
                                LLokacji.append(wart)
                        
                    elif pole == 'lokacja_dokad':
                        wart = rsglobal.Dekoduj(wart).strip()
                        if wart == '':
                            if CzyLokacjeDokad:
                                stat = 'Nie podano lokacji dokd'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)

                        elif len(wart)>10:
                            stat = 'Zbyt dugi symbol lokacji dokd'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_lokacje"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(wart)+"' FOR UPDATE NOWAIT;"
                            stat,daneDOKAD,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd pobrania danych lokacji DOKAD: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif len(daneDOKAD) <> 1:
                                stat = 'Bdna lokacja dokd'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif not daneDOKAD[0][0] in [None,'None','',MagDokad]:
                                stat = 'Lokacja dokd niezgodna z magazynem dokd dokumentu'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif not wart in LLokacji:
                                LLokacji.append(wart)

                    elif pole == 'ilosc':
                        Ilosc = wart
                        if wart <= 0:
                            stat = 'BL LICZBA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif wart<>'' and len(str(int(wart)))>5:
                            stat = 'DL LICZBA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                            
                #jesli byly jakies bledy
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            rsglobal.ZapiszDoLogow('!!! robie update',1)
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_dokumenty_magazynowe_lokacje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole in ('lokacja_skad', 'lokacja_dokad'): 
                        if wart.strip()=='':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+str(wart)+"',"
                    elif pole == 'ilosc':
                        SET+=pole+"="+str(wart)+","
                    
                SET = SET[:-1]
                
                where = ''
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    where+=" AND "+pole+"='"+wart+"'"
                
                sql+=UPDATE+SET+" WHERE "+WHERE+where+";"
                rsglobal.ZapiszDoLogow('!!! SQL '+sql+"!",1)
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat = 'Bd przy modyfikowaniu danych: '+stat   
                    dane.append(stat)  
                                    
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat == "OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)
            
        if stat == 'OK':
            sql = " SELECT MAX(lp) FROM rs_dokumenty_magazynowe_lokacje WHERE "+WHERE+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            
            if stat<>'OK':
                stat="Bd przy pobieraniu danych: "+stat   
                dane.append(stat)            
            else:
                if len(d)>0:
                    Lp = d[0][0]+1
                else:
                    Lp = 1
                    
        if stat == 'OK':
            #aktualizacja rs_lokacje w kolumnie zajete
            UPDATE = ''
            
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                Ilosc = 0

                for j in xrange(len(Insert[0][i])): 
                    pole = Insert[1][j]
                    wart = Insert[0][i][j]

                    if pole == 'lokacja_skad':
                        wart = rsglobal.Dekoduj(wart.strip())
                        if wart == '':
                            if CzyLokacjeSkad:
                                stat = 'Nie podano lokacji skd'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                                
                        elif len(wart)>10:
                            stat = 'Zbyt dugi symbol lokacji skd'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_lokacje"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(wart)+"' FOR UPDATE NOWAIT;"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd pobrania danych lokacji skd: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif len(d) <> 1:
                                stat = 'Bdna lokacja skd'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif not d[0][0] in [None,'None','',MagSkad]:
                                stat = 'Lokacja skd niezgodna z magazynem skd dokumentu'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif not wart in LLokacji:
                                LLokacji.append(wart)
                        
                    elif pole == 'lokacja_dokad':
                        wart = rsglobal.Dekoduj(wart).strip()
                        if wart == '':
                            if CzyLokacjeDokad:
                                stat = 'Nie podano lokacji dokd'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)

                        elif len(wart)>10:
                            stat = 'Zbyt dugi symbol lokacji dokd'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_lokacje"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(wart)+"' FOR UPDATE NOWAIT;"
                            stat,daneDOKAD,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd pobrania danych lokacji DOKAD: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif len(daneDOKAD) <> 1:
                                stat = 'Bdna lokacja dokd'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif not daneDOKAD[0][0] in [None,'None','',MagDokad]:
                                stat = 'Lokacja dokd niezgodna z magazynem dokd dokumentu'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif not wart in LLokacji:
                                LLokacji.append(wart)
            
                    elif pole == 'ilosc':
                        Ilosc = wart
                        if wart <= 0:
                            stat = 'BL LICZBA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif wart<>'' and len(str(int(wart)))>5:
                            stat = 'DL LICZBA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat) 
                    
        #jesli byly jakies bledy
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
        
        # wykonanie INSERT i ewent.UPDATE
        if stat == 'OK':
            sql = ''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_dokumenty_magazynowe_lokacje"
                KOLUMNY=" (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,lp"
                VALUES="  VALUES ('"+self.firma_id+"','"+Mag+"','"+Dok+"','"+Data+"',"+str(Numer)
                VALUES+=","+str(NrPoz)+","+str(NrPPoz)+","+str(Lp)
                Lp += 1
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole in ['lokacja_skad','lokacja_dokad']:
                        KOLUMNY+=","+pole
                        if str(wart)=='':
                            VALUES+=",NULL"   
                        else:
                            VALUES+=",'"+str(wart)+"'"  
                            
                    elif pole == 'ilosc':
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)+"" 
           
                KOLUMNY += ") "
                VALUES += ") "
                sql += INSERT+KOLUMNY+VALUES+"; "
                
            if sql <> '': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)  
    
    # woenie iloci do pobrania z lokacji
    if stat=='OK':
        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Numer,NrPoz,'+',False,True)   

    if stat=='OK':
        # odwieenie wirtualnych artykuw przyjcia
        stat=fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Mag,Dok,Data,Numer,NrPoz)
        if stat=='OK' and LLokacji<>[]:
            stat,dane=fs_dokumenty_magazynowe_lokacje_pom.SprawdzListeLokacji(self,LLokacji,TypDokumentu)
        if stat=='OK':
            stat=fs_dokumenty_magazynowe_lokacje_pom.SprawdzIlosciWArtykPrzyj(self,Mag,Dok,Data,Numer,NrPoz)

if stat<>'OK':
    if dane==[]:
        dane=[stat]

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat == 'OK':
    SELECT ="SELECT COALESCE(lokacja_skad,''),COALESCE(lokacja_dokad,''),ilosc"
    SELECT+=" FROM rs_dokumenty_magazynowe_lokacje WHERE "+WHERE
    SELECT+=" ORDER BY lokacja_skad,lokacja_dokad;" 
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat   
        dane.append(stat)
        
    if Fun == 1 and stat == 'OK':
        #sprawdzimy, czy suma ilosci z pozycji lokacji nie przekracza ilosci w pozycji
        #to sprawdzenie jest robione na oknie przed wywolaniem zapisu
        #gdyz tam mamy caly grid
        #tu jest dodatkowe sprawdzenie, ktore mozna bedzie usunac w przyszlosci
        #jesli lokacje beda dobrze dzialac
        
        SIlosc = 0
        for d in dane:
            SIlosc += d[2]
            
        if SIlosc > 0:
            
            if rsglobal.RSRound(SIlosc,4) > rsglobal.RSRound(danePOZ[0][0],4):
                #to nie powinno sie zdarzyc
                stat = "Suma iloci z lokacji jest wieksza od iloci artykuu "
                dane = [stat]