# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_lokacje_pom.py
# Purpose:     funkcje pomocnicze do obsugi iloci w lokacjach
# Author:      MIcha Raburski
# Created:     2010/05/21
# RCS-ID:      $Id: fs_dokumenty_magazynowe_lokacje_pom.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2011-02-03 Mariusz Rajfura - ominiecie sprawdzenia dokumentu typu 'C'
#                             byc moze powinien byc sprawdzany (4230)

#2011-04-07 Mariusz Rajfura - kontrola lokacji po wykonaniu UPDATE (xxxx)
#2017-10-31 Rafa Woniak (10734) zmiana zapisu do logw z 1 na 5
#2021-06-28 Jan Raburski (12549) dodanie kart przyjecia do artykulow przyjecia

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- OBSUGA ILOCI DO WYDANIA
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

def ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Nr,NrPoz,Znak,Sprawdzac=True,SprawdzacDoWydania=False):
    import rsglobal
    # funkcja pobiera dane z pozycji i wkada/zdejmuje odpowiednie dane na lokacje.
    # Znak +/- suy do wkadania/zdejmowania. Funkcja przy zmianach dziaa w dwie strony.
    # czyli najpierw zdejmuje star pozycj a potem wkada now (2 wywoania)
    # uywa pola ilosc_lokacja
    Mag=rsglobal.Dekoduj(Mag)
    Dok=rsglobal.Dekoduj(Dok)
    Data=rsglobal.Dekoduj(Data)
    Nr=str(Nr)
    NrPoz=str(NrPoz)
    Znak=rsglobal.Dekoduj(Znak)

    SQLTest ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
    SQLTest+=" WHERE firma_id = '"+self.firma_id+"' AND dokument_id = '"+Dok+"';"
    stat,DaneDok,dump,dump = self.PolSQL.Execute(SQLTest,3)
    if stat<>'OK':
        return "Bdy pobierania typu dokumentu w zmianie iloci do wydania :"+stat
    elif len(DaneDok) == 0:
        return "Brak podanego typu dokumentu."
    
    if rsglobal.Dekoduj(DaneDok[0][0]) == 'C':
        return 'OK'
    
    #sprawdzenie czy dokument jest dokumentem wydania
    if Sprawdzac:
        if len(DaneDok)>0:
            if not DaneDok[0][0] in ('M','W','L','D'):
                return 'OK'

    # pobieramy dane z pozycji dokumentu magazynowego i lokacji rwnoczenie
    SQL=" SELECT dp.lokacja_skad,dp.ilosc"+self.lokacje_jm+",dl.lokacja_skad,dl.ilosc,dp.ilosc_lokacja"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dp LEFT OUTER JOIN rs_dokumenty_magazynowe_lokacje dl "
    SQL+=" USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)"
    SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.magazyn_id='"+Mag+"'"
    SQL+=" AND dp.dokument_id='"+Dok+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
    SQL+=" AND dp.nr_poz="+str(NrPoz)+" AND COALESCE(dp.lokacja_skad,dl.lokacja_skad,'') <> '' ORDER BY dp.nr_poz,dp.nr_ppoz,dl.lp;"
    rsglobal.ZapiszDoLogow('SQL '+SQL,5)
    stat, DanePoz, dump, dump = self.PolSQL.Execute(SQL, 3)
    rsglobal.ZapiszDoLogow('DanePoz '+str(DanePoz),5)
    if stat<>'OK':
        return "Bd pobierania danych podczas zapisu iloci do pobrania w lokacjach "+stat

    LSumaLok={}
    
    # dodanie danych lokacjami
    for poz in DanePoz:
        # uwzgldnienie iloci lokacyjnej (iloci w tabelce s w iloci zwykej. Wyliczamy lokacyjn)
        if poz[1] ==0:
            return 'Jedna z pozycji dokumentu wprowadzanych na lokacj ma lokacyjn ilo 0. Sprawd dane.'
        
        PrzelLok = poz[4]/poz[1]
        
        if not poz[2] in ('',None,'None'):
            # dane z tabelki
            if poz[2] in LSumaLok:
                LSumaLok[poz[2]]+=rsglobal.RSRound(poz[3]*PrzelLok,4)
            else:
                LSumaLok[poz[2]]=rsglobal.RSRound(poz[3]*PrzelLok,4)
        
        elif not poz[0] in ('',None,'None'):
            # dane z pozycji
            if poz[0] in LSumaLok:
                LSumaLok[poz[0]]+=poz[4]
            else:
                LSumaLok[poz[0]]=poz[4]
                
    rsglobal.ZapiszDoLogow('LSumaLok '+str(LSumaLok),5)
    # jak nie ma lokacji to wychodzimy z funkcji
    if LSumaLok=={}:
        return 'OK'
    
    # wkadamy/zdejmujemy odpowiednie iloci na lokacje
    SQL=''
    
    for lok in LSumaLok:
        SQL+="UPDATE rs_lokacje SET do_wydania=do_wydania"+Znak+" "+str(LSumaLok[lok])
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(lok)+"';"
    rsglobal.ZapiszDoLogow('UPD '+SQL,5)
    if SQL<>'':
        #---test-----
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat<>'OK':
            return "Bd zapisu iloci do pobrania w lokacjach "+stat

    return 'OK'

#-------------------------------------------------------------------------------

def ZmienIlosciDoWydaniaWLokacjachNaCalymDokumencie(self,Mag,Dok,Data,Nr,Znak,SprawdzacDoWydania=True):
    stat='OK'
    SQL="SELECT DISTINCT tdm.typ_dokumentu,dp.nr_poz FROM rs_dokumenty_magazynowe_pozycje dp "
    SQL+="INNER JOIN rs_typy_dokumentow_m tdm USING (firma_id,dokument_id) "
    SQL+=" WHERE dp.firma_id = '"+self.firma_id+"' AND dp.magazyn_id = '"+Mag+"' AND dp.dokument_id = '"+Dok+"'"
    SQL+=" AND dp.data = '"+Data+"' AND dp.numer = "+str(Nr)+"; "
    stat,DanePoz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DanePoz)>0:
            if DanePoz[0][0] in ('M','W','L','D'):
                for poz in DanePoz:
                    if stat=='OK':
                        stat=ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,str(Nr),poz[1],Znak,False,SprawdzacDoWydania)
                        
    return stat


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- POBIERANIE LISTY LOKACJI I TESTY POPRAWNOSCI LOKACJI
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

def PodajLokacjeDokumentuLubPozycji(self,Mag,Dok,Data,Nr,NrPoz=0):
    import rsglobal
    stat='OK'
    LSkad=[]
    LDokad=[]
    LWszystkie=[]
        
    SQL=" SELECT DISTINCT TRIM(dp.lokacja_skad),TRIM(dp.lokacja_dokad),TRIM(dl.lokacja_skad),TRIM(dl.lokacja_dokad)"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dp LEFT OUTER JOIN rs_dokumenty_magazynowe_lokacje dl "
    SQL+=" USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)"
    SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.magazyn_id='"+Mag+"'"
    SQL+=" AND dp.dokument_id='"+Dok+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
    if NrPoz<>0:
        SQL+=" AND dp.nr_poz="+str(NrPoz)
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        for d in Dane:
            if not d[0] in ('',None,'None'):
                if not d[0] in LSkad:
                    LSkad.append(d[0])
                if not d[0] in LWszystkie:
                    LWszystkie.append(d[0])
    
            if not d[1] in ('',None,'None'):
                if not d[1] in LDokad:
                    LDokad.append(d[1])
                if not d[1] in LWszystkie:
                    LWszystkie.append(d[1])

            if not d[2] in ('',None,'None'):
                if not d[2] in LSkad:
                    LSkad.append(d[2])
                if not d[2] in LWszystkie:
                    LWszystkie.append(d[2])
    
            if not d[3] in ('',None,'None'):
                if not d[3] in LDokad:
                    LDokad.append(d[3])
                if not d[3] in LWszystkie:
                    LWszystkie.append(d[3])
    
    return stat,LSkad,LDokad,LWszystkie

#-------------------------------------------------------------------------------

def SprawdzListeLokacji(self,LLokacji,TypDok=''):
    import rsglobal
    stat='OK'
    dane=[]
    
    if LLokacji==[]:
        return 'OK',[]
    
    Lokacje=''
    for lok in LLokacji:
        Lokacje+="'"+rsglobal.Dekoduj(lok)+"',"
    
    Lokacje=Lokacje[:-1]
    
    SQL="SELECT lokacja_id,liczba,rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete')::NUMERIC,"
    SQL+="rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete_dokl')::NUMERIC,do_wydania,stan_minimalny "
    SQL+=" FROM rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id IN("+Lokacje+")"
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        for d in Dane:
            # jeli stan minimalny <> 0 i pojemno lokacji 1 to mierzymy dokadn zajtoci i 
            # pozwalamy na zajto 1+(stan minimalny*0.01)
            rsglobal.ZapiszDoLogow('d[1] '+str(d[1])+' d[5] '+str(d[5]),5)
            if d[1] == 1 and d[5] > 0:
                rsglobal.ZapiszDoLogow('weszo 1',5)
                if d[3] > d[1]+(d[5]*0.01):
                    rsglobal.ZapiszDoLogow('weszo 11',5)
                    dane.append('Nie mona zaj za duo miejsca : '+str(d[3])+' na lokacji '+d[0])
                    
            # zajte za duo (typ nie ma znaczenia bo albo zamykamy Typ P albo otwieramy Typ W)
            elif d[1]<d[2] and d[1]>0:
                rsglobal.ZapiszDoLogow('weszo 2',5)
                dane.append('Nie mona zaj za duo miejsca : '+str(d[2])+' na lokacji '+d[0])
        if len(dane)>0:
            stat=dane[0]
    return stat,dane    

#-------------------------------------------------------------------------------
#-- KONTROLA WYDANIA W OPARCIU O ARTYKULY PRZYJECIA
#-------------------------------------------------------------------------------

def SprawdzIlosciWArtykPrzyj(self,Mag,Dok,Data,Nr,NrPoz):
    import rsglobal
    # funkcja pobiera dane z pozycji i sprawdza czy dla podanych lokacji znajdzie artyku przyjcia do wydania.
    # Uwzgldnia pozycje wirtualne oraz pozycje z otwartych dokumentow magaznowych wydania.
    Mag=rsglobal.Dekoduj(Mag)
    Dok=rsglobal.Dekoduj(Dok)
    Data=rsglobal.Dekoduj(Data)
    Nr=str(Nr)
    NrPoz=str(NrPoz)

    SQLTest ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
    SQLTest+=" WHERE firma_id = '"+self.firma_id+"' AND dokument_id = '"+Dok+"';"
    stat,DaneDok,dump,dump = self.PolSQL.Execute(SQLTest,3)
    if stat<>'OK':
        return "Bdy pobierania typu dokumentu w sprawdzaniu wydawania :"+stat
    elif len(DaneDok) == 0:
        return "Brak podanego typu dokumentu."
    
    # analizujemy tylko dokumenty wydajce
    if not DaneDok[0][0] in ('M','W','L','D'):
        return 'OK'
    
    # pobranie danych pomocniczych do analizy dokument_id
    SQL="SELECT dokument_id FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND typ_dokumentu IN ('M','W','L')"
    stat, DaneTypowDok, dump, dump = self.PolSQL.Execute(SQL, 3)
    FiltrTypDok=''
    for poz in DaneTypowDok:
        FiltrTypDok+="'"+rsglobal.Dekoduj(poz[0])+"',"
    FiltrTypDok="("+FiltrTypDok.strip(',')+")"
        
    # pobieramy dane z pozycji dokumentu magazynowego i lokacji rwnoczenie
    SQL=" SELECT dp.artykul_id,dp.lokacja_skad,dp.ilosc"+self.lokacje_jm+",dl.lokacja_skad,dl.ilosc"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dp LEFT OUTER JOIN rs_dokumenty_magazynowe_lokacje dl "
    SQL+=" USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)"
    SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.magazyn_id='"+Mag+"'"
    SQL+=" AND dp.dokument_id='"+Dok+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
    SQL+=" AND dp.nr_poz="+str(NrPoz)+" ORDER BY dp.nr_poz,dp.nr_ppoz,dl.lp;"

    rsglobal.ZapiszDoLogow(20* 'sqllsumalok' + str(SQL), 5)
    stat, DanePoz, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat<>'OK':
        return "Bd pobierania danych pozycji w sprawdzaniu wydawania :"+stat

    LSumaLok={}

    # dodanie danych lokacjami
    for poz in DanePoz:
        if not poz[3] in ('',None,'None'):
            if (poz[0],poz[3]) in LSumaLok:
                LSumaLok[(poz[0],poz[3])]+=poz[4]
            else:
                LSumaLok[(poz[0],poz[3])]=poz[4]
        
        elif not poz[1] in ('',None,'None'):
            if (poz[0],poz[1]) in LSumaLok:
                LSumaLok[(poz[0],poz[1])]+=poz[2]
            else:
                LSumaLok[(poz[0],poz[1])]=poz[2]
    
    # jak nie ma lokacji to wychodzimy z funkcji
    if LSumaLok=={}:
        return 'OK'
    
    # dla kadej pary (artyku,lokacja) sprawdzamy czy da si j wyda w odpowiedni sposb z lokacji
    SQL=''
    
    for klucz in LSumaLok:
        art=rsglobal.Dekoduj(klucz[0])
        lokacja=rsglobal.Dekoduj(klucz[1])
        Ile=rsglobal.RSRound(LSumaLok[klucz],4)
        
        # pobieramy dane z art przyjecia, jeli tu ju brakuje to nie analizujemy wyda w stanie W.
        SQL=" SELECT SUM(ilosc"+self.lokacje_jm+"-rezerwacja"+self.lokacje_jm+") FROM rs_artykuly_przyjecia "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+art+"' AND lokacja_id='"+lokacja+"';"
        stat, DaneTest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            return "Bdy pobierania przyj w sprawdzaniu wydawania :"+stat
        
        if len(DaneTest)==0:
            rsglobal.ZapiszDoLogow(str(locals()), 5)
            return "Nie mona wyda z lokacji "+lokacja.strip()+" artykuu "+art.strip()+" w iloci "+str(Ile)+". Brakuje "+str(Ile)
        if DaneTest[0][0]<Ile:
            rsglobal.ZapiszDoLogow(str(locals()), 5)
            return "Nie mona wyda z lokacji "+lokacja.strip()+" artykuu "+art.strip()+" w iloci "+str(Ile)+". Brakuje conajmniej "+str(Ile-DaneTest[0][0])
    
        # poniewa wydaje si, e mona wyda z artykuw przyjcia to analizujemy jeszcze wydania w stanie W.
        SQL="SELECT SUM(COALESCE(dl.ilosc,dp.ilosc"+self.lokacje_jm+")) "
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje dp "
        SQL+=" INNER JOIN rs_dokumenty_magazynowe d USING (firma_id, magazyn_id,dokument_id,data,numer)"
        SQL+=" LEFT OUTER JOIN rs_dokumenty_magazynowe_lokacje dl "
        SQL+=" USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)"
        SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND d.dokument_id IN "+FiltrTypDok
        SQL+=" AND dp.artykul_id='"+art+"' AND COALESCE(dl.lokacja_skad,dp.lokacja_skad)='"+lokacja+"'"
        SQL+=" AND d.stan='W' AND NOT (dp.firma_id='"+self.firma_id+"' AND dp.magazyn_id='"+Mag+"'"
        SQL+=" AND dp.dokument_id='"+Dok+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
        SQL+=" AND dp.nr_poz="+str(NrPoz)+")"

        # SQL = "SELECT pn.ilosc1 "
        # SQL += "FROM rs_artykuly_przyjecia ap "
        # SQL += "INNER JOIN rs_dokumenty_magazynowe_pozycje dmp USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz, "
        # SQL += "nr_ppoz) "
        # SQL += "INNER JOIN rs_dokumenty_magazynowe d USING (firma_id, magazyn_id,dokument_id,data,numer) "
        # SQL += "INNER JOIN rs_dokumenty_magazynowe_pozycje_palety dmpp USING (firma_id,magazyn_id,dokument_id,data, "
        # SQL += "numer,nr_poz,nr_ppoz) "
        # SQL += "INNER JOIN rs_palety_numery pn ON (pn.firma_id=dmpp.firma_id AND pn.nr_palety_id = dmpp.nr_palety_id) "
        # SQL += "INNER JOIN rs_lokacje l ON (l.firma_id=dmpp.firma_id AND l.lokacja_id = ap.lokacja_id) and l.lokacja_id "
        # SQL += " = dmp.lokacja_dokad  "
        # SQL += "WHERE ap.firma_id='" + self.firma_id + "' AND l.lokacja_id='" + lokacja + "' AND dmpp.data <= now() and "
        # SQL += " dmpp.data=(SELECT max(data) FROM rs_dokumenty_magazynowe_pozycje_palety WHERE nr_palety_id =  "
        # SQL += "pn.nr_palety_id);"
        rsglobal.ZapiszDoLogow(str(SQL), 5)
        stat, DaneTestWyd, dump, dump = self.PolSQL.Execute(SQL, 3)
        if len(DaneTest)>0 and stat == 'OK':
            if Ile > rsglobal.RSRound(DaneTest[0][0]-DaneTestWyd[0][0],4):
                rsglobal.ZapiszDoLogow(str(locals()), 5)
                return "Nie mona wyda z lokacji "+lokacja.strip()+" artykuu "+art.strip()+" w iloci "+str(Ile)+". Brakuje "+str(Ile-rsglobal.RSRound(DaneTest[0][0]-DaneTestWyd[0][0]))

    return 'OK'



#-------------------------------------------------------------------------------
#-- OPERACJE NA ARTYKUACH PRZYJCIA
#-------------------------------------------------------------------------------

def OdswiezWirtualnePozPrzyj(self,Mag,Dok,Data,Nr,NrPoz=0,TylkoUsun=False):
    import rsglobal
    import fs_dokumenty_magazynowe_pom
    stat='OK'
    
    #----------------------------------
    # POBRANIE TYPU DOKUMENTU
    #---------------------------------- 

    sql ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
    stat,daneTD,dump,dump = self.PolSQL.Execute(sql ,3)     
    if stat <> "OK":
        return "Bd pobierania typu dokumentu : "+stat
    if len(daneTD)==0:
        return "Brak podanego typu dokumentu magazynowego"
    
    Typ=daneTD[0][0]
    if not Typ in ['P','M','L']:
        return 'OK'
    
    #----------------------------------
    # POBRANIE DANYCH NAGWKA
    #---------------------------------- 
    
    #kolumny 0-4
    SQL="SELECT waluta,kontrahent_id,COALESCE(dostawca_id,kontrahent_id),nr_zlecenia,konto_kosztow,"
    #kolumny 5-11
    SQL+="nr_faktury,kierowca,czy_nocny,zo_wyznacznik_id,zo_data,zo_numer,czy_pobrane_z_zamowien,"
    #kolumny 12-15
    SQL+="magazyn_dokad,numer_dokad,nr_faktury,waluta"
    
    SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Nr)+" FOR UPDATE NOWAIT;"
    stat, DaneN, dump, dump = self.PolSQL.Execute(SQL,3)
    if stat <> "OK":
        return "Bd pobierania nagwka : "+stat
    if len(DaneN)==0:
        return "Brak podanego dokumentu magazynowego"
    if len(DaneN)>1:
        return "Podany dokument wystpuje w wicej ni raz w bazie danych!"
    
    
    #----------------------------------
    # USUNICIE STARYCH WIRTUALNYCH POZYCJI
    #---------------------------------- 
    
    SQLDEL="DELETE FROM rs_artykuly_przyjecia "
    if Typ=='P':
        SQLDEL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        SQLDEL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Nr)
    else:
        SQLDEL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+rsglobal.Dekoduj(DaneN[0][12])+"'"
        SQLDEL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(DaneN[0][13])
    if NrPoz<>0:
        SQLDEL+=" AND nr_poz="+str(NrPoz)
    SQLDEL+=" AND wirtualne;"
    
    if TylkoUsun:
        # jesli tylko usunac art-przyjecia, bo dokument zostal usuniety lub skopiowany
        stat,d,dump,dump = self.PolSQL.Execute(SQLDEL,1)
        if stat <> 'OK':
            stat = 'Bd usuwania danych przyjcia: '+stat
        return stat
        
    #----------------------------------
    # POBRANIE DANYCH POZYCJI
    #---------------------------------- 

    # kolumny 0-8
    SQL="SELECT dp.nr_poz,dp.nr_ppoz,dp.artykul_id,dp.ilosc1,dp.ilosc2,dp.cena1,dp.cena2,dp.cena_wal1,dp.cena_wal2,"
    # kolumny 9-13
    SQL+="dp.cena_pierw1,dp.cena_pierw2,dp.cena_pierw_wal1,dp.cena_pierw_wal2,COALESCE(dp.nr_serii,''),"
    # kolumny 14-19
    SQL+="dp.termin_przyd,dp.dokument_przych,dp.wejscie_data,dp.wejscie_magazyn,dp.dostawca_id,dp.opis,"
    # kolumny 20-23
    SQL+="COALESCE(dp.oryginal,dp.artykul_id),dp.czy_lokacje,dp.lokacja_skad,dp.lokacja_dokad,"
    # kolumny 24-30
    SQL+="dp.cecha1_opis,dp.cecha1_wartosc,dp.produkt_id,dl.lokacja_skad,dl.lokacja_dokad,dl.ilosc,dl.lp,"
    # kolumny 31-35
    SQL+="COALESCE(lp.artykul_id,''),COALESCE(lp.kateg_artykulu,''),COALESCE(lt.artykul_id,''),COALESCE(lt.kateg_artykulu,''),a.kateg_artykulu, "
    # kolumny 36-39
    SQL+="COALESCE(dp.opakowanie_id,''),wsp_ilosci_opakowanie,COALESCE(dp.paleta_id,''), wsp_ilosci_paleta,"
    # kolumny 40-41
    SQL+="wsp_ilosci_lokacja,ilosc_lokacja"
    
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dp LEFT OUTER JOIN rs_dokumenty_magazynowe_lokacje dl "
    SQL+=" USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)"
    SQL+=" LEFT OUTER JOIN rs_lokacje lp ON (lp.firma_id=dp.firma_id AND lp.lokacja_id=dp.lokacja_dokad) "
    SQL+=" LEFT OUTER JOIN rs_lokacje lt ON (lt.firma_id=dl.firma_id AND lt.lokacja_id=dl.lokacja_dokad) "
    SQL+=" INNER JOIN rs_artykuly a ON (a.firma_id=dp.firma_id AND a.artykul_id=dp.artykul_id) "
    SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.magazyn_id='"+Mag+"' "
    SQL+=" AND dp.dokument_id='"+Dok+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
    if NrPoz<>0:
        SQL+=" AND dp.nr_poz="+str(NrPoz)
    SQL+=" ORDER BY dp.nr_poz,dl.lp"
    stat, DaneP, dump, dump = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('SQL DaneP: ' + str(SQL), 5)
    rsglobal.ZapiszDoLogow('DaneP: ' + str(DaneP), 5)
    if stat <> "OK":
        return "Bd pobierania pozycji : "+stat

    magprzyj = rsglobal.Dekoduj(DaneN[0][12])
    numprzyj = str(DaneN[0][13])
    if numprzyj in ('None','0','0.0'):
        numprzyj = str(Nr)
        
    faktura = rsglobal.Dekoduj(DaneN[0][14])
    if faktura in ['None',None]:
        faktura="NULL"
    else:
        faktura="'"+rsglobal.Dekoduj(faktura)+"'"
    
    waluta = rsglobal.Dekoduj(DaneN[0][15])

    #----------------------------------
    # WSTAWIENIE WIRTUALNYCH POZYCJI PRZYJECIA
    #---------------------------------- 

    SQLINS=''
    for poz in DaneP:
        if stat=='OK':
            nr_poz=str(poz[0])
            nr_ppoz=str(poz[1])
            seria=poz[13]
            if seria in ['None',None]:
                seria=""
            else:
                seria=rsglobal.Dekoduj(seria.rstrip())
            termin=poz[14]
            if termin in ['None',None]:
                termin="NULL"
            else:
                termin="'"+rsglobal.Dekoduj(termin)+"'"
    
            artykul = rsglobal.Dekoduj(poz[2]).strip()
    
            # bez tabelki lokacji
            if poz[28] in [None,'None','']:
                ilosc1 = poz[3]
                ilosc2 = poz[4]
            
                LokDokad = rsglobal.Dekoduj(poz[23])                            
                if LokDokad in ['None',None]:
                    LokDokad="NULL"
                else:
                    LokDokad="'"+LokDokad+"'"        
                    
                # sprawdzenie czy nie wkadamy na lokacj z wpisanym innym artykuem lub kategori
                if poz[31].strip()<>'' and  poz[2].strip()<>poz[31].strip():
                    stat='Artyku '+poz[2].strip()+' nie moe zosta przypisany do lokacji '+LokDokad.strip("'").strip()+' poniewa ma ona wpisany artyku '+poz[31].strip()
                elif poz[32].strip()<>'' and  poz[35].strip()<>poz[32].strip():                                
                    stat='Artyku '+poz[2].strip()+' o kategorii '+poz[35].strip()+' nie moe zosta przypisany do lokacji '+LokDokad.strip("'").strip()+' poniewa ma ona wpisan kategori '+poz[32].strip()
            # z tabelk lokacji
            else:
                nr_ppoz=str(poz[30])
                IlLok=poz[29]
                SQL="SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul+"';"
                stat, DanePrz, dump, dump = self.PolSQL.Execute(SQL,3)
                if stat <> "OK":
                    return "Bd pobierania przelicznika : "+stat
                
                if self.lokacje_jm=='1':
                    ilosc1 = IlLok
                    ilosc2 = rsglobal.RSRound(IlLok*DanePrz[0][0],4)
                else:
                    ilosc2 = IlLok
                    ilosc1 = rsglobal.RSRound(IlLok/DanePrz[0][0],4)
                    
                LokDokad = "'"+rsglobal.Dekoduj(poz[28])+"'"
                
                # sprawdzenie czy nie wkadamy na lokacj z wpisanym innym artykuem lub kategori
                if poz[33].strip()<>'' and  poz[2].strip()<>poz[33].strip():
                    stat='Artyku '+poz[2].strip()+' nie moe zosta przypisany do lokacji '+LokDokad.strip("'").strip()+' poniewa ma ona wpisany artyku '+poz[33].strip()
                elif poz[34].strip()<>'' and  poz[35].strip()<>poz[34].strip():                                
                    stat='Artyku '+poz[2].strip()+' o kategorii '+poz[35].strip()+' nie moe zosta przypisany do lokacji '+LokDokad.strip("'").strip()+' poniewa ma ona wpisan kategori '+poz[34].strip()

        if stat=='OK':
            cena1=poz[5]
            cena2=poz[6]
            cenaw1=poz[7]
            cenaw2=poz[8]
            cenap1=poz[9]
            cenap2=poz[10]
            cenapw1=poz[11]
            cenapw2=poz[12]    
            
            if Typ == "P" :
                wejscie_data="'"+Data+"'"
                wejscie_magazyn="'"+Mag+"'"
            else:
                wejscie_data=poz[16]
                if wejscie_data in ['None',None]:
                    wejscie_data="NULL"
                else:
                    wejscie_data="'"+rsglobal.Dekoduj(wejscie_data)+"'"
                wejscie_magazyn=poz[17]
                if wejscie_magazyn in ['None',None]:
                    wejscie_magazyn="NULL"
                else:
                    wejscie_magazyn="'"+rsglobal.Dekoduj(wejscie_magazyn)+"'"
                    
            opis= rsglobal.Dekoduj(poz[19])
            if opis in ['None',None]:
                opis="NULL"
            else:
                opis="'"+opis+"'"
    
            dokumentprzych = rsglobal.Dekoduj(poz[15])                            
            if dokumentprzych in ['None',None]:
                dokumentprzych="NULL"
            else:
                dokumentprzych="'"+dokumentprzych+"'"
            
            Cecha1Opis = rsglobal.Dekoduj(poz[24])                            
            if Cecha1Opis in ['None',None]:
                Cecha1Opis=""
    
            Cecha1Wart = rsglobal.Dekoduj(poz[25])                            
            if Cecha1Wart in ['None',None]:
                Cecha1Wart=""
            else:
                stat=fs_dokumenty_magazynowe_pom.SprawdzPoprawnoscCechy(self,Cecha1Opis,Cecha1Wart)
                if stat<> 'OK':
                    stat+='. Dotyczy artykuu '+artykul
        
        if stat=='OK':
            Produkt = rsglobal.Dekoduj(poz[26])
            if Produkt in ['None',None]:
                Produkt="NULL"
            else:
                Produkt="'"+Produkt+"'"
                
            kierowca = rsglobal.Dekoduj(DaneN[0][6])                            
            if kierowca in ['None',None]:
                kierowca="NULL"
            else:
                kierowca="'"+kierowca+"'"
            
            dostawca=rsglobal.Dekoduj(DaneN[0][2])
    
            if dostawca in ['None',None]:
                dostawca="NULL"
            else:
                dostawca="'"+dostawca+"'"
    
            kontrahent=DaneN[0][1]
            if kontrahent in [None,'None']:
                kontrahent="NULL"
            else:
                kontrahent="'"+rsglobal.Dekoduj(kontrahent)+"'"
    
            czynocny=DaneN[0][7]
            if czynocny:
                czynocny="TRUE"
            else:
                czynocny="FALSE"
            
            if poz[36] == '':
                Opak='NULL'
            else:
                Opak="'"+rsglobal.Dekoduj(poz[36])+"'"

            WspOpak = str(poz[37])
            
            if poz[38] == '':
                Paleta='NULL'
            else:
                Paleta="'"+rsglobal.Dekoduj(poz[38])+"'"
                
            WspPaleta = str(poz[39])
            WspLokacja = str(poz[40])
            
            # uwzgldnienie iloci lokacyjnej (iloci w tabelce s w iloci zwykej. Wyliczamy lokacyjn)
            rsglobal.ZapiszDoLogow('poz 28: ' + str(poz[28]), 5)
            rsglobal.ZapiszDoLogow('poz 41: ' + str(poz[41]), 5)
            rsglobal.ZapiszDoLogow('poz 3: ' + str(poz[3]), 5)
            rsglobal.ZapiszDoLogow('poz 29: ' + str(poz[29]), 5)
            if poz[28] in [None,'None','']:
                IloscLok = str(poz[41])
            else:
                if self.lokacje_jm=='1':
                    PrzelLok = poz[41]/poz[3]
                else:
                    PrzelLok = poz[41]/poz[4]
                IloscLok = str(rsglobal.RSRound(poz[29]*PrzelLok,4))
    
            SQLINS+="INSERT INTO rs_artykuly_przyjecia (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
            SQLINS+="dostawca_id,nr_faktury,nr_serii,termin_przyd,artykul_id,ilosc_prz1,ilosc_prz2,"
            SQLINS+="cena1,cena2,cena_pierw1,cena_pierw2,waluta,cena_wal1,cena_wal2,cena_pierw_wal1,cena_pierw_wal2,"
            SQLINS+="ilosc1,ilosc2,wejscie_data,wejscie_magazyn,opis,lokacja_id,cecha1_opis,cecha1_wartosc,wirtualne,"
            SQLINS+="opakowanie_id,paleta_id,wsp_ilosci_opakowanie,wsp_ilosci_paleta,wsp_ilosci_lokacja,ilosc_lokacja) VALUES"
            SQLINS+=" ('"+self.firma_id+"','"+magprzyj+"','"+Dok+"','"+Data+"',"+numprzyj+","+nr_poz+","+nr_ppoz+","
            SQLINS+=dostawca+","+faktura+",'"+seria+"',"+termin+",'"+artykul+"',"+str(ilosc1)+","+str(ilosc2)+","
            SQLINS+=str(cena1)+","+str(cena2)+","+str(cenap1)+","+str(cenap2)+",'"+waluta+"',"+str(cenaw1)+","+str(cenaw2)+","+str(cenapw1)+","+str(cenapw2)+","
            SQLINS+=str(ilosc1)+","+str(ilosc2)+","+wejscie_data+","+wejscie_magazyn+","+opis+","+LokDokad+",'"+Cecha1Opis+"','"+Cecha1Wart+"',TRUE,"
            SQLINS+=Opak+","+Paleta+","+WspOpak+","+WspPaleta+","+WspLokacja+","+IloscLok+");"

    if stat=='OK':
        SQL = SQLDEL+SQLINS
        rsglobal.ZapiszDoLogow('INSERT  rs_artykuly_przyjecia ' + SQL, 5)
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
    
    return stat

#-##############################################################################
#--- FUNKCJA USTAWIAJCA WSPӣCZYNNIK I ILO LOKACYJN NA DOKUMENCIE LUB JEGO POZYCJI
#-##############################################################################

def UstawWspIIloscLokacyjnaNaDM(self,Mag,Dok,Data,Numer,NrPoz,NrPPoz,TylkoIlosc):
    import rsglobal    
    # pobranie pozycji, ktre bd miay zmieniane dane
    SQL = "SELECT dp.nr_poz,dp.nr_ppoz,dp.ilosc"+self.lokacje_jm+",COALESCE(dp.wsp_ilosci_opakowanie,0),"
    SQL+= "COALESCE(dp.wsp_ilosci_paleta,0),COALESCE(p.pojemnosc_lokacyjna,0),COALESCE(dp.wsp_ilosci_lokacja,0)"
    SQL+= " FROM rs_dokumenty_magazynowe_pozycje dp"
    SQL+= " LEFT OUTER JOIN rs_palety p USING (firma_id,paleta_id)"
    SQL+= " WHERE dp.firma_id='"+self.firma_id+"' AND dp.magazyn_id='"+Mag+"'"
    SQL+= " AND dp.dokument_id='"+Dok+"' AND dp.data='"+Data+"' AND dp.numer = "+str(Numer)
    if NrPoz <> 0:
        SQL+=" AND dp.nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
    # zmiana pobranych wierszy
    if stat <> 'OK':
        return 'Bdy pobierania pozycji do zmiany iloci lokacyjnej: '+stat
    
    for poz in Dane:
        rsglobal.ZapiszDoLogow('poz '+str(poz),5)
        if TylkoIlosc and poz[6] <> 0:
            WspLok = poz[6]
        else:
            WspLok = poz[5]
            
        if poz[3] == 0 or poz[4] == 0 or WspLok == 0:
            Ilosc = poz[2]
        else:
            rsglobal.ZapiszDoLogow(str(poz[2])+'/'+str(float(poz[3]))+'/'+str(float(poz[4]))+'/'+str(float(WspLok)),5)
            Ilosc = rsglobal.RSRound(((poz[2]/float(poz[3]))/float(poz[4]))/float(WspLok),4)
        rsglobal.ZapiszDoLogow('ilosc '+str(Ilosc),5)
        UPD = "UPDATE rs_dokumenty_magazynowe_pozycje SET ilosc_lokacja = "+str(Ilosc)
        if not TylkoIlosc:
            UPD+=", wsp_ilosci_lokacja="+str(poz[5])
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        UPD+= " AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer = "+str(Numer)
        UPD+= " AND nr_poz="+str(poz[0])+" AND nr_ppoz="+str(poz[1])
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            return "Bd wyliczenia iloci lokacyjnej dla pozycji "+str(poz[0])+'/'+str(poz[1])+": "+stat
    return 'OK'

