# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_pozycje.py
# Purpose:     
# Author:      Dariusz Boduch,Micha Raburski
# Created:     2009/09/18
# RCS-ID:      $Id: fs_dokumenty_magazynowe_pozycje.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Pawe Wjcikowski - przejscie na fun. 24.09.09r.
# 2011-03-30 Mariusz Rajfura    - pobranie do grida z pozycjami lokacji takze dla rodzaju dok 'L' (4427)
# 2020-05-20 Aleksander Bargie - Usuwanie pozycji dokumentu magazynowego jeeli jest zamknity (11980)
# 2020-06-15 Aleksander Bargie - [HD] F1 w GM dla magazynu detalicznego  (12007)
# 2022-10-11 Aleksander Bargie (13198) [GM] Uzupenianie iloci ujemnych w magazynie

from funkcje import fs_dokumenty_magazynowe_lokacje_pom
from funkcje import fs_dokumenty_magazynowe_rezerwacje_pom

Magazyn=rsglobal.Dekoduj(klucze[0])
Dokument=rsglobal.Dekoduj(klucze[1])
Data=rsglobal.Dekoduj(klucze[2])
Numer=klucze[3]
SymbolF=klucze[4]
CenaF=klucze[5]
NrSeriiF=klucze[6]
Waluta=klucze[7]
DwieJednMiar=klucze[8]
Klucze=klucze[9]
PozycjaN=klucze[10]
Pozycja=klucze[11]
Stan=klucze[12]
PPozycja=klucze[13]
Fun=klucze[-1]

stat = "OK"
dane = []
wyn1 = []
wyn2 = []
daneL = [] 
daneT = []
UPD_lok = ''

UprDodawanie=(((self.oddzial_id,'032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'032024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZmianaKlucza=(((self.oddzial_id,'032025') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'032022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH DO FILTRA DLA OKNA Z PRZESYLEK 14                        
#-------------------------------------------------------------------------------

if Fun == 14:
    sql="SELECT waluta, czy_pobrane_z_zamowien FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"' "
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+" ;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu danych dokumentu magazynowego :'+stat
        dane.append(stat)    
        
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY MAGAZYN MA WCZONE LOKACJE 13
#-------------------------------------------------------------------------------

if Fun in [13,5]:
    sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"' ;"
    stat,daneL,dump,dump = self.PolSQL.Execute(sql ,3)        
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu danych o lokacjach :'+stat
        dane.append(stat) 
    else:         
        sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id = '"+Dokument+"' ;"
        stat,daneT,dump,dump = self.PolSQL.Execute(sql ,3)        
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych o rodzaju dokumentu mag. :'+stat
            dane.append(stat)
        else:
            dane=[daneL[0][0],daneT[0][0]]


#-------------------------------------------------------------------------------
#Funkcja 9                                                                      
#Tworzenie dok. ze wszystkimi pozycjami z artykulow przyjec dla danego magazynu 
#-------------------------------------------------------------------------------

if Fun == 9 and stat=='OK':
    if not UprDodawanie:
        stat='UPR INS'
        dane.append( stat )

    if stat =='OK':
        #KONTROLA DANYCH
        #Pobranie typu dokumentu
        sql = "SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' "
        sql+= "AND dokument_id='"+Dokument+"' ;"
        stat, doc_type, dump, dump = self.PolSQL.Execute( str(sql), 3 )
        if stat != "OK":
          stat="BL_SQL"
          dane.append( stat )
        elif doc_type[0][0] == 'P':
          stat = "BL TYPDOK"
          dane.append( stat ) 
        #czy sa pozycje na dokumencie
        if stat=='OK':
            sql="SELECT * FROM rs_dokumenty_magazynowe_pozycje WHERE "
            sql+=" firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"' "
            sql+=" AND data ='"+Data+"' AND numer="+str(Numer)+" ;"
            stat, doc_poz, dump, dump = self.PolSQL.Execute( str(sql), 3 )
            if stat != "OK":
              stat="BL_SQL"
              dane.append( stat )
            elif len(doc_poz) > 0:
              stat = 'ISTN POZ'
              dane.append( stat ) 
        if stat=='OK':
            #POBRANIE POZYCJI Z MAGAZYNU 
            SEL=" SELECT artykul_id, sum(ilosc1-rezerwacja1) as ilosc1, sum(ilosc2-rezerwacja2) as ilosc2 "
            SEL+=" FROM rs_artykuly_przyjecia "
            SEL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND data<='"+Data+"' AND NOT wirtualne"
            SEL+=" GROUP BY artykul_id HAVING sum(ilosc1-rezerwacja1) > 0 ORDER BY artykul_id ;"
            stat, poz, dump, dump = self.PolSQL.Execute( str(SEL), 3 )
            if stat != "OK":
              stat="BL_SQL"
              dane.append(stat)
            else:
                INSERT=''
                NrPoz=0
                for w in poz:
                    NrPoz=NrPoz+1
                    INSERT+="INSERT INTO rs_dokumenty_magazynowe_pozycje "
                    INSERT+=" (firma_id, magazyn_id, dokument_id, data, numer, nr_poz, nr_ppoz, "
                    INSERT+=" artykul_id, ilosc1, ilosc2 )"
                    INSERT+=" VALUES ('"+self.firma_id+"', '"+Magazyn+"', '"+Dokument+"',"
                    INSERT+=" '"+Data+"', '"+str(Numer)+"', "+str(NrPoz)+",0,"
                    INSERT+=" '"+str(w[0])+"', "+str(w[1])+","+str(w[2])+" ) ;"
                stat, dump, dump, dump = self.PolSQL.Execute(INSERT,1)
                if stat != "OK":
                  stat="BL_INS"
                  dane.append(stat) 


#-------------------------------------------------------------------------------
#     USUWANIE POZYCJI                
#     Funkcja 10 - usuwanie i przenumerowanie i usunicie poaczenia z zamwieniem    
#-------------------------------------------------------------------------------

if Fun ==10 and stat=='OK':  
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania.'
        dane.append(stat)

    if stat == 'OK':
        #sprawdzenie uprawnien do magazynu i typu dokumentu
        sql="SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"',10);"
        stat, TestUpr, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat=='OK':
            if len(TestUpr)==0:
                stat='Bd sprawdzania uprawnie do magazynu i typw dokumentw.'
            elif not TestUpr[0][0]:
                stat= "Brak uprawnie do usuwania pozycji dokumentu."
    #AB 20.05.20r
    if stat == 'OK':
        # sprawdzenie czy dokument jest w stanie 'W'
        sql = """SELECT stan
                 FROM rs_dokumenty_magazynowe 
                 WHERE firma_id='{}' AND magazyn_id='{}' AND dokument_id='{}' AND data='{}' AND numer={}
                 ;""".format(self.firma_id, Magazyn, Dokument, Data, Numer)
        stat, TestStan, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(TestStan) == 0:
                stat = u'Nie odnaleziono dokumentu.'
            elif TestStan[0][0] != 'W':
                stat = u"Dokument nie jest w stanie W."
        else:
            stat = u"Bad sprawdzania stanu dokumentu: " + stat

    UPDLOK = ''

    if stat=='OK':
        # zdjcie iloci do wydania z lokacji w iloci z pozycji dokumentu (jeli usuwana podpozycja to potem jest wkadanie z powrotem)
        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Magazyn,Dokument,Data,Numer,Pozycja,'-')   
        
        if stat=='OK':
            # sprawdzam czy usuwajc bede mogl zdjc odpowiednie ilosci w lokacjach // jesli wczone //    
            MaGridaLokacji = False
            
            #sprawdzenie czy pozycja posiada grida z lokacjami
            #jesli tak, to test czy mozna wycofac stany z lokacji_dokad
            
            sql ="SELECT lokacja_skad,lokacja_dokad,ilosc FROM rs_dokumenty_magazynowe_lokacje"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"'"
            sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Pozycja)+" AND nr_ppoz="+str(PPozycja)+" FOR UPDATE NOWAIT;"
            
            stat,daneLOK,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania danych lokacji doczonych do pozycji: '+stat
                dane.append(stat)
            elif len(daneLOK) > 0:
                MaGridaLokacji = True
        
        if stat == 'OK' and MaGridaLokacji:
            if Dokument == 'MM':
                #pobieramy magazyn_dokad z naglowka dokumentu
                sql ="SELECT stan, magazyn_dokad FROM rs_dokumenty_magazynowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"'"
                sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania danych nagwka dokumentu: '+stat
                    dane.append(stat)
                elif len(d) != 1:
                    stat = 'Brak dokumentu o podanym kluczu'
                    dane.append(stat)
                elif d[0][0] != 'W':
                    stat = 'Dokument nie jest w stanie W'
                    dane.append(stat)
                    
                Mag = rsglobal.Dekoduj(d[0][1]).strip()
            else:
                Mag = Magazyn.strip()
                
        if stat == 'OK' and MaGridaLokacji and Dokument == 'MM':
            #sprawdzimy, czy w przypadku dok.MM,
            #magazyn DOKAD posiada lokacje bo jesli nie,
            #to nie musimy zajmowac sie wycofywanien ilosci z grida
            sql ="SELECT czy_lokacje FROM rs_magazyny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania danych o lokacjach w magazynie: '+stat
                dane.append(stat)
            elif len(d) != 1:
                stat = 'Brak magazynu DOKD'
                dane.sppend(stat)
            elif not d[0][0]:
                #magazyn DOKAD nie obsluguje lokacji, czy grid nie jest istotny
                MaGridaLokacji = False
                
        if stat == 'OK' and MaGridaLokacji:
            for i in xrange(len(daneLOK)):
                LokacjaDokad = rsglobal.Dekoduj(daneLOK[i][1]).strip()
                Ilosc = daneLOK[i][2]
                if LokacjaDokad != 'None':
                    sql ="SELECT rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete')::NUMERIC,"
                    sql+="magazyn_id,CEIL("+str(Ilosc)+"),do_wydania FROM rs_lokacje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+LokacjaDokad+"' FOR UPDATE NOWAIT;"
    
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd pobrania danych lokacji '+stat
                        dane.append(stat)
                        
                    elif len(d) != 1:
                        stat = 'Brak lokacji '+LokacjaDokad
                        dane.append(stat)
                        
                    elif rsglobal.Dekoduj(d[0][1]).strip() in ('None',Mag):
                        if d[0][2] > d[0][0]:
                            stat = 'Brak wystarczajcej iloci w lokacji '+LokacjaDokad
                            dane.append(stat)
                    else:
                        stat = 'Brak lokacji '+LokacjaDokad+' z magazynu '+Mag
                        dane.append(stat)
                        
        #czy byly jakies bledy 
        if stat == 'OK':
            if len(dane) > 0:
                stat == dane[0]
        
    if stat=='OK' and not MaGridaLokacji:
        #jesli nie ma grida z lokacjami, wiec sprawdzamy lokacje przy pozycji
        czy_lokacje_mm=''
        czy_lokacje=''
        typ_dokumentu=''
        # sprawdzam czy magazyn ma wczone lokacje 
        sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"' ;"
        stat,daneL,dump,dump = self.PolSQL.Execute(sql ,3)  
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych o lokacjach :'+stat
            dane.append(stat) 
            
        if stat=='OK':
            czy_lokacje=daneL[0][0]        
            sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id = '"+Dokument+"' ;"
            stat,daneT,dump,dump = self.PolSQL.Execute(sql ,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu danych o rodzaju dokumentu mag. :'+stat
                dane.append(stat)
        if stat=='OK':
            typ_dokumentu=daneT[0][0]
            if Dokument=='MM': # spr czy 2 magazyn w mm-ce ma wczone lokacje
                sql="SELECT magazyn_dokad FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' "
                sql+="AND magazyn_id='"+Magazyn+"' AND dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND numer = "+str(Numer)+";"
                stat,daneMM,dump,dump = self.PolSQL.Execute(sql ,3)        
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu informacji o lokacjach :'+stat
                    dane.append(stat)    
                else:           
                    mag_dokad=daneMM[0][0]
                    sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+str(mag_dokad)+"' ;"
                    stat,daneML,dump,dump = self.PolSQL.Execute(sql ,3)  
                    if stat<>'OK':
                        stat = 'Bd przy pobieraniu danych o lokacji :'+stat
                        dane.append(stat)     
                    else:
                        czy_lokacje_mm=daneML[0][0]
                        
                if czy_lokacje<>'' or czy_lokacje_mm<>'':
                    sql="SELECT ilosc_lokacja,lokacja_skad,lokacja_dokad FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND"
                    sql+=" magazyn_id = '"+str(Magazyn)+"' AND dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND"
                    sql+=" numer = "+str(Numer)+" AND nr_poz = "+str(Pozycja)+" AND nr_ppoz = "+str(PPozycja)+";"
                    stat,daneMM,dump,dump = self.PolSQL.Execute(sql ,3)    
                    if stat<>'OK':
                        stat = 'Bdy przy pobieraniu informacji o lokacjach :'+stat
                        dane.append(stat)       
                    else:
                        ilosc=daneMM[0][0]
                        lokacja_skad=daneMM[0][1]
                        lokacja_dokad=daneMM[0][2]
                        if lokacja_dokad not in ['',None,'None']:  # jesli jest lokacja skad to czy aktywna (ilosc > 0) i jakie iloci                           
                            sql="SELECT liczba,rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete_dokl')::NUMERIC,do_wydania FROM rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id = '"+str(lokacja_dokad)+"' ;"
                            stat,daneLOK_D,dump,dump = self.PolSQL.Execute(sql ,3)        
                            if stat<>'OK':
                                stat = 'Bd przy pobieraniu iloci w lokacjach :'+stat
                                dane.append(stat) 
                            if stat=='OK':
                                if daneLOK_D<>'':
                                    st_ilosc_dokad=daneLOK_D[0][0]
                                    st_zajete_dokad=daneLOK_D[0][1]
                                    st_do_wydania_dokad=daneLOK_D[0][2]
                                    if st_zajete_dokad-ilosc<0:
                                        stat = ' Brak odpowiedniej iloci artykuu w lokacji DOKAD do wydania'
                                        dane.append(stat)                     
                                    
                                    #if stat=='OK':
                                    #    if st_zajete_dokad-ilosc<st_do_wydania_dokad:
                                    #        stat = 'Nie mona zdj artykuu z lokacji '+lokacja_dokad+' poniewa pozostanie za mao artykuu, by mona byo zrealizowa wydanie artykuu z kolumny "do wydania"'

    if stat=='OK':
        # zdjcie rezerwacji jeli dokument typu C
        stat=fs_dokumenty_magazynowe_rezerwacje_pom.ZmienRezerwacjeNaArtPrzyjDokumentC(self,[Magazyn,Dokument,Data,Numer],[[Pozycja,PPozycja]],'-')    
        
        #na poczatek aktualizacja lokacji
    if stat=='OK':
        DEL = UPDLOK
        
        DEL+="DELETE FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND"
        DEL+=" magazyn_id = '"+str(Magazyn)+"' AND dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND"
        DEL+=" numer = "+str(Numer)+" AND nr_poz = "+str(Pozycja)+" AND nr_ppoz = "+str(PPozycja)+";"
        
        if UPD_lok<>'':
            DEL+=UPD_lok    
        
        stat,dump,dump,dump = self.PolSQL.Execute(DEL,1)
        if stat<>'OK':
            stat = 'Bdy przy usuwaniu pozycji :'+stat
            dane.append(stat)
            
        if stat=='OK':
            #sprawdzenie czy pozycja jest caa usunita
            TestPoz="SELECT * FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND"
            TestPoz+=" magazyn_id = '"+str(Magazyn)+"' AND dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND"
            TestPoz+=" numer = "+str(Numer)+" AND nr_poz = "+str(Pozycja)+";"
            stat,DaneTest,dump,dump = self.PolSQL.Execute(TestPoz,3)
            if stat<>'OK':
                stat = 'Bdy przy testowaniu istnienia pozycji :'+stat
                dane.append(stat)      
        
        if stat=='OK':
            # sprawdzenie czy dokument nie pochodzi z WMS i ma nr_ppozycji > 0
            OperatorWMS = 0
            if PPozycja > 0:
                SQL = "SELECT operator_wms FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND " \
                      " magazyn_id = '"+str(Magazyn)+"' AND dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND " \
                      " numer = "+str(Numer)
                stat,DWMS,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu operatora WMS :'+stat
                if stat == "OK":
                    OperatorWMS = DWMS[0][0]


            if len(DaneTest)>0:
                # usunito jedn podpozycj z kilku to zostanie to wrzucone z powrotem co zostao.
                stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Magazyn,Dokument,Data,Numer,Pozycja,'+')   
                #  zmienne do przenumerowania
                if stat=='OK':
                    FiltrPoz=" AND nr_poz = "+str(Pozycja)+" and nr_ppoz > "+str(PPozycja)+";"        
                    Pole='nr_ppoz'
            else:
                Pole='nr_poz'
                FiltrPoz=" AND nr_poz > "+str(Pozycja)+";"
        
        # przenumerowanie
        if stat=='OK' and not (PPozycja > 0 and OperatorWMS > 0):
            UPD="UPDATE rs_dokumenty_magazynowe_pozycje SET "+Pole+"="+Pole+"+1000 WHERE "
            UPD+="firma_id='"+self.firma_id+"' AND magazyn_id = '"+str(Magazyn)+"' AND "
            UPD+="dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND numer = "+str(Numer)+FiltrPoz+';'
            UPD+="UPDATE rs_dokumenty_magazynowe_pozycje SET "+Pole+"="+Pole+"-1001 WHERE "
            UPD+="firma_id='"+self.firma_id+"' AND magazyn_id = '"+str(Magazyn)+"' AND "
            UPD+="dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND numer = "+str(Numer)+FiltrPoz
        
            stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)   
            if stat<>'OK':
                stat = 'Bdy przy modyfikowaniu pozycji :'+stat
                dane.append(stat)         

        #Usuniecie powiazania z zamowienem odbiorcy (ZO) w przypadku,
        #gdy podane jest konkretne zamowienie i zaden z artykulow z ZO
        #nie wystepuje na dokumencie magazynowym (DM)
        #Jesli usunieto jedyna pozycje na dokumencie, to triger before_delete
        #na rs_dokumenty_magazynowe_pozycje wyczysci powiazanie z ZO
        if stat == 'OK':
            sql ="SELECT zo_wyznacznik_id,zo_data,zo_numer"
            sql+=" FROM rs_dokumenty_magazynowe"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"'"
            sql+=" AND dokument_id='"+str(Dokument)+"' AND data='"+str(Data)+"'"
            sql+=" AND numer = "+str(Numer)+" FOR UPDATE NOWAIT;"

            stat,daneZO,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o zamwieniu odbiorcy: '+stat
            elif len(daneZO) != 1:
                stat = 'Brak dokumentu magazynowego o podanym kluczu'
        
        if stat == 'OK':
            if rsglobal.Dekoduj(daneZO[0][0]).strip() != 'None' and \
               daneZO[0][1] != 'None' and daneZO[0][2] != 0:
                #pobierzemy liste artykulow z DM, ktore byly na ZO
                sql ="SELECT artykul_id FROM rs_dokumenty_magazynowe_pozycje"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"'"
                sql+=" AND dokument_id='"+str(Dokument)+"' AND data='"+str(Data)+"'"
                sql+=" AND numer = "+str(Numer)+" AND artykul_id IN "
                sql+=" (SELECT artykul_id FROM rs_zamowienia_odbiorcy_pozycje"
                sql+="   WHERE firma_id='"+self.firma_id+"'"
                sql+="   AND wyznacznik_id='"+str(daneZO[0][0])+"' "
                sql+="   AND data='"+str(daneZO[0][1])+"' "
                sql+="   AND numer='"+str(daneZO[0][2])+"');"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd porwnania dokumentu z zamwieniem: '+stat
                elif len(d) == 0:
                    #na dokumencie nie ma zadnego artykulu z zamowienia,
                    #a zostaly pozycje dodane recznie, wiec trigger nie usunal
                    #powiazania z ZO, wiec trzeba wyczyscic powiazanie
                    UPD="UPDATE rs_dokumenty_magazynowe SET czy_pobrane_z_zamowien=FALSE,"
                    UPD+="zo_wyznacznik_id=NULL,zo_data=NULL, zo_numer=NULL"
                    UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"'"
                    UPD+=" AND dokument_id='"+str(Dokument)+"' AND data = '"+str(Data)+"'"
                    UPD+=" AND numer="+str(Numer)+";"

                    stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
                    if stat != 'OK':
                        stat = 'Bd przy modyfikowaniu dokumentu: '+stat
            
                          
#-------------------------------------------------------------------------------
#                           Funkcja 7    ZMIANA KLUCZA                          
#-------------------------------------------------------------------------------

if Fun == 7 and stat=='OK':  
    if not UprZmianaKlucza:
        stat = 'Brak uprawnie do zmiany klucza.'
        dane.append( stat )

    #AB 20.05.20r
    if stat == 'OK':
        # sprawdzenie czy dokument jest w stanie 'W'
        sql = """SELECT stan
                 FROM rs_dokumenty_magazynowe 
                 WHERE firma_id='{}' AND magazyn_id='{}' AND dokument_id='{}' AND data='{}' AND numer={}
                 ;""".format(self.firma_id, Magazyn, Dokument, Data, Numer)
        stat, TestStan, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(TestStan) == 0:
                stat = u'Nie odnaleziono dokumentu.'
            elif TestStan[0][0] != 'W':
                stat = u"Dokument nie jest w stanie W."
        else:
            stat = u"Bad sprawdzania stanu dokumentu: " + stat
    if stat == 'OK':
        UPD="UPDATE rs_dokumenty_magazynowe_pozycje SET nr_poz = '"+str(PozycjaN)+"' "
        UPD+="WHERE firma_id='"+self.firma_id+"' AND"
        UPD+=" magazyn_id='"+str(Magazyn)+"' AND dokument_id ='"+str(Dokument)+"' AND "
        UPD+="data ='"+str(Data)+"' AND numer ="+str(Numer)+" AND nr_poz="+str(Pozycja)+";"

        UPD+="UPDATE rs_dokumenty_magazynowe_pozycje_lokacje SET nr_poz = '"+str(PozycjaN)+"' "
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND"
        UPD+=" magazyn_id='"+str(Magazyn)+"' AND dokument_id ='"+str(Dokument)+"' AND "
        UPD+=" data ='"+str(Data)+"' AND numer ="+str(Numer)+" AND nr_poz="+str(Pozycja)+";"
        
        stat,dane,wyn1,tr = self.PolSQL.Execute(UPD,1)   
        if stat<>'OK':
            stat = 'Bdy przy zmianie klucza :'+stat
            dane.append(stat)      


#-------------------------------------------------------------------------------
#                           Funkcja 8    ZMIANA NUMERU SERII                    
#-------------------------------------------------------------------------------

if Fun == 8 and stat=='OK':   
    if not UprEdycja:
        stat = 'Brak uprawnie do modyfikacji.'
        dane.append( stat )

    #AB 20.05.20r
    if stat == 'OK':
        # sprawdzenie czy dokument jest w stanie 'W'
        sql = """SELECT stan
                 FROM rs_dokumenty_magazynowe 
                 WHERE firma_id='{}' AND magazyn_id='{}' AND dokument_id='{}' AND data='{}' AND numer={}
                 ;""".format(self.firma_id, Magazyn, Dokument, Data, Numer)
        stat, TestStan, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(TestStan) == 0:
                stat = u'Nie odnaleziono dokumentu.'
            elif TestStan[0][0] != 'W':
                stat = u"Dokument nie jest w stanie W."
        else:
            stat = u"Bad sprawdzania stanu dokumentu: " + stat

    if stat == 'OK':
        UPD="UPDATE rs_dokumenty_magazynowe_pozycje SET nr_serii='"+str(NrSeriiF)+"' "
        if Stan=='G':
            UPD+=",czy_dodatkowy_nr_serii=TRUE "
        UPD+="WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+str(Magazyn)+"' AND "
        UPD+="dokument_id = '"+str(Dokument)+"' AND data = '"+str(Data)+"' AND"
        UPD+=" numer = "+str(Numer)+" AND nr_poz = "+str(Pozycja)+" and nr_ppoz = "+str(PPozycja)+";"   
        stat,dane,wyn1,tr = self.PolSQL.Execute(UPD,1)   
        if stat<>'OK':
            stat = 'Bdy przy zmianie numeru serii :'+stat
            dane.append(stat) 
     
#-------------------------------------------------------------------------------
#                           Funkcja 7,8,9,10  OBSUGA ARTYKUW PRZYJCIA                      
#-------------------------------------------------------------------------------
     
if stat=='OK' and Fun in [7,8,9,10]:
    # odwieenie wirtualnych artykuw przyjcia
    stat=fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Magazyn,Dokument,Data,Numer)
    if stat=='OK':
        stat,dump,dump,LLokacje=fs_dokumenty_magazynowe_lokacje_pom.PodajLokacjeDokumentuLubPozycji(self,Magazyn,Dokument,Data,Numer)
    if stat=='OK':

        sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id = '"+Dokument+"' ;"
        stat,daneT,dump,dump = self.PolSQL.Execute(sql ,3)        
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych o rodzaju dokumentu mag. :'+stat
            dane.append(stat)
        else:
            stat,dane=fs_dokumenty_magazynowe_lokacje_pom.SprawdzListeLokacji(self,LLokacje,daneT[0][0])

#-------------------------------------------------------------------------------
#                    Funkcja 11 UZUPELNIANIE ZEROWYCH ILOSCI
#-------------------------------------------------------------------------------
#AB 12.10.22r
if stat == 'OK' and Fun in [11, ]:
    # Sprawdzenie czy waluta to PLN
    sql = """SELECT waluta
             FROM rs_dokumenty_magazynowe
             WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data=%s AND numer=%s;"""
    args = [self.firma_id, Magazyn, Dokument, Data, Numer]
    args = [str(x) if isinstance(x, unicode) else x for x in args]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
    stat, waluta, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzania waluty na dokumencie: ' + stat
    elif waluta[0][0] != 'PLN':
        stat = 'Funkcjonalno tylko dla dokumentw magazynowych w walucie PLN'

    # Sprawdzenie czy 0 pozycji
    sql = """SELECT COUNT(1) 
             FROM rs_dokumenty_magazynowe_pozycje 
             WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data=%s AND numer=%s;"""
    args = [self.firma_id, Magazyn, Dokument, Data, Numer]
    args = [str(x) if isinstance(x, unicode) else x for x in args]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
    stat, ilosc_pozycji, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzania liczby pozycji: ' + stat
    elif ilosc_pozycji[0][0] != 0:
        stat = 'Na dokumencie znajduj si ju pozycje, nie mona doda przyjcia ujemnych iloci'

    if stat == 'OK':
        # Sprawdzenie czy magazyn detaliczny
        sql = """SELECT detaliczny
                 FROM rs_magazyny 
                 WHERE firma_id=%s AND magazyn_id=%s;"""
        args = [self.firma_id, Magazyn]
        args = [str(x) if isinstance(x, unicode) else x for x in args]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
        stat, czy_detal, dump, dump = self.PolSQL.Execute(sql, 7, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd sprawdzania informacji o magazynie: ' + stat
        elif not czy_detal:
            stat = 'Magazyn {} nie jest detaliczny'.format(Magazyn)

    if stat == 'OK':
        # Sprawdzenie czy typ 'P'
        sql = """SELECT typ_dokumentu
                 FROM rs_typy_dokumentow_m
                 WHERE firma_id=%s AND dokument_id=%s;"""
        args = [self.firma_id, Dokument]
        args = [str(x) if isinstance(x, unicode) else x for x in args]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
        stat, typ_dok, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd sprawdzania typu dokumentu: ' + stat
        elif typ_dok[0][0] != 'P':
            stat = "Dokument {} nie jest typu 'P'(przyjcie)".format(Dokument)

    if stat == 'OK':
        #pobranie ujemnych ilosci z rs_artykuly_magazyny
        sql = """SELECT artykul_id, ilosc1, ilosc2, 
                   CASE WHEN COALESCE(ost_przychod, '9999-01-01') <= %s
                        THEN ost_cena1 
                        ELSE (SELECT cena1 
                              FROM rs_artykuly_przyjecia ap 
                              WHERE (ap.artykul_id, ap.magazyn_id, ap.firma_id) = (am.artykul_id, am.magazyn_id, am.firma_id)
                               AND ap.data <= %s
                              ORDER BY DATA DESC
                              LIMIT 1)
                        END AS cena1, 
                   CASE WHEN COALESCE(ost_przychod, '9999-01-01') <= %s
                        THEN ost_cena2 
                        ELSE (SELECT cena2
                              FROM rs_artykuly_przyjecia ap 
                              WHERE (ap.artykul_id, ap.magazyn_id, ap.firma_id) = (am.artykul_id, am.magazyn_id, am.firma_id)
                               AND ap.data <= %s
                              ORDER BY DATA DESC
                              LIMIT 1)
                        END AS cena2
                 FROM rs_artykuly_magazyny am
                 WHERE firma_id = %s AND  magazyn_id = %s AND ilosc1<0;"""
        args = [Data, Data, Data, Data, self.firma_id, Magazyn]
        args = [str(x) if isinstance(x, unicode) else x for x in args]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
        stat, do_dodania, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania artykuw o ujemnych ilociach: ' + stat
        elif len(do_dodania) == 0:
            stat = 'Brak ujemnych iloci w magazynie {}'.format(Magazyn)
        else:
            INS = ""
            args = []
            poz = 1
            for artykul in do_dodania:  #petla dodajaca pozycje
                art, ilosc1, ilosc2, cena1, cena2 = artykul
                ilosc1 = abs(ilosc1)
                ilosc2 = abs(ilosc2)
                INS += """INSERT INTO rs_dokumenty_magazynowe_pozycje 
                          (firma_id, magazyn_id, data, dokument_id, numer, nr_poz, nr_ppoz, artykul_id, cena1, cena2,  
                           cena_wal1, cena_wal2, ilosc1, ilosc2,  wejscie_data, wejscie_magazyn, termin_przyd)
                          VALUES(%s, %s, %s, %s, %s, %s, 0, %s, %s, %s, 
                                 %s, %s, %s, %s, %s, %s, %s);
                       """
                args += [self.firma_id, Magazyn, Data, Dokument, Numer, poz, art, cena1, cena2,
                         cena1, cena2, ilosc1, ilosc2, Data, Magazyn, Data]
                poz += 1
            args = [str(x) if isinstance(x, unicode) else x for x in args]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INS, args))
            stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd podczas dodawania pozycji: "+ stat

                      
#-------------------------------------------------------------------------------
#                           Funkcja 5    POBIERANIE DANYCH                      
#-------------------------------------------------------------------------------

if Fun == 5 and stat=='OK':   
    Filtr = "(dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+str(Magazyn)+"' "
    Filtr+= "AND dmp.dokument_id='"+str(Dokument)+"' AND dmp.data='"+str(Data)+"' AND dmp.numer="+str(Numer)
    if str(SymbolF) != '':
       Filtr+= " AND dmp.artykul_id LIKE '"+str(SymbolF)+"%'"
    if str(CenaF) != '0.0':
        Filtr+= " AND (dmp.cena1="+str(CenaF)+" OR dmp.cena2="+str(CenaF)+") "
    if str(NrSeriiF) != '':
        Filtr+= " AND dmp.nr_serii LIKE '"+str(NrSeriiF)+"%'"
    Filtr+= ')'
        
    if (str(SymbolF) != '') or (str(CenaF) != '0.0') or (str(NrSeriiF) != ''):
        #pobranie klucza wynikajacego z numerow nowych kluczy
        if Klucze not in ['',[],None]:
            Filtr+= " OR ((dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+str(Magazyn)+"' "
            Filtr+= "AND dmp.dokument_id='"+str(Dokument)+"' AND dmp.data='"+str(Data)+"' "
            Filtr+= "AND dmp.numer="+str(Numer)+" AND jmd1.firma_id='"+self.firma_id+"' AND "
            Filtr+= "jmd2.firma_id='"+self.firma_id+"' ) AND ("
            Pierwszy = True
            for klucz in Klucze:
                if not Pierwszy:
                    Filtr+= " OR "
                else:
                    Pierwszy = False
                Filtr+= "(dmp.nr_poz="+klucz[0]+" AND dmp.nr_ppoz="+klucz[1]+")"
            Filtr+= '))'    
    
    Pola = "dmp.nr_poz,dmp.nr_ppoz,dmp.artykul_id||' - '||rsart.nazwa,"
    Pola+= "dmp.cecha1_opis,dmp.cecha1_wartosc,rsf_podaj_parametry_cechy(dmp.firma_id,dmp.cecha1_opis,dmp.cecha1_wartosc,'opis'),"
    Pola+= "dmp.ilosc1,dmp.cena1,dmp.cena_wal1,"
    Pola+= "jmd1.opis,dmp.ilosc2,dmp.cena2,"
    Pola+= "dmp.cena_wal2,jmd2.opis,nr_serii,"
    Pola+= "termin_przyd,dmp.artykul_id||' - '||rsart.nazwa,dmp.dokument_przych,"
    Pola+=" CASE WHEN dmp.zo_numer>0 AND dmp.zo_wyznacznik_id IS NOT NULL AND dmp.zo_data IS NOT NULL"
    Pola+=" THEN rsf_podaj_numer_dokumentu_na_wydruk(dmp.firma_id,'[\"'||dmp.zo_wyznacznik_id||'\",\"'||dmp.zo_data||'\",\"'||dmp.zo_numer||'\"]', 'F')"
    Pola+=" ||' poz.'||dmp.zo_nr_poz ELSE '' END "
    Pola+=",COALESCE(dmp.lokacja_skad,''),COALESCE(dmp.lokacja_dokad,'')"

    SQL="SELECT "+Pola+" FROM rs_dokumenty_magazynowe_pozycje dmp LEFT OUTER JOIN rs_artykuly rsart "
    SQL+="USING (firma_id,artykul_id) LEFT OUTER JOIN rs_jednostki_miar jmd1 ON "
    SQL+="(dmp.firma_id = jmd1.firma_id AND rsart.jm1=jmd1.kod) LEFT OUTER JOIN rs_jednostki_miar "
    SQL+="jmd2 ON (dmp.firma_id = jmd2.firma_id AND rsart.jm2=jmd2.kod)  "
    SQL+="WHERE "+Filtr+" ORDER BY dmp.nr_poz,dmp.nr_ppoz;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)   
        
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)

    if stat == 'OK':
        #AB 15.06.20r zmieniona nazwa zmiennej przyjmujacej stat by kolejne sprawdzenie nie zmienilo statusu na OK po
        # bledzie w pierwszym
        #sprawdzenie uprawnien do dodawania pozycji dla magazynu i typu dokumentu
        sql="SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"',8);"
        statDodawanie, TestUpr, dump, dump = self.PolSQL.Execute(sql, 3)
        if statDodawanie=='OK':
            if len(TestUpr)==0:
                stat='Bd sprawdzania uprawnie do dodawania pozcyji dla magazynu i typw dokumentw.'
            else:
                wyn2.append(TestUpr[0][0])

        #sprawdzenie uprawnien do usuwania pozycji dla magazynu i typu dokumentu
        sql="SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"',10);"
        statUsuwanie, TestUpr, dump, dump = self.PolSQL.Execute(sql, 3)
        if statUsuwanie=='OK':
            if len(TestUpr)==0:
                stat='Bd sprawdzania uprawnie do usuwania pozycji dla magazynu i typw dokumentw.'
            else:
                wyn2.append(TestUpr[0][0])
        #AB 15.06.20r
        #sprawdzenie czy magazyn jest detaliczny
        sql="SELECT detaliczny FROM rs_magazyny WHERE firma_id=%s AND magazyn_id=%s;"
        args = [self.firma_id, str(Magazyn)]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
        statCzyDetaliczny, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
        if statCzyDetaliczny=='OK':
            if len(Detaliczny)==0:
                stat='Bd sprawdzania czy magazyn jest detaliczny.'
            else:
                wyn2.append(Detaliczny[0][0])
        else:
            stat='Bd sprawdzania czy magazyn jest detaliczny: ' + stat

