# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane pozycji dokumentu magazynowego 
# Author:      Micha Raburski
# Created:     2005/11/08
# RCS-ID:      $Id: fs_dokumenty_magazynowe_pozycje_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2011.02.02 Mariusz Rajfura - nowe pole 'produkt_id' (4223)
#2011.03.24 Mariusz Rajfura - wyswietlenie jednostek miar - bez opisow (4406)
#2011.04.29 Mariusz Rajfura - pobranie inf. o biezacej wartosci pola 'cecha1_opis' dla artykulu,
#                             kontrola przy zapisie pola 'cecha1_opis' z biezaca wart.dla artykulu (4550)
#2011-10-26 Mariusz Rajfura - kontrola stanu przed zapisem (5076)
#2011-11-06 Mariusz Rajfura - zawsze dozwolona edycja pola 'opis' (5178)
#2012-12-16 Mariusz Rajfura    (6366) pobieranie pola cecha1_wartosc_dm z danych kontrahenta lub platnika
#2012-12-20 Mariusz Rajfura    (6386) popr.slq dla pobieranie pola cecha1_wartosc_dm z danych kontrahenta lub platnika (LEFT JOIN)
#2013-05-01 Mariusz Rajfura    (6826) nowe pole 'partia_id'
#2013-06-02 Mariusz Rajfura    (6901) cecha artykulu 'po nowemu', pobranie domyslnej wartosci dla zeslownikowanej cechy, jej kontrola przy zapisie
#2013-06-11 Mariusz Rajfura    (6940) popr.literowki przy pobieraniu danych slownikowych
#2013-07-15 Mariusz Rajfura    (7032) uwzglednienie w edycji: dynamiczny_przelicznik, sledzenie_dostaw
#2014-10-22 Micha Raburski    (8450) refaktoryzacja i opakowania/palety
#2017-09-15 Piotr Witkowski    (10725) Karta przyjcia w pozycjach dokumentu magazynowego
#2017-09-20 Rafa Woniak      (10722) Refaktoryzacjao
#2017-10-31 Rafa Woniak      (10734) zmiana zapisu do logw z 1 na 5
#2018-03-07 Aleksander Bargie (10966) poprawka joina w ostatnim selectcie funkcji 20
#2020-06-15 Aleksander Bargie (12007) [HD] F1 w GM dla magazynu detalicznego

#--- klucze to [Magazyn,Typ,Data,Numer,NrPoz,NrPPoz,Artykul,NumerWymuszanejPozycji,Wersja,Waluta,Polecenie]

# FUNKCJE
# 1 - insert z pobraniem danych
# 2 - insert bez pobrania danych
# 3 - update z pobraniem danych
# 4 - update bez pobrania danych
# 5 - pobranie danych
# 6 - pobranie symbolu artykuu ???
# 7 - pobranie informacji z rs_artykuly_przyjecia
# 8 - pobranie waluty, wersji, wymagania cen w magazynie i typu dokumentu
# 9 - pobranie informacji przy zmianie artykuu
# 10 - pobranie informacji o opakowaniu i palecie
# 11 - pobranie nowego klucza przy dodawaniu
# 12 - sprawdzenie czy magazyn ma wczone lokacje
# 20 - pobranie danych do dokumentw magazynowych pozycji kart przyj
# 25 - modyfikacja dokumentw magazynowych pozycji kart przyj
# 25 - pobranie informacji o cechach


from funkcje import fs_dokumenty_magazynowe_lokacje_pom
from funkcje import fs_dokumenty_magazynowe_rezerwacje_pom
import math

stat='OK'
CzyWMS = False
#AB 15.06.20r
puste = ('', None, 'None', 'NULL')

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Magazyn':[1,2,3,4,5,8,9,10,11,12,20,21],'Dokument':[1,2,3,4,5,8,9,10,11,12,20,21],'Data':[1,2,3,4,5,8,9,10,11,12,20,21],
           'Numer':[1,2,3,4,5,8,9,10,11,12,20,21],'NrPoz':[1,2,3,4,5,12,20,21],'NrPPoz':[1,2,3,4,5,12,20,21],
           'Artykul':[1,2,3,4,6,9,10,25],'NrWymPoz':[1,2,3,4,8,12],'Wersja':[9],'Waluta':[9],'Pozycja':[7],
           'Opakowanie':[10],'Paleta':[10],'Cecha':[10],'CechaKontr':[9],'NowaCecha':[10],}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_zestawy_czesci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,2,3,4,5,6,7,8,9,10,11,12,20,21]:
        Mag=rsglobal.Dekoduj(klucze['Magazyn']).strip()
        Dok=rsglobal.Dekoduj(klucze['Dokument'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Numer=str(klucze['Numer'])
    if Funkcja in [1,2,3,4,5,12,20,21]:
        NrPoz=str(klucze['NrPoz'])
        NrPPoz=str(klucze['NrPPoz'])
    if Funkcja in [1,2,3,4,6,9,10,25]:    
        Artykul=rsglobal.Dekoduj(klucze['Artykul'])        
    if Funkcja in [1,2,3,4,8,12]:    
        NrWymPoz=str(klucze['NrWymPoz'])
        #AB 17.06.20r.
        MagDetalSkad = None
        MagDetalDokad = None
    if Funkcja in [1,3,5]:        
        Wersja=''
        Waluta=''
    if Funkcja == 9:        
        Wersja=rsglobal.Dekoduj(klucze['Wersja'])
        Waluta=rsglobal.Dekoduj(klucze['Waluta'])        
        CechaKontr=rsglobal.Dekoduj(klucze['CechaKontr'])        
    if Funkcja == 7:        
        Pozycja=rsglobal.Dekoduj(klucze['Pozycja'])        
    if Funkcja == 10:
        Opak = rsglobal.Dekoduj(klucze['Opakowanie'])
        Paleta = rsglobal.Dekoduj(klucze['Paleta'])
        Cecha = rsglobal.Dekoduj(klucze['Cecha'])
        NowaCecha = klucze['NowaCecha']
        
    # wiemy e uprawnienie pochodzi z WMS
    if 'WMS' in klucze:
        CzyWMS = klucze['WMS']
        
dane = []
wyn1 = []
wyn2 = []

mag_dokad=''
czy_lokacje_mm=False
MagSkad=''
MagDokad=''
LLokacji=[] 
NowaLokacjaSkad=''           
NowaLokacjaDokad=''
StanDokumentu = ''
            

#-------------------------------------------------------------------------------
#---   DOKUMENTY MAGAZYNOWE POZYCJE KARTY PRZYJECIA 20-pobierz , 21-zapisz
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 21:
    if not ((((self.oddzial_id, '032022') in self.uprawnienia) or (self.oddzial_id, '032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat = 'Brak uprawnie do modyfikowania danych'

    for TC in klucze:
        if stat=='OK' and TC not in ['Magazyn','Dokument','Data','Numer','NrPoz','NrPPoz','Funkcja']:
            kod = klucze[TC][0]
            wartosc = klucze[TC][1]
            typ = klucze[TC][2]
            pole = ''
            SET=''
            SQL="SELECT 1 FROM rs_dokumenty_magazynowe_pozycje_karty_przyjecia "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
            SQL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+" "
            SQL+=" AND nr_poz='"+NrPoz+"' AND nr_ppoz='"+NrPPoz+"' AND kod='"+kod+"';"
            stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                stat = 'Bdy przy sprawdzeniu istnienia kart przyj w pozycjach dokumentu magazynowego :' + stat
                dane.append(stat)
            else:
                if typ.upper() == 'B':
                    pole = 'wart_b'
                    if wartosc in [None, 'None', 'Null', '']:
                        wartosc = 'false'
                    SET = 'wart_b='+str(wartosc) + ", operator="+str(self.operator_id)+" "
                if typ.upper() == 'D':
                    pole = 'wart_d'
                    if wartosc in ['    -  -  ','']:
                        wartosc='null'
                        SET = "wart_d=null, operator="+str(self.operator_id)+" "
                    elif not rsglobal.SprawdzCzyToData(wartosc):
                        stat = "Bdna data"
                    else:
                        SET = "wart_d='"+str(wartosc)+"', operator="+str(self.operator_id)+" "

                if typ.upper() == 'S':
                    pole = 'wart_s'
                    if wartosc =='':
                        wartosc = 'null'
                        SET = "wart_s=null, operator="+str(self.operator_id)+" "
                    else:
                        SET = "wart_s='"+str(wartosc.replace("'",'`').replace("\\",'/'))+"', operator="+str(self.operator_id)+" "
                if typ.upper() == 'N':
                    pole = 'wart_n'
                    SET = "wart_n="+str(wartosc)+", operator="+str(self.operator_id)+" "

                if stat=='OK' and len(d)==0:
                    if wartosc not in [None, 'None', 'Null', 'null', '']:
                        wart = str(wartosc).replace("'",'`').replace("\\",'/')
                        wart = "'"+str(wart)+"'"
                    else:
                        wart = str('null')
                    SQL="INSERT INTO rs_dokumenty_magazynowe_pozycje_karty_przyjecia (firma_id, magazyn_id, dokument_id, "
                    SQL+="data, numer, nr_poz, nr_ppoz, kod, "+pole+", operator) "
                    SQL+="VALUES('"+self.firma_id+"', '"+Mag+"', '"+Dok+"', '"+Data+"','"+Numer+"', '"+NrPoz+"',"
                    SQL+="'"+NrPPoz+"','"+str(kod)+"',"+wart+",'"+str(self.operator_id)+"');"
                    stat, d1, dump, dump = self.PolSQL.Execute(SQL, 1)
                    if stat<>'OK':
                        stat="Bdy dodania karty przyjcia '"+kod+"':"+stat

                if stat=='OK' and len(d)>0:
                    if wartosc<>'null':
                        wart = str(wartosc).replace("'",'`').replace("\\",'/')
                        wart = "'"+str(wart)+"'"
                    else:
                        wart = str(wartosc)
                    SQL="SELECT 1 FROM rs_dokumenty_magazynowe_pozycje_karty_przyjecia "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
                    SQL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+" "
                    SQL+=" AND nr_poz='"+NrPoz+"' AND nr_ppoz='"+NrPPoz+"' AND kod='"+kod+"' "
                    if wart == 'null':
                        SQL+=" AND ("+pole+" is not null);"
                    else:
                        SQL+=" AND ("+pole+"<>"+wart+" or "+pole+" isnull);"
                    stat, d3, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat<>'OK':
                        stat='Bdy sprawdzenia przed modyfikacj:'+stat
                    elif len(d3)>0:
                        SQL="UPDATE rs_dokumenty_magazynowe_pozycje_karty_przyjecia SET "+SET
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
                        SQL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+" "
                        SQL+=" AND nr_poz='"+NrPoz+"' AND nr_ppoz='"+NrPPoz+"' AND kod='"+str(kod)+"';"
                        stat, d1, dump, dump = self.PolSQL.Execute(SQL, 1)
                        if stat<>'OK':
                            stat="Bdy modyfikacji karty przyjcia '"+kod+"':"

#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 20:
    if not (((self.oddzial_id, '032020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat = 'Brak uprawnie do przegldania danych'

    if stat=='OK':
        sql = "SELECT 1 FROM rs_magazyny_dokumenty_parametry "
        sql+="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' ;"
        stat, d, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
        if stat<>'OK':
            stat=u'Bdy sprawdzenia parametrw dokumentw magazynowych'
        elif len(d)==0:
            stat = u'W danym magazynie dla typu dokumentu '+ Dok+u' nie s wykorzystywane karty przyj'

    if stat=='OK':
        sql= "SELECT kp.kod, kp.opis, kp.typ, kp.dlugosc,dmpkp.wart_b,dmpkp.wart_d, dmpkp.wart_s, dmpkp.wart_n, o.login \n"
        sql+="FROM rs_karty_przyjecia kp \n"
        sql+="JOIN rs_dokumenty_magazynowe_pozycje_karty_przyjecia dmpkp on dmpkp.firma_id =kp.firma_id and dmpkp.kod = kp.kod \n"
        sql+="JOIN rs_operatorzy o ON o.operator_id=dmpkp.operator "
        sql+="WHERE dmpkp.firma_id='"+self.firma_id+"' AND dmpkp.magazyn_id='"+Mag+"' AND dmpkp.dokument_id='"+Dok+"' "
        sql+="AND dmpkp.data='"+Data+"' AND dmpkp.numer="+Numer+" AND dmpkp.nr_poz='"+NrPoz+"' AND dmpkp.nr_ppoz='"+NrPPoz+"' \n"
        sql+="AND UPPER(kp.typ) in ('B','D','S','N') ORDER BY kp.typ, kp.kod;"
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bdy przy pobieraniu istniejcych kart przyj :' + stat
            dane.append(stat)

    if stat=='OK' and len(dane)==0:
        sql = "SELECT akp.kod, kp.opis, kp.typ, kp.dlugosc, dmpkp.wart_b,dmpkp.wart_d, dmpkp.wart_s, dmpkp.wart_n, o.login \n"
        sql+= "FROM rs_karty_przyjecia kp \n"
        sql+= "JOIN rs_artykuly_karty_przyjecia akp ON akp.firma_id=kp.firma_id AND akp.kod=kp.kod \n"
        sql+= "JOIN rs_magazyny_dokumenty_parametry mdp ON kp.firma_id=mdp.firma_id AND mdp.karta_przyjecia=True \n"
        sql+= "JOIN rs_dokumenty_magazynowe_pozycje dmp ON dmp.firma_id=kp.firma_id AND dmp.artykul_id=akp.artykul_id "
        sql+= "AND mdp.magazyn_id=dmp.magazyn_id AND mdp.dokument_id=dmp.dokument_id \n"
        sql+= "LEFT JOIN rs_dokumenty_magazynowe_pozycje_karty_przyjecia dmpkp  \n"
        sql+= "ON dmp.firma_id=dmpkp.firma_id and dmp.magazyn_id=dmpkp.magazyn_id and dmp.dokument_id=dmpkp.dokument_id "
        #AB dodanie numeru w joinie                \/
        sql+= "and dmp.data=dmpkp.data AND dmp.numer=dmpkp.numer and dmp.nr_poz=dmpkp.nr_poz and dmp.nr_ppoz=dmpkp.nr_ppoz and dmpkp.kod = akp.kod \n"
        sql+= "LEFT JOIN rs_operatorzy o ON o.operator_id= dmpkp.operator \n"
        sql+="WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Mag+"' AND dmp.dokument_id='"+Dok+"' "
        sql+="AND dmp.data='"+Data+"' AND dmp.numer="+Numer+" AND dmp.nr_poz='"+NrPoz+"' AND dmp.nr_ppoz='"+NrPPoz+"' \n"
        sql+="AND UPPER(kp.typ) in ('B','D','S','N') ORDER BY kp.typ, akp.kod;"
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bdy przy pobieraniu danych kart przyj :' + stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE WARTOSCI PRZY DODAWANIU (11)
#-------------------------------------------------------------------------------

if Funkcja == 11:
    Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND magazyn_id=\\\'"+str(Mag)+"\\\' AND dokument_id=\\\'"+str(Dok)+"\\\' AND data=\\\'"+str(Data)+"\\\' AND numer="+str(Numer)
    sql="SELECT rsf_klucz_where_new('rs_dokumenty_magazynowe_pozycje','"+Warunek+"','nr_poz');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu danych artykuu :'+stat
        dane.append(stat)
    #AB 15.06.20r
    else:
        #sprawdzenie czy magazyn jest detaliczny (11)
        sql = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, Mag)
        stat, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(Detaliczny)==0:
                rsglobal.ZapiszDoLogow(Mag)
                rsglobal.ZapiszDoLogow(Detaliczny)
                rsglobal.ZapiszDoLogow(sql)
                stat = 'Bd sprawdzania czy magazyn jest detaliczny.'
            else:
                wyn2.append(Detaliczny[0][0])
        else:
            rsglobal.ZapiszDoLogow(Mag)
            rsglobal.ZapiszDoLogow(Detaliczny)
            rsglobal.ZapiszDoLogow(sql)
            stat = 'Bd sprawdzania czy magazyn jest detaliczny: ' + stat


#-------------------------------------------------------------------------------
#---   POBRANIE WARTOSCI Z ARTYKULY PRZYJECIA (7)
#-------------------------------------------------------------------------------

if Funkcja == 7:
    sql="SELECT ilosc1-rezerwacja1,cena1,cena_wal1,ilosc2-rezerwacja2,cena2,cena_wal2,"
    sql+="nr_serii,termin_przyd,artykul_id,COALESCE(lokacja_id,'') FROM rs_artykuly_przyjecia WHERE "
    sql+="firma_id = '"+self.firma_id+"' AND magazyn_id='"+str(Pozycja[2])+"' AND data='"+str(Pozycja[1])+"' "
    sql+="AND dokument_id='"+str(Pozycja[3])+"' AND numer="+str(Pozycja[4])+" AND nr_poz="+str(Pozycja[5])
    sql+="AND nr_ppoz="+str(Pozycja[6])+" AND NOT wirtualne;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)        
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu cen :'+stat
        dane.append(stat)   


#-------------------------------------------------------------------------------
#---   POBRANIE WALUTY,WERSJI, WYMAGANIA CEN W MAGAZYNIE, TYPU DOKUMENTU (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat=='OK':
    CechaWartoscDm = ''
    
    wyn2 = []
    SQL ="SELECT dm.waluta,dm.wersja,tdm.typ_dokumentu,"
    
    # przy okazji pobieramy kontrahenta, jego pole cecha1_wartosc_dm i platnika_id,
    # ktry bedzie sprawdzany jesli kontrahent na puste pole cecha1_wartosc_dm
    SQL+=" COALESCE(dm.kontrahent_id,''::TEXT),COALESCE(k.cecha1_wartosc_dm,''::TEXT),"
    SQL+=" COALESCE(k.platnik_id,''::TEXT)"

    SQL+=" FROM rs_dokumenty_magazynowe dm"
    SQL+=" INNER JOIN rs_typy_dokumentow_m tdm USING (firma_id,dokument_id)"
    SQL+=" LEFT JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
    SQL+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Mag+"'"
    SQL+=" AND dm.dokument_id='"+Dok+"' AND dm.data='"+Data+"' AND dm.numer="+Numer+";"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu informacji z nagwka dokumentu: '+stat
        dane.append(stat)
    
    if stat=='OK' and len(dane)==1:
        if dane[0][4] <> '':
            # jesli kontrahent ma wypelnione pole cecha1_wartosc_dm
            CechaWartoscDm = dane[0][4]
            
        elif dane[0][3] <> dane[0][5] and dane[0][5] <> '':
            # jesli kontrahent nie ma wypelnionego pola cecha1_wartosc_dm
            # a posiada innego platnika, to pobierzemy wartosc z platnika
            sql ="SELECT COALESCE(cecha1_wartosc_dm,''::TEXT) FROM rs_kontrahenci"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+rsglobal.Dekoduj(dane[0][5])+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych patnika: '+stat
            elif len(d) == 0:
                stat = 'Brak patnika w katalogu kontrahentw.'
            else:
                CechaWartoscDm = d[0][0]

    if stat == 'OK':
        sql ="SELECT czy_ceny FROM rs_magazyny WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND magazyn_id='"+Mag+"';"
        sql,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu cen w magazynie: '+stat
            dane.append(stat)
        elif len(d) <> 1:
            stat = 'BL MAGAZ'
            dane.append(stat)
        else:
            wyn2.append(d[0][0])
            wyn2.append(CechaWartoscDm)
            

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Funkcja in [1,2]:
    if not (((self.oddzial_id,'032023') in self.uprawnienia) or (CzyWMS and (self.oddzial_id,'701000') in self.uprawnienia and Funkcja == 1) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR INS'
        dane.append(stat) 
               
if Funkcja in [3,4]:
    if not (((self.oddzial_id,'032022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY MAGAZYN MA WCZONE LOKACJE (12)
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4,5,12] and stat=='OK':
    czy_lokacje=False
    typ_dokumentu=''
    czy_lokacje_mm=False
    mag_dokad=''
    czy_grid_lokacji=False
    
    # sprawdzam czy magazyn ma wczone lokacje 
    sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+Mag+"' ;"
    stat,daneL,dump,dump = self.PolSQL.Execute(sql ,3)  
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu danych o lokacjach :'+stat
        dane.append(stat) 
    
    if stat=='OK': 
        czy_lokacje=daneL[0][0]        
        sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id = '"+Dok+"' ;"        
        stat,daneT,dump,dump = self.PolSQL.Execute(sql ,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych o rodzaju dokumentu mag. :'+stat
            dane.append(stat)
    
    if stat=='OK':
        typ_dokumentu=daneT[0][0]
        sql="SELECT magazyn_dokad,magazyn_skad FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' "
        sql+="AND magazyn_id='"+Mag+"' AND dokument_id = '"+Dok+"' AND data = '"+str(Data)+"' AND numer = "+str(Numer)+";"
        stat,daneMM,dump,dump = self.PolSQL.Execute(sql ,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu informacji o lokacjach :'+stat
            dane.append(stat)    
        else:
            MagSkad=daneMM[0][1]
            MagDokad=daneMM[0][0]
            
        if typ_dokumentu=='M': # spr czy 2 magazyn w mm-ce ma wczone lokacje
            if stat=='OK':
                mag_dokad=daneMM[0][0]
                sql="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+str(mag_dokad)+"' ;"
                stat,daneML,dump,dump = self.PolSQL.Execute(sql ,3)  
                if stat<>'OK':
                    stat = 'Bd przy pobieraniu danych o lokacjach :'+stat
                    dane.append(stat)     
                else:
                    czy_lokacje_mm=daneML[0][0]
        
    if stat=='OK':
        #sprawdzenie, czy pozycja posiada grid z lokacjami
        sql ="SELECT COUNT(*) > 0 FROM rs_dokumenty_magazynowe_lokacje"
        sql+="  WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
        sql+=" AND data = '"+str(Data)+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych dotyczcych lokacji pozycji'+stat
            dane.append(stat)
        else:
            czy_grid_lokacji = d[0][0]
                    
    if Funkcja == 12 and stat=='OK':    
        dane = [czy_lokacje, typ_dokumentu, czy_lokacje_mm, mag_dokad, czy_grid_lokacji]
    elif Funkcja in [1,3,5]:
        DaneLokacji = [czy_lokacje, typ_dokumentu, czy_lokacje_mm, mag_dokad, czy_grid_lokacji]

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (1,2 - insert; 3,4 update)
#-------------------------------------------------------------------------------

if (Funkcja in [1,2,3,4]) and (stat=="OK"):
    # kontrola stanu
    
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
    sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak dokumentu o podanym kluczu.'
        dane.append(stat)
    else:
        StanDokumentu = rsglobal.Dekoduj(d[0][0])

    if stat == 'OK' and StanDokumentu <> 'W':
        if Funkcja in [1,2]:
            stat = 'Dokument w stanie '+StanDokumentu+'. Dodawanie pozycji niemoliwe.'
            dane.append(stat)
        
        elif StanDokumentu == 'G':
            # w stanie G dozwolona edycja pol: nr_serii, opis
            for i in xrange(len(pola)):
                if not pola[i] in ['nr_serii','opis']:
                    stat = 'Dokument w stanie '+StanDokumentu+'. Zapis zmian niemoliwy.'
                    dane.append(stat)
                    break
        else:
            # w pozostalych stanach dowolona edycja pol: opis
            for i in xrange(len(pola)):
                if not pola[i] in ['opis']:
                    stat = 'Dokument w stanie '+StanDokumentu+'. Zapis zmian niemoliwy.'
                    dane.append(stat)
                    break
    
if Funkcja in [1,2,3,4] and stat == "OK":
    PolaDod=[]
    WartDod=[]
    #AB 15.06.20r
    MagDetal = False
    typdok = ''
    
    #pobranie informacji czy podany magazyn uzywa cen na dokumentach
    CzyCeny = True #AB 15.06.20r
    sql = "SELECT czy_ceny, detaliczny FROM rs_magazyny WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Mag+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o stosowaniu cen w magazynie: '+stat
        dane.append(stat)
    elif len(d) <> 1:
        stat = 'BL MAGAZ'
        dane.append(stat)
    else:
        CzyCeny = d[0][0]
        
    #Pobranie typu dokumentu
    stat,typd,typn,dump = self.PolSQL.Execute("SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';" ,3)    
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu typu :'+stat
        dane.append(stat) 
    else:      
        trtyp = rssql.RSTableRowset(typd,typn)
        typdok=trtyp.GetVal(0,"typ_dokumentu")
    
    if stat =='OK':
        Ilosc1 = 0
        IloscLok=0 # ilo uwzgldniana przy lokacjach
        JestIlosc = False
    
        #Pobranie danych artykuu
        art=Artykul
        if art == '':
            stat = "BR ART"
            dane.append(stat)
            
    if stat=='OK':
        sql ="SELECT a.czy_seria AS czy_seria,a.czy_termin AS czy_termin,a.typ_artykulu AS typ_artykulu,"
        sql+=" a.aktywny AS aktywny,a.cecha1_opis AS cecha1_opis,a.wydanie_proporcjonalne AS wydanie_proporcjonalne,"
        sql+=" a.jm_kalk::INT AS jm_kalk,jm1.calkowita AS calk1,jm2.calkowita AS calk2, tylko_detal, " #AB 15.06.20r
        sql+=" NOT tylko_detal AND NOT czy_detal AS nie_detal"
        sql+=" FROM rs_artykuly a INNER JOIN rs_jednostki_miar jm1 ON(jm1.firma_id=a.firma_id AND jm1.kod = a.jm1) "
        sql+=" INNER JOIN rs_jednostki_miar jm2 ON(jm2.firma_id=a.firma_id AND jm2.kod = a.jm2)"
        sql+=" WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+art+"';"

        stat,artd,artn,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bdy przy sprawdzaniu danych :'+stat
            dane.append(stat)  
        elif len(artd) == 0:
            stat = "BL ART"
            dane.append(stat)
        elif not artd[0][3]:
            stat = "ART AKT"
            dane.append(stat)
        
        if stat =='OK':    
            # sprawdzenie czy na poziomie magazynu nie jest wczone jednorazowe wystpowanie artykuu na dokumencie magazynowym
            if 'artykul_id' in pola:
                # sprawdzenie czy jest to wczone w magazynach
                SQL = "SELECT COALESCE(ms.jednoraz_art_na_dokum,FALSE) OR COALESCE(md.jednoraz_art_na_dokum,FALSE), "
                SQL+= " ms.detaliczny, md.detaliczny " #AB 15.06.20r
                SQL+= " FROM rs_dokumenty_magazynowe dm LEFT OUTER JOIN rs_magazyny ms ON (ms.firma_id = dm.firma_id AND ms.magazyn_id = dm.magazyn_id) "
                SQL+= " LEFT OUTER JOIN rs_magazyny md ON (md.firma_id = dm.firma_id AND md.magazyn_id = dm.magazyn_dokad) "
                SQL+= " WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Mag+"' AND dm.dokument_id='"+Dok+"' AND dm.data='"+Data+"' AND dm.numer="+Numer
                stat,DJednor,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat =='OK':
                    if DJednor[0][0]:
                        SQL = "SELECT nr_poz FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id 
                        SQL+= "' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+" AND artykul_id='"+art+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                        if stat<>'OK':
                            stat = 'Bdy przy pobieraniu numeru pozycji 2:'+stat
                            dane.append(stat)  
                        elif len(d) >0:
                            stat = "UZ ART"
                            dane.append(stat)
                    #AB 15.06.20r
                    MagDetalSkad  = DJednor[0][1]
                    MagDetalDokad = DJednor[0][2]
            
        if stat=='OK':    
            trart = rssql.RSTableRowset(artd,artn)
            czysart=trart.GetVal(0,"czy_seria")
            czytart=trart.GetVal(0,"czy_termin")
            typart=trart.GetVal(0,"typ_artykulu")
            calkjm1=trart.GetVal(0,"calk1")
            calkjm2=trart.GetVal(0,"calk2")
            #AB 15.06.20r
            tylko_detal=trart.GetVal(0,"tylko_detal")
            nie_detal=trart.GetVal(0,"nie_detal")
            
            cechaopis = rsglobal.Dekoduj(trart.GetVal(0,"cecha1_opis")).strip()
            if cechaopis in ('None','NULL'):
                cechaopis = ''
            #AB 15.06.20r
            #Artykuly tylko do magazynow detalicznych
            if tylko_detal:
                if MagSkad not in puste and MagDetalSkad not in puste and not MagDetalSkad:  # Magazyn skad niepusty i nie detaliczny
                    stat = "Artyku {} moe zosta dodany do dokumentu magazynowgo " \
                           "jedynie w magazynie detalicznym. Magazyn {} nie jest detaliczny.".format(Artykul, MagSkad)
                    dane.append(stat)
                if MagDokad not in puste and MagDetalDokad not in puste and not MagDetalDokad:  # Magazyn dokad niepusty i nie detaliczny
                    stat = "Artyku {} moe zosta dodany do dokumentu magazynowgo " \
                           "jedynie w magazynie detalicznym. Magazyn {} nie jest detaliczny.".format(Artykul, MagDokad)
                    dane.append(stat)
            if nie_detal:  # Artykuly NIE dla magazynow detalicznych
                if MagSkad not in puste and MagDetalSkad not in puste and MagDetalSkad:  # Magazyn skad niepusty i detaliczny
                    stat = "Artyku {} nie moe zosta dodany do dokumentu magazynowgo " \
                           "w magazynie detalicznym {}".format(Artykul, MagSkad)
                    dane.append(stat)
                if MagDokad not in puste and MagDetalDokad not in puste and MagDetalDokad:  # Magazyn dokad niepusty i detaliczny
                    stat = "Artyku {} nie moe zosta dodany do dokumentu magazynowgo " \
                           "w magazynie detalicznym {}".format(Artykul, MagDokad)
                    dane.append(stat)

            if typart =='31':
                stat = "BL TYPART"
                dane.append(stat)
            if typart =='99':
                stat = "BL TYPART2"
                dane.append(stat)
                
            # wydanie proporcjonalne
            if trart.GetVal(0,"typ_artykulu") and typdok in ['W','M']:
                wydanieprop = trart.GetVal(0,"jm_kalk")
            else:
                wydanieprop = 0
            
        if stat=='OK':
            for i in range(len(pola)):
                if stat =='OK':
                    pole = pola[i]
                    wart = wartosci[i]
                    rsglobal.ZapiszDoLogow('pole '+pole+' wart '+str(wart),5)
    
                    if pole == 'ilosc1':
                        JestIlosc = True
                        Ilosc1 = wart
                        if wart <= 0 and not wydanieprop == 2:
                            stat = "BL IL1"
                            dane.append(stat)
                        elif calkjm1 and int(wart) <> wart:
                            stat = "BL CALKIL1"
                            dane.append(stat)
                        else:
                            # zapis ilosci jesli byla zmieniana ( jesli nie to przekazywane dalej 0 )
                            ilosc=wart
                            if self.lokacje_jm=='1':
                                IloscLok=wart
                            if not 'ilosc2' in pola:
                                PolaDod.append('ilosc2')
                                WartDod.append(wart)                            
                                if self.lokacje_jm=='2':
                                    IloscLok=wart
            
                    if pole == 'ilosc2':
                        if wart <= 0 and not wydanieprop == 1:
                            stat = "BL IL2"
                            dane.append(stat)
                        elif calkjm2 and int(wart) <> wart:
                            stat = "BL CALKIL2"
                            dane.append(stat)
                        else:
                            if self.lokacje_jm=='2':
                                IloscLok=wart
            
                    if pole == 'cena1':
                        if typdok == 'P':
                            if wart <= 0:
                                if CzyCeny:
                                    stat = "BL CENA1"
                                    dane.append(stat)
                            elif wart == 0:
                                PolaDod.append('czy_cena')
                                WartDod.append(False)
                            else:
                                PolaDod.append('czy_cena')
                                WartDod.append(True)
                        if not ('cena2' in pola) and wart >=0:
                            PolaDod.append('cena2')
                            WartDod.append(wart)
            
                    if pole == 'cena2':
                        if typdok == 'P':
                            if wart <= 0:
                                if CzyCeny:
                                    stat = "BL CENA2"
                                    dane.append(stat)
                            
                    if pole == 'cena_wal1':
                        if not ('cena_wal2' in pola):
                            PolaDod.append('cena_wal2')
                            WartDod.append(wart)
            
            
                    if pole == 'nr_serii':
                        if czysart:
                            if typdok == 'P':
                                if wart =='':
                                    stat = "BR SERIA"
                                    dane.append(stat)
    
                        if wart == '':
                            PolaDod.append('czy_seria')
                            WartDod.append(False)
                        else:
                            PolaDod.append('czy_seria')
                            WartDod.append(True)
    
    
                    if pole == 'termin_przyd':
                        if wart =='    -  -  ':
                            if typdok == 'P':
                                if czytart:
                                    stat = "BR TERMIN"
                                    dane.append(stat)
                        else:
                            #sprawdzenie poprawnosci daty
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = "BL TERMIN"
                                dane.append(stat)
    
                    if pole == 'cecha1_opis':
                        if rsglobal.Dekoduj(wart).strip() <> cechaopis:
                            stat = 'BL CECHA ART'
                            dane.append(stat)
                            
                    if pole == 'cecha1_wartosc':
                        if wart == '':
                            if cechaopis <> '':
                                stat = 'BL CECHA MUSI MIEC WARTOSC'
                                dane.append(stat)
                        else:
                            # czy cecha ma zdefiniowane wartosci
                            # jesli nie, to mozna wpisac dowolna wartosc
                            sql ="SELECT wartosc FROM rs_artykuly_cechy_wartosci"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+cechaopis+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia listy wartoci dla cechy: '+stat
                            elif len(d) > 0:
                                # poniewaz cecha ma zdefiniowane wartosci, to czy podana wartosc jest poprawna
                                sql ="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+cechaopis+"','"+wart+"','poprawna');"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'Bd sprawdzenia wartoci cechy: '+stat
                                else:
                                    Wynik=eval(d[0][0])
                                    if not Wynik[0]:
                                        stat = Wynik[1]
                                        dane.append(stat)
    
                    if pole == 'lokacja_skad':
                        wart = rsglobal.Dekoduj(wart).strip()
                        if wart not in ['',None,'None']:
                            SQL ="SELECT magazyn_id FROM rs_lokacje"
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id = '"+str(wart)+"' ;"
                            stat,daneLL,dump,dump = self.PolSQL.Execute(SQL ,3)        
                            if stat <> 'OK':
                                stat = 'Bd przy sprawdzaniu lokacji SKD: '+stat
                                dane.append(stat)
                            elif len(daneLL) <> 1:
                                stat = 'BL LOK_SKAD'
                                dane.append(stat)
                            elif not daneLL[0][0] in [None,'None','',MagSkad]:
                                stat = 'BR MAG_LOK_SKAD'
                                dane.append(stat)
                            else:
                                NowaLokacjaSkad=wart
    
                    if pole == 'lokacja_dokad':
                        wart = rsglobal.Dekoduj(wart).strip()
                        #sprawdzamy czy podana lokacja istnieje i jesli lokacja posiada przypisany magazyn,
                        #sprawdzamy, czy jest zgodny z magazynem dokumentu
                        if stat == 'OK' and not wart in ['',None,'None']:
                            SQL="SELECT magazyn_id FROM rs_lokacje "
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id = '"+str(wart)+"' ;"
                            stat,daneLL,dump,dump = self.PolSQL.Execute(SQL ,3)
                            if stat<>'OK':
                                stat = 'Bd przy sprawdzaniu lokacji dokd'
                                dane.append(stat)  
                            elif len(daneLL)==0: 
                                stat = "BL LOK_DOKAD"
                                dane.append(stat)   
                            elif not daneLL[0][0] in [None,'None','',MagDokad]:
                                stat = 'BR MAG_LOK_DOKAD'
                                dane.append(stat)
                            else:
                                NowaLokacjaDokad=wart
                        
                    if pole =='nr_poz':
                        if Funkcja in [1,2]:
                            if wart < 1:
                                stat = "BL NR"
                                dane.append(stat)
                            else:
                                stat,d,n,dump = self.PolSQL.Execute("SELECT nr_poz FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id +
                                    "' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz+";" ,3)
                                if stat<>'OK':
                                    stat = 'Bdy przy pobieraniu numeru :'+stat
                                    dane.append(stat)  
                                else:
                                    if (len(d) <> 0) and (NrWymPoz==None):
                                        stat = "UZ NR"
                                        dane.append(stat)
        
                    if pole == 'produkt_id':
                        wart = rsglobal.Dekoduj(wart).strip()
                        if not wart in ['',None,'None']:
                            SQL="SELECT artykul_id FROM rs_artykuly "
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzenia produktu_wiodcego: '+stat
                                dane.append(stat)  
                            elif len(d)==0: 
                                stat = "BL PRODUKT"
                
                
                    if pole == 'partia_id':
                        if wart < 0:
                            stat = 'BL PARTIA'
                            dane.append(stat)
                        elif wart > 0:
                            sql ="SELECT * FROM rs_produkcja_plan"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(wart)+";"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia numeru partii w planie produkcji: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR PARTIA'
                                dane.append(stat)
                
                    if pole == 'opakowanie_id':
                        # sprawdzenie czy opakowanie istnieje
                        if wart <> '':
                            SQL="SELECT opakowanie_id FROM rs_artykuly_opakowania_zbiorcze "
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND opakowanie_id = '"+wart+"'"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia opakowania w opakowaniach zbiorczych: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL OPAK'
                                dane.append(stat)
                                
                    if pole == 'paleta_id':
                        # sprawdzenie czy paleta istnieje
                        if wart <> '':
                            SQL="SELECT paleta_id FROM rs_palety "
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND paleta_id = '"+wart+"'"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia opakowania w opakowaniach zbiorczych: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL PALETA'
                                dane.append(stat)
                                
            for i in range(len(PolaDod)):
                pola.append(PolaDod[i][0])
                wartosci.append(PolaDod[i][1])
        
        #czy byly jakies bledy
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
        
    # zdjcie iloci do pobrania z lokacji
    if stat=='OK' :
        # pobranie listy lokacji, ktre bd sprawdzane (wszystkie z pozycji)
        stat,dump,dump,LLokacji=fs_dokumenty_magazynowe_lokacje_pom.PodajLokacjeDokumentuLubPozycji(self,Mag,Dok,Data,Numer,NrPoz)
        if NowaLokacjaSkad<>'' and not NowaLokacjaSkad in LLokacji:
            LLokacji.append(NowaLokacjaSkad)
        if NowaLokacjaDokad<>'' and not NowaLokacjaDokad in LLokacji:
            LLokacji.append(NowaLokacjaDokad)
    if stat=='OK':
        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Numer,NrPoz,'-')   
      

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Funkcja in [1,2]:
    if stat == 'OK':
        #sprawdzenie uprawnien do magazynu i typu dokumentu
        sql="SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Mag+"','"+Dok+"',8);"
        stat, TestUpr, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat=='OK':
            if len(TestUpr)==0:
                stat='Bd sprawdzania uprawnie do magazynu i typw dokumentw.'
            elif not TestUpr[0][0]:
                stat= "Brak uprawnie do wstawiania pozycji dokumentu."

    if stat == 'OK':
        ins = "INSERT INTO rs_dokumenty_magazynowe_pozycje"
        Pola="firma_id,magazyn_id,dokument_id,data,numer"
        Wartosci="'"+self.firma_id+"','"+Mag+"','"+Dok+"','"+Data+"',"+Numer
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['artykul_id','nr_serii','dokument_przych','opis']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
                
            elif pole in ['lokacja_skad','lokacja_dokad','cecha1_opis','cecha1_wartosc','produkt_id',
                'opakowanie_id','paleta_id']: 
                Pola= Pola+","+pole
                if wart<>'':
                    Wartosci= Wartosci+",'"+wart+"'"
                else:                 
                    Wartosci= Wartosci+",NULL"

            elif pole in ['ilosc1','ilosc2','cena1','cena2','cena_wal1','cena_wal2','czy_cena','czy_seria',
                          'nr_poz','nr_ppoz','partia_id','wsp_ilosci_opakowanie','wsp_ilosci_paleta','wsp_ilosci_lokacja']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            elif pole in ['termin_przyd']:
                Pola= Pola+","+pole
                if wart=='    -  -  ':
                    Wartosci= Wartosci+",NULL"
                else:
                    Wartosci= Wartosci+",'"+wart+"'"

        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"
        
        #ewentualne przenumerowanie
        if NrWymPoz <> 'None' and stat=='OK':
            SQL="SELECT max(nr_poz) FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND magazyn_id = '"+Mag+"' AND dokument_id = '"+Dok+"' AND data = '"+Data+"'"
            SQL+=" AND numer = "+Numer+" AND nr_poz >= "+NrWymPoz+";" 
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                Licznik=int(d[0][0])
                while Licznik>=float(NrWymPoz):
                    Upd=" UPDATE rs_dokumenty_magazynowe_pozycje SET nr_poz=nr_poz+1 "
                    Upd+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id = '"+Mag+"' AND dokument_id = '"+Dok+"'"
                    Upd+=" AND data = '"+Data+"' AND numer = "+Numer+" AND nr_poz = "+str(Licznik)+" ;"
                    stat,dump,dump,dump = self.PolSQL.Execute(Upd,1)
                    Licznik=Licznik-1
            if stat<>'OK':
                stat = 'Bdy przy przenumerowaniu pozycji :'+stat
                dane.append(stat)  
                
        if stat == 'OK':
            stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
            if stat<>'OK':
                stat = 'Bdy przy dodawaniu danych :'+stat
                dane.append(stat)  
            else:
                # woenie rezerwacji przy dokumencie C
                stat=fs_dokumenty_magazynowe_rezerwacje_pom.ZmienRezerwacjeNaArtPrzyjDokumentC(self,[Mag,Dok,Data,Numer],[[int(NrPoz),int(NrPPoz)]],'+')
                    
                    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Funkcja in [3,4]:
    if stat == 'OK':
        #sprawdzenie uprawnien do edycji pozycji dla magazynu i typu dokumentu (10)
        sql="SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Mag+"','"+Dok+"',9);"
        stat, TestUpr, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat=='OK':
            if len(TestUpr)==0:
                stat='Bd sprawdzania uprawnie do magazynu i typw dokumentw.'
            elif not TestUpr[0][0]:
                stat= "Brak uprawnie do edycji pozycji dokumentu."


    # zdjcie rezerwacji przy dokumencie C
    if stat=='OK':
        stat=fs_dokumenty_magazynowe_rezerwacje_pom.ZmienRezerwacjeNaArtPrzyjDokumentC(self,[Mag,Dok,Data,Numer],[[int(NrPoz),int(NrPPoz)]],'-')

    if stat =='OK':
        where = " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer ="+Numer
        where +=" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz+";"
        upd = "UPDATE rs_dokumenty_magazynowe_pozycje SET "

        usuwac=False

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id',]:
                usuwac=True
            if pole in ['artykul_id','nr_serii','dokument_przych','opis']:
                upd=upd+pole+"='"+wart+"',"
            elif pole in ['ilosc1','ilosc2','cena1','cena2','cena_wal1','cena_wal2',
                'czy_cena','czy_seria','nr_poz','nr_ppoz','partia_id','wsp_ilosci_opakowanie','wsp_ilosci_paleta','wsp_ilosci_lokacja']:
                upd=upd+pole+"="+str(wart)+","
            elif pole in ['termin_przyd']:
                if wart=='    -  -  ':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+wart+"',"
            elif pole in ['lokacja_skad','lokacja_dokad','cecha1_opis','cecha1_wartosc','produkt_id',
                'opakowanie_id','paleta_id']:
                if wart=='':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+wart+"',"
                    
        upd = upd[0:len(upd)-1]+where
        if usuwac:
            upd += " DELETE FROM rs_dokumenty_magazynowe_pozycje_karty_przyjecia " + where

        if stat == 'OK':
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
            if stat<>'OK':
                stat = 'Bdy przy modyfikowaniu danych :'+stat
                dane.append(stat)  
            else:
                stat=fs_dokumenty_magazynowe_rezerwacje_pom.ZmienRezerwacjeNaArtPrzyjDokumentC(self,[Mag,Dok,Data,Numer],[[int(NrPoz),int(NrPPoz)]],'+')


if Funkcja in [1,2,3,4] and stat=="OK" and StanDokumentu == 'W':
    # po edycji kontrola obslugi dynamicznego przelicznika i sledzenia dostaw
    if stat == 'OK':
        sql ="SELECT dmp.artykul_id,a.dynamiczny_przelicznik,a.sledzenie_dostaw,"
        sql+=" tdm.typ_dokumentu, TRIM(COALESCE(dmp.dokument_przych,''))"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp "
        sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        sql+=" INNER JOIN rs_typy_dokumentow_m tdm USING(firma_id,dokument_id)"
        sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Mag+"'"
        sql+=" AND dmp.dokument_id='"+Dok+"' AND dmp.data='"+Data+"'"
        sql+=" AND dmp.numer="+Numer+" AND dmp.nr_poz="+NrPoz+" AND dmp.nr_ppoz="+NrPPoz+";"
        
        stat,Poz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania zapisanych danych: '+stat
        elif Poz[0][1]:
            # kontrola, czy pozycja posiada lokacje w tabeli rs_dokumenty_magazynowe_lokacje
            sql ="SELECT * FROM rs_dokumenty_magazynowe_lokacje "
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
            sql+=" AND dokument_id='"+Dok+"' AND data='"+Data+"'"
            sql+=" AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz+";"
            stat,LokPoz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych z lokacji dla pozycji: '+stat
            elif len(LokPoz) > 0:
                stat = 'BL DYNAM_PRZEL_WIELO_LOK'
        
        if stat == 'OK' and Poz[0][2] and Poz[0][3] in ('W','M','L') and Poz[0][4] == '':
            # sledzenie dostaw wymusza podanie w dokumencie rozchowym konkretnego przyjecia
            stat = 'BL SLEDZ_DOST_BRAK_PRZYJECIA'


if Funkcja in [1,2,3,4] and stat=="OK" and not StanDokumentu in ('Z','K'):
    # obrbka dziaa na lokacjach  i opakowaniach/paletach
    # uzupenienie wspczynnika paletowego na dokumencie magazynowym
    if stat == 'OK':
        # jeli pozycja z WMS to wszystkie wspczynniki w pozycji spoliczone. Jeli z Anakondy to pobieramy wspczynnik lokacyjny
        stat = fs_dokumenty_magazynowe_lokacje_pom.UstawWspIIloscLokacyjnaNaDM(self,Mag,Dok,Data,Numer,NrPoz,NrPPoz,CzyWMS)
    if stat == 'OK' and typdok == 'P':
        # sprawdzenie czy dla dokumentw przychodowych s dobrze dobrane pary opakowanie/paleta
        SQL = "SELECT nr_poz,nr_ppoz FROM rs_dokumenty_magazynowe_pozycje"
        SQL+= " WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        SQL+= " AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)
        SQL+= " AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)
        SQL+= " AND NOT opakowanie_id IS NULL AND NOT paleta_id IS NULL "
        SQL+= " AND (wsp_ilosci_opakowanie = 0 OR wsp_ilosci_paleta = 0)"
        stat, DTest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat<> 'OK':
            stat = 'Bdy sprawdzania poprawnoci opakowa/palet :'+stat
        
        if stat == 'OK':
            if len(DTest) > 0:
                stat = "Dla opakowania/palety nie ma zdefiniowanej pozycji w opakowaniach zbiorczych o podanych parametrach"
                
    if stat == 'OK':
        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Numer,NrPoz,'+',False,True)   
    # odwieenie wirtualnych artykuw przyjcia
    if stat=='OK':
        stat=fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Mag,Dok,Data,Numer)
    if stat=='OK' and typdok <>'W':
        stat,dane=fs_dokumenty_magazynowe_lokacje_pom.SprawdzListeLokacji(self,LLokacji,typdok)
    if stat=='OK':
        stat=fs_dokumenty_magazynowe_lokacje_pom.SprawdzIlosciWArtykPrzyj(self,Mag,Dok,Data,Numer,NrPoz)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Funkcja in [1,3,5] and stat=='OK':
    # pobranie danych magazynowych
    Artykul = ''
    SQL = "SELECT * FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
    SQL+= " AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer
    SQL+= " AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz+";"
    rsglobal.ZapiszDoLogow('SQL '+str(SQL),5)
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('dane '+str(dane),5)
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu danych magazynowych :'+stat
        dane.append(stat)  
        
    #pobranie danych do opisow
    elif len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        Artykul = tr.GetVal(0,"artykul_id")

        # produkt opis (0)
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"produkt_id")+"';" ,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu opisu produkt wiodcego :'+stat
                dane.append(stat) 
            else: 
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        # -- lokacja skad (1)
        if ((self.oddzial_id,'014000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+tr.GetVal(0,"lokacja_skad")+"';" 
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu opisu lokacji skd :'+stat
                dane.append(stat) 
            else: 
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania lokacji.')
        
        # --lokacja dokad (2)
        if ((self.oddzial_id,'014000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+tr.GetVal(0,"lokacja_dokad")+"';" 
            stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu opisu lokacji dokd :'+stat
                dane.append(stat) 
            else: 
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania lokacji.')
        
        # cecha z pozycji (a nie z artykuu) (3,4)
        if tr.GetVal(0,"cecha1_opis").strip() == '':
            wyn2.append('')
            wyn2.append('')
        else:
            if ((self.oddzial_id,'017010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                sql = "SELECT opis FROM rs_artykuly_cechy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"cecha1_opis")+"';" 
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu opisu cechy nr 1 :'+stat
                    dane.append(stat) 
                else: 
                    if len(d) == 0:
                        wyn2.append('')
                        wyn2.append('')
                    else:
                        wyn2.append(tr.GetVal(0,"cecha1_opis").strip())
                        wyn2.append(rsglobal.Dekoduj(d[0][0]).strip())
            else:
                wyn2.append('BR UPR')            
                wyn2.append('Brak uprawnie do przegldania cech artykuu.')            
        
        # cecha domylna dla kontrahenta lub patnika z dokumentu (5)
        CechaWartoscDm = ''

        sql =" SELECT COALESCE(dm.kontrahent_id,''),COALESCE(k.cecha1_wartosc_dm,''),"
        sql+=" COALESCE(k.platnik_id,'')"
        sql+=" FROM rs_dokumenty_magazynowe dm"
        sql+=" LEFT JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
        sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Mag+"'"
        sql+=" AND dm.dokument_id='"+Dok+"' AND dm.data='"+Data+"' AND dm.numer="+Numer+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu informacji z nagwka dokumentu: '+stat
            #AB 15.06.20r
            dane.append(stat)
        elif d[0][1] <> '':
            # jesli kontrahent ma wypelnione pole cecha1_wartosc_dm
            CechaWartoscDm = d[0][1]
        elif d[0][0] <> d[0][2] and d[0][2] <> '':
            # jesli kontrahent nie ma wypelnionego pola cecha1_wartosc_dm
            # a posiada innego platnika, to pobierzemy wartosc z platnika
            sql ="SELECT COALESCE(cecha1_wartosc_dm,'') FROM rs_kontrahenci"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+rsglobal.Dekoduj(d[0][2])+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych patnika: '+stat
                #AB 15.06.20r
                dane.append(stat)
            elif len(d) == 0:
                stat = 'Brak patnika w katalogu kontrahentw.'
                #AB 15.06.20r
                dane.append(stat)
            else:
                CechaWartoscDm = d[0][0]
        
        wyn2.append(CechaWartoscDm)
        
        # dane lokacji z funkcji 12 (6)
        wyn2.append(DaneLokacji)
        
        # zalepka na dane artykuu (7)
        wyn2.append([])
        
        # pobranie opisu opakowania (8)
        if ((self.oddzial_id,'011170') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"opakowanie_id")+"';" 
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu opisu opakowania :'+stat
                dane.append(stat) 
            else: 
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania opakowa zbiorczych.')
            
        # pobranie opisu palety (9)
        if ((self.oddzial_id,'014110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_palety WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+tr.GetVal(0,"paleta_id")+"';" 
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu opisu palety :'+stat
                dane.append(stat) 
            else: 
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania palet.')

        #sprawdzenie uprawnien do edycji pozycji dla magazynu i typu dokumentu (10)
        sql="SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Mag+"','"+Dok+"',9);"
        stat, TestUpr, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat=='OK':
            if len(TestUpr)==0:
                stat='Bd sprawdzania uprawnie do magazynu i typw dokumentw.'
                #AB 15.06.20r
                dane.append(stat)
            else:
                wyn2.append(TestUpr[0][0])
        #AB 15.06.20r
        else:
            dane.append(stat)

        #AB 15.06.20r
        #sprawdzenie czy magazyn jest detaliczny (11)
        sql = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, Mag)
        stat, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(Detaliczny)==0:
                rsglobal.ZapiszDoLogow(Mag)
                rsglobal.ZapiszDoLogow(Detaliczny)
                rsglobal.ZapiszDoLogow(sql)
                stat = 'Bd sprawdzania czy magazyn jest detaliczny.'
                dane.append(stat)
            else:
                wyn2.append(Detaliczny[0][0])
        else:
            rsglobal.ZapiszDoLogow(Mag)
            rsglobal.ZapiszDoLogow(Detaliczny)
            rsglobal.ZapiszDoLogow(sql)
            stat = 'Bd sprawdzania czy magazyn jest detaliczny: ' + stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ARTYKUU (1,3,5,9)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,3,5,9]:
    from funkcje import fs_artykuly_pom
    stat,DArt = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self,Artykul,'',Data,0,'',Wersja,Waluta,1,'',True)
    
    # pobranie typu dokumentu
    if stat == 'OK' and len(DArt) > 0:
        SQL="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"'"
        stat,DDok,dump,dump = self.PolSQL.Execute(SQL ,3)   
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu typu dokumentu :'+stat
        if stat == 'OK':        
            if not DDok[0][0] in ('W','M'):
                DArt[22] = 0
            
            # sprawdzamy, czy w tym magazynie pobierac ceny
            SQL = "SELECT czy_ceny FROM rs_magazyny WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Mag+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu informacji o cenach w magazynie :'+stat
    
        if stat == 'OK':        
            if not d[0][0]:
                DArt[11] = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
        
    if Funkcja in [1,3,5]:
        # dane artykuu (7)
        if len(wyn2) >= 7:
            wyn2[7] = DArt
    else:
        dane = [DArt]

#-------------------------------------------------------------------------------
#---   POBRANIE INFORMACJI O OPAKOWANIU/PALECIE (9,10)
#-------------------------------------------------------------------------------

if Funkcja in [9,10] and stat =='OK':
    # pobranie kontrahenta z dokumentu
    SQL= "SELECT COALESCE(kontrahent_id,'') FROM rs_dokumenty_magazynowe "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
    SQL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer+";"
    stat,DKontr,dump,dump = self.PolSQL.Execute(SQL ,3)        
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu kontrahenta :'+stat
    
    if stat == 'OK':
        from funkcje import fs_dokumenty_magazynowe_pom
        # jeli tylko pobieramy dane o opakowaniu/palecie
        if Funkcja == 10:
            stat,dane = fs_dokumenty_magazynowe_pom.PodajOpisIIlosciOpakowaniaIPalety(self,Artykul,Cecha,DKontr[0][0],Opak,Paleta,NowaCecha)
        # jeli pobieramy te dane dla domylnych wartoci z artykuu
        elif Funkcja == 9:
            # sprawdzenie czy cecha idzie z kontrahenta czy z artykuu domylna
            CechaOp = ''
            if CechaKontr <> '':
                CechaOp = CechaKontr
            elif DArt <> []:
                CechaOp = DArt[7][3]
                
            stat,DOpak = fs_dokumenty_magazynowe_pom.PodajOpisIIlosciOpakowaniaIPalety(self,Artykul,CechaOp,DKontr[0][0],'','',True)
            if stat =='OK':
                dane.append(DOpak)