# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_pozycje_nr_serii.py
# Purpose:     wczytuje dane / importuje z pliku list numerw serii do dokumentu magazynowego
#
# Author:      Micha Raburski
# Created:     2008/03/12
# RCS-ID:      $Id: fs_dokumenty_magazynowe_pozycje_nr_serii.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-10-26 Mariusz Rajfura - kontrola stanu przed zapisem (5076)
# 2011-11-30 Micha Raburski - zdjcie kontroli stanu przed zapisem (5240)

#klucze = [magazyn,dokument,data,numer,funkcja]


Fun=klucze[-1]

Mag=rsglobal.Dekoduj(klucze[0])
Dok=rsglobal.Dekoduj(klucze[1])
Data=rsglobal.Dekoduj(klucze[2])
Nr=str(klucze[3])

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
# Kontrola uprawnien
#-------------------------------------------------------------------------------

UprIns=(self.oddzial_id,'032023') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#   IMPORT NUMERW SERII Z PLIKU - FUNKCJA 9
#-------------------------------------------------------------------------------

if Fun == 9:    
    if not UprIns:
        stat="UPR INS"   
        dane.append(stat)

    if stat == 'OK':
        wiersze=rsglobal.rseval(klucze[4])
        
        #-----------------------------------
        # SPRAWDZENIE POPRAWNOCI DANYCH
        #-----------------------------------
        
        #lista z numerami seryjnymi. Sprawdzane czy si nie powtarzaj.
        LNum=[]
        #Sownik z artykuami i z iloci numerw. Sprawdzane czy zgadza si ilo numerw z iloci na pozycji
        SArt={}
        for w in wiersze:
            if stat=='OK':
                ArtOK=True
                Art=rsglobal.Dekoduj(w[0]).strip()
                stat,d,dump,dump=self.PolSQL.Execute("SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'",3)
            if stat =='OK':
                #sprawdzenie istnienia artykuu
                if len(d)==0:
                    buf='BR ART$'+Art
                    if not buf in dane:
                        dane.append(buf)
                    ArtOK=False
    
            if stat=='OK' and ArtOK:    
                #przejscie po numerach seryjnych
                if not Art in SArt.keys():
                    # w pierwszej kolumnie - ilo numerw, w drugiej - ilosc na pozycjach
                    SArt[Art]=[0,0]

                for nr in w:
                    if nr.strip() not in ('',Art) and stat=='OK':
                        if nr in LNum:
                            dane.append('POWT NUM$'+nr)
                        else:
                            #sprawdzenie czy dany numer serii nie wystpuje na innym dokumencie
                            KlPom="[\"'||magazyn_id||'\",\"'||dokument_id||'\",\"'||data||'\",'||numer||']"
                            sql="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','"+KlPom+"','M') "
                            sql+=" FROM rs_dokumenty_magazynowe_numery_serii WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
                            sql+=" AND nr_serii='"+nr.strip()+"';"
                            rsglobal.ZapiszDoLogow(sql)
                            stat,dpom,dump,dump=self.PolSQL.Execute(sql,3)
                            if stat=='OK':
                                if len(dpom)>0:
                                    dane.append('NUM POZ$'+nr.strip()+' wystpuje na dokumencie '+dpom[0][0])
                                LNum.append(nr)
                                SArt[Art][0]=SArt[Art][0]+1

        #sprawdzenie czy zgadzaj si iloci numerw i czy artykuy w ogle wystpuj
        if stat=='OK' and len(SArt.keys())>0:
            SQL="SELECT artykul_id,sum(ilosc1) FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' "
            SQL+="AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Nr+" AND artykul_id IN ("+str(SArt.keys())[1:-1]+") GROUP BY artykul_id ORDER BY artykul_id"
            stat,Dane,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=="OK":
                 for d in Dane:
                     Art=d[0].strip()
                     if Art in SArt.keys():
                         SArt[Art][1]=d[1]

            for art in SArt.keys():
                if SArt[art][0] <> SArt[art][1]:
                    dane.append('BL IL$'+art.strip()+'. Na pozycjach - '+str(SArt[art][1])+' , numerw serii - '+str(SArt[art][0]))
            
        
        #------------------------------------
        # IMPORT WACIWY
        #------------------------------------
        if stat=='OK' and len(dane)==0:
            SQL="DELETE FROM rs_dokumenty_magazynowe_numery_serii WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Nr+";"
            for w in wiersze:
                Art=rsglobal.Dekoduj(w[0])
                #przejscie po numerach seryjnych
                for nr in w:
                    if nr not in ('',Art):
                        SQL+="INSERT INTO rs_dokumenty_magazynowe_numery_serii (firma_id,magazyn_id,dokument_id,data,numer,artykul_id,nr_serii)"
                        SQL+=" VALUES ('"+self.firma_id+"','"+Mag+"','"+Dok+"','"+Data+"',"+Nr+",'"+Art+"','"+rsglobal.Dekoduj(nr.strip())+"');"

            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)


#-------------------------------------------------------------------------------
#   POBRANIE DANYCH DO TABELKI - FUNKCJE 5,9
#-------------------------------------------------------------------------------

if (Fun in [5]) and stat=='OK':
    Sel=" SELECT ns.artykul_id,a.nazwa,ns.nr_serii FROM rs_dokumenty_magazynowe_numery_serii ns" 
    Sel+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE ns.firma_id = '" + self.firma_id+"' "
    Sel+=" AND ns.magazyn_id='"+Mag+"' AND ns.dokument_id='"+Dok+"' AND ns.data='"+Data+"' AND ns.numer="+Nr
    Sel+=" ORDER BY ns.artykul_id,ns.nr_serii;"	
 
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(Sel,3)
    if stat!="OK":
        stat="BL SQL PRZ$"+stat
        dane.append(stat)
