# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_produkcja_pom.py
# Purpose:     funkcje pomocnicze do obsugi produkcji w dokumentach magazynowych
# Author:      Mariusz Rajfura
# Created:     2011/02/18
# RCS-ID:      $Id: fs_dokumenty_magazynowe_produkcja_pom.py$
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#2011.02.18 - Mariusz Rajfura - modyf.il.prod.w zam.odb.na pdst.produkcji G->Z,Z->G (4229)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---- MODYFIKACJA ILOSCI WYPRODUKOWANEJ W ZAMOWIENIACH ODBIORCOW 
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

def ZmienIlosciWyprodukoweNaZamowieniachOdbiorcow(self,KluczDok,Znak):
    import rsglobal

    Mag = str(KluczDok[0])
    Dok = str(KluczDok[1])
    Data = str(KluczDok[2])
    Numer = str(KluczDok[3])
    
    sql ="SELECT czy_wplywa_na_zamowienia FROM rs_typy_dokumentow_m"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return 'Bd pobrania informacji o dokumencie: '+stat
    elif len(d) == 0:
        return 'Brak dokumentu typu '+Dok
    elif not d[0][0]:
        return 'OK'
    
    sql ="SELECT dmp.artykul_id, SUM(dmp.ilosc1), SUM(dmp.ilosc2), a.przelicznik, a.dynamiczny_przelicznik"
    sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
    sql+=" INNER JOIN rs_dokumenty_magazynowe dm USING(firma_id,magazyn_id,dokument_id,numer)"
    sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND a.typ_artykulu='02'"
    sql+=" AND dmp.magazyn_id='"+Mag+"' AND dmp.dokument_id='"+Dok+"'"
    sql+=" AND dmp.data='"+Data+"' AND dmp.numer="+Numer
    if Znak == '+':
        #dodawanie do zamowien, jesli dokument magazynowe wszedl w stan Z
        sql+=" AND dm.stan='Z'"
    else:
        #zdejmowanie z zamowien, jesli dokument magazynowy cofnity do stanu G
        sql+=" AND dm.stan='G'"
        
    sql+=" GROUP BY dmp.artykul_id, a.przelicznik, a.dynamiczny_przelicznik;"
    
    stat,dDokMPoz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return 'Bd pobrania pozycji dokumentu magazynowego: '+stat
    elif len(dDokMPoz) == 0:
        #brak pozycji do modyfikacji zamowien
        return 'OK'
    
    ArtS = {}
    Artykuly = ''
    for i in xrange(len(dDokMPoz)):
        ArtS[dDokMPoz[i][0]] = [dDokMPoz[i][1], dDokMPoz[i][2], dDokMPoz[i][3], dDokMPoz[i][4]]
        if i > 0:
            Artykuly += ","
        Artykuly += "'"+rsglobal.Dekoduj(dDokMPoz[i][0])+"'"
    #print 'ArtS przed   ',ArtS
    sql ="SELECT zop.artykul_id, zop.wyznacznik_id, zop.data, zop.numer, zop.nr_poz,"
    sql+=" zop.ilosc1, zop.ilosc2, zop.wyprodukowano1, zop.wyprodukowano2"
    sql+=" FROM rs_zamowienia_odbiorcy_pozycje zop"
    sql+=" INNER JOIN rs_zamowienia_odbiorcy zo"
    sql+="  ON (zo.firma_id=zop.firma_id AND zo.wyznacznik_id=zop.wyznacznik_id"
    sql+="      AND zo.data=zop.data AND zo.numer=zop.numer)"
    sql+=" WHERE zop.firma_id='"+self.firma_id+"' AND zo.stan='G'"
    sql+=" AND zop.artykul_id IN ("+Artykuly+")"
    if Znak == '+':
        sql+=" AND zop.ilosc1>zop.wyprodukowano1 AND zop.ilosc2>zop.wyprodukowano2"
    else:
        sql+=" AND zop.wyprodukowano1>0 AND zop.wyprodukowano2>0"
    
    if Znak == '+':
    #od najstarszego
        sql+=" ORDER BY zop.data, zop.wyznacznik_id, zop.numer, zop.nr_poz"
    else:
        sql+=" ORDER BY zop.data DESC, zop.wyznacznik_id DESC, zop.numer DESC, zop.nr_poz DESC"
        #jesli zdemowanie to od najmlodszego
        
    sql+=" FOR UPDATE NOWAIT;"
    
    stat,dZamPoz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return 'Bd pobrania pozycji zamwie :'+stat
    elif len(dZamPoz) == 0:
        #brak pozycji zamowien do modyfikacji
        return 'OK'
    
    # rozkladamy ilosci pobrane z dokumentu magazynowego
    # na poszczegolne pozycje zamowien
    UPD = ''
    
    for i in xrange(len(dZamPoz)):
        Ilosc1, Ilosc2, Przelicznik, DynamPrzel = ArtS[dZamPoz[i][0]]

        if Ilosc1 > 0 and Ilosc2 > 0:
            # zostala ilosc do rozlozenia na pozycje zamowienia
            
            if Znak == '+':
                # powiekszamy wyprodukowane jesli mniejsze od zamowionej
                if dZamPoz[i][7] < dZamPoz[i][5]:
                    # wyprodukowano1 < ilosc1
                    IleMozna1 = min(Ilosc1, dZamPoz[i][5]-dZamPoz[i][7])
                    if  DynamPrzel:
                        IleMozna2 = min(Ilosc2, dZamPoz[i][6]-dZamPoz[i][8])
                    else:
                        IleMozna2 = rsglobal.RSRound(IleMozna1*Przelicznik,4)
                    
                    UPD+=" UPDATE rs_zamowienia_odbiorcy_pozycje"
                    UPD+=" SET wyprodukowano1=wyprodukowano1+"+str(IleMozna1)
                    UPD+="    ,wyprodukowano2=wyprodukowano2+"+str(IleMozna2)
                    UPD+=" WHERE firma_id='"+self.firma_id+"'"
                    UPD+=" AND wyznacznik_id='"+rsglobal.Dekoduj(dZamPoz[i][1])+"'" 
                    UPD+=" AND data='"+rsglobal.Dekoduj(dZamPoz[i][2])+"'" 
                    UPD+=" AND numer="+str(dZamPoz[i][3])
                    UPD+=" AND nr_poz="+str(dZamPoz[i][4])+"; "
                    
                    ArtS[dZamPoz[i][0]] = [Ilosc1-IleMozna1, Ilosc2-IleMozna2, Przelicznik, DynamPrzel]
                    
                    dZamPoz[i][7] += IleMozna1
                    dZamPoz[i][8] += IleMozna2

            else:
                #pomniejszamy wyprodukowano
                if dZamPoz[i][7] > 0:
                    # wyprodukowano1 > 0
                    IleMozna1 = min(Ilosc1, dZamPoz[i][7])
                    if  DynamPrzel:
                        IleMozna2 = min(Ilosc2, dZamPoz[i][8])
                    else:
                        IleMozna2 = rsglobal.RSRound(IleMozna1*Przelicznik,4)
                
                    UPD+=" UPDATE rs_zamowienia_odbiorcy_pozycje"
                    UPD+=" SET wyprodukowano1=wyprodukowano1-"+str(IleMozna1)
                    UPD+="    ,wyprodukowano2=wyprodukowano2-"+str(IleMozna2)
                    UPD+=" WHERE firma_id='"+self.firma_id+"'"
                    UPD+=" AND wyznacznik_id='"+rsglobal.Dekoduj(dZamPoz[i][1])+"'" 
                    UPD+=" AND data='"+rsglobal.Dekoduj(dZamPoz[i][2])+"'" 
                    UPD+=" AND numer="+str(dZamPoz[i][3])
                    UPD+=" AND nr_poz="+str(dZamPoz[i][4])+"; "
                    
                    ArtS[dZamPoz[i][0]] = [Ilosc1-IleMozna1, Ilosc2-IleMozna2, Przelicznik, DynamPrzel]
                    
                    dZamPoz[i][7] -= IleMozna1
                    dZamPoz[i][8] -= IleMozna2
            
    if Znak == '+':
        # jesli powiekszamy produkcje, to w przypadku nierozlozenie calosci
        # asortymentu powiekszamy 'wyprodukowano' dla ostatniego wystapienia
        # artykulu w zamowieniach, czyli najmlodszego
        
        for Art in ArtS:
            #Ilosc1, Ilosc2, Przelicznik, DynamPrzel = ArtS[Art]
            Ilosc1, Ilosc2, Przelicznik, DynamPrzel = ArtS[Art]
            if (Ilosc1 > 0 and Ilosc2 > 0) or (DynamPrzel and (Ilosc1 > 0 or Ilosc2 > 0)):
                for i in xrange(len(dZamPoz)-1,-1,-1):
                    if dZamPoz[i][0] == Art:
                        UPD+=" UPDATE rs_zamowienia_odbiorcy_pozycje"
                        UPD+=" SET wyprodukowano1=wyprodukowano1+"+str(Ilosc1)
                        UPD+="    ,wyprodukowano2=wyprodukowano2+"+str(Ilosc2)
                        UPD+=" WHERE firma_id='"+self.firma_id+"'"
                        UPD+=" AND wyznacznik_id='"+rsglobal.Dekoduj(dZamPoz[i][1])+"'" 
                        UPD+=" AND data='"+rsglobal.Dekoduj(dZamPoz[i][2])+"'" 
                        UPD+=" AND numer="+str(dZamPoz[i][3])
                        UPD+=" AND nr_poz="+str(dZamPoz[i][4])+"; "
                        break
                    
    if UPD <> '':
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            return 'Bd modyfikacji pozycji zamowie: '+stat
    
    return 'OK'