# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_rezerwacje_pom.py
# Purpose:     funkcje pomocnicze do obsugi rezerwacji_w_artykulach_przyjecia
# Author:      Micha Raburski
# Created:     2011/02/16
# RCS-ID:      $Id: fs_dokumenty_magazynowe_rezerwacje_pom.py$
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- OBSUGA BLOKOWANIA/ZDEJMOWANIA REZERWACJI W DOKUMENTACH TYPU C
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

# Funkcja zmieniajca warto rezerwacji w przyjciach artykuu, ktre s pobrane na
# dokument typu C. Jeli podane s klucze pozycji to zmienia na pozycji. Jeli nie to 
# zmienia dla wszystkich pozycji dokumentu.
# Znak - zmienia na 0, znak + zmienia na ilo aktualn.

def ZmienRezerwacjeNaArtPrzyjDokumentC(self,KluczDok,KluczePoz,Znak):
    import rsglobal
    stat='OK'
    Mag=str(KluczDok[0])
    Dok=str(KluczDok[1])
    Data=str(KluczDok[2])
    Numer=str(KluczDok[3])

    if Znak=='-':
        WartRez1='0'
        WartRez2='0'
    else:
        WartRez1='ilosc1'
        WartRez2='ilosc2'    
        
    # Sprawdzenie czy dokument jest typu C    
    SQL="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHErE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"';"
    stat, DTyp, dump, dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return stat
    
    if DTyp[0][0]<>'C':
        return "OK"
    
    # pobranie kluczy z artykuw przyjcia
    SQL="SELECT COALESCE(dokument_przych,''),artykul_id,ilosc1,ilosc2"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+Numer
    if KluczePoz<>[]:
        SQL+=" AND ("
        for kl in KluczePoz:
            SQL+=" (nr_poz="+rsglobal.UsunKropkaZero(kl[0])+" AND nr_ppoz="+rsglobal.UsunKropkaZero(kl[1])+") OR"
        # ucicie ostatniego OR
        SQL=SQL[:-2]
        SQL+=")"
    SQL+=" FOR UPDATE NOWAIT;"
        
    stat, DPrzyjecia, dump, dump = self.PolSQL.Execute(SQL,3)
    
    if stat<>'OK':
        return stat
                
    for poz in DPrzyjecia:
        DokPrzych = rsglobal.Dekoduj(poz[0]).strip()
        if DokPrzych=='':
            return "OK"
        
        DokAP = DokPrzych[6:8]
        DataAP = DokPrzych[8:18]
        NumerAP = DokPrzych[18:22]
        PozAP = DokPrzych[22:26]
        PPozAP = DokPrzych[26:30]  
        
        Art=rsglobal.Dekoduj(poz[1]).strip()
        Ilosc1=str(poz[2])
        Ilosc2=str(poz[3])
        
        # update rs_artykuly_przyjecia
        SQL="UPDATE rs_artykuly_przyjecia SET rezerwacja1="+WartRez1+",rezerwacja2="+WartRez2
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND data='"+DataAP+"'"
        SQL+=" AND dokument_id='"+DokAP+"' AND numer="+NumerAP+" AND nr_poz="+PozAP+" AND nr_ppoz="+PPozAP+";"
        # update rs_artykuly_magazyny
        SQL+=" UPDATE rs_artykuly_magazyny SET rezerwacja1=rezerwacja1"+Znak+Ilosc1+",rezerwacja2=rezerwacja2"+Znak+Ilosc2
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND magazyn_id='"+Mag+"';"
        # update rs_artykuly
        SQL+=" UPDATE rs_artykuly SET rezerwacja1=rezerwacja1"+Znak+Ilosc1+",rezerwacja2=rezerwacja2"+Znak+Ilosc2
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            return stat
    
    return "OK"