# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_rw_z_pw.py
# Purpose:     Tworzenie dok.magaz.RW z dok.magaz.PW
# Author:      Mariusz Rajfura
# Created:     2011/02/08
# RCS-ID:      $Id: fs_dokumenty_magazynowe_rw_z_pw.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-02-25 Mariusz Rajfura - uzupelnienie 'produk_id' w tworzonym RW (4318)
# 2011-03-09 Mariusz Rajfura - blad tworz.RW bez pozycji w mag.bez.cen, magazyn_skad (4343)
# 2011-03-23 Mariusz Rajfura - pozycje w RW w kolejnosci artykulow z dok.PW,
#                              sort.wg.skladnikow, nie sumowa ilosci dla tej samej receptury (4398)
# 2011-05-12 Mariusz Rajfura - pobranie domyslnych parametrow dla tworzonych dokumentow (4578)
# 2011-12-07 Mariusz Rajfura - popr.zachowanie kolejnosci pozycji RW wg pozycji z PW (5219)
# 2013-02-12 Mariusz Rajfura   (6522)  Tworzenie RW z receptury
# 2024-01-31 Wojciech Skowron  (13629) Pobieranie receptur dla oddziau pobranego z magazynu PW zamiast self.oddzial_id


#-------------------------------------------------------------------------------

def PodajReceptureDlaArtykulu(PolSQL,Firma,Oddzial,Artykul,Data):
    import rsglobal
    
    ReceptNag = []
    ReceptPoz = []

    Oddz = Oddzial
    # pobieram recepture dla oddzialu
    # jako wazniejsza niz recepture dla wszystkich oddzialow
    sql ="SELECT data_od,ilosc1,ilosc2"
    sql+=" FROM rs_receptury"
    sql+=" WHERE firma_id='"+Firma+"' AND oddzial_id='"+Oddz+"'"
    sql+=" AND stan='Z' AND artykul_id='"+Artykul+"' AND data_od<='"+Data+"'"
    sql+=" ORDER BY data_od DESC LIMIT 1;"
        
    stat,ReceptNag,dump,dump = PolSQL.Execute(sql,3)
    if stat != 'OK':
        return 'Bd pobrania nagwka receptury: '+stat,RecepNag,ReceptPoz
    
    if stat == 'OK' and len(ReceptNag) == 0:
        # jesli nie bylo receptury dla oddzialu, w ktorym zalogowany jest operator
        # probujemy pobrac recepture ogolna dla wszystkich oddzialow
        
        Oddz = '**'
        sql ="SELECT data_od,ilosc1,ilosc2"
        sql+=" FROM rs_receptury"
        sql+=" WHERE firma_id='"+Firma+"' AND oddzial_id='"+Oddz+"'"
        sql+=" AND stan='Z' AND artykul_id='"+Artykul+"' AND data_od<='"+Data+"'"
        sql+=" ORDER BY data_od DESC LIMIT 1;"

        stat,ReceptNag,dump,dump = PolSQL.Execute(sql,3)
        if stat != 'OK':
            return 'Bd pobrania nagwka receptury: '+stat,RecepNag,ReceptPoz
    
    if stat=='OK' and len(ReceptNag) > 0: 
        # pobranie pozycji receptury dla artykulu
        sql ="SELECT skladnik_id,COALESCE(magazyn_id,''::TEXT),ilosc1,ilosc2,0,0"
        sql+=" FROM rs_receptury_pozycje"
        sql+=" WHERE firma_id='"+Firma+"' AND oddzial_id='"+Oddz+"'"
        sql+=" AND artykul_id='"+Artykul+"'"
        sql+=" AND data_od='"+rsglobal.Dekoduj(ReceptNag[0][0])+"'"
        sql+=" ORDER BY skladnik_id;"
        
        stat,ReceptPoz,dump,dump = PolSQL.Execute(sql,3)
        if stat != 'OK':
            return 'Bd pobrania pozycji receptury: '+stat,RecepNag,ReceptPoz
    
    return 'OK',ReceptNag,ReceptPoz

#-------------------------------------------------------------------------------


from funkcje import fs_magazyny_parametry_dokumentow_pom

MagPW = rsglobal.Dekoduj(klucze[0])
DokPW = rsglobal.Dekoduj(klucze[1])
DataPW = rsglobal.Dekoduj(klucze[2])
NrPW = rsglobal.Dekoduj(klucze[3])

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDod = (((self.oddzial_id,'032013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
# POBRANIE RECEPTURY DLA ARTYKULU (2)
#-------------------------------------------------------------------------------

if Fun == 2:
    Mag = rsglobal.Dekoduj(klucze[0]).strip()  #WS 2024-01-31
    Art = rsglobal.Dekoduj(klucze[1]).strip()
    Data = rsglobal.Dekoduj(klucze[2])

    #WS 2024-01-31 - pobranie oddziau z magazynu
    if stat=='OK':
        sql ="SELECT oddzial_id FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania oddziau dla magazynu: '+stat
            dane.append(stat)
        else:
            OddzialMag = d[0][0]

    if stat == 'OK' and rsglobal.SprawdzCzyToData(Data) and Art != '':
        #WS 2024-01-31 - OddzialMag zamiast self.oddzial_id
        stat,dane,wyn1 = PodajReceptureDlaArtykulu(self.PolSQL,self.firma_id,OddzialMag,Art,Data)
    

#-------------------------------------------------------------------------------
# TWORZENIE DOKUMENTOW RW Z RECEPTURY (3)
#-------------------------------------------------------------------------------

if Fun == 3:
    if not UprDod:
        stat = 'BR UPR DOD'
        dane.append(stat)

    if stat=='OK':
        Mag = rsglobal.Dekoduj(klucze[0]).strip()
        Art = rsglobal.Dekoduj(klucze[1]).strip()
        Data = rsglobal.Dekoduj(klucze[2])
        Ilosc = rsglobal.Dekoduj(klucze[3])

    if stat=='OK':
        if Art == '':
            stat = 'BR ART'
            dane.append(stat)
    
    if stat=='OK':
        sql ="SELECT typ_artykulu,przelicznik,przelicznik_odwr FROM rs_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND aktywny;"
        stat,DaneArt,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych artykulu: '+stat
            dane.append(stat)
        elif len(DaneArt) == 0:
            stat = 'BL ART'
            dane.append(stat)
        elif not DaneArt[0][0] in ['02','03']:
            # tylko produkt, element
            stat = 'BL ART TYP'
            dane.append(stat)
            
    if stat=='OK':
        if Ilosc <= 0:
            stat = 'BL ILOSC'
            dane.append(stat)

    #WS 2024-01-31 - pobranie oddziau z magazynu
    if stat=='OK':
        if Mag != '':
            sql ="SELECT oddzial_id FROM rs_magazyny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania oddziau dla magazynu: '+stat
                dane.append(stat)
            elif len(d) == 0:
                stat = 'BL MAG'
                dane.append(stat)
            else:
                OddzialMag = d[0][0]
        else:
            stat = 'BR MAG'
            dane.append(stat)

    if stat=='OK':
        #WS 2024-01-31 - OddzialMag zamiast self.oddzial_id
        stat,ReceptNag,ReceptPoz = PodajReceptureDlaArtykulu(self.PolSQL,self.firma_id,OddzialMag,Art,Data)
        if stat != 'OK':
            dane.append(stat)
    
    if stat=='OK':
        if len(ReceptPoz) == 0:
            stat = 'BR RECEPTURY'
            dane.append(stat)

    #WS 2024-01-31 - sprawdzenie magazynu wyej
    # if stat=='OK':
    #     if Mag != '':
    #         sql ="SELECT magazyn_id FROM rs_magazyny"
    #         sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
    #         stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    #         if stat != 'OK':
    #             stat = 'Bd sprawdzenia magazynu: '+stat
    #             dane.append(stat)
    #         elif len(d) == 0:
    #             stat = 'BL MAG'
    #         else:
    #             Mag = rsglobal.Dekoduj(d[0][0])
    
    if stat=='OK':
        for i in xrange(len(ReceptPoz)):
            if ReceptPoz[i][1] == '':
                # w recepturze nie podano magazynu wiec musi byc podany przez operatora
                # if Mag == '':
                #     stat = 'BR MAG'
                #     dane.append(stat)
                #     break
                # else:
                # wstawiamy magazyn podany przez operatora i sprawdzony
                ReceptPoz[i][1] = Mag


    if stat=='OK':
        SMagazyny = {}
        Ilosc1Art = Ilosc
        Ilosc2Art = rsglobal.RSRound(Ilosc1Art/DaneArt[0][1],4)
        Przel1Art = ReceptNag[0][1]
        Przel2Art = ReceptNag[0][2]
        
        for i in xrange(len(ReceptPoz)):
            Sklad = rsglobal.Dekoduj(ReceptPoz[i][0])
            MagSklad = rsglobal.Dekoduj(ReceptPoz[i][1])
            Ilosc1Sklad = rsglobal.RSRound(Ilosc1Art/Przel1Art*ReceptPoz[i][2],4)
            Ilosc2Sklad = rsglobal.RSRound(Ilosc2Art/Przel2Art*ReceptPoz[i][3],4)
            
            if not MagSklad in SMagazyny:
                SMagazyny[MagSklad] = []
            
            # kolejna pozycja dla magazynu
            PozDokMag = SMagazyny[MagSklad]
            PozDokMag.append([Sklad,Ilosc1Sklad,Ilosc2Sklad,Art])
            
            # do slownika z magazynami
            SMagazyny[MagSklad] = PozDokMag

        # pobranie danych, potrzebych do wypelnienia dok.RW
        # jesli dokumenty mialyby byc od razu zamykane lub 
        # przygotowane do szybkiego zamkniecia, to bedzie potrzebne
        # ustalenie konfiguracji
        Wersja = 'NULL'
        Kontrahent = 'NULL'
        Dokument = 'RW'
      
        # czy dwie jednostki miary
        sql ="SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o stosowaniu dwch jednostek miar: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak firmy o podanym kodzie '+self.firma_id
            dane.append(stat)
        else:
            DwieJM = d[0][0]    
            
    if stat == 'OK':
        # lista utworzonych dokumentow
        LDokNag = []
        
        INS = ''
        
        for Magazyn in SMagazyny:
            Pozycje = SMagazyny[Magazyn]

            # pobranie domyslnych parametrow dla dokumentu w magazynie
            SParam = {}
            SParam['wersja'] = ''
            SParam['kontrahent_id'] = ''
            stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Magazyn,Dokument,SParam)
            if stat != 'OK':
                dane.append(stat)
                break
            
            Wersja = SParam['wersja']
            Kontrahent = SParam['kontrahent_id']
            
            if Wersja in ('','NULL'):
                Wersja = 'NULL'
            else:
                Wersja = "'"+Wersja+"'"
                
            if Kontrahent in ('','NULL'):
                Kontrahent = 'NULL'
            else:
                Kontrahent = "'"+Kontrahent+"'"

            # czy w magazynie pobierac ceny
            sql ="SELECT czy_ceny FROM rs_magazyny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"
    
            sql,dStosCeny,dump,dump = self.PolSQL.Execute(sql,2)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o stosowaniu cen w magazynie '+Magazyn
                dane.append(stat)
                break
            elif len(d) != 1:
                stat = 'Bdny numer magazynu '+Magazyn
                dane.append(stat)
                break

            # czy mozna dodac dokument z podana data do magazynu
            sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"',"
            sql+="'[\\\'"+Magazyn+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','M');"            

            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if d[0][0] != 'OK':    
                stat = 'Do magazynu '+Magazyn+' nie mona doda dokumentu z dat '+Data
                dane.append(stat)
                break

            # pobranie numeru dla nowego dokumentu
            sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
            sql+="'[\\\'"+Magazyn+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','M');"

            stat,dNumer,dump,dump = self.PolSQL.Execute(sql,3)
            if dNumer[0][0] in (None,'None',''):
                stat = 'Bd pobrania nowego numeru dla '+Dokument+' z magazynu '+Magazyn
                dane.append(stat)
                break

            INS+="INSERT INTO rs_dokumenty_magazynowe"
            INS+=" (firma_id, magazyn_id, dokument_id,"
            INS+=" data, numer, wersja,"
            INS+=" magazyn_skad, kontrahent_id)"
            INS+=" VALUES "
            INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"',"
            INS+="'"+Data+"',"+str(dNumer[0][0])+","+Wersja+","
            INS+="'"+Magazyn+"',"+Kontrahent+"); "
            
            LDokNag.append([Magazyn,Dokument,Data,int(str(dNumer[0][0]))])

            for i in xrange(len(Pozycje)):
                Skladnik = rsglobal.Dekoduj(Pozycje[i][0])
                Ilosc1 = Pozycje[i][1]
                Ilosc2 = Pozycje[i][2]
                Produkt = rsglobal.Dekoduj(Pozycje[i][3])
                
                Cena1Magazyn = 0
                Cena2Magazyn = 0
    
                if dStosCeny[0][0]:
                    Cena1Jm = 0
                    Cena2Jm = 0
                    Cena1Magazyn = 0
                    Cena2Magazyn = 0
    
                    sql ="SELECT rsf_podaj_ceny('"+self.firma_id+"',"
                    sql+="'"+Skladnik+"',"+Wersja+",'PLN','"+Data+"');"
    
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bdy przy pobieraniu ceny :'+stat
                        dane.append(stat)
                        break
                    
                    elif len(d)>0:
                        Ceny = rsglobal.rseval(d[0][0])
                        if len(Ceny)>0:
                            Cena1Jm = Ceny[0]
                            Cena2Jm = Ceny[1]
                            
                    if stat == 'OK' and dStosCeny[0][0]:
                        Cena1Magazyn = Cena1Jm
                        Cena2Magazyn = Cena2Jm
            
                    if stat == 'OK' and DwieJM:
                        sql ="SELECT przelicznik FROM rs_artykuly"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Skladnik+"'"
                        sql+=" AND aktywny;"
    
                        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                        if stat != 'OK':
                            stat = 'Bd pobrania przelicznika dla skadnika: '+stat
                            break
                        elif len(d) == 0:
                            stat = 'Brak skadnika o kodzie '+Skladnik
                            break
                        else:
                            Przelicznik = d[0][0]
                
                if stat == 'OK':
                    # INSERT dla pozycji dokumentu
                    INS+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
                    INS+=" (firma_id, magazyn_id, dokument_id, data,"
                    INS+="  numer, nr_poz, nr_ppoz, artykul_id,"
                    INS+="  ilosc1, ilosc2,"
                    INS+="  cena1, cena2,"
                    INS+="  cena_wal1, cena_wal2,produkt_id)"
                    INS+=" VALUES"
                    INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"','"+Data+"',"
                    INS+="  "+str(dNumer[0][0])+","+str(i+1)+",0,'"+Skladnik+"',"
                    INS+="  "+str(Ilosc1)+","+str(Ilosc2)+","
                    INS+="  "+str(Cena1Magazyn)+","+str(Cena2Magazyn)+","
                    INS+="  "+str(Cena1Magazyn)+","+str(Cena2Magazyn)+",'"+Produkt+"'); "
                    

    if stat == 'OK' and INS != '':
        stat,dane,dump,dump = self.PolSQL.Execute(INS,1)
        if stat != 'OK':
            stat = 'Bd tworzenia dokumentw: '+stat
        else:
            # zalaczamy liste utworzonych dokumentow
            wyn2 = LDokNag


#-------------------------------------------------------------------------------
# TWORZ.DOKUMENTOW RW Z DOKUMENTU PW NA PODST.RECEPTUR (1) 
# (po zmianach typy mog by inne)
#-------------------------------------------------------------------------------

if Fun == 1:
    if not UprDod:
        stat = 'Brak uprawnie do tworzenia dokumentw.'
        dane.append(stat)
    
if Fun == 1 and stat == 'OK':
    DokRW=rsglobal.Dekoduj(klucze[4])
    MagDokad=rsglobal.Dekoduj(klucze[5])

    if stat == 'OK':
        # pobranie stanu dokumentu i zablokowanie
        sql ="SELECT stan, COALESCE(dokument_zwiaz,''::TEXT)"
        sql+=" FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagPW+"'"
        sql+=" AND dokument_id='"+DokPW+"' AND data='"+DataPW+"' AND numer="+str(NrPW)+" FOR UPDATE NOWAIT;"
        
        stat,dNag,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania stanu z dokumentu magazynowego: '+stat
            dane.append(stat)
        elif len(dNag) == 0:
            stat = 'Brak dokumentu o podanym kluczu.'
            dane.append(stat)
        elif rsglobal.Dekoduj(dNag[0][1]).strip() != '':
            stat = 'Dokument jest ju powizany z innym dokumentem '+rsglobal.Dekoduj(dNag[0][1])
            dane.append(stat)
    
    if stat == 'OK':
        # pobranie pozycji dokumentu
        sql ="SELECT dmp.artykul_id,a.nazwa,dmp.ilosc1,dmp.ilosc2,dmp.nr_poz,dmp.nr_ppoz"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
        sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+MagPW+"'"
        sql+=" AND dmp.dokument_id='"+DokPW+"' AND dmp.data='"+DataPW+"' AND dmp.numer="+str(NrPW)
        sql+=" ORDER BY dmp.nr_poz,dmp.nr_ppoz;"
    
        stat,dPoz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania pozycji dokumentu magazynowego: '+stat
            dane.append(stat)
        elif len(dNag) == 0:
            stat = "Brak pozycji na dokumencie w stanie 'Z'."
            dane.append(stat)

    #WS 2024-01-31 - pobranie oddziau z magazynu
    if stat == 'OK':
        sql ="SELECT oddzial_id FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagPW+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania oddziau dla magazynu: '+stat
            dane.append(stat)
        else:
            OddzialMag = d[0][0]
            
    if stat == 'OK':
        # pobranie receptur
        # przy kazdej recepturze zapisuje w sql-u ilosci z dok.PW
        # aby miec wszystko w jednym miejscu
        SReceptury = {}
        
        for i in xrange(len(dPoz)):
            Art = rsglobal.Dekoduj(dPoz[i][0])
            ArtOpis = rsglobal.Dekoduj(dPoz[i][1]).strip()
            Ilosci = str(dPoz[i][2])+","+str(dPoz[i][3])
            PozDok = rsglobal.UsunKropkaZero(dPoz[i][4])
            if dPoz[i][4] > 0:
                PozDok += ','+rsglobal.UsunKropkaZero(dPoz[i][5])
            #WS 2024-01-31
            Oddz = OddzialMag
            # Oddz = self.oddzial_id
            
            # pobieram recepture dla oddzialu, w ktorym zalogowany jest operator
            # jako wazniejsza niz recepture dla wszystkich oddzialow
            sql ="SELECT data_od,ilosc1,ilosc2,"+Ilosci+",artykul_id"
            sql+=" FROM rs_receptury"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddz+"'"
            sql+=" AND stan='Z' AND artykul_id='"+Art+"' AND data_od<='"+DataPW+"'"
            sql+=" ORDER BY data_od DESC LIMIT 1;"
            
            stat,dReceptNag,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania nagwka receptury: '+stat
                dane.append(stat)
                break
            
            if stat == 'OK' and len(dReceptNag) == 0:
                # jesli nie bylo receptury dla oddzialu, w ktorym zalogowany jest operator
                # probujemy pobrac recepture ogolna dla wszystkich oddzialow
                
                Oddz = '**'
                sql ="SELECT data_od,ilosc1,ilosc2,"+Ilosci+",artykul_id"
                sql+=" FROM rs_receptury"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddz+"'"
                sql+=" AND stan='Z' AND artykul_id='"+Art+"' AND data_od<='"+DataPW+"'"
                sql+=" ORDER BY data_od DESC LIMIT 1;"

                stat,dReceptNag,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania nagwka receptury: '+stat
                    dane.append(stat)
                    break
            
            if len(dReceptNag) == 0:
                wyn2.append('Brak receptury dla poz.'+PozDok+'. '+Art+' '+ArtOpis)
            else:
                # pobranie pozycji receptury dla artykulu
                sql ="SELECT skladnik_id,COALESCE(magazyn_id,''::TEXT),ilosc1,ilosc2"
                sql+=" FROM rs_receptury_pozycje"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddz+"'"
                sql+=" AND artykul_id='"+Art+"'"
                sql+=" AND data_od='"+rsglobal.Dekoduj(dReceptNag[0][0])+"'"
                sql+=" ORDER BY skladnik_id;"
                
                stat,dReceptPoz,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania pozycji receptury: '+stat
                    dane.append(stat)
                    break
                elif len(dReceptPoz) > 0:
                    # jesli receptura ma pozycje, z ktorych mozna utworzyc dokument
                    SReceptury[str([str(i).zfill(4),Art])] = [dReceptNag,dReceptPoz]

                    # czy wszystkie skladniki maja wpisany magazyn_id aby mozna utworzyc RW
                    for i in xrange(len(dReceptPoz)):
                        if rsglobal.Dekoduj(dReceptPoz[i][1]).strip() == '':
                            wyn2.append('W recepturze dla poz.'+PozDok+'. '+Art+' '+ArtOpis+\
                                        ' brak magazynu dla skadnika '+rsglobal.Dekoduj(dReceptPoz[i][0]))
                    
                else:
                    wyn2.append('Brak skadnikw receptury z dnia '+rsglobal.Dekoduj(dReceptNag[0][0])+\
                                'z oddziau '+Oddz+' dla poz.dok.'+PozDok+'. '+Art+' '+ArtOpis)
            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
    if stat == 'OK':
        SMagazyny = {}
        
        kReceptury = SReceptury.keys()
        kReceptury.sort()
        
        for s in kReceptury:
            
            if SReceptury[s] != None:
                dReceptNag, dReceptPoz = SReceptury[s]
                Produkt = rsglobal.Dekoduj(dReceptNag[0][5])
                Przel1Art = dReceptNag[0][1]
                Przel2Art = dReceptNag[0][2]
                Ilosc1Art = dReceptNag[0][3]
                Ilosc2Art = dReceptNag[0][4]
                
                for i in xrange(len(dReceptPoz)):
                    Sklad = rsglobal.Dekoduj(dReceptPoz[i][0])
                    Mag = rsglobal.Dekoduj(dReceptPoz[i][1])
                    Ilosc1Sklad = rsglobal.RSRound(Ilosc1Art/Przel1Art*dReceptPoz[i][2],4)
                    Ilosc2Sklad = rsglobal.RSRound(Ilosc2Art/Przel2Art*dReceptPoz[i][3],4)
                    
                    if not Mag in SMagazyny:
                        SMagazyny[Mag] = []
                        
                    PozDokMag = SMagazyny[Mag]
                    PozDokMag.append([Sklad,Ilosc1Sklad,Ilosc2Sklad,Produkt])
                    SMagazyny[Mag] = PozDokMag
    
    # jeli podano docelowy magazyn rwny jakiemu magazynowi skd to jest to bd
    if stat=='OK':
        if MagDokad<>'':
            if MagDokad in SMagazyny.keys():
                stat='Podano magazyn dokd, ktry bdzie rwny jednemu z magazynw skd. Dokumenty nie utworzone.'
        
    if stat == 'OK':
        if len(wyn2) > 0:
            # jesli byly bledy wynikajace tylko z niepelnosci receptur
            # zmieniam stat na charakterystyczny dla tej sytuacji aby na oknie
            # nie alarmowac operatora bledem tylko wyswietlic liste brakow w recepturach
            stat = 'BLEDY_RECEPTUR'

    if stat == 'OK':
        # pobranie danych, potrzebych do wypelnienia dok.RW
        # jesli dokumenty mialyby byc od razu zamykane lub 
        # przygotowane do szybkiego zamkniecia, to bedzie potrzebne
        # ustalenie konfiguracji
        Wersja = 'NULL'
        Kontrahent = 'NULL'
        Dokument = DokRW
        Data = DataPW
      
    if stat == 'OK':
        # czy dwie jednostki miary
        sql ="SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o stosowaniu dwch jednostek miar: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak firmy o podanym kodzie '+self.firma_id
        else:
            DwieJM = d[0][0]    
            
    if stat == 'OK':
        INS = ''
        NrPWDoZwiaz = MagPW+'/'+DokPW+'/'+DataPW+'/'+rsglobal.UsunKropkaZero(NrPW)
        ZwiazPWzRW = False
        
        for Magazyn in SMagazyny:
            Pozycje = SMagazyny[Magazyn]

            # pobranie domyslnych paramtetrow dla dokumentu w magazynie
            SParam = {}
            SParam['wersja'] = ''
            SParam['kontrahent_id'] = ''
            stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Magazyn,Dokument,SParam)
            if stat != 'OK':
                dane.append(stat)
                break
            
            Wersja = SParam['wersja']
            Kontrahent = SParam['kontrahent_id']
            
            if Wersja in ('','NULL'):
                Wersja = 'NULL'
            else:
                Wersja = "'"+Wersja+"'"
                
            if Kontrahent in ('','NULL'):
                Kontrahent = 'NULL'
            else:
                Kontrahent = "'"+Kontrahent+"'"

            # czy w magazynie pobierac ceny
            sql ="SELECT czy_ceny FROM rs_magazyny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"
    
            sql,dStosCeny,dump,dump = self.PolSQL.Execute(sql,2)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o stosowaniu cen w magazynie '+Magazyn
                dane.append(stat)
                break
            elif len(d) != 1:
                stat = 'Bdny numer magazynu '+Magazyn
                dane.append(stat)
                break

            # czy mozna dodac dokument z podana data do magazynu
            sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"',"
            sql+="'[\\\'"+Magazyn+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','M');"            

            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if d[0][0] != 'OK':    
                stat = 'Do magazynu '+Magazyn+' nie mona doda dokumentu z dat '+Data
                dane.append(stat)
                break

            # pobranie numeru dla nowego dokumentu
            sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
            sql+="'[\\\'"+Magazyn+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','M');"

            stat,dNumer,dump,dump = self.PolSQL.Execute(sql,3)
            if dNumer[0][0] in (None,'None',''):
                stat = 'Bd pobrania nowego numeru dla '+Dokument+' z magazynu '+Magazyn
                dane.append(stat)
                break
            
            if MagDokad<>'':
                # czy mozna dodac dokument z podana data do magazynu dokad
                sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"',"
                sql+="'[\\\'"+MagDokad+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','M');"            

                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if d[0][0] != 'OK':    
                    stat = 'Do magazynu dokd '+MagDokad+' nie mona doda dokumentu z dat '+Data
                    dane.append(stat)
                    break

                # pobranie numeru dla nowego dokumentu
                sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
                sql+="'[\\\'"+MagDokad+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','M');"

                stat,dNumerD,dump,dump = self.PolSQL.Execute(sql,3)
                if dNumerD[0][0] in (None,'None',''):
                    stat = 'Bd pobrania nowego numeru dla '+Dokument+' z magazynu dokd '+MagDokad
                    dane.append(stat)
                    break

            INS+="INSERT INTO rs_dokumenty_magazynowe"
            INS+=" (firma_id, magazyn_id, dokument_id,"
            INS+=" data, numer, wersja,"
            if MagDokad<>'':
                INS+="magazyn_dokad,numer_dokad,"
            INS+=" magazyn_skad, kontrahent_id,dokument_zwiaz)"
            INS+=" VALUES "
            INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"',"
            INS+="'"+Data+"',"+str(dNumer[0][0])+","+Wersja+","
            if MagDokad<>'':
                INS+="'"+MagDokad+"',"+str(dNumerD[0][0])+","
            INS+="'"+Magazyn+"',"+Kontrahent+",'"+NrPWDoZwiaz+"'); "

            for i in xrange(len(Pozycje)):
                Skladnik = rsglobal.Dekoduj(Pozycje[i][0])
                Ilosc1 = Pozycje[i][1]
                Ilosc2 = Pozycje[i][2]
                Produkt = rsglobal.Dekoduj(Pozycje[i][3])
                
                Cena1Magazyn = 0
                Cena2Magazyn = 0

                if dStosCeny[0][0]:
                    Cena1Jm = 0
                    Cena2Jm = 0
                    Cena1Magazyn = 0
                    Cena2Magazyn = 0

                    sql ="SELECT rsf_podaj_ceny('"+self.firma_id+"',"
                    sql+="'"+Skladnik+"',"+Wersja+",'PLN','"+Data+"');"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bdy przy pobieraniu ceny :'+stat
                        dane.append(stat)
                        break
                    
                    elif len(d)>0:
                        Ceny = rsglobal.rseval(d[0][0])
                        if len(Ceny)>0:
                            Cena1Jm = Ceny[0]
                            Cena2Jm = Ceny[1]
                            
                    if stat == 'OK' and dStosCeny[0][0]:
                        Cena1Magazyn = Cena1Jm
                        Cena2Magazyn = Cena2Jm
            
                    if stat == 'OK' and DwieJM:
                        sql ="SELECT przelicznik FROM rs_artykuly"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Skladnik+"'"
                        sql+=" AND aktywny;"
    
                        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                        if stat != 'OK':
                            stat = 'Bd pobrania przelicznika dla skadnika: '+stat
                            break
                        elif len(d) == 0:
                            stat = 'Brak skadnika o kodzie '+Skladnik
                            break
                        else:
                            Przelicznik = d[0][0]
                
                if stat == 'OK':
                    # INSERT dla pozycji dokumentu
                    INS+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
                    INS+=" (firma_id, magazyn_id, dokument_id, data,"
                    INS+="  numer, nr_poz, nr_ppoz, artykul_id,"
                    INS+="  ilosc1, ilosc2,"
                    INS+="  cena1, cena2,"
                    INS+="  cena_wal1, cena_wal2,produkt_id)"
                    INS+=" VALUES"
                    INS+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"','"+Data+"',"
                    INS+="  "+str(dNumer[0][0])+","+str(i+1)+",0,'"+Skladnik+"',"
                    INS+="  "+str(Ilosc1)+","+str(Ilosc2)+","
                    INS+="  "+str(Cena1Magazyn)+","+str(Cena2Magazyn)+","
                    INS+="  "+str(Cena1Magazyn)+","+str(Cena2Magazyn)+",'"+Produkt+"'); "
            
            if not ZwiazPWzRW:
                # powiazanie PW z pierwszym dodawanym dokumentem RW
                ZwiazPWzRW = True
                
                INS+="UPDATE rs_dokumenty_magazynowe"
                INS+=" SET dokument_zwiaz='"+Magazyn+'/'+Dokument+'/'+Data+'/'+rsglobal.UsunKropkaZero(dNumer[0][0])+"'"
                INS+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagPW+"'"
                INS+=" AND dokument_id='"+DokPW+"' AND data='"+DataPW+"' AND numer="+str(NrPW)+"; "
            
    if stat == 'OK':
        stat,dane,dump,dump = self.PolSQL.Execute(INS,1)
        if stat != 'OK':
            stat = 'Bd tworzenia dokumentw: '+stat
