#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_tworzenie_wz_z_paragonow_i_faktur.py
# Author:      Jan Raburski
# Created:     2022/01/11
# RCS-ID:      $Id: fs_dokumenty_magazynowe_tworzenie_wz_z_paragonow_i_faktur.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# Tworzenie dokumentw WZ z paragonw i faktur dla caej firmy.

from funkcje import fs_dokumenty_magazynowe_pom as dpom

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach.'
    dane.append(stat)

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {'Mag' : [1], 'Typ' : [1], 'Data' : [1], 'Zamykac' : [1]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_tworzenie_wz_z_paragonow_i_faktur z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        dane.append(stat)

if stat == 'OK':
    if Funkcja in [1,]:
        Magazyn = klucze['Mag']
        Typ = klucze['Typ']
        Data = klucze['Data']
        Zamykac = klucze['Zamykac']

ileparagonow = 0
ilefaktur = 0
ileparagonowzamk = 0
ilefakturzamk = 0

UprIns = ((self.oddzial_id, '804000') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

if Funkcja in [1, ] and not UprIns:
    stat = u'Brak uprawnie do tworzenia WZ.'
    dane.append(stat)

if stat =='OK':
    if not rsglobal.SprawdzCzyToData(Data):
        stat = 'Niepoprawna data.'
        dane.append(stat)
if stat == 'OK':
    # --- sprawdzenie, czy podany magazyn istnieje
    sql = "SELECT magazyn_id FROM rs_magazyny"
    sql += " WHERE firma_id = '" + self.firma_id + "' AND magazyn_id = '" + Magazyn + "';"
    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bd sprawdzenia istnienia magazynu : ' + stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak podanego magazynu.'
        dane.append(stat)

if stat == 'OK':
    # sprawdzenie czy mona wystawic dokument z t dat
    stat, test, dump, dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Typ+"\\\',\\\'"+Data+"\\\']','M');", 3)
    if stat != 'OK':
        stat = u'Bd sprawdzenia czy mona dodawa dokumenty z dat ' + str(Data)
        dane.append(stat)
    else:
        if test[0][0] != 'OK':
            stat = test[0][0]
            dane.append(stat)

if stat == 'OK':
    sql = "SELECT count(*) FROM rs_paragony_fiskalne WHERE firma_id='" + self.firma_id +"'"
    sql += " AND data='" + str(Data) + "' AND magazyn_id IS NULL AND dokument_id IS NULL AND NOT stan='Z';"
    stat, paragony, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bd sprawdzania niezamknitych paragonw ' + stat
        dane.append(stat)
    elif paragony[0][0] > 0:
        stat = u'Nie wszystkie paragony s zamknite z dnia: ' + str(Data)
        dane.append(stat)

if stat == 'OK':
    sql = "SELECT count(*) FROM rs_faktury fa WHERE firma_id='" + self.firma_id +"'"
    sql += " AND data='" + str(Data) + "' AND NOT stan IN ('Z','K') AND NOT EXISTS"
    sql += " (SELECT f_wyznacznik_id FROM rs_dokumenty_magazynowe dm WHERE dm.firma_id=fa.firma_id AND dm.f_wyznacznik_id=fa.wyznacznik_id"
    sql += " AND dm.f_data=fa.data AND dm.f_numer=fa.numer);"
    stat, faktury, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bd sprawdzania niezamknitych faktur ' + stat
        dane.append(stat)
    elif faktury[0][0] > 0:
        stat = u'Nie wszystkie faktury s zamknite z dnia: ' + str(Data)
        dane.append(stat)

if stat == 'OK':
    # pobranie listy paragonow
    sql = "SELECT oddzial_id, kasa_id, numer, COALESCE(kontrahent_id,'') FROM rs_paragony_fiskalne WHERE firma_id='" + self.firma_id +"'"
    sql += " AND data='" + str(Data) + "' AND magazyn_id IS NULL AND dokument_id IS NULL AND stan='Z' ORDER BY oddzial_id,kasa_id,numer;"
    stat, paragony, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bd pobierania listy paragonw ' + stat
        dane.append(stat)

if stat == 'OK':
    # tworzenie i zamykanie WZ z paragonow
    ileparagonow += len(paragony)
    for par in paragony:
        sql = "SELECT pfp.artykul_id, pfp.ilosc1, pfp.ilosc2 FROM rs_paragony_fiskalne_pozycje pfp"
        sql += " INNER JOIN rs_artykuly ar USING (firma_id, artykul_id)"
        sql += " WHERE pfp.firma_id='" + self.firma_id +"' AND oddzial_id='" + par[0] + "' AND kasa_id='" + par[1] + "'"
        sql += " AND data='" + str(Data) + "' AND numer=" + str(par[2]) + " AND NOT ar.typ_artykulu IN ('31','99')"
        stat, Pozycje, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = u'Bd pobieranie listy pozycji paragonu ' + stat
            dane.append(stat)
            break
        elif len(Pozycje) == 0:
            ileparagonow -= 1
            continue

        (stat, Numer) = dpom.WstawDokumentMagazynowy(self, Magazyn, Typ, Data, par[3], Pozycje)
        if stat != 'OK':
            stat = u'Bd wstawiania WZ ' + stat
            dane.append(stat)
            break

        sql = "UPDATE rs_paragony_fiskalne SET dokument_id='" + Typ + "', magazyn_id='" + Magazyn + "', data_dm='" + str(Data) + "', numer_dm=" + str(Numer)
        sql += " WHERE firma_id='" + self.firma_id + "' AND oddzial_id='" + par[0] + "' AND kasa_id='" + par[1] + "'"
        sql += " AND data='" + str(Data) + "' AND numer=" + str(par[2]) + ";"
        stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        if stat != 'OK':
            stat = u'Bd zapisu numeru WZ do paragonu' + stat
            dane.append(stat)
            break
        else:
            self.PolSQL.CommitCzysty()

        # proba zamkniecia - blad niekrytyczny - bedzie kontynuacja
        #def ZamknijDokumentMagazynowy(self, Mag, Dok, Data, Nr, StanP, StanK, IgnorowacStat=False):
        if Zamykac:
            if stat == 'OK':
                stat = dpom.ZamknijDokumentMagazynowy(self, Magazyn, Typ, Data, Numer, 'W', 'G')
            if stat == 'OK':
                stat = dpom.ZamknijDokumentMagazynowy(self, Magazyn, Typ, Data, Numer, 'G', 'Z')
            if stat == 'OK':
                ileparagonowzamk += 1
            else:
                Zamykac = False
                stat = 'OK'
        if stat == 'OK':
            self.PolSQL.CommitCzysty()


if stat == 'OK':
    # pobranie listy faktur
    sql = "SELECT oddzial_id, wyznacznik_id, numer, kontrahent_id FROM rs_faktury fa WHERE firma_id='" + self.firma_id +"'"
    sql += " AND data='" + str(Data) + "' AND stan IN ('Z','K') AND NOT EXISTS"
    sql += " (SELECT f_wyznacznik_id FROM rs_dokumenty_magazynowe dm WHERE dm.firma_id=fa.firma_id AND dm.f_wyznacznik_id=fa.wyznacznik_id"
    sql += " AND dm.f_data=fa.data AND dm.f_numer=fa.numer) ORDER BY wyznacznik_id,numer;"
    stat, faktury, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bd pobierania listy faktur ' + stat
        dane.append(stat)

if stat == 'OK':
    # zapisywanie WZ dla faktur
    ilefaktur += len(faktury)
    for fakt in faktury:
        sql = "SELECT fp.artykul_id, fp.ilosc1, fp.ilosc2 FROM rs_faktury_pozycje fp"
        sql += " INNER JOIN rs_artykuly ar USING (firma_id, artykul_id)"
        sql += " WHERE fp.firma_id='" + self.firma_id + "' AND wyznacznik_id='" + fakt[1] + "'"
        sql += " AND data='" + str(Data) + "' AND numer=" + str(fakt[2]) + " AND NOT ar.typ_artykulu IN ('31','99')"
        stat, Pozycje, dump, dump = self.PolSQL.Execute(sql, 3)
        rsglobal.ZapiszDoLogow('WZPF pozycje:' + str(Pozycje), 0)
        if stat != 'OK':
            stat = u'Bd pobieranie listy pozycji faktury ' + stat
            dane.append(stat)
            break
        elif len(Pozycje) == 0:
            ilefaktur -= 1
            continue

        (stat, Numer) = dpom.WstawDokumentMagazynowy(self, Magazyn, Typ, Data, fakt[3], Pozycje)
        if stat != 'OK':
            stat = u'Bd wstawiania WZ ' + stat
            dane.append(stat)
            break

        sql = "UPDATE rs_dokumenty_magazynowe SET f_wyznacznik_id='" + fakt[1] + "', f_data='" + str(Data) + "', f_numer=" + str(fakt[2])
        sql += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "' AND dokument_id='" + Typ + "'"
        sql += " AND data='" + str(Data) + "' AND numer=" + str(Numer) + ";"
        stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        if stat != 'OK':
            stat = u'Bd zapisu numeru faktury do WZ' + stat
            dane.append(stat)
            break
        else:
            rsglobal.ZapiszDoLogow('WZPF sql:' + sql, 0)
            self.PolSQL.CommitCzysty()

        # proba zamkniecia - blad niekrytyczny - bedzie kontynuacja
        # def ZamknijDokumentMagazynowy(self, Mag, Dok, Data, Nr, StanP, StanK, IgnorowacStat=False):
        if Zamykac:
            if stat == 'OK':
                stat = dpom.ZamknijDokumentMagazynowy(self, Magazyn, Typ, Data, Numer, 'W', 'G')
            if stat == 'OK':
                stat = dpom.ZamknijDokumentMagazynowy(self, Magazyn, Typ, Data, Numer, 'G', 'Z')
            if stat == 'OK':
                ilefakturzamk += 1
            else:
                Zamykac = False
                stat = 'OK'
        if stat == 'OK':
            self.PolSQL.CommitCzysty()

if stat=='OK':
    dane = [ileparagonow, ilefaktur, ileparagonowzamk, ilefakturzamk]