#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#Boa:Frame:WDokumentyMagazyny
#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazyny.py
# Purpose:     wczytuje/usuwa dane z rodzajami dokumentw dla magazynu w produkcji
#
# Author:      Micha Raburski
# Created:     2006/02/16
# RCS-ID:      $Id: fs_dokumenty_magazyny.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2021-12-29 Bartosz Pagan (12788) Refaktoryzacja okna 'Dokumenty/magazyny' i podokna


"""
Funkcje:

1. INSERT
5. SELECT
6. DELETE
9. ZMIANA MAGAZYNU RW
"""
import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Magazyn': [1,5,6,9], 'Dokument': [1,5,6,9],
             'MagazynRW': [9]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":

    if Funkcja in (1,5,6,9):
        Magazyn  = rsglobal.Dekoduj(klucze['Magazyn']).strip()
        Dokument = rsglobal.Dekoduj(klucze['Dokument']).strip()

    if  Funkcja == 9:
        MagazynRW = rsglobal.Dekoduj(klucze['MagazynRW']).strip()


#---   INSERT DANYCH (1)
if stat == "OK" and Funkcja == 1:
    if ((self.oddzial_id,'042003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        # Mag = klucze[0]
        # Dok = klucze[1]
        Select = "SELECT * FROM rs_dokumenty_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"';"
        stat,dane,dump,dump = self.PolSQL.Execute(Select,2)
        if len(dane) > 0:
            stat = 'UZ KLUCZ'
        if stat == 'OK':    
            stat,dump,dump,dump = self.PolSQL.Execute("INSERT INTO rs_dokumenty_magazyny (firma_id,magazyn_id,dokument_id) VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"');" ,1)
    else:
        stat = 'UPR INS'

        
#---   DELETE DANYCH (6)
if stat == "OK" and Funkcja == 6:
    if ((self.oddzial_id,'042004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        # Mag = klucze[0]
        # Dok = klucze[1]
        stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_dokumenty_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"';" ,1)
    else:
        stat='UPR DEL'

#---   ZMIANA MAGAZYNU RW (9)
if stat == "OK" and Funkcja == 9:
    if ((self.oddzial_id,'042003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        
        if MagazynRW == '':
            MagazynRW = 'NULL'
        else:
            MagazynRW = "'"+MagazynRW+"'"
            
        # sprawdzenie czy magazyn jest z odpowiedniego oddziau
        if MagazynRW != 'NULL':
            SQL = "SELECT oddzial_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"'"
            SQL += " AND magazyn_id="+MagazynRW+";"
            stat,DMag,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat == 'OK':
                if len(DMag) == 0:
                    stat = 'Brak podanego magazynu w wybranej firmie'
                    
        if stat == 'OK':
            UPD = "UPDATE rs_dokumenty_magazyny SET magazyn_rw="+MagazynRW+" WHERE firma_id='"+self.firma_id+"'"
            UPD += " AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"';"
            stat,dump,dump,dump = self.PolSQL.Execute(UPD ,1)
    else:
        stat = 'UPR DEL'
        
#---   POBRANIE DANYCH (1-insert, 5 -select, 6 -delete, 9 - zmiana magazynu RW)
if stat == "OK" and (Funkcja in [1,5,6,9]):
    # pobranie danych o dokumentach
    SQL = "SELECT mg.magazyn_id||' - '||mg.opis,td.dokument_id||' - '||td.nazwa_dokumentu, "
    SQL += " COALESCE(mrw.magazyn_id||' - '||mrw.opis,'')"
    SQL += " FROM rs_dokumenty_magazyny dm "
    SQL += " INNER JOIN rs_magazyny mg ON (dm.firma_id=mg.firma_id AND dm.magazyn_id=mg.magazyn_id)"
    SQL += " LEFT OUTER JOIN rs_magazyny mrw ON (dm.firma_id=mrw.firma_id AND dm.magazyn_rw=mrw.magazyn_id)"
    SQL += " INNER JOIN rs_typy_dokumentow_m td ON (dm.firma_id=td.firma_id AND dm.dokument_id=td.dokument_id)"
    SQL += " WHERE dm.firma_id='"+self.firma_id+"' ORDER BY dm.magazyn_id,dm.dokument_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)

    if stat == 'OK' and Funkcja == 1:
        SQL = " SELECT mg.magazyn_id||' - '||mg.opis,td.dokument_id||' - '||td.nazwa_dokumentu"
        SQL += " FROM rs_dokumenty_magazyny dm"
        SQL += " INNER JOIN rs_magazyny mg ON (dm.firma_id=mg.firma_id AND dm.magazyn_id=mg.magazyn_id)"
        SQL += " INNER JOIN rs_typy_dokumentow_m td ON (dm.firma_id=td.firma_id AND dm.dokument_id=td.dokument_id)"
        SQL += " WHERE dm.firma_id='"+self.firma_id+"' AND  mg.magazyn_id='"+Magazyn+"' AND td.dokument_id='"+Dokument+"'"

        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych ' + stat
        elif len(d) != 1:
            stat = 'Bdne dane'
        else:
            wyn2 = d[0]







