#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_dostawy.py
# Purpose:          przeglda dostawy
# Author:           Marcin Grzda
# Created:          2007/08/23
# RCS-ID:           $Id: fs_dostawy.py $
# Copyright:        (c) 2017 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#2011-05-13 kontrola tworzenia PZ-ki z param.dla PZ w podanym magazynie Mariusz Rajfura (4578)
#2011-11-17 Micha Raburski (5200) dekretacja dostaw
#2012-04-11 Mariusz Rajfura (5638) kontrola w stanie K: otwieranie, usuwanie
#2013-02-08 Mariusz Rajfura (6511) kontrola dekretacji: daty od-do, okres_id z biezacego zalogowania operatora
#2013-03-08 Mariusz Rajfura (6657) blokada przed zamykaniem, dekretacja
#2013-12-12 Jan Raburski (7471) nie wpisywac terminu w pozycje d.k.
#2013-08-25 Konrad Opieka (8174) sprawdzanie czy cecha zostala zmieniona na artykulach
#2017-03-13 Piotr Witkowski (10358) Pena refaktoryzacja Magazyny/RSDostawy
#2020-03-10 Mikoaj Kozowski (11891) Filtrowanie po licie magazynw w ktrych operator ma uprawnienia do dokumentw magazynowych typu 'P'
#2020-05-06 Jan Raburski (11976) Import faktur
#2020-06-22 Aleksander Bargie (12007) [HD] F1 w GM dla magazynu detalicznego
#2023-06-05 Aleksander Bargie (13459) SPC - bd otwierania dostawy

#klucze (czyli filtr):
# 0: DataOd
# 1: Numer
# 2: kontrahent
# 3: handlowiec
# 4: po terminie
# 5: historia

#Funkcje:
#1 - Dodaj
#5 - Pobierz
#6 - Usnu
#7 - Zamknij
#8 - Otwrz
#11 - import faktury

from funkcje import fs_magazyny_parametry_dokumentow_pom
from funkcje import fs_dostawy_pom

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Stan':[1,5,6,7,8,11,],'Magazyn':[1,5,6,7,8,],'DataOd':[1,5,6,7,8,],
           'DataDo':[1,5,6,7,8,],'Kontrahent':[1,5,6,7,8,],'Kraj':[1,5,6,7,8,],
           'Data':[1,5,6,7,8,11,],'Numer':[1,5,6,7,8,11,],'OstKlucze':[1,5,6,7,8],
           'DokMag':[7,],'Plik':[11,],'StanPoz':[11,]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dostawy z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5,6,7,8,]:
        Stan = klucze['Stan']
        Magazyn = klucze['Magazyn']
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']
        Kontrahent = klucze['Kontrahent']
        Kraj = klucze['Kraj']
        Data = klucze['Data']
        Numer = klucze['Numer']
    if Funkcja in [1,5,6,7,8]:
        OstKlucze = klucze['OstKlucze']
    if Funkcja in [7,]:
        DokMag = klucze['DokMag']
    if Funkcja in [11,]:
        StanPoz = klucze['StanPoz']
        Data = klucze['Data']
        Numer = klucze['Numer']
        Plik = klucze['Plik']


if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = ['    -  -  ', '', []]
    DokumentPowt = ''

if Funkcja != 11:  # nie import
    if stat == 'OK':
        if DataOd != '    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat='BL DATAOD'
                dane.append(stat)
    if stat=='OK':
        if DataDo != '    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat='BL DATADO'
                dane.append(stat)
    if stat=='OK':
        if DataOd != '    -  -  ' and DataDo != '    -  -  ' :
            if DataDo<DataOd:
                stat='BL ZAKR DAT'
                dane.append(stat)

if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
    UprDel=True
    UprIns=True
    UprZam=True
    UprOtw=True
else:
    UprPrz=(self.oddzial_id,'035011') in self.uprawnienia
    UprDel=(self.oddzial_id,'035014') in self.uprawnienia
    UprIns=(self.oddzial_id,'035013') in self.uprawnienia
    UprZam=(self.oddzial_id,'035016') in self.uprawnienia
    UprOtw=(self.oddzial_id,'035017') in self.uprawnienia
    if UprPrz or UprDel or UprIns or UprZam or UprOtw:
        UprPrz=True

#-------------------------------------------------------------------------------
#--- DODAWANIE
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==1:
    if UprIns:
        Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND data=\\\'"+Data+"\\\'"
        Select = "SELECT rsf_klucz_where_new('rs_dostawy','"+Warunek+"','numer');"
        stat,d,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(d)>0:
                Numer=d[0][0]                         
                sql= "INSERT INTO rs_dostawy (firma_id,data,numer,stan) VALUES ("
                sql+="'"+self.firma_id+"','"+Data+"',"+str(Numer)+",'W');"
                stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
                if stat<>'OK':
                    stat='BL SQL INS'
                    dane.append(stat)
                else:
                    OstKlucze.append([Data,Numer])
            else:
                stat='BL SEL NUM'
                dane.append(stat)
        else:
            stat='BL SEL NUM'
            dane.append(stat)
    else:
        stat="UPR INS"   
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- ZAMYKANIE 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==7:
    rsglobal.ZapiszDoLogow("ZAMYKANIE DOSTAWY          "*30)
    rsglobal.ZapiszDoLogow(str(locals()))
    if UprZam!=True:
        stat='UPR ZAM'
        dane.append(stat)

    # blokada naglowka dostawy
    if stat=='OK':
        sql ="SELECT * FROM rs_dostawy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' and numer="+str(Numer)
        sql+=" FOR UPDATE;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Nie mona zablokowa nagwka dostawy przed zamkniciem'
            dane.append(stat)
        elif len(d)==0:
            stat = 'Brak dostawy o podanym kluczu'
        
    # blokada pozycji dostawy
    if stat=='OK':
        sql ="SELECT * FROM rs_dostawy_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' and numer="+str(Numer)
        sql+=" FOR UPDATE;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Nie mona zablokowa pozycji dostawy przed zamkniciem'
            dane.append(stat)

    if stat=='OK':
        KMagazyn=DokMag[0]
        KDokument=DokMag[1]
        KData=DokMag[2]
        KNumer=DokMag[3]
               
        #--------------------------------
        
        sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"'"
        sql+=",'[\""+KMagazyn+"\",\""+KDokument+"\",\""+KData+"\"]','M')"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if d[0][0]<>'OK':
                stat='BL DATA SA POZN'
                dane.append(stat)
        
        d=[]
        if stat=='OK':
            Select="SELECT * FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"'"
            Select+="AND data='"+Data+"' and numer="+str(Numer)+" LIMIT 1"
            stat,d,dump,dump=self.PolSQL.Execute(Select,3)
            if stat=='OK':
                if len(d)==0:
                    stat='BR POZ DOST ZAM'
                    dane.append(stat)
            else:
                stat='BL SQL POZ DOST ZAM'
                dane.append(stat)

        if stat=='OK':
            Select="SELECT * FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"'"
            Select+=" AND data='"+Data+"' AND numer="+str(Numer)
            Select+=" AND (ilosc_dost1<=0 OR ilosc_dost2<=0 OR cena_dostawy1<=0 OR cena_dostawy2<=0) "
            stat,d,dump,dump=self.PolSQL.Execute(Select,3)
            if stat=='OK':
                if len(d)>0:
                    stat='BL POZ DOST ZAM'
                    dane.append(stat)
            else:
                stat='BL SQL POZ DOST ZAM'
                dane.append(stat)

        # sprawdzenie czy wszystkie artykuy s aktywne na pozycjach dostawy
        if stat=="OK":
            SQL="SELECT dp.artykul_id FROM rs_dostawy_pozycje dp "
            SQL+="INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.data='"+Data+"' and dp.numer="+str(Numer)
            SQL+=" AND NOT a.aktywny;"
            stat,DAkt,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat='Bd sprawdzania czy artykuy na dostawie s aktywne'
                dane.append(stat)
            elif len(DAkt)>0:
                stat="Nie mona zamkn dostawy poniewa artyku "+DAkt[0][0].strip()+" jest nieaktywny"
                dane.append(stat)

        ##SPRAWDZANIE CZY MAGAZYN JEST DETALICZNY
        if stat=='OK':
           Select="SELECT detaliczny FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+KMagazyn+"'"
           stat,d,dump,dump=self.PolSQL.Execute(Select,3)
           if stat=='OK':
               if len(d)==0:
                   stat='BR MAG ZAM'
                   dane.append(stat)
               else:
                   mag_detal = d[0][0]
           else:
               stat='BL SQL MAG ZAM'
               dane.append(stat)
        
        # sprawdza czy cecha artykulu nie ulegla zmianie
        if stat=='OK':
            SQL ="SELECT dp.artykul_id,a.cecha1_opis, tylko_detal, NOT tylko_detal AND NOT czy_detal AS nie_detal, "
            SQL+="COALESCE(NOT dp.cecha1_opis = a.cecha1_opis, FALSE) as cecha FROM rs_dostawy_pozycje dp"
            SQL+=" INNER JOIN rs_artykuly a"
            SQL+=" ON (dp.firma_id=a.firma_id AND dp.artykul_id=a.artykul_id)"
            SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.data='"+Data+"' and dp.numer="+str(Numer)
            SQL+=" AND a.aktywny;"
            stat,DCecha,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat='Bd sprawdzania czy cecha si zgadza'
                dane.append(stat)
            # elif len(DCecha)>0:
            #     stat="Nie mona zamkn dostawy poniewa artyku "+DCecha[0][0].strip()+" ma zmienion cech"
            #     dane.append(stat)

        rsglobal.ZapiszDoLogow(SQL)
        if stat == 'OK':
            bl = []
            bl_cech = []
            rsglobal.ZapiszDoLogow(str(DCecha))
            for art in DCecha:
                artykul_id = art[0].strip()
                tylko_detal = art[2]
                nie_detal = art[3]
                cecha = art[4]
                rsglobal.ZapiszDoLogow("war1: {} war2: {}, art: {}, mag: {}".format(tylko_detal, nie_detal, artykul_id, mag_detal))
                if (tylko_detal and not mag_detal) or (nie_detal and mag_detal):
                    bl.append(artykul_id)
                if cecha:
                    bl_cech.append(artykul_id)
            bl = set(bl)
            bl_cech=set(bl_cech)
            if bl:
                if mag_detal:
                    stat = "Nie mona zamkn dostawy. Magazyn "+KMagazyn+" jest detaliczny, artyku/y "+", ".join(bl)+\
                           " nie mog zosta przyjte w magazynie detalicznym."
                    dane.append(stat)
                else:
                    stat = "Nie mona zamkn dostawy. Magazyn "+KMagazyn+" nie detaliczny, artyku/y "+", ".join(bl)+\
                           " mog by przyjte jedynie w magazynie detalicznym."
                    dane.append(stat)
            if bl_cech:
                stat = "Nie mona zamkn dostawy poniewa artyku/y "+", ".join(bl_cech)+\
                       " ma/j zmienion/e cech/y."
                dane.append(stat)

            
        if stat=='OK':
            Select ="SELECT COALESCE(kontrahent_id,''::TEXT),kraj_wysylki,waluta,"
            Select+=" kurs,nr_tabeli,data_tabeli,COALESCE(wersja,''::TEXT)"
            Select+=" FROM rs_dostawy"
            Select+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' and numer="+str(Numer)+";"
            stat,d,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat='BL SQL DOST ZAM'
                dane.append(stat)
            else:
                if len(d)==0:
                    stat='BR DOST'
                    dane.append(stat)
                else:
                    if rsglobal.Dekoduj(d[0][0]).strip() in ['','None']:
                        stat='BR KONTR ZAM'
                        dane.append(stat)
                    if rsglobal.Dekoduj(d[0][1]).strip() in ['','None']:
                        stat='BR KRAJ ZAM'
                        dane.append(stat)
                    if rsglobal.Dekoduj(d[0][2]).strip() in ['','None']:
                        stat='BR WAL ZAM'
                        dane.append(stat)
                    if d[0][3]==0:
                        stat='BL KURS ZAM'
                        dane.append(stat)
                    if rsglobal.Dekoduj(d[0][2]).strip()<>'PLN':
                        if rsglobal.Dekoduj(d[0][4]).strip() in ['None','']:
                            stat='BR NR TAB ZAM'
                            dane.append(stat)
                        if rsglobal.Dekoduj(d[0][5]).strip() in ['None','','-  -']:
                            stat='BR DAT TAB ZAM'
                            dane.append(stat)

        if stat == 'OK':
            # parametry dokumentu w magazynie
            SParam = {}
            SParam['wersja'] = rsglobal.Dekoduj(d[0][6]).strip()
            SParam['kontrahent_id'] = rsglobal.Dekoduj(d[0][0]).strip()
            
            stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,KMagazyn,KDokument,SParam)
            if stat != 'OK':
                dane.append(stat)
                
        if stat == 'OK':
            stat = fs_magazyny_parametry_dokumentow_pom.SprawdzParametryDlaDokumentu(self,KMagazyn,KDokument,SParam)
            if stat != 'OK':
                dane.append(stat)
            
        if stat == 'OK':
            # sprawdzone i uzupelnione parametry dla dokumentu
            WersjaDM = SParam['wersja']        
            KontrahentDM = SParam['kontrahent_id']

            if WersjaDM.strip() == '':
                WersjaDM = 'NULL'
            else:
                WersjaDM = "'"+WersjaDM+"'"
    
            if KontrahentDM.strip() == '':
                KontrahentDM = 'NULL'
            else:
                KontrahentDM = "'"+KontrahentDM+"'"

        if stat=='OK':
            Select="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+KDokument+"'"
            stat,d,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat='BL SQL DOK ZAM'
                dane.append(stat)
            else:
                if len(d)>0:
                    if d[0][0]<>'P':
                        stat='DOK NIE PRZYCH ZAM'
                        dane.append(stat)
                else:
                    stat='BR DOK ZAM'
                    dane.append(stat)
        
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(KData):
                stat='BL DAT ZAM'
                dane.append(stat)


        if stat=='OK':
            INSERT ="INSERT INTO rs_dokumenty_magazynowe"
            INSERT+=" (firma_id,magazyn_id,dokument_id,data,numer,stan,kontrahent_id,magazyn_dokad,nr_faktury,wersja)"
            INSERT+="  SELECT firma_id,'"+KMagazyn+"','"+KDokument+"','"+KData+"',"+str(KNumer)+",'W',"+KontrahentDM+",'"+KMagazyn+"',nr_faktury,"+WersjaDM
            INSERT+="  FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "

            INSERT+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
            INSERT+=" (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,cena1,cena2,cena_wal1,cena_wal2,cecha1_opis,cecha1_wartosc)"
            INSERT+="  SELECT firma_id,'"+KMagazyn+"','"+KDokument+"','"+KData+"',"+str(KNumer)+",nr_poz,0,artykul_id,ilosc_dost1,ilosc_dost2,"
            INSERT+=" cena_dostawy1_pz,cena_dostawy2_pz,cena_dostawy1_pz,cena_dostawy2_pz,cecha1_opis,cecha1_wartosc"
            INSERT+="  FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "

            INSERT+="UPDATE rs_dostawy SET d_magazyn_id='"+KMagazyn+"',d_dokument_id='"+KDokument+"',d_data='"+KData+"',d_numer="+str(KNumer)+",stan='Z'"
            INSERT+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "

            #Pobranie kontrahent z dostawy
            SQL="SELECT kontrahent_id, pobrane_z_zamowien,nr_faktury FROM rs_dostawy "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)

            stat,DaneKontr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DaneKontr)==0:
                stat='BR KONTR'
                dane.append(stat)

        if stat=='OK':
            #OBSUGA KONTROLI PARY KONTRAHENT/FAKTURA/ROK NA DOKUMENCIE MAGAZYNOWYM
            if not KontrahentDM  in ('','NULL') and DaneKontr[0][2] != '':
                RokTemp=str(KData)[0:4]
                SQL="SELECT magazyn_id||'/'||dokument_id||'/'||data||'/'||numer FROM rs_dokumenty_magazynowe "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND data >='"+RokTemp+"-01-01'"
                SQL+=" AND data <='"+RokTemp+"-12-31' AND kontrahent_id="+KontrahentDM+" AND nr_faktury='"+rsglobal.Dekoduj(DaneKontr[0][2])+"'"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)    
                if stat<>'OK':    
                    stat="Bdy przy sprawdzaniu kontrahenta : "+stat   
                    dane.append(stat)             
                else:
                    if len(d)>0:
                        DokumentPowt=d[0][0]
                                                    
            #OBSUGA ZAMWIE DO DOSTAWCW
            if DaneKontr[0][1]:
                #pobranie klucza zamowienia_dostawcy 
                stat,DaneZD,dump,dump=self.PolSQL.Execute("SELECT zd_wyznacznik, zd_data,zd_numer FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer),3)
                if stat=='OK':
                    if len(DaneZD)>0:
                        WyznZamDost=DaneZD[0][0]
                        DataZamDost=DaneZD[0][1]
                        NumerZamDost=DaneZD[0][2]
                    else:
                        stat='BR DOST'
                        dane.append(stat)
                
                if stat=='OK':
                    KontrDost=str(DaneKontr[0][0])
                    #Tworzenie sownika z ilosciami dostarczonymi z dostaw
                    SlowDost={}
                    Select="SELECT artykul_id, ilosc_dost1, ilosc_dost2,cena_z_zamowienia1,TRIM(COALESCE(cecha1_opis,'')),TRIM(COALESCE(cecha1_wartosc,''))"
                    Select+=" FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
                    stat,DaneDost,dump,dump=self.PolSQL.Execute(Select,3)

                if stat=='OK':
                    for w in DaneDost:
                        SlowDost[(w[0],rsglobal.RSRound(w[3],4),w[4],w[5])]=[w[1],w[2]]
            
                    #Pobranie pozycji z zamowien dostawcow
                    Select="SELECT dpz.wyznacznik_id, dpz.data, dpz.numer, dpz.nr_poz, dpz.artykul_id , dpz.cena_upust1 , dpz.ilosc1- dpz.anulowano1- dpz.dostarczono1 as ile1, " # 0 -6
                    Select+="dpz.ilosc2- dpz.anulowano2- dpz.dostarczono2 AS ile2,TRIM(COALESCE(cecha1_opis,'')),TRIM(COALESCE(cecha1_wartosc,'')) " # 7-9
                    Select+="FROM rs_zamowienia_dostawcy_pozycje dpz "
                    Select+=" LEFT OUTER JOIN rs_zamowienia_dostawcy dp ON (dpz.firma_id=dp.firma_id AND dpz.wyznacznik_id=dp.wyznacznik_id AND dpz.data=dp.data AND dpz.numer=dp.numer) "
                    Select+="WHERE dpz.firma_id='"+self.firma_id+"' AND dp.kontrahent_id='"+KontrDost+"' AND dpz.ilosc1-dpz.anulowano1-dpz.dostarczono1>0 AND dpz.ilosc2-dpz.anulowano2-dpz.dostarczono2>0 AND dp.stan='A'"
                    if WyznZamDost.strip() not in ('',None,'None'):
                        Select+="AND dpz.wyznacznik_id='"+str(WyznZamDost)+"' AND dpz.data='"+str(DataZamDost)+"' AND dpz.numer="+str(NumerZamDost)+" "
                    Select+=" ORDER BY dpz.artykul_id, dpz.cena_upust1, dpz.data, dpz.wyznacznik_id, dpz.numer, dpz.nr_poz"    
                    stat,DaneZam,dump,dump=self.PolSQL.Execute(Select,3)
          
                if stat=='OK':
                    Klucz=['','','',0]
                    ArtCenaS=('',0,'','')
                    for poz in DaneZam:
                        if ArtCenaS<>(poz[4],rsglobal.RSRound(poz[5],4),poz[8],poz[9]) and ArtCenaS<>('',0,'','') and Klucz<>[poz[0],poz[1],poz[2],poz[3]] and Klucz<>['','','',0]:
                            if ArtCenaS in SlowDost:
                                if SlowDost[ArtCenaS][0]>0:
                                    INSERT+="UPDATE rs_zamowienia_dostawcy_pozycje SET dostarczono1=dostarczono1+"+str(SlowDost[ArtCenaS][0])+", "
                                    INSERT+="dostarczono2=dostarczono2+"+str(SlowDost[ArtCenaS][1])+" "
                                    INSERT+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(Klucz[0])+"' AND data='"+str(Klucz[1])+"' "
                                    INSERT+="AND numer="+str(int(Klucz[2]))+" AND nr_poz="+str(int(Klucz[3]))+"; "
        
                        ArtCenaS=(poz[4],round(poz[5],4),poz[8],poz[9])
              
                        if ArtCenaS in SlowDost:
                            ileD1=SlowDost[ArtCenaS][0]
                            ileD2=SlowDost[ArtCenaS][1]
                            if ileD1>0:
                                ile1=min(ileD1, poz[6])
                                ile2=min(ileD2, poz[7])
                                if ile1>0:
                                    INSERT+="UPDATE rs_zamowienia_dostawcy_pozycje SET dostarczono1=dostarczono1+"+str(ile1)+" ,dostarczono2=dostarczono2+"+str(ile2)+" "
                                    INSERT+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(poz[0])+"' AND data='"+str(poz[1])+"' AND numer="+str(int(poz[2]))+" AND nr_poz="+str(int(poz[3]))+"; "
                                    SlowDost[ArtCenaS][0]=ileD1-ile1
                                    SlowDost[ArtCenaS][1]=ileD2-ile2
                                    Klucz=[poz[0],poz[1],poz[2],poz[3]]

                    if ArtCenaS<>('',0,'','') and Klucz<>['','','',0]:
                        if ArtCenaS in SlowDost:                
                            if SlowDost[ArtCenaS][0]>0:
                                INSERT+="UPDATE rs_zamowienia_dostawcy_pozycje SET dostarczono1=dostarczono1+"+str(SlowDost[ArtCenaS][0])+" , "
                                INSERT+="dostarczono2=dostarczono2+"+str(SlowDost[ArtCenaS][1])+" "
                                INSERT+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(Klucz[0])+"' AND data='"+str(Klucz[1])+"' "
                                INSERT+="AND numer="+str(int(Klucz[2]))+" AND nr_poz="+str(int(Klucz[3]))+"; "

        if stat=='OK':
            stat,dump,dump,dump=self.PolSQL.Execute(INSERT,1)

        #sprawdzenie, ktore zamowienia zamknac        
        if stat=='OK':
            if DaneKontr[0][1]:    
                LZamow=[]
                LZamowNZam=[]
                Where="WHERE zdp.firma_id='"+self.firma_id+"' AND zd.kontrahent_id='"+KontrDost+"' AND zd.stan='A'"
                if WyznZamDost.strip() not in ('',None,'None'):
                    Where+=" AND zdp.wyznacznik_id='"+rsglobal.Dekoduj(WyznZamDost)+"' AND zdp.data='"+rsglobal.Dekoduj(DataZamDost)+"' AND zdp.numer="+str(NumerZamDost)+" "

                SQL="SELECT zd.wyznacznik_id,zd.data,zd.numer,zdp.ilosc1-zdp.anulowano1-zdp.dostarczono1 "            
                SQL+="FROM rs_zamowienia_dostawcy_pozycje zdp "
                SQL+="LEFT OUTER JOIN rs_zamowienia_dostawcy zd ON (zdp.firma_id=zd.firma_id AND zdp.wyznacznik_id=zd.wyznacznik_id AND zdp.data=zd.data AND zdp.numer=zd.numer) "
                SQL+=Where
                SQL+=" ORDER BY zd.wyznacznik_id,zd.data,zd.numer"
                stat,DZamZam,dump,dump=self.PolSQL.Execute(SQL,3)
                
                if stat=='OK':    
                    for d in DZamZam:
                        Dok=(rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1]),str(d[2]))
                        if not Dok in LZamow:
                            LZamow.append(Dok)
                        if d[3]>0:
                            LZamowNZam.append(Dok)
                
                    UPDZam=''
                    for dok in LZamow:
                        if not dok in LZamowNZam:
                            UPDZam+="UPDATE rs_zamowienia_dostawcy SET stan='Z' WHERE firma_id='"+self.firma_id+"'"
                            UPDZam+="AND wyznacznik_id='"+dok[0]+"' AND data='"+dok[1]+"' AND numer="+dok[2]+";" 
                    if UPDZam != '':
                        stat,dump,dump,dump=self.PolSQL.Execute(UPDZam,1)
            

#-------------------------------------------------------------------------------
#--- O T W I E R A N I E
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==8:
    OtwZZamDost=False    
    if UprOtw!=True:
        stat='UPR OTW'
        dane.append(stat)

    if stat=='OK':
        Select ="SELECT stan FROM rs_dostawy"
        Select+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)

        if stat != 'OK':
            stat='BL BLOKADA'
        elif len(d) == 0:
            stat = 'Brak dostawy o podanym kluczu.'
        elif rsglobal.Dekoduj(d[0][0]) == 'K':
            stat = 'BL DOST OTW STAN K'
        
        
    if stat=='OK':
        Select="SELECT d_magazyn_id,d_dokument_id,d_data,d_numer, zd_wyznacznik, zd_data, zd_numer,pobrane_z_zamowien FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(d)>0:
                DMagazyn=rsglobal.Dekoduj(d[0][0])
                DDokument=rsglobal.Dekoduj(d[0][1])
                DData=rsglobal.Dekoduj(d[0][2])
                DNumer=d[0][3]
                ZDWyznacznik=rsglobal.Dekoduj(d[0][4])
                ZDData=rsglobal.Dekoduj(d[0][5])
                ZDNumer=d[0][6]
                ZZamowien=d[0][7]

                if (ZZamowien and ZDWyznacznik not in (None,'','None') and ZDData not in (None,'    -  -  ','None') and ZDNumer not in (None,0,'None')) or not ZZamowien:
                    OtwZZamDost=True

            else:
                stat='BL DOST OTW'
                dane.append(stat)
        else:
            stat='BL SQL DOST OTW'
            dane.append(stat)
        
        if not OtwZZamDost:
            stat='ZAM WSZYS'
            dane.append(stat)
           
        else:
            if stat=='OK':
                Select="SELECT stan FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+DMagazyn+"' AND dokument_id='"+DDokument+"' AND data='"+DData+"' AND numer="+str(DNumer)
                stat,d,dump,dump=self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if len(d)>0:
                        if d[0][0]<>'W':
                            stat='ZAM DOK MAG OTW'
                            dane.append(stat)
                    else:
                        stat='BR DOK MAG OTW'
                        dane.append(stat)
                else:
                    stat='BL SQL DOK MAG OTW'
                    dane.append(stat)
            
            
            if stat=='OK' and self.automat_numery:
                Select="SELECT * FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+DMagazyn+"' AND dokument_id='"+DDokument+"' AND data='"+DData+"' AND numer>"+str(DNumer)
                stat,d,dump,dump=self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if len(d)>0:
                        stat='BL NOT LAST DOK OTW'
                        dane.append(stat)
                else:
                    stat='BL SQL NOT LAST DOK OTW'
                    dane.append(stat)
            
            
            
            if stat=='OK':
                Update="UPDATE rs_dostawy SET stan='W',d_dokument_id=NULL,d_data=NULL,d_numer=NULL WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)   #MK 2020-03-11
                stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
            if stat=='OK':  #AB 05.06.23r
                Delete="DELETE FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+DMagazyn+"' AND dokument_id='"+DDokument+"' AND data='"+DData+"' AND numer="+str(DNumer)+";"
                Delete+="DELETE FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+DMagazyn+"' AND dokument_id='"+DDokument+"' AND data='"+DData+"' AND numer="+str(DNumer)
                stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
                if stat<>'OK':
                    stat='BL DEL DOK MAG OTW'
                    dane.append(stat)
            else:
                stat='BL UPD DOST OTW'
                dane.append(stat)
            #WYCOFYWANIE ILOSCI DOSTARCZONEJ Z ZAMOWIEN DO DOSTAWCY 
            if stat=='OK' and  ZZamowien:
                INSERT=''
                #pobranie pozycji z dostaw
                SQL="SELECT artykul_id, ilosc_dost1,ilosc_dost2,cena_z_zamowienia1,TRIM(COALESCE(cecha1_opis,'')),TRIM(COALESCE(cecha1_wartosc,'')) "
                SQL+="FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
                stat,DaneDP,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='BL SQL DP'
                    dane.append(stat)
                elif len(DaneDP)==0:
                    stat='BR SQL DP'
                    dane.append(stat)
                if stat=='OK':
                    #Tworzenie sownika z ilosciami dostarczonymi z dostaw
                    SlDost={}
                    if stat=='OK':
                        for w in DaneDP:
                            SlDost[(w[0],rsglobal.RSRound(w[3],4),w[4],w[5])]=[w[1],w[2]]    
    
                    #Pobranie pozycji z zamowien dostawcow
                    Select="SELECT dpz.artykul_id , dpz.cena_upust1 , dpz.dostarczono1 as ile1, dpz.dostarczono2 as ile2,dpz.nr_poz, "
                    Select+="TRIM(COALESCE(cecha1_opis,'')),TRIM(COALESCE(cecha1_wartosc,''))"
                    Select+="FROM rs_zamowienia_dostawcy_pozycje dpz "
                    Select+="WHERE dpz.firma_id='"+self.firma_id+"' AND dpz.wyznacznik_id='"+ZDWyznacznik+"' AND dpz.data='"+ZDData+"' AND dpz.numer="+str(ZDNumer)
                    Select+=" ORDER BY dpz.artykul_id, dpz.cena_upust1 ;"    
                    stat,DaneZam,dump,dump=self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    ArtCenaS=('',0,'','')
                    for poz in DaneZam:
                        ArtCenaS=(poz[0],rsglobal.RSRound(poz[1],4),poz[5],poz[6])
                        if ArtCenaS in SlDost:
                            ileD1=SlDost[ArtCenaS][0]
                            ileD2=SlDost[ArtCenaS][1]
                            if ileD1>0:
                                ile1=min(ileD1, poz[2])
                                ile2=min(ileD2, poz[3])
                                if ile1>0:
                                    INSERT+="UPDATE rs_zamowienia_dostawcy_pozycje  SET dostarczono1=dostarczono1-"+str(ile1)+" ,dostarczono2=dostarczono2-"+str(ile2)+" "
                                    INSERT+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+ZDWyznacznik+"' "
                                    INSERT+="AND data='"+ZDData+"' AND numer="+str(ZDNumer)+" AND nr_poz="+str(int(poz[4]))+"; "
    
    
                if stat=='OK':
                    INSERT+="UPDATE rs_zamowienia_dostawcy SET stan='A' "
                    INSERT+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+ZDWyznacznik+"' "
                    INSERT+="AND data='"+ZDData+"' AND numer="+str(ZDNumer)+"; "
                    stat,dump,dump,dump=self.PolSQL.Execute(INSERT,1)

 
#-------------------------------------------------------------------------------
# -- Usuwanie (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==6:
    if not UprDel:
        stat="UPR DEL"   
        dane.append(stat)

    if stat=='OK':
        Select ="SELECT stan FROM rs_dostawy"
        Select+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)

        if stat != 'OK':
            stat='BL BLOKADA'
        elif len(d) == 0:
            stat = 'Brak dostawy o podanym kluczu.'
        elif rsglobal.Dekoduj(d[0][0]) == 'K':
            stat = 'BL DOST USU STAN K'

    if stat=='OK':
        Filtr = "firma_id='"+self.firma_id+"' AND data = '"+Data+"' AND numer = "+str(Numer)
        sql="DELETE FROM rs_dostawy_pozycje WHERE " + Filtr + ";"
        sql+="DELETE FROM rs_dostawy_vat WHERE " + Filtr + ";"
        sql+="DELETE FROM rs_dostawy WHERE " + Filtr + ";"
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL SQL DEL'
            dane.append(stat)
        else:
            self.PolSQL.Commit()


#-------------------------------------------------------------------------------
# -- Pobranie danych
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,5,6,7,8]:
    if UprPrz:
        SELECT ="SELECT  z.data, z.numer,z.stan, z.kontrahent_id ||' - '||k.nazwa,z.kraj_wysylki ||' - '||p.nazwa,"
        SELECT+="z.kwota_netto,z.kwota_vat,z.d_magazyn_id,z.d_magazyn_id||'/'||z.d_dokument_id||'/'||z.d_data||'/'||z.d_numer,"
        SELECT+="z.wartosc_opakowan,z.do_zaplaty,z.zd_wyznacznik,z.zd_data,z.zd_numer,z.pobrane_z_zamowien "
        SELECT+="FROM rs_dostawy z LEFT OUTER JOIN rs_kontrahenci k ON (z.kontrahent_id=k.kontrahent_id AND z.firma_id=k.firma_id) "
        SELECT+="LEFT OUTER JOIN rs_kraje p ON (z.kraj_wysylki=p.kraj) "
        Filtr = " z.firma_id = '" + self.firma_id + "'"
        if Stan<>'':
            Filtr += " AND z.stan='" + Stan + "'"
        if Magazyn<>'':
            Filtr += " AND z.d_magazyn_id='" + Magazyn + "'"
        if DataOd not in puste_pola:
            Filtr += " AND z.data>='" + DataOd + "'"
        if DataDo not in puste_pola:
            Filtr += " AND z.data<='" + DataDo + "'"
        if Kontrahent.strip() != '':
            Filtr += " AND z.kontrahent_id LIKE '" + Kontrahent + "%'"
        if Kraj.strip() != '':
            Filtr += " AND z.kraj_wysylki LIKE '" + Kraj + "%'"
        stat, lista_magazynow= fs_dostawy_pom.PodajListeMagazynowZUprDoDokTypuP(self)
        if stat == 'OK':                                                                         #MK 2020-03-09
            Filtr+=" AND (d_magazyn_id IN ('" + "', '".join(lista_magazynow) + "', '') OR d_magazyn_id IS NULL)"
        if ((DataDo not in puste_pola) or (DataOd not in puste_pola)) and len(OstKlucze) > 0:
            FiltrPoz = " OR (z.firma_id= '" + self.firma_id + "' AND ("
            for poz in OstKlucze:
                FiltrPoz += "(z.data='" + poz[0] + "' AND z.numer=" + str(poz[1]) + ") OR "
            FiltrPoz = FiltrPoz[:-3] + "))"
            Filtr += FiltrPoz
        SELECT+=" WHERE "+Filtr
        SELECT+=" ORDER BY z.data DESC,z.numer DESC;"
        stat,dane,wyn1,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SELECT),3)
        if stat!="OK":
            stat="BL SQL PRZ"
            dane.append(stat)
        else:
            wyn2=[Numer,DokumentPowt]
    else:
        stat='UPR PRZ'

# ---------------------------------------------------
# Import faktury (11976) Jan Raburski 2020-05-06
# ---------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    if StanPoz != 'W':
        stat = 'Import moliwy tylko dla dostaw w stanie W'
    if stat == 'OK':
        if Plik == '':
            stat = 'Pusty plik z faktur.'
    if stat == 'OK':
        # sprawdzenie czy nie ma juz pozycji
        SQL = "SELECT count(*) FROM rs_dostawy_pozycje WHERE firma_id = '" + self.firma_id + "'"
        SQL += " AND data='" + str(Data) + "' AND numer=" + str(Numer)
        #rsglobal.ZapiszDoLogow('sprawdzenie pozycji:'+SQL,1)
        stat, lpoz, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat == 'OK':
            if lpoz[0][0] > 0:
                stat = 'Dostawa ma ju pozycje. Import niemoliwy.'
    if stat == 'OK':
        PlikWiersze = Plik.splitlines()
        if PlikWiersze[0] == 'TypPolskichLiter:LA':
            stat, naglowek, pozycje = fs_dostawy_pom.WczytajFaktureTxt1(self, PlikWiersze)
        elif Plik.find('<Document-Invoice>') > -1 :
            stat, naglowek, pozycje = fs_dostawy_pom.WczytajFaktureXmlEcod(self, Plik)
        else:
            stat = 'Nieobsugiwany typ pliku - poinformuj serwis.' + str(Plik.find('<Document-Invoice>'))

    if stat == 'OK':
        # update naglowka
        UPD = "UPDATE rs_dostawy SET kontrahent_id='" + naglowek[0] + "', nr_faktury='" + naglowek[1] + "',"
        UPD += " data_wystawienia='" + naglowek[2] + "', data_wplywu='" + naglowek[2] + "',"
        UPD += " termin_plat='" + naglowek[3] + "', kraj_wysylki='PL', waluta='PLN', waluta2='PLN',"
        UPD += " kurs=1, kurs2=1"
        UPD += " WHERE firma_id = '" + self.firma_id + "'"
        UPD += " AND data='" + str(Data) + "' AND numer=" + str(Numer)
        stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1)

    if stat == 'OK':
        # insert pozycji
        INSERT = ""
        for p in pozycje:
            # Pozycje - nrpoz, artykul_id, ilosc, cena, vat_procent, ilosc2, cena2, wartosc netto
            INSERT += "INSERT INTO rs_dostawy_pozycje (firma_id, data, numer, nr_poz,"
            INSERT += " artykul_id,ilosc_dost1,ilosc_dost2,cena_wal1,cena_wal2, "
            INSERT += " cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto, "
            INSERT += " cena_dostawy1,cena_dostawy2,wartosc_dostawy, "
            INSERT += " cena_dostawy1_pz,cena_dostawy2_pz,wartosc_dostawy_pz, "
            INSERT += " cena_upust1_pz,cena_upust2_pz, "
            INSERT += "  cena_upust1,cena_upust2,wartosc_netto, stawka_vat, wartosc_vat)"
            INSERT += " VALUES('" + self.firma_id + "','" + str(Data) + "'," + str(Numer) + "," + str(p[0])
            INSERT += ",'" + p[1] + "'," + str(p[2]) + "," + str(p[5]) + "," + str(p[3]) + "," + str(p[6])
            INSERT += "," + str(p[3]) + "," + str(p[6]) + "," + str(p[7])
            INSERT += "," + str(p[3]) + "," + str(p[6]) + "," + str(p[7])
            INSERT += "," + str(p[3]) + "," + str(p[6]) + "," + str(p[7])
            INSERT += "," + str(p[3]) + "," + str(p[6])
            INSERT += "," + str(p[3]) + "," + str(p[6]) + "," + str(p[7]) + ",'" + p[4] + "'," + str(p[8])
            INSERT += ");"
        if INSERT != '':
            stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1)
