# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dostawy_dane.py
# Purpose:     wczytuje/edytuje dane podstawowe dostawy
#
# Author:      Marcin Grzda
# Created:     2006/10/10
# RCS-ID:      $Id: fs_dostawy_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-11-14 Mariusz Rajfura: nowe pola: data_wystawienia,data_wplywu,termin_plat
#                             pobranie kraju kontrahenta (5197)
# 2013-03-08 Mariusz Rajfura (6657) blokada naglowka i pozycji(jesli potrzebne) przed modyfikacja
# 2020-03-06 Mikoaj Kozowski (11891) obsuga pola d_magazyn_id + sprawdzanie czy operator posiada uprawnienia do dokumentw typu P w danym magazynie
# 2020-04-05 Wojciech Skowron  (11919) nowe pola dla JPK_V7 - ozn_trans, ozn_nabycie, import
# 2020-06-22 Wojciech Skowron  (12019) Poprawka sprawdzania uprawnie do wprowadzonego magazynu
# 2021-07-29 Aleksander Bargie  (12587) [GM] Lokacja w dostawach

from funkcje import fs_dostawy_pom
from distutils.util import strtobool

#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci
puste_pola = [[],"","    -  -  "]

global firma_id
firma_id = self.firma_id
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Data': [3, 4, 5], 'Numer': [3, 4, 5], 'Magazyn': [15]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_operatorzy_uprawnienia_typy_plikow_zam_odb z numerem '+str(Funkcja)+' bez parametrw: '+Lista
dane=[]
wyn1=[]
wyn2=[]
if stat == 'OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']
if stat == 'OK' and Funkcja in (3, 4, 5):
    Data    = klucze['Data']
    Numer   = klucze['Numer']
if stat == 'OK' and Funkcja == 15:
    Magazyn=klucze['Magazyn']

global SprawdzCzyLokacje

def SprawdzCzyLokacje(self, mag):
    SQL = "SELECT czy_lokacje FROM rs_magazyny WHERE firma_id = '{}' AND magazyn_id = '{}';"
    SQL = SQL.format(firma_id, mag)
    stat, Lok, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return stat
    elif len(Lok) == 0:
        return 'False'
    else:
        return str(Lok[0][0])


def SprawdzPoprawnoscLokacji(self, lok, mag):
    if SprawdzCzyLokacje(self, mag) == 'False':
        return 'OK'
    SQL = "SELECT 1 FROM rs_lokacje WHERE firma_id = '{}' AND magazyn_id = '{}' AND lokacja_id = '{}';"
    SQL = SQL.format(firma_id, mag, lok)
    stat, Lok, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return stat
    else:
        if len(Lok) == 0:
            return u'Lokacja {} nie wystpuje w magazynie {}.'.format(lok, mag)
        else:
            return 'OK'


if self.operator_id != STANDARD_OPERATOR_ID:
    UprEdycja = ((self.oddzial_id,'035010') in self.uprawnienia)
else:
    UprEdycja = True
    
if Funkcja in (3,4):
    if not UprEdycja:
        stat='BL_UPR'
        dane.append(stat)
        
if Funkcja in (3,4) and stat=='OK':  # blokada dostawy
    sql ="SELECT * FROM rs_dostawy"
    sql+=" WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" FOR UPDATE;"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Nie mona zablokowa nagwka dostawy przed modyfikacj'
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak dostawy o podanym kluczu'
        dane.append(stat)
            

#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-----------------------------------------------------------------------------
if Funkcja in (3,4) and stat=='OK':
    Wersja=''
    Upust=-1
    Kontrahent=''
    Waluta=''
    Kurs=0
    lokacja = ''
    magazyn = ''

    if Data not in puste_pola:
        dane_wyn = rsglobal.SprawdzCzyToData(Data)
        if not dane_wyn:
            stat = "BL KLUCZ"
        else:
            sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+firma_id+self.oddzial_id+"\',\'"+Data+"\',1);"
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
            if dane_wyn <> 1:
                stat="ZK DATA"
                dane_wyn.append(stat)
        Filtr = "firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql="SELECT waluta,waluta2, d_magazyn_id FROM rs_dostawy WHERE "+Filtr+";"
        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
        if len(dane_wyn) == 0:
            stat = "BL KLUCZ"
            dane.append(stat)
        else:
            waluta1=dane_wyn[0][0]
            waluta2=dane_wyn[0][1]
            oryg_magazyn = dane_wyn[0][2]
    else:
        stat = "BL KLUCZ"
        dane.append(stat)
#-----------------------------------
    sql = "SELECT stan FROM rs_dostawy WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
    st,d,dump,dump=self.PolSQL.Execute(sql,3)
    if st<>'OK' or len(d)==0:
        stat="BL SQL STAN"
        dane.append(stat)
    else:
        Stan=rsglobal.Dekoduj(d[0][0])
        if Stan<>'W':
            stat='BL STAN'
            dane.append(stat)

    if stat=="OK":
        for i in range(len(Pola)):
            pole = Pola[i]
            wart = Wartosci[i]

#----------wyznacznik_id end -----------------
            if pole == "numer":
                if wart <=0:
                    stat="BL NUMER"
                    dane.append(stat)

#---------- oddzial_id end -----------------
            elif pole == "stan" and stat=='OK':
                if wart == "":
                    stat="BR STAN"
                    dane.append(stat)
                else:
                    if not wart in ["W","Z"]:
                        stat="BL STAN"
                        dane.append(stat)
#---------- stan end -----------------
            elif pole == "kontrahent_id"  and stat=='OK':
                if wart <>'':
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;",3)
                    if len(dane_wyn) == 0:
                        stat="BL KONTR"
                        dane.append(stat)
#---------- dostawa_do end -----------------
            elif pole == "waluta"  and stat=='OK':
                if wart == "":
                    stat="BR WALUTA"
                    dane.append(stat)
                else:
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id=\'"+firma_id+"\' AND kod= \'"+wart+"\';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WALUTA"
                        dane.append(stat)
                    else:
                        waluta1=wart
                        Waluta=wart
#----------waluta_2-------------------------------

            elif pole == "waluta2"  and stat=='OK':
                if wart == "":
                    stat="BR WALUTA2"
                    dane.append(stat)
                else:
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id=\'"+firma_id+"\' AND kod= \'"+wart+"\';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WALUTA2"
                        dane.append(stat)
                    else:
                        waluta2=wart
                        Waluta=wart
#---------- waluta end -----------------

            elif pole == "kraj_wysylki"  and stat=='OK':
                if wart <> "":
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kraj FROM rs_kraje WHERE kraj = \'"+wart+"\';",3)
                    if len(dane_wyn) == 0:
                        stat="BL KRAJ"
                        dane.append(stat)


#------------------------------------------------------------
            elif pole == "data_tabeli"  and stat=='OK':
                if wart== '    -  -  ':
                    Wartosci[i]="NULL"
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat="BL_DATA_TABELI"
                    dane.append(stat)

#------------------------------------------------------------
            elif pole == "data_tabeli2"  and stat=='OK':
                if wart== '    -  -  ':
                    Wartosci[i]="NULL"
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat="BL_DATA_TABELI2"
                    dane.append(stat)

#------------------------------------------------------------

            elif pole == "wersja" and stat=='OK':
                if wart == "":
                    Wartosci[i] = "NULL"
                else:
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id=\'"+firma_id+"\' AND kod = \'"+wart+"\';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WERSJA"
                        dane.append(stat)
                    else:
                        Wersja=wart

#------------------------------------------------------------

            elif pole=="rodzaj_transportu" and stat=='OK':
                if wart=="":
                    Wartosci[i]="NULL"
                else:
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_intrastat_rodzaje_transportu WHERE kod = \'"+wart+"\';",3)
                    if len(dane_wyn) == 0:
                        stat="BL RODZ TRANSP"
                        dane.append(stat)
##                        else:
##                            Wersja=wart

#------------------------------------------------------------ #WS 2020-04-05

            elif pole == 'ozn_trans' and stat=='OK':
                if wart.strip() == "":
                    Wartosci[i] = "NULL"
                else:
                    SQL = "SELECT kod FROM rs_transakcje_oznaczenia WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(SQL, 2, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd sprawdzenia oznaczenia transakcji: "+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = "BL_OZN_TRANS"
                        dane.append(stat)

#------------------------------------------------------------ #WS 2020-04-05

            elif pole == 'ozn_nabycie' and stat=='OK':
                if wart.strip() == "":
                    Wartosci[i] = "NULL"
                else:
                    SQL = "SELECT kod FROM rs_oznaczenia_nabycie WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(SQL, 2, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd sprawdzenia oznaczenia dowodu nabycia: "+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = "BL_OZN_NABYCIE"
                        dane.append(stat)

#------------------------------------------------------------

            elif pole=="warunki_dostawy" and stat=='OK':
                if wart=="":
                    Wartosci[i]="NULL"
                else:
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_intrastat_warunki_dostawy WHERE kod = \'"+wart+"\';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WAR DOST"
                        dane.append(stat)
##                        else:
##                            Wersja=wart

#------------------------------------------------------------

            elif pole == "data_wystawienia"  and stat=='OK':
                if wart== '    -  -  ':
                    Wartosci[i]="NULL"
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat="BL_DATA_WYSTAWIENIA"
                    dane.append(stat)

#------------------------------------------------------------

            elif pole == "data_wplywu"  and stat=='OK':
                if wart== '    -  -  ':
                    Wartosci[i]="NULL"
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat="BL_DATA_WPLYWU"
                    dane.append(stat)

#------------------------------------------------------------

            elif pole == "termin_plat"  and stat=='OK':
                if wart== '    -  -  ':
                    Wartosci[i]="NULL"
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat="BL_TERMIN_PLAT"
                    dane.append(stat)

#-------------------------------------------------------------- #MK 2020-03-10

            elif pole == "d_magazyn_id" and stat == 'OK':
                stat, lista_magazynow = fs_dostawy_pom.PodajListeMagazynowZUprDoDokTypuP(self)
                if stat <> "OK":
                    stat = 'BL_UPR_P'
                    dane.append(stat)
                else:
                    #WS 2020-06-22
                    if wart is not None and wart.strip() != '' and wart.ljust(4, ' ') not in lista_magazynow:
                    # if wart not in lista_magazynow:
                        stat = 'BL_NO_UPR_P'
                        dane.append(stat)
                    elif wart not in puste_pola:
                        magazyn = wart

#-------------------------------------------------------------- #AB 2021-07-29

            elif pole == "lokacja_id" and stat == 'OK':
                if wart not in puste_pola:
                    lokacja = wart

#--------------------------------------------------------------

        if waluta1.strip()<>'' and waluta2.strip()<>'' and waluta1<>waluta2:
            stat="INNE WAL"
            dane.append(stat)

# --------------------------------------------------------------

        if stat == 'OK' and lokacja not in puste_pola:  # test porawnoci lokacji
            mag_test = magazyn if magazyn not in puste_pola else oryg_magazyn
            stat = SprawdzPoprawnoscLokacji(self, lokacja, mag_test)


#---------- projekt_id end -----------------
    else:
        stat="BL_SQL"
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [4,3]:
    dane = []
    sql = "UPDATE rs_dostawy SET "
    Filtr = "firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
    for i in range(len(Pola)):
        wart = Wartosci[i]
        pole = Pola[i]
        #MK 2020-03-10 - d_magazyn_id
        if pole in ["kontrahent_id","kraj_wysylki","wersja","rodzaj_transportu","warunki_dostawy","nr_faktury", "d_magazyn_id", "lokacja_id"]:
            if wart in ["",'NULL']:
                sql += pole+"=NULL,"
            else:
                sql += pole+"=\'"+str(wart)+"\',"
        if pole in ["data","data_tabeli","data_tabeli2",
                    "data_wystawienia","data_wplywu","termin_plat",
                    "ozn_trans","ozn_nabycie"]:  #WS 2020-04-05
            if wart in puste_pola or wart in ['','NULL']:
                sql += pole+"=NULL,"
            else:
                sql += pole+"=\'"+str(wart)+"\',"
        elif pole in ['miejsc_po_przecinku','numer','kwota_netto','kwota_vat','wartosc_opakowan','do_zaplaty','kurs','kurs2','transport_proc','narzut_proc']:
            sql += pole+"="+str(wart)+","
        elif pole in ["stan","waluta","nr_tabeli","waluta2","nr_tabeli2"]:
            sql += pole+"='"+str(wart)+"',"
        #WS 2020-04-05
        # Checkboxy
        elif pole in ["import"]:
            if wart is True:
                sql += pole+"=TRUE,"
            else:
                sql += pole+"=FALSE,"
    sql = sql.strip(',')
    sql += " WHERE "+Filtr+";"
    
    stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
    if stat != 'OK':
        stat = 'BL_SQL'
        dane.append(stat)
    else:
        #------------UPDATE pozycji-----------------------------------------
        if (('wersja' in pola) or ('waluta' in pola) or ('kontrahent' in pola) or ('miejsc_po_przecinku' in pola)):
            sql = "SELECT wersja,waluta,kontrahent_id,miejsc_po_przecinku FROM rs_dostawy WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer='"+str(Numer)+"';"
            st,d,dump,dump=self.PolSQL.Execute(sql,3)
            if st=='OK' and len(d)>0:
                wersja=rsglobal.Dekoduj(d[0][0])
                waluta=rsglobal.Dekoduj(d[0][1])
                kontrahent=rsglobal.Dekoduj(d[0][2])
                IlMPP=str(d[0][3]).rstrip('.0')
                if wersja not in ["",None,'None']:
                    Select="SELECT nr_poz,artykul_id FROM rs_dostawy_pozycje WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
                    st,d,dump,dump=self.PolSQL.Execute(Select,3)
                    if st=='OK':
                        for wiersz in d:
                            NrPoz=rsglobal.Dekoduj(wiersz[0])
                            Art=rsglobal.Dekoduj(wiersz[1])
                            sql="SELECT rsf_podaj_ceny_dla_kontrahenta('"+str(firma_id)+"','"+str(kontrahent)+"','"+waluta+"','"+Data+"','"+Art+"','"+wersja+"',-1)"
                            st,d,dump,dump=self.PolSQL.Execute(sql,3)
                            if st<>'OK':
                                stat='BL SQL CENY'
                                dane.append(stat)
                                break
                            else:
                                da=rsglobal.rseval(d[0][0])
                                cena_wal1=str(da[0])
                                cena_wal2=str(da[1])
                                cena_upust_wal1="round("+cena_wal1+"*(100-upust_procent)*0.01,"+IlMPP+")"
                                cena_upust_wal2="round("+cena_wal2+"*(100-upust_procent)*0.01,"+IlMPP+")"
                                Update="Update rs_dostawy_pozycje SET cena_wal1=round("+cena_wal1+","+IlMPP+"),cena_wal2=round("+cena_wal2+","+IlMPP+")"
                                Update+=",cena_upust_wal1="+cena_upust_wal1+",cena_upust_wal2="+cena_upust_wal2
                                Update+=" WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
                                st,dump,dump,dump=self.PolSQL.Execute(Update,1)
                                if st<>'OK':
                                    stat='BL UPD'
                                    dane.append(stat)
                                    break
                    else:
                        stat='BL SEL POZ WER'
                        dane.append(stat)
            else:
                stat='BL SEL DANE DOST'
                dane.append(stat)
                
        if ('kurs2' in pola) or ('kurs' in pola) or ('narzut_proc' in pola) or ('wersja' in pola) or ('waluta' in pola) or ('kontrahent' in pola) or ('transport_proc' in pola) or ('miejsc_po_przecinku' in pola):
            Select="SELECT kurs,narzut_proc,transport_proc,kurs2,miejsc_po_przecinku FROM rs_dostawy WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
            st,d,dump,dump=self.PolSQL.Execute(Select,3)
            if st=='OK' and len(d)>0:
                Kurs=d[0][0]
                Narzut=d[0][1]
                Transport=d[0][2]
                Kurs2=d[0][3]
                IlMPP=str(d[0][4]).rstrip('.0')
            
                CenaUpust1="round(cena_wal1*(100-upust_procent)*0.01*"+str(Kurs)+"*(100+"+str(Transport)+")*0.01,2)"
                CenaUpust2="round(cena_wal2*(100-upust_procent)*0.01*"+str(Kurs)+"*(100+"+str(Transport)+")*0.01,2)"
                WartoscNetto="round(ilosc_dost1*"+CenaUpust1+",2)"
                WartoscNarzut="round("+WartoscNetto+"*"+str(Narzut)+"*0.01,2)"
                WartoscClo="round(("+WartoscNetto+" + "+WartoscNarzut+")*clo_procent*0.01,2)"
                
                CenaUpust1PZ="round(round(cena_wal1*(100-upust_procent)*0.01*"+str(Kurs2)+",2)*(100+"+str(Transport)+")*0.01,2)"
                CenaUpust2PZ="round(round(cena_wal2*(100-upust_procent)*0.01*"+str(Kurs2)+",2)*(100+"+str(Transport)+")*0.01,2)"
                WartoscNettoPZ="round(ilosc_dost1*"+CenaUpust1PZ+",2)"
                WartoscNarzutPZ="round("+WartoscNettoPZ+"*"+str(Narzut)+"*0.01,2)"
                WartoscCloPZ="round(("+WartoscNettoPZ+" + "+WartoscNarzutPZ+")*clo_procent*0.01,2)"
                
                WartoscVAT="round(("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")*(CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE CAST( TRIM(LEADING '0' from stawka_vat) AS NUMERIC) END)*0.01,2)"
                CenaDostawy1="round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")/ilosc_dost1 END,2)"
                CenaDostawy2="round(CASE WHEN ilosc_dost2=0 THEN 0 ELSE ("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")/ilosc_dost2 END,2)"
                WartoscDostawy="round(round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")/ilosc_dost1 END,"+IlMPP+")*ilosc_dost1"+",2)"
                
                CenaDostawy1PZ="round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNettoPZ+" + "+WartoscNarzutPZ+" + "+WartoscCloPZ+")/ilosc_dost1 END,2)"
                CenaDostawy2PZ="round(CASE WHEN ilosc_dost2=0 THEN 0 ELSE ("+WartoscNettoPZ+" + "+WartoscNarzutPZ+" + "+WartoscCloPZ+")/ilosc_dost2 END,2)"
                WartoscDostawyPZ="round(round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNettoPZ+" + "+WartoscNarzutPZ+" + "+WartoscCloPZ+")/ilosc_dost1 END,"+IlMPP+")*ilosc_dost1"+",2)"
                
                Update="UPDATE rs_dostawy_pozycje SET wartosc_netto="+WartoscNetto+",wartosc_narzut="+WartoscNarzut+",wartosc_clo="+WartoscClo
                Update+=",wartosc_vat="+WartoscVAT+",cena_dostawy1="+CenaDostawy1+",cena_dostawy2="+CenaDostawy2+",wartosc_dostawy="+WartoscDostawy
                Update+=",cena_upust1="+CenaUpust1+",cena_upust2="+CenaUpust2
                Update+=",cena_upust1_pz="+CenaUpust1PZ+",cena_upust2_pz="+CenaUpust2PZ 
                Update+=", wartosc_netto_pz="+WartoscNettoPZ+",wartosc_narzut_pz="+WartoscNarzutPZ+",wartosc_clo_pz="+WartoscCloPZ
                Update+=",cena_dostawy1_pz="+CenaDostawy1PZ+",cena_dostawy2_pz="+CenaDostawy2PZ+",wartosc_dostawy_pz="+WartoscDostawyPZ
                Update+=" WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
                rsglobal.ZapiszDoLogow(Update,5)
                st,dump,dump,dump=self.PolSQL.Execute(Update,1)
                if st<>'OK':
                    stat="BL SQL UPD POZ"
                    dane.append(stat)
            else:
                stat="BL SQL UPD POZ"
                dane.append(stat)

                
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (Funkcja in [15]) and (stat=='OK'):
    wyn = SprawdzCzyLokacje(self, Magazyn)
    if wyn in ('True', 'False'):
        stat = 'OK'
        dane = strtobool(wyn)
    else:
        stat = wyn
    if ((self.oddzial_id, '031000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat2, wyn, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id=\'%s\' AND magazyn_id='%s';" % (firma_id, Magazyn),3)
        if stat2 == 'OK':
            if len(wyn)>0:
                wyn1=wyn[0][0]
        else:
            wyn1 = "Nd pobierania opisu magazynu"
    else:
        wyn1='Brak uprawnie do magazynw. Poinformuj administratora.'

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (Funkcja in [5,3,1]) and (stat=='OK'):
    where="WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)
    sql = "SELECT * FROM rs_dostawy " + where + ";"

    # pobranie danych
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    
    #pobranie danych do opisow
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        #kontrahent [0]
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #kraj wysylki [1]
        if ((self.oddzial_id,'011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kraje WHERE kraj='"+tr.GetVal(0,"kraj_wysylki")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        #waluta 1 [2]
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #waluta 2 [3]
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+firma_id+"' AND kod='"+tr.GetVal(0,"waluta2")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        #wersja [4]
        if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
            
        #rodzaj transportu [5]
        if ((self.oddzial_id,'011390') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_intrastat_rodzaje_transportu WHERE kod='"+tr.GetVal(0,"rodzaj_transportu")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
            
        # kraj kontrahenta [6]
        sql ="SELECT k.kraj FROM rs_dostawy d"
        sql+=" LEFT JOIN rs_kontrahenci k using (firma_id, kontrahent_id)"
        sql+=" WHERE d.firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            wyn2.append('Bd pobrania kraju kontrahenta: '+stat)
        else:
            wyn2.append(d[0][0])

        # magazyn [7]  #MK 2020-03-11
        if ((self.oddzial_id, '031000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute(
                "SELECT opis FROM rs_magazyny WHERE firma_id='"+firma_id+"' AND magazyn_id='"+tr.GetVal(0,"d_magazyn_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        # oznaczenia transkacji [8]  #WS 2020-04-05
        if ((self.oddzial_id,'211430') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_transakcje_oznaczenia WHERE kod='"+tr.GetVal(0,"ozn_trans")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        # oznaczenia dowodw nabycia [9]  #WS 2020-04-05
        if ((self.oddzial_id,'211450') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_oznaczenia_nabycie WHERE kod='"+tr.GetVal(0,"ozn_nabycie")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        # lokacja [10]
        if ((self.oddzial_id,'014130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_lokacje WHERE firma_id='"+firma_id+"' AND lokacja_id='"+tr.GetVal(0,"lokacja_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bdy przy pobieraniu opisu lokacji:'+stat
                dane.append(stat)
            else:
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania lokacji.')
