#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_dostawy.py
# Purpose:          funkcje pomocnicze dostaw
# Author:           Mikoaj Kozowski
# Created:          2020/03/10
# RCS-ID:           $Id: fs_dostawy_pom.py $
# Copyright:        (c) 2020 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------
# 2020-05-14 Jan Raburski (11976) funkcje obrobki wczytania faktur

import rs_anakonda_daty
import rsglobal
from funkcje.fs_xml import XmlToRS

##############################################################################################
#--- WCZYTANIE PLIKU TEKSTOWEGO TYP 1
##############################################################################################
def WczytajFaktureTxt1(self, Wiersze):
    # Naglowek = [kontrahent_id,faktura,data,terminplatnosci,kwota_netto,kwota_vat,kwota_brutto, slownik{stawka}=[netto,vat]
    # Pozycje - nrpoz, artykul_id, ilosc, cena, vat_procent, ilosc2, cena2, wartosc netto, wartosc vat
    Naglowek = []
    Pozycje = []

    nip = Wiersze[12][12:].strip().replace('-', '')
    kodpocztowy = Wiersze[9][12:].strip()
    SQL = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '" + self.firma_id + "'"
    SQL += " AND REPLACE (TRIM(nip),'-','') = '" + nip + "' AND adr_kod='" + kodpocztowy + "'"
    SQL += " AND dostawca AND aktywny;"
    stat, kontr, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return 'Bd szukania kontrahenta' + stat, Naglowek, Pozycje
    if len(kontr) == 1:
        Naglowek.append(kontr[0][0])
    else:
        return 'Jest ' + str(len(kontr)) + 'kontrahentw o NIP ' + nip + ' i kodzie ' + kodpocztowy + '.', Naglowek, Pozycje
    Naglowek.append(Wiersze[2][6:].strip())  # nr faktury
    datawyst = Wiersze[3][5:].strip()
    if datawyst[2] == '.':    # data w formacie dd.mm.rrrr
        datawyst = datawyst[6:] + '-' + datawyst[3:5] + '-' + datawyst[0:2]
    Naglowek.append(datawyst)
    termin = Wiersze[5][12:].strip()
    if len(termin) > 2:        # data a nie liczba dni
        if termin[2] == '.':    # data w formacie dd.mm.rrrr
            termin = termin[6:] + '-' + termin[3:5] + '-' + termin[0:2]
    else:      # liczba dni
        dni = int(termin)
        termin = rs_anakonda_daty.DodajKilkaDni(datawyst, dni)
    Naglowek.append(termin)

    SQL = "SELECT artykul_id FROM rs_artykuly WHERE firma_id = '" + self.firma_id + "'"
    SQL += " AND nazwa='TOWAR DO WPROWADZENIA' AND aktywny; "
    stat, art, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return 'Bd szukania artykuu tymczasowego' + stat, Naglowek, Pozycje
    if len(art) == 0:
        return 'Brak artykuu tymczasowego', Naglowek, Pozycje
    ArtTymcz = art[0][0].strip()

    nrwiersza = 20
    IloscLinii = 0
    NrLinii = 0
    Poz = {}
    Poz['Nr'] = 0;  Poz['Art'] = '';  Poz['Ilosc'] = 0; Poz['Cena'] = 0; Poz['StawkaVat'] = ''
    while True:
        nrwiersza += 1
        if Wiersze[nrwiersza][0:10] == 'Stawka:Vat':
            break
        if Wiersze[nrwiersza][0:10] == 'IloscLinii':
            IloscLinii = int(Wiersze[nrwiersza][11:].strip())
        if Wiersze[nrwiersza][0:6] == 'Linia:':
            if Poz['Nr'] > 0:
                if Poz['Art'] != '' and Poz['Ilosc'] > 0 and Poz['Cena'] > 0 and Poz['StawkaVat'] != '':
                    Pozycje.append([Poz['Nr'], Poz['Art'], Poz['Ilosc'], Poz['Cena'], Poz['StawkaVat'], Poz['Ilosc2'], Poz['Cena2'],Poz['Wartosc'],Poz['WartoscVat']])
                else:
                    return 'Brak danych dla linii nr '+str(Poz['Nr']), Naglowek, Pozycje
            NrLinii += 1
            # inicjacja
            Poz['Nr'] = NrLinii;  Poz['Art'] = '';  Poz['Ilosc'] = 0; Poz['Cena'] = 0; Poz['StawkaVat'] = ''

        # kod artykulu, traktujemy jako ean, jesli nie znajdziemy podstawiamy tymczasowy
        i = Wiersze[nrwiersza].find('Kod{')
        if i > 0:
            w = Wiersze[nrwiersza][i+4:]
            i = w.find('}')
            w = w[:i].strip()
            SQL = "SELECT artykul_id, przelicznik, zbiorczy, liczba_sztuk_w_opakowaniu FROM rs_artykuly_ean"
            SQL += " INNER JOIN rs_artykuly USING (firma_id, artykul_id) WHERE firma_id = '" + self.firma_id + "'"
            SQL += " AND ean='" + w + "';"
            stat, art, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                return 'Bd szukania kodu EAN ' + stat, Naglowek, Pozycje
            if len(art) == 0:
                Poz['Art'] = ArtTymcz
                Przelicznik = 1.0
                Zbiorczy = False
                LiczbaSztuk = 1
            else:
                Poz['Art'] = art[0][0].strip()
                Przelicznik = art[0][1]
                Zbiorczy = art[0][2]
                LiczbaSztuk = art[0][3]
        # ilosc artykulu
        i = Wiersze[nrwiersza].find('Ilosc{')
        if i > 0:
            w = Wiersze[nrwiersza][i+6:]
            i = w.find('}')
            w = w[:i]
            if not Zbiorczy:
                Poz['Ilosc'] = float(w)
            else:
                # kod ean na opakowanie zbiorcze, przeliczenie ilosci na sztuki
                Poz['Ilosc'] = float(w) * LiczbaSztuk
            Poz['Ilosc2'] = rsglobal.RSRound(Poz['Ilosc'] * Przelicznik,3)
        # cena artykulu
        i = Wiersze[nrwiersza].find('Cena{n')
        if i > 0:
            w = Wiersze[nrwiersza][i+6:]
            i = w.find('}')
            w = w[:i]
            if not Zbiorczy:
                Poz['Cena'] = float(w)
            else:
                # kod ean na opakowanie zbiorcze, przeliczenie ceny na sztuke
                Poz['Cena'] = rsglobal.RSRound(float(w) / LiczbaSztuk, 2)
            Poz['Cena2'] = rsglobal.RSRound(Poz['Cena'] / Przelicznik,2)
        # wartosc pozycji
        i = Wiersze[nrwiersza].find('Wartosc{n')
        if i > 0:
            w = Wiersze[nrwiersza][i+9:]
            i = w.find('}')
            w = w[:i]
            Poz['Wartosc'] = float(w)
            if Poz['StawkaVat'] != '':
                Poz['WartoscVat'] = rsglobal.RSRound(float(w) * float(Poz['StawkaVat']) * 0.01, 2)
        # stawka vat
        i = Wiersze[nrwiersza].find('Vat{')
        if i > 0:
            w = Wiersze[nrwiersza][i+4:]
            i = w.find('}')
            w = w[:i].strip()
            if len(w) == 1:
                w = '0' + w
            Poz['StawkaVat'] = w
            if Poz['Wartosc'] != 0:
                Poz['WartoscVat'] = rsglobal.RSRound(float(w) * float(Poz['Wartosc']) * 0.01, 2)

    # zapis ostatniej pozycji po wyjsciu z petli
    if Poz['Nr'] > 0:
        if Poz['Art'] != '' and Poz['Ilosc'] > 0 and Poz['Cena'] > 0 and Poz['StawkaVat'] != '':
            Pozycje.append([Poz['Nr'], Poz['Art'], Poz['Ilosc'], Poz['Cena'], Poz['StawkaVat'], Poz['Ilosc2'], Poz['Cena2'], Poz['Wartosc'],Poz['WartoscVat']])
        else:
            return 'Brak danych dla linii nr ' + str(Poz['Nr']), Naglowek, Pozycje

    if IloscLinii != NrLinii:
        return 'Liczba pozycji niezgodna ze zdefiniowan.', Naglowek, Pozycje


    return 'OK', Naglowek, Pozycje

##############################################################################################
#--- WCZYTANIE PLIKU XML ECOD
##############################################################################################
def WczytajFaktureXmlEcod(self, Plik):
    # Naglowek = [kontrahent_id,faktura,data,terminplatnosci,kwota_netto,kwota_vat,kwota_brutto, slownik{stawka}=[netto,vat]
    # Pozycje - nrpoz, artykul_id, ilosc, cena, vat_procent, ilosc2, cena2, wartosc netto, wartosc vat
    Naglowek = []
    Pozycje = []

    # --- inicjacja
    xml = XmlToRS()
    if not xml.Inicjuj(Plik):
        return 'Niepoprawny plik XML', Naglowek, Pozycje

    # --- sprawdzenie poprawnosci pliku (czy to faktura i czy dla nas)
    if not xml.CzyJestTag('Document-Invoice'):
        return 'Plik xml nie zawiera faktury', Naglowek, Pozycje

    nip = xml.PodajWartosc(['Invoice-Parties', 'Payer', 'TaxID'])
    sql = "SELECT oddzial_id FROM rs_oddzialy"
    sql += " WHERE firma_id='" + self.firma_id + "'"
    sql += " AND nip='" + nip + "';"
    stat, oddzialy, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(oddzialy) == 0:
            return 'Brak oddziau o NIP=' + nip, Naglowek, Pozycje
    else:
       return 'Bd pobrania listy oddziaw: ' + stat, Naglowek, Pozycje

    # --- wyszukanie dostawcy
    DostawcaILN = xml.PodajWartosc(['Invoice-Parties', 'Seller', 'ILN'])
    sql = "SELECT kontrahent_id FROM rs_kontrahenci"
    sql += " WHERE firma_id='" + self.firma_id + "'"
    sql += " AND dostawca AND aktywny AND gln='" + DostawcaILN + "';"
    stat, dostawcy, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(dostawcy) == 0:
            return 'Brak dostawcy o GLN=' + DostawcaILN, Naglowek, Pozycje
        elif len(dostawcy) > 1:
            return 'Wicej ni 1 dostawca o GLN=' + DostawcaILN, Naglowek, Pozycje
        else:
            Naglowek.append(dostawcy[0][0])
    else:
        return 'Bd pobrania dostawcy: ' + stat, Naglowek, Pozycje

    Naglowek.append(xml.PodajWartosc(['Invoice-Header', 'InvoiceNumber']))
    Naglowek.append(xml.PodajWartosc(['Invoice-Header', 'InvoiceDate']))
    Naglowek.append(xml.PodajWartosc(['Invoice-Header', 'InvoicePaymentDueDate']))

    # wyszukanie artykulu tymczasowego do wprowadzenia
    SQL = "SELECT artykul_id FROM rs_artykuly WHERE firma_id = '" + self.firma_id + "'"
    SQL += " AND nazwa='TOWAR DO WPROWADZENIA' AND aktywny; "
    stat, art, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return 'Bd szukania artykuu tymczasowego' + stat, Naglowek, Pozycje
    if len(art) == 0:
        return 'Brak artykuu tymczasowego', Naglowek, Pozycje
    ArtTymcz = art[0][0].strip()

    Wiersze = xml.PodajListeWierszy(['Invoice-Lines', 'Line', 'Line-Item'], ['LineNumber', 'EAN', 'InvoiceQuantity', 'InvoiceUnitNetPrice', 'TaxRate', 'NetAmount', 'TaxAmount'])
    for w in Wiersze:
        SQL = "SELECT artykul_id, przelicznik, zbiorczy, liczba_sztuk_w_opakowaniu FROM rs_artykuly_ean"
        SQL += " INNER JOIN rs_artykuly USING (firma_id, artykul_id) WHERE firma_id = '" + self.firma_id + "'"
        SQL += " AND ean='" + w[1].strip() + "';"
        stat, art, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            return 'Bd szukania kodu EAN ' + stat, Naglowek, Pozycje
        if len(art) == 0:
            Art = ArtTymcz
            Przelicznik = 1.0
            Zbiorczy = False
            LiczbaSztuk = 1
        else:
            Art = art[0][0].strip()
            Przelicznik = art[0][1]
            Zbiorczy = art[0][2]
            LiczbaSztuk = art[0][3]
        VAT = str(w[4])
        VAT = VAT[:VAT.find('.')]
        if len(VAT) == 1:
            VAT = '0' + VAT
        if Zbiorczy:
            # kod ean na opakowanie zbiorcze, przeliczenie ilosci i cen na sztuki
            w[2] = str(rsglobal.RSRound(float(w[2]) * LiczbaSztuk, 0))
            w[3] = str(rsglobal.RSRound(float(w[3]) / LiczbaSztuk,2))
        Pozycje.append([w[0], Art, float(w[2]), float(w[3]), VAT, rsglobal.RSRound(float(w[2]) * Przelicznik,3), rsglobal.RSRound(float(w[3]) / Przelicznik,3), float(w[5]), float(w[6])])

    return 'OK', Naglowek, Pozycje

##############################################################################################
#---WYSZUKIWANIE LISTY MAGAZYNOW DLA KTORYCH OPERATOR MA UPRAWNIENIA DO DOKUMENTOW TYPU 'P'
##############################################################################################
def PodajListeMagazynowZUprDoDokTypuP(self):
    if self.operator_id=='0':
        sql = "SELECT DISTINCT d.magazyn_id"
        sql += " FROM rs_dokumenty_m_upr d"
        sql += " INNER JOIN rs_typy_dokumentow_m t USING (firma_id,dokument_id)"
        sql += " WHERE firma_id='"+self.firma_id+"' AND t.typ_dokumentu='P';"
    else:
        sql="SELECT DISTINCT d.magazyn_id"
        sql+=" FROM rs_dokumenty_m_upr d"
        sql+=" INNER JOIN rs_typy_dokumentow_m t USING (firma_id,dokument_id)"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND d.operator_id=rsf_getuserid() AND t.typ_dokumentu='P';"

    stat,LMag,dump,dump = self.PolSQL.Execute(sql,3)

    if stat <> 'OK':
        rsglobal.ZapiszDoLogow("Bd zapytania! :" + stat, LMag)
        return 'Bdy sprawdzania uprawnie magazynowych : ' + stat, []
    if len(LMag) == 0:
        return 'Brak uprawnie do dokumentw magazynowych typu "P". ', []

    return 'OK', [ x[0] for x in LMag]
