#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dostawy_pozycje.py
# Purpose:     przeglda pozycje dostaw
# Author:      Marcin Natkaski
# Created:     2007/08/25
# RCS-ID:      $Id: fs_dostawy_pozycje.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2012-01-27 Marcin Natkaski           (refaktoryzacja kodu)
#2013-03-08 Mariusz Rajfura     (6657) blokada pozycji przed modyfikacja
#2020-06-15 Aleksander Bargie (12007) [HD] F1 w GM dla magazynu detalicznego

#AB 15.06.20r
import rssql

stat = 'OK'
dane = []
#AB 15.06.20r
wyn2 = []
puste = ('', None, 'None', 'NULL')

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Data':[5,6],'Numer':[5,6],'KrajF':[5,6,7],'KodF':[5,6,7],
    'Artykul':[5,6],'NrPoz':[6],'Kraj':[7],'Kod':[7]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dostawy_pozycje z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [5,6,7]:
        Data=rsglobal.Dekoduj(klucze['Data'])
        Numer=str(klucze['Numer'])
        KrajF=rsglobal.Dekoduj(klucze['KrajF'])
        KodF=rsglobal.Dekoduj(klucze['KodF'])
        Artykul=rsglobal.Dekoduj(klucze['Artykul'])
    if Fun in [6,7]:
        NrPoz=str(klucze['NrPoz'])
    if Fun in [7]:
        Kraj=rsglobal.Dekoduj(klucze['Kraj'])
        Kod=rsglobal.Dekoduj(klucze['Kod'])

UprDel = ((self.oddzial_id,'035024') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprEdy = ((self.oddzial_id,'035022') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# -- Usuwanie 6 
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [6] and stat=='OK':    
    if not UprDel:
        stat="UPR DEL"   
        dane.append(stat)
    if stat=='OK':
        sql="DELETE FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"' "
        sql+="AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz="+str(NrPoz)+" "
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL SQL DEL'
            dane.append(stat)
        if stat=='OK':
            #przenumerowanie pozycji po usuniciu    
            UPD="UPDATE rs_dostawy_pozycje SET nr_poz=nr_poz + 500 WHERE firma_id='"+self.firma_id+"' "
            UPD+=" AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz>"+str(NrPoz)+" ;"
            UPD+="UPDATE rs_dostawy_pozycje SET nr_poz=nr_poz - 501 WHERE firma_id='"+self.firma_id+"' "
            UPD+=" AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz>"+str(NrPoz)+" ;"
            stat,dump,dump,dump=self.PolSQL.Execute(UPD,1)
            if stat<>'OK':
                stat='BL SQL UPD'
                dane.append(stat)
            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# -- Zmiana masowa kraju pochodzenia i kodu transakcji [7]
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [7] and stat=='OK':
    if not UprEdy:
        stat="UPR EDY"  
        dane.append(stat)
    if stat=='OK':
        # blokada pozycji przed modyfikacja
        sql="SELECT * FROM rs_dostawy_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
        sql+=" AND nr_poz="+str(NrPoz)+" FOR UPDATE;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Nie mona zablokowa pozycji przed modyfikacj'
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak pozycji o podanym kluczu'
            dane.append(stat)
        
    if stat=='OK':
        #sprawdzenie stanu dostawy
        sql="SELECT stan FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' "
        sql+="AND data = '"+Data+"' AND numer = "+str(Numer)
        stat,DStan,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL SQL STAN'
            dane.append(stat)
            
        if stat=='OK':
            if len(DStan)==0:
                stat="BR DOST"   
                dane.append(stat)
            elif DStan[0][0] <> 'W':
                stat='BL STAN W'   
                dane.append(stat)
    
        if stat=='OK': 
            # zmieniamy kraj   
            if Kraj not in ['',None]:
                sql="UPDATE rs_dostawy_pozycje SET kraj_pochodz='"+Kraj+"' "
                sql+="WHERE firma_id='"+self.firma_id+"' AND data = '"+Data+"' AND numer = '"+str(Numer)+"' "
                stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
                if stat<>'OK':
                    stat="BL UPD KR"   
                    dane.append(stat)
                    
        if stat=='OK':
            #zmieniamy kod transakcji
            if Kod not in ['',None]:
                sql="UPDATE rs_dostawy_pozycje SET kod_transakcji='"+Kod+"' "
                sql+="WHERE firma_id='"+self.firma_id+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" "
                stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            else:
                stat='BL KOD TRANS'   
                dane.append(stat)
            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---- SELECT - 5,6,7  
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [5,6,7] and stat=='OK':
    SELECT="SELECT  z.nr_poz, z.kraj_pochodz ||' - '|| p.nazwa,z.kod_transakcji,"
    SELECT+=" z.artykul_id ||' - '||k.nazwa,z.cecha1_opis,z.cecha1_wartosc,rsf_podaj_parametry_cechy(z.firma_id,z.cecha1_opis,z.cecha1_wartosc,'opis'),z.ilosc_zam1,z.ilosc_dost1,z.cena_upust_wal1,z.stawka_vat,"
    SELECT+="z.wartosc_vat,z.wartosc_netto,z.wartosc_wal_netto, nagl.d_magazyn_id"
    SELECT+=" FROM rs_dostawy nagl "
    #AB 15.06.20r
    SELECT+=" LEFT JOIN rs_dostawy_pozycje z USING (firma_id, data, numer) "
    SELECT+=" LEFT OUTER JOIN rs_artykuly k ON (z.artykul_id=k.artykul_id AND z.firma_id=k.firma_id) "
    SELECT+=" LEFT OUTER JOIN rs_kraje p ON (z.kraj_pochodz=p.kraj) "
    SELECT+=" WHERE nagl.firma_id = '" + self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
    if KrajF.strip() <>'':
        SELECT+=" AND z.kraj_pochodz='"+KrajF.strip()+"'"
    if KodF.strip() <>'':
        SELECT+=" AND z.kod_transakcji='"+KodF.strip()+"'"
    if Artykul.strip() <>'':
        SELECT+=" AND z.artykul_id LIKE '"+Artykul+"%'"
    SELECT+=" ORDER BY z.data,z.numer,z.nr_poz;"
                #AB 15.06.10r wyn2 na dump bo nie wykorzystuje sie wyniku PolSQL.Execute
    stat,dane,wyn1,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SELECT),3)
    rsglobal.ZapiszDoLogow(rsglobal.Dekoduj(SELECT))
    if stat<>'OK':
        stat='BL SQL PRZ'
        dane.append(stat)
    else:
        #AB 15.06.10r
        #sprawdzenie czy magazyn jest detaliczny

        rsglobal.ZapiszDoLogow(dane)
        tr = rssql.RSTableRowset(dane, wyn1)
        Mag = tr.GetVal(0,"d_magazyn_id")
        if not  tr.GetVal(0,"nr_poz"):
            dane = []

        if Mag not in puste:
            sql = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, Mag)
            stat, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat == 'OK':
                if len(Detaliczny) == 0:
                    rsglobal.ZapiszDoLogow(Mag)
                    rsglobal.ZapiszDoLogow(Detaliczny)
                    rsglobal.ZapiszDoLogow(sql)
                    stat = 'Bd sprawdzania czy magazyn jest detaliczny.'
                else:
                    wyn2.append(Detaliczny[0][0])
            else:
                wyn2.append(False)
                rsglobal.ZapiszDoLogow(Mag)
                rsglobal.ZapiszDoLogow(Detaliczny)
                rsglobal.ZapiszDoLogow(sql)
                stat = 'Bd sprawdzania czy magazyn jest detaliczny: ' + stat
        else:
            wyn2.append(False)
        if dane:
            dane = [x[0:-1] for x in dane]
