# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_faktury_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji faktury
#
# Author:      Marcin Grzda
# Created:     2006/12/27
# RCS-ID:      $Id:$
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2010-12-18 Mariusz Rajfura     (4150) edytowalna stawka VAT
#2011-11-15 Mariusz Rajfura     (5197) pobranie kraju kontrahenta
#2012-07-04 Mariusz Rajfura     (5888) sprawdzenie bledow po kontroli danych, a przed zapisem
#2012-09-06 Mariusz Rajfura     (4188) pobranie stawka_vat_import z rs_artykuly_stawki_vat
#2013-03-08 Mariusz Rajfura     (6657) blokada pozycji przed modyfikacja
#2014-01-30 Micha Raburski     (7624) obsuga cech w pozycjach dostaw
#2014-07-15 Konrad Opieka       (7648) refaktoryzacja
#2020-06-15 Aleksander Bargie (12007) [HD] F1 w GM dla magazynu detalicznego
#2021-02-15 Aleksander Bargie (12323) Pozycje dostaw - uzaleni pobieran stawk VAT od danych nagwka

from funkcje import fs_artykuly_pom

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Data':[1,2,3,4,5,10,11],'Numer':[1,2,3,4,5,10,11,],'Artykul':[11],'Pozycja':[1,2,3,4,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dostawy_pozycje_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
if stat=='OK':
    Data=klucze['Data']
    Numer=klucze['Numer']
    if Funkcja in [11]:
        Artykul=klucze['Artykul']
    if Funkcja in [1,2,3,4,5]:
        Poz=klucze['Pozycja']

#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci

wyn1 = []
wyn2 = []
Mag = ''
StawkaVATPozaTerminem = False

puste_pola = [[],"","    -  -  ",None,'None']
#AB 15.06.20r
magazyn_id = ''
tylko_detal=False
nie_detal=False

if self.operator_id != STANDARD_OPERATOR_ID:
    UprPrz = ((self.oddzial_id,'035020') in self.uprawnienia)
    UprIns = ((self.oddzial_id,'035023') in self.uprawnienia)
    UprUpd =((self.oddzial_id,'035022') in self.uprawnienia)
else:
    UprUpd=UprPrz = UprIns = True
           

#--------------------------------------------------------------------------------------------------------
#                                  FUNKCJA 10- pobiera dane dla nowej pozycji 
#       Funkcja pobiera numer pozycji
#       Funkcja pobiera narzut procentowy, transport, oraz ilo miejsc po przecinku  
#       Funkcja pobiera kraj kontrahenta                                                   
#                                                                                                        
#--------------------------------------------------------------------------------------------------------

if Funkcja in [10]:
    dane=[]
    SQL = "SELECT nr_poz FROM rs_dostawy_pozycje WHERE firma_id = '"+self.firma_id+"' "
    SQL+= "AND data = '"+Data+"' AND numer="+str(Numer)+" ORDER BY nr_poz DESC LIMIT 1"
    stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)  
    if stat<>'OK':
        stat='Bd pobrania nr_poz'+stat
        dane.append(stat)
    if len(d)==0:
        numer = 1
    else:
        numer = int(d[0][0]) + 1
    
    if stat=='OK':
        SQL = "SELECT narzut_proc, transport_proc,miejsc_po_przecinku FROM rs_dostawy "
        SQL+= "WHERE firma_id = '"+self.firma_id+"' AND data = '"+Data+"' AND numer="+str(Numer)
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobrania narzutu procentowego, transportu i miejsc po przecinku'+stat
            dane.append(stat)
        elif len(dane)<>1:
            stat='NARZUT BR'
            dane.append(stat) 
        else:
            dane[0].append(numer) # nr_poz (3)
            
    if stat=='OK':
        SQL = "SELECT k.kraj, d_magazyn_id FROM rs_dostawy d "
        SQL+= "LEFT JOIN rs_kontrahenci k using (firma_id, kontrahent_id) "
        SQL+= "WHERE d.firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,tmp,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobrania kraju dostawcy'+stat
            dane.append(stat)
        else:
            dane[0].append(tmp[0][0])  # kraj (4)
            Mag = tmp[0][1]
            
    if stat=='OK':
        SQL = "SELECT kurs,kurs2 FROM rs_dostawy "
        SQL+= "WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer='"+Numer+"';"
        stat,DaneWaluty,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobrania kursw'+stat
            dane.append(stat) 
        if len(DaneWaluty)>0:
            dane[0].append(DaneWaluty[0][0])  # wal (5)
            dane[0].append(DaneWaluty[0][1])  # wal (6)

    #AB 15.06.10r
    #sprawdzenie czy magazyn jest detaliczny
    if stat=='OK' and Mag not in puste_pola:
        sql = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, Mag)
        stat, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(Detaliczny) == 0:
                stat = 'Bd sprawdzania czy magazyn jest detaliczny.'
                dane.append(stat)
            else:
                wyn2.append(Detaliczny[0][0])
        else:
            stat = 'Bd sprawdzania czy magazyn jest detaliczny: ' + stat
            dane.append(stat)
    elif stat=='OK' and Mag in puste_pola:
        wyn2.append(None) #detaliczny (11)
        
        
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4]:
    if Funkcja in [1,2] and not UprIns:
        stat='UPR INS'
        dane.append(stat)
    if Funkcja in [3,4] and not UprUpd:
        stat='UPR UPD'
        dane.append(stat)

if Funkcja in [3,4] and stat=='OK':
    # blokada pozycji przed modyfikacja
    SQL = "SELECT * FROM rs_dostawy_pozycje "
    SQL+= "WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+Numer+" "
    SQL+= "AND nr_poz="+str(Poz)+" FOR UPDATE;"
    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Nie mona zablokowa modyfikowanej pozycji'
        dane.append(stat)
    elif len(d)==0:
        stat = 'Brak pozycji po podanym kluczu'
        dane.append(stat)

if Funkcja in [1,2,3,4]:
    if stat=='OK':    
        if Data not in puste_pola:
            dane_wyn = rsglobal.SprawdzCzyToData(Data)   
            if not dane_wyn:
                stat = 'Bdna data'
            else:
                SQL = "SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+self.oddzial_id+"','"+Data+"',1);"
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(SQL ,3)
                if dane_wyn <> 1:
                    stat='DATA ZK'
                    dane_wyn.append(stat)
                    
            SQL = "SELECT * FROM rs_dostawy WHERE "
            SQL+= "firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            stat,dane_wyn,wyn1,dump = self.PolSQL.Execute(SQL ,3)
            if stat != 'OK':
                dane.append(stat)
            elif len(dane_wyn) == 0:
                stat = 'KLUCZ BL'
                dane.append(stat)
            else: #AB 15.06.20r
                tr_dost = rssql.RSTableRowset(dane_wyn,wyn1)
                magazyn_id = tr_dost.GetVal(0,"d_magazyn_id")
        else:
            stat = 'KLUCZ BL'
            dane.append(stat)
            
        if stat=='OK':
            # pobranie stanu i kraju kontrahenta w nagwku dostawy. Jeli PL to znaczy e to dostawa z Polski i nie trzeba 
            # podawa kodu transakcji i kraju pochodzenia
            SQL ="SELECT d.stan,COALESCE(k.kraj,'PL') FROM rs_dostawy d "
            SQL+="LEFT OUTER JOIN rs_kontrahenci k using (firma_id, kontrahent_id) "
            SQL+="WHERE d.firma_id='"+self.firma_id+"' AND d.data='"+Data+"' AND d.numer="+str(Numer)
            stat,dane_s,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat<>'OK':
                stat = 'Bd w pobieraniu stanu dostawy'+stat
                dane.append(stat)
            else:
                if len(dane_s)==0:
                    stat = 'STAN BR'
                    dane.append(stat)
                else:
                    self.Stan=dane_s[0][0]
                    KrajKontrahenta=dane_s[0][1]
                    
        if stat=='OK':
            dane = []
            NrPoz = Poz
            i = 0
            # pobranie informacji o cechach (dla update)
            CechaArt=''
            Cecha=''
            CechaWart=''
            if Funkcja in [3,4]:
                SQL = "SELECT TRIM(COALESCE(a.cecha1_opis,'')),TRIM(COALESCE(dp.cecha1_opis,'')),"
                SQL+=" TRIM(COALESCE(dp.cecha1_wartosc,''))"
                SQL+= " FROM rs_dostawy_pozycje dp LEFT OUTER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                SQL+= " WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
                SQL+= " AND numer="+Numer+" AND nr_poz="+str(Poz)
                stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat <> 'OK':
                    stat = "Bd pobierania danych artykuu z pozycji dostawy"
                    dane.append(stat)
                else:
                    CechaArt=Dane[0][0]
                    Cecha=Dane[0][1]
                    CechaWart=Dane[0][2]
                        
            for pole in Pola:
                wart = Wartosci[i]
                if pole=='nr_poz':
                    if wart < 1:
                        stat = 'NRPOZYCJI BL'
                        dane.append(stat)
                        
                    SQL = "SELECT nr_poz FROM rs_dostawy_pozycje WHERE firma_id='"+self.firma_id+"' "
                    SQL+= "AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(wart)+";"
                    dump,Dane,dump,dump = self.PolSQL.Execute(SQL ,3) 
                    if Dane <> []:
                        stat = 'NRPOZYCJI BR'
                        dane.append(stat)
                        
                elif pole == 'kraj_pochodz':
                    if wart == '':
                        if KrajKontrahenta <>'PL': 
                            stat = 'KRAJ BR'
                            dane.append(stat)
                    else:
                        SQL = "SELECT * FROM rs_kraje WHERE kraj = '"+wart+"';"
                        dump,Dane,dump,dump = self.PolSQL.Execute(SQL ,3) 
                        if Dane == []:
                            stat = 'KRAJ BL'
                            dane.append(stat)
                        else:
                            kraj = wart
                            
                elif pole == 'kod_transakcji':
                    if wart == '':
                        if KrajKontrahenta <>'PL': 
                            stat = 'KOD BR'
                            dane.append(stat)
                    else:
                        SQL = "SELECT * FROM rs_kody_transakcji WHERE firma_id='"+self.firma_id+"' "
                        SQL+= "AND kod = '"+wart+"';"
                        dump,Dane,dump,dump = self.PolSQL.Execute(SQL ,3) 
                        if Dane == []:
                            stat = 'KOD BL'
                            dane.append(stat)
                        else:
                            art_id = wart
                            
                elif pole == 'artykul_id':
                    if wart == '':
                        stat = 'ART BR'
                        dane.append(stat)
                    else:
                        SQL = "SELECT artykul_id,TRIM(COALESCE(cecha1_opis,'')),aktywny, tylko_detal, " #AB 15.06.20r
                        SQL+=" NOT tylko_detal AND NOT czy_detal AS nie_detal FROM rs_artykuly "
                        SQL+= "WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                        stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3) 
                        if stat<>'OK':
                            stat = "Bd sprawdzania danych artykuu: "+stat
                            dane.append(stat)
                        elif Dane == []:
                            stat = 'ART BL'
                            dane.append(stat)
                        elif not Dane[0][2]:
                            stat='ART NIEAKT'
                            dane.append(stat)
                        else:
                            art_id      = wart
                            CechaArt    = Dane[0][1]
                            #AB 15.06.20r
                            tylko_detal = Dane[0][3]
                            nie_detal   = Dane[0][4]
                            detaliczny = False
                            # pobranie detalicznosci magazynu jesli jest wpisany
                            if (tylko_detal or nie_detal) and magazyn_id not in puste_pola:
                                sql = "SELECT detaliczny FROM rs_magazyny " \
                                      "WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, magazyn_id)
                                stat, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3)
                                if stat == 'OK':
                                    if len(Detaliczny) == 0:
                                        stat = 'Bd sprawdzania czy magazyn jest detaliczny.'
                                        rsglobal.ZapiszDoLogow(sql)
                                        rsglobal.ZapiszDoLogow(magazyn_id)
                                        dane.append(stat)
                                    else:
                                        detaliczny = Detaliczny[0][0]
                                else:
                                    stat = 'Bd sprawdzania czy magazyn jest detaliczny: ' + stat
                                    dane.append(stat)
                            # magazyn detaliczny, a artykul nie moze byc w takim magazynie
                            if stat == 'OK' and detaliczny and nie_detal and magazyn_id not in puste_pola:
                                stat = "Artyku {} nie moe zosta dodany do dokumentu magazynowgo " \
                                       "w magazynie detalicznym {}".format(art_id, magazyn_id)
                                dane.append(stat)
                            # magazyn nie detaliczny, a artykul musi byc w detalicznym magazynie
                            if stat == 'OK' and not detaliczny and tylko_detal and magazyn_id not in puste_pola:
                                stat = "Artyku {} moe zosta dodany do dokumentu magazynowgo " \
                                       "jedynie w magazynie detalicznym. " \
                                       "Magazyn {} nie jest detaliczny.".format(art_id, magazyn_id)
                                dane.append(stat)
                    if stat != 'OK':
                        rsglobal.ZapiszDoLogow(stat * 5)
                            
                elif pole == 'ilosc_dost1':
                    if wart < 0:
                        stat = 'ILOSC DOST1 BL'
                        dane.append(stat)
                        
                elif pole == 'ilosc_dost2':
                    if wart < 0:
                        stat = 'ILOSC DOST2 BL'
                        dane.append(stat)
                        
                elif pole == 'cena_wal1':
                    if wart < 0:
                        stat = 'CENA WAL1 BL'
                        dane.append(stat)
                        
                elif pole == 'cena_wal2':
                    if wart < 0:
                        stat = 'CENA WAL2 BL'
                        dane.append(stat)
                        
                elif pole == 'cena_upust_wal1':
                    if wart < 0:
                        stat = 'CENA WAL UPUST1 BL'
                        dane.append(stat)
                        
                elif pole == 'cena_upust_wal2':
                    if wart < 0:
                        stat = 'CENA WAL UPUST2 BL'
                        dane.append(stat)

                elif pole == 'stawka_vat':
                    wart = rsglobal.Dekoduj(wart).strip()
                    StawkaVAT = wart
                    if wart == '':
                        stat = 'STAWKA_VAT BR'
                        dane.append(stat)
                    else:
                        SQL ="SELECT kod FROM rs_stawki_vat WHERE kod='"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia stawki VAT: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'STAWKA_VAT BL'
                            dane.append(stat)
                    
                    if stat == 'OK':
                        SQL ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                        SQL+=" WHERE stawka_vat='"+wart+"'"
                        SQL+=" AND '"+Data+"'>=od_dnia"
                        SQL+=" AND CASE WHEN do_dnia IS NULL"
                        SQL+=" THEN TRUE ELSE '"+Data+"'<=do_dnia END;"
                        
                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            #informacja zwrotna, ze podana stawka VAT nie zgadza sie
                            #z terminem jej obowiazywania
                            StawkaVATPozaTerminem = True
                elif pole == 'cecha1_opis':
                    Cecha = wart.strip()                   
                elif pole == 'cecha1_wartosc':
                    CechaWart = wart.strip()           
                i= i+1
        else:
            stat='SQL BL'
            dane.append(stat)
    
    # sprawdzenie spjnoci informacji o cechach
    if stat=='OK' :
        # jeli opis cechy pozycji inny ni artykuu
        if Cecha <> CechaArt:
            stat = 'CECHA BL'
            dane.append(stat)
        else:
            SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','poprawna')"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia wartoci cechy: '+stat
            else:
                Wynik=eval(d[0][0])
                if not Wynik[0]:
                    stat = Wynik[1]
                    dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

    if stat=='OK' and Funkcja in [2,1]:
        if self.Stan=='Z':
            stat = 'STAN BL'
            dane.append(stat)
        if stat=='OK':
            SQL = "INSERT INTO rs_dostawy_pozycje"
            PolaN="firma_id,data,numer"
            WartosciN = "'"+self.firma_id+"','"+Data+"','"+Numer+"'"
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
                if pole in ['artykul_id','stawka_vat','kraj_pochodz','kod_transakcji',
                    'cecha1_opis','cecha1_wartosc']:
                    PolaN += ","+pole
                    if wart.strip()=='':
                        WartosciN += ",NULL"
                    else:
                        WartosciN += ",'"+str(wart)+"'"
                else:
                    PolaN += ","+pole
                    WartosciN += ","+str(wart)
                if pole == "nr_poz":
                    Poz = wart
            SQL += " ("+PolaN+") VALUES ("+WartosciN+");"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
            if stat<>'OK':
                stat = 'SQL BL'
                dane.append(stat)

                
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

    if stat=='OK' and Funkcja in [3,4]:
        if self.Stan=='Z':
            stat='STAN BL'
            dane.append(stat)
        if stat=='OK':
            dane = []
            SQL = "UPDATE rs_dostawy_pozycje SET "
            Filtr = "firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
            for i in range(len(Pola)):
                wart = Wartosci[i]
                pole = Pola[i]
                if pole in ['artykul_id','stawka_vat','kraj_pochodz','kod_transakcji',
                    'cecha1_opis','cecha1_wartosc']:
                    SQL += pole+"="
                    if wart.strip()=='':
                        SQL += "NULL,"
                    else:
                        SQL += "'"+str(wart)+"',"
                elif wart == "NULL":
                    SQL += pole+"="+str(wart)+","
                else:
                    SQL += pole+"="+str(wart)+","
                if pole == "nr_poz":
                    Poz = wart
            SQL = SQL.strip(',')
            SQL += " WHERE "+Filtr+";"
            
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
            if stat<>'OK':
                stat = 'BL_SQL'
                dane.append(stat)

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,3,1]:
    if UprPrz:
        dane = []
        where="WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
        
        SQL = "SELECT * FROM rs_dostawy_pozycje "+where+";"
        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych'+stat
            dane.append(stat)
            
        if stat=='OK':
            tr = rssql.RSTableRowset(dane,wyn1)
            
            #Pobranie narzutu procentowego, transportu i miejsc po przecinku
            SQL = "SELECT narzut_proc, transport_proc,miejsc_po_przecinku, d_magazyn_id FROM rs_dostawy "
            SQL+= "WHERE firma_id = '"+self.firma_id+"' AND data = '"+Data+"' AND numer="+Numer
            stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobrania narzutu procentowego, transportu i miejsc po przecinku'+stat
                dane.append(stat)
            elif len(d)<>1:
                stat='NARZUT BR'
                dane.append(stat)
            if stat=='OK':
                wyn2=[d[0][0]]          #narzut_proc (0)
                wyn2.append(d[0][1])    #transport_proc (1)
                wyn2.append(d[0][2])    #miejsc_po_przecinku (2)
                Mag = d[0][3]    #Magazyn dostawy

            #Pobranie nazwy kraju pochodzenia
            if ((self.oddzial_id,'011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT nazwa FROM rs_kraje WHERE kraj='"+tr.GetVal(0,"kraj_pochodz")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Bd pobrania nazwy kraju pochodzenia'+stat
                    dane.append(stat)
                elif len(d) == 0:
                    wyn2.append('')     #kraj pochodzenia nazwa (3)
                else:
                    wyn2.append(d[0][0])#kraj pochodzenia nazwa (3)
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
            #Pobranie opisu kodu transakcji
            if ((self.oddzial_id,'011350') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_kody_transakcji WHERE firma_id='"+self.firma_id+"' "
                SQL+= "AND kod='"+tr.GetVal(0,"kod_transakcji")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK':
                    stat='Bd pobrania opisu transakcji'+stat
                    dane.append(stat)
                if len(d) == 0:
                    wyn2.append('')     #kod transakcji opis (4)
                else:
                    wyn2.append(d[0][0])#kod transakcji opis (4)
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
            #Pobranie opisu stawki VAT
            if ((self.oddzial_id,'011120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat")+"';" 
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Bd pobrania opisu stawki VAT'+stat
                    dane.append(stat)
                if len(d) == 0:
                    wyn2.append('')     #stawka vat opis (5)
                else:
                    wyn2.append(d[0][0])#stawka vat opis (5)
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
            #Pobranie kraju kontrahenta
            SQL ="SELECT k.kraj FROM rs_dostawy d"
            SQL+=" LEFT JOIN rs_kontrahenci k using (firma_id, kontrahent_id)"
            SQL+=" WHERE d.firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobrania kraju dostawcy'+stat
                dane.append(stat)
            wyn2.append(d[0][0])        #kraj kontrahenta (6)
                        
            #Informacja o zgodnosci stawki VAT tylko w wypadku zapisu
            wyn2.append(Funkcja in (1,2,3,4) and StawkaVATPozaTerminem) #zgodnosc stawki vat (7)
            
            SQL = "SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+tr.GetVal(0,"cecha1_opis")+"','"
            SQL+= tr.GetVal(0,"cecha1_wartosc")+"','opis')"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd przy pobieraniu opisu wartosci: '+stat
                dane.append(stat)
            else:
                wyn2.append(d[0][0])    #opis cechy wartosci (8)
            
            #Pobranie Kursu i wersji waluty
            if stat=='OK':
                SQL = "SELECT kurs,kurs2 FROM rs_dostawy "
                SQL+= "WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer='"+Numer+"';"
                stat,DaneWaluty,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Bd przy pobieraniu kursu walut'
                    dane.append(stat) 
                if len(DaneWaluty)>0:
                    wyn2.append(DaneWaluty[0][0])    #kurs (9)
                    wyn2.append(DaneWaluty[0][1])    #kurs2 (10)
            #AB 15.06.10r
            #sprawdzenie czy magazyn jest detaliczny
            if stat=='OK' and Mag not in puste_pola:
                sql = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, Mag)
                stat, Detaliczny, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat == 'OK':
                    if len(Detaliczny) == 0:
                        stat = 'Bd sprawdzania czy magazyn jest detaliczny.'
                        dane.append(stat)
                    else:
                        wyn2.append(Detaliczny[0][0]) #detaliczny (11)
                else:
                    stat = 'Bd sprawdzania czy magazyn jest detaliczny: ' + stat
                    dane.append(stat)
            elif stat=='OK' and Mag in puste_pola:
                wyn2.append(None) #detaliczny (11)

            
    else:
        stat='UPR PRZ'
        dane.append(stat)
        
#--------------------------------------------------------------------------------------------------------                                           
#       Pobranie danych artykuu (1,3,5,11)                                                                                              
#--------------------------------------------------------------------------------------------------------

if Funkcja in [1,3,5,11] and stat == 'OK':
    from funkcje import fs_artykuly_pom
    
    if Funkcja in [1,3,5]:
        Artykul=tr.GetVal(0,"artykul_id")
    stat, DaneArtPom = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self,Artykul,'',Data,Numer,'','','',0,'')
    if stat<>'OK':
        stat='Bd pobrania danych artykuu'
        dane.append(stat)
    if stat=='OK':            
        wyn2.append(DaneArtPom)  # dene do artykulu (12)
        
if Funkcja == 11 and stat=='OK':
    SQL = "SELECT wersja,waluta,kontrahent_id FROM rs_dostawy "
    SQL+= "WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer='"+Numer+"';"
    stat,DaneWaluty,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania informacji o walutach'
        dane.append(stat) 
    if len(DaneWaluty)>0:
        wersja=DaneWaluty[0][0]
        waluta=DaneWaluty[0][1]
        kontrahent=DaneWaluty[0][2]
        if wersja not in puste_pola:
            SQL ="SELECT rsf_podaj_ceny_dla_kontrahenta('"+str(self.firma_id)+"','"
            SQL+= str(kontrahent)+"','"+waluta+"','"+Data+"','"+Artykul+"','"+wersja+"',-1)"
            stat,DaneCeny,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobrania ceny dla kontrahenta'
                dane.append(stat)
            else:
                wyn2.append(rsglobal.rseval(DaneCeny[0][0]))  #cena walutowa (12)
                wyn2.append(waluta)  #waluta (13)  #AB 15.02.21r
        else:
            wyn2.append([0,0,0,0,0,0,0,0])
