# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_dostawy_pozycje_transporty.py
# Purpose:     Grid z transportami dla pozycji dostawy
# Author:      Aleksander Bargie
# Created:     2021/07/20
# RCS-ID:      $Id: fs_dostawy_pozycje_transporty.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal
from funkcje import fs_pliki_global

"""
035040 okno
035041 przegldanie
035042 modyfikacja
035050 pliki
"""

stat       = 'OK'
dane       = []
wyn1       = []
wyn2       = []
firma_id   = self.firma_id
puste_pola = [[], "", "    -  -  ", None, 'None']

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Data': [1, 5, 15, ], 'Numer': [1, 5, 15, ], 'Poz': [1, 5, 15, ], 'DoImportu': [1, ], }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, ]:
        DoImportu  = rsglobal.Dekoduj(klucze['DoImportu'])
    if Funkcja in [1, 5, 15, ]:
        Data  = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])
        Poz   = rsglobal.Dekoduj(klucze['Poz'])

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprUpd    = ((self.oddzial_id, '035042') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUpdPoz = ((self.oddzial_id, '035022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprSel    = ((self.oddzial_id, '035041') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprUpd

if stat == 'OK' and not UprSel > 0:
    stat = 'Brak uprawnie do przegldania transportw'
    rsglobal.ZapiszDoLogow("(self.oddzial_id, '035041') in self.uprawnienia) {}".format((self.oddzial_id, '035041') in self.uprawnienia))
    rsglobal.ZapiszDoLogow("(self.operator_id == STANDARD_OPERATOR_ID) {}".format((self.operator_id == STANDARD_OPERATOR_ID)))

if stat == 'OK' and Funkcja in [1, ]:
    if not UprUpd:
        stat = "Brak uprawnie do modyfikacji transportw"
    if not UprUpdPoz:
        stat = "Brak uprawnie do modyfikacji iloci na pozycji dowodu"

# -------------------------------------------------------------------------------
# ----------------------   DODANIE TRANSPORTU (1)   -----------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, ]:
    rejestracje         = []

    # pobranie samochodow przypsianych do dostawy
    SEL = """SELECT samochod_id
             FROM rs_dostawy_samochody
             WHERE firma_id = '{}' AND data = '{}' AND numer = {}
             ;"""
    SEL = SEL.format(self.firma_id, Data, Numer)
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania akceptowanych rejestracji: '+stat
        rsglobal.ZapiszDoLogow(SEL)
    elif len(dane) == 0:
        stat = "Nie przypisano adnych samochodw do dostawy."
    else:
        for wiersz in dane:
            rejestracje.append(wiersz[0].strip())

    # pobranie przypisanych rejestracji
    if stat == 'OK':
        SEL = """SELECT samochod_id
             FROM rs_dostawy_samochody
             WHERE firma_id = '{}' AND data = '{}' AND numer = {}
             ;"""
        SEL = SEL.format(self.firma_id, Data, Numer)
        rsglobal.ZapiszDoLogow(SEL)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania akceptowanych rejestracji: '+stat
            rsglobal.ZapiszDoLogow(SEL)
        elif len(dane) == 0:
            stat = "Nie przypisano adnych samochodw do dostawy."
        else:
            for wiersz in dane:
                rejestracje.append(wiersz[0].strip())

    if stat == 'OK':
        Samochody = DoImportu['Samochody']
        Ilosc     = DoImportu['Ilosc']
        Zdjecia   = DoImportu['Zdjecia']
        Czas      = DoImportu['Czas']

        # z gory przygotowanie samochodow do INSERTowania
        samochod1 = Samochody[0]
        if len(Samochody) > 1:
            samochod2 = "'"+Samochody[1]+"'"
        else:
            samochod2 = 'NULL'
        if len(Samochody) > 2:
            samochod3 = "'"+Samochody[2]+"'"
        else:
            samochod3 = 'NULL'

        for sam in Samochody:
            if sam not in rejestracje:  # test czy wszystkie rejestracje
                stat = "Rejestracja {} w folderze {} nie jest przypisana do dostawy".format(sam, Czas)

    if stat == 'OK':
        # blokada przed modyfikacja
        SQL  = "SELECT * FROM rs_dostawy_pozycje "
        SQL += "WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
        SQL += " FOR UPDATE;"
        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Nie mona zablokowa modyfikowanej pozycji'
            rsglobal.ZapiszDoLogow(SQL)
        elif len(d) == 0:
            stat = 'Brak dostawy o podanym kluczu'

    if stat == 'OK':
        # pobranie stanu
        SQL  = "SELECT d.stan FROM rs_dostawy d "
        SQL += "WHERE d.firma_id='"+firma_id+"' AND d.data='"+Data+"' AND d.numer="+str(Numer)
        stat, dane_s, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(SQL)
            stat = 'Bd w pobieraniu stanu dostawy: '+stat
        else:
            if dane_s[0][0] != 'W':
                stat = "Dostawa musi by w stanie 'W' by importowa do niej transporty."

    if stat == 'OK':  # dopisanie transportu
        INS = """INSERT INTO rs_dostawy_pozycje_transporty
                    (firma_id, data, numer, nr_poz, czas_transportu, samochod1, samochod2, samochod3, ilosc_dost1)
                VALUES('{}',    '{}',  {},    {},         '{}',        '{}',         {},       {},        {})
                ;
             """.format(firma_id, Data, Numer, Poz, Czas, samochod1, samochod2, samochod3, Ilosc)
        rsglobal.ZapiszDoLogow(INS)
        stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd dodawania transportu: '+stat
            rsglobal.ZapiszDoLogow(INS)

    if stat == 'OK':  # aktualizacja iloci
        INS = """UPDATE rs_dostawy_pozycje p SET ilosc_dost1=ilosc_dost1+{}, ilosc_dost2=ilosc_dost2+ROUND({}*a.przelicznik, 4)
                 FROM rs_artykuly a 
                 WHERE (p.firma_id, data, numer, nr_poz) = ('{}', '{}', {}, {}) AND a.firma_id = p.firma_id and a.artykul_id = p.artykul_id
                ;
             """.format(Ilosc, Ilosc, firma_id, Data, Numer, Poz)
        rsglobal.ZapiszDoLogow(INS)
        stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd dodawania transportu: '+stat
            rsglobal.ZapiszDoLogow(INS)

    i = 0
    while stat == 'OK' and i < len(Zdjecia):  # wrzucanie plikw
        nazwa_pliku = Zdjecia[i]['nazwa_pliku']
        tresc_pliku = Zdjecia[i]['tresc_pliku']

        if stat == 'OK':
            INSPLIKI = """INSERT INTO rs_pliki (  firma_id,      nazwa,            tabela,     kompresja)
                                        VALUES ('{firma_id}','{nazwa_pliku}','fs_dostawy_pozycje_transporty_pliki', FALSE);""".format(**locals())
            rsglobal.ZapiszDoLogow(INSPLIKI)
            stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd dodawania pliku: {stat}".format(**locals())

        if stat == 'OK':
            # pobranie id pliku
            SQLNumerPliku = """SELECT max(plik_id) 
                                       FROM rs_pliki 
                                       WHERE firma_id='{firma_id}' AND tabela='fs_dostawy_pozycje_transporty_pliki';
                                       """.format(**locals())
            stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow("pobrano numer: " + str(nrp))
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(SQLNumerPliku)
                stat = "Bd pobierania numeru pliku: {stat}".format(**locals())

        if stat == 'OK':
            # faktycznie wstawienie pliku na serwer
            NumerPliku = nrp[0][0]
            stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, tresc_pliku)

            if stat != 'OK':
                stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())

        if stat == 'OK':
            # zanotowanie w bazie informacji o wrzuconym pliku
            INSPLIKI = """INSERT INTO rs_dostawy_pozycje_transporty_pliki
                        (firma_id,    data,     numer, nr_poz, czas_transportu, nr_pliku,         opis)
                VALUES('{firma_id}', '{Data}', {Numer}, {Poz},    '{Czas}',    {NumerPliku}, '{nazwa_pliku}')
                ;""".format(**locals())

            rsglobal.ZapiszDoLogow(INSPLIKI, 5)
            stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd dodawania rekordu o nowym pliku: ' + stat
                rsglobal.ZapiszDoLogow(INSPLIKI)
        i += 1

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE REJESTRACJI (15)   -----------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [15, ]:
    SEL = """SELECT samochod_id
             FROM rs_dostawy_samochody
             WHERE firma_id = '{}' AND data = '{}' AND numer = {}
             ;"""
    SEL = SEL.format(self.firma_id, Data, Numer)
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania akceptowanych rejestracji: '+stat

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH (5)   --------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [5, ]:
    SEL = """SELECT czas_transportu, samochod1, samochod2, samochod3, ilosc_dost1
             FROM rs_dostawy_pozycje_transporty
             WHERE firma_id = '{}' AND data = '{}' AND numer = {} AND nr_poz = {}
             ORDER BY czas_transportu DESC;"""
    SEL = SEL.format(self.firma_id, Data, Numer, Poz)
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych: '+stat
