# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_dostawy_pozycje_transporty_pliki.py
# Purpose:     Grid z transportami dla pozycji dostawy
# Author:      Aleksander Bargie
# Created:     2021/07/20
# RCS-ID:      $Id: fs_dostawy_pozycje_transporty_pliki.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal
from funkcje import fs_pliki_global

"""
035040 okno
035041 przegldanie
035042 modyfikacja
035050 pliki
"""

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
firma_id = self.firma_id

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Data': [5, ], 'Numer': [5, ], 'Poz': [5, ], 'Czas': [5, ], 'Plik': [15, ]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [5, ]:
        Data  = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])
        Poz   = rsglobal.Dekoduj(klucze['Poz'])
        Czas  = rsglobal.Dekoduj(klucze['Czas'])
    if Funkcja in [15, ]:
        Plik  = rsglobal.Dekoduj(klucze['Plik'])

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprSel = ((self.oddzial_id, '035051') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if stat == 'OK' and not UprSel > 0:
    stat = 'UPR_SEL'

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE PLIKU (15)   -----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (15, ):
    stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, Plik)
    dane = [Tresc]

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH (5)   -----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [5, ]:
    SEL = """SELECT nr_pliku, opis
             FROM rs_dostawy_pozycje_transporty_pliki
             WHERE firma_id = '{}' AND data = '{}' AND numer = {} AND nr_poz = {} AND czas_transportu = '{}'
             ORDER BY nr_pliku DESC;"""
    SEL = SEL.format(self.firma_id, Data, Numer, Poz, Czas)
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych: '+stat
