# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_dostawy_samochody.py
# Purpose:     obsuga edytowalnego grida samochodw obsugujcych dostaw
# Author:      Aleksander Bargie
# Created:     2021/07/19
# RCS-ID:      $Id: fs_dostawy_samochody.py$
# Copyright:   (c) 2021 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2021-08-02 Aleksander Bargie (12591) Eksport danych o dostawie

"""
035030 okno
035031 przegladanie
035032 modyfikacja
"""

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []
firma_id = self.firma_id  #AB 02.08.21r

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'data': [1, 5, 15], 'numer': [1, 5, 15], }  #AB 02.08.21r

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1, 5, 15]:  #AB 02.08.21r
        data  = str(klucze['data'])
        numer = str(klucze['numer'])

UprPrzegladanie = (((self.oddzial_id, '035030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprModyf        = (((self.oddzial_id, '035032') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat == 'OK' and not UprPrzegladanie:
    stat = u"Brak uprawnie do samochodw dostawy"

if stat == 'OK' and Funkcja == 1 and not UprModyf:
    stat = u"Brak uprawnie do modyfikowania samochodw dostawy"

if Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

# ------------------------------------------------------------------------------------------------------------
# -------------------------- DELETE
# ------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1 and len(Delete[0]) > 0:
    sql = ''
    for i in xrange(len(Delete[0])):
        DELETE = "DELETE FROM rs_dostawy_samochody "
        WHERE = "WHERE firma_id='" + self.firma_id + "' AND data='" + str(data) + "' AND numer='" + str(numer) + "'"
        for j in xrange(len(Delete[0][i])):
            if 'samochod_id' not in Delete[1]:
                stat = "Bad usuwania danych."
                break
            pole = Delete[1][j]
            wart = Delete[0][i][j]
            if pole == 'samochod_id':
                WHERE += " AND " + pole + "='" + str(wart) + "' "
        sql += DELETE + WHERE + ";"
    if sql != '':
        rsglobal.ZapiszDoLogow(sql)
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
    if stat != 'OK':
        stat = u"Bd przy usuwaniu danych: " + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# ---   UPDATE DANYCH (1)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1 and len(Update[0]) > 0:
    WierszeNr = Update[-1]
    for i in xrange(len(Update[0])):
        for j in xrange(len(Update[0][i])):
            pole = Update[0][i][j]
            wart = Update[1][i][j]
            if pole == 'samochod_id':
                if str(wart).strip() == '':
                    stat = u'KOD BR'
                    wyn2.append((WierszeNr[i], 0))
                    dane.append(stat)
                else:
                    sql = "SELECT kod FROM rs_samochody WHERE firma_id = '" + self.firma_id + "'"
                    sql += " AND kod = '" + str(wart) + "';"
                    rsglobal.ZapiszDoLogow(sql)
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        wyn2.append((WierszeNr[i], 0))
                        dane.append(u'KOD BL SQL')
                    else:
                        if len(d) == 0:
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(u'KOD BL')

    if len(dane) > 0:
        stat = 'Bdy modyfikacji danych'

    if stat == 'OK':
        sql = ''
        for i in xrange(len(Update[0])):
            UPDATE = "UPDATE rs_dostawy_samochody "
            SET = 'SET '
            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]
                if pole == 'samochod_id':
                    SET += pole + "='" + wart + "',"
            SET = SET.strip(",")
            WHERE = " WHERE firma_id='" + self.firma_id + "' AND data='" + str(data) + "' AND numer='" + str(numer) + "'"
            for j in xrange(len(Update[2][i])):  # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])
                WHERE += " AND " + pole + "='" + str(wart) + "' "
            WHERE += ";"
            if str(SET) == 'SET ':
                pass
            else:
                sql += UPDATE + SET + WHERE;
        if sql != '':
            rsglobal.ZapiszDoLogow(sql)
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
            if stat != 'OK':
                stat = u"Bd przy modyfikowaniu danych: " + stat
                dane.append(stat)

# ----------------------------------------------------------------------------------------------------------------------
# ---------Sprawdzanie danych do Insert------
# ----------------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1 and len(Insert[0]) > 0:
    WierszeNr = Insert[-1]
    for i in xrange(len(Insert[0])):
        for j in xrange(len(Insert[0][i])):
            pole = Insert[1][j]
            wart = Insert[0][i][j]
            if pole == 'samochod_id':
                if wart.strip() == '':
                    wyn2.append((WierszeNr[i], 0))
                    dane.append(u'KOD BR')
                else:
                    sql = "SELECT kod FROM rs_samochody WHERE firma_id = '" + self.firma_id + "'"
                    sql += " AND kod = '" + str(wart) + "';"
                    rsglobal.ZapiszDoLogow(sql)
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        wyn2.append((WierszeNr[i], 0))
                        dane.append(u'KOD BL SQL')
                    else:
                        if d == []:
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(u'KOD BL')
    if len(dane) > 0:
        stat = 'Bdy dodawania danych'

    # ------------------------------------------------------------------------------------------------------------
    # ---------------   INSERT
    # -------------------------------------------------------------------------------------------------------------

    if stat == 'OK':
        sqlIns = ''
        for i in xrange(len(Insert[0])):
            INSERT = "INSERT INTO rs_dostawy_samochody "
            KOLUMNY = "(firma_id, data, numer"
            VALUES = " VALUES ('" + self.firma_id + "','" + data + "','" + numer + "'"
            for j in xrange(len(Insert[0][i])):
                pole = Insert[1][j]
                wart = Insert[0][i][j]
                if pole == 'samochod_id':
                    KOLUMNY += "," + pole
                    VALUES += ",'" + wart + "'"
            KOLUMNY += ")"
            VALUES += ");"
            sqlIns += INSERT + KOLUMNY + VALUES
        if sqlIns != '':
            rsglobal.ZapiszDoLogow(sqlIns)
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns), 1)
            if stat != 'OK':
                stat = u"Bd przy dodawaniu danych: " + stat
                dane.append(stat)
#AB 02.08.21r
# ------------------------------------------------------------------------------------------------------------
# ---   POBRANIE DANYCH DO EKSPORTU(15)
# ------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [15, ]:
    SQLRejestracje = """SELECT samochod_id FROM rs_dostawy_samochody WHERE firma_id='{}' AND data='{}' AND numer='{}';"""
    SQLRejestracje = SQLRejestracje.format(firma_id, data, numer)
    rsglobal.ZapiszDoLogow(SQLRejestracje)
    stat, Rejestracje, wyn1, wyn2 = self.PolSQL.Execute(SQLRejestracje, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = u"Bd pobierania rejestracji do eksportu: " + stat
    elif len(Rejestracje) < 1:
        stat = u"Brak przypisanych samochodw."

    if stat == 'OK':
        SQLLokacja = """SELECT lokacja_id, l.opis FROM rs_dostawy
                        JOIN rs_lokacje l USING(firma_id, lokacja_id)
                        WHERE firma_id='{}' AND data='{}' AND numer='{}';"""
        SQLLokacja = SQLLokacja.format(firma_id, data, numer)
        rsglobal.ZapiszDoLogow(SQLLokacja)
        stat, Lokacja, wyn1, wyn2 = self.PolSQL.Execute(SQLLokacja, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania danych lokacji do eksportu: " + stat
        elif len(Lokacja) < 1:
            stat = u"Dostawa musi mie wybran lokacj."

    if stat == 'OK':
        SQLArtykul = """SELECT artykul_id, a.nazwa FROM rs_dostawy_pozycje
                        JOIN rs_artykuly a USING(firma_id, artykul_id)
                        WHERE firma_id='{}' AND data='{}' AND numer='{}';"""
        SQLArtykul = SQLArtykul.format(firma_id, data, numer)
        rsglobal.ZapiszDoLogow(SQLArtykul)
        stat, Artykul, wyn1, wyn2 = self.PolSQL.Execute(SQLArtykul, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania danych towaru do eksportu: " + stat
        elif len(Artykul) != 1:
            stat = u"Dostawa powinna zawiera dokadnie 1 pozycj."

    if stat == 'OK':
        dane = [Rejestracje, Lokacja, Artykul]

# ------------------------------------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
# ------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1, 5]:
    # pobranie danych
    SQL = "SELECT d.samochod_id, s.opis, k.kontrahent_id FROM rs_dostawy_samochody d "
    SQL += "LEFT JOIN rs_samochody s ON d.firma_id = s.firma_id AND d.samochod_id = s.kod "
    SQL += "LEFT JOIN rs_kontrahenci k ON d.firma_id = k.firma_id AND s.wlasciciel_id = k.kontrahent_id "
    SQL += "WHERE d.firma_id = '" + self.firma_id + "' AND d.data = '" + str(data) + "' AND d.numer = '" + str(numer) + "';"
    rsglobal.ZapiszDoLogow(SQL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = u"Bd przy pobieraniu danych: " + stat
        dane.append(stat)