# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw.py
# Purpose:     grid z dowodami dostaw
# Author:      Micha Raburski
# Created:     2007/04/23
# RCS-ID:      $Id: fs_dowody_dostaw.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-09-16 Mariusz Rajfura     (4929) blokada SELECT FOR UPDATE
# 2012-02-20 Mariusz Rajfura     (5474) nowe pole 'korekta':grid,filtry
# 2012-02-26 Mariusz Rajfura     (5486) mozliwosc.usun.ostat.dow.automat.jesli to korekta
# 2012-03-14 Mariusz Rajfura     (5531) tworzenie recznej korekty dowodu; otwieranie, usuwanie, zamykanie
# 2012-04-11 Mariusz Rajfura     (5640) rzut do filtrowania
# 2012-09-20 Mariusz Rajfura     (6087) dostep do dowodow wynikajacych z rs_boksy_trasy_dni
# 2013-02-04 Mariusz Rajfura     (6479) zmiana kontrahenta: kontrola blokady
# 2013-07-26 Micha Raburski     (7063) pola dokumentw WZ i ZW
# 2013-10-11 Mariusz Rajfura     (7265) zezwolenie na filtrowanie po trasie jako LIKE zamiast dokladnie
# 2014-02-12 Konrad Opieka       (7673) dodanie korekty z dat dostawy
# 2018-09-27 Aleksander Bargie (11235) Zablokowa otwieranie dowodw dostaw w stanie 1 gdy istnieje plan wydania WMS
# 2019-04-15 Wojciech Skowron   (11464) nowe filtry - 'dowod_zwrotu', 'numer_zamowienia' i 'artykul_id'
# 2019-12-11 Aleksander Bargie (11780) Wywietlanie listy dowodw dostaw z artykuem w filtrze moe zdublowa pozycje na gridzie
# 2020-12-22 Aleksander Bargie (12230) [SP] zmiana wydruku d.d.
# 2021-03-12 Aleksander Bargie (12381) [SP] Zamykanie d.d. z innego oddziau
# 2021-04-13 Wojciech Skowron   (12229) Przy pobieraniu dowodw nieuproszczonych zalepka w miejsce sum iloci
# 2021-05-18 Jan Raburski       (12493) Ograniczenie filtra do kontrahenta z operatora, jesli jest
# 2021-08-02 Aleksander Bargie (12593) Korekta dowodu dostawy - BLAD
# 2021-08-05 Wojciech Skowron   (12594) Kolumna "Artykuy" w uproszczonych dowodach
# 2021-12-14 Jan Raburski       (12772) Bez filtru na oddzial w centrali i dla uprawnie 803000


from funkcje import fs_dowody_dostaw_pom

stat = "OK"
dane = []
wyn1 = []
wyn2 = []

if isinstance(klucze, list):
    Trasa = rsglobal.Dekoduj(klucze[0])
    Data = rsglobal.Dekoduj(klucze[1])
    Tryb = rsglobal.Dekoduj(klucze[2])
    Numer = klucze[3]
    TrasaF = rsglobal.Dekoduj(klucze[4])
    DataOdF = rsglobal.Dekoduj(klucze[5])
    DataDoF = rsglobal.Dekoduj(klucze[6])
    TrybF = rsglobal.Dekoduj(klucze[7]).strip()
    KontrF = rsglobal.Dekoduj(klucze[8])
    StanF = rsglobal.Dekoduj(klucze[9])
    KlFakt = klucze[10]
    KontrahentN = rsglobal.Dekoduj(klucze[11])
    KorektaF = rsglobal.Dekoduj(klucze[12])
    RzutF = rsglobal.Dekoduj(klucze[13]).strip()
    Oddzial = rsglobal.Dekoduj(klucze[14]).strip()
    NiewyeksportowaneF = klucze[15]
    #WS 2019-04-15
    Niezwrocone = klucze[16]
    NrDowZwrotuF = rsglobal.Dekoduj(klucze[17]).strip()
    NrZamowieniaF = rsglobal.Dekoduj(klucze[18]).strip()
    ArtykulF = rsglobal.Dekoduj(klucze[19]).strip()

    Fun = klucze[-1]

    stat = "OK"
    dane = []
    wyn1 = []
    wyn2 = []
else:

    if 'Funkcja' not in klucze:
        stat = 'Brak podanej funkcji w kluczach'
    if stat == 'OK':
        Funkcja = klucze['Funkcja']
        SlPar = {'Trasa':              [6,  7, 11, 12, 13, 14, 16, 19, 21, 31],
                 'Data':               [6,  7, 11, 12, 13, 14, 16, 19, 21, 31],
                 'Tryb':               [6,  7, 11, 12, 13, 14, 16, 19, 21, 31],
                 'Numer':              [6,  7, 11, 12, 13, 14, 19, 21, 31],
                 'TrasaF':             [5,  6,  7, 12, 13, 21, 31],
                 'DataOdF':            [5,  6,  7, 12, 13, 21, 31],
                 'DataDoF':            [5,  6,  7, 12, 13, 21, 31],
                 'TrybF':              [5,  6,  7, 12, 13, 21, 31],
                 'KontrF':             [5,  6,  7, 12, 13, 21, 31],
                 'StanF':              [5,  6,  7, 12, 13, 21, 31],
                 'KontrahentN':        [5,  6,  7, 12, 13, 21, 31],
                 'KorektaF':           [5,  6,  7, 12, 13, 21, 31],
                 'RzutF':              [5,  6,  7, 12, 13, 21, 31],
                 'Oddzial':            [6,  7, 11, 12, 13, 14, 16, 19, 21, 31],
                 'NiewyeksportowaneF': [5,  6,  7, 12, 13, 21, 31],
                 'NiezwroconeF':       [5,  6,  7, 12, 13, 21, 31],
                 #WS 2019-04-15
                 'NrDowZwrotuF':       [5,  6,  7, 12, 13, 21, 31],
                 'NrZamowieniaF':      [5,  6,  7, 12, 13, 21, 31],
                 'ArtykulF':           [5,  6,  7, 12, 13, 21, 31]
                 }
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_dowody_dostaw '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [6, 7, 11, 12, 13, 16, 19, 21, 31]:
        Trasa   = klucze['Trasa']
        Data    = klucze['Data']
        Tryb    = klucze['Tryb']
        Oddzial = klucze['Oddzial']

    if Funkcja in [6, 7, 11, 12, 13, 19, 21, 31]:
        Numer = klucze['Numer']

    if Funkcja in [5, 6, 7, 12, 13, 21, 31]:
        TrasaF             = klucze['TrasaF']
        DataOdF            = klucze['DataOdF']
        DataDoF            = klucze['DataDoF']
        TrybF              = klucze['TrybF']
        KontrF             = klucze['KontrF']
        StanF              = klucze['StanF']
        KontrahentN        = klucze['KontrahentN']
        KorektaF           = klucze['KorektaF']
        RzutF              = klucze['RzutF']
        NiewyeksportowaneF = klucze['NiewyeksportowaneF']
        Niezwrocone        = klucze['NiezwroconeF']
        #WS 2019-04-15
        NrDowZwrotuF       = klucze['NrDowZwrotuF']
        NrZamowieniaF      = klucze['NrZamowieniaF']
        ArtykulF           = klucze['ArtykulF']

    if Funkcja == 14:
        Trasa   = klucze['Trasa']
        Data    = klucze['Data']
        Tryb    = klucze['Tryb']
        Oddzial = klucze['Oddzial']
        Numer   = klucze['Numer']


# tu bedzie klucz do nowego dowodu, aby uwzglednic go w filtrowaniu,
# a takze zwrocic do klienta, aby mozna ustawic kursor na nowo dodanym
NowyDowod = []

if stat == 'OK' and self.operator_id != STANDARD_OPERATOR_ID:    #JR 2021-05-18 (12493)
    # sprawdzenie czy operator ma wpisany symbol kontrahenta, jesli tak - zastepujemy tego z filtra
    sql = "SELECT COALESCE(kontrahent_id,'') FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)+";"
    stat, kont, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if kont[0][0].strip() != '':
            KontrF = kont[0][0]     # bez strip() bo jest robiony like

#-------------------------------------------------------------------------------
#--- sprawdzenie danych filtra okna (5,6,7,31)
#-------------------------------------------------------------------------------

if Funkcja in [5,6,7,31]:
    if stat=='OK':
        if TrybF.strip()<>'':
            Select="SELECT kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+TrybF+"' ;"
            stat,daneT,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat='BL SQL TRYB'
            else:    
                if len(daneT)==0:
                    stat='BL TRYB'
    if stat=='OK':
        if KontrF.strip()<>'':
            Select= "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
            Select+="AND kontrahent_id='"+KontrF+"' ;"
            stat,daneT,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat='BL SQL KONTR'
            else:
                if len(daneT)==0:
                    stat='BL KONTR'

    #WS 2019-04-15
    if stat=='OK':
        if ArtykulF.strip()<>'':
            Select= "SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+ArtykulF+"' ;"
            stat,daneT,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat='BL SQL ART'
            else:
                if len(daneT)==0:
                    stat='BL ART'

    if stat=='OK':
        if DataOdF<>'    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataOdF):
                stat='BL DATAOD'
                dane.append(stat)
    if stat=='OK':
        if DataDoF<>'    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataDoF):
                stat='BL DATADO'
                dane.append(stat)
    
    if stat=='OK':
        if DataOdF<>'    -  -  ' and DataDoF<>'    -  -  ':
            if DataDoF<DataOdF:
                stat='BL ZAKR DAT'


#-------------------------------------------------------------------------------
#--- sprawdzenie czy dostawy uproszczone (17,12,13,19)
#-------------------------------------------------------------------------------

if Funkcja in [5,17,12,13,19]:
    if stat=='OK':  #AB 22.12.20r dodane czy_zbiorcza_dla_oddzialow
        Select="SELECT dostawy_uproszczone, czy_zbiorcza_dla_oddzialow FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat='BL FIRMA'
        else:
            self.DostUpr=(dane[0][0])
    else:
        self.DostUpr=False


#-------------------------------------------------------------------------------
#---   Pobranie numerw do masowego wydruku dowodw dostaw (16)
#-------------------------------------------------------------------------------

if stat=='OK':
    if Funkcja in [16]:
        sql= "SELECT numer,oddzial_id FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' ORDER BY numer;"
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat="BL SQL POB"


#-------------------------------------------------------------------------------
#---   Przeczenie wartoci komrki 'zwrocony' dla DD (14)
#-------------------------------------------------------------------------------

if stat=='OK':
    if Funkcja in [14]:
        SQL = """SELECT 1 FROM rs_dowody_dostaw
        WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' 
        AND numer={} AND stan != '0';"""
        SQL = SQL.format(self.firma_id, Oddzial, Trasa, Data, Tryb, Numer)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(SQL, 5)
        if stat != 'OK':
            stat = "BL SQL UPD ZWR"
        elif len(dane) != 1:
            stat = "BL SQL UPD STAN"
        else:
            upd = """UPDATE rs_dowody_dostaw SET zwrocony=COALESCE(NOT zwrocony, TRUE) 
            WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' 
            AND numer={} AND stan != '0';"""
            upd = upd.format(self.firma_id, Oddzial, Trasa, Data, Tryb, Numer)
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(upd, 1, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow(upd, 5)
            if stat != 'OK':
                stat = "BL SQL UPD ZWR"


#-------------------------------------------------------------------------------
#---   Zamykanie dowodow dostaw (12,19)
#-------------------------------------------------------------------------------

if Funkcja in [12,19] and (stat=='OK'):
    if not ((self.oddzial_id,'028016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat == 'UPR ZAM'
        
    
    # pobranie typu korekty/niekorekty na podstawie podanego dowodu
    if stat == 'OK':
        sql="SELECT COALESCE(korekta,FALSE) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(dane)==0:
                stat='Brak podanego dowodu dostawy'
            else:
                if dane[0][0]:
                    CzyKorekta=' korekta'
                else:
                    CzyKorekta=' NOT COALESCE(korekta,FALSE)'
        
    if stat == 'OK':
        if self.DostUpr:
            Num= "AND numer="+str(Numer)+" "
        else:
            if dane[0][0]:
                # jesli korekta, to zamykanie pojedyncze
                Num= "AND numer="+str(Numer)+" "

                # sprawdzenie zerowych pozycji
                sql ="SELECT ilosc_dost1,ilosc_zwr1"
                sql+=" FROM rs_dowody_dostaw_pozycje"
                sql+=" WHERE firma_id='"+self.firma_id+"' "
                sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
                sql+="AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"

                stat,Pozycje,dump,dump=self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania danych pozycji: '+stat
                elif len(Pozycje) == 0:
                    stat = 'Korekta nie zawiera pozycji. Zamknicie niemoliwe.'
                else:
                    Pusta = True
                    for i in xrange(len(Pozycje)):
                        if Pozycje[i][0] <> 0 or Pozycje[i][1]:
                            Pusta = False
                            break
                    if Pusta:
                        stat = 'Na korekcie nie wprowadzono adnych zmian. Zamknicie niemoliwe.'
            else:
                Num=""

    if stat == 'OK':
        sql="SELECT DISTINCT stan FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' "+Num+" AND "+CzyKorekta+" ORDER by stan desc;"
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat="BL SQL POB"
        elif len(dane)>1:
            stat="BL SQL ZAM"
        elif int(dane[0][0])>1:
            stat="BL SQL ZAM"

    if stat == 'OK' and rsglobal.Dekoduj(dane[0][0]) in ('0','1'):
        #blokada wybranych dowodow dostaw 
        sql="SELECT stan FROM rs_dowody_dostaw "
        sql+=" WHERE firma_id='"+self.firma_id+"' "
        sql+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+=" AND tryb_dostawy='"+Tryb+"' "+Num+" AND "+CzyKorekta
        sql+=" AND stan='"+rsglobal.Dekoduj(dane[0][0])+"' FOR UPDATE NOWAIT;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            if self.DostUpr:
                stat = 'Wrd zamykanych dowodw jest dowd zablokowany przez innego operatora. Operacja zmiany stanu niemoliwa.'
            else:
                stat = 'Dowd dostawy jest zablokowany przez innego operatora. Operacja zmiany stanu niemoliwa.'
    
    if stat == 'OK':
        #  sprawdzenie czy kady dowd dostawy ma pozycj
        sql="SELECT dd.trasa||'/'||dd.data||'/'||dd.tryb_dostawy||'/'||dd.numer::TEXT,COALESCE(ddp.artykul_id,'') FROM rs_dowody_dostaw dd "
        sql+=" LEFT OUTER JOIN rs_dowody_dostaw_pozycje ddp USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
        sql+=" WHERE dd.firma_id='"+self.firma_id+"' "
        sql+=" AND dd.oddzial_id='"+Oddzial+"' AND dd.trasa='"+Trasa+"' AND dd.data='"+Data+"' "
        sql+=" AND dd.tryb_dostawy='"+Tryb+"' "+Num+" AND "+CzyKorekta
        sql+=" AND dd.stan='"+rsglobal.Dekoduj(dane[0][0])+"';"            
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat= "Bd pobierania danych do sprawdzenia pustoci pozycji na dowodach dostaw: "+stat
    
    if stat == 'OK':
        for poz in d:
            if stat == 'OK':
                if poz[1] == '':
                    stat="Nie mona zamkn dowodw dostaw - na dowodzie "+poz[0]+" nie ma pozycji"
        
    if stat == 'OK':
        sql= "UPDATE rs_dowody_dostaw SET stan=CAST(stan as integer)+1 WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' "+Num+" AND stan<'2' AND "+CzyKorekta+";"
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat="BL SQL ZAM"


#-------------------------------------------------------------------------------
#---  Otwieranie dowodow dostaw (13)
#-------------------------------------------------------------------------------

if Funkcja in [13] and (stat=='OK'):
    if not (((self.oddzial_id,'028015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR ZAM'

    #AB 27.09.18r
    if stat == 'OK':
        stan = """SELECT stan FROM rs_dowody_dostaw 
                  WHERE firma_id = '{firma}' AND oddzial_id = '{oddzial}' AND "data" = '{data}' AND trasa = '{trasa}'
                        AND tryb_dostawy = '{tryb}' AND numer = '{numer}'; """
        stan = stan.format(firma=self.firma_id, oddzial=Oddzial, data=Data, trasa=Trasa, tryb=Tryb, numer=Numer)
        stat, dane, dump, dump = self.PolSQL.Execute(stan, 3)
        if stat == 'OK':
            rsglobal.ZapiszDoLogow(dane[0][0], 5)
            if dane[0][0] == '1':
                sql  ="SELECT * FROM rs_dowody_dostaw_wms WHERE firma_id='"+self.firma_id+"' "
                sql +="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
                sql +="AND tryb_dostawy='"+Tryb+"';"
                stat, wms, dump, dump = self.PolSQL.Execute(sql, 3)
                rsglobal.ZapiszDoLogow(sql, 5)
                if stat == 'OK':
                    if len(wms) > 0:
                        stat = 'Dla dowodw z {data} na trasie {trasa} o trybie {tryb} istnieje przygotowane wydanie do WMS. Nie mona zmieni stanu na 0.'
                        stat = stat.format(data=Data, trasa=Trasa, tryb=Tryb)
                    else:
                        sql  ="SELECT * FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
                        sql +="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
                        sql +="AND tryb_dostawy='"+Tryb+"' and (zw_data IS NOt NULL OR wz_data IS NOT NULL);"
                        stat, dok, dump, dump = self.PolSQL.Execute(sql, 3)
                        rsglobal.ZapiszDoLogow(sql, 5)
                        if stat == 'OK':
                            if len(dok) > 0:
                                stat = 'Dla dowodw z {data} na trasie {trasa} o trybie {tryb} s ju utworzone dokumenty. Nie mona zmieni stanu na 0.'
                                stat = stat.format(data=Data, trasa=Trasa, tryb=Tryb)

    if stat=='OK':
        sql="SELECT korekta FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(dane)==0:
                stat='Brak podanego dowodu dostawy'
            else:
                if dane[0][0]:
                    CzyKorekta=' korekta'
                else:
                    CzyKorekta=' NOT COALESCE(korekta,FALSE)'
    
    if stat=='OK':
        if self.DostUpr:
            Num= "AND numer='"+str(Numer)+"' "
        else:
            Num=""

    if stat=='OK' and dane[0][0]:
        # jesli korekta, to otwieranie pojedynczych korekt
        Num= "AND numer='"+str(Numer)+"' "
        
    # sprawdzenie czy na dokumencie jest wpisany dokument WZ lub ZW. Jeli tak to nie mona otwiera
    # obowizuje dla dowodw stanu 2
    if stat == 'OK':
        sql= "SELECT DISTINCT COALESCE(wz_magazyn_id,zw_magazyn_id,'') FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' "+Num+" AND "+CzyKorekta
        sql+=" AND COALESCE(wz_magazyn_id,zw_magazyn_id,'') <> '' AND stan ='2';"
        rsglobal.ZapiszDoLogow('sql '+sql,1)
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow('dane '+str(dane),1)
        if stat<>'OK':
            stat="BL SQL POB"
        elif len(dane)>0:
            stat="IST DM ST2"
            
    if stat=='OK':        
        sql= "SELECT DISTINCT stan FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
        sql+="AND tryb_dostawy='"+Tryb+"' "+Num+" AND "+CzyKorekta+" ORDER by stan;"
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat="BL SQL POB"
        elif len(dane)>1:
            stat="BL SQL OTW"
        elif (dane[0][0]>'2') or (dane[0][0]=='0'):
            stat="BL SQL OTW"
        
        if stat=='OK':
            sql="UPDATE rs_dowody_dostaw SET stan=CAST(stan as integer)-1 WHERE firma_id='"+self.firma_id+"' "
            sql+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
            sql+="AND tryb_dostawy='"+Tryb+"' "+Num+" AND stan>'0' AND stan<'3' AND "+CzyKorekta+";"
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                stat="BL SQL OTW"


#-------------------------------------------------------------------------------
#---   Zmiana kontrahenta -  21
#-------------------------------------------------------------------------------

if Funkcja == 21 and (stat=='OK'):
    if not (((self.oddzial_id,'028019') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):       
        stat = 'Brak uprawnie do zmiany kontrahenta .'
        dane.append(stat)
    
    if stat=='OK':    
        Select="SELECT platnik_id,zablokowany FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
        Select+="AND kontrahent_id='"+str(KontrahentN)+"';"
        stat,dane,dump,dump = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania patnika :'+stat
            dane.append(stat) 
        elif dane[0][1]:
            stat = 'BL KONTRAHENT ZABLOKOWANY'
            
    if stat=='OK':
        if len(dane)>0: 
            if dane[0][0] in ['',None,'NULL','None']:
                PlatnikN=KontrahentN
            else:
                PlatnikN=dane[0][0]                
            sql ="UPDATE rs_dowody_dostaw SET kontrahent_id='"+str(KontrahentN)+"', platnik_id='"+str(PlatnikN)+"'"
            sql +=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"' AND trasa = '"+Trasa+"'"
            sql +=" AND data = '"+Data+"' AND tryb_dostawy = '"+Tryb+"' AND numer = "+str(Numer)+";"
            stat,dane,dump,dump = self.PolSQL.Execute(sql,1)           
            if stat<>'OK':
                stat = 'Bdy zmiany kontrahenta :'+stat
                dane.append(stat)
                 
            if stat=='OK':
                #pobranie ceny z dowodw
                SQL="SELECT DISTINCT dp.artykul_id,dp.cena_netto1 FROM rs_dowody_dostaw_pozycje dp INNER JOIN rs_dowody_dostaw dd "
                SQL+=" USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
                SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dd.kontrahent_id='"+str(KontrahentN)+"' AND oddzial_id='"+Oddzial+"'"
                SQL+=" AND dp.data='"+Data+"' ORDER BY dp.artykul_id,dp.cena_netto1;"
                stat,DCena,dump,dump = self.PolSQL.Execute(SQL,3)   
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu wersji cenowych :'+stat
                    dane.append(stat)                                 
            
            if stat=='OK':
                temp=None
                for poz in DCena:
                    if temp == poz[0]:
                        stat="Podany artyku wystpuje z dwoma cenami w danym dniu : "+str(temp)
                        dane.append(stat)                                                 
                        break
                    temp=poz[0]
                                     

#-------------------------------------------------------------------------------
#---   Sprawdzenie czy usuwa 1 dowd czy trase (i czy cokolwiek) (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and (stat=='OK'):
    # czy dotyczy to dowodu czy korekty dowodu
    sql ="SELECT COALESCE(korekta,FALSE) FROM rs_dowody_dostaw"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    sql+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z dowodu: '+stat
    elif len(d) == 0:
        stat='Brak podanego dowodu dostawy'
    elif d[0][0]:
        CzyKorekta = 'korekta'
    else:
        CzyKorekta = 'NOT COALESCE(korekta,FALSE)'
    
    Select="SELECT max(numer) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
    Select+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' "
    Select+="AND tryb_dostawy='"+Tryb+"' AND "+CzyKorekta+";"

    stat,dane,dump,dump = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania numeru :'+stat
        dane.append(stat)  
    elif len(dane)==0:
        stat='BR DOW'


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (1 dowod - 6) (wiele dowodow - 7) 
#-------------------------------------------------------------------------------

if Funkcja in [6,7] and (stat=='OK') :
    if ((self.oddzial_id,'028014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        if Funkcja==6:
            Select ="SELECT COALESCE(korekta,FALSE),czy_automatycznie"
            Select+=" FROM rs_dowody_dostaw"
            Select+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            Select+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"'"
            Select+=" AND numer="+str(Numer)+";"

            stat,Dowod,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat = 'Bd pobrania danych: '+stat
            elif len(Dowod) == 0:
                stat = 'Brak dokumentu o podanym kluczu.'
            else:
                automatyczny = Dowod[0][1]

            if stat == 'OK' and Dowod[0][0]:
                # jesli korekta, to sprawdzamy czy ostatnia (niezaleznie reczna, automatyczna)
                Select= "SELECT numer FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
                Select+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
                Select+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer>" + str(Numer)
                Select+=" AND korekta;"
                
                stat,d,dump,dump=self.PolSQL.Execute(Select,3)
                if stat<>'OK':
                    stat = 'Bdy w pobieraniu danych :'+stat
                    dane.append(stat)
                else:
                    if len(d)>0:
                        stat='DEL KOR NIE OST'
                        dane.append(stat)
            
            if stat == 'OK' and automatyczny and not Dowod[0][0]:
                # jesli to automatyczny dowod, to sprawdzamy, czy jest pierwszy
                Select= "SELECT * FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
                Select+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND"
                Select+=" data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer<" + str(Numer)
                
                # brak COALESCE pozwoli sprawdzic i usunac dowody z korektami z calej trasy
                #Select+=" AND COALESCE(korekta,FALSE);"
                
                Select+=";"
                
                stat,d,dump,dump=self.PolSQL.Execute(Select,3)
                if stat<>'OK':
                    stat = 'Bdy w pobieraniu danych :'+stat
                    dane.append(stat)
                else:
                    if len(d)>0:
                        stat='DEL DOW AUT'
                        dane.append(stat)
            
            FNr=" AND numer="+str(Numer)
        else:
            FNr=""
    
        if stat=='OK':
            # sprawdzenie czy z usuwanych dowodw dostaw nic nie jest wanie rozstawione
            SQL="SELECT * FROM rs_dowody_dostaw_pozycje "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' "
            SQL+="AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' "+FNr
            SQL+=" AND ilosc_wysw1 <> 0 LIMIT 1; "
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat='Bd pobierania informacji o wywietlaniu danych na wywietlaczach'
            elif len(DTest)>0:
                stat='Nie mona usnc dowodu/w dostaw poniewa niektre pozycje s wywietlone na wywietlaczach'
            
        if stat == 'OK':
            Select="SELECT stan FROM rs_dowody_dostaw "
            Select+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' "
            Select+="AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' "+FNr
            Select+=" FOR UPDATE NOWAIT;"

            stat,d,dump,dump = self.PolSQL.Execute(Select,3)
            if stat <> 'OK':
                if Funkcja == 6:
                    if Dowod[0][0]:
                        stat = 'Korekta dowodu dostawy zablokowana'
                    else:
                        stat = 'Dowd dostawy zablokowany'
                    stat+= ' przez innego operatora.'
                    stat+= ' Operacja usunicia niemoliwa.'
                else:
                    stat = 'Wrd dowodw dostaw, ktre podlegaj usuniciu'
                    stat+= ' jest przynajmniej jeden, zablokowany przez innego operatora.'
                    stat+= ' Operacja usunicia niemoliwa.'
                dane.append(stat)
            
        if stat == 'OK': 
            Select="SELECT SUM(CAST(stan AS numeric)) FROM rs_dowody_dostaw "
            Select+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' "
            Select+="AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"'"+FNr+";"
            stat,stan,dump,dump = self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat = 'Bdy pobierania stanu :'+stat
                dane.append(stat)
            else:
                if len(stan)==0:
                    stat='BR US'
                else:
                    if stan[0][0]==0:
                        Delete="DELETE FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
                        Delete+="AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
                        Delete+="AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"'"+FNr+";"
                        stat,dump,dump,dump = self.PolSQL.Execute(Delete,1)
                    else:
                        stat='US ZAM'
    else:
        stat='UPR DEL'


#-------------------------------------------------------------------------------
#---   TWORZENIE KOREKTY DOWODU (31) 
#-------------------------------------------------------------------------------

if Funkcja == 31 and stat == 'OK':
    if not ((self.oddzial_id,'128011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat == 'UPR TWORZ KOR'
        
    if stat == 'OK':
        sql = "SELECT stan,COALESCE(korekta,FALSE),oddzial_id,current_date"
        sql+=" FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        sql+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
        sql+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
        sql+=" FOR UPDATE NOWAIT;"
            
        stat,Dowod,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':  #AB 03.08.21r
            stat = 'Dowd dostawy jest zablokowany przez innego operatora.'
        elif len(Dowod) == 0:
            stat = 'Brak dowodu dostawy o podanym kluczu: '+stat
        elif Dowod[0][1]:
            stat = 'Korekt mona wystawi tylko do dowodu, a nie do korekty.'

    if stat == 'OK':
        sql = "SELECT artykul_id"
        sql+=" FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' "
        sql+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
        sql+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
            
        stat,Pozycje,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bd pobrania pozycji: '+stat
        elif len(Pozycje) == 0:
            stat = 'Dowd dostawy nie zawiera pozycji. Korekta niemoliwa.'

    if stat == 'OK':
        SQL = "SELECT rsf_podaj_pole_z_danych_do_fakturowania(firma_id,kontrahent_id,data,'korekta_z_data_dowodu'),"
        SQL+=" rsf_podaj_pole_z_danych_do_fakturowania(firma_id,platnik_id,data,'korekta_z_data_dowodu')"
        SQL+=" FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
        SQL+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
        stat,DFakt,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=u'Bdy pobirania informacji z danych do fakturowania :'+stat
        if stat=='OK':
            DataKorekty = rsglobal.PodajDzis() #domylnie ustawiamy
            if DFakt[0][0]=='true':     #kontrahent ma ptaszka
                DataKorekty = Data      #dostajemy date dowodu
            
            elif DFakt[0][0]=='':       #kontrahent nie ma danych
                if DFakt[0][1]=='true': #patnik ma ptaszka
                    DataKorekty = Data  #dostajemy date dowodu
                    
            elif DataKorekty<Data:      #Data dowodu dostawy jest pniejsza ni dzie dzisiejszy
                DataKorekty = Data      #Data korekty jest dniem dowodu dostawy

    if stat == 'OK':
        INS = ''
        
        # ustalamy numer korekty
        Warunek ="firma_id=\\'"+self.firma_id+"\\' AND oddzial_id=\\'"+Oddzial+"\\'"
        Warunek+=" AND trasa=\\'"+Trasa+"\\' AND data=\\'"+DataKorekty+"\\'"
        Warunek+=" AND tryb_dostawy=\\'"+Tryb+"\\'"
        
        sql = "SELECT rsf_klucz_where_new('rs_dowody_dostaw','"+Warunek+"','numer');"
        stat,NumerKorekty,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru dla korekty: '+stat

    if stat == 'OK':
        NaglowekBezPol = ['f_wyznacznik_id','f_data','f_numer']
        PozycjeBezPol = ['op_dost','op_zwr']
        PolaNaglowka = rsglobal.PolaTabeli(self.PolSQL,'rs_dowody_dostaw',NaglowekBezPol)
        PolaPozycji = rsglobal.PolaTabeli(self.PolSQL,'rs_dowody_dostaw_pozycje',PozycjeBezPol)
        
        if not (PolaNaglowka[0] == 'OK' and PolaPozycji[0] == 'OK'):
            stat = 'Bd pobrania listy pl z dowodw.'

    if stat == 'OK':
        # INSERT naglowka
        INS+= "INSERT INTO rs_dowody_dostaw ("
        for i in xrange(len(PolaNaglowka[1])):
            if i > 0:
                INS+= ","
            INS+= PolaNaglowka[1][i]
        INS+= ") SELECT "

        for i in xrange(len(PolaNaglowka[1])):
            if i > 0:
                INS+= ","
            pole = PolaNaglowka[1][i]
            
            # dane do klucza nowej korekty
            if pole == 'numer':
                INS+= str(NumerKorekty[0][0])
            elif pole == 'data':
                INS+= "'"+DataKorekty+"'"
                
            # wazne dane indywidualne
            elif pole == 'stan':
                INS+= "'0'"
            elif pole == 'czy_automatycznie':
                INS+= "FALSE"
            elif pole == 'korekta':
                INS+= "TRUE"

            # dane korygowanego dowodu
            elif pole == 'oddzial_id_p':
                INS+= "'"+rsglobal.Dekoduj(Dowod[0][2])+"'"
            elif pole == 'trasa_p':
                INS+= "'"+Trasa+"'"
            elif pole == 'data_p':
                INS+= "'"+Data+"'"
            elif pole == 'tryb_dostawy_p':
                INS+= "'"+Tryb+"'"
            elif pole == 'numer_p':
                INS+= str(Numer)
            
            # dane utworzonych dokuemntw WZ i ZW
            elif pole in ('wz_magazyn_id','wz_dokument_id','wz_data','wz_numer','zw_magazyn_id','zw_dokument_id','zw_data','zw_numer','data_eksportu'):
                INS+="NULL"
                
            # pozostale kopiowane pola
            else:
                INS+= pole
            

        INS+=" FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
        INS+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
        INS+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
        INS+= "; "

        # INSERT pozycji
        INS+= "INSERT INTO rs_dowody_dostaw_pozycje ("
        for i in xrange(len(PolaPozycji[1])):
            if i > 0:
                INS+= ","
            INS+= PolaPozycji[1][i]
        INS+= ") SELECT "
        
        for i in xrange(len(PolaPozycji[1])):
            if i > 0:
                INS+= ","
            pole = PolaPozycji[1][i]
            
            # dane do klucza nowej korekty
            if pole == 'numer':
                INS+= str(NumerKorekty[0][0])
            elif pole == 'data':
                INS+= "'"+DataKorekty+"'"
                
            # wyzerowane pola: ilosci
            elif pole in ('ilosc_zam1','ilosc_zam2',
                          'ilosc_pobr1','ilosc_pobr2',
                          'ilosc_dost1','ilosc_dost2',
                          'ilosc_zwr1','ilosc_zwr2',
                          'ilosc_rozl1','ilosc_rozl2',
                          'ilosc_rozl_f1','ilosc_rozl_f2',
                          'ilosc_rozst1','ilosc_rozst2',
                          'ilosc_wysw1','ilosc_wysw2',
                          ):
                INS+= "0"
                
            # pozostale kopiowane pola
            else:
                INS+= pole

        INS+=" FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' "
        INS+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
        INS+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
        INS+= "; "


    if stat == 'OK' and INS <> '':
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
        if stat <> 'OK':
            stat = 'Bd tworzenia korekty do dowodu: '+stat
            
    if stat == 'OK':
        NowyDowod = [Oddzial,Trasa,DataKorekty,Tryb,NumerKorekty[0][0]]
        
      
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete jednego, 7- delete wielu)
#-------------------------------------------------------------------------------
if stat == 'OK':
    #JR 2021-12-14 (12772) -rezygnacja z filtru na oddzial przy uprawnieniach 803000 w centrali
    wszystkie = False
    if ((self.oddzial_id,'803000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat,d,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND centrala;",3)
        if stat != 'OK':
            stat = 'Bd pobierania danych o centrali.' + stat
        elif len(d) == 0:
            stat = 'Brak Centrali w oddziaach'
        elif d[0][0] == self.oddzial_id:
            wszystkie = True

if (Funkcja in [5,6,7,12,13,21,31]) and (stat=='OK'):
    # pobranie danych o dokumentach
    Filtr="WHERE f.firma_id='"+self.firma_id+"'"
    if not wszystkie:
        Filtr+= " AND (f.oddzial_id='"+self.oddzial_id+"'"
        Filtr+="  OR '"+self.oddzial_id+"'=rsf_podaj_oddzial_ekspedycji(f.firma_id,f.oddzial_id,f.trasa,f.data,f.tryb_dostawy))"
    
    if TrasaF <> '':
        Filtr=Filtr+" AND f.trasa LIKE '"+TrasaF+"%'"
    if DataOdF not in ('','    -  -  '):
        Filtr=Filtr+" AND f.data >= '"+DataOdF+"'"        
    if DataDoF not in ('','    -  -  '):
        Filtr=Filtr+" AND f.data <= '"+DataDoF+"'"        
        
    if TrybF <> '':
        Filtr=Filtr+" AND f.tryb_dostawy ='"+TrybF+"'"
    elif RzutF <> '':
        #pobranie listy trybow dla podanego rzutu
        Filtr+=" AND f.tryb_dostawy IN ("
        Filtr+=" SELECT kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND rzut='"+RzutF+"'"
        Filtr+=" )"
        
    if KontrF <> '':
        Filtr=Filtr+" AND f.kontrahent_id LIKE '"+KontrF+"%'"        
    if StanF <> '':
        Filtr=Filtr+" AND f.stan ='"+StanF+"'"    
    if KorektaF:
        Filtr=Filtr+" AND f.korekta"    
    if NiewyeksportowaneF:
        Filtr=Filtr+" AND f.data_eksportu IS NULL"
    if Niezwrocone:
        Filtr=Filtr+" AND NOT COALESCE(zwrocony, FALSE) "

    #WS 2019-04-15
    if NrDowZwrotuF:
        Filtr=Filtr+" AND f.dowod_zwrotu LIKE '%"+NrDowZwrotuF+"%'"
    if NrZamowieniaF:
        Filtr=Filtr+" AND f.numer_zamowienia LIKE '%"+NrZamowieniaF+"%'"
    if ArtykulF:
        Filtr=Filtr+" AND fp.artykul_id ='"+ArtykulF+"'"

    if KontrahentN not in ('',None,'NULL'):
        Filtr=Filtr+" OR f.kontrahent_id='"+str(KontrahentN)+"%'"
    
    if NowyDowod <> []:
        # uwzglednienie nowego dowodu
        Filtr+=" OR ("
        Filtr+=" f.oddzial_id='"+NowyDowod[0]+"' AND f.trasa='"+NowyDowod[1]+"'"
        Filtr+=" AND f.data='"+NowyDowod[2]+"' AND f.tryb_dostawy='"+NowyDowod[3]+"'"
        Filtr+=" AND f.numer="+str(NowyDowod[4])
        Filtr+=") "

    DokWZ="CASE WHEN wz_magazyn_id IS NULL THEN '' ELSE wz_magazyn_id||'/'||wz_dokument_id||'/'||wz_data::TEXT||'/'||wz_numer::TEXT END"
    DokZW="CASE WHEN zw_magazyn_id IS NULL THEN '' ELSE zw_magazyn_id||'/'||zw_dokument_id||'/'||zw_data::TEXT||'/'||zw_numer::TEXT END"

    if self.DostUpr:
        #SELECT DLA DOWODOW UPROSZCZONYCH (DODATKOWA KOLUMNA Z SUMAMI ILOSCI Z POZYCJI)
        Select="SELECT f.stan,f.trasa,f.data,f.tryb_dostawy,f.numer,f.kontrahent_id||' - '||k.nazwa,f.platnik_id,f.kierowca "
        Select+=",SUM(CASE WHEN a.typ_artykulu not in ('31','99') THEN fp.ilosc_pobr1 END) "
        Select+=" ,f.f_wyznacznik_id||'/'||f.f_data||'/'||f.f_numer,f.z_wyznacznik_id||'/'||f.z_data||'/'||f.z_numer,"
        Select+=" f.korekta,f.oddzial_id,f.skan,"+DokWZ+","+DokZW + ', f.zwrocony, '
        Select+=" STRING_AGG(DISTINCT TRIM(a.artykul_id), ',')"  #WS 2021-08-05
        Select+=" FROM rs_dowody_dostaw f "
        Select+=" LEFT OUTER JOIN rs_dowody_dostaw_pozycje fp ON (f.firma_id=fp.firma_id AND  f.oddzial_id=fp.oddzial_id " 
        Select+=" AND f.trasa=fp.trasa AND f.data=fp.data AND f.tryb_dostawy=fp.tryb_dostawy AND f.numer=fp.numer) "
        Select+=" LEFT OUTER JOIN rs_artykuly a ON(f.firma_id=a.firma_id AND fp.artykul_id=a.artykul_id ) "
        Select+=" INNER JOIN rs_kontrahenci k ON (f.kontrahent_id=k.kontrahent_id AND f.firma_id=k.firma_id) "
        Select+=" "+Filtr+" "
        Select+=" GROUP BY f.stan,f.trasa,f.data,f.tryb_dostawy,f.numer,f.kontrahent_id,k.nazwa,f.platnik_id,f.kierowca "
        Select+=" ,f.f_wyznacznik_id,f.f_data,f.f_numer,f.z_wyznacznik_id,f.z_data,f.z_numer,f.korekta,f.oddzial_id,f.skan, "
        Select+=" wz_magazyn_id,wz_dokument_id,wz_data,wz_numer,zw_magazyn_id,zw_dokument_id,zw_data,zw_numer, f.zwrocony"
        Select+=" ORDER BY f.trasa,f.data,f.tryb_dostawy,f.numer; "
    
    else: #AB 11.12.19r Dodanie Distinct  #WS 2021-04-13 - dodana zalepka midzy kierowc i faktur
          #WS 2021-08-05 - dodana zalepka po zwrocony
        Select="SELECT DISTINCT f.stan,f.trasa,f.data,f.tryb_dostawy,f.numer,f.kontrahent_id||' - '||k.nazwa,"
        Select+=" f.platnik_id,f.kierowca,NULL,f.f_wyznacznik_id||'/'||f.f_data||'/'||f.f_numer,"
        Select+=" f.z_wyznacznik_id||'/'||f.z_data||'/'||f.z_numer,f.korekta,f.oddzial_id,f.skan,"+DokWZ+","+DokZW+', f.zwrocony,NULL '
        Select+=" FROM rs_dowody_dostaw f INNER JOIN rs_kontrahenci k ON "
        Select+=" (f.kontrahent_id=k.kontrahent_id AND f.firma_id=k.firma_id) "
        #WS 2019-04-15
        if ArtykulF:
            Select+=" INNER JOIN rs_dowody_dostaw_pozycje fp ON (f.firma_id=fp.firma_id AND f.oddzial_id=fp.oddzial_id "
            Select+=" AND f.trasa=fp.trasa AND f.data=fp.data AND f.tryb_dostawy=fp.tryb_dostawy AND f.numer=fp.numer) "

        Select+=" "+Filtr+" "
        Select+=" ORDER BY f.trasa,f.data,f.tryb_dostawy,f.numer;"
    
    rsglobal.ZapiszDoLogow(Select, 5)
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania dokumentw :'+stat
        dane.append(stat)
        
    if stat == 'OK':
        # numer nowego dowodu
        wyn2.append(NowyDowod)
    

#-------------------------------------------------------------------------------
#--- dla komser
#-------------------------------------------------------------------------------

def dolozDodatkoweDane(dodatkoweDane, nazwa, row, desc, zwroc=[]):
    nowe = []
    doZwrocenia = [None] * len(zwroc)
    for d, info in zip(row, desc):
        if d == "None":
            d = None
        if info[0] not in ("z_czas", "z_typ", "z_op_id"):
            nowe.append((info[0], d))
        if info[0] in zwroc:
            doZwrocenia[zwroc.index(info[0])] = d
    dodatkoweDane.append((nazwa.upper(), nowe))
    return doZwrocenia

# komser: no to jesli mamy cos do przeslania to zapisujemy
# FIXME: brak obsugi dostaw nie uproszczonych (zamykanie hurtem)
if stat == "OK" and Funkcja in (12, 19, 13) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    # komser: sprawdzamy czy dane maj by przesyane dalej
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest and Funkcja in (12, 19):
        komserDane = []
        stat, dowodDostawy, desc, dump = self.PolSQL.Execute("SELECT * FROM rs_dowody_dostaw"
            " WHERE firma_id=%s AND oddzial_id=%s AND trasa=%s AND data=%s AND tryb_dostawy=%s AND numer=%s", 3,
            (self.firma_id, Oddzial, Trasa, Data, Tryb, Numer))
        if stat == "OK":
            stat, pozycje, pdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_dowody_dostaw_pozycje"
                " WHERE firma_id=%s AND oddzial_id=%s AND trasa=%s AND data=%s AND tryb_dostawy=%s AND numer=%s", 3,
                (self.firma_id, Oddzial, Trasa, Data, Tryb, Numer))
        if stat == "OK" and dowodDostawy:
            nowyStan = dolozDodatkoweDane(komserDane, "DOW_DOST", dowodDostawy[0], desc, ["stan"])
            if int(nowyStan[0]) == 2:
                for pozycja in pozycje:
                    dolozDodatkoweDane(komserDane, "DDOSTPOZ", pozycja, pdesc)
                stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja", "dodatkowe-dane:", komserDane],
                    ["fs_komser_dowody_dostaw", klucze, pola, wartosci])
    elif jest and Funkcja in (13, ):
        stat, stan, desc, dump = self.PolSQL.Execute("SELECT stan FROM rs_dowody_dostaw"
            " WHERE firma_id=%s AND oddzial_id=%s AND trasa=%s AND data=%s AND tryb_dostawy=%s AND numer=%s", 3,
            (self.firma_id, Oddzial, Trasa, Data, Tryb, Numer))
        rsglobal.ZapiszDoLogow("fs_dowody_dostaw/komser: otwieranie Fun=%s teraz stan=%r" % (Funkcja, stan), 3)
        if stat != "OK":
            stat = "BL SQL komser"
        elif stan[0][0] == 1:
            # przekazywanie te informacji o otworzeniu dowodu z 2 na 1, wtedy niech zostanie usuniety z docelowej
            stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], ["fs_komser_dowody_dostaw", klucze, pola, wartosci])
