# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_dane.py
# Purpose:     wczytuje/edytuje dane dowodu dostawy
#
# Author:      Micha Raburski
# Created:     2007/07/12
# RCS-ID:      $Id: fs_dowody_dostaw_dane.py $
# Copyright:   (c) 2004-2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-03-16 Mariusz Rajfura    pobranie opisow dla korygowanego dowodu (5531)
# 2012-09-20 Mariusz Rajfura    (6087) oddzial_id w kluczu
# 2020-12-22 Wojciech Skowron   (12225) Jeli kontrahent nie ma patnika to patnik=kontrahent
# 2020-12-28 Wojciech Skowron   (12233) Okno edycji na wzr okna dodawania
# 2021-06-17 Aleksander Bargie (12535) Zmiana kontrahenta na dowodzie dostawy przelicza ceny bez uwzgldnienia
#                                       oddziau w pobieraniu
# 2022-07-14 Aleksander Bargie (12780) Uproszczone Dowody dostaw - zmiana kontrahenta moe ustawi zerowe ceny
import rsglobal

stat = 'OK'
dane = []
wyn2 = []

Trasa = rsglobal.Dekoduj(klucze[0])
Data = rsglobal.Dekoduj(klucze[1])
Tryb = rsglobal.Dekoduj(klucze[2])
Nr = str(klucze[3])
Oddzial = rsglobal.Dekoduj(klucze[4])

Fun = klucze[-1]

UprEdycja = (((self.oddzial_id,'028012') in self.uprawnienia) or ((self.oddzial_id,'028013') in self.uprawnienia) or \
                self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if UprEdycja:
        UPD_Poz = ''
        where =" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"' AND trasa = '"+Trasa+"'"
        where+=" AND data = '"+Data+"' AND tryb_dostawy = '"+Tryb+"' AND numer = "+str(Nr)+";"
        upd = "UPDATE rs_dowody_dostaw SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
    
            if pole in ['dowod_zwrotu','numer_zamowienia','numer_mpt','budowa']:
                upd=upd+pole+"='"+str(wart)+"',"

            #WS 2020-12-28 - samochod
            elif pole in ['samochod']:
            # elif pole in ['samochod2']:
                if wart == '':
                    stat = 'BR SAMOCHOD'
                    dane.append(stat)
                    # upd+=pole+"=NULL,"
                else:
                    upd+=pole+"='"+str(wart)+"',"

            #WS 2020-12-28
            elif pole in ['kierowca']:
            # elif pole in ['kierowca2']:
                if wart == '':
                    stat = 'BR KIER'
                    dane.append(stat)
                    # upd+=pole+"=NULL,"
                else:
                    upd+=pole+"='"+str(wart)+"',"
                    sql ="SELECT opis FROM rs_kierowcy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';" 
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania opisu kierowcy : '+stat
                        dane.append(stat)
                    else:
                        if len(d) == 0:
                            stat = 'BL KIER'
                            dane.append(stat)
                            # stat = 'BL KIER2'

            #WS 2020-12-28
            elif pole in ['przewoznik_id']:
            # elif pole in ['kierowca2']:
                if wart == '':
                    stat = 'BR PRZEW'
                    dane.append(stat)
                    # upd+=pole+"=NULL,"
                else:
                    upd+=pole+"='"+str(wart)+"',"
                    sql ="SELECT kontrahent_id, aktywny FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kontrahent_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania przewonika : '+stat
                        dane.append(stat)
                    else:
                        if len(d) == 0:
                            stat = 'BL PRZEW'
                            dane.append(stat)
                        elif not d[0][1]:
                            stat = "NAKT PRZEW"
                            dane.append(stat)
                
            elif pole == 'kontrahent_id':
                
                #---------------------------------------------------------------------------
                #WAZNE: w przypadku zmian w sposobie pobierania cen nalezy dokonac zmian
                #       w fs_dowody_dostaw_pozycje, gdyz tam tez sa pobierane ceny
                #       Podobny komunikat, informujacy o koniecznosci dostosowania
                #       fs_dowody_dostaw_dane jest umieszczony w fs_dowody_dostaw_pozycje
                #       mariusz rajfura  2010/06/18  mantis:3590
                #---------------------------------------------------------------------------
                
                Kontrahent = wart.strip()  #AB 14.07.22r
                                
                upd += pole+"='"+str(wart.strip())+"',"

                #WS 2020-12-22
                sql ="SELECT kontrahent_id, COALESCE(platnik_id,kontrahent_id), aktywny FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                # sql ="SELECT kontrahent_id, platnik_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                sql+=" AND kontrahent_id='"+wart+"';" 
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania danych kontrahenta : '+stat
                elif len(d) == 0:
                    stat = "BL KONTR"
                    dane.append(stat)
                elif not d[0][2]:  #WS 2020-12-28
                    stat = "NAKT KONTR"
                    dane.append(stat)
                else:
                    #dodatkowo zapisujemy platnika dla kontrahenta
                    #potrzebne do kontroli cen w ramach dnia  mantis:3590 mariusz rajfura
                    Platnik = rsglobal.Dekoduj(d[0][1]).strip()
                    #WS 2020-12-22
                    # if Platnik in ('None',''):
                    #     Platnik = 'NULL'
                    # else:
                    #     Platnik = "'"+Platnik+"'"
                    upd += "platnik_id='"+Platnik+"',"
                    
                    
                    sql ="SELECT nr_poz, artykul_id FROM rs_dowody_dostaw_pozycje"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND oddzial_id='"+Oddzial+"' AND trasa = '"+Trasa+"'"
                    sql+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"'"
                    sql+=" AND numer="+str(Nr)+" FOR UPDATE NOWAIT;"
                    
                    stat, dPoz, dump, dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania listy pozycji z dowodu: '+stat
                        dane.append(stat)
                        break
                    if len(dPoz) == 0:
                        #dowod bez pozycji, nie ma co aktualizowac
                        break
                    
                    for i in xrange(len(dPoz)):
                        NrPoz = dPoz[i][0]
                        Artykul = rsglobal.Dekoduj(dPoz[i][1]).strip()  #AB 14.07.22r
                        
                        #pobranie ceny z dowodw
                        sql ="SELECT ddp.cena_netto1 FROM rs_dowody_dostaw_pozycje ddp"
                        sql+=" INNER JOIN rs_dowody_dostaw dd "
                        sql+=" USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
                        sql+=" WHERE ddp.firma_id='"+self.firma_id+"'"
                        sql+=" AND dd.kontrahent_id='"+Kontrahent+"'"
                        sql+=" AND ddp.data='"+Data+"' AND ddp.artykul_id='"+Artykul+"' AND dd.oddzial_id='"+Oddzial+"';"
                        stat,dCenaDDOst,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd pobrania ceny z dowodw dostaw: '+stat
                            dane.append(stat)
                            break
                        
                        sql= "SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"',"
                        sql+="'"+Kontrahent+"','PLN','"+Data+"','"+Artykul+"','',-1, '"+Oddzial+"');"  #AB 16.06.21r
                        stat,dCeny,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd pobrania ceny z cennika dla kontrahenta: '
                            dane.append(stat)
                            
                        LCeny = rsglobal.rseval(rsglobal.Dekoduj(dCeny[0][0]))
                        if 0 in LCeny[:-1]:  #AB 14.07.22r
                            stat = "Brak cen dla artykuu {Artykul} i kontrahenta {Kontrahent} na dzie {Data}. Zmiana " \
                                   "odbiorcy niemoliwa.".format(**locals())
                        elif len(dCenaDDOst) > 0:
                            #jesli byly jakies dowody z podanego dnia, sprawdzamy
                            #sprzwdzamy, czy cena dla kontrahenta jest zgodna z
                            #cena z dowodow dla danego dnia
                            if dCenaDDOst[0][0] <> LCeny[0]:
                                stat = 'Cena artykuu '+str(Artykul).strip()+' dla kontrahenta '
                                stat+= str(Kontrahent).strip()+' jest rna od ceny z dowodw '
                                stat+= ' z dnia '+str(Data)+' dla podanego kontrahenta. '
                                stat+= 'Operacja zmiany odbiorcy niemoliwa.'
                                dane.append(stat)
                                break
                        
                        UPD_Poz+="UPDATE rs_dowody_dostaw_pozycje SET"
                        UPD_Poz+=" cena_netto1="+str(LCeny[0])+","
                        UPD_Poz+=" cena_netto2="+str(LCeny[1])+","
                        UPD_Poz+=" cena_upust1="+str(LCeny[4])+","
                        UPD_Poz+=" cena_upust2="+str(LCeny[5])+","
                        UPD_Poz+=" cena_brutto1="+str(LCeny[6])+","
                        UPD_Poz+=" cena_brutto2="+str(LCeny[7])+" "
                        UPD_Poz+=" WHERE firma_id='"+self.firma_id+"'"
                        UPD_Poz+=" AND oddzial_id='"+Oddzial+"' AND trasa = '"+Trasa+"'"
                        UPD_Poz+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"'"
                        UPD_Poz+=" AND numer="+str(Nr)+" AND nr_poz="+str(NrPoz)+"; "

                    if stat <> 'OK':
                        #opuszczamy petle sprawdzania aktualizowanych pol
                        break
                    
        
        if stat == 'OK':
            upd = upd[0:len(upd)-1]+where
            upd += UPD_Poz
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
            if stat <> 'OK':
                stat = 'Bd modyfikacji danych dowodu dostawy : '+stat
                dane.append(stat)
    else:
        stat='UPR UPD'

    #WS 2020-12-28
    if len(dane) > 0:
        stat = dane[0]

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem
#-------------------------------------------------------------------------------

if Fun in (5,3) and stat == 'OK':
    wyn2 = []

    sql = "SELECT * FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    sql+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+Nr+";"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych dowodu dostawy : ' + stat
    elif len(dane) == 1:
        #pobranie opisow slownikowych
        tr = rssql.RSTableRowset(dane,wyn1)

        #WS 2020-12-28 - kierowca2 -> kierowca
        # [0] kierowca
        kod = tr.GetVal(0,"kierowca").strip()
        if kod <> 'None':
            if (((self.oddzial_id,'011250') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+kod+"';" 
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu kierowcy: '+stat)
                else:
                    if len(d) == 1:
                        wyn2.append(str(d[0][0]))
                    else:
                        wyn2.append('Bdny numer kierowcy.')
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [1] kontrahent_id 
        if (((self.oddzial_id,'012000') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" 
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu kontrahenta: '+stat)
            else:
                if len(d) == 1:
                    wyn2.append(str(d[0][0]))
                else:
                    wyn2.append('Bdny numer kontrahenta.')
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')

        # [2] trasa_p
        kod = tr.GetVal(0,"trasa_p").strip()
        if kod <> 'None':
            if (((self.oddzial_id,'011040') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_trasy WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+kod+"';" 
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu trasy: '+stat)
                else:
                    if len(d) == 1:
                        wyn2.append(str(d[0][0]))
                    else:
                        wyn2.append('Bdny numer trasy.')
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [3] tryb_dostawy_p
        kod = tr.GetVal(0,"tryb_dostawy_p").strip()
        if kod <> 'None':
            if (((self.oddzial_id,'011260') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+kod+"';" 
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu trybu dostawy: '+stat)
                else:
                    if len(d) == 1:
                        wyn2.append(str(d[0][0]))
                    else:
                        wyn2.append('Bdny numer trybu dostawy.')
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        #WS 2020-12-28
        # [4] samochod
        kod = tr.GetVal(0,"samochod").strip()
        if kod <> 'None':
            if (((self.oddzial_id,'211480') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_samochody WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+kod+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu samochodu: '+stat)
                else:
                    if len(d) == 1:
                        wyn2.append(str(d[0][0]))
                    else:
                        wyn2.append('')
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        #WS 2020-12-28
        # [5] przewoznik_id
        if (((self.oddzial_id,'012000') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+tr.GetVal(0,"przewoznik_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu kontrahenta: '+stat)
            else:
                if len(d) == 1:
                    wyn2.append(str(d[0][0]))
                else:
                    wyn2.append('Bdny numer kontrahenta.')
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')
