# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_eksport.py
# Purpose:     funkcje eksportu dowodow dostaw dla roznych systemow
# Author:      Jan Raburski
# Created:     2013/11/20
# RCS-ID:      $Id: fs_dowody_dostaw_eksport.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# funkcja eksportu jest uruchamiana w harmonogramie i rcznie w dowodach dostaw. W przypadku zmian
# oba te mechanizmy musz by sprawdzone i zaktualizowane
# 2016-11-28 Piotr Witkowski   (10140) Zamienniki w eksporcie dowodw dostaw do PC-marketu
# 2023-10-21 Jan Raburski      (13588) Automatyczne zamykanie d.m. utworzonych z d.d.

import rsglobal

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Oddzial':[2,9], 'Data':[2,9], 'Trasa':[2,9],
           'Tryb':[2,9], 'Numer':[2,9] }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dowody_dostaw_eksport z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [2,9]:
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Trasa = rsglobal.Dekoduj(klucze['Trasa'])
        Tryb = rsglobal.Dekoduj(klucze['Tryb'])
        Numer = klucze['Numer']

if stat =='OK' and Funkcja ==1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  DELETE
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja ==1 and len(Delete[0])>0:
    DELETE=''
    for i in xrange(len(Delete[0])):
        DELETE+="DELETE FROM rs_dowody_dostaw_zamienniki "
        DELETE+="WHERE firma_id='"+self.firma_id+"' "
        for j in xrange(len(Delete[0][i])):
            pole=Delete[1][j]
            wart=Delete[0][i][j]
            if pole in ['artykul_id']:
                DELETE+=" AND "+pole+"='"+wart+"'"
        DELETE+=";"

    if DELETE<>'':
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1)
        if stat<>'OK':
            stat='BL SQL DEL'
            dane.append(stat)


#-------------------------------------------------------------------------------
#-------     Sprawdzanie danych do Update
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja ==1 and len(Update[0])>0:
    for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
        for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
            if stat == 'OK':
                pole=Update[0][i][j]
                wart=Update[1][i][j]

                # zapisujemy z ktrego wiersza pobierzemy klucz - numer pozycji
                if pole=='artykul_id':
                    if wart.strip()=='':
                        dane.append('ART BR$'+str(Update[-1][i]))
                        wyn2.append([Update[-1][i],1])
                    else:
                        Sql ="SELECT artykul_id FROM rs_artykuly"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"' AND aktywny;"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='ART BL SQL'
                            dane.append(stat)
                        if stat == 'OK':
                            if len(d)==0:
                                dane.append('ART BL$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])

                if pole=='artykul_zamiennik':
                    if wart.strip()=='':
                        dane.append('ART ZAM BR$'+str(Update[-1][i]))
                        wyn2.append([Update[-1][i],1])
                    else:
                        Sql ="SELECT artykul_id FROM rs_artykuly"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"' AND aktywny;"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='ART ZAM BL SQL'
                            dane.append(stat)
                        if stat == 'OK':
                            if len(d)==0:
                                dane.append('ART ZAM BR$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])

    if len(dane)>0 and stat == 'OK':
        stat=dane[-1]


#-------------------------------------------------------------------------------
#---------- UPDATE
#-------------------------------------------------------------------------------

    if stat == 'OK':
        if len(Update[0])>0:
            sql=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                if stat == 'OK':
                    RobicTestCen=False
                    UPDATE="UPDATE rs_dowody_dostaw_zamienniki "
                    SET='SET '

                    BylDost = False
                    BylZwr = False

                    for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]

                        if pole in ['artykul_id',]:
                            SET+=pole+"='"+wart+"',"

                        if pole in ['artykul_zamiennik',]:
                            if wart<>'':
                                SET+=pole+"='"+wart+"',"
                            else:
                                SET+=pole+"=NULL,"

                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'"
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=Update[2][i][j]
                        if pole in ['artykul_id']:
                            WHERE+=" AND "+pole+"='"+str(wart)+"' "

                    sql+=UPDATE+SET+WHERE+";"

            if stat == 'OK' and sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='UPD SQL BL'
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja ==1 and len(Insert[0])>0:
    if len(Insert[0])>0:
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]

                if pole=='artykul_id':
                    if wart.strip()=='':
                        dane.append('ART BR$'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],1])
                    if wart.strip()<>'':
                        Sql ="SELECT artykul_id FROM rs_artykuly"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"' AND aktywny;"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='ART BL SQL'
                            dane.append(stat)
                        if stat=='OK':
                            if len(d)==0:
                                dane.append('ART BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],1])

                if pole=='artykul_zamiennik':
                    if wart.strip()<>'':
                        Sql ="SELECT artykul_id FROM rs_artykuly"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"' AND aktywny;"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='ART ZAM BL SQL'
                            dane.append(stat)
                        if stat=='OK':
                            if len(d)==0:
                                dane.append('ART ZAM BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],1])

    if len(dane)>0:
        stat=dane[-1]


#------------------------------------------------------------------------------------------------------------
#---------------   INSERT
#-------------------------------------------------------------------------------------------------------------

    if stat=='OK':
        sql=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_dowody_dostaw_zamienniki "
            KOLUMNY="(firma_id"
            VALUES=" VALUES ('"+self.firma_id+"'"

            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole=='artykul_id':
                    KOLUMNY+=","+pole
                    VALUES+=",'"+str(wart)+"'"


                if pole in ['artykul_zamiennik',]:
                    if wart=='':
                        KOLUMNY+=","+pole
                        VALUES+=",NULL"
                    else:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"

            KOLUMNY+=")"
            VALUES+=")"
            sql+=INSERT+KOLUMNY+VALUES+";"

        if sql<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='INS SQL BL'
                dane.append(stat)


# -------------------------------------------------------------------------------
# ---   Sprawdzenie poprawnoci artykuw
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    sql = "SELECT artykul_id, artykul_zamiennik FROM rs_dowody_dostaw_zamienniki "
    sql += "WHERE firma_id='" + str(self.firma_id) + "' ;"
    stat, spr, wyn1, dump = self.PolSQL.Execute(sql, 3)

    if stat != 'OK':
        stat = u'Bdy pobrania listy zamiennikw: ' + stat
    elif stat=='OK' and len(spr)>0:
        info = u'Artyku jest taki sam jak zamiennik:'
        for x in spr:
            if x[0] == x[1]:
                info += u'\n' + str(x[0].strip())
                stat = 'Bl'

        if x[0] == x[1]:
            info += u'\n' + str(x[0].strip())
            stat = 'Bl'
        if stat != 'OK':
            stat = str(info)


#-------------------------------------------------------------------------------
# Eksport do PC Market (1)
#-------------------------------------------------------------------------------

if Funkcja == 2 and stat == 'OK':
    dane=[]
    nrdowodu = ''
    folder = ''
    sql = "SELECT kontrahent_id, platnik_id FROM rs_dowody_dostaw"
    sql += " WHERE firma_id='" + self.firma_id + "' AND oddzial_id='" + Oddzial + "'"
    sql += " AND data='" + Data + "' AND trasa='" + Trasa + "' AND tryb_dostawy='" + Tryb + "'"
    sql += " AND numer=" + str(Numer) + "; "
    
    stat, kontrahent, dump, dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych z dowodu dostawy: ' + stat
    elif len(kontrahent) == 0:
        stat = 'Brak dowodu o podanym kluczu'

    if stat == 'OK':
        # pobranie folderu z kontrahenta
        sql ="SELECT COALESCE(folder_dowody_dostaw,''), nazwa FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent[0][0]+"'"
        stat,danef,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z kontrahenta: ' + stat
        elif len(danef) == 0:
            stat = 'Brak kontrahenta o podanym kluczu'
        else:
            nazwakontrahenta = danef[0][1].strip()
            folder = danef[0][0].strip()
            if folder == '':
                # pobranie folderu z platnika
                sql ="SELECT COALESCE(folder_dowody_dostaw,'') FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent[0][1]+"'"
                stat,danef,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania danych z patnika: ' + stat
                elif len(danef) == 0:
                    stat = 'Brak patnika o podanym kluczu'
                else:
                    folder = danef[0][0].strip()
            if folder != '':
                nrdowodu = Data[2:4] + Data[5:7] + Data[8:10] + Oddzial[-1:] + Trasa[-2:] + Tryb[-1:] + str(int(Numer))
                dane.append(folder)
                dane.append(nrdowodu+'.txt')
                dane.append(nrdowodu+'z.txt')
                
    if stat == 'OK' and nrdowodu != '':
        # pobranie nipu oddzialu
        sql = "SELECT nip FROM rs_oddzialy"
        sql += " WHERE firma_id='" + self.firma_id + "' AND oddzial_id='" + Oddzial + "';"
        stat, daneo, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z oddziaw: '+stat 
        elif len(daneo) == 0:
            stat = 'Brak oddziau o podanym kluczu'
        nip=daneo[0][0].strip()
    
    if stat == 'OK' and nrdowodu != '':
        # pobranie wierszy dostarczonych i wypelnienie pliku
        wyn1 = []
        wyn1.append('TypPolskichLiter:LA\n')
        wyn1.append('TypDok:MP\n')
        wyn1.append('NrDok:' + nrdowodu+'\n')
        wyn1.append('Data:' + Data[-2:] + '.' + Data[5:7] + '.' + Data[0:4]+'\n')
        wyn1.append('NIPWystawcy:' + Oddzial + '\n')
        wyn1.append('Magazyn:' + kontrahent[0][0] + '\n')
        wyn1.append('NrWystawcyWSieciSklepow:' + nazwakontrahenta + '\n')
                    
        sql = "SELECT a.nazwa, p.artykul_id, p.stawka_vat, a.jm1, "   # 0 - 3
        sql += " (SELECT opis FROM rs_kateg_artykulow WHERE firma_id=p.firma_id AND kod=a.kateg_artykulu) as opis, "  # 4
        sql += " a.sww_pkwiu, p.ilosc_dost1, p.cena_upust1, "  # 5 - 7
        sql += " COALESCE(z.artykul_zamiennik,'') AS artykul_zamiennik, "  # 8
        sql += " (SELECT nazwa FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik) as zamiennik_nazwa, "
        sql += " (SELECT stawka_vat FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik) as zamiennik_vat, "
        sql += " (SELECT opis FROM rs_kateg_artykulow WHERE firma_id=p.firma_id AND kod=(SELECT kateg_artykulu FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik)) as zamiennik_opis, "
        sql += " (SELECT sww_pkwiu FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik) as zamiennik_sww, "
        sql += " a.przelicznik "  # 13
        sql += "  FROM rs_dowody_dostaw_pozycje as p"
        sql += " INNER JOIN rs_artykuly as a USING (firma_id, artykul_id)"
        sql += " LEFT OUTER JOIN rs_dowody_dostaw_zamienniki as z USING (firma_id, artykul_id)"
        sql += " WHERE p.firma_id='" + self.firma_id + "' AND p.oddzial_id='" + Oddzial + "'"
        sql += " AND p.data='" + Data + "' AND p.trasa='" + Trasa + "' AND p.tryb_dostawy='" + Tryb + "'"
        sql += " AND p.numer=" + str(Numer) + " AND ilosc_dost1!=0; "
        
        stat, pozycje, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z dowodu dostawy: ' + stat
        elif len(pozycje) == 0:
            wyn1 = []
        else:
            for p in pozycje:
                if p[8] != '':
                    # podstawienie zamiennika
                    w ='Linia:Nazwa{' + p[9].strip() + '}Kod{' + p[8].strip() + '}Vat{' + p[10].strip() + '}'
                    w += 'Jm{' + p[3].strip() + '}Asortyment{' + p[11].strip() + '}Sww{' + p[12].strip() + '}'
                    w += 'PKWiU{' + p[12].strip() + '}Ilosc{' + str(p[6]) + '}Cena{n' + str(p[7]) + '}\n'
                else:
                    w = 'Linia:Nazwa{' + p[0].strip() + '}Kod{' + p[1].strip() + '}Vat{' + p[2].strip() + '}'
                    w += 'Jm{' + p[3].strip() + '}Asortyment{' + p[4].strip() + '}Sww{' + p[5].strip() + '}'
                    w += 'PKWiU{' + p[5].strip() + '}Ilosc{' + str(p[6]) + '}Cena{n' + str(p[7]) + '}\n'
                wyn1.append(w)
                    

    if stat == 'OK' and nrdowodu != '':
        # pobranie wierszy zwroconych i wypelnienie pliku
        wyn2 = []
        wyn2.append('TypPolskichLiter:LA\n')
        wyn2.append('TypDok:ZD\n')
        wyn2.append('NrDok:' + nrdowodu + '\n')
        wyn2.append('Data:' + Data[-2:] + '.' + Data[5:7] + '.'+Data[0:4] + '\n')
        wyn2.append('NIPWystawcy:' + Oddzial + '\n')
        wyn2.append('Magazyn:' + kontrahent[0][0] + '\n')
        wyn2.append('NrWystawcyWSieciSklepow:' + nazwakontrahenta + '\n')
                    
        sql = "SELECT a.nazwa, p.artykul_id, p.stawka_vat, a.jm1, "  # 0 - 3
        sql += " (SELECT opis FROM rs_kateg_artykulow WHERE firma_id=p.firma_id AND kod=a.kateg_artykulu) as opis, "  # 4
        sql += " a.sww_pkwiu, p.ilosc_zwr1, p.cena_upust1, "  # 5 - 7
        sql += " COALESCE(z.artykul_zamiennik,'') AS artykul_zamiennik, "  # 8
        sql += " (SELECT nazwa FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik) as zamiennik_nazwa, "
        sql += " (SELECT stawka_vat FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik) as zamiennik_vat, "
        sql += " (SELECT opis FROM rs_kateg_artykulow WHERE firma_id=p.firma_id AND kod=(SELECT kateg_artykulu FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik)) as zamiennik_opis, "
        sql += " (SELECT sww_pkwiu FROM rs_artykuly WHERE firma_id=p.firma_id AND artykul_id=z.artykul_zamiennik) as zamiennik_sww, "
        sql += " a.przelicznik "  # 13
        sql += "  FROM rs_dowody_dostaw_pozycje as p"
        sql += " INNER JOIN rs_artykuly as a USING (firma_id, artykul_id)"
        sql += " LEFT OUTER JOIN rs_dowody_dostaw_zamienniki as z USING (firma_id, artykul_id)"
        sql += " WHERE p.firma_id='" + self.firma_id + "' AND p.oddzial_id='" + Oddzial + "'"
        sql += " AND p.data='" + Data + "' AND p.trasa='" + Trasa + "' AND p.tryb_dostawy='" + Tryb + "'"
        sql += " AND p.numer=" + str(Numer) + " AND ilosc_zwr1!=0; "
        
        stat, pozycjezd, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z dowodu dostawy: '+stat
        elif len(pozycjezd) == 0:
            wyn2 = []
        else:
            for p in pozycjezd:
                if p[8] != '':
                    # podstawienie zamiennika
                    w = 'Linia:Nazwa{' + p[9].strip() + '}Kod{'+p[8].strip() + '}Vat{' + p[10].strip() + '}'
                    w += 'Jm{' + p[3].strip() + '}Asortyment{' + p[11].strip() + '}Sww{' + p[12].strip() + '}'
                    w += 'PKWiU{' + p[12].strip() + '}Ilosc{' + str(p[6]) + '}Cena{n' + str(p[7]) + '}\n'
                else:
                    w = 'Linia:Nazwa{' + p[0].strip() + '}Kod{' + p[1].strip() + '}Vat{' + p[2].strip() + '}'
                    w += 'Jm{' + p[3].strip() + '}Asortyment{' + p[4].strip() + '}Sww{' + p[5].strip() + '}'
                    w += 'PKWiU{' + p[5].strip() + '}Ilosc{' + str(p[6]) + '}Cena{n' + str(p[7]) + '}\n'
                wyn2.append(w)

    if stat == 'OK' and nrdowodu != '' and len(kontrahent[0][0].strip()) == 3:
        # tworzenie dokumentow magazynowych dla sklepow firmowych
        #Mag = 'H' + kontrahent[0][0].strip()
        #JR 2023-01-10 (13303) - zmiana z 'H' na 'D'
        Mag = 'D' + kontrahent[0][0].strip()
        DokPrz = 'DD'
        DokRoz = 'ZD'
        # sprawdzenie czy magazyn 'H'+kontrahent jest detaliczny
        sql = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='" + self.firma_id + "'"
        sql += " AND magazyn_id='" + Mag + "';"
        stat, detal, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z definicji magazynw: '+stat
        elif len(detal) == 0:
            stat = 'Brak definicji magazynu: ' + Mag
        elif detal[0][0]:      # magazyn istnieje i jest detaliczny

            # ustawienie kontrahenta
            if Oddzial == '02':
                Kontr = 'ZP2'
            elif Oddzial == '03':
                Kontr = 'ZP3'
            elif Oddzial == '05':
                Kontr = 'ZC'
            elif Oddzial == '07':
                Kontr = 'ZP7'
            else:
                stat = "Nieokrelony oddzia - kontrahent:" + Oddzial

            # podzielenie w petli na dostarczone i zwrocone z uzglednieniem d.d. korygujacych
            PozPrz = []  # artykul (zamiennik), ilosc1, ilosc2, cena1, cena2
            PozRoz = []  # artykul (zamiennik), ilosc1, ilosc2
            for p in pozycje:    # 1-artykul, 6-ilosc_dost1, 7-cena_upust1, 8-zamiennik, 13-przelicznik
                if p[8] != '':
                    Art = p[8]
                else:
                    Art = p[1]
                if p[6] > 0:  # dostarczone
                    PozPrz.append([Art, p[6], rsglobal.RSRound(p[6] * p[13],3), p[7], rsglobal.RSRound(p[7] / p[13], 2)])
                elif p[6] < 0:  # korekta dostawy
                    PozRoz.append([Art, - p[6], rsglobal.RSRound(- p[6] * p[13],3)])
            for p in pozycjezd:    # 1-artykul, 6-ilosc_zwr1, 7-cena_upust1, 8-zamiennik, 13-przelicznik
                if p[8] != '':
                    Art = p[8]
                else:
                    Art = p[1]
                if p[6] > 0:  # zwrocone
                    PozRoz.append([Art, p[6], rsglobal.RSRound(p[6] * p[13],3)])
                elif p[6] < 0:  # korekta zwrotu
                    PozPrz.append([Art, - p[6], rsglobal.RSRound(- p[6] * p[13],3), p[7], rsglobal.RSRound(p[7] / p[13], 2)])
            # sprawdzanie poprawnosci zakresu dat
            if stat == 'OK':
                SQL = "SELECT rsf_sprawdz_date_z_zakresem('" + self.firma_id + Mag + "','" + Data + "',2);"
                stat, TestZakr, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat == 'OK':
                if len(TestZakr) == 0:
                    stat = 'Bd sprawdzania zakresu dat'
                elif not TestZakr[0][0]:
                    stat = "Data dokumentu spoza zakresu"

            # zapis czesci przychodowej
            #rsglobal.ZapiszDoLogow('PozPrz:'+str(PozPrz)+'|PozRoz:'+str(PozRoz))
            if stat == 'OK' and len(PozPrz) > 0:
                # wybranie numeru dokumentu  rsf_sprawdz_czy_mozna_dodac_dokument(Firma,Klucz,Typ)
                stat, DNr, dump, dump = self.PolSQL.Execute(
                    "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('" + self.firma_id + "','[\\\'" + Mag + "\\\',\\\'" + DokPrz + "\\\',\\\'" + Data + "\\\']','M');",3)
                if stat != 'OK':
                    stat = 'Nie mona doda dokumentu przychodowego: ' + stat
                else:
                    stat, DNr, dump, dump = self.PolSQL.Execute(
                        "SELECT rsf_podaj_nowy_numer_dokumentu('" + self.firma_id + "','[\\\'" + Mag + "\\\',\\\'" + DokPrz + "\\\',\\\'" + Data + "\\\']','M');",3)
                    if stat != 'OK':
                        stat = 'Bdy pobierania numeru dokumentu przychodowego: ' + stat
                    elif DNr[0][0] in (None, 'None', ''):
                        stat = 'Bdy pobierania numeru dokumentu przychodowego'
                    else:
                        NrDok = str(DNr[0][0])

                        INSERT = "INSERT INTO rs_dokumenty_magazynowe"
                        INSERT += " (firma_id,magazyn_id,dokument_id,data,numer,stan,kontrahent_id,magazyn_dokad)"
                        INSERT += "  VALUES('" + self.firma_id + "','" + Mag + "','" + DokPrz + "','" + Data + "'," + NrDok
                        INSERT += ",'W','" + Kontr + "','" + Mag + "');"
                        nrpoz = 0
                        for w in PozPrz:
                            nrpoz += 1
                            INSERT += "INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,"
                            INSERT += "numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,cena1,cena2,cena_wal1,cena_wal2)"
                            INSERT += " VALUES ('" + self.firma_id + "','" + Mag + "','" + DokPrz + "','" + Data + "',"
                            INSERT += NrDok + "," + str(nrpoz) + ",0,'" + rsglobal.Dekoduj(w[0]) + "',"
                            INSERT += " " + str(w[1]) + "," + str(w[2]) + "," + str(w[3]) + "," + str(w[4]) + "," + str(w[3]) + "," + str(w[4]) + ");"

                        stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1)
                        if stat != 'OK':
                            stat = 'Bd wstawiania dokumentu przychodowego ' + stat
                        else:
                            self.PolSQL.Commit()  # AB 2023-10-30
                    if stat == 'OK':  #JR 2023-10-21 (13588)
                        Klucze = {}
                        Klucze['Mag'] = Mag
                        Klucze['Typ'] = DokPrz
                        Klucze['Data'] = Data
                        Klucze['Numer'] = NrDok
                        Klucze['Funkcja'] = 18
                        # zamkniecie moze sie nie udac, stad osobny statz
                        # zamknicie dokumentu przychodowego z W na G
                        statz, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                        if statz == 'OK':
                            # zamknicie dokumentu przychodowego z G na Z
                            Klucze['Funkcja'] = 19
                            statz, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                        stat = 'OK'

            # zapis czasci rozchodowej
            if stat == 'OK' and len(PozRoz) > 0:
                # wybranie numeru dokumentu  rsf_sprawdz_czy_mozna_dodac_dokument(Firma,Klucz,Typ)
                stat, DNr, dump, dump = self.PolSQL.Execute(
                    "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('" + self.firma_id + "','[\\\'" + Mag + "\\\',\\\'" + DokRoz + "\\\',\\\'" + Data + "\\\']','M');",3)
                if stat != 'OK':
                    stat = 'Nie mona doda dokumentu rozchodowego: ' + stat
                else:
                    stat, DNr, dump, dump = self.PolSQL.Execute(
                        "SELECT rsf_podaj_nowy_numer_dokumentu('" + self.firma_id + "','[\\\'" + Mag + "\\\',\\\'" + DokRoz + "\\\',\\\'" + Data + "\\\']','M');",3)
                    if stat != 'OK':
                        stat = 'Bdy pobierania numeru dokumentu rozchodowego: ' + stat
                    elif DNr[0][0] in (None, 'None', ''):
                        stat = 'Bdy pobierania numeru dokumentu rozchodowego'
                    else:
                        NrDok = str(DNr[0][0])
                        INSERT = "INSERT INTO rs_dokumenty_magazynowe"
                        INSERT += " (firma_id,magazyn_id,dokument_id,data,numer,stan,kontrahent_id,magazyn_skad)"
                        INSERT += "  VALUES('" + self.firma_id + "','" + Mag + "','" + DokRoz + "','" + Data + "'," + NrDok
                        INSERT += ",'W','" + Kontr + "','" + Mag + "');"
                        nrpoz = 0
                        for w in PozRoz:
                            nrpoz += 1
                            INSERT += "INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,"
                            INSERT += "numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2)"
                            INSERT += " VALUES ('" + self.firma_id + "','" + Mag + "','" + DokRoz + "','" + Data + "',"
                            INSERT += NrDok + "," + str(nrpoz) + ",0,'" + rsglobal.Dekoduj(w[0]) + "',"
                            INSERT += " " + str(w[1]) + "," + str(w[2]) + ");"

                        stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1)
                        if stat != 'OK':
                            stat = 'Bd wstawiania dokumentu rozchodowego ' + stat
                        else:
                            self.PolSQL.Commit()  # AB 2023-10-30
                        if stat == 'OK':  #JR 2023-10-21 (13588)
                            Klucze = {}
                            Klucze['Mag'] = Mag
                            Klucze['Typ'] = DokRoz
                            Klucze['Data'] = Data
                            Klucze['Numer'] = NrDok
                            Klucze['Funkcja'] = 18
                            # zamkniecie moze sie nie udac, stad osobny statz
                            # zamknicie dokumentu rozchodowego z W na Z
                            statz, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                            stat = 'OK'


#-------------------------------------------------------------------------------
#-- 9 - zapis daty eksportu do dowodu dostawy
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == 'OK':
    SQL ="UPDATE rs_dowody_dostaw SET data_eksportu = NOW()::DATE "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    SQL+=" AND data='"+Data+"' AND trasa='"+Trasa+"' AND tryb_dostawy='"+Tryb+"'"
    SQL+=" AND numer="+str(Numer)+";"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat != 'OK':
        stat = 'Bd zmiany daty eksportu dowodu dostawy '+Oddzial+'/'+Data+'/'+Trasa+'/'+Tryb+'/'+str(Numer)+': '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,5]:
    sql ="SELECT z.artykul_id, a.nazwa, z.artykul_zamiennik, b.nazwa  FROM  rs_dowody_dostaw_zamienniki z "
    sql+="LEFT OUTER JOIN rs_artykuly a ON a.firma_id = z.firma_id AND a.artykul_id = z.artykul_id "
    sql+="LEFT OUTER JOIN rs_artykuly b ON b.firma_id = z.firma_id AND b.artykul_id = z.artykul_zamiennik "
    sql+="WHERE z.firma_id='"+str(self.firma_id)+"' ORDER BY 1;"
    stat,dane,wyn1,dump=self.PolSQL.Execute(sql,3)

    if stat<>'OK':
        stat="Bd przy pobieraniu danych  : "+stat
        dane.append(stat)
