# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_opakowania_zwrotne.py
# Purpose:     Wprowadzanie opakowa zwrotnych dla dowodw dostaw
# Author:      Wojciech Skowron
# Created:     2020/04/25
# RCS-ID:      $Id: fs_dowody_dostaw_opakowania_zwrotne.py $
# Copyright:   (c) 2020 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Trasa': [1, 5], 'Data': [1, 5], 'TrybDostawy': [1, 5], 'Numer': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_dowody_dostaw_opakowania_zwrotne z numerem '+str(Funkcja)+' bez parametrw: '+Lista

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprDod    = (((self.oddzial_id,'028023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprMod    = (((self.oddzial_id,'028022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDod
UprPrzegl = (((self.oddzial_id,'028021') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod or UprDod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK':
    Trasa = rsglobal.Dekoduj(klucze['Trasa'])
    Data = klucze['Data']
    TrybDostawy = rsglobal.Dekoduj(klucze['TrybDostawy'])
    Numer = klucze['Numer']

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']

#-------------------------------------------------------------------------------
#---------------------------  SPRAWDZENIE DANYCH  ------------------------------
#-------------------------------------------------------------------------------


def SprawdzPole(pole, wart, nrWiersza, dane, wyn2):
    if pole == 'zostawiono':
        if wart < 0:
            dane.append('BL_ZOSTAWIONO_MIN')
            wyn2.append((nrWiersza, 2))
        elif wart > 999999:
            dane.append('BL_ZOSTAWIONO_MAX')
            wyn2.append((nrWiersza, 2))

    if pole == 'odebrano':
        if wart < 0:
            dane.append('BL_ODEBRANO_MIN')
            wyn2.append((nrWiersza, 3))
        elif wart > 999999:
            dane.append('BL_ODEBRANO_MAX')
            wyn2.append((nrWiersza, 3))


#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat = 'BR_UPR_MOD'
            dane.append(stat)
        else:
            for pola, wartosci, nrWiersza in zip(Update[0], Update[1], Update[-1]):
                for pole, wart in zip(pola, wartosci):
                    SprawdzPole(pole, wart, nrWiersza, dane, wyn2)

    if len(Insert[0]) > 0:
        if not UprMod:
            stat = 'BR_UPR_MOD'
            dane.append(stat)
        else:
            pola = Insert[1]

            for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
                for pole, wart in zip(pola, wartosci):
                    SprawdzPole(pole, wart, nrWiersza, dane, wyn2)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    if len(dane) > 0:
        dane = list(set(dane))  # usunicie zduplikowanych komunikatw bdw

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Update[0]) > 0:
    UPD = ''

    for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
        UPD += "UPDATE rs_dowody_dostaw_opakowania_zwrotne SET "
        for pole, wart in zip(pola, wartosci):
            if pole in ['zostawiono', 'odebrano']:
                UPD += pole+"="+str(wart)+","

        UPD = UPD.strip(",")
        UPD += " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        UPD += " AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+TrybDostawy+"' AND numer="+Numer

        for pole, wart in zip(Update[3], klucz):  # petla po kluczu
            UPD += " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

        UPD += ";"

    if UPD != '':
        rsglobal.ZapiszDoLogow(UPD)
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(UPD), 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Insert[0]) > 0:
    INS = ''
    pola = Insert[1]

    for wartosci in Insert[0]:
        INSERT  = "INSERT INTO rs_dowody_dostaw_opakowania_zwrotne "
        KOLUMNY = "(firma_id,oddzial_id,trasa,data,tryb_dostawy,numer"
        VALUES  = " VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+Data+"','"+TrybDostawy+"',"+Numer
        for pole, wart in zip(pola, wartosci):
            if pole in ['zostawiono', 'odebrano']:
                KOLUMNY += ","+pole
                VALUES += ","+str(wart)
            elif pole in ['opakowanie']:
                KOLUMNY += ","+pole
                VALUES += ",'"+str(wart)+"'"

        KOLUMNY += ")"
        VALUES += ");"
        INS += INSERT+KOLUMNY+VALUES

    if INS != '':
        rsglobal.ZapiszDoLogow(INS)
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(INS), 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy dodawaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrzegl:
        stat = 'BR_UPR_PRZ'
        dane.append(stat)

    SEL = """SELECT a.artykul_id as opakowanie, a.nazwa, COALESCE(o.zostawiono, 0), COALESCE(o.odebrano, 0)
             FROM rs_artykuly a
             LEFT OUTER JOIN rs_dowody_dostaw_opakowania_zwrotne o 
             ON o.firma_id = a.firma_id AND o.opakowanie = a.artykul_id AND o.oddzial_id='{oddzial_id}' 
             AND o.trasa='{trasa}' AND o.data='{data}' AND o.tryb_dostawy='{tryb_dostawy}' AND o.numer={numer} 
             WHERE a.firma_id='{firma_id}' AND a.rotacja = TRUE
             ORDER BY opakowanie;"""
    SEL = SEL.format(firma_id=self.firma_id,
                     oddzial_id=self.oddzial_id,
                     trasa=Trasa,
                     data=Data,
                     tryb_dostawy=TrybDostawy,
                     numer=Numer)
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych: "+stat
        dane = [stat]
    else:
        # Pobranie listy opakowa ju wprowadzonych dla danego dd
        # Dla wierszy z opakowaniem z tej listy przy zapisie bdzie wykonywany update, dla pozostaych insert
        SEL = """SELECT opakowanie
                 FROM rs_dowody_dostaw_opakowania_zwrotne o
                 WHERE firma_id='{firma_id}' AND oddzial_id='{oddzial_id}' 
                 AND trasa='{trasa}' AND data='{data}' AND tryb_dostawy='{tryb_dostawy}' AND numer={numer} 
                 ORDER BY opakowanie;"""
        SEL = SEL.format(firma_id=self.firma_id,
                         oddzial_id=self.oddzial_id,
                         trasa=Trasa,
                         data=Data,
                         tryb_dostawy=TrybDostawy,
                         numer=Numer)
        stat, dane1, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobierania danych: "+stat
            dane.append(stat)
        else:
            wyn1 = [d[0] for d in dane1]
