# -*- coding: iso8859_2 -*-
#-----------------------------' in k--------------------------------------------------
# Name:			fs_dowody_dostaw_pozycje.py
# Purpose:		obsuga edytowalnego grida z pozycjami dowodw dostaw
# Author:		Piotr Witkowski
# Created:		2007/04/20
# RCS-ID:		$Id: fs_dowody_dostaw_pozycje.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------
#2011-07-13 Mariusz Rajfura - info o poziomie zwrotow dla kontrahenta (4749)
#2011-10-28 Mariusz Rajfura - funkcja pobier.info o poziomie zwrotow dla kontrahenta
#                             przeniesiona do fs_zamowienia_odbiorcy_pom (5154)
#2012-02-24 Mariusz Rajfura - kontrola aktywnosci artykulu (5485)
#2012-03-12 Mariusz Rajfura - kolumny z loginami operatorow modyf.dost,zwrot (5530)
#                             wpisywanie id operatora modyfikujacego ilosci:dost,zwro
# 2012-09-20 Mariusz Rajfura     (6087) oddzial_id w kluczu
# 2013-02-04 Mariusz Rajfura     (6479) pobranie informacji o blokadzie dla kontrahenta
# 2013-08-05 Mariusz Rajfura     (7087) korekta: blokada jednoczesnego podania il.dost1 i zwroc1 na dokumencie
# 2015-04-08 Piotr Witkowski     (6715) Uporzdkowanie pozycji dowodw dostaw - wprowadzenie sownikw
# 2019-08-19 Wojciech Skowron   (11591) Zniesienie blokady modyfikacji pozycji dowodu dostawy jeli niezwrcony dla stanu 0
# 2020-12-31 Aleksander Bargie (12238) Uzgldnia oddzia przy pobieraniu cen do d.d.
# 2021-05-18 Jan Raburski       (12493) Dla uprawnien 802000 ewentualna modyfikacja TYLKO ZWOTOW + dodanie pozycji ze zwrotami
# 2022-12-14 Aleksander Bargie (13281) Bad przy wprowadzaniu zwrotw do d.d.
# 2023-03-13 Jan Raburski       (13381) Blokada wprowadzania zwrotow dla sklepow firmowych
# 2023-04-26 Aleksander Bargie (13410) Operator z upr. do wprowadzania tylko zwrotow nie moze dodac zwrotu w nowej pozycji
# 2023-08-28 Jan Raburski       (13525) Blokada zwrotow jesli w rs_artykuly jest 'nie_przyjmowac_zwrotow'
#                           przy okazji zablokowana mozliwosc korzystania z artykulow 'tylko_detal'

from funkcje import fs_zamowienia_odbiorcy_pom

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Trasa':[1,5,11,12,14,15,16],'Data':[1,5,11,12,14,15,16],'Tryb':[1,5,11,12,14,15,16],
           'Numer':[1,5,11,12,14,15,16],'Art':[1,5,11,13,14,15],'Naglowek':[1], 'Oddzial':[1,5,11,12,14,15,16,24]}  #AB 14.12.2022
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dowody_dostaw_pozycje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5,11,12,14,15,16]: 
            Trasa   = str(klucze['Trasa'])
            Data    = str(klucze['Data'])
            Tryb    = str(klucze['Tryb'])
            Numer   = str(klucze['Numer'])
            Oddzial = str(klucze['Oddzial'])
        if Funkcja in [1,5,11,13,14,15]:  #AB 14.12.2022
            Art    = str(klucze['Art'])
        if Funkcja in [1]: 
            Naglowek=klucze['Naglowek']
        if Funkcja in [24]:
            Oddzial = klucze['Oddzial']


dane = []
wyn1 = []
wyn2 = []
LArtPoziom=[]

#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprUpd = (self.oddzial_id,'028022') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns = (self.oddzial_id,'028023') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel = (self.oddzial_id,'028024') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprTylkoZwroty = (self.oddzial_id,'802000') in self.uprawnienia  #JR 2021-05-18 (12493)

#-------------------------------------------------------------------------------
# pobieranie cen na podstawie arykuu (11)
#-------------------------------------------------------------------------------

if (Funkcja in [11]): #pobieranie cen
    
    #---------------------------------------------------------------------------
    #WAZNE: w przypadku zmian w sposobie pobierania cen nalezy dokonac zmian
    #       w fs_dowody_dostaw_dane, gdyz tam tez sa pobierane ceny w przypadku
    #       zmiany odbiorcy.
    #       Podobny komunikat, informujacy o koniecznosci dostosowania
    #       fs_dowody_dostaw_pozycje jest umieszczony w fs_dowody_dostaw_dane
    #       mariusz rajfura  2010/06/18  mantis:3590
    #---------------------------------------------------------------------------
    
    if Art.strip=='':
        dane=[0,0,0,0,0,0,'','']
    else:
        # sprawdzenie istnienia i odpowiedniego artykulu
        Sql = "SELECT artykul_id FROM rs_artykuly"
        Sql += " WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + Art + "' AND aktywny AND NOT tylko_detal;"
        stat, d, dump, dump = self.PolSQL.Execute(Sql, 3)
        if stat != 'OK':
            stat = 'Bdy sprawdzania artykuu '+stat
            dane.append(stat)
        else:
            if len(d) == 0:
                stat = 'Brak artykuu, artyku nieaktywny lub tylko detaliczny. '
                dane.append(stat)

        if stat == 'OK':
            Select = "SELECT rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"'),nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
            stat,DOpis,dump,dump= self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat=u'Bd wykonania sprawdzenia vatu artykuu' + stat
                dane.append(stat)

            if stat=='OK':
                if len(DOpis)==0:
                    stat='ART BR'
                    dane.append(stat)
        
        if stat=='OK':    
            # pobranie kontrahenta
            SQL="SELECT kontrahent_id FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
            SQL+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"'"
            SQL+=" AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
            stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat=='OK':    
            Kontr=rsglobal.Dekoduj(DKontr[0][0])
            
            #pobranie ceny z dowodw
            SQL="SELECT dp.cena_upust1 FROM rs_dowody_dostaw_pozycje dp INNER JOIN rs_dowody_dostaw dd "
            SQL+=" USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
            SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dd.kontrahent_id='"+Kontr+"' AND oddzial_id='"+Oddzial+"'"
            SQL+=" AND dp.data='"+Data+"' AND dp.artykul_id='"+Art+"' AND (NOT dd.korekta OR dd.korekta IS NULL);"
            stat,DCenaDDost,dump,dump = self.PolSQL.Execute(SQL,3)
            
        if stat=='OK':
            CenaNDost=0
            if len(DCenaDDost)>0:
                CenaNDost=DCenaDDost[0][0]

            # pobranie ceny dla artykuu z cennika
            #AB 01.01.20r
            # Select = "SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"','"+Kontr+"','PLN','"+Data+"','"+Art+"','',-1);"
            Select = "SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"','"+Kontr+"','PLN','"+Data+"','"+Art+"','',-1,'"+Oddzial+"');"
            stat,DCeny,dump,dump = self.PolSQL.Execute(Select,3)
            if stat!= 'OK':
                stat='BL SQL CEN'

        
        if stat=='OK':
            #porwnanie cen
            if CenaNDost!=0:
                LCeny=rsglobal.rseval(rsglobal.Dekoduj(DCeny[0][0]))
                if LCeny[4] != CenaNDost:
                    stat='Pobrana z cennika cena artykuu jest inna ni cena tego artykuu w dowodach dostaw'
            
        if stat=='OK':
            Select="SELECT max(nr_poz)+1 FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
            stat,d,dump,dump=self.PolSQL.Execute(Select,3)
            if stat=='OK':
                dane=rsglobal.rseval(rsglobal.Dekoduj(DCeny[0][0]))+rsglobal.Dekoduj(DOpis[0])+d[0]
                    
                    
#-------------------------------------------------------------------------------
# pobieranie numeru pozycji (12)
#-------------------------------------------------------------------------------

if (Funkcja in [12]):
    Select="SELECT max(nr_poz)+1 FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
    stat,d,dump,dump=self.PolSQL.Execute(Select,3)
    if stat=='OK':
        dane=d[0][0]
    else:
        stat='BL SQL NR' + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# pobranie informcji o przeliczniku artykuu (13)  #AB 14.12.2022
# i nie przyjmowac zwrotow #JR 2023-08-28
# -------------------------------------------------------------------------------
if Funkcja == 13:
    sql="SELECT przelicznik, nie_przyjmowac_zwrotow FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND NOT tylko_detal;"
    stat,dane,dump,dump=self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat='BL SQL PRZEL'
        dane.append(stat)
    elif len(dane)==0:
        stat='BR ART'
        dane.append(stat)
# -------------------------------------------------------------------------------
# pobranie informcji o mozliwosci zwrotu (14)
# -------------------------------------------------------------------------------

if Funkcja == 14:
    # pobranie kontrahenta z dowodu
    sql = "SELECT kontrahent_id FROM rs_dowody_dostaw WHERE firma_id='" + self.firma_id + "' "
    sql += " AND oddzial_id='" + Oddzial + "' AND trasa='" + Trasa + "' AND data='" + Data + "'"
    sql += " AND tryb_dostawy='" + Tryb + "' AND numer=" + str(Numer) + ";"
    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Bd pobrania kontrahenta z dowodu dostawy: ' + stat
    elif len(d) == 0:
        stat = 'Brak dowodu dostawy o podanym kodzie'

    if stat == 'OK':
        # pobranie pola blokada_zwrotow z danych do fakturowania dla kontrahenta
        sql = "SELECT blokada_zwrotow FROM rs_kontrahenci_fakturowanie"
        sql += " WHERE firma_id='" + self.firma_id + "' AND kontrahent_id='" + str(d[0][0]) + "'"
        sql += " AND data_od <='" + Data + "' ORDER BY data_od DESC LIMIT 1;"
        stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych do fakturowania dla kontrahenta: ' + stat
        elif len(dane) == 0:
            # brak danych do fakturowania, tzn blokady nie ma
            dane = [[False]]

#-------------------------------------------------------------------------------
# pobranie informcji o tym, czy w oddziale mona edytowa neizwrcone DD (24)
#-------------------------------------------------------------------------------

if Funkcja == 24:

    sql = "SELECT blokowac_edycje_dd FROM rs_oddzialy WHERE firma_id='{}' AND oddzial_id='{}';".format(self.firma_id, Oddzial)
    stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Bd sprawdzania ustawie w oddziale: '+stat


#-------------------------------------------------------------------------------
# Pobranie informacji o poziomie zwrotow (15)
#-------------------------------------------------------------------------------

if Funkcja == 15 and stat=='OK':
    stat,dane = fs_zamowienia_odbiorcy_pom.PoziomZwrotowDlaOdbiorcyZDowoduDostawy(self, Oddzial, Trasa, Data, Tryb, Numer)


#-------------------------------------------------------------------------------
# Pobranie informacji o blokadzie kontrahenta (16)
#-------------------------------------------------------------------------------

if Funkcja == 16 and stat=='OK':
    sql="SELECT dd.kontrahent_id,k.zablokowany"
    sql+=" FROM rs_dowody_dostaw dd"
    sql+=" INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
    sql+=" WHERE dd.firma_id='"+self.firma_id+"' "
    sql+=" AND dd.oddzial_id='"+Oddzial+"' AND dd.trasa='"+Trasa+"' AND dd.data='"+Data+"'"
    sql+=" AND dd.tryb_dostawy='"+Tryb+"' AND dd.numer="+str(Numer)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania stanu blokady dla kontrahenta: '+stat

    
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# EDYCJA GRIDA
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
            
if (Funkcja in [1]):
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

    SPozGrOdb = {} # lista pozycji, ktre powinny by sprawdzone pod ktem danych z rs_grupy_odbiorcow_asortyment. Klucz to nr_poz, a wynik - (typ i wiersz)

    #WS 2019-08-19 - dodane "AND stan != '0'"
    sql = "SELECT blokowac_edycje_dd AND NOT zwrocony AND stan != '0' FROM rs_oddzialy JOIN rs_dowody_dostaw USING(firma_id,oddzial_id)" \
          " WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' " \
          " AND data='{}' AND tryb_dostawy='{}' AND numer={};".format(self.firma_id, Oddzial, Trasa, Data, Tryb, Numer)
    stat, niedane, dump, dump = self.PolSQL.Execute(sql, 3)
    rsglobal.ZapiszDoLogow('!!! '+str(sql) + stat, 5)
    if stat != 'OK':
        stat = 'Bd sprawdzania ustawie w oddziale: '+stat
    elif niedane[0][0]:
        stat = 'Modyfikacja niedozwolona, nie zwrcono dowodu dostawy.'
    rsglobal.ZapiszDoLogow('!!! '+str(sql) + stat, 5)
    rsglobal.ZapiszDoLogow('!!! '+str(Naglowek),1)
    if stat == 'OK' and len(Naglowek)<>0:
        OpakDost1=Naglowek[0]
        OpakDost2=Naglowek[1]
        OpakZwr1=Naglowek[2]
        OpakZwr2=Naglowek[3]
        Upd="UPDATE rs_dowody_dostaw SET opak_dostarczone1="+str(OpakDost1)+",opak_dostarczone2="+str(OpakDost2)+",opak_zwrocone1="+str(OpakZwr1)+",opak_zwrocone2="+str(OpakZwr2)+" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
        stat,dump,dump,dump=self.PolSQL.Execute(Upd,1)
        if stat<>'OK':
            stat='BL SQL UPD NAGL'
            dane.append(stat)

    if stat=='OK': 
        TablicaZwrotow=[]
        TablicaZwrotowBledy=[]
        SZwrotow={}


    if stat=='OK':    
        # pobranie kontrahenta i stanu i ewentualnie czy korekta
        SQL="SELECT kontrahent_id,stan,korekta,oddzial_id_p,trasa_p,data_p,tryb_dostawy_p,numer_p"
        SQL+=" FROM rs_dowody_dostaw"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        SQL+=" AND trasa='"+Trasa+"' AND data='"+Data+"'"
        SQL+=" AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+";"
        stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':    
        Kontr=rsglobal.Dekoduj(DKontr[0][0])
        Stan=rsglobal.Dekoduj(DKontr[0][1])
        Korekta=DKontr[0][2]
        SprawdzacCeny=[]

    if stat == 'OK':  #JR 2023-03-13 (13381) - sprawdzenie czy mozna edytowac zwroty
        MoznaEdytowacZwroty = True
        if not Korekta:
            SQL = "SELECT gop.operator_id, gop.oddzial_id FROM rs_grupa_operator_oddzial gop"
            SQL += " INNER JOIN rs_operatorzy ope USING (operator_id)"
            SQL += " WHERE gop.firma_id='" + self.firma_id + "' AND gop.oddzial_id='" + Oddzial + "'"
            SQL += " AND ope.kontrahent_id='" + Kontr + "'"
            SQL += " AND gop.grupa_id IN (SELECT grupa_id FROM rs_grupa_menu WHERE menu_id='802000' AND firma_id='" + self.firma_id + "')"
            stat, DMozna, dump, dump = self.PolSQL.Execute(SQL, 3)
            rsglobal.ZapiszDoLogow(SQL)
            if stat == 'OK':
                MoznaEdytowacZwroty = len(DMozna) == 0
                #rsglobal.ZapiszDoLogow('mozna'+str(DMozna)+'|'+str(MoznaEdytowacZwroty),1)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

        if len(Delete[0])>0:
            if not UprDel:
                stat='UPR DEL'
                dane.append(stat)
   
            if stat=='OK':
                sql=''
                for i in xrange(len(Delete[0])):
                    if stat=='OK':
                        DELETE="DELETE FROM rs_dowody_dostaw_pozycje "
                        WHERE="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                        for j in xrange(len(Delete[0][i])):
                            pole=Delete[1][j]
                            wart=Delete[0][i][j]
                            if pole in ['nr_poz']:
                                WHERE+=" AND "+pole+"="+str(wart)
                            else:
                                WHERE+=" AND "+pole+"='"+wart+"'"
                        sql+=DELETE+WHERE+";"
                        
                        # sprawdzenie czy z usuwanych dowodw dostaw nic nie jest wanie rozstawione
                        SQL="SELECT * FROM rs_dowody_dostaw_pozycje "+WHERE
                        SQL+=" AND ilosc_wysw1 != 0 LIMIT 1; "
                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':
                            stat='WYSW BL'
                            dane.append(stat)
                        elif len(DTest)>0:
                            stat='WYSW US'
                            dane.append(stat)
                            
                if sql<>'' and stat=='OK': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat='BL SQL DEL'
                        dane.append(stat)

        
#-------------------------------------------------------------------------------
#-------     Sprawdzanie danych do Update   
#-------------------------------------------------------------------------------

    if stat == 'OK':        
        if len(Update[0])>0:
            if not UprUpd:
                stat='UPR UPD'
                dane.append(stat)
                                
            if stat == 'OK':    
                # sownik do analizy czy naley wpisa pozycj do tablicy zwrotw
                # klucz to Update[2][i][0]
                # dane wynikowe to [dane do tabeli bdw, liczba zwrtw (bez informacji=-1),Typ "U"pdate lub "I"nsert]

                LZmArt = [] # lista indeksw i, ktre maj zmieniany artyku albo ilosc_zam1 albo ilosc_dost1

                for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                    IlZwrocona='brak'
                    IlDostarczona='brak'
                    for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                        if stat == 'OK':
                            pole=Update[0][i][j]
                            wart=Update[1][i][j]

                            # zapisujemy z ktrego wiersza pobierzemy klucz - numer pozycji
                            if pole in ['artykul_id','ilosc_zam1','ilosc_dost1']:
                                if not i in LZmArt:
                                    LZmArt.append(i)

                            # normalne testy
                            if pole=='nr_poz': 
                                if wart<=0:
                                    dane.append('NR POZ BR$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],0])
                            if pole=='artykul_id': 
                                if wart.strip()=='':
                                    dane.append('ART BR$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],1])
                                else:    
                                    Sql ="SELECT artykul_id FROM rs_artykuly"
                                    Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"' AND aktywny AND NOT tylko_detal;"
                                    stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                    if stat<>'OK':
                                        stat='BL SQL ART'
                                        dane.append(stat)
                                    if stat == 'OK':
                                        if len(d)==0:
                                            dane.append('ART BL$'+str(Update[-1][i]))
                                            wyn2.append([Update[-1][i],1])

                                if stat=='OK':
                                    if not Update[2][i][0] in SZwrotow:
                                        SZwrotow[Update[2][i][0]]=[Update[-1][i],-1,'U',i]
                            elif pole=='stawka_vat':
                                if wart.strip()<>'':
                                    Sql="Select kod FROM rs_stawki_vat WHERE kod='"+str(wart)+"'"
                                    stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                    if stat<>'OK':
                                        stat='BL SQL VAT'
                                        dane.append(stat)
                                    if stat == 'OK':
                                        if len(d)==0:
                                            dane.append('VAT BL$'+str(Update[-1][i]))
                                            wyn2.append([Update[-1][i],-1])
                                
                            elif pole=='ilosc_dost1':
                                IlDostarczona=wart
                                if not Update[2][i][0] in SZwrotow:
                                    SZwrotow[Update[2][i][0]]=[Update[-1][i],-1,'U',i]
                            elif pole=='ilosc_zwr1':
                                IlZwrocona=wart
                                if IlZwrocona>0:
                                    if not Update[2][i][0] in SZwrotow:
                                        SZwrotow[Update[2][i][0]]=[Update[-1][i],IlZwrocona,'U',i]
                                    else:
                                        SZwrotow[Update[2][i][0]][1]=IlZwrocona
                            elif pole=='cena_netto1':
                                if wart == 0:
                                    dane.append('CENAN1 BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],-1])
                            elif pole=='cena_netto2':
                                if wart == 0:
                                    dane.append('CENAN2 BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],-1])
                            elif pole=='cena_brutto1':
                                if wart == 0:
                                    dane.append('CENAB1 BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],-1])
                            elif pole=='cena_brutto2':
                                if wart == 0:
                                    dane.append('CENAB2 BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],-1])                                
                            elif pole=='cena_upust1':
                                if wart == 0:
                                    dane.append('CENAU1 BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],-1])
                            elif pole=='cena_upust2':
                                if wart == 0:
                                    dane.append('CENAU2 BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],-1])   
                                    
                if len(dane)>0 and stat == 'OK':
                    stat=dane[-1]

 
#-------------------------------------------------------------------------------
#---------- UPDATE       
#-------------------------------------------------------------------------------

    if stat == 'OK':

        if len(Update[0])>0:
            sql=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                if stat == 'OK':
                    RobicTestCen=False
                    UPDATE="UPDATE rs_dowody_dostaw_pozycje "
                    SET='SET '
    
                    BylDost = False
                    BylZwr = False
    
                    for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]

                        if UprTylkoZwroty:  #JR 2021-05-18 (12493)
                            # tylko zwroty reszte pol pomijamy
                            if pole in ['ilosc_zwr1', 'ilosc_zwr2']:
                                SET += pole + "=" + str(wart) + ","
                                if  not BylZwr:
                                    SET += "op_zwr=" + str(self.operator_id) + ","
                                    BylZwr = True
                            continue

                        if not MoznaEdytowacZwroty:  #JR 2023-03-13 (13381)
                            if pole in ['ilosc_zwr1', 'ilosc_zwr2']:
                                continue


                        if pole in ['cena_netto1','cena_upust1','artykul_id','stawka_vat']:
                            RobicTestCen=True
                        if pole in ['nr_poz','ilosc_zam1','ilosc_zam2','ilosc_pobr1','ilosc_pobr2',
                                    'ilosc_dost1','ilosc_dost2','ilosc_zwr1','ilosc_zwr2',
                                    'cena_netto1','cena_netto2','cena_upust1','cena_upust2',
                                    'cena_brutto1','cena_brutto2','faktura_zwrot','korekta_zwrot']: 
                                
                            SET+=pole+"="+str(wart)+","
                            
                            if pole in ['ilosc_dost1','ilosc_dost2'] and not BylDost:
                                SET+="op_dost="+str(self.operator_id)+","
                                BylDost = True
    
                            if pole in ['ilosc_zwr1','ilosc_zwr2'] and not BylZwr:
                                SET+="op_zwr="+str(self.operator_id)+","
                                BylZwr = True
                            
                        elif pole in ['artykul_id','stawka_vat']:
                            if wart<>'':
                                SET+=pole+"='"+wart+"',"
                            else:
                                SET+=pole+"=NULL,"
                            
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=Update[2][i][j]
                        if pole in ['nr_poz']:
                            WHERE+=" AND "+pole+"="+str(wart)

                            # dodatkowo pobieramy ten numer do testu na blokad z tytuu danych w grupach obiorcw asortyment
                            if i in LZmArt:
                                if not wart in SPozGrOdb:
                                    SPozGrOdb[wart] =['U',i]
                        else:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                    if RobicTestCen:
                        SprawdzacCeny.append(WHERE)
    
                    # sprawdzenie czy z usuwanych dowodw dostaw nic nie jest wanie rozstawione
                    SQL="SELECT * FROM rs_dowody_dostaw_pozycje "+WHERE
                    SQL+=" AND ilosc_wysw1 != 0 LIMIT 1; "
                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat='WYSW BL'
                        dane.append(stat)
                    elif len(DTest)>0:
                        stat='WYSW ED'
                        dane.append(stat)
                            
                    if len(SET) > 4:  #JR 2021-05-18 (12493) - SET moze byc puste czyli tylko 'SET '
                        sql+=UPDATE+SET+WHERE+";"
                
            if sql<>'' and stat == 'OK': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL SQL UPD'
                    dane.append(stat)

                             
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------
    
    if stat =='OK':                    
        if len(Insert[0])>0:
            rsglobal.ZapiszDoLogow('!!! Insert '+str(Insert),1)
            if not UprIns: 
                stat='UPR INS'
                dane.append(stat)
            if UprTylkoZwroty and Stan != '1':  #JR 2021-05-18 (12493)
                stat = 'Operator moe wstawia tylko zwroty'
                dane.append(stat)
                UprIns = False
                        
            if UprIns:
                for i in xrange(len(Insert[0])):
                    IlZwrocona='brak'
                    IlDostarczona='brak'
                    for j in xrange(len(Insert[0][i])):
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        if pole=='nr_poz': 
                            if wart<0:
                                dane.append('NR POZ BR')
                                wyn2.append([Insert[-1][i],0])
                            else:
                                Sql="SELECT * FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND  tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+" AND nr_poz="+str(wart)
                                stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if stat<>'OK':
                                    stat = 'BL SQL NR$'+stat
                                if stat=='OK':
                                    if len(d)>0:
                                        dane.append('POZ BL$'+str(Insert[-1][i]))
                                        wyn2.append([Insert[-1][i],0])   
                                         
                        if pole=='artykul_id': 
                            if wart.strip()=='':
                                dane.append('ART BR$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],1])
                            if wart.strip()<>'':
                                Sql ="SELECT artykul_id FROM rs_artykuly"
                                Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"' AND aktywny AND NOT tylko_detal;"
                                stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if stat<>'OK':
                                    stat='BL SQL ART'
                                    dane.append(stat)
                                if stat=='OK':
                                    if len(d)==0:
                                        dane.append('ART BL$'+str(Insert[-1][i]))
                                        wyn2.append([Insert[-1][i],1])
                        
                            if stat=='OK':
                                if not Insert[0][i][0] in SZwrotow:
                                    SZwrotow[Insert[0][i][0]]=[Insert[-1][i],-1,'I',i]
                                    
                        elif pole=='stawka_vat':
                            if wart.strip()<>'':                        
                                Sql="Select kod FROM rs_stawki_vat WHERE kod='"+str(wart)+"'"
                                stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if stat<>'OK':
                                    stat='BL SQL VAT'
                                    dane.append(stat)
                                if stat=='OK':
                                    if len(d)==0:
                                        dane.append('VAT BL$'+str(Insert[-1][i]))
                                        wyn2.append([Insert[-1][i],-1])
                                    
                        elif pole=='ilosc_dost1':
                            IlDostarczona=wart
                            if not Insert[0][i][0] in SZwrotow:
                                SZwrotow[Insert[0][i][0]]=[Insert[-1][i],-1,'I',i]
                        elif pole=='ilosc_zwr1':
                            IlZwrocona=wart
                            
                        elif pole=='cena_netto1':
                            if wart == 0:
                                dane.append('CENAN1 BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],-1])
                        elif pole=='cena_netto2':
                            if wart == 0:
                                dane.append('CENAN2 BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],-1])
                        elif pole=='cena_brutto1':
                            if wart == 0:
                                dane.append('CENAB1 BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],-1])
                        elif pole=='cena_brutto2':
                            if wart == 0:
                                dane.append('CENAB2 BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],-1])                                
                        elif pole=='cena_upust1':
                            if wart == 0:
                                dane.append('CENAU1 BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],-1])
                        elif pole=='cena_upust2':
                            if wart == 0:
                                dane.append('CENAU2 BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],-1])      
                        
                            
                    if IlZwrocona<>'brak':
                        if IlZwrocona>0:
                            if not Insert[0][i][0] in SZwrotow:
                                SZwrotow[Insert[0][i][0]]=[Insert[-1][i],IlZwrocona,'I',i]
                            else:
                                SZwrotow[Insert[0][i][0]][1]=IlZwrocona

                    
        if len(dane)>0:
            stat=dane[-1]
 
 
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       
    
        if stat=='OK':    
            sql=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_dowody_dostaw_pozycje "
                KOLUMNY="(firma_id,oddzial_id,trasa,data,tryb_dostawy,numer"
                VALUES=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Trasa+"','"+Data+"','"+Tryb+"',"+str(Numer)
                FiltrTestu="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
                FiltrTestu+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)

                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole=='nr_poz':
                        FiltrTestu+=" AND nr_poz="+str(wart)
                        
                    if UprTylkoZwroty and pole in ['ilosc_zam1','ilosc_zam2','ilosc_pobr1','ilosc_pobr2','ilosc_dost1','ilosc_dost2']:  #JR 2021-05-18 (12493)
                        pass                      #AB 26.04.23r
                    elif (not MoznaEdytowacZwroty and not UprTylkoZwroty) and pole in ['ilosc_zwr1','ilosc_zwr2']:  #JR 2022-03-13 (13381)
                        pass
                    elif pole in ['nr_poz','ilosc_zam1','ilosc_zam2','ilosc_pobr1','ilosc_pobr2','ilosc_dost1','ilosc_dost2','ilosc_zwr1','ilosc_zwr2','cena_netto1','cena_netto2','cena_upust1','cena_upust2','cena_brutto1','cena_brutto2','faktura_zwrot','korekta_zwrot']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)

                        # dodatkowo pobieramy ten numer do testu na blokad z tytuu danych w grupach obiorcw asortyment
                        if pole == 'nr_poz':
                            if not wart in SPozGrOdb:
                                SPozGrOdb[wart] = ['I',i]

                    if pole in ['artykul_id','stawka_vat']:
                        if wart=='':
                            KOLUMNY+=","+pole
                            VALUES+=",NULL"
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                            
                # jesli dodawano pozycje do dowodu w stanie '1'
                # to oznaczamy ja jako zmodyfikowana
                if Stan == '1':
                    KOLUMNY+=",op_dost,op_zwr"
                    VALUES+=","+str(self.operator_id)+","+str(self.operator_id)
                    
                KOLUMNY+=")"
                VALUES+=");"
                sql+=INSERT+KOLUMNY+VALUES
                SprawdzacCeny.append(FiltrTestu)
            if sql<>'':
                rsglobal.ZapiszDoLogow(sql)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL SQL INS'
                    dane.append(stat)            
                        
        else:
            if self.PolSQL.bylo_cos_robione:
                self.PolSQL.Rollback()


        if stat=='OK':
            # jesli to korekta, to kontrola, zeby na korekcie byly tylko zwroty lub dostarczenia
            if Korekta:
                sql ="SELECT ilosc_dost1,ilosc_zwr1 FROM rs_dowody_dostaw_pozycje"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
                sql+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                sql+=" AND (ilosc_dost1!=0 OR ilosc_zwr1!=0);"

                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania pozycji dowodu po modyfikacji: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    LiczDost = 0
                    LiczZwroc = 0
                    for i in xrange(len(d)):
                        if d[i][0] != 0:
                            LiczDost += 1
                        if d[i][1] != 0:
                            LiczZwroc += 1
                    if LiczDost > 0 and LiczZwroc > 0:
                        stat = 'KOR DOST I ZWROC BL'
                        dane.append(stat)

        #------------------------------------------
        # sprawdzenie czy zmieniane pozycje s dopuszczone do zapisu ze wzgldu na ograniczenia dla grup odbiorcw
        #------------------------------------------
        if stat=='OK' and len(SPozGrOdb) > 0:
            # pobieramy artykuy z odpowiednich pozycji
            SQL="SELECT nr_poz,artykul_id FROM rs_dowody_dostaw_pozycje " \
                " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'" \
                " AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+" " \
                " AND nr_poz IN ("+str(SPozGrOdb.keys())[1:-1]+") AND (ilosc_zam1 > 0 or ilosc_dost1 >0)"

            stat,DPozGr,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat = 'Bd pobrania pozycji dowodu do analizy grup odbiorcw: '+stat
                dane.append(stat)
            if stat=='OK':
                for poz in DPozGr:
                    SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+Kontr+"','"+poz[1]+"','"+Data+"')"
                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = 'Bd analizy grup odbiorcw dla pozycji '+str(poz[0])+': '+stat
                        dane.append(stat)
                    elif DTest[0][0] != 'OK':
                        # pozycja pochodzi z Update
                        if SPozGrOdb[poz[0]][0] == 'U':
                            dane.append('GR ODB AS$'+str(Update[-1][SPozGrOdb[poz[0]][1]])+': '+DTest[0][0])
                            wyn2.append([Update[-1][SPozGrOdb[poz[0]][1]],-1])
                        else:
                            dane.append('GR ODB AS$'+str(Insert[-1][SPozGrOdb[poz[0]][1]])+': '+DTest[0][0])
                            wyn2.append([Insert[-1][SPozGrOdb[poz[0]][1]],-1])
                if stat == 'OK':
                    if len(dane)>0:
                        stat=dane[-1]

        #------------------------------------------
        #-- SPRAWDZENIE CEN
        #------------------------------------------
        
        if stat=='OK':
            for filtr in SprawdzacCeny:
                if stat=='OK':
                    ArtSC="(SELECT artykul_id FROM rs_dowody_dostaw_pozycje "+filtr+")"
                    
                    SQL="SELECT DISTINCT dp.artykul_id,dp.cena_upust1 FROM rs_dowody_dostaw_pozycje dp "
                    SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
                    SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dd.kontrahent_id='"+Kontr+"' AND oddzial_id='"+Oddzial+"'"
                    SQL+=" AND dp.data='"+Data+"' AND dp.artykul_id="+ArtSC+" AND (NOT dd.korekta OR dd.korekta IS NULL);"
                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat=='OK':
                    if len(DTest)==0:
                        stat='POZ KL BR$'+filtr
                        dane.append(stat)            
                    elif len(DTest)>1:
                        stat='DUZO POZ$dnia '+Data+' i artykuu '+DTest[0][0]
                        dane.append(stat)            
            
            
        
        #------------------------------------------
        #-- ANALIZA ZWROTW
        #------------------------------------------
        
        if stat=='OK':
            # Analiza SZwrotow - czy bdzie co sprawdza
            for kl in SZwrotow:
                if SZwrotow[kl][1]>0:
                    TablicaZwrotow.append(kl)
                    TablicaZwrotowBledy.append([SZwrotow[kl][0],6])
                elif SZwrotow[kl][1]==-1 and SZwrotow[kl][2]=='U':
                    #sprawdzenie czy w zwrotach jest 0 :
                    i=SZwrotow[kl][3]
                    SQLZwr="SELECT ilosc_zwr1 FROM rs_dowody_dostaw_pozycje"    
                    SQLZwr+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=Update[2][i][j]
                        if pole in ['nr_poz']:
                            SQLZwr+=" AND "+pole+"="+str(wart)
                        else:
                            SQLZwr+=" AND "+pole+"='"+wart+"'"
                        
                    stat,DaneZwr,dump,dump=self.PolSQL.Execute(SQLZwr,3)
                    if DaneZwr[0][0]>0:
                        TablicaZwrotow.append(kl)
                        TablicaZwrotowBledy.append([SZwrotow[kl][0],6])
        
    
        # Analiza konkretnych zwrotw 
        if stat=='OK' and (len(TablicaZwrotow)>0):
            #pobranie kontrahenta
            if stat=='OK':
                SelK="SELECT kontrahent_id FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
                SelK+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                stat,DaneK,dump,dump=self.PolSQL.Execute(SelK,3)
                if stat<>'OK':
                    stat='Bd pobrania kontrahenta z dowodu dostawy:'+stat
                if stat=='OK' and len(DaneK)==0:
                    stat='KONTR BR' +stat
                if stat=='OK':    
                    Kontr=rsglobal.Dekoduj(DaneK[0][0])
            
            #pobranie artykuw dla pozycji 
            if stat=='OK':
                SelP="SELECT nr_poz,artykul_id FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
                SelP+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+" AND nr_poz in ("
                for i in xrange(len(TablicaZwrotow)):
                    SelP+=str(TablicaZwrotow[i])+","
                SelP=SelP.rstrip(',')
                SelP+=");"
            
                stat,DaneP,dump,dump=self.PolSQL.Execute(SelP,3)
                if stat<>'OK':
                    stat=u'Bd pobrania danych z pozycji ' +stat
                if stat=='OK' and len(DaneP)==0:
                    stat='POZ BR'
            
            #utworzenie listy artykuw
            if stat=='OK':
                LArt=[]
                for d in DaneP:
                    LArt.append(rsglobal.Dekoduj(d[1]))
            
                Select=" SELECT dp.artykul_id,SUM(dp.ilosc_dost1),SUM(dp.ilosc_dost1-dp.ilosc_zwr1) FROM rs_dowody_dostaw_pozycje dp "
                Select+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
                Select+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"' AND dd.data<='"+Data+"'"
                Select+=" AND CAST('"+Data+"' AS date)-90<=dd.data AND dd.kontrahent_id='"+Kontr+"' AND artykul_id IN ("+str(LArt)[1:-1]+")"
                Select+=" GROUP BY dp.artykul_id ORDER BY dp.artykul_id;"
            
                stat,d,dump,dump=self.PolSQL.Execute(Select,3)
                CzyRollback=False
                if stat=='OK':
                    if len(d)>0:
                        for i in xrange(len(d)):
                            #artyku z ktrego nie da si zdj zwrotw
                            if d[i][2]<0:
                                CzyRollback=True
                                #sprawdzenie jaki to nr pozycji
                                Nr=-1
                                for poz in DaneP:
                                    if poz[1]==d[i][0]:
                                        Nr=poz[0]
                                j=TablicaZwrotow.index(Nr)
                                wyn2.append(TablicaZwrotowBledy[j])
                                if d[i][1]==0:
                                    stat=rsglobal.Dekoduj('DOST BR$'+str(Nr)+". Artyku "+str(d[i][0]).strip())
                                    dane.append(stat)
                                else:
                                    stat=u'PRZ ZWR$'+str(rsglobal.Dekoduj(d[i][0])).strip()+u' w pozycji '+str(Nr)+rsglobal.Dekoduj(u' zostaa przekroczona o ')+rsglobal.Dekoduj(str(-d[i][2]))
                                    dane.append(stat)
                        
                if CzyRollback:
                    if self.PolSQL.bylo_cos_robione:
                        self.PolSQL.Rollback()

    # jeli co zmieniano to sprawdzamy spjno grupy dokumentw
    if len(Delete[0])+len(Update[0])+len(Insert[0])>0 and stat=='OK' and Korekta:
        OddP=rsglobal.Dekoduj(DKontr[0][3])
        TrasaP=rsglobal.Dekoduj(DKontr[0][4])
        TrasaP=rsglobal.Dekoduj(DKontr[0][4])
        DataP=rsglobal.Dekoduj(DKontr[0][5])
        TrybP=rsglobal.Dekoduj(DKontr[0][6])
        NrP=str(DKontr[0][7])
    
        SQL="SELECT ddp.artykul_id,SUM(ddp.ilosc_dost1),SUM(ddp.ilosc_zwr1) "
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
        SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
        SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+OddP+"'"
        SQL+="  AND trasa='"+TrasaP+"' AND data='"+DataP+"' AND tryb_dostawy='"+TrybP+"' AND numer="+NrP
        SQL+=" GROUP BY ddp.artykul_id;"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            SQL="SELECT ddp.artykul_id,SUM(ddp.ilosc_dost1),SUM(ddp.ilosc_zwr1) "
            SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
            SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
            SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id_p='"+OddP+"'"
            SQL+=" AND trasa_p='"+TrasaP+"' AND data_p='"+DataP+"' AND tryb_dostawy_p='"+TrybP+"' AND numer_p="+NrP
            SQL+=" GROUP BY ddp.artykul_id;"
            stat,DTest2,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat == 'OK':
                SArt={}
                for poz in DTest:
                    if not poz[0] in SArt:
                        SArt[poz[0]]=[0,0]
                    SArt[poz[0]][0]+=poz[1]
                    SArt[poz[0]][1]+=poz[2]
                for poz in DTest2:
                    if not poz[0] in SArt:
                        SArt[poz[0]]=[0,0]
                    SArt[poz[0]][0]+=poz[1]
                    SArt[poz[0]][1]+=poz[2]
                    
                LArt=[]
                KlArt=SArt.keys()
                KlArt.sort()
                for art in KlArt:
                    if SArt[art][0]<0:
                        LArt.append(" Art: "+art.strip()+'   il. dost. = '+str(SArt[art][0]))
                    elif SArt[art][1]<0:
                        LArt.append(" Art: "+art.strip()+'   il. zwr. = '+str(SArt[art][1]))
            
                if len(LArt)>0:
                    stat="Ponisze artykuy maj sum iloci < 0:\n"
                    for poz in LArt:
                        stat+=poz+'\n'
                    dane.append(stat)
                    
                    if self.PolSQL.bylo_cos_robione:
                        self.PolSQL.Rollback()
    
#---------------------------------------------------------------------------------------------------------------
#------- POBIERANIE DANYCH
#---------------------------------------------------------------------------------------------------------------

if (Funkcja in [1,5,6]) and (stat=='OK'):
    Select ="SELECT fp.nr_poz,TRIM(fp.artykul_id),art.nazwa,fp.ilosc_zam1,fp.ilosc_pobr1,fp.ilosc_dost1,fp.ilosc_zwr1,"
    Select+=" TRIM(fp.artykul_id) as artykul_id_2,fp.cena_upust1,fp.ilosc_zam2,fp.ilosc_pobr2,fp.ilosc_dost2,fp.ilosc_zwr2,"
    Select+=" fp.cena_upust2,fp.cena_netto1,fp.cena_netto2,fp.cena_brutto1,fp.cena_brutto2,fp.faktura_zwrot,"
    Select+=" fp.korekta_zwrot,fp.stawka_vat,COALESCE(o1.login,''::TEXT),COALESCE(o2.login,''::TEXT)"
    Select+=" FROM rs_dowody_dostaw_pozycje fp"
    Select+=" LEFT OUTER JOIN rs_artykuly art ON fp.firma_id = art.firma_id AND fp.artykul_id = art.artykul_id"
    Select+=" LEFT OUTER JOIN rs_operatorzy o1 ON fp.op_dost=o1.operator_id"
    Select+=" LEFT OUTER JOIN rs_operatorzy o2 ON fp.op_zwr=o2.operator_id"
    Select+=" WHERE fp.firma_id='"+self.firma_id+"' AND fp.oddzial_id='"+Oddzial+"' AND fp.trasa='"+Trasa+"'"
    Select+=" AND fp.data='"+Data+"' AND  fp.tryb_dostawy='"+Tryb+"' AND fp.numer="+str(Numer)
    if Art.strip()<>'':
        Select+=" AND fp.artykul_id LIKE '"+Art+"%' "
    Select+=" ORDER BY nr_poz;"
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
        
    if stat!="OK":
        stat="PRZ BL"
    else:
        wyn1=[]
        Select ="SELECT czy_automatycznie,opak_dostarczone1,opak_dostarczone2,opak_zwrocone1,opak_zwrocone2"
        Select+=" FROM rs_dowody_dostaw"
        Select+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
        Select+=" AND data='"+Data+"' AND  tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat=u'bd pobierania danych nagwka'
            dane.append(stat)
        if len(d)>0:
            wyn1=d[0]
    wyn1.append(LArtPoziom)