# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_przyg_wyd_wms.py
# Purpose:     obsluga przygotowania wyda wms
# Author:      Piotr Witkowski
# Created:     2018/01/11
# RCS-ID:      $Id: fs_dowody_dostaw_przyg_wyd_wms $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2023-11-30 Aleksander Bargie (13626) Dugo trwajcy plan wydania WMS
import rsglobal

global wykonania  #AB 2023-11-30
wykonania = {}
stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Trasa': [1, 2, 5, 6, 11], 'Data': [1, 2,  5, 6, 11], 'Tryb': [1, 2,  5, 6, 11], 'Numer': [1, 2,  5, 6, 11],
             'Oddzial': [1, 2,  5, 6, 11], 'Magazyn': [1, 2,  5, 6, 11]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_dowody_dostaw_pozycje z numerem ' + str(
            Funkcja) + ' bez parametrw: ' + Lista

if stat == 'OK' and Funkcja in [1, 2, 5, 6, 11]:
    Trasa = str(klucze['Trasa'])
    Data = str(klucze['Data'])
    Tryb = str(klucze['Tryb'])
    Numer = str(klucze['Numer'])
    Oddzial = str(klucze['Oddzial'])
    Magazyn = str(klucze['Magazyn'])

dane = []
wyn1 = []
wyn2 = []


class WMSWydanie():
    def __init__(self, firma, oddzial, trasa, data, tryb, magazyn, operator, PolSQL):
        # przypisujemy dane, w kadej funkcji klasy moemy z nich koysta
        self.firma = firma
        self.oddzial = oddzial
        self.trasa = trasa
        self.data = data
        self.tryb = tryb
        self.magazyn = magazyn
        self.operator = operator
        self.PolSQL = PolSQL
        self.palety = None
        self.dane = []
        self.stat = 'OK'
        self.bledy_przy_wydaniu = []

    def insert_wms(self, numer, nr_poz, art, kontr, ilosc, zabr, nr_pal, lok):
        from time import time  #AB 2023-11-30
        from datetime import datetime
        # zapis do bazy pojedyczej pozycji
        if self.stat == 'OK':
            sql = "INSERT INTO rs_dowody_dostaw_wms "
            sql += "(firma_id, oddzial_id, trasa, data, tryb_dostawy, numer, nr_poz, magazyn_id, "
            sql += "artykul_id, kontrahent_id, ilosc, zabraklo, nr_palety_id, lokacja_id, stan) "
            sql += "VALUES('" + self.firma + "','" + self.oddzial + "','" + self.trasa + "','" + self.data + "',"
            sql += "'" + self.tryb + "','" + numer + "','" + nr_poz + "', '" + self.magazyn + "', "
            sql += "'" + art + "','" + kontr + "', " + ilosc + ", " + zabr + ", '" + nr_pal + "', "
            sql += "'" + lok + "', 'U');"
            rsglobal.ZapiszDoLogow(self.stat + ' ' + sql, 5)
            start = time()  #AB 2023-11-30
            self.stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
            wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]  #AB 2023-11-30
            if self.stat != 'OK':
                rsglobal.ZapiszDoLogow(self.stat + ' ' + sql, 5)
                self.stat = 'BL SQL INS'
                self.dane.append(self.stat)

    def funkcja_select_pozycje(self, ponownie):
        from time import time  #AB 2023-11-30
        from datetime import datetime
        if self.stat != 'OK':
            return
        # Ze wzgldu na rozmiar i atwiejsz analiz sql zmontowany jest w ten sposb
        if ponownie:
            ilosc = """ddp.ilosc_dost1- COALESCE((SELECT sum(ilosc) FROM rs_dowody_dostaw_wms w
                                   WHERE w.firma_id=dd.firma_id AND w.oddzial_id = dd.oddzial_id AND w.trasa = dd.trasa
                                        AND w."data" = dd."data" AND w.tryb_dostawy = dd.tryb_dostawy AND w.numer = dd.numer
                                        AND w.nr_poz = ddp.nr_poz AND stan IN ('W', 'U')), 0) AS pozostalo"""
        else:
            ilosc = "ddp.ilosc_dost1"
        sql = """
            SELECT
                dd.numer, ddp.nr_poz, ddp.artykul_id, dd.kontrahent_id, """ + ilosc + """,
                (select l.lokacja_id from rs_lokacje l join rs_artykuly_przyjecia ap using (firma_id, lokacja_id)
                    where l.firma_id = dd.firma_id and l.magazyn_id = '"""+self.magazyn+"""' and
                    l.kontrahent_id=ddp.kontrahent_id
                            and rsf_podaj_dane_lokacji(dd.firma_id, l.lokacja_id, 'zajete') = '1.0'
                            and ap.artykul_id=ddp.artykul_id limit 1) is not null as czy_lokacje_kontrahenta,
                (SELECT case when aoz.czy_unikalna is true  then aoz.opakowanie_id else '' end
                    FROM rs_artykuly_opakowania_zbiorcze aoz
                    where aoz.firma_id = dd.firma_id and aoz.artykul_id = ddp.artykul_id and paleta_id is not null
                    and aoz.czy_unikalna  AND aoz.kontrahent_id = ddp.kontrahent_id) as czy_unikalne,
                ((alp.limit_dni > 0 or alp.limit_procent > 0) and a.dni_przydatnosci > 0) as czy_termin_przydatnosci,
                a.dni_przydatnosci, alp.limit_dni, alp.limit_procent, ddp.artykul_id||'-'||a.nazwa
            FROM rs_dowody_dostaw dd
            JOIN rs_dowody_dostaw_pozycje ddp
                ON dd.firma_id = ddp.firma_id AND dd.oddzial_id=ddp.oddzial_id AND dd.trasa = ddp.trasa
                AND dd.data = ddp.data AND dd.tryb_dostawy = ddp.tryb_dostawy AND dd.numer = ddp.numer	AND dd.stan='1'
            JOIN rs_kontrahenci k ON ddp.firma_id=k.firma_id AND dd.kontrahent_id=k.kontrahent_id
            JOIN rs_artykuly a ON ddp.firma_id = a.firma_id and ddp.artykul_id=a.artykul_id
            LEFT JOIN rs_artykuly_limity_przydatnosci alp
                ON alp.firma_id=ddp.firma_id and alp.artykul_id=a.artykul_id
                and alp.kontrahent_id=k.kontrahent_id AND alp.typ='W'
        """
        where = " WHERE dd.firma_id='" + self.firma + "' AND dd.oddzial_id='" + self.oddzial + "' "
        where += " AND dd.trasa='" + self.trasa + "'"
        where += " AND dd.data='" + self.data + "' AND  dd.tryb_dostawy='" + self.tryb + "' "
        where += " AND dd.stan='1' "
        sql += where + " ORDER BY ddp.numer, ddp.nr_poz, ddp.artykul_id, ddp.kontrahent_id;"
        # Wykonanie zapytania i zapisanie do zmiennej globalnej
        start = time()  #AB 2023-11-30
        self.stat, self.dane_pozycje, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
        wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]  #AB 2023-11-30
        # rsglobal.ZapiszDoLogow("sql: " + sql, 5)
        if self.dane_pozycje:
            rsglobal.ZapiszDoLogow("pozycje: " + sql, 5)
        if self.stat != 'OK':
            self.stat = "Bd przy pobieraniu pozycji: " + self.stat

    def funkcja_select_palety(self, artykul, ponownie):
        from time import time  #AB 2023-11-30
        from datetime import datetime
        if self.stat != 'OK':
            return
        now = rsglobal.PodajDzis()
        war_ponownie = "" if ponownie else "AND stan!='P'"  #AB 2023-12-07
        sql = """
SELECT (case
    when coalesce(alp.limit_dni,0) > 0 then (pn.termin_przyd-'""" + now + """')-alp.limit_dni
    when coalesce(alp.limit_procent,0) > 0
    then (pn.termin_przyd-'""" + now + """')::float-(a.dni_przydatnosci*alp.limit_procent::float/100)::float
    else pn.termin_przyd-'""" + now + """' end ) as liczba_dni_przydatnosci,
    l.lokacja_id, l.magazyn_id, l.kontrahent_id, dmp.dokument_id,
    a.dni_przydatnosci,    alp.limit_dni, alp.limit_procent, pn.termin_przyd, pn.artykul_id, pn.nr_palety_id,
    pn.ilosc1, pn.opakowanie_id, pn.paleta_id, pn.wsp_ilosci_opakowanie, aoz.ilosc1*aoz.pojemnosc_paletowa,
    aoz.ilosc1, aoz.pojemnosc_paletowa
FROM rs_artykuly_przyjecia ap
INNER JOIN rs_dokumenty_magazynowe_pozycje dmp USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)
INNER JOIN rs_dokumenty_magazynowe_pozycje_palety dmpp USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)
--INNER JOIN rs_dokumenty_magazynowe_lokacje dml USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)
INNER JOIN rs_palety_numery pn ON (pn.firma_id=dmpp.firma_id AND pn.nr_palety_id = dmpp.nr_palety_id AND ap.ilosc1 = pn.ilosc1)
JOIN rs_artykuly_opakowania_zbiorcze aoz ON ap.firma_id=aoz.firma_id AND ap.artykul_id = aoz.artykul_id and
pn.opakowanie_id = aoz.opakowanie_id
INNER JOIN rs_lokacje l ON (l.firma_id=dmpp.firma_id AND l.lokacja_id = ap.lokacja_id) and l.lokacja_id = dmp.lokacja_dokad
INNER JOIN rs_artykuly a ON (a.firma_id=ap.firma_id AND a.artykul_id = ap.artykul_id)
LEFT JOIN rs_artykuly_limity_przydatnosci alp on ap.firma_id = alp.firma_id and ap.artykul_id = alp.artykul_id
and alp.kontrahent_id = '""" + self.kontrahent + """' and alp.typ='W'
LEFT OUTER JOIN rs_lokalizacje lok ON (lok.firma_id=l.firma_id AND lok.lokacja_id = l.lokacja_id)"""
        sql += " WHERE ap.firma_id = '" + self.firma + "' and ap.artykul_id='" + artykul + "' "
        sql += " \nAND not EXISTS (Select 1 From rs_dowody_dostaw_wms wm WHERE wm.nr_palety_id=dmpp.nr_palety_id "+war_ponownie+" )"  #AB 2023-12-07
        sql += " and l.magazyn_id = '" + self.magazyn + "' AND l.lokacja_id NOT IN (SELECT COALESCE(dl2.lokacja_skad, "
        sql += " dp2.lokacja_skad) FROM rs_dokumenty_magazynowe_pozycje dp2 INNER JOIN rs_dokumenty_magazynowe d2 USING"
        sql += " (firma_id, magazyn_id,dokument_id,data,numer) LEFT OUTER JOIN rs_dokumenty_magazynowe_lokacje dl2 "
        sql += " USING (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz) WHERE dp2.firma_id=ap.firma_id AND "
        sql += " dp2.magazyn_id=l.magazyn_id AND d2.dokument_id IN (SELECT dokument_id FROM rs_typy_dokumentow_m WHERE "
        sql += " firma_id=ap.firma_id AND typ_dokumentu IN ('M','W','L')) AND dp2.artykul_id=ap.artykul_id AND "
        sql += " COALESCE(dl2.lokacja_skad, dp2.lokacja_skad) IS NOT null AND d2.stan='W')   AND dmpp.data <= now()"
        sql += " and dmpp.data=(SELECT max(data) FROM rs_dokumenty_magazynowe_pozycje_palety "
        sql += " WHERE nr_palety_id = pn.nr_palety_id AND firma_id = pn.firma_id) AND  pn.ilosc1 = aoz.ilosc1 * "
        sql += "aoz.pojemnosc_paletowa and (l.kontrahent_id='" + self.kontrahent + "' or l.kontrahent_id is null or "
        sql += "l.kontrahent_id = '') and aoz.lp  = coalesce((select aoz2.lp from rs_artykuly_opakowania_zbiorcze aoz2"
        sql += " WHERE aoz2.firma_id=aoz.firma_id AND aoz2.artykul_id = aoz.artykul_id and aoz2.opakowanie_id = "
        sql += " aoz.opakowanie_id and aoz2.kontrahent_id='" + self.kontrahent + "'),"
        sql += " (select max(aoz2.lp) from rs_artykuly_opakowania_zbiorcze aoz2"
        sql += " \n\tWHERE aoz2.firma_id=aoz.firma_id AND aoz2.artykul_id = aoz.artykul_id and "
        sql += " aoz2.opakowanie_id = aoz.opakowanie_id))"
        if self.unikalne_opakowanie not in (None, 'None', '',):
            sql += "AND aoz.opakowanie_id = '"+self.unikalne_opakowanie+"' "
        sql += " and pn.termin_przyd > '" + now + "'"
        sql += " AND (case when coalesce(alp.limit_dni,0) > 0 then (pn.termin_przyd-'" + now + "')-alp.limit_dni "
        sql += " when coalesce(alp.limit_procent,0) > 0  "
        sql += " then (pn.termin_przyd-'" + now + "')::float-(a.dni_przydatnosci*alp.limit_procent::float/100)::float "
        sql += " else pn.termin_przyd-'" + now + "' end ) > 0  "
        sql += " order by l.kontrahent_id, liczba_dni_przydatnosci, l.lokacja_id;"

        start = time()  #AB 2023-11-30
        self.stat, self.dane_palety, dump, dump = self.PolSQL.Execute(sql, 3)
        wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]  #AB 2023-11-30
        # if self.dane_palety:
        rsglobal.ZapiszDoLogow("j3 " + sql, 5)
        if self.stat != 'OK':
            self.stat = "Bd przy pobieraniu palety: " + self.stat

    def bledy_wydania(self, artykul, numer, nr_poz, zabraklo, powod):
        # Funkcja pomocnicza do komunikatu bdw
        stat = 'Nr: ' + str(int(numer)) + ' poz: ' + str(int(nr_poz)) + ', kontrahent: ' + self.kontrahent.strip()
        if artykul:
            stat += '. \tDla artykuu: ' + str(artykul)
        if zabraklo:
            stat += ', zabrako: ' + str(zabraklo)
        if powod:
            stat += '. ' + powod
        return stat

    def wydaj_palety_do_wms(self, czy_lokacja_kontrahent, czy_unikalna, czy_termin_przydatnosci, ponownie):
        if self.stat != 'OK' or not self.dane_pozycje:
            return

        # pozycje pobierane s raz przed wywoaniem tej funkcji dla wszystkich wyda
        for poz in self.dane_pozycje:
            # rsglobal.ZapiszDoLogow("i7 " + str(poz), 5)
            zmieniono = False
            numer = poz[0]
            nr_poz = poz[1]
            artykul = poz[2]
            artykul_i_opis = poz[-1] # poz[11]
            self.kontrahent = poz[3]
            ilosc_do_wyst_na_paletach = poz[4]
            self.unikalne_opakowanie = poz[6]
            ilosc_palety = 0
            # poz - wartoci z select palety
            kryteria = (poz[5], bool(poz[6]), poz[7]) == (czy_lokacja_kontrahent,
                                                          czy_unikalna,
                                                          czy_termin_przydatnosci)

            # JELI SPENIA KRYTERIA Z ZAOE, JELI NIE TO W INNYM PUNKCIE BDZIE WYKONANE
            if kryteria and self.stat == 'OK':
                # przy kadym dowodzie dostaw pobieramy wie palet - jest warunek w zapytaniu niepozwalajcy
                # pobra palet jeszcze raz

                # select pobiera wszystkie palety w odpowiedniej kolejnoci
                # np. z lokacji kontrahenta a pniej bez jeli jest w warunku czy_lokacja_kontrahent
                self.funkcja_select_palety(artykul=artykul, ponownie=ponownie)

                # jeli byy palety to wchodzimy w funkcj

                rsglobal.ZapiszDoLogow(str(self.dane_palety), 5)
                if self.dane_palety:
                    # Ptla zakada, e moe by wicej wyda na jeden dowd ni tylko jeden np 500 a palety po 150 - 3 wydania
                    # Flaga jeli natrafi na bd to nie wykonuje ju wyda
                    kolejne = True

                    # ptla po wszystkich dostpnych paletach
                    for paleta in self.dane_palety:
                        ilosc_palety = paleta[15]
                        ilosc_do_rozstawienia = ilosc_palety
                        rsglobal.ZapiszDoLogow(str(ilosc_do_wyst_na_paletach), 5)
                        if kolejne and ilosc_do_wyst_na_paletach >= ilosc_palety:
                            # jeeli paleta istnieje
                            if paleta:
                                lokacja = paleta[1]
                                nr_pal = paleta[10]
                                rsglobal.ZapiszDoLogow("i6 " + str(ilosc_do_rozstawienia)+" "+str(ilosc_do_wyst_na_paletach)+" "+str(paleta)+" ", 5)
                                ilosc_do_wyst_na_paletach -= ilosc_palety
                                self.insert_wms(
                                    numer=str(numer), nr_poz=str(nr_poz), art=artykul,
                                    kontr=self.kontrahent, ilosc=str(ilosc_do_rozstawienia),
                                    zabr=str(ilosc_do_wyst_na_paletach), nr_pal=nr_pal.strip(), lok=lokacja,
                                )
                                zmieniono = True
                                # usuwam to co dodaem
                            else:
                                # zabezpieczenie przed bdami chyba nie powinno si wyday
                                blad = self.bledy_wydania(
                                    artykul=artykul_i_opis,
                                    numer=numer,
                                    nr_poz=nr_poz,
                                    zabraklo=int(ilosc_do_wyst_na_paletach),
                                    powod="Brak palet speniajcych podane kryteria. ",
                                )
                                self.bledy_przy_wydaniu.append(blad)
                                rsglobal.ZapiszDoLogow("brak palet 1")
                                kolejne = False
                                zmieniono = True


                    # rsglobal.ZapiszDoLogow("i9 " + " " + str(kolejne) + " " + str(ilosc_do_wyst_na_paletach) + " " + str(ilosc_palety), 5)
                    # rsglobal.ZapiszDoLogow("i9a " + str(kolejne and ilosc_do_wyst_na_paletach < ilosc_palety), 5)

                    # jeeli wydano co, a nie wydano wszystkiego
                    if kolejne and zmieniono and ilosc_do_wyst_na_paletach > 0:
                        # rsglobal.ZapiszDoLogow("i10 " + str(ilosc_do_wyst_na_paletach > 0), 5)
                        blad = self.bledy_wydania(
                            artykul=artykul_i_opis,
                            numer=numer,
                            nr_poz=nr_poz,
                            zabraklo=ilosc_do_wyst_na_paletach,
                            powod=None
                        )
                        self.bledy_przy_wydaniu.append(blad)
                        rsglobal.ZapiszDoLogow("i12 " + blad, 5)
                        zmieniono = True

                # nie wydano pozycji bo nie odpowiaday palety lub co w tym stylu
                if not zmieniono:
                    blad = self.bledy_wydania(
                        artykul=artykul_i_opis,
                        numer=numer,
                        nr_poz=nr_poz,
                        zabraklo=None,
                        powod="Brak palet speniajcych podane kryteria.   ",
                    )
                    self.bledy_przy_wydaniu.append(blad)
                    zmieniono = True
                    rsglobal.ZapiszDoLogow("brak palet 3")

    def usun_dane_z_okna(self):
        from time import time  #AB 2023-11-30
        from datetime import datetime
        # usuwa wszystkie dane z okna dowody dostaw wms dla dowodu dostawy - warunki
        if self.stat != 'OK':
            return self.stat

        sql = "DELETE FROM rs_dowody_dostaw_wms w "
        sql += " WHERE w.firma_id='" + self.firma + "' AND w.oddzial_id='" + self.oddzial + "' "
        sql += " AND w.trasa='" + self.trasa + "'"
        sql += " AND w.data='" + self.data + "' AND  w.tryb_dostawy='" + self.tryb + "' "
        sql += " AND w.magazyn_id='" + self.magazyn + "';"
        # rsglobal.ZapiszDoLogow(sql)
        start = time()  #AB 2023-11-30
        self.stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]  #AB 2023-11-30
        if self.stat != 'OK':
            self.stat = "Bdy usuwania danych: " + self.stat
        return self.stat

    def pobierz_dane(self):
        from time import time  #AB 2023-11-30
        from datetime import datetime

        if self.stat != 'OK':
            return self.stat, self.dane

        sql = ("SELECT w.trasa||'/'||w.data||'/'||w.tryb_dostawy||'/'||w.numer, "
               " w.nr_poz, w.kontrahent_id||'-'||k.nazwa, w.artykul_id||'-'||a.nazwa, "
               " w.nr_palety_id, w.lokacja_id, w.operator_id, w.stan, w.ilosc\n "
               " FROM rs_dowody_dostaw_wms w "
               " JOIN rs_kontrahenci k ON w.firma_id=k.firma_id AND w.kontrahent_id=k.kontrahent_id "
               " JOIN rs_artykuly a ON w.firma_id=a.firma_id AND w.artykul_id=a.artykul_id "
               " WHERE w.firma_id='" + self.firma + "' AND w.oddzial_id='" + self.oddzial + "' "
               " AND w.trasa='" + self.trasa + "'"
               " AND w.data='" + self.data + "' AND  w.tryb_dostawy='" + self.tryb + "' " # AND w.numer=" + str(Numer) + " "
               " AND w.magazyn_id='" + self.magazyn + "' ORDER BY lokacja_id;")
        # rsglobal.ZapiszDoLogow(sql)
        start = time()  #AB 2023-11-30
        self.stat, self.dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
        wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]  #AB 2023-11-30
        if self.stat != 'OK':
            self.stat = "Bd przy pobieraniu danych: " + self.stat
        return self.stat, self.dane

if stat == 'OK' and Funkcja in (1, 2, 5, 6, 11):
    # Zainicjowanie klasy dla wszystkich funkcji
    wms = WMSWydanie(firma=self.firma_id, oddzial=Oddzial, trasa=Trasa, data=Data,
                          tryb=Tryb, magazyn=Magazyn, operator=self.operator_id, PolSQL=self.PolSQL)
    # Przeliczanie okna na nowo (usunicie danych )
    if Funkcja in (2, 6):
        stat = wms.usun_dane_z_okna()

if stat == 'OK' and Funkcja in [1, 6, 11]:
    # pobranie pozycji z dowodw dostaw do wydania
    wms.funkcja_select_pozycje(ponownie=Funkcja == 11)
    # Ze wzgldu na wymagania kolejnoci wyda, wykonujemy pen kombinacje wszystkich wyda.
    # Wydania nie duplikuj si, bo w selekcie sprawdza czy pozycja jest ju w insertowanej tabeli.
    # Poniej wykonywane s wszystkie warianty
    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=True, czy_unikalna=True, czy_termin_przydatnosci=True, ponownie=Funkcja == 11)
    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=False, czy_unikalna=True, czy_termin_przydatnosci=True, ponownie=Funkcja == 11)

    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=True, czy_unikalna=True, czy_termin_przydatnosci=False, ponownie=Funkcja == 11)
    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=False, czy_unikalna=True, czy_termin_przydatnosci=False, ponownie=Funkcja == 11)

    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=True, czy_unikalna=False, czy_termin_przydatnosci=True, ponownie=Funkcja == 11)
    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=False, czy_unikalna=False, czy_termin_przydatnosci=True, ponownie=Funkcja == 11)

    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=True, czy_unikalna=False, czy_termin_przydatnosci=False, ponownie=Funkcja == 11)
    wms.wydaj_palety_do_wms(czy_lokacja_kontrahent=False, czy_unikalna=False, czy_termin_przydatnosci=False, ponownie=Funkcja == 11)
    stat = wms.stat
    dane = wms.dane
    if stat == 'OK':
        wyn1 = wms.bledy_przy_wydaniu
    rsglobal.ZapiszDoLogow("stat po zapisie " + stat, 5)

if stat == 'OK' and Funkcja in (1, 2, 5, 6, 11):
    stat, dane = wms.pobierz_dane()
    rsglobal.ZapiszDoLogow("stat po pobraniu  " + stat, 5)

#AB 2023-11-30
wysylac = False
for key, value in wykonania.iteritems():
    if value[0] > 60:
        wysylac = True
if wysylac:
    rsglobal.RSWyslijEmail('abargiel@recordsystem.com.pl', 'Odnaleziono dugie przygotowanie wydania',
                           str(wykonania).replace('],',']<br>'),  [], 0, self.PolSQL)
