
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_skany.py
# Purpose:     wyswietla, dodaje, usuwa z bazy danych informacje o 
#              skanach dowodw dostaw                                
# Author:      Micha Raburski
# Created:     2012/11/19
# RCS-ID:      $Id: fs_dowody_dostaw_skany.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-12-06 Mariusz Rajfura (6341) zapis skanow u klienta


from funkcje import fs_pliki_global

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

# 2 - podgld treci konkretnego pliku, 
# 5 - wywietlenie listy, 
# 6 - usuwanie skanu,
# 7 - wstawienie pliku do tabeli
# 8 - pobranie dowodu na podstawie parametrw

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Oddzial':[2,5,6,7],'Trasa':[2,5,6,7],'Data':[2,5,6,7],'Tryb':[2,5,6,7],
    'Numer':[2,5,6,7],'Strona':[2,6,7],'NazwaPliku':[2,6,7],'Tresc':[7],'LPar':[8],
    'ListaDowodow':[11]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dowody_dostaw_skany z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [2,5,6,7]:
        Oddzial=rsglobal.Dekoduj(klucze['Oddzial'])
        Trasa=rsglobal.Dekoduj(klucze['Trasa'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Tryb=rsglobal.Dekoduj(klucze['Tryb'])
        Numer=str(klucze['Numer'])
        
    if Fun in [2,6,7]:
        Strona=str(klucze['Strona'])
        NazwaPliku=rsglobal.Dekoduj(klucze['NazwaPliku'])
        
    if Fun==7:
        Tresc=rsglobal.Dekoduj(klucze['Tresc'])
        
    if Fun==8:
        LPar=klucze['LPar']

    if Fun==11:
        ListaDowodow=klucze['ListaDowodow']
        
        

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

UprEdycja=((self.oddzial_id,'028012') in self.uprawnienia) or ((self.oddzial_id,'028013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if Fun == 6:
    if not UprEdycja:
        stat='Brak uprawnie do usuwania skanw'

if Fun == 7:
    if not UprEdycja:
        stat='Brak uprawnie do wstawiania skanw'


#-------------------------------------------------------------------------------
#---   POBRANIE LISTY SKANOW NA PODSTAWIE LISTY DOWODOW (11)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 11:
    dane = []
    
    for d in ListaDowodow:
        Oddzial1 = rsglobal.Dekoduj(d[0])
        Trasa1 = rsglobal.Dekoduj(d[1])
        Data1 = rsglobal.Dekoduj(d[2])
        Tryb1 = rsglobal.Dekoduj(d[3])
        Numer1 = d[4]

        sql ="SELECT dds.strona, p.nazwa"
        sql+=" FROM rs_dowody_dostaw_skany dds"
        sql+=" INNER JOIN rs_pliki p "  
        sql+=" USING (firma_id,plik_id)"
        sql+=" WHERE dds.firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial1+"' AND trasa='"+Trasa1+"'"
        sql+=" AND data='"+Data1+"' AND tryb_dostawy='"+Tryb1+"' AND numer="+str(Numer1)
        sql+=" ORDER BY dds.strona;"
        
        stat,skany,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = "Bd pobierania list skanw dla dowodw dostaw: "+stat
            dane = []
            dane.append(stat)
            break
        
        if len(skany) == 0:
            continue
        
        # dopisujemy do dane[] liste skanow kolejnego dowodu z numeracja kolejnosci
        Lp = 0
        for s in skany:
            Lp += 1
            Strona1 = s[0]
            Nazwa1 = s[1]
            dane.append([Oddzial1,Trasa1,Data1,Tryb1,Numer1,Nazwa1,Strona1,Lp])
    

#-------------------------------------------------------------------------------
#---   POBRANIE DOWODU NA PODSTAWIE PARAMETRW (8)
#-------------------------------------------------------------------------------
    
if Fun==8:            
    # po kolei sprawdzamy kolejne w miar dopasowane klucze
    if stat=='OK':
        dane=[]

        for par in LPar:
            rsglobal.ZapiszDoLogow('!!! PAR '+str(par),1)
            if stat=='OK' and dane==[]:
                if not len(par) in [4,13,17]:
                    rsglobal.ZapiszDoLogow('lenpar '+str(len(par)),1)
                    continue
                # wersja z XXX (stara)
                if len(par) == 4:
                    LTrasN = []
                    
                    NrP=par[0]
                    DataN='20'+NrP[:6]
                    DataN=DataN[:4]+'-'+DataN[4:6]+'-'+DataN[6:]
                    DataN2=''

                    if DataN <'2016-10-01':
                        OddzN='0'+NrP[6:7]
                        KoncowkaTrasyN=NrP[7:9]
                        TrybN=NrP[6:7]+NrP[9:10]
                        NrN=NrP[10:]
                        DataP=par[1]
                        DataP=DataP[:4]+'-'+DataP[4:6]+'-'+DataP[6:]
                        KontrP=par[2]
                        StronaP=par[3]
                    else:
                        OddzN=NrP[6:8]
                        TrasaN=NrP[8:12]
                        TrybN=NrP[12:14]
                        NrN=NrP[14:]
                        DataP=par[1]
                        DataP=DataP[:4]+'-'+DataP[4:6]+'-'+DataP[6:]
                        KontrP=par[2]
                        StronaP=par[3]
                        KoncowkaTrasyN=''

                    # podstawiamy rne cyfry pod litery w stronie i dacie i dacie w numerze.
                    DataP=DataP.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                    StronaP=StronaP.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                    DataN=DataN.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                    OddzN=OddzN.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                    KoncowkaTrasyN=KoncowkaTrasyN.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                    TrybN=TrybN.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2')
                    NrN=NrN.replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                    CzyOK=True
                    
                # wersja z XXXX nowa
                elif len(par) == 13:
                    rsglobal.ZapiszDoLogow('nowa ',1)
                    ParTmp = eval(str(par))
                    for i in range(13):
                        # podstawiamy rne cyfry pod litery w stronie i dacie i dacie w numerze.
                        ParTmp[i] = ParTmp[i].replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                        try:
                            tmp = int(ParTmp[i])
                        except:
                            rsglobal.ZapiszDoLogow('Nienumeryczny '+str(i)+' parametr: '+str(ParTmp[i])+' w wierszu bazowym '+str(par),1)

                    LTrasN = []
                    rsglobal.ZapiszDoLogow('ParTmp '+str(ParTmp),1)
                    try:
                        DataN='20'+ParTmp[0]
                        DataN=DataN[:4]+'-'+DataN[4:6]+'-'+DataN[6:]
                        DataN2=''
                        OddzN='0'+chr(int(ParTmp[1]))
                        KoncowkaTrasyN=chr(int(ParTmp[2]))+chr(int(ParTmp[3]))
                        TrybN=chr(int(ParTmp[1]))+chr(int(ParTmp[4]))
                        NrN=ParTmp[5]
                        DataP=ParTmp[6]
                        DataP=DataP[:4]+'-'+DataP[4:6]+'-'+DataP[6:]
                        KontrP=chr(int(ParTmp[7]))+chr(int(ParTmp[8]))+chr(int(ParTmp[9]))+chr(int(ParTmp[10]))+chr(int(ParTmp[11]))
                        KontrP = KontrP.strip()
                        StronaP=ParTmp[12]
                        CzyOK=True
                    except:
                        continue


                # wersja z XXXX od 2016-10-01
                elif len(par) == 17:
                    rsglobal.ZapiszDoLogow('nowa 2016-10-01',1)
                    ParTmp = eval(str(par))
                    for i in range(17):
                        # podstawiamy rne cyfry pod litery w stronie i dacie i dacie w numerze.
                        ParTmp[i] = ParTmp[i].replace('I','1').replace('L','1').replace('l','1').replace('S','5').replace('B','8').replace('O','0').replace('Z','2').replace('C','0')
                        try:
                            tmp = int(ParTmp[i])
                        except:
                            rsglobal.ZapiszDoLogow('Nienumeryczny '+str(i)+' parametr: '+str(ParTmp[i])+' w wierszu bazowym '+str(par),1)

                    LTrasN = []
                    rsglobal.ZapiszDoLogow('ParTmp '+str(ParTmp),1)
                    try:
                        DataN='20'+ParTmp[0]
                        DataN=DataN[:4]+'-'+DataN[4:6]+'-'+DataN[6:]
                        DataN2=''
                        OddzN=chr(int(ParTmp[1]))+chr(int(ParTmp[2]))
                        TrasaN=chr(int(ParTmp[3]))+chr(int(ParTmp[4]))+chr(int(ParTmp[5]))+chr(int(ParTmp[6]))
                        TrybN=chr(int(ParTmp[7]))+chr(int(ParTmp[8]))
                        NrN=ParTmp[9]
                        DataP=ParTmp[10]
                        DataP=DataP[:4]+'-'+DataP[4:6]+'-'+DataP[6:]
                        KontrP=chr(int(ParTmp[11]))+chr(int(ParTmp[12]))+chr(int(ParTmp[13]))+chr(int(ParTmp[14]))+chr(int(ParTmp[15]))
                        KontrP = KontrP.strip()
                        StronaP=ParTmp[16]
                        CzyOK=True
                    except:
                        continue

            if DataN < '2016-10-01':
                # pobranie listy tras na podstawie oddziau i kocwki trasy
                from funkcje import fs_dowody_dostaw_pom

                rsglobal.ZapiszDoLogow('Bedzie lista  ' + str((OddzN, KoncowkaTrasyN)), 1)
                stat, LTrasN = fs_dowody_dostaw_pom.PodajTrasyDlaOddzialuZKoncowkiTras(self.PolSQL,self.firma_id,OddzN, KoncowkaTrasyN)
                rsglobal.ZapiszDoLogow('Lista tras  ' + str(LTrasN), 1)
                if stat <> 'OK':
                    stat = 'Bdy pobierania listy tras : ' + stat
                else:
                    TrasaT = " AND trasa IN ("+str(LTrasN)[1:-1]+") "

            else:
                TrasaT = " AND trasa='"+str(TrasaN)+"' "

            if stat=='OK': 
                # daty musz by prawie rwne (dopuszczalny jeden znak bdu.
                # jeli mam 2 nieznacznie rne daty to zakadam, e ktra jest poprawna i tylko jedna z nich.
                if not DataP==DataN:
                    if rsglobal.SprawdzCzyToData(DataP) and rsglobal.SprawdzCzyToData(DataN):
                        Blad=0
                        for i in range(len(DataN)):
                            if DataN[i]<>DataP[i]:
                                Blad+=1
                        if Blad>1:
                            CzyOK=False
                        else:
                            DataN2=DataP
                    else:
                        CzyOK=False
                rsglobal.ZapiszDoLogow('Czy OK1  '+str(CzyOK),1)
                # numer skada si z cyfr
                for znak in NrN:
                    if not znak in ('0','1','2','3','4','5','6','7','8','9'):
                        CzyOK=False
                rsglobal.ZapiszDoLogow('Czy OK2  '+str(CzyOK),1)
                # strona skada si z cyfr
                for znak in StronaP:
                    if not znak in ('0','1','2','3','4','5','6','7','8','9'):
                        CzyOK=False
                rsglobal.ZapiszDoLogow('Czy OK3  '+str(CzyOK),1)
                if not CzyOK:
                    continue
                
                # pobieramy kontrahenta dla potencjalnego dowodu
                SQL="SELECT TRIM(kontrahent_id),TRIM(trasa) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND oddzial_id='"+OddzN+"' "+TrasaT+ " AND data='"+DataN+"' AND tryb_dostawy='"+TrybN+"' AND numer="+NrN+";"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                rsglobal.ZapiszDoLogow('kontr  '+str(DTest),1)
                if stat<>'OK':
                    stat='Bdy pobierania danych z dowodw dostaw '+stat

            if stat=='OK':
                if DataN2<>'':
                    SQL="SELECT TRIM(kontrahent_id),TRIM(trasa) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
                    #AB190422
                    # SQL+=" AND oddzial_id='"+OddzN+"' "+Trasa+ " AND data='"+DataN2+"' AND tryb_dostawy='"+TrybN+"' AND numer="+NrN+";"
                    SQL+=" AND oddzial_id='"+OddzN+"' "+TrasaT+ " AND data='"+DataN2+"' AND tryb_dostawy='"+TrybN+"' AND numer="+NrN+";"
                    stat,DTest2,dump,dump = self.PolSQL.Execute(SQL,3)
                    rsglobal.ZapiszDoLogow('kontr2  '+str(DTest2),1)
                    if stat<>'OK':
                        stat='Bdy drugiego pobierania danych z dowodw dostaw '+stat
                    if stat=='OK':
                        # nie mona stwierdzi, ktra data jest ok
                        if len(DTest)>0 and len(DTest2)>0:
                            DTest=[]
                        elif len(DTest2)>0:
                            DTest=DTest2
                            DataN=DataN2
                            
            # jeli nie ma dowodu to zmieniamy tryb i sprawdzamy czy teraz jest.
            if stat=='OK' and len(DTest)==0:
                TrybN=TrybN[0]+TrybN[1].replace('1','I').replace('5','S').replace('8','B').replace('0','O').replace('2','Z')
                rsglobal.ZapiszDoLogow('Nowy tryb  '+str(TrybN),1)
                SQL="SELECT TRIM(kontrahent_id),TRIM(trasa) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND oddzial_id='"+OddzN+"' "+TrasaT+ " AND data='"+DataN+"' AND tryb_dostawy='"+TrybN+"' AND numer="+NrN+";"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                rsglobal.ZapiszDoLogow('kontrN1 '+str(DTest),1)
                if stat<>'OK':
                    stat='Bdy trzeciego pobierania danych z dowodw dostaw '+stat
            
                if stat=='OK':
                    if DataN2<>'':
                        SQL="SELECT TRIM(kontrahent_id),TRIM(trasa) FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND oddzial_id='"+OddzN+"' "+TrasaT+ " AND data='"+DataN2+"' AND tryb_dostawy='"+TrybN+"' AND numer="+NrN+";"
                        stat,DTest2,dump,dump = self.PolSQL.Execute(SQL,3)
                        rsglobal.ZapiszDoLogow('kontrN2 '+str(DTest2),1)
                        if stat<>'OK':
                            stat='Bdy czwartego pobierania danych z dowodw dostaw '+stat
                        if stat=='OK':
                            # nie mona stwierdzi, ktra data jest ok
                            if len(DTest)>0 and len(DTest2)>0:
                                DTest=[]
                            elif len(DTest2)>0:
                                DTest=DTest2
            
            if stat=='OK':
                # jeli nie znaleziono dowodu to kiszka
                if len(DTest)==0:
                    continue
                
                # porwnujemy kontrahenta z pobranym przez OCR. Dopuszczamy podmiany 5,S itd    
                
                KontrTest=DTest[0][0]
                TrasaN = DTest[0][1]
                
                if len(KontrP)<>len(KontrTest):
                    continue
                rsglobal.ZapiszDoLogow('Zostalo porownanie kontr',1)
                for i in range(len(KontrTest)):
                    if KontrP[i]<>KontrTest[i]:
                        if not (KontrP[i],KontrTest[i]) in [('I','1'),('1','I'),('L','1'),('1','L'),('l','1'),('1','l'),('S','5'),('5','S'),('B','8'),('8','B'),('O','0'),('0','O'),('Z','2'),('2','Z'),('Z','2'),('C','0'),('0','C')]:
                            CzyOK=False
                rsglobal.ZapiszDoLogow('Porwnanie OK: '+str(CzyOK),1)
                if not CzyOK:
                    continue
                
                # jeli tu jestemy to wszystkie testy przeszy i mamy dowd
                dane=[OddzN,TrasaN,DataN,TrybN,NrN,StronaP]

  
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (7)
#-------------------------------------------------------------------------------
    
if Fun==7:            
     # wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i uycie klucza przy wstawianiu do skanw
    if stat=='OK':
        SQL="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
        SQL="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
        SQL+="('"+self.firma_id+"','"+NazwaPliku+"','rs_dowody_dostaw_skany',FALSE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

    if stat=='OK':
        SQL="SELECT max(plik_id) FROM rs_pliki WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND tabela='rs_dowody_dostaw_skany' AND nazwa='"+NazwaPliku+"';"
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        NrPliku=str(DNum[0][0])
        #wstawiamy plik do bazy
        SQL="INSERT INTO rs_dowody_dostaw_skany (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,plik_id,strona) "
        SQL+= " VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Trasa+"','"+Data+"','"+Tryb+"',"+Numer+","+NrPliku+","+Strona+");"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

    if stat=='OK':
        #wrzucamy plik na serwer
        stat=fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,Tresc)

    if stat=='OK':
        # zaznaczamy na dowodzie dostaw e ma skany
        SQL="UPDATE rs_dowody_dostaw SET skan=TRUE"
        SQL+= " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"'"
        SQL+=" AND tryb_dostawy='"+Tryb+"'AND numer="+Numer+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

       
#-------------------------------------------------------------------------------
#---   POBRANIE NUMERU PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------
    
if Fun in [2,6]:
    if stat=='OK':
        SQL="SELECT plik_id FROM rs_dowody_dostaw_skany dds INNER JOIN rs_pliki p USING (plik_id) "
        SQL+=" WHERE dds.firma_id='"+self.firma_id+"' "
        SQL+=" AND dds.oddzial_id='"+Oddzial+"' AND dds.trasa='"+Trasa+"' AND dds.data='"+Data+"'"
        SQL+=" AND dds.tryb_dostawy='"+Tryb+"' AND dds.numer="+str(Numer)+" AND dds.strona="+str(Strona)
        SQL+=" AND p.nazwa='"+NazwaPliku+"';"
        stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat=='OK':
        if len(DPlik)==0:
            stat="Skan nie istnieje"
        else:
            NrPliku=DPlik[0][0]

 
#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if Fun==2:   
    if stat=='OK':
        stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,NrPliku)
        dane=[Tresc]    
            
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    if stat=='OK':
        # sprawdzamy istnienie katalogu
        wyn2=[]
        
        # sprawdzenie czy katalog istnieje. Jeli tak to usuwamy wpis w bazie, 
        # bo prawdopodobnie tego pliku ju nie ma na dysku. 
        # A jeli katalogu nie ma to zakadamy, e np. jest niezamontowany i zgaszamy bd
        if not os.path.exists(self.KatalogPlikow):
            stat='Brak dostpu do usuwanego pliku. Poinformuj serwis.'
        else:
            wyn2=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,NrPliku)
            if wyn2<>'OK':
                wyn2=['Fizyczny plik nie istnieje. Usunito powizanie w bazie danych.']
            else:
                wyn2=[]
        
    if stat=='OK':
        SQL="DELETE FROM rs_dowody_dostaw_skany WHERE plik_id='"+str(NrPliku)+"';" 
        SQL+="DELETE FROM rs_pliki WHERE plik_id='"+str(NrPliku)+"';" 
        # zaznaczamy na dowodzie dostaw informacj czy ma skany
        SQL+="UPDATE rs_dowody_dostaw SET skan= NOT ((SELECT DISTINCT firma_id FROM rs_dowody_dostaw_skany "
        SQL+=" WHERE firma_id=rs_dowody_dostaw.firma_id AND oddzial_id=rs_dowody_dostaw.oddzial_id "
        SQL+=" AND trasa=rs_dowody_dostaw.trasa AND data=rs_dowody_dostaw.data "
        SQL+=" AND tryb_dostawy=rs_dowody_dostaw.tryb_dostawy AND numer=rs_dowody_dostaw.numer) IS NULL)"
        SQL+= " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"'"
        SQL+=" AND tryb_dostawy='"+Tryb+"'AND numer="+Numer+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
  
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Fun in [5,6]) and (stat=='OK'):
    SQL="SELECT dds.strona, p.nazwa FROM rs_dowody_dostaw_skany dds INNER JOIN rs_pliki p "  
    SQL+=" USING (firma_id,plik_id)"
    SQL+=" WHERE dds.firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
    SQL+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+" ORDER BY dds.strona"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)