# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_tworzenie.py
# Purpose:     tworzy (automatycznie lub rcznie) nowe dowody dostaw
# Author:      Micha Raburski
# Created:     2007/05/22
# RCS-ID:      $Id: fs_dowody_dostaw_tworzenie.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
import rsglobal

# 2012.02.22 Micha Raburski     (5476) Tworzenie korekt z poziomw dostaw
# 2013-02-04 Mariusz Rajfura     (6479) Kontrola blokady wzgledem blokady zwrotow
# 2013-02-04 Mariusz Rajfura     (6480) tworzenie dd z zamowien: blokada: lista kth bez zamowien
# 2013-02-07 Mariusz Rajfura     (6515,6516) rsglobal.Dekoduj na kluczach slownikow
# 2020-12-18 Wojciech Skowron   (12220) Zmiana w tworzeniu uproszczonych dowodw dostaw
# 2020-12-28 Wojciech Skowron   (12233) Wyczenie sprawdzania nr rej (samochod) ze sownikiem
# 2021-01-04 Aleksander Bargie (12238) Uzgldnia oddzia przy pobieraniu cen do d.d.
# 2021-02-22 Aleksander Bargie (12347) [SP] Prawdopodobnie sie kursor le ustawia po dodaniu d.d.
# 2023-10-09 Aleksander Bargie (13577) Doda kontrol zakresw dat w dowodach dostaw

Trasa=rsglobal.Dekoduj(klucze[0])
DataDost=rsglobal.Dekoduj(klucze[1])
Tryb=rsglobal.Dekoduj(klucze[2])
Kier=rsglobal.Dekoduj(klucze[3])
Typ=rsglobal.Dekoduj(klucze[4])
NieSumowac=klucze[5]
Kontr=rsglobal.Dekoduj(klucze[6])
Wyzn=rsglobal.Dekoduj(klucze[7])
DataZam=rsglobal.Dekoduj(klucze[8])
NrZam=klucze[9]
PozOd=klucze[10]
PozDo=klucze[11]
Samochod=klucze[12]
Budowa=klucze[13]
DataDo=klucze[14]

Fun = klucze[-1]

#WS 2020-12-18
if Fun == 12:
    Przewoznik = klucze[15]
else:
    Przewoznik = ''

dane = []
stat = 'OK'
wyn1=[]
wyn2=[]

UprTworz= (self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'128012') in self.uprawnienia) 

#-------------------------------------------------------------------------------
# STWORZENIE KOREKT W OPARCIU O POZIOMY ZWROTW
#-------------------------------------------------------------------------------

if Fun==4:
    CzyCosDodano=False
    # pobranie listy kontrahentw i artykuw ktrych dotyczy tworzenie korekt
    SQL="SELECT TRIM(kontrahent_id),TRIM(oddzial_id),TRIM(artykul_id),procent_zwrotow"
    SQL+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id IN ('"+self.oddzial_id+"','**') AND kontrahent_id IS NOT NULL"
    SQL+=" AND NOT artykul_id IS NULL AND tworzyc_korekty"
    SQL+=" ORDER BY kontrahent_id,oddzial_id,artykul_id;"

    stat,DPoziomy,none,none = self.PolSQL.Execute(SQL,2)
    if stat != 'OK':
        stat = 'Bd pobrania danych o poziomach zwrotw dla kontrahentw: '+stat
    elif len(DPoziomy)==0:
        stat = 'Brak kontrahentw do tworzenia korekt'
    
    if stat=='OK':
        # wyrzucenie niepotrzebnych gwiazdek z oddziaw
        SKontr={}
        for poz in DPoziomy:
            Kontr=poz[0]
            Art=poz[2]
            Poziom=poz[3]
            
            klucz=(Kontr,Art)
            
            # jeli oddzia to dokadny oddzia lub nie istnieje wpis to wstawiamy
            # mamy pewno e oddzia dokadny nadpisze ** w razie czego, ale nie odwrotnie
            if poz[1]==self.oddzial_id.strip() or not klucz in SKontr:
                SKontr[klucz]=[Poziom]
            
            

        # dla kadego kontrahenta/artykuu liczymy oddzielnie - czyli kadej pozycji z poziomu zwrotw.
        # dla jednego kontrahenta bdziemy tworzy kilka dowodw dostawy (zalenie od trasy i trybu dostawy)
        # liczc na to, e bedzie kilka artykuw w kadym z nich
        KluczeKontrahentow=SKontr.keys()
        KluczeKontrahentow.sort()
        STrasyTryby={}
        for kontrart in KluczeKontrahentow:
            if stat=='OK':
                # pobieramy pozycje dowodw dostaw dotyczcych kontrahenta i oddziau i wybranego artykuu
                # dane s ustawione dniami od koca
                SQL=" SELECT ddp.data,ddp.trasa,ddp.tryb_dostawy,ddp.ilosc_dost1,ddp.ilosc_zwr1,ddp.ilosc_zwr2," # 0-5
                SQL+=" ddp.cena_netto1,ddp.cena_netto2,ddp.cena_upust1,ddp.cena_upust2," # 6-9
                SQL+=" ddp.cena_brutto1,ddp.cena_brutto2,ddp.stawka_vat,dd.kierowca,dd.platnik_id,a.przelicznik " # 10-15
                SQL+=" FROM rs_dowody_dostaw_pozycje ddp INNER JOIN rs_dowody_dostaw dd "
                SQL+=" USING (firma_id,oddzial_id, trasa, data, tryb_dostawy, numer) "
                SQL+=" INNER JOIN rs_artykuly a ON (ddp.firma_id=a.firma_id AND ddp.artykul_id=a.artykul_id) "
                SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+self.oddzial_id+"' "
                SQL+=" AND ddp.data>='"+DataDost+"' AND ddp.data <='"+DataDo+"' "
                SQL+=" AND ddp.artykul_id='"+kontrart[1]+"' AND dd.stan::INT>1 AND dd.kontrahent_id='"+kontrart[0]+"'"
                SQL+=" ORDER BY ddp.data DESC;"
                stat,DPozycje,none,none = self.PolSQL.Execute(SQL,2)
                if stat != 'OK':
                    stat = 'Bd pobrania danych pozycji dowodw dostaw: '+stat
                
            if stat=='OK':
                # sumujemy wartosc dostaw i warto zwrotw. Jeli poziom zwrotw zosta przekroczony to
                # umieszczamy tyle ujemnych zwrotw w dowodach dostaw ile konieczne by uregulowa
                # przekroczone zwroty
                SumaDost=0 
                SumaZwr=0 
                KwotaDoZwr=0
                Poziom=SKontr[kontrart][0]
                LPozPrzekroczone=[]
                for poz in DPozycje:
                    SumaDost+=rsglobal.RSRound(poz[3]*poz[8],2)
                    SumaZwr+=rsglobal.RSRound(poz[4]*poz[8],2)
                
                if SumaDost>0:
                    if rsglobal.RSRound((SumaZwr/SumaDost)*100,2)>Poziom:
                        KwotaDoZwr=SumaZwr-rsglobal.RSRound((SumaDost*Poziom)*0.01,2)
                
                # jeszcze raz przelatujemy pozycje w celu zdjcia zwrotw
                if KwotaDoZwr>0:
                    for poz in DPozycje:
                        if KwotaDoZwr>0:
                            WartPoz=rsglobal.RSRound(poz[4]*poz[8],2)
                            if WartPoz>0:
                                if KwotaDoZwr-WartPoz>0:
                                    LPozPrzekroczone.append(eval(str(poz)))
                                    KwotaDoZwr=KwotaDoZwr-WartPoz
                                else:
                                    PozTmp=eval(str(poz))
                                    Cena=poz[8]
                                    IloscTmp=0
                                    while KwotaDoZwr-rsglobal.RSRound(IloscTmp*Cena,2)>0 and IloscTmp<poz[4]:
                                        IloscTmp+=1
                
                                    if IloscTmp<poz[4]:
                                        PozTmp[4]=IloscTmp
                                        PozTmp[5]=rsglobal.RSRound(IloscTmp*poz[15],4)
                                    LPozPrzekroczone.append(eval(str(PozTmp)))
                                    KwotaDoZwr=0
                
                
                # mamy dane zebrane dla artykuu i je rozkadamy po trasach i trybach
                for poz in LPozPrzekroczone:
                    # kontrahent, trasa, tryb, kierowca, artykul, vat, cena_netto1, cena_upust1,cena_brutto1
                    klucz=(kontrart[0],poz[1],poz[2],poz[13],kontrart[1],poz[12],poz[6],poz[8],poz[10])
                    if klucz in STrasyTryby:
                        # jest ju artyku i dodajemy tylko iloci do ponownego dostarczenia
                        STrasyTryby[klucz][0]+=poz[4]
                        STrasyTryby[klucz][1]+=poz[5]
                        # uzupenienie ostatnim patnikiem
                        STrasyTryby[klucz][5]=poz[14]
                    else:
                        # wstawiamy now pozycj do STrasyTryby - ilosci i ceny 2 i patnik
                        STrasyTryby[klucz]=[poz[4],poz[5],poz[7],poz[9],poz[11],poz[14]]

        
        # przeanalizowalimy wszystkie artykuy wszystkich kontrahentw i zapisujemy dowody dostaw
        # ustawiamy dane po kolei kontrahentem/tras/trybem. Std tworzymy po kolei dowody dostaw
        if stat=='OK':
            Klucze=STrasyTryby.keys()
            Klucze.sort()
            
            KontrAkt=''
            TrasaAkt=''
            TrybAkt=''
            KierAkt=''
            for klucz in Klucze:
                if stat=='OK':
                    poz=STrasyTryby[klucz]
                    
                    if KontrAkt!= klucz[0] or TrasaAkt!=klucz[1] or TrybAkt!=klucz[2] or KierAkt!=klucz[3]:
                        # wstawienie nagwka dowodu dostawy - wiemy e zmieni si kontrahent, trasa, tryb lub kierowca
                        
                        # pobranie numeru i stanu nowego dowodu dostawy
                        SQL="SELECT CASE WHEN stan IN ('0','1','2') THEN stan ELSE '2' END,MAX(numer) "
                        SQL+=" FROM rs_dowody_dostaw "
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
                        SQL+=" AND trasa='"+klucz[1]+"' AND data='"+DataDo+"' AND tryb_dostawy='"+klucz[2]+"'"
                        SQL+=" GROUP BY CASE WHEN stan IN ('0','1','2') THEN stan ELSE '2' END ORDER BY MAX(numer) DESC;"
                        stat,DNrDost,none,none = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':
                            stat = 'Bd pobrania danych o numerze dowodu dostawy: '+stat
                        
                        if stat=='OK':
                            if len(DNrDost)==0:
                                Stan='2'
                                Numer=1
                            else:
                                Stan=DNrDost[0][0]
                                Numer=DNrDost[0][1]+1
                               
                            # wstawienie dowodu dostawy
                            SQL=" INSERT INTO rs_dowody_dostaw (firma_id,oddzial_id,trasa,data,"
                            SQL+=" tryb_dostawy,numer,stan,kontrahent_id,platnik_id,"
                            SQL+=" czy_automatycznie,kierowca,korekta) "
                            SQL+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+klucz[1]+"','"+DataDo+"',"
                            SQL+=" '"+klucz[2]+"',"+str(Numer)+",'"+Stan+"','"+klucz[0]+"','"+poz[5]+"'"
                            SQL+=" ,TRUE,'"+klucz[3]+"',TRUE);"

                            stat,none,none,none = self.PolSQL.Execute(SQL,1)
                            if stat<>'OK':
                                stat="Bd wstawiania nagwka dowodu dostawy:"+stat
                            else:
                                NrPoz=1
                                KontrAkt=klucz[0]
                                TrasaAkt=klucz[1]
                                TrybAkt=klucz[2]
                                KierAkt=klucz[3]
                
                if stat=='OK':
                    # wstawienie pozycji do aktualnego dowodu
                    CzyCosDodano=True
                    SQL="INSERT INTO rs_dowody_dostaw_pozycje (firma_id,oddzial_id,trasa,data,"
                    SQL+=" tryb_dostawy,numer,nr_poz,artykul_id,ilosc_zwr1,ilosc_zwr2,"
                    SQL+="cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
                    SQL+="cena_brutto1,cena_brutto2,stawka_vat)"
                    SQL+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+klucz[1]+"','"+DataDo+"',"
                    SQL+=" '"+klucz[2]+"',"+str(Numer)+",'"+str(NrPoz)+"','"+klucz[4]+"',"+str(-1*poz[0])+","+str(-1*poz[1])+","
                    SQL+=str(klucz[6])+","+str(poz[2])+","+str(klucz[7])+","+str(poz[3])+","
                    SQL+=str(klucz[8])+","+str(poz[4])+",'"+klucz[5]+"');"

                    stat,none,none,none = self.PolSQL.Execute(SQL,1)
                    if stat<>'OK':
                        stat='Bd wstawiania pozycji dowodu dostawy :'+stat
                    
                    if stat=='OK':
                        NrPoz+=1

        # jeli nic nie dodano to przypomnie o wpisaniu artykuu
        if stat=='OK':
            if not CzyCosDodano:
                stat=' Nie dodano adnych korekt dowodw dostaw. Jeli podejrzewasz, e korekty powinny si utworzy to sprawdz czy w poziomach zwrotw s wpisane odpowiednie artykuy dla kontrahenta.'

#-------------------------------------------------------------------------------
# POBRANIE DANYCH DO MASOWEGO AUTOMATYCZNEGO DODANIA DOWODOW
#-------------------------------------------------------------------------------

if Fun ==11:
    if stat=='OK':
        if DataDost == '   -  -  ':
            stat='BR DATA'
        else:
            if not rsglobal.SprawdzCzyToData(DataDost):
                stat = "BL DATA"    
                
    if stat=='OK':
        if Typ == '':
            stat='BR TYP'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_typy_zamowien WHERE firma_id = '"+self.firma_id+"' AND kod='"+Typ+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL TYP"
            else:
                stat = 'Bdy przy selekcie trybu zamwienia :'+stat
                dane.append(stat)     
    if stat=='OK':
        Filtr=" firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND dz_0"+str(rsglobal.PodajNrDniaTygodnia(DataDost,3))
        if Trasa != '':
            Filtr+=" AND trasa='"+Trasa+"'"
        if Tryb != '':
            Filtr+=" AND tryb_dostawy='"+Tryb+"'"
        if Kier != '':
            Filtr+=" AND kierowca='"+Kier+"'"

        stat,dane,dump,dump = self.PolSQL.Execute("SELECT kierowca,trasa,tryb_dostawy FROM rs_lista_tras WHERE "+Filtr+";" ,3)
        if stat=='OK':
            if len(dane)==0:
                stat='BR NAGL'
        else:
             stat = 'Bdy przy pobieraniu danych z listy tras :'+stat
             dane.append(stat)


#-------------------------------------------------------------------------------
# SPRAWDZENIE POPRAWNOCI DANYCH DO AUTOMATYCZNEGO GENEROWANIA DOWODW DOSTAW
#-------------------------------------------------------------------------------

if Fun in [1,2]:
    if Trasa == '':
        stat='BR TRASA'
    else:
        stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_trasy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"' AND kod='"+Trasa+"';" ,3)
        if stat == 'OK':
            if len(d) == 0:
                stat = "BL TRASA"
        else:
            stat = 'Bdy przy selekcie tasy :'+stat
            dane.append(stat)
    if stat=='OK':
        if DataDost == '   -  -  ':
            stat='BR DATA'
        else:
            if not rsglobal.SprawdzCzyToData(DataDost):
                stat = "BL DATA"

    if stat=='OK':
        if Tryb == '':
            stat='BR TRYB'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_tryby_dostaw WHERE firma_id = '"+self.firma_id+"' AND kod='"+Tryb+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL TRYB"
            else:
                stat = 'Bdy przy pobieraniu trybu :'+stat
                dane.append(stat)
    if stat=='OK':        
        if Kier == '':
            stat='BR KIER'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_kierowcy WHERE firma_id = '"+self.firma_id+"' AND kod='"+Kier+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL KIER"
            else:
                stat = 'Bdy przy pobieraniu kodu kierowcy :'+stat
                dane.append(stat)
    if stat=='OK':
        if Typ == '':
            stat='BR TYP'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_typy_zamowien WHERE firma_id = '"+self.firma_id+"' AND kod='"+Typ+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL TYP"
            else:
                stat = 'Bdy przy pobieraniu typu zamwienia :'+stat
                dane.append(stat)
    if stat=='OK' and Fun ==1:
        stat,d,dump,dump = self.PolSQL.Execute("SELECT stan FROM rs_dowody_dostaw WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+DataDost+"' AND tryb_dostawy='"+Tryb+"';" ,3)
        if stat == 'OK':
            if len(d) > 0:
                if d[0][0]=='0':
                    stat = "PYT"
                else:
                    stat = "BL STAN"
        else:
             stat = 'Bdy przy pobieraniu stanu dow. dostaw :'+stat
             dane.append(stat)
             
    if stat=='OK':
        Select="SELECT stan FROM rs_dowody_dostaw WHERE firma_id = '"+self.firma_id+"' "
        Select+="AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+DataDost+"' "
        Select+="AND tryb_dostawy='"+Tryb+"' AND stan>0::text;"
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)        
        if stat == 'OK':
            if len(d)>0:
                stat = "Trasa zostaa ju zamknita."
                dane.append(stat)
        else:
             stat = 'Bdy przy pobieraniu stanu :'+stat
             dane.append(stat)        
                
#-------------------------------------------------------------------------------
# POBRANIE DANYCH DO UPROSZCZONEGO TWORZENIA DOWODOW
#-------------------------------------------------------------------------------

if Fun == 12 and stat=='OK':
    
    DaneUTD=[]
    #pobranie trasy
    stat,DaneT,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_trasy WHERE firma_id = '"+self.firma_id+"' ORDER BY kod LIMIT 1;",3)
    if stat<>'OK':
        stat='BL TR'
    if stat=='OK':
        if len(DaneT)==0:
            stat='BR TR'
    if stat=='OK':
        TrasaU=DaneT[0][0]
        if TrasaU.strip() in (None,'','None'):
            stat='BR TR' 
        else:
            DaneUTD.append(TrasaU)
   #pobranie typu
    if stat=='OK':
        stat,DaneTP,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_typy_zamowien  WHERE firma_id = '"+self.firma_id+"' ORDER BY kod LIMIT 1;",3)
        if stat<>'OK':
            stat='BL TP'
        if stat=='OK':
            if len(DaneTP)==0:
                stat='BR TP'
        if stat=='OK':
            TypU=DaneTP[0][0]
            if TypU.strip() in (None,'','None'):
                stat='BR TP' 
            else:
                DaneUTD.append(TypU)
    #pobranie trybu
    if stat=='OK':
        stat,DaneTB,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_tryby_dostaw  WHERE firma_id = '"+self.firma_id+"' ORDER BY kod LIMIT 1;",3)
        if stat<>'OK':
            stat='BL TB'
        if stat=='OK':
            if len(DaneTB)==0:
                stat='BR TB'
        if stat=='OK':
            TrybU=DaneTB[0][0]
            if TrybU.strip() in (None,'','None'):
                stat='BR TB' 
            else:
                DaneUTD.append(TrybU)
    #WS 2020-12-18
    # #pobranie daty z serwera
    # if stat=='OK':
    #     stat,DaneDT,dump,dump = self.PolSQL.Execute("SELECT CURRENT_DATE;",3)
    #     if stat<>'OK':
    #         stat='BL DT'
    #     if stat=='OK':
    #         if len(DaneDT)==0:
    #             stat='BL DT'
    #     if stat=='OK':
    #         DataU=DaneDT[0][0]
    #         if DataU in (None,'','None','    -  -  '):
    #             stat='BL DT'
    #         else:
    #             DaneUTD.append(DataU)
    
    # SPRAWDZANIE DANYCH KIEROWCY
    if stat=='OK':        
        if Kier.strip() == '':
            stat='BR KIER'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_kierowcy WHERE firma_id = '"+self.firma_id+"' AND kod='"+Kier+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL KIER"
            else:
                stat = 'Bdy przy pobieraniu kierowcy :'+stat
                dane.append(stat)
    # SPRAWDZENIE DANYCH ODBIORCY
    if stat=='OK' and Fun==12:
        if Kontr.strip() == '':
            stat='BR KONTR'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id,aktywny FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL KONTR"
                elif not d[0][1]:
                    stat = "NAKT KONTR"
            else:
                stat = 'Bdy przy pobieraniu id odbiorcy :'+stat
                dane.append(stat)
    #WS 2020-12-28 - wyczenie sprawdzania nr rej (samochod) ze sownikiem
    #WS 2020-12-18
    # SPRAWDZENIE DANYCH SAMOCHODU
    if stat == 'OK':
        if Samochod.strip() == '':
            stat='BR SAMOCHOD'
    #     else:
    #         stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_samochody WHERE firma_id = '"+self.firma_id+"' AND kod='"+Samochod+"';", 3)
    #         if stat == 'OK':
    #             if len(d) == 0:
    #                 stat = "BL SAMOCHOD"
    #         else:
    #             stat = 'Bdy przy pobieraniu id samochodu :'+stat
    #WS 2020-12-18
    # SPRAWDZENIE DANYCH PRZEWONIKA
    if stat == 'OK':
        if Przewoznik.strip() == '':
            stat='BR PRZEW'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id,aktywny FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id='"+Przewoznik+"';", 3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = "BL PRZEW"
                elif not d[0][1]:
                    stat = "NAKT PRZEW"
            else:
                stat = 'Bdy przy pobieraniu id przewonika :'+stat
                dane.append(stat)
             
                 
#-------------------------------------------------------------------------------
# SPRAWDZENIE POPRAWNOCI POZOSTAYCH DANYCH DO RCZNEGO GENEROWANIA DOWODW DOSTAW I WSTAWIENIE DANYCH
#-------------------------------------------------------------------------------

if Fun in [2] and stat=='OK':
    if Kontr == '':
        stat='BR KONTR'
    else:
        stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id,aktywny FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';" ,3)
        if stat<>"OK":
             stat = 'Bdy przy pobieraniu kontrahenta :'+stat
             dane.append(stat)
        if stat == 'OK':
            if len(d) == 0:
                stat = "BL KONTR"
            elif not d[0][1]:
                stat = "NAKT KONTR"

    if stat=='OK' and (Wyzn != '' or DataZam<>'    -  -  ' or NrZam !=0 or PozOd != 0 or PozDo !=0):
        if DataZam in ('','    -  -  ',None):
            stat='BL DATAZAM'
            
        if stat=='OK':
            SQL="SELECT czy_stale,zamowienie_nr,waluta FROM rs_zamowienia_odbiorcy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+DataZam+"' AND numer="+str(NrZam)+";"
            stat,DZam,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat == 'OK':
                if  len(DZam) == 0:
                    stat = "BL ZAM"
                elif DZam[0][0]:
                    stat="ZAM STALE"
    else:
        DZam=[]

#-------------------------------------------------------------------------------
# pobranie cen dla kontrahenta/artykuu na dzie z dowodw dostaw na potrzeby kontroli.
#-------------------------------------------------------------------------------

if Fun in [2,5,12] and stat=='OK':            
    #klucz to kontrahent,waluta,artykul a wynik to cena_netto1
    SCeny={}
    SQL="SELECT DISTINCT dd.kontrahent_id,COALESCE(z.waluta,'PLN'),dp.artykul_id,dp.cena_upust1,z.waluta"
    SQL+=" FROM rs_dowody_dostaw_pozycje dp INNER JOIN rs_dowody_dostaw dd "
    SQL+="ON (dd.firma_id=dp.firma_id AND  dd.oddzial_id=dp.oddzial_id AND dd.trasa=dp.trasa"
    SQL+=" AND dd.data=dp.data AND dd.tryb_dostawy=dp.tryb_dostawy AND  dd.numer=dp.numer) "
    SQL+=" LEFT OUTER JOIN rs_zamowienia_odbiorcy z ON (dd.firma_id=z.firma_id "
    SQL+=" AND dd.z_wyznacznik_id=z.wyznacznik_id AND dd.z_data=z.data AND dd.z_numer=z.numer) "
    SQL+=" WHERE dp.firma_id='"+self.firma_id+"'AND dp.oddzial_id='"+self.oddzial_id+"' AND dp.data='"+DataDost+"'"
    SQL+=" AND (NOT dd.korekta OR dd.korekta IS NULL);"
    # nie sprawdzaj jeli to wywoanie bez podanej daty
    if DataDost:
        stat,DCeny,dump,dump=self.PolSQL.Execute(SQL,3)    
        if stat=='OK':
            for d in DCeny:
                SCeny[(rsglobal.Dekoduj(d[0]).strip(),rsglobal.Dekoduj(d[1]).strip(),rsglobal.Dekoduj(d[2]).strip())]=d[3]


#-------------------------------------------------------------------------------
# WYKONANIE AUTOMATYCZNEGO GENEROWANIA DOWODW DOSTAW Z ZAMWIE 
#-------------------------------------------------------------------------------

if Fun==5 and stat=='OK':
    #zablokowanie trasy na ktrej dziaamy przy tworzeniu dowodw dostaw
    stat,dane,w1,w2=self.PolSQL.Execute("SELECT * FROM rs_trasy WHERE firma_id='"+self.firma_id+"' AND kod='"+Trasa+"' FOR UPDATE NOWAIT;",3)
    if stat!= 'OK':
        stat="TRASA UZ"

    if stat=='OK':
        if not UprTworz:
            stat="Brak uprawnie do dodawania dowodw dostaw"
            
    if stat=='OK':
        # sprawdzenie czy z usuwanych dowodw dostaw nic nie jest wanie rozstawione
        SQL="SELECT * FROM rs_dowody_dostaw_pozycje "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' "
        SQL+="AND trasa='"+Trasa+"' AND data='"+DataDost+"' AND tryb_dostawy='"+Tryb+"' "
        SQL+=" AND ilosc_wysw1 != 0 LIMIT 1; "
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat='Bd pobierania informacji o wywietlaniu danych na wywietlaczach'
        elif len(DTest)>0:
            stat='Nie mona usun dowodw dostaw  przed tworzeniem ich od nowa poniewa niektre z ich pozycji s wywietlone na wywietlaczach'
            
    if stat=='OK':
        #usunicie starych dowodw dostaw
        stat, none, none, none = self.PolSQL.Execute(" DELETE FROM rs_dowody_dostaw WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+DataDost+"' AND tryb_dostawy='"+Tryb+"';" ,1)
        if stat<>"OK":
             stat = 'Bdy przy usuwaniu starych dowodw :'+stat
             dane.append(stat)
             
    if stat == 'OK':
        #pobranie odbiorcw na trasie
        SQL="SELECT DISTINCT kt.kontrahent_id FROM rs_kontrahenci_trasy kt "
        SQL+=" INNER JOIN rs_trasy t ON (kt.firma_id=t.firma_id AND kt.trasa=t.kod) "
        SQL+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=kt.firma_id AND k.kontrahent_id=kt.kontrahent_id) "
        SQL+=" WHERE kt.firma_id = '"+self.firma_id+"' AND kt.trasa='"+Trasa+"'"
        SQL+=" AND kt.data_od <='"+DataDost+"' AND (kt.data_do >='"+DataDost+"' or kt.data_do IS NULL)"
        SQL+=" AND t.oddzial_id='"+self.oddzial_id+"' AND k.aktywny ORDER BY kontrahent_id;"
        stat,DKontr,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat<>"OK":
            stat = 'Bdy przy pobieraniu odbiorcw :'+stat
            dane.append(stat)
        if stat == 'OK':
            if len(DKontr) == 0:
                stat = "BR KT"

    if stat=='OK':
        # slownik kontrahentow dla danej trasy, licznik dodanych zamowien
        SKontrTrasa = {}
        
        # slownik kontrahentow na trasie, ktorzy maja blokade, licznik opuszczonych zamowien
        SKontrBlok = {}

        # pobranie kontrahentow z listy odbiorcow na trasie
        ListaK = "("
        for i in xrange(len(DKontr)):
            if i > 0:
                ListaK += ","
            ListaK += "'"+rsglobal.Dekoduj(DKontr[i][0])+"'"
        ListaK += ")"
        
        sql ="SELECT kontrahent_id,nazwa,zablokowany FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id IN "+ListaK+";"
        
        stat,KontrBlok,dump,dump = self.PolSQL.Execute(sql,3)
        
        rsglobal.ZapiszDoLogow("mariusz 1: "+str(sql),1)
        rsglobal.ZapiszDoLogow("mariusz 2: "+str(KontrBlok),1)
        
        if stat != 'OK':
            stat = 'Bd pobrania danych dla kontrahentw z trasy: '+stat
        else:
            for i in xrange(len(KontrBlok)):
                # kontrahent z trasy z opisem
                SKontrTrasa[rsglobal.Dekoduj(KontrBlok[i][0])] = [KontrBlok[i][1],0]
                
                # jesli kontrahent aktualnie zablokowany
                if KontrBlok[i][2]:
                    SKontrBlok[rsglobal.Dekoduj(KontrBlok[i][0])] = [KontrBlok[i][1],0]
            
            rsglobal.ZapiszDoLogow("mariusz 3: "+str(SKontrTrasa),1)
            rsglobal.ZapiszDoLogow("mariusz 4: "+str(SKontrBlok),1)
        
    if stat=='OK':
        LKontr=[]
        for kontr in DKontr:
            LKontr.append(rsglobal.Dekoduj(kontr[0]))
        LKontr=str(LKontr)[1:-1]
        
        #pobranie wszystkich zamwie pasujcych do wzorca
        PolePlatnik="(SELECT platnik_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
        PolePlatnik+=" AND kontrahent_id=rs_zamowienia_odbiorcy.kontrahent_id)"
        SQL="SELECT wyznacznik_id,data,numer,czy_stale,kontrahent_id,"+PolePlatnik+",zamowienie_nr,waluta,zamowienie_data FROM rs_zamowienia_odbiorcy "
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND (typ_zamowienia='"+Typ+"' OR NOT czy_stale) AND (dostawy_od_dnia <='"+DataDost+"' OR dostawy_od_dnia IS NULL) AND (dostawy_do_dnia >='"+DataDost+"' OR dostawy_do_dnia IS NULL) AND kontrahent_id IN ("+str(LKontr)+") ORDER BY kontrahent_id;"
        stat,DZam,dump,dump = self.PolSQL.Execute(SQL ,3)

        rsglobal.ZapiszDoLogow("mariusz 5: "+str(SQL),1)
        rsglobal.ZapiszDoLogow("mariusz 6: "+str(DZam),1)
        
        if stat<>"OK":
             stat = 'Bdy przy pobieraniu zamwie :'+stat
             dane.append(stat)
        if stat=='OK':
            if len(DZam) == 0:
                # UWAGA: kod 'BR ZAM' jest na koncu Fun==5 traktowany jak 'OK'. Patrz na koniec funkcji
                stat = "BR ZAM"
        
    #robimy kolejne zamwienia
    if stat=='OK':
        Ile=0
        
        #pobieramy aktualnie najwiekszy numer dowodu dostawy
        for Zam in DZam:
            if stat=='OK':
                SPalety = {}
                
                #wygenerowanie nagwka
                Warunek = "firma_id=\\'"+self.firma_id+"\\' AND oddzial_id=\\'"+self.oddzial_id+"\\' AND trasa=\\'"+Trasa+"\\' AND data=\\'"+DataDost+"\\' AND tryb_dostawy=\\'"+Tryb+"\\'"
                Select = "SELECT rsf_klucz_where_new('rs_dowody_dostaw','"+Warunek+"','numer');"
                stat,DNr,dump,dump = self.PolSQL.Execute(Select,3)
                if stat != 'OK':
                    continue
                NrDost=DNr[0][0]
                WyznZ=rsglobal.Dekoduj(Zam[0])
                DataZ=rsglobal.Dekoduj(Zam[1])
                NrZ=Zam[2]
                Kontr=rsglobal.Dekoduj(Zam[4])
                Plat=rsglobal.Dekoduj(Zam[5])
                
                # jesli zamowienie dla kontrahenta zablokowanego
                # to powiekszamy licznik jego pominietych zamowien i pomijamy to zamowienie
                if Kontr in SKontrBlok:
                    SKontrBlok[Kontr][1] += 1
                    continue
                else:
                    rsglobal.ZapiszDoLogow("mariusz 7: "+str(Kontr),1)
                
                # zamowienie tworzy dowod wiec powiekszamy licznik dla kontrahenta
                if Kontr in SKontrTrasa:
                    SKontrTrasa[Kontr][1] += 1
                else:
                    rsglobal.ZapiszDoLogow("mariusz 8: "+str(Kontr),1)
                
                if Plat in ('','None',None):
                    Plat=Kontr 
                NrZamD=rsglobal.Dekoduj(Zam[6])
                if NrZamD in ('None',None):
                    NrZamD=''
                Waluta=rsglobal.Dekoduj(Zam[7])
                if Zam[8] in (None,'None','    -  -  '):
                    ZamData='NULL'
                else:
                    ZamData="'"+rsglobal.Dekoduj(Zam[8])+"'"
                    
                #sprawdzenie daty/numeru zamwienia zewntrznego w tabeli z datami
                WarDNrDaty="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznZ+"' AND data='"+DataZ+"' AND numer="+str(NrZ)+" AND zamowienie_na_kiedy='"+DataDost+"';"
                stat,DNrDaty,dump,dump = self.PolSQL.Execute("SELECT zamowienie_nr,zamowienie_data FROM rs_zamowienia_odbiorcy_daty "+WarDNrDaty,3)
                if stat<>"OK":
                    stat = 'Bdy przy pobieraniu danych zamwienia :'+stat
                    dane.append(stat)
                if stat == 'OK':
                    if len(DNrDaty)>0:
                        NrZamD=rsglobal.Dekoduj(DNrDaty[0][0])
                        if NrZamD in ('None',None):
                            NrZamD=''
                        if DNrDaty[0][1] not in (None,'None','    -  -  '):
                            ZamData="'"+rsglobal.Dekoduj(DNrDaty[0][1])+"'"
                            
                    SQLN="INSERT INTO rs_dowody_dostaw (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,"
                    SQLN+="kontrahent_id,platnik_id,kierowca,f_wyznacznik_id,f_data,f_numer,z_wyznacznik_id,z_data,z_numer,"
                    SQLN+="dowod_zwrotu,numer_zamowienia,czy_automatycznie,stan,data_zamowienia,samochod) "
                    SQLN+="VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+DataDost+"','"+Tryb+"',"+str(NrDost)+", "
                    SQLN+="'"+Kontr+"','"+Plat+"','"+Kier+"',NULL,NULL,NULL,'"+WyznZ+"','"+DataZ+"',"+str(NrZ)+","
                    SQLN+="'','"+NrZamD+"',TRUE,0,"+ZamData+",'"+Samochod+"');"
                    
                    # sprawdzenie czy kontrahent lub patnik ma wczone sortowanie po artykule obcym
                    SQLKontr="SELECT rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"',"
                    SQLKontr+="'"+Kontr+"','"+DataDost+"','sort_wg_symboli_obcych'),"
                    SQLKontr+="rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"',"
                    SQLKontr+="'"+Plat+"','"+DataDost+"','sort_wg_symboli_obcych');"
                    stat,DSort,dump,dump = self.PolSQL.Execute(SQLKontr,3)
                    if stat<>"OK":
                        stat = 'Bdy przy pobieraniu danych o sortowaniu kontrahentw :'+stat
                        dane.append(stat)
                if stat=='OK':
                    SortWgObcych=''
                    if len(DSort)>0:
                        if DSort[0][0]=='true':
                            SortWgObcych='K'
                        if DSort[0][1]=='true':
                            SortWgObcych+='P'
                    
                #-----------------
                #zamwienia stae
                #-----------------
                if Zam[3] and stat=='OK':
                    if NieSumowac:
                        SQL="SELECT zs.artykul_id,rsf_podaj_vat_artykulu(zs.firma_id,zs.artykul_id,'"+DataDost+"'),a.przelicznik,zs.dz_00+zs.dz_0"+str(rsglobal.PodajNrDniaTygodnia(DataDost,3))
                    else:
                        SQL="SELECT zs.artykul_id,rsf_podaj_vat_artykulu(zs.firma_id,zs.artykul_id,'"+DataDost+"'),a.przelicznik,SUM(zs.dz_00+zs.dz_0"+str(rsglobal.PodajNrDniaTygodnia(DataDost,3))+")"
                    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_stale zs INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                    if 'K' in SortWgObcych:
                        SQL+=" LEFT OUTER JOIN rs_artykuly_obce aok ON (zs.firma_id=aok.firma_id "
                        SQL+=" AND zs.artykul_id=aok.artykul_id AND aok.kontrahent_id='"+Kontr+"')"
                    if 'P' in SortWgObcych:
                        SQL+=" LEFT OUTER JOIN rs_artykuly_obce aop ON (zs.firma_id=aop.firma_id "
                        SQL+=" AND zs.artykul_id=aop.artykul_id AND aop.kontrahent_id='"+Plat+"')"
                    SQL+=" WHERE zs.firma_id='"+self.firma_id+"' AND zs.wyznacznik_id='"+WyznZ+"' AND zs.data='"+DataZ+"' AND zs.numer="+str(NrZ)
                    SQL+=" AND (zs.data_od <= '"+DataDost+"' OR zs.data_od IS NULL) AND (zs.data_do >='"+DataDost+"' OR zs.data_do IS NULL) "
                    SQL+=" AND tryb_dostawy='"+Tryb+"' AND a.aktywny "
                    if not NieSumowac:
                        SQL+=" GROUP BY zs.firma_id,zs.artykul_id,rsf_podaj_vat_artykulu(zs.firma_id,zs.artykul_id,zs.data::TEXT),a.przelicznik"
                        if SortWgObcych=='K':
                            SQL+=",COALESCE(aok.obcy_id,'')"
                        elif SortWgObcych=='P':
                            SQL+=",COALESCE(aop.obcy_id,'')"
                        elif SortWgObcych=='KP':
                            SQL+=",COALESCE(aok.obcy_id,aop.obcy_id,'')"                                            
                    
                    if SortWgObcych=='':
                        SQL+=" ORDER BY zs.artykul_id"
                    elif SortWgObcych=='K':
                        SQL+=" ORDER BY COALESCE(aok.obcy_id,''),zs.artykul_id"
                    elif SortWgObcych=='P':
                        SQL+=" ORDER BY COALESCE(aop.obcy_id,''),zs.artykul_id"
                    elif SortWgObcych=='KP':
                        SQL+=" ORDER BY COALESCE(aok.obcy_id,aop.obcy_id,''),zs.artykul_id"                        
                        
                    stat,DPoz,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if stat<>"OK":
                        stat = 'Bdy przy pobieraniu danych zamwienia staego :'+stat
                        dane.append(stat)
                    #mamy pozycje zamwienia. Dla kadej pobieramy ceny.
                    SQLP=""
                    NrPoz=0
                    if stat == 'OK' and len(DPoz) > 0:
                        for Poz in DPoz:
                            if Poz[3]>0 and stat=='OK':
                                NrPoz=NrPoz+1
                                Art=rsglobal.Dekoduj(Poz[0]).strip()
                                StVAT=rsglobal.Dekoduj(Poz[1])
                                if len(StVAT)>2:
                                    Komentarz=StVAT
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                Ilosc=Poz[3]
                                Ilosc2=round(Poz[2]*Poz[3],2)
                                Select = "SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"','"+Kontr+"','"+Waluta+"','"+DataDost+"','"+Art+"','',-1, '"+self.oddzial_id+"');"  #AB 04.01.21r
                                stat,DCeny,dump,dump = self.PolSQL.Execute(Select,3)
                                if stat != 'OK':
                                    Komentarz='Bd pobierania ceny dla artykuu '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                LCeny=rsglobal.rseval(rsglobal.Dekoduj(DCeny[0][0]))
                                if LCeny[4]==0:
                                    Komentarz='Zerowa cena na artykule '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue        
                                else:
                                    #sprawdzenie czy cena zgadza si z dotychczasowymi dowodami
                                    klucz=(rsglobal.Dekoduj(Kontr).strip(),rsglobal.Dekoduj(Waluta).strip(),rsglobal.Dekoduj(Art).strip())
                                    if not klucz in SCeny:
                                        SCeny[klucz]=LCeny[4]
                                    else:
                                        if SCeny[klucz] != LCeny[4]:
                                            Komentarz='Cena na artykule '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr+' wynoszca '+str(LCeny[4])+' jest inna ni cena z dowodw dostaw : '+str(SCeny[klucz])
                                            if not Komentarz in wyn1:
                                                wyn1.append(Komentarz)
                                                wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                            continue        

                                # sprawdzamy czy moemy doda ten artyku do dowodu ze wzgldu na ograniczenia grup odbiorcw
                                SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+Kontr+"','"+Art+"','"+DataDost+"')"
                                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    Komentarz='Bd pobierania informacji o dostpnoci dla grupy odbiorcw artykuu '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                elif DTest[0][0] != 'OK':
                                    Komentarz=DTest[0][0]
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue

                                #przygotowanie zapisu pozycji
                                SQLP+="INSERT INTO rs_dowody_dostaw_pozycje (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,nr_poz,artykul_id,"
                                SQLP+="ilosc_zam1,ilosc_zam2,ilosc_pobr1,ilosc_pobr2, ilosc_dost1,ilosc_dost2,stawka_vat,"
                                SQLP+="cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2)"
                                SQLP+="VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+DataDost+"','"+Tryb+"',"+str(NrDost)+","+str(NrPoz)+",'"+Art+"',"
                                SQLP+=str(Ilosc)+","+str(Ilosc2)+","+str(Ilosc)+","+str(Ilosc2)+","+str(Ilosc)+","+str(Ilosc2)+",'"+StVAT+"',"
                                SQLP+=str(LCeny[0])+","+str(LCeny[1])+","+str(LCeny[4])+","+str(LCeny[5])+","+str(LCeny[6])+","+str(LCeny[7])+");"
                                
                                # analiza palet dla kadej pozycji osobno
                                SQLPal="SELECT paleta_id,pojemnosc_paletowa * ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
                                SQLPal+=" AND artykul_id='"+Art+"' AND NOT paleta_id IS NULL "
                                
                                # sprawdzamy dla kontrahenta
                                stat,DPal,dump,dump = self.PolSQL.Execute(SQLPal+" AND kontrahent_id='"+Kontr+"' LIMIT 1",3)
                                if stat != 'OK':
                                    stat = u'Bd sprawdzania palet dla kontrahenta :'+stat
                                    continue        

                                # sprawdzamy dla patnika
                                if len(DPal) == 0 and Kontr != Plat:
                                    stat,DPal,dump,dump = self.PolSQL.Execute(SQLPal+" AND kontrahent_id='"+Plat+"' LIMIT 1",3)
                                    if stat != 'OK':
                                        stat = u'Bd sprawdzania palet dla patnika :'+stat
                                        continue        
                                             
                                # sprawdzamy bez kontrahenta
                                if len(DPal) == 0:
                                    stat,DPal,dump,dump = self.PolSQL.Execute(SQLPal+" AND kontrahent_id IS NULL LIMIT 1",3)
                                    if stat != 'OK':
                                        stat = u'Bd sprawdzania palet bez kontrahentw :'+stat
                                        continue        
                                
                                # jeli co znaleziono to dodajemy to do listy palet
                                if len(DPal) > 0:
                                    if not DPal[0][0] in SPalety:
                                        SPalety[DPal[0][0]] = 0

                                    if float(DPal[0][1]) != 0:
                                        # dzielimy ilo artykuu przez pojemno ilociowjednej palety
                                        SPalety[DPal[0][0]] += (float(Ilosc)/float(DPal[0][1]))
    
    
                    #Dodanie dowodu staego
                    if SQLP!= "" and stat=='OK':
                        stat,Dane,dump,dump = self.PolSQL.Execute(SQLN+SQLP,1)  # zmienione st na stat i licznik tylko jesli OK, JR, 2008-03-07,
                        if stat<>"OK":
                            stat = 'Bdy przy zapisie danych :'+stat
                            dane.append(stat)
                        if stat=='OK':
                            Ile=Ile+1                                           # opuszczalo czasem dowody dostaw bez sygnalizacji
    
                #-----------------
                #zamwienia pojedycze    
                #-----------------
                elif stat == 'OK':
                    SQL="SELECT zop.nr_poz,zop.artykul_id,zop.ilosc1,zop.ilosc2,zop.cena_netto1,zop.cena_netto2,zop.cena_upust1,zop.cena_upust2"
                    SQL+=",zop.cena_brutto1,zop.cena_brutto2,rsf_podaj_vat_artykulu(zop.firma_id,zop.artykul_id,'"+DataDost+"')"
                    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje zop INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
                    SQL+=" WHERE zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id='"+WyznZ+"' AND zop.data='"+DataZ+"' "
                    SQL+=" AND zop.numer="+str(NrZ)+" AND (zop.data_od <= '"+DataDost+"' OR zop.data_od IS NULL) AND (zop.data_do >='"+DataDost+"' OR zop.data_do IS NULL)"
                    SQL+=" AND zop.tryb_dostawy='"+Tryb+"' AND a.aktywny ORDER BY zop.nr_poz,zop.nr_ppoz;"                
                    stat,DPoz,dump,dump = self.PolSQL.Execute(SQL ,3)
                    #mamy pozycje zamwienia. Dla kadej pobieramy ceny.
                    SQLP=""
                    Lp=1
                    if stat == 'OK' and len(DPoz) > 0:
                        for Poz in DPoz:
                            if Poz[2]>0 and stat=='OK':
                                # sprawdzenie cen zamwienia
                                #if Poz[4]==0:
                                Art=rsglobal.Dekoduj(Poz[1]).strip()
                                Stawka=rsglobal.Dekoduj(Poz[10])
                                if len(Stawka)>2:
                                    Komentarz=Stawka
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                Select = "SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"','"+Kontr+"','"+Waluta+"','"+DataDost+"','"+rsglobal.Dekoduj(Poz[1])+"','',-1, '"+self.oddzial_id+"');"  #AB 04.01.21r
                                stat,DCeny,dump,dump = self.PolSQL.Execute(Select,3)
                                if stat != 'OK':
                                    Komentarz='Bd pobierania ceny dla artykuu '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                LCeny=rsglobal.rseval(rsglobal.Dekoduj(DCeny[0][0]))
                                if LCeny[4]==0:
                                    Komentarz='Zerowa cena na artykule '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                else:
                                    #sprawdzenie czy cena zgadza si z dotychczasowymi dowodami
                                    klucz=(rsglobal.Dekoduj(Kontr).strip(),rsglobal.Dekoduj(Waluta).strip(),rsglobal.Dekoduj(Art).strip())
                                    if not klucz in SCeny:
                                        SCeny[klucz]=LCeny[4]
                                    elif SCeny[klucz] != LCeny[4]:
                                        Komentarz='Cena na artykule '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr+' wynoszca '+str(LCeny[4])+' jest inna ni cena z dowodw dostaw : '+str(SCeny[klucz])
                                        if not Komentarz in wyn1:
                                            wyn1.append(Komentarz)
                                            wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                        continue        

                                # sprawdzamy czy moemy doda ten artyku do dowodu ze wzgldu na ograniczenia grup odbiorcw
                                SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+Kontr+"','"+Art+"','"+DataDost+"')"
                                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    Komentarz='Bd pobierania informacji o dostpnoci dla grupy odbiorcw artykuu '+Art+' w dniu '+DataDost+' dla kontrahenta '+Kontr
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue
                                elif DTest[0][0] != 'OK':
                                    Komentarz=DTest[0][0]
                                    if not Komentarz in wyn1:
                                        wyn1.append(Komentarz)
                                        wyn1.append("     Artyku nie zosta pobrany do dowodu dostawy.")
                                    continue


                                CenaN1=str(LCeny[0])
                                CenaN2=str(LCeny[1])
                                CenaU1=str(LCeny[4])
                                CenaU2=str(LCeny[5])
                                CenaB1=str(LCeny[6])
                                CenaB2=str(LCeny[7])
                                # Dodanie pozycji
                            
                                SQLP+="INSERT INTO rs_dowody_dostaw_pozycje (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,nr_poz,artykul_id,"
                                SQLP+="ilosc_zam1,ilosc_zam2,ilosc_pobr1,ilosc_pobr2, ilosc_dost1,ilosc_dost2,stawka_vat,"
                                SQLP+="cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2)"
                                SQLP+="VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+DataDost+"','"+Tryb+"',"+str(NrDost)+","+str(Lp)+",'"+Art+"',"
                                SQLP+=str(Poz[2])+","+str(Poz[3])+","+str(Poz[2])+","+str(Poz[3])+","+str(Poz[2])+","+str(Poz[3])+",'"+Stawka+"',"
                                SQLP+=CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+","+CenaB1+","+CenaB2+");"
                                
                                # analiza palet dla kadej pozycji osobno
                                SQLPal="SELECT paleta_id,pojemnosc_paletowa * ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
                                SQLPal+=" AND artykul_id='"+Art+"' AND NOT paleta_id IS NULL "
                                
                                # sprawdzamy dla kontrahenta
                                stat,DPal,dump,dump = self.PolSQL.Execute(SQLPal+" AND kontrahent_id='"+Kontr+"' LIMIT 1",3)
                                if stat != 'OK':
                                    stat = u'Bd sprawdzania palet dla kontrahenta :'+stat
                                    continue        

                                # sprawdzamy dla patnika
                                if len(DPal) == 0 and Kontr != Plat:
                                    stat,DPal,dump,dump = self.PolSQL.Execute(SQLPal+" AND kontrahent_id='"+Plat+"' LIMIT 1",3)
                                    if stat != 'OK':
                                        stat = u'Bd sprawdzania palet dla patnika :'+stat
                                        continue        
                                            
                                # sprawdzamy bez kontrahenta
                                if len(DPal) == 0:
                                    stat,DPal,dump,dump = self.PolSQL.Execute(SQLPal+" AND kontrahent_id IS NULL LIMIT 1",3)
                                    if stat != 'OK':
                                        stat = u'Bd sprawdzania palet bez kontrahentw :'+stat
                                        continue        
                                
                                # jeli co znaleziono to dodajemy to do listy palet
                                if len(DPal) > 0:
                                    if not DPal[0][0] in SPalety:
                                        SPalety[DPal[0][0]] = 0
                                    # dzielimy ilo artykuu przez pojemno ilociowjednej palety
                                    if float(DPal[0][1]) != 0:
                                        SPalety[DPal[0][0]] += (float(Poz[2])/float(DPal[0][1]))
                                
                                Lp=Lp+1
                            
                    if SQLP != "" and stat=='OK':
                        Ile=Ile+1
                        stat,Dane,dump,dump = self.PolSQL.Execute(SQLN+SQLP,1)
                        if stat<>"OK":
                            stat = 'Bdy przy dodawaniu pozycji :'+stat
                            dane.append(stat)
            
                # wstawienie pozycji z paletami
                if stat == 'OK' and SPalety != {}:
                    # pobranie domylnej wartoci "drukowania"
                    Drukowac = 'False'
                    # dla kontrahenta
                    SQL = "SELECT drukowac_palety_na_dd FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
                    SQL+=" AND kontrahent_id = '"+Kontr+"' AND data_od <='"+DataDost+"' ORDER BY data_od DESC LIMIT 1"
                    stat,DDruk,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = u'Bd pobrania informacji o drukowaniu dla kontrahenta '+Kontr+' :'+stat
                        continue  
                       
                    # dla patnika   
                    if len(DDruk) == 0:
                        SQL = "SELECT drukowac_palety_na_dd FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND kontrahent_id = '"+Plat+"' AND data_od <='"+DataDost+"' ORDER BY data_od DESC LIMIT 1"
                        stat,DDruk,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':
                            stat = u'Bd pobrania informacji o drukowaniu dla kontrahenta '+Kontr+' :'+stat
                            continue        
                    
                    if len(DDruk) > 0:
                        Drukowac = str(DDruk[0][0])
                        
                    # wstawienie wierszy z paletami
                    INS = ''
                    for paleta in SPalety:
                        INS+="INSERT INTO rs_dowody_dostaw_palety (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,"
                        INS+="paleta_id,liczba_palet,drukowac)"
                        INS+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+DataDost+"','"+Tryb+"',"
                        INS+=str(NrDost)+",'"+paleta+"',CEIL("+str(SPalety[paleta])+"),"+Drukowac+"); "
                    stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
    
    #porwnanie ile byo tydzie temu a ile teraz
    if stat=='OK':
        stat,Dane,dump,dump=self.PolSQL.Execute("SELECT COUNT (*) FROM rs_dowody_dostaw WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data=  date '"+DataDost+"'- integer '7' AND tryb_dostawy='"+Tryb+"' AND NOT korekta;" ,3)    
        if stat != 'OK':
            pass
        elif len(Dane)>0:
            if Ile != Dane[0][0]:
                wyn2=[Dane[0][0],Ile]
        else:
            if Ile >0:
                wyn2=[0,Ile]
    
    # Uwaga: kod 'BR ZAM' jest obslugiwany tak, jak 'OK' gdyz zwracamy liste kontrahentow z trasy bez zamowien
    if stat in ('OK','BR ZAM'):
        # dolaczenie listy kontrahentow z trasy dla ktorych nie bylo zamowien do utworzenia dowodow
        KluczeKontrBezZam = SKontrTrasa.keys()
        KluczeKontrBezZam.sort()
        LKontrBezZam = []
        for k in KluczeKontrBezZam:
            if SKontrTrasa[k][1] == 0:
                LKontrBezZam.append(k+' '+SKontrTrasa[k][0])
        
        if len(LKontrBezZam) > 0:
            wyn2.append(['LISTA_KONTRAHENTOW_BEZ_ZAMOWIEN',LKontrBezZam])
            

#-------------------------------------------------------------------------------
# 2 - WYKONANIE DOWODU DOSTAWY RCZNEGO / 12 - UPROSZCZONE DODAWANIE
#-------------------------------------------------------------------------------

if Fun in [2,12] and stat=='OK':
    if Fun==12:
        # dane dla dowodu uproszczonego
        Trasa=str(DaneUTD[0])
        Typ=str(DaneUTD[1])
        Tryb=str(DaneUTD[2])
        # DataDost=str(DaneUTD[3])  #WS 2020-12-18
        DZam=[]
        PozOd=0
        PozDo=0

        if not rsglobal.SprawdzCzyToData(DataDost):  #AB 2023-10-09
            stat = "BL DT"
        else:  #AB 2023-10-09
            sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+self.oddzial_id+"\',\'"+DataDost+"\',1);"
            rsglobal.ZapiszDoLogow(sql)
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 4)
            rsglobal.ZapiszDoLogow(repr(dane_wyn))
            if dane_wyn != 1:
                stat = "ZK DATA"

    if stat == 'OK':
        # sprawdzenie konfliktu pomiedzy blokada na kontrahencie a blokada przyjmowania zwrotow
        sql ="SELECT zablokowany FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
        stat,KontrBlok,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania stanu blokady dla kontrahenta: '+stat
    
    if stat=='OK':
        sql ="SELECT blokada_zwrotow FROM rs_kontrahenci_fakturowanie"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"'"
        sql+=" AND data_od<='"+DataDost+"' ORDER BY data_od DESC LIMIT 1;"
        stat,KontrFakt,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych do fakturowania: '+stat
        elif len(KontrFakt) == 1:
            if KontrBlok[0][0] and KontrFakt[0][0]:
                stat = 'BL BLOKADA VS BLOKADA ZWROTOW'
    
    if stat=='OK':
        if len(DZam)>0:
            if DZam[0][1] not in ['',None,'None']:
                NrZamD=rsglobal.Dekoduj(DZam[0][1])
            else:
                NrZamD=''
                
            if DZam[0][2] not in ['',None,'None']:
                Waluta=rsglobal.Dekoduj(DZam[0][2])
            else:
                Waluta='PLN'        
                
        else:
            NrZamD=''
            Waluta='PLN'        
    
        if Wyzn=='':
            Wyzn="NULL"
        else:
            Wyzn="'"+Wyzn+"'"
        
        if DataZam=='    -  -  ':
            DataZam="NULL"
        else:
            DataZam="'"+DataZam+"'"
    
        #pobranie patnika
        Sel="SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
        stat,DKontr,wyn1,tr = self.PolSQL.Execute(Sel,3)
        if stat == 'OK':
            Plat=rsglobal.Dekoduj(DKontr[0][0])
        else:
            stat = 'Bdy przy pobieraniu platnika:'+stat
            dane.append(stat)   
    
    if stat=='OK':
        #pobranie waluty
        SQL="SELECT waluta FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND wyznacznik_id="+Wyzn+" AND data="+DataZam+" AND numer="+str(NrZam)+";"
        stat,DZamow,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(DZamow)>0:
                Waluta=rsglobal.Dekoduj(DZamow[0][0])
            else:
                Waluta='PLN'
        else:
            stat = 'Bdy przy pobieraniu waluty zamwienia:'+stat
            dane.append(stat)   
         
    #pobranie numeru
    if stat == 'OK':
        Warunek = "firma_id=\\'"+self.firma_id+"\\' AND oddzial_id=\\'"+self.oddzial_id+"\\' AND trasa=\\'"+Trasa+"\\' AND data=\\'"+DataDost+"\\' AND tryb_dostawy=\\'"+Tryb+"\\'"
        Select = "SELECT rsf_klucz_where_new('rs_dowody_dostaw','"+Warunek+"','numer');"
        stat,DNr,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>"OK":
             stat = 'Bdy przy pobieraniu numer :'+stat
             dane.append(stat)
        else:
            NrDost=DNr[0][0]

            SQLN="INSERT INTO rs_dowody_dostaw (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,"
            SQLN+="kontrahent_id,platnik_id,kierowca,f_wyznacznik_id,f_data,f_numer,z_wyznacznik_id,z_data,z_numer,"
            SQLN+="dowod_zwrotu,numer_zamowienia,czy_automatycznie,stan,samochod,budowa,przewoznik_id) "  #WS 2020-12-18 - przewoznik
            SQLN+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+DataDost+"','"+Tryb+"',"+str(NrDost)+", "
            SQLN+="'"+Kontr+"','"+Plat+"','"+Kier+"',NULL,NULL,NULL,"+Wyzn+","+DataZam+","+str(NrZam)+","
            SQLN+="'','"+NrZamD+"',FALSE,0,'"+Samochod+"','"+Budowa+"',"+rsglobal.ZmienNaNULL(Przewoznik)+");"  #WS 2020-12-18 - Przewoznik

    SQLP=""
    #pobranie pozycji
    if stat == 'OK' and PozOd != 0 and PozDo != 0:
        #tylko pozycje jednorazowe
        SQL="SELECT zop.nr_poz,zop.artykul_id,zop.ilosc1,zop.ilosc2,zop.cena_netto1,zop.cena_netto2,"
        SQL+="zop.cena_upust1,zop.cena_upust2,zop.cena_brutto1,zop.cena_brutto2,rsf_podaj_vat_artykulu(zop.firma_id,zop.artykul_id,'"+DataDost+"')"
        SQL+=" FROM rs_zamowienia_odbiorcy_pozycje zop INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" WHERE zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id="+Wyzn+" AND zop.data="+DataZam+" AND zop.numer="+str(NrZam)
        SQL+=" AND zop.nr_poz >="+str(PozOd)+" AND zop.nr_poz <="+str(PozDo)+" AND a.aktywny ORDER BY zop.nr_poz,zop.nr_ppoz;"        
        stat,DPoz,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat<>"OK":
             stat = 'Bdy przy pobieraniu danych :'+stat
             dane.append(stat)
        if stat=='OK':
            #sprawdzenie, czy pobray si poprawnie stawki VAT
            for poz in DPoz:
                if stat == 'OK':
                    Stawka=rsglobal.Dekoduj(poz[10])
                    if len(Stawka)>2:
                        stat=Stawka
        if stat=='OK':
            #sprawdzenie, czy nie wystpuje ten sam artyku z rnymi cenami na zamwieniu
            ArtCenaData={}
            for poz in DPoz:
                if stat == 'OK':
                    Art=poz[1]
                    Cena=poz[6]
                    if not Art in ArtCenaData:
                        ArtCenaData[Art]=[Cena]
                    else:
                        SCena=ArtCenaData[Art]
                        if SCena[0]<>Cena:
                            stat='Wystpuj rne ceny dla artykuu '+Art.strip()+' w zamwieniu: wyznacznik '+Wyzn+' z dnia '+DataZam+' numer '+str(NrZam)                
                            
        if stat=='OK':                
            #sprawdzenie, czy nie wystpuje ten sam artyku z rnymi cenami na dodwodach dostaw
            for poz in DPoz:
                if stat == 'OK':
                    Art=poz[1]
                    Cena=poz[6]
                    klucz=(rsglobal.Dekoduj(Kontr).strip(),rsglobal.Dekoduj(Waluta).strip(),rsglobal.Dekoduj(Art).strip())
                    #rsglobal.ZapiszDoLogow('KL 1 '+str(klucz)+' '+str(klucz in SCeny),1)
                    if not klucz in SCeny:
                        SCeny[klucz]=Cena
                    else:
                        if SCeny[klucz] != Cena:
                            stat='Wystpuj rne ceny dla artykuu '+Art.strip()+' w zamwieniu: wyznacznik '+Wyzn+' z dnia '+DataZam+' numer '+str(NrZam)+' i na dowodach dostaw z tego dnia'                 


            
            if stat == 'OK' and len(DPoz) > 0:
                Lp=1
                for Poz in DPoz:
                    SQLP+="INSERT INTO rs_dowody_dostaw_pozycje (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer,nr_poz,artykul_id,"
                    SQLP+="ilosc_zam1,ilosc_zam2,ilosc_pobr1,ilosc_pobr2, ilosc_dost1,ilosc_dost2,stawka_vat,"
                    SQLP+="cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2)"
                    SQLP+="VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Trasa+"','"+DataDost+"','"+Tryb+"',"+str(NrDost)+","+str(Lp)+",'"+rsglobal.Dekoduj(Poz[1])+"',"
                    SQLP+=str(Poz[2])+","+str(Poz[3])+","+str(Poz[2])+","+str(Poz[3])+","+str(Poz[2])+","+str(Poz[3])+",'"+rsglobal.Dekoduj(Poz[10])+"',"
                    SQLP+=str(Poz[4])+","+str(Poz[5])+","+str(Poz[6])+","+str(Poz[7])+","+str(Poz[8])+","+str(Poz[9])+");"
                    Lp=Lp+1          
    if stat=='OK':
        #rsglobal.ZapiszDoLogow(SQLN+SQLP,1)
        stat,Dane,dump,dump = self.PolSQL.Execute(SQLN+SQLP,1)  
        if stat<>"OK":
             stat = 'Bdy przy dodawaniu danych :'+stat
             dane.append(stat)
        else:  #AB 22.02.21r
            wyn2=[self.oddzial_id, Trasa, DataDost, Tryb, NrDost]
