# -*- coding: iso8859_2 -*-
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_tworzenie_faktur.py
# Purpose:     tworzy (automatycznie lub rcznie) nowe faktury/korekty z dowodw dostaw
#
# Author:      Micha Raburski
#
# Created:     2007/06/25
# RCS-ID:      $Id: fs_dowody_dostaw_tworzenie_faktur.py $
# Copyright:   (c) 2004-2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011.11.16 - Micha Raburski - (5180) tworzenie faktur z rabatem finansowym
# 2012-01-04 Mariusz Rajfura  edycja i kontrola daty tworzenia faktur (5344)
# 2012-01-11 Mariusz Rajfura  zdjecie kontroli daty tworzenia faktur (5375)
# 2013-08-01 Mariusz Rajfura  (7076) popr.sql po dodaniu kontrahent_id do rs_dowody_dostaw_pozycje
# 2013-12-18 Jan Raburski  (7501) VAT 2014
# 2019-08-01 Aleksander Bargie (11568) Obsuga split payment w fakturach
# 2019-08-06 Wojciech Skowron   (11579) Czy_mpp ustawiane na True jesli zaznaczone u patnika lub kontrahenta
# 2020-03-23 Mikoaj Kozowski  (11906) Uzupenianie pola 'kod_gtu' w pozycjach faktury przy tworzeniu faktur z dowodw dostawy
# 2020-12-10 Jan Raburski (12208) Tworzenie faktur wspolnych dla wszystkich oddzialow

from funkcje import fs_sprzedaz_pom

DataOd = rsglobal.Dekoduj(klucze[0])
DataDo = rsglobal.Dekoduj(klucze[1])
DataFakt = rsglobal.Dekoduj(klucze[2])
Wyzn = rsglobal.Dekoduj(klucze[3])
CzyWszyscy = klucze[4]
CzyKateg = klucze[5]
Kateg = rsglobal.Dekoduj(klucze[6])
Dni = klucze[7]
Tytul = klucze[8]
CzyDlaKorekt = klucze[9]
WyznKor = klucze[10]
DlaKontrahenta = klucze[11].strip()
ZbiorczaDlaPlatnika = klucze[12]
OddzielnyVAT = False

Fun = klucze[-1]
stat = 'BR UPR'
if Fun == 1:
    if ((self.oddzial_id,'028017') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'OK'
#-------------------------------------------------------------------------------
# SPRAWDZENIE POPRAWNOCI DANYCH 
#-------------------------------------------------------------------------------

if Fun in [1, 2] and stat == 'OK':
    if stat == 'OK':
        if DataOd == '    -  -  ':
            stat = 'Nie podano daty od'
        else:
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat = u"Nieprawidowa data od"
    
    if stat == 'OK':
        if DataDo == '    -  -  ':
            stat = 'Nie podano daty do'
        else:
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat = u"Nieprawidowa data do"
    
    if stat == 'OK':
        if DataFakt == '    -  -  ':
            stat = 'Nie podano daty faktury'
        else:
            if not rsglobal.SprawdzCzyToData(DataFakt):
                stat = u"Nieprawidowa data faktury"
            else:
                #sprawdzenie czy mona na ten dzie tworzy faktury
                stat, Dane, dump, dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+DataFakt+"\\\']','F');",3)
                if Dane[0][0] != 'OK':
                    stat = "Nie mona tworzy faktur - istniej faktury z pniejsz dat"

    if stat == 'OK':
        if DataFakt < DataDo:
            stat = 'Data faktury wczeniejsza od daty kocowej dla dowodw dostaw.'

    if stat == 'OK':
        if Wyzn == '':
            stat = 'Nie podano wyznacznika'
        else:
            sql = "SELECT wyznacznik_id FROM rs_wyznaczniki"
            sql += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
            sql += " AND typ_faktury IN ('KR','DU','RR','WW','ZL','ZU')"
            sql += " AND (NOT czy_korekta OR czy_korekta IS NULL);"
            stat, d, dump, dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenienia wyznacznika: '+stat
            if len(d) == 0:
                stat = 'Wyznacznik '+Wyzn+' nie jest wyznacznikiem faktury'
    
    if stat == 'OK' and CzyKateg:
        if Kateg == '':
            stat = 'Nie podano kategorii'
        else:
            stat, d, dump, dump = self.PolSQL.Execute("SELECT kod FROM rs_czestosci_fakturowania WHERE firma_id = '"+self.firma_id+"' AND kod='"+Kateg+"';" ,3)
            if stat == 'OK':
                if len(d) == 0:
                    stat = u"Nieprawidowa kategoria"

    OddzialDlaFaktur = ''
    if stat == 'OK':
        # sprawdzenie czy wystawiac zbiorcze faktury
        sql = "SELECT czy_zbiorcza_dla_oddzialow FROM rs_firmy WHERE firma_id = '"+self.firma_id+"';"
        stat, zbiorcza, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia czy faktury zbiorcze dla oddziaw' + stat
        elif zbiorcza[0][0]:
            # faktury wystawiane w centrali
            sql = "SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '" + self.firma_id + "' AND centrala;"
            stat, zbiorcza, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd szukania centrali ' + stat
            elif len(zbiorcza) == 0:
                stat = 'Brak oddziau oznaczonego jako centrala.'
            else:
                OddzialDlaFaktur = zbiorcza[0][0]

    if stat == 'OK':
        #sprawdzenie poprawnoci uprawnie do wyznacznika
        if OddzialDlaFaktur == '':
            sql = "SELECT rsf_podaj_liste_wyznacznikow('"+str([self.firma_id,self.oddzial_id,'',self.operator_id]).replace("'",'"')+"','[]','[]','[]');"
        else:
            sql = "SELECT rsf_podaj_liste_wyznacznikow('" + str([self.firma_id, OddzialDlaFaktur, '', self.operator_id]).replace("'", '"') + "','[]','[]','[]');"
        stat, wyzn, dump, dump = self.PolSQL.Execute(sql,3)
        LWyzn = eval(wyzn[0][0])
        if (not Wyzn in LWyzn) and (not Wyzn+' ' in LWyzn):
            stat = u'Niezdefiniowane uprawnienia do wybranego wyznacznika w danym oddziale'

    if stat == 'OK' and OddzialDlaFaktur != '':
        # zmieniany jest stat, eby nie wykonywal sie caly kod ponizej dla normalnych faktur
        # tworzenie faktur zbiorczych jest uproszczone i zrobione na samym dole modulu
        stat = 'faktury zbiorcze dla firmy'

#-------------------------------------------------------------------------------
# WYKONANIE FAKTUR
#-------------------------------------------------------------------------------

if Fun==1 and stat=='OK':
    if CzyDlaKorekt:

        #-------------------------------------------------------------------------------
        # WYKONANIE FAKTUR I KOREKT Z KOREKT ZWROTW (RCZNYCH I AUTOMATYCZNYCH)
        #-------------------------------------------------------------------------------
        # zablokowanie wyznacznika na UPDATE - to sprawi, e inni nie bd mogli go wykorzysta do tworzenia 
        # faktur z dowodw dostaw
        SQL="SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' FOR UPDATE NOWAIT"
        stat,DWyzn,dump,dump = self.PolSQL.Execute(SQL,3)  
        
        if stat=='OK':

            #pobranie pozycji z dowodw dostaw
            SQLDow="SELECT COALESCE(k.platnik_id,dd.kontrahent_id),dd.kontrahent_id,COALESCE(k.zamawiajacy_id,dd.kontrahent_id)," #0-2
            SQLDow+=" dp.artykul_id,dp.cena_netto1,dp.cena_netto2,dp.cena_upust1,dp.cena_upust2," # 3-7
            SQLDow+=" dp.cena_brutto1,dp.cena_brutto2,dp.ilosc_zwr1,dp.ilosc_zwr2,dp.stawka_vat," #8-12
            SQLDow+=" dd.trasa,dd.data,dd.tryb_dostawy,dd.numer,ilosc_dost1,ilosc_dost2," #13-18
            SQLDow+=" COALESCE(dd.oddzial_id_p),trasa_p,data_p,tryb_dostawy_p,numer_p" # 19-23
            SQLDow+=" FROM rs_dowody_dostaw_pozycje dp "
            SQLDow+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
            SQLDow+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=dd.firma_id AND k.kontrahent_id=dd.kontrahent_id) "
            SQLDow+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"'"
            SQLDow+=" AND dd.data>='"+DataOd+"' AND dd.data <='"+DataDo+"' AND dd.stan='2' AND f_wyznacznik_id IS NULL"
            if CzyKateg:
                SQLDow+=" AND TRIM(rsf_podaj_czestosc_kontrahenta(dd.firma_id,k.kontrahent_id,dd.oddzial_id))=TRIM('"+Kateg+"')"        
            SQLDow+=" AND dd.korekta "
            SQLDow+=" ORDER BY COALESCE(k.platnik_id,dd.kontrahent_id),dd.kontrahent_id,artykul_id FOR UPDATE NOWAIT;"
            stat,DDow,dump,dump = self.PolSQL.Execute(SQLDow,3)
            if stat<>'OK':
                stat='Bd pobierania danych do tworzenia faktur z korekt zwrotw :'+stat

        #-----------------------------------------
        # obsuga faktur korekt dowodw dostaw
        #-----------------------------------------

        # tworzenie faktur nastpuje w sprytnej ptli. Do tej pory byy tylko zwroty na minus wic nie byo problemu. Teraz
        # bd te pozycje, ktre wymagaj korekt. W tym wypadku w ptli fakturowej wyapywane s pozycje,
        # ktre nie trafiaj na faktur a trafiaj na korekt.
        # Uwzgldniony jest te przypadek gdy ostatecznie nie tworzymy faktury, bo mog by same pozycje korekt
        
        if stat=='OK':
            LDostFakt={}
            Platnik=''
            Kontr=''
            SPozDok={}
            SPozDoKorekty={}
            i=0
            Lp=0
            for poz in DDow:
                if stat=='OK':
                    Art=poz[3]
                    
                    # jeli zmienia si kontrahent lub patnik to tworzymy now faktur
                    if Platnik<>poz[0] or Kontr<>poz[1]:
                        # to oznacza, e poprzednia faktura nie ma ani jednej pozycji i naley j usun.
                        # Mona to zrobi, bo wyznacznik jest zablokowany
                        if Lp==1:
                            SQL="DELETE FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                            SQL+=" AND data='"+DataFakt+"' AND numer="+str(NumerF)+";"
                            stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
                            if stat<>'OK':
                                stat='Bd usuwania danych faktury bez pozycji'
                                
                        if stat=='OK':    
                            Platnik=poz[0]
                            Kontr=poz[1]
                            Zamaw=poz[2]
                        
                            #pobranie wolnego numeru faktury
                            stat,DNr,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+DataFakt+"\\\']','F');",3)        
                            if stat=='OK':
                                if DNr[0][0] in (None,'None',''):
                                    stat="Bdy przy pobieraniu numeru faktury"
                        if stat=='OK':
                            NumerF=DNr[0][0]
                            #przygotowanie klucza,ktry bdzie wrzucany na nagwek dowodu dostawy
                            KluczFakt=(Wyzn,DataFakt,NumerF)
                            
                            SQLKontr="SELECT dni,wersja,spos_zaplaty,spos_dostawy,handlowiec,"
                            SQLKontr+="sposob_odbioru_faktury,rozliczac_zwroty,projekt_id,osobny_rachunek_vat"
                            SQLKontr+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
                            SQLKontr+=" AND kontrahent_id = '"+Kontr+"' AND data_od <= '"+DataDo+"'"
                            SQLKontr+=" ORDER BY data_od DESC LIMIT 1;"
                            stat,DFaktKontr,dump,dump = self.PolSQL.Execute(SQLKontr, 3)
                            
                        if stat=='OK':
                            SQLPlat="SELECT dni,wersja,spos_zaplaty,spos_dostawy,handlowiec,"
                            SQLPlat+="sposob_odbioru_faktury,rozliczac_zwroty,projekt_id,osobny_rachunek_vat "
                            SQLPlat+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
                            SQLPlat+=" AND kontrahent_id = '"+Platnik+"' AND data_od <= '"+DataDo+"'"
                            SQLPlat+=" ORDER BY data_od DESC LIMIT 1;"
                            stat,DFaktPlat,dump,dump = self.PolSQL.Execute(SQLPlat, 3)

                            if stat=='OK':
                                if len(DFaktPlat)==0:
                                    if len(DFaktKontr) ==0:
                                        stat='Brak danych do fakturowania dla patnika '+PlatN
                                    else:
                                        DFaktPlat = eval(str(DFaktKontr))

                        #WS 2019-08-06
                        if stat=='OK':
                            CzyMPP = False

                            SEL = """SELECT BOOL_OR(czy_mpp) FROM rs_kontrahenci WHERE firma_id = '{}' AND kontrahent_id in ('{}','{}');"""
                            SEL = SEL.format(self.firma_id, Platnik or 'NULL', Kontr or 'NULL')
                            stat,DMPP,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd przy pobieraniu danych patnika/kontrahenta:'+stat
                            elif DMPP[0][0]:
                                CzyMPP = True

                        #MK 2020-04-22
                        if stat=='OK':
                            sqlw = "SELECT ozn_trans,ozn_sprzedaz"
                            sqlw += " FROM rs_wyznaczniki"
                            sqlw += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "';"
                            stat, dww, dump, dump = self.PolSQL.Execute(sqlw, 3)
                            if stat <> 'OK':
                                stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
                                dane.append(stat)
                            if dww != []:
                                OznTrans = dww[0][0]
                                OznSprz = dww[0][1]
                                        
                        if stat=='OK':
                            # podmiana danych w danych patnika jeli uzupenione dane u kontrahenta
                            if len(DFaktPlat) >0 and len(DFaktKontr) > 0 and DFaktPlat <> DFaktKontr:
                                if DFaktKontr[0][0] <> -1: # dni
                                    DFaktPlat[0][0] = DFaktKontr[0][0]
                                for licz in range(8):
                                    if licz <> 5: # pomijamy rozliczac_zwroty
                                        if DFaktKontr[0][licz+1] in (None,'None',''):
                                            DFaktPlat[0][licz+1] = DFaktKontr[0][licz+1]
                            #pobranie danych do fakturowania
                            KDni=str(DFaktPlat[0][0])[0:-2]
                            KWersja=rsglobal.Dekoduj(DFaktPlat[0][1])
                            if KWersja in (None,'None',''):
                                KWersja="NULL"
                            else:
                                KWersja="'"+KWersja+"'"
        
                            if DFaktPlat[0][2] in (None,'None',''):
                                KSposZapl="NULL"
                            else:
                                KSposZapl="'"+rsglobal.Dekoduj(DFaktPlat[0][2])+"'"
                                
                            if DFaktPlat[0][3] in (None,'None',''):
                                KSposDost='NULL'
                            else:
                                KSposDost="'"+rsglobal.Dekoduj(DFaktPlat[0][3])+"'"
        
                            if DFaktPlat[0][4] in (None,'None',''):
                                KHandl="NULL"
                            else:
                                KHandl="'"+rsglobal.Dekoduj(DFaktPlat[0][4])+"'"
                                
                            if DFaktPlat[0][5] in (None,'None',''):
                                KSposOdbF="NULL"
                            else:
                                KSposOdbF="'"+rsglobal.Dekoduj(DFaktPlat[0][5])+"'"
                                
                            KRozlZwroty=rsglobal.Dekoduj(DFaktPlat[0][6])
                            
                            if DFaktPlat[0][7] in (None,'None',''):
                                KProj="'zzzz'"
                            else:
                                KProj="'"+rsglobal.Dekoduj(DFaktPlat[0][7])+"'"

                            #RW
                            OddzielnyVAT = DFaktPlat[0][8]

                            #przygotowanie dodania nagwka faktury

                            SQL='INSERT INTO rs_faktury '
                            SQL+='(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,kraj_opodatkowania,'
                            SQL+='dostawy_od_dnia,dostawy_do_dnia,kierowca,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,'
                            SQL+='termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,projekt_id,upust,upust_wartosc,upust_wartosc_wal,'
                            SQL+='rabat,rabat_wartosc,rabat_wartosc_wal,kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,'
                            SQL+='kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,numer_z_rs,'
                            SQL+='zamowienie_nr,zamowienie_data,osobny_rachunek_vat,czy_mpp,ozn_trans,ozn_sprzedaz)' #WS 2019-08-06 - dodane czy_mpp
                            SQL+=' VALUES '
                            SQL+="('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerF)+",'"+self.oddzial_id+"','W','"+Kontr+"','"+Zamaw+"','"+Platnik+"',NULL,'PL',"
                            SQL+="NULL,NULL,NULL,'PLN',1,NULL,NULL,"+KWersja+","+KSposZapl+","+KDni+",NULL,"
                            SQL+="date '"+DataFakt+"' + integer '"+KDni+"',"+KHandl+","+KSposOdbF+","+KSposDost+","+KProj+",0,0,0,"
                            SQL+="0,0,0,0,0,0,0,"
                            SQL+="0,0,0,0,'','','',"
                            SQL+="'',NULL,"+str(OddzielnyVAT)+","+str(CzyMPP) #WS 2019-08-06 - dodane CzyMPP
                            if OznTrans not in ('None', ''):
                                SQL+= ",'" + str(OznTrans) + "'"  #MK 2020-04-22
                            else:
                                SQL+= ",NULL"
                            if OznSprz not in ('None', ''):
                                SQL+= ",'" + str(OznSprz) + "'"  #MK 2020-04-22
                            else:
                                SQL+= ",NULL"
                            SQL+= ");"
                            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)  
                            LDostFaktPom={}
                            Lp=1
                            
                if stat=='OK':        
                    # sumujemy pozycje tak dugo a wiemy e nie nastpi zmiana patnika/kontrahenta/artykuu
                    # artykul, cenaN1, cenaN2, cenaU1, cenaU2, cenaB1, cenaB2, stawka vat
                    # dodajemy te klucze dowodw dostaw, ktre zostan przypisane do faktury.
                    # dodajemy te list dowodw, ktre s korygowane w taki sposb, by do nich wystawi korekt
                    
                    KluczPoz=(poz[3],poz[4],poz[5],poz[6],poz[7],poz[8],poz[9],poz[12])
                    if KluczPoz in SPozDok:
                        SPozDok[KluczPoz][0]+=poz[10]-poz[17] 
                        SPozDok[KluczPoz][1]+=poz[11]-poz[18]
                        SPozDok[KluczPoz][2][(poz[13],poz[14],poz[15],poz[16])]=KluczFakt
                        if not (poz[19],poz[20],poz[21],poz[22],poz[23]) in SPozDok[KluczPoz][3]:
                            SPozDok[KluczPoz][3].append((poz[19],poz[20],poz[21],poz[22],poz[23]))
                    else:
                        SPozDok[KluczPoz]=[poz[10]-poz[17],poz[11]-poz[18],
                                 {(poz[13],poz[14],poz[15],poz[16]):KluczFakt},
                                 [(poz[19],poz[20],poz[21],poz[22],poz[23])]]
                        
                    
                    Robic=False
                    # jestemy na ostatniej pozycji
                    if i+1==len(DDow):
                        Robic=True
                        # zmienia si patnik/kontrahent/artykul
                    elif DDow[i+1][0]<>Platnik or DDow[i+1][1]<>Kontr or DDow[i+1][3]<>Art:
                        Robic=True
                        
                    # wstawienie pozycji artykuu
                    if Robic:
                        Klucze=SPozDok.keys()
                        Klucze.sort()
                        for kl in Klucze:
                            if stat=='OK':
                                PozArt=SPozDok[kl]
                                # to oznacza, e pozycja powinna trafi na faktur
                                if PozArt[0]<0:
                                    Ilosc1=rsglobal.RSRound(-PozArt[0],2)
                                    Ilosc2=rsglobal.RSRound(-PozArt[1],2)
                                    
                                    UpustWart= rsglobal.RSRound((kl[1]-kl[3])*Ilosc1,2)
                                                                
                                    StawkaVAT=kl[7]
                                    if StawkaVAT=='None':
                                        stat='Brak stawki VAT na pozycji w dowodzie dostaw '+poz[11]
                                        
                                    if stat=='OK':
                                        if StawkaVAT in self.ListaStawekZn:
                                            PomStVATLiczb=0
                                        else:
                                            PomStVATLiczb=int(StawkaVAT)
            
                                        WartN=rsglobal.RSRound(Ilosc1*(kl[3]),2)
                                        WartVAT=rsglobal.RSRound(WartN*PomStVATLiczb*0.01,2)
                                        WartB=WartN+WartVAT
                                        
                                        Upust=rsglobal.RSRound(UpustWart/WartN*100,2)
                                        
                                        CechaOpis="(SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+kl[0]+"')"
                                        KodGtu = "(SELECT kod_gtu FROM rs_artykuly WHERE firma_id='" + self.firma_id + "' AND artykul_id='" +kl[0] + "')" #MK 2020-03-23
                                
                                        SQL="INSERT INTO rs_faktury_pozycje "
                                        SQL+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"                                                        #1
                                        SQL+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"       #2
                                        SQL+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,"            #3
                                        SQL+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,cecha1_opis,kod_gtu) "#4  #MK 2020-03-23
                                        SQL+=" VALUES "
                                        SQL+="('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerF)+","+str(Lp)+",0,"               #1
                                        SQL+="'"+kl[0]+"',"+str(Ilosc1)+","+str(Ilosc2)+","+str(kl[1])+","+str(kl[2])+","+str(kl[3])+","+str(kl[4])+","+str(kl[5])+","+str(kl[6])+","       #2
                                        SQL+=str(Upust)+","+str(UpustWart)+",'"+rsglobal.Dekoduj(StawkaVAT)+"',"+str(WartN)+","+str(WartVAT)+","+str(WartB)+",'',NULL,"                #3
                                        SQL+=str(kl[1])+","+str(kl[2])+","+str(kl[3])+","+str(kl[4])+","+str(WartN)+","+str(WartVAT)+","+str(WartB)+","+CechaOpis+","+KodGtu+");" #4      #MK 2020-03-23
                                        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                                        Lp+=1
                                        
                                        # zapisujemy ktre dowody dostaw trafiy na t faktur
                                        for kl in PozArt[2]:
                                            LDostFakt[kl]=eval(str(PozArt[2][kl]))
                                elif PozArt[0]>0:
                                    # to oznacza, e pozycja powinna trafi na korekt
                                    if not (Kontr,Platnik) in SPozDoKorekty:
                                        SPozDoKorekty[(Kontr,Platnik)]=[]
                                    # dla kadej pary kontrahent/patnik mamy dane artykuu, iloci do skorygowania,
                                    # oraz list pierwotnych dowodw dostaw
                                    SPozDoKorekty[(Kontr,Platnik)].append([kl,PozArt[0],PozArt[1],PozArt[3]])
                        SPozDok={}    
                    
                    i=i+1

        # ewentualne usunicie ostatniej pustej faktury
        if stat=='OK':
            if Lp==1:
                SQL="DELETE FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                SQL+=" AND data='"+DataFakt+"' AND numer="+str(NumerF)+";"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
                if stat<>'OK':
                    stat='Bd usuwania danych faktury bez pozycji'
            
        #-----------------------------------------
        # teraz zajmujemy si korektami korekt dowodw dostaw
        #-----------------------------------------
        
        # mamy list pozycji, ktre maj by skorygowane. Uzyskalimy to na podstawie analizy danych do faktur
        # teraz dla kadej pary kontrahent/patnik wystawiamy korekty. 
        # Do wystawienia jest ile tam pozycji. Kada z nich ma potencjalne dowody dostaw do ktrych wystawiono faktury i to 
        # do nich mona sprbowa wystawi korekty. 
        # po wystawieniu pierwszej korekty (wirtualnie) mamy te dane o innych pozycjach i maj one priorytet
        # przed przypisanymi dowodami dostaw. 
        # Jak nie ma pozycji do korekty z wybranych ju dokumentw oraz z przypisanych faktur
        # to szukamy ostatniej , z ktrej mona wyda po tej cenie
            
        # mamy list korekt do zmiany i tworzymy te korekty    

        # jeli potrzebny to sprawdzamy czy podano wyznacznik korekty i czy jest poprawny 
        # i czy s do niego uprawnienia. Rwnoczenie blokujemy go do czasu zakoczenia procesu tworzenia korekt
        if stat=='OK' and SPozDoKorekty<>{}:
            if WyznKor == '':
                stat='Nie podano wyznacznika korekty, a jest on potrzebny'
            
            if stat=='OK':
                SQL="SELECT wyznacznik_id FROM rs_wyznaczniki"
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznKor+"'"
                SQL+=" AND czy_korekta FOR UPDATE NOWAIT;"
                stat,DWyznKor,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenienia wyznacznika korekty: '+stat
                elif len(DWyznKor) == 0:
                    stat = 'Wyznacznik '+WyznKor+' nie jest wyznacznikiem korekty'
    
            if stat=='OK':    
                #sprawdzenie poprawnoci uprawnie do wyznacznika
                SQL = "SELECT rsf_podaj_liste_wyznacznikow('"+str([self.firma_id,self.oddzial_id,'',self.operator_id]).replace("'",'"')+"','[]','[]','[]');"
                stat,DUprWyzn,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat=' Bd pobierania uprawnie do wyznacznika korekty : '+stat
                
            if stat=='OK':
                LWyzn=eval(DUprWyzn[0][0])
                if (not WyznKor in LWyzn) and (not WyznKor+' ' in LWyzn):
                    stat = u'Niezdefiniowane uprawnienia do wybranego wyznacznika korekty w danym oddziale'

        if stat=='OK' and SPozDoKorekty<>{}:            
            # znalezienie pozycji faktur do korekty dla poszczeglnych pozycji
            KluczeKor=SPozDoKorekty.keys()
            KluczeKor.sort()
            
            for kl in KluczeKor:
                LPozycjeDoKor=SPozDoKorekty[kl]
                # sownik, ktry mwi do czego konkretnie zostan wystawione korekty
                # klucz to dokument do ktrego bdzie korekta (typ F/K, wyznacznik,data, numer)
                # wynik to pozycja, podpozycja dokumentu, dane artykuu, ile korygujemy
                
                SDokKor={}
                # pomocnicza lista - wykorzystanych dowodw pierwotnych 
                LDowPierwPom=[]
                
                for poz in LPozycjeDoKor:
                    if stat=='OK':
                        DaneArt=poz[0]
                        Ilosc1=poz[1]
                        LDowodowPierw=poz[3]
                        SprawdzoneFaktury=''
                        
                        # ustawienie kolejnoci analizy Dowodw pierwotnych. Najpierw
                        # te ktre s ju na wykorzystywane. Potem reszta
                        LDowodowPom=[]
                        for dowpierw in LDowodowPierw:
                            if dowpierw in LDowPierwPom:
                                LDowodowPom.append([0,dowpierw])
                            else:
                                LDowodowPom.append([1,dowpierw])
                                
                        LDowodowPom.sort()
        
                        for dowpierw in LDowodowPom:
                            if stat=='OK' and Ilosc1>0:
                                DokPoprz=('','','',0)
                                dow=dowpierw[1]
                                if dow[0]<>'':
                                    # pobranie faktury utworzonej do pierwotnego dowodu dostawy
                                    SQL="SELECT COALESCE(f_wyznacznik_id,''),f_data,f_numer FROM rs_dowody_dostaw "
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+dow[0]+"' AND trasa='"+dow[1]+"'"
                                    SQL+=" AND data='"+dow[2]+"' AND tryb_dostawy='"+dow[3]+"' AND numer="+str(dow[4])+";"
                                    stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)              
                                    if stat<>'OK':
                                        stat='Bdy pobierania faktury z pierwotnego dowodu dostawy :'+stat
                                        
                                    if stat=='OK':
                                        if len(DFakt)>0:
                                            if DFakt[0][0]<>'':
                                                # sprawdzenie czy istniej korekty do wybranej faktury
                                                SQL="SELECT wyznacznik_id,data,numer FROM rs_korekty"
                                                SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_o='"+DFakt[0][0]+"'"
                                                SQL+=" AND data_o='"+DFakt[0][1]+"' AND numer_o="+str(DFakt[0][2])
                                                SQL+=" ORDER BY data DESC LIMIT 1;"
                                                stat,DKor,dump,dump = self.PolSQL.Execute(SQL,3)              
                                                if stat<>'OK':
                                                    stat='Bdy pobierania faktury z pierwotnego dowodu dostawy :'+stat
                            
                                                if stat=='OK':
                                                    if len(DKor)>0:
                                                        # jeli data nie jest wiksza ni data tworzonej korekty
                                                        if DKor[0][1]<=DataFakt:
                                                            DokPoprz=('korekty',DKor[0][0],DKor[0][1],DKor[0][2])
                                                    else:
                                                        DokPoprz=('faktury',DFakt[0][0],DFakt[0][1],DFakt[0][2])
                                    
                                
                                if stat=='OK' and DokPoprz<>('','','',0):
                                    # sprawdzamy czy dokument jest zamknity (jeli nie to go ignorujemy)
                                    SQL="SELECT stan FROM rs_"+DokPoprz[0]+" WHERE firma_id='"+self.firma_id+"'" 
                                    SQL+=" AND wyznacznik_id='"+DokPoprz[1]+"' AND data='"+DokPoprz[2]+"' AND numer="+str(DokPoprz[3])
                                    stat,DTestStan,dump,dump = self.PolSQL.Execute(SQL,3)              
                                    if stat=='OK':
                                        if len(DTestStan)==0:
                                            DokPoprz=('','','',0)
                                        elif not DTestStan[0][0] in ('Z','K'):
                                            DokPoprz=('','','',0)
                                    
                                if stat=='OK' and DokPoprz<>('','','',0):
                                    # sprawdzamy czy na tym dokumencie jest co wyda dla artykuu o podanych parametrach                    
                                    SQL="SELECT nr_poz,nr_ppoz,ilosc1 FROM rs_"+DokPoprz[0]+"_pozycje WHERE firma_id='"+self.firma_id+"'" 
                                    SQL+=" AND wyznacznik_id='"+DokPoprz[1]+"' AND data='"+DokPoprz[2]+"' AND numer="+str(DokPoprz[3])
                                    SQL+=" AND artykul_id='"+DaneArt[0]+"' AND cena_brutto1="+str(DaneArt[5])+" AND ilosc1>0;"
                                    stat,DPozDok,dump,dump = self.PolSQL.Execute(SQL,3)              
                                    if stat<>'OK':
                                        stat="Bd pobierania danych pozycji z faktury/korekty : "+stat
                                    
                                    if stat=='OK':
                                        if len(DPozDok)>0:
                                            # moemy tyle wanie cign tego artykuu z wybranej faktury/korekty
                                            if not DokPoprz in SDokKor:
                                                SDokKor[DokPoprz]=[[DPozDok[0][0],DPozDok[0][1],min(DPozDok[0][2],Ilosc1)]]
                                            else:
                                                SDokKor[DokPoprz].append([DPozDok[0][0],DPozDok[0][1],min(DPozDok[0][2],Ilosc1)])
                                            # ewentualnie bd dwie pozycje, z tego cz bdzie na aktualnie obrabianej
                                            Ilosc1=Ilosc1-min(DPozDok[0][2],Ilosc1)
                                            # wiemy, e ten dowd jest wykorzystany wic trafia na list priorytetowych
                                            LDowPierwPom.append(dow)
                                            SprawdzoneFaktury+=" AND NOT (wyznacznik_id='"+DokPoprz[1]+"'"
                                            SprawdzoneFaktury+=" AND data='"+DokPoprz[2]+"' AND numer='"+str(DokPoprz[3])+"')"
                                
                        # jeli tu jestemy, to znaczy, e z wybranych dowodw nie udao si zrobi korekt i musimy poszuka 
                        # korekty w puli korekt oglnych
                        while Ilosc1>0 and stat=='OK':
                            SQL="SELECT fp.wyznacznik_id,fp.data,fp.numer,fp.nr_poz,fp.nr_ppoz,fp.ilosc1 "
                            SQL+=" FROM rs_faktury_pozycje fp "
                            SQL+=" INNER JOIN rs_faktury f USING (firma_id,wyznacznik_id,data,numer) "
                            SQL+=" WHERE fp.firma_id='"+self.firma_id+"' AND fp.data<='"+DataFakt+"'"
                            SQL+=" AND fp.artykul_id='"+DaneArt[0]+"' "
                            SQL+=" AND fp.cena_brutto1="+str(DaneArt[5])+" AND f.stan IN ('Z','K') "
                            SQL+=" AND f. kontrahent_id='"+kl[0]+"' AND f.platnik_id='"+kl[1]+"'"
                            SQL+=SprawdzoneFaktury
                            SQL+=" ORDER BY data DESC LIMIT 1;"
                            
                            stat,DPozFakt,dump,dump = self.PolSQL.Execute(SQL,3)              
                            if stat<>'OK':
                                stat="Bd pobierania danych pozycji z losowej faktury/korekty : "+stat
                            
                            if stat=='OK':
                                if len(DPozFakt)==0:
                                    stat=" Nie ma faktury dla pary (kontrahent,patnik) rwnej ("+str(kl)[1:-1]+"), z ktrej mona zdj artyku "+DaneArt[0].strip()+" w iloci "+str(Ilosc1)+" oraz cenie brutto "+str(DaneArt[5])
                                    
                            if stat=='OK':
                                # dodanie faktury do listy ju sprawdzonych faktur
                                SprawdzoneFaktury+=" AND NOT (wyznacznik_id='"+DPozFakt[0][0]+"'"
                                SprawdzoneFaktury+=" AND data='"+DPozFakt[0][1]+"' AND numer='"+str(DPozFakt[0][2])+"')"
                                
                                # sprawdzenie czy istniej korekty do wybranej faktury 
                                SQL="SELECT wyznacznik_id,data,numer FROM rs_korekty"
                                SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_o='"+DPozFakt[0][0]+"'"
                                SQL+=" AND data_o='"+DPozFakt[0][1]+"' AND numer_o="+str(DPozFakt[0][2])
                                SQL+=" ORDER BY data DESC LIMIT 1;"
                                stat,DKor,dump,dump = self.PolSQL.Execute(SQL,3)              
                                if stat<>'OK':
                                    stat='Bdy pobierania korekty do losowej faktury :'+stat
            
                                # jeli nie ma korekty to zdejmujemy ilo z faktury
                                if stat=='OK' and len(DKor)==0:
                                    DokPoprz=('faktury',DPozFakt[0][0],DPozFakt[0][1],DPozFakt[0][2])
                                    if not DokPoprz in SDokKor:
                                        SDokKor[DokPoprz]=[[DPozFakt[0][3],DPozFakt[0][4],min(DPozFakt[0][5],Ilosc1)]]
                                    else:
                                        SDokKor[DokPoprz].append([DPozFakt[0][3],DPozFakt[0][4],min(DPozFakt[0][5],Ilosc1)])
                                    Ilosc1=Ilosc1-min(DPozFakt[0][5],Ilosc1)
                                
                                # jeli za jest korekta i jeli jej data nie jest wiksza ni data tworzonej korekty
                                if stat=='OK' and len(DKor)>0:
                                    if DKor[0][1]<=DataFakt:
                                        # sprawdzamy czy na tym dokumencie jest co wyda dla artykuu o podanych parametrach                
                                        DokPoprz=('korekty',DKor[0][0],DKor[0][1],DKor[0][2])
                                        SQL="SELECT nr_poz,nr_ppoz,ilosc1 FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"'" 
                                        SQL+=" AND wyznacznik_id='"+DokPoprz[1]+"' AND data='"+DokPoprz[2]+"' AND numer="+str(DokPoprz[3])
                                        SQL+=" AND artykul_id='"+DaneArt[0]+"' AND cena_brutto1="+str(DaneArt[5])+" AND ilosc1>0;"
                                        stat,DPozDok,dump,dump = self.PolSQL.Execute(SQL,3)              
                                        if stat<>'OK':
                                            stat="Bd pobierania danych pozycji z faktury/korekty : "+stat
                                    
                                        if stat=='OK':
                                            if len(DPozDok)>0:
                                                # moemy tyle wanie cign tego artykuu z wybranej faktury/korekty
                                                if not DokPoprz in SDokKor:
                                                    SDokKor[DokPoprz]=[[DPozDok[0][0],DPozDok[0][1],min(DPozDok[0][2],Ilosc1)]]
                                                else:
                                                    SDokKor[DokPoprz].append([DPozDok[0][0],DPozDok[0][1],min(DPozDok[0][2],Ilosc1)])
                                                # ewentualnie bd dwie pozycje, z tego cz bdzie na aktualnie obrabianej
                                                Ilosc1=Ilosc1-min(DPozDok[0][2],Ilosc1)
                                            

                # tworzenie faktur korygujcych dla pary kontrahent/patnik. Mamy ju list dokumentw do ktrych bdziemy 
                # wystawia korekty oraz list pozycji z ktrych bdziemy je wystawia
                if stat=='OK' and SDokKor<>{}:
                    # sprawdzamy czy mona dodawa korekty z t dat dla tego wyznacznika
                    SQL="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"
                    SQL+= self.firma_id+"','[\\\'"+WyznKor+"\\\',\\\'"+DataFakt+"\\\']','K');"
                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)    
                    if stat<>'OK':
                        stat=' Bdy sprawdzania czy mona wstawi korekt z wybran dat'
                
                    if stat=='OK':
                        if DTest[0][0]<>'OK':
                            stat='Nie mona wystawi korekty z podan dat : '+DTest[0][0]
                    
                    if stat=='OK':
                        #wybieramy kolejny numer korekty
                        SQL="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+WyznKor+"\\\',\\\'"+DataFakt+"\\\']','K');"
                        stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)        
                        if stat<>'OK':
                            stat=" Bdy przy pobieraniu nowego numeru korekty : "+stat
                            
                        if stat=='OK':
                            if DNr[0][0] in (None,'None',''):
                                stat=u"Bdy przy pobieraniu numeru korekty"
                                
                    if stat=='OK':        
                        # ten numer bdziemy powiksza rcznie o 1. Wyznacznik korekty jest zablokowany wic jest to bezpieczne
                        NumerK=int(DNr[0][0])
                        
                        PomOpis=' dotyczy korekt dowodw dostaw od dnia '+DataOd+' do dnia '+DataDo
                        if CzyKateg:
                            PomOpis+=" i czstoci fakturowania kontrahentw "+Kateg
                        
                        for korekta in SDokKor:
                            if stat=='OK':
                                Typ=korekta[0]
                                
                                if Typ=='faktury':
                                    TypDokP='F'
                                    PolaO='wyznacznik_id,data,numer,'
                                else:
                                    TypDokP='K'
                                    PolaO='wyznacznik_id_o,data_o,numer_o,'
                                    
                                # wstawienie nagowka korekty
                                InsN='INSERT INTO rs_korekty '
        
                                InsN+='(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,typ_dok_p,wyznacznik_id_p,data_p,numer_p,wyznacznik_id_o,data_o,numer_o,'
                                InsN2="firma_id,'"+WyznKor+"','"+DataFakt+"',"+str(NumerK)+",'"+self.oddzial_id+"','W','"+TypDokP+"',wyznacznik_id,data,numer,"+PolaO
                                
                                InsN+='kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,dostawy_od_dnia,dostawy_do_dnia,kierowca,projekt_id,'
                                InsN2+="kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,dostawy_od_dnia,dostawy_do_dnia,kierowca,projekt_id,"
                                                
                                InsN+='tytul_zmniejszenia_podatku,opis,waluta,kurs,nr_tabeli,data_tabeli,kurs_p,nr_tabeli_p,data_tabeli_p,'
                                InsN2+="'"+Tytul+"','"+PomOpis+"',waluta,kurs,nr_tabeli,data_tabeli,kurs,nr_tabeli,data_tabeli,"
                                                
                                InsN+='wersja,sposob_zaplaty,dni,data_odbioru,wersja_p,sposob_zaplaty_p,dni_p,data_odbioru_p,'
                                InsN2+="wersja,sposob_zaplaty,dni,NULL,wersja,sposob_zaplaty,dni,data_odbioru,"
                                                
                                InsN+='termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,czy_bonus,tekst_nad_podp,tekst_pod_podp,kraj_opodatkowania,'
                                InsN2+="'"+DataFakt+"'::DATE + dni::INTEGER,handlowiec,sposob_odbioru_faktury,sposob_dostawy,czy_bonus,tekst_nad_podp,tekst_pod_podp,kraj_opodatkowania,"
                                                
                                InsN+='upust,upust_wartosc,upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal,'
                                InsN2+='upust,upust_wartosc,upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal,'
                                                
                                InsN+='kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,'
                                InsN2+='kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,'
        
                                InsN+='upust_p,upust_wartosc_p,upust_wartosc_wal_p,rabat_p,rabat_wartosc_p,rabat_wartosc_wal_p,'
                                InsN2+='upust,upust_wartosc,upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal,'
                                                                                                                                                                        #AB 01.08.19r
                                InsN+='kwota_netto_p,kwota_vat_p,wartosc_opakowan_p,do_zaplaty_p,kwota_netto_wal_p,kwota_vat_wal_p,wartosc_opakowan_wal_p,do_zaplaty_wal_p, czy_mpp)'
                                InsN2+='kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal, czy_mpp'
                                                                        
                                InsN+=" SELECT "+InsN2+" FROM rs_"+Typ+" WHERE firma_id='"+self.firma_id+"'"
                                InsN+=" AND wyznacznik_id='"+korekta[1]+"' AND data='"+korekta[2]+"'"
                                InsN+=" AND numer="+str(korekta[3])+";"
                            
                                # wstawienie wszystkich pozycji z faktury/korekty w postaci nieobrobionej
                                InsP="INSERT INTO rs_korekty_pozycje "
                                
                                InsP+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,artykul_id,"
                                InsP2="firma_id,'"+WyznKor+"','"+DataFakt+"',"+str(NumerK)+",nr_poz,nr_ppoz,artykul_id,"
                                                  
                                InsP+="ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
                                InsP2+="ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
                
                                InsP+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
                                InsP2+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
                                        
                                InsP+="ilosc1_p,ilosc2_p,cena_netto1_p,cena_netto2_p,cena_upust1_p,cena_upust2_p,cena_brutto1_p,cena_brutto2_p,"
                                InsP2+="ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
        
                                InsP+="upust_p,upust_wartosc_p,stawka_vat_p,wartosc_netto_p,wartosc_vat_p,wartosc_brutto_p,"
                                InsP2+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
                                                   
                                InsP+="nr_serii,termin_przyd,cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
                                InsP2+="nr_serii,termin_przyd,cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
                                                    
                                InsP+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
                                InsP2+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
                                                    
                                InsP+="cena_wal1_p,cena_wal2_p,cena_upust_wal1_p,cena_upust_wal2_p,"
                                InsP2+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
                                                    
                                InsP+="wartosc_wal_netto_p,wartosc_wal_vat_p,wartosc_wal_brutto_p,cecha1_opis,cecha1_wartosc,kod_gtu)" #MK 2020-04-03
                                InsP2+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,cecha1_opis,cecha1_wartosc,kod_gtu"  #MK 2020-04-03
        
                                InsP+=" SELECT "+InsP2+" FROM rs_"+Typ+"_pozycje WHERE firma_id='"+self.firma_id+"'"
                                InsP+=" AND wyznacznik_id='"+korekta[1]+"' AND data='"+korekta[2]+"'"
                                InsP+=" AND numer="+str(korekta[3])+";"
                                
                                #UPDATE na zmienione wartosci tylko dla zmienionych pozycji 
                                # (to przepisuje odpowiednio kwoty do nagwka i stawek vat)
                                # wykonywany po przepisaniu "czystej" faktury/korekty
                    
                                UpdP=''
                                for poz in SDokKor[korekta]:
                                    NrPoz,NrPPoz,IleZdjac=poz
                                    
                                    Przel="(SELECT przelicznik FROM rs_artykuly WHERE "
                                    Przel+="firma_id=rs_korekty_pozycje.firma_id AND artykul_id=rs_korekty_pozycje.artykul_id)"
                                    StVat="CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE stawka_vat::INTEGER END"
                                    
                                    Ilosc1="(ilosc1-"+str(IleZdjac)+")"
                                    Ilosc2="("+Ilosc1+'*'+Przel+")"
                                    UpustWart="ROUND("+Ilosc1+"*(cena_netto1-cena_upust1),2)"
                                    WartN="ROUND("+Ilosc1+"*cena_upust1,2)"
                                    WartV="ROUND("+Ilosc1+"*cena_upust1*0.01*"+StVat+",2)"
                                    WartB="ROUND("+WartN+"+"+WartV+",2)"
                                    WartNW="ROUND("+Ilosc1+"*cena_upust_wal1,2)"
                                    WartVW="ROUND("+Ilosc1+"*cena_upust_wal1*0.01*"+StVat+",2)"
                                    WartBW="ROUND("+WartN+"+"+WartV+",2)"
                                                
                                    UpdP+="UPDATE rs_korekty_pozycje SET ilosc1="+Ilosc1+", ilosc2="+Ilosc2+",upust_wartosc="+str(UpustWart)+","
                                    UpdP+="wartosc_netto="+str(WartN)+", wartosc_vat="+str(WartV)+", wartosc_brutto="+str(WartB)+","
                                    UpdP+="wartosc_wal_netto="+str(WartNW)+", wartosc_wal_vat="+str(WartVW)+", wartosc_wal_brutto="+str(WartBW)
                                    UpdP+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznKor+"' AND data='"+DataFakt+"'"
                                    UpdP+=" AND numer="+str(NumerK)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+" ;"+chr(10)
                                    
                                #--- pobranie i wstawienie ewentualnych pozycji opisowych
                                InsO="INSERT INTO rs_korekty_pozycje_opisowe (firma_id,wyznacznik_id,data,numer,nr_poz,opis_pozycji,stawka_vat,wartosc_netto,"
                                InsO+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto, opis_pozycji_p,"
                                InsO+="stawka_vat_p, wartosc_netto_p, wartosc_vat_p, wartosc_brutto_p, wartosc_wal_netto_p, wartosc_wal_vat_p,"
                                InsO+="wartosc_wal_brutto_p,kod_gtu) " #MK 2020-04-03
                                InsO+="SELECT firma_id,'"+WyznKor+"','"+DataFakt+"',"+str(NumerK)+",nr_poz,opis_pozycji,stawka_vat,wartosc_netto,"
                                InsO+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto, opis_pozycji,"
                                InsO+="stawka_vat, wartosc_netto, wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat,wartosc_wal_brutto, kod_gtu" #MK 2020-04-03
                                InsO+=" FROM rs_"+Typ+"_pozycje_opisowe WHERE firma_id='"+self.firma_id+"'"
                                InsO+=" AND wyznacznik_id='"+korekta[1]+"' AND data='"+korekta[2]+"' AND numer="+str(korekta[3])+";"
    
                                #--- pobranie i wstawienie stawek vat
                                InsV="INSERT INTO rs_korekty_vat (firma_id,wyznacznik_id,data,numer,stawka_vat,wartosc_netto,"
                                InsV+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
                                InsV+="wartosc_netto_p, wartosc_vat_p, wartosc_brutto_p, wartosc_wal_netto_p, wartosc_wal_vat_p,wartosc_wal_brutto_p) "
                                InsV+="SELECT firma_id,'"+WyznKor+"','"+DataFakt+"',"+str(NumerK)+",stawka_vat,wartosc_netto,"
                                InsV+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
                                InsV+="wartosc_netto, wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat,wartosc_wal_brutto"
                                InsV+=" FROM rs_"+Typ+"_vat WHERE firma_id='"+self.firma_id+"'"
                                InsV+=" AND wyznacznik_id='"+korekta[1]+"' AND data='"+korekta[2]+"' AND numer="+str(korekta[3])+";"
        
                                # faktyczne utworzenie korekty
                                stat,dump,dump,dump = self.PolSQL.Execute(InsN,1)
                                if stat <> 'OK':
                                    stat='Bd tworzenia nagwka korekty : '+stat
                                    
                            if stat == 'OK':
                                stat = fs_sprzedaz_pom.PrzeniesUdzialyHandlowcowZFakturyDoKorekty(self,WyznKor,DataFakt,NumerK)
                                
                            if stat=='OK':    
                                stat,dump,dump,dump = self.PolSQL.Execute(InsP,1)
                                if stat <> 'OK':
                                    stat='Bd tworzenia pozycji korekty : '+stat
    
                            if stat=='OK':    
                                stat,dump,dump,dump = self.PolSQL.Execute(InsO,1)
                                if stat <> 'OK':
                                    stat='Bd tworzenia pozycji opisowych korekty : '+stat
                                    
                            if stat=='OK':    
                                stat,dump,dump,dump = self.PolSQL.Execute(InsV,1)
                                if stat <> 'OK':
                                    stat='Bd tworzenia stawek vat korekty : '+stat
    
                            if stat=='OK':    
                                stat,dump,dump,dump = self.PolSQL.Execute(UpdP,1)
                                if stat <> 'OK':
                                    stat='Bd zmieniania pozycji korekty : '+stat
        
                            if stat=='OK':  
                                NumerK+=1
                                        
        #-------------------------------------------------- 
        # jestemy po utworzeniu faktur i korekt. Teraz czynnoci domykajce    
        #--------------------------------------------------
        if stat=='OK':
            # zmiana stanu wszystkich uwzgldnionych korekt dowodw dostaw na 4
            SQL="UPDATE rs_dowody_dostaw SET stan='4'"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
            SQL+=" AND data>='"+DataOd+"' AND data <='"+DataDo+"' AND stan='2' AND f_wyznacznik_id IS NULL"
            if CzyKateg:
                SQL+=" AND TRIM(rsf_podaj_czestosc_kontrahenta(firma_id,kontrahent_id,oddzial_id))=TRIM('"+Kateg+"')"        
            SQL+=" AND korekta;"
            
            # wstawienie dowodom dostaw im numeru faktury
            for dowod in LDostFakt:
                KlFakt=LDostFakt[dowod]
                SQL+="UPDATE rs_dowody_dostaw SET f_wyznacznik_id='"+KlFakt[0]+"',"
                SQL+="f_data='"+KlFakt[1]+"',f_numer="+str(KlFakt[2])
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
                SQL+=" AND trasa='"+dowod[0]+"' AND data='"+dowod[1]+"' AND tryb_dostawy='"+dowod[2]+"'"
                SQL+=" AND numer="+str(dowod[3])+";"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)              

    else:
        #-##############################################################################
        #-------------------------------------------------------------------------------
        # WYKONANIE FAKTUR Z POZOSTAYCH DOWODW DOSTAW
        #-------------------------------------------------------------------------------
        #-##############################################################################

        if stat=='OK':
            #pobranie listy kontrahentw i artykuw z rabatem finansowym i zamiana na sownik
            # najpierw pobieramy wszystkie pary artyku-kontrahent, ktrych moe dotyczy rabat w dniu daty faktury.
            # Potem pobieramy dla nich po kolei informacj, jakie naprawd warunki obowizuj.
            SQL="SELECT DISTINCT TRIM(kontrahent_id),TRIM(artykul_id) FROM rs_kontrahenci_upusty "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND NOT rabat_finansowy_indeks IS NULL"
            SQL+=" AND data_od<='"+DataFakt+"' AND (data_do>='"+DataFakt+"' OR data_do IS NULL);"
            #print 1, SQL
            stat,DKontrArt,dump,dump = self.PolSQL.Execute(SQL ,3)
    
        if stat=='OK':
            # sownik z kluczem kontrahent+artyku oraz wynikiem indeks_rabatu, procent
            SRabatowF={}
            # sownik z kluczem artykul_rabatowy oraz wynikiem stawka_vat, warto netto
            SArtRabatow={}
            for poz in DKontrArt:
                if stat=='OK':
                    SQL="SELECT COALESCE(TRIM(rabat_finansowy_indeks),''), rabat_finansowy, rsf_podaj_vat_artykulu(firma_id,rabat_finansowy_indeks,'"+DataFakt+"')"
                    SQL+=" FROM rs_kontrahenci_upusty WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(poz[0])+"'"
                    SQL+=" AND artykul_id='"+rsglobal.Dekoduj(poz[1])+"'"
                    SQL+=" AND data_od<='"+DataFakt+"' AND (data_do>='"+DataFakt+"' OR data_do IS NULL) ORDER BY data_od DESC LIMIT 1;"
                    #print 2, SQL
                    stat,DRabat,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat=='OK':
                    if len(DRabat)>0:
                        if DRabat[0][0]<>'' and DRabat[0][1]<>0:
                            SRabatowF[(poz[0],poz[1])]=DRabat[0][0:2]
                            SArtRabatow[DRabat[0][0]]=[DRabat[0][2],0]
                            if len(DRabat[0][2])>2:
                                stat=' Bd rabatu finansowego : '+DRabat[0][2]
            
            #pobranie kontrahenta i patnika z nagwkw dowodw dostaw
            SQLKontr="SELECT DISTINCT dd.kontrahent_id,COALESCE(k.platnik_id,dd.kontrahent_id) as platnik "
            SQLKontr+=" FROM rs_dowody_dostaw dd INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id) "
            SQLKontr+=" WHERE dd.firma_id = '"+self.firma_id+"' AND dd.stan='2' AND dd.data >='"+DataOd+"'"
            SQLKontr+=" AND dd.data <='"+DataDo+"' AND dd.oddzial_id='"+self.oddzial_id+"'"
            if CzyKateg:
                SQLKontr+=" AND TRIM(rsf_podaj_czestosc_kontrahenta(dd.firma_id,k.kontrahent_id,dd.oddzial_id))=TRIM('"+Kateg+"')"
            SQLKontr+=" ORDER BY platnik,dd.kontrahent_id;"
            #print 3, SQLKontr
            stat,DKontr,dump,dump = self.PolSQL.Execute(SQLKontr ,3)
        if stat=='OK':
            if len(DKontr) == 0:
                stat = "Brak dowodw dostaw dla podanych parametrw"
        
            SPlat={}
            Plat=''
            
            #-------------------------------------------------------
            #--- Ptla po kontrahentach dzielca ich na patnikw
            #-------------------------------------------------------
            if stat=='OK':
                for kontr in DKontr:
                    if stat=='OK':
                        PlatN=rsglobal.Dekoduj(kontr[1])
                        if PlatN<>Plat:
                            SQL = "SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,"
                            SQL+=" sposob_odbioru_faktury,rozliczac_zwroty,projekt_id, limit_zwrotow_faktury, osobny_rachunek_vat "
                            SQL+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND kontrahent_id = '"+PlatN+"' AND data_od <= '"+DataDo+"'"
                            SQL+=" ORDER BY data_od DESC LIMIT 1;"
                            #print 4, SQL
                            stat,DFaktPlat,dump,dump = self.PolSQL.Execute(SQL, 3)
                            if DFaktPlat != []:
                                OddzielnyVAT = DFaktPlat[0][10]

                            if len(DFaktPlat)==0:
                                stat='Brak danych do fakturowania dla patnika '+PlatN
                            if stat=='OK':
                                if Plat <> '':
                                    SPlat[Plat]=[LRazemZbiorcza,LRazemNieZbiorcza,LOsobnoZbiorcza,LOsobnoNieZbiorcza,SPlat[Plat][4]]
                                SPlat[PlatN]=([],[],[],[],DFaktPlat[0])
                                LRazemZbiorcza=[]
                                LRazemNieZbiorcza=[]
                                LOsobnoZbiorcza=[]
                                LOsobnoNieZbiorcza=[]
                                Plat=PlatN
                    
                        #sprawdzenie do ktrej z kategorii nalezy kontrahent
                        if stat=="OK":
                            SQL= "SELECT czy_osobna,czy_zbiorcza FROM rs_kontrahenci_fakturowanie "
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+rsglobal.Dekoduj(kontr[0])+"' "
                            SQL+=" AND data_od <= '"+DataDo+"' ORDER BY data_od DESC LIMIT 1;"
                            #print 5, SQL
                            dump,DFaktKontr,dump,dump = self.PolSQL.Execute(SQL, 3)
                            if len(DFaktKontr)==0:
                                LOsobnoZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                            elif DFaktKontr[0][0] and DFaktKontr[0][1]:
                                LOsobnoZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                            elif DFaktKontr[0][0] and not DFaktKontr[0][1]:
                                LOsobnoNieZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                            elif not DFaktKontr[0][0] and DFaktKontr[0][1]:
                                LRazemZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                            elif not DFaktKontr[0][0] and not DFaktKontr[0][1]:
                                LRazemNieZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
            if stat=='OK':    
                SPlat[Plat]=[LRazemZbiorcza,LRazemNieZbiorcza,LOsobnoZbiorcza,LOsobnoNieZbiorcza,SPlat[Plat][4]]       
    
                SListaGrup={}
                for plat in SPlat:
                    if stat=='OK':
                        DPl=SPlat[plat]
                        # razem zbiorcza
                        if len(DPl[0])>0:
                            SListaGrup[(plat,str(DPl[0])[1:-1])]=[False,True,DPl[4]]
                        # razem nie zbiorcza    
                        if len(DPl[1])>0:
                            SListaGrup[(plat,str(DPl[1])[1:-1])]=[False,False,DPl[4]]
                        # osobno zbiorcza    
                        for kontr in DPl[2]:
                            SListaGrup[(plat,kontr)]=[True,True,DPl[4]]
                        # osobno nie zbiorcza                                
                        for kontr in DPl[3]:
                            SListaGrup[(plat,kontr)]=[True,False,DPl[4]]
                 
                #----------------------------------------------------------------------------------
                #ptla po kontrahentach lub grupach kontrahentw przypitych do jednego patnika   
                #---------------------------------------------------------------------------------- 
                
            if stat=='OK':
                KluczeSLGrup=SListaGrup.keys()
                KluczeSLGrup.sort()
                for kontr in KluczeSLGrup:
                    if stat=='OK':
                        LDokumentowZFakturami={}
                        DKontr=SListaGrup[kontr]
                        # sprawdzenie czy patnik ma wczone sortowanie po artykule obcym
                        SQLKontr="SELECT rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"',"
                        SQLKontr+="'"+kontr[0]+"','"+DataFakt+"','sort_wg_symboli_obcych');"
                        stat,DSort,dump,dump = self.PolSQL.Execute(SQLKontr,3)
                        if stat<>"OK":
                            stat = 'Bdy przy pobieraniu danych o sortowaniu kontrahentw dla patnika:'+stat
                            dane.append(stat)
                    
                    if stat=='OK':
                        SortWgObcych=''
                        if len(DSort)>0:
                            if DSort[0][0]=='true':
                                SortWgObcych+='P'
                        
                        #osobne
                        if DKontr[0]:
                            # sprawdzenie czy kontrahent ma wczone sortowanie po artykule obcym
                            SQLKontr="SELECT rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"',"
                            SQLKontr+="'"+kontr[1]+"','"+DataFakt+"','sort_wg_symboli_obcych');"
                            stat,DSort,dump,dump = self.PolSQL.Execute(SQLKontr,3)
                            if stat<>"OK":
                                stat = 'Bdy przy pobieraniu danych o sortowaniu kontrahentw dla kontrahenta:'+stat
                                dane.append(stat)
                            if stat=='OK':
                                if len(DSort)>0:
                                    if DSort[0][0]=='true':
                                        SortWgObcych+='K'
                            FiltrKontr=" AND dd.kontrahent_id='"+kontr[1]+"'"
                        else:
                            FiltrKontr=" AND dd.kontrahent_id IN ("+kontr[1]+")"
            
                    if stat=='OK' and SortWgObcych<>'':
                        #blokada odpowiednich dowodw dostaw (tylko gdy sort wg obcych)
                        SQLBlok="SELECT dd.numer_zamowienia FROM rs_dowody_dostaw dd "
                        SQLBlok+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"'"
                        SQLBlok+=" AND dd.data>='"+DataOd+"' AND dd.data <='"+DataDo+"' AND dd.stan='2'"
                        SQLBlok+=FiltrKontr+" AND (NOT dd.korekta OR dd.korekta IS NULL) FOR UPDATE NOWAIT;"
                        stat,dump,dump,dump = self.PolSQL.Execute(SQLBlok,3)  
                    
                    if stat=='OK':    
                        #pobranie pozycji z dowodw dostaw
                        SQLDow="SELECT dd.numer_zamowienia,dd.data,dp.artykul_id,dp.cena_netto1,dp.cena_netto2,dp.cena_upust1,dp.cena_upust2,dp.cena_brutto1,dp.cena_brutto2," # 0 - 8
                        SQLDow+="dp.ilosc_dost1,dp.ilosc_dost2,dp.ilosc_zwr1,dp.ilosc_zwr2,dd.trasa||'/'||dd.data||'/'||dd.tryb_dostawy||'/'||dd.numer||'/'||dp.nr_poz" #9-13
                        SQLDow+=",dd.trasa,dd.data,dd.tryb_dostawy,dd.numer,dp.nr_poz,dp.stawka_vat,dp.nr_poz,dd.data_zamowienia," #14-21
                        if SortWgObcych=='': # 22
                            SQLDow+="''"
                        elif SortWgObcych=='K':
                            SQLDow+="COALESCE(aok.obcy_id,'')"
                        elif SortWgObcych=='P':
                            SQLDow+="COALESCE(aop.obcy_id,'')"
                        elif SortWgObcych=='PK':
                            SQLDow+="COALESCE(aok.obcy_id,aop.obcy_id,'')"
                        SQLDow+=" FROM rs_dowody_dostaw_pozycje dp INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
                        if 'K' in SortWgObcych:
                            SQLDow+=" LEFT OUTER JOIN rs_artykuly_obce aok ON (dp.firma_id=aok.firma_id "
                            SQLDow+=" AND dp.artykul_id=aok.artykul_id AND aok.kontrahent_id='"+kontr[1]+"')"
                        if 'P' in SortWgObcych:
                            SQLDow+=" LEFT OUTER JOIN rs_artykuly_obce aop ON (dp.firma_id=aop.firma_id "
                            SQLDow+=" AND dp.artykul_id=aop.artykul_id AND aop.kontrahent_id='"+kontr[0]+"')"
                        SQLDow+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' AND dd.data>='"+DataOd+"' AND dd.data <='"+DataDo+"' AND dd.stan='2'"
                        SQLDow+=FiltrKontr+" AND (NOT dd.korekta OR dd.korekta IS NULL) "
                        SQLDow+=" ORDER BY dd.numer_zamowienia,dd.kontrahent_id,dd.data,dd.trasa,dd.tryb_dostawy,dd.numer,dp.artykul_id"
                        if SortWgObcych=='':
                            SQLDow+=" FOR UPDATE NOWAIT"
                        stat,DDow,dump,dump = self.PolSQL.Execute(SQLDow,3)

                    # teraz robimy list, ktra po posortowaniu da nam odpowiedni kolejno artykuem obcym/zwykym. Jeli nie ma obcych 
                    # to kolejno bdzie zwykymi. Potem sortujemy a na kocu gdy przegldamy pozycje do wstawienia na faktur to idziemy 
                    # zgodnie z ustawion tu kolejnoci.
                    if stat=='OK':
                        LKluczeArtObcych=[]
                        for poz in DDow:
                            kl=[poz[22],poz[2]]
                            if not kl in LKluczeArtObcych:
                                LKluczeArtObcych.append(kl)
                        LKluczeArtObcych.sort()
                    
                    if stat=='OK':
                        #pobranie danych do fakturowania
                        KDni=str(DKontr[2][0])[0:-2]
                        KWersja=rsglobal.Dekoduj(DKontr[2][1])
                        if KWersja in (None,'None',''):
                            KWersja="NULL"
                        else:
                            KWersja="'"+KWersja+"'"
    
                        if DKontr[2][3] in (None,'None',''):
                            KSposZapl="NULL"
                        else:
                            KSposZapl="'"+rsglobal.Dekoduj(DKontr[2][3])+"'"
                            
                        if DKontr[2][4] in (None,'None',''):
                            KSposDost='NULL'
                        else:
                            KSposDost="'"+rsglobal.Dekoduj(DKontr[2][4])+"'"
    
                        if DKontr[2][5] in (None,'None',''):
                            KHandl="NULL"
                        else:
                            KHandl="'"+rsglobal.Dekoduj(DKontr[2][5])+"'"
                            
                        if DKontr[2][6] in (None,'None',''):
                            KSposOdbF="NULL"
                        else:
                            KSposOdbF="'"+rsglobal.Dekoduj(DKontr[2][6])+"'"
                        KRozlZwroty=rsglobal.Dekoduj(DKontr[2][7])
                        if DKontr[2][8] in (None,'None',''):
                            KProj="'zzzz'"
                        else:
                            KProj="'"+rsglobal.Dekoduj(DKontr[2][8])+"'"
                            
                        KLimitZwr = rsglobal.Dekoduj(DKontr[2][9])

                        if DKontr[2][8] not in (None, 'None', ''):
                            OddzielnyVAT=DKontr[2][10]
                        
                        #sprawdzenie ile faktur powinno zosta utworzonych i w jakich dniach
                        SArtCenaData={}
                        LFakt=[]
                        Klucz=[None,None,None]
                        for dow in DDow:

                            Zm=False
                            if stat=='OK':

                                NrZ=dow[0]
                                DataZam=dow[21]
                                DataZ=rsglobal.Dekoduj(dow[1])
                                
                                Art=rsglobal.Dekoduj(dow[2])
                                KluczDD=(dow[14],dow[15],dow[16],dow[17])
                                Cena=dow[5]
                                #zmiana numeru zamwienia
                                if NrZ <> Klucz[0]:
                                    Klucz[0]=NrZ
                                    Zm=True
                                #zmiana daty
                                if DataZ <> Klucz[1]:
                                    Klucz[1]=DataZ
                                    #jeli nie zbiorcza to zmieniamy
                                    if not DKontr[1]:
                                        Zm=True
                                
                                #zmiana klucza dowodu dostawy 
                                # zmieniamy jeli nie zbiorcza (kiedy byo tylko z dokadnoci do daty)
                                if not DKontr[1]:
                                    if KluczDD <> Klucz[2]:
                                        Klucz[2] = KluczDD
                                        Zm = True

                                #sprawdzenie czy zmienia si cena artykuu
                                if not Art in SArtCenaData:
                                    SArtCenaData[Art]=[Cena,DataZ]
                                    #print 1, Art,Cena
                                else:
                                    Stara=SArtCenaData[Art]
                                    #print 2, Art,Cena
                                    #cena zmieniona
                                    if Stara[0] <> Cena:
                                        #jak data zmieniona to nowa faktura
                                        if Stara[1]<>DataZ:
                                            SArtCenaData[Art]=[Cena,DataZ]
                                            Zm=True
                                        #inaczej - zmiana ceny jednego dnia - bd
                                        else:
                                            stat='Zmiana ceny w cigu dnia na artykule '+Art+' dnia '+DataZ+' na dowodzie '+dow[13]

                                if stat=='OK':
                                    if Zm:
                                        # jeli zbiorcza
                                        if DKontr[1]:
                                            LFakt.append([str(Klucz[0]),str(Klucz[1]),DataZ,'',dow[1],dow[1]])
                                        elif not [str(Klucz[0]),str(Klucz[1]),DataZ,KluczDD] in LFakt:
                                            LFakt.append([str(Klucz[0]),str(Klucz[1]),DataZ,KluczDD,dow[1],dow[1]])
                                    else:
                                        if LFakt[-1][4] > dow[1]:
                                            LFakt[-1][4] = dow[1]
                                        if LFakt[-1][5] < dow[1]:
                                            LFakt[-1][5] = dow[1]
                                    
                    #-------------------------------------------------------------------------
                    #teraz generujemy pojedycze faktury dla kokretnego patnika/kontrahenta
                    #-------------------------------------------------------------------------
                    if stat=='OK':
                        i=1
                        for fakt in LFakt:
                            rsglobal.ZapiszDoLogow('fakt '+str(fakt),1)
                            if stat=='OK':
                                # jeli limit % osignity to "na si" zamykamy dowody z 3 na 4
                                LimitOsiagniety=False
                                NrZam=fakt[0]
                                DataZ=fakt[2]
                                if DataZ in (None,'None',''):
                                    DataZ='NULL'
                                else:
                                    DataZ="'"+DataZ+"'"

                                # jeli zbiorcza to '', jeli nie to (trasa,data,tryb,numer)
                                KluczDD=fakt[3]

                                DataDostawOd=fakt[4]
                                DataDostawDo=fakt[5]
                                DataOdF=fakt[1]
                                if i==len(LFakt) or KluczDD <> '':
                                    DataDoF='NULL'
                                else:
                                    FaktNast=LFakt[i]
                                    NrZamNast=FaktNast[0]
                                    if NrZam <> NrZamNast:
                                        DataDoF='NULL'
                                    else:
                                        DataDoF =FaktNast[1]

                                #pobranie wolnego numeru faktury
                                stat,DNr,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+DataFakt+"\\\']','F');",3)
                                if DNr[0][0] in (None,'None',''):
                                    stat="Bdy przy pobieraniu numeru faktury"
                                NumerF=DNr[0][0]
                                #przygotowanie klucza,ktry bdzie wrzucany na nagwek dowodu dostawy
                                KluczFakt=[Wyzn,DataFakt,NumerF,False]

                                #kontrahent i inni na fakturze
                                # jeli razem i zbiorcza to wstawiamy patnika zamiast kontrahenta, w innym wypadku - zostaje kontrahent
                                if not DKontr[0] and DKontr[1]:
                                    KontrFakt=kontr[0].strip("'")
                                else:
                                    KontrFakt=kontr[1].strip("'")

                                dump,DZamaw,dump,dump = self.PolSQL.Execute("SELECT zamawiajacy_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+KontrFakt+"';", 3)
                                if str(DZamaw[0][0]).strip() in ('',None,'None'):
                                    ZamawFakt=KontrFakt
                                else:
                                    ZamawFakt=rsglobal.Dekoduj(DZamaw[0][0])

                                PlatnikFakt=kontr[0]
                            if stat=='OK':
                                KFDni = str(KDni); KFWersja = str(KWersja); KFSposZapl = str(KSposZapl); KFSposDost = str(KSposDost);
                                KFHandl = str(KHandl); KFSposOdbF = str(KSposOdbF); KFProj = str(KProj)
                                # pobranie danych z kontrahenta
                                if KontrFakt <> PlatnikFakt:
                                    SQLKontr="SELECT dni::INTEGER,wersja,spos_zaplaty,spos_dostawy,handlowiec,"
                                    SQLKontr+="sposob_odbioru_faktury,projekt_id,osobny_rachunek_vat "
                                    SQLKontr+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
                                    SQLKontr+=" AND kontrahent_id = '"+KontrFakt+"' AND data_od <= '"+DataFakt+"'"
                                    SQLKontr+=" ORDER BY data_od DESC LIMIT 1;"
                                    stat,DFaktPlat,dump,dump = self.PolSQL.Execute(SQLKontr, 3)

                                    if stat=='OK':
                                        if len(DFaktPlat) > 0:
                                            if DFaktPlat[0][0] <> -1: # dni
                                                KFDni = str(DFaktPlat[0][0])
                                            if not DFaktPlat[0][1] in (None,'None',''):
                                                KFWersja = "'"+DFaktPlat[0][1]+"'"
                                            if not DFaktPlat[0][2] in (None,'None',''):
                                                KFSposZapl = "'"+DFaktPlat[0][2]+"'"
                                            if not DFaktPlat[0][3] in (None,'None',''):
                                                KFSposDost = "'"+DFaktPlat[0][3]+"'"
                                            if not DFaktPlat[0][4] in (None,'None',''):
                                                KFHandl = "'"+DFaktPlat[0][4]+"'"
                                            if not DFaktPlat[0][5] in (None,'None',''):
                                                KFSposOdbF = "'"+DFaktPlat[0][5]+"'"
                                            if not DFaktPlat[0][6] in (None,'None',''):
                                                KFProj = "'"+DFaktPlat[0][6]+"'"
                                            OddzielnyVAT=DFaktPlat[0][7]

                            #WS 2019-08-06
                            if stat=='OK':
                                CzyMPP = False

                                SEL = """SELECT BOOL_OR(czy_mpp) FROM rs_kontrahenci WHERE firma_id = '{}' AND kontrahent_id in ('{}','{}');"""
                                SEL = SEL.format(self.firma_id, PlatnikFakt or 'NULL', KontrFakt or 'NULL')
                                stat,DMPP,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                                if stat != 'OK':
                                    stat = 'Bd przy pobieraniu danych patnika/kontrahenta: '+stat
                                elif DMPP[0][0]:
                                    CzyMPP = True

                            #MK 2020-04-22
                            if stat == 'OK':
                                sqls = "SELECT ozn_trans,ozn_sprzedaz"
                                sqls += " FROM rs_wyznaczniki"
                                sqls += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "';"
                                stat, dws, dump, dump = self.PolSQL.Execute(sqls, 3)
                                if stat <> 'OK':
                                    stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
                                    dane.append(stat)
                                if dws != []:
                                    OznTransS = dws[0][0]
                                    OznSprzS = dws[0][1]

                            if stat=='OK':
                                #przygotowanie dodania nagwka faktury
                                SqlN='INSERT INTO rs_faktury '
                                SqlN=SqlN+'(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,kraj_opodatkowania,'
                                SqlN=SqlN+'dostawy_od_dnia,dostawy_do_dnia,kierowca,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,'
                                SqlN=SqlN+'termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,projekt_id,upust,upust_wartosc,upust_wartosc_wal,'
                                SqlN=SqlN+'rabat,rabat_wartosc,rabat_wartosc_wal,kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,'
                                SqlN=SqlN+'kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,numer_z_rs,'
                                SqlN=SqlN+'zamowienie_nr,zamowienie_data,data_przychodu,osobny_rachunek_vat,czy_mpp,ozn_trans,ozn_sprzedaz)' #WS 2019-08-06 - dodane czy_mpp
                                SqlN=SqlN+' VALUES '
                                SqlN=SqlN+"('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerF)+",'"+self.oddzial_id+"','W','"+KontrFakt+"','"+ZamawFakt+"','"+PlatnikFakt+"',NULL,'PL',"
                                SqlN=SqlN+"'"+DataDostawOd+"','"+DataDostawDo+"',NULL,'PLN',1,NULL,NULL,"+KFWersja+","+KFSposZapl+","+KFDni+",NULL,"
                                SqlN=SqlN+"date '"+DataFakt+"' + integer '"+KFDni+"',"+KFHandl+","+KFSposOdbF+","+KFSposDost+","+KFProj+",0,0,0,"
                                SqlN=SqlN+"0,0,0,0,0,0,0,"
                                SqlN=SqlN+"0,0,0,0,'','','',"
                                SqlN=SqlN+"'"+NrZam+"',"+DataZ+",'"+DataDostawDo+"',"+str(OddzielnyVAT)+","+str(CzyMPP) #WS 2019-08-06 - dodane CzyMPP
                                if OznTransS not in ('None', ''):
                                    SqlN=SqlN+ ",'" + str(OznTransS) + "'"  #MK 2020-04-22
                                else:
                                    SqlN=SqlN+ ",NULL"
                                if OznSprzS not in ('None', ''):
                                    SqlN=SqlN+ ",'" + str(OznSprzS) + "'"  #MK 2020-04-22
                                else:
                                    SqlN=SqlN+ ",NULL"
                                SqlN = SqlN +");"

                                SQLTest="SELECT wyznacznik_id FROM rs_faktury WHERE firma_id='"+self.firma_id+"' "
                                SQLTest+=" AND wyznacznik_id='"+Wyzn+"' AND data='"+DataFakt+"' AND numer="+str(NumerF)
                                SQLTest+=" AND kontrahent_id='"+KontrFakt+"' AND zamawiajacy_id='"+ZamawFakt+"'"
                                SQLTest+=" AND platnik_id='"+PlatnikFakt+"';"
                                KluczFakturyTest=Wyzn+'/'+DataFakt+'/'+NumerF+' '+KontrFakt+' '+PlatnikFakt
                                # policzenie ilosci na faktur (kluczem jest artykul a polami - ilosci wyslane, zwroty oraz ceny
                                SIlosci={}
                                LRozliczone=[]
                                LDokPotencjalne=[]

                                # ptla po pozycjach. Brane s tylko te, ktre maj odpowiedni nr zamwienia i dat w zakresie.
                                for dow in DDow:
                                    if (NrZam==dow[0]) and (dow[1] >=DataOdF) and (DataDoF=='NULL' or dow[1]<DataDoF):
                                        # jeli podany konkretny klucz dowodu to te jest uwzgldniany
                                        if KluczDD=='' or (KluczDD == (dow[14],dow[15],dow[16],dow[17])):
                                            Art=dow[2]
                                            KluczDok=(rsglobal.Dekoduj(dow[14]),rsglobal.Dekoduj(dow[15]),rsglobal.Dekoduj(dow[16]),dow[17])
                                            LDokPotencjalne.append((rsglobal.Dekoduj(dow[14]),rsglobal.Dekoduj(dow[15]),rsglobal.Dekoduj(dow[16]),dow[17]))

                                            if Art in SIlosci:
                                                # artykul jest to dodajemy ilosci
                                                SIlosci[Art][0] += dow[9]
                                                SIlosci[Art][1] += dow[10]
                                            else:
                                                # nie ma artykulu dodajemy calosc
                                                # [ilosc_dost1,ilosc_dost2,zwroty1,zwroty2,cenaN1,cenaN2,cenaU1,cenaU2,cenaB1,cenaB2]
                                                SIlosci[Art]=[dow[9],dow[10],0,0,dow[3],dow[4],dow[5],dow[6],dow[7],dow[8],dow[19],dow[13],dow[20],0]

                                # ptla po zwrotach
                                if KRozlZwroty:
                                    for dow in DDow:
                                        if (NrZam==dow[0]) and (dow[1] >=DataOdF) and (DataDoF=='NULL' or dow[1]<DataDoF):
                                            # jeli podany konkretny klucz dowodu to te jest uwzgldniany
                                            if KluczDD=='' or (KluczDD == (dow[14],dow[15],dow[16],dow[17])):
                                                Art=dow[2]
                                                if dow[11]>0:
                                                    if Art in SIlosci:
                                                        # artykul jest to dodajemy zwroty. Jesli sie da to dodajemy do rozliczonych odpowiednie ilosci
                                                        if SIlosci[Art][0]-SIlosci[Art][2] > 0:
                                                            Ile=min(SIlosci[Art][0]-SIlosci[Art][2],dow[11])
                                                            Ile2=min(SIlosci[Art][1]-SIlosci[Art][3],dow[12])
                                                            if Ile>0:
                                                                SIlosci[Art][2] += Ile
                                                                SIlosci[Art][3] += Ile2
                                                                # zapis ile rozliczyc zwrotw na danej pozycji
                                                                LRozliczone.append([rsglobal.Dekoduj(dow[14]),rsglobal.Dekoduj(dow[15]),rsglobal.Dekoduj(dow[16]),dow[17],dow[18],Ile,Ile2,Art])

                                    # jeli jest limit % na zwrotach to :
                                    if KLimitZwr < 100:
                                        # liczymy warto przyj
                                        SWartN = 0
                                        for art in SIlosci:
                                            SWartN+=rsglobal.RSRound(SIlosci[art][0]*SIlosci[art][6],2) # ilosc1 * cena_upust1

                                        # liczymy graniczn warto zwrotw
                                        Limit = SWartN*KLimitZwr*0.01
                                        # dla kadej pozycji sprawdzamy czy jej wprowadzenie nie przekroczy limitu.
                                        # jeli tak to zaczynamy przycina zwroty
                                        for art in SIlosci:
                                            if stat=='OK':
                                                Roznica = 0
                                                IlArt=SIlosci[art][0]
                                                IlZwr=SIlosci[art][2]
                                                Cena = SIlosci[art][6]

                                                IlTmp=min(IlArt,IlZwr)
                                                # w miar koniecznoci zmniejszamy po 1 sztuce a zmiecimy si w limicie
                                                while IlTmp > 0 and (rsglobal.RSRound(IlTmp*Cena,2)>Limit):
                                                    LimitOsiagniety=True
                                                    IlTmp = IlTmp-1

                                                if IlTmp < 0:
                                                    IlTmp = 0

                                                # to co zostao mona rzeczywicie odj jako zwroty
                                                SQLPrzel = "SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+art+"';"
                                                stat,DPrzel,dump,dump = self.PolSQL.Execute(SQLPrzel, 3)
                                            if stat=='OK':
                                                Roznica = IlZwr - IlTmp
                                                SIlosci[art][2] = IlTmp
                                                SIlosci[art][3] = rsglobal.RSRound(IlTmp*DPrzel[0][0],3)
                                                Limit = Limit - rsglobal.RSRound(IlTmp*Cena,2)
                                            if stat=='OK' and Roznica >0:

                                                # odejmujemy jeszcze rnic iloci w LRozliczone,
                                                # tak by waciwe iloci poszy na pozycje dowodu dostawy
                                                for prozl in LRozliczone:
                                                    if Roznica >0:
                                                        if art == prozl[7]:
                                                            IleRoz=eval(str(min(Roznica,prozl[5])))
                                                            Roznica = Roznica - IleRoz
                                                            prozl[5]= prozl[5] - IleRoz
                                                            prozl[6]=rsglobal.RSRound(prozl[5]*DPrzel[0][0],3)

                            if stat=='OK':
                                # numeracja pozycji z SIlosci
                                ind=0
                                lp=1
                                if len(SIlosci)>0:
                                    CzySa=True
                                    while CzySa:
                                        CzySa=False
                                        for Art in SIlosci:
                                            if (SIlosci[Art][0]-SIlosci[Art][2])>0:
                                                if SIlosci[Art][12]==ind:
                                                    SIlosci[Art][13]=lp
                                                    lp=lp+1
                                                elif SIlosci[Art][13]==0:
                                                    CzySa=True
                                        ind=ind+1

                                # zapis pozycji na fakturze
                                SqlP=''
                                KluczeSIlosci=SIlosci.keys()
                                KluczeSIlosci.sort()
                                Lp=1

                                for artobcy in LKluczeArtObcych:
                                    # tu mamy wszystkie artykuy a tylko cz moe by na tej fakturze
                                    if not artobcy[1] in SIlosci:
                                        continue

                                    poz=SIlosci[artobcy[1]]
                                    Art=artobcy[1]
                                    if (poz[0]-poz[2])>0:
                                        # przygotowanie pozycji faktury
                                        Ilosc1=rsglobal.RSRound(poz[0]-poz[2],2)
                                        if poz[4] >0:
                                            SQLUpust="SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"','"+rsglobal.Dekoduj(KontrFakt)+"','PLN','"+rsglobal.Dekoduj(DataFakt)+"','"+rsglobal.Dekoduj(Art)+"','',-1)"
                                            stat,DaneUpust,dump,dump = self.PolSQL.Execute(SQLUpust, 3)
                                            Upust=rsglobal.Dekoduj(eval(DaneUpust[0][0])[8])
                                        else:
                                            Upust=0
                                        UpustWart=rsglobal.RSRound(Ilosc1*(poz[4]-poz[6]),2)
                                        StawkaVAT=poz[10]
                                        if StawkaVAT=='None':
                                            stat='Brak stawki VAT na pozycji w dowodzie dostaw '+poz[11]
                                        if StawkaVAT in self.ListaStawekZn:
                                            PomStVATLiczb=0
                                        else:
                                            PomStVATLiczb=int(StawkaVAT)
                                        WartN=rsglobal.RSRound(Ilosc1*(poz[6]),2)
                                        WartVAT=rsglobal.RSRound(WartN*PomStVATLiczb*0.01,2)
                                        WartB=WartN+WartVAT
                                        CechaOpis="(SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+rsglobal.Dekoduj(Art)+"')"
                                        KodGtu = "(SELECT kod_gtu FROM rs_artykuly WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + rsglobal.Dekoduj(Art) + "')"

                                        SqlP+="INSERT INTO rs_faktury_pozycje "
                                        SqlP+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"                                                        #1
                                        SqlP+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"       #2
                                        SqlP+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,"            #3
                                        SqlP+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,cecha1_opis,kod_gtu) "#4 #MK 2020-03-23
                                        SqlP+=" VALUES "
                                        SqlP+="('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerF)+","+str(Lp)+",0,"               #1
                                        SqlP+="'"+rsglobal.Dekoduj(Art)+"',"+str(rsglobal.RSRound(poz[0]-poz[2],2))+","+str(rsglobal.RSRound(poz[1]-poz[3],2))+","+str(poz[4])+","+str(poz[5])+","+str(poz[6])+","+str(poz[7])+","+str(poz[8])+","+str(poz[9])+","       #2
                                        SqlP+=str(Upust)+","+str(UpustWart)+",'"+rsglobal.Dekoduj(StawkaVAT)+"',"+str(WartN)+","+str(WartVAT)+","+str(WartB)+",'',NULL,"                #3
                                        SqlP+=str(poz[4])+","+str(poz[5])+","+str(poz[6])+","+str(poz[7])+","+str(WartN)+","+str(WartVAT)+","+str(WartB)+","+CechaOpis+","+KodGtu+");" #4 #MK 2020-03-23

                                        # sumowanie wartoci netto rabatu finansowego
                                        # sownik z kluczem kontrahent+artyku oraz wynikiem indeks_rabatu,stawka_vat, procent     SRabatowF={}
                                        # sownik z kluczem artykul_rabatowy oraz wynikiem stawka_vat,procent, warto netto    SArtRabatow={}
                                        # KontrFakt+"','"+ZamawFakt+"','"+PlatnikFakt
                                        klucz=(KontrFakt.strip(),Art.strip())
                                        if not klucz in SRabatowF:
                                            klucz=(PlatnikFakt.strip(),Art.strip())

                                        Lp+=1

                                        if klucz in SRabatowF:
                                            ArtRabat=SRabatowF[klucz][0]
                                            ProcRabat=SRabatowF[klucz][1]
                                            SArtRabatow[ArtRabat][1]=rsglobal.RSRound(WartN*0.01*ProcRabat,2)
                                            if SArtRabatow[ArtRabat][1]>0:
                                                CenaN=-1*SArtRabatow[ArtRabat][1]
                                                Stawka= SArtRabatow[ArtRabat][0]
                                                if Stawka in self.ListaStawekZn:
                                                    CenaV=0
                                                else:
                                                    CenaV=rsglobal.RSRound(CenaN*0.01*int(Stawka),2)

                                                CenaB=CenaN+CenaV
                                                CechaOpis="(SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+rsglobal.Dekoduj(ArtRabat)+"')"
                                                KodGtu = "(SELECT kod_gtu FROM rs_artykuly WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + rsglobal.Dekoduj(ArtRabat) + "')"

                                                SqlP+="INSERT INTO rs_faktury_pozycje "
                                                SqlP+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"                                                        #1
                                                SqlP+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"       #2
                                                SqlP+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,"            #3
                                                SqlP+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,cecha1_opis,kod_gtu) "#4 #MK 2020-03-23
                                                SqlP+=" VALUES "
                                                SqlP+="('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerF)+","+str(Lp)+",0,"               #1
                                                SqlP+="'"+rsglobal.Dekoduj(ArtRabat)+"',1,1,"+str(CenaN)+","+str(CenaN)+","+str(CenaN)+","+str(CenaN)+","+str(CenaB)+","+str(CenaB)+","       #2
                                                SqlP+="0,0,'"+rsglobal.Dekoduj(str(Stawka))+"',"+str(CenaN)+","+str(CenaV)+","+str(CenaB)+",'',NULL,"                #3
                                                SqlP+=str(CenaN)+","+str(CenaN)+","+str(CenaN)+","+str(CenaN)+","+str(CenaN)+","+str(CenaV)+","+str(CenaB)+","+CechaOpis+","+KodGtu+");" #4 #MK 2020-03-23

                                                SArtRabatow[ArtRabat][1]=0
                                                Lp+=1

                                #zapis rozliczonych zwrotw
                                SqlR=''
                                for rozl in LRozliczone:
                                    SqlR+="UPDATE rs_dowody_dostaw_pozycje SET ilosc_rozl1="+str(rozl[5])+",ilosc_rozl2="+str(rozl[6])+", ilosc_rozl_f1="+str(rozl[5])+",ilosc_rozl_f2="+str(rozl[6])
                                    SqlR+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+rozl[0]+"' AND data='"+rozl[1]+"' AND tryb_dostawy='"+rozl[2]+"' AND numer="+str(rozl[3])+" AND nr_poz="+str(rozl[4])+";"

                                #mamy gotowe wszystkie inserty i update'y. Jeli jest ok to zapisujemy wszystko 1 zapytaniem
                                if stat=='OK':
                                    if SqlP <> '':
                                        for KluczDok in LDokPotencjalne:
                                            LDokumentowZFakturami[eval(str(KluczDok))]=eval(str(KluczFakt))
                                            LDokumentowZFakturami[KluczDok][3]=LimitOsiagniety

                                        stat,dump,dump,dump = self.PolSQL.Execute(SqlN+SqlP+SqlR, 1)
                                        if stat <> 'OK':
                                            rsglobal.ZapiszDoLogow("BLTWFAKT! :"+stat+' dla faktury '+KluczFakturyTest ,1)

                                        # test na istnienie niby dodanej faktury
                                        else:
                                            stat,DaneTest,dump,dump = self.PolSQL.Execute(SQLTest, 3)
                                            if stat<>'OK':
                                                rsglobal.ZapiszDoLogow("BLTESTU! :"+SQLTest+' dla faktury '+KluczFakturyTest,1)
                                            elif len(DaneTest)==0:
                                                rsglobal.ZapiszDoLogow("FAKTNIEUTW! :"+SQLTest+' dla faktury '+KluczFakturyTest,1)
                                                stat='Nie utworzona faktura '+KluczFakturyTest+'mimo, e proces przebieg poprawnie. Poinformuj serwis.'
                                    else:
                                        if SqlR <> '':
                                            stat,dump,dump,dump = self.PolSQL.Execute(SqlR, 1)

                                        for KluczDok in LDokPotencjalne:
                                            LDokumentowZFakturami[eval(str(KluczDok))]=['','',0,LimitOsiagniety]

                                i=i+1

                        if stat <> 'OK':
                            self.PolSQL.Rollback()
                        else:
                            #zmieniamy stan dowodw dostaw na 3,4
                            SQL=''
                            for dok in LDokumentowZFakturami:
                                Filtr=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+dok[0]+"' AND data='"+dok[1]+"' AND tryb_dostawy='"+dok[2]+"' AND numer="+str(dok[3])

                                #sprawdzamy na jaki stan zmieniac
                                fak=LDokumentowZFakturami[dok]

                                # jeli limit osignity to Stan = 4
                                rsglobal.ZapiszDoLogow('Limit osiag na koniec '+str(LimitOsiagniety),1)
                                if fak[3]:
                                    Stan = '4'
                                else:
                                    SQLTmp="SELECT SUM(ilosc_zwr1-ilosc_rozl1) FROM rs_dowody_dostaw_pozycje "+Filtr
                                    stat,d,dump,dump = self.PolSQL.Execute(SQLTmp, 3)
                                    if d[0][0] >0:
                                        Stan='3'
                                    else:
                                        Stan='4'

                                fak=LDokumentowZFakturami[dok]
                                fakt=''
                                if fak[:3] <> ['','',0]:
                                    fakt= ",f_wyznacznik_id='"+fak[0]+"',f_data='"+fak[1]+"',f_numer="+str(fak[2])

                                SQL+="UPDATE rs_dowody_dostaw SET stan="+Stan+fakt+Filtr+";"
                            if SQL <> '':
                                stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
                            if stat<>'OK':
                                self.PolSQL.Rollback()
                            else:
                                self.PolSQL.Commit()

# -##############################################################################
# -------------------------------------------------------------------------------
# WYKONANIE FAKTUR ZBIORCZYCH DLA FIRMY LUB DLA PLATNIKA
# -------------------------------------------------------------------------------
# -##############################################################################
if stat == 'faktury zbiorcze dla firmy':
    # tworzenie wspolnych faktur dla wszystkich oddzialow z dokladnoscia do kontrahenta
    # jeli wczony checkbox 'dla platnika' to jedna faktura dla platnika
    # zablokowanie wyznacznika na UPDATE - to sprawi, e inni nie bd mogli go wykorzysta do tworzenia
    # faktur z dowodw dostaw
    SQL = "SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + Wyzn + "' FOR UPDATE NOWAIT"
    stat, DWyzn, dump, dump = self.PolSQL.Execute(SQL, 3)
    #if stat != 'OK':
    #    stat = 'Bd blokady wyznacznika.'
    FakturaOpis = ''
    NumerF = 0

    if stat == 'OK':
        # pobranie pozycji z dowodw dostaw
        SQLDow = "SELECT dd.platnik_id,dd.kontrahent_id,COALESCE(k.zamawiajacy_id,dd.kontrahent_id),"  # 0-2
        SQLDow += " dp.artykul_id,dp.cena_netto1,dp.cena_netto2,dp.cena_upust1,dp.cena_upust2,"  # 3-7
        SQLDow += " dp.cena_brutto1,dp.cena_brutto2,dp.stawka_vat,SUM(dp.ilosc_dost1),SUM(dp.ilosc_dost2),"  # 8-12
        SQLDow += " k.nazwa "  # 13
        SQLDow += " FROM rs_dowody_dostaw_pozycje dp "
        SQLDow += " INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
        SQLDow += " INNER JOIN rs_kontrahenci k ON (k.firma_id=dd.firma_id AND k.kontrahent_id=dd.kontrahent_id) "
        SQLDow += " WHERE dd.firma_id='" + self.firma_id + "'"
        SQLDow += " AND dd.data>='" + DataOd + "' AND dd.data <='" + DataDo + "' AND dd.stan='2' AND f_wyznacznik_id IS NULL"
        if ZbiorczaDlaPlatnika and DlaKontrahenta != '':
            SQLDow += " AND dd.platnik_id='" + DlaKontrahenta + "'"
        elif DlaKontrahenta != '':
            SQLDow += " AND dd.kontrahent_id='" + DlaKontrahenta + "'"
        elif CzyKateg:  # kontrahent jest wazniejszy, jak jest to pomijamy kategorie
            SQLDow += " AND TRIM(rsf_podaj_czestosc_kontrahenta(dd.firma_id,k.kontrahent_id,dd.oddzial_id))=TRIM('" + Kateg + "')"
        SQLDow += " GROUP BY dd.platnik_id,dd.kontrahent_id,COALESCE(k.zamawiajacy_id,dd.kontrahent_id),"
        SQLDow += " dp.artykul_id,dp.cena_netto1,dp.cena_netto2,dp.cena_upust1,dp.cena_upust2,"
        SQLDow += " dp.cena_brutto1,dp.cena_brutto2,dp.stawka_vat,k.nazwa"
        SQLDow += " ORDER BY dd.platnik_id,dd.kontrahent_id,dp.artykul_id,dp.cena_upust1;"
        stat, DDow, dump, dump = self.PolSQL.Execute(SQLDow, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania danych do tworzenia faktur z dowodw dostaw:' + stat
        elif len(DDow) == 0:
            stat = 'Brak danych do tworzenia faktur z dowodw dostaw'
        else:
            # petla po kontrahentach
            KontrFakt = ''
            PlatnFakt = ''
            InsUpd = ''
            for w in DDow:
                if w[0] != PlatnFakt:
                    if PlatnFakt != '' and ZbiorczaDlaPlatnika:
                        #JR 2022-05-13 (13019) zmiana oddzialu jesli tylko jeden
                        # sprawdzenie czy jeden oddzial
                        if TworzycKP:  # tylko dla sposobu zaplaty dla ktorego tworzone jest KP
                            SQL = "SELECT DISTINCT oddzial_id FROM rs_dowody_dostaw "
                            SQL += " WHERE firma_id='" + self.firma_id + "' AND platnik_id='" + PlatnFakt + "'"
                            SQL += " AND data>='" + DataOd + "' AND data <='" + DataDo + "' AND stan = '2' AND f_wyznacznik_id IS NULL;"
                            stat, Doddzialy, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd przy sprawdzaniu oddziau w dowodach dostaw :' + stat
                                break
                            if len(Doddzialy) == 1:
                                # jeden oddzial - zastepujemy na fakturze
                                SQL = "UPDATE rs_faktury SET oddzial_id='" + Doddzialy[0][0] + "' "
                                SQL += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + KluczFakt[0] + "'"
                                SQL += " AND data='" + str(KluczFakt[1]) + "' AND numer=" + str(KluczFakt[2])
                                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                                if stat != 'OK':
                                    stat = 'Bd przy wpisywaniu oddziau do faktury :' + stat
                                    break
                        # zapis do d.d.
                        SQL = "UPDATE rs_dowody_dostaw SET stan = '4', f_wyznacznik_id='" + KluczFakt[0] + "',"
                        SQL += "f_data='" + str(KluczFakt[1]) + "',f_numer=" + str(KluczFakt[2])
                        SQL += " WHERE firma_id='" + self.firma_id + "' AND platnik_id='" + PlatnFakt + "'"
                        SQL += " AND data>='" + DataOd + "' AND data <='" + DataDo + "' AND stan = '2' AND f_wyznacznik_id IS NULL;"
                        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd przy wpisywaniu nr faktury do dowodw dostaw :' + stat
                            break
                    # pobranie potrzebnych damych dla platnika i oddzialu
                    PlatnFakt = w[0]
                    SQL = "SELECT dni,spos_zaplaty,spos_dostawy,handlowiec,"  # 0-3
                    SQL += " sposob_odbioru_faktury,projekt_id, osobny_rachunek_vat, COALESCE(sz.tworzyc_kp,False) "  # 4-7
                    SQL += " FROM rs_kontrahenci_fakturowanie kf INNER JOIN rs_sposoby_zaplaty sz ON (kf.firma_id=sz.firma_id AND spos_zaplaty=sz.kod)"
                    SQL += " WHERE kf.firma_id='" + self.firma_id + "'"
                    SQL += " AND kontrahent_id = '" + PlatnFakt + "' AND data_od <= '" + DataFakt + "'"
                    SQL += " ORDER BY data_od DESC LIMIT 1;"
                    stat, DFaktPlat, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd pobierania danych do fakturowania dla patnika ' + PlatnFakt
                        break
                    if len(DFaktPlat) == 0:
                        stat = 'Brak danych do fakturowania dla patnika ' + PlatnFakt
                        break
                    KFDni = str(int(DFaktPlat[0][0]))
                    KFSposZapl = rsglobal.ZmienNaNULL(DFaktPlat[0][1])
                    KFSposDost = rsglobal.ZmienNaNULL(DFaktPlat[0][2])
                    KFHandl = rsglobal.ZmienNaNULL(DFaktPlat[0][3])
                    KFSposOdbF = rsglobal.ZmienNaNULL(DFaktPlat[0][4])
                    KFProj = rsglobal.ZmienNaNULL(DFaktPlat[0][5])
                    OddzielnyVAT = str(DFaktPlat[0][6])
                    TworzycKP = DFaktPlat[0][7]

                    SQL = "SELECT COALESCE(czy_mpp,False) FROM rs_kontrahenci WHERE firma_id = '" + self.firma_id + "'"
                    SQL += " AND kontrahent_id='" + PlatnFakt + "';"
                    stat, DMPP, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd przy pobieraniu danych patnika/kontrahenta: ' + stat
                        break
                    CzyMPP = str(DMPP[0][0])

                    SQL = "SELECT ozn_trans,ozn_sprzedaz FROM rs_wyznaczniki"
                    SQL += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "';"
                    stat, dws, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd przy sprawdzaniu danych wyznacznika :' + stat
                        break
                    OznTransS = rsglobal.ZmienNaNULL(dws[0][0])
                    OznSprzS = rsglobal.ZmienNaNULL(dws[0][1])

                if w[1] != KontrFakt:
                    if KontrFakt != '' and not ZbiorczaDlaPlatnika:  # zamkniecie faktury, wpisanie f-ry do dowodow dostaw
                        #JR 2022-05-13 (13019) zmiana oddzialu jesli tylko jeden
                        # sprawdzenie czy jeden oddzial
                        if  TworzycKP:  # tylko dla sposobu zaplaty dla ktorego tworzone jest KP
                            SQL = "SELECT DISTINCT oddzial_id FROM rs_dowody_dostaw "
                            SQL += " WHERE firma_id='" + self.firma_id + "' AND kontrahent_id='" + KontrFakt + "'"
                            SQL += " AND data>='" + DataOd + "' AND data <='" + DataDo + "' AND stan = '2' AND f_wyznacznik_id IS NULL;"
                            stat, Doddzialy, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd przy sprawdzaniu oddziau w dowodach dostaw :' + stat
                                break
                            if len(Doddzialy) == 1:
                                # jeden oddzial - zastepujemy na fakturze
                                SQL = "UPDATE rs_faktury SET oddzial_id='" + Doddzialy[0][0] + "' "
                                SQL += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + KluczFakt[0] + "'"
                                SQL += " AND data='" + str(KluczFakt[1]) + "' AND numer=" + str(KluczFakt[2])
                                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                                if stat != 'OK':
                                    stat = 'Bd przy wpisywaniu oddziau do faktury :' + stat
                                    break

                        # zapis do d.d.
                        SQL = "UPDATE rs_dowody_dostaw SET stan = '4', f_wyznacznik_id='" + KluczFakt[0] + "',"
                        SQL += "f_data='" + str(KluczFakt[1]) + "',f_numer=" + str(KluczFakt[2])
                        SQL += " WHERE firma_id='" + self.firma_id + "' AND kontrahent_id='" + KontrFakt + "'"
                        SQL += " AND data>='" + DataOd + "' AND data <='" + DataDo + "' AND stan = '2' AND f_wyznacznik_id IS NULL;"
                        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd przy wpisywaniu nr faktury do dowodw dostaw :' + stat
                            break
                    # nowa faktura dla kontrahenta lub zbiorcza dla platnika
                    KontrFakt = w[1]
                    if not ZbiorczaDlaPlatnika or NumerF == 0:
                        Lp = 0
                        # pobranie wolnego numeru faktury
                        stat, DNr, dump, dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('" + self.firma_id + "','[\\\'" + Wyzn + "\\\',\\\'" + DataFakt + "\\\']','F');",3)
                        if stat != 'OK':
                            stat = "Bdy przy pobieraniu numeru faktury"
                            break
                        if DNr[0][0] in (None, 'None', ''):
                            stat = "Bdy przy pobieraniu numeru faktury"
                            break
                        NumerF = str(DNr[0][0])
                        # przygotowanie klucza,ktry bdzie wrzucany na nagwek dowodu dostawy
                        KluczFakt = [Wyzn, DataFakt, NumerF, False]
                        SqlN = 'INSERT INTO rs_faktury '
                        SqlN += '(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,kraj_opodatkowania,'
                        SqlN += 'dostawy_od_dnia,dostawy_do_dnia,kierowca,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,'
                        SqlN += 'termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,projekt_id,upust,upust_wartosc,upust_wartosc_wal,'
                        SqlN += 'rabat,rabat_wartosc,rabat_wartosc_wal,kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,'
                        SqlN += 'kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,numer_z_rs,'
                        SqlN += 'zamowienie_nr,zamowienie_data,data_przychodu,osobny_rachunek_vat,czy_mpp,ozn_trans,ozn_sprzedaz)'  # WS 2019-08-06 - dodane czy_mpp
                        SqlN += ' VALUES '
                        SqlN += "('" + self.firma_id + "','" + Wyzn + "','" + DataFakt + "'," + NumerF + ",'" + OddzialDlaFaktur + "','W','"
                        if ZbiorczaDlaPlatnika:
                            SqlN += w[0] + "','" + w[0] + "','" + w[0] + "',NULL,'PL',"
                        else:
                            SqlN += w[1] + "','" + w[2] + "','" + w[0] + "',NULL,'PL',"
                        SqlN += "'" + DataOd + "','" + DataDo + "',NULL,'PLN',1,NULL,NULL,NULL," + KFSposZapl + "," + KFDni + ",NULL,"
                        SqlN += "date '" + DataFakt + "' + integer '" + KFDni + "'," + KFHandl + "," + KFSposOdbF + "," + KFSposDost + "," + KFProj + ",0,0,0,"
                        SqlN += "0,0,0,0,0,0,0,"
                        SqlN += "0,0,0,0,'','','',"
                        SqlN += "NULL,NULL,'" + DataDo + "'," + OddzielnyVAT + "," + CzyMPP  # WS 2019-08-06 - dodane CzyMPP
                        SqlN += "," + OznTransS + "," + OznSprzS + ");"
                        stat, dump, dump, dump = self.PolSQL.Execute(SqlN, 1, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd dodania nagwka faktury.' + stat
                            break

                # dodanie pozycji
                Lp += 1
                StawkaVAT = w[10]
                #if StawkaVAT == 'None':
                #    stat = 'Brak stawki VAT na pozycji w dowodzie dostaw ' + poz[11]

                if stat == 'OK':
                    if StawkaVAT in self.ListaStawekZn:
                        PomStVATLiczb = 0
                    else:
                        PomStVATLiczb = int(StawkaVAT)

                    WartN = rsglobal.RSRound(w[11] * (w[6]), 2)
                    WartVAT = rsglobal.RSRound(WartN * PomStVATLiczb * 0.01, 2)
                    WartB = WartN + WartVAT
                    #Upust = rsglobal.RSRound(UpustWart / WartN * 100, 2)
                    Upust = 0
                    FakturaOpis += "Pozycja: " + str(Lp) + " - " + KontrFakt + " " + w[13] + "\n"
                    KodGtu = "(SELECT kod_gtu FROM rs_artykuly WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + w[3] + "')"

                    SQL = "INSERT INTO rs_faktury_pozycje "
                    SQL += "(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"  # 1
                    SQL += "artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"  # 2
                    SQL += "upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,"  # 3
                    SQL += "cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,cecha1_opis,kod_gtu) "  # 4  #MK 2020-03-23
                    SQL += " VALUES "
                    SQL += "('" + self.firma_id + "','" + Wyzn + "','" + DataFakt + "'," + str(NumerF) + "," + str(Lp) + ",0,"  # 1
                    SQL += "'" + w[3] + "'," + str(w[11]) + "," + str(w[12]) + "," + str(w[4]) + "," + str(
                        w[5]) + "," + str(w[6]) + "," + str(w[7]) + "," + str(w[8]) + "," + str(w[9]) + ","  # 2
                    SQL += "0,0,'" + rsglobal.Dekoduj(StawkaVAT) + "'," + str(WartN) + "," + str(WartVAT) + "," + str(WartB) + ",'',NULL,"  # 3
                    SQL += str(w[4]) + "," + str(w[5]) + "," + str(w[6]) + "," + str(w[7]) + "," + str(
                        WartN) + "," + str(WartVAT) + "," + str(WartB) + ",NULL," + KodGtu + ");"  # 4
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd dodania pozycji faktury.' + stat
                        break

            if stat == 'OK':
                if KontrFakt != '':  # zamkniecie faktury, wpisanie f-ry do dowodow dostaw
                    # JR 2022-05-13 (13019) zmiana oddzialu jesli tylko jeden
                    # sprawdzenie czy jeden oddzial
                    if TworzycKP:  # tylko dla sposobu zaplaty dla ktorego tworzone jest KP
                        SQL = "SELECT DISTINCT oddzial_id FROM rs_dowody_dostaw "
                        if ZbiorczaDlaPlatnika:
                            SQL += " WHERE firma_id='" + self.firma_id + "' AND platnik_id='" + PlatnFakt + "'"
                        else:
                            SQL += " WHERE firma_id='" + self.firma_id + "' AND kontrahent_id='" + KontrFakt + "'"
                        SQL += " AND data>='" + DataOd + "' AND data <='" + DataDo + "' AND stan = '2' AND f_wyznacznik_id IS NULL;"
                        stat, Doddzialy, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd przy sprawdzaniu oddziau w dowodach dostaw :' + stat
                        elif len(Doddzialy) == 1:
                            # jeden oddzial - zastepujemy na fakturze
                            SQL = "UPDATE rs_faktury SET oddzial_id='" + Doddzialy[0][0] + "' "
                            SQL += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + KluczFakt[0] + "'"
                            SQL += " AND data='" + str(KluczFakt[1]) + "' AND numer=" + str(KluczFakt[2])
                            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd przy wpisywaniu oddziau do faktury :' + stat

                    if stat == 'OK':
                        SQL = "UPDATE rs_dowody_dostaw SET stan = '4', f_wyznacznik_id='" + str(KluczFakt[0]) + "',"
                        SQL += " f_data='" + str(KluczFakt[1]) + "',f_numer=" + str(KluczFakt[2])
                        SQL += " WHERE firma_id='" + self.firma_id + "'"
                        if ZbiorczaDlaPlatnika:
                            SQL += " AND platnik_id='" + DlaKontrahenta + "'"
                        else:
                            SQL += " AND kontrahent_id='" + KontrFakt + "'"
                        SQL += " AND data>='" + DataOd + "' AND data <='" + DataDo + "' AND stan = '2' AND f_wyznacznik_id IS NULL;"
                        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd przy wpisywaniu nr faktury do dowodw dostaw :' + stat
                    #if ZbiorczaDlaPlatnika and FakturaOpis != '':  # wpisanie opisu do faktury - Siwiec zrezygnowal 2021-02-18
                    #    SQL = "UPDATE rs_faktury SET opis='" + FakturaOpis + "'"
                    #    SQL += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + str(KluczFakt[0]) + "'"
                    #    SQL += " AND data='" + str(KluczFakt[1]) + "' AND numer=" + str(KluczFakt[2]) + ";"
                    #    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                    #    if stat != 'OK':
                    #        stat = 'Bd przy wpisywaniu opisu do faktury :' + stat

