# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_tworzenie_korekt.py
# Purpose:     tworzy (automatycznie lub rcznie) nowe korekty z dowodw dostaw
#
# Author:      Micha Raburski
#
# Created:     2007/07/30
# RCS-ID:      $Id: fs_dowody_dostaw_tworzenie_korekt.py $
# Copyright:   (c) 2004-2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-08 Mariusz Rajfura - termin zaplaty liczony z korekty (4462)
# 2017-10-19 Rafa Woniak (10783) ustawianie checkboxa zalenie od faktury
# 2019-08-01 Aleksander Bargie (11568) Obsuga split payment w fakturach
# 2020-04-27 Mikoaj Kozowski (11916) Obsuga pl oznaczenia transakcji i oznaczenia sprzedazy

import time
from funkcje import fs_sprzedaz_pom

DataOd=rsglobal.Dekoduj(klucze[0])
DataDo=rsglobal.Dekoduj(klucze[1])
DataFakt=rsglobal.Dekoduj(klucze[2])
Wyzn=rsglobal.Dekoduj(klucze[3])
CzyWszyscy=klucze[4]
CzyKateg=klucze[5]
Kateg=rsglobal.Dekoduj(klucze[6])
Dni=klucze[7]
Tytul=klucze[8]
CzyDlaKorekt=klucze[9]
WyznKor=klucze[10]
OddzielneKVat=False

Fun = klucze[-1]

stat='BR UPR'
if Fun==2:
    if ((self.oddzial_id,'028018') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'OK'
    if stat == 'OK':
        #sprawdzenie poprawnoci uprawnie do wyznacznika
        sql = "SELECT rsf_podaj_liste_wyznacznikow('"+str([self.firma_id,self.oddzial_id,'',self.operator_id]).replace("'",'"')+"','[]','[]','[]');"
        stat, wyzn, dump, dump = self.PolSQL.Execute(sql,3)
        LWyzn = eval(wyzn[0][0])
        if (not WyznKor in LWyzn) and (not WyznKor+' ' in LWyzn) and (not Wyzn in LWyzn) and (not Wyzn+' ' in LWyzn):
            stat = u'Niezdefiniowane uprawnienia do wybranego wyznacznika w danym oddziale.'
            rsglobal.ZapiszDoLogow('wyznkor:'+WyznKor+'|'+Wyzn+'|Lista:'+str(LWyzn))


#w danych bdzie znajdowa si lista komentarzy
dane=[]
#-------------------------------------------------------------------------------
# SPRAWDZENIE POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

if Fun ==2 and stat=='OK':
    if stat=='OK':
        if DataOd == '    -  -  ':
            stat='Nie podano daty od'
        else:
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat = u"Nieprawidowa data od"

    if stat=='OK':
        if DataDo == '    -  -  ':
            stat='Nie podano daty do'
        else:
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat = 'Nieprawidowa data do'

    if stat=='OK':
        if DataFakt == '    -  -  ':
            stat='Nie podano daty korekty'
        else:
            if not rsglobal.SprawdzCzyToData(DataFakt):
                stat = 'Nieprawidowa data korekty'
            else:
                #sprawdzenie czy mona na ten dzie tworzy faktury
                stat,Dane,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+DataFakt+"\\\']','K');",3)

                if Dane[0][0]<>'OK' and stat=='OK':
                    stat='Nie mona tworzy korekt - istniej korekty z pniejsz dat'

    if stat=='OK':
        if Wyzn == '':
            stat='Nie podano wyznacznika'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT czy_korekta FROM rs_wyznaczniki WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';" ,3)
            if stat=='OK':
                if len(d) == 0:
                    stat = 'Nieprawidowy wyznacznik'
                elif not d[0][0]:
                    stat = 'Wyznacznik '+Wyzn+' nie jest wyznacznikiem korekty'

    if stat=='OK' and CzyKateg:
        if Kateg == '':
            stat='Nie podano kategorii'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_czestosci_fakturowania WHERE firma_id = '"+self.firma_id+"' AND kod='"+Kateg+"';" ,3)
            if stat=='OK':
                if len(d) == 0:
                    stat = 'Nieprawidowa kategoria'

    if stat=='OK':
        if Tytul=='':
            stat = 'Brak tytuu zmniejszenia podatku'
        else:
            stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id = '"+self.firma_id+"' AND kod='"+Tytul+"';" ,3)
            if stat=='OK':
                if len(d) == 0:
                    stat = 'Nieprawidowy tytu zmniejszenia podatku'
                else:
                    Tytul="'"+rsglobal.Dekoduj(Tytul)+"'"


#-------------------------------------------------------------------------------
# WYKONANIE KOREKT
#-------------------------------------------------------------------------------

if Fun==2:
    if stat=='OK':
        SQL=''
        #pobranie danych faktur
        #pobranie kontrahenta z dowodw dostaw
        SQLKontr=" SELECT DISTINCT dd.kontrahent_id,COALESCE(k.platnik_id,dd.kontrahent_id) AS platnik "
        SQLKontr+=" FROM rs_dowody_dostaw dd INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id) "
        SQLKontr+=" LEFT OUTER JOIN rs_kontrahenci_artykuly_poziom_zwrotow kapz USING (firma_id,kontrahent_id) "
        SQLKontr+=" WHERE dd.firma_id = '"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' AND dd.stan='3'"
        SQLKontr+=" AND dd.data>='"+DataOd+"' AND dd.data <='"+DataDo+"'"
        if CzyKateg:
            SQLKontr+=" AND rsf_podaj_czestosc_kontrahenta(dd.firma_id,k.kontrahent_id,dd.oddzial_id)='"+Kateg+"'"
        SQLKontr+=" ORDER BY platnik,dd.kontrahent_id;"
        stat,DKontr,dump,dump = self.PolSQL.Execute(SQLKontr ,3)
    if stat=='OK':
        if len(DKontr) == 0:
            stat = "Brak dowodw dostaw dla podanych parametrw"

        SPlat={}
        LRazemZbiorcza=[]
        LRazemNieZbiorcza=[]
        LOsobnoZbiorcza=[]
        LOsobnoNieZbiorcza=[]
        Plat=''

        #-------------------------------------------------------
        #--- Ptla po kontrahentach dzielca ich na patnikw
        #-------------------------------------------------------
        for kontr in DKontr:
            if stat=='OK':
                PlatN=rsglobal.Dekoduj(kontr[1])
                if PlatN!=Plat:
                    stat,DFaktPlat,dump,dump = self.PolSQL.Execute("SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,rozliczac_zwroty FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+PlatN+"' AND data_od <= '"+DataDo+"' ORDER BY data_od DESC LIMIT 1;", 3)
                    if stat=='OK':
                        if len(DFaktPlat)==0:
                            stat='Brak danych do fakturowania dla patnika '+PlatN+" u kontrahenta "+kontr[0]
                    if stat=='OK':
                        if Plat != '':
                            SPlat[Plat]=[LRazemZbiorcza,LRazemNieZbiorcza,LOsobnoZbiorcza,LOsobnoNieZbiorcza,SPlat[Plat][4]]
                        SPlat[PlatN]=([],[],[],[],DFaktPlat[0])
                        LRazemZbiorcza=[]
                        LRazemNieZbiorcza=[]
                        LOsobnoZbiorcza=[]
                        LOsobnoNieZbiorcza=[]
                        Plat=PlatN

                #sprawdzenie do ktrej z kategorii nalezy kontrahent
                if stat=="OK":
                    stat,DFaktKontr,dump,dump = self.PolSQL.Execute("SELECT czy_osobna,czy_zbiorcza FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+rsglobal.Dekoduj(kontr[0])+"' AND data_od <= '"+DataDo+"' ORDER BY data_od DESC LIMIT 1;", 3)
                if stat=='OK':
                    if len(DFaktKontr)==0:
                        LOsobnoZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                    elif DFaktKontr[0][0] and DFaktKontr[0][1]:
                        LOsobnoZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                    elif DFaktKontr[0][0] and not DFaktKontr[0][1]:
                        LOsobnoNieZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                    elif not DFaktKontr[0][0] and DFaktKontr[0][1]:
                        LRazemZbiorcza.append(rsglobal.Dekoduj(kontr[0]))
                    elif not DFaktKontr[0][0] and not DFaktKontr[0][1]:
                        LRazemNieZbiorcza.append(rsglobal.Dekoduj(kontr[0]))

        if stat=='OK':
            SPlat[Plat]=[LRazemZbiorcza,LRazemNieZbiorcza,LOsobnoZbiorcza,LOsobnoNieZbiorcza,SPlat[Plat][4]]

            SListaGrup={}
            for plat in SPlat:
                DPl=SPlat[plat]
                if len(DPl[0])>0:
                    SListaGrup[(plat,str(DPl[0])[1:-1])]=[False,True,DPl[4]]
                if len(DPl[1])>0:
                    SListaGrup[(plat,str(DPl[1])[1:-1])]=[False,False,DPl[4]]
                for kontr in DPl[2]:
                    SListaGrup[(plat,kontr)]=[True,True,DPl[4]]
                for kontr in DPl[3]:
                    SListaGrup[(plat,kontr)]=[True,False,DPl[4]]

            #----------------------------------------------------------------------------------
            #ptla po kontrahentach lub grupach kontrahentw przypitych do jednego patnika
            #----------------------------------------------------------------------------------

            KluczeSLGrup=SListaGrup.keys()
            KluczeSLGrup.sort()
            for kontr in KluczeSLGrup:
                if stat=='OK':
                    #Lista zamykanych dokumentw
                    LZamykanych=[]
                    #Lista tych dokumentw, ktre miay by zamknite, ale nie wszystko udao si wyda
                    LNierozliczonych=[]
                    #Tu trzymane s wszystkie informacje o tym jakie pozycje poczone s z jakim dowodem i na ile (to trafi do pol opisowych)
                    LKor=[]

                    DKontr=SListaGrup[kontr]
                    #grupowe
                    if DKontr[0]:
                        FiltrKontr="dd.kontrahent_id='"+kontr[1]+"'"
                        FiltrKontrF="kontrahent_id='"+kontr[1]+"'"
                    else:
                        FiltrKontr="dd.kontrahent_id IN ("+kontr[1]+")"
                        FiltrKontrF="kontrahent_id='"+kontr[0]+"'"

                    #pobranie zwrotow z dowodw dostaw (na tyle trzeba wystawic korekty)
                    SQLDow="SELECT dd.trasa||'/'||dd.data||'/'||dd.tryb_dostawy||'/'||dd.numer||'/'||dp.nr_poz,dp.artykul_id,dp.ilosc_zwr1-dp.ilosc_rozl1,dp.ilosc_zwr2-dp.ilosc_rozl2,dd.data,"
                    SQLDow+="CASE WHEN dd.dowod_zwrotu IS NULL OR TRIM(dd.dowod_zwrotu)='' THEN 'Dowd zwrotu '||substring(data::TEXT from 3 for 2)||substring(data::TEXT from 6 for 2)||substring(data::TEXT from 9 for 2)||dd.oddzial_id||dd.trasa||dd.tryb_dostawy||dd.numer||' z dnia '||dd.data ELSE 'Dowd zwrotu '||TRIM(dd.dowod_zwrotu)||' z dnia '||dd.data::TEXT END"
                    SQLDow+=" FROM rs_dowody_dostaw_pozycje dp INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
                    SQLDow+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' AND dd.data>='"+DataOd+"' AND dd.data <='"+DataDo+"' AND dd.stan='3' AND dp.ilosc_zwr1-dp.ilosc_rozl1 !=0"
                    SQLDow+=" AND "+FiltrKontr+" AND (NOT dd.korekta OR dd.korekta IS NULL) "
                    SQLDow+=" ORDER BY artykul_id,dp.ilosc_zwr1-dp.ilosc_rozl1 desc FOR UPDATE NOWAIT;"
                    stat,DDow,dump,dump = self.PolSQL.Execute(SQLDow,3)

                    if stat<>'OK':
                        stat='Bdy pobierania danych : '+stat
                        # jeli s jakie zwroty
                        # a co jesli nie ma ? program sie idzie walic ????  Dfakt is not defined
                    elif len(DDow) >0:
                        # pobranie listy faktur dla kontrahenta.
                        # RW sprawdzamy i ustawiamy osobny_rachunek_vat w zaleznoci od tego jaki jest w fakturze
                        SQLFakt="SELECT wyznacznik_id,data,numer,osobny_rachunek_vat"
                        SQLFakt+=" FROM rs_faktury "
                        SQLFakt+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND data>= date '"+DataOd+"' - integer '"+str(Dni)+"' AND data <='"+DataDo+"' AND stan IN ('Z','K')"
                        SQLFakt+=" AND "+FiltrKontrF
                        stat,DFakt,dump,dump = self.PolSQL.Execute(SQLFakt,3)
                        if DFakt == []:
                            stat ="Brak faktur w stanie Z lub K z dat <= " + DataDo + ", z ktrych mona utworzy korekty."
                        else:
                            OddzielneKVat=str(DFakt[0][3])


                        if stat=='OK':
                            # pobranie listy korekt dla kontrahenta.
                            SQLKor="SELECT wyznacznik_id,data,numer,wyznacznik_id_p,data_p,numer_p,wyznacznik_id_o,data_o,numer_o,stan,typ_dok_p"
                            SQLKor+=" FROM rs_korekty "
                            SQLKor+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND data>= date '"+DataOd+"' - integer '"+str(Dni)+"'"
                            SQLKor+=" AND "+FiltrKontrF+" ORDER BY kontrahent_id,data,numer"
                            stat,DKor,dump,dump = self.PolSQL.Execute(SQLKor,3)

                            #pobranie danych z faktur dla kontrahenta (patnika gdy grupowo) - z uwzgldnieniem korekt
                            # dane faktury, dane korekty, typ pary(FB - Faktura bez korekt, FK - faktura z korekt z Anakondy, FR - Faktura z korektami z Recorda

                            LFakt=[]

                            for fakt in DFakt:
                                if stat=='OK':
                                    # Sprawdzenie czy faktura ma jakiekolwiek korekty
                                    MaKorekty=['','','']
                                    ZRekorda=False
                                    WyznF=rsglobal.Dekoduj(fakt[0])
                                    DataF=rsglobal.Dekoduj(fakt[1])
                                    NrF=rsglobal.Dekoduj(str(fakt[2]))

                                    #pierwszy przebieg sprawdzajacy czy i jakie korekty sa do faktury
                                    for kor in DKor:
                                        if stat=='OK':
                                            #znaleziono korekte
                                            if kor[3]==WyznF and kor[4]==DataF and str(kor[5])==NrF and kor[10]=='F':
                                                if kor[6] != WyznF:
                                                    #korekta z recorda
                                                    ZRekorda=True
                                                elif kor[9] in ['W','G']:
                                                    stat='Faktura '+fakt[0]+'/'+fakt[1]+'/'+str(fakt[2])+" ma niezamknit korekt o symbolu "+kor[0]+"/"+kor[1]+"/"+str(kor[2])
                                                else:
                                                    MaKorekty=[kor[0],kor[1],str(kor[2])]

                                if stat=='OK':
                                    #nie ma korekt
                                    if MaKorekty==['','',''] and not ZRekorda:
                                        LFakt.append([WyznF,DataF,NrF,WyznF,DataF,NrF,'FB'])

                                    #tylko korekty z recorda
                                    elif MaKorekty==['','','']:
                                        LFakt.append([WyznF,DataF,NrF,WyznF,DataF,NrF,'FR'])

                                    #istnieje korekta z anakondy
                                    else:
                                        #ptla sprawdzajca ktra korekta jest ostatnia
                                        while MaKorekty != ['','','']:
                                            WyznK=rsglobal.Dekoduj(MaKorekty[0])
                                            DataK=rsglobal.Dekoduj(MaKorekty[1])
                                            NrK=rsglobal.Dekoduj(MaKorekty[2])
                                            MaKorekty=['','','']

                                            for kor in DKor:
                                                if stat=='OK':
                                                    #znaleziono korekte do korekty
                                                    if kor[3]==WyznK and kor[4]==DataK and str(kor[5])==NrK and kor[10]=='K':
                                                        if kor[9] in ['W','G']:
                                                            stat='Faktura '+fakt[0]+'/'+fakt[1]+'/'+str(fakt[2])+" ma niezamknit korekt o symbolu "+kor[0]+"/"+kor[1]+"/"+str(kor[2])
                                                        else:
                                                            MaKorekty=[kor[0],kor[1],str(kor[2])]
                                        if stat=='OK':
                                            # jeli korekta ma dat wiksz od daty tworzonej korekty to przerywamy dziaanie algorytmu
                                            if DataFakt<DataK:
                                                stat='Dla kontrahenta o warunku :'+FiltrKontrF+' istniej korekty o dacie wikszej ni podana data tworzenia korekt'
                                            LFakt.append([WyznF,DataF,NrF,WyznK,DataK,NrK,'FK'])

                            if stat=='OK':
                                #mamy list faktur z ich aktualnymi korektami - teraz pobieramy pozycje i sortujemy na koniec
                                FPoz={}
                                for fakt in LFakt:
                                    #W zalenoci od ostatniego parametru wiemy co robi :)
                                    if fakt[6] in ('FB','FK'):
                                        #faktura bez korekt
                                        if fakt[6]=='FB':
                                            tabela='rs_faktury_pozycje'
                                        elif fakt[6]=='FK':
                                            tabela='rs_korekty_pozycje'
                                        SQL="SELECT artykul_id,ilosc1,ilosc2,wyznacznik_id,data,numer,nr_poz,nr_ppoz FROM "+tabela+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+fakt[3]+"' AND data='"+fakt[4]+"' AND numer="+fakt[5]
                                        dump,DPozF,dump,dump = self.PolSQL.Execute(SQL,3)
                                        for poz in DPozF:
                                            Art=rsglobal.Dekoduj(poz[0]).strip()
                                            if not Art in FPoz:
                                                FPoz[Art]=[]
                                            #pierwsza kolumna jest pomocnicza sluzy do sortowania (prawdziwe dane sa w 2 kolumnie)
                                            #cao to [il.pom.,ilosc1,ilosc2,zdjete1,zdjete2,wyzn,data,numer,nr poz,nr ppoz]
                                            FPoz[Art].append([rsglobal.Dekoduj(poz[4]),poz[1],poz[2],0,0,rsglobal.Dekoduj(poz[3]),rsglobal.Dekoduj(poz[4]),poz[5],poz[6],poz[7]])

                                    #faktura z korektami z recorda
                                    elif fakt[6]=='FR':
                                        #pobranie ilosci z faktur
                                        SIlArt={}
                                        SQL="SELECT artykul_id,ilosc1,ilosc2,wyznacznik_id,data,numer,nr_poz,nr_ppoz FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+fakt[0]+"' AND data='"+fakt[1]+"' AND numer="+fakt[2]
                                        dump,DPozF,dump,dump = self.PolSQL.Execute(SQL,3)
                                        for poz in DPozF:
                                            SIlArt[rsglobal.Dekoduj(poz[0]).strip()]=poz[1:]

                                        #pobranie listy korekt dla faktury
                                        SQL="SELECT wyznacznik_id,data,numer FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_p='"+fakt[0]+"' AND data_p='"+fakt[1]+"' AND numer_p="+fakt[2]+" AND typ_dok_p='F'"
                                        dump,DKorekty,dump,dump = self.PolSQL.Execute(SQL,3)
                                        for kor in DKorekty:
                                            #ptla po korektach pobierajca iloci do korekty
                                            WyznK=rsglobal.Dekoduj(kor[0])
                                            DataK=rsglobal.Dekoduj(kor[1])
                                            NrK=rsglobal.Dekoduj(str(kor[2]))
                                            SQL="SELECT artykul_id,ilosc1_p-ilosc1,ilosc2_p-ilosc2 FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznK+"' AND data='"+DataK+"' AND numer="+NrK
                                            dump,DPozK,dump,dump = self.PolSQL.Execute(SQL,3)
                                            #if kontr[1]=='M0703':
                                            for poz in DPozK:
                                                Art=rsglobal.Dekoduj(poz[0]).strip()
                                                if Art in SIlArt:
                                                    SIlArt[Art][0]=SIlArt[Art][0]-poz[1]
                                                    SIlArt[Art][1]=SIlArt[Art][1]-poz[2]


                                        #zapis uzyskanych liczb do artykulow potencjalnych
                                        for klpoz in SIlArt:
                                            if not klpoz in FPoz:
                                                FPoz[klpoz]=[]
                                            poz=SIlArt[klpoz]
                                            #pierwsza kolumna jest pomocnicza sluzy do sortowania (prawdziwe dane sa w 2 kolumnie)
                                            #cao to [il.pom.,ilosc1,ilosc2,zdjete1,zdjete2,wyzn,data,numer,nr poz,nr ppoz]
                                            FPoz[klpoz].append([rsglobal.Dekoduj(poz[3]),poz[0],poz[1],0,0,rsglobal.Dekoduj(poz[2]),rsglobal.Dekoduj(poz[3]),poz[4],poz[5],poz[6]])

                                #sortujemy kolumny artykulem i ilosci (od najwiekszej do najmniejszej)
                                for Art in FPoz:
                                    FPoz[Art].sort()
                                    FPoz[Art].reverse()

                            #mamy dane z faktur/korekt oraz dane z dowodw dostaw. Rozliczamy.
                            #robimy dwa przebiegi. Jeden - scigajcy z tych faktur, do ktrych na pewno bd korekty. Potem pobierane z gry (od najwikszych iloci)
                            #uwzgldniamy te dat faktury (gdyby si okazao e jest wczeniejsza ni zwrot)
                            if stat=='OK':
                                #Tu trzymana jest lista juz wykorzystanych faktur/korekt. W pierwszej kolejnosci uzywane sa
                                LPomFakt=[]
                                for dow in DDow:
                                    SymbD=rsglobal.Dekoduj(dow[0])
                                    SymbSkrD=dow[5]
                                    DataD=rsglobal.Dekoduj(dow[4])
                                    Art=rsglobal.Dekoduj(dow[1]).strip()
                                    IlR1=dow[2]
                                    IlR2=dow[3]
                                    Przel=IlR2/IlR1
                                    if not Art in FPoz:
                                        dane.append('Brak artykuu '+Art+u' na wszystkich pobranych fakturach dla kontrahenta '+kontr[1])
                                        if SymbD[0:SymbD.rfind("/")] not in LNierozliczonych:
                                            LNierozliczonych.append(SymbD[0:SymbD.rfind("/")])
                                    else:
                                        SArt=FPoz[Art]
                                        UwzgledniacFaktury=True
                                        for i in range(2):

                                            if IlR1>0:
                                                for poz in SArt:
                                                    #lecimy pozycjami od najwikszej do najmniejszej. Ew. uwzgldniamy faktury
                                                    SymbF=[poz[5],poz[6],str(poz[7])]
                                                    DataF=poz[6]
                                                    IleMozna=poz[1]-poz[3]

                                                    #albo nie musimy uwzgledniac faktur albo jest to wykorzystywana faktura

                                                    if ((not UwzgledniacFaktury) or (SymbF in LPomFakt)) and (IleMozna >0) and (IlR1 >0):
                                                        IlSciag=min(IlR1,IleMozna)
                                                        IlSciag2=IlSciag*Przel

                                                        #odejmujemy z iloci do cignicia
                                                        IlR1=IlR1-IlSciag
                                                        IlR2=IlR1*Przel

                                                        #dodajemy do zdjtych w artykuach
                                                        poz[3]=poz[3]+IlSciag
                                                        poz[4]=poz[4]+(IlSciag*Przel)
                                                        #dodajemy faktur do listy "uywanych faktur"
                                                        if not SymbF in LPomFakt:
                                                            LPomFakt.append([poz[5],poz[6],str(poz[7])])
                                                        #zapisujemy rekord - poczenie dowodw dostaw i faktur/korekt ( to znajdzie si na opisie korekty)
                                                        LKor.append([poz[5],poz[6],poz[7],poz[8],poz[9],IlSciag,SymbD,SymbSkrD,IlSciag2])
                                                        if SymbD[0:SymbD.rfind("/")] not in LZamykanych:
                                                            LZamykanych.append(SymbD[0:SymbD.rfind("/")])

                                                UwzgledniacFaktury=False
                                        #po ustawieniu par wida, czy wszystko udao si cign.
                                        #jeli nie, to dodana zostaje informacja, e czego nie zdjto w caoci.
                                        if IlR1>0:
                                            dane.append('Nie udao si zdj artykuu '+Art+' z dowodu dostawy '+SymbD+' dla kontrahenta '+kontr[1])
                                            if SymbD[0:SymbD.rfind("/")] not in LNierozliczonych:
                                                LNierozliczonych.append(SymbD[0:SymbD.rfind("/")])

                            #Teraz generujemy korekty na to co sie dao cign
                            #w kluczach uzywanych faktur sa symbole korekt ( a nie oryginalnych faktur)
                            if stat=='OK':
                                #generujemy poszczegolne korekty
                                for fakt in LPomFakt:
                                    if stat=='OK':
                                        LPotencDowod=[]
                                        #wybieramy kolejny numer korekty
                                        stat,DNr,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+DataFakt+"\\\']','K');",3)
                                        if DNr[0][0] in (None,'None',''):
                                            stat=u"Bdy przy pobieraniu numeru korekty"
                                        NumerK=DNr[0][0]
                                        WyznP=fakt[0]
                                        DataP=fakt[1]
                                        NrP=fakt[2]
                                        for f in LFakt:
                                            if WyznP==f[3] and DataP==f[4] and NrP==f[5]:
                                                WyznO=f[0]
                                                DataO=f[1]
                                                NrO=f[2]
                                        #pobranie danych pomocniczych z nagwka faktury/korekty
                                        if WyznP != WyznO or DataP != DataO or NrP != NrO:
                                            TypDokP='K'
                                            tabela='korekty'
                                            tytul='NULL'
                                        else:
                                            TypDokP='F'
                                            tabela='faktury'
                                            tytul='NULL'
                                        SQLPom="SELECT kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,dostawy_od_dnia,dostawy_do_dnia,kierowca,projekt_id," #0 - 7
                                        SQLPom+=tytul+",opis,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru," #8 - 17
                                        SQLPom+="termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,czy_bonus,tekst_nad_podp,tekst_pod_podp,kraj_opodatkowania," #18 - 25
                                        SQLPom+="upust,upust_wartosc,upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal," #26 - 31                                                 #AB 01.08.19r
                                        SQLPom+="kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,osobny_rachunek_vat, czy_mpp, ozn_trans,ozn_sprzedaz" #32 - 43 #MK 2020-04-27
                                        SQLPom+=" FROM rs_"+tabela+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznP+"' AND data='"+DataP+"' AND numer="+str(NrP)+";"
                                        stat,DanePom,dump,dump = self.PolSQL.Execute(SQLPom,3)
                                        PomKontrId=rsglobal.ObrobTekst(DanePom[0][0])
                                        PomZamId=rsglobal.ObrobTekst(DanePom[0][1])
                                        PomPlatId=rsglobal.ObrobTekst(DanePom[0][2])
                                        PomMiejId=rsglobal.ObrobTekst(DanePom[0][3])
                                        PomDostawyOd=rsglobal.ObrobTekst(DanePom[0][4])
                                        PomDostawyDo=rsglobal.ObrobTekst(DanePom[0][5])
                                        PomKierowca=rsglobal.ObrobTekst(DanePom[0][6])
                                        PomProjekt=rsglobal.ObrobTekst(DanePom[0][7])
                                        LZdjKor=[]
                                        for kor in LKor:
                                            KlPoz=[WyznP,DataP,int(NrP[0:-2])]
                                            if KlPoz==kor[0:3]:
                                                if not [kor[7]] in LZdjKor:
                                                    LZdjKor.append([rsglobal.Dekoduj(kor[7])])
                                        LZdjKor.sort()
                                        PomOpis=''
                                        i=1
                                        for kor in LZdjKor:
                                            if i>4:
                                                PomOpis+=chr(10)
                                            PomOpis+=kor[0]+"  "
                                            i=i+1
                                        PomOpis=PomOpis.replace("'","\\\'")
                                        PomWaluta=rsglobal.ObrobTekst(DanePom[0][10])
                                        PomKurs=str(DanePom[0][11])
                                        PomNrTabeli=rsglobal.ObrobTekst(DanePom[0][12])
                                        PomDataTabeli=rsglobal.ObrobTekst(DanePom[0][13])
                                        PomWersja=rsglobal.ObrobTekst(DanePom[0][14])
                                        PomSposZapl=rsglobal.ObrobTekst(DanePom[0][15])
                                        PomDni=rsglobal.UsunKropkaZero(DanePom[0][16])
                                        PomDataOdb=rsglobal.ObrobTekst(DanePom[0][17])
                                        PomTerminZ=rsglobal.ObrobTekst(DanePom[0][18])
                                        PomHandl=rsglobal.ObrobTekst(DanePom[0][19])
                                        PomSposOdbF=rsglobal.ObrobTekst(DanePom[0][20])
                                        PomSposDost=rsglobal.ObrobTekst(DanePom[0][21])
                                        PomBonus=rsglobal.ObrobBool(DanePom[0][22])
                                        PomTekstNad=rsglobal.ObrobTekst(DanePom[0][23])
                                        PomTekstPod=rsglobal.ObrobTekst(DanePom[0][24])
                                        PomKrajOpod=rsglobal.ObrobTekst(DanePom[0][25])
                                        PomUpust=str(DanePom[0][26])
                                        PomUpustWart=str(DanePom[0][27])
                                        PomUpustWartWal=str(DanePom[0][28])
                                        PomRabat=str(DanePom[0][29])
                                        PomRabatWart=str(DanePom[0][30])
                                        PomRabatWartWal=str(DanePom[0][31])
                                        PomKwNetto=str(DanePom[0][32])
                                        PomKwVAT=str(DanePom[0][33])
                                        PomWartOpak=str(DanePom[0][34])
                                        PomDoZaplaty=str(DanePom[0][35])
                                        PomKwNettoWal=str(DanePom[0][36])
                                        PomKwVATWal=str(DanePom[0][37])
                                        PomWartOpakWal=str(DanePom[0][38])
                                        PomDoZaplatyWal=str(DanePom[0][39])
                                        OddzielneKVat=str(DanePom[0][40])
                                        #AB 01.08.19r
                                        PomMPP=rsglobal.ObrobBool(DanePom[0][41])
                                        #MK 2020-04-27 - poczatek
                                        OznTrans = str(DanePom[0][42])
                                        OznSprz = str(DanePom[0][43])
                                        if OznTrans == 'None':
                                            OznTrans = "NULL"
                                        else:
                                            OznTrans = "'" + OznTrans + "'"

                                        if OznSprz == 'None':
                                            OznSprz = "NULL"
                                        else:
                                            OznSprz = "'" + OznSprz + "'"
                                        #MK 2020-04-27 - koniec

                                        SqlN='INSERT INTO rs_korekty '
                                        SqlN+='(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,typ_dok_p,wyznacznik_id_p,data_p,numer_p,wyznacznik_id_o,data_o,numer_o,'
                                        SqlN2="('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerK)+",'"+self.oddzial_id+"','W','"+TypDokP+"','"+WyznP+"','"+DataP+"',"+str(NrP)+",'"+WyznO+"','"+DataO+"',"+str(NrO)+","

                                        SqlN+='kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,dostawy_od_dnia,dostawy_do_dnia,kierowca,projekt_id,'
                                        SqlN2+=PomKontrId+","+PomZamId+","+PomPlatId+","+PomMiejId+","+PomDostawyOd+","+PomDostawyDo+","+PomKierowca+","+PomProjekt+","

                                        SqlN+='tytul_zmniejszenia_podatku,opis,waluta,kurs,nr_tabeli,data_tabeli,kurs_p,nr_tabeli_p,data_tabeli_p,'
                                        SqlN2+=Tytul+",'"+PomOpis+"',"+PomWaluta+","+PomKurs+","+PomNrTabeli+","+PomDataTabeli+","+PomKurs+","+PomNrTabeli+","+PomDataTabeli+","

                                        SqlN+='wersja,sposob_zaplaty,dni,data_odbioru,wersja_p,sposob_zaplaty_p,dni_p,data_odbioru_p,'
                                        SqlN2+=PomWersja+","+PomSposZapl+","+PomDni+",NULL,"+PomWersja+","+PomSposZapl+","+PomDni+","+PomDataOdb+","

                                        SqlN+='termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,czy_bonus,tekst_nad_podp,tekst_pod_podp,kraj_opodatkowania,'
                                        SqlN2+="'"+DataFakt+"'::DATE+"+PomDni+","+PomHandl+","+PomSposOdbF+","+PomSposDost+","+PomBonus+","+PomTekstNad+","+PomTekstPod+","+PomKrajOpod+","

                                        #RW dodanie do instera danych z osobny rachunek vat
                                        SqlN+='upust,upust_wartosc,upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal,osobny_rachunek_vat,'
                                        SqlN2+=PomUpust+","+PomUpustWart+","+PomUpustWartWal+","+PomRabat+","+PomRabatWart+","+PomRabatWartWal+","+OddzielneKVat+","

                                        SqlN+='kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,'
                                        SqlN2+=PomKwNetto+","+PomKwVAT+","+PomWartOpak+","+PomDoZaplaty+","+PomKwNettoWal+","+PomKwVATWal+","+PomWartOpakWal+","+PomDoZaplatyWal+","

                                        SqlN+='upust_p,upust_wartosc_p,upust_wartosc_wal_p,rabat_p,rabat_wartosc_p,rabat_wartosc_wal_p,'
                                        SqlN2+=PomUpust+","+PomUpustWart+","+PomUpustWartWal+","+PomRabat+","+PomRabatWart+","+PomRabatWartWal+","
                                                                                                                                                                                #AB 01.08.19r
                                        SqlN+='kwota_netto_p,kwota_vat_p,wartosc_opakowan_p,do_zaplaty_p,kwota_netto_wal_p,kwota_vat_wal_p,wartosc_opakowan_wal_p,do_zaplaty_wal_p, czy_mpp, ozn_trans, ozn_sprzedaz)' #MK 2020-04-27
                                        SqlN2+=PomKwNetto+","+PomKwVAT+","+PomWartOpak+","+PomDoZaplaty+","+PomKwNettoWal+","+PomKwVATWal+","+PomWartOpakWal+","+PomDoZaplatyWal+","+PomMPP+","+OznTrans+","+OznSprz+");" #MK 2020-04-27

                                        SqlN+=' VALUES '
                                        SqlN+=SqlN2

                                        #--- pobranie i wstawienie pozycji
                                        SQLPomP="SELECT nr_poz,nr_ppoz,artykul_id,p.ilosc1,p.ilosc2,a.przelicznik,cena_netto1,cena_netto2,cena_upust1,cena_upust2," #0 - 9
                                        SQLPomP+="cena_brutto1,cena_brutto2,upust,upust_wartosc,p.stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd," #10 -19
                                        SQLPomP+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,COALESCE(p.cecha1_opis,''),COALESCE(p.cecha1_wartosc,''),p.kod_gtu" #20 - 30 #MK 2020-04-03
                                        SQLPomP+=" FROM rs_"+tabela+"_pozycje p INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                                        SQLPomP+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznP+"' AND data='"+DataP+"' AND numer="+str(NrP)+";"
                                        stat,DanePomP,dump,dump = self.PolSQL.Execute(SQLPomP,3)
                                        #dla kadej pozycji sprawdzamy jakie dane s dla niej w LKor (poaczenie dowodw i korekt). Sprawdzamy po kluczu korekty
                                        InsP=''
                                        UpdP=''
                                        for poz in DanePomP:
                                            KlPoz=[WyznP,DataP,int(NrP[0:-2]),poz[0],poz[1]]
                                            IloscZdj=0
                                            Opis=''
                                            for kor in LKor:
                                                if KlPoz==kor[0:5]:
                                                    IloscZdj+=kor[5]
                                                    if Opis != '':
                                                        Opis+=chr(10)
                                                    Opis+='Z dokumentu '+kor[6]+' zdjto sztuk : '+str(kor[5])
                                            PomNrPoz=str(poz[0])
                                            PomNrPPoz=str(poz[1])
                                            PomArt=rsglobal.ObrobTekst(poz[2])
                                            PomIl1=poz[3]
                                            PomIl2=poz[4]
                                            PomPrzel=poz[5]
                                            PomIl1PoZdj=PomIl1-IloscZdj
                                            PomIl2PoZdj=PomIl1PoZdj*PomPrzel
                                            PomCN1=poz[6]
                                            PomCN2=str(poz[7])
                                            PomCU1=poz[8]
                                            PomCU2=str(poz[9])
                                            PomCB1=poz[10]
                                            PomCB2=str(poz[11])
                                            PomUpust=poz[12]
                                            PomUpustWartP=poz[13]
                                            PomUpustWart=rsglobal.RSRound(PomIl1PoZdj*(PomCN1-PomCU1),2)
                                            PomStVAT=rsglobal.ObrobTekst(poz[14])
                                            if PomStVAT.strip("'") in self.ListaStawekZn:
                                                PomStVATLiczb=0
                                            else:
                                                PomStVATLiczb=int(PomStVAT[1:-1])

                                            PomWartN=rsglobal.RSRound(PomIl1PoZdj*PomCU1,2)
                                            PomWartV=rsglobal.RSRound(PomWartN*0.01*PomStVATLiczb,2)
                                            PomWartB=rsglobal.RSRound(PomWartN+PomWartV,2)
                                            PomWartNP=str(rsglobal.RSRound(poz[15],2))
                                            PomWartVP=str(rsglobal.RSRound(poz[16],2))
                                            PomWartBP=str(rsglobal.RSRound(poz[17],2))
                                            PomNrSerii=rsglobal.ObrobTekst(poz[18])
                                            PomTerminP=rsglobal.ObrobTekst(poz[19])
                                            PomCNW1=rsglobal.RSRound(poz[20],2)
                                            PomCNW2=str(rsglobal.RSRound(poz[21],2))
                                            PomCUW1=rsglobal.RSRound(poz[22],2)
                                            PomCUW2=str(rsglobal.RSRound(poz[23],2))
                                            PomWartNW=rsglobal.RSRound(PomIl1PoZdj*PomCUW1,2)
                                            PomWartVW=rsglobal.RSRound(PomWartNW*PomStVATLiczb*0.01,2)
                                            PomWartBW=rsglobal.RSRound(PomWartNW+PomWartVW,2)
                                            PomWartNWP=str(rsglobal.RSRound(poz[24],2))
                                            PomWartVWP=str(rsglobal.RSRound(poz[25],2))
                                            PomWartBWP=str(rsglobal.RSRound(poz[26],2))
                                            CechaOpis=rsglobal.Dekoduj(poz[27])
                                            CechaWart=rsglobal.Dekoduj(poz[28])
                                            KodGtu=str(rsglobal.Dekoduj(poz[29])) #MK 2020-04-03

                                            #najpierw jest INSERT nieobrobionej pozycji a potem UPDATE na zmienione wartosci (to przepisuje odpowiednio kwoty do nagwka i stawek vat)
                                            InsP+="INSERT INTO rs_korekty_pozycje "
                                            InsP+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,artykul_id,"
                                            InsP2="('"+self.firma_id+"','"+Wyzn+"','"+DataFakt+"',"+str(NumerK)+","+PomNrPoz+","+PomNrPPoz+","+PomArt+","

                                            InsP+="ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
                                            InsP2+=str(PomIl1PoZdj)+","+str(PomIl2PoZdj)+","+str(PomCN1)+","+PomCN2+","+str(PomCU1)+","+PomCU2+","+str(PomCB1)+","+PomCB2+","

                                            InsP+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
                                            InsP2+=str(PomUpust)+","+str(PomUpustWartP)+","+PomStVAT+","+str(PomWartNP)+","+str(PomWartVP)+","+str(PomWartBP)+","

                                            InsP+="ilosc1_p,ilosc2_p,cena_netto1_p,cena_netto2_p,cena_upust1_p,cena_upust2_p,cena_brutto1_p,cena_brutto2_p,"
                                            InsP2+=str(PomIl1)+","+str(PomIl2)+","+str(PomCN1)+","+PomCN2+","+str(PomCU1)+","+PomCU2+","+str(PomCB1)+","+PomCB2+","

                                            InsP+="upust_p,upust_wartosc_p,stawka_vat_p,wartosc_netto_p,wartosc_vat_p,wartosc_brutto_p,"
                                            InsP2+=str(PomUpust)+","+str(PomUpustWartP)+","+PomStVAT+","+str(PomWartNP)+","+str(PomWartVP)+","+str(PomWartBP)+","

                                            InsP+="nr_serii,termin_przyd,cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
                                            InsP2+=PomNrSerii+","+PomTerminP+","+str(PomCNW1)+","+PomCNW2+","+str(PomCUW1)+","+PomCUW2+","

                                            InsP+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
                                            InsP2+=str(PomWartNWP)+","+str(PomWartVWP)+","+str(PomWartBWP)+","

                                            InsP+="cena_wal1_p,cena_wal2_p,cena_upust_wal1_p,cena_upust_wal2_p,"
                                            InsP2+=str(PomCNW1)+","+PomCNW2+","+str(PomCUW1)+","+PomCUW2+","

                                            InsP+="wartosc_wal_netto_p,wartosc_wal_vat_p,wartosc_wal_brutto_p, cecha1_opis,cecha1_wartosc,kod_gtu)"  #MK 2020-04-03
                                            InsP2+=str(PomWartNWP)+","+str(PomWartVWP)+","+str(PomWartBWP)+",'"+CechaOpis+"','"+CechaWart #MK 2020-04-03
                                            if str(poz[29]) == 'None' or '':  #MK 2020-04-03
                                                InsP2+="',NULL)"
                                            else:
                                                InsP2+="','"+KodGtu+"')"

                                            InsP+=" VALUES "+InsP2+";" +chr(10)
                                            #UPDATE pozycji:
                                            UpdP+="UPDATE rs_korekty_pozycje SET wartosc_netto="+str(PomWartN)+", wartosc_vat="+str(PomWartV)+", wartosc_brutto="+str(PomWartB)+","
                                            UpdP+="wartosc_wal_netto="+str(PomWartNW)+", wartosc_wal_vat="+str(PomWartVW)+", wartosc_wal_brutto="+str(PomWartBW)+", upust_wartosc="+str(PomUpustWart)
                                            UpdP+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+DataFakt+"' AND numer="+str(NumerK)+" AND nr_poz="+PomNrPoz+" AND nr_ppoz="+PomNrPPoz+" ;"+chr(10)

                                        #--- pobranie i wstawienie stawek vat
                                        InsV="INSERT INTO rs_korekty_vat (firma_id,wyznacznik_id,data,numer,stawka_vat,wartosc_netto,"
                                        InsV+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
                                        InsV+="wartosc_netto_p, wartosc_vat_p, wartosc_brutto_p, wartosc_wal_netto_p, wartosc_wal_vat_p,wartosc_wal_brutto_p) "
                                        InsV+="SELECT firma_id,'"+Wyzn+"','"+DataFakt+"',"+str(NumerK)+",stawka_vat,wartosc_netto,"
                                        InsV+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
                                        InsV+="wartosc_netto, wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat,wartosc_wal_brutto"
                                        InsV+=" FROM rs_"+tabela+"_vat WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznP+"' AND data='"+DataP+"' AND numer="+str(NrP)+";"

                                        #--- pobranie i wstawienie ewentualnych pozycji opisowych
                                        InsO="INSERT INTO rs_korekty_pozycje_opisowe (firma_id,wyznacznik_id,data,numer,nr_poz,opis_pozycji,stawka_vat,wartosc_netto,"
                                        InsO+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto, opis_pozycji_p,"
                                        InsO+="stawka_vat_p, wartosc_netto_p, wartosc_vat_p, wartosc_brutto_p, wartosc_wal_netto_p, wartosc_wal_vat_p,"
                                        InsO+="wartosc_wal_brutto_p,kod_gtu) " #MK 2020-04-03
                                        InsO+="SELECT firma_id,'"+Wyzn+"','"+DataFakt+"',"+str(NumerK)+",nr_poz,opis_pozycji,stawka_vat,wartosc_netto,"
                                        InsO+="wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto, opis_pozycji,"
                                        InsO+="stawka_vat, wartosc_netto, wartosc_vat, wartosc_brutto, wartosc_wal_netto, wartosc_wal_vat,wartosc_wal_brutto,kod_gtu" #MK 2020-04-03
                                        InsO+=" FROM rs_"+tabela+"_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznP+"' AND data='"+DataP+"' AND numer="+str(NrP)+";"
                                        rsglobal.ZapiszDoLogow('TU MASZ ZAPYTANIEEEEEEEEEEEEEEE ' + InsP, 1)
                                        stat,dump,dump,dump = self.PolSQL.Execute(SqlN,1)
                                        if stat != 'OK':
                                            rsglobal.ZapiszDoLogow('BL TW KOREKT N '+stat,1)

                                        if stat == 'OK':
                                            stat = fs_sprzedaz_pom.PrzeniesUdzialyHandlowcowZFakturyDoKorekty(self,Wyzn,DataFakt,NumerK)

                                        if stat=='OK':
                                            stat,dump,dump,dump = self.PolSQL.Execute(InsP,1)
                                            if stat != 'OK':
                                                rsglobal.ZapiszDoLogow('BL TW KOREKT P '+stat,1)

                                        if stat=='OK':
                                            stat,dump,dump,dump = self.PolSQL.Execute(InsO,1)
                                            if stat != 'OK':
                                                rsglobal.ZapiszDoLogow('BL TW KOREKT O '+stat,1)

                                        if stat=='OK':
                                            stat,dump,dump,dump = self.PolSQL.Execute(InsV,1)
                                            if stat != 'OK':
                                                rsglobal.ZapiszDoLogow('BL TW KOREKT V '+stat,1)

                                        if stat=='OK':
                                            stat,dump,dump,dump = self.PolSQL.Execute(UpdP,1)
                                            if stat != 'OK':
                                                rsglobal.ZapiszDoLogow('BL TW KOREKT UP '+stat,1)


                    if stat=='OK':
                        #dodajemy ilosci rozliczone w odpowiednich pozycjach dowodw (dane dla kontrahenta)
                        SQLPoz=''
                        for kor in LKor:
                            PomTrasa=rsglobal.Dekoduj(kor[6].split('/')[0])
                            PomData=rsglobal.Dekoduj(kor[6].split('/')[1])
                            PomTryb=rsglobal.Dekoduj(kor[6].split('/')[2])
                            PomNr=rsglobal.Dekoduj(kor[6].split('/')[3])
                            PomNrPoz=rsglobal.Dekoduj(kor[6].split('/')[4])
                            SQLPoz+="UPDATE rs_dowody_dostaw_pozycje SET ilosc_rozl1=ilosc_rozl1+"+str(kor[5])+", ilosc_rozl2=ilosc_rozl2+"+str(kor[8])
                            SQLPoz+=" WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+PomTrasa+"' AND data='"+PomData+"'"
                            SQLPoz+=" AND tryb_dostawy='"+PomTryb+"' AND numer="+PomNr+" AND nr_poz="+PomNrPoz+";"

                        if SQLPoz != '':
                            stat,dump,dump,dump = self.PolSQL.Execute(SQLPoz,1)
                        #zostao zrobi update rozliczonych dowodw z 3 na 4
                    if stat=='OK':
                        for dow in LNierozliczonych:
                            if dow in LZamykanych:
                                LZamykanych.remove(dow)
                        if len(LZamykanych)>0:
                            SQLStan=''
                            for dow in LZamykanych:
                                PomTrasa=rsglobal.Dekoduj(dow.split('/')[0])
                                PomData=rsglobal.Dekoduj(dow.split('/')[1])
                                PomTryb=rsglobal.Dekoduj(dow.split('/')[2])
                                PomNr=rsglobal.Dekoduj(dow.split('/')[3])
                                SQLStan+="UPDATE rs_dowody_dostaw SET stan=4 WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+self.oddzial_id+"'"
                                SQLStan+=" AND trasa='"+PomTrasa+"' AND data='"+PomData+"' AND tryb_dostawy='"+PomTryb+"' AND numer="+PomNr+";"
                            stat,dump,dump,dump = self.PolSQL.Execute(SQLStan,1)

                    if stat=='OK':
                        self.PolSQL.Commit()
                    else:
                        self.PolSQL.Rollback()
                        rsglobal.ZapiszDoLogow("UWAGA BD! "+stat,1)
