#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#Boa:Frame:WDowodyDostawZamknijZInnegoOddzialu
# -------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_zamknij_z_innego_oddz.py
# Authors:     Aleksander Bargie
# Created:     2021/03/12
# RCS-ID:      $Id: fs_dowody_dostaw_zamknij_z_innego_oddz.py $
# Copyright:   Record System(c) 2021
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
import datetime

stat = 'OK'

"""Funkcje:
1. Update z RSEdit
5. Pobranie danych"""

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'symbol': [1, 5, 7, 15], 'pin': [1, 5, 7, 15]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_dowody_dostaw_zamknij_z_innego_oddz z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in (1, 5, 7, 15):
        symbol = klucze['symbol']
        if len(symbol.split('/')) != 3:
            stat = u'podano bdny symbol dowodu dostawy'
        else:
            oddzial_id = symbol.split('/')[0]
            data       = str(datetime.datetime.strptime(symbol.split('/')[1], '%y%m%d'))[:10]
            numer      = symbol.split('/')[2]
        pin    = klucze['pin']
dane = []
wyn1 = []
wyn2 = []

UprModyf = ((self.oddzial_id, '028012') in self.uprawnienia) or ((self.oddzial_id, '028013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


# -------------------------------------------------------------------------------
# -------- POBRANIE TRASY (1, 5, 7, 15)
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (1, 5, 7, 15):
    stat, DaneT, dump, dump = self.PolSQL.Execute(
        "SELECT kod FROM rs_trasy WHERE firma_id = '" + self.firma_id + "' ORDER BY kod LIMIT 1;", 3)
    if stat != 'OK':
        stat = u'Bd pobieranie trasu'
    if stat == 'OK':
        if len(DaneT) == 0:
            stat = u'Brak zdefiniowanych tras w firmie'
    if stat == 'OK':
        trasa = DaneT[0][0]
        if trasa.strip() in (None, '', 'None'):
            stat = u'Brak zdefiniowanych traf w firmie'


# -------------------------------------------------------------------------------
# -------- POBRANIE TRYBU (1, 5, 7, 15)
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (1, 5, 7, 15):
    stat, DaneTB, dump, dump = self.PolSQL.Execute(
        "SELECT kod FROM rs_tryby_dostaw  WHERE firma_id = '" + self.firma_id + "' ORDER BY kod LIMIT 1;", 3)
    if stat != 'OK':
        stat = u'Bd pobierania trybu'
    if stat == 'OK':
        if len(DaneTB) == 0:
            stat = u'Brak zdefiniowanych trybw w firmie'
    if stat == 'OK':
        tryb = DaneTB[0][0]
        if tryb.strip() in (None, '', 'None'):
            stat = u'Brak zdefiniowanych trybw w firmie'


# -------------------------------------------------------------------------------
# -------- SPRAWDZENIE PINU (1, 5, 7, 15)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5, 7, 15):
    klucz_dd = self.firma_id + oddzial_id + trasa + data + tryb + str(numer)
    if pin  != rsglobal.GenerujPIN(klucz_dd):
        stat = "Podano bdny PIN"
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(pin)
        rsglobal.ZapiszDoLogow(rsglobal.GenerujPIN(klucz_dd))


# -------------------------------------------------------------------------------
# -------- POBRANIE STANU (1, 5, 7, 15)
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (1, 5, 7, 15):
    sql = "SELECT stan FROM rs_dowody_dostaw  WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' AND " \
                      "numer='{}'".format(self.firma_id, oddzial_id, trasa, data, tryb, numer)
    stat, DaneTB, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bd pobierania stanu'
    if stat == 'OK':
        if len(DaneTB) == 0:
            stat = u'Nie odnaleziono dowodu'
    if stat == 'OK':
        stan = DaneTB[0][0]
        if not stan.strip() <'2':
            stat = u'Edycja dowodw moliwa jedynie w stanie mniejszym ni 2'

# -------------------------------------------------------------------------------
# -------- EDYCJA GRIDA EDYTOWALNEGO (1)
# -------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']


# -------------------------------------------------------------------------------
# -----------------------------   DELETE (1) ------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0])>0:
        stat = "DEL"

# -------------------------------------------------------------------------------
# -------------------------------  UPDATE (1)  ----------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_dowody_dostaw_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])):
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if stat == 'OK' and pole in ['ilosc_pobr1']:
                        nr_poz = Update[2][i][Update[3].index('nr_poz')]
                        SET+=pole+"="+str(wart)+","
                        if stan == '0':
                            pole = 'ilosc_dost1'
                        SQLPrzel = "SELECT przelicznik FROM rs_dowody_dostaw_pozycje JOIN rs_artykuly USING(firma_id, artykul_id) " \
                                   " WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' AND " \
                                   "numer='{}' AND nr_poz='{}';".format(self.firma_id, oddzial_id, trasa, data, tryb, numer, nr_poz)
                        stat, DPrzel, dump, dump = self.PolSQL.Execute(SQLPrzel, 3)
                        if stat == 'OK':
                            wart2 = rsglobal.RSRound(wart * DPrzel[0][0], 3)
                            SET+="ilosc_pobr2="+str(wart2)+","
                    if stat == 'OK' and pole in ['ilosc_dost1']:
                        nr_poz = Update[2][i][Update[3].index('nr_poz')]
                        SET+=pole+"="+str(wart)+","
                        SQLPrzel = "SELECT przelicznik FROM rs_dowody_dostaw_pozycje JOIN rs_artykuly USING(firma_id, artykul_id) " \
                                   " WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' AND " \
                                   "numer='{}' AND nr_poz='{}';".format(self.firma_id, oddzial_id, trasa, data, tryb, numer, nr_poz)
                        stat, DPrzel, dump, dump = self.PolSQL.Execute(SQLPrzel, 3)
                        if stat == 'OK':
                            wart2 = rsglobal.RSRound(wart * DPrzel[0][0], 3)
                            SET+="ilosc_dost2="+str(wart2)+","

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' AND " \
                      "numer='{}'".format(self.firma_id, oddzial_id, trasa, data, tryb, numer)
                for j in xrange(len(Update[2][i])):
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['nr_poz']:
                        WHERE+= " AND "+pole+"="+str(wart)+""
                WHERE+=";"
                sql+=UPDATE+SET+WHERE

            if sql!='':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat != 'OK':
                    stat = u"Bd przy modyfikowaniu danych: "+stat
                    rsglobal.ZapiszDoLogow(sql)
                    dane.append(stat)

# -------------------------------------------------------------------------------
# ------------------------------  INSERT (1)  -----------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0])>0:
        stat='INS'

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1 - update, 5 - select)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    SQL = """SELECT nr_poz, TRIM(artykul_id) ||' - '|| TRIM(nazwa), ilosc_dost1, ilosc_pobr1 
             FROM rs_dowody_dostaw_pozycje 
             JOIN rs_artykuly using(firma_id, artykul_id)
             WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' AND numer={};
          """.format(self.firma_id, oddzial_id, trasa, data, tryb, numer)
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        rsglobal.ZapiszDoLogow(SQL)
        dane.append(stat)
    elif len(dane) == 0:
        stat = "Nie odnaleziono dowodu dostawy."

# -------------------------------------------------------------------------------
# ---   ZAMKNIECIE DD (7)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (7, ):
    UPD2  = " UPDATE rs_dowody_dostaw SET stan='2' "
    WHERE = " WHERE firma_id='{}' AND oddzial_id='{}' AND trasa='{}' AND data='{}' AND tryb_dostawy='{}' AND " \
            "numer='{}'".format(self.firma_id, oddzial_id, trasa, data, tryb, numer)


    stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(UPD2 + WHERE), 1)
    if stat != 'OK':
        stat = u"Bd przy modyfikowaniu danych: " + stat
        rsglobal.ZapiszDoLogow(sql)
        dane.append(stat)
    else:
        SEL = "SELECT opis from rs_oddzialy WHERE firma_id='{}' AND oddzial_id='{}';".format(self.firma_id, oddzial_id)
        stat, dane, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SEL), 5)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(UPD2)
            stat = u"Bd pobierania opisu oddziau."

# -------------------------------------------------------------------------------
# ---  PODANIE TRASY I TRYBU (15)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (15, ):
    dane = [trasa, tryb, stan]
