# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_zmiana_cen.py.py
# Purpose:     Przeliczenie cen za okres na dowodach dostaw
# Author:      Aleksander Bargie
# Created:     2022/02/03
# RCS-ID:      $Id: fs_dowody_dostaw_zmiana_cen.py $
# Copyright:   (c) 2022 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'DataOd': [1, ], 'DataDo': [1, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista
if stat == 'OK':
    if Funkcja == 1:
        data_od = klucze['DataOd']
        data_do = klucze['DataDo']

dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
#-------- AKTUALIZACJA CEN (1)
#-------------------------------------------------------------------------------
# Glowne zapytanie znajdujace dd w zakresie dat dla firmy na ktorych ceny sie nie zgadzaja
sql = '''SELECT {}
         FROM rs_dowody_dostaw dd 
             JOIN rs_dowody_dostaw_pozycje p USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)
             JOIN(SELECT string_to_array(
                         RTRIM(
                         LTRIM(
                         rsf_podaj_ceny_dla_kontrahenta(
                             firma_id, kontrahent_id, 'PLN', DATA::TEXT, artykul_id, '', -1, oddzial_id),
                             '['),
                             ']')
                             ,',') AS a
                             , 
                     firma_id, oddzial_id, trasa, "data", tryb_dostawy, numer, nr_poz
                 FROM rs_dowody_dostaw_pozycje rddp 
                 WHERE firma_id = %s 
                     AND data BETWEEN %s AND %s) AS ceny 
                         ON (p.firma_id, p.oddzial_id, p.trasa, p.data, p.tryb_dostawy, p.numer, p.nr_poz) = 
                         (ceny.firma_id, ceny.oddzial_id, ceny.trasa, ceny.data, ceny.tryb_dostawy, ceny.numer, ceny.nr_poz)
                         AND(p.cena_netto1  != ceny.a[1]::NUMERIC OR
                            p.cena_netto2  != ceny.a[2]::NUMERIC OR
                            p.cena_brutto1 != ceny.a[3]::NUMERIC OR
                            p.cena_brutto2 != ceny.a[4]::NUMERIC OR
                            p.cena_upust1 != ceny.a[5]::NUMERIC OR
                            p.cena_upust2 != ceny.a[6]::NUMERIC)
         WHERE dd.firma_id = %s 
             AND dd.data BETWEEN %s AND %s
             AND stan IN ('0', '1')
      '''
# z takimi kolumnami otrzymamy liczbe dd na ktorych cos jest do poprawki
kol_zliczanie = " COUNT(DISTINCT (dd.firma_id,dd.oddzial_id, dd.trasa, dd.data, dd.tryb_dostawy, dd.numer)) "
# to wszystkie kolumny z klucza pozycji dd oraz ceny z rsf_a
kol_do_update = """ dd.firma_id,dd.oddzial_id, dd.trasa, dd.data, dd.tryb_dostawy, dd.numer, ceny.a[1] AS cena_netto1, 
                    ceny.a[2] AS cena_netto2, ceny.a[3] AS cena_brutto1, ceny.a[4] AS cena_brutto2, 
                    ceny.a[5] AS cena_upust1, ceny.a[6] AS cena_upust2, p.nr_poz """
zliczanie      = sql.format(kol_zliczanie)
# wszystko co korzysta z tego selecta potrzebuje te argumenty
sel_args       = [self.firma_id, data_od, data_do, self.firma_id, data_od, data_do]
zliczanie_args = sel_args  # brak dodatkowych argumentow na ten moment
update_args    = sel_args  # brak dodatkowych argumentow na ten moment
sel_update     = sql.format(kol_do_update)
# update wykorzystuje wczesniejszy select jako zrodlo nowych cen, zlaczony po pelnym kluczu pozycji dd
update = """UPDATE rs_dowody_dostaw_pozycje p
            SET cena_netto1  = tmp.cena_netto1::NUMERIC,   cena_netto2 = tmp.cena_netto2::NUMERIC, 
                cena_brutto1 = tmp.cena_brutto1::NUMERIC, cena_brutto2 = tmp.cena_brutto2::NUMERIC, 
                cena_upust1  = tmp.cena_upust1::NUMERIC,   cena_upust2 = tmp.cena_upust2::NUMERIC
            FROM
                ({}) AS tmp
            WHERE (p.firma_id, p.oddzial_id, p.trasa, p.data, p.tryb_dostawy, p.numer, p.nr_poz) = 
                (tmp.firma_id, tmp.oddzial_id, tmp.trasa, tmp.data, tmp.tryb_dostawy, tmp.numer, tmp.nr_poz)
            ;""".format(sel_update)

rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(zliczanie, zliczanie_args))
stat, do_poprawy, dump, dump = self.PolSQL.Execute(zliczanie, 3, zliczanie_args, CzyDodawacBlad=True)
if stat != 'OK':
    stat = u"Bd pobierania listy dowodw do aktualizacji: "+stat
elif do_poprawy[0][0] > 0:
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(update, update_args))
    stat, dump, dump, dump = self.PolSQL.Execute(update, 1, update_args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = u"Bd aktualizacji cen na dowodach dostaw: "+stat

wyn1 = [do_poprawy[0][0]]