# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe.py
# Purpose:     okno obsugi dokumentw ksigowych.
# Author:      Micha Raburski
# Created:     2007/03/24
# RCS-ID:      $Id: fs_dowody_ksiegowe.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-09-19 Mariusz Rajfura (4925) blokada SELECT FOR UPDATE 
# 2011-12-02 Mariusz Rajfura (5079) uszczelnienie, kontrola zamykania 
# 2011-12-09 Mariusz Rajfura (5278) pole 'tresc' do sekcji filtrow i grida 
# 2012-04-01 Micha Raburski (2070) przejcie na funkcje z W na G i z Z na G
# 2012-10-31 Mariusz Rajfura (6204) kontrola kwot walutowych, testy: waluta->kurs->kwota
# 2013-02-19 Micha Raburski (6544) przeniesienie funkcji pomocniczych do fs_dowody_ksiegowe_pom
# 2013-05-28 Mariusz Rajfura (6896) popr.kolejnosc usuwania dla dekretacji w srodkach trwalych
# 2016-04-26 Piotr Bender    (9772) refaktoryzacja
# 2020-07-08 Wojciech Skowron (12042) poprawka usuwania klucza do rs_rozrachunki przy usuwaniu dowodu
# 2022-01-26 Wojciech Skowron (12836) filtr na zagadnienie_id, odznaczenie 'zaksiegowane' w zagadnieniu przy usuwaniu
# 2022-02-21 Aleksander Bargie fs_dekretuj_i_zamknij_dowody :Bd wykonania funkcji wewntrznej fs_dowody_ksiegowe:name 'DataOdF' is not defined  (12894)
# 2022-05-10 Wojciech Skowron  (13004) Nowy stan 'M'
# 2022-05-20 Aleksander Bargie (13010) Przygotowanie dowodw ksigowych w okrelonym terminie nie dziaa
# 2023-06-29 Aleksander Bargie (13474) Filtr 'Nip' w d.k.
# 2023-07-07 Aleksander Bargie (13473) zmiany w sprawdzaniu pary kontrahent - dokument

# Funkcje
# 5 - pobranie danych
# 6 - usuwanie dowodw
# 11 - automatyczne zamykanie dokumentw (harmonogram)
# 12 - otwieranie dokumentw
# 13 - zamykanie dokumentw
# 15 - pobieranie stanu dokumentw o okrelonej porze
# 20 - zamykanie dokumentw
# 21 - automatyczne zamykanie dokumentw (harmonogram)
# 23 - pobranie stanu dokumentu do sprawdzenia na oknie
# 23 - sprawdzenie projektw

import rsglobal
from funkcje import fs_dowody_ksiegowe_pom
#AB 21.02.22r przeniesione na gr funkcji
stat = "OK"
dane = []
wyn1 = []
Stan = ''

Insert = []
Update = []
Delete = []
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    filtry = [5, 6, 11, 12, 13, 15, 20, 21, 23]
    SlPar = {'StanF': filtry, 'DowodF': filtry, 'NazwaF': filtry, 'DataOdF': filtry,
             'DataDoF': filtry, 'KontrF': filtry, 'NipF': filtry, 'SymbF': filtry, 'PlatnosciF': filtry,  #AB 2023-06-29
             'KontaVATF': filtry, 'TrescF': filtry, 'NumerF': filtry, 'KluczDokF': filtry,
             'NoweKlucze': filtry, 'ZagadnienieF': filtry,  #WS 2022-01-26 - ZagadnienieF
             'Numer': [6, 12, 13, 23, 33], 'Nazwa': [6, 12, 13, 23, 33], 'Data': [6, 12, 13, 23, 33], 'Dowod': [6, 12, 13, 23, 33],
             'Stan': [6, 12, 13, 23, 33], 'Czas': [15], 'DataW': [15]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_dowody_ksiegowe_pozycje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    if stat == 'OK':
        if Funkcja in [6, 12, 13, 23, 33]:
            Numer = str(klucze['Numer'])
            Nazwa = str(klucze['Nazwa'])
            Data = str(klucze['Data'])
            Dowod = str(klucze['Dowod'])
            Stan = str(klucze['Stan'])
        if Funkcja in filtry:
            StanF = str(klucze['StanF'])
            DowodF = str(klucze['DowodF'])
            NazwaF = str(klucze['NazwaF'])
            DataOdF = str(klucze['DataOdF'])
            DataDoF = str(klucze['DataDoF'])
            KontrF = str(klucze['KontrF'])
            NipF = str(klucze['NipF'])  #AB 2023-06-29
            SymbF = str(klucze['SymbF'])
            PlatnosciF = str(klucze['PlatnosciF'])
            KontaVATF = str(klucze['KontaVATF'])
            KluczDokF = klucze['KluczDokF']
            TrescF = str(klucze['TrescF'])
            NumerF = klucze['NumerF']
            NoweKlucze = klucze['NoweKlucze']
            ZagadnienieF = klucze['ZagadnienieF']  #WS 2022-01-26 - ZagadnienieF
        if Funkcja in [15]:
            DataW = str(klucze['DataW'])
            Czas = klucze['Czas']

OkresDow = self.okres_id

# obsluga zamykania dowodow wywolywana przez funkcje harmonogramu 'fs_dekretuj_i_zamknij_dowody'
# dlugosc kluczy sluzy do odroznienia wywolania dla funkcji zamykania
# bezposrednio z okna RSDowodyKsiegowe lub funkcji harmonogramu 'fs_zamknij' od wywolania z 'fs_dekretuj_i_zamknij_dowody'

if stat == 'OK' and 'OkresDow' in klucze and Funkcja in [11, 21]:  #AB 21.02.22r dodany test na stat
    OkresDow = klucze['OkresDow']
#AB 21.02.22r
# stat = "OK"
# dane = []
# wyn1 = []
# Stan = ''
#
# Insert = []
# Update = []
# Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#sprawdzenie dat

if stat == 'OK' and Funkcja in filtry:  #AB 21.02.22r dodany test na stat
    if DataOdF != '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataOdF):
            stat='BL DATAOD'

    if DataDoF != '    -  -  ' and stat == 'OK':
        if not rsglobal.SprawdzCzyToData(DataDoF):
            stat='BL DATADO'

    if DataOdF != '    -  -  ' and DataDoF != '    -  -  ' and stat == 'OK':
        if DataOdF>DataDoF:
            stat='BL ZAKR DAT'

if stat=='OK':
    UprTotal=True
    #Pobranie uprawnien do dokumentw ksigowych dla operatora
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprAutZWG=True
        UprAutZGZ=True
        UprUsuwanie=True
        UprOtwieranie= True
          
        LAutZWG=[]
        LPrzeg=[]
        LAutZGZ=[]
        LOtw=[]
        LUsuw=[]
        
    else:
        sql="SELECT dowod_id,nazwa_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie FROM rs_wzory_dekretacji_upr "
        sql+="WHERE firma_id='"+self.firma_id+"' AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+" AND okres_id='"+OkresDow+"'; "
        stat,daneupr,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(daneupr)>0:
                UprTotal=False
            else:
                UprTotal=True
            
            LAutZWG=[]
            LAutZGZ=[]
            LOtw=[]
            LUsuw=[]
            LPrzeg=[]

            UprAutZWG=(self.oddzial_id,'075012') in self.uprawnienia or (self.oddzial_id,'075013') in self.uprawnienia
            UprAutZGZ=(self.oddzial_id,'075016') in self.uprawnienia
            UprUsuwanie=(self.oddzial_id,'075014') in self.uprawnienia
            UprOtwieranie=(self.oddzial_id,'075017') in self.uprawnienia

            for d in daneupr:
                #LPrzeg.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if d[2] or d[3] or d[4] or d[5] or d[6] or d[7]:
                    LPrzeg.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if UprAutZWG:
                    if d[2] or d[3]:
                        LAutZWG.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if UprAutZGZ:
                    if d[6]:
                        LAutZGZ.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if UprUsuwanie:
                    if d[4]:
                        LUsuw.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if UprOtwieranie:
                    if d[7]:
                        LOtw.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))

#Pobranie filtra do pobierania/zamykania dowodow
if stat=='OK':
    Filtr="(dk.firma_id='"+self.firma_id+"' AND dk.okres_id='"+OkresDow+"'"
    CzyFiltr=False
    if Funkcja in filtry:
        if KluczDokF<>[]:
            if KluczDokF[0]=='rozrachunek':
                SQL="SELECT dowod_id,nazwa_id,data,numer FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND okres_id='"+OkresDow+"' AND seria="+str(KluczDokF[1])
                #print 2, SQL
                stat,DaneRoz,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat=='OK':
                    if len(DaneRoz)>0:
                        Filtr+=" AND dk.dowod_id='"+rsglobal.Dekoduj(DaneRoz[0][0])+"' AND dk.nazwa_id='"+rsglobal.Dekoduj(DaneRoz[0][1])+"'"
                        Filtr+=" AND dk.data='"+rsglobal.Dekoduj(DaneRoz[0][2])+"' AND dk.numer="+str(DaneRoz[0][3])
                        CzyFiltr=True

            elif KluczDokF[0]=='dowod':
                Filtr+=" AND dk.dowod_id='"+rsglobal.Dekoduj(KluczDokF[1])+"' AND dk.nazwa_id='"+rsglobal.Dekoduj(KluczDokF[2])+"'"
                Filtr+=" AND dk.data='"+rsglobal.Dekoduj(KluczDokF[3])+"' AND dk.numer="+str(KluczDokF[4])
                CzyFiltr=True

        if not CzyFiltr:
            if StanF<>'':
                Filtr+=" AND upper(dk.stan)=upper('"+StanF+"')"
            if DowodF != '':
                Filtr +=" AND dk.dowod_id LIKE '"+DowodF+"%' "
            if NazwaF != '':
                Filtr +=" AND dk.nazwa_id LIKE '"+NazwaF+"%' "
            if DataOdF != '    -  -  ':
                Filtr +=" AND dk.data>='"+DataOdF+"' "
            if DataDoF != '    -  -  ':
                Filtr += " AND dk.data<='"+DataDoF+"' "
            if KontrF <>'':
                Filtr += " AND dk.kontrahent_id='"+KontrF+"' "
            if NipF != '':  #AB 2023-06-29
                Filtr += "AND (regexp_replace(kon.nip, '[^0-9]', '', 'g') LIKE regexp_replace('"+NipF+"', '[^0-9]', '', 'g')||'%' OR" \
                         " regexp_replace(dkk.nip, '[^0-9]', '', 'g') LIKE regexp_replace('"+NipF+"', '[^0-9]', '', 'g')||'%')"
            if SymbF <>'':
                Filtr += " AND dk.symbol_dok LIKE '"+SymbF+"%' "
            #WS 2022-01-26
            if ZagadnienieF != 0:
                Filtr += " AND dk.zagadnienie_id="+str(ZagadnienieF)

        Filtr+=')'


#-------------------------------------------------------------------------------
#POBIERANIE STANU DOKUMENTU O OKRESLONEJ PORZE- 15
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 15:
    #WS 2022-05-10
    if StanF.upper() not in ('M','W','G'):
    # if StanF.upper() not in ('W','G'):
        stat='BL STAN'
        
    if stat=='OK':
        #WS 2022-05-10
        if not ((StanF.upper() in ('M','W') and UprAutZWG) or (StanF.upper() =='G' and UprAutZGZ)):
        # if not ((StanF.upper() =='W' and UprAutZWG) or (StanF.upper() =='G' and UprAutZGZ)):
            stat='BL UPRAUT'

    klucze["oddzial_id"] = self.oddzial_id
    klucze["okres_id"] = self.okres_id
    klucze["Funkcja"] = 21

    slownik=str(klucze)[1:-1]
    slownik=slownik.replace("'",'"')
    klucze['PlatnosciF'] = str(klucze['DataW']) + ' ' + str(klucze['Czas']) + ':00'
    
    query= "INSERT INTO rs_harmonogram_zadan (firma_id,nazwa,argumenty,czas,stop_po_ok,powiadom_gdy_blad, ile_odstepow, odstep, zalegle)"
    query+= " VALUES ('"+ self.firma_id +"','fs_wykonaj','" + slownik + "','" + str(klucze['DataW']+' '+str(klucze['Czas']))
    query+= "',True,True, 10, 'm', 'J')"  #AB 20.05.22r poprawa danych dodawanego zadania w harmonogramie

    stat,none,none,none=self.PolSQL.Execute(query,1)

#-------------------------------------------------------------------------------
#POBIERANIE STANU DOKUMENTU - 6,12,13,20,23
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6,12,13,20,23]:
    SQL=" SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
    if Funkcja in [6,12,13,20]:
        SQL+=" FOR UPDATE"
        if Funkcja in [6,13]:
            SQL+=" NOWAIT"
            
    SQL+=";"
    
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(Dane)==0:
            stat='BR DOK'
        else:
            Stan = Dane[0][0]
    elif Funkcja in (6,13):
        stat = 'Dowd ksigowy zablokowany przez innego operatora.'
        if Funkcja == 6:
            stat += ' Operacja usunicia niemoliwa.'
        elif Funkcja == 13:
            stat += ' Operacja zmiany stanu niemoliwa.'

#-------------------------------------------------------------------------------
# POBRANIE STANU DOKUMENTU DO SPRAWDZENIA NA OKNIE (23)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 23:
    dane = [[Stan]]

#-------------------------------------------------------------------------------
#POBIERANIE STANU DOKUMENTU - 11,21
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [11,21]:
    if StanF=='':
        stat='BR STAN'
    else:
        Stan = StanF

#-------------------------------------------------------------------------------
#USUWANIE DOWODOW - 6    
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:

    if not UprUsuwanie and self.operator_id != STANDARD_OPERATOR_ID:
        stat='UPR DEL'
       
    if stat == 'OK' and not UprTotal:
        if (not (str(Dowod),Nazwa) in LUsuw) and self.operator_id!=STANDARD_OPERATOR_ID:
            stat='UPR DEL'
    #SPRAWDZANE CZY MOZNA USUNAC DOWOD
    if stat == 'OK':
        #WS 2022-05-10
        if not Stan in ['M','W','G']:
        # if not Stan in ['W','G']:
            stat='BL STAN'
    if stat =='OK':
        Select = "SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\""+self.okres_id+"\",\""+Dowod+"\",\""+Nazwa+"\",\""+Data+"\","+str(Numer)+"]','D')"
        stat,dane,dump,dump = self.PolSQL.Execute(Select,3)
        if len(dane)>0 and dane[0][0]<>'OK':
            stat=str(dane[0][0])

    #USUWANIE DEKRETU Z rs_srodki_trwale_dekrety 
    if stat=='OK':
        SQL="DELETE FROM rs_srodki_trwale_dekrety WHERE firma_id= '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer ='"+str(Numer)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'BL USUW$'+stat

    # usunicie rozliczenia potencjalnej rnicy kursowej
    if stat=='OK':
        SQL="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
        stat,DTypWzoru,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'BL TYPWZ$'+stat
        
        if stat == 'OK':
            if DTypWzoru[0][0] == 'W':
                SQL="UPDATE rs_rozrachunki SET rk_dowod_id=NULL, rk_nazwa_id=NULL, rk_data=NULL,rk_numer=NULL "
                SQL+=" WHERE firma_id= '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
                #WS 2020-07-08
                # SQL += " AND rk_dowod_id='" + Dowod + "' AND rk_nazwa_id='" + Nazwa + "' AND rk_data='" + Data + "' AND rk_numer ='" + str(Numer) + "';"
                SQL+=" AND rk_dowod_id='"+Dowod+"' AND TRIM(rk_nazwa_id)='"+Nazwa.strip()+"' AND rk_data='"+Data+"' AND rk_numer ="+str(Numer)+";"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat<>'OK':
                    stat = 'BL RK$'+stat

    #WS 2022-01-26
    # odznaczenie 'zaksiegowane' w zagadnieniu
    if stat=='OK':
        SQL=" SELECT zagadnienie_id FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
        stat,DZagadnienie,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = 'Bd pobrania numeru zagadnienia z nagwka dowodu'
        elif DZagadnienie[0][0] != 0:
            zagadnienie_id = DZagadnienie[0][0]
            SQL = """UPDATE rs_wf_zagadnienia SET zaksiegowane=FALSE 
                     WHERE firma_id='{self.firma_id}' AND zagadnienie_id={zagadnienie_id};
                     INSERT INTO rs_wf_zagadnienia_historia 
                                 (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                     VALUES('{self.firma_id}', {zagadnienie_id}, NOW(), rsf_getuserid(), 'Usunito dowd ksigowy', 
                            TRIM('{Dowod}') ||'/'|| TRIM('{Nazwa}') ||'/'|| TRIM('{Data}') ||'/'|| '{Numer}'::NUMERIC::INTEGER);""".format(**locals())
            rsglobal.ZapiszDoLogow('Odznaczenie zaksiegowania zagadnienia i aktualizacja historii: '+SQL)
            stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                stat = 'Bd aktualizacji zagadnienia'
    
    # usunicie dowodu
    if stat=='OK':
        SQL="DELETE FROM rs_dowody_ksiegowe WHERE firma_id= '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer ='"+str(Numer)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'BL USUW$'+stat

#-------------------------------------------------------------------------------
#AUTOMATYCZNE ZAMYKANIE DOKUMENTW - 11,21(harmonogram)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [11,21]:
    #WS 2022-05-10
    if StanF.upper() not in ('M','W','G'):
    # if StanF.upper() not in ('W','G'):
        stat='BL STAN'

    if stat=='OK' and StanF.upper()=='G':
        if not (StanF.upper() =='G' and UprAutZGZ):
            stat='BL UPRAUT'

    if stat=='OK':
        SQL="SELECT dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.stan "
        SQL+=" FROM rs_dowody_ksiegowe dk WHERE "+Filtr
        SQL+=" ORDER BY dk.dowod_id,dk.nazwa_id,dk.data,dk.numer FOR UPDATE NOWAIT;"
        stat,Dane,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = 'Wsrd wybranych dowodw ksigowych istnieje dowd zablokowany przez innego operatora. Operacja zmiany stanu niemoliwa.'
        
        if stat=='OK':
            for dok in Dane:
                DowodDK=rsglobal.Dekoduj(dok[0])
                NazwaDK=rsglobal.Dekoduj(dok[1])
                DataDK=rsglobal.Dekoduj(dok[2])
                NumerDK=dok[3]
                StanF=dok[4]
                # W -> G
                dane=[]
                #WS 2022-05-10
                if StanF in ('M','W'):
                # if StanF=='W':
                    stat=fs_dowody_ksiegowe_pom.SprawdzProjektyNaDokumencie(self.firma_id,OkresDow,DowodDK,NazwaDK,DataDK,NumerDK,self.PolSQL)
                    if stat=='OK':
                        # reszta kontroli i zmiana stanu z W na G
                        LBledy=fs_dowody_ksiegowe_pom.SprawdzDowodKsiegowy(self,DowodDK,NazwaDK,DataDK,NumerDK,OkresDow)
                        stat=LBledy[0]
                    
                    if stat != 'OK':
                        self.PolSQL.Rollback() # cofamy JEDEN dokument
                        st="Dokument "+rsglobal.Dekoduj(dok[0]).strip()+"/"+rsglobal.Dekoduj(dok[1]).strip()+"/"+rsglobal.Dekoduj(dok[2])+"/"+rsglobal.Dekoduj(str(dok[3])[0:str(dok[3]).find('.')])+": "+stat
                        wyn2.append(st)
                        stat='OK'
                    else:
                        #w celu zamknicia dokumentu zamykamy transakcj
                        self.PolSQL.Commit()
                        
                        # dodatkowo sprawdzamy czy para kontrahent/faktura nie wystpuje wicej ni jeden raz
                        # wyn1=fs_dowody_ksiegowe_pom.SprawdzPareKontrahentFaktura(self,DowodDK,NazwaDK,DataDK,NumerDK,OkresDow,wyn1)
                        #AB 2023-07-07
                        stat, kom = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'DK', None, None, None, [OkresDow, DowodDK, NazwaDK, DataDK, NumerDK])
                        if stat != 'OK':
                            wyn1.append(stat)
                        elif kom:
                            wyn1.append(kom)

                # G -> Z
                elif StanF=='G':
                    stat=fs_dowody_ksiegowe_pom.ZamknijDowodKsiegowy(self,DowodDK,NazwaDK,DataDK,NumerDK,OkresDow)
                    
                    if stat != 'OK':
                        self.PolSQL.Rollback() # cofamy JEDEN dokument
                        st="Dokument "+rsglobal.Dekoduj(dok[0]).strip()+"/"+rsglobal.Dekoduj(dok[1]).strip()+"/"+rsglobal.Dekoduj(dok[2])+"/"+rsglobal.Dekoduj(str(dok[3])[0:str(dok[3]).find('.')])+": "+stat
                        wyn2.append(st)
                        stat='OK'
                    else:
                        #w celu zamknicia dokumentu zamykamy transakcj
                        self.PolSQL.Commit()

#-------------------------------------------------------------------------------
#--- OTWIERANIE DOKUMENTOW - 12
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [12,]:
    if not UprOtwieranie and self.operator_id != STANDARD_OPERATOR_ID:
        stat='UPR OTW'
       
    if stat == 'OK' and not UprTotal:
        if not ((Dowod,Nazwa) in LOtw ) and self.operator_id!=STANDARD_OPERATOR_ID:
            stat='UPR OTW'
            
    if stat=='OK':
        if not Stan in ['G','Z']:
            stat='BL STAN OTW'
            
    # prawdziwe otwieranie    
    if stat == 'OK' and Stan == 'G':
        SQL+=" UPDATE rs_dowody_ksiegowe SET stan = 'W' WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'Bd otwierania dowodu ksigowego'
    elif stat == 'OK' and Stan == 'Z':
        stat=fs_dowody_ksiegowe_pom.OtworzDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,self.okres_id)

#-------------------------------------------------------------------------------
#--- ZAMYKANIE DOKUMENTOW - 13, 20 (bez pobierania)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [13,20]:
    #WS 2022-05-10
    if Stan not in ('M','W','G'):
    # if Stan not in ('W','G'):
        stat = 'BL STAN'
    #WS 2022-05-10
    elif stat=='OK' and Stan in ('M','W'):
    # elif stat=='OK' and Stan=='W':
        stat=fs_dowody_ksiegowe_pom.SprawdzProjektyNaDokumencie(self.firma_id,self.okres_id,Dowod,Nazwa,Data,Numer,self.PolSQL)        
            
        if stat=='OK':
            LBledow=fs_dowody_ksiegowe_pom.SprawdzDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,self.okres_id)
            stat=LBledow[0]
            wyn2=LBledow
            if stat=='OK':
                # dodatkowo sprawdzamy czy para kontrahent/faktura nie wystpuje wicej ni jeden raz
                # wyn1 = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentFaktura(self,Dowod,Nazwa,Data,Numer,self.okres_id,wyn1)
                #AB 2023-07-07
                stat, kom = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'DK', None, None, None, [self.okres_id, Dowod, Nazwa, Data, Numer])
                if stat != 'OK':
                    wyn1.append(stat)
                elif kom:
                    wyn1.append(kom)
                
    elif stat=='OK' and Stan == 'G':
        if not UprAutZGZ and self.operator_id != STANDARD_OPERATOR_ID:
            stat='UPR ZAM'
        
        if stat == 'OK' and not UprTotal:
            if not ((str(Dowod),Nazwa) in LAutZGZ) and self.operator_id!=STANDARD_OPERATOR_ID:
                stat='UPR ZAM'
                
        if stat=='OK':
            if Funkcja==13:
                stat=fs_dowody_ksiegowe_pom.ZamknijDowodKsiegowy(self,Dowod,Nazwa,Data,Numer)
                        
#-------------------------------------------------------------------------------
#   POBRANIE DANYCH 5 
#-------------------------------------------------------------------------------

if stat == 'OK' and (Funkcja in [5, 6, 11, 12, 13, 15, 20, 21, 23]) and dane in ([], [['OK']]):
    if self.operator_id != STANDARD_OPERATOR_ID:
        if len(LPrzeg) == 0:# or KluczDokF == []:
            Filtr += ' '
        else:
            Filtr += ' AND ('
            Pierwszy = True
            for dok in LPrzeg:
                if Pierwszy:
                    Pierwszy = False
                else:
                    Filtr+=' OR '
                Filtr+="(dk.dowod_id='"+rsglobal.Dekoduj(dok[0])+"' AND dk.nazwa_id='"+rsglobal.Dekoduj(dok[1])+"')"
                
            Filtr += ')'
    
    #pobranie klucza wynikajcego z numerw nowych kluczy
    if NoweKlucze != []:# and KluczDokF == []:
        Filtr += " OR ((dk.firma_id='"+self.firma_id+"'AND dk.okres_id='"+self.okres_id+"') AND ("
        Pierwszy = True
        for kl in NoweKlucze:
            if not Pierwszy:
                Filtr+=" OR "
            else:
                Pierwszy = False
            Filtr+="(dk.dowod_id='"+rsglobal.Dekoduj(kl[0])+"' AND dk.nazwa_id='"+rsglobal.Dekoduj(kl[1])+"' AND dk.data='"+rsglobal.Dekoduj(kl[2])+"' AND dk.numer="+str(kl[3])+")"
        Filtr+='))'

    PolePlat='0'
    FromPlat=''
    FromKontr = ''  #AB 2023-06-29
    GroupPlat=''
    FromKontaVAT=''
    FiltrKontaVAT=''
    FiltrTresc=''
    FiltrNr=''
    
    if TrescF != '':
        FiltrTresc=" AND dk.tresc LIKE '"+TrescF+"%' "
    
    if NumerF <>'':
        try:
            FiltrNr=' AND dk.numer='+str(int(NumerF))
        except:
            stat='Bdny numer filtrowanego dokumentu'
    
    if stat=='OK':
        if KontaVATF<>'':
            PlatnosciF=False
            FromKontaVAT=" INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
            FiltrKontaVAT=" AND ((NOT konto_vat_wn IS NULL AND NOT konto_vat_wn IN ('',"+str(KontaVATF.split(','))[1:-1]+"))"
            FiltrKontaVAT+=" OR (NOT konto_vat_ma IS NULL AND NOT konto_vat_ma IN ('',"+str(KontaVATF.split(','))[1:-1]+"))"
            FiltrKontaVAT+=" OR (konto_vat_wn IN ("+str(KontaVATF.split(','))[1:-1]+") AND NOT pobierac_na_rejestr)"
            FiltrKontaVAT+=" OR (konto_vat_ma IN ("+str(KontaVATF.split(','))[1:-1]+") AND NOT pobierac_na_rejestr))"
            
        if PlatnosciF:
            PolePlat="SUM(CASE WHEN rsf_podaj_element_konta(dkp.firma_id,dkp.okres_id,dkp.konto_ma,8) IN ('True','TRUE','1') THEN dkp.kwota_ma ELSE 0 END)"
            FromPlat=" LEFT OUTER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
            GroupPlat=" GROUP BY dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.stan,dk.symbol_dok,dk.kwota_wn,dk.kwota_ma,"
            GroupPlat+="dk.data_wyst,dk.data_wplywu,dk.termin_plat,dk.kontrahent_id,dk.tresc,dk.rejestr, dk.data_rejestru "

        if NipF:  #AB 2023-06-29
            FromKontr = "LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk USING (firma_id, okres_id, dowod_id, nazwa_id, DATA, numer) "
            FromKontr += "LEFT OUTER JOIN rs_kontrahenci kon ON (dk.firma_id, dk.kontrahent_id) = (kon.firma_id, kon.kontrahent_id) "

        Select="SELECT DISTINCT dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.stan,dk.symbol_dok,dk.kwota_wn,dk.kwota_ma,"
        Select+=" dk.data_wyst,dk.data_wplywu,dk.termin_plat,dk.kontrahent_id,"+PolePlat+","
        Select+=" COALESCE(dk.tresc,''::TEXT), dk.rejestr, dk.data_rejestru"
        Select+=" FROM rs_dowody_ksiegowe dk "+FromPlat+FromKontaVAT + FromKontr  #AB 2023-06-29
        Select+=" WHERE "+Filtr+FiltrKontaVAT+FiltrTresc+FiltrNr
        Select+=" "+GroupPlat
        Select+=" ORDER BY dk.dowod_id,dk.nazwa_id,dk.data,dk.numer;"
        stat,dane,dump,dump = self.PolSQL.Execute(Select,3)
        rsglobal.ZapiszDoLogow(Select)  #AB 2023-06-29
        if stat<>'OK':
            stat = 'BL DANE$'+stat


#-------------------------------------------------------------------------------
#   POBRANIE DANYCH 5
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja ==33:
    nrDok=str(Dowod)+"/"+str(Nazwa)+"/"+str(Data)+"/"+str(Numer)
    WHERE ="WHERE firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "' AND dowod_id = '" + Dowod + "' "
    WHERE+="AND nazwa_id='" +Nazwa+ "' AND data='" +Data+ "' AND numer='" +Numer+ "' "
    #pobranie projektu
    sql= "SELECT projekt_id FROM rs_dowody_ksiegowe "+WHERE+";"
    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = u'Bdy przy pobraniu projektu z dokumentu ksigowego:' + stat

    elif stat=='OK' and len(d)>0:
        #sprawdzenie daty dla projektu nagwka
        sql= "SELECT data_do>='" + Data + "' FROM rs_projekty WHERE firma_id='" + self.firma_id + "' "
        sql+= "AND projekt_id='"+d[0][0]+"' and data_do is not null;"
        stat, dd, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = u'Bdy przy sprawdzaniu daty projektu :' + stat
        elif len(dd) == 1 and dd[0][0] == False:
            dane.append(u"Dowd ksigowy "+nrDok+u" ma dat pniejsz ni 'data do' projektu "+d[0][0])

    if stat=='OK':
        sql="SELECT DISTINCT projekt_wn as projekt FROM rs_dowody_ksiegowe_pozycje "+WHERE+" and (projekt_wn is not null);"   #and data < '"+Data+"'
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = u'Bdy przy pobraniu projektu wn z pozycji dokumentu ksigowego:' + stat

        if stat=='OK' and len(d)>0:
            for projekt in d:
                sql= "SELECT data_do>='" + Data + "' FROM rs_projekty WHERE firma_id='" + self.firma_id + "' "
                sql+= "AND projekt_id='"+projekt[0]+"' and data_do is not null; "
                stat, dd, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    stat = u'Bdy przy sprawdzaniu daty projektu wn :' + stat
                elif len(dd) == 1 and dd[0][0] == False:
                    dane.append(u"Pozycja dowodu ksigowego "+nrDok+u" ma dat pniejsz ni 'data do' projektu_wn "+projekt[0])

    if stat=='OK':
        sql="SELECT DISTINCT projekt_ma as projekt FROM rs_dowody_ksiegowe_pozycje "+WHERE+" and (projekt_ma is not null);"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = u'Bdy przy pobraniu projektu ma z pozycji dokumentu ksigowego:' + stat

        if stat=='OK' and len(d)>0:
            for projekt in d:
                sql= "SELECT data_do>='" + Data + "' FROM rs_projekty WHERE firma_id='" + self.firma_id + "' "
                sql+= "AND projekt_id='"+projekt[0]+"' and data_do is not null; "
                stat, dd, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    stat = u'Bdy przy sprawdzaniu daty projektu ma :' + stat
                elif len(dd) == 1 and dd[0][0] == False:
                    dane.append(u"Pozycja dowodu ksigowego "+nrDok+u" ma dat pniejsz ni 'data do' projektu_ma "+projekt[0])
