# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_dane.py
# Purpose:     okno obsugi dokumentw ksigowych.
# Author:      Dariusz Boduch
# Created:     2008/06/17
# RCS-ID:      $Id: fs_dowody_ksiegowe_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2010.11.19 MR - zmiana pobierania uprawnie do dowodw.
# 2010.12.09 Mariusz Rajfura    ( 4112) konto_id=None Fun==10 jesli we wzorze nie zaznaczono 'czy_konto_id'
# 2010.12.10 Mariusz Rajfura    ( 4099) sprawdzenie stawek z obowiazujacymi terminami przy zmianie 'data_wyst'
# 2010.12.10 Mariusz Rajfura    ( 4099) data_wyst moze byc pusta, wtedy nie przenosi sie na pozycje
# 2011.09.20 Mariusz Rajfura    ( 4925) pobranie stanu dowodu dla sprawdzenia
# 2012-09-20 Mariusz Rajfura    ( 6092) pobranie sposobu numeracji dowodow
# 2013-08-09 Mariusz Rajfura    ( 7070) symbol_dok: przy modyfikacji naglowka wpisanie na pozycjach
# 2018-11-27 Aleksander Bargie (10922) Sprawdzanie, czy kontrahent jest aktywnym patnikiem VAT
# 2019-08-05 Aleksander Bargie (11577) [KS] czy_mpp w dowodach ksigowych
# 2019-08-22 Wojciech Skowron   (11596) Brakujca definicja czy_mpp przy dodawaniu dowodu
# 2020-04-01 Wojciech Skowron   (11917) JPK - oznaczenia w nagwku dowodu ksigowego
# 2022-05-06 Wojciech Skowron   (13004) Zmiana ze stanu 'M' na 'W' przy edycji
# 2023-01-04 Aleksander Bargie (13293) Konto_id w dowodach ksigowych - zmiana
# 2023-06-30 Aleksander Bargie (13473) zmiany w sprawdzaniu pary kontrahent - dokument
# 2024-02-23 Wojciech Skowron   (13700) Sprzeda usug

from funkcje import fs_dowody_ksiegowe_pom

Dowod=rsglobal.Dekoduj(klucze[0]).strip()
Nazwa=rsglobal.Dekoduj(klucze[1]).strip()
Data=rsglobal.Dekoduj(klucze[2]).strip()
Nr=str(klucze[3])
Kontrahent=rsglobal.Dekoduj(klucze[4]).strip()
SymbolDok=rsglobal.Dekoduj(klucze[5]).strip()
Fun=klucze[-1]
#AB 27.11.18r
if Fun == 34:
    NIP = rsglobal.Dekoduj(klucze[6]).strip()

stat="OK"
dane=[]
wyn2=[]

puste = ('', None, 'None', 'NULL')

if stat=='OK':
    UprTotal=True
    #Pobranie uprawnien do dokumentw ksigowych dla operatora
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprTotal=True
        UprDodawanie=True       
        UprEdycja=True;
        LEdy=[]
        LPrzeg=[]
        LDod=[]
    else:
        Sel="SELECT TRIM(dowod_id),TRIM(nazwa_id),wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie "
        Sel+="FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id in "
        Sel+=""+str(self.operatorzy).replace("[","(").replace("]",")")+" AND okres_id='"+self.okres_id+"'; "
        
        stat,daneupr,dump,dump = self.PolSQL.Execute(Sel,3)
        
        if stat != 'OK':
            stat = "BR SPR1"
            dane.append(stat)                        
        if stat=='OK':
            if len(daneupr)>0:
                UprTotal=False
            else:
                UprTotal=True
            LEdy=[]
            LDod=[]
            LPrzeg=[]

            UprDodawanie=(self.oddzial_id,'075013') in self.uprawnienia
            UprEdycja=(self.oddzial_id,'075012') in self.uprawnienia 
            
            if UprDodawanie:
                UprEdycja = UprDodawanie  
            
            for d in daneupr:
                if d[2] or d[3] or d[4] or d[5] or d[6] or d[7]:
                    LPrzeg.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if UprDodawanie:
                    if d[2]:
                        LDod.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))
                if UprEdycja:
                    if d[3]:
                        LEdy.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))

      
#-------------------------------------------------------------------------------
#------ POBRANIE SPOSOBU NUMERACJI 
#-------------------------------------------------------------------------------
if Fun == 21 and stat == 'OK':
    #pobranie typu numeracji (D,M,R)
    sql = "SELECT spos_dowody FROM rs_firmy_numeracja"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND data_od <='"+Data+"' ORDER BY data_od DESC LIMIT 1;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania sposobu numeracji dowodw ksigowych: '+stat
    elif len(dane) == 0:
        dane = [["D"]]



#-------------------------------------------------------------------------------
#--------------------- SPRAWDZANIE KONTRAHENTA <przed updatem>------------------
#-------------------------------------------------------------------------------

if Fun == 8 and stat=="OK":
    #AB 2023-07-07
    stat, dane = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'DK', Kontrahent, None, SymbolDok,
                                                                     [self.okres_id, Dowod, Nazwa, Data, Nr])

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

StawkiVATPozaTerminem = False

if Fun in [4,3]:
    DataWyst = None
    ZmieniacKth = False
    #AB 05.08.19r
    NowyKth = False
    UPDKTH = ''
    UPDPOZ = ''
    PrzeliczycProjekty=False
    if not UprEdycja:
        stat="UPR UPD"
        dane.append(stat) 
        
    if stat=='OK' and not UprTotal:
        if (not (str(Dowod),Nazwa) in LEdy)  and self.operator_id!=STANDARD_OPERATOR_ID:
            stat="UPR UPD1"
            dane.append(stat)

    sql ="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr+" FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia stanu dowodu ksigowego: '+stat
    elif len(d) != 1:
        stat = 'BR DOWODU'
    elif str(d[0][0]) == 'Z':
        stat = 'BL DOWOD ZAMK'
            
    #sprawdzanie kontrahenta - czy wystepuje w bazie 
    if Kontrahent != '' and stat=="OK":
        #AB 05.08.19r
        SQL="SELECT czy_mpp FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"';"
        stat,dane1,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = "BR SPR3"
            dane.append(stat)                        
        elif len(dane1)==0:
            stat = "BL KONT"
            dane.append(stat)
        #AB 05.08.19r
        else:
            czy_mpp = dane1[0][0]
        
        #pobranie poprzedniej wartosci kontrahenta z dowodu
        KontrahentOld = None
        ga = []
        ko = []
        dp = []
        if stat == 'OK':
            sql ="SELECT kontrahent_id FROM rs_dowody_ksiegowe"
            sql+=" WHERE firma_id ='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"'"
            sql+="  AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania kontrahenta z nagwka dowodu: '+stat
                dane.append(stat)
            elif len(d) == 0:
                stat = 'Brak dowodu o podanym kluczu'
                dane.append(stat)
            else:
                KontrahentOld = str(d[0][0]).strip()
                if KontrahentOld != 'None':
                    if Kontrahent != KontrahentOld:
                        ZmieniacKth = True
                        #AB 05.08.19r
                        NowyKth = True
                else:
                    NowyKth = True
            if NowyKth:
                SQL = "SELECT czy_mpp FROM rs_kontrahenci WHERE firma_id = '" + self.firma_id + "' AND kontrahent_id = '" + Kontrahent + "';"
                stat, mpp_kontr, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = "BL SPR7"
                    dane.append(stat)
        
        #jesli zmienia sie kontrahent w naglowku, bedziemy zmieniac tego kontrahenta
        #w pozycjach dowodu: w polu kontrahent_id i w konto_wn, konto_ma,konto_vat_wn, konto_vat_ma
        #dla odpowiednich grup analitycznych
        
        if stat == 'OK' and ZmieniacKth:
            #najpierw przygotujemy zmiane kontrahenta w polu kontrahent_id
            sql ="SELECT kontrahent_id FROM rs_dowody_ksiegowe_pozycje"
            sql+=" WHERE firma_id ='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"'"
            sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr
            sql+=" AND kontrahent_id='"+KontrahentOld+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania pozycji dowodu ksigowego: '+stat
                dane.append(stat)
            elif len(d) > 0:
                UPDKTH+= "UPDATE rs_dowody_ksiegowe_pozycje SET kontrahent_id='"+Kontrahent+"'"
                UPDKTH+=" WHERE firma_id ='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"'"
                UPDKTH+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr
                UPDKTH+=" AND kontrahent_id='"+KontrahentOld+"'; "

        if stat == 'OK' and ZmieniacKth:
            #wybieramy grupy analityczne, zawierajace kontrahenta
            sql ="SELECT grupa_id FROM rs_grupy_analityczne"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kontrahenci;"
            stat,ga,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania grup analitycznych: '+stat
                dane.append(stat)
            
        #jesli zmieniamy kontrahenta i sa grupy analityczne z kontrahentami
        if stat == 'OK' and ZmieniacKth and len(ga) > 0:
            grupy = []
            for i in ga:
                grupy.append(str(i[0]))
                
            g = str(grupy).replace('[','(').replace(']',')')
            #pobieramy z planu kont konta dla ktrych kontrahent moze byc w grupie analitycznej
            #od razu robimy miejsce w tabeli na dodatkow dane, aby nie mnozyc danych
            sql ="SELECT kontos_id,konto_id,grupa1,grupa2,grupa3,grupa4,grupa5,'',0,'' FROM rs_plan_kont"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            sql+=" AND (grupa1 IN "+g+" OR grupa2 IN "+g+" OR grupa3 IN "+g+" OR grupa4 IN "+g+" OR grupa5 IN "+g+");"
            stat,ko,dump,dump = self.PolSQL.Execute(sql,3)
            
            if stat != 'OK':
                stat = 'Bd pobrania danych z planu kont: '+stat
                dane.append(stat)
             
        #jesli istnieja konta z grupa analityczna, zawierajaca kontrahenta pobieramy pozycje dowodu
        #ktore zawieraja szukane przez nas poczatki kont
        if stat == 'OK' and ZmieniacKth and len(ko) > 0:
            WHERE=''
            for i in xrange(len(ko)):
                konto = str(ko[i][0])
                if str(ko[i][1]) != '':
                    konto += '-'+str(ko[i][1])
                
                #zapiszemy numery GRUP(!) zawierajace kontrahenta
                #(!)GRUP, a nie grupy, bo konto moze zawierac wiecej niz jedna grupe analityczna,
                #ktora zawiera kontrahenta
                grupy = []
                for j in xrange(len(ga)):
                    grupa = str(ga[j][0])
                    if str(ko[i][2]) == grupa:
                        grupy.append(1)
                    if str(ko[i][3]) == grupa:
                        grupy.append(2)
                    if str(ko[i][4]) == grupa:
                        grupy.append(3)
                    if str(ko[i][5]) == grupa:
                        grupy.append(4)
                    if str(ko[i][6]) == grupa:
                        grupy.append(5)

                #zachowamy stworzone konto do porownan przy przegladaniu wylowionych pozycji dowodu
                ko[i][-1] = konto
                ko[i][-2] = len(konto)
                ko[i][-3] = grupy
                
                #tworzymy fragment sql-a wychwytujacego pozycje dowodu z interesujacymi nas poczatkami kont    
                if i > 0:
                    WHERE+=" OR "
                
                WHERE+=" konto_wn LIKE '"+str(konto)+"-%' OR"
                WHERE+=" konto_ma LIKE '"+str(konto)+"-%' OR"
                WHERE+=" konto_vat_wn LIKE '"+str(konto)+"-%' OR"
                WHERE+=" konto_vat_ma LIKE '"+str(konto)+"-%'"
                
            sql ="SELECT konto_wn,konto_ma,konto_vat_wn,konto_vat_ma,nr_poz,nr_ppoz"
            sql+=" FROM rs_dowody_ksiegowe_pozycje"
            sql+=" WHERE firma_id ='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"'"
            sql+="  AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr
            sql+=" AND ("+WHERE+");"
            
            stat,dp,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania pozycji dowodu ksigowego: '+stat
                dane.append(stat)
        
        #jesli dowod zawieral szukane konta,
        #przygotowujemy sql-a do zamiany kont, jesli trafi na kontrahenta w koncie
        if stat == 'OK' and ZmieniacKth and len(dp) > 0:
            for i in xrange(len(ko)):
                konto = ko[i][-1]
                dlg = ko[i][-2]
                grupy = ko[i][-3]
                
                for j in xrange(len(dp)):
                    KontoWn = None
                    KontoMa = None
                    KontoVatWn = None
                    KontoVatMa = None
                    
                    #konto_wn
                    k = str(dp[j][0]).strip()
                    if k[:dlg] == konto:
                        reszta = k[dlg+1:]
                        resztas = reszta.split('-')
                        Zmiana = False
                        for n in xrange(len(grupy)):
                            grupa = grupy[n]
                            if grupa <= len(resztas):
                                if str(resztas[grupa-1]) == KontrahentOld:
                                    resztas[grupa-1] = Kontrahent
                                    Zmiana = True
                        if Zmiana:
                            KontoWn = konto+'-'+ '-'.join(resztas)

                    #konto_ma
                    k = str(dp[j][1]).strip()
                    if k[:dlg] == konto:
                        reszta = k[dlg+1:]
                        resztas = reszta.split('-')
                        Zmiana = False
                        for n in xrange(len(grupy)):
                            grupa = grupy[n]
                            if grupa <= len(resztas):
                                if str(resztas[grupa-1]) == KontrahentOld:
                                    resztas[grupa-1] = Kontrahent
                                    Zmiana = True
                        if Zmiana:
                            KontoMa = konto+'-'+ '-'.join(resztas)

                    #konto_vat_wn
                    k = str(dp[j][2]).strip()
                    if k[:dlg] == konto:
                        reszta = k[dlg+1:]
                        resztas = reszta.split('-')
                        Zmiana = False
                        for n in xrange(len(grupy)):
                            grupa = grupy[n]
                            if grupa <= len(resztas):
                                if str(resztas[grupa-1]) == KontrahentOld:
                                    resztas[grupa-1] = Kontrahent
                                    Zmiana = True
                        if Zmiana:
                            KontoVatWn = konto+'-'+ '-'.join(resztas)

                    #konto_vat_ma
                    k = str(dp[j][3]).strip()
                    if k[:dlg] == konto:
                        reszta = k[dlg+1:]
                        resztas = reszta.split('-')
                        Zmiana = False
                        for n in xrange(len(grupy)):
                            grupa = grupy[n]
                            if grupa <= len(resztas):
                                if str(resztas[grupa-1]) == KontrahentOld:
                                    resztas[grupa-1] = Kontrahent
                                    Zmiana = True
                        if Zmiana:
                            KontoVatMa = konto+'-'+ '-'.join(resztas)
                
                    #jesli zmiana ktoregos konta powiekszamy sql-a do modyfikacji
                    if (KontoWn != None) or (KontoMa != None) or (KontoVatWn != None) or (KontoVatMa != None):
                        UPDKTH += " UPDATE rs_dowody_ksiegowe_pozycje SET "
                        dodano = False
                        if KontoWn != None:
                            UPDKTH += " konto_wn='"+KontoWn+"'"
                            dodano = True
                            
                        if KontoMa != None:
                            if dodano:
                                UPDKTH += ","
                                dodano = False
                            UPDKTH += " konto_ma='"+KontoMa+"'"
                            dodano = True
                            
                        if KontoVatWn != None:
                            if dodano:
                                UPDKTH += ","
                                dodano = False
                            UPDKTH += " konto_vat_wn='"+KontoVatWn+"'"
                            dodano = True
                            
                        if KontoVatMa != None:
                            if dodano:
                                UPDKTH += ","
                            UPDKTH += " konto_vat_ma='"+KontoVatMa+"'"
                        
                        UPDKTH+=" WHERE firma_id ='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"'"
                        UPDKTH+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"'"
                        UPDKTH+=" AND numer="+Nr+" AND nr_poz="+str(dp[j][-2])+" AND nr_ppoz="+str(dp[j][-1])+";"
                    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    #---   Sprawdzenie pozostaych danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    
        if stat=="OK":
            if (pole in ['data_wyst','data_wplywu','termin_plat','data_zapl','data_rejestru']):
                if stat=="OK" and wart!='    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat = "BL "+pole
                        dane.append(stat)

            if pole=='data_wyst':
                DataWyst = wart
                 
            elif pole=='konto_id':
                if wart != '':
                    SQL="SELECT konto_id FROM rs_konta_bankowe WHERE firma_id = '"+self.firma_id+"' AND konto_id = '"+wart+"';"
                    stat,dane2,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = "BR SPR4"
                        dane.append(stat)                        
                    if stat=='OK':
                        if len(dane2)==0:
                            stat = "BL KONTO"
                            dane.append(stat)   
                    
            elif pole=='rejestr':
                if wart!='':
                    SQL="SELECT kod FROM rs_rejestry_vat WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,dane3,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = "BR SPR5"
                        dane.append(stat)                        
                    if stat=='OK':
                        if len(dane3)==0:
                            stat = "BL RE"
                            dane.append(stat)                          

            elif pole=='projekt_id':
                if wart!='':
                    SQL="SELECT projekt_id FROM rs_projekty WHERE firma_id = '"+self.firma_id+"' AND TRIM(projekt_id) = '"+wart+"';"
                    stat,dproj,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = "Bd sprawdzenia projektu"
                        dane.append(stat)
                    elif len(dproj) == 0:
                        stat = "BL PROJEKT"
                        dane.append(stat)                          
            
            elif pole=='bez_projektow':
                if wart:
                    SQL="DELETE FROM rs_dowody_ksiegowe_projekty WHERE firma_id='"+self.firma_id+"' "
                    SQL+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"'"
                    SQL+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
                    wartosci[i]='TRUE'
                else:
                    PrzeliczycProjekty=True
                    wartosci[i]='FALSE'

            #WS 2020-04-01
            elif pole == 'ozn_trans':
                if wart.strip() != '':
                    SQL = "SELECT kod FROM rs_transakcje_oznaczenia WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(SQL,2,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd sprawdzenia oznaczenia transakcji: "+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = "BL OZN_TRANS"
                        dane.append(stat)

            #WS 2020-04-01
            elif pole == 'ozn_sprzedaz':
                if wart.strip() != '':
                    SQL = "SELECT kod FROM rs_oznaczenia_sprzedaz WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(SQL,2,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd sprawdzenia oznaczenia dowodu sprzeday: "+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = "BL OZN_SPRZEDAZ"
                        dane.append(stat)

            #WS 2020-04-01
            elif pole == 'ozn_nabycie':
                if wart.strip() != '':
                    SQL = "SELECT kod FROM rs_oznaczenia_nabycie WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(SQL,2,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd sprawdzenia oznaczenia dowodu nabycia: "+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = "BL OZN_NABYCIE"
                        dane.append(stat)


    #sprawdzenie stawek vat z terminami ich obowiazywania dla pozycji
    #dla 'data_wyst' z naglowka, poniewaz aktualizacja 'data_wyst' naglowka
    #powiela 'data_wyst' w pozycjach
    if stat == 'OK' and not DataWyst in (None,'    -  -  '):
        sql ="SELECT stawka_vat_wn,stawka_vat_ma FROM rs_dowody_ksiegowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
        sql+=" AND data='"+Data+"' AND numer="+Nr
        sql+=" AND NOT (stawka_vat_wn IS NULL AND stawka_vat_ma IS NULL);"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania pozycji ze stawkami VAT z dowodu: '+stat
            dane.append(stat)
        elif len(d) > 0:
            #jesli byly pozycje ze stawkami VAT
            Stawki = []
            for i in xrange(len(d)):
                St = rsglobal.Dekoduj(d[i][0])
                if St != 'None' and not St in Stawki:
                    Stawki.append(St)

                St = rsglobal.Dekoduj(d[i][1])
                if St != 'None' and not St in Stawki:
                    Stawki.append(St)
                    
            #czy liczba sprawdzanych stawek rozna od liczby stawek spelniajacych warunki
            sql ="SELECT COUNT(*) != "+str(len(Stawki))+" FROM rs_stawki_vat_okresy"
            sql+=" WHERE stawka_vat IN "+str(Stawki).replace('[','(').replace(']',')')
            sql+=" AND '"+DataWyst+"'>=od_dnia"
            sql+=" AND CASE WHEN do_dnia IS NULL"
            sql+=" THEN TRUE ELSE '"+DataWyst+"'<=do_dnia END;"

            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia stawek VAT z terminami ich obowizywania: '+stat
                dane.append(stat)
            else:
                StawkiVATPozaTerminem = d[0][0]

                
    #--- zapis
    if stat == 'OK':
        where =" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"'"
        where+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr+";"
        upd = "UPDATE rs_dowody_ksiegowe SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            #WS 2020-04-01 - import  #WS 2024-02-23 - sprzedaz_uslug
            if pole in ['nr_faktury','nr_dok_mag','kwota_ma','bez_projektow','import','sprzedaz_uslug']:
                upd=upd+pole+"="+str(wart)+","

            #AB 05.08.19r
            elif pole=='czy_mpp':
                CzyMPP = ' TRUE ' if wart or (NowyKth and mpp_kontr[0][0]) else ' FALSE '
                upd=upd+pole+"="+CzyMPP+","


            elif pole == 'symbol_dok':
                upd=upd+pole+"='"+wart+"',"
                
                UPDPOZ+="UPDATE rs_dowody_ksiegowe_pozycje SET symbol_dok='"+wart+"'"
                UPDPOZ+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"'"
                UPDPOZ+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Nr+";"
                
            elif pole in ['kontrahent_id','data_od','data_do','kwota_wn','tresc',
                          'rejestr','data_wyst','data_wplywu','termin_plat','data_zapl',
                          'data_rejestru','konto_id','symbol_dok','projekt_id',
                          'ozn_trans','ozn_sprzedaz','ozn_nabycie']:  #WS 2020-04-01
                if wart=='    -  -  ' or wart=='':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+wart+"',"
        #AB 05.08.19r
        if NowyKth and 'czy_mpp' not in pola:
            if mpp_kontr[0][0]:
                upd=upd+"czy_mpp=TRUE,"

        #WS 2022-05-06
        upd += "stan=CASE WHEN stan ='M' THEN 'W' ELSE stan END "+where
        # upd = upd[0:len(upd)-1]+where
        
        #jesli zmienila sie data wystawienia, to przenosimy ja na pozycje
        #bo data wystawienia nie moze byc pusta - wczesniejsze sprawdzenie)
        
        #zmiana: data_wyst moze byc pusta, wtedy nie przenosi sie na pozycje
        if not DataWyst in (None,'    -  -  '):
            upd += " UPDATE rs_dowody_ksiegowe_pozycje SET data_wyst = '"+DataWyst+"' "+where
        
        #jesli zmiana kontrahenta na pozycjach
        if len(UPDKTH) > 0:
            upd += UPDKTH

        #jesli zmiana dotyczy pozycji dowodu
        if len(UPDPOZ) > 0:
            upd += UPDPOZ
            
        stat,dump,dump,dump = self.PolSQL.Execute(upd, 1)
        if stat != 'OK':
            stat = 'BL DANE$'+stat
            dane.append(stat)
            
        if stat=='OK':
            if PrzeliczycProjekty:
                from funkcje import fs_dowody_ksiegowe_projekty_tworzenie
                stat=fs_dowody_ksiegowe_projekty_tworzenie.StworzPozycjeProjektoweWDowodzieKsiegowym(self.firma_id,self.okres_id,Dowod,Nazwa,Data,Nr,self.PolSQL)


#-------------------------------------------------------------------------------
#   DODAWANIE DANYCH 1, 2 
#-------------------------------------------------------------------------------

if (Fun in [1,2]) and (stat=='OK'):
    if not UprDodawanie:
        stat='UPR DOD'
        dane.append(stat)

    if stat=='OK' and not UprTotal:
        if ((not (str(Dowod),Nazwa) in LDod) ) and self.operator_id!=STANDARD_OPERATOR_ID:
            stat='UPR DOD'
            dane.append(stat)
    if stat=='OK':
        Select=" SELECT czy_symbol_dok,symbol_dok,czy_data_wyst,czy_data_wplywu,czy_kontrahent_id"  #0-4
        Select+=",kontrahent_id,czy_rejestr,rejestr,czy_data_rejestru,czy_konto_id,konto_id,projekty_podzial "  #5-11
        Select+=",czy_ozn_trans,ozn_trans,czy_ozn_sprzedaz,ozn_sprzedaz,czy_ozn_nabycie,ozn_nabycie,import "  #WS 2020-04-01 - 12-18
        Select+=",sprzedaz_uslug "  #WS 2024-02-23 - 19
        Select+=" FROM rs_wzory_dekretacji"
        Select+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' "
        Select+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
        stat,Dane,dump,dump=self.PolSQL.Execute(Select,3)
        if stat != 'OK':
            stat = 'BL DANE$'+stat
            dane.append(stat)
        if stat=='OK':
            if Dane==[]:
                stat= 'BL WZ DEKR'
                dane.append(stat)
        
    if not (str(Dowod) in ['BO','BK']) and stat=="OK":   
        if not rsglobal.SprawdzCzyToData(Data):
            stat = "BL DATA"
            dane.append(stat)
        if Data=='    -  -  ':
            stat = "PUS DATA"
            dane.append(stat)

    if str(Dowod) != 'BO' and stat=="OK":
        Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND okres_id=\\\'"+self.okres_id+"\\\' "
        Warunek += "AND dowod_id=\\\'"+Dowod+"\\\' AND nazwa_id=\\\'"+Nazwa+"\\\' AND data=\\\'"+str(Data)+"\\\'"
        Select = "SELECT rsf_klucz_where_new('rs_dowody_ksiegowe','"+Warunek+"','numer');"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat != 'OK':
            stat = 'BL SPR6'
            dane.append(stat)
        if stat=='OK':
            Nr=str(dane[0][0])

        if Dane[0][0]: #Symbol
            Symbol = Dane[0][1]
        else:
            Symbol = ''

        if Dane[0][2]: #Data wystawienia
            DataWyst = "'"+str(Data)+"'"
        else:
            DataWyst = "NULL"
                
        if Dane[0][3]:
            DataWplywu = "'"+str(Data)+"'"
        else:
            DataWplywu = "NULL"

        Kontrahent = 'NULL'
        if Dane[0][4]:
            if Dane[0][5] != 'None':
                Kontrahent = "'"+Dane[0][5]+"'"

        Rejestr = 'NULL'
        if Dane[0][6]:
            if Dane[0][7] != 'None':
                Rejestr = "'"+Dane[0][7]+"'"

        if Dane[0][8]:
            DataRej = "'"+str(Data)+"'"
        else:
            DataRej ='NULL'

        KontoId='NULL'
        if Dane[0][9]:
            if Dane[0][10] != 'None':
                KontoId = "'"+Dane[0][10]+"'"

        #WS 2020-04-01
        OznTransakcje = 'NULL'
        if Dane[0][12]:
            OznTransakcje = rsglobal.ZmienNaNULL(Dane[0][13].strip())

        #WS 2020-04-01
        OznSprzedaz = 'NULL'
        if Dane[0][14]:
            OznSprzedaz = rsglobal.ZmienNaNULL(Dane[0][15].strip())

        #WS 2020-04-01
        OznNabycie = 'NULL'
        if Dane[0][16]:
            OznNabycie = rsglobal.ZmienNaNULL(Dane[0][17].strip())

        #WS 2020-04-01
        Import = 'TRUE' if Dane[0][18] is True else 'FALSE'

        #WS 2024-02-23
        SprzedazUslug = 'TRUE' if Dane[0][19] is True else 'FALSE'

    czy_mpp = 'FALSE' #WS 2019-08-22

    if stat == "OK" and Kontrahent != 'NULL':
        SQL="SELECT czy_mpp FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = "+Kontrahent+";"
        stat,dane1,dump,dump = self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL, 5)
        if stat != 'OK':
            stat = "BR SPR8"
            dane.append(stat)
        elif len(dane1)==0:
            stat = "BL KONT"
            dane.append(stat)
        #AB 05.08.19r
        else:
            czy_mpp = 'TRUE' if dane1[0][0] else 'FALSE'



    if stat== "OK":
        query ="INSERT INTO rs_dowody_ksiegowe"
        query+=" (firma_id,okres_id,dowod_id,nazwa_id"
        query+=",data,numer,stan,kwota_wn,kwota_ma,symbol_dok,data_wyst,data_wplywu"
        query+=",kontrahent_id,rejestr,data_rejestru,konto_id, czy_mpp"
        query+=",ozn_trans,ozn_sprzedaz,ozn_nabycie,import,"  #WS 2020-04-01
        query+=",sprzedaz_uslug)"  #WS 2024-02-23
        query+=" VALUES ("
        query+="'"+self.firma_id+"','"+str(self.okres_id)+"','"+str(Dowod)+"','"+str(Nazwa)+"'"
        query+=",'"+str(Data)+"',"+str(Nr)+",'W',0,0,'"+str(Symbol)+"',"+DataWyst+","+DataWplywu
        query+=","+Kontrahent+","+Rejestr+","+DataRej+","+str(KontoId)+","+czy_mpp
        query+=","+OznTransakcje+","+OznSprzedaz+","+OznNabycie+","+Import  #WS 2020-04-01
        query+=","+SprzedazUslug+");"  #WS 2024-02-23
        
        stat,Nr,dump,dump = self.PolSQL.Execute(query ,1)
        if stat != "OK":    
            stat = "BL INS"
            dane.append(stat)


#-------------------------------------------------------------------------------
#   Pobieranie danych [7] 
#-------------------------------------------------------------------------------
       
if (Fun in [7]) and (stat=='OK'):
    if stat=="OK":
        SQL="SELECT rsf_utworz_pozycje_dowodu_ze_wzoru('"+self.firma_id+"','"+self.okres_id+"','"+str(Dowod)+"','"+str(Nazwa)+"','"+str(Data)+"',"+Nr+");"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != "OK":    
            stat = "BL INS"
            dane.append(stat)
                
#-------------------------------------------------------------------------------
#   POBRANIE DANYCH do sprawdzenia [9] 
#-------------------------------------------------------------------------------

if (Fun in [9]) and (stat=='OK'):
    Select ="SELECT czy_symbol_dok,mod_symbol_dok,czy_data_wyst,czy_data_wplywu,czy_termin_plat"  #0-4
    Select+=",czy_data_zapl,czy_kontrahent_id,mod_kontrahent_id,czy_rejestr,mod_rejestr,czy_data_rejestru"  #5-10
    Select+=",mod_konto_id, czy_konto_id,projekty_podzial"  #11-13
    Select+=",czy_ozn_trans,mod_ozn_trans,czy_ozn_sprzedaz,mod_ozn_sprzedaz,czy_ozn_nabycie,mod_ozn_nabycie"  #WS 2020-04-01 - 14-19
    Select+=",typ_wzoru in ('S', 'D') as czy_import"  #WS 2020-04-01 - 20
    Select+=",typ_wzoru in ('S', 'F') as czy_sprzedaz_uslug,mod_sprzedaz_uslug"  #WS 2024-02-23  - 21-22
    Select+=" FROM rs_wzory_dekretacji "
    Select+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Select+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat != 'OK':
        stat = 'BL DANE$'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#   POBRANIE DANYCH KONTRAHENTA KONTA TERMINU PLATNOSCI 
#-------------------------------------------------------------------------------
if Fun==10 and stat=='OK':
    Select=" SELECT nazwa,nip FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' ;"
    stat,danek,dump,dump = self.PolSQL.Execute(Select,3)
    if stat != 'OK':
        stat='BL KONTR$'+stat
        dane.append(stat)
    else:
        if len(danek)>0:    
            dane.append(danek[0])
        else:
            dane.append(['None'])
            
        #sprawdzenie, czy we wzorze dekretacji jest zaznaczone konto_id
        #jesli nie, nie zwracamy w miejsce konto_id wartosc 'None'
        sql ="SELECT czy_konto_id, konto_id FROM rs_wzory_dekretacji"  #AB 04.01.23r
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
        stat,dWzorD,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z wzoru dekretacji: '+stat
            dane.append(stat)
        elif len(dWzorD) != 1:
            stat = 'Brak wzoru dekretacji dla dowodu ksigowego.'
            dane.append(stat)
            
        if stat == 'OK':
            SELECT = "SELECT kf.konto_id,DATE '"+Data+"' + CAST(kf.dni AS INTEGER) , kf.dni "
            SELECT += "FROM rs_kontrahenci_fakturowanie kf "
            SELECT += " WHERE kf.firma_id='"+self.firma_id+"' AND kf.kontrahent_id='"+Kontrahent+"' AND kf.data_od<='"+Data+"'" 
            SELECT += " ORDER BY (kf.data_od) DESC limit 1 ;"
            stat,danekf,dump,dump = self.PolSQL.Execute(SELECT,3)
            if stat != 'OK':
                stat = 'BL KONTRF$'+stat
                dane.append(stat)
            else:
                if len(danekf)>0:
                    if not dWzorD[0][0]:
                        danekf[0][0] = 'None'
                    #AB 04.01.23r
                    elif danekf[0][0] in puste and dWzorD[0][1] not in puste:  #  jeli konto na dk, ale brak w danych
                        danekf[0][0] = dWzorD[0][1]                            # fakt, to mozna pobrac z wzoru dekretacji

                    dane.append(danekf[0])
                else:
                    if dWzorD[0][1] not in puste:  # jeli konto na dk, ale brak w danych
                        dane.append([dWzorD[0][1], 'None','None'])
                    else:
                        dane.append(['BRAK','None','None'])


#-------------------------------------------------------------------------------
# POBRANIE STANU DOWODU (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    sql= "SELECT stan FROM rs_dowody_ksiegowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' " 
    sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Nr)+";"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania stanu dokumentu: '+ stat
        dane.append(stat)
    elif len(dane) == 0:
        stat = 'Brak dowodu o podanym kluczu.'
        dane.append(stat)

                
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat=='OK':
    Select= "SELECT * FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' " 
    Select+= "AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Nr)+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat != 'OK':
        stat = 'BL POBIERANIA$'+stat
        dane.append(stat)

if Fun in (3,4) and stat == 'OK':
    wyn2.append(['STAWKI_VAT',StawkiVATPozaTerminem])


#AB 27.11.18r
# jesli STAT wroci 'OK', to bedzie RSMess z zawartoscia zmiennej dane, jesli inny, to RSBlad
if Fun == 34 and stat == 'OK':
    from funkcje import fs_sprawdz_czy_aktywny_vat_pom as vat
    platnik, dane = vat.SprAktywnychPlatnikowVAT(NIP)

    SQL = ''
    if platnik is None:
        stat = 'BLAD'
    elif platnik:
        SQL = """UPDATE rs_kontrahenci
    SET aktywny_vat=TRUE, aktywny_vat_data=NOW()::DATE
    WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, Kontrahent)
    elif not platnik:
        SQL = """UPDATE rs_kontrahenci
                SET aktywny_vat=FALSE, aktywny_vat_data=NOW()::DATE
                WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, Kontrahent)
    if SQL != '':
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            dane = stat
    else:
        stat = "BLAD SQL"
