# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_dane_kontrahenta.py
# Purpose:     okno obsugi danych kontrahenta w dowodach ksiegowych
# Author:      Pawe Wjcikowski
# Created:     2009/11/19 
# RCS-ID:      $Id: fs_dowody_ksiegowe_dane_kontrahenta.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2023-06-30 Aleksander Bargie (13473) zmiany w sprawdzaniu pary kontrahent - dokument
from funkcje import fs_dowody_ksiegowe_pom

Dowod=rsglobal.Dekoduj(klucze[0])
Nazwa=rsglobal.Dekoduj(klucze[1])
Data=rsglobal.Dekoduj(klucze[2])
Numer=str(klucze[3])
Kraj=str(klucze[4])
Nip=str(klucze[5])
Fun=klucze[-1] 

stat = "OK"
dane = []
wyn2 = []

UprDodawanie=(((self.oddzial_id,'075013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'075012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
UprUsuwanie=(((self.oddzial_id,'075014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   POBRANIE KONTRAHENTA (8)
#-------------------------------------------------------------------------------

if (Fun == 8):
    sql= "SELECT numer FROM rs_dowody_ksiegowe_kontrahent WHERE firma_id = '"+self.firma_id+"' "
    sql+="AND okres_id = '"+self.okres_id+"' AND dowod_id='"+str(Dowod)+"' AND nazwa_id='"+str(Nazwa)+"' "
    sql+="AND data='"+str(Data)+"' AND numer="+str(Numer)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bdy pobierania kontrahenta : '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT KONTRAHENTA (9)
#-------------------------------------------------------------------------------

if Fun == 9:
    if not UprDodawanie:
        stat = 'Brak uprawnie do dodawania kontrahenta'
        dane.append(stat)        
    if stat=='OK':
        SQL= "INSERT INTO rs_dowody_ksiegowe_kontrahent (firma_id,okres_id,dowod_id,nazwa_id,data,numer,kraj) VALUES "
        SQL+="('"+self.firma_id+"','"+self.okres_id+"','"+str(Dowod)+"','"+str(Nazwa)+"','"+str(Data)+"',"+str(Numer)+",'PL')"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat!="OK":
            stat = 'Bdy dodawania kontrahenta : '+stat
            dane.append(stat)  


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania kontrahenta'
        dane.append(stat)        
    if stat=='OK':          
        SQL= "DELETE FROM rs_dowody_ksiegowe_kontrahent WHERE firma_id= '"+self.firma_id+"' "
        SQL+=" AND okres_id='"+str(self.okres_id)+"' AND dowod_id='"+str(Dowod)+"' "
        SQL+=" AND nazwa_id='"+str(Nazwa)+"' AND data='"+str(Data)+"' AND numer ='"+str(Numer)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat!="OK":
            stat = 'Bdy usuwania kontrahenta : '+stat
            dane.append(stat)  
                

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [4,3]:       
    if not UprEdycja:
        stat = 'Brak uprawnie do modyfikowania danych'
        dane.append(stat)        
    if stat=='OK':     
        
        if Nip != '':
            stat = rsglobal.SprNip(Nip,Kraj)
            if stat<>'OK':
                dane.append(stat)
                
        #---   Sprawdzenie pozostaych danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]    
            if stat=="OK":                 
                if pole == 'kraj':
                    if wart == '':
                        stat = "BR KRAJ"
                        dane.append(stat)
                    else:
                        Select="SELECT kraj FROM rs_kraje WHERE kraj='"+wart+"';"
                        stat,Dane,wyn1,tr = self.PolSQL.Execute(Select,3)
                        if stat<>'OK':
                            stat = 'Bdy pobierania kraju : '+stat
                            dane.append(stat)
                        else:
                            if len(Dane)==0:
                                stat = "BL KRAJ"
                                dane.append(stat)
                if pole == 'nip':  #AB 2023-07-07
                    stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'DK', None, wart, None,
                                                                                     [self.okres_id, Dowod, Nazwa, Data,
                                                                                      Numer])
                    if komunikat:
                        wyn2.append(komunikat)
                    if stat:
                        dane.append(stat)
                    
            #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND dowod_id='"+Dowod+"' "
            where +=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            upd = "UPDATE rs_dowody_ksiegowe_kontrahent SET "
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
                
                if pole in ['nazwa','kraj','adr_kod','adr_miej','adr_ulica','adr_nry','adr_poczta','nip']:
                    if wart=='    -  -  ' or wart=='':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"='"+wart+"',"

            upd = upd[0:len(upd)-1]+where
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
            if stat<>'OK':
                stat = 'Bdy zapisu danych : '+stat
                dane.append(stat)

    if dane:
        stat = dane[0]
                                   
                                   
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (Fun in [5,3,1]) and (stat=='OK'):
    # pobranie danych kontrahenta
    Select= "SELECT * FROM rs_dowody_ksiegowe_kontrahent WHERE firma_id='"+self.firma_id+"' "
    Select+=" AND okres_id='"+str(self.okres_id)+"' AND dowod_id='"+str(Dowod)+"' AND nazwa_id='"+str(Nazwa)+"' "
    Select+=" AND data='"+str(Data)+"' AND numer="+str(Numer)+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych : '+stat
        dane.append(stat)