#
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_import_z_pliku.py
# Purpose:     Importuje dowody ksigowe z pliku.
# Author:      Micha Raburski    
# Created:     2009/02/07
# RCS-ID:      $Id: fs_dowody_ksiegowe_import_z_pliku.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2017-10-11 Rafa Woniak sprawdzanie czy nie ma znakw specjalnych i zmian poziomu zapisu logw
#2020-09-08 Aleksander Bargie (12100) Zmiany w imporcie dowodw ksigowych z pliku ze wzgldu na nowy JPK_V7M/K

#przychodza parametry: kucze,NIC,NIC 
#gdzie klucze jest ca zawartoci wybranego pliku

#F= eval(str(klucze))
Plik= klucze
   
#Status i bledy
stat = "OK"
dane = []
wyn1 = []

#debug level - zmienna pomocnicza. 1 zapisuje do logw, 10 nie zapisuje
dl=5

if not (((self.oddzial_id,'075013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
    stat='UPR IMP'
    dane.append(stat)

if stat=='OK':
    NrDok=0
    IlDok=0
    IlPoz=0
    PozAkt=0
    Stan=0 #0 czekam na nowy dokument, 1 czekam na nagowek, 2 czekam na pozycje, 3 czekam na nowy dokument lub koniec
    LDok=[] #lista zapyta dodajcych dokumenty
    LDokBuf=[] #dane ostatniego dokumentu
    Koniec=False
        
    for wiersz in Plik:
        # RW zadeklarowanie zmiennej wyej by bya dostpna przy sprawdzaniu
        w = ''
        if stat=='OK' and not Koniec:
            try:
                w=wiersz.decode('cp1250').encode('iso-8859-2')
                w=w.split(';')
                w[-1]=w[-1].strip('\n\r')
            except:
                stat = "Bdna struktura importowanego pliku."
                dane.append(stat)
            for i in range(len(w)):
                if type(w[i])==type('str'):
                    w[i]=w[i].strip("\\'")
                
            rsglobal.ZapiszDoLogow('---------WIERSZ '+str(w),dl)
            Uzyty=False    
            Poprawny=True
            #------------------------------------
            #DKELARACJA KONCA
            #------------------------------------
            rsglobal.ZapiszDoLogow('w[0] '+w[0],dl)
            rsglobal.ZapiszDoLogow('Stan '+str(Stan),dl)
            rsglobal.ZapiszDoLogow('len(w) '+str(len(w)),dl)
            if w[0]=='KONIEC' and Stan==3:
                rsglobal.ZapiszDoLogow('KONIEC',1)
                Uzyty=True
                if IlPoz <> PozAkt:
                    stat='Bdna liczba pozycji dokumentu nr '+str(NrDok)
                    dane.append(stat)
                elif len(w)<2:
                    stat='Nie podano liczby dokumentw za znacznikiem KONIEC'
                    dane.append(stat)
                elif w[1] <> str(IlDok):
                    stat='Bdna liczba dokumentw w pliku'
                    dane.append(stat)
                elif LDokBuf <> []:
                    LDok.append(rsglobal.rseval(str(LDokBuf)))                    
                Koniec=True
                
            #------------------------------------
            # DEKLARACJA NOWEGO DOKUMENTU
            #------------------------------------
            elif w[0]=='N' and len(w)==3 and Stan in (0,3):
                rsglobal.ZapiszDoLogow('NOWY',dl)
                Uzyty=True
                #nieprawidowa liczba pozycji dokumentu
                if IlPoz <> PozAkt:
                    stat='Bdna liczba pozycji dokumentu nr '+str(NrDok)
                    dane.append(stat)
                #nieprawidowy numer dokumentu
                elif w[1] <> str(IlDok+1):
                    stat='Bdny numer dokumentu : '+str(w[1])
                    dane.append(stat)
                #jest ok i zaczynamy nowy dokument
                else:
                    if LDokBuf <> []:
                        LDok.append(rsglobal.rseval(str(LDokBuf)))
                    NrDok=w[1]
                    IlPoz=int(w[2])
                    PozAkt=0
                    IlDok=IlDok+1
                    Stan=1
                    LDokBuf=[]
        
            #------------------------------------
            # POBRANIE NAGWKA
            #------------------------------------
            #AB 08.09.20r Dodanie opcji dla kolejnych 5 pol w naglowku
            elif len(w) in [13, 14, 18, 19] and Stan==1:
                rsglobal.ZapiszDoLogow('NAGLOWEK',dl)
                Uzyty=True
                Stan=2
                #AB 08.09.20r
                CzyMPP     = None
                OznTrans   = None
                OznSprz    = None
                OznNabycie = None
                Import     = None
                
                DowodId=w[0]
                NazwaId=w[1]
                Data=w[2].strip()
                SymbDok=w[3]
                DataWyst=w[4].strip()
                DataWplywu=w[5].strip()
                TerminPlat=w[6].strip()
                DataZapl=w[7].strip()
                KontrId=w[8]
                Rejestr=w[9]
                DataRej=w[10].strip()
                ProjektId=w[11]
                KontoId=w[12]
                #AB 09.09.20r
                if len(w) in(14, 19):
                    Tresc = w[13]
                else:
                    Tresc='.'
                #AB 09.09.20r
                if len(w) == 18:
                    CzyMPP     = w[13]
                    OznTrans   = w[14]
                    OznSprz    = w[15]
                    OznNabycie = w[16]
                    Import     = w[17]
                elif len(w) == 19:
                    CzyMPP     = w[14]
                    OznTrans   = w[15]
                    OznSprz    = w[16]
                    OznNabycie = w[17]
                    Import     = w[18]

                #sprawdzenie czy kluczowe pola s podane
                if DowodId=='' or NazwaId=='':
                    dane.append('Brak parametrw wzoru dekretacji dla dokumentu '+NrDok)
                    Poprawny=False
                if Data in ('','None', '    -  -  '):
                    dane.append('Bdna data dekretacji dla dokumentu '+NrDok)
                    Poprawny=False
                
                if stat=='OK' and Poprawny:
                    #sprawdzenie poprawnosci dowodu,nazwy,daty i mozliwosci wstawienia dokumentu o podanych parametrach
                    SQL="SELECT wd.dowod_id,wd.nazwa_id,COUNT(wdp.nr_poz) FROM rs_wzory_dekretacji wd "
                    SQL+=" LEFT OUTER JOIN rs_wzory_dekretacji_pozycje wdp USING (firma_id,okres_id,dowod_id,nazwa_id) "
                    SQL+=" WHERE wd.firma_id='"+self.firma_id+"' AND wd.okres_id='"+self.okres_id+"'"
                    SQL+=" AND wd.dowod_id='"+DowodId+"' AND wd.nazwa_id='"+NazwaId+"' GROUP BY wd.dowod_id,wd.nazwa_id;"
                    
                    stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                
                if stat=='OK' and Poprawny:
                    if len(Test)==0:
                        dane.append('Bdne parametry wzoru dekretacji dla dokumentu '+NrDok)
                        Poprawny=False
                    elif Test[0][2]==0:
                        dane.append('Brak pozycji wzoru dekretacji dla dokumentu '+NrDok)
                        Poprawny=False
                        
                #sprawdzenie czy Data jest poprawna i czy mona dla niej dodawa dokumenty
                if stat=='OK' and Poprawny:
                    if not rsglobal.SprawdzCzyToData(Data):
                        dane.append('Bdna data dokumentu '+NrDok+' : '+Data)
                        Poprawny=False
                        
                if stat=='OK' and Poprawny:
                    #sprawdzenie czy dodawanie dokumentu z podan dat jest ok
                    stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+self.okres_id+"\\\',\\\'"+DowodId+"\\\',\\\'"+NazwaId+"\\\',\\\'"+Data+"\\\']','D');",3)            
                    if stat=='OK':
                        if test[0][0]<>'OK':    
                            dane.append('Nie mona doda dokumentu '+NrDok+' z dat '+Data+' : '+test[0][0])
                            Poprawny=False

                if stat=='OK' and Poprawny:    
                    if DataWyst in ('    -  -  ','',None,'None',"NULL"):
                        DataWyst="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataWyst):
                        dane.append('Bdna data wystawienia dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataWyst="'"+DataWyst+"'"

                    if DataWplywu in ('    -  -  ','',None,'None',"NULL"):
                        DataWplywu="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataWplywu):
                        dane.append('Bdna data wpywu dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataWplywu="'"+DataWplywu+"'"
                    rsglobal.ZapiszDoLogow('!'+str(TerminPlat)+'! '+str(TerminPlat=="NULL")+" "+str(str(TerminPlat)=="NULL"),dl)    
                    
                    if TerminPlat in ('    -  -  ','',None,'None',"NULL"):
                        rsglobal.ZapiszDoLogow("WCHODZE",dl)    
                        TerminPlat="NULL"
                    elif not rsglobal.SprawdzCzyToData(TerminPlat):
                        rsglobal.ZapiszDoLogow("WCHODZE2",1)
                        dane.append('Bdny termin patnoci dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        TerminPlat="'"+TerminPlat+"'"

                    if DataZapl in ('    -  -  ','',None,'None',"NULL"):
                        DataZapl="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataZapl):
                        dane.append('Bdna data zapaty dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataZapl="'"+DataZapl+"'"

                    if DataRej in ('    -  -  ','',None,'None',"NULL"):
                        DataRej="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataRej):
                        dane.append('Bdna data rejestru dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataRej="'"+DataRej+"'"
                        
                    if KontrId in ('',None,'None'):
                        KontrId="NULL"
                    else:
                        SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrId+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny symbol kontrahenta na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                KontrId="'"+KontrId+"'"

                    if Rejestr in ('',None,'None'):
                        Rejestr="NULL"
                    else:
                        SQL="SELECT kod FROM rs_rejestry_vat WHERE firma_id='"+self.firma_id+"' AND kod='"+Rejestr+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny symbol rejestru vat na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                Rejestr="'"+Rejestr+"'"

                    if ProjektId in ('',None,'None'):
                        ProjektId="NULL"
                    else:
                        SQL="SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+ProjektId+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny projekt na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                ProjektId="'"+ProjektId+"'"
                    #AB 08.09.20r
                    CzyMPP = rsglobal.ZmienNaNULL(CzyMPP)

                    OznTrans=rsglobal.ZmienNaNULL(OznTrans)

                    OznSprz=rsglobal.ZmienNaNULL(OznSprz)

                    OznNabycie=rsglobal.ZmienNaNULL(OznNabycie)

                    Import=rsglobal.ZmienNaNULL(Import)

                    if KontoId in ('',None,'None'):
                        KontoId="NULL"
                    else:
                        SQL="SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+KontoId+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdne konto bankowe na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                KontoId="'"+KontoId+"'"
                
                if stat=='OK' and Poprawny:    
                    LDokBuf=[[DowodId,NazwaId,Data,SymbDok,DataWyst,DataWplywu,TerminPlat,DataZapl,KontrId,Rejestr,
                                                                #AB 08.09.20r
                              DataRej,ProjektId,KontoId,Tresc, CzyMPP, OznTrans, OznSprz, OznNabycie, Import],[]]
                else:
                    LDokBuf=[[],[]]
                    
            #------------------------------------
            # POBRANIE POZYCJI
            #------------------------------------
            elif len(w) in(29, 30) and Stan==2:
                rsglobal.ZapiszDoLogow('POZYCJA',dl)
                Uzyty=True
                PozAkt=PozAkt+1
                
                if PozAkt==IlPoz:
                    Stan=3
                #AB 08.09.20r
                KodGtu = None

                SymbDok=w[0]
                DataWyst=w[1].strip()
                DataWplywu=w[2].strip()
                TerminPlat=w[3].strip()
                DataZapl=w[4].strip()
                KontrId=w[5]
                KontoWn=w[6]
                KwotaWn=w[7]
                KontoVATWn=w[8]
                KwotaVATWn=w[9]
                StawkaVATWn=w[10]
                TrescWn=w[11]
                ProjektWn=w[12]
                SposRozl=w[13]
                WalutaWn=w[14]
                KursWn=w[15]
                KwotaWalWn=w[16]
                NKup= (w[17].strip()=='T')
                KontoMa=w[18]
                KwotaMa=w[19]
                KontoVATMa=w[20]
                KwotaVATMa=w[21]
                StawkaVATMa=w[22]
                TrescMa=w[23]
                ProjektMa=w[24]
                WalutaMa=w[25]
                KursMa=w[26]
                KwotaWalMa=w[27]
                Pnop=(w[28].strip()=='T')
                #AB 08.09.20r
                if len(w) == 30:
                    KodGtu=w[29]

                if stat=='OK' and Poprawny:    
                    if DataWyst in ('    -  -  ','',None,'None',"NULL"):
                        DataWyst="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataWyst):
                        dane.append('Bdna data wystawienia dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataWyst="'"+DataWyst+"'"

                    if DataWplywu in ('    -  -  ','',None,'None',"NULL"):
                        DataWplywu="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataWplywu):
                        dane.append('Bdna data wpywu dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataWplywu="'"+DataWplywu+"'"
                        
                    if TerminPlat in ('    -  -  ','',None,'None',"NULL"):
                        TerminPlat="NULL"
                    elif not rsglobal.SprawdzCzyToData(TerminPlat):
                        dane.append('Bdny termin patnoci dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        TerminPlat="'"+TerminPlat+"'"

                    if DataZapl in ('    -  -  ','',None,'None',"NULL"):
                        DataZapl="NULL"
                    elif not rsglobal.SprawdzCzyToData(DataZapl):
                        dane.append('Bdna data zapaty dokumentu '+NrDok)
                        Poprawny=False
                    else:
                        DataZapl="'"+DataZapl+"'"
                    #RW Sprawdzanie czy w danych nie ma znakw specjalnych , w razie wystpenia takowych zapisa gdzie
                    if '\\'  in KontrId:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in KontrId:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if KontrId in ('',None,'None'):
                        KontrId="NULL"
                    else:
                        SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrId+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny symbol kontrahenta na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                KontrId="'"+KontrId+"'"

                    if '\\'  in KontoWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in KontoWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if KontoWn in ('',None,'None'):
                        KontoWn="NULL"
                    else:
                        sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoWn+"');"
                        stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat=='OK':
                            if (DaneTmp <> []) and (DaneTmp <> None):
                                Dane = rsglobal.rseval(DaneTmp[0][0])
                                if Dane[0] == '':
                                    dane.append("Brak podanego konta wn "+KontoWn+" w dokumencie "+NrDok)  
                                    Poprawny=False
                                else:
                                    KontoWn="'"+KontoWn+"'"

                    if '\\' in KontoVATWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in KontoVATWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if KontoVATWn in ('',None,'None'):
                        KontoVATWn="NULL"
                    else:
                        sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoVATWn+"');"
                        stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat=='OK':
                            if (DaneTmp <> []) and (DaneTmp <> None):
                                Dane = rsglobal.rseval(DaneTmp[0][0])
                                if Dane[0] == '':
                                    dane.append("Brak podanego konta vat wn "+KontoVATWn+" w dokumencie "+NrDok)  
                                    Poprawny=False
                                else:
                                    KontoVATWn="'"+KontoVATWn+"'"

                    if '\\' in StawkaVATWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in StawkaVATWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if StawkaVATWn in ('',None,'None'):
                        StawkaVATWn="NULL"
                    else:
                        SQL="SELECT kod FROM rs_stawki_vat WHERE kod='"+StawkaVATWn+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdna stawka VAT wn na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                StawkaVATWn="'"+StawkaVATWn+"'"

                    if '\\' in ProjektWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in ProjektWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if ProjektWn in ('',None,'None'):
                        ProjektWn="NULL"
                    else:
                        SQL="SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+ProjektWn+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny projekt wn na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                ProjektWn="'"+ProjektWn+"'"

                    if '\\' in SposRozl:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in SposRozl:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if SposRozl in ('',None,'None'):
                        SposRozl="''"
                    else:
                        SQL="SELECT kod FROM rs_sposob_rozl_vat WHERE kod='"+SposRozl+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny sposb rozliczenia VAT na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                SposRozl="'"+SposRozl+"'"

                    if '\\' in WalutaWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in WalutaWn:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if WalutaWn in ('',None,'None'):
                        WalutaWn="NULL"
                    else:
                        SQL="SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+WalutaWn+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdna waluta wn na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                WalutaWn="'"+WalutaWn+"'"

                    if '\\' in KontoMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in KontoMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if KontoMa in ('',None,'None'):
                        KontoMa="NULL"
                    else:
                        sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoMa+"');"
                        stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat=='OK':
                            if (DaneTmp <> []) and (DaneTmp <> None):
                                Dane = rsglobal.rseval(DaneTmp[0][0])
                                if Dane[0] == '':
                                    dane.append("Brak podanego konta ma "+KontoMa+" w dokumencie "+NrDok)  
                                    Poprawny=False
                                else:
                                    KontoMa="'"+KontoMa+"'"

                    if '\\' in KontoVATMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in KontoVATMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if KontoVATMa in ('',None,'None'):
                        KontoVATMa="NULL"
                    else:
                        sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoVATMa+"');"
                        stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat=='OK':
                            if (DaneTmp <> []) and (DaneTmp <> None):
                                Dane = rsglobal.rseval(DaneTmp[0][0])
                                if Dane[0] == '':
                                    dane.append("Brak podanego konta vat ma "+KontoVATMa+" w dokumencie "+NrDok)  
                                    Poprawny=False
                                else:
                                    KontoVATMa="'"+KontoVATMa+"'"

                    if '\\' in StawkaVATMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in StawkaVATMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if StawkaVATMa in ('',None,'None'):
                        StawkaVATMa="NULL"
                    else:
                        SQL="SELECT kod FROM rs_stawki_vat WHERE kod='"+StawkaVATMa+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdna stawka VAT ma na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                StawkaVATMa="'"+StawkaVATMa+"'"

                    if '\\' in ProjektMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in ProjektMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if ProjektMa in ('',None,'None'):
                        ProjektMa="NULL"
                    else:
                        SQL="SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+ProjektMa+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdny projekt ma na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                ProjektMa="'"+ProjektMa+"'"

                    if '\\' in WalutaMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in WalutaMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if WalutaMa in ('',None,'None'):
                        WalutaMa="NULL"
                    else:
                        SQL="SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+WalutaMa+"';"
                        stat,Test,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            if len(Test)==0:
                                dane.append('Bdna waluta ma na dokumencie '+NrDok)
                                Poprawny=False
                            else:
                                WalutaMa="'"+WalutaMa+"'"
                    if '\\' in SymbDok:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in SymbDok:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\\' in TrescMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    if '\'' in TrescMa:
                        dane.append('Plik zawiera niedozwolone znaki w dokumencie ' + NrDok)
                        Poprawny = False
                    #AB 08.09.20r
                    KodGtu=rsglobal.ZmienNaNULL(KodGtu)
                
                if stat=='OK' and Poprawny:
                    LDokBuf[1].append([SymbDok,DataWyst,DataWplywu,TerminPlat,DataZapl,KontrId,KontoWn,KwotaWn,
                                       KontoVATWn,KwotaVATWn, StawkaVATWn,TrescWn,ProjektWn,SposRozl,WalutaWn,KursWn,
                                       KwotaWalWn,NKup,KontoMa,KwotaMa, KontoVATMa,KwotaVATMa,StawkaVATMa,TrescMa,
                                                                                #AB 08.09.20r
                                       ProjektMa,WalutaMa,KursMa,KwotaWalMa,Pnop, KodGtu])

           
            if not Uzyty:
                if len(w) not in [3,13,14,29]:
                    rsglobal.ZapiszDoLogow('BLAD STRUKTURY!!!!!!!!!!',1)
                    rsglobal.ZapiszDoLogow('Bdna liczba kolumn w wierszu. Wiersz : '+str(wiersz),1)
                    stat='Bd struktury importowanego pliku. Bdna liczba kolumn w wierszu. Wiersz : '+str(wiersz)
                    dane.append(stat)
                elif Stan==3:
                    rsglobal.ZapiszDoLogow('BLAD STRUKTURY!!!!!!!!!!',1)
                    rsglobal.ZapiszDoLogow('Liczba deklarowanych pozycji jest mniejsza mni ilo pozycji w dokumencie.',1)
                    rsglobal.ZapiszDoLogow('Wiersz : '+str(wiersz),1)
                    stat='Liczba deklarowanych pozycji jest mniejsza mni ilo pozycji w dokumencie. Wiersz : '+str(wiersz)
                    dane.append(stat)
                elif Stan==2:
                    rsglobal.ZapiszDoLogow('BLAD STRUKTURY!!!!!!!!!!',1)
                    rsglobal.ZapiszDoLogow('Liczba deklarowanych pozycji jest wiksza mni ilo pozycji w dokumencie.',1)
                    rsglobal.ZapiszDoLogow('Wiersz : '+str(wiersz),1)
                    stat='Liczba deklarowanych pozycji jest mniejsza mni ilo pozycji w dokumencie. Wiersz : '+str(wiersz)
                    dane.append(stat)
                else:
                    rsglobal.ZapiszDoLogow('BLAD STRUKTURY!!!!!!!!!!',1)
                    rsglobal.ZapiszDoLogow('Wiersz : '+str(wiersz),1)
                    stat='Bd struktury importowanego pliku. Wiersz : '+str(wiersz)
                    dane.append(stat)
                
                
    #Wszystko wyglda ok wic tworzymy po kolei dokumenty                    
    if stat=='OK' and len(dane)==0:
        NrDokPom=1
        for dok in LDok:
            if stat=='OK':
                Rejestr=dok[0][9]
                Konto=dok[0][12]
                if Rejestr=='NULL' or Konto=='NULL':
                    #pobranie danych ze wzoru dekretacji
                    SQL="SELECT konto_id,rejestr FROM rs_wzory_dekretacji wd "
                    SQL+=" WHERE wd.firma_id='"+self.firma_id+"' AND wd.okres_id='"+self.okres_id+"'"
                    SQL+=" AND wd.dowod_id='"+dok[0][0]+"' AND wd.nazwa_id='"+dok[0][1]+"';"
                    stat,DaneWz,dump,dump = self.PolSQL.Execute(SQL,3)                        
                    if stat=='OK':
                        if Rejestr=='NULL':
                            if not DaneWz[0][1] in ('','None',None):
                                Rejestr="'"+rsglobal.Dekoduj(DaneWz[0][1])+"'"
                        if Konto=='NULL':
                            if not DaneWz[0][0] in ('','None',None):
                                Konto="'"+rsglobal.Dekoduj(DaneWz[0][0])+"'"
                            
            if stat=='OK':
                stat,DaneNr,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+self.okres_id+"\\\',\\\'"+dok[0][0]+"\\\',\\\'"+dok[0][1]+"\\\',\\\'"+dok[0][2]+"\\\']','D');",3)                        
            if stat=='OK':
                if DaneNr[0][0] in (None,'None',''):
                    rsglobal.ZapiszDoLogow('NR ' + str(DaneNr), 1)
                    dane.append('Bdy numeracji dokumentu '+NrDok)
                    Poprawny=False
                else:
                    NumerDok=DaneNr[0][0]
                rsglobal.ZapiszDoLogow('NR '+str(NumerDok),dl)
                rsglobal.ZapiszDoLogow('FOX '+str(dok[0][13]),dl)
                rsglobal.ZapiszDoLogow('DOK '+str(dok[0]),dl)
                
                INS="INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer,stan,"
                INS+="kwota_wn,kwota_ma,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
                #AB 08.09.20r
                INS+="rejestr,data_rejestru,projekt_id,konto_id,tresc,czy_mpp,ozn_trans,"
                INS+="ozn_sprzedaz,ozn_nabycie,import) VALUES "
                INS+="('"+self.firma_id+"','"+self.okres_id+"','"+dok[0][0]+"','"+dok[0][1]+"','"+dok[0][2]+"',"+str(NumerDok)+",'W',"
                INS+="0,0,'"+dok[0][3]+"',"+dok[0][4]+","+dok[0][5]+","+dok[0][6]+","+dok[0][7]+","+dok[0][8]+","
                #AB 08.09.20r
                INS+=Rejestr+","+dok[0][10]+","+dok[0][11]+","+Konto+",'"+dok[0][13]+"',"+dok[0][14]+","+dok[0][15]
                INS+=","+dok[0][16]+","+dok[0][17]+","+dok[0][18]+");"
                
                Lp=0
                for poz in dok[1]:
                    Lp=Lp+1
                    
                    
                    TrescWn='.'
                    if poz[11] <> '':
                        TrescWn=poz[11]
                    
                    TrescMa='.'
                    if poz[23] <> '':
                        TrescMa=poz[23]
                    
                    INS+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                    INS+="nr_poz,nr_ppoz,nr_pozw,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto_wn,kwota_wn,"
                    INS+="konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,"
                    INS+="nkup,konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,"
                                                            #AB 08.09.20r
                    INS+="waluta_ma,kurs_ma,kwota_wal_ma,pnop, kod_gtu)"
                    INS+=" VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+dok[0][0]+"','"+dok[0][1]+"','"+dok[0][2]+"',"+str(NumerDok)+","
                    INS+=str(Lp)+",0,1,'"+poz[0]+"',"+poz[1]+","+poz[2]+","+poz[3]+","+poz[4]+","+poz[5]+","+poz[6]+","+poz[7]+","
                    INS+=poz[8]+","+poz[9]+","+poz[10]+",'"+TrescWn+"',"+poz[12]+","+poz[13]+","+poz[14]+","+poz[15]+","+poz[16]+","
                    INS+=str(poz[17])+","+poz[18]+","+poz[19]+","+poz[20]+","+poz[21]+","+poz[22]+",'"+TrescMa+"',"+poz[24]+","
                                                                        #AB 08.09.20r
                    INS+=poz[25]+","+poz[26]+","+poz[27]+","+str(poz[28])+","+poz[29]+");"

                stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
                if stat=='OK':
                    self.PolSQL.Commit()
                    NrFox=dok[0][13].strip()
                    NrFox=NrFox[NrFox.rfind(' ')+1:]
                    wyn1.append([NrDokPom,NrFox,dok[0][0],dok[0][1],dok[0][2],NumerDok,rsglobal.Dekoduj(TrescWn)])
                    NrDokPom=NrDokPom+1
                else:
                    self.PolSQL.Rollback()
