# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_klucz.py
# Purpose:      
# Author:      Dariusz Boduch
# modyfikowany: Pawe Wjcikowski  2009/05/08
# Created:     2009/04/27
# RCS-ID:      $Id: fs_dowody_ksiegowe_klucz.py $
# Copyright:   (c) 2006 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
import rsglobal

# 2011-03-31 Mariusz Rajfura    - (4426) kopiowanie 'tresc','termin_plat'
# 2012-06-05 Micha Raburski    - (5601) uwzgldnianie danych rozrachunku
# 2020-03-23 Wojciech Skowron   - (11909) kod_gtu w rs_dowody_ksiegowe_pozycje
# 2020-04-01 Wojciech Skowron   - (11917) JPK - oznaczenia w nagwku dowodu ksigowego
# 2020-04-20 Wojciech Skowron   - (11941) Poprawka w kopiowaniu kod_gtu przy kopiowaniu dowodu ksigowego
# 2022-02-03 Wojciech Skowron   - (12836) Przekazanie numeru zagadnienia
# 2022-05-12 Aleksander Bargie - (13014) [WF] Zagadnienia - dekret merytoryczny
# 2023-05-27 Jan Raburski       - (13427) zmiana daty i numeru dowodu wywolywane z dowodow ksiegowych jako zmiana klucza
# 2023-08-08 Wojciech Skowron   - (13482) przepisywanie daty utworzenia zagadnienia jako daty wpywu

Dowod = rsglobal.Dekoduj(klucze[0]).strip()
Nazwa = rsglobal.Dekoduj(klucze[1]).strip()
Data  = rsglobal.Dekoduj(klucze[2])
Pola  = klucze[3]
nip   = None
TylkoKlucz = klucze[4]
KluczKopiowanego = klucze[5]
DaneRozrachunku = klucze[6]
#WS 2022-02-03
if len(klucze) == 9:
    Zagadnienie = klucze[7]
    if isinstance(Zagadnienie, dict):  #AB 11.05.22r
        wf_uproszczone = Zagadnienie['uproszczone']
        Zagadnienie    = Zagadnienie['zagadnienie_id']
    else:
        wf_uproszczone = False
    rsglobal.ZapiszDoLogow("uproszczone: {} zagadnienie_id: {}".format(wf_uproszczone, Zagadnienie))
elif len(klucze) == 10:
    Zagadnienie      = klucze[7]
    d_kontr          = klucze[8]
    if d_kontr is not None:
        nip              = d_kontr['nip']
        kontrahent_nazwa = d_kontr['kontrahent_nazwa']
        kontrahent_adres = d_kontr['kontrahent_adres']
    if isinstance(Zagadnienie, dict):  #AB 11.05.22r
        wf_uproszczone = Zagadnienie['uproszczone']
        Zagadnienie    = Zagadnienie['zagadnienie_id']
    else:
        wf_uproszczone = False
else:
    Zagadnienie = 0



Fun = klucze[-1]


stat='OK'
dane = []

self.Pola = Pola
self.TylkoKlucz = TylkoKlucz
self.KluczKopiowanego = KluczKopiowanego
UprTotal=True
if stat=='OK':
    #Pobranie uprawnien do dokumentw ksigowych dla operatora
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprDodawanie=True       
        LDod=[]
    else:
        Sel="SELECT dowod_id,nazwa_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie "
        Sel+="FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id in "
        Sel+=""+str(self.operatorzy).replace("[","(").replace("]",")")+" AND okres_id='"+self.okres_id+"'; "
        stat,daneupr,dump,dump = self.PolSQL.Execute(Sel,3)
        if stat<>'OK':
            stat = 'BL SPR UPR'
            dane.append(stat)                        
        if stat=='OK':
            if len(daneupr)>0:
                UprTotal=False
            else:
                UprTotal=True
            
            LDod=[]

            UprDodawanie=(self.oddzial_id,'075013') in self.uprawnienia
            if UprDodawanie:
                for d in daneupr:
                    if d[2]:
                        LDod.append((rsglobal.Dekoduj(d[0]).strip(),rsglobal.Dekoduj(d[1]).strip()))

if not UprDodawanie and Zagadnienie == 0:  #AB 11.05.22r
    stat='UPR DOD'
    dane.append(stat)
if stat=='OK' and not UprTotal and Zagadnienie == 0:  #AB 11.05.22r
    if not ((str(Dowod),Nazwa) in LDod ) and self.operator_id!=STANDARD_OPERATOR_ID:
        stat='UPR DOD'
        dane.append(stat)
#sprawdzenie danych
if Data != '    -  -  ':
    if not rsglobal.SprawdzCzyToData(Data):
        stat='BL DATA'
        dane.append(stat)

if Fun in [10,11,12] and stat=='OK':
    # jesli BO,BK to dodatkowo ustawia dane
    if Dowod in ['BO','BK']:

        if self.Pola != None and KluczKopiowanego==None:
            stat = 'BL BO/BK'
            dane.append(stat)
        if stat=='OK':
            SQL = "SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"';"
            stat,dane_d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat = 'BL SQL DATA_OD'
                dane.append(stat)
            else:
                if Dowod=='BO':
                    Data = dane_d[0][0]
                Nazwa = '00001'
                Numer = 1

            if stat == 'OK':
                SQL = "SELECT dowod_id FROM rs_dowody_ksiegowe WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                SQL+= " AND dowod_id='BO';"
                stat,dane_dk,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat =='OK':
                    # jeli BO to sprawdzamy,  go jeszcze nie ma
                    if Dowod == 'BO':
                        if dane_dk != []:
                            stat='DOW ISTN'
                            dane.append(stat)
                    
                    # jeli BK to upewniamy si, e BO istnieje
                    else:
                        if dane_dk == []:
                            stat='BK BEZ BO'
                            dane.append(stat)
                    
                
if stat=='OK':
    SQL = "SELECT czy_symbol_dok,symbol_dok,czy_data_wyst,czy_data_wplywu,"  #0-3
    SQL+= "czy_kontrahent_id,kontrahent_id,czy_rejestr,rejestr,"  #4-7
    SQL+= "czy_data_rejestru,czy_konto_id,konto_id,"  #8-10
    SQL+= "czy_ozn_trans,ozn_trans,czy_ozn_sprzedaz,ozn_sprzedaz,czy_ozn_nabycie,ozn_nabycie,import,"  #WS 2020-04-01 - 11-17
    SQL+= "typ_wzoru, dod_kontrahent,"  #WS 2022-02-03 - 18-19
    SQL+= "sprzedaz_uslug"  #WS 2024-02-23 - 20
    SQL+= " FROM rs_wzory_dekretacji WHERE firma_id = '"+self.firma_id+"' AND okres_id "
    SQL+= "= '"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,dane_s,dump,dump = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('dane_s: '+SQL)
    if stat<>'OK':
        stat='BL SQL WZ DEK'
        dane.append(stat)
    else:
        if dane_s == [] :
            stat='BL WZ DEK'
            dane.append(stat)
     
    
    if not (Dowod in ['BO','BK']):
        if Data == '    -  -  ':
            stat = 'BR DATA'
            dane.append(data)

        if stat=='OK' and Fun != 13:
            stat,dane_dz,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+"', '"+Data+"', 3) ;",3)
            if stat<>'OK':
                stat='BL SQL ZAK DAT'
                dane.append(stat)
            else:
                if dane_dz[0][0]<> 1:
                    stat='BL ZAK DAT'
                    dane.append(stat)
    if stat=='OK':
        sql="SELECT rsf_sprawdz_date_z_okresem('"+self.firma_id+"','"+self.okres_id+"','"+Data+"');"
        stat,D,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL SQL OKR'
            dane.append(stat)
        else:
            if D[0][0]<>1:
                stat='NZG DATA'
                dane.append(stat)
            
    if Dowod != 'BO' and stat=='OK':
        SQL = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+self.okres_id+"\\\',\\\'"+Dowod+""
        SQL+= "\\\',\\\'"+Nazwa+"\\\',\\\'"+Data+"\\\']','D');"            
        stat,DData,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='BL SQL SPR DOK'
            dane.append(stat)
        else:
            if DData[0][0]=='OK':
                SQL = "SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+self.okres_id+"\\\',\\\'"+Dowod+""
                SQL+= "\\\',\\\'"+Nazwa+"\\\',\\\'"+Data+"\\\']','D');"
                stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)
                if DNr[0][0] in (None,'None',''):
                    stat='BL NR DOW'
                    dane.append(stat)
            else:
                stat=str(DData[0][0])
                dane.append(stat)
            if stat=='OK':    
                Numer=DNr[0][0]
    if stat=='OK' and nip is not None and not dane_s[0][19]:
        stat = 'Zagadnienie zawiera kontrahenta spoza kartoteki. We wzorze dekretacji naley zaznaczy opcj "Dodatkowy kontrahent"'
    rsglobal.ZapiszDoLogow('stat: '+stat)
    rsglobal.ZapiszDoLogow('Fun: ' +str(Fun))

if Fun == 10 and stat=='OK':
    if self.TylkoKlucz and stat=='OK':
        dane=[Dowod,Nazwa,Data,str(Numer)+'.0']
    dane=[Dowod,Nazwa,Data,str(Numer)+'.0']
    
    if dane_s[0][0]: #Symbol
        self.Symbol = str(dane_s[0][1])
    else:
        self.Symbol = ''

    #mantis: 3992 mariusz rajfura 2010/10/11
    self.DataWyst = "NULL"
        
    if dane_s[0][3]:
        self.DataWplywu = "'"+str(Data)+"'"
    else:
        self.DataWplywu = "NULL"

    self.Kontrahent = 'NULL'
    if dane_s[0][4]:
        if dane_s[0][5] != 'None':
            self.Kontrahent = "'"+str(dane_s[0][5])+"'"

    self.Rejestr = 'NULL'
    if dane_s[0][6]:
        if dane_s[0][7] != 'None':
            self.Rejestr = "'"+str(dane_s[0][7])+"'"

    if dane_s[0][8]:
        self.DataRej = "'"+str(Data)+"'"
    else:
        self.DataRej ='NULL'

    self.KontoId='NULL'
    if dane_s[0][9]:
        if dane_s[0][10] != 'None':
            self.KontoId = "'"+str(dane_s[0][10])+"'"

    #WS 2020-04-01
    self.OznTransakcje = 'NULL'
    if dane_s[0][11]:
        self.OznTransakcje = rsglobal.ZmienNaNULL(dane_s[0][12].strip())

    #WS 2020-04-01
    self.OznSprzedaz = 'NULL'
    if dane_s[0][13]:
        self.OznSprzedaz = rsglobal.ZmienNaNULL(dane_s[0][14].strip())

    #WS 2020-04-01
    self.OznNabycie = 'NULL'
    if dane_s[0][15]:
        self.OznNabycie = rsglobal.ZmienNaNULL(dane_s[0][16].strip())

    #WS 2020-04-01
    self.Import = 'TRUE' if dane_s[0][17] is True else 'FALSE'

    #WS 2024-02-23
    self.SprzedazUslug = 'TRUE' if dane_s[0][20] is True else 'FALSE'

    #WS 2022-02-03
    self.TypWzoru = dane_s[0][18].strip()

    #WS 2022-02-03
    if stat == 'OK':
        if Zagadnienie == 0:
            self.Zagadnienie = 'NULL'
            self.ZagadnienieStan = ''
            self.ZagadnienieKomorka = ''
            self.ZagadnienieDokument = ''
        else:
            if self.TypWzoru != 'S':
                stat = "TYP DK"
                dane.append(stat)

            if stat == 'OK':
                self.Zagadnienie = Zagadnienie
                SQL="SELECT 1 FROM rs_dowody_ksiegowe WHERE zagadnienie_id="+str(self.Zagadnienie)+";"
                stat,dane_dk_zag,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':
                    stat = "Bdy przy szukaniu dowodu ksigowego powizanego z zagadnieniem"
                    dane.append(stat)
                elif len(dane_dk_zag) > 0:
                    stat = "DK ISTNIEJE"
                    dane.append(stat)

            if stat == 'OK':
                #WS 2023-08-08 - wprowadzenie_czas
                SQL="SELECT kontrahent_id, COALESCE(symbol_dokumentu, ''), stan, komorka_id, dokument_id, wprowadzenie_czas::DATE FROM rs_wf_zagadnienia"
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND zagadnienie_id="+str(self.Zagadnienie)+";"
                stat,dane_zag,dump,dump = self.PolSQL.Execute(SQL,3)
                rsglobal.ZapiszDoLogow('Dane zagadnienia do wpisania na dowod: '+SQL, 5)
                if stat<>'OK':
                    stat = "Wystpi bd podczas pobierania danych zagadnienia"
                    dane.append(stat)
                elif len(dane_zag)==0:
                    stat = "Zagadnienie nie istnieje"
                    dane.append(stat)
                else:
                    self.Kontrahent = rsglobal.ZmienNaNULL(dane_zag[0][0])
                    self.Symbol = dane_zag[0][1]
                    self.ZagadnienieStan = dane_zag[0][2]
                    self.ZagadnienieKomorka = dane_zag[0][3]
                    self.ZagadnienieDokument = dane_zag[0][4]
                    self.DataWplywu = "'"+str(dane_zag[0][5])+"'"  #WS 2023-08-08

if Fun==11: #kopiowanie dowodu ksiegowego
    
    if stat=='OK':
        INSERT = "INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer, "
        INSERT +="stan,kwota_wn,kwota_ma,symbol_dok,data_wyst,data_wplywu,kontrahent_id,rejestr, "
        INSERT +="data_rejestru, konto_id, projekt_id,tresc,termin_plat, czy_mpp,"
        INSERT +="ozn_trans, ozn_sprzedaz, ozn_nabycie, import, sprzedaz_uslug)"  #WS 2020-04-01  #WS 2024-02-23
        INSERT +=" SELECT '"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"', "
        INSERT +="'"+Nazwa+"','"+Data+"',"+str(Numer)+",'W',kwota_wn,kwota_ma,symbol_dok,data_wyst, "
        INSERT +=" data_wplywu,kontrahent_id,rejestr,data_rejestru, konto_id, projekt_id,tresc,termin_plat, coalesce(czy_mpp OR "
        INSERT +="(select czy_mpp from rs_kontrahenci k where k.firma_id=dk.firma_id and k.kontrahent_id = dk.kontrahent_id ), FALSE),"
        INSERT +=" ozn_trans, ozn_sprzedaz, ozn_nabycie, import, sprzedaz_uslug"  #WS 2020-04-01  #WS 2024-02-23
        INSERT +=" FROM rs_dowody_ksiegowe dk "
        INSERT +="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        INSERT +="AND dowod_id='"+str(self.KluczKopiowanego[0]).strip()+"' AND nazwa_id='"+str(self.KluczKopiowanego[1]).strip()+"' "
        INSERT +="AND data='"+str(self.KluczKopiowanego[2])+"' AND numer="+str(self.KluczKopiowanego[3])+"; "
        
        INSERT +="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer "
        INSERT +=",nr_poz,nr_ppoz,nr_pozw,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id "
        INSERT +=",konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl "
        INSERT +=",waluta_wn,kurs_wn,kwota_wal_wn,nkup,konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma "
        INSERT +=",tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop,zamkniecie_kregu,pobierac_na_rejestr,"
        INSERT +="pozycja_ze_wzoru,data_ksieg_kosztow,kod_gtu) "  #WS 2020-03-23 - kod_gtu
        INSERT +="SELECT '"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"','"+Data+"',"+str(Numer)+", "
        INSERT +="nr_poz,nr_ppoz,nr_pozw,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto_wn "
        INSERT +=",kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn "
        INSERT +=",kwota_wal_wn,nkup,konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma "
        INSERT +=",waluta_ma,kurs_ma,kwota_wal_ma,pnop,zamkniecie_kregu,pobierac_na_rejestr,"
        INSERT +="pozycja_ze_wzoru, data_ksieg_kosztow, kod_gtu FROM rs_dowody_ksiegowe_pozycje "  #WS 2020-03-23 - kod_gtu
        INSERT +="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        INSERT +="AND dowod_id='"+str(self.KluczKopiowanego[0]).strip()+"' AND nazwa_id='"+str(self.KluczKopiowanego[1]).strip()+"' "
        INSERT +="AND data='"+str(self.KluczKopiowanego[2])+"' AND numer="+str(self.KluczKopiowanego[3])+";"
        
        #--- uporzdkowanie pozycji krgu
        
        #sprawdzenie czy byy pozycje z krgu
        #WS 2020-04-20 - pobranie kod_gtu
        SQLTest="SELECT DISTINCT nr_poz,nr_pozw,data_wyst,kod_gtu FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQLTest+="AND dowod_id='"+str(self.KluczKopiowanego[0])+"' AND nazwa_id='"+str(self.KluczKopiowanego[1])+"' "
        SQLTest+="AND data='"+str(self.KluczKopiowanego[2])+"' AND numer="+str(self.KluczKopiowanego[3])+" AND zamkniecie_kregu;"
        rsglobal.ZapiszDoLogow(INSERT, 5)
        stat,DKregu,dump,dump = self.PolSQL.Execute(SQLTest,3)

    rsglobal.ZapiszDoLogow(INSERT, 5)
    if stat=='OK':
        if len(DKregu)>0:
            # usunicie pozycji z krgu
            INSERT+="DELETE FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            INSERT+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
            INSERT+=" AND zamkniecie_kregu;"
            
            for w in DKregu:
                # wstawienie nowych pozycji z krgu
                INSERT+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                INSERT+="nr_poz,nr_ppoz,nr_pozw,symbol_dok,kontrahent_id,konto_wn,konto_vat_wn,"
                INSERT+="stawka_vat_wn,tresc_wn,sposob_rozl,konto_ma,konto_vat_ma,stawka_vat_ma,tresc_ma,"
                INSERT+="waluta_wn,waluta_ma,projekt_wn,projekt_ma,zamkniecie_kregu,pobierac_na_rejestr,"
                INSERT+="data_ksieg_kosztow,kwota_wn,kwota_ma,kod_gtu) "  #WS 2020-03-23 - kod_gtu
                INSERT+=" SELECT firma_id,okres_id,dowod_id,nazwa_id,'"+Data+"',"+str(Numer)+","
                INSERT+=str(w[0])+",0,nr_poz,symbol_dok,kontrahent_id,konto_wn,konto_vat_wn,"
                INSERT+="stawka_vat_wn,tresc_wn,COALESCE(sposob_rozl,''),konto_ma,konto_vat_ma,stawka_vat_ma,tresc_ma,"
                INSERT+="'PLN','PLN',projekt_wn,projekt_ma,zamkniecie_kregu,pobierac_na_rejestr,NULL,0,0,"+rsglobal.ZmienNaNULL(w[3])  #WS 2020-04-20 - w[3]
                INSERT+=" FROM rs_wzory_dekretacji_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                INSERT+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(w[1])+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat<>'OK':
            stat='BL INS KOP'
            dane.append(stat)

if Fun==12: #dodawanie nowego dokumentu
    if Zagadnienie == 0:
        self.Zagadnienie = 'NULL'
        self.ZagadnienieStan = ''
        self.ZagadnienieKomorka = ''
        self.ZagadnienieDokument = ''
    else:
        if self.TypWzoru != 'S':
            stat = "TYP DK"
            dane.append(stat)

        if stat == 'OK':
            self.Zagadnienie = Zagadnienie
            SQL="SELECT 1 FROM rs_dowody_ksiegowe WHERE zagadnienie_id="+str(self.Zagadnienie)+";"
            stat,dane_dk_zag,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat = "Bdy przy szukaniu dowodu ksigowego powizanego z zagadnieniem"
                dane.append(stat)
            elif len(dane_dk_zag) > 0:
                stat = "DK ISTNIEJE"
                dane.append(stat)

        if stat == 'OK':
            #WS 2023-08-08 - wprowadzenie_czas
            SQL="SELECT kontrahent_id, COALESCE(symbol_dokumentu, ''), stan, komorka_id, dokument_id, wprowadzenie_czas::DATE FROM rs_wf_zagadnienia"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND zagadnienie_id="+str(self.Zagadnienie)+";"
            stat,dane_zag,dump,dump = self.PolSQL.Execute(SQL,3)
            rsglobal.ZapiszDoLogow('Dane zagadnienia do wpisania na dowod: '+SQL, 5)
            if stat<>'OK':
                stat = "Wystpi bd podczas pobierania danych zagadnienia"
                dane.append(stat)
            elif len(dane_zag)==0:
                stat = "Zagadnienie nie istnieje"
                dane.append(stat)
            else:
                self.Kontrahent = rsglobal.ZmienNaNULL(dane_zag[0][0])
                self.Symbol = dane_zag[0][1]
                self.ZagadnienieStan = dane_zag[0][2]
                self.ZagadnienieKomorka = dane_zag[0][3]
                self.ZagadnienieDokument = dane_zag[0][4]
                self.DataWplywu = "'"+str(dane_zag[0][5])+"'"  #WS 2023-08-08
    rsglobal.ZapiszDoLogow("#dodawanie nowego dokumentu")
    if stat == "OK" and self.Kontrahent != 'NULL':
        SQL="SELECT czy_mpp FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = "+self.Kontrahent+";"
        stat,dane1,dump,dump = self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL, 5)
        if stat<>'OK':
            stat = "BR SPR8"
            dane.append(stat)
        elif len(dane1)==0:
            stat = "BL KONT"
            dane.append(stat)
        #AB 05.08.19r
        else:
            czy_mpp = 'TRUE' if dane1[0][0] else 'FALSE'
    elif stat == 'OK' and self.Kontrahent == 'NULL':
        czy_mpp = 'FALSE'

    if stat=='OK':
        #WS 2022-02-03 - zagadnienie_id
        args = []
        Insert="INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer,stan,kwota_wn,kwota_ma,"
        Insert+="symbol_dok,data_wyst,data_wplywu,kontrahent_id,rejestr,data_rejestru,konto_id, czy_mpp,"
        Insert+="ozn_trans, ozn_sprzedaz, ozn_nabycie, import, sprzedaz_uslug, zagadnienie_id)"  #WS 2020-04-01  #WS 2024-02-23
        Insert+=" VALUES "
        Insert+="('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"' "
        Insert+=",'"+Data+"',"+str(Numer)+",'W',0,0,'"+self.Symbol+"',"+self.DataWyst+","+self.DataWplywu+","
        Insert+=""+self.Kontrahent+","+self.Rejestr+","+self.DataRej+","+self.KontoId+","+czy_mpp
        Insert+=","+self.OznTransakcje+","+self.OznSprzedaz+","+self.OznNabycie+","+self.Import+","+self.SprzedazUslug+","+str(self.Zagadnienie)+");"  #WS 2020-04-01  #WS 2024-02-23

        rsglobal.ZapiszDoLogow(self.Kontrahent)
        if nip is not None and self.Kontrahent in ('', None, 'NULL'):
            tmp_adr    = kontrahent_adres.split(',')
            kod_poczta = tmp_adr[0].strip().split(' ')
            adr_kod    = kod_poczta[0].strip()
            poczta     = ' '.join(kod_poczta[1:]).strip()
            miej       = tmp_adr[1].strip() if tmp_adr[1].strip() else poczta
            ulica      = tmp_adr[2].strip().strip(',')
            adr_nr     = ' '.join(tmp_adr[3:]).strip().strip(',')
            nip        = nip.replace('-', '').replace(' ', '').strip()[-12:]

            args = [self.firma_id, self.okres_id, Dowod, Nazwa, Data, Numer, kontrahent_nazwa[:50], adr_kod[:10], miej[:50], ulica[:50], poczta[:50], adr_nr[:15], nip]
            Insert+= """INSERT INTO rs_dowody_ksiegowe_kontrahent
                      (firma_id, okres_id, dowod_id, nazwa_id, data, numer, nazwa, kraj, adr_kod, adr_miej, adr_ulica, adr_poczta, adr_nry, nip)
                    VALUES(%s, %s, %s, %s, %s, %s, %s, 'PL', %s, %s, %s, %s, %s, %s);
            """
        args = [str(x) if isinstance(x, unicode) else x for x in args]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(Insert, args))
        stat,dane,dump,dump = self.PolSQL.Execute(Insert, 1, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat='BL INS DOK'
            dane.append(stat)
        else:
            rsglobal.ZapiszDoLogow("#dodawanie pozycji nowego dokumentu")
            SELECT = "SELECT rsf_utworz_pozycje_dowodu_ze_wzoru('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"',"
            SELECT+= "'"+Nazwa+"','"+Data+"',"+str(Numer)+");"
            
            stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3)
            rsglobal.ZapiszDoLogow(SELECT)
            if stat<>'OK':
                stat = 'BL SQL TW POZ DOW'
            elif dane[0][0] != 'OK':
                stat=dane[0][0]
        
            # jeli dowd jest utworzony i uzupenione s dane rozrachunku to zmieniamy pierwsz pozycj dowodu
            if stat=='OK' and DaneRozrachunku!=None:
                rsglobal.ZapiszDoLogow("#zmiana 1 pozycji dk")
                SQL="UPDATE rs_dowody_ksiegowe_pozycje SET "
                if DaneRozrachunku[2]<>0:    # strona wn
                    SQL+="konto_wn='"+DaneRozrachunku[0]+"', kwota_wn="+str(DaneRozrachunku[2])+",kwota_wal_wn="+str(DaneRozrachunku[2])+", tresc_wn=TRIM(tresc_wn||' "+DaneRozrachunku[1]+"'), kurs_wn=1"
                elif DaneRozrachunku[3]<>0:    # strona ma
                    SQL+="konto_ma='"+DaneRozrachunku[0]+"', kwota_ma="+str(DaneRozrachunku[3])+",kwota_wal_ma="+str(DaneRozrachunku[3])+", tresc_ma=TRIM(tresc_ma||' "+DaneRozrachunku[1]+"'), kurs_ma=1"
                else:
                    SQL=""
                
                if  SQL<>"":
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"'"
                    SQL+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz=1;"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,1)

            #WS 2022-02-03
            if stat == 'OK' and self.Zagadnienie != 'NULL':
                rsglobal.ZapiszDoLogow("#kopiowanie plikow z zagadnienia")
                from funkcje import fs_wf_zagadnienia_pom
                argumenty = (self, self.firma_id, self.operator_id, self.Zagadnienie, 'modyfikacja' if wf_uproszczone else 'ksiegowanie',  #AB 11.05.22r
                                                                self.ZagadnienieStan, self.ZagadnienieKomorka, self.ZagadnienieDokument)

                rsglobal.ZapiszDoLogow("argumenty {}".format(argumenty))
                stat = fs_wf_zagadnienia_pom.SprawdzUprawnienia(*argumenty, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
                if stat == 'OK':
                    stat, dump, dump, dump = self.WykonajFunkcje("fs_wf_zagadnienia_dane", {'Funkcja': 10, 'zagadnienie_id': self.Zagadnienie, 'uproszczone': wf_uproszczone}, [], [], False)

                if stat == 'OK':
                    INSPLIKIZAG = """INSERT INTO rs_dowody_ksiegowe_pliki (dowod_plik, nr_pliku, firma_id, okres_id, dowod_id, nazwa_id, data, numer)
                                     SELECT SUBSTRING(p.nazwa,1,100), nr_pliku, '{self.firma_id}', '{self.okres_id}', '{Dowod}', '{Nazwa}', '{Data}', {Numer}
                                     FROM rs_wf_zagadnienia_pliki zp
                                     JOIN rs_pliki p ON zp.nr_pliku = p.plik_id
                                     WHERE zagadnienie_id={self.Zagadnienie} AND NOT EXISTS (SELECT 1 FROM rs_dowody_ksiegowe_pliki dkp WHERE zp.nr_pliku=dkp.nr_pliku);""".format(**locals())
                    rsglobal.ZapiszDoLogow('Pliki zagadnienie dowod: '+INSPLIKIZAG)
                    stat,dump,dump,dump = self.PolSQL.Execute(INSPLIKIZAG, 1)
                    if stat != 'OK':
                        stat = 'Bd przepisania plikw zagadnienia do dowodu ksigowego'
                        dane.append(stat)
                    
if Fun == 13:  #zmiana klucza dowodu ksiegowego (data i numer tylko, wywolywane z dowodow ksiegowych wprost)
    if stat=='OK':
        Numer = str(self.Pola[0])
        NowaData = str(self.Pola[1])

        # pobranie sposobu numeracji
        SQL = "SELECT spos_dowody, data_od FROM rs_firmy_numeracja"
        SQL += " WHERE firma_id='" + self.firma_id + "' AND data_od<='" + NowaData + "' ORDER BY data_od DESC LIMIT 1;"
        stat, dane_sp, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzania sposobw numeracji. ' + stat
            dane.append(stat)
        elif len(dane_sp) == 0:
            sposnum = 'D'
        else:
            sposnum = dane_sp[0][0]
            if sposnum == 'R':
                stat = 'Roczna numeracja nie jest obsugiwana przy zmianie daty dowodu.'
                dane.append(stat)
            else:
                if str(dane_sp[0][1]) > Data:
                    stat = 'Zmiana sposobu numeracji - zmiana daty dowodu niemoliwa.'
                    dane.append(stat)

    # sprawdzenie daty z zakresem i okresem
    if stat == 'OK':
        stat, dane_dz, dump, dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date_z_zakresem('" + self.firma_id + "', '" + NowaData + "', 3) ;", 3)
        if stat != 'OK':
            stat = 'Bd sprawdzania z zakresem dat. ' + stat
            dane.append(stat)
        else:
            if dane_dz[0][0] != 1:
                stat = 'Nowa data dowodu spoza zakresu.'
                dane.append(stat)
    if stat == 'OK':
        sql = "SELECT rsf_sprawdz_date_z_okresem('" + self.firma_id + "','" + self.okres_id + "','" + NowaData + "');"
        stat, D, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzanie z okresem. ' + stat
            dane.append(stat)
        else:
            if D[0][0] != 1:
                stat = 'Nowa data niezgodna z wybranym okresem.'
                dane.append(stat)

    #---------- OBSLUGA SPOSOBU 'D' - dzienne

    # czy jest ostatni i mozna go 'usunac'
    if stat == 'OK' and sposnum == 'D':
        SQL = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('" + self.firma_id + "','[\\\'" + self.okres_id + "\\\',\\\'" + Dowod + ""
        SQL += "\\\',\\\'" + Nazwa + "\\\',\\\'" + Data + "\\\']','D');"
        stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzania czy ostatni dowd. ' + stat
            dane.append(stat)
        else:
            if DData[0][0] == 'OK':
                SQL = "SELECT rsf_podaj_nowy_numer_dokumentu('" + self.firma_id + "','[\\\'" + self.okres_id + "\\\',\\\'" + Dowod + ""
                SQL += "\\\',\\\'" + Nazwa + "\\\',\\\'" + Data + "\\\']','D');"
                stat, DNr, dump, dump = self.PolSQL.Execute(SQL, 3)
                if DNr[0][0] in (None, 'None', ''):
                    stat = 'Bd sprawdzania czy ostatni dowd. ' + stat
                    dane.append(stat)
            else:
                stat = str(DData[0][0])
                dane.append(stat)
            if stat == 'OK':
                if int(Numer) + 1 != int(DNr[0][0]):
                    stat = 'Wybrany dowd nie jest ostatni.' # + Numer + '/' + str(DNr[0][0])
                    dane.append(stat)

    # czy mozna dodac z nowa data, pobranie numeru
    if stat == 'OK' and sposnum == 'D':
        SQL = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('" + self.firma_id + "','[\\\'" + self.okres_id + "\\\',\\\'" + Dowod + ""
        SQL += "\\\',\\\'" + Nazwa + "\\\',\\\'" + NowaData + "\\\']','D');"
        stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzania czy mona doda dowd. ' + stat
            dane.append(stat)
        else:
            if DData[0][0] == 'OK':
                SQL = "SELECT rsf_podaj_nowy_numer_dokumentu('" + self.firma_id + "','[\\\'" + self.okres_id + "\\\',\\\'" + Dowod + ""
                SQL += "\\\',\\\'" + Nazwa + "\\\',\\\'" + NowaData + "\\\']','D');"
                stat, DNr, dump, dump = self.PolSQL.Execute(SQL, 3)
                if DNr[0][0] in (None, 'None', ''):
                    stat = 'Bd pobierania nowego numeru dowodu. ' + stat
                    dane.append(stat)
            else:
                stat = str(DData[0][0])
                dane.append(stat)
            if stat == 'OK':
                NowyNumer = DNr[0][0]

    if stat == 'OK' and sposnum == 'D':
        # zmiana daty i numeru
        UPD = "UPDATE rs_dowody_ksiegowe SET data='"+NowaData+"',"
        UPD+= "numer="+str(NowyNumer)+" WHERE firma_id='"+self.firma_id+"' "
        UPD+= "AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND "
        UPD+= "nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+""
        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat != 'OK':
            stat = 'Bd zmiany numeru dowodu. ' + stat
            dane.append(stat)
        else:
            dane.append('Dowd przeniesiono do dnia ' + str(NowaData) + ' i otrzyma numer ' + str(NowyNumer) + '.')

    #---------- OBSLUGA SPOSOBU 'M' - miesieczne

    if stat == 'OK' and sposnum == 'M':
        SQL = "SELECT numerowanie_pomijac_nazwe FROM rs_definicje_okresow_miesiace WHERE firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
        SQL += " AND rok='" + Data[0:4] + "' and miesiac='" + Data[5:7] + "'"
        stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzania numeracji w miesicach. ' + stat
            dane.append(stat)
        else:
            PomijacNazwe = DData[0][0]
        if stat == 'OK' and Data[0:7] == NowaData[0:7]:  # obie daty z tego samego miesiaca
            PomijacNazweN = PomijacNazwe
        else:
            SQL = "SELECT numerowanie_pomijac_nazwe FROM rs_definicje_okresow_miesiace WHERE firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
            SQL += " AND rok='" + NowaData[0:4] + "' and miesiac='" + NowaData[5:7] + "'"
            stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd sprawdzania numeracji w miesicach. ' + stat
                dane.append(stat)
            else:
                PomijacNazweN = DData[0][0]

        if stat == 'OK':
            # sprawdzenie czy ostatni
            SQL = "SELECT count(*) FROM rs_dowody_ksiegowe WHERE firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
            SQL += " AND dowod_id='" + Dowod + "'"
            SQL += " AND ((data='" + Data + "' AND numer>" + str(Numer) + ") OR (EXTRACT (YEAR FROM data)=" + Data[0:4]
            SQL += " AND EXTRACT (MONTH FROM data)=" + Data[5:7] + " AND data>'" + Data + "'))"
            if not PomijacNazwe:
                SQL += " AND nazwa_id='" + Nazwa + "'"
            stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd sprawdzania czy ostatni dowd. ' + stat
                dane.append(stat)
            elif DData[0][0] > 0:
                stat = 'Wybrany dowd nie jest ostatni.'  # + Numer + '/' + str(DNr[0][0])
                dane.append(stat)

        if stat == 'OK':
            SQL = "SELECT count(*) FROM rs_dowody_ksiegowe WHERE firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
            SQL += " AND dowod_id='" + Dowod + "'"
            SQL += " AND EXTRACT (YEAR FROM data)=" + NowaData[0:4]
            SQL += " AND EXTRACT (MONTH FROM data)=" + NowaData[5:7] + " AND data>'" + NowaData + "' AND numer != " + str(Numer)
            if not PomijacNazweN:
                SQL += " AND nazwa_id='" + Nazwa + "'"
            stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd sprawdzania czy mona zmieni dat. ' + stat
                dane.append(stat)
            elif DData[0][0] > 0:
                stat = 'Nie mona doda dowodu w podanym dniu.'  # + Numer + '/' + str(DNr[0][0])
                dane.append(stat)

        if stat == 'OK':
            if Data[0:7] == NowaData[0:7]:  # obie daty z tego samego miesiaca
                if stat == 'OK':
                    # zmiana daty, numer zostaje ten sam - ostatni
                    UPD = "UPDATE rs_dowody_ksiegowe SET data='"+NowaData+"'"
                    UPD+= " WHERE firma_id='"+self.firma_id+"' "
                    UPD+= "AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND "
                    UPD+= "nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+""
                    stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
                    if stat != 'OK':
                        stat = 'Bd zmiany numeru dowodu. ' + stat
                        dane.append(stat)
                    else:
                        dane.append('Dowd przeniesiono do dnia ' + str(NowaData) + '.')

            else:  # rozne miesiace

                # pobranie nowego numeru
                if stat == 'OK':
                    SQL = "SELECT MAX(numer) FROM rs_dowody_ksiegowe WHERE firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
                    SQL += " AND dowod_id='" + Dowod + "'"
                    SQL += " AND EXTRACT (YEAR FROM data)=" + NowaData[0:4]
                    SQL += " AND EXTRACT (MONTH FROM data)=" + NowaData[5:7]
                    if not PomijacNazweN:
                        SQL += " AND nazwa_id='" + Nazwa + "'"
                    stat, DData, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':
                        stat = 'Bd pobierania nowego numeru. ' + stat
                        dane.append(stat)
                    else:
                        NowyNumer = DData[0][0] + 1
                        # zmiana daty i numeru
                        UPD = "UPDATE rs_dowody_ksiegowe SET data='"+NowaData+"',"
                        UPD+= "numer="+str(NowyNumer)+" WHERE firma_id='"+self.firma_id+"' "
                        UPD+= "AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND "
                        UPD+= "nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+""
                        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
                        if stat != 'OK':
                            stat = 'Bd zmiany numeru dowodu. ' + stat
                            dane.append(stat)
                        else:
                            dane.append('Dowd przeniesiono do dnia ' + str(NowaData) + ' i otrzyma numer ' + str(NowyNumer) + '.')


    rsglobal.ZapiszDoLogow('stat: '+stat)
    rsglobal.ZapiszDoLogow('dane: '+str(dane))
