# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_pliki.py
# Author:      Piotr Witkowski
# Created:     2018/04/13
# RCS-ID:      $Id: fs_dowody_ksiegowe_pliki.py $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2022-05-10 Wojciech Skowron (13004) Zmiana z 'M' na 'W' przy modyfikacji
# 2022-05-11 Wojciech Skowron (13013) Poprawka w usuwaniu pliku

from funkcje import fs_pliki_global
import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {
        'NazwaPliku': [1], 'TrescPliku': [1],
        'PlikId': [2, 6], 
        'Dowod': [1, 2, 5, 6],  'Nazwa': [1, 2, 5, 6],
        'Data': [1, 2, 5, 6],  'Numer': [1, 2, 5, 6],
    }
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_dowody_ksiegowe_pliki ' \
               'z numerem ' + str(Funkcja) + ' bez parametrw: ' + Lista

if stat == "OK":
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    Data = klucze['Data']
    Numer = klucze['Numer']

    if Funkcja in [2, 6]:
        PlikId = klucze['PlikId']
    if Funkcja == 1:
        NazwaPliku = klucze['NazwaPliku']
        TrescPliku = klucze['TrescPliku']

dane = []
LPlik = []

# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
# -------------------------------------------------------------------------------

UprIns = ((self.oddzial_id, '075013') in self.uprawnienia) or \
         ((self.oddzial_id, '075012') in self.uprawnienia) or \
         (self.operator_id == STANDARD_OPERATOR_ID)

UprDel = ((self.oddzial_id, '075014') in self.uprawnienia) or \
         (self.operator_id == STANDARD_OPERATOR_ID)

if stat == 0 and Funkcja == 1 and not UprIns:
    stat = 'UPR INS'

if stat == 0 and Funkcja == 6 and not UprDel:
    stat = 'UPR DEL'

if stat == 'OK':
    WHERE = " WHERE firma_id='" + self.firma_id + "' "
    WHERE += "AND okres_id='" + str(self.okres_id) + "' "
    WHERE += "AND dowod_id='" + str(Dowod) + "' "
    WHERE += "AND nazwa_id='" + str(Nazwa) + "' "
    WHERE += "AND data='" + str(Data) + "' "
    WHERE += "AND numer='" + str(Numer) + "' "
    # sprawdzenie poprawnoci dowodu ksigowego
    SQL = "SELECT dowod_id FROM rs_dowody_ksiegowe " + WHERE + "FOR UPDATE NOWAIT;"
    stat, DTest, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd sprawdzania poprawnoci dowodu ksigowego' + stat
if stat == 'OK' and len(DTest) == 0:
    stat = 'BR DK'


# -------------------------------------------------------------------------------
# ---   INSERT DANYCH (1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    # wstawiamy plik do bazy
    SQL = "INSERT INTO rs_dowody_ksiegowe_pliki (firma_id, okres_id, dowod_id, nazwa_id, data, numer, dowod_plik) "
    SQL += "VALUES ('" + str(self.firma_id) + "','" + str(self.okres_id) + "',"
    SQL += "'" + str(Dowod) + "','" + str(Nazwa) + "','" + str(Data) + "','" + str(Numer) + "',"
    SQL += "'" + NazwaPliku + "');"
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
    if stat != 'OK':
        stat = 'Bd wykonania wstawienia pliku do bazy.' + stat

    if stat == 'OK':
        # pobranie dodanego numeru pliku umowy
        SQL = "SELECT max(plik_id) FROM rs_dowody_ksiegowe_pliki " + WHERE
        stat, DNum, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania numeru pliku umowy' + stat
    if stat == 'OK' and len(DNum) == 0:
        stat = 'PR DOD'

    if stat == 'OK':
        PlikId = str(DNum[0][0])

        # wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i poczenie klucza z obu tabel.
        SQL = "INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) "
        SQL += "VALUES ('" + self.firma_id + "','" + NazwaPliku + "','rs_dowody_ksiegowe_pliki',FALSE);"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd wstawiania pustego rekordu' + stat

    if stat == 'OK':
        SQL = "SELECT max(plik_id) FROM rs_pliki "
        SQL += "WHERE firma_id='" + self.firma_id + "' AND tabela='rs_dowody_ksiegowe_pliki';"
        stat, DNum, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania numeru pliku' + stat
    if stat == 'OK':
        NrPliku = str(DNum[0][0])
        # wrzucamy plik na serwer
        stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NrPliku, TrescPliku)
    if stat == 'OK':
        SQL = "UPDATE rs_dowody_ksiegowe_pliki SET "
        SQL += "nr_pliku=" + NrPliku + WHERE + " AND plik_id=" + PlikId
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd przy dodawaniu pliku na serwer' + stat
    if stat == 'OK':
        #WS 2022-05-10
        SQL = "UPDATE rs_dowody_ksiegowe SET stan=CASE WHEN stan='M' THEN 'W' ELSE stan END WHERE "
        SQL += "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd przy aktualizacji stanu dowodu' + stat

# -------------------------------------------------------------------------------
# ---   POBRANIE PLIKU Z SERWERA (2,6)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [2, 6]:
    SQL = "SELECT nr_pliku FROM rs_dowody_ksiegowe_pliki "
    SQL += WHERE + " AND plik_id=" + str(PlikId) + ";"
    stat, DPlik, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru pliku' + stat

    if stat == 'OK':
        if len(DPlik) == 0:
            stat = "Brak pliku o numerze " + str(PlikId) + " w dowodzie: "
            stat += str(Dowod) + "/" + str(Nazwa) + "/" + str(Data) + "/" + str(Numer)

# -------------------------------------------------------------------------------
# ---   PLIK POBIERANY DO KLIENTA (2)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 2:
    stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, DPlik[0][0])
    dane = [Tresc]


# -------------------------------------------------------------------------------
# ---   DELETE DANYCH (6)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    test = """select 1 from rs_wf_zagadnienia_pliki where nr_pliku = %s"""
    args = [DPlik[0][0]]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(test, args))
    stat, plk, dump, dump = self.PolSQL.Execute(test, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd szukania pliku w zagadnieniach: " + stat
    elif len(plk)>0:
        stat = "Plik zosta przepisany z zagadnienia. Mona go usun w przepywie dokumentw."
    if stat == 'OK':
        #WS 2022-05-11
        SQL = "DELETE FROM rs_dowody_ksiegowe_pliki WHERE plik_id="+str(PlikId)+";"
        SQL += "DELETE FROM rs_pliki WHERE plik_id="+str(DPlik[0][0])+";"
        # SQL = "DELETE FROM rs_pliki WHERE plik_id=(SELECT nr_pliku from "
        # SQL += "rs_dowody_ksiegowe_pliki where plik_id='"+str(PlikId)+"');"
        # SQL += "DELETE FROM rs_dowody_ksiegowe_pliki WHERE plik_id='" + str(PlikId) + "';"
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd przy usuwaniu pliku' + stat
    if stat == 'OK':
        #WS 2022-05-10
        SQL = "UPDATE rs_dowody_ksiegowe SET stan=CASE WHEN stan='M' THEN 'W' ELSE stan END WHERE "
        SQL += "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd przy aktualizacji stanu dowodu' + stat

    if stat == 'OK':
        stat = fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow, DPlik[0][0])

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5 -select, 6 -delete)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 5, 6]:
    SQL = "SELECT plik_id, dowod_plik FROM rs_dowody_ksiegowe_pliki " + WHERE
    stat, dane, wyn1, tr = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd przy pobieraniu danych' + stat
