# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_pom.py
# Purpose:     funkcje wspomagajce prace na dowodach ksigowych
# Author:      Micha Raburski
# Created:     2013/02/19
# RCS-ID:      $Id: fs_dowody_ksiegowe_pom.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-04-04 Mariusz Rajfura (6755) wielokrotna proba zablokowania stanow kont przy zamykaniu G->Z
# 2016-10-06 Piotr Witkowski (10049) Problemy z zamykaniem dowodw ksigowych
# 2016-10-20 Piotr Witkowski (10023) 2215-01-28 jako data operacji w rs_operacje w SPC
# 2018-03-20 Aleksander Bargie 10018 - zabezpieczenie przed zachodzcymi na siebie okresami ksigowymi
# 2018-07-03 Jan Raburski (11133) Zapisywanie kwoty VAT do platnosci
# 2018-08-27 Aleksander Bargie 11195 Lakman - blad zamykania dowodu ksiegowego
# 2019-08-03 Jan Raburski (11578) Ustawienie czy_mpp jeli do zaplaty > 15 tys. i termin platnosci >= 2019-11-01 (z W na G)
# 2019-10-15 Aleksander Bargie (11681) Zmiany w zamykaniu faktur i korekt ze wzgldu na mpp
# 2020-04-14 Aleksander Bargie (11933) Kompania - problem z zamkniciem dowodu ksigowego
# 2022-05-10 Wojciech Skowron (13004) Nowy stan 'M'
# 2023-06-30 Aleksander Bargie (13473) zmiany w sprawdzaniu pary kontrahent - dokument
# 2023-08-01 Aleksander Bargie (13499) Sprawdzanie pary Kontrahent/Dokument w dowodach ksigowych ograniczy do okresu obrachunkowego
# 2023-08-17 Aleksander Bargie (13517) WF - bd podczas dodawania zagadnienia
# 2023-08-22 Wojciech Skowron   (13495) Poprawka w zapytaniu w SprawdzPareKontrahentDokument (tryb 'ZG')
# 2023-09-05 Aleksander Bargie (13534) Bd w SprawdzPareKontrahentDokument gdy utworzono DK z Zagadnienia, sprawdzane na etapie zagadnienia lub wczeniej

# FUNKCJE:

# FUNKCJA SPRAWDZAJCA ZGODNO CZY PARA KONTRAHENT/FAKTURA WYSTPUJE TYLKO NA TYM DOKUMENCIE
# SprawdzPareKontrahentFaktura(self,DowodDK,NazwaDK,DataDK,NumerDK,OkresDow,wyn1)

# FUNKCJA SPRAWDZAJCA ZGODNO POZYCJI I INFORMACJI O PROJEKTACH NA DOKUMENCIE
# SprawdzProjektyNaDokumencie(Firma,Okres,Dowod,Nazwa,Data,Nr,PolSQL)

# FUNKCJA ZAMYKAJCA DOWD KSIEGOWY Z W na G
# SprawdzDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,OkresDow='')

# FUNKCJA ZAMYKAJCA DOWD KSIEGOWY Z G na Z
# ZamknijDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,OkresDow='')

# FUNKCJA OTWIERAJCA DOWD KSIGOWY Z Z NA G
# OtworzDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,OkresDow=''):

# FUNKCJA SPRAWDZAJCA WYSTPOWANIE PARY KONTRAHENT - SYMBOL DOKUMENTU W SYSTEMIE
# SprawdzPareKontrahentDokument(self,Tryb, Kontrahent, NIP, Dokument, Klucze):


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

import time
import rsglobal
from funkcje import fs_rozrachunki_pom, fs_okresy_pom  #AB 2023-08-01


#-------------------------------------------------------------------------------
# FUNKCJA SPRAWDZAJCA ZGODNO CZY PARA KONTRAHENT/FAKTURA WYSTPUJE TYLKO NA TYM DOKUMENCIE
#-------------------------------------------------------------------------------

def SprawdzPareKontrahentFaktura(self,DowodDK,NazwaDK,DataDK,NumerDK,OkresDow,wyn1):
    # pobranie kontrahenta/faktury
    
    SQL="SELECT COALESCE(kontrahent_id,''),COALESCE(TRIM(symbol_dok),'')"
    SQL+=" FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' "
    SQL+=" AND okres_id='"+OkresDow+"' AND dowod_id='"+DowodDK+"'"
    SQL+=" AND nazwa_id='"+NazwaDK+"' AND data='"+DataDK+"' AND numer="+str(NumerDK)+";"
    stat,DDow,dump,dump = self.PolSQL.Execute(SQL,3)    
    if stat<>'OK':
        wyn1.append('Bd sprawdzenia kontrahenta/faktury dla dowodu: '+DowodDK.strip()+'/'+NazwaDK.strip()+'/'+DataDK+'/'+rsglobal.UsunKropkaZero(NumerDK)+' : '+stat)
        return wyn1
    
    if len(DDow)>0:
        if DDow[0][0]=='' or DDow[0][1]=='':
            return wyn1
            
        # sprawdzenie czy na innym dokumencie wystpuje ta para
        SQL="SELECT dowod_id||'/'||nazwa_id||'/'||data||'/'||numer FROM rs_dowody_ksiegowe WHERE firma_id = '"+self.firma_id+"' "
        SQL+=" AND okres_id='"+OkresDow+"' AND kontrahent_id = '"+rsglobal.Dekoduj(DDow[0][0])+"' AND UPPER(TRIM(symbol_dok))='"+rsglobal.Dekoduj(DDow[0][1].upper())+"'"
        SQL+=" AND NOT (dowod_id='"+DowodDK+"' AND nazwa_id='"+NazwaDK+"' AND data='"+DataDK+"' AND numer="+str(NumerDK)+");"
        stat,DPar,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            wyn1.append('Bd sprawdzenia par kontrahenta/faktury dla dowodu: '+DowodDK.strip()+'/'+NazwaDK.strip()+'/'+DataDK+'/'+rsglobal.UsunKropkaZero(NumerDK)+' : '+stat)
            return wyn1
        if stat=='OK':
            if len(DPar) >0:
                for poz in DPar:
                    wyn1.append('Ta sama para kontrahent/faktura dla dowodu: '+DowodDK.strip()+'/'+NazwaDK.strip()+'/'+DataDK+'/'+rsglobal.UsunKropkaZero(NumerDK)+' oraz '+poz[0])
        
    return wyn1
    
#-------------------------------------------------------------------------------
# FUNKCJA SPRAWDZAJCA ZGODNO POZYCJI I INFORMACJI O PROJEKTACH NA DOKUMENCIE
#-------------------------------------------------------------------------------

def SprawdzProjektyNaDokumencie(Firma,Okres,Dowod,Nazwa,Data,Nr,PolSQL):
    from funkcje import fs_dowody_ksiegowe_projekty_tworzenie

    debl=10

    Firma=rsglobal.Dekoduj(Firma)
    Okres=rsglobal.Dekoduj(Okres)
    Dowod=rsglobal.Dekoduj(Dowod)
    Nazwa=rsglobal.Dekoduj(Nazwa)
    Data=rsglobal.Dekoduj(Data)
    
    # prba utworzenia pozycji w projektach jeli ich tam nie ma
    stat=fs_dowody_ksiegowe_projekty_tworzenie.StworzPozycjeProjektoweWDowodzieKsiegowym(Firma,Okres,Dowod,Nazwa,Data,Nr,PolSQL)
    if stat != 'OK':
        return stat

    # sprawdzenie czy nie jest wczone "bez_projektow" na dokumencie
    SQL ="SELECT bez_projektow FROM rs_dowody_ksiegowe WHERE firma_id='"+Firma+"' "
    SQL+=" AND okres_id='"+Okres+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
    SQL+=" AND data='"+Data+"' AND numer="+str(Nr)+";"
    stat,d,dump,dump = PolSQL.Execute(SQL,3)    
    if stat != 'OK':
        return 'Bd pobrania danych z dowodu ksigowego : '+stat
    elif len(d) == 0:
        return 'Brak podanego dowodu ksigowego '
    elif d[0][0]:
        return 'OK'
    

    NrDok=Dowod.strip()+"/"+Nazwa.strip()+"/"+Data.strip()+"/"+str(Nr)
    # sprawdzenie poprawnoci danych z rs_dowody_ksiegowe_projekty
    SQL="SELECT projekty_podzial,zespol_kont FROM rs_wzory_dekretacji WHERE firma_id='"+Firma+"'"
    SQL+=" AND okres_id='"+Okres+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    stat,DaneWzoru,dump,dump = PolSQL.Execute(SQL,3)
    if stat=='OK':                    
        if not DaneWzoru[0][0]:
            return "OK"
        
        ZespolKont=rsglobal.Dekoduj(DaneWzoru[0][1]).strip()
        
        # suma wn z pozycji
        SQL="SELECT TRIM(COALESCE(dp.projekt_wn,dk.projekt_id,'')),SUM(dp.kwota_wn)"
        SQL+=" FROM rs_dowody_ksiegowe_pozycje dp "
        SQL+=" INNER JOIN rs_dowody_ksiegowe dk USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
        SQL+=" WHERE dp.firma_id='"+Firma+"' AND dp.okres_id='"+Okres+"' "
        SQL+=" AND dp.dowod_id='"+Dowod+"' AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
                #AB 14.04.2020r.
        SQL+=" AND TRIM(dp.konto_wn) != '' AND POSITION(SUBSTRING(dp.konto_wn FROM 1 FOR 1) IN '"+ZespolKont+"')>0 "
        SQL+=" GROUP BY COALESCE(dp.projekt_wn,dk.projekt_id,'')"
        stat,DanePozWn,dump,dump = PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)

    if stat=='OK':
        # suma ma z pozycji
        SQL="SELECT TRIM(COALESCE(dp.projekt_ma,dk.projekt_id,'')),SUM(dp.kwota_ma)"
        SQL+=" FROM rs_dowody_ksiegowe_pozycje dp "
        SQL+=" INNER JOIN rs_dowody_ksiegowe dk USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
        SQL+=" WHERE dp.firma_id='"+Firma+"' AND dp.okres_id='"+Okres+"' "
        SQL+=" AND dp.dowod_id='"+Dowod+"' AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Nr)
                #AB 14.04.2020r.
        SQL+=" AND TRIM(dp.konto_ma) != ''AND POSITION(SUBSTRING(dp.konto_ma FROM 1 FOR 1) IN '"+ZespolKont+"')>0 "
        SQL+=" GROUP BY COALESCE(dp.projekt_ma,dk.projekt_id,'')"
        stat,DanePozMa,dump,dump = PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)
        
    # stworzenie sownika z projektami w ktrym bdzie wida wszystkie dane - z pozycji i z danymi z projektami
    # klucz to projekt a pozycja to kwota_wn z pozycji,kwota ma z pozycji, kwota wn z danych projektu i kwota ma z danych projektu
    if stat=='OK':    
        SProj={}
        for poz in DanePozWn:
            if poz[1]<>0:
                if poz[0]=='':
                    rsglobal.ZapiszDoLogow(poz)
                    return "Dokument "+NrDok+". S pozycje pasujce do zespou kont z nieprzypisanym projektem po stronie wn"
                
                if not poz[0] in SProj:
                    SProj[poz[0]]=[poz[1],0,0,0]
                else:
                    SProj[poz[0]][0]=SProj[poz[0]][0]+poz[1]
                    
        for poz in DanePozMa:
            if poz[1]<>0:
                if poz[0]=='':
                    rsglobal.ZapiszDoLogow(poz)                                                                     #AB 14.04.2020r.
                    return "Dokument "+NrDok+". S pozycje pasujce do zespou kont z nieprzypisanym projektem po stronie ma"
                
                if not poz[0] in SProj:
                    SProj[poz[0]]=[0,poz[1],0,0]
                else:
                    SProj[poz[0]][1]=SProj[poz[0]][1]+poz[1]
                
        # suma z projektow        
        SQL="SELECT TRIM(projekt_id),SUM(kwota_wn),SUM(kwota_ma) FROM rs_dowody_ksiegowe_projekty"
        SQL+=" WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"' "
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Nr)
        SQL+=" GROUP By projekt_id;"
        stat,DaneProj,dump,dump = PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        for poz in DaneProj:
            if poz[1]<>0 or poz[2]<>0:
                if poz[0]=='':
                    return "Dokument "+NrDok+". S pozycje projektw z niewpisanym projektem"
                
                if not poz[0] in SProj:
                    return "Dokument "+NrDok+". Na danych projektw jest umieszczony projekt "+poz[0].strip()+", ktrego nie ma na pozycjach"
                else:
                    SProj[poz[0]][2]=SProj[poz[0]][2]+poz[1]
                    SProj[poz[0]][3]=SProj[poz[0]][3]+poz[2]
    
        #mamy zagregowane dane - teraz sprawdzamy czy wszystko si zgadza
        
        for kl in SProj:
            if SProj[kl][0]<>SProj[kl][2]:
                return "Dokument "+NrDok+". Dla projektu "+kl.strip()+" rne kwoty wn. Pozycje :"+str(SProj[kl][0])+" i dane projektw :"+str(SProj[kl][2])
            
            if SProj[kl][1]<>SProj[kl][3]:
                return "Dokument "+NrDok+". Dla projektu "+kl.strip()+" rne kwoty ma. Pozycje :"+str(SProj[kl][1])+" i dane projektw :"+str(SProj[kl][3])
      
    return stat

#-------------------------------------------------------------------------------
# FUNKCJA ZAMYKAJCA DOWD KSIEGOWY Z M,W na G
#-------------------------------------------------------------------------------

def SprawdzDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,OkresDow=''):
    LBledy = []
    SDatyKsieg = {}
    SBilansowaWn = 0
    SBilansowaMa = 0
    DoZaplaty = 0
    
    if OkresDow=='':
        OkresDow=self.okres_id
    FiltrDok="firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    FiltrDok+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)

    # pobranie typu dokumentu ze wzoru dekretacji
    SQL="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,DaneWz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return ['Bd pobierania wzoru dekretacji :'+stat]

    if len(DaneWz)==0:
        return ['Brak podanego wzoru dekretacji :'+stat]
    
    TypWzoru=DaneWz[0][0]
    
    # pobranie nagwka dowodu i #JR czy_moo
    SQL="SELECT stan, COALESCE(czy_mpp, False), COALESCE(termin_plat,'2019-10-30') >= '2019-11-01' FROM rs_dowody_ksiegowe WHERE "+FiltrDok+" FOR UPDATE NOWAIT;"
    stat,DaneN,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return ['Bd pobierania nagwka dowodu :'+stat]
    
    if len(DaneN)<>1:
        return ["Niepoprawne identyfikatory dowodu."]

    # sprawdzenie stanu dowodu

    CzyMPP = DaneN[0][1]
    CzyListopad = DaneN[0][2]
    StanDow = DaneN[0][0]
    if StanDow == "G":
        return ["Dowd ju jest sprawdzony"]
    #WS 2022-05-10
    elif StanDow not in ("M","W"):
        return ["Nie mona zamkn dowodu - dowd nie jest w stanie W lub M"]
    # elif StanDow != "W":
    #     return ["Nie mona zamkn dowodu - dowd nie jest w stanie W"]

    #PW 2016-10-26 sprawdzenie BO dla biecego okresu
    CzyJestBO=True
    sqlBO = "SELECT 1 FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' AND dowod_id = 'BO';"
    stat,DaneP,dump,dump = self.PolSQL.Execute(sqlBO,3)
    if stat<>'OK':
        return ['Bd pobierania danych o BO z biecego okresu: '+stat]
    elif len(DaneP)==0:
        CzyJestBO = False

    #WS 2022-05-10 - usuwanie zerowych pozycji
    SQLUsuw = "DELETE FROM rs_dowody_ksiegowe_pozycje"
    SQLUsuw += " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    SQLUsuw += " AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
    SQLUsuw += " AND kwota_wn=0 AND kwota_ma=0 AND kwota_vat_wn=0 AND kwota_vat_ma=0 AND NOT zamkniecie_kregu;"
    stat,dump,dump,dump = self.PolSQL.Execute(SQLUsuw, 1)
    if stat != 'OK':
        return ['Bd usuwania pozycji z zerowymi kwotami: '+stat]

    #AB sprawdzenie, czy nie ma pozycji z dat ksigowania zawart w 2 okresach ksigowych
    #AB 2018-03-26 podmiana parametrw ze staych na zmienne
    #AB 2018-03-27 usuniecie \n
    sqlOkr  = "SELECT dowod_id ||' '|| nazwa_id ||'/'|| \"data\" ||'/'|| numer||' nr poz: '||nr_poz||' nr ppoz: '||nr_ppoz, count(o.okres_id) "
    sqlOkr += "FROM rs_dowody_ksiegowe_pozycje dp LEFT OUTER JOIN rs_definicje_okresow o "
    sqlOkr += "ON (dp.firma_id=o.firma_id AND o.data_od <= dp.data_ksieg_kosztow AND o.data_do>=dp.data_ksieg_kosztow) "
    sqlOkr += "WHERE dp.firma_id='"+self.firma_id+"' AND dp.okres_id='"+OkresDow+"' "
    sqlOkr += "AND dp.dowod_id='"+Dowod+"' AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer=" + str(Numer) + " "
    sqlOkr += "GROUP BY dp.firma_id, dp.okres_id, dowod_id, nazwa_id, \"data\", numer, nr_poz, nr_ppoz "
    sqlOkr += "HAVING count(o.okres_id) > 1;"
    stat, okresy, dump, dump = self.PolSQL.Execute(sqlOkr, 3)

    if stat != 'OK':
        return ['Bd sprawdzania okresw ksigowych dla pozycji dowodu: '+stat]
    elif len(okresy) > 0:
        return ['Istniej zachodzce na siebie okresy ksigowe dla daty ksig. kosztw dowodu: ' + rsglobal.Dekoduj(okresy[0][0])]

    # pobranie pozycji dowodu  
    SQLPoz= "SELECT dp.nr_poz,dp.nr_ppoz,COALESCE(dp.data_ksieg_kosztow::TEXT,'')," # 0-2
    SQLPoz+="TRIM(COALESCE(dp.konto_wn,'')),TRIM(COALESCE(dp.konto_ma,''))," # 3-4
    SQLPoz+="TRIM(COALESCE(dp.konto_vat_wn,'')),TRIM(COALESCE(dp.konto_vat_ma,''))," #5-6
    SQLPoz+="COALESCE(dp.tresc_wn,''),COALESCE(dp.tresc_ma,'')," # 7-8
    SQLPoz+="COALESCE(dp.kwota_wn,0),COALESCE(dp.kwota_ma,0)," # 9-10
    SQLPoz+="COALESCE(dp.kwota_vat_wn,0),COALESCE(dp.kwota_vat_ma,0), " #11-12
    SQLPoz+="COALESCE(dp.kurs_wn,0),COALESCE(dp.kurs_ma,0)," #13-14
    SQLPoz+="COALESCE(dp.kwota_wal_wn,0),COALESCE(dp.kwota_wal_ma,0), " #15-16
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,'"+OkresDow+"',COALESCE(dp.konto_wn,''))," # 17
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,'"+OkresDow+"',COALESCE(dp.konto_ma,''))," # 18
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,'"+OkresDow+"',COALESCE(dp.konto_vat_wn,''))," # 19
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,'"+OkresDow+"',COALESCE(dp.konto_vat_ma,''))," #20
    SQLPoz+="COALESCE(stawka_vat_wn,'00'),COALESCE(stawka_vat_ma,'00')," #21-22
    SQLPoz+="dp.zamkniecie_kregu,dp.sposob_rozl,COALESCE(o.okres_id,'')," # 23-25
    SQLPoz+="CASE WHEN om.zamkniety THEN 'True' WHEN NOT om.zamkniety THEN 'False' ELSE '' END," # 26
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,COALESCE(o.okres_id,''),COALESCE(dp.konto_wn,''))," # 27
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,COALESCE(o.okres_id,''),COALESCE(dp.konto_ma,''))," # 28
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,COALESCE(o.okres_id,''),COALESCE(dp.konto_vat_wn,''))," # 29
    SQLPoz+="rsf_podaj_parametry_konta(dp.firma_id,COALESCE(o.okres_id,''),COALESCE(dp.konto_vat_ma,''))," #30
    SQLPoz+="COALESCE(dp.waluta_wn,''),COALESCE(dp.waluta_ma,'')" # 31-32
    SQLPoz+=" FROM rs_dowody_ksiegowe_pozycje dp LEFT OUTER JOIN rs_definicje_okresow o " 
    SQLPoz+=" ON (dp.firma_id=o.firma_id AND o.data_od <= dp.data_ksieg_kosztow AND o.data_do>=dp.data_ksieg_kosztow) "
    SQLPoz+=" LEFT OUTER JOIN rs_definicje_okresow_miesiace om ON (o.firma_id=om.firma_id AND o.okres_id=om.okres_id AND "
    SQLPoz+=" om.rok::INT=EXTRACT(YEAR FROM dp.data_ksieg_kosztow) AND om.miesiac::INT=EXTRACT(MONTH FROM dp.data_ksieg_kosztow)) "
    SQLPoz+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.okres_id='"+OkresDow+"'"
    SQLPoz+=" AND dp.dowod_id='"+Dowod+"' AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Numer)
    SQLPoz+=" ORDER BY dp.nr_poz,dp.nr_ppoz;"
    stat,DaneP,dump,dump = self.PolSQL.Execute(SQLPoz,3)
    if stat<>'OK':
        return ['Bd pobierania danych pozycji dowodu: '+stat]
    
    if len(DaneP)==0:
        return ["Brak pozycji na dowodzie ksigowym"]

    # sprawdzenie daty wystawienia i wpywu w dowodach ksigowych
    SQL = "SELECT COALESCE(data_wyst<=data_wplywu,'T'),COALESCE(data_wyst<=data,'T') FROM rs_dowody_ksiegowe WHERE " + FiltrDok + ";"
    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)

    if stat != 'OK':
        return ["Bdy pobrania daty wystawienia i wpywu dowodu ksigowego:"+stat]
    else:
        if len(d) != 1:
            return ["Niepoprawne identyfikatory dowodu."]

        # sprawdzenie poprawnoci daty
        if d[0][0] == False:
            return ["Data wystawienia dokumentu ksigowego jest wiksza od daty wpywu tego dokumentu."]
        if d[0][1] == False:
            return ["Data wystawienia dokumentu ksigowego jest wiksza od daty dokumentu."]


    # sprawdzenie daty wystawienia i wpywu w pozycjach dowodu ksigowego
    SQL = "SELECT COALESCE(data_wyst<=data_wplywu,'T'), COALESCE(data_wyst<=data,'T'),nr_poz,nr_ppoz "
    SQL +="FROM rs_dowody_ksiegowe_pozycje WHERE " + FiltrDok + ";"
    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return ["Bdy pobrania daty wystawienia i wpywu pozycji dowodu ksigowego:" + stat]
    else:
        if len(d) == 0:
            return ["Brak pozycji na dowodzie ksigowym"]
        for i in range(len(d)):
            # sprawdzenie poprawnoci daty
            if d[i][0] == False:
                return ["Data wystawienia pozycji dokumentu ksigowego jest wiksza od daty wpywu tej pozycji. Dotyczy pozycji:"+str(int(d[i][2]))+"/"+str(int(d[i][2]))+"."]
            if d[i][1] == False:
                return ["Data wystawienia pozycji dokumentu ksigowego jest wiksza od daty dokumentu. Dotyczy pozycji:"+str(int(d[i][2]))+"/"+str(int(d[i][2]))+"."]


    if Dowod in ["BO","BK"]:
        #--- bilans otwarcia i korekta bilansu
        if Dowod == "BO":
            # BO moe by tylko na dat od okresu
            SQL="SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' ;" 
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                return ['Bd pobierania daty z definicji okresw :'+stat]
            
            if Data!=DTest[0][0]:
                SQL="UPDATE rs_dowody_ksiegowe SET data='"+DTest[0][0]+"' WHERE "+FiltrDok
                return ["Uwaga: zostaa zmieniona data dowodu BO - konieczna ponowna kontrola."]
            
        # Posumowanie kont syntetnycznych i analitycznych w Sowniku Kont Syntetnycznych
        # klucz to konto a wynik to (caa syntetyka wn, caa syntetyka ma, caa analityka wn, caa analityka ma,
        # czy syntetyka czciowa, klucz poz syntetyki wn, syntetyki ma, analityki wn, analityki ma
        SKontSynt={}
        for poz in DaneP:
            PozD=str(int(poz[0]))
            PPozD=str(int(poz[1]))
            
            KontoWn=poz[3]
            KwotaWn=poz[9]
            KluczWn=poz[3].split('-')[0]
            NazwaWn=eval(poz[17])[1]
            CzescioweWn=not eval(poz[17])[2]
            DoBilansuWn=eval(poz[17])[6]
            KontoMa=poz[4]
            KwotaMa=poz[10]
            KluczMa=poz[4].split('-')[0]
            NazwaMa=eval(poz[18])[1]
            CzescioweMa=not eval(poz[18])[2]
            DoBilansuMa=eval(poz[18])[6]

            # upewniamy si, e odpowiednie klucze s zainicjowane
            if not KluczWn in SKontSynt:
                SKontSynt[KluczWn]=[0,0,0,0,False,'','','','']
            if not KluczMa in SKontSynt:
                SKontSynt[KluczMa]=[0,0,0,0,False,'','','','']
            
            # sprawdzenie niewypenienia daty ksigowania kosztw
            if poz[2] <>'':
                LBledy.append("W pozycji "+PozD+"/"+PPozD+" jest wpisana data ksigowania kosztw")

            # sprawdzamy czy konta s dobrze wypenione
            if KwotaWn!=0 and KontoWn=='':
                LBledy.append("Brak konta Wn dla pozycji "+PozD+"/"+PPozD)
                
            if KwotaMa!=0 and KontoMa=='':
                LBledy.append("Brak konta Ma dla pozycji "+PozD+"/"+PPozD)
            
            if KontoWn<>'':
                if NazwaWn=='':
                    LBledy.append("Niepoprawna definicja konta Wn dla pozycji "+PozD+"/"+PPozD)
                
                if DoBilansuWn == 'N':
                    LBledy.append("Konto Wn nie powinno wchodzi do bilansu dla pozycji "+PozD+"/"+PPozD)
                    
                # konto wn syntetyczne
                if KontoWn.find('-') == -1:
                    if not CzescioweWn:
                        SKontSynt[KluczWn][4]=True
                    SKontSynt[KluczWn][0]+=KwotaWn
                    if SKontSynt[KluczWn][5]=='':
                        SKontSynt[KluczWn][5]=PozD+"/"+PPozD
                    
                # konto wn analityczne
                else:
                    if KwotaWn==0:
                        LBledy.append("Brak kwoty Wn dla pozycji "+PozD+"/"+PPozD)
                        
                    if CzescioweWn:
                        LBledy.append("Konto Wn "+KontoWn+" dla pozycji "+PozD+"/"+PPozD+"  nie jest ksigowane.")
                    else:
                        SKontSynt[KluczWn][2]+=KwotaWn
                        if SKontSynt[KluczWn][7]=='':
                            SKontSynt[KluczWn][7]=PozD+"/"+PPozD
                
            if KontoMa<>'':
                if NazwaMa=='':
                    LBledy.append("Niepoprawna definicja konta Ma dla pozycji "+PozD+"/"+PPozD)
                
                if DoBilansuMa == 'N':
                    LBledy.append("Konto Ma nie powinno wchodzi do bilansu dla pozycji "+PozD+"/"+PPozD)
                    
                # konto ma syntetyczne
                if KontoMa.find('-') == -1:
                    if not CzescioweMa:
                        SKontSynt[KluczMa][4]=True
                    SKontSynt[KluczMa][1]+=KwotaMa
                    if SKontSynt[KluczMa][6]=='':
                        SKontSynt[KluczMa][6]=PozD+"/"+PPozD
                        
                # konto ma analityczne
                else:
                    if KwotaMa==0:
                        LBledy.append("Brak kwoty Ma dla pozycji "+PozD+"/"+PPozD)
                        
                    if CzescioweMa:
                        LBledy.append("Konto Ma "+KontoMa+" dla pozycji "+PozD+"/"+PPozD+"  nie jest ksigowane.")
                    else:
                        SKontSynt[KluczMa][3]+=KwotaMa
                        if SKontSynt[KluczMa][8]=='':
                            SKontSynt[KluczMa][8]=PozD+"/"+PPozD
            
            # zapis sumy bilansowej wn i ma do porwnania 
            if KontoWn.find('-') == -1:
                if not eval(poz[17])[4]:
                    SBilansowaWn+=KwotaWn
                    
            if poz[4].find('-') == -1:
                if not eval(poz[18])[4]:
                    SBilansowaMa+=KwotaMa
        
        # analiza poprawnoci sum bilansowych
        if Dowod == "BO":
            if SBilansowaWn==0:
                LBledy.append("Brak zapisw syntetyki po stronie Wn")
            if SBilansowaMa==0:
                LBledy.append("Brak zapisw syntetyki po stronie Ma")
        if rsglobal.RSRound(SBilansowaWn,4)<>rsglobal.RSRound(SBilansowaMa,4):
            LBledy.append("Kwota Syntetyki Wn = "+str(SBilansowaWn)+", Kwota Syntetyki Ma = "+str(SBilansowaMa)+", rnica =  "+str(rsglobal.RSRound(SBilansowaWn-SBilansowaMa,4)))

        # badanie poprawnoci kolejnych kont syntetycznych
        KluczeKont=SKontSynt.keys()
        KluczeKont.sort()

        for kl in KluczeKont:
            DKonta=SKontSynt[kl]
            # sprawdzenie kont syntetycznych bez analityki
            if DKonta[4]:
                # jeli jest analityka to le
                if DKonta[0]<>0 and DKonta[2]<>0:
                    LBledy.append("Wystpuje analityka dla konta Wn "+kl+" dla pozycji "+DKonta[5])         
                if DKonta[1]<>0 and DKonta[3]<>0:
                    LBledy.append("Wystpuje analityka dla konta Ma "+kl+" dla pozycji "+DKonta[6])         
                
            #sprawdzenie pozostaych kont
            else:
                if DKonta[0]==0 and DKonta[2]<>0:
                    LBledy.append("Brak zapisu w syntetyce dla kont Wn z syntetyk "+kl+" pozycja "+DKonta[7])         
                elif rsglobal.RSRound(DKonta[0],4)<>rsglobal.RSRound(DKonta[2],4):
                    LBledy.append("Niezgodna suma syntetyki i analityki dla kont z syntetyk Wn "+kl+" o "+str(rsglobal.RSRound(DKonta[0]-DKonta[2],4))+" pozycja "+DKonta[5])         

                if DKonta[1]==0 and DKonta[3]<>0:
                    LBledy.append("Brak zapisu w syntetyce dla kont Ma z syntetyk "+kl+" pozycja "+DKonta[8])         
                elif rsglobal.RSRound(DKonta[1],4)<>rsglobal.RSRound(DKonta[3],4):
                    LBledy.append("Niezgodna suma syntetyki i analityki dla kont z syntetyk Ma "+kl+" o "+str(rsglobal.RSRound(DKonta[1]-DKonta[3],4))+" pozycja "+DKonta[6])         
                    
        if len(LBledy)>0:
            return LBledy
        
        SQL="UPDATE rs_dowody_ksiegowe SET stan='G', kwota_wn="+str(SBilansowaWn)+", kwota_ma="+str(SBilansowaWn)
        SQL+=" WHERE "+FiltrDok
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        return [stat]


    #-------------------------------------------
    # pozostale dowody
    #-------------------------------------------

    #policzenie sumy potencjalnych 500
    LDoKregu={}
    for w in DaneP:
        # jeli nie jest to pozycja z zamknicia krgu
        if not w[23]:
            # jeli konto wn wypenione
            if w[3]<>'':
                # jeli kontown zaczyna si na 5
                if w[3][0]=="5":
                    # jeli pusta data ksigowania kosztw
                    if w[2]=='':
                        DataKlucz=Data
                    else:
                        DataKlucz=w[2]
                    # dodajemy kwot wn
                    if DataKlucz in LDoKregu: 
                        LDoKregu[DataKlucz]+=w[9]
                    else:
                        LDoKregu[DataKlucz]=w[9]

    SQLKrag=""
    Filtr="firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
    #zapisanie kwot do pozycji zamykania krgu  
    KlZam=LDoKregu.keys()
    KlZam.sort()
    
    if LDoKregu != {}:
        for w in DaneP:
            # jeli pozycja z zamknicia krgu
            if w[23]:
                Lp=1
                for kl in KlZam:
                    # jeli data zamknicia rwna dacie dowodu
                    if kl==Data:
                        SQLKrag+="UPDATE rs_dowody_ksiegowe_pozycje SET kwota_wn="+str(LDoKregu[kl])+",kwota_wal_wn="+str(LDoKregu[kl])
                        SQLKrag+=", kwota_ma="+str(LDoKregu[kl])+", kwota_wal_ma="+str(LDoKregu[kl])+" WHERE "+Filtr+" AND nr_poz="+str(w[0])+" AND nr_ppoz="+str(w[1])+";"
                    # w przeciwnym przypadku
                    else:
                        SQLKrag+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                        SQLKrag+="nr_poz,nr_ppoz,nr_pozw,symbol_dok,data_wyst,kontrahent_id,konto_wn,konto_vat_wn,"
                        SQLKrag+="stawka_vat_wn,tresc_wn,sposob_rozl,konto_ma,konto_vat_ma,stawka_vat_ma,tresc_ma,"
                        SQLKrag+="waluta_wn,waluta_ma,projekt_wn,projekt_ma,zamkniecie_kregu,pobierac_na_rejestr,"
                        SQLKrag+="data_ksieg_kosztow,kwota_wn,kwota_ma,kwota_wal_wn,kwota_wal_ma) "
                        SQLKrag+=" SELECT firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                        SQLKrag+="nr_poz,"+str(Lp)+",nr_pozw,symbol_dok,data_wyst,kontrahent_id,konto_wn,konto_vat_wn,"
                        SQLKrag+="stawka_vat_wn,tresc_wn,sposob_rozl,konto_ma,konto_vat_ma,stawka_vat_ma,tresc_ma,"
                        SQLKrag+="waluta_wn,waluta_ma,projekt_wn,projekt_ma,zamkniecie_kregu,pobierac_na_rejestr,"
                        SQLKrag+="\'"+kl+"\',"+str(LDoKregu[kl])+","+str(LDoKregu[kl])+","+str(LDoKregu[kl])+","+str(LDoKregu[kl])
                        SQLKrag+=" FROM rs_dowody_ksiegowe_pozycje WHERE "+Filtr+" AND nr_poz="+str(w[0])+" AND nr_ppoz="+str(w[1])+";"
                        Lp=Lp+1
        
                if not Data in KlZam:
                    SQLKrag+="DELETE FROM rs_dowody_ksiegowe_pozycje WHERE "+Filtr+" AND nr_poz="+str(w[0])+" AND nr_ppoz="+str(w[1])+";"

    if SQLKrag <>"":
        # ponowne pobranie pozycji po zmianie krgu
        stat,dump,dump,dump=self.PolSQL.Execute(SQLKrag,1)
        if stat<>'OK':
            return ['Bd uzupeniania krgu : '+stat]
        
        stat,DaneP,dump,dump = self.PolSQL.Execute(SQLPoz,3)
        if stat<>'OK':
            return ['Bd ponownego pobierania pozycji : '+stat]

        if len(DaneP)==0:
            return ["Brak ponownie pobranych pozycji dowodu."]
    
    
    # sprawdzenie sum dowodu, poprawnoci kont itp

    # deklaracja zmiennych sucych do uwzglednienia dziwnego rozliczania sposobu rozliczenia vat : "D"
    CzyD=False
    SumaD=0
    VatD=0
    StawkaD=0

    # deklaracja zmiennych sucych do uwzglednienia dziwnego rozliczania sposobu rozliczenia vat : "M"
    CzyMieszany=False
    
    PozP=0
    PozK=0

    #ptla po pozycjach
    for w in DaneP:
        Poz=str(int(w[0]))
        PPoz=str(int(w[1]))
        KontoWn=w[3]
        KontoMa=w[4]
        KontoVatWn=w[5]
        KontoVatMa=w[6]
        KwotaWn=w[9]
        KwotaMa=w[10]
        KwotaVatWn=w[11]
        KwotaVatMa=w[12]
        StVatWn=w[21]
        if not StVatWn in self.ListaStawekZn:
            StVatWn=int(StVatWn)
        else:
            StVatWn=0
        StVatMa=w[22]
        if not StVatMa in self.ListaStawekZn:
            StVatMa=int(StVatMa)
        else:
            StVatMa=0
 
        TrescWn=w[7]
        TrescMa=w[8]
        SposRozl=w[24]

        DataKsiegK = w[2]
        
        if SposRozl =='M':
            CzyMieszany=True
        
        # robimy sztuczk. Od momentu wystpienia typu M do koca dowodu cao jest analizowana jak pozycje dzielone typu D.
        # zmiana jest uwzgldniana tylko jeli zmienia si VAT, poza tym typy i kwoty si sumuj.
        if CzyMieszany:
            SposRozl = 'D'

        # metoda na policzenie danych zwizanych z vatem rozliczanym sposobem D
        if CzyD:
            if (StawkaD!=StVatWn) or (not CzyMieszany and ((SposRozl != "D") or (KwotaVatWn >0))):
                #sprawdzenie czy suma sie zgadza
                if abs(rsglobal.RSRound(SumaD*StawkaD*0.01,2)-rsglobal.RSRound(VatD,2)) > 1:
                    LBledy.append("Bdny vat :"+str(VatD)+" dla sumy netto :"+str(SumaD)+" i vatu : "+str(StawkaD)+"  w pozycjach "+str(PozP)+"-"+str(PozK))
                
            # wracamy do normalnego analizowania pozycji
            if SposRozl!= "D":
                CzyD=False
                SumaD=0
                VatD=0
                StawkaD=0
                PozP=0
                PozK=0

            #zmiana stawki vat przy "D" lub rozpoczcie nowego "D" przy starej stawce (kwotavatwn>0)
            elif (StawkaD!=StVatWn) or (not CzyMieszany and KwotaVatWn >0):
                SumaD=KwotaWn
                VatD=KwotaVatWn
                PozP=Poz
                PozK=Poz
                StawkaD=StVatWn
                CzyD=True
            else:
                #dodanie kolejnych kwot wn
                SumaD+=KwotaWn
                # jeli mieszane to dodajemy te VAT
                if CzyMieszany:
                    VatD+=KwotaVatWn
                PozK=Poz
        else:
            #pierwszy wiersz w "D" (lub "M")
            if SposRozl=="D":
                SumaD=KwotaWn
                VatD=KwotaVatWn
                PozP=Poz
                PozK=Poz
                StawkaD=StVatWn
                CzyD=True
                
        # sprawdzenie podstawowych danych na pozycji
        if KontoWn=="" and KontoMa=="" and KontoVatWn=="" and KontoVatMa=="":
            LBledy.append("Brak kont dla pozycji "+Poz+"/"+PPoz)
        if KontoWn=="" and KwotaWn!=0 :
            LBledy.append("Brak konta Wn dla pozycji "+Poz+"/"+PPoz)
        if KontoMa=="" and KwotaMa!=0 :
            LBledy.append("Brak konta Ma dla pozycji "+Poz+"/"+PPoz)
        if KontoVatWn=="" and KwotaVatWn!=0 :
            LBledy.append("Brak konta VAT Wn dla pozycji "+Poz+"/"+PPoz)
        if KontoVatMa=="" and KwotaVatMa!=0 :
            LBledy.append("Brak konta VAT Ma dla pozycji "+Poz+"/"+PPoz)

        # analiza konta wn
        if KontoWn<>"":
            if KwotaWn==0:
                LBledy.append("Brak kwoty Wn dla pozycji "+Poz+"/"+PPoz)
            if TrescWn=="":
                LBledy.append("Brak treci Wn dla pozycji "+Poz+"/"+PPoz)

            par = eval(w[17])
            if par[1] == '':
                LBledy.append("Konto Wn dla pozycji "+Poz+"/"+PPoz+" jest niepoprawne. ")
            elif not par[2]:
                LBledy.append("Konto Wn dla pozycji "+Poz+"/"+PPoz+" nie jest ksigowane. ")
            elif not par[4]:
                SBilansowaWn = rsglobal.RSRound(SBilansowaWn + KwotaWn ,4)

        # analiza konta ma
        if KontoMa<>"":
            if KwotaMa==0:
                LBledy.append("Brak kwoty Ma dla pozycji "+Poz+"/"+PPoz)
            if TrescMa=="":
                LBledy.append("Brak treci Ma dla pozycji "+Poz+"/"+PPoz)

            par = eval(w[18])
            if par[1] == '':
                LBledy.append("Konto Ma dla pozycji "+Poz+"/"+PPoz+" jest niepoprawne. ")
            elif not par[2]:
                LBledy.append("Konto Ma dla pozycji "+Poz+"/"+PPoz+" nie jest ksigowane.")
            elif not par[4]:
                SBilansowaMa = rsglobal.RSRound(SBilansowaMa + KwotaMa ,4)

        # analiza konta vat wn
        if KontoVatWn<>"":
            if KwotaVatWn==0:
                LBledy.append("Brak kwoty VAT Wn dla pozycji "+Poz+"/"+PPoz)
            par = eval(w[19])
            if par[1] == '':
                LBledy.append("Konto VAT Wn dla pozycji "+Poz+"/"+PPoz+" jest niepoprawne. ")
            elif not par[2]:
                LBledy.append("Konto VAT Wn dla pozycji "+Poz+"/"+PPoz+" nie jest ksigowane.")
            elif not par[4]:
                SBilansowaWn = rsglobal.RSRound( SBilansowaWn + KwotaVatWn ,4 )

            if SposRozl=='':
                LBledy.append("Brak sposobu rozliczenia VAT Wn dla pozycji "+Poz+"/"+PPoz)
            if StVatWn==0:
                LBledy.append("Niepoprawna stawka VAT Wn dla pozycji "+Poz+"/"+PPoz)
            elif not CzyD:
                Kw = abs(rsglobal.RSRound(KwotaWn * StVatWn *0.01 - KwotaVatWn, 4 ))
                if Kw > 1:
                    LBledy.append("Niezgodno kwoty Wn, stawki Vat i kwoty VAT o wicej ni 1 ("+str(Kw)+") dla pozycji "+Poz+"/"+PPoz)
                    
        # analiza konta vat ma
        if KontoVatMa<>"":
            if KwotaVatMa==0:
                LBledy.append("Brak kwoty VAT Ma dla pozycji "+Poz+"/"+PPoz)
            par = eval(w[20])
            if par[1] == '':
                LBledy.append("Konto VAT Ma dla pozycji "+Poz+"/"+PPoz+" jest niepoprawne. ")
            elif not par[2]:
                LBledy.append("Konto VAT Ma dla pozycji "+Poz+"/"+PPoz+" nie jest ksigowane.")
            elif not par[4]:
                SBilansowaMa = rsglobal.RSRound( SBilansowaMa + KwotaVatMa ,4 )

            if SposRozl=='':
                LBledy.append("Brak sposobu rozliczenia VAT Ma dla pozycji "+Poz+"/"+PPoz)
            if StVatMa==0:
                LBledy.append("Niepoprawna stawka VAT Ma dla pozycji "+Poz+"/"+PPoz)
            elif not CzyD:
                Kw = abs(rsglobal.RSRound(KwotaMa * StVatMa *0.01 - KwotaVatMa, 4 ))
                if Kw > 1:
                    LBledy.append("Niezgodno kwoty Ma, stawki Vat i kwoty VAT o wicej ni 1 ("+str(Kw)+") dla pozycji "+Poz+"/"+PPoz)

        # analiza danych kursu walutowego pozycji

        KursWn=w[13]
        KursMa=w[14]
        KwotaWalWn=w[15]
        KwotaWalMa=w[16]
        WalutaWn=w[31]
        WalutaMa=w[32]

        if WalutaWn=='':
            LBledy.append("Brak waluty Wn dla pozycji "+Poz+"/"+PPoz)
        elif TypWzoru != 'W':
            if WalutaWn=='PLN':
                if rsglobal.RSRound(KursWn,4)<>rsglobal.RSRound(1.0,4):
                    LBledy.append("Kurs waluty Wn dla PLN rny od 1.0000 dla pozycji "+Poz+"/"+PPoz)
                elif rsglobal.RSRound(KwotaWalWn,4)<>rsglobal.RSRound(KwotaWn,4) and TypWzoru != 'W':
                    LBledy.append("Kwota Wn rna od kwoty walutowej Wn (PLN) dla pozycji "+Poz+"/"+PPoz)
            else:
                Kw = abs(rsglobal.RSRound(KwotaWalWn * KursWn - KwotaWn, 4))
                if Kw > 1:
                    LBledy.append("Niezgodno kwoty Wn, kursu waluty i kwoty w walucie o wicej ni 1 ("+str(Kw)+") dla pozycji "+Poz+"/"+PPoz)

        if WalutaMa=='':
            LBledy.append("Brak waluty Ma dla pozycji "+Poz+"/"+PPoz)
        elif TypWzoru != 'W':
            if WalutaMa=='PLN':
                if rsglobal.RSRound(KursMa,4)<>rsglobal.RSRound(1.0,4):
                    LBledy.append("Kurs waluty Ma dla PLN rny od 1.0000 dla pozycji "+Poz+"/"+PPoz)
                elif rsglobal.RSRound(KwotaWalMa,4)<>rsglobal.RSRound(KwotaMa,4):
                    LBledy.append("Kwota Ma rna od kwoty walutowej Ma (PLN) dla pozycji "+Poz+"/"+PPoz)
            else:
                Kw = abs(rsglobal.RSRound(KwotaWalMa * KursMa - KwotaMa, 4))
                if Kw > 1:
                    LBledy.append("Niezgodno kwoty Ma, kursu waluty i kwoty w walucie o wicej ni 1 ("+str(Kw)+") dla pozycji "+Poz+"/"+PPoz)

        if KwotaWalWn!=0:
            if KursWn<=0:
                LBledy.append("Niepoprawny kurs waluty Wn dla pozycji "+Poz+"/"+PPoz)
            else:
                Kw = abs(rsglobal.RSRound(KwotaWalWn * KursWn - KwotaWn, 4))
                if Kw > 1:
                    LBledy.append("Niezgodno kwoty Wn, kursu waluty i kwoty w walucie o wicej ni 1 ("+str(Kw)+") dla pozycji "+Poz+"/"+PPoz)

        if KwotaWalMa!=0:
            if KursMa<=0:
                LBledy.append("Niepoprawny kurs waluty Ma dla pozycji "+Poz+"/"+PPoz)
            else:
                Kw = abs(rsglobal.RSRound(KwotaWalMa * KursMa - KwotaMa, 4))
                if Kw > 1:
                    LBledy.append("Niezgodno kwoty Ma, kursu waluty i kwoty w walucie o wicej ni 1 ("+str(Kw)+") dla pozycji "+Poz+"/"+PPoz)
        
        # sprawdzenie czy dane zwizane z dat ksigowania pozycji s poprawne
        if DataKsiegK<>'':
            if CzyJestBO:
                SQL="SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' ;"
                stat, B, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat<>'OK':
                    LBledy.append(u'Bd wykonania zapytania sprawdzenia okresu daty ksigowania kosztw z BO')
                elif B[0][0]>DataKsiegK:
                    LBledy.append(u"Zamknicie dowodu z dat ksigowania kosztu/przychodu " + DataKsiegK
                              + u" jest niemoliwe ze wzgldu na zaksigowany Bilans Otwarcia w obecnym okresie obrachunkowym."
                              + u'Dotyczy pozycji '+Poz+u"/"+PPoz)

            # sprawdzenie czy s sumy dla tej daty
            if not DataKsiegK in SDatyKsieg:
                SDatyKsieg[DataKsiegK]=[0,0]
            
            # sprawdzenie czy istnieje okres dla niej
            if w[25]=='':
                LBledy.append("Brak okresu dla daty ksigowania "+DataKsiegK+" dla pozycji "+Poz+"/"+PPoz)
            # jeli istnieje to sprawdzamy czy miesic istnieje
            elif w[26]=='':
                LBledy.append("Brak miesica w okresie ksigowym dla daty ksigowania kosztw :"+DataKsiegK+" dla pozycji "+Poz+"/"+PPoz)
            # sprawdzamy czy jest zamknity (jeli tak to le)
            elif w[26] in ['True','TRUE',True]:
                LBledy.append("Zamknity miesic w okresie ksigowym dla daty ksigowania kosztw :"+DataKsiegK+" dla pozycji "+Poz+"/"+PPoz)

            # sprawdzenie poprawnoci kont i zsumowanie kwot 
            if KontoWn<>'':
                par=eval(w[27])
                if par[0]=='':
                    LBledy.append("Brak definicji konta Wn "+KontoWn+" w okresie ksigowym "+w[25]+" dla daty ksigowania kosztw :"+DataKsiegK+" z pozycji "+Poz+"/"+PPoz)
                else:
                    if not par[4]:
                        SDatyKsieg[DataKsiegK][0]+=KwotaWn
        
            if KontoMa<>'':
                par=eval(w[28])
                if par[0]=='':
                    LBledy.append("Brak definicji konta Ma "+KontoMa+" w okresie ksigowym "+w[25]+" dla daty ksigowania kosztw :"+DataKsiegK+" z pozycji "+Poz+"/"+PPoz)
                else:
                    if not par[4]:
                        SDatyKsieg[DataKsiegK][1]+=KwotaMa
                            
            if KontoVatWn<>'':
                par=eval(w[29])
                if par[0]=='':
                    LBledy.append("Brak definicji konta Vat Wn "+KontoVatWn+" w okresie ksigowym "+w[25]+" dla daty ksigowania kosztw :"+DataKsiegK+" z pozycji "+Poz+"/"+PPoz)
                else:
                    if not par[4]:
                        SDatyKsieg[DataKsiegK][0]+=KwotaVatWn
        
            if KontoVatMa<>'':
                par=eval(w[30])
                if par[0]=='':
                    LBledy.append("Brak definicji konta Vat Ma "+KontoMa+" w okresie ksigowym "+w[25]+" dla daty ksigowania kosztw :"+DataKsiegK+" z pozycji "+Poz+"/"+PPoz)
                else:
                    if not par[4]:
                        SDatyKsieg[DataKsiegK][1]+=KwotaVatMa

    #jesli pozycja z "D" byla ostatnia to dopiero teraz bedzie to sprawdzone
    if CzyD:
        #sprawdzenie czy suma pozycji sie zgadza
        if abs(rsglobal.RSRound(SumaD*StawkaD*0.01,2)-rsglobal.RSRound(VatD,2)) > 1:
            LBledy.append("Bdny vat :"+str(VatD)+" dla sumy netto :"+str(SumaD)+" i vatu : "+str(StawkaD)+"  w pozycjach "+str(PozP)+"-"+str(PozK))

    # sprawdzenie czy cay dowd si bilansuje 
    if rsglobal.RSRound(SBilansowaWn,4)<>rsglobal.RSRound(SBilansowaMa,4):
        LBledy.append ("Dowd si nie bilansuje. Kwota Wn ="+str(SBilansowaWn)+", Kwota Ma="+str(SBilansowaMa)+", rnica ="+str(rsglobal.RSRound(SBilansowaWn-SBilansowaMa,4)))
        
    if len(LBledy)>0:
        return LBledy

    #-################################################
    #sprawdzenie kwoty do zaplaty i ustawienie czyMPP    #JR 11578
    #-################################################

    SQL="SELECT COALESCE(dk.konto_id,''), "
    SQL+=" SUM(CASE WHEN rsf_podaj_parametr_konta(dkp.firma_id,dkp.okres_id,dkp.konto_ma,9) IN ('True','TRUE','1') THEN dkp.kwota_ma ELSE 0 END)"
    SQL+=" FROM rs_dowody_ksiegowe dk LEFT OUTER JOIN rs_dowody_ksiegowe_pozycje dkp "
    SQL+=" USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
    SQL+=" WHERE dk.firma_id= '"+self.firma_id+"' AND dk.okres_id='"+OkresDow+"' AND dk.dowod_id='"+Dowod+"' "
    SQL+=" AND dk.nazwa_id='"+Nazwa+"' AND dk.data='"+Data+"' "
    SQL+=" AND dk.numer ="+str(Numer)+" GROUP BY dk.konto_id;"
    stat,DaneD,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return stat

    if DaneD[0][0] != '':
        DoZaplaty=DaneD[0][1]
    #AB 15.10.19r
    # if CzyListopad and DoZaplaty > 15000:
    #     CzyMPP = True

    # ostateczna akceptacja zmiany z W na G
    SQL  = "UPDATE rs_dowody_ksiegowe SET stan='G', kwota_wn="+str(SBilansowaWn)+", kwota_ma="+str(SBilansowaMa) + ","
    SQL += " czy_mpp=" + str(CzyMPP)  #JR 11578
    SQL += " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"'"
    SQL += " AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    
    return [stat]

#-------------------------------------------------------------------------------
# FUNKCJA ZAMYKAJCA DOWD KSIEGOWY Z G na Z
#-------------------------------------------------------------------------------

def ZamknijDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,OkresDow=''):
    if OkresDow=='':
        OkresDow=self.okres_id
    FiltrDok="firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    FiltrDok+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)

    # lista rozrachunkow, ktre na koniec s przegldane w celu ponownego rozliczenia rozrachunkw podczas zamykania BO
    LRozrachunkow=[]

    # pobranie typu dokumentu ze wzoru dekretacji
    SQL="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,DaneWz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bd pobierania wzoru dekretacji :'+stat

    if len(DaneWz)==0:
        return 'Brak podanego wzoru dekretacji :'+stat
    
    TypWzoru=DaneWz[0][0]

        
    # pobranie nagwka dowodu
    SQL="SELECT stan,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
    SQL+="rejestr,data_rejestru,projekt_id,COALESCE(f_typ,''),f_wyznacznik_id,f_data,f_numer, COALESCE(czy_mpp, False) "
    SQL+=" FROM rs_dowody_ksiegowe WHERE "+FiltrDok+" FOR UPDATE NOWAIT;"
    stat,DaneN,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DaneN)<>1:
            return "Niepoprawne identyfikatory dowodu."

    # sprawdzenie stanu dowodu
    StanDow=DaneN[0][0]
    if StanDow=="Z":
        return "Dowd ju jest zamknity"
    elif StanDow<>"G":
        return "Nie mona zamkn dowodu - dowd nie jest w stanie G"
    
    # pobranie pozycji dowodu

    SQL="SELECT nr_poz,nr_ppoz,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id," #0-7
    SQL+="data_ksieg_kosztow,konto_wn,konto_ma,konto_vat_wn,konto_vat_ma,projekt_wn,projekt_ma," #8-14
    SQL+="kwota_wn,kwota_wal_wn,tresc_wn,COALESCE(seria_wn,''),waluta_wn,kurs_wn,kwota_vat_wn, " #15-21
    SQL+="kwota_ma,kwota_wal_ma,tresc_ma,COALESCE(seria_ma,''),waluta_ma,kurs_ma,kwota_vat_ma,platnosc_id " #22-29
    SQL+=" FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok+" ORDER BY nr_poz,nr_ppoz;"
    stat,DaneP,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return stat
    
    if len(DaneP)==0:
        return "Brak pozycji na dowodzie ksigowym"

    #pobranie i zablokowanie stanow kont, ktore beda zmieniane

    SQL="SELECT * FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' AND "
    SQL+="( konto IN (SELECT DISTINCT konto_wn FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok+") OR"
    SQL+=" konto IN (SELECT DISTINCT konto_vat_wn FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok+") OR"
    SQL+=" konto IN (SELECT DISTINCT konto_ma FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok+") OR"
    SQL+=" konto IN (SELECT DISTINCT konto_vat_ma FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok+")) FOR UPDATE NOWAIT;"

    # opoznienie w sekundach przy kolejnych probach blokady
    opoznienie = (0,3,6,9)
    for t in opoznienie:
        if t > 0:
            time.sleep(t)
            
        stat,Bufor,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            break
    
    if stat<>'OK':
        stat = 'Nie mona zablokowa stanw kont. Sprbuj za chwil.'
        return stat

    SymbolDokG = rsglobal.Dekoduj(DaneN[0][1])
    if SymbolDokG == None:
        SymbolDokG=""
    DataWystG   = rsglobal.Dekoduj(DaneN[0][2])
    DataWplywuG = rsglobal.Dekoduj(DaneN[0][3])
    TerminG     = rsglobal.Dekoduj(DaneN[0][4])
    DataZaplatyG= rsglobal.Dekoduj(DaneN[0][5])
    KontrahentG = rsglobal.Dekoduj(DaneN[0][6])
    Rejestr     = rsglobal.Dekoduj(DaneN[0][7])
    DataRej     = rsglobal.Dekoduj(DaneN[0][8])
    ProjektG    = rsglobal.Dekoduj(DaneN[0][9])
    CzyMPP      = rsglobal.Dekoduj(DaneN[0][14])
    
    polafakt=',f_typ,f_wyznacznik_id,f_data,f_numer'
        
    if ProjektG in (None,'None'):
        ProjektG="NULL"
    else:
        ProjektG="'"+ProjektG.strip()+"'"
        
    #zamkniecie dokumentu - ptla po pozycjach
    for w in DaneP:
        SQLGlowny=''
        
        # przeniesione do rodka ptli poniewa moe si w niej zmienia podczas tworzenia BO
        TypF = rsglobal.Dekoduj(DaneN[0][10])
        if TypF=='':
            wartfakt=",NULL,NULL,NULL,NULL"
        else:
            wartfakt=",'"+TypF+"','"+rsglobal.Dekoduj(DaneN[0][11])+"','"+rsglobal.Dekoduj(DaneN[0][12])+"',"+str(DaneN[0][13])
            
        # skadanie bazy pl do zapyta w rozrachunkach i operacjach
        pola = "(firma_id, okres_id,dowod_id,nazwa_id,data"
        pola+= ",numer,nr_poz,nr_ppoz"
        wart = "('"+self.firma_id+"','"+OkresDow+"','"+Dowod+"','"+Nazwa+"','"+str(Data)+"'"
        wart+= ","+str(Numer)+","+str(w[0])+","+str(w[1])
        
        SymbolDok=rsglobal.Dekoduj(w[2])
        if SymbolDok in ("",None,"None"):
            SymbolDok = SymbolDokG
        if SymbolDok<>"":
            pola+=",symbol_dok"
            wart+=",'"+SymbolDok+"'"
            
        DataWyst=rsglobal.Dekoduj(w[3])
        if DataWyst in ("",None,"None"):
            DataWyst=DataWystG
        if not DataWyst in ("",None,"None"):
            pola+=",data_wyst"
            wart+=",'"+str(DataWyst)+"'"
            
        DataWplywu=rsglobal.Dekoduj(w[4])
        if DataWplywu in ("",None,"None"):
            DataWplywu=DataWplywuG
        if not DataWplywu in ("",None,"None"):
            pola+=",data_wplywu"
            wart+=",'"+str(DataWplywu)+"'"
            
        Termin=rsglobal.Dekoduj(w[5])
        if Termin in ("",None,"None"):
            Termin=TerminG
        if not Termin in ("",None,"None"):
            pola+=",termin_plat"
            wart+=",'"+str(Termin)+"'"
            
        DataZaplaty=rsglobal.Dekoduj(w[6])
        if DataZaplaty in ("",None,"None"):
            DataZaplaty=DataZaplatyG
        if not DataZaplaty in ("",None,"None"):
            pola+=",data_zapl"
            wart+=",'"+str(DataZaplaty)+"'"    
            
        Kontrahent=rsglobal.Dekoduj(w[7])
        if Kontrahent in ("",None,"None"):
            Kontrahent=KontrahentG
        if not Kontrahent in ("",None,"None"):
            pola+=",kontrahent_id"
            wart+=",'"+str(Kontrahent)+"'"    
            
        Platnosc=str(w[29])
        if Platnosc in ('None','0',''):
            Platnosc='NULL'
   
        DataKsiegKosztow = rsglobal.Dekoduj(w[8])
        if DataKsiegKosztow in ("",None,"None"):
            DataKsieg=str(Data)
            OkresKsieg=OkresDow
            DataKsiegKosztow='NULL'
        else:
            SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' "
            SQL+=" AND data_od<='"+DataKsiegKosztow+"' AND data_do>='"+DataKsiegKosztow+"';"
            stat,DOkresu,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                return stat
            if len(DOkresu)==0:
                return "Brak okresu dla daty "+dataksiegkosztow

            OkresKsieg=rsglobal.Dekoduj(DOkresu[0][0])
            DataKsieg=DataKsiegKosztow
            DataKsiegKosztow="'"+DataKsiegKosztow+"'"

            #TODO do usunicia
            #SQL = "SELECT 1 FROM rs_wzory_dekretacji "
            #SQL += "WHERE firma_id='" + self.firma_id + "' AND dowod_id='BO' "
            #SQL += " AND okres_id<>" + OkresDow + " AND okres_id=" + OkresKsieg + ";"
            #stat, B, dump, dump = self.PolSQL.Execute(SQL, 3)
            #if B[0][0]==1:
            #    stat = u"Zamknicie dowodu z dat ksigowania kosztu/przychodu" + DataKsiegKosztow
            #    stat+= u" jest niemoliwe ze wzgldu na zaksigowany Bilans Otwarcia w obecnym okresie obrachunkowym"
            #    return stat

        pola+=",data_ksieg_kosztow"
        wart+=","+DataKsiegKosztow
    
        KontoWn=rsglobal.Dekoduj(w[9])
        if KontoWn in (None,'None'):
            KontoWn=""
        else:
            KontoWn=KontoWn.strip()
            
        KontoMa=rsglobal.Dekoduj(w[10])
        if KontoMa in (None,'None'):
            KontoMa=""
        else:
            KontoMa=KontoMa.strip()

        KontoVatWn=rsglobal.Dekoduj(w[11])
        if KontoVatWn in (None,'None'):
            KontoVatWn=""
        else:
            KontoVatWn=KontoVatWn.strip()
            
        KontoVatMa=rsglobal.Dekoduj(w[12])
        if KontoVatMa in (None,'None'):
            KontoVatMa=""
        else:
            KontoVatMa=KontoVatMa.strip()


        ProjektWn=rsglobal.Dekoduj(w[13])
        if ProjektWn in (None,'None'):
            ProjektWn=ProjektG
        else:
            ProjektWn="'"+ProjektWn.strip()+"'"
            
        ProjektMa=rsglobal.Dekoduj(w[14])
        if ProjektMa in (None,'None'):
            ProjektMa=ProjektG
        else:
            ProjektMa="'"+ProjektMa.strip()+"'"

        #--- KONTO WN
        if KontoWn <>"" and w[15]<>0:
            KwotaDoRozr=str(w[15])
            KwotaDoRozrWal=str(w[16])
            TrescRozr=rsglobal.Dekoduj(w[17])
            polapdk=''
            wartpdk=''
            if Dowod in ["BO","BK"]:
                Gdzie= TrescRozr.find("Nr:")
                if Gdzie >-1:
                    NumerSerii=TrescRozr[Gdzie+3:]
                    if not NumerSerii in LRozrachunkow:
                        LRozrachunkow.append(NumerSerii)
                    SQL="SELECT kwota_wn,kwota_wal_wn,COALESCE(f_typ,''),f_wyznacznik_id,f_data,f_numer,"
                    SQL+=" COALESCE(pdk_okres_id,okres_id),COALESCE(pdk_dowod_id,dowod_id),COALESCE(pdk_nazwa_id,nazwa_id),"
                    SQL+=" COALESCE(pdk_data,data),COALESCE(pdk_numer,numer),COALESCE(pdk_nr_poz,nr_poz),COALESCE(pdk_nr_ppoz,nr_ppoz)"
                    SQL+=" FROM rs_rozrachunki WHERE seria="+NumerSerii+";"
                    stat,DKwotyRoz,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        return stat
                        
                    if len(DKwotyRoz)>0:
                        KwotaDoRozr=str(DKwotyRoz[0][0])
                        KwotaDoRozrWal=str(DKwotyRoz[0][1])
                        TrescRozr=TrescRozr[:Gdzie]
                        if rsglobal.Dekoduj(DKwotyRoz[0][2])=='':
                            wartfakt=",NULL,NULL,NULL,NULL"
                        else:
                            wartfakt=",'"+rsglobal.Dekoduj(DKwotyRoz[0][2])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][3])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][4])+"',"+str(DKwotyRoz[0][5])

                        polapdk=",pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"
                        if DKwotyRoz[0][7] in ['BO','BK']:
                            wartpdk=",NULL,NULL,NULL,NULL,NULL,NULL,NULL"
                        else:
                            wartpdk=",'"+rsglobal.Dekoduj(DKwotyRoz[0][6])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][7])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][8])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][9])+"',"+str(DKwotyRoz[0][10])+","+str(DKwotyRoz[0][11])+","+str(DKwotyRoz[0][12])

            f = pola+",konto,konto_prz,kwota_wn,tresc,projekt_id"
            v = wart+",'"+KontoWn+"','"+KontoMa+"',"+str(w[15])+",'"+TrescRozr+"',"+ProjektWn
            froz=pola+polafakt+polapdk+",konto,kwota_wn,saldo_wn,tresc,projekt_id,seria_rozl,platnosc_id"
            vroz=wart+wartfakt+wartpdk+",'"+KontoWn+"',"+KwotaDoRozr+","+str(w[15])+",'"+TrescRozr+"',"+ProjektWn+",'"+str(w[18])+"',"+Platnosc
            if not Dowod in ["BO","BK"]:
                froz+=",pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"
                vroz+=",'"+OkresDow+"','"+Dowod+"','"+Nazwa+"','"+str(Data)+"',"+str(Numer)+","+str(w[0])+","+str(w[1])
            
            # obsuga waluty != 'PLN'
            if (w[16]<>0 and w[19]<> "PLN") or TypWzoru=='W':
                f += ",waluta,kurs,kwota_wal_wn"
                v += ",'"+rsglobal.Dekoduj(w[19])+"',"+str(w[20])+","+str(w[16])
                froz+=",waluta,kurs,kwota_wal_wn,saldo_wal_wn"
                vroz+=",'"+rsglobal.Dekoduj(w[19])+"',"+str(w[20])+","+KwotaDoRozrWal+","+str(w[16])
                if Dowod in ["BO","BK"]:
                    # sprawdzenie czy syntetyka ma analityke
                    Robic=True
                    if KontoWn.find('-') == -1:
                        SQL="SELECT konto_wn FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok
                        SQL+=" AND POSITION('-' IN konto_wn)>0 AND konto_wn LIKE '"+KontoWn+"%';" 
                        stat,DAnalityka,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            return stat
                        if len(DAnalityka)>0:
                            Robic=False
                    
                    if Robic:
                        SQLGlowny+="SELECT rsf_zapisz_stan_konta_BO('"+self.firma_id+"'"
                        SQLGlowny+=",'"+OkresDow+"','"+Data+"','"+KontoWn+"'"
                        SQLGlowny+=",'W',"+str(w[15])+",'"+rsglobal.Dekoduj(w[19])+"',"+str(w[16])+");"
                else:
                    SQLGlowny+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"'"
                    SQLGlowny+=",'"+OkresKsieg+"','"+DataKsieg+"','"+KontoWn+"'"
                    SQLGlowny+=",'W',"+str(w[15])+",'"+rsglobal.Dekoduj(w[19])+"',"+str(w[16])+");"
            # obsuga PLN
            else:
                f += ",waluta,kurs,kwota_wal_wn"
                v += ",'PLN',1,"+str(w[15])
                froz+=",waluta,kurs,kwota_wal_wn,saldo_wal_wn"
                vroz+=",'PLN',1,"+KwotaDoRozr+","+str(w[15])
                if Dowod in ["BO","BK"]:
                    # sprawdzenie czy syntetyka ma analityke
                    Robic=True
                    if KontoWn.find('-') == -1:
                        SQL="SELECT konto_wn FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok
                        SQL+=" AND POSITION('-' IN konto_wn)>0 AND konto_wn LIKE '"+KontoWn+"%';" 
                        stat,DAnalityka,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            return stat
                        
                        if len(DAnalityka)>0:
                            Robic=False
                                
                    if Robic:
                        SQLGlowny+="SELECT rsf_zapisz_stan_konta_BO('"+self.firma_id+"'"
                        SQLGlowny+=",'"+OkresDow+"','"+Data+"','"+KontoWn+"'"
                        SQLGlowny+=",'W',"+str(w[15])+",'PLN',"+str(w[15])+");"
                else:
                    SQLGlowny+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"'"
                    SQLGlowny+=",'"+OkresKsieg+"','"+DataKsieg+"','"+KontoWn+"'"
                    SQLGlowny+=",'W',"+str(w[15])+",'PLN',"+str(w[15])+");"

            q = "INSERT INTO rs_operacje "+f+",operator_zam) VALUES "+v+",rsf_getuserid());"
            qroz="INSERT INTO rs_rozrachunki "+froz+") VALUES "+vroz+");"

            if Dowod in ["BO","BK"]:
                #--- do operacji tylko ksiegowane
                SQL="SELECT rsf_podaj_parametr_konta('"+self.firma_id+"','"+OkresDow+"','"+KontoWn+"',3);"
                stat,DKonta,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    return stat
                
                if len(DKonta)==1:
                    if DKonta[0][0] in ('1','True'):
                        SQLGlowny+=q
                        SQLGlowny+=qroz
            else:
                SQLGlowny+=q
                SQLGlowny+=qroz

        #--- KONTO VAT WN
        if KontoVatWn <>"" and (not (Dowod in ["BO","BK"])):
            f = pola+",konto,kwota_wn,tresc"
            v = wart+",'"+KontoVatWn+"',"+str(w[21])+",'"+rsglobal.Dekoduj(w[17])+"'"
            froz=pola+polafakt+",konto,kwota_wn,saldo_wn,tresc"
            vroz=wart+wartfakt+",'"+KontoVatWn+"\',"+str(w[21])+","+str(w[21])+",'"+rsglobal.Dekoduj(w[17])+"'"
            if not Dowod in ["BO","BK"]:
                froz+=",pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"
                vroz+=",'"+OkresDow+"','"+Dowod+"','"+Nazwa+"','"+str(Data)+"',"+str(Numer)+","+str(w[0])+","+str(w[1])
                
            if w[16]<>0 and w[19]<> "PLN":
                f = f + ",waluta,kurs,kwota_wal_wn"
                v = v + ",'"+rsglobal.Dekoduj(w[19])+"',"+str(w[20])+","+str(w[21]/w[20])
                froz+=",waluta,kurs,kwota_wal_wn,saldo_wal_wn"
                vroz+=",'"+rsglobal.Dekoduj(w[19])+"',"+str(w[20])+","+str(w[21]/w[20])+","+str(w[21]/w[20])
            else:
                f = f + ",waluta,kurs,kwota_wal_wn"
                v = v + ",'PLN',1,"+str(w[21])
                froz+=",waluta,kurs,kwota_wal_wn,saldo_wal_wn"
                vroz+=",'PLN',1,"+str(w[21])+","+str(w[21])

            SQLGlowny+="INSERT INTO rs_operacje "+f+",operator_zam) VALUES "+v+",rsf_getuserid());"
            SQLGlowny+="INSERT INTO rs_rozrachunki "+froz+") VALUES "+vroz+");"
            
            SQLGlowny+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"'"
            SQLGlowny+=",'"+KontoVatWn+"','W',"+str(w[21])+",'PLN',"+str(w[21])+");"


        #--- KONTO MA
        if KontoMa <>"" and w[22]<>0:
            KwotaDoRozr=str(w[22])
            KwotaDoRozrWal=str(w[23])
            TrescRozr=rsglobal.Dekoduj(w[24])
            polapdk=''
            wartpdk=''
            if Dowod in ["BO","BK"]:
                Gdzie= TrescRozr.find("Nr:")
                if Gdzie >-1:
                    NumerSerii=TrescRozr[Gdzie+3:]
                    if not NumerSerii in LRozrachunkow:
                        LRozrachunkow.append(NumerSerii)
                    SQL="SELECT kwota_ma,kwota_wal_ma,COALESCE(f_typ,''),f_wyznacznik_id,f_data,f_numer,"
                    SQL+=" COALESCE(pdk_okres_id,okres_id),COALESCE(pdk_dowod_id,dowod_id),COALESCE(pdk_nazwa_id,nazwa_id),"
                    SQL+=" COALESCE(pdk_data,data),COALESCE(pdk_numer,numer),COALESCE(pdk_nr_poz,nr_poz),COALESCE(pdk_nr_ppoz,nr_ppoz)"
                    SQL+=" FROM rs_rozrachunki WHERE seria="+NumerSerii+";"
                    stat,DKwotyRoz,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        return stat

                    if len(DKwotyRoz)>0:
                        KwotaDoRozr=str(DKwotyRoz[0][0])
                        KwotaDoRozrWal=str(DKwotyRoz[0][1])
                        TrescRozr=TrescRozr[:Gdzie]
                        if rsglobal.Dekoduj(DKwotyRoz[0][2])=='':
                            wartfakt=",NULL,NULL,NULL,NULL"
                        else:
                            wartfakt=",'"+rsglobal.Dekoduj(DKwotyRoz[0][2])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][3])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][4])+"',"+str(DKwotyRoz[0][5])
                        
                        polapdk=",pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"
                        if DKwotyRoz[0][7] in ['BO','BK']:
                            wartpdk=",NULL,NULL,NULL,NULL,NULL,NULL,NULL"
                        else:
                            wartpdk=",'"+rsglobal.Dekoduj(DKwotyRoz[0][6])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][7])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][8])+"','"+rsglobal.Dekoduj(DKwotyRoz[0][9])+"',"+str(DKwotyRoz[0][10])+","+str(DKwotyRoz[0][11])+","+str(DKwotyRoz[0][12])

            f = pola+",konto,konto_prz,kwota_ma,tresc,projekt_id"
            v = wart+",'"+KontoMa+"','"+KontoWn+"',"+str(w[22])+",'"+TrescRozr+"',"+ProjektMa
            froz=pola+polafakt+polapdk+",konto,kwota_ma,saldo_ma,tresc,projekt_id,seria_rozl,platnosc_id"
            vroz=wart+wartfakt+wartpdk+",'"+KontoMa+"',"+KwotaDoRozr+","+str(w[22])+",'"+TrescRozr+"',"+ProjektMa+",'"+str(w[25])+"',"+Platnosc
            if not Dowod in ["BO","BK"]:
                froz+=",pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"
                vroz+=",'"+OkresDow+"','"+Dowod+"','"+Nazwa+"','"+str(Data)+"',"+str(Numer)+","+str(w[0])+","+str(w[1])
                
            # obsuga waluty != 'PLN'
            if (w[23]<>0 and w[26]<> "PLN") or TypWzoru=='W':
                f += ",waluta,kurs,kwota_wal_ma"
                v += ",'"+rsglobal.Dekoduj(w[26])+"',"+str(w[27])+","+str(w[23])
                froz+=",waluta,kurs,kwota_wal_ma,saldo_wal_ma"
                vroz+=",'"+rsglobal.Dekoduj(w[26])+"',"+str(w[27])+","+KwotaDoRozrWal+","+str(w[23])
                if Dowod in ["BO","BK"]:
                    # sprawdzenie czy syntetyka ma analityke
                    Robic=True
                    if KontoMa.find('-') == -1:
                        SQL="SELECT konto_ma FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok
                        SQL+=" AND POSITION('-' IN konto_ma)>0 AND konto_ma LIKE '"+KontoMa+"%';" 
                        stat,DAnalityka,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            return stat
                        
                        if len(DAnalityka)>0:
                            Robic=False
                    
                    if Robic:
                        SQLGlowny+="SELECT rsf_zapisz_stan_konta_BO('"+self.firma_id+"'"
                        SQLGlowny+=",'"+OkresDow+"','"+Data+"','"+KontoMa+"'"
                        SQLGlowny+=",'M',"+str(w[22])+",'"+rsglobal.Dekoduj(w[26])+"',"+str(w[23])+");"
                else:
                    SQLGlowny+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"'"
                    SQLGlowny+=",'"+OkresKsieg+"','"+DataKsieg+"','"+KontoMa+"'"
                    SQLGlowny+=",'M',"+str(w[22])+",'"+rsglobal.Dekoduj(w[26])+"',"+str(w[23])+");"
            # obsuga PLN
            else:
                f += ",waluta,kurs,kwota_wal_ma"
                v += ",'PLN',1,"+str(w[22])
                froz+=",waluta,kurs,kwota_wal_ma,saldo_wal_ma"
                vroz+=",'PLN',1,"+KwotaDoRozr+","+str(w[22])
                if Dowod in ["BO","BK"]:
                    # sprawdzenie czy syntetyka ma analityke
                    Robic=True
                    if KontoMa.find('-') == -1:
                        SQL="SELECT konto_ma FROM rs_dowody_ksiegowe_pozycje WHERE "+FiltrDok
                        SQL+=" AND POSITION('-' IN konto_ma)>0 AND konto_ma LIKE '"+KontoMa+"%';" 
                        stat,DAnalityka,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            return stat
                        
                        if len(DAnalityka)>0:
                            Robic=False
                                
                    if Robic:
                        SQLGlowny+="SELECT rsf_zapisz_stan_konta_BO('"+self.firma_id+"'"
                        SQLGlowny+=",'"+OkresDow+"','"+Data+"','"+KontoMa+"'"
                        SQLGlowny+=",'M',"+str(w[22])+",'PLN',"+str(w[22])+");"
                else:
                    SQLGlowny+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"'"
                    SQLGlowny+=",'"+OkresKsieg+"','"+DataKsieg+"','"+KontoMa+"'"
                    SQLGlowny+=",'M',"+str(w[22])+",'PLN',"+str(w[22])+");"

            q = "INSERT INTO rs_operacje "+f+",operator_zam) VALUES "+v+",rsf_getuserid());"
            qroz="INSERT INTO rs_rozrachunki "+froz+") VALUES "+vroz+");"

            if Dowod in ["BO","BK"]:
                #--- do operacji tylko ksiegowane
                SQL="SELECT rsf_podaj_parametr_konta('"+self.firma_id+"','"+OkresDow+"','"+KontoMa+"',3);"
                stat,DKonta,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    return stat
                
                if len(DKonta)==1:
                    if DKonta[0][0] in ('1','True'):
                        SQLGlowny+=q
                        SQLGlowny+=qroz
            else:
                SQLGlowny+=q
                SQLGlowny+=qroz

        #--- KONTO VAT MA
        if KontoVatMa <>"" and (not (Dowod in ["BO","BK"])):
            f = pola+",konto,kwota_ma,tresc"
            v = wart+",'"+KontoVatMa+"',"+str(w[28])+",'"+rsglobal.Dekoduj(w[24])+"'"
            froz=pola+polafakt+",konto,kwota_ma,saldo_ma,tresc"
            vroz=wart+wartfakt+",'"+KontoVatMa+"\',"+str(w[28])+","+str(w[28])+",'"+rsglobal.Dekoduj(w[24])+"'"
            if not Dowod in ["BO","BK"]:
                froz+=",pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"
                vroz+=",'"+OkresDow+"','"+Dowod+"','"+Nazwa+"','"+str(Data)+"',"+str(Numer)+","+str(w[0])+","+str(w[1])
                
            if w[23]<>0 and w[26]<> "PLN":
                f = f + ",waluta,kurs,kwota_wal_ma"
                v = v + ",'"+rsglobal.Dekoduj(w[26])+"',"+str(w[27])+","+str(w[28]/w[27])
                froz+=",waluta,kurs,kwota_wal_ma,saldo_wal_ma"
                vroz+=",'"+rsglobal.Dekoduj(w[26])+"',"+str(w[27])+","+str(w[28]/w[27])+","+str(w[28]/w[27])
            else:
                f = f + ",waluta,kurs,kwota_wal_ma"
                v = v + ",'PLN',1,"+str(w[28])
                froz+=",waluta,kurs,kwota_wal_ma,saldo_wal_ma"
                vroz+=",'PLN',1,"+str(w[28])+","+str(w[28])

            SQLGlowny+="INSERT INTO rs_operacje "+f+",operator_zam) VALUES "+v+",rsf_getuserid());"
            SQLGlowny+="INSERT INTO rs_rozrachunki "+froz+") VALUES "+vroz+");"
            
            SQLGlowny+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"'"
            SQLGlowny+=",'"+KontoVatMa+"','M',"+str(w[28])+",'PLN',"+str(w[28])+");"
        
        if SQLGlowny<>'':
            stat,dump,dump,dump = self.PolSQL.Execute(SQLGlowny,1)
            if stat<>'OK':
                return 'Bd zapisu danych dla pozycji '+str(w[0])+"/"+str(w[1])+' : '+stat


    # koniec ptli z pozycjami. Zosta update na rozrachunki w BO oraz zmiana stanu na Z.
    SQLGlowny=''
    if Dowod =="BO":
        SQLGlowny+="UPDATE rs_rozrachunki SET kwota_bo_wn=saldo_wn,kwota_bo_ma=saldo_ma,"
        SQLGlowny+="kwota_bo_wal_wn=saldo_wal_wn,kwota_bo_wal_ma=saldo_wal_ma"
        SQLGlowny+=" WHERE "+FiltrDok+";"

    SQLGlowny+="UPDATE rs_dowody_ksiegowe SET stan='Z' WHERE "+FiltrDok+";"
    
    stat,dump,dump,dump = self.PolSQL.Execute(SQLGlowny,1)

    if stat<>'OK':
        return stat
            
    #-################################################                
    #dodawanie dowodu do platnosci jesli konto we wzorze dekretacji
    #-################################################        

    SQL="SELECT COALESCE(dk.konto_id,''), COALESCE(dk.kontrahent_id,''), dk.symbol_dok, dk.termin_plat,"
    SQL+=" SUM(CASE WHEN rsf_podaj_parametr_konta(dkp.firma_id,dkp.okres_id,dkp.konto_ma,9) IN ('True','TRUE','1') THEN dkp.kwota_ma ELSE 0 END),"
    SQL+=" SUM(kwota_vat_wn)"
    SQL+=" FROM rs_dowody_ksiegowe dk LEFT OUTER JOIN rs_dowody_ksiegowe_pozycje dkp "
    SQL+=" USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
    SQL+=" WHERE dk.firma_id= '"+self.firma_id+"' AND dk.okres_id='"+OkresDow+"' AND dk.dowod_id='"+Dowod+"' "
    SQL+=" AND dk.nazwa_id='"+Nazwa+"' AND dk.data='"+Data+"' "
    SQL+=" AND dk.numer ="+str(Numer)+" GROUP BY dk.konto_id,dk.kontrahent_id,dk.symbol_dok,dk.termin_plat;"
    stat,DaneD,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return stat

    if DaneD[0][0]<>'':
        TermPl=str(DaneD[0][3])
        if TermPl in (None,'None'):
            TermPlat="Null" 
        else:
            TermPlat="'"+TermPl+"'"
        KwotaVAT=DaneD[0][5]
                
        KontoFK=''
        SQL="SELECT konto_ma,sum(kwota_ma) FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"' "
        SQL+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' "
        SQL+=" AND numer ="+str(Numer)+" AND rsf_podaj_parametr_konta(firma_id,okres_id,konto_ma,9) IN ('True','TRUE','1')"
        SQL+=" AND konto_ma LIKE '2%' GROUP BY konto_ma HAVING SUM(kwota_ma)="+str(DaneD[0][4])+";"
        stat,DaneKontaFK,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return stat
        
        if len(DaneKontaFK)>0:
            KontoFK=rsglobal.Dekoduj(DaneKontaFK[0][0])

        KontrPl="'"+rsglobal.Dekoduj(DaneD[0][1])+"'"
        if KontrPl=="''":
            KontrPl="NULL"
        
        #jeli s dane, ale kwota wychodzi 0 to wychodzimy z odpowiednim komunikatem
        if DaneD[0][4]==0:
            return 'Mimo podania konta w nagwku podana jest zerowa kwota potencjalnej patnoci. Zamykanie dowodu przerwane.'
                    
        # pobranie danych z rozrachunkw, ktre odejmiemy z patnoci
        SQL="SELECT seria_ma FROM rs_dowody_ksiegowe_pozycje dkp WHERE dkp.firma_id= '"+self.firma_id+"' "
        SQL+=" AND dkp.okres_id='"+OkresDow+"' AND dkp.dowod_id='"+Dowod+"' "
        SQL+=" AND dkp.nazwa_id='"+Nazwa+"' AND dkp.data='"+Data+"' "
        SQL+=" AND dkp.numer ="+str(Numer)+" AND NOT seria_ma IS NULL AND not TRIM(seria_ma)=''"
        SQL+=" AND rsf_podaj_parametr_konta(firma_id,okres_id,konto_ma,9) IN ('True','TRUE','1');"
        stat,DaneRozrach,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return stat
        
        KwotaRozrach=0
        if len(DaneRozrach)>0:
            Rozrach=''
            for d in DaneRozrach:
                Rozrach+=d[0]+','
            Rozrach=Rozrach.strip(',')
            
            SQL="SELECT SUM(COALESCE(saldo_wn,0)) FROM rs_rozrachunki WHERE seria IN ("+rsglobal.Dekoduj(Rozrach)+");"
            stat,DaneS,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                return stat

            KwotaRozrach=DaneS[0][0]
                            
        if DaneD[0][4]-KwotaRozrach!=0:

            #AB27.08.18r
            #sprawdzenie czy MPP
            #JR 11578 byo sprawdzane w kontrahencie teraz pobiera z d.k.
            #SQL="SELECT czy_mpp FROM rs_kontrahenci WHERE firma_id= '"+self.firma_id+"' AND kontrahent_id="+KontrPl
            #stat,czympp,dump,dump = self.PolSQL.Execute(SQL ,3)
            #if stat<>'OK':
            #    return stat
            #if len(czympp) == 0:
            #    KwotaVAT = 0
            #else:
            #    if not czympp[0][0]:
            #        KwotaVAT=0
            if not CzyMPP:
                KwotaVAT = 0

            KluczDowodu = Dowod.strip()+"/"+Nazwa.strip()+"/"+Data+"/"+str(Numer)[0:str(Numer).find('.')]
            
            INS = "INSERT INTO rs_platnosci (firma_id, stan, konto_id, kontrahent_id, dowod, nr_faktury,"
            INS+=" kwota_oryg,kwota_platnosci,termin_plat, op_wpr,konto_fk,kwota_vat) VALUES ("
            INS+=" '"+self.firma_id+"', 'W', '"+str(DaneD[0][0])+"',"+KontrPl+", "
            INS+=" '"+KluczDowodu+"', "
            INS+=" '"+str(DaneD[0][2])+"', "+str(DaneD[0][4])+","+str(DaneD[0][4]-KwotaRozrach)+","+TermPlat+", "
            INS+=" '"+str(self.operator_id)+"','"+KontoFK+"',"+str(KwotaVAT)+");"
            stat,dump,dump,dump = self.PolSQL.Execute(INS ,1)
        
            if stat<>'OK':
                return stat
            
            SQL="SELECT MAX(platnosc_id) FROM rs_platnosci WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND dowod='"+KluczDowodu+"' AND NOT stan='U';"
            stat,danePl,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat<>'OK':
                return 'BL SEL PLAT'
    
            PlatnoscId=danePl[0][0]
            UPD = "UPDATE rs_dowody_ksiegowe SET platnosc_id="+str(PlatnoscId)+" WHERE "
            UPD+= "firma_id= '"+self.firma_id+"' AND okres_id='"+OkresDow+"' "
            UPD+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer ='"+str(Numer)+"';"
            
            # zapis numeru patnoci na odpowiednich pozycjach
            UPD+="UPDATE rs_dowody_ksiegowe_pozycje SET platnosc_id="+str(PlatnoscId)+" WHERE firma_id='"+self.firma_id+"'"
            UPD+=" AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"' "
            UPD+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' "
            UPD+=" AND numer ="+str(Numer)+" AND rsf_podaj_parametr_konta(firma_id,okres_id,konto_ma,9) IN ('True','TRUE','1')"
            UPD+=" AND konto_ma LIKE '2%';"
            
            # zapis patnoci do odpowiednich rozrachunkw
            UPD+="UPDATE rs_rozrachunki SET platnosc_id=poz.platnosc_id FROM rs_dowody_ksiegowe_pozycje poz "
            UPD+=" WHERE  rs_rozrachunki.firma_id='"+self.firma_id+"'"
            UPD+=" AND rs_rozrachunki.okres_id='"+OkresDow+"' AND rs_rozrachunki.dowod_id='"+Dowod+"' "
            UPD+=" AND rs_rozrachunki.nazwa_id='"+Nazwa+"' AND rs_rozrachunki.data='"+Data+"' "
            UPD+=" AND rs_rozrachunki.numer ="+str(Numer)+" AND rs_rozrachunki.firma_id=poz.firma_id" 
            UPD+=" AND rs_rozrachunki.okres_id=poz.okres_id AND rs_rozrachunki.dowod_id=poz.dowod_id" 
            UPD+=" AND rs_rozrachunki.nazwa_id=poz.nazwa_id AND rs_rozrachunki.data=poz.data" 
            UPD+=" AND rs_rozrachunki.numer=poz.numer AND rs_rozrachunki.nr_poz=poz.nr_poz" 
            UPD+=" AND rs_rozrachunki.nr_ppoz=poz.nr_ppoz AND NOT poz.platnosc_id IS NULL;" 
            stat,dump,dump,dump = self.PolSQL.Execute(UPD ,1)

    #-################################################                
    # sprawdzenie i ewentualne rozliczenie jednostronne rozrachunkw rozliczonych midzyokresowo
    #-################################################        
    if stat != 'OK':
        return stat
    
    # rozpatrujemy poszczeglne rozrachunki. Pobieramy ich dane identyfikacyjne i szukamy ewentualnie takich,
    # ktre byy rozliczane midzyokresowo (ta lista jest uzupeniana tylko dla BO i BK)
    for rozr in LRozrachunkow:
        DRozrStare=[]
        DRozrNowy=[]

        # pobranie identyfikacyjnych danych rozrachunku bazowego
        SQL= "SELECT COALESCE(pdk_okres_id,okres_id),COALESCE(pdk_dowod_id,dowod_id),COALESCE(pdk_nazwa_id,nazwa_id),"
        SQL+=" COALESCE(pdk_data,data),COALESCE(pdk_numer,numer),COALESCE(pdk_nr_poz,nr_poz),"
        SQL+=" COALESCE(pdk_nr_ppoz,nr_ppoz),COALESCE(symbol_dok,''),COALESCE(termin_plat::TEXT,''),COALESCE(kontrahent_id,''),"
        SQL+=" konto,kwota_wn,kwota_ma FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' AND seria="+str(rozr)+";"
        stat,DRozr,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat != 'OK':
            return 'Bdy pobierania danych rozrachunku :'+stat
  
        # pobranie danych ze starego okresu do potencjalnego rozliczenia
        if len(DRozr)>0:
            SQL="SELECT seria_prz, rozliczone_wn, rozliczone_ma, data_rozlicz, konto FROM rs_rozrachunki "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND COALESCE(pdk_okres_id,okres_id)='"+DRozr[0][0]+"' "
            SQL+=" AND COALESCE(pdk_dowod_id,dowod_id)='"+rsglobal.Dekoduj(DRozr[0][1])+"'"
            SQL+=" AND COALESCE(pdk_nazwa_id,nazwa_id)='"+rsglobal.Dekoduj(DRozr[0][2])+"'"
            SQL+=" AND COALESCE(pdk_data,data)='"+DRozr[0][3]+"' AND COALESCE(pdk_numer,numer)="+str(DRozr[0][4])
            SQL+=" AND COALESCE(pdk_nr_poz,nr_poz)="+str(DRozr[0][5])+" AND COALESCE(pdk_nr_ppoz,nr_ppoz)="+str(DRozr[0][6])
            SQL+=" AND COALESCE(symbol_dok,'')='"+rsglobal.Dekoduj(DRozr[0][7])+"'"
            SQL+=" AND COALESCE(termin_plat::TEXT,'')='"+DRozr[0][8]+"'"
            SQL+=" AND COALESCE(kontrahent_id,'')='"+rsglobal.Dekoduj(DRozr[0][9])+"'"
            SQL+=" AND konto='"+rsglobal.Dekoduj(DRozr[0][10])+"'"
            SQL+=" AND kwota_wn="+str(DRozr[0][11])+" AND kwota_ma="+str(DRozr[0][12])+" AND data_rozlicz>='"+Data+"'"
            stat,DRozrStare,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat != 'OK':
                return 'Bdy pobierania danych rozrachunku midzyokresowych :'+stat
            
        # pobranie numeru rozrachunku do rozliczenia w nowym okresie
        if len(DRozrStare)>0:
            SQL="SELECT seria FROM rs_rozrachunki "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND pdk_okres_id='"+DRozr[0][0]+"' "
            SQL+=" AND pdk_dowod_id='"+rsglobal.Dekoduj(DRozr[0][1])+"'"
            SQL+=" AND pdk_nazwa_id='"+rsglobal.Dekoduj(DRozr[0][2])+"'"
            SQL+=" AND pdk_data='"+DRozr[0][3]+"' AND pdk_numer="+str(DRozr[0][4])
            SQL+=" AND pdk_nr_poz="+str(DRozr[0][5])+" AND pdk_nr_ppoz="+str(DRozr[0][6])
            SQL+=" AND COALESCE(symbol_dok,'')='"+rsglobal.Dekoduj(DRozr[0][7])+"'"
            SQL+=" AND COALESCE(termin_plat::TEXT,'')='"+DRozr[0][8]+"'"
            SQL+=" AND COALESCE(kontrahent_id,'')='"+rsglobal.Dekoduj(DRozr[0][9])+"'"
            SQL+=" AND konto='"+rsglobal.Dekoduj(DRozr[0][10])+"'"
            SQL+=" AND kwota_wn="+str(DRozr[0][11])+" AND kwota_ma="+str(DRozr[0][12])+" AND dowod_id='"+Dowod+"'"
            SQL+=" AND data='"+Data+"' AND data_rozlicz IS NULL;" 
            stat,DRozrNowy,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat != 'OK':
                return 'Bdy pobierania danych rozrachunku do rozliczenia :'+stat
        
        # rozliczenie jednostronne
        if len(DRozrNowy)>0:
            SeriaR=DRozrNowy[0][0]
            for poz in DRozrStare:
                if SeriaR == 0:
                    return 'Rozrachunek nie moe by rozliczony do koca, a zostay rozliczenia do przeniesienia z poprzedniego okresu. Techniczne dane problemu: '+str(DRozr[0])+'\n\n'+str(DRozrNowy[0])+'\n\n'+str(poz)
                
                SeriaPrz = poz[0]
                DataRozlicz = poz[3]
                KontoRozr = poz[4] 
                if poz[1] == 0:
                    Kwota = poz[2]
                else:
                    Kwota = poz[1]

                stat,SeriaR=fs_rozrachunki_pom.RozliczJednostronnieRozrachunek(self,SeriaR,SeriaPrz,Kwota,DataRozlicz,KontoRozr)
                if stat != 'OK':
                    return 'Bdy rozliczania jednostronnego rozrachunku :'+stat
                
    return stat

#-------------------------------------------------------------------------------
# FUNKCJA OTWIERAJCA DOWD KSIGOWY Z Z NA G
#-------------------------------------------------------------------------------

def OtworzDowodKsiegowy(self,Dowod,Nazwa,Data,Numer,OkresDow=''):
    if OkresDow=='':
        OkresDow=self.okres_id

    # jeli dowd BO lub BK to nie otwieramy 
    if Dowod in ["BO","BK"]:
        return "Nie mona otwiera bilansu otwarcia ani korekty bilansu"
    
    # sprawdzenie czy istnieje dowd i czy jest w stanie Z
    SQL="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"'"
    SQL+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
    stat,DNagl,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>"OK":
        return "Bdy pobierania danych nagwka dowodu : "+stat
    if len(DNagl)<>1:
        return "Niepoprawne identyfikatory dowodu."
    if DNagl[0][0]<>"Z":
        return "Dowd nie jest zamknity"

    # pobranie typu dokumentu ze wzoru dekretacji
    SQL="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,DaneWz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bd pobierania wzoru dekretacji :'+stat

    if len(DaneWz)==0:
        return 'Brak podanego wzoru dekretacji :'+stat
    
    TypWzoru=DaneWz[0][0]
    
    # sprawdzenie czy mona usun patno
    SQL="SELECT COALESCE(CAST(platnosc_id AS TEXT),'') FROM rs_dowody_ksiegowe "
    SQL+="WHERE firma_id= '"+self.firma_id+"' AND okres_id='"+OkresDow+"' "
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer ='"+str(Numer)+"';"
    stat,DanePL,dump,dump = self.PolSQL.Execute(SQL,3)
    
    if stat<>'OK':
        return "Bd sprawdzania patnoci : "+stat
    
    Platnosc=str(DanePL[0][0]).strip()
    if not Platnosc in ['','0']: 
        SQL="SELECT stan FROM rs_platnosci WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+Platnosc+"; "
        stat,daneST,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return "Bd pobierania stanu patnoci : "+stat
        if len(daneST)==0:
            return "Brak spodziewanej patnoci o numerze "+Platnosc
        
        StanPL=str(daneST[0][0])
        if StanPL in ('P','Z'):
             return 'BL STAN PL'
    
    # sprawdzenie, czy miesic jest otwarty w okresie
    SQL="SELECT zamkniety FROM rs_definicje_okresow_miesiace WHERE firma_id='"+self.firma_id+"' "
    SQL+=" AND okres_id='"+OkresDow+"' AND rok='"+Data[0:4]+"' AND miesiac='"+Data[5:7]+"' AND zamkniety;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bd pobierania danych miesica w okresie : '+stat
    
    if len(DTest)>0:
        return 'BL MC ZAM'
  
    # sprawdzenie czy mona usun rozrachunki (bo s niezrozliczone)
    SQL="SELECT seria FROM rs_rozrachunki WHERE  firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"'"
    SQL+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND data_rozlicz IS NOT NULL;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bd pobierania danych z rozrachunkw : '+stat
   
    if len(DTest)>0:
        return "Nie mozna otworzy dokumentu - istniej rozliczone rozrachunki."

    # pobranie pozycji do otwierania
    SQL="SELECT COALESCE(dp.konto_wn,''),COALESCE(dp.konto_ma,''),COALESCE(dp.konto_vat_wn,''),COALESCE(dp.konto_vat_ma,''), " # 0-3
    SQL+="COALESCE(dp.data_ksieg_kosztow::TEXT,''),COALESCE(o.okres_id,'')," # 4-5
    SQL+="CASE WHEN om.zamkniety THEN 'True' WHEN NOT om.zamkniety THEN 'False' ELSE '' END," # 6
    SQL+=" COALESCE(kwota_wn,0),COALESCE(kwota_ma,0),COALESCE(kwota_vat_wn,0),COALESCE(kwota_vat_ma,0)," #7-10
    SQL+=" COALESCE(kwota_wal_wn,0),COALESCE(kwota_wal_ma,0),waluta_wn,waluta_ma" #11-12
    SQL+=" FROM rs_dowody_ksiegowe_pozycje dp LEFT OUTER JOIN rs_definicje_okresow o " 
    SQL+=" ON (dp.firma_id=o.firma_id AND o.data_od <= dp.data_ksieg_kosztow AND o.data_do>=dp.data_ksieg_kosztow) "
    SQL+=" LEFT OUTER JOIN rs_definicje_okresow_miesiace om ON (o.firma_id=om.firma_id AND o.okres_id=om.okres_id AND "
    SQL+=" om.rok::INT=EXTRACT(YEAR FROM dp.data_ksieg_kosztow) AND om.miesiac::INT=EXTRACT(MONTH FROM dp.data_ksieg_kosztow)) "
    SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.okres_id='"+OkresDow+"' AND dp.dowod_id='"+Dowod+"'"
    SQL+=" AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Numer)+" ORDER BY dp.nr_poz,dp.nr_ppoz;"
    stat,DPoz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bd pobierania pozycji dowodu : '+stat
    if len(DPoz)==0:
        return "Brak pozycji dowodu"
    
    SQLPoz=""
    
    for w in DPoz:
        KontoWn=rsglobal.Dekoduj(w[0])
        KontoMa=rsglobal.Dekoduj(w[1])
        KontoVatWn=rsglobal.Dekoduj(w[2])
        KontoVatMa=rsglobal.Dekoduj(w[3])
        DataKsiegK =rsglobal.Dekoduj(w[4])
        if DataKsiegK=='':
            DataKsieg=str(Data)
            OkresKsieg=rsglobal.Dekoduj(OkresDow)
        else:
            if w[5]=='':
                return "Brak okresu dla daty "+DataKsiegK
            if w[6] in ['True','TRUE',True]:
                return "Miesic w okresie "+w[5]+" dla daty "+DataKsiegK+" jest ju zamknity"
            DataKsieg=DataKsiegK
            OkresKsieg=rsglobal.Dekoduj(w[5])
            
        KwotaWn=w[7]
        KwotaMa=w[8]
        KwotaVatWn=w[9]
        KwotaVatMa=w[10]
        KwotaWalWn=w[11]
        KwotaWalMa=w[12]
        WalutaWn=rsglobal.Dekoduj(w[13])
        WalutaMa=rsglobal.Dekoduj(w[14])

        #--- KONTO WN
        if KontoWn <>"":
            if KwotaWalWn!=0 or TypWzoru == 'W':
                SQLPoz+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"',"
                SQLPoz+="'"+KontoWn+"','W',"+str(-1*KwotaWn)+",'"+WalutaWn+"',"+str(-1*KwotaWalWn)+");"
            else:
                SQLPoz+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"',"
                SQLPoz+="'"+KontoWn+"','W',"+str(-1*KwotaWn)+",'PLN',"+str(-1*KwotaWn)+");"
                
        #--- KONTO VAT WN
        if KontoVatWn <>"":
            SQLPoz+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"',"
            SQLPoz+="'"+KontoVatWn+"','W',"+str(-1*KwotaVatWn)+",'PLN',"+str(-1*KwotaVatWn)+");"

        #--- KONTO MA
        if KontoMa <>"":
            if KwotaWalMa!=0 or TypWzoru == 'W':
                SQLPoz+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"',"
                SQLPoz+="'"+KontoMa+"','M',"+str(-1*KwotaMa)+",'"+WalutaMa+"',"+str(-1*KwotaWalMa)+");"
            else:
                SQLPoz+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"',"
                SQLPoz+="'"+KontoMa+"','M',"+str(-1*KwotaMa)+",'PLN',"+str(-1*KwotaMa)+");"
            
        #--- KONTO VAT MA
        if KontoVatMa<>"":
            SQLPoz+="SELECT rsf_zapisz_stan_konta('"+self.firma_id+"','"+OkresKsieg+"','"+DataKsieg+"',"
            SQLPoz+="'"+KontoVatMa+"','M',"+str(-1*KwotaVatMa)+",'PLN',"+str(-1*KwotaVatMa)+");"

    SQLOp= "DELETE FROM rs_operacje WHERE  firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    SQLOp+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    SQLRozr="DELETE FROM rs_rozrachunki WHERE  firma_id='"+self.firma_id+"' AND okres_id='"+OkresDow+"'"
    SQLRozr+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    SQLStan="UPDATE rs_dowody_ksiegowe SET stan='G' WHERE firma_id='"+self.firma_id+"'"
    SQLStan+=" AND okres_id='"+OkresDow+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    SQLStan+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,dump,dump,dump = self.PolSQL.Execute(SQLPoz+SQLOp+SQLRozr+SQLStan,1)
    if stat<>'OK':
        return "Bdy zapytania otwierajcego dokument : "+stat
        
    if Platnosc<>'':
        UPD = "UPDATE rs_dowody_ksiegowe SET platnosc_id= NULL  WHERE "
        UPD+= "firma_id= '"+self.firma_id+"' AND okres_id='"+OkresDow+"' "
        UPD+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer ='"+str(Numer)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD ,1)
        if stat <>'OK':
            return 'BL UPD PL'

        UPDPL = "UPDATE rs_platnosci SET stan = 'U' , op_ed = "+str(self.operator_id)+" WHERE "
        UPDPL+= "firma_id= '"+self.firma_id+"' AND platnosc_id="+Platnosc+" "
        stat,dump,dump,dump = self.PolSQL.Execute(UPDPL ,1)
        if stat <>'OK':
            return 'BL UPD PLAT'

    return stat

# -------------------------------------------------------------------------------
# FUNKCJA SPRAWDZAJCA WYSTPOWANIE PARY KONTRAHENT - SYMBOL DOKUMENTU W SYSTEMIE  #AB 2023-06-30
# -------------------------------------------------------------------------------

def SprawdzPareKontrahentDokument(self, Tryb, Kontrahent='', NIP='', Dokument=None, Klucze=[]):
    """
    Funkcja szuka czy w systemie nie zosta ju wprowadzony dany dokument dla wskazanego kontrahenta. Tryb okrela
    skd startujemy, np. startujc z poziomu zaliczki naley te poszuka dokumentu w zagadnieniach i dowodach
    ksigowych. Kontrahenta mona szuka po systemowym ID bd NIPie, a Klucze zawiera symbole dokumentw ktrych
    nie bra pod uwag w wynikach.
    :param self: self niezbdny by wykonywa zapytania
    :param Tryb: 'ZA' - zaliczki, 'ZG' - zgadnienia, 'KP' - korespondencja przychodzca, 'DK' - dowody ksigowe
    :param Kontrahent: Id kontrahenta w systemie
    :param NIP: NIP kontrahenta
    :param Dokument: symbol dokumentu
    :param Klucze: klucze dokumentw do pominicia. 'ZA' - [zaliczka_id], 'ZG' - [zagadnienie_id],
                                                    'KP' - [oddzial_id, rok, numer],
                                                    'DK' - [okres_id, dowod_id, nazwa_id, data, numer]
    :return: stat(str), komunikat(str)
    """
    rsglobal.ZapiszDoLogow("Sprawdzanie pary kontrahent dokument \n\n\n\n\n\n")
    args_kontrahent = []
    data_dokumentu = None  #AB 2023-08-01

    if NIP == '' and Kontrahent == '':
        return 'OK', ''
    if Dokument == '':
        return 'OK', ''
    if Tryb not in ('ZA', 'ZG', 'KP', 'DK'):
        return 'podano nieprawidowy tryb', ''
    if not Klucze:
        return 'nie podano kluczy do szukania powtrek', ''

    #pobranie danych z naglowka DK
    if Tryb == 'DK':
        #podczas zamykania wywoujemy z None eby pobra dane z bazy
        if Dokument is None and NIP is None and Kontrahent is None:
            SQL = """SELECT COALESCE(kontrahent_id,''), COALESCE(TRIM(symbol_dok)), COALESCE(nip,'')
                                 FROM rs_dowody_ksiegowe
                                 LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk
                                     USING (firma_id, okres_id, dowod_id, nazwa_id, DATA, numer)
                                 WHERE (firma_id, okres_id, dowod_id, nazwa_id, data, numer) 
                                 = (%s, %s, %s, %s, %s, %s);"""
            if not Klucze:
                return "Nie podano klucza dowodu ani symbolu dokumentu", ''
            okres_id, dowod_id, nazwa_id, data, numer = Klucze
            args = [self.firma_id, okres_id, dowod_id, nazwa_id, data, numer]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
            stat, dane_dk, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                return "Bd pobierania danych dowodu ksigowego {}/{}/{}/{}".format(dowod_id, nazwa_id, data,
                                                                                     numer) + stat, ''
            if len(dane_dk) < 1:
                return "Nie odnaleziono dowodu ksigowego {}/{}/{}/{}".format(dowod_id, nazwa_id, data, numer), ""
            Kontrahent, Dokument, NIP = dane_dk[0]
        elif NIP is None and Kontrahent.strip() == '':  # w edycji danych DK nie mamy NIPu kontrahenta
            SQL = """SELECT COALESCE(kontrahent_id,''), COALESCE(TRIM(symbol_dok)), COALESCE(nip,'')
                                 FROM rs_dowody_ksiegowe
                                 LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk
                                     USING (firma_id, okres_id, dowod_id, nazwa_id, DATA, numer)
                                 WHERE (firma_id, okres_id, dowod_id, nazwa_id, data, numer) 
                                 = (%s, %s, %s, %s, %s, %s);"""
            if not Klucze:
                return "Nie podano klucza dowodu ani symbolu dokumentu", ''
            okres_id, dowod_id, nazwa_id, data, numer = Klucze
            args = [self.firma_id, okres_id, dowod_id, nazwa_id, data, numer]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
            stat, dane_dk, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                return "Bd pobierania danych dowodu ksigowego {}/{}/{}/{}".format(dowod_id, nazwa_id, data,
                                                                                     numer) + stat, ''
            if len(dane_dk) < 1:
                return "Nie odnaleziono dowodu ksigowego {}/{}/{}/{}".format(dowod_id, nazwa_id, data, numer), ""
            NIP = dane_dk[0][2]
        elif Dokument is None and NIP is not None and Kontrahent is None:  # w edycji danych kontrahenta nie mamy
                                                                            # symbolu dokumentu
            SQL = """SELECT COALESCE(kontrahent_id,''), COALESCE(TRIM(symbol_dok))
                                 FROM rs_dowody_ksiegowe
                                 LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk
                                     USING (firma_id, okres_id, dowod_id, nazwa_id, DATA, numer)
                                 WHERE (firma_id, okres_id, dowod_id, nazwa_id, data, numer) 
                                 = (%s, %s, %s, %s, %s, %s);"""
            if not Klucze:
                return "Nie podano klucza dowodu ani symbolu dokumentu", ''
            okres_id, dowod_id, nazwa_id, data, numer = Klucze
            args = [self.firma_id, okres_id, dowod_id, nazwa_id, data, numer]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
            stat, dane_dk, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                return "Bd pobierania danych dowodu ksigowego {}/{}/{}/{}".format(dowod_id, nazwa_id, data,
                                                                                     numer) + stat, ''
            if len(dane_dk) < 1:
                return "Nie odnaleziono dowodu ksigowego {}/{}/{}/{}".format(dowod_id, nazwa_id, data, numer), ""
            Kontrahent, Dokument = dane_dk[0]

        if Dokument == '' or (Kontrahent == '' and NIP == ''):
            return 'OK', ''

    if NIP:
        # POBRANIE KONTRAHENTW Z DANYM NIPEM
        SQL = """SELECT kontrahent_id
                 FROM rs_kontrahenci
                 WHERE firma_id = %s
                     AND regexp_replace(nip, '[^0-9]', '', 'g') = regexp_replace(%s, '[^0-9]', '', 'g');"""
        args = [self.firma_id, NIP]

        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

        stat, tmp_kontr, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd pobierania listy kontrahentw: '+stat, ''
        elif len(tmp_kontr) > 0:
            Kontrahenci = [x[0] for x in tmp_kontr]
        else:
            Kontrahenci = []

    else:
        Kontrahenci = [Kontrahent]

    if NIP:
        war_kontrahent = " AND (kontrahent_id IN {} OR regexp_replace(nip, '[^0-9]', '', 'g') = regexp_replace(%s, '[^0-9]', '', 'g'))"
        args_kontrahent.append(NIP)
    else:
        war_kontrahent = " AND kontrahent_id IN {}"
    war_kontrahent = war_kontrahent.format("('" + ("', '".join(Kontrahenci)) + "')")

    if Tryb == 'ZA':
        zaliczka_id, nr_poz = Klucze
        args = [self.firma_id, zaliczka_id, nr_poz, Dokument]
        SQL = """SELECT zaliczka_id, nr_poz::int
                 FROM rs_wf_zaliczki_pozycje
                 WHERE firma_id = %s AND (zaliczka_id != %s or nr_poz != %s)
                     AND UPPER(TRIM(%s)) = UPPER(TRIM(symbol_dokumentu)) {} ;"""
        SQL = SQL.format(war_kontrahent)
        args+=args_kontrahent
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

        #SZUKANIE ZALICZEK Z PODANYM KONTRAHENTEM WHERE kontrahent in <Kontrahenci> and zaliczka_id != <zaliczka_id> do zmiennej dupliakty

        stat, duplikaty, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd pobierania listy zaliczek: '+stat, ''
        if duplikaty:
            duplikaty_opis = "zaliczkach: \n" + ("\n".join([', '.join([str(y).strip() for y in x]) for x in duplikaty]))
            return 'OK',  "Dokument {} dla danego kontrahenta wystpuje ju na {} (Zaliczka, Nr pozycji)".format(Dokument, duplikaty_opis)
        else:
            Tryb = 'ZG'
            #WS 2023-08-22 - dodane aliasy tabel
            #pobranie zagadnie utworzonych z zaliczki  #AB 2023-08-01
            SQL = """SELECT COALESCE(zp.zagadnienie_id, -1), COALESCE(data_dokumentu, data)
                     FROM rs_wf_zaliczki_pozycje zp
                     JOIN rs_wf_zaliczki z using(zaliczka_id)
                     WHERE zp.firma_id = %s 
                         AND zp.zaliczka_id = %s and zp.nr_poz = %s;"""
            args = [self.firma_id, zaliczka_id, nr_poz]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

            stat, pozycja, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow(SQL)
            if stat != 'OK':
                return 'Bd pobierania listy zagadnie: ' + stat, ''
            if pozycja:
                Klucze = [pozycja[0][0]]  #AB 2023-08-01
                data_dokumentu = pozycja[0][1]  #AB 2023-08-01
            else:
                Klucze = [-1]

    if Tryb == 'KP':
        oddzial_id, rok, numer = Klucze
        # SZUKANIE KORESPONDENCJI Z PODANYM KONTRAHENTEM WHERE firma_id=<firma_id> and <war_kontrahent>
        # and (oddzial_id, rok, numer) !=(<oddzial_id>, <rok>, <numer>) do zmiennej dupliakty
        SQL = """SELECT oddzial_id, rok, numer::INT
                  FROM rs_wf_korespondencja_przychodzaca
                  WHERE firma_id = %s AND (oddzial_id,rok,numer) != (%s, %s, %s) AND UPPER(TRIM(%s)) = UPPER(TRIM(symbol_dokumentu)) {};"""
        args = [self.firma_id, str(oddzial_id), rok, numer, Dokument]

        SQL = SQL.format(war_kontrahent)

        args += args_kontrahent

        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, duplikaty, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            return "Bd szukania duplikatw w korespondencji przychodzcej: "+stat, ''
        if duplikaty:
            duplikaty_opis = "pozycjach: \n" + ("\n".join([', '.join([str(y).strip() for y in x]) for x in duplikaty])) + " (Oddzia, Rok, Numer)"
            return 'OK', "Dokument {} dla danego kontrahenta wystpuje ju w korespondencji na {}".format(Dokument,
                                                                                                         duplikaty_opis)
        else:
            Tryb = 'ZG'
            #pobranie zagadnie utworzonych z korespondencji  #AB 2023-08-01
            SQL = """SELECT COALESCE(zagadnienie_id, -1), COALESCE(data_dokumentu, data)
                     FROM rs_wf_korespondencja_przychodzaca
                     WHERE firma_id = %s AND (oddzial_id,rok,numer) = (%s, %s, %s);"""
            args = [self.firma_id, oddzial_id, rok, numer]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

            stat, pozycja, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                return 'Bd pobierania listy zagadnie: ' + stat, ''
            if pozycja:
                Klucze = [pozycja[0][0]]   #AB 2023-08-01
                data_dokumentu = pozycja[0][1]  #AB 2023-08-01
            else:
                Klucze = [-1]

    if Tryb == 'ZG':
        zagadnienie = Klucze[0]

        SQL = """SELECT zagadnienie_id
                 FROM rs_wf_zagadnienia
                 WHERE firma_id=%s AND zagadnienie_id!=%s AND UPPER(TRIM(%s)) = UPPER(TRIM(symbol_dokumentu)) {};"""
        args = [self.firma_id, zagadnienie, Dokument]
        SQL = SQL.format(war_kontrahent)
        args += args_kontrahent
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

        #SZUKANIE ZAGADNIE Z PODANYM KONTRAHENTEM WHERE firma_id=<firma_id> and <war_kontrahent> and zagadnienie_id != <zagadnienie_id> do zmiennej dupliakty
        stat, duplikaty, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            return "Bd szukania duplikatw w zagadnieniach: "+stat, ''
        if duplikaty:
            duplikaty_opis = "zagadnieniach:\n" + (", ".join([str(x[0]) for x in duplikaty]))
            return 'OK',  "Dokument {} dla danego kontrahenta wystpuje ju na {}".format(Dokument, duplikaty_opis)
        else:
            Tryb = 'DK'
            if data_dokumentu is None:  #AB 2023-08-17 czasowa atka na 2023-01-01
                #pobranie daty dokumentu lub zagadnienia
                SQL = """SELECT COALESCE(data_dokumentu, '2023-01-01'::DATE)
                         FROM rs_wf_zagadnienia
                         WHERE zagadnienie_id=%s;"""
                args = [zagadnienie]
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

                stat, data, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
                if stat != 'OK':
                    return 'Bd pobierania daty dokumentu: ' + stat, ''
                if data:
                    data_dokumentu = data[0][0]
                else:  #AB 2023-08-17 czasowa atka na 2023-01-01
                    data_dokumentu = '2023-01-01'
            if zagadnienie:
                #pobranie dk utworzonego z zagadnienia(WHERE firma_id=<firma_id> and zagadnienie_id=<zagadnienie_id>)
                SQL = """SELECT okres_id, dowod_id, nazwa_id, data, numer
                         FROM rs_dowody_ksiegowe
                         WHERE firma_id = %s AND zagadnienie_id = %s;"""
                args = [self.firma_id, zagadnienie]
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
                stat, dowod, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)

                if dowod:
                    Klucze = dowod[0]  #AB 2023-09-05
                else:
                    Klucze = []
            else:
                Klucze = []

    if Tryb == 'DK':

        args = [self.firma_id, Dokument]
        args += args_kontrahent
        war_dowod = ""
        if Klucze:
            war_dowod = "AND (okres_id, dowod_id, nazwa_id, data, numer) != "
            okres_id, dowod_id, nazwa_id, data, numer = Klucze
            war_dowod += "(%s, %s, %s, %s, %s)"
            args += [okres_id, dowod_id, nazwa_id, data, numer]
        else:  #AB 2023-08-01
            stat, Okres = fs_okresy_pom.PodajOkresDlaDaty(self, data_dokumentu)
            if stat != 'OK':
                return stat, ''
            okres_id = Okres
        #AB 2023-08-01
        war_dowod += " AND okres_id = %s "
        args += [okres_id]


        SQL = """SELECT okres_id, dowod_id, nazwa_id, data, numer::int
                 FROM rs_dowody_ksiegowe
                 LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk
                     USING (firma_id, okres_id, dowod_id, nazwa_id, DATA, numer)
                 WHERE firma_id = %s
                    AND UPPER(TRIM(%s)) = UPPER(TRIM(symbol_dok)) {} {};""".format(war_kontrahent, war_dowod)


        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

        #SZUKANIE DOWODW Z PODANYM KONTRAHENTEM WHERE firma_id=<firma_id> and <war_kontrahent>
        # and (okres_id, dowod_id, nazwa_id, data, numer) != (<okres_id>, <dowod_id>, <nazwa_id>, <data>, <numer>) do zmiennej dupliakty
        # eby zadziaao OR kontr.nip = <NIP> trzeba doda LEFT OUTER JOIN na rs_dowody_ksiegowe_kontrahent
        stat, duplikaty, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            return "Bd szukania duplikatw w dowodach ksigowych: " + stat, ''
        if duplikaty:
            duplikaty_opis = "dowodach:\n" + (", \n".join(['/'.join([str(y).strip() for y in x]) for x in duplikaty])) + " (Okres/Dowd/Nazwa/Data/Numer)"
            return 'OK',  "Dokument {} dla danego kontrahenta wystpuje ju na {}".format(Dokument, duplikaty_opis)
    return 'OK', ''
