# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_pozycje.py
# Purpose:     pobieranie/edycja/usuwanie pozycji dowodu ksigowego 
#
# Author:      Dariusz Boduch
# Created:     2008/04/09
# RCS-ID:      $Id: fs_dowody_ksiegowe_pozycje.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2011-11-26 Mariusz Rajfura   - (5079) uszczelnienie: blokada zmian dla stanu Z 
# 2012-11-12 Mariusz Rajfura   - (6246) uzup.danych walutowych przy imporcie pozycji jesli wzor dekretacji w PLN
# 2015-11-21 Piotr Witkowski   - (9411) pena refaktoryzacja okna 'pozycje dowodw ksigowych'
# 2022-05-10 Wojciech Skowron  - (13004) zmiana M na W przy usuwaniu pozycji

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
    
if stat=='OK':    
    Funkcja = klucze['Funkcja']    
    
    SlPar={'Dowod':[5,6,22],'Nazwa':[5,6,22],'Data':[5,6,22],'Numer':[5,6,22],'NrPoz':[6],'NrPpoz':[6]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dowody_ksiegowe_pozycje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [5,6,22]: 
            Dowod = str(klucze['Dowod'])
            Nazwa = str(klucze['Nazwa'])
            Data  = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja == 6: 
            NrPoz = int(float(klucze['NrPoz']))
            NrPpoz = int(float(klucze['NrPpoz']))
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
# -------------Uprawnienia
#-------------------------------------------------------------------------------

UprUsuwanie = (self.oddzial_id,'075024') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprDodawanie = (self.oddzial_id,'075023') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
# Funkcja == 22 - pobranie stanu dowodu
#-------------------------------------------------------------------------------

if Funkcja == 22:
    sql ="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dowodu ksigowego: '+stat
    elif len(dane) <> 1:
        stat = 'Brak dowodu o podanym numerze'


#-------------------------------------------------------------------------------
# Funkcja == 6 - usuniecie pozycji/podpozycji z dowodu ksiegowego
#-------------------------------------------------------------------------------

if Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania pozycji w dowodzie ksigowym.'
    
    if stat == 'OK':
        sql ="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu dowodu ksigowego: '+stat
        elif len(d) <> 1:
            stat = 'Brak dowodu o podanym numerze'
        elif str(d[0][0]) == 'Z':
            stat = 'Dowd ksigowy zosta zamknity. Operacja niemoliwa.'
        
    if stat == 'OK':        
        #sprawdzenie, czy to jedyna pozycja na dowodzie
        sql ="SELECT COUNT(nr_poz) FROM rs_dowody_ksiegowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"'"
        sql+=" AND numer="+str(Numer)+";"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania danych pozycji dowodu ksigowego : '+stat
    
    if stat == 'OK':
        if len(d) == 0:
            stat = 'Bd pobrania danych pozycji dowodu ksigowego : '+stat
            
    if stat == 'OK':
        if d[0][0] == 1: 
            stat = 'Nie mona usuwa jedynej pozycji w dowodzie ksigowym.'
    
    if stat == 'OK':
        #sprawdzenie, czy pozycja ma podpozycje
        sql ="SELECT COUNT(nr_poz) FROM rs_dowody_ksiegowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"'"
        sql+=" AND numer="+Numer+" AND nr_poz="+str(NrPoz)+";"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania danych pozycji dowodu ksigowego : '+stat
    
    if stat == 'OK':
        if len(d) == 0:
            stat = 'Bd pobrania danych pozycji dowodu ksigowego : '+stat
            
    if stat == 'OK':
        upd = ''

        if d[0][0] == 1:
            #usuwana pozycja nie ma podpozycji
            
            # pobranie maksymalnego numeru pozycji
            SQLTest="SELECT COUNT(*),MAX(nr_poz) FROM rs_dowody_ksiegowe_pozycje"
            SQLTest+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
            SQLTest+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"'"
            SQLTest+=" AND numer="+Numer+" AND nr_poz > "+str(NrPoz)+"; "
            stat,DTest,dump,dump = self.PolSQL.Execute(SQLTest,3)
            if stat <> 'OK':
                stat = 'Bd analizy numeracji pozycji dowodu ksigowego : '+stat
                
            if stat == 'OK':
                # jeli maksymalny nr pozycji i przesunicie przekraczaj 99999 to niedobrze
                if DTest[0][0]+DTest[0][1]>99999:
                    stat='Nie mona usun pozycji, bo przesunicie przekracza 99999'
            
            if stat == 'OK':
                Przesuniecie=str(DTest[0][0])
                
                upd+= "UPDATE rs_dowody_ksiegowe_pozycje"
                upd+=" SET nr_poz=nr_poz+"+Przesuniecie+" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                upd+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"'"
                upd+=" AND numer="+Numer+" AND nr_poz > "+str(NrPoz)+"; "
                
                upd+= "UPDATE rs_dowody_ksiegowe_pozycje"
                upd+=" SET nr_poz=nr_poz-"+Przesuniecie+"-1 WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                upd+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"'"
                upd+=" AND numer="+Numer+" AND nr_poz > "+Przesuniecie+"+"+str(+NrPoz)+"; "
            
        elif d[0][0] > 1:
            #sa podpozycje, wiec nalezy przenumerowac podpozycje
            
            # pobranie maksymalnego numeru pozycji
            SQLTest="SELECT COUNT(*),MAX(nr_poz) FROM rs_dowody_ksiegowe_pozycje"
            SQLTest+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
            SQLTest+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"'"
            SQLTest+=" AND numer="+Numer+" AND nr_poz = "+str(NrPoz)+" AND nr_ppoz > "+str(NrPpoz)+"; "
            stat,DTest,dump,dump = self.PolSQL.Execute(SQLTest,3)
            if stat <> 'OK':
                stat = 'Bd analizy numeracji podpozycji dowodu ksigowego : '+stat
                
            if stat == 'OK':
                # jeli maksymalny nr pozycji i przesunicie przekraczaj 99999 to niedobrze
                if DTest[0][0]+DTest[0][1]>99999:
                    stat='Nie mona usun podpozycji, bo przesunicie przekracza 99999'
            
            if stat == 'OK':
                Przesuniecie=str(DTest[0][0])
            
            if stat == 'OK':
                upd+= "UPDATE rs_dowody_ksiegowe_pozycje" 
                upd+=" SET nr_ppoz=nr_ppoz+"+Przesuniecie+" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                upd+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer
                upd+=" AND nr_poz = "+str(NrPoz)+" AND nr_ppoz > "+str(NrPpoz)+"; "
                
                upd+= "UPDATE rs_dowody_ksiegowe_pozycje"
                upd+=" SET nr_ppoz=nr_ppoz-"+Przesuniecie+"-1 WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                upd+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer
                upd+=" AND nr_poz = "+str(NrPoz)+" AND nr_ppoz > "+Przesuniecie+"+"+str(NrPpoz)+"; "

        SQL = "DELETE FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        SQL+=" AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"'"
        SQL+=" AND numer="+Numer+" AND nr_poz = "+str(NrPoz)+" AND nr_ppoz = "+str(NrPpoz)+"; "
        
        SQL += upd

        #Sprawdzamy czy na usuwanej pozycji by projekt wn albo ma
        if stat == 'OK':
            PROJ =  " SELECT projekt_wn,projekt_ma FROM rs_dowody_ksiegowe_pozycje WHERE  firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' "
            PROJ += " AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer
            PROJ += " AND nr_poz = "+str(NrPoz)+" AND nr_ppoz = "+str(NrPpoz)+" AND (projekt_wn is not null or projekt_ma is not null); "
            stat,czy_przeliczac,dump,dump = self.PolSQL.Execute(PROJ,3)
            if stat <> 'OK':
                stat = 'Bd usuwania pozycji dowodu ksigowego : '+stat

        if stat == 'OK':
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat = 'Bd usuwania pozycji dowodu ksigowego : '+stat

        if stat == 'OK':
            #WS 2022-05-10
            SQL = "UPDATE rs_dowody_ksiegowe SET stan=CASE WHEN stan='M' THEN 'W' ELSE stan END WHERE "
            SQL += "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                stat = 'Bd przy aktualizacji stanu dowodu'+stat

        if czy_przeliczac:
            from funkcje import fs_dowody_ksiegowe_projekty_tworzenie
            stat=fs_dowody_ksiegowe_projekty_tworzenie.StworzPozycjeProjektoweWDowodzieKsiegowym(self.firma_id,self.okres_id,Dowod,Nazwa,Data,Numer,self.PolSQL)
            if stat != 'OK':
                stat = 'Bdy przeliczania projektw dla dowodu ksigowego.'


#-------------------------------------------------------------------------------
# Pobranie danych do grida pozycji danego dokumentu i nru dokumentu na wydruk
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5,6):
    sql ="SELECT nr_poz,nr_ppoz,konto_wn,kwota_wn,tresc_wn,konto_ma,kwota_ma,tresc_ma,"
    sql+=" konto_vat_wn,kwota_vat_wn,konto_vat_ma,kwota_vat_ma,zamkniecie_kregu"
    sql+=" FROM rs_dowody_ksiegowe_pozycje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" ORDER BY nr_poz,nr_ppoz;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania pozycji dowodu ksigowego : '+stat
        
    if stat == 'OK':
        klucz=str([Dowod,Nazwa,Data,Numer]).replace("'",'"')
        sql ="SELECT rsf_podaj_numer_dokumentu_na_wydruk("
        sql+="'"+self.firma_id+"','"+klucz+"','D');"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bd w pobieraniu numeru dowodu ksigowego do wydruku: '+stat
        else:
            wyn2 = d