# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane pozycji dokumentu magazynowego 
#
# Author:      Marcin Grzeda
# Created:     2007/02/03
# RCS-ID:      $Id: fs_dowody_ksiegowe_pozycje_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2009-04-30 - Dariusz Boduch - poprawki - mantis: 1982
#2009-06-22 - Dariusz Boduch - sprawdzanie uprawnie do edycji
#2010-12-10 - Mariusz Rajfura - kontrola stawek VAT z terminami obowiazywania (4099)
#2013-10-30 - Micha Raburski - obsuga typu W - rnic kursowych (7309)
#2020-03-21 - Wojciech Skowron - pole kod_gtu (11909)
#2022-02-04 Aleksander Bargie (12859) [KS] Zdj kontrol na konto bilansowe przy koncie vat
#2022-02-24 Aleksander Bargie (12903) brak moliwoci edycji pozycji dowodu ksigowego
#2022-05-10 Wojciech Skowron   (13004) przy modyfikacji zmiana z 'M' na 'W'

Dowod=rsglobal.Dekoduj(klucze[0])
Nazwa=rsglobal.Dekoduj(klucze[1])
Data=rsglobal.Dekoduj(klucze[2])
Numer=str(klucze[3])
NrPoz=str(klucze[4])
NrPPoz=str(klucze[5])
FunkcjaOkna=klucze[6]
Konto=str(klucze[7])
Pola=pola
Wartosci=wartosci

Fun=klucze[-1]

stat="OK"
dane=[]
DanePoz=[]

puste_pola = [[],"","    -  -  ",None,'None','NULL']


#-------------------------------------------------------------------------------
#-- POBRANIE TYPU WZORU DEKRETACJI DLA DOWODU KSIGOWEGO
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 19:
    SQL="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'; "
    
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    

#-------------------------------------------------------------------------------
#-- SPRAWDZENIE UPRAWNIE
#-------------------------------------------------------------------------------

if stat=='OK' and Fun <> 19:
    UprTotal=True
    #Pobranie uprawnien do pozycji dokumentw ksigowych dla operatora
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprTotal=True
        UprUpd =True;
        LEdy=[]
    else:
        Sel="SELECT dowod_id,nazwa_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie "
        Sel+="FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id in "
        Sel+=""+str(self.operatorzy).replace("[","(").replace("]",")")+" AND okres_id='"+self.okres_id+"'; "
        
        stat,daneupr,dump,dump = self.PolSQL.Execute(Sel,3)
        
        if stat<>'OK':
            stat = "BR SPR1"
            dane.append(stat)                        
        if stat=='OK':
            if len(daneupr)>0:
                UprTotal=False
            else:
                UprTotal=True
            LEdy=[]

            UprUpd =(self.oddzial_id,'075022') in self.uprawnienia 
            
            for d in daneupr:
                if UprUpd:
                    if d[3]:
                        LEdy.append((rsglobal.Dekoduj(d[0]),rsglobal.Dekoduj(d[1])))

#-------------------------------------------------------------------------------
# sprawdzenie danych przed update
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat == 'OK':
    # pobranie typu wzoru
    SQL="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'; "
    stat,DWzoru,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        TypWzoru = DWzoru[0][0]
    
        #sprawdzenie czy waluta jest rozna od PLN  i dopasowanie kursu
        sql = "SELECT waluta_wn,waluta_ma,kurs_wn,kurs_ma,data_ksieg_kosztow,"
        sql+=" konto_wn,konto_vat_wn,konto_ma,konto_vat_ma,data_wyst,"
        sql+=" stawka_vat_wn, stawka_vat_ma"
        sql+=" FROM rs_dowody_ksiegowe_pozycje "
        sql+= "WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+";"
        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)    
    if stat=='OK':
        if len(dane_wyn)==0:
            stat="BR POZ"
            dane.append(stat)
    
    if stat=="OK":    
        WalWn=dane_wyn[0][0]
        WalMa=dane_wyn[0][1]
        KursWn=dane_wyn[0][2]
        KursMa=dane_wyn[0][3]
        DataKsiegKosztow=dane_wyn[0][4]
        KontoWn=rsglobal.Dekoduj(dane_wyn[0][5])
        KontoVATWn=rsglobal.Dekoduj(dane_wyn[0][6])
        KontoMa=rsglobal.Dekoduj(dane_wyn[0][7])
        KontoVATMa=rsglobal.Dekoduj(dane_wyn[0][8])
        DataWyst=rsglobal.Dekoduj(dane_wyn[0][9])
        StawkaVATWnP=rsglobal.Dekoduj(dane_wyn[0][10])
        StawkaVATMaP=rsglobal.Dekoduj(dane_wyn[0][11])
        
        #sprawdzenie czy cos nie jest zmieniane
        for i in range(len(Pola)):
            pole = Pola[i]
            wart = Wartosci[i]

            if pole =="waluta_wn" and stat=='OK': 
                if wart=='':
                    stat='BR WALWN'
                    dane.append(stat)
                else:
                    #sprawdzenie poprawnoci waluty wn
                    stat,dwal,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"'" ,3)    
                    if stat=='OK':
                        if len(dwal)==0:
                            stat="BL WALWN"
                            dane.append(stat)
                           
                WalWn=wart
            elif pole=="waluta_ma"  and stat=='OK':
                if wart=='':
                    stat='BR WALMA'
                    dane.append(stat)
                else:
                    #sprawdzenie poprawnoci waluty ma
                    stat,dwal,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"'" ,3)    
                    if stat=='OK':
                        if len(dwal)==0:
                            stat="BL WALMA"
                            dane.append(stat)
                            
                WalMa=wart
            elif pole=="kurs_wn":
                KursWn=wart
            elif pole=="kurs_ma":
                KursMa=wart
           
        #sprawdzenie poprawnoci waluty,kursu
    if stat=='OK':
        if (WalWn=='PLN' and KursWn <>1) or (WalWn<>'PLN' and KursWn ==1 and TypWzoru <>'W'): 
            stat='BL KURSWN'
            dane.append(stat)
        if (WalMa=='PLN' and KursMa <>1) or (WalMa<>'PLN' and KursMa ==1 and TypWzoru <>'W'): 
            stat='BL KURSMA'
            dane.append(stat)
    
    #sprawdzenie daty ksiegowania kosztow - pobranie lub uwzglednienie zmienionej
    if stat=='OK':
        if 'data_ksieg_kosztow' in Pola:
            for i in range(len(Pola)):
                pole = Pola[i]
                wart = Wartosci[i]
                if pole =="data_ksieg_kosztow":
                    if wart in puste_pola:
                        Wartosci[i]='NULL'
                        DataKsiegKosztow=None
                    else:
                        if not rsglobal.SprawdzCzyToData(wart):
                            stat='BL_DATA_KSIEG_KOSZTOW'
                            dane.append(stat)
                        else:
                            DataKsiegKosztow=wart
                            
                #dodanie kont do pl w celu ponownej weryfikacji ich istnienia w odpowiednim okresie
                if stat=='OK':
                    if 'konto_wn' not in Pola:
                        Pola.append('konto_wn')
                        Wartosci.append(KontoWn)
                    if 'konto_vat_wn' not in Pola:
                        Pola.append('konto_vat_wn')
                        Wartosci.append(KontoVATWn)
                    if 'konto_ma' not in Pola:
                        Pola.append('konto_ma')
                        Wartosci.append(KontoMa)
                    if 'konto_vat_ma' not in Pola:
                        Pola.append('konto_vat_ma')
                        Wartosci.append(KontoVATMa)
 
    # uwzglednienie daty ksiegowania kosztow w wyborze okresu kont
    if stat=='OK':
        if DataKsiegKosztow in  puste_pola:
            OkresKont=self.okres_id               
        else:
            SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' "
            SQL+=" AND data_od<='"+DataKsiegKosztow+"' AND data_do >='"+DataKsiegKosztow+"';"
            stat,DaneOkr,dump,dump = self.PolSQL.Execute(SQL ,3)    
            if stat=='OK':
                if len(DaneOkr)==0:
                    stat="BR OKR DATY KSIEG"
                    dane.append(stat)
                else:
                    OkresKont=rsglobal.Dekoduj(DaneOkr[0][0])
            
    StawkaVATWn = StawkaVATWnP
    StawkaVATMa = StawkaVATMaP
    StawkaVATWnPozaTerminem = False
    StawkaVATMaPozaTerminem = False
    
    if stat=="OK":
        for i in range(len(Pola)):
            pole = Pola[i]
            wart = Wartosci[i]
            if pole =="data_wyst":
                if wart in puste_pola:
                    Wartosci[i]='NULL'
                    DataWyst = None
                else:
                    if rsglobal.SprawdzCzyToData(wart):
                        DataWyst = wart
                    else:
                        stat='BL_DATA_WYST'
                        dane.append(stat)
                        
            elif pole =="data_wplywu":
                if wart in puste_pola:
                    Wartosci[i]='NULL'
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL_DATA_WPLYWU'
                        dane.append(stat)
            elif pole =="termin_plat":
                if wart in puste_pola:
                    Wartosci[i]='NULL'
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL_TERMIN_PLAT'
                        dane.append(stat)
            elif pole =="data_zapl":
                if wart in puste_pola:
                    Wartosci[i]='NULL'
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL_DATA_ZAPL'
                        dane.append(stat)
            #WS 2020-03-21
            elif pole == "kod_gtu":
                if wart in puste_pola:
                    Wartosci[i]='NULL'
                else:
                    sql = "SELECT kod FROM rs_kody_towarow_uslug WHERE kod = '"+wart+"';"
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                    if len(dane_wyn) == 0:
                        stat="BL_KOD_GTU"
                        dane.append(stat)
            elif pole =="kontrahent_id":
                if wart == '':
                    Wartosci[i]='NULL'
                else:
                    sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                    if len(dane_wyn) == 0:
                        stat="BL_KONTR"
                        dane.append(stat)
            elif pole =="konto_wn":
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresKont+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '' or Dane[1] =='':# sprawdzamy te opis 
                            stat='BL_KONTO_WN'
                            dane.append(stat)    
                        elif (not Dane[2]) and (not ((Dowod in ['BO','BK']) or (len(wart) <> 3))):
                            stat='KONTO_WN_NIE_KSIE'
                            dane.append(stat)
                            
                    else:
                        stat='BL_KRY_KONTO_WN'
                        dane.append(stat)
                
            elif pole =="konto_vat_wn":
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresKont+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '' or Dane[1] =='':# sprawdzamy te opis 
                            stat='BL_KONTO_VAT_WN'
                            dane.append(stat)
                        elif not Dane[2]:
                            stat='NIE_KSIEGOWANE_KONTO_VAT_WN'
                            dane.append(stat)
                        #AB 04.02.22r
                        # if Dane[4]:
                        #     stat='NIE_POZABILANSOWE_KONTO_VAT_WN'
                        #     dane.append(stat)
                    else:
                        stat='BL_KRYTYCZNY_KONTO_VAT_WN'
                        dane.append(stat)
            elif pole =="stawka_vat_wn":
                if wart.strip() == '':
                    Wartosci[i]='NULL'
                    StawkaVATWn = Wartosci[i]
                else:
                    StawkaVATWn = wart
                    sql="SELECT kod FROM rs_stawki_vat WHERE kod = '"+wart+"';"
                    dump,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                    if Dane == []:
                        stat='BL_STAWKA_VAT_WN'
                        dane.append(stat)
                        
            elif pole =="projekt_wn":
                if wart == '':
                    Wartosci[i]='NULL'
                else:
                    sql="SELECT data_od,data_do FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+wart+"';"
                    stat,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if Dane == []:
                            stat='BL_PROJ_WN'
                            dane.append(stat)
                        else:
                            if Dane[0][0] <> 'None':
                                if Data < Dane[0][0]:
                                    stat = 'BL_PROJ_WN_DATAOD'
                                    dane.append(stat)
                            if Dane[0][1] <> 'None':
                                if Data > Dane[0][1]:
                                    stat = 'BL_PROJ_WN_DATADO'
                                    dane.append(stat)

            elif pole =="seria_wn":
                # pole jest list numerkw rozdzielon przecinkami
                if wart <> '':
                    LWart=wart.split(',')
                    for nr in LWart:
                        if stat=='OK':
                            sql="SELECT seria FROM rs_rozrachunki WHERE seria="+str(nr)+";"
                            stat,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                            if stat=='OK':
                                if Dane == []:
                                    stat='Bdny numer rozrachunku wn:'+str(nr)
                                    dane.append(stat)
                
            elif pole =="sposob_rozl":
                if wart <> '':
                    sql="SELECT kod FROM rs_sposob_rozl_vat WHERE kod = '"+wart+"';"
                    dump,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                    if Dane == []:
                        stat='BL_SPOSOB_ROZL'
                        dane.append(stat)
                        
                
            elif pole=="konto_ma":
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresKont+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '' or Dane[1] =='':# sprawdzamy te opis 
                            stat='BL_KONTO_MA'
                            dane.append(stat)    
                        elif (not Dane[2]) and (not ((Dowod in ['BO','BK']) or (len(wart) <> 3))):
                            stat='KONTO_MA_NIE_KSIE'
                            dane.append(stat)
                               
                    else:
                        stat='BL_KRY_KONTO_MA'
                        dane.append(stat)
                
            elif pole=="konto_vat_ma":
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresKont+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '' or Dane[1] =='':# sprawdzamy te opis 
                            stat='BL_KONTO_VAT_MA'
                            dane.append(stat)
                        elif not Dane[2]:
                            stat='NIE_KSIEGOWANE_KONTO_VAT_MA'
                            dane.append(stat)
                        #AB 04.02.22r
                        # if Dane[4]:
                        #     stat='NIE_POZABILANSOWE_KONTO_VAT_MA'
                        #     dane.append(stat)
                    else:
                        stat='BL_KRYTYCZNY_KONTO_VAT_MA'
                        dane.append(stat)
            
            elif pole=="stawka_vat_ma":
                if wart.strip() == '':
                    Wartosci[i]='NULL'
                    StawkaVATMa = Wartosci[i]
                else:
                    StawkaVATMa = wart
                    sql="SELECT kod FROM rs_stawki_vat WHERE kod = '"+wart+"';"
                    dump,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                    if Dane == []:
                        stat='BL_STAWKA_VAT_MA'
                        dane.append(stat)
                
            elif pole =="projekt_ma":
                if wart == '':
                    Wartosci[i]='NULL'
                else:
                    sql="SELECT data_od,data_do FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+wart+"';"
                    dump,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                    if Dane == []:
                        stat='BL_PROJ_MA'
                        dane.append(stat)
                    else:
                        if Dane[0][0] <> 'None':
                            if Data < Dane[0][0]:
                                stat = 'BL_PROJ_MA_DATAOD'
                                dane.append(stat)
                        if Dane[0][1] <> 'None':
                            if Data > Dane[0][1]:
                                stat = 'BL_PROJ_MA_DATADO'
                                dane.append(stat)

            elif pole =="seria_ma":
                # pole jest list numerkw rozdzielon przecinkami
                if wart <> '':
                    LWart=wart.split(',')
                    for nr in LWart:
                        if stat=='OK':
                            sql="SELECT seria FROM rs_rozrachunki WHERE seria="+str(nr)+";"
                            stat,Dane,dump,dump =self.PolSQL.Execute(sql,3)
                            if stat=='OK':
                                if Dane == []:
                                    stat='Bdny numer rozrachunku ma:'+str(nr)
                                    dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
    
    if stat == 'OK' and DataWyst in puste_pola and (not StawkaVATWn in puste_pola or not StawkaVATMa in puste_pola):
        #jesli data_wyst na pozycji dokumentu jest niewypelniona
        #pobranie daty z naglowka dokumentu do sprawdzenia z okresem stawki VAT
        sql ="SELECT CASE WHEN data_wyst IS NULL THEN data ELSE data_wyst END"
        sql+=" FROM rs_dowody_ksiegowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania daty z nagwka dowodu: '+stat
            dane.append(stat)
        elif len(d) <> 1:
            stat = 'Brak dowodu o podanym kluczu.'
            dane.append(stat)
        else:
            DataWyst = rsglobal.Dekoduj(d[0][0])

    if stat == 'OK' and not StawkaVATWn in puste_pola:
        sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
        sql+=" WHERE stawka_vat='"+StawkaVATWn+"'"
        sql+=" AND '"+DataWyst+"'>=od_dnia"
        sql+=" AND CASE WHEN do_dnia IS NULL"
        sql+=" THEN TRUE ELSE '"+DataWyst+"'<=do_dnia END;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia terminu obowizywania stawki VAT Wn: '+stat
            dane.append(stat)
        elif len(d) == 0:
            #informacja zwrotna, ze podana stawka VAT nie zgadza sie
            #z terminem jej obowiazywania
            StawkaVATWnPozaTerminem = True

    if stat == 'OK' and not StawkaVATMa in puste_pola:
        sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
        sql+=" WHERE stawka_vat='"+StawkaVATMa+"'"
        sql+=" AND '"+DataWyst+"'>=od_dnia"
        sql+=" AND CASE WHEN do_dnia IS NULL"
        sql+=" THEN TRUE ELSE '"+DataWyst+"'<=do_dnia END;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia terminu obowizywania stawki VAT Ma: '+stat
            dane.append(stat)
        elif len(d) == 0:
            #informacja zwrotna, ze podana stawka VAT nie zgadza sie
            #z terminem jej obowiazywania
            StawkaVATMaPozaTerminem = True


#-------------------------------------------------------------------------------
#--- UPDATE --------------(3-z pobieraniem,4-bez pobierania danych)
#-------------------------------------------------------------------------------

if stat=="OK" and (Fun in [3,4]):
    if not UprUpd:
        stat = 'BR_UPR_UPD'
        dane.append(stat)
        
    if stat=='OK' and not UprTotal:
        if (not (str(Dowod),Nazwa) in LEdy)  and self.operator_id<>STANDARD_OPERATOR_ID:
            stat="UPR UPD1"
            dane.append(stat)    
        
    if stat=='OK':    
        dane = []
        sql = "UPDATE rs_dowody_ksiegowe_pozycje SET "
        Filtr = "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            #WS 2020-03-21 - kod_gtu
            if pole in ["dowod_id","nazwa_id","data","symbol_dok","data_wyst","data_wplywu","data_ksieg_kosztow","termin_plat","data_zapl","kontrahent_id","konto_wn","konto_vat_wn","stawka_vat_wn","seria_ma","seria_wn","tresc_wn","projekt_wn","sposob_rozl","waluta_wn","konto_ma","konto_vat_ma","stawka_vat_ma","tresc_ma","projekt_ma","waluta_ma","kod_gtu"]:
                if wart == "NULL":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"='"+str(wart)+"',"
            elif pole in ["numer","nr_poz","numer_ppoz","numer_pozw","kwota_wn","kwota_vat_wn","kurs_wn","kwota_wal_wn","nkup","kwota_ma","kwota_vat_ma","kurs_ma","kwota_wal_ma","pnop","pobierac_na_rejestr"]:
                sql += pole+"="+str(wart)+","
            elif pole in ["firma_id","okres_id","dowod_id","nazwa_id","data","symbol_dok","data_wyst","data_wplywu","termin_plat","data_zapl date","kontrahent_id","konto_wn","konto_vat_wn","stawka_vat_wn","tresc_wn","sposob_rozl","waluta_wn","konto_ma","konto_vat_ma","stawka_vat_ma","tresc_ma","waluta_ma"]:
                sql += pole+"='"+str(wart)+"',"
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        #WS 2022-05-10
        sql += "UPDATE rs_dowody_ksiegowe SET stan=CASE WHEN stan='M' THEN 'W' ELSE stan END WHERE "
        sql += "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        
        rsglobal.ZapiszDoLogow('oto i sql : '+str(sql),5)

        if stat=='OK':
            from funkcje import fs_dowody_ksiegowe_projekty_tworzenie
            stat=fs_dowody_ksiegowe_projekty_tworzenie.StworzPozycjeProjektoweWDowodzieKsiegowym(self.firma_id,self.okres_id,Dowod,Nazwa,Data,Numer,self.PolSQL)
            if stat != 'OK':
                stat = 'Bdy przeliczania projketw dla dowodu ksigowego'

        if stat != 'OK':
            stat = 'BL_UPD'
            dane.append(stat)
    
#-------------------------------------------------------------------------------
#---   USUWANIE KONT Z ZEROWYMI POZYCJAMI (9 - delete)
#-------------------------------------------------------------------------------

if Fun in [9] and stat=='OK':
    #pobranie numeru pozycji ze wzoru dekretacji w aktywnej pozycji
    JeszczeSa=True
    while JeszczeSa:
        if stat<> 'OK':
            JeszczeSa=False

        # sprawdzenie czy s pozycje nie ze wzoru, ktre s niewypenione
        if stat=='OK':
            sql= "SELECT nr_poz,nr_ppoz FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
            sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND kwota_wn=0 AND kwota_ma=0 AND kwota_vat_wn=0 AND kwota_vat_ma=0 AND NOT pozycja_ze_wzoru;"
            stat,Dane,dump,dump = self.PolSQL.Execute(sql, 3)
            
        # sprawdzenie czy to nie jest ostatnia pozycja na dokumencie
        if stat=='OK':
            JeszczeSa=len(Dane)>0
            
            if JeszczeSa:
                sql= "SELECT nr_poz,nr_ppoz FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
                sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+";"
                stat,DanePoz,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat=='OK':
                    if len(DanePoz)<=1:
                        JeszczeSa=False

        if stat=='OK':
            if JeszczeSa:
                d=Dane[0]
                if stat=='OK':
                    sql="DELETE FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' "
                    sql+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
                    sql+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz = "+str(d[0])+" AND nr_ppoz="+str(d[1])+" ;"
                    stat,dump,dump,dump = self.PolSQL.Execute(sql, 1)
                    
                if stat=='OK':
                    sql= "SELECT COUNT(nr_ppoz) FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
                    sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz = "+str(d[0])+";"
                    stat,DPpoz,dump,dump = self.PolSQL.Execute(sql, 3)
            
                if stat=='OK':
                    CzyPodpozycje = DPpoz[0][0]
                    if CzyPodpozycje==0:
                        # pobranie maksymalnej pozycji do przesunicia
                        SQL="SELECT MAX(nr_poz) FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
                        SQL+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+";"
                        stat,DMax,dump,dump = self.PolSQL.Execute(SQL, 3)
                        if stat=='OK':
                            LMax=DMax[0][0]
                            i = d[0]+1
                            while i<= LMax:
                                sql="UPDATE rs_dowody_ksiegowe_pozycje SET nr_poz=nr_poz-1 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
                                sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz = '"+str(i)+"';"
                                stat,dump,dump,dump = self.PolSQL.Execute(sql, 1)
                                i = i+1
                                
                    elif CzyPodpozycje>0:
                        sql="UPDATE rs_dowody_ksiegowe_pozycje SET nr_ppoz=nr_ppoz-1 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
                        sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(d[0])+" AND nr_ppoz > '"+str(d[1])+"';"
                        stat,dump,dump,dump = self.PolSQL.Execute(sql, 1)
               
#-------------------------------------------------------------------------------
#---   DODAWANIE DANYCH GDY FUNKCJA OKNA=1 (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if (Fun in [3,5]) and (stat=='OK') and FunkcjaOkna==1:
    sql="SELECT dod_pozycje FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    sql+="AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat=='OK':
        if len(Dane)==0:
            stat='BR WZD'
            dane.append(stat)
        elif not Dane[0][0]:
            stat='NM DOD POZ'
            dane.append(stat)
    
    if stat=='OK':
        sql="UPDATE rs_dowody_ksiegowe_pozycje SET nr_poz=nr_poz+10000,nr_ppoz=nr_ppoz- CASE WHEN nr_ppoz>=10 THEN 100 ELSE 0 END"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
        sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz>"+NrPoz+";"
        
        sql+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
        sql+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto_wn,konto_vat_wn,stawka_vat_wn,tresc_wn,"
        sql+="sposob_rozl,waluta_wn,kurs_wn,konto_ma,konto_vat_ma,stawka_vat_ma,tresc_ma,waluta_ma,kurs_ma,projekt_wn,projekt_ma,"
        sql+="pozycja_ze_wzoru,zamkniecie_kregu,pobierac_na_rejestr,data_ksieg_kosztow,kod_gtu) "  #WS 2020-03-21 - kod_gtu
        sql+="SELECT  firma_id,okres_id,dowod_id,nazwa_id,data,numer,"+str(float(NrPoz)+1)+",0,nr_pozw,"
        sql+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto_wn,konto_vat_wn,stawka_vat_wn,tresc_wn,"
        sql+="sposob_rozl,waluta_wn,kurs_wn,konto_ma,konto_vat_ma,stawka_vat_ma,tresc_ma,waluta_ma,kurs_ma,projekt_wn,projekt_ma,"
        sql+="FALSE,zamkniecie_kregu,pobierac_na_rejestr,data_ksieg_kosztow,kod_gtu "  #WS 2020-03-21 - kod_gtu
        sql+=" FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
        sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz+";"
        
        #powrot numeracji pozostalej czesci
        sql+="UPDATE rs_dowody_ksiegowe_pozycje SET nr_poz=nr_poz-9999,nr_ppoz=nr_ppoz- CASE WHEN nr_ppoz>=10 THEN 100 ELSE 0 END"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' "
        sql+= "AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz>10000;"

        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
    
    if stat=='OK':
        NrPoz=str(float(NrPoz)+1)
        NrPPoz='0'
        
if (Fun in [3,4,5,9]) and (stat=='OK') :
    sql="SELECT nr_poz,nr_ppoz,konto_wn,kwota_wn,tresc_wn,konto_ma,kwota_ma,tresc_ma,konto_vat_wn,kwota_vat_wn,"
    sql+="konto_vat_ma,kwota_vat_ma,zamkniecie_kregu FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' "
    sql+="AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' "
    sql+=" AND numer="+Numer+" ORDER BY nr_poz,nr_ppoz;"
    stat,DanePoz,dump,dump = self.PolSQL.Execute(sql ,3)

#--------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if (Fun in [3,5]) and (stat=='OK'):
    sql="SELECT * FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+";"    

    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    #pobranie danych do opisow
    if (len(dane) >0):
        # pobranie stanu i tresci dowodu ksigowego
        SQL ="SELECT stan,COALESCE(TRIM(tresc),'') FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,DStan,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu i treci dowodu ksigowego: '+stat
        elif len(DStan) <> 1:
            stat = 'Brak dowodu o podanym numerze'
        if stat=='OK':
            wyn2.append(DStan[0][0])
            wyn2.append(DStan[0][1])

            #AB 24.02.22r wcicie by reszta robia si tylko gdy stat OK, bo co prawda nie zmieni statu na OK, ale te
            # nie ma potrzeby si robi, by bd krytyczny

            # pobranie danych wzoru dekretacji
            tr = rssql.RSTableRowset(dane,wyn1)

            Select="SELECT nr_pozw FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+";"
            NrPozW = self.PolSQL.Execute(Select,3)[1][0][0]
            Select="SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
            TypWzoru = self.PolSQL.Execute(Select,3)[1][0][0]

            if TypWzoru=='S':
                ListaPol = "czy_symbol_dok,mod_symbol_dok,czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,"
                ListaPol+="czy_kontrahent_id,mod_kontrahent_id,czy_konto_wn,mod_konto_wn,czy_konto_vat_wn,mod_konto_vat_wn,"
                ListaPol+="mod_stawka_vat_wn,czy_tresc_wn,mod_tresc_wn,czy_sposob_rozl,mod_sposob_rozl,czy_konto_ma,"
                ListaPol+="mod_konto_ma,czy_konto_vat_ma,mod_konto_vat_ma,mod_stawka_vat_ma,czy_tresc_ma,mod_tresc_ma,"
                ListaPol+="czy_nkup,czy_pnop,czy_projekt_wn,mod_projekt_wn,czy_projekt_ma,mod_projekt_ma,"+str(NrPozW)+","
                ListaPol+="czy_data_ksieg_kosztow,czy_przeliczac_kwote_ma,kod_gtu,'"+TypWzoru+"'"  #WS 2020-03-21 - kod_gtu
                Tabela='rs_wzory_dekretacji_pozycje'
                sql="SELECT "+ListaPol+" FROM rs_wzory_dekretacji_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPozW)+" ORDER BY nr_poz;"
            #WS 2020-03-21
            elif TypWzoru=='F':
                sql ="SELECT TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,0,FALSE,FALSE,"
                sql+="kod_gtu,'"+TypWzoru+"' FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPozW)+" ORDER BY nr_poz;"
            else:
                sql="SELECT TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,0,FALSE,FALSE,FALSE,'"+TypWzoru+"';"  #WS 2020-03-21 kod_gtu

            DaneP = self.PolSQL.Execute(sql,3)[1]
            if len(DaneP)==0:
                stat = 'BR_POZ_WZR'
                dane=[]
                dane.append(stat)

            if stat=='OK':
                Dane=DaneP[0]

                if len(Dane)== 0:
                    wyn2.append('')
                else:
                    wyn2.append(Dane)

            #odbiorca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) and stat=='OK':
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika kontrahentw. Poinformuj administratora.')

            #stawka vat wn
            if ((self.oddzial_id,'011121') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) and stat=='OK':
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat_wn")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika stawek VAT. Poinformuj administratora.')


            #stawka vat ma
            if ((self.oddzial_id,'011121') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat_ma")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika stawek VAT. Poinformuj administratora.')

            #sposob rozliczenia
            if ((self.oddzial_id,'011211') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposob_rozl_vat WHERE kod='"+tr.GetVal(0,"sposob_rozl")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika sposobw rozliczenia VAT. Poinformuj administratora.')

            #projekt wn i ma
            if ((self.oddzial_id,'027010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_wn")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])

                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_ma")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do projektw. Poinformuj administratora.')
                wyn2.append('Brak uprawnie do projektw. Poinformuj administratora.')  #AB 24.02.22r

            #WS 2020-03-21
            #kod GTU
            if ((self.oddzial_id,'211421') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kody_towarow_uslug WHERE kod='"+tr.GetVal(0,"kod_gtu")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika kodw towarw i usug. Poinformuj administratora.')

            #dodany numer lub aktualny
            NrTemp=str(NrPoz)
            NrTempP=str(NrPPoz)
            if NrTemp.find('.')==-1:
                NrTemp=NrTemp+'.0'
            if NrTempP.find('.')==-1:
                NrTempP=NrTempP+'.0'
            wyn2.append([NrTemp,NrTempP])
        
if (Fun in [3,4,5,9]) and (stat=='OK') :
    if DanePoz <> []:
        wyn2.append(DanePoz)
    else:
        wyn2.append(None)
    
    if Fun in (3,4):
        wyn2.append(['STAWKI_VAT',StawkaVATWnPozaTerminem, StawkaVATMaPozaTerminem])
    else:
        wyn2.append(None)
        
else:
    wyn2.append(None)
    wyn2.append(None) 