# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_pozycje_import.py
# Purpose:     pobieranie danych z pliku CSV i TXT
#
# Author:      Konrad Opieka
# Created:     2014/03/04
# RCS-ID:      $Id: fs_dowody_ksiegowe_pozycje_import.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Dowod = rsglobal.Dekoduj(klucze['Dowod']).strip()
Nazwa = rsglobal.Dekoduj(klucze['Nazwa']).strip()
Data = rsglobal.Dekoduj(klucze['Data'])
Numer = rsglobal.Dekoduj(str(klucze['Numer']))
ZdefiniowanySPC = klucze['ZdefiniowanySPC']
z_pliku = klucze['Plik']

stat = "OK"
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = (self.oddzial_id,'075023') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

#-##############################################################################
#-##############################################################################
#----- NOWY UNIWERSALNY IMPORT
#-##############################################################################
#-##############################################################################

#-------------------------------------------------------------------------------
#----- Sprawdzenie
#-------------------------------------------------------------------------------

if not UprDodawanie:
    stat = 'Brak uprawnie do dodawania pozycji w dowodzie ksigowym.'

if stat == 'OK' and not ZdefiniowanySPC:
    if len(z_pliku) == 0:
        stat = 'Brak pozycji w importowanym pliku'
    if stat == 'OK':
        SQL ="SELECT stan FROM rs_dowody_ksiegowe"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu dowodu ksigowego: '+stat
        elif len(d) <> 1:
            stat = 'Brak dowodu o podanym numerze'
        elif str(d[0][0]) == 'Z':
            stat = 'Dowd ksigowy zosta zamknity. Operacja niemoliwa.'
    if stat == 'OK':
        # pobranie informacji o walucie z wzoru dekretacji
        SQL ="SELECT waluta FROM rs_wzory_dekretacji"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"';"
        stat,dWaluta,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobrania waluty z wzoru dekretacji: '+stat
        elif len(dWaluta) == 0:
            stat = 'Brak wzoru dekretacji dla podanego dowodu ksigowego.'
        else:
            WalutaPLN = dWaluta[0][0].upper() == 'PLN'
            dWaluta[0][0] = rsglobal.Dekoduj(dWaluta[0][0])
    if stat == 'OK':
        #pobranie ilosci pozycji na dowodzie
        SQL ="SELECT MAX(nr_poz) FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,maxpoz,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia ilosci pozycji na dowodzie ksigowym: '+stat
        elif maxpoz[0][0] == 0:
            stat = 'Dowd ksigowy musi zawiera cho jedn pozycj pozycj.\nImport niemoliwy.'
    if stat == 'OK':
        #przyblokowanie pierwszej pozycji, aby inny operator jej nie usunal lub zmodyfikowal
        #gdyz uzyjemy jej jako SELECTa w INSERCIE dla pozostalych pozycji importowanego dokumentu
        SQL ="SELECT nr_poz,nr_ppoz FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+""
        SQL+=" AND nr_poz=1 AND nr_ppoz=0 FOR UPDATE NOWAIT;"
        stat,ppoz,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pierwszej pozycji na dowodzie ksigowym: '+stat
        if len(ppoz) == 0:
            stat = 'Brak pierwszej pozycji do powielania.'
    if stat == 'OK':
        #sprawdzenie czy zawiera jakies wartosci
        SQL ="SELECT kwota_wn,kwota_ma FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND data='"+Data+"' AND numer="+Numer+""
        SQL+=" AND dowod_id='"+Dowod+"' AND nr_poz=1 AND nr_ppoz=0;"
        stat,kwota,dump,dump = self.PolSQL.Execute(SQL,3)
        if kwota[0][0] <> 0 or kwota[0][1] <> 0:
            stat = 'Import niemoliwy. W dowodzie ksigowym istniej wypenione pozycje'
    if stat == 'OK':
        SQL ="SELECT nr_poz FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND data='"+Data+"' AND numer="+Numer+""
        SQL+=" AND dowod_id='"+Dowod+"' AND nr_ppoz=0;"
        stat,poz,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(poz) > 1:
            stat = 'Import niemoliwy. W dowodzie ksigowym istniej wypenione pozycje'

 
#-------------------------------------------------------------------------------
#----- wczytanie sownikw i pozycji z wczytanego pliku CSV/TXT 
#------------------------------------------------------------------------------- 
   
    if stat == 'OK':  
        Rzad = rsglobal.Dekoduj(klucze['TCWierszPocz']) 
        #Sprawdzenie iloci wierszy do pobrania
        if (Rzad > len(z_pliku)):
            stat = 'NR WIERSZ'
            dane.append(stat)
        
        #Pobranie Kluczy z wartociami pl
        Pobranie = rsglobal.Dekoduj(klucze['Pobranie'])
        #Stworzenie listy wartoci z klucza
        LPoz=Pobranie.values()
               
        #sownik do wczytania danych z pliku:
        Dane = {}        
        #zmienna potrzebna do okrelenia wiersza z pliku:
        ilosc_wierszy = 0   
        #pobieranie danych z pliku:
        if stat == 'OK':
            for wiersz in z_pliku:
                rsglobal.ZapiszDoLogow('WIERSZ '+wiersz,1)
                w = wiersz
                # zakadamy, e plik jest w Latin2, jeli nie to zakadamy ISO-8859-2
                try:
                    w=wiersz.decode('cp1250').encode('iso-8859-2')
                except:
                    pass
                w=w.split(';')
                w[-1]=w[-1].strip('\r\n')
                for i in range(len(w)):
                    if type(w[i])==type("str"):
                        w[i]=w[i].strip("\\'")
                Dane[ilosc_wierszy]=w
                ilosc_wierszy+=1
        
                
#-------------------------------------------------------------------------------
#----- Sprawdzenie czy pola istnieja
#-------------------------------------------------------------------------------

    if stat == 'OK':
        for poz in LPoz:
            if poz[0] > len(Dane[Rzad-1]):
                stat= poz[3]
                dane.append(stat)
                
#-------------------------------------------------------------------------------
#----- Sprawdzenie kontrahentw
#-------------------------------------------------------------------------------
    
    if stat=='OK':
        if Pobranie['Kontrahent'][0]<>0:
            for poz in xrange(1,len(z_pliku)-Rzad+2):
                if Dane[Rzad-2+poz][Pobranie['Kontrahent'][0]-1].strip().replace('"','')<>'':
                    SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Dane[Rzad-2+poz][Pobranie['Kontrahent'][0]-1].strip().replace('"','')+"'"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat <> 'OK':
                        stat="Bd pobrania danych o kontrahentach."
                    if len(dane)==0:
                        stat="Brak kontrahenta '"+Dane[Rzad-2+poz][Pobranie['Kontrahent'][0]-1].strip().replace('"','')+"' w bazie"
                        break
                   
#-------------------------------------------------------------------------------
#----- Pobranie danych przed usuniciem
#-------------------------------------------------------------------------------
   
    if stat == 'OK':
        Pola ='firma_id, okres_id, dowod_id, nazwa_id, data, numer,'
        Pola+=' pobierac_na_rejestr, pozycja_ze_wzoru, nr_pozw'
        
        SQL="SELECT "+Pola+" FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND data='"+Data+"' AND numer="+Numer+""
        SQL+=" AND dowod_id='"+Dowod+"' AND nr_ppoz=0;"
        stat,StarePola,dump,dump = self.PolSQL.Execute(SQL,3)
        
        
#-------------------------------------------------------------------------------
#----- Usunicie pierwszego wiersza
#-------------------------------------------------------------------------------

    if stat == 'OK':
        SQL="DELETE FROM rs_dowody_ksiegowe_pozycje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND data='"+Data+"' AND numer="+Numer+""
        SQL+=" AND dowod_id='"+Dowod+"' AND nr_ppoz=0;"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
        
        
#-------------------------------------------------------------------------------
#------ Tworzenie SQL 
#-------------------------------------------------------------------------------
   
    if stat == 'OK':
        SQL=""
        for i in xrange(1,len(z_pliku)-Rzad+2):
            SQL+="INSERT INTO rs_dowody_ksiegowe_pozycje"
            SQL+=" ("+Pola+","
            SQL+=" nr_poz,nr_ppoz,"
                
            for poz in LPoz:
                if poz[1]==1 or poz[1]==2:
                    SQL+=" "+poz[2]+","
            SQL+=" kwota_wal_wn, kwota_wal_ma)" 
            SQL+=" VALUES ("
            for s in StarePola[0]:
                SQL+=" '"+str(s)+"',"
            SQL+=" "+str(i)+",0,"
            for poz in LPoz:
                if poz[1]==1:
                    if poz[0]<>0 and len(Dane[Rzad-2+i][poz[0]-1]):
                        SQL+=" "+Dane[Rzad-2+i][poz[0]-1].strip().replace('"','').replace(',','.')+","
                    else:
                        SQL+=" "+str(poz[4])+","
                elif poz[1]==2:
                    if poz[4] == None and Dane[Rzad-2+i][poz[0]-1].strip().replace('"','') == '':
                        SQL+=" NULL,"
                    elif poz[0]<>0 and Dane[Rzad-2+i][poz[0]-1].strip().replace('"','') <> 'None':
                        SQL+=" '"+Dane[Rzad-2+i][poz[0]-1].strip().replace('"','')+"',"
                    else:
                        if poz[4] == None:
                            SQL+=" NULL,"
                        else:
                            SQL+=" "+poz[4]+","
        
            for STR in ['WN','MA']:
                if Pobranie['KwotaWal'+STR][0]<>0:
                    SQL+=" "+Dane[Rzad-2+i][Pobranie['KwotaWal'+STR][0]-1].strip().replace('"','').replace(',','.')+","
                else:
                    if Pobranie['Kwota'+STR][0]<>0 and len(Dane[Rzad-2+i][Pobranie['Kwota'+STR][0]-1])<>0:
                        if Pobranie['Kurs'+STR][0]<>0:
                            SQL+=" "+str((float(Dane[Rzad-2+i][Pobranie['Kwota'+STR][0]-1].strip().replace('"','').replace(',','.')))/(float(Dane[Rzad-2+i][Pobranie['Kurs'+STR][0]-1].strip().replace('"','').replace(',','.'))))+","
                        else:
                            SQL+=" "+Dane[Rzad-2+i][Pobranie['Kwota'+STR][0]-1].strip().replace('"','').replace(',','.')+","
                    else:
                        SQL+=" 0,"
            SQL=SQL.strip(',')
            SQL+="); "
        
#-------------------------------------------------------------------------------
#----- INSERT
#-------------------------------------------------------------------------------
    
    if stat == 'OK':
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'BL IMPORT'
            dane.append(stat)


#-##############################################################################
#-##############################################################################
#----- STARY IMPORT DLA PAC SPC
#-##############################################################################
#-##############################################################################

if stat == 'OK' and ZdefiniowanySPC:
    if len(z_pliku) == 0:
        stat = 'Brak pozycji w importowanym pliku'
    
    if stat == 'OK':
        sql ="SELECT stan FROM rs_dowody_ksiegowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu dowodu ksigowego: '+stat
        elif len(d) <> 1:
            stat = 'Brak dowodu o podanym numerze'
        elif str(d[0][0]) == 'Z':
            stat = 'Dowd ksigowy zosta zamknity. Operacja niemoliwa.'

    if stat == 'OK':
        #pobranie ilosci pozycji na dowodzie
        sql ="SELECT MAX(nr_poz) FROM rs_dowody_ksiegowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,maxpoz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia ilosci pozycji na dowodzie ksigowym: '+stat
        elif maxpoz[0][0] == 0:
            stat = 'Dowd ksigowy musi zawiera cho jedn pozycj pozycj.\nImport niemoliwy.'

    if stat == 'OK':
        #przyblokowanie pierwszej pozycji, aby inny operator jej nie usunal lub zmodyfikowal
        #gdyz uzyjemy jej jako SELECTa w INSERCIE dla pozostalych pozycji importowanego dokumentu
        sql ="SELECT nr_poz,nr_ppoz FROM rs_dowody_ksiegowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer
        sql+=" AND nr_poz=1 and nr_ppoz=0 FOR UPDATE NOWAIT;"
        stat,ppoz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pierwszej pozycji na dowodzie ksigowym: '+stat
        if len(ppoz) == 0:
            stat = 'Brak pierwszej pozycji do powielania.'
            
    if stat == 'OK':
        #modyfikacja pierwszej pozycji w dowodzie
        konto = rsglobal.Dekoduj(z_pliku[0][0]).strip().replace('"','')
        kwota_wn = z_pliku[0][1]
        kwota_ma = z_pliku[0][2]
        tresc = rsglobal.Dekoduj(z_pliku[0][3]).strip().replace('"','')
        SQL ="UPDATE rs_dowody_ksiegowe_pozycje SET"
        if kwota_wn <> 0:
            SQL+=" konto_wn='"+konto+"', kwota_wn="+str(kwota_wn)+", kwota_wal_wn="+str(kwota_wn)+", tresc_wn='"+tresc+"'"
        else:
            SQL+=" konto_wn='', kwota_wn=0, kwota_wal_wn=0, tresc_wn=''"
        SQL+=" ,"
                
        if kwota_ma <> 0:
            SQL+=" konto_ma='"+konto+"', kwota_ma="+str(kwota_ma)+", kwota_wal_ma="+str(kwota_ma)+", tresc_ma='"+tresc+"'"
        else:
            SQL+=" konto_ma='', kwota_wal_ma=0, kwota_ma=0, tresc_ma=''"

        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer
        SQL+=" AND nr_poz=1 and nr_ppoz=0; "
        
        #przenumerowuje dalsze pozycje dowodu ksiegowego jesli takie istnieja,
        #a wczytywany dokument posiada wiecej niz jedna pozycje
        if maxpoz[0][0] > 1 and len(z_pliku) > 1:
            SQL+= "UPDATE rs_dowody_ksiegowe_pozycje"
            SQL+=" SET nr_poz=nr_poz+10000+"+str(len(z_pliku))+" WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND okres_id = '"+self.okres_id+"' AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"'"
            SQL+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz > 1; "
            
            SQL+= "UPDATE rs_dowody_ksiegowe_pozycje"
            SQL+=" SET nr_poz=nr_poz-10001 WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND okres_id = '"+self.okres_id+"' AND dowod_id = '"+Dowod+"' AND nazwa_id= '"+Nazwa+"'"
            SQL+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz > 10000; "
        
        #pozostale pozycje
        for i in xrange(1,len(z_pliku)):
            konto = rsglobal.Dekoduj(z_pliku[i][0]).strip().replace('"','')
            kwota_wn = z_pliku[i][1]
            kwota_ma = z_pliku[i][2]
            tresc = rsglobal.Dekoduj(z_pliku[i][3]).strip().replace('"','')

            Pola ='firma_id, okres_id, dowod_id, nazwa_id, data, numer,'
            Pola+='symbol_dok, data_wyst, data_wplywu, termin_plat, data_zapl, data_ksieg_kosztow,'
            Pola+='kontrahent_id, konto_vat_wn, kwota_vat_wn, stawka_vat_wn, projekt_wn, sposob_rozl,'
            Pola+='waluta_wn, kurs_wn, seria_wn, nkup, konto_vat_ma, kwota_vat_ma,'
            Pola+='stawka_vat_ma, projekt_ma, waluta_ma, kurs_ma, seria_ma,'
            Pola+='pnop, zamkniecie_kregu, pobierac_na_rejestr,pozycja_ze_wzoru,nr_pozw'
            
            SQL+=" INSERT INTO rs_dowody_ksiegowe_pozycje"
            SQL+=" ("+Pola+","
            SQL+=" nr_poz,nr_ppoz,"
            SQL+=" konto_wn,kwota_wn,kwota_wal_wn,tresc_wn,"
            SQL+=" konto_ma,kwota_ma,kwota_wal_ma,tresc_ma)"
            SQL+=" SELECT "+Pola+","
            SQL+=" "+str(i+1)+",0,"

            if kwota_wn <> 0:
                SQL+="'"+konto+"',"+str(kwota_wn)+","+str(kwota_wn)+",'"+tresc+"',"
            else:
                SQL+="'',0,0,'',"
                
            if kwota_ma <> 0:
                SQL+="'"+konto+"',"+str(kwota_ma)+","+str(kwota_ma)+",'"+tresc+"'"
            else:
                SQL+="'',0,0,''"
                
            SQL+=" FROM rs_dowody_ksiegowe_pozycje"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+Numer
            SQL+=" AND nr_poz="+str(ppoz[0][0])+" AND nr_ppoz="+str(ppoz[0][1])+"; "
            
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1,CzyDodawacBlad=True)
        if stat <> 'OK':
            stat = 'Bd zapisywania zaimportowanych pozycji: '+stat
            

#-------------------------------------------------------------------------------
# Pobranie danych do grida pozycji danego dokumentu i nru dokumentu na wydruk
#-------------------------------------------------------------------------------

if stat == 'OK':
    SQL ="SELECT nr_poz,nr_ppoz,konto_wn,kwota_wn,tresc_wn,konto_ma,kwota_ma,tresc_ma,"
    SQL+=" konto_vat_wn,kwota_vat_wn,konto_vat_ma,kwota_vat_ma,zamkniecie_kregu"
    SQL+=" FROM rs_dowody_ksiegowe_pozycje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)
    SQL+=" ORDER BY nr_poz,nr_ppoz;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania pozycji dowodu ksigowego : '+stat
        
    if stat == 'OK':
        klucz=str([Dowod,Nazwa,Data,Numer]).replace("'",'"')
        SQL ="SELECT rsf_podaj_numer_dokumentu_na_wydruk("
        SQL+="'"+self.firma_id+"','"+klucz+"','D');"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd w pobieraniu numeru dowodu ksigowego do wydruku: '+stat
        else:
            wyn2 = d
    