# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_projekty_tworzenie.py
# Purpose:     tworzy pozycje w rs_dowody_ksiegowe_projekty za pomoc funkcji
# Author:      Micha Raburski
# Created:     2010/02/26
# RCS-ID:      $Id: fs__dowody_ksiegowe_projekty_tworzenie.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2016-10-27 Marcin Natkaski - poprwka przeliczania projektw, jeeli na pozycjach nie ma konta do przelicznia W/G projektw
#2022-05-10 Wojciech Skowron - nowy stan dk 'M' (13004)

def StworzPozycjeProjektoweWDowodzieKsiegowym(Firma,Okres,Dowod,Nazwa,Data,Numer,PolSQL):
    import rsglobal
    
    dl=1
    CzyPodzialWZ=True
    SumaWn=0
    SumaMa=0


    #USUWAMY ISTNIEJACE POZYCJE W rs_dowody_ksiegowe_pozycje_projekty
    DEL = " DELETE FROM rs_dowody_ksiegowe_projekty WHERE firma_id='"+Firma+"' "
    DEL+=" AND okres_id='"+Okres+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
    DEL+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,dump,dump,dump = PolSQL.Execute(DEL,1)
    if stat <> 'OK':
        return 'Bd usuwanie pozycji projektw : '+stat

    sql ="SELECT bez_projektow,stan FROM rs_dowody_ksiegowe WHERE firma_id='"+Firma+"' "
    sql+=" AND okres_id='"+Okres+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,d,dump,dump = PolSQL.Execute(sql,3)    
    if stat <> 'OK':
        return 'Bd pobrania danych z dowodu ksigowego : '+stat
    elif len(d) == 0:
        return 'Brak podanego dowodu ksigowego '
    elif d[0][0]:
        return 'OK'
    #WS 2022-05-10
    elif not d[0][1] in ['M','W','G']:
    # elif not d[0][1] in ['W','G']:
        return 'OK'

    
    #czy dowod ksiegowy posiada juz podzial na projekty
    sql = "SELECT projekt_id FROM rs_dowody_ksiegowe_projekty"
    sql+=" WHERE firma_id='"+Firma+"' AND dowod_id='"+Dowod+"'"
    sql+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,d,dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return 'Bd pobrania danych z dowodu ksigowego dot.podziau kosztw : '+stat
    elif len(d) > 0:
        return 'OK'

    #dane z wzoru dekretacji
    sql ="SELECT projekty_podzial,zespol_kont FROM rs_wzory_dekretacji"
    sql+=" WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"'"
    sql+=" and dowod_id='"+Dowod+"' and nazwa_id='"+Nazwa+"';"
    stat,daneWD,dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return u"Bd pobrania danych z wzoru dekretacji: "+stat
    
    if len(daneWD) == 0:
        return u'Bdny wzr dekretacji'
    
    if not daneWD[0][0]:
        return 'OK'
        #CzyPodzialWZ=False
        
    elif daneWD[0][1] == 'None':
	    return u'Brak zespou kont na wzorze dekretacji z ktrego utworzono dowd ksigowy'
    else:
        ZespolKont=rsglobal.Dekoduj(daneWD[0][1]).strip()

    #projekty z pozycji dowodu ksiegowego (lub z nagwka jak pusto w pozycji)
    sql ="SELECT DISTINCT COALESCE(dp.projekt_wn,dk.projekt_id,''),COALESCE(dp.projekt_ma,dk.projekt_id,''), "
    sql+="COALESCE(dp.kontrahent_id,dk.kontrahent_id,'NULL') FROM rs_dowody_ksiegowe_pozycje dp"
    sql+=" INNER JOIN rs_dowody_ksiegowe dk USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer) "
    sql+=" WHERE dp.firma_id='"+Firma+"' AND dp.okres_id='"+Okres+"' AND dp.dowod_id='"+Dowod+"'"
    sql+=" AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Numer)
    sql+="AND (POSITION(SUBSTRING(dp.konto_wn FROM 1 FOR 1) IN '"+ZespolKont+"')>0 "
    sql+=" OR POSITION(SUBSTRING(dp.konto_ma FROM 1 FOR 1) IN '"+ZespolKont+"')>0);"
    stat,DaneDK,dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return u'Bd pobrania projektw z dowodu ksiegowego : '+stat
    elif len(DaneDK) == 0:
        #return u'Brak pozycji dowodu ksigowego, ktre zawieraj jakiekolwiek konta z podanego we wzorze dekretacji zespou kont dla podziau wg projektw'
        return 'OK'
    LProj=[]
    for d in DaneDK:
        Kontr=rsglobal.Dekoduj(d[2]).strip()
        ProjWn=rsglobal.Dekoduj(d[0]).strip()
        if ProjWn <> '':
            if not (ProjWn,Kontr) in LProj:
                LProj.append((ProjWn,Kontr))
        
        ProjMa=rsglobal.Dekoduj(d[1]).strip()
        if ProjMa <> '':
            if not (ProjMa,Kontr) in LProj:
                LProj.append((ProjMa,Kontr))

    #jesli nie ma projektw - nie robimy pozycji
    if LProj==[]:
        return 'OK'

    SQL=''
    NrPoz=1
    #-------------------------------------------------------------------------------
    # kady projekt obsugujemy oddzielnie - skadamy globalne zapytanie
    #-------------------------------------------------------------------------------

    for poz in LProj:
        Projekt=poz[0]
        KontrProj=poz[1]
        if KontrProj <> 'NULL':
            KontrProj="'"+KontrProj+"'"
        CzyPodzial=True

        #sumy kwot Wn z dowodu ksiegowego dla dekretow zaczynajacych sie cyfra rowna zespol_kont
        sql = "SELECT SUM(dp.kwota_wn) FROM rs_dowody_ksiegowe_pozycje dp"
        sql+=" INNER JOIN rs_dowody_ksiegowe dk USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
        sql+=" WHERE dp.firma_id='"+Firma+"' AND dp.okres_id='"+Okres+"' AND dp.dowod_id='"+Dowod+"'"
        sql+=" AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Numer)
        sql+=" AND POSITION(SUBSTRING(dp.konto_wn FROM 1 FOR 1) IN '"+ZespolKont+"')>0 "
        sql+=" AND COALESCE(dp.projekt_wn,dk.projekt_id)='"+Projekt+"'"
        sql+=" AND COALESCE(dp.kontrahent_id,dk.kontrahent_id,'NULL')='"+str(poz[1])+"';"
        stat,d,dump,dump = PolSQL.Execute(sql,3)
        if stat <> 'OK':
            return u'Bd pobrania sumy Wn kwot z pozycji dowodu ksiegowego dla projektu '+Projekt+' : '+stat
    
        SumaWn = d[0][0]
        
        #sumy kwot Ma z dowodu ksiegowego dla dekretow zaczynajacych sie cyfra rowna zespol_kont
        sql = "SELECT SUM(dp.kwota_ma) FROM rs_dowody_ksiegowe_pozycje dp"
        sql+=" INNER JOIN rs_dowody_ksiegowe dk USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
        sql+=" WHERE dp.firma_id='"+Firma+"' AND dp.okres_id='"+Okres+"' AND dp.dowod_id='"+Dowod+"'"
        sql+=" AND dp.nazwa_id='"+Nazwa+"' AND dp.data='"+Data+"' AND dp.numer="+str(Numer)
        sql+=" AND POSITION(SUBSTRING(dp.konto_ma FROM 1 FOR 1) IN '"+ZespolKont+"')>0 "
        sql+=" AND COALESCE(dp.projekt_ma,dk.projekt_id)='"+Projekt+"'"
        sql+=" AND COALESCE(dp.kontrahent_id,dk.kontrahent_id,'NULL')='"+str(poz[1])+"';"
        stat,d,dump,dump = PolSQL.Execute(sql,3)
        if stat <> 'OK':
            return u'Bd pobrania sumy Ma kwot z pozycji dowodu ksiegowego dla projektu '+Projekt+': '+stat
    
        SumaMa = d[0][0]
        
        # jeli dla projektu akurat nie ma danych to robimy kolejny projekt
        if SumaWn==0 and SumaMa==0:
            continue
    
        #wzor podzialu kosztow na dzialy dla projektu pobranego z dowodu ksiegowego
        sql ="SELECT dzial_id,handlowiec_id,kontrahent_id,koszty_proc"
        sql+=" FROM rs_projekty_dzialy WHERE firma_id='"+Firma+"' AND projekt_id='"+Projekt+"'"
        sql+=" ORDER BY numer;"
        stat,danePD,dump,dump = PolSQL.Execute(sql,3)
        if stat <> 'OK':
            return u'Bd pobrania danych dot.podziau kosztw dla projektu '+Projekt+': '+stat
        
        if len(danePD) == 0:
            CzyPodzial=False
    
        if (not CzyPodzialWZ) or (not CzyPodzial):
            #-------------------------------------------------------------------------------
            #wpisujemy do grida jeden wiersz z cala kwota, dane pobieramy z projektu
            #-------------------------------------------------------------------------------
    
            sql ="SELECT handlowiec_wiad,dzial_wiad FROM rs_projekty"
            sql+=" WHERE firma_id='"+Firma+"' AND projekt_id='"+Projekt+"';"
    
            stat,daneP,dump,dump = PolSQL.Execute(sql,3)
            if stat <> 'OK':
                return u'Bd pobrania danych z projektu : '+stat
            
            if len(daneP) == 0:
                return u'Bdny projekt na dowodzie ksigowym'
    
            Handlowiec = rsglobal.Dekoduj(daneP[0][0]).strip()
            if Handlowiec == 'None':
                Handlowiec = 'NULL'
            else:
                Handlowiec = "'"+Handlowiec+"'"
                    
            Dzial = rsglobal.Dekoduj(daneP[0][1]).strip()
            if Dzial == 'None':
                Dzial = 'NULL'
            else:
                Dzial = "'"+Dzial+"'"
    
            SQL+="INSERT INTO rs_dowody_ksiegowe_projekty"
            SQL+=" (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
            SQL+="projekt_id,dzial_id,handlowiec_id,kontrahent_id,kwota_wn,kwota_ma,nr_poz)"
            SQL+=" VALUES"
            SQL+=" ('"+Firma+"','"+Okres+"','"+Dowod+"','"+Nazwa+"','"+Data+"',"+str(Numer)+","
            SQL+=" '"+Projekt+"',"+Dzial+","+Handlowiec+","+KontrProj+","
            SQL+=" "+str(SumaWn)+","+str(SumaMa)+","+str(NrPoz)+"); "
                
            NrPoz=NrPoz+1
                
        else:
            #-------------------------------------------------------------------------------
            #rozdzielamy koszty wg koszty_proc
            #-------------------------------------------------------------------------------
            
            SWn = 0
            SMa = 0
    
            for i in xrange(len(danePD)):
                Dzial = rsglobal.Dekoduj(danePD[i][0])
                Handlowiec = rsglobal.Dekoduj(danePD[i][1])
                Kontrahent = rsglobal.Dekoduj(danePD[i][2])
                KosztyProc = danePD[i][3]
    
                if Dzial == 'None':
                    Dzial = 'NULL'
                else:
                    Dzial = "'"+Dzial+"'"
    
                if Handlowiec == 'None':
                    Handlowiec = 'NULL'
                else:
                    Handlowiec = "'"+Handlowiec+"'"
    
                if Kontrahent == 'None':
                    Kontrahent = 'NULL'
                else:
                    Kontrahent = "'"+Kontrahent+"'"
    
                KwotaWn = rsglobal.RSRound(SumaWn*KosztyProc/100,2)
                KwotaMa = rsglobal.RSRound(SumaMa*KosztyProc/100,2)
    
                SWn += KwotaWn
                SMa += KwotaMa
    
                #jesli ostatnia pozycja, to wpisanie roznicy wynikajacej z zaokroglen
                if i == len(danePD)-1:
                    if SWn <> SumaWn:
                        KwotaWn += rsglobal.RSRound(SumaWn - SWn,2)
    
                    if SMa <> SumaMa:
                        KwotaMa += rsglobal.RSRound(SumaMa - SMa,2)
    
                SQL+="INSERT INTO rs_dowody_ksiegowe_projekty"
                SQL+=" (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                SQL+="projekt_id,dzial_id,handlowiec_id,kontrahent_id,kwota_wn,kwota_ma,nr_poz)"
                SQL+=" VALUES"
                SQL+=" ('"+Firma+"','"+Okres+"','"+Dowod+"','"+Nazwa+"','"+Data+"',"+str(Numer)+","
                SQL+=" '"+Projekt+"',"+Dzial+","+Handlowiec+",COALESCE("+KontrProj+","+Kontrahent+"),"
                SQL+=" "+str(KwotaWn)+","+str(KwotaMa)+","+str(NrPoz)+"); "
                
                NrPoz=NrPoz+1
        
    SQL+="UPDATE rs_dowody_ksiegowe SET stan='W'"
    SQL+=" WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"' AND dowod_id='"+Dowod+"'"
    SQL+=" AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,dump,dump,dump = PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        return u'Bd dodawania pozycji podziau kosztw : '+stat
    
    return 'OK'