# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_drukarki_fiskalne.py
# Purpose:     wyswietla, dodaje,usuwa drukarki fiskalne
# Author:      Pawel Wojcikowski
# Created:     2008/11/12
# RCS-ID:      $Id: fs_drukarki_fiskalne.py$
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Jan Kaliszewski, 2009-10-15: popr. bdu usuwania drukarki fiskalnej
# mariusz rajfura, 2010-01-05: przenies.dod/edycji do fs_drukarki_fiskalne_dane mantis:3029

Oddzial = rsglobal.Dekoduj(klucze[0])
Kasa = rsglobal.Dekoduj(klucze[1])
Fun = klucze[-1]

stat = "OK"
dane = []
wyn1 = []
wyn2 = []

UprOddzialy = ''

UprUsuwanie = (self.oddzial_id,'014064') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprUsuwanie:
        stat = 'UPR DEL'

    if stat == 'OK':
        sql ="SELECT kasa_id FROM rs_kasy_fiskalne"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        sql+=" AND kasa_id='"+Kasa+"' FOR UPDATE NOWAIT;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o drukarce fiskalnej : '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Bdny numer drukarki fiskalnej'
            dane.append(stat)

        if stat == 'OK':
            sql ="SELECT numer FROM rs_paragony_fiskalne"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id='"+Kasa+"';"
            
            stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o paragonach : '+stat
                dane.append(stat)
            elif len(dane)>0:
                stat = "WYST PAR"
                dane.append(stat)
            
        if stat == 'OK':
            DELETE ="DELETE FROM rs_kasy_fiskalne"
            DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id='"+Kasa+"';"
            
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> "OK":
                stat="BL DEL"
                dane.append(stat)

#-------------------------------------------------------------------------------
# POBRANIE LISTY DOZWOLONYCH DZIALOW I DRUKAREK/KAS FISKALNYCH Z TYCH DZIALOW
#-------------------------------------------------------------------------------

if Fun in (5,6,15,25) and stat == 'OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
    else:
        sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
        sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
        sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
        sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
        sql+=" ORDER BY o.oddzial_id;"

    stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
    else:
        if len(oddz) == 0:
            stat = 'Brak oddzialw, do ktrych uytkownik ma prawa.'
        else:
            UprOddzialy = '('
            for i in oddz:
                UprOddzialy += "'"+str(i[0])+"',"

            UprOddzialy = UprOddzialy[:-1]+")"

            sql ="SELECT oddzial_id,kasa_id FROM rs_kasy_fiskalne WHERE firma_id = '"+self.firma_id+"'"
            sql+=" AND oddzial_id IN "+UprOddzialy+";"

            stat,kasy,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania listy udostpnionych drukarek : '+stat

    if stat == 'OK':
        dane = oddz
        wyn1 = kasy

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH LISTY DRUKAREK TYLKO SPOSROD DOZWOLONYCH ODDZIALOW
#-------------------------------------------------------------------------------

if Fun == 15 and stat=='OK':
    UprOddzial = rsglobal.Dekoduj(klucze[-2]).strip()
    if UprOddzial <> '':
        UprOddzialy = "('"+UprOddzial+"')"

    SELECT ="SELECT oddzial_id,kasa_id,opis_kasy,typ_kasy_id FROM rs_kasy_fiskalne"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"'"
    if len(UprOddzialy) > 0:
        SELECT+=" AND oddzial_id IN "+UprOddzialy
    SELECT+=" ORDER BY oddzial_id,kasa_id;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'BL SELECT'
        dane.append(stat) 

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    SELECT ="SELECT oddzial_id,kasa_id,opis_kasy,typ_kasy_id"
    SELECT+=" FROM rs_kasy_fiskalne"
    SELECT+=" WHERE firma_id='"+self.firma_id+"'"
    
    #uwzglednienie dozwolonych oddzialow
    if len(UprOddzialy) > 0:
        SELECT+=" AND oddzial_id IN "+UprOddzialy
    SELECT+=" ORDER BY oddzial_id,kasa_id;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'BL SELECT'
        dane.append(stat)   
