# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_drukarki_fiskalne_dane
# Purpose:     dodawanie/edycja danych drukarki fiskalnej
# Author:      Mariusz Rajfura
# Created:     2010/01/05
# RCS-ID:      $Id: fs_drukarki_fiskalne_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Oddzial = rsglobal.Dekoduj(klucze[0]).strip()
Kasa = rsglobal.Dekoduj(klucze[1]).strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = (((self.oddzial_id,'014063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'014062') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if Oddzial == '':
        stat = 'BR ODDZIAL'
        dane.append(stat)
    else:
        sql ="SELECT oddzial_id FROM rs_oddzialy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            dane.append('Bd sprawdzenia numeru oddzialu : '+stat)
        elif len(d) == 0:
            dane.append('BL ODDZIAL')
            
    if stat == 'OK':
        #sprawdzenie czy oddzial jest na liscie dozwolonych oddzialow
        if self.operator_id <> STANDARD_OPERATOR_ID:
            sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
            sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
            sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
            sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
            sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
            sql+=" ORDER BY o.oddzial_id;"

            stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
            else:
                if len(oddz) == 0:
                    stat = 'Brak oddzialw, do ktrych uytkownik ma prawa.'
                else:
                    jest = False
                    for i in xrange(len(oddz)):
                        if Oddzial == str(oddz[i][0]):
                            jest = True
                            break
                    
                if not jest:
                    stat = 'BR UPR ODDZIAL'
                    
    if stat == 'OK':
        if Kasa == '':
            stat = 'BR KASA'
            dane.append(stat)
        else:
            if len(Kasa) <> 5:
                stat = 'BL DL KASA'
                dane.append(stat)
            else:    
                sql ="SELECT kasa_id FROM rs_kasy_fiskalne WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kasa_id = '"+Kasa+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia istnienia drukarki fiskalnej : '+stat
                elif len(d) <>0:
                    stat='BL KASA IST'
                
if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'opis_kasy':
            if wart == '':
                dane.append('BR OPIS KASY')
            wartosci[i] = "'"+wart+"'"
            
        elif pole == 'typ_kasy_id':
            if wart == '':
                dane.append('BR TYP KASY')
            else:
                sql ="SELECT kod FROM rs_typy_drukarek_fiskalnych WHERE kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia kodu typu drukarki fiskalnej : '+stat)
                elif len(d) == 0:
                    dane.append('BL TYP KASY')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'konto':
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if (DaneTmp <> []) and (DaneTmp <> None):
                    Dane = rsglobal.rseval(DaneTmp[0][0])
                    if Dane[0] == '':
                        dane.append('BL KONTO')
                else:
                    dane.append('Bd sprawdzenia numeru konta')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'zaokrag_piatki':
            if not wart in ['D','G']:
                dane.append('BL WART PIATEK')
            wartosci[i] = "'"+wart+"'"
            
        elif pole == 'kontrahent_domyslny':
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kontrahent_id = '"+wart+"' AND aktywny;"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia istnienia kontrahenta domylnego : '+stat)
                elif len(d) == 0:
                    dane.append('BL KONTR')
                wartosci[i] = "'"+wart+"'"

        else:
            #pozostale pola
            wartosci[i] = "'"+str(wart)+"'"

    if len(dane) > 0:
        stat = dane[0]

#-------------------------------------------------------------------------------
#--- DODAWANIE (1 -z pobraniem  2 - bez pobrania)
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = "firma_id,oddzial_id,kasa_id"
    inswart = "'"+self.firma_id+"','"+Oddzial+"','"+Kasa+"'"

    for i in xrange(len(pola)):
        if not pola[i] in ('oddzial_id','kasa_id'):
            inspola += ","+pola[i]
            inswart += ","+wartosci[i]
        	
    INSERT ="INSERT INTO rs_kasy_fiskalne ("+inspola+") VALUES ("+inswart+");"
    INSERT+="INSERT INTO rs_kasy_fiskalne_vat (firma_id, oddzial_id, kasa_id, stawka_vat, kod)" 
    INSERT+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Kasa+"','22','A');"
    INSERT+="INSERT INTO rs_kasy_fiskalne_vat (firma_id, oddzial_id, kasa_id, stawka_vat, kod)" 
    INSERT+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Kasa+"','07','B');"

    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowej drukarki fiskalnej : '+stat

#-------------------------------------------------------------------------------
#--- UPDATE ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kasy_fiskalne SET "

    for i in xrange(len(pola)):
	    UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE = UPDATE[:-1]
    UPDATE+= " WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"'"
    UPDATE+=" AND kasa_id = '"+Kasa+"';"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
	    stat = 'Bd aktualizacji danych drukarki fiskalnej : '+stat

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem  1 - insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    OddzialOpis = ''
    TypOpis = ''
    KontoOpis = ''
    KontrOpis = ''

    SELECT ="SELECT * FROM rs_kasy_fiskalne"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"'"
    SELECT+=" AND kasa_id = '"+Kasa+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych drukarki fiskalnej : '+stat
        dane.append(stat)

    if stat == 'OK':
        for i in xrange(len(dane[0])):
            pole = wyn1[i][0]
            wart = str(dane[0][i])

            if pole == 'oddzial_id':
                if (self.oddzial_id,'001100') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        OddzialOpis = 'Bd pobrania opisu oddziau : '+stat
                    else:
                        if len(d) == 0:
                            OddzialOpis = 'Bdny kod oddziau.'
                        else:
                            OddzialOpis = str(d[0][0])
                else:
                    OddzialOpis = 'Brak uprawnie do oddziaw. Poinformuj administratora.'

            elif pole == 'typ_kasy_id':
                if (self.oddzial_id,'011840') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_typy_drukarek_fiskalnych WHERE kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        TypOpis = 'Bd pobrania opisu ze sownika typw drukarek fiskalnych : '+stat
                    else:
                        if len(d) == 0:
                            TypOpis = 'Bdny kod typu drukarki fiskalnej.'
                        else:
                            TypOpis = str(d[0][0])
                else:
                    TypOpis = 'Brak uprawnie do sownika typw drukarek. Poinformuj administratora.'

            elif pole == 'konto' and wart <> 'None':
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                st,d,dump,dump = self.PolSQL.Execute(sql,3)
                d = self.PolSQL.Execute(sql,3)[1]
                if (d <> []) and (d <> None):
                    Dane = rsglobal.rseval(d[0][0])
                    if Dane[0] == '':
                        KontoOpis = 'Bdne konto'
                    else:
                        KontoOpis = str(Dane[1])
                else:
                    KontoOpis = 'Bd pobrania nazwy konta'
                    
            elif pole == 'typ_kasy_id' and wart<>'None':
                if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        KontrOpis = 'Bd pobrania opisu z tabeli kontrahentw : '+stat
                    else:
                        if len(d) == 0:
                            KontrOpis = 'Bdny Symbol kontrahenta.'
                        else:
                            KontrOpis = str(d[0][0])
                else:
                    KontrOpis = 'Brak uprawnie do okna kontrahentw. Poinformuj administratora.'

    wyn2 = [OddzialOpis,TypOpis,KontoOpis,KontrOpis]
