# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_esprawozdania.py
# Purpose:
#
# Author:      Wojciech Skowron, Aleksander Bargie
# Created:     2019/02/20
# RCS-ID:      $Id: fs_esprawozdania.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2021-10-20 Wojciech Skowron (12174) - poprawka obsugi pliku

from datetime import datetime, timedelta
from os import listdir
from os.path import isdir, isfile, join


"""Funkcje:
1. Zwraca list schematw znajdujcych si na serwerze
2. Przesya zawarto wybranego pliku
3. Wyszukuje pole formularza przypisane do wskazanej cieki
4. Wpisuje ciek z sprawozdania do pola formularza
5. Pobranie danych firmy i oddziau"""

stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']
    SlPar = {'Sprawozdanie': [2], 'Data': [2], 'KluczXSD': [3, 4], 'PoleFormularza': [4]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_esprawozdania z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [2]:
        Sprawozdanie = klucze['Sprawozdanie']
        Data         = klucze['Data']
    if Fun in [3, 4]:
        KluczXSD = klucze['KluczXSD']
    if Fun in [4]:
        PoleFormularza = klucze['PoleFormularza']

dane = []
wyn1 = []
wyn2 = []

katalog = 'xsd'

# -------------------------------------------------------------------------------
# --- KONTROLA UPRAWNIEN
# -------------------------------------------------------------------------------

# if not((self.oddzial_id,'?') in self.uprawnienia) and self.operator_id != STANDARD_OPERATOR_ID:
#     stat = 'Brak uprawnie'

# -------------------------------------------------------------------------------
# --- (1) - Pobranie schematw XSD z serwera
# -------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    Lista_sprawozdan = {}

    for kat_spr in [kat for kat in listdir(katalog) if isdir(join(katalog, kat))]:
        sprawozdanie = kat_spr
        kat_spr = join(katalog, kat_spr)

        for kat_data in [kat for kat in listdir(kat_spr) if isdir(join(kat_spr, kat))]:
            data = kat_data
            kat_data = join(kat_spr, kat_data)

            for plik in [p for p in listdir(kat_data) if (isfile(join(kat_data, p)) and p.endswith('.xsd'))]:
                if sprawozdanie not in Lista_sprawozdan.keys():
                    Lista_sprawozdan[sprawozdanie] = []
                Lista_sprawozdan[sprawozdanie].append(data)

    if not Lista_sprawozdan:
        stat = 'Nie odnaleziono sprawozda.'
    else:
        stat = 'OK'
        dane = Lista_sprawozdan

# -------------------------------------------------------------------------------
# --- (2) - Przesanie zawartoci wybranego pliku XSD
# -------------------------------------------------------------------------------

if Fun == 2 and stat == 'OK':
    kat = join(katalog, Sprawozdanie, Data)
    Tresc = ''

    for plik in listdir(kat):
        if isfile(join(kat, plik)) and plik.endswith('.xsd'):
            try:
                #WS 2021-10-20
                with open(join(kat, plik), 'rb') as p:
                    Tresc = p.read()
                # Tresc = open(join(kat, plik), 'rb').read()
            except Exception, e:
                stat = 'Bd wczytania pliku z serwera: ' + str(e)
        else:
            stat = 'dany plik nie istnieje lub ma nieprawidowe rozszerzenie.'

    if stat == 'OK':
        if Tresc != '':
            dane = Tresc
        else:
            stat = 'dany plik jest pusty.'

# -------------------------------------------------------------------------------
# --- (3) - Pobranie pola formularza przypisanego do pola w sprawozdaniu
# -------------------------------------------------------------------------------

if Fun == 3 and stat == 'OK':
    SQL = """SELECT formularz_id, wiersz, kolumna 
    FROM rs_formularze_pozycje 
    WHERE firma_id='{}' AND klucz_sprawozdania='{}';""".format(self.firma_id, KluczXSD)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SQL, 5)
    if stat != 'OK':
        stat = 'Bad pobierania danych pola formularza do ktrego przypisane jest pole sprawozdania: ' + stat
    elif dane:
        dane = dane[0]

# -------------------------------------------------------------------------------
# --- (4) - Aktualizacja pola formularza przypisanego do pola w sprawozdaniu
# -------------------------------------------------------------------------------

if Fun == 4 and stat == 'OK':
    form   = PoleFormularza[0]
    wiersz = PoleFormularza[1]
    kol    = PoleFormularza[2]
    SQL    = """UPDATE rs_formularze_pozycje 
                SET klucz_sprawozdania='' 
                WHERE firma_id='{firma}' AND klucz_sprawozdania='{klucz}';
                
                UPDATE rs_formularze_pozycje 
                SET klucz_sprawozdania='{klucz}' 
                WHERE firma_id='{firma}' AND formularz_id='{form}' AND wiersz={wiersz} 
                    AND kolumna={kol};""".format(firma=self.firma_id, klucz=KluczXSD, form=form, wiersz=wiersz, kol=kol)
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SQL, 5)
    if stat != 'OK':
        stat = u'Bad aktualizacji pola formularza do ktrego przypisane jest pole sprawozdania: ' + stat

# -------------------------------------------------------------------------------
# --- (5) - Pobranie domylnych danych do sprawozdania
# -------------------------------------------------------------------------------

if Fun == 5 and stat == 'OK':
    dane     = {}
    dzis     = datetime.now()
    koniec   = dzis - timedelta(days=dzis.day)
    poczatek = koniec.replace(day=1)
    dzis     = str(dzis)
    poczatek = str(poczatek)
    koniec   = str(koniec)

    dane['Naglowek:OkresOd'] = poczatek
    dane['Naglowek:OkresDo'] = koniec
    dane['Naglowek:DataSporzadzenia'] = dzis
    SQL = """SELECT nazwa, adr_wojew, adr_powiat, adr_gmina, adr_miej, adr_kraj, adr_ulica, adr_nry, adr_miej, adr_kod, 
                    adr_poczta, nip 
             FROM rs_oddzialy WHERE firma_id='{}' AND oddzial_id='{}';""".format(self.firma_id, self.oddzial_id)
    stat, oddz, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat == 'OK' and len(oddz) > 0:
        oddz = oddz[0]
        slownik = {}
        for i in range(len(oddz)):
            slownik[wyn1[i][0]] = oddz[i]
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1A:NazwaFirmy']           = slownik['nazwa']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1A:Siedziba:Wojewodztwo'] = slownik['adr_wojew']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1A:Siedziba:Powiat']      = slownik['adr_powiat']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1A:Siedziba:Gmina']       = slownik['adr_gmina']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1A:Siedziba:Miejscowosc'] = slownik['adr_miej']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:Wojewodztwo']    = slownik['adr_wojew']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:Powiat']         = slownik['adr_powiat']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:Gmina']          = slownik['adr_gmina']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:Ulica']          = slownik['adr_ulica']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:NrDomu']         = slownik['adr_nry']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:Miejscowosc']    = slownik['adr_miej']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:KodPocztowy']    = slownik['adr_kod']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1B:Adres:Poczta']         = slownik['adr_poczta']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_1:P_1D:NIP']                  = slownik['nip']
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_3:DataOd']                    = poczatek
        dane['WprowadzenieDoSprawozdaniaFinansowego:P_3:DataDo']                    = koniec
    else:
        stat = u"Bd pobierania domylnych danych sprawozdania: " + stat
