# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_faktura_z_dokumentu_magazynowego.py
# Purpose:     generuje fakture z dokumentu magazynowego
# Author:      Jarek Plawgo
# Created:     2006/07/21
# RCS-ID:      $Id: fs_faktura_z_dokumentu_magazynowego.py $
# Copyright:   (c) 2006 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2009.12.23 Micha Raburski (4151) - zmiany w pobieraniu vat
# 2013-02-03 Mariusz Rajfura (6478) kontrola blokady kontrahenta przed wystawieniem faktury
# 2014-04-08 Micha Raburski (7727) przepisywanie handlowcw z zamwienia na faktur
# 2017-10-18 Rafa Woniak (10782) dodanie pobierania danych czy oddzielny wat
# 2019-08-06 Wojciech Skowron (11579) Czy_mpp ustawiane na True jesli zaznaczone u patnika lub kontrahenta
# 2020-03-23 Mikoaj Kozowski  (11906) Uzupenianie pola 'kod_gtu' w pozycjach faktury przy tworzeniu faktur z dokumentu magazynowego
# 2020-04-05 Wojciech Skowron (11911) Bd przy tworzeniu faktury z dm z odznaczon opcj 'nowa faktura'
# 2021-12-03 Aleksander Bargie (12748) Blad przy tworzeniu faktury z WZ
# 2024-01-03 Aleksander Bargie (13656) Tworzenie faktury z DM, projekt Patnika nie zawiera '' i psuje zapytanie

#klucze=[[KluczM],[KluczF],Sklejac]  SKlejac - czy sklejac podpozycje
from funkcje import fs_global_faktury

stat='OK'
dane=[]

if len(klucze) != 7:
    stat='BL KLUCZ'
    
if stat=='OK':
    KluczM=klucze[0]
    KluczF=klucze[1]
    Sklejac=klucze[2]
    SklejacPoz=klucze[3]
    DodNagl=klucze[4]
    Dodawac=klucze[5]
    RozbijacCecha=klucze[6]

    MagM= rsglobal.Dekoduj(KluczM[0])
    TypM= rsglobal.Dekoduj(KluczM[1])
    DataM = rsglobal.Dekoduj(KluczM[2])
    NumerM = rsglobal.Dekoduj(str(KluczM[3]))

    WyznF = rsglobal.Dekoduj(KluczF[0])
    DataF = rsglobal.Dekoduj(KluczF[1])
    NumerF = rsglobal.Dekoduj(str(KluczF[2]))
    
    WyznZamO='NULL'
    DataZamO='NULL'
    NrZamO='NULL'
    BlokadaCen = False
    BlokadaCenS = "FALSE"
    OsobnyVat = False

#sprawdzenie poprawonosci przychodzcych danych
    
    FiltrM = " firma_id='"+self.firma_id+"' AND magazyn_id='"+MagM+"' AND dokument_id = '"+TypM+"' AND data = '"+DataM+"' AND numer = "+str(NumerM)
    FiltrF = " firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznF+"' AND data = '"+DataF+"' AND numer = "+str(NumerF)
    
    if not (((self.oddzial_id,"022012") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="BL UPR"   

if stat=='OK':
    # sprawdzenie daty faktury z zakresem
    sql ="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+self.oddzial_id+"','"+DataF+"',1);"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzenia daty dokumentu z zakresem dat faktur : '+stat
    else:
        if d[0][0] != 1:
             stat = 'BL DATAF POZA ZAKR'
             dane.append(stat)

    #sql="SELECT sprzedaz_od,sprzedaz_do FROM rs_zakresy_dat WHERE firma_id='"+self.firma_id+"';"
    #stat,daty,dump,dump = self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
    #if stat != 'OK':
    #    stat = 'Bd pobrania zakresw dat dla sprzeday: '+stat
    #elif len(daty) == 0:
    #    stat = 'Tabela zawierajca zakresy dat jest pusta. Powiadom administratora.'
    #else:
    #    if daty[0][0] != 'None':
    #        if DataF < daty[0][0]:
    #            stat = 'BL DATAF PRZED ZAKR'
    #            dane.append(stat)

    #    if daty[0][1] != 'None':
    #        if DataF > daty[0][1]:
    #            stat = 'BL DATAF POZA ZAKR'
    #            dane.append(stat)
    #jesli byl jakis blad, dotyczacy dat
    #if len(dane) > 0:
    #    stat = dane[0]

if stat=='OK':
    stat,DaneTDok,dump,dump=self.PolSQL.Execute("SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id=\'"+self.firma_id+"\' AND dokument_id = \'"+TypM+"\';",3, CzyDodawacBlad=True)    

if stat=='OK':
    if len(DaneTDok) == 0:
        stat='BR TYPDOK'
    elif DaneTDok[0][0] != 'W':
        stat='BL TYPDOK'

if stat=='OK':
    SQL="SELECT f_numer,stan,magazyn_dokad,kontrahent_id,kierowca,waluta,kwota_wal,kwota,"
    SQL+="zo_wyznacznik_id,zo_data,zo_numer,projekt_id FROM rs_dokumenty_magazynowe WHERE "+FiltrM+";"
    stat,DaneM,wyn1,wyn2=self.PolSQL.Execute(SQL,3, CzyDodawacBlad=True)

if stat=='OK':
    if len(DaneM) == 0:
        stat='BR DOKMAG'
    elif DaneM[0][3] in ('',None,'None'):
        stat='BR KONTR MAG'

if stat=='OK':
    if DaneM[0][0] > 0:
        stat='UZ DOKMAG'

if stat=='OK':
    if DaneM[0][1]=="W":
        stat='NZ DOKMAG'

# kontrola blokady na wystawianie faktur
if stat=='OK':
    sql ="SELECT zablokowany FROM rs_kontrahenci"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(DaneM[0][3])+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzenia blokady dla kontrahenta: '+stat
    elif d[0][0]:
        stat = 'BL ZABLOKOWANY'
       
if stat=='OK':
    #sprawdzenie blokowania cen - czy bedzie i czy nowa faktura
    if DaneM[0][8] not in ["None",None,'']:
        WyznZamO=rsglobal.Dekoduj(DaneM[0][8])
        DataZamO=rsglobal.Dekoduj(DaneM[0][9])
        NrZamO=DaneM[0][10]
        SQL="SELECT blokada_cen FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND"
        SQL+=" wyznacznik_id='"+WyznZamO+"' AND data='"+DataZamO+"' AND numer="+str(NrZamO)
        stat,DaneZamO,dump,dump=self.PolSQL.Execute(SQL,3, CzyDodawacBlad=True)    
        if stat=='OK':
            if len(DaneZamO)==0:
                stat="BR ZAM"
            else:
                BlokadaCen=DaneZamO[0][0]
        
if stat=='OK' and Dodawac:
    stat,DaneMP,wyn1,wyn2=self.PolSQL.Execute("SELECT * FROM rs_dokumenty_magazynowe_pozycje WHERE "+FiltrM+";",3, CzyDodawacBlad=True)
    if len(DaneMP) == 0:
        stat='BR DMPOZ'
        
        
#sprawdzenie uprawnien do konkretnego wyznacznika na modyfikacje oraz jego typu
if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
    stat,dwyzn,dump,dump=self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)

if stat=='OK':
    LWyzn=rsglobal.rseval(dwyzn[0][0])[1]
    WBuf=WyznF.strip()+'  '
    if not WBuf[0:2] in LWyzn:
        stat='Brak uprawnie do edycji wybranego wyznacznika'
       
if stat=='OK':
    SQL="SELECT typ_faktury,czy_korekta FROM rs_wyznaczniki "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznF+"'"
    stat,dwyzn,dump,dump=self.PolSQL.Execute(SQL,3, CzyDodawacBlad=True)
if stat=='OK':
    if len(dwyzn)==0:
        stat='Podany wyznacznik jest nieprawidowy'
    elif dwyzn[0][0] in ['ZA','ZO','ZD']:
        stat='Podany wyznacznik jest nieprawidowego typu'
    elif dwyzn[0][1]:
        stat='Podany wyznacznik jest wyznacznikiem korekty'

if stat=='OK':
    #sprawdzenie istnienia faktury (lub nieistnienia) w zalenoci od parametru czy nowa.
    stat,DaneF,wyn1,wyn2=self.PolSQL.Execute("SELECT stan FROM rs_faktury WHERE "+FiltrF+";",3, CzyDodawacBlad=True)
    
    if DodNagl: #jeli nie powinna istnie
        if len(DaneF)>0:
            stat='IS FAKT'    
        else:
            #sprawdzenie czy mona doda faktur z t dat. I czy podany numer jest ok
            stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+WyznF+"\\\',\\\'"+DataF+"\\\']','F');",3, CzyDodawacBlad=True)            
            if dane[0][0]=='OK':
                stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+WyznF+"\\\',\\\'"+DataF+"\\\']','F');",3, CzyDodawacBlad=True)        
                if dane[0][0] in (None,'None',''):
                    stat="BL N NUM"
            elif stat=='OK':
                stat="NM DD"

        if stat=='OK':
            if int(dane[0][0])<> int(NumerF):
                stat='BL POR NR'
        #powinna istnie
        
    elif len(DaneF)==0:
        stat='BR FAKT'    
    elif DaneF[0][0] <>'W':
        stat='ZM FAKT'    
        #chcemy dodawac pozycje przy blokadzie cen
    elif BlokadaCen:
        stat='BLOK CEN ISTN FAK'    

    if stat=='OK' and not DodNagl:
        #sprawdzamy, czy kontrahent_id z dok.mag jest zgodny z kontrahent_id na fakturze, do ktorej dopisujemy
        sql ="SELECT kontrahent_id FROM rs_faktury"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+WyznF+"' AND data = '"+DataF+"'"
        sql+=" AND numer = "+NumerF+" AND kontrahent_id='"+rsglobal.Dekoduj(DaneM[0][3])+"';"
            
        stat,d,dump,dump = self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania kontrahenta z faktury : '+stat
        elif len(d) != 1:
            stat = 'BL ROZNICA KTH'

#dodawanie nagwka gdy faktura nie istnieje
if stat=='OK' and DodNagl and Dodawac:
    Kontrahent=rsglobal.Dekoduj(DaneM[0][3])
    # stat,DaneMag,wyn1,wyn2=self.PolSQL.Execute("SELECT oddzial_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagM+"';",3, CzyDodawacBlad=True) #WS 2019-08-06 - zakomentowany nieuywany Execute
    #Oddz=rsglobal.Dekoduj(DaneMag[0][0])
    stat,DaneK,wyn1,wyn2=self.PolSQL.Execute("SELECT zamawiajacy_id,platnik_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';",3,CzyDodawacBlad=True)
    #WS 2019-08-06 - sprawdzenie stat
    if stat != 'OK':
        stat = 'Bd przy pobieraniu danych kontrahenta: '+stat

                #WS 2020-04-05
if stat == 'OK' and DodNagl and Dodawac: #WS 2019-08-06
    Zamawiaj=rsglobal.Dekoduj(DaneK[0][0])

    if Zamawiaj in ('None','','     '):
        Zamawiaj=Kontrahent
    Platnik=rsglobal.Dekoduj(DaneK[0][1])
    if Platnik in ('None','','     '):
        Platnik=Kontrahent

    #WS 2019-08-06
    CzyMPP = False

    SEL = """SELECT BOOL_OR(czy_mpp) FROM rs_kontrahenci WHERE firma_id = '{}' AND kontrahent_id in ('{}','{}');"""
    SEL = SEL.format(self.firma_id, Platnik or 'NULL', Kontrahent or 'NULL')
    stat,DMPP,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd przy pobieraniu danych patnika/kontrahenta faktury: '+stat
    elif DMPP[0][0]:
        CzyMPP = True

if stat == 'OK' and DodNagl and Dodawac:  #WS 2020-04-05
    Kier=rsglobal.Dekoduj(DaneM[0][4])
    if Kier=='None':
        Kier='NULL'
    else:
        Kier="'"+Kier+"'"
    
    Wersja='NULL'
    SpZap='NULL'
    Hand='NULL'
    SpOF='NULL'
    SpD='NULL'
    SpD='NULL'
    Dni='0'
    Upust='0'
    
    #projekt pobrany z dokumentu magazynowego
    Projekt = str(DaneM[0][11])
    if Projekt == 'None':
        Projekt = 'NULL'
    else:
        Projekt = "'"+Projekt+"'"
    # RW dodanie pobierania danych czy oddzielny wat
    sql ="SELECT wersja,spos_zaplaty,handlowiec,sposob_odbioru_faktury,spos_dostawy,dni,upust,projekt_id,osobny_rachunek_vat"
    sql+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
    sql+=" AND data_od <= '"+DataF+"' ORDER BY data_od DESC LIMIT 1;"
    stat,DaneKF,wyn1,wyn2=self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
    if DaneKF != []:
        if DaneKF[0][8] in [True, False]:
            OsobnyVat = DaneKF[0][8]

    if len(DaneKF)==0 and Platnik!=Kontrahent:
        sql ="SELECT wersja,spos_zaplaty,handlowiec,sposob_odbioru_faktury,spos_dostawy,dni,upust,projekt_id,osobny_rachunek_vat"
        sql+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"'"
        sql+=" AND data_od <= '"+DataF+"' ORDER BY data_od DESC LIMIT 1;"
        stat,DaneKF,wyn1,wyn2=self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
    
    if len(DaneKF)<>0:
        if rsglobal.Dekoduj(DaneKF[0][0])<>'None':
            Wersja="'"+rsglobal.Dekoduj(DaneKF[0][0])+"'"
        if rsglobal.Dekoduj(DaneKF[0][1])<>'None':
            SpZap="'"+rsglobal.Dekoduj(DaneKF[0][1])+"'"
        if rsglobal.Dekoduj(DaneKF[0][2])<>'None':
            Hand="'"+rsglobal.Dekoduj(DaneKF[0][2])+"'"
        if rsglobal.Dekoduj(DaneKF[0][3])<>'None':
            SpOF="'"+rsglobal.Dekoduj(DaneKF[0][3])+"'"
        if rsglobal.Dekoduj(DaneKF[0][4])<>'None':
            SpD="'"+rsglobal.Dekoduj(DaneKF[0][4])+"'"
            
        if Projekt == 'NULL':
            #jesli na dokumencie brak projekt_id, probujemy projekt_id z rs_kontrahenci_fakturowanie
            if rsglobal.Dekoduj(DaneKF[0][7])<>'None':
                Projekt="'"+rsglobal.Dekoduj(DaneKF[0][7])+"'"
        if DaneKF[0][8] in [True,False]:
            OsobnyVat = DaneKF[0][8]
        else:
            OsobnyVat = False
        Upust=str(DaneKF[0][6])
      
        Dni=str(DaneKF[0][5])
        Dni=Dni[0:Dni.find('.')]

    if Projekt == 'NULL' and Platnik != Kontrahent:
        #proba pobrania projektu z wersji dla platnika jesli platnik jest inny niz kontrahent,
        # bo moze byc wersja fakturowania dla kontrahenta ale nie bedzie wpisanego projektu
        sql ="SELECT projekt_id,osobny_rachunek_vat FROM rs_kontrahenci_fakturowanie"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"'"
        sql+=" AND data_od <= '"+DataF+"' ORDER BY data_od DESC LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych fakturowania dla patnika : '+stat
        elif len(d) >= 1:
            if rsglobal.Dekoduj(d[0][0]) != 'None':
                Projekt = "'"+rsglobal.Dekoduj(d[0][0])+"'"  #AB 2024-01-03
            if d[0][1] in [True,False]:
                OsobnyVat = d[0][1]
            else:
                OsobnyVat = False
    if BlokadaCen:
        BlokadaCenS='TRUE'
    else:
        BlokadaCenS='FALSE'

    Kurs=1
    if DaneM[0][7] != 0:
        Kurs=DaneM[0][6]/DaneM[0][7]
        
    if WyznZamO not in ["NULL","None",None,'']:
        WyznZamO="'"+WyznZamO+"'"
        DataZamO="'"+DataZamO+"'"
        NrZamO=str(NrZamO)
    else:
        WyznZamO = 'NULL'
        DataZamO = 'NULL'
        NrZamO   = 'NULL'


    #MK 2020-04-22
    if stat == 'OK':
        sqlw = "SELECT ozn_trans,ozn_sprzedaz"
        sqlw += " FROM rs_wyznaczniki"
        sqlw += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id = '" + WyznF + "';"
        stat, dww, dump, dump = self.PolSQL.Execute(sqlw, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
            dane.append(stat)
        if dww != []:
            OznTrans = dww[0][0]
            OznSprz = dww[0][1]
    
    SQL='INSERT INTO rs_faktury '
    SQL+='(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,'
    SQL+='dostawy_od_dnia,dostawy_do_dnia,kierowca,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,'
    SQL+='termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,projekt_id,upust,upust_wartosc,upust_wartosc_wal,'
    SQL+='rabat,rabat_wartosc,rabat_wartosc_wal,kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,'
    SQL+='kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,numer_z_rs,'
    SQL+='zo_wyznacznik_id,zo_data,zo_numer,blokada_cen,osobny_rachunek_vat,czy_mpp,ozn_trans,ozn_sprzedaz)' #WS 2019-08-06 - dodane czy_mpp #MK 2020-04-22
    SQL+=' VALUES '
    SQL+="('"+self.firma_id+"','"+WyznF+"','"+DataF+"',"+str(NumerF)+",'"+self.oddzial_id+"','W','"+rsglobal.Dekoduj(DaneM[0][3])+"','"+Zamawiaj+"','"+Platnik+"','"+rsglobal.Dekoduj(DaneM[0][3])+"',"
    SQL+="NULL,NULL,"+Kier+",'"+rsglobal.Dekoduj(DaneM[0][5])+"',"+str(Kurs)+",NULL,NULL,"+Wersja+","+SpZap+","+Dni+",NULL,"
    SQL+="date '"+DataF+"' + integer '"+Dni+"',"+Hand+","+SpOF+","+SpD+","+Projekt+","+Upust+",0,0,"
    SQL+="0,0,0,0,0,0,0,"
    SQL+="0,0,0,0,'','','',"
    SQL+=WyznZamO+","+DataZamO+","+NrZamO+","+BlokadaCenS+","+str(OsobnyVat)+","+str(CzyMPP) #WS 2019-08-06 - dodane CzyMPP
    if OznTrans not in ('None', ''):
        SQL+= ",'" + str(OznTrans) + "'"  #MK 2020-04-22
    else:
        SQL+= ",NULL"
    if OznSprz not in ('None', ''):
        SQL+= ",'" + str(OznSprz) + "'"  #MK 2020-04-22
    else:
        SQL += ",NULL"

    SQL +=");"
    
    # pobranie udziaw handlowcw z zamwienia na faktur
    # if WyznZamO != 'NULL':  #AB 01.12.21r
    if WyznZamO not in ["NULL","None",None,'']:
        SQL+=" INSERT INTO rs_faktury_handlowcy (firma_id,wyznacznik_id,data,numer,handlowiec_id,udzial) "
        SQL+=" SELECT firma_id,'"+WyznF+"','"+DataF+"',"+str(NumerF)+",handlowiec_id,udzial "
        SQL+=" FROM rs_zamowienia_odbiorcy_handlowcy"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id="+WyznZamO  #AB 01.12.21r usuniete ciapki
        SQL+=" AND data="+DataZamO+" AND numer="+NrZamO+';'  #AB 01.12.21r

    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,1, CzyDodawacBlad=True)    

#dodanie pozycji
if stat=='OK' and Dodawac:
    # dla blokady cen podajemy ceny netto i upust zwyke i walutowe. Reszta bdzie wyliczona funkcj.
    CenaN1='0'
    CenaN2='0'
    CenaU1='0'
    CenaU2='0'
    CenaNW1='0'
    CenaNW2='0'
    CenaUW1='0'
    CenaUW2='0'
    if BlokadaCen:
        Pole="COALESCE((SELECT %s FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id=dmp.firma_id " 
        Pole+="AND wyznacznik_id=dmp.zo_wyznacznik_id AND data=dmp.zo_data AND numer=dmp.zo_numer"
        Pole+=" AND nr_poz=dmp.zo_nr_poz AND nr_ppoz=dmp.zo_nr_ppoz),0)"
        CenaN1=Pole % 'cena_netto1'
        CenaN2=Pole % 'cena_netto2'
        CenaU1=Pole % 'cena_upust1'
        CenaU2=Pole % 'cena_upust2'
        CenaNW1=Pole % 'cena_wal1'
        CenaNW2=Pole % 'cena_wal2'
        CenaUW1=Pole % 'cena_upust_wal1'
        CenaUW2=Pole % 'cena_upust_wal2'
    
    stat,dane,dump,dump=self.PolSQL.Execute("SELECT max(nr_poz) FROM rs_faktury_pozycje WHERE "+FiltrF,3, CzyDodawacBlad=True)
    if stat=='OK':
        NrP=dane[0][0]

        
        # zapytanie dodajce pozycje
        SQL="INSERT INTO rs_faktury_pozycje "
        SQL+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"                                                        #1
        SQL+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"       #2
        SQL+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,"            #3
        SQL+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto," #4
        SQL+="cecha1_opis,cecha1_wartosc,kod_gtu)"  #MK 2020-03-23
        
        PolaCechy="a.cecha1_opis,dmp.cecha1_wartosc"
        OrderByCechy="a.cecha1_opis,dmp.cecha1_wartosc"
        if RozbijacCecha:
            PolaCechy="dmp.cecha1_opis,dmp.cecha1_wartosc" 
            OrderByCechy="dmp.cecha1_opis,dmp.cecha1_wartosc" 
            
        if SklejacPoz:
            SQL+="SELECT dmp.firma_id,'"+WyznF+"','"+DataF+"',"+NumerF+","+str(NrP)+"+rsf_podaj_numer_wiersza(),0,"               #1
            SQL+="dmp.artykul_id,SUM(dmp.ilosc1),SUM(dmp.ilosc2),"+CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+",0,0,"       #2
            SQL+="0,0,a.stawka_vat,0,0,0,'',NULL,"                #3
            SQL+=CenaNW1+","+CenaNW2+","+CenaUW1+","+CenaUW2+",0,0,0,"+PolaCechy+",a.kod_gtu" #4
        elif Sklejac:
            SQL+="SELECT dmp.firma_id,'"+WyznF+"','"+DataF+"',"+NumerF+","+str(NrP)+"+dmp.nr_poz,0,"               #1
            SQL+="dmp.artykul_id,SUM(dmp.ilosc1),SUM(dmp.ilosc2),"+CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+",0,0,"       #2
            SQL+="0,0,a.stawka_vat,0,0,0,'',NULL,"                #3
            SQL+=CenaNW1+","+CenaNW2+","+CenaUW1+","+CenaUW2+",0,0,0,"+PolaCechy+",a.kod_gtu" #4
        else:
            SQL+="SELECT dmp.firma_id,'"+WyznF+"','"+DataF+"',"+NumerF+","+str(NrP)+"+dmp.nr_poz,dmp.nr_ppoz,"               #1
            SQL+="dmp.artykul_id,dmp.ilosc1,dmp.ilosc2,"+CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+",0,0,"                  #2
            SQL+="0,0,a.stawka_vat,0,0,0,dmp.nr_serii,dmp.termin_przyd,"                #3
            SQL+=CenaNW1+","+CenaNW2+","+CenaUW1+","+CenaUW2+",0,0,0,dmp.cecha1_opis,dmp.cecha1_wartosc,a.kod_gtu" #4 #MK 2020-03-23
        
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE "+FiltrM
        if SklejacPoz:
            SQL+=" GROUP BY dmp.firma_id,dmp.artykul_id,a.stawka_vat,a.kod_gtu,"+OrderByCechy  #MK 2020-03-31
        elif Sklejac:
            SQL+=" GROUP BY dmp.firma_id,dmp.nr_poz,dmp.artykul_id,a.stawka_vat,a.kod_gtu,"+OrderByCechy #MK 2020-03-31
        if BlokadaCen and (Sklejac or SklejacPoz):
            SQL+=","+CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+","+CenaNW1+","+CenaNW2+","+CenaUW1+","+CenaUW2
            
        if SklejacPoz:
            SQL+=" ORDER BY dmp.artykul_id,"+OrderByCechy
        elif Sklejac:
            SQL+=" ORDER BY dmp.nr_poz,dmp.artykul_id,"+OrderByCechy
        else:
            SQL+=" ORDER BY dmp.nr_poz,dmp.nr_ppoz"
        SQL+=";"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,1, CzyDodawacBlad=True)    
        
        if SklejacPoz:
            #poprawienie numerow pozycji ktore sie skleily
            Poprawiac=True
            while Poprawiac:
                Poprawiac=False
                stat,dane,dump,dump=self.PolSQL.Execute("SELECT DISTINCT nr_poz FROM rs_faktury_pozycje WHERE "+FiltrF+" ORDER BY nr_poz;",3, CzyDodawacBlad=True)
                licznik=1
                for d in dane:
                    if not Poprawiac:
                        if licznik!= d[0]:
                            Poprawiac=True
                            stat,dump,dump,dump=self.PolSQL.Execute("UPDATE rs_faktury_pozycje SET nr_poz=nr_poz-1 WHERE "+FiltrF+" AND nr_poz>"+str(licznik)+";",1, CzyDodawacBlad=True)
                        licznik=licznik+1    
       
#pobranie cen na faktur
if stat=='OK' and Dodawac:
    stat=fs_global_faktury.PobierzCenyDoPozycji(self,self.firma_id,WyznF,DataF,NumerF,NrP)

#poczenie faktury i dokumentu.
if stat=='OK':
    sql="UPDATE rs_dokumenty_magazynowe SET f_wyznacznik_id='"+WyznF+"',f_data='"+DataF+"',f_numer='"+NumerF+"' WHERE "+FiltrM+";"
    stat,dump,dump,dump=self.PolSQL.Execute(sql,1, CzyDodawacBlad=True)
    
# uzupenienie dat dostaw i daty przychodu na fakturze
if stat=='OK':
    sql="SELECT rsf_przelicz_daty_przychodu_na_fakturze('"+self.firma_id+"','"+WyznF+"','"+DataF+"',"+NumerF+");"
    stat,DaneF,dump,dump=self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
    if stat =='OK':
        if DaneF[0][0] != 'OK':
            stat = DaneF[0][0]