#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_faktury.py
# Purpose:          dodaje/pobiera/usuwa faktury
# Author:           Jakub Krajniak, Micha Raburski (poprawki)
# Created:          2006/10/22
# Edited:           2008/05/28
# RCS-ID:           $Id: fs_faktury.py $
# Copyright:        (c) 2004-2009 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#2008-04-24 - zmiana funkcji tak by obsugiwana by problem z  sekwencj w zalegociach
#2010-01-03 - tworzenie WZ-ki z faktury - mariusz rajfura  mantis: 3027
#2010-12-01 - Zmiana stanu po zamykaniu grupowym - Marcin  Natkaski , mantis: 4109
#2011-04-20 - tworz.zaleglosci w zalez.od danych do fakturowania  Mariusz Rajfura (4513)
#2011-05-12 - kontrola tworzenia wz-ki z param.dla wz w podanym magazynie Mariusz Rajfura (4578)
#2011-09-28 - zmiana komunikatu dla proby zamykania faktury bez pozycji Mariusz Rajfura (5049)
#2011-11-09 - uszczelnienie blokady Mariusz Rajfura (5077)
#2011-11-24 - uszczelnienie blokady Mariusz Rajfura (5078) (zamykanie: dostosowanie do 5075)
# 2017-08-22 Piotr Witkowski    - (10679) Sprawdzi czy wpisanie daty_do w projektach blokuje mozliwosc wprowadzania
# 2017-10-31 Rafa Woniak      - (10734) zmiana zapisu do logw z 1 na 5
# 2019-08-01 Aleksander Bargie - (11568) Obsuga split payment w fakturach
# 2019-10-15 Aleksander Bargie - (11681) Zmiany w zamykaniu faktur i korekt ze wzgldu na mpp
# 2020-04-17 Wojciech Skowron   - (11931) Przy zamykaniu (W->G) sprawdzenie, czy artyku na pozycji nie jest tylko_detal
# 2020-10-29 Mikoaj Kozowski  - (12024) Dodane sprawdzanie naruszalnoci kluczy obcych podczas usuwania
# 2021-01-07 Aleksander Bargie - (12245) Bdy usuwania wspolnej faktury dla oddzialow z dd
# 2021-01-18 Aleksander Bargie - (12275) Serwal 'znikajce' dd z faktur.
# 2021-01-29 Aleksander Bargie - (12303) Usuwanie faktur z dd - likwidowa powizania z DD w stanie 3 i 4
# 2021-02-08 Aleksander Bargie - (12313) [SP] Automat KP przy wystawianiu faktur.
# 2021-12-14 Aleksander Bargie - (12766) Zmiany w zamykaniu paragonw i faktur
# 2022-02-17 Aleksander Bargie - (12889) Usuwanie faktur w Serwalu
# 2022-03-30 Wojciech Skowron   - (12854) Przekazanie oddziau do ZapiszDoRaportu()

#klucze:
# 0: Wyznacznik_id
# 1: Data_od
# 2: Data_do
# 3: Platnik_id
# 4: Kontrahent_id
# 5: Stan

import time
from funkcje import fs_zaleglosci_sprawdzenie
from funkcje import fs_magazyny_parametry_dokumentow_pom
from funkcje import fs_okresy_pom
from funkcje import fs_raporty_wyciagi_pom

Wyzn=rsglobal.Dekoduj(klucze[0])
Data=rsglobal.Dekoduj(klucze[1])
Numer=str(klucze[2])
WyznF=rsglobal.Dekoduj(klucze[3])
DataOdF=rsglobal.Dekoduj(klucze[4])
DataDoF=rsglobal.Dekoduj(klucze[5])
PlatF=rsglobal.Dekoduj(klucze[6])
KontrF=rsglobal.Dekoduj(klucze[7])
StanF=rsglobal.Dekoduj(klucze[8])
NiewyslaneF=rsglobal.Dekoduj(klucze[9])
klucze_id=klucze[10]
Fun=klucze[-1]
stat = "OK"
dane = []
wyn1=[]
wyn2=[]

# dla komser
def dolozDodatkoweDane(dodatkoweDane, nazwa, row, desc):
    nowe = []
    for d, info in zip(row, desc):
        if d == "None":
            d = None
        if info[0] not in ("z_czas", "z_typ", "z_op_id"):
            nowe.append((info[0], d))
    dodatkoweDane.append((nazwa.upper(), nowe))

komserDane = None


if DataOdF <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdF):
        stat='BL DATAOD'

if DataDoF <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoF):
        stat='BL DATADO'

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

#pobranie uprawnien
UprTworzDokMag = ((self.oddzial_id,'032013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#pobranie uprawnie do wyznacznikw dla operatora
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrz=True
        UprEdy=True
        UprDel=True
        UprZam=True
        UprOtw=True
        LPrz=LWyzn
        LEdy=LWyzn
        LDel=LWyzn
        LZam=LWyzn
        LOtw=LWyzn
        LPrz.append('ZASLEPKA')
    else:
        UprPrz=(self.oddzial_id,'022010') in self.uprawnienia
        UprEdy=((self.oddzial_id,'022012') in self.uprawnienia or (self.oddzial_id,'022013') in self.uprawnienia)
        UprDel=(self.oddzial_id,'022014') in self.uprawnienia
        UprZam=(self.oddzial_id,'022016') in self.uprawnienia
        UprOtw=(self.oddzial_id,'022017') in self.uprawnienia
        
        LPrz=LWyzn
        LPrz.append('ZASLEPKA')
        LEdy=[]
        LDel=[]
        LZam=[]
        LOtw=[]

        if UprEdy and (Fun in [7,8,9]):
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]
        
        if stat=='OK':
            if UprDel and (Fun in [6]):
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LDel=rsglobal.rseval(wyzn[0][0])[1]
        
        if stat=='OK':
            if UprZam and (Fun in [7,9]):
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,False,True,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LZam=rsglobal.rseval(wyzn[0][0])[1]
        
        if stat=='OK':
            if UprOtw and (Fun in [8]):
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,False,False,True]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LOtw=rsglobal.rseval(wyzn[0][0])[1]
        
#pobranie stanu faktury (wyczone, gdy funkcja ==11)
Stan=''
if stat=='OK' and Fun <> 11:
    if Wyzn <> '':
        Select ="SELECT stan FROM rs_faktury"
        Select+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
        Select+=" AND data='"+Data+"' AND numer="+Numer
        if Fun in (6,):
            # blokada przed delete
            Select+=" FOR UPDATE NOWAIT"
        Select+=";"

        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Faktura zablokowana przez innego operatora. Operacja niemoliwa.'
            dane.append(stat)
        elif len(d)==0:
            stat='BR FAKT'
            dane.append(stat)
        else:
            Stan=rsglobal.Dekoduj(d[0][0])

#-------------------------------------------------------------------------------
# -- Usuwanie 6 
#-------------------------------------------------------------------------------

if Fun in [6] and stat=='OK':
    if not ((UprDel and (Wyzn in LDel)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="UPR DEL"   
        dane.append(stat)
        
    if stat=='OK':    
        if Stan <> 'W':
            stat = "BL STAN"
            dane.append(stat)
        
    if stat=='OK':    
        Select= "SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\""+Wyzn+"\",\""+Data+"\","+Numer+"]','F')"
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
    if stat=='OK':
        if d[0][0]<>'OK':
            stat='NUM NOT LAST'
            dane.append(stat)

    #AB 29.01.21r czy_zbiorcza po nowemu, else po staremu
    if stat == 'OK':
        stat, czy_zbiorcza, dump, dump = self.PolSQL.Execute("SELECT czy_zbiorcza_dla_oddzialow FROM rs_firmy rf WHERE firma_id ='{}';".format(self.firma_id), 7)
        if stat != 'OK':  #AB 17.02.22r
            stat = u"Bd spradzania konfiguracji tworzenia faktur z dowodw dostaw: " + stat
        elif czy_zbiorcza is None:
            stat = u"Bd spradzania konfiguracji tworzenia faktur z dowodw dostaw."

    if stat=='OK':
        if czy_zbiorcza:
            #Wyczyszczenie na dokumentach magazynowych informacji, e faktura zostaa z nich pobrana
            Upd="UPDATE rs_dokumenty_magazynowe SET f_wyznacznik_id=NULL,f_data=NULL,f_numer=NULL WHERE firma_id='"+self.firma_id+"' AND f_wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' AND f_numer="+Numer+";"

            #wyczyszczenie danych w dowodach dostaw     #AB 19.01.21 dodanie pobierania oddzialu
            Sel="SELECT trasa, data, tryb_dostawy, numer, oddzial_id FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND f_wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' AND f_numer="+Numer+" AND stan='4';"
            # Sel="SELECT trasa, data, tryb_dostawy, numer FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'AND f_wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' AND f_numer="+Numer+";"
            stat,danepom,dump,dump=self.PolSQL.Execute(Sel,3)
            rsglobal.ZapiszDoLogow(Sel)
            rsglobal.ZapiszDoLogow(danepom)

            #Wyczyszczenie na paragonach informacji, e faktura zostaa z nich pobrana
            Upd+="UPDATE rs_paragony_fiskalne SET wyznacznik_id=NULL,f_data=NULL,f_numer=NULL WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' AND f_numer="+Numer+";"
            if stat=='OK':
                UpdD=''
                for d in danepom:                       #AB 19.01.21 zmiana oddzialu na pobrany w danepom
                    # Filtr=" firma_id='"+self.firma_id+"' AND trasa='"+rsglobal.Dekoduj(d[0])+"' AND data='"+rsglobal.Dekoduj(d[1])+"' AND tryb_dostawy='"+rsglobal.Dekoduj(d[2])+"' AND numer="+str(d[3])
                    Filtr=" firma_id='"+self.firma_id+"' AND oddzial_id='"+rsglobal.Dekoduj(d[4])+"' AND trasa='"+rsglobal.Dekoduj(d[0])+"' AND data='"+rsglobal.Dekoduj(d[1])+"' AND tryb_dostawy='"+rsglobal.Dekoduj(d[2])+"' AND numer="+str(d[3])

                    UpdD+="UPDATE rs_dowody_dostaw SET stan=2, f_wyznacznik_id=NULL, f_data=NULL,f_numer=NULL "
                    UpdD+="WHERE "+Filtr+";"

                    UpdD+="UPDATE rs_dowody_dostaw_pozycje SET ilosc_rozl1=ilosc_rozl1-ilosc_rozl_f1,ilosc_rozl2=ilosc_rozl2-ilosc_rozl_f2,"
                    UpdD+="ilosc_rozl_f1=0,ilosc_rozl_f2=0 WHERE "+Filtr+" AND ilosc_rozl_f1>0;"
                rsglobal.ZapiszDoLogow(UpdD)

                Filtr = " firma_id = '" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "' AND data = '" + Data + "' AND numer = " + Numer
                delete="DELETE FROM rs_faktury_pozycje_opisowe WHERE "+Filtr+";"
                delete+="DELETE FROM rs_faktury_pozycje WHERE "+Filtr+";"
                delete+="DELETE FROM rs_faktury WHERE "+Filtr+";"
                stat,dump,dump,dump=self.PolSQL.Execute(Upd+UpdD+delete,1, CzyDodawacBlad=True)
                if stat != 'OK':
                    if "NARUSZA KLUCZ OBCY" in stat.upper() or "FOREIGN KEY" in stat.upper():                           #MK 2020-10-29
                        stat = 'Nie mona usun faktury, poniewa moe wystpowa jej powizanie z innymi tabelami.'
                    stat="BL DEL$" + stat
                    dane.append(stat)
        else:

            # Wyczyszczenie na dokumentach magazynowych informacji, e faktura zostaa z nich pobrana
            Upd = "UPDATE rs_dokumenty_magazynowe SET f_wyznacznik_id=NULL,f_data=NULL,f_numer=NULL WHERE firma_id='" + self.firma_id + "' AND f_wyznacznik_id='" + Wyzn + "' AND f_data='" + Data + "' AND f_numer=" + Numer + ";"

            # wyczyszczenie danych w dowodach dostaw
            Sel = "SELECT trasa, data, tryb_dostawy, numer FROM rs_dowody_dostaw WHERE firma_id='" + self.firma_id + "' AND oddzial_id='" + self.oddzial_id + "'AND f_wyznacznik_id='" + Wyzn + "' AND f_data='" + Data + "' AND f_numer=" + Numer + ";"
            stat, danepom, dump, dump = self.PolSQL.Execute(Sel, 3)

            # Wyczyszczenie na paragonach informacji, e faktura zostaa z nich pobrana
            Upd += "UPDATE rs_paragony_fiskalne SET wyznacznik_id=NULL,f_data=NULL,f_numer=NULL WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + Wyzn + "' AND f_data='" + Data + "' AND f_numer=" + Numer + ";"
            if stat == 'OK':
                UpdD = ''
                for d in danepom:
                    Filtr = " firma_id='" + self.firma_id + "' AND oddzial_id='" + self.oddzial_id + "' AND trasa='" + rsglobal.Dekoduj(
                            d[0]) + "' AND data='" + rsglobal.Dekoduj(d[1]) + "' AND tryb_dostawy='" + rsglobal.Dekoduj(
                            d[2]) + "' AND numer=" + str(d[3])

                    UpdD += "UPDATE rs_dowody_dostaw SET stan=2, f_wyznacznik_id=NULL, f_data=NULL,f_numer=NULL "
                    UpdD += "WHERE " + Filtr + ";"

                    UpdD += "UPDATE rs_dowody_dostaw_pozycje SET ilosc_rozl1=ilosc_rozl1-ilosc_rozl_f1,ilosc_rozl2=ilosc_rozl2-ilosc_rozl_f2,"
                    UpdD += "ilosc_rozl_f1=0,ilosc_rozl_f2=0 WHERE " + Filtr + " AND ilosc_rozl_f1>0;"

                Filtr = " firma_id = '" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "' AND data = '" + Data + "' AND numer = " + Numer
                delete = "DELETE FROM rs_faktury_pozycje_opisowe WHERE " + Filtr + ";"
                delete += "DELETE FROM rs_faktury_pozycje WHERE " + Filtr + ";"
                delete += "DELETE FROM rs_faktury WHERE " + Filtr + ";"
                stat, dump, dump, dump = self.PolSQL.Execute(Upd + UpdD + delete, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    if "NARUSZA KLUCZ OBCY" in stat.upper() or "FOREIGN KEY" in stat.upper():  # MK 2020-10-29
                        stat = 'Nie mona usun faktury, poniewa moe wystpowa jej powizanie z innymi tabelami.'
                    stat = "BL DEL$" + stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
# Sprawdzenie limitu (17)
#-------------------------------------------------------------------------------

if Fun == 17 and Stan == 'W' and stat == 'OK':
    sql ="SELECT kontrahent_id, do_zaplaty FROM rs_faktury"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
    sql+=" AND data='"+Data+"' AND numer="+Numer+";"

    stat,dn,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia danych faktury: '+stat
    elif len(dn)==0:
        stat="BR FAKTZ"
        dane.append(stat)

    if stat == 'OK':
        #sprawdzenie kontrahenta
        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND kontrahent_id = '"+str(dn[0][0])+"' AND aktywny;"
        stat,k,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(k) <> 1:
                dane.append(u"Nieaktywny kontrahent '"+str(dn[0][0]).strip()+u"' na fakturze")
        else:
            dane.append("BL SPR KONTR")
            
    if stat == 'OK':
        #porownanie stanu zaleglosci z limitem
        stat = fs_zaleglosci_sprawdzenie.SprawdzLimitKontrahenta(self,dn[0][0],dn[0][1],Data)
        if stat == 'LIMIT':
            #podmieniam stat, bo osiagniecie limitu nie blokuje operacj
            stat = 'OK'
            dane.append(["Odbiorca '"+str(dn[0][0]).strip()+"' wykorzysta limit."])


#-------------------------------------------------------------------------------
# -- Pobranie najniszej daty na gridzie (15)
#-------------------------------------------------------------------------------

if Fun==15 and stat=='OK':
    sqlData  ="SELECT data from rs_faktury WHERE data>='"+DataOdF+"' AND data<='"+DataDoF+"'"
    sqlData +=" ORDER BY data DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sqlData,3) 
    if stat<>'OK':
        stat='Bdy pobierania najwyszej daty: ', stat
    elif len(dane)==0:
        stat='Nie mona kopiowa faktur bez wypenionych datami fitrw'
         

#-------------------------------------------------------------------------------
# -- Zamykanie (22 - sprawdzenie czy stawki VAT s ok)
#-------------------------------------------------------------------------------

if Fun in [22,] and stat=='OK':
    SQL = "SELECT COALESCE(data_przychodu,data) FROM rs_faktury"
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
    SQL+= " AND data='"+Data+"' AND numer="+Numer

    stat,DData,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK' and len(DData)>0:
        DataSprzedazy = rsglobal.Dekoduj(DData[0][0])
    
        SQL ="SELECT fp.stawka_vat,fp.nr_poz FROM rs_faktury_pozycje fp "
        SQL+=" LEFT OUTER JOIN rs_stawki_vat_okresy st ON (st.stawka_vat=fp.stawka_vat "
        SQL+=" AND '"+DataSprzedazy+"'>=st.od_dnia"
        SQL+=" AND CASE WHEN do_dnia IS NULL THEN TRUE ELSE '"+DataSprzedazy+"'<=do_dnia END) "
        SQL+= " WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"'"
        SQL+= " AND fp.data='"+Data+"' AND fp.numer="+Numer+ " AND st.stawka_vat IS NULL" 
        SQL+=" ORDER BY fp.stawka_vat, fp.nr_poz;"

        stat,DStawek,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(DStawek)>0:
                SStaw={}
                for poz in DStawek:
                    if not poz[0] in SStaw:
                        SStaw[poz[0]]=[poz[1]]
                    else:
                        SStaw[poz[0]]=SStaw[poz[0]].append([poz[1]])
                    
                stat=" Uwaga! Na dzie sprzeday "+DataSprzedazy+ " nie obowizuj stawki VAT :"
                for stawka in SStaw:
                    stat+=stawka+" ( poz. "+str(SStaw[stawka])[1:-1]+"), "
                stat=stat.strip(',')
                stat+=" Czy kontynuowa?"
            

#-------------------------------------------------------------------------------
# Pobranie biezacego stanu faktury (23)
#-------------------------------------------------------------------------------

if Fun in [23,] and stat=='OK':
    dane = []
    dane.append(Stan)
    
        
#-------------------------------------------------------------------------------
# -- Zamykanie (7 - z pobieraniem, 9 - bez pobierania)
#-------------------------------------------------------------------------------

if Fun in [7,9] and stat=='OK':
    if not ((UprZam and (Wyzn in LZam)) or (UprEdy and Stan=='W' and (Wyzn in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        if Stan=='W':
            stat="UPR PRZYG"
        else:
            stat="UPR ZAM"
        dane.append(stat)
            
    NastStan='D'    
    ZmianaZaliczki=''
    if stat=='OK':
        if Stan == 'W':
            NastStan='G'
        if Stan == 'G':
            NastStan='Z'
        elif Stan in ('Z','K'):
            stat ='BL STANZK'
            dane.append(stat)
    
    if stat=='OK':        
        if Stan in ('W','G'):
            sql ="SELECT kontrahent_id IS NULL or kontrahent_id='' ,wyznacznik_id IS NULL or wyznacznik_id='',"
            sql+=" zamawiajacy_id IS NULL or zamawiajacy_id='',platnik_id IS NULL or platnik_id='',"
            sql+=" waluta IS NULL or waluta='',sposob_zaplaty IS NULL or sposob_zaplaty='' ,"
            sql+=" projekt_id IS NULL or projekt_id='', kwota_netto<0,"
            sql+=" kontrahent_id, zamawiajacy_id, platnik_id, miejsce_dostawy_id"
            sql+=" FROM rs_faktury"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"'"
            sql+=" AND numer="+Numer+" FOR UPDATE NOWAIT;"
            
            stat,dn,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Faktura jest edytowana przez kogo innego i nie mona zmienia jej stanu'
            rsglobal.ZapiszDoLogow('!!!1 '+str(dn),5)
            if stat=='OK':
                if len(dn)==0:
                    stat="BR FAKTZ"
                    dane.append(stat)
                    
            # sprawdzenie typu faktury - czy zaliczkowa (jeli tak to moe mie ona jedn pozycj zwyk i koniec)
            if stat=='OK':
                Zaliczkowa=False
                SQL="SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';"
                stat,DWyzn,dump,dump = self.PolSQL.Execute(SQL,3)                
                if stat<>'OK':
                    stat='Bd pobierania danych wyznacznika : '+stat
                    dane.append(stat)
                else:
                    Zaliczkowa=(DWyzn[0][0]=='FZ')
        
            if stat=="OK":
                #WS 2020-04-17 - JOIN na rs_artykuly i pobranie tylko_detal
                SQL = "SELECT fp.wartosc_netto, fp.artykul_id, fp.ilosc1, fp.nr_poz, fp.nr_ppoz, "  # 0-4
                SQL += " rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb(firma_id,'"+dn[0][8].strip()+"',artykul_id,data), "  # 5
                SQL += " a.tylko_detal"  # 6
                SQL += " FROM rs_faktury_pozycje fp JOIN rs_artykuly a USING (firma_id, artykul_id)"
                SQL += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                SQL += " AND data='"+Data+"' AND numer="+Numer
                # SQL = "SELECT wartosc_netto,artykul_id,ilosc1,nr_poz,nr_ppoz, " \
                #       " rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb(firma_id,'"+dn[0][8].strip()+"',artykul_id,data)" \
                #       " FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'" \
                #       " AND data='"+Data+"' AND numer="+Numer
                stat,dp,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':                
                stat,do,dump,dump = self.PolSQL.Execute("SELECT wartosc_netto FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer,3)
                rsglobal.ZapiszDoLogow('!!!2 '+str(dp),5)
            if stat=='OK':
                if Zaliczkowa:
                    if len(dp)<>1 or len(do)>0:
                        stat="Na fakturze zaliczkowej moe by tylko jedna pozycja zwyka i adnej opisowej."
                        dane.append(stat)
                    # sprawdzenie czy artyku ma ilosc=1 i przelicznik=1
                    if stat=='OK':
                        if dp[0][2]<>1:
                            stat="Na pozycji faktury zaliczkowej moe by tylko ilo rwna 1."
                            dane.append(stat)
                    
                    if stat=='OK':
                        SQL="SELECT przelicznik FROM rs_artykuly "
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+rsglobal.Dekoduj(dp[0][1])+"';"
                        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat="Bd sprawdzania przelicznika artykuu :"+stat
                            dane.append(stat)
                        elif DArt[0][0]<>1:
                            stat="Przelicznik artykuu na fakturze zaliczkowej musi by rwny 1"
                            dane.append(stat)

                    if stat=='OK':
                        # dodatkowa edycja pola 
                        ZmianaZaliczki=",zaliczka_pozostalo=do_zaplaty "

            if stat=='OK':
                if len(dp)+len(do)==0:
                    stat="BR POZ NA FAKT"
                    dane.append(stat)
            rsglobal.ZapiszDoLogow('!!!3 ',5)
            if stat=='OK':
                # sprawdzenie zerowych wartoci. Zerowa warto w pozycji rozbitej na zestaw jest dopuszczalna
                LZerowych = []
                for poz in dp:
                    if stat =='OK':
                        if poz[0]==0:
                            if poz[4] == 0:
                                LZerowych.append(poz[3])
                            else:
                                dane.append("ZER POZ")
                            
                        else:
                            if poz[3] in LZerowych:
                                LZerowych.remove(poz[3])

                    # sprawdzenie czy pozycja nie powinna by odrzucona ze wzgldu na brak uprawnie w grupach odbiorcw - asortyment
                    if stat=='OK':
                        if poz[5] <> 'OK':
                            dane.append('Poz '+rsglobal.UsunKropkaZero(poz[3])+'/ '+rsglobal.UsunKropkaZero(poz[4])+' : '+poz[5])

                    #WS 2020-04-17
                    # sprawdzenie, czy artyku nie ma zaznaczonego tylko_detal
                    if stat == 'OK':
                        if Stan == 'W' and poz[6]:
                            dane.append("BL ART TYLKO_DETAL$" +
                                        rsglobal.UsunKropkaZero(poz[3])+'/ '+rsglobal.UsunKropkaZero(poz[4]))

                if stat =='OK':
                    if len(LZerowych) > 0:
                        dane.append("ZER POZ")

            if stat=="OK":
                if dn[0][0]:
                    dane.append("BR KONTR")
    
            if stat=="OK":
                if dn[0][1]:
                    dane.append("BR WYZN")
            
            if stat=="OK":
                if dn[0][2]:
                    dane.append("BR ZAMAW")

            if stat=="OK":
                if dn[0][3]:
                    dane.append("BR PLATNIK")
    
            if stat=="OK":
                if dn[0][4]:
                    dane.append("BR WALUTA")
    
            if stat=="OK":
                if dn[0][5]:
                    dane.append("BR SPOSZAPL")
    
            if stat=="OK":
                if dn[0][6]:
                    dane.append("BR PROJ")
        
            if stat=="OK":
                if dn[0][7]:
                    dane.append("BL KWOTA")
            
            #jesli do tego miejsca nie bylo bledow, sprawdzamy aktywnosc
            if len(dane) == 0 and stat == 'OK':
                if Stan == 'W':  # sprawdzenie projektu PW 2017-08-22
                    SQL = "SELECT projekt_id FROM rs_faktury WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + str(Wyzn) + "' "
                    SQL += "AND data='" + str(Data) + "' AND numer=" + str(Numer) + ";"
                    stat, dd, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat <> 'OK':
                        stat = u'Bdy przy pobraniu projektu z faktury:' + stat
                    elif stat == 'OK' and len(dd) > 0:
                        SQL = "SELECT data_do>='" + str(Data) + "' FROM rs_projekty WHERE firma_id='" + self.firma_id + "' "
                        SQL += "AND projekt_id='"+dd[0][0]+"' and data_do is not null;"
                        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat <> 'OK':
                            dane.append(u'Bdy przy sprawdzaniu daty projektu :' + stat)
                        else:
                            if len(d) == 1 and d[0][0] == False:
                                dane.append("BL PROJ")

                #kontrahent_id
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+str(dn[0][8])+"' AND aktywny;"
                stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if len(k) <> 1:
                        dane.append(u"Nieaktywny kontrahent '"+str(dn[0][8]).strip()+u"' na fakturze")
                else:
                    dane.append("BL SPR KONTR")
                
                #zamawiajacy_id
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+str(dn[0][9])+"' AND aktywny;"
                stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if len(k) <> 1:
                        dane.append(u"Nieaktywny zamawiajcy '"+str(dn[0][9]).strip()+u"' na fakturze")
                else:
                    dane.append("BL SPR KONTR")

                #platnik_id
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+str(dn[0][10])+"' AND aktywny;"
                stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if len(k) <> 1:
                        dane.append(u"Nieaktywny patnik '"+str(dn[0][10]).strip()+u"' na fakturze")
                else:
                    dane.append("BL SPR KONTR")

                #miejsce_dostawy_id
                if str(dn[0][11]) <> 'None':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+str(dn[0][11])+"' AND aktywny;"
                    stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat == 'OK':
                        if len(k) <> 1:
                            dane.append("BL MIEJDOST NAKT")
                    else:
                        dane.append("BL SPR KONTR")

            #jesli byly jakies bledy
            if len(dane) > 0:
                stat = dane[0]

    TworzycZaleglosc = True
    if stat == 'OK' and NastStan == 'Z':
        sql ="SELECT kontrahent_id, platnik_id, COALESCE(s.tworzyc_kp, FALSE) as tworzyc_kp, do_zaplaty, oddzial_id "  #AB 08.02.21r
        sql+=" FROM rs_faktury f"
        sql+=" LEFT JOIN rs_sposoby_zaplaty s ON (f.firma_id, f.sposob_zaplaty) = (s.firma_id, s.kod) "  #AB 08.02.21r
        sql+=" WHERE f.firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
        sql+=" AND data='"+Data+"' AND numer="+Numer+";"
        
        stat,dNagl,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z nagwka faktury: '+stat
            dane.append(stat)
        elif len(dNagl) == 0:
            stat = 'Brak faktury o podanym kluczu.'
            dane.append(stat)
        
        if stat == 'OK':
            # pobranie danych platnika 
            sql ="SELECT tworzyc_zaleglosc FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(dNagl[0][1])+"'"
            sql+=" AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1;"
            
            stat,dTworz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia danych patnika: '+stat
                dane.append(stat)
            elif len(dTworz) == 0 and dNagl[0][1] <> dNagl[0][0]:
                # dla platnika nie bylo danych ale jest inny kontrahent
                sql ="SELECT tworzyc_zaleglosc FROM rs_kontrahenci_fakturowanie"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(dNagl[0][0])+"'"
                sql+=" AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1;"
            
                stat,dTworz,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych kontrahenta: '+stat
                    dane.append(stat)
                
        if stat == 'OK' and len(dTworz) == 1:
            TworzycZaleglosc = dTworz[0][0]
        #AB 08.02.21r
        if stat == 'OK' and dNagl[0][2]:  # SPOSOB ZAPLATY FAKTURY WYMAGA UTWORZENIA KP(kasa przyjela, pozycja na wyciagu)
            # ------------------------------------------
            # -- TWORZENIE  WYCIGU BANKOWEGO
            # ------------------------------------------
            #AB 14.12.21r przejcie na uycie pom'w

            # sprawdzenie okresu faktury
            Okres = ''
            KasaBank = ''
            # KontoKB = ''
            DowodKB = ''
            # NazwaDowoduKB = ''
            SQLZam = ''
            KwotaPar = '0'
            NrWyc = '1'
            NrPozWyc = '1'
            Saldo = '0'
            TworzycWyc = True
            Oddzial = dNagl[0][4]
            KwotaPar = str(dNagl[0][3])
            if KwotaPar != '0':
                #WS 2022-03-30 - przekazanie oddzial_id
                stat = fs_raporty_wyciagi_pom.ZapiszDoRaportu(self, Data, 'FA', {'platnik_id': rsglobal.Dekoduj(dNagl[0][1]),
                                                                                 'oddzial_id': Oddzial,
                                                                                 'wyznacznik_id': Wyzn,
                                                                                 'numer': Numer,
                                                                                 'kwota': KwotaPar})

            # PodajOkresDlaDaty

            # SQL = "SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='" + self.firma_id + "' "
            # SQL += " AND data_od<='" + Data + "' AND data_do >='" + Data + "'"
            # stat, DaneOkr, dump, dump = self.PolSQL.Execute(SQL, 3)
            # rsglobal.ZapiszDoLogow("SQL: {}".format(SQL))
            # rsglobal.ZapiszDoLogow("Dane: {}".format(DaneOkr))
            #
            # if stat == 'OK':
            #     if len(DaneOkr) == 1:
            #         Okres = rsglobal.Dekoduj(DaneOkr[0][0])

            # PodajOkresDlaDaty

            # stat, Okres = fs_okresy_pom.PodajOkresDlaDaty(self, Data)

            # PodajSymbolKasy

            # if stat == 'OK' and Okres <> '':
            #     # --- jeli jest tylko 1 kasa_bank to tworzy wycig bankowy
            #     SQL = "SELECT kasa_bank_id,konto, dowod_id, nazwa_id FROM rs_kasy_banki WHERE firma_id='" + self.firma_id + "' AND okres_id='" + Okres + "'"
            #     stat, DaneKB, dump, dump = self.PolSQL.Execute(SQL, 3)
            #     rsglobal.ZapiszDoLogow("SQL: {}".format(SQL))
            #     rsglobal.ZapiszDoLogow("Dane: {}".format(DaneKB))
            #
            #     if stat == 'OK':
            #         if len(DaneKB) == 1:
            #             KasaBank      = rsglobal.Dekoduj(DaneKB[0][0])
            #             DowodKB       = rsglobal.Dekoduj(DaneKB[0][2])

            # PodajSymbolKasy

            # if stat == 'OK' and Okres != '':
            #     stat, dane_kasy = fs_raporty_wyciagi_pom.PodajDomyslnaKase(self, Okres)
            #     if stat == 'OK':
            #         if dane_kasy is None:
            #             KasaBank = ''
            #             DowodKB  = ''
            #         else:
            #             KasaBank = dane_kasy['kasa_bank_id']
            #             DowodKB  = dane_kasy['dowod_id']

            # PodajUtworzRaportKasowy

            # if stat == 'OK' and KasaBank <> '':
            #     # --- mamy okres, i kas i moemy tworzy wycig.
            #     # --- najpierw sprawdzamy czy nie istnieje ju otwarty wycig.
            #     # --- Jeli tak - pobieramy klucz - jeli nie - wstawiamy nowy dokument
            #     SQL = "SELECT stan,numer FROM rs_raporty_wyciagi WHERE firma_id='" + self.firma_id + "' "
            #     SQL += "AND okres_id='" + Okres + "' AND kasa_bank_id='" + KasaBank + "' AND data='" + Data + "' "
            #     SQL += "ORDER BY numer DESC LIMIT 1"
            #
            #     stat, DaneWyc, dump, dump = self.PolSQL.Execute(SQL, 3)
            #     rsglobal.ZapiszDoLogow("SQL: {}".format(SQL))
            #     rsglobal.ZapiszDoLogow("Dane: {}".format(DaneWyc))
            #
            #     if stat == 'OK':
            #         if len(DaneWyc) == 1:
            #             # jest wycig - sprawdzamy stan
            #             if DaneWyc[0][0] == 'W':
            #                 NrWyc = str(DaneWyc[0][1])
            #                 TworzycWyc = False
            #             else:
            #                 from funkcje import fs_raporty_wyciagi_pom
            #
            #                 stat, NrWyc = fs_raporty_wyciagi_pom.PodajNumerRaportu(self, KasaBank, Data)
            #                 NrWyc = str(NrWyc)
            #                 if NrWyc == '0':
            #                     stat = 'Uwaga! Przyznano 0 jako nowy numer raportu/wycigu dla kasy ' + KasaBank
            #                     stat += "\nSprawd czy w kasie jest wisany sposb numeracji raportw"
            #
            # if stat == 'OK' and KasaBank <> '' and TworzycWyc:
            #     SQLSaldo = "SELECT saldo_konc FROM rs_raporty_wyciagi WHERE firma_id='" + self.firma_id + "' "
            #     SQLSaldo += "AND okres_id='" + Okres + "' AND kasa_bank_id='" + KasaBank + "' AND (data<'" + Data + "' OR (data='" + Data + "' AND numer<" + NrWyc + ")) ORDER BY data desc, numer desc LIMIT 1;"
            #
            #     stat, DaneSaldo, dump, dump = self.PolSQL.Execute(SQLSaldo, 3)
            #     rsglobal.ZapiszDoLogow("SQL: {}".format(SQL))
            #     rsglobal.ZapiszDoLogow("Dane: {}".format(DaneSaldo))
            #
            #     if stat == 'OK':
            #         if len(DaneSaldo) == 1:
            #             Saldo = str(DaneSaldo[0][0])
            #
            # if stat == 'OK' and KasaBank <> '':
            #     if TworzycWyc:
            #         # tworzenie nagwka wycigu bankowego
            #         SQLZam = "INSERT INTO rs_raporty_wyciagi (firma_id,okres_id,kasa_bank_id,data,numer,stan, saldo_pocz, saldo_konc) "
            #         SQLZam += "VALUES ('" + self.firma_id + "','" + Okres + "','" + KasaBank + "','" + Data + "'," + NrWyc + ",'W'," + Saldo + "," + Saldo + ");"
            #     else:
            #         # pobranie numeru pozycji ktra bdzie dodawano do istniejcego wycigu
            #         SQL = "SELECT max(nr_poz) FROM rs_raporty_wyciagi_pozycje WHERE firma_id='" + self.firma_id + "' "
            #         SQL += "AND okres_id='" + Okres + "' AND kasa_bank_id='" + KasaBank + "' AND data='" + Data + "' "
            #         SQL += " AND numer=" + str(NrWyc)
            #         stat, DaneWBP, dump, dump = self.PolSQL.Execute(SQL, 3)
            #         rsglobal.ZapiszDoLogow("SQL: {}".format(SQL))
            #         rsglobal.ZapiszDoLogow("Dane: {}".format(DaneWBP))
            #         if stat == 'OK':
            #             if len(DaneWBP) > 0:
            #                 if DaneWBP[0][0] not in [0, None]:
            #                     NrPozWyc = str(DaneWBP[0][0] + 1)

            # PodajUtworzRaportKasowy

            # if stat == 'OK' and KasaBank != '':
            #     stat, NrWyc, NrPozWyc = fs_raporty_wyciagi_pom.PodajUtworzRaportKasowy(self, Okres, KasaBank, Data)


            # if stat == 'OK' and KwotaPar <> '0' and DowodKB != '':
            #     # dodanie pozycji wycigu
            #     Tresc = 'Faktura ' + Wyzn + '/' + Data + '/' + str(Numer)
            #     SQLZam += "INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz,"
            #     SQLZam += "stan_poz,typ, platnik_id, typ_fakt, wyznacznik_id, data_fakt, numer_fakt, kwota) VALUES"
            #     SQLZam += " ('" + self.firma_id + "','" + Okres + "','" + KasaBank + "','" + Data + "'," + NrWyc + "," + NrPozWyc + ",0,"
            #     SQLZam += "'W','P','" + rsglobal.Dekoduj(dNagl[0][1]) + "', 'F', '"+Wyzn+"', '" + Data + "', '"+Numer+"', " + KwotaPar + ");"
            #     stat, dump, dump, dump = self.PolSQL.Execute(SQLZam, 1)
            #     rsglobal.ZapiszDoLogow("SQL: {}".format(SQLZam))
            #     rsglobal.ZapiszDoLogow("stat: {}".format(stat))

    # komser: sprawdzamy czy dane maj by przesyane dalej
    if stat == "OK":
        stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
        if stat != "OK":
            stat = "BL rs_komser_funkcje"
        elif jest and Stan == "G":
            # komser: zbierzmy dane do przekazania dalej zanim przerobimy je lokalnie
            komserDane = []
            stat, faktura, desc, dump = self.PolSQL.Execute("SELECT * FROM rs_faktury"
                " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s", 3,
                (self.firma_id, Wyzn, Data, Numer))
            if stat == "OK":
                stat, pozycje, pdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_faktury_pozycje"
                    " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY nr_poz, nr_ppoz", 3,
                    (self.firma_id, Wyzn, Data, Numer))
            if stat == "OK":
                stat, pozycjeOp, podesc, dump = self.PolSQL.Execute("SELECT * FROM rs_faktury_pozycje_opisowe"
                    " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY nr_poz", 3,
                    (self.firma_id, Wyzn, Data, Numer))
            if stat == "OK" and faktura:
                dolozDodatkoweDane(komserDane, "FAKTURA", faktura[0], desc)
                for pozycja in pozycje:
                    dolozDodatkoweDane(komserDane, "POZYCJA", pozycja, pdesc)
                for pozycja in pozycjeOp:
                    dolozDodatkoweDane(komserDane, "POZ_OPI", pozycja, podesc)

    # przygotowanie/zamknicie faktury
    if stat=="OK":        
        Filtr="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND numer="+Numer+" AND stan='"+Stan+"' AND data='"+Data+"'; "
        Filtr1="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND numer="+Numer+" AND stan='"+NastStan+"' AND data='"+Data+"'; "        

        if Stan=='G':
            #AB 01.08.19r
            sql="UPDATE rs_faktury SET stan='"+NastStan+"'"+ZmianaZaliczki+" "+Filtr
            if TworzycZaleglosc:
                Insert ="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,opis,numer_z_rs,ureg_kwota)"
                Insert+=" SELECT firma_id,'F',wyznacznik_id,data,numer,oddzial_id,'Z',kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,'',numer_z_rs,0 FROM rs_faktury "+Filtr1
                sql+=Insert
                
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            #potencjalnie za numeracja sekwencji w zaleglosciach
            if stat<>'OK':
                #proba zrobienia tego jeszcze raz
                stat,dump,dump,dump=self.PolSQL.Execute("SELECT setval('rs_zaleglosci_nr_zal_seq', max(nr_zal)) FROM rs_zaleglosci;",1)
                if stat=='OK':
                    stat,dump,dump,dump=self.PolSQL.Execute(sql,1)

        
        #-------------------------------------------------------------------------------
        #--- zmiana z W na G
        #-------------------------------------------------------------------------------
        
        elif Stan == 'W':                                                   #AB 15.10.19r
            UpdMPP  = ", czy_mpp = czy_mpp OR ((kwota_netto + kwota_vat > 15000 AND EXISTS(SELECT 1 FROM "
            UpdMPP += "rs_faktury_pozycje p JOIN rs_artykuly a USING (firma_id, artykul_id) WHERE (p.firma_id, "
            UpdMPP += "p.wyznacznik_id, p.data, p.numer) = (f.firma_id, f.wyznacznik_id, f.data, f.numer) AND "
            UpdMPP += "a.czy_mpp)) AND termin_zaplaty>='2019-11-01')"
            sql="UPDATE rs_faktury f SET stan='"+NastStan+"'"+UpdMPP+ZmianaZaliczki+" "+Filtr
            rsglobal.ZapiszDoLogow(sql, 5)
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1) 
            
            # dodatkowe wstawienie pozycji zaliczkowych jeli jest taka potrzeba
            SQL="SELECT COALESCE(zaliczka_rozliczenie,FALSE),COALESCE(zaliczka_wyznacznik_id,''), zaliczka_data, "
            SQL+="zaliczka_numer,platnik_id, do_zaplaty FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+";"
            stat,DZal,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy pobierania informacji o zaliczkach :'+stat

            if stat=='OK':
                if DZal[0][0]:
                    # pobieramy ostatni numer pozycji
                    SQL="SELECT MAX(nr_poz) FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"'"
                    SQL+=" AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+";"
                    stat,DFaktNrPoz,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        stat='Bdy pobierania informacji o pozycji faktury :'+stat
                    
                    if stat=='OK':
                        NrPozMax=DFaktNrPoz[0][0]+1
                        # pobieramy list faktur zaliczkowych zdatnych do obsuenia zaliczki
                        SQL="SELECT f.wyznacznik_id,f.data,f.numer,fp.artykul_id,fp.stawka_vat," #0 - 4
                        SQL+=" f.zaliczka_pozostalo,fp.cecha1_opis,fp.cecha1_wartosc,f.stan " # 5 - 8
                        SQL+=" FROM rs_faktury f INNER JOIN rs_faktury_pozycje fp USING (firma_id,wyznacznik_id,data,numer) "
                        SQL+=" INNER JOIN rs_wyznaczniki w USING (firma_id, wyznacznik_id) "
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND w.typ_faktury='FZ' AND f.zaliczka_pozostalo>0" 
                        SQL+=" AND platnik_id='"+rsglobal.Dekoduj(DZal[0][4])+"' AND f.data<='"+Data+"'"
                        if DZal[0][1]<>'':
                            SQL+=" AND f.wyznacznik_id='"+rsglobal.Dekoduj(DZal[0][1])+"' AND f.data='"+rsglobal.Dekoduj(DZal[0][2])+"'"
                            SQL+=" AND f.numer="+str(DZal[0][3])
                        SQL+=" ORDER BY f.data, f.wyznacznik_id FOR UPDATE;"
                        stat,DFaktZal,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat='Bdy pobierania informacji o fakturach zaliczkowych :'+stat
                        
                    if stat=='OK':
                        # sprawdzenie, czy wszystkie interesujce nas faktury zaliczkowe s zamknite
                        for poz in DFaktZal:
                            if poz[8] not in ['Z','K']:
                                stat= "Zamknicie faktury jest niemoliwe, poniewa odnoszca si do niej faktura zaliczkowa nie jest zamknita ani zaksigowana."
                                break
                    
                    if stat=='OK':
                        # ptla tworzca pozycje zaliczkowe ujemne, modyfikujca faktury zaliczkowe
                        # oraz przygotowujca opis do faktury
                        DoZaplaty=DZal[0][5]
                        Opis='FAKTURY ZALICZKOWE ROZLICZONE Z FAKTUR:\n'
                        SQLZal=''
                        
                        PozZaliczkowe=[]
                        for poz in DFaktZal:
                            if DoZaplaty>0 and stat=='OK':
                                # kwota od razu jest ujemna i string
                                Kwota=min(DoZaplaty,poz[5])
                                rsglobal.ZapiszDoLogow('Do zaplaty 1 '+str(DoZaplaty),5)
                                rsglobal.ZapiszDoLogow('Kwota 1 '+str(Kwota),5)
                                if poz[4] in self.ListaStawekZn:
                                    ProcVAT=0
                                else:
                                    ProcVAT=int(poz[4])
                                    
                                CenaN=str(-1*rsglobal.RSRound((Kwota*100)/(100+ProcVAT),2))
                                Kwota=str(-1*Kwota)
                                # zmieniamy nagwek faktury zaliczkowej
                                SQLZal+="UPDATE rs_faktury SET zaliczka_pozostalo=zaliczka_pozostalo+ "+Kwota
                                SQLZal+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(poz[0])+"'"
                                SQLZal+=" AND data='"+poz[1]+"' AND numer="+str(poz[2])+";"
                                
                                # tworzymy pozycj faktury
                                SQLZal+="INSERT INTO rs_faktury_pozycje (firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"
                                SQLZal+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
                                SQLZal+="cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,"
                                SQLZal+="wartosc_netto,wartosc_vat,wartosc_brutto,cena_wal1,cena_wal2,"
                                SQLZal+="cena_upust_wal1,cena_upust_wal2, wartosc_wal_netto,"
                                SQLZal+="wartosc_wal_vat,wartosc_wal_brutto,cecha1_opis,cecha1_wartosc)"
                                SQLZal+=" VALUES "
                                SQLZal+=" ('"+self.firma_id+"','"+Wyzn+"','"+Data+"',"+Numer+","+str(NrPozMax)+",0,"
                                SQLZal+=" '"+rsglobal.Dekoduj(poz[3])+"',1,1,"+CenaN+","+CenaN+","+CenaN+","+CenaN+","
                                SQLZal+=Kwota+","+Kwota+",0,0,'"+poz[4]+"',"
                                SQLZal+=CenaN+","+Kwota+"- "+CenaN+","+Kwota+","+CenaN+","+CenaN+","
                                SQLZal+=CenaN+","+CenaN+","+CenaN+","+Kwota+"- "+CenaN+","+Kwota+",'"+rsglobal.Dekoduj(poz[6])+"','"+rsglobal.Dekoduj(poz[7])+"');"
                                                     
                                # wstawiamy tekst do opisu
                                Opis+=rsglobal.Dekoduj(poz[0])+"/"+poz[1]+"/"+rsglobal.UsunKropkaZero(str(poz[2]))+" Kwota: "+str(-1*float(Kwota))+" Pozycja: "+str(NrPozMax)+"\n"
                                
                                DoZaplaty=rsglobal.RSRound(DoZaplaty+float(Kwota),2)
                                PozZaliczkowe.append(NrPozMax)
                                NrPozMax+=1
                            
                    if stat=='OK':
                        if SQLZal<>'':
                            SQLZal+="UPDATE rs_faktury SET opis= CASE WHEN TRIM(COALESCE(opis,'')) =''"
                            SQLZal+=" THEN '"+Opis+"' ELSE opis||'\n'||'"+Opis+"' END WHERE firma_id='"+self.firma_id+"'"
                            SQLZal+=" AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+";"

                            stat,dump,dump,dump=self.PolSQL.Execute(str(SQLZal),1)
                    
                    # jeli byy pozycje zaliczkowe to sprawdzamy, czy faktura nie ma ujemnej wartoci. 
                    # Prawdopodobnie ujemno z tytuu zaokrgle nie przekroczy 1 grosza.
                    # jeli taka sytuacja wystpuje to zmniejszamy cen netto i warto pozycji o tyle ile trzeba
                    if stat=='OK' and PozZaliczkowe <>[]:
                        Zmienione=True
                        SQLFakt="SELECT do_zaplaty FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
                        SQLFakt+=" AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+";"
                        while Zmienione and stat=='OK' and PozZaliczkowe <>[]:
                            Zmienione = False
                            stat,DDoZapl,dump,dump=self.PolSQL.Execute(SQLFakt,3)
                            # jeli do zapaty < 0 zmniejszamy ostatni pozycj zaliczki o 1 gr
                            if stat=='OK':
                                if DDoZapl[0][0]<0:
                                    CenaN="(cena_netto1+0.01)"
                                    Kwota="ROUND("+CenaN+"*0.01*(100+CASE WHEN stawka_vat IN ('zw','np') THEN 0 ELSE stawka_vat::INT END),2)"
                                    
                                    SQL= "UPDATE rs_faktury_pozycje SET cena_netto1="+CenaN+",cena_netto2="+CenaN+","
                                    SQL+="cena_upust1="+CenaN+",cena_upust2="+CenaN+","
                                    SQL+="cena_brutto1="+Kwota+",cena_brutto2="+Kwota+","
                                    SQL+="wartosc_netto="+CenaN+",wartosc_vat="+Kwota+"- "+CenaN+","
                                    SQL+="wartosc_brutto="+Kwota+",cena_wal1="+CenaN+",cena_wal2="+CenaN+","
                                    SQL+="cena_upust_wal1="+CenaN+",cena_upust_wal2="+CenaN+", wartosc_wal_netto="+CenaN+","
                                    SQL+="wartosc_wal_vat="+Kwota+"- "+CenaN+",wartosc_wal_brutto="+Kwota
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                                    SQL+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(PozZaliczkowe[-1])+";"
                                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                                    if stat=='OK':
                                        Zmienione = True
                                        
                                        # potem sprawdzamy, czy nie wyzerowaa si przypadkiem.
                                        SQL="SELECT cena_netto1 FROM rs_faktury_pozycje "
                                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                                        SQL+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(PozZaliczkowe[-1])+";"
                                        stat,DPozFakt,dump,dump=self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        # jeli pozycja si wyzerowaa to j usuwamy
                                        # i usuwamy j z listy
                                        if DPozFakt[0][0] == 0:
                                            SQL="DELETE FROM rs_faktury_pozycje "
                                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                                            SQL+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(PozZaliczkowe[-1])+";"                                        
                                            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                                            if stat=='OK':
                                                PozZaliczkowe.pop()
            if stat=='OK':
                #dodatkowe testy/informacja
                sql="SELECT * from rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND f_wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' AND f_numer="+Numer
                stat,DDokDM,dump,dump=self.PolSQL.Execute(sql,3)
            
            if stat=="OK":
                if len(DDokDM)>0:  
                    sql="SELECT artykul,ilosc_w_fakturze,ilosc_w_dokumentach FROM (SELECT p.artykul_id as artykul,"
                    sql+="COALESCE((SELECT SUM(ilosc1) FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' "
                    sql+="AND data='"+Data+"' AND numer="+Numer+" AND artykul_id=p.artykul_id),0) as ilosc_w_fakturze,"
                    sql+="SUM(p.ilosc1) as ilosc_w_dokumentach FROM rs_dokumenty_magazynowe_pozycje p "
                    sql+="INNER JOIN rs_dokumenty_magazynowe d ON (p.firma_id=d.firma_id AND p.magazyn_id=d.magazyn_id "
                    sql+="AND p.dokument_id=d.dokument_id AND p.data=d.data AND p.numer=d.numer) "
                    sql+="WHERE p.firma_id='"+self.firma_id+"' AND d.f_wyznacznik_id='"+Wyzn+"' AND d.f_data='"+Data+"' AND d.f_numer="+Numer
                    sql+=" GROUP BY p.artykul_id) AS tab WHERE ilosc_w_fakturze<>ilosc_w_dokumentach "
                    sql+=" AND NOT (SELECT typ_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND artykul_id=artykul) IN ('31','99') ORDER BY ilosc_w_fakturze-ilosc_w_dokumentach"
                    
                    stat,Dane,dump,dump=self.PolSQL.Execute(sql,3)
                    
                    if stat=="OK":
                        sql="SELECT artykul_id,SUM(ilosc1),0 FROM rs_faktury_pozycje k WHERE firma_id='"+self.firma_id+"' "
                        sql+="AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+" "
                        sql+="AND (SELECT SUM(p.ilosc1) as ilosc_w_dokumentach FROM rs_dokumenty_magazynowe_pozycje p "
                        sql+="INNER JOIN rs_dokumenty_magazynowe d ON (p.firma_id=d.firma_id AND p.magazyn_id=d.magazyn_id "
                        sql+="AND p.dokument_id=d.dokument_id AND p.data=d.data AND p.numer=d.numer) "
                        sql+="WHERE p.firma_id='"+self.firma_id+"' AND d.f_wyznacznik_id='"+Wyzn+"' AND d.f_data='"+Data+"' "
                        sql+=" AND d.f_numer="+Numer+" AND p.artykul_id=k.artykul_id) IS NULL "
                        sql+=" AND NOT (SELECT typ_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND artykul_id=k.artykul_id) IN ('31','99') GROUP BY k.artykul_id" 
                        stat,Dane1,dump,dump=self.PolSQL.Execute(sql,3)
                        
                    if stat=="OK":
                        sql="SELECT artykul,wartosc_w_fakturze,wartosc_w_dokumentach FROM (SELECT p.artykul_id as artykul,"
                        sql+="COALESCE((SELECT SUM(ilosc1*cena_upust1) FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' "
                        sql+="AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+" AND artykul_id=p.artykul_id),0) as wartosc_w_fakturze,"
                        sql+="SUM(p.ilosc1*p.cena1) as wartosc_w_dokumentach FROM rs_dokumenty_magazynowe_pozycje p "
                        sql+="INNER JOIN rs_dokumenty_magazynowe d ON (p.firma_id=d.firma_id AND p.magazyn_id=d.magazyn_id "
                        sql+="AND p.dokument_id=d.dokument_id AND p.data=d.data AND p.numer=d.numer) "
                        sql+="WHERE p.firma_id='"+self.firma_id+"' AND d.f_wyznacznik_id='"+Wyzn+"' AND d.f_data='"+Data+"' "
                        sql+="AND d.f_numer="+Numer+" GROUP BY p.artykul_id) AS tab WHERE wartosc_w_fakturze<wartosc_w_dokumentach "
                        sql+=" AND NOT (SELECT typ_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND artykul_id=artykul) IN ('31','99') ORDER BY wartosc_w_fakturze-wartosc_w_dokumentach"
                        stat,Dane2,dump,dump=self.PolSQL.Execute(sql,3)
            
                    if stat=="OK" and len(DDokDM)>0:
                        Lista=[]
                        wyn1=Dane+Dane1                
                        wyn2=Dane2                            
                        
            if stat=="OK":
                # sprawdzenie limitu KUKE
                from funkcje import fs_kontrahenci_kuke_pom
                
                SQL ="SELECT kontrahent_id,do_zaplaty FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer
                stat,DKuke,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat = 'Bd pobierania danych o kontrahencie '+stat
                if stat =='OK':
                    stat,Przekroczenie=fs_kontrahenci_kuke_pom.SprawdzLimitKuke(self,DKuke[0][0],rsglobal.PodajDzis(),DKuke[0][1])
                    if stat == 'OK':
                        if Przekroczenie > 0:
                            stat='Przekroczono kwote ubezpieczenia Kuke o '+str(Przekroczenie)

            
                
#-------------------------------------------------------------------------------
# -- Otwieranie 8
#-------------------------------------------------------------------------------

if Fun in [8] and stat=='OK':
    if not ((UprOtw and (Wyzn in LOtw)) or (UprEdy and Stan=='G' and (Wyzn in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        if Stan=='G':
            stat="UPR EDYC"
        else:
            stat="UPR OTW"
        dane.append(stat)
        
    if stat=='OK':    
        if Stan == 'Z':
            NastStan='G'
        if Stan == 'G':
            NastStan='W'
        elif Stan in ('W','K'):
            stat='BL STAN OTW'
                
    if stat=="OK":
        stat,Dane,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_p='"+Wyzn+"' AND data_p='"+Data+"' AND numer_p="+Numer,3)        
    if stat=='OK':
        if len(Dane)>0:
            stat="UZ KOR"
    if stat=='OK':
        Filtr="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+" AND stan='"+Stan+"'; "

        if Stan=='Z':
            # sprawdzenie czy faktura zaliczkowa nie zostaa ju czciowo wykorzystana
            SQL="SELECT w.typ_faktury,f.zaliczka_pozostalo,f.do_zaplaty"
            SQL+=" FROM rs_faktury f INNER JOIN rs_wyznaczniki w USING(firma_id,wyznacznik_id) "
            SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+";"            
            stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DFakt) == 0:
                    stat = "BL BRAK FAKT"
            if stat=='OK':
                if DFakt[0][0] =='FZ':
                    if DFakt[0][1] <> DFakt[0][2]:
                        stat = "ROZL FZ"
            
            if stat=='OK':
                # sprawdzenie czy faktura nie bya ju regulowana
                Select="Select SUM(ureg_kwota) From rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND typ_dok='F' AND numer="+Numer+" AND rodzaj='"+Stan+"' AND data='"+Data+"'; "
                stat,Dane,dump,dump = self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if len(Dane)>0:
                        if Dane[0][0]>0:
                            stat="UREG FAKT"
        
        if Stan=='G' and stat=='OK':
            # jeli byy elemety z faktury zaliczkowej to naley je wyczyci i uporzdkowa
            # sprawdzenie czy bya zaliczka (po opisie)
            SQL="SELECT COALESCE(zaliczka_rozliczenie,FALSE),opis FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
            SQL+="  AND data='"+Data+"' AND numer="+Numer+";"
            stat,DaneF,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy pobierania opisu z faktury' 
            if stat=='OK':
                # bya zaliczka - analizujemy opis
                if DaneF[0][0]:
                    LPoz=DaneF[0][1].splitlines()
                    NowyOpis=''
                    DodawacNO=True
                    SQL=''
                    for poz in LPoz:
                        # traktujemy wiersz jak pozycj zaliczkow
                        if stat=='OK' and not DodawacNO:
                            if len(poz.split())==5:
                                KluczZal,dump,Kwota,dump,Pozycja=poz.split()
                                KlZal=KluczZal.split('/')
                                if len(KlZal)<>3:
                                    stat="Bdnie sformatowany opis faktury dotyczcy rozliczenia zaliczki"
                                if stat == 'OK':
                                    WyznZal=KlZal[0]
                                    DataZal=KlZal[1]
                                    NrZal=KlZal[2]
                                    # zgodnie z zapisami opisu usuwamy pozycj i przywracamy zuyt warto w fakturze zaliczkowej
                                    SQL+="DELETE FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                                    SQL+="  AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Pozycja)+";"

                                    SQL+="UPDATE rs_faktury SET zaliczka_pozostalo=zaliczka_pozostalo+"+Kwota+" WHERE firma_id='"+self.firma_id+"'"
                                    SQL+=" AND wyznacznik_id='"+WyznZal+"' AND data='"+DataZal+"' AND numer="+str(NrZal)+";"
                            
                        # trafienie na napis o zaliczkach zmienia styl obrbki wierszy
                        if poz=='FAKTURY ZALICZKOWE ROZLICZONE Z FAKTUR:':
                            DodawacNO=False
                        
                        # dopki nie trafimy na odpowiedni wiersz to jestemy w zwykym opisie
                        if DodawacNO:
                            NowyOpis+=poz+'\n'
                        
                    if stat=='OK':
                        SQL+="UPDATE rs_faktury SET opis='"+NowyOpis.strip()+"' WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
                        SQL+="  AND data='"+Data+"' AND numer="+Numer+";"
                        stat,dump,dump,dump = self.PolSQL.Execute(str(SQL),1)
             
        if stat=="OK":
            sql="UPDATE rs_faktury SET stan='"+NastStan+"' "+Filtr
            if Stan=='Z':
                delete="DELETE FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND typ_dok='F' AND numer="+Numer+" AND rodzaj='"+Stan+"' AND data='"+Data+"'; "
                sql=sql+delete
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)


#-------------------------------------------------------------------------------
# -- tworzenie dok.magazynowego z faktury - 13
#-------------------------------------------------------------------------------

if Fun == 13:
    dane = []
    Dok = klucze[-2]
    Mag = rsglobal.Dekoduj(Dok[0])
    Dokum = rsglobal.Dekoduj(Dok[1])
    DataDM = rsglobal.Dekoduj(Dok[2])
    NrDM = str(Dok[3])

    Kontrahent = ''
    Wersja = ''
    Projekt = ''

    if not UprTworzDokMag:
        stat = 'BR UPR TWORZ DOK MAG'

    #--- sprawdzenie, czy podany magazyn istnieje - czytelniejszy bedzie ewentualny, nastepny komunikat
    if stat == 'OK':
        sql ="SELECT magazyn_id FROM rs_magazyny"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = '"+Mag+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia magazynu : '+stat
        elif len(d) == 0:
            stat = 'BL MAG'
        
    #--- czy operator ma uprawnienie do wstawiania tego typu dokumentu w tym magazynie 
    if self.operator_id <> STANDARD_OPERATOR_ID and stat=='OK':
        sql = "SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Mag+"','"+Dokum+"',4);"
        stat,upr,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(upr)==0:
                stat = 'BR UPR TYP DOK'
            else:
                if not upr[0][0]:
                    stat = 'BR UPR TYP DOK'
                    
    #---stworzenie numeru faktury wg ustalonego wzorca
    if stat == 'OK':
        sql = "SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"',"
        sql+= "\'[\'\'"+Wyzn+"\'\',\'\'"+Data+"\'\',"+Numer+"]\','F\');"
        stat,nr,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru faktury : '+stat
        elif len(nr) == 1:
            Faktura = str(nr[0][0])
        else:
            stat = 'Nie udao si stworzy numeru faktury : '+stat
    
    #--- pobranie danych faktury, a przy okazji sprawdzenie poprawnosci wyboru
    #--- i przyblokowanie, aby w trakcie operacji cos tej fakturze sie nie stalo
    if stat == 'OK':
        sql ="SELECT kontrahent_id,stan,wersja,projekt_id FROM rs_faktury"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Faktura jest edytowana przez kogo innego i nie mona stworzy z niej dokumentu magazynowego'
        elif len(d) == 0:
            stat = 'BL BRAK FAKT'
        else:
            if not str(d[0][1]) in ('Z','K'):
                stat = 'BL FAKT STAN NZ NK'
            else:
                Kontrahent = rsglobal.Dekoduj(d[0][0]).strip()
                # wersja cenowa nie jest pobierana z faktury (4578)
                #Wersja = rsglobal.Dekoduj(d[0][2]).strip()
                Projekt = rsglobal.Dekoduj(d[0][3]).strip()
                
                #README
                #to zabezpiecza nas przed bledem pustego: projektu, wersji cenowej
                #takie faktury powstaja przy tworzenie faktury z paragonu fiskalnego
                #chociaz dok.mag powinien byc tworzony juz z paragonu, a nie dopiero z faktury
                if Projekt == 'None':
                    Projekt = 'NULL'
                else:
                    Projekt = "'"+Projekt+"'"
                    
    #--- sprawdzenie czy data jest poprawna
    if stat == 'OK':
        sql ="SELECT rsf_sprawdz_date(\'"+str(DataDM)+"\');"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)  
        if stat <> 'OK':
            stat = 'Bd spradzenie poprawnoci daty : '+stat
        else:
            Dane = d[0][0]
            if Dane <> 2:
                stat = "BL DATA DM"

    #--- sprawdzenie istnienia dokumentu magazynowego
    if stat=='OK':
        sql ="SELECT stan FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dokum+"'"
        sql+=" AND data='"+DataDM+"' AND numer="+NrDM+";"

        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia dok.magazynowego : '+stat
        else:
            if len(stan)>0:
                stat='BL DM IST'

    #--- sprawdzenie istnienia innego dokumentu magazynowego przypisanego do tej faktury
    if stat=='OK':
        sql ="SELECT magazyn_id,dokument_id,data,numer FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND f_wyznacznik_id = '"+Wyzn+"' AND f_data = '"+Data+"' AND f_numer = "+Numer+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia dok.magazynowego : '+stat
        elif len(d)>0:
            stat = 'BL FAKT MA DM'
            dane = [[str(d[0][0]).strip()+'/'+str(d[0][1])+'/'+str(d[0][2])+'/'+str(d[0][3]).split('.')[0]]]

    #--- sprawdzenie czy podany typ dokumentu jest na wydanie 
    if stat=='OK':
        sql ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dokum+"';"
        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia typu dokumentu magazynowego : '+stat
        else:
            if len(stan)==0:
                stat='BR TYP DOK'
            elif stan[0][0]<>'W':
                stat='BL TYP DOK'
            
    #--- sprawdzenie czy nie ma pniejszych dokumentw
    if stat=='OK':
        sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Mag+"\\\',\\\'"+Dokum+"\\\',\\\'"+DataDM+"\\\',\\\'\\\']','M');"            
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia moliwoci dodania dokumentu magazynowego : '+stat
        else:
            if d[0][0]<>'OK':
                stat='BL DOK DATA'

    #--- sprawdzenie zakresu dat dokumentw magazynowych
    if stat == 'OK':
        sql ="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+Mag+"','"+DataDM+"',2);"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia daty dokumentu z zakresem dat dokumentw mag : '+stat
        else:
            Dane = d[0][0]
            if Dane <> 1:
                stat = "BL ZAKR DATA"

    #--- pobranie pozycji faktury z pominieciem uslug: typ=31,99
    SQLP = ''
    if stat == 'OK':
        FiltrPoz ="pf.firma_id='"+self.firma_id+"' AND pf.wyznacznik_id='"+Wyzn+"'"
        FiltrPoz+=" AND pf.data='"+Data+"' AND pf.numer="+str(Numer)+" AND NOT a.typ_artykulu IN ('31','99')"
        
        sql ="SELECT pf.artykul_id, pf.ilosc1, pf.ilosc2 FROM rs_faktury_pozycje pf"
        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE "+FiltrPoz+";"
        stat,p,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji z faktury : '+stat
        elif len(p) == 0:
            stat = 'BR POZ DOK MAG'
        else:
            for i in xrange(len(p)):
                SQLP+="INSERT INTO rs_dokumenty_magazynowe_pozycje "
                SQLP+="(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,"
                SQLP+="cena1,cena2,cena_pierw1,cena_pierw2,nr_serii,cena_wal1,cena_wal2,cena_pierw_wal1,cena_pierw_wal2) "
                SQLP+=" VALUES "
                SQLP+="('"+self.firma_id+"','"+Mag+"','"+Dokum+"','"+DataDM+"',"+NrDM+","+str(i+1)+",0,"
                SQLP+="'"+str(p[i][0]).strip()+"',"+str(p[i][1])+","+str(p[i][2])+","
                SQLP+="0,0,0,0,'',0,0,0,0); "

    if stat == 'OK':
        # parametry dokumentu w magazynie
        SParam = {}
        SParam['wersja'] = Wersja
        SParam['kontrahent_id'] = Kontrahent
        
        stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Mag,Dokum,SParam)
        if stat == 'OK':
            stat = fs_magazyny_parametry_dokumentow_pom.SprawdzParametryDlaDokumentu(self,Mag,Dokum,SParam)
            if stat == 'OK':
                # sprawdzone i uzupelnione parametry dla dokumentu
                Wersja = SParam['wersja']        
                Kontrahent = SParam['kontrahent_id']        

    #--------------------------------------
    #--- tworzenie dokumentu magazynowego
    #--------------------------------------
    if stat=='OK':
        if Wersja.strip() == '':
            Wersja = 'NULL'
        else:
            Wersja = "'"+Wersja+"'"

        if Kontrahent.strip() == '':
            Kontrahent = 'NULL'
        else:
            Kontrahent = "'"+Kontrahent+"'"
        
        SQLN ="INSERT INTO rs_dokumenty_magazynowe "
        SQLN+="(firma_id,magazyn_id,dokument_id,data,numer,stan,magazyn_skad,kontrahent_id,"
        SQLN+="nr_faktury,wersja,projekt_id,f_wyznacznik_id,f_data,f_numer)"
        SQLN+=" VALUES "
        SQLN+="('"+self.firma_id+"','"+Mag+"','"+Dokum+"','"+DataDM+"',"+NrDM+",'W','"+Mag+"',"+Kontrahent+","
        SQLN+="'"+Faktura+"',"+Wersja+","+Projekt+",'"+Wyzn+"','"+Data+"',"+Numer+");"
        
        stat,d,wyn1,dump=self.PolSQL.Execute(SQLN+SQLP,1)
        if stat <> 'OK':
            stat = 'Bd tworzenia dokumentu magazynowego z faktury : '+stat
        else:
            dane = [[Mag.strip()+'/'+Dokum+'/'+DataDM+'/'+NrDM.split('.')[0]]]
            
    # uzupenienie dat dostaw i daty przychodu na fakturze
    if stat=='OK':
        sql="SELECT rsf_przelicz_daty_przychodu_na_fakturze('"+self.firma_id+"','"+Wyzn+"','"+Data+"'::DATE,"+Numer+"::INTEGER);"
        stat,DaneF,dump,dump=self.PolSQL.Execute(sql,3)
        if stat =='OK':
            if DaneF[0][0] <> 'OK':
                stat = DaneF[0][0]


#-------------------------------------------------------------------------------
# -- przegladanie  (5, 6, 7, 8)
#-------------------------------------------------------------------------------

if (Fun in [5,6,7,8,11]) and (stat=='OK') and (len(LWyzn)>0):
    if not UprPrz:
        stat="UPR PRZ"
        dane.append(stat)        
    if stat=='OK' and Fun<>11:    
        if WyznF=='' and DataOdF=='    -  -  ' and DataDoF=='    -  -  ' and PlatF=='' and KontrF=='' and StanF=='' and klucze_id==[]:
            stat='BR FILTR'
    
    if stat=='OK' and Fun <> 11:
        Filtr = "(f.firma_id = '" + self.firma_id+"'"
        if self.handlowiec_id<>None:
            Filtr+=" AND f.handlowiec='"+self.handlowiec_id+"'"
        if WyznF <> '' :
            Filtr+=" AND f.wyznacznik_id = '" + WyznF +"'"
        if DataOdF <> '    -  -  ': 
            Filtr+=" AND f.data >= '" + DataOdF + "'"
        if DataDoF <> '    -  -  ': 
            Filtr+=" AND f.data <= '" + DataDoF + "'"
        if PlatF <> '': 
            Filtr+=" AND f.platnik_id LIKE '" + PlatF+ "%'"
        if KontrF <> '': 
            Filtr+=" AND f.kontrahent_id LIKE '" + KontrF + "%'"
        if StanF <> '': 
            Filtr+=" AND f.stan = UPPER('"+StanF+"')"
        if NiewyslaneF:
            Filtr+=" AND f.data_exportu is NULL" 
        Filtr+=")"
        
        if klucze_id <>[]: #uzywane przy dodawaniu faktury, tak zeby dodawana byla widoczna
            for k in klucze_id:
                Filtr+=" OR (f.firma_id = '" + self.firma_id + "' AND f.wyznacznik_id = '" + rsglobal.Dekoduj(k[0]) + "' AND f.data = '"+rsglobal.Dekoduj(k[1]) + "' AND f.numer = '" + str(k[2]) + "')"
    if stat== 'OK' and Fun in [11]:
        Filtr="(f.firma_id = '" + self.firma_id + "' AND f.wyznacznik_id = '" + Wyzn + "' AND f.data = '"+ Data + "' AND f.numer = '" + Numer + "')"
    
    if stat=='OK':
        SELECT="SELECT f.stan,f.data,f.wyznacznik_id,f.numer,f.platnik_id||' - '||k.nazwa,f.kontrahent_id,f.do_zaplaty, "
        SELECT+="f.kwota_netto,f.kwota_vat,f.do_zaplaty_wal,f.oddzial_id,f.blokada_cen, f.z_paragonow "
        
        FROM="FROM rs_faktury f INNER JOIN rs_kontrahenci k ON (f.platnik_id=k.kontrahent_id AND f.firma_id=k.firma_id)" 
        WHERE=" WHERE f.wyznacznik_id in ("+str(LPrz)[1:-1]+") AND "+ Filtr
        ORDER=" ORDER BY f.data,f.wyznacznik_id,f.numer;"	
        sql=SELECT+FROM+WHERE+ORDER
        rsglobal.ZapiszDoLogow(rsglobal.Dekoduj(sql))
        stat,dane,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        if stat!="OK":
            stat="BL SQL"
            dane.append(stat)          



# komser: no to jesli mamy cos do przeslania to zapisujemy
if stat == "OK" and Fun in (7, 9) and komserDane is not None and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    # bez selecta na koniec
    klucze[-1] = 9
    # znajdz paragony powizane z faktura i zapisz zeby mozna bylo odtworzyc to powiazanie po drugiej stronie
    #         tak na marginesie, jesli tego paragonu nie znajdzie tam? to nic si nie stanie i nie bdziemy o tym wiedzieli
    paragony = []
    sql = "SELECT oddzial_id, kasa_id, data, numer FROM rs_paragony_fiskalne WHERE firma_id=%s AND wyznacznik_id=%s AND f_data=%s AND f_numer=%s"
    s, d, ds, none = self.PolSQL.Execute(sql, 3, (self.firma_id, Wyzn, Data, Numer))
    for r in d:
        dolozDodatkoweDane(komserDane, "PARAGON", r, ds)
    stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja", "dodatkowe-dane:", komserDane],
        ["fs_komser_faktury", klucze, pola, wartosci])
