# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_faktury_dane.py
# Purpose:     wczytuje/edytuje dane podstawowe faktury
#
# Author:      Jakub Krajniak, Michal Raburski
# Created:     2006/12/10
# RCS-ID:      $Id: fs_faktury_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

# 03.04.2009 - Dariusz Boduch - obsuga dla faktury z paragonu - mantis: 1945
# 2011.05.20 Micha R. (4061) zmiany przeliczania cen
# 2011-10-26 Mariusz Rajfura - kontrola stanu przed zapisem (5077)
# 2011-11-23 Mariusz Rajfura - kontrola stanu przed zapisem (5078)
# 2012-09-03 Mariusz Rajfura     (6029) pobranie waluty z danych do fakturowania
# 2013-02-05 Mariusz Rajfura     (6478) kontrola blokady kontrahenta
# 2013-05-10 Mariusz Rajfura     (6842) nowe pole 'zaliczka_pozostalo': wizualizacja
# 2013-05-10 Mariusz Rajfura     (6843) nowe pola zaliczki: rozliczenie,wyznacznik,data,numer
# 2017-10-18 Rafa Woniak      (10782) dodanie pobierania danych czy oddzielny wat
# 2019-07-24 Aleksander Bargie (11557) Czy split payment
# 2020-04-15 Mikoaj Kozowski  (11914) nowe pola 'oznaczenie transakcji' i 'oznaczenie sprzedaz'
# 2022-09-28 Wojciech Skowron   (13138) eval -> rsglobal.rseval
# 2022-10-21 Wojciech Skowron   (13138) poprawki w przeliczaniu cen na pozycjach
# 2023-03-10 Wojciech Skowron   (13275) pobranie cen dla kontrahenta bez wersji cenowej
# 2023-12-07 Wojciech Skowron   (13553) pobranie ksef_data_przeslania, ksef_data_przyjecia

#klucze = [Wyznacznik,Data,Numer]
from datetime import datetime, timedelta

from funkcje import fs_global_faktury
from funkcje import fs_zaleglosci_sprawdzenie

stat='OK'
Wyznacznik=rsglobal.Dekoduj(klucze[0])
Wyznacznik=Wyznacznik+' '
Wyznacznik=Wyznacznik[0:2]
Data=rsglobal.Dekoduj(klucze[1])
Numer=rsglobal.Dekoduj(klucze[2])
Funkcja=klucze[-1]
Pola = pola
Wartosci=wartosci

puste_pola = [[],"","    -  -  "]
self.CzyZParagonu = False
if self.operator_id != STANDARD_OPERATOR_ID:
    UprDodawanie = ((self.oddzial_id,'022013') in self.uprawnienia)
    UprEdycja = ((self.oddzial_id,'022012') in self.uprawnienia) or UprDodawanie
    if UprEdycja:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprEdycja=(Wyznacznik in LWyzn)
else:
    UprEdycja = True

# -------------------------------------------------------------------------------
# # FUNKCJA 19
# -------------------------------------------------------------------------------

if Funkcja == "9" and stat=='OK': #sprawdzam walute
    if Wyznacznik not in puste_pola:
        sql = "SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND data='"+Wyznacznik+"';"
    elif Data not in puste_pola:
        sql = "SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND nr_tabeli='"+Data+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    
# -------------------------------------------------------------------------------
#Funkcja 17
#Sprawdzanie czy faktura utworzona z paragonu
#jesli tak, to nie zmieniac rabatow, upustow ani wersji cenowych
# -------------------------------------------------------------------------------

if Funkcja in [17,3,4]:
    sql = "SELECT z_paragonow FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(dane)>0:
        CzyZParagonu=rsglobal.Dekoduj(dane[0][0])
    else:
        stat="BL SQL PAR"
        dane.append(stat)
    self.CzyZParagonu = CzyZParagonu

#Sprawdzanie czy faktura utworzona z dowodu dostawy #PW (11002) 2017-04-18
if stat == 'OK' and Funkcja in [3, 4, 31]:
    self.CzyZDowoduDostawy = False
    sql = "SELECT 1 FROM rs_dowody_dostaw "
    sql += "WHERE firma_id='" + self.firma_id + "' AND f_wyznacznik_id='" + Wyznacznik + "' "
    sql += "AND f_data='" + Data + "' AND f_numer=" + str(Numer) + ";"
    stat, dow_dost, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = "Bd sprawdzenia czy faktura zostaa utworzona z dowodu dostawy."
    elif dow_dost:
        self.CzyZDowoduDostawy = True

    if stat == 'OK' and Funkcja == 31:
        dane = self.CzyZDowoduDostawy


# --------------------------------------------------------------------------------------------------
#Funkcja (21) 
#Pobieranie danych, ktre musz ulec modyfikacji po zmianie kontrahenta w danych faktury 
# --------------------------------------------------------------------------------------------------

if Funkcja==21 and stat=='OK':
    Kontr = rsglobal.Dekoduj(klucze[0])
    Data=rsglobal.Dekoduj(klucze[1])
    Wyzn=rsglobal.Dekoduj(klucze[2])
    Zamawiajacy = Kontr
    Platnik = Kontr
    dane=[]
    stat=='OK'
        
    if Kontr.strip()<>"":
        st,d,dump,dump = self.PolSQL.Execute("SELECT zamawiajacy_id,platnik_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id=\'"+str(Kontr)+"\';",3)
        if st<>'OK':
            stat='BL SQL PLAT ZAM'
        elif len(d) != 0:
            if d[0][0] not in ["     ",u'None']:
                Zamawiajacy = rsglobal.Dekoduj(d[0][0])
            if d[0][1] not in ["     ",u'None']:
                Platnik = rsglobal.Dekoduj(d[0][1])
                 
            Kontrahenci=[Kontr,Platnik,Zamawiajacy]
            wyn2=[]
                 
            #odbiorca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
            #platnik
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            #zamawiajacy
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Zamawiajacy+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            sql ="SELECT wersja,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,projekt_id,dni,upust,"
            sql+=" COALESCE(waluta_sprzedaz,'PLN'::TEXT) AS waluta_sprzedaz"
            sql+=" FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+Kontr+"\' AND data_od <= \'"+Data+"\'"
            sql+=" ORDER BY data_od DESC LIMIT 1;"
            st,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
            if st<>'OK':
                stat='BL SQL DAN KONT'
                dane.append(stat)
            elif len(dane)<>1 and Platnik!=Kontr:
                sql ="SELECT wersja,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,projekt_id,dni,upust,"
                sql+=" COALESCE(waluta_sprzedaz,'PLN'::TEXT) AS waluta_sprzedaz"
                sql+=" FROM rs_kontrahenci_fakturowanie"
                sql+=" WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+Platnik+"\' AND data_od <= \'"+Data+"\'"
                sql+=" ORDER BY data_od DESC LIMIT 1;"
                st,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
                if st<>'OK':
                    stat='BL SQL DAN KONT'
                    dane.append(stat)
            if stat=='OK' and len(dane) == 1:
                tr = rssql.RSTableRowset(dane,wyn1)
                dane=Kontrahenci+dane[0]
                for i in xrange(len(dane)):
                    if dane[i]==u'None':
                        dane[i]=''
                    
                #wersja
                if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')   
                    
                #sposob zaplaty
                if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_zaplaty")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')
                    
                #sposob dostawy
                if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_dostawy")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')
                
                #handlowiec
                if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
                #sposob odbioru faktury
                if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')
                
                #projekt
                if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')
                    
                #dla wyrownania pozycji z lista dane[]
                wyn2.append(0)
                wyn2.append(0)
                
                #waluta
                if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta_sprzedaz")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')
            else:
                dane=Kontrahenci+['','','','','','',0,0,'PLN']
                wyn2=wyn2       +['','','','','','',0,0,'polski zoty']

                        
# --------------------------------------------------------------------------------
# -- Pobieranie opisw
# -------------------------------------------------------------------------------

if Funkcja == "20" and stat=='OK': 
    Opis=klucze[0]
    #odbiorca
    if Opis[0]<>'':
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Opis[0]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
    #zamawiajacy
    if Opis[1]<>'':
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Opis[1]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
    #platnik
    if Opis[2]<>'':
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Opis[2]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
    #miejsce dostawy
    if Opis[3]<>'':
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Opis[3]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.') 
                
    #waluta
    if Opis[4]<>'':
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+Opis[4]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  
                
    #wersja
    if Opis[5]<>'':
        if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+Opis[5]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
                
    #sposob zaplaty
    if Opis[6]<>'':
        if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+Opis[6]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
    #handlowiec
    if Opis[7]<>'':
        if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+Opis[7]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    
    #sposob odbioru faktury
    if Opis[8]<>'':
        if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+Opis[8]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
    #sposob dostawy                   
    if Opis[9]<>'':
        if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+Opis[9]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
    #projekt
    if Opis[10]<>'':
        if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+Opis[10]+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

    #oznaczenie transakcje #MK 2020-04-15
    if Opis[11] != '':
        if (self.oddzial_id, '211430') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_transakcje_oznaczenia WHERE kod='" + Opis[11] + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia transakcji: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia transakcji. Poinformuj administratora.')

    #oznaczenie sprzedaz #MK 2020-04-15
    if Opis[12] != '':
        if (self.oddzial_id, '211440') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_oznaczenia_sprzedaz WHERE kod='" + Opis[12] + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia sprzeday: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia sprzeday. Poinformuj administratora.')


# -------------------------------------------------------------------------------
# ---   Sprawdzam dane
# -----------------------------------------------------------------------------

if stat == "OK" and Funkcja in [4,3]:
    dane=[]
    if not UprEdycja:
        stat='BL_UPR'
        dane.append(stat)

    if stat == 'OK':
        # pobranie aktualnych danych do sprawdzenia poprawnosci wraz z polami modyfikowanymi
        sql ="SELECT * FROM rs_faktury"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        
        stat,DaneFakt,NaglFakt,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia stanu faktury: '+stat
            dane.append(stat)
        elif len(DaneFakt) == 0:
            stat = 'Brak faktury o podanym kluczu.'
            dane.append(stat)
    
    if stat == 'OK':
        tr = rssql.RSTableRowset(DaneFakt,NaglFakt)
        if tr.GetVal(0,'stan') != 'W':
            # w stanie innym niz W dozwolona edycja pol:
            for i in xrange(len(pola)):
                if not pola[i] in ['zamowienie_nr','zamowienie_data','waga',
                                   'nr_samochodu','data_zaladunku','opis']:
                    stat = 'Faktura w stanie '+tr.GetVal(0,'stan')+'. Zapis zmian niemoliwy.'
                    dane.append(stat)
                    break
    
    if stat=='OK':
        Wersja=None  #WS 2023-03-10
        Upust=-1
        Kontrahent=''
        Waluta=''
        Kurs=0
        ZaliczkaRozliczenie = None
        ZaliczkaWyznacznik = None
        ZaliczkaData = None
        ZaliczkaNumer = None
        
        if Funkcja in [3,4]:
            if Data not in puste_pola:
                dane_wyn = rsglobal.SprawdzCzyToData(Data)   
                if not dane_wyn:
                    stat = "BL KLUCZ"
                else:
                    sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+self.oddzial_id+"\',\'"+Data+"\',1);"
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                    if dane_wyn != 1:
                        stat="ZK DATA"
                        dane_wyn.append(stat)
                Filtr = "firma_id=\'"+self.firma_id+"\' AND wyznacznik_id=\'"+Wyznacznik+"\' AND data=\'"+Data+"\' AND numer="+str(Numer)
                sql="SELECT * FROM rs_faktury WHERE "+Filtr+";"
                stat, dane_fakt, wyn1_fakt, dump = self.PolSQL.Execute(sql ,3)
                if len(dane_fakt) == 0:
                    stat = "BL KLUCZ"
                    dane.append(stat)
                else:
                    tr          = rssql.RSTableRowset(dane_fakt,wyn1_fakt)
                    test_dni    = tr.GetVal(0, 'dni')
                    test_termin = tr.GetVal(0, 'termin_zaplaty')
                    test_data   = tr.GetVal(0, 'data')
            else:
                stat = "BL KLUCZ"
                dane.append(stat)
    
            if stat == "OK":
                for i in range(len(Pola)):
                    pole = Pola[i]
                    wart = Wartosci[i]

                    if stat == 'OK' and pole == "kontrahent_id":
                        if wart == "":
                            stat = "BR KONTR"
                            dane.append(stat)
                        elif self.CzyZDowoduDostawy:
                            stat = "BL KONTR DD"
                            dane.append(stat)
                        else:
                            sql = "SELECT kontrahent_id,zablokowany FROM rs_kontrahenci "
                            sql += "WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' "
                            sql += "AND aktywny=TRUE;"
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                            if len(dane_wyn) == 0:
                                stat = "BL KONTR"
                                dane.append(stat)
                            elif dane_wyn[0][1]:
                                stat = "BL KONTR ZABLOK"
                                dane.append(stat)
                            else:
                                Kontrahent=wart

                    elif stat == 'OK' and pole == "wyznacznik_id":
                        if wart == "":
                            stat = "BR WYZN"
                            dane.append(stat)
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id=\'"+self.firma_id+"\' AND wyznacznik_id = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL WYZN"
                                dane.append(stat)
    
                    elif pole == "numer" and stat == 'OK':
                        if wart <= 0:
                            stat="BL NUMER"
                            dane.append(stat)
    
                    elif pole == "oddzial_id" and stat == 'OK':
                        if wart == "":
                            stat="BR ODDZ"
                            dane.append(stat)
                        else:
                            if wart != Oddzial:
                                stat="NG ODDZ"
                                dane.append(stat)   
    
                    elif pole == "stan" and stat == 'OK':
                        if wart == "":
                            stat="BR STAN"
                            dane.append(stat)
                        else:
                            if not wart in ["W","Z"]:
                                stat="BL STAN"
                                dane.append(stat)
    
                    elif stat == 'OK' and pole == "zamawiajacy_id":
                        if wart == "":
                            stat = "BR ZAMAW"
                            dane.append(stat)
                        elif self.CzyZDowoduDostawy:
                            stat = "BL ZAMAW DD"
                            dane.append(stat)
                        else:
                            sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' "
                            sql += "AND kontrahent_id = \'"+wart+"\' AND aktywny=TRUE;"
                            stat, dane_wyn, dump, dump = self.PolSQL.Execute(sql, 3)
                            if len(dane_wyn) == 0:
                                stat = "BL ZAMAW"
                                dane.append(stat)
    
                    elif stat == 'OK' and pole == "platnik_id":
                        if wart == "":
                            stat="BR PLATNIK"
                            dane.append(stat)
                        elif self.CzyZDowoduDostawy:
                            stat = "BL PLATNIK DD"
                            dane.append(stat)
                        else:
                            sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' "
                            sql += "AND kontrahent_id = \'"+wart+"\' AND aktywny=TRUE;"
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                            if len(dane_wyn) == 0:
                                stat="BL PLATNIK"
                                dane.append(stat)
    
                    elif pole == "miejsce_dostawy_id" and stat == 'OK':
                        if wart == "":
                            Wartosci[i] = "NULL"
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;",3)
                            if len(dane_wyn) == 0:
                                stat= "BL MIEJDOST"
                                dane.append(stat)
    
                    elif pole == "dostawy_od_dnia" and stat == 'OK':
                        if wart == "    -  -  ":
                            Wartosci[i] = "NULL"
                        else:
                            dane_wyn = rsglobal.SprawdzCzyToData(wart)
                            if not dane_wyn:
                                stat="BL DATADOD"
                                dane.append(stat)
    
                    elif pole == "dostawy_do_dnia" and stat == 'OK':
                        if wart == "    -  -  ":
                            Wartosci[i] = "NULL"
                        else:
                            dane_wyn = rsglobal.SprawdzCzyToData(wart)
                            if not dane_wyn:
                                stat="BL DATADDO"
                                dane.append(stat)
    
                    elif pole == "waluta" and stat == 'OK':
                        if wart == "":
                            stat="BR WALUTA"
                            dane.append(stat)
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id=\'"+self.firma_id+"\' AND kod= \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL WALUTA"
                                dane.append(stat)
                            else:
                                Waluta=wart
    
                    elif pole == "wersja" and stat == 'OK':
                        if wart == "":
                            Wartosci[i] = "NULL"
                            Wersja=''
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL WERSJA"
                                dane.append(stat)
                            else:
                                Wersja=wart
                    
                    elif pole == "kraj_opodatkowania" and stat == 'OK':
                        if wart == "":
                            stat="BR KRAJ"
                            dane.append(stat)
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kraj FROM rs_kraje WHERE kraj = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL KRAJ"
                                dane.append(stat)
                            else:
                                Kraj=wart
                                
                    elif pole == "nie_podlega_vat":
                        NiePodlVAT=wart
    
                    elif pole == "sposob_zaplaty" and stat == 'OK':
                        if wart == "":
                            stat="BR SPOSZAPL"
                            dane.append(stat)
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_zaplaty WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL SPOSZAPL"
                                dane.append(stat)
    
                    elif pole == "sposob_dostawy" and stat == 'OK':
                        if wart == "":
                            Wartosci[i] = "NULL"
                            dane.append(stat)
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_dostaw WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL SPOSDOST"
                                dane.append(stat)
    
                    elif pole == "handlowiec" and stat == 'OK':    
                        if wart == "":
                            Wartosci[i] = "NULL"
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_handlowcy WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL HANDL"
                                dane.append(stat)

                    elif pole == "ozn_trans" and stat == 'OK':    #MK 2020-04-15
                        if wart == "":
                            Wartosci[i] = "NULL"
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_transakcje_oznaczenia WHERE kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL OZN_TRANS"
                                dane.append(stat)

                    elif pole == "ozn_sprzedaz" and stat == 'OK':    #MK 2020-04-15
                        if wart == "":
                            Wartosci[i] = "NULL"
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_oznaczenia_sprzedaz WHERE kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL OZN_SPRZ"
                                dane.append(stat)
    
                    elif pole == "sposob_odbioru_faktury" and stat == 'OK':    
                        if wart == "":
                            Wartosci[i] = "NULL"
                        else:
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_odbioru_faktury WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                            if len(dane_wyn) == 0:
                                stat="BL SPOSODBFAKT"
                                dane.append(stat)
    
                    elif pole == "data_przychodu" and stat == 'OK':
                        if wart == "    -  -  ":
                            Wartosci[i] = "NULL"
                        else:
                            dane_wyn = rsglobal.SprawdzCzyToData(wart)
                            if not dane_wyn:
                                stat="BL_DATAPRZYCH"
                                dane.append(stat)
    
                    elif pole == "projekt_id" and stat == 'OK':    
                        if wart == "":
                            stat = 'BR PROJ'
                            dane.append(stat)
                        else:
                            sql ="SELECT data_od,data_do FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id = '"+wart+"';"
                            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                            if len(dane_wyn) == 0:
                                stat="BL PROJ"
                                dane.append(stat)
                            else:
                                if dane_wyn[0][0] != 'None':
                                    if Data < dane_wyn[0][0]:
                                        stat = 'BL_PROJ_DATAOD'
                                        dane.append(stat)
                                if dane_wyn[0][1] != 'None':
                                    if Data > dane_wyn[0][1]:
                                        stat = 'BL_PROJ_DATADO'
                                        dane.append(stat)
                                    #AB 24.07.19r
                    elif pole in ("czy_bonus", "czy_mpp") and stat == 'OK':
                        if wart:
                            Wartosci[i] = "TRUE"
                        else:
                            Wartosci[i] = "FALSE"
    
                    elif pole == "kurs":
                        Kurs=wart
    
                    elif pole == "data_tabeli" and stat == 'OK':
                        if wart== '    -  -  ':
                            Wartosci[i]="NULL"
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat="BL_DATA_TABELI"
                            dane.append(stat)
    
                    elif pole == "zamowienie_data" and stat == 'OK':
                        if wart== '    -  -  ':
                            Wartosci[i]="NULL"
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat="BL_DATA_ZAMOW"
                            dane.append(stat)
    
                    elif pole == "upust":
                        Upust=wart
                                
                    elif pole == "termin_zaplaty" and stat == 'OK':
                        test_termin = None
                        if wart=='    -  -  ':
                            stat="BR_TERM_ZAPL"
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat="BL_TERM_ZAPL"
                            dane.append(stat)
                        else:
                            test_termin = wart
    
                    elif pole == "data_zaladunku" and stat == 'OK':
                        if wart == "    -  -  ":
                            Wartosci[i] = "NULL"
                        else:
                            dane_wyn = rsglobal.SprawdzCzyToData(wart)
                            if not dane_wyn:
                                stat="BL DATAZAL"
                                dane.append(stat)
                    
                    elif pole == "zaliczka_rozliczenie" and stat == 'OK':
                        ZaliczkaRozliczenie = wart
                        
                    elif pole == "zaliczka_wyznacznik_id" and stat == 'OK':
                        ZaliczkaWyznacznik = wart
                        if wart == "":
                            Wartosci[i] = "NULL"
                        else:
                            sql ="SELECT typ_faktury='FZ' FROM rs_wyznaczniki"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'Bd sprawdzenia wyznacznika zaliczki: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL_ZALICZKA_WYZNACZNIK'
                                dane.append(stat)
                            elif not d[0][0]:
                                stat = 'BL_ZALICZKA_WYZNACZNIK_NIE_ZALICZKA'

                    elif pole == "zaliczka_data" and stat == 'OK':
                        ZaliczkaData = wart
                        if wart == "    -  -  ":
                            Wartosci[i] = "NULL"
                        else:
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = "BL_ZALICZKA_DATA"
                                dane.append(stat)

                    elif pole == "zaliczka_numer" and stat == 'OK':
                        ZaliczkaNumer = wart
                        if wart < 0:
                            stat = "BL_ZALICZKA_NUMER"
                            dane.append(stat)
                        ZaliczkaNumer = Wartosci[i]

                    elif pole == "dni" and stat == 'OK':
                        test_dni = None
                        if wart is None:
                            test_dni = 0
                            Wartosci[i] = 0
                        elif wart < 0:
                            stat = "BL_DNI_0"
                        elif wart > 999:
                            stat = "BL_DNI_999"
                        else:
                            test_dni = wart
                # test czy dni/termin na fakturze sie zgadzaja
                if test_dni is not None and test_termin is not None:  # pola sa None jesli byl blad, nie ma co sprawdzac
                    if test_data > test_termin:
                        stat = "BL_TERM_DATA"
                        dane.append(stat)
                    elif datetime.strptime(test_data, "%Y-%m-%d") + timedelta(days=test_dni) \
                            != datetime.strptime(test_termin, "%Y-%m-%d"):
                        stat = "BL_NIEZG_DATA"
                        dane.append(stat)



                        
                #jesli byly jakies bledy
                if len(dane) > 0:
                    stat = dane[0]
                    
            else:
                stat="BL_SQL"
                dane.append(stat)


    if stat == 'OK' and (ZaliczkaWyznacznik != None or ZaliczkaData != None or ZaliczkaNumer != None):
        # zmieniono dane faktury zaliczkowej, wiec ja sprawdzamy czy istnieje
        
        if ZaliczkaWyznacznik in (None,'') and ZaliczkaData in (None,'    -  -  ') and ZaliczkaNumer in (None,0):
            # to znaczy, ze wszystkie dane puste
            # skladnia opisana ze wzgledu na zle samopoczucie i koniecznosc dokonczenia zagadnienia :-(
            # dla jasnosci algorytmu
            pass
        
        else:
            # pobieramy pola, ktore nie zostalyz zmienione z dotychczasowych danych i sprawdzamy fakture zaliczkowa
            if ZaliczkaWyznacznik == None:
                ZaliczkaWyznacznik = tr.GetVal(0,'zaliczka_wyznacznik_id')
            
            if ZaliczkaData == None:
                ZaliczkaData = tr.GetVal(0,'zaliczka_data')
            
            if ZaliczkaNumer == None:
                ZaliczkaNumer = tr.GetVal(0,'zaliczka_numer')
    
            sql ="SELECT platnik_id FROM rs_faktury"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+ZaliczkaWyznacznik+"'"
            sql+=" AND data='"+ZaliczkaData+"' AND numer="+str(ZaliczkaNumer)+";"
    
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia faktury zaliczkowej: '+stat
                dane.append(stat)
            elif len(d) == 0:
                stat = 'BR_ZALICZKA_FAKTURA'
                dane.append(stat)
            else:
                # sprawdzenie czy patnik z faktury zaliczkowej zgadza si z patnikiem z faktury
                SQL="SELECT platnik_id FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)    
                if stat<>'OK':
                    stat='Bd przy pobieraniu danych faktury:'+stat
                elif len(DTest)==0:
                    stat='Brak modyfikowanej faktury'
                elif d[0][0]<>DTest[0][0]:
                    stat='Podana faktura zaliczkowa dotyczy innego patnika ni modyfikowana faktura'
            
# -------------------------------------------------------------------------------
# ---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
# -------------------------------------------------------------------------------
    
    if stat=='OK':
        dane = []
        sql = "UPDATE rs_faktury SET "
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            
            if pole in ["miejsce_dostawy_id","dostawy_od_dnia","data_tabeli","dostawy_do_dnia","handlowiec",
                        "sposob_odbioru_faktury","sposob_dostawy","wersja","projekt_id","opis","zamowienie_nr",
                        "data_przychodu","zamowienie_data","data_zaladunku","data_exportu",
                        "zaliczka_wyznacznik_id","zaliczka_data","ozn_trans","ozn_sprzedaz"]: #MK 2020-04-15
                if wart == "NULL":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"='"+str(wart)+"',"

                    #AB 24.07.19r dodane czy_mpp
            elif pole in ["numer","kierowca","kurs","dni","data_odbioru","upust_wartosc",
                          "upust_wartosc_wal","rabat_wartosc","rabat_wartosc_wal","kwota_netto",
                          "kwota_vat","wartosc_opakowan","do_zaplaty","kwota_netto_wal","kwota_vat_wal",
                          "wartosc_opakowan_wal","do_zaplaty_wal","czy_bonus", "sprzedaz_uslug", "nie_podlega_vat",
                          "zaliczka_rozliczenie","zaliczka_numer", "czy_mpp"]:
                sql += pole+"="+str(wart)+","
             # RW  dodanie pobierania danych czy oddzielny wat
            elif pole in ["wyznacznik_id","data","oddzial_id","stan","kontrahent_id","termin_zaplaty",
                          "zamawiajacy_id","platnik_id","waluta","nr_tabeli","sposob_zaplaty","tekst_nad_podp",
                          "tekst_pod_podp","kraj_opodatkowania","nr_samochodu","osobny_rachunek_vat"]:
                sql += pole+"='"+str(wart)+"',"
            #WS 2022-10-21 - edytowalne pola numeryczne osobno
            elif pole in ["upust","rabat","waga"]:
                if wart is None:
                    sql += pole+"=0,"
                else:
                    sql += pole+"="+str(wart)+","
                
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"

        if (Waluta<>'' or Wersja is not None or Upust<>-1 or Kontrahent<>'') and not self.CzyZParagonu:  #WS 2022-10-21 - Waluta<>''  #WS 2023-03-10 - Wersja is not None zamiast Wersja<>''
            Select="SELECT kontrahent_id,wersja,upust,waluta,kurs FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            stat,d,dump,dump = self.PolSQL.Execute(Select,3)
            if stat=='OK':
                if Kontrahent=='':
                    Kontrahent=rsglobal.Dekoduj(d[0][0])
                if Wersja is None:
                    Wersja=rsglobal.Dekoduj(d[0][1])
                if Upust== -1:
                    Upust=d[0][2]
                if Waluta=='':
                    Waluta=rsglobal.Dekoduj(d[0][3])
                if Kurs== 0:
                    Kurs=d[0][4]
                    
                # sprawdzenie czy wersja jest netto czy brutto
                SQL="SELECT nr_poz,nr_ppoz,artykul_id,stawka_vat,COALESCE(upust,-1) FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(SQL,3)
                for poz in dane_wyn:
                    StVAT=poz[3]
                    if StVAT in self.ListaStawekZn:
                        StVATL='0'
                    else:       
                        StVATL=str(int(StVAT))
                    
                    if poz[4]<>-1:
                        Upust=poz[4]

                    WersjaRSF = Wersja if Wersja != '' else ''  #WS 2023-03-10
                    sdl="SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"',CAST('"+Kontrahent+"' AS TEXT),CAST('"+Waluta+"' AS TEXT),CAST('"+Data+"' AS TEXT),CAST('"+rsglobal.Dekoduj(poz[2])+"' AS TEXT),CAST('"+WersjaRSF+"' AS TEXT),"+str(Upust)+")"
                    rsglobal.ZapiszDoLogow(sdl)
                    stat,d_c,dump,dump=self.PolSQL.Execute(sdl,3)
                    if stat=='OK':
                        d=rsglobal.rseval(d_c[0][0])
                        if (d[0]<>0 or d[2]<>0):
                            CzyArtJm2="(SELECT faktura_w_jm2 FROM rs_artykuly WHERE firma_id=rs_faktury_pozycje.firma_id AND artykul_id=rs_faktury_pozycje.artykul_id)"
                            CenaWalN1=str(d[0])
                            CenaWalN2=str(d[1])
                            CenaWalN1U=str(d[4])
                            CenaWalN2U=str(d[5])
                            CenaWalB1=str(d[6])
                            CenaWalB2=str(d[7])
                            WartWalN="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*"+CenaWalN2U+" ELSE ilosc1*"+CenaWalN1U+" END,2)"
                            WartWalVAT="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*"+CenaWalN2U+" ELSE ilosc1*"+CenaWalN1U+" END*"+StVATL+"*0.01,2)"
                            WartWalB="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*"+CenaWalN2U+" ELSE ilosc1*"+CenaWalN1U+" END*(100+"+StVATL+")*0.01,2)"
                            CenaN1=str(rsglobal.RSRound(d[0]*Kurs,2))
                            CenaN2=str(rsglobal.RSRound(d[1]*Kurs,2))
                            CenaN1U=str(rsglobal.RSRound(d[4]*Kurs,2))
                            CenaN2U=str(rsglobal.RSRound(d[5]*Kurs,2))
                            CenaB1=str(rsglobal.RSRound(d[6]*Kurs,2))
                            CenaB2=str(rsglobal.RSRound(d[7]*Kurs,2))
                            WartN="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*"+CenaN2U+" ELSE ilosc1*"+CenaN1U+" END,2)"
                            WartVAT="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*"+CenaN2U+" ELSE ilosc1*"+CenaN1U+" END*"+StVATL+"*0.01,2)"
                            WartB="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*"+CenaN2U+" ELSE ilosc1*"+CenaN1U+" END*(100+"+StVATL+")*0.01,2)"
                            #WS 2022-10-21
                            WartU="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*("+CenaN2+"-"+CenaN2U+") ELSE ilosc1*("+CenaN1+"-"+CenaN1U+") END,2)"
                            # WartU="ROUND(CASE WHEN "+CzyArtJm2+" THEN ilosc2*("+CenaN2+"-"+CenaWalN2U+") ELSE ilosc1*("+CenaN1+"-"+CenaWalN1U+") END,2)"
                            
                            Update="UPDATE rs_faktury_pozycje SET cena_wal1="+CenaWalN1
                            Update+=",cena_wal2="+CenaWalN2+",cena_upust_wal1="+CenaWalN1U
                            Update+=",cena_upust_wal2="+CenaWalN2U+",wartosc_wal_netto="+WartWalN
                            Update+=",wartosc_wal_vat="+WartWalVAT+",wartosc_wal_brutto="+WartWalB
                            
                            Update+=",cena_netto1="+CenaN1+",cena_netto2="+CenaN2
                            Update+=",cena_upust1="+CenaN1U+",cena_upust2="+CenaN2U
                            Update+=",cena_brutto1="+CenaB1+",cena_brutto2="+CenaB1
                            
                            Update+=",wartosc_netto="+WartN+",wartosc_vat="+WartVAT
                            Update+=",wartosc_brutto="+WartB+",upust_wartosc="+WartU
                            Update+=",upust="+str(Upust)
                            Update+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND "
                            Update+="data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(poz[0])+" AND nr_ppoz="+str(poz[1])+"; "                            
                            stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
    
        if 'kurs' in Pola and not self.CzyZParagonu and stat=='OK':
            if Kurs!=0:
                CaseVAT="CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE stawka_vat::INT END"
                
                stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT nr_poz FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; ",3)
                if len(dane_wyn) > 0:
                    #ustawienie parametrw
                    Przel="(SELECT przelicznik FROM rs_artykuly WHERE firma_id=rs_faktury_pozycje.firma_id AND artykul_id=rs_faktury_pozycje.artykul_id)"
                    CzyArtJm2="(SELECT faktura_w_jm2 FROM rs_artykuly WHERE firma_id=rs_faktury_pozycje.firma_id AND artykul_id=rs_faktury_pozycje.artykul_id)"
                    CenaN1="ROUND(cena_wal1*"+str(Kurs)+",2)"    
                    CenaU1="ROUND("+CenaN1+"*(100-upust)*0.01,2)"
                    CenaWU1="ROUND(cena_wal1*(100-upust)*0.01,2)"
                    CenaB1="ROUND("+CenaU1+"*(100+"+CaseVAT+")*0.01 ,2)"
                    CenaN2="ROUND("+CenaN1+"/"+Przel+",2)"
                    CenaU2="ROUND("+CenaN2+"*(100-upust)*0.01,2)"
                    CenaB2="ROUND("+CenaU2+"*(100+"+CaseVAT+")*0.01 ,2)"
                    CenaW2="ROUND("+CenaN2+"/"+str(Kurs)+",2)"
                    CenaWU2="ROUND("+CenaW2+"*(100-upust)*0.01,2)"
                    WartWN="ROUND("+CenaWU1+"*ilosc1,2)"
                    WartN="ROUND("+WartWN+"*"+str(Kurs)+",2)"
                    WartWVAT="ROUND("+WartWN+"*"+CaseVAT+"*0.01,2)"
                    WartVAT="ROUND("+WartN+"*"+CaseVAT+"*0.01,2)"
                    
                    Update="UPDATE rs_faktury_pozycje SET cena_netto1="+CenaN1+",cena_netto2="+CenaN2
                    Update+=",cena_upust1="+CenaU1+",cena_upust2="+CenaU2
                    Update+=",cena_brutto1="+CenaB1+",cena_brutto2="+CenaB2
                    Update+=",cena_wal2="+CenaW2+",cena_upust_wal1="+CenaWU1+",cena_upust_wal2="+CenaWU2
                    Update+=",wartosc_netto="+WartN+",wartosc_vat="+WartVAT
                    Update+=",wartosc_brutto="+WartN+"+"+WartVAT
                    Update+=",wartosc_wal_netto="+WartWN+",wartosc_wal_vat="+WartWVAT
                    Update+=",wartosc_wal_brutto="+WartWN+"+"+WartWVAT
                    Update+=",upust_wartosc=round((cena_wal1-cena_upust_wal1)*ilosc1*"+str(Kurs)+",2)"
                    Update+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "
                    sql=sql+Update
                stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT nr_poz FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; ",3)
                if len(dane_wyn) > 0:
                    Update="UPDATE rs_faktury_pozycje_opisowe SET wartosc_netto=round(wartosc_wal_netto*"+str(Kurs)+",2),wartosc_vat=round(wartosc_wal_vat*"+str(Kurs)+",2),wartosc_brutto=round(wartosc_wal_brutto*"+str(Kurs)+",2) WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "
                    sql=sql+Update 
        
        #sprawdzenie czy nie zmieniamy VATU na "np"
        if 'nie_podlega_vat' in Pola and not self.CzyZParagonu:
            if NiePodlVAT:
                #nie podlega
                UpdKrajPZ="UPDATE rs_faktury_pozycje SET stawka_vat='np',cena_brutto1=cena_netto1,cena_brutto2=cena_netto2,wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+";"
                UpdKrajPO="UPDATE rs_faktury_pozycje_opisowe SET stawka_vat='np',wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+";"
                sql+=UpdKrajPZ
                sql+=UpdKrajPO
            else:
                #wiemy ze podlega i sie zmienia czyli trzeba uwzglednic kraj opodatkowania
                if not 'kraj_opodatkowania' in Pola:
                    #nie wiadomo jaki kraj to trzeba go pobrac
                    SQL = "SELECT kraj_opodatkowania FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
                    stat,DaneK,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        Kraj=DaneK[0][0]
                            
                if Kraj <>'PL' and stat=='OK':
                    #zamiana vatu np na vat 0.
                    UpdKrajPZ="UPDATE rs_faktury_pozycje SET stawka_vat='00' WHERE "+Filtr+";"
                    UpdKrajPO="UPDATE rs_faktury_pozycje_opisowe SET stawka_vat='00' WHERE "+Filtr+";"
                    sql+=UpdKrajPZ
                    sql+=UpdKrajPO
                elif stat=='OK':
                    #zamiana vatu "np" na stawki vat z artykulow
                    VAT=" (SELECT a.stawka_vat FROM rs_artykuly a WHERE a.firma_id=rs_faktury_pozycje.firma_id AND a.artykul_id=rs_faktury_pozycje.artykul_id) "
                    PrVAT=" (SELECT CASE WHEN a.stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE (0.01*CAST (a.stawka_vat AS integer)) END FROM rs_artykuly a WHERE a.firma_id=rs_faktury_pozycje.firma_id AND a.artykul_id=rs_faktury_pozycje.artykul_id) "
                    UpdKrajPZ="UPDATE rs_faktury_pozycje SET stawka_vat="+VAT+",cena_brutto1=cena_netto1*(1+"+PrVAT+"),cena_brutto2=cena_netto2*(1+"+PrVAT+"),"
                    UpdKrajPZ+="wartosc_vat=wartosc_netto*"+PrVAT+",wartosc_brutto=wartosc_netto*(1+"+PrVAT+"),wartosc_wal_vat=wartosc_wal_netto*"+PrVAT+",wartosc_wal_brutto=wartosc_wal_netto*(1+"+PrVAT+") WHERE "+Filtr+";"
                    sql+=UpdKrajPZ

        elif 'kraj_opodatkowania' in Pola and not self.CzyZParagonu:
            #wiemy e nie zmiania si "Nie podlega VAT" i e zmienia si kraj opodatkowania
            #sprawdzamy czy podlega VAT
            SQL = "SELECT nie_podlega_vat FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
            stat,DanePO,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if not DanePO[0][0]:
                    #podlega VAT
                    #zmiana vatu w zalenoci od kraju opodatkowania
                    if Kraj!= 'PL':
                        #zamiana dowolnego vatu na vat 0.
                        UpdKrajPZ="UPDATE rs_faktury_pozycje SET stawka_vat='00',cena_brutto1=cena_netto1,cena_brutto2=cena_netto2,wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+";"
                        UpdKrajPO="UPDATE rs_faktury_pozycje_opisowe SET stawka_vat='00',wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+";"
                        sql+=UpdKrajPZ
                        sql+=UpdKrajPO
                    else:
                        #zamiana na stawki vat z artykulow
                        VAT=" (SELECT a.stawka_vat FROM rs_artykuly a WHERE a.firma_id=rs_faktury_pozycje.firma_id AND a.artykul_id=rs_faktury_pozycje.artykul_id) "
                        PrVAT=" (SELECT CASE WHEN a.stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE (0.01*CAST (a.stawka_vat AS integer)) END FROM rs_artykuly a WHERE a.firma_id=rs_faktury_pozycje.firma_id AND a.artykul_id=rs_faktury_pozycje.artykul_id) "
                        UpdKrajPZ="UPDATE rs_faktury_pozycje SET stawka_vat="+VAT+",cena_brutto1=cena_netto1*(1+"+PrVAT+"),cena_brutto2=cena_netto2*(1+"+PrVAT+"),"
                        UpdKrajPZ+="wartosc_vat=wartosc_netto*"+PrVAT+",wartosc_brutto=wartosc_netto*(1+"+PrVAT+"),wartosc_wal_vat=wartosc_wal_netto*"+PrVAT+",wartosc_wal_brutto=wartosc_wal_netto*(1+"+PrVAT+") WHERE "+Filtr+";"
                        sql+=UpdKrajPZ
        
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL_SQL'
            dane.append(stat)

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
# -------------------------------------------------------------------------------

if (Funkcja in [5,3,1]) and (stat=='OK'):
    where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
    #WS 2023-12-07 - ksef_data_przeslania, ksef_data_przyjecia
    sql = "SELECT *, " \
          "to_char(ksef_data_przeslania, 'YYYY-MM-DD HH24:MI:SS') AS ksef_data_przeslania, " \
          "to_char(ksef_data_przyjecia, 'YYYY-MM-DD HH24:MI:SS') AS ksef_data_przyjecia" \
          " FROM rs_faktury " + where + ";"

    # pobranie danych
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    #pobranie danych do opisow
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # [0] odbiorca
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        # [1] zamawiajacy
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"zamawiajacy_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        # [2] platnik
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"platnik_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        # [3] miejsce dostawy
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"miejsce_dostawy_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.') 
            
        # [4] waluta
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  
            
        # [5] wersja
        if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
            
        # [6] sposob zaplaty
        if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_zaplaty")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        # [7] handlowiec
        if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        # [8] sposob odbioru faktury
        if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        # [9] sposob dostawy                   
        if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_dostawy")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        # [10] projekt
        if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
            
        # [11] kraj opodatkowania
        if ((self.oddzial_id,'011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kraje WHERE kraj='"+tr.GetVal(0,"kraj_opodatkowania")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
        
        # [12]
        wyn2.append(str(UprEdycja))
        
        # [13] kontrola limitu zaleglosci 
        Stan = tr.GetVal(0,"stan")
        Kontrahent = tr.GetVal(0,"kontrahent_id")
        Kwota = tr.GetVal(0,"do_zaplaty")
        if Stan == 'W':
            limit = fs_zaleglosci_sprawdzenie.SprawdzLimitKontrahenta(self,Kontrahent,Kwota,Data)
            wyn2.append(limit)
        else:
            wyn2.append('')
            
        # [14] czy to faktura zaliczkowe
        sql ="SELECT typ_faktury='FZ' FROM rs_wyznaczniki"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
        dump,d,dump,dump = self.PolSQL.Execute(sql,3)
        wyn2.append(d[0][0])

        # [15] oznaczenie transakcje #MK 2020-04-16
        if (self.oddzial_id, '211430') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_transakcje_oznaczenia WHERE kod='" + tr.GetVal(0,
                                                                                       "ozn_trans") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia transakcji: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia transakcji. Poinformuj administratora.')

        # [16] oznaczenie sprzedaz #MK 2020-04-16
        if (self.oddzial_id, '211440') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_oznaczenia_sprzedaz WHERE kod='" + tr.GetVal(0,
                                                                                     "ozn_sprzedaz") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia sprzeday: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia sprzeday. Poinformuj administratora.')
