# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_faktury_hdi
# Purpose:     dodawanie/przegldanie/edycja danych HDI faktury
# Author:      Micha Raburski
# Created:     2014/01/14
# RCS-ID:      $Id: fs_faktury_hdi.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'KluczFakt':[3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_faktury_hdi z numerem '+str(Fun)+' bez parametrw: '+Lista

    if Fun in (3,4,5): 
        Wyzn=rsglobal.Dekoduj(klucze['KluczFakt'][0])
        Data=klucze['KluczFakt'][1]
        Nr=str(klucze['KluczFakt'][2])

UprDodawanie = (((self.oddzial_id,'022013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'022012') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i].lower()
        wart = wartosci[i]

        if pole == 'przewoznik_id':
            if wart <> '':
                SQL ="SELECT kontrahent_id FROM rs_kontrahenci"
                SQL+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania przewodnika : '+stat)
                elif len(d) == 0:
                    dane.append('BL PRZEW')
                
        elif pole == 'metoda_przetwarzania':
            if wart not in ['1','2','3','4','5','6','7']:
                dane.append('BL METODA')
            
        if len(dane) > 0:
            stat = dane[0]




#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    upd = "UPDATE rs_faktury_hdi SET "
    WHERE=" WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
    WHERE+=" AND data = '"+Data+"' AND numer = '"+Nr+"'"
    
    Wartosci=''
    Pola=''
    for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['rodzaje_opakowan','srodek_transportu','metoda_przetwarzania',
                'cel_przewozu','gatunek_zwlok1','gatunek_zwlok2','nr_kolczyka','cmr_cechy_i_numery','cmr_ilosc',
               'cmr_spos_opakowania','cmr_rodzaj_towaru','cmr_nr_statyst','cmr_waga_brutto',
               'cmr_objetosc','cmr_instrukcja']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
                
            elif pole in ['przewoznik_id','czas_odkazenia']: 
                Pola= Pola+","+pole
                if wart<>'':
                    Wartosci= Wartosci+",'"+wart+"'"
                else:                 
                    Wartosci= Wartosci+",NULL"

            elif pole in ['liczba_zwlok1','liczba_zwlok2']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            
            elif pole in ['material_kat_3','produkt_przetworzony_kat_3']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
                
    if len(Wartosci)>0:    
        upd = upd+" ("+Pola[1:]+") = ("+Wartosci[1:]+")" + WHERE        
        stat,d,dump,dump = self.PolSQL.Execute(upd,1)        
        if stat <> 'OK':
            stat = 'Bd aktualizacji danych HDI Faktury : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,5) and stat=='OK':
    # sprawdzenie czy istnieje rekord. Jeli nie to go automatycznie dodajemy a potem bdzie tylko edycja
    SQL ="SELECT rodzaje_opakowan,srodek_transportu,metoda_przetwarzania,"
    SQL+="cel_przewozu,gatunek_zwlok1,gatunek_zwlok2,nr_kolczyka,przewoznik_id,COALESCE(czas_odkazenia::TEXT,'') AS czas_odkazenia,"
    SQL+="liczba_zwlok1,liczba_zwlok2,material_kat_3,produkt_przetworzony_kat_3,z_op_id,z_czas,"
    SQL+="cmr_cechy_i_numery,cmr_ilosc,cmr_spos_opakowania,cmr_rodzaj_towaru,cmr_nr_statyst,cmr_waga_brutto,"
    SQL+="cmr_objetosc,cmr_instrukcja FROM rs_faktury_hdi"
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
    SQL+=" AND data = '"+Data+"' AND numer ="+Nr
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)    
    if stat <> 'OK':
        stat = 'Bd pobrania danych HDI faktury : '+stat

    if stat == 'OK':
        if len(dane)==0:
        # wstawienie rekordu
            Ins= "INSERT INTO rs_faktury_hdi (firma_id,wyznacznik_id,data,numer,cel_przewozu) VALUES "
            Ins+=" ('"+self.firma_id+"','"+Wyzn+"','"+Data+"',"+Nr+",'0');"
            stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)    
            if stat <> 'OK':
                stat = 'Bd wstawienia danych HDI faktury : '+stat
            
            if stat=='OK':
                stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)    
                if stat <> 'OK':
                    stat = 'Bd drugiego pobrania danych HDI faktury : '+stat
                elif len(dane)==0:
                    stat = 'Dodawanie wiersza nie powiodo si.'
        
    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] opis przewonika
        if tr.GetVal(0,"przewoznik_id")<>'None':
            if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT nazwa FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"przewoznik_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu przewonika : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod przewonika.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')