# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_faktury_klucz.py
# Purpose:     insert/update faktury
#
# Author:      Tomasz Romanczuk,Micha Raburski
# Created:     2007/01/19
# RCS-ID:      $Id: fs_faktury_klucz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#dodany typ faktury RR - Dariusz Boduch 2009-02-09
# dodawanie z rs_oddzialy wersji sprzedaz (jesli jest) jesli nie to z klucza (przy dodawaniu nowej faktury) - Dariusz Boduch 2009-02-16 - mantis:1726
#2011.01.10 MR                   (4192) stawki vat dla kopiowania faktury bez przeliczania cen
#2011.01.13 Mariusz Rajfura      (4200) pobranie danych do fakturowania dla kopiowanej faktury wg daty nowej faktury
#2012.09.03 Mariusz Rajfura      (6029) pobranie waluty z danych do fakturowania
#2012.09.03 Mariusz Rajfura      (6033) pobranie handlowca z rs_wyznaczniki dla nowej lub kopiowanej faktury
#2013-02-03 Mariusz Rajfura      (6478) kontrola blokady kontrahenta przed wystawieniem/kopiowaniem faktury
#2014-06-01 Marcin Natkaski     (8021) kontrola uprawnie do wyznacznika przy tworzeniu faktury z paragonu
#2017-08-22 Piotr Witkowski     (10679) Sprawdzi czy wpisanie daty_do w projektach blokuje mozliwosc wprowadzania
#2017-10-18 Rafa Woniak       (10782) dodanie pobierania danych czy oddzielny wat
#2019-08-06 Wojciech Skowron    (11579) Przy tworzeniu faktur - czy_mpp ustawiane na True jesli zaznaczone u patnika lub kontrahenta
#2020-03-25 Mikoaj Kozowski   (11906) Uzupenianie pola kod_gtu w pozycjach, podczas kopiowania faktury
#2020-04-16 Wojciech Skowron    (11634) Zapisywanie do stat wyniku wykonania PobierzNaFaktureDaneDoFakturowaniaDlaKontrahenta() i PobierzCenyDoPozycji()
#2020-04-15 Mikoaj Kozowski   (11914) nowe pola 'oznaczenie transakcji' i 'oznaczenie sprzedaz' przy kopiowaniu faktury
#2020-04-16 Wojciech Skowron    (11634) - kopiowanie faktury - nieprzenoszzenie upust_wartosc i upust_wartosc_wal
#2021-02-16 Aleksander Bargie  (12340) Zmiana klucza faktury - aktualizowa klucze faktur w dowodach

from funkcje import fs_global_faktury

Fun=klucze[-1]

stat = "OK"
dane = []

UprDodawanie=((self.oddzial_id,'022013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'022015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie
UprPozycje=((self.oddzial_id,'022010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------
if Fun in [2,3,4,11]:
    kl = klucze[0]
    pl = klucze[1]
    wr = klucze[2]
    firma = kl[0]
    wyzn = kl[1]
    data = kl[2]
    numer = kl[3]
    OdswiezacGrida = False
    
    SprKlucz = False
    firmaN = firma
    wyznN = wyzn
    dataN = data
    numerN = numer
    numerN = numer
    OddzielnyVAT=False
    
    for i in range(len(pl)):
        pole = pl[i]
        if pole in ["firma_id","wyznacznik_id","data","numer"]:
            SprKlucz = True
        if pole == "firma_id":
            firmaN = wr[i]
        elif pole == "wyznacznik_id":
            wyznN = wr[i]
        elif pole == "data":
            dataN = wr[i]
            if dataN == "    -  -  ":
                stat = "BR DATA"
            if stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date('"+str(dataN)+"');",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu daty :'+stat
                    dane.append(stat) 
                else:
                    Dane = d[0][0]
                    if Dane <> 2:
                        stat = "BL DATA"
            if stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date_z_zakresem('"+str(firma)+self.oddzial_id+"','"+str(dataN)+"',1);",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu daty z zakresem :'+stat
                    dane.append(stat) 
                else:
                    Dane = d[0][0]
                    if Dane <> 1:
                        stat = "ZK DATA"
            
        elif pole == "numer":
            numerN = wr[i]
            
    if SprKlucz:
        if stat=='OK':
            filtr = "firma_id='"+str(firmaN)+"' AND wyznacznik_id='"+str(wyznN)+"' AND data='"+str(dataN)+"' AND numer="+str(numerN)
            stat,d,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_faktury WHERE "+filtr+";",3)
            if stat<>'OK':
                stat = 'Bdy przy sprawdzaniu daty :'+stat
                dane.append(stat) 
            else:
                if len(d) <> 0:
                    stat = "UZ KLUCZ"
        if stat =="OK" and Fun in [3,]: #sprawdzenie projektu PW 2017-08-22
            SQL = "SELECT projekt_id FROM rs_faktury WHERE firma_id='"+str(firma)+"' "
            SQL +="AND wyznacznik_id='"+str(wyzn)+"' AND data='"+str(data)+"' AND numer="+str(numer) +";"
            stat, dd, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                stat = u'Bdy przy pobraniu projektu z faktury:' + stat
            elif stat == 'OK' and len(dd) > 0:
                SQL = "SELECT data_do>='" + str(dataN) + "' FROM rs_projekty WHERE firma_id='"+str(firmaN)+"' "
                SQL +="AND projekt_id='"+dd[0][0]+"' and data_do is not null; "
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat<>'OK':
                    stat = u'Bdy przy sprawdzaniu daty projektu :'+stat
                    dane.append(stat)
                else:
                    if len(d) == 1 and d[0][0] == False:
                        stat = "BL PROJ"

    for i in range(len(pl)):
        pole = pl[i]
        wart = wr[i]
        if pole == "kontahent_id":
            if wart == "":
                stat = "BR KONTR"
            if stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+str(firma)+"' AND kontrahent_id='"+str(wart)+"' AND aktywny=TRUE;",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu kontrahenta :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL KONTR" 
            
        elif pole == "wyznacznik_id":
            if wart == "":
                stat = "BR WYZN"
            else:
                if stat=='OK':
                    sql ="SELECT wyznacznik_id,czy_korekta,typ_faktury,COALESCE(handlowiec,''::TEXT)"
                    sql+=" FROM rs_wyznaczniki WHERE firma_id='"+str(firma)+"' AND wyznacznik_id='"+str(wart)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat<>'OK':
                        stat = 'Bdy przy sprawdzaniu danych :'+stat
                        dane.append(stat)
            if stat=='OK':
                if len(d) == 0:
                    stat = "BL WYZN" 
            
            if stat=='OK':
                if d[0][1]:
                    stat = "WYZN KOR" 
            if stat=='OK':
                HandlowiecZWyznacznika = rsglobal.Dekoduj(d[0][3])
                if HandlowiecZWyznacznika == '':
                    HandlowiecZWyznacznika = "NULL"
                else:
                    HandlowiecZWyznacznika = "'"+HandlowiecZWyznacznika+"'"
            
            #U W A G A ! ! ! PRZY ZMIANIACH TYPU FAKTURY NALEZY DO KONAC ZMIAN ROWNIEZ W PLIKU: fs_paragony_fiskalne.py        
            if stat=='OK':        
                if not d[0][2] in ('BP','DU','EK','KR','WW','ZA','ZU','RR','ZL','FZ'):
                    stat = "BL TYP FAKT" 
                
                #sprawdzenie czy operator ma prawo dodawa ten wyznacznik w danym oddziale
                #pobranie listy wyznacznikw, do ktrych ma prawo dodawania
            if stat=='OK':
                if self.operator_id <> STANDARD_OPERATOR_ID:
                    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"
                    stat,DaneW,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat<>'OK':
                        stat = 'Bdy przy pobieraniu wyznacznika :'+stat
                        dane.append(stat)
                    if stat=='OK':
                        LWyzn=eval(DaneW[0][0])[1]
                        Buf=str(wart)+'  '
                        Buf=Buf[0:2]
                        if not Buf in LWyzn:
                            stat="BL UPR WYZN"
                  
        elif pole == "numer":
            if wart <= 0:
                stat = "BL NUMER"
        elif pole == "oddzial_id":
            if wart == "":
                stat = "BR ODDZ"
            if wart <> self.oddzial_id:
                stat = "NG ODDZ"
        elif pole == "stan":
            if wart == "":
                stat = "BR STAN"
            if not wart in ["W","Z"]:
                stat = "BL STAN"
        elif pole == "zamawiajacy_id":
            if wart == "":
                stat = "BR ZAMAW"
            if stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+str(firma)+"' AND kontrahent_id='"+str(wart)+"' AND aktywny=TRUE;",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu zamawiajcego :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL ZAMAW"
        elif pole == "platnik_id":
            if wart == "":
                stat = "BR PLATNIK"
            if stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+str(firma)+"' AND kontrahent_id='"+str(wart)+"' AND aktywny=TRUE;",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu kontrahenta :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL PLATNIK"
            
        elif pole == "miejsce_dostawy_id":
            if wart == "":
                wr[i] = "NULL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+str(firma)+"' AND kontrahent_id='"+str(wart)+"' AND aktywny=TRUE;",3)
                if stat<>'OK':
                    stat = 'Bdy przy spr. kontrahenta :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL MIEJDOST"
                
        elif pole == "dostawy_od_dnia":
            if wart == "    -  -  ":
                wr[i] = "NULL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date('"+str(wart)+"');",3) 
                if stat<>'OK':
                    stat = 'Bdy przy spr. daty od :'+stat
                    dane.append(stat) 
                else:  
                    Dane = d[0][0]
                    if Dane <> 2:
                        stat = "BL DATADOD"
                
        elif pole == "dostawy_do_dnia":
            if wart == "    -  -  ":
                wr[i] = "NULL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date('"+str(wart)+"');",3)   
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu daty do:'+stat
                    dane.append(stat) 
                else:
                    Dane = d[0][0]
                    if Dane <> 2:
                        stat = "BL DATADDO"
                
        elif pole == "waluta":
            if wart == "":
                stat = "BR WALUTA"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id='"+str(firma)+"' AND kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu waluty :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL WALUTA"
        
        elif pole == "wersja":
            if wart == "":
                wr[i] = "NULL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+str(firma)+"' AND kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu daty :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL WERSJA" 
                
        elif pole == "spos_zaplaty":
            if wart == "":
                stat = "BR SPOSZAPL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_zaplaty WHERE firma_id='"+str(firma)+"' AND kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu sposobu zapaty :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL SPOSZAPL" 
            
        elif pole == "spos_dostawy":
            if wart == "":
                stat = "BR SPOSDOST"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_dostaw WHERE firma_id='"+str(firma)+"' AND kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu sposobu dostawy :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL SPOSDOST" 
            
        elif pole == "handlowiec":
            if wart == "":
                wr[i] = "NULL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_handlowcy WHERE firma_id='"+str(firma)+"' AND kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu handlowca :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL HANDL" 
                
        elif pole == "sposob_odbioru_faktury":
            if wart == "":
                wr[i] = "NULL"
            elif stat=='OK':
                stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+str(firma)+"' AND kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat = 'Bdy przy spr. sposobu odbioru faktury :'+stat
                    dane.append(stat) 
                else:
                    if d == None or len(d) == 0:
                        stat = "BL SPOSODBFAKT" 
        
        elif pole in ["stan","data","wyznacznik_id","numer","platnik_id","kontrahent_id","do_zaplaty","kwota_netto","kwota_vat","do_zaplaty_wal","oddzial_id"]:
            OdswiezacGrida = True
        
        
#-------------------------------------------------------------------------------
#--- SELECT DANYCH(1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if not UprPozycje:
        stat = 'UPR INS'
        dane.append(stat)
    if stat=='OK':
        Wyzn = klucze[0]
        Data = klucze[1]
        stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+Wyzn+"\\',\\'"+Data+"\\']','F');",3)            
        if stat<>'OK':
            stat = 'Bdy przy spr. faktury :'+stat
            if dane is None:
                dane = []
            dane.append(stat)
        else:
            if dane[0][0]=='OK':
                stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\'"+Wyzn+"\\',\\'"+Data+"\\']','F');",3)        
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu nowego numeru :'+stat
                    if dane is None:
                        dane = []
                    dane.append(stat)
                else:
                    if dane[0][0] in (None,'None',''):
                        stat="BL N NUM"
            elif stat=='OK':
                stat="NM DD"


#-------------------------------------------------------------------------------
#--- INSERT DANYCH(2)     
#-------------------------------------------------------------------------------

if Fun == 2 and stat == "OK":
    if not UprDodawanie:
        stat = 'UPR INS'
        dane.append(stat)
    if stat=='OK':
        klucz = klucze[0]
        pola = klucze[1]
        wart = klucze[2]
        
        firmaK = klucz[0]
        wyznK = rsglobal.Dekoduj(klucz[1])
        dataK = rsglobal.Dekoduj(klucz[2])
        nrK = klucz[3]
        
        # sprawdzenie  unikalnoci numeru faktury w ramach odpowiedniego zakresu czasowego
        SQL="SELECT rsf_sprawdz_czy_unikalny_numer_dokumentu('"
        SQL+= self.firma_id+"','[\\\'"+wyznK+"\\\',\\\'"+dataK+"\\\',"+str(nrK)+"]','F');"
        stat,DaneNrF,dump,dump = self.PolSQL.Execute(SQL,3)            
        if stat<>'OK':
            stat='Bd sprawdzania unikalnoci numeru faktury :'+stat
        if DaneNrF[0][0]<>'OK':
            stat=DaneNrF[0][0]
                
        #sprawdzenie czy mona doda faktur z t dat
        if stat =='OK':
            stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+wyznK+"\\',\\'"+dataK+"\\']','F');",3)            
            if stat<>'OK':
                stat = 'Bdy przy sprawdzaniu dokumentu :'+stat
                dane.append(stat)
            else:
                if test[0][0]<>'OK':    
                    stat='NM DD' # nie mozna doda dokumentu
                  
        Kontr = ""
        Dni = "0.0"
        Wersja = "NULL"
        Upust = "0"
        SposZaplaty = "NULL"
        SposDostawy = "NULL"
        Handlowiec = "NULL"
        SposobOdbioruFaktury = "NULL"
        Projekt = "NULL"
        Waluta = "'PLN'"
        
        i=0
        for pole in pola:
            if pole == "kontrahent_id":
                Kontr = wart[i]
                Zamawiajacy = Kontr
                Platnik = Kontr
            i = i + 1
                
        if Kontr == "" and stat=='OK':
            stat = "BR KONTR"
        elif stat=='OK':
            sql ="SELECT zamawiajacy_id,platnik_id,zablokowany"
            sql+=" FROM rs_kontrahenci"
            sql+=" WHERE firma_id='"+str(firmaK)+"' AND kontrahent_id='"+str(Kontr)+"' AND aktywny=TRUE;"
            
            dump,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bdy przy sprawdzaniu kontrahenta :'+stat
                dane.append(stat)
                
            if stat == 'OK':
                if d == None or len(d) == 0:
                    stat = "BL KONTR"
                elif d[0][2]:
                    stat = 'BL ZABLOKOWANY'
            
            if stat == 'OK':
                if d[0][0] not in ["     ",u'None']:
                    Zamawiajacy = d[0][0]
                if d[0][1] not in ["     ",u'None']:
                     Platnik = d[0][1]
                     
                Wersja='NULL'
                if stat=='OK':
                    stat,dr,dump,dump = self.PolSQL.Execute("SELECT wersja_sprzedaz FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"';", 3)
                    if stat<>'OK':
                        stat = 'BL SQL WERS CEN'        
                    if len(dr) == 1:
                        if str(dr[0][0]).strip() not in ('None',''):
                            ok,wersjac,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod = '"+str(dr[0][0])+"';", 3)    
                            if stat<>'OK':
                                stat = 'Bdy przy sprawdzaniu wersji cenowej :'+stat
                                dane.append(stat)
                            else:
                                if len(wersjac)==0:
                                    stat='BL WERSJA CEN'
                                    dane.append(stat) 
                                else:
                                    Wersja = "'"+dr[0][0]+"'"
                    if stat=='OK':
                        # RW dodanie do popranych informacji danych z osobnych rachynek vat
                        sql ="SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,"
                        sql+=" projekt_id,COALESCE(waluta_sprzedaz,'PLN'::TEXT),osobny_rachunek_vat"
                        sql+=" FROM rs_kontrahenci_fakturowanie"
                        sql+=" WHERE firma_id='"+str(firmaK)+"' AND kontrahent_id = '"+str(Kontr)+"' AND data_od <= '"+str(dataK)+"'"
                        sql+=" ORDER BY data_od DESC LIMIT 1;"
                        stat,dk,dump,dump = self.PolSQL.Execute(sql, 3)
                        if dk != []:
                            OddzielnyVAT = dk[0][9]
                        if stat<>'OK':
                            stat = 'Bdy przy sprawdzaniu danych :'+stat
                            dane.append(stat)
                            
                if stat=='OK':
                    if len(dk)<>1 and Platnik<>Kontr:
                        sql ="SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,"
                        sql+=" projekt_id,COALESCE(waluta_sprzedaz,'PLN'::TEXT),osobny_rachunek_vat"
                        sql+=" FROM rs_kontrahenci_fakturowanie"
                        sql+=" WHERE firma_id='"+str(firmaK)+"' AND kontrahent_id = '"+str(Platnik)+"' AND data_od <= '"+str(dataK)+"'"
                        sql+=" ORDER BY data_od DESC LIMIT 1;"
                        stat,dk,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat<>'OK':
                            stat = 'Bdy przy sprawdzaniu danych :'+stat
                            dane.append(stat)
                        # RW Przypisywanie informacji z chekboxa
                        if dk != []:
                            OddzielnyVAT = dk[0][8]
                    elif len(dk) == 1:
                        Dni = str(dk[0][0])
                        if dk[0][1] <> u'None' and str(Wersja.strip()) in ('None','','NULL'):
                            Wersja = "'"+dk[0][1]+"'"
                        Upust = str(dk[0][2])
                        if dk[0][3] <> u'None':
                            SposZaplaty = "'"+dk[0][3]+"'"
                        if dk[0][4] <> u'None':
                            SposDostawy = "'"+dk[0][4]+"'"
                        if dk[0][5] <> u'None':
                            Handlowiec = "'"+dk[0][5]+"'"
                        if dk[0][6] <> u'None':
                            SposobOdbioruFaktury = "'"+dk[0][6]+"'"
                        if dk[0][7] <> u'None':
                            Projekt = "'"+rsglobal.Dekoduj(dk[0][7])+"'"

                        Waluta = "'"+rsglobal.Dekoduj(dk[0][-2])+"'"

                if stat == 'OK':
                    #WS 2019-08-06
                    CzyMPP = False

                    SEL = """SELECT BOOL_OR(czy_mpp) FROM rs_kontrahenci WHERE firma_id = '{}' AND kontrahent_id in ('{}','{}');"""
                    SEL = SEL.format(self.firma_id, Platnik or 'NULL', Kontr or 'NULL')
                    stat,DMPP,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd przy pobieraniu danych patnika/kontrahenta faktury: '+stat
                    elif DMPP[0][0]:
                        CzyMPP = True

                if stat == 'OK': #MK 2020-04-21
                    if len(wyznK) > 0 :
                        sql = "SELECT ozn_trans,ozn_sprzedaz"
                        sql += " FROM rs_wyznaczniki"
                        sql += " WHERE firma_id='" + str(firmaK) + "' AND wyznacznik_id = '" + str(wyznK) + "';"
                        stat, dw, dump, dump = self.PolSQL.Execute(sql, 3)
                        if stat <> 'OK':
                            stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
                            dane.append(stat)
                        if dw != []:
                            OznTrans = dw[0][0]
                            OznSprz = dw[0][1]

                if Handlowiec == "NULL":
                    Handlowiec = HandlowiecZWyznacznika
                                  
                        
                Termin = Dni[0:Dni.find(".")]
                if Termin=="":
                    Termin="date '"+dataK+"'"
                Termin="date '"+dataK+"' + integer '"+Termin+"'"
                
                p = "stan,firma_id,wyznacznik_id,data,numer,oddzial_id,kontrahent_id,zamawiajacy_id,platnik_id,waluta,kurs,kraj_opodatkowania,"
                p = p+"wersja,projekt_id,sposob_zaplaty,dni,termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,upust,upust_wartosc,"
                p = p+"upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal,kwota_netto,kwota_vat,wartosc_opakowan,"
                p = p+"do_zaplaty,kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,osobny_rachunek_vat"
                p = p+",czy_mpp,ozn_trans,ozn_sprzedaz" #WS 2019-06-08  #MK 2020-04-21
                   
                w = "'W','"+str(firmaK)+"','"+str(wyznK)+"','"+str(dataK)+"',"+str(nrK)+",'"+str(self.oddzial_id)+"','"+str(Kontr)+"','"+str(Zamawiajacy)+"','"+str(Platnik)+"',"+Waluta+",1,'PL',"
                w = w+ str(Wersja)+","+Projekt+","+str(SposZaplaty)+","+str(Dni)+","+str(Termin)+","+str(Handlowiec)+","+str(SposobOdbioruFaktury)+","+str(SposDostawy)+","+str(Upust)+",0,"
                w = w+ "0,0,0,0,0,0,0,"
                w = w+ "0,0,0,0,0,"
                w = w+ str(OddzielnyVAT)
                w = w+ ","+str(CzyMPP) #WS 2019-08-06
                if OznTrans not in ('None',''):
                    w = w+ ",'" + str(OznTrans) + "'" #MK 2020-04-21
                else:
                    w = w+ ",NULL"
                if OznSprz not in ('None',''):
                    w = w+ ",'" + str(OznSprz) +"'" #MK 2020-04-21
                else:
                    w = w+ ",NULL"

                Insert = "INSERT INTO rs_faktury ("+p+") VALUES ("+w+");"
            if stat=='OK':
                rsglobal.ZapiszDoLogow(Insert,1)
                stat,dump,dump,dump = self.PolSQL.Execute(Insert,1)
                if stat<>'OK':
                    stat = 'Bdy przy dodawaniu danych :'+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------        
#--- UPDATE DANYCH(3)
#-------------------------------------------------------------------------------

if Fun == 3 and stat == "OK":
    if not UprEdycja:
        stat = 'UPR UPD'       
        dane.append(stat)
    if stat=='OK':    
        klucz = klucze[0]
        pola = klucze[1]
        wartosci = klucze[2]

        wyznK = rsglobal.Dekoduj(klucz[1])
        dataK = rsglobal.Dekoduj(klucz[2])
        nrK = klucz[3]
        
        dataN = rsglobal.Dekoduj(wartosci[2])
        
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(wyznK)+"' AND data='"+str(dataK)+"' AND numer="+str(nrK)
        
        #pobranie danych do zmiany terminu zapaty
        SQL="SELECT dni FROM rs_faktury WHERE "+Filtr+" ;"
        stat,daneD,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>"OK":
            stat="BL SQL DNI"
        else:
            Dni=daneD[0][0]
        
        Zapyt = "UPDATE rs_faktury SET "
        i = 0
        #AB 16.02.21r
        nowy_wyzn = ''
        nowa_data = ''
        nowy_nr = None

        for pole in pola:
            wart = wartosci[i]
            if pole in ["miejsce_dostawy_id","dostawy_od_dnia","dostawy_do_dnia","handlowiec","sposob_odbioru_faktury","wersja"]:
                if wart == "NULL":
                    Zapyt = Zapyt+pole+"="+str(wart)+","
                else:
                    Zapyt = Zapyt+pole+"='"+str(wart)+"',"
            elif pole in ["numer","kierowca","kurs","data_tabeli","dni","data_odbioru","upust","upust_wartosc","upust_wartosc_wal","rabat","rabat_wartosc","rabat_wartosc_wal","kwota_netto","kwota_vat","wartosc_opakowan","do_zaplaty","kwota_netto_wal","kwota_vat_wal","wartosc_opakowan_wal","do_zaplaty_wal"]:
                Zapyt = Zapyt+pole+"="+str(wart)+","
                if pole == "numer":  #AB 16.02.21r
                    nowy_nr = int(wart)
            elif pole in ["wyznacznik_id","data","oddzial_id","stan","kontrahent_id","termin_zaplaty","zamawiajacy_id","platnik_id","waluta","nr_tabeli","sposob_zaplaty","sposob_dostawy","tekst_nad_podp","tekst_pod_podp"]:
                Zapyt = Zapyt+pole+"='"+str(wart)+"',"
                if pole == "wyznacznik_id":  #AB 16.02.21r
                    nowy_wyzn = str(wart)
                elif pole == "data":  #AB 16.02.21r
                    nowa_data = str(wart)
            
            i = i + 1    
        Zapyt = Zapyt+" data_przychodu='"+dataN+"', termin_zaplaty= date '"+dataK+"'+  CAST((date '"+dataN+"' - date '"+dataK+"') + "+str(Dni)+" AS INTEGER),"
        Zapyt = Zapyt[0:len(Zapyt)-1]
        Zapyt = Zapyt+" WHERE "+Filtr+";"
        #AB 16.02.21r
        UPDATEDD = """UPDATE rs_dowody_dostaw 
                      SET f_wyznacznik_id='{}', f_data='{}', f_numer={} 
                      WHERE firma_id='{}' AND f_wyznacznik_id='{}' AND f_data='{}' AND f_numer={}
                      ;""".format(nowy_wyzn, nowa_data, nowy_nr, self.firma_id, wyznK, dataK, nrK)
        
        if stat=="OK":
            stat,dump,dump,dump = self.PolSQL.Execute(Zapyt+UPDATEDD,1)  #AB 16.02.21r
            if stat<>'OK':
                rsglobal.ZapiszDoLogow(Zapyt+UPDATEDD)
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bdy przy modyfikowaniu danych :'+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
# KOPIOWANIE FAKTURY - 4
#-------------------------------------------------------------------------------

if Fun == 4 and stat == "OK":
    
    if not UprDodawanie:
        stat = 'UPR KOP'
        dane.append(stat)
    
    if stat=='OK':
        klucz = klucze[0]
        pola = klucze[1]
        wartosci = klucze[2]
    
        #Faktura bazowa
        WyznK = rsglobal.Dekoduj(klucz[1])
        DataK = rsglobal.Dekoduj(klucz[2])
        NrK = klucz[3]
        
        #Faktura nowa i ju sprawdzona pod wzgldem nieistnienia
        WyznN = rsglobal.Dekoduj(wartosci[1])
        DataN = rsglobal.Dekoduj(wartosci[2])
        NrN = str(wartosci[3])
        
        # sprawdzenie  unikalnoci numeru faktury w ramach odpowiedniego zakresu czasowego
        SQL="SELECT rsf_sprawdz_czy_unikalny_numer_dokumentu('"
        SQL+= self.firma_id+"','[\\\'"+WyznN+"\\\',\\\'"+DataN+"\\\',"+str(NrN)+"]','F');"
        stat,DaneNrF,dump,dump = self.PolSQL.Execute(SQL,3)            
        if stat<>'OK':
            stat='Bd sprawdzania unikalnoci numeru faktury :'+stat
        if DaneNrF[0][0]<>'OK':
            stat=DaneNrF[0][0]
    
        
    if stat == 'OK':
        #czy kopiowana faktura ma nieaktywnego kontrahenta
        sql ="SELECT kontrahent_id,zablokowany"
        sql+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND aktywny=TRUE"
        sql+=" AND kontrahent_id=("
        sql+=" SELECT kontrahent_id FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+WyznK+"' AND data='"+DataK+"' AND numer="+str(NrK)+");"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych kopiowanej faktury : '+stat
        else:
            if len(d) == 0:
                stat = 'BL KONTR KOP'
            elif d[0][1]:
                stat = 'BL ZABLOKOWANY'

    if stat=='OK':
        #zablokowanie, aby jej cos sie nie stalo
        #sprawdzenie czy faktura utworzona z paragonu
        #pobranie znacznika nie_podlega_vat
        sql = "SELECT z_paragonow, nie_podlega_vat"
        sql+=" FROM rs_faktury"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznK+"'"
        sql+=" AND data='"+DataK+"' AND numer="+str(NrK)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if d[0][0]:
                stat='Z PAR' #faktura z paragonu, nie kopiowac
            NiePodlegaVat = d[0][1]
        else:
             stat = 'Bdy przy spr. faktury z paragonu :'+stat
             dane.append(stat)
             
    if stat=='OK':    
        #sprawdzenie czy mona doda faktur z t dat
        stat,test,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+WyznN+"\\',\\'"+DataN+"\\']','F');",3)
        if stat<>'OK':
             stat = 'Bdy przy sprawdzaniu faktury :'+stat
             dane.append(stat)       
        else:    
            if test[0][0]<>'OK':    
                stat='NM DD' # nie mozna doda dokumentu
    
    if stat=='OK':    
        #sprawdzenie czy nie kopiujemy faktury zomu na zwyk lub odwrotnie
        SQL="SELECT DISTINCT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND wyznacznik_id IN ('"+WyznK+"','"+WyznN+"');"
        stat,DWyzn,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu typw faktur :'+stat
            dane.append(stat)       
        elif len(DWyzn)==2 and ['ZL'] in DWyzn:    
            stat=u'Nie mona kopiowa faktury zomowej na niezomow lub odwrotnie'
    if stat=='OK':
        CzyZlom=(['ZL'] in DWyzn)
          
        
    if stat=='OK':
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(WyznK)+"' AND data='"+str(DataK)+"' AND numer="+str(NrK)
        
        stat,dane,dump,dump=self.PolSQL.Execute("SELECT wersja FROM rs_faktury WHERE "+Filtr+";",3)
        if stat<>'OK':
             stat = 'Bdy przy pobieraniu wersji :'+stat
             dane.append(stat)
             
    if stat=='OK':
        wersja=dane[0][0]
        
        #pobranie nowych danych z danych do fakturowania kontrahenta (termin platnosci) dla nowej faktury
        SQLD= " SELECT COALESCE(dni,0), COALESCE(wersja,''), COALESCE(upust,0), COALESCE(spos_zaplaty,''), "
        SQLD+=" COALESCE(spos_dostawy,''), COALESCE(handlowiec,''), COALESCE(sposob_odbioru_faktury,''),osobny_rachunek_vat "
        SQLD+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+str(self.firma_id)+"' "
        SQLD+=" AND kontrahent_id=( SELECT kontrahent_id FROM rs_faktury WHERE firma_id='"+str(self.firma_id)+"' "
        SQLD+=" AND wyznacznik_id='"+WyznK+"' AND data='"+DataK+"' AND numer="+str(NrK)+") "
        SQLD+=" AND wyznacznik='"+WyznN+"' AND data_od=(SELECT data_od FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+str(self.firma_id)+"' "
        SQLD+=" AND kontrahent_id=( SELECT kontrahent_id FROM rs_faktury WHERE firma_id='"+str(self.firma_id)+"' "
        SQLD+=" AND wyznacznik_id='"+WyznK+"' AND data='"+DataK+"' AND numer="+str(NrK)+") AND data_od <='"+DataN+"' ORDER BY data_od DESC limit 1) ;"
        
        stat,DaneD,dump,dump=self.PolSQL.Execute(SQLD,3)
        if stat<>'OK':
            stat='Bdy przy pobieraniu danych fakt. dla kontrahenta: '+stat
            dane.append(stat)
        
    if stat=='OK':    
        #--- pobranie dat dostaw od i do
        SQL="SELECT COALESCE(dostawy_od_dnia::TEXT,''),COALESCE(dostawy_do_dnia::TEXT,''),"
        SQL+="DATE '"+DataK[:7]+"-01' + INTERVAL '1 MONTH'"
        SQL+=" FROM rs_faktury WHERE "+Filtr+";"
        stat,DaneFakt,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bdy przy pobieraniu danych starej faktury: '+stat
            dane.append(stat)

    if stat=='OK':
        #--- jeli obie daty wypenione i obejmuj zakresem cay miesic
        # to w nowej fakturze bdzie to zakres obejmujcy miesic z ktrego pochodzi skopiowana faktura
        DataDostOd=DaneFakt[0][0]
        DataDostDo=DaneFakt[0][1]
        if DataDostOd <> '' and DataDostDo <> '':
            if DataDostOd[-2:] == '01':
                SQL="SELECT (DATE '"+DataDostOd+"' + INTERVAL '1 MONTH' - INTERVAL '1 DAY')::DATE,"
                SQL+="(DATE '"+DataN[:7]+"-01' + INTERVAL '1 MONTH' - INTERVAL '1 DAY')::DATE"
                stat,DaneDat,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat == 'OK' and DataDostDo == DaneDat[0][0]:
                    DataDostOd=DataN[:7]+'-01'
                    DataDostDo=DaneDat[0][1]
            
            DataDostOd = "'"+DataDostOd+"'"
            DataDostDo = "'"+DataDostDo+"'"
        else:
            if DataDostOd == '':
                DataDostOd='NULL'
            else:
                DataDostOd = "'"+DataDostOd+"'"
            if DataDostDo == '':
                DataDostDo='NULL'
            else:
                DataDostDo = "'"+DataDostDo+"'"
            
    if stat=='OK':    
        #--- Wstawienie nagwka
        #WS 2020-04-16 - nieprzepisywanie upust_wartosc i upust_wartosc_wal - te pola zostan uzupenione przez trigger przy insercie pozycji
        SQLN = "INSERT INTO rs_faktury ("
        SQLN+="firma_id,wyznacznik_id,data,numer,oddzial_id,stan,kontrahent_id,zamawiajacy_id,platnik_id,"
        SQLN+="miejsce_dostawy_id,dostawy_od_dnia,dostawy_do_dnia,kierowca,projekt_id,waluta,kurs,nr_tabeli,"
        SQLN+="data_tabeli,zamowienie_nr,zamowienie_data,kraj_opodatkowania,nie_podlega_vat,wersja,"
        SQLN+="sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,"
        SQLN+="czy_bonus,opis,upust,rabat,rabat_wartosc,rabat_wartosc_wal,"
        SQLN+="kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,"
        SQLN+="wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,data_przychodu,osobny_rachunek_vat,ozn_trans,ozn_sprzedaz" #MK 2020-04-16
        SQLN+=") SELECT "
        SQLN+="'"+self.firma_id+"','"+WyznN+"','"+DataN+"',"+NrN+",'"+self.oddzial_id+"','W',kontrahent_id,zamawiajacy_id,platnik_id,"
        SQLN+="miejsce_dostawy_id,"+DataDostOd+","+DataDostDo+",kierowca,projekt_id,waluta,kurs,nr_tabeli,"
        SQLN+="data_tabeli,zamowienie_nr,zamowienie_data,kraj_opodatkowania,nie_podlega_vat,wersja,"
        SQLN+="sposob_zaplaty,dni,data_odbioru,date '"+DataK+"'+  CAST((date '"+DataN+"' - date '"+DataK+"') + dni AS INTEGER),handlowiec,sposob_odbioru_faktury,sposob_dostawy,"
        SQLN+="czy_bonus,opis,upust,rabat,rabat_wartosc,rabat_wartosc_wal,"
        SQLN+="kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,"
        SQLN+="wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,COALESCE("+DataDostDo+",'"+DataN+"')::DATE,osobny_rachunek_vat"

        #MK 2020-04-21 - poczatek

        #znajdujemy oznaczenia z wyznacznika nowej faktury
        sqlw = "SELECT ozn_trans,ozn_sprzedaz"
        sqlw += " FROM rs_wyznaczniki"
        sqlw += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id = '" + WyznN + "';"
        stat, dww, dump, dump = self.PolSQL.Execute(sqlw, 3)
        if stat <> 'OK':
            stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
            dane.append(stat)
        if dww != []:
            OznTransW = dww[0][0]
            OznSprzW = dww[0][1]

        #znajdujemy oznaczenia ze pierwotnej faktury
        sqlf = "SELECT ozn_trans,ozn_sprzedaz"
        sqlf += " FROM rs_faktury"
        sqlf += " WHERE "+Filtr+";"
        stat, dwk, dump, dump = self.PolSQL.Execute(sqlf, 3)
        if stat <> 'OK':
            stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
            dane.append(stat)
        if dwk != []:
            OznTrans = dwk[0][0]
            OznSprz = dwk[0][1]


        if OznTransW not in ('None', ''):            #jezeli mamy wartosc pola z wyznacznika docelowego to ja wstawiamy
            SQLN+= ",'" + str(OznTransW) + "'"
        elif OznTrans not in ('None', ''):           #jezeli nie mielismy wartosci pola z wyznacznika, ale mamy wartosc pola z faktury pierwotnej to ja wstawiamy
            SQLN+= ",'" + str(OznTrans) + "'"
        else:                                        #jezeli nie mielismy wartosci pola ani z wyznacznika docelowego, ani z faktury pierwotnej to wstawiamy NULL
            SQLN+=",NULL"

        if OznSprzW not in ('None', ''):            #jezeli mamy wartosc pola z wyznacznika docelowego to ja wstawiamy
            SQLN+= ",'" + str(OznSprzW) + "'"
        elif OznSprz not in ('None', ''):           #jezeli nie mielismy wartosci pola z wyznacznika, ale mamy wartosc pola z faktury pierwotnej to ja wstawiamy
            SQLN+= ",'" + str(OznSprz) + "'"
        else:                                       #jezeli nie mielismy wartosci pola ani z wyznacznika docelowego, ani z faktury pierwotnej to wstawiamy NULL
            SQLN+=",NULL"

        #MK 2020-04-21 - koniec

        SQLN+=" FROM rs_faktury WHERE "+Filtr+";"
        
        #--- Wstawienie pozycji
        SQLP = "INSERT INTO rs_faktury_pozycje ("
        SQLP+="firma_id,wyznacznik_id,data,numer,"
        SQLP+="nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,"
        SQLP+="cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
        SQLP+="upust,upust_wartosc,"
        
        #zapis dla zgodnosci kolejnosci pol z wartosciami
        SQLP+="stawka_vat,"
        
        SQLP+="wartosc_netto,wartosc_vat,wartosc_brutto,"
        SQLP+="nr_serii,termin_przyd,cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
        SQLP+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
        SQLP+="deklaracja_zgodnosci_przeznaczenie,deklaracja_zgodnosci_dokumenty,"
        SQLP+="deklaracja_zgodnosci_partia,deklaracja_zgodnosci_nr,cecha1_opis,cecha1_wartosc,kod_gtu"  #MK 2020-03-25
        SQLP+=") SELECT "
        SQLP+="'"+self.firma_id+"','"+WyznN+"','"+DataN+"',"+NrN+","
        SQLP+="fp.nr_poz,fp.nr_ppoz,fp.artykul_id,fp.ilosc1,fp.ilosc2,"
        SQLP+="fp.cena_netto1,fp.cena_netto2,fp.cena_upust1,fp.cena_upust2,fp.cena_brutto1,fp.cena_brutto2,"
        SQLP+="fp.upust,fp.upust_wartosc,"
        
        if NiePodlegaVat:
            SQLP+="'np',"
        elif CzyZlom:
            SQLP+="'oo',"
        else:
            SQLP+="rsf_podaj_vat_artykulu(a.firma_id,a.artykul_id,'"+DataN+"'),"
            
        SQLP+="fp.wartosc_netto,fp.wartosc_vat,fp.wartosc_brutto,"
        SQLP+="fp.nr_serii,fp.termin_przyd,fp.cena_wal1,fp.cena_wal2,fp.cena_upust_wal1,fp.cena_upust_wal2,"
        SQLP+="fp.wartosc_wal_netto,fp.wartosc_wal_vat,fp.wartosc_wal_brutto,"
        SQLP+="fp.deklaracja_zgodnosci_przeznaczenie,fp.deklaracja_zgodnosci_dokumenty,"
        SQLP+="fp.deklaracja_zgodnosci_partia,fp.deklaracja_zgodnosci_nr,fp.cecha1_opis,fp.cecha1_wartosc,a.kod_gtu"  #MK 2020-03-25
        SQLP+=" FROM rs_faktury_pozycje fp"
        SQLP+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        SQLP+=" WHERE "+Filtr+" ;"
        
        #--- Wstawienie pozycji opisowych
        SQLO = "INSERT INTO rs_faktury_pozycje_opisowe ("
        SQLO+="firma_id,wyznacznik_id,data,numer,"
        SQLO+="nr_poz,opis_pozycji,"
        
        #zapis dla zgodnosci kolejnosci pol z wartosciami
        SQLO+="stawka_vat,"
        
        SQLO+="wartosc_netto,wartosc_vat,wartosc_brutto,"
        SQLO+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,kod_gtu"  #MK 2020-03-25
        SQLO+=") SELECT "
        SQLO+="'"+self.firma_id+"','"+WyznN+"','"+DataN+"',"+NrN+","
        SQLO+="nr_poz,opis_pozycji,"
        
        if NiePodlegaVat:
            SQLO+="'np',"
        elif CzyZlom:
            SQLO+="'oo',"
        else:
            SQLO+="stawka_vat,"
            
        SQLO+="wartosc_netto,wartosc_vat,wartosc_brutto,"
        SQLO+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,kod_gtu" #MK 2020-03-25
        SQLO+=" FROM rs_faktury_pozycje_opisowe WHERE "+Filtr+";"

        #-------------------------------------------------------------------------------
        #--- Wstawienie informacji o udziaach handlowcw
        SQLH = "INSERT INTO rs_faktury_handlowcy ("
        SQLH+="firma_id,wyznacznik_id,data,numer,"
        SQLH+="handlowiec_id,udzial"
        SQLH+=") SELECT "
        SQLH+="'"+self.firma_id+"','"+WyznN+"','"+DataN+"',"+NrN+","
        SQLH+="handlowiec_id,udzial"
        SQLH+=" FROM rs_faktury_handlowcy WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQLN+SQLP+SQLO+SQLH,1)
        if stat <> "OK":
            stat="BL ZKOP" 

    if stat=='OK':
        #WS 2020-04-16 - dodanie stat =
        stat = fs_global_faktury.PobierzNaFaktureDaneDoFakturowaniaDlaKontrahenta(self,self.firma_id,WyznN,DataN,NrN)

    if stat=='OK':
        #WS 2020-04-16 - dodanie stat =
        stat = fs_global_faktury.PobierzCenyDoPozycji(self,self.firma_id,WyznN,DataN,NrN,0)
                
                
#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH DLA PARAGONU W STANIE W 
#-------------------------------------------------------------------------------

if Fun == 11:   
    Wyznacznik = klucze[0]
    Data = klucze[1]
    Numer = klucze[2]
    Odbiorca = klucze[3]    
    Select="SELECT * FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND "
    Select+="wyznacznik_id='"+str(Wyznacznik)+"' AND data='"+str(Data)+"' AND kontrahent_id='"+str(Odbiorca)+"' "
    Select+="AND numer='"+str(Numer)+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat='Bdy sprawdzania danych paragonu '+stat           
