# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_faktury_pliki.py
# Purpose:     Pobiera, dodaje, usuwa pliki binarne dla faktur
# Author:      Wojciech Skowron
# Created:     2023/01/25
# RCS-ID:      $Id: fs_faktury_pliki.py $
# Copyright:   (c) 2023 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

from funkcje import fs_pliki_global
import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Wyzn':[1,2,5,6], 'Data':[1,2,5,6], 'Nr':[1,2,5,6],
             'PlikId':[2,6], 'NazwaPliku':[1], 'TrescPliku':[1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_faktury_pliki z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    if Funkcja in [1,2,5,6]:
        Wyzn       = rsglobal.Dekoduj(klucze['Wyzn'])
        Data       = rsglobal.Dekoduj(klucze['Data'])
        Nr         = rsglobal.Dekoduj(klucze['Nr'])
    if Funkcja in [2,6]:
        PlikId     = rsglobal.Dekoduj(klucze['PlikId'])
    if Funkcja == 1:
        NazwaPliku = rsglobal.Dekoduj(klucze['NazwaPliku'])
        TrescPliku = rsglobal.Dekoduj(klucze['TrescPliku'])
        TypPliku   = rsglobal.Dekoduj(klucze['TypPliku'])

dane = []
LPlik = []

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

UprSel = ((self.oddzial_id,'022061') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns = ((self.oddzial_id,'022063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel = ((self.oddzial_id,'022064') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if stat == 'OK':
    SEL = """SELECT wyznacznik_id, data, numer 
             FROM rs_faktury 
             WHERE firma_id='{}' AND wyznacznik_id='{}' AND data='{}' AND numer={};
          """.format(self.firma_id, Wyzn, Data, Nr)

    stat,DTest,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzania poprawnoci faktury: '+stat
    else:
        if len(DTest) == 0:
            stat = 'BR_FAKT'

#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if not UprIns:
        stat = 'UPR_INS'

    if stat == 'OK' and TypPliku != '':
        SEL = """SELECT kod
                 FROM rs_typy_plikow_binarnych 
                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, TypPliku)

        stat,DTyp,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania typu pliku binarnego: '+stat
        else:
            if len(DTyp) == 0:
                stat = 'BL_TYP'

    if stat == 'OK':
        INS = """INSERT INTO rs_pliki (  firma_id,    nazwa,   tabela,           kompresja)
                               VALUES ('{firma_id}','{nazwa}','fs_faktury_pliki',FALSE    );"""
        INS = INS.format(firma_id = self.firma_id,
                         nazwa    = NazwaPliku)

        rsglobal.ZapiszDoLogow(INS,5)
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd wstawiania rekordu: '+stat

    if stat == 'OK':
        SEL = """SELECT max(plik_id) 
                 FROM rs_pliki 
                 WHERE firma_id='{}' AND tabela='fs_faktury_pliki';""".format(self.firma_id)

        stat,DNum,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania numeru nowego pliku: '+stat

    if stat == 'OK':
        NrPliku = DNum[0][0]
        stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)

    if stat == 'OK':
        INS = """INSERT INTO rs_faktury_pliki
                             (  firma_id,    wyznacznik_id,    data,   numer,  nr_pliku,   typ_pliku  )
                      VALUES ('{firma_id}','{wyznacznik_id}','{data}',{numer},{nr_pliku},'{typ_pliku}');"""
        INS = INS.format(firma_id      = self.firma_id,
                         wyznacznik_id = Wyzn,
                         data          = Data,
                         numer         = Nr,
                         nr_pliku      = NrPliku,
                         typ_pliku     = TypPliku)

        rsglobal.ZapiszDoLogow(INS,5)
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd dodawania rekordu o nowym pliku: '+stat

#-------------------------------------------------------------------------------
#---   POBRANIE/USUWANIE PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [2,6]:
    SEL = """SELECT nr_pliku 
             FROM rs_faktury_pliki 
             WHERE firma_id='{}' AND wyznacznik_id='{}' AND data='{}' AND numer={} AND plik_id={};
          """.format(self.firma_id, Wyzn, Data, Nr, PlikId)

    rsglobal.ZapiszDoLogow(SEL,5)
    stat,DNrPliku,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania numeru pliku: '+stat
    else:
        if len(DNrPliku) == 0:
            stat = """Brak pliku o numerze {} dla faktury {}/{}/{}""".format(PlikId, Wyzn, Data, rsglobal.UsunKropkaZero(Nr))

#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 2:
    if not UprSel:
        stat = 'UPR_SEL'
    else:
        stat,Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DNrPliku[0][0])
        dane = [Tresc]

#-------------------------------------------------------------------------------
#---   DELETE (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprDel:
        stat = 'UPR_DEL'
    else:
        stat = fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DNrPliku[0][0])

    if stat == 'OK':
        DEL = """DELETE FROM rs_faktury_pliki  WHERE plik_id={};""".format(PlikId)
        DEL+= """DELETE FROM rs_pliki          WHERE plik_id={};""".format(DNrPliku[0][0])

        rsglobal.ZapiszDoLogow(DEL,5)
        stat,dump,dump,dump = self.PolSQL.Execute(DEL,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd przy usuwaniu pliku: '+stat

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 - select, 6 - delete)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,5,6]:
    if not UprSel:
        stat = 'UPR_SEL'
    else:
        SEL = """SELECT f.plik_id, f.typ_pliku, '', p.nazwa 
                 FROM rs_faktury_pliki f 
                 JOIN rs_pliki p ON p.firma_id=f.firma_id  AND p.plik_id=f.nr_pliku AND p.tabela ='fs_faktury_pliki' 
                 WHERE f.firma_id='{}' AND wyznacznik_id='{}' AND data='{}' AND numer='{}';
              """.format(self.firma_id, Wyzn, Data, Nr)

        stat,dane,wyn1,tr = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd przy pobieraniu danych: '+stat
