# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_faktury_pozycje.py
# Purpose:     wczytuje/usuwa dane pozycji faktur
#
# Author:      Jakub Krajniak
# Created:     2006/11/29
# RCS-ID:      $Id: fs_faktury_pozycje.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#03.04.2009 - Dariusz Boduch - obsuga dla faktury z paragonu - mantis: 1945
# poprawa kodu - Pawe Wjcikowski 20.07.09r
# 2014-07-04 Micha Raburski (7926) - zestawy na fakturach

from funkcje import fs_zestawy_pom

Wyznacznik=rsglobal.Dekoduj(klucze[0])
Data=rsglobal.Dekoduj(klucze[1])
Numer=klucze[2]
ArtykulF=klucze[3]
CenaF=klucze[4]
NrPoz=klucze[5]
NrPPoz=klucze[6]
Pola=klucze[7]
klucze_id=klucze[8]
Funkcja=int(klucze[-1])

self.CzyZParagonu = False
stat = "OK"
dane = []
puste_pola = ['    -  -  ','',[]]
Filtr = " firma_id = '" + self.firma_id + "'"

UprDodawanie=(((self.oddzial_id,'022023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'022024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
# rozbicie pozycji z zestawem na skadniki
#-------------------------------------------------------------------------------

if Funkcja==14 and stat=='OK':
    if not UprDodawanie:
        stat="BL_UPR"   
        dane.append(stat)
    if stat == 'OK':
        stat = fs_zestawy_pom.RozbijZestawNaFakturze(self,Wyznacznik,Data,Numer,NrPoz)

#-------------------------------------------------------------------------------
# scalenie pozycji z zestawem rozbitym na skadniki
#-------------------------------------------------------------------------------

if Funkcja==15 and stat=='OK':
    if not UprDodawanie:
        stat="BL_UPR"   
        dane.append(stat)
    if stat == 'OK':
        stat = fs_zestawy_pom.ScalZestawNaFakturze(self,Wyznacznik,Data,Numer,NrPoz)


#-------------------------------------------------------------------------------
#Funkcja 17
#Sprawdzanie czy faktura utworzona z paragonu
#jesli tak, to nie zmieniac rabatow, upustow, wersji cenowych 
#-------------------------------------------------------------------------------

if Funkcja in [17,6] and stat=='OK':
    if Funkcja == 17:
        sql = "SELECT z_paragonow FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND "
        sql+= "wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
    if Funkcja == 6:
        sql = "SELECT z_paragonow FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND "
        sql+= "wyznacznik_id ='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer 
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(dane)>0:
        CzyZParagonu=rsglobal.Dekoduj(dane[0][0])
    else:
        stat="BL SQL PAR"
        dane.append(stat)
    self.CzyZParagonu = CzyZParagonu


#-------------------------------------------------------------------------------
#sprawdzenie czy mona dodawa podany wyznacznik (11)
#-------------------------------------------------------------------------------

if (Funkcja==11):
    if UprDodawanie:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','"
        sql +="[False,True,False,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprDodawanie=(Wyznacznik in LWyzn) and UprDodawanie       
    dane=[[str(UprDodawanie)]]


#-------------------------------------------------------------------------------
#           sprawdzenie waluty (9)
#-------------------------------------------------------------------------------

if Funkcja == 9:
    sql = "SELECT waluta FROM rs_faktury WHERE firma_id = '"+self.firma_id+"' AND"
    sql+= " wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)   


#-------------------------------------------------------------------------------
#           DELETE (6)
#-------------------------------------------------------------------------------

if (Funkcja ==6) and not self.CzyZParagonu:
    if not UprUsuwanie:
        stat="BL_UPR"   
        dane.append(stat)
        
    if stat=='OK':
        sql = "SELECT deklaracja_zgodnosci_nr,zestaw FROM rs_faktury_pozycje WHERE firma_id = '"+self.firma_id+"' AND"
        sql+= " wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        sql+= " AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPPoz+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)         
        if stat<>'OK':
            stat = 'Bdy pobierania numeru deklaracji zgodnoci:'+stat
            dane.append(stat)


    if stat=='OK':
        if d[0][1] and NrPPoz <> '0.0':
            stat='Nie mona usuwa pozycji zawierajcych skadniki rozbitego zestawu'
            dane.append(stat)
            
    if stat=='OK':
        Filtr = " firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND"
        Filtr+= " data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz
        sql = "DELETE FROM rs_faktury_pozycje WHERE"+Filtr+";"
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)  
        if stat!="OK":
            stat="BR_KAS_POZ"
            dane.append(stat)
        else:
            Filtr = " firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"' AND"
            Filtr+= " data='"+Data+"' AND numer="+Numer+" AND nr_poz>"+NrPoz
            sql = "UPDATE rs_faktury_pozycje SET nr_poz=nr_poz-1 WHERE"+Filtr+";"
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat != 'OK':
                stat="BL_SQL"
                dane.append(stat)
            elif int(d[0][0]) not in [0.0,0]:
                Filtr = " firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"' AND"
                Filtr+= " data='"+Data+"' AND numer="+Numer+" AND deklaracja_zgodnosci_nr>"+str(d[0][0])
                sql = "UPDATE rs_faktury_pozycje SET deklaracja_zgodnosci_nr=deklaracja_zgodnosci_nr-1 WHERE"+Filtr+";"
                stat,dump,dump,dump=self.PolSQL.Execute(sql,1)                           
    
    
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if (Funkcja in [3,5,6]) and stat=='OK':
    Filtr = "(fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyznacznik+"' "
    Filtr+= "AND fp.data='"+Data+"' AND fp.numer="+Numer+" "
    if ArtykulF not in puste_pola:
        Filtr += "AND fp.artykul_id LIKE '"+ArtykulF+"%'"
    if CenaF not in puste_pola and CenaF <> '0.0':
        Filtr += "AND (fp.cena_netto1 ="+CenaF+") "
    Filtr +=")"
    
    if klucze_id not in puste_pola:
        Filtr +=" OR ((fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyznacznik+"'"
        Filtr +=" AND fp.data='"+Data+"' AND fp.numer="+Numer+") AND ("
        Pierwszy = True
        for klucz in klucze_id:
            if not Pierwszy:
                Filtr += " OR "
            else:
                Pierwszy = False
            Filtr += "(fp.nr_poz="+klucz[0]+" AND fp.nr_ppoz="+klucz[1]+")"
        Filtr +='))'
    sql = "SELECT " + ",".join(Pola) + " FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly art"
    sql+= " ON fp.firma_id = art.firma_id AND fp.artykul_id = art.artykul_id WHERE "+Filtr+" "
    sql+= "ORDER BY fp.nr_poz,fp.nr_ppoz;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat="BL_SQL"
        dane.append(stat)