# -*- coding: iso8859_2 -*-
#
#-------------------------------------------------------------------------------
# Name:        fs_faktury_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji faktury
# Author:      Micha Raburski
# Created:     2006/12/27
# RCS-ID:      $Id:$
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#
# 2009-04-03 - Dariusz Boduch      - (1945) obsuga dla faktury z paragonu
# 2009-07-20 - Pawe Wjcikowski   - (    ) poprawa kodu
# 2009-09-22 - Pawe Wjcikowski   - (2337) dodanie do update'w pl deklaracji zgodnosci z artyk.
#
# 2010-11-25 - Mariusz Rajfura     - (4096) edytowalna stawka VAT, kontrola zgodnosci
#                                          z terminem obowiazywania (tylko ostrzezenie)
# 2011-08-15 - Mariusz Rajfura     - (4881) kontrola braku jakiejkolwiek stawki VAT
# 2011-11-09 - Mariusz Rajfura     - (5077) kontrola stanu przed zapisem
# 2014-02-06 - Konrad Opieka       - (7646) dodanie cech
# 2014-07-10 - Micha Raburski     - (7926) refaktoryzacja okna przy okazji zestaww i przyspieszenia
# 2020-03-20 - Mikoaj Kozowski   - (11906) obsuga pola 'kod GTU'
# 2020-04-15 - Wojciech Skowron    - (11931) blokada dodawania artykuw z "tylko_detal"
# 2023-09-20 - Aleksaqnder Bargie - (13174) Sprzeda - Dodanie do faktury pozycji dla artykuu z cech
# 2023-10-04 - Aleksaqnder Bargie - (13573) Bd dodawania pozycji faktury na nowym postgresie
#-------------------------------------------------------------------------------

# funkcje :
# 21 - pobranie upustu,waluty z nagwka i uprawnienia do wstawiania danych dla wyznacznika
# 10 - pobranie kolejnego numeru z pozycji
# 11 - sprawdzenie przelicznika i jm i innych rzeczy
# 1,2,3,4 - update i insert
# 3,4 - dodatkowa cz z przenumerowaniem deklaracji zgodnoci
# 5 - pobranie danych

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

Pola=pola
Wartosci=wartosci

#w celach informacyjno rozeznaniowych
puste_pola = [[],"","    -  -  "]
dzprzeznaczenie=''
dzdokumenty=''
dzpartia=''
dznumer=0
starynumer=0
Modyfikacja=False
StawkaVAT = None
StawkaVATPozaTerminem = False

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[1,2,3,4,5,10,11,21],'Data':[1,2,3,4,5,10,11,21],
           'Numer':[1,2,3,4,5,10,11,21],'Poz':[1,2,3,4,5],'Ppoz':[1,2,3,4,5],
           'Artykul':[11]}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_faktury_pozycje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

    if Fun in [1,2,3,4,5,10,11,21]: 
        Wyznacznik = rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = klucze['Numer']
        
    if Fun in [1,2,3,4,5]: 
        Poz=klucze['Poz']
        Ppoz=klucze['Ppoz']

    if Fun == 11:
        Artykul = klucze['Artykul']


if self.operator_id != STANDARD_OPERATOR_ID:
    UprDodawanie = ((self.oddzial_id,'022023') in self.uprawnienia)
    UprEdycja = ((self.oddzial_id,'022022') in self.uprawnienia) or UprDodawanie
    
    if UprEdycja:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','"  #AB 2023-10-04
        sql+= "[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprEdycja=(Wyznacznik in LWyzn)
            UprDodawanie=(Wyznacznik in LWyzn) and UprDodawanie
else:
    UprEdycja = UprDodawanie = True

UprStawkaVAT = ((self.oddzial_id,'022027') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

    
#-------------------------------------------------------------------------------
# (21) sprawdzanie danych nagwka faktury i uprawnie do wyznacznika
#      Sprawdzanie czy faktura utworzona z paragonu
#      jesli tak, to nie zmieniac rabatow, upustow, wersji cenowych 
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4,21] and stat=='OK': 
    dane=[]
    sql = "SELECT waluta,kurs,upust,COALESCE(wersja,''),"+str(UprDodawanie)+",z_paragonow, data_przychodu, " \
          "nie_podlega_vat,FALSE,COALESCE(kontrahent_id,'') FROM rs_faktury WHERE firma_id='"+str(self.firma_id)+"' " \
          "AND wyznacznik_id = '"+str(Wyznacznik)+"' AND data = '"+str(Data)+"' AND numer = "+str(Numer)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    
    if stat<>'OK':
        stat=u'Bd pobierania danych z nagwka faktury:'+stat
    if stat=='OK':
        if len(dane)==0:
            stat = 'Podano nieprawidowe parametry faktury'
    if stat=='OK':
        CzyZParagonu = rsglobal.Dekoduj(dane[0][5])
        DataSprzedazy = rsglobal.Dekoduj(dane[0][6])
        Kontr = rsglobal.Dekoduj(dane[0][9])
        if DataSprzedazy in ('None',''):
            DataSprzedazy = Data

        # sprawdzenie czy faktura zomowa
        SQL = "SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
        stat,DWyzn,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        CzyZlom=(DWyzn[0][0]=='ZL')
        dane[0].append(CzyZlom)


#-------------------------------------------------------------------------------
#   sprawdzanie  nr_poz (10)
#-------------------------------------------------------------------------------

if (Fun == 10) and stat=='OK': # warunek
    dane=[]
    sql = "SELECT nr_poz FROM rs_faktury_pozycje WHERE firma_id = '"+self.firma_id+"' "
    sql+= "AND wyznacznik_id='"+Wyznacznik+"' AND data = '"+Data+"' AND numer="+str(Numer)+" "
    sql+= "ORDER BY nr_poz DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    
    if stat<>'OK':
        stat=u'Bd pobierania najwikszego numeru pozycji :'+stat
        dane.append(stat)
    if len(dane)==0:
        dane = 1
    else:
        dane = int(dane[0][0]) + 1

#-------------------------------------------------------------------------------
#    sprawdzanie danych artykuu (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    from funkcje import fs_artykuly_pom
    stat, dane = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self,Artykul,Wyznacznik,Data,Numer,'','','',0,'rs_faktury',False)

    
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if UprEdycja:
    if Fun in [1,2,3,4] and stat=='OK':
        # usuwam poprzednie wyniki - zaklocalo dzialanie RSEditF
        dane = []

        # kontrola stanu
        sql ="SELECT stan FROM rs_faktury"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia stanu faktury: '+stat
        elif len(d) == 0:
            stat = 'Brak faktury o podanym kluczu.'
        elif d[0][0] != 'W':
            stat = 'Faktura w stanie '+d[0][0]+'. Zapis zmian niemoliwy.'

        if stat != 'OK':
            dane.append(stat)

        if stat=='OK':
            if Data not in puste_pola:
                dane_wyn = rsglobal.SprawdzCzyToData(Data)   
                if not dane_wyn:
                    stat = "BL KLUCZ"
                else:
                    sql="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+self.oddzial_id+"','"+Data+"',1);"
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                    if dane_wyn != 1:
                        stat="ZK DATA"
                        dane_wyn.append(stat)
                Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
                Filtr+= "AND data='"+Data+"' AND numer="+str(Numer)
                sql="SELECT wyznacznik_id FROM rs_faktury WHERE "+Filtr+";"
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                if len(dane_wyn) == 0:
                    stat = "BL KLUCZ"
                    dane.append(stat)
            else:
                stat = "BL KLUCZ"
                dane.append(stat)
        
        if stat == "OK":
            dane = []
            NrPoz = Poz
            i = 0
            art_id = None
            StaraIlosc1 = -1
            StaraIlosc2 = -1
            NowaIlosc1 = -1
            NowaIlosc2 = -1
            
            # pobieramy dane pomocnicze z pozycji faktury
            if Fun in [3,4]:
                SQL = "SELECT fp.artykul_id,a.jm_kalk,fp.ilosc1,fp.ilosc2 FROM rs_faktury_pozycje fp "
                SQL+= " INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                SQL+= " WHERE firma_id='"+self.firma_id+"' "
                SQL+= " AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" "
                SQL+= " AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)+";"
                stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat != 'OK':
                    stat = "Bd pobierania danych artykuu z pozycji faktury"
                    dane.append(stat)
                elif Dane in puste_pola:
                    stat = "BL ART"
                    dane.append(stat)
                else:
                    if 'artykul_id' not in Pola and ('nr_serii' in Pola or 'termin_przyd' in Pola or 'cecha1_opis' in Pola or 'cecha1_wartosc' in Pola):
                        art_id = Dane[0][0]
                    
                    JmKalk = Dane[0][1]
                    StaraIlosc1 = Dane[0][2]
                    StaraIlosc2 = Dane[0][3]
            
            # pobranie informacji o cechach (dla update)
            CechaArt=''
            Cecha=''
            CechaWart=''
            if Fun in [3,4]:
                SQL = "SELECT TRIM(COALESCE(a.cecha1_opis,'')),TRIM(COALESCE(dp.cecha1_opis,'')),"
                SQL+=" TRIM(COALESCE(dp.cecha1_wartosc,''))"
                SQL+= " FROM rs_faktury_pozycje dp LEFT OUTER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                SQL+= " WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
                SQL+= " AND wyznacznik_id='"+Wyznacznik+"' AND numer='"+Numer+"'"
                SQL+= " AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)+";" 
                stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat != 'OK':
                    stat = "Bd pobierania danych artykuu z pozycji faktury"
                    dane.append(stat)
                else:
                    CechaArt=Dane[0][0]
                    Cecha=Dane[0][1]
                    CechaWart=Dane[0][2]
            
            if stat=='OK':    
                for pole in Pola:
                    wart = Wartosci[i]
                    if pole == 'artykul_id':
                        if wart == '':
                            stat = "BR ART"
                            dane.append(stat)
                        #WS 2020-04-15 - pobranie tylko_detal
                        sql = "SELECT artykul_id,jm_kalk,tylko_detal FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                        sql+= "AND artykul_id = '"+wart+"';"
                        stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                        if stat<>'OK':
                            stat = 'Bdy pobierania artykuu:'+stat
                            dane.append(stat) 
                        elif Dane == []:
                            stat = "BL ART"
                            dane.append(stat)
                        #WS 2020-04-15
                        elif Dane[0][2]:
                            art_id = wart
                            stat = "BL ART TYLKO_DETAL"
                            dane.append(stat)
                        else:
                            art_id = wart   
                            JmKalk = Dane[0][1]
                                                
                            sql = "SELECT deklaracja_zgodnosci_przeznaczenie,deklaracja_zgodnosci_dokumenty"
                            sql+= ",deklaracja_zgodnosci_partia,TRIM(COALESCE(cecha1_opis,'')) FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                            sql+= "AND artykul_id = '"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
                            if stat<>'OK':
                                stat = 'Bdy sprawdzania artykuu:'+stat
                                dane.append(stat)     
                            else:
                                dzprzeznaczenie=str(d[0][0]).replace("'", "`").replace("\\", "/")  #AB 2023-09-20
                                dzdokumenty=str(d[0][1]).replace("'", "`").replace("\\", "/")  #AB 2023-09-20
                                dzpartia=str(d[0][2]).replace("'", "`").replace("\\", "/")  #AB 2023-09-20
                                CechaArt=str(d[0][3]).replace("'", "`").replace("\\", "/")  #AB 2023-09-20
                                if Fun in [1,2]:
                                    if dzprzeznaczenie=='' and dzdokumenty=='' and dzpartia=='':
                                        dznumer=0
                                    else:
                                        sql = "SELECT deklaracja_zgodnosci_nr FROM rs_faktury_pozycje WHERE "
                                        sql+= "firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+str(Wyznacznik)+"' "
                                        sql+= "AND data='"+Data+"' AND numer='"+str(Numer)+"' ORDER BY deklaracja_zgodnosci_nr DESC LIMIT 1 ;"
                                        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
                                        if stat<>'OK':
                                            stat = 'Bdy pobierania numeru:'+stat
                                            dane.append(stat)
                                        elif len(d)==0 or int(d[0][0]) in [0.0,0]:
                                            dznumer=1  
                                        else:
                                            dznumer=int(str(d[0][0])[0:-2])+1
                                if Fun in [3,4]:
                                    sql = "SELECT deklaracja_zgodnosci_nr FROM rs_faktury_pozycje WHERE "
                                    sql+= "firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+str(Wyznacznik)+"' "
                                    sql+= "AND data='"+Data+"' AND numer='"+str(Numer)+"' "
                                    sql+= "AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)+";"
                                    stat,starynumer,dump,dump = self.PolSQL.Execute(sql ,3)                               
                                    if stat<>'OK':
                                        stat = 'Bdy w pobieraniu numeru:'+stat
                                        dane.append(stat)
                                    else:
                                        if dzprzeznaczenie=='' and dzdokumenty=='' and dzpartia=='':
                                            dznumer=0
                                            if len(starynumer)<>0 or int(starynumer[0][0]) not in [0.0,0]:
                                                Modyfikacja=True    
                                        else: 
                                            if len(starynumer)==0 or int(starynumer[0][0]) in [0.0,0]:                                           
                                                sql = "SELECT deklaracja_zgodnosci_nr FROM rs_faktury_pozycje WHERE "
                                                sql+= "firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+str(Wyznacznik)+"' "
                                                sql+= "AND data='"+Data+"' AND numer='"+str(Numer)+"' ORDER BY deklaracja_zgodnosci_nr DESC LIMIT 1 ;"
                                                stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
                                                if stat<>'OK':
                                                    stat = 'Bdy pobierania numeru:'+stat
                                                    dane.append(stat)
                                                else:
                                                    if len(starynumer)==0 or int(starynumer[0][0]) in [0.0,0]:
                                                        dznumer=int(str(d[0][0])[0:-2])+1
                                            else:
                                                dznumer=int(str(starynumer[0][0])[0:-2])
    
                    elif pole == 'cecha1_opis':
                        Cecha = wart.strip()                   
                    elif pole == 'cecha1_wartosc':
                        CechaWart = wart.strip()           
                    elif pole == 'ilosc1':
                        NowaIlosc1 = wart
                        if wart == 0:
                            stat = "BL ILOSCART1"
                            dane.append(stat)
                    elif pole == 'ilosc2':
                        NowaIlosc2 = wart
                        if wart == 0:
                            stat = "BL ILOSCART2"
                            dane.append(stat)
                    elif pole == 'cena_netto1':
                        if wart <= 0:
                            stat = "BL CENANETTO1"
                            dane.append(stat)
                    elif pole == 'cena_netto2':
                        if wart <= 0:
                            stat = "BL CENANETTO2"
                            dane.append(stat)
                    elif pole == 'cena_brutto1':
                        if wart <= 0:
                            stat = "BL CENABRUTTO1"
                            dane.append(stat)
                    elif pole == 'cena_brutto2':
                        if wart <= 0:
                            stat = "BL CENABRUTTO2"
                            dane.append(stat)
                    elif pole == 'nr_serii':
                        sql = "SELECT czy_seria FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                        sql+= "AND artykul_id = '"+str(art_id)+"';"
                        dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                        if Dane == []:
                            stat = "BR ART"
                            dane.append(stat)
                        if Dane[0][0] and wart in puste_pola: #czy seria
                            stat = "BR SERIA"
                            dane.append(stat)
                    elif pole == 'termin_przyd':
                        sql = "SELECT czy_termin FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                        sql+= "AND artykul_id = '"+str(art_id)+"';"
                        dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                        if Dane == []:
                            stat = "BR ART"
                            dane.append(stat)
    
                        if wart in puste_pola:
                            if Dane[0][0]: #czy termin
                                stat = "BR TERMIN"
                                dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = "BL TERMIN"
                            dane.append(stat)
                            
                    elif pole == 'stawka_vat':
                        wart = rsglobal.Dekoduj(wart).strip()
                        StawkaVAT = wart
                        if wart == '':
                            stat = 'BR STAWKA_VAT'
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_stawki_vat WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'Bd sprawdzenia stawki VAT: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL STAWKA_VAT'
                                dane.append(stat)
                            
                        if stat == 'OK':
                            sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                            sql+=" WHERE stawka_vat='"+wart+"'"
                            sql+=" AND '"+DataSprzedazy+"'>=od_dnia"
                            sql+=" AND CASE WHEN do_dnia IS NULL"
                            sql+=" THEN TRUE ELSE '"+DataSprzedazy+"'<=do_dnia END;"
                            
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                #informacja zwrotna, ze podana stawka VAT nie zgadza sie
                                #z terminem jej obowiazywania
                                StawkaVATPozaTerminem = True
                            
                    i= i+1
            
            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]
                    
            if stat == 'OK' and StawkaVAT != None:
                if Fun in [3,4] and not UprStawkaVAT:
                    stat = 'BR UPR STAWKA_VAT'
                    dane.append(stat)
            
            # sprawdzenie spjnoci informacji o cechach
            if stat == 'OK' :
                # jeli opis cechy pozycji inny ni artykuu
                if Cecha != CechaArt:
                    stat = 'BL CECHA'
                    dane.append(stat)
                else:
                    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','poprawna')"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia wartoci cechy: '+stat
                    else:
                        Wynik=eval(d[0][0])
                        if not Wynik[0]:
                            stat = Wynik[1]
                            dane.append(stat)
                
            if stat == 'OK':
                #jesli dodawanie lub edycja pozycji 
                #to nalezy sprawdzic, czy podana stawka jest zgodna ze stawk
                #obowizujaca dla artykulu z odpowiedniej daty sprzedazy
                if art_id == None or StawkaVAT == None:
                    # pobranie brakujacych wartosci
                    sql ="SELECT artykul_id, stawka_vat FROM rs_faktury_pozycje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' "
                    sql+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                    sql+=" AND numer="+Numer+" AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)+";"
                    
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd pobrania artykuu z pozycji faktury: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'Brak podane pozycji na fakturze'
                        dane.append(stat)
                    else:
                        if art_id == None:
                            art_id = rsglobal.Dekoduj(d[0][0])
                        if StawkaVAT == None:
                            StawkaVAT = rsglobal.Dekoduj(d[0][1])
                        
            if stat == 'OK':
                sql ="SELECT stawka_vat FROM rs_artykuly_stawki_vat"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+art_id+"'"
                sql+=" AND od_dnia<='"+DataSprzedazy+"' ORDER BY od_dnia DESC LIMIT 1;"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia stawki VAT dla artykuu z podan dat sprzeday: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BR BIEZ STAWKA_VAT ART'
                    dane.append(stat)
                elif StawkaVAT != rsglobal.Dekoduj(d[0][0]):
                    if not UprStawkaVAT:
                        stat = 'BL STAWKA_VAT ZM'
                        dane.append(stat)

              
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

    if stat == "OK" and Fun in [2,1] and not CzyZParagonu:
        sql="UPDATE rs_faktury_pozycje SET nr_ppoz=nr_ppoz+100 "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND "
        sql+= "data='"+Data+"' AND numer="+Numer+" AND nr_poz>="+str(NrPoz)+";"
        sql+="UPDATE rs_faktury_pozycje SET nr_poz=nr_poz+1,nr_ppoz=nr_ppoz-100 "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND "
        sql+= "data='"+Data+"' AND numer="+Numer+" AND nr_poz>="+str(NrPoz)+";"             
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat!="OK":
            stat=u"Bd przy numerowaniu pozycji : "+stat   
            dane.append(stat)
            
        sql = "INSERT INTO rs_faktury_pozycje"
        PolaN="firma_id,wyznacznik_id,data,numer"
        WartosciN = "'"+self.firma_id+"','"+Wyznacznik+"','"+Data+"','"+Numer+"'"

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id']:
                PolaN+=",deklaracja_zgodnosci_przeznaczenie,deklaracja_zgodnosci_dokumenty,"
                PolaN+="deklaracja_zgodnosci_partia,deklaracja_zgodnosci_nr"
                WartosciN+=",'"+str(dzprzeznaczenie).replace("'", "`").replace("\\", "/")+"','"\
                           +str(dzdokumenty).replace("'", "`").replace("\\", "/")+"','"\
                           +str(dzpartia).replace("'", "`").replace("\\", "/")+"',"\
                           +str(dznumer).replace("'", "`").replace("\\", "/")+""
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['nr_serii','stawka_vat','cecha1_opis','cecha1_wartosc']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['kod_gtu']: #MK 2020-03-26
                PolaN += "," + pole
                if wart not in ['',None]:
                    WartosciN += ",'" + str(wart) + "'"
                else:
                    WartosciN += ",NULL"
            elif pole in ['termin_przyd']:
                PolaN += ","+pole
                if wart=='    -  -  ':
                    WartosciN += ",NULL"
                else:
                    WartosciN += ",'"+str(wart)+"'"
            else:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                Poz = wart
            elif pole == "nr_ppoz":
                Ppoz == wart
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"        
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat!="OK":
            stat=u"Bd przy dodawaniu pozycji : "+stat   
            dane.append(stat)
            
            
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

    if stat == "OK" and Fun in [3,4] and not CzyZParagonu:
        dane = []        
        sql = "UPDATE rs_faktury_pozycje SET "
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND "
        Filtr+= "data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ['artykul_id']:
                sql += 'deklaracja_zgodnosci_przeznaczenie'"='"+str(dzprzeznaczenie).replace("'", "`").replace("\\", "/")+"',"
                sql += 'deklaracja_zgodnosci_dokumenty'"='"+str(dzdokumenty).replace("'", "`").replace("\\", "/")+"',"
                sql += 'deklaracja_zgodnosci_partia'"='"+str(dzpartia).replace("'", "`").replace("\\", "/")+"',"
                sql += 'deklaracja_zgodnosci_nr'"="+str(dznumer).replace("'", "`").replace("\\", "/")+","
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['nr_serii','stawka_vat','cecha1_opis','cecha1_wartosc']:
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['kod_gtu']: #MK 2020-03-26
                Pola += "," + pole
                if wart not in ['',None]:
                    sql += pole+"='"+str(wart)+"',"
                else:
                    sql += pole+"=NULL,"
            elif pole in ['termin_przyd']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"
            elif wart == "NULL":
                sql += pole+"="+str(wart)+","
            else:
                sql += pole+"="+str(wart)+","
            if pole == "nr_poz":
                Poz = wart
            elif pole == "nr_ppoz":
                Ppoz == wart
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"        
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL_SQL'
            dane.append(stat)
        
        # jeli zmiana iloci zestawu to przeliczamy ilo na podzestawach
        if  stat == 'OK' and Ppoz == 0 and NowaIlosc1 != -1: 
            from funkcje import fs_zestawy_pom
            rsglobal.ZapiszDoLogow('S '+str(StaraIlosc1)+',N '+str(NowaIlosc1),1)
            if JmKalk == '1':
                stat = fs_zestawy_pom.PrzeliczZestawNaFakturze(self,Wyznacznik,Data,Numer,Poz,StaraIlosc1,NowaIlosc1)
            else:
                stat = fs_zestawy_pom.PrzeliczZestawNaFakturze(self,Wyznacznik,Data,Numer,Poz,StaraIlosc2,NowaIlosc2)

        rsglobal.ZapiszDoLogow('STAT '+stat,1)
        
#-------------------------------------------------------------------------------
#---   PRZENUMEROWANIE DEKL ZGODNOSCI PRZY UPDACIE (3,4)
#-------------------------------------------------------------------------------

if Fun in [3,4] and Modyfikacja and stat=='OK':
    Filtr = " firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"' AND"
    Filtr+= " data='"+Data+"' AND numer="+Numer+" AND deklaracja_zgodnosci_nr>"+str(starynumer[0][0])
    sql = "UPDATE rs_faktury_pozycje SET deklaracja_zgodnosci_nr=deklaracja_zgodnosci_nr-1 WHERE"+Filtr+";"
    stat,dump,dump,dump=self.PolSQL.Execute(sql,1)

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY ARTYKU MOE BY UYTY W ZWIZKU Z GRUPAMI ODBIORCW (1,2,3,4)
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat=='OK':
    Art = "(SELECT artykul_id FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"' " \
          " AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)+" )"
    SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+Kontr+"',"+Art+",'"+Data+"')"
    stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = u'Bd sprawdzania moliwoci wykorzystania artykuu ze wzgldu na grupy odbiorcw: '+stat
    if stat == 'OK':
        if DArt[0][0] != 'OK':
            stat = DArt[0][0]

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [1,3,5]:
    dane = []
    where= "WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
    where+="AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
    if Ppoz not in puste_pola:
        where += " AND nr_ppoz="+str(Ppoz)
    sql = "SELECT * FROM rs_faktury_pozycje "+where+";"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    tr = rssql.RSTableRowset(dane,wyn1) 

    # pobranie uprawnie
    wyn2.append(str(UprDodawanie))    
    wyn2.append(str(UprEdycja)) 
    
    #informacja o zgodnosci stawki VAT tylko w wypadku zapisu
    wyn2.append(Fun in [1,2,3,4] and StawkaVATPozaTerminem)
    
    # pobranie danych dodatkowych artykuu
    from funkcje import fs_artykuly_pom
    stat, DaneArtPom = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self,tr.GetVal(0,"artykul_id"),Wyznacznik,Data,Numer,'','','',0,'rs_faktury',False)

    wyn2.append(DaneArtPom)
    
    # sprawdzenie czy jest to pozycja zwyka, nagwek rozbitego zestawu czy pozycja zestawu
    if not tr.GetVal(0,"zestaw"):
        # zwyka pozycja
        wyn2.append(0)
    elif Ppoz > 0:
        # podpozycja zestawu
        wyn2.append(2)
    else:  
        # nagwek zestawu
        wyn2.append(1)

    if ((self.oddzial_id, '211421') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):  #MK 2020-03-31
        sql = "SELECT nazwa FROM rs_kody_towarow_uslug WHERE kod = '" +DaneArtPom[23]+ "' "
        st, o, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if len(o) == 0:
                wyn2.append('')
            else:
                wyn2.append(o[0][0])
        else:
            wyn2.append('Bd sprawdzania sownika towarw usug.')
    else:
        wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')