# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_faktury_pozycje_opisowe_dane.py
# Purpose:     wczytuje/edytuje dane pozycji faktury
#
# Author:      Marcin Grzda
# Created:     2006/12/10
# RCS-ID:      $Id: fs_faktury_pozycje_opisowe_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#
# 2009-04-03 - Dariusz Boduch  - (1945) obsuga dla faktury z paragonu
# 2010-11-25 - Mariusz Rajfura - (4096) kontrola zgodnosci stawki vat z terminem
#                                       obowiazywania (tylko ostrzezenie)
# 2011-11-09 - Mariusz Rajfura - (4096) kontrola stanu przed zapisem
# 2013-12-19 - Konrad Opieka   - (4312) Refaktoryzacja
# 2020-03-24 - Mikoaj Kozowski - (11906) Obsuga pola 'kod_gtu'
#-------------------------------------------------------------------------------

StawkaVATPozaTerminem=False

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[1,2,3,4,5,10,11],'Data':[1,2,3,4,5,10,11],'Numer':[1,2,3,4,5,10,11],'NrPoz':[1,2,3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_faktury_pozycje_opisowe_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2,3,4,5,10,11]:
        Wyznacznik=rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Numer=str(klucze['Numer'])
    if Fun in [1,2,3,4,5]:
        NrPoz=str(klucze['NrPoz'])

#-------------------------------------------------------------------------------
#-- Sprawdzanie uprawnie
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [1,2,3,4,5,10,]:
    UprIns = (((self.oddzial_id,'022033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprUpd = (((self.oddzial_id,'022032') in self.uprawnienia) or UprIns or (self.operator_id == STANDARD_OPERATOR_ID))

    if UprUpd:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprUpd=(Wyznacznik in LWyzn)
            UprIns=(Wyznacznik in LWyzn) and UprIns


#-------------------------------------------------------------------------------
# Pobranie rnych danych faktury (10)
#-------------------------------------------------------------------------------

if Fun in [10]:
    SQL="SELECT kraj_opodatkowania,nie_podlega_vat FROM rs_faktury WHERE firma_id='"+self.firma_id+"' "
    SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" ;"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        SQL="SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
        stat,DWyzn,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='BL SQL KRAJ'
            dane.append(stat)
        elif len(DWyzn)==0:
            stat="Brak wyznacznika "+Wyznacznik
        else:
            dane.append(DWyzn[0][0]=='ZL')

#-------------------------------------------------------------------------------
# Pobranie numeru pozycji (11)
#-------------------------------------------------------------------------------
        
if  stat=='OK' and Fun in [11,]:
    SQL='SELECT max(nr_poz)+1 from rs_faktury_pozycje_opisowe WHERE '
    SQL+="firma_id= '"+self.firma_id+"' AND wyznacznik_id= '"+Wyznacznik+"' AND data= '"+Data+"' AND numer= "+str(Numer)
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if dane[0][0]==0:
            dane[0][0]=1
    else:
        stat='BL POB NR POZ'
        dane.append(stat)

#-------------------------------------------------------------------------------
#Sprawdzanie czy faktura utworzona z paragonu (17)
#-------------------------------------------------------------------------------

if Fun in [17,1,2,3,4] and stat=='OK':
    sql = "SELECT z_paragonow, data_przychodu FROM rs_faktury"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,danep,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(danep)>0:
        CzyZParagonu = rsglobal.Dekoduj(danep[0][0])
        DataSprzedazy = rsglobal.Dekoduj(danep[0][1])
    else:
        stat="BL SQL PAR"
        dane.append(stat)
    self.CzyZParagonu = CzyZParagonu
                 
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (1,2 - insert; 3,4 update)
#-------------------------------------------------------------------------------

NrPozycji= -1

if Fun in [1,2] and UprIns==False:
    stat='UPR INS'
    dane.append(stat)
if Fun in [3,4] and UprUpd==False:
    stat='UPR UPD'
    dane.append(stat)

if Fun in (1,2,3,4) and stat=='OK':
    # kontrola stanu
    sql ="SELECT stan FROM rs_faktury"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu faktury: '+stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak faktury o podanym kluczu.'
        dane.append(stat)
    elif d[0][0] <> 'W':
        stat = 'Faktura w stanie '+d[0][0]+'. Zapis zmian niemoliwy.'
        dane.append(stat)

if Fun in (1,2,3,4) and stat=="OK":
    StVAT=None
    Kwota=None
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole=='nr_poz':
            if wart < 1:
                dane.append('BL NR POZ')
            else:
                SQL="SELECT nr_poz FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
                SQL+="AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(wart)+";"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat=u'Bdy sprawdzania numeracji pozycji'
                    dane.append(stat)
                elif len(d)<>0:
                    dane.append('NR POZ ISTN')
                else:
                    NrPozycji=wart

        elif pole == 'stawka_vat':
            wart = rsglobal.Dekoduj(wart).strip()
            StVAT = wart
            if wart == '':
                wartosci[i]='NULL'
            else:
                SQL = "SELECT kod FROM rs_stawki_vat WHERE kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)

                if stat <> 'OK':
                    stat = 'Bd sprawdzenia stawki VAT: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    dane.append('BL VAT')

                if stat == 'OK':
                    SQL ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                    SQL+=" WHERE stawka_vat='"+wart+"'"
                    SQL+=" AND '"+DataSprzedazy+"'>=od_dnia"
                    SQL+=" AND CASE WHEN do_dnia IS NULL"
                    SQL+=" THEN TRUE ELSE '"+DataSprzedazy+"'<=do_dnia END;"
                    
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat == 'OK':
                        if len(d) == 0:
                            #informacja zwrotna, ze podana stawka VAT nie zgadza sie
                            #z terminem jej obowiazywania
                            StawkaVATPozaTerminem = True
                    else:
                        stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                        dane.append(stat)
        
        elif pole == 'wartosc_netto':        
            Kwota=wart
        elif pole == 'opis_pozycji':      
            if wart =='':
                dane.append('BR OPIS')
        elif pole == 'kod_gtu' and wart.strip() !='':
            SQLG = "SELECT kod FROM rs_kody_towarow_uslug WHERE kod='" + wart + "'"
            stat, kod, dump, dump = self.PolSQL.Execute(SQLG, 3)
            if stat == 'OK':
                if len(kod) != 1:
                        stat = 'Podany kod gtu nie wystpuje w sowniku kodw towarw i usug.'
                        dane.append(stat)
            else:
                stat = 'Bd sprawdzania listy kodw towarw i usug.'
                dane.append(stat)
                
        i= i+1

        
    #-------------------------------------------------------------------------------
    #sprawdzenie relacji stawka VAT - kwota netto
    #-------------------------------------------------------------------------------

    if stat=='OK':
        if StVAT==None:
            SQL="SELECT stawka_vat FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
            SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+";"
            st,d,dump,dump = self.PolSQL.Execute(SQL,3)
            StVAT=d[0][0]
        if Kwota==None:
            SQL="SELECT wartosc_netto FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
            SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+";"
            st,d,dump,dump = self.PolSQL.Execute(SQL,3)
            Kwota=d[0][0]
        
        if (StVAT in (None,'None','')) and Kwota <> 0:
            stat='BR VAT'
            dane.append(stat)

        if (Kwota in (None,'None',0)) and StVAT not in (None,'None',''):
            stat='BR KW'
            dane.append(stat)
            
    # przywoanie ewentualnego bedu
    if stat == 'OK':
        if len(dane)>0:
            stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK' and not self.CzyZParagonu:
    ins = "INSERT INTO rs_faktury_pozycje_opisowe"
    Pola="firma_id,wyznacznik_id,data,numer"
    Wartosci="'"+self.firma_id+"','"+Wyznacznik+"','"+Data+"','"+Numer+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['opis_pozycji']:
            Pola= Pola+","+pole
            Wartosci= Wartosci+",'"+wart+"'"
        elif pole in ['kod_gtu']: #MK 2020-03-26
            Pola = Pola + "," + pole
            if wart not in ['', None]:
                Wartosci = Wartosci + ",'" + wart + "'"
            else:
                Wartosci += ",NULL"
        elif pole in ['nr_poz','wartosc_netto','wartosc_vat','wartosc_brutto',
                      'wartosc_wal_netto','wartosc_wal_vat','wartosc_wal_brutto']:
            Pola= Pola+","+pole
            Wartosci= Wartosci+","+str(wart)
        elif pole in ['stawka_vat']:
            Pola= Pola+","+pole
            if wart=="NULL":
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+wart+"'"

    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"       
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat='BL SQL INS'
        dane.append(stat)

                    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK' and not self.CzyZParagonu:
    where = " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    where+=" AND data='"+Data+"' AND numer='"+str(Numer)+"' AND nr_poz ="+str(NrPoz)
    upd = "UPDATE rs_faktury_pozycje_opisowe SET "
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
    
        if pole in ['opis_pozycji']:
            upd=upd+pole+"='"+wart+"',"
        elif pole in ['kod_gtu']: #MK 2020-03-26
            if wart not in ['', None]:
                upd=upd+pole+"='"+wart+"',"
            else:
                upd = upd + pole + "=NULL,"
        elif pole in ['nr_poz','wartosc_netto','wartosc_vat','wartosc_brutto',
                      'wartosc_wal_netto','wartosc_wal_vat','wartosc_wal_brutto']:
            upd=upd+pole+"="+str(wart)+","
        elif pole in ['stawka_vat']:
            if wart=="NULL":
                upd=upd+pole+"=NULL,"
            else:
                upd=upd+pole+"='"+wart+"',"

    upd = upd[0:len(upd)-1]+where
    stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    if stat<>'OK':
        stat='BL SQL UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat=='OK':
    if NrPozycji<> -1:
        NrPoz=NrPozycji    
    sql ="SELECT * FROM rs_faktury_pozycje_opisowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+";"    
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)    
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        #--- opis stawki vat
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        #--- opis kodu gtu #MK 2020-03-30
        if ((self.oddzial_id, '211421') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, o, dump, dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kody_towarow_uslug WHERE kod='" + tr.GetVal(0, "kod_gtu") + "';", 3)
            if len(o) == 0:
                wyn2.append('')
            else:
                wyn2.append(o[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika towarw i usug. Poinformuj administratora.')
        #informacja o zgodnosci stawki VAT z tylko w wypadku zapisu
        wyn2.append(Fun in (1,2,3,4) and StawkaVATPozaTerminem)