# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_formularze.py
# Purpose:     
# Author:      Pawel Wojcikowski, Micha Raburski
# Created:     2009/07/16
# RCS-ID:      $Id: fs_formularze.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-06-29 Mariusz Rajfura  (5865) LIKE 'symbol' w filtrze
# 2012-10-18 Mariusz Rajfura  (6178) Zadeklarowanie zmiennej Wynik w Fun==1
# 2018-03-19 Aleksander Bargie 10961 - przygotowanie do bdw w tworzeniu pliku .xlsx
# 2018-03-30 Aleksander Bargie - (10989) poprawka kodowania xlsx'w
# 2021-11-03 Wojciech Skowron - (12174) Poprawiona obsuga pliku
# 2024-02-20 Wojciech Skowron - (13695) Przyjmowany stat z ZapiszXLS

import rsglobal
try:
    from funkcje import fs_edeklaracje_parsowanie
except:
    pass

Fun = klucze[-1]
FormularzId = klucze[0]
if Fun not in (19,):
    FormularzIdS = klucze[1]
    ModulF = klucze[2]
    klucze_id=klucze[3]
    SymbolF = klucze[4]
    DeklaracjaF = klucze[5]
    DeklaracjaKlucz = klucze[6]
    DataKlucz = klucze[7]

stat = "OK"
dane = []
wyn1=[]

dl=10

UprDodawanie=((self.oddzial_id,'077063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'077062') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie

UprUsuwanie=((self.oddzial_id,'077064') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprWykonywanie=((self.oddzial_id,'077066') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDeklaracje=((self.oddzial_id,'077067') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE DANYCH
# -------------------------------------------------------------------------------

rsglobal.ZapiszDoLogow("formularze start", 5)

if Fun in [1,2] and stat=='OK':
    if FormularzId.strip() != '':
        Select="SELECT formularz_id FROM rs_formularze WHERE firma_id='"+self.firma_id+"' "
        Select+="AND formularz_id='"+str(FormularzId)+"';"
        stat,daneO,dump,dump = self.PolSQL.Execute(Select,3)

        rsglobal.ZapiszDoLogow("formularze start", 5)
        if stat=='OK':
            if len(daneO)<>0:
                stat='BL EXT'
                dane.append(stat)
        else:
            stat = 'Bdy przy sprawdzaniu danych :'+stat
            dane.append(stat)
    else:
         stat='POZ PUST'
         dane.append(stat)
    rsglobal.ZapiszDoLogow("formularze 2", 5)
    rsglobal.ZapiszDoLogow(stat, 5)
    rsglobal.ZapiszDoLogow(dane, 5)


#-------------------------------------------------------------------------------
#---   OBLICZANIE FORMULARZA (10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat=='OK': 
    if not UprWykonywanie:
        stat='UPR WYK' 
        dane.append(stat)   
        
    Form=rsglobal.Dekoduj(klucze_id[0])
    Rok=rsglobal.Dekoduj(klucze_id[1])
    Mc=rsglobal.Dekoduj(klucze_id[2])
    
    #sprawdzenie czy podana data jest w aktualnym okresie
    SQL="SELECT * FROM rs_definicje_okresow_miesiace WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+self.okres_id+"' AND rok='"+Rok+"' AND miesiac='"+Mc+"';"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':                
        stat = 'Bdy testowaniu poprawnoci daty :'+stat
        
    if stat=='OK':
        if len(DTest)==0:
            stat='Podana data jest spoza aktywnego okresu'
        
    if stat=='OK':
        #- usuwanie wartoci z kolejnych komrek
        SQL="UPDATE rs_formularze_pozycje SET wartosc=0 WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Form+"';"
        SQL+="UPDATE rs_formularze_definicje SET wartosc=0 WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Form+"' AND sposob != '21';"

        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat<>'OK':                
        stat = 'Bdy przy zerowaniu pozycji :'+stat
        
    if stat=='OK':     
        SPoz={}
        SDef={}
        MaxWiersz=0
        MaxKol=0
        
        #---------------------------------------------
        #- pobieranie struktury formularza 
        #---------------------------------------------
        
        # pobranie pozycji
        SQL="SELECT wiersz,kolumna FROM rs_formularze_pozycje WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND formularz_id='"+Form+"' AND COALESCE(opis,'')='';"
        stat,DaneP,dump,dump = self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        #- budowanie sownika z pozycjami
        # kluczem jest wiersz, kolumna, 
        # wynikiem jst, wartosc,liczba pozycji definicji oraz czy policzone
        for poz in DaneP:
            SPoz[poz[0],poz[1]]=[0,0,False]
            if poz[0]>MaxWiersz:
                MaxWiersz=int(poz[0])       #PW(10376) 2017-03-15
            if poz[1]>MaxKol:
                MaxKol=int(poz[1])
        
        # pobranie definicji pozycji
        SQL="SELECT wiersz,kolumna,nr_poz,konto,sposob,dzialanie,ujemna,analityka1,analityka1_od,"
        SQL+="analityka2,analityka2_od,f_wiersz,f_kolumna,f_nr_poz,fd.wartosc,COALESCE(miesiac,0) "
        SQL+=" FROM rs_formularze_definicje fd INNER JOIN rs_formularze_pozycje "
        SQL+=" USING (firma_id,formularz_id,wiersz,kolumna) WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND formularz_id='"+Form+"';"
        stat,DaneD,dump,dump = self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        #- budowanie sownika z definicjami
        # kluczem jest wiersz, kolumna i nr pozycji  
        # wynikiem s wszystkie pola z definicji po kolei, a na kocu - czy policzone
        for poz in DaneD:
            SDef[poz[0],poz[1],poz[2]]=poz[3:]+[False]
            SPoz[poz[0],poz[1]][1] += 1
        
        #- ptla obliczajca warto pozostaych komrek
        Zmienione=True
        KluczePoz=SPoz.keys()
        KluczePoz.sort()
    
        while Zmienione and stat=='OK':
            Zmienione=False
            #- przebiegamy po kolei pozycje formularza. Analizujemy tylko te niepoliczone.
            rsglobal.ZapiszDoLogow('PRZEBIEG POZ '+str(SPoz),dl)
            for klucz in KluczePoz:
                if not SPoz[klucz][2]:
                    # sprawdzenie i ewentualne pobranie wartosci na definicje
                    WszystkieSa=(SPoz[klucz][1]>0)
                    rsglobal.ZapiszDoLogow('AN KL '+str(klucz)+' '+str(SPoz[klucz][1]-1),dl)
                    for i in range(SPoz[klucz][1]):
                        if stat=='OK':
                            Przerwac=False
                            kluczdef=(klucz[0],klucz[1],i+1)
                            pozdef=SDef[kluczdef]
                            rsglobal.ZapiszDoLogow('A '+str(kluczdef)+' '+str(pozdef),dl)
                            KontoD=rsglobal.Dekoduj(pozdef[0])
                            SposobD=pozdef[1]
                            UjemnaD=pozdef[3]
                            Anal1D=rsglobal.Dekoduj(pozdef[4]).strip()
                            Anal1OdD=str(int(pozdef[5]))
                            Anal2D=rsglobal.Dekoduj(pozdef[6]).strip()
                            Anal2OdD=str(int(pozdef[7]))
                            FWierszD=pozdef[8]
                            FKolumnaD=pozdef[9]
                            FNrD=pozdef[10]
                            McD=str(pozdef[12])
                            
                        if stat=='OK' and not SDef[kluczdef][-1]:
                            Wart=None
                            
                            #pobranie konkretnego roku, miesiaca i okresu jeli wymaga tego sposb obliczenia
                            #oraz jest przesunicie miesiczne
                            if SposobD not in [20,21]:
                                OkresAkt=self.okres_id
                                RokAkt=Rok
                                McAkt=Mc
                                if McD != 0:
                                    SQL="SELECT '"+Rok+"-"+Mc+"-01'::date +interval '"+McD+" month' FROM rs_formularze_definicje"
                                    stat,DaneD,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        RokAkt=rsglobal.Dekoduj(DaneD[0][0][0:4])
                                        McAkt=rsglobal.Dekoduj(DaneD[0][0][5:7])
                                        #sprawdzenie jaki to bdzie okres
                                        SQL="SELECT okres_id FROM rs_definicje_okresow_miesiace INNER JOIN "
                                        SQL+=" rs_definicje_okresow USING(firma_id,okres_id) WHERE firma_id='"+self.firma_id+"'"
                                        SQL+=" AND rok='"+RokAkt+"' AND miesiac='"+McAkt+"' ORDER BY data_do DESC;"
                                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                        if stat=='OK':
                                            if len(DTest)==0:
                                                Przerwac=True
                                                WszystkieSa=False
                                            else:
                                                OkresAkt=rsglobal.Dekoduj(DTest[0][0])
                                
                                #wybr strony po ktrej wykonujemy dziaania (Wn/Ma)
                                if SposobD in ['01','03','05','07','09','11']:
                                    StronaD='wn'
                                else:
                                    StronaD='ma'
                                
                                #filtr konta
                                FiltrKonta=" AND konto LIKE '"+KontoD+"%'"    
                                if Anal1OdD<>'0' and Anal1D != 'None':
                                    FiltrKonta+=" AND substring(konto FROM "+Anal1OdD+" FOR length('"+Anal1D+"'))='"+Anal1D+"'"
                                if Anal2OdD<>'0' and Anal2D != 'None':
                                    FiltrKonta+=" AND substring(konto FROM "+Anal2OdD+" FOR length('"+Anal2D+"'))   ='"+Anal2D+"'"
                                        
                            if not Przerwac:
                                #-------------------------------------------------------------------------------
                                # w zaleznoci od typu na rne sposoby wyznaczamy warto pozycji definicji
                                #-------------------------------------------------------------------------------
                                
                                # warto podawana przez operatora
                                if SposobD=='21':
                                    SDef[kluczdef][-1]=True
                                    Zmienione=True
            
                                # wartosc pobierana z innego pola formularza
                                elif SposobD=='20':
                                    if FNrD>0:
                                        # pobierane z definicji
                                        if (FWierszD,FKolumnaD,FNrD) in SDef.keys():
                                            if SDef[FWierszD,FKolumnaD,FNrD][-1]:
                                                Wart=SDef[FWierszD,FKolumnaD,FNrD][11]
                                    else:            
                                        # pobierane z pozycji
                                        # jeli wiersz jest 0, a kolumna nie jest 0 to sumujemy ca kolumn
                                        if FWierszD==0 and FKolumnaD !=0:
                                            Wart=0
                                            CzyWszystkie=True
                                            for i in range(MaxWiersz):
                                                if CzyWszystkie:
                                                    if (i+1,FKolumnaD) in SPoz:
                                                        if not SPoz[i+1,FKolumnaD][-1]:
                                                            if not (i+1==klucz[0] and FKolumnaD==klucz[1]):
                                                                CzyWszystkie=False
                                                        
                                                        Wart+=SPoz[i+1,FKolumnaD][0]
                                                    
                                            if not CzyWszystkie:
                                                Wart=None
                                                
                                        # jeli wiersz nie jest 0, a kolumna jest 0 to sumujemy cay wiersz
                                        elif FWierszD!=0 and FKolumnaD==0:
                                            Wart=0
                                            CzyWszystkie=True
                                            for i in range(MaxKol):
                                                if CzyWszystkie:
                                                    if (FWierszD,i+1) in SPoz:
                                                        if not SPoz[FWierszD,i+1][-1]:
                                                            if not (FWierszD==klucz[0] and i+1==klucz[1]):
                                                                CzyWszystkie=False
                                                        
                                                        Wart+=SPoz[FWierszD,i+1][0]
                                                    
                                            if not CzyWszystkie:
                                                Wart=None    
                                                
                                        # jeli jest podany konkretny wiersz i kolumna
                                        elif (FWierszD,FKolumnaD) in SPoz.keys():
                                            if SPoz[FWierszD,FKolumnaD][-1]:        
                                                Wart=SPoz[FWierszD,FKolumnaD][0]
                                             
                                    
                                # bilans otwarcia 
                                elif SposobD in ['01','02']:
                                    SQL="SELECT SUM(saldo_"+StronaD+") FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"' AND miesiac='00'"
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                        #rsglobal.ZapiszDoLogow('WART '+str(Wart),1)
                                
                                # obroty miesiczne
                                elif SposobD in ['03','04']:
                                    SQL="SELECT SUM(kwota_"+StronaD+") FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"'"
                                    SQL+=" AND rok='"+RokAkt+"' AND miesiac='"+McAkt+"'"
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL 04 '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                        #rsglobal.ZapiszDoLogow('WART '+str(Wart),1)
                                    
                                # obroty miesiczne narastajco bez BO
                                elif SposobD in ['05','06']:
                                    SQL="SELECT SUM(kwota_"+StronaD+") FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"'"
                                    SQL+=" AND (rok<'"+RokAkt+"' OR (rok='"+RokAkt+"' AND miesiac<='"+McAkt+"'))"
                                    SQL+=" AND miesiac != '00' "
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                        
                                # obroty miesiczne narastajco z BO
                                elif SposobD in ['07','08']:
                                    SQL="SELECT SUM(CASE WHEN miesiac='00' THEN saldo_"+StronaD+" ELSE kwota_"+StronaD+" END) FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"'"
                                    SQL+=" AND (rok<'"+RokAkt+"' OR (rok='"+RokAkt+"' AND miesiac<='"+McAkt+"'))"
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                    
                                # saldo w miesicu - rnica stron
                                elif SposobD in ['09','10']:
                                    SQL="SELECT SUM(kwota_wn-kwota_ma) FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"'"
                                    SQL+=" AND rok='"+RokAkt+"' AND miesiac='"+McAkt+"'"
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                        if SposobD=='10':
                                            Wart=-1*Wart
                                
                                # saldo narastajco z BO - roznica stron
                                elif SposobD in ['11','12']:
                                    SQL="SELECT SUM(saldo_"+StronaD+") FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"'"
                                    SQL+=" AND rok='"+RokAkt+"' AND miesiac='"+McAkt+"'"
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                                                            
                                # obroty narastajco z BO - roznica stron
                                elif SposobD in ['13','14']:
                                    SQL="SELECT SUM(CASE WHEN miesiac='00' THEN saldo_wn-saldo_ma ELSE kwota_wn-kwota_ma END) FROM rs_stany_kont"
                                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAkt+"'"
                                    SQL+=" AND (rok<'"+RokAkt+"' OR (rok='"+RokAkt+"' AND miesiac<='"+McAkt+"'))"
                                    SQL+=FiltrKonta+";"
                                    #rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                                    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        Wart=DTest[0][0]
                                        if SposobD=='14':
                                            Wart=-1*Wart
                                            
                                else:
                                    #by jaki dziwny sposb pobierania
                                    WszystkieSa=False
                                
                            if stat=='OK':
                                # tu zapisujemy do naszych sownikw nowo policzone wartoci, 
                                # pod warunkiem, e si udao je policzy
                                rsglobal.ZapiszDoLogow('WART3 '+str(Wart),dl)
                                if SposobD<>'21':    
                                    if Wart == None:   
                                        #jeli nie udao si policzy formuy
                                        WszystkieSa=False
                                    else:
                                        if Wart<0:
                                            if UjemnaD=='-':
                                                Wart=-1*Wart
                                            elif UjemnaD=='0':
                                                Wart=0
                                                
                                        SDef[kluczdef][11]=Wart
                                        SDef[kluczdef][-1]=True
                                        rsglobal.ZapiszDoLogow('ZMIENIONE 2 '+str(kluczdef),dl)
                                        Zmienione=True
        
                    
                    #jeli policzone s wszystkie definicje podpozycji to liczymy pozycj
                    if WszystkieSa:
                        Wart=0
                        for i in range(SPoz[klucz][1]):
                            kluczdef=(klucz[0],klucz[1],i+1)
                            pozdef=SDef[kluczdef]
                            
                            dzial=pozdef[2]
                            wart=pozdef[11]
                            if dzial=='/' and wart==0:
                                stat="UWAGA! W pozycji "+str(kluczdef)+" wystpio dzielenie przez 0"
                            else:
                                Wart=eval('Wart'+dzial+str(wart))
                                
                            rsglobal.ZapiszDoLogow('B '+str(kluczdef)+' '+str(pozdef)+str(Wart),dl)
                    
                        SPoz[klucz][0]=Wart
                        SPoz[klucz][2]=True
                        
    if stat=='OK':
        # Co mona byo policzy zostao policzone.
        # kad policzon pozycj i definicj wpisujemy do bazy.
        # Niepoliczone pozycje dodajemy do listy niepoliczonych, ktr pniej wywietlamy
        UPD=''
        rsglobal.ZapiszDoLogow('POZ '+str(SPoz),dl)
        rsglobal.ZapiszDoLogow('WART1 '+str(SDef),dl)
        for klucz in KluczePoz:
            # analiza pozycji
            rsglobal.ZapiszDoLogow('KL '+str(klucz)+' '+str(i),dl)
            if not SPoz[klucz][2]:
                rsglobal.ZapiszDoLogow('11 '+str(SPoz[klucz][2]),dl)
                wyn1.append((int(klucz[0]),int(klucz[1])))
            else:
                rsglobal.ZapiszDoLogow('12 '+str(SPoz[klucz][2]),dl)
                UPD+="UPDATE rs_formularze_pozycje SET wartosc="+str(SPoz[klucz][0])
                UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Form+"'"
                UPD+=" AND wiersz="+str(klucz[0])+" AND kolumna="+str(klucz[1])+";"
                
            # sprawdzenie i ewentualne wrzucenie wartosci na definicje
            for i in range(SPoz[klucz][1]):
                kluczdef=(klucz[0],klucz[1],i+1)
                pozdef=SDef[kluczdef]
                if pozdef[-1]:
                    UPD+="UPDATE rs_formularze_definicje SET wartosc="+str(pozdef[11])
                    UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Form+"'"
                    UPD+=" AND wiersz="+str(klucz[0])+" AND kolumna="+str(klucz[1])
                    UPD+=" AND nr_poz="+str(i+1)+";"
    
        rsglobal.ZapiszDoLogow('UPD '+UPD,dl)
        if UPD != '':
            UPD+="UPDATE rs_formularze SET obliczenia_data=NOW(),obliczenia_okres='"+self.okres_id+"',"
            UPD+="obliczenia_miesiac='"+Mc+"',obliczenia_rok='"+Rok+"' WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Form+"'"
            stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=='OK': 
    if not UprDodawanie:
        stat='UPR INS' 
        dane.append(stat)   

    LKolumn=0
    EDeklTyp='NULL'
    EDeklWersja='NULL'
    Wynik = []
    
    # jeli edeklaracja to pobieramy definicj deklaracji
    if stat=='OK' and DeklaracjaKlucz<>'':
        if not UprDeklaracje:
            stat='Brak uprawnie do tworzenia formularza deklaracji'
            
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataKlucz):
                stat='Nie podano prawidowej daty deklaracji'
        if stat=='OK':
            SQL="SELECT wersja_id FROM rs_edeklaracje_wersje WHERE typ_id='"+DeklaracjaKlucz+"'"
            SQL+=" AND data_od<='"+DataKlucz+"' ORDER BY data_od DESC LIMIT 1;"
            stat,DDekl,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania wersji deklaracji :'+stat
            elif len(DDekl)==0:
                stat=' Brak deklaracji typu '+DeklaracjaKlucz+' na dzie '+DataKlucz

        if stat=='OK':
            EDeklTyp="'"+DeklaracjaKlucz.strip()+"'"
            EDeklWersja="'"+rsglobal.Dekoduj(DDekl[0][0]).strip()+"'"
            
            # pobranie danych do formularza (katalog uzmienni)
            KatDekl=self.KatalogDeklaracji+DeklaracjaKlucz.strip()+'/'+rsglobal.Dekoduj(DDekl[0][0]).strip()
            Wynik=fs_edeklaracje_parsowanie.PobierzPolaDeklaracji(KatDekl)
            LKolumn=4
            
    if stat=='OK':     
        klucze_id.append([str(FormularzId)])        
        SQL="INSERT INTO rs_formularze (firma_id,formularz_id,nazwa,modul,okres_id,"
        SQL+="l_wierszy,l_kolumn,obliczenia_data,obliczenia_okres,obliczenia_miesiac,obliczenia_rok,"
        SQL+="edeklaracja_typ,edeklaracja_wersja)"
        SQL+=" VALUES ('"+self.firma_id+"','"+str(FormularzId)+"',NULL,NULL,NULL,"
        SQL+="0,"+str(LKolumn)+",NULL,NULL,NULL,NULL,"
        SQL+=EDeklTyp+","+EDeklWersja+");"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)  
        if stat<>'OK':
            stat = 'Bdy przy dodawaniu danych :'+stat
            dane.append(stat)   

        # wstawienie danych do pozycji formularza
    if stat=='OK':     
        LWier=1
        WartDodSek='T'
        SQL=''
        
        SQLPom=" INSERT INTO rs_formularze_pozycje (firma_id,formularz_id,wiersz,kolumna,nazwa,opis,wartosc)"
        SQLPom+=" VALUES ('"+self.firma_id+"','"+str(FormularzId)+"',%s,%s,'%s','%s',0);"
        
        for sekcja in Wynik:
            Nazwa=sekcja['nazwa']
            Pola=sekcja['pola']
            
            # dodanie pozycji z sekcj
            
            # nazwa sekcji

            SQL+=SQLPom % (str(LWier),'1','Nazwa sekcji',Nazwa)
            # techniczna nazwa sekcji
            SQL+=SQLPom % (str(LWier),'2','Nazwa techniczna sekcji',Nazwa)
            # opis sekcji
            SQL+=SQLPom % (str(LWier),'3','SEKCJA DEKLARACJI','SEKCJA DEKLARACJI')
            # wartosc sekcji
            SQL+=SQLPom % (str(LWier),'4','Warto',WartDodSek)

            LWier+=1
            WartDodSek='N'
            for pole in Pola:
                # nazwa pola
                SQL+=SQLPom % (str(LWier),'1','Nazwa pola',pole[0])
                # nazwa pola
                SQL+=SQLPom % (str(LWier),'2','Nazwa techniczna pola',pole[1])
                # opis pola
                SQL+=SQLPom % (str(LWier),'3','Opis pola',pole[2])
                # warto pola
                SQL+=SQLPom % (str(LWier),'4','Warto pola',pole[3])
                LWier+=1
            
        if SQL<>'':
            SQL=SQL.replace(u'\u201e','"').replace(u'\u201d','"').replace(u'\u2013',"-")
            SQL+=" UPDATE rs_formularze SET l_wierszy='"+str(LWier)+"' WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"';"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1,CzyDodawacBlad=True)
            if stat<>'OK':
                stat = 'Bdy przy dodawaniu pozycji :'+stat
                dane.append(stat)   
            
            
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH (2)
#-------------------------------------------------------------------------------

if Fun == 2 and stat=='OK': 
    if not UprEdycja:
        stat='Brak uprawnie do modyfikowania danych'
        dane.append(stat)
            
    if stat=='OK':           
        Select="SELECT okres_id,nazwa,modul,l_wierszy,l_kolumn,obliczenia_data"
        Select+=",obliczenia_okres,obliczenia_miesiac,COALESCE(naglowek,''),COALESCE(stopka,''),obliczenia_rok FROM rs_formularze "
        Select+="WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzIdS)+"';"
        stat,DANE,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania danych :'+stat
            dane.append(stat)        
        
        if stat=="OK":  
            for i in [0,1,2,3,4,5,6,7,8,9,10]:
                if DANE[0][i]=='None':
                    DANE[0][i]='NULL'
                else:
                    DANE[0][i]="'"+str(DANE[0][i])+"'"                     
            klucze_id.append([str(FormularzId)])        
            query="INSERT INTO rs_formularze (firma_id,formularz_id,okres_id,nazwa,modul,"
            query+="l_wierszy,l_kolumn,obliczenia_data,obliczenia_okres,obliczenia_miesiac,naglowek,stopka,obliczenia_rok)"
            query+=" VALUES ('"+self.firma_id+"','"+str(FormularzId)+"',"+str(DANE[0][0])+","
            query+=""+str(DANE[0][1])+","+str(DANE[0][2])+","+str(DANE[0][3])+","
            query+=""+str(DANE[0][4])+","+str(DANE[0][5])+","+str(DANE[0][6])+","+str(DANE[0][7])+","
            query+=""+str(DANE[0][8])+","+str(DANE[0][9])+","+str(DANE[0][10])+");"
            stat,dump,dump,dump = self.PolSQL.Execute(query ,1)  
            if stat<>'OK':
                stat = 'Bdy przy kopiowaniu formularza :'+stat
                dane.append(stat)
            else:
                query="DELETE FROM rs_formularze_pozycje WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'; "
                query+="DELETE FROM rs_formularze_definicje WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'; "
                stat,dump,wyn1,wyn2=self.PolSQL.Execute(query,1)                       
                if stat<>'OK':
                    stat='Bdy usuwania starych definicji :'+stat
                    dane.append(stat) 
                else:
                    query="INSERT INTO rs_formularze_pozycje (firma_id,formularz_id,"
                    query+="wiersz,kolumna,nazwa,opis,wartosc)"
                    query+=" SELECT firma_id,'"+str(FormularzId)+"',wiersz,kolumna,"
                    query+="nazwa,opis,wartosc FROM rs_formularze_pozycje WHERE "
                    query+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzIdS)+"';"
                    
                    query+="INSERT INTO rs_formularze_definicje (firma_id,formularz_id,"
                    query+="wiersz,kolumna,nr_poz,konto,sposob,dzialanie,ujemna,"
                    query+="analityka1,analityka1_od,analityka2,analityka2_od,"
                    query+="f_wiersz,f_kolumna,f_nr_poz,wartosc,miesiac)"
                    query+=" SELECT firma_id,'"+str(FormularzId)+"',wiersz,kolumna,"
                    query+="nr_poz,konto,sposob,dzialanie,ujemna,analityka1,analityka1_od,analityka2,analityka2_od,"
                    query+="f_wiersz,f_kolumna,f_nr_poz,wartosc,miesiac FROM rs_formularze_definicje WHERE "
                    query+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzIdS)+"' ;"
                    stat,dump,dump,dump = self.PolSQL.Execute(query ,1)  
                    if stat<>'OK':
                        stat = 'Bdy przy kopiowaniu definicji :'+stat
                        dane.append(stat)     

#-------------------------------------------------------------------------------
#---   ZAPIS WIELU FORMULARZY W XLS (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat=='OK':
    from funkcje import fs_pliki_office
    import binascii
    import tempfile
    Tresc=[]
    Kodowanie=klucze[1]
    DFormularzy=klucze_id
    for formularz in DFormularzy:
        # nazwa zakadki
        DForm=[formularz[0]]
        #AB 30.03.2018 poprawka kodowania
        DForm.append(fs_pliki_office.PrzygotujTrescZCSV(formularz[1], Kodowanie))
        Tresc.append(DForm)
    
    Plik=tempfile.mktemp('.xlsx')
    try:  #AB otoczenie w try/except
        stat = fs_pliki_office.ZapiszXLS(Tresc,Plik,Kodowanie)  #WS 2024-02-20 - stat=
        #WS 2021-11-03
        with open(Plik,'rb') as p:
            dane = [binascii.hexlify(buffer(p.read()))]
        # dane = [binascii.hexlify(buffer(open(Plik,'rb').read()))]
    except Exception, e:
        stat = u'Problem z tworzeniem pliku xlsx'
        rsglobal.ZapiszDoLogow(stat + str(e), 1)

#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 and stat=='OK':
    if not UprUsuwanie:
        stat='UPR DEL'
        dane.append(stat)
        
    if stat=='OK':
        query="DELETE FROM rs_formularze WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"';"       
        query+=" DELETE FROM rs_formularze_pozycje WHERE"
        query+=" firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"';"
        query+=" DELETE FROM rs_formularze_definicje WHERE"
        query+=" firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
        if stat<>'OK':
            stat = 'Bdy przy usuwaniu danych :'+stat
            dane.append(stat)
                                      

#-------------------------------------------------------------------------------
#---   POBRANIE TRECI DEKLARACJI XML (9)
#-------------------------------------------------------------------------------

if Fun == 9 and stat=='OK':
    if not UprDeklaracje:
        stat='Brak uprawnie do tworzenia pliku XML z formularza deklaracji'
        dane.append(stat)
        
    if stat=='OK':
        # pobranie danych formularza
        SQL="SELECT edeklaracja_typ,edeklaracja_wersja FROM rs_formularze WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"';"
        stat,DForm,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych formularza :'+stat
            dane.append(stat)
        elif len(DForm)==0:
            stat = 'Brak formularza o symbolu '+str(FormularzId).strip()
            dane.append(stat)
        else:
            Katalog=self.KatalogDeklaracji+rsglobal.Dekoduj(DForm[0][0]).strip()+'/'+rsglobal.Dekoduj(DForm[0][1]).strip()
            
    if stat=='OK':
        # pobranie wartoci z pozycji
        SQL="SELECT wiersz,kolumna,nazwa,opis,wartosc FROM rs_formularze_pozycje WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND formularz_id='"+str(FormularzId)+"' AND kolumna IN (2,4) ORDER BY wiersz,kolumna;"
        stat,DFormPoz,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu danych pozycji formularza :'+stat
            dane.append(stat)
        elif len(DForm)==0:
            stat = 'Brak pozycji formularza o symbolu '+str(FormularzId).strip()
            dane.append(stat)
        
    if stat=='OK':
        # stworzenie struktury danych do deklaracji
        LDekl=[]
        SSekcja={}
        Robic=True
        NazwaTech=''
        for poz in DFormPoz:
            wiersz=poz[0]
            kol=poz[1]
            nazwa=rsglobal.Dekoduj(poz[2]).strip()
            opis=rsglobal.Dekoduj(poz[3]).strip()
            wartosc=rsglobal.RSRound(poz[4],2)
            
            # jeli zaczynamy now sekcj to star naley zapisa (jestemy w kolumnie 2)
            if nazwa=='Nazwa techniczna sekcji':
                if SSekcja<>{}:
                    LDekl.append(SSekcja)
                SSekcja={'nazwa':opis}
                Robic=True
        
            # jestemy w kolumnie 4 pocztku nowej sekcji
            elif len(SSekcja.keys())==1:
                # jeli ma zaznaczone e ma by
                if opis=='T':
                    SSekcja['pola']=[]
                else:
                    Robic=False
                    SSekcja={}
        
            # jeli nazwa techniczna pola pozycji
            elif kol==2 and Robic:
                NazwaTech=opis
            elif kol==4 and Robic:
                WartPom=''
                if wartosc!=0:
                    WartPom=str(wartosc)
                else:
                    WartPom=opis
                
                if WartPom<>'':
                    SSekcja['pola'].append([NazwaTech,WartPom])
            
        # jeli co zostao to zapisujemy ostatni sekcj
        if SSekcja<>{}:
            LDekl.append(SSekcja)
        
        rsglobal.ZapiszDoLogow(LDekl)
        
        # stworzenie deklaracji XML
        dane=[fs_edeklaracje_parsowanie.StworzDeklaracje(Katalog,['AdresZagr'],LDekl,[])]

# -------------------------------------------------------------------------------
# ---  POBRANIE WARTOSCI Z FORMULARZA DO SPRAWOZDANIA FINANSOWEGO (19)
# -------------------------------------------------------------------------------

if Fun == 19 and stat == 'OK':
    rsglobal.ZapiszDoLogow("formularze 3", 5)
    SQL  = "SELECT wartosc, klucz_sprawozdania FROM rs_formularze_pozycje WHERE "
    SQL += "firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"' AND "
    SQL += "klucz_sprawozdania!='';"
    rsglobal.ZapiszDoLogow(SQL, 5)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(stat, 5)
    rsglobal.ZapiszDoLogow(dane, 5)
    if stat != 'OK':
        stat = u"Bd pobierania wartoci: " + stat
    elif len(dane) == 0:
        stat = u"Brak wartoci do pobrania"

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Fun in [1,2,5,6]) and (stat=='OK'):
    SQL="SELECT formularz_id,COALESCE(nazwa,''),COALESCE(modul,''),COALESCE(okres_id,''),"
    SQL+="COALESCE(edeklaracja_wersja,'') FROM rs_formularze "
    SQL+="WHERE firma_id='"+self.firma_id+"'"

    if ModulF != '':
        SQL+=" AND modul LIKE '"+str(ModulF)+"%'"

    if SymbolF != '':
        SQL+=" AND formularz_id LIKE '"+str(SymbolF)+"%'"    

    if DeklaracjaF != '':
        SQL+=" AND edeklaracja_wersja LIKE '"+str(DeklaracjaF)+"%'"    

    if not UprDeklaracje:
        SQL+=" AND edeklaracja_typ IS NULL"
    if klucze_id <>[]: 
        for k in klucze_id: 
            if str(k[0])<> '[]':
                SQL+=" OR (firma_id = '" + self.firma_id + "' AND formularz_id = '" + rsglobal.Dekoduj(k[0]) + "')"    

    SQL+=" ORDER BY formularz_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)