# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_formularze_pozycje.py
# Purpose:     operacje na tabeli rs_formularze_pozycje
# Author:      Pawe Wjcikowski
# Created:     2009/07/27
# RCS-ID:      $Id: fs_formularze_pozycje.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-02-07 Mariusz Rajfura  obsluga 'grida wirtualnego' (5421)
# 2012-06-19 Mariusz Rajfura  kopiowanie pojedynczej kolumny lub wiersza (5804)
# 2012-07-02 Mariusz Rajfura  modyfikacja formul przy przenoszeniu, kopiowaniu wierszy/kolumn,
#                             przesuwaniu komorek (5865)
# 2012-07-09 Mariusz Rajfura  tworzenie definicji sumy komorek (5897)

FormularzId = rsglobal.Dekoduj(klucze[0])
Wiersz = klucze[1]
Kolumna = klucze[2]
WierszS = klucze[3]
KolumnaS = klucze[4]
ListaKomorek = klucze[5]

Fun = klucze[-1]
stat = "OK"
dane = []
wyn1 = []
wyn2 = []
   
UprDodawanie=((self.oddzial_id,'077063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'077062') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie


#-------------------------------------------------------------------------------
#---   WYCZYSZCZENIE ZAWARTOSCI KOMORKI (6)
#-------------------------------------------------------------------------------

if Fun==6 and stat=='OK':
    if not UprEdycja:
        stat='Brak uprawnie do modyfikowania danych'
        dane.append(stat)
          
    if stat=="OK":       
        sql= "SELECT wiersz,kolumna FROM rs_formularze_pozycje WHERE "
        sql+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' "
        sql+="AND wiersz="+str(Wiersz)+" AND kolumna="+str(Kolumna)+" FOR UPDATE NOWAIT;"
        stat,d,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bdy przy sprawdzaniu danych :'+stat
            dane.append(stat)
        elif len(d)==0:
            stat = 'Brak komrki o podanym kluczu'
            dane.append(stat)

        if stat == 'OK':
            # czyszczenie pol komorki
            UPD = "UPDATE rs_formularze_pozycje SET "            
            UPD+= " nazwa=NULL,wartosc=0,opis=NULL,wytluszczenie=FALSE,wyposrodkowanie=FALSE"
            UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
            UPD+= " AND kolumna='"+str(Kolumna)+"' AND wiersz='"+str(Wiersz)+"'; "
            
            # usuniecie definicji przypisanych do komorki
            UPD+="DELETE FROM rs_formularze_definicje"
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
            UPD+=" AND wiersz='"+str(Wiersz)+"' AND kolumna='"+str(Kolumna)+"';" 

            stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)  
            if stat <> 'OK':
                stat = 'Bdy przy czyszczeniu zawartoci komrki: '+stat
                dane.append(stat)  


#-------------------------------------------------------------------------------
#---   WKLEJENIE DANYCH (9)
#-------------------------------------------------------------------------------

if Fun==9 and stat=='OK':
    if not UprEdycja:
        stat='Brak uprawnie do modyfikowania danych'
        dane.append(stat)
          
    # pobranie danych z kopiowanej kom.
    if stat=="OK":       
        sql= "SELECT COALESCE(nazwa,''),COALESCE(opis,''),wartosc,wytluszczenie,wyposrodkowanie"
        sql+=" FROM rs_formularze_pozycje WHERE "
        sql+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' "
        sql+="AND wiersz="+str(WierszS)+" AND kolumna="+str(KolumnaS)+";"
        stat,daneO,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bdy przy sprawdzaniu danych :'+stat
            dane.append(stat)
        else:
            if len(daneO)<>0:
                NazwaS=daneO[0][0]
                OpisS=daneO[0][1]
                WartoscS=daneO[0][2]
                WytluszczenieS=daneO[0][3]
                WyposrodkowanieS=daneO[0][4]

                sql = "UPDATE rs_formularze_pozycje SET"
                sql+= " nazwa='"+str(NazwaS)+"', wartosc='"+str(WartoscS)+"', opis='"+str(OpisS)+"',"
                sql+= " wytluszczenie="+str(WytluszczenieS)+", wyposrodkowanie="+str(WyposrodkowanieS)
                sql+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
                sql+= " AND kolumna='"+str(Kolumna)+"' AND wiersz='"+str(Wiersz)+"';"
                stat,daneO,wyn1,wyn2=self.PolSQL.Execute(sql,1)
                if stat<>'OK':
                    stat='Bdy modyfikacji komrki :'+stat
                    dane.append(stat)
                else:
                    query="DELETE FROM rs_formularze_definicje WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
                    query+=" AND wiersz='"+str(Wiersz)+"' AND kolumna='"+str(Kolumna)+"';" 
                    stat,dump,wyn1,wyn2=self.PolSQL.Execute(query,1)                       
                    if stat<>'OK':
                        stat='Bdy usuwania starych definicji :'+stat
                        dane.append(stat) 
                    else:
                        query="INSERT INTO rs_formularze_definicje (firma_id,formularz_id,"
                        query+="wiersz,kolumna,nr_poz,konto,sposob,dzialanie,ujemna,"
                        query+="analityka1,analityka1_od,analityka2,analityka2_od,"
                        query+="f_wiersz,f_kolumna,f_nr_poz,wartosc,miesiac)"
                        query+=" SELECT firma_id,formularz_id,"+str(Wiersz)+","+str(Kolumna)+","
                        query+="nr_poz,konto,sposob,dzialanie,ujemna,analityka1,analityka1_od,analityka2,analityka2_od,"
                        query+="f_wiersz,f_kolumna,f_nr_poz,wartosc,miesiac FROM rs_formularze_definicje WHERE "
                        query+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' "
                        query+="AND wiersz="+str(WierszS)+" AND kolumna="+str(KolumnaS)+";"
                        stat,dump,dump,dump = self.PolSQL.Execute(query ,1)  
                        if stat<>'OK':
                            stat = 'Bdy przy kopiowaniu definicji :'+stat
                            dane.append(stat)  
            else:
                stat='Bdy kopiowania komrki :'+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   PRZENOSZENIE POZYCJI /GORA-DOL/LEWO-PRAWO/ (11)
#-------------------------------------------------------------------------------

if Fun==11 and stat=='OK':
    if not UprEdycja:
        stat='Brak uprawnie do modyfikowania danych'
        dane.append(stat)
    
    if stat == 'OK':
        # pobranie listy odwolan z formul dla komorki przesuwanej
        sql ="SELECT wiersz,kolumna,nr_poz FROM rs_formularze_definicje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        sql+=" AND sposob='20' AND f_wiersz="+str(WierszS)+" AND f_kolumna="+str(KolumnaS)+";"

        stat,KomPrzesuw,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania przesuwanych formu: '+stat

    if stat == 'OK':
        # pobranie listy odwolan z formul dla komorki ustepujacej miejsca komorce przesuwanej
        sql ="SELECT wiersz,kolumna,nr_poz FROM rs_formularze_definicje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        sql+=" AND sposob='20' AND f_wiersz="+str(Wiersz)+" AND f_kolumna="+str(Kolumna)+";"

        stat,KomUstep,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania formu ustpujcych miejsce: '+stat
    
    
    if stat=='OK':
        UPD = ''
        
        # modyfikacja formul odwolulacych do przesuwanej komorki
        for i in xrange(len(KomPrzesuw)):
            UPD+="UPDATE rs_formularze_definicje"
            UPD+=" SET f_wiersz="+str(Wiersz)+", f_kolumna="+str(Kolumna)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
            UPD+=" AND wiersz="+str(KomPrzesuw[i][0])+" AND kolumna="+str(KomPrzesuw[i][1])
            UPD+=" AND nr_poz="+str(KomPrzesuw[i][2])+"; "

        # modyfikacja formul odwolulacych do komorki ustepujacej miejsce
        for i in xrange(len(KomPrzesuw)):
            UPD+="UPDATE rs_formularze_definicje"
            UPD+=" SET f_wiersz="+str(Wiersz)+", f_kolumna="+str(Kolumna)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
            UPD+=" AND wiersz="+str(KomPrzesuw[i][0])+" AND kolumna="+str(KomPrzesuw[i][1])
            UPD+=" AND nr_poz="+str(KomPrzesuw[i][2])+"; "
        
        #przeniesienie kom. z nowego adresu na 99 pozycje
        UPD+= "UPDATE rs_formularze_pozycje SET "            
        UPD+= "kolumna=99, wiersz="+str(Wiersz+100)
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        UPD+= " AND kolumna="+str(Kolumna)+" AND wiersz="+str(Wiersz)+"; "

        UPD+= "UPDATE rs_formularze_definicje SET "            
        UPD+= "kolumna=99, wiersz="+str(Wiersz+100)
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        UPD+= " AND kolumna="+str(Kolumna)+" AND wiersz="+str(Wiersz)+"; "

        #przeniesienie starej kom. na nowy adres.
        UPD+= " UPDATE rs_formularze_pozycje SET "            
        UPD+= "kolumna="+str(Kolumna)+", wiersz="+str(Wiersz)
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        UPD+=" AND kolumna="+str(KolumnaS)+" AND wiersz="+str(WierszS)+"; "

        UPD+= " UPDATE rs_formularze_definicje SET "            
        UPD+= "kolumna="+str(Kolumna)+", wiersz="+str(Wiersz)
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        UPD+=" AND kolumna="+str(KolumnaS)+" AND wiersz="+str(WierszS)+" ;"

        #powrt przeniesionej w pierwszym updacie kom. na adres starej 
        UPD+= " UPDATE rs_formularze_pozycje SET "            
        UPD+= "kolumna="+str(KolumnaS)+", wiersz="+str(WierszS)
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        UPD+= " AND kolumna=99 AND wiersz="+str(Wiersz+100)+" ;"

        UPD+= " UPDATE rs_formularze_definicje SET "            
        UPD+= "kolumna="+str(KolumnaS)+", wiersz="+str(WierszS)
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        UPD+= " AND kolumna=99 AND wiersz="+str(Wiersz+100)+" ;"

        stat,daneO,wyn1,wyn2=self.PolSQL.Execute(UPD,1)
    
        if stat<>'OK':
            stat='Bdy przenoszenia komrki :'+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   PRZENOSZENIE WIERSZA/KOLUMNY (12)
#-------------------------------------------------------------------------------

if Fun == 12 and stat=='OK':
    if not UprEdycja:
        stat = 'Brak uprawnie do modyfikowania danych'
        dane.append(stat)
    
    if stat == 'OK':
        # bezpieczne przesuniecie dla przenumerowania wierszy i kolumn,
        # wynikajace z szerokosci pol
        # dokladne sprawdzenie warunkow tworzenia sql-a umozliwi kontrole parametrow
        # warto sprawdzac parametry, bo funkcje grida moga podac wieksze wymiary
        # np 'puszczenie' przesuwanego wiersza/kolumny poza gridem w funkcji drag&drop
        PrzesuniecieWierszy = 500
        PrzesuniecieKolumn = 50

        WierszSkad = Wiersz
        KolumnaSkad = Kolumna
        WierszDokad = WierszS
        KolumnaDokad = KolumnaS
        
        sql ="SELECT l_wierszy,l_kolumn FROM rs_formularze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"' ;"
        stat,Wymiary,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania maksymalnych wartoci: '+stat
        elif Wymiary[0][0] > PrzesuniecieWierszy-1:
            # ograniczenie zwiazane z szerokoscia pola 'wiersz'
            stat = 'Za duo wierszy - operacja niemoliwa.'
        elif Wymiary[0][1] > PrzesuniecieKolumn-1:
            # ograniczenie zwiazane z szerokoscia pola 'kolumna'
            stat = 'Za duo kolumn - operacja niemoliwa.'
        
    if stat == 'OK':
        # zamiast pisac dwa razy uzyjemy podstawienia poniewaz mechanizm
        # przesuwania wierszy i kolumn jest taki sam :-)
        Pole = ''
        Przesuniecie = 0
        PoleSkad = 0
        PoleDokad = 0
        UPD = ''
        
        if WierszSkad > 0 and WierszDokad > 0 and KolumnaSkad == 0 and KolumnaDokad == 0:
            Pole = 'wiersz'
            Przesuniecie = PrzesuniecieWierszy
            PoleSkad = WierszSkad
            PoleDokad = WierszDokad
            if PoleSkad > Wymiary[0][0] or PoleDokad > Wymiary[0][0]:
                stat = 'Przekroczona maksymalna warto dla wiersza: '+str(PoleSkad)+','+str(PoleDokad)

        elif WierszSkad == 0 and WierszDokad == 0 and KolumnaSkad > 0 and KolumnaDokad > 0:
            Pole = 'kolumna'
            Przesuniecie = PrzesuniecieKolumn
            PoleSkad = KolumnaSkad
            PoleDokad = KolumnaDokad
            if PoleSkad > Wymiary[0][1] or PoleDokad > Wymiary[0][1]:
                stat = 'Przekroczona maksymalna warto dla kolumny: '+str(PoleSkad)+','+str(PoleDokad)
    
    if stat == 'OK':
        if Przesuniecie == 0:
            stat = 'Brak przesuniecia.'


    if stat == 'OK':
        # lista komorek, ktore zawieraja bezposrednie odwolanie
        # do przesuwanego wiersza/kolumny
        sql ="SELECT wiersz,kolumna,nr_poz FROM rs_formularze_definicje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        sql+=" AND sposob='20' AND f_"+Pole+"="+str(PoleSkad)
        sql+=" ORDER BY wiersz,kolumna,nr_poz; "

        stat,KomBezp,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania formu modyfikowanych: '+stat
            
    if stat == 'OK':
        # lista komorek z wartosciami, ktore maja odwolania do wierszy/kolumn,
        # ktore ulegaja przesunieciu
        sql ="SELECT wiersz,kolumna,nr_poz,f_"+Pole+" FROM rs_formularze_definicje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        sql+=" AND sposob='20'"
        if PoleSkad < PoleDokad:
            sql+=" AND f_"+Pole+">"+str(PoleSkad)+" AND f_"+Pole+"<="+str(PoleDokad)
        else:
            sql+=" AND f_"+Pole+">="+str(PoleDokad)+" AND f_"+Pole+"<"+str(PoleSkad)
        sql+=" ORDER BY wiersz,kolumna,nr_poz; "

        stat,KomPrzesuw,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania formu przesuwanych: '+stat

    # a teraz tworzymy sql-a modyfikujacego
    if stat == 'OK':

        # najpierw modyfikacja odwolan (wartosci) w formulach do innych komorek formularza
        # zanim zmienia sie ich wiersze/kolumny
        
        # komorki bezposrednio przenoszone
        for i in xrange(len(KomBezp)):
            UPD+="UPDATE rs_formularze_definicje SET f_"+Pole+"="+str(PoleDokad)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND wiersz="+str(KomBezp[i][0])+" AND kolumna="+str(KomBezp[i][1])
            UPD+=" AND nr_poz="+str(KomBezp[i][2])+"; "

        # komorki w wierszach/kolumnach, ktore ulegaja wymuszonemu przesunieciu
        for i in xrange(len(KomPrzesuw)):
            UPD+="UPDATE rs_formularze_definicje SET f_"+Pole+"="

            if PoleSkad < PoleDokad:
                # wiersze/kolumny cofaja sie na opuszczona pozycje
                UPD+=str(KomPrzesuw[i][3]-1)
            else:
                # wiersze/kolumny odsuwaja sie dalej aby zrobic miejsce
                UPD+=str(KomPrzesuw[i][3]+1)
                
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND wiersz="+str(KomPrzesuw[i][0])+" AND kolumna="+str(KomPrzesuw[i][1])
            UPD+=" AND nr_poz="+str(KomPrzesuw[i][2])+"; "

        # przeniesienie wybranego wiersza/kolumny na nowa pozycje
        UPDWybrany ="UPDATE rs_formularze_pozycje SET "+Pole+"="+str(PoleDokad)
        UPDWybrany+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPDWybrany+=" AND "+Pole+"="+str(PoleSkad)+"; "
        
        UPDWybrany+="UPDATE rs_formularze_definicje SET wiersz="+str(WierszDokad)
        UPDWybrany+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPDWybrany+=" AND wiersz="+str(WierszSkad)+"; "
        
        if PoleDokad > PoleSkad:
            # przesuniecie wierszy/kolumn lezacych powyzej na bezpieczny zakres
            UPD+="UPDATE rs_formularze_pozycje SET "+Pole+"="+Pole+"+"+str(Przesuniecie)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">"+str(PoleSkad)+" AND "+Pole+"<="+str(PoleDokad)+"; "
            
            UPD+="UPDATE rs_formularze_definicje SET "+Pole+"="+Pole+"+"+str(Przesuniecie)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">"+str(PoleSkad)+" AND "+Pole+"<="+str(PoleDokad)+"; "
    
            # przeniesienie wybranego wiersza/kolumny na nowa pozycje
            UPD+=UPDWybrany
            
            # powrot przesunietych wierszy/kolumn z bezpiecznego zakresu na nowe pozycje
            UPD+="UPDATE rs_formularze_pozycje SET "+Pole+"="+Pole+"-"+str(Przesuniecie+1)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">"+str(Przesuniecie)+"; "
            
            UPD+="UPDATE rs_formularze_definicje SET "+Pole+"=wiersz-"+str(Przesuniecie+1)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">"+str(Przesuniecie)+"; "
    
        elif PoleDokad < PoleSkad:
            # przesuniecie wierszy/kolumn lezacych ponizej na bezpieczny zakres
            UPD+="UPDATE rs_formularze_pozycje SET "+Pole+"="+Pole+"+"+str(Przesuniecie)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">="+str(PoleDokad)+" AND "+Pole+"<"+str(PoleSkad)+"; "
            
            UPD+="UPDATE rs_formularze_definicje SET "+Pole+"="+Pole+"+"+str(Przesuniecie)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">="+str(PoleDokad)+" AND "+Pole+"<"+str(PoleSkad)+"; "
    
            # przeniesienie wybranego wiersza/kolumny na nowa pozycje
            UPD+=UPDWybrany
            
            # powrot przesunietych wierszy/kolumn z bezpiecznego zakresu na nowe pozycje
            UPD+="UPDATE rs_formularze_pozycje SET "+Pole+"="+Pole+"-"+str(Przesuniecie-1)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">"+str(Przesuniecie)+"; "
            
            UPD+="UPDATE rs_formularze_definicje SET "+Pole+"="+Pole+"-"+str(Przesuniecie-1)
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+">"+str(Przesuniecie)+"; "
        
    if stat == 'OK' and UPD <> '':
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji arkusza: '+stat


#-------------------------------------------------------------------------------
#---   KOPIOWANIE WIERSZA/KOLUMNY (13)
#-------------------------------------------------------------------------------

if Fun == 13 and stat=='OK':
    if not UprEdycja:
        stat = 'Brak uprawnie do modyfikowania danych'
        dane.append(stat)
    
    if stat == 'OK':
        # kontrola wymiarow
        sql ="SELECT l_wierszy,l_kolumn FROM rs_formularze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"' ;"
        stat,Wymiary,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania maksymalnych wartoci: '+stat

    if stat == 'OK':
        WierszSkad = Wiersz
        KolumnaSkad = Kolumna
        WierszDokad = WierszS
        KolumnaDokad = KolumnaS
        
        # zamiast pisac dwa razy uzyjemy podstawienia poniewaz mechanizm
        # kopiowania wierszy i kolumn jest taki sam :-)
        Pole = ''
        PoleSkad = 0
        PoleDokad = 0
        UPD = ''
        
        if WierszSkad > 0 and WierszDokad > 0 and KolumnaSkad == 0 and KolumnaDokad == 0:
            Pole = 'wiersz'
            PoleSkad = WierszSkad
            PoleDokad = WierszDokad
            if PoleSkad > Wymiary[0][0]:
                stat = 'Przekroczona maksymalna warto dla wiersza SKD: '+str(PoleSkad)

            if stat == 'OK':
                if PoleDokad > Wymiary[0][0]:
                    stat = 'Przekroczona maksymalna warto dla wiersza DOKAD: '+str(PoleDokad)

        elif WierszSkad == 0 and WierszDokad == 0 and KolumnaSkad > 0 and KolumnaDokad > 0:
            Pole = 'kolumna'
            PoleSkad = KolumnaSkad
            PoleDokad = KolumnaDokad
            if PoleSkad > Wymiary[0][1]:
                stat = 'Przekroczona maksymalna warto dla kolumny SKD: '+str(PoleSkad)
                
            if stat == 'OK':
                if PoleDokad > Wymiary[0][1]:
                    stat = 'Przekroczona maksymalna warto dla kolumny DOKD: '+str(PoleDokad)
        
        else:
            stat = 'Nieprawidowa warto dla wiersza lub kolumny'
            
    if stat == 'OK':
        if PoleSkad == 0:
            stat = 'Bdna pozycja SKD'

    if stat == 'OK':
        if PoleDokad == 0:
            stat = 'Bdna pozycja DOKD'
            
    if stat == 'OK':
        if PoleSkad == PoleDokad:
            stat = 'Pozycja SKD jest taka sama, jak pozycja DOKD'

    if stat == 'OK':
        stat, PolaDefinicji = rsglobal.PolaTabeli(self.PolSQL,'rs_formularze_definicje')

    if stat == 'OK':
        # pobranie wartosci kopiowanych w ramach tabeli pozycji
        sql ="SELECT COALESCE(nazwa,''),COALESCE(opis,''),"
        sql+=" wartosc,wytluszczenie,wyposrodkowanie,wiersz,kolumna"
        sql+=" FROM rs_formularze_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        sql+=" AND "+Pole+"="+str(PoleSkad)+"; "
        
        stat,DPozycje,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania kopiowanych pozycji: '+stat

    if stat == 'OK':
        # a teraz tworzymy sql-a modyfikujacego
        
        # usuwamy ewentualne definicje, ktore dotyczyly kolumny/wiersza docelowego
        UPD = "DELETE FROM rs_formularze_definicje"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPD+=" AND "+Pole+"="+str(PoleDokad)+"; "
        
        # dodajemy definicje pobrane z kopiowanego wiersza/kolumny
        UPD+="INSERT INTO rs_formularze_definicje ("
        for i in xrange(len(PolaDefinicji)):
            UPD+= PolaDefinicji[i]
            if i < len(PolaDefinicji)-1:
                UPD+=","
        UPD+= ") SELECT "
        
        for i in xrange(len(PolaDefinicji)):
            if PolaDefinicji[i] == Pole:
                UPD+= str(PoleDokad)
            else:
                UPD+= PolaDefinicji[i]
            if i < len(PolaDefinicji)-1:
                UPD+= ","
                
        UPD+=" FROM rs_formularze_definicje"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPD+=" AND "+Pole+"="+str(PoleSkad)+"; "
        
        # aktualizujemy w dodanych formulach odwolania do samego siebie
        # (wiersza/kolumny) tak, aby np sumowanie dzialalo
        UPD+="UPDATE rs_formularze_definicje SET f_"+Pole+"="+str(PoleDokad)
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPD+=" AND "+Pole+"="+str(PoleDokad)
        UPD+=" AND sposob='20' AND f_"+Pole+"="+str(PoleSkad)+"; "
        
        
        # aktualizujemy tabele pozycji:
        # przy kopiowaniu wiersza komorki z wszystkich kolumn
        # przy kopiowaniu kolumny komorki z wszystkich wierszy
        
        for d in xrange(len(DPozycje)):
            UPD+="UPDATE rs_formularze_pozycje SET "
            UPD+=" nazwa='"+DPozycje[d][0]+"',"
            UPD+=" opis='"+DPozycje[d][1]+"',"
            UPD+=" wartosc="+str(DPozycje[d][2])+","
            UPD+=" wytluszczenie="+str(DPozycje[d][3])+","
            UPD+=" wyposrodkowanie="+str(DPozycje[d][4])
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            UPD+=" AND "+Pole+"="+str(PoleDokad)
            
            if Pole == 'wiersz':
                UPD+=" AND kolumna="+str(DPozycje[d][6])
            else:
                UPD+=" AND wiersz="+str(DPozycje[d][5])
            UPD+="; "
                
    if stat == 'OK' and UPD <> '':
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji arkusza: '+stat
            

#-------------------------------------------------------------------------------
#---   TWORZENIE FORMULY SUMOWANIA WYBRANYCH KOMOREK (14)
#-------------------------------------------------------------------------------

if Fun == 14 and stat=='OK':
    if not UprEdycja:
        stat = 'Brak uprawnie do modyfikowania danych'
        dane.append(stat)

    if stat == 'OK':
        if Wiersz == 0:
            stat = 'Wiersz nie moe mie wartosci zerowej.'

    if stat == 'OK':
        if Kolumna == 0:
            stat = 'Kolumna nie moe mie wartosci zerowej.'
    
    if stat == 'OK':
        if len(ListaKomorek) == 0:
            stat = 'Pusta lista komrek'

    if stat == 'OK':
        # kontrola wymiarow
        sql ="SELECT l_wierszy,l_kolumn FROM rs_formularze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"' ;"
        stat,Wymiary,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania maksymalnych wartoci: '+stat

    if stat == 'OK':
        if Wiersz > Wymiary[0][0]:
            stat = 'Wiersz przekracza wymiar formularza.'

    if stat == 'OK':
        if Kolumna > Wymiary[0][1]:
            stat = 'Kolumna przekracza wymiar formularza.'
    
    if stat == 'OK':
        UPD = ''
        # zmiana charakteru komorki, na taki, ktory pozwala miec definicje
        UPD+="UPDATE rs_formularze_pozycje SET opis=''"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPD+=" AND wiersz="+str(Wiersz)+" AND kolumna="+str(Kolumna)+"; "

        # usuniecie ewentualnej starej definicji
        UPD+= "DELETE FROM rs_formularze_definicje"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        UPD+=" AND wiersz="+str(Wiersz)+" AND kolumna="+str(Kolumna)+"; "
        
        # dodanie definicji sumowan wybranych komorek
        for i in xrange(len(ListaKomorek)):
            UPD+="INSERT INTO rs_formularze_definicje"
            UPD+=" (firma_id,formularz_id,wiersz,kolumna,nr_poz,"
            UPD+="  sposob,dzialanie,ujemna,f_wiersz,f_kolumna,f_nr_poz)"
            UPD+=" VALUES"
            UPD+=" ('"+self.firma_id+"','"+FormularzId+"',"+str(Wiersz)+","+str(Kolumna)+","+str(i+1)+","
            UPD+=" '20','+','=',"+str(ListaKomorek[i][0])+","+str(ListaKomorek[i][1])+",0); "
        
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd tworzenia definicji sumy komrek: '+stat
            

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete,  9-kopiowanie)
#-------------------------------------------------------------------------------

if Fun in [1,5,6,9,11,12] and stat=='OK':
    wyn2 = []
    sql ="SELECT wiersz,kolumna,COALESCE(nazwa,''),wartosc,COALESCE(opis,'')"
    sql+=" FROM rs_formularze_pozycje"
    sql+=" WHERE firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"'"
    sql+=" ORDER BY wiersz,kolumna;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bdy przy pobieraniu pozycji formularze: '+stat
        dane.append(stat)
        
    if stat == 'OK':
        # [0] lista komorek zawierajacych definicje
        sql ="SELECT DISTINCT wiersz,kolumna FROM rs_formularze_definicje"
        sql+=" WHERE firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"'"
        sql+=" ORDER BY wiersz,kolumna;"
        stat,Definicje,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bdy przy pobieraniu definicji pozycji: '+stat
            dane.append(stat)
        else:
            wyn2.append(Definicje)
            
    if stat == 'OK':
        # [1] lista komorek zawierajacych opis<>'', wiec nie moze miec definicji
        Opisy = []
        for i in xrange(len(dane)):
            if dane[i][4] <> '':
                Opisy.append([dane[i][0],dane[i][1]])
        wyn2.append(Opisy)

    if stat == 'OK':
        # [2] atrybuty dla komorek grida
        sql ="SELECT wiersz,kolumna,COALESCE(wyposrodkowanie,FALSE),COALESCE(wytluszczenie,FALSE)"
        sql+=" FROM rs_formularze_pozycje"
        sql+=" WHERE firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"'"
        sql+=" ORDER BY wiersz,kolumna;"
        stat,Atrybuty,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bdy przy pobieraniu atrybutw pozycji: '+stat
            dane.append(stat)
        else:
            wyn2.append(Atrybuty)
