#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_generator.py
# Purpose:          dodaje/pobiera/usuwa raporty generatora
# Author:           Piotr Witkowski
# Created:          2016/03/18
# RCS-ID:           $Id: fs_generator.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------
#
# 2018-03-19, Aleksander Bargie 10961 - przygotowanie do bdw w tworzeniu pliku .xlsx
# 2021-01-19  Wojciech Skowron   12202 - filtr na nazw raportu
# 2021-04-15  Wojciech Skowron   12174 - poprawiona obsuga pliku
# 2022-02-07  Wojciech Skowron   12849 - stat dodany do bdu zapytania
# 2022-07-13  Aleksander Bargie 12989 - Komunikat gdy tworzenie raportu pdf nie powiedzie si
# 2024-02-20 Wojciech Skowron    13695 - Przyjmowany stat z ZapiszXLSGenerator


import binascii
import codecs
import os
import sys
import tempfile
import time

import rsglobal
import rs_print_util
from funkcje import fs_generator_pdf_html
from funkcje import fs_pliki_office

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    #WS 2021-01-19 - NazwaF
    SlPar={'ModulF':[5,6],'RaportF':[5,6],'NazwaF':[5,6],'Raport':[6,8,9,10,11,12,13,14,15,20,21,],
           'NowyR':[21,],'Wypelnienie':[10,11,12,13,14,15,20], }

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_generator z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6]:
        ModulF = klucze['ModulF']
        RaportF = klucze['RaportF']
        NazwaF = klucze['NazwaF']  #WS 2021-01-19
    if Funkcja in [6,8,9,10,11,12,13,14,15,20,21,]:
        Raport = klucze['Raport']
    if Funkcja in [21,]:
        NowyR = klucze['NowyR']
    if Funkcja in [10,11,12,13,14,15,20]:
        Wypelnienie = klucze['Wypelnienie']

        #SQL = klucze['SQL']
        #Kolumny = klucze['Kolumny']
        #Naglowek = klucze['Naglowek']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

UPR = False
if self.operator_id == STANDARD_OPERATOR_ID:
    UPR = True

#-------------------------------------------------------------------------------
#---   USUWANIE DANYCH RAPORTU (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6 and UPR:
    DEL="DELETE FROM rs_raporty WHERE firma_id= '"+self.firma_id+"' AND raport_id='"+str(Raport)+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(DEL,1)
    if stat<>'OK':
        stat = 'Bdy usuwania danych :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH RAPORTU (21)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 21 and UPR:
    sql = "SELECT 1 FROM rs_raporty WHERE firma_id= '"+self.firma_id+"' AND raport_id = '"+str(NowyR)+"';"
    stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(Dane)>0:
        stat = "Podany symbol ju istnieje, prosz o podanie unikalnego symbolu"
    elif stat=='OK':
        #kopiowanie raportu
        SQL = "INSERT INTO rs_raporty (firma_id, raport_id,nazwa,szer_okna,wys_okna,naglowek,kolumny,tabela,sql_przed,sql_raport,sql_po, modul_id ) "
        SQL +="SELECT firma_id, '"+str(NowyR)+"',nazwa,szer_okna,wys_okna,naglowek,kolumny,tabela,sql_przed,sql_raport,sql_po, modul_id "
        SQL += "FROM rs_raporty WHERE firma_id= '"+self.firma_id+"' AND raport_id='"+str(Raport)+"';"
        #kopiowanie parametrw raportu
        SQL += "INSERT INTO rs_raporty_parametry(firma_id,raport_id,lp,nazwa,opis,typ,dlugosc,po_przec,wsp_gora,wsp_lewa,wsp_dlug) "
        SQL +="SELECT firma_id, '"+str(NowyR)+"',lp,nazwa,opis,typ,dlugosc,po_przec,wsp_gora,wsp_lewa,wsp_dlug "
        SQL += "FROM rs_raporty_parametry WHERE firma_id= '"+self.firma_id+"' AND raport_id='"+str(Raport)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

    if stat<>'OK':
        stat = 'Bdy kopiowania raportu :\n'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE NAZWY RAPORTU (9)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 9:
    Select="SELECT nazwa FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"' "
    Select+="AND raport_id='"+str(Raport)+"' ORDER BY lp;"
    stat,Dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania nazwy :'+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Funkcja in [1,5,6]) and (stat=='OK') :
    Filtr="firma_id='"+self.firma_id+"' "
    if ModulF != '':
        Filtr = Filtr+" AND modul_id LIKE '"+str(ModulF)+"%'"
    if RaportF != '':
        Filtr = Filtr+" AND raport_id LIKE '"+str(RaportF)+"%'"
    #WS 2021-01-19
    if NazwaF != '':
        Filtr = Filtr + " AND upper(nazwa) LIKE upper('%"+str(NazwaF)+"%')"
    if int(self.operator_id) > 0:
        Select="SELECT DISTINCT grupa_id FROM rs_grupa_operator_oddzial WHERE "
        Select+="firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)+";"
        stat,Dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania filtra :'+stat
            dane.append(stat)
        else:
            LGr="'Brak',"
            for gr in Dane:
                LGr=LGr+"'"+gr[0]+"',"
            Filtr = Filtr+" AND modul_id IN ("+str(LGr)[0:-1]+")"
    Select="SELECT raport_id,nazwa,modul_id FROM "
    Select+="rs_raporty WHERE "+Filtr+" ORDER BY raport_id;"
    stat,Dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   Wykonanie zapytania (10,11,12,13,14,15,20)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [10,11,12,13,14,15,20]:
    Select="SELECT login FROM rs_operatorzy WHERE operator_id = '"+str(self.operator_id)+"';"
    stat,operator,dump,dump = self.PolSQL.Execute(Select,3)
    if stat == 'OK':
        Select="SELECT firma_id,raport_id,nazwa,szer_okna,wys_okna,naglowek,kolumny,tabela,sql_przed,"
        Select+="sql_raport,sql_po,autor,modul_id,czcionka_pdf,czy_znakowy,czy_graficzny,czy_agata "
        Select+="FROM rs_raporty WHERE firma_id='"+self.firma_id+"' AND raport_id='"+str(Raport)+"';"
        stat,defraportu,wyn1,tr = self.PolSQL.Execute(Select,3)


    if stat<>'OK':
        stat = 'Bdy pobierania raportu :'+stat

    if stat=='OK':
        sqlprzed = defraportu[0][8]
        sqlraport = defraportu[0][9]
        sqlpo = defraportu[0][10]

        naglowek = defraportu[0][5]
        # sprawdzenie, czy jest where na firma_id
        if not sqlprzed:
            sqlprzed=''
        if not sqlraport:
            sqlraport=''
        if not sqlpo:
            sqlpo=''

        i = []
        i.append(len(sqlprzed))
        i.append(len(sqlraport))
        i.append(len(sqlpo))

        sqlprzed = sqlprzed.replace(u'$firma', str(self.firma_id))
        sqlraport = sqlraport.replace(u'$firma', str(self.firma_id))
        sqlpo = sqlpo.replace(u'$firma', str(self.firma_id))

        naglowek = naglowek.replace(u'$firma', str(self.firma_id))
        if Funkcja in [13,14]:
            naglowek = naglowek.replace(u'\n', u'<br/>') #PW 2016-10-28

        if i[0] == len(sqlprzed) and (sqlprzed not in ['None',None,'']):
            stat = u'Niepoprawny raport - brak definicji firmy w zapytaniu sql przed.'
        if i[1] == len(sqlraport):
            stat = u'Niepoprawny raport - brak definicji firmy w zapytaniu sql raport.'
        if i[2] == len(sqlpo) and (sqlpo not in ['None',None,'']):
            stat = u'Niepoprawny raport - brak definicji firmy w zapytaniu sql po.'

    if stat=='OK':
        sqlprzed = sqlprzed.replace(u'$oddzial', str(self.oddzial_id))
        sqlraport = sqlraport.replace(u'$oddzial', str(self.oddzial_id))
        sqlpo = sqlpo.replace(u'$oddzial', str(self.oddzial_id))
        naglowek = naglowek.replace(u'$oddzial', str(self.oddzial_id))
        Kolumny = defraportu[0][6].splitlines()  #Kolumny z pola memo

        if self.okres_id not in ['<None>','None',None]:
            okres=str(self.okres_id).strip()
        else:
            okres=''
        
        sqlprzed = sqlprzed.replace(u'$okres', okres)
        sqlraport = sqlraport.replace(u'$okres', okres)
        sqlpo = sqlpo.replace(u'$okres', okres)
        naglowek = naglowek.replace(u'$okres', okres)

        for i in range(len(Wypelnienie)):
            sqlprzed =sqlprzed.replace('$$' + Wypelnienie[i][0] +'$$', str(Wypelnienie[i][1]).strip("'"))
            sqlraport =sqlraport.replace('$$' + Wypelnienie[i][0] +'$$', str(Wypelnienie[i][1]).strip("'"))
            sqlpo =sqlpo.replace('$$' + Wypelnienie[i][0] +'$$', str(Wypelnienie[i][1]).strip("'"))
            naglowek = naglowek.replace('$$' + Wypelnienie[i][0] +'$$', str(Wypelnienie[i][1]).strip("'"))
            for j,k in enumerate(Kolumny):
                Kolumny[j]=k.replace('$$' + Wypelnienie[i][0] +'$$', str(Wypelnienie[i][1]).strip("'"))

        sqlraport = sqlraport.replace('from', 'FROM')
        sqlraport = sqlraport.replace('From', 'FROM')
        SQL = sqlraport.split(' ')
        nag = u'Program:Anakonda, Firma:'+self.firma_id+u', Oddzial:'+self.oddzial_id+u', Operator:'+operator[0][0]+u', Wykonano dnia:'+time.strftime("%Y.%m.%d %H:%M")
        NagRozdzielenie = naglowek.split('&&---')
        Zakonczenie=''
        naglowek = NagRozdzielenie[0]
        if len(NagRozdzielenie)>2:
            stat = u'Wicej ni jeden znak rozdzielenia nagwka.'
        elif len(NagRozdzielenie)==2:
            Zakonczenie = NagRozdzielenie[1]

        #wstawienie do zakoczenia i nagwka odpowiednich kolumn
        if stat =='OK' and (sqlprzed not in ['None',None,'']) and Funkcja!=20:
            stat,daneprzed,wyn1,dump = self.PolSQL.Execute(sqlprzed,3)
            if stat<>'OK':
                stat = u'Bdy w wykonaniu zapytania sql przed.'
            else:
                if len(daneprzed)>1:
                    stat = 'W zapytaniu sql przed, wystpuje wicej ni jeden wynik'

                elif len(daneprzed) == 1:
                    for i in range(len(wyn1)):
                        if str(daneprzed[0][i])<>'':
                            naglowek =naglowek.replace('##' + str(wyn1[i][0]) +'##', str(daneprzed[0][i]).strip("'"))


        if stat =='OK' and len(Zakonczenie)>0 and (sqlpo not in ['None',None,'']) and Funkcja!=20:
            stat,danepo,wyn2,dump = self.PolSQL.Execute(sqlpo,3)
            if stat<>'OK':
                stat = u'Bdy w wykonaniu zapytania sql po.'
            else:
                if len(danepo)>1:
                    stat = 'W zapytaniu sql po wystpuje wicej ni jeden wynik'

                elif len(danepo) == 1:
                    for i in range(len(wyn2)):
                        if str(danepo[0][i])<>'':
                            Zakonczenie =Zakonczenie.replace('##' + str(wyn2[i][0]) +'##', str(danepo[0][i]).strip("'"))

        Naglowek = [nag,naglowek,] #Jeeli chcemy doda kolejne wiersze do nagwka dodajemy do listy

    if stat == 'OK' and Funkcja!=20: #nie musz by uzupenione kolumny gdy sprawdzamy raport
        try:
            Kodowanie = 'iso8859_2'
            sortowac = [[],[]]  # zmienna przechowujca ktre elementy s sortowane [[ktra kolumna],[jaka kolejno]]
                                # jeli element jest wypity to ma warto 0
            sql = u''           # zapytanie sql
            Nazwa=[]            # Nazwa kolumny z pola memo
            Typ=[]              # Typ kolumny z pola memo
            Dlugosc=[]          # Dugo kolumny z pola memo
            PoPrzecinku=[]      # Ilo miejsc po przecinku dla z pola memo
            Podsumowanie=[]     # Kolumny wypinane do podgrup z pola memo
            Sumowac=[]          # Kolumny po ktrych sumujemy o ile s to pola typu numeric z pola memo
            Srednia=[]          # Kolumny po ktrych sumujemy o ile s to pola typu numeric z pola memo
            try:
                for k in range(len(Kolumny)):
                    stat = u'nazwa'
                    Nazwa.append(str(Kolumny[k].split(',')[0]).strip())
                    stat = u'typ'
                    Typ.append(Kolumny[k].lower().split(',')[1].strip())
                    stat = u'dugo'
                    Dlugosc.append(int(float(Kolumny[k].split(',')[2])))
                    stat=u'po przecinku'
                    PoPrzecinku.append(int(float(Kolumny[k].split(',')[3])))
                    stat= u'podsumowanie'
                    Podsumowanie.append(int(float(Kolumny[k].split(',')[4])))
                    stat = u'sumowac'
                    Sumowac.append(Kolumny[k].split(',')[5].strip())
                    stat = u'rednia'
                    Srednia.append(Kolumny[k].split(',')[6].strip())
                    stat = 'OK'
            except:
                pass
            Cechy = [Nazwa,Typ,Dlugosc,PoPrzecinku,Podsumowanie,Sumowac,Srednia]
            for i in range(len(SQL)):
                sql += SQL[i].strip()+u' '
        except:
            stat = u'Bdne uzupenione pole '+ stat + u' w '+ str(k) + u' wierszu.'

    if stat =='OK' and Funkcja!=20:
        try:
            spr = sql.split('FROM')
            if len(spr)==1:
                stat = u'Sowo kluczowe FROM nie jest napisane duymi literami'
        except:
            pass

if stat == 'OK' and Funkcja in [12,13,14,15] and len(Nazwa):   ##Przygotowanie do txt
    sql = sql.strip()
    sql = sql.strip(";")

    IleKolumn = range(len(Nazwa))  # indeksy wszystkich kolumn ktre nie s wypite
    Sumowanie=[]                   # Indeksy kolumn ktre s sumowane
    Su=[]                          # Pomocnicza
    Avs=[]                         # Indeksy kolumn ktre s brane do redniej
    NagKol=u''                     # Wypisane nagwki kolumn
    podsuma = u''                  # i-ty wiersz z danymi
    Sum = [[],]                    # Sumy z danych [ [sumy dla pierwszego wypicia], [drugie wypicie] ....[n-te wypicie],
                                   # [ostatnia suma jako podsumowanie wszystkich danych] ]
    Ilosc=[[],]                    # pomocnicza do Avs i podobna do Sum - zlicza ilo wystpowanych wartoci
    stare = [1]                    # poprzedni wiersz z danymi - i-1
    kol=[]                         # Numery kolumn wypitych
    mmin = 1                       # zmienna pomocnicza

    #for w in range(len(Sumowac)):
    #    if Sumowac[w] == 'T':
    #        Sumowanie.append(w)

    [Su.append(x) for x in range(len(Sumowac)) if Sumowac[x] == 'T']
    [Avs.append(x) for x in range(len(Srednia)) if Srednia[x] == 'T']
    [Sumowanie.append(x) for x in Su]
    [Sumowanie.append(x) for x in Avs]

    #dodawanie po ktrych kolumnach sortujemy (order by)
    for w in IleKolumn:
        if int(Podsumowanie[w]) > 0:
            sortowac[0].append(w+1)             # ktra kolumna
            sortowac[1].append(int(Podsumowanie[w]))   # kolejno

    for i in range(len(sortowac[0])):
        for j in range(len(sortowac[0])):
            if sortowac[1][j]==mmin:
                kol.append(sortowac[0][j])
                mmin+=1

    for w in kol:
        IleKolumn.remove(w-1)
        stare.append([])
        Sum.append([])
        Ilosc.append([])

    for w in IleKolumn:
        [Sum[j].append(0) for j in range(len(Sum))]
        [Ilosc[j].append(0) for j in range(len(Ilosc))]


        roznica = int(Dlugosc[w])-len(Nazwa[w])
        if roznica>0:
            NagKol += Nazwa[w]+' '*(roznica)
        elif roznica<0:
            NagKol += Nazwa[w][:roznica]
        elif roznica==0:
            NagKol += Nazwa[w]
        NagKol += '|'


    if len(sortowac[0])>0:
        pom = sql.split('ORDER BY')
        if len(pom)==1:
            pom = sql.split('order by')
        OrderBy = u''
        try:
            spr = pom[1].split(',')
            for x in spr:
                OrderBy += u','+x

            sql = pom[0]
        except:
            OrderBy=u''

        sql += ' ORDER BY '
        for w in range(len(kol)):
            sql += str(kol[w])
            if w < len(kol)-1:
                sql +=','
        if OrderBy!=u'':
            sql += OrderBy
        sql += ';'


#-------------------------------------------------------------------------------
#---   Wykonanie zapytania
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja ==20:
    Dane = u''
    if sqlprzed != 'None':
        przed,dump,dump,dump = self.PolSQL.Execute(sqlprzed,3,CzyDodawacBlad=True)
        Dane += u'Zapytanie SQL PRZED:\n'+sqlprzed+ '\n\n'+przed+ '\n\n'

    if sqlraport != 'None':
        raport,dump,dump,dump = self.PolSQL.Execute(sqlraport,3,CzyDodawacBlad=True)
        Dane += u'Zapytanie SQL RAPORT:\n'+sqlraport+ '\n\n'+raport+ '\n\n'

    if sqlpo != 'None':
        po, dump, dump, dump = self.PolSQL.Execute(sqlpo, 3, CzyDodawacBlad=True)
        Dane += u'Zapytanie SQL PO:\n'+sqlpo+ '\n\n'+po


#-------------------------------------------------------------------------------
#---   Wykonanie zapytania
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [10, 11, 12,13,14,15]:
    stat,Dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bdnie wykonane zapytanie: '+stat  #WS 2022-02-07 - dodany stat
        dane.append(stat)
    elif len(Dane)==0:
        stat = 'Brak danych do raportu'
    elif len(Typ)<> len(wyn1):
        stat = 'Nie zgadza si ilo kolumn zapytania sql z definicj kolumn'
    if stat=='OK':
        sprT=[]
        for i in range(len(wyn1)):
            if stat =='OK' and Typ[i].upper()=='S' and wyn1[i][1][0].upper().strip()<>'S':
                stat = u'Bdnie zdefiniowany typ S '+str(i+1)+u' kolumny'
            if stat =='OK' and Typ[i].upper()=='N' and wyn1[i][1][0].upper() not in ['N','I']:
                stat = u'Bdnie zdefiniowany typ N '+str(i+1)+u' kolumny'
            if stat =='OK' and Typ[i].upper()=='D' and wyn1[i][1][0].upper() not in ['S','D']:
                stat = u'Bdnie zdefiniowany typ D '+str(i+1)+u' kolumny'
            if stat =='OK' and Typ[i].upper()=='B' and wyn1[i][1][0].upper() <>'B':
                stat = u'Bdnie zdefiniowany typ B '+str(i+1)+u' kolumny'


#-------------------------------------------------------------------------------
#---   Funkcja tworzca HTML (14)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja ==14:
    Plik = tempfile.mktemp('.html')
    html = fs_generator_pdf_html.RSGeneratorHTML(self,Plik, Naglowek,Zakonczenie, Dane,Cechy,
                                                 sortowac,IleKolumn,Sumowanie, Sum,Avs,Ilosc, kol, stare)
    wydruk = html.UtworzHTMLGeneratora()


#-------------------------------------------------------------------------------
#---   Funkcja tworzca PDF (13)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja ==13:
    Plik = tempfile.mktemp('.pdf')
    pdf = fs_generator_pdf_html.RSGeneratorPDF(self,Plik, Naglowek,Zakonczenie, Dane,Cechy,
                                               sortowac,IleKolumn,Sumowanie, Sum,Avs,Ilosc, kol, stare)
    #AB 13.07.22r dodana obsluga przez stat
    stat = pdf.UtworzPDFGeneratora()
    if stat != 'OK':
        stat = "Wystpi problem podczas generowania raportu w formacie PDF. Wybierz inny format wydruku."


#-------------------------------------------------------------------------------
dane=Dane
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
#---   Funkcja tworzca TXT (12)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [12,15]:
    # PW 2017.02.03 - poprawki w wydruku znakowym z generatora (nagwki + nr stron na kadej stronie)

    def DrukujNaglowek(Strona,KrytNagl,KrytZnakowy,Naglowek,CzyKolejneStrony):
        IloscLiniDrukuZnakowego = 56
        if CzyKolejneStrony:
            KrytZnakowy=IloscLiniDrukuZnakowego-KrytNagl
            if Strona >1:
                print chr(12)
            print(Naglowek[0]+' strona '+str(Strona)+chr(13))
            Strona+=1
        else:
            print(Naglowek[0]+chr(13))
        print(Naglowek[1]+chr(13))

        return Strona,KrytZnakowy

    def DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol):
        if IloscWypiec == 0:
            print '-'*len(NagKol)
            print NagKol
            print '-'*len(NagKol)
        elif IloscWypiec in [1,2]:
            print '     '*(len(kol)) + '-'*len(NagKol)
            print '     '*(len(kol)) + NagKol
            print '     '*(len(kol)) + '-'*len(NagKol)
        KrytZnakowy-=3
        return KrytZnakowy

    zmienna = []
    KrytNagl=len(Naglowek[1].split('\n'))+2   #ilo linijek nagwka
    KrytSuma = 4                              #dugo sumy
    KrytZnakowy = 60                     #biece wykoystanie
    CzyKolejneStrony = Funkcja==15      #jeli 12 to txt, jeli 15 to znakowo na drukarce
    Strona = 1

    Plik = tempfile.mktemp('.txt')
    txt = open(Plik, "w")
    sys.stdout = txt
    sys.stdout = codecs.getwriter('utf8')(sys.stdout)

    Strona, KrytZnakowy = DrukujNaglowek(Strona,KrytNagl,KrytZnakowy,Naglowek,CzyKolejneStrony)
    #Cechy = [Nazwa,Typ,Dlugosc,PoPrzecinku,Podsumowanie,Sumowac,Srednia]

    # JR 2017.01.27 - zmniejszenie szerokosci kolumn przy txt
    # JR 2017.01.30 - przeliczenie naglowka dla txt
    #rsglobal.ZapiszDoLogow('Przed:'+str(Cechy), 1)
    NagKol = ''
    for i in range(len(Cechy[0])):
        if Cechy[4][i]:
            continue
        if Cechy[1][i].upper()=='D':
            Cechy[2][i]=max(10,len(Cechy[0][i])+2)
        if Cechy[1][i].upper()=='S':
            szer=0
            for j in range(len(dane)):
                szer=max(szer,len(str(dane[j][i]).strip()))
            szer=min(szer,Cechy[2][i])
            Cechy[2][i]=max(szer,len(Cechy[0][i])+2)
        if Cechy[1][i].upper()=='N':
            szer=0
            for j in range(len(dane)):
                szer=max(szer,len(str(dane[j][i]).strip()))
            szer=min(szer,Cechy[2][i])
            Cechy[2][i]=max(szer,len(Cechy[0][i])+2)
        roznica=Cechy[2][i]-len(Cechy[0][i])
        if roznica>0:
            if round(roznica/2,0)*2==roznica:
                NagKol += ' '*int(roznica/2)+Cechy[0][i]+' '*int(roznica/2)+'|'
            else:
                NagKol += ' '*int(round(roznica/2,0))+Cechy[0][i]+' '*int(round(roznica/2,0)+1)+'|'
        else:
            NagKol += ' '+Cechy[0][i]+' |'

    #rsglobal.ZapiszDoLogow('Po   :'+str(Cechy), 1)
    
    for i in range(len(dane)):
        text = []
        dl = []
        zmiana=[]

        if len(kol)>0:
            for j in range(len(kol)):
                pole = str(dane[i][kol[j]-1])
                text.append(pole)
                dl.append(len(pole))

            for w in range(len(text)):
                if stare[w] != text[w]:
                    zmiana.append(w)

            ##--- Wiecej wypi

            if len(zmiana)>0 and len(kol)>1:
                IloscWypiec = 2
                zakres =range(zmiana[0],len(kol))
                zakres.sort(reverse=True)
                j = 0
                for w in range(zmiana[0],len(kol)):
                    if i>0:
                        if len(Sumowanie)>0:                            #dla najniszej gazi
                            podsuma = u''
                            spr = u''
                            podsuma += '     '*(len(kol)-1-j) + u'Suma:'
                            spr = podsuma
                            #if j>0:
                            podsuma += '     '*(j)
                            zmienna = zakres[j]
                            for x in range(len(Sum[w])):
                                if Sum[zmienna][x] == 0 and Ilosc[zmienna][x] == 0:
                                    podsuma += ' ' * int(Dlugosc[IleKolumn[x]])
                                else:
                                    if Ilosc[zmienna][x] == 0:
                                        podsuma += str(rs_print_util.PFloat(float(Sum[zmienna][x]),
                                                        int(Dlugosc[IleKolumn[x]]) - int(PoPrzecinku[IleKolumn[x]]),
                                                        int(PoPrzecinku[IleKolumn[x]])))
                                    else:

                                        wart = str(rs_print_util.PFloat(float(Sum[zmienna][x])/float(Ilosc[zmienna][x]),
                                                        int(Dlugosc[IleKolumn[x]]) - int(PoPrzecinku[IleKolumn[x]]),
                                                        int(PoPrzecinku[IleKolumn[x]])))

                                        if int(Dlugosc[IleKolumn[x]])>3 and len(wart)-len(wart.strip())>3:
                                            podsuma += u'r:'+wart[3:]
                                        else:
                                            podsuma += wart

                                podsuma += ' '
                            if spr != podsuma:
                                pom = podsuma
                                if CzyKolejneStrony and KrytZnakowy< 3:
                                    Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek,CzyKolejneStrony)
                                    KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
                                else:
                                    print ' ' * (len(str(podsuma))-len(podsuma.lstrip())) + '-'*len(str(podsuma).lstrip())
                                print podsuma
                                if CzyKolejneStrony:
                                    KrytZnakowy-=2

                                        #zerowanie na koniec zmiennej i print
                            for x in range(len(Sum[zmienna])):
                                Sum[zmienna][x]=0
                                Ilosc[zmienna][x]=0
                    j+=1


                for w in range(zmiana[0],len(kol)):
                    if w == zmiana[0]:
                        if CzyKolejneStrony and KrytZnakowy< 5+len(kol)-w:
                            Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek,CzyKolejneStrony)
                            #KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
                        else:
                            print ' '
                        if CzyKolejneStrony:
                            KrytZnakowy-=1

                    if CzyKolejneStrony and KrytZnakowy< 5+len(kol)-w:
                        Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek,CzyKolejneStrony)
                        KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
                    print '     '*w +Nazwa[kol[w]-1]+': '+ str(dane[i][kol[w]-1])
                    if CzyKolejneStrony:
                        KrytZnakowy-=1

            ##--- Jedno wypicie
            elif len(zmiana)==1:
                IloscWypiec = 1
                if i > 0:
                    if len(Sumowanie)>0:
                        #print '-'*len(wiersz)
                        podsuma = u'Suma:'
                        for w in range(len(Sum[0])):
                            if Sum[0][w]==0 and Ilosc[0][w]==0:
                                podsuma +=' '*int(Dlugosc[IleKolumn[w]])
                            else:
                                if Ilosc[0][w] == 0:
                                    podsuma += str(rs_print_util.PFloat(float(Sum[0][w]),
                                                                        int(Dlugosc[w+len(kol)])-int(PoPrzecinku[w+len(kol)]),
                                                                        int(PoPrzecinku[w+len(kol)])))
                                else:
                                    wart = str(rs_print_util.PFloat(float(Sum[0][w])/float(Ilosc[0][w]),
                                                                        int(Dlugosc[w+len(kol)])-int(PoPrzecinku[w+len(kol)]),
                                                                        int(PoPrzecinku[w+len(kol)])))

                                    if int(Dlugosc[IleKolumn[w]])>3 and len(wart)-len(wart.strip())>3:
                                        podsuma += u'r:'+wart[3:]
                                    else:
                                        podsuma += wart

                            podsuma+=' '

                        if CzyKolejneStrony and KrytZnakowy< 3:
                            Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek,CzyKolejneStrony)
                            KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
                        else:
                            print '-'*len(podsuma)
                        print podsuma
                        for x in range(len(Sum[0])):
                            Sum[0][x]=0
                            Ilosc[0][x]=0
                        if CzyKolejneStrony:
                            KrytZnakowy-=2

                if CzyKolejneStrony and KrytZnakowy < 6:
                    Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
                else:
                    print ' '
                print Nazwa[kol[0]-1]+': '+ str(dane[i][kol[0]-1])
                if CzyKolejneStrony:
                    KrytZnakowy-=2

        ##---

            if len(zmiana)>0 and (len(Sumowanie)>0 or i==0):
                if CzyKolejneStrony and KrytZnakowy < 5:
                    Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
                KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
                #print '     '*(len(kol)) + '-'*len(NagKol)
                #print '     '*(len(kol)) + NagKol
                #print '     '*(len(kol)) + '-'*len(NagKol)

        elif len(kol)==0 and i==0: #jeli nie ma wypi do podsumowa to eby drukowa nagwek
            IloscWypiec = 0
            if CzyKolejneStrony and KrytZnakowy < 5:
                Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
            KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
            #print '-'*len(NagKol)
            #print NagKol
            #print '-'*len(NagKol)

        ##------------------- wypisywanie danych-----------------------##
        wiersz=u''
        wiersz += '     '*(len(kol))
        j=0

        for w in range(len(IleKolumn)):
            ##print 1, w, IleKolumn[w], Nazwa[IleKolumn[w]],Sumowac[IleKolumn[w]],
            if Typ[IleKolumn[w]] not in ['n','N']:
                roznica = int(Dlugosc[IleKolumn[w]])-len(str(dane[i][IleKolumn[w]]))
                if roznica>0:
                    wiersz += str(dane[i][IleKolumn[w]])+' '*(roznica)
                elif roznica<0:
                    wiersz += str(dane[i][IleKolumn[w]])[:roznica]
                elif roznica==0:
                    wiersz += str(dane[i][IleKolumn[w]])
            elif Typ[IleKolumn[w]] in ['n','N']:
                wiersz += str(rs_print_util.PFloat(float(dane[i][IleKolumn[w]]),
                                                   int(Dlugosc[IleKolumn[w]])-int(PoPrzecinku[IleKolumn[w]]),
                                                   int(PoPrzecinku[IleKolumn[w]])))
                if len(Sumowanie)>0 and (Sumowac[IleKolumn[w]]=='T' or Srednia[IleKolumn[w]]=='T'):
                    for z in range(len(Sum)):
                        Sum[z][w] +=float(dane[i][IleKolumn[w]])
                        if Srednia[IleKolumn[w]]=='T':
                            Ilosc[z][w] +=1

            wiersz += ' '

        if CzyKolejneStrony and KrytZnakowy < 1:
            Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
            KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
        print wiersz
        if CzyKolejneStrony:
            KrytZnakowy-=1

        ##--- Dla ostatniego wiersza wydruk podsumowania
        if i == len(dane)-1 and len(Sumowanie)>0:
            pom = range(len(kol))
            pom.sort(reverse=True)
            for z in range(len(kol)):
                pocz = ' '*5*(len(kol)-1-z) + u'Suma:'
                podsuma = ' '*5*(z)
                for w in range(len(Sum[pom[z]])):
                    if Sum[pom[z]][w] == 0 and Ilosc[pom[z]][w] == 0:
                        podsuma += ' ' * int(Dlugosc[IleKolumn[w]])
                    else:
                        if Ilosc[pom[z]][w] == 0:
                            podsuma += str(rs_print_util.PFloat(float(Sum[pom[z]][w]),
                                            int(Dlugosc[IleKolumn[w]]) - int(PoPrzecinku[IleKolumn[w]]),
                                            int(PoPrzecinku[IleKolumn[w]])))
                        else:
                            wart = str(rs_print_util.PFloat(float(Sum[pom[z]][w])/float(Ilosc[pom[z]][w]),
                                            int(Dlugosc[IleKolumn[w]]) - int(PoPrzecinku[IleKolumn[w]]),
                                            int(PoPrzecinku[IleKolumn[w]])))

                            if int(Dlugosc[IleKolumn[w]])>3 and len(wart)-len(wart.strip())>3:
                                podsuma += u'r:'+wart[3:]
                            else:
                                podsuma += wart

                    podsuma += ' '

                if len(kol) == 0:
                    podsuma = pocz + podsuma[5*(len(kol)-z-1):]
                else:
                    podsuma = pocz + podsuma
                if CzyKolejneStrony and KrytZnakowy < 3:
                    Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
                    KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
                else:
                    print pocz[:-5] + '-'*(len(podsuma)-len(pocz)+5) #+5 oznacza ilo znakw suma
                print podsuma
                if CzyKolejneStrony:
                    KrytZnakowy-=2

            if CzyKolejneStrony and KrytZnakowy < 6:
                Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
            print ''
            print '=' * len(wiersz)
            print 'Podsumowanie:'
            print '=' * len(wiersz)
            print '     '*(len(kol)) + NagKol
            if CzyKolejneStrony:
                KrytZnakowy-=5

            #---PODSUMOWANIE przy ostatnim wierszu

            pocz = ' ' * 5 * len(kol)
            podsuma = u''
            for w in range(len(Sum[len(kol)])):
                if Sum[len(kol)][w] == 0 and Ilosc[len(kol)][w] == 0:
                    podsuma += ' ' * int(Dlugosc[IleKolumn[w]])
                else:
                    if Ilosc[len(kol)][w] == 0:
                        podsuma += str(rs_print_util.PFloat(float(Sum[len(kol)][w]),
                                                            int(Dlugosc[IleKolumn[w]]) - int(PoPrzecinku[IleKolumn[w]]),
                                                            int(PoPrzecinku[IleKolumn[w]])))
                    else:
                        wart = str(rs_print_util.PFloat(float(Sum[len(kol)][w])/float(Ilosc[len(kol)][w]),
                                                                  int(Dlugosc[IleKolumn[w]]) - int(PoPrzecinku[IleKolumn[w]]),
                                                                  int(PoPrzecinku[IleKolumn[w]])))
                        if int(Dlugosc[IleKolumn[w]])>3 and len(wart)-len(wart.strip())>3:
                            podsuma += u'r:'+wart[3:]
                        else:
                            podsuma += wart

                podsuma += ' '
            podsuma = pocz + podsuma

            if CzyKolejneStrony and KrytZnakowy < 4:
                Strona, KrytZnakowy = DrukujNaglowek(Strona, KrytNagl, KrytZnakowy, Naglowek, CzyKolejneStrony)
                KrytZnakowy = DrukujTabelkeNaglowka(IloscWypiec,KrytZnakowy,NagKol,kol)
            print '     '*(len(kol)) + '=' * len(NagKol)
            print podsuma
            print '     '*(len(kol)) + '=' * len(NagKol)
            if CzyKolejneStrony:
                KrytZnakowy-=3

##------------------------------------------------------------------------------------------------------------

        stare = text

    sys.stdout = sys.__stdout__
    sys.stdout = codecs.getwriter('ISO-8859-2')(sys.stdout)
    txt.close()

# -------------------------------------------------------------------------------
# ---   Funkcja tworzca XSL (10)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    Plik = tempfile.mktemp('.xlsx')
    #AB dodatnie wyniku i zmiany statu jeli wystpi bd
    # fs_pliki_office.ZapiszXLSGenerator(dane, Plik, Cechy, Naglowek, Kodowanie)
    # wynik = fs_pliki_office.ZapiszXLSGenerator(dane, Plik, Cechy, Naglowek, Kodowanie)
    # if not wynik:
    #     stat = 'Nie udao si utworzy pliku .xlsx'

    #WS 2024-02-20 - przyjmowany stat z funkcji
    stat = fs_pliki_office.ZapiszXLSGenerator(dane, Plik, Cechy, Naglowek, Kodowanie)

# -------------------------------------------------------------------------------
# ---   Funkcja tworzca CSV (11)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    Plik = tempfile.mktemp('.csv')
    fs_pliki_office.ZapiszCSVGenerator(dane, Plik, Cechy, Naglowek, Kodowanie)


# -------------------------------------------------------------------------------
# ---   Przesanie danych binarnych
# -------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [10,11,12,13,14,15]:
    p = None
    try:  #AB otoczenie w try/except
        p = open(Plik, 'rb')
        dane = [binascii.hexlify(buffer(p.read()))]
        os.remove(Plik)
    except IOError, e:
        stat = 'Bd odczytu: ' + str(e)
        rsglobal.ZapiszDoLogow(stat, 1)
    #WS 2021-04-15
    finally:
        if p is not None:
            p.close()
