#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_generator_dane.py
# Purpose:          dane generatora raportw
# Author:           Piotr Witkowski
# Created:          2016/03/30
# RCS-ID:           $Id: fs_generator_dane.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

# 2022-02-07 Wojciech Skowron   - (12849) Poprawki w generatorze - podmiana typu na du liter, update lp
# 2022-02-10 Aleksander Bargie - (12868) w spc sie sypie raoprt RD1005

#Funkcje:
# 1 - INSERT,UPDATE,DELETE Grida Parametrw
# 3 - Modyfikacja Nagwka raportw
# 4 - Odczyt nagwka raportw
# 5 - Odczyt Grida Parametrw

stat='OK'


if stat == 'OK' and not 'FunkcjaDodatkowa' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['FunkcjaDodatkowa']
    SlPar={'Symbol':[1,3,4,5],}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_generator_dane z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [1,3,4,5]:
            Symbol = str(klucze['Symbol'])

#AB 10.02.22r
if not self.operator_id == STANDARD_OPERATOR_ID and Funkcja<>5:
    stat = 'Brak uprawnie.'

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

    if Funkcja == 1:
        Insert = []
        Update = []
        Delete = []
        Update = klucze['Update']
        Insert = klucze['Insert']
        Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#---   DELETE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
    # sprawdzanie DELETE
        for i in xrange(len(Delete[0])):
            DELETE = "DELETE FROM rs_raporty_parametry "
            DELETE+= "WHERE firma_id='"+self.firma_id+"' AND raport_id='"+Symbol+"'"

            for j in xrange(len(Delete[0][i])):
                pole = Delete[1][j]
                wart = Delete[0][i][j]
                if pole =='lp' and wart<>'':
                    DELETE+=" AND "+str(pole)+"='"+str(int(wart))+"'"
            DELETE+=";"
            if stat == 'OK':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        WierszeNr = Update[-1]

        for i in xrange(len(Update[0])):
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND raport_id='"+Symbol+"'"
            for j in xrange(len(Update[2][i])):
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                if pole =='lp':
                    WHERE+=" AND "+pole+"='"+str(int(wart))+"'"

            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]

                if pole =='nazwa':
                    if len(str(wart))>20:
                        wyn2.append((WierszeNr[i],1))
                        dane.append('NAZWA DL')

                elif pole =='opis':
                    if len(str(wart))>20:
                        wyn2.append((WierszeNr[i],2))
                        dane.append('OPIS DL')

                elif pole =='typ':
                    #WS 2022-02-07
                    wart = wart.upper().strip()
                    Update[1][i][j] = wart
                    if len(str(wart))>1:
                        wyn2.append((WierszeNr[i],3))
                        dane.append('TYP DL')
                    #WS 2022-02-07
                    if wart == '':
                        wyn2.append((WierszeNr[i],3))
                        dane.append('TYP BR')
                    elif wart not in ['T','D','N','L','S']:
                        wyn2.append((WierszeNr[i],3))
                        dane.append('TYP WART')

                elif pole =='dlugosc':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],4))
                        dane.append('DLUGOSC DL')

                elif pole =='po_przec':
                    if len(str(int(wart)))>1:
                        wyn2.append((WierszeNr[i],5))
                        dane.append('PO DL')

                elif pole =='wsp_gora':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],6))
                        dane.append('GORA DL')

                elif pole =='wsp_lewa':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],7))
                        dane.append('LEWA DL')

                elif pole =='wsp_dlug':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],8))
                        dane.append('DLUG DL')

            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]

            # wykonanie UPDATE
            if stat=='OK':
                sql=''
                UPDATE="UPDATE rs_raporty_parametry "
                SET='SET '
                for j in xrange(len(Update[0][i])):
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole=='lp':  #WS 2022-02-07
                        SET+=pole+"="+str(wart)+","
                    elif pole in ['nazwa','opis','typ']:
                        SET+=pole+"='"+str(wart)+"',"
                    elif pole in ['dlugosc','po_przec',
                                'wsp_gora','wsp_lewa','wsp_dlug']:
                        SET+=pole+"='"+str(int(wart))+"',"

                SET=SET.strip(",")
                WHERE+=";"
                sql+=UPDATE+SET+WHERE
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat = "Bd przy modyfikowaniu danych parametrw: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Insert[0])>0:
        WierszeNr = Insert[-1]
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])):

                pole=Insert[1][j]
                wart=Insert[0][i][j]

                if pole =='lp':
                    if int(wart)<1:
                        wyn2.append((WierszeNr[i],0))
                        dane.append('LP BR')
                    if len(str(int(wart)))>2:
                        wyn2.append((WierszeNr[i],1))
                        dane.append('LP DL')

                elif pole =='nazwa':
                    if len(str(wart))>20:
                        wyn2.append((WierszeNr[i],1))
                        dane.append('NAZWA DL')

                elif pole =='opis':
                    if len(str(wart))>20:
                        wyn2.append((WierszeNr[i],2))
                        dane.append('OPIS DL')

                elif pole =='typ':
                    #WS 2022-02-07
                    wart = wart.upper().strip()
                    Insert[0][i][j] = wart
                    if wart == '':
                        wyn2.append((WierszeNr[i],3))
                        dane.append('TYP BR')
                    elif wart not in ['T','D','N','L','S']:
                        wyn2.append((WierszeNr[i],3))
                        dane.append('TYP WART')
                    if len(str(wart))>1:
                        wyn2.append((WierszeNr[i],3))
                        dane.append('TYP DL')

                elif pole =='dlugosc':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],4))
                        dane.append('DLUGOSC DL')

                elif pole =='po_przec':
                    if len(str(int(wart)))>1:
                        wyn2.append((WierszeNr[i],5))
                        dane.append('PO DL')

                elif pole =='wsp_gora':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],6))
                        dane.append('GORA DL')

                elif pole =='wsp_lewa':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],7))
                        dane.append('LEWA DL')

                elif pole =='wsp_dlug':
                    if len(str(int(wart)))>4:
                        wyn2.append((WierszeNr[i],8))
                        dane.append('DLUG DL')

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    # wykonanie INSERT
    if stat == 'OK':
        sqlIns=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_raporty_parametry"
            KOLUMNY="(firma_id, raport_id"
            VALUES=" VALUES ('"+self.firma_id+"','"+Symbol+"'"

            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]

                if pole =='lp':
                    KOLUMNY+=","+pole
                    VALUES+=",'"+str(wart)+"'"

                if pole in ['nazwa','opis','typ']:
                    KOLUMNY+=","+pole
                    VALUES+=",'"+str(wart)+"'"

                elif pole in ['dlugosc','po_przec','wsp_gora',
                              'wsp_lewa','wsp_dlug']:
                    KOLUMNY+=","+pole
                    if str(wart)=='':
                        VALUES+=","+str('NULL')
                    else:
                        VALUES+=",'"+str(wart)+"'"

            KOLUMNY+=")"
            VALUES+=");"
            sqlIns+=INSERT+KOLUMNY+VALUES
        if sqlIns<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
            if stat<>'OK':
                stat = "Bd przy dodawaniu danych: "+stat
                dane.append(stat)


#----------------------------------------------
# Modyfikowanie Naglowka - ROZLICZENIA
#----------------------------------------------
#zapisywanie nagwka

if stat=='OK' and Funkcja == 3:
    SQL="SELECT 1 FROM rs_raporty WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND raport_id='" + Symbol +"'ORDER BY 1;"
    stat,d,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)

    if stat =='OK' and len(d)==0:
        if len(pola)>0:
            INS ="INSERT INTO rs_raporty(firma_id, sql_raport"
            VAL =" VALUES ('"+self.firma_id+"','SELECT \nFROM \nWHERE firma_id=''$firma'''"
            for j in range(len(pola)):
                wart = wartosci[j]
                pole = pola[j]

                ##----------------------------------
                ##Sprawdzenie
                ##----------------------------------

                if pole == 'raport_id':
                    if len(str(wart)) < 1:
                        dane.append(u'Pole symbol musi by wypenione')
                    if len(str(wart)) > 6:
                        dane.append(u'Pole symbol moe mie 6 znakw')

                elif pole == 'nazwa':
                    if len(str(wart)) > 100:
                        dane.append(u'Pole nazwa moe mie 100 znakw')

                elif pole == 'modul_id':
                    if len(str(wart)) <> 2:
                        dane.append(u'Pole modu musi mie 2 znaki')

                elif pole == 'szer_okna':
                    if len(str(int(wart))) > 4:
                        dane.append(u'Pole szeroko okna moe mie 4 znaki')

                elif pole == 'wys_okna':
                    if len(str(int(wart))) > 4:
                        dane.append(u'Pole wysoko okna moe mie 4 znaki')

            ##----------------------------------
            ##zapytanie
            ##----------------------------------

                if pole == 'raport_id':
                    INS+=","+pole
                    VAL+=",'"+wart+"'"
                if wart <> '':
                    if pole in ["nazwa","modul_id","naglowek","kolumny"]:
                        INS += "," + pole
                        VAL +=",'"+str(wart)+"'"

                    elif pole in ["szer_okna","wys_okna"]:
                        INS += "," + pole
                        VAL +=","+str(int(wart))

            if stat == 'OK' and len(dane) == 0:
                ins = INS+" ) "+VAL+" );"
                stat, dump, dump, dump = self.PolSQL.Execute(ins, 1)

            elif stat <> 'OK':
                stat = u'Bdy modyfikacji danych raportu :' + stat
                dane.append(stat)
            elif len(dane) > 0:
                stat = u'Bdy modyfikacji danych raportu'
                dane.append(stat)

    else:
        if len(pola)>0:
            dane = []
            sql = "UPDATE rs_raporty SET "
            for i in range(len(pola)):
                wart = wartosci[i]
                pole = pola[i]

                ##----------------------------------
                ##Sprawdzenie
                ##----------------------------------

                if pole == 'raport_id':
                    if len(str(wart)) < 1:
                        dane.append(u'Pole symbol musi by wypenione')
                    if len(str(wart)) > 6:
                        dane.append(u'Pole symbol moe mie 6 znakw')

                elif pole == 'nazwa':
                    if len(str(wart)) > 100:
                        dane.append(u'Pole nazwa moe mie 100 znakw')

                elif pole == 'modul_id':
                    if len(str(wart)) <> 2:
                        dane.append(u'Pole modu musi mie 2 znaki')

                elif pole == 'szer_okna':
                    if len(str(int(wart))) > 4:
                        dane.append(u'Pole szeroko okna moe mie 4 znaki')

                elif pole == 'wys_okna':
                    if len(str(int(wart))) > 4:
                        dane.append(u'Pole wysoko okna moe mie 4 znaki')

                ##----------------------------------
                ##zapytanie
                ##----------------------------------

                if pole in ["nazwa","modul_id","naglowek","kolumny"]:
                    if wart == "NULL":
                        sql += pole+"="+str(wart)+","
                    else:
                        sql += pole+"='"+str(wart)+"',"

                elif pole in ["szer_okna","wys_okna"]:
                    if wart == "NULL":
                        sql += pole+"="+str(wart)+","
                    else:
                        sql += pole+"='"+str(int(wart))+"',"

            if len(dane)==0:
                sql = sql.strip(',')
                sql += " WHERE firma_id='"+self.firma_id+"' AND raport_id='"+Symbol+"';"
                stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            elif stat <> 'OK':
                stat = u'Bdy modyfikacji danych raportu :' + stat
                dane.append(stat)
            elif len(dane) > 0:
                stat = u'Bdy modyfikacji danych raportu'
                dane.append(stat)

#----------------------------------------------
# POBIERANIE DANYCH - Nagwek
#----------------------------------------------

if Funkcja in [3,4] and stat=='OK':
    SQL="SELECT raport_id, nazwa,modul_id,szer_okna,wys_okna,naglowek,kolumny FROM rs_raporty WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND raport_id='" + Symbol +"';"
    stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,3)


#----------------------------------------------
# POBIERANIE DANYCH - Parametry
#----------------------------------------------
    
if Funkcja in [1,5] and stat=='OK':
    if Symbol not in ['',None]:
        SQL="SELECT lp, nazwa,opis, typ,dlugosc,po_przec,wsp_gora,wsp_lewa,wsp_dlug "
        SQL+="FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND raport_id='" + Symbol +"';"
        stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,3)