#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_generator_pdf_html.py
# Purpose:          tworzenie pdf
# Author:           Piotr Witkowski
# Created:          2016/07/21
# RCS-ID:           $Id: fs_generator_pdf_html.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------
# 2020-09-07 Aleksander Bargie (10740) - Bdne generowanie krawdzi w generatorze raportw
# 2022-06-08 Aleksander Bargie (12985) - Poprawna liczba miejsc po przecinku w raportach ktre zawieraj sumowanie i grupowanie
# 2022-07-13 Aleksander Bargie (12989) - Komunikat gdy tworzenie raportu pdf nie powiedzie si

                    #AB 07.09.20r
import rs_print_util, rsglobal
from reportlab.lib.units import inch

class RSGeneratorHTML:
    def __init__(self,parent=None,Plik=None, naglowek=[], Zakonczenie = '', dane=[],
                 Cechy=[],sortowac=[],IleKolumn=[],Sumowanie=[],
                 Sum=[], Avs=[],Ilosc=[],kol=[], stare=[]):

        self.strkod1="iso-8859-2"
        self.strkod2='utf-8'
        self.parent=parent
        self.Plik = Plik
        self.naglowek = naglowek
        self.Zakonczenie = Zakonczenie
        self.dane = dane
        self.kolory = ['darkgreen','purple','gray','navy','red']
        self.KoloryPom = {'TloSuma':u'cornsilk',
                          'TloWiersze':u'gainsboro',
                          'TloNaglowki':u'gold',
                          'TloPodsumowanie':u'red'}
        self.Cechy = Cechy
        self.Nazwa = Cechy[0]
        self.Typ = Cechy[1]
        self.Dlugosc = Cechy[2]
        self.PoPrzecinku = Cechy[3]
        self.Podsumowanie = Cechy[4]
        self.Sumowac = Cechy[5]
        self.Srednia = Cechy[6]

        self.sortowac = sortowac
        self.IleKolumn = IleKolumn
        self.Sumowanie = Sumowanie
        self.Sum = Sum
        self.Avs = Avs
        self.Ilosc = Ilosc
        self.kol = kol
        self.stare = stare

#-----------------------------------------------------------------------------------------------------------------------

    def UtworzHTMLGeneratora(self):
        self.Naglowek = u""
        for w in range(len(self.naglowek)):
            self.Naglowek +=self.WstawDoHTML('naglowek', str(self.naglowek[w]))+u'<br/>'

        self.HTML=u''
        self.HTML+=u'<!DOCTYPE HTML PUBLIC ' + u'"' + u'-//W3C//DTD HTML 3.2//EN'+u'">\n'
        self.HTML+=u'<HTML>\n'
        self.HTML+=u'<HEAD>\n'
        self.UstawStyle()
        self.HTML+=u'<TITLE> Generator raportw </TITLE>\n'
        self.HTML+=u'<META http-equiv="Content-type" content="text/html; charset=iso-8859-2">\n'
        self.HTML+=u'<META http-equiv="Content-Language" content="pl">\n'
        self.HTML+=u'</HEAD>\n'
        self.HTML+=u'<BODY>\n'
        self.HTML+=self.Naglowek+u'<br/><br/>\n'
        self.HTML+=u'<table width="100%">\n'
        self.PrzygotujDaneHTML()
        self.HTML+=u'</table>\n'
        self.HTML+=u'</BODY>\n'
        self.HTML+=u'</HTML>\n'

        Plik = open(self.Plik, 'w+b')
        Plik.write(self.HTML)
        Plik.close()

#-----------------------------------------------------------------------------------------------------------------------

    def UstawStyle(self):
        self.HTML+= """
        <style>
        body
        { background: white}
        table, th, td
        {   border: 0.2px solid black;
            border-collapse: collapse;
            color:black;
        }

        th, td
            {
            padding: 5px;
            text-align: center;
            }

        #naglowek
            {
            text-align: center;
            background:""" + self.KoloryPom['TloNaglowki']+""";
            }
        #podsumowanie
            {
            text-align: center;
            background:""" + self.KoloryPom['TloPodsumowanie']+""";
            }

        #n
            {
            text-align: right;
            }

        #s
            {
            text-align: left;
            }
        #wypiecie
            {
            text-align: left;
            color:white
            }
        #suma
            {
            text-align: right;
            background:""" + self.KoloryPom['TloSuma']+""";
            }

        </style>
        """

#-----------------------------------------------------------------------------------------------------------------------

    def WstawDoHTML(self,rodzaj=None,tekst=u'',nrwypiecia=0,i=False):
        if i == True:
            tlo =  u'style="background:'+self.KoloryPom['TloWiersze']+u'"'
        else:
            tlo =  u''

        if rodzaj == 'tekst':
            return u'<br>'+str(tekst)+u'</br>\n'
        elif rodzaj == 'WTabeli':
            wiersz = u'<tr>\n'
            for w in tekst:
                wiersz +=u'<td>'+str(w)+u'</td>\n'

            wiersz += u'</tr>\n'
            return wiersz
        elif rodzaj=='naglowek':
            return u'<th id="naglowek">'+str(tekst)+u'</th>\n'
        elif rodzaj=='podsumowanie':
            return u'<td id="podsumowanie" colspan="'+str(len(self.dane[0]))+u'">'+str(tekst)+u'</td>\n'
        elif rodzaj=='wypiecie':
            return u'<td id="wypiecie" colspan="'+str(len(self.dane[0])-nrwypiecia)+u'" style="background:'+self.kolory[nrwypiecia]+u'">'+str(tekst)+u'</td>\n'
        elif rodzaj=='n':
            return u'<td id="n" '+tlo+u'>'+str(tekst)+u'</td>\n'
        elif rodzaj=='s':
            return u'<td id="s" '+tlo+u'>'+str(tekst)+u'</td>\n'
        elif rodzaj=='suma':
            return u'<td id="suma" style="color:'+self.kolory[nrwypiecia]+u'">'+str(tekst)+u'</td>\n'

#-----------------------------------------------------------------------------------------------------------------------

    def PrzygotujDaneHTML(self):
        dane = self.dane
        Nazwa = self.Cechy[0]
        Typ = self.Cechy[1]
        Dlugosc = self.Cechy[2]
        PoPrzecinku = self.Cechy[3]
        Podsumowanie = self.Cechy[4]
        Sumowac = self.Cechy[5]
        Srednia = self.Cechy[6]
        sortowac = self.sortowac
        IleKolumn = self.IleKolumn
        Sumowanie = self.Sumowanie
        Sum = self.Sum
        Avs = self.Avs
        Ilosc = self.Ilosc
        kol = self.kol
        stare = self.stare

        self.CzySumowac = len(Sumowanie)
        if len(Sumowanie)>0:
            for x in range(len(sortowac[0])):
                if sortowac[0][x]-1 in Sumowanie:
                    self.CzySumowac -=1

        self.NagKol = u''
        for w in kol:
            self.NagKol+=self.WstawDoHTML('s','')

        for w in IleKolumn:
            self.NagKol+=self.WstawDoHTML('naglowek',str(Nazwa[w]))

        for i in range(len(dane)):
            text = []
            zmiana=[]

            if len(kol)>0:
                for j in range(len(kol)):
                    pole = str(dane[i][kol[j]-1])
                    text.append(pole)
                for w in range(len(text)):
                    if stare[w] <> text[w]:
                        zmiana.append(w)

                ##--- Wiecej wypi
                if len(zmiana)>0 and len(kol) >= 1:  #AB 08.06.22r > na >=
                    zakres = range(zmiana[0],len(kol))
                    zakres.sort(reverse=True)
                    j = 0
                    for w in range(zmiana[0],len(kol)):
                        if i>0:
                            if self.CzySumowac:
                                #self.dla najniszej gazi
                                if len(Sum[w])>0:
                                    self.HTML+=u'<tr>'
                                for z in range(len(kol)):
                                    self.HTML+=self.WstawDoHTML('s','')

                                zmienna = zakres[j]
                                for x in range(len(Sum[w])):
                                    if Sum[zmienna][x] == 0 and Ilosc[zmienna][x] == 0:
                                        self.HTML+=self.WstawDoHTML('s','')
                                    else:
                                        if Ilosc[zmienna][x] == 0:
                                            self.HTML+=self.WstawDoHTML('suma',(u'S: '+rs_print_util.PFloat(float(Sum[zmienna][x]),
                                                int(Dlugosc[IleKolumn[x]]),int(PoPrzecinku[IleKolumn[x]])).strip()),len(kol)-1-j)
                                        else:
                                            self.HTML+=self.WstawDoHTML('suma',(u'r: '+rs_print_util.PFloat(float(Sum[zmienna][x])/float(Ilosc[zmienna][x]),
                                                int(Dlugosc[IleKolumn[x]]),int(PoPrzecinku[IleKolumn[x]])).strip()),len(kol)-1-j)

                                if len(Sum[w])>0:
                                    self.HTML+=u'</tr>'

                                #zerowanie na koniec zmiennej sum
                                for x in range(len(Sum[zmienna])):
                                    Sum[zmienna][x]=0
                                    Ilosc[zmienna][x]=0
                        j+=1

                    for w in range(zmiana[0],len(kol)):
                        self.HTML+=u'<tr>'
                        for x in range(w):
                            self.HTML+=self.WstawDoHTML('s','')
                        self.HTML+=self.WstawDoHTML('wypiecie',(str(Nazwa[kol[w]-1] +': '+ str(dane[i][kol[w]-1]) )),w)
                        self.HTML+=u'</tr>'

                #AB 08.06.22r
                # ##--- Jedno wypicie
                # elif len(zmiana)==1:
                #     if i > 0:
                #         if self.CzySumowac:
                #             self.HTML+=u'<tr>'
                #             self.HTML+=self.WstawDoHTML('s','')
                #             for w in range(len(Sum[0])):
                #                 if Sum[0][w]==0 and Ilosc[0][w]==0:
                #                     self.HTML+=self.WstawDoHTML('s','')
                #                 else:
                #                     if Ilosc[0][w] == 0:
                #                         self.HTML+=self.WstawDoHTML('suma',(u'S6: '+rs_print_util.PFloat(float(Sum[0][w]),
                #                                     int(Dlugosc[w+len(kol)]),int(PoPrzecinku[w+len(kol)])).strip()))
                #                         rsglobal.ZapiszDoLogow("Dodaje {}, PoPrzecinku {} [{}]".format(Sum[0][w], PoPrzecinku, w+len(kol)))
                #                     else:
                #                         self.HTML+=self.WstawDoHTML('suma',(u'r: '+rs_print_util.PFloat(float(Sum[0][w])/float(Ilosc[0][w]),
                #                                     int(Dlugosc[w+len(kol)]),int(PoPrzecinku[w+len(kol)])).strip()))
                #
                #             for x in range(len(Sum[0])):
                #                 Sum[0][x]=0
                #                 Ilosc[0][x]=0
                #
                #             self.HTML+=u'</tr>'
                #     self.HTML+=u'<tr>'
                #     self.HTML+=self.WstawDoHTML('wypiecie',(str(Nazwa[kol[0]-1]+': '+ str(dane[i][kol[0]-1]))))
                #     self.HTML+=u'</tr>'

                ##---wpisywanie nagwka kolumn
                if len(zmiana)>0 and ( self.CzySumowac or i==0 or len(kol)>0):
                    self.HTML+=self.NagKol

            if len(kol)==0 and i==0: #jeli nie ma wypi do podsumowa to eby drukowa nagwek
                self.HTML+=self.NagKol

            ##--- wypisywanie danych
            pom = i%2
            if len(IleKolumn)>0:
                self.HTML+=u'<tr>'
            for w in range(len(kol)):
                self.HTML+=self.WstawDoHTML('s','')
            j=0

            for w in range(len(IleKolumn)):
                if Typ[IleKolumn[w]] in ['b','B']:
                    self.HTML+=self.WstawDoHTML('s',str(dane[i][IleKolumn[w]]),0,pom)
                elif Typ[IleKolumn[w]] not in ['n','N']:
                    self.HTML+=self.WstawDoHTML('s',dane[i][IleKolumn[w]].strip(),0,pom)
                elif Typ[IleKolumn[w]] in ['n','N']:
                    self.HTML+=self.WstawDoHTML('n',(rs_print_util.PFloat(float(dane[i][IleKolumn[w]]),
                                                       int(Dlugosc[IleKolumn[w]]),
                                                       int(PoPrzecinku[IleKolumn[w]])).strip()),0,pom)
                    if self.CzySumowac and (Sumowac[IleKolumn[w]]=='T' or Srednia[IleKolumn[w]]=='T'):
                        for z in range(len(Sum)):
                            Sum[z][w] +=float(dane[i][IleKolumn[w]])
                            if Srednia[IleKolumn[w]]=='T':
                                Ilosc[z][w] +=1
            if len(IleKolumn)>0:
                self.HTML+=u'</tr>'

            ##--- Dla ostatniego wiersza wydruk podsumowania
            if i == len(dane)-1 and  self.CzySumowac:
                pom = range(len(kol))
                pom.sort(reverse=True)
                for z in range(len(kol)):
                    self.HTML+=u'<tr>'
                    self.HTML+=self.WstawDoHTML('s','')
                    for w in range(len(kol)-1):
                        self.HTML+=self.WstawDoHTML('s','')

                    for w in range(len(Sum[pom[z]])):
                        if Sum[pom[z]][w] == 0 and Ilosc[pom[z]][w] == 0:
                            self.HTML+=self.WstawDoHTML('s','',0,pom)
                        else:
                            if Ilosc[pom[z]][w] == 0:
                                self.HTML+=self.WstawDoHTML('suma',(u'S: '+rs_print_util.PFloat(float(Sum[pom[z]][w]),
                                    int(Dlugosc[IleKolumn[w]]),int(PoPrzecinku[IleKolumn[w]])).strip()),len(kol)-1-z,pom)
                            else:
                                self.HTML+=self.WstawDoHTML('suma',(u'r: '+rs_print_util.PFloat(float(Sum[pom[z]][w])/float(Ilosc[pom[z]][w]),
                                    int(Dlugosc[IleKolumn[w]]),int(PoPrzecinku[IleKolumn[w]])).strip()),len(kol)-1-z,pom)
                    self.HTML+=u'</tr>'

                #---PODSUMOWANIE przy ostatnim wierszu
                self.HTML+=self.WstawDoHTML('podsumowanie','Podsumowanie:')
                self.HTML+=u'<tr>'
                for w in kol:
                    self.HTML+=self.WstawDoHTML('s','')

                for w in range(len(Sum[len(kol)])):
                    if Sum[len(kol)][w] == 0 and Ilosc[len(kol)][w] == 0:
                        self.HTML+=self.WstawDoHTML('s','',0,pom)
                    else:
                        if Ilosc[len(kol)][w] == 0:
                            self.HTML+=self.WstawDoHTML('suma',(u'S: '+rs_print_util.PFloat(float(Sum[len(kol)][w]),
                                        int(Dlugosc[IleKolumn[w]]),int(PoPrzecinku[IleKolumn[w]])).strip()),-1,pom)
                        else:
                            self.HTML+=self.WstawDoHTML('suma',(u'r: '+rs_print_util.PFloat(float(Sum[len(kol)][w])/float(Ilosc[len(kol)][w]),
                                        int(Dlugosc[IleKolumn[w]]),int(PoPrzecinku[IleKolumn[w]])).strip()),-1,pom)

                self.HTML+=u'</tr>'
            stare = text

#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------

class RSGeneratorPDF:
    def __init__(self,parent=None,Plik=None, naglowek=[], Zakonczenie='',dane=[],
                 Cechy=[],sortowac=[],IleKolumn=[],Sumowanie=[],
                 Sum=[], Avs=[],Ilosc=[],kol=[], stare=[]):

        self.strkod1="iso-8859-2"
        self.strkod2='utf-8'
        self.parent=parent
        self.Plik = Plik
        self.naglowek = naglowek+[u' ']
        self.Zakonczenie = Zakonczenie
        self.dane = dane
        self.Tresc=[]

        self.opcje={}
        self.opcje['topMargin']=0.1* inch
        self.opcje['bottomMargin']=0.1* inch
        self.ozdobniki = 4

        self.KoloryPom = {'TloSuma':rs_print_util.colors.cornsilk,   #cornsilk
                          'TloWiersze':rs_print_util.colors.gainsboro,
                          'TloNaglowki':rs_print_util.colors.gold,
                          'TloPodsumowanie':rs_print_util.colors.red,
                          'CzcionkaWypiecie':rs_print_util.colors.black,
                          'CzcionkaWypiecie2':u'Black',
                          'Wypiecie1':rs_print_util.colors.Color(0.5373,0.5451,0.702,1),
                          'Wypiecie2':rs_print_util.colors.Color(0.8314,0.8314,0.8314,1),
                          'Wypiecie3':rs_print_util.colors.Color(0.9569,0.9725,0.9725,1),
                          'Wypiecie4':rs_print_util.colors.Color(0.7765,0.9843,0.8784,1),
                          'Wypiecie5':rs_print_util.colors.Color(0.8745,0.6941,0.9725,1),}    #white lub black

        self.kolory = [self.KoloryPom['Wypiecie1'],
                       self.KoloryPom['Wypiecie2'],
                       self.KoloryPom['Wypiecie3'],
                       self.KoloryPom['Wypiecie4'],
                       self.KoloryPom['Wypiecie5'],]
        if not Cechy:
            Cechy=range(6)
        self.Cechy = Cechy
        self.Nazwa = Cechy[0]
        self.Typ = Cechy[1]
        self.Dlugosc = Cechy[2]
        self.PoPrzecinku = Cechy[3]
        self.Podsumowanie = Cechy[4]
        self.Sumowac = Cechy[5]

        self.sortowac = sortowac
        self.IleKolumn = IleKolumn
        self.Sumowanie = Sumowanie
        self.Sum = Sum
        self.Avs = Avs
        self.Ilosc = Ilosc
        self.kol = kol
        self.stare = stare

        self.CzySumowac = len(Sumowanie)
        if len(Sumowanie)>0:
            for x in range(len(sortowac[0])):
                if sortowac[0][x]-1 in Sumowanie:
                    self.CzySumowac -=1


    #-##############################################################################
    # Tworzenie dokumentw w wersji pdf
    #-##############################################################################


    def UtworzPDFGeneratora(self):
        self.PrzygotujPDFGeneratora()
        self.PrzygotujPDFGeneratora2()
        self.ZrobDanePDFGeneratora()
        #AB 13.07.22r dodana zwracana wartosc
        return self.WykonajPDFGeneratora()


    def PrzygotujPDFGeneratora(self):
        rs_print_util.PrzygotujCzcionki()
        szer = len(self.kol)*4
        for w in self.IleKolumn:
            szer += int(self.Dlugosc[w])

        if szer <= 100:
            self.RozmiarCzcionki = 9.5
            self.Landscape = False
        elif szer <= 136:
            #self.czcionkaw=7
            self.RozmiarCzcionki = 15.5 - 0.0625 * szer  # (funkcja liniowa)
            self.Landscape = False
        elif szer <= 170:
            #self.czcionkaw=6
            self.RozmiarCzcionki = 10 - 0.025 * szer     # (funkcja liniowa)
            self.Landscape = False
        #elif szer <= 190:
        #    #self.czcionkaw=6
        #    self.RozmiarCzcionki = 10 - 0.025 * szer     # (funkcja liniowa)
        #    self.Landscape = False
        elif szer <= 290:
            #self.czcionkaw=7
            self.RozmiarCzcionki = 13 - (szer-160) * 0.52 / 10  # (funkcja liniowa)
            self.Landscape = True
        #elif szer <= 230:
        #    #self.czcionkaw=6
        #    self.RozmiarCzcionki = 10 - 0.025 * szer      # (funkcja liniowa)
        #    self.Landscape = True
        else:
            self.RozmiarCzcionki = 6
            self.Landscape = True

        self.szer=szer

        self.SPusty = 0.5
        if self.Landscape:
            self.dl=28
        else:
            self.dl = 19


    def PrzygotujPDFGeneratora2(self):
        self.KolumnyTabelki = []

        for w in self.kol:
            self.dl -= self.SPusty
            self.KolumnyTabelki.append(self.SPusty * rs_print_util.cm)

        wsp = float(self.dl)/float(self.szer)
        for w in self.IleKolumn:
            self.KolumnyTabelki.append(wsp * int(self.Dlugosc[w]) * rs_print_util.cm)



    def ZrobDanePDFGeneratora(self):
        self.ZrobStyle()
        self.Tresc.append(self.ZrobNaglowek())
        self.PrzygotujDane()
        self.Tresc.append(self.ZrobZakonczenie())



    def WykonajPDFGeneratora(self):
        #AB 13.07.22r dodana zwracana wartosc
        return rs_print_util.ZrobPdf(self.parent.firma_id,self.Plik,'',self.Tresc,rs_print_util.ZrobNaglowekReportlab,
                              rysujNaKolejnych = rs_print_util.ZrobNaglowekReportlab,
                              opcje=self.opcje,ozdobniki=self.ozdobniki,Landscape=self.Landscape)

    ##------------------------------------------------------------------------------------------------------------

    def ZrobNaglowek(self):
        nagl = []
        for w in range(len(self.naglowek)):
            nagl.append([self.Parag(self.naglowek[w])])
        nagl.append([self.Parag(u'<br />\n')])

        tnagl=rs_print_util.Table(nagl,self.dl*rs_print_util.cm)
        tnagl.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black)]))

        return tnagl

    ##------------------------------------------------------------------------------------------------------------

    def ZrobZakonczenie(self):
        zak = []
        zak.append([self.Parag(u'<br />\n'+self.Zakonczenie)])
        tzak=rs_print_util.Table(zak,self.dl*rs_print_util.cm)
        tzak.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black)]))

        return tzak

    ##------------------------------------------------------------------------------------------------------------

    def Parag(self, Tekst='', align=u'left', color=u'black'):
        TextN=u"<para font='DejaVu' fontSize = "+str(self.RozmiarCzcionki)+u" align="+align+u" color="+color+u">"+Tekst+u"</para>"
        P = rs_print_util.Paragraph(TextN ,rs_print_util.normalnyStyl)
        return P

    ##------------------------------------------------------------------------------------------------------------

    def PrzygotujDane(self):

        dane = self.dane
        Nazwa = self.Cechy[0]
        Typ = self.Cechy[1]
        Dlugosc = self.Cechy[2]
        PoPrzecinku = self.Cechy[3]
        Podsumowanie = self.Cechy[4]
        Sumowac = self.Cechy[5]
        Srednia = self.Cechy[6]
        sortowac = self.sortowac
        IleKolumn = self.IleKolumn
        Sumowanie = self.Sumowanie
        Sum = self.Sum
        Avs = self.Avs
        Ilosc = self.Ilosc
        kol = self.kol
        stare = self.stare
        podsuma = []
        wiersz = []
        self.Tabelakoniec = []
        self.Tabela = []
        self.NagKol = []
        for w in kol:
            self.NagKol.append('')

        for w in IleKolumn:
            self.NagKol.append(self.Parag(Nazwa[w]))

        for i in range(len(dane)):
            text = []
            zmiana=[]

            NaglowekTabeli = []
            if len(kol)>0:
                for j in range(len(kol)):
                    pole = str(dane[i][kol[j]-1])
                    text.append(pole)

                for w in range(len(text)):
                    if stare[w] <> text[w]:
                        zmiana.append(w)

                ##--- Wiecej wypi
                if len(zmiana)>0 and len(kol)>=1:  #AB 08.06.22r > na >=
                    zakres =range(zmiana[0],len(kol))
                    zakres.sort(reverse=True)
                    j = 0
                    wiersz=[]
                    for w in range(zmiana[0],len(kol)):
                        if i>0:
                            if self.CzySumowac:

                                #self.dla najniszej gazi
                                spr = []
                                wiersz=[]
                                for z in range(len(kol)):
                                    wiersz.append('')
                                    spr.append('')

                                zmienna = zakres[j]
                                for x in range(len(Sum[w])):
                                    #if Sum[zmienna][x] == 0 and Ilosc[zmienna][x] == 0:
                                    if Sumowac[IleKolumn[x]]=='F' and Srednia[IleKolumn[x]]=='F':
                                        wiersz.append('')
                                    else:
                                        if Sumowac[IleKolumn[x]]=='T':
                                            wart=float(Sum[zmienna][x])
                                            wiersz.append(u'S: '+rs_print_util.PFloat(wart,
                                                int(Dlugosc[IleKolumn[x]]),
                                                int(PoPrzecinku[IleKolumn[x]])).strip())
                                        elif Srednia[IleKolumn[x]]=='T':
                                            wart=float(Sum[zmienna][x])/float(Ilosc[zmienna][x])
                                            wiersz.append(u'r: '+rs_print_util.PFloat(wart,
                                                int(Dlugosc[IleKolumn[x]]),
                                                int(PoPrzecinku[IleKolumn[x]])).strip())


                                if spr <> wiersz:
                                    pom = wiersz
                                    self.DodajFormat(self.StylDane,u'suma',len(kol)-1-j,len(self.Tabela),-1,len(self.Tabela))
                                    self.Tabela.append(wiersz)

                                #zerowanie na koniec zmiennej sum
                                for x in range(len(Sum[zmienna])):
                                    Sum[zmienna][x]=0
                                    Ilosc[zmienna][x]=0
                        j+=1

                    for w in range(zmiana[0],len(kol)):
                        wiersz=[]
                        for x in range(w):
                            wiersz.append('')
                        wiersz.append(self.Parag(str(Nazwa[kol[w]-1])+': '+ str(dane[i][kol[w]-1]),color=self.KoloryPom['CzcionkaWypiecie2']))
                        self.DodajFormat(self.StylDane,u'wypiecia',w,len(self.Tabela),-1,len(self.Tabela))
                        self.Tabela.append(wiersz)

                #AB 08.06.22r
                # ##--- Jedno wypicie
                # elif len(zmiana)==1:
                #     if i > 0:
                #         if self.CzySumowac:
                #             wiersz = ['']
                #             for w in range(len(Sum[0])):
                #                 if Sumowac[IleKolumn[w]]=='F' and Srednia[IleKolumn[w]]=='F':
                #                 #if Ilosc[0][w]==0:
                #                     wiersz.append('')
                #                 else:
                #                     if Sumowac[IleKolumn[w]]=='T':
                #                         wiersz.append(u'S2: '+rs_print_util.PFloat(float(Sum[0][w]),
                #                                                                   int(Dlugosc[w+len(kol)]),
                #                                                                   int(PoPrzecinku[w+len(kol)])).strip())
                #
                #                     elif Srednia[IleKolumn[w]]=='T':
                #                         wiersz.append(u'r: '+rs_print_util.PFloat(float(Sum[0][w])/float(Ilosc[0][w]),
                #                                                                   int(Dlugosc[w+len(kol)]),
                #                                                                   int(PoPrzecinku[w+len(kol)])).strip())
                #
                #             for x in range(len(Sum[0])):
                #                 Sum[0][x]=0
                #                 Ilosc[0][x]=0
                #             self.DodajFormat(self.StylDane,u'suma',0,len(self.Tabela),-1,len(self.Tabela))
                #             self.Tabela.append(wiersz)
                #     self.DodajFormat(self.StylDane,u'wypiecia',0,len(self.Tabela),-1,len(self.Tabela))
                #     self.Tabela.append([self.Parag(str(Nazwa[kol[0]-1])+': '+ str(dane[i][kol[0]-1]))])

                ##---wpisywanie nagwka kolumn
                if len(zmiana)>0 and (self.CzySumowac or i==0 or len(kol)>0):
                    self.DodajFormat(self.StylDane,u'kolumna',len(kol),len(self.Tabela),-1,len(self.Tabela))
                    self.Tabela.append(self.NagKol)



            if len(kol)==0 and i==0: #jeli nie ma wypi do podsumowa to eby drukowa nagwek
                self.DodajFormat(self.StylDane,u'kolumna',len(self.kol),len(self.Tabela),-1,len(self.Tabela))
                self.Tabela.append(self.NagKol)

            ##--- wypisywanie danych
            wiersz=[]
            for w in range(len(kol)):
                wiersz.append('')
            j=0
            for w in range(len(IleKolumn)):
                if Typ[IleKolumn[w]] in ['b','B']:
                    wiersz.append(self.Parag(str(dane[i][IleKolumn[w]])))
                elif Typ[IleKolumn[w]] not in ['n','N']:
                    wiersz.append(self.Parag(str(dane[i][IleKolumn[w]]).strip()))

                elif Typ[IleKolumn[w]] in ['n','N']:
                    wiersz.append(rs_print_util.PFloat(float(dane[i][IleKolumn[w]]),
                                                       int(Dlugosc[IleKolumn[w]]),
                                                       int(PoPrzecinku[IleKolumn[w]])).strip())
                    if self.CzySumowac and (Sumowac[IleKolumn[w]]=='T' or Srednia[IleKolumn[w]]=='T'):
                        for z in range(len(Sum)):
                            Sum[z][w] +=float(dane[i][IleKolumn[w]])
                            if Srednia[IleKolumn[w]]=='T':
                                Ilosc[z][w] +=1

            self.DodajFormat(self.StylDane,u'dane',len(self.kol),len(self.Tabela),-1,len(self.Tabela),i)
            self.Tabela.append(wiersz)

            ##--- Dla ostatniego wiersza wydruk podsumowania
            if i == len(dane)-1 and self.CzySumowac:
                pom = range(len(kol))
                pom.sort(reverse=True)
                for z in range(len(kol)):

                    wiersz = []
                    wiersz.append('')
                    for w in range(len(kol)-1):
                        wiersz.append('')

                    for w in range(len(Sum[pom[z]])):
                        if Sumowac[IleKolumn[w]]=='F' and Srednia[IleKolumn[w]]=='F':
                        #if Sum[pom[z]][w] == 0 and Ilosc[pom[z]][w] == 0:
                        #if Ilosc[pom[z]][w] == 0:
                            wiersz.append('')
                        else:
                            #if Ilosc[pom[z]][w] == 0:
                            self.StylKoniec.add('GRID', (len(wiersz), -1), (len(wiersz), -1),  0.25, rs_print_util.colors.black)

                            if Sumowac[IleKolumn[w]]=='T':
                                wiersz.append(u'S: '+rs_print_util.PFloat(float(Sum[pom[z]][w]),
                                                                          int(Dlugosc[IleKolumn[w]]),
                                                                          int(PoPrzecinku[IleKolumn[w]])).strip())
                            #else:
                            elif Srednia[IleKolumn[w]]=='T':
                                wiersz.append(u'r: '+rs_print_util.PFloat(float(Sum[pom[z]][w]/float(Ilosc[pom[z]][w])),
                                                                          int(Dlugosc[IleKolumn[w]]),
                                                                          int(PoPrzecinku[IleKolumn[w]])).strip())

                    self.DodajFormat(self.StylDane,u'suma',len(kol)-1-z,len(self.Tabela),-1,len(self.Tabela))
                    self.Tabela.append(wiersz)
                if not kol:  #AB 08.06.22r
                    for x in self.Sumowanie:
                        self.StylKoniec.add('GRID', (x, -1), (x, -1),  0.25, rs_print_util.colors.black)
                self.Tabelakoniec = []
                self.Tabelakoniec.append([''])
                self.DodajFormat(self.StylKoniec,u'podsumowanie',0,len(self.Tabelakoniec),-1,len(self.Tabelakoniec))
                self.Tabelakoniec.append(['Podsumowanie:'])
                self.DodajFormat(self.StylKoniec,u'kolumna',len(self.kol),len(self.Tabelakoniec),-1,len(self.Tabelakoniec))
                self.Tabelakoniec.append(self.NagKol)

                #---PODSUMOWANIE przy ostatnim wierszu
                wiersz = []
                for w in kol:
                    wiersz.append('')

                for w in range(len(Sum[len(kol)])):
                    if Sumowac[IleKolumn[w]]=='F' and Srednia[IleKolumn[w]]=='F':
                    #if Sum[len(kol)][w] == 0 and Ilosc[len(kol)][w] == 0:
                    #if Ilosc[len(kol)][w] == 0:
                        wiersz.append('')
                    else:
                        #if Ilosc[len(kol)][w] == 0:
                        if Sumowac[IleKolumn[w]]=='T':
                            wiersz.append(u'S: '+rs_print_util.PFloat(float(Sum[len(kol)][w]),
                                        int(Dlugosc[IleKolumn[w]]),int(PoPrzecinku[IleKolumn[w]])).strip())
                        elif Srednia[IleKolumn[w]]=='T':
                            wiersz.append(u'r: '+rs_print_util.PFloat(float(Sum[len(kol)][w])/float(Ilosc[len(kol)][w]),
                                        int(Dlugosc[IleKolumn[w]]),int(PoPrzecinku[IleKolumn[w]])).strip())
                self.Tabelakoniec.append(wiersz)
            stare = text

        self.tab=rs_print_util.Table(self.Tabela,self.KolumnyTabelki)
        self.tab.setStyle(self.StylDane)
        self.Tresc.append(self.tab)

        if  self.CzySumowac>0:
            self.koniec=rs_print_util.Table(self.Tabelakoniec,self.KolumnyTabelki)
            self.koniec.setStyle(self.StylKoniec)
            self.Tresc.append(self.koniec)

    ##------------------------------------------------------------------------------------------------------------

    def ZrobStyle(self):
        self.StylDane = rs_print_util.TableStyle(
            [('TEXTCOLOR',(1,-1),(-1,-1),rs_print_util.colors.black),
             ('FONT', (0,0), (-1,-1), 'DejaVu', 8)])
        for w in range(len(self.kol)):
            self.StylDane.add('ALIGN', (w,0), (w,-1),'LEFT')
        for w in range(len(self.IleKolumn)):
            i = len(self.kol)+w
            if self.Typ[self.IleKolumn[w]] in ['n','N']:
                kierunek = 'RIGHT'
            else:
                kierunek = 'LEFT'
            self.StylDane.add('ALIGN', (i,1), (i,-1),kierunek)
        ##----
        self.StylKoniec = rs_print_util.TableStyle(
            [('TEXTCOLOR',(1,-1),(-1,-1),rs_print_util.colors.red),
             ('ALIGN', (0,-1), (-1,-1),'RIGHT'),
             ('FONT', (0,0), (-1,-1), 'DejaVu', self.RozmiarCzcionki)])

        self.StylKoniecInne = rs_print_util.TableStyle(
            [('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
             ('ALIGN', (0,0), (-1,-1),'RIGHT'),
             ('FONT', (0,0), (-1,-1), 'DejaVu', self.RozmiarCzcionki)])

    def DodajFormat(self,zmienna,rodz,xod=0,yod=0,xdo=0,ydo=0,i=0):

        if rodz == u'kolumna':
            zmienna.add('BACKGROUND', (xod,yod), (xdo,ydo), self.KoloryPom['TloNaglowki'])
            zmienna.add('TEXTCOLOR', (xod,yod), (xdo,ydo), rs_print_util.colors.black)
            zmienna.add('ALIGN', (xod,yod), (xdo,ydo), 'CENTER')
            zmienna.add('GRID', (xod,yod), (xdo,ydo),  0.25, rs_print_util.colors.black)
            zmienna.add('SIZE', (xod,yod), (xdo,ydo), self.RozmiarCzcionki)
        elif rodz == u'podsumowanie':
            zmienna.add('SPAN', (xod,yod), (xdo,ydo))
            zmienna.add('ALIGN', (xod,yod), (xdo,ydo), 'CENTER')
            zmienna.add('BACKGROUND', (xod,yod), (xdo,ydo), self.KoloryPom['TloPodsumowanie'])
            zmienna.add('GRID', (xod,yod), (xdo,ydo),  0.25, rs_print_util.colors.black)
            zmienna.add('SIZE', (xod,yod), (xdo,ydo), self.RozmiarCzcionki)
        elif rodz == u'suma':
            zmienna.add('TEXTCOLOR', (xod,yod), (xdo,ydo), self.KoloryPom['CzcionkaWypiecie2'])
            zmienna.add('SIZE', (xod,yod), (xdo,ydo), self.RozmiarCzcionki)
            zmienna.add('ALIGN', (xod,yod), (xdo,ydo), 'RIGHT')
            zmienna.add('GRID', (max(self.Podsumowanie),yod), (xdo,ydo),  0.25, rs_print_util.colors.black)
            zmienna.add('BACKGROUND', (max(self.Podsumowanie),yod), (xdo,ydo), self.kolory[xod])

        elif rodz == u'dane':
            if i%2==0:
                kolor = self.KoloryPom['TloWiersze']
            else:
                kolor = rs_print_util.colors.white
            zmienna.add('BACKGROUND', (xod,yod), (xdo,ydo), kolor)
            zmienna.add('GRID', (xod,yod), (xdo,ydo),  0.25, rs_print_util.colors.black)
            zmienna.add('SIZE', (xod,yod), (xdo,ydo), self.RozmiarCzcionki)
        elif rodz == u'wypiecia':
            zmienna.add('SPAN', (xod,yod), (xdo,ydo))
            zmienna.add('ALIGN', (xod,yod), (xdo,ydo), 'LEFT')
            zmienna.add('BACKGROUND', (xod,yod), (xdo,ydo), self.kolory[xod])
            zmienna.add('TEXTCOLOR', (xod,yod), (xdo,ydo), self.KoloryPom['CzcionkaWypiecie'])
            zmienna.add('GRID', (xod,yod), (xdo,ydo),  0.25, rs_print_util.colors.black)
            zmienna.add('SIZE', (xod,yod), (xdo,ydo), self.RozmiarCzcionki)
