#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_global_faktury.py
# Purpose:          modu zawiera funkcje dotyczace operacji na fakturach
# Author:           Marcin Grzda
# Created:          2008/01/16
# RCS-ID:           $Id: fs_global_faktury.py $
# Copyright:        (c) 2008 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
# 2009.12.23 Micha Raburski (4151) - zmiany w pobieraniu vat i przeliczaniu cen - teraz ceny brutto wyliczane w oparciu o ceny netto
# 2011.01.13 Mariusz Rajfura (4200) - pobranie danych do fakturowania dla nowej faktury wg daty
# 2011.01.20 Micha Raburski (4215) - poprawki odnonie faktur walutowych
# 2012.09.03 Mariusz Rajfura (6029) - pobranie waluty z danych do fakturowania
# 2012.09.03 Mariusz Rajfura (6033) - pobranie handlowca z rs_wyznaczniki
# 2013.05.14 Mariusz Rajfura (6843) - popr.sql: podwojny minus czyli odejmowanie ujemnej stworzylo komentarz
# 2020.04.16 Wojciech Skowron (11634) - poprawka w nanoszeniu danych do fakturowania przy kopiowaniu faktury

import rsglobal

def PobierzCenyDoPozycji(f_parent,f_Firma,f_Wyznacznik,f_Data,f_Numer,Poz=0,PozDokl=0,PPozDokl=-1):
    f_Select="SELECT kontrahent_id,wersja,upust,waluta,kurs,kraj_opodatkowania,blokada_cen,zo_wyznacznik_id,"
    f_Select+="zo_data,zo_numer,nie_podlega_vat FROM rs_faktury WHERE firma_id='"+f_Firma+"' AND wyznacznik_id='"+f_Wyznacznik+"'"
    f_Select+=" AND data='"+f_Data+"' AND numer="+f_Numer
    stat,f_d,dump,dump = f_parent.PolSQL.Execute(f_Select,3)
    if stat=='OK':
        if len(f_d)==0:
            return 'Bd pobierania cen na pozycje faktury - podana faktura nie istnieje'
        
        f_Kontrahent=rsglobal.Dekoduj(f_d[0][0])
        f_Wersja=rsglobal.Dekoduj(f_d[0][1])
        f_Upust=f_d[0][2]
        f_Waluta=rsglobal.Dekoduj(f_d[0][3])
        f_Kurs=f_d[0][4]
        f_Kraj_Opodatkowania=rsglobal.Dekoduj(f_d[0][5])
        f_Blokada_Cen=f_d[0][6]
        f_ZO_Wyzn=rsglobal.Dekoduj(f_d[0][7])
        f_ZO_Data=rsglobal.Dekoduj(f_d[0][8])
        f_ZO_Nr=str(f_d[0][9])
        f_NP_VAT=f_d[0][10]
        #sprawdzenie czy faktura jest zomem
        if stat=='OK':    
            SQL="SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+f_Firma+"'"
            SQL+=" AND wyznacznik_id = '"+f_Wyznacznik+"';"
            stat,DWyzn,dump,dump = f_parent.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                return 'Bdy przy pobieraniu typw faktur :'+stat

    if stat=='OK':
        CzyZlom=(DWyzn[0][0]=='ZL')
        
        if PozDokl>0:
            FiltrPoz=' AND nr_poz='+str(PozDokl)
            if PPozDokl>0:
                FiltrPoz+=' AND nr_ppoz='+str(PPozDokl)
        elif Poz >0:
            FiltrPoz=' AND nr_poz>'+str(Poz)
        else:
            FiltrPoz=''
        
        SQL="SELECT nr_poz,nr_ppoz,artykul_id FROM rs_faktury_pozycje WHERE firma_id='"+f_Firma+"' "
        SQL+=" AND wyznacznik_id='"+f_Wyznacznik+"' AND data='"+f_Data+"' AND numer="+str(f_Numer)+FiltrPoz+"; "
        stat,f_dane_poz,dump,dump = f_parent.PolSQL.Execute(SQL,3)
                
        f_Update=''
        if stat=='OK':
            for f_poz in f_dane_poz:
                if stat=='OK':
                    f_NrPoz=f_poz[0]
                    f_NrPpoz=f_poz[1]
                    f_Artykul=rsglobal.Dekoduj(f_poz[2])
                    f_ceny=[0]
                    
                    if f_NP_VAT:
                        Stawka='0'
                        StawkaKod='np'
                    elif CzyZlom:
                        Stawka='0'
                        StawkaKod='oo'
                    else:
                        #pobranie vatu
                        SQL="SELECT rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+f_Data+"') FROM rs_artykuly WHERE firma_id='"+f_Firma+"' AND artykul_id='"+f_Artykul+"';"                    
                        stat,DStawka,dump,dump=f_parent.PolSQL.Execute(SQL,3)
                        if stat=='OK':
                            if len(DStawka)==0:
                                return 'Brak stawki vat dla arykuu '+f_Artykul
                            
                            Stawka=rsglobal.Dekoduj(DStawka[0][0])
                            if len(Stawka)>2:
                                return Stawka
    
                            StawkaKod=str(Stawka)
                            if Stawka in f_parent.ListaStawekZn:
                                Stawka='0'
                            
                    #jeli cen pobieramy z zamwienia
                    if stat=='OK':
                        if not f_Blokada_Cen:
                            f_Select="SELECT rsf_podaj_ceny_dla_kontrahenta('"+f_Firma+"','"+f_Kontrahent+"','"+f_Waluta+"','"+f_Data+"'::TEXT,'"+f_Artykul+"','"+f_Wersja+"'::TEXT,"+str(f_Upust)+")"
                            stat,f_d_ceny,dump,dump=f_parent.PolSQL.Execute(f_Select,3)
                            if stat=='OK':
                                f_ceny=rsglobal.rseval(f_d_ceny[0][0])
                        
                    # jesli pobrane ceny s zerowe to pobierana jest cena z pozycji faktury
                    if stat=='OK':
                        if f_ceny[0]==0:
                            SQL="SELECT cena_wal1,cena_wal2,ROUND(cena_wal1*(100+"+Stawka+")*0.01,2),"
                            SQL+="ROUND(cena_wal2*(100+"+Stawka+")*0.01,2),cena_upust_wal1,cena_upust_wal2,"
                            SQL+="ROUND(cena_upust_wal1*(100+"+Stawka+")*0.01,2),ROUND(cena_upust_wal2*(100+"+Stawka+")*0.01,2),upust"
                            SQL+=" FROM rs_faktury_pozycje WHERE firma_id='"+f_Firma+"' "
                            SQL+=" AND wyznacznik_id='"+f_Wyznacznik+"' AND data='"+f_Data+"' "
                            SQL+=" AND numer="+str(f_Numer)+" AND nr_poz="+str(f_NrPoz)+" AND nr_ppoz="+str(f_NrPpoz)+"; "
                            stat,DanePozCeny,dump,dump = f_parent.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                f_ceny=DanePozCeny[0]
                                        
                    if stat=='OK':
                        CaseNaJm2WArt="CASE WHEN (SELECT a.faktura_w_jm2 FROM rs_artykuly a"
                        CaseNaJm2WArt+=" WHERE a.firma_id='"+f_Firma+"' AND a.artykul_id=rs_faktury_pozycje.artykul_id) THEN "
                        WartNettoWal=CaseNaJm2WArt+"ROUND(ilosc2*"+str(f_ceny[5])+",2) ELSE ROUND(ilosc1*"+str(f_ceny[4])+",2) END"
                        WartVatWal="ROUND("+WartNettoWal+"*0.01*"+Stawka+",2)"
                        WartNetto=CaseNaJm2WArt+"ROUND("+str(f_ceny[5])+"*ilosc2*"+str(f_Kurs)+",2) ELSE ROUND("+str(f_ceny[4])+"*ilosc1*"+str(f_Kurs)+",2) END"
                        WartVat="ROUND("+WartNetto+"*0.01*"+Stawka+",2)"
                        
                        f_Update+="UPDATE rs_faktury_pozycje SET stawka_vat='"+StawkaKod+"', cena_wal1=round("+str(f_ceny[0])+",2),cena_wal2=round("+str(f_ceny[1])+",2)"
                        f_Update+=",cena_upust_wal1=round("+str(f_ceny[4])+",2),cena_upust_wal2=round("+str(f_ceny[5])+",2)"
                        
                        if f_Kraj_Opodatkowania=='PL' or CzyZlom:
                            f_Update+=",wartosc_wal_netto="+WartNettoWal+",wartosc_wal_brutto="+WartNettoWal+"+"+WartVatWal    
                            f_Update+=",wartosc_wal_vat="+WartVatWal
                        else:
                            f_Update+=",wartosc_wal_netto="+CaseNaJm2WArt+"ROUND(ilosc2*"+str(f_ceny[5])+",2) ELSE ROUND(ilosc1*"+str(f_ceny[4])+",2) END,"
                            f_Update+="wartosc_wal_brutto="+CaseNaJm2WArt+"ROUND(ilosc2*"+str(f_ceny[5])+",2) ELSE ROUND(ilosc1*"+str(f_ceny[4])+",2) END," 
                            f_Update+="wartosc_wal_vat=0"
                            
                        f_Update+=",cena_netto1=round("+str(f_ceny[0])+"*"+str(f_Kurs)+",2),cena_netto2=round("+str(f_ceny[1])+"*"+str(f_Kurs)+",2)"

                        if CzyZlom:
                            f_Update+=",cena_brutto1=round("+str(f_ceny[4])+"*"+str(f_Kurs)+",2),cena_brutto2=round("+str(f_ceny[5])+"*"+str(f_Kurs)+",2)"                            
                        elif f_Kraj_Opodatkowania=='PL':
                            f_Update+=",cena_brutto1=round("+str(f_ceny[2])+"*"+str(f_Kurs)+",2),cena_brutto2=round("+str(f_ceny[3])+"*"+str(f_Kurs)+",2)"
                        else:
                            f_Update+=",cena_brutto1=round("+str(f_ceny[0])+"*"+str(f_Kurs)+",2),cena_brutto2=round("+str(f_ceny[1])+"*"+str(f_Kurs)+",2)"
                        
                        f_Update+=",cena_upust1=round("+str(f_ceny[4])+"*"+str(f_Kurs)+",2),cena_upust2=round("+str(f_ceny[5])+"*"+str(f_Kurs)+",2)"
                            
                        if f_Kraj_Opodatkowania=='PL' or CzyZlom:                            
                            f_Update+=",wartosc_netto="+WartNetto
                            f_Update+=",wartosc_vat="+WartVat
                            f_Update+=",wartosc_brutto="+WartNetto+"+"+WartVat
                        else:    
                            f_Update+=",wartosc_netto="+WartNetto
                            f_Update+=",wartosc_vat=0"
                            f_Update+=",wartosc_brutto="+WartNetto

                        f_Update+=",upust=round("+str(f_ceny[8])+",2)"
                        f_Update+=",upust_wartosc="+CaseNaJm2WArt+" ROUND(("+str(f_ceny[1])+"- "+str(f_ceny[5])+")*ilosc2*"+str(f_Kurs)+",2)"
                        f_Update+=" ELSE ROUND(("+str(f_ceny[0])+"- "+str(f_ceny[4])+")*ilosc1*"+str(f_Kurs)+",2) END"
                        f_Update+=" WHERE firma_id='"+f_Firma+"' AND wyznacznik_id='"+f_Wyznacznik+"' AND data='"+f_Data+"'"
                        f_Update+=" AND numer="+str(f_Numer)+" AND nr_poz="+str(f_NrPoz)+" AND nr_ppoz="+str(f_NrPpoz)+"; "
            
            #pobranie cen na wszystkie pozycje
            if stat=="OK" and f_Update <> '':            
                f_st,dump,dump,dump=f_parent.PolSQL.Execute(f_Update,1)
                
        return stat
    else:
        stat="BL SQL POZ"
        return stat

#-------------------------------------------------------------------------------

def PobierzNaFaktureDaneDoFakturowaniaDlaKontrahenta(f_parent,f_Firma,f_Wyznacznik,f_Data,f_Numer):
    sql ="SELECT kontrahent_id,platnik_id,wersja FROM rs_faktury"
    sql+=" WHERE firma_id='"+f_Firma+"' AND wyznacznik_id='"+f_Wyznacznik+"'"
    sql+=" AND data='"+f_Data+"' AND numer="+str(f_Numer)+";"
    
    stat,dFakt,dump,dump = f_parent.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z nagwka faktury: '+stat
        return stat
    
    if len(dFakt) <> 1:
        stat = 'Brak faktury o podanym kluczu.'
        return stat
    
    Kontrah = rsglobal.Dekoduj(dFakt[0][0])
    Platnik = rsglobal.Dekoduj(dFakt[0][1])
    Wersja = rsglobal.Dekoduj(dFakt[0][2])
    if Wersja == 'None':
        Wersja = 'NULL'
    else:
        Wersja = "'"+Wersja+"'"

    Dni = "0.0"
    Upust = "0"
    SposZaplaty = "NULL"
    SposDostawy = "NULL"
    Handlowiec = "NULL"
    SposobOdbioruFaktury = "NULL"
    Projekt = "NULL"
    Waluta = "'PLN'"

    sql ="SELECT COALESCE(handlowiec,''::TEXT) FROM rs_wyznaczniki"
    sql+=" WHERE firma_id='"+f_Firma+"' AND wyznacznik_id='"+f_Wyznacznik+"';"
    stat,d,dump,dump = f_parent.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        return stat
    if len(d) == 0:
        return 'Brak wyznacznika '+f_Wyznacznik
    
    HandlowiecZWyznacznika = rsglobal.Dekoduj(d[0][0]).strip()
    if HandlowiecZWyznacznika == '':
        HandlowiecZWyznacznika = "NULL"
    else:
        HandlowiecZWyznacznika = "'"+HandlowiecZWyznacznika+"'"
    
    sql ="SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,"
    #WS 2020-04-16
    sql+=" sposob_odbioru_faktury,projekt_id,waluta_sprzedaz"
    # sql+=" sposob_odbioru_faktury,projekt_id,COALESCE(waluta_sprzedaz,'PLN'::TEXT)"
    sql+=" FROM rs_kontrahenci_fakturowanie"
    sql+=" WHERE firma_id='"+f_Firma+"' AND kontrahent_id='"+Kontrah+"'"
    sql+=" AND data_od <= '"+f_Data+"' ORDER BY data_od DESC LIMIT 1;"
    
    stat,dk,dump,dump = f_parent.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych do fakturowania dla kontrahenta: '+stat
        return stat
                                
    if len(dk) <> 1 and Platnik <> 'None' and Platnik <> Kontrah:
        sql ="SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,"
        #WS 2020-04-16
        sql+=" sposob_odbioru_faktury,projekt_id,waluta_sprzedaz"
        # sql+=" sposob_odbioru_faktury,projekt_id,COALESCE(waluta_sprzedaz,'PLN'::TEXT)"
        sql+=" FROM rs_kontrahenci_fakturowanie"
        sql+=" WHERE firma_id='"+f_Firma+"' AND kontrahent_id='"+Platnik+"'"
        sql+=" AND data_od <= '"+f_Data+"' ORDER BY data_od DESC LIMIT 1;"
        
        stat,dk,dump,dump = f_parent.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych do fakturowania dla patnika: '+stat
            return stat

    if len(dk) == 1:
        #WS 2020-04-16

        Dni = dk[0][0]
        Wersja = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][1]).strip())
        Upust = dk[0][2]
        SposZaplaty = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][3]).strip())
        SposDostawy = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][4]).strip())
        Handlowiec = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][5]).strip())
        if Handlowiec == 'NULL':
            Handlowiec = HandlowiecZWyznacznika
        SposobOdbioruFaktury = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][6]).strip())
        Projekt = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][7]).strip())
        Waluta = rsglobal.ZmienNaNULL(rsglobal.Dekoduj(dk[0][8]).strip())

        UPD = "UPDATE rs_faktury SET "

        if Wersja != 'NULL':
            UPD += "wersja="+Wersja+","

        if Dni > 0:
            UPD += "dni="+str(Dni)+","

        if Upust > 0:
            UPD += "upust="+str(Upust)+","

        if SposZaplaty != 'NULL':
            UPD += "sposob_zaplaty="+SposZaplaty+","

        if SposDostawy != 'NULL':
            UPD += "sposob_dostawy="+SposDostawy+","

        if Handlowiec != 'NULL':
            UPD += "handlowiec="+Handlowiec+","

        if SposobOdbioruFaktury != 'NULL':
            UPD += "sposob_odbioru_faktury="+SposobOdbioruFaktury+","

        if Projekt != 'NULL':
            UPD += "projekt_id="+Projekt+","

        if Waluta != 'NULL':
            UPD += "waluta="+Waluta+","

        UPD += "termin_zaplaty='"+f_Data+"'::DATE"
        if Dni > 0:
            UPD += " + INTERVAL '"+str(Dni)+" DAYS'"

        UPD+=" WHERE firma_id='"+f_Firma+"' AND wyznacznik_id='"+f_Wyznacznik+"'"
        UPD+=" AND data='"+f_Data+"' AND numer="+str(f_Numer)+";"

        # Dni = dk[0][0]
        #
        # if rsglobal.Dekoduj(dk[0][1]) <> 'None':
        #     Wersja = "'"+rsglobal.Dekoduj(dk[0][1])+"'"
        #
        # Upust = str(dk[0][2])
        #
        # if rsglobal.Dekoduj(dk[0][3]) <> 'None':
        #     SposZaplaty = "'"+rsglobal.Dekoduj(dk[0][3])+"'"
        #
        # if rsglobal.Dekoduj(dk[0][4]) <> 'None':
        #     SposDostawy = "'"+rsglobal.Dekoduj(dk[0][4])+"'"
        #
        # if rsglobal.Dekoduj(dk[0][5]) <> 'None':
        #     Handlowiec = "'"+rsglobal.Dekoduj(dk[0][5])+"'"
        #
        # if rsglobal.Dekoduj(dk[0][6]) <> 'None':
        #     SposobOdbioruFaktury = "'"+rsglobal.Dekoduj(dk[0][6])+"'"
        #
        # if rsglobal.Dekoduj(dk[0][7]) <> 'None':
        #     Projekt = "'"+rsglobal.Dekoduj(dk[0][7])+"'"
        #
        # Waluta = "'"+rsglobal.Dekoduj(dk[0][8])+"'"
        #
        # if Handlowiec == "NULL":
        #     Handlowiec = HandlowiecZWyznacznika
        #
        # Termin="'"+f_Data+"'::DATE"
        # if Dni > 0:
        #     Termin += " + INTERVAL '"+str(Dni)+" DAYS'"
        #
        # UPD ="UPDATE rs_faktury SET wersja="+Wersja+", upust="+Upust+","
        # UPD+=" sposob_zaplaty="+SposZaplaty+", sposob_dostawy="+SposDostawy+","
        # UPD+=" handlowiec="+Handlowiec+", termin_zaplaty="+Termin+","
        # UPD+=" dni="+str(Dni)+", sposob_odbioru_faktury="+SposobOdbioruFaktury+","
        # UPD+=" projekt_id="+Projekt+", waluta="+Waluta
        # UPD+=" WHERE firma_id='"+f_Firma+"' AND wyznacznik_id='"+f_Wyznacznik+"'"
        # UPD+=" AND data='"+f_Data+"' AND numer="+str(f_Numer)+";"

        stat,dump,dump,dump = f_parent.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji danych fakturowych w nagwku faktury: '+stat
            return stat

    return stat

#-------------------------------------------------------------------------------

def PrzeliczWartosciNaPozycji(self,Wyznacznik,Data,Numer,Poz=0,PPoz=-1,PozDokl=0,PPozDokl=-1):
    
    # stworzenie filtra na pozycje
    if PozDokl>0:
        FiltrPoz=' AND nr_poz='+str(PozDokl)
        if PPozDokl>=0:
            FiltrPoz+=' AND nr_ppoz='+str(PPozDokl)
        elif PPoz>=0:
            FiltrPoz+=' AND nr_ppoz>'+str(PPoz)
    elif Poz >0:
        FiltrPoz=' AND nr_poz>'+str(Poz)
    else:
        FiltrPoz=''
    
    # pobranie pozycji faktury, ktre bd zmieniane
    SQL="SELECT fp.nr_poz,fp.nr_ppoz,fp.stawka_vat,CASE WHEN a.faktura_w_jm2 THEN '2' ELSE '1' END"
    SQL+=" FROM rs_faktury_pozycje fp "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    SQL+=" AND numer="+str(Numer)+FiltrPoz+"; "
    stat,DPozFakt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania pozycji faktur w celu zmiany ich wartoci :'+stat
    
    if len(DPozFakt) > 0:
        # pobranie kraju opodatkowania i kursu faktury i czy faktura - zom
        SQL="SELECT f.kraj_opodatkowania,f.kurs,w.typ_faktury FROM rs_faktury f "
        SQL+=" INNER JOIN rs_wyznaczniki w USING (firma_id,wyznacznik_id)"
        SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+Wyznacznik+"' AND f.data='"+Data+"'"
        SQL+=" AND f.numer="+str(Numer)+";"
        stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return u'Bd pobierania danych nagwka zmienianej faktury :'+stat
        if len(DFakt) == 0:
            return u'Podana faktura nie istnieje'
        
        Kraj = DFakt[0][0]
        Kurs = str(DFakt[0][1])
        CzyZlom = (DFakt[0][2] == 'ZL')
    
    # zmiana danych pozycja po pozycji
    for poz in DPozFakt:
        if poz[2] in self.ListaStawekZn:
            Stawka='0'
        else:
            Stawka = poz[2]
                                
        WartNettoWal="ROUND(ilosc"+poz[3]+"*cena_upust"+poz[3]+",2)"
        WartVatWal="ROUND("+WartNettoWal+"*0.01*"+Stawka+",2)"
        WartNetto="ROUND(cena_upust"+poz[3]+"*ilosc"+poz[3]+"*"+Kurs+",2)"
        WartVat="ROUND("+WartNetto+"*0.01*"+Stawka+",2)"
                   
             
        SQL="UPDATE rs_faktury_pozycje SET "
        
        if Kraj == 'PL' or CzyZlom:
            SQL+="wartosc_wal_netto="+WartNettoWal
            SQL+=",wartosc_wal_vat="+WartVatWal
            SQL+=",wartosc_wal_brutto="+WartNettoWal+"+"+WartVatWal    
            SQL+=",wartosc_netto="+WartNetto
            SQL+=",wartosc_vat="+WartVat
            SQL+=",wartosc_brutto="+WartNetto+"+"+WartVat
        else:
            SQL+="wartosc_wal_netto="+WartNettoWal
            SQL+=",wartosc_wal_vat=0"
            SQL+=",wartosc_wal_brutto="+WartNettoWal
            SQL+=",wartosc_netto="+WartNetto
            SQL+=",wartosc_vat=0"
            SQL+=",wartosc_brutto="+WartNetto
            
        SQL+=",upust_wartosc=ROUND((cena_netto"+poz[3]+" - cena_upust"+poz[3]+")*ilosc"+poz[3]+"*"+Kurs+",2)"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        SQL+=" AND numer="+str(Numer)+" AND nr_poz="+str(poz[0])+" AND nr_ppoz="+str(poz[1])+"; "
        
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            return u'Wystpi bd zmiany wartoci pozycji faktury: '+stat
    
    return 'OK'