#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_global_konta.py
# Purpose:          modu zawiera funkcje dotyczace operacji na kontach bankowych
# Author:           Micha Raburski
# Created:          2011/06/01
# RCS-ID:           $Id: fs_global_konta.py $
# Copyright:        (c) 2011 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

import rsglobal

#-------------------------------------------------------------------------------

# sprawdza poprawno i istnienie nazwy konta w systemie.
# Wraca : 0 - niepoprawne konto, 1- brak nazwy, 2 - jest ok
def SprawdzIstnienieKonta(self, konto):
    # sprawdzenie poprawnoci numerycznej konta
    wynik=SprawdzPoprawnoscKonta(konto)
    if not wynik:
        return 0

    wynik=PodajNazweBankuKonta(self,konto)
    if wynik[0:4]=='BLAD':
        rsglobal.ZapiszDoLogow(wynik,1)
        return 3
    
    elif wynik=='Brak':    
        return 1
    
    return 2

#-------------------------------------------------------------------------------

# sprawdza numeryczn poprawno konta
def SprawdzPoprawnoscKonta(konto):
    konto=konto.replace(' ','')
    konto=konto.replace('-','')
    
    # s znaki inne ni cyfry - nie kontrolujemy
    if not konto.isdigit():
        return True
    
    # same cyfry ale nie 26- za dugo
    if not len(konto)==26:
        return False
   
    Wagi = [1,10,3,30,9,90,27,76,81,34,49,5,50,15,53,45,62,38,89,17,73,51,25,56,75,71,31,19,93,57]
    
    konto=konto+'2521'
    konto=konto[2:]+konto[0:2]
    Suma=0
    for i in xrange(len(Wagi)):
       Suma+= Wagi[i]*int(konto[-i-1])

    if Suma % 97 == 1:
        return True
    else:
        return False
    
#-------------------------------------------------------------------------------
    
# zwraca nazw konta z kont bankowych lub oddziaw na podstawie numeru konta
def PodajNazweBankuKonta(self,konto):
    konto=konto.replace(' ','')
    konto=konto.replace('-','')
    
    # sprawdzenie czy bank znajduje si w systemie
    Bank=konto[2:10]
        
    SQL="SELECT bank FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND SUBSTRING(REPLACE(REPLACE(konto,' ',''),'-','') FROM 3 FOR 8)='"+Bank+"';"
    stat,DKonta,dump,dump=self.PolSQL.Execute(SQL, 3)
    if stat<>'OK':
        return 'BLAD '+stat
    
    if len(DKonta)>0:
        return DKonta[0][0]
    
    SQL="SELECT konto_bank FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND SUBSTRING(REPLACE(REPLACE(konto_nr,' ',''),'-','') FROM 3 FOR 8)='"+Bank+"';"
    stat,DKonta,dump,dump=self.PolSQL.Execute(SQL, 3)
    if stat<>'OK':
        return 'BLAD '+stat
    
    if len(DKonta)>0:
        return DKonta[0][0]
    
    return 'Brak'
    