
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_grupy.py
# Purpose:     pobiera liste grup, dodaje nowa grupe, edytuje opis, usuwa grupe
#
# Author:      Mariusz Rajfura
# Created:     2009/05/06
# RCS-ID:      $Id: fs_grupy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2021-01-20 Wojciech Skowron - (12258) Refaktoryzacja
# 2023-06-30 Jan Raburski     - (13472) Kopiowanie grupy

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {'Numer': [1,3,4,7], 'Opis': [1,3,7], 'StaryNumer': [7], }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_grupy z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1,3,4,7]:
        Numer = rsglobal.Dekoduj(klucze['Numer'])
    if Funkcja in [1,3,7]:
        Opis = rsglobal.Dekoduj(klucze['Opis'])
    if Funkcja in [7]:
        StaryNumer = rsglobal.Dekoduj(klucze['StaryNumer'])

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprIns = (self.oddzial_id, '001250') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprUpd = (self.oddzial_id, '001210') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel = (self.oddzial_id, '001260') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprSel = (self.oddzial_id, '001200') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID or UprUpd or UprDel

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,3,4,7):
    if len(Numer.strip()) != 2:
        stat = 'BL_SYMB_DLUG'

if stat == 'OK' and Funkcja == 7:
    if len(StaryNumer.strip()) != 2:
        stat = 'BL_SYMB_DLUG'

if stat == 'OK' and Funkcja == 4:
    if Numer == '**':
        stat = 'BL_GWIAZDKI_DELETE'

if stat == 'OK' and Funkcja == 3:
    if Numer == '**':
        stat = 'BL_GWIAZDKI_PROTECT'

if stat == 'OK' and Funkcja in (1, 3, 4):
    SQL = "SELECT grupa_id FROM rs_grupy WHERE firma_id = '" + self.firma_id + "' AND grupa_id = '" + Numer + "';"
    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat == 'OK':
        if Funkcja in (3, 4) and len(d) == 0:
            stat = 'BL_SYMB_BRAK'
        elif Funkcja == 1 and len(d) > 0:
            stat = 'BL_SYMB_UZYW'

if stat == 'OK' and Funkcja == 7:
    SQL = "SELECT grupa_id FROM rs_grupy WHERE firma_id = '" + self.firma_id + "' AND grupa_id = '" + Numer + "';"
    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat == 'OK':
        if len(d) > 0:
            stat = 'BL_SYMB_UZYW'
        else:
            SQL = "SELECT grupa_id FROM rs_grupy WHERE firma_id = '" + self.firma_id + "' AND grupa_id = '" + StaryNumer + "';"
            stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat == 'OK':
                if len(d) == 0:
                    stat = 'BL_SYMB_BRAK'

#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -insert)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if not UprIns:
        stat = 'BR_UPR_INS'

    INS = "INSERT INTO rs_grupy (firma_id,grupa_id,opis) VALUES ('"+self.firma_id+"','"+Numer+"','"+Opis+"');"
    stat,d,wyn1,dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd dodawania grupy: '+stat

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3 - update )
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 3:
    if not UprUpd:
        stat = 'BR_UPR_UPD'

    UPD = "UPDATE rs_grupy SET opis = '"+Opis+"' WHERE firma_id = '"+self.firma_id+"' AND grupa_id = '"+Numer+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd aktualizacji opisu grupy: '+stat

# -------------------------------------------------------------------------------
# ---   DELETE DANYCH ( 4 - delete )
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 4:
    if not UprDel:
        stat = 'BR_UPR_DEL'

    DEL = "DELETE FROM rs_grupy WHERE firma_id = '" + self.firma_id + "' AND grupa_id='" + Numer + "';"
    stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd usuwania grupy: ' + stat

# -------------------------------------------------------------------------------
# ---   KOPIA GRUPY  ( 5 - kopia )
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 7:
    if not UprIns:
        stat = 'BR_UPR_INS'

    INS = "INSERT INTO rs_grupy (firma_id,grupa_id,opis) VALUES ('"+self.firma_id+"','"+Numer+"','"+Opis+"');"
    stat, d, wyn1, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd dodawania grupy: '+stat
    if stat == 'OK':
        INS = "INSERT INTO rs_grupa_menu (firma_id, grupa_id, menu_id)"
        INS += " SELECT firma_id, '" + Numer + "', menu_id FROM rs_grupa_menu"
        INS += " WHERE firma_id = '" + self.firma_id + "' AND grupa_id='" + StaryNumer + "';"
        stat, d, wyn1, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd kopiowania uprawnie: '+stat

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5 - select    6 - select z gwiazdkami )
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,3,4,5,6):
    if not UprSel:
        stat = 'BR_UPR_SEL'

    bezgw = " grupa_id<>'**' AND "
    if Funkcja == 6:
        bezgw = ''
        
    SEL = "SELECT grupa_id,opis FROM rs_grupy WHERE "+bezgw+" firma_id='"+self.firma_id+"' ORDER BY grupa_id;"
    stat,dane,nagl,dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania listy grup: '+stat
