# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_harmonogram_zadan.py
# Purpose:
# Author:      Piotr Szydeko
# Created:     2008/05/22
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2012-03-26 Mariusz Rajfura dodanie do filtru kryterium 'trwajace' czyli stat='' lub NULL (5573)
# 2017-03-15 Piotr Wikowski (10375) Refaktoryzacja

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'hzid':[1,2,3,4,5,6,7,8,10],'Id':[6,],'tylkoAktywne':[6,],'szukajTekst':[6,],'dajListeFunkcji':[6,],
           'dataOd':[6,],'dataDo':[6,],'widziCudze':[6,],'operatorSzukaj':[6,],
           'trwajace':[6,],'dataOd':[6,],'widziCudze':[6,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_harmonogram_zadan z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,2,3,4,5,6,7,8,10]:
        hzid = klucze['hzid']
    if Funkcja in [6,]:
        Id = klucze['Id']
        tylkoAktywne = klucze['tylkoAktywne']
        szukajTekst = klucze['szukajTekst']
        dajListeFunkcji = klucze['dajListeFunkcji']
        dataOd = klucze['dataOd']
        dataDo = klucze['dataDo']
        widziCudze = klucze['widziCudze']
        operatorSzukaj = klucze['operatorSzukaj']
        trwajace = klucze['trwajace']
        widziCudze = klucze['widziCudze']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    PUSTA_DATA = "    -  -  "


UprWidziSwoje = (self.oddzial_id, "001701") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprDodawanie = (self.oddzial_id, "001703") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprEdycja = (self.oddzial_id, "001702") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID or UprDodawanie
UprUsuwanie = (self.oddzial_id, "001704") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprWidziCudze = (self.oddzial_id, "001705") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID


#------------------------------------------------------------------------------

def sprawdzPole(self, row, pole, wartosc):
    # sprawdzanie podana warto jest dopuszczalna dla tego pola
    # zwraca "OK" lub kod bdu (lub False dla nieznanego pola)
    if pole == "zalegle":
        if not str(wartosc) in ("J", "W"):
            return "BL zalegle"
        return "OK"
    elif pole == "odstep":
        # sprawdzenie kodu odstpu
        query = "SELECT kod FROM rs_powtarzalnosc WHERE kod='" + str(wartosc) + "'"
        #print query
        stat, dane, none, none = self.PolSQL.Execute(query, 2)
        if stat != "OK":
            return "BL odstepy"
        if not dane:
            return "BL odstep"
        return "OK"
    elif pole == "argumenty":
        # sprawdzenie czy argumenty mog zosta sparsowane
        #  ale najpierw pozbd si zbdnych backslashy bo dostaj nie to co wpisa user
        wartosc = wartosc.replace("\\\\", "\\").replace("\\'", "'")
        #print "args: %r" % wartosc
        try:
            code = compile("{%s}" % wartosc, "argumenty", "eval") 
            if code.co_names:
                return "BL args"    # odwoania do obiektw, funkcji itp nie jest dopuszczalne
            exec code in {}, {}
        except Exception, exc:
            return "BL args"
        return "OK"
    elif pole == "czas":
        # czy nowy czas nie min ju za bardzo
        czas = time.strftime("%F %T", time.localtime(time.time()-65))
        if wartosc < czas:
            return "BL czas"
        return "OK"
    elif pole in ("nazwa", "opis", "zacznij", "data", "aktywne", "stop_po_ok", "ile_odstepow", "powiadom_gdy_blad"):
        return "OK"

    return False


#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,2]:
    if not UprDodawanie or not UprEdycja:
        stat = "BL upr"
    else:
        #print "INS; klucze: %r\npola: %r\ndane: %r" % (klucze, pola, wartosci)

        # zebrane nazwy pl ktre zostan wypenione
        keys = ["firma_id", "harmzad_id", "dodal_op_id"]
        # i wpisywane wartoci, ju z '' gdzie trzeba
        vals = ["'%s'" % self.firma_id, None, str(self.operator_id)]
        for pole, wartosc in zip(pola, wartosci):
            wyn = sprawdzPole(self, None, pole, wartosc)
            if pole == "argumenty":
                if wartosc.endswith("'"):   # w SQL podwjny ' ma swoje znaczenie
                    wartosc += " "
                # obejcie eby mona byo uywa ' i \ a nawet \'
                wartosc = wartosc.replace("\\\\", "\\").replace("\\'", "'").replace("\\", "\\\\\\\\").replace("'", "\\'")
            if wyn == "OK":
                keys.append(pole)
                vals.append("'%s'" % wartosc)
            elif wyn:
                stat = wyn
                break

        if stat=='OK':
            query = "SELECT nextval('rs_harmonogram_zadan_harmzad_id_seq')"
            stat, hzid, none, none = self.PolSQL.Execute(query, 4)
            if stat<>'OK':
                stat="BL INS getID"
            vals[1] = str(hzid)

        if stat == "OK":
            query =''
            query+="INSERT INTO rs_harmonogram_zadan "
            query+=" (" + ",".join(keys) + ") "
            query+="VALUES"
            query+=" (" + ",".join(vals) + ")"
            #print query
            dane = [hzid]
            stat, none, none, none = self.PolSQL.Execute(query, 1)
            if stat<>'OK':
                stat = "BL INS"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [3,4]:
    if not UprEdycja:
        stat = "BL upr"
    else:
        sets = []
        # zdarzao si e dostawaem nie to co trzeba, to niech si sypnie wczeniej w takim wypadku
        assert isinstance(hzid, int), " upd> hzid=%r is not int (%s)" % (hzid, type(hzid))
        # pobieram dane dane zadania zapisane obecnie
        query = ("SELECT harmzad_id, aktywne, czas < NOW() - INTERVAL '65 SECONDS', czas::TEXT FROM rs_harmonogram_zadan "
            " WHERE firma_id='" + self.firma_id + "' AND harmzad_id=" + str(hzid))
        stat, row, none, none = self.PolSQL.Execute(query, 2)
        if row:
            row = row[0]
        elif len(row) == 0:
            stat = "BLAD zadanie wskazane do zmiany nie zostao znalezione"

        # przejd po polach, sprawd czy wartoci s w porzdku i zbuduj liste przypisa do zapytania
        if stat <> "OK":
            stat = "BLAD pobrania danych w czasie przygotowywania do zapisu"
        else:
            bledy = []
            # jeli zmieniamy warto 'aktywne' to zapamitaj now warto, w ten sposb wykrywam aktywowanie
            noweAktywne = None
            for pole, wartosc in zip(pola, wartosci):
                wyn = sprawdzPole(self, row, pole, wartosc)
                #print pole, wartosc, wyn
                if pole == "argumenty":
                    if wartosc.endswith("'"):   # w SQL podwjny ' ma swoje znaczenie
                        wartosc += " "
                    # obejcie eby mona byo uywa ' i \ a nawet \'
                    wartosc = wartosc.replace("\\\\", "\\").replace("\\'", "'").replace("\\", "\\\\\\\\").replace("'", "\\'")
                elif pole == "aktywne":
                    noweAktywne = wartosc

                if wyn == "OK":
                    sets.append("%s = '%s'" % (pole, wartosc))
                elif wyn:
                    bledy.append(wyn)

            # gdyby czas by zmieniany to by spawdzony, ale jeli nie to moe aktywujemy zostawiajc czas przeszy?
            #print "row: %r" % row, 
            zostalCzasPrzeszly = "czas" not in pola and row[2]
            #aktywowane = not row[1] and noweAktywne
            aktywne = noweAktywne or (noweAktywne is None and row[1])
            #print "zP: %r, akt: %r, nA: %r" % (zostalCzasPrzeszly, aktywne, noweAktywne)
            if aktywne and zostalCzasPrzeszly:
                bledy.append("BL aktywne")

            #print bledy, sets
            if bledy:
                stat = bledy[0]

        # zapisanie przygotowych danych
        if stat=='OK':
            query = (
                "UPDATE rs_harmonogram_zadan "
                " SET " + ", ".join(sets) +
                " WHERE firma_id='" + self.firma_id + "' AND harmzad_id=%d" % hzid
            )
            #print query
            dane = [hzid]
            stat, none, none, none = self.PolSQL.Execute(query, 1)
            if stat<>'OK':
                stat="BL UPD"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [9,]:
    # pobranie numeru dla kolejnego
    # zwraca [[nextID, czas + 1 godzina], ]
    query = "SELECT CASE WHEN is_called THEN last_value+1 ELSE last_value END, substr(text(now() + INTERVAL '1 HOUR'), 0, 17) "
    query += " FROM rs_harmonogram_zadan_harmzad_id_seq"
    stat, dane, none, none = self.PolSQL.Execute(query, 2)
    if stat<>'OK':
        stat = "BL SEL nextid"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [10,]:
    # znajd opis funkcji o podanej nazwie
    query = "SELECT opis, argumenty FROM rs_harmonogram_zadan_funkcje WHERE kod='" + hzid + "'"
    stat, dane, none, none = self.PolSQL.Execute(query, 2)
    if stat<>'OK':
        stat = "BL opisFunkcji"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,3,5,]:
    if not UprWidziSwoje:
        stat = "BL upr"
    else:
        dane = []
        assert isinstance(hzid, int), "sel> hzid: %r (%s)" % (hzid, type(hzid))
        sql = ("SELECT harmzad_id::TEXT, nazwa, opis, replace(argumenty, '\\\\\\\\', '\\\\') AS argumenty,"
            "  odstep, ile_odstepow, zalegle,  substr(text(zacznij), 0, 17) AS zacznij,  substr(text(czas), 0, 17) AS czas,"
            "  data, aktywne, stop_po_ok, powiadom_gdy_blad, "
            "  OP.login AS operator, ZH.z_op_id, ZH.z_czas, ZH.z_czas, ZH.z_typ"
            " FROM rs_harmonogram_zadan ZH LEFT JOIN rs_operatorzy OP ON (dodal_op_id = OP.operator_id)"
            " WHERE firma_id='"+str(self.firma_id)+"' AND harmzad_id=%d" % hzid)
        #print "SELECT to edit: ", sql
        stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = "BL SEL"


#------------------------------------------------------------------------------
#------------------------Okno gwne harmonogramu
#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6,]:
    if not UprWidziSwoje:
        stat = "BL upr"
    else:
        # pobranie listy zada
        SELECT = ''
        widziCudze = widziCudze and UprWidziCudze
        SELECT+="SELECT substr(text(czas), 0, 17), nazwa, opis, aktywne, ile_odstepow::text || odstep, OP.login, data, zalegle,"
        SELECT+="     stop_po_ok, replace(argumenty, '\\\\\\\\', '\\\\'), powiadom_gdy_blad, harmzad_id"
        SELECT+=" FROM rs_harmonogram_zadan ZH LEFT JOIN rs_operatorzy OP ON (OP.operator_id = ZH.dodal_op_id)"
        SELECT+=" WHERE firma_id = '%s'" % self.firma_id
        if dataOd and dataDo and dataOd != PUSTA_DATA and dataDo != PUSTA_DATA:
            zakresDat = "BETWEEN '%s' AND (DATE '%s' + INTERVAL '1 DAY')" % (dataOd, dataDo)
        elif dataOd and dataOd != PUSTA_DATA:
            zakresDat = " >= '%s'" % dataOd
        elif dataDo and dataDo != PUSTA_DATA:
            zakresDat = " <= (DATE '%s' + INTERVAL '1 DAY')" % dataDo
        else:
            zakresDat = ""
        if Id:
            SELECT += " AND harmzad_id=%s" % Id
        if zakresDat:
            SELECT += " AND czas %s" % zakresDat
        if szukajTekst:
            SELECT += " AND (ZH.opis LIKE '%%%s%%' OR ZH.nazwa LIKE '%%%s%%' OR ZH.argumenty LIKE '%%%s%%')"  % (
                szukajTekst, szukajTekst, szukajTekst)
        if tylkoAktywne:
            SELECT += " AND ZH.aktywne"
        if trwajace:
            SELECT += " AND ((firma_id,harmzad_id) IN "
            SELECT +=" (SELECT DISTINCT firma_id,harmzad_id FROM rs_harmonogram_zadan_log"
            SELECT +="  WHERE firma_id='"+self.firma_id+"' AND (TRIM(stat)='' OR stat IS NULL)))"
        if widziCudze:
            if operatorSzukaj:
                SELECT += " AND OP.login LIKE '%s%%'" % operatorSzukaj
        else:
            SELECT += " AND ZH.dodal_op_id=%s" % self.operator_id

        SELECT+=" ORDER BY firma_id, harmzad_id;"
        stat, dane, none, none = self.PolSQL.Execute(SELECT, 2)
        if stat<>'OK':
            stat=="BL LIST"

        # opcjonalne wczytywanie nazw dostpnych funkcji
        if stat == "OK" and dajListeFunkcji:
            query = "SELECT kod FROM rs_harmonogram_zadan_funkcje ORDER BY kod"
            #print "funkcjeQuery:", query
            stat, listaFunkcji, none, none = self.PolSQL.Execute(query, 2)
            if stat <>'OK':
                stat="BL SEL fun"
        else:
            listaFunkcji = ()

        wyn2 = (listaFunkcji, )

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [7,]:
    if not UprDodawanie:
        stat = "BL upr"

    if stat=='OK':
        SQL = "INSERT INTO rs_harmonogram_zadan (firma_id,harmzad_id,nazwa,ile_odstepow,odstep,argumenty,"
        SQL+= "opis,zacznij,czas,zalegle,aktywne,data,dodal_op_id,stop_po_ok,powiadom_gdy_blad)"
        SQL+= "SELECT firma_id,nextval('rs_harmonogram_zadan_harmzad_id_seq'),nazwa,ile_odstepow,odstep,argumenty,"
        SQL+= "opis,zacznij,czas,zalegle,aktywne,data,"+str(self.operator_id)+",stop_po_ok,powiadom_gdy_blad"
        SQL+= " FROM rs_harmonogram_zadan WHERE firma_id='" + self.firma_id + "' AND harmzad_id=" + str(hzid)
        stat, none, none, none = self.PolSQL.Execute(SQL, 1)

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [8,]:
    # usuwanie zadania
    # najpierw wszystkie logi tego zadania, potem ono samo
    if not UprUsuwanie:
        stat = "BL upr"
    else:
        dane = (self.firma_id, hzid)
        query = "DELETE FROM rs_harmonogram_zadan_log WHERE firma_id='" + self.firma_id + "' AND harmzad_id=" + str(hzid)

        stat, none, none, none = self.PolSQL.Execute(query, 1)
        if stat<>'OK':
            stat = "BL DEL log"
        else:
            query = "DELETE FROM rs_harmonogram_zadan WHERE firma_id = '" + self.firma_id + "' AND harmzad_id = " + str(hzid)
            stat, none, none, none = self.PolSQL.Execute(query, 1)
            if stat<>'OK':
                stat="BL DEL"