# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_hd_artykuly.py
# Purpose:     wczytuje/usuwa artykuy
# Author:      Wojciech Skowron
# Created:     2019/07/02
# RCS-ID:      $Id: fs_artykuly_dane.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'ArtykulId':[6], 'Magazyn':[10],
             'SymbolF':[5], 'NazwaF':[5], 'KategoriaF':[5], 'EanF':[5], 'AktywnyF':[5],
             'TypF':[5], 'ProducentF':[5], 'DostawcaF':[5], 'SymbolObcyF':[5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_artykuly z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    if Funkcja == 6:
        ArtykulId   = rsglobal.Dekoduj(klucze['ArtykulId'])
    if Funkcja == 5:
        SymbolF     = rsglobal.Dekoduj(klucze['SymbolF'])
        NazwaF      = rsglobal.Dekoduj(klucze['NazwaF'])
        KategoriaF  = rsglobal.Dekoduj(klucze['KategoriaF'])
        EanF        = rsglobal.Dekoduj(klucze['EanF'])
        AktywnyF    = rsglobal.Dekoduj(klucze['AktywnyF'])
        TypF        = rsglobal.Dekoduj(klucze['TypF'])
        ProducentF  = rsglobal.Dekoduj(klucze['ProducentF'])
        DostawcaF   = rsglobal.Dekoduj(klucze['DostawcaF'])
        SymbolObcyF = rsglobal.Dekoduj(klucze['SymbolObcyF'])
    if Funkcja == 10:
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn']).strip()

dane = []
wyn2=[]

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE
#-------------------------------------------------------------------------------

UprDod = ((self.oddzial_id,'092113') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod = ((self.oddzial_id,'092112') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDod
UprPrzegl = ((self.oddzial_id,'092111') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDod or UprMod
UprDel = ((self.oddzial_id,'092114') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   DELETE (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprDel:
        stat = "UPR_DEL"
        dane.append(stat)
    else:
        DEL = """DELETE FROM rs_artykuly
                       WHERE firma_id = '{}' AND artykul_id='{}';""".format(self.firma_id, ArtykulId)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(DEL,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd usuwania danych: "+stat

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5)
#-----------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 5:
    if not UprPrzegl:
        stat = "UPR_PRZEGL"
    else:
        SEL ="SELECT DISTINCT art.artykul_id,art.nazwa,art.kateg_artykulu||' - '||ka.opis,"
        SEL+="art.typ_artykulu,art.producent_id,art.dostawca_id,art.ost_przychod,ost_rozchod,art.cecha1_opis "
        SEL+="FROM rs_artykuly AS art "
        SEL+="LEFT OUTER JOIN rs_kateg_artykulow AS ka ON art.firma_id = ka.firma_id AND art.kateg_artykulu = ka.kod "
        if EanF !='':
            SEL+="LEFT OUTER JOIN rs_artykuly_ean AS e ON art.firma_id = e.firma_id AND art.artykul_id = e.artykul_id "
        if SymbolObcyF!='':
            SEL+="LEFT OUTER JOIN rs_artykuly_obce AS o ON art.firma_id = o.firma_id AND art.artykul_id = o.artykul_id "
            SEL+="LEFT OUTER JOIN rs_kontrahenci AS k ON o.firma_id = k.firma_id AND o.kontrahent_id = k.kontrahent_id "

        SEL += " WHERE art.firma_id='"+self.firma_id+"'"
        SEL += " AND (art.czy_detal=TRUE OR art.tylko_detal=TRUE)"
        if SymbolF!='':
            SEL += " AND upper(art.artykul_id) LIKE upper('"+SymbolF+"%')"
        if NazwaF != '':
            SEL += " AND upper(art.nazwa) LIKE upper('"+NazwaF+"%')"
        if KategoriaF != '':
            SEL += " AND upper(art.kateg_artykulu) LIKE upper('"+KategoriaF+"%')"
        if TypF != '':
            SEL += " AND upper(art.typ_artykulu) LIKE upper('"+TypF+"%')"
        if ProducentF != '':
            SEL += " AND upper(art.producent_id) LIKE upper('"+ProducentF+"%')"
        if DostawcaF != '':
            SEL += " AND upper(art.dostawca_id) LIKE upper('"+DostawcaF+"%')"
        if EanF != '':
            SEL += " AND upper(e.ean) LIKE upper('"+EanF+"%')"
        if SymbolObcyF != '':
            SEL += " AND upper(o.obcy_id) LIKE upper('"+SymbolObcyF+"%')"
        if AktywnyF:
            SEL+=' AND art.aktywny'

        SEL+=" ORDER BY art.artykul_id;"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(SEL,5)
        if stat != "OK":
            stat = "Bd pobierania danych: "+stat
            dane.append(stat)
        else:
            SEL = "SELECT COUNT(*) FROM rs_artykuly WHERE firma_id='" + str(self.firma_id) + "' AND COALESCE(aktywny,TRUE);"
            stat,wyn1,dump,dump=self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
            if stat != "OK":
                stat = "Bd pobierania liczby artykuw: "+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH DO EKSPORTU (10)  #MK 2020-05-25
#-----------------------------------------------------------------------------
if stat == 'OK' and Funkcja == 10:
    if not UprPrzegl:
        stat = "UPR_PRZEGL"
    else:
        if Magazyn != '':
            SELS = "SELECT ra.artykul_id, ra.nazwa, COALESCE(e.ean,''),"
            SELS += " COALESCE((SELECT ost_cena1 FROM rs_artykuly_magazyny am"
            SELS += " WHERE am.firma_id=ra.firma_id AND am.artykul_id=ra.artykul_id AND am.magazyn_id='" + Magazyn + "' ), 0),"
            SELS += " COALESCE((SELECT ilosc1 FROM rs_artykuly_magazyny am"
            SELS += " WHERE am.firma_id=ra.firma_id AND am.artykul_id=ra.artykul_id AND am.magazyn_id='" + Magazyn + "' ), 0)"
            SELS += " FROM rs_artykuly ra "
            SELS += " LEFT OUTER JOIN rs_artykuly_ean e USING (firma_id,artykul_id) "
            SELS += "WHERE ra.firma_id='"+ self.firma_id + "' AND ra.czy_detal='True' "
            SELS += " ORDER BY ra.artykul_id"
        else:
            SELS = "SELECT ra.artykul_id, ra.nazwa, COALESCE(e.ean,'') FROM rs_artykuly ra "
            SELS += " LEFT OUTER JOIN rs_artykuly_ean e USING (firma_id,artykul_id) "
            SELS += "WHERE ra.firma_id='" + self.firma_id + "' AND ra.czy_detal='True' ORDER BY ra.artykul_id"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SELS,3,CzyDodawacBlad=True)
        if stat != "OK":
            stat = "Bd pobierania danych: "+stat
            dane.append(stat)