# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_hd_artykuly_dane.py
# Purpose:     Dodawanie/edycja artykuu
# Author:      Wojciech Skowron
# Created:     2019/07/16
# RCS-ID:      $Id: fs_artykuly_dane.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-07-25 Wojciech Skowron (11557) - pole 'czy_mpp' przy select
# 2019-07-25 Wojciech Skowron (11552) - sprawdzenie unikalnoci pary nazwa skrcona - stawka wrd aktywnych artykuw
# 2019-08-22 Wojciech Skowron (11599) - pole 'kateg_artykulu' (obowizkowe jeli nie tylko_detal)
# 2020-09-10 Wojciech Skowron (12107) - typ_artykulu = '01' dla kadego art przy dodawaniu
# 2020-09-20 Wojciech Skowron (12127) - edycja zamiennika
# 2021-11-17 Wojciech Skowron (11552) - poprawka kontroli na par stawka VAT + nazwa skrcona,
#                                       pominicie pl nazwa_skrocona, stawka_vat i sww_pkwiu przy UPDATE
# 2023-10-13 Aleksander Bargie (13581) - [HD] W artykuach detal kolumna 'rozliczac_produkcje'
# 2023-12-07 Wojciech Skowron   (13634) - pole 'na_magazyn_surowcow'

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Symbol':[1,2,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_artykuly_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    Symbol = rsglobal.Dekoduj(klucze['Symbol']).strip()

dane = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE
#-------------------------------------------------------------------------------

UprDod = ((self.oddzial_id,'092113') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod = ((self.oddzial_id,'092112') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDod
UprPrzegl = ((self.oddzial_id,'092111') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDod or UprMod

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,2,3,4):
    PKWIU = 'NULL'
    VAT = 'NULL'
    NazwaSkr = None  #WS 2019-07-24
    Zamiennik = None  #WS 2020-09-20

    SEL = """SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='{}';""".format(self.firma_id)
    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != "OK":
        stat = "Bd pobrania danych: "+stat
        dane.append(stat)
    else:
        DwieJednMiar = d[0][0]

    if stat == 'OK':
        if Symbol == '':
            stat = 'BR_SYMBOL'
            dane.append(stat)
        else:
            SEL = """SELECT artykul_id FROM rs_artykuly 
                     WHERE firma_id='{}' AND artykul_id='{}' 
                     FOR UPDATE NOWAIT;""".format(self.firma_id, Symbol)
            stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzenia kodu artykuu: '+stat
                dane.append(stat)
            else:
                if Funkcja in (3,4,7):
                    if len(d) == 0:
                        stat = "BL_SYMBOL1"
                        dane.append(stat)

                elif Funkcja in (1,2) and len(d) > 0:
                    stat = "BL_SYMBOL2"
                    dane.append(stat)

        #--- analiza sww_pkwiu w zalenoci od VAT-u
        if "stawka_vat" in pola:
            index = pola.index("stawka_vat")

            if wartosci[index].strip() != '':
                SEL = """SELECT kod FROM rs_stawki_vat WHERE kod='{}';""".format(wartosci[index])
                stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd pobrania kodu stawki VAT: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL_VAT"
                    dane.append(stat)
                else:
                    VAT = wartosci[index].strip()

                if stat == 'OK':
                    #sprawdzenie stawki z biezaco obowiazujacymi stawkami
                    SEL = """SELECT stawka_vat FROM rs_stawki_vat_okresy
                             WHERE stawka_vat='{}'
                             AND NOW()::DATE >= od_dnia
                             AND CASE WHEN do_dnia IS NULL 
                             THEN TRUE 
                             ELSE NOW()::DATE <= do_dnia END;""".format(wartosci[index])
                    stat,ds,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                        dane.append(stat)
                    elif len(ds) == 0:
                        stat = 'BL_BIEZACA_STAWKA'
                        dane.append(stat)
            else:
                 stat = "BR_VAT"
                 dane.append(stat)

        else:
            SEL = """SELECT stawka_vat FROM rs_artykuly
                     WHERE firma_id ='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
            stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd pobrania stawki VAT z artykuu: '+stat
                dane.append(stat)
            else:
                if len(d) > 0:
                    VAT = d[0][0]
                else:
                    VAT = '00'

        if VAT not in ('NULL', '23'):
            if "sww_pkwiu" in pola:
                index = pola.index("sww_pkwiu")

                if wartosci[index].strip() not in ('NULL', ''):
                    PKWIU = wartosci[index].strip()
                else:
                    stat = "BR_PKWIU"
                    dane.append(stat)
            else:
                SEL = """SELECT sww_pkwiu FROM rs_artykuly
                         WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
                rsglobal.ZapiszDoLogow(SEL,5)
                stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd pobrania PKWiU dla artykuu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BR_PKWIU"
                    dane.append(stat)
                else:
                    PKWIU = rsglobal.Dekoduj(d[0][0])
                    if PKWIU in ('', 'None'):
                        stat = 'BR_PKWIU'
                        dane.append(stat)

        #WS 2019-08-22 - kategoria obowizkowa, jeli niezaznaczone tylko_detal
        SEL = """SELECT kateg_artykulu, tylko_detal FROM rs_artykuly
                 WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
        rsglobal.ZapiszDoLogow(SEL,5)
        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd sprawdzania kategorii artykuu: '+stat
            dane.append(stat)
        else:
            if "tylko_detal" in pola:
                index = pola.index("tylko_detal")
                TylkoDetal = wartosci[index]
            else:
                TylkoDetal = d[0][1]

            if "kateg_artykulu" in pola:
                index = pola.index("kateg_artykulu")

                if wartosci[index].strip() in ('', 'None') and not TylkoDetal:
                    stat = "BR_KATEG"
                    dane.append(stat)
            else:
                if not TylkoDetal:
                    if len(d) == 0 or rsglobal.Dekoduj(d[0][0]).strip() in ('', 'None'):
                        stat = "BR_KATEG"
                        dane.append(stat)

        # sprawdzenie pozostaych danych
        for pole, wart in zip(pola, wartosci):
            if pole == 'nazwa':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart == '' :
                    stat = 'BR_NAZWA'
                    dane.append(stat)

            elif pole == 'nazwa_skrocona':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart == '' :
                    stat = 'BR_NAZWA_SKR'
                    dane.append(stat)
                #WS 2019-07-24
                else:
                    NazwaSkr = wart.strip()

            #WS 2019-08-22
            elif pole == 'kateg_artykulu':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart != '' :
                    SEL = """SELECT kod FROM rs_kateg_artykulow
                             WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu kategorii artykuu: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_KATEG'
                        dane.append(stat)

            elif pole == 'grupa_towarowa':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart != '' :
                    SEL = """SELECT kod FROM rs_hd_grupy_towarowe
                             WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu grupy towarowej: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_GR_TOW'
                        dane.append(stat)

            elif pole == 'producent_id':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart != '' :
                    SEL = """SELECT kontrahent_id FROM rs_kontrahenci
                             WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia producenta: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_PROD'
                        dane.append(stat)

            elif pole == 'dostawca_id':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart != '' :
                    SEL = """SELECT kontrahent_id FROM rs_kontrahenci
                             WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu dostawcy: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_DOST'
                        dane.append(stat)

            elif pole == 'jm1':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart == '' :
                    stat = 'BR_JM1'
                    dane.append(stat)
                else:
                    SEL = """SELECT kod FROM rs_jednostki_miar
                             WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu JM1: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_JM1'
                        dane.append(stat)
                    else:
                        JM1 = wart


                if not DwieJednMiar:
                    JM2 = JM1

            elif pole == 'jm2':
                wart = rsglobal.Dekoduj(wart).strip()
                if DwieJednMiar:
                    if wart == '':
                        stat = 'BR_JM2'
                        dane.append(stat)
                    else:
                        SEL = """SELECT kod FROM rs_jednostki_miar
                                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd sprawdzenia kodu JM2: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'BL_JM2'
                            dane.append(stat)
                        else:
                            JM2 = wart
                else:
                    JM2 = JM1

            elif pole == 'decydent':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart != '' :
                    SEL = """SELECT kod FROM rs_hd_decydenci
                             WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia kodu decydenta: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_DEC'
                        dane.append(stat)

            #WS 2020-09-20
            elif pole == 'zamiennik_id':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart != '':
                    Zam = None

                    SEL = """SELECT zamiennik_id FROM rs_artykuly
                             WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, wart)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia id zamiennika: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_ZAMIENNIK'
                        dane.append(stat)
                    else:
                        if d[0][0] not in ('', 'None'):
                            Zam = d[0][0]
                            index = pola.index("zamiennik_id")
                            wartosci[index] = Zam
                        else:
                            Zam = wart

                    if Zam is not None:
                        SEL = """SELECT czy_detal or tylko_detal FROM rs_artykuly
                                 WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Zam)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd sprawdzenia danych zamiennika: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'BL_ZAMIENNIK'
                            dane.append(stat)
                        elif not d[0][0]:
                            stat = 'BL_ZAMIENNIK_DETAL'
                            dane.append(stat)
                        else:
                            Zamiennik = Zam

            elif pole == 'przelicznik':
                if DwieJednMiar:
                    if float(wart) == 0:
                        stat = 'BL_PRZEL'
                        dane.append(stat)

            elif pole == 'przelicznik_odwr':
                if DwieJednMiar:
                    if float(wart) == 0:
                        stat = 'BL_PRZEL_ODWR'
                        dane.append(stat)

            elif pole == 'aktywny':
                if not wart:
                    SEL = """SELECT artykul_id FROM rs_artykuly
                             WHERE firma_id='{}' AND artykul_id='{}' AND ilosc1 > 0;""".format(self.firma_id, Symbol)
                    stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia iloci artykuu na stanie: ' + stat
                        dane.append(stat)
                    elif len(d) != 0:
                        stat = 'NA_STANIE'
                        dane.append(stat)

    #WS 2019-08-01
    if NazwaSkr is None:
        SEL = """SELECT nazwa_skrocona
                 FROM rs_artykuly
                 WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)
        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania informacji o edytowanym artykule: '+stat
        elif len(d) == 0:
            stat = 'Bd pobierania informacji o edytowanym artykule'
        else:
            NazwaSkr = rsglobal.Dekoduj(d[0][0]).strip()
            if NazwaSkr in ('','None',None):
                stat = 'BR_NAZWA_SKR'
                dane.append(stat)

    #WS 2019-07-25
    #WS 2021-11-17 - poprawka kontroli na par stawka VAT + nazwa skrcona
    if NazwaSkr not in ('','None',None):
        SEL = """SELECT artykul_id
                 FROM rs_artykuly_stawki_vat
                 WHERE firma_id='{}' AND nazwa_skrocona='{}' AND artykul_id!='{}' AND stawka_vat!='{}';"""
        SEL = SEL.format(self.firma_id, NazwaSkr, Symbol, VAT.strip("'"))
        # SEL = """SELECT artykul_id
        #          FROM rs_artykuly
        #          WHERE firma_id='{}' AND aktywny=TRUE AND nazwa_skrocona='{}' AND artykul_id!='{}';""".format(self.firma_id, NazwaSkr, Symbol)
        stat,d,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania informacji o artykuach: '+stat
            dane.append(stat)
        elif len(d) != 0:
            #WS 2021-11-17
            stat = 'Podana nazwa skrcona wystpuje w parze z inn stawkVAT dla artykuw: '+', '.join(dane[0].strip() for dane in d)
            # stat = 'Istniej inne aktywne artykuy o tej samej stawce VAT i nazwie skrconej: '+', '.join(d[0])
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -insert z pobraniem, 2 -insert)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,2):
    if not UprDod:
        stat = 'BR_UPR_DOD'
        dane.append(stat)
    else:
        INS = "INSERT INTO rs_artykuly (firma_id,stawka_vat_import,typ_artykulu,"  #WS 2020-09-10 - typ_artykulu
        INS+= ",".join(pola)

        INS += ") VALUES ('"+self.firma_id+"','"+VAT+"','01',"  #WS 2020-09-10 - typ_artykulu
        wartosci2 = []
        for wart in wartosci:
            if wart == '':
                wartosci2.append('NULL')
            elif isinstance(wart, basestring):
                wartosci2.append("'"+wart+"'")
            else:
                wartosci2.append(str(wart))

        INS+= ",".join(wartosci2) + "); "

        #WS 2019-07-24 - nazwa_skrocona
        INS+="""INSERT INTO rs_artykuly_stawki_vat
                (firma_id, artykul_id, stawka_vat, od_dnia, sww_pkwiu, stawka_vat_import, nazwa_skrocona)
                VALUES 
                ('{firma_id}','{artykul_id}','{stawka_vat}',NOW()::DATE,'{sww_pkwiu}','{stawka_vat_import}','{nazwa_skrocona}');
             """.format(firma_id          = self.firma_id,
                        artykul_id        = Symbol,
                        stawka_vat        = VAT,
                        sww_pkwiu         = PKWIU,
                        stawka_vat_import = VAT,
                        nazwa_skrocona    = NazwaSkr)

        INS+="""UPDATE rs_artykuly SET wprowadzil={wprowadzil}, data_wprowadzenia=NOW() 
                WHERE firma_id='{firma_id}' AND artykul_id='{artykul_id}';
             """.format(wprowadzil = self.operator_id,
                        firma_id   = self.firma_id,
                        artykul_id = Symbol)

        rsglobal.ZapiszDoLogow(INS,5)
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd wstawiania danych: '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-update z pobraniem, 4 -update)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3,4):
    if not UprMod:
        stat = 'BR_UPR_MOD'
        dane.append(stat)
    else:
        UPD = "UPDATE rs_artykuly SET "

        wartosci2 = []
        for pole,wart in zip(pola,wartosci):
            #WS 2021-11-17
            if pole in ('nazwa_skrocona', 'stawka_vat', 'sww_pkwiu'):
                continue

            if wart == '':
                wartosci2.append(pole+'=NULL')
            elif isinstance(wart, basestring):
                wartosci2.append(pole+"="+"'"+wart+"'")
            else:
                wartosci2.append(pole+"="+str(wart))

        UPD+= ",".join(wartosci2)
        UPD+= ",modyfikowal="+str(self.operator_id)+",data_modyfikacji=NOW(),zmieniony=TRUE"
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Symbol+"';"
        stat,d,dump,dump = self.PolSQL.Execute(UPD,1,CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow('UPD: ' + UPD, 5)
        if stat != 'OK':
           stat = "Bd modyfikacji danych: "+stat
           dane.append(stat)

#-------------------------------------------------------------------------------
#---   ZMIANY PO ZAPISIE
#-------------------------------------------------------------------------------

#WS 2020-09-20
if stat=='OK' and Funkcja in (1,2,3,4):
    sql = ''
    if 'zamiennik_id' in pola:
        sql+="UPDATE rs_artykuly SET zamiennik_id="+rsglobal.ZmienNaNULL(Zamiennik)
        sql+=" WHERE firma_id='"+self.firma_id+"' AND zamiennik_id='"+Symbol+"';"

    if sql != '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,1)
        if stat != 'OK':
            stat = 'Bd modyfikacji zamiennika: '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5,3,1):
    if not UprPrzegl:
        stat = 'BR_UPR_PRZEGL'
        dane.append(stat)
    else:
        #WS 2020-09-20 - Zamiennik
        GrupaTowarowa = StawkaVat = Producent = Dostawca = Jm1 = Jm2 = Decydent = Kategoria = Zamiennik = ''

        #WS 2019-08-22 - kateg_artykulu
        #WS 2020-09-20 - zamiennik_id
        #WS 2023-12-07 - na_magazyn_surowcow
        SEL = """SELECT artykul_id, nazwa, stawka_vat, kateg_artykulu, producent_id, dostawca_id, sww_pkwiu, a.aktywny, jm1, jm2, 
                        przelicznik, przelicznik_odwr, ilosc1, ilosc2, ost_przychod, ost_rozchod, tylko_detal, decydent,
                        nazwa_skrocona, grupa_towarowa, czy_podlega_ubytkom, tylko_dokumenty, nie_na_kasy,
                        rozliczac_produkcje, na_magazyn_surowcow, zmieniony, kgo, czy_mpp, zamiennik_id,
                        to_char(data_wprowadzenia, 'YYYY-MM-DD HH24:MI:SS') AS data_wprowadzenia, 
                        to_char(data_modyfikacji,  'YYYY-MM-DD HH24:MI:SS') AS data_modyfikacji, 
                        wprowadzil::TEXT  || '. ' || wpr.imie || ' ' || wpr.nazwisko AS wprowadzil, 
                        modyfikowal::TEXT || '. ' || mod.imie || ' ' || mod.nazwisko AS modyfikowal
                 FROM   rs_artykuly a
                 LEFT OUTER JOIN rs_operatorzy wpr ON wprowadzil = wpr.operator_id
                 LEFT OUTER JOIN rs_operatorzy mod ON modyfikowal = mod.operator_id
                 WHERE  firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, Symbol)

        stat,dane,wyn1,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd podczas pobierania danych: "+stat
            dane.append(stat)
        else:
            for pole,wart in zip(wyn1,dane[0]):
                pole = pole[0]
                wart = str(wart)

                if pole == 'producent_id' and wart != 'None':
                    if ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT nazwa FROM rs_kontrahenci 
                                 WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Producent = 'Bd pobrania opisu producenta z katalogu'
                        else:
                            if len(d) == 0:
                                Producent = 'Bdny kod producenta'
                            else:
                                Producent = d[0][0]
                    else:
                        Producent = 'Brak uprawnie do katalogu. Poinformuj administratora.'

                elif pole == 'dostawca_id' and wart != 'None':
                    if ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT nazwa FROM rs_kontrahenci 
                                 WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Dostawca = 'Bd pobrania opisu dostawcy z katalogu'
                        else:
                            if len(d) == 0:
                                Dostawca = 'Bdny kod dostawcy.'
                            else:
                                Dostawca = d[0][0]
                    else:
                        Dostawca = 'Brak uprawnie do katalogu. Poinformuj administratora.'

                elif pole == 'grupa_towarowa' and wart != 'None':
                    if ((self.oddzial_id,'D') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT opis FROM rs_hd_grupy_towarowe 
                                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            GrupaTowarowa = 'Bd pobrania opisu grupy towarowej'
                        else:
                            if len(d) == 0:
                                GrupaTowarowa = 'Bdny kod grupy towarowej'
                            else:
                                GrupaTowarowa = d[0][0]
                    else:
                        Typ = 'Brak uprawnie do sownika. Poinformuj administratora.'

                elif pole == 'stawka_vat':
                    if ((self.oddzial_id,'011120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT opis FROM rs_stawki_vat WHERE kod='{}';""".format(wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            StawkaVat = 'Bd pobrania opisu stawki VAT'
                        else:
                            if len(d) == 0:
                                StawkaVat = 'Bdny kod stawki VAT'
                            else:
                                StawkaVat = d[0][0]
                    else:
                        StawkaVat = 'Brak uprawnie do sownika. Poinformuj administratora.'

                elif pole == 'jm1':
                    if ((self.oddzial_id,'011110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT opis FROM rs_jednostki_miar 
                                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Jm1 = 'Bd pobrania opisu jed.miary 1'
                        else:
                            if len(d) == 0:
                                Jm1 = 'Bdny kod j.m. 1'
                            else:
                                Jm1 = d[0][0]
                    else:
                        Jm1 = 'Brak uprawnie do sownika. Poinformuj administratora.'

                elif pole == 'jm2':
                    if ((self.oddzial_id,'011110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT opis FROM rs_jednostki_miar 
                                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Jm2 = 'Bd pobrania opisu j.m. 2'
                        else:
                            if len(d) == 0:
                                Jm2 = 'Bdny kod j.m. 2'
                            else:
                                Jm2 = d[0][0]
                    else:
                        Jm2 = 'Brak uprawnie do sownika. Poinformuj administratora.'

                elif pole == 'decydent' and wart != 'None':
                    if ((self.oddzial_id,'211380') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT opis FROM rs_hd_decydenci 
                                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Decydent = 'Bd pobrania opisu decydenta'
                        else:
                            if len(d) == 0:
                                Decydent = 'Bdny kod decydenta'
                            else:
                                Decydent = d[0][0]
                    else:
                        Decydent = 'Brak uprawnie do sownika. Poinformuj administratora.'

                #WS 2019-08-22
                elif pole == 'kateg_artykulu' and wart != 'None':
                    if ((self.oddzial_id,'011060') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT opis FROM rs_kateg_artykulow 
                                 WHERE firma_id='{}' AND kod='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Kategoria = 'Bd pobrania opisu kategorii'
                        else:
                            if len(d) == 0:
                                Kategoria = 'Bdny kod kategorii'
                            else:
                                Kategoria = d[0][0]
                    else:
                        Kategoria = 'Brak uprawnie do sownika. Poinformuj administratora.'

                #WS 2020-09-20
                elif pole == 'zamiennik_id' and wart != 'None':
                    if ((self.oddzial_id,'092100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        SEL = """SELECT nazwa FROM rs_artykuly 
                                 WHERE firma_id='{}' AND artykul_id='{}';""".format(self.firma_id, wart)
                        stat,d,dump,dump = self.PolSQL.Execute(SEL,3)
                        if stat != 'OK':
                            Zamiennik = 'Bd pobrania opisu zamiennika'
                        else:
                            if len(d) == 0:
                                Zamiennik = 'Bdny symbol zamiennika'
                            else:
                                Zamiennik = d[0][0]
                    else:
                        Zamiennik = 'Brak uprawnie do kartoteki artykuw. Poinformuj administratora.'

            #WS 2020-09-20 - Zamiennik
            wyn2 = [GrupaTowarowa,Producent,Dostawca,StawkaVat,Jm1,Jm2,Decydent,Kategoria,Zamiennik]

#----------------  komser: przesanie modyfikacji danych dalej jeli tak ustawiono
if stat == "OK" and Funkcja in (1,2,3,4) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja,4,CzyDodawacBlad=True)
    if stat != "OK":
        stat = 'Bd wykonania zapytania: '+stat
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], ['fs_komser_artykuly', klucze, pola, wartosci])
        if stat != 'OK':
            stat = 'Bd wykonania fs_komser_zapisz: '+stat
