# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_kasy_stoiska.py
# Purpose:     Pobieranie i usuwanie powiza kas ze stoiskami w placwkach handlowych
# Author:      Wojciech Skowron
# Created:     2019/11/06
# RCS-ID:      $Id: fs_hd_kasy_stoiska.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
091531 Przegldanie
091532 Modyfikacja
"""

stat = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprMod = ((self.oddzial_id, '091532') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprPrz = ((self.oddzial_id, '091531') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Klucz':[5,6], 'Typ':[5,6], 'Placowka':[6], 'Stoisko':[6], 'Kasa':[6], 'DataOd':[6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_kasy_stoiska z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    if Funkcja in (5,6):
        Typ        = rsglobal.Dekoduj(klucze['Typ']).strip()
        Klucz      = [rsglobal.Dekoduj(el) for el in klucze['Klucz']]
    if Funkcja == 6:
        Placowka   = rsglobal.Dekoduj(klucze['Placowka']).strip()
        Stoisko    = rsglobal.Dekoduj(klucze['Stoisko']).strip()
        Kasa       = rsglobal.Dekoduj(klucze['Kasa'])
        DataOd     = rsglobal.Dekoduj(klucze['DataOd']).strip()

dane = []

# -------------------------------------------------------------------------------
# --------------------   USUWANIE Z POBRANIEM (6)  ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (6, ):
    if not UprMod > 0:
        stat = 'UPR MOD'
    else:
        DEL = """DELETE FROM rs_hd_kasy_stoiska 
                 WHERE firma_id='{firma_id}' AND kasa_id={kasa_id} AND sklep_id='{sklep_id}' 
                 AND typ_stoiska_id='{typ_stoiska_id}' AND data_od='{data_od}';
              """.format(firma_id       = self.firma_id,
                         kasa_id        = Kasa,
                         sklep_id       = Placowka,
                         typ_stoiska_id = Stoisko,
                         data_od        = DataOd)
        stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(DEL)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat, 1)
            stat = 'Bd usuwania danych: '+stat

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH (5, 6)  ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, 6):
    if Typ == 'Stoiska':
        WHERE   = "firma_id='{firma_id}' AND ks.kasa_id={kasa_id}"
        WHERE   = WHERE.format(firma_id = self.firma_id,
                               kasa_id  = Klucz[0])

        ORDERBY = "ks.data_od"
    else:
        WHERE   = "firma_id='{firma_id}' AND ks.sklep_id='{sklep_id}' AND ks.typ_stoiska_id='{typ_stoiska_id}' " \
                  "AND ks.data_od_stoiska='{data_od_stoiska}'"
        WHERE   = WHERE.format(firma_id        = self.firma_id,
                               sklep_id        = Klucz[0],
                               typ_stoiska_id  = Klucz[1],
                               data_od_stoiska = Klucz[2])

        ORDERBY = "ks.kasa_id"

    SEL = """SELECT ks.sklep_id, ks.typ_stoiska_id, ks.data_od_stoiska, ks.kasa_id, k.nazwa, ks.data_od, ks.data_do
             FROM rs_hd_kasy_stoiska ks
             JOIN rs_hd_kasy k USING (firma_id, kasa_id)
             WHERE {} ORDER BY {};
             """.format(WHERE, ORDERBY)

    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SEL)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'Bd pobierania danych: ' + stat
