# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_kasy_stoiska_dane.py
# Purpose:     Edycja danych powiza kas ze stoiskami w placwkach handlowych
# Author:      Wojciech Skowron
# Created:     2019/11/08
# RCS-ID:      $Id: fs_hd_kasy_stoiska_dane.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2019-12-18 Wojciech Skowron - (11783) Kontrola dat midzy nagwkiem placwki handlowej i stoiskami placwki handlowej

"""
091531 Przegldanie
091532 Modyfikacja
"""

stat = 'UPR_PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprMod = ((self.oddzial_id, '091532') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprPrz = ((self.oddzial_id, '091531') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

dane = []

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Kasa':[1,2,3,4,5], 'Placowka':[1,2,3,4,5], 'Stoisko':[1,2,3,4,5], 'DataOd':[1,2,3,4,5], 'DataOdStoiska':[1,2,3,4,5], 'Typ':[1,2,3,4,5]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga: wywoanie funkcji fs_hd_kasy_stoiska_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK' and Funkcja in (1,2,3,4,5,):
    PlacowkaKlucz      = rsglobal.Dekoduj(klucze['Placowka']).strip()
    StoiskoKlucz       = rsglobal.Dekoduj(klucze['Stoisko']).strip()
    KasaKlucz          = rsglobal.Dekoduj(klucze['Kasa'])
    DataOdStoiskaKlucz = rsglobal.Dekoduj(klucze['DataOdStoiska']).strip()
    DataOdKlucz        = rsglobal.Dekoduj(klucze['DataOd']).strip()
    Typ           = rsglobal.Dekoduj(klucze['Typ']).strip()

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH(1, 3)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR_MOD'

    if Typ not in ('Kasy','Stoiska'):
        stat = 'BL_TYP'

    if stat == 'OK':
        kasa             = None
        sklep            = None
        stoisko          = None
        data_od          = None
        data_do          = None
        data_od_stoiska  = None
        data_do_stoiska  = None
        data_od_kasy     = None
        data_do_kasy     = None
        data_od_placowki = None
        data_do_placowki = None
        ip_vnc_in        = None
        ip_vnc_out       = None

        KasaOK  = True
        SklepOK = True
        DatyOK  = True

        for pole, wart in zip(pola, wartosci):
            if pole == 'kasa_id':
                if wart is None:
                    stat = 'BR_KASA'
                    dane.append(stat)
                else:
                    SQL = "SELECT 1 FROM rs_hd_kasy WHERE firma_id='{}' AND kasa_id={};".format(self.firma_id, wart)
                    rsglobal.ZapiszDoLogow(SQL, 1)
                    stat, kasa_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania numeru kasy: '+ stat
                        dane.append(stat)

                        KasaOK = False
                    elif len(kasa_dane) == 0:
                        stat = 'BL_KASA${}'.format(wart)
                        dane.append(stat)

                        KasaOK = False
                    else:
                        kasa = wart

            elif pole == 'sklep_id':
                if wart is None or wart.strip() in ('','None'):
                    stat = 'BR_SKLEP'
                    dane.append(stat)
                else:
                    SQL = "SELECT 1 FROM rs_hd_sklepy WHERE firma_id='{}' AND sklep_id='{}';".format(self.firma_id, wart)
                    rsglobal.ZapiszDoLogow(SQL, 1)
                    stat, sklep_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania id sklepu: '+ stat
                        dane.append(stat)

                        SklepOK = False
                    elif len(sklep_dane) == 0:
                        stat = "BL_SKLEP${}".format(wart)
                        dane.append(stat)

                        SklepOK = False
                    else:
                        sklep = wart

            elif pole == 'typ_stoiska_id':
                if wart is None or wart.strip() in ('','None'):
                    stat = 'BR_STOISKO'
                    dane.append(stat)
                else:
                    stoisko = wart

            elif pole == 'data_od_stoiska':
                if wart is None or wart in ('', '    -  -  '):
                    stat = 'BR_DATA_OD_STOISKA'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA_OD_STOISKA'
                    dane.append(stat)
                else:
                    data_od_stoiska = wart

            elif pole == 'data_od':
                if wart is None or wart in ('', '    -  -  '):
                    DatyOK = False
                    stat = 'BR_DATA_OD'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    DatyOK = False
                    stat = 'BL_DATA_OD'
                    dane.append(stat)
                else:
                    data_od = wart

            elif pole == 'data_do':
                if wart is not None and wart not in ('', '    -  -  ') and not rsglobal.SprawdzCzyToData(wart):
                    DatyOK = False
                    stat = 'BL_DATA_DO'
                    dane.append(stat)
                else:
                    data_do = wart

            elif pole in ('adres_ip_vnc_in', 'adres_ip_vnc_out'):
                if wart != '':
                    for znak in wart:
                        if znak not in ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.'):
                            if pole == 'adres_ip_vnc_in':
                                stat = """Niepoprawny znak w lokalnym adresie IP VNC: {}""".format(rsglobal.Dekoduj(znak))
                            else:
                                stat = """Niepoprawny znak w publicznym adresie IP VNC: {}""".format(rsglobal.Dekoduj(znak))
                            dane.append(stat)
                            break

                    if stat == 'OK':
                        grupy = [int(sekcja) for sekcja in filter(len, wart.split('.'))]

                        if len(grupy) != 4:
                            if pole == 'adres_ip_vnc_in':
                                stat = 'BL_IP_VNC_IN'
                            else:
                                stat = 'BL_IP_VNC_OUT'
                            dane.append(stat)

                        else:
                            for grupa in grupy:
                                if grupa > 255 or grupa < 0:
                                    if pole == 'adres_ip_vnc_in':
                                        stat = 'BL_IP_VNC_IN'
                                    else:
                                        stat = 'BL_IP_VNC_OUT'
                                    dane.append(stat)
                        if stat == 'OK':
                            wart = '.'.join([str(grupa) for grupa in grupy])
                else:
                    if pole == 'adres_ip_vnc_in':
                        stat = 'BR_IP_VNC_IN'
                    else:
                        stat = 'BR_IP_VNC_OUT'
                    dane.append(stat)

        kasa = kasa or KasaKlucz
        sklep = sklep or PlacowkaKlucz
        stoisko = stoisko or StoiskoKlucz
        data_od = data_od or DataOdKlucz
        data_od_stoiska = data_od_stoiska or DataOdStoiskaKlucz

        SQL = """SELECT data_od, data_do FROM rs_hd_sklepy_stoiska
                 WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                 AND typ_stoiska_id='{typ_stoiska_id}' AND data_od='{data_od_stoiska}';"""
        SQL = SQL.format(firma_id        = self.firma_id,
                         sklep_id        = sklep,
                         typ_stoiska_id  = stoisko,
                         data_od_stoiska = data_od_stoiska)
        rsglobal.ZapiszDoLogow(SQL, 1)
        stat, stoisko_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd sprawdzania stoiska: '+ stat
            dane.append(stat)
        elif len(stoisko_dane) == 0:
            stat = "BL_STOISKO${}".format(sklep+" / "+stoisko+" / "+data_od_stoiska)
            dane.append(stat)
        elif Typ == "Stoiska" and len(stoisko_dane) > 0 and not (stoisko_dane[0][1] in ('', '    -  -  ','None') or stoisko_dane[0][1] >= rsglobal.PodajDzis()):
            stat = "BL_STOISKO2${}".format(sklep+" / "+stoisko+" / "+data_od_stoiska)
            dane.append(stat)
        else:
            if (stoisko_dane[0][0] not in ('', '    -  -  ','None') and stoisko_dane[0][1] not in ('', '    -  -  ','None') and stoisko_dane[0][0] > stoisko_dane[0][1]) \
            or stoisko_dane[0][0] != data_od_stoiska:
                stat = 'BL_DATY_STOISKO'
                dane.append(stat)
            else:
                data_do_stoiska = stoisko_dane[0][1] if stoisko_dane[0][1] not in ('', '    -  -  ','None') else None

        if data_od is None or data_do is None:
            SQL = """SELECT data_od, data_do FROM rs_hd_kasy_stoiska 
                     WHERE firma_id='{firma_id}' AND kasa_id={kasa_id} AND sklep_id='{sklep_id}'
                     AND typ_stoiska_id='{typ_stoiska_id}' AND data_od_stoiska='{data_od_stoiska}' 
                     AND data_od='{data_od}';"""
            SQL = SQL.format(firma_id        = self.firma_id,
                             kasa_id         = KasaKlucz,
                             sklep_id        = PlacowkaKlucz,
                             typ_stoiska_id  = StoiskoKlucz,
                             data_od_stoiska = DataOdStoiskaKlucz,
                             data_od         = DataOdKlucz)
            rsglobal.ZapiszDoLogow(SQL, 1)
            stat, daty_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                DatyOK = False
                stat = 'Bd sprawdzania danych: '+ stat
                dane.append(stat)
            elif len(daty_dane) == 0:
                DatyOK = False
                stat = "Bd sprawdzania danych, wiersz o podanym kluczu nie istnieje ({}, {}, {}, {}).".format(KasaKlucz, PlacowkaKlucz, StoiskoKlucz, DataOdKlucz)
                dane.append(stat)
            else:
                data_od = data_od or daty_dane[0][0]
                data_do = data_do or (daty_dane[0][1] if daty_dane[0][1] not in ('', '    -  -  ','None') else None)

        if KasaOK:
            SQL = """SELECT data_od, data_do FROM rs_hd_kasy
                     WHERE firma_id='{firma_id}' AND kasa_id={kasa_id};"""
            SQL = SQL.format(firma_id = self.firma_id,
                             kasa_id  = kasa)
            rsglobal.ZapiszDoLogow(SQL, 1)
            stat, daty_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzania danych: '+ stat
                dane.append(stat)
            elif len(daty_dane) == 0:
                stat = "Bd sprawdzania danych, kasa o numerze {} nie istnieje.".format(KasaKlucz)
                dane.append(stat)
            else:
                if daty_dane[0][0] not in ('', '    -  -  ','None') and daty_dane[0][1] not in ('', '    -  -  ','None') and daty_dane[0][0] > daty_dane[0][1]:
                    stat = 'BL_DATY_KASA'
                    dane.append(stat)
                else:
                    data_od_kasy = daty_dane[0][0] if daty_dane[0][0] not in ('', '    -  -  ','None') else None
                    data_do_kasy = daty_dane[0][1] if daty_dane[0][1] not in ('', '    -  -  ','None') else None

        #WS 2019-12-18
        if SklepOK:
            SQL = """SELECT data_od, data_do FROM rs_hd_sklepy
                     WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}';"""
            SQL = SQL.format(firma_id = self.firma_id,
                             sklep_id  = sklep)
            rsglobal.ZapiszDoLogow(SQL, 1)
            stat, daty_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzania danych: '+ stat
                dane.append(stat)
            elif len(daty_dane) == 0:
                stat = "Bd sprawdzania danych, sklep '{}' nie istnieje.".format(KasaKlucz)
                dane.append(stat)
            else:
                data_od_placowki = daty_dane[0][0] if daty_dane[0][0] not in ('', '    -  -  ','None') else None
                data_do_placowki = daty_dane[0][1] if daty_dane[0][1] not in ('', '    -  -  ','None') else None

        if DatyOK and data_do not in ('', '    -  -  ','None',None) and data_od > data_do:
            DatyOK = False
            stat = 'BL_DATY'
            dane.append(stat)

        if DatyOK and Typ == 'Stoiska':
            # Dla wszystkich wierszy oprcz zmienianego/dodawanego:
            # - czy data_od ktregokolwiek z nich jest zawarta pomidzy datami podanymi na okienku
            # - czy data_do ktregokolwiek z nich jest zawarta pomidzy datami podanymi na okienku
            # - czy daty na okienku s zawarte pomidzy datami ktregokolwiek z nich
            # - czy data_do ktregokolwiek z nich jest pusta i jednoczenie data_od wczeniejsza od daty_od na okienku

            SQL = """SELECT data_od, data_do, kasa_id, sklep_id, typ_stoiska_id, data_od_stoiska FROM rs_hd_kasy_stoiska
                     WHERE firma_id='{firma_id}' AND kasa_id={kasa_id} AND NOT (sklep_id='{sklep_id}'
                     AND typ_stoiska_id='{typ_stoiska_id}' AND data_od_stoiska='{data_od_stoiska}' AND data_od='{data_od}') 
                     AND
                     (((data_od<=COALESCE({data_do_nowa},'2501-01-01')::DATE AND data_od>='{data_od_nowa}')
                     OR 
                     (data_do<=COALESCE({data_do_nowa},'2501-01-01')::DATE AND data_do>='{data_od_nowa}'))
                     OR
                     (data_od<='{data_od_nowa}' AND data_do>=COALESCE({data_do_nowa},'2501-01-01')::DATE)
                     OR
                     (data_od IS NOT NULL AND data_do IS NULL AND data_od<'{data_od_nowa}'))
                     ORDER BY data_od DESC;"""
            SQL = SQL.format(firma_id        = self.firma_id,
                             kasa_id         = KasaKlucz,
                             sklep_id        = PlacowkaKlucz,
                             typ_stoiska_id  = StoiskoKlucz,
                             data_od_stoiska = DataOdStoiskaKlucz,
                             data_od         = DataOdKlucz,
                             data_od_nowa    = data_od,
                             data_do_nowa    = "'"+data_do+"'" if data_do not in ('', '    -  -  ','None',None) else 'NULL')
            rsglobal.ZapiszDoLogow(SQL, 1)
            stat, daty_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzania danych: '+ stat
                dane.append(stat)
            elif len(daty_dane) > 1:
                stat = 'BL_DATY_STOISKA_DLA_KASY$'+str(KasaKlucz)
                dane.append(stat)
            elif len(daty_dane) == 1:
                if daty_dane[0][1] in ('', '    -  -  ','None') and daty_dane[0][0] < data_od:
                    # przypadek kiedy daty s ok, ale wczeniejsze powizanie jest niezamknite - czyli data_do jest pusta
                    # i trzeba j uzupeni
                    SQL = """UPDATE rs_hd_kasy_stoiska SET data_do=('{data_od_nowa}'::DATE-INTERVAL '1 day')::DATE
                             WHERE (firma_id, kasa_id, sklep_id, typ_stoiska_id, data_od)=
                                   ('{firma_id}',{kasa_id},'{sklep_id}','{typ_stoiska_id}','{data_od}')
                                   AND data_od<'{data_od_nowa}' AND data_do IS NULL ;"""
                    SQL = SQL.format(firma_id        = self.firma_id,
                                     kasa_id         = daty_dane[0][2],
                                     sklep_id        = daty_dane[0][3],
                                     typ_stoiska_id  = daty_dane[0][4],
                                     data_od_stoiska = daty_dane[0][5],
                                     data_od         = daty_dane[0][0],
                                     data_od_nowa    = data_od)
                    rsglobal.ZapiszDoLogow(SQL, 1)
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd zamykania stoiska: '+ stat
                        dane.append(stat)
                else:
                    stat = 'BL_DATY_STOISKA_DLA_KASY$'+str(KasaKlucz)
                    dane.append(stat)

        elif DatyOK and Typ == 'Kasy' and KasaOK:
            SQL = """SELECT data_od, data_do, sklep_id, typ_stoiska_id, data_od_stoiska FROM rs_hd_kasy_stoiska
                     WHERE firma_id='{firma_id}' AND kasa_id={kasa_id} AND NOT (sklep_id='{sklep_id}'
                     AND typ_stoiska_id='{typ_stoiska_id}' AND data_od_stoiska='{data_od_stoiska}' AND data_od='{data_od}') 
                     AND
                     (((data_od<=COALESCE({data_do_nowa},'2501-01-01')::DATE AND data_od>='{data_od_nowa}')
                     OR 
                     (data_do<=COALESCE({data_do_nowa},'2501-01-01')::DATE AND data_do>='{data_od_nowa}'))
                     OR
                     (data_od<='{data_od_nowa}' AND data_do>=COALESCE({data_do_nowa},'2501-01-01')::DATE)
                     OR
                     (data_od IS NOT NULL AND data_do IS NULL AND data_od<'{data_od_nowa}'))
                     ORDER BY data_od DESC LIMIT 1;"""
            SQL = SQL.format(firma_id        = self.firma_id,
                             kasa_id         = kasa,
                             sklep_id        = PlacowkaKlucz,
                             typ_stoiska_id  = StoiskoKlucz,
                             data_od         = DataOdKlucz,
                             data_od_stoiska = DataOdStoiskaKlucz,
                             data_od_nowa    = data_od,
                             data_do_nowa    = "'"+data_do+"'" if data_do not in ('', '    -  -  ','None',None) else 'NULL')
            rsglobal.ZapiszDoLogow(SQL, 1)
            stat, daty_dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzania danych: '+ stat
                dane.append(stat)
            elif len(daty_dane) > 0:
                stat = 'BL_DATY_KASY_DLA_STOISKA$'+str(daty_dane[0][2].strip()+" / "+daty_dane[0][3].strip()+" / "+daty_dane[0][4])
                dane.append(stat)

        if DatyOK:
            if data_od and data_od_stoiska and data_od_stoiska > data_od:
                stat = 'BL_DATY2'
                dane.append(stat)

            if data_od and data_do_kasy and data_od > data_do_kasy:
                stat = 'BL_DATY3'
                dane.append(stat)

            if data_od and data_do_stoiska and data_od > data_do_stoiska:
                stat = 'BL_DATY4'
                dane.append(stat)

            if data_do and data_do_stoiska and data_do > data_do_stoiska:
                stat = 'BL_DATY5'
                dane.append(stat)

            if data_od and data_od_kasy and data_od_kasy > data_od:
                stat = 'BL_DATY6'
                dane.append(stat)

            if data_do and data_do_kasy and data_do > data_do_kasy:
                stat = 'BL_DATY7'
                dane.append(stat)

            #WS 2019-12-18
            if data_od and data_do_placowki and data_od > data_do_placowki:
                stat = 'BL_DATY8'
                dane.append(stat)

            if data_do and data_do_placowki and data_do > data_do_placowki:
                stat = 'BL_DATY9'
                dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------------   INSERT(1)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2):
    INS = "INSERT INTO rs_hd_kasy_stoiska "
    POLA = "firma_id "
    WART = "'" + self.firma_id + "' "

    for pole, wart in zip(pola, wartosci):
        POLA += "," + pole

        if wart in ('', '    -  -  '):
            WART += ",NULL"
        elif isinstance(wart, int) or isinstance(wart, float):
            WART += "," + str(wart)+""
        else:
            WART += ",'" + str(wart)+"'"

    INS += "(" + POLA + ") VALUES (" + WART + ");"

    rsglobal.ZapiszDoLogow(INS)
    stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd dodawania kasy: ' + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# --------------------------   UPDATE(3)   --------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3, 4):
    UPD = "UPDATE rs_hd_kasy_stoiska SET  "

    for pole, wart in zip(pola, wartosci):
        if wart in ('', '    -  -  '):
            UPD += pole + "=NULL,"
        else:
            UPD += pole + "='" + str(wart) + "',"

    UPD = UPD[:-1]
    UPD += """ WHERE firma_id='{firma_id}' AND kasa_id={kasa_id} AND sklep_id='{sklep_id}' 
               AND typ_stoiska_id='{typ_stoiska_id}' AND data_od='{data_od}';"""
    UPD = UPD.format(firma_id       = self.firma_id,
                     kasa_id        = KasaKlucz,
                     sklep_id       = PlacowkaKlucz,
                     typ_stoiska_id = StoiskoKlucz,
                     data_od        = DataOdKlucz)

    rsglobal.ZapiszDoLogow(UPD)
    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bdy modyfikowania danych: ' + stat
        dane.append(stat)
    else:
        KasaKlucz = kasa or KasaKlucz
        PlacowkaKlucz = sklep or PlacowkaKlucz
        StoiskoKlucz = stoisko or StoiskoKlucz
        DataOdKlucz = data_od or DataOdKlucz

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH(1, 3, 5)   ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5):
    SEL = """SELECT * FROM rs_hd_kasy_stoiska
             WHERE firma_id='{firma_id}' AND kasa_id={kasa_id} AND sklep_id='{sklep_id}' 
             AND typ_stoiska_id='{typ_stoiska_id}' AND data_od='{data_od}';"""
    SEL = SEL.format(firma_id       = self.firma_id,
                     kasa_id        = KasaKlucz,
                     sklep_id       = PlacowkaKlucz,
                     typ_stoiska_id = StoiskoKlucz,
                     data_od        = DataOdKlucz)

    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'Bd pobierania danych: ' + stat
