# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_paragony.py
# Purpose:     Przegladanie paragonw fiskalnych (Handel)
# Author:      Wojciech Skowron
# Created:     2019/10/08
# RCS-ID:      $Id: fs_hd_paragony.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2019-01-13 Wojciech Skowron - (11816) Uwzgldnienie filtru na sposb zapaty
# 2020-05-11 Wojciech Skowron - (11973) Poprawki

import rsglobal

"""
093610 Paragony fiskalne
093611 Przegldanie
"""

stat = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrz = ((self.oddzial_id, '093610') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'NrTransakcjiF':[5], 'NrParagonuF':[5], 'DataOdF':[5], 'GodzinaOdF':[5],
             'DataDoF':[5], 'GodzinaDoF':[5], 'PlacowkaF':[5], 'TypStoiskaF':[5], 'DataOdStoiskaF':[5],
             'KasaF':[5], 'KontrahentF':[5], 'NIPF':[5], 'KasjerF':[5], 'RabatF':[5], 'SposobZaplatyF':[5],
             'WartoscOdF':[5], 'WartoscDoF':[5], 'TypPozF':[5], 'ArtykulPozF':[5], 'GrupaTowarowaPozF':[5],
             'StawkaVATPozF':[5], 'WartoscOdPozF':[5], 'WartoscDoPozF':[5],
             'CzyPozycje':[5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_paragony z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
if stat == "OK":
    if Funkcja == 5:
        CzyPozycje = klucze['CzyPozycje']

        NrTransakcjiF = rsglobal.Dekoduj(klucze['NrTransakcjiF'])
        NrParagonuF = rsglobal.Dekoduj(klucze['NrParagonuF'])
        DataOdF = rsglobal.Dekoduj(klucze['DataOdF'])
        GodzinaOdF = rsglobal.Dekoduj(klucze['GodzinaOdF'])
        DataDoF = rsglobal.Dekoduj(klucze['DataDoF'])
        GodzinaDoF = rsglobal.Dekoduj(klucze['GodzinaDoF'])
        PlacowkaF = rsglobal.Dekoduj(klucze['PlacowkaF'])
        TypStoiskaF = rsglobal.Dekoduj(klucze['TypStoiskaF'])
        DataOdStoiskaF = rsglobal.Dekoduj(klucze['DataOdStoiskaF'])
        KasaF = rsglobal.Dekoduj(klucze['KasaF'])
        KontrahentF = rsglobal.Dekoduj(klucze['KontrahentF'])
        NIPF = rsglobal.Dekoduj(klucze['NIPF'])
        KasjerF = rsglobal.Dekoduj(klucze['KasjerF'])
        RabatF = rsglobal.Dekoduj(klucze['RabatF'])
        SposobZaplatyF = rsglobal.Dekoduj(klucze['SposobZaplatyF'])
        WartoscOdF = rsglobal.Dekoduj(klucze['WartoscOdF'])
        WartoscDoF = rsglobal.Dekoduj(klucze['WartoscDoF'])

        TypPozF = rsglobal.Dekoduj(klucze['TypPozF'])
        ArtykulPozF = rsglobal.Dekoduj(klucze['ArtykulPozF'])
        GrupaTowarowaPozF = rsglobal.Dekoduj(klucze['GrupaTowarowaPozF'])
        StawkaVATPozF = rsglobal.Dekoduj(klucze['StawkaVATPozF'])
        WartoscOdPozF = rsglobal.Dekoduj(klucze['WartoscOdPozF'])
        WartoscDoPozF = rsglobal.Dekoduj(klucze['WartoscDoPozF'])

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH(1, 5)   ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, ):
    filtr = ''

    if NrTransakcjiF != '':
        filtr += " AND upper(p.nr_transakcji) LIKE upper('"+NrTransakcjiF+"%')"
    if NrParagonuF != '':
        filtr += " AND upper(p.nr_paragonu) LIKE upper('"+NrParagonuF+"%')"
    if DataOdF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataOdF):
        if GodzinaOdF not in ('','  :  ','None') and rsglobal.SprawdzCzyToGodzina(GodzinaOdF):
            filtr += " AND p.czas >= '{} {}:{}:00.000000'".format(DataOdF, GodzinaOdF[0:2].strip().rjust(2,'0'), GodzinaOdF[3:5].strip().rjust(2,'0'))
        else:
            filtr += " AND p.czas >= '"+DataOdF+" 00:00:00.000000'"
    if DataDoF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataDoF):
        if GodzinaDoF not in ('','  :  ','None') and rsglobal.SprawdzCzyToGodzina(GodzinaDoF):
            filtr += " AND p.czas <= '{} {}:{}:59.999999'".format(DataDoF, GodzinaDoF[0:2].strip().rjust(2,'0'), GodzinaDoF[3:5].strip().rjust(2,'0'))
        else:
            filtr += " AND p.czas <= '"+DataDoF+" 23:59:59.999999'"
    if PlacowkaF != '':
        filtr += " AND upper(p.sklep_id) LIKE upper('"+PlacowkaF+"%')"
    if TypStoiskaF != '':
        filtr += " AND upper(p.typ_stoiska_id) LIKE upper('"+TypStoiskaF+"%')"
    if DataOdStoiskaF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataOdStoiskaF):
        filtr += " AND p.data_od_stoiska = '"+DataOdStoiskaF+"'"
    if KasaF is not None:
        filtr += " AND p.kasa_id = "+str(KasaF)
    if KontrahentF != '':
        filtr += " AND upper(p.kontrahent_id) LIKE upper('"+KontrahentF+"%')"
    if NIPF != '':
        filtr += " AND regexp_replace(k.nip, '[^0-9]', '', 'g') LIKE '" + rsglobal.re.sub('[^0-9]', '', NIPF) + "%'"
    if KasjerF != '':
        filtr += " AND upper(p.kasjer_id) LIKE upper('"+KasjerF+"%')"
    if RabatF:
        filtr += " AND p.rabat > 0"
    if SposobZaplatyF:
        filtr += " AND ppl.platnosc = '"+SposobZaplatyF+"'"
    if WartoscOdF is not None:
        filtr += " AND p.wartosc >= "+str(WartoscOdF)
    if WartoscDoF is not None:
        filtr += " AND p.wartosc <= "+str(WartoscDoF)

    if CzyPozycje:
        if TypPozF != '':
            filtr += " AND pp.typ = '"+TypPozF+"'"
        if ArtykulPozF != '':
            filtr += " AND upper(pp.artykul_id) LIKE upper('"+ArtykulPozF+"%')"
        if GrupaTowarowaPozF != '':
            filtr += " AND upper(a.grupa_towarowa) LIKE upper('"+GrupaTowarowaPozF+"%')"
        if StawkaVATPozF != '':
            filtr += " AND upper(pp.proc_vat) = upper('"+StawkaVATPozF.rjust(2,'0')+"')"
        if WartoscOdPozF is not None:
            filtr += " AND pp.wartosc >= "+str(WartoscOdPozF)
        if WartoscDoPozF is not None:
            filtr += " AND pp.wartosc <= "+str(WartoscDoPozF)

    #WS 2020-05-11 - poprawione wywietlanie sklep/stoisko/kasa
    SEL = """SELECT p.paragon_id, p.nr_transakcji, p.nr_paragonu, to_char(p.czas, 'YYYY-MM-DD HH24:MI:SS'),
                    p.sklep_id || COALESCE(' / ' || p.typ_stoiska_id, '') || COALESCE(' / ' || p.data_od_stoiska, '') || COALESCE(' / ' || p.kasa_id::TEXT, '') as stoisko_kasa,
                    p.kontrahent_id, k.nip, p.kasjer_id, p.wartosc, p.rabat, p.ilosc_pkt,
                    ppl.platnosc {pola_pozycji}
             FROM rs_hd_paragony p
             LEFT OUTER JOIN rs_kontrahenci k USING (firma_id, kontrahent_id)
             {join_pozycje}
             LEFT OUTER JOIN rs_hd_paragony_platnosci ppl USING (paragon_id)
             WHERE p.firma_id='{firma_id}' {filtr} ORDER BY p.paragon_id;"""
    SEL = SEL.format(firma_id     = self.firma_id,
                     filtr        = filtr,
                     pola_pozycji = ", pp.typ, pp.artykul_id, a.nazwa_skrocona, pp.proc_vat, pp.ilosc, pp.cena_spr, pp.cena_ew, pp.wartosc" if CzyPozycje else ", '', '', '', '', NULL, NULL, NULL, NULL",
                     join_pozycje = "JOIN rs_hd_paragony_pozycje pp USING (paragon_id) LEFT OUTER JOIN rs_artykuly a ON (p.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id)" if CzyPozycje else '')

    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'Bd pobierania danych: ' + stat
