# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_placowki_handlowe.py
# Purpose:     przegladanie i usuwanie placowek handlowych
# Author:
# Created:     2019/08/20
# RCS-ID:      $Id: fs_hd_placowki_handlowe.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2019-11-12 Wojciech Skowron - (11711) TRIM(sklep_id)
# 2019-01-09 Wojciech Skowron - (11711) Komunikat przy usuwaniu o istniejcych powizaniach z kasami lub paragonach

import rsglobal

"""
Funkcje:
5 - Pobranie danych
6 - Usunicie placwki
 """

"""
091300 Placwki handlowe
091320 Modyfikacja
"""

stat      = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id, '091300') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod    = ((self.oddzial_id, '091320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


if UprPrzegl > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

if stat == 'OK' and Funkcja in (6, ):
    sklep_id = klucze['sklep_id']


# -------------------------------------------------------------------------------
# --------------------   USUWANIE Z POBRANIEM(6)   ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (6, ):
    if not UprMod > 0:
        stat = 'UPR DEL'
    else:
        #WS 2019-01-09
        # sprawdzenie, czy nie istniej powizania z kasami
        SQL = """SELECT FROM rs_hd_sklepy_stoiska WHERE firma_id='{}' AND sklep_id='{}';""".format(self.firma_id, sklep_id)
        stat, stoiska, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd sprawdzania stoisk: ' + stat
            dane.append(stat)
        elif len(stoiska) != 0:
            stat = 'Nie mona usun placwki {}, poniewa istniej przypisane do niej stoiska'.format(sklep_id)
            dane.append(stat)
        else:
            # sprawdzenie, czy nie istniej paragony dla tej placwki
            SQL = """SELECT FROM rs_hd_paragony WHERE firma_id='{}' AND sklep_id='{}';""".format(self.firma_id, sklep_id)
            stat, paragony, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzania paragonw: ' + stat
                dane.append(stat)
            elif len(paragony) != 0:
                stat = 'Nie mona usun placwki {}, poniewa istniej przypisane do niej paragony fiskalne'.format(sklep_id)
                dane.append(stat)
            else:
                SQL = "DELETE FROM rs_hd_sklepy WHERE firma_id='{}' AND sklep_id='{}';".format(self.firma_id, sklep_id)
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    rsglobal.ZapiszDoLogow(stat, 1)
                    stat = 'BL DEL'

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH(5, 6)   ------------------------------
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (5, 6, ):
    SQL = "SELECT TRIM(sklep_id), nazwa FROM rs_hd_sklepy WHERE firma_id='{}' ORDER BY sklep_id;".format(self.firma_id)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'BL SQL PRZ'
