# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_placowki_handlowe_artykuly_zamiana.py
# Purpose:     Edycja zamian artykuw w placwkach handlowych
# Author:      Aleksander Bargie
# Created:     2023-09-29
# RCS-ID:      $Id: fs_hd_placowki_handlowe_artykuly_zamiana.py $
# Copyright:   (c) 2023 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------


import rsglobal

"""
Funkcje:
1 - Dodawanie, Modyfikacja i Usuwanie danych(grid edytowalny)
5 - Pobranie danych
 """

"""
091300 - Placwki handlowe
091320 - Modyfikacja
"""

stat = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id, '091330') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod    = ((self.oddzial_id, '091332') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if UprPrzegl > 0:
    stat = 'OK'

if stat == 'OK' and 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

if stat == 'OK' and Funkcja in (1, 5, ):
    sklep_id     = klucze['sklep_id']
    ograniczenie = klucze['ograniczenie']

if stat == 'OK' and Funkcja in (1, ):
    if not UprMod > 0:
        stat = 'UPR MOD'

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []
dane   = []
wyn2   = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            DEL = ''
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_hd_sklepy_artykuly_zamiana WHERE firma_id='{}' AND sklep_id='{}'""".format(self.firma_id, sklep_id)
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"='"+str(wart)+"'"

                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL), 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(dane) == 0:
    if len(Update[0]) > 0:

        # wykonanie UPDATE
        if stat == 'OK':
            UPD = ''

            for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
                UPD += "UPDATE rs_hd_sklepy_artykuly_zamiana SET "
                for pole, wart in zip(pola, wartosci):
                    if pole not in ("artykul_opis_z", "artykul_opis_na"):
                        if pole == 'artykul_id_z' and wart in ('', '-  -', '    -  -  ', 'None'):
                            stat = "Nie wypeniono pola Artyku"
                            if stat not in dane:
                                dane.append(stat)
                        elif pole == 'data_od' and wart in ('', '-  -', '    -  -  ', 'None'):
                            stat = "Nie wypeniono pola Od dnia"
                            if stat not in dane:
                                dane.append(stat)
                        elif pole in ('artykul_id_z', 'artykul_id_na'):
                            if wart != '':
                                sql = "SELECT artykul_id FROM rs_artykuly  WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + wart + "';"
                                ok, d, dump, dump = self.PolSQL.Execute(sql, 2)
                                if ok != "OK":
                                    stat = "Bd sprawdzania poprawnoci symbolu artykuu"
                                    dane.append(stat)
                                else:
                                    if len(d) == 0:
                                        stat = "Niepoprawny symbol artykuu: " + wart
                                        dane.append(stat)
                        if wart in ('', '-  -', '    -  -  ', 'None'):
                            if pole == 'czy_surowiec':
                                UPD += pole+"=FALSE,"
                            else:
                                UPD += pole+"=NULL,"
                        else:
                            UPD += pole+"='"+str(wart)+"',"

                UPD = UPD.strip(",")
                UPD += " WHERE firma_id='"+self.firma_id+"' AND sklep_id='"+sklep_id+"'"

                for pole, wart in zip(Update[3], klucz): # petla po kluczu
                    UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

                UPD += ";"
            if UPD != '':
                rsglobal.ZapiszDoLogow(UPD)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)

if stat == 'OK' and len(dane) > 0:
    stat = dane[0]
#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(dane) == 0:
    if len(Insert[0]) > 0:

        # wykonanie INSERT
        INS = ''
        pola = Insert[1]

        for wartosci in Insert[0]:
            INSERT  = "INSERT INTO rs_hd_sklepy_artykuly_zamiana "
            KOLUMNY = "(firma_id, sklep_id"
            VALUES  = " VALUES ('"+self.firma_id+"','"+sklep_id+"'"
            for pole, wart in zip(pola, wartosci):
                if pole not in ("artykul_opis_z", "artykul_opis_na"):
                    KOLUMNY += ","+pole
                    if pole == 'artykul_id_z' and wart in ('', '-  -', '    -  -  ', 'None'):
                        stat = "Nie wypeniono pola Artyku"
                        if stat not in dane:
                            dane.append(stat)
                    elif pole == 'data_od' and wart in ('', '-  -', '    -  -  ', 'None'):
                        stat = "Nie wypeniono pola Od dnia"
                        if stat not in dane:
                            dane.append(stat)
                    elif pole in ('artykul_id_z', 'artykul_id_na'):
                        if wart != '':
                            sql = "SELECT artykul_id FROM rs_artykuly  WHERE firma_id='" + self.firma_id + "' AND artykul_id='" + wart + "';"
                            ok, d, dump, dump = self.PolSQL.Execute(sql, 2)
                            if ok != "OK":
                                stat = "Bd sprawdzania poprawnoci symbolu artykuu"
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Niepoprawny symbol artykuu: " + wart
                                    dane.append(stat)

                    if wart in ('', '-  -', '    -  -  ', 'None'):
                        if pole == 'czy_surowiec':
                            VALUES+=",FALSE"
                        else:
                            VALUES+=",NULL"
                    else:
                        VALUES+=",'"+str(wart)+"'"

            KOLUMNY+=")"
            VALUES+=");"
            INS += INSERT+KOLUMNY+VALUES
        if INS != '':
            rsglobal.ZapiszDoLogow(INS, 5)
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd przy dodawaniu danych: "+stat
                dane.append(stat)


if stat == 'OK' and len(dane) > 0:
    stat = dane[0]


# -------------------------------------------------------------------------------
# ------------------------------  INSERT (1)  -----------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    SQL = '''select distinct(artykul_id_z)
             from rs_hd_sklepy_artykuly_zamiana z1
             where firma_id =%s and sklep_id = %s
             and exists(select 1 
                        from rs_hd_sklepy_artykuly_zamiana z2
                        where (z1.firma_id, z1.sklep_id, z1.artykul_id_z) = (z2.firma_id, z2.sklep_id, z2.artykul_id_z)
                         and z1.data_od != z2.data_od
                         and tsrange(z1.data_od, z1.data_do + interval '1 day') && tsrange(z2.data_od, z2.data_do+ interval '1 day')
                        ); '''
    args = [self.firma_id, sklep_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, duplikaty, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzania pokrywania si dat: ' + stat
    elif len(duplikaty) > 0:
        stat = 'Znaleziono pokrywajce si daty dla artykuu/w: ' + (", ".join([x[0] for x in duplikaty]))


# -------------------------------------------------------------------------------
# ------------------------   POBRANIE DANYCH(1, 5)   ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5, ):
    if ograniczenie == 'surowce':
        ograniczenie = " AND czy_surowiec"
    elif ograniczenie == 'towary':
        ograniczenie = " AND NOT czy_surowiec"

    SQL = "SELECT artykul_id_z, az.nazwa AS artykul_opis_z, artykul_id_na, an.nazwa AS artykul_opis_na, data_od, data_do, czy_surowiec " \
          "FROM rs_hd_sklepy_artykuly_zamiana z " \
          "JOIN rs_artykuly az ON (az.firma_id, az.artykul_id)=(z.firma_id, z.artykul_id_z) " \
          "LEFT JOIN rs_artykuly an ON (an.firma_id, an.artykul_id)=(z.firma_id, z.artykul_id_na) " \
          "WHERE z.firma_id='{}' AND z.sklep_id='{}' {} " \
          "ORDER BY z.artykul_id_z, z.data_od DESC;"
    SQL = SQL.format(self.firma_id, sklep_id, ograniczenie)
    rsglobal.ZapiszDoLogow(SQL, 1)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'Bd pobierania danych'

