# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_placowki_handlowe_dane.py
# Purpose:     przegladanie, edycja i dodawanie placowek handlowych
# Author:
# Created:     2019/08/20
# RCS-ID:      $Id: fs_hd_placowki_handlowe_dane.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2019-12-17 Wojciech Skowron   - (11783) Kontrola dat midzy nagwkiem placwki handlowej i stoiskami placwki handlowej
# 2023-09-29 Aleksander Bargie - (13565) [HD] Do placwek handlowych doda kontrahent_id
# 2023-10-24 Aleksander Bargie - (13590) [HD] Dodatkowe magazyny w placwkach handlowych

import rsglobal

"""
Funkcje:
1 - Dodawanie z pobraniem danych
3 - Edycja z pobraniem danych
5 - Pobranie danych
 """

"""
091300 Placwki handlowe
091320 Modyfikacja
"""

stat      = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id, '091300') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod    = ((self.oddzial_id, '091320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
dane = []
wylaczenia = ('magazyn_opis', 'magazyn_przejsciowy_opis', 'magazyn_produkcji_opis', 'magazyn_surowcow_opis', 'sklep_id',
              'wprowadzono', 'zmodyfikowano', 'zmieniony', 'modyfikujacy', 'kontrahent_opis')  #AB 2023-10-24
if UprPrzegl > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

if stat == 'OK' and Funkcja in (1, 2, 3, 4, 5, ):
    sklep_id = klucze['sklep_id']


# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH(1, 3)   ---------------------------
# -------------------------------------------------------------------------------


if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR MOD'

    if stat == 'OK':
        #WS 2019-12-17
        data_od = None
        data_do = None

        SprawdzacDaty   = True
        DataDoZmieniona = False
        UPD_stoiska = '' #WS 2019-12-17
        UPD_powiazania = '' #WS 2019-12-17

        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole == 'magazyn_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu magazynu handlowego: '+ stat  #AB 2023-10-24
                        dane.append(stat)
                    elif len(mag) == 0:
                        stat = 'Niepoprawny symbol magazynu handlowego: {}'.format(wart)  #AB 2023-10-24
                        dane.append(stat)
                else:
                    stat = 'Nie podano symbolu magazynu handlowego'  #AB 2023-10-24
                    dane.append(stat)
            #AB 2023-10-24 start
            if pole == 'magazyn_przejsciowy_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu magazynu przejciowego: '+ stat
                        dane.append(stat)
                    elif len(mag) == 0:
                        stat = 'Niepoprawny symbol magazynu przejciowego: {}'.format(wart)
                        dane.append(stat)

            if pole == 'magazyn_produkcji_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu magazynu produkcji: '+ stat
                        dane.append(stat)
                    elif len(mag) == 0:
                        stat = 'Niepoprawny symbol magazynu produkcji: {}'.format(wart)
                        dane.append(stat)

            if pole == 'magazyn_surowcow_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu magazynu surowcw: '+ stat
                        dane.append(stat)
                    elif len(mag) == 0:
                        stat = 'Niepoprawny symbol magazynu surowcw: {}'.format(wart)
                        dane.append(stat)
            #AB 2023-10-24 koniec
            if pole == 'kontrahent_id':  #AB 2023-09-29
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_kontrahenci WHERE firma_id='{}' AND kontrahent_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu kontrahenta: '+ stat
                        dane.append(stat)
                    elif len(mag) == 0:
                        stat = 'Niepoprawny symbol kontrahenta: {}'.format(wart)
                        dane.append(stat)
                # else:
                #     stat = 'Nie podano symbolu kontrahenta'
                #     dane.append(stat)

            elif pole == 'sklep_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_hd_sklepy WHERE firma_id='{}' AND sklep_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu placwki handlowej: '+ stat
                        dane.append(stat)
                    elif len(mag) == 1:
                        stat = 'Placwka handlowa o symbolu {} ju istnieje.'.format(wart)
                        dane.append(stat)
                else:
                    stat = 'Nie podano symbolu placwki handlowej.'
                    dane.append(stat)

            elif pole == 'adres_ip_wew':
                if wart != '':
                    for znak in wart:
                        if znak not in ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.'):
                            stat = 'Niepoprawny znak w wewntrznym adresie ip: {}'.format(znak)
                            dane.append(stat)
                            break


                    if stat == 'OK':
                        grupy = [int(sekcja) for sekcja in filter(len, wart.split('.'))]

                        if len(grupy) != 4:
                            stat = 'Bdny wewntrzny adres ip.'
                            dane.append(stat)

                        else:
                            for grupa in grupy:
                                if grupa > 255 or grupa < 0:
                                    stat = 'Bdny wewntrzny adres ip.'
                                    dane.append(stat)
                        if stat == 'OK':
                            wartosci[i] = '.'.join([str(grupa) for grupa in grupy])
                else:
                    stat = 'Brak wewntrznego adresu ip.'
                    dane.append(stat)

            elif pole == 'adres_ip_zew':
                if wart != '':
                    for znak in wart:
                        if znak not in ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.'):
                            stat = 'Niepoprawny znak w zewntrznym adresie ip: {}'.format(znak)
                            dane.append(stat)
                            break

                    if stat == 'OK':
                        grupy = [int(sekcja) for sekcja in filter(len, wart.split('.'))]

                        if len(grupy) != 4:
                            stat = 'Bdny zewntrzny adres ip.'
                            dane.append(stat)

                        else:
                            for grupa in grupy:
                                if grupa > 255 or grupa < 0:
                                    stat = 'Bdny zewntrzny adres ip.'
                                    dane.append(stat)
                        if stat == 'OK':
                            wartosci[i] = '.'.join([str(grupa) for grupa in grupy])
                else:
                    stat = 'Brak zewntrznego adresu ip.'
                    dane.append(stat)

            elif pole == 'czy_centrala':
                if wart:
                    SQL = "SELECT sklep_id  FROM rs_hd_sklepy WHERE firma_id='{}' AND czy_centrala;".format(self.firma_id)
                    stat, centr, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania unikalnoci centrali: ' + stat
                        dane.append(stat)
                    elif len(centr) > 0:
                        stat = 'Placwka {} jest ju central, tylko jedna placwka moe by central.'.format(centr[0][0])
                        dane.append(stat)

            #WS 2019-12-17
            elif pole == 'data_od':
                if wart not in ('', '-  -', '    -  -  ','None') and not rsglobal.SprawdzCzyToData(wart):
                    SprawdzacDaty = False
                    stat = 'Bdna data uruchomienia placwki.'
                    dane.append(stat)
                else:
                    data_od = wart

            #WS 2019-12-17
            elif pole == 'data_do':
                if wart not in ('', '-  -', '    -  -  ','None') and not rsglobal.SprawdzCzyToData(wart):
                    SprawdzacDaty = False
                    stat = 'Bdna data zamknicia placwki.'
                    dane.append(stat)
                else:
                    DataDoZmieniona = True
                    data_do = wart

            elif pole == 'adres':
                if wart.strip() == '':
                    stat = 'Nie podano adresu'
                    dane.append(stat)

        #WS 2019-12-17
        if (data_od is None or data_do is None) and SprawdzacDaty and Funkcja in (3, 4):
            SQL = "SELECT data_od, data_do FROM rs_hd_sklepy WHERE firma_id='{}' AND sklep_id='{}';".format(self.firma_id, sklep_id)
            stat, daty, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd sprawdzania dat aktywnoci placwki: '+stat
                dane.append(stat)
            elif len(daty) == 0:
                stat = 'Bd sprawdzania dat aktywnoci placwki.'
                dane.append(stat)
            else:
                data_od = daty[0][0] if data_od is None else data_od
                data_do = daty[0][1] if data_do is None else data_do

        #WS 2019-12-17
        if data_od not in ('', '-  -', '    -  -  ','None') and data_do not in ('', '-  -', '    -  -  ','None') and data_od > data_do:
            SprawdzacDaty = False
            stat = 'Data uruchomienia placwki nie moe by pniejsza ni data zamknicia.'
            dane.append(stat)

        #WS 2019-12-17
        if SprawdzacDaty:
            # sprawdzenie, czy wprowadzona data od nie jest pniejsza ni data od ktregokolwiek ze stoisk
            if data_od not in ('', '    -  -  ','None',None):
                SQL = """SELECT 1 FROM rs_hd_sklepy_stoiska
                         WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                         AND data_od<'{data_od}';"""
                SQL = SQL.format(firma_id = self.firma_id,
                                 sklep_id = sklep_id,
                                 data_od  = data_od)
                stat,sklepy_stoiska,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania dat stoisk placwki: ' + stat
                    dane.append(stat)
                elif len(sklepy_stoiska) > 0:
                    stat = 'Nie mona wprowadzi daty uruchomienia placwki {}, poniewa istnieje aktywne wczeniej, przypisane do niej stoisko.'.format(data_od)
                    dane.append(stat)

            # sprawdzenie, czy wprowadzona data do nie jest wczeniejsza ni data od lub do ktregokolwiek ze stoisk
            if data_do not in ('', '    -  -  ', 'None'):
                SQL = """SELECT 1 FROM rs_hd_sklepy_stoiska
                         WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                         AND (data_do > '{data_do}' OR data_od > '{data_do}');"""
                SQL = SQL.format(firma_id = self.firma_id,
                                 sklep_id = sklep_id,
                                 data_do  = data_do)
                stat,sklepy_stoiska,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania stoisk placwki: ' + stat
                    dane.append(stat)
                elif len(sklepy_stoiska) > 0:
                    stat = 'Nie mona wprowadzi daty zamknicia placwki {}, poniewa istnieje przypisane do niej, otwierajce lub zamykajce si po tej dacie stoisko.'.format(data_do)
                    dane.append(stat)
                else:
                    # sprawdzenie, czy wprowadzona data do nie jest wczeniejsza ni data od lub do ktregokolwiek z powiza
                    SQL = """SELECT 1 FROM rs_hd_kasy_stoiska
                             WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                             AND (data_do > '{data_do}' OR data_od > '{data_do}');"""
                    SQL = SQL.format(firma_id = self.firma_id,
                                     sklep_id = sklep_id,
                                     data_do  = data_do)
                    stat, kasy_stoiska, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania powiza stoisk z kasami: ' + stat
                        dane.append(stat)
                    elif len(kasy_stoiska) > 0:
                        stat = 'Nie mona wprowadzi daty zamknicia placwki {}, poniewa istniej otwierajce lub zamykajce si po tej dacie powizania kas z przypisanymi do niej stoiskami.'.format(data_do)
                        dane.append(stat)

            if data_do not in ('', '    -  -  ', 'None') and DataDoZmieniona:
                #WS 2019-12-17
                # wprowadzono now dat do
                # jeli istniej stoiska z pust dat do - trzeba je zamkn
                UPD_stoiska = """UPDATE rs_hd_sklepy_stoiska SET data_do='{data_do}'
                                WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                                AND data_od<='{data_do}' AND data_do IS NULL;"""
                UPD_stoiska = UPD_stoiska.format(firma_id=self.firma_id,
                                                 sklep_id=sklep_id,
                                                 data_do=data_do)

                SQL = """SELECT typ_stoiska_id,data_od FROM rs_hd_sklepy_stoiska
                         WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                         AND data_od<='{data_do}' AND data_do IS NULL;"""
                SQL = SQL.format(firma_id=self.firma_id,
                                 sklep_id=sklep_id,
                                 data_do=data_do)
                stat, sklepy_stoiska, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania dat aktywnoci stoisk: ' + stat
                    dane.append(stat)
                elif len(sklepy_stoiska) > 0:
                    for stoisko in sklepy_stoiska:
                        # jeli istniej powizania z pust dat do dla zamykanych stoisk - trzeba je rwnie zamkn
                        UPD_powiazania += """UPDATE rs_hd_kasy_stoiska SET data_do='{data_do}'
                                             WHERE firma_id='{firma_id}' AND sklep_id='{sklep_id}'
                                             AND typ_stoiska_id='{typ_stoiska_id}' AND data_od_stoiska='{data_od_stoiska}'
                                             AND data_od<='{data_do}' AND data_do IS NULL;
                                          """.format(firma_id=self.firma_id,
                                                     sklep_id=sklep_id,
                                                     typ_stoiska_id=stoisko[0],
                                                     data_od_stoiska=stoisko[1],
                                                     data_do=data_do)


    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
        #WS 2019-12-05
        elif UPD_stoiska:
            rsglobal.ZapiszDoLogow(UPD_stoiska+UPD_powiazania)
            stat, dump, dump, dump = self.PolSQL.Execute(UPD_stoiska+UPD_powiazania, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bdy zamykania stoisk/powiza: ' + stat
                dane.append(stat)

# -------------------------------------------------------------------------------
# ---------------------------   INSERT(1)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2):
    rsglobal.ZapiszDoLogow('Ibnsert')
    INSERT = "INSERT INTO rs_hd_sklepy "
    Pola = "firma_id, sklep_id, data_wprowadzenia, operator "
    Wartosci = "'" + self.firma_id + "','" + sklep_id + "', now(), rsf_getuserid() "
    for i in xrange(len(pola)):
        if pola[i] not in wylaczenia:
            Pola += "," + pola[i]
            if pola[i] in ('data_od', 'data_do', 'magazyn_przejsciowy_id', 'magazyn_produkcji_id', 'magazyn_surowcow_id'):  #AB 2023-10-24
                if (wartosci[i].strip() if isinstance(wartosci[i], basestring) else wartosci[i]) in ('', '-  -'):
                    Wartosci += ",NULL"
                else:
                    Wartosci += ",'" + str(wartosci[i])+"'"

            else:
                Wartosci += ",'" + str(wartosci[i])+"'"

    INSERT += "(" + Pola + ") VALUES (" + Wartosci + ");"

    stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1)
    if stat != 'OK':
        stat = 'Bd dodawania placwki handlowej: ' + stat
        dane.append(stat)

    if stat == 'OK':
        SQL = "SELECT typ_stoiska_id FROM rs_hd_typy_stoisk s WHERE firma_id='{}';".format(self.firma_id)
        stat, stoiska, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(SQL)
        rsglobal.ZapiszDoLogow(stoiska)

        if stat != 'OK':
            stat = "Bd sprawdzania typw stoisk: " + stat
        else:
            # Jesli istnieje tylko 1 typ stoiska, to od razu dodajemy go do placowki handlowej
            if len(stoiska) == 1:
                INS = """INSERT INTO rs_hd_sklepy_stoiska
(firma_id, sklep_id, typ_stoiska_id, data_od, data_do, magazyn_id)
SELECT firma_id, sklep_id, '{}', data_od, data_do, magazyn_id
FROM rs_hd_sklepy WHERE firma_id='{}' AND sklep_id='{}';
""".format(stoiska[0][0], self.firma_id, sklep_id)
                stat, dump, dump, dump = self.PolSQL.Execute(INS, 1)
                rsglobal.ZapiszDoLogow(INS)
                rsglobal.ZapiszDoLogow(stat)

                if stat != 'OK':
                    stat = 'Bd dodawania stoiska: ' + stat
                    dane.append(stat)

# -------------------------------------------------------------------------------
# --------------------------   UPDATE(3)   --------------------------------------
# -------------------------------------------------------------------------------


if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    rsglobal.ZapiszDoLogow('Updawte')
    UPDATE = "UPDATE rs_hd_sklepy SET data_aktualizacji=NOW(), operator=rsf_getuserid(), zmieniony=TRUE, "

    for i in range(len(pola)):
        #WS 2019-12-18
        if pola[i] not in wylaczenia:
            if pola[i] in ('data_od', 'data_do', 'magazyn_przejsciowy_id', 'magazyn_produkcji_id', 'magazyn_surowcow_id'):  #AB 2023-10-24
                if (wartosci[i].strip() if isinstance(wartosci[i], basestring) else wartosci[i]) in ('', '-  -'):
                    UPDATE += pola[i] + "=NULL,"
                else:
                    UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"
            else:
                UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"
        elif pola[i] == 'sklep_id':
            UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"
            nowe_sklep_id = wartosci[i]
        # if pola[i] not in wylaczenia:
        #     UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"
        # elif pola[i] == 'sklep_id':
        #     UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"
        #     nowe_sklep_id = wartosci[i]

    UPDATE = UPDATE[0:-1]
    UPDATE += " WHERE firma_id ='" + self.firma_id + "' AND sklep_id = '" + sklep_id + "';"

    stat, dump, dump, dump = self.PolSQL.Execute(UPDATE, 1)
    rsglobal.ZapiszDoLogow(UPDATE)
    if stat != 'OK':
        stat = 'Bdy modyfikowania danych:' + stat
        dane.append(stat)
    else:
        try:
            sklep_id=nowe_sklep_id
        except:
            pass


if len(dane) > 0:
    stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH(1, 3, 5)   ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    rsglobal.ZapiszDoLogow('selegst')
    #AB 2023-10-24
    SQL = "SELECT s.*, substring(s.data_wprowadzenia::TEXT FROM 0 FOR 20) AS wprowadzono, \n" \
          "     substring(s.data_aktualizacji::TEXT FROM 0 FOR 20) AS zmodyfikowano, \n" \
          "     s.operator || ' - ' || o.imie ||' ' ||o.nazwisko AS modyfikujacy, m.opis as magazyn_opis, \n" \
          "     m2.opis as magazyn_przejsciowy_opis, m3.opis as magazyn_produkcji_opis, \n" \
          "     m4.opis as magazyn_surowcow_opis, k.nazwa as kontrahent_opis \n" \
          "FROM rs_hd_sklepy s \n" \
          " LEFT JOIN rs_magazyny m USING(firma_id, magazyn_id)\n" \
          " LEFT JOIN rs_kontrahenci k USING(firma_id, kontrahent_id)\n" \
          " LEFT JOIN rs_magazyny m2 ON (s.firma_id, s.magazyn_przejsciowy_id) = (m2.firma_id, m2.magazyn_id) \n" \
          " LEFT JOIN rs_magazyny m3 ON (s.firma_id, s.magazyn_produkcji_id)   = (m3.firma_id, m3.magazyn_id) \n" \
          " LEFT JOIN rs_magazyny m4 ON (s.firma_id, s.magazyn_surowcow_id)    = (m4.firma_id, m4.magazyn_id) \n" \
          " LEFT JOIN rs_operatorzy o on o.operator_id = s.operator\n" \
          " WHERE s.firma_id='{}' AND sklep_id='{}';".format(self.firma_id, sklep_id)
    rsglobal.ZapiszDoLogow(SQL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(str(dane))
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'BL SQL PRZ'
