# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_hd_placowki_handlowe_dane_pcmarket.py
# Purpose:     Wyswietlanie listy numerw sklepw z PC Market oraz ich kas
# Author:      Wojciech Skowron
# Created:     2020/11/30
# RCS-ID:      $Id: fs_hd_placowki_handlowe_dane_pcmarket.py $
# Copyright:   (c) 2020 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal
import rsmssql
import traceback

stat      = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id, '091300') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
dane = []
if UprPrzegl > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH(5)         ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, ):
    try:
        self.RSPCMarketSQL = rsmssql.RSPCMarketSQL()
        stat = self.RSPCMarketSQL.Polacz()
    except:
        stat = 'Bd poczenia z PC Market: '+traceback.format_exc()

    if stat == 'OK':
        SEL = """SELECT M.Nazwa, M.MagId,
                 COALESCE(REPLACE(RTRIM((SELECT convert(varchar(5),KasaId) + ' ' 
                                         FROM Kasa K
                                         WHERE M.MagId = K.MagId
                                         ORDER BY KasaId
                                         FOR XML PATH('') )),' ', ','), '') AS Kasy
                 FROM Magazyn M
                 ORDER BY M.Nazwa;""".format(**locals())
        stat, dane, wyn1 = self.RSPCMarketSQL.Execute(SEL)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat, 1)
            stat = 'Bd pobrania danych: '+stat

    self.RSPCMarketSQL.Rozlacz()
