# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_placowki_handlowe_stoiska_dane.py
# Purpose:     przegladanie, dodwanie i modyfikacja danych stoisk przypisanych do placwki handlowej
# Author:
# Created:     2019/08/20
# RCS-ID:      $Id: fs_hd_placowki_handlowe_stoiska_dane.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
Funkcje:
3 - Edycja z pobraniem danych
5 - Pobranie danych
 """

"""
091330 Stoiska
091332 Stoiska modyfikacja
"""

stat      = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id, '091330') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod    = ((self.oddzial_id, '091332') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
dane = []
if UprPrzegl > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

if stat == 'OK' and Funkcja in (3, 4, 5, ):
    sklep_id       = klucze['sklep_id']
    typ_stoiska_id = klucze['typ_stoiska_id']
    data_od        = klucze['data_od']


# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH(3)   ---------------------------
# -------------------------------------------------------------------------------


if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR MOD'

    if stat == 'OK':
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole == 'magazyn_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, wart)
                    stat, mag, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania symbolu magazynu: '+ stat
                        dane.append(stat)
                    elif len(mag) == 0:
                        stat = 'Niepoprawny symbol magazynu: {}'.format(wart)
                        dane.append(stat)

            elif pole == 'adres':
                if wart.strip() == '':
                    stat = 'Nie podano adresu'
                    dane.append(stat)
# -------------------------------------------------------------------------------
# --------------------------   UPDATE(3)   --------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    rsglobal.ZapiszDoLogow('Updawte')
    UPDATE = "UPDATE rs_hd_sklepy_stoiska SET "

    for i in range(len(pola)):
        if pola[i] in ('magazyn',):
            if str(wartosci[i]).strip() == '':
                UPDATE += pola[i] + "=NULL,"
            else:
                UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"
        elif pola[i] not in ('magazyn_opis',):
            UPDATE += pola[i] + "='" + str(wartosci[i]) + "',"

    UPDATE = UPDATE[0:-1]
    UPDATE += " WHERE firma_id='{}' AND sklep_id='{}' AND typ_stoiska_id='{}' AND data_od='{}';".format(self.firma_id, sklep_id, typ_stoiska_id, data_od)

    stat, dump, dump, dump = self.PolSQL.Execute(UPDATE, 1)
    rsglobal.ZapiszDoLogow(UPDATE)
    if stat != 'OK':
        stat = 'Bdy modyfikowania danych:' + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH(1, 3, 5)   ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    rsglobal.ZapiszDoLogow('selegst')
    SQL = "SELECT s.*, m.opis as magazyn_opis FROM rs_hd_sklepy_stoiska s LEFT JOIN rs_magazyny m USING(firma_id, magazyn_id)" \
          " WHERE firma_id='{}' AND sklep_id='{}' AND typ_stoiska_id='{}' AND data_od='{}'" \
          ";".format(self.firma_id, sklep_id, typ_stoiska_id, data_od)
    rsglobal.ZapiszDoLogow(SQL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(str(dane))
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'BL SQL PRZ'
