# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_pos_kasy_dane.py
# Purpose:     przegladanie i edycja danych pos/kas
# Author:      Wojciech Skowron
# Created:     2019/10/10
# RCS-ID:      $Id: fs_hd_pos_kasy_dane.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2019-12-05 Wojciech Skowron - (11773) W edycji dat Kas i stoisk doda kontrol na obecne powizania kas do stoisk

"""
091510 Przegldanie
091520 Modyfikacja
"""

stat = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprMod = ((self.oddzial_id, '091520') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprPrz = ((self.oddzial_id, '091510') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

dane = []
wylaczenia = ('wprowadzono', 'zmodyfikowano', 'modyfikujacy')

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Kasa':[1,2,3,4,5]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga: wywoanie funkcji fs_hd_pos_kasy_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK' and Funkcja in (1,2,3,4,5,):
    Kasa = klucze['Kasa']

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH(1, 3)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR MOD'

    if stat == 'OK':
        data_od = None
        data_do = None
        UPD_powiazania = ''
        datyOK = True

        for pole, wart in zip(pola, wartosci):
            if pole == 'kasa_id':
                if wart is None:
                    stat = 'BR ID'
                    dane.append(stat)
                else:
                    SQL = "SELECT 1 FROM rs_hd_kasy WHERE firma_id='{}' AND kasa_id={};".format(self.firma_id, wart)
                    stat, kasa, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania numeru kasy: '+ stat
                        dane.append(stat)
                    elif len(kasa) == 1:
                        stat = "BL UNI ID${}".format(wart)
                        # stat = 'Kasa o numerze {} ju istnieje.'.format(wart)
                        dane.append(stat)

            elif pole == 'nazwa':
                if wart.strip() == '':
                    stat = 'BR NAZ'
                    dane.append(stat)

            elif pole == 'nazwa_skrocona':
                if wart.strip() == '':
                    stat = 'BR SKR'
                    dane.append(stat)

            elif pole == 'data_od':
                if wart not in ('', '    -  -  '):
                    if rsglobal.SprawdzCzyToData(wart):
                        data_od = wart
                    else:
                        datyOK = False
                        stat = 'BL DATA OD'
                        dane.append(stat)

            elif pole == 'data_do':
                if wart not in ('', '    -  -  '):
                    if rsglobal.SprawdzCzyToData(wart):
                        data_do = wart

                        # wprowadzono now dat do
                        # jeli istniej powizania z pust dat do - trzeba je zamkn
                        UPD_powiazania = """UPDATE rs_hd_kasy_stoiska SET data_do='{data_do}'
                                            WHERE firma_id='{firma_id}' AND kasa_id={kasa_id}
                                            AND data_od<='{data_do}' AND data_do IS NULL;"""
                        UPD_powiazania = UPD_powiazania.format(firma_id=self.firma_id,
                                                               kasa_id=Kasa,
                                                               data_do=data_do)
                    else:
                        datyOK = False
                        stat = 'BL DATA DO'
                        dane.append(stat)

        #WS 2019-12-05
        if (data_od is None or data_do is None) and Funkcja in (3, 4):
            SQL = "SELECT data_od, data_do FROM rs_hd_kasy WHERE firma_id='{}' AND kasa_id={};".format(self.firma_id, Kasa)
            stat, daty, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                datyOK = False
                stat = 'Bd sprawdzania dat aktywnoci kasy: ' + stat
                dane.append(stat)
            elif len(daty) == 0:
                datyOK = False
                stat = 'Bd sprawdzania dat aktywnoci kasy.'
                dane.append(stat)
            else:
                if not data_od:
                    data_od = daty[0][0] if daty[0][0] not in ('', '    -  -  ','None') else None

                if not data_do:
                    data_do = daty[0][1] if daty[0][1] not in ('', '    -  -  ','None') else None

        if data_od and data_do and datyOK:
            if data_od > data_do:
                stat = 'BL DATY'
                dane.append(stat)

        #WS 2019-12-05
        if datyOK and Funkcja in (3, 4):
            if data_od not in ('', '    -  -  ','None',None):
                # sprawdzenie, czy wprowadzona data od nie jest pniejsza ni data od ktregokolwiek z powiza
                SQL = """SELECT sklep_id, typ_stoiska_id, data_od, data_do FROM rs_hd_kasy_stoiska
                         WHERE firma_id='{firma_id}' AND kasa_id={kasa_id}
                         AND data_od < '{data_od}'
                         ORDER BY data_od DESC;"""
                SQL = SQL.format(firma_id = self.firma_id,
                                 kasa_id  = Kasa,
                                 data_od  = data_od)
                stat, kasy_stoiska, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania dat powiza ze stoiskami: ' + stat
                    dane.append(stat)
                elif len(kasy_stoiska) > 0:
                    stat = "BL DATA OD POW${}".format(data_od)
                    # stat = 'Nie mona wprowadzi daty od {}, poniewa istnieje rozpoczynajce si wczeniej powizanie ze stoiskiem.'.format(data_od)
                    dane.append(stat)

            # sprawdzenie, czy wprowadzona data do nie jest wczeniejsza ni data od lub do ktregokolwiek z powiza
            if data_do not in ('', '    -  -  ','None',None):
                SQL = """SELECT sklep_id, typ_stoiska_id, data_od, data_do FROM rs_hd_kasy_stoiska
                         WHERE firma_id='{firma_id}' AND kasa_id={kasa_id}
                         AND (data_do > '{data_do}' OR data_od > '{data_do}')
                         ORDER BY data_od DESC;"""
                SQL = SQL.format(firma_id = self.firma_id,
                                 kasa_id  = Kasa,
                                 data_do  = data_do)
                stat, kasy_stoiska, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania dat powiza ze stoiskami: ' + stat
                    dane.append(stat)
                elif len(kasy_stoiska) > 0:
                    stat = "BL DATA DO POW${}".format(data_do)
                    # stat = 'Nie mona wprowadzi daty do {}, poniewa istnieje rozpoczynajce lub koczce si po tej dacie powizanie ze stoiskiem.'.format(data_do)
                    dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
        #WS 2019-12-05
        elif UPD_powiazania:
            rsglobal.ZapiszDoLogow(UPD_powiazania)
            stat, dump, dump, dump = self.PolSQL.Execute(UPD_powiazania, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bdy zamykania powiza: ' + stat
                dane.append(stat)

# -------------------------------------------------------------------------------
# ---------------------------   INSERT(1)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2):
    INS = "INSERT INTO rs_hd_kasy "
    POLA = "firma_id, data_wprowadzenia, operator "
    WART = "'" + self.firma_id + "',now(), rsf_getuserid() "

    for pole, wart in zip(pola, wartosci):
        if pole not in wylaczenia:
            POLA += "," + pole

            if pole in ('data_od', 'data_do') and wart in ('', '    -  -  '):
                WART += ",NULL"
            elif pole == 'kasa_id':
                WART += "," + str(wart)+""
            else:
                WART += ",'" + str(wart)+"'"

    INS += "(" + POLA + ") VALUES (" + WART + ");"

    stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd dodawania kasy: ' + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# --------------------------   UPDATE(3)   --------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3, 4):
    UPD = "UPDATE rs_hd_kasy SET data_aktualizacji=NOW(), operator=rsf_getuserid(), "

    for pole, wart in zip(pola, wartosci):
        if pole not in wylaczenia:
            if pole in ('data_od', 'data_do') and wart in ('', '    -  -  '):
                UPD += pole + "=NULL,"
            else:
                UPD += pole + "='" + str(wart) + "',"

    UPD = UPD[:-1]
    UPD += " WHERE firma_id ='" + self.firma_id + "' AND kasa_id = " + str(Kasa) + ";"

    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(UPD)
    if stat != 'OK':
        stat = 'Bdy modyfikowania danych: ' + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH(1, 3, 5)   ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5):
    SEL = """SELECT k.*, 
                    substring(k.data_wprowadzenia::TEXT FROM 0 FOR 20) AS wprowadzono, 
                    substring(k.data_aktualizacji::TEXT FROM 0 FOR 20) AS zmodyfikowano, 
                    k.operator || ' - ' || o.imie ||' ' ||o.nazwisko AS modyfikujacy 
             FROM rs_hd_kasy k
             LEFT JOIN rs_operatorzy o on o.operator_id = k.operator
             WHERE firma_id='{}' AND kasa_id={};""".format(self.firma_id, Kasa)

    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SEL)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'Bd pobierania danych: ' + stat
