# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_hd_rozlicz_produkcje_w_sklepie.py
# Purpose:     funkcje rozliczenia produkcji w sklepie (np. kanapek albo kawy)
# Author:      Jan Raburski
# Created:     2023/10/24
# RCS-ID:      $Id: fs_hd_rozlicz_produkcje_w_sklepie.py $
# Copyright:   (c) 2023 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# funkcja rozliczania jest uruchamiana w harmonogramie i rcznie w module Handel. W przypadku zmian
# oba te mechanizmy musz by sprawdzone i zaktualizowane
# Funkcja = 10 - rozliczenie produkcji w dniu
#         = 11 - pobranie listy aktywnych sklepow

#def SprawdzDokumentWMagazynie(self, Magazyn, Dokument):
#    stat = 'OK'
#    import rsglobal
#    firma_id = self.firma_id

import rsglobal

def DodajDokument(self, Magazyn, MagazynDokad, Typ, Data, ListaArt, Wersja, Zlecenie, Kontrahent):
    # dodaje dokument, wpisuje pozycje
    # ListaArt = [artykul_id, ilosc1, ilosc2] moze byc rozszerzona o cena1 i cena2
    # wraca stat ('OK') i numerem dokumentu
    firma_id = self.firma_id
    TypD = "M"
    stat, test, dump, dump = self.PolSQL.Execute(
        "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('" + firma_id + "','[\\\'" + Magazyn + "\\\',\\\'" + Typ + "\\\',\\\'" + Data + "\\\']','" + TypD + "');",
        3)
    if stat != 'OK':
        return stat, 0
    else:
        if test[0][0] != 'OK':
            return test[0][0], 0

    stat, dane, dump, dump = self.PolSQL.Execute(
        "SELECT rsf_podaj_nowy_numer_dokumentu('" + firma_id + "','[\\\'" + Magazyn+ "\\\',\\\'" + Typ + "\\\',\\\'" + Data + "\\\']','" + TypD + "');",
        3)
    if dane[0][0] in (None, 'None', ''):
        return u'bdy numeracji dokumentu', 0
    else:
        NrDok = dane[0][0]

    # opracowanie zmiennych do insertow
    if Wersja == '':
        Wersja = 'NULL'
    else:
        Wersja = "'" + Wersja + "'"
    if Zlecenie == '':
        Zlecenie = 'NULL'
    else:
        Zlecenie = "'" + Zlecenie + "'"
    if Kontrahent == '':
        Kontrahent = 'NULL'
    else:
        Kontrahent = "'" + Kontrahent + "'"

    if Typ == 'M2':
        TypD = "MM"
        if MagazynDokad == '':
            return "Brak magazynu dokd", 0
        stat, test, dump, dump = self.PolSQL.Execute(
            "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('" + firma_id + "','[\\\'" + MagazynDokad + "\\\',\\\'" + Typ + "\\\',\\\'" + Data + "\\\']','" + TypD + "');",
            3)
        if stat != 'OK':
            return stat, 0
        else:
            if test[0][0] != 'OK':
                return test[0][0], 0

        stat, dane, dump, dump = self.PolSQL.Execute(
            "SELECT rsf_podaj_nowy_numer_dokumentu('" + firma_id + "','[\\\'" + MagazynDokad+ "\\\',\\\'" + Typ + "\\\',\\\'" + Data + "\\\']','" + TypD + "');",
            3)
        if dane[0][0] in (None, 'None', ''):
            return u'bdy numeracji dokumentu', 0
        else:
            NrDokDokad = dane[0][0]
        # insert naglowka dokumentu MM
        Insert = """INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id, magazyn_skad, magazyn_dokad, dokument_id,
           data, numer, numer_dokad, waluta, kontrahent_id) VALUES ('{firma_id}','{Magazyn}','{Magazyn}','{MagazynDokad}','{Typ}',
           '{Data}',{NrDok},{NrDokDokad},'PLN',{Kontrahent});""".format(**locals())
    else:
        # insert naglowka pozostalych dokumentow
        if MagazynDokad == '':  # dokument rozchodowy
            MagazynSkad = "'" + Magazyn + "'"
            MagazynDokad = 'NULL'
        else:  # dokument przychodowy
            MagazynSkad = 'NULL'
            MagazynDokad = "'" + Magazyn + "'"
        Insert = """INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id, magazyn_skad, magazyn_dokad, dokument_id,
           data, numer, wersja,nr_zlecenia, waluta, kontrahent_id) VALUES ('{firma_id}','{Magazyn}',{MagazynSkad},{MagazynDokad},'{Typ}',
           '{Data}',{NrDok},{Wersja},{Zlecenie},'PLN',{Kontrahent});""".format(**locals())

    nrpoz = 1
    for art in ListaArt:  # insert pozycji
        artykul = art[0]
        ilosc = art[1]
        ilosc2 = art[2]
        cena1 = 0
        cena2 = 0
        if Wersja != 'NULL':  # pobranie cen
            sql = "SELECT"
            sql += " rsf_podaj_cene_n1('" + self.firma_id + "','" + artykul + "'," + Wersja + ",'PLN','" + Data + "'),"
            sql += " rsf_podaj_cene_n2('" + self.firma_id + "','" + artykul + "'," + Wersja + ",'PLN','" + Data + "');"
            stat, ceny, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat == 'OK':
                cena1 = ceny[0][0]
                cena2 = ceny[0][1]
            else:
                return stat, 0
        elif len(art) > 3:  # sa ceny na liscie
            cena1 = art[3]
            cena2 = art[4]

        Insert += """INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id, dokument_id,
           data, numer, nr_poz, nr_ppoz, artykul_id, ilosc1, ilosc2, cena1, cena2, cena_wal1, cena_wal2)
           VALUES ('{firma_id}','{Magazyn}', '{Typ}', '{Data}',{NrDok},{nrpoz},0,'{artykul}',{ilosc},{ilosc2},
           {cena1}, {cena2}, {cena1}, {cena2});""".format(**locals())
        nrpoz += 1

    stat, dump, dump, dump = self.PolSQL.Execute(Insert, 1, CzyDodawacBlad=True)

    return stat, NrDok



#-------------------------------------------------------------
# glowny algorytm
#-------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Sklep':[10], 'Data':[10,11] }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat='Uwaga : wywoanie funkcji fs_hd_rozlicz_produkcje_w_sklepie '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [10]:
        Sklep = rsglobal.Dekoduj(klucze['Sklep'])
        Data = rsglobal.Dekoduj(klucze['Data'])
    elif Funkcja in [11]:
        Data = rsglobal.Dekoduj(klucze['Data'])
    else:
        stat = 'Nieprawidowy numer funkcji.'

firma_id = self.firma_id

#-------------------------------------------------------------------------------
#---------- ROZLICZENIE PRODUKCJI< INSERT WYMAGANYCH DOKUMENTOW
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    # sprawdzenie czy sa wypelnione magazyny w sklepie
    sql = """SELECT COALESCE(magazyn_id,''), COALESCE(magazyn_produkcji_id,''),
        COALESCE(magazyn_surowcow_id,''), COALESCE(magazyn_przejsciowy_id,''),
        COALESCE(kontrahent_id,'')
        FROM rs_hd_sklepy 
        WHERE firma_id='{firma_id}' AND sklep_id='{Sklep}' ;""".format(**locals())
    stat, spr, wyn1, dump = self.PolSQL.Execute(sql, 3)

    if stat != 'OK':
        stat = u'Bdy pobrania listy magazynw dla sklepu: ' + stat
    elif len(spr) == 0:
        stat = u'Niepoprawny indeks sklepu '
    else:
        MagHandlowy = spr[0][0].strip()
        MagProdukcji = spr[0][1].strip()
        MagSurowcow = spr[0][2].strip()
        MagPrzejsciowy = spr[0][3].strip()
        Kontrahent = spr[0][4].strip()
        if MagHandlowy == '' or MagProdukcji == '' or MagSurowcow == '' or MagPrzejsciowy == '':
            stat = u'Brak zdefiniowanych magazynw dla sklepu.'
        if Kontrahent == '':
            stat = u'Brak zdefiniowanego kontrahenta dla sklepu.'

    # sprawdzenie czy wszystkie dokumenty sa zdefiniowane
    if stat == 'OK':
        sql = """SELECT dokument_id, typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='{firma_id}'
           AND dokument_id IN ('WZ','PW','PM','RM','RW','M2','PI');""".format(**locals())
        stat, typydokumentow, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania listy dokumentw: ' + stat
        elif len(typydokumentow) != 7:
            stat = u'Brak definicji jednego z dokumentw (WZ,PW,PM,RM,RW,M2,PI).'

    # sprawdzenie czy sa niezamkniete dokumenty
    if stat == 'OK':
        sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
           AND stan NOT IN ('Z','K') AND magazyn_id='{MagHandlowy}' AND data<='{Data}';""".format(**locals())
        stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania liczby dokumentw magazynu handlowego: ' + stat
        elif czywz[0][0] > 0:
            stat = u'Magazyn handlowy ('+MagHandlowy+'). Liczba niezamknitych dokumentw: ' + str(int(czywz[0][0])) +'.'
    if stat == 'OK':
        sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
           AND stan NOT IN ('Z','K') AND magazyn_id='{MagProdukcji}' AND data<='{Data}';""".format(**locals())
        stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania liczby dokumentw magazynu produkcji: ' + stat
        elif czywz[0][0] > 0:
            stat = u'Magazyn produkcji ('+MagProdukcji+'). Liczba niezamknitych dokumentw: ' + str(int(czywz[0][0])) +'.'
    if stat == 'OK':
        sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
           AND stan NOT IN ('Z','K') AND magazyn_id='{MagSurowcow}' AND data<='{Data}';""".format(**locals())
        stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania liczby dokumentw magazynu surowcw: ' + stat
        elif czywz[0][0] > 0:
            stat = u'Magazyn surowcw ('+MagSurowcow+'). Liczba niezamknitych dokumentw: ' + str(int(czywz[0][0])) +'.'

    # sprawdzenie czy sa zamkniete dokumenty
    #if stat == 'OK':
    #    sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
    #       AND stan NOT IN ('W','G') AND magazyn_id='{MagHandlowy}' AND data>'{Data}';""".format(**locals())
    #    stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    #    if stat != 'OK':
    #        stat = u'Bdy pobrania liczby dokumentw magazynu handlowego: ' + stat
    #    elif czywz[0][0] > 0:
    #        stat = u'Magazyn handlowy ('+MagHandlowy+'). Liczba zamknitych dokumentw: ' + str(int(czywz[0][0])) +'.'
    #if stat == 'OK':
    #    sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
    #       AND stan NOT IN ('W','G') AND magazyn_id='{MagProdukcji}' AND data>'{Data}';""".format(**locals())
    #    stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    #    if stat != 'OK':
    #        stat = u'Bdy pobrania liczby dokumentw magazynu produkcji: ' + stat
    #    elif czywz[0][0] > 0:
    #        stat = u'Magazyn produkcji ('+MagProdukcji+'). Liczba zamknitych dokumentw: ' + str(int(czywz[0][0])) +'.'
    #if stat == 'OK':
    #    sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
    #       AND stan NOT IN ('W','G') AND magazyn_id='{MagSurowcow}' AND data>'{Data}';""".format(**locals())
    #    stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    #    if stat != 'OK':
    #        stat = u'Bdy pobrania liczby dokumentw magazynu surowcw: ' + stat
    #    elif czywz[0][0] > 0:
    #        stat = u'Magazyn surowcw ('+MagSurowcow+'). Liczba zamknitych dokumentw: ' + str(int(czywz[0][0])) +'.'

    # sprawdzenie czy jest zapisana sprzedaz
    if stat == 'OK':
        sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
           AND dokument_id='WZ' AND magazyn_id='{MagHandlowy}' AND data='{Data}';""".format(**locals())
        stat, czywz, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania liczby dokumentw WZ: ' + stat
        elif czywz[0][0] == 0:
            stat = u'Brak zarejestrowanej sprzeday w magazynie '+MagHandlowy+' w dniu '+str(Data)+'.'

    # pobranie listy i ilosci artykulow do rozliczenia
    if stat == 'OK':
        sql = """SELECT artykul_id, SUM(ilosc1), SUM(ilosc2) FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='{firma_id}' 
           AND ((dokument_id='WZ' AND magazyn_id='{MagHandlowy}') OR (dokument_id='RW' AND magazyn_id='{MagProdukcji}')) AND data='{Data}'
           AND artykul_id IN (SELECT artykul_id FROM rs_artykuly WHERE firma_id ='{firma_id}' AND rozliczac_produkcje AND aktywny)
           GROUP BY artykul_id ORDER BY artykul_id;""".format(**locals())
        stat, artdorozliczenia, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania produktw do rozliczenia: ' + stat
        elif len(artdorozliczenia) == 0:
            stat = u'Brak produktw dla ktrych trzeba utworzy rozliczenie produkcji. '

    # sprawdzenie czy nie ma juz rozliczenia produkcji
    if stat == 'OK':
        sql = """SELECT count(*) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
           AND dokument_id='PW' AND magazyn_id='{MagProdukcji}' AND data='{Data}';""".format(**locals())
        stat, czypw, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania liczby dokumentw PW: ' + stat
        elif czypw[0][0] > 0:
            stat = u'W sklepie bya ju rozliczana produkcja.'

    # utworzenie dokumentu PW
    if stat == 'OK':
        # dodaje dokument, wpisuje pozycje
        # wraca stat ('OK') i numerem dokumentu
        stat, NrDok =  DodajDokument(self, MagProdukcji, MagProdukcji, 'PW', Data, artdorozliczenia, '01','00','!05')
        if stat == 'OK':
            dane.append(['Utworzono dokument: '+MagProdukcji+'/PW/'+str(Data)+'/'+str(int(NrDok))+'.'])
    Klucze = {}
    # zamkniecie dokumentu PW z auto tworzeniem RW
    if stat == 'OK':
        Klucze['Mag'] = MagProdukcji
        Klucze['Typ'] = 'PW'
        Klucze['Data'] = Data
        Klucze['Numer'] = NrDok
        Klucze['Funkcja'] = 18
        # zamknicie dokumentu przychodowego z W na G
        self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
        stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
        if stat == 'OK':
            # zamknicie dokumentu przychodowego z G na Z
            Klucze['Funkcja'] = 19
            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
        self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
        if stat != 'OK':
            stat = MagProdukcji+'/PW/'+str(Data)+'/'+str(int(NrDok))+'-' + stat

    # pobranie numeru RW
    if stat == 'OK':
        sql = """SELECT max(numer) FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
           AND dokument_id='RW' AND magazyn_id='{MagSurowcow}' AND data='{Data}';""".format(**locals())
        stat, nrrw, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania numeru RW: ' + stat
        elif nrrw[0][0] == 0:
            stat = u'Brak RW w magazynie surowcw.'
        else:
            NrDok = nrrw[0][0]
            dane.append(['Utworzono dokument: '+MagSurowcow+'/RW/'+str(Data)+'/'+str(int(NrDok))+'.'])
        if stat == 'OK':  # sprawdzenie czy RW zamkniete
            sql = """SELECT stan FROM rs_dokumenty_magazynowe WHERE firma_id='{firma_id}'
               AND dokument_id='RW' AND magazyn_id='{MagSurowcow}' AND data='{Data}' AND numer={NrDok};""".format(**locals())
            stat, stan, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u'Bdy pobrania stamu RW: ' + stat
            elif stan[0][0] != 'Z':
                stat = u'Niezamknite RW w magazynie surowcw.'
            else:
                pass

    # pobranie z RW artykulow do przeniesienia z handlowego do surowcow
    if stat == 'OK':
        zamien = """rsf_hd_artykuly_zamiana_wstecz('{firma_id}', artykul_id, '{Sklep}', '{Data}', True)""".format(**locals())

        sql = """SELECT {zamien} as "artykul_id_z", SUM(ilosc1), SUM(ilosc2) FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='{firma_id}' 
           AND dokument_id='RW' AND magazyn_id='{MagSurowcow}' AND data='{Data}' AND numer={NrDok}
           AND {zamien} != artykul_id
           GROUP BY artykul_id_z, artykul_id ORDER BY artykul_id;""".format(**locals())
        stat, artdoprzeniesienia, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania artykuw do przeniesienia: ' + stat

    # utworzenie dokumentu RM w magazynie handlowym jesli trzeba
    if stat == 'OK':
        NrDok = 0
        if len(artdoprzeniesienia) > 0:
            stat, NrDok = DodajDokument(self, MagHandlowy, '', 'RM', Data, artdoprzeniesienia, '', '', Kontrahent)
            if stat == 'OK':
                dane.append(['Utworzono dokument: ' + MagHandlowy + '/RM/' + str(Data) + '/' + str(int(NrDok)) + '.'])
                Klucze = {}
                # zamkniecie dokumentu RM
                Klucze['Mag'] = MagHandlowy
                Klucze['Typ'] = 'RM'
                Klucze['Data'] = Data
                Klucze['Numer'] = NrDok
                Klucze['Funkcja'] = 18
                # zamknicie dokumentu rozchodowego z W na Z
                self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
                if stat != 'OK':
                    stat = MagHandlowy + '/RM/' + str(Data) + '/' + str(int(NrDok))+'-' + stat

    if stat == 'OK':
        if NrDok > 0:  # jest RM tworzymy PM w magazynie surowcow
            zamien = """rsf_hd_artykuly_zamiana('{firma_id}', artykul_id, '{Sklep}', '{Data}', True)""".format(**locals())

            sql = """SELECT {zamien} as "artykul_id", SUM(ilosc1), SUM(ilosc2), cena1, cena2 FROM rs_dokumenty_magazynowe_pozycje 
               WHERE firma_id='{firma_id}' AND dokument_id='RM' AND magazyn_id='{MagHandlowy}' AND data='{Data}' AND numer={NrDok}
               GROUP BY artykul_id, cena1, cena2 ORDER BY artykul_id;""".format(**locals())
            stat, artdoprzeniesienia, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u'Bdy pobrania artykuw do przeniesienia: ' + stat
            else:
                stat, NrDok = DodajDokument(self, MagSurowcow, MagSurowcow, 'PM', Data, artdoprzeniesienia, '', '', Kontrahent)
                if stat == 'OK':
                    dane.append(['Utworzono dokument: ' + MagSurowcow + '/PM/' + str(Data) + '/' + str(int(NrDok)) + '.'])
                    Klucze = {}
                    Klucze['Mag'] = MagSurowcow
                    Klucze['Typ'] = 'PM'
                    Klucze['Data'] = Data
                    Klucze['Numer'] = NrDok
                    Klucze['Funkcja'] = 18
                    # zamknicie dokumentu przychodowego z W na G
                    self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
                    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                    if stat == 'OK':
                        # zamknicie dokumentu przychodowego z G na Z
                        Klucze['Funkcja'] = 19
                        stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                    self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
                    if stat != 'OK':
                        stat = MagSurowcow + '/PM/' + str(Data) + '/' + str(int(NrDok))+'-' + stat

    # przesuniecie produkcji do magazynu handlowego przez przejsciowy
    if stat == 'OK':
        sql = """SELECT artykul_id, SUM(ilosc1), SUM(ilosc2) FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='{firma_id}' 
           AND dokument_id='WZ' AND magazyn_id='{MagHandlowy}' AND data='{Data}'
           AND artykul_id IN (SELECT artykul_id FROM rs_artykuly WHERE firma_id ='{firma_id}' AND rozliczac_produkcje AND aktywny)
           GROUP BY artykul_id ORDER BY artykul_id;""".format(**locals())
        stat, artdoprzeniesienia, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania produktw do przeniesienia z produkcji do handlu ' + stat
        elif len(artdoprzeniesienia) > 0:
            stat, NrDok = DodajDokument(self, MagProdukcji, MagPrzejsciowy, 'M2', Data, artdoprzeniesienia, '', '', '')
            if stat == 'OK':
                dane.append(['Utworzono dokument: ' + MagProdukcji + '/M2/' + str(Data) + '/' + str(int(NrDok)) + '.'])
                Klucze = {}
                Klucze['Mag'] = MagProdukcji
                Klucze['Typ'] = 'M2'
                Klucze['Data'] = Data
                Klucze['Numer'] = NrDok
                Klucze['Funkcja'] = 18
                # zamknicie dokumentu przychodowego z W na G
                self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                if stat == 'OK':
                    # zamknicie dokumentu przychodowego z G na Z
                    Klucze['Funkcja'] = 19
                    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
                if stat != 'OK':
                    stat = MagProdukcji + '/M2/' + str(Data) + '/' + str(int(NrDok)) + '-' + stat
            if stat == 'OK':
                stat, NrDok = DodajDokument(self, MagPrzejsciowy, MagHandlowy, 'M2', Data, artdoprzeniesienia, '', '', '')
                if stat == 'OK':
                    dane.append(['Utworzono dokument: ' + MagPrzejsciowy + '/M2/' + str(Data) + '/' + str(int(NrDok)) + '.'])
                    Klucze = {}
                    Klucze['Mag'] = MagPrzejsciowy
                    Klucze['Typ'] = 'M2'
                    Klucze['Data'] = Data
                    Klucze['Numer'] = NrDok
                    Klucze['Funkcja'] = 18
                    # zamknicie dokumentu przychodowego z W na G
                    self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
                    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                    if stat == 'OK':
                        # zamknicie dokumentu przychodowego z G na Z
                        Klucze['Funkcja'] = 19
                        stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                    self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
                    if stat != 'OK':
                        stat = MagPrzejsciowy + '/M2/' + str(Data) + '/' + str(int(NrDok)) + '-' + stat

    # usuniecie ilosci ujemnych w magazynie surowcow
    #if stat == 'OK':
    #    sql = """SELECT count(*) FROM rs_artykuly_magazyny WHERE firma_id='{firma_id}'
    #       AND magazyn_id='{MagSurowcow}'
    #       AND ilosc1 < 0;""".format(**locals())
    #    stat, czyujemne, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    #    if stat != 'OK':
    #        stat = u'Bdy sprawdzania iloci ujemnych ' + stat
    #    elif czyujemne[0][0] > 0:
    #        stat, NrDok = DodajDokument(self, MagSurowcow, MagSurowcow, 'PI', Data, [], '', '', '!05')
    #        if stat == 'OK':
    #            dane.append(['Utworzono dokument: ' + MagSurowcow + '/PI/' + str(Data) + '/' + str(int(NrDok)) + '.'])
    #            # pobranie ilosci ujemnych na dokument
    #            klucze = [MagSurowcow,'PI',Data,NrDok,'','','','','','','','','','',11]
    #            self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
    #            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe_pozycje", klucze, [], [], False)
    #            self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
    #            if stat == 'OK':
    #                KLucze = {}
    #                Klucze['Mag'] = MagSurowcow
    #                Klucze['Typ'] = 'PI'
    #                Klucze['Data'] = Data
    #                Klucze['Numer'] = NrDok
    #                Klucze['Funkcja'] = 18
    #                # zamknicie dokumentu przychodowego z W na G
    #                self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
    #                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
    #                if stat == 'OK':
    #                    # zamknicie dokumentu przychodowego z G na Z
    #                    Klucze['Funkcja'] = 19
    #                    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
    #                self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
    #                if stat != 'OK':
    #                    stat = MagSurowcow + '/PI/' + str(Data) + '/' + str(int(NrDok)) + '-' + stat

    # pobranie magazynie handlowym artykulow do przeniesienia z handlowego do surowcow
    if stat == 'OK':
        sql = """SELECT artykul_id, am.ilosc1, am.ilosc2 FROM rs_artykuly_magazyny am
           INNER JOIN rs_artykuly a USING(firma_id,artykul_id)
           WHERE am.firma_id='{firma_id}' AND am.magazyn_id='{MagHandlowy}'
           AND am.ilosc1>0 AND a.na_magazyn_surowcow ORDER BY am.artykul_id;""".format(**locals())
        stat, artdoprzeniesienia, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u'Bdy pobrania artykuw do przeniesienia: ' + stat

    # utworzenie dokumentu RM w magazynie handlowym jesli trzeba
    if stat == 'OK':
        NrDok = 0
        if len(artdoprzeniesienia) > 0:
            stat, NrDok = DodajDokument(self, MagHandlowy, '', 'RM', Data, artdoprzeniesienia, '', '', Kontrahent)
            if stat == 'OK':
                dane.append(['Utworzono dokument: ' + MagHandlowy + '/RM/' + str(Data) + '/' + str(int(NrDok)) + '.'])
                Klucze = {}
                # zamkniecie dokumentu RM
                Klucze['Mag'] = MagHandlowy
                Klucze['Typ'] = 'RM'
                Klucze['Data'] = Data
                Klucze['Numer'] = NrDok
                Klucze['Funkcja'] = 18
                # zamknicie dokumentu rozchodowego z W na Z
                self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
                if stat != 'OK':
                    stat = MagHandlowy + '/RM/' + str(Data) + '/' + str(int(NrDok))+'-' + stat

    if stat == 'OK':
        if NrDok > 0:  # jest RM tworzymy PM w magazynie surowcow
            sql = """SELECT artykul_id, SUM(ilosc1), SUM(ilosc2), cena1, cena2 FROM rs_dokumenty_magazynowe_pozycje 
               WHERE firma_id='{firma_id}' AND dokument_id='RM' AND magazyn_id='{MagHandlowy}' AND data='{Data}' AND numer={NrDok}
               GROUP BY artykul_id, cena1, cena2 ORDER BY artykul_id;""".format(**locals())
            stat, artdoprzeniesienia, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u'Bdy pobrania artykuw do przeniesienia: ' + stat
            else:
                stat, NrDok = DodajDokument(self, MagSurowcow, MagSurowcow, 'PM', Data, artdoprzeniesienia, '', '', Kontrahent)
                if stat == 'OK':
                    dane.append(['Utworzono dokument: ' + MagSurowcow + '/PM/' + str(Data) + '/' + str(int(NrDok)) + '.'])
                    Klucze = {}
                    Klucze['Mag'] = MagSurowcow
                    Klucze['Typ'] = 'PM'
                    Klucze['Data'] = Data
                    Klucze['Numer'] = NrDok
                    Klucze['Funkcja'] = 18
                    # zamknicie dokumentu przychodowego z W na G
                    self.PolSQL.CzyCommitRollback = False  # !!!!!!!!!!!!!!!!!!!!
                    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                    if stat == 'OK':
                        # zamknicie dokumentu przychodowego z G na Z
                        Klucze['Funkcja'] = 19
                        stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
                    self.PolSQL.CzyCommitRollback = True  # !!!!!!!!!!!!!!!!!!!!
                    if stat != 'OK':
                        stat = MagSurowcow + '/PM/' + str(Data) + '/' + str(int(NrDok))+'-' + stat

    if stat != 'OK':
        self.PolSQL.Rollback()
    #else:  # zaslepka coby dalej nie szlo i nie commitowalo ;)
    #    stat = 'Jak dotd wszystko w porzdku.'



#-------------------------------------------------------------------------------
#---------- POBRANIE LISTY WSZYSTKICH AKTYWNYCH SKLEPOW
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    # sprawdzenie czy sa wypelnione magazyny w sklepie i czy sklep czynny
    sql = """SELECT sklep_id, COALESCE(nazwa,'brak')
        FROM rs_hd_sklepy
        WHERE TRIM(magazyn_id) != '' AND TRIM(magazyn_produkcji_id) != '' AND TRIM(magazyn_surowcow_id) != '' AND TRIM(magazyn_przejsciowy_id) != ''
        AND firma_id='{firma_id}'  AND COALESCE(data_do,'2300-01-01')>='{Data}' ORDER BY sklep_id ;""".format(**locals())
    stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)

    if stat != 'OK':
        stat = u'Bdy pobrania listy placwek: ' + stat
    elif len(dane) == 0:
        stat = u'Brak placwek do rozliczanie produkcji.'

