# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_hd_tworzenie_wz_z_paragonow_pom.py
# Purpose:     wczytuje dane rotacji opakowa
# Author:      Aleksander Bargie
# Created:     2020/02/25
# RCS-ID:      $Id: fs_hd_tworzenie_wz_z_paragonow_pom.py $
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# Funkcje:UtworzWZZParagonow(self, data, sklep_id) - tworzy WZ z paragonw w podanym sklepie na wskazany dzie, self
#                                                    musi zawiera atrybuty firma_id oraz PolSQL

# 2020-04-14 Wojciech Skowron - (11928) Zmiany w tworzeniu WZ z paragonw w handlu
# 2020-07-14 Wojciech Skowron - (12048) Kontrahent = grupa towarowa
# 2023-04-26 Wojciech Skowron - (13394) Tworzenie ZP
# 2023-06-02 Wojciech Skowron - (13456) Poprawki - w ZP uzupeniany magazyn_dokad nie skad, wpisanie cen wal
# 2023-10-13 Jan Raburski     - (13580) Zmiana - w tworzeniu WZ uzwgledniac rs_hd_sklepy_artykuly_zamiana

def UtworzWZZParagonow(self, data, sklep_id):
    stat = 'OK'
    import rsglobal
    firma_id = self.firma_id
    puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')

    # Sprawdzenie czy zdefiniowany dokument przychodowy jest typu 'W' 
    SQL = "SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='{firma_id}' and dokument_id='WZ';".format(**locals())
    rsglobal.ZapiszDoLogow(SQL)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        kom = u'Bd pobierania typu dokumentu WZ.'
        rsglobal.ZapiszDoLogow(kom)
        return kom
    if len(dane) == 0:
        kom = u'Brak definicji dokumentu WZ.'
        rsglobal.ZapiszDoLogow(kom)
        return kom
    if dane[0][0] != 'W':
        kom = u'Dokument WZ nie jest rozchodowym dokumentem magazynowym.'
        rsglobal.ZapiszDoLogow(kom)
        return kom

    #WS 2020-04-14 - pocztek zmian, poprzednia wersja bez grup towarowych zakomentowana na dole

    # Pobranie magazynu przypisanego do sklepu
    SQLMAG = """SELECT magazyn_id FROM rs_hd_sklepy 
                WHERE firma_id ='{firma_id}' AND sklep_id='{sklep_id}';""".format(**locals())
    rsglobal.ZapiszDoLogow(SQLMAG)
    stat, danemagazyn, dump, dump = self.PolSQL.Execute(SQLMAG, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        return u'{sklep_id}: Bd pobrania magazynu przypisanego do sklepu.'.format(**locals())

    magazyn_id = danemagazyn[0][0]

    if magazyn_id in puste:
        return "{sklep_id}: Sklep nie posiada przypisanego magazynu.".format(**locals())

    # PODZIAL NA 2 ZAPYTANIA PONIEWAZ NIE MOZNA BLOKOWAC GDY UZYWA SIE 'GROUP BY'
    filtr  = "WHERE p.firma_id ='{firma_id}' AND data_tworzenia_wz IS NULL AND sklep_id='{sklep_id}' " \
             "AND czas::DATE = '{data}'".format(**locals())
    zamien = """TRIM(rsf_hd_artykuly_zamiana('{firma_id}', pp.artykul_id, '{sklep_id}', '{data}', False))""".format(**locals())
    LOCK = """SELECT  paragon_id
              FROM rs_hd_paragony p
              {filtr}
              FOR UPDATE NOWAIT;
              """.format(**locals())
    rsglobal.ZapiszDoLogow(LOCK)
    stat, dump, dump, dump = self.PolSQL.Execute(LOCK, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        return u'{sklep_id}: Bd nakadania blokady na paragony.'.format(**locals())

    # Pobranie sum ilosci sprzedanych artykulow z paragonow, grupowane wg grup towarowych
    # kolumny: 0 - grupa_towarowa, 1 - artykul_id, 2 - ilosc, 3 - ilosc2, 4 - znak_ilosci
    # zmieniajac kolejnosc kolumn trzeba bedzie zmienic dalsza czesc kodu
    #JR 2023-10-13 - pogrupowanie po znaku sumy iloci
    SQLWYD = """SELECT grupa_towarowa, artykul_id, ABS(ilosc) AS ilosc, ABS(ilosc2) AS ilosc2,
                CASE WHEN zap.ilosc >= 0 THEN 1 ELSE -1 END AS znak_ilosci
                FROM (SELECT a.grupa_towarowa, {zamien} as "artykul_id", 
                             SUM(pp.ilosc) as ilosc,
                             ROUND(sum(pp.ilosc) * a.przelicznik, 4) AS ilosc2
                      FROM rs_hd_paragony p
                      JOIN rs_hd_paragony_pozycje pp USING (paragon_id)
                      JOIN rs_artykuly a ON (p.firma_id=a.firma_id AND  {zamien}=a.artykul_id)
                      {filtr} AND pp.typ ='1'
                      GROUP BY a.grupa_towarowa, {zamien}, a.przelicznik) AS zap
                ORDER BY grupa_towarowa, artykul_id;""".format(**locals())
    #WS 2023-04-26 - pogrupowanie po znaku sumy iloci
    #SQLWYD = """SELECT grupa_towarowa, artykul_id, ABS(ilosc) AS ilosc, ABS(ilosc2) AS ilosc2,
    #            CASE WHEN zap.ilosc >= 0 THEN 1 ELSE -1 END AS znak_ilosci
    #            FROM (SELECT a.grupa_towarowa, pp.artykul_id,
    #                         SUM(pp.ilosc) as ilosc,
    #                         ROUND(sum(pp.ilosc) * a.przelicznik, 4) AS ilosc2
    #                  FROM rs_hd_paragony p
    #                  JOIN rs_hd_paragony_pozycje pp USING (paragon_id)
    #                  JOIN rs_artykuly a ON (p.firma_id=a.firma_id AND  pp.artykul_id=a.artykul_id)
    #                  {filtr} AND pp.typ ='1'
    #                  GROUP BY a.grupa_towarowa, pp.artykul_id, a.przelicznik) AS zap
    #            ORDER BY grupa_towarowa, artykul_id;""".format(**locals())
    # SQLWYD = """SELECT a.grupa_towarowa, pp.artykul_id, SUM(pp.ilosc) as ilosc,
    #                    ROUND(sum(pp.ilosc) * a.przelicznik, 4) AS ilosc2
    #             FROM rs_hd_paragony p
    #             JOIN rs_hd_paragony_pozycje pp USING (paragon_id)
    #             JOIN rs_artykuly a ON (p.firma_id=a.firma_id AND  pp.artykul_id=a.artykul_id)
    #             {filtr} AND pp.typ ='1'
    #             GROUP BY a.grupa_towarowa, pp.artykul_id, a.przelicznik
    #             ORDER BY a.grupa_towarowa, pp.artykul_id;""".format(**locals())
    rsglobal.ZapiszDoLogow("SQLWYD"+SQLWYD)
    stat, daneparagony, dump, dump = self.PolSQL.Execute(SQLWYD, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        return u'{sklep_id}: Bd pobierania pozycji paragonw.'.format(**locals())
    if len(daneparagony) < 1:
        return "OK"
    rsglobal.ZapiszDoLogow("SQLWYD"+str(daneparagony))
    #return "OK"

    numer = 0
    nr_poz = 0
    dokument_id = 'WZ'
    grupa_towarowa_poprz = None
    znak_ilosci_poprz = None

    danezwroty = []  #WS 2023-04-26

    for wiersz in daneparagony:
        # -----------------
        # NAGWEK
        # -----------------

        grupa_towarowa = wiersz[0]
        znak_ilosci = wiersz[4]

        #WS 2023-04-26
        if znak_ilosci > 0:
            dokument_id = 'WZ'
        else:
            dokument_id = 'ZP'

        # Dla kadej grupy towarowej tworzymy osobny dokument
        # grupa_towarowa - grupa w aktualnym wierszu
        # grupa_towarowa_poprz - grupa z poprzedniego wiersza
        #WS 2023-04-26
        if grupa_towarowa != grupa_towarowa_poprz or znak_ilosci != znak_ilosci_poprz:
        # if grupa_towarowa != grupa_towarowa_poprz:
            nr_poz = 0  # Nowy dokument, wic resetujemy numer pozycji
            grupa_towarowa_poprz = grupa_towarowa
            znak_ilosci_poprz = znak_ilosci  #WS 2023-04-26

            SQLNUMSPRW = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('{firma_id}'," \
                         "'[''{magazyn_id}'',''WZ'',''{data}'']','M');".format(**locals())
            rsglobal.ZapiszDoLogow(SQLNUMSPRW)
            stat, danenumsprw, dump, dump = self.PolSQL.Execute(SQLNUMSPRW, 3, CzyDodawacBlad=True)
            if danenumsprw[0][0] != 'OK':
                return "{sklep_id}: Ze wzgldu na numeracj nie mona doda dokumentu magazynowego WZ w " \
                       "magazynie {magazyn_id} na {data}.".format(**locals())

            SQLNUMW = "SELECT rsf_podaj_nowy_numer_dokumentu('{firma_id}'," \
                      "'[''{magazyn_id}'',''WZ'',''{data}'']','M');".format(**locals())
            rsglobal.ZapiszDoLogow(SQLNUMW)
            stat, danenumw, dump, dump = self.PolSQL.Execute(SQLNUMW, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                return "{sklep_id}: Bd wyznaczania numeru dokumentu magazynowego WZ w " \
                       "magazynie {magazyn_id} na {data} : {stat}".format(**locals())

            #WS 2020-07-14 - kontrahent = grupa towarowa
            kontrahent_id = grupa_towarowa.strip() if grupa_towarowa.strip() not in ('None', '') else '!20'

            # Sprawdzenie, czy kontrahent o symbolu grupy towarowej istnieje
            SQLKONTRAHSPR = "SELECT kontrahent_id FROM rs_kontrahenci " \
                            "WHERE firma_id='{firma_id}' AND kontrahent_id='{kontrahent_id}';".format(**locals())
            rsglobal.ZapiszDoLogow(SQLKONTRAHSPR)
            stat, danekontrahspr, dump, dump = self.PolSQL.Execute(SQLKONTRAHSPR, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                return "{sklep_id}: Bd pobrania danych z rs_kontrahenci : {stat}".format(**locals())
            elif len(danekontrahspr) == 0:
                return "{sklep_id}: Nie istnieje kontrahent " \
                       "o symbolu grupy towarowej '{kontrahent_id}'.".format(**locals())
        
            numer = danenumw[0][0]

            #WS 2023-06-02
            pole_magazyn = ''
            if dokument_id == 'WZ':
                pole_magazyn = 'magazyn_skad'
            elif dokument_id == 'ZP':
                pole_magazyn = 'magazyn_dokad'
        
            # Dodanie naglowka dokumentu rozchodowego
            #WS 2020-07-14 - kontrahent_id
            SQLINSW = """INSERT INTO rs_dokumenty_magazynowe
                                         (firma_id,    magazyn_id,    dokument_id,    data,   numer,  {pole_magazyn}, kontrahent_id)
                                VALUES ('{firma_id}','{magazyn_id}','{dokument_id}','{data}',{numer},'{magazyn_id}','{kontrahent_id}');
                                """.format(**locals())
        
            rsglobal.ZapiszDoLogow(SQLINSW)
            stat, dump, dump, dump = self.PolSQL.Execute(SQLINSW, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                return "{sklep_id}: Bad dodawania dokumentu magazynowego {dokument_id} w " \
                       "magazynie {magazyn_id} na {data} o numerze {numer} : {stat}".format(**locals())

        # -----------------
        # POZYCJE
        # -----------------

        nr_poz += 1
        artykul_id = wiersz[1]
        ilosc      = wiersz[2]
        ilosc2     = wiersz[3]
        cena1      = 0
        cena2      = 0

        #WS 2023-04-26
        if dokument_id == 'ZP':
            SQLSELCENY = """SELECT ost_cena1, ost_cena2
                            FROM rs_artykuly_magazyny
                            WHERE firma_id='{firma_id}' AND magazyn_id='{magazyn_id}' AND artykul_id='{artykul_id}';""".format(**locals())
            rsglobal.ZapiszDoLogow(SQLSELCENY)
            stat, daneselceny, dump, dump = self.PolSQL.Execute(SQLSELCENY, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                return "{sklep_id}: Bad pobrania cen dla pozycji dokumentu magazynowego {dokument_id} w " \
                                   "magazynie {magazyn_id} na {data} o numerze {numer} dla artykuu {artykul_id} : {stat}.".format(**locals())
            elif len(daneselceny) > 0:
                cena1 = daneselceny[0][0]
                cena2 = daneselceny[0][1]

        # Dodanie pozycji dokumentu rozchodowego  #WS 2023-06-02 - ceny wal
        SQLINSPOZW = """INSERT INTO rs_dokumenty_magazynowe_pozycje
                                 (firma_id,    magazyn_id,    dokument_id,    data,   numer,  nr_poz,  nr_ppoz,
                                  artykul_id,    ilosc1,  ilosc2,   cena1,   cena2, cena_wal1, cena_wal2)
                        VALUES ('{firma_id}','{magazyn_id}','{dokument_id}','{data}',{numer}, {nr_poz},     0,
                                '{artykul_id}', {ilosc}, {ilosc2}, {cena1}, {cena2}, {cena1}, {cena2})
                        ;""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLINSPOZW)
        stat, dump, dump, dump = self.PolSQL.Execute(SQLINSPOZW, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return "{sklep_id}: Bad dodawania pozycji dokumentu magazynowego {dokument_id} w " \
                               "magazynie {magazyn_id} na {data} o numerze {numer} dla artykuu {artykul_id} : {stat}.".format(**locals())

    # -----------------
    # Dodawanie dokumentw powiodo si, wykonujemy update wpisujcy magazyn i date WZ w naglwki paragonw
    UPDPAR = """UPDATE rs_hd_paragony
                SET magazyn_id='{magazyn_id}', data_tworzenia_wz=NOW()::DATE
                WHERE paragon_id IN (SELECT DISTINCT paragon_id
                                    FROM rs_hd_paragony p
                                    JOIN rs_hd_paragony_pozycje pp USING (paragon_id)
                                    {filtr} AND pp.typ ='1');""".format(**locals())
    rsglobal.ZapiszDoLogow(UPDPAR)
    stat, dump, dump, dump = self.PolSQL.Execute(UPDPAR, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        return "{sklep_id}: Bd aktualizowania informacji o WZ/ZP w nagwkach paragonw : {stat}.".format(**locals())

    return stat

    # # PODZIAL NA 2 ZAPYTANIA PONIEWAZ NIE MOZNA BLOKOWAC GDY UZYWA SIE 'GROUP BY'
    # filtr  = "WHERE p.firma_id ='{firma_id}' AND wz_data IS NULL AND sklep_id='{sklep_id}' " \
    #          "AND czas::DATE = '{data}'".format(**locals())
    # LOCK = """SELECT  paragon_id
    #           FROM rs_hd_paragony p
    #           {filtr}
    #           FOR UPDATE NOWAIT;
    #           """.format(**locals())
    # rsglobal.ZapiszDoLogow(LOCK)
    # stat, dump, dump, dump = self.PolSQL.Execute(LOCK, 3, CzyDodawacBlad=True)
    # if stat != 'OK':
    #     return u'{sklep_id}: Bd nakadania blokady na paragony.'.format(**locals())
    #
    # # Pobranie sum ilosci sprzedanych artykulow z paragonow
    # # kolumny: 0 - sklep_id, 1 - magazyn_id, 2 - artykul_id, 3 - ilosc, 4 - ilosc2
    # # zmieniajac kolejnosc kolumn trzeba bedzie zmienic dalsza czesc kodu
    # SQLWYD = """SELECT sklep_id,
    #                 (SELECT magazyn_id FROM rs_hd_sklepy WHERE firma_id=p.firma_id AND sklep_id=p.sklep_id) AS magazyn_id,
    #                  pp.artykul_id, SUM(pp.ilosc) as ilosc,
    #                 ROUND(sum(pp.ilosc) * a.przelicznik, 4) AS ilosc2
    #             FROM rs_hd_paragony p
    #             JOIN rs_hd_paragony_pozycje pp USING (paragon_id)
    #             JOIN rs_artykuly  a ON (p.firma_id=a.firma_id AND  pp.artykul_id=a.artykul_id)
    #             {filtr} AND pp.typ ='1'
    #             GROUP BY sklep_id, pp.artykul_id, p.firma_id, a.przelicznik
    #             ORDER BY sklep_id, pp.artykul_id;""".format(**locals())
    # rsglobal.ZapiszDoLogow(SQLWYD)
    # stat, daneparagony, dump, dump = self.PolSQL.Execute(SQLWYD, 3, CzyDodawacBlad=True)
    # if stat != 'OK':
    #     return u'{sklep_id}: Bd pobierania pozycji paragonw.'.format(**locals())
    # if len(daneparagony) < 1:
    #     return "OK"
    #
    # numer       = 0
    # magazyn_id  = daneparagony[0][1]
    # dokument_id = 'WZ'
    #
    # if magazyn_id in puste:
    #     return "{sklep_id}: Sklep nie posiada przypisanego magazynu.".format(**locals())
    #
    # SQLNUMSPRW = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('{firma_id}'," \
    #              "'[\\\'{magazyn_id}\\\',\\\'WZ\\\',\\\'{data}\\\']','M');".format(**locals())
    # rsglobal.ZapiszDoLogow(SQLNUMSPRW)
    # stat, danenumsprw, dump, dump = self.PolSQL.Execute(SQLNUMSPRW, 3, CzyDodawacBlad=True)
    # if danenumsprw[0][0] != 'OK':
    #     return "{sklep_id}: Ze wzgldu na numeracj nie mona doda dokumentu magazynowego WZ w " \
    #            "magazynie {magazyn_id} na {data}.".format(**locals())
    #
    # SQLNUMW = "SELECT rsf_podaj_nowy_numer_dokumentu('{firma_id}'," \
    #           "'[\\\'{magazyn_id}\\\',\\\'WZ\\\',\\\'{data}\\\']','M');".format(**locals())
    # rsglobal.ZapiszDoLogow(SQLNUMW)
    # stat, danenumw, dump, dump = self.PolSQL.Execute(SQLNUMW, 3, CzyDodawacBlad=True)
    # if stat != 'OK':
    #     return "{sklep_id}: Bd wyznaczania numeru dokumentu magazynowego WZ w " \
    #            "magazynie {magazyn_id} na {data} : {stat}".format(**locals())
    #
    # numer = danenumw[0][0]
    #
    # # dodanie naglowka dokumentu rozchodowego
    # SQLINSW = """INSERT INTO rs_dokumenty_magazynowe
    #                              (firma_id,    magazyn_id,    dokument_id, data,   numer, magazyn_skad)
    #                     VALUES ('{firma_id}','{magazyn_id}',     'WZ',   '{data}',{numer} ,'{magazyn_id}');
    #                     """.format(**locals())
    #
    # rsglobal.ZapiszDoLogow(SQLINSW)
    # stat, dump, dump, dump = self.PolSQL.Execute(SQLINSW, 1, CzyDodawacBlad=True)
    # if stat != 'OK':
    #     return "{sklep_id}: Bad dodawania dokumentu magazynowego WZ w " \
    #            "magazynie {magazyn_id} na {data} o numerze {numer} : {stat}".format(**locals())
    #
    # nr_poz = 0
    # for wiersz in daneparagony:
    #     nr_poz += 1
    #     artykul_id     = wiersz[2]
    #     ilosc          = wiersz[3]
    #     ilosc2         = wiersz[4]
    #
    #     # dodanie pozycji dokumentu rozchodowego
    #     SQLINSPOZW = """INSERT INTO rs_dokumenty_magazynowe_pozycje
    #                              (firma_id,    magazyn_id,  dokument_id,  data,  numer,    nr_poz,  nr_ppoz,
    #                               artykul_id,  ilosc1,  ilosc2)
    #                     VALUES ('{firma_id}','{magazyn_id}',    'WZ',   '{data}',{numer}, {nr_poz},     0,
    #                             '{artykul_id}', {ilosc}, {ilosc2})
    #                     ;""".format(**locals())
    #     rsglobal.ZapiszDoLogow(SQLINSPOZW)
    #     stat, dump, dump, dump = self.PolSQL.Execute(SQLINSPOZW, 1, CzyDodawacBlad=True)
    #     if stat != 'OK':
    #         return "{sklep_id}: Bad dodawania pozycji dokumentu magazynowego WZ w " \
    #                            "magazynie {magazyn_id} na {data} o numerze {numer} dla artykuu {artykul_id} : {stat}.".format(**locals())
    #
    #
    # # wpisane danych WZ w naglowki paragonow
    # UPDPAR = """UPDATE rs_hd_paragony
    #             SET wz_magazyn_id='{magazyn_id}', wz_dokument_id='WZ', wz_data='{data}', wz_numer={numer}
    #             WHERE paragon_id IN (SELECT DISTINCT paragon_id
    #                                 FROM rs_hd_paragony p
    #                                 JOIN rs_hd_paragony_pozycje pp USING (paragon_id)
    #                                 {filtr} AND pp.typ ='1')
    #             ;""".format(**locals())
    # rsglobal.ZapiszDoLogow(UPDPAR)
    # stat, dump, dump, dump = self.PolSQL.Execute(UPDPAR, 1, CzyDodawacBlad=True)
    # if stat != 'OK':
    #     return "{sklep_id}: Bd aktualizowania informacji o WZ w nagwkach paragonw : {stat}.".format(**locals())
    # return stat
