# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_typy_stoisk.py
# Purpose:     przegladanie i edycja typow stoisk
# Author:      Wojciech Skowron
# Created:     2019/08/20
# RCS-ID:      $Id: fs_hd_typy_stoisk.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
091400 Typy stoisk
091420 Modyfikacja
091430 Grupy towarowe
"""

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprMod    = (((self.oddzial_id,'091420') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrzegl = (((self.oddzial_id,'091400') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'BR UPR MOD'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            DEL = ''
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_hd_typy_stoisk WHERE firma_id='{}'""".format(self.firma_id)
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"='"+wart+"'"

                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            for pola, wartosci, nrWiersza in zip(Update[0], Update[1], Update[-1]):
                for pole, wart in zip(pola, wartosci):
                    if pole == 'typ_stoiska_id':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,0))
                            dane.append('BR ID')
                        elif len(wart.strip()) > 3:
                            wyn2.append((nrWiersza,0))
                            dane.append('BL DL ID')

                    elif pole == 'nazwa':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,1))
                            dane.append('BR NAZWA')
                        elif len(wart.strip()) > 40:
                            wyn2.append((nrWiersza,1))
                            dane.append('BL DL NAZWA')

                    elif pole == 'nazwa_skrot':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,2))
                            dane.append('BR SKROT')
                        elif len(wart.strip()) > 10:
                            wyn2.append((nrWiersza,2))
                            dane.append('BL DL SKROT')

                    elif pole == 'nazwa_mobile':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,3))
                            dane.append('BR MOBILE')
                        elif len(wart.strip()) > 6:
                            wyn2.append((nrWiersza,3))
                            dane.append('BL DL MOBILE')

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            UPD = ''

            for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
                UPD += "UPDATE rs_hd_typy_stoisk SET "
                for pole, wart in zip(pola, wartosci):
                    if pole in ['typ_stoiska_id', 'nazwa', 'nazwa_skrot', 'nazwa_mobile']:
                        UPD += pole+"='"+str(wart).strip()+"',"
                    elif pole in ['czy_sprzedaz']:
                        UPD += pole+"="+str(bool(wart))+","

                UPD = UPD.strip(",")
                UPD += " WHERE firma_id='"+self.firma_id+"'"

                for pole, wart in zip(Update[3], klucz): # petla po kluczu
                    UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

                UPD += ";"
            if UPD != '':
                rsglobal.ZapiszDoLogow(UPD)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0]) > 0:
        if not UprMod:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            pola = Insert[1]

            for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
                for pole, wart in zip(pola, wartosci):
                    if pole == 'typ_stoiska_id':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,0))
                            dane.append('BR ID')
                        elif len(wart.strip()) > 3:
                            wyn2.append((nrWiersza,0))
                            dane.append('BL DL ID')

                    elif pole == 'nazwa':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,1))
                            dane.append('BR NAZWA')
                        elif len(wart.strip()) > 40:
                            wyn2.append((nrWiersza,1))
                            dane.append('BL DL NAZWA')

                    elif pole == 'nazwa_skrot':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,2))
                            dane.append('BR SKROT')
                        elif len(wart.strip()) > 10:
                            wyn2.append((nrWiersza,2))
                            dane.append('BL DL SKROT')

                    elif pole == 'nazwa_mobile':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,3))
                            dane.append('BR MOBILE')
                        elif len(wart.strip()) > 6:
                            wyn2.append((nrWiersza,3))
                            dane.append('BL DL MOBILE')

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            INS = ''
            pola = Insert[1]

            for wartosci in Insert[0]:
                INSERT  = "INSERT INTO rs_hd_typy_stoisk "
                KOLUMNY = "(firma_id"
                VALUES  = " VALUES ('"+self.firma_id+"'"
                for pole, wart in zip(pola, wartosci):
                    if pole in ['typ_stoiska_id', 'nazwa', 'nazwa_skrot', 'nazwa_mobile']:
                        KOLUMNY += ","+pole
                        VALUES+=",'"+str(wart).strip()+"'"
                    elif pole in ['czy_sprzedaz']:
                        KOLUMNY += ","+pole
                        VALUES+=","+str(bool(wart))

                KOLUMNY+=")"
                VALUES+=");"
                INS += INSERT+KOLUMNY+VALUES
            if INS != '':
                rsglobal.ZapiszDoLogow(INS, 5)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrzegl:
        stat='BR UPR PRZ'
        dane.append(stat)

    SEL = """SELECT typ_stoiska_id,nazwa,nazwa_skrot,nazwa_mobile,czy_sprzedaz FROM rs_hd_typy_stoisk WHERE firma_id='{}' 
             ORDER BY typ_stoiska_id,nazwa,nazwa_skrot,nazwa_mobile;""".format(self.firma_id)
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
    else:
        for d in dane:
            d[0] = d[0].strip()
