# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_typy_stoisk_grupy_towarowe.py
# Purpose:     przegladanie i edycja typow stoisk
# Author:
# Created:     2019/08/20
# RCS-ID:      $Id: fs_hd_typy_stoisk_grupy_towarowe.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'ID': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_typy_stoisk_grupy_towarowe z numerem '+str(Funkcja)+' bez parametrw: '+Lista

"""
091430 Grupy towarowe
091432 Grupy towarowe Modyfikacja
"""

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

if stat == 'OK':
    if Funkcja in (1, 5):
        TypStoiskaID = klucze['ID']

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprMod    = (((self.oddzial_id,'091432') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrzegl = (((self.oddzial_id,'091430') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'BR UPR MOD'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            DEL = ''
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_hd_typy_stoisk_grupy_towarowe 
                          WHERE firma_id='{}' AND typ_stoiska_id='{}'""".format(self.firma_id, TypStoiskaID)
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"='"+wart+"'"

                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            for pola, wartosci, nrWiersza in zip(Update[0], Update[1], Update[-1]):
                for pole, wart in zip(pola, wartosci):
                    if pole == 'grupa':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,0))
                            dane.append('BR GRUPA')
                        else:
                            SQL = """SELECT 1 FROM rs_hd_grupy_towarowe 
                                     WHERE firma_id='{}' AND kod='{}';
                                  """.format(self.firma_id, wart.strip())
                            stat,gr,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd sprawdzania grupy towarowej: '+stat
                                wyn2.append((nrWiersza,0))
                                dane.append(stat)
                            elif len(gr) == 0:
                                stat = 'Nieprawidowa grupa towarowa: '+str(wart)
                                wyn2.append((nrWiersza,0))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            UPD = ''

            for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
                UPD += "UPDATE rs_hd_typy_stoisk_grupy_towarowe SET "
                for pole, wart in zip(pola, wartosci):
                    if pole in ['grupa']:
                        UPD += pole+"='"+str(wart).strip()+"',"

                UPD = UPD.strip(",")
                UPD += """ WHERE firma_id='{}' AND typ_stoiska_id='{}'""".format(self.firma_id, TypStoiskaID)

                for pole, wart in zip(Update[3], klucz): # petla po kluczu
                    UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

                UPD += ";"
            if UPD != '':
                rsglobal.ZapiszDoLogow(UPD)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0]) > 0:
        if not UprMod:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            pola = Insert[1]

            for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
                for pole, wart in zip(pola, wartosci):
                    if pole == 'grupa':
                        if wart.strip() == '':
                            wyn2.append((nrWiersza,0))
                            dane.append('BR GRUPA')
                        else:
                            SQL = """SELECT 1 FROM rs_hd_grupy_towarowe 
                                     WHERE firma_id='{}' AND kod='{}';
                                  """.format(self.firma_id, wart.strip())
                            stat,gr,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd sprawdzania grupy towarowej: '+stat
                                wyn2.append((nrWiersza,0))
                                dane.append(stat)
                            elif len(gr) == 0:
                                stat = 'Nieprawidowa grupa towarowa: '+str(wart)
                                wyn2.append((nrWiersza,0))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            INS = ''
            pola = Insert[1]

            for wartosci in Insert[0]:
                INSERT  = "INSERT INTO rs_hd_typy_stoisk_grupy_towarowe "
                KOLUMNY = "(firma_id,typ_stoiska_id"
                VALUES  = " VALUES ('"+self.firma_id+"','"+TypStoiskaID+"'"
                for pole, wart in zip(pola, wartosci):
                    if pole in ['grupa']:
                        KOLUMNY += ","+pole
                        VALUES+=",'"+str(wart).strip()+"'"

                KOLUMNY+=")"
                VALUES+=");"
                INS += INSERT+KOLUMNY+VALUES
            if INS != '':
                rsglobal.ZapiszDoLogow(INS, 5)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrzegl:
        stat='BR UPR PRZ'
        dane.append(stat)

    SEL = """SELECT grupa, opis 
             FROM rs_hd_typy_stoisk_grupy_towarowe t
             LEFT OUTER JOIN rs_hd_grupy_towarowe gr ON t.grupa = gr.kod AND t.firma_id = gr.firma_id
             WHERE t.firma_id='{}' AND t.typ_stoiska_id='{}'
             ORDER BY grupa""".format(self.firma_id, TypStoiskaID)
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
    else:
        for d in dane:
            d[0] = d[0].strip()
