# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_import_eksport_tabel.py
# Purpose:     import/eksport tabel
# Author:      Micha Raburski
# Created:     2010/05/04
# RCS-ID:      $Id: fs_import_eksport_tabel.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2024-02-20 Wojciech Skowron - (13695) Przyjmowany stat z ZapiszXLS

Fun=klucze[-1]
stat='OK'
dane=[]

#-------------------------------------------------------------------------------
# pobranie tabel do grida. 
#-------------------------------------------------------------------------------

if Fun==1:
    SQL="SELECT DISTINCT relname FROM pg_class INNER JOIN pg_attribute ON (pg_class.oid=attrelid)"
    SQL+=" WHERE NOT pg_class.relname LIKE 'rsi%' AND NOT pg_class.relname LIKE '%pkey' AND NOT pg_class.relname LIKE 'rsa%' "
    SQL+=" AND pg_attribute.attname='firma_id' ORDER BY relname;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    
    # od razu s pobierane pozycje
    SPoz={}
    
    for d in dane:
        SQL="SELECT DISTINCT pg_attribute.attnum,attname,pg_type.typname,TRUE FROM  pg_attribute"
        SQL+=" INNER JOIN pg_class ON (pg_class.oid=attrelid) INNER JOIN pg_type ON (atttypid=pg_type.oid)"
        SQL+=" WHERE pg_class.relname='"+rsglobal.Dekoduj(d[0])+"' AND NOT pg_attribute.attname IN ('z_czas','z_typ','z_op_id') "
        SQL+=" AND NOT pg_type.typname IN ('cid','xid','oid','tid') ORDER BY pg_attribute.attnum;"
        stat,DanePoz,Nagl,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            SPoz[d[0]]=DanePoz

    wyn2=SPoz

#-------------------------------------------------------------------------------
# pobranie danych do pliku - EKSPORT (2)
#-------------------------------------------------------------------------------

if Fun==2:
    Tabela=klucze[0]
    LPola=klucze[1]
    Warunek=klucze[2]
    Warunek=Warunek.replace("\\"+"'","'")
    Firma=klucze[3]
    Okres=klucze[4]

    # obsuga zmiennej Firma w zalenoci od jej treci
    if Firma=='':
        Firma=self.firma_id
    else:
        #sprawdzenie czy podana firma istnieje
        SQL="SELECT * FROM rs_firmy WHERE firma_id='"+Firma+"';"
        stat,DTab,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTab)==0:
                stat="Brak firmy "+Firma
    
    if stat=='OK':
        Pola=''
        for pole in LPola:
            Pola+=rsglobal.Dekoduj(pole)+","
        Pola=Pola[:-1]
        
        SQL="SELECT "+Pola+" FROM "+Tabela+" WHERE firma_id='"+Firma+"'"
        if Okres != "":
            # sprawdzenie czy jest pole okres_id
            SQLOkr="SELECT DISTINCT relname FROM pg_class INNER JOIN pg_attribute ON (pg_class.oid=attrelid)"
            SQLOkr+=" WHERE pg_class.relname='"+Tabela+"' AND pg_attribute.attname='okres_id';"
            stat,DOkr,dump,dump=self.PolSQL.Execute(SQLOkr,3)
            if stat=='OK':
                if len(DOkr)>0:
                    SQL+=" AND okres_id='"+Okres+"'"
                    
        if Warunek != "":
            SQL+=" AND ("+Warunek+")"
    
        rsglobal.ZapiszDoLogow('SQL DANE '+SQL,1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
        if stat!= 'OK':
            if stat=='BLAD' and Warunek != '':
                stat='Bd pobierania danych do eksportu - prawdopodobnie podany niepoprawny filtr do tabeli. '
            else:
                stat='Bd pobierania danych do eksportu : '+stat
                
#-------------------------------------------------------------------------------
# wstawienie danych z pliku - IMPORT (3)
#-------------------------------------------------------------------------------

if Fun==3:
    Tabela=klucze[0]
    Wiersze=klucze[1]
    Firma=klucze[2]
    Okres=klucze[3]
    
    CzyOkres=False
        
    #---------------------------------------------------------------------------
    #---- CZʦ ALGORYTMU SPRAWDZAJCA POPRAWNO DANYCH
    #---------------------------------------------------------------------------
    
    # obsuga zmiennej Firma w zalenoci od jej treci
    if Firma=='':
        Firma=self.firma_id
    else:
        #sprawdzenie czy podana firma istnieje
        SQL="SELECT * FROM rs_firmy WHERE firma_id='"+Firma+"';"
        stat,DTab,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTab)==0:
                stat="Brak firmy "+Firma
    
    if stat=='OK':    
        # sprawdzenie czy tabela istnieje i czy jest w niej pole firma_id
        SQL="SELECT DISTINCT relname FROM pg_class INNER JOIN pg_attribute ON (pg_class.oid=attrelid)"
        SQL+=" WHERE pg_class.relname='"+Tabela+"' AND pg_attribute.attname='firma_id';"
        stat,DTab,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTab)==0:
                stat="Brak tabeli "+Tabela+" pobranej z nazwy podanego pliku lub nie zawiera ona pola 'firma_id' "
    
    if stat=='OK':
        # sprawdzenie czy pole okres_id jest w tabeli i jeli tak - sprawdzenie jego poprawnoci 
        SQL="SELECT attname FROM pg_class cl INNER JOIN pg_attribute atr ON (atr.attrelid=cl.oid) "
        SQL+=" WHERE cl.relname='"+Tabela+"' AND attname='okres_id';"
        stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DOkr)>0:
                CzyOkres=True
                if Okres=='':
                    stat="Nie podano okresu, mimo, e wystpuje w tabeli "+Tabela
                if stat=='OK':
                    SQL="SELECT * FROM rs_definicje_okresow WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"';"
                    stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)
                    if len(DOkr)==0:
                        stat='Podany okres '+Okres+" nie istnieje w wybranej firmie"

    if stat=='OK':
        PolaTmp=Wiersze[0].split(';')
        Pola=[]
        for p in PolaTmp:
            if not ('\n' in p or '\r' in p or p.strip()==''):
                Pola.append(p.strip())
                
    # sprawdzenie czy w caym pliku jest odpowiednia liczba kolumn w wierszach
    if stat=='OK':
        KrotkieW=[]
        i=1
        for w in Wiersze:
            if len(w.split(';'))<len(Pola):
                KrotkieW.append(i)
            i=i+1
        
        if KrotkieW != []:
            stat='Za mao kolumn w wierszach : '+str(KrotkieW)[1:-1]
            
    if stat=='OK':
    # sprawdzenie czy podane pola s w tabeli moliwe do wstawienia
        SQL="SELECT attname FROM pg_class cl INNER JOIN pg_attribute atr ON (atr.attrelid=cl.oid) "
        SQL+=" WHERE cl.relname='"+Tabela+"' AND attname IN ("+str(Pola)[1:-1]+");"
        stat,DPola,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            LBrak=[]
            STypow={}
            for p in Pola:
                if not [p] in DPola:
                    LBrak.append(p)
                else:
                    # pobranie typu pola
                    SQL="SELECT typname FROM pg_class cl INNER JOIN pg_attribute atr ON (atr.attrelid=cl.oid) "
                    SQL+=" INNER JOIN pg_type typ ON (typ.oid=atr.atttypid) "
                    SQL+=" WHERE cl.relname='"+Tabela+"' AND attname ='"+p+"';"
                    stat,DAtr,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if len(DAtr)==0:
                            LBrak.append(p)
                        else:
                            STypow[p]=DAtr[0][0]
            if LBrak<>[]:
                stat="W tabeli "+Tabela+" brak podanych w pliku pl :"+str(LBrak)[1:-1]
    
            rsglobal.ZapiszDoLogow('STYPOW '+str(STypow),1)
    if stat=='OK':
        # pobranie klucza - ktre pola s kluczowe w tabeli
        SQL="SELECT attname FROM  pg_class cl INNER JOIN pg_constraint con ON (cl.oid=con.conrelid)"
        SQL+="INNER JOIN pg_attribute atr ON (atr.attrelid=cl.oid AND "
        SQL+="(POSITION(atr.attnum::TEXT||',' IN array_to_string(con.conkey,',')||',')>0 OR POSITION(atr.attnum::TEXT||'}' IN array_to_string(con.conkey,',')||',')>0))"
        SQL+=" WHERE cl.relname='"+Tabela+"' AND con.contype='p';"
        stat,DPolaKl,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':    
        PolaKlucz=[]
        PolaKluczBrak=[]
        for p in DPolaKl:
            PolaKlucz.append(rsglobal.Dekoduj(p[0]))
            if p[0] not in ['firma_id','okres_id']:
                if p[0] not in Pola:
                    PolaKluczBrak.append(rsglobal.Dekoduj(p[0]))
        
        if PolaKluczBrak<>[]:
            stat="W pliku brak kolumn z klucza tabeli "+Tabela+" : "+str(PolaKluczBrak)[1:-1]
            
    # sprawdzenie w ktrych kolumnach s firma i ew. oddzial
    KolFirma=-1
    KolOddz=-1
    if 'firma_id' in Pola:
        KolFirma=Pola.index('firma_id')
    if 'oddzial_id' in Pola:
        KolOddz=Pola.index('oddzial_id')

    #---------------------------------------------------------------------------
    #---- GWNA CZʦ ALGORYTMU WSTAWIAJCA DANE
    #---------------------------------------------------------------------------
    
    # inicjalizacja zmiennych
    LDodanych=0
    LKlucz=0
    LBledy=[]

    if stat=='OK':
        for w in Wiersze:
            if stat != 'OK':
                break
                
            #ignorujemy pierwszy wiersz
            if w==Wiersze[0]:
                continue
            
            # odwrcenie podstawienia @->-- pod zamanie wiersza
            w=w.replace('@->--','\n')
            
            wiersz=w.split(';')
            # sprawdzenie czy rekord o podanym kluczu ju istnieje
            SQLKlucz="SELECT * FROM "+Tabela+" WHERE firma_id='"+Firma+"'"
            for pole in PolaKlucz:
                if pole != 'firma_id':
                    SQLKlucz+=" AND "+pole+"='"+wiersz[Pola.index(pole)].strip()+"' "

            stat,DTestIstn,dump,dump=self.PolSQL.Execute(SQLKlucz,3)
            if stat<>'OK':
                stat='Bd zapytania sprawdzajcego klucz : '+stat
            if stat=='OK':
                if len(DTestIstn)>0:
                    LKlucz=LKlucz+1
                    continue
                
            # prba inserta - w przypadku niepowodzenia zapis bdu do logw.
            try:
                CzyBlad=False
                SQLIns="INSERT INTO "+Tabela+" ("+str(Pola)[1:-1].replace("'","")+") VALUES ("
                i=0
                for p in wiersz:
                    if i<len(Pola):
                        wart=str(p).strip()
                        
                        if i==KolFirma:
                            SQLIns+="'"+Firma+"',"
                        elif i==KolOddz:
                            SQLIns+="'"+self.oddzial_id+"',"
                        # obsuga NULLa
                        elif wart in ['NULL','None']:
                            #usunicie pola z inserta - wstawiany jest default
                            SQLIns=SQLIns.replace("("+Pola[i]+", ","(").replace(", "+Pola[i]+")",")").replace(", "+Pola[i]+",",",")
                        # tu s uwzgldniane typy pl
                        elif STypow[Pola[i]]=='bool':
                            if wart in ['TRUE','True','T']:
                                SQLIns+="TRUE,"
                            else:
                                SQLIns+="FALSE,"
                        elif STypow[Pola[i]] in ['numeric','int2','int4','int8']:
                            SQLIns+=wart.replace(',','.')+","
                        else:
                            if wart.strip()=='' and not Pola[i] in PolaKlucz:
                                #usunicie pola z inserta - wstawiany jest default
                                SQLIns=SQLIns.replace("("+Pola[i]+", ","(").replace(", "+Pola[i]+")",")").replace(", "+Pola[i]+",",",")
                            else:
                                SQLIns+="'"+wart+"',"
                        
                    i=i+1
                SQLIns=SQLIns[:-1]+")"
                stat,dump,dump,dump=self.PolSQL.Execute(SQLIns,1,CzyDodawacBlad=True)
                if stat!= 'OK':
                    CzyBlad=True
                    LBledy.append('#'*40)
                    LBledy.append('BD wstawienia danych w linii : '+str(w))
                    LBledy.append('    '+str(stat[4:]))
                    rsglobal.ZapiszDoLogow('!!! BLAD stat'+stat,1)
                    stat='OK'
                else:
                    self.PolSQL.Commit()
                    
            except Exception,e:
                CzyBlad=True
                LBledy.append('BD w linii : '+str(w))
                LBledy.append(str(e))
                self.PolSQL.Rollback()
                stat='OK'
                pass
            
            if not CzyBlad:
                LDodanych=LDodanych+1
                self.PolSQL.Commit()
                
                
    
    if stat=='OK':
        dane.append('IMPORT ZAKOCZONY')
        dane.append('')
        dane.append('POLA '+str(Pola))
        dane.append('Liczba dodanych wierszy : '+str(LDodanych))
        if LKlucz>0:
            dane.append('Liczba wierszy z istniejcym kluczem : '+str(LKlucz))
        if len(LBledy)>0:
            dane.append('Liczba wierszy z bdami dodawania : '+str(len(LBledy)/3))
            dane.append('')
            dane.append('BDY :')
            dane=dane+LBledy
            
#-------------------------------------------------------------------------------
#-- ZAPIS DANYCH SPRZEDAOWYCH DO XLSX (11)
#-------------------------------------------------------------------------------
            
if Fun == 11:
    from funkcje import fs_pliki_office
    from funkcje import fs_pliki_global
    
    Platnik = klucze[0]
    DataOd = klucze[1]
    DataDo = klucze[2]
    Oddzial = klucze[3]
    
    # zakadamy, e dane wypenia admin i s poprawne
    SQL="SELECT dd.oddzial_id,dd.platnik_id,dd.data,ddp.artykul_id,SUM(ddp.ilosc_zam1)"
    SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
    SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer) "
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    if Oddzial != '':
        SQL+=" AND dd.oddzial_id = '"+Oddzial+"'"
    if Platnik != '':
        SQL+=" AND dd.platnik_id = '"+Platnik+"'"

    SQL+=" AND dd.data >= '"+DataOd+"'"
    SQL+=" AND dd.data <= '"+DataDo+"'"
    SQL+=" GROUP BY dd.oddzial_id,dd.platnik_id,dd.data,ddp.artykul_id"
    SQL+=" ORDER BY dd.data,dd.platnik_id,dd.oddzial_id,ddp.artykul_id"
    stat,DSprzed,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd pobierania danych sprzedaowych : '+stat

    if stat=='OK':
        if len(DSprzed) == 0:
            stat = 'Brak pozycji do pobrania'
    # zoenie danych w odpowiedni struktur. Kady miesic bdzie w osobnej zakadce
    
    if stat =='OK':
        LTresc=[]
        Zakl=''
        TrescZakl=[]
        i=0
        for poz in DSprzed:
            # zmiana miesica - nowa zakadka
            if Zakl != poz[2][:7]:
                # jeli bya zakadka to zapisujemy j do arkusza
                if Zakl != '':
                    LTresc.append([Zakl,TrescZakl])
                    
                Zakl=poz[2][:7]
                TrescZakl=[[0,0,'DATA','s'],[0,1,'PATNIK','s'],[0,2,'ODDZIA','s'],[0,3,'ARTYKU','s'],[0,4,'ZAMOWIENIE','s']]
                i=1
            
            TrescZakl.append([i,0,poz[2],'s'])
            TrescZakl.append([i,1,poz[1],'s'])
            TrescZakl.append([i,2,poz[0],'s'])
            TrescZakl.append([i,3,poz[3],'s'])
            TrescZakl.append([i,4,poz[4],'n'])
            i+=1
            
        # zapis ostatniej 
        if TrescZakl<>[]:
            LTresc.append([Zakl,TrescZakl])
            
        if LTresc==[]:
            stat = 'Pusty dokument do zapisu'
        
    if stat =='OK':
        Plik='DaneSprz'+Platnik+DataOd.replace('-','')+DataDo.replace('-','')+Oddzial+'.xlsx'
        
        # pobranie treci pliku
        stat=fs_pliki_office.ZapiszXLS(LTresc,self.KatalogPlikow+'/'+Plik,kodowanie='iso8859_2')  #WS 2024-02-20 - stat=
        if stat == 'OK':
            stat,Tresc=fs_pliki_global.PobierzZwyklyPlikZSerwera(self.KatalogPlikow+'/'+Plik)
            dane=[Tresc]
