#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_intrastat.py
# Purpose:          przeglda dostawy
# Author:           Marcin Grzda
# Created:          2007/11/23
# RCS-ID:           $Id: fs_intrastat.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
# 2010-10-20        Marcin Natkaski (refaktoryzacja kodu)
# 2016-04-26        Piotr Bender (9619) refaktoryzacja
#-----------------------------------------------------------------------------
# 2016-08-29   Piotr Witkowski (9619) refaktoryzacja poprawki

stat = 'OK'
dane = []

rsglobal.ZapiszDoLogow('A MOZE TU',  1)

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'FRok': [1, 5, 6, 9], 'FMiesiac': [1, 5, 6, 9], 'Rok': [6, 9, 10], 'Miesiac': [6, 9, 10],
             'NrZgloszenia': [6, 9], 'NrWersji': [6, 9],
             'RodzajDeklaracji': [6, 9], 'RodzajWydruku': [6, 9]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)

    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_zobowiazanie_ratalne z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if stat == 'OK':
        if Funkcja in [1, 5, 6, 9, 10]:
            FRok = rsglobal.Dekoduj(klucze['FRok'])
            FMiesiac = rsglobal.Dekoduj(klucze['FMiesiac'])
            Rok = rsglobal.Dekoduj(klucze['Rok'])
            Miesiac = rsglobal.Dekoduj(klucze['Miesiac'])
            NrZgloszenia = rsglobal.Dekoduj(klucze['NrZgloszenia'])
            NrWersji = rsglobal.Dekoduj(klucze['NrWersji'])
            RodzajDeklaracji = rsglobal.Dekoduj(klucze['RodzajDeklaracji'])
            RodzajWydruku = rsglobal.Dekoduj(klucze['RodzajWydruku'])

if stat=='OK':
    UprDel = ((self.oddzial_id, '036014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprDod = ((self.oddzial_id, '036013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    Insert = []
    Update = []
    Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- POBIERANIE POZYCJI Z DOSTAW -9
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [9,]:
    if not UprDod:
        stat="UPR DOD"   
        dane.append(stat)
    if stat=='OK':
        Delete="DELETE FROM rs_intrastat_pozycje WHERE firma_id='"+self.firma_id+"'"
        Delete+=" AND rok = '"+Rok+"' AND miesiac = '"+Miesiac+"' "
        Delete+=" AND nr_zgloszenia='"+NrZgloszenia+"' AND nr_wersji='"+NrWersji+"'"
        Delete+=" AND rodzaj_deklaracji='"+RodzajDeklaracji+"'"
        Delete+=" AND wywoz_przywoz='"+RodzajWydruku+"'"
        stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
    if stat<>'OK':
        stat='BL DEL POZ'
        dane.append(stat)
        
    if stat=='OK':
        sequence="Create temp sequence seq_intrastat start 1;"
        stat,dump,dump,dump=self.PolSQL.Execute(sequence,1)
        if stat<>'OK':
            stat='BL CREATE SEQ'
            dane.append(stat)

    if stat=='OK':
        sql="INSERT INTO rs_intrastat_pozycje "
        sql+="(firma_id,rok,miesiac,nr_zgloszenia,nr_wersji,rodzaj_deklaracji,wywoz_przywoz,nr_poz"
        sql+=",kraj_wysylki,kraj_pochodz,kod_towaru,kod_transakcji,masa_netto,ilosc"
        sql+=",wartosc_fakturowa,wartosc_statystyczna,rodzaj_transportu,warunki_dostawy)"  
        sql+=" (SELECT '"+self.firma_id+"','"+Rok+"','"+Miesiac+"'"
        sql+=",'"+NrZgloszenia+"','"+NrWersji+"','"+RodzajDeklaracji+"','"+RodzajWydruku+"'"
        sql+=",nextval('seq_intrastat'),nagl.kraj_wysylki,poz.kraj_pochodz,art.kod_cn,poz.kod_transakcji"
        sql+=",SUM(poz.ilosc_dost1*art.waga) as masa_netto"
        sql+=",CASE WHEN art.czy_jedn_uzupelniajace THEN SUM(poz.ilosc_dost1) ELSE 0 END as ilosc"
        sql+=",SUM(round(poz.cena_upust_wal1*poz.ilosc_dost1*nagl.kurs,2)),SUM(poz.wartosc_dostawy)"
        sql+=",nagl.rodzaj_transportu,nagl.warunki_dostawy"
        sql+=" FROM rs_dostawy_pozycje poz INNER JOIN rs_dostawy nagl"
        sql+=" ON (poz.firma_id=nagl.firma_id AND poz.data=nagl.data AND poz.numer=nagl.numer)"
        sql+=" INNER JOIN rs_kraje kraj ON (kraj.kraj=nagl.kraj_wysylki)" 
        sql+=" INNER JOIN rs_artykuly art ON (poz.firma_id=art.firma_id AND poz.artykul_id=art.artykul_id)" 
        sql+=" WHERE kraj.czy_ue=true AND poz.firma_id='"+self.firma_id+"' AND art.firma_id='"+self.firma_id+"' AND  EXTRACT(MONTH FROM nagl.data)="+str(int(Miesiac))
        sql+=" AND CAST(EXTRACT(YEAR FROM nagl.data) AS INTEGER)%100="+str(int(Rok))
        sql+=" GROUP BY art.czy_jedn_uzupelniajace,art.kod_cn,nagl.kraj_wysylki,poz.kraj_pochodz"
        sql+=",nagl.rodzaj_transportu,poz.kod_transakcji,nagl.warunki_dostawy)"
        stat,d,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>"OK":
            stat='Bdy pobierania pozycji z dostaw ' + stat
            dane.append(stat)

    if stat=='OK':
        sequence="Drop sequence seq_intrastat"
        stat,dump,dump,dump=self.PolSQL.Execute(sequence,1)
        
        
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- POBIERANIE ARTYKULOW Z NIEWYPELNIONYMI CENAMI
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [9, 10]:
    select="SELECT art.artykul_id,art.kod_cn,art.waga"
    select+=" FROM rs_dostawy_pozycje poz INNER JOIN rs_dostawy nagl"
    select+=" ON (poz.firma_id=nagl.firma_id AND poz.data=nagl.data AND poz.numer=nagl.numer)"
    select+=" INNER JOIN rs_kraje kraj ON (kraj.kraj=nagl.kraj_wysylki)" 
    select+=" INNER JOIN rs_artykuly art ON (poz.firma_id=art.firma_id AND poz.artykul_id=art.artykul_id)" 
    select+=" WHERE (art.kod_cn='' OR art.kod_cn is null OR art.waga=0) "
    select+=" AND art.firma_id='"+self.firma_id+"' "
    select+=" AND kraj.czy_ue=true AND EXTRACT(MONTH FROM nagl.data)="+str(int(Miesiac))
    select+=" AND CAST(EXTRACT(YEAR FROM nagl.data) AS INTEGER)%100="+str(int(Rok))
    select+=" GROUP BY art.kod_cn,nagl.kraj_wysylki,poz.kraj_pochodz,art.artykul_id,art.waga"
    stat,art,dump,dump=self.PolSQL.Execute(select,3)
    
    
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# -- USUWANIE -6 
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [6,]:
    if not UprDel:
        stat="UPR DEL"   
        dane.append(stat)
        
    if stat=='OK':
        sql="DELETE FROM rs_intrastat_pozycje WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND rok = '"+Rok+"' AND miesiac = '"+Miesiac+"' "
        sql+=" AND nr_zgloszenia='"+NrZgloszenia+"' AND nr_wersji='"+NrWersji+"'"
        sql+=" AND rodzaj_deklaracji='"+RodzajDeklaracji+"'"
        sql+=" AND wywoz_przywoz='"+RodzajWydruku+"';"
        sql+="DELETE FROM rs_intrastat WHERE firma_id='"+self.firma_id+"' "
        sql+="AND rok = '"+Rok+"' AND miesiac = '"+Miesiac+"' "
        sql+=" AND nr_zgloszenia='"+NrZgloszenia+"' AND nr_wersji='"+NrWersji+"'"
        sql+=" AND rodzaj_deklaracji='"+RodzajDeklaracji+"'"
        sql+=" AND wywoz_przywoz='"+RodzajWydruku+"'"
        rsglobal.ZapiszDoLogow(sql,5)
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='Bdne zapytanie usuwajce dane deklaracji ' + stat
            dane.append(stat)
            
       
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- POBIERANIE DANYCH
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and (Funkcja in [5, 6, 9, 1]):
    Filtr = " intr.firma_id = '" + self.firma_id+"'"
    if FRok.strip()<>'':
        Filtr+=" AND intr.rok='"+FRok+"'"
    if FMiesiac.strip()<>'':
        Filtr+=" AND intr.miesiac='"+FMiesiac+"'"

    SELECT = "SELECT  intr.rok,intr.miesiac,intr.nr_zgloszenia,intr.nr_wersji,intr.rodzaj_deklaracji"
    SELECT+=",intr.wywoz_przywoz, COALESCE(intr.izba_celna::TEXT,''),COALESCE(izba.opis::TEXT,'')"
    FROM=" FROM rs_intrastat intr LEFT OUTER JOIN rs_intrastat_izby_celne izba ON (intr.izba_celna=izba.kod)"
    WHERE=" WHERE "+Filtr
    ORDER=" ORDER BY intr.rok,intr.miesiac;"

    sql = SELECT+FROM+WHERE+ORDER
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
    if stat!="OK":
        stat="Bdy w pobieraniu danych " + stat
        dane.append(stat)

if (Funkcja in [9, 10]) and stat == 'OK':
    wyn1 = art
else:
    wyn1 = []