# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_intrastat_dane.py
# Purpose:     wczytuje i edytuje dane podstawowe deklaracji intrastat
# Author:      Marcin Grzda
# Created:     2007/11/29
# RCS-ID:      $Id: fs_intrastat_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
# 2010-10-20   Marcin Natkaski (refaktoryzacja kod)
#-------------------------------------------------------------------------------

Rok=klucze[0]
Miesiac=klucze[1]
NrZgloszenia=klucze[2]
NrWersji=klucze[3]
RodzajDeklaracji=klucze[4]
RodzajWydruku=klucze[5]
Funkcja=klucze[-1]
stat='OK'

Pola=pola
Wartosci=wartosci
puste_pola = [[],"","    -  -  "]
UprEdycja=((self.oddzial_id,'036012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

Filtr = " WHERE firma_id='"+self.firma_id+"' AND rok='"+Rok+"' AND miesiac='"+Miesiac+"'"
Filtr+= " AND nr_zgloszenia='"+NrZgloszenia+"' AND nr_wersji='"+NrWersji+"'"
Filtr+= " AND rodzaj_deklaracji='"+RodzajDeklaracji+"'"
Filtr+= " AND wywoz_przywoz='"+RodzajWydruku+"'"


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja in [3,4]:
    if not UprEdycja:
        stat="UPR ED"
        dane.appent(stat)
    if stat=='OK':       
        # Czy deklaracja istnieje
        sql  = "SELECT stan FROM rs_intrastat "
        sql += Filtr
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
        if stat<>'OK':
            stat="Bd zapytania sprawdzajcego istnienie deklaracji " + stat
            dane.append(stat)
        if len(d)==0:
            stat="Brak deklaracji "+stat                 
            dane.append(stat)
        if stat=="OK":            
            # ptla sprawdzajca pola
            for i in range(len(Pola)):
                pole = Pola[i]
                wart = Wartosci[i]

                if pole == "rok":
                    if len(war)<>2:
                        stat="BL ROK"
                        dane.append(stat)
                    else:
                        try:
                            rok=int(wart)
                        except:
                            stat="BL ROK"
                            dane.append(stat)

                elif pole == "miesiac":
                    if wart == "":
                        stat="BR MIES"
                        dane.append(stat)
                    else:
                        if not wart in ["01","02","03","04","05","06","07","08","09","10","11","12"]:
                            stat="BL MIES"
                            dane.append(stat)

                elif pole == "nr_zgloszenia":
                    if wart <>'':
                        sq = "SELECT kontrahent_id FROM rs_kontrahenci "
                        sq+= "WHERE firma_id='"+self.firma_id+"\' "
                        sq+= "AND kontrahent_id = \'"+wart+"\';"                        
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sq,3)
                        if len(dane_wyn) == 0:
                            stat="BL KONTR"
                            dane.append(stat)

                elif pole == "data":
                    if wart.strip() not in ['','-  -']:
                        if not rsglobal.SprawdzCzyToData(wart.strip()):
                            stat="BL DATA"
                            dane.append(stat)
                    if wart.strip() in ['','-  -']:
                        wartosci[i]="NULL"

                elif pole == "izba_celna":
                    if wart == "":
                        stat="Prosz wypeni pole \"Izba Celna\""
                        dane.append(stat)
                    else:
                        izb  = "SELECT kod from rs_intrastat_izby_celne"
                        izb += " WHERE kod ='"+wart+"';"
                        stat,dane,dump,dump=self.PolSQL.Execute(izb,3)
                        if dane==[]:
                            stat="Bdny numer izby celnej: "+wart
                            dane.append(stat)                            
    # Update waciwy
    dane = []
    if stat=='OK':        
        sql = "UPDATE rs_intrastat SET "
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ["izba_celna","wypelniajacy","telefon","fax","email","miasto",
                        "nr_identyfikacyjny","email_zwrotny","data","nr_wlasny_intr"]:
                if wart == "NULL" or "":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"='"+str(wart)+"',"
            elif pole in ['liczba_pozycji','wartosc_fakturowa','wartosc_statystyczna','liczyc_wartosc_stat']:
                sql += pole+"="+str(wart)+","
        sql = sql.strip(',')
        sql += ""+Filtr+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'Bd modyfikacji danych deklaracji: '+stat
            dane.append(stat)
                    
                
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if (Funkcja in [5,3,1])and stat=='OK':
    dane = []   
    sql = "SELECT * FROM rs_intrastat "
    sql +="" +Filtr+";"
    
    # pobranie danych
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    
    # pobranie danych do opisow
    if stat=='OK':
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # rodzaj deklaracji
        if ((self.oddzial_id,'011360') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sq2 = "SELECT opis FROM rs_intrastat_rodzaje_deklaracji "
            sq2+= "WHERE kod='"+tr.GetVal(0,"rodzaj_deklaracji")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(sq2 ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        # izba celna
        if ((self.oddzial_id,'011400') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_intrastat_izby_celne \
                                                    WHERE kod='"+tr.GetVal(0,"izba_celna")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')               