# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_intrastat_klucz.py
# Purpose:     insert/update deklaracje intrastat
# Author:      Marcin Grzda
# Created:     2007/11/30
# RCS-ID:      $Id: fs_intrastat_klucz.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
# 2010-10-20   Marcin Natkaski (refaktoryzacja kodu)
#-----------------------------------------------------------------------------

RokS = klucze[0]
MiesiacS = klucze[1]
NrZgloszeniaS = klucze[2]
NrWersjiS = klucze[3]
RodzajDeklaracjiS = klucze[4]
RodzajWydrukuS = klucze[5]
Fun=klucze[-1]

stat = "OK"
dane = []

if Fun in [1,2] and not (((self.oddzial_id,'036013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
    stat='UPR INS'
    dane.append(stat)
    
    
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- SPRAWDZANIE DANYCH
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    for i in xrange(len(pola)):
        pole=pola[i]
        wart=wartosci[i]
        if pole=='rok':
            RokS=wart
            if len(wart)<>2:
                stat='BL ROK'
                dane.append(stat)
            else:
                try:
                    rok=int(wart)
                except:
                    stat='BL ROK'
                    dane.append(stat)
            
        elif pole=='miesiac' and stat=='OK':
            if wart not in ['01','02','03','04','05','06','07','08','09','10','11','12']:
                stat='BL MIES'
                dane.append(stat)
            else:
                MiesiacS=wart
        elif pole=='nr_zgloszenia':
            NrZgloszeniaS=wart
        elif pole=='nr_wersji':
            NrWersjiS=wart
        elif pole=='rodzaj_deklaracji':
            RodzajDeklaracjiS=wart
        elif pole=='wywoz_przywoz':
            if wart not in ['W','P']:
                stat='BL RODZ DRUK'
                dane.append(stat)
            else:
                RodzajWydrukuS=wart
                
    
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

    if stat == "OK" and Fun in [2,1]:
        sql = "INSERT INTO rs_intrastat"
        PolaN="firma_id"
        WartosciN="'"+self.firma_id+"'"
        Select="SELECT wypelniajacy,telefon,fax,email,nr_identyfikacyjny,email_zwrotny,miasto"
        Select+=" FROM rs_intrastat WHERE firma_id='"+self.firma_id+"'"
        Select+=" ORDER BY z_czas desc LIMIT 1"        
        st,d,dump,dump=self.PolSQL.Execute(Select,3)
        if st=='OK':
            if len(d)>0:
                Wypelniajacy=rsglobal.Dekoduj(d[0][0])
                if Wypelniajacy<>'None':
                    PolaN+=",wypelniajacy"
                    WartosciN+=",'"+Wypelniajacy+"'"
                Telefon=rsglobal.Dekoduj(d[0][1])
                if Telefon<>'None':
                    PolaN+=",telefon"
                    WartosciN+=",'"+Telefon+"'"
                Fax=rsglobal.Dekoduj(d[0][2])
                if Fax<>'None':
                    PolaN+=",fax"
                    WartosciN+=",'"+Fax+"'"
                Email=rsglobal.Dekoduj(d[0][3])
                if Email<>'None':
                    PolaN+=",email"
                    WartosciN+=",'"+Email+"'"
                NrID=rsglobal.Dekoduj(d[0][4])
                if NrID<>'None':
                    PolaN+=",nr_identyfikacyjny"
                    WartosciN+=",'"+NrID+"'"
                EmailZwrotny=rsglobal.Dekoduj(d[0][5])
                if EmailZwrotny<>'None':
                    PolaN+=",email_zwrotny"
                    WartosciN+=",'"+EmailZwrotny+"'"
                Miasto=rsglobal.Dekoduj(d[0][6])
                if Miasto<>'None':
                    PolaN+=",miasto"
                    WartosciN+=",'"+Miasto+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['rok','miesiac','nr_zgloszenia','nr_wersji','rodzaj_deklaracji','wywoz_przywoz']:
                PolaN+=","+pole
                WartosciN += ",'"+str(wart)+"'"
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)  
             
        
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [1,2,5] and stat=='OK':
    Select="Select * FROM rs_intrastat WHERE firma_id='"+self.firma_id+"'"
    Select+=" AND rok='"+RokS+"' AND miesiac='"+MiesiacS+"' AND nr_zgloszenia='"+NrZgloszeniaS+"'"
    Select+=" AND nr_wersji='"+NrWersjiS+"' AND rodzaj_deklaracji='"+RodzajDeklaracjiS+"' AND wywoz_przywoz='"+RodzajWydrukuS+"'"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat='Bd zapytania pobierajcego dane '+stat  