# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_intrastat_pozycje_dane.py
# Purpose:     wczytuje i edytuje dane pozycji deklaracji intrastat
# Author:      Marcin Grzda, 
# Created:     2007/11/29
# RCS-ID:      $Id: fs_intrastat_pozycje_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
# 2010/10/20   Marcin Natkaski (refaktoryzacja kodu)
# 2016-04-26   Piotr Bender (9619) refaktoryzacja
#-----------------------------------------------------------------------------

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Rok': [1, 2, 3, 4, 5, 10], 'Miesiac': [1, 2, 3, 4, 5, 10], 'NrZgloszenia': [1, 2, 3, 4, 5, 10],
             'NrWersji': [1, 2, 3, 4, 5, 10], 'RodzajDeklaracji': [1, 2, 3, 4, 5, 10],
             'RodzajWydruku': [1, 2, 3, 4, 5, 10], 'NrPoz': [1, 2, 3, 4, 5, 10]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)

    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_zobowiazanie_ratalne z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if stat == 'OK':
        if Funkcja in [1, 2, 3, 4, 5, 10]:
            Rok = rsglobal.Dekoduj(klucze['Rok'])
            Miesiac = rsglobal.Dekoduj(klucze['Miesiac'])
            NrZgloszenia = rsglobal.Dekoduj(klucze['NrZgloszenia'])
            NrWersji = rsglobal.Dekoduj(klucze['NrWersji'])
            RodzajDeklaracji = rsglobal.Dekoduj(klucze['RodzajDeklaracji'])
            RodzajWydruku = rsglobal.Dekoduj(klucze['RodzajWydruku'])
            NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

UprEdycja = ((self.oddzial_id, '036022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns = ((self.oddzial_id, '036022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

Filtr = "WHERE firma_id='"+self.firma_id+"' AND rok='"+Rok+"' AND miesiac='"+Miesiac+"'"
Filtr += "AND nr_zgloszenia='"+NrZgloszenia+"' AND nr_wersji='"+NrWersji+"'"
Filtr += " AND rodzaj_deklaracji='"+RodzajDeklaracji+"' AND wywoz_przywoz='"+RodzajWydruku+"'"

#---Pobieranie numeru pozycji---------------------------------------------------

if stat == 'OK' and Funkcja == 10: 
    sql = "SELECT nr_poz FROM rs_intrastat_pozycje " + Filtr + " ORDER BY nr_poz DESC LIMIT 1;"
    rsglobal.ZapiszDoLogow(sql, 5)
    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
    
    if stat == 'OK':
        if len(d) == 0:
            numer = 1
        else:
            numer = d[0][0] + 1            
        dane = [[numer]]
    else:
        stat = 'Bdy pobierania numeru pozycji'+stat
        dane.append(stat)
        

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---SPRAWDZAM DANE
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 2, 3, 4]:
    sql = "SELECT * FROM rs_intrastat "+Filtr+";"
    stat, dane_wyn, dump, dump = self.PolSQL.Execute(sql, 3)
    if len(dane_wyn) == 0:
        stat = "BL KLUCZ"
        dane.append(stat)
            
    if stat <> "OK":
        stat = "Bd zapytania pobierajcego dane do sprawdzenia "+stat
        dane.append(stat)

    else:
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole == "nr_poz" and (Funkcja in [1,2]):
                if wart < 1:
                    stat = 'BL NR POZ'
                    dane.append(stat)
                else:
                    sql = "SELECT nr_poz FROM rs_intrastat_pozycje"+Filtr 
                    sql += " AND nr_poz="+str(wart)
                    stat, d, dump, dump = self.PolSQL.Execute(sql,3)
                    if stat == 'OK':
                        if len(d) > 0:
                            stat = 'BL NR POZYCJI'
                            dane.append(stat)
                    else:
                        stat = 'Bdy w zapytaniu pobierajcym numer pozycji '+stat
                        dane.append(stat)
#----------kraj wysylki --------------------------------------------------------
            elif pole == "kraj_wysylki":
                Select = "SELECT * FROM rs_kraje WHERE kraj='"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(Select, 3)
                if stat == 'OK':
                    if len(d) < 1:
                        stat = 'BL KRAJ WYS'
                        dane.append(stat)
                else:
                    stat = 'Bdy w zapytaniu pobierajcym kraj wysyki '+stat
                    dane.append(stat)
#---------- kraj pochodzenia ---------------------------------------------------
            elif pole == "kraj_pochodz":
                Select = "SELECT * FROM rs_kraje WHERE kraj='"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(Select, 3)
                if stat == 'OK':
                    if len(d) < 1:
                        stat = 'BL KRAJ POCH'
                        dane.append(stat)
                else:
                    stat = 'Bdy w pobieraniu kraju pochodzenia'+stat
                    dane.append(stat)
#---------- warunki dostawy ----------------------------------------------------
            elif pole == "warunki_dostawy":
                Select = "SELECT * FROM rs_intrastat_warunki_dostawy WHERE kod='"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(Select, 3)
                if stat == 'OK':
                    if len(d) < 1:
                        stat = 'BL WAR DOST'
                        dane.append(stat)
                else:
                    stat = 'Bdy w pobieraniu warunkw dostawy '+stat
                    dane.append(stat)                
#-----------rodzaj transportu---------------------------------------------------
            elif pole == "rodzaj_transportu":
                Select = "SELECT * FROM rs_intrastat_rodzaje_transportu WHERE kod='"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(Select,3)
                if stat == 'OK':
                    if len(d) < 1:
                        stat = 'BL RODZ TRANS'
                        dane.append(stat)
                else:
                    stat = 'Bdy w pobieraniu rodzaju transportu '+stat
                    dane.append(stat)
#------------kod towaru---------------------------------------------------------
            elif pole == "kod_towaru":
                Select = "SELECT * FROM rs_kody_intrastat WHERE kod='"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(Select, 3)
                if stat == 'OK':
                    if len(d) < 1:
                        stat = 'BL RODZ TOWAR'
                        dane.append(stat)
                else:
                    stat = 'Bdy w pobieraniu kodu towaru '+stat
                    dane.append(stat) 
                             
            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#----  INSERT DANYCH (1- z pobraniem, 2- bez pobrania)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
    
if stat == 'OK' and Funkcja in [1,2]:
    if not UprIns:
        stat = 'BR INS'
        dane.append(stat)
    if stat == 'OK':
        sql = "INSERT INTO rs_intrastat_pozycje"
        PolaN = "firma_id,rok,miesiac,nr_zgloszenia,nr_wersji,rodzaj_deklaracji,wywoz_przywoz"
        WartosciN = "'"+self.firma_id+"','"+Rok+"','"+Miesiac+"','"+NrZgloszenia+"','"+NrWersji+"'"
        WartosciN += ",'"+RodzajDeklaracji+"','"+RodzajWydruku+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['kraj_wysylki', 'kraj_pochodz', 'kod_towaru', 'warunki_dostawy', 'rodzaj_transportu']:
                PolaN += ","+pole
                if wart.strip() == '':
                    WartosciN += ",NULL"
                else:
                    WartosciN += ",'"+str(wart)+"'"
            elif pole in ['nr_poz', 'masa_netto', 'ilosc', 'wartosc_fakturowa', 'wartosc_statystyczna']:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                NrPoz = wart
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        if stat <> 'OK':
            stat = 'Bedy przy zapytaniu dodajcym pozycje deklaracji '+stat
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)-----------------------
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [3,4]:
    if not UprIns:
        stat = 'BR INS'
        dane.append(stat)
    if stat == 'OK':
        dane = []
        sql = "UPDATE rs_intrastat_pozycje SET "        
        Filtr += " AND nr_poz="+str(NrPoz)
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole in ['kraj_wysylki', 'kraj_pochodz', 'kod_towaru', 'warunki_dostawy', 'rodzaj_transportu']:
                if wart == "NULL":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"='"+str(wart)+"',"
            elif pole in ['masa_netto', 'ilosc', 'wartosc_fakturowa', 'wartosc_statystyczna']:
                sql += pole+"="+str(wart)+","
        sql = sql.strip(',')
        sql += ""+Filtr+";"
        
        stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        if stat <> 'OK':
            stat = 'Bd uaktualnienia danych'+stat
            dane.append(stat)
                    
                
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and (Funkcja in [5, 3, 1]):
    sql = "SELECT * FROM rs_intrastat_pozycje "        
    sql += Filtr+"AND nr_poz='"+str(NrPoz)+"';"
    
    # pobranie danych
    stat, dane, wyn1, tr = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd zapytania pobierajcego dane'+stat
        dane.append(stat)
        
    #pobranie danych do opisow    
    elif stat == 'OK' and len(dane) > 0:
        tr = rssql.RSTableRowset(dane, wyn1)
        
        #kraj wysylki
        if ((self.oddzial_id, '011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kraje WHERE kraj='"+tr.GetVal(0, "kraj_wysylki")+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #kraj pochodz
        if ((self.oddzial_id, '011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kraje WHERE kraj='"+tr.GetVal(0, "kraj_pochodz")+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #warunki dostawy
        if ((self.oddzial_id, '011380') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_intrastat_warunki_dostawy WHERE kod='"+tr.GetVal(0,"warunki_dostawy")+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.') 
        
        #rodzaj transportu
        if ((self.oddzial_id, '011390') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_intrastat_rodzaje_transportu WHERE kod='"+tr.GetVal(0, "rodzaj_transportu")+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')                