# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:        fs_inwentaryzacja_srodki_trwale.py
# Purpose:     wczytuje/usuwa dane z inwentaryzacji srodkow trwalych
# Author:      Dariusz Boduch
# Created:     2010/04/19
# RCS-ID:      $Id: fs_inwentaryzacja_srodki_trwale.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
# 2017-03-28 Konrad Opieka    (10403) Refaktoryzacja
# 2024-02-07 Wojciech Skowron (13680) Nowy widok pozycji w inwentaryzacji rodkw trwaych
# 2024-02-19 Wojciech Skowron (13699) Inwentaryzacja 'szczegolowa' przy zamykaniu i otwieraniu
# 2024-02-28 Wojciech Skowron (13682) Lista pozycji do wyjanienia (7, 10)

stat='OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'NrId':[6, 7, 8, 9, 10], 'GrupaF':[5, 6, 7, 8, 9, 10], 'TypF':[5, 6, 7, 8, 9, 10],'UzytkownikF':[5, 6, 7, 8, 9, 10],
           'DostawcaF':[5, 6, 7, 8, 9, 10], 'MiejsceF':[5, 6, 7, 8, 9, 10],'DataOdF':[5, 6, 7, 8, 9, 10], 'DataDoF':[5, 6, 7, 8, 9, 10]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat='Uwaga: wywoanie funkcji fs_inwentaryzacja_srodki_trwale z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [6, 7, 8, 9, 10]:
        NrId = klucze['NrId']
    if Funkcja in [5, 6, 7, 8, 9, 10]:
        GrupaF = klucze['GrupaF']
        TypF = klucze['TypF']
        UzytkownikF = klucze['UzytkownikF']
        DostawcaF = klucze['DostawcaF']
        MiejsceF = klucze['MiejsceF']
        DataOdF = klucze['DataOdF']
        DataDoF = klucze['DataDoF']

dane = []
wyn1 = []
wyn2 = []

UprUsuwanie   = ((self.oddzial_id, '174514') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprZamykanie  = ((self.oddzial_id, '174516') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprOtwieranie = ((self.oddzial_id, '174517') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-----------------------------------------------------------------------------------------------------------------------
#--- Sprawdzenie danych z klucza
#-----------------------------------------------------------------------------------------------------------------------

if DataOdF != '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdF):
        stat = 'BL DATAOD'
        
if DataDoF != '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoF):
        stat = 'BL DATADO'

if (DataOdF != '    -  -  ') and (DataDoF != '    -  -  '):
    if DataOdF > DataDoF:
        stat = 'BL ZAKR DAT'

if stat=='OK':
    if GrupaF.strip() != '':
        sql = "SELECT kod FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+GrupaF+"';"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'BL SEL GR'
            wart.append(stat)
        else:
            if len(d)==0:
                stat = 'BL GRUPA'
                dane.append(stat)
        
    if stat=='OK':
        if TypF.strip() != '':
            sql = "SELECT kod FROM rs_typy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+TypF+"';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'BL SEL TYP'
                dane.append(stat)
            else:
                if len(d)==0:
                    stat = 'BL TYP'
                    dane.append(stat)
            
    if stat=='OK':
        if UzytkownikF.strip() != '':
            sql = "SELECT kontrahent_id FROM rs_kontrahenci "
            sql+= "WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+UzytkownikF+"';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'BL SEL UZYT'
                dane.append(stat)
            else:
                if len(d)==0:
                    stat = 'BL UZYT'
                    dane.append(stat)
    
    if stat=='OK':
        if DostawcaF.strip() != '':
            sql = "SELECT kontrahent_id FROM rs_kontrahenci "
            sql+= "WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DostawcaF+"';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'BL SEL DOST'
                dane.append(stat)
            else:
                if len(d)==0:
                    stat = 'BL DOST'
                    dane.append(stat)
    
    if stat == 'OK':
        if MiejsceF.strip() != '':
            sql = "SELECT kod FROM rs_miejsca_uzytkowania WHERE firma_id='"+self.firma_id+"' AND kod='"+MiejsceF+"';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'BL SEL MIEJ'
                dane.append(stat)
            else:
                if len(d)==0:
                    stat = 'BL MIEJ'
                    dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#--- POBRANIE DANYCH DO RAPORTU
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==9 and stat=='OK':
    SQL = "SELECT COALESCE(przewodniczacy,'...........................'),"
    SQL+= "COALESCE(czlonek1,'................................'),COALESCE(czlonek2,'................................'),"
    SQL+= "COALESCE(osoba1,'................................'),COALESCE(osoba2,'................................'), "
    SQL+= "COALESCE(osoba3,'................................'),data_inwentaryzacji "
    SQL+= "FROM rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
    stat, dane, wyn1, tr = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'BL SEL RAP'
        dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==6 and stat=='OK':
    if not UprUsuwanie:
        stat = 'UPR DEL'
        dane.append(stat)
    
    if stat=='OK':
        sql = "SELECT stan FROM rs_srodki_trwale_inwentaryzacja "
        sql+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
        stat, dane, wyn1, tr = self.PolSQL.Execute(sql, 3)
        if len(dane)==0:
            stat = 'BR DEL'
            dane.append(stat)
        else:
            if dane[0][0]=='Z':
                stat = 'ZAMK DEL'
                dane.append(stat)                
            else:
                SQL = "DELETE FROM rs_srodki_trwale_inwentaryzacja "
                SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
                SQL+= "DELETE FROM rs_srodki_trwale_inwentaryzacja_pozycje "
                SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
                if stat != 'OK':
                    stat = 'Bd przy usuwaniu danych: '+stat
                    dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#---   ZAMKNICIE INWENTARYZACJI (7)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==7 and stat=='OK':
    if not UprZamykanie:
        stat = 'UPR ZAM'
        dane.append(stat)
    if stat=='OK':
        #WS 2024-02-12
        SQL = "UPDATE rs_srodki_trwale_inwentaryzacja SET stan=(CASE WHEN stan='W' THEN 'G' ELSE 'Z' END) "
        # SQL = "UPDATE rs_srodki_trwale_inwentaryzacja SET stan='Z' "
        SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd zamykania inwentaryzacji: '+stat
            dane.append(stat)
        else:
            #WS 2024-02-19
            SQL = "SELECT stan, szczegolowa FROM rs_srodki_trwale_inwentaryzacja  "
            SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
            stat, d_nagl, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd zmiany stanu inwentaryzacji: '+stat
                dane.append(stat)
            elif d_nagl[0][0] == 'Z' and d_nagl[0][1] is True:
                #WS 2024-02-12 - sprawdzenie czy istniej niezatwierdzone pozycje przy przejciu do stanu Z
                SQL = "SELECT BOOL_AND(COALESCE(czy_zatw,FALSE)) FROM rs_srodki_trwale_inwentaryzacja_pozycje  "
                SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
                stat, d_zatw, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd sprawdzania pozycji inwentaryzacji: '+stat
                    dane.append(stat)
                elif d_zatw[0][0] is False:  # ktra pozycja niezatwierdzona
                    stat = 'NIE ZATW ZAMK'
                    dane.append(stat)
                else:
                    SQL = "SELECT p.srodek_id, "
                    SQL+= " COALESCE(p.miejsce_uzytkowania_id, (SELECT DISTINCT ON (firma_id, srodek_id) miejsce_id FROM rs_srodki_trwale_miejsca_uzytkowania WHERE data_od<n.data_inwentaryzacji AND firma_id=p.firma_id AND srodek_id=p.srodek_id ORDER BY firma_id, srodek_id, data_od DESC)), "
                    SQL+= " p.nowe_miejsce_uzytkowania, n.data_inwentaryzacji"
                    SQL+= " FROM rs_srodki_trwale_inwentaryzacja_pozycje p "
                    SQL+= " JOIN rs_srodki_trwale_inwentaryzacja n USING (firma_id, nr_id) "
                    SQL+= " WHERE p.firma_id='"+self.firma_id+"' AND p.nr_id="+str(NrId)
                    SQL+= " AND p.nowe_miejsce_uzytkowania IS NOT NULL AND p.srodek_id IS NOT NULL;"
                    stat, d_poz, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':
                        stat = 'Bd pobrania danych pozycji inwentaryzacji: '+stat
                        dane.append(stat)
                    else:
                        UPDINS = ""
                        args = []
                        for poz in d_poz:
                            srodek_id = poz[0]
                            miejsce_uzytkowania_id = poz[1]
                            nowe_miejsce_uzytkowania = poz[2]
                            data_inwentaryzacji = poz[3]

                            #WS 2024-02-19 - sprawdzenie czy istnieje miejsce z dat pniejsz ni data inwentaryzacji,
                            # jeli tak to blokada
                            SQL = "SELECT 1 FROM rs_srodki_trwale_miejsca_uzytkowania "
                            SQL+= " WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+srodek_id+"' "
                            SQL+= " AND GREATEST(data_od, data_do, przekazanie_kiedy)>='"+data_inwentaryzacji+"';"
                            stat, d_miejsca, dump, dump = self.PolSQL.Execute(SQL, 3)
                            if stat != 'OK':
                                stat = 'Bd sprawdzania miejsc uytkowania: '+stat
                                dane.append(stat)
                                break
                            elif len(d_miejsca) > 0:
                                stat = "rodek '"+srodek_id.strip()+"' ma wprowadzone miejsce uytkowania z dat pniejsz ni data inwentaryzacji"
                                dane.append(stat)
                                break
                            else:
                                #WS 2024-02-12 - utworzenie nowego wiersza i aktualizacja poprzedniego
                                # w rs_srodki_trwale_miejsca_uzytkowania
                                UPDINS += """UPDATE rs_srodki_trwale_miejsca_uzytkowania 
                                             SET data_do=%s::DATE-INTERVAL '1 DAY', przekazanie_miejsce=%s, przekazanie_kiedy=NOW(), przekazanie_kto=%s
                                             WHERE (firma_id, miejsce_id, srodek_id)=
                                                   (SELECT firma_id, miejsce_id, srodek_id FROM rs_srodki_trwale_miejsca_uzytkowania WHERE firma_id=%s AND miejsce_id=%s AND srodek_id=%s AND data_do IS NULL ORDER BY data_od DESC LIMIT 1);
                                             INSERT INTO rs_srodki_trwale_miejsca_uzytkowania 
                                             (firma_id, miejsce_id, srodek_id, data_od)
                                             VALUES (%s, %s, %s, %s);"""
                                args.extend([data_inwentaryzacji, nowe_miejsce_uzytkowania, self.operator_id,
                                             self.firma_id, miejsce_uzytkowania_id, srodek_id,
                                             self.firma_id, nowe_miejsce_uzytkowania, srodek_id, data_inwentaryzacji])

                        if stat == 'OK' and UPDINS != "":
                            stat, dump, dump, dump = self.PolSQL.Execute(UPDINS, 1, args)
                            if stat != 'OK':
                                stat = "Bd przy aktualizacji miejsca rodka trwaego: "+stat
                                dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#---   OTWARCIE INWENTARYZACJI (8)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 8 and stat=='OK':
    if not UprOtwieranie:
        stat = 'UPR OTW'
        dane.append(stat)
        
    if stat=='OK':
        #WS 2024-02-19
        SQL = "UPDATE rs_srodki_trwale_inwentaryzacja SET stan=(CASE WHEN stan='Z' THEN 'G' ELSE 'W' END) "
        SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+" AND NOT (stan='Z' AND szczegolowa IS TRUE);"
        # SQL = "UPDATE rs_srodki_trwale_inwentaryzacja SET stan='W' "
        # SQL+= "WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd otwierania inwentaryzacji: '+stat


#-----------------------------------------------------------------------------------------------------------------------
#---   LISTA POZYCJI DO WYJANIENIA (10)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja in (7, 10) and stat=='OK':
    #WS 2024-02-28 - lista pozycji do wyjanienia
    SQL = "(SELECT nr_poz, uwagi, NULL AS srodek_id, NULL AS miejsce_uzytkowania_id, NULL AS nowe_miejsce_uzytkowania"
    SQL+= " FROM rs_srodki_trwale_inwentaryzacja_pozycje"
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+" AND srodek_id IS NULL)"
    SQL+= " UNION"
    SQL+= " (SELECT nr_poz, uwagi, srodek_id, miejsce_uzytkowania_id||' - '||ms.opis, nowe_miejsce_uzytkowania||' - '||mn.opis"
    SQL+= " FROM rs_srodki_trwale_inwentaryzacja_pozycje p"
    SQL+= " JOIN rs_miejsca_uzytkowania ms ON(p.firma_id=ms.firma_id AND p.miejsce_uzytkowania_id=ms.kod) "
    SQL+= " JOIN rs_miejsca_uzytkowania mn ON(p.firma_id=mn.firma_id AND p.miejsce_uzytkowania_id=mn.kod) "
    SQL+= " WHERE p.firma_id='"+self.firma_id+"' AND p.nr_id="+str(NrId)+" AND p.miejsce_uzytkowania_id != p.nowe_miejsce_uzytkowania)"
    SQL+= " UNION"
    SQL+= " (SELECT nr_poz, uwagi, srodek_id, miejsce_uzytkowania_id, nowe_miejsce_uzytkowania"
    SQL+= " FROM rs_srodki_trwale_inwentaryzacja_pozycje"
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+" AND miejsce_uzytkowania_id IS NULL AND nowe_miejsce_uzytkowania IS NULL)"
    SQL+= " ORDER BY nr_poz;"
    rsglobal.ZapiszDoLogow('!!!!!!!!!!!!!!!!!!!'+SQL)
    stat, wyn2, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych pozycji: '+stat
        dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#--- POBRANIE DANYCH (5 -select, 6 -delete, 7 - zamknij 8 - otwrz
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja in [5,6,7,8] and stat=='OK':
    #WS 2024-02-19 - szczegolowa
    # pobranie danych o dokumentach
    SQL = "SELECT i.stan,i.data_inwentaryzacji,COALESCE(i.grupa||' - '||g.opis,''),"
    SQL+= "COALESCE(i.typ_srodka||' - '||t.opis,''),COALESCE(i.miejsce_uzytkowania_id||' - '||m.opis,''),"
    SQL+= "COALESCE(i.uzytkownik_id||' - '||u.nazwa,''), COALESCE(i.dostawca_id||' - '||d.nazwa,''), nr_id, szczegolowa"
    SQL+= " FROM rs_srodki_trwale_inwentaryzacja i "
    SQL+= "LEFT OUTER JOIN rs_grupy_srodkow_trwalych g ON(i.firma_id=g.firma_id AND i.grupa=g.kod) "
    SQL+= "LEFT OUTER JOIN rs_typy_srodkow_trwalych t ON(i.firma_id=t.firma_id AND i.typ_srodka=t.kod) "
    SQL+= "LEFT OUTER JOIN rs_miejsca_uzytkowania m ON(i.firma_id=m.firma_id AND i.miejsce_uzytkowania_id=m.kod) "
    SQL+= "LEFT OUTER JOIN rs_kontrahenci u ON(i.firma_id=u.firma_id AND i.uzytkownik_id=u.kontrahent_id) "
    SQL+= "LEFT OUTER JOIN rs_kontrahenci d ON(i.firma_id=d.firma_id AND i.dostawca_id=d.kontrahent_id) "
    SQL+= "WHERE i.firma_id='"+self.firma_id+"' "
    if GrupaF != '':
        SQL+= "AND i.grupa='"+GrupaF+"' "
    if TypF != '':
        SQL+= "AND i.typ_srodka='"+TypF+"' "
    if UzytkownikF != '':
        SQL+= "AND i.uzytkownik_id='"+UzytkownikF+"' "
    if DostawcaF != '':
        SQL+= "AND i.dostawca_id='"+DostawcaF+"' "
    if MiejsceF != '':
        SQL+= "AND i.miejsce_uzytkowania_id='"+MiejsceF+"' "
    if DataOdF != '    -  -  ':
        SQL+= "AND i.data_inwentaryzacji>='"+DataOdF+"' "
    if DataDoF != '    -  -  ':
        SQL+= "AND i.data_inwentaryzacji<='"+DataDoF+"' "
    SQL+= "ORDER BY i.nr_id, i.data_inwentaryzacji,i.grupa,i.typ_srodka;"
    stat, dane, wyn1, tr = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych '+stat
        dane.append(stat)