# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_inwentaryzacja_srodki_trwale_klucz.py
# Purpose:     dodaje/edytuje klucz inwentaryzacji srodkow trwalych
# Author:      Dariusz Boduch
# Created:     2010/04/20
# RCS-ID:      $Id: fs_inwentaryzacja_srodki_trwale_klucz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2017-03-22 Konrad Opieka    (10403) Refaktoryzacja
# 2024-02-08 Wojciech Skowron (13680) Wpisywanie nr_poz przy dodawaniu pozycji inwentaryzacji
# 2024-02-19 Wojciech Skowron (13699) Wpisywanie szczegolowa przy dodawaniu inwentaryzacji jeli s uprawnienia w firmie

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'GrupaF':[1], 'TypF':[1], 'UzytkownikF':[1], 'DostawcaF':[1], 'MiejsceF':[1], 'DataOdF':[1], 'DataDoF':[1],
           'Grupa':[1], 'Typ':[1], 'Uzytkownik':[1], 'Dostawca':[1], 'Miejsce':[1], 'Data':[1], 'Przewod':[1,2],
           'Czlonek1':[1,2], 'Czlonek2':[1,2], 'Osoba1':[1,2], 'Osoba2':[1,2], 'Osoba3':[1,2], 'NrId':[2,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga: wywoanie funkcji fs_inwentaryzacja_srodki_trwale_klucz z numerem '+str(Funkcja)
        stat+= ' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1]:
        GrupaF      = klucze['GrupaF']
        TypF        = klucze['TypF']
        UzytkownikF = klucze['UzytkownikF']
        DostawcaF   = klucze['DostawcaF']
        MiejsceF    = klucze['MiejsceF']
        DataOdF     = klucze['DataOdF']
        DataDoF     = klucze['DataDoF']
        Grupa       = klucze['Grupa']
        Typ         = klucze['Typ']
        Uzytkownik  = klucze['Uzytkownik']
        Dostawca    = klucze['Dostawca']
        Miejsce     = klucze['Miejsce']
        Data        = klucze['Data']
    if Funkcja in [1,2]:
        Przewod     = klucze['Przewod']
        Czlonek1    = klucze['Czlonek1']
        Czlonek2    = klucze['Czlonek2']
        Osoba1      = klucze['Osoba1']
        Osoba2      = klucze['Osoba2']
        Osoba3      = klucze['Osoba3']
    if Funkcja in [2,5]:
        NrId        = klucze['NrId']

wart = []
if Funkcja==5:
    self.NowaInwentId = NrId
else:
    self.NowaInwentId = 'x'

UprDodawanie=(((self.oddzial_id,'174513') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#Fun: 1- dodawanie, 2-edycja, 5-pobranie danych
#-------------------------------------------------------------------------------
#dodawanie nowego spisu
#-------------------------------------------------------------------------------

if Funkcja in [1,2]:
    if not UprDodawanie:
        stat='BR UPR DOD'
        wart.append(stat)

if Funkcja==1 and stat=='OK':
    if stat=='OK':
        Szczegolowa = False  #WS 2024-02-19

        if Data=='    -  -  ':
            stat='BR DATA'
            wart.append(stat)
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(Data):
                stat='BL DATA'
                wart.append(stat)
        if stat=='OK':
            if Grupa.strip() != '':
                SQL = "SELECT kod FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+Grupa+"';"
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat='BL SEL GR'
                    wart.append(stat)
                elif len(d)==0:
                    stat='BL GRUPA'
                    wart.append(stat)
        if stat=='OK':
            if Typ.strip() != '':
                SQL = "SELECT kod FROM rs_typy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+Typ+"';"
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat='BL SEL TYP'
                    wart.append(stat)
                elif len(d)==0:
                  stat='BL TYP'
                  wart.append(stat)
        if stat=='OK':
            if Uzytkownik.strip() != '':
                SQL = "SELECT kontrahent_id FROM rs_kontrahenci "
                SQL+= "WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Uzytkownik+"';"
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat='BL SEL UZYT'
                    wart.append(stat)
                elif len(d)==0:
                    stat='BL UZYT'
                    wart.append(stat)
        if stat=='OK':
            if Dostawca.strip() != '':
                SQL = "SELECT kontrahent_id FROM rs_kontrahenci "
                SQL+= "WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Dostawca+"';"
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat='BL SEL DOST'
                    wart.append(stat)
                elif len(d)==0:
                    stat='BL DOST'
                    wart.append(stat)
        if stat=='OK':
            if Miejsce.strip() != '':
                SQL = "SELECT kod FROM rs_miejsca_uzytkowania WHERE firma_id='"+self.firma_id+"' AND kod='"+Miejsce+"';"
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat='BL SEL MIEJ'
                    wart.append(stat)
                elif len(d)==0:
                    stat='BL MIEJ'
                    wart.append(stat)
        #WS 2024-02-19 - sprawdzenie czy s uprawnienia do szczegowej inwentaryzacji w jakiejkolwiek grupie w firmie
        if stat=='OK':
            SQL = "SELECT 1 FROM rs_grupa_menu WHERE menu_id='808000' AND firma_id='"+self.firma_id+"';"
            stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat='BL SEL UPR GRUPA'
                wart.append(stat)
            elif len(d) > 0:
                Szczegolowa = True
                       
    if stat=='OK':
        #sprawdzenie istnienia spisu z natury
        SQL = "SELECT stan FROM rs_srodki_trwale_inwentaryzacja "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND data_inwentaryzacji='"+Data+"' "
        if Grupa.strip() != '':
            SQL+=" AND grupa='"+Grupa+"' "
        else:
            SQL+=" AND grupa IS NULL"
        if Typ.strip() != '':
            SQL+=" AND typ_srodka='"+Typ+"' "
        else:
            SQL+=" AND typ_srodka IS NULL"
        if Uzytkownik.strip() != '':
            SQL+=" AND uzytkownik_id='"+Uzytkownik+"' "
        else:
            SQL+=" AND uzytkownik_id IS NULL"
        if Miejsce.strip() != '':
            SQL+=" AND miejsce_uzytkowania_id='"+Miejsce+"' "
        else:
            SQL+=" AND miejsce_uzytkowania_id IS NULL"
        if Dostawca.strip() != '':
            SQL+=" AND dostawca_id='"+Dostawca+"';"
        else:
            SQL+=" AND dostawca_id IS NULL;"
        ok, wyn, wyn1, tr = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat='BL SEL INWENT'
            wart.append(stat)
        elif len(wyn) != 0:
            stat='INWENT ISTN'
            wart.append(stat)
        
        if stat=='OK':
            #pobranie danych - jesli sa, to tworzony jest spis
            #sprawdzenie istnienia spisu z natury
            Select = "SELECT s.srodek_id,s.grupa,s.typ_srodka,s.uzytkownik_id, s.dostawca_id, sm.miejsce_id "
            Select+= "FROM rs_srodki_trwale s  "
            Select+= "LEFT OUTER JOIN rs_srodki_trwale_miejsca_uzytkowania sm ON(s.firma_id=sm.firma_id AND s.srodek_id=sm.srodek_id) "
            Select+= "WHERE s.firma_id='"+self.firma_id+"' "
            if Grupa.strip() != '':
                Select+=" AND s.grupa='"+Grupa+"' "
            if Typ.strip() != '':
                Select+=" AND s.typ_srodka='"+Typ+"' "
            if Uzytkownik.strip() != '':
                Select+=" AND s.uzytkownik_id='"+Uzytkownik+"' "
            if Miejsce.strip() != '':
                Select+=" AND sm.miejsce_id='"+Miejsce+"' "
            if Dostawca.strip() != '':
                Select+=" AND s.dostawca_id='"+Dostawca+"' "
            Select+= "AND (sm.data_od<='"+Data+"' OR sm.data_od IS NULL) AND (sm.data_do>='"+Data+"' OR sm.data_do IS NULL) "
            Select+= "AND (data_sprzedazy IS NULL or data_sprzedazy > '"+Data+"') "
            Select+= "AND (data_likwidacji IS NULL or data_likwidacji > '"+Data+"');"
            stat, wyn, wyn1, tr = self.PolSQL.Execute(Select,3)
            if stat != 'OK':
                stat='Bd pobrania rodkw trwaych: '+stat
                wart.append(stat)
            elif len(wyn)==0:
                stat = 'BR POZ'
                wart.append(stat)
        if stat=='OK':
            #WS 2024-02-19 - szczegolowa
            #dodawanie nagwka spisu z natury
            Ins ="INSERT INTO rs_srodki_trwale_inwentaryzacja (firma_id,stan,grupa,data_inwentaryzacji,typ_srodka,"
            Ins+="uzytkownik_id, dostawca_id, miejsce_uzytkowania_id,przewodniczacy,czlonek1,czlonek2,osoba1,osoba2,osoba3,szczegolowa)  "
            Ins+="VALUES ('"+self.firma_id+"', 'W' "
            if Grupa.strip() != '':
                Ins+=", '"+Grupa+"' "
            else:
                Ins+=", NULL "
            if Data.strip() != '':
                Ins+=", '"+Data+"' "
            if Typ.strip() != '':
                Ins+=", '"+Typ+"' "
            else:
                Ins+=", NULL "
            if Uzytkownik.strip() != '':
                Ins+=", '"+Uzytkownik+"' "
            else:
                Ins+=", NULL "
            if Dostawca.strip() != '':
                Ins+=", '"+Dostawca+"' "
            else:
                Ins+=", NULL "
            if Miejsce.strip() != '':
                Ins+=",'"+Miejsce+"' "
            else:
                Ins+=", NULL "
            if Przewod.strip() != '':
                Ins+=",'"+Przewod+"' "
            else:
                Ins+=", NULL "
            if Czlonek1.strip() != '':
                Ins+=",'"+Czlonek1+"' "
            else:
                Ins+=", NULL "
            if Czlonek2.strip() != '':
                Ins+=",'"+Czlonek2+"' "
            else:
                Ins+=", NULL "
            if Osoba1.strip() != '':
                Ins+=", '"+Osoba1+"' "
            else:
                Ins+=", NULL "
            if Osoba2.strip()  != '':
                Ins+=",'"+Osoba2+"' "
            else:
                Ins+=", NULL "
            if Osoba3.strip() != '':
                Ins+=", '"+Osoba3+"' "
            else:
                Ins+=", NULL "
            #WS 2024-02-19
            if Szczegolowa is True:
                Ins+=", TRUE );"
            else:
                Ins+=", FALSE );"
            rsglobal.ZapiszDoLogow('aaaaaaaaaaa '+str(Ins),1)
            stat,dump,dump,dump = self.PolSQL.Execute(Ins, 1)
            if stat != 'OK':
                stat='BL INS INW'
                wart.append(stat)
            else:
                #pobieram bigserial
                SQL = "SELECT max(nr_id) FROM  rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' ;"
                stat, daneB, dump, dump = self.PolSQL.Execute(SQL ,3)
                if stat != 'OK':
                    stat='BL SEL ID'
                    wart.append(stat)
                else:
                    self.NowaInwentId=daneB[0][0]
                    wart.append(self.NowaInwentId)
            
            #dodawanie pozycji
            #s.srodek_id,s.grupa,s.typ_srodka,s.uzytkownik_id, s.dostawca_id, sm.mejsce_uzytkowania_id 
        if stat=='OK':
            InsP=''
            for w in wyn:
                #WS 2024-02-08 - nr_poz, zmiana z VALUES() na SELECT FROM WHERE
                InsP+="INSERT INTO rs_srodki_trwale_inwentaryzacja_pozycje (nr_poz,nr_id,firma_id,srodek_id,grupa,data,"
                InsP+="typ_srodka,uzytkownik_id,dostawca_id,miejsce_uzytkowania_id,ilosc,ilosc_ks,uwagi,recznie ) "
                InsP+="SELECT COALESCE(MAX(nr_poz)+1, 1), "+str(self.NowaInwentId)+", '"+self.firma_id+"'  "
                if w[0] not in (None,'None',''):
                    InsP+=", '"+str(w[0])+"' "
                else:
                    stat='BR SR TRW'
                    wart.append(stat)
                    break
                if w[1] not in (None,'None',''):
                    InsP+=",'"+str(w[1])+"' "
                else:
                    InsP+=", NULL "
                if Data.strip() != '':
                    InsP+=", '"+Data+"' "
                if w[2] not in (None,'None',''):
                    InsP+=", '"+str(w[2])+"' "
                else:
                    InsP+=", NULL "
                if w[3] not in (None, 'None', ''):
                    InsP+=", '"+str(w[3])+"' "
                else:
                    InsP+=", NULL "
                if w[4] not in (None, 'None', ''):
                    InsP+=", '"+str(w[4])+"' "
                else:
                    InsP+=", NULL "
                if w[5] not in (None, 'None', ''):
                    InsP+=", '"+str(w[5])+"' "
                else:
                    InsP+=", NULL "
                InsP+=", 0 , 1, '', False "
                #WS 2024-02-08
                InsP+=" FROM rs_srodki_trwale_inwentaryzacja_pozycje"
                InsP+=" WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(self.NowaInwentId)+";"
            stat, dump, dump, dump = self.PolSQL.Execute(InsP, 1)
            if stat != 'OK':
               stat='BL INS POZ'
   
    if stat=='OK':
        #WS 2024-02-19 - szczegolowa
        Select ="SELECT i.stan,i.data_inwentaryzacji,COALESCE(i.grupa||' - '||g.opis,''),"
        Select+="COALESCE(i.typ_srodka||' - '||t.opis,''),COALESCE(i.miejsce_uzytkowania_id||' - '||m.opis,''),"
        Select+="COALESCE(i.uzytkownik_id||' - '||u.nazwa,''), COALESCE(i.dostawca_id||' - '||d.nazwa,''), nr_id, szczegolowa"
        Select+=" FROM rs_srodki_trwale_inwentaryzacja i "
        Select+="LEFT OUTER JOIN rs_grupy_srodkow_trwalych g ON(i.firma_id=g.firma_id AND i.grupa=g.kod) "
        Select+="LEFT OUTER JOIN rs_typy_srodkow_trwalych t ON(i.firma_id=t.firma_id AND i.typ_srodka=t.kod) "
        Select+="LEFT OUTER JOIN rs_miejsca_uzytkowania m ON(i.firma_id=m.firma_id AND i.miejsce_uzytkowania_id=m.kod) "
        Select+="LEFT OUTER JOIN rs_kontrahenci u ON(i.firma_id=u.firma_id AND i.uzytkownik_id=u.kontrahent_id) "
        Select+="LEFT OUTER JOIN rs_kontrahenci d ON(i.firma_id=d.firma_id AND i.dostawca_id=d.kontrahent_id) "
        Select+="WHERE (i.firma_id='"+self.firma_id+"'"
        if GrupaF != '':
            Select+=" AND i.grupa='"+GrupaF+"'"
        if TypF != '':
            Select+=" AND i.typ_srodka='"+TypF+"'"
        if UzytkownikF != '':
            Select+=" AND i.uzytkownik_id='"+UzytkownikF+"'"
        if DostawcaF != '':
            Select+=" AND i.dostawca_id='"+DostawcaF+"'"
        if MiejsceF != '':
            Select+=" AND i.miejsce_uzytkowania_id='"+MiejsceF+"'"
        if DataOdF != '    -  -  ':
            Select+=" AND i.data_inwentaryzacji>='"+DataOdF+"'"
        if DataDoF != '    -  -  ':
            Select+=" AND i.data_inwentaryzacji<='"+DataDoF+"'"
        Select+="  )OR i.nr_id="+str(self.NowaInwentId)+" "
        Select+=" ORDER BY i.nr_id, i.data_inwentaryzacji,i.grupa,i.typ_srodka;"
        stat, wyn1, wart, dump = self.PolSQL.Execute(Select, 3)
        if stat != 'OK':
            stat='Bd pobrania danych inwentaryzacji: '+stat 
            wart.append(stat)
        elif wart==[]:
            wart.append(self.NowaInwentId)

#-------------------------------------------------------------------------------
#Zapis edycji
#-------------------------------------------------------------------------------

if Funkcja==2 and stat=='OK':
    UPD= "UPDATE rs_srodki_trwale_inwentaryzacja SET przewodniczacy='"+Przewod+"', czlonek1='"+Czlonek1+"',  "
    UPD+="czlonek2='"+Czlonek2+"',osoba1='"+Osoba1+"',osoba2='"+Osoba2+"',osoba3='"+Osoba3+"' "
    UPD+="WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
    stat,wyn1,wart,dump = self.PolSQL.Execute(UPD,1) 
    if stat != 'OK':
        stat='Bd zapisu: '+stat 
        wart.append(stat)

#-------------------------------------------------------------------------------
#Pobranie danych do edycji
#-------------------------------------------------------------------------------

if Funkcja==5 and stat=='OK':
    dane=[]
    SQL="SELECT COALESCE(grupa,''), COALESCE(typ_srodka,''), COALESCE(uzytkownik_id,''), COALESCE(dostawca_id,''), "
    SQL+="COALESCE(miejsce_uzytkowania_id,''), COALESCE(przewodniczacy,'') as przewodniczacy,"
    SQL+="COALESCE(czlonek1,'') as czlonek1, COALESCE(czlonek2,'') as czlonek2, "
    SQL+="COALESCE(osoba1,'') as osoba1, COALESCE(osoba2,'') as osoba2, COALESCE(osoba3,'') as osoba3, data_inwentaryzacji "
    SQL+="FROM rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(self.NowaInwentId)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3) 
    if stat != 'OK':
        stat='Bd pobrania danych inwentaryzacji: '+stat 
        wart.append(stat)