# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_inwentaryzacja_srodki_trwale_pozycje.py
# Purpose:     obsluga grida edytowalnego
# Author:      Dariusz Boduch
# Created:     2010/04/19
# RCS-ID:      $Id: fs_inwentaryzacja_srodki_trwale_pozycje.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2017-03-31 Konrad Opieka    (10403) Refaktoryzacja
# 2024-02-06 Wojciech Skowron (13680) Nowy widok pozycji w inwentaryzacji rodkw trwaych

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'SrodekId':[1,5,7]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat ='Uwaga: wywoanie funkcji fs_inwentaryzacja_srodki_trwale_pozycje z numerem '+str(Funkcja)
        stat+=' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5,7]:
        NrId = klucze['SrodekId']

dane = []
wyn1 = []
wyn2 = []

ModyfikowaneSrodki = {}
StanInw = 'Z'

UprIns=((self.oddzial_id,'174523') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'174522') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'174524') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#WS 2024-02-06
UprSzczegolowe=((self.oddzial_id,'808000') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja==1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']


#-------------------------------------------------------------------------------
#-------   SPRAWDZANIE OPISU
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==7:
    sql = "SELECT nazwa FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+NrId+"';"
    stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Bd przy sprawdzaniu nazwy rodka trwaego: '+stat   
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  POBRANIE STANU INWENTARYZACJI PRZED INS/UPD/DEL ----------------------
#-------------------------------------------------------------------------------

#WS 2024-02-06
if stat=='OK' and Funkcja==1:
    sel="SELECT stan FROM rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
    stat,d,dump,dump = self.PolSQL.Execute(sel,3)
    if stat != 'OK' or len(d) == 0:
        stat="BL SPR STAN"
        dane.append(stat)
    else:
        StanInw = d[0][0]

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==1:
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)    
            
        # wykonanie DELETE 
        if stat=='OK':
            # #sprawdzam stan inwentaryzacji
            # sel="SELECT stan FROM rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
            # stat,d,dump,dump = self.PolSQL.Execute(sel,3)
            # if stat != 'OK':
            #     stat="BL SPR STAN"
            #     dane.append(stat)
            # else:
            #     if d[0][0]=='Z':
            if StanInw=='Z':
                stat="STAN Z"
                dane.append(stat)
            if stat=='OK':
                sql=''
                for i in xrange(len(Delete[0])):
                    DELETE="DELETE FROM rs_srodki_trwale_inwentaryzacja_pozycje "
                    WHERE="WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+" "
                    for j in xrange(len(Delete[0][i])):
                        pole=Delete[1][j]
                        wart=Delete[0][i][j]
                        #WS 2024-02-06
                        if pole in ['nr_poz']:
                        # if pole in ['srodek_id']:
                            WHERE+=" AND "+pole+"="+str(wart)
                    sql+=DELETE+WHERE+";"
                if sql != '':
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat != 'OK':
                        stat = "Bd przy usuwaniu danych: "+stat
                        dane.append(stat)
                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==1:
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)
            
        if stat == 'OK':
            #pobranie klucza dla oddzialu
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'srodek_id':
                        SrodekId = wart

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]

                    if pole == 'srodek_id':
                        if wart.strip()=='':
                            #WS 2024-02-06 - jeli niewypeniony srodek_id wymagane pole uwagi
                            if 'uwagi' not in Update[0][i]:
                                SQL ="SELECT uwagi FROM rs_srodki_trwale_inwentaryzacja_pozycje"
                                SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)
                                for j in xrange(len(Update[2][i])): # petla po kluczu
                                    pole=Update[3][j]
                                    wart=rsglobal.Dekoduj(Update[2][i][j])
                                    SQL+=" AND "+pole+"='"+str(wart)+"'"
                                SQL+=";"
                                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    stat='Bd pobrania danych pozycji: '+stat
                                else:
                                    uwagi = d[0][0]
                            else:
                                uwagi = Update[1][i][Update[0][i].index('uwagi')]

                            if uwagi.strip() in ('', 'None'):
                                stat = 'BR UWAGI'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
                        else:
                            sql ="SELECT srodek_id FROM rs_srodki_trwale WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND srodek_id = '"+str(wart).strip()+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'BL SQL SRTRW'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL SRTRW'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            else:
                                SrodekId = wart.strip()
                                #Sprawdzam czy dodawany srodek id nalezy do klucza inwentaryzacji
                                sql="SELECT grupa, typ_srodka, uzytkownik_id, dostawca_id, miejsce_uzytkowania_id "
                                sql+="FROM rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
                                stat,di,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat != 'OK':
                                    stat='BL INS INW'
                                    dane.append(stat)
                                else:
                                    FILTR=''
                                    if di[0][0] not in ('',None,'None'):
                                        FILTR=FILTR+" AND grupa='"+str(di[0][0])+"' "
                                    if di[0][1] not in ('',None,'None'):
                                        FILTR=FILTR+" AND typ_srodka='"+str(di[0][1])+"' "
                                    if di[0][2] not in ('',None,'None'):
                                        FILTR=FILTR+" AND uzytkownik_id='"+str(di[0][2])+"' "
                                    if di[0][3] not in ('',None,'None'):
                                        FILTR=FILTR+" AND dostawca_id='"+str(di[0][3])+"' "
                                    #if di[0][4] not in ('',None,'None'):
                                    #    FILTR=FILTR+" AND miejsce_uzytkowania_id='"+str(di[0][4])+"' "

                                    sql="SELECT srodek_id FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "+FILTR+"; "
                                    stat,ds,dump,dump = self.PolSQL.Execute(sql,3)
                                    if stat != 'OK':
                                        stat="BL SQL SRTRW"
                                        dane.append(stat)
                                    if len(ds)==0:
                                        stat="Srodek trway: "+str(SrodekId)+" nie wystpuje w kluczu inwentaryzacji: "+FILTR[4:]
                                        dane.append(stat)

                                ModyfikowaneSrodki[SrodekId] = (WierszeNr[i],1)  #WS 2024-02-06
                    #WS 2024-02-06
                    elif pole == 'nowe_miejsce_uzytkowania' and UprSzczegolowe:
                        if wart.strip() != '':
                            SQL = "SELECT kod FROM rs_miejsca_uzytkowania WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                            stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                            if stat != 'OK':
                                stat='BL SQL MIEJUZYT'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)
                            elif len(d)==0:
                                stat='BL MIEJUZYT'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)
                    #WS 2024-02-06
                    elif pole == 'uwagi':
                        if wart.strip()=='':
                            #WS 2024-02-06 - jeli niewypeniony srodek_id wymagane pole uwagi
                            if 'srodek_id' not in Update[0][i]:
                                SQL ="SELECT srodek_id FROM rs_srodki_trwale_inwentaryzacja_pozycje"
                                SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)
                                for j in xrange(len(Update[2][i])): # petla po kluczu
                                    pole=Update[3][j]
                                    wart=rsglobal.Dekoduj(Update[2][i][j])
                                    SQL+=" AND "+pole+"='"+str(wart)+"'"
                                SQL+=";"
                                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    stat='Bd pobrania danych pozycji: '+stat
                                else:
                                    srodek_id = d[0][0]
                                    if srodek_id.strip() in ('', 'None'):
                                        stat = 'BR UWAGI'
                                        wyn2.append((WierszeNr[i],10))
                                        dane.append(stat)
    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_srodki_trwale_inwentaryzacja_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ('srodek_id','uwagi') or (UprSzczegolowe and pole in ('nowe_miejsce_uzytkowania')):
                        wart = wart.strip()
                        if wart == '':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+wart+"',"
                    elif pole in ('ilosc') or (UprSzczegolowe and pole == 'czy_zatw' and StanInw == 'G'):
                        SET+=pole+"="+str(wart)+" ,"
                    # else:
                    #     if wart.strip()=='':
                    #         SET+=pole+"=NULL,"
                        

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+" " 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+str(wart)+"'"
                WHERE+=";"    
                
                sql+=UPDATE+SET+WHERE;

                
            if sql != '':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat != 'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)
                                    
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==1:
    SrodekId = ''
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat=='OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        
                        if pole == 'srodek_id':
                            if wart.strip()=='':
                                #WS 2024-02-06 - jeli niewypeniony srodek_id wymagane pole uwagi
                                uwagi = Insert[0][i][Insert[1].index('uwagi')]
                                if uwagi.strip() in ('', 'None'):
                                    stat = 'BR UWAGI'
                                    wyn2.append((WierszeNr[i],10))
                                    dane.append(stat)
                            else:
                                sql ="SELECT srodek_id FROM rs_srodki_trwale"
                                sql+=" WHERE firma_id = '"+self.firma_id+"' AND srodek_id = '"+str(wart).strip()+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat != 'OK':
                                    stat = 'BL SQL SRTRW'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL SRTRW'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                                else:
                                    SrodekId = wart.strip()
                                    #Sprawdzam czy dodawany srodek id nalezy do klucza inwentaryzacji
                                    sql="SELECT grupa, typ_srodka, uzytkownik_id, dostawca_id, miejsce_uzytkowania_id "
                                    sql+="FROM rs_srodki_trwale_inwentaryzacja WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+"; "
                                    stat,di,dump,dump = self.PolSQL.Execute(sql,3)
                                    if stat != 'OK':
                                        stat='BL INS INW'
                                        dane.append(stat)
                                    else:
                                        FILTR=''
                                        if di[0][0] not in ('',None,'None'):
                                            FILTR+=" AND grupa='"+str(di[0][0])+"' "
                                        if di[0][1] not in ('',None,'None'):
                                            FILTR+=" AND typ_srodka='"+str(di[0][1])+"' "
                                        if di[0][2] not in ('',None,'None'):
                                            FILTR+=" AND uzytkownik_id='"+str(di[0][2])+"' "
                                        if di[0][3] not in ('',None,'None'):
                                            FILTR+=" AND dostawca_id='"+str(di[0][3])+"' "
                                        #if di[0][4] not in ('',None,'None'):
                                        #    FILTR+=" AND miejsce_uzytkowania_id='"+str(di[0][4])+"' "
                                        sql="SELECT srodek_id FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "+FILTR+"; "
                                        stat,ds,dump,dump = self.PolSQL.Execute(sql,3)
                                        if stat != 'OK':
                                            stat="BL SQL SRTRW"
                                            dane.append(stat)
                                        if len(ds)==0:
                                            stat="Srodek trway: "+str(SrodekId)+" nie wystpuje w kluczu inwentaryzacji: "+FILTR[4:]
                                            dane.append(stat)

                                    ModyfikowaneSrodki[SrodekId] = (WierszeNr[i],1)  #WS 2024-02-06
                        #WS 2024-02-06
                        elif pole == 'nowe_miejsce_uzytkowania' and UprSzczegolowe:
                            if wart.strip() != '':
                                SQL = "SELECT kod FROM rs_miejsca_uzytkowania WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
                                if stat != 'OK':
                                    stat='BL SQL MIEJUZYT'
                                    wyn2.append((WierszeNr[i],8))
                                    dane.append(stat)
                                elif len(d)==0:
                                    stat='BL MIEJUZYT'
                                    wyn2.append((WierszeNr[i],8))
                                    dane.append(stat)
            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]

        if stat=='OK':
            # pobranie najnowszego nr_poz
            SQL ="SELECT MAX(nr_poz) FROM rs_srodki_trwale_inwentaryzacja_pozycje"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)+";"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat='Bd pobrania numeru pozycji: '+stat
            NrPoz = d[0][0]+1
                                                        
        # wykonanie INSERT
        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_srodki_trwale_inwentaryzacja_pozycje "
                KOLUMNY="(firma_id, nr_id, recznie, nr_poz "
                VALUES=" VALUES ('"+self.firma_id+"', "+str(NrId)+",'True',"+str(NrPoz)
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ('srodek_id','uwagi') or (UprSzczegolowe and pole in ('nowe_miejsce_uzytkowania')):
                        wart = wart.strip()
                        if wart == '':
                            KOLUMNY+=","+pole
                            VALUES+=",NULL"
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                    elif pole in ('ilosc') or (UprSzczegolowe and pole == 'czy_zatw' and StanInw == 'G'):
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)+" "
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns != '': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat != 'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)

if stat == 'OK' and Funkcja == 1 and (len(Insert[0])>0 or len(Update[0])>0):
    #WS 2024-02-06
    #Sprawdzam czy dodawany srodek id nie wystpuje ju na innej pozycji
    sql="SELECT srodek_id, COUNT(srodek_id) FROM rs_srodki_trwale_inwentaryzacja_pozycje "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND nr_id="+str(NrId)
    sql+=" AND srodek_id IS NOT NULL GROUP BY srodek_id HAVING COUNT(srodek_id) > 1; "
    stat,dp,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat='BL INS INW'
        dane.append(stat)
    elif len(dp) > 0:
        stat='BL UNIKALNY SRTRW'
        for d in dp:
            srodek_id = d[0].strip()
            if srodek_id in ModyfikowaneSrodki:
                dane.append(stat)
                wyn2.append(ModyfikowaneSrodki[srodek_id])

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (1,5):
#WS 2024-02-06 - nowe pola 'nr_poz', 'miejsce_uzytkowania_id', 'opis_miejsca',
# 'czy_zatw', 'nowe_miejsce_uzytkowania', 'opis_nowego_miejsca'
# oraz ORDER BY nr_poz zamiast srodek_id
    if UprSzczegolowe:  #WS 2024-02-06
        SQL="SELECT ip.nr_poz, ip.srodek_id,st.nazwa "
        SQL+=", ip.miejsce_uzytkowania_id, mu.opis AS opis_miejsca"
        SQL+=", ip.ilosc_ks, ip.ilosc"
        SQL+=", ip.czy_zatw, ip.nowe_miejsce_uzytkowania, nmu.opis AS opis_nowego_miejsca"
        SQL+=", COALESCE(ip.uwagi,''), ip.recznie"
        SQL+=" FROM rs_srodki_trwale_inwentaryzacja_pozycje ip"
        SQL+=" LEFT OUTER JOIN rs_srodki_trwale st ON(ip.firma_id=st.firma_id AND ip.srodek_id=st.srodek_id)"
        SQL+=" LEFT OUTER JOIN rs_miejsca_uzytkowania mu ON(ip.firma_id=mu.firma_id AND ip.miejsce_uzytkowania_id=mu.kod)"
        SQL+=" LEFT OUTER JOIN rs_miejsca_uzytkowania nmu ON(ip.firma_id=nmu.firma_id AND ip.nowe_miejsce_uzytkowania=nmu.kod)"
        SQL+=" WHERE ip.firma_id='"+self.firma_id+"' AND ip.nr_id="+str(NrId)+" "
        SQL+=" ORDER BY ip.nr_poz;"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat="Bd przy pobieraniu danych: "+stat
            dane.append(stat)
    else:
        SQL="SELECT ip.nr_poz, ip.srodek_id,st.nazwa "
        SQL+=", '' AS miejsce_uzytkowania_id, '' AS opis_miejsca"
        SQL+=", ip.ilosc_ks, ip.ilosc"
        SQL+=", False AS czy_zatw, '' AS nowe_miejsce_uzytkowania, '' AS opis_nowego_miejsca"
        SQL+=", COALESCE(ip.uwagi,''), recznie"
        SQL+=" FROM rs_srodki_trwale_inwentaryzacja_pozycje ip"
        SQL+=" LEFT OUTER JOIN rs_srodki_trwale st ON(ip.firma_id=st.firma_id AND ip.srodek_id=st.srodek_id)"
        SQL+=" WHERE ip.firma_id='"+self.firma_id+"' AND ip.nr_id="+str(NrId)+" "
        SQL+=" ORDER BY ip.nr_poz;"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat="Bd przy pobieraniu danych: "+stat   
            dane.append(stat)
