# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_jpk.py
# Purpose:     pobranie danych do JPL
# Author:      Marcin Natkaski
# Created:     2016/06/09
# RCS-ID:      $Id: fs_jpk.py $
# Copyright:   (c) 2016 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# FUNKCJE
# 1 - Pobranie danych do JPK - Ksiegi Rachunkowe
# 11 - rezerwacja na zleceniu
# 12 - zlecenie wykonania produkcji 
# 13 - akceptacja produkcji
# 14 - wykonanie produkcji
# 15 - zgoszenie brakw

print klucze
from funkcje import fs_rozrachunki_pom


stat='OK'
dane=[]
wyn1 = []
wyn2 = []
zois = []
dziennik = []


if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'DataOd':[1,],'DataDo':[1,],'KontoOd':[1,],'KontoDo':[1,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_jpk z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        KontoOd = rsglobal.Dekoduj(klucze['KontoOd'])
        KontoDo = rsglobal.Dekoduj(klucze['KontoDo'])

    Rok = DataOd[:4]
    Mc = DataDo[5:7]
    Poziom = 99999
    NieDrukowacNazw = False
    ObrotyZBO = True
#-------------------------------------------------------------------------------
# POBIERANIE DANYCH  (5)
#-------------------------------------------------------------------------------
if Funkcja == 1 and stat=='OK':

    #Pobieramy dane do nagwka
    SQL = "SELECT nazwa1,nip,regon,adr_kraj,adr_wojew,adr_powiat,adr_gmina,adk_ulica,adk_nry,adr_miej,adk_kod,adk_poczta,urzad_skarbowy_id "
    SQL+= " FROM rs_oddzialy "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        dane.append("Bd pobierania danych oddziau "+stat)





# pobieramy pozycje do ZOiS
if Funkcja == 1 and stat=='OK':
    #sprawdzenie poprawnosci kluczy
    #sprawdzenie roku
    try:
        if int(Rok)<1950 or int(Rok)>2100:
            stat='Niepoprawny rok wykonania raportu'
    except:
        stat='Niepoprawny rok wykonania raportu: '+str(Rok)
    #sprawdzenie miesiaca
    if stat=='OK':
        if Mc not in ['01','02','03','04','05','06','07','08','09','10','11','12']:
            stat='Niepoprawny miesic wykonania raportu: '+str(Mc)

    if stat=='OK':
        Data = Rok+'-'+Mc+'-'+'01'
        sql = "SELECT data_od, data_do FROM rs_definicje_okresow"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
        if stat <> 'OK':
            stat = 'Bd pobrania danych okresu ksigowego : '+stat
            dane.append(stat)
        else:
            if len(d) == 1:
                if DataOd < str(d[0][0]):
                    stat = 'Data od jest wczeniejsza od daty pocztku okresu ksigowego'
                    dane.append(stat)

                if DataDo > str(d[0][1]):
                    stat = 'Data do jest pniejsza ni data koca okresu okresu ksigowego'
                    dane.append(stat)

            else:
                stat = 'Brak zdefiniowanego okresu ksigowego '+str(self.okres_id)
                dane.append(stat)

    if stat=='OK':
        if not '_' in KontoOd:
            if KontoOd=='':
                stat='Nie podano konta od'

            if stat=='OK':
                if KontoDo=='':
                    stat='Nie podano konta do'

    if stat =='OK':
        if '_' in KontoOd:
            FiltrKont=" AND konto LIKE '"+KontoOd+"%' "
        else:
            FiltrKont=" AND (((konto>='"+KontoOd+"') AND (konto<='"+KontoDo+"')) OR (konto LIKE '"+KontoDo+"%')) "

    if stat =='OK':
        #pobranie listy kont z tabeli rs_stany_kont
        SQL="SELECT DISTINCT konto FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' "+FiltrKont
        SQL+=" ORDER BY konto ASC;"
        stat,DaneKont,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat='Bdy pobierania list kont do analizy : '+stat
    if stat=='OK':
        if len(DaneKont)==0:
            stat="Brak kont mieszczcych si w zakresie o podanych parametrach"

    if stat=='OK':
        ListaKont = []
        #stworzenie pelnej list kont w oparciu o pobrana liste
        for konto in DaneKont:
            Konto=rsglobal.Dekoduj(konto[0])
            if not Konto in ListaKont:
                Poz=Konto.count("-")

                if Poz <= Poziom:
                    if not Konto in ListaKont:
                        ListaKont.append(Konto)

                bufor = Konto
                indeks = 0
                while indeks <> -1:
                    indeks = bufor.rfind("-")
                    if indeks <> -1:
                        bufor = bufor[0:indeks]
                        Poz = Poz-1
                    if not bufor in ListaKont:
                         if (bufor >= KontoOd or '_' in KontoOd) and Poz <=Poziom:
                            ListaKont.append(bufor)

        #pobranie sum kont dla wszystkich kont (i potem wyszukiwanie)
        #Suma bilansu otwarcia
        SQL="SELECT konto,sum(kwota_wn) AS bown,sum(kwota_ma) AS boma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        SQL+=" AND miesiac = '00' "+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneBO,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat=='OK':
        #Obroty w miesiacu
        SQL="SELECT konto,sum(kwota_wn) AS obrwn,sum(kwota_ma) AS obrma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND rok = '"+Rok+"' "
        SQL+=" AND miesiac = '"+Mc+"' "+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneOBR,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat=='OK':
        #Suma obrotow narastajaca
        SQL="SELECT konto,sum(kwota_wn) AS narwn,sum(kwota_ma) AS narma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND (rok||miesiac) <= ('"+Rok+"'||'"+Mc+"') "
        SQL+=" AND miesiac <> '00' "+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneNAR,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat=='OK':
        #Saldo
        SQL="SELECT konto,sum(saldo_wn) AS salwn,sum(saldo_ma) AS salma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND rok = '"+Rok+"' "
        SQL+=" AND miesiac = '"+Mc+"'"+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneSAL,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat=='OK':
       # sprawdzenie istnienia BO
        stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,self.okres_id)
        if stat <> 'OK':
            stat = 'Bd pobierania okresw dla rozrachunkw : '+stat

    if stat == 'OK':
        LOkresow=Wyn[0]
        DataGr=Wyn[1]
        IstniejeBO=(LOkresow.find(',')==-1)

    if stat=='OK':
        #pobranie danych dla kolejnych kont
        for Konto in ListaKont:
            if stat=='OK':
                KontoS = Konto[0:3]
                KontoA = ""
                if len(Konto)>3:
                    KontoA = Konto[4:len(Konto)]
                KontoA = KontoA.strip()

                #Pobranie opisow
                Nazwa=""
                SQL="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+Konto+"');"
                stat,DaneParK,dump,dump = self.PolSQL.Execute(SQL,3)

            if stat=='OK':
                if len(DaneParK)==0:
                    stat="Bdy w definicji konta : "+KontoS+"-"+KontoA

            #pobranie danych zespou kont syntetycznych
            if stat=='OK':
                SQL="SELECT DISTINCT kontos_id, nazwa FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND "
                SQL+=" kontos_id = substring('"+Konto+"' from 1 for 1) AND trim(konto_id)='';"
                stat,DaneKontSynt,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Bdy w pobieraniu opisu grupy kont systetycznych.'

                elif len(DaneKontSynt)==0:
                    DaneKontSynt=[['Brak konta','Brak nazwy']]


            #pobranie danych grupy kont analitycznych
            if stat=='OK':
                SQL="SELECT DISTINCT kontos_id, nazwa FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND "
                SQL+="kontos_id = substring('"+Konto+"' from 1 for 3) AND trim(konto_id)='';"
                stat,DaneKontAnal,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Bdy w pobieraniu opisu grupy kont systetycznych.'
                elif len(DaneKontSynt)==0:
                    DaneKontSynt=[['Brak konta','Brak nazwy']]

            if stat=='OK':
                DaneKonta=eval(DaneParK[0][0])
                if NieDrukowacNazw:
                    Nazwa = '     '
                else:
                    Nazwa = DaneKonta[1]

                Rozrachunkowe = DaneKonta[3]
                Pozabilansowe = DaneKonta[4]
                Jednostronne  = DaneKonta[7]
                Waluta = DaneKonta[5]
                DoBilansu = DaneKonta[6]

                BOWn=0
                BOMa=0
                for BO in DaneBO:
                    if (Konto==BO[0]) or (BO[0][0:len(Konto)+1] == Konto+'-'):
                        if BO[1] not in (None,'None',0):
                            BOWn+=rsglobal.RSRound(BO[1],2)
                        if BO[2] not in (None,'None',0):
                            BOMa+=rsglobal.RSRound(BO[2],2)

                OBRWn=0
                OBRMa=0
                for OBR in DaneOBR:
                    if (Konto==OBR[0]) or (OBR[0][0:len(Konto)+1] == Konto+'-'):
                        if OBR[1] not in (None,'None',0):
                            OBRWn+=rsglobal.RSRound(OBR[1],2)
                        if OBR[2] not in (None,'None',0):
                            OBRMa+=rsglobal.RSRound(OBR[2],2)

                NARWn=0
                NARMa=0
                for NAR in DaneNAR:
                    if (Konto==NAR[0]) or (NAR[0][0:len(Konto)+1] == Konto+'-'):
                        if NAR[1] not in (None,'None',0):
                            NARWn+=rsglobal.RSRound(NAR[1],2)
                        if NAR[2] not in (None,'None',0):
                            NARMa+=rsglobal.RSRound(NAR[2],2)

                if Rozrachunkowe and IstniejeBO:
                    SALWn=0
                    SALMa=0
                    for SAL in DaneSAL:
                        if (Konto==SAL[0]) or (SAL[0][0:len(Konto)+1] == Konto+'-'):
                            if SAL[1] not in (None,'None',0):
                                SALWn+=rsglobal.RSRound(SAL[1],2)
                            if SAL[2] not in (None,'None',0):
                                SALMa+=rsglobal.RSRound(SAL[2],2)
                else:
                    if (BOWn+NARWn) > (BOMa+NARMa):
                        SALWn = rsglobal.RSRound(BOWn+NARWn-BOMa-NARMa,2)
                        SALMa = 0
                    else:
                        SALWn = 0
                        SALMa = rsglobal.RSRound(BOMa+NARMa-BOWn-NARWn,2)

                    if BOWn>BOMa:
                        BOWn=rsglobal.RSRound(BOWn-BOMa,2)
                        BOMa=0
                    else:
                        BOMa=rsglobal.RSRound(BOMa-BOWn,2)
                        BOWn=0

                if Jednostronne:
                    if BOWn>BOMa:
                        BOWn=rsglobal.RSRound(BOWn-BOMa,2)
                        BOMa=0
                    else:
                        BOMa=rsglobal.RSRound(BOMa-BOWn,2)
                        BOWn=0

                    if SALWn>SALMa:
                        SALWn=rsglobal.RSRound(SALWn-SALMa,2)
                        SALMa=0
                    else:
                        SALMa=rsglobal.RSRound(SALMa-SALWn,2)
                        SALWn=0

                #obsuga obrotw z BO dziaa tylko dla zestawienia bez miesicznych
                # BO jest dodawane do sumy narastajco po uwzgldnieniu sald jednostronnych
                # if Fun==5:
                #     if ObrotyZBO:
                #         NARWn=NARWn+BOWn
                #         NARMa=NARMa+BOMa

                if (BOWn <> 0) or (BOMa <> 0) or (OBRWn <> 0) or (OBRMa <> 0) or (NARWn <> 0) or (NARMa <> 0) or (SALWn <> 0) or (SALMa <> 0):
                    zois.append([Konto,Nazwa,Pozabilansowe,BOWn,BOMa,OBRWn,OBRMa,NARWn,NARMa,SALWn,SALMa,Waluta,DoBilansu,Rozrachunkowe,DaneKontSynt,DaneKontAnal])



#pobieranie danych do dziennika

if Funkcja==1 and stat=='OK':

    #pobranie danych z operacji i danych operatora
    Pola =" CASE WHEN o.dziennik IS NOT NULL THEN o.dziennik ELSE 0 END as nr_dziennika, o.dowod_id,  CAST(o.numer AS TEXT) as nr_dowodu, CAST(o.nr_poz AS TEXT) as nr_poz, CAST(o.nr_ppoz AS TEXT) as nr_ppoz"
    Pola+=", o.data, o.data_wyst, o.tresc, o.kwota_wn, o.kwota_ma, o.konto, o.konto_prz, SUBSTRING(u.imie FROM 1 FOR 1) as imie , u.nazwisko, p.pozabilansowe,o.nazwa_id, m.nazwa  "
    From ="rs_operacje o LEFT OUTER JOIN rs_operatorzy u on(o.z_op_id=u.operator_id)"
    From+=" LEFT OUTER JOIN rs_plan_kont p on (o.firma_id=p.firma_id AND o.okres_id=p.okres_id AND (STRING_TO_ARRAY(o.konto,'-'))[1] = p.kontos_id)"
    From+=" INNER JOIN rs_wzory_dekretacji m ON (o.firma_id=m.firma_id AND o.okres_id=m.okres_id AND o.dowod_id=m.dowod_id AND o.nazwa_id=m.nazwa_id )"
    Where=" o.firma_id='"+self.firma_id+"' AND o.okres_id='"+self.okres_id+"' AND o.data>='"+DataOd+"' AND o.data<='"+DataDo+"' AND o.dziennik IS NOT NULL"
    GroupBy=" o.dziennik, o.dowod_id,o.numer,o.nr_poz,o.nr_ppoz,o.data,o.data_wyst,o.tresc,o.kwota_wn, o.kwota_ma,o.konto,o.konto_prz,u.imie, u.nazwisko,p.pozabilansowe,o.nazwa_id, m.nazwa "
    stat,daneO,naglO,dump=self.PolSQL.Execute("SELECT "+Pola+" FROM "+From+" WHERE "+Where+" GROUP BY "+GroupBy+" ORDER BY o.dziennik;",3)
    if stat=='OK':
        if len(daneO)==0:
            stat='Brak danych dziennika do tworzenia JPK'

    if stat=="OK":
        #pobieranie sum kwota_wn, kwota_ma za okres_id
        SQL="SELECT COALESCE(SUM(o.kwota_wn),0) AS KwotaWn, COALESCE(SUM(o.kwota_ma),0) AS KwotaMa "
        SQL+=" FROM rs_operacje o "
        SQL+=" LEFT OUTER JOIN rs_plan_kont p ON (o.firma_id=p.firma_id AND o.okres_id=p.okres_id AND (STRING_TO_ARRAY(o.konto,'-'))[1] = p.kontos_id AND TRIM(p.konto_id)='')"
        SQL+=" WHERE o.firma_id='"+self.firma_id+"' AND o.okres_id='"+self.okres_id+"' AND o.data<'"+DataOd+"'"
        SQL+=" AND o.dziennik IS NOT NULL"

        # bilansowe
        stat,daneS,naglS,dump=self.PolSQL.Execute(SQL+" AND NOT p.pozabilansowe;",3)
        if stat <> 'OK':
            stat='Bdy w pobieraniu sumy kont bilansowych :'+stat
        elif len(daneS)==0:
            stat='Bdy w pobieraniu sumy kont bilansowych'

        # pozabilansowe
        if stat=='OK':
            stat,daneSPB,naglSPB,dump=self.PolSQL.Execute(SQL+" AND p.pozabilansowe;",3)
            if stat <> 'OK':
                stat='Bdy w pobieraniu sumy kont pozabilansowych:'+stat
            elif len(daneSPB)==0:
                stat='Bdy w pobieraniu sumy kont pozabilansowych'

    if stat=='OK':
        #pobranie danych do obliczenia liczby wierszy
        stat,daneW,naglW,dump=self.PolSQL.Execute("SELECT COUNT(*)::NUMERIC as ile_wierszy FROM rs_operacje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND data<'"+DataOd+"' AND SUBSTRING(data::TEXT from 6 for 2) in ('01','02','03','04','05','06','07','08','09','10','11','12') AND dziennik IS NOT NULL GROUP BY SUBSTRING(data::TEXT from 6 for 2) ORDER BY SUBSTRING(data::TEXT from 6 for 2);",3)
        #rsglobal.ZapiszDoLogow(daneW,1)
    if stat=='OK':
        dziennik=[daneO,naglO,daneS,naglS,daneSPB,naglSPB,daneW,naglW]


if stat=='OK':
    dane.append(zois)
    dane.append(dziennik)

