# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_jpk_ewidencja_faktur_vat.py
# Purpose:     pobranie danych do JPK
# Author:      Marcin Natkaski
# Created:     2016/06/09
# RCS-ID:      $Id: fs_jpk_ewidencja_faktur_vat.py $
# Copyright:   (c) 2016 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# FUNKCJE
# 1 - Pobranie danych do JPK - Faktury
# 2 - Pobranie danych do nagwka
# 2018-08-17 Aleksander Bargie - 11075 - JPK_FA - poprawki
# 2019-08-28 - 2019-10-14 Wojciech Skowron - 11495 - Nowa struktura JPK dla faktur
# 2020-01-14 Wojciech Skowron   - 11815 - Pobieranie danych firmy z centrali
# 2020-01-20 Wojciech Skowron   - 11815 - Zamiana na utf-8 pola P_2A, podmiana zastrzeonych znakw w P_7 (&,<,>,',")

class FakturyVat:
    def __init__(self,data_od,data_do,cel):
        from funkcje import fs_xml
        self.faktury_vat_jpk = fs_xml.RSToXml()
        self.data_od = data_od
        self.data_do = data_do
        self.cel = cel


#-------------------------------------------------------------------------------

    def ZapiszfakturyVat(self,faktury):
        import time
        import tempfile
        import datetime
        from funkcje import fs_jpk_pom
        import os

        dane_naglowka = faktury['dane_naglowka'][0]
        #AB 2018-08-17
        if dane_naglowka[0] == '':
            self.nip = 'BRAK'
        else:
            self.nip = dane_naglowka[0].strip()
        self.nazwa = dane_naglowka[1]
        self.kraj = dane_naglowka[2]
        self.woje = dane_naglowka[3]
        self.powiat = dane_naglowka[4]
        self.gmina = dane_naglowka[5]
        self.ulica = dane_naglowka[6]
        self.numer = dane_naglowka[7]
        self.kod = dane_naglowka[8]
        self.poczta = dane_naglowka[9]
        self.miejsc = dane_naglowka[10]
        self.urzad = dane_naglowka[11]
        self.regon = dane_naglowka[12]
        self.adres = self.kod+' '+self.miejsc+', '+self.ulica+' '+self.numer



        #----SKLADAMY JPK__NAGLOWEK
        self.faktury_vat_jpk.Inicjuj("JPK",2)
        self.faktury_vat_jpk.WstawWRoot("Naglowek")
        #WS 2019-08-30
        self.faktury_vat_jpk.WstawTekst('<KodFormularza wersjaSchemy="1-0" kodSystemowy="JPK_FA (2)">JPK_FA</KodFormularza>')
        # self.faktury_vat_jpk.WstawTekst('<KodFormularza wersjaSchemy="1-0" kodSystemowy="JPK_FA (1)">JPK_FA</KodFormularza>')
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","WariantFormularza",'2')
        # self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","WariantFormularza",'1')
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","CelZlozenia",self.cel.encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","DataWytworzeniaJPK",time.strftime("%Y-%m-%d")+'T'+datetime.datetime.now().time().isoformat()[:-7]+'Z')
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","DataOd",self.data_od)
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","DataDo",self.data_do)
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","DomyslnyKodWaluty",'PLN')
        self.faktury_vat_jpk.WstawNowyWZWartoscia("Naglowek","KodUrzedu",self.urzad)
        self.faktury_vat_jpk.Zamknij("Naglowek")
        self.faktury_vat_jpk.WstawWRoot("Podmiot1")
        self.faktury_vat_jpk.WstawNowyW("Podmiot1","IdentyfikatorPodmiotu")
        self.faktury_vat_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","etd:NIP",str(self.nip).strip())
        self.faktury_vat_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","etd:PelnaNazwa",self.nazwa.encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","etd:REGON",str(self.regon).strip())
        self.faktury_vat_jpk.Zamknij("IdentyfikatorPodmiotu")
        self.faktury_vat_jpk.WstawNowyW("Podmiot1","AdresPodmiotu")
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:KodKraju",str(self.kraj))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:Wojewodztwo",str(self.woje).encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:Powiat",str(self.powiat).encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:Gmina",str(self.gmina).encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:Ulica",str(self.ulica).encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:NrDomu",str(self.numer))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:NrLokalu",0)
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:Miejscowosc",str(self.miejsc).encode('utf-8'))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:KodPocztowy",str(self.kod))
        self.faktury_vat_jpk.WstawNowyWZWartoscia("AdresPodmiotu","etd:Poczta",str(self.poczta).encode('utf-8'))
        self.faktury_vat_jpk.Zamknij("AdresPodmiotu")
        self.faktury_vat_jpk.Zamknij("Podmiot1")

        #WS 2019-10-11 - dla kwot zamiast str(wart) - '{:.2f}'.format(wart)

        # WSTAWIAMY GALZKE FAKTURY
        # self.faktury_vat_jpk.WstawWRoot("Faktury")
        # self.faktury_vat_jpk.WstawAtrybutW("Faktury",'typ','G')

        if faktury['dane_sum'][0]<>0: #robimy ptle po poczonej licie faktur i korekt
            for i in faktury['dane_faktura'][0]:
                self.faktury_vat_jpk.WstawTekst('<Faktura typ="G">')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_1",str(i[3]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_2A",str(i[4]).encode('utf-8'))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_3A",str(i[5]).encode('utf-8'))
                #WS 2019-09-11
                if str(i[6]).strip() in ('','None'):
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_3B",'BRAK')
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_3B",str(i[6]).encode('utf-8'))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_3C",self.nazwa.encode('utf-8'))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_3D",self.adres.encode('utf-8'))
                if i[32].strip()=='WW': # typ wyznacznika faktury =='WW'
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_4A",'PL')
                    #WS 2019-10-14
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_4B",str(self.nip).strip())
                    # self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_4B",str(i[7]))
                else:
                    #self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_4A",'')
                    #WS 2019-10-14
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_4B",str(self.nip).strip())
                    # self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_4B",str(i[7]))
                if i[32].strip()=='WW':
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_5A",'PL')
                # else:
                #     self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_5A",'')
                #WS 2019-10-16
                if i[7].strip() not in ('','None'):
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_5B",i[7].strip())
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_5B",'BRAK')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_6",i[8])
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_1",'{:.2f}'.format(i[9]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_14_1",'{:.2f}'.format(i[10]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_2",'{:.2f}'.format(i[11]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_14_2",'{:.2f}'.format(i[12]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_3",'{:.2f}'.format(i[13]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_14_3",'{:.2f}'.format(i[14]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_4",'{:.2f}'.format(i[15]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_14_4",'{:.2f}'.format(i[16]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_5",'{:.2f}'.format(i[17]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_14_5",'{:.2f}'.format(i[18]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_6",'{:.2f}'.format(i[19]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_13_7",'{:.2f}'.format(i[20]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_15",'{:.2f}'.format(i[21]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_16",str(i[22]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_17",'false')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_18",str(i[23]))
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_19",str(i[24]))
                if i[24]=='true': #jeeli co jest zwolnione z podatku (stawka ZW)
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_19A",str(i[25]))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_19A",'')
                self.faktury_vat_jpk.WstawNowyW("Faktury","P_19B",1)
                if i[24]=='true': #jeeli co jest zwolnione z podatku (stawka ZW)
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_19C",str(i[25]))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_19C",'')

                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_20",'false')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_21",'false')
                #self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktury","P_22",'false')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_23",'false')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_106E_2",'false')
                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","P_106E_3",'false')

                self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","RodzajFaktury",str(i[26]))
                if i[27]:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","PrzyczynaKorekty",str(i[27]).encode('utf-8'))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","PrzyczynaKorekty",'BRAK')
                if i[28] and len(i[28]) <= 256:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","NrFaKorygowanej",str(i[28]).encode('utf-8'))
                #WS 2019-10-11 - korekta wartociowa
                elif i[33]:
                    if len(i[33]) <= 256:
                        self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","NrFaKorygowanej",str(i[33]).encode('utf-8'))
                    else:
                        self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","NrFaKorygowanej",str(i[34]).encode('utf-8'))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","NrFaKorygowanej",'BRAK')
                #WS 2019-10-11 - korekta wartociowa
                if i[34]:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","OkresFaKorygowanej",str(i[34]).encode('utf-8'))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","OkresFaKorygowanej",'BRAK')
                if i[29]:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","ZALZaplata",'{:.2f}'.format(i[29]))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","ZALZaplata",0)
                if i[30]:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","ZALPodatek",'{:.2f}'.format(i[30]))
                else:
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("Faktura","ZALPodatek",0)
                self.faktury_vat_jpk.Zamknij("Faktura")

            self.faktury_vat_jpk.WstawWRoot("FakturaCtrl")
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaCtrl","LiczbaFaktur",str(faktury['dane_sum'][0]))
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaCtrl","WartoscFaktur",'{:.2f}'.format(faktury['dane_sum'][1]))
            self.faktury_vat_jpk.Zamknij("FakturaCtrl")

            self.faktury_vat_jpk.WstawWRoot("StawkiPodatku")
            #WS 2019-10-14
            if len(faktury['dane_faktura_stawki'][0]) == 1:
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka1",str(float(int(faktury['dane_faktura_stawki'][0][0][0]))*0.01))
            elif len(faktury['dane_faktura_stawki'][0]) == 0:
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka1",'0.23')
            # self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka1",'0.23')
            if len(faktury['dane_faktura_stawki'][1]) == 1:
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka2",str(float(int(faktury['dane_faktura_stawki'][1][0][0]))*0.01))
            elif len(faktury['dane_faktura_stawki'][1]) == 0:
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka2",'0.08')
            # self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka2",'0.08')
            self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka3",'0.05')

            #WS 2019-08-30
            if len(faktury['dane_faktura_stawki'][2]) == 1 and faktury['dane_faktura_stawki'][2][0][0].isdigit():
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka4",str(float(int(faktury['dane_faktura_stawki'][2][0][0]))*0.01))
            else:
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka4",'0.00')
            if len(faktury['dane_faktura_stawki'][3]) == 1 and faktury['dane_faktura_stawki'][3][0][0].isdigit():
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka5",str(float(int(faktury['dane_faktura_stawki'][3][0][0]))*0.01))
            else:
                self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka5",'0.00')
            # if len(faktury['dane_faktura_stawki'])>=2:
            #     self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka4",str(float(int(faktury['dane_faktura_stawki'][0][0]))*0.01))
            #     self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka5",str(float(int(faktury['dane_faktura_stawki'][1][0]))*0.01))
            # elif len(faktury['dane_faktura_stawki'])==1:
            #     self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka4",str(float(int(faktury['dane_faktura_stawki'][0][0]))*0.01))
            #     self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka5",'0.00')
            # else:
            #     self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka4",'0.00')
            #     self.faktury_vat_jpk.WstawNowyWZWartoscia("StawkiPodatku","Stawka5",'0.00')
            self.faktury_vat_jpk.Zamknij("StawkiPodatku")

        else:
            self.faktury_vat_jpk.WstawWRoot("FakturaCtrl")
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaCtrl","LiczbaFaktur",'0')
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaCtrl","WartoscFaktur",'0')
            self.faktury_vat_jpk.Zamknij("FakturaCtrl")



        if faktury['dane_sum'][0]<>0:
            for j in faktury['dane_wierszy'][0]:
                #AB 2018-08-17
                if j[11] != 0 and str(j[13]).lower() not in ('null', 'none'):
                    self.faktury_vat_jpk.WstawTekst('<FakturaWiersz typ="G">')
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_2B",j[4].encode('utf-8'))
                    #AB 2018-08-17
                    #WS 2020-01-20
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz", "P_7", fs_jpk_pom.ZamienZastrzezoneZnaki(j[5][:256]))
                    # self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_7",j[5][:256].encode('utf-8'))
                    #AB 2018-08-17
                    if j[6].encode('utf-8') == '':
                        jm = 'Brak'
                    else:
                        jm = j[6].encode('utf-8')
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_8A", jm)
                    #AB 2018-08-17
                    if str(j[7]) in ('', '0'):
                        il = '1'
                    else:
                        il = str(j[7])
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_8B",il)
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_9A",'{:.2f}'.format(j[8]))
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_9B",'{:.2f}'.format(j[9]))
                    #AB 2018-08-17
                    if str(j[10]) == '':
                        upusty = '0'
                    else:
                        upusty = '{:.2f}'.format(j[10])

                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_10",upusty)
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_11",'{:.2f}'.format(j[11]))
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_11A",'{:.2f}'.format(j[12]))
                    if j[13].startswith('0'):
                        j[13]=j[13][1:]
                    self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWiersz","P_12",str(j[13]))
                    self.faktury_vat_jpk.Zamknij("FakturaWiersz")

            self.faktury_vat_jpk.WstawWRoot("FakturaWierszCtrl")
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWierszCtrl","LiczbaWierszyFaktur",str(faktury['dane_sum_wierszy'][0]))
            #WS 2019-10-11
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWierszCtrl","WartoscWierszyFaktur",'{:.2f}'.format(faktury['dane_sum_wierszy'][1]))
            self.faktury_vat_jpk.Zamknij("FakturaWierszCtrl")

        else:
            self.faktury_vat_jpk.WstawWRoot("FakturaWierszCtrl")
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWierszCtrl","LiczbaWierszyFaktur",'0')
            self.faktury_vat_jpk.WstawNowyWZWartoscia("FakturaWierszCtrl","WartoscWierszyFaktur",'0')
            self.faktury_vat_jpk.Zamknij("FakturaWierszCtrl")
        self.faktury_vat_jpk.Zamknij("JPK")

        #plik = tempfile.mktemp()
        #WS 2019-10-03
        plik = 'jpk_fa_'+datetime.datetime.now().strftime("%Y_%m_%d_%H_%M_%S")+'.xml'
        # plik = 'jpk_fa_'+time.strftime("%Y-%m-%d_%H_%M_%S", time.gmtime())+'.xml'

        self.faktury_vat_jpk.ZapiszPlik(plik,False,'<?xml version="1.0" encoding="utf-8"?>')
        file = open(plik,'r')

        #WS 2019-08-30
        tresc = file.read().replace('&','&amp;').replace('<JPK>', '<JPK xmlns="http://jpk.mf.gov.pl/wzor/2019/03/21/03211/" xmlns:etd="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2018/08/24/eD/DefinicjeTypy/">')
        # tresc = file.read().replace('&','&amp;').replace('<JPK>', '<JPK xmlns="http://jpk.mf.gov.pl/wzor/2017/11/13/1113/" xmlns:etd="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/">')

        file.close()

        file = open(plik,'w')

        file.write(tresc)
        file.close()

        stat = fs_jpk_pom.SprawdzJpk(plik,'xsd/jpk_fa.xsd')

        if stat=='OK':
            os.remove(plik)
            return stat,tresc

        else:
            os.system('mv '+plik+' '+'xsd/Blad_'+plik)
            return stat,'BLAD'


stat='OK'
dane=[]
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'DataOd':[1,],'DataDo':[1,],'Cel':[1,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_jpk_ewidencja_faktur_vat z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        Cel = rsglobal.Dekoduj(klucze['Cel'])


#-------------------------------------------------------------------------------
# Pobranie danych  (1)
#-------------------------------------------------------------------------------
if Funkcja == 1 and stat=='OK':
    #Pobieramy dane do nagwka
                    #AB 2018-08-17
    SQL=" SELECT REPLACE(nip, ' ', ''), CASE WHEN (nazwa1 IS NULL OR TRIM(nazwa1) = '') AND (nazwa2 IS NULL OR TRIM(nazwa2) = '') THEN nazwa ELSE COALESCE(nazwa1,'') || ' ' || COALESCE(nazwa2,'') END, "
    SQL+=" adr_kraj,adr_wojew,adr_powiat,adr_gmina,adr_ulica,adr_nry,adr_kod,adr_poczta,adr_miej,urzad_skarbowy_id,regon "
    #WS 2020-01-14
    SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND centrala;"
    # SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    stat,dane_naglowka,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd pobierania danych oddziau "
        dane.append(stat)
    #WS 2020-01-14
    elif len(dane_naglowka) == 0:
        stat="Brak oddziau oznaczonego jako centrala"
        dane.append(stat)

    #Pobieramy sum faktur i wartosci brutto
    if stat=='OK':
        SQL=" Select COUNT(firma_id),SUM(do_zaplaty) FROM rs_faktury WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan in ('Z','K')" #WS 2019-10-02 - sprawdzenie stanu
        stat,dane_sum_f,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum faktur "
            dane.append(stat)
    #Pobieramy sum korekt i wartosci brutto
    if stat=='OK':
        #WS 2019-09-11
        SQL="""SELECT
               (Select COUNT(DISTINCT nr_zbiorczy) FROM rs_korekty WHERE firma_id='{firma_id}' 
               AND data>='{DataOd}' AND data<='{DataDo}' AND nr_zbiorczy>0 AND stan in ('Z','K'))
               +
               (Select COUNT(firma_id) FROM rs_korekty WHERE firma_id='{firma_id}' 
               AND data>='{DataOd}' AND data<='{DataDo}' AND (nr_zbiorczy is null OR nr_zbiorczy=0) AND stan in ('Z','K'))
               ,sum(do_zaplaty-do_zaplaty_p) FROM rs_korekty WHERE firma_id='{firma_id}' AND data>='{DataOd}' AND data<='{DataDo}' AND stan in ('Z','K');
            """.format(firma_id = self.firma_id,
                       DataOd   = DataOd,
                       DataDo   = DataDo)
        # SQL=" Select count(firma_id),sum(do_zaplaty) FROM rs_korekty WHERE firma_id='"+self.firma_id+"' "
        # SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_sum_k,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum korekt "
            dane.append(stat)

    if stat=='OK':
        dane_sum = [dane_sum_f[0][0]+dane_sum_k[0][0],dane_sum_f[0][1]+dane_sum_k[0][1]]
        #WS 2020-01-14
        if dane_sum_f[0][0]+dane_sum_k[0][0] == 0:
            stat="Brak danych do wykonania zestawienia "
            dane.append(stat)


    #WS 2019-10-11 - pobieranie stawek VAT przeniesione wyej w kodzie
    #Pobieranie stawek VAT
    #WS 2019-08-30
    if stat=='OK':
        SQL="""SELECT v.stawka_vat
               FROM rs_faktury_vat v
               JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND v.stawka_vat in ('23', '22') AND f.stan in ('Z','K')
               UNION
               SELECT v.stawka_vat
               FROM rs_korekty_vat v
               JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND v.stawka_vat in ('23', '22') AND k.stan in ('Z','K');
            """.format(firma_id = self.firma_id,
                       DataOd   = DataOd,
                       DataDo   = DataDo)
        stat,dane_faktura_stawka_podstawowa,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania stawki podstawowej dla faktur/korekt  "
            dane.append(stat)
        elif len(dane_faktura_stawka_podstawowa) > 1:
            stat = "W podanym okresie, na fakturach/korektach wystpuje wicej ni jedna stawka podstawowa: "+', '.join([st[0].strip() for st in dane_faktura_stawka_podstawowa])
            dane.append(stat)

    if stat=='OK':
        SQL="""SELECT v.stawka_vat
               FROM rs_faktury_vat v 
               JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND v.stawka_vat in ('08', '07') AND f.stan in ('Z','K')
               UNION
               SELECT v.stawka_vat
               FROM rs_korekty_vat v
               JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND v.stawka_vat in ('08', '07') AND k.stan in ('Z','K');
            """.format(firma_id = self.firma_id,
                       DataOd   = DataOd,
                       DataDo   = DataDo)
        stat,dane_faktura_stawka_pierwsza,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania stawki obnionej pierwszej dla faktur/korekt  "
            dane.append(stat)
        elif len(dane_faktura_stawka_pierwsza) > 1:
            stat = "W podanym okresie, na fakturach/korektach wystpuje wicej ni jedna stawka obniona pierwsza: "+', '.join([st[0].strip() for st in dane_faktura_stawka_pierwsza])
            dane.append(stat)

    if stat=='OK':
        SQL="""SELECT v.stawka_vat
               FROM rs_faktury_vat v 
               JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND v.stawka_vat in ('04', 'oo') AND f.stan in ('Z','K')
               UNION
               SELECT v.stawka_vat
               FROM rs_korekty_vat v
               JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND v.stawka_vat in ('04', 'oo') AND k.stan in ('Z','K');
            """.format(firma_id = self.firma_id,
                       DataOd   = DataOd,
                       DataDo   = DataDo)
        stat,dane_faktura_stawka_trzecia,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania stawki obnionej trzeciej dla faktur/korekt  "
            dane.append(stat)
        elif len(dane_faktura_stawka_trzecia) > 1:
            stat = "W podanym okresie, na fakturach/korektach wystpuje wicej ni jedna stawka obniona trzecia: "+', '.join([st[0].strip() for st in dane_faktura_stawka_trzecia])
            dane.append(stat)

    if stat=='OK':
        SQL="""SELECT v.stawka_vat
               FROM rs_faktury_vat v 
               JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)
               JOIN rs_kontrahenci k ON (k.firma_id=f.firma_id AND k.platnik_id=f.kontrahent_id)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND k.kraj != 'PL' AND f.kraj_opodatkowania != 'PL' AND f.stan in ('Z','K')
               UNION
               SELECT v.stawka_vat
               FROM rs_korekty_vat v 
               JOIN rs_korekty f USING (firma_id, wyznacznik_id, data, numer)
               JOIN rs_kontrahenci k ON (k.firma_id=f.firma_id AND k.platnik_id=f.kontrahent_id)
               WHERE v.firma_id='{firma_id}' AND v.data>='{DataOd}' AND v.data<='{DataDo}' AND k.kraj != 'PL' AND f.kraj_opodatkowania != 'PL' AND f.stan in ('Z','K');
            """.format(firma_id = self.firma_id,
                       DataOd   = DataOd,
                       DataDo   = DataDo)
        stat,dane_faktura_stawka_czwarta,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania stawki obnionej czwartej dla faktur/korekt "
            dane.append(stat)
        elif len(dane_faktura_stawka_czwarta) > 1:
            stat = "W podanym okresie, na fakturach/korektach wystpuje wicej ni jedna stawka obniona czwarta: "+', '.join([st[0].strip() for st in dane_faktura_stawka_czwarta])
            dane.append(stat)

    if stat=='OK':
        dane_faktura_stawki = []
        dane_faktura_stawki.extend([dane_faktura_stawka_podstawowa, dane_faktura_stawka_pierwsza, dane_faktura_stawka_trzecia, dane_faktura_stawka_czwarta])

    #     #zapytanie dla faktur
    #     SQL=" SELECT stawka_vat FROM rs_faktury_vat WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
    #     SQL+="AND stawka_vat not in ('23','08','05','zw','oo','np','OP','OE')"
    #     stat,dane_faktura_stawki_czwarta,dump,dump=self.PolSQL.Execute(SQL,3)
    #     if stat<>'OK':
    #         stat="Bd pobierania stawek vat dla faktur "
    #         dane.append(stat)
    #
    # if stat=='OK':
    #     #zapytanie dla faktur
    #     SQL=" SELECT stawka_vat FROM rs_korekty_vat WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
    #     SQL+="AND stawka_vat not in ('23','08','05','zw','oo','np','OP','OE')"
    #     stat,dane_faktura_stawki_korekta,dump,dump=self.PolSQL.Execute(SQL,3)
    #     if stat<>'OK':
    #         stat="Bd pobierania stawek vat dla korekt "
    #         dane.append(stat)
    #
    # if stat =='OK': #laczymy dwie listy tak, zeby usunac duplikaty
    #     a = dane_faktura_stawki_faktura+dane_faktura_stawki_korekta
    #     dane_faktura_stawki = []
    #     for l in a:
    #         if a not in dane_faktura_stawki:
    #             dane_faktura_stawki.append(a)
    #     if len(dane_faktura_stawki)>0:
    #         dane_faktura_stawki = dane_faktura_stawki[0]


    #Dane do galazki Faktura (Faktury)
    if stat=='OK':
        SQL=" SELECT a.wyznacznik_id,a.data,a.numer,a.data_przychodu,"
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','F'), """
                                                                                        #AB 2018-08-17
        SQL+=" b.nazwa,b.adr_kod||' '||b.adr_miej||', '||b.adr_ulica||' '||b.adr_nry,    CASE WHEN b.kraj = 'PL' THEN REPLACE(b.nip, ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = b.kraj AND kr.czy_ue) || REPLACE(b.nip, ' ', '') END AS nip,a.data_przychodu, "
        SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat in ('23','22') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT sum(wartosc_vat) FROM rs_faktury_vat WHERE stawka_vat in ('23','22') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat in ('08','07') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT sum(wartosc_vat) FROM rs_faktury_vat WHERE stawka_vat in ('08','07') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat ='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE stawka_vat ='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        #WS 2019-08-29
        SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat in ('04','oo') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat ='03' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE stawka_vat in ('04','oo') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE stawka_vat ='03' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE b.kraj != 'PL' AND a.kraj_opodatkowania != 'PL' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat ='01' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE b.kraj != 'PL' AND a.kraj_opodatkowania != 'PL' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE stawka_vat ='01' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat ='00' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat in ('zw','np') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="a.do_zaplaty,"
        SQL+=" CASE WHEN a.data_przychodu=a.termin_zaplaty THEN 'true' ELSE 'false' END,"
        SQL+=" CASE WHEN (SELECT count(*) FROM rs_faktury_vat WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer AND stawka_vat='oo' )>0 THEN 'true' ELSE 'false' END,"
        SQL+=" CASE WHEN (SELECT count(*) FROM rs_faktury_vat WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer AND stawka_vat='zw' )>0 THEN 'true' ELSE 'false' END,"
        SQL+=" (SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id), "
        SQL+=" CASE WHEN (SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id)='FZ' THEN 'ZAL' ELSE 'VAT' END,"
        #te pola tylko dla korekt
        SQL+=" '','','', "
        #te pola tylko dla faktur zaliczkowych
        SQL+=" CASE WHEN (SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id)='FZ' THEN zaliczka_pozostalo ELSE 0 END, "
        SQL+=" CASE WHEN (SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id)='FZ' THEN a.kwota_netto * "
        #WS 2019-08-30 - dodane '04'
        SQL+=" (SELECT DISTINCT stawka_vat::FLOAT*0.01 FROM rs_faktury_vat WHERE stawka_vat in ('23','22','08','07','06','05','04','03','02','01') AND firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer)"
        SQL+=" /100* "
        SQL+=" (SELECT DISTINCT stawka_vat::FLOAT*0.01 FROM rs_faktury_vat WHERE stawka_vat in ('23','22','08','07','06','05','04','03','02','01') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer)) END,"
        SQL+=" (SELECT tekst_pod_podp FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id),"
        SQL+=" '','','' " #pola 33, 34, 35 dla korekt
        SQL+=" FROM rs_faktury a INNER JOIN rs_kontrahenci b ON (a.firma_id=b.firma_id AND a.platnik_id=b.kontrahent_id)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND a.stan in ('Z','K') "
        stat,dane_faktura_faktura,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych dla faktur "
            dane.append(stat)


    #Dane do galazki Faktura (KOREKTY)
    if stat=='OK':
        #WS 2019-09-11 - zamiana rs_faktury_vat na rs_korekty_vat
        SQL=" SELECT a.wyznacznik_id,a.data,a.numer,COALESCE(a.data_odbioru,a.data),"
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','F'), """
                                                                                        #AB 2018-08-17
        SQL+=" b.nazwa,b.adr_kod||' '||b.adr_miej||', '||b.adr_ulica||' '||b.adr_nry,    CASE WHEN b.kraj = 'PL' THEN REPLACE(b.nip, ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = b.kraj AND kr.czy_ue) || REPLACE(b.nip, ' ', '') END AS nip,a.data_przychodu, "
        #WS 2019-10-02
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE stawka_vat in ('23','22') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat-wartosc_vat_p     FROM rs_korekty_vat WHERE stawka_vat in ('23','22') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE stawka_vat in ('08','07') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat-wartosc_vat_p     FROM rs_korekty_vat WHERE stawka_vat in ('08','07') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE stawka_vat ='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat-wartosc_vat_p     FROM rs_korekty_vat WHERE stawka_vat ='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_korekty_vat WHERE stawka_vat in ('23','22') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_korekty_vat WHERE stawka_vat in ('23','22') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_korekty_vat WHERE stawka_vat in ('08','07') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_korekty_vat WHERE stawka_vat in ('08','07') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_korekty_vat WHERE stawka_vat ='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_korekty_vat WHERE stawka_vat ='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        #WS 2019-08-29
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE stawka_vat in ('04','oo') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat ='03' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat-wartosc_vat_p FROM rs_korekty_vat WHERE stawka_vat in ('04','oo') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE stawka_vat ='03' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE b.kraj != 'PL' AND a.kraj_opodatkowania != 'PL' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_netto FROM rs_faktury_vat WHERE stawka_vat ='01' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_vat-wartosc_vat_p FROM rs_korekty_vat WHERE b.kraj != 'PL' AND a.kraj_opodatkowania != 'PL' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        # SQL+="(SELECT wartosc_vat FROM rs_faktury_vat WHERE stawka_vat ='01' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE stawka_vat ='00' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="(SELECT wartosc_netto-wartosc_netto_p FROM rs_korekty_vat WHERE stawka_vat in ('zw','np') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"
        SQL+="a.do_zaplaty-a.do_zaplaty_p,"
        # SQL+="a.do_zaplaty,"
        SQL+=" CASE WHEN a.data_przychodu=a.termin_zaplaty THEN 'true' ELSE 'false' END,"
        SQL+=" CASE WHEN (SELECT count(*) FROM rs_korekty_vat WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer AND stawka_vat='oo' )>0 THEN 'true' ELSE 'false' END,"
        SQL+=" CASE WHEN (SELECT count(*) FROM rs_korekty_vat WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer AND stawka_vat='zw' )>0 THEN 'true' ELSE 'false' END,"
        SQL+=" (SELECT tekst_pod_podp FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id),"
        SQL+="'KOREKTA',"
        #te pola tylko dla korekt
        #WS 2019-09-11
        SQL+=" (SELECT opis FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id=a.firma_id AND kod=a.tytul_zmniejszenia_podatku),"
        # SQL+=" a.tytul_zmniejszenia_podatku,"
        SQL+=""" CASE WHEN a.wyznacznik_id_p IS NOT NULL THEN rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id_p||'", "'||a.data_p||'", "'||a.numer_p||'"]',a.typ_dok_p) ELSE '' END, """
        # SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','K'), """
        SQL+="  '',"
        #te pola tylko dla faktur zaliczkowych
        SQL+="'','', "
        SQL+=" (SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id), "
        #WS 2019-10-11 - pobranie numerw korygowanych dokumentw z opisu dla korekty wartociowej (ograniczenie do 256 znakw)
        SQL+=" CASE WHEN a.opis IS NOT NULL AND a.wyznacznik_id_p IS NULL THEN REPLACE(REPLACE(REPLACE(opis, 'FAKTURY',''), 'KOREKTY', ','), '\n','') ELSE '' END,"
        SQL+=" CASE WHEN a.opis IS NOT NULL AND a.wyznacznik_id_p IS NULL THEN 'Korekta sprzeday za okres od '||a.dostawy_od_dnia||' do '||a.dostawy_do_dnia ELSE '' END"
        SQL+=" FROM rs_korekty a INNER JOIN rs_kontrahenci b ON (a.firma_id=b.firma_id AND a.platnik_id=b.kontrahent_id)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND a.stan in ('Z','K') "
        SQL+=" AND (a.nr_zbiorczy=0 OR a.nr_zbiorczy IS NULL)" #WS 2019-10-02 - korekty zbiorcze obsuone osobno niej
        stat,dane_faktura_korekta,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych dla korekt "
            dane.append(stat)

    #WS 2019-10-02
    #Dane do galazki Faktura (KOREKTY ZBIORCZE)
    if stat=='OK':
        SQL= """    SELECT wyznacznik_id,data,'',data,
                           nr_zbiorczy::text||'/'||substring(data::text from 3 for 2),
                           k.nazwa,
                           k.adr_kod||' '||k.adr_miej||', '||k.adr_ulica||' '||k.adr_nry,
                           CASE WHEN k.kraj = 'PL' THEN REPLACE(k.nip, ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = k.kraj AND kr.czy_ue) || REPLACE(k.nip, ' ', '') END AS nip,
                           data_przychodu,
                           netto23,vat23,netto1,vat1,netto2,vat2,netto3,vat3,netto4,vat4,netto00,nettoZW,
                           do_zaplaty,P_16,P_18,P_19,tekst_pod_podp,'KOREKTA',tytul_zmniejszenia_podatku,NrFaKorygowanej,'','','',
                           typ_faktury
                    FROM (
                SELECT kor.firma_id,kor.wyznacznik_id,kor.data,kor.platnik_id,kor.nr_zbiorczy,kor.data_przychodu,
                SUM(CASE WHEN kv.stawka_vat in ('23','22') THEN kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as netto23, 
                SUM(CASE WHEN kv.stawka_vat in ('23','22') THEN kv.wartosc_vat-kv.wartosc_vat_p     ELSE 0 END) as vat23,
                SUM(CASE WHEN kv.stawka_vat in ('08','07') THEN kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as netto1, 
                SUM(CASE WHEN kv.stawka_vat in ('08','07') THEN kv.wartosc_vat-kv.wartosc_vat_p     ELSE 0 END) as vat1,
                SUM(CASE WHEN kv.stawka_vat = '05'         THEN kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as netto2, 
                SUM(CASE WHEN kv.stawka_vat = '05'         THEN kv.wartosc_vat-kv.wartosc_vat_p     ELSE 0 END) as vat2,
                SUM(CASE WHEN kv.stawka_vat in ('04','oo') THEN kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as netto3, 
                SUM(CASE WHEN kv.stawka_vat in ('04','oo') THEN kv.wartosc_vat-kv.wartosc_vat_p     ELSE 0 END) as vat3,
                SUM(CASE WHEN kontr.kraj != 'PL' AND kor.kraj_opodatkowania != 'PL' then kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as netto4, 
                SUM(CASE WHEN kontr.kraj != 'PL' AND kor.kraj_opodatkowania != 'PL' then kv.wartosc_vat-kv.wartosc_vat_p     ELSE 0 END) as vat4,
                SUM(CASE WHEN kv.stawka_vat = '00'         THEN kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as netto00, 
                SUM(CASE WHEN kv.stawka_vat in ('zw','np') THEN kv.wartosc_netto-kv.wartosc_netto_p ELSE 0 END) as nettoZW,
                SUM(kor.do_zaplaty-kor.do_zaplaty_p) as do_zaplaty,
                (CASE WHEN BOOL_AND(kor.data_przychodu=kor.termin_zaplaty) THEN 'true' ELSE 'false' END) as P_16,
                (CASE WHEN SUM(CASE WHEN kv.stawka_vat = 'oo' THEN 1 ELSE 0 END) > 0 THEN 'true' ELSE 'false' END) as P_18,
                (CASE WHEN SUM(CASE WHEN kv.stawka_vat = 'zw' THEN 1 ELSE 0 END) > 0 THEN 'true' ELSE 'false' END) as P_19,
                (SELECT tekst_pod_podp FROM rs_wyznaczniki WHERE firma_id=kor.firma_id AND wyznacznik_id=kor.wyznacznik_id) as tekst_pod_podp,
                (SELECT opis FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id=kor.firma_id AND kod=kor.tytul_zmniejszenia_podatku) as tytul_zmniejszenia_podatku,
                STRING_AGG(rsf_podaj_numer_dokumentu_na_wydruk('{firma_id}','["'||kor.wyznacznik_id_p||'", "'||kor.data_p||'", "'||kor.numer_p||'"]',kor.typ_dok_p), ',') as NrFaKorygowanej,
                '','','',
                (SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id=kor.firma_id AND wyznacznik_id=kor.wyznacznik_id) as typ_faktury,
                '','',''
                FROM rs_korekty kor
                JOIN rs_korekty_vat kv USING (firma_id, wyznacznik_id, data, numer)
                JOIN rs_kontrahenci kontr ON kor.firma_id = kontr.firma_id AND kor.platnik_id = kontr.kontrahent_id 
                WHERE kor.firma_id='{firma_id}' AND kor.data>='{DataOd}' AND kor.data<='{DataDo}' AND kor.nr_zbiorczy > 0 AND kor.stan in ('Z','K')
                GROUP BY kor.firma_id,kor.nr_zbiorczy,kor.wyznacznik_id,kor.data,kor.platnik_id,kor.data_przychodu,kor.tytul_zmniejszenia_podatku
                    ) as a
                    JOIN rs_kontrahenci k ON a.firma_id = k.firma_id and a.platnik_id = k.kontrahent_id;
             """
        SQL = SQL.format(firma_id = self.firma_id,
                         DataOd   = DataOd,
                         DataDo   = DataDo)
        stat,dane_faktura_korekta_zbiorcza,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych korekt zbiorczych "
            dane.append(stat)

    if stat=='OK':
        dane_faktura = [dane_faktura_faktura+dane_faktura_korekta+dane_faktura_korekta_zbiorcza]

    if stat=='OK': #liczymy sume netto i ilosc wierszy dla faktury (FAKTURY - pozycje zwykle)
        #WS 2019-09-11
        SQL=" Select COUNT(p.firma_id), SUM(p.wartosc_netto) FROM rs_faktury_pozycje p "
        SQL+=" JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.data>='"+DataOd+"' AND p.data<='"+DataDo+"' AND f.stan in ('Z','K') AND p.wartosc_netto != 0 AND p.stawka_vat IS NOT NULL"
        # SQL=" Select count(firma_id),sum(wartosc_netto) FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' "
        # SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_sum_f_pozycje_zwykle,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum faktur dla pozycji zwyklych "
            dane.append(stat)
    #Pobieramy sum wierszy i wartosci netto dla Korekt (pozycje zwykle)
    if stat=='OK':
        #WS 2019-09-11
        SQL=" Select COUNT(p.firma_id), SUM(p.wartosc_netto-p.wartosc_netto_p) FROM rs_korekty_pozycje p "
        SQL+=" JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.data>='"+DataOd+"' AND p.data<='"+DataDo+"' AND k.stan in ('Z','K') AND p.wartosc_netto-p.wartosc_netto_p != 0 AND p.stawka_vat IS NOT NULL"
        # SQL=" Select count(firma_id),sum(wartosc_netto) FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' "
        # SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_sum_k_pozycje_zwykle,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum korekt dla pozycji zwyklych "
            dane.append(stat)

    if stat=='OK': #liczymy sume netto i ilosc wierszy dla faktury (FAKTURY - pozycje opisowe)
        #WS 2019-09-11
        SQL=" Select COUNT(p.firma_id), SUM(p.wartosc_netto) FROM rs_faktury_pozycje_opisowe p "
        SQL+=" JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.data>='"+DataOd+"' AND p.data<='"+DataDo+"' AND f.stan in ('Z','K') AND p.wartosc_netto != 0 AND p.stawka_vat IS NOT NULL"
        # SQL=" Select count(firma_id),sum(wartosc_netto) FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' "
        # SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_sum_f_pozycje_opisowe,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum faktur dla pozycji opisowych "
            dane.append(stat)
    #Pobieramy sum wierszy i wartosci brutto dla Korekt (pozycje opisowe)
    if stat=='OK':
        #WS 2019-09-11
        SQL=" Select COUNT(p.firma_id), SUM(p.wartosc_netto-p.wartosc_netto_p) FROM rs_korekty_pozycje_opisowe p "
        SQL+=" JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.data>='"+DataOd+"' AND p.data<='"+DataDo+"' AND k.stan in ('Z','K') AND p.wartosc_netto-p.wartosc_netto_p != 0 AND p.stawka_vat IS NOT NULL"
        # SQL=" Select count(firma_id),sum(wartosc_netto) FROM rs_korekty_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' "
        # SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_sum_k_pozycje_opisowe,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum korekt dla pozycji opisowych "
            dane.append(stat)


    if stat=='OK':#laczymy wszystkie pobrane dane
        dane_sum_wierszy = [dane_sum_f_pozycje_zwykle[0][0]+dane_sum_f_pozycje_opisowe[0][0]+dane_sum_k_pozycje_zwykle[0][0]+dane_sum_k_pozycje_opisowe[0][0],
                            dane_sum_f_pozycje_zwykle[0][1]+dane_sum_f_pozycje_opisowe[0][1]+dane_sum_k_pozycje_zwykle[0][1]+dane_sum_k_pozycje_opisowe[0][1]]



#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------

    #pobieramy dane dla pozycji faktury (pozycje zwykle)
    if stat=='OK':
        SQL=" SELECT a.firma_id,a.wyznacznik_id,a.data,a.numer, "
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','F'), """
        #WS 2019-10-03
        SQL+=" b.nazwa,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN UPPER(b.jm2)   ELSE UPPER(b.jm1) END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.ilosc2       ELSE a.ilosc1 END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.cena_netto2  ELSE a.cena_netto1 END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.cena_brutto2 ELSE a.cena_brutto1 END,"
        SQL+=" a.upust_wartosc,a.wartosc_netto,a.wartosc_brutto,a.stawka_vat"
        # SQL+=" b.nazwa,b.jm1,a.ilosc1,a.cena_netto1,a.cena_brutto1,a.upust_wartosc,a.wartosc_netto,a.wartosc_brutto,a.stawka_vat"
        SQL+=" FROM rs_faktury_pozycje a INNER jOIN rs_artykuly b USING(firma_id, artykul_id)"
        SQL+=" JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)" #WS 2019-09-11
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.data>='"+DataOd+"' AND a.data<='"+DataDo+"' AND f.stan in ('Z','K')" #WS 2019-09-11 - sprawdzenie stanu
        stat,dane_wierszy_f_pozycje_zwykle,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych wierszy faktury dla pozycji zwykych "
            dane.append(stat)

    #pobieramy dane dla pozcji faktury (pozycje opisowe)
    if stat=='OK':
        #WS 2019-09-11
        SQL=" SELECT a.firma_id,a.wyznacznik_id,a.data,a.numer, "
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','F'), """
        SQL+=" a.opis_pozycji,'','',a.wartosc_netto,a.wartosc_brutto,'',a.wartosc_netto,a.wartosc_brutto,a.stawka_vat"
        SQL+=" FROM rs_faktury_pozycje_opisowe a"
        SQL+=" JOIN rs_faktury f USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.data>='"+DataOd+"' AND a.data<='"+DataDo+"' AND f.stan in ('Z','K')"
        # SQL=" SELECT firma_id,wyznacznik_id,data,numer, "
        # SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||wyznacznik_id||'", "'||data||'", "'||numer||'"]','F'), """
        # SQL+=" opis_pozycji,'','',wartosc_netto,wartosc_brutto,'',wartosc_netto,wartosc_brutto,stawka_vat"
        # SQL+=" FROM rs_faktury_pozycje_opisowe"
        # SQL+=" WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_wierszy_f_pozycje_opisowe,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych wierszy faktury dla pozycji opisowych "
            dane.append(stat)

    #pobieramy dane dla pozcji korekt (pozycje zwykle)
    if stat=='OK':
        SQL=" SELECT a.firma_id,a.wyznacznik_id,a.data,a.numer, "
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','K'), """
        #WS 2019-10-03
        SQL+=" b.nazwa,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN UPPER(b.jm2) ELSE UPPER(b.jm1) END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.ilosc2 ELSE a.ilosc1 END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.cena_netto2 ELSE a.cena_netto1 END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.cena_brutto2 ELSE a.cena_brutto1 END,"
        SQL+=" a.upust_wartosc,a.wartosc_netto-a.wartosc_netto_p,a.wartosc_brutto-a.wartosc_brutto_p,a.stawka_vat"
        # SQL+=" b.nazwa,b.jm1,a.ilosc1,a.cena_netto1,a.cena_brutto1,a.upust_wartosc,a.wartosc_netto,a.wartosc_brutto,a.stawka_vat"
        SQL+=" FROM rs_korekty_pozycje a INNER jOIN rs_artykuly b USING(firma_id, artykul_id)"
        SQL+=" JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)" #WS 2019-09-11
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.data>='"+DataOd+"' AND a.data<='"+DataDo+"' AND k.stan in ('Z','K')" #WS 2019-09-11 - sprawdzenie stanu
        SQL+=" AND (k.nr_zbiorczy=0 OR k.nr_zbiorczy IS NULL)" #WS 2019-10-02 - korekty zbiorcze obsuone niej
        stat,dane_wierszy_k_pozycje_zwykle,dump,dump=self.PolSQL.Execute(SQL,3)

        if stat<>'OK':
            stat="Bd pobierania danych wierszy korekty dla pozycji zwykych "
            dane.append(stat)

    #WS 2019-10-02
    #pobieramy dane dla pozcji korekt zbiorczych (pozycje zwykle)
    if stat=='OK':
        SQL=" SELECT a.firma_id,a.wyznacznik_id,a.data,a.numer, "
        SQL+=" nr_zbiorczy::text||'/'||substring(data::text from 3 for 2),"
        SQL+=" b.nazwa,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN UPPER(b.jm2) ELSE UPPER(b.jm1) END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.ilosc2 ELSE a.ilosc1 END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.cena_netto2 ELSE a.cena_netto1 END,"
        SQL+=" CASE WHEN b.faktura_w_jm2 THEN a.cena_brutto2 ELSE a.cena_brutto1 END,"
        SQL+=" a.upust_wartosc,a.wartosc_netto-a.wartosc_netto_p,a.wartosc_brutto-a.wartosc_brutto_p,a.stawka_vat"
        SQL+=" FROM rs_korekty_pozycje a INNER jOIN rs_artykuly b USING(firma_id, artykul_id)"
        SQL+=" JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.data>='"+DataOd+"' AND a.data<='"+DataDo+"' AND k.stan in ('Z','K')"
        SQL+=" AND k.nr_zbiorczy > 0"
        stat,dane_wierszy_k_zbiorcze_pozycje_zwykle,dump,dump=self.PolSQL.Execute(SQL,3)

        if stat<>'OK':
            stat="Bd pobierania danych wierszy korekty zbiorczej dla pozycji zwykych "
            dane.append(stat)

    #pobieramy dane dla pozcji korekt (pozycje opisowe)
    if stat=='OK':
        SQL=" SELECT a.firma_id,a.wyznacznik_id,a.data,a.numer, "
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','K'), """
        SQL+=" a.opis_pozycji,'','',a.wartosc_netto-a.wartosc_netto_p,a.wartosc_brutto-a.wartosc_brutto_p,'',a.wartosc_netto-a.wartosc_netto_p,a.wartosc_brutto-a.wartosc_brutto_p,a.stawka_vat"
        SQL+=" FROM rs_korekty_pozycje_opisowe a"
        SQL+=" JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.data>='"+DataOd+"' AND a.data<='"+DataDo+"' AND k.stan in ('Z','K')"
        SQL+=" AND (k.nr_zbiorczy=0 OR k.nr_zbiorczy IS NULL)" #WS 2019-10-02 - korekty zbiorcze obsuone niej
        # SQL=" SELECT firma_id,wyznacznik_id,data,numer, "
        # SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||wyznacznik_id||'", "'||data||'", "'||numer||'"]','F'), """
        # SQL+=" opis_pozycji,'','',wartosc_netto,wartosc_brutto,'',wartosc_netto,wartosc_brutto,stawka_vat"
        # SQL+=" FROM rs_korekty_pozycje_opisowe"
        # SQL+=" WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' "
        stat,dane_wierszy_k_pozycje_opisowe,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych wierszy korekty dla pozycji opisowych "
            dane.append(stat)

    #WS 2019-10-02
    #pobieramy dane dla pozcji korekt zbiorczych (pozycje opisowe)
    if stat=='OK':
        SQL=" SELECT a.firma_id,a.wyznacznik_id,a.data,a.numer, "
        SQL+=" nr_zbiorczy::text||'/'||substring(data::text from 3 for 2),"
        SQL+=" a.opis_pozycji,'','',a.wartosc_netto-a.wartosc_netto_p,a.wartosc_brutto-a.wartosc_brutto_p,'',a.wartosc_netto-a.wartosc_netto_p,a.wartosc_brutto-a.wartosc_brutto_p,a.stawka_vat"
        SQL+=" FROM rs_korekty_pozycje_opisowe a"
        SQL+=" JOIN rs_korekty k USING (firma_id, wyznacznik_id, data, numer)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.data>='"+DataOd+"' AND a.data<='"+DataDo+"' AND k.stan in ('Z','K')"
        SQL+=" AND k.nr_zbiorczy > 0"
        stat,dane_wierszy_k_zbiorcze_pozycje_opisowe,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych wierszy korekty zbiorczej dla pozycji opisowych "
            dane.append(stat)

    if stat=='OK':
        dane_wierszy = [dane_wierszy_f_pozycje_zwykle+dane_wierszy_f_pozycje_opisowe+dane_wierszy_k_pozycje_zwykle+dane_wierszy_k_zbiorcze_pozycje_zwykle+dane_wierszy_k_pozycje_opisowe+dane_wierszy_k_zbiorcze_pozycje_opisowe]

    #WS 2019-09-11
    if stat=='OK':
        if len(dane) > 0:
            stat = dane[0]

#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------



if Funkcja== 1 and stat=='OK':
    FAKTURY = {}
    FAKTURY['dane_naglowka'] = dane_naglowka
    if dane_sum[0]>0:
        FAKTURY['dane_sum'] = dane_sum
        FAKTURY['dane_faktura'] = dane_faktura
        FAKTURY['dane_faktura_stawki'] = dane_faktura_stawki
        FAKTURY['dane_sum_wierszy'] = dane_sum_wierszy
        FAKTURY['dane_wierszy'] = dane_wierszy
    else:
        FAKTURY['dane_sum'] = [0,0]

    faktury = FakturyVat(DataOd, DataDo, Cel)
    stat,wynik = faktury.ZapiszfakturyVat(FAKTURY)
    if stat=='OK':
       dane = [wynik]
    else:
        dane.append(stat)
