# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_jpk_ewidencja_zakupu_sprzedazy.py
# Purpose:     pobranie danych do JPK
# Author:      Marcin Natkaski
# Created:     2016/06/09
# RCS-ID:      $Id: fs_jpk_ewidencja_faktur_vat.py $
# Copyright:   (c) 2016 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# FUNKCJE
# 1 - Pobranie danych do JPK - Magazyny
# 2 - Pobranie danych do nagwka
# 3 - Sprawdzanie poprawnoci parametr?
# uzdatnienie: Jan Raburski
# 2018-12-03 Aleksander Bargie - 11304 - JPK_vat - kontrola weryfikacja nip-ow zagranicznych kontrahentw
# 2020-01-14 Wojciech Skowron   - 11814 - Pobieranie danych oddziau z centrali
# 2020-09-09 Wojciech Skowron   - 12103 - Zmiana warunkw dla pl K_11-K_20
# 2020-09-24 Wojciech Skowron   - 12133 - Zaokraglenia dla pl z kwota_ma i kwota_vat_ma
# 2020-12-03 Wojciech Skowron   - 12203 - Uwzgldnienie wart. NULL w data_wplywu przy pobieraniu dk do rejestru zakupu
# 2023-05-05 Wojciech Skowron   - (12103) Pobranie i uwzgldnienie pola sprzedaz_uslug w K_12


import rsglobal


class EwidencjaZakupuSprzedazy:
    def __init__(self,data_od,data_do,cel,warunkisprzedazy,email=''):
        from funkcje import fs_xml
        self.ewidencja_zakupu_sprzedazy_jpk = fs_xml.RSToXml()

        self.data_od = data_od
        self.data_do = data_do
        self.cel = cel
        self.warunkisprzedazy=warunkisprzedazy
        self.email=email


#-------------------------------------------------------------------------------

    def ZapiszEwidencje(self,rejestr):
        import time
        import tempfile
        import datetime
        from funkcje import fs_jpk_pom
        import os

        dane_naglowka = rejestr['dane_naglowka'][0]

        self.nip = dane_naglowka[0]
        self.nazwa = dane_naglowka[1]
        self.kraj = dane_naglowka[2]
        self.woje = dane_naglowka[3]
        self.powiat = dane_naglowka[4]
        self.gmina = dane_naglowka[5]
        self.ulica = dane_naglowka[6]
        self.numer = dane_naglowka[7]
        self.kod = dane_naglowka[8]
        self.poczta = dane_naglowka[9]
        self.miejsc = dane_naglowka[10]
        self.urzad = dane_naglowka[11]
        self.regon = dane_naglowka[12]
        
        sumy_k=[]
        for i in xrange(60):
            sumy_k.append(0)

        self.ewidencja_zakupu_sprzedazy_jpk.Inicjuj("JPK",2)
        self.ewidencja_zakupu_sprzedazy_jpk.WstawWRoot("tns:Naglowek")
        #if self.data_od<'2017-01-01':
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:KodFormularza wersjaSchemy="1-0" kodSystemowy="JPK_VAT (1)">JPK_VAT</tns:KodFormularza>')
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:WariantFormularza",'1')
        #else:
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:KodFormularza kodSystemowy="JPK_VAT (2)" wersjaSchemy="1-0">JPK_VAT</tns:KodFormularza>')
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:WariantFormularza",'2')
        self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:KodFormularza wersjaSchemy="1-1" kodSystemowy="JPK_VAT (3)">JPK_VAT</tns:KodFormularza>')
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:WariantFormularza",'3')
            
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:CelZlozenia",self.cel.encode('utf-8'))
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:DataWytworzeniaJPK",time.strftime("%Y-%m-%d")+'T'+datetime.datetime.now().time().isoformat()[:-7]+'Z')
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:DataOd",self.data_od)
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:DataDo",self.data_do)
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:NazwaSystemu","Anakonda")
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:DomyslnyKodWaluty",'PLN')
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Naglowek","tns:KodUrzedu",self.urzad)
        self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:Naglowek")
        self.ewidencja_zakupu_sprzedazy_jpk.WstawWRoot("tns:Podmiot1")
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Podmiot1","tns:NIP",str(self.nip).strip())
        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Podmiot1","tns:PelnaNazwa",self.nazwa.encode('utf-8'))
        if len(self.email)>=5:
            self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("Podmiot1","tns:Email",self.email.encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyW("Podmiot1","tns:IdentyfikatorPodmiotu")
        #if self.data_od<'2017-01-01':
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","tns:NIP",str(self.nip).strip())
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","tns:PelnaNazwa",self.nazwa.encode('utf-8'))
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","tns:REGON",str(self.regon).strip())
        #else:
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","etd:NIP",str(self.nip).strip())
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","etd:PelnaNazwa",self.nazwa.encode('utf-8'))
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","etd:REGON",str(self.regon).strip())
        #self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:IdentyfikatorPodmiotu")
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyW("Podmiot1","tns:AdresPodmiotu")
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:KodKraju",str(self.kraj))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Wojewodztwo",str(self.woje).encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Powiat",str(self.powiat).encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Gmina",str(self.gmina).encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Ulica",str(self.ulica).encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:NrDomu",str(self.numer))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:NrLokalu",0)
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Miejscowosc",str(self.miejsc).encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:KodPocztowy",str(self.kod))
        #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Poczta",str(self.poczta).encode('utf-8'))
        #self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:AdresPodmiotu")
        self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:Podmiot1")

        podatek=0
        if 'SprzedazWiersze' in rejestr.keys():
            num=0
            for i in rejestr['SprzedazWiersze']:
                num+=1
                podatek+=i[17]+i[19]+i[21]
                #self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:SprzedazWiersz typ="G" >')
                self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:SprzedazWiersz>')
                if self.data_od<'2017-01-01':
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:LpSprzedazy",str(num))
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:DataSprzedazy",i[3])
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:DataWystawienia",i[1])
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NrDokumentu",str(i[7]).encode('utf-8'))
                    if i[4].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NazwaNabywcy",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NazwaNabywcy",i[4].encode('utf-8'))

                    if i[6].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:AdresNabywcy",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:AdresNabywcy",i[6].encode('utf-8'))
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:LpSprzedazy",str(num))
                    if i[23].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NrKontrahenta",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NrKontrahenta",str(i[23]).encode('utf-8'))
                    if i[4].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NazwaKontrahenta",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:NazwaKontrahenta",i[4].encode('utf-8'))
                    if i[6].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:AdresKontrahenta",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:AdresKontrahenta",i[6].encode('utf-8'))
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:DowodSprzedazy",str(i[7]).encode('utf-8'))
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:DataWystawienia",i[1])
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:DataSprzedazy",i[3])


                if i[9].strip()=='PL' and i[22] in self.warunkisprzedazy[13]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_10",str(i[12]))
                    sumy_k[10]+=i[12]
                #WS 2023-05-05  #WS 2020-09-09
                if i[24] != 'DK' and (i[9].strip() != 'PL' and i[11].strip() != 'PL' and i[25] and i[22] in self.warunkisprzedazy[13]):
                # if i[9].strip() != 'PL' and i[11].strip() != 'PL' and (i[25] or i[24]=='DK') and i[22] in self.warunkisprzedazy[13]:
                # if i[9].strip()<>'PL' and i[22] in self.warunkisprzedazy[13]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_11",str(i[13]))
                    sumy_k[11]+=i[13]
                #WS 2023-05-05  #WS 2020-09-09
                if i[24] != 'DK' and (i[9].strip() != 'PL' and i[11].strip() != 'PL' and i[25] and i[26] and i[22] in self.warunkisprzedazy[13]):
                # if i[9].strip() != 'PL' and i[11].strip() != 'PL' and (i[25] or i[24]=='DK') and i[10] and i[22] in self.warunkisprzedazy[13]:
                # if i[9].strip()<>'PL' and i[10] and i[22] in self.warunkisprzedazy[13]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_12",str(i[14]))
                    sumy_k[12]+=i[14]
                #WS 2023-05-05  #WS 2020-09-09
                if (i[24] == 'DK' or i[9].strip() == 'PL' or (i[9].strip() != 'PL' and i[11].strip() == 'PL' and not i[25])) and i[22] in self.warunkisprzedazy[13]:
                # if (i[9].strip() == 'PL' or (i[9].strip() != 'PL' and i[11].strip() == 'PL' and (not i[25] or i[24]=='DK'))) and i[22] in self.warunkisprzedazy[13]:
                # if i[9].strip()=='PL' and i[22] in self.warunkisprzedazy[13]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_13",str(i[15]))
                    sumy_k[13]+=i[15]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_15",str(i[16]))
                    sumy_k[15]+=i[16]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_16",str(i[17]))
                    sumy_k[16]+=i[17]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_17",str(i[18]))
                    sumy_k[17]+=i[18]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_18",str(i[19]))
                    sumy_k[18]+=i[19]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_19",str(i[20]))
                    sumy_k[19]+=i[20]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_20",str(i[21]))
                    sumy_k[20]+=i[21]
                if i[8].strip()=='ww' or i[22] in self.warunkisprzedazy[0]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_21",str(i[13]))
                    sumy_k[21]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_21",0.0)
                #if i[9].strip()<>'PL' or i[22] in self.warunkisprzedazy[1]:
                if i[22] in self.warunkisprzedazy[1]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_22",str(i[13]))
                    sumy_k[22]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_22",0.0)
                if i[22] in self.warunkisprzedazy[2]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_23",str(i[13]))
                    sumy_k[23]+=i[13]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_24",str(i[17]+i[19]+i[21]))
                    sumy_k[24]+=i[17]+i[19]+i[21]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_23",0.0)
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_24",0.0)
                if i[22] in self.warunkisprzedazy[3]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_25",str(i[13]))
                    sumy_k[25]+=i[13]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartscia("SprzedazWiersz","tns:K_26",str(i[17]+i[19]+i[21]))
                    sumy_k[26]+=i[17]+i[19]+i[21]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_25",0.0)
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_26",0.0)
                if i[22] in self.warunkisprzedazy[4]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_27",str(i[13]))
                    sumy_k[27]+=i[13]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_28",str(i[17]+i[19]+i[21]))
                    sumy_k[28]+=i[17]+i[19]+i[21]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_27",0.0)
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_28",0.0)
                if i[22] in self.warunkisprzedazy[5]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_29",str(i[13]))
                    sumy_k[29]+=i[13]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_30",str(i[17]+i[19]+i[21]))
                    sumy_k[30]+=i[17]+i[19]+i[21]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_29",0.0)
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_30",0.0)
                if i[22] in self.warunkisprzedazy[6]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_31",str(i[13]))
                    sumy_k[31]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_31",0.0)
                if i[22] in self.warunkisprzedazy[7]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_32",str(i[13]))
                    sumy_k[32]+=i[13]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_33",str(i[17]+i[19]+i[21]))
                    sumy_k[33]+=i[17]+i[19]+i[21]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_32",0.0)
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_33",0.0)
                if i[22] in self.warunkisprzedazy[8]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_34",str(i[13]))
                    sumy_k[34]+=i[13]
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_35",str(i[17]+i[19]+i[21]))
                    sumy_k[35]+=i[17]+i[19]+i[21]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_34",0.0)
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_35",0.0)
                if i[22] in self.warunkisprzedazy[9]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_36",str(i[13]))
                    sumy_k[36]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_36",0.0)
                if i[22] in self.warunkisprzedazy[10]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_37",str(i[13]))
                    sumy_k[37]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_37",0.0)
                if i[22] in self.warunkisprzedazy[11]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_38",str(i[13]))
                    sumy_k[38]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_38",0.0)
                if i[22] in self.warunkisprzedazy[12]:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_39",str(i[13]))
                    sumy_k[39]+=i[13]
                else:
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazWiersz","tns:K_39",0.0)
                self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:SprzedazWiersz")

            self.ewidencja_zakupu_sprzedazy_jpk.WstawWRoot("tns:SprzedazCtrl")
            #print 'Tak wyglada 1 ', rejestr['sprzedaz_ctrl']
            #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazCtrl","LiczbaWierszySprzedazy",str(rejestr['sprzedaz_ctrl'][0][0]))
            #self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazCtrl","PodatekNalezny",str(rejestr['sprzedaz_ctrl'][0][1]))
            self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazCtrl","tns:LiczbaWierszySprzedazy",str(num))
            self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("SprzedazCtrl","tns:PodatekNalezny",str(podatek))
            self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:SprzedazCtrl")

        suma_kwot = 0
        if 'ZakupWiersze' in rejestr.keys():
            num=0
            for i in rejestr['ZakupWiersze']:
                #self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:ZakupWiersz typ="G" >')
                self.ewidencja_zakupu_sprzedazy_jpk.WstawTekst('<tns:ZakupWiersz>')
                num=num+1
                suma_kwot += i[6]+i[8]+i[9]+i[10]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:LpZakupu",str(num))
                if self.data_od<'2017-01-01':
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NazwaWystawcy",i[0].split('@#@')[0].encode('utf-8'))
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:AdresWystawcy",i[1].split('@#@')[0].encode('utf-8'))
                    if i[2].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NrIdWystawcy",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NrIdWystawcy",str(i[2]))
                    if i[3].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NrFaktury",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NrFaktury",i[3].encode('utf-8'))
                else:
                    if i[2].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NrDostawcy",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NrDostawcy",str(i[2]).encode('utf-8'))
                    if i[0].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NazwaDostawcy",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:NazwaDostawcy",i[0].encode('utf-8'))
                    if i[1].strip()=='':
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:AdresDostawcy",'BRAK')
                    else:
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:AdresDostawcy",i[1].encode('utf-8'))
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:DowodZakupu",str(i[3]).encode('utf-8'))
                    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:DataZakupu",i[11])
                    if i[4] != 'None':  #WS 2020-12-03
                        self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:DataWplywu",i[4])
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_43",str(i[5]))
                sumy_k[43]+=i[5]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_44",str(i[6]))
                sumy_k[44]+=i[6]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_45",str(i[7]))
                sumy_k[45]+=i[7]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_46",str(i[8]))
                sumy_k[46]+=i[8]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_47",str(i[9]))
                sumy_k[47]+=i[9]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_48",str(i[10]))
                sumy_k[48]+=i[10]
                self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupWiersz","tns:K_49",0.0)
                self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:ZakupWiersz")

            #wstawiam tutaj sum kwot, eby nie robi osobnej ptli zliczajcej
            self.ewidencja_zakupu_sprzedazy_jpk.WstawWRoot("tns:ZakupCtrl")
            self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupCtrl","tns:LiczbaWierszyZakupow",str(len(rejestr['ZakupWiersze'])))
            self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupCtrl","tns:PodatekNaliczony",str(suma_kwot))
            self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:ZakupCtrl")

        #else:
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawWRoot("ZakupCtrl")
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupCtrl","LiczbaWierszyZakupow",'0')
        #    self.ewidencja_zakupu_sprzedazy_jpk.WstawNowyWZWartoscia("ZakupCtrl","SumaNetto",'0')
        #    self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("ZakupCtrl")

        self.ewidencja_zakupu_sprzedazy_jpk.Zamknij("tns:JPK")


        if 'SrzedazWiersze' in rejestr.keys():
            sprzedaz = podatek
        else:
            sprzedaz = 0

        #plik = tempfile.mktemp()
        plik = 'jpk_vat_'+time.strftime("%Y-%m-%d_%H_%M_%S", time.gmtime())+'.xml'



        self.ewidencja_zakupu_sprzedazy_jpk.ZapiszPlik(plik,False,'<?xml version="1.0" encoding="utf-8"?>')
        file = open(plik,'r')

#        if self.data_od<'2017-01-01':
#            tresc = file.read().replace('&','&amp;').replace('<JPK>', '<JPK xmlns="http://jpk.mf.gov.pl/wzor/2016/03/09/03094/"'
#                                                                  ' xmlns:tns="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/">')
#        else:
#            tresc = file.read().replace('&','&amp;').replace('<JPK>', '<tns:JPK xmlns:etd="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/" xmlns:kck="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2013/05/23/eD/KodyCECHKRAJOW/" xmlns:tns="http://jpk.mf.gov.pl/wzor/2016/10/26/10261/" xmlns:xsi="http://www.w3.org/2001/XMLSchema">') #targetNamespace="http://jpk.mf.gov.pl/wzor/2016/10/26/10261/"
        tresc = file.read().replace('&','&amp;').replace('<JPK>', '<tns:JPK xmlns:etd="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/" xmlns:tns="http://jpk.mf.gov.pl/wzor/2017/11/13/1113/" xmlns:xsi="http://www.w3.org/2001/XMLSchema">') #targetNamespace="http://jpk.mf.gov.pl/wzor/2016/10/26/10261/"
#	<xsd:import namespace="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/" schemaLocation="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/StrukturyDanych_v4-0E.xsd"/>
#	<xsd:import namespace="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2013/05/23/eD/KodyCECHKRAJOW/" schemaLocation="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2013/05/23/eD/KodyCECHKRAJOW/KodyCechKrajow_v3-0E.xsd"/>      

        file.close()

        file = open(plik,'w')


        file.write(tresc)
        file.close()

        stat = fs_jpk_pom.SprawdzJpk(plik,'xsd/jpk_vat.xsd')

        if stat=='OK':
            os.remove(plik)
            return stat,(tresc,(podatek,suma_kwot,sumy_k))

        else:
            os.system('mv '+plik+' '+'xsd/Blad_'+plik)
            return stat,'BLAD'



stat='OK'
dane=[]
wyn1 = []
wyn2 = []


if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'DataOd':[1,],'DataDo':[1,],'Cel':[1,],'Email':[1,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_jpk_ewidencja_zakupu_sprzedazy z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,3]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        Cel = rsglobal.Dekoduj(klucze['Cel'])
        Email = rsglobal.Dekoduj(klucze['Email'])


#-------------------------------------------------------------------------------
# Pobranie danych nagwka  (2)
#-------------------------------------------------------------------------------
if Funkcja == 1 and stat=='OK':
    #Pobieramy parametry stae
    SQL="SELECT war_1,war_2,war_3,war_4,war_5,war_6,war_7,war_8,war_9,war_10 FROM rs_jpk_parametry "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND jpk_id='JPK_VAT'  AND data_od<='"+DataDo+"' ORDER BY data_od DESC LIMIT 1"
    stat,parametry,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd pobierania parametrw "
        dane.append(stat)
    elif not parametry:
        stat = "Dla podanych dat brak zarejestrowanych parametw staych"
        dane.append(stat)
    else:
        parametry1=parametry
        parametry=[]
        for parametr in parametry1:
            par = []
            for p in parametr:
                par.append(p.replace("`","'"))
            parametry.append(par)

    if parametry[0][7].strip()<>'' and parametry[0][5].strip()<>'<None>':
        warunkisprzedazy=rsglobal.rseval(parametry[0][7].strip())
        if len(warunkisprzedazy)<>14:
            stat='Nieprawidlowa liczba warunkow sprzedazy.'
            dane.append(stat)
    else:
        warunkisprzedazy=[[],[],[],[],[],[],[],[],[],[],[],[],[],['111']]
    #Pobieramy dane do nagwka
    if stat=='OK':
        SQL=" SELECT nip, CASE WHEN (nazwa1 IS NULL OR TRIM(nazwa1) = '') AND (nazwa2 IS NULL OR TRIM(nazwa2) = '') THEN nazwa ELSE COALESCE(nazwa1,'') || ' ' || COALESCE(nazwa2,'') END, "
        # SQL=" SELECT nip, nazwa, "
        SQL+="adr_kraj,adr_wojew,adr_powiat,adr_gmina,adr_ulica,adr_nry,adr_kod,adr_poczta,adr_miej,urzad_skarbowy_id, regon "
        #WS 2020-01-14
        SQL += " FROM rs_oddzialy WHERE firma_id='" + self.firma_id + "' AND centrala;"
        # SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        stat,dane_naglowka,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych oddziau "
            dane.append(stat)
        #WS 2020-01-14
        elif len(dane_naglowka) == 0:
            stat="Brak oddziau oznaczonego jako centrala "
            dane.append(stat)

    SprzedazWiersze=None
    #Dane do galazki SprzedazWiersz dla faktur
    if stat=='OK':
        if parametry[0][5].strip()<>'' and parametry[0][5].strip()<>'<None>':
            SQL=" SELECT a.wyznacznik_id,a.data,a.numer,a.data_przychodu, b.nazwa,a.do_zaplaty," #[0-5]
            SQL+="COALESCE(b.adr_kod,'')||' '||COALESCE(b.adr_miej,'')||' '||COALESCE(b.adr_ulica,'')||' '||COALESCE(b.adr_nry,'')," #[6]
            SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','F'), """  #[7]
            SQL+=" w.typ_faktury, b.kraj, k.czy_ue,a.kraj_opodatkowania,  " #[8-11]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat in ('zw','np') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[12]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[13]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat NOT IN ('zw') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[14]
            #SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat NOT IN ('zw','00') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[14]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat='00' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[15]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[16]
            SQL+="(SELECT sum(wartosc_vat) FROM rs_faktury_vat WHERE stawka_vat='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[17]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat in ('07','08') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[18]
            SQL+="(SELECT sum(wartosc_vat) FROM rs_faktury_vat WHERE stawka_vat in ('07','08') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[19]
            SQL+="(SELECT sum(wartosc_netto) FROM rs_faktury_vat WHERE stawka_vat in ('22','23') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[20]
            SQL+="(SELECT sum(wartosc_vat) FROM rs_faktury_vat WHERE stawka_vat in ('22','23') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[21]
                                                             #AB 04.12.18r
            SQL+=" '111', CASE WHEN b.kraj = 'PL' THEN REPLACE(COALESCE(b.nip,'BRAK'), ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = b.kraj AND kr.czy_ue) || REPLACE(b.nip, ' ', '') END AS nip, " #[22],[23] zaslepka dla symblu rejestru z dowodow ksiegowych
            SQL+=" 'F', nie_podlega_vat, sprzedaz_uslug"  # [24-26]  #WS 2020-09-09  #WS 2023-05-05
            SQL+=" FROM rs_faktury a  INNER JOIN rs_kontrahenci b ON (a.firma_id=b.firma_id AND a.platnik_id=b.kontrahent_id) "
            SQL+=" INNER JOIN rs_wyznaczniki w ON (a.firma_id=w.firma_id AND a.wyznacznik_id=w.wyznacznik_id) "
            SQL+=" INNER JOIN rs_kraje k ON (b.kraj=k.kraj ) "
            SQL+= parametry[0][5].replace('$firma',self.firma_id).replace('$$data_od$$',DataOd).replace('$$data_do$$',DataDo)
            rsglobal.ZapiszDoLogow('JPK SQL FAKTURY:'+str(SQL),1)
            stat,SprzedazWierszeFaktury,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat="Bd pobierania wierszy dla faktur "
                dane.append(stat)
            else:
                SprzedazWiersze=SprzedazWierszeFaktury

    #Dane do galazki SprzedazWiersz dla korekt
    if stat=='OK':
        if parametry[0][4].strip()<>'' and parametry[0][4].strip()<>'<None>':
            SQL=" SELECT a.wyznacznik_id,a.data,a.numer,a.data_przychodu, b.nazwa,a.do_zaplaty,"
            SQL+="COALESCE(b.adr_kod,'')||' '||COALESCE(b.adr_miej,'')||' '||COALESCE(b.adr_ulica,'')||' '||COALESCE(b.adr_nry,''),"
            SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"""+self.firma_id+"""','["'||a.wyznacznik_id||'", "'||a.data||'", "'||a.numer||'"]','F'), """
            SQL+=" w.typ_faktury, b.kraj, k.czy_ue,a.kraj_opodatkowania,  " #[8-11]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat in ('zw','np') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[12]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[13]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat NOT IN ('zw') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[14]
            #SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat NOT IN ('zw','00') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[14]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat='00' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[15]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[16]
            SQL+="(SELECT sum(wartosc_vat-wartosc_vat_p) FROM rs_korekty_vat WHERE stawka_vat='05' AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[17]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat in ('07','08') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[18]
            SQL+="(SELECT sum(wartosc_vat-wartosc_vat_p) FROM rs_korekty_vat WHERE stawka_vat in ('07','08') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[19]
            SQL+="(SELECT sum(wartosc_netto-wartosc_netto_p) FROM rs_korekty_vat WHERE stawka_vat in ('22','23') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[20]
            SQL+="(SELECT sum(wartosc_vat-wartosc_vat_p) FROM rs_korekty_vat WHERE stawka_vat in ('22','23') AND (firma_id=a.firma_id AND wyznacznik_id=a.wyznacznik_id AND data=a.data AND numer=a.numer) ),"#[21]
                        #AB 04.12.18r
            SQL+=" '111', CASE WHEN b.kraj = 'PL' THEN REPLACE(COALESCE(b.nip,'BRAK'), ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = b.kraj AND kr.czy_ue) || REPLACE(b.nip, ' ', '') END AS nip, " #[22] [23] zaslepka dla symblu rejestru z dowodow ksiegowych
            SQL+=" 'K', nie_podlega_vat, sprzedaz_uslug"  # [24-26]  #WS 2020-09-09  #WS 2023-05-05
            SQL+=" FROM rs_korekty a  INNER JOIN rs_kontrahenci b ON (a.firma_id=b.firma_id AND a.platnik_id=b.kontrahent_id) "
            SQL+=" INNER JOIN rs_wyznaczniki w ON (a.firma_id=w.firma_id AND a.wyznacznik_id=w.wyznacznik_id) "
            SQL+=" INNER JOIN rs_kraje k ON (b.kraj=k.kraj ) "
            SQL+= parametry[0][4].replace('$firma',self.firma_id).replace('$$data_od$$',DataOd).replace('$$data_do$$',DataDo)

        #print 'SQL pozycje KOREKTY:'
        #print SQL
            rsglobal.ZapiszDoLogow('JPK SQL KOREKTY:'+str(SQL),1)
            stat,SprzedazWierszeKorekty,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat="Bd pobierania wierszy dla korekt "
                dane.append(stat)
            else:
                if SprzedazWiersze==None:
                    SprzedazWiersze=SprzedazWierszeKorekty
                else:
                    SprzedazWiersze+=SprzedazWierszeKorekty

    #Dane do galazki SprzedazWiersz z dowodow ksiegowych
    if stat=='OK':
        if parametry[0][6].strip()<>'' and parametry[0][6].strip()<>'<None>':
            #WS 2020-09-24 - ROUND dla 5 oraz sum z 12-21
            SQL=" SELECT '',a.data,a.numer,a.data_rejestru, COALESCE(b.nazwa,'BRAK'),ROUND(a.kwota_ma,2)," #[0-5]
            SQL+="COALESCE(b.adr_kod,'')||' '||COALESCE(b.adr_miej,'')||' '||COALESCE(b.adr_ulica,'')||' '||COALESCE(b.adr_nry,'')," #[6]
            SQL+=" a.symbol_dok,  "  #[7]
            SQL+=" 'KR', b.kraj, k.czy_ue,b.kraj,  " #[8-11]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma in ('zw','np') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[12]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[13]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma NOT IN ('zw') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[14]
            #SQL+="(SELECT sum(kwota_ma) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma NOT IN ('zw','00') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[14]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma='00' AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[15]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma='05' AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[16]
            SQL+="(SELECT ROUND(sum(kwota_vat_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma='05' AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[17]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma IN ('07','08') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[18]
            SQL+="(SELECT ROUND(sum(kwota_vat_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma IN ('07','08') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[19]
            SQL+="(SELECT ROUND(sum(kwota_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma IN ('22','23') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[20]
            SQL+="(SELECT ROUND(sum(kwota_vat_ma),2) FROM rs_dowody_ksiegowe_pozycje WHERE stawka_vat_ma IN ('22','23') AND (firma_id=a.firma_id AND okres_id=a.okres_id AND dowod_id=a.dowod_id AND nazwa_id=a.nazwa_id AND data=a.data AND numer=a.numer) ),"#[21]
                #AB 04.12.18r
            SQL+=" a.rejestr, CASE WHEN b.kraj = 'PL' THEN REPLACE(COALESCE(b.nip,'BRAK'), ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = b.kraj AND kr.czy_ue) || REPLACE(b.nip, ' ', '') END AS nip, " #[22] [23]
            SQL+=" 'DK', NULL, NULL"  # [24-26]  #WS 2020-09-09  #WS 2023-05-05
            SQL+=" FROM rs_dowody_ksiegowe a  INNER JOIN rs_kontrahenci b ON (a.firma_id=b.firma_id AND a.kontrahent_id=b.kontrahent_id) "
            SQL+=" INNER JOIN rs_kraje k ON (b.kraj=k.kraj ) "
            SQL+= parametry[0][6].replace('$firma',self.firma_id).replace('$$data_od$$',DataOd).replace('$$data_do$$',DataDo)
            rsglobal.ZapiszDoLogow('JPK SQL DOW.SPRZEDAZ:'+str(SQL),1)
            stat,SprzedazWierszeDowody,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat="Bd pobierania wierszy dla dowodow "
                dane.append(stat)
            else:
                if SprzedazWiersze==None:
                    SprzedazWiersze=SprzedazWierszeDowody
                else:
                    SprzedazWiersze+=SprzedazWierszeDowody


    #Pobieranie danych do rejestry zakupu (wykomentowany kod to jest funkjca pobierajca rajestr zakupu w ANAKONDZIE) - NIE USUWA!!!
    if stat=='OK':
        SQL=" SELECT CASE WHEN NOT k.kontrahent_id IS NULL THEN TRIM(COALESCE(k.nazwa,'')) ELSE 'BRAK' END,"
        SQL+= " CASE WHEN NOT k.kontrahent_id IS NULL THEN COALESCE(k.adr_kod,'')||' '||TRIM(COALESCE(k.adr_miej,''))||', '||TRIM(COALESCE(k.adr_ulica,''))||' '||TRIM(COALESCE(k.adr_nry,'')) ELSE 'BRAK' END,"
                                        #AB 04.12.18r
        SQL+="  CASE WHEN k.kontrahent_id IS NOT NULL THEN TRIM(CASE WHEN k.kraj = 'PL' THEN "
        SQL+="REPLACE(COALESCE(k.nip,'BRAK'), ' ', '') ELSE (SELECT kraj FROM rs_kraje kr WHERE kr.kraj = k.kraj AND "
        SQL+="kr.czy_ue) || REPLACE(k.nip, ' ', '') END) ELSE 'BRAK' END AS nipp, "
        SQL+=" dk.symbol_dok, "
        SQL+="dk.data_wplywu, "
        SQL+=" CASE WHEN dk.rejestr IN "+str(tuple(parametry[0][0].encode('utf-8').split(',')))+u" THEN SUM(COALESCE(dkp.kwota_wn,0)) ELSE 0 END, "
        SQL+=" CASE WHEN dk.rejestr IN "+str(tuple(parametry[0][0].encode('utf-8').split(',')))+u" THEN SUM(COALESCE(dkp.kwota_vat_wn,0)) ELSE 0 END, "
#        SQL+=" CASE WHEN dk.rejestr='"+parametry[0][0].encode('utf-8')+"' THEN SUM(COALESCE(dkp.kwota_wn,0)) ELSE 0 END, "
#        SQL+=" CASE WHEN dk.rejestr='"+parametry[0][0].encode('utf-8')+"' THEN SUM(COALESCE(dkp.kwota_vat_wn,0)) ELSE 0 END, "
        SQL+=u" CASE WHEN dk.rejestr not in"+str(tuple(parametry[0][1].encode('utf-8').split(',')))+u"  THEN SUM(COALESCE(dkp.kwota_wn,0)) ELSE 0 END, "
        SQL+=u" CASE WHEN dk.rejestr not in "+str(tuple(parametry[0][1].encode('utf-8').split(',')))+u" THEN SUM(COALESCE(dkp.kwota_vat_wn,0)) ELSE 0 END, "
        SQL+=" CASE WHEN dk.rejestr IN "+str(tuple(parametry[0][2].encode('utf-8').split(',')))+u"  THEN SUM(COALESCE(dkp.kwota_vat_wn,0)) ELSE 0 END, "
        SQL+=u" CASE WHEN dk.rejestr IN "+str(tuple(parametry[0][3].encode('utf-8').split(',')))+u" THEN SUM(COALESCE(dkp.kwota_vat_wn,0)) ELSE 0 END, "
        SQL+="dk.data_wyst "
        # tabele i filtry wydruku
        SQL+=" FROM rs_dowody_ksiegowe dk INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,dowod_id,nazwa_id,data,numer)"
        SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (dk.firma_id=k.firma_id AND dk.kontrahent_id=k.kontrahent_id)"
        SQL+=" LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk "
        SQL+=" ON (dk.firma_id=dkk.firma_id AND dk.dowod_id=dkk.dowod_id AND dk.nazwa_id=dkk.nazwa_id AND dk.data=dkk.data AND dk.numer=dkk.numer) "
        SQL+=" INNER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod) "
        if parametry[0][8].strip()<>'' and parametry[0][8].strip()<>'<None>':
            SQL+= parametry[0][8].replace('$firma',self.firma_id).replace('$$data_od$$',DataOd).replace('$$data_do$$',DataDo)
        else:
            SQL+=" WHERE dk.firma_id='"+self.firma_id+"' AND COALESCE(dk.data_rejestru,dk.data)>='"+str(DataOd)+"' AND COALESCE(dk.data_rejestru,dk.data)<='"+str(DataDo)+"' "
            SQL+=" AND NOT dkp.stawka_vat_wn IS NULL AND NOT dkp.sposob_rozl IN (' ','N') AND NOT dk.rejestr IS NULL AND rv.typ='Z' "
            SQL += " AND NOT dkp.zamkniecie_kregu AND dkp.pobierac_na_rejestr AND NOT dkp.stawka_vat_wn IS NULL "  # JR 2019-06-07 11504
            #SQL+=" GROUP BY dk.data_wplywu,dk.symbol_dok,dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.rejestr,dkp.kwota_wn, dkp.kwota_vat_wn,"
            SQL+=" GROUP BY dk.data_wplywu,dk.symbol_dok,dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.rejestr,"
                                    #AB 04.12.18r
            SQL+=" k.kontrahent_id,k.nazwa,nipp,k.adr_kod,k.adr_miej,k.adr_ulica,k.adr_nry,"
            SQL+="dkk.nazwa,dkk.nip,dkk.adr_kod,dkk.adr_miej,dkk.adr_ulica,dkk.adr_nry,dk.data_wyst,dk.data_rejestru"
            SQL+=" ORDER BY dk.data,dk.dowod_id,dk.numer;"

        rsglobal.ZapiszDoLogow('JPK SQL DOW.ZAKUP:'+str(SQL),1)
        stat,ZakupWierszePrzed,dump,dump = self.PolSQL.Execute(SQL,3)
        # Dopiero tutaj bdziemy filrowa wynik z zapytania bo bdzie szybciej ni w SQL
        ZakupWiersze = []
        if parametry[0][8].strip() != '' and parametry[0][8].strip() != '<None>':  #WS 2020-12-03
            for b in ZakupWierszePrzed:
                #if (b[4] >=DataOd and b[4] <=DataDo and b[4].strip()<>''):
                #WS 2020-12-03
                if (b[4] <= DataDo and b[4].strip() != '') or b[4] == 'None':
                # if (b[4] <=DataDo and b[4].strip()<>''):
                    ZakupWiersze.append(b)
                else:
                    rsglobal.ZapiszDoLogow('Odrzucony:'+str(b),1)
        else:
            # rezygnacja z odrzucenia
            ZakupWiersze=ZakupWierszePrzed

        #wyn2= LStawek


if Funkcja== 1 and stat=='OK':
    REJESTR = {}
    REJESTR['dane_naglowka']=dane_naglowka

    if len(SprzedazWiersze)>0:
    #if sprzedaz_ctrl[0]>0 :
    #    REJESTR['sprzedaz_ctrl'] = sprzedaz_ctrl
        REJESTR['SprzedazWiersze'] = SprzedazWiersze
    if len(ZakupWiersze)>0:
        REJESTR['ZakupWiersze'] = ZakupWiersze

    rejestr = EwidencjaZakupuSprzedazy(DataOd, DataDo, Cel,warunkisprzedazy,Email)
    stat,wynik = rejestr.ZapiszEwidencje(REJESTR)
    if stat=='OK':
        dane = [wynik[0]]
        wyn1 = wynik[1]
    else:
        dane.append(stat)
