# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_jpk_magazyny.py
# Purpose:     pobranie danych do JPK
# Author:      Marcin Natkaski
# Created:     2016/06/09
# RCS-ID:      $Id: fs_jpk_magazyny.py $
# Copyright:   (c) 2016 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2018-08-20 Aleksander Bargie - 11067 - JPK_MAG - poprawki
# 2020-01-14 Wojciech Skowron   - 11815 - Pobieranie danych firmy z centrali
# 2020-01-20 Wojciech Skowron   - 11815 - Podmiana zastrzeonych znakw w nazwie towaru (&,<,>,',")

class Magazyny:
    def __init__(self,data_od,data_do,cel,magazyn):
        from funkcje import fs_xml
        self.magazyny_jpk = fs_xml.RSToXml()
        self.data_od = data_od
        self.data_do = data_do
        self.magazyn = magazyn
        self.cel = cel


#-------------------------------------------------------------------------------

    def ZapiszMagazyny(self,magazyny):
        import time
        import tempfile
        import rsglobal
        import datetime
        from funkcje import fs_jpk_pom
        import os


        dane_naglowka = magazyny['dane_naglowka']
        d = magazyny

        self.nip = dane_naglowka[0][0]
        self.nazwa = dane_naglowka[0][1]
        self.kraj = dane_naglowka[0][2]
        self.woje = dane_naglowka[0][3]
        self.powiat = dane_naglowka[0][4]
        self.gmina = dane_naglowka[0][5]
        self.ulica = dane_naglowka[0][6]
        self.numer = dane_naglowka[0][7]
        self.kod = dane_naglowka[0][8]
        self.poczta = dane_naglowka[0][9]
        self.miejsc = dane_naglowka[0][10]
        self.urzad = dane_naglowka[0][11]
        self.regon = dane_naglowka[0][12]
        rsglobal.ZapiszDoLogow('!!!!! POCZTEK CSV',1)

        if 'sumy_pz' in d.keys():
            self.sumy_pz = d['sumy_pz'][0]
            self.wartosc_pz = d['wartosc_pz']
            self.wiersze_pz = d['wiersze_pz']
        if 'sumy_wz' in d.keys():
            self.sumy_wz = d['sumy_wz'][0]
            self.wartosc_wz = d['wartosc_wz']
            self.wiersze_wz = d['wiersze_wz']
        if 'sumy_rw' in d.keys():
            self.sumy_rw = d['sumy_rw'][0]
            self.wartosc_rw = d['wartosc_rw']
            self.wiersze_rw = d['wiersze_rw']
        if 'sumy_mm' in d.keys():
            self.sumy_mm = d['sumy_mm'][0]
            self.wartosc_mm = d['wartosc_mm']
            self.wiersze_mm = d['wiersze_mm']

        rsglobal.ZapiszDoLogow('!!!! Sumy przygotowane',1)

        #!!! Prosz nie usuwa zakomentowanch wierszy. Niewykluczone, e bd potrzebne

        self.magazyny_jpk.Inicjuj("JPK",2)
        self.magazyny_jpk.WstawWRoot("Naglowek")
        self.magazyny_jpk.WstawTekst('<KodFormularza wersjaSchemy="1-0" kodSystemowy="JPK_MAG (1)">JPK_MAG</KodFormularza>')
        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","WariantFormularza",'1')
        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","CelZlozenia",self.cel.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","DataWytworzeniaJPK",time.strftime("%Y-%m-%d")+'T'+datetime.datetime.now().time().isoformat()[:-7]+'Z')

        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","DataOd",self.data_od)
        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","DataDo",self.data_do)
        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","DomyslnyKodWaluty",'PLN')
        self.magazyny_jpk.WstawNowyWZWartoscia("Naglowek","KodUrzedu",self.urzad)
        self.magazyny_jpk.Zamknij("Naglowek")
        self.magazyny_jpk.WstawWRoot("Podmiot1")
        self.magazyny_jpk.WstawNowyW("Podmiot1","IdentyfikatorPodmiotu")
        self.magazyny_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","tns:NIP",str(self.nip).strip())
        self.magazyny_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","tns:PelnaNazwa",self.nazwa.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("IdentyfikatorPodmiotu","tns:REGON",str(self.regon).strip())
        self.magazyny_jpk.Zamknij("IdentyfikatorPodmiotu")
        self.magazyny_jpk.WstawNowyW("Podmiot1","AdresPodmiotu")
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:KodKraju",self.kraj.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Wojewodztwo",self.woje.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Powiat",self.powiat.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Gmina",self.gmina.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Ulica",self.ulica.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:NrDomu",str(self.numer))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:NrLokalu",0)
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Miejscowosc",self.miejsc.encode('utf-8'))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:KodPocztowy",str(self.kod))
        self.magazyny_jpk.WstawNowyWZWartoscia("AdresPodmiotu","tns:Poczta",self.poczta.encode('utf-8'))
        self.magazyny_jpk.Zamknij("AdresPodmiotu")
        self.magazyny_jpk.Zamknij("Podmiot1")
        self.magazyny_jpk.WstawNowyWZWartoscia("JPK","Magazyn",str(self.magazyn))

        rsglobal.ZapiszDoLogow('!!!! Koniec nagwka',1)
        #Jeeli mamy jakie PZ to wstawiamy
        if 'sumy_pz' in d.keys():
            self.magazyny_jpk.WstawWRoot("PZ")
            rsglobal.ZapiszDoLogow('!!!! Wstawianie PZ - z danymi',1)
            rsglobal.ZapiszDoLogow('!!!! Naglowki PZ',1)
            for j in self.wartosc_pz:
                rsglobal.ZapiszDoLogow('! j '+str(j),1)
                self.magazyny_jpk.WstawNowyW("PZ","PZWartosc")
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","NumerPZ",j[7].encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","DataPZ",j[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","WartoscPZ",str(j[4]))
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","DataOtrzymaniaPZ",j[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","Dostawca",j[5].encode('utf-8'))
                #self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","NumerFaPZ",j[6].encode('utf-8'))
                #self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","DataFaPZ",j[6].encode('utf-8'))
                #self.magazyny_jpk.WstawNowyWZWartoscia("PZWartosc","DataFaPZ",j[2])
                self.magazyny_jpk.Zamknij("PZWartosc")
            for l in self.wiersze_pz:
                rsglobal.ZapiszDoLogow('! l '+str(l),1)
                self.magazyny_jpk.WstawNowyW("PZ","PZWiersz")
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","Numer2PZ",l[10])
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","KodTowaruPZ",l[4].encode('utf-8'))
                #WS 2020-01-20
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz", "NazwaTowaruPZ", fs_jpk_pom.ZamienZastrzezoneZnaki(l[5]))
                # self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","NazwaTowaruPZ",l[5].encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","IloscPrzyjetaPZ",str(l[6]))
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","JednostkaMiaryPZ",l[7].encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","CenaJednPZ",str(l[8]))
                self.magazyny_jpk.WstawNowyWZWartoscia("PZWiersz","WartoscPozycjiPZ",str(round(l[9],2)))
                self.magazyny_jpk.Zamknij("PZWiersz")
            #self.magazyny_jpk.Zamknij("PZWiersz")
            self.magazyny_jpk.WstawNowyW("PZ","PZCtrl")
            self.magazyny_jpk.WstawNowyWZWartoscia("PZCtrl","LiczbaPZ",str(self.sumy_pz[0]))
            self.magazyny_jpk.WstawNowyWZWartoscia("PZCtrl","SumaPZ",str(self.sumy_pz[1]))
            self.magazyny_jpk.Zamknij("PZCtrl")
            self.magazyny_jpk.Zamknij("PZ")
        #Jeeli nie byo dokumentw to i tak musimy zachowa struktur (niektre pola s wymagalne)
        # else:
        #     rsglobal.ZapiszDoLogow('!!!! Wstawianie PZ - pusta struktura',1)
        #     self.magazyny_jpk.WstawWRoot("PZ")
        #     self.magazyny_jpk.WstawNowyW("PZ","PZWartosc")
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","NumerPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","DataPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","WartoscPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","DataOtrzymaniaPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","Dostawca",1)
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","NumerFaPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWartosc","DataFaPZ",1)
        #     self.magazyny_jpk.Zamknij("PZWartosc")
        #     self.magazyny_jpk.WstawNowyW("PZ","PZWiersz")
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","Numer2PZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","KodTowaruPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","NazwaTowaruPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","IloscPrzyjetaPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","JednostkaMiaryPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","CenaJednPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZWiersz","WartoscPozycjiPZ",1)
        #     self.magazyny_jpk.Zamknij("PZWiersz")
        #     self.magazyny_jpk.WstawNowyW("PZ","PZCtrl")
        #     self.magazyny_jpk.WstawNowyW("PZCtrl","LiczbaPZ",1)
        #     self.magazyny_jpk.WstawNowyW("PZCtrl","SumaPZ",1)
        #     self.magazyny_jpk.Zamknij("PZCtrl")
        #     self.magazyny_jpk.Zamknij("PZ")



        #Jeeli mamy jakie WZ to wstawiamy
        if 'sumy_wz' in d.keys():
            rsglobal.ZapiszDoLogow('!!!! Wstawianie WZ - z danymi',1)
            self.magazyny_jpk.WstawWRoot("WZ")

            rsglobal.ZapiszDoLogow('!!!! Wstawianie WZ - nagwki',1)
            for m in self.wartosc_wz:
                rsglobal.ZapiszDoLogow('!! m '+str(m),1)
                self.magazyny_jpk.WstawNowyW("WZ","WZWartosc")
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","NumerWZ",str(m[7]).encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","DataWZ",m[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","WartoscWZ",str(m[4]))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","DataWydaniaWZ",m[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","OdbiorcaWZ",str(m[5]).encode('utf-8'))
                #self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","NumerFaWZ",str(m[6]).encode('utf-8'))
                #self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","DataFaWZ",m[2])
                #self.magazyny_jpk.WstawNowyWZWartoscia("WZWartosc","DataFaWZ",str(m[6]).encode('utf-8'))
                self.magazyny_jpk.Zamknij("WZWartosc")
            rsglobal.ZapiszDoLogow('!!!! Wstawianie WZ - wiersze',1)
            for k in self.wiersze_wz:
                rsglobal.ZapiszDoLogow('!! k '+str(k),1)
                self.magazyny_jpk.WstawNowyW("WZ","WZWiersz")
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","Numer2WZ",str(k[10]).encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","KodTowaruWZ",str(k[4]).strip())
                #WS 2020-01-20
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz", "NazwaTowaruWZ", fs_jpk_pom.ZamienZastrzezoneZnaki(k[5]))
                # self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","NazwaTowaruWZ",str(k[5]).strip().encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","IloscWydanaWZ",str(k[6]))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","JednostkaMiaryWZ",k[7].encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","CenaJednWZ",str(k[8]))
                self.magazyny_jpk.WstawNowyWZWartoscia("WZWiersz","WartoscPozycjiWZ",str(round(k[9],2)))
                self.magazyny_jpk.Zamknij("WZWiersz")
            self.magazyny_jpk.WstawNowyW("WZ","WZCtrl")
            self.magazyny_jpk.WstawNowyWZWartoscia("WZCtrl","LiczbaWZ",str(self.sumy_wz[0]))
            self.magazyny_jpk.WstawNowyWZWartoscia("WZCtrl","SumaWZ",str(self.sumy_wz[1]))
            self.magazyny_jpk.Zamknij("WZCtrl")
            self.magazyny_jpk.Zamknij("WZ")

        #Jeeli nie byo dokumentw to i tak musimy zachowa struktur (niektre pola s wymagalne)
        # else:
        #     rsglobal.ZapiszDoLogow('!!!! Wstawianie PZ - pusta struktura',1)
        #     self.magazyny_jpk.WstawWRoot("WZ")
        #     self.magazyny_jpk.WstawNowyW("WZ","WZWartosc")
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","NumerWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","DataWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","WartoscWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","DataWydaniaWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","OdbiorcaWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","NumerFaWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWartosc","DataFaWZ",1)
        #     self.magazyny_jpk.Zamknij("WZWartosc")
        #     self.magazyny_jpk.WstawNowyW("WZ","WZWiersz")
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","Numer2WZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","KodTowaruWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","NazwaTowaruWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","IloscWydanaWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","JednostkaMiaryWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","CenaJednWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZWiersz","WartoscPozycjiWZ",1)
        #     self.magazyny_jpk.Zamknij("WZWiersz")
        #     self.magazyny_jpk.WstawNowyW("WZ","WZCtrl")
        #     self.magazyny_jpk.WstawNowyW("WZCtrl","LiczbaWZ",1)
        #     self.magazyny_jpk.WstawNowyW("WZCtrl","SumaWZ",1)
        #     self.magazyny_jpk.Zamknij("WZCtrl")
        #     self.magazyny_jpk.Zamknij("WZ")


        #Jeeli mamy jakie RW to wstawiamy
        if 'sumy_rw' in d.keys():
            rsglobal.ZapiszDoLogow('!!!! Wstawianie RW - z danymi',1)
            self.magazyny_jpk.WstawWRoot("RW")
            rsglobal.ZapiszDoLogow('!!!! Wstawianie RW - naglowki',1)
            for g in self.wartosc_rw:
                rsglobal.ZapiszDoLogow('!! g '+str(g),1)
                self.magazyny_jpk.WstawNowyW("RW","RWWartosc")
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWartosc","NumerRW",str(g[7]).encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWartosc","DataRW",g[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWartosc","WartoscRW",str(g[4]))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWartosc","DataWydaniaRW",g[2])
                #self.magazyny_jpk.WstawNowyW("RWWartosc","SkadRW",1)
                #self.magazyny_jpk.WstawNowyW("RWWartosc","DokadRW",1)
                self.magazyny_jpk.Zamknij("RWWartosc")
            rsglobal.ZapiszDoLogow('!!!! Wstawianie RW - wiersze',1)
            for z in self.wiersze_rw:
                rsglobal.ZapiszDoLogow('!! z '+str(z),1)
                self.magazyny_jpk.WstawNowyW("RW","RWWiersz")
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","Numer2RW",str(z[10]).encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","KodTowaruRW",str(z[4]).strip())
                #WS 2020-01-20
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz", "NazwaTowaruRW", fs_jpk_pom.ZamienZastrzezoneZnaki(z[5]))
                # self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","NazwaTowaruRW",str(z[5]).strip().encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","IloscWydanaRW",str(z[6]))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","JednostkaMiaryRW",z[7].encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","CenaJednRW",str(z[8]))
                self.magazyny_jpk.WstawNowyWZWartoscia("RWWiersz","WartoscPozycjiRW",str(round(z[9],2)))
                self.magazyny_jpk.Zamknij("RWWiersz")
            self.magazyny_jpk.WstawNowyW("RW","RWCtrl")
            self.magazyny_jpk.WstawNowyWZWartoscia("RWCtrl","LiczbaRW",str(self.sumy_rw[0]))
            self.magazyny_jpk.WstawNowyWZWartoscia("RWCtrl","SumaRW",str(self.sumy_rw[1]))
            self.magazyny_jpk.Zamknij("RWCtrl")
            self.magazyny_jpk.Zamknij("RW")

        # else:
        #     rsglobal.ZapiszDoLogow('!!!! Wstawianie WZ - pusta struktura',1)
        #     self.magazyny_jpk.WstawWRoot("RW")
        #     self.magazyny_jpk.WstawNowyW("RW","RWWartosc")
        #     self.magazyny_jpk.WstawNowyW("RWWartosc","NumerRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWartosc","DataRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWartosc","WartoscRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWartosc","DataWydaniaRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWartosc","SkadRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWartosc","DokadRW",1)
        #     self.magazyny_jpk.Zamknij("RWWartosc")
        #     self.magazyny_jpk.WstawNowyW("RW","RWWiersz")
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","Numer2RW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","KodTowaruRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","NazwaTowaruRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","IloscWydanaRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","JednostkaMiaryRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","CenaJednRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWWiersz","WartoscPozycjiRW",1)
        #     self.magazyny_jpk.Zamknij("RWWiersz")
        #     self.magazyny_jpk.WstawNowyW("RW","RWCtrl")
        #     self.magazyny_jpk.WstawNowyW("RWCtrl","LiczbaRW",1)
        #     self.magazyny_jpk.WstawNowyW("RWCtrl","SumaRW",1)
        #     self.magazyny_jpk.Zamknij("RWCtrl")
        #     self.magazyny_jpk.Zamknij("RW")


        if 'sumy_mm' in d.keys():
            rsglobal.ZapiszDoLogow('!!!! Wstawianie MM - z danymi',1)
            self.magazyny_jpk.WstawWRoot("MM")

            rsglobal.ZapiszDoLogow('!!!! Wstawianie MM - naglowki',1)
            for g in self.wartosc_mm:
                rsglobal.ZapiszDoLogow('!! g '+str(g),1)
                self.magazyny_jpk.WstawNowyW("MM","MMWartosc")
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWartosc","NumerMM",str(g[7]).encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWartosc","DataMM",g[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWartosc","WartoscMM",str(g[4]))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWartosc","DataWydaniaMM",g[2])
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWartosc","SkadMM",str(g[8]))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWartosc","DokadMM",str(g[9]))
                self.magazyny_jpk.Zamknij("MMWartosc")
            rsglobal.ZapiszDoLogow('!!!! Wstawianie MM - pozycje',1)
            for z in self.wiersze_mm:
                rsglobal.ZapiszDoLogow('!! z '+str(z),1)
                self.magazyny_jpk.WstawNowyW("MM","MMWiersz")
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","Numer2MM",str(z[10]).encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","KodTowaruMM",str(z[4]).strip())
                #WS 2020-01-20
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz", "NazwaTowaruMM", fs_jpk_pom.ZamienZastrzezoneZnaki(z[5]))
                # self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","NazwaTowaruMM",str(z[5]).strip().encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","IloscWydanaMM",str(z[6]))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","JednostkaMiaryMM",z[7].encode('utf-8'))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","CenaJednMM",str(z[8]))
                self.magazyny_jpk.WstawNowyWZWartoscia("MMWiersz","WartoscPozycjiMM",str(round(z[9],2)))
                self.magazyny_jpk.Zamknij("MMWiersz")
            self.magazyny_jpk.WstawNowyW("MM","MMCtrl")
            self.magazyny_jpk.WstawNowyWZWartoscia("MMCtrl","LiczbaMM",str(self.sumy_mm[0]))
            self.magazyny_jpk.WstawNowyWZWartoscia("MMCtrl","SumaMM",str(self.sumy_mm[1]))
            self.magazyny_jpk.Zamknij("MMCtrl")
            self.magazyny_jpk.Zamknij("MM")

        # else:
        #     rsglobal.ZapiszDoLogow('!!!! Wstawianie MM - pusta struktura',1)
        #     self.magazyny_jpk.WstawWRoot("MM")
        #     self.magazyny_jpk.WstawNowyW("MM","MMWartosc")
        #     self.magazyny_jpk.WstawNowyW("MMWartosc","NumerMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWartosc","DataMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWartosc","WartoscMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWartosc","DataWydaniaMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWartosc","SkadMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWartosc","DokadMM",1)
        #     self.magazyny_jpk.Zamknij("MMWartosc")
        #     self.magazyny_jpk.WstawNowyW("MM","MMWiersz")
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","Numer2MM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","KodTowaruMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","NazwaTowaruMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","IloscWydanaMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","JednostkaMiaryMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","CenaJednMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMWiersz","WartoscPozycjiMM",1)
        #     self.magazyny_jpk.Zamknij("MMWiersz")
        #     self.magazyny_jpk.WstawNowyW("MM","MMCtrl")
        #     self.magazyny_jpk.WstawNowyW("MMCtrl","LiczbaMM",1)
        #     self.magazyny_jpk.WstawNowyW("MMCtrl","SumaMM",1)
        #     self.magazyny_jpk.Zamknij("MMCtrl")
        #     self.magazyny_jpk.Zamknij("MM")

        #self.magazyny_jpk.Zamknij("Magazyn")
        self.magazyny_jpk.Zamknij("JPK")





        #plik = tempfile.mktemp()
        plik = 'jpk_mag_'+time.strftime("%Y-%m-%d_%H_%M_%S", time.gmtime())+'.xml'



        self.magazyny_jpk.ZapiszPlik(plik,False,'<?xml version="1.0" encoding="utf-8"?>')
        file = open(plik,'r')

        tresc = file.read().replace('&','&amp;').replace('<JPK>', '<JPK xmlns="http://jpk.mf.gov.pl/wzor/2016/03/09/03093/"  xmlns:tns="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2016/01/25/eD/DefinicjeTypy/">')

        file.close()

        file = open(plik,'w')

        file.write(tresc)
        file.close()

        stat = fs_jpk_pom.SprawdzJpk(plik,'xsd/jpk_mag.xsd')

        if stat=='OK':
            os.remove(plik)
            return stat,tresc

        else:
            os.system('mv '+plik+' '+'xsd/Blad_'+plik)
            return stat,'BLAD'





stat='OK'
dane=[]
wyn1 = []
wyn2 = []


if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'DataOd':[1,3],'DataDo':[1,3],'Magazyn':[1,3],'Cel':[1,3]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_jpk_magazyny z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,3]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
        Cel = rsglobal.Dekoduj(klucze['Cel'])


#-------------------------------------------------------------------------------
# Walidacja parametrw  (3)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK':
    # sprawdzamy poprawno dat i magazynw
    if DataOd>DataDo:
        stat="Data od wiksza ni data do"
        dane.append(stat)
    if stat=='OK':
        SQL="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"
        stat,mag,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd sprawdzania poprawnoci magazynu "
            dane.append(stat)
        elif len(mag) == 0:
            stat='W bazie nie ma magazynu: '+Magazyn
            dane.append(stat)

#-------------------------------------------------------------------------------
# Pobranie danych nagwka  (2)
#-------------------------------------------------------------------------------
if Funkcja == 1 and stat=='OK':
    #AB 20.08-18r

    puste = ['', 'None', 'NULL', '    -  -  ']
    # Pobieramy parametry stae
    SQL = "SELECT war_1,war_2,war_3,war_4 FROM rs_jpk_parametry "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND jpk_id='JPK_MAG'  AND data_od<='" + DataDo + "' ORDER BY data_od DESC LIMIT 1"
    stat, parametry, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = "Bd pobierania parametrw "
        dane.append(stat)
    else:
        if len(parametry) > 0 and parametry[0][0].strip() not in puste:
        # if parametry[0][0].strip() not in puste:
            TypyPZ = "'" + parametry[0][0].replace(' ', '').replace('\'', '').replace(',', "','") + "'"
        else:
            TypyPZ = "'PZ'"
        if len(parametry) > 0 and parametry[0][1].strip() not in puste:
        # if parametry[0][1].strip() not in puste:
            TypyWZ = "'" + parametry[0][1].replace(' ', '').replace('\'', '').replace(',', "','") + "'"
        else:
            TypyWZ = "'WZ'"
        if len(parametry) > 0 and parametry[0][2].strip() not in puste:
        # if parametry[0][2].strip() not in puste:
            TypyRW = "'" + parametry[0][2].replace(' ', '').replace('\'', '').replace(',', "','") + "'"
        else:
            TypyRW = "'RW'"
        if len(parametry) > 0 and parametry[0][3].strip() not in puste:
        # if parametry[0][3].strip() not in puste:
            TypyMM = "'" + parametry[0][3].replace(' ', '').replace('\'', '').replace(',', "','") + "'"
        else:
            TypyMM = "'MM'"

    # AB 20.08-18r
    cena = 'round(a.cena1, 2)'
    wartosc = 'round(a.ilosc1*a.cena1, 2)'
    rsglobal.ZapiszDoLogow('!!!!! POCZTEK POBIERANIA',1)
    #Pobieramy dane do nagwka
    #WS 2019-01-14
    SQL = " SELECT nip, CASE WHEN (nazwa1 IS NULL OR TRIM(nazwa1) = '') AND (nazwa2 IS NULL OR TRIM(nazwa2) = '') THEN nazwa ELSE COALESCE(nazwa1,'') || ' ' || COALESCE(nazwa2,'') END, "
    # SQL=" SELECT nip, nazwa, "
    SQL+="adr_kraj,adr_wojew,adr_powiat,adr_gmina,adr_ulica,adr_nry,adr_kod,adr_poczta,adr_miej,urzad_skarbowy_id,regon "
    #WS 2020-01-14
    SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND centrala"
    # SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    rsglobal.ZapiszDoLogow(SQL, 5)
    stat,dane_naglowek,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd pobierania danych oddziau "
        dane.append(stat)
    #WS 2020-01-14
    elif len(dane_naglowek) == 0:
        stat = "Brak oddziau oznaczonego jako centrala"
        dane.append(stat)

    rsglobal.ZapiszDoLogow('!!!! Pobieranie PZ',1)
    #Pobieramy dane dla PZ
    #Suma liczby dokumentow i suma wartosci
    if stat=='OK':
        SQL=" Select count(*),sum(kwota) FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' "
                                                                                                            #AB 20.08-18r
        SQL+=" AND magazyn_id='"+Magazyn+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyPZ + ")"
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_sum_pz,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum PZ "
            dane.append(stat)
    #Dane do galazki PZCtrl
    if stat=='OK':
        SQL=" SELECT magazyn_id, dokument_id, data, numer, kwota,kontrahent_id, nr_faktury,"
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyPZ + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_pzctrl,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania sum kontorlnych dla PZ "
            dane.append(stat)
    #Dane do galazki PZWiersze
    if stat=='OK':
                                                                                                         #AB 20.08-18r
        SQL=" SELECT a.magazyn_id, a.dokument_id, a.data, a.numer, a.artykul_id, b.nazwa, a.ilosc1,b.jm1," + cena + "," + wartosc + ","
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje a INNER JOIN rs_artykuly b USING(firma_id,artykul_id) "
        SQL+=" WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyPZ + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_pz_wiersze,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania wierszy dla PZ "
            dane.append(stat)

    rsglobal.ZapiszDoLogow('!!!! Pobieranie WZ',1)
    #Pobieramy dane dla WZ
    #Suma liczby dokumentow i suma wartosci
    if stat=='OK':
        SQL=" Select count(*),sum(kwota) FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' "
                                                                                                              #AB 20.08-18r
        SQL+=" AND magazyn_id='"+Magazyn+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyWZ + ")"
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_sum_wz,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd pobierania danych sum WZ "
            dane.append(stat)
    #Dane do galazki WZCtrl
    if stat=='OK':
        SQL=" SELECT magazyn_id, dokument_id, data, numer, kwota,kontrahent_id, nr_faktury,"
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyWZ + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_wzctrl,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania sum kontorlnych dla WZ "
            dane.append(stat)
    #Dane do galazki WZWiersze
    if stat=='OK':
                                                                                                         #AB 20.08-18r
        SQL=" SELECT a.magazyn_id, a.dokument_id, a.data, a.numer, a.artykul_id, b.nazwa, a.ilosc1,b.jm1," + cena + "," + wartosc + ","
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje a INNER JOIN rs_artykuly b USING(firma_id,artykul_id) "
        SQL+=" WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyWZ + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_wz_wiersze,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania wierszy dla WZ "
            dane.append(stat)

    rsglobal.ZapiszDoLogow('!!!! Pobieranie RW',1)
    #Pobieramy dane dla RW
    #Suma liczby dokumentow i suma wartosci
    if stat=='OK':
        SQL=" Select count(*),sum(kwota) FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' "
                                                                                                             #AB 20.08-18r
        SQL+=" AND magazyn_id='"+Magazyn+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyRW + ")"
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_sum_rw,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania danych sum RW "
            dane.append(stat)
    #Dane do galazki RWCtrl
    if stat=='OK':
        SQL=" SELECT magazyn_id, dokument_id, data, numer, kwota,kontrahent_id, nr_faktury,"
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyRW + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_rwctrl,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania sum kontorlnych dla RW "
            dane.append(stat)
    #Dane do galazki RWWiersze
    if stat=='OK':
                                                                                                              #AB 20.08-18r
        SQL=" SELECT a.magazyn_id, a.dokument_id, a.data, a.numer, a.artykul_id, b.nazwa, a.ilosc1,b.jm1," + cena + "," + wartosc + ","
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje a INNER JOIN rs_artykuly b USING(firma_id,artykul_id) "
        SQL+=" WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyRW + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)

        stat,dane_rw_wiersze,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania wierszy dla RW "
            dane.append(stat)

    rsglobal.ZapiszDoLogow('!!!! Pobieranie MM',1)
    #Pobieramy dane dla MM
    #Suma liczby dokumentow i suma wartosci
    if stat=='OK':
        SQL=" Select count(*),sum(kwota) FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' "
                                                                                                             #AB 20.08-18r
        SQL+=" AND magazyn_id='"+Magazyn+"' AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyMM + ")"
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_sum_mm,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania danych sum MM "
            dane.append(stat)
    #Dane do galazki MMCtrl
    if stat=='OK':
        SQL=" SELECT magazyn_id, dokument_id, data, numer, kwota,kontrahent_id, nr_faktury,"
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M'),magazyn_skad,magazyn_dokad """
        SQL+=" FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyMM + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_mmctrl,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania sum kontorlnych dla MM "
            dane.append(stat)

    #Dane do galazki MMWiersze
    if stat=='OK':
                                                                                                          #AB 20.08-18r
        SQL=" SELECT a.magazyn_id, a.dokument_id, a.data, a.numer, a.artykul_id, b.nazwa, a.ilosc1,b.jm1," + cena + "," + wartosc + ","
        SQL+=""" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','["'||magazyn_id||'", "'||dokument_id||'", "'||data||'", "'||numer||'"]','M') """
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje a INNER JOIN rs_artykuly b USING(firma_id,artykul_id) "
        SQL+=" WHERE firma_id='"+self.firma_id+"' and magazyn_id='"+Magazyn+"' "
                                                                                 #AB 20.08-18r
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND dokument_id IN (" + TypyMM + ") "
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat,dane_mm_wiersze,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat=="Bd pobierania wierszy dla MM "
            dane.append(stat)
    rsglobal.ZapiszDoLogow('!!!!! KONIEC POBIERANIA',1)


if Funkcja== 1 and stat=='OK':
    DM = {}
    DM['dane_naglowka'] = dane_naglowek

    if dane_sum_pz[0][1]>0:
        DM['wartosc_pz'] = dane_pzctrl
        DM['sumy_pz'] = dane_sum_pz
        DM['wiersze_pz'] = dane_pz_wiersze

    if dane_sum_wz[0][1]>0:

        DM['wartosc_wz'] = dane_wzctrl
        DM['sumy_wz'] = dane_sum_wz
        DM['wiersze_wz'] = dane_wz_wiersze


    if dane_sum_rw[0][1]>0:

        DM['wartosc_rw'] = dane_rwctrl
        DM['sumy_rw'] = dane_sum_rw
        DM['wiersze_rw'] = dane_rw_wiersze

    if dane_sum_mm[0][1]>0:

        DM['wartosc_mm'] = dane_mmctrl
        DM['sumy_mm'] = dane_sum_mm
        DM['wiersze_mm'] = dane_mm_wiersze


    magazyny = Magazyny(DataOd, DataDo, Cel, Magazyn)
    stat,wynik = magazyny.ZapiszMagazyny(DM)
    if stat=='OK':
        dane = [wynik]
    else:
        dane.append(stat)
