# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki.py
# Purpose:     wczytuje/usuwa dane z kasami/bankami
#
# Author:      Micha Raburski
# Created:     2007/02/12
# RCS-ID:      $Id: fs_kasy_banki.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-06-08 Mariusz Rajfura - 'konto_id' na gridzie (4667)
# 2011-08-24 Mariusz Rajfura - poprawione usuwanie kasy-banku (4691)
# 2019-03-11 Aleksander Bargie (11432) - [KP] Okno do zamylania listy

stat = "OK"

Fun=klucze[-1]

if stat == 'OK' and Fun in (1, 5, 6, 99):
    if self.okres_id is None or self.okres_id.strip() == '':
        stat = "Nie wybrano okresu obrachunkowego."

if stat == 'OK' and Fun in (1, 5, 6):
    Symbol =        klucze[0]
    SymbolF =       klucze[1]
    NazwaF =        klucze[2]
    KontoF =        klucze[3]
    LKl =           klucze[4]
    OkrojonyWidok = klucze[5]
    #AB 11.03.19r
    Typ =           klucze[6]
    if Symbol==None:
        Symbol=''
    if SymbolF==None:
        SymbolF=''
    if NazwaF==None:
        NazwaF=''
    if KontoF==None:
        KontoF=''

dane = []


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 1 :
    if ((self.oddzial_id,'171013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat,d,w1,t = self.PolSQL.Execute("SELECT kasa_bank_id FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Symbol+"' AND okres_id='"+self.okres_id+"';",3)
        if len(d)==0:
            stat,dump,dump,dump = self.PolSQL.Execute("INSERT INTO rs_kasy_banki (firma_id,okres_id,kasa_bank_id,nazwa,konto,waluta) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Symbol+"','','','PLN');" ,1)
            LKl.append(Symbol)
        else:
            stat='UZ ID'
    else:
        stat='UPR INS'


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 6 :
    if ((self.oddzial_id,'171014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        # czy kasa ma juz raporty
        sql ="SELECT COUNT(*) FROM rs_raporty_wyciagi"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Symbol+"';"
        stat,d,dump,dump= self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia raportw w kasie: '+stat
            dane.append(stat)
        elif d[0][0] > 0:
            stat = 'BL DEL IST RAPORTY'
            dane.append(stat)

        if stat == 'OK':
            sql = ''
            
            sql+="DELETE FROM rs_kasy_banki_plik_dekretacja"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Symbol+"';"

            sql+="DELETE FROM rs_kasy_banki_plik_kolumny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Symbol+"';"
            
            sql+="DELETE FROM rs_kasy_banki"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Symbol+"';"
            
            stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
            if stat <> 'OK':
                stat = 'Kasa-bank uywana w innych tabelach. Usunicie niemoliwe.'
            
    else:
        stat='UPR DEL'


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete, 1 - insert)
#-------------------------------------------------------------------------------

if (Fun in [1,5,6]) and (stat=='OK'):
    # pobranie danych o dokumentach
    Filtr="WHERE kb.firma_id='"+self.firma_id+"' AND kb.okres_id='"+self.okres_id+"'"
    if SymbolF <> '':
        Filtr+=" AND kb.kasa_bank_id='"+SymbolF+"'"
    if NazwaF <> '':
        Filtr+=" AND kb.nazwa LIKE '"+NazwaF+"%'"        
    if KontoF <> '':
        Filtr+=" AND kb.konto LIKE '"+KontoF+"%'"
#AB 11.03.19r
    if Typ == 'bank':
        Filtr += " AND (kb.konto_id IS NOT NULL or kb.konto_id != '') "
    if Typ == 'kasa':
        Filtr += " AND (kb.konto_id IS NULL OR kb.konto_id = '') "

    if len(LKl) > 0:
        LKluczy=[]
        for k in LKl:
            LKluczy.append(rsglobal.Dekoduj(k))
            
        Filtr +=" OR "
        Filtr +=" (kb.firma_id='"+self.firma_id+"' AND kb.okres_id='"+self.okres_id+"'"
        Filtr +="  AND kb.kasa_bank_id IN ("+str(LKluczy)[1:-1]+") )"
    
    if OkrojonyWidok and self.operator_id <> STANDARD_OPERATOR_ID:
        Select ="SELECT DISTINCT kasa_bank_id FROM rs_kasy_banki_upr"
        Select+=" WHERE okres_id='"+self.okres_id+"' AND firma_id='"+self.firma_id+"'"
        Select+=" AND operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")+";"
        
        st,d,dump,dump= self.PolSQL.Execute(Select,3)
        if st<>'OK':
            stat='BL SEL UPR KAS'
            dane.append(stat)
        else:
            if len(d)>0:
                ListaKas="("
                for wiersz in d:
                    ListaKas=ListaKas+"'"+str(wiersz[0])+"',"
                ListaKas=ListaKas.rstrip(",")+")"
                
                Filtr+=" AND kb.kasa_bank_id IN "+ListaKas
            else:
                Filtr+=" AND FALSE"
    
    Select ="SELECT kb.kasa_bank_id,kb.nazwa,kb.konto,kb.waluta,kb.dowod_id||' '||kb.nazwa_id,"
    Select+=" kb.kompensata,CASE WHEN kb.konto_id IS NULL THEN '' ELSE kb.konto_id||' - '||kbn.bank END"
    Select+=" FROM rs_kasy_banki kb "
    Select+=" LEFT JOIN rs_konta_bankowe kbn USING(firma_id,konto_id)"
    Select+=" "+Filtr+" ORDER BY kb.kasa_bank_id;"
    
    rsglobal.ZapiszDoLogow(Select,5)
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)