# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki_dane.py
# Purpose:     wczytuje/edytuje dane kasy/banku
#
# Author:      Micha Raburski
# Created:     2007/02/13
# RCS-ID:      $Id: fs_kasy_banki_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-06-08 Mariusz Rajfura - nowe pole 'konto_id' (4667)
# 2023-07-05 Wojciech Skowron - nowe pole 'konto_zaliczek' (13440)

stat='OK'
Id=klucze[0]
Fun = klucze[-1]

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4]:
    if (((self.oddzial_id,'171012') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat = "OK"
        dane = []
 
        dowod=''
        nazwa=''
          
        #sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
                
            if pole == "nazwa":
                if wart == "":
                    stat="BR NAZWY"
                    dane.append(stat)
            
            elif pole == "konto":
                if wart == "":
                    stat="BR KONTA"
                    dane.append(stat)
                else:
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp != []) and (DaneTmp != None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL KONTO'
                            dane.append(stat)    
                    
            elif pole == "waluta":
                if wart == "":
                    stat="BR WALUTA"
                    dane.append(stat)
                else:
                    st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod= '"+wart+"';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WALUTA"
                        dane.append(stat)       
                        
            elif pole in ("dowod_id","nazwa_id"):
                if pole=='dowod_id':
                    if wart != '':
                        dowod=wart
                    else:
                        stat="BR DWZ"
                        dane.append(stat)       
                else:
                    if wart != '':
                        nazwa=wart
                    else:
                        stat="BR NWZ"
                        dane.append(stat)       

            elif pole == "konto_id":
                if wart.strip() != "":
                    sql ="SELECT konto_id FROM rs_konta_bankowe"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND konto_id='"+wart+"';"
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzenia konta bankowego: '+stat
                        dane.append(stat)
                    elif len(dane_wyn) == 0:
                        stat="BL KONTO_BANKOWE"
                        dane.append(stat)       
                        
            elif pole == "sposob_numeracji":
                if not wart in ["",'D','M','R']:
                    stat="BL NUMERACJA"
                    dane.append(stat)

            #WS 2023-07-05
            elif pole == "konto_zaliczek":
                if wart != "":
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp != []) and (DaneTmp != None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL KONTO ZAL'
                            dane.append(stat)

        #sprawdzenie wzoru dekretacji (cos zostalo zmienione)
        if (dowod != '' or nazwa != '') and stat=='OK':
            #gdy tylko jedno z dwoch
            if dowod == '' or  nazwa == '':
                st,dane,wyn1,tr = self.PolSQL.Execute("SELECT dowod_id,nazwa_id FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Id+"' AND okres_id='"+self.okres_id+"';",3)
                tr = rssql.RSTableRowset(dane,wyn1)
                if dowod=='':
                    dowod=tr.GetVal(0,"dowod_id")
                else:
                    nazwa=tr.GetVal(0,"nazwa_id")
            st,dane,wyn1,tr = self.PolSQL.Execute("SELECT dowod_id FROM rs_wzory_dekretacji WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND dowod_id='"+dowod+"' AND nazwa_id='"+nazwa+"';",3)
            #gdy zle
            if len(dane)==0:
                stat='BL WZOR'
                dane.appedn(stat)    


        #Jak ok to update
        if stat=='OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Id+"' AND okres_id='"+self.okres_id+"';"
            upd = "UPDATE rs_kasy_banki SET "
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]

                #WS 2023-07-05 - konto_zaliczek
                if pole in ['nazwa','konto','waluta','dowod_id','nazwa_id','sposob_numeracji','konto_zaliczek']:
                    upd=upd+pole+"='"+str(wart)+"',"
                elif pole in ['kompensata','tylko_oddzial','nie_sprawdzac_konta','zamykac_dowod']:
                    upd=upd+pole+"="+str(wart)+","
                elif pole in ['konto_id']:
                    wart = wart.strip()
                    if wart == '':
                        upd+= pole+"=NULL,"
                    else:
                        upd+= pole+"='"+str(wart)+"',"

            upd = upd[0:len(upd)-1]+where

            rsglobal.ZapiszDoLogow('UPD '+upd,5)
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    else:
        stat='UPR UPD'
   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun  in [5,3,1] and stat=='OK':
    # pobranie danych kasy/banku
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Id+"' AND okres_id='"+self.okres_id+"' ORDER BY kasa_bank_id;",3)
   
    # pobranie sownika
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- waluta
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        #--- konto bankowe
        if ((self.oddzial_id,'014050') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT bank FROM rs_konta_bankowe"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND konto_id='"+tr.GetVal(0,"konto_id")+"';" 
            dump,d,dump,dump = self.PolSQL.Execute(sql,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

#-------------------------------------------------------------------------------
#-----SPRAWDZANIE CZY DO DANEJ KASY PRZYPISANE SA RAPORTY WYCIAGI---------------
#-------------------------------------------------------------------------------

    sql ="SELECT COUNT(*) FROM rs_raporty_wyciagi"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Id+"';"
    status,d,dump,dump= self.PolSQL.Execute(sql,3)
    wyn2.append(str(d[0][0]))
