# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki_plik_dekretacja.py
# Purpose:     obsluga grida dekretacji kolumn w pliku importu wyciagu
#
# Author:      Mariusz Rajfura
# Created:     2011/06/18
# RCS-ID:      $Id: fs_kasy_banki_plik_kolumny.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-03 Mariusz Rajfura  wstawienie nazwy kolumny lub nazwy typu jesli pusta (4851)

KasaBank = rsglobal.Dekoduj(klucze[0])
NrPoz = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprEdycja = (((self.oddzial_id,'171017') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   DODAWANIE POZYCJI (1)
#-------------------------------------------------------------------------------

if Fun == 1:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)
    
    if stat == 'OK':
        NrPoz += 1
        # numer dodawanej pozycji - za biezaca
        
        # dodanie nowej pozyci za podana, dalsze pozycje przenumerowane
        # przenumerowanie z zabezpieczeniem 
        INS ="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz+50000"
        INS+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        INS+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz>="+str(NrPoz)+";"

        # wstawienie nowej pod podany numer
        INS+="INSERT INTO rs_kasy_banki_plik_dekretacja"
        INS+=" (firma_id,okres_id,kasa_bank_id,nr_poz)"
        INS+=" VALUES"
        INS+=" ('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"',"+str(NrPoz)+");"

        #przenumerowanie - powrot
        INS+="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz-49999"
        INS+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        INS+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz>="+str(50000+NrPoz)+";"
            
        wyn2.append(['DODANA',NrPoz])
            
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
        if stat <> 'OK':
            stat = 'Bd dodawania nowej pozycji: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   PRZESUNIECIE POZYCJI W GORE (11)
#-------------------------------------------------------------------------------

if Fun == 11:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)

    if stat == 'OK':
        if NrPoz == 0:
            stat = 'BL POZYCJA ZERO'
            dane.append(stat)
        elif NrPoz == 1:
            stat = 'BL PIERWSZA POZYCJA'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT nr_poz FROM rs_kasy_banki_plik_dekretacja"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"'"
        sql+=" AND nr_poz IN ("+str(NrPoz)+","+str(NrPoz-1)+")"
        sql+=" ORDER BY nr_poz FOR UPDATE NOWAIT;"
        
        stat,dPoz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numerw pozycji: '+stat
            dane.append(stat)
        elif len(dPoz) <> 2:
            stat = 'BL PIERWSZA POZYCJA'
            dane.append(stat)
            
    if stat == 'OK':
        # taki nr_poz bedzie miec pozycja po zmianie
        # - do ustawienia kursora na gridzie
        wyn2.append(['POPRZEDNIA',dPoz[0][0]])
        
        # zmiana numeru pozycji wczesniejszej - zwolnienie miejsca
        UPD ="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz+50000"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(dPoz[0][0])+";"
        
        # zmiana numeru pozycji wybranej na wczesniejsza
        UPD+="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz-1"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(dPoz[1][0])+";"
        
        # zmiana numeru pozycji wczesniejszej na zwolniana przez wybrana
        UPD+="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz-49999"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(dPoz[0][0]+50000)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd zmiany pozycji na poprzednia: '+stat


#-------------------------------------------------------------------------------
#---   PRZESUNIECIE POZYCJI W DOL (12)
#-------------------------------------------------------------------------------

if Fun == 12:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)

    if stat == 'OK':
        if NrPoz == 0:
            stat = 'BL POZYCJA ZERO'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT nr_poz FROM rs_kasy_banki_plik_dekretacja"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"'"
        sql+=" AND nr_poz IN ("+str(NrPoz)+","+str(NrPoz+1)+")"
        sql+=" ORDER BY nr_poz FOR UPDATE NOWAIT;"
        
        stat,dPoz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numerw pozycji: '+stat
            dane.append(stat)
        elif len(dPoz) <> 2:
            stat = 'BL OSTATNIA POZYCJA'
            dane.append(stat)
            
    if stat == 'OK':
        # taki nr_poz bedzie miec pozycja po zmianie
        # - do ustawienia kursora na gridzie
        wyn2.append(['NASTEPNA',dPoz[1][0]])
        
        # zmiana numeru pozycji pozniejszej - zwolnienie miejsca
        UPD ="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz+50000"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(dPoz[1][0])+";"
        
        # zmiana numeru pozycji wybranej na pozniejsza
        UPD+="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz+1"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(dPoz[0][0])+";"
        
        # zmiana numeru pozycji pozniejszej na zwolniana przez wybrana 
        UPD+="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz-50001"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(dPoz[1][0]+50000)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd zmiany pozycji na nastpn: '+stat


#-------------------------------------------------------------------------------
#---   USUWANIE POZYCJI (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT nr_poz FROM rs_kasy_banki_plik_dekretacja"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(NrPoz)+" FOR UPDATE NOWAIT;"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pozycji: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'BL BRAK POZYCJI'
            dane.append(stat)
        
    if stat == 'OK':
        # usuwanie
        DEL = "DELETE FROM rs_kasy_banki_plik_dekretacja"
        DEL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        DEL+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(NrPoz)+";"

        # przenumerowanie z zabezpieczeniem 
        UPD ="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz+50000"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz>"+str(NrPoz)+";"

        UPD+="UPDATE rs_kasy_banki_plik_dekretacja SET nr_poz=nr_poz-50001"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz>"+str(50000+NrPoz)+";"

        stat,dump,dump,dump = self.PolSQL.Execute(DEL+UPD,1)
        if stat <> 'OK':
            stat = 'Bd usuwania pozycji: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 - delete, 1 - insert)
#-------------------------------------------------------------------------------

if Fun in [12,11,6,5,1] and stat == 'OK':
    # do nr_kolumny1 musi byc LEFT JOIN, bo w momencie dodawania pozycji
    # pole 'nr_kolumny1' jest niewypelnione
    
    sql ="SELECT kbpd.nr_poz,"
    
    # nr_kolumny1
    sql+=" CASE WHEN kbpd.nr_kolumny1 IS NULL OR kbpd.nr_kolumny1=0 THEN ''::TEXT"
    sql+="      ELSE kbpd.nr_kolumny1||' - '||"
    # nazwa kolumny1: jesli pusta, to wstawiamy nazwe typu kolumny
    sql+="           CASE WHEN kbpk1.nazwa_kolumny IS NULL OR TRIM(kbpk1.nazwa_kolumny)=''::TEXT"
    sql+="                THEN (SELECT nazwa FROM rs_kasy_banki_typy_kolumn WHERE kod=kbpk1.typ_kolumny)"
    sql+="                ELSE kbpk1.nazwa_kolumny"
    sql+="           END"
    sql+=" END,"
    
    sql+=" COALESCE(kbpd.wartosc1,''::TEXT),"
    
    # nr_kolumny2
    sql+=" CASE WHEN kbpd.nr_kolumny2 IS NULL OR kbpd.nr_kolumny2=0 THEN ''::TEXT"
    sql+="      ELSE kbpd.nr_kolumny2||' - '||"
    # nazwa kolumny2: jesli pusta, to wstawiamy nazwe typu kolumny
    sql+="           CASE WHEN kbpk2.nazwa_kolumny IS NULL OR TRIM(kbpk2.nazwa_kolumny)=''::TEXT"
    sql+="                THEN (SELECT nazwa FROM rs_kasy_banki_typy_kolumn WHERE kod=kbpk2.typ_kolumny)"
    sql+="                ELSE kbpk2.nazwa_kolumny"
    sql+="           END"
    sql+=" END,"

    sql+=" COALESCE(kbpd.wartosc2,''::TEXT),COALESCE(kbpd.konto,''::TEXT),dodawac_kontrahenta"
    sql+=" FROM rs_kasy_banki_plik_dekretacja kbpd"
    sql+=" LEFT JOIN rs_kasy_banki_plik_kolumny kbpk1 ON"
    sql+="  (kbpk1.firma_id=kbpd.firma_id AND kbpk1.okres_id=kbpd.okres_id"
    sql+="   AND kbpk1.kasa_bank_id=kbpd.kasa_bank_id AND kbpk1.nr_kolumny=kbpd.nr_kolumny1)"
    sql+=" LEFT JOIN rs_kasy_banki_plik_kolumny kbpk2 ON"
    sql+="  (kbpk2.firma_id=kbpd.firma_id AND kbpk2.okres_id=kbpd.okres_id"
    sql+="   AND kbpk2.kasa_bank_id=kbpd.kasa_bank_id AND kbpk2.nr_kolumny=kbpd.nr_kolumny2)"
    sql+=" WHERE kbpd.firma_id='"+self.firma_id+"' AND kbpd.kasa_bank_id='"+KasaBank+"'"
    sql+=" AND kbpd.okres_id='"+self.okres_id+"'"
    sql+=" ORDER BY kbpd.nr_poz;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych kolumn: '+stat