# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki_plik_dekretacja_dane.py
# Purpose:     edycja pozycji z grida dekretacji dla importu wyciagu
#
# Author:      Mariusz Rajfura
# Created:     2011/06/19
# RCS-ID:      $Id: fs_kasy_banki_plik_dekretacja_dane.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-03 Mariusz Rajfura  pobranie nazwy kolumny lub nazwy typu jesli pusta (4851)

KasaBank = rsglobal.Dekoduj(klucze[0])
NrPoz = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprEdycja = (((self.oddzial_id,'171017') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   MODYFIKACJA (3,4)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT nr_kolumny1,COALESCE(wartosc1,''::TEXT),"
        sql+=" nr_kolumny2,COALESCE(wartosc2,''::TEXT),"
        sql+=" COALESCE(konto,''::TEXT),dodawac_kontrahenta"
        sql+=" FROM rs_kasy_banki_plik_dekretacja"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(NrPoz)+" FOR UPDATE NOWAIT;"
        
        stat,d,nagl,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania dotychczasowych danych pozycji: '+stat
            dane.append(stat)
        elif len(d) <> 1:
            stat = 'BR POZYCJI'
            dane.append(stat)
    
    if stat == 'OK':
        # dane do sprawdzenia uzupelniajacego
        NrKolumny1 = rsglobal.Dekoduj(d[0][0])
        Wartosc1 = rsglobal.Dekoduj(d[0][1])
        NrKolumny2 = rsglobal.Dekoduj(d[0][2])
        Wartosc2 = rsglobal.Dekoduj(d[0][3])
        Konto = rsglobal.Dekoduj(d[0][4])
        DodawacKontrahenta = rsglobal.Dekoduj(d[0][5])

        
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'nr_kolumny1':
                NrKolumny1 = wart
                if wart == 0:
                    stat = 'BR NR_KOLUMNY1'
                    dane.append(stat)
                else:
                    sql ="SELECT nr_kolumny FROM rs_kasy_banki_plik_kolumny"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND okres_id='"+self.okres_id+"'"
                    sql+=" AND kasa_bank_id='"+KasaBank+"'"
                    sql+=" AND nr_kolumny="+str(NrKolumny1)+";"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia numeru kolumny: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL NR_KOLUMNY1'
                        dane.append(stat)

            elif pole == 'wartosc1':
                wart = rsglobal.Dekoduj(wart).strip()
                Wartosc1 = wart
                if wart == '':
                    stat = 'BR WARTOSC1'
                    dane.append(stat)

            elif pole == 'nr_kolumny2':
                NrKolumny2 = wart
                if wart > 0:
                    sql ="SELECT nr_kolumny FROM rs_kasy_banki_plik_kolumny"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND okres_id='"+self.okres_id+"'"
                    sql+=" AND kasa_bank_id='"+KasaBank+"'"
                    sql+=" AND nr_kolumny="+str(NrKolumny2)+";"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia numeru kolumny: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL NR_KOLUMNY2'
                        dane.append(stat)

            elif pole == 'wartosc2':
                Wartosc2 = rsglobal.Dekoduj(wart).strip()

            elif pole == 'konto':
                Konto = rsglobal.Dekoduj(wart).strip()
                if Konto <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia konta: '+stat
                        dane.append(stat)
                    elif (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat = 'BL KONTO'
                            dane.append(stat)
                        
            elif pole == 'dodawac_kontrahenta':
                DodawacKontrahenta = wart
        
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    if stat == 'OK' and NrKolumny1 == 0:
        stat = 'BL NR_KOLUMNY1'
        dane.append(stat)

    if stat == 'OK' and Wartosc1 == '':
        stat = 'BR WARTOSC1'
        dane.append(stat)

    if stat == 'OK' and NrKolumny2 > 0 and Wartosc2 == '':
        stat = 'BR WARTOSC2'
        dane.append(stat)
        
    if stat == 'OK' and NrKolumny2 == 0 and Wartosc2 <> '':
        stat = 'BR NR_KOLUMNY2'
        dane.append(stat)
        
    if stat == 'OK' and Konto == '' and DodawacKontrahenta:
        stat = 'BR KONTO'
        dane.append(stat)

    if stat == 'OK':
        UPD = "UPDATE rs_kasy_banki_plik_dekretacja SET "
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = rsglobal.Dekoduj(wartosci[i])
            
            if pole in ('nr_kolumny1','nr_kolumny2','dodawac_kontrahenta'):
                UPD += pole+"="+str(wart)+","
            elif pole in ('wartosc1',):
                UPD += pole+"='"+wart+"',"
            elif pole in ('wartosc2','konto'):
                wart = wart.strip()
                if wart == '':
                    UPD += pole+"=NULL,"
                else:
                    UPD += pole+"='"+wart+"',"
                    
        UPD = UPD[:-1]
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(NrPoz)+";"

        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji danych: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 - update)
#-------------------------------------------------------------------------------

if Fun in (5,3) and stat == 'OK':
    sql ="SELECT * FROM rs_kasy_banki_plik_dekretacja"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+KasaBank+"'"
    sql+=" AND okres_id='"+self.okres_id+"' AND nr_poz="+str(NrPoz)+";"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych kolumny: '+stat
    
    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- nr_kolumny1
        if (self.oddzial_id,'171016') in self.uprawnienia or UprEdycja or self.operator_id == STANDARD_OPERATOR_ID:        
            sql ="SELECT COALESCE(nazwa_kolumny,''::TEXT),typ_kolumny"
            sql+=" FROM rs_kasy_banki_plik_kolumny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(tr.GetVal(0,"nr_kolumny1"))+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat ='Bdy podczas pobierania nazwy kolumny 1: ' + stat
                dane.append(stat)
            elif len(d) == 0:
                wyn2.append('')
            elif rsglobal.Dekoduj(d[0][0]) == '':
                sql ="SELECT nazwa FROM rs_kasy_banki_typy_kolumn"
                sql+=" WHERE kod='"+rsglobal.Dekoduj(d[0][1])+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat ='Bdy podczas pobierania nazwy typu dla kolumny 1: ' + stat
                    dane.append(stat)
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do tabeli kolumn. Poinformuj administratora.')

        #--- nr_kolumny2
        if (self.oddzial_id,'171016') in self.uprawnienia or UprEdycja or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT COALESCE(nazwa_kolumny,''::TEXT),typ_kolumny"
            sql+=" FROM rs_kasy_banki_plik_kolumny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(tr.GetVal(0,"nr_kolumny2"))+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat ='Bdy podczas pobierania nazwy kolumny 1: ' + stat
                dane.append(stat)
            elif len(d) == 0:
                wyn2.append('')

            elif rsglobal.Dekoduj(d[0][0]) == '':
                sql ="SELECT nazwa FROM rs_kasy_banki_typy_kolumn"
                sql+=" WHERE kod='"+rsglobal.Dekoduj(d[0][1])+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat ='Bdy podczas pobierania nazwy typu dla kolumny 2: ' + stat
                    dane.append(stat)
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do tabeli kolumn. Poinformuj administratora.')

        #--- konto
        sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+tr.GetVal(0,"konto")+"');"
        st,d,dump,dump = self.PolSQL.Execute(sql,3)
        d = self.PolSQL.Execute(sql,3)[1]
        if (d <> []) and (d <> None):
            Dane = rsglobal.rseval(d[0][0])
            wyn2.append(Dane[0])
        else:
            wyn2.append('Bd pobrania nazwy konta')
