# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki_plik_kolumny.py
# Purpose:     obsluga grida definicji kolumn w pliku importu wyciagu
#
# Author:      Mariusz Rajfura
# Created:     2011/06/13
# RCS-ID:      $Id: fs_kasy_banki_plik_kolumny.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-06-29 Mariusz Rajfura  pusta 'nazwa_kolumny' - poprawne wyswietlanie na gridzie (4725)
# 2011-08-04 Mariusz Rajfura  pobranie opisu kolumny lub nazwy typu, jesli pusty opis (4851)

KasaBank = rsglobal.Dekoduj(klucze[0])
NrKolumny = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprEdycja = (((self.oddzial_id,'171017') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   POBRANIE OPISU KOLUMNY (LUB NAZWY TYPU JESLI PUSTY) (10)
#-------------------------------------------------------------------------------

if Fun == 10:
    sql ="SELECT COALESCE(nazwa_kolumny,''::TEXT),typ_kolumny"
    sql+=" FROM rs_kasy_banki_plik_kolumny"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(NrKolumny)+";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu kolumny: '+stat
        dane.append(stat)
    elif len(d) == 0:
        dane = [['']]
    elif rsglobal.Dekoduj(d[0][0]) == '':
        sql ="SELECT nazwa FROM rs_kasy_banki_typy_kolumn"
        sql+=" WHERE kod='"+rsglobal.Dekoduj(d[0][1])+"';"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania nazwy typu kolumny: '+stat
            dane.append(stat)
    else:
        dane = [[d[0][0]]]


#-------------------------------------------------------------------------------
#---   DODAWANIE KOLUMNY (1)
#-------------------------------------------------------------------------------

if Fun == 1:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)
    
    if stat == 'OK':
        # sprawdzenie ilosci pozycji
        sql ="SELECT nr_kolumny FROM rs_kasy_banki_plik_kolumny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(NrKolumny)
        sql+=" ORDER BY nr_kolumny;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia iloci pozycji: '+stat
            dane.append(stat)
    
    if stat == 'OK':
        if NrKolumny == 0:
            if len(d) > 0:
                stat = 'ODSWIEZ_GRIDA'
            else:
                # jesli brak zdefiniowanych kolumn,
                # to dodajemy wszystkie kolumny ze slownika rs_kasy_banki_typy_kolumn
                sql ="SELECT kod,nazwa FROM rs_kasy_banki_typy_kolumn ORDER BY kod;"
                stat,dKol,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania typw kolumn: '+stat
                    dane.append(stat)
                
                if len(dKol) > 0 and stat == 'OK':
                    INS = ''
                    for i in xrange(len(dKol)):
                        INS+="INSERT INTO rs_kasy_banki_plik_kolumny"
                        INS+=" (firma_id,okres_id,kasa_bank_id,"
                        INS+="  nr_kolumny,typ_kolumny,nazwa_kolumny)"
                        INS+=" VALUES"
                        INS+=" ('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"',"
                        INS+="  "+str(i+1)+",'"+rsglobal.Dekoduj(dKol[i][0])+"','"+rsglobal.Dekoduj(dKol[i][1])+"');"
                    
                    stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
                    if stat <> 'OK':
                        stat = 'Bd dodawania nowych pozycji ze sownika typw kolumn: '+stat
                        dane.append(stat)
                    else:
                        wyn2.append(['DODANA',0])
                        
        else:
            # dodanie nowej kolumny za podana, dalsze kolumny przenumerowane
            # przenumerowanie z zabezpieczeniem 
            INS ="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny+500"
            INS+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            INS+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny>"+str(NrKolumny)+";"

            # wstawienie nowej pod podany numer
            INS+="INSERT INTO rs_kasy_banki_plik_kolumny"
            INS+=" (firma_id,okres_id,kasa_bank_id,nr_kolumny)"
            INS+=" VALUES"
            INS+=" ('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"',"+str(NrKolumny+1)+");"
            
            #przenumerowanie - powrot
            INS+="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny-499"
            INS+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            INS+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny>"+str(500+NrKolumny)+";"
            
            wyn2.append(['DODANA',NrKolumny+1])
            
            stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
            if stat <> 'OK':
                stat = 'Bd dodawania nowej pozycji: '+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   PRZESUNIECIE POZYCJI W GORE (11)
#-------------------------------------------------------------------------------

if Fun == 11:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)

    if stat == 'OK':
        if NrKolumny == 0:
            stat = 'BL POZYCJA ZERO'
            dane.append(stat)
        elif NrKolumny == 1:
            stat = 'BL PIERWSZA POZYCJA'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT nr_kolumny FROM rs_kasy_banki_plik_kolumny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"'"
        sql+=" AND nr_kolumny IN ("+str(NrKolumny)+","+str(NrKolumny-1)+")"
        sql+=" ORDER BY nr_kolumny FOR UPDATE NOWAIT;"
        
        stat,dKol,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numerw kolumn: '+stat
            dane.append(stat)
        elif len(dKol) <> 2:
            stat = 'BL PIERWSZA POZYCJA'
            dane.append(stat)
            
    if stat == 'OK':
        # taki nr_kolumny bedzie miec pozycja po zmianie
        # - do ustawienia kursora na gridzie
        wyn2.append(['POPRZEDNIA',dKol[0][0]])
        
        # zmiana numeru pozycji wczesniejszej - zwolnienie miejsca
        UPD ="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny+500"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"'AND nr_kolumny="+str(dKol[0][0])+";"
        
        # zmiana numeru pozycji wybranej na wczesniejsza
        UPD+="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny-1"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(dKol[1][0])+";"
        
        # zmiana numeru pozycji wczesniejszej na zwolniana przez wybrana 
        UPD+="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny-499"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(dKol[0][0]+500)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd zmiany pozycji na poprzednia: '+stat


#-------------------------------------------------------------------------------
#---   PRZESUNIECIE POZYCJI W DOL (12)
#-------------------------------------------------------------------------------

if Fun == 12:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)

    if stat == 'OK':
        if NrKolumny == 0:
            stat = 'BL KOLUMNA ZERO'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT nr_kolumny FROM rs_kasy_banki_plik_kolumny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"'"
        sql+=" AND nr_kolumny IN ("+str(NrKolumny)+","+str(NrKolumny+1)+")"
        sql+=" ORDER BY nr_kolumny FOR UPDATE NOWAIT;"
        
        stat,dKol,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numerw kolumn: '+stat
            dane.append(stat)
        elif len(dKol) <> 2:
            stat = 'BL OSTATNIA POZYCJA'
            dane.append(stat)
            
    if stat == 'OK':
        # taki nr_kolumny bedzie miec pozycja po zmianie
        # - do ustawienia kursora na gridzie
        wyn2.append(['NASTEPNA',dKol[1][0]])
        
        # zmiana numeru pozycji pozniejszej - zwolnienie miejsca
        UPD ="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny+500"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(dKol[1][0])+";"
        
        # zmiana numeru pozycji wybranej na pozniejsza
        UPD+="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny+1"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(dKol[0][0])+";"
        
        # zmiana numeru pozycji pozniejszej na zwolniana przez wybrana 
        UPD+="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny-501"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(dKol[1][0]+500)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd zmiany pozycji na nastpn: '+stat


#-------------------------------------------------------------------------------
#---   USUWANIE KOLUMNY (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT nr_kolumny FROM rs_kasy_banki_plik_kolumny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(NrKolumny)+" FOR UPDATE NOWAIT;"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia kolumny: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'BL BRAK KOLUMNY'
            dane.append(stat)
        
    if stat == 'OK':
        # usuwanie
        DEL = "DELETE FROM rs_kasy_banki_plik_kolumny"
        DEL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        DEL+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(NrKolumny)+";"

        # przenumerowanie z zabezpieczeniem 
        UPD ="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny+500"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny>"+str(NrKolumny)+";"

        UPD+="UPDATE rs_kasy_banki_plik_kolumny SET nr_kolumny=nr_kolumny-501"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny>"+str(500+NrKolumny)+";"

        stat,dump,dump,dump = self.PolSQL.Execute(DEL+UPD,1)
        if stat <> 'OK':
            stat = 'Bd usuwania kolumny. Dane z tabeli wystpuj w innych tabelach: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 - delete, 1 - insert)
#-------------------------------------------------------------------------------

if Fun in [12,11,6,5,1] and stat == 'OK':
    sql ="SELECT kbpk.nr_kolumny,kbpk.typ_kolumny||' - '||kbtk.nazwa,"
    sql+=" COALESCE(kbpk.nazwa_kolumny,''::TEXT),kbpk.dlugosc_kolumny,"
    sql+=" COALESCE(kbpk.format_daty,''::TEXT),COALESCE(kbpk.wartosc_stala,''::TEXT)"
    sql+=" FROM rs_kasy_banki_plik_kolumny kbpk"
    sql+=" LEFT JOIN rs_kasy_banki_typy_kolumn kbtk ON (kbtk.kod=kbpk.typ_kolumny)"
    sql+=" WHERE kbpk.firma_id='"+self.firma_id+"' AND kbpk.kasa_bank_id='"+KasaBank+"'"
    sql+=" AND kbpk.okres_id='"+self.okres_id+"'"
    sql+=" ORDER BY kbpk.nr_kolumny;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych kolumn: '+stat