# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki_plik_kolumny_dane.py
# Purpose:     edycja kolumny z grida definicji kolumn w pliku importu wyciagu
#
# Author:      Mariusz Rajfura
# Created:     2011/06/14
# RCS-ID:      $Id: fs_kasy_banki_plik_kolumny_dane.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-06-29 Mariusz Rajfura  zezwolenie na niepodanie: nazwa_kolumny, dlugosc_kolumny (4725)

KasaBank = rsglobal.Dekoduj(klucze[0])
NrKolumny = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprEdycja = (((self.oddzial_id,'171017') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   POBRANIE TYPU KOLUMNY ZE SLOWNIKA NA PDST KODU (9)
#-------------------------------------------------------------------------------

if Fun == 9:
    # NrKolumny z klucza w tej funkcji zawiera kod kolumny 
    sql ="SELECT typ FROM rs_kasy_banki_typy_kolumn"
    sql+=" WHERE kod='"+rsglobal.Dekoduj(NrKolumny)+"';"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania typu ze sownika kolumn: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   MODYFIKACJA (3,4)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR UPR ED'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT COALESCE(typ_kolumny,''::TEXT),COALESCE(nazwa_kolumny,''::TEXT),"
        sql+=" dlugosc_kolumny,COALESCE(format_daty,''::TEXT),COALESCE(wartosc_stala,''::TEXT)"
        sql+=" FROM rs_kasy_banki_plik_kolumny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(NrKolumny)+" FOR UPDATE NOWAIT;"
        
        stat,d,nagl,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania dotychczasowych danych kolumny: '+stat
            dane.append(stat)
        elif len(d) <> 1:
            stat = 'BR KOLUMNY'
            dane.append(stat)
    
    if stat == 'OK':
        # dane do sprawdzenia uzupelniajacego
        TypKolumny = rsglobal.Dekoduj(d[0][0])
        NazwaKolumny = rsglobal.Dekoduj(d[0][1])
        DlugoscKolumny = rsglobal.Dekoduj(d[0][2])
        FormatDaty = rsglobal.Dekoduj(d[0][3])
        WartoscStala = rsglobal.Dekoduj(d[0][4])
        
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'nazwa_kolumny':
                wart = wart.strip()
                NazwaKolumny = wart
                
            elif pole == 'typ_kolumny':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart == '':
                    stat = 'BR TYP_KOLUMNY'
                    dane.append(stat)
                else:
                    TypKolumny = wart
                    sql ="SELECT kod FROM rs_kasy_banki_typy_kolumn"
                    sql+=" WHERE kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania danych ze sownika typw kolumn: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL TYP_KOLUMNY'
                        dane.append(stat)
                        
            elif pole == 'dlugosc_kolumny':
                DlugoscKolumny = wart

            elif pole == 'wartosc_stala':
                WartoscStala = wart.strip()

            elif pole == 'format_daty':
                FormatDaty = wart.strip()
        
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    if stat == 'OK' and TypKolumny == '98':
        # wymaganie wpisania stalej wartosci dla podanego typu(kodu) kolumny
        if WartoscStala == '':
            stat = 'BR WARTOSC_STALA'
            dane.append(stat)

    if stat == 'OK':
        # pobranie typu danych w kolumnie dla sprawdzenia wymagalnosci formatu daty
        sql ="SELECT typ FROM rs_kasy_banki_typy_kolumn WHERE kod='"+TypKolumny+"';"
        stat,dTyp,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania typu danych dla kolumny: '+stat
            dane.append(stat)
        elif len(dTyp) == 0:
            stat = 'BL TYP_KOLUMNY'
            dane.append(stat)
            
    if stat == 'OK' and rsglobal.Dekoduj(dTyp[0][0]) == 'D':
        if FormatDaty == '':
            stat = 'BR FORMAT_DATY'
            dane.append(stat)
        elif len(FormatDaty) <> DlugoscKolumny:
            stat = 'BL DLUGOSC_KOLUMNY'
            dane.append(stat)

    if stat == 'OK':
        UPD = "UPDATE rs_kasy_banki_plik_kolumny SET "
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = rsglobal.Dekoduj(wartosci[i])
            
            if pole in ('typ_kolumny',):
                UPD += pole+"='"+wart+"',"

            elif pole in ('nazwa_kolumny',):
                wart = wart.strip()
                if wart == '':
                    UPD += pole+"=NULL,"
                else:
                    UPD += pole+"='"+wart+"',"

            elif pole in ('dlugosc_kolumny',):
                UPD += pole+"="+str(wart)+","
            elif pole in ('format_daty','wartosc_stala'):
                wart = wart.strip()
                if wart == '':
                    UPD += pole+"=NULL,"
                else:
                    UPD += pole+"='"+wart+"',"
                    
        UPD = UPD[:-1]
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UPD+=" AND kasa_bank_id='"+KasaBank+"' AND nr_kolumny="+str(NrKolumny)+";"

        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji danych: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 - update)
#-------------------------------------------------------------------------------

if Fun in (5,3) and stat == 'OK':
    sql ="SELECT * FROM rs_kasy_banki_plik_kolumny"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+KasaBank+"'"
    sql+=" AND okres_id='"+self.okres_id+"' AND nr_kolumny="+str(NrKolumny)+";"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych kolumny: '+stat
    
    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- typ kolumny: nazwa, typ danych w kolumnie
        if ((self.oddzial_id,'011930') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa,typ FROM rs_kasy_banki_typy_kolumn"
            sql+=" WHERE kod='"+tr.GetVal(0,"typ_kolumny")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat ='Bdy podczas pobierania opisu typu kolumny ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
                wyn2.append(d[0][1])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
