#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_kasy_banki_pozycje.py
# Purpose:          Obsuga grida podtabeli Kasy/banki - Pozycje
# Author:           Wojciech Skowron
# Created:          2021/06/22
# RCS-ID:           $Id: fs_kasy_banki_pozycje.py $
# Copyright:        Record System(c) 2021
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

# 2007-02-12 Marcin Grzeda () funkcja fs_raporty_wyciagi_pozycje
# 2016-03-10 Piotr Witkowski (9614) Refaktoryzacja Raportw Wycigw i Raportw pozycji
# 2021-06-22 Wojciech Skowron - fs_kasy_banki_pozycje utworzony na podst. fs_raporty_wyciagi_pozycje (12538)

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'KasaBank':[5,6,7,10,11],'NrPoz':[6,7],
           'SymbolF':[5,6,7],'PlatnikF':[5,6,7],'KontoF':[5,6,7],'KierowcaF':[5,6,7]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_kasy_banki_pozycje z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [5,6,7,10,11]:
            KasaBank = str(klucze['KasaBank'])
        if Funkcja in [6,7]:
            NrPoz = klucze['NrPoz']
        if Funkcja in [5,6,7]:
            SymbolF = klucze['SymbolF']
            PlatnikF = klucze['PlatnikF']
            KontoF = klucze['KontoF']
            KierowcaF = klucze['KierowcaF']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = ['    -  -  ','',[]]

if self.okres_id=='':
    stat='BR_OKR'
    dane.append(stat)
if KasaBank=='':
    stat='BR_KAS'
    dane.append(stat)

UprPrz=(self.oddzial_id,'171020') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod=(self.oddzial_id,'171022') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#sprawdzenie czy mona dodawa w wybranej kasie/banku (11)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==11:
    if self.operator_id != STANDARD_OPERATOR_ID:
        if UprMod:
            sql = "SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            sql+=" AND kasa_bank_id='"+KasaBank+"' AND (wprowadzanie OR edycja) AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
            stat,uprd,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                UprMod= UprMod and len(uprd)>0

    dane=[[str(UprMod)]]

#-------------------------------------------------------------------------------
#sprawdzenie kolejnych parametrw
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6,7]:
    if NrPoz=='':
        stat='BR_NR_POZ'
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- kopiowanie pozycji/podpozycji (7)
#-------------------------------------------------------------------------------

#jeli nr_ppoz=0 to kopiujemy ca pozycj z podpozycjami. Jeli jest <> 0 to tylko podpozycj w ramach pozycji

if (Funkcja ==7) and (stat=='OK'):
    #--- sprawdzenie czy pozycja kopiowana istnieje
    FiltrKB= "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    FiltrKB+=" AND kasa_bank_id='"+KasaBank+"'"

    sql="SELECT * FROM rs_kasy_banki_pozycje WHERE "+FiltrKB
    sql+=" AND nr_poz="+str(NrPoz)+";"
    stat,DaneTest,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DaneTest)==0:
            stat="BR POZ K"

    if stat=='OK':
        Ile='5000'
        sql="UPDATE rs_kasy_banki_pozycje SET nr_poz=nr_poz+"+Ile+" WHERE "+FiltrKB
        sql+=" AND nr_poz>"+str(NrPoz)+";"

        sql+="INSERT INTO rs_kasy_banki_pozycje (firma_id,okres_id,kasa_bank_id,nr_poz,"
        sql+="typ,symbol_dok,platnik_id,kierowca,"
        sql+="konto,tresc)"
        sql+=" SELECT firma_id,okres_id,kasa_bank_id,nr_poz+1,"
        sql+="typ,symbol_dok,platnik_id,kierowca,"
        sql+="konto,tresc FROM rs_kasy_banki_pozycje WHERE "+FiltrKB
        sql+=" AND nr_poz="+str(NrPoz)+";"

        sql+="UPDATE rs_kasy_banki_pozycje SET nr_poz=nr_poz-("+Ile+"-1) WHERE "+FiltrKB
        sql+=" AND nr_poz>"+Ile+";"

        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)

#-------------------------------------------------------------------------------
#--- usuwanie pozycji (6)
#-------------------------------------------------------------------------------

if (Funkcja ==6) and (stat=='OK'):
    if not UprMod:
        stat='BR_UPR_DEL'
        dane.append(stat)

    #sprawdzenie czy mona usuwa w wybranej kasie/banku
    if stat=='OK' and self.operator_id != STANDARD_OPERATOR_ID:
        sql = "SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND usuwanie AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
        stat,upru,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(upru)==0:
                stat='BR_UPR_DEL_KASA'
                dane.append(stat)

    if stat=='OK':
        #przesuniecie pozycji/podpozycji o 1000 w d
        #pozycja
        Delete="UPDATE rs_kasy_banki_pozycje SET nr_poz=nr_poz+1000 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Delete+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz>"+NrPoz+";"

        Delete+="DELETE FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        Delete+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+NrPoz
        Delete+="; "
        #przesuniecie pozycji/podpozycji o 1001 w gr
        #pozycja
        Delete+="UPDATE rs_kasy_banki_pozycje SET nr_poz=nr_poz-1001 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Delete+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz>"+NrPoz+";"

        stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
        if stat<>'OK':
            stat='BL_DEL'
            dane.append(stat)


#-------------------------------------------------------------------------------
# SPRAWDZENIE, CZY NIE MA ZEROWEJ POZYCJI
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja<>11:
    NrZmieniony=0
    # dodatkowy test na poprawno klucza
    # if rsglobal.SprawdzCzyToData(Data):
    #rsglobal.ZapiszDoLogow('TEST ZMIANY POZYCJI ZERO W POZYCJE '+str(klucze),1)
    SQL="SELECT min(nr_poz),max(nr_poz) FROM rs_kasy_banki_pozycje "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    SQL+=" AND kasa_bank_id='"+KasaBank+"';"

    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DTest)>0:
            if DTest[0][0]==0:
                rsglobal.ZapiszDoLogow('ZMIANA POZYCJI ZERO W POZYCJE '+str(klucze),1)
                SQL="UPDATE rs_kasy_banki_pozycje SET nr_poz="+str(DTest[0][1]+1)
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
                SQL+=" AND kasa_bank_id='"+KasaBank+"'"
                SQL+=" AND nr_poz=0;"
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat=='OK':
                    NrZmieniony=DTest[0][1]+1
                    NrPoz=str(DTest[0][1]+1)


#-------------------------------------------------------------------------------
#-------------Pobieranie Pozycji (5,6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6,7]:
    if not UprPrz:
        stat='BR_UPR_PRZ'
        dane.append(stat)
    if stat=='OK':
        #przed zmian - zmieniony sposb pobierania numeru faktury - 2008-03-27 D. Boduch
        #Sql="SELECT stan_poz,typ,nr_poz,nr_ppoz,kwota,platnik_id,kierowca,konto,typ_fakt || ' - ' || wyznacznik_id || '/' || data_fakt || '/' || numer_fakt, tresc, symbol_dok FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer
        #po zmianie
        Sql="SELECT typ,nr_poz,platnik_id,kierowca,konto,tresc,symbol_dok FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
        if SymbolF<>'':
            Sql=Sql+" AND symbol_dok='"+SymbolF+"'"
        if PlatnikF<>'':
            Sql=Sql+" AND platnik_id='"+PlatnikF+"'"
        if KontoF<>'':
            Sql=Sql+" AND konto='"+KontoF+"'"
        if KierowcaF<>'':
            Sql=Sql+" AND kierowca='"+KierowcaF+"'"
        Sql=Sql+" ORDER BY nr_poz;"

        stat,dane,wyn1,wyn2=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL_PRZ'
            dane.append(stat)
