#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_kasy_banki_pozycje_dane.py
# Purpose:          Dodaje/pobiera/usuwa definicje pozycji raportw dla kas/bankw
# Author:           Wojciech Skowron
# Created:          2021/06/22
# RCS-ID:           $Id: fs_kasy_banki_pozycje_dane.py $
# Copyright:        (c) 2021 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-24 Mariusz Rajfura - nowy typ dokumentu 'N' - niezidentyfikowany (4528)
# 2011-05-20 Mariusz Rajfura - zapis pozycji/podpozycji pobranych z zaleglosci (4583)
# 2011-05-26 Mariusz Rajfura - usuniecie wpisywania kontrahenta dla podpozycji z zaleglosci (4626)
# 2011-09-09 Mariusz Rajfura - popr.zapisu dla wartosci==None w Fun==16 (4999)
# 2012-01-05 Mariusz Rajfura - dodawanie podpozycji do pozycji ze zmiana pozycji w podpoz
# 2021-06-22 Wojciech Skowron - fs_kasy_banki_pozycje_dane utworzony na podst. fs_raporty_wyciagi_pozycje_dane (12538)
# 2021-08-31 Wojciech Skowron - obowizkowe pola Konto i Tre (12627)


KasaBank=rsglobal.Dekoduj(klucze[0])
Data=klucze[1]
Numer=klucze[2]
NrPoz=klucze[3]
NrPpoz=klucze[4]
Fun=klucze[-1]
stat='OK'
dane=[]
puste_pola = ['    -  -  ','',[],'None']
CzyPodpozycja=(Fun==20)
Symbol=''
Tresc=''

#Lista funkcji:
#1,2 - INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#3,4 - Update danych
#10 - pobranie numeru pozycji
#15 - sprawdzenie czy kasa jest tylko w oddziale
#17 - pobranie danych dostawy
#18 - pobranie danych 1 patnoci
#20 - wstawienie sumy podpozycji w pozycj po kopiowaniu podpozycji

#-------------------------------------------------------------------------------
#sprawdzenie uprawnien
#-------------------------------------------------------------------------------

UprUpd= ((self.oddzial_id,'171022') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprIns= ((self.oddzial_id,'171022') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

if UprUpd and (self.operator_id != STANDARD_OPERATOR_ID):
    sql = "SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    sql+=" AND kasa_bank_id='"+KasaBank+"' AND (wprowadzanie OR edycja) AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
    stat,uprd,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        UprUpd= len(uprd)>0
        UprIns= UprIns and len(uprd)>0


#-------------------------------------------------------------------------------
#pobranie danych dostawy (17)
#-------------------------------------------------------------------------------

if Fun==17 and stat=='OK':
    Trasa=klucze[0]
    Data=klucze[1]
    Tryb=klucze[2]
    Numer=klucze[3]
    dane=[]
    sql = "SELECT kontrahent_id,kierowca,platnik_id FROM rs_dowody_dostaw WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(dane)>0:
            Platnik=rsglobal.Dekoduj(dane[0][2])
            Kontrahent=rsglobal.Dekoduj(dane[0][0])
            Kierowca=rsglobal.Dekoduj(dane[0][1])
            sql = "SELECT SUM(cena_brutto1*ilosc_dost1) FROM rs_dowody_dostaw_pozycje WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
            stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='BL SQL KWOT DOST'
            else:
                dane[0]=dane[0]+[Platnik,Kierowca,Kontrahent]
        else:
            stat='BL KLUCZ DOST'
    else:
        stat='BL SQL DOST'


#-------------------------------------------------------------------------------
#sprawdzenie przychodzcych parametrw
#-------------------------------------------------------------------------------

if Fun not in [17,] and stat=='OK':
    #tylko to jest sprawdzane dla 15
    if KasaBank=='':
        stat='BR KAS'
        dane.append(stat)

    if Fun in [11,]:
        if NrPoz=='':
            stat='BR_NR_POZ'
            dane.append(stat)


#-------------------------------------------------------------------------------
#sprawdzenie czy kasa jest tylko w oddziale (15)
#-------------------------------------------------------------------------------

if Fun==15 and stat=='OK':
    dane=[]
    sql = "SELECT tylko_oddzial FROM rs_kasy_banki WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)


#-------------------------------------------------------------------------------
#pobranie kolejnego numeru pozycji do dodania (10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat=='OK':
    sql = "SELECT nr_poz FROM rs_kasy_banki_pozycje WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' ORDER BY nr_poz DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat=='OK':
        if len(dane)==0:
            dane = 1
        else:
            dane = int(dane[0][0]) + 1


#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [1,2,3,4]:
    #sprawdzenie kompensaty i waluty
    waluta = 'PLN'
    kompensata = False
    TypPPoz=0

    #jeli update
    if Fun in [3,4] and stat=='OK':
        Sql ="SELECT konto,'','','',0,0,"
        Sql+=" tresc,platnik_id,0,1,0,typ "
        Sql+=" FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"'"
        Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
        Sql+=" AND nr_poz="+str(NrPoz)
        Sql+=" FOR UPDATE;"

        stat,d,wyn1,wyn2=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL POB KONT'
            dane.append(stat)
        else:
            KontoS=rsglobal.Dekoduj(d[0][0])
            TypFaktS=d[0][1]
            WyznacznikS=d[0][2]
            DataFaktS=d[0][3]
            NumerFaktS=d[0][4]
            KwotaS=d[0][5]
            TrescS=d[0][6]
            PlatnikS=rsglobal.Dekoduj(d[0][7])
            PlatnoscS=d[0][8]
            KursS=d[0][9]
            NrPPozS=d[0][10]
            ZmianaKontaLubPlat=0
            TypS=d[0][11]

    # jeli insert
    elif Fun in [1,2] and stat=='OK':
        KontoS=''
        TypFaktS=''
        WyznacznikS=''
        DataFaktS=''
        NumerFaktS=0
        KwotaS=0
        TrescS=''
        PlatnikS=''
        PlatnoscS=0
        KursS=1
        NrPPozS=0
        ZmianaKontaLubPlat=3
        TypS=''

    #sprawdzenie kolejnych pl w ptli
    if stat=='OK':
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole=='konto':
                if Fun in [3,4]:
                    ZmianaKontaLubPlat+=1
                KontoS=wart
                if wart<>'':
                    Sql="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    stat,d,dump,dump = self.PolSQL.Execute(Sql,3)
                    if d <> None:
                        if rsglobal.rseval(rsglobal.Dekoduj(d[0][0]))[0]=='':
                            stat='BL KONT'
                            dane.append(stat)
                        elif not rsglobal.rseval(rsglobal.Dekoduj(d[0][0]))[2]:
                            stat='BL KONT NIE KSIE'
                            dane.append(stat)
                    else:
                        stat='BL KRYT KONT'
                        dane.append(stat)
                #WS 2021-08-31
                else:
                    stat='BR KONT'
                    dane.append(stat)

            elif pole=='typ_fakt':
                TypFaktS=wart
                #To s dozwolone typy
                if wart not in ['F','K','P','D','','N']:
                    stat='BL TYP FAKT'
                    dane.append(stat)

                # jeli tak jest to istniej ju inne podpozycje i trzeba sprawdzi zgodno typw
                elif TypPPoz>0:
                    #dodajemy patno na pozycj z innym typem podpozycji
                    if wart=='P' and TypPPoz <> 2:
                        stat='BL TYP PPOZ PLAT'
                        dane.append(stat)
                    #dodajemy zalego na pozycj z innym typem podpozycji
                    elif wart in ['F','K','N'] and TypPPoz <> 1:
                        stat='BL TYP PPOZ ZAL'
                        dane.append(stat)
                    #dodajemy dowd dostawy na pozycj z innym typem podpozycji
                    elif wart =='D' and TypPPoz <> 1:
                        stat='BL TYP PPOZ DOST'
                        dane.append(stat)
                    #dodajemy pusty typ na podpozycj
                    elif wart.strip() =='' and TypPPoz <> 3:
                        stat='BL TYP PPOZ PUST'
                        dane.append(stat)

            elif pole=='wyznacznik_id':
                WyznacznikS=wart
                if wart.strip()<>'':
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+wart+"';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WYZN"
                        dane.append(stat)

            elif pole=='data_fakt':
                DataFaktS=wart
                if wart not in puste_pola:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL DAT'
                        dane.append(stat)

            elif pole=='numer_fakt':
                NumerFaktS=wart

            elif pole=='kurs':
                if wart==0:
                    stat='KURS 0'
                    dane.append(stat)
                KursS=wart

            elif pole=='typ':
                if wart not in ('P','W'):
                    stat='BL TYP'
                    dane.append(stat)
                TypS=wart

            elif pole=='kwota':
                wartosci[i]=round(wartosci[i],2)
                KwotaS=wartosci[i]

            elif pole=='tresc':
                TrescS=wart

            elif pole == "nr_ppoz":
                NrPPozS = wart

            elif pole=='platnik_id':
                if Fun in [3,4]:
                    ZmianaKontaLubPlat+=2
                PlatnikS=wart
                if wart <> "":
                    sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat='Bd sprawdzania kontrahenta : '+stat
                        dane.append(stat)
                    elif len(d)==0:
                        stat='BL PLAT'
                        dane.append(stat)

            elif pole=='platnosc_id':
                PlatnoscS=wart
                if wart not in ["",'None',0]:
                    sql = "SELECT platnosc_id FROM rs_platnosci WHERE platnosc_id='"+str(wart)+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if len(d)==0:
                        stat='BL PLATNOSCI'
                        dane.append(stat)
                else:
                    wartosci[i]=''

            elif pole=='kierowca':
                if wart <> "":
                    sql = "SELECT kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if len(d)==0:
                        stat='BL KIER'
                        dane.append(stat)

        #sprawdzenie czy dodawany typ pasuje do ju istniejcych podpozycji
        if not NrPPozS in [0,'0']:
            if not ((TypPPoz==1 and TypFaktS in ['F','K','D','N']) or \
                    (TypPPoz==2 and TypFaktS=='P') or \
                    (TypPPoz==3 and TypFaktS.strip() in ['']) or \
                    (TypPPoz==0)):
                stat='TYP NIEZGRANY'
                dane.append(stat)

        # sprawdzenie czy dane wpisane w koncie oraz w patniku s dobrze zsynchronizowane. Uwzgldniane s rwnie zalenoci zwizane z tym, czy
        # s spenione zalenoci pomidzy podpozycj a pozycj.
        # zmienna ZmianaKontaLubPlat wynosi 0 gdy nie zmienione, 1 gdy zm konto, 2 - zm. patnik, 3 - zm. patniki i konto

        #sprawdzanie w zaleznosci od wartosci checkboxa z KASY/BANKI
        if stat=='OK':
            Pomin=False
            sql = "SELECT nie_sprawdzac_konta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' "
            sql+= "AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+str(KasaBank)+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='Bedy przy sprawdzaniu kontrahenta i konta.'
                dane.append(stat)
            else:
                if d<>[]:
                    if d[0][0]:
                        Pomin=True
            if ZmianaKontaLubPlat>0 and stat=='OK' and Pomin==False:
                # pobranie patnika z konta
                PlatKonta=''
                if KontoS<>'':
                    SQL="SELECT rsf_sprawdz_czy_kontrahent_w_koncie('"+self.firma_id+"','"+self.okres_id+"','"+KontoS+"')"
                    stat,DKonta,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if int(DKonta[0][0])>0:
                            KontoPodz=KontoS.split('-')
                            PlatKonta=KontoPodz[int(DKonta[0][0])-1]

                        # sprawdzenie lokalne patnika
                        # ten warunek wystarczy by sprawdzi lokaln zgodno.
                        if PlatKonta <> '' and (not PlatnikS in ['None',None,'']):
                            #rsglobal.ZapiszDoLogow('platnicy '+str(PlatKonta)+' '+str(PlatnikS)+' '+str(PlatnikS=='None'),1)
                            if PlatKonta.strip() <> PlatnikS.strip():
                                stat='PLAT KONTO NIEZGODNE'
                                dane.append(stat)

                    if stat=='OK':
                        # jeli podpozycja i patnik ='' i jest Platnik konta to rwnie globalnie
                        if (not NrPPozS in [0,'0']) and PlatnikS in ['None','',None] and PlatKonta <> '':
                            SQL="SELECT COALESCE(platnik_id,'') FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                            SQL+=" AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+str(NrPoz)
                            # SQL+=" AND nr_ppoz=0"
                            stat,DPlat,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                #rsglobal.ZapiszDoLogow('Platnik0 '+str(DPlat),1)
                                if not DPlat[0][0] in  ['',None]:
                                    if PlatKonta.strip() <> DPlat[0][0].strip():
                                        stat='Patnik z konta nie zgadza si z patnikiem z pozycji 0 o symbolu '+DPlat[0][0].strip()
                                        dane.append(stat)

        #sprawdzenie czy dane dla typu kompensata s uzupenione
        if kompensata and stat=='OK':
            if (TypFaktS.strip() in puste_pola):
                stat='KOMP BR TYP FAKT'
                dane.append(stat)
            elif (TrescS.strip() in puste_pola):
                stat='KOMP BR TRESC'
                dane.append(stat)
            elif (WyznacznikS.strip() in puste_pola):
                stat='KOMP BR WYZN'
                dane.append(stat)
            elif (DataFaktS in puste_pola):
                stat='KOMP BR DAT FAKT'
                dane.append(stat)
            elif (NumerFaktS==0):
                stat='KOMP BR NR FAKT'
                dane.append(stat)
            elif (KontoS.strip()==''):
                stat='KOMP BR KONT'
                dane.append(stat)

        if TypFaktS.strip()=='D' and stat=='OK':
            if PlatnikS.strip()=='':
                stat='BR PLAT D'
                dane.append(stat)
            if WyznacznikS.strip() in puste_pola:
                stat='BR WYZN D'
                dane.append(stat)
            if DataFaktS not in puste_pola:
                stat='IS DAT D'
                dane.append(stat)
            if NumerFaktS<>0:
                stat='IS NR D'
                dane.append(stat)

        if KwotaS==0 and TypFaktS.strip()<> '' and stat=='OK':
            stat='BR KWOT'
            dane.append(stat)

        if KursS==1 and waluta <> 'PLN'  and stat=='OK':
            stat='KURS WAL 1'
            dane.append(stat)

        if KursS<>1 and waluta=='PLN'  and stat=='OK':
            stat='KURS PL NIE 1'
            dane.append(stat)

        #sprawdzenie czy przy wpisanym wyznaczniku wpisany jest typ F,K,D
        if not WyznacznikS.strip() in puste_pola:
            if not TypFaktS.strip() in ['F','K','D']:
                stat='WYZN TYP FKD'
                dane.append(stat)

        if stat=='OK':
            if KontoS not in puste_pola :
                if ((TypFaktS.strip() in ['F','K','D']) or (WyznacznikS.strip() not in puste_pola) or (DataFaktS not in puste_pola) or (NumerFaktS<>0)) and (not kompensata):
                    stat='KONT LUB FAKT'
                    dane.append(stat)
                elif TrescS=='':
                    stat='BR TRES'
                    dane.append(stat)

            if TypFaktS in ['F','K']:
                if (WyznacznikS.strip() in puste_pola) or (DataFaktS in puste_pola) or  (NumerFaktS==0):
                    stat="BR ZAL PAR"

                if stat=='OK':
                    sql = "SELECT platnik_id FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"'"
                    sql=sql+" AND wyznacznik_id='"+WyznacznikS+"' AND typ_dok='"+TypFaktS+"'"
                    sql=sql+" AND data='"+DataFaktS+"' AND numer="+str(NumerFaktS)+";"
                    stat,d,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
                    if stat=='OK':
                        if len(d)==0:
                            stat="BL ZAL"
                            dane.append(stat)
                        elif d[0][0].strip()<> PlatnikS.strip():
                            stat="BL PLATZ"
                            dane.append(stat)
            # zalego z patnoci
            elif TypFaktS=='P':
                if KontoS in puste_pola:
                    stat="BR KONTA PL"
                    dane.append(stat)
                elif PlatnoscS==0:
                    stat="BR PLATNOSCI"
                    dane.append(stat)
                #sprawdzenie,czy patno istnieje jest wyej. Tu sprawdzamy czy patno i konto s wpisane
            # dane z dowodw dostaw
            elif TypFaktS=='D':
                if len(TrescS)<11:
                    stat='KR TRESCS'
                    dane.append(stat)
                if stat=="OK":
                    from funkcje import fs_dowody_dostaw_pom
                    data_dostawy_rap="20"+TrescS[0:2]+"-"+TrescS[2:4]+"-"+TrescS[4:6]

                    if data_dostawy_rap < '2016-10-01':
                        Oddzial_rap="0"+TrescS[6]

                        stat,Trasy_rap=fs_dowody_dostaw_pom.PodajTrasyDlaOddzialuZKoncowkiTras(self.PolSQL,self.firma_id,Oddzial_rap,TrescS[7:9])
                        if stat=="OK":
                            if len(Trasy_rap) ==0:
                                stat=" Nie znaleziono tras dla odziau "+Oddzial_rap+" i kocwki trasy "+TrescS[7:9]
                                dane.append(stat)

                            Tryb_rap=TrescS[6]+TrescS[9]
                            NrDowodu_rap=TrescS[10:]
                            Trasa_sql = " AND ddp.trasa IN ("+str(Trasy_rap)[1:-1]+")"

                    else:
                        Oddzial_rap=TrescS[6:8]
                        Trasa_rap = TrescS[8:12]
                        Tryb_rap = TrescS[12:14]
                        NrDowodu_rap=TrescS[14:]
                        Trasa_sql = " AND ddp.trasa ='"+Trasa_rap+"'"

                if stat=='OK':
                    SQL="SELECT SUM(ddp.cena_brutto1*ddp.ilosc_dost1) FROM rs_dowody_dostaw_pozycje ddp"
                    SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,data,oddzial_id,trasa,tryb_dostawy,numer)"
                    SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.data='"+data_dostawy_rap+"'"
                    SQL+=" AND ddp.oddzial_id='"+Oddzial_rap+"' "+Trasa_sql
                    SQL+=" AND ddp.tryb_dostawy='"+Tryb_rap+"' AND ddp.numer="+NrDowodu_rap
                    if PlatnikS <> '':
                        SQL+=" AND dd.platnik_id='"+PlatnikS+"'"

                    stat,DDowodu,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
                    if stat<>'OK':
                        stat='BL SPR DOW'
                if stat=='OK':
                    if len(DDowodu)==0:
                        stat='BR DOW DOST'
                        dane.append(stat)
                    elif DDowodu[0][0] in [0,None]:
                        stat='BR DOW DOST'
                        dane.append(stat)

    # czy byly jakies bledy
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    # sprawdzenie danych dla typu 'N' - niezidentyfikowany
    if stat == 'OK' and TypFaktS == 'N':
        if KontoS.strip() == '':
            stat = 'BR KONTO DLA N'
            dane.append(stat)

        if PlatnikS.strip() == '':
            stat = 'BR PLATNIK DLA N'
            dane.append(stat)

        if TypS.strip() <> 'P':
            stat = 'BL TYP DLA N'
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- Insert danych (1,2)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [1,2]:
    if UprIns:
        sql = "INSERT INTO rs_kasy_banki_pozycje"
        PolaN="firma_id,okres_id,kasa_bank_id"
        WartosciN = "'"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['typ','symbol_dok','tresc','konto']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['platnik_id','kierowca']:
                PolaN += ","+pole
                if wart in puste_pola:
                    WartosciN += ",NULL"
                else:
                    WartosciN += ",'"+str(wart)+"'"
            else:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                NrPoz = wart
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"

        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)

        if stat<>'OK':
            stat='BL INS'
            dane.append(stat)
    else:
        stat='BR_UPR_INS'
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- Update danych (3,4)
#-------------------------------------------------------------------------------

if (Fun in [3,4]) and (stat=='OK'):
    if not UprUpd:
        stat='BR_UPR_UPD'
        dane.append(stat)

    if stat=='OK':
        sql = "UPDATE rs_kasy_banki_pozycje SET "
        Filtr = "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND nr_poz="+NrPoz
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole in ['typ','symbol_dok','konto','tresc']:
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['kierowca','platnik_id']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"
            elif wart == "NULL":
                sql += pole+"="+str(wart)+","
            else:
                sql += pole+"="+str(wart)+","
            if pole == "nr_poz":
                NrPoz = wart
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)


#-------------------------------------------------------------------------------
# SPRAWDZENIE, CZY NIE MA ZEROWEJ POZYCJI
#-------------------------------------------------------------------------------

if stat=='OK':
    NrZmieniony=0

    SQL="SELECT min(nr_poz),max(nr_poz) FROM rs_kasy_banki_pozycje "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    SQL+=" AND kasa_bank_id='"+KasaBank+"';"

    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DTest)>0:
            if DTest[0][0]==0:
                rsglobal.ZapiszDoLogow('ZMIANA POZYCJI ZERO W POZYCJE DANE '+str(klucze),3)
                SQL="UPDATE rs_kasy_banki_pozycje SET nr_poz="+str(DTest[0][1]+1)
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
                SQL+=" AND kasa_bank_id='"+KasaBank+"'"
                SQL+=" AND nr_poz=0;"
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat=='OK':
                    NrZmieniony=DTest[0][1]+1
                    NrPoz=str(DTest[0][1]+1)


#-------------------------------------------------------------------------------
#SELECT
#-------------------------------------------------------------------------------

if (Fun in [1,2,3,4,5]) and (stat=='OK'):
    Sql="SELECT * FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"'"
    Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
    Sql+=" AND nr_poz="+str(NrPoz)

    stat,dane,wyn1,dump=self.PolSQL.Execute(Sql,3)
    if stat<>'OK':
        stat='BL PRZ'
        dane.append(stat)

if stat=='OK' and Fun not in [15,17,12]:
    CzyPlatnosci=False
    CzyZaleglosci=False
    if stat=='OK':
        #uprawnienia do zmiany danych; uprawnienia do insert; czy w pozycji s podpozycje; numer pozycji po zmianie z zera
        wyn2=[str(UprUpd),str(UprIns),False,CzyPlatnosci,CzyPlatnosci,NrZmieniony]
