# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_kasy_banki_sposoby_zaplaty.py
# Purpose:     Sposoby zapaty dla Kas/bankw
# Author:      Bartosz Pagan
# Created:     2022/02/03
# RCS-ID:      $Id: fs_kasy_banki_sposoby_zaplaty.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2022-04-05 Wojciech Skowron (12851) Sposoby zapaty dla kas/bankw

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'KasaBank': [1, 5], }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = "Uwaga: wywoanie funkcji fs_kasy_banki_sposoby_zaplaty z numerem "+str(Funkcja)+" bez parametrw: "+Lista

    if Funkcja in [1, 5]:
        KasaBank = str(klucze['KasaBank'])

UprMod = (((self.oddzial_id, '171012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

# ------------------------------------------------------------------------------------------------------------
# -------------------------- DELETE
# ------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1 and len(Delete[0]) > 0:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

        if stat == 'OK':
            DEL = ''
            zmienne = []
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_kasy_banki_sposoby_zaplaty 
                          WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s"""
                zmienne.extend([self.firma_id, self.okres_id, KasaBank])
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"=%s"
                    zmienne.append(str(wart))
                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL), 1, zmienne)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE DANYCH (1)
# -------------------------------------------------------------------------------


def SprawdzDane(self, pola_wiersze, wartosci_wiersze, nr_wierszy, dane, wyn2):
    for pola, wartosci, nr_wiersza in zip(pola_wiersze, wartosci_wiersze, nr_wierszy):
        for pole, wart in zip(pola, wartosci):
            if pole == 'lp':
                if wart != 0:
                    if wart < 0 or wart >= (2**16)/2:
                        stat = 'BL_LP'
                        dane.append(stat)
                        wyn2.append((nr_wiersza, 0))

            elif pole == 'sposob_zaplaty':
                if wart.strip() == '':
                    stat = 'BR_SPOSOB'
                    dane.append(stat)
                    wyn2.append((nr_wiersza, 1))
                else:
                    SEL = """SELECT 1 FROM rs_sposoby_zaplaty WHERE firma_id=%s AND kod=%s;"""
                    zmienne = [self.firma_id, str(wart)]
                    rsglobal.ZapiszDoLogow('Spr sposob_zaplaty: ' + self.PolSQL.Mogrify(SEL, zmienne))
                    stat, d_sposob, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania sposobu zapaty: ' + stat
                        dane.append(stat)
                    elif len(d_sposob) == 0:
                        stat = 'BL_SPOSOB'
                        dane.append(stat)
                        wyn2.append((nr_wiersza, 1))

            elif pole == 'konto':
                if wart.strip() != '':
                    SEL = "SELECT rsf_podaj_parametry_konta(%s,%s,%s);"
                    zmienne = [self.firma_id, self.okres_id, str(wart)]
                    DaneTmp = self.PolSQL.Execute(SEL, 3, zmienne)[1]
                    if DaneTmp != [] and DaneTmp is not None:
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat = 'BL_KONTO'
                            dane.append(stat)
                            wyn2.append((nr_wiersza, 3))


if stat == "OK" and Funkcja == 1 and (len(Update[0]) > 0 or len(Insert[0]) > 0):
    if not UprMod:
        stat = 'UPR_MOD'
        dane.append(stat)

    if stat == 'OK':
        if len(Update[0]) > 0:
            pola_wiersze = Update[0]
            wartosci_wiersze = Update[1]
            nr_wierszy = Update[-1]
            SprawdzDane(self, pola_wiersze, wartosci_wiersze, nr_wierszy, dane, wyn2)

        if len(Insert[0]) > 0:
            pola_wiersze = [Insert[1]]*len(Insert[0])
            wartosci_wiersze = Insert[0]
            nr_wierszy = Insert[-1]
            SprawdzDane(self, pola_wiersze, wartosci_wiersze, nr_wierszy, dane, wyn2)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---   UPDATE (1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Update[0]) > 0:
    UPD = ''
    zmienne = []

    for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
        UPD += "UPDATE rs_kasy_banki_sposoby_zaplaty SET "
        for pole, wart in zip(pola, wartosci):
            if pole in ['lp', 'sposob_zaplaty', 'konto']:
                UPD += pole+"=%s,"
                zmienne.append(str(wart))

        UPD = UPD.strip(",")
        UPD += " WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s"
        zmienne.extend([self.firma_id, self.okres_id, KasaBank])

        for pole, wart in zip(Update[3], klucz):  # petla po kluczu
            UPD+= " AND "+pole+"=%s"
            zmienne.append(str(wart))

        UPD += ";"
    if UPD != '':
        rsglobal.ZapiszDoLogow('UPD: '+self.PolSQL.Mogrify(UPD, zmienne))
        stat,dump,dump,dump=self.PolSQL.Execute(UPD, 1, zmienne)
        if stat != 'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)

# -------------------------------------------------------------------------------
# ---   INSERT (1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Insert[0]) > 0:
    INS = ''
    zmienne = []
    pola = Insert[1]

    for wartosci in Insert[0]:
        INSERT  = "INSERT INTO rs_kasy_banki_sposoby_zaplaty "
        KOLUMNY = "(firma_id, okres_id, kasa_bank_id"
        VALUES  = " VALUES (%s,%s,%s"
        zmienne.extend([self.firma_id, self.okres_id, KasaBank])
        for pole, wart in zip(pola, wartosci):
            if pole in ['lp', 'sposob_zaplaty', 'konto']:
                KOLUMNY += ","+pole
                VALUES+=",%s"
                zmienne.append(str(wart))

        KOLUMNY+=")"
        VALUES+=");"
        INS += INSERT+KOLUMNY+VALUES

    if INS != '':
        rsglobal.ZapiszDoLogow('INS: '+self.PolSQL.Mogrify(INS, zmienne))
        stat,dump,dump,dump=self.PolSQL.Execute(INS, 1, zmienne)
        if stat != 'OK':
            stat = "Bd przy dodawaniu danych: "+stat
            dane.append(stat)

# ------------------------------------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
# ------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1, 5]:
    # pobranie danych
    SQL = "SELECT lp, sposob_zaplaty, sz.opis, konto FROM rs_kasy_banki_sposoby_zaplaty kb "
    SQL += "JOIN rs_sposoby_zaplaty sz ON kb.firma_id=sz.firma_id AND sz.kod=kb.sposob_zaplaty  "
    SQL += "WHERE kb.firma_id=%s AND okres_id=%s AND kasa_bank_id=%s ORDER BY lp;"
    zmienne = [self.firma_id, self.okres_id, str(KasaBank)]
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        stat = u"Bd przy pobieraniu danych: "+stat
        dane.append(stat)