
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kategorie_fakturowanie_dane.py
# Purpose:     wczytuje/edytuje dane fakturowe kontrahenta
#
# Author:      Marcin Grzda
# Created:     2008/03/15
# RCS-ID:      $Id: fs_kategorie_fakturowanie_dane.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#--- klucze to [Kontrahent,Data,Polecenie]

Kateg=rsglobal.Dekoduj(klucze[0])
Fun=klucze[-1]
stat='OK'

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------


if Fun in [1,2]:
    if ((self.oddzial_id,'014043') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat = "OK"
    else:
        stat='UPR INS'
        
if Fun in [3,4]:
    if ((self.oddzial_id,'014042') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat = "OK"
    else:
        stat='UPR UPD'

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (1,2 - insert; 3,4 update)
#-------------------------------------------------------------------------------

if (Fun in [1,2,3,4]) and (stat=="OK"):
    dane = []

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'kateg_kontrahenta':
            if wart=='':
                stat='BR KATEG'
                dane.appedn(stat)
            else:
                st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_kateg_kontrahentow WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if st<>'OK':
                    stat="BL SPR KATEG"
                    dane.append(stat)
                elif len(d) ==0:
                    stat = "BL KATEG"
                    dane.append(stat)
                else:
                    st,d,dump,dump = self.PolSQL.Execute("SELECT kateg_kontrahenta FROM rs_kategorie_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta='"+wart+"';" ,3)
                    if st<>"OK":
                        stat="BL SPR KATEG"
                        dane.append(stat)
                    elif len(d)>0:
                        stat="KATEG IN USE"
                        dane.append(stat)
                            

        if pole == 'wyznacznik':
            if wart<>'':
                st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"';" ,3)
                if st<>'OK':
                    stat="BL SPR WYZN"
                    dane.append(stat)
                elif len(d) ==0:
                    stat = "BL WYZN"
                    dane.append(stat)
                    
        if pole == 'wersja':
            if wart=='':
                stat='BR WERS'
                dane.appedn(stat)
            else:
                st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if st<>'OK':
                    stat='BL SPR WERS'
                    dane.append(stat)
                elif len(d) ==0:
                    stat = "BL WERS"
                    dane.append(stat)                    
                    
        if pole == 'spos_zaplaty':
            if wart<>'':
                st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if st<>'OK':
                    stat='BL SPR SPZ'
                    dane.append(stat)
                elif len(d) ==0:
                    stat = "BL SPZ"
                    dane.append(stat)                    
                    
        if pole == 'spos_dostawy':
            if wart<>'':
                st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if st<>"OK":
                    stat='BL SPR SPD'
                    dane.append(stat)
                elif len(d) ==0:
                    stat = "BL SPD"
                    dane.append(stat)                    
                    
        if pole == 'projekt_id':
            if wart<>'':
                st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+wart+"';" ,3)
                if st<>'OK':
                    stat='BL SPR PROJ'
                    dane.append(stat)
                elif len(d) ==0:
                    stat = "BL PROJ"
                    dane.append(stat)       
        
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat=='OK' :
    ins = "INSERT INTO rs_kategorie_fakturowanie "
    Pola="firma_id"
    Wartosci="'"+self.firma_id+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
            
        if pole in ['wyznacznik','wersja','spos_zaplaty','spos_dostawy','projekt_id']:
            Pola= Pola+","+pole
            if wart=='':
                Wartosci+=",NULL"
            else:    
                Wartosci+=",'"+wart+"'"
        elif pole=='kateg_kontrahenta':
            Pola+=","+pole
            Wartosci+=",'"+wart+"'"
            Kateg=wart
        elif pole in ['dni','upust','maks_wart']:
            Pola= Pola+","+pole
            Wartosci= Wartosci+","+str(wart)

    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat='BL INS'
        dane.append(stat)
    
                    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat=='OK':
    where = " WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta='"+Kateg+"';" 
    upd = "UPDATE rs_kategorie_fakturowanie SET "
        
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole in ['wyznacznik','wersja','spos_zaplaty','spos_dostawy','projekt_id']:
            if wart=='':
                upd+=pole+"=NULL,"
            else:    
                upd+=pole+"='"+wart+"',"
        elif pole=='kateg_kontrahenta':
            upd+=pole+"='"+wart+"',"
            Kateg=wart
        elif pole in ['dni','upust','maks_wart']:
            upd+=pole+"="+str(wart)+","

    upd = upd[0:len(upd)-1]+where
    stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    if stat<>'OK':
        stat='BL UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and (stat=='OK'):
    # pobranie danych fakturowych kontrahenta
    SELECT="SELECT * FROM rs_kategorie_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta='"+Kateg+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)
            #--- kategoria kontrahenta
            if ((self.oddzial_id,'011010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_kateg_kontrahentow WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"kateg_kontrahenta")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            #--- wyznacznik
            if ((self.oddzial_id,'021000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id
                +"' AND wyznacznik_id='"+tr.GetVal(0,"wyznacznik")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #--- wersja
            if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    
    
            #--- sposb zapaty
            if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_zaplaty")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    
            
            #--- sposb dostawy
            if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_dostawy")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
            #--- projekt
            if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                projekt=tr.GetVal(0,"projekt_id")
                if not projekt in ('','None',None):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+projekt+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('')
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        stat='BL SQL PRZ'
        dane.append(stat)


#----------------  sprawdzamy czy dane maj by przesyane dalej
if stat == "OK" and Fun in (1, 2, 3, 4) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    if Fun in (1, 3):
        # bdzie bez pobierania
        klucze[-1] += 1
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_kategorie_fakturowanie'", 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], [funkcja, klucze, pola, wartosci])
