#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:			fs_kierowcy_wersje_stawki_dane.py
# Purpose:		zmiana stawek dla tras
# Author:		Konrad Opieka
# Created:		2017/03/21
# RCS-ID:		$Id: fs_kierowcy_wersje_stawki_dane.py $
# Copyright:	(c) 2017 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
# 2018-02-27 (0010944) Rafa Woniak      - dwie nowe kolumny
# 2019-01-17 (0011364) Aleksander Bargie - W oknie Trasy - stawki doda kolumn km
# 2020-09-23   (12126) Wojciech Skowron   - Kolumna dodatek
# 2022-11-29 Aleksander Bargie (13252) Wystawianie faktur dla transportu - okno zlece transportowych(zmiana numerow uprawnien)
# 2023-09-22 Wojciech Skowron   (13537) Kolumna dystans_godz i inne, sprawdzenie zakresu dla pl liczbowych

stat = 'OK'
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Kod':[1,5]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = "Uwaga: wywoanie funkcji fs_kierowcy_wersje_stawki_dane z numerem "+str(Funkcja)+" bez parametrw: "+Lista

if Funkcja in [1,5]:
    Kod = klucze['Kod']

UprEdycja    = (((self.oddzial_id,'103002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie  = (((self.oddzial_id,'103004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDodawanie = (((self.oddzial_id,'103003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE UPDATE
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUsuwanie:
            stat='UPR UPD'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  UPDATE SPRAWDZANIE DANYCH
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'od_dnia':
                        if wart == '    -  -  ':
                            stat = 'BR DATA'
                            dane.append('BR DATA')
                        elif wart != '    -  -  ':
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = 'BL DATA'
                                dane.append('BL DATA')
                            else:
                                SQL ="SELECT * FROM rs_trasy_transport WHERE firma_id='"+self.firma_id+"' "
                                SQL+="AND kod='"+Kod+"' AND od_dnia='"+wart+"';"
                                stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    dane.append('BL SPR DATA')
                                elif len(D) > 0:
                                    stat = 'EX DATA'
                                    dane.append('EX DATA')
                    elif pole == 'ryczalt':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**14):
                            stat = 'Warto w polu Ryczat przekracza dozwolony zakres'
                    elif pole == 'za_km':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**4):
                            stat = 'Warto w polu Za km przekracza dozwolony zakres (0-9999,99)'
                    elif pole == 'za_godz':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**4):
                            stat = 'Warto w polu Za godz przekracza dozwolony zakres (0-9999,99)'
                    elif pole in ('proc_obrotu', 'proc_got_w_terminie', 'proc_got_po_terminie'):
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart <= 100):
                            stat = 'Warto w polu $ przekracza dozwolony zakres (0-100)'
                            if pole == 'proc_obrotu':
                                stat = stat.replace('$', '% obrotu')
                            elif pole == 'proc_got_w_terminie':
                                stat = stat.replace('$', '% got.term')
                            elif pole == 'proc_got_po_terminie':
                                stat = stat.replace('$', '% got.po term')
                    elif pole == 'dystans_km':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**3):
                            stat = 'Warto w polu km przekracza dozwolony zakres (0-999)'
                    elif pole == 'dodatek':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**14):
                            stat = 'Warto w polu Dodatek przekracza dozwolony zakres'
                    elif pole == 'dystans_godz':
                        spr_wart = rsglobal.RSRound(wart, 1)
                        if not (0 <= spr_wart < 10**2):
                            stat = 'Warto w polu Dystans godz przekracza dozwolony zakres (0-99,9)'


#-----------------------------------------------------------------------------------------------------------------------
#-------  UPDATE
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Update[0])):
                UPDATE ="UPDATE rs_trasy_transport "
                SET ='SET '
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole in ['od_dnia','opis']:
                        SET+=pole+"='"+wart+"',"
                    #WS 2023-09-22 - dystans_godz, inne
                                                                                                                    #AB 17.01.19r     #WS 2020-09-23
                    if pole in ['ryczalt','za_km','za_godz','proc_obrotu','proc_got_w_terminie','proc_got_po_terminie', 'dystans_km', 'dodatek',
                                'dystans_godz']:
                        SET+=pole+"="+str(wart)+","
                    if pole in ['bez_wywozu', 'inne']:
                        if wart==1:
                            SET+=pole+"=TRUE,"
                        else:
                            SET+=pole+"=FALSE,"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Kod+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['od_dnia']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";"
                SQL=UPDATE+SET+WHERE
                #rsglobal.ZapiszDoLogow('aaaaaaaaaaaa '+str(SQL),1)
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat != 'OK':
                    dane.append('BL UPD')


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE INSERT
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprUsuwanie:
            stat='UPR INS'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  INSERT SPRAWDZANIE DANYCH
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'od_dnia':
                        if wart == '    -  -  ':
                            stat = 'BR DATA'
                            dane.append('BR DATA')
                        elif wart != '    -  -  ':
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = 'BL DATA'
                                dane.append('BL DATA')
                            else:
                                SQL ="SELECT * FROM rs_trasy_transport WHERE firma_id='"+self.firma_id+"' "
                                SQL+="AND kod='"+Kod+"' AND od_dnia='"+wart+"';"
                                #rsglobal.ZapiszDoLogow('aaaaaaaaaaaa '+str(SQL),1)
                                stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    dane.append('BL SPR DATA')
                                elif len(D) > 0:
                                    stat = 'EX DATA'
                                    dane.append('EX DATA')
                    elif pole == 'ryczalt':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**14):
                            stat = 'Warto w polu Ryczat przekracza dozwolony zakres'
                    elif pole == 'za_km':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**4):
                            stat = 'Warto w polu Za km przekracza dozwolony zakres (0-9999,99)'
                    elif pole == 'za_godz':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**4):
                            stat = 'Warto w polu Za godz przekracza dozwolony zakres (0-9999,99)'
                    elif pole in ('proc_obrotu', 'proc_got_w_terminie', 'proc_got_po_terminie'):
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart <= 100):
                            stat = 'Warto w polu $ przekracza dozwolony zakres (0-100)'
                            if pole == 'proc_obrotu':
                                stat = stat.replace('$', '% obrotu')
                            elif pole == 'proc_got_w_terminie':
                                stat = stat.replace('$', '% got.term')
                            elif pole == 'proc_got_po_terminie':
                                stat = stat.replace('$', '% got.po term')
                    elif pole == 'dystans_km':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**3):
                            stat = 'Warto w polu km przekracza dozwolony zakres (0-999)'
                    elif pole == 'dodatek':
                        spr_wart = rsglobal.RSRound(wart, 2)
                        if not (0 <= spr_wart < 10**14):
                            stat = 'Warto w polu Dodatek przekracza dozwolony zakres'
                    elif pole == 'dystans_godz':
                        spr_wart = rsglobal.RSRound(wart, 1)
                        if not (0 <= spr_wart < 10**2):
                            stat = 'Warto w polu Dystans godz przekracza dozwolony zakres (0-99,9)'


#-----------------------------------------------------------------------------------------------------------------------
#-------  INSERT
#-----------------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            for i in xrange(len(Insert[0])):
                INSERT ="INSERT INTO rs_trasy_transport "
                KOLUMNY="(firma_id,kod"
                VALUES =" VALUES ('"+self.firma_id+"','"+Kod+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    KOLUMNY+=","+pole
                    if pole in ['od_dnia','opis']:
                        VALUES+=",'"+wart+"'"
                    #WS 2023-09-22 - dystans_godz, inne
                                                                                                                        #AB 17.01.19r   #WS 2020-09-23
                    elif pole in ['ryczalt','za_km','za_godz','proc_obrotu','proc_got_w_terminie','proc_got_po_terminie', 'dystans_km', 'dodatek',
                                  'dystans_godz']:
                        VALUES+=","+str(wart)
                    elif pole in ['bez_wywozu', 'inne']:
                        if wart==1:
                            VALUES+=",TRUE"
                        else:
                            VALUES+=",FALSE"
                KOLUMNY+=")"
                VALUES+=");"
                SQL=INSERT+KOLUMNY+VALUES
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat != 'OK':
                    dane.append('BL INS')


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='UPR DEL'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  DELETE
#-----------------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_trasy_transport "
                DELETE+= "WHERE firma_id='"+self.firma_id+"' AND kod='"+Kod+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['od_dnia']:
                        DELETE+= " AND "+pole+"='"+wart+"'"

                DELETE+= ";"
                stat,dump,dump,dump=self.PolSQL.Execute(DELETE, 1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  POBRANIE
#-----------------------------------------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1, 5]:
    #WS 2020-09-23 - dodatek
    #WS 2023-09-22 - dystans_godz, inne
                                                                                                                    #AB 17.01.19r
    SQL ="SELECT od_dnia,ryczalt,za_km,za_godz,proc_obrotu,proc_got_w_terminie,proc_got_po_terminie,bez_wywozu,opis, dystans_km, dodatek, dystans_godz, inne FROM rs_trasy_transport "
    SQL+="WHERE firma_id='" + self.firma_id + "' AND kod='"+Kod+"' ORDER BY 1;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL, 3)
    if stat<>'OK':
        stat = 'BL POB'
