# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kierowcy_wersje_wydruk_pdf.py
# Purpose:     wydruk pdf
# Author:      Piotr Witkowski
# Created:     2017/04/03
# RCS-ID:      $Id: fs_kierowcy_wersje_wydruk_pdf.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2017-05-12 (10498) Piotr Witkowski - Wysanie pdf dla przewonikw
# 2018-02-27 (0010944) Rafa Woniak - kolumna Dod. za gotwk
# 2021-11-03 Wojciech Skowron   - (12174) Poprawiona obsuga pliku
# 2022-07-13 Aleksander Bargie - (12989) Komunikat gdy tworzenie raportu pdf nie powiedzie si

import binascii
import tempfile
import time
import os

import rsglobal
import rs_print_util
from funkcje import fs_generator_pdf_html
from funkcje import fs_wydruki_kierowcy_wersje_pom

def PodajCeneWartosc(artykul,CzyWlasny,CzySpecjalny,CzyDzPowszedni,CzyDzien,DaneWersje,DaneSlownika,CzyCena,CzyMagazyn):
    #pobranie wersji cenowej parametry: artykul, czy kierowca wlasny, czy platnik specjalny, czy dzien powszedni,
    # dane z rs_kierowcy_wersje, slownik z cenami, parametr czy podawac cene czy wersje cenowa
    #lista z wersjami cenowymi: wc_normal, wc_swiat, wc_przerz, wc_noc
    wersja=['','','','']
    Cena=0
    for w in DaneWersje:
        if w[0]==CzyWlasny and w[1]==CzySpecjalny:
            wersja[0]=w[2]
            wersja[1]=w[3]
            wersja[2]=w[4]
            wersja[3]=w[5]

    if not CzyMagazyn:
        #cena dla wersji cenowej normalnej
        if CzyDzPowszedni :
            if CzyCena:
                return DaneSlownika.get((artykul, wersja[0]), 0)
            else:
                return wersja[0]

        else:
            #cena dla wersji cenowej swiatecznej
            if CzyCena:
                return DaneSlownika.get((artykul, wersja[1]),0)
            else:
                return wersja[1]
    else:
        #cena dla wersji cenowej przerzuty dzien
        if CzyDzien:
            if CzyCena:
                return DaneSlownika.get((artykul, wersja[2]), 0)
            else:
                return wersja[2]
        else:
            #cena dla wersji cenowej przerzuty noc
            if CzyCena:
                return DaneSlownika.get((artykul, wersja[3]),0)
            else:
                return wersja[3]


def RysowanieTabeli(pdf,DANE,rs_print_util,wiersz=[]):
    pdf.dane=DANE
    pdf.RozmiarCzcionki=8
    pdf.Tresc.append(pdf.ZrobNaglowek())
    pdf.RozmiarCzcionki=6
    pdf.PrzygotujDane()
    if wiersz:
        pdf.Tabelakoniec = []
        pdf.Tabelakoniec.append(wiersz)
        pdf.DodajFormat(pdf.StylKoniec,u'kolumna',len(pdf.kol),len(pdf.Tabelakoniec),-1,len(pdf.Tabelakoniec))
        pdf.ZrobStyle()
        pdf.koniec=rs_print_util.Table(pdf.Tabelakoniec,pdf.KolumnyTabelki)
        pdf.koniec.setStyle(pdf.StylKoniecInne)
        pdf.Tresc.append(pdf.koniec)
    pdf.Tresc.append(rs_print_util.Pagebreak())

def PodsumowanieTabeli(Wart1,Wart2):
    wiersz=[]
    wiersz.append('Suma: '+str(rsglobal.RSRound(Wart1+Wart2,2)))
    for x in range(4):
        wiersz.append('')
    wiersz.append('Razem:')
    wiersz.append(str(rsglobal.RSRound(Wart1,2)))
    wiersz.append('')
    wiersz.append('')
    wiersz.append(str(rsglobal.RSRound(Wart2,2)))
    return wiersz

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'DataOd':[2,3,],'DataDo':[2,3,],'Przewoznik':[2,3,],'Oddzial':[2,],'OddzialOpis':[2,],}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kierowcy_wersje_wydruk_pdf z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [2,]:
        Oddzial = klucze['Oddzial']
        OddzialOpis = klucze['OddzialOpis']
    if Funkcja in [2,3]:
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']
        Przewoznik = klucze['Przewoznik']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []


#-------------------------------------------------------------------------------
# Pobranie listy przewonikw
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    sql ="SELECT DISTINCT przewoznik_id FROM rs_trasy_przewoznicy WHERE firma_id='"+self.firma_id+"' "
    sql+=" ORDER BY przewoznik_id DESC;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych przewonika: '+stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# Pobranie listy oddziaw
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 3:
    sql = "SELECT DISTINCT r.oddzial_id, o.nazwa FROM rs_dowody_dostaw_rentownosc r "
    sql +="JOIN rs_oddzialy o ON r.firma_id=o.firma_id AND r.oddzial_id=o.oddzial_id "
    sql += "WHERE r.firma_id='" + self.firma_id + "' AND r.data between '" + DataOd + "' and '" + DataDo + "' "
    sql += "AND r.przewoznik_id='" + Przewoznik + "' ORDER BY r.oddzial_id ASC;"
    #rsglobal.ZapiszDoLogow("SQL"+sql,1)
    stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych oddziau: ' + stat
        dane.append(stat)


#-------------------------------------------------------------------------------
# Pobranie listy przewonikw
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 2:
    Plik = tempfile.mktemp('.pdf')
    Drukowac=False
    DaneRentownosci=[]
    sql ="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(Przewoznik.strip())+"' ;"
    stat,PrzewoznikOpis,wyn1,dump = self.PolSQL.Execute(sql,3)
    rsglobal.ZapiszDoLogow(sql, 5)
    rsglobal.ZapiszDoLogow(PrzewoznikOpis, 5)
    if stat <> 'OK':
        stat = 'Bd pobrania nazwy przewonika: '+stat
        dane.append(stat)
    else:
        PrzewoznikOpis=PrzewoznikOpis[0][0]
        sql ="SELECT DISTINCT d.trasa,d.oddzial_id FROM rs_dowody_dostaw d JOIN rs_trasy_przewoznicy p ON d.firma_id=p.firma_id AND d.trasa=p.kod "
        sql+="WHERE d.firma_id='"+self.firma_id+"' AND d.data BETWEEN '"+DataOd+"' and '"+DataDo+"' "
        sql+="AND p.przewoznik_id='"+str(Przewoznik.strip())+"' AND d.oddzial_id='"+Oddzial+"';"
        stat,Trasa,wyn1,dump = self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow(sql, 5)
        rsglobal.ZapiszDoLogow(Trasa, 5)

        if stat <> 'OK':
            stat = 'Bd pobrania danych kierowcy: '+stat
            dane.append(stat)
        else:

            if len(Trasa)>0:

                Select="SELECT login FROM rs_operatorzy WHERE operator_id = '"+str(self.operator_id)+"';"
                stat,operator,dump,dump = self.PolSQL.Execute(Select,3)
                nag = str(u'Program:Anakonda, Firma:'+self.firma_id+u'Operator:'+operator[0][0]+u', Wykonano dnia:'+time.strftime("%Y.%m.%d %H:%M"))
                opisprzewoznika= str(u', Oddzia: '+OddzialOpis+u', Przewonik:'+str(Przewoznik.strip())+u'-'+str(PrzewoznikOpis))
                #---------------------------------------------------------------------
                #-----Tabelka z dowodw dostaw rentownoci
                #---------------------------------------------------------------------
                #RW
                sql="""
                SELECT r.trasa as "Trasa", t.opis as "Opis Trasy",SUM(liczba) as "Liczba przewozow",
                    transport as "Koszt transportu", dod_godz as "Dodatkowe godziny",
                    dod_km as "Dodatkowe kilometry", SUM(dod_proc) as "Procent za sprzedaz",
                    dod_got as "Premia",
                    ryczalt as "Ryczalt",
                    transport+dod_godz+dod_km+SUM(dod_proc)+ryczalt as "Razem"
                FROM rs_dowody_dostaw_rentownosc r
                JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod
                WHERE r.firma_id='"""+self.firma_id+"""' AND r.data between '"""+DataOd+"""' and '"""+DataDo+"""'
                AND r.przewoznik_id='"""+Przewoznik+"""' AND r.oddzial_id='"""+Oddzial+"""'
                GROUP BY r.trasa, t.opis, r.transport, r.dod_godz, r.dod_km, r.dod_got, r.ryczalt ORDER by r.trasa;
                """

                stat,DaneRentownosci,wyn1,dump = self.PolSQL.Execute(sql,3)
                #rsglobal.ZapiszDoLogow('DaneRentownosci'+str(DaneRentownosci), 1)
                if stat <> 'OK':
                    stat = u'Bd pobrania danych do tabeli dowodw dostaw rentownoci: '+stat
                    dane.append(stat)
                rsglobal.ZapiszDoLogow(sql, 5)
                rsglobal.ZapiszDoLogow(DaneRentownosci, 5)

            if stat=='OK' and len(DaneRentownosci)>0:
                rsglobal.ZapiszDoLogow('LALALALAL', 5)
                Nazwa12=[u'Artyku - Nazwa', u'J.m.',u'Dostarczone',u'Zwroty',u'Rnica',u'Cena',u'Warto',u'Niedziela',u'Cena',u'Warto']
                Nazwa3 =[u'Artyku - Nazwa', u'J.m.',u'-',          u'-',     u'Dzie',  u'Cena',u'Warto',u'Noc',      u'Cena',u'Warto']
                NazwaNaglowek=[u'Trasa',u'Opis Trasy',u'Liczba przewozw',u'Koszt transportu',u'Dodatkowe godziny',
                               u'Dodatkowe kilometry', u'Procent za sprzeda',u'Premia',u'Ryczat',u'Razem']

                Typ=['s','s','n','n','n','n','n','n','n','n']
                Dlugosc=[10,30,15,15,15,15,15,15,15,20]
                PoPrzecinku=[0,0,0,4,4,4,4,4,4,4]
                Podsumowanie=[0,0,0,0,0,0,0,0,0,0]
                Srednia=['F','F','F','F','F','F','F','F','F','F']
                Sumowac=Srednia
                Cechy = [NazwaNaglowek,Typ,Dlugosc,PoPrzecinku,Podsumowanie,Sumowac,Srednia]
                kol=[]
                IleKolumn=range(len(NazwaNaglowek))
                pdf = fs_generator_pdf_html.RSGeneratorPDF(self,Plik,naglowek=[], Zakonczenie='',dane=[],
                                                             Cechy=Cechy,sortowac=[[],[]],IleKolumn=IleKolumn,Sumowanie=[],
                                                             Sum=[[],] , Avs=[],Ilosc=[[],]  ,kol=kol, stare=[1])
                pdf.PrzygotujPDFGeneratora()
                pdf.PrzygotujPDFGeneratora2()
                pdf.ZrobStyle()
                pdf.RozmiarCzcionki=7

                DANE=DaneRentownosci
                NaglN=[]
                NaglN.append(nag)
                NaglN.append(u"Okres od "+DataOd+u" do "+DataDo +opisprzewoznika)
                pdf.naglowek = NaglN
                RysowanieTabeli(pdf,DANE,rs_print_util,[])

                #---------------------------------------------------------------------
                #---------------------------------------------------------------------
                #---------------------------------------------------------------------
                #---------------------------------------------------------------------

                Typ12=['s','s','n','n','n','n','n','n','n','n',]
                Typ3=['s','s','s','s','n','n','n','n','n','n',]
                pdf.Typ=Typ12
                pdf.Dlugosc=[45,8,16,14,14,14,14,14,14,14]
                pdf.PoPrzecinku=[0,0,3,3,3,4,2,0,4,2]
                pdf.Podsumowanie=[0,0,0,0,0,0,0,0,0,0]
                pdf.Srednia=['F','F','F','F','F','F','F','F','F','F',]
                pdf.Sumowac=Srednia
                pdf.Cechy = [Nazwa12,pdf.Typ,pdf.Dlugosc,pdf.PoPrzecinku,pdf.Podsumowanie,pdf.Sumowac,pdf.Srednia]
                pdf.IleKolumn=range(len(Nazwa12))

                pdf.PrzygotujPDFGeneratora()
                pdf.PrzygotujPDFGeneratora2()
                pdf.ZrobStyle()

            for x in range(len(Trasa)):
                rsglobal.ZapiszDoLogow('ALALALALALA', 5)
                if stat=='OK' and len(DaneRentownosci)>0:
                    rsglobal.ZapiszDoLogow('LALAdddddddddddLALAL', 5)
                    Tras=Trasa[x][0]
                    Oddz=Trasa[x][1]
                    Normalny=True
                    Specjalny=True
                    Przerzuty=True
                    stat,D = fs_wydruki_kierowcy_wersje_pom.WydrukPdf(self,DataOd,DataDo,Tras,Oddz,Normalny,Specjalny,Przerzuty,STANDARD_OPERATOR_ID)

                    rsglobal.ZapiszDoLogow('LALALALAL' + str(stat), 5)
                    if stat=='OK':
                        Dane=rsglobal.rseval(D)
                        rsglobal.ZapiszDoLogow('LALALALAL' + str(Normalny) + str(Specjalny) + str(Przerzuty), 5)
                        rsglobal.ZapiszDoLogow('DANE2' + str(Dane[2]), 5)
                        rsglobal.ZapiszDoLogow('DANE4' + str(Dane[4]), 5)
                        rsglobal.ZapiszDoLogow('DANE6' + str(Dane[6]), 5)
                        # dodatkowe kontrole - jr.
                        if Normalny:
                            if len(Dane[2])==0:    # jr
                                Normalny=False
                                DaneNormalny=[]
                            else:
                                #Dane do wydruku Normalny
                                DaneNormalny=Dane[2]
                                DaneNormalny=rssql.RSTableRowset(Dane[2],Dane[3])
                        if Specjalny:
                            if len(Dane[4])==0:    # jr
                                Specjalny=False
                                DaneSpecjalny=[]
                            else:
                                #Dane do wydruku Specjalny
                                DaneSpecjalny=Dane[4]
                                DaneSpecjalny=rssql.RSTableRowset(Dane[4],Dane[5])
                        if Przerzuty:
                            if len(Dane[6])==0:    # jr
                                Przerzuty=False
                                DanePrzerzuty=[]
                            else:
                                #Dane do wydruku Przerzuty
                                DanePrzerzuty=Dane[6]
                                DanePrzerzuty=rssql.RSTableRowset(Dane[6],Dane[7])

                        if Normalny or Specjalny or Przerzuty:
                            pdf.ZrobStyle()
                            rsglobal.ZapiszDoLogow('LAL' + str(stat) + str(DaneNormalny) + str(DaneSpecjalny) + str(DanePrzerzuty), 5)
                            if stat=='OK':
                                #Dane z rs_kierowcy_wersje
                                DaneWersje=Dane[0]
                                #DaneWersje=rssql.RSTableRowset(Dane[0],Dane[1])
                                Platnicy=DaneWersje[0][7]
                                Magazyn=str(DaneWersje[0][6]).strip()+' - '+str(DaneWersje[0][8]).strip()
                                #Slownik z cenami artykulow dla wersji cenowych
                                DaneSlownika= Dane[8]
                                #if not self.rsp.ZacznijDruk():
                                #    return
                                #--- zmienne sterujace
                                liczbaNormalny=0
                                liczbaSpecjalny=0
                                liczbaPrzerzuty=0
                                if Normalny:
                                    liczbaNormalny=len(DaneNormalny.dane)-1
                                if Specjalny:
                                    liczbaSpecjalny=len(DaneSpecjalny.dane)-1
                                if Przerzuty:
                                    liczbaPrzerzuty=len(DanePrzerzuty.dane)-1
                                iNormalny=0
                                iSpecjalny=0
                                iPrzerzuty=0

                                #--- glowna petla
                                while True:
                                    #--- wybor kierowcy
                                    trasa=''
                                    if Normalny and iNormalny<=liczbaNormalny:
                                        if trasa<DaneNormalny.GetVal(iNormalny,"trasa"):
                                            trasa=DaneNormalny.GetVal(iNormalny,"trasa")
                                    if Specjalny and iSpecjalny<=liczbaSpecjalny:
                                        if trasa<DaneSpecjalny.GetVal(iSpecjalny,"trasa"):
                                            trasa=DaneSpecjalny.GetVal(iSpecjalny,"trasa")
                                    if Przerzuty and iPrzerzuty<=liczbaPrzerzuty:
                                        if trasa<DanePrzerzuty.GetVal(iPrzerzuty,"trasa"):
                                            trasa=DanePrzerzuty.GetVal(iPrzerzuty,"trasa")
                                    if trasa=='':
                                        break
                                    Drukowac=True
                                    rsglobal.ZapiszDoLogow('DOSZLISMY TU', 5)
                                    #--- Generowanie raportow
                                    if stat=='OK' and Normalny:
                                        if iNormalny<=liczbaNormalny:
                                            pdf.Cechy[0]=Nazwa12
                                            pdf.Cechy[1]=Typ12
                                            if trasa==DaneNormalny.GetVal(iNormalny,"trasa"):
                                                NaglN=[]
                                                NaglN.append(nag)
                                                rsglobal.ZapiszDoLogow('DOSZLISMY TUUUU', 5)
                                                NaglN.append(u"Zestawienie wywiezionego asortymentu dla trasy "+str(trasa).strip()+"-"+
                                                             str(DaneNormalny.GetVal(iNormalny,"trasa_opis")).strip()+" za okres od "+DataOd+" do "+DataDo +opisprzewoznika)
                                                NaglN.append(u"Bez patnikw: "+Platnicy+"   Wersje cenowe: normalna - "+
                                                             PodajCeneWartosc('',DaneNormalny.GetVal(iNormalny,"wlasny"),False,True,False,DaneWersje,DaneSlownika,False,False)+
                                                             ",  witeczna - "+
                                                             PodajCeneWartosc('',DaneNormalny.GetVal(iNormalny,"wlasny"),False,False,False,DaneWersje,DaneSlownika,False,False))
                                                pdf.naglowek = NaglN
                                                WartoscPowsz=0
                                                WartoscNd=0
                                                DANE=[]
                                                OK=False
                                                while trasa==DaneNormalny.GetVal(iNormalny,"trasa"):
                                                    wart1=rsglobal.RSRound(PodajCeneWartosc(str(DaneNormalny.GetVal(iNormalny,"artykul_id")),DaneNormalny.GetVal(iNormalny,"wlasny"),False,True,False,DaneWersje,DaneSlownika,True,False)*DaneNormalny.GetVal(iNormalny,"roznica"),2)
                                                    wart2=rsglobal.RSRound(PodajCeneWartosc(str(DaneNormalny.GetVal(iNormalny,"artykul_id")),DaneNormalny.GetVal(iNormalny,"wlasny"),False,False,False,DaneWersje,DaneSlownika,True,False)*DaneNormalny.GetVal(iNormalny,"dostarczone_nd"),2)

                                                    if float(wart1)<>0 or float(wart2)<>0:
                                                        OK=True
                                                        wiersz=[]
                                                        wiersz.append(str(DaneNormalny.GetVal(iNormalny,"artykul_id")).strip()+' - '+str(DaneNormalny.GetVal(iNormalny,"artykul_opis")).strip())
                                                        wiersz.append(DaneNormalny.GetVal(iNormalny,"jm"))
                                                        wiersz.append(DaneNormalny.GetVal(iNormalny,"dostarczone"))
                                                        wiersz.append(DaneNormalny.GetVal(iNormalny,"zwroty"))
                                                        wiersz.append(DaneNormalny.GetVal(iNormalny,"roznica"))
                                                        wiersz.append(PodajCeneWartosc(str(DaneNormalny.GetVal(iNormalny,"artykul_id")),DaneNormalny.GetVal(iNormalny,"wlasny"),False,True,False,DaneWersje,DaneSlownika,True,False))
                                                        wiersz.append(wart1)
                                                        wiersz.append(DaneNormalny.GetVal(iNormalny,"dostarczone_nd"))
                                                        wiersz.append(PodajCeneWartosc(str(DaneNormalny.GetVal(iNormalny,"artykul_id")),DaneNormalny.GetVal(iNormalny,"wlasny"),False,False,False,DaneWersje,DaneSlownika,True,False))
                                                        wiersz.append(wart2)
                                                        DANE.append(wiersz)
                                                        WartoscPowsz+=wart1
                                                        WartoscNd+=wart2

                                                    iNormalny=iNormalny+1
                                                    if iNormalny>liczbaNormalny:
                                                        break
                                                if OK:
                                                    w = PodsumowanieTabeli(WartoscPowsz,WartoscNd)
                                                    RysowanieTabeli(pdf,DANE,rs_print_util,w)

                                    if stat=='OK' and Specjalny:

                                        rsglobal.ZapiszDoLogow('DOSZLISMY SPECJALNIE', 5)
                                        if iSpecjalny<=liczbaSpecjalny:
                                            pdf.Cechy[0]=Nazwa12
                                            pdf.Cechy[1]=Typ12
                                            if trasa==DaneSpecjalny.GetVal(iSpecjalny,"trasa"):
                                                NaglS=[]
                                                NaglS.append(nag)
                                                NaglS.append(u"Zestawienie wywiezionego asortymentu dla trasy "+trasa+"-"+str(DaneSpecjalny.GetVal(iSpecjalny,"trasa").strip()+u" za okres od "+DataOd+u" do "+DataDo )+opisprzewoznika)
                                                NaglS.append(u"Dla patnikw: "+Platnicy+u"   Wersje cenowe: normalna: "+PodajCeneWartosc('',DaneSpecjalny.GetVal(iSpecjalny,"wlasny"),True,True,False,DaneWersje,DaneSlownika,False,False)+", witeczna: "+PodajCeneWartosc('',DaneSpecjalny.GetVal(iSpecjalny,"wlasny"),True,False,False,DaneWersje,DaneSlownika,False,False))
                                                pdf.naglowek = NaglS
                                                WartoscPowsz=0
                                                WartoscNd=0
                                                DANE=[]
                                                OK=False
                                                while trasa==DaneSpecjalny.GetVal(iSpecjalny,"trasa"):
                                                    wart1=rsglobal.RSRound(PodajCeneWartosc(str(DaneSpecjalny.GetVal(iSpecjalny,"artykul_id")),DaneSpecjalny.GetVal(iSpecjalny,"wlasny"),True,True,False,DaneWersje,DaneSlownika,True,False)*DaneSpecjalny.GetVal(iSpecjalny,"dostarczone"),2)
                                                    wart2=rsglobal.RSRound(PodajCeneWartosc(str(DaneSpecjalny.GetVal(iSpecjalny,"artykul_id")),DaneSpecjalny.GetVal(iSpecjalny,"wlasny"),True,False,False,DaneWersje,DaneSlownika,True,False)*DaneSpecjalny.GetVal(iSpecjalny,"dostarczone_nd"),2)
                                                    if float(wart1)<>0 or float(wart2)<>0:
                                                        OK=True
                                                        wiersz=[]
                                                        wiersz.append(str(DaneSpecjalny.GetVal(iSpecjalny,"artykul_id")).strip()+' - '+str(DaneSpecjalny.GetVal(iSpecjalny,"artykul_opis")).strip())
                                                        wiersz.append(DaneSpecjalny.GetVal(iSpecjalny,"jm"))
                                                        wiersz.append(DaneSpecjalny.GetVal(iSpecjalny,"dostarczone"))
                                                        wiersz.append(DaneSpecjalny.GetVal(iSpecjalny,"zwroty"))
                                                        wiersz.append(DaneSpecjalny.GetVal(iSpecjalny,"roznica"))
                                                        wiersz.append(PodajCeneWartosc(str(DaneSpecjalny.GetVal(iSpecjalny,"artykul_id")),DaneSpecjalny.GetVal(iSpecjalny,"wlasny"),True,True,False,DaneWersje,DaneSlownika,True,False))
                                                        wiersz.append(wart1)
                                                        wiersz.append(DaneSpecjalny.GetVal(iSpecjalny,"dostarczone_nd"))
                                                        wiersz.append(PodajCeneWartosc(str(DaneSpecjalny.GetVal(iSpecjalny,"artykul_id")),DaneSpecjalny.GetVal(iSpecjalny,"wlasny"),True,False,False,DaneWersje,DaneSlownika,True,False))
                                                        wiersz.append(wart2)
                                                        DANE.append(wiersz)
                                                        WartoscPowsz+=wart1
                                                        WartoscNd+=wart2
                                                    iSpecjalny=iSpecjalny+1
                                                    if iSpecjalny>liczbaSpecjalny:
                                                        break
                                                if OK:
                                                    w = PodsumowanieTabeli(WartoscPowsz,WartoscNd)
                                                    RysowanieTabeli(pdf,DANE,rs_print_util,w)

                                    if stat=='OK' and Przerzuty:

                                        rsglobal.ZapiszDoLogow('DOSZLISMY PRZERZUTY', 5)
                                        if iPrzerzuty<=liczbaPrzerzuty:
                                            pdf.Cechy[0]=Nazwa3
                                            pdf.Cechy[1]=Typ3
                                            if trasa==DanePrzerzuty.GetVal(iPrzerzuty,"trasa"):
                                                NaglP=[]
                                                NaglP.append(nag)
                                                NaglP.append(u"Zestawienie wywiezionego asortymentu dla trasy "+trasa+"-"+str(DanePrzerzuty.GetVal(iPrzerzuty,"opis")).strip()+" za okres od "+DataOd+" do "+DataDo +opisprzewoznika)
                                                NaglP.append(u"z magazynu: "+Magazyn+"   Wersje cenowe: dzie - "+PodajCeneWartosc('',DanePrzerzuty.GetVal(iPrzerzuty,"wlasny"),False,False,True,DaneWersje,DaneSlownika,False,True)+", noc - "+PodajCeneWartosc('',DanePrzerzuty.GetVal(iPrzerzuty,"wlasny"),False,False,False,DaneWersje,DaneSlownika,False,True))
                                                pdf.naglowek = NaglP
                                                WartoscDz=0
                                                WartoscNoc=0
                                                DANE=[]
                                                OK=False
                                                while trasa==DanePrzerzuty.GetVal(iPrzerzuty,"trasa"):
                                                    wart1=rsglobal.RSRound(PodajCeneWartosc(str(DanePrzerzuty.GetVal(iPrzerzuty,"artykul_id")),DanePrzerzuty.GetVal(iPrzerzuty,"wlasny"),False,False,True,DaneWersje,DaneSlownika,True,True)*DanePrzerzuty.GetVal(iPrzerzuty,"iloscdzien"),2)
                                                    wart2=rsglobal.RSRound(PodajCeneWartosc(str(DanePrzerzuty.GetVal(iPrzerzuty,"artykul_id")),DanePrzerzuty.GetVal(iPrzerzuty,"wlasny"),False,False,False,DaneWersje,DaneSlownika,True,True)*DanePrzerzuty.GetVal(iPrzerzuty,"iloscnoc"),2)
                                                    if float(wart1)<>0 or float(wart2)<>0:
                                                        OK=True
                                                        wiersz=[]
                                                        wiersz.append(str(DanePrzerzuty.GetVal(iPrzerzuty,"artykul_id")).strip()+' - '+str(DanePrzerzuty.GetVal(iPrzerzuty,"artykul_opis")).strip())
                                                        wiersz.append(DanePrzerzuty.GetVal(iPrzerzuty,"jm"))
                                                        wiersz.append(u'-')
                                                        wiersz.append(u'-')
                                                        wiersz.append(DanePrzerzuty.GetVal(iPrzerzuty,"iloscdzien"))
                                                        wiersz.append(PodajCeneWartosc(str(DanePrzerzuty.GetVal(iPrzerzuty,"artykul_id")),DanePrzerzuty.GetVal(iPrzerzuty,"wlasny"),False,False,True,DaneWersje,DaneSlownika,True,True))
                                                        wiersz.append(wart1)
                                                        wiersz.append(DanePrzerzuty.GetVal(iPrzerzuty,"iloscnoc"))
                                                        wiersz.append(PodajCeneWartosc(str(DanePrzerzuty.GetVal(iPrzerzuty,"artykul_id")),DanePrzerzuty.GetVal(iPrzerzuty,"wlasny"),False,False,False,DaneWersje,DaneSlownika,True,True))
                                                        wiersz.append(wart2)
                                                        DANE.append(wiersz)
                                                        WartoscDz+=wart1
                                                        WartoscNoc+=wart2
                                                    iPrzerzuty=iPrzerzuty+1
                                                    if iPrzerzuty>liczbaPrzerzuty:
                                                        break
                                                if OK:
                                                    w = PodsumowanieTabeli(WartoscDz,WartoscNoc)
                                                    RysowanieTabeli(pdf,DANE,rs_print_util,w)
        if Drukowac:
            if pdf.Tresc<>[]:
                #rsglobal.ZapiszDoLogow('pdf.Tresc'+str(pdf.Tresc), 1)
                #AB 13.07.22r dodana zwrotka przez stat
                stat = pdf.WykonajPDFGeneratora()
                if stat=='OK':
                    #WS 2021-11-03
                    try:
                        with open(Plik, 'rb') as p:
                            dane = [binascii.hexlify(buffer(p.read()))]
                    except:
                        import traceback
                        stat = 'Bd odczytu pliku: '+traceback.format_exc()
                    # dane = [binascii.hexlify(buffer(open(Plik, 'rb').read()))]
                else:
                    stat = "Wystpi problem podczas generowania pliku w formacie PDF"
            else:
                dane=[]
            os.remove(Plik)