# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_artykuly
# Purpose:     przetwarza dane operacji na artykulach z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2011/09/15
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = "OK"
dane = []

kodOperacji = klucze[-1]
artykul_id = klucze[0]

#======================================================================

def wyslijWiadomosc(self, temat, tresc):
    adresat = STANDARD_OPERATOR_ID
    # zapisanie wiadomoci do admina
    stat, wiadomosc_id, none, none = self.PolSQL.Execute(
        "SELECT nextval('rs_wiadomosci_id')", 4)
    rsglobal.ZapiszDoLogow("3b %s" % stat, 5)
    if stat == "OK":
        stat, none, none, none = self.PolSQL.Execute(
            "INSERT INTO rs_wiadomosci (firma_id, wiadomosc_id, operator_id, naglowek, tresc, priorytet, usunieta)"
            " VALUES (%s, %s, %s, %s, %s, 'N', FALSE)", 1,
            (self.firma_id, wiadomosc_id, self.operator_id, rsglobal.Dekoduj(temat), rsglobal.Dekoduj(tresc)))
    rsglobal.ZapiszDoLogow("3c %s" % stat, 5)
    if stat == "OK":
        stat, none, none, none = self.PolSQL.Execute(
            "INSERT INTO rs_wiadomosci_operatorzy (wiadomosc_id, folder_id, operator_id, usunieta, nowa)"
            " VALUES (%s, 0, %s, FALSE, TRUE)", 1,
            (wiadomosc_id, adresat))
    # wykonany jest COMMIT, potem z powodu stat!="OK" bdzie ROLLBACK, ale wiadomo zostanie i tyle
    rsglobal.ZapiszDoLogow("3d %s" % stat, 5)
    return stat

#======================================================================

# zmiana na operacj bez select
if kodOperacji in (1, 3):
    kodOperacji += 1
#rsglobal.ZapiszDoLogow("2 kodOperacji:%s, artykul_id:%s" % (kodOperacji, artykul_id), 5)

# sprawdzenie czy kontrahent wystpuje ju w bazie, zarwno przed wstawianiem jak i zmian
if kodOperacji == 4:
    ok, d, none, none = self.PolSQL.Execute(
        "SELECT artykul_id FROM rs_artykuly WHERE firma_id=%s AND artykul_id=%s", 2,
        (self.firma_id, artykul_id))

    if ok == "OK" and not d:
        # takiego jeszcze nie ma a mamy polecenie modyfikacji (UPDATE)

        # wybierz pierwszy typ_artykulu z odpowiedniej tabeli
        region = None
        stat, d, none, none = self.PolSQL.Execute("SELECT typ FROM rs_typy_artykulow ORDER BY typ LIMIT 1", 2)
        if stat != "OK":
            stat = "BL_SQL-komser-typ_artykulu"
        elif d:
            typ_artykulu = d[0][0]
        else:
            stat = "BL komser BRAK typ_artykulu"

        # wybierz pierwsz jednostk miary z odpowiedniej tabeli
        stat, d, none, none = self.PolSQL.Execute("SELECT kod FROM rs_jednostki_miar WHERE firma_id=%s ORDER BY z_czas LIMIT 1",
                        2, (self.firma_id, ))
        if stat != "OK":
            stat = "BL_SQL-komser-jm"
        elif d:
            jm = d[0][0]
        else:
            stat = "BL komser BRAK JM"

        # wybierz pierwsz kategorie artykuu z odpowiedniej tabeli
        stat, d, none, none = self.PolSQL.Execute("SELECT kod FROM rs_kateg_artykulow WHERE firma_id=%s ORDER BY z_czas LIMIT 1",
                        2, (self.firma_id, ))
        if stat != "OK":
            stat = "BL_SQL-komser-kat_art"
        elif d:
            kategoria = d[0][0]
        else:
            stat = "BL komser BRAK kat_art"

        if stat == "OK":
            stat, dane, none, none = self.WykonajFunkcje("fs_artykuly_dane", [artykul_id, 1],
                ['artykul_id', 'nazwa', 'typ_artykulu', 'kateg_artykulu', 'stawka_vat', 'jm1', 'jm2'],
                [artykul_id, 'ARTYKU %s' % artykul_id, typ_artykulu, kategoria, '23', jm, jm])

        if stat == "OK":
            temat = u"Modyfikacja nieistniejcego artykuu"
            tresc = u"System synchronizacji danych otrzyma polecenie modyfikacji danych artykuu ktry nie wystpuje lokalnie."
            tresc += u"Aby przetworzy to polecenie wstawiam do bazy artyku o symbolu: %s\n" % artykul_id
            tresc += u"\nSystem dziaa, ale prawdopodobnie dane tego artykuu wymagaj uzupenienia."
            rsglobal.ZapiszDoLogow("wiadomosc o wstawieniu modyfikowanego artykulu %s" % artykul_id, 2)
            stat = wyslijWiadomosc(self, temat, tresc)
        

# przekazanie danych do normalnej funkcji serwera
if stat == "OK":
    #rsglobal.ZapiszDoLogow("5", 5)
    # usun escapowanie ktore zaraz i tak zostanie dodane
    for i, w in enumerate(wartosci):
        if isinstance(w, str):
            wartosci[i] = w.replace("\\\'", "\'").replace("\\\\", "\\")
    stat, dane, none, none = self.WykonajFunkcje("fs_artykuly_dane", klucze, pola, wartosci)
    #rsglobal.ZapiszDoLogow("6 %s" % [stat, dane], 5)
