# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_dokumenty_magazynowe.py
# Purpose:     przetwarza dane dokumentu magazynowego otrzymane z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2008/12/05
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2015-11-25 Piotr Witkowski (9424) Dokumenty magazynowe nowy grid (wysyanie Kluczy w sownikach)


def zrobSQL(tabela, dane, podstaw={}):
    pol = []
    wart = []
    for k, v in dane:
        pol.append(k)
        if k in podstaw:
            v = podstaw[k]
        wart.append(rsglobal.Dekoduj(v))
    return "INSERT INTO %s(%s) VALUES(%s)" % (tabela, ",".join(pol), "%s," * (len(wart) - 1) + "%s"), wart

dodatkoweDane = None
stat = "OK"
# nie przekazuj do pozostaych serwerw po wykonaniu
wyn2 = False

CzySlownik = isinstance(klucze, dict)


##====================================
#  Cz ze sownikami - docelowa
##====================================

if CzySlownik:

    kluczeWnaG = eval(str(klucze))
    kluczeGnaW = eval(str(klucze))
    if 'dodatkoweDane' in klucze:
        dodatkoweDane = klucze["dodatkoweDane"]

    ##====================================
    #  ZAMYKANIE DOKUMENTU MAGAZYNOWEGO
    ##====================================
    if klucze['Funkcja'] in (9, 12, 19):

        if not dodatkoweDane:
            stat = "BLAD brak danych"

        if klucze['Funkcja'] == 9:
            klucze['Funkcja'] == 19    # bez pobierania

        # wstawienie do bazy otrzymanego dokumentu magazynowego wraz z pozycjami
        if stat == "OK":
            for typ, pwar in dodatkoweDane:
                if typ == "DOKMAGAZ":
                    query, dane = zrobSQL("rs_dokumenty_magazynowe", pwar,
                        {"stan": "W", "kwota": 0.0, "kwota_wal": 0.0, "kwota_pierw": 0.0, "kwota_pierw_wal": 0.0})
                elif typ == "DMAGPOZ":
                    query, dane = zrobSQL("rs_dokumenty_magazynowe_pozycje", pwar,
                        {"dokument_przych": " "*30})
                else:
                    stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                    break
                stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
                if stat != "OK":
                    break

        # nie commituj po kadym wykonaniu funkcji
        self.zdalne_zlecenie[1] = False

        # scalenie pozycji
        if stat == "OK":
            kluczeGnaW['Funkcja'] = 30
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeGnaW, pola, wartosci)
        # zamkniecie dokumentu magazynowego
        if stat == "OK":
            kluczeWnaG['Funkcja'] = 18
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeWnaG, pola, wartosci)
        if stat == "OK":
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", klucze, pola, wartosci)

    ##====================================
    #  OTWIERANIE DOKUMENTU MAGAZYNOWEGO
    ##====================================
    elif klucze['Funkcja'] in (11, 21):
        # nie commituj po kadym wykonaniu funkcji, eby nie zostawi poowy pracy
        self.zdalne_zlecenie[1] = False
        # bez pobierania danych
        klucze['Funkcja'] = 21

        # fragment kodu wziety z fs_dokumenty_magazynowe
        Mag = klucze['Mag']
        Dok = klucze['Typ']
        Data = klucze['Data']
        Numer = klucze['Numer']

        # otworzenie dokumentu ze stanu Z do W
        if stat == "OK":
            kluczeZnaG = klucze
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeZnaG, pola, wartosci)
        if stat == "OK":
            kluczeGnaW['Funkcja'] = 20
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeGnaW, pola, wartosci)

        # i usunicie    (na razie nie ma do tego funkcji), kod przepisany z klienta
        if stat == "OK":
            query = ("UPDATE rs_paragony_fiskalne"
                    " SET magazyn_id=NULL, dokument_id=NULL, data_dm=NULL, numer_dm=0"
                    " WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data_dm=%s AND numer_dm=%s")
            stat, d, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, Mag, Dok, Data, Numer))
        if stat == "OK":
            query = ("DELETE FROM rs_dokumenty_magazynowe"
                    " WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data=%s AND numer=%s")
            stat, d, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, Mag, Dok, Data, Numer))

        if stat == "OK" and Dok == "RW":
            DokRW = Mag.rstrip() + '/RW/' + Data + '/' + str(Numer)
            query = "UPDATE rs_inwentaryzacja SET dokument_rw=NULL WHERE firma_id=%s AND dokument_rw=%s"
            stat, d, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, DokRW))

    else:
        stat = "BLAD nieprawidlowy kod operacji: %s" % klucze['Funkcja']


##=================================================================
#  Cz z kluczami - stara - do usunicia po penej migracji
##=================================================================

else:

    if klucze[-1] == "dodatkoweDane":
        dodatkoweDane = wartosci.pop()
        klucze.pop()

    # dosowanie argumentow do nowego formatu
    if len(klucze) == 17 and klucze[10] == False and klucze[11] == False:
        klucze.insert(12, False)
    elif len(klucze) == 15 and klucze[8] == '' and type(klucze[9]) == list:
        klucze.insert(10, False)
        klucze.insert(10, False)
        klucze.insert(10, False)

    ##====================================
    #  ZAMYKANIE DOKUMENTU MAGAZYNOWEGO
    ##====================================
    if klucze[-1] in (9, 12, 19):

        if not dodatkoweDane:
            stat = "BLAD brak danych"

        if klucze[-1] == 9:
            klucze[-1] == 19    # bez pobierania

        # wstawienie do bazy otrzymanego dokumentu magazynowego wraz z pozycjami
        if stat == "OK":
            for typ, pwar in dodatkoweDane:
                if typ == "DOKMAGAZ":
                    query, dane = zrobSQL("rs_dokumenty_magazynowe", pwar,
                        {"stan": "W", "kwota": 0.0, "kwota_wal": 0.0, "kwota_pierw": 0.0, "kwota_pierw_wal": 0.0})
                elif typ == "DMAGPOZ":
                    query, dane = zrobSQL("rs_dokumenty_magazynowe_pozycje", pwar,
                        {"dokument_przych": " "*30})
                else:
                    stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                    break
                stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
                if stat != "OK":
                    break

        # nie commituj po kadym wykonaniu funkcji
        self.zdalne_zlecenie[1] = False

        # scalenie pozycji
        if stat == "OK":
            kluczeGnaW = klucze[:-1] + [30]
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeGnaW, pola, wartosci)
        # zamkniecie dokumentu magazynowego
        if stat == "OK":
            kluczeWnaG = klucze[:-1] + [18]
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeWnaG, pola, wartosci)
        if stat == "OK":
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", klucze, pola, wartosci)

    ##====================================
    #  OTWIERANIE DOKUMENTU MAGAZYNOWEGO
    ##====================================
    elif klucze[-1] in (11, 21):
        # nie commituj po kadym wykonaniu funkcji, eby nie zostawi poowy pracy
        self.zdalne_zlecenie[1] = False
        # bez pobierania danych
        klucze[-1] = 21

        # fragment kodu wziety z fs_dokumenty_magazynowe
        if len(klucze)==15:
            NiezamknieteF = False
            NiewyslaneTowF = False

            Mag = rsglobal.Dekoduj(klucze[10])
            Dok = rsglobal.Dekoduj(klucze[11])
            Data = rsglobal.Dekoduj(klucze[12])
            Numer = str(klucze[13])
        else:
            NiezamknieteF = klucze[11]
            NiewyslaneTowF=klucze[12]

            Mag = rsglobal.Dekoduj(klucze[15])
            Dok = rsglobal.Dekoduj(klucze[16])
            Data = rsglobal.Dekoduj(klucze[17])
            Numer = str(klucze[18])

        # otworzenie dokumentu ze stanu Z do W
        if stat == "OK":
            kluczeZnaG = klucze
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeZnaG, pola, wartosci)
        if stat == "OK":
            kluczeGnaW = klucze[:-1] + [20]
            stat, dane, none, none = self.WykonajFunkcje("fs_dokumenty_magazynowe", kluczeGnaW, pola, wartosci)

        # i usunicie    (na razie nie ma do tego funkcji), kod przepisany z klienta
        if stat == "OK":
            query = ("UPDATE rs_paragony_fiskalne"
                    " SET magazyn_id=NULL, dokument_id=NULL, data_dm=NULL, numer_dm=0"
                    " WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data_dm=%s AND numer_dm=%s")
            stat, d, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, Mag, Dok, Data, Numer))
        if stat == "OK":
            query = ("DELETE FROM rs_dokumenty_magazynowe"
                    " WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data=%s AND numer=%s")
            stat, d, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, Mag, Dok, Data, Numer))

        if stat == "OK" and Dok == "RW":
            DokRW = Mag.rstrip() + '/RW/' + Data + '/' + str(Numer)
            query = "UPDATE rs_inwentaryzacja SET dokument_rw=NULL WHERE firma_id=%s AND dokument_rw=%s"
            stat, d, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, DokRW))

    else:
        stat = "BLAD nieprawidlowy kod operacji: %s" % klucze[-1]
