# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_faktury.py
# Purpose:     przetwarza dane faktury otrzymane z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2008/12/05
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


def zrobSQL(tabela, dane, podstaw={}, wybrane=None, zapisuj=None):
    pol = []
    wart = []
    if wybrane and len(zapisuj) < len(wybrane):
        zapisuj.extend([None] * (len(wybrane) - len(zapisuj)))
    for k, v in dane:
        pol.append(k)
        if wybrane and k in wybrane:
            zapisuj[wybrane.index(k)] = rsglobal.Dekoduj(v)
        if k in podstaw:
            v = podstaw[k]
        wart.append(rsglobal.Dekoduj(v))
    return "INSERT INTO %s(%s) VALUES(%s)" % (tabela, ",".join(pol), "%s," * (len(wart) - 1) + "%s"), wart

dodatkoweDane = None
stat = "OK"
# tutaj zapisywany jako wyznacznik_id, data, numer, firma_id
kluczFaktury = []
# nie przekazuj do pozostaych serwerw po wykonaniu
wyn2 = False

CzySlownik = isinstance(klucze, dict)

if CzySlownik:
    if 'dodatkoweDane' in klucze:
        dodatkoweDane = klucze["dodatkoweDane"]

    if not dodatkoweDane:
        stat = "BLAD brak danych"

    if klucze['Funkcja'] == 7:
        klucze['Funkcja'] == 9
    if klucze['Funkcja'] <> 9:
        stat = "BLAD nieprawidlowy kod operacji: %s" % klucze['Funkcja']

    # wstawienie do bazy otrzymanej faktury wraz z pozycjami
    if stat == "OK":
        for typ, pwar in dodatkoweDane:
            if typ == "FAKTURA":
                podstaw = {"upust_wartosc": 0, "upust_wartosc_wal": 0}
                query, dane = zrobSQL("rs_faktury", pwar, podstaw, ['wyznacznik_id', 'data', 'numer', 'firma_id'], kluczFaktury)
            elif typ == "POZYCJA":
                query, dane = zrobSQL("rs_faktury_pozycje", pwar)
            elif typ == "POZ_OPI":
                query, dane = zrobSQL("rs_faktury_pozycje_opisowe", pwar)
            elif typ == "PARAGON":
                assert kluczFaktury
                # dane(znaczy klucz) faktury mam juz zapisane bo jej naglowek musial wystapic wczesniej
                # w pliku sa zapisane pary (pole, wartosc), wybieram, obrabiam itp zeby otrzymac zapytanie
                query = ("UPDATE rs_paragony_fiskalne SET wyznacznik_id=%s, f_data=%s, f_numer=%s"
                         " WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s")
                dane = kluczFaktury + [rsglobal.Dekoduj(x[1]) for x in pwar]
            else:
                stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                break
            stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
            if stat != "OK":
                break

    # zamkniecie faktury
    if stat == "OK":
        stat, dane, none, none = self.WykonajFunkcje("fs_faktury", klucze, pola, wartosci)

else:
    if klucze[-1] != "dodatkoweDane":
        stat = "BL Brak dodatkowych danych"
    else:
        dodatkoweDane = wartosci.pop()
        klucze.pop()

    if not dodatkoweDane:
        stat = "BLAD brak danych"

    if klucze[-1] == 7:
        klucze[-1] == 9
    if klucze[-1] != 9:
        stat = "BLAD nieprawidlowy kod operacji: %s" % klucze[-1]

    # wstawienie do bazy otrzymanej faktury wraz z pozycjami
    if stat == "OK":
        for typ, pwar in dodatkoweDane:
            if typ == "FAKTURA":
                podstaw = {"upust_wartosc": 0, "upust_wartosc_wal": 0}
                query, dane = zrobSQL("rs_faktury", pwar, podstaw, ['wyznacznik_id', 'data', 'numer', 'firma_id'], kluczFaktury)
            elif typ == "POZYCJA":
                query, dane = zrobSQL("rs_faktury_pozycje", pwar)
            elif typ == "POZ_OPI":
                query, dane = zrobSQL("rs_faktury_pozycje_opisowe", pwar)
            elif typ == "PARAGON":
                assert kluczFaktury
                # dane(znaczy klucz) faktury mam juz zapisane bo jej naglowek musial wystapic wczesniej
                # w pliku sa zapisane pary (pole, wartosc), wybieram, obrabiam itp zeby otrzymac zapytanie
                query = ("UPDATE rs_paragony_fiskalne SET wyznacznik_id=%s, f_data=%s, f_numer=%s"
                         " WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s")
                dane = kluczFaktury + [rsglobal.Dekoduj(x[1]) for x in pwar]
            else:
                stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                break
            stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
            if stat != "OK":
                break

    # zamkniecie faktury
    if stat == "OK":
        stat, dane, none, none = self.WykonajFunkcje("fs_faktury", klucze, pola, wartosci)
