# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_kontrahenci
# Purpose:     przekazuje dane operacji na kontrahencie z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2008/12/01
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = "OK"
dane = []
#rsglobal.ZapiszDoLogow("1", 5)

kodOperacji = klucze[-1]
kontrahent_id = klucze[0]

#======================================================================

def wyslijWiadomosc(self, temat, tresc):
    adresat = STANDARD_OPERATOR_ID
    # zapisanie wiadomoci do admina
    stat, wiadomosc_id, none, none = self.PolSQL.Execute(
        "SELECT nextval('rs_wiadomosci_id')", 4)
    rsglobal.ZapiszDoLogow("3b %s" % stat, 5)
    if stat == "OK":
        stat, none, none, none = self.PolSQL.Execute(
            "INSERT INTO rs_wiadomosci (firma_id, wiadomosc_id, operator_id, naglowek, tresc, priorytet, usunieta)"
            " VALUES (%s, %s, %s, %s, %s, 'N', FALSE)", 1,
            (self.firma_id, wiadomosc_id, self.operator_id, rsglobal.Dekoduj(temat), rsglobal.Dekoduj(tresc)))
    rsglobal.ZapiszDoLogow("3c %s" % stat, 5)
    if stat == "OK":
        stat, none, none, none = self.PolSQL.Execute(
            "INSERT INTO rs_wiadomosci_operatorzy (wiadomosc_id, folder_id, operator_id, usunieta, nowa)"
            " VALUES (%s, 0, %s, FALSE, TRUE)", 1,
            (wiadomosc_id, adresat))
    # wykonany jest COMMIT, potem z powodu stat!="OK" bdzie ROLLBACK, ale wiadomo zostanie i tyle
    rsglobal.ZapiszDoLogow("3d %s" % stat, 5)
    return stat

#======================================================================

# zmiana na operacj bez select
if kodOperacji in (1, 3):
    kodOperacji += 1
#rsglobal.ZapiszDoLogow("2 %s" % kodOperacji, 5)

# sprawdzenie czy kontrahent wystpuje ju w bazie, zarwno przed wstawianiem jak i zmian
if kodOperacji in (2, 4):
    ok, d, none, none = self.PolSQL.Execute(
        "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=%s AND kontrahent_id=%s", 2,
        (self.firma_id, kontrahent_id))

    #rsglobal.ZapiszDoLogow("3 %s" % [ok, d], 5)
    if ok == "OK" and d and kodOperacji == 2:
        # taki ju istnieje a mamy polecenie wstawienia (INSERT)
        temat = u"Konflikt symboli kontrahentw"
        tresc = u"W zdalnym oddziale dodano kontrahenta o symbolu ktry jest ju uywany: %s\n" % kontrahent_id
        tresc += u"Dalsze przetwarzanie danych z tego oddziau wymana rozwizania konfliktu."
        #rsglobal.ZapiszDoLogow("3a", 5)
        stat = wyslijWiadomosc(self, temat, tresc)
        if stat == "OK":
            stat = "BL_SYMBOL1"             # wysanie si powiodo, ale zgo bd konfliktu symboli
        else:
            stat += "+W"                    # bd przy wysyaniu, a dodatkowo oznacz gdzie to si stao
        #rsglobal.ZapiszDoLogow("4 %s" % [ok, stat], 5)

    elif ok == "OK" and not d and kodOperacji == 4:
        # takiego jeszcze nie ma a mamy polecenie modyfikacji (UPDATE)

        # wybierz jakis region dla tego kontrahenta
        region = None
        stat, d, none, none = self.PolSQL.Execute("SELECT region, COUNT(region) FROM rs_kontrahenci WHERE firma_id=%s" +
            " GROUP BY region ORDER BY COUNT(region) DESC, region", 2, (self.firma_id,))
        if stat == "OK" and not d:
            stat, d, none, none = self.PolSQL.Execute("SELECT MIN(kod) FROM rs_regiony")
        if stat != "OK":
            stat = "BL_SQL-komser-region"
        elif d:
            region = d[0][0]
        else:
            stat = "BL komser BRAK REGION"

        # wybierz kategorie kontrahenta odpowiednia w tym oddziale
        stat, d, none, none = self.PolSQL.Execute("SELECT kod FROM rs_kateg_kontrahentow WHERE firma_id=%s AND kod<>'' ORDER BY kod LIMIT 1",
                        2, (self.firma_id, ))
        if stat != "OK":
            stat = "BL_SQL-komser-kat_kont"
        elif d:
            kateg_kontrahenta = d[0][0]
        else:
            stat = "BL komser BRAK KAT_KONT"

        if stat == "OK":
            stat, dane, none, none = self.WykonajFunkcje("fs_kontrahenci_dane", [kontrahent_id, 1],
                ['kontrahent_id', 'nazwa', 'kateg_kontrahenta', 'region', 'odbiorca'],
                [kontrahent_id, 'KONTRAHENT %s' % kontrahent_id, kateg_kontrahenta, region, True])

        if stat == "OK":
            temat = u"Modyfikacja nieistniejcego kontrahenta"
            tresc = u"System synchronizacji danych otrzyma polecenie modyfikacji danych kontrahenta ktry nie wystpuje lokalnie."
            tresc += u"Aby przetworzy to polecenie wstawiam do bazy kontrahenta o symbolu: %s\n" % kontrahent_id
            tresc += u"\nSystem dziaa, ale prawdopodobnie dane tego kontrahenta wymagaj uzupenienia."
            rsglobal.ZapiszDoLogow("wiadomosc o wstawieniu modyfikowanego kontrahenta %s" % kontrahent_id, 2)
            stat = wyslijWiadomosc(self, temat, tresc)
        

#--- podmiana danych przed wstawieniem nowego
if kodOperacji == 2:
    if stat == "OK":
        # zawsze zamieniamy kategorie kontrahenta na lokaln
        if "kateg_kontrahenta" in pola:
            kk_idx = pola.index("kateg_kontrahenta")
        else:
            kk_idx = len(pola)
            pola.append("kateg_kontrahenta")
            wartosci.append(None)

        st, d, none, none = self.PolSQL.Execute("SELECT kod FROM rs_kateg_kontrahentow WHERE firma_id=%s AND kod<>'' ORDER BY kod LIMIT 1",
                        2, (self.firma_id, ))
        if st != "OK":
            stat = "BL_SQL-komser-kat_kont"
        elif d:
            wartosci[kk_idx] = d[0][0]
        else:
            stat = "BL komser BRAK KAT_KONT"

        # dane z kategorii s przepisywane ju w fs_kontrahenci_dane

#---  update wpisu kontrahenta
elif kodOperacji == 4:
    
    if "kateg_kontrahenta" in pola:
        # wyrzucenie zmiany kategorii
        kk_idx = pola.index("kateg_kontrahenta")
        pola.pop(kk_idx)
        wartosci.pop(kk_idx)
        if not pola:
            rsglobal.ZapiszDoLogow("puste pola", 5)
            klucze = []

# przekazanie danych do normalnej funkcji serwera
if stat == "OK" and klucze:
    #rsglobal.ZapiszDoLogow("5", 5)
    # usun escapowanie ktore zaraz i tak zostanie dodane
    for i, w in enumerate(wartosci):
        if isinstance(w, str):
            wartosci[i] = w.replace("\\\'", "\'").replace("\\\\", "\\")
    stat, dane, none, none = self.WykonajFunkcje("fs_kontrahenci_dane", klucze, pola, wartosci)
    #rsglobal.ZapiszDoLogow("6 %s" % [stat, dane], 5)
