# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_korekty.py
# Purpose:     przetwarza dane korekty otrzymane z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2008/12/15
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


def zrobSQL(tabela, dane, podstaw={}):
    pol = []
    wart = []
    for k, v in dane:
        pol.append(k)
        if k in podstaw:
            v = podstaw[k]
        wart.append(rsglobal.Dekoduj(v))
    return "INSERT INTO %s(%s) VALUES(%s)" % (tabela, ",".join(pol), "%s," * (len(wart) - 1) + "%s"), wart

dodatkoweDane = None
stat = "OK"
# nie przekazuj do pozostaych serwerw po wykonaniu
wyn2 = False

if klucze[-1] != "dodatkoweDane":
    stat = "BL Brak dodatkowych danych"
else:
    dodatkoweDane = wartosci.pop()
    klucze.pop()

if not dodatkoweDane:
    stat = "BLAD brak danych"

if klucze[-1] == 7:
    klucze[-1] = 9
if klucze[-1] != 9:
    stat = "BLAD nieprawidlowy kod operacji: %s" % klucze[-1]

# wstawienie do bazy otrzymanej korekty wraz z pozycjami
if stat == "OK":
    for typ, pwar in dodatkoweDane:
        if typ == "KOREKTA":
            query, dane = zrobSQL("rs_korekty", pwar)
        elif typ == "POZYCJA":
            query, dane = zrobSQL("rs_korekty_pozycje", pwar)
        elif typ == "POZ_OPI":
            query, dane = zrobSQL("rs_korekty_pozycje_opisowe", pwar)
        elif typ == "STAWKA":
            query, dane = zrobSQL("rs_korekty_vat", pwar)
        else:
            stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
            break
        stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
        if stat != "OK":
            break

# zamkniecie faktury
if stat == "OK":
    stat, dane, none, none = self.WykonajFunkcje("fs_korekty", klucze, pola, wartosci)
