# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_paragony_fiskalne.py
# Purpose:     przetwarza dane paragonu fiskalnego otrzymane z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2008/12/05
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


def zrobSQL(tabela, dane, podstaw={}):
    pol = []
    wart = []
    for k, v in dane:
        pol.append(k)
        if k in podstaw:
            v = podstaw[k]
        wart.append(rsglobal.Dekoduj(v))
    return "INSERT INTO %s(%s) VALUES(%s)" % (tabela, ",".join(pol), "%s," * (len(wart) - 1) + "%s"), wart

dodatkoweDane = None
stat = "OK"
# nie przekazuj dalej, do pozostaych serwerw
wyn2 = False

CzySlownik = isinstance(klucze, dict)

if CzySlownik:
    if 'dodatkoweDane' in klucze:
        dodatkoweDane = klucze["dodatkoweDane"]

    if not dodatkoweDane:
        stat = "BLAD brak danych"

    # wstawienie do bazy otrzymanego paragonu wraz z pozycjami
    if stat == "OK":
        for typ, pwar in dodatkoweDane:
            if typ == "PARAGON":
                query, dane = zrobSQL("rs_paragony_fiskalne", pwar, {"do_zaplaty": 0.0})
            elif typ == "POZYCJA":
                query, dane = zrobSQL("rs_paragony_fiskalne_pozycje", pwar)
            elif typ == "DOKMAGAZ":
                continue
            elif typ == "DMAGPOZ":
                continue
            else:
                stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                break
            stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
            if stat != "OK":
                break


##=================================================================
#  Cz z kluczami - stara - do usunicia po penej migracji
##=================================================================

else:
    if klucze[-1] != "dodatkoweDane":
        stat = "BL Brak dodatkowych danych"
    else:
        dodatkoweDane = wartosci.pop()
        klucze.pop()

    if not dodatkoweDane:
        stat = "BLAD brak danych"

    # wstawienie do bazy otrzymanego paragonu wraz z pozycjami
    if stat == "OK":
        for typ, pwar in dodatkoweDane:
            if typ == "PARAGON":
                query, dane = zrobSQL("rs_paragony_fiskalne", pwar, {"do_zaplaty": 0.0})
            elif typ == "POZYCJA":
                query, dane = zrobSQL("rs_paragony_fiskalne_pozycje", pwar)
            elif typ == "DOKMAGAZ":
                continue
            elif typ == "DMAGPOZ":
                continue
            else:
                stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                break
            stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
            if stat != "OK":
                break
