# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_raporty_wyciagi.py
# Purpose:     przetwarza dane "raporty wycigi" otrzymane z innego serwera
#
# Author:      Piotr Szydeko
# Created:     2009/01/02
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


def zrobSQL(tabela, dane, podstaw={}):
    pol = []
    wart = []
    for k, v in dane:
        pol.append(k)
        if tabela == 'rs_raporty_wyciagi_pozycje' and k == 'platnosc_id' and v == 0:
            v = None
        elif k in podstaw:
            v = podstaw[k]
        wart.append(rsglobal.Dekoduj(v))
    return "INSERT INTO %s(%s) VALUES(%s)" % (tabela, ",".join(pol), "%s," * (len(wart) - 1) + "%s"), wart

dodatkoweDane = None
stat = "OK"
# nie przekazuj do pozostaych serwerw po wykonaniu
wyn2 = False

CzySlownik = isinstance(klucze, dict)

if CzySlownik:
    if 'dodatkoweDane' in klucze:
        dodatkoweDane = klucze["dodatkoweDane"]

    if not dodatkoweDane:
        stat = "BLAD brak danych"

    if klucze['Funkcja'] != 12:
        stat = "BLAD nieprawidlowy kod operacji: %s" % klucze['Funkcja']

    # wstawienie do bazy otrzymanego raportu/wycigu wraz z pozycjami
    if stat == "OK":
        for typ, pwar in dodatkoweDane:
            if typ == "RAP_WYC":
                zerowanie = {"stan": "W", "wplaty": 0, "wyplaty": 0, "saldo_konc": 0}
                query = "SELECT okres_id FROM rs_raporty_wyciagi WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND data<=%s LIMIT 1"
                dane_rapwyc = dict(pwar)
                stat, d, none, none = self.PolSQL.Execute(query, 2,
                    [rsglobal.Dekoduj(dane_rapwyc["firma_id"]), rsglobal.Dekoduj(dane_rapwyc["okres_id"]),
                     rsglobal.Dekoduj(dane_rapwyc["kasa_bank_id"]), rsglobal.Dekoduj(dane_rapwyc["data"])])
                if stat <> "OK":
                    stat = "BL SQL spr ist wczesniejszych wyciagow"
                    break
                elif not d:
                    zerowanie["saldo_pocz"] = 0

                query, dane = zrobSQL("rs_raporty_wyciagi", pwar, zerowanie)
            elif typ == "RWYCPOZ":
                query, dane = zrobSQL("rs_raporty_wyciagi_pozycje", pwar)
            else:
                stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                break
            stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
            if stat != "OK":
                break

        # zamkniecie raportu/wycigu
        if stat == "OK":
            stat, dane, none, none = self.WykonajFunkcje("fs_raporty_wyciagi", klucze, pola, wartosci)

else:
    if klucze[-1] != "dodatkoweDane":
        stat = "BL Brak dodatkowych danych"
    else:
        dodatkoweDane = wartosci.pop()
        klucze.pop()

    if not dodatkoweDane:
        stat = "BLAD brak danych"

    if klucze[-1] != 12:
        stat = "BLAD nieprawidlowy kod operacji: %s" % klucze[-1]

    # wstawienie do bazy otrzymanego raportu/wycigu wraz z pozycjami
    if stat == "OK":
        for typ, pwar in dodatkoweDane:
            if typ == "RAP_WYC":
                zerowanie = {"stan": "W", "wplaty": 0, "wyplaty": 0, "saldo_konc": 0}
                query = "SELECT okres_id FROM rs_raporty_wyciagi WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND data<=%s LIMIT 1"
                dane_rapwyc = dict(pwar)
                stat, d, none, none = self.PolSQL.Execute(query, 2,
                    [rsglobal.Dekoduj(dane_rapwyc["firma_id"]), rsglobal.Dekoduj(dane_rapwyc["okres_id"]),
                     rsglobal.Dekoduj(dane_rapwyc["kasa_bank_id"]), rsglobal.Dekoduj(dane_rapwyc["data"])])
                if stat <> "OK":
                    stat = "BL SQL spr ist wczesniejszych wyciagow"
                    break
                elif not d:
                    zerowanie["saldo_pocz"] = 0

                query, dane = zrobSQL("rs_raporty_wyciagi", pwar, zerowanie)
            elif typ == "RWYCPOZ":
                query, dane = zrobSQL("rs_raporty_wyciagi_pozycje", pwar)
            else:
                stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
                break
            stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
            if stat != "OK":
                break

        # zamkniecie raportu/wycigu
        if stat == "OK":
            stat, dane, none, none = self.WykonajFunkcje("fs_raporty_wyciagi", klucze, pola, wartosci)
