# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_list.py
# Purpose:      
# Author:      Jarek Plawgo
# Created:     2006/08/10
# RCS-ID:      $Id: fs_kontrahenci_list.py $
# Copyright:   (c) 2006 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-01-14 Wojciech Skowron   - pobranie liczby kontrahentow tylko aktywnych
# 2021-02-04 Wojciech Skowron   - pobranie nazw kolumn tabeli rs_kontrahenci_archiwum_dane_adresowe
# 2023-07-20 Aleksander Bargie - Kontrahenci w Handlu nie otworz si bez uprawnie do Kontrahentw w danych podstawowych 

from funkcje import fs_sprawdz_analityke

#WS 2021-02-04
if isinstance(klucze, list):
    Funkcja = klucze[-1]
else:
    Funkcja = klucze['Funkcja']
# UpdateInsertSelect=klucze[-1]

stat = "OK"
dane = []
UprAdmin=(self.operator_id == STANDARD_OPERATOR_ID)
UprList = (self.oddzial_id,'012000') in self.uprawnienia or (self.oddzial_id,'092200') in self.uprawnienia
UprUsuwanie=(self.oddzial_id,'012014') in self.uprawnienia


def AddFiltr(nazwa,pole):
    if pole != '':
        filtr=" AND upper(%s) LIKE upper('%s%s')"%(str(nazwa),str(pole),"%")
    else:
        return ""    
    return filtr

if (Funkcja==1):
    if UprList or UprAdmin:
        Symbol=klucze[0]
        Nazwa=klucze[1]
        NIP=klucze[2]
        Kategoria=klucze[3]
        Aktywny=klucze[4]
        
        Region=klucze[5]
        KodPocztowy=klucze[6]
        Miejscowosc=klucze[7]
        Ulica=klucze[8]
        Telefon=klucze[9]
        
        Platnik=klucze[10]
        PlatnikNazwa=klucze[11]
        Gln=klucze[12]
        SymbolObcy=klucze[13]
        
        klucze_id=klucze[14]


#pobranie klucza wynikaj\u0105cego z numer\xf3w nowych kluczy

            
        SELECT = "SELECT k.kontrahent_id,k.nazwa,k.nip,k.tel1,k.adr_kod,k.adr_miej,k.adr_ulica||' '||k.adr_nry,k.region,k.kateg_kontrahenta FROM rs_kontrahenci k"
        if PlatnikNazwa<>'':
            SELECT += " INNER JOIN rs_kontrahenci kp ON (kp.firma_id=k.firma_id AND kp.kontrahent_id=k.platnik_id)"
        SELECT += " WHERE k.firma_id='"+self.firma_id+"'"

        if Symbol != '':
            SELECT += " AND upper(k.kontrahent_id) LIKE upper('"+Symbol+"%')"
        if Nazwa != '':
            SELECT += " AND upper(k.nazwa) LIKE upper('"+Nazwa+"%')"
        if Ulica != '':
            SELECT += " AND upper(k.adr_ulica) LIKE upper('"+Ulica+"%')"
        if NIP != '':
            SELECT += " AND upper(k.nip) LIKE upper('"+NIP+"%')"
        if Telefon != '':
            SELECT += " AND upper(k.tel1) LIKE upper('"+Telefon+"%')"
        if KodPocztowy != '':
            SELECT += " AND upper(k.adr_kod) LIKE upper('"+KodPocztowy+"%')"
        if Miejscowosc != '':
            SELECT += " AND upper(k.adr_miej) LIKE upper('"+Miejscowosc+"%')"
        if Region != '':
            SELECT += " AND upper(k.region) LIKE upper('"+Region+"%')"
        if Kategoria != '':
            SELECT += " AND upper(k.kateg_kontrahenta) LIKE upper('"+Kategoria+"%')"
        if Platnik != '':
            SELECT += " AND upper(k.platnik_id) LIKE upper('"+Platnik+"%')"
        if Gln != '':
            SELECT += " AND upper(k.gln) LIKE upper('"+Gln+"%') AND k.gln IS NOT NULL AND trim(k.gln) <>'' "
        if SymbolObcy != '':
            SELECT += " AND upper(k.symbol_obcy) LIKE upper('"+SymbolObcy+"%') AND k.symbol_obcy IS NOT NULL AND trim(k.symbol_obcy) <>''"
        if PlatnikNazwa<>'':
            SELECT+=" AND upper(kp.nazwa) LIKE upper('"+PlatnikNazwa+"%')"
        if Aktywny:
            SELECT+=' AND k.aktywny'

        if klucze_id != []:
            SELECT+=" OR (k.firma_id='"+self.firma_id+"' AND k.kontrahent_id IN ("+",".join(["'%s'"%(str(klucz[0])) for klucz in klucze_id])+"))"

        SELECT+=" ORDER BY k.kontrahent_id;"

        rsglobal.ZapiszDoLogow('AAA '+SELECT,1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SELECT,3)
        if stat!="OK":
            stat="BL_SQL"
            
        # pobranie liczby kontrahentw
        if stat == 'OK':
            #SQL= "SELECT COUNT(*) FROM rs_kontrahenci WHERE firma_id='"+str(self.firma_id)+"';"
            #WS 2019-01-14
            SQL= "SELECT COUNT(*) FROM rs_kontrahenci WHERE firma_id='"+str(self.firma_id)+"' AND COALESCE(aktywny,TRUE);"
            stat,wyn2,dump,dump=self.PolSQL.Execute(SQL,3)
    else:
        stat="BL_UPR"
        dane.append(stat)


elif Funkcja==2: 
    if UprUsuwanie or UprAdmin:
        kontrahent_id = rsglobal.Dekoduj(klucze[0])
        
        stat = fs_sprawdz_analityke.CzyMoznaUsunac(self,'rs_kontrahenci',kontrahent_id,'')
        if stat == 'OK':
            sql ="DELETE FROM rs_kontrahenci"
            sql+=" WHERE kontrahent_id = '"+kontrahent_id+"' AND firma_id = '"+self.firma_id+"';"
            stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
            if stat != 'OK':
                stat = "BR_KAS_KONTRA"
    else:
        stat="BL_UPR"   
        dane.append(stat)

# -------------------------------------------------------------------------------
# --------------   POBRANIE NAZW KOLUMN TABELI ARCHIWUM (10)   ------------------
# -------------------------------------------------------------------------------

#WS 2021-02-04
if stat == 'OK' and Funkcja == 10:
    SEL = """SELECT DISTINCT column_name FROM information_schema.columns 
             WHERE table_name='rs_kontrahenci_archiwum_dane_adresowe' 
                   AND column_name NOT LIKE 'z_%' AND column_name not in ('firma_id', 'kontrahent_id', 'do_dnia');"""
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Wystpi bd podczas pobrania listy pl do archiwizacji: '+stat
    else:
        dane = [wiersz[0] for wiersz in dane]
