# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_artykuly_poziom_zwrotow.py
# Purpose:     obsluga grida edytowalnego okreslajacego poziom dopuszczlne
#              zwroty w ukladzie kontrahent->artykuly lub artykul->kontrahenci
# Author:      mariusz rajfura
# Created:     2010/08/30
# RCS-ID:      $Id: fs_kontrahenci_artykuly_poziom_zwrotow $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-07-07 Mariusz Rajfura - nowe pola: oddzial_id,czestosc_fakturowania,poziom_zwrotow_wartosc (4745)
# 2011-09-28 Mariusz Rajfura - checkboxy zmieniajace zakres filtrowania (5060)
# 2011-12-05 Mariusz Rajfura - literowka w zmiennej klucza (Artykul->ArtykulK) (5264)
# 2012-02-20 Mariusz Rajfura - nowe pole: 'tworzyc_korekty' (5473)
# 2012-03-02 Mariusz Rajfura - popr.UPDATE: byla zapisywana modyfikcja tylko ostatniego zmienionego wiersza (5498)
# 2013-10-09 Mariusz Rajfura (7266) usuniecie sprawdzenia przy dodawaniu: kluczem jest numer_id (sekwencja)
# 2021-01-28 Jan Raburski - liczba dni moe by 1 (12296)



Kontrahent = rsglobal.Dekoduj(klucze[0][0]).strip()
ArtykulK = rsglobal.Dekoduj(klucze[0][1]).strip()
Numer = klucze[0][2]

KontrahentF = rsglobal.Dekoduj(klucze[1][0]).strip()
ArtykulF = rsglobal.Dekoduj(klucze[1][1]).strip()
FunkcjaF = klucze[1][2]
KontrahenciZArtykulemF = klucze[1][3]
NiezeroweZwrotyF = klucze[1][4]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if FunkcjaF == 1:
    #uprawnienia od strony kontrahent->artykuly
    UprIns=((self.oddzial_id,'012123') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    UprUpd=((self.oddzial_id,'012122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
    UprDel=((self.oddzial_id,'012124') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
elif FunkcjaF == 2:
    #uprawnienia od strony artykul->kontrahenci
    UprIns=((self.oddzial_id,'013103') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    UprUpd=((self.oddzial_id,'013102') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
    UprDel=((self.oddzial_id,'013104') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]
    

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT kontrahent_id,artykul_id,numer_id"
                SQLFU+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_kontrahenci_artykuly_poziom_zwrotow "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole == 'numer_id':
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                        
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,dDEL,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
                elif len(dDEL) == 0:
                    stat = 'Bdny zakres danych do usunicia'
                    dane.append(stat)
                    
            if stat == 'OK':
                #Sprawdzenie, czy przypadkiem nie usuwamy danych spoza dozwolonego ukladu
                #tzn. tylko w ukladzie kontrahent->artykuly mozna usunac wiersz z pustym
                #artykulem, ktory oznacza 'wszystkie artykuly dla kontrahenta'
                #Nie mozna tego robic z ukladu artykul->kontrahenci
                #Odwrotnie jest w ukladzie artykul->kontrahenci
                for i in xrange(len(dDEL)):
                    if FunkcjaF == 1:
                        if rsglobal.Dekoduj(dDEL[i][0]).strip() == 'None':
                            stat = 'Nie mona usuwa zapisu nr '+str(dDEL[i][2])+' z tego okna.'
                            dane.append(stat)
                            exit
                    elif FunkcjaF == 2:
                        if rsglobal.Dekoduj(dDEL[i][1]).strip() == 'None':
                            stat = 'Nie mona usuwa zapisu nr '+str(dDEL[i][2])+' z tego okna.'
                            dane.append(stat)
                            exit
                        
            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT TRIM(oddzial_id),TRIM(COALESCE(kontrahent_id,''::TEXT)),"
                SQLFU+=" TRIM(COALESCE(artykul_id,''::TEXT)),numer_id"
                SQLFU+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'numer_id':
                        SQLFU += " AND "+pole+"="+str(wart)
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dUPD,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
                elif len(dUPD) == 0:
                    stat = 'Bdny zakres danych do modyfikacji'
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    
                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart <> '':
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND oddzial_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZIAL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZIAL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                        else:
                            stat = 'BR ODDZIAL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)

                    elif pole == 'czestosc_fakturowania':
                        wart = wart.strip()
                        if wart <> '':
                            sql ="SELECT kod FROM rs_czestosci_fakturowania"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND kod='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL CZESTOSC'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL CZESTOSC'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)

                    elif pole == 'kontrahent_id':
                        wart = wart.strip()
                        if wart <> '':
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KTH'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL KTH'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'artykul_id':
                        if wart.strip() <> '':
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND artykul_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ART'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ART'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'procent_zwrotow':
                        if wart < 0 or wart > 99.9:
                            stat = 'BL PROC_ZWR'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)

                    elif pole == 'liczba_dni':
                        if wart < 1 or wart > 99:
                            stat = 'BL LICZ_DNI'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
        SQLU = ''
        # wykonanie UPDATE
        if stat=='OK':
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_kontrahenci_artykuly_poziom_zwrotow "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id','czestosc_fakturowania','kontrahent_id','artykul_id']:
                        if wart.strip() == '':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+wart+"',"
                            
                    elif pole in ['procent_zwrotow','liczba_dni']:
                        SET+=pole+"="+str(wart)+","

                    elif pole in ['tworzyc_korekty']:
                        if wart:
                            SET+=pole+"=TRUE,"
                        else:
                            SET+=pole+"=FALSE,"

                
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'numer_id':
                        WHERE+=" AND "+pole+"="+str(wart)
                WHERE+=";"    
                
                SQLU+=UPDATE+SET+WHERE;
                
            if SQLU<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQLU),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


        if stat == 'OK' and SQLU <> '':
            # Kontrola unikalnosci po modyfikacji
            # Poniewaz kluczem jest 'numer_id', to sprawdzamy unikalnosc
            # danych dla kontrahenta i artykulu w oddziale.
            # Wiersze modyfikowane posiadamy jako wynik zapytania SELECT FOR UPDATE
            # w tablicy dUPD[]
        
            sql ="SELECT TRIM(oddzial_id),TRIM(COALESCE(kontrahent_id,''::TEXT)),"
            sql+=" TRIM(COALESCE(artykul_id,''::TEXT)),numer_id"
            sql+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
            sql+=" WHERE firma_id='"+self.firma_id+"';"
            stat,dUPD1,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych do sprawdzenia po modyfikacji: '+stat
                dane.append(stat)
            elif len(dUPD1) < len(dUPD):
                stat = 'Braki wrd danych po modyfikacji: '+stat
                dane.append(stat)
            else:
                sPoziomy1 = {}
                for i in xrange(len(dUPD1)):
                    Oddzial = dUPD1[i][0]
                    Kontrah = dUPD1[i][1]
                    Artykul = dUPD1[i][2]
                    NumerId = dUPD1[i][3]
                
                    if not (Oddzial,Kontrah,Artykul) in sPoziomy1:
                        sPoziomy1[(Oddzial,Kontrah,Artykul)] = [NumerId]
                    else:
                        sPoziomy1[(Oddzial,Kontrah,Artykul)].append(NumerId)
                
                # jesli dla ktoregos z kluczy lista zawiera wiecej niz jeden 'numer_id'
                # to oznacza powtorzenie danych
            
                kPoziomy1 = sPoziomy1.keys()
                for k in kPoziomy1:
                    lNumerId = sPoziomy1[k]
                    if len(lNumerId) > 1:
                        # Powtorzony klucz
                        # Szukamy wsrod modyfikowanych kluczy 'numer_id'
                        # i zaznaczamy na gridzie jako blad
                        for n in lNumerId:
                            for i in xrange(len(Update[0])):
                                for j in xrange(len(Update[2][i])): # petla po kluczu
                                    pole = Update[3][j]
                                    wart = rsglobal.Dekoduj(Update[2][i][j])
                                    if pole == 'numer_id':
                                        if wart == n:
                                            stat = 'BL KLUCZ IST'
                                            dane.append(stat)
                                            wyn2.append((WierszeNr[i],0))

                                            
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        



#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                KontrahentNowy = None
                ArtykulNowy = None
                OddzialNowy = None
                
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole == 'oddzial_id':
                            wart = wart.strip()
                            if wart <> '':
                                OddzialNowy = wart
                                sql ="SELECT oddzial_id FROM rs_oddzialy"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND oddzial_id='"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL ODDZIAL'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL ODDZIAL'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                            else:
                                stat = 'BR ODDZIAL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                        elif pole == 'czestosc_fakturowania':
                            wart = wart.strip()
                            if wart <> '':
                                sql ="SELECT kod FROM rs_czestosci_fakturowania"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND kod='"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL CZESTOSC'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL CZESTOSC'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)

                        elif pole == 'kontrahent_id':
                            wart = wart.strip()
                            if wart <> '':
                                KontrahentNowy = wart
                                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL KTH'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL KTH'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)

                        elif pole == 'artykul_id':
                            wart = wart.strip()
                            if wart <> '':
                                ArtykulNowy = wart
                                sql ="SELECT artykul_id FROM rs_artykuly"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND artykul_id='"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL ART'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL ART'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)

                        elif pole == 'procent_zwrotow':
                            if wart < 0 or wart > 99.9:
                                stat = 'BL PROC_ZWR'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)

                        elif pole == 'liczba_dni':
                            if wart < 2 or wart > 99:
                                stat = 'BL LICZ_DNI'
                                wyn2.append((WierszeNr[i],6))
                                dane.append(stat)

                #sprawdzam przed dodawaniem, czy podany klucz juz istnieje,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje

                if len(dane) == 0:
                    if KontrahentNowy == None:
                        KontrahentNowy = ''
                    if ArtykulNowy == None:
                        ArtykulNowy = ''
                    
                    OddzialNowy = rsglobal.Dekoduj(OddzialNowy)
                    KontrahentNowy = rsglobal.Dekoduj(KontrahentNowy)
                    ArtykulNowy = rsglobal.Dekoduj(ArtykulNowy)
                    
                    sql ="SELECT numer_id FROM rs_kontrahenci_artykuly_poziom_zwrotow"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+OddzialNowy+"'"

                    if FunkcjaF == 1:
                        sql+=" AND kontrahent_id='"+Kontrahent+"'"
                        if ArtykulNowy == '':
                            sql+=" AND artykul_id IS NULL;"
                        else:
                            sql+=" AND artykul_id='"+ArtykulNowy+"';"
                            
                    elif FunkcjaF == 2:
                        sql+=" AND artykul_id='"+ArtykulK+"'"
                        if KontrahentNowy == '':
                            sql+=" AND kontrahent_id IS NULL;"
                        else:
                            sql+=" AND kontrahent_id='"+KontrahentNowy+"';"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))


##                    elif len(d) > 0:
##                        stat = 'BL KLUCZ IST'
##                        dane.append(stat)
##                        wyn2.append((WierszeNr[i],0))

                                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kontrahenci_artykuly_poziom_zwrotow "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                
                if FunkcjaF == 1:
                    KOLUMNY+=",kontrahent_id"
                    VALUES+=",'"+Kontrahent+"'"
                elif FunkcjaF == 2:
                    KOLUMNY+=",artykul_id"
                    VALUES+=",'"+ArtykulK+"'"

                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole in ['kontrahent_id','artykul_id']:
                        if FunkcjaF == 1 and pole == 'artykul_id' or \
                           FunkcjaF == 2 and pole == 'kontrahent_id':
                            KOLUMNY+=","+pole
                            if wart.strip() == '':
                                VALUES+=",NULL"
                            else:
                                VALUES+=",'"+wart+"'"

                    elif pole == 'oddzial_id':
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"

                    elif pole == 'czestosc_fakturowania':
                        KOLUMNY+=","+pole
                        wart = wart.strip()
                        if wart == '':
                            VALUES+=",NULL"
                        else:
                            VALUES+=",'"+str(wart)+"'"
                        
                    elif pole in ['procent_zwrotow','liczba_dni']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)                        

                    elif pole in ['tworzyc_korekty']:
                        KOLUMNY+=","+pole
                        if wart:
                            VALUES+=",TRUE"
                        else:
                            VALUES+=",FALSE"

                        
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
                
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat=='OK':
    if FunkcjaF == 1:
        #uklad kontrahent->artykuly
        
        SQL ="SELECT"
        SQL+=" COALESCE(pz.oddzial_id,''::TEXT),COALESCE(pz.czestosc_fakturowania,''::TEXT),"
        SQL+=" COALESCE(pz.kontrahent_id,''::TEXT),"
        SQL+=" COALESCE(pz.artykul_id,''::TEXT),COALESCE(a.nazwa,''::TEXT),"
        SQL+=" pz.procent_zwrotow,pz.liczba_dni,pz.procent_zwrotow_wartosc,pz.tworzyc_korekty,pz.numer_id"
        
        SQL+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow pz"
        SQL+=" LEFT JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE pz.firma_id='"+self.firma_id+"'"
        SQL+=" AND (pz.kontrahent_id='"+Kontrahent+"' OR pz.kontrahent_id IS NULL)"
        if ArtykulF <> '':
            SQL+=" AND pz.artykul_id LIKE '"+ArtykulF+"%'"
        SQL+=" ORDER BY COALESCE(pz.oddzial_id,''::TEXT),"
        SQL+=" COALESCE(pz.kontrahent_id,''::TEXT),COALESCE(artykul_id,''::TEXT);"
        
    elif FunkcjaF == 2:
        #uklad artykul->kontrahenci
        SQL ="SELECT"
        SQL+=" COALESCE(pz.oddzial_id,''::TEXT),COALESCE(pz.czestosc_fakturowania,''::TEXT),"
        SQL+=" COALESCE(pz.artykul_id,''::TEXT),"
        SQL+=" COALESCE(pz.kontrahent_id,''::TEXT),COALESCE(k.nazwa,''::TEXT),"
        SQL+=" pz.procent_zwrotow,pz.liczba_dni,pz.procent_zwrotow_wartosc,pz.tworzyc_korekty,pz.numer_id"
        
        SQL+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow pz"
        SQL+=" LEFT JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
        SQL+=" WHERE pz.firma_id='"+self.firma_id+"'"
        
        SQL+=" AND (pz.artykul_id='"+ArtykulK+"'"
        if not KontrahenciZArtykulemF:
            SQL+=" OR pz.artykul_id IS NULL"
        SQL+=")"

        if NiezeroweZwrotyF:
            SQL+=" AND pz.procent_zwrotow<>0"
        
        if KontrahentF <> '':
            SQL+=" AND pz.kontrahent_id LIKE '"+KontrahentF+"%'"
        SQL+=" ORDER BY COALESCE(pz.oddzial_id,''::TEXT),"
        SQL+=" COALESCE(pz.artykul_id,''::TEXT),COALESCE(pz.kontrahent_id,''::TEXT);"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)