# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_dane.py
# Purpose:      
# Author:      Jarek Plawgo
# Created:     2006/07/25
# RCS-ID:      $Id: fs_kontrahenci_dane.py $
# Copyright:   (c) 2006 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2009.02.02 Micha Raburski  poprawki w kontrahentach (1677)
# 2011.09.06 Mariusz Rajfura  kontrola danych przed zapisem (4982)
# 2011.12.15 Micha Raburski  refaktoryzacja kodu (5302)
# 2012.03.28 Mariusz Rajfura  blad sql-a dla pobierania nast.numeru kontrahenta (5591)
# 2013-02-01 Mariusz Rajfura (6477) nowe pole 'zablokowany', obsluga blokady 
# 2013-02-19 Mariusz Rajfura (6545) maile na adresy z rs_powiadomienia_pozycje przy odblokowaniu kontrahenta (B0004)
# 2013-03-25 Mariusz Rajfura (6727) zapisanie daty recznego odblokowania
# 2013-03-27 Mariusz Rajfura (6736) popr.dodawanie z uwzgl.pola 'odblokowany_recznie_dnia'
# 2013-11-11 Mariusz Rajfura (7362) popr.blok/odblok platnika dla grupy kontrahentow
# 2018-01-19 Piotr Witkowski (10452) pobieranie z bazy zewntrznej danych na podstawie nip/regon
# 2018-07-04 Aleksander Bargie (11132) Czy MPP w kontrahentach
# 2018-12-05 Aleksander Bargie (10452) baza z kontrahentami
# 2018-12-21 Aleksander Bargie (11340)  Pobieranie danych kontrahenta - zabezpieczy przed zbyt dug nazw
# 2019-01-15 Aleksander Bargie (11357)  Nie da si doda kontrahenta z rcznie wpisan nazw, chyba e wczeniej dodao si innego z NIP'u.
# 2019-02-28 Aleksander Bargie (11422)  Dodawanie kontrahentw z bazy GUS nie jest odporne na ''' w nazwie
# 2019-11-22 Aleksander Bargie (11754)  Biaa lista - wprowadzanie - edycja kontrahenta
# 2019-12-16 Aleksander Bargie (11791)  Nie sprawdza biaej listy w danych kontrahenta
# 2021-01-11 Wojciech Skowron   (12249)  Pobranie listy kontrahentw o podanym NIP
# 2021-01-22 Mikoaj Kozowski  (12285)  Blokada na dodawanie kontrahenta ze spacj na pocztku symbolu
# 2021-01-31 Wojciech Skowron   (12288)  Zapis do archiwum
# 2021-02-01 Wojciech Skowron            Podmiana "'" na "`" przy dodawaniu i edycji dla pl tekstowych
# 2022-06-15 Aleksander Bargie (13059)  Bd przy dodawaniu kontrahenta
# 2022-08-26 Aleksander Bargie (13134)  Bd sprawdzania certyfikatu przy sprawdzaniu biaej listy przy tworzeniu pliku pli
# 2023-08-29 Aleksander Bargie (13509)  Upora si ze znakami specjalnymi w danych pobieranych z GUS (usunicie pobrania klucza GUS w tym fs_ie)
# 2023-11-29 Jan Raburski       (13625)  Pobieranie kolejnego numeru kontrahenta przez F3

import re
import time # pobranie godziny tworzenia mejli o odblokowaniu

import rsglobal
from funkcje import fs_blokada_kontr_pom


Symbol = rsglobal.Dekoduj(klucze[0]).strip()

Fun=klucze[-1]

UprDodawanie=(self.oddzial_id,'012013') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdytowanie=(self.oddzial_id,'012012') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie
UprOdblokowanie=(self.oddzial_id,'012017') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)

stat="OK"
stat2="OK"
dane=[]
wyn2=[]
#AB 02.12.19r
SprBialaListe = False
puste = ('', '    -  -  ', 'None', '-  -')


#AB 02.12.19r
def CzySprawdzacBialaListe(pol, firma_id):
    sql = "SELECT sprawdzac_biala_liste FROM rs_firmy WHERE firma_id = '" + firma_id + "';"
    stat, d, dump, dump = pol.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych firmy: ' + stat
        return stat, False
    else:
        return stat, d[0][0]

#AB 22.11.19r
#-------------------------------------------------------------------------------
# test patnika vat (10)
#-------------------------------------------------------------------------------

if Fun == 10:
    #AB 02.12.19r
    stat, spr = CzySprawdzacBialaListe(self.PolSQL, self.firma_id)
    if spr:
        NIP = klucze[0]
        konto = klucze[1]
        rsglobal.ZapiszDoLogow("test bialej listy NIP {} konto {}.".format(NIP, konto))
        wyn = rsglobal.SprawdzNaBialejLiscie(konto, nip=NIP, self_fun=self)  #AB 26.08.22r
        if wyn == -2:
            wyn1 = "Wystpi bd weryfikacji certyfikatu SSL dla API, sprawdzono ignorujc certyfikat."
            wyn = rsglobal.SprawdzNaBialejLiscie(konto, nip=NIP, verify=False)
        dane = [wyn]

#WS 2021-01-11
#-------------------------------------------------------------------------------
#--- pobranie listy kontrahentw o podanym NIP (11)
#-------------------------------------------------------------------------------

if Fun == 11:
    NIP = klucze[0]
    kontrahent = klucze[1]
    SEL = "SELECT kontrahent_id, nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
    SEL += " AND regexp_replace(nip, '[^0-9]', '', 'g')=regexp_replace('"+NIP+"', '[^0-9]', '', 'g')"
    SEL += " AND kontrahent_id!='"+kontrahent+"';"
    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania listy kontrahentw o tym samym NIP: ' + stat
        dane = [stat]
    elif len(d) > 0:
        dane = d

#-------------------------------------------------------------------------------
# Domyslne informacje dla kontrahenta (8)
#-------------------------------------------------------------------------------

if Fun==8:
    DomyslnaKategoriaKontrahenta = ''
    DomyslnyRegion = ''
    
    SQL ="SELECT kateg_kontrahenta FROM rs_kategorie_fakturowanie"
    SQL+=" WHERE firma_id='"+self.firma_id+"' ORDER BY kateg_kontrahenta LIMIT 1;"
    
    stat,DaneK,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='BL SQL KAT'
        dane.append(stat)
    elif len(DaneK) > 0:
        DomyslnaKategoriaKontrahenta = DaneK[0]

    if stat=='OK':
        SQL ="SELECT region FROM rs_oddzialy"
        SQL+=" WHERE firma_id='"+self.firma_id+"' and oddzial_id='"+self.oddzial_id+"';"
        
        stat,DaneR,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='BL SQL REG'
            dane.append(stat)
        elif len(DaneR)>0 and (DaneR[0][0] not in ['None',None]): 
            DomyslnyRegion = DaneR[0]

    #AB 17.12.19r

    if stat=='OK':
        stat, spr = CzySprawdzacBialaListe(self.PolSQL, self.firma_id)

    if stat=='OK':
        dane=[DomyslnaKategoriaKontrahenta,DomyslnyRegion, spr]


#-------------------------------------------------------------------------------
#  TESTY NA SYMBOL KONTRAHENTA
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4]:
    if Symbol == '':
        stat="BR_SYMBOL"   
        dane.append(stat2)
        
    if stat=='OK':
                                                                                               #AB 22.11.19r
        SQL="SELECT odbiorca,dostawca,pracownik,inny,kraj,COALESCE(regon,''),COALESCE(nip,''), COALESCE(bank_konto,'') FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
        SQL+=" AND kontrahent_id = '"+Symbol+"';"
        stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>"OK":
            stat="BL_SQL_spr"
            rsglobal.ZapiszDoLogow(stat+"1",1)
           
        elif (Fun in [3,4] and len(DKontr)==0):
            stat="BL_SYMBOL1"   

        elif (Fun in [1,2] and len(DKontr) > 0):
            stat="BL_SYMBOL2"   


#-------------------------------------------------------------------------------
#---   KLUCZ MAKS (7)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [7,17]:
    SQL="SELECT rsf_klucz_max('rs_kontrahenci','"+self.firma_id+"','kontrahent_id',5,'"+Symbol+"');"
    stat,dane2,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat != "OK":
        stat = "BL_KLUCZ_MAX"
    elif Fun == 7:
        dane=dane2        

#-------------------------------------------------------------------------------
#---   KLUCZ NASTEPNY (MAX+1) (17)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==17:
    Symbol2 = ''
    Numer = ''
    Ostatni = rsglobal.Dekoduj(dane2[0][0])
        
    for z in Ostatni:
        if not z.isdigit():
            if Numer=='':
                Symbol2+=z
        else:
            Numer+=z
        
    #if len(Numer) > 0:
    #jesli jest miejsce na numer
    #sprawdzimy, czy to maksymalny, istniejacy numer kontrahenta
    #bo moze jest to zaproponowany numer 1 (uzupelniony zerami) kontrahenta dla danego symbolu
    #tj. A0001, AB001, ABC01, ABCD1
    if len(Numer) == 0:
        Numer = '0'
    SQL ="SELECT kontrahent_id FROM rs_kontrahenci"
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Ostatni+"';"
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia ostatniego numeru kontrahenta : '+stat
    elif len(Dane) > 0:
        #to ostatni istniejacy, a nie zaproponowany, wiec dodamy do niego 1
        dlg_numer = len(Numer)
        #dane = dane2
        Numer = str(int(Numer)+100001)[len(Symbol2.strip())+1:6]
        dane = [[Symbol2.strip() + Numer]]
    else:
        dane=[[Symbol]]

# -------------------------------------------------------------------------------
# ---   KLUCZ NASTEPNY (MAX+1) (27)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun == 27:
    ile = len(Symbol)
    SQL = "SELECT CAST(SUBSTRING(kontrahent_id FROM "+str(ile+1)+" FOR 5) AS INT) + 1 as \"numer\" FROM rs_kontrahenci"
    SQL += " WHERE firma_id = '" + self.firma_id + "' AND kontrahent_id LIKE '" + Symbol + "%' ORDER BY numer DESC;"
    stat, Dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia ostatniego numeru kontrahenta : ' + stat
    elif len(Dane) > 0:
        # zamieniamy na string
        dane = [[Symbol + str(int(Dane[0][0]))]]
    else:
        dane = [[Symbol+'1']]
    if len(dane[0][0]) > 5:
        dane = None

#-------------------------------------------------------------------------------
# Sprawdzenie poprawnoci danych do zmian danych
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat=='OK':
    if not ((UprDodawanie and (Fun in [1,2])) or (UprEdytowanie and (Fun in [3,4]))):
        stat="BL_UPR"   
    
    if stat=='OK':
        DKategKontr=[]
        Kontrahent=Symbol
        Odbiorca=False
        Dostawca=False
        Pracownik=False
        Inny=False
        Kraj=''
        Kategoria=''
        Regon=''
        NIP=''
        
        if Fun in [3,4]: 
            Odbiorca=DKontr[0][0]
            Dostawca=DKontr[0][1]
            Pracownik=DKontr[0][2]
            Inny=DKontr[0][3]
            Kraj=str(DKontr[0][4])
            Regon=str(DKontr[0][5]).strip()
            NIP=str(DKontr[0][6]).strip()
            #AB 22.11.19r
            Konto=str(DKontr[0][7]).strip()

        #sprawdzenie niektrych pl sucych do weryfikacji innych pl
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole=='kraj':
                Kraj=wart
            elif pole=='odbiorca':
                Odbiorca=wart
            elif pole=='dostawca':
                Dostawca=wart
            elif pole=='pracownik':
                Pracownik=wart
            elif pole=='inny':
                Inny=wart
            elif pole=='Regon':
                Regon=wart.strip()
            elif pole=='NIP':
                NIP=wart.strip()
            #AB 22.11.19r
            elif pole=='bank_konto':
                Konto=wart.strip()
            elif pole=='kontrahent_id': #MK 2021-01-22
                if not wart:
                    stat = 'Symbol kontrahenta nie moe by pusty'
                elif wart[0] in [' ', '']:
                    stat = 'Symbol kontrahenta nie moe zaczyna si od spacji'
                else:
                    Kontrahent=wart
                
        if Kraj in ['',None,'None']:
            stat='BR_KRAJ'
        else:
            SQL="SELECT kraj FROM rs_kraje WHERE kraj = '"+Kraj+"';"
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>"OK":
                stat="Bd sprawdzania kraju :"+stat
            elif len(DTest)==0:    
                stat="BL_KRAJ"   

    Platnik = None
    Zablokowany = None
    if stat=='OK':    
        for i in range(len(pola)):
            if stat=='OK':    
                pole = pola[i]
                wart = wartosci[i]
                    
                if pole=='zamawiajacy_id':
                    if wart<>'':
                        SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                        
                        if stat<>"OK":
                            stat="BL_SQL_spr"
                            rsglobal.ZapiszDoLogow(stat+"2",1)
                            dane.append(stat) 
                        else:
                            if len(DTest)==0:
                                dane.append("BL_ZAMAW_ID")
        
                elif pole=='platnik_id':
                    Platnik = wart
                    if wart<>'':
                        SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>"OK":
                            stat="BL_SQL_spr"
                            rsglobal.ZapiszDoLogow(stat+"3",1)
                            dane.append(stat) 
                        else:    
                            if len(DTest)==0:
                                dane.append("BL_PLATNIK_ID")
    
                elif pole=='nazwa':
                    if wart=='':
                        dane.append("BL_NAZWA")
        
                elif pole=='kateg_kontrahenta':
                    if not ((self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'012016') in self.uprawnienia) or (Fun in [1,2])):
                        stat='BR UPR ZM KAT'
                        dane.append(stat)
                    
                    if stat=='OK':
                        Kategoria=wart
                        if wart=='':
                            dane.append("BR_KAT_KONT")
                        else:
                            SQL="SELECT kod FROM rs_kateg_kontrahentow WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>"OK":
                                stat="BL_SQL_spr"
                                rsglobal.ZapiszDoLogow(stat+"4",1)
                                dane.append(stat) 
                            else:    
                                if len(DTest)==0:
                                    dane.append("BL_KAT_KONT")

                elif pole=='region':
                    if wart=='':
                        stat="BR_REG"   
                        dane.append(stat)
                    if stat=='OK':    
                        SQL="SELECT kod FROM rs_regiony WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>"OK":
                            stat="BL_SQL_spr"
                            rsglobal.ZapiszDoLogow(stat+"5",1)
                            dane.append(stat) 
                        else:
                            if len(DTest)==0:
                                dane.append("BL_REG")

                elif pole=='grupa_odbiorcow':
                    if wart<>'':
                        SQL="SELECT kod FROM rs_grupy_odbiorcow WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>"OK":
                            stat="Bd sprawdzenia grupy odbiorcw :"+stat
                            dane.append(stat) 
                        else:
                            if len(DTest)==0:
                                dane.append("BL_GR_ODB")


                elif pole == 'Pesel':
                    if wart != '':
                        stat = rsglobal.SprPesel(wart)
                        if stat != 'OK':
                            dane.append(stat)

                elif pole=='zablokowany':
                    Zablokowany = wart
                    if not wart:
                        if Fun in (3,4):
                            if not UprOdblokowanie:
                                stat = 'BR UPR ODBLOKOWANIA'
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
    
        if Fun in [1,2,3,4] and stat == 'OK': 
            if not (Odbiorca or Dostawca or Pracownik or Inny):
                dane.append("BL_RODZ_KONT")

        #sprawdzanie regonu
        if Regon.strip()<>'':
            if Kraj=="PL" and len(Regon)>0:       
                stat=rsglobal.SprRegon(Regon)
                if stat<>'OK':
                    dane.append("BL_REG_CRC")
    
        #sprawdzanie nipu
        #AB 22.11.19r
        if re.sub('[^0-9]', '', NIP) != '' and Kraj == 'PL':
            NIP = re.sub('[^0-9]', '', NIP)
            stat = rsglobal.SprNip(NIP)
            if stat != 'OK':
                dane.append("BL_NIP_CRC")

        #sprawdzanie IBAN
        #AB 22.11.19r
        if re.sub('[^0-9]', '', Konto) != '' and Kraj == 'PL':
            Konto = re.sub('[^0-9]', '', Konto)
            stat = rsglobal.SprIBAN(Konto)
            if stat != 'OK':
                dane.append("BL_IBAN_CRC")

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
    
        
#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------
    
    if Fun in [1,2] and stat == 'OK':
        #AB 21/.12.18r
        DANE = klucze[-2]
        SQL="INSERT INTO rs_kontrahenci (firma_id"
        Wartosci=''
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            #AB 28.02.19
            if isinstance(wart, basestring):
                #WS 2021-02-01
                wart = wart.replace("'", "`")
                # wart.replace("'", "`")
            if pole in ['zamawiajacy_id','platnik_id','krajk','region','grupa_odbiorcow','spos_zaplaty']:
                SQL+=','+pole
                Wartosci+=','+rsglobal.ObrobTekst(wart).strip()                                         #AB 16.12.19r
            elif pole in ['odbiorca','dostawca','pracownik','inny','aktywny','zablokowany','czy_mpp','nie_sprawdzac_bialej_listy']:
                SQL+=','+pole
                Wartosci+=','+str(wart)
            elif not pole in ('odblokowany_recznie_dnia'):
                SQL+=','+pole
                Wartosci+=",'"+wart.strip()+"'"


        #AB 15.01.19r
        if DANE:
            #AB 28.02.19
            nazwa = DANE['pelna_nazwa'].replace("'", "`")
            f1 = ''
            f2 = ''
            if len(DANE['pelna_nazwa']) > 50:
                wyrazy = nazwa.split(' ')
                while len(wyrazy) > 0 and len(f1 + wyrazy[0]) < 50:
                    f1 += ' ' + wyrazy[0]
                    wyrazy = wyrazy[1:]
                while len(wyrazy) > 0 and len(f2 + wyrazy[0]) < 50:
                    f2 += ' ' + wyrazy[0]
                    wyrazy = wyrazy[1:]
            else:
                f1 = nazwa
            SQL      += ",nazwa_pelna,nazwa_f1,nazwa_f2"
            Wartosci += ", '"+nazwa+"','"+f1+"','"+f2+"'"

        
        SQL+=") VALUES ('"+self.firma_id+"'"+Wartosci+");"
        SQL = SQL.replace(u"\u2019", u"`").replace(u'\u201e', u'"')
                
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1, CzyDodawacBlad=True)  #AB 15.06.22r
        rsglobal.ZapiszDoLogow(SQL, 5)
        if stat<>"OK":
            rsglobal.ZapiszDoLogow(u"BL_SQL_spr6\n" + stat, 1)  #AB 15.06.22r
            dane.append(stat)

                                    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

    if Fun in [3,4]: 
        if stat == 'OK':
            #WS 2021-01-31 - zapis do archiwum
            DoDnia = rsglobal.Dekoduj(klucze[1])
            if DoDnia not in ('', '-  -', '    -  -  ', 'None'):
                Klucze = {}
                Klucze['Funkcja'] = 12
                Klucze['Kontrahent'] = Symbol
                Klucze['DoDnia'] = DoDnia
                stat, dump, dump, dump = self.WykonajFunkcje("fs_kontrahenci_dane_archiwalne_dane",
                                                             Klucze, [], [], RobicCommit=False)
                if stat != 'OK':
                    dane.append(stat)

        if stat == 'OK':
            UPD="UPDATE rs_kontrahenci SET "
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]

                #WS 2021-02-01
                if isinstance(wart, basestring):
                    wart = wart.replace("'", "`")

                if pole in ['zamawiajacy_id','platnik_id','krajk','region','grupa_odbiorcow']:
                    wart=rsglobal.ObrobTekst(wart)
                                                                                                         #AB 16.12.19r
                elif pole in ['odbiorca','dostawca','pracownik','inny','aktywny','spos_zaplaty', 'czy_mpp', 'nie_sprawdzac_bialej_listy']:
                    wart=str(wart)
                elif pole in ['zablokowany']:
                    if not wart:
                        # dodatkowo zapisywana informacja o odblokowaniu wykanym recznie przez edycje
                        UPD+="odblokowany_recznie_dnia=NOW()::DATE,"
                    wart=str(wart)
                else:
                    wart="'"+wart+"'"
                UPD+=pole+"="+str(wart)+","
                
            UPD = UPD.strip(',')
            SQL= UPD+" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Symbol+"'; "
            
            stat,d,wyn1,dump = self.PolSQL.Execute(SQL,1)
            if stat!="OK":
                stat="BL_SQL_spr"
                stat = SQL
                rsglobal.ZapiszDoLogow(stat+"7",1)
                dane.append(stat)

            # obsluga blokady
            if stat == 'OK':
                sql ="SELECT COALESCE(platnik_id,''::TEXT),zablokowany FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Symbol+"'; "
                stat,NoweDane,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania nowych danych kontrahenta: '+stat
                    
            if stat == 'OK':
                if Platnik != None and NoweDane[0][0] != '':
                    BedzieOdblokowanie = False
                    # jesli byl modyfikowany platnik, to ustawiamy taki stan blokady dla kontrahenta,
                    # jaki posiada nowy platnik
                    sql ="SELECT zablokowany FROM rs_kontrahenci"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"'; "

                    stat,PlatBlok,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd pobrania danych patnika: '+stat
                    elif NoweDane[0][1] and not PlatBlok[0][0]:
                        # u nowego platnika nie ma blokady, a u kontrahenta jest
                        BedzieOdblokowanie = True
                        if not UprOdblokowanie:
                            stat = 'BR UPR ODBLOKOWANIA'
                    
                    if stat == 'OK':
                        if PlatBlok[0][0]:
                            # zalozenie blokady dla tego kontrahenta
                            stat = fs_blokada_kontr_pom.ZalozBlokadeNaKontrahenta(self.PolSQL,self.firma_id,Symbol,'')
                        else:
                            # zdjecie blokady dla tego kontrahenta
                            upd ="UPDATE rs_kontrahenci SET zablokowany="+str(PlatBlok[0][0])+","
                            upd+=" odblokowany_recznie_dnia=NOW()::DATE"
                            upd+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Symbol+"'; "
                            stat,upd,dump,dump = self.PolSQL.Execute(upd,1)
                            if stat != 'OK':
                                stat = 'Bd modyfikacji stanu blokady: '+stat
                            
                            # wyslanie mejla o odblokowaniu tego kontrahenta
                            if stat == 'OK' and BedzieOdblokowanie:
                                # pobranie adresw na ktre ma to pj dla konkretnego oddziau
                                sql ="SELECT DISTINCT email FROM rs_powiadomienia_pozycje"
                                sql+=" WHERE firma_id='"+self.firma_id+"' AND powiadomienie='B0004';"
                                
                                stat,DPoczta,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
                                if stat != 'OK':    
                                    stat="Bd pobierania listy kont pocztowych dla wysania powiadomienia: "+stat

                                if stat == 'OK' and len(DPoczta) > 0:
                                    # pobranie danych operatora
                                    sql ="SELECT TRIM(imie)||' '||TRIM(nazwisko) FROM rs_operatorzy"
                                    sql+=" WHERE operator_id="+str(self.operator_id)+";"
                                    stat,Operator,dump,dump = self.PolSQL.Execute(sql,3)
                                    if stat != 'OK':
                                        stat = 'Bd pobrania danych operatora: '+stat

                            if stat == 'OK' and BedzieOdblokowanie and len(DPoczta) > 0:
                                # pobranie opisu kontrahenta
                                sql ="SELECT TRIM(nazwa) FROM rs_kontrahenci"
                                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Symbol+"'; "

                                stat,DaneOdblok,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat != 'OK':
                                    stat = 'Bd pobrania informacji o odblokowywanych kontrahentach: '+stat
                                elif len(DaneOdblok) == 0:
                                    stat = 'Brak kontrahentw do odblokowania'
                            
                            if stat=='OK' and BedzieOdblokowanie and len(DPoczta) > 0:
                                Temat="Informacja o odblokowaniu kontrahenta wygenerowana "+\
                                      time.strftime('%Y-%m-%d %H:%m:%S' , time.localtime())
                                
                                Tresc="Kontrahent "+rsglobal.Dekoduj(Symbol)+\
                                      " "+rsglobal.Dekoduj(DaneOdblok[0][0])+\
                                      " zosta odblokowany przez operatora "+\
                                      rsglobal.Dekoduj(Operator[0][0])+"\n"

                                # wysanie maili
                                for mail in DPoczta:
                                    rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,self.PolSQL)

                elif Zablokowany != None:
                    
                    if NoweDane[0][1]:
                        # zalozenie blokady dla grupy kontrahentow z platnikiem
                        
                        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                        sql+=" WHERE firma_id='"+self.firma_id+"'"
                        if NoweDane[0][0] == '':
                            sql+=" AND platnik_id='"+Symbol+"';"
                        else:
                            sql+=" AND (platnik_id='"+Symbol+"' OR platnik_id='"+rsglobal.Dekoduj(NoweDane[0][0])+"'"
                            sql+="      OR kontrahent_id='"+rsglobal.Dekoduj(NoweDane[0][0])+"');"
                            
                        stat,LKontr,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat != 'OK':
                            stat = 'Bd pobrania listy patnikw dla kontrahenta: '+stat

                        if stat == 'OK':
                            # dodanie samego siebie
                            LKontr.append([Symbol])
                            for i in xrange(len(LKontr)):
                                stat = fs_blokada_kontr_pom.ZalozBlokadeNaKontrahenta(self.PolSQL,self.firma_id,LKontr[i][0],'')
                                if stat != 'OK':
                                    break

                    else:
                        # zdjecie blokady dla grupy kontrahentow z platnikiem
                        upd ="UPDATE rs_kontrahenci SET zablokowany="+str(NoweDane[0][1])+","
                        upd+=" odblokowany_recznie_dnia=NOW()::DATE"
                        upd+=" WHERE firma_id='"+self.firma_id+"'"
                        if NoweDane[0][0] == '':
                            upd+=" AND platnik_id='"+Symbol+"';"
                        else:
                            upd+=" AND (platnik_id='"+Symbol+"' OR platnik_id='"+rsglobal.Dekoduj(NoweDane[0][0])+"'"
                            upd+="      OR kontrahent_id='"+rsglobal.Dekoduj(NoweDane[0][0])+"');"

                        stat,upd,dump,dump = self.PolSQL.Execute(upd,1)
                        if stat != 'OK':
                            stat = 'Bd modyfikacji stanu blokady dla kontrahentw danego patnika: '+stat
                        
                        # wyslanie mejli powiadomienia o recznym zdjeciu blokady
                        if stat == 'OK':
                            # pobranie adresow, na ktore ma to pojsc powiadomienie
                            sql ="SELECT DISTINCT email FROM rs_powiadomienia_pozycje"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND powiadomienie='B0004';"
                            
                            stat,DPoczta,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
                            if stat != 'OK':
                                stat="Bd pobierania listy kont pocztowych dla wysania powiadomienia: "+stat

                        if stat == 'OK' and len(DPoczta) > 0:
                            # pobranie danych operatora
                            sql ="SELECT TRIM(imie)||' '||TRIM(nazwisko) FROM rs_operatorzy"
                            sql+=" WHERE operator_id="+str(self.operator_id)+";"
                            stat,Operator,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'Bd pobrania danych operatora: '+stat
                            
                        if stat == 'OK' and len(DPoczta) > 0:
                            # pobranie opisu odblokowanych kontrahentow
                            sql ="SELECT kontrahent_id,COALESCE(platnik_id,kontrahent_id),nazwa FROM rs_kontrahenci"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            if NoweDane[0][0] == '':
                                sql+=" AND COALESCE(platnik_id,kontrahent_id)='"+Symbol+"';"
                            else:
                                sql+=" AND (platnik_id='"+Symbol+"' OR platnik_id='"+rsglobal.Dekoduj(NoweDane[0][0])+"');"
                            
                            stat,DaneOdblok,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'Bd pobrania informacji o odblokowywanych kontrahentach: '+stat
                            elif len(DaneOdblok) == 0:
                                stat = 'Brak kontrahentw do odblokowania'

                        if stat == 'OK' and len(DPoczta) > 0:
                            # pobranie danych operatora
                            sql ="SELECT TRIM(imie)||' '||TRIM(nazwisko) FROM rs_operatorzy"
                            sql+=" WHERE operator_id="+str(self.operator_id)+";"
                            stat,Operator,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat != 'OK':
                                stat = 'Bd pobrania danych operatora: '+stat
                            
                        if stat == 'OK' and len(DPoczta) > 0:
                            Temat="Informacja o odblokowaniu kontrahentw wygenerowana "+\
                                  time.strftime('%Y-%m-%d %H:%m:%S' , time.localtime())
                            Tresc="KONTRAHENCI, KTRZY ZOSTALI ODBLOKOWANI przez operatora "+\
                                   rsglobal.Dekoduj(Operator[0][0])+"\n\n"

                            for i in xrange(len(DaneOdblok)):
                                Tresc+=DaneOdblok[i][0]+" "+DaneOdblok[i][2]+"  patnik "+DaneOdblok[i][1]+"\n"
                            
                            # wysanie maili
                            for mail in DPoczta:
                                rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,self.PolSQL)
                
                
#-------------------------------------------------------------------------------
#---   EWENTUALNE WSTAWIENIE DANYCH DO FAKTUROWANIA (1,2,3,4)
#-------------------------------------------------------------------------------

    # jeli Kategoria si zmienia to od razu pobieramy dane z rs_kategorie_fakturowanie dla obu sytuacji (ins/upd)
    if stat == 'OK':
        if 'kateg_kontrahenta' in pola and Kategoria <>'':
            SQL="SELECT COALESCE(wyznacznik,''),COALESCE(dni,0),COALESCE(wersja,''),COALESCE(upust,0),COALESCE(maks_wart,0),"
            SQL+="COALESCE(spos_zaplaty,''),COALESCE(spos_dostawy,''),COALESCE(projekt_id,'')"
            SQL+=" FROM rs_kategorie_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta='"+Kategoria+"'"
            stat,DKategKontr,dump,dump=self.PolSQL.Execute(SQL,2)
            if stat<>'OK':
                stat='BL SEL WYBR KAT'
                dane.append(stat)

        # wiemy e jest kategoria i s jej dane do fakturowania
        if stat=='OK' and len(DKategKontr)>0:        
            Data=rsglobal.PodajDzis()
            
            KFWyznacznik=rsglobal.Dekoduj(DKategKontr[0][0])
            KFDni=DKategKontr[0][1]
            KFWersja=rsglobal.Dekoduj(DKategKontr[0][2])
            KFUpust=DKategKontr[0][3]
            KFMaksWart=DKategKontr[0][4]
            KFSposZaplaty=rsglobal.Dekoduj(DKategKontr[0][5])
            KFSposDostawy=rsglobal.Dekoduj(DKategKontr[0][6])
            KFProjekt=rsglobal.Dekoduj(DKategKontr[0][7])
            InsertDodPola=''
            InsertDodWart=''

            # jeli funkcja to update to musimy sprawdzi czy robimy update czy insert
            Data=rsglobal.PodajDzis()
            DataKF=''
            DDanychFakt=[]
            if Fun in [3,4]: 
                Kontrahent=Symbol
                SQL= "SELECT data_od,COALESCE(wyznacznik,''),COALESCE(dni,0),COALESCE(wersja,''),COALESCE(upust,0),COALESCE(maks_wart,0),"
                SQL+="COALESCE(spos_zaplaty,''),COALESCE(spos_dostawy,''),COALESCE(projekt_id,''),czy_upow,czy_fakt,czy_zbiorcza,"
                SQL+="czy_osobna,czy_z_dostaw,rozliczac_zwroty,czy_ceny_na_dowodach,czy_wg_indeksow,COALESCE(handlowiec,''),"
                SQL+="COALESCE(sposob_odbioru_faktury,'')"
                SQL+=" FROM rs_kontrahenci_fakturowanie "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND data_od<='"+Data+"' "
                SQL+=" ORDER BY data_od DESC LIMIT 1;"

                stat,DDanychFakt,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat=='OK':
                    if len(DDanychFakt)>0:
                        DataKF=DDanychFakt[0][0]
                        if KFWyznacznik=='':
                            KFWyznacznik=rsglobal.Dekoduj(DDanychFakt[0][1])
                        if KFDni==0:
                            KFDni=rsglobal.Dekoduj(DDanychFakt[0][2])
                        if KFWersja=='':
                            KFWersja=rsglobal.Dekoduj(DDanychFakt[0][3])
                        if KFUpust==0:
                            KFUpust=DDanychFakt[0][4]
                        if KFMaksWart==0:
                            KFMaksWart=DDanychFakt[0][5]
                        if KFSposZaplaty=='':
                            KFSposZaplaty=rsglobal.Dekoduj(DDanychFakt[0][6])
                        if KFSposDostawy=='':
                            KFSposDostawy=rsglobal.Dekoduj(DDanychFakt[0][7])
                        if KFProjekt=='':
                            KFProjekt=rsglobal.Dekoduj(DDanychFakt[0][8])
                        
                        InsertDodPola=",czy_upow,czy_fakt,czy_zbiorcza,czy_osobna,czy_z_dostaw,rozliczac_zwroty,czy_ceny_na_dowodach"
                        InsertDodPola+=",czy_wg_indeksow,handlowiec,sposob_odbioru_faktury"
                        
                        for i in range(8):
                            if DDanychFakt[0][i+8]:
                                InsertDodWart+=',TRUE'
                            else:
                                InsertDodWart+=',FALSE'
                       
                        InsertDodWart+=','+rsglobal.ObrobTekst(DDanychFakt[0][17])
                        InsertDodWart+=','+rsglobal.ObrobTekst(DDanychFakt[0][18])
                                        
            if stat=='OK':
                # przygotowanie danych do obu rodzajw zapisw
                INSPOLA=''
                INSWART=''
                UPDPOLAW=''
                if KFWyznacznik<>'':
                    INSPOLA+=",wyznacznik"
                    INSWART+=",'"+KFWyznacznik+"'"
                    UPDPOLAW+=",wyznacznik='"+KFWyznacznik+"'"
                if KFSposZaplaty<>'':
                    INSPOLA+=",spos_zaplaty"
                    INSWART+=",'"+KFSposZaplaty+"'"
                    UPDPOLAW+=",spos_zaplaty='"+KFSposZaplaty+"'"
                if KFSposDostawy<>'':
                    INSPOLA+=",spos_dostawy"
                    INSWART+=",'"+KFSposDostawy+"'"
                    UPDPOLAW+=",spos_dostawy='"+KFSposDostawy+"'"
                if KFWersja<>'':
                    INSPOLA+=",wersja"
                    INSWART+=",'"+KFWersja+"'"
                    UPDPOLAW+=",wersja='"+KFWersja+"'"
                if KFProjekt<>'':
                    INSPOLA+=",projekt_id"
                    INSWART+=",'"+KFProjekt+"'"
                    UPDPOLAW+=",projekt_id='"+KFProjekt+"'"
                if KFDni!=0:
                    INSPOLA+=",dni"
                    INSWART+=","+str(KFDni)
                    UPDPOLAW+=",dni='"+str(KFDni)+"'"
                if KFUpust!=0:
                    INSPOLA+=",upust"
                    INSWART+=","+str(KFUpust)
                    UPDPOLAW+=",upust='"+str(KFUpust)+"'"
                if KFMaksWart!=0:
                    INSPOLA+=",maks_wart"
                    INSWART+=","+str(KFMaksWart)
                    UPDPOLAW+=",maks_wart='"+str(KFMaksWart)+"'"
                
                CzyInsert=True
                if Fun in [1,2] or (Fun in [3,4] and len(DDanychFakt)==0):
                    # jeli nowy kontrahent lub stary ale bez danych kontrahenta
                    DataPocz='2000-01-01'
                elif Fun in [3,4] and DataKF==Data:
                    # jeli bdziemy zmienia istniejce dane kontrahenta
                    CzyInsert=False
                else:
                    # jeli bdziemy dodawa nowe dane kontrahenta w oparciu o istniejce
                    DataPocz=Data
                    
                
                # INSERT DANYCH
                if CzyInsert:
                    SQL="INSERT INTO rs_kontrahenci_fakturowanie "
                    SQL+=" (firma_id,data_od,kontrahent_id"
                    VALUES=" VALUES ('"+self.firma_id+"','"+DataPocz+"','"+Kontrahent+"'"                
                    
                    INSPOLA+=InsertDodPola+")"
                    INSWART+=InsertDodWart+")"
                    SQL+=INSPOLA+VALUES+INSWART
                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    if stat<>'OK':
                        stat='BL INS KONTR FAKT'
                        dane.append(stat)
                        
                # UPDATE ISTNIEJCYCH DANYCH
                else:
                    SQL="UPDATE rs_kontrahenci_fakturowanie SET "+UPDPOLAW.strip(',')
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND data_od='"+Data+"';"
                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    if stat<>'OK':
                        stat='BL UPD KONTR FAKT'
                        dane.append(stat)
                    
                    
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem,1 - insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in [5,3,1]:
    Kategoria   = ''
    Kraj        = ''
    Region      = ''
    GrupaOdb    = ''
    #AB 22.11.19r
    BialaLista  = 'OK'
    Platnik     = ''
    Zamawiajacy = ''

    if stat == 'OK':
        sql="SELECT * FROM rs_kontrahenci WHERE kontrahent_id ='"+Symbol+"' AND firma_id = '"+self.firma_id+"';"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)

        if stat!="OK":
            stat="BL_SQL_spr"

            rsglobal.ZapiszDoLogow(stat + "8", 1)
            dane.append(stat)
        else:
            for i in xrange(len(dane[0])):
                pole = wyn1[i][0]
                wart = str(dane[0][i])

                if pole == 'kateg_kontrahenta':
                    if ((self.oddzial_id,'011010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        sql = "SELECT opis FROM rs_kateg_kontrahentow WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            Kategoria = 'Bd pobrania opisu kategorii kontrahenta : '+stat
                        else:
                            if len(d) == 0:
                                Kategoria = 'Bdny kod kategorii kontrahenta'
                            else:
                                Kategoria = str(d[0][0])
                    else:
                        Kategoria = 'Brak uprawnie do sownika. Poinformuj administratora.'

                elif pole == 'kraj':
                    if ((self.oddzial_id,'011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        sql = "SELECT nazwa FROM rs_kraje WHERE kraj = '"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            Kraj = 'Bd pobrania opisu kraju : '+stat
                        else:
                            if len(d) == 0:
                                Kraj = 'Bdny kod kraju'
                            else:
                                Kraj = str(d[0][0])
                    else:
                        Kraj = 'Brak uprawnie do sownika. Poinformuj administratora.'

                #AB 22.11.19r
                elif pole == 'platnik_id'  and wart.strip() != '' and wart != 'None':
                    sql = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id='{}' AND kontrahent_id='{}';".format(self.firma_id, wart)
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Platnik = 'Bd pobrania nazwy patnika : ' + stat
                    else:
                        if len(d) == 0:
                            Platnik = 'Bdne id patnika'
                        else:
                            Platnik = str(d[0][0])

                #AB 22.11.19r
                elif pole == 'zamawiajacy_id'  and wart.strip() != '' and wart != 'None':
                    sql = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id='{}' AND kontrahent_id='{}';".format(self.firma_id, wart)
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Zamawiajacy = 'Bd pobrania nazwy zamawiajcego : ' + stat
                    else:
                        if len(d) == 0:
                            Zamawiajacy = 'Bdne id zamawiajcego'
                        else:
                            Zamawiajacy = str(d[0][0])

                elif pole == 'region':
                    if ((self.oddzial_id,'011020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                        sql = "SELECT opis FROM rs_regiony WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            Region = 'Bd pobrania opisu regionu : '+stat
                        else:
                            if len(d) == 0:
                                Region = 'Bdny kod regionu'
                            else:
                                Region = str(d[0][0])
                    else:
                        Region = 'Brak uprawnie do sownika. Poinformuj administratora.'

                elif pole == 'grupa_odbiorcow' and wart.strip() != '' and wart != 'None':
                    if ((self.oddzial_id,'211270') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) and wart != '':
                        sql = "SELECT opis FROM rs_grupy_odbiorcow WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            GrupaOdb = 'Bd pobrania opisu grupy odbiorcw : '+stat
                        else:
                            if len(d) == 0:
                                GrupaOdb = 'Bdny kod grupy odbiorcw'
                            else:
                                GrupaOdb = str(d[0][0])
                    else:
                        GrupaOdb = 'Brak uprawnie do sownika. Poinformuj administratora.'
            #AB 02.12.19r
            if stat == 'OK' and Fun in (1, 2, 3, 4, 5):
                stat, SprBialaListe = CzySprawdzacBialaListe(self.PolSQL, self.firma_id)
            #AB 22.11.19r
            if stat == 'OK' and Fun in (3, 1, ):
                rsglobal.ZapiszDoLogow(dane)
                naglowki = [kol[0] for kol in wyn1]
                konto    = dane[0][naglowki.index('bank_konto')]
                nip      = dane[0][naglowki.index('nip')]
                kraj     = dane[0][naglowki.index('kraj')]
                aktywny  = dane[0][naglowki.index('aktywny')]
                dostawca = dane[0][naglowki.index('dostawca')]
                #AB 16.12.19r
                nie_spr  = dane[0][naglowki.index('nie_sprawdzac_bialej_listy')]
                if (SprBialaListe and kraj == "PL" and nip.strip() not in puste and konto.strip() not in puste and aktywny and dostawca
                    and not nie_spr):
                    BialaLista = rsglobal.SprawdzNaBialejLiscie(konto=konto, nip=nip)

                                                    #AB 22.11.19r
            wyn2 = [Kategoria,Kraj,Region,GrupaOdb, BialaLista, Platnik, Zamawiajacy, SprBialaListe]
            

#----------------  sprawdzamy czy dane maj by przesyane dalej
if stat == "OK" and Fun in [1,2,3,4] and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    #-#############################################################################################
    # obsuga komsera
    #-#############################################################################################
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_kontrahenci_dane'", 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], ["fs_komser_kontrahenci", klucze, pola, wartosci])



    #-#############################################################################################
    #obsuga foxa -- update i insert bd przesyane do plikw w zdefiniowanym katalogu foxa
    #-#############################################################################################
    if stat=='OK':
        Robic= os.path.isfile('./fox')
        #----- nie ma pliku fox - ignorujemy dalsz cz algorytmu
        
        if Robic:
            try:
                f=file('./fox','r')
            except:
                Robic=False
                rsglobal.ZapiszDoLogow(u'Nie mona otworzy pliku fox',1)
                
        if Robic:
            parametry=f.read()
            f.close()
            parametry=parametry.splitlines()
            if len(parametry)==0:
                #--- pusty plik - powrot z bledem o pustym pliku fox
                rsglobal.ZapiszDoLogow(u'Plik fox istnieje, ale jest pusty',1)
                Robic=False
        rsglobal.ZapiszDoLogow("ABC ",1)
        if Robic:
            katalog=parametry[0].strip()
            if not os.path.isdir(katalog):
                #---- bledna sciezka lub brak mapowania - napisac jaka 
                rsglobal.ZapiszDoLogow(u'Bdny katalog w pliku fox :'+katalog,1)
                Robic=False
                
        if Robic:
            pliktxt=katalog+'anod01.txt'
            #---- zapis bledow
            try:
                f=file(pliktxt,'a+')
            except:
                #--- powrot z bledem - wystapily bledy ale nie udalo sie zapisac
                rsglobal.ZapiszDoLogow(u'Nie mona otworzy pliku anod01.txt do edycji',1)
                Robic=False

        if Robic:
            # umieszczenie na kocu dwch linii z danymi kontrahenta
            SQL="SELECT COALESCE(nip,''), COALESCE(regon,''), COALESCE(pesel,''), COALESCE(adr_kod,''), COALESCE(adr_miej,''),"
            SQL+=" COALESCE(adr_ulica,''), COALESCE(adr_nry,''), COALESCE(tel1,tel2,''), COALESCE(fax,''),"
            SQL+="COALESCE(nazwa,''), COALESCE(nazwa_f1,''), COALESCE(nazwa_f2,''), COALESCE(bank_nazwa,''), COALESCE(bank_konto,''), "
            SQL+="COALESCE(email,'') FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Symbol+"';"
            stat,DaneK,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DaneK)>0:
                    SymbPl=Symbol+'     '
                    Nip=DaneK[0][0]+'          '
                    Regon=DaneK[0][1]+'         '
                    Pesel=DaneK[0][2]+'           '
                    AdrKod=DaneK[0][3]+'      '
                    AdrMiej=DaneK[0][4]+'               '
                    AdrUlica=DaneK[0][5]+'                    '
                    AdrNr=DaneK[0][6]+'      '
                    Tel=DaneK[0][7]+'               '
                    Fax=DaneK[0][8]+'               '
                    Nazwa=DaneK[0][9]+'                                                  '
                    NazwaF1=DaneK[0][10]+'                                                  '
                    NazwaF2=DaneK[0][11]+'                                                  '
                    BankNazwa=DaneK[0][12]+'                                                  '
                    BankKonto=DaneK[0][13]+'                                             '
                    Email=DaneK[0][14]+'                                                  '
                    if Fun in [1,2]:
                        Nowy='T'
                    else:
                        Nowy='F'

                    wiersz=SymbPl[:5]+'T'+Nip[:10]+Regon[:9]
                    wiersz+=Pesel[:11]+AdrKod[:6]+AdrMiej[:15]
                    wiersz+=AdrUlica[:20]+AdrNr[:6]+Tel[:15]+Fax[:15]
                    wiersz+=Nazwa[:50]+NazwaF1[:50]+NazwaF2[:50]+chr(13)+chr(10)
                    f.write(wiersz)
                    wiersz='T'+BankNazwa[:50]+BankKonto[:45]+Email[:50]+Nowy+chr(13)+chr(10)
                    f.write(wiersz)
                    f.close()   
