# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_kontrahenci_dane_archiwalne.py
# Purpose:     Przegladanie i usuwanie danych archiwalnych kontrahenta
# Author:      Wojciech Skowron
# Created:     2021/01/26
# RCS-ID:      $Id: fs_kontrahenci_dane_archiwalne.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
012180 - Dane archiwalne
    012181 - Przegldanie
    012182 - Modyfikacja
    012183 - Dodawanie
    012184 - Usuwanie
"""

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Kontrahent': [5, 6], 'DoDnia': [6], }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kontrahenci_dane_archiwalne z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [5, 6]:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])

    if Funkcja == 6:
        DoDnia = rsglobal.Dekoduj(klucze['DoDnia'])

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprDel = ((self.oddzial_id, '012184') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns = ((self.oddzial_id, '012183') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUpd = ((self.oddzial_id, '012182') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprIns
UprSel = ((self.oddzial_id, '012181') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprUpd or UprDel

if stat == 'OK' and not UprSel > 0:
    stat = 'UPR_SEL'

# -------------------------------------------------------------------------------
# --------------------   USUWANIE Z POBRANIEM (6)   -----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprDel > 0:
        stat = 'UPR_DEL'
    else:
        DEL = """DELETE FROM rs_kontrahenci_archiwum_dane_adresowe 
                 WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}'
                       AND do_dnia='{DoDnia}';"""
        DEL = DEL.format(**locals())
        rsglobal.ZapiszDoLogow(DEL)
        stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd usuwania danych: '+stat

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH (5, 6)   -----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [5, 6]:
    SEL = """SELECT do_dnia, nazwa, CONCAT(adr_kod, ' ', adr_miej, ', ', adr_ulica, ' ', adr_nry) 
             FROM rs_kontrahenci_archiwum_dane_adresowe 
             WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}' 
             ORDER BY do_dnia DESC;"""
    SEL = SEL.format(**locals())
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych: '+stat
