# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_kontrahenci_dane_archiwalne_dane.py
# Purpose:     Dodawanie i edycja danych archiwalnych kontrahenta
# Author:      Wojciech Skowron
# Created:     2021/01/26
# RCS-ID:      $Id: fs_kontrahenci_dane_archiwalne_dane.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
012180 - Dane archiwalne
    012181 - Przegldanie
    012182 - Modyfikacja
    012183 - Dodawanie
    012184 - Usuwanie
"""

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Kontrahent': [1, 2, 3, 4, 5, 10, 12, 13], 'DoDnia': [1, 3, 4, 5, 12, 13], }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kontrahenci_dane_archiwalne_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 2, 3, 4, 5, 10, 12, 13]:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])

    if Funkcja in [1, 3, 4, 5, 12, 13]:
        DoDnia = rsglobal.Dekoduj(klucze['DoDnia'])

# -------------------------------------------------------------------------------
# -----------------------------   UPRAWNIENIA   ---------------------------------
# -------------------------------------------------------------------------------

UprDel = ((self.oddzial_id, '012184') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns = ((self.oddzial_id, '012183') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUpd = ((self.oddzial_id, '012182') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprIns
UprSel = ((self.oddzial_id, '012181') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprUpd or UprDel

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH (1, 3)   --------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprIns > 0 and Funkcja in (1, 2):
        stat = 'UPR_INS'
    if not UprUpd > 0 and Funkcja in (3, 4):
        stat = 'UPR_UPD'

    if stat == 'OK':
        for pole, wart in zip(pola, wartosci):
            if pole == 'do_dnia':
                if wart in ('', '-  -', '    -  -  ', 'None'):
                    stat = 'BR_DO_DNIA'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DO_DNIA'
                    dane.append(stat)
                else:
                    SQL = """SELECT 1 FROM rs_kontrahenci_archiwum_dane_adresowe  
                             WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}' 
                                   AND do_dnia='{wart}';"""
                    SQL = SQL.format(**locals())
                    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) > 0:
                            stat = "BL_KLUCZ"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'nazwa':
                if wart.strip() == '':
                    stat = "BR_NAZWA"
                    dane.append(stat)

            elif pole == 'kraj':
                if wart.strip() == '':
                    stat = "BR_KRAJ"
                    dane.append(stat)
                else:
                    SQL = "SELECT kraj FROM rs_kraje WHERE kraj = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KRAJ"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'krajk':
                if wart.strip() != '':
                    SQL = "SELECT kraj FROM rs_kraje WHERE kraj = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KRAJK"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------------   INSERT (1)   ------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2):
    INS = "INSERT INTO rs_kontrahenci_archiwum_dane_adresowe "
    Pola = "firma_id, kontrahent_id "
    Wartosci = "'{self.firma_id}', '{Kontrahent}'".format(**locals())

    for pole, wart in zip(pola, wartosci):
        Pola += ","+pole
        Wartosci += ",'"+str(wart).replace("'", "`")+"'"

    INS += "("+Pola+") VALUES ("+Wartosci+");"

    stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd dodania danych: '+stat
        dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# --------------------------   UPDATE (3)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    UPD = "UPDATE rs_kontrahenci_archiwum_dane_adresowe SET "
    DoDniaNowa = DoDnia

    for pole, wart in zip(pola, wartosci):
        UPD += pole+"='"+str(wart).replace("'", "`")+"',"

        if pole == 'do_dnia':
            DoDniaNowa = wart

    UPD = UPD[0:-1]
    UPD += " WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}' AND do_dnia='{DoDnia}';".format(**locals())

    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(UPD)
    if stat != 'OK':
        stat = 'Bad modyfikacji danych:' + stat
        dane.append(stat)
    else:
        DoDnia = DoDniaNowa

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH (1, 3, 5)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    if not UprSel > 0:
        stat = 'UPR_SEL'

    if stat == 'OK':
        SEL = """SELECT * FROM rs_kontrahenci_archiwum_dane_adresowe
                WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}' AND do_dnia='{DoDnia}';"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat

    if stat == 'OK':
        Kraj = KrajK = ''

        tr = rssql.RSTableRowset2(dane, wyn1)[0]

        if ((self.oddzial_id,'011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            SQL = "SELECT nazwa FROM rs_kraje WHERE kraj='"+tr["kraj"]+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                Kraj = 'Bd pobrania opisu kraju: '+stat
            else:
                if len(d) == 0:
                    Kraj = 'Bdny kod kraju'
                else:
                    Kraj = str(d[0][0])
        else:
            Kraj = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if ((self.oddzial_id,'011070') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            SQL = "SELECT nazwa FROM rs_kraje WHERE kraj='"+tr["krajk"]+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                KrajK = 'Bd pobrania opisu kraju: '+stat
            else:
                if len(d) == 0:
                    KrajK = 'Bdny kod kraju'
                else:
                    KrajK = str(d[0][0])
        else:
            KrajK = 'Brak uprawnie do sownika. Poinformuj administratora.'

        wyn2 = [Kraj, KrajK]

# -------------------------------------------------------------------------------
# --------------   POBRANIE AKTUALNYCH DANYCH KONTRAHENTA (10)   ----------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    SEL = """SELECT * FROM rs_kontrahenci
             WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}';"""
    SEL = SEL.format(**locals())
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania aktualnych danych kontrahenta: '+stat

# -------------------------------------------------------------------------------
# -----------------   POBRANIE NAZW KOLUMN TABELI (11, 12)   --------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (11, 12):
    SEL = """SELECT DISTINCT column_name FROM information_schema.columns 
             WHERE table_name='rs_kontrahenci_archiwum_dane_adresowe' 
                   AND column_name NOT LIKE 'z_%' AND column_name not in ('firma_id', 'kontrahent_id', 'do_dnia');"""
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Wystpi bd podczas pobrania listy pl do archiwizacji: '+stat
    else:
        dane = [wiersz[0] for wiersz in dane]

# -------------------------------------------------------------------------------
# -----------   ZAPIS WIERSZA Z RS_KONTRAHENCI DO ARCHIWUM (12)   ---------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    if not UprIns > 0:
        stat = 'UPR_INS'

    if len(dane) == 0:
        stat = 'Bd zapisu danych kontrahenta do archiwum'
    else:
        ListaPol = ', '.join(dane)

        INS = """INSERT INTO rs_kontrahenci_archiwum_dane_adresowe (firma_id, kontrahent_id, do_dnia, {ListaPol})
                 SELECT firma_id, kontrahent_id, '{DoDnia}', {ListaPol} 
                 FROM rs_kontrahenci WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}';"""
        INS = INS.format(**locals())
        rsglobal.ZapiszDoLogow(INS)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd zapisu danych kontrahenta do archiwum: '+stat

# -------------------------------------------------------------------------------
# ----------   SPRAWDZENIE CZY WPIS Z DAT DO JU ISTNIEJE (13)   ---------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 13:
    SQL = """SELECT 1 FROM rs_kontrahenci_archiwum_dane_adresowe  
             WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}' 
                   AND do_dnia='{DoDnia}';"""
    SQL = SQL.format(**locals())
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bdy sprawdzania danych: '+stat
    elif len(dane) > 0:
        stat = "BL_KLUCZ"
