# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrachenci_dane_dodatkowe.py
# Purpose:     wywietlanie i modyfikowanie danych dodatkowych kontrahenta 
# Author:      Pawe Wjcikowski / przejscie na fun
# Created:     2009/06/22
# RCS-ID:      $Id: fs_kontrachenci_dane_dodatkowe.py $
# Copyright:   (c) 2009 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012.01.11 Mariusz Rajfura  (5376)  nowe pole: potwierdzenie_sald
# 2021-01-31 Wojciech Skowron (12288) Zapis do archiwum
# 2021-02-01 Wojciech Skowron         Podmiana "'" na "`" przy dodawaniu i edycji dla pl tekstowych

from funkcje import fs_ftp_obsluga

Kontrahent=rsglobal.Dekoduj(klucze[0])

Fun=klucze[-1]
stat = "OK"
Dane = [] 
  
UprEdycja=((self.oddzial_id,'012022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    FTPNazwa = rsglobal.Dekoduj(klucze[2])
    if not UprEdycja:
        stat="UPR UPD"

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    
        if stat=="OK":               
            if pole=='krajk':
                if wart<>'':
                    SQL="SELECT kraj FROM rs_kraje WHERE kraj = '"+wart+"';"
                    stat,dane2,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if len(dane2)==0:                          
                            stat = "BL KRAJ"
                            dane.append(stat)                        
                    else:
                        stat = 'Bdy sprawdzania danych:'+stat
                        dane.append(stat)


    #WS 2021-01-31 - zapis do archiwum
    if stat == 'OK':
        DoDnia = rsglobal.Dekoduj(klucze[1])
        if DoDnia not in ('', '-  -', '    -  -  ', 'None'):
            Klucze = {}
            Klucze['Funkcja'] = 12
            Klucze['Kontrahent'] = Kontrahent
            Klucze['DoDnia'] = DoDnia
            stat, dump, dump, dump = self.WykonajFunkcje("fs_kontrahenci_dane_archiwalne_dane",
                                                         Klucze, [], [], RobicCommit=False)
            if stat != 'OK':
                dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

    if stat=='OK':
        where = " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'; "
        upd = "UPDATE rs_kontrahenci SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole == 'ftp_katalog':
                if wart.strip() != '':
                    if 'ftp_nazwa' in pola:
                        nazwa = wartosci[pola.index('ftp_nazwa')]
                    else:
                        SQL = """SELECT ftp_nazwa 
                        FROM rs_kontrahenci
                        WHERE firma_id='{}' AND kontrahent_id='{}';""".format(self.firma_id, Kontrahent)
                        stat, ftp_nazwa, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        rsglobal.ZapiszDoLogow(SQL)
                        if stat != 'OK':
                            stat = 'Bad pobierania nazwy ftp z bazy: ' + stat
                            dane.append(stat)
                        else:
                            nazwa = ftp_nazwa[0][0]
                            if nazwa in ('', None):
                                stat = 'Nie podano nazwy ftp'
                                dane.append(stat)
                    if stat == 'OK':
                        rsglobal.ZapiszDoLogow("sprawdzanie sciezki '{}' dla configu '{}'".format(wart, nazwa))
                        if not fs_ftp_obsluga.sprawdzSciezke(wart.strip('/'), z_configu=nazwa, rsgl=rsglobal):
                                stat = 'W ftp: {} nie ma folderu: {}'.format(nazwa, wart)
                                dane.append(stat)
                        else:
                            upd = upd + pole + "='" + wart + "',"
                else:
                    upd = upd + pole + "='" + wart + "',"

            elif wart=='    -  -  ' or wart=='':
                upd=upd+pole+"=NULL,"
            elif wart in (True,False):
                upd=upd+pole+"="+str(wart)+","
            else:
                #WS 2021-02-01
                upd=upd+pole+"='"+wart.replace("'", "`")+"',"
                # upd=upd+pole+"='"+wart+"',"

        if len(dane) > 0:
            stat = dane[0]

        if stat == 'OK':
            upd = upd[0:len(upd)-1]+where
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
            if stat<>'OK':
                stat = 'Bdy modyfikowania danych:'+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,3 -select)
#-------------------------------------------------------------------------------

if (Fun in [5,3]) and (stat=='OK'):
    # pobranie danych kontrahenta
    Select= "SELECT * FROM rs_kontrahenci WHERE kontrahent_id='"+Kontrahent+"' AND firma_id='"+self.firma_id+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych:'+stat
        dane.append(stat)

#-#############################################################################################
# obsuga komsera, gdy wprowadzano zmiany, jest OK i jest odpowiedni wpis w rs_komser_funkcje
#-#############################################################################################
if stat == "OK" and Fun in (3, 4) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    stat, synchronizuj, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_kontrahenci_dane'", 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif synchronizuj:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], ["fs_kontrahenci_dane_dodatkowe", klucze, pola, wartosci])
