# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_dane_fakturowe_dane.py
# Purpose:     wczytuje/edytuje dane fakturowe kontrahenta
# Author:      Micha Raburski
# Created:     2005/12/20
# RCS-ID:      $Id: fs_kontrahenci_dane_fakturowe_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2010-11-08 Marcin Natkaski - (4056) refaktoryzacja kodu
# 2011-02-28 Mariusz Rajfura  - (4317) pobranie domyslnej wartosci dla pola 'maks_wart' z tabel
#                                      systemowych postgresa zamiast ze 'schema'
# 2011-03-01 Mariusz Rajfura  - (4323) nowe pole 'priorytet'
# 2011-04-20 Mariusz Rajfura  - (4513) nowe pole 'tworzyc_zaleglosc'
# 2011-07-11 Mariusz Rajfura  - (4748) nowe pole 'drukowac_poziom_zwrotow'
# 2011-10-20 Mariusz Rajfura  - (5125) zezwolenie na brak wyznacznika przy zapisie
# 2012-01-10 Mariusz Rajfura  - (5364) nowe pole 'zamowienie' 
# 2012-06-21 Micha Raburski  - (5863) nowe pole 'sort_wg_symboli_obcych' 
# 2012-07-13 Mariusz Rajfura  - (5910) nowe pole 'nie_uzupelniac_dat_wplywu' 
# 2012-08-31 Mariusz Rajfura  - (6029) nowe pola 'waluta_sprzedaz','waluta_zakup' 
# 2012-09-21 Mariusz Rajfura  - (6096) nowe pole 'tylko_numery_dowodow_dostaw' 
# 2013-01-29 Mariusz Rajfura  - (6481) nowe pola: dni_po_terminie,kwota_blokady,od_kiedy_sprawdzac_date
# 2014-01-09 Micha Raburski  - (7548) pole limit_zwrotow_faktury
# 2014-02-11 Konrad Opieka    - (7673) pole korekta_z_data_dowodu
# 2016-03-06 Piotr Witkowski  - (9628) Pole "zwroty-dni" w danych do fakturowania kontrahenta
# 2017-10-16 Rafa Woniak    - (10781) Checkbox z czy konto Vat, przy dodawaniu przenosi si z poprzedniego
# 2018-06-06 Aleksander Bargie - (11082) MPP od dnia w danych do fakurowania
# 2018-08-14 Aleksander Bargie - (11177) Wycofa zbdne informacje o MPP
# 2018-12-11 Aleksander Bargie - (11317) zmiany w oknie Kontrahenci->Dane do fakturowania
# 2019-07-01 Wojciech Skowron   - (11534) pole 'spodziewane_dni_opoznienia'
# 2020-05-06 Mikoaj Kozowski  - (11963) obsuga pola 'czy_drukowac_opakowania_na_dd'
# 2020-12-03 Mikoaj Kozowski  - (12206) obsuga pola 'czy_zbiorcza_dla_oddzialow'
# 2020-12-04 Mikoaj Kozowski  - (12206) usunicie obsugi pola 'czy_zbiorcza_dla_oddzialow'
# 2021-01-04 Wojciech Skowron   - (12236) nowe pole 'format_dowodu_dostawy' (Format wydruku dowodu)
# 2021-01-15 Aleksander Bargie (12268) [SP] Automatyczne potwierdzanie korekt.
# 2021-01-28 Jan Raburski - (12296) Dopuszczenie -1 w zwroty-dni
# 2022-11-05 Jan Raburski - (13238) pola dotyczce informacji o blokadzie (blokada...)

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

from funkcje import fs_global_konta

#--- klucze to [Kontrahent,Data,Polecenie]
Kontrahent = rsglobal.Dekoduj(klucze[0])
Data = rsglobal.Dekoduj(klucze[1])
Fun = klucze[-1]

#--- uprawnienia
UprDod = ((self.oddzial_id, '012043') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja = (((self.oddzial_id, '012042') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDod
  

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#--- POBRANIE DOMYLNEJ WARTOCI DLA POLA 'maks_wart' i NAJWYSZEJ DATY (10)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    # JR ustawienie -1 na sztywno zamiast selecta
    #sql ="SELECT pg_get_expr(adbin, adrelid),'' FROM pg_attribute atr"
    #sql+=" INNER JOIN pg_attrdef AD on (AD.adrelid = atr.attrelid AND AD.adnum = atr.attnum)"
    #sql+=" WHERE atr.attrelid=(SELECT oid FROM pg_class WHERE relname='rs_kontrahenci_fakturowanie')"
    #sql+=" AND atr.attstattarget=-1 AND atr.attname='maks_wart';"
    
    #stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
    if stat != 'OK':
        stat = 'Bd pobrania domylnej wartoci dla limitu: '+stat
        dane.append(stat)
    else:
        #konwersja do wygodnej postaci liczbowej
        #dane[0][0] = float(str(dane[0][0]).replace('(','').replace(')',''))
        #AB 06.06.18r - zamiana tab na spacje
        #dane = [-1] * 2
        dane = [[-1, '']]
        #dane.append([-1])
        #---pobieranie daty ostatnich danych z fakturowania
        zapytanie = "SELECT data_od FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
        zapytanie += " AND kontrahent_id='"+Kontrahent+"' ORDER BY data_od DESC LIMIT 1;"
        stat, d, dump, dump = self.PolSQL.Execute(zapytanie, 3)
        if stat != 'OK':
            stat = 'Bd pobrania ostatnich danych dla fakturowania: '+stat
            dane = [stat]
        elif len(d) == 1:
            dane[0][1] = d[0][0]
            #dane.append(d[0][0])
            
            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---  SPRAWDZENIE DANYCH (1,2 - insert; 3,4 - update)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [1, 2, 3, 4, 5] and (stat == "OK"):
    dane = []
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]         
        #wyznacznik
        if pole == 'wyznacznik':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego wyznacznik '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL WYZN"
                    dane.append(stat)
        #wersja            
        elif pole == 'wersja':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego wersj cenow '+stat
                    dane.append(stat)                    
                elif len(d) == 0:
                    stat = "BL WERSJA"
                    dane.append(stat)                    
        #sposb zapaty           
        elif pole == 'spos_zaplaty':
            if wart == '':
                stat = "BR SPZ"
                dane.append(stat)
            else:
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego sposb zapaty '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL SPZ"
                    dane.append(stat)                    
        #sposb dostawy            
        elif pole == 'spos_dostawy':
            if wart == '':
                stat = "BR SPD"
                dane.append(stat)
            else:
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego wersj cenow '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL SPD"
                    dane.append(stat)                    
        # handlowiec         
        elif pole == 'handlowiec':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego wersj cenow '+stat
                elif len(d) == 0:
                    stat = "BL HANDL"
                    dane.append(stat)                    
        # sposb odbioru faktury
        elif pole == 'sposob_odbioru_faktury':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego sposoby odbioru faktury '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL SOF"
                    dane.append(stat)                    
        # identyfikator projektu            
        elif pole == 'projekt_id':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego identyfikator projektu'+stat
                    dane.append(stat)  
                elif len(d) == 0:
                    stat = "BL PROJ"
                    dane.append(stat)       
        #identyfikator konta         
        elif pole == 'konto_id':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego identyfikator konta'+stat
                    dane.append(stat)  
                elif len(d) ==0:
                    stat = "BL KONTO"
                    dane.append(stat)
        #wersja detaliczna
        elif pole == 'wersja_detaliczna':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego detaliczn wersj cenow '+stat
                    dane.append(stat)       
                elif len(d) == 0:
                    stat = "BL WERSJA DET"
                    dane.append(stat)                    
        #warto limitu
        elif pole == 'maks_wart':
            if wart < 0:
                if wart != -1:
                    stat = 'BL MAKS WART MINUS'
                    dane.append(stat)
        #priorytet
        elif pole == 'priorytet':
            if not wart in xrange(0, 10):
                stat = 'BL PRIORYTET'
                dane.append(stat)
        #format wydruku dowodu  #WS 2021-01-04
        elif pole == 'format_dowodu_dostawy':
            if not wart.strip().upper() in ('', 'L'):
                stat = 'BL FORMATWYDRUKUDOSTAWY'
                dane.append(stat)
            else:
                wartosci[i] = wart.strip().upper()
        #limit zwrotw faktury
        elif pole == 'limit_zwrotow_faktury':
            if not wart in xrange(0,101):
                stat = 'BL LIMITZWFAKT'
                dane.append(stat)
        #data od
        elif pole == 'data_od':
            if wart == '    -  -  ':
                wart = '1970-01-01'
            if wart == '0001-01-01':
                wart = '2001-01-01'
            #podmiana skorygowanego klucza i wartosci pola
            Data = wart
            wartosci[i] = wart                            
            if wart!='    - -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    stat = "BL DATA"
                    dane.append(stat)
            if Fun in [1, 2]:
                dump, d, dump,dump = self.PolSQL.Execute("SELECT data_od FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+klucze[0]+"' AND data_od='"+wart+"';", 3)
                if len(d) != 0:
                    stat = "UZ DATA"
                    dane.append(stat)
        #patno subkonto
        elif pole =='platnosc_subkonto':
            if wart != '':
                Wynik = fs_global_konta.SprawdzIstnienieKonta(self,wart)
                if Wynik == 0:
                    stat = "BL SUBKONTO"
                    dane.append(stat)
                elif Wynik == 1:
                    stat = "BR NAZWY SUBKONTA"
                    dane.append(stat)
                elif Wynik != 2:
                    stat='Bd funkcji analizujcej subkonto patnoci' 
                    dane.append(stat)
        #zamowienie
        elif pole == 'zamowienie':
            if wart != '':
                sql = "SELECT opis FROM rs_wyznaczniki"
                sql +=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"'"
                sql +=" AND typ_faktury='ZO';"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego wyznacznik '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL ZAMOWIENIE"
                    dane.append(stat)
        #waluta sprzedazy
        elif pole == 'waluta_sprzedaz':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE kod='"+wart+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego walut sprzeday '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BL WALUTA_SPRZEDAZ"
                    dane.append(stat)                    
        #waluta zakupu
        elif pole == 'waluta_zakup':
            if wart != '':
                stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE kod='"+wart+"';" , 3)
                if stat != 'OK':
                    stat = 'Bdy zapytania sprawdzajcego walut zakupu '+stat
                    dane.append(stat)
                if len(d) == 0:
                    stat = "BL WALUTA_ZAKUP"
                    dane.append(stat)                    
        # od kiedy sprawdzac
        elif pole == 'od_kiedy_sprawdzac':
            if wart != '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    stat = "BL OD KIEDY SPRAWDZAC"
                    dane.append(stat)
        # zwroty dni
        elif pole =='zwroty_dni':
            if wart < -1 and wart >365:
                stat = "BL ZWROTY DNI"
                dane.append(stat)
        #WS 2019-07-01
        elif pole == 'spodziewane_dni_opoznienia':
            if wart < 0:
                stat = 'BL SPODZIEWANE DNI OP'
                dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]    
              
    #filtr dla UPDATE i SELECT  (po ewentualnej zmianie wartoci zmiennej Data)                  
    where = " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
    where += " AND data_od='"+Data+"'"   
             
                                
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [1, 2]:
    if not UprDod:
        stat = 'UPR INS'
        dane.append(stat)
    if stat == 'OK':
        ins = "INSERT INTO rs_kontrahenci_fakturowanie"
        Pola = "firma_id,kontrahent_id"
        Wartosci = "'"+self.firma_id+"','"+Kontrahent+"'"

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ['wyznacznik', 'wersja', 'spos_zaplaty', 'spos_dostawy',
                        'handlowiec', 'sposob_odbioru_faktury', 'projekt_id',
                        'format_dowodu_dostawy',  #WS 2021-01-04
                        #AB 14.08.18r
                        'konto_id',  #'konto_vat_id',
                        'wersja_detaliczna', 'platnosc_subkonto', 'blokada_email', 'blokada_tel',
                        'zamowienie', 'waluta_sprzedaz', 'waluta_zakup', 'platnosc_subkonto_skrot']:
                Pola += ","+pole
                if wart == '':
                    Wartosci += ",NULL"
                else:    
                    Wartosci += ",'"+wart+"'"

            elif pole in ['dni', 'upust', 'maks_wart', 'czy_upow', 'czy_fakt',
                          'czy_zbiorcza', 'czy_osobna', 'czy_z_dostaw',
                          'rozliczac_zwroty', 'czy_ceny_na_dowodach', 'czy_wg_indeksow',
                          'cena_przed_upustem', 'blokada_zwrotow', 'zaleglosci_dowody_dostaw',
                          'zaleglosci_mail', 'priorytet', 'tworzyc_zaleglosc',
                          'drukowac_poziom_zwrotow', 'sort_wg_symboli_obcych',
                          'nie_uzupelniac_dat_wplywu', 'potwierdzac_automatycznie_korekte', 'tylko_numery_dowodow_dostaw',#AB 15.01.21r
                          'dni_po_terminie', 'kwota_blokady',
                          'spodziewane_dni_opoznienia', #WS 2019-07-01
                          'limit_zwrotow_faktury', 'zwroty_dni', 'blokada_info',
                          'korekta_z_data_dowodu', 'drukowac_palety_na_dd', "osobny_rachunek_vat",
                            #AB 13.12.18r
                          'czy_drukowac_faktury', 'czy_pdf_faktury', 'czy_pdf_z_dowodami_dostaw',
                          'czy_skany_dowodow_dostaw', 'czy_drukowac_korekty', 'czy_pdf_korekty',
                          'czy_drukowac_opakowania_na_dd']: #MK 2020-05-06
                Pola += ","+pole
                Wartosci += ","+str(wart)

            elif pole in ['data_od']:
                Pola += ","+pole
                if wart == '    -  -  ':
                    Wartosci += ",'1970-01-01'"
                else:
                    Wartosci += ",'"+wart+"'"

            #AB 06.06.18r dodanie mpp_od_dnia i konto_vat_id ???
            elif pole in ['od_kiedy_sprawdzac', 'mpp_od_dnia']:
                Pola += ","+pole
                if wart == '    -  -  ':
                    Wartosci += ",NULL"
                else:
                    Wartosci += ",'"+wart+"'"

        ins += " ("+Pola+") VALUES ("+Wartosci+");"
        rsglobal.ZapiszDoLogow(ins)
        stat, dump, dump, dump = self.PolSQL.Execute(ins, 1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(stat)
        if stat != 'OK':
            stat = u'Bdy zapytania dodajcego dane '+stat
            dane.append(stat)
        
                    
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [3, 4]:
    if not UprEdycja:
        stat='UPR UPD'
        dane.append(stat)
    if stat == 'OK':
        upd = "UPDATE rs_kontrahenci_fakturowanie SET "        

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ['wyznacznik', 'wersja', 'spos_zaplaty', 'spos_dostawy',
                        'handlowiec', 'sposob_odbioru_faktury', 'projekt_id',
                        'format_dowodu_dostawy',  #WS 2021-01-04
                        #AB 14.08.18r
                        'konto_id',  # 'konto_vat_id',
                        'wersja_detaliczna', 'platnosc_subkonto', 'blokada_email', 'blokada_tel',
                        'zamowienie', 'waluta_sprzedaz', 'waluta_zakup', 'platnosc_subkonto_skrot']:
                if wart == '':
                    upd += pole+"=NULL,"
                else:    
                    upd += pole+"='"+wart+"',"

            elif pole in ['data_od']:
                upd += pole + '='
                if wart == '    -  -  ':
                    upd += "'1970-01-01',"
                else:
                    upd += "'"+wart+"',"

            elif pole in ['dni','upust','maks_wart','czy_upow','czy_fakt',
                          'czy_zbiorcza','czy_osobna','czy_z_dostaw','rozliczac_zwroty',
                          'czy_ceny_na_dowodach','czy_wg_indeksow','cena_przed_upustem',
                          'blokada_zwrotow','zaleglosci_dowody_dostaw','zaleglosci_mail',
                          'priorytet','tworzyc_zaleglosc','drukowac_poziom_zwrotow',
                          'sort_wg_symboli_obcych','nie_uzupelniac_dat_wplywu', 'potwierdzac_automatycznie_korekte',  #AB 15.01.21r
                          'tylko_numery_dowodow_dostaw','dni_po_terminie',
                          'spodziewane_dni_opoznienia', #WS 2019-07-01
                          'limit_zwrotow_faktury','zwroty_dni',
                          'korekta_z_data_dowodu','drukowac_palety_na_dd',"osobny_rachunek_vat",
                #AB 13.12.18r
                          'czy_drukowac_faktury', 'czy_pdf_faktury', 'czy_pdf_z_dowodami_dostaw',
                          'czy_skany_dowodow_dostaw', 'czy_drukowac_korekty', 'czy_pdf_korekty',
                          'czy_drukowac_opakowania_na_dd', 'blokada_info']:  #MK 2020-05-06
                upd += pole+"="+str(wart)+","

            elif pole in ['kwota_blokady']:
                # ze wzgledu na dlugosc pola
                upd += pole+"="+repr(wart)+","

            #AB 06.06.18r dodanie mpp_od_dnia i konto_vat_id
            elif pole in ['od_kiedy_sprawdzac', 'mpp_od_dnia']:
                if wart == '    -  -  ':
                    upd += pole+"=NULL,"
                else:
                    upd += pole+"='"+wart+"',"

        upd = upd[0:len(upd)-1]+where
        stat, dump, dump, dump = self.PolSQL.Execute(upd , 1)
        if stat != 'OK':
            stat = u'Bdy zapytania zmieniajcego dane '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun in [1, 3, 5] and (stat == 'OK'):
    # pobranie danych fakturowych kontrahenta
    stat, dane, wyn1, tr = self.PolSQL.Execute("SELECT * FROM rs_kontrahenci_fakturowanie "+where+" ;", 3)
    if stat != 'OK':
        stat=u'Bdy zapytania pobierajcego dane '+stat
        dane.append(stat)
    #pobranie danych do opisow
    elif len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- wyznacznik (0)
        if ((self.oddzial_id, '021000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id
            +"' AND wyznacznik_id='"+tr.GetVal(0,"wyznacznik")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu wyznacznika ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika wyznacznikw. Poinformuj administratora.')

        #--- wersja (1)
        if ((self.oddzial_id, '011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu wersji ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika wersji cenowych. Poinformuj administratora.')

        #--- sposb zapaty (2)
        if ((self.oddzial_id, '011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_zaplaty")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu sposobu zapaty ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika sposobw zapaty. Poinformuj administratora.')

        #--- sposb dostawy (3)
        if ((self.oddzial_id, '011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_dostawy")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu sposobu dostawy ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika sposobw dostawy. Poinformuj administratora.')
        
        #--- handlowiec (4)
        if ((self.oddzial_id, '011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu handlowca ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika handlowcw. Poinformuj administratora.')

        #--- sposb odbioru faktury (5)
        if ((self.oddzial_id, '011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu sposobu odbioru faktury ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika sposobw odbioru faktury. Poinformuj administratora.')
            
        #--- projekt (6)
        if ((self.oddzial_id, '027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            projekt=tr.GetVal(0, "projekt_id")
            if not projekt in ('', 'None', None):
                stat, d, dump, dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+projekt+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy podczas pobierania opisu projektu ' + stat
                    dane.append(stat)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('')
        else:
            wyn2.append('Brak uprawnie do sownika projektw. Poinformuj administratora.')
        
        #--- konto id (7)
        if ((self.oddzial_id, '014050') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            KontoId = tr.GetVal(0, "konto_id")
            if not KontoId in ('', 'None', None):
                stat, d, dump, dump = self.PolSQL.Execute("SELECT bank FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+KontoId+"';" ,3)
                if stat != 'OK':
                    stat = 'Bdy podczas pobierania opisu konta ze sownika ' + stat
                    dane.append(stat)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('')
        else:
            wyn2.append('Brak uprawnie do sownika kont. Poinformuj administratora.')
            
        #--- wersja detaliczna (8)
        if ((self.oddzial_id, '011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja_detaliczna")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu detalicznej wersji cenowej ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika wersji cenowych. Poinformuj administratora.')

        #--- zamowienie (9)
        if ((self.oddzial_id, '021000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id
            +"' AND wyznacznik_id='"+tr.GetVal(0,"zamowienie")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu wyznacznika ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika wyznacznikw. Poinformuj administratora.')

        #--- waluta sprzedazy (10)
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE kod='"+tr.GetVal(0,"waluta_sprzedaz")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu waluty sprzeday ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika walut. Poinformuj administratora.')

        #--- waluta zakupu (11)
        if ((self.oddzial_id, '011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE kod='"+tr.GetVal(0,"waluta_zakup")+"';" ,3)
            if stat != 'OK':
                stat = 'Bdy podczas pobierania opisu waluty zakupu ze sownika ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika walut. Poinformuj administratora.')

# ----------------  sprawdzamy czy dane maj by przesyane dalej

if stat == "OK" and Fun in (1, 2, 3, 4, 6) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    if Fun in (1, 3):
        klucze[-1] += 1
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_kategorie_fakturowanie'", 4)
    rsglobal.ZapiszDoLogow(stat)
    rsglobal.ZapiszDoLogow(jest)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], [funkcja, klucze, pola, wartosci])
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(odp)