# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kontrahenci_dekrety.py
# Purpose:     obsuga edytowalnego grida z cenami dostaw z oddziaw
# Author:      Aleksander Bargie
# Created:     2020/12/07
# RCS-ID:      $Id: fs_kontrahenci_dekrety.py$
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
import rsglobal
from funkcje import fs_okresy_pom

stat = 'OK'

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    
    SlPar = {'Kontrahent': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kontrahenci_dekrety z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1, 5]:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])

        
dane = []
wyn1 = []
wyn2 = []

Puste = (None, '', '    -  -  ', 'None', '-  -')

Insert = []
Update = []
Delete = []
UprPrzegl = ((self.oddzial_id, '012190') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']
    UprMod = ((self.oddzial_id, '012192') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


def SprawdzIstnienieWzoruDekretacji(self, dowod_id, nazwa_id):
    from funkcje import fs_okresy_pom
    stat, Okres = fs_okresy_pom.PodajOkresDlaDaty(self, rsglobal.PodajDzis())
    if stat != 'OK':
        return stat
    sql = """SELECT 1 FROM rs_wzory_dekretacji 
             WHERE (firma_id, okres_id, dowod_id, nazwa_id) = (%s, %s, %s, %s);"""
    args = [self.firma_id, str(Okres), str(dowod_id), str(nazwa_id)]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
    stat, nazwa_dane, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        return "Bd wprawdzania wzoru dekretacji: "+stat
    elif len(nazwa_dane) == 0:
        return "Nie odnaleziono wzoru dekretacji {} {} w w okresie ksigowym {}".format(dowod_id, nazwa_id, Okres)
    else:
        return 'OK'


# -------------------------------------------------------------------------------
# -------  SPRAWDZANIE DELETE  --------------------------------------------------
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'BR UPR MOD'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kontrahenci_dekrety "
                WHERE = " WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['dokument_kod', ]:
                        WHERE += " AND "+pole+" = '"+wart+"'"

                SQLDEL += DELETE + WHERE + "; "
            
            if stat == 'OK' and SQLDEL  != '':
                stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL), 1)
                if stat  != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
# -------------------------------------------------------------------------------
# ---   UPDATE DANYCH (1)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat = 'BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                wartosci = Update[1][i]
                pola     = Update[0][i]
                rsglobal.ZapiszDoLogow(Update)
                dokument_kod = wartosci[pola.index('dokument_kod')].strip() if 'dokument_kod' in pola else None
                dowod_id     = wartosci[pola.index('dowod_id')].strip()     if 'dowod_id'     in pola else None
                nazwa_id     = wartosci[pola.index('nazwa_id')].strip()     if 'nazwa_id'     in pola else None
                rsglobal.ZapiszDoLogow(dowod_id, nazwa_id)
                if dokument_kod is not None:
                    if dokument_kod in Puste:
                        stat = 'BR DOK'
                        wyn2.append((WierszeNr[i], 0))
                        dane.append(stat)
                    else:
                        sql = "SELECT kod FROM rs_wf_rodzaje_dokumentow "
                        sql+= " WHERE firma_id = '"+self.firma_id+"' AND kod = '"+dokument_kod+"';"
                        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                        if stat  != 'OK':
                            stat = 'BL SQL DOK'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'BL KOD DOK$'+dokument_kod
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                if dowod_id is not None:
                    if dowod_id is not None and nazwa_id is None:
                        sql = """SELECT nazwa_id FROM rs_kontrahenci_dekrety
                                 WHERE firma_id = %s and kontrahent_id = %s and dokument_kod = %s;"""
                        args = [self.firma_id, str(Kontrahent), str(Update[2][i][Update[3].index('dokument_kod')])]
                        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
                        stat, nazwa_dane, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd pobierania nazwy wzoru dekretacji: ' + stat
                            wyn2.append((WierszeNr[i], 1))
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        elif len(nazwa_dane) == 0:
                            stat = 'Brak nazwy dekretacji do pobrania.'
                            wyn2.append((WierszeNr[i], 1))
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        else:
                            nazwa_id = nazwa_dane[0][0]
                    if dowod_id not in Puste and nazwa_id in Puste:
                        stat = 'Dla wzoru dekretacji naley uzupeni dowd i nazw'
                        wyn2.append((WierszeNr[i], 1))
                        wyn2.append((WierszeNr[i], 2))
                        if stat not in dane:
                            dane.append(stat)
                    if dowod_id == '' and nazwa_id not in Puste:
                        stat = 'Dla wzoru dekretacji naley uzupeni dowd i nazw'
                        wyn2.append((WierszeNr[i], 1))
                        wyn2.append((WierszeNr[i], 2))
                        if stat not in dane:
                            dane.append(stat)
                if nazwa_id is not None:
                    if nazwa_id is not None and dowod_id is None:
                        sql = """SELECT dowod_id FROM rs_kontrahenci_dekrety
                                 WHERE firma_id = %s and kontrahent_id = %s and dokument_kod = %s;"""
                        args = [self.firma_id, str(Kontrahent), str(Update[2][i][Update[3].index('dokument_kod')])]
                        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
                        stat, dowod_dane, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
                        rsglobal.ZapiszDoLogow(dowod_dane)
                        if stat != 'OK':
                            stat = 'Bd pobierania id dowodu wzoru dekretacji: ' + stat
                            wyn2.append((WierszeNr[i], 1))
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        elif len(dowod_dane) == 0:
                            stat = 'Brak id dowodu do pobrania.'
                            wyn2.append((WierszeNr[i], 1))
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        else:
                            dowod_id = dowod_dane[0][0]
                    if nazwa_id not in Puste and dowod_id in Puste:
                        stat = 'Dla wzoru dekretacji naley uzupeni dowd i nazw'
                        wyn2.append((WierszeNr[i], 1))
                        wyn2.append((WierszeNr[i], 2))
                        if stat not in dane:
                            dane.append(stat)
                    if nazwa_id == '' and dowod_id not in Puste:
                        stat = 'Dla wzoru dekretacji naley uzupeni dowd i nazw'
                        wyn2.append((WierszeNr[i], 1))
                        wyn2.append((WierszeNr[i], 2))
                        if stat not in dane:
                            dane.append(stat)

                if dowod_id not in Puste and nazwa_id not in Puste:
                    stat = SprawdzIstnienieWzoruDekretacji(self, dowod_id, nazwa_id)
                    if stat != 'OK':
                        wyn2.append((WierszeNr[i], 1))
                        wyn2.append((WierszeNr[i], 2))
                        dane.append(stat)
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat == 'OK':
                    sql = ''
                    UPDATE = "UPDATE rs_kontrahenci_dekrety "
                    SET = 'SET '
                    for j in xrange(len(Update[0][i])): 
                        pole = Update[0][i][j]
                        wart = Update[1][i][j]
    
                        if pole in ['dokument_kod', 'dowod_id', 'nazwa_id']:
                            SET += pole+" = "+rsglobal.ZmienNaNULL(wart)+", "
                            
                    SET = SET.strip(", ")
                    WHERE = " WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"' "
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole = Update[3][j]
                        wart = rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['dokument_kod', ]:
                            WHERE += " AND "+pole+" = '"+wart+"'"
                        
                    WHERE += ";"
                        
                    sql += UPDATE+SET+WHERE
                        
                    stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
                    if stat != 'OK':
                        stat = "Bd modyfikacji danych: "+stat
                        dane.append(stat)
                    

# -------------------------------------------------------------------------------
# ---------Sprawdzanie danych do Insert------
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    if len(Insert[0]) > 0:
        if not UprMod:
            stat = 'BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole = Insert[1][j]
                    wart = Insert[0][i][j]

                    if pole == 'dokument_kod':
                        wart = wart.strip()
                        if wart in Puste:
                            stat = 'BR DOK'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        else:
                            sql  = "SELECT kod FROM rs_wf_rodzaje_dokumentow "
                            sql += " WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                            if stat  != 'OK':
                                stat = 'BL SQL DOK'
                                wyn2.append((WierszeNr[i], 0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL KOD DOK$'+wart
                                wyn2.append((WierszeNr[i], 0))
                                dane.append(stat)
                    elif pole == 'dowod_id':
                        dowod_id = wart.strip()
                    elif pole == 'nazwa_id':
                        nazwa_id = wart.strip()

                if dowod_id not in Puste and nazwa_id not in Puste:
                    stat = SprawdzIstnienieWzoruDekretacji(self, dowod_id, nazwa_id)
                    if stat != 'OK':
                        wyn2.append((WierszeNr[i], 1))
                        wyn2.append((WierszeNr[i], 2))
                        dane.append(stat)
                if dowod_id in Puste and nazwa_id not in Puste or dowod_id not in Puste and nazwa_id in Puste:
                    stat = 'Dla wzoru dekretacji naley uzupeni dowd i nazw'
                    wyn2.append((WierszeNr[i], 1))
                    wyn2.append((WierszeNr[i], 2))
                    if stat not in dane:
                        dane.append(stat)


                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':
                    sqlIns = ''
                    INSERT = "INSERT INTO rs_kontrahenci_dekrety "
                    KOLUMNY = "(firma_id, kontrahent_id"
                    VALUES = " VALUES ('"+self.firma_id+"', '"+Kontrahent+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole = Insert[1][j]
                        wart = Insert[0][i][j]

                        if pole in ['dokument_kod', 'dowod_id', 'nazwa_id']:
                            KOLUMNY += ", "+pole
                            VALUES += ", "+rsglobal.ZmienNaNULL(wart)+""
    
                    KOLUMNY+= ")"
                    VALUES+= ");"
                    sqlIns+= INSERT+KOLUMNY+VALUES
                if stat == 'OK' and sqlIns != '': 
                    stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns), 1)
                    if stat != 'OK':
                        stat = "Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrzegl:
        stat = 'Brak uprawnie do przegldania danych'
        
    if stat == 'OK':
        SQL = "SELECT dokument_kod, dowod_id, nazwa_id "
        SQL+= " FROM rs_kontrahenci_dekrety "
        SQL+= " WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"' "
        SQL+= " ORDER BY dokument_kod, dowod_id, nazwa_id;"
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3)
        if stat  != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            if isinstance(dane, list):
                dane.append(stat)
            else:
                dane = [stat]

# -------------------------------------------------------------------------------
# ---   POBRANIE OKRESU NA DZIS (15)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 15:
    stat, dane = fs_okresy_pom.PodajOkresDlaDaty(self, rsglobal.PodajDzis())
