# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_kuke_pom.py
# Purpose:     funkcje pomocnicze do KUKE
# Author:      Micha Raburski
# Created:     2014/07/28
# RCS-ID:      $Id: fs_kontrahenci_kuke_pom $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
 

# funkcja sprawdza czy kontraehnta danego dnia obejmowao kuke. Jeli tak to sprawdza
# czy suma nieopaconych faktur i suma sprawdzanego dokumentu nie jest wiksza ni przyznany limit.
# wraca z tupl (status,kwota o ile przekroczy)
#2017-10-31 Rafa Woniak (10734) zmiana zapisu do logw z 1 na 5

def SprawdzLimitKuke(self,Kontrahent,Data,Kwota):
    from funkcje import fs_rozrachunki_pom
    import rsglobal
    rsglobal.ZapiszDoLogow('!!!! Sprawdzam KUKE',5)
    
    Kontrahent = rsglobal.Dekoduj(Kontrahent)
    KwotaPrzekroczenia = 0
    stat='OK'
    
    # pobranie konta odbiorcy z kontrahenta
    SQL="SELECT COALESCE(konto_odbiorca,'') FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND kontrahent_id='"+Kontrahent+"';"
    stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('1 stat '+stat,5)
    if stat <> 'OK':
        return 'Bd pobrania konta odbiorcy kontrahenta '+stat,0
    
    if len(DKontr) == 0:
        return 'Brak podanego kontrahenta :'+Kontrahent,0
    
    if DKontr[0][0] == '':
        return 'OK',0
    rsglobal.ZapiszDoLogow('2 '+stat,5)
    Konto = DKontr[0][0].strip('-')+'-'+Kontrahent
    
    # pobranie limitu dla kontrahenta
    SQL="SELECT kwota FROM rs_kontrahenci_kuke WHERE firma_id = '"+self.firma_id+"'"
    SQL+=" AND kontrahent_id = '"+Kontrahent+"' AND data_od <= '"+Data+"' AND data_do >= '"+Data+"'"
    SQL+= "AND (data_przerwania IS NULL OR data_przerwania > '"+Data+"') AND NOT prywatny ORDER BY nazwany DESC;"
    stat,DKwota,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bd pobrania limitu kontrahenta '+stat,0
    
    # nie ma limitu kuke
    if len(DKwota) == 0:
        return 'OK',0
    
    KwotaLimit = DKwota[0][0]
    rsglobal.ZapiszDoLogow('3 '+stat,5)
    # pobranie okresu dla daty
    stat,Okresy = fs_rozrachunki_pom.PodajOkresyDlaRozrachunkowDlaDaty(self.PolSQL,self.firma_id,Data)
    if stat <> 'OK':
        return stat,0
    
    # pobranie aktualnej wykorzystanej kwoty limitu z rozrachunkw
    SQL ="SELECT SUM(saldo_wn) FROM rs_rozrachunki r "
    SQL+=" WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id IN ("+Okresy+") AND r.konto='"+Konto+"'"
    SQL+=" AND r.data_rozlicz IS NULL AND r.saldo_wal_wn > 0;"
    stat,DWykorz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bd pobrania wykorzystanego limitu kontrahenta '+stat,0
    rsglobal.ZapiszDoLogow('4 '+stat,5)
    # porwnanie kwot
    KwotaWyk = 0
    if len(DWykorz) > 0:
        rsglobal.ZapiszDoLogow('AAASD '+str(DWykorz),5)
        KwotaWyk = DWykorz[0][0]
    
    if KwotaWyk+Kwota > KwotaLimit:
        KwotaPrzekroczenia = KwotaWyk+Kwota - KwotaLimit
    
    return stat,KwotaPrzekroczenia