# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_trasy_dane.py
# Purpose:     dodaje/edytuje trase dla kontrahenta
#
# Author:      Marcin Grzeda
# Created:     2006/11/13
# RCS-ID:      $Id: fs_kontrahenci_trasy_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

Kontrahent = rsglobal.Dekoduj(klucze[0])
Trasa = rsglobal.Dekoduj(klucze[1])
Data_Od = rsglobal.Dekoduj(klucze[2])

Fun = klucze[-1]

UprDodawanie = (self.oddzial_id,'012053') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprEdycja = (self.oddzial_id,'012052') in self.uprawnienia or UprDodawanie

sqlupdate = ''
sqlinsertpola = ''
sqlinsertwart = ''

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat = 'UPR INS'
        
if Fun in (3,4):
    if not UprEdycja:
        stat = 'UPR UPD'

#-------------------------------------------------------------------------------
#--- SPRAWDZANIE POPRAWNOSCI DANYCH
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == "OK":
    if Trasa == '':
        stat = 'BR TRAS'
        dane.append(stat)
        
    if Data_Od == '':
        stat = 'BR DATAOD'
        dane.append(stat)
    else:
        if not rsglobal.SprawdzCzyToData(Data_Od):
            stat='BL DATAOD'
            dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT kod FROM rs_trasy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+Trasa+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania opisu trasy : '+stat
        
        if stat == 'OK':        
            if len(d) == 0:
                stat = 'BL TRA'
                dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT trasa FROM rs_kontrahenci_trasy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND trasa = '"+Trasa+"'"
        sql+=" AND data_od = '"+Data_Od+"' AND kontrahent_id = '"+Kontrahent+"';" 
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania listy trasy dla kontrahenta : '+stat
            dane.append(stat)
    
    if stat == 'OK':
        if len(d) > 0:
            stat = 'BL UZYW'
            dane.append(stat)
            
if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        robsql = False
        
        if pole == 'data_do':
            robsql = True
            if wart == '    -  -  ':
                wart = 'NULL'
            else:
                if not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL DATADO'
                    dane.append(stat)
                else:
                    if wart < Data_Od:
                        stat = 'REL DAT'
                        dane.append(stat)
                    else:    
                        wart = "'"+wart+"'"
        if robsql:                
            if Fun in (1,2):
                sqlinsertpola += pole+","            
                sqlinsertwart += wart+","
                
            elif Fun in (3,4):
                sqlupdate += pole+" = "+wart+","
                
#-------------------------------------------------------------------------------
#---- INSERT DANYCH (2- bez pobierania, 1- z pobieraniem
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK' and sqlinsertpola <> '':
    sql ="INSERT INTO rs_kontrahenci_trasy"
    sql+=" (firma_id,kontrahent_id,trasa,data_od,"+sqlinsertpola[:-1]+")"
    sql+=" VALUES ('"+self.firma_id+"','"+Kontrahent+"','"+Trasa+"','"+Data_Od+"',"+sqlinsertwart[:-1]+");"
    stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
    if stat <> 'OK':
        stat = 'BL INS'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK' and sqlupdate <> '':
    sql ="UPDATE rs_kontrahenci_trasy SET "+sqlupdate[:-1]
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
    sql+=" AND trasa = '"+Trasa+"' AND data_od = '"+Data_Od+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
    if stat <> 'OK':
        stat = 'BL UPD'

#-------------------------------------------------------------------------------
#--- ZMIANA KLUCZA - 9
#-------------------------------------------------------------------------------

if Fun == 9:
    #poprzednie wartosci trasa, data_od
    TrasaP = rsglobal.Dekoduj(klucze[3])
    Data_OdP = rsglobal.Dekoduj(klucze[4])
    
    if not ((self.oddzial_id,'012055') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'UPR ZM KLUCZ'
        dane.append(stat)
    
    if stat == 'OK':
        if Trasa == '':
            stat = 'BR TRA'
            dane.append(stat)
            
    if stat == 'OK':
        if Data_Od == '':
            stat = 'BR DATAOD'
            dane.append(stat)
        else:
            if not rsglobal.SprawdzCzyToData(Data_Od):
                stat='BL DATAOD'
                dane.append(stat)
        
    if stat == 'OK':
        sql ="SELECT kod FROM rs_trasy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+Trasa+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        
        if stat <> 'OK':
            stat = 'Bd pobrania opisu trasy : '+stat
            dane.append(stat)
        
        if stat == 'OK':
            if len(d) == 0:
                stat = 'BL TRA'
                dane.append(stat)
        
    if stat == 'OK':
        sql ="SELECT trasa FROM rs_kontrahenci_trasy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
        sql+=" AND trasa = '"+Trasa+"' AND data_od = '"+Data_Od+"';" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        
        if stat <> 'OK':
            stat='Bd pobrania trasy dla kontrahenta : '+stat
            dane.append(stat)
    
    if stat == 'OK':
        if len(d) > 0:
            stat = 'BL UZYW'
            dane.append(stat)
            
    if stat == 'OK':
        zmiany = 0
        sql ="UPDATE rs_kontrahenci_trasy SET"
        
        if Trasa <> TrasaP:
            sql+=" trasa = '"+Trasa+"'"
            zmiany += 1
            
        if Data_Od <> Data_OdP:
            if zmiany > 0:
                sql+=","
            sql+=" data_od = '"+Data_Od+"'"
            zmiany += 1
        
        if zmiany > 0:
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
            sql+=" AND trasa = '"+TrasaP+"' AND data_od = '"+Data_OdP+"';" 
            stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
            if stat <> 'OK':
                stat='BL ZM KLUCZ'
                dane.append(stat)
   
#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (5-select, 3-update z pobr, 1-insert z pobr, 9 -zmiana klucza)
#-------------------------------------------------------------------------------

if Fun in (1,3,5,9) and stat == 'OK':
    sql ="SELECT * FROM rs_kontrahenci_trasy WHERE trasa = '"+Trasa+"'"
    sql+=" AND firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
    sql+=" AND data_od = '"+Data_Od+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)

    #pobranie danych do opisow
    if stat == 'OK' and len(dane) == 1:
        
        #opis trasy
        if (self.oddzial_id,'011040') in self.uprawnienia or \
           self.operator_id == STANDARD_OPERATOR_ID:
                
            sql ="SELECT opis FROM rs_trasy"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+Trasa+"';"
            
            st,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if st <> 'OK':
                wyn2.append('Bd pobrania opisu trasy : '+st)
            else:
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
