# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_upusty_dane.py
# Purpose:     wczytuje/edytuje/dodaje wzgldniajc uprawnienia operatora 
#
# Author:      Jarek Plawgo
# Created:     2006/03/27
# RCS-ID:      $Id: fs_kontrahenci_upusty_dane.py $
# Copyright:   (c) 2005 Cybertronika
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-11-16 Mariusz Rajfura  nowe pola: rabat_finansowy, rabat_finansowy_indeks (5209)
# 2011-11-21 Mariusz Rajfura  pobranie opisow slownikowych przy odczycie (5213)


def SprNakladanieDat(self, Fun, Kontrahent, Artykul, Data_Od, Data_Do):
    stat = 'OK'
    sql = ''
    
    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        
        sql ="SELECT artykul_id FROM rs_kontrahenci_upusty"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND kontrahent_id = '"+Kontrahent+"' AND artykul_id = '"+Artykul+"'"
        
        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        sql+=" AND ("
        sql+=" ( data_do IS NOT NULL AND '"+Data_Od+"' > data_od AND '"+Data_Od+"' <= data_do )"
        
        #jesli podano date do
        if Data_Do <> 'NULL':
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            sql+=" OR (data_od > '"+Data_Od+"' AND data_od <= '"+Data_Do+"' )"
            
            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            sql+=" OR (data_do IS NOT NULL AND data_do >= '"+Data_Od+"' AND data_do <= '"+Data_Do+"' )"
            
            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            sql+=" OR (data_do IS NOT NULL AND '"+Data_Do+"' > data_od AND '"+Data_Do+"' <= data_do)"
        sql+=");"
    
    #sprawdzenie unikalnosci zakresow przed UPDATE
    
    #jesli data_do z konkretnej zmieni sie na NULL, to nie trzeba
    #nic sprawdzac, bo klucz jest bez zmian, a okres bedzie obowiazywac
    #do kolejnej daty_od lub do konca swiata (i jeszce jeden dzien)
    
    if Fun in (3,4) and Data_Do <> 'NULL':
    
        sql ="SELECT artykul_id FROM rs_kontrahenci_upusty"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND kontrahent_id = '"+Kontrahent+"' AND artykul_id = '"+Artykul+"'"
        
        #wykluczenie z SELECT modyfikowanej pozycji
        sql+=" AND data_od <> '"+Data_Od+"' AND ("
        
        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" (data_od > '"+Data_Od+"' AND data_od <= '"+Data_Do+"' )"
            
        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR (data_do IS NOT NULL AND data_do >= '"+Data_Od+"' AND data_do <= '"+Data_Do+"' )"
            
        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR (data_do IS NOT NULL AND '"+Data_Do+"' > data_od AND '"+Data_Do+"' <= data_do));"
    
    if sql <> '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania listy upustw dla kontrahenta : '+stat
        
        if stat == 'OK':
            if len(d) > 0:
                stat = 'BL_NAKL_DAT'
    
    return stat            

#-------------------------------------------------------------------------------

Kontrahent = rsglobal.Dekoduj(klucze[0]).strip()
Artykul = rsglobal.Dekoduj(klucze[1]).strip()
Data_Od = rsglobal.Dekoduj(klucze[2]).strip()
Fun = klucze[-1]

Data_Do = None
Upust = ''
RabatFinansowy = 0
RabatFinansowyIndeks = "NULL"

stat = 'OK'

UprDodawanie = (self.oddzial_id,"012073") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprEdycja = (self.oddzial_id,"012072") in self.uprawnienia or UprDodawanie or self.operator_id == STANDARD_OPERATOR_ID 

#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat = 'BR_UPR_INS'

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR_UPR_UPD'

#-------------------------------------------------------------------------------
#-------- Sprawdzenie poprawnoci danych
#-------------------------------------------------------------------------------

if stat == 'OK':
    if Kontrahent == '':
        stat = 'BR_KTH'   
        dane.append(stat) 
        
if stat == 'OK':    
    if Artykul == '':
        stat = 'BR_ART'   
        dane.append(stat)
    else:    
        sql ="SELECT artykul_id FROM rs_artykuly"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Artykul+"';"
                  
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania danych artykuu : '+stat
            dane.append(stat)
        else:
            if len(d) == 0:
                stat = 'BL_ART'   
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2):
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'data_do':
            if wart == '    -  -  ':
                Data_Do = 'NULL'
            else:
                Data_Do = wart
                if rsglobal.SprawdzCzyToData(Data_Do):
                    if Data_Od > Data_Do:
                        stat = 'BL_ZAKR_DAT'   
                        dane.append(stat)
                else:
                    stat = 'BL_DATAOD'
                    dane.append(stat)
                                
        elif pole == 'upust':
            if wart < 0 or wart >=100:
                stat = 'BL_UPUST'   
                dane.append(stat)
            else:    
                Upust = wart

        elif pole == 'rabat_finansowy':
            if wart < 0 or wart >=100:
                stat = 'BL_RABAT_FINANSOWY'   
                dane.append(stat)
            else:
                RabatFinansowy = wart

        elif pole == 'rabat_finansowy_indeks':
            wart = wart.strip()
            if wart <> '':
                RabatFinansowyIndeks = "'"+wart+"'"
                sql ="SELECT artykul_id FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia indeksu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_RABAT_FINANSOWY_INDEKS'
                    dane.append(stat)
            else:
                RabatFinansowyIndeks = "NULL"

    
    if stat == 'OK':
        stat = SprNakladanieDat(self, Fun, Kontrahent, Artykul, Data_Od, Data_Do)
        if stat <> 'OK':
            dane.append(stat)
    
    if stat == 'OK':    
        sql ="SELECT artykul_id FROM rs_kontrahenci_upusty"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
        sql+=" AND artykul_id = '"+Artykul+"' AND data_od = '"+Data_Od+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania upustu artykuu dla kontrahenta : '+stat
            dane.append(stat)
        else:
            if len(d) > 0:    
                stat = "BL_ISTN_UPUST"   
                dane.append(stat)
                
    if stat == 'OK':
        if Data_Do <> 'NULL':
            Data_Do = "'"+Data_Do+"'"
            
        INS ="INSERT INTO rs_kontrahenci_upusty"
        INS+=" (firma_id,kontrahent_id,artykul_id,data_od,data_do,upust,"
        INS+="  rabat_finansowy, rabat_finansowy_indeks)"
        INS+=" VALUES"
        INS+="('"+self.firma_id+"','"+Kontrahent+"','"+Artykul+"','"+Data_Od+"',"+Data_Do+","+str(Upust)+","
        INS+="  "+str(RabatFinansowy)+","+RabatFinansowyIndeks+");"
        
        stat,d,dump,dump = self.PolSQL.Execute(INS,1)
        if stat <> 'OK':
            stat = 'Bd dodawania upustu do artykuu dla kontrahenta : '+stat
            dane.append(stat) 


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobieraniem,4- bez pobierania)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3,4):
    UPD = "UPDATE rs_kontrahenci_upusty SET "
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'data_do':
           if wart == '    -  -  ':
               wart = 'NULL'
               Data_Do = wart
               UPD += pole + ' = NULL,'
           else:    
                if rsglobal.SprawdzCzyToData(wart):
                    if Data_Od > wart:
                        stat = 'BL_ZAKR_DAT'   
                        dane.append(stat)
                    else:
                        Data_Do = wart
                        UPD += pole+" = '"+str(wart)+"',"
                else:
                    stat = 'BL_DATADO'
                            
        elif pole == 'upust':
            if wart < 0 or wart >= 100:
                stat = 'BL_UPUST'   
                dane.append(stat)
            else:    
                UPD += pole+" = "+str(wart)+","

        elif pole == 'rabat_finansowy':
            if wart < 0 or wart >=100:
                stat = 'BL_RABAT_FINANSOWY'   
                dane.append(stat)
            else:
                UPD += pole+"="+str(wart)+","

        elif pole == 'rabat_finansowy_indeks':
            wart = wart.strip()
            if wart <> '':
                UPD += pole+"='"+str(wart)+"',"
                sql ="SELECT artykul_id FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia indeksu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_RABAT_FINANSOWY_INDEKS'
                    dane.append(stat)
            else:
                UPD += pole+"=NULL,"
    
    if stat == 'OK' and Data_Do <> None:
        stat = SprNakladanieDat(self, Fun, Kontrahent, Artykul, Data_Od, Data_Do)
        if stat <> 'OK':
            dane.append(stat)
                
    if stat == 'OK':
        UPD = UPD[:-1]
        UPD+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
        UPD+=" AND artykul_id = '"+Artykul+"' AND data_od = '"+Data_Od+"';"
        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji upustu artykuu dla kontrahenta : '+stat
            dane.append(stat) 


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,3,5):
    sql ="SELECT * FROM rs_kontrahenci_upusty"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
    sql+=" AND artykul_id = '"+Artykul+"' AND data_od = '"+Data_Od+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = '5.Bd pobrania danych upustu do artykuu dla kontrahenta : '+stat
        dane.append(stat) 

    #pobranie danych do opisow
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- artykul [0]
        if ((self.oddzial_id,'013000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<> 'OK':
                stat='Bd pobrania opisu artykuu: ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do katalogi artykuw. Poinformuj administratora.')

        #--- parat_finansowy_indeks [1]
        if ((self.oddzial_id,'013000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND artykul_id='"+tr.GetVal(0,"rabat_finansowy_indeks")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<> 'OK':
                stat='Bd pobrania opisu indeksu: ' + stat
                dane.append(stat)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do katalogi artykuw. Poinformuj administratora.')
