# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_upusty_kategorie_dane.py
# Purpose:     wczytuje/edytuje/dodaje/usuwa wzgldniajc uprawnienia operatora 
#
# Author:      Jarek Plawgo
# Created:     2006/03/27
# RCS-ID:      $Id: fs_kontrahenci_upusty_kategorie_dane.py $
# Copyright:   (c) 2005 Cybertronika
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def SprNakladanieDat(self, Fun, Kontrahent, Kategoria, Data_Od, Data_Do):
    stat = 'OK'
    sql = ''
    
    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        
        sql ="SELECT kateg_artykulu FROM rs_kontrahenci_upusty_kateg"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND kontrahent_id = '"+Kontrahent+"' AND kateg_artykulu = '"+Kategoria+"'"
        
        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        sql+=" AND ("
        sql+=" ( data_do IS NOT NULL AND '"+Data_Od+"' > data_od AND '"+Data_Od+"' <= data_do )"
        
        #jesli podano date do
        if Data_Do <> 'NULL':
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            sql+=" OR (data_od > '"+Data_Od+"' AND data_od <= '"+Data_Do+"' )"
            
            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            sql+=" OR (data_do IS NOT NULL AND data_do >= '"+Data_Od+"' AND data_do <= '"+Data_Do+"' )"
            
            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            sql+=" OR (data_do IS NOT NULL AND '"+Data_Do+"' > data_od AND '"+Data_Do+"' <= data_do)"
        sql+=");"
    
    #sprawdzenie unikalnosci zakresow przed UPDATE
    
    #jesli data_do z konkretnej zmieni sie na NULL, to nie trzeba
    #nic sprawdzac, bo klucz jest bez zmian, a okres bedzie obowiazywac
    #do kolejnej daty_od lub do konca swiata (i jeszce jeden dzien)
    
    if Fun in (3,4) and Data_Do <> 'NULL':
    
        sql ="SELECT kateg_artykulu FROM rs_kontrahenci_upusty_kateg"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND kontrahent_id = '"+Kontrahent+"' AND kateg_artykulu = '"+Kategoria+"'"
        
        #wykluczenie z SELECT modyfikowanej pozycji
        sql+=" AND data_od <> '"+Data_Od+"' AND ("
        
        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" (data_od > '"+Data_Od+"' AND data_od <= '"+Data_Do+"' )"
            
        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR (data_do IS NOT NULL AND data_do >= '"+Data_Od+"' AND data_do <= '"+Data_Do+"' )"
            
        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR (data_do IS NOT NULL AND '"+Data_Do+"' > data_od AND '"+Data_Do+"' <= data_do));"
    
    if sql <> '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania listy upustw dla kontrahenta i kategorii artykuw : '+stat
        
        if stat == 'OK':
            if len(d) > 0:
                stat = 'BL_NAKL_DAT'
    
    return stat            

#-------------------------------------------------------------------------------

Kontrahent = rsglobal.Dekoduj(klucze[0]).strip()
Kategoria = rsglobal.Dekoduj(klucze[1]).strip()
Data_Od = rsglobal.Dekoduj(klucze[2]).strip()
Fun = klucze[-1]

Data_Do = None
Upust = ''
stat = 'OK'

UprDodawanie = (self.oddzial_id,"012083") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprEdycja = (self.oddzial_id,"012082") in self.uprawnienia or UprDodawanie or \
            self.operator_id == STANDARD_OPERATOR_ID 

#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat = 'BR_UPR_INS'

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR_UPR_UPD'

#-------------------------------------------------------------------------------
#-------- Sprawdzenie poprawnoci danych
#-------------------------------------------------------------------------------

if stat == 'OK':
    if Kontrahent == '':
        stat = 'BR_KTH'   
        dane.append(stat) 
        
if stat == 'OK':    
    if Kategoria == '':
        stat = 'BR_KATEG'   
        dane.append(stat)
    else:    
        sql ="SELECT kod FROM rs_kateg_artykulow"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+Kategoria+"';"
                  
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania kategorii artykuu : '+stat
            dane.append(stat)
        else:
            if len(d) == 0:
                stat = 'BL_KATEG'   
                dane.append(stat)
if stat=='OK':
    if Data_Od=='    -  -  ':
        stat='Brak daty od'
        dane.append(stat)  
    else:
        if not rsglobal.SprawdzCzyToData(Data_Od):
            stat='Bdna data od'
            dane.append(stat)              
    

#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2):

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'data_do':
            if wart == '    -  -  ':
                Data_Do = 'NULL'
            else:
                Data_Do = wart
                if rsglobal.SprawdzCzyToData(Data_Do):
                    if Data_Od > Data_Do:
                        stat = 'BL_ZAKR_DAT'   
                        dane.append(stat)
                else:
                    stat = 'BL_DATAOD'
                    dane.append(stat)
                                
        elif pole == 'upust':
            if wart < 0 or wart >= 100:
                stat = 'BL_UPUST'   
                dane.append(stat)
            else:    
                Upust = wart
                
    if stat == 'OK':
        stat = SprNakladanieDat(self, Fun, Kontrahent, Kategoria, Data_Od, Data_Do)
        if stat <> 'OK':
            dane.append(stat)
    
    if stat == 'OK':    
        sql ="SELECT kateg_artykulu FROM rs_kontrahenci_upusty_kateg"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
        sql+=" AND kateg_artykulu = '"+Kategoria+"' AND data_od = '"+Data_Od+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania upustu dla kontrahenta i kategorii artykuw : '+stat
            dane.append(stat)
        else:
            if len(d) > 0:    
                stat = "BL_ISTN_UPUST"   
                dane.append(stat)
                
    if stat == 'OK':
        if Data_Do <> 'NULL':
            Data_Do = "'"+Data_Do+"'"
            
        sql ="INSERT INTO rs_kontrahenci_upusty_kateg"
        sql+=" (firma_id,kontrahent_id,kateg_artykulu,data_od,data_do,upust)"
        sql+=" VALUES"
        sql+="('"+self.firma_id+"','"+Kontrahent+"','"+Kategoria+"','"+Data_Od+"',"+Data_Do+","+str(Upust)+");"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,1)
        if stat <> 'OK':
            stat = 'Bd dodawania upustu dla kontrahenta i kategorii artykuw : '+stat
            dane.append(stat) 

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobieraniem,4- bez pobierania)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3,4):

    sql = "UPDATE rs_kontrahenci_upusty_kateg SET "
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'data_do' and stat=='OK':
           if wart == '    -  -  ':
               wart = 'NULL'
               Data_Do = wart
               sql += pole + ' = NULL,'
           else:
                if rsglobal.SprawdzCzyToData(wart):
                    if Data_Od > wart:
                        stat = 'BL_ZAKR_DAT'   
                        dane.append(stat)
                    else:
                        Data_Do = wart
                        sql += pole+" = '"+str(wart)+"',"
                else:
                    stat = 'BL_DATADO'
                            
        elif pole == 'upust' and stat=='OK':
            if wart < 0 or wart >= 100:
                stat = 'BL_UPUST'   
                dane.append(stat)
            else:    
                sql += pole+" = "+str(wart)+","
                
    if stat == 'OK' and Data_Do <> None:
        stat = SprNakladanieDat(self, Fun, Kontrahent, Kategoria, Data_Od, Data_Do)
        if stat <> 'OK':
            dane.append(stat)
                
    if stat == 'OK':
        sql = sql[0:len(sql)-1]
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
        sql+=" AND kateg_artykulu = '"+Kategoria+"' AND data_od = '"+Data_Od+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji upustu dla kontrahenta i kategorii artykuw : '+stat
            dane.append(stat) 

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,3,5):
    
    sql ="SELECT data_od,data_do,kateg_artykulu,upust,z_op_id,z_czas"
    sql+=" FROM rs_kontrahenci_upusty_kateg"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"'"
    sql+=" AND kateg_artykulu = '"+Kategoria+"' AND data_od = '"+Data_Od+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania upustu dla kontrahenta i kategorii artykuw : '+stat
        dane.append(stat) 
