#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:          fs_korekty.py
# Purpose:       dodaje/pobiera/usuwa korekty
# Author:        Jakub Krajniak, Micha Raburski
# Created:       2006/10/22
# RCS-ID:        $Id: fs_korekty.py $
# Copyright:     (c) 2006 RecordSystem
# Licence:       GNU GPL
#-------------------------------------------------------------------------------
#2008-04-24 - zmiana funkcji tak by obsugiwana by problem z  sekwencj w zalegociach
#2009-02-20 - sprawdzanie przed zamknieciem, czy cos sie zmienilo w korekcie Dariusz Boduch (1234) 
#2011-04-20 - tworz.zaleglosci w zalez.od danych do fakturowania  Mariusz Rajfura (4513)
#2011-07-07 - 'Niepotwierdzone' (data_przyjecia) do filtru na gridzie Mariusz Rajfura (4742)
#2011-09-16 - blokada SELECT FOR UPDATE  Mariusz Rajfura (4928)
#2011-11-23 - uszczelnienie: sprawdzenie przed zmiana stanu  Mariusz Rajfura (5078)
#2012-07-16 - wpisanie dat powierdzenia korekt (5912)
# 2019-10-15 Aleksander Bargie (11681) Zmiany w zamykaniu faktur i korekt ze wzgldu na mpp
# 2020-01-15 Aleksander Bargie (11822) [SP] Filtr na opis w korektach
# 2021-01-15 Aleksander Bargie (12268) [SP] Automatyczne potwierdzanie korekt.
# 2021-03-31 Jan Raburski (12428) KOntrola opisu z W na G
# 2023-12-04 Wojciech Skowron (13623) Przy zamykaniu sprawdzenie czy zaliczka_pozostalo <= kwocie do zwrotu
#                                     i pomniejszenie zaliczka_pozostalo o kwot do zwrotu
# 2023-12-13 Wojciech Skowron (13646) Poprawka przy zamykaniu elif len(danef) > 0 zamiast else
# 2023-12-14 Wojciech Skowron (13647) Poprawka dla korekt do korekt zaliczkowych

from funkcje import fs_korekty_pom

Wyzn=klucze[0]
Data=klucze[1]
Numer=str(klucze[2])
Stan=klucze[3]

WyznF=klucze[4]
DataOdF=klucze[5]
DataDoF=klucze[6]
PlatnikF=klucze[7]
KontrF=klucze[8]
StanF=klucze[9]
NiewyslaneF=klucze[10]
klucze_id=klucze[11]
NiepotwierdzoneF=klucze[12]
OpisF=klucze[13]
KorektaDoPotwierdzenia=klucze[14]

Fun=klucze[-1]
stat = "OK"
dane = []

puste_pola = ['    -  -  ','',[]]
format_daty = "%Y-%m-%d"

# dla komser
def dolozDodatkoweDane(dodatkoweDane, nazwa, row, desc):
    nowe = []
    for d, info in zip(row, desc):
        if d == "None":
            d = None
        if info[0] not in ("z_czas", "z_typ", "z_op_id"):
            nowe.append((info[0], d))
    dodatkoweDane.append((nazwa.upper(), nowe))

komserDane = None


if DataOdF != '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdF):
        stat='BL DATAOD'

if DataDoF != '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoF):
        stat='BL DATADO'

#wyznaczniki dla operatora
if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    #sql = "SELECT rsf_podaj_liste_wyznacznikow('"+str(Lista).replace("'",'"')+"','"+str([])+"','"+str([])+"','"+str([])+"');"
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]


#pobranie uprawnie do wyznacznikw dla operatora
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrz=True
        UprEdy=True
        UprDel=True
        UprZam=True
        UprOtw=True
        LPrz=LWyzn
        LEdy=LWyzn
        LDel=LWyzn
        LUpd=LWyzn
        LZam=LWyzn
        LOtw=LWyzn
        LPrz.append('ZASLEPKA')
    else:
        stat,dupr,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie FROM rs_wyznaczniki_upr WHERE firma_id='"+self.firma_id+"' AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+"; ",3)
        if stat=='OK':
            LPrz=['ZASLEPKA']
            LEdy=[]
            LDel=[]
            LUpd=[]
            LZam=[]
            LOtw=[]
            
            UprPrz=(self.oddzial_id,'023010') in self.uprawnienia
            UprEdy=((self.oddzial_id,'023012') in self.uprawnienia or (self.oddzial_id,'022013') in self.uprawnienia)
            UprDel=(self.oddzial_id,'023014') in self.uprawnienia
            UprZam=(self.oddzial_id,'023016') in self.uprawnienia
            UprOtw=(self.oddzial_id,'023017') in self.uprawnienia
            
            for d in dupr:
                if UprPrz:
                    if d[1] or d[2] or d[3] or d[4]:
                        if d[0] in LWyzn:
                            LPrz.append(rsglobal.Dekoduj(d[0]))
                if UprEdy:
                    if d[1] or d[2]:
                        if d[0] in LWyzn:
                            LEdy.append(rsglobal.Dekoduj(d[0]))
                if UprDel:
                    if d[3]:
                        if d[0] in LWyzn:
                            LDel.append(rsglobal.Dekoduj(d[0]))
                if UprZam:
                    if d[5]:
                        if d[0] in LWyzn:
                            LZam.append(rsglobal.Dekoduj(d[0]))
                if UprOtw:
                    if d[6]:
                        if d[0] in LWyzn:
                            LOtw.append(rsglobal.Dekoduj(d[0]))


#pobranie stanu korekty
if stat=='OK' and Fun in [6,7,8,23]:
    if Wyzn != '':
        Select= "SELECT stan FROM rs_korekty WHERE firma_id = '" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "' AND data = '" + Data + "' AND numer = " + Numer       
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        
        if stat=='OK':
            if len(d)==0:
                stat='BR KOR'
                dane.append(stat)
            else:
                Stan=rsglobal.Dekoduj(d[0][0])


#-------------------------------------------------------------------------------
# Pobranie biezacego stanu korekty (23)
#-------------------------------------------------------------------------------

if Fun in [23,] and stat=='OK':
    dane = []
    dane.append(Stan)
                            
                            
#-------------------------------------------------------------------------------
# -- Usuwanie 6 -- #
#-------------------------------------------------------------------------------

if Fun in [6]:
    if not ((UprDel and (Wyzn in LDel)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="UPR DEL"   
        dane.append(stat)
    
    if stat=='OK':    
        if Stan != 'W':
            stat = "BL STANU"
            dane.append(stat)
        
    if stat=='OK':    
        sql = "SELECT stan FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+ "'"
        sql+=" AND data='"+Data+ "' AND numer="+Numer+" AND stan='"+Stan+"'"
        sql+=" FOR UPDATE NOWAIT;"        
        
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Korekta zablokowana przez innego operatora. Usunicie niemoliwe.'
    
    if stat=='OK':        
        if len(d)==0:
            stat='BL KOR PAR'
            dane.append(stat)
        elif d[0][0] != Stan:
            stat='NIEZG STAN'
            dane.append(stat)
        
    if stat=='OK':   
        Select= "SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\""+Wyzn+"\",\""+Data+"\","+str(Numer)+"]','K')"
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        
    if stat=='OK':
        if len(d)>0:
            if d[0][0]<>'OK':
                stat='NUM NOT LAST'
                dane.append(stat)
        
    if stat=='OK':
        sql="UPDATE rs_dokumenty_magazynowe SET k_wyznacznik_id=NULL, k_data=NULL, k_numer=0 WHERE firma_id='"+self.firma_id+"' AND k_wyznacznik_id='"+Wyzn+"' AND k_data='"+Data+"' AND k_numer="+Numer+";"
        Filtr = " firma_id = '" + self.firma_id + "' AND wyznacznik_id = '" + Wyzn + "' AND data = '" + Data + "' AND numer = " + Numer
        
        sql+="DELETE FROM rs_korekty_pozycje_opisowe WHERE "+Filtr+";"
        sql+="DELETE FROM rs_korekty_pozycje WHERE "+Filtr+";"
        sql+="DELETE FROM rs_korekty WHERE "+Filtr+" AND stan='W';"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)


#-------------------------------------------------------------------------------
# -- Zamykanie 7 -- #
#-------------------------------------------------------------------------------

if Fun in [7]:
    if not ((UprZam and (Wyzn in LZam)) or (UprEdy and Stan=='W' and (Wyzn in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        if Stan=='W':
            stat="UPR PRZYG"
        else:
            stat="UPR ZAM"
        dane.append(stat)
            
    NastStan='D'    
    if stat=='OK':
        if Stan == 'W':
            NastStan='G'
        if Stan == 'G':
            NastStan='Z'
        elif Stan in ('Z','K'):
            stat ='BL STANZK'
            dane.append(stat)

    if stat=='OK':         
        if Stan in ('W','G'):
            sql ="SELECT kontrahent_id IS NULL or kontrahent_id='' ,wyznacznik_id IS NULL or wyznacznik_id='',"
            sql+=" zamawiajacy_id IS NULL or zamawiajacy_id='',platnik_id IS NULL or platnik_id='',"
            sql+=" waluta IS NULL or waluta='',sposob_zaplaty IS NULL or sposob_zaplaty='' ,"
            sql+=" tytul_zmniejszenia_podatku IS NULL or tytul_zmniejszenia_podatku='',"
            sql+=" opis IS NULL or trim(opis)=''"  #JR 2021-03-31 (12428)
            sql+=" FROM rs_korekty"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"'"
            sql+=" AND numer="+Numer+" FOR UPDATE NOWAIT;"
                    
            stat,dn,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Korekta jest edytowana przez kogo innego i nie mona zmienia jej stanu'

            if stat == 'OK':
                if len(dn) == 0:
                    stat = "BR KORZ"
            
            if stat == "OK":
                stat,dp,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer,3)        
                stat,do,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer,3)        
                if len(dp)+len(do)==0:
                    stat="BR POZ"
        
            if stat=="OK":
                if dn[0][0]:
                    stat="BR KONTR"
        
            if stat=="OK":
                if dn[0][1]:
                    stat="BR WYZN"
                
            if stat=="OK":
                if dn[0][2]:
                    stat="BR ZAMAW"
        
            if stat=="OK":
                if dn[0][3]:
                    stat="BR PLATNIK"
        
            if stat=="OK":
                if dn[0][4]:
                    stat="BR WALUTA"
        
            if stat=="OK":
                if dn[0][5]:
                    stat="BR SPOSZAPL"
        
            if stat=="OK":
                if dn[0][6]:
                    stat="BR TYT"

            #if stat == "OK":  #JR 20251-03-31 (12428)
            #    if dn[0][7]:  # brak opisu, sprawdzamy, czy w wyzaczniku jest ecod=true
            #        stat, ecod, dump, dump = self.PolSQL.Execute("SELECT ecod FROM rs_wyznaczniki WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + Wyzn + "'", 3)
            #        if stat == 'OK':
            #            if ecod[0][0]:
            #                stat = "W nagwku korekty brak opisu w formacie: Dowd zwrotu (numer) z dnia (RRRR-MM-DD)."

    #WS 2023-12-04
    if stat == 'OK':
        KwotaDoZwrotuZal = 0
        WyznF = DataF = NumerF = ''

        #WS 2023-12-14 - _p -> _o
        FSQL = """SELECT k.wyznacznik_id_o, k.data_o, k.numer_o, wk.czy_korekta_zaliczki, 
                         f.zaliczka_pozostalo, ABS(LEAST(k.do_zaplaty-k.do_zaplaty_p, 0)) AS do_zwrotu
                  FROM rs_korekty k
                  JOIN rs_wyznaczniki wk ON (wk.firma_id=k.firma_id AND wk.wyznacznik_id=k.wyznacznik_id)
                  JOIN rs_faktury f ON (f.firma_id=k.firma_id AND f.wyznacznik_id=k.wyznacznik_id_o and f.data=k.data_o and f.numer=k.numer_o)
                  WHERE k.firma_id='{self.firma_id}' AND k.wyznacznik_id='{Wyzn}' AND k.data='{Data}' AND k.numer={Numer};""".format(**locals())
        stat, danef, wyn1f, dump = self.PolSQL.Execute(FSQL, 3)
        if stat != 'OK':
            stat = "Bd pobrania danych korygowanej faktury"
        elif len(danef) > 0:
            Faktura = rssql.RSTableRowset2(danef, wyn1f)

            WyznF = Faktura[0]['wyznacznik_id_o']
            DataF = Faktura[0]['data_o']
            NumerF = Faktura[0]['numer_o']

            if Faktura[0]['czy_korekta_zaliczki']:
                if Faktura[0]['do_zwrotu'] > Faktura[0]['zaliczka_pozostalo']:
                    stat = "BL ZAL POZOSTALO"
                else:
                    KwotaDoZwrotuZal = Faktura[0]['do_zwrotu']

    #sprawdzanie czy cos si zmienilo na korekcie
    if stat == 'OK':
        #korekta
        SPSQL="SELECT k.wyznacznik_id, k.data, k.numer, COALESCE(CAST (k.kurs_p AS TEXT),'') = COALESCE(CAST(k.kurs AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.nr_tabeli_p AS TEXT),'') = COALESCE(CAST(k.nr_tabeli AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.data_tabeli_p AS TEXT),'') = COALESCE(CAST(k.data_tabeli AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.wersja_p AS TEXT),'') = COALESCE(CAST(k.wersja AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.sposob_zaplaty_p AS TEXT),'') = COALESCE(CAST(k.sposob_zaplaty AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.dni_p AS TEXT),'') = COALESCE(CAST(k.dni AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.data_odbioru_p AS TEXT),'') = COALESCE(CAST(k.data_odbioru AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.upust_p AS TEXT),'') = COALESCE(CAST(k.upust AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.upust_wartosc_p AS TEXT),'') = COALESCE(CAST(k.upust_wartosc AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.upust_wartosc_wal_p AS TEXT),'') = COALESCE(CAST(k.upust_wartosc_wal AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.rabat_p AS TEXT),'') = COALESCE(CAST(k.rabat_p AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.rabat_wartosc_p AS TEXT),'') = COALESCE(CAST(k.rabat_wartosc AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.rabat_wartosc_wal_p AS TEXT),'') = COALESCE(CAST(k.rabat_wartosc_wal AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.kwota_netto_p AS TEXT),'') = COALESCE(CAST(k.kwota_netto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.kwota_vat_p AS TEXT),'') = COALESCE(CAST (k.kwota_vat AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.wartosc_opakowan_p AS TEXT),'') = COALESCE(CAST(k.wartosc_opakowan AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.do_zaplaty_p AS TEXT),'') = COALESCE(CAST(k.do_zaplaty AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.kwota_netto_wal_p AS TEXT),'') = COALESCE(CAST(k.kwota_netto_wal AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.kwota_vat_wal_p AS TEXT),'') = COALESCE(CAST(k.kwota_vat_wal AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.wartosc_opakowan_wal_p AS TEXT),'') = COALESCE(CAST(k.wartosc_opakowan_wal AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(k.do_zaplaty_wal_p AS TEXT),'') = COALESCE(CAST(k.do_zaplaty_wal AS TEXT),'') "
        #pozycje korekty
        SPSQL+="AND COALESCE(CAST(kp.ilosc1_p AS TEXT),'') = COALESCE(CAST(kp.ilosc1 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.ilosc2_p AS TEXT),'') = COALESCE(CAST(kp.ilosc2 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_netto1_p AS TEXT),'') = COALESCE(CAST(kp.cena_netto1 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_netto2_p AS TEXT),'') = COALESCE(CAST(kp.cena_netto2 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_upust1_p AS TEXT),'') = COALESCE(CAST(kp.cena_upust1 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_upust2_p AS TEXT),'')= COALESCE(CAST(kp.cena_upust2 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_brutto1_p AS TEXT),'') = COALESCE(CAST(kp.cena_brutto1 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_brutto2_p AS TEXT),'') = COALESCE(CAST(kp.cena_brutto2 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.upust_p AS TEXT),'') = COALESCE(CAST(kp.upust AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.upust_wartosc_p AS TEXT),'') = COALESCE(CAST(kp.upust_wartosc AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.stawka_vat_p AS TEXT),'') = COALESCE(CAST(kp.stawka_vat AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.wartosc_netto_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_netto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.wartosc_vat_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_vat AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.wartosc_brutto_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_brutto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_wal1_p AS TEXT),'') = COALESCE(CAST(kp.cena_wal1 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_wal2_p AS TEXT),'') = COALESCE(CAST(kp.cena_wal2 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_upust_wal1_p AS TEXT),'') = COALESCE(CAST(kp.cena_upust_wal1 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.cena_upust_wal2_p AS TEXT),'') = COALESCE(CAST(kp.cena_upust_wal2 AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.wartosc_wal_netto_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_wal_netto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(kp.wartosc_wal_brutto_p AS TEXT),'')= COALESCE(CAST(kp.wartosc_wal_brutto AS TEXT),'') "
        #pozycje opisowe korekty
        SPSQL+="AND COALESCE(CAST(ko.opis_pozycji_p AS TEXT),'') = COALESCE(CAST(ko.opis_pozycji AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.stawka_vat_p AS TEXT),'') = COALESCE(CAST(ko.stawka_vat AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.wartosc_netto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_netto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.wartosc_vat_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_vat AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.wartosc_brutto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_brutto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.wartosc_wal_netto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_wal_netto AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.wartosc_wal_vat_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_wal_vat AS TEXT),'') "
        SPSQL+="AND COALESCE(CAST(ko.wartosc_wal_brutto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_wal_brutto AS TEXT),'') "

        SPSQL+="FROM rs_korekty k "
        SPSQL+="LEFT OUTER JOIN rs_korekty_pozycje kp ON (k.firma_id=kp.firma_id AND k.wyznacznik_id=kp.wyznacznik_id AND k.data=kp.data AND k.numer=kp.numer) "
        SPSQL+="LEFT OUTER JOIN rs_korekty_pozycje_opisowe ko ON (k.firma_id=ko.firma_id AND k.wyznacznik_id=ko.wyznacznik_id AND k.data=ko.data AND k.numer=ko.numer) "
 
        SPSQL+="WHERE k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+Wyzn+"' AND k.data='"+Data+"' AND k.numer="+Numer
        stat,DaneSP,dump,dump = self.PolSQL.Execute(SPSQL,3)
  
        Zmiany=False
        for poz in DaneSP:
            if not Zmiany:
                Zmiany= not poz[3]
        
        if not Zmiany:
            stat='Brak zmian na korekcie: '+str(DaneSP[0][0])+"/"+str(DaneSP[0][1])+"/"+str(DaneSP[0][2])[:-1]

    TworzycZaleglosc = True
    if stat == 'OK' and NastStan == 'Z':
        sql ="SELECT kontrahent_id, platnik_id FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
        sql+=" AND data='"+Data+"' AND numer="+Numer+";"
        
        stat,dNagl,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z nagwka korekty: '+stat
            dane.append(stat)
        elif len(dNagl) == 0:
            stat = 'Brak korekty o podanym kluczu.'
            dane.append(stat)
        
        if stat == 'OK':
            # dane dla platnika
            sql ="SELECT tworzyc_zaleglosc FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(dNagl[0][1])+"'"
            sql+=" AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1;"
            
            stat,dTworz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia danych patnika: '+stat
                dane.append(stat)
            elif len(dTworz) == 0 and dNagl[0][1] != dNagl[0][0]:
                # dla platnika nie bylo danych ale jest inny kontrahent
                sql ="SELECT tworzyc_zaleglosc FROM rs_kontrahenci_fakturowanie"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(dNagl[0][0])+"'"
                sql+=" AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1;"
            
                stat,dTworz,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia danych kontrahenta: '+stat
                    dane.append(stat)
                
        if stat == 'OK' and len(dTworz) == 1:
            TworzycZaleglosc = dTworz[0][0]

        
    if stat=="OK":
        Filtr="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+" AND stan='"+Stan+"'; "
        Filtr1="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer+" AND stan='"+NastStan+"'; "
        FiltrF="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznF+"' AND data='"+DataF+"' AND numer="+str(NumerF)+";"  #WS 2023-12-04
        #AB 15.01.21r
        potw = """ data_{typ} = CASE WHEN stan='W' AND (SELECT potwierdzac_automatycznie_korekte 
                               FROM rs_kontrahenci_fakturowanie 
                               WHERE firma_id=k.firma_id AND kontrahent_id IN (k.kontrahent_id, k.platnik_id) 
                               AND data_od <= k."data" ORDER BY data_od DESC, kontrahent_id=k.kontrahent_id LIMIT 1) 
            THEN COALESCE(data_{typ}, DATA) ELSE data_{typ} END """
        sql="UPDATE rs_korekty k SET stan='"+NastStan+"', "+potw.format(typ='odbioru')+", "+potw.format(typ='wplywu')+", czy_mpp=COALESCE(czy_mpp, FALSE)"+Filtr
        # sql="UPDATE rs_korekty SET stan='"+NastStan+"', czy_mpp=COALESCE(czy_mpp OR (abs(do_zaplaty) > 15000 AND COALESCE(termin_zaplaty, data)>='2019-11-01'), FALSE)"+Filtr
        if Stan=='G':
            # komser: sprawdzamy czy dane maj by przesyane dalej
            stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
            if stat != "OK":
                stat = "BL rs_komser_funkcje"
            elif jest:
                komserDane = []
                # komser: zbierzmy dane do przekazania dalej zanim przerobimy je lokalnie
                stat, korekta, desc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty"
                    " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s", 3,
                    (self.firma_id, Wyzn, Data, Numer))
                if stat == "OK":
                    stat, pozycje, pdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_pozycje"
                        " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY nr_poz, nr_ppoz", 3,
                        (self.firma_id, Wyzn, Data, Numer))
                if stat == "OK":
                    stat, pozycjeOp, podesc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_pozycje_opisowe"
                        " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY nr_poz", 3,
                        (self.firma_id, Wyzn, Data, Numer))
                if stat == "OK":
                    stat, DStawkiVAT, stdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_vat"
                        " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY stawka_vat", 3,
                        (self.firma_id, Wyzn, Data, Numer))
                if stat == "OK" and korekta:
                    dolozDodatkoweDane(komserDane, "KOREKTA", korekta[0], desc)
                    for pozycja in pozycje:
                        dolozDodatkoweDane(komserDane, "POZYCJA", pozycja, pdesc)
                    for pozycja in pozycjeOp:
                        dolozDodatkoweDane(komserDane, "POZ_OPI", pozycja, podesc)
                    for pozycja in DStawkiVAT:
                        dolozDodatkoweDane(komserDane, "STAWKA", pozycja, stdesc)

            #WS 2023-12-04
            if KwotaDoZwrotuZal > 0:
                UpdateFaktura = """UPDATE rs_faktury SET zaliczka_pozostalo=zaliczka_pozostalo-{KwotaDoZwrotuZal} {FiltrF}""".format(**locals())
                rsglobal.ZapiszDoLogow("Update zaliczka_pozostalo faktury zal: " + UpdateFaktura)
                sql+=UpdateFaktura

            if TworzycZaleglosc:
                Insert ="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,typ_dok_p,wyznacznik_id_p,data_p,numer_p,oddzial_id,rodzaj,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,opis,numer_z_rs,ureg_kwota)"
                Insert+=" SELECT firma_id,'K',wyznacznik_id,data,numer,typ_dok_p,wyznacznik_id_p,data_p,numer_p,oddzial_id,'Z',kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty-do_zaplaty_p,do_zaplaty_wal-do_zaplaty_wal_p,'',numer_z_rs,0 FROM rs_korekty "+Filtr1
                sql+=Insert
                
            #rsglobal.ZapiszDoLogow(sql,1)

        if stat == "OK":
            stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
            #potencjalnie za numeracja sekwencji w zaleglosciach
            if stat<>'OK':
                #proba zrobienia tego jeszcze raz
                stat,dane,wyn1,wyn2=self.PolSQL.Execute("SELECT setval('rs_zaleglosci_nr_zal_seq', max(nr_zal)) FROM rs_zaleglosci;",1)
                if stat=='OK':
                    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)

#-------------------------------------------------------------------------------
# -- Otwieranie 8 -- #
#-------------------------------------------------------------------------------

if Fun in [8]:
    if not ((UprOtw and (Wyzn in LOtw)) or (UprEdy and Stan=='G' and (Wyzn in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        if Stan=='G':
            stat="UPR EDYC"
        else:
            stat="UPR OTW"
        dane.append(stat)

    if stat=='OK':
        sql ="SELECT stan FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
        sql+=" AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
                
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Korekta jest edytowana przez kogo innego i nie mona zmienia jej stanu'
    
    if stat=='OK':    
        if Stan in ('W','K'):
            stat='BL STAN OTW'
             
    if stat=="OK":
        stat,Dane,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_p='"+Wyzn+"' AND data_p='"+Data+"' AND numer_p="+Numer,3)        
        if len(Dane)>0:
            stat="UZ KOR"

    if stat=="OK":
        stat,Dane,dump,dump = self.PolSQL.Execute("SELECT ureg_kwota FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND typ_dok='K' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)+" ORDER BY ureg_kwota desc",3)
        if len(Dane)>0:
            if Dane[0][0]<>0 or Dane[0][-1]<>0:
                stat='ZAL UREG'
    
    if stat=="OK":
        if Stan=='G':
            sql="UPDATE rs_korekty SET stan='W' WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer
            stat,dump,wyn1,wyn2=self.PolSQL.Execute(sql,1)
        elif Stan=='Z':
            sql="UPDATE rs_korekty SET stan='G' WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Numer
            stat,dump,wyn1,wyn2=self.PolSQL.Execute(sql,1)
            if stat=='OK':
                sql="DELETE FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND typ_dok='K' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)
                stat,dump,wyn1,wyn2=self.PolSQL.Execute(sql,1)
                if stat<>'OK':
                    stat='BL OTW DEL ZAL'
            else:
                stat='BL OTW UPD KOR'

    #WS 2023-12-04
    if stat == 'OK' and Stan == 'Z':
        #WS 2023-12-14 - _p -> _o
        sql = """WITH k AS (SELECT k.wyznacznik_id_o, k.data_o, k.numer_o, wk.czy_korekta_zaliczki, ABS(LEAST(k.do_zaplaty-k.do_zaplaty_p, 0)) AS do_zwrotu
                            FROM rs_korekty k 
                            JOIN rs_wyznaczniki wk ON (wk.firma_id=k.firma_id AND wk.wyznacznik_id=k.wyznacznik_id)
                            WHERE k.firma_id='{self.firma_id}' AND k.wyznacznik_id='{Wyzn}' AND k.data='{Data}' AND k.numer={Numer})
                 UPDATE rs_faktury SET zaliczka_pozostalo=zaliczka_pozostalo+k.do_zwrotu
                 FROM k
                 WHERE firma_id='{self.firma_id}' AND wyznacznik_id=k.wyznacznik_id_o AND data=k.data_o AND numer=k.numer_o AND k.czy_korekta_zaliczki=TRUE;""".format(**locals())
        stat,dump,wyn1,wyn2=self.PolSQL.Execute(sql, 1)
        if stat != 'OK':
            stat = 'BL OTW UPD F'


#-------------------------------------------------------------------------------
#--- zamykanie grupy 9
#-------------------------------------------------------------------------------

if Fun in [9]:
    if not ((UprZam and (Wyzn in LZam)) or (UprEdy and Stan=='W' and (Wyzn in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        if Stan=='W':
            stat="UPR PRZYG"
        else:
            stat="UPR ZAM"
        dane.append(stat)

    if stat=='OK':
        NastStan=''
        if Stan == 'W':
            NastStan='G'
        elif Stan == 'G':
            NastStan='Z'
        elif Stan in ('Z','K'):
            stat ='BL STANZ'
        else:
            stat = "BL STANZ"
                
        if stat=="OK":
            Filtr="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND stan='"+Stan+"'"
            if DataOdF<>'    -  -  ' and DataOdF<>'':
                Filtr=Filtr+" AND data>='"+DataOdF+"'"
            if DataDoF<>'    -  -  ' and DataDoF<>'':    
                Filtr=Filtr+" AND data<='"+DataDoF+"'"
            if self.operator_id != STANDARD_OPERATOR_ID:
                Filtr=Filtr+" AND wyznacznik_id in ("+str(LZam)[1:-1]+")"
            FiltrT=Filtr
            Filtr=Filtr+"; "
            
        if stat=='OK' and Stan=='W':
            #blokada SELECT FOR UPDATE NOWAIT
            sql ="SELECT stan FROM rs_korekty "+FiltrT+" FOR UPDATE NOWAIT;"
            stat,dump,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'W zamykanej grupie jest korekta zablokowana przez innego operatora. Operacja niemoliwa.'

            if stat == 'OK':
                #sprawdzenie czy przy zamykaniu na G wszystkie maj wypeniony tytu zmniejszenia podatku i rne inne rzeczy
                SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||wyznacznik_id||'\",\"'||data||'\",'||numer||']', 'K'),kontrahent_id IS NULL or kontrahent_id='' ,wyznacznik_id IS NULL or wyznacznik_id='',"
                SQL+="zamawiajacy_id IS NULL or zamawiajacy_id='',platnik_id IS NULL or platnik_id='',waluta IS NULL or waluta='',"
                SQL+="sposob_zaplaty IS NULL or sposob_zaplaty='' ,tytul_zmniejszenia_podatku IS NULL or tytul_zmniejszenia_podatku='' "
                SQL+=" FROM rs_korekty "+FiltrT+" AND (kontrahent_id IS NULL or kontrahent_id='' OR wyznacznik_id IS NULL or wyznacznik_id='' OR "
                SQL+=" zamawiajacy_id IS NULL or zamawiajacy_id='' OR platnik_id IS NULL or platnik_id='' OR waluta IS NULL or waluta='' OR "
                SQL+="sposob_zaplaty IS NULL or sposob_zaplaty='' OR tytul_zmniejszenia_podatku IS NULL or tytul_zmniejszenia_podatku='');"
                stat,dn,dump,dump = self.PolSQL.Execute(SQL,3)        
                if len(dn)>0:
                    if stat=="OK":
                        if dn[0][1]:
                            stat="BR KONTR$"+dn[0][0]
            
                    if stat=="OK":
                        if dn[0][2]:
                            stat="BR WYZN$"+dn[0][0]
                
                    if stat=="OK":
                        if dn[0][3]:
                            stat="BR ZAMAW$"+dn[0][0]
            
                    if stat=="OK":
                        if dn[0][4]:
                            stat="BR PLATNIK$"+dn[0][0]
                
                    if stat=="OK":
                        if dn[0][5]:
                            stat="BR WALUTA$"+dn[0][0]
                
                    if stat=="OK":
                        if dn[0][6]:
                            stat="BR SPOSZAPL$"+dn[0][0]
                
                    if stat=="OK":
                        if dn[0][7]:
                            stat="BR TYT$"+dn[0][0]

                #dane do sprawdzenia czy bya zmiana w korekcie 
                #sprawdzanie czy cos si zmienilo na korekcie
                    
                if stat == 'OK':
                    SQL="SELECT wyznacznik_id, data, numer "
                    SQL+=" FROM rs_korekty "+FiltrT+" ;"
                    stat,ds,dump,dump = self.PolSQL.Execute(SQL,3)
                    if len(ds)>0:     
                        for w in ds:
                            if stat=='OK':
                                #korekta
                                SPSQL="SELECT k.wyznacznik_id, k.data, k.numer, COALESCE(CAST (k.kurs_p AS TEXT),'') = COALESCE(CAST(k.kurs AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.nr_tabeli_p AS TEXT),'') = COALESCE(CAST(k.nr_tabeli AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.data_tabeli_p AS TEXT),'') = COALESCE(CAST(k.data_tabeli AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.wersja_p AS TEXT),'') = COALESCE(CAST(k.wersja AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.sposob_zaplaty_p AS TEXT),'') = COALESCE(CAST(k.sposob_zaplaty AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.dni_p AS TEXT),'') = COALESCE(CAST(k.dni AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.data_odbioru_p AS TEXT),'') = COALESCE(CAST(k.data_odbioru AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.upust_p AS TEXT),'') = COALESCE(CAST(k.upust AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.upust_wartosc_p AS TEXT),'') = COALESCE(CAST(k.upust_wartosc AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.upust_wartosc_wal_p AS TEXT),'') = COALESCE(CAST(k.upust_wartosc_wal AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.rabat_p AS TEXT),'') = COALESCE(CAST(k.rabat_p AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.rabat_wartosc_p AS TEXT),'') = COALESCE(CAST(k.rabat_wartosc AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.rabat_wartosc_wal_p AS TEXT),'') = COALESCE(CAST(k.rabat_wartosc_wal AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.kwota_netto_p AS TEXT),'') = COALESCE(CAST(k.kwota_netto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.kwota_vat_p AS TEXT),'') = COALESCE(CAST (k.kwota_vat AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.wartosc_opakowan_p AS TEXT),'') = COALESCE(CAST(k.wartosc_opakowan AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.do_zaplaty_p AS TEXT),'') = COALESCE(CAST(k.do_zaplaty AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.kwota_netto_wal_p AS TEXT),'') = COALESCE(CAST(k.kwota_netto_wal AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.kwota_vat_wal_p AS TEXT),'') = COALESCE(CAST(k.kwota_vat_wal AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.wartosc_opakowan_wal_p AS TEXT),'') = COALESCE(CAST(k.wartosc_opakowan_wal AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(k.do_zaplaty_wal_p AS TEXT),'') = COALESCE(CAST(k.do_zaplaty_wal AS TEXT),'') "
                                #pozycje korekty
                                SPSQL+="AND COALESCE(CAST(kp.ilosc1_p AS TEXT),'') = COALESCE(CAST(kp.ilosc1 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.ilosc2_p AS TEXT),'') = COALESCE(CAST(kp.ilosc2 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_netto1_p AS TEXT),'') = COALESCE(CAST(kp.cena_netto1 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_netto2_p AS TEXT),'') = COALESCE(CAST(kp.cena_netto2 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_upust1_p AS TEXT),'') = COALESCE(CAST(kp.cena_upust1 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_upust2_p AS TEXT),'')= COALESCE(CAST(kp.cena_upust2 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_brutto1_p AS TEXT),'') = COALESCE(CAST(kp.cena_brutto1 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_brutto2_p AS TEXT),'') = COALESCE(CAST(kp.cena_brutto2 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.upust_p AS TEXT),'') = COALESCE(CAST(kp.upust AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.upust_wartosc_p AS TEXT),'') = COALESCE(CAST(kp.upust_wartosc AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.stawka_vat_p AS TEXT),'') = COALESCE(CAST(kp.stawka_vat AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.wartosc_netto_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_netto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.wartosc_vat_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_vat AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.wartosc_brutto_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_brutto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_wal1_p AS TEXT),'') = COALESCE(CAST(kp.cena_wal1 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_wal2_p AS TEXT),'') = COALESCE(CAST(kp.cena_wal2 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_upust_wal1_p AS TEXT),'') = COALESCE(CAST(kp.cena_upust_wal1 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.cena_upust_wal2_p AS TEXT),'') = COALESCE(CAST(kp.cena_upust_wal2 AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.wartosc_wal_netto_p AS TEXT),'') = COALESCE(CAST(kp.wartosc_wal_netto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(kp.wartosc_wal_brutto_p AS TEXT),'')= COALESCE(CAST(kp.wartosc_wal_brutto AS TEXT),'') "
                                #pozycje opisowe korekty
                                SPSQL+="AND COALESCE(CAST(ko.opis_pozycji_p AS TEXT),'') = COALESCE(CAST(ko.opis_pozycji AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.stawka_vat_p AS TEXT),'') = COALESCE(CAST(ko.stawka_vat AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.wartosc_netto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_netto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.wartosc_vat_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_vat AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.wartosc_brutto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_brutto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.wartosc_wal_netto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_wal_netto AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.wartosc_wal_vat_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_wal_vat AS TEXT),'') "
                                SPSQL+="AND COALESCE(CAST(ko.wartosc_wal_brutto_p AS TEXT),'') = COALESCE(CAST(ko.wartosc_wal_brutto AS TEXT),'') "
                        
                                SPSQL+="FROM rs_korekty k "
                                SPSQL+="LEFT OUTER JOIN rs_korekty_pozycje kp ON (k.firma_id=kp.firma_id AND k.wyznacznik_id=kp.wyznacznik_id AND k.data=kp.data AND k.numer=kp.numer) "
                                SPSQL+="LEFT OUTER JOIN rs_korekty_pozycje_opisowe ko ON (k.firma_id=ko.firma_id AND k.wyznacznik_id=ko.wyznacznik_id AND k.data=ko.data AND k.numer=ko.numer) "
                         
                                SPSQL+="WHERE k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+w[0]+"' AND k.data='"+w[1]+"' AND k.numer="+str(w[2])
                                stat,DaneSP,dump,dump = self.PolSQL.Execute(SPSQL,3)
                          
                                Zmiany=False
                                for poz in DaneSP:
                                    if not Zmiany:
                                        Zmiany= not poz[3]
                                
                                if not Zmiany:
                                    stat='Brak zmian na korekcie: '+str(DaneSP[0][0])+"/"+str(DaneSP[0][1])+"/"+str(DaneSP[0][2])[:-1]

        #WS 2023-12-04
        if stat == 'OK':
            FakturyDoZmiany = {}

            SQL = "SELECT wyznacznik_id, data, numer "
            SQL += " FROM rs_korekty "+FiltrT+" ;"
            stat, ds, dump, dump = self.PolSQL.Execute(SQL, 3)
            for w in ds:
                if stat == 'OK':
                    #WS 2023-12-14 - _p -> _o
                    FSQL = """SELECT rsf_podaj_numer_dokumentu_na_wydruk('{self.firma_id}','[\"'||k.wyznacznik_id||'\",\"'||k.data||'\",'||k.numer||']', 'K') AS nr_dok, 
                                     k.wyznacznik_id_o, k.data_o, k.numer_o, wk.czy_korekta_zaliczki, 
                                     f.zaliczka_pozostalo, ABS(LEAST(k.do_zaplaty-k.do_zaplaty_p, 0)) AS do_zwrotu
                              FROM rs_korekty k
                              JOIN rs_wyznaczniki wk ON (wk.firma_id=k.firma_id AND wk.wyznacznik_id=k.wyznacznik_id)
                              JOIN rs_faktury f ON (f.firma_id=k.firma_id AND f.wyznacznik_id=k.wyznacznik_id_o and f.data=k.data_o and f.numer=k.numer_o)
                              WHERE k.firma_id='{self.firma_id}' AND k.wyznacznik_id='{w[0]}' AND k.data='{w[1]}' AND k.numer={w[2]};""".format(**locals())
                    stat, danef, wyn1f, dump = self.PolSQL.Execute(FSQL, 3)
                    if stat != 'OK':
                        stat = "Bd pobrania danych korygowanej faktury"
                    elif len(danef) > 0:
                        Faktura = rssql.RSTableRowset2(danef, wyn1f)

                        WyznF = Faktura[0]['wyznacznik_id_o']
                        DataF = Faktura[0]['data_o']
                        NumerF = Faktura[0]['numer_o']

                        if Faktura[0]['czy_korekta_zaliczki']:
                            if Faktura[0]['do_zwrotu'] > Faktura[0]['zaliczka_pozostalo']:
                                stat = "BL ZAL POZOSTALO GRUPOWE$"+Faktura[0][0]
                            else:
                                KwotaDoZwrotuZal = Faktura[0]['do_zwrotu']
                                FakturyDoZmiany[(WyznF, DataF, NumerF)] = {'KwotaDoZwrotuZal': KwotaDoZwrotuZal}

                    
        if stat == "OK" and NastStan == "Z" and not self.zdalne_zlecenie:
            # komser: zaraz bdzie wykonana operacja, sprawdzamy czy dane maj by przesyane dalej
            stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
            if stat != "OK":
                stat = "BL rs_komser_funkcje"
            elif jest:
                komserDane = []
                # komser: zbierzmy dane do przekazania dalej zanim przerobimy je lokalnie
                stat, korekty, desc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty " + Filtr, 3)
                if stat == "OK":
                    nazwy_pol = [d[0] for d in desc]
                    WYZN_IDX = nazwy_pol.index("wyznacznik_id")
                    DATA_IDX = nazwy_pol.index("data")
                    NUM_IDX = nazwy_pol.index("numer")
                    for korekta in korekty:
                        stat, pozycje, pdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_pozycje"
                            " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY nr_poz, nr_ppoz", 3,
                            (self.firma_id, rsglobal.Dekoduj(korekta[WYZN_IDX]), korekta[DATA_IDX], korekta[NUM_IDX]))
                        if stat != "OK":
                            break
                        stat, pozycjeOp, podesc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_pozycje_opisowe"
                            " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY nr_poz", 3,
                            (self.firma_id, rsglobal.Dekoduj(korekta[WYZN_IDX]), korekta[DATA_IDX], korekta[NUM_IDX]))
                        if stat != "OK":
                            break
                        stat, DStawkiVAT, stdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_korekty_vat"
                            " WHERE firma_id=%s AND wyznacznik_id=%s AND data=%s AND numer=%s ORDER BY stawka_vat", 3,
                            (self.firma_id, rsglobal.Dekoduj(korekta[WYZN_IDX]), korekta[DATA_IDX], korekta[NUM_IDX]))
                        if stat != "OK":
                            break
                        dolozDodatkoweDane(komserDane, "KOREKTA", korekta, desc)
                        for pozycja in pozycje:
                            dolozDodatkoweDane(komserDane, "POZYCJA", pozycja, pdesc)
                        for pozycja in pozycjeOp:
                            dolozDodatkoweDane(komserDane, "POZ_OPI", pozycja, podesc)
                        for pozycja in DStawkiVAT:
                            dolozDodatkoweDane(komserDane, "STAWKA", pozycja, stdesc)
                
        #jeli nie ma bdw to jedziemy
        if stat=='OK':
            #AB 15.01.21r
            potw = """ data_{typ} = CASE WHEN stan='W' AND (SELECT potwierdzac_automatycznie_korekte 
                                   FROM rs_kontrahenci_fakturowanie 
                                   WHERE firma_id=k.firma_id AND kontrahent_id IN (k.kontrahent_id, k.platnik_id) 
                                   AND data_od <= k."data" ORDER BY data_od DESC, kontrahent_id=k.kontrahent_id LIMIT 1) 
                THEN COALESCE(data_{typ}, DATA) ELSE data_{typ} END """
            sql="UPDATE rs_korekty k SET stan='"+NastStan+"', "+potw.format(typ='odbioru')+", "+potw.format(typ='wplywu')+", czy_mpp=COALESCE(czy_mpp, FALSE) "+Filtr
            # sql="UPDATE rs_korekty SET stan='"+NastStan+"', czy_mpp=COALESCE(czy_mpp OR (abs(do_zaplaty) > 15000 AND COALESCE(termin_zaplaty, data)>='2019-11-01'), FALSE) "+Filtr
            if Stan=='G':
                Insert="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,typ_dok_p,wyznacznik_id_p,data_p,numer_p,oddzial_id,rodzaj,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,opis,numer_z_rs,ureg_kwota)"
                Insert=Insert+" SELECT firma_id,'K',wyznacznik_id,data,numer,typ_dok_p,wyznacznik_id_p,data_p,numer_p,oddzial_id,'Z',kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty-do_zaplaty_p,do_zaplaty_wal-do_zaplaty_wal_p,'',numer_z_rs,0 FROM rs_korekty "+Filtr
                sql=Insert+sql

                #WS 2023-12-04
                for kluczf, danef in FakturyDoZmiany.iteritems():
                    if 'KwotaDoZwrotuZal' in danef:
                        UpdateFaktura = """UPDATE rs_faktury SET zaliczka_pozostalo=zaliczka_pozostalo-{KwotaDoZwrotuZal} 
                                           WHERE firma_id='{self.firma_id}' AND wyznacznik_id='{kluczf[0]}' AND data='{kluczf[1]}' AND numer={kluczf[2]};""".format(**locals())
                        rsglobal.ZapiszDoLogow("Update zaliczka_pozostalo faktury zal: "+UpdateFaktura)
                        sql+=UpdateFaktura

            stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
            #potencjalnie za numeracja sekwencji w zaleglosciach
            if stat<>'OK':
                #proba zrobienia tego jeszcze raz
                stat,dane,wyn1,wyn2=self.PolSQL.Execute("SELECT setval('rs_zaleglosci_nr_zal_seq', max(nr_zal)) FROM rs_zaleglosci;",1)
                if stat=='OK':
                    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
    else:
        stat="UPR ZAMG"
        dane.append(stat)


#-------------------------------------------------------------------------------
# Wstawienie dat potwierdzenia - 10
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    WyznacznikK = KorektaDoPotwierdzenia[0]
    DataK = KorektaDoPotwierdzenia[1]
    NumerK = KorektaDoPotwierdzenia[2]
    DataOdbioru = KorektaDoPotwierdzenia[3]
    DataWplywu = KorektaDoPotwierdzenia[4]

    if not WyznacznikK in LEdy:
        stat = 'Brak uprawnie do modyfikacji korekt z wyznacznikiem '+WyznacznikK

    if not rsglobal.SprawdzCzyToData(DataOdbioru):
        stat = 'Bdna data odbioru.'
        
    if stat == 'OK':
        if not rsglobal.SprawdzCzyToData(DataWplywu):
            stat = 'Bdna data wpywu.'

    if DataOdbioru < DataK:
        stat = 'Korekta '+WyznacznikK+'/'+DataK+'/'+rsglobal.UsunKropkaZero(NumerK)+' jest pniejsza od daty odbioru '+DataOdbioru

    if DataWplywu < DataK:
        stat = 'Korekta '+WyznacznikK+'/'+DataK+'/'+rsglobal.UsunKropkaZero(NumerK)+' jest pniejsza od daty wpywu '+DataOdbioru

    if stat == 'OK':
        sql ="SELECT stan FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznacznikK+"'"
        sql+=" AND data='"+DataK+"' AND numer="+str(NumerK)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania stanu korekty: '+stat
        elif len(d) == 0:
            stat = 'Brak korekty o podanym kluczu.'
        elif not d[0][0] in ('Z','K'):
            stat = 'Korekta '+WyznacznikK+'/'+DataK+'/'+rsglobal.UsunKropkaZero(NumerK)+' nie jest w stanie Z lub K.'
    
    if stat == 'OK':
        stat, Opis = fs_korekty_pom.WstawDateWplywuIOdbioru(self.PolSQL, self.firma_id, WyznacznikK, DataK, NumerK, DataOdbioru, DataWplywu,'G')
        dane = [Opis]


#-------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6, 7 zamykanie, 8 otwieranie
#-------------------------------------------------------------------------------

if Fun in [5,6,7,8] and stat=="OK":
    if UprPrz:
        Filtr = " f.firma_id = '" + self.firma_id+"'"
        if self.handlowiec_id!=None:
            Filtr+=" AND f.handlowiec = '"+self.handlowiec_id+"'"
        if WyznF not in puste_pola: 
            Filtr+=" AND f.wyznacznik_id = '" + WyznF +"'"
        if DataOdF not in puste_pola: 
            Filtr+=" AND f.data >= '" + DataOdF + "'"
        if DataDoF not in puste_pola: 
            Filtr+=" AND f.data <= '" + DataDoF + "'"
        if PlatnikF not in puste_pola: 
            Filtr+=" AND f.platnik_id LIKE '" + PlatnikF + "%'"
        if KontrF not in puste_pola: 
            Filtr+=" AND f.kontrahent_id LIKE '" + KontrF + "%'"
        if StanF not in puste_pola: 
            Filtr+=" AND f.stan LIKE '" + StanF +"%'"
        if NiewyslaneF:
            Filtr+=" AND f.data_exportu is NULL" 
        if NiepotwierdzoneF:
            Filtr+=" AND f.data_odbioru is NULL"
        #AB 15.01.20r
        if OpisF:
            Filtr += " AND UPPER(f.opis) LIKE UPPER('%{}%')".format(OpisF)
            
        if klucze_id not in puste_pola: #uzywane przy dodawaniu korekty, tak zeby dodawana byla widoczna
            # jesli to co dostalismy pasuje do aktualnego klucza to nie bedziemy juz sie bawic OR
            Filtr+=" OR (f.firma_id = '" + self.firma_id + "' AND f.wyznacznik_id = '" + klucze_id[0][0] + "' AND f.data = '"+klucze_id[0][1] + "' AND f.numer = '" + klucze_id[0][2] + "')"

        SELECT="SELECT f.stan,f.data,f.wyznacznik_id,f.numer,f.typ_dok_p,f.wyznacznik_id_p||'/'|| f.data_p||'/'|| f.numer_p,f.platnik_id||' - '||k.nazwa,f.kontrahent_id,f.do_zaplaty-f.do_zaplaty_p,f.kwota_netto-f.kwota_netto_p,f.kwota_vat-f.kwota_vat_p,f.do_zaplaty_wal-f.do_zaplaty_wal_p,f.oddzial_id,COALESCE(nr_zbiorczy::TEXT,'') "
        FROM="FROM rs_korekty f INNER JOIN rs_kontrahenci k ON (f.platnik_id=k.kontrahent_id AND f.firma_id=k.firma_id)" 
        WHERE=" WHERE f.wyznacznik_id in ("+str(LPrz)[1:-1]+") AND "+ Filtr
        ORDER=" ORDER BY f.data,f.wyznacznik_id,f.numer;"    
        sql=SELECT+FROM+WHERE+ORDER
        rsglobal.ZapiszDoLogow(sql)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        if stat!="OK":
            stat="BL SQL"
            dane.append(stat)
        if stat=='OK':
            if len(dane) > 130000:
                stat='PRZ LICZ WIER'
                dane= None
    else:
        stat="UPR PRZ"
        dane.append(stat)


# komser: jesli mamy cos do przeslania to zapisujemy
if stat == "OK" and Fun in (7, 9) and komserDane is not None and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja", "dodatkowe-dane:", komserDane],
        ["fs_komser_korekty", klucze, pola, wartosci])
