# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_korekty_dane.py
# Purpose:     dane korekty
#
# Author:      Kod pierwotny napisany przez: Tomasz Romanczuk
# Zmieniony przez: Dariusz Boduch, Micha Raburski
# Created:     2007/01/24
# RCS-ID:      $Id: fs_korekty_dane.py $
# Copyright:   (c) 2004 - 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-14 Mariusz Rajfura (4475) kontrola uprawnien do edycji pola data_odbioru 
# 2011-11-23 Mariusz Rajfura (5078) uszczelnie: kontrola stanu przed zapisem 
# 2012-05-29 Micha Raburski (5790) obsuga daty wpywu
# 2012-07-19 Mariusz Rajfura (5938) zaznaczenie recznego wprowadzania data_wplywu/data_odbioru
# 2013-01-02 Mariusz Rajfura (6388) kontrola sensownosci dat:wplywu, odbioru
# 2019-07-24 Aleksander Bargie (11557) Czy split payment
# 2020-04-20 Mikoaj Kozowski (11916) Obsuga kontrolek oznaczenie transakcji i oznaczenie sprzedazy
# 2021-09-17 Aleksander Bargie (12102) Zmiany w oknie z nagwkiem korekt
# 2022-01-19 Wojciech Skowron   (12827) Pola termin_platnosci_ulga i data_zaplaty_ulga
# 2023-12-07 Wojciech Skowron   (13620) pobranie ksef_data_przeslania, ksef_data_przyjecia


stat='OK'
dane = []

Wyznacznik=rsglobal.Dekoduj(klucze[0])
Data=rsglobal.Dekoduj(klucze[1])
Numer=rsglobal.Dekoduj(klucze[2])
Funkcja=klucze[-1]

puste_pola = [[],"","    -  -  "]

if self.operator_id != STANDARD_OPERATOR_ID:
    UprDodawanie = ((self.oddzial_id,'023013') in self.uprawnienia)
    UprEdycja = ((self.oddzial_id,'023012') in self.uprawnienia) or UprDodawanie
    if UprEdycja:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprEdycja=(Wyznacznik in LWyzn)
    UprEdycjaDataOdbioru=(((self.oddzial_id,'023111') in self.uprawnienia and UprEdycja) or (self.operator_id == STANDARD_OPERATOR_ID))
else:
    UprEdycja = True
    UprEdycjaDataOdbioru = True

#-------------------------------------------------------------------------------
#-- SPRAWDZAM WALUT
#- Zmiana w kluczu: Wyznacznik = data, Data = tabela, Numer = waluta
#-------------------------------------------------------------------------------

if Funkcja == 9:
    if Wyznacznik not in puste_pola:
        sql = ("SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND data='"+Wyznacznik+"';")
    elif Data not in puste_pola:
        sql = ("SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND nr_tabeli='"+Data+"';")
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'BL WAL'
        dane.append(stat)

    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobieraniem,4- bez pobierania)
#-------------------------------------------------------------------------------

if Funkcja in [3,4] and stat == 'OK':
    BylaDataWplywuOdbioru = False
    DataWplywu = ''
    DataOdbioru = ''
    TerminPlatnosciUlga = None  #WS 2022-01-19
    DataZaplatyUlga = None  #WS 2022-01-19
    
    if not UprEdycja:
        stat = 'BL_UPR'
        dane.append(stat)

    if stat == 'OK':
        # kontrola stanu, pobranie dat do kontroli
        sql ="SELECT stan,data_wplywu,data_odbioru,termin_platnosci_ulga,data_zaplaty_ulga FROM rs_korekty"  #WS 2022-01-19
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia stanu korekty: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak korekty o podanym kluczu.'
            dane.append(stat)
        elif d[0][0] != 'W':
            # w stanie innym niz W dozwolona edycja pol:
            for i in xrange(len(pola)):
                if not pola[i] in ['data_wplywu','data_odbioru','opis','termin_platnosci_ulga','data_zaplaty_ulga']:  #WS 2022-01-19
                    stat = 'Korekta w stanie '+tr.GetVal(0,'stan')+'. Zapis zmian niemoliwy.'
                    dane.append(stat)
                    break

    if stat == 'OK':
        DataWplywu = rsglobal.Dekoduj(d[0][1])
        DataOdbioru = rsglobal.Dekoduj(d[0][2])
        TerminPlatnosciUlga = rsglobal.Dekoduj(d[0][3])  #WS 2022-01-19
        DataZaplatyUlga = rsglobal.Dekoduj(d[0][4])  #WS 2022-01-19
        
        Wersja=''
        Upust=-1
        Kontrahent=''
        Waluta=''
        Kurs=0

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole == 'wersja':
                if wart == '':
                    wartosci[i] = "NULL"
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL WERSJA"
                            dane.append(stat)
                        else:
                            Wersja=wart
                        
            elif pole == "sposob_zaplaty":
                if wart == "":
                    stat = ("BR SPOSZAPL") 
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_zaplaty WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat="BL SPOSZAPL"
                            dane.append(stat)
                    
                        
            elif pole == "sposob_odbioru_faktury":    
                if wart == "":
                    wartosci[i] = "NULL"
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_odbioru_faktury WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL SPOSODBFAKT"
                            dane.append(stat)
                            
            elif pole == "projekt_id":    
                if wart == "":
                    wartosci[i] = "NULL"
                else:
                    SQL="SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"'"
                    SQL+=" AND projekt_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL PROJEKT"
                            dane.append(stat)
                        
            elif pole == "tytul_zmniejszenia_podatku":    
                if wart.strip() == "":
                    stat = "BR TYT"
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';", 3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL TYT"
                            dane.append(stat)

            elif pole == "data_odbioru":
                BylaDataWplywuOdbioru = True
                DataOdbioru = wart
            
                if stat=='OK':
                    # sprawdzenie, czy operator, ktory nie posiada praw do edycji pola 'data_odbioru'
                    # aktualizuje puste pole, bo to moze zrobic
                    if not UprEdycjaDataOdbioru:
                        sql ="SELECT data_odbioru FROM rs_korekty"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                        sql+=" AND data='"+Data+"' AND numer="+Numer+";"
                
                        stat,dDataOdb,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat != 'OK':
                            stat = 'Bd pobrania danych z nagwka korekty: '+stat
                            dane.append(stat)
                        elif len(dDataOdb) == 0:
                            stat = 'Brak korekty o podanym kluczu.'
                            dane.append(stat)
                        elif not rsglobal.Dekoduj(dDataOdb[0][0]) in ('None','','NULL'):
                            stat = 'BR UPR DATAODB'
                            dane.append(stat)
    
                    if stat == 'OK':
                        if wart == "    -  -  ":
                            wartosci[i] = "NULL"
                        else:
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = "BL DATAODB"
                            
            elif pole == "data_wplywu":
                BylaDataWplywuOdbioru = True
                DataWplywu = wart
                
                if stat == 'OK':
                    # sprawdzenie, czy operator, ktory nie posiada praw do edycji pola 'data_wplywu'
                    # aktualizuje puste pole, bo to moze zrobic
                    if not UprEdycjaDataOdbioru:
                        sql ="SELECT data_wplywu FROM rs_korekty"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                        sql+=" AND data='"+Data+"' AND numer="+Numer+";"
                
                        stat,dDataWpl,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat != 'OK':
                            stat = 'Bd pobrania danych z nagwka korekty: '+stat
                            dane.append(stat)
                        elif len(dDataWpl) == 0:
                            stat = 'Brak korekty o podanym kluczu.'
                            dane.append(stat)
                        elif not rsglobal.Dekoduj(dDataWpl[0][0]) in ('None','','NULL'):
                            stat = 'BR UPR DATAWPL'
                            dane.append(stat)

                    if stat == 'OK':
                        if wart == "    -  -  ":
                            wartosci[i] = "NULL"
                        else:
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = "BL DATAWPL"

            elif pole == "data_przychodu":
                if wart == "    -  -  ":
                    wartosci[i] = "NULL"
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date(\'"+wart+"\');",3)
                    if stat=='OK':
                        if len(d)== 0:
                            stat = "BL_SPD"
                            dane.append(stat)
                        else:
                            Dane = d[0][0]
                            if Dane != 2:
                                stat = "BL DATAPRZYCH"
                                dane.append(stat)
                                
            elif pole == "termin_zaplaty":
                if wart == "    -  -  ":
                    wartosci[i] = "NULL"
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date(\'"+wart+"\');",3)
                    if stat=='OK':
                        if len(d)== 0:
                            stat = "BL_SPTZ"
                            dane.append(stat)
                        else:
                            Dane = d[0][0]
                            if Dane != 2:
                                stat = "BL TERMINZAPLATY"
                                dane.append(stat)

            #WS 2022-01-19
            elif pole == "termin_platnosci_ulga":
                TerminPlatnosciUlga = wart
                if wart == "    -  -  ":
                    wartosci[i] = "NULL"
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat = "BL TERMINPLATULG"
                        dane.append(stat)

            #WS 2022-01-19
            elif pole == "data_zaplaty_ulga":
                DataZaplatyUlga = wart
                if wart == "    -  -  ":
                    wartosci[i] = "NULL"
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat = "BL DATAZAPULG"
                        dane.append(stat)
                                
            elif pole == "upust":
                Upust=wart

        # czy byly bledy w kontroli pol
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # kontrole sensownosci dat  wplywu i odbioru
        if stat == 'OK':
            if rsglobal.SprawdzCzyToData(DataWplywu) and not rsglobal.SprawdzCzyToData(DataOdbioru):
                stat = 'BL DATAWPL DATAODB'
                
            if stat == 'OK':
                if rsglobal.SprawdzCzyToData(DataOdbioru) and not rsglobal.SprawdzCzyToData(DataWplywu):
                    stat = 'BL DATAODB DATAWPL'

        if stat == 'OK' and rsglobal.SprawdzCzyToData(DataWplywu) and rsglobal.SprawdzCzyToData(DataOdbioru):
            if DataWplywu < Data:
                stat = 'BL DATAWPL ZA WCZESNA'

            if stat == 'OK':
                if DataOdbioru < Data:
                    stat = 'BL DATAODB ZA WCZESNA'

            if stat == 'OK':
                if DataOdbioru < DataWplywu:
                    stat = 'BL DATAODB ZA WCZESNA DATAWPL'

        #WS 2022-01-19
        # kontrola na termin patnoci/dat zapaty (ulga na ze dugi)
        if stat == 'OK':
            if rsglobal.SprawdzCzyToData(TerminPlatnosciUlga) and rsglobal.SprawdzCzyToData(DataZaplatyUlga):
                stat = 'BL DATY ULGA'
                            
        if stat=='OK':
            sql = "UPDATE rs_korekty SET "
            Filtr = "firma_id=\'"+self.firma_id+"\' AND wyznacznik_id=\'"+Wyznacznik+"\' AND data=\'"+Data+"\' AND numer="+str(Numer)
            for i in range(len(pola)):
                wart = wartosci[i]
                pole = pola[i]
                if pole in ["sposob_odbioru_faktury","wersja","opis","data_przychodu","tytul_zmniejszenia_podatku",
                     "data_odbioru","data_exportu","data_wplywu","projekt_id","termin_zaplaty","ozn_trans","ozn_sprzedaz",  #MK 2020-04-20
                     "termin_platnosci_ulga","data_zaplaty_ulga"]:  #WS 2022-01-19
                    if wart == "NULL":
                        sql += pole+"="+str(wart)+","
                    else:
                        sql += pole+"=\'"+str(wart)+"\',"
                elif pole in ["upust","upust_wartosc","upust_wartosc_wal","rabat","rabat_wartosc",
                    "rabat_wartosc_wal","kwota_netto","kwota_vat","wartosc_opakowan","do_zaplaty","kwota_netto_wal",#AB 24.07.19r dodane czy_mpp
                    "kwota_vat_wal","wartosc_opakowan_wal","do_zaplaty_wal","kurs","osobny_rachunek_vat", "czy_mpp",
                              "sprzedaz_uslug",]:
                    sql += pole+"="+str(wart)+","
                elif pole in ["sposob_zaplaty","tekst_nad_podp","tekst_pod_podp"]:
                    sql += pole+"=\'"+str(wart)+"\',"
            
            sql = sql.strip(',')
            
            if BylaDataWplywuOdbioru:
                sql+=",data_sposob='R'"
            
            sql += " WHERE "+Filtr+";"

            if Wersja<>'' or Upust<>-1:  
                # sprawdzenie czy na jakiej pozycji nie ma ju zmiany iloci
                SQL="SELECT nr_poz,nr_ppoz FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND ilosc1!=ilosc1_p;"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat=='OK':
                    if len(DTest)>0:
                        stat='W pozycjach:'
                        for w in DTest:
                            if w != DTest[0]:
                                stat+=', ('+str(int(w[0]))+', '+str(int(w[1]))+')'
                            else:
                                stat+=' ('+str(int(w[0]))+', '+str(int(w[1]))+')'
                        stat+=" zmieniono ilo - nie mona zmieni wersji ani upustu"
                
                if stat=='OK':      
                    Select="SELECT kontrahent_id,wersja,upust,waluta,kurs FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
                    stat,d,dump,dump = self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if Kontrahent=='':
                        Kontrahent=rsglobal.Dekoduj(d[0][0])
                    if Wersja=='':
                        Wersja=rsglobal.Dekoduj(d[0][1])
                    if Upust== -1:
                        Upust=d[0][2]
                    if Waluta=='':
                        Waluta=rsglobal.Dekoduj(d[0][3])
                    if Kurs== 0:
                        Kurs=d[0][4]

                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT nr_poz,nr_ppoz,artykul_id FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; ",3)
                if stat=='OK':
                    for i in dane_wyn:
                        if stat=='OK':
                            sdl="SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"',CAST('"+Kontrahent+"' AS TEXT),CAST('"+Waluta+"' AS TEXT),CAST('"+Data+"' AS TEXT),CAST('"+rsglobal.Dekoduj(i[2])+"' AS TEXT),CAST('"+Wersja+"' AS TEXT),"+str(Upust)+")"
                            rsglobal.ZapiszDoLogow(sdl,1)
                            stat,d_c,dump,dump=self.PolSQL.Execute(sdl,3)
                        if stat=='OK':
                            d=rsglobal.rseval(d_c[0][0])
                            Update="UPDATE rs_korekty_pozycje SET cena_wal1=round("+str(d[0])+",2)"
                            Update+=",cena_wal2=round("+str(d[1])+",2),cena_upust_wal1=round("+str(d[4])+",2)"
                            Update+=",cena_upust_wal2=round("+str(d[5])+",2),wartosc_wal_netto=round(ilosc1*"+str(d[4])+",2)"
                            Update+=",wartosc_wal_brutto=round(ilosc1*"+str(d[6])+",2)"
                            Update+=",wartosc_wal_vat=round(ilosc1*("+str(d[6])+"-"+str(d[4])+"),2)"
                            Update+=",cena_netto1=round("+str(d[0])+"*"+str(Kurs)+",2)"
                            Update+=",cena_netto2=round("+str(d[1])+"*"+str(Kurs)+",2)"
                            Update+=",cena_brutto1=round("+str(d[2])+"*"+str(Kurs)+",2)"
                            Update+=",cena_brutto2=round("+str(d[3])+"*"+str(Kurs)+",2)"
                            Update+=",cena_upust1=round("+str(d[4])+"*"+str(Kurs)+",2)"
                            Update+=",cena_upust2=round("+str(d[5])+"*"+str(Kurs)+",2)"
                            Update+=",wartosc_netto=round("+str(d[4])+"*ilosc1*"+str(Kurs)+",2)"
                            Update+=",wartosc_vat=round(("+str(d[6])+" - "+str(d[4])+")*ilosc1*"+str(Kurs)+",2)"
                            Update+=",wartosc_brutto=round("+str(d[6])+"*ilosc1*"+str(Kurs)+",2),upust=round("+str(d[8])+",2)"
                            Update+=",upust_wartosc=round(("+str(d[0])+"-"+str(d[4])+")*ilosc1*"+str(Kurs)+",2)"
                            Update+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(i[0])+" AND nr_ppoz="+str(i[1])+"; "
                            stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
                            
        if stat=='OK':
            stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------
if (Funkcja in [5,3]) and (stat=='OK'):
    where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
    #WS 2023-12-07 - ksef_data_przeslania, ksef_data_przyjecia
    sql = "SELECT *, " \
          "to_char(ksef_data_przeslania, 'YYYY-MM-DD HH24:MI:SS') AS ksef_data_przeslania, " \
          "to_char(ksef_data_przyjecia, 'YYYY-MM-DD HH24:MI:SS') AS ksef_data_przyjecia " \
          "FROM rs_korekty " + where + ";"

    # pobranie danych
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
        
    #pobranie danych do opisow
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
            
        #odbiorca [0]
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        #zamawiajacy [1]
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"zamawiajacy_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        #platnik [2]
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"platnik_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        #miejsce dostawy [3]
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"miejsce_dostawy_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.') 
            
        #waluta [4]
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  
            
        #wersja [5]
        if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
            
        #sposob zaplaty [6]
        if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_zaplaty")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #handlowiec [7]
        if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #sposob odbioru faktury [8]
        if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #sposob dostawy [9]
        if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_dostawy")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #projekt [10]
        if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            SQL="SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    

        #tytu zm. podatku [11]
        if ((self.oddzial_id,'011190') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"tytul_zmniejszenia_podatku")+"';" ,3)
            if len(d) == 0:
                if Funkcja in (3, ):
                    stat = "BR TYT"
                else:
                    wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
        
        # dozwolona edycja [12]
        wyn2.append(str(UprEdycja)) 
        
        #--- sprawdzenie czy podana korekta jest wartociowa [13] i wczytanie czy ecod
        if stat=='OK':
            SQL="SELECT typ_faktury='KW', ecod FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
            st,d,dump,dump = self.PolSQL.Execute(SQL ,3)
            if st=='OK':
                if len(d) == 0:
                    wyn2.append(False)
                    ecod = False
                else:
                    wyn2.append(d[0][0])
                    ecod = d[0][1]

            # [14] oznaczenie transakcje #MK 2020-04-16
        if (self.oddzial_id, '211430') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_transakcje_oznaczenia WHERE kod='" + tr.GetVal(0,
                                                                                       "ozn_trans") + "';"
            st, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if st != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia transakcji: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia transakcji. Poinformuj administratora.')

            # [15] oznaczenie sprzedaz #MK 2020-04-20
        if (self.oddzial_id, '211440') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_oznaczenia_sprzedaz WHERE kod='" + tr.GetVal(0,
                                                                                     "ozn_sprzedaz") + "';"
            st, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if st != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia sprzeday: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia sprzeday. Poinformuj administratora.')

        wyn2.append(ecod)  # [16] czy korekta wysylana przez ecod