# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_korekty_klucz.py
# Purpose:     insert/update korekty
#
# Author:      Micha Raburski
# Created:     2007/01/22
#Edited:       2008/07/07
# RCS-ID:      $Id: fs_korekty_klucz.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 26-11-2010 - Mariusz Rajfura - przeniesienie dodawania nowej korekty 
#              mantis:4096       z 'rsf_korekty_insert' do 'fs_korekty_klucz'
# 2012-11-27 Mariusz Rajfura    (6309)  kontrola numeru tworzonej korekty
# 2017-10-19 Rafa Woniak      (10783) ustawianie checkboxa zalenie od faktury
# 2019-08-01 Aleksander Bargie (11568) Obsuga split payment w fakturach
# 2020-03-27 Mikoaj Kozowski (11907) Pobieranie "kod GTU" z faktury oryginalnej do pozycji
# 2020-04-20 Mikoaj Kozowski (11916) Obsuga kontrolek oznaczenie transakcji i oznaczenie sprzedazy
# 2023-12-04 Wojciech Skowron  (13623) Jeli wyzn faktury 'FZ' to wyzn korekty musi mie czy_korekta_zaliczki=True

from funkcje import fs_sprzedaz_pom

Fun = klucze[-1]

stat = "OK"
dane = []
wyn2 = []
    
#--- SELECT DANYCH(1)
if Fun == 1:
    if ((self.oddzial_id,'023010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Wyzn = klucze[0]
        Data = klucze[1]

        sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"
        sql+= self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+Data+"\\\']','K');"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)            
        if dane[0][0]=='OK':
            sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"
            sql+= self.firma_id+"','[\\\'"+Wyzn+"\\\',\\\'"+Data+"\\\']','K');"
            stat,dane,dump,dump = self.PolSQL.Execute(sql,3)        
            if dane[0][0] in (None,'None',''):
                stat="BL N NUM"
        elif stat=='OK':
            stat="NM DD"

    else:
        stat = 'UPR SEL'


if Fun ==2 and stat=='OK':
    if not ((self.oddzial_id,'023013') in self.uprawnienia) and (self.operator_id != STANDARD_OPERATOR_ID):
        stat = 'UPR INS'

    if stat=='OK':
        klucz = klucze[0]
        wart = klucze[1]
        
        WyznK = rsglobal.Dekoduj(klucz[0])
        DataK = rsglobal.Dekoduj(klucz[1])
        NrK = str(klucz[2])
        # sprawdzenie  unikalnoci numeru korekty w ramach odpowiedniego zakresu czasowego
        SQL="SELECT rsf_sprawdz_czy_unikalny_numer_dokumentu('"
        SQL+= self.firma_id+"','[\\\'"+WyznK+"\\\',\\\'"+DataK+"\\\',"+NrK+"]','K');"
        stat,DaneNrK,dump,dump = self.PolSQL.Execute(SQL,3)            
        if stat<>'OK':
            stat='Bd sprawdzania unikalnoci numeru korekty :'+stat
        if DaneNrK[0][0]<>'OK':
            stat=DaneNrK[0][0]
     
    if stat=='OK':       
        WyznO = rsglobal.Dekoduj(wart[0])
        DataO = rsglobal.Dekoduj(wart[1])
        NrO = str(wart[2])
        Orginal = "F"
        
        #sprawdzenie czy operator ma prawo dodawa ten wyznacznik w danym oddziale
        #pobranie listy wyznacznikw, do ktrych ma prawo dodawania
        sql ="SELECT wyznacznik_id,czy_korekta,typ_faktury FROM rs_wyznaczniki"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznK+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)

    if stat=='OK':
        if len(d) == 0:
            stat = "BL WYZN" 
    
    if stat=='OK':
        if not d[0][1]:
            stat = "WYZN FAKT" 
    
    if stat=='OK':
        #WS 2023-12-04 - FZ
        if not d[0][2] in ('BP','DU','EK','KR','WW','ZA','ZU','FZ'):
            stat = "BL TYP KOR" 
    
    if stat=='OK':
        if int(NrK)<1:
            stat = 'Korekta musi mie numer wikszy od zera.'

    if stat=='OK':
        if self.operator_id != STANDARD_OPERATOR_ID:
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            ListaUpr='[False,True,False,False,False,False]'
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','"+ListaUpr+"');"    
            
            stat,DaneW,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LWyzn=rsglobal.rseval(DaneW[0][0])[1]
                Buf=str(WyznK)+'  '
                Buf=Buf[0:2]
                if not( Buf in LWyzn):
                    stat="BL UPR WYZN"

    if stat=='OK':        
        #sprawdzenie czy mona doda faktur z t dat
        sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument(\'"
        sql+= self.firma_id+"','[\\\'"+WyznK+"\\\',\\\'"+DataK+"\\\']','K');"
        
        stat,test,dump,dump = self.PolSQL.Execute(sql,3)
        if test[0][0]<>'OK':    
            stat='NM DD' # nie mozna doda dokumentu
                
        if DataK == "    -  -  " or DataO == "    -  -  ":
            stat = 'BR DATA'
          
    if stat == "OK":
        if not rsglobal.SprawdzCzyToData(DataK):
            stat = "BL DATA"
            dane.append(stat)

    if stat == 'OK':    
        sql = "SELECT rsf_sprawdz_date_z_zakresem(\'"
        sql+= str(self.firma_id)+self.oddzial_id+"\',\'"+str(DataK)+"\',1);"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        Dane = d[0][0]
        if Dane != 1:
            stat = "ZK DATA"
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT wyznacznik_id FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznK+"'"
        sql+=" AND data='"+DataK+"' AND numer="+str(NrK)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(d) != 0:
                stat = 'UZ KLUCZ'
                dane.append(stat)


    if stat == 'OK':
        if DataK <= DataO:
            stat == 'BL DATAO'
            dane.append(stat)


    if stat == "OK":
        Klucz1=[self.firma_id,self.oddzial_id]
        Klucz2=[self.firma_id,WyznK,DataK,NrK]
        Klucz3=[self.firma_id,WyznO,DataO,NrO]

            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

    if stat == "OK":
        KluczGl = Klucz1
        Klucz = Klucz2
        KluczO = Klucz3

        Firma= KluczGl[0]
    
        FirmaK = Klucz[0]
        WyznK = Klucz[1]
        DataK = Klucz[2]
        NrK = Klucz[3]

        FirmaO = KluczO[0]
        WyznO = KluczO[1]
        DataO = KluczO[2]
        NrO = KluczO[3]
        Orginal = "F"
        ZImportu = False

        WyznOrg = KluczO[1]
        DataOrg = KluczO[2]
        NrOrg = KluczO[3]

        TypFakt0 = ''

        if (Firma != FirmaK) or (FirmaK != FirmaO):
            stat = '0005'
            dane.append(stat)

    if stat == 'OK':
        if DataK == '    -  -  ':
            stat = 'BR DATA'
            dane.append(stat)

    if stat == 'OK':
        #WS 2023-12-04 - czy_korekta_zaliczki
        sql ="SELECT wyznacznik_id, czy_korekta_zaliczki FROM rs_wyznaczniki WHERE firma_id='"+FirmaK+"'"
        sql+=" AND wyznacznik_id='"+WyznK+"' AND czy_korekta=True;"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania wyznacznika: '+stat
            dane.append(stat)
        elif len(d)==0:
            stat = 'BL WYZN KOR'
            dane.append(stat)

    #WS 2023-12-04
    if stat == 'OK':
        sql ="SELECT typ_faktury FROM rs_wyznaczniki"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznO+"';"
        stat,d2,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych wyznacznika faktury: '+stat
            dane.append(stat)
        elif d[0][1] is False and d2[0][0] == 'FZ':
            stat = 'BL WYZN ZAL K'
            dane.append(stat)
        elif d[0][1] is True and d2[0][0] != 'FZ':
            stat = 'BL WYZN ZAL F'
            dane.append(stat)
        else:
            TypFakt0 = d2[0][0]

    if stat == 'OK':
        if not rsglobal.SprawdzCzyToData(DataK):
            stat = 'BL DATA'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT rsf_sprawdz_date_z_zakresem(\'"+Firma+self.oddzial_id+"\',\'"+DataK+"\',1);"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia daty z okresem sprzeday: '+stat
            dane.append(stat)
        elif d[0][0] != 1:
            stat = 'ZK DATA'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT wyznacznik_id FROM rs_korekty"
        sql+=" WHERE firma_id='"+FirmaK+"' AND wyznacznik_id='"+WyznK+"'"
        sql+=" AND data='"+DataK+"' AND numer="+str(NrK)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenienia istnienia korekty: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'UZ KLUCZ'
            dane.append(stat)

    if stat == 'OK':
        #WS 2023-12-04 - zaliczka_pozostalo
        sql ="SELECT stan, zaliczka_pozostalo, do_zaplaty-zaliczka_pozostalo FROM rs_faktury"
        sql+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
        sql+=" AND data='"+DataO+"' AND numer="+str(NrO)+" FOR UPDATE NOWAIT;"
         
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia faktury rodowej: '+stat
            dane.append(stat)
        elif len(d)==0:
            stat = 'BR ORGI'
            dane.append(stat)
            
        elif d[0][0] in ('W','G'):
            stat = 'BL STAN'
            dane.append(stat)
        #WS 2023-12-04
        elif TypFakt0 == 'FZ' and d[0][1] == 0:
            stat = 'BL F ZAL ROZL'
            dane.append(stat)

    #-- w tym miejscu nastepuje podzial na korekty do korekt z importu oraz do korekt z anakondy

    if stat == 'OK':
        #najpierw sprawdzenie czy do faktury sa jakiekolwiek korekty
        sql ="SELECT wyznacznik_id,data,numer,stan FROM rs_korekty"
        sql+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id_p='"+WyznO+"'"
        sql+=" AND data_p='"+DataO+"' AND numer_p="+str(NrO)+" AND typ_dok_p='F'"
        sql+=" ORDER BY wyznacznik_id_o;"
        stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia istnienia korekt do faktury: '+stat
            dane.append(stat)

    if stat == 'OK':
        if len(Dane)>0:
            # Jesli sa to sprawdzamy czy sa takie ze sa "normalnie" wystawione w anakondzie.
            # Jesli sa to lecimy dalej normalnie, a jesli nie to zapuszczamy najnowszy algorytm :)
            sql ="SELECT wyznacznik_id,data,numer,stan FROM rs_korekty"
            sql+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id_p='"+WyznO+"'"
            sql+=" AND data_p='"+DataO+"' AND numer_p="+str(NrO)+" AND typ_dok_p='F'"
            sql+=" AND wyznacznik_id_o='"+WyznO+"' AND data_o='"+DataO+"' AND numer_o="+str(NrO)+";"
            stat,DanePom,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia korekt importowanych: '+stat
                dane.append(stat)
            elif len(DanePom) == 0: 
                ZImportu=True


    #-------------------------------------------------
    # SEKCJA TWORZENIA KOREKTY DO KOREKT Z IMPORTU
    #-------------------------------------------------
    if stat == 'OK' and ZImportu:
        #-- pobranie danych - najpierw dane z faktury
        sql ="SELECT * FROM rs_faktury"
        sql+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
        sql+=" AND data='"+DataO+"' AND numer="+str(NrO)+";"

        stat,DaneN,wynN,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych z faktury: '+stat
            dane.append(stat)

        if stat == 'OK':
            #pozycje z faktury
            sql ="SELECT nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,"
            sql+=" cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
            sql+=" cena_brutto1,cena_brutto2,upust,upust_wartosc,"
            sql+=" stawka_vat,nr_serii,termin_przyd,cena_wal1,cena_wal2,"
            sql+=" cena_upust_wal1,cena_upust_wal2,"
            sql+=" COALESCE(cecha1_opis,'') AS cecha1_opis,COALESCE(cecha1_wartosc,'') AS cecha1_wartosc"
            sql+=" FROM rs_faktury_pozycje"
            sql+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
            sql+=" AND data='"+DataO+"' AND numer="+str(NrO)+";"
            
            stat,daneP,wynP,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania pozycji z faktury: '+stat
                dane.append(stat)

        if stat == 'OK':
            #-- teraz dane z korekt - od razu wszystkich
            sql ="SELECT artykul_id,ilosc1,ilosc1_p,ilosc2,ilosc2_p"
            sql+=" FROM rs_korekty_pozycje kp"
            sql+=" INNER JOIN rs_korekty k USING (firma_id,wyznacznik_id,data,numer)"
            sql+=" WHERE k.firma_id='"+FirmaO+"' AND k.wyznacznik_id_p='"+WyznO+"'"
            sql+=" AND k.data_p='"+DataO+"' AND k.numer_p="+str(NrO)+";" 
            
            stat,daneK,wynK,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania danych z pozycji korekt: '+stat
                dane.append(stat)
        
        if stat == 'OK':
            #naglowek
            trN = rssql.RSTableRowset(DaneN,wynN)
            
            # aby zachowac dzialajacy algorytm dla pozycji faktury i pozycji korekty
            # tworze DaneP i DaneK w takiej formie, jak bylyby pozyskane w rsf_korekta_insert()
            # w wyniku dzialania funkcji plpy.execute() (mariusz)
            
            #pozycje faktury
            DaneP = []
            for i in xrange(len(daneP)):
                d = {}
                for j in xrange(len(wynP)):
                    pole = wynP[j][0]
                    wart = rsglobal.Dekoduj(daneP[i][j])
                    d[pole] = wart
                DaneP.append(d)
                
            #pozycje korekty
            DaneK = []
            for i in xrange(len(daneK)):
                d = {}
                for j in xrange(len(wynK)):
                    pole = wynK[j][0]
                    wart = rsglobal.Dekoduj(daneK[i][j])
                    d[pole] = wart
                DaneK.append(d)
            
            
            Waluta=trN.GetVal(0,'waluta')
            Kurs=trN.GetVal(0,'kurs')
    
            SPoz={}
            for d in DaneP:
                SPoz[d["artykul_id"]]=d
    
            #-- naoenie danych z korekt na dane z faktury
            for d in DaneK:
                if d["artykul_id"] in SPoz:
                    SPoz[d["artykul_id"]]["ilosc1"] = SPoz[d["artykul_id"]]["ilosc1"]+d["ilosc1"]-d["ilosc1_p"]
                    SPoz[d["artykul_id"]]["ilosc2"] = SPoz[d["artykul_id"]]["ilosc2"]+d["ilosc2"]-d["ilosc2_p"]
    
            #-- teraz liczymy sum stawek vat netto
            SVat={}
            for klucz in SPoz:
                d=SPoz[klucz]
                st=d["stawka_vat"]
                if st in SVat:
                    SVat[st][0]=SVat[st][0]+round(d["cena_upust1"]*d["ilosc1"],2)
                else:
                    SVat[st]=[round(d["cena_upust1"]*d["ilosc1"],2),0]
    
            SumaN=0
            SumaV=0
            #-- i przeliczamy wartoci VAT (sumujc prz okazji kwoty faktury)
            for st in SVat:
                if st not in ["zw","np","00"]:
                    SVat[st][1]=round(SVat[st][0]*int(st)*0.01,2)
                    SumaN=SumaN+SVat[st][0]
                    SumaV=SumaV+SVat[st][1]
    
            UpustW=0
            #-- poza tym liczymy wartosci faktury
            for art in SPoz:
                d=SPoz[art]
                UpustW=UpustW+round((d["cena_netto1"]-d["cena_upust1"])*d["ilosc1"],2)
    
            if Waluta != "PLN":
                SumaNWal=round(SumaN/Kurs,2)
                SumaVWal=round(SumaV/Kurs,2)
                UpustWWal=round(UpustW/Kurs,2)
            else:
                SumaNWal=SumaN
                SumaVWal=SumaV
                UpustWWal=UpustW
            
           
            #-- tworzenie korekty
            SposOdb=trN.GetVal(0,'sposob_odbioru_faktury')
            if SposOdb=='None':
                SposOdb="NULL"
            else:
                SposOdb="'"+SposOdb+"'"
    
            SposDost=trN.GetVal(0,'sposob_dostawy')
            if SposDost=='None':
                SposDost="NULL"
            else:
                SposDost="'"+SposDost+"'"
    
            Projekt=trN.GetVal(0,'projekt_id')
            if Projekt=='None':
                Projekt="NULL"
            else:
                Projekt="'"+Projekt+"'"
    
            Bonus=trN.GetVal(0,'czy_bonus')
            if Bonus:
                Bonus="TRUE"
            else:
                Bonus="FALSE"

            #AB 01.08.19r
            MPP=trN.GetVal(0,'czy_mpp')
            if MPP:
                MPP="TRUE"
            else:
                MPP="FALSE"
    
            Handlowiec=trN.GetVal(0,'handlowiec')
            if Handlowiec=='None':
                Handlowiec="NULL"
            else:
                Handlowiec="'"+Handlowiec+"'"
    
            NrTab=trN.GetVal(0,'nr_tabeli')
            if NrTab=='None':
                NrTab="NULL"
            else:
                NrTab="'"+NrTab+"'"
        
            DataTab=trN.GetVal(0,'data_tabeli')
            if DataTab=='None':
                DataTab="NULL"
            else:
                DataTab="'"+DataTab+"'"
            
            KrajOpodat=trN.GetVal(0,'kraj_opodatkowania')
            if KrajOpodat=='None':
                KrajOpodat="NULL"
            else:
                KrajOpodat="'"+KrajOpodat+"'"
    
            DataZaladunku=trN.GetVal(0,'data_zaladunku')
            if DataZaladunku=='None':
                DataZaladunku="NULL"
            else:
                DataZaladunku="'"+DataZaladunku+"'"
    
            NrSamochodu=trN.GetVal(0,'nr_samochodu')
            if NrSamochodu=='None':
                NrSamochodu="NULL"
            else:
                NrSamochodu="'"+NrSamochodu+"'"
            # RW sprawdzamy i ustawiamy osobny_rachunek_vat w zaleznoci od tego jaki jest w fakturze
            Waga=trN.GetVal(0,'waga')
            if Waga=='None':
                Waga="NULL"
            OsobneKVat=trN.GetVal(0,'osobny_rachunek_vat')

            OznTrans = trN.GetVal(0, 'ozn_trans') #MK 2020-04-24
            if OznTrans == 'None':
                OznTrans = "NULL"
            else:
                OznTrans = "'" + OznTrans + "'"

            OznSprz = trN.GetVal(0, 'ozn_sprzedaz') #MK 2020-04-24
            if OznSprz == 'None':
                OznSprz = "NULL"
            else:
                OznSprz = "'" + OznSprz + "'"
            
            p = "stan,firma_id,wyznacznik_id,data,numer,oddzial_id,"
            p+= "kontrahent_id,zamawiajacy_id,"
            p+= "platnik_id,waluta,kurs,"
            p+=" nr_tabeli,data_tabeli,kurs_p,nr_tabeli_p,data_tabeli_p,"
            p+= "wersja,sposob_zaplaty,dni,"
            p+= "termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,"
            p+= "upust,upust_wartosc,"
            p+= "upust_wartosc_wal,rabat,rabat_wartosc,"
            p+= "rabat_wartosc_wal,kwota_netto,kwota_vat,"
            p+= "wartosc_opakowan,kraj_opodatkowania,"
            p+= "do_zaplaty,kwota_netto_wal,kwota_vat_wal,"
            p+= "wartosc_opakowan_wal,do_zaplaty_wal,"
            p+= "typ_dok_p,wyznacznik_id_p,data_p,numer_p,"
            p+= "projekt_id,czy_bonus,wyznacznik_id_o,data_o,numer_o, " #AB 01.08.19r
            p+= "data_zaladunku, nr_samochodu, waga,osobny_rachunek_vat, czy_mpp,ozn_trans,ozn_sprzedaz "  #MK 2020-04-24

            w = "'W','"+FirmaK+"','"+WyznK+"','"+DataK+"',"+str(NrK)+",'"+KluczGl[1]+"',"
            w+= "'"+trN.GetVal(0,'kontrahent_id')+"','"+trN.GetVal(0,'zamawiajacy_id')+"',"
            w+= "'"+trN.GetVal(0,'platnik_id')+"','"+Waluta+"',"+str(Kurs)+","
            w+= NrTab+","+DataTab+","+str(Kurs)+","+NrTab+","+DataTab+","
            w+= " NULL,'"+trN.GetVal(0,'sposob_zaplaty')+"',"+str(trN.GetVal(0,'dni'))+","
            w+= "'"+trN.GetVal(0,'termin_zaplaty')+"',"+Handlowiec+","+SposOdb+","+SposDost+","
            w+= str(trN.GetVal(0,'upust'))+","+str(UpustW)+","
            w+= str(UpustWWal)+","+str(trN.GetVal(0,'rabat'))+","+str(trN.GetVal(0,'rabat_wartosc'))+","
            w+= str(trN.GetVal(0,'rabat_wartosc_wal'))+","+str(SumaN)+","+str(SumaV)+","
            w+= str(trN.GetVal(0,'wartosc_opakowan'))+","+KrajOpodat+","
            w+= str(SumaN+SumaV)+","+str(SumaNWal)+","+str(SumaVWal)+","
            w+= str(trN.GetVal(0,'wartosc_opakowan_wal'))+","+str(SumaNWal+SumaVWal)+","
            w+= "'"+Orginal+"','"+WyznO+"','"+DataO+"',"+str(NrO)+","
            w+= Projekt+","+Bonus+",'"+WyznOrg+"','"+DataOrg+"',"+str(NrOrg)+"," #AB 01.08.19r
            w+= DataZaladunku+","+NrSamochodu+","+str(Waga)+","+str(OsobneKVat)+","+MPP+","+OznTrans+","+OznSprz  #MK 2020-04-24
    
            InsN = "INSERT INTO rs_korekty ("+p+") VALUES ("+w+");"
            stat,dump,dump,dump = self.PolSQL.Execute(InsN,1)

            if stat != 'OK':
                stat = 'Bd dodawania nagwka korekty: '+stat
                dane.append(stat)

            if stat == 'OK':
                TerminPlat = "UPDATE rs_korekty SET termin_zaplaty = (date'"+DataK+"'+ interval '"+str(trN.GetVal(0,'dni'))+" days')"
                TerminPlat+=" WHERE firma_id='"+FirmaK+"' and wyznacznik_id='"+WyznK+"' and data='"+DataK+"' and numer='"+str(NrK)+"';"

                stat,dump,dump,dump = self.PolSQL.Execute(TerminPlat,1)
                if stat != 'OK':
                    stat = 'Bd aktualizacji terminu zapaty korekty: '+stat
                    dane.append(stat)

            if stat == 'OK':
                stat = fs_sprzedaz_pom.PrzeniesUdzialyHandlowcowZFakturyDoKorekty(self,WyznK,DataK,NrK)
    
            #-- update korekty
            if stat == 'OK':
                U = "UPDATE rs_korekty SET kurs_p=kurs, nr_tabeli_p=nr_tabeli,data_tabeli_p=data_tabeli,"
                U+= "wersja_p=wersja,sposob_zaplaty_p=sposob_zaplaty,dni_p=dni,data_odbioru_p=data_odbioru,"
                U+= "upust_p=upust,upust_wartosc_p=upust_wartosc,upust_wartosc_wal_p=upust_wartosc_wal,"
                U+= "rabat_p=rabat,rabat_wartosc_p=rabat_wartosc,rabat_wartosc_wal_p=rabat_wartosc_wal,"
                U+= "kwota_netto_p=kwota_netto,kwota_vat_p=kwota_vat,wartosc_opakowan_p=wartosc_opakowan,do_zaplaty_p=do_zaplaty,"
                U+= "kwota_netto_wal_p=kwota_netto_wal,kwota_vat_wal_p=kwota_vat_wal,wartosc_opakowan_wal_p=wartosc_opakowan_wal,do_zaplaty_wal_p=do_zaplaty_wal"
                U+= " WHERE firma_id='"+FirmaK+"' AND wyznacznik_id='"+WyznK+"' AND data='"+DataK+"' AND numer="+str(NrK)+";"
                
                stat,dump,dump,dump = self.PolSQL.Execute(U,1)
                if stat != 'OK':
                    stat = 'Bd modyfikacji danych korekty: '+stat
                    dane.append(stat)
    
            #-- ptla po pozycjach w celu dodania pozycji na korekt
            if stat == 'OK':
                Ins=""
                for art in SPoz:
                    d=SPoz[art]
                    upustW=round((d["cena_netto1"]-d["cena_upust1"])*d["ilosc1"],2)
                    wartN=round(d["cena_upust1"]*d["ilosc1"],2)
                    if d["stawka_vat"] in ("zw","np"):
                        wartV=0
                    else:
                        wartV=round(wartN*int(d["stawka_vat"])*0.01,2)
        
                    if Waluta != "PLN":
                        wartNWal=round(wartN/Kurs,2)
                        wartVWal=round(wartV/Kurs,2)
                    else:
                        wartNWal=wartN
                        wartVWal=wartV
        
                    NrSerii=d["nr_serii"]
                    if NrSerii=='None':
                        NrSerii="NULL"
                    else:
                        NrSerii="'"+NrSerii+"'"
        
                    TermPrz=d["termin_przyd"]
                    if TermPrz=='None':
                        TermPrz="NULL"
                    else:
                        TermPrz="'"+TermPrz+"'"
        
                    CechaOpis=d["cecha1_opis"]
                    CechaWart=d["cecha1_wartosc"]
        
                    Ins+="INSERT INTO rs_korekty_pozycje (firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,"
                    Ins+="cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,ilosc1_p,ilosc2_p,cena_netto1_p,cena_netto2_p,"
                    Ins+="cena_upust1_p,cena_upust2_p,cena_brutto1_p,cena_brutto2_p,upust_p,upust_wartosc_p,stawka_vat_p,wartosc_netto_p,wartosc_vat_p,wartosc_brutto_p,"
                    Ins+="nr_serii,termin_przyd,cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
                    Ins+= "cena_wal1_p,cena_wal2_p,cena_upust_wal1_p,cena_upust_wal2_p,wartosc_wal_netto_p,wartosc_wal_vat_p,wartosc_wal_brutto_p, cecha1_opis,cecha1_wartosc)"
                    Ins+=" VALUES ('"+FirmaK+"','"+WyznK+"','"+DataK+"',"+str(NrK)+","
                    Ins+= str(d["nr_poz"])+","+str(d["nr_ppoz"])+",'"+d["artykul_id"]+"',"+str(d["ilosc1"])+","+str(d["ilosc2"])+","
                    Ins+= str(d["cena_netto1"])+","+str(d["cena_netto2"])+","+str(d["cena_upust1"])+","+str(d["cena_upust2"])+","
                    Ins+= str(d["cena_brutto1"])+","+str(d["cena_brutto2"])+","+str(d["upust"])+","+str(upustW)+","
                    Ins+= "'"+d["stawka_vat"]+"',"+str(wartN)+","+str(wartV)+","+str(wartN+wartV)+","
                    Ins+= str(d["ilosc1"])+","+str(d["ilosc2"])+","
                    Ins+= str(d["cena_netto1"])+","+str(d["cena_netto2"])+","+str(d["cena_upust1"])+","+str(d["cena_upust2"])+","
                    Ins+= str(d["cena_brutto1"])+","+str(d["cena_brutto2"])+","+str(d["upust"])+","+str(upustW)+","
                    Ins+= "'"+d["stawka_vat"]+"',"+str(wartN)+","+str(wartV)+","+str(wartN+wartV)+","
                    Ins+= NrSerii+","+TermPrz+","
                    Ins+= str(d["cena_wal1"])+","+str(d["cena_wal2"])+","+str(d["cena_upust_wal1"])+","+str(d["cena_upust_wal2"])+","
                    Ins+= str(wartNWal)+","+str(wartVWal)+","+str(wartNWal+wartVWal)+","
                    Ins+= str(d["cena_wal1"])+","+str(d["cena_wal2"])+","+str(d["cena_upust_wal1"])+","+str(d["cena_upust_wal2"])+","
                    Ins+= str(wartNWal)+","+str(wartVWal)+","+str(wartNWal+wartVWal)+",'"+CechaOpis+"','"+CechaWart+"'); "
                
                stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)
                if stat != 'OK':
                    stat = 'Bd dodawania pozycji korekty: '+stat
                    dane.append(stat)
    
            #-- wstawienie stawek VAT
            if stat == 'OK':
                Ins=""
                for st in SVat:
                    if Waluta=="PLN":
                       NWal=SVat[st][0]
                       VWal=SVat[st][1]
                    else:
                       NWal=round(SVat[st][0]/Kurs,2)
                       VWal=round(SVat[st][1]/Kurs,2)
        
                    Ins+="INSERT INTO rs_korekty_vat VALUES ('"+FirmaK+"','"+WyznK+"','"+DataK+"',"+str(NrK)+","
                    Ins+= "'"+st+"',"+str(SVat[st][0])+","+str(SVat[st][1])+","+str(SVat[st][0]+SVat[st][1])+","
                    Ins+= str(NWal)+","+str(VWal)+","+str(NWal+VWal)+","
                    Ins+= str(SVat[st][0])+","+str(SVat[st][1])+","+str(SVat[st][0]+SVat[st][1])+","
                    Ins+= str(NWal)+","+str(VWal)+","+str(NWal+VWal)+"); "
                
                stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)
                if stat != 'OK':
                    stat = 'Bd dodawania danych VAT dla korekty: '+stat
                    dane.append(stat)
    


    #-------------------------------------------------
    # SEKCJA TWORZENIA KOREKTY W ANAKONDZIE
    #-------------------------------------------------
    #-- zmienna "Dane" jest pobierana na samej gorze przy tescie do czego tworzymy korekte

    if stat == 'OK' and not ZImportu:
        #sprawdzenie korekt do faktury
        while len(Dane) > 0:
            if Dane[0][3] in ('W','G'):
                stat = 'BL STAN'
                dane.append(stat)
                break
                
            Orginal = "K"
            WyznO = rsglobal.Dekoduj(Dane[0][0])
            DataO = rsglobal.Dekoduj(Dane[0][1])
            NrO = Dane[0][2]

            sql = "SELECT wyznacznik_id,data,numer,stan FROM rs_korekty"
            sql+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id_p='"+WyznO+"'"
            sql+=" AND data_p='"+DataO+"' AND numer_p="+str(NrO)
            sql+=" AND typ_dok_p='K';"
            
            stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd odczytania poprzedniej korekty: '+stat
                dane.append(stat)
                break
            
            
        if stat == 'OK':
            if DataK < DataO:
                stat = 'BL DATAO'
                dane.append(stat)
                
        if stat == 'OK':
            sql = "SELECT * FROM "
            if Orginal == 'F':
                sql+="rs_faktury"
            else:
                sql+="rs_korekty"
                
            sql+= " WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
            sql+=" AND data='"+DataO+"' AND numer="+str(NrO)+";"
            
            stat,Dane,wyn1,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bad pobrania danych z faktury/korekty: '+stat
                dane.append(stat)
            elif len(Dane) != 1:
                stat = 'Bdny zakres odczytanych dokumentw'
                dane.append(stat)
            
        if stat == 'OK':
            tr = rssql.RSTableRowset(Dane,wyn1)
    
            SposOdb=tr.GetVal(0,'sposob_odbioru_faktury')
            if SposOdb=='None':
                SposOdb="NULL"
            else:
                SposOdb="'"+SposOdb+"'"
    
            SposDost=tr.GetVal(0,'sposob_dostawy')
            if SposDost=='None':
                SposDost="NULL"
            else:
                SposDost="'"+SposDost+"'"
    
            Projekt=tr.GetVal(0,'projekt_id')
            if Projekt=='None':
                Projekt="NULL"
            else:
                Projekt="'"+Projekt+"'"
        
            Bonus=tr.GetVal(0,'czy_bonus')
            if Bonus:
                Bonus="TRUE"
            else:
                Bonus="FALSE"
            #AB 01.08.19r
            MPP=tr.GetVal(0,'czy_mpp')
            if MPP:
                MPP="TRUE"
            else:
                MPP="FALSE"

            Handlowiec=tr.GetVal(0,'handlowiec')
            if Handlowiec=='None':
                Handlowiec="NULL"
            else:
                Handlowiec="'"+Handlowiec+"'"
        
            Waluta=tr.GetVal(0,'waluta')
            Kurs=tr.GetVal(0,'kurs')
            
            NrTab=tr.GetVal(0,'nr_tabeli')
            if NrTab=='None':
                NrTab="NULL"
            else:
                NrTab="'"+NrTab+"'"
            
            DataTab=tr.GetVal(0,'data_tabeli')
            if DataTab=='None':
                DataTab="NULL"
            else:
                DataTab="'"+DataTab+"'"
        
            KrajOpodat=tr.GetVal(0,'kraj_opodatkowania')
            if KrajOpodat=='None':
                KrajOpodat="NULL"
            else:
                KrajOpodat="'"+KrajOpodat+"'"
            
            NiePodlegaVAT=tr.GetVal(0,'nie_podlega_vat')
        
            DataZaladunku=tr.GetVal(0,'data_zaladunku')
            if DataZaladunku=='None':
                DataZaladunku="NULL"
            else:
                DataZaladunku="'"+DataZaladunku+"'"
        
            NrSamochodu=tr.GetVal(0,'nr_samochodu')
            if NrSamochodu=='None':
                NrSamochodu="NULL"
            else:
                NrSamochodu="'"+NrSamochodu+"'"
            #RW sprawdzamy i ustawiamy osobny_rachunek_vat w zaleznoci od tego jaki jest w fakturze
            Waga=tr.GetVal(0,'waga')
            if Waga=='None':
                Waga="NULL"
            OsobneKVat = tr.GetVal(0, 'osobny_rachunek_vat')

            OznTrans = tr.GetVal(0, 'ozn_trans') #MK 2020-04-24
            if OznTrans == 'None':
                OznTrans = "NULL"
            else:
                OznTrans = "'" + OznTrans + "'"

            OznSprz = tr.GetVal(0, 'ozn_sprzedaz') #MK 2020-04-24
            if OznSprz == 'None':
                OznSprz = "NULL"
            else:
                OznSprz = "'" + OznSprz + "'"

            p = "stan,firma_id,wyznacznik_id,data,numer,oddzial_id,"
            p+= "kontrahent_id,zamawiajacy_id,"
            p+= "platnik_id,waluta,kurs,nr_tabeli,data_tabeli,"
            p+= "kurs_p,nr_tabeli_p,data_tabeli_p,"
            p+= "wersja,sposob_zaplaty,dni,"
            p+= "termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,"
            p+= "upust,upust_wartosc,"
            p+= "upust_wartosc_wal,rabat,"
            p+= "rabat_wartosc,rabat_wartosc_wal,"
            p+= "kwota_netto,kwota_vat,"
            p+= "wartosc_opakowan,kraj_opodatkowania,"
            p+= "do_zaplaty,kwota_netto_wal,"
            p+= "kwota_vat_wal,wartosc_opakowan_wal,"
            p+= "do_zaplaty_wal,"
            p+= "typ_dok_p,wyznacznik_id_p,data_p,numer_p,projekt_id,"
            p+= "czy_bonus,wyznacznik_id_o,data_o,numer_o,"         #AB 01.08.19r
            p+= "data_zaladunku, nr_samochodu, waga,osobny_rachunek_vat, czy_mpp, ozn_trans, ozn_sprzedaz " #MK 2020-04-24
        
            w = "'W','"+FirmaK+"','"+WyznK+"','"+DataK+"',"+str(NrK)+",'"+tr.GetVal(0,'oddzial_id')+"',"
            w+= "'"+tr.GetVal(0,"kontrahent_id")+"','"+tr.GetVal(0,"zamawiajacy_id")+"',"
            w+= "'"+tr.GetVal(0,'platnik_id')+"','"+Waluta+"',"+str(Kurs)+","+NrTab+","+DataTab+","
            w+= str(Kurs)+","+NrTab+","+DataTab+","
            w+= " NULL,'"+tr.GetVal(0,'sposob_zaplaty')+"',"+str(tr.GetVal(0,'dni'))+","
            w+= "'"+tr.GetVal(0,'termin_zaplaty')+"',"+Handlowiec+","+SposOdb+","+SposDost+","
            w+= str(tr.GetVal(0,'upust'))+","+str(tr.GetVal(0,'upust_wartosc'))+","
            w+= str(tr.GetVal(0,'upust_wartosc_wal'))+","+str(tr.GetVal(0,'rabat'))+","
            w+= str(tr.GetVal(0,'rabat_wartosc'))+","+str(tr.GetVal(0,'rabat_wartosc_wal'))+","
            w+= str(tr.GetVal(0,'kwota_netto'))+","+str(tr.GetVal(0,'kwota_vat'))+","
            w+= str(tr.GetVal(0,'wartosc_opakowan'))+","+KrajOpodat+","
            w+= str(tr.GetVal(0,'do_zaplaty'))+","+str(tr.GetVal(0,'kwota_netto_wal'))+","
            w+= str(tr.GetVal(0,'kwota_vat_wal'))+","+str(tr.GetVal(0,'wartosc_opakowan_wal'))+","
            w+= str(tr.GetVal(0,'do_zaplaty_wal'))+","
            w+= "'"+Orginal+"','"+WyznO+"','"+DataO+"',"+str(NrO)+","+Projekt+","
            w+= Bonus+",'"+WyznOrg+"','"+DataOrg+"',"+str(NrOrg)+","        #AB 01.08.19r
            w+= DataZaladunku+","+NrSamochodu+","+str(Waga)+","+str(OsobneKVat)+","+MPP+","+OznTrans+","+OznSprz

            Insert = "INSERT INTO rs_korekty ("+p+") VALUES ("+w+");"
            stat,dump,dump,dump = self.PolSQL.Execute(Insert,1)
            if stat != 'OK':
                stat = 'Bd dodawania nagwka korekty: '+stat
                dane.append(stat)

        if stat == 'OK':
            stat = fs_sprzedaz_pom.PrzeniesUdzialyHandlowcowZFakturyDoKorekty(self,WyznK,DataK,NrK)    
            
        if stat == 'OK':
            #termin platnosci
            UPD = "UPDATE rs_korekty SET"
            UPD+=" termin_zaplaty = (date'"+DataK+"'+ interval '"+str(tr.GetVal(0,"dni"))+" days')"
            UPD+=" WHERE firma_id='"+FirmaK+"' and wyznacznik_id='"+WyznK+"'"
            UPD+=" AND data='"+DataK+"' AND numer='"+str(NrK)+"';"
            stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
            if stat != 'OK':
                stat = 'Bd aktualizacji terminu patnoi: '+stat
                dane.append(stat)
            
            U = "UPDATE rs_korekty SET kurs_p=kurs, nr_tabeli_p=nr_tabeli,data_tabeli_p=data_tabeli,"
            U+= " wersja_p=wersja,sposob_zaplaty_p=sposob_zaplaty,dni_p=dni,data_odbioru_p=data_odbioru,"
            U+= " upust_p=upust,upust_wartosc_p=upust_wartosc,upust_wartosc_wal_p=upust_wartosc_wal,"
            U+= " rabat_p=rabat,rabat_wartosc_p=rabat_wartosc,rabat_wartosc_wal_p=rabat_wartosc_wal,"
            U+= " kwota_netto_p=kwota_netto,kwota_vat_p=kwota_vat,wartosc_opakowan_p=wartosc_opakowan,"
            U+= " do_zaplaty_p=do_zaplaty,kwota_netto_wal_p=kwota_netto_wal,kwota_vat_wal_p=kwota_vat_wal,"
            U+= " wartosc_opakowan_wal_p=wartosc_opakowan_wal,do_zaplaty_wal_p=do_zaplaty_wal"
            U+= " WHERE firma_id='"+FirmaK+"' AND wyznacznik_id='"+WyznK+"'"
            U+= " AND data='"+DataK+"' AND numer="+str(NrK)+";"

            stat,dump,dump,dump = self.PolSQL.Execute(U,1)
            if stat != 'OK':
                stat = 'Bd aktualizacji nagwka korekty: '+stat
                dane.append(stat)
                
        if stat == 'OK':
            Ins = "INSERT INTO rs_korekty_pozycje (firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,"
            Ins+= "cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,ilosc1_p,ilosc2_p,cena_netto1_p,cena_netto2_p,"
            Ins+= "cena_upust1_p,cena_upust2_p,cena_brutto1_p,cena_brutto2_p,upust_p,upust_wartosc_p,stawka_vat_p,wartosc_netto_p,wartosc_vat_p,wartosc_brutto_p,"
            Ins+= "nr_serii,termin_przyd,cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
            Ins+= "cena_wal1_p,cena_wal2_p,cena_upust_wal1_p,cena_upust_wal2_p,wartosc_wal_netto_p,wartosc_wal_vat_p,wartosc_wal_brutto_p,"
            Ins+= "cecha1_opis,cecha1_wartosc,zestaw,kod_gtu) "  #MK 2020-03-27
            Ins+= "(SELECT '"+FirmaK+"','"+WyznK+"','"+DataK+"',"+str(NrK)+","
            Ins+= "nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
            Ins+= "cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
            Ins+= "ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
            Ins+= "cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
            Ins+= "nr_serii,termin_przyd,"
            Ins+= "cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
            Ins+= "cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
            Ins+= "COALESCE(cecha1_opis,''),COALESCE(cecha1_wartosc,''),zestaw,kod_gtu "  #MK 2020-03-27
            if Orginal=="F":
                Ins += "FROM rs_faktury_pozycje "
            else:
                Ins += "FROM rs_korekty_pozycje "
                
            Ins+= "WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
            Ins+=" AND data='"+DataO+"' AND numer="+str(NrO)+");"
            stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)
            if stat != 'OK':
                stat = 'Bd dodawania pozycji korekty: '+stat
                dane.append(stat)
                
        if stat == 'OK':    
            Ins = "INSERT INTO rs_korekty_pozycje_opisowe "
            Ins+="(firma_id,wyznacznik_id,data,numer,nr_poz,opis_pozycji,stawka_vat,wartosc_netto," #MK 2020-03-27
            Ins+="wartosc_vat,wartosc_brutto,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,opis_pozycji_p," #MK 2020-03-27
            Ins+="stawka_vat_p,wartosc_netto_p,wartosc_vat_p,wartosc_brutto_p,wartosc_wal_netto_p,wartosc_wal_vat_p,wartosc_wal_brutto_p,kod_gtu) " #MK 2020-03-27
            Ins+= "(SELECT \'"+FirmaK+"\',\'"+WyznK+"\',\'"+DataK+"\',"+str(NrK)+","
            Ins+= "nr_poz,opis_pozycji,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
            Ins+= "wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
            Ins+= "opis_pozycji,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
            Ins+= "wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto, kod_gtu " #MK 2020-03-27
            if Orginal=="F":
                Ins += "FROM rs_faktury_pozycje_opisowe "
            else:
                Ins += "FROM rs_korekty_pozycje_opisowe "
                
            Ins+= "WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
            Ins+=" AND data='"+DataO+"' AND numer="+str(NrO)+");"
            
            stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)
            if stat != 'OK':
                stat = 'Bd dodawania pozycji opisowych korekty: '+stat
                dane.append(stat)

        if stat == 'OK':
            Ins = "INSERT INTO rs_korekty_vat"
            Ins+=" (SELECT '"+FirmaK+"','"+WyznK+"','"+DataK+"',"+str(NrK)+","
            Ins+= " stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"
            Ins+= " wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,"
            Ins+= " wartosc_netto,wartosc_vat,wartosc_brutto,"
            Ins+= " wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto "
            if Orginal=="F":
                Ins+=" FROM rs_faktury_vat"
            else:
                Ins+= " FROM rs_korekty_vat"
            
            Ins+=" WHERE firma_id='"+FirmaO+"' AND wyznacznik_id='"+WyznO+"'"
            Ins+=" AND data='"+DataO+"' AND numer="+str(NrO)+");"
            
            stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)
            if stat != 'OK':
                stat = 'Bd dodawania danych VAT dla korekty: '+stat
                dane.append(stat)

    
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH(3)
#-------------------------------------------------------------------------------

if Fun == 3  and stat=='OK':
    if not ((self.oddzial_id,'023015') in self.uprawnienia) and (self.operator_id != STANDARD_OPERATOR_ID):
        stat = 'UPR UPD'
        
    if stat=='OK':     
        klucz = klucze[0]
        wart = klucze[1]
        
        WyznK = rsglobal.Dekoduj(klucz[0])
        DataK = rsglobal.Dekoduj(klucz[1])
        NrK = str(klucz[2])
        
        WyznN = rsglobal.Dekoduj(wart[0])
        DataN = rsglobal.Dekoduj(wart[1])
        NrN = str(wart[2])
        
        
    # sprawdzenie stanu zmienianej korekty    
    SQL="SELECT stan, data_o FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznK+"' "
    SQL+=" AND data=\'"+DataK+"\' AND numer="+str(NrK)
    stat,dkor,dump,dump = self.PolSQL.Execute(SQL,3)

    
    if stat=='OK':
        if len(dkor)==0:
            stat='BR KOR'
        elif dkor[0][0] != 'W':
            stat='BL STAN KOR'

    # sprawdzenie czy data jest ok
    if stat=='OK':
        if not rsglobal.SprawdzCzyToData(DataN):
            stat='BL DATAN'
        
    if stat=='OK':
        if DataK != DataN:
            if DataN<dkor[0][1]:
                stat='DATA KOR ZA MALA'
    
    #sprawdzenie, czy s uprawnienia do wyznacznika pierwotnego
    if stat=='OK':
        if self.operator_id != STANDARD_OPERATOR_ID:
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            ListaUpr='[False,True,False,False,False,False]'
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','"+ListaUpr+"');"    
        
            stat,DaneW,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LWyzn=rsglobal.rseval(DaneW[0][0])[1]
                Buf=str(WyznK)+'  '
                Buf=Buf[0:2]
                if not Buf in LWyzn:
                    stat="BL UPR WYZNK"
    
            #sprawdzenie, czy s uprawnienia do wyznacznika nowego
            if stat=='OK':
                if WyznK != WyznN:
                    Buf=str(WyznN)+'  '
                    Buf=Buf[0:2]
                    if not Buf in LWyzn:
                        stat="BL UPR WYZNN"
                    
    #sprawdzenie czy nowy wyznacznik jest wyznacznikiem korekty
    if stat=='OK':
        stat,d,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id,czy_korekta,typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznN+"';",3)
        if stat=='OK':
            if len(d) == 0:
                stat = "BL WYZN" 

        if stat=='OK':
            if not d[0][1]:
                stat = "WYZN FAKT" 

        if stat=='OK':
            if not d[0][2] in ('BP','DU','EK','KR','WW','ZA','ZU'):
                stat = "BL TYP KOR"

    #sprawdzenie czy nowy klucz nie istnieje
    if stat=='OK':
        SQL="SELECT wyznacznik_id FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznN+"' "
        SQL+=" AND data=\'"+DataN+"\' AND numer="+str(NrN)
        stat,dkor,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(dkor)>0:
                stat='UZ KLUCZ'
    
    #sprawdzenie czy mona zmieni klucz Z pierwotnego numeru
    if stat=='OK':
        stat,dtest,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\\\'"+WyznK+"\\\',\\\'"+DataK+"\\\',"+NrK+"]','K');",3)            
        
    if stat=='OK':
        if dtest[0][0]<>'OK':
            stat="NM UKOR"
            
    #sprawdzenie czy mona zmieni klucz NA nowy numer
    if stat=='OK':
        stat,dtest,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+WyznN+"\\\',\\\'"+DataN+"\\\']','K');",3)            
        
    if stat=='OK':
        if dtest[0][0]<>'OK':
            stat="NM DKOR"
    
    #wszystko jest ok -zmieniamy klucz
    if stat=='OK':
        SQL="UPDATE rs_korekty SET wyznacznik_id='"+WyznN+"', data='"+DataN+"',numer="+NrN
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznK+"' AND data='"+DataK+"' AND numer="+str(NrK)
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)