# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_korekty_pom.py
# Purpose:		funkcje pomocnicze do obslugi korekt
# Author:		Mariusz Rajfura
# Created:		2012/07/16
# RCS-ID:		$Id: fs_korekty_pom.py $
# Copyright:	(c) 2012 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------


#-------------------------------------------------------------------------------
# Funkcja wstawia do korekty date wplywu i date odbioru korekty z uwzglednieniem
# daty delaracji VAT (25 dzien miesiaca) i przesunieciem, jesli to dzien swiateczny.
# Funkcja uwzglednia, czy platnik ma zaznaczone w danych do fakturowania
# blokade 'nie_uzupelniac_dat_wplywu'
#-------------------------------------------------------------------------------

def WstawDateWplywuIOdbioru(objSQL, Firma, Wyznacznik, Data, Numer, DataOdbioru, DataWplywu, Typ='R'):
    import rs_anakonda_daty
    import rsglobal
    import rssql
    
    if not rsglobal.SprawdzCzyToData(DataWplywu):
        return 'Bdna data wpywu.',''

    if not rsglobal.SprawdzCzyToData(DataOdbioru):
        return 'Bdna data odbioru.',''
    
    sql = "SELECT * FROM rs_korekty"
    sql+=" WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" AND data_wplywu IS NULL AND data_odbioru IS NULL;"
    
    stat,d,n,dump = objSQL.Execute(sql,3)
    if stat <> 'OK':
        return stat, 'Bd pobrania danych korekty: '+stat
    
    if len(d) == 0:
        # to nie jest blad tylko informacja, bo podana korekta moze miec
        # wpisane daty wpywu i odbioru
        return stat, 'Brak korekty o podanym kluczu.'
    
    # czy platnik ma blokade wstawiania dat wplywu
    tr = rssql.RSTableRowset(d,n)
    sql ="SELECT nie_uzupelniac_dat_wplywu FROM rs_kontrahenci_fakturowanie"
    sql+=" WHERE firma_id='"+Firma+"' AND kontrahent_id='"+tr.GetVal(0,"platnik_id")+"'"
    sql+=" AND data_od<='"+tr.GetVal(0,"data")+" 'ORDER BY data_od DESC LIMIT 1;"
    
    stat,df,dump,dump = objSQL.Execute(sql,3)
    if stat <> 'OK':
        return stat, 'Bd pobrania danych do fakturowania dla platnika: '+stat
        
    if len(df) == 1:
        if df[0][0]:
            # to nie jest blad tylko informacja
            return stat, 'Patnik ma blokad na wstawianie dat wpywu i odbioru.'
    
    # to oznacza, ze nalezy mu wstawic daty

    # czy to 25, czyli dzien skladania deklaracji, to przesuwamy na nastepny dzien        
    if int(DataWplywu[8:10]) == 25:
        DataWplywu = rs_anakonda_daty.DodajKilkaDni(DataWplywu, 1)
        
    # przesuwamy date wplywu az do dnia roboczego
    while not rs_anakonda_daty.CzyRoboczy(rs_anakonda_daty.ZamienDate(DataWplywu)):
        DataWplywu = rs_anakonda_daty.DodajKilkaDni(DataWplywu, 1)

    if DataWplywu < Data:
        DataWplywu = 'NULL'
    else:
        DataWplywu = "'"+DataWplywu+"'"

    # czy to 25, czyli dzien skladania deklaracji, to przesuwamy na nastepny dzien            
    if int(DataOdbioru[8:10]) == 25:
        DataOdbioru = rs_anakonda_daty.DodajKilkaDni(DataOdbioru, 1)
        
    # przesuwamy date odbioru az do dnia roboczego
    while not rs_anakonda_daty.CzyRoboczy(rs_anakonda_daty.ZamienDate(DataOdbioru)):
        DataOdbioru = rs_anakonda_daty.DodajKilkaDni(DataOdbioru, 1)
            
    if DataOdbioru < Data:
        DataOdbioru = 'NULL'
    else:
        DataOdbioru = "'"+DataOdbioru+"'"
    
    UPD ="UPDATE rs_korekty SET data_wplywu="+DataWplywu+", data_odbioru="+DataOdbioru+",data_sposob='"+Typ+"'"
    UPD+=" WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    UPD+=" AND numer="+str(Numer)+";"
    
    stat,dump,dump,dump = objSQL.Execute(UPD,1)
    if stat <> 'OK':
        return stat, 'Bd aktualizacji korekty: '+stat
    
    return stat,''
