# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_korekty_pozycje_dane.py
# Purpose:     sprawdza uprawnienia (kiedys-wczytuje/edytuje dane dotyczace pozycji korekty)
#-------------------------------------------------------------------------------
# Author:      Micha Raburski, Dariusz Boduch - (wczytywanie/edycja pozycji)
# Created:     2008/07/07, dodanie wczytywania/edycji - 2009/01/11
# RCS-ID:      $Id:$
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#
# 2010-11-25 - Mariusz Rajfura - (4096) edytowalna stawka VAT, kontrola zgodnosci
#                                       z terminem obowiazywania (tylko ostrzezenie)
# 2011-11-23 - Mariusz Rajfura - (5078) uszczelnie: kontrola stanu przed zapisem
# 2014-02-06 - Konrad Opieka   - (7646) dodanie cech
# 2020-03-30 - Mikoaj Kozowski - (11907) pobranie opisu kodu towarw i usug
#-------------------------------------------------------------------------------


Wyznacznik=rsglobal.Dekoduj(klucze[0]) 
Data=rsglobal.Dekoduj(klucze[1]) 
Numer=rsglobal.Dekoduj(klucze[2]) 
Poz=rsglobal.Dekoduj(klucze[3]) 
Ppoz=rsglobal.Dekoduj(klucze[4])
Artykul=rsglobal.Dekoduj(klucze[5])
Fun=klucze[-1]

#w celach informacyjno rozeznaniowych
stat='OK'
Pola=pola
Wartosci=wartosci
dane=[]
wyn2=[]
puste_pola = [[],"","    -  -  "]

UprStawkaVAT = ((self.oddzial_id,'023027') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
StawkaVATPozaTerminem = False

if self.operator_id != STANDARD_OPERATOR_ID:
    UprEdycja = ((self.oddzial_id,'023022') in self.uprawnienia)
    
    if UprEdycja:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprEdycja=(Wyznacznik in LWyzn)
else:
    UprEdycja = True


#-------------------------------------------------------------------------------
#   pobranie informacji o cechach (25)
#-------------------------------------------------------------------------------

if (Fun == 25) and stat=='OK': 
    # wraca [cecha, opis cechy, liczba wartoci, domylna warto]
    SQL ="SELECT TRIM(COALESCE(cecha1_opis,'')) FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,DCecha,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = u'Bdy pobierania danych cechy artykuu : '+stat
    if stat == 'OK':
        if len(DCecha)==0:
            dane=['','',0,'']
        elif DCecha[0][0] == '':
            dane=['','',0,'']
        else:
            dane.append(DCecha[0][0])
        
            SQL = "SELECT TRIM(COALESCE(opis,'')) FROM rs_artykuly_cechy WHERE firma_id='"+self.firma_id+"' AND kod='"+DCecha[0][0]+"';"
            stat,DOpisyCechy,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd pobrania opisu cechy artykuu : '+stat
            else:
                dane.append(DOpisyCechy[0][0])
    
            if stat == 'OK':
                SQL="SELECT wartosc,domyslna FROM rs_artykuly_cechy_wartosci WHERE firma_id='"+self.firma_id+"' AND kod='"+DCecha[0][0]+"'"
                stat,DWartCechy,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania wartoci cechy artykuu : '+stat
                else:
                    dane.append(len(DWartCechy))
                    
                Dom=False
                for poz in DWartCechy:
                    if not Dom:
                        if poz[1]:
                            dane.append(poz[0])
                            Dom =True
                if not Dom:
                    dane.append('')
        

#-------------------------------------------------------------------------------
#--- Sprawdzenie walut (9)
#-------------------------------------------------------------------------------

if (Fun == 9) and stat=='OK': #sprawdzam walute
    dane=[]
    sql = "SELECT waluta,kurs,upust,wersja FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+";" 
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    
    if stat<>'OK':
        stat='BL DANE KOR' 
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- Sprawdzenie przelicznikow (11)
#-------------------------------------------------------------------------------

if (Fun == 11) and stat=='OK' :
    dane = []
    sql = "SELECT przelicznik,jm1,jm2,dynamiczny_przelicznik,faktura_w_jm2 FROM rs_artykuly WHERE artykul_id='"+Wyznacznik+"' AND firma_id = '"+self.firma_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL DANE KOR'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if UprEdycja:
    if Fun in [3,4] and stat=='OK':
        # kontrola stanu
        sql ="SELECT stan FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu korekty: '+stat
        elif len(d) == 0:
            stat = 'Brak korekty o podanym kluczu.'
        elif d[0][0] <> 'W':
            stat = 'Korekta w stanie '+d[0][0]+'. Zapis zmian niemoliwy.'
    

    if Fun in [3,4] and stat=='OK':
        BufIlosc=0
        BufCena=0
        BufIloscP=0
        BufCenaP=0
        BufStawkaVAT=''
        BufStawkaVATP=''
        BufCenaNetto=0
        BufCenaNettoP=0
        
        if Data in puste_pola:
            stat = "BL KLUCZ"
            dane.append(stat)
            
        if stat=='OK':
            dane_wyn = rsglobal.SprawdzCzyToData(Data)   
            if not dane_wyn:
                stat = "BL KLUCZ"
            
            Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
            sql="SELECT wyznacznik_id FROM rs_korekty WHERE "+Filtr+";"
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
            if stat=='OK':
                if len(dane_wyn) == 0:
                    stat = "BL KLUCZ"
                    dane.append(stat)
          
        if stat == "OK":
            dane = []
            NrPoz = Poz
            i = 0
            
            if 'ilosc1' in Pola or 'cena_brutto1' in Pola or 'stawka_vat' in Pola or 'cena_netto1' in Pola:
                sql ="SELECT ilosc1,cena_brutto1,ilosc1_p,cena_brutto1_p,"
                sql+=" stawka_vat, cena_netto1, cena_netto1_p" 
                sql+=" FROM rs_korekty_pozycje WHERE "
                sql+=" firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                sql+=" AND numer="+Numer+" AND nr_poz="+str(Poz)+";"
                stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3)
                if stat=='OK':
                    BufIlosc=Dane[0][0]
                    BufCena=Dane[0][1]
                    BufIloscP=Dane[0][2]
                    BufCenaP=Dane[0][3]
                    BufStawkaVATP=rsglobal.Dekoduj(Dane[0][4])
                    BufStawkaVAT=BufStawkaVATP
                    BufCenaNetto=Dane[0][5]
                    BufCenaNettoP=Dane[0][6]
                    

        if stat=='OK':
            art_id = None
            if 'artykul_id' not in Pola and ('nr_serii' in Pola or 'termin_przyd' in Pola):
                sql = "SELECT artykul_id FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)+";"
                stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3)
                if stat=='OK':
                    if Dane in puste_pola:
                        stat = "BL ART"
                        dane.append(stat)
                    else:
                        art_id = Dane[0][0]

        if stat=='OK':
            for pole in Pola:
                wart = Wartosci[i]
                if pole=='nr_poz':
                    if wart < 1:
                        stat = "BL NRPOZYCJI"
                        dane.append(stat)
                    sql = "SELECT nr_poz FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(wart)+";"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane <> []:
                        stat = "BR NRPOZYCJI"
                        dane.append(stat)
                elif pole == 'ilosc1':
                    BufIlosc=wart                   
                elif pole == 'artykul_id':
                    if wart == '':
                        stat = "BR ART"
                        dane.append(stat)
                    sql = "SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = "BL ART"
                        dane.append(stat)
                    else:
                        art_id = wart
                elif pole == 'cena_netto1':
                    BufCenaNetto = wart
                    if wart < 0:
                        stat = "BL CENANETTO1"
                        dane.append(stat)
                elif pole == 'cena_netto2':
                    if wart < 0:
                        stat = "BL CENANETTO2"
                        dane.append(stat)
                elif pole == 'cena_brutto1':
                    BufCena=wart
                    if wart < 0:
                        stat = "BL CENABRUTTO1"
                        dane.append(stat)
                elif pole == 'cena_brutto2':
                    if wart < 0:
                        stat = "BL CENABRUTTO2"
                        dane.append(stat)
                elif pole == 'nr_serii':
                    sql = "SELECT czy_seria FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(art_id)+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = "BR ART"
                        dane.append(stat)
                    if Dane[0][0] and wart in puste_pola: #czy seria
                        stat = "BR SERIA"
                        dane.append(stat)
                elif pole == 'termin_przyd':
                    sql = "SELECT czy_termin FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(art_id)+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = "BR ART"
                        dane.append(stat)

                    if wart in puste_pola:
                        if Dane[0][0]: #czy termin
                            stat = "BR TERMIN"
                            dane.append(stat)
                    elif not rsglobal.SprawdzCzyToData(wart):
                        stat = "BL TERMIN"
                        dane.append(stat)
                        
                elif pole == 'stawka_vat':
                    wart = rsglobal.Dekoduj(wart).strip()
                    BufStawkaVAT = wart
                    
                    if not UprStawkaVAT:
                        stat = 'BR UPR STAWKA_VAT'
                        dane.append(stat)
                    
                    if stat == 'OK':
                        if wart == '':
                            stat = 'BR STAWKA_VAT'
                            dane.append(stat)
                    
                    if stat == 'OK':
                        sql ="SELECT kod FROM rs_stawki_vat WHERE kod='"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia stawki VAT: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'BL STAWKA_VAT'
                            dane.append(stat)
                    
                    if stat == 'OK':
                        sql ="SELECT COALESCE(f.data_przychodu,f.data) FROM rs_faktury f"
                        sql+=" INNER JOIN rs_korekty k"
                        sql+=" ON (f.firma_id=k.firma_id AND f.wyznacznik_id=k.wyznacznik_id_o AND f.data=k.data_o)"
                        sql+=" WHERE k.firma_id='"+self.firma_id+"'"
                        sql+=" AND k.wyznacznik_id='"+Wyznacznik+"' AND k.data='"+Data+"'"
                        sql+=" AND k.numer="+str(Numer)+";"
                        
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd pobrania daty sprzeday z faktury rdowej: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'Brak faktury rdowej.'
                            dane.append(stat)
                        else:
                            DataSprzedazy = rsglobal.Dekoduj(d[0][0])
                    
                    if stat == 'OK':
                        sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                        sql+=" WHERE stawka_vat='"+wart+"'"
                        sql+=" AND '"+DataSprzedazy+"'>=od_dnia"
                        sql+=" AND CASE WHEN do_dnia IS NULL"
                        sql+=" THEN TRUE ELSE '"+DataSprzedazy+"'<=do_dnia END;"
                        
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            #informacja zwrotna, ze podana stawka VAT nie zgadza sie
                            #z terminem jej obowiazywania
                            StawkaVATPozaTerminem = True
                        
                i= i+1

            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]        

            if stat == 'OK':
                if BufIlosc<>BufIloscP and BufStawkaVAT<>BufStawkaVATP:
                    stat='ILOSC I STAWKA_VAT NA RAZ'
                    dane.append(stat)
            
                elif BufCenaNetto<>BufCenaNettoP and BufStawkaVAT<>BufStawkaVATP:
                    stat='CENA I STAWKA_VAT NA RAZ'
                    dane.append(stat)

                elif BufIlosc<>BufIloscP and BufCena<>BufCenaP:
                    stat='KWOTA I ILOSC NA RAZ'
                    dane.append(stat)

     
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [3,4]:
    dane = []
    sql = "UPDATE rs_korekty_pozycje SET "
    Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)
    for i in range(len(Pola)):
        wart = Wartosci[i]
        pole = Pola[i]
        if pole in ['artykul_id','nr_serii','stawka_vat','cecha1_opis','cecha1_wartosc']:
            sql += pole+"='"+str(wart)+"',"
        elif pole in ['termin_przyd']:
            sql += pole+"="
            if wart in puste_pola:
                sql += "NULL,"
            else:
                sql += "'"+str(wart)+"',"
        elif wart == "NULL":
            sql += pole+"="+str(wart)+","
        else:
            sql += pole+"="+str(wart)+","
        if pole == "nr_poz":
            Poz = wart
        elif pole == "nr_ppoz":
            Ppoz == wart
    sql = sql.strip(',')
    sql += " WHERE "+Filtr+";"
    stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
    if stat != 'OK':
        stat = 'BL_SQL'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [5,3,1]:
    dane = []
    where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
    if Ppoz not in puste_pola:
        where += " AND nr_ppoz="+str(Ppoz)
    sql = "SELECT * FROM rs_korekty_pozycje "+where+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        tr = rssql.RSTableRowset(dane,wyn1)
        
        wyn2=[]
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT nazwa FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+tr.GetVal(0,"artykul_id")+"' "
            st,d,dump,dump=self.PolSQL.Execute(sql,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania artykuw. Poinformuj administratora.')

        if ((self.oddzial_id, '211421') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):  #MK 2020-03-30
            sql = "SELECT nazwa FROM rs_kody_towarow_uslug WHERE kod = '" + tr.GetVal(0, "kod_gtu") + "' "
            st, o, dump, dump = self.PolSQL.Execute(sql, 3)
            if len(o) == 0:
                wyn2.append('')
            else:
                wyn2.append(o[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania sownika towarw i usug. Poinformuj administratora.')
            
        #wyn2.append(str(UprDodawanie)) 
        wyn2.append(str(UprEdycja))
    
        #informacja o zgodnosci stawki VAT tylko w wypadku zapisu
        wyn2.append(Fun in (1,2,3,4) and StawkaVATPozaTerminem)
    
        # informacja o tym, czy wybrana pozycja to zestaw
        if not tr.GetVal(0,"zestaw"):
            # zwyka pozycja
            wyn2.append(0)
        elif Ppoz > 0:
            # podpozycja zestawu
            wyn2.append(2)
        else:  
            # nagwek zestawu
            wyn2.append(1)
        
         