# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_korekty_pozycje_pozycje_dane.py
# Purpose:     sprawdza uprawnienia (kiedys-wczytuje/edytuje dane dotyczace pozycji korekty)
#
# Author:      Micha Raburski, Dariusz Boduch - (wczytywanie/edycja pozycji)
# Created:     2008/07/07 dodanie wczytywania/edycji - 2009/01/14
# RCS-ID:      $Id:$
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2010-11-25 Mariusz Rajfura: kontrola zgodnosci stawki vat z terminem
#                             obowiazywania (tylko ostrzezenie) - mantis:4096
# 2011-11-23 Mariusz Rajfura: uszczelnie: kontrola stanu przed zapisem (5078)
# 2020-03-30 Mikoaj Kozowski: pobranie opisu kodu towarw i usug (11907)

#klucze = [Wyznacznik,Data,Numer,Poz,Ppoz]

Wyznacznik=rsglobal.Dekoduj(klucze[0]) 
Data=rsglobal.Dekoduj(klucze[1]) 
Numer=rsglobal.Dekoduj(klucze[2]) 
Poz=rsglobal.Dekoduj(klucze[3]) 
Ppoz=rsglobal.Dekoduj(klucze[4])
Fun=klucze[-1]

stat = 'OK'
dane = []
wyn2 = []
StawkaVATPozaTerminem = False

if self.operator_id != STANDARD_OPERATOR_ID:
    UprEdycja = ((self.oddzial_id,'023032') in self.uprawnienia)
    
    if UprEdycja:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LWyzn=rsglobal.rseval(wyzn[0][0])[1]
            UprEdycja=(Wyznacznik in LWyzn)
else:
    UprEdycja = True

#-------------------------------------------------------------------------------

if Fun==10:
    dane.append(str(UprEdycja))

#-------------------------------------------------------------------------------

if Fun in [11]:
    st,dane,dump,dump = self.PolSQL.Execute("SELECT waluta,kurs FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";",3)
    if st<>'OK':
        stat='BL SQL KRAJ'
        dane.append(stat)
        
            
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH 3,4 - update
#-------------------------------------------------------------------------------

NrPozycji= -1

if Fun in [3,4] and (not UprEdycja):
    stat='UPR UPD'
    dane.append(stat)

if Fun in [3,4] and stat=='OK':
    # kontrola stanu
    sql ="SELECT stan FROM rs_korekty"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu korekty: '+stat
    elif len(d) == 0:
        stat = 'Brak korekty o podanym kluczu.'
    elif d[0][0] <> 'W':
        stat = 'Korekta w stanie '+d[0][0]+'. Zapis zmian niemoliwy.'

if Fun in (3,4) and stat=="OK":
    StVAT=None
    Kwota=None
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole=='nr_poz':
            if wart < 1:
                stat='BL NR POZ'
                dane.append(stat)
            else:
                sql ="SELECT nr_poz FROM rs_korekty_pozycje_opisowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(wart)+";"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia pozycji opisowej: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = 'NR POZ ISTN'
                    dane.append(stat)
                else:
                    NrPozycji=wart

        elif pole == 'stawka_vat':
            StVAT = rsglobal.Dekoduj(wart)
            if wart == '':
                wartosci[i]='NULL'
            else:
                sql = "SELECT kod FROM rs_stawki_vat WHERE kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia stawki VAT: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat='BL VAT'
                    dane.append(stat)

                if stat == 'OK':
                    sql ="SELECT COALESCE(f.data_przychodu,f.data) FROM rs_faktury f"
                    sql+=" INNER JOIN rs_korekty k"
                    sql+=" ON (f.firma_id=k.firma_id AND f.wyznacznik_id=k.wyznacznik_id_o AND f.data=k.data_o)"
                    sql+=" WHERE k.firma_id='"+self.firma_id+"'"
                    sql+=" AND k.wyznacznik_id='"+Wyznacznik+"' AND k.data='"+Data+"'"
                    sql+=" AND k.numer="+str(Numer)+";"
                    
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania daty sprzeday z faktury rdowej: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'Brak faktury rdowej.'
                        dane.append(stat)
                    else:
                        DataSprzedazy = rsglobal.Dekoduj(d[0][0])
                
                if stat == 'OK':
                    sql ="SELECT stawka_vat FROM rs_stawki_vat_okresy"
                    sql+=" WHERE stawka_vat='"+wart+"'"
                    sql+=" AND '"+DataSprzedazy+"'>=od_dnia"
                    sql+=" AND CASE WHEN do_dnia IS NULL"
                    sql+=" THEN TRUE ELSE '"+DataSprzedazy+"'<=do_dnia END;"
                    
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia terminu obowizywania stawki VAT: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        #informacja zwrotna, ze podana stawka VAT nie zgadza sie
                        #z terminem jej obowiazywania
                        StawkaVATPozaTerminem = True

        elif pole == 'wartosc_netto':        
            Kwota=wart
                
        i= i+1
    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#sprawdzenie relacji stawka VAT - kwota netto
#-------------------------------------------------------------------------------

    if stat=='OK':
        if StVAT==None:
            st,d,dump,dump = self.PolSQL.Execute("SELECT stawka_vat FROM rs_korekty_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Poz)+";",3)
            StVAT=d[0][0]
        if Kwota==None:
            st,d,dump,dump = self.PolSQL.Execute("SELECT wartosc_netto FROM rs_korekty_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Poz)+";",3)
            Kwota=d[0][0]
        
        if (StVAT in (None,'None','')) and Kwota <> 0:
            stat='BR VAT'
            dane.append(stat)

        if (Kwota in (None,'None','')) and StVAT not in (None,'None',''):
            stat='BR KW'
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if stat == 'OK':
        where = " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        where+=" AND data='"+Data+"' AND numer='"+str(Numer)+"' AND nr_poz ="+str(Poz)
        upd = "UPDATE rs_korekty_pozycje_opisowe SET "
        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
        
            if pole in ['opis_pozycji']:
                upd=upd+pole+"='"+wart+"',"
            elif pole in ['nr_poz','wartosc_netto','wartosc_vat','wartosc_brutto',
                          'wartosc_wal_netto','wartosc_wal_vat','wartosc_wal_brutto']:
                upd=upd+pole+"="+str(wart)+","
            elif pole in ['stawka_vat']:
                if wart=="NULL":
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+wart+"',"

        upd = upd[0:len(upd)-1]+where
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        if stat<>'OK':
            stat='BL SQL UPD'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------


if Fun in [3,5] and stat=='OK':
    if NrPozycji<> -1:
        NrPoz=NrPozycji
    
    sql ="SELECT * FROM rs_korekty_pozycje_opisowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Poz)+";"
    
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)
    
            #--- opis stawki vat
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat")+"';" ,3)
                if stat=='OK':
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Bd sprawdzania uprawnie do sownika stawek VAT.')  #MK 2020-03-30
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #--- opis kod gtu  #MK 2020-03-30
            if ((self.oddzial_id, '211421') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                stat, o, dump, dump = self.PolSQL.Execute(
                    "SELECT nazwa FROM rs_kody_towarow_uslug WHERE kod='" + tr.GetVal(0, "kod_gtu") + "';", 3)
                if stat == 'OK':
                    if len(o) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(o[0][0])
                else:
                    wyn2.append('Bd sprawdzania uprawnie do sownika kodw GTU.')
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    
            #informacja o zgodnosci stawki VAT z tylko w wypadku zapisu
            if stat=='OK':
                wyn2.append(Fun in (3,4) and StawkaVATPozaTerminem)
        
            #--- sprawdzenie czy podana korekta jest wartociowa.
            if stat=='OK':
                SQL="SELECT typ_faktury='KW' FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat=='OK':
                    if len(d) == 0:
                        wyn2.append(False)
                    else:
                        wyn2.append(d[0][0])
                else:
                    stat='Bd sprawdzania typu faktury.'
        else:
            stat = 'Pobrano zero, lub wicej ni jedn pozycj.'