# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_korekty_wart_klucz.py
# Purpose:     insert/update korekty wartociowej
#
# Author:      Micha Raburski
# Created:     2013/04/02
# RCS-ID:      $Id: fs_korekty_wart_klucz.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-08-07 Aleksander Bargie - (11568) Obsuga split payment w fakturach
# 2019-08-30 Aleksander Bargie - (11622) Mpp w korektach wartociowych


from funkcje import fs_sprzedaz_pom
stat = "OK"
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']

    # 1 - pobranie numeru nowej korekty ; 2 - wstawienie nowej korekty

    SlPar={'Wyznacznik':[1,2],'Data':[1,2],'Numer':[2],'DataOd':[2],
    'DataDo':[2],'Platnik':[2],'Kontrahent':[2],'Upust':[2]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_korekty_wart_klucz z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2]:
        Wyznacznik=rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        
    if Fun in [2]:
        Numer=rsglobal.Dekoduj(str(klucze['Numer']))
        DataOd=rsglobal.Dekoduj(klucze['DataOd'])
        DataDo=rsglobal.Dekoduj(klucze['DataDo'])
        Platnik=rsglobal.Dekoduj(klucze['Platnik'])
        Kontrahent=rsglobal.Dekoduj(klucze['Kontrahent'])
        Upust=klucze['Upust']
        
#-------------------------------------------------------------------------------
#--- SELECT DANYCH(1)
#-------------------------------------------------------------------------------

if Fun == 1:
    sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"
    sql+= self.firma_id+"','[\\\'"+Wyznacznik+"\\\',\\\'"+Data+"\\\']','K');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)            
    if dane[0][0]=='OK':
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"
        sql+= self.firma_id+"','[\\\'"+Wyznacznik+"\\\',\\\'"+Data+"\\\']','K');"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)        
        if dane[0][0] in (None,'None',''):
            stat="BL N NUM"
    elif stat=='OK':
        stat="NM DD"

#-------------------------------------------------------------------------------
# WSTAWIENIE KOREKTY WARTOCIOWEJ (2)
#-------------------------------------------------------------------------------

if Fun ==2 and stat=='OK':
    # sprawdzenie  unikalnoci numeru korekty w ramach odpowiedniego zakresu czasowego
    SQL="SELECT rsf_sprawdz_czy_unikalny_numer_dokumentu('"
    SQL+= self.firma_id+"','[\\\'"+Wyznacznik+"\\\',\\\'"+Data+"\\\',"+Numer+"]','K');"
    stat,DaneNrK,dump,dump = self.PolSQL.Execute(SQL,3)            
    if stat<>'OK':
        stat='Bd sprawdzania unikalnoci numeru korekty :'+stat
    if DaneNrK[0][0]<>'OK':
        stat=DaneNrK[0][0]
     
    if stat=='OK':       
        #sprawdzenie czy operator ma prawo dodawa ten wyznacznik w danym oddziale
        #pobranie listy wyznacznikw, do ktrych ma prawo dodawania
        sql ="SELECT wyznacznik_id,czy_korekta,typ_faktury FROM rs_wyznaczniki"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    
    if stat=='OK':
        if len(d) == 0:
            stat = "BL WYZN" 
    
    if stat=='OK':
        if not d[0][1]:
            stat = "WYZN FAKT" 
    
    if stat=='OK':        
        if not d[0][2] in ('KW'):
            stat = "BL TYP KOR" 
    
    if stat=='OK':
        if int(Numer)<1:
            stat = 'Korekta musi mie numer wikszy od zera.'
            
    if stat=='OK':
        if self.operator_id <> STANDARD_OPERATOR_ID:
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            ListaUpr='[False,True,False,False,False,False]'
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','"+ListaUpr+"');"    
            
            stat,DaneW,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LWyzn=rsglobal.rseval(DaneW[0][0])[1]
                Buf=str(Wyznacznik)+'  '
                Buf=Buf[0:2]
                if not( Buf in LWyzn):
                    stat="BL UPR WYZN"

    if stat=='OK':        
        #sprawdzenie czy mona doda faktur korygujc z t dat
        sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument(\'"
        sql+= self.firma_id+"','[\\\'"+Wyznacznik+"\\\',\\\'"+Data+"\\\']','K');"
        
        stat,test,dump,dump = self.PolSQL.Execute(sql,3)
        if test[0][0]<>'OK':    
            stat='NM DD' # nie mozna doda dokumentu
                
        if Data == "    -  -  ":
            stat = 'BR DATA'
          
    if stat == "OK":
        if not rsglobal.SprawdzCzyToData(Data):
            stat = "BL DATA"
            
    if stat == 'OK':    
        sql = "SELECT rsf_sprawdz_date_z_zakresem(\'"
        sql+= str(self.firma_id)+self.oddzial_id+"\',\'"+str(Data)+"\',1);"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        Dane = d[0][0]
        if Dane <> 1:
            stat = "ZK DATA"
            
    if stat == 'OK':
        sql ="SELECT wyznacznik_id FROM rs_korekty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(d) <> 0:
                stat = 'UZ KLUCZ'

    if stat == "OK":
        if not rsglobal.SprawdzCzyToData(DataOd):
            stat = "BL DATAOD"
            
    if stat == "OK":
        if not rsglobal.SprawdzCzyToData(DataDo):
            stat = "BL DATADO"

    if stat == "OK":
        if DataOd>DataDo:
            stat = "BL DATADOOD"
            
    # sprawdzenie poprawnoci upustu
    if stat=='OK':
        if Upust <0 or Upust>100:
            stat='Upust musi mie warto pomidzy 0 a 100'
                

    # sprawdzenie poprawnoci i dostpnoci wyznacznika
    if stat == 'OK':
        SQL ="SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND czy_korekta=True;"
    
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobrania wyznacznika: '+stat
        elif len(d)==0:
            stat = 'BL WYZN KOR'

    # testy patnika/kontrahenta na obecno, poprawno i aktywno
    if stat=='OK':
        if Platnik=='' and Kontrahent == '':
            stat='Naley poda konkretnego patnika lub kontrahenta'
    
    if stat=='OK' and Kontrahent<>'':
        SQL="SELECT COALESCE(aktywny,TRUE) FROM rs_kontrahenci "
        SQL+=" WHERE firma_id='"+self.firma_id+"' ANd kontrahent_id='"+Kontrahent+"';"
        
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania danych kontrahenta: '+stat
        elif len(DTest)==0:
            stat = 'Podano bdnego kontrahenta'
        elif not DTest[0][0]:
            stat = 'Podano nieaktywnego kontrahenta'
        
        if stat=='OK':
            FiltrKontrPlat="kontrahent_id='"+Kontrahent+"'"
            PlatnikDlaKontr="(SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"')"
        
    elif stat=='OK' and Platnik<>'':
        SQL="SELECT COALESCE(aktywny,TRUE) FROM rs_kontrahenci "
        SQL+=" WHERE firma_id='"+self.firma_id+"' ANd kontrahent_id='"+Platnik+"';"
        
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania danych patnika: '+stat
        elif len(DTest)==0:
            stat = 'Podano bdnego patnika'
        elif not DTest[0][0]:
            stat = 'Podano nieaktywnego patnika'
            
        if stat=='OK':
            FiltrKontrPlat="COALESCE(platnik_id,kontrahent_id)='"+Platnik+"'"
    
    # test na waluty - e tylko PLN bdziemy obrabia
    if stat=='OK':
        Filtr="firma_id='"+self.firma_id+"' AND "+FiltrKontrPlat
        Filtr+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"'"
        
        # sprawdzenie czy wszystkie faktury s w PLN
        SQL="SELECT DISTINCT waluta FROM rs_faktury WHERE "+Filtr+" AND waluta<>'PLN'"
        
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania danych o walucie faktur: '+stat
        elif len(DTest)>0:
            stat = 'W podanym okresie dla patnika/kontrahenta istniej faktury walutowe i utworzenie korekty wartociowej jest niemoliwe'

    if stat=='OK':
        # sprawdzenie czy wszystkie korekty s w PLN        
        SQL="SELECT DISTINCT waluta FROM rs_korekty WHERE "+Filtr+" AND waluta<>'PLN'"
        
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania danych o walucie korekt: '+stat
        elif len(DTest)>0:
            stat = 'W podanym okresie dla patnika/kontrahenta istniej korekty walutowe i utworzenie korekty wartociowej jest niemoliwe'
                
    #-------------------------------------------------------------------------------
    # TESTY PRZESZY POMYLNIE I TWORZYMY KOREKT
    #-------------------------------------------------------------------------------
    
    if stat=='OK':
        # pobranie danych z faktur
        SQL="SELECT fv.stawka_vat,SUM(fv.wartosc_netto) FROM rs_faktury_vat fv"
        SQL+=" INNER JOIN rs_faktury f USING (firma_id,wyznacznik_id,data,numer)"
        SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND "+FiltrKontrPlat
        SQL+=" AND f.data>='"+DataOd+"' AND f.data<='"+DataDo+"' AND stan IN ('Z','K') GROUP BY fv.stawka_vat;"
        stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania danych faktur: '+stat
            
    if stat=='OK':
        # pobranie danych z korekt
        SQL="SELECT kv.stawka_vat,SUM(kv.wartosc_netto-kv.wartosc_netto_p) FROM rs_korekty_vat kv"
        SQL+=" INNER JOIN rs_korekty k USING (firma_id,wyznacznik_id,data,numer)"
        SQL+=" WHERE k.firma_id='"+self.firma_id+"' AND "+FiltrKontrPlat
        SQL+=" AND k.data>='"+DataOd+"' AND k.data<='"+DataDo+"' AND stan IN ('Z','K') GROUP BY kv.stawka_vat;"
        stat,DKor,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania danych korekt: '+stat

    if stat == 'OK':
        SQL = """SELECT EXISTS(SELECT 1
              FROM rs_faktury f 
              WHERE f.firma_id='{firma}' AND {filtr} AND f.data>='{od}' AND f.data<='{do}' AND stan IN ('Z','K') AND czy_mpp) 
       OR EXISTS(SELECT 1
              FROM rs_korekty k 
              WHERE k.firma_id='{firma}' AND {filtr} AND k.data>='{od}' AND k.data<='{do}' AND stan IN ('Z','K') AND czy_mpp) AS mpp_gdziekolwiek;"""
        SQL = SQL.format(firma=self.firma_id, filtr=FiltrKontrPlat, od=DataOd, do=DataDo)
        rsglobal.ZapiszDoLogow(SQL)
        stat, MPP, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(MPP)
        Czy_MPP = MPP[0][0]
        if stat != 'OK':
            stat = 'Bd pobrania informacji o MPP na korygowanych dokumentach: '+stat

    if stat == 'OK':
        # wyznaczenie opisu dla korekty wartociowej
        Opis=''
        # pobranie danych faktur
        SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','F') "
        SQL+=" FROM rs_faktury  WHERE firma_id='"+self.firma_id+"' AND "+FiltrKontrPlat
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan IN ('Z','K')"
        SQL+=" ORDER BY rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','F');"
        stat,DFaktOpis,dump,dump = self.PolSQL.Execute(SQL,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania numerw faktur do opisu: '+stat
            
        if len(DFaktOpis) >0:
            Opis+='FAKTURY\n'
            i=0
            for w in DFaktOpis:
                if i>8:
                    Opis+='\n'
                    i=0
                Opis+=w[0]+","
                i+=1
            Opis = Opis.strip(',')
            
        # pobranie danych korekt
        SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','K')"
        SQL+=" FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND "+FiltrKontrPlat
        SQL+=" AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan IN ('Z','K')"
        SQL+=" ORDER BY rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'|| wyznacznik_id ||'\",\"'|| data ||'\",\"'|| numer ||'\"]','K');"
        stat,DKorOpis,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(DKorOpis) >0:
            if Opis <> '':
                Opis+='\n\n'
                
            Opis+='KOREKTY\n'
            i=0
            for w in DKorOpis:
                if i>8:
                    Opis+='\n'
                    i=0
                Opis+=w[0]+","
                i+=1
            Opis = Opis.strip(',')
            
    if stat=='OK':
        # policzenie rnic
        SStawki={}
        for poz in DFakt:
            SStawki[poz[0]]=poz[1]
        
        for poz in DKor:
            if poz[0] in SStawki:
                SStawki[poz[0]]+=poz[1]
            else:
                SStawki[poz[0]]=poz[1]
        
        if SStawki=={}:
            stat='Brak danych do wstawienia na korekt wartociow'
        
    if stat=='OK':
        # pobranie danych do fakturowania kontrahenta
        SQLD= " SELECT COALESCE(dni,0), COALESCE(wersja,''), COALESCE(spos_zaplaty,''), "
        SQLD+=" COALESCE(spos_dostawy,''), COALESCE(handlowiec,''), COALESCE(sposob_odbioru_faktury,''), "
        SQLD+=" COALESCE(projekt_id,'')"
        SQLD+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+str(self.firma_id)+"' "
        if Kontrahent <> '':
            SQLD+=" AND kontrahent_id= "+PlatnikDlaKontr
        else:
            SQLD+=" AND kontrahent_id='"+Platnik+"' "
        SQLD+=" AND wyznacznik='"+Wyznacznik+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1;"
        stat,DaneF,dump,dump = self.PolSQL.Execute(SQLD,3)
        if stat <> 'OK':
            stat = 'Bd pobierania danych do fakturowania patnika: '+stat
        elif len(DaneF)==0:
            SposZapl='NULL'
            SposDost='NULL'
            SposOdbF='NULL'
            Projekt='NULL'
        else:
            if DaneF[0][2]=='':
                SposZapl='NULL'
            else:
                SposZapl="'"+rsglobal.Dekoduj(DaneF[0][2])+"'"
    
            if DaneF[0][3]=='':
                SposDost='NULL'
            else:
                SposDost="'"+rsglobal.Dekoduj(DaneF[0][3])+"'"
                
            if DaneF[0][5]=='':
                SposOdbF='NULL'
            else:
                SposOdbF="'"+rsglobal.Dekoduj(DaneF[0][5])+"'"
                
            if DaneF[0][6]=='':
                Projekt='NULL'
            else:
                Projekt="'"+rsglobal.Dekoduj(DaneF[0][6])+"'"
    
    if stat=='OK':
        # wstawienie nagowka korekty
        SQL="INSERT INTO rs_korekty "
        SQL+="(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,"
        SQL+="kontrahent_id,platnik_id,zamawiajacy_id,waluta,kurs,kurs_p,kraj_opodatkowania,upust,upust_p,"
        SQL+="dostawy_od_dnia, dostawy_do_dnia,sposob_zaplaty,sposob_dostawy,sposob_odbioru_faktury,projekt_id,opis, czy_mpp)"
        SQL+=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+",'"+self.oddzial_id+"','W',"
        if Kontrahent <> '':
            SQL+="'"+Kontrahent+"',"+PlatnikDlaKontr+",'"+Kontrahent+"','PLN',1,1,'PL',"+str(Upust)+",0,"
        else:
            SQL+="'"+Platnik+"','"+Platnik+"','"+Platnik+"','PLN',1,1,'PL',"+str(Upust)+",0,"
        SQL+="'"+DataOd+"','"+DataDo+"',"+SposZapl+","+SposDost+","+SposOdbF+","+Projekt+",'"+Opis+"', "+str(Czy_MPP)+")"
        
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd dodawania nagwka korekty: '+stat
        
    if stat=='OK':
        stat = fs_sprzedaz_pom.PrzeniesUdzialyHandlowcowZFakturyDoKorekty(self,Wyznacznik,Data,Numer)
        
    if stat=='OK':    
        # wstawienie pozycji opisowych i stawek vat korekty z jednoczesn edycj nagwka
        KlStawek=SStawki.keys()
        KlStawek.sort()
        NrPoz=0
        for stawka in KlStawek:
            KwNetto=SStawki[stawka]
            if KwNetto==0:
                continue
            
            NrPoz+=1
            
            if stawka in self.ListaStawekZn:
                StL=0
            else:
                StL=int(stawka)

            KwVAT=rsglobal.RSRound(KwNetto*0.01*StL,2)
            KwBrutto=rsglobal.RSRound(KwNetto*0.01*(100+StL),2)
            
            KwNettoU=rsglobal.RSRound(KwNetto*(100-Upust)*0.01,2)
            KwVATU=rsglobal.RSRound(KwNettoU*0.01*StL,2)
            KwBruttoU=rsglobal.RSRound(KwNettoU*0.01*(100+StL),2)
            
            # pozycja opisowa
            SQL="INSERT INTO rs_korekty_pozycje_opisowe (firma_id,wyznacznik_id,data,numer,"
            SQL+=" nr_poz, opis_pozycji,stawka_vat,stawka_vat_p,"
            SQL+=" wartosc_netto, wartosc_vat, wartosc_brutto,"
            SQL+=" wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
            SQL+=" wartosc_netto_p, wartosc_vat_p, wartosc_brutto_p,"
            SQL+=" wartosc_wal_netto_p, wartosc_wal_vat_p, wartosc_wal_brutto_p)"
            SQL+=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","
            SQL+=str(NrPoz)+",'rabat','"+stawka+"','"+stawka+"',"
            SQL+=str(KwNettoU)+","+str(KwVATU)+","+str(KwBruttoU)+","
            SQL+=str(KwNettoU)+","+str(KwVATU)+","+str(KwBruttoU)+","
            SQL+=str(KwNetto)+","+str(KwVAT)+","+str(KwBrutto)+","
            SQL+=str(KwNetto)+","+str(KwVAT)+","+str(KwBrutto)+")"

            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat = 'Bd dodawania pozycji opisowej korekty: '+stat
                
            if stat=='OK':
                #stawka vat
                SQL="INSERT INTO rs_korekty_vat (firma_id,wyznacznik_id,data,numer,"
                SQL+=" stawka_vat,"
                SQL+=" wartosc_netto, wartosc_vat, wartosc_brutto,"
                SQL+=" wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
                SQL+=" wartosc_netto_p, wartosc_vat_p, wartosc_brutto_p,"
                SQL+=" wartosc_wal_netto_p, wartosc_wal_vat_p, wartosc_wal_brutto_p)"
                SQL+=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","
                SQL+="'"+stawka+"',"
                SQL+=str(KwNettoU)+","+str(KwVATU)+","+str(KwBruttoU)+","
                SQL+=str(KwNettoU)+","+str(KwVATU)+","+str(KwBruttoU)+","
                SQL+=str(KwNetto)+","+str(KwVAT)+","+str(KwBrutto)+","
                SQL+=str(KwNetto)+","+str(KwVAT)+","+str(KwBrutto)+")"
    
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat <> 'OK':
                    stat = 'Bd dodawania stawki VAT korekty: '+stat
    
            if stat=='OK':
                # update korekty
                SQL="UPDATE rs_korekty SET "
                SQL+=" upust_wartosc=COALESCE(upust_wartosc,0)+ "+str(rsglobal.RSRound(KwBrutto-KwBruttoU,2))+","
                SQL+=" upust_wartosc_wal=COALESCE(upust_wartosc_wal,0)+ "+str(rsglobal.RSRound(KwBrutto-KwBruttoU,2))+","
                SQL+=" kwota_netto=COALESCE(kwota_netto,0)+ "+str(KwNettoU)+","
                SQL+=" kwota_vat=COALESCE(kwota_vat,0)+ "+str(KwVATU)+","
                SQL+=" do_zaplaty=COALESCE(do_zaplaty,0)+ "+str(KwBruttoU)+","
                SQL+=" kwota_netto_wal=COALESCE(kwota_netto_wal,0)+ "+str(KwNettoU)+","
                SQL+=" kwota_vat_wal=COALESCE(kwota_vat_wal,0)+ "+str(KwVATU)+","
                SQL+=" do_zaplaty_wal=COALESCE(do_zaplaty_wal,0)+ "+str(KwBruttoU)+","
                SQL+=" kwota_netto_p=COALESCE(kwota_netto_p,0)+ "+str(KwNetto)+","
                SQL+=" kwota_vat_p=COALESCE(kwota_vat_p,0)+ "+str(KwVAT)+","
                SQL+=" do_zaplaty_p=COALESCE(do_zaplaty_p,0)+ "+str(KwBrutto)+","
                SQL+=" kwota_netto_wal_p=COALESCE(kwota_netto_wal_p,0)+ "+str(KwNetto)+","
                SQL+=" kwota_vat_wal_p=COALESCE(kwota_vat_wal_p,0)+ "+str(KwVAT)+","
                SQL+=" do_zaplaty_wal_p=COALESCE(do_zaplaty_wal_p,0)+ "+str(KwBrutto)
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                SQL+=" AND data='"+Data+"' AND numer="+Numer
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat <> 'OK':
                    stat = 'Bd zmiany kwot korekty: '+stat