# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_absencje_rodzaje.py
# Purpose:     grid z rodzajami absencji
#
# Author:      Mariusz Rajfura
# Created:     2010/07/05
# RCS-ID:      $Id: fs_kp_absencje_rodzaje.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-09-18 Aleksander Bargie (11223) - [KP] czy_glowna w rs_kp_absencje_rodzaje
# 2020-02-03 Wojciech Skowron   (11830) - AND czy_glowna zamiast OR
# 2021-02-13 Jan Raburski (12332) - niewyswietlanie nieaktywnych absencji

Fun = klucze[-1]
TypAbsencji = rsglobal.Dekoduj(klucze[0])
if Fun <> 10:
    CzyNieobecnoscF = klucze[1][0]
    CzyZwolnienieF = klucze[1][1]
    CzyZawieszenieF = klucze[1][2]
    CzyPlaciZUSF = klucze[1][3]
    CzyNieobecnoscInnaF = klucze[1][4]
    #AB 18.09.18r
    CzyGlowne = klucze[1][5]

    Klucze_Id = klucze[2]


dane = []
wyn1 = []
stat = 'OK'

UprUsuwanie = ((self.oddzial_id,'051014') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
# POBRANIE OPISU DLA PODANEGO KODU
#-------------------------------------------------------------------------------

if Fun == 10:
    sql ="SELECT nazwa FROM rs_kp_absencje_rodzaje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu absencji: '+stat
    elif len(dane) == 0:
        stat = 'Bdny kod rodzaju absencji'


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania rodzajw absencji.'

    if stat == 'OK':
        sql = "SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND typ_absencji_id='"+TypAbsencji+"' FOR UPDATE NOWAIT;" 

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych rodzaju absencji: '+stat
        elif len(d) == 0:
            stat = 'Brak rodzaju absencji o podanym kodzie: '+stat

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_absencje_rodzaje"
            DELETE+=" WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"

            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = 'Kodu nie mona usun poniewa jest uywany w innych tabelach.'


#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy rodzjow abasencji
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    FILTR = "(firma_id = '"+self.firma_id+"'"                                                       #AB 18.09.18r
    if CzyNieobecnoscF or CzyZwolnienieF or CzyZawieszenieF or CzyPlaciZUSF or CzyNieobecnoscInnaF: # or CzyGlowne: #WS 2020-02-03
        FILTR+=' AND ('
        Byl = False
        if CzyNieobecnoscF:
            FILTR += "czy_nieobecnosc"
            Byl = True
            
        if CzyZwolnienieF:
            if Byl:
                FILTR += " OR "
            FILTR += "czy_zwolnienie"
            Byl = True
            
        if CzyZawieszenieF:
            if Byl:
                FILTR += " OR "
            FILTR += "czy_zawieszenie"
            Byl = True
        
        if CzyPlaciZUSF:
            if Byl:
                FILTR += " OR "
            FILTR += "placi_zus"
            Byl = True
            
        if CzyNieobecnoscInnaF:
            if Byl:
                FILTR += " OR "
            FILTR += "nieobecnosc_inna"
            Byl = True
        #WS 2020-02-03
        # #AB 18.09.18r
        # if CzyGlowne:
        #     if Byl:
        #        FILTR += " OR "
        #     FILTR += "czy_glowna"
        #     Byl = True
            
        FILTR += ")"
    #WS 2020-02-03
    if CzyGlowne:
        FILTR += " AND czy_glowna"
    FILTR += ")"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (firma_id='"+self.firma_id+"' AND typ_absencji_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"
    FILTR += " AND czy_aktywna"     #JR 21-02-13
    SELECT ="SELECT typ_absencji_id,COALESCE(nazwa,''::TEXT),czy_nieobecnosc,"          #AB 18.09.18r
    SELECT+=" czy_zwolnienie,czy_zawieszenie,czy_staz_pracy,placi_zus,nieobecnosc_inna, czy_glowna"
    SELECT+=" FROM rs_kp_absencje_rodzaje WHERE "+FILTR
    SELECT+=" ORDER BY typ_absencji_id;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy rodzajw absencji: '+stat
