# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_absencje_rodzaje_dane
# Purpose:     dodawanie/edycja rodzaju absencji
# Author:      Mariusz Rajfura
# Created:     2010/07/05
# RCS-ID:      $Id: fs_kp_absencje_rodzaje_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-07-13 Aleksander Bargie (11148) Dodatkowe opcje w rodzajach absencji
# 2018-09-18 Aleksander Bargie (11223) - [KP] czy_glowna w rs_kp_absencje_rodzaje
# 2019-10-08 Wojciech Skowron   (11679) - Podstawy dla zasikw - osobna funkcja do pobrania wymaga

TypAbsencji = rsglobal.Dekoduj(klucze[0])

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
puste = ('', '    -  -  ', 'None', None, 'NULL')

UprDodawanie = (((self.oddzial_id,'051013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'051012') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if TypAbsencji == '':
        stat = 'BR_TYP'
        dane.append(stat)
        
    if stat == 'OK':
        SQL ="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia kodu rodzaju absencji: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'BL_TYP_IST'
            dane.append(stat)
            
if Fun in (3,4) and stat == 'OK':
    SQL ="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje"
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND typ_absencji_id='"+TypAbsencji+"' FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia kodu rodzaju absencji: '+stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'BL_TYP'
        dane.append(stat)
    
    if stat=='OK':
        SQL ="SELECT * FROM rs_kp_dane_osobowe_absencje"
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest) > 0:
                for i in range(len(pola)):
                    pole = pola[i]
                    #AB 2018-09-04
                    if pole in ['typ_absencji_id', 'kod_zus', 'proc_zwolnienia', 'proc_platnosci_innej', 'nr_placowy',
                                'czy_nieobecnosc', 'nieobecnosc_inna', 'czy_zwolnienie', 'czy_zawieszenie',
                                'czy_staz_pracy', 'placi_zus', 'zus_wymagany', 'dostarczono', 'wystawiono']:
                        stat = 'Pola '+pole+' nie mona zmieni, bo istniej absencje przypisane do typu absencji'

if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        #AB 18.09.18r
        if pole in ('algorytm_limit', 'algorytm_rodzaj'):
            stat = 'MOD_ALG'
            rsglobal.ZapiszDoLogow('MOD_ALG', 5)

        if pole == 'nazwa':
            wart = wart.strip()
            if wart == '':
                wartosci[i] = "NULL"
            else:
                wartosci[i] = "'"+wart+"'"

        elif pole in ('czy_nieobecnosc','nieobecnosc_inna','czy_zwolnienie','czy_zawieszenie',
                        #AB 2018-09-04
                      'czy_staz_pracy','placi_zus', 'zus_wymagany', 'przechodni', 'dostarczono', 'wystawiono'):
            wartosci[i] = str(wart)

        elif pole[:7] in ('staz_do', 'liczba_'):
            wartosci[i] = str(wart)
            
        elif pole == 'kod_zus':
            if wart == '':
                wartosci[i] = "NULL"
            else:
                wartosci[i] = "'"+wart+"'"
                
        elif pole == 'proc_zwolnienia':
            if wart < 0:
                stat = 'BL_PROC_ZWOLNIENIA'
            elif wart > 100.0:
                stat = 'BL_PROC_ZWOLNIENIA'
            wartosci[i] = str(wart)
        elif pole == 'proc_platnosci_innej':
            if wart < 0:
                stat = 'BL_PROC_PLATNOSCI_INNEJ'
            elif wart > 100.0:
                stat = 'BL_PROC_PLATNOSCI_INNEJ'
            wartosci[i] = str(wart)


        elif pole == 'nr_placowy':
            if wart < 0:
                stat = 'BL_NR_PLACOWY'
            wartosci[i] = str(wart)
                
    if len(dane) > 0:
        stat = dane[0]


#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -insert z pobraniem  2 -insert bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = "firma_id,typ_absencji_id"
    inswart = "'"+self.firma_id+"','"+TypAbsencji+"'"

    for i in range(len(pola)):
        if pola[i] <> 'typ_absencji_id':
            inspola += ","+pola[i]
            inswart += ","+str(wartosci[i])

    INSERT = "INSERT INTO rs_kp_absencje_rodzaje ("+inspola+") VALUES ("+inswart+");"
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)

    if stat <> 'OK':
        stat = 'Bd dodawania nowego rodzaju absencji: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3 -udate z pobraniem, 4 -update bez pobrania)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_absencje_rodzaje SET "

    for i in range(len(pola)):
        UPDATE += pola[i]+" = "+str(wartosci[i])+","

    UPDATE  = UPDATE[:-1]
    UPDATE += " WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd aktualizacji danych rodzaju absencji: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat == 'OK':
    SELECT ="SELECT * FROM rs_kp_absencje_rodzaje"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych rodzaju absencji: '+stat
        dane.append(stat)
    
    if stat=='OK':
        wyn2=[]
        SQL ="SELECT * FROM rs_kp_dane_osobowe_absencje"
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND typ_absencji_id='"+TypAbsencji+"';"
        
        stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
        wyn2.append(len(d) <> 0)

#-------------------------------------------------------------------------------
#--- POBRANIE WYMAGA (6)
#-------------------------------------------------------------------------------

#WS 2019-10-08
if Fun == 6 and stat == 'OK':
    SELECT ="SELECT typ_absencji_id,zus_wymagany,dostarczono,wystawiono, czy_nieobecnosc, czy_zwolnienie, nieobecnosc_inna FROM rs_kp_absencje_rodzaje"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych rodzaju absencji: '+stat
        dane.append(stat)
