# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_angaze_skladniki.py
# Purpose:     grid ze skadnikami specjalnymi dla angay
# Author:      Piotr Witkowski
# Created:     2015/09/14
# RCS-ID:      $Id: fs_kp_angaze_skladniki.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2022-05-05 Wojciech Skowron - (12850) Kontrola dat

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Pracownik':[1,5],'Zatrudnienie':[1,5],'Angaz':[1,5],\
            'Umowa':[1,5],'Skladnik':[1,5],'DataOd':[1,5],'DataDo':[1,5]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_angaze_skladniki z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5]: 
            Pracownik = str(klucze['Pracownik'])
            Zatrudnienie = str(klucze['Zatrudnienie'])
            Angaz = str(klucze['Angaz'])
            Umowa = str(klucze['Umowa'])
        if Funkcja in [1,5]: 
            Skladnik = str(klucze['Skladnik'])
            DataOd = str(klucze['DataOd'])
            DataDo = str(klucze['DataDo'])

dane = []
wyn2 = []


#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprModyfikowanie=(((self.oddzial_id,'052046') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 


#-------------------------------------------------------------------------------
#---   EDYCJA GRIDA (1)
#-------------------------------------------------------------------------------

#WS 2022-05-05
def sprawdz_daty(self, data_od, data_do, skladnik_id, nr_wiersza, Pracownik, Zatrudnienie, Umowa, Angaz, dane, wyn2):
    if data_do not in ['None', '', '    -  -  ', '-  -'] and data_od > data_do:
        wyn2.append((nr_wiersza, 0))
        dane.append('DATY ZAKRES$'+str(int(nr_wiersza)))

    # sprawdzenie daty od i do
    SEL = """SELECT od_kiedy, do_kiedy FROM rs_kp_angaze 
             WHERE firma_id='{self.firma_id}' AND pracownik_id='{Pracownik}' AND
                   umowa_id={Umowa} AND angaz_id={Angaz} AND zatrudnienie_id={Zatrudnienie};""".format(**locals())
    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat=u'Bd pobrania daty angau'
        dane.append(stat)
        wyn2.append([nr_wiersza, 2])
    elif len(d) == 0:
        stat=u'Bd pobrania daty angau'
        dane.append(stat)
        wyn2.append([nr_wiersza, 2])
    else:
        od_kiedy_angazu = d[0][0]
        # data od moe by jedynie dat pocztku angau lub pierwszym dniem miesica >= daty pocztku angau
        if not (od_kiedy_angazu == data_od or (data_od[8:] == '01' and data_od[:7] >= od_kiedy_angazu[:7])):
            stat='DATA OD BL'
            dane.append(stat)
            wyn2.append([nr_wiersza, 2])

        do_kiedy_angazu = d[0][1]
        # data do moe by pusta lub dat koca angau lub ostatnim dniem miesica <= daty koca angau
        if data_do not in ['None', '', '    -  -  ', '-  -'] and not (do_kiedy_angazu == data_do or (data_do[8:] == str(rsglobal.PodajOstatniDzien(data_do)).zfill(2) and (do_kiedy_angazu == 'None' or data_do[:7] <= do_kiedy_angazu[:7]))):
            stat='DATA DO BL'
            dane.append(stat)
            wyn2.append([nr_wiersza, 3])

        if data_do in ['None', '', '    -  -  ', '-  -'] and 'DATA OD BL' not in dane and do_kiedy_angazu != 'None' and data_od > do_kiedy_angazu:
            stat='DATA OD DATA DO ANGAZ BL'
            dane.append(stat)
            wyn2.append([nr_wiersza, 2])

    data_od = rsglobal.ZmienNaNULL(data_od)
    data_do = rsglobal.ZmienNaNULL(data_do)
    skladnik_id = rsglobal.ZmienNaNULL(skladnik_id)
    # kontrola zazbiania si dat
    SEL = """SELECT 1 FROM rs_kp_angaze_skladniki
             WHERE firma_id='{self.firma_id}' AND pracownik_id='{Pracownik}'
                   AND zatrudnienie_id={Zatrudnienie} AND umowa_id={Umowa}
                   AND angaz_id={Angaz} AND skladnik_id={skladnik_id} AND data_od!={data_od}
                   AND ((CASE WHEN {data_do} IS NULL THEN data_do>={data_od} ELSE data_do BETWEEN {data_od} AND {data_do} END 
                         OR (data_do IS NULL AND data_od<={data_od})) 
                        OR (CASE WHEN {data_do} IS NULL 
                            THEN data_od>={data_od} 
                            ELSE data_od BETWEEN {data_od} AND {data_do} 
                            END))
             LIMIT 1;""".format(**locals())
    rsglobal.ZapiszDoLogow('Kontrola zazbiania dat: '+SEL)
    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = u'Bd kontroli zazbiania si dat: '+stat
        dane.append(stat)
        wyn2.append((nr_wiersza, 0))
    elif len(d) > 0:
        stat = 'DATY ZAZEB'
        dane.append(stat)
        wyn2.append((nr_wiersza, 0))

    return dane, wyn2


if stat == "OK" and Funkcja in [1]:

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------
    
    Delete=klucze['Delete']
    if len(Delete[0])>0:
        if not UprModyfikowanie:
            stat='UPR DEL'
            dane.append(stat)

        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                if stat=='OK':
                    DELETE="DELETE FROM rs_kp_angaze_skladniki "
                    WHERE="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"
                    WHERE+=Pracownik+"' AND zatrudnienie_id="+Zatrudnienie
                    WHERE+= " AND umowa_id="+Umowa+" AND angaz_id="+Angaz
                    for j in xrange(len(Delete[0][i])):
                        pole=Delete[1][j]
                        wart=Delete[0][i][j]
                        if pole in ['skladnik_id']:
                            WHERE+=" AND "+pole+"='"+str(wart)+"'"
                        elif pole in ['data_od']:
                            WHERE+=" AND "+pole+"='"+str(wart).strip()+"'"
                    sql+=DELETE+WHERE+";"                    
            if sql<>'' and stat=='OK': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='SQL DEL BL'
                    dane.append(stat)    

            
#-------------------------------------------------------------------------------
#-------     Sprawdzanie danych do Update   
#-------------------------------------------------------------------------------

    if stat == 'OK':
        Update=klucze['Update'] 
        if len(Update[0])>0:
            if not UprModyfikowanie:
                stat='UPR UPD'
                dane.append(stat)
                                
            if stat == 'OK':    
                # sownik do analizy czy naley wpisa pozycj do tablicy zwrotw
                # klucz to Update[2][i][0]
                # dane wynikowe to [dane do tabeli bdw, liczba zwrtw (bez informacji=-1),Typ "U"pdate lub "I"nsert]
                
                for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                    for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                        if stat == 'OK':
                            pole=Update[0][i][j]
                            wart=Update[1][i][j] 
                            if pole== u'skladnik_id': 
                                if wart.strip()=='':
                                    dane.append(u'Brak skadnika dla pozycji: '+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],0])
                                    
                            elif pole==u'data_od':
                                if wart not in (None,'None') and wart.strip()<>'':
                                    if not rsglobal.SprawdzCzyToData(wart.strip()):
                                        stat=u'Bd wartoci daty od:'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],2])
                                else:
                                    dane.append('Brak wartoci daty od dla pozycji: '+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],2])
                            elif pole=='data_do':
                                if wart not in (None,'None') and wart.strip()<>'':
                                    if not rsglobal.SprawdzCzyToData(wart):
                                        stat=u'Bd wartoci daty do dla pozycji: '+str(Update[-1][i])
                                        wyn2.append([Update[-1][i],2])
                                    
                if len(dane)>0 and stat == 'OK':
                    stat=dane[-1]
                    
                    
#-------------------------------------------------------------------------------
#---------- UPDATE       
#-------------------------------------------------------------------------------

    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
            UPDATE="UPDATE rs_kp_angaze_skladniki "
            SET='SET '
            
            for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                
                if pole in ['skladnik_id']:
                    if str(wart).strip()<>'':
                        SET+=pole+"='"+str(wart).strip()+"',"
                    else:
                        dane.append('SKL BR$'+str(Update[0][i][0]))
                        wyn2.append([Update[0][i],0]) 
                            
                elif pole in ['data_od']:
                    if wart not in (None,'None') and wart.strip()<>'':
                        SET+=pole+"='"+wart+"',"
                    else:
                        dane.append('DATA_OD BR$'+str(Update[0][i][1]))
                        wyn2.append([Update[0][i],0]) 
                elif pole in ['data_do',]:
                    if wart not in (None,'None') and wart.strip()<>'':
                        SET+=pole+"='"+wart+"',"
                    else:
                        SET+=pole+" = NULL,"
                
                elif pole in ['kwota']:
                    SET+=pole+"='"+str(wart).strip()+"',"

            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND  pracownik_id='"+Pracownik
            WHERE +="' AND zatrudnienie_id="+Zatrudnienie+" AND umowa_id="+Umowa
            WHERE +=" AND angaz_id='"+Angaz +"'"
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=Update[2][i][j]
                if pole in ['skladnik_id']:
                    WHERE+=" AND "+pole+"='"+str(wart).strip()+"'"
                else:
                    WHERE+=" AND "+pole+"='"+wart+"'"
            sql+=UPDATE+SET+WHERE+";"
            
        if sql<>'': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='Bdy zmiany pozycji: ' + stat
                dane.append(stat)

        #WS 2022-05-05 - kontrola zazbiania si dat
        if stat == 'OK':
            # ptla po wszystkich zmodyfikowanych wierszach
            for pola, wartosci, klucz, nr_wiersza in zip(Update[0], Update[1], Update[2], Update[-1]):
                stat = 'OK'

                if 'skladnik_id' in pola:
                    skladnik_id = wartosci[pola.index('skladnik_id')]
                else:
                    skladnik_id = klucz[Update[3].index('skladnik_id')]

                if 'data_od' in pola:
                    data_od = wartosci[pola.index('data_od')]
                else:
                    data_od = klucz[Update[3].index('data_od')]

                if 'data_do' in pola:
                    data_do = wartosci[pola.index('data_do')]
                else:
                    SEL = """SELECT data_do FROM rs_kp_angaze_skladniki
                             WHERE firma_id='{self.firma_id}' AND pracownik_id='{Pracownik}'
                                   AND zatrudnienie_id={Zatrudnienie} AND umowa_id={Umowa}
                                   AND angaz_id={Angaz} AND skladnik_id='{skladnik_id}'
                                   AND data_od='{data_od}';""".format(**locals())
                    rsglobal.ZapiszDoLogow(SEL)
                    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
                    if stat != 'OK':
                        stat = u'Bd pobrania danych wiersza: '+stat
                        dane.append(stat)
                        wyn2.append((nr_wiersza, 0))
                    else:
                        data_do = d[0][0]

                if stat == 'OK':
                    dane, wyn2 = sprawdz_daty(self, data_od, data_do, skladnik_id, nr_wiersza, Pracownik, Zatrudnienie, Umowa, Angaz, dane, wyn2)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                

#-------------------------------------------------------------------------------
#-------     Sprawdzanie danych do Insert   
#-------------------------------------------------------------------------------

    if stat == 'OK':      
        Insert=klucze['Insert'] 
        if len(Insert[0])>0:
            if not UprModyfikowanie:
                stat='UPR INS'
                dane.append(stat)        
            if stat == 'OK':  
                for i in xrange(len(Insert[0])):            
                    for j in xrange(len(Insert[0][i])):
                        if stat == 'OK':                            
                            pole=Insert[1][j]
                            wart=Insert[0][i][j]     
                            if pole== u'skladnik_id': 
                                if wart.strip()=='':
                                    dane.append(u'Brak skadnika dla pozycji: '+str(Insert[-1][i]))
                                    wyn2.append([Insert[-1][i],0])   
                            elif pole==u'data_od':
                                if wart not in (None,'None') and wart.strip()<>'':
                                    if not rsglobal.SprawdzCzyToData(wart.strip()):
                                        stat=u'Bd wartoci daty od dla pozycji:'+str(Insert[-1][i])        
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],2])
                                else:
                                    dane.append('Brak wartoci daty od dla pozycji: '+str(Insert[-1][i]))
                                    wyn2.append([Insert[-1][i],1])
                            elif pole=='data_do':                                  
                                if wart not in (None,'None') and wart.strip()<>'':
                                    if not rsglobal.SprawdzCzyToData(wart.strip()):                            
                                        stat=u'Bd wartoci daty do dla pozycji: '+str(Insert[-1][i])
                                        wyn2.append([Insert[-1][i],2])

                            elif pole==u'kwota':
                                if wart == 0:
                                    dane.append(u'Zerowa kwota w pozycji: '+str(Insert[-1][i]))
                                    wyn2.append([Insert[-1][i],4])

                if len(dane)>0 and stat == 'OK':
                    stat=dane[-1]
                    
                    
#-------------------------------------------------------------------------------
#---   INSERT DANYCH 
#-------------------------------------------------------------------------------
    
    if stat=='OK': 
        Insert=klucze['Insert']  
        if not UprModyfikowanie:
            stat='UPR INS'
            dane.append(stat)
        if stat=='OK':            
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_angaze_skladniki "
                KOLUMNY="(firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id "
                VALUES=" VALUES ('"+self.firma_id+"','"+Pracownik+"','"+Zatrudnienie+"','"+Umowa+"','"+Angaz+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]  
                    if pole in ['skladnik_id']:
                        if str(wart).strip()=='':
                            stat= 'SKL BR$'+str(Insert[0][i][0])
                            dane.append(stat)
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart).strip()+"'"
                    elif pole in ['data_od']:
                        if wart not in (None,'None') and wart.strip()<>'':                          
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart)+"'"  
                        else:
                            stat= u'DATA OD BR$'+str(Insert[0][i][1])
                            dane.append(stat)               
                    elif pole in ['data_do']:
                        if wart not in (None,'None') and wart.strip()<>'':                            
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart)+"'" 
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",NULL"        
                    elif pole in ['kwota']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"
                KOLUMNY+=")"
                VALUES+=");"
                sql+=INSERT+KOLUMNY+VALUES
                rsglobal.ZapiszDoLogow('sql '+sql,1)
            if sql<>'':
                if stat=='OK':     
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat=u'INS BL$'+stat
                        dane.append(stat)

        #WS 2022-05-05
        if stat == 'OK':
            for wartosci, nr_wiersza in zip(Insert[0], Insert[-1]):
                data_od = wartosci[Insert[1].index('data_od')]
                data_do = wartosci[Insert[1].index('data_do')]
                skladnik_id = wartosci[Insert[1].index('skladnik_id')]

                dane, wyn2 = sprawdz_daty(self, data_od, data_do, skladnik_id, nr_wiersza, Pracownik, Zatrudnienie, Umowa, Angaz, dane, wyn2)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
            
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,5)
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [1,5]):
    sql ="SELECT TRIM(ask.skladnik_id),sp.opis, ask.data_od, ask.data_do, ask.kwota FROM rs_kp_angaze_skladniki ask "
    sql+=" INNER JOIN rs_kp_skladniki_placowe sp USING (firma_id,skladnik_id)"
    sql +="WHERE ask.firma_id='"+str(self.firma_id)+"' AND ask.pracownik_id='" + Pracownik 
    sql +="' AND ask.zatrudnienie_id="+Zatrudnienie+" AND ask.umowa_id="+Umowa+" AND ask.angaz_id="+Angaz
    if DataOd <> '    -  -  ':
        sql += " AND ask.data_od>='"+DataOd+"'"
    if DataDo <> '    -  -  ':
        sql += " AND ask.data_do<='"+DataDo+"'"
    if Skladnik <> '':
        sql+= " AND ask.skladnik_id LIKE '"+Skladnik+"%'"
    sql += "ORDER BY ask.skladnik_id, ask.data_od;"
    
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych : "+stat   
        dane.append(stat)
