#!/usr/bin/python
# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:			fs_kp_dane_osobowe_kartoteka_zarobkowa.py
# Purpose:		wywietla kartotek zarobkow pracownika
# Author:		Aleksander Bargie
# Created:		2017/08/06
# RCS-ID:		$Id: fs_kp_dane_osobowe_kartoteka_zarobkowa.py $
# Copyright:	(c) 2018 RecordSystem
# Licence:		GNU GPL
# -----------------------------------------------------------------------------
# 2018-08-21 Aleksander Bargie 11185 - Kartoteka zarobkowa - doda nazw skadnika
# 2019-02-06 Wojciech   Skowron 11394 - Zmiana w pobieraniu danych do kartoteki zarobkowej
# 2019-03-08 Aleksander Bargie 11430 - Kartoteka zarobkowa - opcja wywietlania po dacie wypaty

stat = 'OK'

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    
    SlPar = {'Pracownik': [5], 'Rok': [5], 'WgWyplaty': [5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat  = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_kartoteka_zarobkowa z numerem ' + str(Funkcja)
        stat += ' bez parametrw: ' + Lista

if stat == 'OK':
    if Funkcja in [5]:
        prac      = klucze['Pracownik']
        rok       = klucze['Rok']
        wgWyplaty = klucze['WgWyplaty']

dane = []
wyn1 = []
wyn2 = []

Upr = ((self.oddzial_id, '052240') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
if not Upr:
    stat = 'Brak uprawnie do przegldania kartoteki zarobkowej'

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5 - select)
# -------------------------------------------------------------------------------
                
if (Funkcja in [5]) and (stat == 'OK'):  #AB 11.03.19r
    #WS 2019-02-06 - zamiana 'data_wyplaty' na 'l.data_od'
    if wgWyplaty:
        data = 'data_wyplaty'
    else:
        data = 'data_od'
    SQL = """SELECT skladnik_id || ' - ' || s.opis, sum(wartosc) as sum,
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 1  THEN wartosc ELSE 0 END) AS "01",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 2  THEN wartosc ELSE 0 END) AS "02",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 3  THEN wartosc ELSE 0 END) AS "03",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 4  THEN wartosc ELSE 0 END) AS "04",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 5  THEN wartosc ELSE 0 END) AS "05",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 6  THEN wartosc ELSE 0 END) AS "06",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 7  THEN wartosc ELSE 0 END) AS "07",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 8  THEN wartosc ELSE 0 END) AS "08",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 9  THEN wartosc ELSE 0 END) AS "09",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 10 THEN wartosc ELSE 0 END) AS "10",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 11 THEN wartosc ELSE 0 END) AS "11",
                    sum(CASE WHEN EXTRACT(MONTH FROM l.{data}) = 12 THEN wartosc ELSE 0 END) AS "12"
FROM rs_kp_listy_plac_osoby_skladniki JOIN rs_kp_listy_plac l USING (firma_id, numer_listy_id)
JOIN rs_kp_skladniki_placowe s USING (firma_id, skladnik_id)
WHERE firma_id = '{firma}' AND pracownik_id = '{prac}' AND l.{data} IS NOT NULL  
AND EXTRACT(YEAR FROM l.{data}) = '{rok}'  AND wartosc != 0 AND l.stan != 'W'
GROUP BY skladnik_id || ' - ' || s.opis
ORDER BY skladnik_id || ' - ' || s.opis;""".format(firma=self.firma_id, prac=prac, rok=rok, data=data)
    rsglobal.ZapiszDoLogow(SQL, 5)
    stat, dane, wyn, dump = self.PolSQL.Execute(SQL, 3)
