# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_kary_dane
# Purpose:     dodawanie/edycja danych o karach pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/08/24
# RCS-ID:      $Id: fs_kp_dane_osobowe_kary_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2018-08-23  (10560) Aleksander Bargie - Refaktoryzacja

Fun        = klucze['Funkcja']
Pracownik  = klucze['Pracownik']
if Fun in(1, 2, 3, 4, 5):
    KaraId       = klucze['IdKary']
if 'Rodzaj' in klucze:
    Rodzaj       = klucze['Rodzaj']
if 'DataNadania' in klucze:
    DataNadania  = klucze['DataNadania']
if 'DataWaznosci' in klucze:
    DataWaznosci = klucze['DataWaznosci']
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
Numer = 0

UprDodawanie = (((self.oddzial_id, '052153') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja    = (((self.oddzial_id, '052152') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or \
               UprDodawanie


# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE UPRAWNIEN
# -------------------------------------------------------------------------------

if Fun in (1, 2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3, 4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
        

# -------------------------------------------------------------------------------
# --- POBRANIE NUMERU ( 9 - pobranie nowego numeru)
# -------------------------------------------------------------------------------

if Fun == 9:
    SELECT  = "SELECT kara_id FROM rs_kp_dane_osobowe_kary"
    SELECT += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    SELECT += " ORDER BY kara_id DESC LIMIT 1;"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych o nowym id kary : '+stat
        dane.append(stat)
    else:
        if len(dane) != 0:
            Numer = int(dane[0][0])+1
        else:
            Numer = 1
            
        dane = str(Numer)


# -------------------------------------------------------------------------------
# --- SPRAWDZENIE DANYCH (1, 2, 3, 4) - bez 5 (pobieranie)
# -------------------------------------------------------------------------------

if Fun in (1, 2, 3, 4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]   
        if pole == 'kara_rodzaj':
            if wart == '':
                stat = 'BR_KRODZ'
            else:
                sql  = "SELECT kod FROM rs_rodzaje_kar"
                sql += " WHERE firma_id = '"+self.firma_id+"' AND kod = '"+str(wart)+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania rodzaju kary : '+stat)
                elif len(d) == 0:
                    dane.append('BL_KRODZ')        
          
        elif pole == 'data_nadania':
            if wart != '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_NAD')
            else:    
                stat = 'BR DATA_NAD'
                dane.append(stat)        

        elif pole == 'data_waznosci':
            if wart != '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_WAZ')         
           
        elif pole == 'tresc':
            if len(wart) > 100:
                stat = 'DL_TRESC'
                dane.append(stat)

    if stat == 'OK' and (DataWaznosci != '    -  -  ' and DataNadania != '    -  -  '):
        sql = "SELECT '"+str(DataNadania)+"' > '"+str(DataWaznosci)+"';"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3) 
        if stat != 'OK':
            dane.append('Bd sprawdzenia zakresu dat : '+stat)
        elif len(d) > 0:
            if d[0][0] in [True, 'True']:  # jesli wieksze to odpowiedni stat
                stat = 'DATA_POZ'
                dane.append(stat) 

    if len(dane) > 0:
        stat = dane[0]


# -------------------------------------------------------------------------------
# --- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
# -------------------------------------------------------------------------------

if Fun in (1, 2) and stat == 'OK':

    ins      = "INSERT INTO rs_kp_dane_osobowe_kary"
    Pola     = "firma_id, pracownik_id, kara_id"
    Wartosci = "'"+self.firma_id+"', '"+Pracownik+"', '"+str(KaraId)+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['tresc', 'kara_rodzaj', 'data_nadania', 'data_waznosci']:
            Pola = Pola+", "+pole
            if wart.strip() == '' or wart == '    -  -  ':
                Wartosci = Wartosci+", NULL"
            else:
                Wartosci = Wartosci+", '"+str(wart)+"'"
        elif pole in ['lista_id']:
            Pola = Pola+", "+pole
            if wart == '':
                Wartosci = Wartosci+", NULL"
            else:
                Wartosci = Wartosci+", '"+str(wart)+"'"
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
    stat, dump, dump, dump = self.PolSQL.Execute(ins, 1)
    if stat != 'OK':
        stat = 'Bdy dodawania danych:'+stat
        dane.append(stat)  
        
          
# -------------------------------------------------------------------------------
# --- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
# -------------------------------------------------------------------------------

if Fun in (3, 4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_dane_osobowe_kary SET "  
    for i in xrange(len(pola)):
        UPDATE += pola[i]+'='
        if pola[i] in ['data_nadania', 'data_waznosci']:
            if wartosci[i] in ['', '    -  -  ']:
                UPDATE += " NULL,"
            else:
                UPDATE += " '"+str(wartosci[i])+"',"
        else:
            UPDATE += " '"+str(wartosci[i])+"',"
    UPDATE  = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    UPDATE += " AND kara_id = '"+str(KaraId)+"';"
    stat, dump, dump, dump = self.PolSQL.Execute(UPDATE, 1)
    if stat != 'OK':
        stat = 'Bd przy modyfikacji danych : '+stat

# -------------------------------------------------------------------------------
# --- SPRAWDZENIE UNIKALNOSCI DANYCH 
# -------------------------------------------------------------------------------

if Fun in (1, 2, 3, 4) and stat == 'OK':

    spr  = "SELECT k1.* FROM rs_kp_dane_osobowe_kary k1 JOIN rs_kp_dane_osobowe_kary k2 ON k1.firma_id = k2.firma_id "
    spr += "AND k1.pracownik_id = k2.pracownik_id AND k2.kara_rodzaj = k1.kara_rodzaj AND k1.data_nadania ="
    spr += " k2.data_nadania AND k1.kara_id != k2.kara_id WHERE k1.firma_id='{firma}' AND k1.pracownik_id='{prac}' "
    spr += " AND k1.kara_id='{kara}';"
    spr  = spr.format(firma=self.firma_id, prac=Pracownik, kara=KaraId)
    rsglobal.ZapiszDoLogow(spr, 5)
    stat, d, dump, dump = self.PolSQL.Execute(spr, 3)
    if stat != 'OK':
        dane.append('Bd sprawdzenia unikalnoci kary : '+stat)
    elif len(d) != 0:
        stat = 'W dniu ' + DataNadania + ' zostaa ju wprowadzona kara tego rodzaju.'


# -------------------------------------------------------------------------------
# --- POBRANIE DANYCH ( 5 - select, 3 - update z pobraniem)
# -------------------------------------------------------------------------------

if Fun in (1, 3, 5) and stat == 'OK':
    SELECT  = "SELECT * FROM rs_kp_dane_osobowe_kary"
    SELECT += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    SELECT += " AND kara_id = '"+str(KaraId)+"';"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych o karach pracownika : '+stat
        dane.append(stat)
    kw = ''
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane, wyn1)
        if (self.oddzial_id, '011820') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                                                        # AB 22.08.18r
            sql = "SELECT opis FROM rs_rodzaje_kar WHERE firma_id = '" + self.firma_id + "' AND kod = '"+tr.GetVal(0, "kara_rodzaj")+"';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                kw = 'Bd pobrania opisu ze sownika rodzajw kar : '+stat
            else:
                if len(d) == 0:
                    kw = 'Bdny rodzaj kary.'
                else:
                    kw = str(d[0][0])
        else:
            kw = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2 = [kw]
