# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_kwalifikacje_dane
# Purpose:     dodawanie/edycja danych o kwalifikacjach pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/07/20
# RCS-ID:      $Id: fs_kp_dane_osobowe_kwalifikacje_dane.py $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2018-03-22 Piotr Witkowski (10561) Refaktoryzacja

stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {
        'Pracownik': [1, 2, 3, 4, 5, ],
        'Kwalifikacja': [1, 2, 3, 4, 5, ],
        'DataUkonczenia': [1, 2, 3, 4, 5, ],
        'DataUObecna': [1, 2, 3, 4, ],
        'KwalifikacjaId': [1, 2, 3, 4, ],
    }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_kwalifikacje z numerem '
        stat += str(Funkcja) + ' bez parametrw: ' + Lista

if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []

    if stat == 'OK' and Funkcja in [1, 2, 3, 4, 5, ]:
        Pracownik = klucze['Pracownik']
        Kwalifikacja = klucze['Kwalifikacja']
        DataUkonczenia = klucze['DataUkonczenia']
        KwalifikacjaF = Kwalifikacja

    if stat == 'OK' and Funkcja in [1, 2, 3, 4, ]:
        DataUObecna = klucze['DataUObecna']
        KwalifikacjaId = klucze['KwalifikacjaId']

# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE UPRAWNIEN
# -------------------------------------------------------------------------------

if stat == 'OK':
    UprDodawanie = (((self.oddzial_id, '052123') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprEdycja = (((self.oddzial_id, '052122') in self.uprawnienia) or (
            self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
    if Funkcja in (1, 2):
        if not UprDodawanie:
            stat = 'BR UPR INS'
    if Funkcja in (3, 4):
        if not UprEdycja:
            stat = 'BR UPR UPD'

# -------------------------------------------------------------------------------
# --- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    for i in range(len(pola)):
        pole = pola[i]
        wart = str(wartosci[i])
        lista_wart = wart.split("\\")
        wart = "".join(lista_wart)
        if pole == 'data_ukonczenia':
            if wart != '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_UK')
            else:
                stat = 'BR DATA_UK'
                dane.append(stat)

        elif pole == 'kwalifikacja_id':
            if wart == '':
                stat = 'BR_KWAL'
            else:
                sql = "SELECT kod FROM rs_kwalifikacje"
                sql += " WHERE firma_id = '" + self.firma_id + "' AND kod = '" + str(wart) + "';"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu kwalifikacji : ' + stat)
                elif len(d) == 0:
                    dane.append('BL_KWAL')
                elif DataUkonczenia != '    -  -  ':
                    sql = "SELECT kwalifikacja_id FROM rs_kp_dane_osobowe_kwalifikacje"
                    sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
                    sql += " AND kwalifikacja_id= '" + str(Kwalifikacja) + "' AND data_ukonczenia='" + str(DataUkonczenia) + "';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        dane.append('Bd sprawdzania poprawnoci kwalifikacji : ' + stat)
                    else:
                        if len(d) != 0:
                            stat = 'KWAL_JEST1'
                            dane.append(stat)
            KwalifikacjaF = wart

        elif pole == 'data_waznosci':
            if wart != '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_WAZN')

        elif pole == 'opis':
            if len(wart) > 30:
                stat = 'DL_OPIS'
                dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# --- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2):
    ins = "INSERT INTO rs_kp_dane_osobowe_kwalifikacje"
    Pola = "firma_id,pracownik_id"
    Wartosci = "'" + self.firma_id + "','" + Pracownik + "'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['kwalifikacja_id', 'opis', 'data_ukonczenia', 'data_waznosci']:
            Pola = Pola + "," + pole
            if wart.strip() == '' or wart == '    -  -  ':
                Wartosci = Wartosci + ",NULL"
            else:
                Wartosci = Wartosci + ",'" + str(wart) + "'"

    ins = ins + " (" + Pola + ") VALUES (" + Wartosci + ");"
    stat, dump, dump, dump = self.PolSQL.Execute(ins, 1)
    if stat != 'OK':
        stat = 'Bdy dodawania danych:' + stat
        dane.append(stat)


# -------------------------------------------------------------------------------
# --- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3, 4):
    UPDATE = "UPDATE rs_kp_dane_osobowe_kwalifikacje SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'data_waznosci' and wart in [None, 'None', '', '    -  -  ']:
            UPDATE += pole + "=Null,"
        else:
            UPDATE += pole + "='" + str(wart) + "',"

    UPDATE = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + str(Pracownik) + "' "
    UPDATE += " AND kwalifikacja_id = '" + str(KwalifikacjaId) + "' AND data_ukonczenia='" + str(DataUObecna) + "';"
    stat, dump, dump, dump = self.PolSQL.Execute(UPDATE, 1)
    if stat != 'OK':
        stat = u'Bd modyfikacji uprawnienia dot.kadr : istnieje ju kwalifikacja '
        stat += str(Kwalifikacja) + u' ktrej data ukoczenia jest rwna ' + str(DataUkonczenia)

# -------------------------------------------------------------------------------
# --- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5):
    SELECT = "SELECT * FROM rs_kp_dane_osobowe_kwalifikacje"
    SELECT += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "' "
    SELECT += "AND kwalifikacja_id = '" + str(KwalifikacjaF) + "' and data_ukonczenia = '" + str(DataUkonczenia) + "';"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych o kwalifikacjach pracownika : ' + stat
        dane.append(stat)
    kw = ''
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane, wyn1)
        if (self.oddzial_id, '011610') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_kwalifikacje WHERE firma_id = '" + self.firma_id + "' "
            sql += "AND kod = '" + tr.GetVal(0, "kwalifikacja_id") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                kw = 'Bd pobrania opisu ze sownika kwalifikacji : ' + stat
            else:
                if len(d) == 0:
                    kw = 'Bdny kod kwalifikacji.'
                else:
                    kw = str(d[0][0])
        else:
            kw = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2 = [kw]
