#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_kp_dane_osobowe_limity_urlopow.py
# Purpose:		dodaje/pobiera/usuwa limity urlopw pracownika
# Author:		Micha Raburski
# Created:		2016/04/20
# RCS-ID:		$Id: fs_kp_dane_osobowe_limity_urlopow.py $
# Copyright:	(c) 2016 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------
# 2018-09-05 Aleksander Bargie (11211) - [KP] z grida 'Limity urlopw' usun kolumny
# 2020-08-15 Jan Raburski (12086) - dodanie limitow zaleglych
# 2021-05-28 Jan Raburski (12501) - od_dnia zamiast rok
# 2021-06-01 Wojciech Skowron (12504) - sprawdzenie z absencjami

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Pracownik':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_limity_urlopow z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5]:
        Pracownik = klucze['Pracownik']

dane = []
wyn1 = []
wyn2 = []

UprUpd=((self.oddzial_id,'052222') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Insert=klucze['Insert']
    Update=klucze['Update']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUpd:
            stat='UPR UPD'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQL=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_kp_dane_osobowe_limity_urlopow "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    #WS 2021-06-01
                    if pole in ['od_dnia', ]:
                    # if pole in ['do_dnia',]:
                        WHERE+=" AND "+pole+"='"+str(wart)+"'"
                    elif pole in ['urlop_id']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                SQL+=DELETE+WHERE+";"
            
            if SQL<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(SQL ,1)
                if stat<>'OK':
                    stat='DEL BL'
                    dane.append(stat)
    

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='UPR UPD'
            dane.append(stat)
    
        if stat=='OK': #sprawdzanie danych
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                OdDnia = UrlopID = ''  #WS 2021-06-01

                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    if stat=='OK':
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole=='urlop_id':
                            if wart.strip()=='':
                                dane.append('URLOP BR$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])
                                UrlopID = None
                            else:
                                SQL ="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+str(wart)+"'; "
                                stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat=='OK':
                                    if len(d)==0:
                                        dane.append('URLOP BL$'+str(Update[-1][i]))
                                        wyn2.append([Update[-1][i],0])
                                        UrlopID = None
                                    else:
                                        UrlopID = wart
                                else:
                                    dane.append('Bad sprawdzania rodzaju absencji')
                                    UrlopID = None

                        elif pole=='od_dnia':
                            if wart < '2010-01-01' or wart > '2500-01-01':
                                dane.append('ROK BL$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],2])
                                OdDnia = None
                            else:
                                OdDnia = wart

                        elif pole=='limit_dni':
                            if wart<0 or wart >999:
                                dane.append('LIMITD$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],3])

                        elif pole=='limit_godziny':
                            if wart<0 or wart >99999:
                                dane.append('LIMITG$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],4])
                        #JR 15.08.20
                        elif pole=='limit_dni_zalegle':
                            if wart<0 or wart >999:
                                dane.append('LIMITDZ$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],5])

                        elif pole=='limit_godziny_zalegle':
                            if wart<0 or wart >99999:
                                dane.append('LIMITGZ$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],6])
                        #AB 05.09.18r
                        # elif pole=='wykorzystane_dni':
                        #     if wart<0 or wart >999:
                        #         dane.append('WYKORZD$'+str(Update[-1][i]))
                        #         wyn2.append([Update[-1][i],5])
                        #
                        # elif pole=='wykorzystane_godziny':
                        #     if wart<0 or wart >99999:
                        #         dane.append('WYKORZG$'+str(Update[-1][i]))
                        #         wyn2.append([Update[-1][i],6])
                        #
                        # elif pole=='pozostalo_dni':
                        #     if wart<-999 or wart >999:
                        #         dane.append('POZOSTD$'+str(Update[-1][i]))
                        #         wyn2.append([Update[-1][i],7])
                        #
                        # elif pole=='pozostalo_godziny':
                        #     if wart<-99999 or wart >99999:
                        #         dane.append('POZOSTG$'+str(Update[-1][i]))
                        #         wyn2.append([Update[-1][i],8])

                #WS 2021-06-01
                if OdDnia is not None and UrlopID is not None:
                    for j in xrange(len(Update[2][i])):  # petla po kluczu
                        pole=Update[3][j]
                        wart=Update[2][i][j]
                        if pole == 'od_dnia' and OdDnia == '':
                            OdDnia = wart
                        if pole == 'urlop_id' and UrlopID == '':
                            UrlopID = wart

                    SQL = "SELECT * FROM rs_kp_dane_osobowe_absencje " \
                          "WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+\
                          "' AND typ_absencji_id='"+UrlopID+"' AND do_kiedy >= '"+OdDnia+"';"
                    rsglobal.ZapiszDoLogow(SQL)
                    stat,d,dump,dump=self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':
                        dane.append('Bd sprawdzania absencji')
                    elif len(d) > 0:
                        dane.append('Istniej absencje o podanym typie i pniejszej dacie')
                        wyn2.append([Update[-1][i],0])
                        wyn2.append([Update[-1][i],2])

        if stat=='OK':
            if len(dane)>0:
                stat=dane[-1]
                
        if stat=='OK':
            SQL=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                UPDATE="UPDATE rs_kp_dane_osobowe_limity_urlopow "
                SET='SET '
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]

                    # AB 05.09.18r, #JR 2020-08-15
                    if pole in ['limit_dni','limit_godziny','limit_dni_zalegle','limit_godziny_zalegle']: # ,'wykorzystane_dni','wykorzystane_godziny','pozostalo_dni','pozostalo_godziny'
                        SET+=pole+"="+str(wart)+","
                        
                    elif pole in ['od_dnia','urlop_id']:
                        SET+=pole+"='"+wart+"',"
                    
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
                
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=Update[2][i][j]
                    if pole in ['rok',]:
                        WHERE+=" AND "+pole+"="+str(wart)
                    elif pole in ['od_dnia','urlop_id']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                        
                SQL+=UPDATE+SET+WHERE+";"
                
            if SQL<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(SQL ,1)

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprUpd:
            stat='UPR UPD'
            dane.append(stat)   
            
        if stat == 'OK':
            for i in xrange(len(Insert[0])):
                OdDnia = UrlopID = None  #WS 2021-06-01

                for j in xrange(len(Insert[0][i])):
                    if stat=='OK':
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        if pole=='urlop_id':
                            if wart.strip()=='':
                                dane.append('URLOP BR$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],0])
                            else:
                                SQL ="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+str(wart)+"'; "
                                stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat=='OK':
                                    if len(d)==0:
                                        dane.append('URLOP BL$'+str(Insert[-1][i]))
                                        wyn2.append([Insert[-1][i],0])
                                    else:
                                        UrlopID = wart

                        elif pole=='od_dnia':
                            if wart < '2010-01-01' or wart > '2500-01-01':
                                dane.append('ROK BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],2])
                            else:
                                OdDnia = wart

                        elif pole=='limit_dni':
                            if wart<0 or wart >999:
                                dane.append('LIMITD$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],3])

                        elif pole=='limit_godziny':
                            if wart<0 or wart >99999:
                                dane.append('LIMITG$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],4])
                        #JR 2020-08-15
                        elif pole=='limit_dni_zalegle':
                            if wart<0 or wart >999:
                                dane.append('LIMITDZ$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],5])

                        elif pole=='limit_godziny_zalegle':
                            if wart<0 or wart >99999:
                                dane.append('LIMITGZ$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],6])
                        #AB 05.09.18r
                        # elif pole=='wykorzystane_dni':
                        #     if wart<0 or wart >999:
                        #         dane.append('WYKORZD$'+str(Insert[-1][i]))
                        #         wyn2.append([Insert[-1][i],5])
                        #
                        # elif pole=='wykorzystane_godziny':
                        #     if wart<0 or wart >99999:
                        #         dane.append('WYKORZG$'+str(Insert[-1][i]))
                        #         wyn2.append([Insert[-1][i],6])
                        #
                        # elif pole=='pozostalo_dni':
                        #     if wart<-999 or wart >999:
                        #         dane.append('POZOSTD$'+str(Insert[-1][i]))
                        #         wyn2.append([Insert[-1][i],7])
                        #
                        # elif pole=='pozostalo_godziny':
                        #     if wart<-99999 or wart >99999:
                        #         dane.append('POZOSTG$'+str(Insert[-1][i]))
                        #         wyn2.append([Insert[-1][i],8])

                #WS 2021-06-01
                if OdDnia is not None and UrlopID is not None:
                    SQL = "SELECT 1 FROM rs_kp_dane_osobowe_absencje " \
                          "WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+\
                          "' AND typ_absencji_id='"+UrlopID+"' AND do_kiedy >= '"+OdDnia+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(SQL, 3)
                    rsglobal.ZapiszDoLogow(SQL)
                    if stat != 'OK':
                        dane.append('Bd sprawdzania absencji')
                    elif len(d) > 0:
                        dane.append('Istniej absencje o podanym typie i pniejszej dacie')
                        wyn2.append([Insert[-1][i],0])
                        wyn2.append([Insert[-1][i],2])

        if stat=='OK':        
            if len(dane)>0:
                stat=dane[-1]
                
        if stat=='OK':    
            SQL=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_dane_osobowe_limity_urlopow "
                KOLUMNY="(firma_id,pracownik_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Pracownik+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    #JR 2020-08-15
                    #if pole in ['ilosc1','ilosc2','pojemnosc_paletowa','lp']:
                    #    KOLUMNY+=","+pole
                    #    VALUES+=","+str(wart)

                    #AB 05.09.18r, #JR 2020-08-15
                    if pole in ['limit_dni','limit_godziny','limit_dni_zalegle','limit_godziny_zalegle']: # ,'wykorzystane_dni','wykorzystane_godziny','pozostalo_dni','pozostalo_godziny'
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)

                    elif pole in ['od_dnia','urlop_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                SQL+=INSERT+KOLUMNY+VALUES
                
            if SQL<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(SQL ,1)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------
                
if (Funkcja in [1,5]) and (stat=='OK'):
        #AB 05.09.18r
    SQL ="SELECT lu.urlop_id,ar.nazwa,lu.od_dnia,lu.limit_dni,lu.limit_godziny,lu.limit_dni_zalegle,lu.limit_godziny_zalegle" # ,lu.wykorzystane_dni,lu.wykorzystane_godziny, lu.pozostalo_dni, lu.pozostalo_godziny
    SQL +=" FROM rs_kp_dane_osobowe_limity_urlopow lu " \
         " INNER JOIN rs_kp_absencje_rodzaje ar ON (ar.firma_id=lu.firma_id AND ar.typ_absencji_id=lu.urlop_id) " \
         " WHERE lu.firma_id = '"+self.firma_id+"' AND lu.pracownik_id='"+Pracownik+"' " \
         " ORDER BY lu.od_dnia DESC, lu.urlop_id"

    stat,dane,wyn,dump=self.PolSQL.Execute(SQL,3)