# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_ppk_skladki.py
# Purpose:     Obsuga grida PPK skadki
# Author:      Wojciech Skowron
# Created:     2020/10/01
# RCS-ID:      $Id: fs_kp_dane_osobowe_ppk_skladki.py $
# Copyright:   (c) 2020 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
052255 - Skadki - przegldanie
"""

"""Funkcje:
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Pracownik': [5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_ppk_skladki z numerem ' + str(Funkcja)
        stat += ' bez parametrw: ' + Lista

dane = []
wyn1 = []
wyn2 = []

if stat == 'OK' and Funkcja in (5,):
    Pracownik = klucze['Pracownik']

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id,'052255') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrzegl:
        stat = 'BR_UPR_PRZ'
        dane.append(stat)
    else:
        SEL = """SELECT rok, mc, numer_listy_id, podstawa, skladka_prac_podst, skladka_prac_dodat, 
                        skladka_firma_podst, skladka_firma_dodat, skladka_obnizona,
                        skladka_prac_podst+skladka_prac_dodat+skladka_firma_podst+skladka_firma_dodat AS razem_skladki,
                        data_wyslania
                 FROM rs_kp_dane_osobowe_ppk_skladki WHERE firma_id='{}' AND pracownik_id='{}'
                 ORDER BY rok DESC, mc DESC;""".format(self.firma_id, Pracownik)
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
