# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_ror.py
# Purpose:     obsluga grida edytowalnego z rachunkami bankowymi
# Author:      Pawe Wjcikowski, Piotr Bender
# Created:     2010/07/13, 2016/04/11 - Refaktoryzacja
# RCS-ID:      $Id: fs_kp_dane_osobowe_ror.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-10-25 Wojciech Skowron   - (11716) BLAD podczas dodawania rachunku bankowego u pracownika
# 2019-11-07 Wojciech Skowron   - (11732) Usunicie kolumny 'Kwota'
# 2022-07-04 Aleksander Bargie - (13087) Bd usuwania rachunku bankowego u pracownika

import textwrap

# FUNKCJE
#
# 1 - zapis danych
# 2 - sprawdzanie uprawnie do moduu
# 5 - pobranie danych

stat='OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'PracownikF':[1,2,5]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_ror.py z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1,2,5]:
        Pracownik=rsglobal.Dekoduj(klucze['PracownikF'])

dane = []
DaneI = []

UprIns = ((self.oddzial_id,'052113') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd = ((self.oddzial_id,'052112') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel = ((self.oddzial_id,'052114') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

if Funkcja == 2:
    #spr. czy jest taka pozycja
    sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','rachunki_ror','"+Pracownik+"');"
    stat,d_ane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        if d_ane[0][0]<>'OK':
            stat = d_ane[0][0]
            dane.append(stat)
    else:
        stat='Problemy przy sprawdzaniu uprawnie do wybranego moduu :'+stat
        dane.append(stat)
      
      
#-------------------------------------------------------------------------------
#-------   DELETE  (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)               
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_kp_dane_osobowe_ror "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Pracownik)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['lp_id',]:
                        WHERE+=" AND "+pole+"="+str(wart)+""
                sql+=DELETE+WHERE+";"
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy usuwaniu danych: "+stat   
                dane.append(stat)  

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)
        if stat=='OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]

                    #WS 2019-10-28
                    if pole == 'lp_id':
                        if wart >= 10:
                            stat = 'LP BL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)

                    elif pole == 'numer_rachunku':
                        # przepisa wartosc na same cyfry < bo mog byc z '-' i ' '>
                        temp=''
                        for a1 in str(wart):
                            if a1.isdigit():
                                temp+=a1
                        st = rsglobal.SprNumerKonta(temp)
                        if st <> 'OK' :
                            stat = st
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        if temp <> '':
                            # sprawdzamy czy numery kont sie nie pokrywaja w ramach firmy
                            sql="SELECT pracownik_id,numer_rachunku FROM rs_kp_dane_osobowe_ror "
                            sql+=" WHERE firma_id='"+self.firma_id+"';"
                            st,dane_nr,dump,dump=self.PolSQL.Execute(sql,3)
                            if st<>'OK':
                                stat=u"Bd przy sprawdzaniu numeru rachunku: "+stat
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            else:
                                #WS 2019-10-28
                                nr=[]
                                for tmp in dane_nr:
                                    if str(tmp[1]).strip().isdigit() and str(tmp[1]).strip() == temp.strip():
                                        nr.append(str(tmp[0]))
                                    # nr=''
                                    # for a2 in str(tmp[1]):
                                    #     if a2.isdigit():
                                    #         nr+=a2
                                    # if nr == temp:

                                nr = list(set(nr))
                                nr.sort()

                                if nr != []:
                                    # stat='Podany numer rachunku jest ju wykorzystywany u pracownika nr '+str(tmp[0])
                                    # wyn2.append((WierszeNr[i],1))
                                    #WS 2019-10-28
                                    kom = 'Podany numer rachunku ('+str(WierszeNr[i])+') jest ju wykorzystywany u pracownika nr '+', '.join(nr)
                                    kom = textwrap.wrap(kom, 125)
                                    for k in kom:
                                        wyn2.append(k)
                                    # wyn2.append('Podany numer rachunku jest ju wykorzystywany u pracownika nr '+str(tmp[0]))
                                    # dane.append(stat)

                    elif pole == 'procent':
                        if wart > 100 or wart < 0:
                            stat = 'PROCENT BL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    #WS 2019-11-07
                    # elif pole == 'kwota':
                    #     if wart < 0 or len(str(wart)) > 16:
                    #         stat = 'KWOTA BL'
                    #         wyn2.append((WierszeNr[i],3))
                    #         dane.append(stat)

        #WS 2019-10-25
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_kp_dane_osobowe_ror "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole == 'lp_id':
                            SET+=pole+"="+str(wart)+","
                    #WS 2019-11-07
                    if pole in ['numer_rachunku','procent']:
                    # if pole in ['numer_rachunku','procent','kwota']:
                            SET+=pole+"='"+str(wart)+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id ='"+str(Pracownik)+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+str(wart)+"'"
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat=u"Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)
                                    
#-------------------------------------------------------------------------------
#--------- INSERT (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == "OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat = 'Brak uprawnie do dodawania danych'
            dane.append(stat)
        else:
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole = Insert[1][j]
                    wart = Insert[0][i][j]

                    #WS 2019-10-28
                    if pole == 'lp_id':
                        if wart >= 10:
                            stat = 'LP BL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)

                    elif pole == 'numer_rachunku':
                        # przepisa wartosc na same cyfry < bo mog byc z '-' i ' '>
                        temp=''
                        for b1 in str(wart):
                            if b1.isdigit():
                                temp+=b1
                        st = rsglobal.SprNumerKonta(temp)
                        if st <> 'OK' :
                            stat = st
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        if temp <> '':
                            # sprawdzamy czy numery kont sie nie pokrywaja w ramach firmy
                            sql="SELECT pracownik_id,numer_rachunku FROM rs_kp_dane_osobowe_ror "
                            sql+=" WHERE firma_id='"+self.firma_id+"';"
                            st,dane_nr,dump,dump=self.PolSQL.Execute(sql,3)
                            if st<>'OK':
                                stat=u"Bd przy sprawdzaniu numeru rachunku: "+stat
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            else:
                                #WS 2019-10-28
                                nr=[]
                                for tmp in dane_nr:
                                    if str(tmp[1]).strip().isdigit() and str(tmp[1]).strip() == temp.strip():
                                        nr.append(str(tmp[0]))
                                    # nr=''
                                    # for a2 in str(tmp[1]):
                                    #     if a2.isdigit():
                                    #         nr+=a2
                                    # if nr == temp:

                                nr = list(set(nr))
                                nr.sort()

                                if nr != []:
                                    # stat='Podany numer rachunku jest ju wykorzystywany u pracownika nr '+str(tmp[0])
                                    # wyn2.append((WierszeNr[i],1))
                                    #WS 2019-10-28
                                    kom = 'Podany numer rachunku ('+str(WierszeNr[i])+') jest ju wykorzystywany u pracownika nr '+', '.join(nr)
                                    kom = textwrap.wrap(kom, 125)
                                    for k in kom:
                                        wyn2.append(k)
                                    # wyn2.append('Podany numer rachunku jest ju wykorzystywany u pracownika nr '+str(tmp[0]))
                                    # dane.append(stat)
                        
                    elif pole == 'procent':
                        if wart > 100 or wart < 0:
                            stat = 'PROCENT BL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    #WS 2019-11-07
                    # elif pole == 'kwota':
                    #     rsglobal.ZapiszDoLogow('kw '+str(wart),5)
                    #     if wart < 0 or len(str(wart)) > 16:
                    #         stat = 'KWOTA BL'
                    #         wyn2.append((WierszeNr[i],3))
                    #         dane.append(stat)

        #WS 2019-10-25
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                                                           
        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_dane_osobowe_ror "
                KOLUMNY="(firma_id,pracownik_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+str(Pracownik)+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    #WS 2019-11-07
                    if pole in ['lp_id','numer_rachunku','procent']:
                    # if pole in ['lp_id','numer_rachunku','procent','kwota']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"
                KOLUMNY+=")"
                VALUES+=");"

                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat=u"Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)         

if Funkcja == 1 and stat == 'OK':
    # sprawdzamy na koniec czy procent nie przekracza 100%  #AB 04.07.22r dodane grup by
    SQL="SELECT SUM(procent) FROM rs_kp_dane_osobowe_ror WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Pracownik)+"' GROUP BY pracownik_id; "
    stat,DProc,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = u'Bd sprawdzenia sumy procent dla pracownika :'+stat
        dane.append(stat)
    elif len(DProc) > 0:
        #WS 2019-11-08
        if DProc[0][0] != 100:
        # if DProc[0][0] > 100:
            stat = 'PROCENT 100'
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 1 -delete)
#-------------------------------------------------------------------------------

if (Funkcja in [1,5]) and (stat=='OK'):
    #WS 2019-11-07
    sql="SELECT lp_id,numer_rachunku,procent FROM rs_kp_dane_osobowe_ror "
    # sql="SELECT lp_id,numer_rachunku,procent,kwota FROM rs_kp_dane_osobowe_ror "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Pracownik)+"';"
    stat,dane,wyn1,dump =self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat   
        dane.append(stat)