# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        rs_kp_dane_osobowe_szkoly
# Purpose:     dodawanie/edycja danych o szkoach pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/09/22
# RCS-ID:      $Id: rs_kp_dane_osobowe_szkoly.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = klucze[0]
Szkola = klucze[1]
Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = (((self.oddzial_id,'052173') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052172') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
#--- POBRANIE NUMERU ( 9 - pobranie nowego numeru)
#-------------------------------------------------------------------------------

if Fun ==9:
    SELECT ="SELECT szkola_id FROM rs_kp_dane_osobowe_szkoly"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    SELECT+=" ORDER BY szkola_id DESC LIMIT 1;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o nowym id szkoy : '+stat
        dane.append(stat)
    if stat=='OK':
        if len(dane)<>0:
            Numer=int(dane[0][0])+1
        else:
            Numer=1
            
        dane=str(Numer)
        

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':       
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i] 

        if pole == 'wyksztalcenie_id':
            if wart<>'':
                sql ="SELECT opis FROM rs_rodzaje_wyksztalcenia"
                sql+=" WHERE kod = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)               
                if stat <> 'OK':
                    dane.append('Bd pobrania kodu wyksztacenia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_WYK')
            else:
                stat='BR_WYK'
                dane.append(stat)                    
        

        elif pole == 'typ_szkoly_id':
            if wart<>'':
                sql ="SELECT opis FROM rs_typy_szkol"
                sql+=" WHERE kod = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)                
                if stat <> 'OK':
                    dane.append('Bd pobrania kodu typu szkoy : '+stat)
                elif len(d) == 0:
                    dane.append('BL_TYP')
            else:
                stat='BR_TYP'
                dane.append(stat)                          
                
        elif pole == 'nazwa':
            if wart<>'':
                if len(wart) > 50:
                    stat='DL_NAZWA'
                    dane.append(stat)

        elif pole == 'kierunek':
            if wart<>'':
                if len(wart) > 50:
                    stat='DL_KIER'
                    dane.append(stat)                 

        elif pole == 'data_ukonczenia':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_UK')
            else:    
                stat='BR DATA_UK'
                dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    ins = "INSERT INTO rs_kp_dane_osobowe_szkoly"
    Pola="firma_id,pracownik_id,szkola_id"
    Wartosci="'"+self.firma_id+"','"+Pracownik+"','"+str(Szkola)+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['wyksztalcenie_id','typ_szkoly_id','nazwa','kierunek','data_ukonczenia']:
            Pola= Pola+","+pole
            if wart.strip()=='' or wart=='    -  -  ':
                Wartosci= Wartosci+",NULL"                
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'" 
        elif pole in ['czas_trwania']:
            Pola= Pola+","+pole
            if wart=='':
                Wartosci= Wartosci+",NULL"                
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'" 
                                            
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat = 'Bdy dodawania danych:'+stat
        dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_dane_osobowe_szkoly SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        UPDATE += pole+"='"+str(wart)+"',"

    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    UPDATE+=" AND szkola_id = '"+str(Szkola)+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji szkoy pracownika : '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_kp_dane_osobowe_szkoly"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' "
    SELECT+="AND szkola_id = '"+str(Szkola)+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o szkoach pracownika : '+stat
        dane.append(stat)
    kw=''
    kw1=''
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        if (self.oddzial_id,'011920') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_rodzaje_wyksztalcenia WHERE kod = '"+tr.GetVal(0,"wyksztalcenie_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                kw = 'Bd pobrania opisu ze sownika rodzajw wyksztacenia : '+stat
            else:
                if len(d) == 0:
                    kw = 'Bdny kod rodzaju wyksztacenia.'
                else:
                    kw = str(d[0][0])
        else:
            kw = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
        if (self.oddzial_id,'011810') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_typy_szkol WHERE kod = '"+tr.GetVal(0,"typ_szkoly_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                kw1 = 'Bd pobrania opisu ze sownika typw szk : '+stat
            else:
                if len(d) == 0:
                    kw1 = 'Bdny kod rodzaju szkoy.'
                else:
                    kw1 = str(d[0][0])
        else:
            kw1 = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2 = [kw,kw1]