# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_zobowiazanie_ratalne.py
# Purpose:     Pobieranie/usuwanie zobowiza na gridzie ze zobowizaniami
# Author:      Piotr Bender
# Created:     2016/06/20
# RCS-ID:      $Id: fs_kp_dane_osobowe_zobowiazanie_ratalne.py $
# Copyright:   (c) 2004 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2016-08-31 Piotr Witkowski (9772) refaktoryzacja poprawki
# 2018-08-06 Aleksander Bargie (11169) Zmiany w zobowizaniach ratalnych
# 2019-01-23 Aleksander Bargie (11376) Bdy w oknie zobowizania/skadki
#
# Funkcje:
# 1 - Dodawanie danych
# 5 - Pobranie danych
# 6 - Usuwanie danych

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
#AB 06-08-18r
    SlPar = {'Pracownik': [1, 5, 6], 'ZobowiazanieIdF': [1, 5], 'DataOdF': [1, 5], 'Aktywne': [1, 5], 'Dodane': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)

    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_zobowiazanie_ratalne z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 5, 6]:
        PracownikId = rsglobal.Dekoduj(klucze['Pracownik'])
        ZobowiazanieIdF = rsglobal.Dekoduj(klucze['ZobowiazanieIdF'])
        DataOdF = rsglobal.Dekoduj(klucze['DataOdF'])
#AB 06-08-18r
        Aktywne = rsglobal.Dekoduj(klucze['Aktywne'])
        Dodane  = rsglobal.Dekoduj(klucze['Dodane'])

UprIns = ((self.oddzial_id, "052233") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUpd = ((self.oddzial_id, "052232") in self.uprawnienia) or ((self.oddzial_id, "052233") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel = ((self.oddzial_id, "052234") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprDel:
            stat='UPR BR DEL'
            dane.append(stat)

    # wykonanie DELETE
    if stat == 'OK':
        DELETE=''
        for i in xrange(len(Delete[0])):
            DELETE += "DELETE FROM rs_kp_dane_osobowe_zobowiazania_ratalne "
            DELETE +="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikId+"'"
            for j in xrange(len(Delete[0][i])):
                pole = Delete[1][j]
                wart = Delete[0][i][j]
                if pole in ['zobowiazanie_id', 'data_od']:
                    if wart <> '':
                        if stat == 'OK':
                            DELETE += " AND " + str(pole) + "='" + str(wart) + "'"
            DELETE += ";"

        if stat == "OK" and DELETE <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = "Bd przy usuwaniu danych: "+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprUpd:
            stat='UPR BR UPD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'zobowiazanie_id':
                        if wart.strip() == '':
                            stat = 'ZOB ID BR'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        elif len(wart.strip()) > 2:
                            stat = 'ZOB ID DL'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        else:
                            spr = "SELECT 1 FROM rs_kp_zobowiazania_ratalne "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND kod = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                wyn2.append((WierszeNr[i], 0))
                                dane.append('ZOB ID BR SL')

                    elif pole == 'data_od':
                        if wart in ['    -  -  ','',None]:
                            stat = 'OD DNIA BR'
#AB 06-08-18r(zmiany nr. kolumn)
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'OD DNIA BL'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                    elif pole == 'zawieszone_do':
                        if wart not in [ '    -  -  ','',None] and not rsglobal.SprawdzCzyToData(wart):
                            stat = 'DO DNIA BL'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 5))
                            dane.append(stat)
                    elif pole == 'zyrant1_id':
                        if wart == PracownikId:
                            stat = 'ZYRANT1 OS'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 8))
                            dane.append(stat)
                        elif wart <> '':
                            spr = "SELECT 1 FROM rs_kp_dane_osobowe "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                stat = 'ZYRANT1 BL'
#AB 06-08-18r
                                wyn2.append((WierszeNr[i], 8))
                                dane.append(stat)

                        #elif wart == '':
                        #    wyn2.append((WierszeNr[i], 4))
                        #    dane.append('ZYRANT1 BR')


                    elif pole == 'zyrant2_id':
                        if wart == PracownikId:
                            stat= 'ZYRANT2 OS'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 9))
                            dane.append(stat)
                        elif wart <> '':
                            spr = "SELECT 1 FROM rs_kp_dane_osobowe "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                stat = 'ZYRANT2 BL'
#AB 06-08-18r
                                wyn2.append((WierszeNr[i], 9))
                                dane.append(stat)

                        #elif wart == '':
                        #    wyn2.append((WierszeNr[i], 6))
                        #    dane.append('ZYRANT2 BR')

#                     elif pole == 'wartosc_poczatkowa':
#                         if wart == 0:
#                             stat = 'WART BR'
# #AB 06-08-18r
#                             wyn2.append((WierszeNr[i], 2))
#                             dane.append(stat)

                    elif pole == 'beneficjent_id':
                        if wart != '':
                            spr = "SELECT aktywny FROM rs_kontrahenci "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND kontrahent_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                stat = 'BEN BL'
                                wyn2.append((WierszeNr[i], 7))
                                dane.append(stat)

                            if stat == "OK" and len(s) > 0:
                                if not s[0][0]:
                                    stat = 'BEN AKT'
                                    wyn2.append((WierszeNr[i], 7))
                                    dane.append(stat)
                    elif pole == 'skladnik_id':
                        if wart.strip() != '':
                            spr = "SELECT 1 FROM rs_kp_skladniki_placowe "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND skladnik_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                stat = 'SKL BL'
                                wyn2.append((WierszeNr[i], 6))
                                dane.append(stat)
                        # else:
                        #     stat = 'SKL BR'
                        #     wyn2.append((WierszeNr[i], 6))
                        #     dane.append(stat)


        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            sql = ''
            for i in xrange(len(Update[0])):
                UPDATE = "UPDATE rs_kp_dane_osobowe_zobowiazania_ratalne "

                WHERE = "WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + PracownikId + "'"
                for j in xrange(len(Update[2][i])):  # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['zobowiazanie_id', 'data_od']:
                        WHERE += " AND " + pole + "='" + wart + "'"

                SET = 'SET '
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole in ['zobowiazanie_id', 'data_od',]:
                        SET += pole+"='"+str(wart)+"',"
#AB 06-08-18r
                    elif pole in ['zawieszone_do', 'zyrant1_id','zyrant2_id', 'wartosc_poczatkowa', 'rata',
                                  'wartosc_aktualna', 'skladnik_id', 'beneficjent_id']:
                        if wart not in ['    -  -  ','',None]:
                            SET += pole+"='"+str(wart)+"',"
                        else:
                            SET += pole+"=Null,"

                SET = SET.strip(",")+' '
                sql += UPDATE+SET+WHERE+";"

            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    if len(Insert[0]) > 0:
        if not UprIns:
            stat='UPR BR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):
                    pole = Insert[1][j]
                    wart = Insert[0][i][j]

                    if pole == 'zobowiazanie_id':
                        if wart.strip() == '':
                            stat = 'ZOB ID BR'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        elif len(wart.strip()) > 2:
                            stat = 'ZOB ID DL'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        else:
                            spr = "SELECT 1 FROM rs_kp_zobowiazania_ratalne "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND kod = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == 'OK':
                                if len(s) == 0:
                                    wyn2.append((WierszeNr[i], 0))
                                    dane.append('ZOB ID BR SL')

                    elif pole == 'data_od':
                        if wart == '':
                            stat = 'OD DNIA BR'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'OD DNIA BL'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)

                    elif pole == 'zawieszone_do':
                        if wart not in ['','    -  -  ',None] and not rsglobal.SprawdzCzyToData(wart):
                            stat = 'DO DNIA BL'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 5))
                            dane.append(stat)

                    elif pole == 'zyrant1_id':
                        if wart == PracownikId:
                            stat = 'ZYRANT1 OS'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 8))
                            dane.append(stat)
                        elif wart <> '':
                            spr = "SELECT 1 FROM rs_kp_dane_osobowe "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
#AB 06-08-18r
                                wyn2.append((WierszeNr[i], 8))
                                dane.append('ZYRANT1 BL')

                    elif pole == 'zyrant2_id':
                        if wart == PracownikId:
                            stat = 'ZYRANT2 OS'
#AB 06-08-18r
                            wyn2.append((WierszeNr[i], 9))
                            dane.append(stat)
                        elif wart <> '':
                            spr = "SELECT 1 FROM rs_kp_dane_osobowe "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
#AB 06-08-18r
                                wyn2.append((WierszeNr[i], 9))
                                dane.append('ZYRANT2 BL')

#                     elif pole == 'wartosc_poczatkowa':
#                         if wart == 0:
#                             stat = 'WART BR'
# #AB 06-08-18r
#                             wyn2.append((WierszeNr[i], 4))
#                             dane.append(stat)

                    elif pole == 'beneficjent_id':
                        if wart != '':
                            spr = "SELECT aktywny FROM rs_kontrahenci "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND kontrahent_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                stat = 'BEN BL'
                                wyn2.append((WierszeNr[i], 7))
                                dane.append(stat)

                            if stat == "OK" and len(s) > 0:
                                if not s[0][0]:
                                    stat = 'BEN AKT'
                                    wyn2.append((WierszeNr[i], 7))
                                    dane.append(stat)
                    elif pole == 'skladnik_id':
                        if wart.strip() != '':
                            spr = "SELECT 1 FROM rs_kp_skladniki_placowe "
                            spr += "WHERE firma_id='"+str(self.firma_id)+"' AND skladnik_id = '"+wart.strip()+"';"
                            stat, s, wyn1, dump = self.PolSQL.Execute(spr, 3)
                            if stat == "OK" and len(s) == 0:
                                stat = 'SKL BL'
                                wyn2.append((WierszeNr[i], 6))
                                dane.append(stat)
                        else:
                            stat = 'SKL BR'
                            wyn2.append((WierszeNr[i], 6))
                            dane.append(stat)
                        #if wart < Insert[0][i][10]:
                        #    stat = 'WART PZ'
                        #    wyn2.append((WierszeNr[i], 8))
                        #    wyn2.append((WierszeNr[i], 20))
                        #    dane.append(stat)


        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
    if stat == 'OK':
        sqlIns = ''
        for i in xrange(len(Insert[0])):
            INSERT = "INSERT INTO rs_kp_dane_osobowe_zobowiazania_ratalne "
            KOLUMNY = "(firma_id, pracownik_id"
            VALUES = " VALUES ('"+self.firma_id+"','"+PracownikId+"'"
            Dodane.append((Insert[0][i][Insert[1].index('zobowiazanie_id')], Insert[0][i][Insert[1].index('data_od')]))

            for j in xrange(len(Insert[0][i])):
                pole = Insert[1][j]
                wart = Insert[0][i][j]
                if pole in ['zobowiazanie_id', 'data_od', 'wartosc_poczatkowa', 'rata', 'wartosc_aktualna']:
                    KOLUMNY += ","+pole
                    VALUES += ",'"+str(wart)+"'"

                #jeli pole Zawieszone_do moe by puste
#AB 06-08-18r
                elif pole  in ['zawieszone_do','zyrant1_id','zyrant2_id', 'skladnik_id', 'beneficjent_id']:
                    if wart in ['    -  -  ','',None]:
                        KOLUMNY += ","+pole
                        VALUES += ",Null"
                    else:
                        KOLUMNY += ","+pole
                        VALUES += ",'"+str(wart)+"'"

            KOLUMNY += ")"
            VALUES += ");"
            sqlIns += INSERT+KOLUMNY+VALUES
        if sqlIns<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns), 1, CzyDodawacBlad=True)
            if stat<>'OK':
                if 'klucza narusza ograniczenie unikalno' in stat:
                    rsglobal.ZapiszDoLogow('AA' + stat + 'AAA', 5)
                    tmp = stat.split(')=(')[1].strip().strip(') ju istnieje.').split(',')
                    stat = "Istnieje ju zobowizanie/skadka o wskazanym id i dacie od:{}, {}.".format(tmp[2], tmp[3])
                stat="Bd przy dodawaniu danych: " + stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   Sprawdzenia po insert update
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    #Sprawdzenie pokrywania si dat
    sql ="SELECT zobowiazanie_id,data_od,zawieszone_do FROM rs_kp_dane_osobowe_zobowiazania_ratalne "
    sql+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikId+"' AND zawieszone_do IS NOT NULL AND data_od>zawieszone_do;"
    stat,D,wyn1,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(D)>0:
        stat=u"\nData od jest wiksza od daty zawieszenia dla: "
        for i in xrange(len(D)):
            zob=str(D[i][0])
            dataod=str(D[i][1])
            zawieszenie=str(D[i][2])
            stat+=u"\nZobowiazania : "+str(zob)+u", data od : "+str(dataod)+u", zawieszone do: "+str(zawieszenie)+u"\nDane nie zostan zapisane."

    if stat == 'OK':
        #Sprawdzenie czy nie pokrywaj si yrant1 z yrant2
        sql ="SELECT zobowiazanie_id,data_od,zyrant1_id,zyrant1_id FROM rs_kp_dane_osobowe_zobowiazania_ratalne "
        sql+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikId+"' "
        sql+="AND zyrant1_id = zyrant2_id AND zyrant1_id IS NOT NULL;"
        stat,D,wyn1,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(D)>0:
            stat = u'yrantem 1 i 2 nie moe by ta sama osoba! \nBdne wartoci dla:'
            for x,y in enumerate(D):
                stat += ' \n\tId=' +y[0] + ', Od dnia='+y[1]
            dane.append(stat)
    #AB 23.01.19r
    # if stat == 'OK':
    #     #Sprawdzenie czy Kolumna 'Pozostao' nie moe by wiksza ni 'warto'
    #     sql ="SELECT zobowiazanie_id,data_od,wartosc_poczatkowa>=wartosc_aktualna FROM rs_kp_dane_osobowe_zobowiazania_ratalne "
    #     sql+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikId+"' "
    #     stat,D,wyn1,dump=self.PolSQL.Execute(sql,3)
    #     if stat=='OK' and len(D)>0:
    #         kom = True
    #         for i in xrange(len(D)):
    #             id=str(D[i][0])
    #             dataod=str(D[i][1])
    #             spr=D[i][2]
    #             if not spr:
    #                 if kom:
    #                     stat = u" \nKolumna 'Pozostao' nie moe by wiksza ni 'warto' dla:"
    #                     kom = False
    #                 stat+=u" \nid="+str(id)+u" data od="+str(dataod)+u","
    #
    #         if stat<>'OK':
    #             stat=stat[:-1]


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if Funkcja in (1, 5) and stat == 'OK':
#AB 06-08-18r
    SQL  = "SELECT zobowiazanie_id, data_od, wartosc_poczatkowa, rata, wartosc_aktualna, zawieszone_do, "
    SQL += "skladnik_id, beneficjent_id, zyrant1_id, zyrant2_id "
    SQL += "FROM rs_kp_dane_osobowe_zobowiazania_ratalne z "
                                                                                    #AB 23.01.19r
    SQL += "WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id ='"+PracownikId+"' AND ((TRUE "
    if ZobowiazanieIdF <> '':
        SQL += "AND z.zobowiazanie_id ='"+ZobowiazanieIdF+"' "
    if DataOdF <> '    -  -  ':
        SQL += "AND z.data_od >='"+DataOdF+"' "
#AB 06-08-18r
    if Aktywne:
        SQL += " AND wartosc_aktualna > 0 "
    SQL += ')'
    #AB 23.01.19r
    if len(Dodane)> 0:
        SQL += ""
        for wiersz in Dodane:
            SQL += " OR (z.zobowiazanie_id ='{}' AND z.data_od='{}') ".format(wiersz[0], wiersz[1])
    #AB 23.01.19r
    SQL += ") ORDER BY z.zobowiazanie_id;"
    rsglobal.ZapiszDoLogow(SQL, 5)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3)

    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)