# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_zus_skladki.py
# Purpose:     Obsuga grida Skadki ZUS
# Author:      Wojciech Skowron
# Created:     2020/10/06
# RCS-ID:      $Id: fs_kp_dane_osobowe_zus_skladki.py $
# Copyright:   (c) 2020 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2022-02-22 Aleksander Bargie - Dodanie roku i miesiaca listy ()

import rsglobal

"""
052260 - przegldanie
"""

"""Funkcje:
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Pracownik': [5], 'RodzajF': [5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_zus_skladki z numerem ' + str(Funkcja)
        stat += ' bez parametrw: ' + Lista

dane = []
wyn1 = []
wyn2 = []

if stat == 'OK' and Funkcja in (5,):
    Pracownik = klucze['Pracownik']
    RodzajF = klucze['RodzajF']

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprPrzegl = ((self.oddzial_id,'052260') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, ):
    if not UprPrzegl:
        stat = 'BR_UPR_PRZ'
        dane.append(stat)
    else:
        Filtr = ""
        if RodzajF != 'wszystkie':
            Filtr = " AND rodzaj='{}' ".format(RodzajF)

        #SEL = """SELECT rok, miesiac, rodzaj, ubezpieczenie_id, etat
        #         FROM rs_kp_dane_osobowe_zus_skladki WHERE firma_id='{self.firma_id}' AND pracownik_id='{Pracownik}'
        #         {Filtr}  AND (podstawa_zdr<>0 OR podst_emeryt_rent<>0)
        #         ORDER BY rok DESC, miesiac DESC, rodzaj;
        #      """.format(**locals())
        SEL = """SELECT rok, miesiac, rok_lista, miesiac_lista, rodzaj, ubezpieczenie_id, etat
                 FROM rs_kp_dane_osobowe_zus_skladki WHERE firma_id='{self.firma_id}' AND pracownik_id='{Pracownik}'
                 {Filtr}
                 ORDER BY rok DESC, miesiac DESC, rodzaj;
              """.format(**locals())
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
