# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_zus_skladki_dane.py
# Purpose:     Obsuga okna danych skadek ZUS dla pracownika
# Author:      Wojciech Skowron
# Created:     2019/10/10
# RCS-ID:      $Id: fs_kp_dane_osobowe_zus_skladki_dane.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
#  2020-11-09 Aleksander Bargie - (12183) [KP] zmiany w oknie dane osobowe skadki zus
#  2022-04-12 Aleksander Bargie - (12966) Kartoteka osobowa - skadki zus - bd przy edycji


import rsglobal

"""
052260 - przegldanie
"""

"""Funkcje:
5. Pobranie danych"""

stat = 'BR_UPR_PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrz = ((self.oddzial_id, '052260') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

dane = []

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    #AB 12.04.22r.
    SlPar = {'Pracownik': [5], 'Rok': [5], 'Miesiac': [5], 'RokL': [5], 'MiesiacL': [5], 'Rodzaj': [5], 'UbezpId': [5],
             'Etat': [5]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga: wywoanie funkcji fs_kp_dane_osobowe_zus_skladki_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK' and Funkcja in (5,):
    Pracownik = klucze['Pracownik']
    Rok       = klucze['Rok']
    Miesiac   = klucze['Miesiac']
    #AB 12.04.22r.
    RokL      = klucze['RokL']
    MiesiacL  = klucze['MiesiacL']
    Rodzaj    = klucze['Rodzaj']
    UbezpId   = klucze['UbezpId']
    Etat      = klucze['Etat']

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH(5)   ----------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, ):  #AB 12.04.22r.
    SEL = """SELECT ubezpieczenie_id, czy_przekroczenie, etat,
                    podst_emeryt_rent, podst_chor, podst_wyp, podstawa_zdr, podstawa_fp, podstawa_fgsp,
                    skl_emeryt_ubez, skl_rent_ubez, skl_chor_ubez, skl_wyp_ubez, skl_zdr_ubez,
                    skl_emeryt_plat, skl_rent_plat, skl_chor_plat, skl_wyp_plat, skl_zdr_plat,
                    skl_emeryt_budzet, skl_rent_budzet, skl_wyp_budzet, skl_zdr_budzet, kwota_obnizenia_podstawy, 
                    ppk_wplaty 
             FROM rs_kp_dane_osobowe_zus_skladki
             WHERE firma_id='{self.firma_id}' AND pracownik_id='{Pracownik}' 
                   AND rok='{Rok}' AND miesiac='{Miesiac}' AND rok_lista='{RokL}' AND miesiac_lista='{MiesiacL}' 
                   AND rodzaj='{Rodzaj}' AND ubezpieczenie_id='{UbezpId}' AND etat={Etat};
          """.format(**locals())

    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SEL)
    if stat != 'OK':
        stat = 'Bd pobierania danych: ' + stat
