
# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_kp_deklaracje_ppk.py
# Purpose:     Tworzenie deklaracji PPK
# Author:      Aleksander Bargie, Jan Raburski
# Created:     2020-09-02
# RCS-ID:      $Id: fs_kp_deklaracje_ppk.py$
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2023-12-14 Wojciech Skowron - (13636) Jeli brak kraju w adr kor to zwraca pusty string zamiast 'PL'

"""057300 - uprawnienia do okna"""
stat = 'OK'
dane = []

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun   = klucze['Funkcja']
    SlPar = {'Standard': [1,], 'MiesDekl': [1,], 'Zgloszenie': [1,], 'Rezygnacja': [1,], 'Folder': [1,], 'DataOd': [1,],
             'DataDo': [1,], 'CzyPonowne': [1,]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_deklaracje_ppk z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in (1, ):
        Standard   = klucze['Standard']
        MiesDekl   = klucze['MiesDekl']
        Zgloszenie = klucze['Zgloszenie']
        Rezygnacja = klucze['Rezygnacja']
        Folder     = klucze['Folder']
        DataOd     = klucze['DataOd']
        DataDo     = klucze['DataDo']
        CzyPonowne = klucze['CzyPonowne']

if stat == 'OK':
    Upr = ((self.oddzial_id, '057300') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    if not Upr:
        stat = 'Brak uprawnie do tworzenia deklaracji PPK'

# ---------------------------------------------------------------------------------------------------------------------
#                                          1, - Tworzenie PPK
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, ):
    # dane zawieraja zawsze wszystkie deklaracje: dane[0] - MiesDekl, dane[1] - Zgloszenie, dane[2] - Rezygnacja
    dekl = zglosz = rezygn = []
    if MiesDekl:
        Rok = DataOd[0:4]
        Mc = DataOd[5:7]
        warunek = " WHERE ppk.firma_id='" + self.firma_id + "'"
        warunek += " AND ppk.rok= '" + Rok + "' AND ppk.mc= '" + Mc + "' AND ppk.podstawa > 0"
        if not CzyPonowne:
            warunek += " AND data_wyslania IS NULL"
        sql = "SELECT COALESCE(dos.pesel,''), COALESCE(dos.dokument_id,'O'), TRIM(COALESCE(dos.dokument_nr,'')),"  # 0-2
        sql += " CAST (ppk.pracownik_id AS INTEGER), COALESCE(dos.nazwisko,''), COALESCE(dos.imie,''), "  # 3-5
        sql += " SUM(ppk.skladka_firma_podst), SUM(ppk.skladka_prac_podst), SUM(ppk.skladka_firma_dodat), SUM(ppk.skladka_prac_dodat),"  # 6-9
        sql += " ppk.mc, ppk.rok, ppk.skladka_obnizona "  # 10-12
        sql += " FROM rs_kp_dane_osobowe_ppk_skladki ppk "
        sql += " INNER JOIN rs_kp_dane_osobowe dos USING(firma_id, pracownik_id)"
        sql += warunek
        sql += " GROUP BY COALESCE(dos.pesel,''), COALESCE(dos.dokument_id,'O'), TRIM(COALESCE(dos.dokument_nr,'')),"  # 0-2
        sql += " ppk.pracownik_id, COALESCE(dos.nazwisko,''), COALESCE(dos.imie,''), ppk.mc, ppk.rok, ppk.skladka_obnizona "
        stat, dekl, dumo, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych miesicznej deklaracji: "+stat
            dane.append(stat)
        elif len(dekl) > 0:
            # sa dane robimy update na zgloszone
            upd = "UPDATE rs_kp_dane_osobowe_ppk_skladki ppk SET data_wyslania = CURRENT_DATE"
            upd += warunek
            stat, ile, dumo, dump = self.PolSQL.Execute(upd, 1)
            if stat != 'OK':
                stat = "Bd przy zapisie daty wysania skadki: "+stat
                dane.append(stat)

    if stat == 'OK':
        if Zgloszenie:
            warunek = " WHERE ppk.firma_id='" + self.firma_id + "'"
            warunek += " AND ppk.data_przystapienia BETWEEN '" + str(DataOd) + "' AND '" + str(DataDo) + "'"
            if not CzyPonowne:
                warunek += " AND data_przystapienia_wyslanie IS NULL;"
            #WS 2023-12-14 - COALESCE(adk.kraj_id,'PL') -> COALESCE(adk.kraj_id,'')
            sql = "SELECT COALESCE(dos.imie,''), COALESCE(dos.imie_drugie,''), COALESCE(dos.nazwisko,''), dos.obywatelstwo_kraj, "  # 0-3
            sql += " COALESCE(dos.pesel,''), COALESCE(dos.plec,'N'), COALESCE(dos.dokument_id,'O'), TRIM(COALESCE(dos.dokument_nr,'')), "  # 4-7
            sql += " COALESCE(dos.dokument_data_waznosci,'1900-01-01'), COALESCE(dos.data_urodzenia,'1900-01-01'),"  # 8-9
            sql += " COALESCE((SELECT TRIM(email) FROM rs_kp_adresy WHERE firma_id=ppk.firma_id AND pracownik_id=ppk.pracownik_id AND email IS NOT NULL LIMIT 1),''),"  # 10
            sql += " COALESCE((SELECT TRIM(telefon) FROM rs_kp_adresy WHERE firma_id=ppk.firma_id AND pracownik_id=ppk.pracownik_id AND telefon IS NOT NULL LIMIT 1),''),"  # 11
            sql += " CAST(ppk.pracownik_id AS INTEGER), "  # 12
            sql += " (SELECT od_kiedy FROM rs_kp_umowy_o_prace um INNER JOIN rs_kp_zatrudnienie za "
            sql += "   ON um.firma_id=za.firma_id AND um.pracownik_id=za.pracownik_id AND zatrudnienie_id=numer_id"
            sql += "   WHERE za.firma_id=ppk.firma_id AND za.pracownik_id=ppk.pracownik_id AND za.stan_pracownika_id='A'"
            sql += "   AND czy_absencje ORDER BY od_kiedy LIMIT 1), '' ,"  # 13-14
            sql += " COALESCE(adz.ulica,''), COALESCE(adz.nr_domu,''), COALESCE(adz.nr_mieszkania,''),"  # 15-17
            sql += " COALESCE(adz.kod_pocztowy,''), COALESCE(adz.miejscowosc,''), COALESCE(adz.kraj_id,'PL'),"  # 18-20
            sql += " COALESCE(adk.ulica,''), COALESCE(adk.nr_domu,''), COALESCE(adk.nr_mieszkania,''),"  # 21-23
            sql += " COALESCE(adk.kod_pocztowy,''), COALESCE(adk.miejscowosc,''), COALESCE(adk.kraj_id,'')"  # 24-26
            sql += " FROM rs_kp_dane_osobowe_ppk ppk "
            sql += " INNER JOIN rs_kp_dane_osobowe dos USING(firma_id, pracownik_id)"
            sql += " LEFT OUTER JOIN rs_kp_adresy adz ON (adz.firma_id=ppk.firma_id and adz.pracownik_id=ppk.pracownik_id and adz.adres_id='1')"
            sql += " LEFT OUTER JOIN rs_kp_adresy adk ON (adk.firma_id=ppk.firma_id and adk.pracownik_id=ppk.pracownik_id and adk.adres_id='3')"
            sql += warunek
            stat, zglosz, dumo, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = "Bd przy pobieraniu danych zgoszenia: " + stat
                dane.append(stat)
            elif len(zglosz) > 0:
                # sa dane robimy update na zgloszone
                upd = "UPDATE rs_kp_dane_osobowe_ppk ppk SET data_przystapienia_wyslanie = CURRENT_DATE"
                upd += warunek
                stat, ile, dumo, dump = self.PolSQL.Execute(upd, 1)
                if stat != 'OK':
                    stat = "Bd przy zapisie daty zgoszenia: "+stat
                    dane.append(stat)

    if stat == 'OK':
        if Rezygnacja:
            warunek = " WHERE ppk.firma_id='" + self.firma_id + "'"
            warunek += " AND ppk.data_konca_zatrudnienia BETWEEN '" + str(DataOd) + "' AND '" + str(DataDo) + "'"
            if not CzyPonowne:
                warunek += " AND data_rezygnacji_wyslanie IS NULL;"
            sql = " SELECT COALESCE(dos.pesel,''),  COALESCE(dos.dokument_id,'O'), TRIM(COALESCE(dos.dokument_nr,'')), "  # 0-2
            sql += " CAST(ppk.pracownik_id AS INTEGER), COALESCE(dos.nazwisko,''),  COALESCE(dos.imie,''), ppk.data_konca_zatrudnienia "  # 3-6
            sql += " FROM rs_kp_dane_osobowe_ppk ppk "
            sql += " INNER JOIN rs_kp_dane_osobowe dos USING(firma_id, pracownik_id)"
            sql += warunek
            stat, rezygn, dumo, dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = "Bd przy pobieraniu danych koca zatrudnienia: "+stat
                dane.append(stat)

    if stat == 'OK':
        dane = [dekl, zglosz, rezygn]