# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_deklaracje_zus_zcna.py
# Purpose:     pobranie danych do ZUS ZCNA
# Author:      Konrad Opieka
# Created:     2017/02/20
# RCS-ID:      $Id: fs_kp_deklaracje_zus_zcna.py $
# Copyright:   (c) 2017 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-11-19 Aleksnader Bargie - 10852 - Deklaracje w Kartotece osobowej
# 2018-12-19 Aleksnader Bargie - 11331 - [KP] Obsuga historii rejestracji w zus
# 2020-11-04 Wojciech Skowron   - 10852 - Deklaracje w Kartotece osobowej (poprawki)
# 2021-02-03 Wojciech Skowron   - 12370 - Usunicie spacji z nr dokumentu tosamoci
# 2021-03-08 Wojciech Skowron   - 12379 - Pobranie danych osobowych przeniesione do _pom
# 2021-06-10 Wojciech Skowron   - 12353 - W pierwszej kolejnoci brany adres o id = 1, potem = 2
# 2021-07-12 Wojciech Skowron   - 12570 - Tworzenie ZCNA dla wszystkich czonkw rodziny z poziomu kartoteki osobowej

import rsglobal

class ZUS:
    def __init__(self, rodzic):
        from funkcje.fs_kp_deklaracje_zus_pom import ZUSXML
        self.zus_zcna = ZUSXML(rodzic)

    def ZapiszZcna(self, iddoc, pracownik_id, D4, data_wypelnienia):
        stat = 'OK'

        self.zus_zcna.ZrobNaglowek()

        self.zus_zcna.WstawTekst('<ZUSZCNA id_dokumentu="'+iddoc+'">')

        stat = self.zus_zcna.WstawDanePlatnika()
        if stat != 'OK':
            return stat, ''

        #WS 2021-03-08
        stat = self.zus_zcna.WstawDaneOsobowe(pracownik_id)
        if stat != 'OK':
            return stat, ''
        # self.zus_zcna.WstawNowy("III")
        # self.zus_zcna.WstawNowyZWartoscia("p1", D3[0][0])
        # if D3[0][1] != 0:
        #     self.zus_zcna.WstawNowyZWartoscia("p3", D3[0][1])
        # if D3[0][2] != '':
        #     self.zus_zcna.WstawNowyZWartoscia("p4", D3[0][2].replace(' ', ''))
        # self.zus_zcna.WstawNowyZWartoscia("p5", D3[0][3])
        # self.zus_zcna.WstawNowyZWartoscia("p6", D3[0][4])
        # self.zus_zcna.WstawNowyZWartoscia("p7", D3[0][5])
        # self.zus_zcna.Zamknij("III")

        for i in xrange(len(D4)):
            self.zus_zcna.WstawNowy("IV id_bloku='"+str(i+1)+"'")
            self.zus_zcna.WstawNowy("A")
            self.zus_zcna.WstawNowyZWartoscia("p1", D4[i][0])
            self.zus_zcna.WstawNowyZWartoscia("p2", D4[i][1])
            self.zus_zcna.WstawNowyZWartoscia("p3", D4[i][2])
            if D4[i][3] != 0:
                self.zus_zcna.WstawNowyZWartoscia("p5", D4[i][3])
            if D4[i][4] != '':
                self.zus_zcna.WstawNowyZWartoscia("p6", D4[i][4].replace(' ', ''))
            self.zus_zcna.WstawNowyZWartoscia("p7", D4[i][5])
            self.zus_zcna.WstawNowyZWartoscia("p8", D4[i][6])
            self.zus_zcna.WstawNowyZWartoscia("p9", D4[i][7])
            self.zus_zcna.WstawNowyZWartoscia("p10", D4[i][8].strip(' '))
            if D4[i][9]:
                self.zus_zcna.WstawNowyZWartoscia("p11", "true")
            else:
                self.zus_zcna.WstawNowyZWartoscia("p11", "false")
            self.zus_zcna.WstawNowyZWartoscia("p12", D4[i][10])  # kod niepelnosprawnosci 0-zdrowy
            self.zus_zcna.Zamknij("A")

            self.zus_zcna.WstawNowy("B")
            self.zus_zcna.WstawNowyZWartoscia("p1", D4[i][11].replace('-', ''))
            self.zus_zcna.WstawNowyZWartoscia("p2", D4[i][12])
            self.zus_zcna.WstawNowyZWartoscia("p3", D4[i][13])
            if D4[i][14] != '':
                self.zus_zcna.WstawNowyZWartoscia("p4", D4[i][14])
            self.zus_zcna.WstawNowyZWartoscia("p5", D4[i][15])
            if D4[i][16] != '':
                self.zus_zcna.WstawNowyZWartoscia("p6", D4[i][16])
            if D4[i][17] != '':
                self.zus_zcna.WstawNowyZWartoscia("p7", D4[i][17])
            self.zus_zcna.Zamknij("B")
            self.zus_zcna.Zamknij("IV")


        self.zus_zcna.WstawNowy("VI")
        self.zus_zcna.WstawNowyZWartoscia("p1", data_wypelnienia)
        self.zus_zcna.Zamknij("VI")

        self.zus_zcna.Zamknij("ZUSZCNA")
        self.zus_zcna.ZakonczTworzenie()

        tresc = self.zus_zcna.PodajTresc()

        return stat, tresc


#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------

stat='OK'
dane=[]
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Pracownik': [1, 2], 'ZgloszenieOd': [2, 3], 'ZgloszenieDo': [2, 3], 'WyrejestrowanieOd': [2, 3], 'WyrejestrowanieDo': [2, 3],
           'RodzinaId': [1, ], 'Rodzaj': [1, ]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista!='':
        stat='Uwaga : wywoanie funkcji fs_kp_deklaracje_zus_zcna '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        RodzinaId = rsglobal.Dekoduj(klucze['RodzinaId'])
        Rodzaj = rsglobal.Dekoduj(klucze['Rodzaj'])
        DataWypelnienia = rsglobal.Dekoduj(klucze['DataWypelnienia'])

    if Funkcja in [2, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])

    if Funkcja in [2, 3]:
        ZgloszenieOd = rsglobal.Dekoduj(klucze['ZgloszenieOd'])
        ZgloszenieDo = rsglobal.Dekoduj(klucze['ZgloszenieDo'])
        WyrejestrowanieOd = rsglobal.Dekoduj(klucze['WyrejestrowanieOd'])
        WyrejestrowanieDo = rsglobal.Dekoduj(klucze['WyrejestrowanieDo'])

#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==1 and stat=='OK':
    #WS 2021-03-08 - pobieranie danych osobowych przeniesione do _pom
    #WS 2020-11-04
    # SQL ="SELECT pesel, CASE WHEN dokument_id='D' THEN 1 WHEN dokument_id='P' THEN 2 ELSE 0 END, "
    # SQL+="CASE WHEN dokument_id in ('D','P') THEN dokument_nr ELSE '' END, "
    # # SQL ="SELECT pesel, CASE WHEN dowod_numer IS NOT Null THEN 1 WHEN paszport_numer IS NOT NULL THEN 2  ELSE 0 END, "
    # # SQL+="CASE WHEN dowod_numer IS NOT Null THEN dowod_numer WHEN paszport_numer IS NOT NULL THEN paszport_numer ELSE '' END, "
    # SQL+="nazwisko, imie, data_urodzenia "
    # SQL+="FROM rs_kp_dane_osobowe "
    # SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    # stat, D3, dump, dump = self.PolSQL.Execute(SQL, 3)
    # if stat!='OK':
    #     stat = 'Bd pobierania informacji z danych osobowych'

    if stat=='OK':
        SQL = ''
        for i in xrange(len(RodzinaId)):
            SQL+="(SELECT "+str(Rodzaj[i])+", CASE WHEN "+str(Rodzaj[i])+"=1 THEN ubezpieczony_od WHEN "+str(Rodzaj[i])+"=2 THEN ubezpieczony_do END, "
            SQL+="pesel, CASE WHEN dowod_numer != '' THEN 1 WHEN paszport_numer != '' THEN 2  ELSE 0 END, "
            SQL+="CASE WHEN dowod_numer != '' THEN dowod_numer WHEN paszport_numer != '' THEN paszport_numer ELSE '' END, "
            SQL+="nazwisko, imie, data_urodzenia, pokrewienstwo_id, czy_na_utrzymaniu, COALESCE(niepelnosprawnosc_id,'0'), "
            SQL+="CASE WHEN wspolne_zameldowanie THEN COALESCE(a.kod_pocztowy, 'BRAK') ELSE COALESCE(r.kod_pocztowy, 'BRAK') END, "
            SQL+="CASE WHEN wspolne_zameldowanie THEN COALESCE(a.miejscowosc, 'BRAK') ELSE COALESCE(r.miejscowosc, 'BRAK') END, "
            SQL+="CASE WHEN wspolne_zameldowanie THEN COALESCE(g2.opis::TEXT, 'BRAK') ELSE COALESCE(g.opis::TEXT, 'BRAK') END, "
            SQL+="CASE WHEN wspolne_zameldowanie THEN COALESCE(a.ulica, '') ELSE COALESCE(r.ulica, '') END, "
            SQL+="CASE WHEN wspolne_zameldowanie THEN COALESCE(a.nr_domu, 'BRAK') ELSE COALESCE(r.numer_domu, 'BRAK') END, "
            SQL+="CASE WHEN wspolne_zameldowanie THEN COALESCE(a.nr_mieszkania, '') ELSE COALESCE(r.numer_mieszkania, '') END, "
            SQL+="COALESCE(r.telefon, ''), a.adres_id, wspolne_zameldowanie FROM rs_kp_rodzina r "
            SQL+="LEFT OUTER JOIN rs_gminy g ON (r.firma_id=g.firma_id AND r.gmina_id=g.kod) "
            SQL+="LEFT OUTER JOIN rs_kp_adresy a ON (r.firma_id=a.firma_id AND r.pracownik_id=a.pracownik_id) "
            SQL+="LEFT OUTER JOIN rs_gminy g2 ON (a.firma_id=g2.firma_id AND a.gmina_id=g2.kod) "
            SQL+="WHERE r.firma_id='"+self.firma_id+"' AND r.pracownik_id='"+Pracownik+"' AND rodzina_id ="+str(RodzinaId[i])+" "
            #WS 2021-06-10
            SQL+="AND a.adres_id in ('1', '2') ORDER BY a.adres_id LIMIT 1) "
            # SQL+="AND a.adres_id='2') "  #WS 2021-04-13
            # SQL+=") "
            SQL+="UNION "
        SQL = SQL.strip('UNION ')
        # SQL += ") as adr ORDER BY adres_id='2' DESC, wspolne_zameldowanie=False DESC; "  #WS 2021-04-13
        rsglobal.ZapiszDoLogow('aaaaaaaa '+str(SQL), 1)
        stat, D4, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat =='OK' and len(D4) == 0:
             stat = 'Brak adresw.'

    if stat=='OK':
        zcna = ZUS(self)
        # dzis = rsglobal.PodajDzis()
        iddoc= Pracownik+str(int(RodzinaId[0]))
        if stat == 'OK':
            stat, wynik = zcna.ZapiszZcna(iddoc, Pracownik, D4, DataWypelnienia)
        if stat == 'OK':
            dane.append(wynik)
        else:
            dane.append(stat)

    if stat=='OK':
        for i in xrange(len(RodzinaId)):

            if stat == 'OK':
                SEL = """SELECT ubezpieczony_od, ubezpieczony_do 
                         FROM rs_kp_rodzina_zus 
                         WHERE firma_id = '{}' AND pracownik_id = '{}' AND rodzina_id = {}
                         ORDER BY ubezpieczony_od DESC LIMIT 1;""".format(self.firma_id, Pracownik, RodzinaId[i])
                rsglobal.ZapiszDoLogow('jjjjjj '+str(SEL), 5)
                stat, zglosz, dump, dump = self.PolSQL.Execute(SEL, 3)
                rsglobal.ZapiszDoLogow('zglosz '+str(zglosz), 5)
                rsglobal.ZapiszDoLogow('D4D4D4 '+str(D4[i][1]), 5)
                if stat != 'OK':
                    stat = 'Bd sprawdzania daty ostatniego zgoszenia/wyrejestrowania'
                    rsglobal.ZapiszDoLogow('a1 '+str(zglosz[0][1]), 5)
                elif len(zglosz) == 1 and Rodzaj[i] == 1 and rsglobal.SprawdzCzyToData(zglosz[0][1]) and zglosz[0][1] >= D4[i][1]:
                    stat = 'Data zgoszenia musi by pniejsza ni data zakoczenia poprzedniego ubezpieczenia.'
                    rsglobal.ZapiszDoLogow('a2 '+str(zglosz[0][1]), 5)
                elif len(zglosz) == 1 and Rodzaj[i] == 2 and rsglobal.SprawdzCzyToData(zglosz[0][0]) and zglosz[0][0] >= D4[i][1]:
                    stat = 'Data wyrejestrowania musi by pniejsza ni data rozpoczcia ubezpieczenia.'
                    rsglobal.ZapiszDoLogow('a3 '+str(zglosz[0][0]), 5)
                else:
                    if Rodzaj[i] == 1 and (len(zglosz) == 0 or zglosz[0][1] not in (None, '', '    -  -  ', 'None')):
                        SQL = """INSERT INTO rs_kp_rodzina_zus
                                 (firma_id, pracownik_id, rodzina_id, ubezpieczony_od)
                                 VALUES('{f}', '{p}', {r}, '{u}');
                                 UPDATE rs_kp_rodzina
                                 SET zgloszenie_zcna=now()::date, wyrejestrowanie_zcna=NULL
                                 WHERE firma_id='{f}' AND pracownik_id='{p}' AND rodzina_id={r};""".format(f=self.firma_id, p=Pracownik, r=RodzinaId[i], u=D4[i][1])
                    elif Rodzaj[i] == 2 and len(zglosz) == 0:
                        stat = 'Nie mona wyrejestrowa czonka rodziny, ktry nie zosta jeszcze zgoszony'
                        #                         SQL = """INSERT INTO rs_kp_rodzina_zus
                        #     (firma_id, pracownik_id, rodzina_id, ubezpieczony_do)
                        #     VALUES('{f}', '{p}', {r}, '{u}');
                        # UPDATE rs_kp_rodzina
                        # SET zgloszenie_zcna=NULL, wyrejestrowanie_zcna=now()::date
                        # WHERE firma_id='{f}' AND pracownik_id='{p}' AND rodzina_id={r};""".format(f=self.firma_id, p=Pracownik, r=RodzinaId[i], u=D4[i][1])
                    elif Rodzaj[i] == 1:
                        SQL = """UPDATE rs_kp_rodzina_zus SET ubezpieczony_od='{u}' WHERE firma_id='{f}' AND pracownik_id='{p}'
                                                              AND rodzina_id={r} AND ubezpieczony_od='{u2}';
                                 UPDATE rs_kp_rodzina
                                 SET zgloszenie_zcna=now()::date
                                 WHERE firma_id='{f}' AND pracownik_id='{p}' AND rodzina_id={r};""".format(u=D4[i][1], f=self.firma_id, p=Pracownik, r=RodzinaId[i], u2=zglosz[0][0])
                    elif Rodzaj[i] == 2:
                        SQL = """UPDATE rs_kp_rodzina_zus SET ubezpieczony_do='{u}' WHERE firma_id='{f}' AND pracownik_id='{p}'
                                                                                          AND rodzina_id={r} AND ubezpieczony_od='{u2}';
                                 UPDATE rs_kp_rodzina
                                 SET wyrejestrowanie_zcna=now()::date
                                 WHERE firma_id='{f}' AND pracownik_id='{p}' AND rodzina_id={r};""".format(u=D4[i][1], f=self.firma_id, p=Pracownik, r=RodzinaId[i], u2=zglosz[0][0])
                    rsglobal.ZapiszDoLogow('jjj '+str(SQL), 5)
                    if stat == 'OK':
                        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
                        if stat != 'OK':
                            stat = 'Bd uzupenienia daty zgaszania/wyrejestrowania: ' + stat

#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==2 and stat=='OK':
    SQL = ''
    #WS 2021-07-12
    if ZgloszenieOd != '    -  -  ':
        SQL ="(SELECT pracownik_id, rodzina_id, 1 FROM rs_kp_rodzina r "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND ubezpieczony_od>='"+ZgloszenieOd+"' AND ubezpieczony_od<='"+ZgloszenieDo+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND ubezpieczony AND (wyrejestrowanie_zcna "
        SQL+="IS NULL OR NOT EXISTS (SELECT 1 FROM rs_kp_rodzina_zus WHERE firma_id='"+self.firma_id+"' AND "
        SQL+="ubezpieczony_od>='"+ZgloszenieOd+"' AND ubezpieczony_od<='"+ZgloszenieDo+"' AND (ubezpieczony_od is Null or"
        SQL+=" ubezpieczony_do IS NULL)))) "
    if ZgloszenieOd != '    -  -  ' and WyrejestrowanieOd != '    -  -  ':
        SQL+="UNION "
    if WyrejestrowanieOd != '    -  -  ':
        SQL+="(SELECT pracownik_id, rodzina_id, 2 FROM rs_kp_rodzina "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND ubezpieczony_do>='"+WyrejestrowanieOd+"' AND ubezpieczony_do<='"+WyrejestrowanieDo+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND ubezpieczony AND zgloszenie_zcna is not Null) "
    if ZgloszenieOd != '    -  -  ' or WyrejestrowanieOd != '    -  -  ':
        SQL+="ORDER BY pracownik_id"
    rsglobal.ZapiszDoLogow('aaaaaaaaaaaaaa '+str(SQL), 5)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat!='OK':
        stat = 'Bd pobierania informacji o rodzinie pracownika'

    # if ZgloszenieOd != '    -  -  ':
    #     SQL ="(SELECT pracownik_id, rodzina_id, 1 FROM rs_kp_rodzina r "
    #     SQL+="WHERE firma_id='"+self.firma_id+"' AND ubezpieczony_od>='"+ZgloszenieOd+"' AND ubezpieczony_od<='"+ZgloszenieDo+"' "
    #     SQL+="AND pracownik_id='"+Pracownik+"' AND ubezpieczony AND (zgloszenie_zcna is Null and wyrejestrowanie_zcna "
    #     SQL+="IS NULL OR NOT EXISTS (SELECT 1 FROM rs_kp_rodzina_zus WHERE firma_id='"+self.firma_id+"' AND "
    #     SQL+="ubezpieczony_od>='"+ZgloszenieOd+"' AND ubezpieczony_od<='"+ZgloszenieDo+"' AND (ubezpieczony_od is Null or"
    #     SQL+=" ubezpieczony_do IS NULL)))) "
    # if ZgloszenieOd != '    -  -  ' and WyrejestrowanieOd != '    -  -  ':
    #     SQL+="UNION "
    # if WyrejestrowanieOd != '    -  -  ':
    #     SQL+="(SELECT pracownik_id, rodzina_id, 2 FROM rs_kp_rodzina "
    #     SQL+="WHERE firma_id='"+self.firma_id+"' AND ubezpieczony_do>='"+WyrejestrowanieOd+"' AND ubezpieczony_do<='"+WyrejestrowanieDo+"' "
    #     SQL+="AND pracownik_id='"+Pracownik+"' AND ubezpieczony AND zgloszenie_zcna is not Null AND wyrejestrowanie_zcna is Null) "
    # if ZgloszenieOd != '    -  -  ' or WyrejestrowanieOd != '    -  -  ':
    #     SQL+="ORDER BY pracownik_id"
    # rsglobal.ZapiszDoLogow('aaaaaaaaaaaaaa '+str(SQL), 5)
    # stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    # if stat!='OK':
    #     stat = 'Bd pobierania informacji o rodzinie pracownika'
    #
    # SQL = ''
    # if ZgloszenieOd != '    -  -  ':
    #     SQL ="(SELECT pracownik_id, rodzina_id, 1, imie, nazwisko, zgloszenie_zcna FROM rs_kp_rodzina "
    #     SQL+="WHERE firma_id='"+self.firma_id+"' AND ubezpieczony_od>='"+ZgloszenieOd+"' AND ubezpieczony_od<='"+ZgloszenieDo+"' "
    #     SQL+="AND pracownik_id='"+Pracownik+"' AND ubezpieczony AND zgloszenie_zcna is not Null and wyrejestrowanie_zcna IS NULL) "
    # if ZgloszenieOd != '    -  -  ' and WyrejestrowanieOd != '    -  -  ':
    #     SQL+="UNION "
    # if WyrejestrowanieOd != '    -  -  ':
    #     SQL+="(SELECT pracownik_id, rodzina_id, 2, imie, nazwisko, wyrejestrowanie_zcna FROM rs_kp_rodzina "
    #     SQL+="WHERE firma_id='"+self.firma_id+"' AND ubezpieczony_do>='"+WyrejestrowanieOd+"' AND ubezpieczony_do<='"+WyrejestrowanieDo+"' "
    #     SQL+="AND pracownik_id='"+Pracownik+"' AND ubezpieczony AND zgloszenie_zcna is not Null AND wyrejestrowanie_zcna is not Null) "
    # if ZgloszenieOd != '    -  -  ' or WyrejestrowanieOd != '    -  -  ':
    #     SQL+="ORDER BY pracownik_id"
    # rsglobal.ZapiszDoLogow('bbbbbbbbbbbbbb '+str(SQL), 5)
    # stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
    # if stat!='OK':
    #     stat = 'Bd pobierania informacji o zatrudnieniach pracownika dla posiadajcych wypenione ZCNA'
    # if stat=='OK':
    #     wyn2=d

#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==3 and stat=='OK':
    SQL = ''
    if ZgloszenieOd != '    -  -  ':
        SQL = "(SELECT pracownik_id, rodzina_id, 1 FROM rs_kp_rodzina "
        SQL += "WHERE firma_id='" + self.firma_id + "' AND ubezpieczony_od>='" + ZgloszenieOd + "' AND ubezpieczony_od<='" + ZgloszenieDo + "' "
        SQL += "AND ubezpieczony AND zgloszenie_zcna is Null) "
    if ZgloszenieOd != '    -  -  ' and WyrejestrowanieOd != '    -  -  ':
        SQL += "UNION "
    if WyrejestrowanieOd != '    -  -  ':
        SQL += "(SELECT pracownik_id, rodzina_id, 2 FROM rs_kp_rodzina "
        SQL += "WHERE firma_id='" + self.firma_id + "' AND ubezpieczony_do>='" + WyrejestrowanieOd + "' AND ubezpieczony_do<='" + WyrejestrowanieDo + "' "
        SQL += "AND ubezpieczony AND zgloszenie_zcna is not Null AND wyrejestrowanie_zcna is Null) "
    if ZgloszenieOd != '    -  -  ' or WyrejestrowanieOd != '    -  -  ':
        SQL += "ORDER BY pracownik_id"
    rsglobal.ZapiszDoLogow('bbbbjjjjbbbb '+str(SQL), 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat!='OK':
        stat = 'Bd pobierania informacji o pracownikach i numerach zatrudnienia'
