# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_deklaracje_zus_ziua.py
# Purpose:     tworzenie deklaracji ZUS ZIUA
# Author:      Wojciech Skowron
# Created:     2021/01/08
# RCS-ID:      $Id: fs_kp_deklaracje_zus_ziua.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2021-02-03 Wojciech Skowron   - 12370 - Usunicie spacji z nr dokumentu tosamoci
# 2021-03-08 Wojciech Skowron   - 12379 - Pobranie danych osobowych przeniesione do _pom

from funkcje.fs_kp_deklaracje_zus_pom import ZUSXML


class ZUS(ZUSXML):
    def __init__(self, rodzic):
        from funkcje.fs_kp_deklaracje_zus_pom import ZUSXML
        ZUSXML.__init__(self, rodzic)

    def ZapiszZiua(self, iddoc, data_wypelnienia, zmiana, korekta):
        self.ZrobNaglowek()

        self.WstawTekst('<ZUSZIUA id_dokumentu="'+iddoc+'">')
        self.WstawNowy("I")
        if zmiana:
            self.WstawNowyZWartoscia("p1", "1")
        elif korekta:
            self.WstawNowyZWartoscia("p1", "2")
        self.Zamknij("I")

        stat = self.WstawDanePlatnika()
        if stat != 'OK':
            return stat, ''

        # zalepka - dane aktualne wpisane jako poprzednie
        #WS 2021-03-08
        stat = self.WstawDaneOsobowe(iddoc)
        if stat != 'OK':
            return stat, ''

        #WS 2021-03-08
        stat = self.WstawDaneOsobowe(iddoc, wezel='IV')
        if stat != 'OK':
            return stat, ''

        self.WstawNowy("V")
        self.WstawNowyZWartoscia("p1", data_wypelnienia)
        self.Zamknij("V")

        self.Zamknij("ZUSZIUA")
        self.ZakonczTworzenie()

        tresc = self.PodajTresc()

        return stat, tresc


#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []


if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Pracownik': [1,], 'DataWypelnienia': [1,], 'Zmiana': [1,], 'Korekta': [1,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista!='':
        stat='Uwaga : wywoanie funkcji fs_kp_deklaracje_zus_ziua '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        DataWypelnienia = rsglobal.Dekoduj(klucze['DataWypelnienia'])
        Zmiana = rsglobal.Dekoduj(klucze['Zmiana'])
        Korekta = rsglobal.Dekoduj(klucze['Korekta'])

#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    zus = ZUS(self)

    stat, dane = zus.ZapiszZiua(Pracownik, DataWypelnienia, Zmiana, Korekta)
