# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_deklaracje_zus_zua.py
# Purpose:     tworzenie xml zus_zua
# Author:      Marcin Natkaski & Konrad Opieka
# Created:     2016/10/19
# RCS-ID:      $Id: fs_kp_deklaracje_zus_zua.py $
# Copyright:   (c) 2016 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-11-19 Aleksnader Bargie - 10852 - Deklaracje w Kartotece osobowej
# 2020-11-04 Wojciech Skowron   - 10852 - Deklaracje w Kartotece osobowej (poprawki)
# 2020-12-30 Wojciech Skowron   - 10852 - Data umowy od, zgoszenie/zmiana/korekta
# 2021-02-03 Wojciech Skowron   - 12370 - Usunicie spacji z nr dokumentu tosamoci
# 2021-03-08 Wojciech Skowron   - 12379 - Pobranie danych osobowych i ewidencyjnych przeniesione do _pom
# 2021-03-18 Wojciech Skowron   - 12394 - Poprawka we wpisywaniu ubezpieczenie_id
# 2021-05-10 Wojciech Skowron   - 12482 - Tworzenie ZWUA/ZUA po zmianie kodu ubezpieczenia w danych zatrudnienia
# 2021-05-12 Wojciech Skowron   - 12487 - Dodanie wpisu do rs_kp_dane_osobowe_zus_skladki
# 2021-05-18 Wojciech Skowron   - 12492 - Pole X.p1 zawod_wykonywany_id
# 2021-09-14 Wojciech Skowron   - 12643 - Usunicie chorobowego z warunku, nie dodawa wiersza do zus_skladki jeli brak ubezpieczenia


class ZUS:
    def  __init__(self, rodzic):
        from funkcje.fs_kp_deklaracje_zus_pom import ZUSXML
        self.zus_zua = ZUSXML(rodzic)

    def ZapiszZua(self,iddoc,pracownik_id,D567,D11,D12,D13,zmiana,korekta,data_wypelnienia):
        stat = 'OK'

        self.zus_zua.ZrobNaglowek()

        self.zus_zua.WstawTekst('<ZUSZUA id_dokumentu="'+iddoc+'">')
        self.zus_zua.WstawNowy("I")
        #WS 2020-12-30
        if zmiana:
            self.zus_zua.WstawNowyZWartoscia("p2", "1")
        elif korekta:
            self.zus_zua.WstawNowyZWartoscia("p2", "2")
        else:
            self.zus_zua.WstawNowyZWartoscia("p1", "true")
        # self.zus_zza.WstawNowyZWartoscia("p1","true")
        self.zus_zua.Zamknij("I")

        stat = self.zus_zua.WstawDanePlatnika()
        if stat != 'OK':
            return stat, ''

        #WS 2021-03-08
        stat = self.zus_zua.WstawDaneOsobowe(pracownik_id)
        if stat != 'OK':
            return stat, ''
        # self.zus_zua.WstawNowy("III")
        # self.zus_zua.WstawNowyZWartoscia("p1",D34[0][0])
        # if D34[0][1]<>0:
        #     self.zus_zua.WstawNowyZWartoscia("p3",D34[0][1])
        # if D34[0][2]<>'':
        #     self.zus_zua.WstawNowyZWartoscia("p4",D34[0][2].replace(' ', ''))
        # self.zus_zua.WstawNowyZWartoscia("p5",D34[0][3])
        # self.zus_zua.WstawNowyZWartoscia("p6",D34[0][4])
        # self.zus_zua.WstawNowyZWartoscia("p7",D34[0][5])
        # self.zus_zua.Zamknij("III")

        #WS 2021-03-08
        stat = self.zus_zua.WstawDaneEwidencyjne(pracownik_id)
        if stat != 'OK':
            return stat, ''
        # self.zus_zua.WstawNowy("IV")
        # if D34[0][6]<>'':
        #     self.zus_zua.WstawNowyZWartoscia("p1",D34[0][6])
        # if D34[0][7]<>'':
        #     self.zus_zua.WstawNowyZWartoscia("p2",D34[0][7])
        # self.zus_zua.WstawNowyZWartoscia("p3",D34[0][8])
        # self.zus_zua.WstawNowyZWartoscia("p4",D34[0][9])
        # self.zus_zua.Zamknij("IV")

        self.zus_zua.WstawNowy("V")
        self.zus_zua.WstawNowy("p1")
        #WS 2021-03-18
        self.zus_zua.WstawNowyZWartoscia("p1",D567[0][0][:4])
        # if len(D567[0][0].strip(' '))==4:
        #     self.zus_zua.WstawNowyZWartoscia("p1",D567[0][0][:4])
        if len(D567[0][0].strip(' '))>4:
            self.zus_zua.WstawNowyZWartoscia("p2",D567[0][0][4:5])
        else:
            self.zus_zua.WstawNowyZWartoscia("p2","0")
        if len(D567[0][0].strip(' '))>5:
            self.zus_zua.WstawNowyZWartoscia("p3",D567[0][0][5:6])
        else:
            self.zus_zua.WstawNowyZWartoscia("p3","0")
        self.zus_zua.Zamknij("p1")
        self.zus_zua.Zamknij("V")

        self.zus_zua.WstawNowy("VI")
        self.zus_zua.WstawNowyZWartoscia("p1",D567[0][1])
        if D567[0][2]==True:
            self.zus_zua.WstawNowyZWartoscia("p2","true")
        else:
            self.zus_zua.WstawNowyZWartoscia("p2","false")
        if D567[0][3]==True:
            self.zus_zua.WstawNowyZWartoscia("p3","true")
        else:
            self.zus_zua.WstawNowyZWartoscia("p3","false")
        if D567[0][4]==True:
            self.zus_zua.WstawNowyZWartoscia("p4","true")
        else:
            self.zus_zua.WstawNowyZWartoscia("p4","false")
        if D567[0][5]==True:
            self.zus_zua.WstawNowyZWartoscia("p5","true")
        else:
            self.zus_zua.WstawNowyZWartoscia("p5","false")
        self.zus_zua.Zamknij("VI")

        self.zus_zua.WstawNowy("VII")
        self.zus_zua.WstawNowyZWartoscia("p1",D567[0][6])
        self.zus_zua.WstawNowyZWartoscia("p2",D567[0][7])
        self.zus_zua.Zamknij("VII")

        self.zus_zua.WstawNowy("X")
        self.zus_zua.WstawNowyZWartoscia("p1",D567[0][9])  #WS 2021-05-18
        self.zus_zua.Zamknij("X")

        if len(D11)>0:
            self.zus_zua.WstawNowy("XI")
            self.zus_zua.WstawNowyZWartoscia("p1",D11[0][0].replace('-',''))
            self.zus_zua.WstawNowyZWartoscia("p2",D11[0][1])
            self.zus_zua.WstawNowyZWartoscia("p3",D11[0][2])
            self.zus_zua.WstawNowyZWartoscia("p4",D11[0][3])
            self.zus_zua.WstawNowyZWartoscia("p5",D11[0][4])
            if D11[0][5]<>'':
                self.zus_zua.WstawNowyZWartoscia("p6",D11[0][5])
            if D11[0][6]<>'':
                self.zus_zua.WstawNowyZWartoscia("p7",D11[0][6])
            self.zus_zua.Zamknij("XI")

        if len(D12)>0:
            self.zus_zua.WstawNowy("XII")
            self.zus_zua.WstawNowyZWartoscia("p1",D12[0][0].replace('-',''))
            self.zus_zua.WstawNowyZWartoscia("p2",D12[0][1])
            self.zus_zua.WstawNowyZWartoscia("p3",D12[0][2])
            self.zus_zua.WstawNowyZWartoscia("p4",D12[0][3])
            self.zus_zua.WstawNowyZWartoscia("p5",D12[0][4])
            if D12[0][5]<>'':
                self.zus_zua.WstawNowyZWartoscia("p6",D12[0][5])
            if D12[0][6]<>'':
                self.zus_zua.WstawNowyZWartoscia("p7",D12[0][6])
            self.zus_zua.Zamknij("XII")

        if len(D13)>0:
            self.zus_zua.WstawNowy("XIII")
            self.zus_zua.WstawNowyZWartoscia("p1",D13[0][0].replace('-',''))
            self.zus_zua.WstawNowyZWartoscia("p2",D13[0][1])
            #WS 2020-11-04
            self.zus_zua.WstawNowyZWartoscia("p3",D13[0][3])
            self.zus_zua.WstawNowyZWartoscia("p4",D13[0][4])
            # self.zus_zua.WstawNowyZWartoscia("p3",D13[0][2])
            # self.zus_zua.WstawNowyZWartoscia("p4",D13[0][3])
            # self.zus_zua.WstawNowyZWartoscia("p5",D13[0][4])
            if D13[0][5]<>'':
                #WS 2020-11-04
                self.zus_zua.WstawNowyZWartoscia("p5", D13[0][5])
                # self.zus_zua.WstawNowyZWartoscia("p6",D13[0][5])
            if D13[0][6]<>'':
                self.zus_zua.WstawNowyZWartoscia("p7", D13[0][6])
            self.zus_zua.Zamknij("XIII")

        self.zus_zua.WstawNowy("XIV")
        self.zus_zua.WstawNowyZWartoscia("p1",data_wypelnienia)
        self.zus_zua.Zamknij("XIV")

        self.zus_zua.Zamknij("ZUSZUA")
        self.zus_zua.ZakonczTworzenie()

        tresc = self.zus_zua.PodajTresc()
        return stat, tresc


#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------

stat='OK'
dane=[]
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Pracownik':[1,2],'Zatrudnienie':[1,],'Zmiana':[1,],'Korekta':[1,],'DataWypelnienia':[1,],'DataOd':[3,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_deklaracje_zus_zua '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        Zatrudnienie = rsglobal.Dekoduj(klucze['Zatrudnienie'])
        Zmiana = rsglobal.Dekoduj(klucze['Zmiana'])  #WS 2020-12-30
        Korekta = rsglobal.Dekoduj(klucze['Korekta'])  #WS 2020-12-30
        DataWypelnienia = rsglobal.Dekoduj(klucze['DataWypelnienia'])

    if Funkcja in [2,]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])

    if Funkcja in [3,]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])

#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==1 and stat=='OK':
    #pobranie danych do zrobienia deklaracji ZUA

    #WS 2021-03-08 - pobieranie danych osobowych i ewidencyjnych przeniesione do _pom
    #WS 2020-11-04
    # SQL ="SELECT pesel, CASE WHEN dokument_id='D' THEN 1 WHEN dokument_id='P' THEN 2 ELSE 0 END, "
    # SQL+="CASE WHEN dokument_id in ('D','P') THEN dokument_nr ELSE '' END, "
    # # SQL ="SELECT pesel, CASE WHEN dowod_numer IS NOT Null THEN 1 WHEN paszport_numer IS NOT NULL THEN 2  ELSE 0 END, "
    # # SQL+="CASE WHEN dowod_numer IS NOT Null THEN dowod_numer WHEN paszport_numer IS NOT NULL THEN paszport_numer ELSE '' END, "
    # SQL+="nazwisko,imie,data_urodzenia,COALESCE(imie_drugie::TEXT,''),COALESCE(rodowe::TEXT,''),obywatelstwo_kraj,plec "
    # SQL+="FROM rs_kp_dane_osobowe "
    # SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    # stat,D34,dump,dump = self.PolSQL.Execute(SQL,3)
    # if stat<>'OK':
    #     stat = 'Bd pobierania informacji z danych osobowych'

    if stat=='OK':
        SQL ="SELECT COALESCE(ubezpieczenie_id,'BRAK'),min(u.od_kiedy),emerytalne,rentowe,chorobowe, "
        SQL+="CASE WHEN rentowe AND emerytalne THEN True ELSE False END ,min(u.od_kiedy),oddzial_nfz_id,etat, "  #WS 2021-05-12 - etat
        SQL+="zawod_wykonywany_id "  #WS 2021-05-18
        SQL+="FROM rs_kp_zatrudnienie z "
        SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
        SQL+="LEFT OUTER JOIN rs_kp_angaze a ON(z.firma_id=a.firma_id AND z.pracownik_id=a.pracownik_id AND z.numer_id=a.zatrudnienie_id AND u.umowa_id=a.umowa_id) "  #WS 2021-05-12
        SQL+="WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND z.numer_id="+str(Zatrudnienie)+" "
        SQL+="GROUP BY ubezpieczenie_id,emerytalne,rentowe,chorobowe,oddzial_nfz_id,etat,zawod_wykonywany_id;"
        stat,D567,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji z zatrudnienia'

    if stat=='OK':
        SQL ="SELECT COALESCE(kod_pocztowy::TEXT,''),COALESCE(miejscowosc::TEXT,''),COALESCE(opis::TEXT,''),COALESCE(ulica::TEXT,''),"
        SQL+="COALESCE(nr_domu::TEXT,''),COALESCE(nr_mieszkania::TEXT,''),COALESCE(telefon::TEXT,'') FROM rs_kp_adresy a "
        SQL+="INNER JOIN rs_gminy g ON (a.firma_id=g.firma_id AND a.gmina_id=g.kod) "
        SQL+="WHERE a.firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='1';"
        stat,D11,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji o adresie zameldowania'

    if stat=='OK':
        SQL ="SELECT COALESCE(kod_pocztowy::TEXT,''),COALESCE(miejscowosc::TEXT,''),COALESCE(opis::TEXT,''),COALESCE(ulica::TEXT,''),"
        SQL+="COALESCE(nr_domu::TEXT,''),COALESCE(nr_mieszkania::TEXT,''),COALESCE(telefon::TEXT,'') FROM rs_kp_adresy a "
        SQL+="INNER JOIN rs_gminy g ON (a.firma_id=g.firma_id AND a.gmina_id=g.kod) "
        SQL+="WHERE a.firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='2';"
        stat,D12,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji o adresie zamieszkania'

    if stat=='OK':
        SQL ="SELECT COALESCE(kod_pocztowy::TEXT,''),COALESCE(miejscowosc::TEXT,''),COALESCE(opis::TEXT,''),COALESCE(ulica::TEXT,''),"
        SQL+="COALESCE(nr_domu::TEXT,''),COALESCE(nr_mieszkania::TEXT,''),COALESCE(telefon::TEXT,'') FROM rs_kp_adresy a "
        SQL+="INNER JOIN rs_gminy g ON (a.firma_id=g.firma_id AND a.gmina_id=g.kod) "
        SQL+="WHERE a.firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='3';"
        stat,D13,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji o adresie korespondencyjnym'

    #WS 2021-05-10
    if stat=='OK':
        if 'DataZar' in klucze:
            D567[0][1] = klucze['DataZar']

    if stat=='OK':
        zua = ZUS(self)
        dzis = rsglobal.PodajDzis()
        iddoc= Pracownik+str(Zatrudnienie)
        if stat == 'OK':
            stat, wynik = zua.ZapiszZua(iddoc,Pracownik,D567,D11,D12,D13,Zmiana,Korekta,DataWypelnienia)
        if stat == 'OK':
            dane.append(wynik)
        else:
            dane.append(stat)

    if stat=='OK':
        SQL ="UPDATE rs_kp_zatrudnienie SET eksport_zua='"+dzis+"' WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND numer_id="+str(Zatrudnienie)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'Bd uzupenienia daty eksportu zua'

    #WS 2021-05-12
    if stat == 'OK':
        firma_id = self.firma_id
        pracownik_id = Pracownik
        rok = D567[0][1][:4]
        miesiac = D567[0][1][5:7]
        rodzaj = 'RCA'
        ubezpieczenie_id = D567[0][0]
        etat = D567[0][8]

        if ubezpieczenie_id != 'BRAK':  #WS 2021-09-14
            SQL = """SELECT 1 FROM rs_kp_dane_osobowe_zus_skladki
                     WHERE firma_id='{firma_id}' AND pracownik_id='{pracownik_id}' AND rok='{rok}' AND miesiac='{miesiac}'
                           AND rodzaj='{rodzaj}' AND ubezpieczenie_id='{ubezpieczenie_id}' AND etat='{etat}';"""
            SQL = SQL.format(**locals())
            stat, spr, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd dodawania danych do rs_kp_dane_osobowe_zus_skladki'
            elif len(spr) == 0:
                SQL = """INSERT INTO rs_kp_dane_osobowe_zus_skladki 
                         (firma_id, pracownik_id, rok, miesiac, rodzaj, ubezpieczenie_id, etat) 
                         VALUES
                         ('{firma_id}', '{pracownik_id}', '{rok}', '{miesiac}', '{rodzaj}', '{ubezpieczenie_id}', '{etat}');"""
                SQL = SQL.format(**locals())
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
                if stat != 'OK':
                    stat = 'Bd dodawania danych do rs_kp_dane_osobowe_zus_skladki'


#-----------------------------------------------------------------------------------------------------------------------

#zapytanie dla wejcia z kartoteki osobowej
if Funkcja==2 and stat=='OK':
    SQL ="SELECT z.pracownik_id,numer_id from rs_kp_zatrudnienie z "
    SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
    SQL+="WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND eksport_zua is Null AND zdrowotne "
    SQL+="AND emerytalne AND rentowe GROUP BY z.pracownik_id,numer_id;"  #WS 2021-09-14 - usunicie chorobowego z warunku
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bd pobierania informacji o zatrudnieniach pracownika'

    elif len(dane)==0:
        SQL ="SELECT numer_id,min(data_zawarcia) AS zawarcie,COALESCE(ubezpieczenie_id,'BRAK'),eksport_zua from rs_kp_zatrudnienie z "
        SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
        SQL+="WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND eksport_zua is not Null "
        SQL+="AND zdrowotne AND emerytalne AND rentowe "  #WS 2021-09-14 - usunicie chorobowego z warunku
        SQL+="Group by numer_id,ubezpieczenie_id,eksport_zua ORDER BY zawarcie"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji o zatrudnieniach pracownika dla posiadajcych wypenione ZUA'
        if stat=='OK':
            wyn2=d

#-----------------------------------------------------------------------------------------------------------------------

#zapytanie po wejciu z deklaracji zus
if Funkcja==3 and stat=='OK':
    #WS 2020-12-30
    WarData = ''
    if DataOd not in ('', '    -  -  ', '-  -'):
        WarData = "u.od_kiedy >= '"+DataOd+"' AND"

    SQL ="SELECT z.pracownik_id,numer_id from rs_kp_zatrudnienie z "
    SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
    SQL+="WHERE z.firma_id ='"+self.firma_id+"' AND "+WarData+" eksport_zua is Null AND zdrowotne AND emerytalne AND rentowe;"  #WS 2021-09-14 - usunicie chorobowego z warunku
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bd pobierania informacji o pracownikach i numerach zatrudnienia'
