# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:        fs_kp_deklaracje_zus_zwua.py
# Purpose:     tworzenie xml zus_zwua
# Author:      Konrad Opieka
# Created:     2017/03/13
# RCS-ID:      $Id: fs_kp_deklaracje_zus_zwua.py $
# Copyright:   (c) 2017 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
# 2018-11-19 Aleksnader Bargie - 10852 - Deklaracje w Kartotece osobowej
# 2020-12-09 Wojciech Skowron   - 10852 - Deklaracje w Kartotece osobowej (poprawki)
# 2020-12-30 Wojciech Skowron   - 10852 - Data zwolnienia od, wyrejestrowanie/korekta
# 2021-02-03 Wojciech Skowron   - 12370 - Usunicie spacji z nr dokumentu tosamoci
# 2021-03-08 Wojciech Skowron   - 12379 - Pobranie danych osobowych przeniesione do _pom
# 2021-04-12 Wojciech Skowron   - 12413 - Wze V - rozwizanie/wyganicie stosunku pracy/subowego
# 2021-05-06 Wojciech Skowron   - 12481 - Poprawki
# 2021-05-10 Wojciech Skowron   - 12482 - Tworzenie ZWUA/ZUA po zmianie kodu ubezpieczenia w danych zatrudnienia


class ZUS:
    def __init__(self, rodzic):
        from funkcje.fs_kp_deklaracje_zus_pom import ZUSXML
        self.zus_zwua = ZUSXML(rodzic)

    def ZapiszZwua(self,iddoc,pracownik_id,D4,korekta,data_wypelnienia):
        stat = 'OK'

        self.zus_zwua.ZrobNaglowek()

        self.zus_zwua.WstawTekst('<ZUSZWUA id_dokumentu="'+iddoc+'">')
        self.zus_zwua.WstawNowy("I")
        #WS 2020-12-30
        if korekta:
            self.zus_zwua.WstawNowyZWartoscia("p2", "true")
        else:
            self.zus_zwua.WstawNowyZWartoscia("p1", "true")
        # self.zus_zwua.WstawNowyZWartoscia("p1","true")
        self.zus_zwua.Zamknij("I")

        stat = self.zus_zwua.WstawDanePlatnika()
        if stat != 'OK':
            return stat, ''

        #WS 2021-03-08
        stat = self.zus_zwua.WstawDaneOsobowe(pracownik_id)
        if stat != 'OK':
            return stat, ''
        # self.zus_zwua.WstawNowy("III")
        # self.zus_zwua.WstawNowyZWartoscia("p1",D3[0][0])
        # if D3[0][1]<>0:
        #     self.zus_zwua.WstawNowyZWartoscia("p3",D3[0][1])
        # if D3[0][2]<>'':
        #     self.zus_zwua.WstawNowyZWartoscia("p4",D3[0][2].replace(' ', ''))
        # self.zus_zwua.WstawNowyZWartoscia("p5",D3[0][3])
        # self.zus_zwua.WstawNowyZWartoscia("p6",D3[0][4])
        # self.zus_zwua.WstawNowyZWartoscia("p7",D3[0][5])
        # self.zus_zwua.Zamknij("III")

        self.zus_zwua.WstawNowy("IV")
        self.zus_zwua.WstawNowy("p1")
        self.zus_zwua.WstawNowyZWartoscia("p1",D4[0][0][:4])
        if len(D4[0][0].strip(' '))>4:
            self.zus_zwua.WstawNowyZWartoscia("p2",D4[0][0][4:5])
        else:
            self.zus_zwua.WstawNowyZWartoscia("p2","0")
        if len(D4[0][0].strip(' '))>5:
            self.zus_zwua.WstawNowyZWartoscia("p3",D4[0][0][5:6])
        else:
            self.zus_zwua.WstawNowyZWartoscia("p3","0")
        self.zus_zwua.Zamknij("p1")
        self.zus_zwua.WstawNowyZWartoscia("p2",D4[0][1])
        self.zus_zwua.WstawNowyZWartoscia("p3",D4[0][2])
        self.zus_zwua.Zamknij("IV")

        if D4[0][2] != '600':  #WS 2021-05-06
            #WS 2021-04-12
            self.zus_zwua.WstawNowy("V")
            self.zus_zwua.WstawNowyZWartoscia("p1",D4[0][3])
            self.zus_zwua.WstawNowyZWartoscia("p2",D4[0][4])
            self.zus_zwua.WstawNowyZWartoscia("p3",D4[0][5])
            if D4[0][5] == '550':
                self.zus_zwua.WstawNowyZWartoscia("p4",D4[0][6])
            if D4[0][7].strip() in ('1', '2'):
                self.zus_zwua.WstawNowyZWartoscia("p5",D4[0][7].strip())
            self.zus_zwua.Zamknij("V")


        self.zus_zwua.WstawNowy("VI")
        self.zus_zwua.WstawNowyZWartoscia("p1",data_wypelnienia)
        self.zus_zwua.Zamknij("VI")

        self.zus_zwua.Zamknij("ZUSZWUA")
        self.zus_zwua.ZakonczTworzenie()

        tresc = self.zus_zwua.PodajTresc()

        return stat, tresc


#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------------------------------

stat='OK'
dane=[]
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Pracownik':[1,2],'Zatrudnienie':[1,],'Korekta':[1,],'DataWypelnienia':[1,],'DataOd':[3,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_deklaracje_zus_zwua '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        Zatrudnienie = rsglobal.Dekoduj(klucze['Zatrudnienie'])
        Korekta = rsglobal.Dekoduj(klucze['Korekta'])  #WS 2020-12-30
        DataWypelnienia = rsglobal.Dekoduj(klucze['DataWypelnienia'])

    if Funkcja in [2,]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])

    #WS 2020-12-30
    if Funkcja in [3,]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])

#-----------------------------------------------------------------------------------------------------------------------

if Funkcja==1 and stat=='OK':
    #pobranie daty z dzi
    dzis = rsglobal.PodajDzis()

    #pobranie danych do zrobienia deklaracji ZWUA
    # SQL ="SELECT nip,regon,nazwa,osoba_fizyczna,nazwisko,imie,data_urodzenia FROM rs_oddzialy o "
    # SQL+="INNER JOIN rs_firmy f ON (o.firma_id=f.firma_id) WHERE o.firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"';"
    # stat,D2,dump,dump = self.PolSQL.Execute(SQL,3)
    # if stat<>'OK':
    #     stat = 'Bd pobierania informacji z danych oddziau'
    # if stat=='OK':

    #WS 2021-03-08 - pobieranie danych osobowych przeniesione do _pom
    #WS 2020-12-09
    # SQL ="SELECT pesel, CASE WHEN dokument_id='D' THEN 1 WHEN dokument_id='P' THEN 2 ELSE 0 END, "
    # SQL+="CASE WHEN dokument_id in ('D','P') THEN dokument_nr ELSE '' END, "
    # # SQL ="SELECT pesel, CASE WHEN dowod_numer IS NOT Null THEN 1 WHEN paszport_numer IS NOT NULL THEN 2  ELSE 0 END, "
    # # SQL+="CASE WHEN dowod_numer IS NOT Null THEN dowod_numer WHEN paszport_numer IS NOT NULL THEN paszport_numer ELSE '' END, "
    # SQL+="nazwisko,imie,data_urodzenia "
    # SQL+="FROM rs_kp_dane_osobowe "
    # SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    # stat,D3,dump,dump = self.PolSQL.Execute(SQL,3)
    # if stat<>'OK':
    #     stat = 'Bd pobierania informacji z danych osobowych'

    if stat=='OK':
        #WS 2021-04-12
        # SQL ="SELECT COALESCE(ubezpieczenie_id,'BRAK'),(max(do_kiedy)+ interval '1' day)::date,przyczyna_wyrejestrowania_zus, "
        SQL ="SELECT COALESCE(ubezpieczenie_id,'BRAK'),(do_kiedy + interval '1' day)::date,przyczyna_wyrejestrowania_zus, "
        SQL+="zwolnienie_data,kod_rozw_stos_pracy,podst_prawna_rozw_stos_pracy,kpr.opis,zus_przyczyna "  #WS 2021-04-12
        SQL+="FROM rs_kp_zatrudnienie z "
        SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
        SQL+="LEFT OUTER JOIN rs_kp_typy_zwolnien tz ON(z.firma_id=tz.firma_id AND z.zwolnienie_id=tz.kod) "
        SQL+="LEFT OUTER JOIN rs_kp_zus_kody_podstawy_rozwiazania_stos_pracy kpr ON(z.podst_prawna_rozw_stos_pracy=kpr.kod) "
        SQL+="WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND z.numer_id="+str(Zatrudnienie)
        SQL+=" ORDER BY do_kiedy DESC LIMIT 1;"
        #WS 2020-12-09
        # SQL+="GROUP BY ubezpieczenie_id,zus_przyczyna HAVING max(do_kiedy)<='"+dzis+"';"
        stat,D4,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji z zatrudnienia'

    #WS 2021-05-10
    if stat=='OK':
        if 'Ubezpieczenie' in klucze:
            D4[0][0] = klucze['Ubezpieczenie']
        if 'DataWyr' in klucze:
            D4[0][1] = klucze['DataWyr']
        if 'KodWyr' in klucze:
            D4[0][2] = klucze['KodWyr']

    if stat=='OK':
        zwua = ZUS(self)

        iddoc= Pracownik+str(Zatrudnienie)
        if stat == 'OK':
            stat, wynik = zwua.ZapiszZwua(iddoc,Pracownik,D4,Korekta,DataWypelnienia)
        if stat == 'OK':
            dane.append(wynik)
        else:
            dane.append(stat)

    if stat=='OK':
        SQL ="UPDATE rs_kp_zatrudnienie SET eksport_zcna='"+dzis+"' WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND numer_id="+str(Zatrudnienie)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'Bd uzupenienia daty eksportu zwua'


#-----------------------------------------------------------------------------------------------------------------------

#zapytanie dla wejcia z kartoteki osobowej
if Funkcja==2 and stat=='OK':
    SQL ="SELECT z.pracownik_id,numer_id from rs_kp_zatrudnienie z "
    SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
    SQL+="WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND eksport_zua is not Null AND eksport_zcna is Null "
    SQL+="AND do_kiedy is not Null GROUP BY z.pracownik_id,numer_id;"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bd pobierania informacji o zatrudnieniach pracownika'

    elif len(dane)==0:
        SQL ="SELECT numer_id,min(data_zawarcia) AS zawarcie,COALESCE(ubezpieczenie_id,'BRAK'),eksport_zcna from rs_kp_zatrudnienie z "
        SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
        SQL+="WHERE z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND eksport_zua is not Null AND eksport_zcna is not Null "
        SQL+="AND do_kiedy is not Null Group by numer_id,ubezpieczenie_id,eksport_zcna ORDER BY zawarcie;"
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bd pobierania informacji o zatrudnieniach pracownika dla posiadajcych wypenione ZWUA'
        if stat=='OK':
            wyn2=d

#-----------------------------------------------------------------------------------------------------------------------

#zapytanie po wejciu z deklaracji zus
if Funkcja==3 and stat=='OK':
    #WS 2020-12-30
    WarData = ''
    if DataOd not in ('', '    -  -  ', '-  -'):
        WarData = "u.do_kiedy >= '"+DataOd+"' AND"

    SQL ="SELECT z.pracownik_id,numer_id from rs_kp_zatrudnienie z "
    SQL+="INNER JOIN rs_kp_umowy_o_prace u ON(z.firma_id=u.firma_id AND z.pracownik_id=u.pracownik_id AND z.numer_id=u.zatrudnienie_id) "
    SQL+="WHERE z.firma_id ='"+self.firma_id+"' AND "+WarData+" eksport_zua is not Null AND eksport_zcna is Null AND do_kiedy is not Null;"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bd pobierania informacji o pracownikach i numerach zatrudnienia'
