# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_edeklaracje_skladniki.py
# Purpose:     obsluga grida edytowalnego laczacego skladniki list plac z edeklaracjami
# Author:      Aleksander Bargie
# Created:     2019/05/14
# RCS-ID:      $Id: fs_kp_edeklaracje_skladniki $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2020-10-02 Wojciech Skowron - (12143) Nowe kolumny 'pole_deklaracji' i 'typ_absencji_id'
# 2020-10-13 Wojciech Skowron - (12164) Nowa kolumna 'klucz'

stat = 'OK'

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Typ': [1, 5], 'Wersja': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_skladniki_edeklaracji z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in (1, 5):
        typ_id    = klucze['Typ']
        wersja_id = klucze['Wersja']

dane = []
wyn1 = []
wyn2 = []

UprModyf = ((self.oddzial_id, '061032') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']



#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_edeklaracje_skladniki "
                WHERE  = "WHERE firma_id='"+self.firma_id+"' AND typ_id='"+typ_id+"' AND wersja_id='"+wersja_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"="+str(wart)
                
                SQLDEL += DELETE+WHERE+"; "

            if stat == "OK" and SQLDEL != '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    
                    if pole == 'skladniki':
                        if wart != '':
                            LSklad = wart.split(',')
                            LSkladBl = ''
                            for sklad in LSklad:
                                SQL="SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+sklad.strip()+"'"  #WS 2020-10-02 - dodany strip()
                                stat,DSklad,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat!='OK':
                                    stat = u'Bd sprawdzania poprawnoci skadnikw: '+stat
                                if stat == 'OK' and len(DSklad) == 0:
                                    LSkladBl += sklad.strip()+','  #WS 2020-10-02 - dodany strip()
                            
                            if stat =='OK' and len(LSkladBl) > 0:
                                wyn2.append((WierszeNr[i],4))
                                dane.append('SKLADNIKI BL$'+LSkladBl.strip(','))

                    elif pole == 'platnik_id':
                        #WS 2020-10-02
                        # if wart != '':
                        BL = ''
                        SQL="SELECT kod FROM rs_edeklaracje_platnicy WHERE kod='"+wart.strip()+"'"
                        stat,DSklad,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat!='OK':
                            stat = u'Bd sprawdzania poprawnoci patnika: '+stat
                        if stat == 'OK' and len(DSklad) == 0:
                            BL = wart

                        if stat =='OK' and len(BL) > 0:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('PLATNIK BL$'+BL)

                    elif pole == 'kolumna_id':
                        #WS 2020-10-02
                        # if wart != '':
                        BL = ''
                        SQL="SELECT kod FROM rs_edeklaracje_kolumny WHERE kod='"+wart.strip()+"'"
                        stat,DSklad,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat!='OK':
                            stat = u'Bd sprawdzania poprawnoci kolumny: '+stat
                        if stat == 'OK' and len(DSklad) == 0:
                            BL = wart

                        if stat =='OK' and len(BL) > 0:
                            wyn2.append((WierszeNr[i],1))
                            dane.append('KOLUMNA BL$'+BL)

                    #WS 2020-10-02
                    elif pole == 'typ_absencji_id':
                        if wart.strip() != '':
                            BL = ''
                            SQL="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+wart+"'"
                            stat,DRodzAbs,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                stat = u'Bd sprawdzania poprawnoci kolumny rodzaju absencji: '+stat
                            elif len(DRodzAbs) == 0:
                                wyn2.append((WierszeNr[i],3))
                                dane.append('RODZ ABS BL$'+wart)
                        
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_edeklaracje_skladniki "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    #WS 2020-10-02
                    if pole in ['skladniki', 'platnik_id', 'pole_deklaracji', 'typ_absencji_id', 'kolumna_id']:
                        if pole in ['platnik_id', 'kolumna_id']:
                            SET += pole+"='"+str(wart)+"',"
                        else:
                            SET += pole+"="+rsglobal.ZmienNaNULL(wart.strip())+","
                    # if pole in ['skladniki', 'platnik_id', 'kolumna_id']:
                        # SET+=pole+"='"+str(wart)+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND typ_id='"+typ_id+"' AND wersja_id='"+wersja_id+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+= " AND "+pole+"='"+str(wart)+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
            if sql!='':
                rsglobal.ZapiszDoLogow(sql)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1,CzyDodawacBlad=True)
                if stat!='OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'skladniki':
                        if wart != '':
                            LSklad = wart.split(',')
                            LSkladBl = ''
                            for sklad in LSklad:
                                SQL="SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+sklad.strip()+"'"  #WS 2020-10-02 - dodany strip()
                                stat,DSklad,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat!='OK':
                                    stat = u'Bd sprawdzania poprawnoci skadnikw: '+stat
                                if stat == 'OK' and len(DSklad) == 0:
                                    LSkladBl += sklad.strip()+','  #WS 2020-10-02 - dodany strip()
                            
                            if stat =='OK' and len(LSkladBl) > 0:
                                wyn2.append((WierszeNr[i],4))
                                dane.append('SKLADNIKI BL$'+LSkladBl.strip(','))

                    elif pole == 'platnik_id':
                        #WS 2020-10-02
                        # if wart != '':
                        BL = ''
                        SQL = "SELECT kod FROM rs_edeklaracje_platnicy WHERE kod='" + wart.strip() + "'"
                        stat, DSklad, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':
                            stat = u'Bd sprawdzania poprawnoci patnika: ' + stat
                        if stat == 'OK' and len(DSklad) == 0:
                            BL = wart

                        if stat == 'OK' and len(BL) > 0:
                            wyn2.append((WierszeNr[i], 0))
                            dane.append('PLATNIK BL$' + BL)

                    elif pole == 'kolumna_id':
                        #WS 2020-10-02
                        # if wart != '':
                        BL = ''
                        SQL = "SELECT kod FROM rs_edeklaracje_kolumny WHERE kod='" + wart.strip() + "'"
                        stat, DSklad, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':
                            stat = u'Bd sprawdzania poprawnoci kolumny: ' + stat
                        if stat == 'OK' and len(DSklad) == 0:
                            BL = wart

                        if stat == 'OK' and len(BL) > 0:
                            wyn2.append((WierszeNr[i], 1))
                            dane.append('KOLUMNA BL$' + BL)

                    #WS 2020-10-02
                    elif pole == 'typ_absencji_id':
                        if wart.strip() != '':
                            BL = ''
                            SQL="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+wart+"'"
                            stat,DRodzAbs,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                stat = u'Bd sprawdzania poprawnoci rodzaju absencji: '+stat
                            elif len(DRodzAbs) == 0:
                                wyn2.append((WierszeNr[i],3))
                                dane.append('RODZ ABS BL$'+wart)
                                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_edeklaracje_skladniki "
                KOLUMNY="(firma_id, typ_id, wersja_id"
                VALUES=" VALUES ('"+self.firma_id+"', '"+typ_id+"', '"+wersja_id+"' "
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    #WS 2020-10-02
                    if pole in ['skladniki', 'platnik_id', 'pole_deklaracji', 'typ_absencji_id', 'kolumna_id']:
                        KOLUMNY+=","+pole
                        if pole in ['platnik_id', 'kolumna_id']:
                            VALUES+=",'"+str(wart)+"'"
                        else:
                            VALUES+=","+rsglobal.ZmienNaNULL(wart.strip())
                    # if pole in ['skladniki', 'platnik_id', 'kolumna_id']:
                        # VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns!='': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1,CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow(sqlIns, 5)
                if stat!='OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    #WS 2020-10-02 - pole_deklaracji, typ_absencji_id, absencja_opis
    #WS 2020-10-13 - klucz
    SQL ="SELECT klucz, platnik_id, kolumna_id, pole_deklaracji, typ_absencji_id, ar.nazwa as absencja_opis, skladniki "
    # SQL ="SELECT platnik_id, kolumna_id, skladniki "
    SQL+=" FROM rs_edeklaracje_skladniki es"
    SQL+=" LEFT OUTER JOIN rs_kp_absencje_rodzaje ar USING (firma_id, typ_absencji_id)"  #WS 2020-10-02
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND typ_id='" + typ_id + "'  AND wersja_id='"+wersja_id+"' "
    SQL+=" ORDER BY typ_id, wersja_id, platnik_id, kolumna_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
