# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_grafik_planowany.py
# Purpose:     obsluga grafiku planowanego
# Author:      Marcin Natkaski
# Created:     2015/07/10
# RCS-ID:      $Id: fs_kp_grafik_planowany.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2020-10-02 (11721) Aleksander Bargie - [KP] Harmonogram w formie arkusza w grafiku planowanym i rzeczywistym
# 2021-05-12 Aleksander Bargie - (12479) Problemy w grafikach typu 1
# 2021-09-08 Aleksander Bargie - (12618) zmiany w grafikach
# 2021-10-19 Aleksander Bargie - (12543) Poprawa filtrowania po czasie
# 2022-04-06 Aleksander Bargie - (12941) Zmiany w harmonogramie
# 2022-07-26 Aleksander Bargie - (13065) [KP] Harmonogram - wszyscy widz wszystko
# 2022-10-17 Aleksander Bargie (13201) - Grafiki typ 1 - zamieniajc absencj na zmian czyci te nieobecnosc i nieobecnosc_za
# 2023-11-21 Aleksander Bargie (13611) - [KP] Harmonogram - bdy i oczywiste usprawnienia
# 2023-11-30 Aleksander Bargie (13616) - [KP] Harmonogram zmiany

import datetime

import rsglobal

stat='OK'
typ_grafiku = 0
puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')  #AB 29.08.21
firma_id = self.firma_id
mod_pozycje = ['-41234123']
dod_pracownicy = set()

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    if 'typ_grafiku' in klucze:
        typ_grafiku = klucze['typ_grafiku']
   
    SlPar = {'DataOdF': [1, 5, 7, 15], 'DataDoF': [1, 5, 7], 'PracownikF': [1, 5, 7],
            'GodzOdF': [1, 5, 7], 'GodzDoF': [1, 5, 7], 'KalendarzSpr':[8],'DataSpr':[8],'IndeksyDoUsuniecia':[9,10],
            'StanowiskoMiejsceF': [1, 5, 7],  'KomorkaF': [1, 5, 7],
             'Pracownik': [15, ]}
    if typ_grafiku != 1:
        SlPar['KalendarzF']        = [1, 5, 7]
        SlPar['MiejsceF']          = [1, 5, 7]
        SlPar['GrupaPracownikowF'] = [1, 5, 7]
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista!='':
        stat='Uwaga : wywoanie funkcji fs_kp_grafik_planowany z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja == 1:
        Update = klucze['Update']
        Insert = klucze['Insert']
        Delete = klucze['Delete']

    if Funkcja in [1, 5, 7]:
        if typ_grafiku != 1:
            Kalendarz         = rsglobal.Dekoduj(klucze['KalendarzF'])
            Miejsce           = rsglobal.Dekoduj(klucze['MiejsceF'])
            GrupaPracownikow  = rsglobal.Dekoduj(klucze['GrupaPracownikowF'])
        if "StanowiskoF" in klucze:
            Stanowisko = rsglobal.Dekoduj(klucze['StanowiskoF'])
        else:
            Stanowisko = None
        StanowiskoMiejsce  = rsglobal.Dekoduj(klucze['StanowiskoMiejsceF'])
        KomorkaF           = rsglobal.Dekoduj(klucze['KomorkaF'])
        DataOd             = rsglobal.Dekoduj(klucze['DataOdF'])
        DataDo             = rsglobal.Dekoduj(klucze['DataDoF'])
        Pracownik          = rsglobal.Dekoduj(klucze['PracownikF'])
        GodzOd             = rsglobal.Dekoduj(klucze['GodzOdF'])
        GodzDo             = rsglobal.Dekoduj(klucze['GodzDoF'])
        GodzinyNadliczbowe = rsglobal.Dekoduj(klucze['GodzinyNadliczbowe']) #AB 2024-01-08
    if Funkcja in [8]:
        KalendarzSpr=rsglobal.Dekoduj(klucze['KalendarzSpr'])
        DataSpr=rsglobal.Dekoduj(klucze['DataSpr'])
    if Funkcja in [15]:
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])
        Data=rsglobal.Dekoduj(klucze['DataOdF'])
    if Funkcja in [9,10,]:
        IndeksyDoUsuniecia=rsglobal.Dekoduj(klucze['IndeksyDoUsuniecia'])
        IndeksyDoUsuniecia=IndeksyDoUsuniecia.split(';')
        tworzenie_warunku = '('
        for m in IndeksyDoUsuniecia:
            tworzenie_warunku+=m+','
        IndeksyDoUsuniecia = tworzenie_warunku[:-1]+')'

dane = []
wyn1 = []
wyn2 = []


# -------------------------------------------------------------------------------
# ---   POBRANIE STANOWISKA(15)
# -------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (15, ):
    SQL = "SELECT COALESCE(stanowisko_miejsce_id, ''), COALESCE(s.opis, ''), o.imie, o.nazwisko " \
          "FROM rs_kp_dane_osobowe o " \
          "LEFT JOIN rs_kp_angaze a on (o.firma_id, o.pracownik_id) = (a.firma_id, a.pracownik_id)  AND a.od_kiedy <= '{}' " \
          "LEFT JOIN rs_kp_stanowiska_pracy_miejsca s on (s.firma_id, s.kod) = (a.firma_id, a.stanowisko_miejsce_id) " \
          "WHERE o.firma_id = '{}' AND o.pracownik_id ='{}'" \
          "ORDER  BY od_kiedy DESC LIMIT 1;".format(Data, self.firma_id, Pracownik)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = "Bd pobierania stanowiska: " + stat
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(SQL)

# -------------------------------------------------------------------------------
# ---------------------  MODYFIKACJA DANYCH NA GRIDZIE - 1  ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (1,) and not GodzinyNadliczbowe:
    wiersze_ins, kolumny_ins, dump = Insert
    ins = ''
    rsglobal.ZapiszDoLogow('wiersze_ins, kolumny_ins')
    rsglobal.ZapiszDoLogow((wiersze_ins, kolumny_ins))
    kolumny_upd, wart_upd, klucze_upd, dump, dump = Update
    rsglobal.ZapiszDoLogow('kolumny_upd, wart_upd, klucze_upd')
    rsglobal.ZapiszDoLogow((kolumny_upd, wart_upd, klucze_upd))
    upd = ''
    klucze_del, dump = Delete
    rsglobal.ZapiszDoLogow('klucze_del')
    rsglobal.ZapiszDoLogow((klucze_del))
    delete = ''

    if self.operator_id != STANDARD_OPERATOR_ID:  #AB 21.06.22r
        SQL = """SELECT komorka_id 
                 FROM rs_kadry_upr
                 WHERE firma_id = %s AND operator_id = rsf_getuserid()"""
    else:
        SQL = """SELECT DISTINCT komorka_id 
                 FROM rs_kp_angaze
                 WHERE firma_id = %s;"""
    args = [firma_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, komorki, wyn1, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Podczas sprawdzania uprawnie do kadr wystpi bd: {}".format(stat)
    elif len(komorki) < 1:
        stat = u"Brak uprawnie do komrek zatrudniajcych. Poinformuj administratora."
    else:
        upr_kom = []
        upr_wszystkie = False  #AB 2024-01-08
        if self.operator_id != STANDARD_OPERATOR_ID:
            upr_wszystkie = True
        else:
            for wiersz in komorki:
                kom = wiersz[0].strip()  #AB 2024-01-08
                if kom == '**':
                    upr_wszystkie = True
                    break
                upr_kom.append(kom)
            upr_kom = "'" + "', '".join(upr_kom) + "'"
        if upr_wszystkie:  #AB 2024-01-08
            upr_kom = ''
        else:
            upr_kom = "a3.komorka_id IN ({}) AND".format(upr_kom)
        test = '''SELECT DISTINCT d.pracownik_id||' - '|| TRIM(d.nazwisko) ||' '|| TRIM(d.imie) as prac, 
                        NOT EXISTS(SELECT 1
                               FROM rs_kp_zatrudnienie zz
                               JOIN rs_kp_umowy_o_prace u4 ON u4.firma_id = zz.firma_id AND u4.pracownik_id = zz.pracownik_id AND u4.zatrudnienie_id = zz.numer_id AND u4.od_kiedy <= {data} AND (do_kiedy IS NULL OR do_kiedy >= {data})
                               JOIN rs_kp_angaze a4 ON  a4.firma_id = zz.firma_id AND a4.pracownik_id = zz.pracownik_id AND a4.zatrudnienie_id = u4.zatrudnienie_id  AND u4.umowa_id = a4.umowa_id AND a4.od_kiedy <= {data} AND (a4.do_kiedy IS NULL OR a4.do_kiedy >= {data})
                               WHERE zz.firma_id=d.firma_id  AND zz.pracownik_id = d.pracownik_id AND upper(zz.stan_pracownika_id) = upper('A')) AS brak_akt_angazu,
                        EXISTS(SELECT 1 
                               FROM rs_kp_zatrudnienie zz
                               JOIN rs_kp_umowy_o_prace u3 ON u3.firma_id = zz.firma_id AND u3.pracownik_id = zz.pracownik_id AND u3.zatrudnienie_id = zz.numer_id AND u3.od_kiedy <= {data} AND (do_kiedy IS NULL OR do_kiedy >= {data})
                               JOIN rs_kp_angaze a3 ON  a3.firma_id = zz.firma_id AND a3.pracownik_id = zz.pracownik_id AND a3.zatrudnienie_id = u3.zatrudnienie_id  AND u3.umowa_id = a3.umowa_id AND a3.od_kiedy <= {data} AND (a3.do_kiedy IS NULL OR a3.do_kiedy >= {data})
                               WHERE zz.firma_id=d.firma_id  AND zz.pracownik_id = d.pracownik_id AND {upr_kom} upper(zz.stan_pracownika_id) = upper('A')) AS uprawnienia_ok
                  FROM rs_kp_dane_osobowe d
                  JOIN rs_kp_grafiki_pozycje g ON g.poz_grafiku_id IN ({poz_grafiku_id}) AND (g.firma_id, g.pracownik_id) = (d.firma_id, d.pracownik_id)
                  FULL OUTER JOIN rs_kp_zatrudnienie z ON (z.firma_id, z.pracownik_id) = (d.firma_id, d.pracownik_id) AND upper(z.stan_pracownika_id) = upper('A')
                  FULL OUTER JOIN rs_kp_umowy_o_prace u2 ON z.firma_id = u2.firma_id AND z.pracownik_id = u2.pracownik_id AND z.numer_id = u2.zatrudnienie_id  
                        AND u2.od_kiedy <= {data} AND (u2.do_kiedy IS NULL OR u2.do_kiedy >= {data})
                  FULL OUTER JOIN rs_kp_angaze a2 ON u2.firma_id = a2.firma_id AND u2.pracownik_id = a2.pracownik_id AND u2.zatrudnienie_id = a2.zatrudnienie_id  
                        AND a2.umowa_id = u2.umowa_id AND a2.od_kiedy <= {data} AND (a2.do_kiedy IS NULL OR a2.do_kiedy >= {data})
                  WHERE d.firma_id = %s 
                  ;'''.format(upr_kom=upr_kom, poz_grafiku_id='{}', data='COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE')

    if stat == 'OK':
        for i in xrange(len(wart_upd)):
            wiersz_kol_upd   = kolumny_upd[i]
            wiersz_wart_upd  = wart_upd[i]
            wiersz_klucz_upd = klucze_upd[i][0]
            for x in xrange(len(wiersz_kol_upd)):
                kol  = wiersz_kol_upd[x]
                wart = wiersz_wart_upd[x]
                zmiany = []
                zmodyfikowano = None
                if kol not in ('imie', 'nazwisko', 'stanowisko', 'godziny', 'nominal', 'zalegle', 'metadane', 'pracownik_id'):
                    if wart.strip() == '':  # pusto, czyli usuwanie
                        if kol[:5] in wiersz_klucz_upd:  #AB 29.08.21
                            klucze_del.append([{kol[:5]: wiersz_klucz_upd[kol[:5]]}])
                    elif '-' in wart:  # godziny
                        rsglobal.ZapiszDoLogow(wart)
                        try:
                            od, do = wart.split('-')
                            od = od.strip()
                            do = do.strip()
                            rsglobal.ZapiszDoLogow(od)
                            rsglobal.ZapiszDoLogow(do)
                            rsglobal.ZapiszDoLogow((DataOd[:4]+'-'+kol[:5] + ' ' + od))
                            rsglobal.ZapiszDoLogow((DataOd[:4]+'-'+kol[:5] + ' ' + do))
                            od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' ' + od), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' ' + do), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            if str(od) < DataOd:
                                od = DataDo[:4] + od[4:]
                                do = DataDo[:4] + do[4:]
                            rsglobal.ZapiszDoLogow(od)
                            rsglobal.ZapiszDoLogow(do)
                            zmiany.append("{}='{}'".format('plan_czas_od', od))
                            zmiany.append("{}='{}'".format('plan_czas_do', do))
                            zmiany.append("nieobecnosc=FALSE")
                            zmiany.append("nieobecnosc_id=NULL")
                            zmiany.append("nieobecnosc_za=NULL")
                            rsglobal.ZapiszDoLogow(kol[:5])
                            rsglobal.ZapiszDoLogow(wiersz_klucz_upd)
                            if kol[:5] in wiersz_klucz_upd:
                                if zmiany not in puste:
                                    poz_id = wiersz_klucz_upd[kol[:5]]
                                    mod_pozycje.append(str(poz_id))  #AB 21.06.22r
                                    upd += "UpDATE rs_kp_grafiki_pozycje SET {} WHERE poz_grafiku_id={}; " \
                                           "".format(', '.join(set(zmiany)), poz_id)
                            else:
                                kolumny = "firma_id, plan_czas_od, plan_czas_do, pracownik_id, plan_stanowisko_miejsce_id"
                                wartosci = ["'"+self.firma_id+"'", "'"+od+"'", "'"+do+"'",
                                            "'"+wiersz_klucz_upd['pracownik_id']+"'",
                                            rsglobal.ZmienNaNULL(wiersz_klucz_upd['stanowisko_id'])]

                                ins += "InSERT INTO rs_kp_grafiki_pozycje ({}) VALUES ({}); ".format(kolumny, ', '.join(wartosci))
                                dod_pracownicy.add((str(wiersz_klucz_upd['pracownik_id']), str(od).strip("'")))  #AB 21.06.22r
                        except ValueError, e:
                            stat = "Bd odczytu czasu dla '{}'".format(wart)
                            dane.append("Pracownik {}: {}".format(wiersz_klucz_upd['pracownik_id'], stat))  #AB 2023-11-21
                            import traceback
                            rsglobal.ZapiszDoLogow(traceback.format_exc())

                    else:  #absencja
                        SQL = "SELECT czy_zwolnienie OR LOWER(nazwa) LIKE '%urlop%' FROM rs_kp_absencje_rodzaje  " \
                              "WHERE firma_id = '{}' AND typ_absencji_id = '{}';".format(self.firma_id, wart)

                        stat, abs, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':
                            stat = "Bd przy sprawdzaniu kodu nieobecnoci: " + stat
                            dane.append("Pracownik {}: {}".format(wiersz_klucz_upd['pracownik_id'], stat))  #AB 2023-11-21
                            rsglobal.ZapiszDoLogow(stat)
                            rsglobal.ZapiszDoLogow(SQL)
                        elif len(abs) == 0:
                            stat = "'{}' nie zostao rozpoznane jako zmiana ani poprawny symbol nieobecnoci.".format(wart)
                            rsglobal.ZapiszDoLogow(stat)
                            rsglobal.ZapiszDoLogow(SQL)
                            dane.append("Pracownik {}: {}".format(wiersz_klucz_upd['pracownik_id'], stat))  #AB 2023-11-21
                        else:
                            rsglobal.ZapiszDoLogow(wart)
                            if abs[0][0]:
                                od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 06:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 14:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            else:
                                od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            if str(od) < DataOd:  #AB 2024-01-08  zabezpieczenie roku przestepnego
                                od = DataDo[:4] + od[4:]
                                do = DataDo[:4] + do[4:]
                            # if str(od) < DataOd:
                            #     od = datetime.datetime.strptime((DataDo[:4] + '-' + kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            #     do = datetime.datetime.strptime((DataDo[:4] + '-' + kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')

                            zmiany.append("{}='{}'".format('plan_czas_od', od))
                            zmiany.append("{}='{}'".format('plan_czas_do', do))
                            zmiany.append("nieobecnosc=TRUE")
                            zmiany.append("nieobecnosc_id="+rsglobal.ZmienNaNULL(wart))
                            if kol[:5] in wiersz_klucz_upd:
                                if zmiany not in puste:  #AB 21.06.22r
                                    poz_id = wiersz_klucz_upd[kol[:5]]
                                    mod_pozycje.append(str(poz_id))
                                    upd += "UPdATE rs_kp_grafiki_pozycje SET {} WHERE poz_grafiku_id={}; ".format(', '.join(set(zmiany)), poz_id)
                            else:
                                # od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                # do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                # if str(od) < DataOd:
                                #     od = datetime.datetime.strptime((DataDo[:4] + '-' + kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                #     do = datetime.datetime.strptime((DataDo[:4] + '-' + kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                kolumny = "firma_id, nieobecnosc, nieobecnosc_id, plan_czas_od, plan_czas_do, " \
                                          "pracownik_id, plan_stanowisko_miejsce_id," \
                                          " nieobecnosc_za, " \
                                          "godz_nadliczbowe_od, " \
                                          "godz_nadliczbowe_do "
                                wartosci = ["'"+self.firma_id+"'", "TRUE", "'"+wart+"'", "'"+od+"'", "'"+do+"'",
                                            "'"+wiersz_klucz_upd['pracownik_id']+"'", rsglobal.ZmienNaNULL(wiersz_klucz_upd['stanowisko_id']),
                                            rsglobal.ZmienNaNULL(wiersz_klucz_upd['za'+kol[:5]] if 'za'+kol[:5] in wiersz_klucz_upd else ''),
                                            rsglobal.ZmienNaNULL(wiersz_klucz_upd['nadliczbowe_od'+kol[:5]] if 'nadliczbowe_od'+kol[:5] in wiersz_klucz_upd else ''),
                                            rsglobal.ZmienNaNULL(wiersz_klucz_upd['nadliczbowe_do'+kol[:5]] if 'nadliczbowe_do'+kol[:5] in wiersz_klucz_upd else '')]  #AB 29.08.21
                                ins += "INsERT INTO rs_kp_grafiki_pozycje ({}) VALUES ({}); ".format(kolumny, ', '.join(wartosci))
                                dod_pracownicy.add((str(wiersz_klucz_upd['pracownik_id']), str(od).strip("'")))  #AB 21.06.22r
                elif kol in ('imie', 'nazwisko', 'pracownik_id'):
                    SQL= "SELECT 1 FROM rs_kp_dane_osobowe WHERE"
                    SQL+=" firma_id='{}' AND pracownik_id='{}'".format(firma_id, wiersz_klucz_upd['pracownik_id'])
                    stat,prac,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
                    rsglobal.ZapiszDoLogow(SQL)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania danych pracownika: '+stat
                        dane.append("Pracownik {}: {}".format(wiersz_klucz_upd['pracownik_id'], stat))
                    elif len(prac)<1:
                        stat = 'Nie odnaleziono pracownika : ' + wiersz_klucz_upd['pracownik_id']
                        dane.append(stat)
                    else:
                        zmiany.append("{}='{}'".format('pracownik_id', wiersz_klucz_upd['pracownik_id']))
                        for wart in wiersz_klucz_upd:
                            if '.' in wart and len(wart) == 5:  #AB 21.06.22r
                                poz_id = wiersz_klucz_upd[wart]
                                mod_pozycje.append(str(poz_id))
                                upd += "UPDaTE rs_kp_grafiki_pozycje SET {} WHERE poz_grafiku_id={}; ".format(', '.join(set(zmiany)), poz_id)
                elif kol == 'metadane':
                    if 'n_stanowisko_id' in wiersz_klucz_upd:  #AB 29.08.21
                        sql = "SELECT kod FROM rs_kp_stanowiska_pracy_miejsca"
                        sql += " WHERE firma_id = '{}' AND kod = '{}';".format(firma_id, wiersz_klucz_upd['n_stanowisko_id'])
                        rsglobal.ZapiszDoLogow(sql)
                        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            stat = 'Bd pobrania kodu stanowiska pracy-miejsca: ' + stat
                            dane.append("Pracownik {}: {}".format(wiersz_klucz_upd['pracownik_id'], stat))  #AB 2023-11-21
                        elif len(d) == 0:
                            stat = 'Brak stanowiska dla pracownika {}'.format(wiersz_klucz_upd['pracownik_id'])
                            dane.append(stat)
                        else:
                            zmiany.append("{}={}".format('plan_stanowisko_miejsce_id', rsglobal.ZmienNaNULL(wiersz_klucz_upd['n_stanowisko_id'])))
                            for wart in wiersz_klucz_upd:
                                if '.' in wart and len(wart) == 5:  #AB 21.06.22r
                                    poz_id = wiersz_klucz_upd[wart]
                                    mod_pozycje.append(str(poz_id))
                                    upd += "UPDAtE rs_kp_grafiki_pozycje SET {} WHERE poz_grafiku_id={}; ".format(', '.join(set(zmiany)), poz_id)

                for wart in wiersz_klucz_upd:
                    if wart.startswith('za') and wart[2:] in wiersz_klucz_upd and wiersz_klucz_upd[wart[2:]] not in puste:  #AB 29.08.21
                        #AB 21.06.22r
                        poz_id = wiersz_klucz_upd[wart[2:]]
                        mod_pozycje.append(str(poz_id))
                        upd += "UPDATe rs_kp_grafiki_pozycje SET nieobecnosc_za={} WHERE poz_grafiku_id={}; " \
                               "".format(rsglobal.ZmienNaNULL(wiersz_klucz_upd[wart]), poz_id)
                    elif wart.startswith('nadliczbowe_') and wart[14:] in wiersz_klucz_upd and wiersz_klucz_upd[wart[14:]] not in puste:  #AB 21.06.22r
                        poz_id = wiersz_klucz_upd[wart[-5:]]
                        mod_pozycje.append(str(poz_id))
                        od_do = wart[12:14]
                        upd += "UPDATe rs_kp_grafiki_pozycje SET godz_nadliczbowe_{}={} WHERE poz_grafiku_id={}; " \
                               "".format(od_do, rsglobal.ZmienNaNULL(wiersz_klucz_upd[wart]).replace("'  :  '", 'NULL'), poz_id)
                    elif wart.startswith('nadliczbowe_od'):
                        try:
                            nadl_od = wiersz_klucz_upd[wart]  # np. u'nadliczbowe_od02.01'
                            nadl_do = wiersz_klucz_upd[wart.replace('od', 'do')]  # np. u'nadliczbowe_do02.01'
                            dzien = wart.strip("nadliczbowe_od")
                            od = datetime.datetime.strptime((DataOd[:4]+'-'+dzien+ ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            do = datetime.datetime.strptime((DataOd[:4]+'-'+dzien+ ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            kolumny = "firma_id, plan_czas_od, plan_czas_do, pracownik_id, plan_stanowisko_miejsce_id, godz_nadliczbowe_od, godz_nadliczbowe_do"
                            wartosci = ["'" + self.firma_id + "'", "'" + od + "'", "'" + do + "'",
                                        "'" + wiersz_klucz_upd['pracownik_id'] + "'",
                                        rsglobal.ZmienNaNULL(wiersz_klucz_upd['stanowisko_id']),
                                        rsglobal.ZmienNaNULL(nadl_od),
                                        rsglobal.ZmienNaNULL(nadl_do)]

                            ins += "InSERT INTO rs_kp_grafiki_pozycje ({}) VALUES ({}); ".format(kolumny,
                                                                                                 ', '.join(wartosci))
                            dod_pracownicy.add((str(wiersz_klucz_upd['pracownik_id']), str(od).strip("'")))
                        except:
                            import traceback
                            stat = "Nie udao sie zapisa godzin nadliczbowych"
                            rsglobal.ZapiszDoLogow("""wart: {},
                            wiersz_klucz_upd: {}
                            wart[14:]: {}
                            exc: """.format(wart, wiersz_klucz_upd, wart[14:], traceback.format_exc()))

    if stat == 'OK':
        for wiersz in wiersze_ins:
            metadane = wiersz[kolumny_ins.index('metadane')]
            for i in xrange(len(wiersz)):
                kolumny  = []
                wartosci = []
                kol  = kolumny_ins[i]
                wart = wiersz[i]
                if kol not in ('imie', 'nazwisko', 'stanowisko', 'godziny', 'nominal', 'zalegle', 'metadane', 'pracownik_id'):
                    if wart.strip() == '':
                        pass
                    elif '-' in wart:
                        rsglobal.ZapiszDoLogow(wart)
                        try:
                            od, do = wart.split('-')
                            od = od.strip()
                            do = do.strip()
                            rsglobal.ZapiszDoLogow(od)
                            rsglobal.ZapiszDoLogow(do)
                            rsglobal.ZapiszDoLogow((DataOd[:4]+'-'+kol[:5] + ' ' + od))
                            rsglobal.ZapiszDoLogow((DataOd[:4]+'-'+kol[:5] + ' ' + do))
                            od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' ' + od), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' ' + do), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            if str(od) < DataOd:
                                od = DataDo[:4] + od[4:]
                                do = DataDo[:4] + do[4:]

                            kolumny.append('plan_czas_od')
                            kolumny.append('plan_czas_do')
                            wartosci.append("'"+od+"'")
                            wartosci.append("'"+do+"'")
                        except ValueError, e:
                            stat = "Bd odczytu czasu dla '{}'".format(wart)
                            dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))
                            import traceback
                            rsglobal.ZapiszDoLogow(traceback.format_exc())
                    else:
                        SQL = "SELECT czy_zwolnienie OR LOWER(nazwa) LIKE '%urlop%' FROM rs_kp_absencje_rodzaje  " \
                              "WHERE firma_id = '{}' AND typ_absencji_id = '{}';".format(self.firma_id, wart)

                        stat, abs, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':
                            stat = "Bd przy sprawdzaniu kodu nieobecnoci: " + stat
                            dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))  #AB 2023-11-21
                            rsglobal.ZapiszDoLogow(stat)
                            rsglobal.ZapiszDoLogow(SQL)
                        elif len(abs) == 0:
                            stat = "'{}' nie zostao rozpoznane jako zmiana ani poprawny symbol nieobecnoci.".format(wart)
                            dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))  #AB 2023-11-21
                            rsglobal.ZapiszDoLogow(stat)
                            rsglobal.ZapiszDoLogow(SQL)
                        else:
                            rsglobal.ZapiszDoLogow(wart)
                            if abs[0][0]:
                                od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 06:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 14:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            else:
                                od = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                                do = datetime.datetime.strptime((DataOd[:4]+'-'+kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            # if str(od) < DataOd:
                            #     od = datetime.datetime.strptime((DataDo[:4] + '-' + kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            #     do = datetime.datetime.strptime((DataDo[:4] + '-' + kol[:5] + ' 08:00'), '%Y-%d.%m %H:%M').strftime('%Y-%m-%d %H:%M')
                            kolumny.append('nieobecnosc')
                            kolumny.append('nieobecnosc_id')
                            kolumny.append('plan_czas_od')
                            kolumny.append('plan_czas_do')
                            wartosci.append('TRUE')
                            wartosci.append("'"+wart+"'")
                            wartosci.append("'"+od+"'")
                            wartosci.append("'"+do+"'")
                if kolumny:
                    SQL= "SELECT 1 FROM rs_kp_dane_osobowe WHERE"
                    SQL+=" firma_id='{}' AND pracownik_id='{}'".format(firma_id, metadane['pracownik_id'])
                    stat,prac,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
                    if stat != 'OK':
                        stat = 'Bd sprawdzania danych pracownika: '+stat
                        dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))
                    elif len(prac) < 1:
                        stat = 'Nie odnaleziono pracownika : ' + metadane['pracownik_id']
                        dane.append(stat)
                    else:
                        sql = "SELECT kod FROM rs_kp_stanowiska_pracy_miejsca"
                        sql += " WHERE firma_id = '{}' AND kod = '{}';".format(firma_id, metadane['n_stanowisko_id'])
                        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            stat = 'Bd pobrania kodu stanowiska pracy-miejsca: ' + stat
                            dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))  #AB 2023-11-21
                        elif len(d) == 0:
                            stat = 'Brak stanowiska'  #AB 21.06.22r
                            dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))  #AB 2023-11-21
                        else:
                            kolumny.append('pracownik_id')
                            wartosci.append("'"+metadane['pracownik_id']+"'")

                            kolumny.append('plan_stanowisko_miejsce_id')
                            wartosci.append(rsglobal.ZmienNaNULL(metadane['n_stanowisko_id']))

                            kolumny.append('firma_id')
                            wartosci.append("'"+self.firma_id+"'")

                            if 'za'+kol[:5] in metadane:
                                kolumny.append('nieobecnosc_za')
                                wartosci.append(rsglobal.ZmienNaNULL(metadane['za'+kol[:5]]))

                            if 'nadliczbowe_od'+kol[:5] in metadane:
                                kolumny.append('godz_nadliczbowe_od')
                                wartosci.append(rsglobal.ZmienNaNULL(metadane['nadliczbowe_od'+kol[:5]]))

                            if 'nadliczbowe_do'+kol[:5] in metadane:
                                kolumny.append('godz_nadliczbowe_do')
                                wartosci.append(rsglobal.ZmienNaNULL(metadane['nadliczbowe_do'+kol[:5]]))

                            ins += "iNSERT INTO rs_kp_grafiki_pozycje ({}) VALUES ({}); ".format(', '.join(kolumny), ', '.join(wartosci))
                            dod_pracownicy.add((str(metadane['pracownik_id']), str(wartosci[kolumny.index('plan_czas_od')]).strip("'")))  #AB 21.06.22r
    if stat == 'OK' and len(dane):
        stat = dane[0]
    if stat == 'OK':
        for klucz in klucze_del:
            for dzien in klucz[0]:
                rsglobal.ZapiszDoLogow('dzien: '+str(dzien))
                if '.' in dzien and len(dzien) == 5:
                    #AB 21.06.22r
                    poz_grafiku = klucz[0][dzien]
                    mod_pozycje.append(str(poz_grafiku))
                    delete += "DELETE FROM rs_kp_grafiki_pozycje WHERE poz_grafiku_id={}; ".format(poz_grafiku)

    if stat == 'OK':
        sql = delete + ins + upd
        if sql != '':
            test_pracownik = "SELECT rsf_kadry_dozwolony_pracownik_na_dzien('{}', '{}', '{}'::DATE::TEXT);"
            if len(mod_pozycje)>1:
                rsglobal.ZapiszDoLogow(test)
                test = test.format(", ".join(mod_pozycje))
                args = [firma_id]
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(test, args))
                stat, brak_upr, dump, dump = self.PolSQL.Execute(test, 3, args, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Podczas sprawdzania uprawnie do kadr wystpi bd: {}".format(stat)
                elif len(brak_upr) > 0:
                    for prac in brak_upr:
                        if prac[1]:
                            stat = 'Pracownik {} nie posiada aktywnego angau'.format(prac[0])
                        elif not prac[2]:
                            stat = 'Brak uprawnie do grafikw dla pracownika {}'.format(prac[0])
                        else:
                            continue
                        dane.append(stat)
            for pozycja in dod_pracownicy:
                tst = test_pracownik.format(firma_id, pozycja[0], pozycja[1])
                stat, pracownik_ok, dump, dump = self.PolSQL.Execute(tst, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd podczas sprawdzania uprawnie do pracownika: " + stat
                elif pracownik_ok[0][0] not in (True, 'True'):
                    stat = pracownik_ok[0][0]
                if stat != 'OK':
                    rsglobal.ZapiszDoLogow(stat)
                    rsglobal.ZapiszDoLogow(tst)
                    dane.append("Pracownik {}: {}".format(metadane['pracownik_id'], stat))  #AB 2023-11-21

            if stat == 'OK':
                rsglobal.ZapiszDoLogow(sql)
                stat, dane, dump, dump = self.PolSQL.Execute(sql, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy zapisie danych: " + stat
                    rsglobal.ZapiszDoLogow(stat)
                    rsglobal.ZapiszDoLogow(sql)


#-------------------------------------------------------------------------------
#----ZBIERANIE DANYCH DO KOLOROWANIA GRIDA - 7
#-------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (7,):
    SQL=" SELECT DISTINCT poz_grafiku_id "
    SQL+=" FROM rs_kp_grafiki_pozycje g "
    SQL+=" INNER JOIN rs_kp_angaze a USING (firma_id,pracownik_id) "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND stan='Z' "
    SQL+=" AND plan_czas_od>='"+DataOd+"'::TIMESTAMP AND plan_czas_do<='"+DataDo+"'::TIMESTAMP "
    if Kalendarz!='':
        SQL+=" AND g.kalendarz_id='"+Kalendarz+"'"
    if Miejsce!='':
        SQL+=" AND plan_miejsce_pracy_id='"+Miejsce+"'"
    if Stanowisko!='':
        SQL+=" AND plan_stanowisko_pracy_id='"+Stanowisko+"'"
    if StanowiskoMiejsce!='':
        SQL+=" AND plan_stanowisko_miejsce_id='"+StanowiskoMiejsce+"'"
    if KomorkaF.strip() not in ['','**']:
        SQL+=" AND a.komorka_id='"+KomorkaF+"'"
        SQL+=" AND (CASE WHEN a.do_kiedy is not NULL THEN (plan_czas_od between a.do_kiedy AND a.do_kiedy) ELSE a.od_kiedy <= plan_czas_do END)"
    if Pracownik!='':
        SQL+=" AND pracownik_id='"+Pracownik+"'"
    if GodzOd.strip()!=':':
        SQL+=" AND substring(plan_czas_od::TEXT from 12 for 5)::TIME>='"+GodzOd+"'::TIME"
    if GodzDo.strip()!=':':
        SQL+=" AND substring(plan_czas_do::TEXT from 12 for 5)::TIME<='"+GodzDo+"'::TIME"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(SQL)

#-------------------------------------------------------------------------------
#----BADANIE EDYTOWANIA GRAFIKU - 8
#-------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (8,):
    SQL =" SELECT poz_grafiku_id FROM rs_kp_grafiki_pozycje WHERE firma_id='"+self.firma_id+"' AND "
    SQL+=" kalendarz_id='"+KalendarzSpr.strip()+"' and fakt_czas_od::Date='"+DataSpr.strip()+"' AND stan='Z' ;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(SQL)


#-------------------------------------------------------------------------------
#----BADANIE USUWANIA GRAFIKU - 9
#-------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (9,):
    SQL =" SELECT kalendarz_id,substring(plan_czas_od::TEXT from 1 for 10)"
    SQL+=" FROM rs_kp_grafiki_pozycje WHERE firma_id='"+self.firma_id+"' AND "
    SQL+=" poz_grafiku_id in "+IndeksyDoUsuniecia+" AND stan='Z' ;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych sprawdzajcych usunicie: "+stat
        dane.append(stat)
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(SQL)


#-------------------------------------------------------------------------------
#----USUWANIE GRAFIKU - 10
#-------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (10,):
    DEL =" DELETE FROM rs_kp_grafiki_pozycje WHERE firma_id='"+self.firma_id+"' AND "
    DEL+=" poz_grafiku_id in "+IndeksyDoUsuniecia+" AND (stan!='Z' or stan IS NULL) ;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(DEL,1)
    if stat != 'OK':
        stat = "Bd usuwania elementw grafiku: "+stat
        dane.append(stat)
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(DEL)

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
# -------------------------------------------------------------------------------

if stat == 'OK' and  Funkcja in (5, 1):
    if self.operator_id != STANDARD_OPERATOR_ID:  #AB 21.06.22r
        SQL = """SELECT komorka_id 
                 FROM rs_kadry_upr
                 WHERE firma_id = %s AND operator_id = rsf_getuserid()"""
    else:
        SQL = """SELECT DISTINCT komorka_id 
                 FROM rs_kp_angaze
                 WHERE firma_id = %s;"""
    args = [firma_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, komorki, wyn1, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Podczas sprawdzania uprawnie do kadr wystpi bd: {}".format(stat)
    elif len(komorki) < 1:
        stat = u"Brak uprawnie do komrek zatrudniajcych. Poinformuj administratora."
    else:
        upr_kom = []
        upr_wszystkie = False#AB 2024-01-08
        if self.operator_id != STANDARD_OPERATOR_ID:
            upr_wszystkie = True
        else:
            for wiersz in komorki:
                kom = wiersz[0]#AB 2024-01-08
                if kom.strip() == '**':
                    upr_wszystkie = True
                    break
                upr_kom.append(kom)
            upr_kom = "'" + "', '".join(upr_kom) + "'"
    if stat == 'OK':
        if typ_grafiku == 0:
            #AB 2024-01-08
            SQL=" SELECT DISTINCT g.plan_czas_od,g.plan_czas_do,"
            SQL += " g.plan_miejsce_pracy_id||'-'||m.opis, COALESCE(g.plan_stanowisko_pracy_id, g.fakt_stanowisko_pracy_id)||'-'||s.opis, g.pracownik_id, o.imie,o.nazwisko,g.poz_grafiku_id "
            SQL += " FROM rs_kp_grafiki_pozycje g INNER JOIN rs_kp_dane_osobowe o USING (firma_id, pracownik_id)"
            SQL += " INNER JOIN rs_kp_angaze a USING (firma_id,pracownik_id) "
            SQL += " INNER JOIN rs_stanowiska_pracy s ON (g.firma_id=s.firma_id AND COALESCE(g.plan_stanowisko_pracy_id, g.fakt_stanowisko_pracy_id)=s.kod) "
            SQL += " INNER JOIN rs_miejsca_pracy m ON (g.firma_id=m.firma_id AND g.plan_miejsce_pracy_id=m.kod) "
        elif typ_grafiku == 1:  #AB 29.08.21
            SQL = """SELECT DISTINCT  COALESCE(g.plan_czas_od, g.fakt_czas_od), poz_grafiku_id, o.imie, o.nazwisko, g.pracownik_id, s.opis AS stanowisko,
                                      s.kod as stanowisko_id, to_char(COALESCE(g.plan_czas_od, g.fakt_czas_od), 'DD.MM') AS dzien, 
                                      to_char(COALESCE(g.plan_czas_od, g.fakt_czas_od), 'HH24:MI') ||'-'|| to_char(plan_czas_do, 'HH24:MI') AS godziny, 
                                      nieobecnosc, nieobecnosc_id, nieobecnosc_za, godz_nadliczbowe_od, godz_nadliczbowe_do
                     FROM rs_kp_grafiki_pozycje g
                     JOIN rs_kp_dane_osobowe o USING (firma_id, pracownik_id)
                     JOIN rs_kp_zatrudnienie z ON (z.firma_id, z.pracownik_id) = (g.firma_id, g.pracownik_id) 
                     JOIN rs_kp_angaze a ON a.firma_id = z.firma_id AND a.pracownik_id = z.pracownik_id AND a.zatrudnienie_id = z.numer_id 
                          AND a.umowa_id = (SELECT umowa_id 
                                            FROM rs_kp_umowy_o_prace u2 
                                            WHERE a.firma_id = u2.firma_id AND a.pracownik_id = u2.pracownik_id AND a.zatrudnienie_id = u2.zatrudnienie_id AND od_kiedy <= COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE AND (do_kiedy IS NULL OR do_kiedy >= COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE)
                                            ORDER BY u2.od_kiedy DESC LIMIT 1) 
                          AND a.angaz_id = (SELECT max(angaz_id) 
                                            FROM rs_kp_angaze a2 
                                            WHERE a.firma_id = a2.firma_id AND a.pracownik_id = a2.pracownik_id AND a.zatrudnienie_id = a2.zatrudnienie_id  AND a2.umowa_id = a.umowa_id AND od_kiedy <= COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE AND (do_kiedy IS NULL OR do_kiedy >= COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE)
                                            )
                     LEFT JOIN rs_kp_stanowiska_pracy_miejsca s ON (g.firma_id, COALESCE(g.plan_stanowisko_miejsce_id, g.fakt_stanowisko_miejsce_id)) = (s.firma_id, s.kod)
                     """  #AB 2024-01-08

        SQL += " WHERE g.firma_id='"+self.firma_id+"' "
        SQL += " AND COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE>='"+DataOd+"' AND COALESCE(g.plan_czas_od, g.fakt_czas_od)::DATE<='"+DataDo+"' "
        if typ_grafiku != 1:
            if Kalendarz!='':
                SQL += " AND g.kalendarz_id='"+Kalendarz+"'"
            if Miejsce!='':
                SQL += " AND g.plan_miejsce_pracy_id='"+Miejsce+"'"
            if GrupaPracownikow != '':
                SQL += " AND a.grupa_pracownikow_id='"+GrupaPracownikow+"'"
        if Stanowisko:
            SQL += " AND COALESCE(g.plan_stanowisko_pracy_id, g.fakt_stanowisko_pracy_id)='"+Stanowisko+"'"  #AB 2024-01-08
        if StanowiskoMiejsce:
            #AB 06.04.22r
            if ',' in StanowiskoMiejsce:
                miejsca = []
                for smiejsce in StanowiskoMiejsce.split(','):
                    smiejsce = smiejsce.strip()
                    miejsca.append("UPPER('{smiejsce}') = ANY(regexp_split_to_array(UPPER(COALESCE(g.plan_stanowisko_miejsce_id, g.fakt_stanowisko_miejsce_id)), E'\\\\s*,\\\\s*'))".format(**locals()))  #AB 2024-01-08
                SQL += ' AND (' + (' OR '.join(miejsca)) + ' )'
            else:
                SQL += " AND COALESCE(g.plan_stanowisko_miejsce_id, g.fakt_stanowisko_miejsce_id) LIKE '"+StanowiskoMiejsce+"%'"  #AB 2024-01-08
        if KomorkaF.strip() not in ['','**']:
            SQL += " AND a.komorka_id='"+KomorkaF+"'"
            SQL += " AND (CASE WHEN a.do_kiedy is not NULL THEN (COALESCE(g.plan_czas_od, g.fakt_czas_od) between a.do_kiedy AND a.do_kiedy) ELSE a.od_kiedy <= g.plan_czas_do END)"
        if Pracownik != '':
            SQL += " AND g.pracownik_id='"+Pracownik+"'"
        if GodzOd.strip() != ':':
            #AB 18.10.21r
            SQL += " AND (substring(COALESCE(g.plan_czas_od, g.fakt_czas_od)::TEXT from 0 for 11) || ' "+GodzOd+"')::TIMESTAMP < CASE WHEN plan_czas_do < plan_czas_od THEN plan_czas_do + INTERVAL '1 DAY' ELSE plan_czas_do END"
        if GodzDo.strip() != ':':
            #AB 18.10.21r
            if GodzOd.strip() != ':' and GodzOd.strip() > GodzDo.strip():
                SQL += " AND (substring(COALESCE(g.plan_czas_od, g.fakt_czas_od)::TEXT from 0 for 11) || ' "+GodzDo+"')::TIMESTAMP + INTERVAL '1 DAY' > plan_czas_od"
            else:
                SQL += " AND (substring(COALESCE(g.plan_czas_od, g.fakt_czas_od)::TEXT from 0 for 11) || ' "+GodzDo+"')::TIMESTAMP > plan_czas_od"
        if typ_grafiku == 1:  #AB 21.06.22r
            if upr_wszystkie:  #AB 2024-01-08
                upr_kom = ''
            else:
                upr_kom = "komorka_id IN ({}) AND".format(upr_kom)
            SQL += " AND {upr_kom} upper(z.stan_pracownika_id) = upper('A')".format(upr_kom=upr_kom)
            SQL += " ORDER BY s.opis, o.nazwisko, o.imie, COALESCE(g.plan_czas_od, g.fakt_czas_od)"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
            rsglobal.ZapiszDoLogow(stat)
            rsglobal.ZapiszDoLogow(SQL)
        elif typ_grafiku == 1:
            z_sql = dane
            tmp = {}
            kolumny = {}
            for x in xrange(len(wyn1)):
                kolumny[wyn1[x][0]] = x
            for wiersz in z_sql:
                klucz = wiersz[kolumny['stanowisko']] + wiersz[kolumny['pracownik_id']]
                #AB 12.04.22r

                if wiersz[kolumny['nieobecnosc']]:
                    tekst = wiersz[kolumny['nieobecnosc_id']]
                else:
                    tekst = wiersz[kolumny['godziny']]

                if GodzinyNadliczbowe and wiersz[kolumny['godz_nadliczbowe_od']] not in puste:  #AB 2024-01-08
                    tekst = wiersz[kolumny['godz_nadliczbowe_od']]+"-"+wiersz[kolumny['godz_nadliczbowe_do']]

                #  8:00-8:00 to zmiana 'techniczna', dla dni z godzinami nadliczbowymi itd.
                if tekst == u'08:00-08:00':
                    tekst = ''

                dzien = {'poz_grafiku_id'      : wiersz[kolumny['poz_grafiku_id']],
                          'imie'               : wiersz[kolumny['imie']],
                          'nazwisko'           : wiersz[kolumny['nazwisko']],
                          'stanowisko'         : wiersz[kolumny['stanowisko']],
                          'pracownik_id'       : wiersz[kolumny['pracownik_id']],
                          'nieobecnosc_za'     : wiersz[kolumny['nieobecnosc_za']],  #AB 29.08.21
                          'godz_nadliczbowe_od': wiersz[kolumny['godz_nadliczbowe_od']],  #AB 11.04.22r
                          'godz_nadliczbowe_do': wiersz[kolumny['godz_nadliczbowe_do']],  #AB 11.04.22r
                          'stanowisko_id'      : wiersz[kolumny['stanowisko_id']],
                          'tekst'              : tekst}
                if klucz in tmp:
                    tmp[klucz][wiersz[kolumny['dzien']]] = dzien
                else:
                    tmp[klucz] = {wiersz[kolumny['dzien']]: dzien}

            wyjscie = []
            for osoba in sorted(tmp):
                os       = tmp[osoba]
                wiersz   = [os.values()[0]['pracownik_id'], os.values()[0]['imie'], os.values()[0]['nazwisko'], os.values()[0]['stanowisko'], '', '', '']
                tmp_data = datetime.datetime.strptime(DataOd, '%Y-%m-%d')
                do       = datetime.datetime.strptime(DataDo, '%Y-%m-%d')
                ids      = {}
                while tmp_data <= do:
                    tekst = tmp_data.strftime("%d.%m")
                    if tekst in os:
                        wiersz.append(os[tekst]['tekst'])
                        ids[tekst]                  = os[tekst]['poz_grafiku_id']
                        ids['za'+tekst]             = os[tekst]['nieobecnosc_za']  #AB 29.08.21
                        ids['nadliczbowe_od'+tekst] = os[tekst]['godz_nadliczbowe_od']  #AB 11.04.22r
                        ids['nadliczbowe_do'+tekst] = os[tekst]['godz_nadliczbowe_do']  #AB 11.04.22r
                        ids['pracownik_id']         = os[tekst]['pracownik_id']
                        ids['stanowisko_id']        = os[tekst]['stanowisko_id']
                    else:
                        wiersz.append('')
                    tmp_data += datetime.timedelta(days=1)
                wiersz.append(ids)
                wyjscie.append(wiersz)
            dane = wyjscie
if dane is None:
    dane = []
