# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_grafik_rzeczywisty_eksport.py
# Purpose:     obsuga eksportugrafiku rzeczywistego
# Author:      Aleksander Bargie
# Created:     2022/06/27
# RCS-ID:      $Id: fs_kp_grafik_rzeczywisty_eksport.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

stat='OK'
puste = ('', None, 'None', 'NULL')  #AB 29.08.21
firma_id = self.firma_id

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'DataOdF': [1, 5, 15], 'DataDoF': [1, 5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista!='':
        stat='Uwaga : wywoanie funkcji fs_kp_grafik_rzeczywisty_eksport z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [5, ]:
        DataOd = rsglobal.Dekoduj(klucze['DataOdF'])
        DataDo = rsglobal.Dekoduj(klucze['DataDoF'])

dane = []
wyn1 = []
wyn2 = []


# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5-odczyt)
# -------------------------------------------------------------------------------

if Funkcja in (5, ) and stat == 'OK':
    """Zapytanie ma pobra dane do generowanego arkusza
    1 wiersz zawiersza wszystkie informacje o dniu - wyliczneia iloci godzin, nazw dnia tygodnia
    zczenia na dane osobowe pracownika(np. do pobrania nazwiska
    angae - czy jest zatrudniony, czy ma dobry rodzaj umowy, jakie stanowisko
    stanowiska pracy miejsca - opis"""

    SQL = """
        SELECT DISTINCT  g.pracownik_id, 0 AS nr_karty, o.nazwisko, o.imie, 
            CASE EXTRACT(DOW FROM COALESCE(fakt_czas_od, plan_czas_od)) WHEN 0 THEN 'Niedziela' WHEN 1 THEN 'Poniedziaek' WHEN 2 THEN 'Wtorek' 
                                                                        WHEN 3 THEN 'roda' WHEN 4 THEN 'Czwartek'
                                                                        WHEN 5 THEN 'Pitek' WHEN 6 THEN 'Sobota' END AS dzien_tygodnia,
            COALESCE(fakt_czas_od, plan_czas_od)::DATE AS DATA,
            CASE WHEN fakt_czas_do IS NULL THEN
                to_char(plan_czas_od, 'HH24:MI')
            ELSE
                CASE WHEN  fakt_czas_od IS NULL THEN
                    ''
                ELSE
                    to_char(fakt_czas_od, 'HH24:MI') 
                END
            END AS godz_rozpoczecia,
            CASE WHEN fakt_czas_do IS NULL THEN
                to_char(plan_czas_do, 'HH24:MI')
            ELSE
                CASE WHEN  fakt_czas_do IS NULL THEN
                    ''
                ELSE
                    to_char(fakt_czas_do, 'HH24:MI') 
                END
            END AS godz_zakonczenia,
            '' AS godz_50, '' AS godz_100, '' AS godz_nocne, '' AS godz_szkodliwe, nieobecnosc_za AS dw_za,
            CASE WHEN fakt_czas_od IS NULL THEN
                CASE WHEN plan_czas_od IS NULL THEN
                    INTERVAL '0 HOURS'
                ELSE
                    plan_czas_do - CASE WHEN plan_czas_od > plan_czas_do THEN plan_czas_od - INTERVAL '1 day' ELSE plan_czas_od END
                END
            ELSE
                fakt_czas_do - CASE WHEN fakt_czas_od > fakt_czas_do THEN fakt_czas_od - INTERVAL '1 day' ELSE fakt_czas_od END 
            END AS il_godz,
            CASE WHEN fakt_czas_od IS NULL THEN
                CASE WHEN plan_czas_od IS NULL THEN
                    INTERVAL '0 HOURS'
                ELSE
                    plan_czas_do - CASE WHEN plan_czas_od > plan_czas_do THEN plan_czas_od - INTERVAL '1 day' ELSE plan_czas_od END
                END
            ELSE
                fakt_czas_do - CASE WHEN fakt_czas_od > fakt_czas_do THEN fakt_czas_od - INTERVAL '1 day' ELSE fakt_czas_od END 
            END AS il_godz_przeprac, nieobecnosc_id AS typ_dnia, 
            s.opis AS stanowisko, s.kod as stanowisko_id, to_char(COALESCE(fakt_czas_od, plan_czas_od), 'DD.MM'),
            nieobecnosc, nieobecnosc_id, nieobecnosc_za, fakt_nieobecnosc, fakt_nieobecnosc_id, godz_nadliczbowe_od, godz_nadliczbowe_do,
            CASE WHEN fakt_nieobecnosc IS NULL THEN nieobecnosc ELSE fakt_nieobecnosc END, CASE WHEN fakt_nieobecnosc_id IS NULL THEN nieobecnosc_id ELSE fakt_nieobecnosc_id END,
            to_char(plan_czas_od, 'DD.MM') AS dzien_plan, to_char(plan_czas_od, 'HH24:MI') ||'-'|| to_char(plan_czas_do, 'HH24:MI') AS godziny_plan,
            (SELECT CASE WHEN czy_zwolnienie THEN 'zwolnienie' WHEN LOWER(nazwa) LIKE %s THEN 'urlop' ELSE NULL END 
             FROM rs_kp_absencje_rodzaje r WHERE r.firma_id=g.firma_id AND r.typ_absencji_id=g.nieobecnosc_id) as kolor
        FROM rs_kp_grafiki_pozycje g
            JOIN rs_kp_dane_osobowe o USING (firma_id, pracownik_id)
            JOIN rs_kp_zatrudnienie z ON (z.firma_id, z.pracownik_id) = (g.firma_id, g.pracownik_id)
            JOIN rs_kp_angaze a ON a.firma_id = z.firma_id AND a.pracownik_id = z.pracownik_id AND a.zatrudnienie_id = z.numer_id
                 AND a.umowa_id = (SELECT umowa_id
                                   FROM rs_kp_umowy_o_prace u2
                                   WHERE a.firma_id = u2.firma_id AND a.pracownik_id = u2.pracownik_id AND a.zatrudnienie_id = u2.zatrudnienie_id AND od_kiedy <= COALESCE(fakt_czas_od, plan_czas_od) AND (do_kiedy IS NULL OR do_kiedy >= COALESCE(fakt_czas_od, plan_czas_od)::DATE) AND u2.rodzaj_umowy_id = '01'
                                   ORDER BY u2.od_kiedy DESC LIMIT 1)
                 AND a.angaz_id = (SELECT max(angaz_id)
                                   FROM rs_kp_angaze a2
                                   WHERE a.firma_id = a2.firma_id AND a.pracownik_id = a2.pracownik_id AND a.zatrudnienie_id = a2.zatrudnienie_id  AND a2.umowa_id = a.umowa_id AND od_kiedy <= COALESCE(fakt_czas_od, plan_czas_od) AND (do_kiedy IS NULL OR do_kiedy >= COALESCE(fakt_czas_od, plan_czas_od)::DATE)
                                   )
            LEFT JOIN rs_kp_stanowiska_pracy_miejsca s ON (g.firma_id, COALESCE(g.fakt_stanowisko_miejsce_id, g.plan_stanowisko_miejsce_id)) = (s.firma_id, s.kod)
            """

    SQL += "\n WHERE g.firma_id=%s\n AND (plan_czas_od IS NOT NULL or fakt_czas_od IS NOT NULL) "
    SQL += "\n AND COALESCE(fakt_czas_od,  plan_czas_od)::DATE>=%s\n AND COALESCE(fakt_czas_od,  plan_czas_od)::DATE<=%s "
    SQL += "  AND upper(z.stan_pracownika_id) = upper('A')\n"
    SQL += "   ORDER BY o.nazwisko, o.imie, data;"
    args = ['%urlop%', firma_id, DataOd, DataDo]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, dane_wyk, wyn1_wyk, wyn2 = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SQL)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(SQL)
    else:
        SQL = """
            SELECT DISTINCT  g.pracownik_id, 0 AS nr_karty, o.nazwisko, o.imie, 
                CASE EXTRACT(DOW FROM plan_czas_od) WHEN 0 THEN 'Niedziela' WHEN 1 THEN 'Poniedziaek' WHEN 2 THEN 'Wtorek' 
                                                    WHEN 3 THEN 'roda' WHEN 4 THEN 'Czwartek'
                                                    WHEN 5 THEN 'Pitek' WHEN 6 THEN 'Sobota' END AS dzien_tygodnia,
                plan_czas_od::DATE AS DATA,
                to_char(plan_czas_od, 'HH24:MI') AS godz_rozpoczecia,
                to_char(plan_czas_do, 'HH24:MI') AS godz_zakonczenia,
                nieobecnosc_id AS typ_dnia, nieobecnosc_za AS dw_za,
                plan_czas_do - CASE WHEN plan_czas_od > plan_czas_do THEN plan_czas_od - INTERVAL '1 day' ELSE plan_czas_od END AS il_godz, 
                s.opis AS stanowisko, s.kod as stanowisko_id, to_char(plan_czas_od, 'DD.MM'),                                        
                nieobecnosc, nieobecnosc_id, nieobecnosc_za, godz_nadliczbowe_od, godz_nadliczbowe_do,
                nieobecnosc, nieobecnosc_id,
                to_char(plan_czas_od, 'DD.MM') AS dzien_plan, to_char(plan_czas_od, 'HH24:MI') ||'-'|| to_char(plan_czas_do, 'HH24:MI') AS godziny_plan,
                (SELECT CASE WHEN czy_zwolnienie THEN 'zwolnienie' WHEN LOWER(nazwa) LIKE %s THEN 'urlop' ELSE NULL END 
                    FROM rs_kp_absencje_rodzaje r WHERE r.firma_id=g.firma_id AND r.typ_absencji_id=g.nieobecnosc_id ) as kolor
            FROM rs_kp_grafiki_pozycje g
                JOIN rs_kp_dane_osobowe o USING (firma_id, pracownik_id)
                JOIN rs_kp_zatrudnienie z ON (z.firma_id, z.pracownik_id) = (g.firma_id, g.pracownik_id)
                JOIN rs_kp_angaze a ON a.firma_id = z.firma_id AND a.pracownik_id = z.pracownik_id AND a.zatrudnienie_id = z.numer_id
                     AND a.umowa_id = (SELECT umowa_id
                                       FROM rs_kp_umowy_o_prace u2
                                       WHERE a.firma_id = u2.firma_id AND a.pracownik_id = u2.pracownik_id AND a.zatrudnienie_id = u2.zatrudnienie_id AND od_kiedy <= plan_czas_od AND (do_kiedy IS NULL OR do_kiedy >= plan_czas_od::DATE) AND u2.rodzaj_umowy_id = '01'
                                       ORDER BY u2.od_kiedy DESC LIMIT 1)
                     AND a.angaz_id = (SELECT max(angaz_id)
                                       FROM rs_kp_angaze a2
                                       WHERE a.firma_id = a2.firma_id AND a.pracownik_id = a2.pracownik_id AND a.zatrudnienie_id = a2.zatrudnienie_id  AND a2.umowa_id = a.umowa_id AND od_kiedy <= plan_czas_od AND (do_kiedy IS NULL OR do_kiedy >= plan_czas_od::DATE)
                                       )
            LEFT JOIN rs_kp_stanowiska_pracy_miejsca s ON (g.firma_id, g.plan_stanowisko_miejsce_id) = (s.firma_id, s.kod)
            """

        SQL += "\n WHERE g.firma_id=%s\n AND plan_czas_od IS NOT NULL "
        SQL += "\n AND plan_czas_od::DATE>=%s\n AND plan_czas_od::DATE<=%s "
        SQL += "  AND upper(z.stan_pracownika_id) = upper('A')\n"
        SQL += "   ORDER BY o.nazwisko, o.imie, data;"
        args = ['%urlop%', firma_id, DataOd, DataDo]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, dane_plan, wyn1_plan, wyn2 = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(SQL)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            rsglobal.ZapiszDoLogow(stat)
            rsglobal.ZapiszDoLogow(SQL)
        else:
            dane = [(dane_plan, wyn1_plan), (dane_wyk, wyn1_wyk)]

