# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_historia_urlopow_dane
# Purpose:     dodawanie/edycja danych urlopu bezplatnego 
# Author:      Mariusz Rajfura
# Created:     2009/11/18
# RCS-ID:      $Id: fs_kp_historia_urlopow_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def SprNakladanieDat(self, Fun, Pracownik, OdKiedy, Data_Od, Data_Do):
    stat = 'OK'
    sql = ''

    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        sql ="SELECT od_kiedy FROM rs_kp_historia_bezplatnych"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND pracownik_id = '"+Pracownik+"' AND od_kiedy = '"+OdKiedy+"'"

        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        sql+=" AND ("
        sql+=" ( '"+Data_Od+"' > poczatek_przerwy AND '"+Data_Od+"' <= koniec_przerwy )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" OR ( poczatek_przerwy > '"+Data_Od+"' AND poczatek_przerwy <= '"+Data_Do+"' )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR ( koniec_przerwy >= '"+Data_Od+"' AND koniec_przerwy <= '"+Data_Do+"' )"

        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR ( '"+Data_Do+"' > poczatek_przerwy AND '"+Data_Do+"' <= koniec_przerwy)"
        sql+=");"

    #sprawdzenie unikalnosci zakresow przed UPDATE
    if Fun in (3,4):
        sql ="SELECT od_kiedy FROM rs_kp_historia_zatrudnienia"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND pracownik_id = '"+Pracownik+"' AND od_kiedy = '"+OdKiedy+"'"

        #wykluczenie z SELECT modyfikowanej pozycji
        sql+=" AND poczatek_przerwy <> '"+Data_Od+"' AND ("

        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" ( poczatek_przerwy > '"+Data_Od+"' AND poczatek_przerwy <= '"+Data_Do+"' )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR ( koniec_przerwy >= '"+Data_Od+"' AND koniec_przerwy <= '"+Data_Do+"' )"

        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR ( '"+Data_Do+"' > poczatek_przerwy AND '"+Data_Do+"' <= koniec_przerwy));"

    if sql <> '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pokrywania si zakresw dat w historii urlopw bezpatnych : '+stat

        if stat == 'OK':
            if len(d) > 0:
                stat = 'BL_POKRYWANIA_DAT'

    return stat

#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
OdKiedy = rsglobal.Dekoduj(klucze[1])
PoczatekPrzerwy = rsglobal.Dekoduj(klucze[2])

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','historia_zatrudnienia','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052062') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

KoniecPrzerwy = None

if Fun in (1,2) and stat == 'OK':
    if PoczatekPrzerwy == '    -  -  ':
        stat = 'BR_POCZATEK_PRZERWY'
        dane.append(stat)
    else:
        if not rsglobal.SprawdzCzyToData(PoczatekPrzerwy):
            stat = 'BL_POCZATEK_PRZERWY'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT poczatek_przerwy FROM rs_kp_historia_bezplatnych"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND od_kiedy = '"+OdKiedy+"' AND poczatek_przerwy = '"+PoczatekPrzerwy+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia urlopu bezpatnego w historii zatrudnienia : '+stat
        elif len(d) > 0:
            stat = 'BL_POCZATEK_PRZERWY_IST'

if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'poczatek_przerwy':
            wartosci[i] = "'"+wart+"'"

        elif pole == 'koniec_przerwy':
            if wart == '    -  -  ':
                dane.append('BR_KONIEC_PRZERWY')
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    KoniecPrzerwy = wart
                else:
                    dane.append('BL_KONIEC_PRZERWY')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'opis':
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                wartosci[i] = "'"+str(wart)+"'"

    if len(dane) > 0:
        stat = dane[0]

    if stat == 'OK':
        if Fun in (1,2) and KoniecPrzerwy in (None, '    -  -  '):
            stat = 'BR_KONIEC_PRZERWY'
            dane.append(stat)

    if stat == 'OK':
        if not KoniecPrzerwy in (None, '    -  -  '):
            if PoczatekPrzerwy > KoniecPrzerwy:
                stat = 'BL_POCZATEK_KONIEC_PRZERWY'
                dane.append(stat)

            if stat == 'OK':
                sql ="SELECT od_kiedy, do_kiedy FROM rs_kp_historia_zatrudnienia"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND od_kiedy = '"+OdKiedy+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania zakresu dat z zatrudnienia : '+stat
                else:
                    if len(d) <> 1:
                        stat = 'Brak podanej historii zatrudnienia.'
                    else:
                        if PoczatekPrzerwy < str(d[0][0]):
                            stat = 'BL_POCZATEK_OD_ZATRUD'
                            dane.append(stat)
                        else:
                            if KoniecPrzerwy > str(d[0][1]):
                                stat = 'BL_KONIEC_OD_ZATRUD'
                                dane.append(stat)    

            if stat == 'OK':
                stat = SprNakladanieDat(self, Fun, Pracownik, OdKiedy, PoczatekPrzerwy, KoniecPrzerwy)
                if stat <> 'OK':
                    dane.append(stat)

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = "firma_id,pracownik_id,od_kiedy,poczatek_przerwy"
    inswart = "'"+self.firma_id+"','"+Pracownik+"','"+OdKiedy+"','"+PoczatekPrzerwy+"'"

    for i in range(len(pola)):
        if pola[i] <> 'poczatek_przerwy':
            inspola += ","+pola[i]
            inswart += ","+wartosci[i]

    INSERT = "INSERT INTO rs_kp_historia_bezplatnych ("+inspola+") VALUES ("+inswart+");"
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)

    if stat <> 'OK':
        stat = 'Bd dodawania nowego urlopu bezpatnego do historii zatrudnienia : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_historia_bezplatnych SET "

    for i in range(len(pola)):
        UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE  = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    UPDATE += " AND od_kiedy = '"+OdKiedy+"' AND poczatek_przerwy = '"+PoczatekPrzerwy+"';"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd aktualizacji danych urlopu bezpatnego : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat == 'OK':
    SELECT ="SELECT * FROM rs_kp_historia_bezplatnych"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    SELECT+=" AND od_kiedy = '"+OdKiedy+"' AND poczatek_przerwy = '"+PoczatekPrzerwy+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych urlopu bezpatnego do historii zatrudnienia : '+stat
        dane.append(stat)
