# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_historia_zatrudnienia_dane
# Purpose:     dodawanie/edycja danych poprzedniego zatrudnienia 
# Author:      Mariusz Rajfura
# Created:     2009/10/16
# RCS-ID:      $Id: fs_kp_historia_zatrudnienia_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def SprNakladanieDat(self, Fun, Pracownik, Data_Od, Data_Do):
    stat = 'OK'
    sql = ''

    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        sql ="SELECT od_kiedy FROM rs_kp_historia_zatrudnienia"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND pracownik_id = '"+Pracownik+"'" 

        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        sql+=" AND ("
        sql+=" ( '"+Data_Od+"' > od_kiedy AND '"+Data_Od+"' <= do_kiedy )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" OR ( od_kiedy > '"+Data_Od+"' AND od_kiedy <= '"+Data_Do+"' )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR ( do_kiedy >= '"+Data_Od+"' AND do_kiedy <= '"+Data_Do+"' )"

        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR ( '"+Data_Do+"' > od_kiedy AND '"+Data_Do+"' <= do_kiedy)"
        sql+=");"

    #sprawdzenie unikalnosci zakresow przed UPDATE
    if Fun in (3,4):
        sql ="SELECT od_kiedy FROM rs_kp_historia_zatrudnienia"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND pracownik_id = '"+Pracownik+"'"

        #wykluczenie z SELECT modyfikowanej pozycji
        sql+=" AND od_kiedy <> '"+Data_Od+"' AND ("

        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" ( od_kiedy > '"+Data_Od+"' AND od_kiedy <= '"+Data_Do+"' )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR ( do_kiedy >= '"+Data_Od+"' AND do_kiedy <= '"+Data_Do+"' )"

        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR ( '"+Data_Do+"' > od_kiedy AND '"+Data_Do+"' <= do_kiedy));"

    if sql <> '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pokrywania si zakresw dat w historii zatrudnienia : '+stat

        if stat == 'OK':
            if len(d) > 0:
                stat = 'BL_POKRYWANIA_DAT'

    return stat

#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
OdKiedy = rsglobal.Dekoduj(klucze[1])

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','historia_zatrudnienia','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052053') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052052') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

DoKiedy = None

if Fun in (1,2) and stat == 'OK':
    if OdKiedy == '    -  -  ':
        stat = 'BR_OD_KIEDY'
        dane.append(stat)
    else:
        if not rsglobal.SprawdzCzyToData(OdKiedy):
            stat = 'BL_OD_KIEDY'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT od_kiedy FROM rs_kp_historia_zatrudnienia"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND od_kiedy = '"+OdKiedy+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia historii zatrudnienia : '+stat
        elif len(d) > 0:
            stat = 'BL_OD_KIEDY_IST'

if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'nazwa_firmy':
            if wart == '':
                dane.append('BR_NAZWA_FIRMY')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'od_kiedy':
            wartosci[i] = "'"+wart+"'"

        elif pole == 'do_kiedy':
            if wart == '    -  -  ':
                dane.append('BR_DO_KIEDY')
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    DoKiedy = wart
                else:
                    dane.append('BL_DO_KIEDY')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'zakonczenie_id':
            if wart == '':
                dane.append('BR_ZAKONCZENIE')
            else:
                sql ="SELECT kod FROM rs_sposoby_rozwiazania_umowy"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania kodu zakoczenia zatrudnienia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_ZAKONCZENIE')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'ubezpieczenie_id':
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                sql ="SELECT kod FROM rs_rodzaje_ubezpieczen"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania kodu ubezpieczenia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_UBEZPIECZENIE')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'dni_uw_wykorzystany':
            if wart < 0:
                dane.append('BL_DNI_UW_WYKORZYSTANY')
            wartosci[i] = str(wart)

        elif pole == 'dni_uw_na_zadanie':
            if wart < 0:
                dane.append('BL_DNI_UW_NA_ZADANIE')
            wartosci[i] = str(wart)

        elif pole == 'dni_choroby':
            if wart < 0:
                dane.append('BL_DNI_CHOROBY')
            wartosci[i] = str(wart)

        elif pole == 'dni_opieki':
            if wart < 0:
                dane.append('BL_DNI_OPIEKI')
            wartosci[i] = str(wart)

        elif pole == 'urlop_bezplatny':
            if wart < 0:
                dane.append('BL_URLOP_BEZPLATNY')
            wartosci[i] = str(wart)

        elif pole in ('panstwowa','ta_sama','branza','do_urlopu','do_stazu','do_jubileuszu','do_emerytury'):
            wartosci[i] = str(wart)

        else:
            #pozostale pola
            wartosci[i] = "'"+wart+"'"

    if len(dane) > 0:
        stat = dane[0]

    if stat == 'OK':
        if Fun in (1,2) and DoKiedy in (None, '    -  -  '):
            stat = 'BR_DO_KIEDY'
            dane.append(stat)

    if stat == 'OK':
        if not DoKiedy in (None, '    -  -  '):
            if OdKiedy > DoKiedy:
                stat = 'BL_OD_DO_KIEDY'
                dane.append(stat)

            if stat == 'OK':
                sql ="SELECT od_kiedy,poczatek_przerwy,koniec_przerwy FROM rs_kp_historia_bezplatnych"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
                sql+=" AND od_kiedy = '"+OdKiedy+"' AND ( poczatek_przerwy > '"+DoKiedy+"' OR koniec_przerwy > '"+DoKiedy+"' );"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia listy urlopw bezpatnych w podanym okresie zatrudnienia : '+stat
                elif len(d) <> 0:
                    stat = 'BL_URLOPY_POZA_ZAKRESEM'
                    dane.append(stat)

            if stat == 'OK':
                stat = SprNakladanieDat(self, Fun, Pracownik, OdKiedy, DoKiedy)
                if stat <> 'OK':
                    dane.append(stat)

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = "firma_id,pracownik_id,od_kiedy"
    inswart = "'"+self.firma_id+"','"+Pracownik+"','"+OdKiedy+"'"

    for i in range(len(pola)):
        if pola[i] <> 'od_kiedy':
            inspola += ","+pola[i]
            inswart += ","+wartosci[i]

    INSERT = "INSERT INTO rs_kp_historia_zatrudnienia ("+inspola+") VALUES ("+inswart+");"
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowej historii zatrudnienia : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_historia_zatrudnienia SET "

    for i in range(len(pola)):
        UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND od_kiedy = '"+OdKiedy+"';"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd aktualizacji danych historii zatrudnienia : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat == 'OK':
    Zakonczenie = ''
    Ubezpieczenie = ''

    SELECT ="SELECT * FROM rs_kp_historia_zatrudnienia"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND od_kiedy = '"+OdKiedy+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych historii zatrudnienia : '+stat
        dane.append(stat)

    if stat == 'OK':
        for i in xrange(len(dane[0])):
            pole = wyn1[i][0]
            wart = str(dane[0][i])

            if pole == 'zakonczenie_id':
                if (self.oddzial_id,'011780') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_sposoby_rozwiazania_umowy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        Zakonczenie = 'Bd pobrania opisu ze sownika rozwiza umowy o prac : '+stat
                    else:
                        if len(d) == 0:
                            Zakonczenie = 'Bdny kod zakoczenia rozwizania umowy o prac.'
                        else:
                            Zakonczenie = str(d[0][0])
                else:
                    Zakonczenie = 'Brak uprawnie do sownika. Poinformuj administratora.'

            if pole == 'ubezpieczenie_id' and wart <> 'None':
                if (self.oddzial_id,'011790') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_rodzaje_ubezpieczen WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        Ubezpieczenie = 'Bd pobrania opisu ze sownika kodw ubezpiecze : '+stat
                    else:
                        if len(d) == 0:
                            Ubezpieczenie = 'Bdny kod ubezpieczenia.'
                        else:
                            Ubezpieczenie = str(d[0][0])
                else:
                    Ubezpieczenie = 'Brak uprawnie do sownika. Poinformuj administratora.'

    wyn2 = [Zakonczenie,Ubezpieczenie]
