# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_kalendarze.py
# Purpose:     grid z kalendarzami czasu pracy
# Author:      Pawe Wjcikowski
# Created:     2010/08/03
# RCS-ID:      $Id: fs_kp_kalendarze.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-02-12 Mariusz Rajfura  pobranie opisu kalendarza (3951)
# 2013-03-11 Mariusz Rajfura  (6654) nowy parametr filtru: typ
# 2017-04-20 Piotr Witkowski (10459) [KP] - Kalendarze przyciski+refaktoryzacja

stat='OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Kalendarz':[6,9],'Klucze_Id':[6],'KluczS':[8],'KluczN':[8],
           'KalendarzF':[5,6,],'NazwaF':[5,6,],'WzorcowyF':[5,6,],'TypF':[5,6,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_kp_kalendarze z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [6,9,]:
            Kalendarz = str(klucze['Kalendarz'])
        if Funkcja in [5,6,]:
            Klucze_Id = klucze['Klucze_Id']
            KalendarzF = klucze['KalendarzF']
            NazwaF = klucze['NazwaF']
            WzorcowyF = klucze['WzorcowyF']
            TypF = klucze['TypF']
        elif Funkcja in [8,]:
            KluczS = klucze['KluczS']
            KluczN = klucze['KluczN']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

    UprPrzegladanie=((self.oddzial_id,'051030') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    UprDodawanie = (((self.oddzial_id,'051033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprUsuwanie = ((self.oddzial_id,'051034') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- POBRANIE OPISU KALENDARZA - 9
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 9:
    sql="SELECT COALESCE(nazwa,''::TEXT) FROM rs_kp_kalendarze"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id='"+Kalendarz+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = u'Bd pobrania nazwy kalendarza: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- KOPIOWANIE - 8
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 8:
    if not UprDodawanie:
        stat=u'Brak uprawnie do kopiowania kalendarzy.'
    if stat == 'OK':
        sql= "SELECT kalendarz_id FROM rs_kp_kalendarze WHERE kalendarz_id='"+str(KluczN)+"'"
        sql+=" AND firma_id='"+self.firma_id+"';"
        stat,row,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = u'Bd pobrania danych kalendarza : '+stat
            dane.append(stat)
        elif row <> []:    
            stat="BL_ISTN1"   
            dane.append(stat)
            
    if stat=='OK':
        #insert kopiowanej pozycji do kalendarzy
        query1="INSERT INTO rs_kp_kalendarze (firma_id,kalendarz_id,nazwa,nr_placowy,"
        query1+="czy_wzorcowy,czy_ruch_ciagly,typ,liczba_dni_cyklu)"
        query1+=" SELECT firma_id,'"+str(KluczN)+"' ,nazwa,nr_placowy,"
        query1+=" 'False',czy_ruch_ciagly,typ,liczba_dni_cyklu FROM rs_kp_kalendarze " 
        query1+=" WHERE firma_id='"+self.firma_id+"'"  
        query1+=" AND kalendarz_id='"+str(KluczS)+"';"
        
        #insert zawartosci kalendarze_dni przypietych do danego kalendarza
        query1+="INSERT INTO rs_kp_kalendarze_dni (firma_id,kalendarz_id,dzien,od_kiedy1,do_kiedy1"
        query1+=" ,od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3,status_dnia,zmiana_id)"
        query1+=" SELECT dn.firma_id,'"+str(KluczN)+"',dn.dzien,dn.od_kiedy1,dn.do_kiedy1"
        query1+=" ,dn.od_kiedy2,dn.do_kiedy2,dn.od_kiedy3,dn.do_kiedy3,dn.status_dnia,dn.zmiana_id FROM rs_kp_kalendarze_dni dn" 
        query1+=" INNER JOIN rs_kp_kalendarze kal ON (kal.firma_id=dn.firma_id AND kal.kalendarz_id=dn.kalendarz_id)"
        query1+=" WHERE dn.firma_id='"+self.firma_id+"' AND dn.kalendarz_id='"+str(KluczS)+"';"                       
        stat,dump,dump,dump = self.PolSQL.Execute(query1 ,1) 
        if stat!="OK":
            stat=u'Bd kopiowania kalendarza : '+stat
            dane.append(stat)        


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania kalendarzy.'    
    if stat == 'OK':
        DELETE ="DELETE FROM rs_kp_kalendarze_dni"
        DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+str(Kalendarz)+"';"
        DELETE+=" DELETE FROM rs_kp_kalendarze"
        DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+str(Kalendarz)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat='Usunicie niemoliwe - dane wystpuj w innych tabelach. '
            dane.append(stat)


#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy kalendarzy
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in[5,6,]:
    if not UprPrzegladanie:
        stat='Brak uprawnie do przegldania kalendarzy.'
        dane.append(stat)
    FILTR ="(firma_id='"+self.firma_id+"'"
    if KalendarzF:
        FILTR += " AND kalendarz_id LIKE '"+str(KalendarzF)+"%'"
    if NazwaF:
        FILTR += " AND nazwa LIKE '"+str(NazwaF)+"%'"
    if WzorcowyF:
        FILTR += " AND czy_wzorcowy="+str(WzorcowyF)
    if TypF:
        FILTR += " AND typ='"+str(TypF)+"'"
    FILTR += ")"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR+= " OR (firma_id = '"+self.firma_id+"' AND kalendarz_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"

    SELECT ="SELECT kalendarz_id,nazwa,czy_wzorcowy,czy_ruch_ciagly"
    SELECT+=" FROM rs_kp_kalendarze WHERE "+FILTR+" ORDER BY kalendarz_id,nazwa;"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy kalendarzy : '+stat
        dane.append(stat)
