# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_kalendarze_dane
# Purpose:     dodawanie/edycja danych o kalendarzach czasu pracy
# Author:      Pawe Wjcikowski
# Created:     2010/08/03
# RCS-ID:      $Id: fs_kp_kalendarze_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-03-08 Mariusz Rajfura (6658) nowe pole 'typ'

IdKalendarza = rsglobal.Dekoduj(klucze[0])
Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
IdKalendarzaF=IdKalendarza

UprDodawanie = (((self.oddzial_id,'051033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'051032') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN  
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
        

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)  
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':       
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]     
        if pole == 'kalendarz_id':
            if wart <> '':
                if len(wart)>15:
                    dane.append('BL DL_ID')
                else:
                    SELECT ="SELECT * FROM rs_kp_kalendarze"
                    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+str(wart)+"';"
                    st,Dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
                    if st <> 'OK':
                        stat = 'Bd sprawdzania danych kalendarza : '+stat
                        dane.append(stat)                                        
                    elif len(Dane)>0:
                        stat = 'KAL JEST'
                        dane.append(stat)   
                                                 
                IdKalendarzaF=wart 
            else:    
                stat='BR ID'
                dane.append(stat)  
        elif pole == 'nazwa':
            if wart <> '':
                if len(wart)>40:
                    dane.append('BL DL_NAZWA')
            else:    
                stat='BR NAZWA'
                dane.append(stat)  

        elif pole == 'typ':
            if wart <> '':
                sql="SELECT kod FROM rs_kalendarze_typy WHERE kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia typu kalendarza: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL TYP'
                    dane.append(stat)
           
    if len(dane) > 0:
        stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    ins = "INSERT INTO rs_kp_kalendarze"
    Pola="firma_id,kalendarz_id"
    Wartosci="'"+self.firma_id+"','"+IdKalendarza+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]        
        if pole in ['nazwa']:
            Pola= Pola+","+pole
            if wart.strip()=='' or wart=='    -  -  ':
                Wartosci= Wartosci+",NULL"                
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'" 
        elif pole in ['nr_placowy','czy_wzorcowy','czy_ruch_ciagly','typ','liczba_dni_cyklu']:
            Pola= Pola+","+pole
            if wart=='':
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'"                            
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"           
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat = 'Bdy dodawania danych:'+stat
        dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_kalendarze SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'typ':
            if wart == '':
                wart = "NULL"
            else:
                wart = "'"+wart+"'"
            UPDATE += pole+"="+str(wart)+","
        else:
            UPDATE += pole+"='"+str(wart)+"',"
            
    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+str(IdKalendarza)+"'; "   
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji kalendarza : '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT kalendarz_id,nr_placowy,nazwa,czy_wzorcowy,czy_ruch_ciagly,typ,liczba_dni_cyklu FROM rs_kp_kalendarze"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id='"+IdKalendarzaF+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o kalendarzach : '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] typ kalendarza - opis
        if tr.GetVal(0,"typ") <> 'None':
            if (self.oddzial_id,'211070') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT opis FROM rs_kalendarze_typy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"typ")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu typu kalendarza ze sownika: '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod typu')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')
