# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_kartoteka_osobowe.py
# Purpose:     kartoteki osobowe kadr/plac - grid: usuw,przegl,wybor,pobr.opisu
# Author:      Mariusz Rajfura
# Created:     2009/09/11
# RCS-ID:      $Id: fs_kp_kartoteka_osobowa.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2016-10-18 - Marcin Natkaski - pobranie dodatkowych danych pracownika
# 2017-11-24 Piotr Witkowski (10810) Refaktoryzacja kartoteki osobowej
# 2018-08-03 Aleksander Bargie (11064) Kartoteka osobowa grid gwny - bdne wartoci w kolumnach Komrka i stan
# 2019-04-24 Wojciech Skowron (11476) Pobieranie nowo dodanych osb nawet gdy nie speniaj wymaga filtrw
# 2023-05-23 Jan Raburski (     ) Dodatkowy filtr na pracownikow


stat = 'OK'
if 'Funkcja' not in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar = {
        'Pracownik': [6, 9, 10],

        'PracownikF': [5, 6],
        'NazwiskoF': [5, 6],
        'ImieF': [5, 6],
        'KomorkaF': [5, 6],
        'StanF': [5, 6],
        'RodzajF': [5, 6],
        'PracownicyF': [5, 6],

        'Klucze_Id': [5, 6, 10],
    }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista!='':
        stat = 'Uwaga : wywoanie funkcji fs_kp_kartoteka_osobowa z numerem ' 
        stat += str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [6, 9, 10]:
        Pracownik = klucze['Pracownik']
    if Funkcja in [5, 6]:
        PracownikF = klucze['PracownikF']
        NazwiskoF = klucze['NazwiskoF']
        ImieF = klucze['ImieF']
        KomorkaF = klucze['KomorkaF']
        StanF = klucze['StanF']
        RodzajF = klucze['RodzajF']
        PracownicyF = klucze['PracownicyF']
    if Funkcja in [5, 6, 10]:
        Klucze_Id = klucze['Klucze_Id']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    UprUsuwanie = (
        ((self.oddzial_id, '052014') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)

# -------------------------------------------------------------------------------
# Pobranie dodatkowych informacji o pracowniku - 10
# -------------------------------------------------------------------------------

if Funkcja == 9:
    Pracownik = ('000000' + str(Pracownik))[-6:]
    sql = "SELECT nazwisko,imie FROM rs_kp_dane_osobowe"
    sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(d) > 0:
            dane.append(d[0][0].strip() + ' ' + d[0][1].strip())
        else:
            dane.append('Bdny nr pracownika')
    else:
        dane.append('Bd pobrania opisu pracownika')

# -------------------------------------------------------------------------------
# Pobranie opisu pracownika - 10
# -------------------------------------------------------------------------------

if Funkcja == 10:
    Pracownik = ('000000' + str(Pracownik))[-6:]
    sql = "SELECT nazwisko,imie FROM rs_kp_dane_osobowe"
    sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(d) > 0:
            dane.append(d[0][0].strip() + ' ' + d[0][1].strip())
        else:
            dane.append('Bdny nr pracownika')
    else:
        dane.append('Bd pobrania opisu pracownika')

    if stat == 'OK':
        # Pobieramy najstarsz aktywn umowe
        SQL = " SELECT min(data_zawarcia) FROM rs_kp_umowy_o_prace WHERE firma_id = '" + self.firma_id + "' "
        SQL += " AND pracownik_id = '" + Pracownik + "' AND (do_kiedy>=current_date or do_kiedy is null) "
        stat, data_zatrudnienia, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            dane.append('Bdy pobierania daty pocztkowej umowy' + stat)

    if stat == 'OK':
        # Pobieramy stanowisko i wynagrodzenia, ze wszystkich aktywnych angazy
        SQL = " SELECT a.stanowisko_id, b.opis, a.placa FROM rs_kp_angaze a INNER JOIN rs_stanowiska_pracy b "
        SQL += " ON(a.firma_id = '" + self.firma_id + "' "
        SQL += " AND b.firma_id = '" + self.firma_id + "' AND a.stanowisko_id = b.kod "
        SQL += " AND a.pracownik_id = '" + Pracownik + "') "
        SQL += " WHERE (a.do_kiedy >= current_date or a.do_kiedy is null) "
        stat, stanowisko_placa, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            dane.append('Bdy pobierania daty pocztkowej umowy' + stat)

    if stat == 'OK':
        # Ukadamy wszystko w fajny komunikat do wywietlenia na kliencie
        komunikat = u"Data zawarcia najstarszej, aktywnej umowy: " + str(data_zatrudnienia[0][0]) + "\n\n"
        komunikat += u"Stanowiska i zarobki pracownika:\n"
        for i in stanowisko_placa:
            komunikat += "    " + i[0].rjust(10) + "   " + i[1].rjust(30) + "   " + str(i[2]).rjust(15) + " PLN\n"

        dane = komunikat

# -------------------------------------------------------------------------------
# DELETE - 6
# -------------------------------------------------------------------------------

if Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania kartotek osobowych.'

    if stat == 'OK':
        sql = "SELECT rsf_kadry_dozwolony_modul('" + self.firma_id + "','" + str(
            self.operator_id) + "','kartoteka_osobowa','" + Pracownik + "');"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)

    if stat == 'OK':
        stat = d[0][0]

    if stat == 'OK':
        sql = "SELECT pracownik_id FROM rs_kp_dane_osobowe"
        sql += " WHERE firma_id = '" + self.firma_id + "' "
        sql += " AND pracownik_id = '" + Pracownik + "' FOR UPDATE NOWAIT;"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji z kartoteki osobowej : ' + stat
        elif len(d) == 0:
            stat = 'Osoba o podanym numerze nie istnieje.'

        if stat == 'OK':
            sql = "SELECT numer_id FROM rs_kp_zatrudnienie"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o zatrudnieniu dla pracownika : ' + stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej zapisy dotyczce zatrudnienia (' + str(len(d)) + ').'

        if stat == 'OK':
            sql = "SELECT umowa_id FROM rs_kp_umowy_o_prace"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o umowach pracy dla pracownika : ' + stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej umowy o prac (' + str(len(d)) + ').'

        if stat == 'OK':
            sql = "SELECT od_kiedy FROM rs_kp_historia_zatrudnienia"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o historii zatrudnienia dla pracownika : ' + stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej zapisy w historii zatrudnienia (' + str(len(d)) + ').'

        if stat == 'OK':
            sql = "SELECT angaz_id FROM rs_kp_angaze"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o angaach dla pracownika : ' + stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej angae (' + str(len(d)) + ').'

        if stat == 'OK':
            DELETE = "DELETE FROM rs_kp_dane_osobowe"
            DELETE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"

            stat, d, dump, dump = self.PolSQL.Execute(DELETE, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                if "NARUSZA KLUCZ OBCY" in stat.upper() or "FOREIGN KEY" in stat.upper():
                    stat = 'Nie mona usun osoby, poniewa moe wystpowa jej powizanie z innymi tabelami'
                else:
                    CzyDodawacBlad = False
                    stat = 'Bd usuwania kartoteki osobowej : ' + stat

# -------------------------------------------------------------------------------
# SELECT 5,6
# -------------------------------------------------------------------------------

if Funkcja in (5, 6) and stat == 'OK':
    #AB 03.08.18r Przebudowa kompletna selecta i filtrw
    FILTR = "d.firma_id = '" + self.firma_id + "'"
    #WS 2019-04-24
    Filtry = []
    if PracownikF != '':
        # FILTR += " AND d.pracownik_id = '" + PracownikF + "'"
        Filtry.append("d.pracownik_id = '" + PracownikF + "'")
    if NazwiskoF != '':
        # FILTR += " AND upper(nazwisko) LIKE upper('" + NazwiskoF + "%')"  #AB 2018-08-14
        Filtry.append("upper(nazwisko) LIKE upper('" + NazwiskoF + "%')"  )
    if ImieF != '':
        # FILTR += " AND upper(imie) LIKE upper('" + ImieF + "%')"    #AB 2018-08-14
        Filtry.append("upper(imie) LIKE upper('" + ImieF + "%')")
    if KomorkaF != '':
        # FILTR += " AND upper(a.komorka_id) = upper('" + KomorkaF + "')"   #AB 2018-08-14
        Filtry.append("upper(a.komorka_id) = upper('" + KomorkaF + "')")
    if StanF != '':
        # FILTR += " AND upper(z.stan_pracownika_id) = upper('" + StanF + "')"   #AB 2018-08-14
        Filtry.append("upper(z.stan_pracownika_id) = upper('" + StanF + "')")
    if RodzajF != '':
        # FILTR += " AND a.rodzaj_pracownika_id = '" + RodzajF + "'"
        Filtry.append("a.rodzaj_pracownika_id = '" + RodzajF + "'")
    if PracownicyF:
        # FILTR += " AND a.rodzaj_pracownika_id = '" + RodzajF + "'"
        Filtry.append("d.pracownik")

    #WS 2019-04-24
    if len(Filtry) > 0:
        FILTR += " AND ((" + " AND ".join(Filtry) + ")"
        if len(Klucze_Id) > 0:
            FILTR += " OR d.pracownik_id in ('" + "', '".join(Klucze_Id) + "')"
        FILTR += ")"

    FILTR +=  " AND rsf_kadry_dozwolony_pracownik(d.firma_id, '" + str(self.operator_id) +"', 'kartoteka_osobowa' "
    FILTR += " , d.pracownik_id,  a.zatrudnienie_id, a.umowa_id, a.angaz_id) = 'True' "

    # uzupelnienie podgladu o klucze nowe lub zmienione
    if stat == 'OK':

        # w miejsce przedprzedostatniego pustego pola zostanie po pobraniu listy pracownikow wpisany kod komorki
        # w miejsce przedostatniego pustego pola zostanie wpisany stan pracownika po pobraniu listy
        # w miejsce ostatniego pustego pola zostanie wpisany rodzaj pracownika po pobraniu listy
        SELECT = "SELECT d.pracownik_id, d.nazwisko, d.imie, a.komorka_id, z.stan_pracownika_id, a.rodzaj_pracownika_id"
        SELECT += """ FROM rs_kp_dane_osobowe d 
                      FULL OUTER JOIN rs_kp_zatrudnienie z USING (firma_id, pracownik_id) 
                      FULL OUTER JOIN rs_kp_angaze a ON a.firma_id = z.firma_id AND a.pracownik_id = z.pracownik_id AND a.zatrudnienie_id = z.numer_id 
                          AND a.umowa_id = (SELECT umowa_id 
                                            FROM rs_kp_umowy_o_prace u2 
                                            WHERE a.firma_id = u2.firma_id AND a.pracownik_id = u2.pracownik_id AND a.zatrudnienie_id = u2.zatrudnienie_id AND od_kiedy <= now() AND (do_kiedy IS NULL OR do_kiedy >= now()::DATE)
                                            ORDER BY u2.od_kiedy DESC LIMIT 1) 
                          AND a.angaz_id = (SELECT max(angaz_id) 
                                            FROM rs_kp_angaze a2 
                                            WHERE a.firma_id = a2.firma_id AND a.pracownik_id = a2.pracownik_id AND a.zatrudnienie_id = a2.zatrudnienie_id  AND a2.umowa_id = a.umowa_id AND od_kiedy <= now() AND (do_kiedy IS NULL OR do_kiedy >= now()::DATE)
                                            ) """
        SELECT += " WHERE " + FILTR + " ORDER BY pracownik_id;"
        rsglobal.ZapiszDoLogow(SELECT, 5)
        stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
        if stat != 'OK':
            stat = 'Bd pobrania listy kartotek osobowych : ' + stat
