# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_kartoteka_osobowa_dane
# Purpose:     edycja danych osobowych kartoteki kadr
# Author:      Mariusz Rajfura
# Created:     2009/09/12
# RCS-ID:      $Id: fs_kp_kartoteka_osobowa_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2020-10-02 Aleksander Bargie (12147) [KP] Ujednolicenie dokumentw tosamoci
# 2020-10-02 Aleksander Bargie (12145) [KP] Zmieni 'obywatelstwo' na 'obywatelstwo_kraj'
# 2021-08-03 Wojciech Skowron   (12586) Sprawdzenie unikalnoci UID karty
# 2022-11-04 Jan Raburski       (13231) Nie rezydent
# 2022-11-23 Aleksander Bargie (13257) Nowy sownik stay (Rodzaj numeru identyfikacyjnego) + wizualizacja na oknie

Pracownik = rsglobal.Dekoduj(klucze[0]).strip()
PominKontroleNipPesel = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','kartoteka_osobowa','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprEdycja = (((self.oddzial_id,'052012') in self.uprawnienia) or \
             ((self.oddzial_id,'052013') in self.uprawnienia) or \
             (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------
#ustawiam na poczatku stat != 'OK' jesli brak uprawnien do operacji zapisu,
#zeby nie sprawdzac danych, bo i tak nie mozna ich zapisac

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR_UPR_UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

DataUrodzenia = None
Pesel = None
UPDATE = "UPDATE rs_kp_dane_osobowe SET "

if stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i].lower()
        wart = wartosci[i]

        if pole == 'pracownik_id':
            continue

        elif pole == 'plec':
            if wart == '' and not self.UproszczoneKadry:
                dane.append('BR_PLEC')
            else:
                if wart not in ('K','M') and not (wart == '' and self.UproszczoneKadry):
                    dane.append('BL_PLEC')
            wart = "'"+wart+"'"

        elif pole == 'nazwisko':
            if wart == '' and not self.UproszczoneKadry:
                dane.append('BR_NAZWI')
            wart = "'"+wart+"'"

        elif pole == 'imie':
            if wart == '' and not self.UproszczoneKadry:
                dane.append('BR_IMIE')
            wart = "'"+wart+"'"

        elif pole == 'obywatelstwo_kraj':
            if wart == '':
                dane.append('BR_OBYWATELSTWO')
            else:
                sql ="SELECT 1 FROM rs_kraje "
                sql+=" WHERE kraj = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd sprawdzenia kodu kraju: '+stat)
                elif len(d) == 0:
                    dane.append('Niepoprawny kod kraju: '+wart)
                else:
                    wart = "'"+wart+"'"

        elif pole == 'dokument_id':
            if wart == '':
                wart = "NULL"
            else:
                sql ="SELECT 1 FROM rs_dokumenty_tozsamosci_typy "
                sql+=" WHERE kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd sprawdzenia typu dokumentu: '+stat)
                elif len(d) == 0:
                    dane.append('Niepoprawny typu dokumentu: '+wart)
                else:
                    wart = "'"+wart+"'"

        elif pole == 'rodzaj_numeru_ident':
            if wart == '':
                wart = "NULL"
            else:
                sql ="SELECT 1 FROM rs_kp_rodzaje_numeru_identyfikacyjnego "
                sql+=" WHERE kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd sprawdzenia rodzaju numeru identyfikacyjnego: '+stat)
                elif len(d) == 0:
                    dane.append('Niepoprawny rodzaj numeru identyfikacyjnego: '+wart)
                else:
                    wart = "'"+wart+"'"

        elif pole == 'nip':
            if wart != '':
                stat = rsglobal.SprNip(wart)
                if stat<>'OK':
                    dane.append(stat)
                else:
                    if not PominKontroleNipPesel:
                        #sprawdzam unikalnosc NIP w ramach kartoteki
                        sql ="SELECT pracownik_id, nazwisko, imie FROM rs_kp_dane_osobowe"
                        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id != '"+Pracownik+"' AND nip = '"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            dane.append('Bd sprawdzenia unikalnoci NIP-u : '+stat)
                        elif len(d) > 0:
                            for i in xrange(len(d)):
                                dane.append('Identyczny NIP posiada '+str(d[i][0])+'. '+str(d[i][1]).strip()+' '+str(d[i][2]).strip())
                wart = "'"+wart+"'"
            else:
                wart = 'NULL'

        elif pole == 'pesel':
            if wart != '':
                Pesel = wart
                stat = rsglobal.SprPesel(Pesel)
                if stat<>'OK':
                    dane.append(stat)
                else:
                    if not PominKontroleNipPesel:
                        #sprawdzam unikalnosc PESEL w ramach kartoteki
                        sql ="SELECT pracownik_id, nazwisko, imie FROM rs_kp_dane_osobowe"
                        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id != '"+Pracownik+"' AND pesel = '"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            dane.append('Bd sprawdzenia unikalnoci PESEL-u : '+stat)
                        elif len(d) > 0:
                            for i in xrange(len(d)):
                                dane.append('Identyczny PESEL posiada '+str(d[i][0])+'. '+str(d[i][1]).strip()+' '+str(d[i][2]).strip())
                wart = "'"+wart+"'"
            else:
                wart = 'NULL'

        elif pole == 'data_urodzenia':
            if wart == '    -  -  ':
                if not self.UproszczoneKadry:
                    dane.append('BR_DATA_URODZ')
                else:
                    wart = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    DataUrodzenia = wart
                    #minimalny, sensowny wiek, to ok 15 lat np.praktykanci/praktykantki
                    if int(DataUrodzenia[:4]) > int(rsglobal.PodajDzis()[:4])-14:
                        dane.append('BL_DATA_URODZ_ABSURD')
                else:
                    dane.append('BL_DATA_URODZ')
            wart = "'"+wart+"'" if wart != 'NULL' else wart

        elif pole == 'dokument_data_waznosci':#AB 02.10.20r
            if wart != '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DOK_DATA')
                wart = "'"+wart+"'"
            else:
                wart = 'NULL'

        #WS 2021-08-03
        elif pole == 'uid_karty':
            if wart.strip() != '':
                #sprawdzam unikalnosc UID karty w ramach kartoteki
                sql ="SELECT pracownik_id, nazwisko, imie FROM rs_kp_dane_osobowe"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id != '"+Pracownik+"' AND uid_karty = '"+wart.strip()+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd sprawdzenia unikalnoci UID karty : '+stat)
                elif len(d) > 0:
                    for i in xrange(len(d)):
                        dane.append('Identyczny UID karty posiada '+str(d[i][0])+'. '+str(d[i][1]).strip()+' '+str(d[i][2]).strip())

                wart = "'"+wart+"'"
            else:
                wart = "NULL"
                
        elif pole in ['pracownik','udzialowiec', 'akcjonariusz', 'nie_rezydent', 'rada_nadzorcza','bofp','inny']:
            wart = "'"+str(wart)+"'"
            
        else:
            #pozostale pola
            wart = "'"+wart+"'"

        UPDATE += pole+"="+wart+","
    
    if len(dane) > 0:
        stat = dane[0]

if stat == 'OK' and DataUrodzenia != None and Pesel != None:
    if not rsglobal.SprPeselZData(Pesel, DataUrodzenia):
        stat = 'BL_DATA_URODZ_PESEL'
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat != 'OK':
        stat = 'Bd aktualizacji danych osobowych : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,5) and stat=='OK':
    SELECT="SELECT * FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych osobowych : '+stat
        dane.append(stat)
