# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_kartoteka_osobowa_klucz
# Purpose:     dodawanie pracownika
# Author:      Mariusz Rajfura
# Created:     2009/09/23
# RCS-ID:      $Id: fs_kp_kartoteka_osobowa_klucz.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2020-02-10 Aleksander Bargie (11849) Dodawanie pracownika bez obowizkowych pl nawet jeli kadry nieuproszczone.
# 2020-10-15 Aleksander Bargie (12165) [SPC] Nie da si doda pracownika w kartotece osobowej.
# 2023-05-17 Jan Raburski (13422) Uproszczone wprowadzanie tylko udziaowca

# funkcje:
# 1 - dodawanie pracownika
# 6 - usuwanie pracownika
# 10 - sprawdzenie uprawnien uzytkownika
# 11 - podaj pierwszy wolny numer ewidencyjny

Fun = klucze[-1]
if Fun != 11:
    Pracownik = klucze[0]
    Nazwisko = rsglobal.Dekoduj(klucze[1]).strip()
    Imie = rsglobal.Dekoduj(klucze[2]).strip()
if Fun == 1:  # wprowadzanie
    TylkoUdzialowiec = klucze[3]
    if TylkoUdzialowiec:
         DataOd = klucze[4]

stat = 'OK'
dane = []

UprDodawanie = (((self.oddzial_id,'052013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

rsglobal.ZapiszDoLogow("Odpalono fs_kp_kartoteka_osobowa_klucz funkcja {}".format(Fun))

#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien operatora do modulu kadrowego - 10
# funkcja wywolywana z innych modulow kadrowych, umiesczona tutaj,
# bo ilosc parametrow wywolania tego modulu od dluzszego czasu nie ulegla zmianie
# w przeciwienstwie do fs_kp_kartoteka_osobowa, gdzie ta funkcja byla wczesniej
#-------------------------------------------------------------------------------

if Fun == 10:
    Modul = rsglobal.Dekoduj(klucze[1])
    sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','"+Modul+"','"+str(Pracownik)+"');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia uprawnie do moduu '+Modul+' : '+stat

#-------------------------------------------------------------------------------
# Wczytanie pierwszego wolnego numeru - 11
# Podaje pierwszy wolny numer z uwzglednieniem "dziur"
#-------------------------------------------------------------------------------

if Fun == 11:
    sql ="SELECT pracownik_id FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' ORDER BY pracownik_id;"
    stat, prac, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Bd pobierania pierwszego wolnego numeru : ' + stat
    else:
        nr = 1
        for p in prac:
            if nr < int(p[0]):
                break
            nr += 1
        dane.append([nr])

#-------------------------------------------------------------------------------
# INSERT - 1
#-------------------------------------------------------------------------------

if Fun == 1:
    if not UprDodawanie:
        stat = 'Brak uprawnie do dodawania kartoteki.'
    
    if stat == 'OK':
        if Nazwisko == '':
            stat = 'Niewypenione nazwisko.'
        
    if stat == 'OK':
        if Imie == '':
            stat = 'Niewypenione imi.'

    if stat == 'OK':
        Modul = 'kartoteka_osobowa'
        sql = "SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','"+Modul+"','"+str(Pracownik)+"');"
        stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia uprawnie do moduu '+Modul+' : '+stat
        elif Fun == 1 and dane[0][0] != 'OK':
            stat = dane[0][0]

    if stat == 'OK':
        if Pracownik > 0:
            #sprawdzamy unikalnosc numeru w przypadku podania przez uzytkownika
            sql = "SELECT pracownik_id FROM rs_kp_dane_osobowe"
            sql += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik).zfill(6)+"';"

            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia numeru w kartotece osobowej : '+stat
            elif len(d) > 0:
                stat = 'Podany numer jest ju wykorzystany.'
        else:
            #z automatu szukamy nowego, maksymalnego numeru
            sql = "SELECT MAX(pracownik_id) FROM rs_kp_dane_osobowe WHERE firma_id = '"+self.firma_id+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania numeru z kartoteki osobowej: '+stat
            else:
                if d[0][0] in ['None','']:
                    Pracownik = 1
                else:
                    Pracownik = int(d[0][0])+1
    
    if Pracownik > 999999:
        stat = 'Przekroczony zakres numerw dla pracownikw'

    if stat == 'OK':  #AB 15.10.20r
        # INSERT = "INSERT INTO rs_kp_dane_osobowe (firma_id,pracownik_id,nazwisko,imie,narodowosc,obywatelstwo_kraj)"
        # INSERT += " VALUES ('"+self.firma_id+"','"+str(Pracownik).zfill(6)+"','"+Nazwisko+"','"+Imie+"','polska','PL');"
        if TylkoUdzialowiec:  # dodajemy zatrudnienie, umowe i angaz oraz kody do slownikow
            INSERT = "INSERT INTO rs_miejsca_pracy VALUES ('"+self.firma_id+"','UD','Udziaowcy tylko');"
            INSERT += "INSERT INTO rs_kp_stanowiska_pracy_miejsca VALUES ('"+self.firma_id+"','UD','Udziaowcy tylko');"
            INSERT += "INSERT INTO rs_stanowiska_pracy VALUES ('"+self.firma_id+"','UD','Udziaowcy tylko');"
            INSERT += "INSERT INTO rs_grupy_pracownikow VALUES ('"+self.firma_id+"','UD','Udziaowcy tylko');"
            INSERT += "INSERT INTO rs_komorki_zatrudniajace VALUES ('"+self.firma_id+"','UD','Udziaowcy tylko');"
            stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1)  # stat nas nie interesuje, kody moga juz byc
            INSERT = "INSERT INTO rs_kp_dane_osobowe (firma_id,pracownik_id,nazwisko,imie,pracownik,udzialowiec)"
            INSERT += " VALUES ('" + self.firma_id + "','" + str(Pracownik).zfill(6) + "','" + Nazwisko + "','" + Imie + "',False,True);"
            INSERT += "INSERT INTO rs_kp_zatrudnienie (firma_id,pracownik_id,numer_id, stan_pracownika_id)"
            INSERT += " VALUES ('" + self.firma_id + "','" + str(Pracownik).zfill(6) + "',1 ,'A');"
            INSERT += "INSERT INTO rs_kp_umowy_o_prace (firma_id,pracownik_id,zatrudnienie_id, umowa_id,od_kiedy)"
            INSERT += " VALUES ('" + self.firma_id + "','" + str(Pracownik).zfill(6) + "', 1, 1,'"+str(DataOd)+"');"
            INSERT += "INSERT INTO rs_kp_angaze (firma_id,pracownik_id,zatrudnienie_id, umowa_id, angaz_id,od_kiedy, "
            INSERT += " miejsce_id, stanowisko_miejsce_id, stanowisko_id, grupa_pracownikow_id, komorka_id)"
            INSERT += " VALUES ('" + self.firma_id + "','" + str(Pracownik).zfill(6) + "', 1, 1, 1,'"+str(DataOd) + "',"
            INSERT += "'UD', 'UD', 'UD', 'UD', 'UD');"
        else:  # normalny pracownik
            INSERT = "INSERT INTO rs_kp_dane_osobowe (firma_id,pracownik_id,nazwisko,imie,narodowosc)"
            INSERT += " VALUES ('"+self.firma_id+"','"+str(Pracownik).zfill(6)+"','"+Nazwisko+"','"+Imie+"','polska');"
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat != 'OK':
            stat = 'Bd dodawania nowej kartoteki osobowej : '+stat
            dane.append(stat)
        else:
            dane = [[str(Pracownik).zfill(6)]]

#-------------------------------------------------------------------------------
# DELETE - 6  #AB 10.02.20r
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprDodawanie:
        stat = 'Problem z uprawnieniami.'
    if stat == 'OK':
        DEL = "DELETE FROM rs_kp_dane_osobowe WHERE firma_id='{}' AND pracownik_id='{}';".format(self.firma_id, Pracownik)
        rsglobal.ZapiszDoLogow(DEL)
        stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1)
        if stat != 'OK':
            stat = 'Bd usuwania wpisu w kartotece osobowej: ' + stat
            dane.append(stat)
