# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kp_kluczowe_dane_pracownika.py
# Purpose:     wczytuje kluczowe dane pracownika pracownika#
# Author:      Mikoaj Kozowski
# Created:     2019/08/06
# RCS-ID:      $Id: fs_kp_kluczowe_dane_pracownika.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2020-10-02 (12146) Mikoaj Kozowski - Zmiana pola obywatelstwo na obywatelstwo_kraj + opis z rs_kraje
# 2020-10-02 (12148) Mikoaj Kozowski - Zmiana danych o dowodzie i paszporcie na dane o dokumencie tosamoci

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji dodatkowej w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {'Pracownik': [5, ],'Komorka': [5, ],'RodzajPrac': [5, ],}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_bilans_otwarcia z numerem ' + str(
            Funkcja) + ' bez parametrw: ' + Lista

    if stat == 'OK':
        if Funkcja in [5, ]:
            Pracownik = str(klucze['Pracownik'])
            Komorka = str(klucze['Komorka'])
            RodzajPrac = str(klucze['RodzajPrac'])
if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [5, ]:
    #sprawdzenie czy jest ju w tabeli
    sql ="""SELECT a.pracownik_id, nazwisko, imie, imie_drugie, imie_ojca, imie_matki, rodowe, rodowe_matki, miejsce_urodzenia,
    data_urodzenia, pesel, nip,
    (d.dokument_id || ' - ' || (SELECT opis FROM rs_dokumenty_tozsamosci_typy l WHERE l.kod=d.dokument_id)) AS dokument_id,
    dokument_nr, dokument_data_waznosci,
    zawod_wyuczony_id,(SELECT opis FROM rs_zawody p WHERE p.firma_id=d.firma_id AND p.kod=d.zawod_wyuczony_id) AS zawod_wyuczony_opis, wyksztalcenie_id,
     (SELECT opis FROM rs_wyksztalcenie q WHERE q.firma_id=d.firma_id AND q.kod=d.wyksztalcenie_id) AS wyksztalcenie_opis, czy_emeryt, nr_emerytury, oddzial_zus_id,
     (SELECT opis FROM rs_oddzialy_zus o WHERE o.firma_id=d.firma_id AND o.kod=d.oddzial_zus_id) AS oddzial_zus_opis, narodowosc,
     ( d.obywatelstwo_kraj || ' - ' || (SELECT nazwa FROM rs_kraje k WHERE k.kraj=d.obywatelstwo_kraj)) AS obywatelstwo_kraj,
       pracownik, udzialowiec, akcjonariusz, rada_nadzorcza, od_kiedy, do_kiedy, ( a.miejsce_id || ' - ' || (SELECT s.opis FROM rs_miejsca_pracy s WHERE s.firma_id=a.firma_id AND s.kod=a.miejsce_id)) AS miejsce_id,
( a.komorka_id || ' - ' || (SELECT c.opis FROM rs_komorki_zatrudniajace c WHERE c.firma_id=a.firma_id AND c.kod=a.komorka_id)) AS komorka_id,
( a.rodzaj_pracownika_id || ' - ' || (SELECT e.opis FROM rs_rodzaje_pracownikow e WHERE e.firma_id=a.firma_id AND e.kod=a.rodzaj_pracownika_id)) AS rodzaj_pracownika_id,
( a.grupa_pracownikow_id || ' - ' || (SELECT f.opis FROM rs_grupy_pracownikow f WHERE f.firma_id=a.firma_id AND f.kod=a.grupa_pracownikow_id)) AS grupa_pracownikow_id, etat, 
( a.stanowisko_id || ' - ' || (SELECT g.opis FROM rs_stanowiska_pracy g WHERE g.firma_id=a.firma_id AND g.kod=a.stanowisko_id)) AS stanowisko_id,
( a.zawod_wykonywany_id || ' - ' || (SELECT h.opis FROM rs_zawody_specjalnosci_klasyfikacja h WHERE h.firma_id=a.firma_id AND h.kod=a.zawod_wykonywany_id)) AS zawod_wykonywany_id,
kategoria_zaszeregowania, placa, stawka, dodatek_fun, ryczalt, dodatek1, dodatek2,
( a.kalendarz_id || ' - ' || (SELECT i.nazwa FROM rs_kp_kalendarze i WHERE i.firma_id=a.firma_id AND i.kalendarz_id=a.kalendarz_id)) AS kalendarz_id,
( a.lista_id || ' - ' || (SELECT j.opis FROM rs_kp_szablony_list_plac j WHERE j.firma_id=a.firma_id AND j.lista_id=a.lista_id)) AS lista_id,
    (SELECT min(od_kiedy) FROM rs_kp_umowy_o_prace z WHERE z.firma_id = a.firma_id AND z.pracownik_id = a.pracownik_id AND z.zatrudnienie_id=a.zatrudnienie_id
    AND (z.do_kiedy>=NOW()::DATE OR z.do_kiedy IS NULL)) AS data_aktualnego_zatrudnienia,
    (SELECT min(od_kiedy) FROM rs_kp_umowy_o_prace z WHERE z.firma_id = a.firma_id AND z.pracownik_id = a.pracownik_id) AS data_pierwszego_zatrudnienia, b.ubezpieczenie_id, b.staz_ogolem, b.staz_do_nagrody
    FROM rs_kp_dane_osobowe d    
    INNER JOIN rs_kp_angaze a
    USING (firma_id,pracownik_id)
    INNER JOIN rs_kp_zatrudnienie b
    ON  b.firma_id = a.firma_id AND b.pracownik_id = a.pracownik_id AND b.numer_id=a.zatrudnienie_id
    WHERE d.firma_id='{firma}' AND d.pracownik_id='{pracownik}' AND coalesce(komorka_id,'')='{komorka}' AND
    coalesce(rodzaj_pracownika_id,'')='{rodzaj}' AND od_kiedy<=NOW()::DATE AND (do_kiedy>=NOW()::DATE OR do_kiedy IS NULL)
    UNION
    SELECT pracownik_id, nazwisko, imie, imie_drugie, imie_ojca, imie_matki, rodowe, rodowe_matki, miejsce_urodzenia,
    data_urodzenia, pesel, nip,
     (d.dokument_id || ' - ' || (SELECT opis FROM rs_dokumenty_tozsamosci_typy l WHERE l.kod=d.dokument_id)) AS dokument_id,
     dokument_nr, dokument_data_waznosci,
    zawod_wyuczony_id,(SELECT opis FROM rs_zawody p WHERE p.firma_id=d.firma_id AND p.kod=d.zawod_wyuczony_id) AS zawod_wyuczony_opis, wyksztalcenie_id,
     (SELECT opis FROM rs_wyksztalcenie q WHERE q.firma_id=d.firma_id AND q.kod=d.wyksztalcenie_id) AS wyksztalcenie_opis, czy_emeryt, nr_emerytury, oddzial_zus_id,
     (SELECT opis FROM rs_oddzialy_zus o WHERE o.firma_id=d.firma_id AND o.kod=d.oddzial_zus_id) AS oddzial_zus_opis, narodowosc, 
     ( d.obywatelstwo_kraj || ' - ' || (SELECT nazwa FROM rs_kraje k WHERE k.kraj=d.obywatelstwo_kraj)) AS obywatelstwo_kraj,
     pracownik, udzialowiec, akcjonariusz, rada_nadzorcza, NULL AS od_kiedy,NULL AS do_kiedy,'' AS miejsce_id,'' AS komorka_id,'' AS rodzaj_pracownika_id,'' AS grupa_pracownikow_id,NULL AS etat,'' AS stanowisko_id,
    '' AS zawod_wykonywany_id,'' AS kategoria_zaszeregowania,NULL AS placa, NULL AS stawka,NULL AS dodatek_fun,NULL AS ryczalt,NULL AS dodatek1,NULL AS dodatek2,
    '' AS kalendarz_id,'' AS lista_id, NULL AS data_aktualnego_zatrudnienia, NULL AS data_pierwszego_zatrudnienia, '' AS ubezpieczenie_id, NULL AS staz_ogolem, NULL AS staz_do_nagrody
    FROM rs_kp_dane_osobowe d
    WHERE firma_id='{firma}' AND pracownik_id='{pracownik}' AND NOT EXISTS(SELECT 1 FROM rs_kp_angaze WHERE firma_id='{firma}' AND
    pracownik_id='{pracownik}' AND coalesce(komorka_id,'')='{komorka}' AND coalesce(rodzaj_pracownika_id,'')='{rodzaj}'
    AND od_kiedy<=NOW()::DATE AND (do_kiedy>=NOW()::DATE OR do_kiedy IS NULL))
    """.format(firma=self.firma_id, pracownik=Pracownik, komorka=Komorka, rodzaj=RodzajPrac)
    rsglobal.ZapiszDoLogow(sql)
    stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
    if stat<>'OK':
        stat="Bd przy pobraniu danych pracownika : "+stat
        dane.append(stat)



    if stat =='OK':
        sql="""SELECT r.opis AS typ_adresu, a.kraj_id, a.miejscowosc, a.ulica, a.nr_domu, a.nr_mieszkania, a.kod_pocztowy, a.poczta, a.telefon, a.email
        FROM rs_kp_adresy a
        INNER JOIN rs_rodzaje_adresow r
        ON a.adres_id = r.kod
        WHERE a.firma_id='{firma}' AND a.pracownik_id='{pracownik}'
        """.format(firma=self.firma_id, pracownik=Pracownik)
        stat, daneAdresy, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat<>'OK':
            stat="Bd przy pobraniu danych adresowych : "+stat
            dane.append(stat)
            #wyn2.append(daneAdresy)

    if stat == 'OK':
        sql="""SELECT lp_id, numer_rachunku FROM rs_kp_dane_osobowe_ror WHERE firma_id='{firma}' AND pracownik_id='{pracownik}'
            """.format(firma=self.firma_id, pracownik=Pracownik)
        stat, daneKonta, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = "Bd przy pobraniu danych kont bankowych : " + stat
            dane.append(stat)
            #wyn2.append(daneKonta)

    if stat == 'OK':
        sql="""SELECT r.pokrewienstwo_id, r.imie, r.nazwisko, s.opis AS pokrewienstwo, r.data_urodzenia, r.pesel, r.nip, r.ubezpieczony, r.ubezpieczony_od, r.ubezpieczony_do, r.czy_na_utrzymaniu
        FROM rs_kp_rodzina r
        INNER JOIN rs_stopnie_pokrewienstwa s
        ON r.pokrewienstwo_id = s.kod
        WHERE firma_id='{firma}' AND pracownik_id='{pracownik}'
        """.format(firma=self.firma_id, pracownik=Pracownik)
        stat, daneRodzina, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = "Bd przy pobraniu danych rodziny : " + stat
            dane.append(stat)
            #wyn2.append(daneRodzina)

    if stat == 'OK':
        sql="""SELECT angaz_id, od_kiedy, do_kiedy,
( a.miejsce_id || ' - ' || (SELECT s.opis FROM rs_miejsca_pracy s WHERE s.firma_id=a.firma_id AND s.kod=a.miejsce_id)) AS miejsce_id,
( a.komorka_id || ' - ' || (SELECT c.opis FROM rs_komorki_zatrudniajace c WHERE c.firma_id=a.firma_id AND c.kod=a.komorka_id)) AS komorka_id,
( a.rodzaj_pracownika_id || ' - ' || (SELECT e.opis FROM rs_rodzaje_pracownikow e WHERE e.firma_id=a.firma_id AND e.kod=a.rodzaj_pracownika_id)) AS rodzaj_pracownika_id,
( a.grupa_pracownikow_id || ' - ' || (SELECT f.opis FROM rs_grupy_pracownikow f WHERE f.firma_id=a.firma_id AND f.kod=a.grupa_pracownikow_id)) AS grupa_pracownikow_id,
( a.stanowisko_id || ' - ' || (SELECT g.opis FROM rs_stanowiska_pracy g WHERE g.firma_id=a.firma_id AND g.kod=a.stanowisko_id)) AS stanowisko_id,
( a.zawod_wykonywany_id || ' - ' || (SELECT h.opis FROM rs_zawody_specjalnosci_klasyfikacja h WHERE h.firma_id=a.firma_id AND h.kod=a.zawod_wykonywany_id)) AS zawod_wykonywany_id,
( a.kalendarz_id || ' - ' || (SELECT i.nazwa FROM rs_kp_kalendarze i WHERE i.firma_id=a.firma_id AND i.kalendarz_id=a.kalendarz_id)) AS kalendarz_id,
etat, kategoria_zaszeregowania, placa, stawka, dodatek_fun, ryczalt, dodatek1, dodatek2,
( a.lista_id || ' - ' || (SELECT j.opis FROM rs_kp_szablony_list_plac j WHERE j.firma_id=a.firma_id AND j.lista_id=a.lista_id)) AS lista_id
          FROM rs_kp_angaze a
          WHERE firma_id='{firma}' AND pracownik_id='{pracownik}' ORDER BY do_kiedy DESC
        """.format(firma=self.firma_id, pracownik=Pracownik)
        stat, daneAngaze, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = "Bd przy pobraniu listy angay : " + stat
            dane.append(stat)
            #wyn2.append(daneAngaze)

    if stat == 'OK':
        wyn2 = {}
        wyn2['daneAdresy'] = daneAdresy
        wyn2['daneKonta'] = daneKonta
        wyn2['daneRodzina'] = daneRodzina
        wyn2['daneAngaze'] = daneAngaze
