# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_listy_plac_klucz.py
# Purpose:     zapisuje now list pac
# Author:      Micha Raburski
# Created:     2015/11/02
# RCS-ID:      $Id: fs_kp_listy_plac_klucz.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-02-05 Jan Raburski Zmiana w sposobie dodawania listy (11390)
# 2022-01-31 Jan Raburski Blokada skladnikoww na przeomie angazy (12736)
# 2022-05-30 Aleksander Bargie W oknie z wyborem pracownikw przy dodawaniu angau doda kolumny komrka org i grupa (13043)
# 2023-05-17 Jan Raburski Powolywanie listy dla dywidendy (13424)


# FUNKCJE
# 1 - dodanie nowej listy pac
# 2 - uzupenienie listy o nowe angae
# 3 - uzupenienie listy o wybrane angaze
# 5 - pobranie angazy do wyboru


stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Szablon':[1,5],'DataOd':[1,],'DataDo':[1,],'GrupaPrac':[1,],'Komorka':[1,],'DataWyplaty':[1,],'PusteAngaze':[1,],'Lista':[2,3,5],'LAngaze':[3,]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_listy_plac_klucz z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5]:
            Szablon=str(klucze['Szablon'])
            GrupaPrac=str(klucze['GrupaPrac'])
            Komorka=str(klucze['Komorka'])
        if Funkcja == 1: 
            DataOd=str(klucze['DataOd'])
            DataDo=str(klucze['DataDo'])
            GrupaPrac=str(klucze['GrupaPrac'])
            Komorka=str(klucze['Komorka'])
            DataWyplaty=str(klucze['DataWyplaty'])
            PusteAngaze=klucze['PusteAngaze']
            Opis=klucze['Opis']
        if Funkcja in [2,3,5]:
            Lista = str(klucze['Lista'])
        if Funkcja == 3:
            LAngaze = klucze['LAngaze']
        if Funkcja == 5:
            Pracownik = klucze['Pracownik']
            CzyHistoria = klucze['CzyHistoria']

dane = []
wyn1 = []
wyn2 = []

UprDod=((self.oddzial_id,'062003') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-- POBRANIE ANGAY DO WYBORU PODCZAS DODAWANIA ANGAY DO LISTY (5)
#-------------------------------------------------------------------------------

if Funkcja == 5 and stat == 'OK':
    if not UprDod:
        stat = 'UPR DOD'
        
    if stat == 'OK':
        # pobranie danych listy
        SQL="SELECT data_od,data_do,COALESCE(grupa_pracownikow,''),COALESCE(komorka_id,'') FROM rs_kp_listy_plac "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id ='"+Lista+"' FOR UPDATE"
        stat,DLista,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat =' Bd pobrania danych listy:'+stat+' Moliwe, e jest przez kogo zablokowana - sprbuj jeszcze raz.'
        elif len(DLista) ==0:
            stat = 'Brak listy o numerze '+Lista
        else:
            DataOdL = DLista[0][0]
            DataDoL = DLista[0][1]
            GrupaPracL = DLista[0][2]
            KomorkaL = DLista[0][3]

    if stat =='OK':
        # pobranie ju istniejcych angay (by si nie dubloway)
        SQL = "SELECT DISTINCT pracownik_id,zatrudnienie_id,umowa_id,angaz_id FROM rs_kp_listy_plac_osoby"
        SQL+= " WHERE firma_id='"+self.firma_id+"' AND numer_listy_id='"+Lista+"'"
        stat,DListyAng,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat =' Bd pobrania danych angay z listy:'+stat
            
    if stat =='OK':
        # pobranie potencjalnych angay
        if CzyHistoria:
            PDataOd = " a.od_kiedy "
            PDataDo = " a.do_kiedy "
        else:
            PDataOd = " CASE WHEN '"+DataOdL+"'::DATE > a.od_kiedy THEN '"+DataOdL+"'::DATE ELSE a.od_kiedy END "
            PDataDo = " CASE WHEN '"+DataDoL+"'::DATE < a.do_kiedy OR a.do_kiedy IS NULL THEN '"+DataDoL+"'::DATE ELSE a.do_kiedy END "
        
        # FALSE z przodu - bo wiemy, e to suy do wybierania z listy
        SQL = "SELECT FALSE,a.pracownik_id,dos.imie,dos.nazwisko,a.zatrudnienie_id,a.umowa_id,a.angaz_id,"+PDataOd+","
        SQL += PDataDo+", komorka_id, grupa_pracownikow_id"  #AB 30.05.22r
        SQL += " FROM rs_kp_angaze a INNER JOIN rs_kp_dane_osobowe dos USING (firma_id,pracownik_id)"
        SQL += " WHERE a.firma_id='"+self.firma_id+"' "
        if Pracownik not in ('', '000000'):
            SQL += " AND a.pracownik_id = '"+Pracownik+"'"
        if not CzyHistoria:
            SQL += " AND a.od_kiedy <= '"+DataDoL+"' AND (a.do_kiedy IS NULL OR a.do_kiedy >= '"+DataOdL+"')"
        if Szablon != '':
            SQL+= " AND (a.lista_id='"+Szablon+"' OR a.lista_id IS NULL)"
        if GrupaPrac != '':
            SQL+= " AND a.grupa_pracownikow_id = '"+GrupaPrac+"'"
        if Komorka != '':
            SQL+= " AND a.komorka_id = '"+Komorka+"'"

        rsglobal.ZapiszDoLogow(100 * ' ' + SQL, 5)

        stat,DAngaze,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat =' Bd pobrania danych angay:'+stat

    
    # jeli sprawdzamy, ktre z podanych angay ju wystpuj na licie i te ignorujemy 
    if stat == 'OK':
        DAngazeTmp = []
        for angaz in DAngaze:
            if not [angaz[1],angaz[4],angaz[5],angaz[6]] in DListyAng:
                DAngazeTmp.append(angaz)
            rsglobal.ZapiszDoLogow(100 * ' ' + str(angaz), 5)
                    
        dane = eval(str(DAngazeTmp))
        rsglobal.ZapiszDoLogow(100 * ' ' + str(dane), 5)
                

#-------------------------------------------------------------------------------
#-- SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if not UprDod:
        stat = 'UPR DOD'
        
    if stat =='OK':
        if Szablon == '':
            dane.append('SZABLON BR')
        else:
            SQL="SELECT lista_id FROM rs_kp_szablony_list_plac WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"    
            stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat = u'Bd pobierania szablonu :'+stat
            elif len(wyn)==0:
                dane.append('SZABLON BL')
                
        if DataOd.strip() == '-  -':
            dane.append('DATAOD BR')
        elif not rsglobal.SprawdzCzyToData(DataOd):
            dane.append('DATAOD BL')
            
        if DataDo.strip() == '-  -':
            dane.append('DATADO BR')
        elif not rsglobal.SprawdzCzyToData(DataDo):
            dane.append('DATADO BL')
            
        if DataOd > DataDo:
            dane.append('DATAOD W DATADO')
            
        if GrupaPrac != '':
            SQL="SELECT kod FROM rs_grupy_pracownikow WHERE firma_id='"+self.firma_id+"' AND kod='"+GrupaPrac+"'"    
            stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat = u'Bd pobierania grupy pracownikw :'+stat
            elif len(wyn)==0:
                dane.append('GRUPAPRAC BL')

        if Komorka != '':
            SQL="SELECT kod FROM rs_komorki_zatrudniajace WHERE firma_id='"+self.firma_id+"' AND kod='"+Komorka+"'"
            stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat = u'Bd pobierania komrki zatrudniajcej :'+stat
            elif len(wyn)==0:
                dane.append('KOMORKA BL')
    
        if DataWyplaty.strip() == '-  -':
            dane.append('DATAWYPL BR')
        elif not rsglobal.SprawdzCzyToData(DataWyplaty):
            dane.append('DATAWYPL BL')
            
        # sprawdzenie czy jest tylko jedna wersja dla wybranego zakresu dat
        SQL= "SELECT data_od,COALESCE(data_do::TEXT,'brak') FROM rs_kp_szablony_list_plac_wersje "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
        SQL+=" AND data_od <= '"+DataOd+"' AND (data_do >= '"+DataDo+"' OR data_do IS NULL)"
        stat,DSzabl,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
        if stat != 'OK':
            stat = "Bd przy pobieraniu skadnikw z szablonu listy: "+stat   
        if stat == 'OK':
            if len(DSzabl) == 0:
                dane.append(u"Brak wersji szablonu "+Szablon+' dla dat '+DataOd+' - '+DataDo)
                
        if len(dane) > 0:
            stat = dane[0]
        
#-------------------------------------------------------------------------------
#-- DODANIE LISTY PAC (1), UZUPENIENIE ANGAY NA LICIE (2)
#-------------------------------------------------------------------------------


if Funkcja == 3 and stat =='OK':
    DAngaze = LAngaze

if Funkcja in [2,3] and stat =='OK':
    NrListy = Lista
    # pobranie dat i grupy pracownikw z listy
    SQL="SELECT lista_id,data_od,data_do,COALESCE(grupa_pracownikow,''),COALESCE(komorka_id,'') FROM rs_kp_listy_plac "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id ='"+Lista+"' FOR UPDATE"
    stat,DLista,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat =' Bd pobrania danych listy:'+stat+' Moliwe, e jest przez kogo zablokowana - sprbuj jeszcze raz.'
    elif len(DLista) ==0:
        stat = 'Brak listy o numerze '+Lista
    else:
        Szablon = DLista[0][0]
        DataOd = DLista[0][1]
        DataDo = DLista[0][2]
        GrupaPrac = DLista[0][3]
        if GrupaPrac == '':
            GrupaPrac = 'NULL'
        else:
            GrupaPrac = "'"+GrupaPrac+"'"
        Komorka = DLista[0][4]
        if Komorka == '':
            Komorka = 'NULL'
        else:
            Komorka = "'"+Komorka+"'"

    
if Funkcja == 1 and stat == 'OK':
    # numer w formacie RRRR/MM/NR
    #NrListy = DataWyplaty[:4]+'/'+DataWyplaty[5:7]+'/'
    NrListy = DataDo[:4]+'/'+DataDo[5:7]+'/'

    # blokada na numery list (od razu pobieram numery potencjalnych list)
    #SQL="SELECT SUBSTRING(numer_listy_id FROM 9)::INT FROM rs_kp_listy_plac "
    #SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id LIKE '"+NrListy+"%'"
    #SQL+=" ORDER BY SUBSTRING(numer_listy_id FROM 9)::INT DESC FOR UPDATE"
    SQL="SELECT SUBSTRING(numer_listy_id FROM 9) FROM rs_kp_listy_plac "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id LIKE '"+NrListy+"%'"
    SQL+=" ORDER BY SUBSTRING(numer_listy_id FROM 9) DESC FOR UPDATE"
    stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat =' Bd pobrania numeru nastpnej listy. Moliwe e wanie kto dodaje list. Sprbuj jeszcze raz.'+stat
    
    if stat == 'OK':
        if len(DNr) == 0:
            NrListy = NrListy+'001'
        else:
            try:
                NrPom = '00'+str(int(DNr[0][0])+1)
                NrListy = NrListy+NrPom[-3:]
            except:
                stat = 'Bd budowy klucza listy, ktry powinien koczy si liczb a koczy si '+DNr[0][0]

    if stat == 'OK':
        # pobranie informacji o polach dodatkowych z szablonu
        SQL = "SELECT do_deklaracji_zus_z_data_wyplaty,do_deklaracji_pit_z_data_wyplaty,COALESCE(tekst_na_przelewie,''),COALESCE(konto_id,''),czy_dywidenda"
        SQL+=" FROM rs_kp_szablony_list_plac WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
        stat,DSzablon,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat =' Bd pobrania danych szablonu:'+stat
        Dywidenda = DSzablon[0][4]
            
    if stat == 'OK':
        # wstawienie listy pac
        if GrupaPrac == '' or Dywidenda:
            GrupaPrac = 'NULL'
        else:
            GrupaPrac = "'"+GrupaPrac+"'"

        if Komorka == '' or Dywidenda:
            Komorka = 'NULL'
        else:
            Komorka = "'"+Komorka+"'"

        if DSzablon[0][3] == '':
            Konto = 'NULL'
        else:
            Konto = "'"+DSzablon[0][3]+"'"
        
        SQL=" INSERT INTO rs_kp_listy_plac (firma_id,numer_listy_id,lista_id,stan,"
        SQL+="grupa_pracownikow,data_wyplaty,data_od,data_do,do_deklaracji_zus_z_data_wyplaty,"
        SQL+="do_deklaracji_pit_z_data_wyplaty,tekst_na_przelewie,konto_id,opis,komorka_id) VALUES "
        SQL+=" ('"+self.firma_id+"','"+NrListy+"','"+Szablon+"','W',"
        SQL+=GrupaPrac+",'"+DataWyplaty+"','"+DataOd+"','"+DataDo+"',"+str(DSzablon[0][0])+","
        SQL+=str(DSzablon[0][1])+",'"+DSzablon[0][2]+"',"+Konto+",'"+Opis+"',"+Komorka+")"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat != 'OK':
            stat =' Bd wstawienia listy plac:'+stat
    
    # pobranie angay do listy
if Funkcja in [1, 2]:
    if stat == 'OK':
        if Szablon[0:3] == 'PIT':  # dodajemy wszystkich, ktrzy wystpili chocia raz na licie w roku dla PIT
            SQL = "SELECT DISTINCT lpo.pracownik_id, lpo.zatrudnienie_id, lpo.umowa_id, lpo.angaz_id, "
            SQL += " lpo.data_od, lpo.data_do, ang.grupa_pracownikow_id, ang.od_kiedy FROM rs_kp_listy_plac_osoby lpo "
            SQL += " INNER JOIN rs_kp_listy_plac lp USING(firma_id,numer_listy_id)"
            SQL += " INNER JOIN rs_kp_angaze ang USING(firma_id,pracownik_id,zatrudnienie_id,umowa_id,angaz_id)"
            SQL += " WHERE lpo.firma_id='" + self.firma_id + "' AND EXTRACT(YEAR FROM lp.data_wyplaty)=" + DataWyplaty[0:4]
            SQL += " ORDER BY lpo.pracownik_id, ang.od_kiedy DESC"
            stat, DPracownicy, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = ' Bd pobrania danych angay:'+stat
            else:
                #rsglobal.ZapiszDoLogow('pobrani pracownicy|'+GrupaPrac+'|'+str(DPracownicy))
                DAngaze = []
                prac = 'x'
                for p in DPracownicy:  # pracownicy moga sie powtarzac wiec eliminujemy powtorki
                    if p[0] == prac:
                        continue
                    if GrupaPrac == 'NULL':  # dla pustej grupy dodajemy angaz
                        DAngaze.append(p)
                    elif GrupaPrac.replace("'", "").strip() == p[6].strip():  # grupa sie zgadza dodajemy angaz
                        DAngaze.append(p)
                    prac = p[0]  # tak czy owak przechodzimy do nastepnego pracownika
                #rsglobal.ZapiszDoLogow('przesiani pracownicy|' + GrupaPrac + '|' + str(DAngaze))
        elif Dywidenda:  # dodajemy wszystkich, ktorzy maja zaznaczone 'udzialowiec' i sa aktywni
            PDataOd = " CASE WHEN '"+DataOd+"'::DATE > od_kiedy THEN '"+DataOd+"'::DATE ELSE od_kiedy END "
            PDataDo = " CASE WHEN '"+DataDo+"'::DATE < do_kiedy OR do_kiedy IS NULL THEN '"+DataDo+"'::DATE ELSE do_kiedy END "
            SQL = "SELECT pracownik_id,zatrudnienie_id,umowa_id,angaz_id,"+PDataOd+","+PDataDo+""
            SQL += " FROM rs_kp_angaze kpa"
            SQL += " INNER JOIN rs_kp_dane_osobowe USING(firma_id, pracownik_id)"
            SQL += " WHERE firma_id='"+self.firma_id+"' AND udzialowiec"
            SQL += " AND od_kiedy <= '"+DataDo+"' AND (do_kiedy IS NULL OR do_kiedy >= '"+DataOd+"')"
            SQL += " ORDER BY kpa.pracownik_id"
            stat, DPracownicy, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = ' Bd pobrania danych angay:'+stat
            else:
                DAngaze = []
                prac = 'x'
                for p in DPracownicy:  # pracownicy moga sie powtarzac wiec eliminujemy powtorki
                    if p[0] == prac:
                        continue
                    DAngaze.append(p)
                    prac = p[0]  # tak czy owak przechodzimy do nastepnego pracownika
        else:  # normalne listy
            PDataOd = " CASE WHEN '"+DataOd+"'::DATE > od_kiedy THEN '"+DataOd+"'::DATE ELSE od_kiedy END "
            PDataDo = " CASE WHEN '"+DataDo+"'::DATE < do_kiedy OR do_kiedy IS NULL THEN '"+DataDo+"'::DATE ELSE do_kiedy END "

            PusteAngazeF = "lista_id IS NULL"
            if Funkcja == 1 and not PusteAngaze:
                PusteAngazeF = "FALSE"

            SQL = "SELECT pracownik_id,zatrudnienie_id,umowa_id,angaz_id,"+PDataOd+","+PDataDo+""
            SQL += " FROM rs_kp_angaze WHERE firma_id='"+self.firma_id+"' AND (lista_id='"+Szablon+"' OR "+PusteAngazeF+")"
            SQL += " AND od_kiedy <= '"+DataDo+"' AND (do_kiedy IS NULL OR do_kiedy >= '"+DataOd+"')"
            if GrupaPrac != 'NULL':
                SQL += " AND grupa_pracownikow_id = "+GrupaPrac
            if Komorka != 'NULL':
                SQL += " AND komorka_id = " + Komorka
            stat, DAngaze, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = ' Bd pobrania danych angay:'+stat
    
# jeli uzupeniamy dane to sprawdzamy, ktre z podanych angay ju wystpuj na licie i te ignorujemy 
if stat == 'OK' and Funkcja in [2,3]:
    DAngazeTmp = []
    # pobieramy angaze  z listy
    SQL = "SELECT DISTINCT pracownik_id,zatrudnienie_id,umowa_id,angaz_id FROM rs_kp_listy_plac_osoby"
    SQL += " WHERE firma_id='"+self.firma_id+"' AND numer_listy_id='"+Lista+"'"
    stat, DListyAng, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = ' Bd pobrania danych angay z listy:' + stat
    if stat == 'OK':
        for angaz in DAngaze:
            if not [angaz[0],angaz[1],angaz[2],angaz[3]] in DListyAng:
                DAngazeTmp.append(angaz)
                
        DAngaze = eval(str(DAngazeTmp))
            
if stat == 'OK' and Funkcja in [1, 2, 3]:
    #JR 2022-01-31 (12736)
    # wywalenie rozbicia na daty wzgldem skadnikw pacowych. Te skadniki s oglne - wystarczy pobra dane dla dat z listy pac
    # zostao: wstawienie angazy na liste plac
    SQL = ''
    for angaz in DAngaze:
        SQL += "INSERT INTO rs_kp_listy_plac_osoby (firma_id,numer_listy_id,pracownik_id, "
        SQL += "zatrudnienie_id,umowa_id,angaz_id,data_od,data_do,przeliczony) "
        SQL += " VALUES ('"+self.firma_id + "','" + NrListy + "','" + angaz[0] + "',"
        SQL += str(angaz[1])+","+str(angaz[2])+","+str(angaz[3])+",'"+str(angaz[4])+"','"+str(angaz[5])+"',FALSE);"

    if SQL != '':
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = ' Bd wstawienia angay na list plac:' + stat



    if stat == 'OK':
        dane = [NrListy]