# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_praca_biezaca_absencje.py
# Purpose:     grid z absencjami pracy biecej
# Author:      Piotr Witkowski
# Created:     2015/11/02
# RCS-ID:      $Id: fs_kp_praca_biezaca_absencje.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2016-02-06 - Piotr Witkowski   (9554) Okno Edycja absencji pracownika - poprawki
# 2018-06-13  - Aleksander Bargie (11094) Poprawki w absencjach
# 2018-07-30 - Jan Raburski Otwieranie i zamykanie paczki
# 2018-08-28  - Aleksander Bargie (11198) uwala sie - BEETWEN na BETWEEN w LiczDniIGodzinyRobocze
# 2018-08-30  - Aleksander Bargie (11204) sort w praca biezaca absencje
# 2018-11-19  - Aleksander Bargie (11286) Praca bieca absencje - dodatkowy filtr na stan
# 2018-12-03  - Aleksander Bargie (11300) Zamykanie absencji sprawdza z datami listy pac a nie angau
# 2019-03-07  - Aleksander Bargie (11425) Praca bieca absencje - doda filtr na pracownika
# 2020-01-30  - Wojciech Skowron   (11829) Podzia absencji na urlopy i zwolnienia
# 2020-08-01  - Jan Raburski       (11946) Tworzenie BO dla urlopow
# 2021-03-16  - Aleksander Bargie (12395) Doda trim na imi i nazwisko
# 2023-08-28  - Jan Raburski (13512) - przejcie w dniach roboczych na kalendarz
# 2023-09-08  - Jan Raburski (13542) - blokada otwarcia paczki jesli lista nie jest w stanie 'W'

import datetime
import rsglobal
import rs_anakonda_daty
from funkcje import fs_kp_praca_biezaca_absencje_pom as abpom


#-------------------------------------------------------------------------------


stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']                                                    #AB 19.11.18r
    SlPar={'Komorka':[1,5,],'Grupa':[1,5,],'Opis':[1,],'DataOd':[5,],'DataDo':[5,],'FStan': [5, ],
                                                                                #AB 07.03.19r.
           'Data':[1,2,6,7], 'Oddzial':[1,2,6,7], 'Numer':[2,6,7], 'Stan':[6,7], 'Pracownik': [5, ],
           #WS 2020-01-30
           'Tryb':[1,2,5,6,7]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_praca_biezaca_absencje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5]:
            Komorka = str(klucze['Komorka'])
            Grupa = str(klucze['Grupa'])
        if Funkcja in [1,]:
            Opis = str(klucze['Opis'])
        if Funkcja in [5,]:
            DataOd = str(klucze['DataOd'])
            DataDo = str(klucze['DataDo'])
            #AB 19.11.18r
            FStan = str(klucze['FStan'])
            #AB 07.03.19r.
            Pracownik = str(klucze['Pracownik'])
        if Funkcja in [1,2,6,7]: 
            Data = str(klucze['Data'])
            Oddzial = str(klucze['Oddzial'])
        if Funkcja in [2,6,7]: 
            Numer = str(klucze['Numer'])          
        if Funkcja in [6,7]:  
            Stan = str(klucze['Stan'])
        if Funkcja in [1,2,5,6,7]:
            #WS 2020-01-30
            Tryb = klucze['Tryb']
        if Funkcja in [11,]:
            Rok = str(datetime.datetime.now().date())[0:4]

dane = []

#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprIns=(((self.oddzial_id,'056103') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprMod=(((self.oddzial_id,'056102') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprIns
UprDel=(((self.oddzial_id,'056104') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprOtw=(((self.oddzial_id,'056105') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZam=(((self.oddzial_id,'056106') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprBO =(((self.oddzial_id,'056106') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))  # jak dla zamykania

#-------------------------------------------------------------------------------
#---   DELETE (2)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,]:
    if not UprDel:
        stat=u'Brak uprawnie do usuwania'
    else:
        delete = "DELETE from rs_kp_absencje"
        delete += " WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial
        delete +="' AND data = '"+Data+"' AND numer='"+Numer+"';"
        #rsglobal.ZapiszDoLogow('zamkniecie absencji '+delete,1)
        if delete<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(delete),1)
            if stat<>'OK':
                stat=u'UPD BL$'+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT DANYCH 
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1,]:
    if not UprIns:
        stat=u'Brak uprawnie do dodawania'
    if stat=='OK':
        if str(Komorka).strip()=='':
            Komorka='Null'
        else:
            Komorka = "'"+str(Komorka)+"'"
        if str(Grupa).strip()=='':
            Grupa='Null'
        else:
            Grupa = "'"+str(Grupa)+"'"
        if str(Opis).strip()=='':
            Opis='Null'
        else:
            Opis = "'"+str(Opis)+"'"
        #WS 2020-01-30
        if Tryb == 1:
            Zwolnienie = 'False'
        else:
            Zwolnienie = 'True'
        sql = "INSERT INTO rs_kp_absencje(firma_id, oddzial_id, data, numer, komorka_id,"
        sql+= "stan, grupa_pracownikow_id, opis, zwolnienie)" #WS 2020-01-30 - zwolnienie
        sql+= " VALUES ('"+self.firma_id+"','"+Oddzial+"','"+str(Data)+"',"
        sql+= "COALESCE((SELECT Max(numer)+1 FROM rs_kp_absencje WHERE firma_id='"
        sql+= self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND data='"+str(Data)+"'),1),"
        sql+= str(Komorka)+",'W',"+str(Grupa)+","+str(Opis)+","+str(Zwolnienie)+");" #WS 2020-01-30 - zwolnienie
        #rsglobal.ZapiszDoLogow('sql absencji '+sql,1)
        if sql<>'' and stat=='OK':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1,CzyDodawacBlad=True)
            if stat<>'OK':
                #WS 2020-01-30
                if Tryb == 1:
                    stat = u'Bd dodawania urlopu' + stat
                else:
                    stat = u'Bd dodawania zwolnienia' + stat
                # stat=u'Bd dodawania absencji'+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   Czy mozna otworzyc ze wzgldu na list plac (7)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 7:
    #sql = u"SELECT 'Absencja pracownika: '||a.pracownik_id||' od '||a.data_od||' do '||a.data_do||"
    #sql +=u"' nakada si na istniejc list pac numer '||l.numer_listy_id||' od '||l.data_od||' do '||l.data_do"
    ##AB 03.12.18r
    #sql += u" FROM rs_kp_absencje_pozycje a, rs_kp_listy_plac_osoby lo JOIN rs_kp_listy_plac l USING (firma_id, numer_listy_id) WHERE a.firma_id = '"+self.firma_id+u"'"
    #sql += u" AND a.firma_id=l.firma_id AND a.pracownik_id=lo.pracownik_id "
    #sql += u" AND a.oddzial_id='"+Oddzial+u"' AND a.data='"+Data+u"' AND a.numer='"+Numer+"'"
    ##sql += u" AND ((a.data_od BETWEEN l.data_od AND LEAST(l.data_do, l.data_wyplaty)) OR (a.data_do BETWEEN l.data_od AND LEAST(l.data_do,l.data_wyplaty)));"
    #sql += u" AND ((a.data_do BETWEEN l.data_od AND LEAST(l.data_do,l.data_wyplaty)));"
    #JR 2022-04-21 (12978) - sprawdzanie czy jakas absencja zostala uzyta do obliczen w liscie plac
    #sql = u"SELECT 'Absencja pracownika: '||a.pracownik_id||' od '||a.data_od||' do '||a.data_do||"
    #sql +=u"' nakada si na istniejc list pac numer '||doa.numer_listy_id"
    #sql += u" FROM rs_kp_absencje_pozycje a, rs_kp_dane_osobowe_absencje doa WHERE a.firma_id = '"+self.firma_id+u"'"
    #sql += u" AND a.firma_id=doa.firma_id AND a.pracownik_id=doa.pracownik_id "
    #sql += u" AND a.oddzial_id='"+Oddzial+u"' AND a.data='"+Data+u"' AND a.numer='"+Numer+"'"
    #sql += u" AND (doa.od_kiedy BETWEEN a.data_od AND a.data_do) AND doa.numer_listy_id IS NOT NULL;"
    #JR 2022-05-18 (13024) - sprawdzanie czy jakas absencja zostala uzyta do obliczen w zamknietej liscie plac
    sql = u"SELECT 'Absencja pracownika: '||a.pracownik_id||' od '||a.data_od||' do '||a.data_do||"
    sql +=u"' uyta w zamknitej licie pac numer '||doa.numer_listy_id"
    sql += u" FROM rs_kp_absencje_pozycje a, rs_kp_dane_osobowe_absencje doa"
    sql += u" INNER JOIN rs_kp_listy_plac lp ON (lp.firma_id=doa.firma_id AND lp.numer_listy_id=doa.numer_listy_id)"
    sql += u" WHERE a.firma_id = '"+self.firma_id+u"'"
    sql += u" AND a.firma_id=doa.firma_id AND a.pracownik_id=doa.pracownik_id "
    sql += u" AND a.oddzial_id='"+Oddzial+u"' AND a.data='"+Data+u"' AND a.numer='"+Numer+"'"
    sql += u" AND (doa.od_kiedy BETWEEN a.data_od AND a.data_do) AND doa.numer_listy_id IS NOT NULL"
    sql += u" AND lp.stan != 'W'"
    stat, d, wyn1, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(d) > 0:
            stat = d[0][0]
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   Zamkniecie (6)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [6, ]:
    if not UprZam:
        stat = u'Brak uprawnie do zamykania'
        
    if stat == 'OK':
        nstan = 'Z'

    if stat == 'OK':
        # sprawdzenie czy s dane w pozycjach
        sql = "Select count(*) FROM rs_kp_absencje_pozycje a "
        sql += "WHERE a.firma_id='"+self.firma_id+"' AND a.oddzial_id='"+Oddzial+"' AND a.data='"+Data+"' AND a.numer='"+Numer+"';"
        stat, d, wyn1, dump = self.PolSQL.Execute(sql, 3)
        rsglobal.ZapiszDoLogow(stat + ' JRd ' + str(d), 5)
        if stat == 'OK':
            if d[0][0] == 0:
                stat = 'Nie mona zamkn absencji - brak absencji pracownikw w pozycjach'
                dane.append(stat)


    #-------------------------------------------------------------------------------
    #---   Sprawdzenie pokrywania si dat
    #-------------------------------------------------------------------------------

    if stat == 'OK':
        # sprawdzenie wszystkich otwartych paczek
        sql = "SELECT a.pracownik_id, a.typ_absencji_id, a.data_od, a.data_do, a.data, a.numer FROM rs_kp_absencje_pozycje a  "
        sql += " INNER JOIN rs_kp_absencje b USING (firma_id,oddzial_id,data,numer) "
        sql += " WHERE b.firma_id='"+self.firma_id+"' AND b.stan = 'W' "
        sql += " ORDER BY a.pracownik_id, a.data_od, a.data_do ;"
        stat, D, wyn1, dump = self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow(stat + ' JRD ' + str(D), 5)
        if stat == 'OK':
            if len(D) > 0:
                stat = ''
                for i in xrange(len(D)-1):
                    prac = rsglobal.Dekoduj(D[i][0])
                    prac2 = rsglobal.Dekoduj(D[i+1][0])
                    rodz = rsglobal.Dekoduj(D[i][1])
                    rodz2 = rsglobal.Dekoduj(D[i+1][1])
                    dataod = rsglobal.Dekoduj(D[i][2])
                    dataod2 = rsglobal.Dekoduj(D[i+1][2])
                    datado = rsglobal.Dekoduj(D[i][3])
                    datado2 = rsglobal.Dekoduj(D[i+1][3])
                    if prac == prac2:
                        #rsglobal.ZapiszDoLogow(stat + ' JR ' + prac, 5)
                        if datado >= dataod2:
                            if stat == '':
                                stat = "Istniej pokrywajce si daty w danych osobowych absencji: " + "\n"
                                #rsglobal.ZapiszDoLogow(stat + ' JR a jednak' , 5)
                            stat += "Pracownik: " + prac + " ,Rodzaj:" + rodz + ",Data do: "+ datado + " pokrywa si z zakresem od "
                            stat += dataod2 + " do " + datado2 + "\n"
                if stat != '':
                    dane.append(stat)
                else:
                    stat = "OK"
        else:
            stat="Bd przy pobieraniu danych przy sprawdzaniu pokrywania si dat : "+stat
            dane.append(stat)

        if stat == 'OK':
            #w poczeniu z rs_kp_dane_osobowe_absencje                            #AB 16.03.21r dodanie TRIM
            sql = "Select DISTINCT a.typ_absencji_id, a.data_od, b.od_kiedy, b.do_kiedy, TRIM(nazwisko)||' '||TRIM(imie) "
            sql += "From rs_kp_absencje_pozycje a JOIN rs_kp_dane_osobowe_absencje b "
            sql += "ON a.firma_id = b.firma_id AND a.pracownik_id=b.pracownik_id "
            sql += "AND ((a.data_od BETWEEN b.od_kiedy and b.do_kiedy) OR (a.data_do BETWEEN b.od_kiedy and b.do_kiedy) "
            sql += " OR (b.od_kiedy BETWEEN a.data_od and a.data_do) OR (b.do_kiedy BETWEEN a.data_od and a.data_do)) "
            sql += " JOIN rs_kp_dane_osobowe p ON p.firma_id = a.firma_id AND  p.pracownik_id=b.pracownik_id "
            sql += " WHERE a.firma_id='"+self.firma_id+"' AND a.oddzial_id='"+Oddzial+"' AND a.data='"+Data+"' AND a.numer='"+Numer+"';"
            stat, D, wyn1, dump = self.PolSQL.Execute(sql, 3)
            if stat == 'OK' and len(D) > 0:
                stat = "Istniej pokrywajce si daty w danych osobowych absencji: "
                for i in xrange(len(D)):
                    rodz = str(D[i][0]);    dataA = str(D[i][1]);    dataB = str(D[i][2])
                    dataC = str(D[i][3]);   dataD = str(D[i][4])
                    stat += "\n"+str(dataD)+" - rodzaj:"+str(rodz)+",data od:"+str(dataA)+"\n\tpokrywa si z zakresem od "+str(dataB)+" do "+str(dataC)
                    wyn2.append((0, 1))
                    dane.append(stat)

    #-------------------------------------------------------------------------------
    #---   pobranie danych absencji, podzial zwolnien na podokresy
    #-------------------------------------------------------------------------------
    if stat == 'OK':
        zopiszb = ''  #zbiorczy opis sposobu policzenia podstaw zasilkow dla pracownikow
        if stat == "OK":
            sql = "SELECT pracownik_id, typ_absencji_id, data_od, data_do,data_dostarczenia,data_wystawienia, "
            sql += " COALESCE(kod_zus,''), dni_kalendarzowe, dni_robocze, procent_wyplaty, kontynuacja,godziny_robocze, "
            sql += " dni_zalegle, godziny_zalegle, dni_tegoroczne, godziny_tegoroczne, rodzina_id, kontynuacja_data,"
            sql += " dni_szpital,na_zadanie,wypadkowe,COALESCE(kod,'') "
            sql += " FROM rs_kp_absencje_pozycje WHERE firma_id='"+str(self.firma_id)+"'AND oddzial_id = '"+str(Oddzial)
            sql += "' AND data = '"+str(Data)+"' AND numer = '"+str(Numer)+"' ORDER BY pracownik_id, data_od;"
            #rsglobal.ZapiszDoLogow('malysql: ' + str(sql), 5)
            stat, Dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = "Bd przy pobieraniu danych absencji: "+stat
                dane.append(stat)
            rsglobal.ZapiszDoLogow('JESTEM 1 '+str(Dane), 5)

        if stat == 'OK':
            # podzial absencji na okresy wg miesiecy i dat angazy
            rsglobal.ZapiszDoLogow('JESTEM 2 '+str(Dane), 5)
            for wierszabsencji in Dane:
                if stat != 'OK':
                    break
                stat, wierszerozbite = abpom.PodzielZwolnienie(self, wierszabsencji)
                if stat == "nie zwolnienie":
                    stat = 'OK'
                    wierszerozbite = []
                    wierszerozbite.append(wierszabsencji)
                elif stat != 'OK':
                    break
                rsglobal.ZapiszDoLogow('JESTEM 22 ' + str(wierszerozbite), 5)
                procpoprz = 0  # umozliwia liczenie zasiku dzie po zmianie procentu dla tego samoego zwolnienia
                for da in wierszerozbite:
                    if stat != 'OK':
                        break
                    pracownik = da[0];     typ = da[1]
                    datadost = da[4];      datawyst = da[5]
                    kodzus = da[6];        proc = da[9]
                    kont = da[10];         dzal = da[12]
                    gzal = da[13];         dtr = da[14]
                    gtr = da[15];          rodz = da[16]
                    kontdata = da[17];     szpital = da[18]
                    nazadanie = da[19];    wypadkowe = da[20]
                    if procpoprz == 0:
                        procpoprz = proc
                    # sprawdzenie czy nie trzeba rozbic zwolnienia
                    # policzenie liczby dni kontynuacji
                    sql = "SELECT czy_zwolnienie, przechodni, nieobecnosc_inna "
                    sql += " FROM rs_kp_absencje_rodzaje WHERE firma_id='" + str(self.firma_id) + "'AND typ_absencji_id='" + typ + "';"
                    stat, Parametry, wyn1, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        stat = 'Bd pobierania parametrw absencji '+stat
                    else:
                        czyzwolnienie = Parametry[0][0]
                        czyprzechodni = Parametry[0][1]
                        nieobecnoscinna = Parametry[0][2]

                    if stat == 'OK':
                        #  podzial na okresy ze wzgledu na miesiace i daty angazy
                        (stat, Okresy) = rs_anakonda_daty.PodzielNaOkresy(self, da[0], da[2], da[3])  # prac,dod,ddo
                    if stat != 'OK':
                        break

                    rsglobal.ZapiszDoLogow('JESTEM 3 Okresy'+str(Okresy), 5)
                    for ok in Okresy:
                        if stat != 'OK':
                            break
                        # kolejne wiersze w ramach
                        if len(ok) == 0:
                            continue
                        dataod = ok[0]
                        rsglobal.ZapiszDoLogow('JESTEM 4 ', 5)
                        datado = ok[1]
                        if dataod > da[2]:
                            kont = 'True'
                            if kontdata in ['', None, 'None']:
                                kontdata = da[2]
                        dnikal = rsglobal.IleDniWZakresieDat(dataod,datado)
                        if da[18] > dnikal:
                            szpital = dnikal
                        (stat, roboczepom) = abpom.LiczDniIGodzinyRobocze(self, dataod, datado, pracownik)
                        if stat != 'OK':
                            break
                        dnirob = roboczepom[0][0]
                        grob = roboczepom[0][1]
                        #AB 13.06.18r  sprawdzanie czy nie ma brakujcych danych
                        if pracownik in ['', None, 'None']:
                            stat = "Brak symbolu pracownika ({0}) w absencji {1}, od {2} do {3}".format(pracownik, typ, dataod, datado)
                            dane.append(stat)
                        elif typ in ['', None, 'None']:
                            stat = "Brak typu absencji ({0}) pracownika {1}, od {2} do {3}".format(typ, pracownik, dataod,datado)
                            dane.append(stat)
                        elif dataod in ['', None, 'None']:
                            stat = "Brak daty od w absencji {0} pracownika {1}".format(typ, pracownik)
                            dane.append(stat)
                        elif datado in ['', None, 'None']:
                            stat = "Brak daty do w absencji {0} pracownika {1}".format(typ, pracownik)
                            dane.append(stat)
                        elif dnirob in ['', None, 'None']:
                            stat = "Nie uzupeniono dni roboczych absencji {0} pracownika {1}, od {2} do {3}".format(typ,pracownik,dataod,datado)
                            dane.append(stat)
                        if stat != 'OK':
                            break

                        #----------------------------------------------------cd ---------------------------
                        #--- SPRAWDZENIE LIMITOW, PODABSENCJE
                        #-------------------------------------------------------------------------------

                        stat, limit = abpom.PodajLimitDoWykorzystania(self, dataod, pracownik, typ, rodz, nazadanie, datado)
                        rsglobal.ZapiszDoLogow('pracownik:' + str(pracownik) + '/' + str(datado)+ 'typ:' + typ + 'limit:' + str(limit), 5)
                        if stat != 'OK':
                            break
                        t = ''
                        if nazadanie:
                            t = ' (na danie) '
                        if limit <= 0 :
                            stat = "Wykorzystany limit dni absencji {2}{0} pracownika {1}. ".format(typ, pracownik, t)
                            #stat = "Wykorzystany limit dni absencji "+str(typ)+" pracownika "+str(pracownik)
                            dane.append(stat)
                        elif limit < dnirob :
                            stat = "Przekroczony limit dni absencji {2}{0} pracownika {1}. ".format(typ, pracownik, t)
                            dane.append(stat)

                        if stat == 'OK':
                            if not czyzwolnienie:
                                (stat, typp) = abpom.PodajPodAbsencje(self, dataod, pracownik, typ, rodz)
                                if stat != 'OK':
                                    dane.append(stat)
                                elif len(typp) == 1:
                                    if typp[0][0] == '':
                                        stat = "Brak podabsencji {0} pracownika {1}".format(typ, pracownik)
                                        dane.append(stat)
                                    else:
                                        typ = typp[0][0]
                        if stat != 'OK':
                            break

                        #-------------------------------------------------------------------------------
                        #--- OBLICZENIE DNI W OKRESIE I W ROKU
                        #-------------------------------------------------------------------------------

                        dniwroku = dniwokresie = 0
                        SQL = "SELECT sum(dni_kalendarzowe), sum(dni_robocze) "
                        SQL += " FROM rs_kp_dane_osobowe_absencje WHERE firma_id='" + self.firma_id + "' "
                        if rodz > 0:
                            SQL += " AND rodzina_id=" + str(rodz)
                        SQL += " AND pracownik_id='" + pracownik + "' AND typ_absencji_id LIKE '" + typ[0] + "%' AND EXTRACT(YEAR from od_kiedy)=" + dataod[0:4] + ";"
                        stat, Dni, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':
                            stat = 'Bd pobierania dni kalendarzowych / roboczych' + stat
                            dane.append(stat)
                            break
                        if czyzwolnienie or nieobecnoscinna:
                            dniwroku = Dni[0][0]+dnikal
                            dniwokresie = dnikal
                            SQL = "SELECT od_kiedy,do_kiedy,dni_kalendarzowe "
                            SQL += " FROM rs_kp_dane_osobowe_absencje WHERE firma_id='"+self.firma_id+"' "
                            if rodz > 0:
                                SQL += " AND rodzina_id="+str(rodz)
                            SQL += " AND pracownik_id='"+pracownik+"' AND typ_absencji_id LIKE '"+typ[0]+"%' "
                            SQL += " ORDER BY od_kiedy DESC;"
                            stat, Dni, dump, dump = self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                stat = 'Bd pobierania dni kalendarzowych '+stat
                                dane.append(stat)
                                break
                            # ???
                            d = dataod
                            for w in Dni:
                                if rs_anakonda_daty.DodajKilkaDni(w[1], 1) < d:
                                    break
                                dniwokresie += w[2]
                                d = w[0]

                        else:  # urlopy
                            dniwroku = Dni[0][1]+dnirob
                            dniwokresie = Dni[0][1]+dnirob

                        if czyprzechodni:
                            # ma juz wpisany limit - wracamy z bledem
                            SQL = "SELECT * FROM rs_kp_dane_osobowe_limity_urlopow WHERE firma_id='" + self.firma_id + "' "
                            SQL += " AND pracownik_id='" + pracownik + "' AND urlop_id LIKE '" + typ.strip() + "%' AND od_dnia>'" + dataod + "';"
                            stat, Limit, dump, dump = self.PolSQL.Execute(SQL, 3)
                            rsglobal.ZapiszDoLogow('SQL LIMIT:' + str(SQL) + '|' + str(Limit) + '|' + str(len(Limit)) + '|' + stat, 5)
                            if stat == 'OK':
                                if Limit != []:
                                    stat = "Istnieje limit urlopu pniejszy ni absencja dla pracownika {0}. ".format(pracownik)
                                    dane.append(stat)
                                    break
                            else:
                                stat = 'Bd pobierania dni limitw' + stat
                                dane.append(stat)
                                break

                            stat, stazzalegle, staztegoroczne = abpom.ZmianaLimituUrlopu(self, datado, pracownik, typ)
                            if stat != 'OK':
                                stat = 'Bd pobierania dni stau '+stat
                                dane.append(stat)
                                break
                            stat, Zostalo = abpom.PodajZalegleTegoroczneUrlop(self, dataod, pracownik, typ)
                            rsglobal.ZapiszDoLogow('pracownik:' + str(pracownik) + '/' + str(datado) + 'typ:' + typ + 'Zostalo:' + str(Zostalo), 5)
                            if stat != 'OK':
                                stat = 'Bd pobierania dni zalegych /tegorocznych'+stat
                                dane.append(stat)
                                break
                            if len(Zostalo) > 0:
                                Zostalo[0][0] += stazzalegle
                                Zostalo[0][1] += staztegoroczne
                                rsglobal.ZapiszDoLogow('pracownik:' + str(pracownik) + '/' + str(datado) + 'typ:' + typ + 'Zostalo2:' + str(Zostalo), 5)
                                if str(Zostalo[0][2])[0:4] == str(dataod)[0:4]:
                                    # ten sam rok
                                    if Zostalo[0][0] >= dnirob:
                                        dzal = Zostalo[0][0] - dnirob
                                        dtr = Zostalo[0][1]
                                    else:
                                        dzal = 0
                                        dtr = Zostalo[0][1]-(dnirob-Zostalo[0][0])
                                else:
                                    # zmiana roku
                                    dzal = Zostalo[0][1]+Zostalo[0][0]
                                    dtr = limit-Zostalo[0][1]-Zostalo[0][0]
                                    if dnirob <= dzal:
                                        dzal = dzal-dnirob
                                    else:
                                        dtr = dtr-(dnirob-dzal);     dzal = 0
                            else:
                                dzal = 0;         dtr = limit-dnirob
                            # ??? moze tutaj etat?
                            gzal = dzal*8;    gtr = dtr*8
                        else:
                            # zaslepka dla innych
                            dzal = dtr = gzal = gtr = 0


                        #-------------------------------------------------------------------------------
                        #--- OBLICZENIE PODSTAWY DLA ZWOLNIEN I NIEOBECNOSCI INNYCH
                        #-------------------------------------------------------------------------------

                        if stat != 'OK':
                            break
                        zlmcy = zpodstawa = zdzien = zzasilek = 0
                        zmce = zopis = ''
                        if czyzwolnienie or nieobecnoscinna:
                            stat, podstawy = abpom.PodajPodstaweZwolnienia(self, str(dataod), pracownik, typ, kont, str(datado))
                            rsglobal.ZapiszDoLogow('podstawy:'+str(podstawy))
                            if stat == 'OK':
                                zlmcy = podstawy[0];               zmce = podstawy[1]
                                zpodstawa = podstawy[2]
                                if podstawy[4][:8] == 'Podstawa':
                                    # policzona wczesniej
                                    #if procpoprz == 0:
                                    #    zdzien = podstawy[3]
                                    #else:
                                    #    zdzien = rsglobal.RSRound(1.0 * podstawy[3] / int(procpoprz) * int(proc), 2)
                                    #    procpoprz = proc
                                    if podstawy[5] == proc:
                                        zdzien = podstawy[3]
                                    else:
                                        zdzien = rsglobal.RSRound(1.0 * podstawy[3] / float(podstawy[5]) * float(proc), 2)
                                else:
                                    zdzien = rsglobal.RSRound(podstawy[3] * float(proc) * 0.01, 2)
                                zzasilek = rsglobal.RSRound(zdzien * dnikal, 2)
                                zopis = "'" + podstawy[4] + "'";   zopiszb += zopis
                                #rsglobal.ZapiszDoLogow("obliczenia podstawy:"+str(zopis),1)
                            else:
                                rsglobal.ZapiszDoLogow("stat z podstawy:"+str(stat),1)
                                break


                        #-------------------------------------------------------------------------------
                        #--- DODAWANIE DANYCH
                        #-------------------------------------------------------------------------------

                        # pobranie etatu do godzin
                        stat, angaz = abpom.PodajZatrudnienieUmoweAngaz(self, dataod, pracownik)
                        if stat == 'OK':
                            etat = angaz[0][4]
                        else:  # ???
                            #etat = 1
                            break
                        ins = "INSERT INTO rs_kp_dane_osobowe_absencje"
                        Pola = "firma_id, pracownik_id, typ_absencji_id, od_kiedy"
                        Wartosci = "'"+str(self.firma_id)+"','"+str(pracownik)+"','"+str(typ)+"','"+str(dataod)+"','"+str(datado)+"'"

                        Pola += ",do_kiedy,data_dostarczenia,data_wystawienia, kod_zus, dni_robocze,dni_kalendarzowe, procent_wyplaty,"
                        Pola += " kontynuacja, godziny_robocze, dni_zalegle, godziny_zalegle, dni_tegoroczne, godziny_tegoroczne, kontynuacja_data, "
                        Pola += " dni_okr, dni_rok, dni_szpital, na_zadanie "
                        Wartosci += ',' + rsglobal.ZmienNaNULL(datadost)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(datawyst)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(kodzus)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dnirob)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dnikal)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(proc)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(kont)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dnirob * rsglobal.RSRound(8 * etat, 0))
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dzal)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dzal * rsglobal.RSRound(8 * etat, 0))
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dtr)
                        Wartosci += ',' + rsglobal.ZmienNaNULL(dtr * rsglobal.RSRound(8 * etat, 0))
                        if kontdata in ['', None, 'None']:
                            if str(kont) == 'True':
                                kontdata=str(da[2])
                        Wartosci += ',' + rsglobal.ZmienNaNULL(kontdata)
                        Wartosci += ","+str(dniwokresie)+","+str(dniwroku)+","+str(szpital)
                        Wartosci += ',' + str(nazadanie)

                        if czyzwolnienie or nieobecnoscinna:
                            Pola += ", lmcy, miesiace, podstawa, zasilek_dzien, zasilek_razem, podstawa_obliczenia"
                            Wartosci += ","+str(zlmcy)+",'"+zmce+"',"+str(zpodstawa)+","+str(zdzien)+","+str(zzasilek)+","+zopis

                        ins += " ("+Pola+") VALUES ("+Wartosci+");"
                        stat, dump, dump, dump = self.PolSQL.Execute(ins, 1, CzyDodawacBlad=True)
                        rsglobal.ZapiszDoLogow('Insert absencji:' + stat + ' ' + ins, 5)
                        if stat != 'OK':
                            stat = u"Bdy dodawania danych:"+stat
                            dane.append(stat)
                            break
                        # update w ewidencji czasu pracy
                        update = "UPDATE rs_kp_grafiki_pozycje SET nieobecnosc=True, nieobecnosc_id = '"+typ+"'"
                        WHERE = " WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id='"+str(pracownik)+"'"
                        WHERE += " AND (plan_czas_od BETWEEN '"+str(dataod)+" 00:00:00' AND '"+str(datado)+" 24:00:00') "
                        WHERE += " AND (plan_czas_do BETWEEN '"+str(dataod)+" 00:00:00' AND '"+str(datado)+" 24:00:00'); "
                        stat, dump, dump, dump = self.PolSQL.Execute(update+WHERE, 1)
                        rsglobal.ZapiszDoLogow(stat + ' ' + update+WHERE, 5)
                        if stat != 'OK':
                            stat = u'Bdy usuwania danych ewidencji czasu pracy: '+stat
                            dane.append(stat)
                            break
                                        
    if stat == 'OK':
        update = "UPDATE rs_kp_absencje SET stan = 'Z'"
        update += " WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial
        update += "' AND data = '"+Data+"' AND numer='"+Numer+"';"
        #rsglobal.ZapiszDoLogow('zamkniecie absencji '+update,1)
        stat, dump, dump, dump=self.PolSQL.Execute(rsglobal.Dekoduj(update), 1)
        if stat != 'OK':
            stat = u'UPD BL$'+stat
            dane.append(stat)
        else:
            wyn2 = zopiszb
    if len(dane) > 0:
        stat = str(dane)


#-------------------------------------------------------------------------------
#---   Otwarcie (7)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [7,]:
    if not UprOtw:
        stat=u'Brak uprawnie do otwierania'
    if stat=='OK':
        if Stan == 'W':
            stat='Stan absencji = W'
            dane.append(stat)
    if stat=='OK':
        sql ="SELECT pracownik_id, typ_absencji_id, data_od, data_do FROM rs_kp_absencje_pozycje "
        sql+="WHERE firma_id='"+str(self.firma_id)+"'AND oddzial_id = '"+str(Oddzial)
        sql+="' AND data = '"+str(Data)+"' AND numer = "+str(Numer)+" ORDER BY data_od DESC;"
        stat,Dane,wyn1,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat="Bd przy pobieraniu danych otwarcia: "+stat
            dane.append(stat)

        if stat=='OK':
            for wiersz3 in Dane:
                Pracownik = wiersz3[0]
                typ = wiersz3[1].strip()
                dataod = wiersz3[2]
                datado = wiersz3[3]
                # sprawdzenie czy w rs_kp_dane_osobowe_absencje nie ma pozniejszych absencji  #AB 16.03.21r dodanie TRIM
                sql ="SELECT a.typ_absencji_id, a.od_kiedy, a.do_kiedy, TRIM(nazwisko)||' '||TRIM(imie) "
                sql+=" FROM rs_kp_dane_osobowe_absencje a "
                sql+=" JOIN rs_kp_dane_osobowe p ON p.firma_id = a.firma_id AND  p.pracownik_id=a.pracownik_id "
                sql+=" WHERE a.firma_id='"+self.firma_id+"' AND a.do_kiedy>'"+str(datado)+"' "
                sql+=" AND a.pracownik_id='"+Pracownik+"' AND typ_absencji_id LIKE '"+str(typ)+"%'; "  # 12439 dopisanie typu
                stat,D,wyn1,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    if len(D)>0:
                        stat = "Istniej pokrywajce si daty w danych osobowych absencji: "
                        stat += "\n Otwarcie niemoliwe, u pracownika "+Pracownik+" - "+D[0][3]+" s pniejsze absencje."
                        stat += "\n Rodzaj:" + D[0][0] + " od dnia:" + str(D[0][1])
                        wyn2.append((0,1))
                        dane.append(stat)
                        break
                else:
                    stat = u'Bdy sprawdzanie absencji w danych osobowych - absencje: '+stat
                    dane.append(stat)
                    break
                #JR 2022-05-18 (13024) zmiana statusu pracownika na przeliczony=False
                if stat == 'OK':
                    sql = "SELECT DISTINCT numer_listy_id FROM rs_kp_dane_osobowe_absencje"
                    WHERE = " WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id='"+str(Pracownik)+"'"
                    WHERE += " AND typ_absencji_id LIKE '"+str(typ)+"%'"
                    WHERE += " AND (od_kiedy BETWEEN '"+str(dataod)+"' AND '"+str(datado)+"') "
                    WHERE += " AND (do_kiedy BETWEEN '"+str(dataod)+"' AND '"+str(datado)+"') "
                    WHERE += " AND numer_listy_id IS NOT NULL"
                    stat, listy, dump, dump = self.PolSQL.Execute(sql+WHERE, 3)
                    #rsglobal.ZapiszDoLogow(stat + ' ' + delete+WHERE, 5)
                    if stat != 'OK':
                        stat = u'Bdy usuwania pozycji danych osobowych - absencje: '+stat
                        dane.append(stat)
                        break
                    upd = ""
                    for wiersz in listy:
                        upd += "UPDATE rs_kp_listy_plac_osoby SET przeliczony = FALSE"
                        upd += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "'"
                        upd += " AND numer_listy_id='" + wiersz[0] + "';"
                    if upd != '':
                        stat, dump, dump, dump = self.PolSQL.Execute(upd, 1)
                        if stat != 'OK':
                            stat = u'Bdy aktualizacji list pac: '+stat
                            dane.append(stat)
                            break

                # usuniecie z danych osobowych
                if stat == 'OK':
                    delete = "DELETE FROM rs_kp_dane_osobowe_absencje"
                    WHERE = " WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id='"+str(Pracownik)+"'"
                    #WHERE += " AND typ_absencji_id='"+str(typ)+"'"
                    WHERE += " AND typ_absencji_id LIKE '"+str(typ)+"%'"
                    WHERE += " AND (od_kiedy BETWEEN '"+str(dataod)+"' AND '"+str(datado)+"') "
                    WHERE += " AND (do_kiedy BETWEEN '"+str(dataod)+"' AND '"+str(datado)+"'); "
                    stat, dump, dump, dump = self.PolSQL.Execute(delete+WHERE, 1)
                    #rsglobal.ZapiszDoLogow(stat + ' ' + delete+WHERE, 5)
                    if stat != 'OK':
                        stat = u'Bdy usuwania pozycji danych osobowych - absencje: '+stat
                        dane.append(stat)
                        break
                    # update w ewidencji czasu pracy
                    update = "UPDATE rs_kp_grafiki_pozycje SET nieobecnosc=False, nieobecnosc_id = NULL"
                    WHERE = " WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id='"+str(Pracownik)+"'"
                    WHERE += " AND (plan_czas_od BETWEEN '"+str(dataod)+" 00:00:00' AND '"+str(datado)+" 24:00:00') "
                    WHERE += " AND (plan_czas_do BETWEEN '"+str(dataod)+" 00:00:00' AND '"+str(datado)+" 24:00:00'); "
                    stat, dump, dump, dump = self.PolSQL.Execute(update+WHERE, 1)
                    #rsglobal.ZapiszDoLogow(stat + ' ' + update+WHERE, 5)
                    if stat != 'OK':
                        stat = u'Bdy usuwania danych ewidencji czasu pracy: '+stat
                        dane.append(stat)
                        break
 
    if stat=='OK':   
        update = "UPDATE rs_kp_absencje SET stan = 'W'"    
        update += " WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial
        update +="' AND data = '"+Data+"' AND numer='"+Numer+"';"
        #rsglobal.ZapiszDoLogow('Otwarcie absencji '+update,1)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(update),1)
        if stat<>'OK':
            stat=u'UPD BL$'+stat
            dane.append(stat)

# -------------------------------------------------------------------------------
# ---   Zapis limitow B.O. (11)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [11, ]:
    if not UprBO:
        stat = u'Brak uprawnie do tworzenia B.O.'
    if stat == 'OK':
        # pobranie listy pracownikow
        SQL = "SELECT DISTINCT pracownik_id, imie, nazwisko FROM rs_kp_dane_osobowe dos"
        SQL += " INNER JOIN rs_kp_zatrudnienie zat USING(firma_id,pracownik_id)"
        SQL += " WHERE dos.firma_id = '"+self.firma_id+"' "
        SQL += " AND zat.stan_pracownika_id='A' AND zat.staz_do_urlopu IS NOT NULL AND zat.czy_absencje;"
        stat, Pracownicy, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania listy pracownikw ' + stat
        elif len(Pracownicy) == 0:
            stat = 'Brak aktywnych pracownikw.'
    if stat == 'OK':
        # pobranie listy absencji
        sql = "SELECT typ_absencji_id, nazwa "
        sql += " FROM rs_kp_absencje_rodzaje WHERE firma_id='" + str(self.firma_id) + "' AND przechodni;"
        stat, Absencje, wyn1, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobierania listy absencji ' + stat
        elif len(Absencje) == 0:
            stat = 'Brak typw absencji do tworzenia B.O.'

    if stat == 'OK':
        Insert = ''
        Liczba = 0
        # petla po pracownikach i absencjach
        for Pracownik in Pracownicy:
            stat, angaz = abpom.PodajZatrudnienieUmoweAngaz(self, Rok+'-01-01', Pracownik[0])
            if stat == 'OK':
                etat = angaz[0][4]
            else:
                etat = 1
            for TypAbsencji in Absencje:
                stat, Limit = abpom.PodajLimitNowyRok(self, Rok, Pracownik[0], TypAbsencji[0])
                if stat != 'OK':
                    stat = 'Bd obliczania limitu urlopu dla pracownika: ' + Pracownik[0] + ', ' + stat
                    break
                if Limit != [0, 0]:
                    Insert += "INSERT into rs_kp_dane_osobowe_limity_urlopow "
                    Insert += " (firma_id,pracownik_id,urlop_id,od_dnia,limit_dni,limit_godziny,limit_dni_zalegle,limit_godziny_zalegle) VALUES "
                    Insert += "('" + self.firma_id + "','" + Pracownik[0] + "','" + TypAbsencji[0] + "','" + Rok + "-01-01"
                    Insert += "'," + str(Limit[1]) + "," + str(Limit[1] * rsglobal.RSRound(8 * etat, 0))+ ","
                    Insert += str(Limit[0]) + "," + str(Limit[0] * rsglobal.RSRound(8 * etat, 0)) + ");"
                    Liczba += 1
            if stat != 'OK':
                break
        if stat == 'OK':
            if Insert != '':
                stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(Insert), 1)
                if stat != 'OK':
                    stat = u'Bd wstawiania limitw' + stat
                else:
                    dane = [str(Liczba)]

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,5,)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==5:
    if rsglobal.SprawdzCzyToData(DataOd) and rsglobal.SprawdzCzyToData(DataDo):
        if DataOd > DataDo:
            stat = "Data od jest wiksza od daty do"
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT stan, oddzial_id, data, numer, komorka_id, k.opis, a.grupa_pracownikow_id,g.opis,a.opis FROM rs_kp_absencje a "
        sql+="LEFT JOIN rs_komorki_zatrudniajace k ON komorka_id=kod AND a.firma_id=k.firma_id "
        sql+="LEFT JOIN rs_grupy_pracownikow g ON a.grupa_pracownikow_id=g.kod AND a.firma_id=g.firma_id "
        sql+="WHERE a.firma_id='"+str(self.firma_id)+"'"
        if rsglobal.SprawdzCzyToData(DataOd):
            sql += " AND data>='"+DataOd+"'"
        if rsglobal.SprawdzCzyToData(DataDo):
            sql += " AND data<='"+DataDo+"'"
        if Komorka != '':
            sql+= " AND komorka_id LIKE '"+Komorka+"%'"
        #AB 19.11.18r
        if FStan != '':
            sql+= " AND stan='"+FStan+"'"
        if Grupa != '':
            sql+= " AND a.grupa_pracownikow_id LIKE '"+Grupa+"%'"
        #AB 07.03.19r.
        if Pracownik != '':
            Pracownik = ('000000' + str(Pracownik))[-6:]
            sql+= " AND EXISTS (SELECT 1 FROM rs_kp_absencje_pozycje ap WHERE ap.firma_id = a.firma_id AND ap.oddzial_id=a.oddzial_id AND ap.DATA=a.data AND a.numer=ap.numer AND ap.pracownik_id ='"+Pracownik+"') "
        #WS 2020-01-30
        if Tryb == 1:
            sql += " AND zwolnienie=False"
        else:
            sql += " AND zwolnienie=True"
        #AB 21.11.18r
        sql += " ORDER BY a.data DESC, a.numer DESC;"
        rsglobal.ZapiszDoLogow(sql, 1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat="Bd przy pobieraniu danych : "+stat
            dane.append(stat)
