# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_praca_biezaca_ewidencja_czasu_pracy.py
# Purpose:     grid z Harmonogramami oraz z oknem danych
# Author:      Aleksander Bargie
# Created:     2018/05/23
# RCS-ID:      $Id: fs_kp_praca_biezaca_ewidencja_czasu_pracy.py $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2018-06-07 Aleksander Bargie (11078) - dodanie filtrowania po grupie pracownikw
# 2023-08-28 Jan Raburski (13512) - przejcie w dniach roboczych na kalendarz

import datetime
import rs_anakonda_daty

stat = 'OK'
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja'] 
    SlPar = {'Rok': [3, 4, 5], 'Mc': [3, 4, 5], 'Nr': [4], 'Nazwisko': [4], 'Komorka': [4], 'Dane': [3],
             #AB 08.06.18r dodanie filtrowania po grupie pracownikw
             'Numer': [3, 5], 'Zatrudnienie': [3, 5], 'Umowa': [3, 5], 'Angaz': [3, 5], 'Identyfikator': [4], 'Grupa':[4]}
    
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = u'Uwaga : wywoanie funkcji fs_kp_ewidencja_czasu_pracy z numerem ' + str(Funkcja) + \
               ' bez parametrw: ' + Lista
    if stat == 'OK':
        if Funkcja in [3, 4, 5]:
            Rok = str(klucze['Rok'])
            Mc = str(klucze['Mc'])
        if Funkcja in [3,5]:
            Numer = str(klucze['Numer'])
            Zatrudnienie = str(klucze['Zatrudnienie'])
            Umowa = str(klucze['Umowa'])
            Angaz = str(klucze['Angaz'])
        if Funkcja in [3]:
            UpdDane = klucze['Dane']
        if Funkcja in [4]:
            Nr = str(klucze['Nr'])
            Nazwisko = str(klucze['Nazwisko'])
            Komorka = str(klucze['Komorka'])
            Identyfikator = str(klucze['Identyfikator'])
             #AB 08.06.18r dodanie filtrowania po grupie pracownikw
            Grupa = str(klucze['Grupa'])

if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []

# -------------------------------------------------------------------------------
# ----------   UPRAWNIENIA
# -------------------------------------------------------------------------------

Upr = (((self.oddzial_id, '056400') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH  (4)
# -------------------------------------------------------------------------------


if not Upr:
    stat = 'Brak uprawnie do Ewidencji czasu pracy'


if stat == 'OK' and Funkcja == 4:
    Mc = '0' + Mc if len(Mc) == 1 else Mc
    DataOd = str(Rok) + "-" + str(Mc) + "-01"
    DataDo = str(Rok) + "-" + str(Mc) + "-" + str(rsglobal.PodajOstatniDzien(DataOd))

    AND = ''
    if Nr != '':
        AND += " AND d.pracownik_id::integer = " + Nr + ""
    if Nazwisko != '':
        AND += " AND upper(nazwisko) LIKE '" + Nazwisko.upper() + "%'"
    if Komorka != '':
        AND += " AND upper(a.komorka_id) LIKE '" + Komorka.upper() + "%'"
    if Identyfikator != '':
        AND += " AND a.lista_id='"+Identyfikator+"' "
    if Grupa != '':
        AND += " AND a.grupa_pracownikow_id='"+Grupa+"' "

    if stat == 'OK':
        sqlKalendarze = "SELECT DISTINCT DATE_PART('days', DATE_TRUNC('month', '" + DataOd + "'::DATE) "
        sqlKalendarze += "+ '1 MONTH'::INTERVAL - '1 DAY'::INTERVAL), sum(CASE WHEN DATE_TRUNC('month', k.dzien) = "
        sqlKalendarze += "DATE_TRUNC('month', '" + DataOd + "'::DATE) THEN 1 ELSE 0 END), k.kalendarz_id "
        sqlKalendarze += " FROM rs_kp_angaze a  JOIN rs_kp_dane_osobowe d USING (firma_id, pracownik_id) JOIN "
        sqlKalendarze += "rs_kp_kalendarze_dni k USING(firma_id, kalendarz_id)"
        sqlKalendarze += "WHERE a.firma_id = '" + self.firma_id + "' AND  a.od_kiedy <='" + DataDo + "'"
        sqlKalendarze += " AND (a.do_kiedy >='" + DataOd + "' OR a.do_kiedy IS NULL) "
        sqlKalendarze += AND
        sqlKalendarze += "GROUP BY a.zatrudnienie_id, a.pracownik_id, a.umowa_id, a.angaz_id, k.kalendarz_id "
        sqlKalendarze += "HAVING DATE_PART('days', DATE_TRUNC('month', '" + DataOd + "'::DATE) + "
        sqlKalendarze += "'1 MONTH'::INTERVAL - '1 DAY'::INTERVAL) != sum(CASE WHEN DATE_TRUNC('month', k.dzien) = "
        sqlKalendarze += "DATE_TRUNC('month', '" + DataOd + "'::DATE) THEN 1 ELSE 0 END);"

        stat, bezKalendarza, dump, dump = self.PolSQL.Execute(sqlKalendarze, 3)
        rsglobal.ZapiszDoLogow('Zapytanie sprawdzajce kalendarze: '+sqlKalendarze, 5)
        rsglobal.ZapiszDoLogow('stat: '+str(stat), 5)
        if stat == 'OK':
            if len(bezKalendarza) > 0:
                # 3. Bez grafikw i kalendarzy wyrzuci komunikat
                rsglobal.ZapiszDoLogow('bezKalendarza: '+str(bezKalendarza), 5)
                stat = "Nie zainicjowano miesica " + Mc + " w kalendarzu/ach: "
                for kalendarz in bezKalendarza:
                    stat += "\n-" + str(kalendarz[2])
            # Nie ma grafikw, ale s kalendarze
            else:
                Upd = "UPDATE rs_kp_grafiki_pozycje SET godz_ewidencja = godz_harmonogram  WHERE poz_grafiku_id IN "
                Upd +="(SELECT g.poz_grafiku_id FROM  rs_kp_angaze a FULL OUTER JOIN rs_kp_grafiki_pozycje g USING "
                Upd +="(firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) FULL OUTER JOIN rs_kp_dane_osobowe"
                Upd +=" d ON d.firma_id = a.firma_id AND d.pracownik_id = a.pracownik_id FULL OUTER JOIN "
                Upd +="rs_kp_dane_osobowe_absencje ab ON d.firma_id = ab.firma_id AND d.pracownik_id = ab.pracownik_id "
                Upd +="AND ab.od_kiedy <= date_trunc('DAY', g.plan_czas_od)::DATE AND  date_trunc('DAY', "
                Upd +="g.plan_czas_od)::DATE <= ab.do_kiedy WHERE a.firma_id='" + self.firma_id + "' AND a.kalendarz_id IS NOT NULL AND "
                Upd +="g.plan_czas_od::DATE<='" + DataDo + "' AND g.plan_czas_od>='" + DataOd + "' AND g.godz_ewidencja IS NULL "
                Upd +="EXCEPT SELECT g.poz_grafiku_id  FROM  rs_kp_angaze a FULL OUTER JOIN rs_kp_grafiki_pozycje g "
                Upd +="USING (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) FULL OUTER JOIN "
                Upd +="rs_kp_dane_osobowe d ON d.firma_id = a.firma_id AND d.pracownik_id = a.pracownik_id JOIN "
                Upd +="rs_kp_dane_osobowe_absencje ab ON d.firma_id = ab.firma_id AND d.pracownik_id = ab.pracownik_id "
                Upd +="AND ab.od_kiedy <= date_trunc('DAY', g.plan_czas_od)::DATE AND  date_trunc('DAY', "
                Upd +="g.plan_czas_od)::DATE <= ab.do_kiedy WHERE a.firma_id='" + self.firma_id + "' AND a.kalendarz_id IS NOT NULL AND "
                Upd +="g.plan_czas_od::DATE<='" + DataDo + "' AND g.plan_czas_od>='" + DataOd + "' AND g.godz_ewidencja IS NULL); "
                Upd +="UPDATE rs_kp_grafiki_pozycje SET godz_ewidencja = '08:00'::TIME WHERE poz_grafiku_id IN (SELECT "
                Upd +="g.poz_grafiku_id FROM rs_kp_angaze a FULL OUTER JOIN rs_kp_grafiki_pozycje g USING (firma_id, "
                Upd +="pracownik_id, zatrudnienie_id, umowa_id, angaz_id) FULL OUTER JOIN rs_kp_dane_osobowe d ON "
                Upd +="d.firma_id = a.firma_id AND d.pracownik_id = a.pracownik_id JOIN rs_kp_dane_osobowe_absencje ab "
                Upd +="ON d.firma_id = ab.firma_id AND d.pracownik_id = ab.pracownik_id AND ab.od_kiedy <= "
                Upd +="date_trunc('DAY', g.plan_czas_od)::DATE AND date_trunc('DAY', g.plan_czas_od)::DATE <= "
                Upd +="ab.do_kiedy WHERE a.firma_id='" + self.firma_id + "' AND a.kalendarz_id IS NOT NULL AND g.plan_czas_od::DATE<="
                Upd +="'" + DataDo + "' AND g.plan_czas_od>='" + DataOd + "' AND g.godz_ewidencja IS NULL) ;"
                stat, out1, out2, out3 = self.PolSQL.Execute(Upd, 1)
                rsglobal.ZapiszDoLogow('Update Ewidencja: ' + Upd, 5)
                rsglobal.ZapiszDoLogow('stat: ' + str(stat) + str(dane), 5)

    if stat == 'OK':

        sql = ""
        sql += "SELECT pracownik_id, nazwisko, imie, komorka_id, zatrudnienie_id, umowa_id, angaz_id, od_kiedy, "
        sql += "do_kiedy, floor(ewidencja /3600) || ':' || (ewidencja / 60)::int % 60, dewidencja FROM (SELECT "
        sql += "d.pracownik_id, d.nazwisko, d.imie, a.komorka_id, a.zatrudnienie_id, a.umowa_id, a.angaz_id, a.od_kiedy"
        sql += ", a.do_kiedy, date_part('epoch', SUM(COALESCE( g.godz_ewidencja, '00:00'::TIME))) AS \"ewidencja\", "
        sql += "sum(CASE WHEN g.godz_ewidencja> '00:00'::TIME THEN 1 ELSE 0 END) AS \"dewidencja\"  FROM  rs_kp_angaze "
        sql += "a FULL OUTER JOIN rs_kp_grafiki_pozycje g USING (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
        sql += "FULL OUTER JOIN rs_kp_dane_osobowe d ON d.firma_id = a.firma_id AND d.pracownik_id = a.pracownik_id "
        sql += "WHERE a.firma_id='" + self.firma_id + "' AND a.kalendarz_id IS NOT NULL AND g.plan_czas_od::DATE<='" + DataDo + "' AND "
        sql += "g.plan_czas_od>='" + DataOd + "' AND g.godz_ewidencja IS NOT NULL "
        sql += AND
        slownik = {}

        SQL = "SELECT rsf_kadry_lista_dozwolonych_pracownikow("
        SQL += "'" + self.firma_id + "','" + str(self.operator_id) + "','kartoteka_osobowa');"
        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania listy dozwolonych pracownikw : ' + stat
        else:
            wynik = rsglobal.rseval(d[0][0])
            slownik = eval(wynik[2][-1])
            if str(wynik[0]) != 'OK':
                stat = 'Bd pobrania listy dozwolonych pracownikw (rsf): ' + stat
            else:
                lista = wynik[1]
                if len(lista) == 0:
                    # ten myk pozwoli wyswietlic pustego grida przy braku dozwolonych pracownikow
                    sql += " AND d.pracownik_id IN ('x')"
                elif len(lista) == 1:
                    if lista[0] != '**':
                        sql += " AND d.pracownik_id IN (" + str(lista)[1:-1] + ")"
                else:
                    sql += " AND d.pracownik_id IN (" + str(lista)[1:-1] + ")"

        if stat == 'OK':
            sql += "GROUP BY CASE WHEN date_trunc('MONTH', "
            sql += "g.plan_czas_od)::DATE IS NULL THEN date_trunc('MONTH', ' " + DataOd + "'::DATE)::DATE ELSE "
            sql += "date_trunc('MONTH', g.plan_czas_od)::DATE END, d.pracownik_id,d.nazwisko,d.imie,a.komorka_id, "
            sql += "a.zatrudnienie_id,a.umowa_id,a.angaz_id,a.od_kiedy, a.do_kiedy, a.kalendarz_id, a.firma_id ) as fo "
            sql += "ORDER BY pracownik_id, od_kiedy;"
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)

            rsglobal.ZapiszDoLogow('Zapytanie pobierajce Ewidencj czasu pracy: '+sql, 5)
            rsglobal.ZapiszDoLogow('stat: '+str(stat)+str(dane), 5)
            if stat != 'OK':
                stat = "Bd przy pobieraniu danych : "+stat
                dane.append(stat)


# -------------------------------------------------------------------------------
# ---   UPDATE Ewidencja czasu pracy  DANE (3)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 3:

    for dzien, wartosci in UpdDane.iteritems():

        sql = ''
        WHERE = " WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Numer)+"' AND zatrudnienie_id='"
        WHERE += str(Zatrudnienie)+"' AND umowa_id='"+str(Umowa)+"' AND angaz_id='"+str(Angaz)+"' AND date_part('day', "
        WHERE += "plan_czas_od)::INT =" + str(dzien) + " AND date_part('month', plan_czas_od)::INT = " + str(Mc)
        WHERE += "AND date_part('year', plan_czas_od)::INT = " + str(Rok)
        UPDATE = "UPDATE rs_kp_grafiki_pozycje "
        SET = 'SET godz_ewidencja = \'' + str(wartosci[0]) + ':' + str(wartosci[1]) + '\' '
        sql += UPDATE+SET+WHERE
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
        rsglobal.ZapiszDoLogow('Update Harmonogram Dane: '+sql, 5)
        rsglobal.ZapiszDoLogow('stat: '+str(stat), 5)
        if stat != 'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)


# ----------------------------------------------
# POBIERANIE DANYCH - KARTY PRACY DANE (3,5)
# ----------------------------------------------

if Funkcja in [3, 5, ] and stat == 'OK':
    Mc = '0' + Mc if len(Mc) == 1 else Mc
    DataOd = str(Rok) + "-" + str(Mc) + "-01"
    DataDo = str(Rok) + "-" + str(Mc) + "-" + str(rsglobal.PodajOstatniDzien(DataOd))
    wyn1 = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, pracownik_id, datetime.date(int(Rok), int(Mc), 1),
                                                datetime.date(int(Rok), int(Mc), rsglobal.PodajOstatniDzien(DataOd)))

    # 1. Pobranie uzupenionych ju danych harmonogramw
    SQL = "SELECT date_part('day', plan_czas_od)::INT AS \"dzien\", date_part('hour', godz_ewidencja)::INT"
    SQL += " AS \"liczba_godzin\", date_part('minute', godz_ewidencja)::INT AS \"liczba_minut\",  status_dnia, ab.typ_absencji_id "
    SQL += "FROM rs_kp_grafiki_pozycje g JOIN rs_kp_kalendarze_dni k ON k.firma_id = g.firma_id AND k.kalendarz_id = "
    SQL += "g.kalendarz_id AND k.dzien = date_trunc('DAY', g.plan_czas_od) FULL OUTER JOIN rs_kp_dane_osobowe_absencje "
    SQL += "ab ON g.firma_id = ab.firma_id AND g.pracownik_id = ab.pracownik_id "
    SQL += "AND ab.od_kiedy <= date_trunc('DAY', g.plan_czas_od)::DATE AND  date_trunc('DAY', g.plan_czas_od)::DATE "
    SQL += "<= ab.do_kiedy WHERE g.firma_id = '"
    SQL += self.firma_id + "' AND g.pracownik_id = '" + Numer + "' AND plan_czas_od::DATE<='" + DataDo
    SQL += "' AND plan_czas_od::DATE>='" + DataOd + "' AND zatrudnienie_id = " + Zatrudnienie + " AND umowa_id = " + Umowa
    SQL += " AND angaz_id = " + Angaz + " AND godz_ewidencja IS NOT NULL;"
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    rsglobal.ZapiszDoLogow('Zapytanie Ewidencja Czasu Pracy Dane1: '+SQL, 5)
    rsglobal.ZapiszDoLogow('stat: '+str(stat)+str(dane), 5)


