# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_praca_biezaca_karty_pracy.py
# Purpose:     grid z kartami pracy - pracy biecej oraz z oknem danych
# Author:      Piotr Witkowski
# Created:     2017/01/17
# RCS-ID:      $Id: fs_kp_praca_biezaca_karty_pracy.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-06-07 Aleksander Bargie (11080) - dodanie nominau dni/godzin w danych kart pracy
# 2018-06-07 Aleksander Bargie (11078) - dodanie filtrowania po grupie pracownikw
# 2018-09-18 Aleksander Bargie (11224) - Odwie dane w Kartach Pracy
# 2018-09-18 Aleksander Bargie (11244) - Uwzgldnia absencje w dniach przepracowanych w kartach pracy
# 2019-06-13 Aleksander Bargie (11514) - Karty pracy - zmiana (insertujac w godz nadliczbowe 100 wstawiac zawsze 0)
# 2023-01-25 Wojciech Skowron - Poprawka w insertach - wyszczeglnione pola
# 2023-03-07 Aleksander Bargie (13375) - Import kart pracy
# 2023-08-28 Jan Raburski (13512) - przejcie w dniach roboczych na kalendarz

import datetime
import os  #AB 07.03.23r
import tempfile  #AB 07.03.23r

import rs_anakonda_daty

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja'] 
    SlPar={'Rok':[3,4,5,8, 11],'Mc':[3,4,5,8, 11],'Nr':[4,8],'Nazwisko':[4,8],'Komorka':[4,8], 'Plik': [11, ],  #AB 07.03.23r
           'Istn': [11, ],  #AB 07.03.23r
           'Numer':[3,5],'Zatrudnienie':[3,5],'Umowa':[3,5],'Angaz':[3,5],'Identyfikator':[4,8], 'Grupa':[4,8]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_kp_praca_biezaca_karty_pracy z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [3,4,5,8, 11]:  #AB 07.03.23r
            Rok = str(klucze['Rok'])
            Mc = str(klucze['Mc'])
            Mc = '0' + Mc if len(Mc) == 1 else Mc
        if Funkcja in [3,5]:
            Numer = str(klucze['Numer'])
            Zatrudnienie = str(klucze['Zatrudnienie'])
            Umowa = str(klucze['Umowa'])
            Angaz = str(klucze['Angaz'])
        if Funkcja in [4,8]:
            Nr = str(klucze['Nr'])
            Nazwisko = str(klucze['Nazwisko'])
            Komorka = str(klucze['Komorka'])
            Identyfikator = str(klucze['Identyfikator'])
             #AB 08.06.18r dodanie filtrowania po grupie pracownikw
            Grupa = str(klucze['Grupa'])
        if Funkcja in [11, ]:  #AB 07.03.23r
            Plik = klucze['Plik']
            Istn = klucze['Istn']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

#AB 18.09.18r
def InsertujKartyPracy(self, karty, Rok, Mc):
    import datetime
    import rs_anakonda_daty
    stat = 'OK'
    for karta in karty:
        nr         = str(karta[0])
        zatr       = str(karta[4])
        umowa_o_pr = str(karta[5])
        ang        = str(karta[6])

        if stat == 'OK':
            SQL = "SELECT * FROM rs_kp_angaze_karty_pracy "
            SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + nr + "' AND zatrudnienie_id='" + zatr
            SQL += "' AND umowa_id='" + umowa_o_pr + "' AND angaz_id='" + ang + "' AND rok='" + str(
                Rok) + "' AND mc='" + str(Mc) + "';"
            stat, spr, wyn1, dump = self.PolSQL.Execute(SQL, 3)

            if stat != 'OK':
                stat = u'Problemy pobierania danych danych kart pracy'

        if stat == 'OK' and len(spr) == 0:

            if stat == 'OK':
                DataOd = str(Rok) + "-" + str(Mc) + "-01"
                DataDo = str(Rok) + "-" + str(Mc) + "-" + str(rsglobal.PodajOstatniDzien(DataOd))
                SQL = "SELECT count(*) "
                SQL += "FROM rs_kp_grafiki_pozycje g JOIN rs_kp_kalendarze_dni k ON k.firma_id = g.firma_id AND k.kalendarz_id = "
                SQL += "g.kalendarz_id AND k.dzien = date_trunc('DAY', g.plan_czas_od) WHERE g.firma_id = '"
                SQL += self.firma_id + "' AND g.pracownik_id = '" + nr + "' AND plan_czas_od::DATE<='" + DataDo
                SQL += "' AND plan_czas_od::DATE>='" + DataOd + "' AND zatrudnienie_id = " + zatr + " AND umowa_id = " + umowa_o_pr
                SQL += " AND angaz_id = " + ang + " AND godz_harmonogram > '00:00'::time;"
                stat, harm, wyn1, dump = self.PolSQL.Execute(SQL, 3)

            if stat == 'OK':
                DataOd = str(Rok) + "-" + str(Mc) + "-01"
                DataDo = str(Rok) + "-" + str(Mc) + "-" + str(rsglobal.PodajOstatniDzien(DataOd))
                DniHarmonogramu = harm[0][0]
                #AB 01.10.18r
                SQL = "SELECT count(*), coalesce(date_part('minute', sum(godz_ewidencja)), 0)::INT, coalesce(date_part('hour', sum(godz_ewidencja)), 0)::INT  "
                SQL += "FROM rs_kp_grafiki_pozycje g JOIN rs_kp_kalendarze_dni k ON k.firma_id = g.firma_id AND k.kalendarz_id = "
                SQL += "g.kalendarz_id AND k.dzien = date_trunc('DAY', g.plan_czas_od) FULL OUTER JOIN rs_kp_dane_osobowe_absencje "
                SQL += "ab ON g.firma_id = ab.firma_id AND g.pracownik_id = ab.pracownik_id "
                SQL += "AND ab.od_kiedy <= date_trunc('DAY', g.plan_czas_od)::DATE AND  date_trunc('DAY', g.plan_czas_od)::DATE "
                SQL += "<= ab.do_kiedy WHERE g.firma_id = '"
                SQL += self.firma_id + "' AND g.pracownik_id = '" + nr + "' AND plan_czas_od::DATE<='" + DataDo
                SQL += "' AND plan_czas_od::DATE>='" + DataOd + "' AND zatrudnienie_id = " + zatr + " AND umowa_id = " + umowa_o_pr
                #AB 01.10.18r
                SQL += " AND angaz_id = " + ang + " AND godz_ewidencja> '00:00'::time AND (NOT nieobecnosc OR nieobecnosc IS NULL);"
                stat, prac, wyn1, dump = self.PolSQL.Execute(SQL, 3)

            # wykonanie INSERT
            if stat == 'OK':
                # rsglobal.ZapiszDoLogow(str(prac), 5)
                DniPrzepracowane = prac[0][0]
                DataOd = str(Rok) + "-" + str(Mc) + "-01"
                ostDzien = rsglobal.PodajOstatniDzien(DataOd)
                # godz_nominalne = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, str(nr), datetime.date(int(Rok), int(Mc), 1),  datetime.date(int(Rok), int(Mc), ostDzien),) * 8
                godz_nominalne = rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, str(nr), zatr, umowa_o_pr, ang, datetime.date(int(Rok), int(Mc), 1)) * 8
                GodzNormalne = 0
                GodzNad100 = 0
                przeprac = float(prac[0][2]) + float(prac[0][1]) / 60
                # rsglobal.ZapiszDoLogow("      przeprac : " + str(przeprac), 5)
                if godz_nominalne < przeprac:
                    GodzNormalne = godz_nominalne
                    #AB 13.06.19r
                    #GodzNad100 = przeprac - godz_nominalne
                else:
                    GodzNormalne = przeprac
                INSERT = "INSERT INTO  rs_kp_angaze_karty_pracy "
                #WS 2023-01-25
                INSERT += "(firma_id, pracownik_id,zatrudnienie_id, "
                INSERT += "umowa_id, angaz_id, rok, mc, "
                INSERT += "dni_harmonogramu, dni_przepracowane, godz_normalne, godz_nadliczbowe_50, "
                INSERT += "godz_nadliczbowe_100, godz_nadliczbowe_0, godz_sobotnie, godz_doplat_tylko, godz_nocne, godz_krotkich_zwoln) "
                # INSERT += "(firma_id, pracownik_id,zatrudnienie_id,umowa_id,angaz_id,rok,mc) "
                INSERT += " VALUES ('" + self.firma_id + "','" + str(nr) + "','" + str(zatr)
                INSERT += "','" + str(umowa_o_pr) + "','" + str(ang) + "','" + str(Rok) + "','" + str(Mc) + "', "
                INSERT += str(DniHarmonogramu) + ", " + str(DniPrzepracowane) + ", " + str(GodzNormalne) + ",0, "
                INSERT += str(GodzNad100) + ",0,0,0,0,0);"

                if INSERT != '':
                    rsglobal.ZapiszDoLogow(INSERT, 5)
                    stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(INSERT), 1)
                    if stat != 'OK':
                        stat = "Bd przy dodawaniu danych: " + stat
                        dane.append(stat)
            else:
                return stat
    return stat

#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprModyfikowanie=(((self.oddzial_id,'056302') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH KART PRACY (4)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 4:
    sql ="SELECT d.pracownik_id,d.nazwisko,d.imie,a.komorka_id,a.zatrudnienie_id,a.umowa_id,a.angaz_id,a.od_kiedy,a.do_kiedy "
    sql+="FROM rs_kp_dane_osobowe d  JOIN rs_kp_angaze a ON d.firma_id = a.firma_id AND d.pracownik_id = a.pracownik_id "
    sql+="WHERE a.firma_id='"+str(self.firma_id)+"' AND "
    if len(Mc)==1:
        Mc='0'+Mc
    DataOd = str(Rok)+"-"+str(Mc)+"-01"
    DataDo = str(Rok)+"-"+str(Mc)+"-"+ str(rsglobal.PodajOstatniDzien(DataOd))
    sql+=" a.od_kiedy<='"+DataDo+"' AND (a.do_kiedy>='"+DataOd+"' OR a.do_kiedy ISNULL)"
    if Nr != '':
        sql += " AND d.pracownik_id::integer = " + (Nr) + ""
    if Nazwisko != '':
        sql += " AND upper(nazwisko) LIKE '" + Nazwisko.upper() + "%'"
    if Komorka != '':
        sql += " AND upper(a.komorka_id) LIKE '" + Komorka.upper() + "%'"
    if Identyfikator != '':
        sql += " AND a.lista_id='"+Identyfikator+"' "
             #AB 08.06.18r dodanie filtrowania po grupie pracownikw
    if Grupa != '':
        sql += " AND a.grupa_pracownikow_id='"+Grupa+"' "

    slownik = {}

    SQL = "SELECT rsf_kadry_lista_dozwolonych_pracownikow("
    SQL += "'" + self.firma_id + "','" + str(self.operator_id) + "','kartoteka_osobowa');"
    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania listy dozwolonych pracownikw : ' + stat
    else:
        wynik = rsglobal.rseval(d[0][0])
        slownik = eval(wynik[2][-1])
        if str(wynik[0]) != 'OK':
            stat = 'Bd pobrania listy dozwolonych pracownikw (rsf): ' + stat
        else:
            lista = wynik[1]
            if len(lista) == 0:
                # ten myk pozwoli wyswietlic pustego grida przy braku dozwolonych pracownikow
                sql += " AND d.pracownik_id IN ('x')"
            elif len(lista) == 1:
                if lista[0] != '**':
                    sql += " AND d.pracownik_id IN (" + str(lista)[1:-1] + ")"
            else:
                sql += " AND d.pracownik_id IN (" + str(lista)[1:-1] + ")"

            sql += " ORDER BY d.pracownik_id,a.zatrudnienie_id,a.umowa_id,a.angaz_id,a.od_kiedy;"

    if stat == 'OK':
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow('Zapytanie pobierajce karty pracy: '+sql,1)
        rsglobal.ZapiszDoLogow('stat: '+str(stat)+str(dane),1)
        if stat<>'OK':
            stat="Bd przy pobieraniu danych : "+stat
            dane.append(stat)

        #AB 18.09.18r
    if UprModyfikowanie:
        if stat == 'OK':
            stat = InsertujKartyPracy(self, dane, Rok, Mc)


#-------------------------------------------------------------------------------
#---   UPDATE KARTY PRACY DANE (1)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 3:

    if not UprModyfikowanie:
        stat = 'Brak uprawnie do modyfikowania kart pracy'

    # wykonanie UPDATE
    if stat=='OK':
        sql=''
        UPDATE="UPDATE rs_kp_angaze_karty_pracy "
        SET='SET '
        WHERE=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Numer)+"' AND zatrudnienie_id='"+str(Zatrudnienie)
        WHERE+="' AND umowa_id='"+str(Umowa)+"' AND angaz_id='"+str(Angaz)+"' AND rok='"+str(Rok)+"' AND mc='"+str(Mc)+"' "

        for j in xrange(len(pola)):
            pole=pola[j]
            wart=wartosci[j]
            if pole in ['dni_harmonogramu','dni_przepracowane','godz_normalne','godz_nadliczbowe_50',
                        'godz_nadliczbowe_100','godz_nadliczbowe_0','godz_sobotnie','godz_doplat_tylko',
                        'godz_nocne','godz_krotkich_zwoln']:
                SET+=pole+"='"+str(wart)+"',"

        SET=SET.strip(",")
        sql+=UPDATE+SET+WHERE+";"
        stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
        if stat<>'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)


# -------------------------------------------------------------------------------
# ---   INSERT (1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 5:
    SQL = "SELECT * FROM rs_kp_angaze_karty_pracy "
    SQL +=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Numer)+"' AND zatrudnienie_id='"+str(Zatrudnienie)
    SQL +="' AND umowa_id='"+str(Umowa)+"' AND angaz_id='"+str(Angaz)+"' AND rok='"+str(Rok)+"' AND mc='"+str(Mc)+"';"
    stat, spr, wyn1, dump = self.PolSQL.Execute(SQL, 3)

    if stat <>'OK':
        stat = u'Problemy pobierania danych danych kart pracy'

if stat == 'OK' and Funkcja == 5 and len(spr)==0:

    if stat == 'OK' and UprModyfikowanie:
        DataOd = str(Rok) + "-" + str(Mc) + "-01"
        DataDo = str(Rok) + "-" + str(Mc) + "-" + str(rsglobal.PodajOstatniDzien(DataOd))
        SQL = "SELECT count(*) "
        SQL += "FROM rs_kp_grafiki_pozycje g JOIN rs_kp_kalendarze_dni k ON k.firma_id = g.firma_id AND k.kalendarz_id = "
        SQL += "g.kalendarz_id AND k.dzien = date_trunc('DAY', g.plan_czas_od) WHERE g.firma_id = '"
        SQL += self.firma_id + "' AND g.pracownik_id = '" + Numer + "' AND plan_czas_od::DATE<='" + DataDo
        SQL += "' AND plan_czas_od::DATE>='" + DataOd + "' AND zatrudnienie_id = " + Zatrudnienie + " AND umowa_id = " + Umowa
        SQL += " AND angaz_id = " + Angaz + " AND godz_harmonogram > '00:00'::time;"
        stat, harm, wyn1, dump = self.PolSQL.Execute(SQL, 3)

    if stat == 'OK' and UprModyfikowanie:
        DataOd = str(Rok) + "-" + str(Mc) + "-01"
        DataDo = str(Rok) + "-" + str(Mc) + "-" + str(rsglobal.PodajOstatniDzien(DataOd))
        DniHarmonogramu = harm[0][0]
                #AB 01.10.18r
        SQL = "SELECT count(*), coalesce(date_part('minute', sum(godz_ewidencja)), 0)::INT, coalesce(date_part('hour', sum(godz_ewidencja)), 0)::INT  "
        SQL += "FROM rs_kp_grafiki_pozycje g JOIN rs_kp_kalendarze_dni k ON k.firma_id = g.firma_id AND k.kalendarz_id = "
                #AB 01.10.18r
        SQL += "g.kalendarz_id AND k.dzien = date_trunc('DAY', g.plan_czas_od) WHERE g.firma_id = '"
        SQL += self.firma_id + "' AND g.pracownik_id = '" + Numer + "' AND plan_czas_od::DATE<='" + DataDo
        SQL += "' AND plan_czas_od::DATE>='" + DataOd + "' AND zatrudnienie_id = " + Zatrudnienie + " AND umowa_id = " + Umowa
                #AB 01.10.18r
        SQL += " AND angaz_id = " + Angaz + " AND godz_ewidencja> '00:00'::time AND (NOT nieobecnosc OR nieobecnosc IS NULL);"
        stat, prac, wyn1, dump = self.PolSQL.Execute(SQL, 3)


    # wykonanie INSERT
    if stat == 'OK' and UprModyfikowanie:
        #rsglobal.ZapiszDoLogow(str(prac), 5)
        DniPrzepracowane = prac[0][0]
        DataOd = str(Rok) + "-" + str(Mc) + "-01"
        ostDzien = rsglobal.PodajOstatniDzien(DataOd)
        #JR godz_nominalne = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, str(Numer), datetime.date(int(Rok), int(Mc), 1),
        #                                                                     datetime.date(int(Rok), int(Mc), ostDzien)) * 8
        godz_nominalne = rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, str(Numer), Zatrudnienie, Umowa, Angaz,  datetime.date(int(Rok), int(Mc), 1)) * 8
        GodzNormalne = 0
        GodzNad100 = 0
        przeprac = float(prac[0][2]) + float(prac[0][1])/60
        #rsglobal.ZapiszDoLogow("      przeprac : " + str(przeprac), 5)
        if godz_nominalne < przeprac:
            GodzNormalne = godz_nominalne
            #AB 13.06.19r
            #GodzNad100 = przeprac - godz_nominalne
        else:
            GodzNormalne = przeprac
        INSERT = "INSERT INTO  rs_kp_angaze_karty_pracy "
        #WS 2023-01-25
        INSERT += "(firma_id, pracownik_id,zatrudnienie_id, "
        INSERT += "umowa_id, angaz_id, rok, mc, "
        INSERT += "dni_harmonogramu, dni_przepracowane, godz_normalne, godz_nadliczbowe_50, "
        INSERT += "godz_nadliczbowe_100, godz_nadliczbowe_0, godz_sobotnie, godz_doplat_tylko, godz_nocne, godz_krotkich_zwoln) "
        #INSERT += "(firma_id, pracownik_id,zatrudnienie_id,umowa_id,angaz_id,rok,mc) "
        INSERT += " VALUES ('" + self.firma_id + "','" + str(Numer) + "','" + str(Zatrudnienie)
        INSERT += "','" + str(Umowa) + "','" + str(Angaz) + "','" + str(Rok) + "','" + str(Mc) + "', "
        INSERT += str(DniHarmonogramu) + ", " + str(DniPrzepracowane) + ", " + str(GodzNormalne) + ",0, "
        INSERT += str(GodzNad100) + ",0,0,0,0,0);"

        if INSERT != '':
            rsglobal.ZapiszDoLogow(INSERT, 5)
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(INSERT), 1)
            if stat != 'OK':
                stat = "Bd przy dodawaniu danych: " + stat
                dane.append(stat)


# ----------------------------------------------
# POBIERANIE DANYCH - KARTY PRACY DANE (1,5)
# ----------------------------------------------
#AB 07.06.18r za rad Piotra stat sprawdzany jako pierwszy
if stat == 'OK' and Funkcja in [3,5,]:
    #AB 07.06.18r  dodanie nominau dni/godzin w danych kart pracy
    SQL = "SELECT 0::numeric as \"godz_nominalne\", 0::numeric as \"dni_nominalne\",dni_harmonogramu,dni_przepracowane,"
    SQL += "godz_normalne,godz_nadliczbowe_50,godz_nadliczbowe_100,godz_nadliczbowe_0, "
    SQL += "godz_sobotnie,godz_doplat_tylko,godz_nocne,godz_krotkich_zwoln FROM rs_kp_angaze_karty_pracy "
    SQL += "WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + str(Numer) + "' "
    SQL += "AND zatrudnienie_id='" + str(Zatrudnienie) + "' "
    SQL += "AND umowa_id='"+str(Umowa)+"' AND angaz_id='"+str(Angaz)+"' AND rok='"+str(Rok)+"' AND mc='"+str(Mc)+"';"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = u'Problemy pobierania danych danych karty pracy'
        rsglobal.ZapiszDoLogow("SQL: " + SQL + "    STAT: " + str(stat))
        #AB 07.06.18r  dodanie nominau dni/godzin w danych kart pracy
    elif len(dane) == 0:
        stat = 'BR_KP'
    else:
        DataOd = str(Rok) + "-" + str(Mc) + "-01"
        ostDzien = rsglobal.PodajOstatniDzien(DataOd)

        #JR ilosc_dni_pracujacych = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, str(Numer), datetime.date(int(Rok), int(Mc), 1),
        #                                                             datetime.date(int(Rok), int(Mc), ostDzien),)
        ilosc_dni_pracujacych = rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, str(Numer), Zatrudnienie, Umowa, Angaz,  datetime.date(int(Rok), int(Mc), 1))

        dane[0][1] = ilosc_dni_pracujacych
        ilosc_godzin_pracujacych = ilosc_dni_pracujacych * 8
        dane[0][0] = ilosc_godzin_pracujacych

        rsglobal.ZapiszDoLogow(str(dane) + str(wyn1), 5)

#AB 25.06.18r
# ----------------------------------------------
# ODSWIEZANIE DANYCH
# ----------------------------------------------
if stat == 'OK' and Funkcja == 8:
    if not UprModyfikowanie:
        stat = 'Brak uprawnie do modyfikowania kart pracy'

    # wykonanie UPDATE
    if stat == 'OK':
        DataOd = str(Rok) + "-" + str(Mc) + "-01"
        ostDzien = rsglobal.PodajOstatniDzien(DataOd)
        DataDo = str(Rok) + "-" + str(Mc) + "-" + str(ostDzien)
        #JR !!! do przemyslenia skoro zmieniamy sposb liczenia na wg kalendarzy, dla wielu pracownikow nie policzy wg kalendarzy
        #JR ilosc_dni_pracujacych = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, str(Nr), datetime.date(int(Rok), int(Mc), 1),
        #                                                                     datetime.date(int(Rok), int(Mc), ostDzien),
        #                                                             )
        ilosc_dni_pracujacych = rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, str(Numer), Zatrudnienie, Umowa, Angaz,  datetime.date(int(Rok), int(Mc), 1))
        ilosc_godzin_pracujacych = str(ilosc_dni_pracujacych * 8)

        SEL = "SELECT '" + self.firma_id + "' AS firma_id, g.pracownik_id, zatrudnienie_id, umowa_id, angaz_id, "
        SEL += "'" + str(Rok) + "' AS rok, '" + str(Mc) + "' AS mc, "  # 5, 6
        SEL += "sum(CASE WHEN  godz_harmonogram> '00:00'::time THEN 1 ELSE 0 END) AS dni_harmonogramu, "  # 7
                #AB 01.10.18r
        SEL += "sum(CASE WHEN  godz_ewidencja> '00:00'::time AND (NOT nieobecnosc OR nieobecnosc IS NULL) THEN 1 ELSE 0 END) AS dni_przepracowane, "  # 8
        SEL += "CASE WHEN COALESCE(date_part('hour', sum(CASE WHEN nieobecnosc THEN '00:00'::TIME ELSE godz_ewidencja END)),0)::INT > " + ilosc_godzin_pracujacych
        SEL += " THEN " + ilosc_godzin_pracujacych + " ELSE COALESCE(date_part('hour', sum(CASE WHEN nieobecnosc THEN '00:00'::TIME ELSE godz_ewidencja END)),0) + "
        SEL += "COALESCE(date_part('minute', sum(CASE WHEN nieobecnosc THEN '00:00'::TIME ELSE godz_ewidencja END)),0)/60 END AS godz_normane, "  # 9
        SEL += "CASE WHEN COALESCE(date_part('hour', sum(CASE WHEN nieobecnosc THEN '00:00'::TIME ELSE godz_ewidencja END)),0)::INT > " + ilosc_godzin_pracujacych
        SEL += " THEN COALESCE(date_part('hour', sum(CASE WHEN nieobecnosc THEN '00:00'::TIME ELSE godz_ewidencja END)),0) + COALESCE(date_part('minute', "
        SEL += "sum(CASE WHEN nieobecnosc THEN '00:00'::TIME ELSE godz_ewidencja END)),0)/60 - " + ilosc_godzin_pracujacych + " ELSE 0 END AS godz_nadliczbowe_100 "  # 10
        SEL += "FROM rs_kp_grafiki_pozycje g JOIN rs_kp_angaze a USING (firma_id, pracownik_id, zatrudnienie_id, "
        SEL += "umowa_id, angaz_id) JOIN rs_kp_dane_osobowe d USING (firma_id, pracownik_id) "
        SEL += "WHERE g.firma_id = '" + self.firma_id + "'AND plan_czas_od::DATE<='" + DataDo + "' "
        SEL += "AND plan_czas_od::DATE>='" + DataOd + "' "
        if Nr != '':
            SEL += " AND d.pracownik_id::integer = " + (Nr) + ""
        if Nazwisko != '':
            SEL += " AND upper(nazwisko) LIKE '" + Nazwisko.upper() + "%'"
        if Komorka != '':
            SEL += " AND upper(a.komorka_id) LIKE '" + Komorka.upper() + "%'"
        if Identyfikator != '':
            SEL += " AND a.lista_id='" + Identyfikator + "' "
            # AB 08.06.18r dodanie filtrowania po grupie pracownikw
        if Grupa != '':
            SEL += " AND a.grupa_pracownikow_id='" + Grupa + "' "
        SEL += "GROUP BY g.pracownik_id, zatrudnienie_id, umowa_id, angaz_id;"
        rsglobal.ZapiszDoLogow(SEL, 5)
        stat, doUpd, dump, dump = self.PolSQL.Execute(SEL, 3)
        rsglobal.ZapiszDoLogow(doUpd, 5)

        if stat != 'OK':
            stat = "Bd pobierania danych do odwieania kart pracy. " + stat
        else:
            for wiersz in doUpd:
                WHERE = "WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + wiersz[1] + "' AND "
                WHERE += "zatrudnienie_id=" + str(wiersz[2]) + " AND umowa_id=" + str(wiersz[3]) + " AND "
                WHERE += "angaz_id=" + str(wiersz[4]) + " AND rok='" + str(Rok) + "' AND mc='" + str(Mc) + "' "

                SET = "SET dni_harmonogramu=" + str(wiersz[7]) + ", dni_przepracowane=" + str(wiersz[8]) + ", "
                SET += "godz_normalne=" + str(wiersz[9]) + ", godz_nadliczbowe_50=0, "
                # SET += "godz_nadliczbowe_100=" + str(wiersz[10]) + ", godz_nadliczbowe_0=0, godz_sobotnie=0, "
                SET += "godz_nadliczbowe_100=0, godz_nadliczbowe_0=0, godz_sobotnie=0, "
                SET += "godz_doplat_tylko=0, godz_nocne=0, godz_krotkich_zwoln=0"

                UPD = "UPDATE rs_kp_angaze_karty_pracy " + SET + WHERE + " ;"
                rsglobal.ZapiszDoLogow(UPD, 5)
                stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1)
                if stat != 'OK':
                    stat = "Bd aktualizacji danych w trakcie odwieania kart pracy. " + stat

# ----------------------------------------------
# IMPORT DANYCH Z CSV - 11  #AB 07.03.23r
# ----------------------------------------------

if stat == 'OK' and Funkcja == 11:
    if not UprModyfikowanie:
        stat = 'Brak uprawnie do modyfikowania kart pracy'

    if stat == 'OK':
        import binascii

        Tresc = binascii.unhexlify(Plik)  #pliki zawsze przesyamy z uyciem hexlify wic przywracamy normalny format

        obowiazkowe = ('pracownik_id', 'zatrudnienie_id', 'umowa_id', 'angaz_id', 'rok', 'mc')
        dozwolone = ('pracownik_id', 'zatrudnienie_id', 'umowa_id', 'angaz_id',
                     'dni_harmonogramu', 'dni_przepracowane', 'godz_normalne', 'godz_nadliczbowe_50',
                     'godz_nadliczbowe_100', 'godz_nadliczbowe_0', 'godz_sobotnie', 'godz_doplat_tylko',
                     'godz_nocne', 'godz_krotkich_zwoln')
        zawartosc = Tresc.splitlines()  # dzielimy po wierszach
        kolumny = zawartosc[0].split(';')  # pierwszy wiersz zawiera nagwki, robimy od razu ich list
        zawartosc = zawartosc[1:]  # kolejne wiersze to zawarto
        ilosc_kolumn = len(kolumny)

    if stat == 'OK':
        for kol in obowiazkowe:
            if kol not in kolumny:
                stat = "W pliku do importu zabrako obowizkowej kolumny '{}'".format(kol)
                rsglobal.ZapiszDoLogow("Tresc: \n"+str(Tresc))
                break

    # nie sprawdzamy bdnych kolumn, po prostu je ignorujemy
    # if stat == 'OK':
    #     for kol in kolumny:
    #         if kol not in dozwolone:
    #             stat = "W pliku do importu wystpuje niepoprawna kolumna '{}'".format(kol)

    if stat == 'OK':
        i = 1  #liczba techniczna, do zwracania numeru wiersza w bdzie
        for wiersz in zawartosc:
            if stat == 'OK':
                i += 1
                tmp_w = wiersz.split(';')  # zawartosc wiersza
                slownik_wiersza = {}
                if len(tmp_w) != ilosc_kolumn:
                    stat = 'Niepoprawna ilo kolumn w wierszu {}'.format(i)
                    rsglobal.ZapiszDoLogow("wiersz: \n"+str(wiersz))
                    break
                for k, w in zip(kolumny, tmp_w):  # robimy slownik w formie {nazwa_kolumny: wartosc} by wygodniej
                                                  # korzystac z danych
                    slownik_wiersza[k] = w

                for k in obowiazkowe:
                    if slownik_wiersza[k].strip() == '':
                        rsglobal.ZapiszDoLogow("wiersz: \n"+str(wiersz))
                        stat = "Kolumna '{}' nie moe by pusta".format(k)
                        break

            if stat == 'OK':

                """Test, czy mamy 1. pracownika(0 wierszy jeli brak), 2. zatrudnienie(z.firma_id jest NULLEM jeli 
                brak) itd."""

                SQL_TEST = """SELECT z.firma_id IS NOT NULL AS zatr, u.firma_id IS NOT NULL AS umowa, a.firma_id IS NOT NULL AS angaz 
                              FROM rs_kp_dane_osobowe prac
                              LEFT JOIN rs_kp_zatrudnienie  z ON (z.firma_id, z.pracownik_id, z.numer_id) = 
                                                                 (prac.firma_id, prac.pracownik_id, %s)
                              LEFT JOIN rs_kp_umowy_o_prace u ON (u.firma_id, u.pracownik_id, zatrudnienie_id, umowa_id) = 
                                                                 (z.firma_id, z.pracownik_id, z.numer_id, %s)
                              LEFT JOIN rs_kp_angaze a ON (u.firma_id, u.pracownik_id, u.zatrudnienie_id, u.umowa_id, %s) = 
                                                          (a.firma_id, a.pracownik_id, a.zatrudnienie_id, a.umowa_id, a.angaz_id)
                              WHERE prac.firma_id = %s AND prac.pracownik_id = %s
                              ;"""
                args = [slownik_wiersza['zatrudnienie_id'], slownik_wiersza['umowa_id'], slownik_wiersza['angaz_id'],
                        self.firma_id, slownik_wiersza['pracownik_id']]

                args = [str(x) if isinstance(x, unicode) else x for x in args]
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL_TEST, args))
                stat, test, dump, dump = self.PolSQL.Execute(SQL_TEST, 3, args, CzyDodawacBlad=True)
                if stat != 'OK':  # blad sprawdzenia
                    stat = "Bd sprawdzania danych pracownika: " + stat
                    break
                elif len(test) == 0:  # pobrano 0 wierszy - pracownika nei ma w danych osobowych
                    stat = "Nie odnaleziono pracownika {}".format(slownik_wiersza['pracownik_id'])
                    break
                elif not test[0][0]:  # z.firma_id jest nullem czyli nie ma zatrudnienia
                    stat = "Nie odnaleziono zatrudnienia {} dla pracownika {}".format(slownik_wiersza['zatrudnienie_id'],
                                                                                      slownik_wiersza['pracownik_id'])
                    break
                elif not test[0][1]:  # u.firma_id jest nullem czyli nie ma umowy
                    stat = "Nie odnaleziono umowy {} dla zatrudnienia {}, pracownika {}".format(slownik_wiersza['umowa_id'],
                                                                                                slownik_wiersza['zatrudnienie_id'],
                                                                                                slownik_wiersza['pracownik_id'])
                    break
                elif not test[0][1]:  # a.firma_id jest nullem czyli nie ma angau
                    stat = "Nie odnaleziono angau {} dla umowy {}, zatrudnienia {}, pracownika {}".format(slownik_wiersza['angaz_id'],
                                                                                                           slownik_wiersza['umowa_id'],
                                                                                                           slownik_wiersza['zatrudnienie_id'],
                                                                                                           slownik_wiersza['pracownik_id'])
                    break
            if stat == 'OK' and not Istn:  # nie odpalona flaga nadpisywania istniejacych, wiec test czy karta juz istnieje
                SQL_ISTN = """SELECT 1
                              FROM rs_kp_angaze_karty_pracy
                              WHERE firma_id=%s AND pracownik_id=%s AND zatrudnienie_id=%s AND umowa_id=%s AND angaz_id=%s AND rok=%s AND mc=%s;
                              """
                args = [self.firma_id, slownik_wiersza['pracownik_id'], slownik_wiersza['zatrudnienie_id'],
                        slownik_wiersza['umowa_id'], slownik_wiersza['angaz_id'], Rok, Mc]

                args = [str(x) if isinstance(x, unicode) else x for x in args]
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL_ISTN, args))
                stat, test2, dump, dump = self.PolSQL.Execute(SQL_ISTN, 3, args, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd sprawdzania kart pracy pracownika: " + stat
                    break
                elif len(test2) != 0:
                    stat = 'ISTN'
                    break

            if stat == 'OK':
                kolumny_ins = ['firma_id', 'rok', 'mc']  # nazwy kolumn do insertu
                args1       = [self.firma_id, Rok, Mc]  # wartosci kolumn do insertu
                #  dodatkowe zmienne pomocnicze jeli nadpisujemy istniejce
                args2       = []  # formulki typu koluma=%s do update'u(uzycie args podmienia %s na odpowiednia wartosc)
                update      = []  # wartosci do update'u
                szkielet_sql = """INSERT INTO rs_kp_angaze_karty_pracy
                                  ({kolumny_ins})
                                  VALUES({wart_ins})"""
                if Istn:  # ta formulka pozwala w przypadku napotkania istniejacego wiersza puscic update, tylko
                          # zamiast where <klucz> pisze si on conflict(kolumny_z_klucza), zawartosc po SET pozostaje
                          # taka sama
                    szkielet_sql += """ON CONFLICT (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id, rok, mc) DO 
                                       UPDATE SET {update}
                                    """
                for k in slownik_wiersza:  # k to nazwa kolumny
                    if k == 'rok' and slownik_wiersza[k] != Rok:
                        stat = "Import na rok {}, w danych podano rok {}".format(Rok, slownik_wiersza[k])
                        break

                    if stat == 'OK' and k == 'mc' and slownik_wiersza[k] != Mc:
                        stat = "Import na miesic {}, w danych podano miesic {}".format(Mc, slownik_wiersza[k])
                        break
                    # tylko z bialej listy pl, rok i mc ju wpisane podczas definicji bo to pola obowiazkowe
                    if stat == 'OK' and k not in ('rok', 'mc') and k in dozwolone:
                        kolumny_ins.append(k)
                        args1.append(slownik_wiersza[k])
                    # kawalek on conflict kleimy tylko jesli chcemy robic update istniejacych danych
                    if stat == 'OK' and Istn and k not in ('rok', 'mc') and k in dozwolone:
                        update.append("{}=%s".format(k))
                        args2.append(slownik_wiersza[k])

                if stat == 'OK':
                    if Istn:  # jest kawalek on conflict
                        SQL = szkielet_sql.format(kolumny_ins=', '.join(kolumny_ins),
                                                  wart_ins=', '.join(['%s' for x in kolumny_ins]),
                                                  update=', '.join(update))
                        args = args1 + args2
                    else:  # brak on conflict update
                        SQL = szkielet_sql.format(kolumny_ins=', '.join(kolumny_ins),
                                                  wart_ins=', '.join(['%s' for x in kolumny_ins]))
                        args = args1
                    # przerobka z unicode na str bo Execute tego nie akceptuje
                    args = [str(x) if isinstance(x, unicode) else x for x in args]
                    args = [None if x.strip() == '' else x for x in args]
                    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args)) # zapis zapytania do logow
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, args, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd dodawania kart pracy: " + stat
                        break
