# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_praca_biezaca_zmiana_angazy.py
# Purpose:     edycja/pobieranie/zamykanie/otwieranie paczek zmian angay
# Author:      Wojciech Skowron
# Created:     2019/06/14
# RCS-ID:      $Id: fs_kp_praca_biezaca_zmiana_angazy.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-06-27 Wojciech Skowron - (11528) Zmiana w insercie pozycji - pobieranie 'kategoria_zaszeregowania' z angay,
#                                       pola _n  domylnie puste

from funkcje import fs_kp_praca_biezaca_zmiana_angazy_pom

import datetime
import rsglobal

#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Komorka':[1,5,],'Grupa':[1,5,],'Opis':[1,],'DataOd':[5,],'DataDo':[5,],'FStan':[5,],
           'Data':[2,6,7],'Oddzial':[1,2,6,7],'Numer':[2,6,7],'Pracownik':[5,],'OdDnia':[1,]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_praca_biezaca_zmiana_angazy z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat == 'OK':
        if Funkcja in [1,5]:
            Komorka = rsglobal.Dekoduj(klucze['Komorka'])
            Grupa   = rsglobal.Dekoduj(klucze['Grupa'])
        if Funkcja in [1,]:
            Opis = rsglobal.Dekoduj(klucze['Opis'])
            OdDnia = rsglobal.Dekoduj(klucze['OdDnia'])
        if Funkcja in [5,]:
            DataOd = rsglobal.Dekoduj(klucze['DataOd'])
            DataDo = rsglobal.Dekoduj(klucze['DataDo'])
            FStan = rsglobal.Dekoduj(klucze['FStan'])
            Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        if Funkcja in [2,6,7]:
            Data = rsglobal.Dekoduj(klucze['Data'])
        if Funkcja in [1,2,6,7]: 
            Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
        if Funkcja in [2,6,7]: 
            Numer = rsglobal.Dekoduj(str(klucze['Numer']))

dane = []

#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprPrz=(((self.oddzial_id,'056501') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprMod=(((self.oddzial_id,'056502') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprOtw=(((self.oddzial_id,'056503') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZam=(((self.oddzial_id,'056504') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   DELETE (2)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,]:
    if not UprMod:
        stat=u'Brak uprawnie do usuwania'
    else:
        delete ="DELETE from rs_kp_zmiany_angazy"
        delete+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        delete+=" AND data = '"+Data+"' AND numer='"+Numer+"';"
        rsglobal.ZapiszDoLogow('zamkniecie absencji '+delete,1)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(delete),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat=u'Bd usuwania danych: '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   INSERT DANYCH 
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1,]:
    if not UprMod:
        stat=u'Brak uprawnie do dodawania'
    else:
        Data = datetime.date.today()

        sql ="SELECT COALESCE((SELECT Max(numer)+1 FROM rs_kp_zmiany_angazy WHERE firma_id='"
        sql+=self.firma_id+"' AND oddzial_id='"+str(Oddzial)+"' AND data='"+str(Data)+"'),1);"
        rsglobal.ZapiszDoLogow('sql zmiany angay '+sql,1)
        stat,d,dump,dump=self.PolSQL.Execute(sql,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat=u'Bd dodawania zmiany angay: '+stat
            dane.append(stat)
        else:
            Nr = rsglobal.Dekoduj(d[0][0])


            ins ="INSERT INTO rs_kp_zmiany_angazy(firma_id, oddzial_id, data, numer, od_dnia, komorka_id,"
            ins+="stan, grupa_pracownikow_id, opis)"
            ins+=" VALUES ('"+self.firma_id+"','"+str(Oddzial)+"','"+str(Data)+"',"+str(Nr)+","
            ins+="'"+str(OdDnia)+"',"+str("'"+Komorka+"'" if Komorka!='' else 'NULL')+","
            ins+="'W',"+str("'"+Grupa+"'" if Grupa!='' else 'NULL')+",'"+str(Opis)+"');"
            rsglobal.ZapiszDoLogow('ins paczki zmiany angay '+ins,1)
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(ins),1,CzyDodawacBlad=True)
            if stat != 'OK':
                stat=u'Bd dodawania zmiany angay: '+stat
                dane.append(stat)

        if stat == 'OK':
            ins ="""INSERT INTO rs_kp_zmiany_angazy_pozycje
                                (firma_id, oddzial_id, data, numer,
                                pracownik_id, zatrudnienie_id, umowa_id, angaz_id,
                                placa, stawka, dodatek_fun, lista_id, kategoria_zaszeregowania)
                        SELECT firma_id, '{oddzial}','{data}',{numer},pracownik_id, zatrudnienie_id, umowa_id, angaz_id, 
                               placa, stawka, dodatek_fun, lista_id, kategoria_zaszeregowania
                        FROM rs_kp_angaze a1 
                        WHERE firma_id = '{firma}' 
                            AND '{komorka}' in ('', komorka_id, '**') AND '{grupa}' in ('', grupa_pracownikow_id, '???')
                            AND od_kiedy <'{od_dnia}'
                            AND (do_kiedy >='{od_dnia}' OR do_kiedy IS NULL)
                            AND angaz_id = (SELECT max(angaz_id) 
                                            FROM rs_kp_angaze a2 
                                            WHERE (a1.firma_id, a1.pracownik_id, a1.zatrudnienie_id, a1.umowa_id) = 
                                                  (a2.firma_id, a2.pracownik_id, a2.zatrudnienie_id, a2.umowa_id));
                 """.format(firma=self.firma_id, oddzial=Oddzial, data=Data, numer=Nr, komorka=Komorka.strip(), grupa=Grupa.strip(), od_dnia=OdDnia)
            rsglobal.ZapiszDoLogow('ins pozycji zmiany angay '+ins,1)
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(ins),1,CzyDodawacBlad=True)
            if stat != 'OK':
                stat=u'Bd dodawania pozycji zmiany angay: '+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   Zamknicie (6)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [6,]:
    if not UprZam:
        stat=u'Brak uprawnie do zamykania'
    else:
        klucz = {}
        klucz['oddzial_id'] = Oddzial
        klucz['data'] = Data
        klucz['numer'] = Numer
        stat = fs_kp_praca_biezaca_zmiana_angazy_pom.zamknij(self, klucz)
        if stat != 'OK':
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   Otwarcie (7)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [7,]:
    if not UprOtw:
        stat=u'Brak uprawnie do otwierania'
    else:
        klucz = {}
        klucz['oddzial_id'] = Oddzial
        klucz['data'] = Data
        klucz['numer'] = Numer
        stat = fs_kp_praca_biezaca_zmiana_angazy_pom.otworz(self, klucz)
        if stat != 'OK':
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,5)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 5:
    if not UprPrz:
        stat=u'Brak uprawnie do przegldania'

    if stat == 'OK' and rsglobal.SprawdzCzyToData(DataOd) and rsglobal.SprawdzCzyToData(DataDo):
        if DataOd > DataDo:
            stat = "Data od jest wiksza od daty do"
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT stan, oddzial_id, data, numer, od_dnia, komorka_id, k.opis, z.grupa_pracownikow_id,g.opis,z.opis FROM rs_kp_zmiany_angazy z "
        sql+="LEFT JOIN rs_komorki_zatrudniajace k ON komorka_id=kod AND z.firma_id=k.firma_id "
        sql+="LEFT JOIN rs_grupy_pracownikow g ON z.grupa_pracownikow_id=g.kod AND z.firma_id=g.firma_id "
        sql+="WHERE z.firma_id='"+str(self.firma_id)+"'"
        if rsglobal.SprawdzCzyToData(DataOd):
            sql += " AND od_dnia>='"+DataOd+"'"
        if rsglobal.SprawdzCzyToData(DataDo):
            sql += " AND od_dnia<='"+DataDo+"'"
        if Komorka <> '':
            sql+= " AND komorka_id LIKE '"+Komorka+"%'"
        if FStan != '':
            sql+= " AND stan='"+FStan+"'"
        if Grupa <> '':
            sql+= " AND z.grupa_pracownikow_id LIKE '"+Grupa+"%'"
        if Pracownik != '':
            Pracownik = ('000000' + str(Pracownik))[-6:]
            sql+= " AND EXISTS (SELECT 1 FROM rs_kp_zmiany_angazy_pozycje zp WHERE zp.firma_id = z.firma_id AND zp.oddzial_id=z.oddzial_id AND zp.data=z.data AND z.numer=zp.numer AND zp.pracownik_id ='"+Pracownik+"') "
        sql += " ORDER BY z.od_dnia DESC, z.numer DESC;"
        rsglobal.ZapiszDoLogow(sql, 1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat="Bd przy pobieraniu danych : "+stat
            dane.append(stat)
