#!/usr/bin/python
# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:             fs_kp_praca_biezaca_zmiana_angazy_pom.py
# Purpose:          funkcje pomocnicze do zmiany angay
# Author:           Aleksander Bargie
# Created:          2019/06/17
# RCS-ID:           $Id: fs_kp_praca_biezaca_zmiana_angazy_pom.py $
# Copyright:        (c) 2019 RecordSystem
# Licence:          GNU GPL
# -------------------------------------------------------------------------------
# 2019-06-28 Aleksander Bargie - (11532) Nowa kolumna w zmianie angay do uwzgldnienia w zamykaniu paczki
# 2020-09-08 Aleksander Bargie - (11923) Grupowa zmiana angay - uwagi z Hali
# 2021-12-23 Bartosz Pagan     - (12779) - Grupowa zmiana angay - kopiowanie checkboxow
# 2022-05-23 (13030) Aleksander Bargie - Wpisanie daty do w umowie lub angazu powioduje zmiane stanu zatrudnienia na Z
# 2023-03-15 Jan Raburski       - (13388)  sprawdzanie list plac - uwzglednianie pracownikow

def _sprawdz_listy_plac(self, data, numer, oddzial_id, data_paczki):
    #SQL = """SELECT numer_listy_id FROM rs_kp_listy_plac WHERE firma_id='{}' AND data_do >= '{}';""".format(self.firma_id, data)
    SQL = """SELECT DISTINCT klp.numer_listy_id FROM rs_kp_listy_plac_osoby lpo
     INNER JOIN rs_kp_listy_plac klp USING (firma_id, numer_listy_id) WHERE lpo.firma_id='{firma}' AND klp.data_od >= '{data}'
     AND lpo.pracownik_id IN  
    (SELECT pracownik_id FROM rs_kp_zmiany_angazy_pozycje WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{datap}' AND numer={numer});
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id, datap=data_paczki)
    stat, lista, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat == 'OK':
        if len(lista) == 1:
            return 'Znaleziono list pac ' + lista[0][0] + ' obejmujc dni po ' + str(data) + '.'
        if len(lista) > 1:
            return 'Znaleziono listy pac ' + ', '.join([l[0] for l in lista]) + ' obejmujce dni po ' + str(data) + '.'
    return stat


def zamknij(self, klucz):
    import rsglobal
    stat       = 'OK'
    oddzial_id = klucz['oddzial_id']
    data       = klucz['data']
    numer      = klucz['numer']

    if stat == 'OK':
        SQL = """SELECT od_dnia FROM rs_kp_zmiany_angazy WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} and stan ='W';
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id)
        stat, tmp, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat == 'OK':
            if len(tmp) < 1:
                return 'Zmiana angay nie jest w stanie "W"'
            else:
                od_dnia = tmp[0][0]
        else:
            return 'Bd sprawdzania stanu zmiany angay: ' + stat

    if stat == 'OK':
        stat = _sprawdz_listy_plac(self, od_dnia, numer, oddzial_id, data)

    if stat == 'OK':
        #AB 28.06.19r dodano pole kategoria_zaszeregowania do zmian i where
        #AB 08.09.20r poprawiony test na to, czy co zostao zmodyfikowane
        #BP 2021-12-23 dodane kolumny do INSERT i SELECT
        #AB 23.05.22r null na do_kiedy
        SQL = """INSERT INTO rs_kp_angaze (firma_id, pracownik_id, umowa_id, angaz_id, od_kiedy, do_kiedy, miejsce_id, komorka_id, rodzaj_pracownika_id, grupa_pracownikow_id, etat, stanowisko_id, zawod_wykonywany_id, stanowisko_kosztow_id, grupa_zaszeregowania, kategoria_zaszeregowania, placa, stawka, dodatek_fun, ryczalt, dodatek1, dodatek2, zatrudnienie_id, kalendarz_id, stanowisko_miejsce_id, lista_id, ulga_rodz_plus, ulga_na_powrot, ulga_dla_emeryta)
    SELECT firma_id, pracownik_id, umowa_id, angaz_id +1 AS angaz_id, '{od_dnia}' AS od_kiedy, NULL::DATE, miejsce_id, komorka_id, rodzaj_pracownika_id, grupa_pracownikow_id, etat, stanowisko_id, zawod_wykonywany_id, stanowisko_kosztow_id, grupa_zaszeregowania, COALESCE(CASE WHEN COALESCE(kategoria_zaszeregowania_n, '') != COALESCE(a.kategoria_zaszeregowania, '') THEN kategoria_zaszeregowania_n ELSE a.kategoria_zaszeregowania END, a.kategoria_zaszeregowania), COALESCE(placa_n, a.placa), COALESCE(stawka_n, a.stawka), COALESCE(dodatek_fun_n, a.dodatek_fun), ryczalt, dodatek1, dodatek2, zatrudnienie_id, kalendarz_id, stanowisko_miejsce_id, 
    COALESCE(CASE WHEN COALESCE(lista_id_n, '') != COALESCE(a.lista_id, '') THEN lista_id_n ELSE a.lista_id END, a.lista_id), ulga_rodz_plus, ulga_na_powrot, ulga_dla_emeryta
    FROM rs_kp_zmiany_angazy_pozycje p JOIN rs_kp_angaze a USING(firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id)
    WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} AND (p.placa!=COALESCE(placa_n, p.placa) OR p.stawka != COALESCE(stawka_n,p.stawka) OR p.dodatek_fun != COALESCE(dodatek_fun_n, p.dodatek_fun) OR p.lista_id != COALESCE(lista_id_n, p.lista_id) OR p.kategoria_zaszeregowania != COALESCE(kategoria_zaszeregowania_n, p.kategoria_zaszeregowania));
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id, od_dnia=od_dnia)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(SQL)
            return 'Bd dodawania zmienionych angay: ' + stat


    if stat == 'OK':

        #AB 28.06.19r
        #AB 08.09.20r poprawiony test na to, czy co zostao zmodyfikowane
        SQL = """INSERT INTO rs_kp_angaze_skladniki (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id, skladnik_id, data_od, data_do, kwota)
    SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id+1, skladnik_id, data_od, data_do, kwota
    FROM rs_kp_zmiany_angazy_pozycje p JOIN rs_kp_angaze_skladniki a USING(firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id)
    WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} AND (p.placa!=COALESCE(placa_n, p.placa) OR p.stawka != COALESCE(stawka_n,p.stawka) OR p.dodatek_fun != COALESCE(dodatek_fun_n, p.dodatek_fun) OR p.lista_id != COALESCE(lista_id_n, p.lista_id) OR p.kategoria_zaszeregowania != COALESCE(kategoria_zaszeregowania_n, p.kategoria_zaszeregowania));
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd kopiowania skadnikw na nowe angae: ' + stat

    if stat == 'OK':

        #AB 28.06.19r
        #AB 08.09.20r poprawiony test na to, czy co zostao zmodyfikowane
        SQL = """UPDATE rs_kp_angaze
SET do_kiedy='{od_dnia}'::DATE - INTERVAL '1 DAY'
WHERE (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) IN (SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id FROM rs_kp_zmiany_angazy_pozycje p 
    WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} AND (p.placa!=COALESCE(placa_n, p.placa) OR p.stawka != COALESCE(stawka_n,p.stawka) OR p.dodatek_fun != COALESCE(dodatek_fun_n, p.dodatek_fun) OR p.lista_id != COALESCE(lista_id_n, p.lista_id) OR p.kategoria_zaszeregowania != COALESCE(kategoria_zaszeregowania_n, p.kategoria_zaszeregowania))
);
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id, od_dnia=od_dnia)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd zamykania starych angay: ' + stat

    if stat == 'OK':

        SQL = """UPDATE rs_kp_zmiany_angazy SET stan='Z' WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} and stan ='W';
""".format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd zamykania zmiany angay: ' + stat

    return stat




def otworz(self, klucz):
    stat       = 'OK'
    oddzial_id = klucz['oddzial_id']
    data       = klucz['data']
    numer      = klucz['numer']


    if stat == 'OK':
        SQL = """SELECT od_dnia FROM rs_kp_zmiany_angazy WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} AND stan ='Z';
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id)
        stat, tmp, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat == 'OK':
            if len(tmp) < 1:
                return 'Zmiana angay nie jest w stanie "Z"'
            else:
                od_dnia = tmp[0][0]
        else:
            return 'Bd sprawdzania stanu zmiany angay: ' + stat

    if stat == 'OK':
        stat = _sprawdz_listy_plac(self, od_dnia, numer, oddzial_id, data)

    if stat == 'OK':
        SQL = """SELECT 'pracownik: ' ||pracownik_id ||' zatrudnienie: '||zatrudnienie_id||' umowa: ' || umowa_id
FROM rs_kp_angaze a WHERE (firma_id, pracownik_id, zatrudnienie_id, umowa_id) IN (SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id FROM rs_kp_zmiany_angazy_pozycje WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer}) AND od_kiedy>'{od_dnia}';
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id, od_dnia=od_dnia)
        stat, tmp, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat == 'OK':
            if len(tmp) > 0:
                return 'Znaleziono angae rozpoczynajce si po '+od_dnia+': ' + '\n'.join([a[0] for a in tmp])
        else:
            return 'Bad sprawdzania, czy nie wystpuj angae nowsze ni data planowanych zmian: ' + stat

    if stat == 'OK':
        SQL = """SELECT 'oddzia: ' ||oddzial_id ||' data: '||DATA||' numer: '||numer ||' pracownik: ' ||pracownik_id ||' zatrudnienie: '||zatrudnienie_id||' umowa: ' || umowa_id||' anga: ' || angaz_id
FROM rs_kp_zmiany_angazy_pozycje 
WHERE (firma_id, oddzial_id, DATA, numer)!=('{firma}', '{oddzial_id}', '{data}', {numer})
AND (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) IN 
      (SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id+1 
       FROM rs_kp_zmiany_angazy_pozycje 
       WHERE (firma_id, oddzial_id, DATA, numer)=('{firma}', '{oddzial_id}', '{data}', {numer}));
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id)
        stat, tmp, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat == 'OK':
            if len(tmp) > 0:
                return 'Angae do usunicia wystpuj na innych zmianach angay: \n' + '\n'.join([a[0] for a in tmp])
        else:
            return 'Bd sprawdzania, czy nie wystpuj angae nowsze ni data planowanych zmian: ' + stat

    if stat == 'OK':

        SQL = """UPDATE rs_kp_angaze a1
SET do_kiedy=(SELECT do_kiedy FROM rs_kp_angaze a2 
        WHERE (a2.firma_id, a2.pracownik_id, a2.zatrudnienie_id, a2.umowa_id, a2.angaz_id) = (a1.firma_id, a1.pracownik_id, a1.zatrudnienie_id, a1.umowa_id, a1.angaz_id + 1)) 
    WHERE (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) IN (SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id FROM rs_kp_zmiany_angazy_pozycje WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer}) AND do_kiedy='{od_dnia}'::DATE - INTERVAL '1 day';
""".format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id, od_dnia=od_dnia)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd cofania zmian w angaach: ' + stat

    if stat == 'OK':

        SQL = """DELETE
FROM rs_kp_angaze a WHERE (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) IN (SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id+1 FROM rs_kp_zmiany_angazy_pozycje WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer}) AND od_kiedy='{od_dnia}';
    """.format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id, od_dnia=od_dnia)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd usuwania dodanych angay: ' + stat

    if stat == 'OK':

        SQL = """UPDATE rs_kp_zmiany_angazy SET stan='W' WHERE firma_id='{firma}' AND oddzial_id='{oddzial_id}' AND data='{data}' AND numer={numer} and stan ='Z';
""".format(firma=self.firma_id, data=data, numer=numer, oddzial_id=oddzial_id)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            return 'Bd otwierania zmiany angay: ' + stat

    return stat
