# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_praca_biezaca_zmiana_angazy_pozycje.py
# Purpose:     edycja/pobieranie pozycji zmian angay
# Author:      Wojciech Skowron
# Created:     2019/06/17
# RCS-ID:      $Id: fs_kp_praca_biezaca_zmiana_angazy_pozycje.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-06-27 Wojciech Skowron - (11528) Dodane pole 'kategoria_zaszeregowania', zmiana kolejnoci kolumn (najpierw _n)
# 2020-09-08 Aleksander Bargie - (11923) Grupowa zmiana angay - uwagi z Hali
# 2021-03-16 Aleksander Bargie - (12395) Doda trim na imi i nazwisko
# 2021-04-07 Wojciech Skowron   - (12352) Sprawdzenie dugoci wartoci przed update

import math

Etykiety = ['pracownik_id','nazwisko_imie','zatrudnienie_id','umowa_id','angaz_id',
            'placa_n','stawka_n','dodatek_fun_n','lista_id_n','kategoria_zaszeregowania_n',
            'placa','stawka','dodatek_fun','lista_id','kategoria_zaszeregowania']
kolGrid = {}
for i in range(len(Etykiety)):
    kolGrid[Etykiety[i]] = i

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Numer':[1,5],'Data':[1,5],'Oddzial':[1,5]}
     
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_praca_biezaca_zmiana_angazy_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
    if stat == 'OK':
        if Funkcja in [1, 5]:
            Numer        = rsglobal.Dekoduj(klucze['Numer'])
            Data         = rsglobal.Dekoduj(klucze['Data'])
            Oddzial      = rsglobal.Dekoduj(klucze['Oddzial'])

dane = []
wyn1 = []
wyn2 = []

Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprMod=(((self.oddzial_id,'056502') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   DELETE (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0])>0:
        if not UprMod:
            stat = 'UPR MOD BR'
            dane.append(stat)
        else:
            rsglobal.ZapiszDoLogow(Delete, 5)
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kp_zmiany_angazy_pozycje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND numer='"+str(Numer) 
                WHERE+= "' AND data='"+str(Data)+"' AND oddzial_id='"+str(Oddzial)+"'"

                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['pracownik_id', 'zatrudnienie_id', 'umowa_id', 'angaz_id']:
                        WHERE+=" AND "+str(pole)+"='"+str(wart)+"'"

                WHERE+=";"
                rsglobal.ZapiszDoLogow(DELETE+WHERE, 5)
                stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE+WHERE), 1)
                if stat != 'OK':
                    stat = "DEL SQL BL"
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0])>0:
        if not UprMod:
            stat = 'UPR MOD BR'
            dane.append(stat)
        else:
            rsglobal.ZapiszDoLogow(Update, 5)
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole in ['lista_id_n']:
                        if wart.strip() != '':
                            sql ="SELECT lista_id FROM rs_kp_szablony_list_plac "
                            sql+=" WHERE firma_id='"+str(self.firma_id)+"' AND lista_id='"+wart+"';"
                            rsglobal.ZapiszDoLogow(sql, 5)
                            stat,d,dump,dump=self.PolSQL.Execute(sql, 3)
                            if stat != 'OK':
                                dane.append('LISTA SQL BL')
                                wyn2.append((WierszeNr[i], kolGrid[pole]))
                            else:
                                if len(d) == 0:
                                    stat = 'LISTA BL'
                                    dane.append('LISTA BL')
                                    wyn2.append((WierszeNr[i], kolGrid[pole]))
                    #WS 2021-04-07
                    elif pole in ['placa_n','stawka_n','dodatek_fun_n']:
                        try:
                            wart_temp = float(wart)
                        except ValueError:
                            stat = 'NUM BL'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i], kolGrid[pole]))
                        else:
                            ulam, calk = math.modf(wart_temp)
                            if pole == 'placa_n' and calk >= 10**5:
                                stat = 'PLACAN NUM BL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i], kolGrid[pole]))
                            elif pole == 'stawka_n' and calk >= 10**3:
                                stat = 'STAWKAN NUM BL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i], kolGrid[pole]))
                            elif pole == 'dodatek_fun_n' and calk >= 10**5:
                                stat = 'DODATEKFUNN NUM BL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i], kolGrid[pole]))
                    #WS 2021-04-07
                    elif pole in ['kategoria_zaszeregowania_n']:
                        if wart.strip() != '':
                            if len(wart.strip()) > 2:
                                stat = 'KATEGZASZER DL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i], kolGrid[pole]))

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    # wykonanie UPDATE
    if stat=='OK':
        sql=''

        for i in xrange(len(Update[0])):
            WHERE =" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+str(Oddzial)+"'"
            WHERE+=" AND data='"+str(Data)+"' AND numer='"+str(Numer)+"'"

            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                if pole in ['pracownik_id','zatrudnienie_id','umowa_id','angaz_id']:
                    WHERE+= " AND "+pole+"='"+str(wart)+"'"

            WHERE+=";"

            UPDATE = "UPDATE rs_kp_zmiany_angazy_pozycje "
            SET='SET '
            for j in xrange(len(Update[0][i])):
                pole=Update[0][i][j]
                wart=Update[1][i][j]

                if pole in ['lista_id_n','kategoria_zaszeregowania_n']:
                    #AB 08.09.20r puste = brak modyfikacji
                    if wart.strip() != '':
                        SET+=pole+"='"+str(wart)+"', "
                    else:
                        SET+=pole+"=NULL, "
                elif pole in ['placa_n','stawka_n','dodatek_fun_n']:
                    SET+=pole+"="+str(wart)+", "

            SET=SET.strip(", ")
            sql+=UPDATE+SET+WHERE
            rsglobal.ZapiszDoLogow('UPDATE', 5)
            rsglobal.ZapiszDoLogow(sql, 5)

            stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'UPD SQL BL'
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,5)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,5]:  #AB 16.03.21r dodanie TRIM
    sql ="SELECT p.pracownik_id, TRIM(nazwisko)||' '||TRIM(imie), zatrudnienie_id, umowa_id, angaz_id,"
    sql+=" placa_n, stawka_n, dodatek_fun_n, lista_id_n, kategoria_zaszeregowania_n,"
    sql+=" placa, stawka, dodatek_fun, lista_id, kategoria_zaszeregowania"
    sql+=" FROM rs_kp_zmiany_angazy_pozycje p"
    sql+=" JOIN rs_kp_dane_osobowe o ON p.firma_id=o.firma_id AND p.pracownik_id = o.pracownik_id"
    sql+=" WHERE p.firma_id='"+str(self.firma_id)+"' AND p.oddzial_id='"+str(Oddzial)+"'"
    sql+=" AND data = '"+str(Data)+"' AND numer = '"+str(Numer)+"' ORDER BY p.pracownik_id, zatrudnienie_id, umowa_id, angaz_id;"
    rsglobal.ZapiszDoLogow(sql, 5)
    stat,dane,wyn1,dump=self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat='SEL SQL BL'
        dane.append(stat)