# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_przywracanie_stosunku_pracy_dane.py
# Purpose:     wraca zamknit umow na aktywn
# Author:      Piotr Witkowski
# Created:     2017/11/11
# RCS-ID:      $Id:10814 $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2021-03-05    (12376)    Aleksander Bargie   Rozwizanie stosunku pracy - rezygnacja z PPK

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Pracownik': [6], 'Zatrudnienie': [6], 'Umowa': [6], 'DataPrzywrocenia': [6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_pracownicy_przywracanie_stosunku_pracy_dane "'
        stat += 'z numerem ' + str(Funkcja) + ' bez parametrw: ' + Lista

if stat == 'OK' and Funkcja == 6:
    DataPrzywrocenia = klucze['DataPrzywrocenia']
    Pracownik = klucze['Pracownik']
    Zatrudnienie = klucze['Zatrudnienie']
    Umowa = klucze['Umowa']

    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = [[], "", "    -  -  ", None, 'None']
    #AB 07.03.21r
    rez_wysl = None
    data_przyst = None

    if self.operator_id != STANDARD_OPERATOR_ID:
        UprPrz = ((self.oddzial_id, '052191') in self.uprawnienia)

# -------------------------------------------------------------------------------
# ---- Sprawdzenie danych
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    # sprawdzenie poprawnosci daty
    if DataPrzywrocenia not in puste_pola:
        dane_wyn = rsglobal.SprawdzCzyToData(DataPrzywrocenia.replace("'", ''))
        if not dane_wyn:
            stat = 'DZ BL'
            dane.append(stat)

    # sprawdzenie poprawnoci pracownika
    if stat == 'OK':
        if Pracownik in puste_pola:
            stat = 'PR BR'
            dane.append(stat)
        else:  #AB 07.03.21r
            SQL = """SELECT pracownik_id, data_rezygnacji_wyslanie, data_konca_zatrudnienia, rkdop.data_przystapienia, count(rkz.numer_id)
                     FROM rs_kp_dane_osobowe 
                     LEFT JOIN rs_kp_dane_osobowe_ppk rkdop USING(firma_id, pracownik_id) 
                     LEFT JOIN rs_kp_zatrudnienie rkz USING(firma_id, pracownik_id)
                     WHERE firma_id ='{}' AND pracownik_id ='{}' AND stan_pracownika_id IN ('Z')
                     GROUP BY pracownik_id, data_rezygnacji_wyslanie, data_konca_zatrudnienia, rkdop.data_przystapienia
                     ORDER BY data_rezygnacji_wyslanie IS NOT NULL
                     ;""".format(self.firma_id, Pracownik)
            stat, pr, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'PR BL SQL'
                dane.append(stat)
            elif len(pr) == 0:
                stat = 'PR BL'
                dane.append(stat)
            else:  #AB 07.03.21r
                rez_wysl = pr[0][1]
                data_przyst = pr[0][3]
                if rez_wysl not in puste_pola:
                    wyn2.append('PPK REZ')

    # wybranie angau
    if stat == 'OK':
        if Zatrudnienie < 1 or Umowa < 1:
            stat = 'BR Angaz'
            dane.append(stat)
        else:
            SQL = "SELECT max(angaz_id) FROM rs_kp_angaze WHERE firma_id='" + self.firma_id + "'"
            SQL += " AND pracownik_id='" + Pracownik + "' AND zatrudnienie_id=" + str(Zatrudnienie)
            SQL += " AND umowa_id=" + str(Umowa) + ";"
            stat, angaz, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'BL Angaz'
                dane.append(stat)
            elif len(angaz) == 0:
                stat = 'BR Angaz'
                dane.append(stat)
            else:
                Angaz = angaz[0][0]

    if stat == 'OK' and len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# ---- Wykonanie przywrcenia stosunku pracy
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    # uzupelnienie rs_kp_zatrudnienie
    dzis = rsglobal.PodajDzis()
    SQL = "SELECT pracownik_id FROM rs_kp_zatrudnienie"
    SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "'"
    SQL += " AND numer_id=" + str(Zatrudnienie) + " AND stan_pracownika_id='Z'"
    stat, za, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'ZA BL'
        dane.append(stat)
    elif len(za) == 0:
        stat = 'ZA BR'
        dane.append(stat)
    else:
        # usunicie wiersza w historii zatrudnienia
        if stat == 'OK':
            # Delete
            SQL = "DELETE FROM rs_kp_historia_zatrudnienia hz "
            SQL += "WHERE hz.firma_id='" + self.firma_id + "' AND hz.pracownik_id='" + Pracownik + "' "
            SQL += " AND hz.do_kiedy = (SELECT zd.zwolnienie_data FROM rs_kp_zatrudnienie zd "
            SQL += " WHERE zd.firma_id=hz.firma_id AND zd.pracownik_id=hz.pracownik_id "
            SQL += " AND zd.numer_id='" + str(Zatrudnienie) + "' and zd.zwolnienie_data is not null);"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                stat = 'ZA BL SQL3'
                dane.append(stat)

        # zmiana stanu zatrudnienia
        if stat == 'OK':
            if DataPrzywrocenia in puste_pola:
                data_przywrocenia = "null"
            else:
                data_przywrocenia = "'" + str(DataPrzywrocenia) + "'"
            SQL = "UPDATE rs_kp_zatrudnienie SET zwolnienie_id=Null, zwolnienie_data=" + data_przywrocenia + ", "
            SQL += " stan_pracownika_id='A' "
            SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "'"
            SQL += " AND numer_id=" + str(Zatrudnienie) + ";"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                stat = 'ZA BL SQL2'
                dane.append(stat)

        # uzupelnienie rs_kp_umowy_o_prace
        if stat == 'OK':
            SQL = "SELECT umowa_id FROM rs_kp_umowy_o_prace "
            SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "' "
            SQL += " AND zatrudnienie_id=" + str(Zatrudnienie) + " AND umowa_id=" + str(Umowa)
            SQL += " AND od_kiedy is not NULL "
            if DataPrzywrocenia not in puste_pola:
                SQL += " AND (do_kiedy is NULL OR do_kiedy<'" + DataPrzywrocenia + "');"
            stat, up, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'UP BL SQL1'
                dane.append(stat)
            elif len(up) > 0:
                SQL = "UPDATE rs_kp_umowy_o_prace SET do_kiedy=" + str(data_przywrocenia)
                SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "' "
                SQL += " AND zatrudnienie_id=" + str(Zatrudnienie) + " AND umowa_id=" + str(Umowa) + ";"
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
                if stat != 'OK':
                    stat = 'UP BL SQL2'
                    dane.append(stat)

        # uzupelnianie rs_kp_angaze
        if stat == 'OK':
            SQL = "SELECT umowa_id,angaz_id FROM rs_kp_angaze "
            SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "' "
            SQL += " AND zatrudnienie_id=" + str(Zatrudnienie) + " AND od_kiedy is not NULL "
            if DataPrzywrocenia not in puste_pola:
                SQL += "AND (do_kiedy is NULL OR do_kiedy<'" + DataPrzywrocenia + "');"
            stat, up, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'BL Angaz SQL1'
                dane.append(stat)
            elif len(up) > 0:
                SQL = "UPDATE rs_kp_angaze SET do_kiedy=" + str(data_przywrocenia)
                SQL += " WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + Pracownik + "' "
                SQL += " AND zatrudnienie_id=" + str(Zatrudnienie) + " AND umowa_id=" + str(Umowa) + " "
                SQL += " AND angaz_id=" + str(Angaz) + ";"
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
                if stat != 'OK':
                    stat = 'BL Angaz SQL2'
                    dane.append(stat)

        #AB 07.03.21r
        # usuniecie daty_konca_zatrudnienia w ppk, tylko jesli nie wyslano rezygnacji
        if stat == 'OK' and rez_wysl in puste_pola and data_przyst not in puste_pola:
            SQL = """UPDATE rs_kp_dane_osobowe_ppk SET data_konca_zatrudnienia = NULL
                     WHERE firma_id = '{}' AND pracownik_id ='{}' AND data_przystapienia = '{}'
                     ;""".format(self.firma_id, Pracownik, data_przyst)
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(SQL)
                stat = 'BL PPK'
                dane.append(stat)
