# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_zawieszenia_dane
# Purpose:     dodawanie/edycja danych zawieszenia dla pracownika 
# Author:      Mariusz Rajfura
# Created:     2010/02/17
# RCS-ID:      $Id: fs_kp_pracownicy_zawieszenia_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
def SprNakladanieDat(self, Fun, Pracownik, Data_Od, Data_Do):
    stat = 'OK'
    sql = ''
    
    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        
        sql ="SELECT pracownik_id FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND pracownik_id='"+Pracownik+"'"
        
        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        sql+=" AND ("
        sql+=" ( do_kiedy IS NOT NULL AND '"+Data_Od+"' > od_kiedy AND '"+Data_Od+"' <= do_kiedy)"
        
        #jesli podano date do
        if Data_Do <> 'NULL':
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            sql+=" OR (od_kiedy > '"+Data_Od+"' AND od_kiedy <= '"+Data_Do+"' )"
            
            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            sql+=" OR (do_kiedy IS NOT NULL AND do_kiedy >= '"+Data_Od+"' AND do_kiedy <= '"+Data_Do+"' )"
            
            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            sql+=" OR (do_kiedy IS NOT NULL AND '"+Data_Do+"' > od_kiedy AND '"+Data_Do+"' <= do_kiedy)"
        sql+=");"
    
    #sprawdzenie unikalnosci zakresow przed UPDATE
    
    #jesli data_do z konkretnej zmieni sie na NULL, to nie trzeba
    #nic sprawdzac, bo klucz jest bez zmian, a okres bedzie obowiazywac
    #do kolejnej daty_od lub do konca swiata (i jeszce jeden dzien)
    
    if Fun in (3,4) and Data_Do <> 'NULL':
    
        sql ="SELECT pracownik_id FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND pracownik_id='"+Pracownik+"'"
        
        #wykluczenie z SELECT modyfikowanej pozycji
        sql+=" AND od_kiedy <> '"+Data_Od+"' AND ("
        
        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        sql+=" (od_kiedy > '"+Data_Od+"' AND od_kiedy <= '"+Data_Do+"' )"
            
        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        sql+=" OR (do_kiedy IS NOT NULL AND do_kiedy >= '"+Data_Od+"' AND do_kiedy <= '"+Data_Do+"' )"
            
        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        sql+=" OR (do_kiedy IS NOT NULL AND '"+Data_Do+"' > od_kiedy AND '"+Data_Do+"' <= do_kiedy));"

    if sql <> '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pokrywania si zakresw dat w zawieszeniach : '+stat

        if stat == 'OK':
            if len(d) > 0:
                stat = 'BL_POKRYWANIA_DAT'

    return stat


#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']

    SlPar={'Pracownik':[1,2,3,4,5],'OdKiedy':[1,2,3,5],'Umowa':[1,2,3,4,5],'Zatrudnienie':[1,2,3,4,5],'DoKiedy':[1,2,3,4]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_pracownicy_zawieszenia_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2,3,4,5]:
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])
        OdKiedy=rsglobal.Dekoduj(klucze['OdKiedy'])
        Umowa=rsglobal.Dekoduj(klucze['Umowa'])
        Zatrudnienie=rsglobal.Dekoduj(klucze['Zatrudnienie'])
    if Fun in [1,2,3,4]:
        DoKiedy=rsglobal.Dekoduj(klucze['DoKiedy'])


sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','zawieszenie_pracownika','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052093') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052092') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':
    if OdKiedy == '    -  -  ':
        stat = 'BR_OD_KIEDY'
        dane.append(stat)
    else:
        if not rsglobal.SprawdzCzyToData(OdKiedy):
            stat = 'BL_OD_KIEDY'
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT od_kiedy FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
        sql+=" AND zatrudnienie_id='"+str(Zatrudnienie)+"' AND umowa_id='"+str(Umowa)+"' "
        sql+=" AND od_kiedy='"+OdKiedy+"' FOR UPDATE NOWAIT;"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia danych zawieszenia : '+stat
        elif Fun in (1,2):
            if len(d) > 0:
                stat = 'BL_OD_KIEDY_IST'
                dane.append(stat)
        elif Fun in (3,4):
            if len(d) == 0:
                stat = 'BL_OD_KIEDY_NIST'
                dane.append(stat)

#DoKiedy = None
#Zatrudnienie = None

if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'zawieszenie_id':
            wart = wart.strip()
            wartosci[i] = "'"+wart+"'"
            if wart == '':
                dane.append('BR_ZAWIESZENIE')
            else:
                sql ="SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND typ_absencji_id='"+wart+"' AND czy_zawieszenie;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia rodzaju absencji: '+stat)
                elif len(d) == 0:
                    dane.append('BL_ZAWIESZENIE')

        elif pole == 'do_kiedy':
            if wart == '    -  -  ':
                dane.append('BR_DO_KIEDY')
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    DoKiedy = wart
                else:
                    dane.append('BL_DO_KIEDY')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'opis':
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                wartosci[i] = "'"+str(wart)+"'"

    if len(dane) > 0:
        stat = dane[0]

    if stat == 'OK':
        if Fun in (1,2) and DoKiedy in (None, '    -  -  '):
            stat = 'BR_DO_KIEDY'
            dane.append(stat)

    if stat == 'OK':
        if not DoKiedy in (None, '    -  -  '):
            if OdKiedy > DoKiedy:
                stat = 'BL_OD_DO_KIEDY'
                dane.append(stat)

    # #czy podane daty mieszcza sie w zakresie ostatniej umowy o prace
    # if stat == 'OK' and DoKiedy <> None:
    #     sql ="SELECT MAX(numer_id) FROM rs_kp_zatrudnienie"
    #     sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"
    #     stat,dZatr,dump,dump = self.PolSQL.Execute(sql,3)
    #     if stat <> 'OK':
    #         stat = 'Bd sprawdzenia ostatniego numeru zatrudnienia : '+stat
    #         dane.append(stat)
    #     elif dZatr[0][0] == 0:
    #         stat = 'Brak jakiegokolwiek zatrudnienia'
    #         dane.append(stat)
    #     else:
    #         Zatrudnienie = dZatr[0][0]
    #
        #zablokowanie zatrudnienia dla wpisania stanu zawieszenia    
        if stat == 'OK':
            sql ="SELECT numer_id FROM rs_kp_zatrudnienie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
            sql+=" FOR UPDATE NOWAIT;"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych zatrudnienia: '+stat
                dane.append(stat)
            elif len(d) == 0:
                stat = 'Brak zatrudnienia o numerze '+str(Zatrudnienie)
                dane.append(stat)
        
        # if stat == 'OK':
        #     sql ="SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
        #     sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
        #     sql+=" AND zatrudnienie_id="+str(Zatrudnienie)+";"
        #     stat,dUmowa,dump,dump = self.PolSQL.Execute(sql,3)
        #     if stat <> 'OK':
        #         stat = 'Bd sprawdzenia ostatniego numeru umowy o prac : '+stat
        #         dane.append(stat)
        #     elif dUmowa[0][0] == 0:
        #         stat = 'Brak jakiejkolwiek umowy o pracy'
        #         dane.append(stat)
        #
        #     if stat == 'OK':
        #         sql ="SELECT od_kiedy,do_kiedy FROM rs_kp_umowy_o_prace"
        #         sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        #         sql+=" AND zatrudnienie_id = "+str(dZatr[0][0])+" AND umowa_id = "+str(dUmowa[0][0])+";"
        #         stat,dDatyUmowy,dump,dump = self.PolSQL.Execute(sql,3)
        #         if stat <> 'OK':
        #             stat = 'Bd pobrania danych umowy o prace : '+stat
        #             dane.append(stat)
        #
        #     if stat == 'OK':
        #         if OdKiedy < dDatyUmowy[0][0]:
        #             stat = 'BL_OD_KIEDY_UMOWA_OD_KIEDY'
        #             dane.append(stat)
        #         elif not dDatyUmowy[0][1] in ('None','    -  -  '):
        #             if DoKiedy > dDatyUmowy[0][1]:
        #                 stat = 'BL_DO_KIEDY_UMOWA_DO_KIEDY'
        #                 dane.append(stat)
        #
    if stat == 'OK' and DoKiedy <> None:
        stat = SprNakladanieDat(self, Fun, Pracownik, OdKiedy, DoKiedy)
        if stat <> 'OK':
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = "firma_id,pracownik_id,od_kiedy,zatrudnienie_id,umowa_id"
    inswart = "'"+self.firma_id+"','"+Pracownik+"','"+OdKiedy+"','"+str(Zatrudnienie)+"','"+str(Umowa)+"'"

    for i in range(len(pola)):
        if pola[i] <> 'od_kiedy':
            inspola += ","+pola[i]
            inswart += ","+wartosci[i]
    
    INSERT = "INSERT INTO rs_kp_zawieszenia ("+inspola+") VALUES ("+inswart+"); "
    
    #sprawdzenie, czy biezaca data zawiera sie w okresie zawieszenia
    sql = "SELECT NOW()::DATE >= '"+OdKiedy+"' AND NOW()::DATE <= '"+DoKiedy+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd porwnania dat: '+stat
        dane.append(stat)
    
    if stat == 'OK':
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT, 1)
        if stat <> 'OK':
            stat = 'Bd dodawania nowego zawieszenia: '+stat
            dane.append(stat)
    
    if stat == 'OK' and d[0][0]:
        #wpisanie stanu zawieszenia pracownikowi, jesli biezaca data zawiera sie
        #w okresie zawieszenia
        UPDATE ="UPDATE rs_kp_zatrudnienie SET stan_pracownika_id='S'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
        UPDATE+=" AND numer_id="+str(Zatrudnienie)+";"
    
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE, 1)
        if stat <> 'OK':
            stat = 'Bd aktualizacji zatrudnienia: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_zawieszenia SET "

    for i in range(len(pola)):
        UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE  = UPDATE[:-1]
    UPDATE += " WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
    UPDATE += " AND od_kiedy='"+OdKiedy+"' AND zatrudnienie_id='"+str(Zatrudnienie)+"' AND umowa_id='"+str(Umowa)+"';"
    
    if DoKiedy == None:
        #pobranie daty konca zawieszenia, jesli nie byla edytowana,
        #aby ewentualnie zmienic status pracownika
        sql ="SELECT do_kiedy FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
        sql+=" AND od_kiedy='"+OdKiedy+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak danych o podanym kluczu'
            dane.append(stat)
        else:
            DoKiedy = str(d[0][0])
    
    if stat == 'OK':
        #ewentualne ustawienie statusu 'ZAWIESZONY', jesli biezaca data
        #miesci sie w zakresie dat zawieszenia

        sql = "SELECT NOW()::DATE >= '"+OdKiedy+"' AND NOW()::DATE <= '"+DoKiedy+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd porwnania dat: '+stat
            dane.append(stat)
        elif d[0][0]:
            UPDATE+="UPDATE rs_kp_zatrudnienie SET stan_pracownika_id='S'"
            UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
            UPDATE+=" AND numer_id="+str(Zatrudnienie)+";"
    
    if stat == 'OK':
        stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd aktualizacji danych urlopu bezpatnego : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat == 'OK':
    SELECT ="SELECT * FROM rs_kp_zawieszenia"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
    SELECT+=" AND od_kiedy='"+OdKiedy+"' AND zatrudnienie_id='"+str(Zatrudnienie)+"' AND umowa_id='"+str(Umowa)+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych zawieszenia : '+stat
        dane.append(stat)
        
    Zawieszenie = 'Brak danych'
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        if (self.oddzial_id,'051010') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_kp_absencje_rodzaje"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+tr.GetVal(0,"zawieszenie_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                Zawieszenie = 'Bd pobrania opisu ze sownika rodzajw absencji: '+stat
            else:
                if len(d) == 0:
                    Zawieszenie = 'Bdny kod zawieszenia.'
                else:
                    Zawieszenie = str(d[0][0])
        else:
            Zawieszenie = 'Brak uprawnie do sownika. Poinformuj administratora.'

    wyn2 = [Zawieszenie]