# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_zwalnianie_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji faktury
#
# Author:      Konrad Opieka
# Created:     2014/08/18
# RCS-ID:      $Id:$
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2021-03-05    (12376)    Aleksander Bargie   Rozwizanie stosunku pracy - rezygnacja z PPK
# 2021-03-26    (12418)    Aleksander Bargie   Dodatkowe pola w oknie rozwizywania stosunku pracy
# 2021-05-10    (12483)    Wojciech Skowron     Zmiana w kontroli wypenienia kodw


stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Pracownik':[6],'DataZwolnienia':[6]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':                       #AB 26.03.21r
        stat='Uwaga : wywoanie funkcji fs_kp_pracownicy_zwalnianie_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    DataZwolnienia           = klucze['DataZwolnienia']
    Pracownik                = klucze['Pracownik']
    TypZwolnienia            = klucze['TypZwolnienia']
    NrZatrudnienia           = klucze['NrZatrudnienia']
    #AB 26.03.21r
    PrzyczynaWyrejestrowania = klucze['PrzyczynaWyrejestrowania'].strip()
    PodstRozwStosPracy       = klucze['PodstRozwStosPracy'].strip()
    KodRozwStosPrac          = klucze['KodRozwStosPrac'].strip()

wyn1 = []
wyn2 = []

puste_pola = [[],"","    -  -  ",None,'None']

if self.operator_id != STANDARD_OPERATOR_ID:
    UprPrz = ((self.oddzial_id,'052191') in self.uprawnienia)
    
#-------------------------------------------------------------------------------
#---- Sprawdzenie danych
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==6:
    dzis = rsglobal.PodajDzis()
    #sprawdzenie poprawnosci daty
    if stat=='OK':
        if DataZwolnienia in puste_pola:
            stat = 'DZ BR'
            dane.append(stat)
        else:
            dane_wyn = rsglobal.SprawdzCzyToData(DataZwolnienia.replace("'",''))  
            if not dane_wyn:
                stat = 'DZ BL'
                dane.append(stat)
            
    #sprawdzenie poprawnoci pracownika
    if stat=='OK':
        if Pracownik in puste_pola:
            stat = 'PR BR'
            dane.append(stat)
        else:  #AB 07.03.21r
            SQL = """SELECT pracownik_id, data_rezygnacji_wyslanie, data_konca_zatrudnienia, rkdop.data_przystapienia, count(rkz.numer_id)
                     FROM rs_kp_dane_osobowe 
                     LEFT JOIN rs_kp_dane_osobowe_ppk rkdop USING(firma_id, pracownik_id) 
                     LEFT JOIN rs_kp_zatrudnienie rkz USING(firma_id, pracownik_id)
                     WHERE firma_id ='{}' AND pracownik_id ='{}' AND data_rezygnacji_wyslanie IS NULL AND stan_pracownika_id IN ('A', 'S')
                     GROUP BY pracownik_id, data_rezygnacji_wyslanie, data_konca_zatrudnienia, rkdop.data_przystapienia
                     ORDER BY data_rezygnacji_wyslanie IS NOT NULL
                     ;""".format(self.firma_id, Pracownik)
            stat, pr, dump, dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat = 'PR BL SQL'
                dane.append(stat)
            elif len(pr)==0:
                stat = 'PR BL'
                dane.append(stat)
                #  istnieje ppk                 nie wyslano rezygn      wiecej niz 1 zatr    bedzie zmiana stanu tutaj(warunek usuniety)
            elif pr[0][3] not in puste_pola and pr[0][1] in puste_pola and pr[0][4] > 1: # and dzis >= DataZwolnienia:  #AB 07.03.21r
                wyn2.append('ZATR IL')
                
    #sprawdzanie poprawnoci typw zwolnie
    if stat=='OK':
        if TypZwolnienia in puste_pola:
            stat = 'TZ BR'
            dane.append(stat)
        elif len(TypZwolnienia) > 2:
            stat = 'TZ DL'
            dane.append(stat)
        else:
            SQL ="SELECT kod FROM rs_kp_typy_zwolnien WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND kod='"+TypZwolnienia+"'"
            stat,kod,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'TZ BL SQL'
                dane.append(stat)
            elif len(kod)==0:
                stat = 'TZ BL'
                dane.append(stat)
                
    #sprawdzenie numeru zatrudnienia
    if stat=='OK':
        if NrZatrudnienia < 1:
            stat = 'NZ BR'
            dane.append(stat)
        else:
            SQL ="SELECT numer_id FROM rs_kp_zatrudnienie WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND pracownik_id='"+Pracownik+"' AND numer_id="+str(NrZatrudnienia)
            stat,nr,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'NZ BL SQL'
                dane.append(stat)
            elif len(nr)==0:
                stat = 'NZ BL'
                dane.append(stat)

    #sprawdzenie przyczyny wyrejestrowania
    if stat == 'OK':
        if PrzyczynaWyrejestrowania not in puste_pola:
            sql = "SELECT opis FROM rs_kp_zus_kody_przyczyn_wyrejestrowania WHERE kod = '" + PrzyczynaWyrejestrowania + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = u"Bd sprawdzania poprawnoci przyczyny wyrejestrowania: " + stat
            elif len(d) == 0:
                stat = u'Bdny kod przyczyny wyrejestrowania: ' + PrzyczynaWyrejestrowania
            if stat != 'OK':
                dane.append(stat)
        else:
            stat = u'Brak kodu przyczyny wyrejestrowania: ' + PrzyczynaWyrejestrowania
            dane.append(stat)

    #sprawdzenie podstawy prawnej rozwiazania stosunku pracy
    if stat == 'OK':
        if PodstRozwStosPracy not in puste_pola:
            sql = "SELECT opis FROM rs_kp_zus_kody_podstawy_rozwiazania_stos_pracy WHERE kod = '" + PodstRozwStosPracy + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = u"Bd sprawdzania poprawnoci podstawy prawnej rozwizania stosunku pracy: " + stat
            elif len(d) == 0:
                stat = u'Bdny kod podstawy prawnej rozwizania stosunku pracy: ' + PodstRozwStosPracy
            if stat != 'OK':
                dane.append(stat)
        #WS 2021-05-10
        elif PrzyczynaWyrejestrowania in ('100', '500'):
        # else:
            stat = u'Brak kodu podstawy prawnej rozwizania stosunku pracy'
            dane.append(stat)

    #sprawdzenie kodu rozwiazania stosunku pracy
    if stat=='OK':
        if KodRozwStosPrac not in puste_pola:
            sql = "SELECT opis FROM rs_kp_zus_kody_rozwiazania_stosunku_pracy WHERE kod = '" + KodRozwStosPrac + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = u"Bd sprawdzania poprawnoci kodu rozwizania stosunku pracy: " + stat
            elif len(d) == 0:
                stat = u'Bdny kod rozwizania stosunku pracy: ' + KodRozwStosPrac
            if stat != 'OK':
                dane.append(stat)
        #WS 2021-05-10
        elif PrzyczynaWyrejestrowania in ('100', '500'):
        # else:
            stat = u'Brak kodu rozwizania stosunku pracy'
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
         
            
#-------------------------------------------------------------------------------
#---- Wykonanie zwolnienia
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==6:
    #uzupelnienie rs_kp_zatrudnienie
    SQL ="SELECT pracownik_id FROM rs_kp_zatrudnienie"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
    SQL+=" AND numer_id="+str(NrZatrudnienia)+" AND stan_pracownika_id='A'"
    stat,za,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'ZA BL SQL1'
        dane.append(stat)
    elif len(za)==0:
        stat = 'ZA BR'
        dane.append(stat)
    else:
        if stat=='OK':
            SQL = "UPDATE rs_kp_zatrudnienie SET zwolnienie_id='"+TypZwolnienia+"', zwolnienie_data='"+str(DataZwolnienia)+"'"
            SQL+=", przyczyna_wyrejestrowania_zus = '{}', podst_prawna_rozw_stos_pracy = {}, kod_rozw_stos_pracy = {} "#.format(PrzyczynaWyrejestrowania, PodstRozwStosPracy, KodRozwStosPrac)
            SQL = SQL.format(PrzyczynaWyrejestrowania,
                             rsglobal.ZmienNaNULL(PodstRozwStosPracy),
                             rsglobal.ZmienNaNULL(KodRozwStosPrac))  #WS 2021-05-10
            #AB 26.03.21r
            if dzis>=DataZwolnienia:
                SQL+=", stan_pracownika_id = 'Z' "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
            SQL+=" AND numer_id="+str(NrZatrudnienia)+";"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat = 'ZA BL SQL2'
                dane.append(stat)

        #uzupelnienie rs_kp_umowy_o_prace
        if stat=='OK':
            SQL ="SELECT umowa_id FROM rs_kp_umowy_o_prace "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
            SQL+="AND zatrudnienie_id="+str(NrZatrudnienia)+" AND od_kiedy is not NULL "
            SQL+="AND (do_kiedy is NULL OR do_kiedy>'"+DataZwolnienia+"');"
            stat,up,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'UP BL SQL1'
                dane.append(stat)
            elif len(up)>0:
                for x in up:
                    SQL ="UPDATE rs_kp_umowy_o_prace SET do_kiedy='"+str(DataZwolnienia)+"' "
                    SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
                    SQL+="AND zatrudnienie_id="+str(NrZatrudnienia)+" AND umowa_id="+str(x[0])+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
                    if stat <> 'OK':
                        stat = 'UP BL SQL2'
                        dane.append(stat)

        #uzupelnianie rs_kp_angaze
        if stat=='OK':
            SQL ="SELECT umowa_id,angaz_id FROM rs_kp_angaze "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
            SQL+="AND zatrudnienie_id="+str(NrZatrudnienia)+" AND od_kiedy is not NULL "
            SQL+="AND (do_kiedy is NULL OR do_kiedy>'"+DataZwolnienia+"');"
            stat,up,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'AN BL SQL1'
                dane.append(stat)
            elif len(up)>0:
                for x in up:
                    SQL ="UPDATE rs_kp_angaze  SET do_kiedy='"+str(DataZwolnienia)+"' "
                    SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
                    SQL+="AND zatrudnienie_id="+str(NrZatrudnienia)+" AND umowa_id="+str(x[0])+" "
                    SQL+="AND angaz_id="+str(x[1])+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
                    if stat <> 'OK':
                        stat = 'AN BL SQL2'
                        dane.append(stat)

        # dodanie wiersza w historii zatrudnienia
        if stat=='OK':
            SQL ="INSERT INTO rs_kp_historia_zatrudnienia (firma_id,pracownik_id,od_kiedy,do_kiedy,"
            SQL+=" zakonczenie_id,nazwa_firmy,ta_sama,branza,ubezpieczenie_id) "
            SQL+=" SELECT firma_id,pracownik_id,(SELECT MIN(od_kiedy) FROM rs_kp_umowy_o_prace "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND zatrudnienie_id='"+str(NrZatrudnienia)+"'),"
            SQL+="'"+DataZwolnienia+"','"+TypZwolnienia+"',"
            SQL+=" (SELECT opis FROM rs_firmy WHERE firma_id='"+self.firma_id+"'),TRUE,TRUE,ubezpieczenie_id"
            SQL+=" FROM rs_kp_zatrudnienie WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
            SQL+=" AND numer_id="+str(NrZatrudnienia)
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
            if stat <> 'OK':
                stat = 'ZA BL SQL3'
                dane.append(stat)

        #AB 07.03.21r
        # dodanie daty_konca_zatrudnienia w ppk, tylko jesli jedno zatr
                            #  istnieje ppk                 nie wyslano rezygn    dokladnie 1 zatr    bedzie zmiana stanu tutaj
        if stat == 'OK' and pr[0][3] not in puste_pola and pr[0][1] in puste_pola and pr[0][4] == 1 and dzis>=DataZwolnienia:
            SQL = """UPDATE rs_kp_dane_osobowe_ppk SET data_konca_zatrudnienia = '{}'
                     WHERE firma_id = '{}' AND pracownik_id ='{}' AND data_rezygnacji_wyslanie IS NULL
                     ;""".format(DataZwolnienia, self.firma_id, Pracownik)
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                stat = 'BL PPK'
                dane.append(stat)