# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_rodzina_dane
# Purpose:     dodawanie/edycja danych umowy o prace
# Author:      Mariusz Rajfura
# Created:     2009/09/24
# RCS-ID:      $Id: fs_kp_rodzina_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#2014-07-22 - Marcin Natkaski (8169) - Dodanie kilku kontrolek
#2018-12-18 - Aleksander Bargie (11331) -  [KP] Obsuga historii rejestracji w zus

Pracownik = klucze[0]
Numer = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','rodzina','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052083') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052082') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':
    #sprawdzenie poprawnosci pracownika
    SQL="SELECT pracownik_id FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        dane.append('Bd pobrania danych pracownika : '+stat)
    elif len(d) == 0:
        dane.append('BR PRACOWNIKA')
    #sprawdzenie podanego numeru rodziny (e istnieje)
    if Fun in (3,4):
        SQL="SELECT rodzina_id FROM rs_kp_rodzina WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND pracownik_id='"+Pracownik+"' AND rodzina_id="+str(Numer)+";"    
        stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            dane.append('Bd pobrania danych czonka rodziny pracownika : '+stat)
        elif len(d) == 0:
            dane.append('BR RODZINY')

    if stat == 'OK':
        SQL="SELECT data_urodzenia, ubezpieczony_od, ubezpieczony_do FROM rs_kp_rodzina WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND pracownik_id='"+Pracownik+"' AND rodzina_id="+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            dane.append('Bd pobrania danych czonka rodziny pracownika : '+stat)
        elif len(d) > 0:
            urodz, ubezp_od, ubezp_do = d[0]
        if 'data_urodzenia' in pola:
            urodz = wartosci[pola.index('data_urodzenia')]
        if 'ubezpieczony_od' in pola:
            ubezp_od = wartosci[pola.index('ubezpieczony_od')]
        if 'ubezpieczony_do' in pola:
            ubezp_do = wartosci[pola.index('ubezpieczony_do')]
    if stat == 'OK':
        if rsglobal.SprawdzCzyToData(ubezp_od) and rsglobal.SprawdzCzyToData(urodz) and ubezp_od < urodz:
            stat = 'Data ubezpieczenia nie moe by wczeniejsza od daty narodzin.'
    if stat == 'OK':
        if rsglobal.SprawdzCzyToData(ubezp_od) and rsglobal.SprawdzCzyToData(urodz) and ubezp_od < urodz:
            stat = 'Data wyrejestrowania nie moe by wczeniejsza od daty rejestracji.'
    
    #sprawdzenie pol, ktore przyszly
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'imie':
            if wart == '':
                dane.append('BR IMIENIA')
        
        elif pole == 'nazwisko':
            if wart == '':
                dane.append('BR NAZWISKA')
        
        elif pole == 'pesel':
            if wart == '':
                dane.append('BR PESEL')
            elif rsglobal.SprPesel(wart)<>'OK':
                dane.append('BL PESEL')
        
        elif pole == 'pokrewienstwo_id':
            if wart == '':
                dane.append('BR POKREW')
            else:
                SQL="SELECT kod FROM rs_stopnie_pokrewienstwa WHERE kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania danych pokrewiestwa czonka rodziny pracownika : '+stat)
                elif len(d) == 0:
                    dane.append('BL POKREW')

        elif pole == 'gmina_id' and wart != '':
            SQL = "SELECT kod FROM rs_gminy "
            SQL += " WHERE firma_id='" + self.firma_id + "' AND kod='" + wart + "';"
            stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                dane.append('Bd pobrania danych gminy : ' + stat)
            elif len(d) == 0:
                dane.append('Bdny kod gminy')

        elif pole == 'rodzaj_zasilku_id':
            if wart<>'':
                SQL="SELECT kod FROM rs_rodzaje_zwolnien WHERE kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania rodzaju zasiku : '+stat)
                elif len(d) == 0:
                    dane.append('BL RODZ ZAS')

        elif pole == 'niepelnosprawnosc_id':
            if wart<>'':
                SQL="SELECT kod FROM rs_kp_niepelnosprawnosc WHERE kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania kodu niepenosprawnoci: '+stat)
                elif len(d) == 0:
                    dane.append('BL NIE')
                
        elif pole == 'nip':
            if wart <> '':
                if rsglobal.SprNip(wart.replace("-","")) <> 'OK':
                    dane.append('BL NIP')
                else:
                    SQL = "SELECT nip FROM rs_kp_rodzina WHERE firma_id = '" + self.firma_id + "' "
                    SQL += "AND pracownik_id = '" + Pracownik + "' and nip = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                    if stat <> 'OK':
                        dane.append('Bd sprawdzenia numeru nip w tabeli. '+stat)
                    
        elif pole == 'data_urodzenia':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATAUR')
                    
        elif pole == 'ubezpieczony_od':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATAOD')
        
        elif pole == 'ubezpieczony_do':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATADO')
                    
        elif pole == 'paszport_wazny_do':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL WAZNYDO')
        elif pole == 'data_zaswiadczenia':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA ZASW')
        
        elif pole == 'waznosc_zaswiadczenia':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL WAZN ZASW')
        
        elif pole == 'waznosc_zaswiadczenia_wiek':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL WAZN ZASW WIEK')
                    
    if len(dane) > 0:
        stat = dane[0]
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    sql ="SELECT MAX(rodzina_id) FROM rs_kp_rodzina"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania numeru z kartoteki rodziny : '+stat
    else:
        if d[0][0] in ['None','']:
            Numer = 1
        else:
            Numer = int(d[0][0])+1

    if stat == 'OK':
        inspola = "firma_id,pracownik_id,rodzina_id"
        inswart = "'"+self.firma_id+"','"+Pracownik+"',"+str(Numer)

        for i in xrange(len(pola)):
            rsglobal.ZapiszDoLogow(pola[i]+' '+str(wartosci[i]),1)
            if pola[i]<>'rodzina_id':
                inspola += ","+pola[i]
                
            if pola[i]=='rodzina_id':
                pass
            elif pola[i] in ['pokrewienstwo_id','ubezpieczony_od','ubezpieczony_do','paszport_wazny_do','data_urodzenia',
                                'data_zaswiadczenia','waznosc_zaswiadczenia','waznosc_zaswiadczenia_wiek','rodzaj_zasilku_id',
                             'niepelnosprawnosc_id','zgloszenie_zcna','wyrejestrowanie_zcna','gmina_id']:
                if wartosci[i] in ['','    -  -  ']:
                    inswart += ",NULL"
                else:
                    inswart += ",'"+wartosci[i]+"'"
            elif pola[i] == 'nip':
                if wartosci[i] == '':
                    inswart += ",NULL"
                else:
                    inswart += ",'"+wartosci[i] + "'"
            elif pola[i] in ['ubezpieczony','czy_na_utrzymaniu','wspolne_zameldowanie','samotnie_wychowuje']:
                inswart += ","+str(wartosci[i])
            else:
                inswart += ",'"+wartosci[i]+"'"
                
        INSERT = "INSERT INTO rs_kp_rodzina ("+inspola+") VALUES ("+inswart+");"

        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat <> 'OK':
            stat = 'Bd dodawania nowego czonka rodziny : '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_rodzina SET "
    for i in xrange(len(pola)):
        if pola[i]<>'rodzina_id':
            UPDATE+=pola[i]+'='
            
            if pola[i] in ['pokrewienstwo_id','ubezpieczony_od','ubezpieczony_do','paszport_wazny_do','data_urodzenia','rodzaj_zasilku_id',
                           'niepelnosprawnosc_id','zgloszenie_zcna','wyrejestrowanie_zcna','gmina_id']:
                if wartosci[i] in ['','    -  -  ']:
                    UPDATE += "NULL,"
                else:
                    UPDATE += "'"+wartosci[i]+"',"
            elif pola[i] in ['ubezpieczony','czy_na_utrzymaniu','wspolne_zameldowanie','samotnie_wychowuje']:
                UPDATE += str(wartosci[i])+","
            else:
                UPDATE += "'"+wartosci[i]+"',"

    UPDATE = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND rodzina_id = "+str(Numer)+";"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd aktualizacji danych czonka rodziny : '+stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# --- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
# -------------------------------------------------------------------------------

if Fun in (1, 3, 5) and stat == 'OK':
    SELECT = "SELECT * FROM rs_kp_rodzina"
    SELECT += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "' AND rodzina_id = " + str(
        Numer) + ";"

    stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych czonka rodziny : ' + stat
        dane.append(stat)

    Pokrewienstwo = 'Brak danych'
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane, wyn1)

        if (self.oddzial_id, '011610') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_stopnie_pokrewienstwa WHERE kod = '" + tr.GetVal(0, "pokrewienstwo_id") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                Pokrewienstwo = 'Bd pobrania opisu ze sownika stopni pokrewiestwa : ' + stat
            else:
                if len(d) == 0:
                    Pokrewienstwo = 'Bdny kod stopnia pokrewiestwa.'
                else:
                    Pokrewienstwo = str(d[0][0])
        else:
            Pokrewienstwo = 'Brak uprawnie do sownika. Poinformuj administratora.'

    Niepelnospranowsc = 'Brak danych'
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane, wyn1)

        if (self.oddzial_id, '211310') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_kp_niepelnosprawnosc WHERE kod = '" + tr.GetVal(0, "niepelnosprawnosc_id") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                Niepelnospranowsc = 'Bd pobrania opisu ze sownika niepenosprawnoci : ' + stat
            else:
                if len(d) == 0:
                    Niepelnospranowsc = 'Bdny kod niepenosprawnoci.'
                else:
                    Niepelnospranowsc = str(d[0][0])
        else:
            Niepelnospranowsc = 'Brak uprawnie do sownika. Poinformuj administratora.'

    wyn2 = [Pokrewienstwo, Niepelnospranowsc]

#AB 18.12.18r
# -------------------------------------------------------------------------------
# --- POBRANIE HISTORII ZCNA (15 - select)
# -------------------------------------------------------------------------------

if Fun == 15 and stat == 'OK':
    SEL  = "SELECT ubezpieczony_od, ubezpieczony_do FROM rs_kp_rodzina_zus "
    SEL += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND rodzina_id = "+str(Numer)+" ORDER BY ubezpieczony_od DESC;"

    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania historii rejestracji do ZCNA : '+stat
        dane.append(stat)

    SELECT = "SELECT imie, nazwisko FROM rs_kp_rodzina"
    SELECT += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "' AND rodzina_id = " + str(Numer) + ";"
    stat, imnaz, dump, dump = self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK' or len(imnaz) != 1:
        stat = 'Bd pobrania danych czonka rodziny : ' + stat
        dane.append(stat)
    wyn1 = str(imnaz[0][0]) + ' ' + str(imnaz[0][1])
