# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_skladniki_placowe.py
# Purpose:     obsluga grida edytowalnego z list skadnikw pacowych
# Author:      Micha Raburski
# Created:     2015/07/08
# RCS-ID:      $Id: fs_kp_skladniki_placowe.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-07-25 Aleksander Bargie (11558) Kontrola na unikalno wartoci pola "skrt" w skadnikach pacowych
# 2020-01-22 Jan Raburski (12291) Analiza skladnikow
# 2021-10-19 Aleksander Bargie (12676) Daty obowizywania staych i wersji skadnikw uzalezni od daty wypaty listy
# 2021-11-22 Wojciech Skowron (12711) Kopiowanie
# 2021-12-08 Bartosz Pagan   (12763) Dodanie Checkbox'a "Wszystkie"
# 2022-05-26 Aleksander Bargie (13039) Kopiowanie skadnikw pacowych
# 2023-02-06 Wojciech Skowron (13344) Nie rozrnia wielkoci liter w filtrze na skadnik
# 2023-08-30 Jan Raburski (13494) Dodawanie i usuwanie skladnikow do szablonow list plac


# 99 - analiza skladnikow
# 98 - pobranie szablonow obliczanych i drukowanych dla skladnika
# 97 - zapis skladnika do szablonow (obliczane i drukowane)

from funkcje import fs_kp_skladniki_placowe_pom

stat='OK'

rsglobal.ZapiszDoLogow('KLUCZE '+str(klucze),1)
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    # BP 2021-12-08
    SlPar={'Skladnik':[10,97,98,],'SkladnikF':[1,5],'OpisF':[1,5],'WszystkieF':[1,5], 'LSklad':[15,], 'Mod':[1,5],
           'SkladnikKopiowany':[20,], 'SkladnikNowy':[20], 'Zmienione':[97] }  #WS 2021-11-22 #JR 2023-08-31
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_skladniki_placowe z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        SkladnikF=rsglobal.Dekoduj(klucze['SkladnikF'])
        OpisF=rsglobal.Dekoduj(klucze['OpisF'])
        Mod=rsglobal.Dekoduj(klucze['Mod'])
        WszystkieF=rsglobal.Dekoduj(klucze['WszystkieF'])  #BP 2021-12-08
    
    if Funkcja in [10,98,97,]:
        Skladnik=rsglobal.Dekoduj(klucze['Skladnik'])

    if Funkcja in [15,]: 
        LSklad=klucze['LSklad']

    #WS 2021-11-22
    if Funkcja in [20,]:
        SkladnikKopiowany = rsglobal.Dekoduj(klucze['SkladnikKopiowany'])
        SkladnikNowy = rsglobal.Dekoduj(klucze['SkladnikNowy'])

    if Funkcja in [97,]:
        Zmienione = rsglobal.Dekoduj(klucze['Zmienione'])

dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'061013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=UprIns or ((self.oddzial_id,'061012') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprDel=((self.oddzial_id,'061014') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------- SPRAWDZENIE POPRAWNOCI ALGORYTMU SKADNIKW (15)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 15:
    LBledy = []
    for sklad in LSklad:
        if stat =='OK':
            # pobranie najnowszego algorytmu skadnika
            SQL = "SELECT algorytm FROM rs_kp_skladniki_placowe_wersje "
            SQL+= " WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+sklad+"' ORDER BY data_od DESC LIMIT 1"
            stat,DSklad,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DSklad) == 0:
                    stat = u'Brak skadnika '+sklad+u' lub definicji jego wersji'
            if stat=='OK':
                wyn = fs_kp_skladniki_placowe_pom.SprawdzSkladnieAlgorytmuSkladnika(self,DSklad[0][0])
                if wyn != 'OK':
                    LBledy.append(wyn)

    if stat == 'OK':
        dane = LBledy
        
#-------------------------------------------------------------------------------
#---   POBIERANIE OPISU (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat == 'OK':
    sql = "SELECT opis FROM rs_kp_skladniki_placowe WHERE firma_id = '"+self.firma_id+"' AND skladnik_id='"+str(Skladnik)+"';"
    stat,DSklad,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DSklad)>0:
            dane=[DSklad[0][0]]

#-------------------------------------------------------------------------------
#---   DELETE (1)
#-------------------------------------------------------------------------------
            
if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        # sprawdzanie DELETE 
        if stat == 'OK':
            for i in xrange(len(Delete[0])):
                if stat == 'OK':
                    DELETE = "DELETE FROM rs_kp_skladniki_placowe "
                    WHERE = "WHERE firma_id='"+self.firma_id+"' "
                    for j in xrange(len(Delete[0][i])):
                        pole = Delete[1][j]
                        wart = Delete[0][i][j]
                        if pole in ['skladnik_id',]:
                            WHERE += " AND "+pole+"='"+wart+"'"
                            SQL="SELECT Count(*) FROM rs_kp_listy_plac_osoby_skladniki WHERE firma_id='"+self.firma_id+"' "
                            SQL+="AND skladnik_id='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
                            if stat<>'OK':
                                stat=u'Bd sprawdzenia powizania ze skadnikami osb w licie pac'
                            elif d[0][0]>0:
                                stat = u"Nie mona usun skadnika '"+wart.strip()+u"' poniewa jest on aktualnie wykorzystywany"

                    if stat == 'OK':
                        stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE+WHERE),1)
                        if stat != 'OK':
                            stat = "Bd przy usuwaniu danych: "+stat
                            dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            
            for i in xrange(len(Update[0])):
                SQLUpd = ''
                zmieniane = [Update[2][y][Update[3].index('skrot')] for y in range(len(Update[2]))]
                skroty = []
                rsglobal.ZapiszDoLogow('i '+str(i),5)
                
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['skladnik_id',]:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                        SkladBazowy = wart
                rsglobal.ZapiszDoLogow('where '+str(WHERE),5)
            
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    rsglobal.ZapiszDoLogow('pole '+str(pole),5)
                    rsglobal.ZapiszDoLogow('wart '+str(wart),5)
                    
                    if pole == 'skladnik_id':
                        if wart.strip()=='':
                            dane.append('SKLADNIK BR')
                            wyn2.append((WierszeNr[i],0))
                        elif len(wart.strip())>10:
                            dane.append('SKLADNIK DL')
                            wyn2.append((WierszeNr[i],0))
                        else:
                            # zmieniamy skadnik w algorytmach innych skadnikw
                            if SkladBazowy != '':
                                SQLUpd = "UPDATE rs_kp_skladniki_placowe_wersje SET "
                                SQLUpd+=" algorytm = REPLACE(algorytm,'&"+SkladBazowy.strip()+"&','&"+wart.strip()+"&')"
                                SQLUpd+=" WHERE firma_id='"+self.firma_id+"' AND STRPOS(algorytm,'&"+SkladBazowy.strip()+"&')>0"
                            
                    elif pole == 'poprzedni_skladnik_id':
                        if wart<>'':
                            if len(wart.strip())>10:
                                dane.append('SKLADNIKPOPRZ DL')
                                wyn2.append((WierszeNr[i],0))


                    elif pole == 'opis':
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],1))
                            dane.append('OPIS BR')
                        elif len(wart.strip())>150:
                            dane.append('OPIS DL')
                            wyn2.append((WierszeNr[i],0))

                    elif pole == 'kolejnosc_obliczen':
                        if wart > 999:
                            dane.append('KOLEJNOSC DUZA')
                            wyn2.append((WierszeNr[i],4))

                    elif pole == 'skrot':
                        if len(wart.strip())>12:
                            wyn2.append((WierszeNr[i],5))
                            dane.append('SKROT DL')
                        elif len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('SKROT BR')
                            #AB 25.07.19r
                        elif wart not in zmieniane:
                            SQL = "SELECT 1 FROM rs_kp_skladniki_placowe WHERE firma_id='{}' AND skrot='{}'"
                            SQL = SQL.format(self.firma_id, wart.strip())
                            stat,skl,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                stat = 'Bd szukania powtrze skrtu: '+ stat
                                rsglobal.ZapiszDoLogow('break '+str(stat),5)
                                break
                            elif len(skl)>0:
                                wyn2.append((WierszeNr[i], 5))
                                dane.append('SKROT DUB')
                        if (WierszeNr[i], 5) not in wyn2:
                            if wart in skroty:
                                wyn2.append((WierszeNr[i], 5))
                                dane.append('SKROT DUB')
                            else:
                                skroty.append(wart.strip())
                    rsglobal.ZapiszDoLogow('wyn2 '+str(wyn2),5)


                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                        
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_kp_skladniki_placowe "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole in ['skladnik_id', 'opis', 'poprzedni_skladnik_id', 'modyfikowalny_recznie',
                                    'kolejnosc_obliczen', 'skrot', 'staly','jednorazowy', 'wg_daty_wyplaty']:  #AB 19.10.21r
                            SET+=pole+"='"+str(wart).strip().replace("\\","\\\\").replace("'","`")+"',"

                    SET=SET.strip(",")
                    WHERE+=";"
                    sql+=UPDATE+SET+WHERE+SQLUpd
                    rsglobal.ZapiszDoLogow('sql '+sql,1)
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat = "Bd przy modyfikowaniu danych: "+stat   
                        dane.append(stat)  
    
#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)
        skroty = []
        if stat == 'OK':
            WierszeNr = Insert[-1]

            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'skladnik_id':
                        if wart.strip()=='':
                            dane.append('SKLADNIK BR')
                            wyn2.append((WierszeNr[i],0))
                        elif len(wart.strip())>10:
                            dane.append('SKLADNIK DL')
                            wyn2.append((WierszeNr[i],0))

                    elif pole == 'poprzedni_skladnik_id':
                        if wart<>'':
                            if len(wart.strip())>10:
                                dane.append('SKLADNIKPOPRZ DL')
                                wyn2.append((WierszeNr[i],0))
                    
                    elif pole == 'opis':
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],1))
                            dane.append('OPIS BR')
                        elif len(wart.strip())>150:
                            dane.append('OPIS DL')
                            wyn2.append((WierszeNr[i],0))

                    elif pole == 'kolejnosc_obliczen':
                        if wart > 999:
                            dane.append('KOLEJNOSC DUZA')
                            wyn2.append((WierszeNr[i],4))

                    elif pole == 'skrot':
                        if len(wart.strip())>12:
                            wyn2.append((WierszeNr[i],5))
                            dane.append('SKROT DL')
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('SKROT BR')
                            #AB 25.07.19r
                        else:
                            SQL = "SELECT 1 FROM rs_kp_skladniki_placowe WHERE firma_id='{}' AND skrot='{}'"
                            SQL = SQL.format(self.firma_id, wart.strip())
                            stat,skl,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
                            if stat != 'OK':
                                stat = 'Bd szukania powtrze skrtu: '+ stat
                                break
                            elif len(skl)>0:
                                wyn2.append((WierszeNr[i], 5))
                                dane.append('SKROT DUB')
                            else:
                                rsglobal.ZapiszDoLogow('Dodaje skrot do instertu ' + str(wart.strip()))
                                if wart.strip() in skroty:
                                    wyn2.append((WierszeNr[i], 5))
                                    dane.append('SKROT DUB')
                                else:
                                    skroty.append(wart.strip())


        #czy nie bylo jakis bledow po drodze
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_skladniki_placowe "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['skladnik_id','opis','poprzedni_skladnik_id', 'modyfikowalny_recznie',
                                'kolejnosc_obliczen', 'skrot','staly','jednorazowy', 'wg_daty_wyplaty']:  #AB 19.10.21r
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart).strip().replace("\\","\\\\").replace("'","`")+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)                
                if stat<>'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)  

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete  5-select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':    
    SQL  = "SELECT skladnik_id,COALESCE(opis,''),COALESCE(poprzedni_skladnik_id,''), modyfikowalny_recznie,COALESCE(kolejnosc_obliczen,0), "
    SQL += "COALESCE(skrot,''), staly, jednorazowy, wg_daty_wyplaty"  #AB 19.10.21r
    SQL += " FROM rs_kp_skladniki_placowe "
    SQL += " WHERE firma_id='"+self.firma_id+"'"
    if SkladnikF != '':
        SQL += " AND UPPER(skladnik_id) LIKE UPPER('"+SkladnikF+"%')"  #WS 2023-02-06
        # SQL += " AND skladnik_id LIKE '"+SkladnikF+"%'"
    if OpisF != '':
        SQL += " AND UPPER(opis) LIKE UPPER('"+OpisF+"%')"  #WS 2023-02-06
        # SQL += " AND opis LIKE '"+OpisF+"%'"
    # BP 2021-12-08
    if not WszystkieF:
        SQL += " AND opis NOT LIKE '--%'"

    SQL+=" ORDER BY skladnik_id;"
    rsglobal.ZapiszDoLogow(SQL) # BP 2021-12-08
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------- KOPIOWANIE (20)
#-------------------------------------------------------------------------------

#WS 2021-11-22
if Funkcja == 20 and stat == "OK":
    if not UprIns:
        stat = 'BR UPR INS'
        dane.append(stat)

    if stat == 'OK':
        SQL = """SELECT 1 FROM rs_kp_skladniki_placowe 
                 WHERE firma_id='{self.firma_id}' AND skladnik_id='{SkladnikKopiowany}';"""
        SQL = SQL.format(**locals())
        rsglobal.ZapiszDoLogow(SQL)
        stat, spr_skl, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Wystpi bd podczas kopiowania skadnika pacowego: '+stat
        elif len(spr_skl) == 0:
            stat = 'Kopiowany skadnik nie istnieje'

    if stat == 'OK':
        SQL = """SELECT DISTINCT column_name FROM information_schema.columns 
                 WHERE table_name='rs_kp_skladniki_placowe'
                       AND column_name NOT IN ('z_czas','z_typ','z_op_id','firma_id','skladnik_id', 'skrot');"""  #AB 26.05.22r dopisany skrot do wyjatkow
        stat, skl, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Wystpi bd podczas pobrania listy pl do skopiowania: '+stat

    if stat == 'OK':
        lista_pol_skl = ', '.join([wiersz[0] for wiersz in skl])

        SQL = """INSERT INTO rs_kp_skladniki_placowe (firma_id, skladnik_id, {lista_pol_skl})
                 SELECT '{self.firma_id}', '{SkladnikNowy}', {lista_pol_skl}
                 FROM rs_kp_skladniki_placowe WHERE firma_id='{self.firma_id}' AND skladnik_id='{SkladnikKopiowany}';"""
        SQL = SQL.format(**locals())
        rsglobal.ZapiszDoLogow(SQL)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Wystpi bd podczas kopiowania skadnika pacowego: '+stat

    if stat == 'OK':
        SQL = """SELECT DISTINCT column_name FROM information_schema.columns 
                 WHERE table_name='rs_kp_skladniki_placowe_wersje'
                       AND column_name NOT IN ('z_czas','z_typ','z_op_id','firma_id','skladnik_id');"""
        stat, skl_wer, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Wystpi bd podczas pobrania listy pl do skopiowania: '+stat

    if stat == 'OK':
        lista_pol_skl_wer = ', '.join([wiersz[0] for wiersz in skl_wer])

        SQL = """INSERT INTO rs_kp_skladniki_placowe_wersje (firma_id, skladnik_id, {lista_pol_skl_wer})
                 SELECT '{self.firma_id}', '{SkladnikNowy}', {lista_pol_skl_wer}
                 FROM rs_kp_skladniki_placowe_wersje WHERE firma_id='{self.firma_id}' AND skladnik_id='{SkladnikKopiowany}';"""
        SQL = SQL.format(**locals())
        rsglobal.ZapiszDoLogow(SQL)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Wystpi bd podczas kopiowania wersji skadnika pacowego: '+stat

#-------------------------------------------------------------------------------
#---  funkcje pomocnicze do 97 i 98
#-------------------------------------------------------------------------------

def CzyJestSkladnikWLiscie(Lista, Skladnik):
    Lista = Lista.strip().replace('\n','').split(',')
    for w in Lista:
        if w.strip() == Skladnik.strip():
            return True
    #rsglobal.ZapiszDoLogow("w czym sprawdzamy:"+str(Lista))
    return False

#-------------------------------------------------------------------------------

def NowaListaSkladnikow(Lista, Skladnik, CzyMaByc, CzySort):
    def DodajSkladnikDoListy(Lista, Skladnik, i):
        Lista += Skladnik + ', '
        if i == 10:
            Lista += '\n'
            i = 0
        else:
            i += 1
        return (Lista, i)

    Lista = Lista.replace('\n','').split(',')
    Skladnik = Skladnik.strip()
    Nowe = ''
    i = 0
    if CzySort:
        Lista.sort()
        #rsglobal.ZapiszDoLogow('Lista po sorcie:'+str(Lista))
        poprz = ' '
        for s in Lista:
            s = s.strip()
            if s == poprz or s == '':  # pominiecie duplikatow i pustych
                continue
            if s < Skladnik:
                (Nowe, i) = DodajSkladnikDoListy(Nowe, s, i)
            elif s == Skladnik:
                if CzyMaByc:
                    (Nowe, i) = DodajSkladnikDoListy(Nowe, s, i)
            else:
                if poprz < Skladnik:
                    if CzyMaByc:
                        (Nowe, i) = DodajSkladnikDoListy(Nowe, Skladnik, i)
                else:
                    (Nowe, i) = DodajSkladnikDoListy(Nowe, s, i)
            poprz = s
        if poprz < Skladnik:  # dodajemy skladnik na koncu
            if CzyMaByc:
                (Nowe, i) = DodajSkladnikDoListy(Nowe, Skladnik, i)
    else:
        poprz = []
        for s in Lista:
            s = s.strip()
            if s in poprz:
                continue
            if s == Skladnik:
                if CzyMaByc:
                    poprz.append(Skladnik)
                else:
                    continue
            poprz.append(s)
        if CzyMaByc and not Skladnik in poprz:
            poprz.append(Skladnik)

        for s in poprz:
            Nowe += s + ', '
            if i == 10:
                Nowe += '\n'
                i = 0
            else:
                i += 1

    return Nowe[:-2]

#-------------------------------------------------------------------------------
#---  Zapis skladnikow do szablonow  (97)
#-------------------------------------------------------------------------------

if Funkcja == 97 and stat == "OK":
    # pobranie obliczanych i drukowanych do porownania ze zmienionymi
    sql = " SELECT sz.lista_id, "
    sql += " (SELECT skladniki FROM rs_kp_szablony_list_plac_wersje WHERE firma_id=sz.firma_id AND lista_id=sz.lista_id ORDER BY data_od DESC LIMIT 1),"
    sql += " (SELECT skladniki_dr FROM rs_kp_szablony_list_plac_wersje WHERE firma_id=sz.firma_id AND lista_id=sz.lista_id ORDER BY data_od DESC LIMIT 1),"
    sql += " (SELECT data_od FROM rs_kp_szablony_list_plac_wersje WHERE firma_id=sz.firma_id AND lista_id=sz.lista_id ORDER BY data_od DESC LIMIT 1)"
    sql += " FROM rs_kp_szablony_list_plac sz"
    sql += " WHERE sz.firma_id='"+self.firma_id+"'"
    sql += " ORDER BY lista_id"
    stat, szablony, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Wystpi bd podczas pobierania listy szablonw: ' + stat
    else:
        Poprzednie = {}
        for s in szablony:
            Poprzednie[s[0]] = [CzyJestSkladnikWLiscie(s[1],Skladnik),CzyJestSkladnikWLiscie(s[2],Skladnik), s[1], s[2], str(s[3])]

    # sprawdzamy, czy jest zmiana i zapisujemy
    dane = ''
    if stat == 'OK':
        for w in Zmienione:
            if Poprzednie.has_key(w[0]):  # jest szablon aktualny
                if w[1] != Poprzednie[w[0]][0] or w[2] != Poprzednie[w[0]][1]:
                    Obliczane =  NowaListaSkladnikow(Poprzednie[w[0]][2], Skladnik, w[1], True)
                    Drukowane =  NowaListaSkladnikow(Poprzednie[w[0]][3], Skladnik, w[2], False)
                    sql = " UPDATE rs_kp_szablony_list_plac_wersje SET skladniki='"+Obliczane+"',skladniki_dr='"+Drukowane+"'"
                    sql += " WHERE firma_id='" + self.firma_id + "' AND lista_id='"+w[0]+"' AND data_od='"+Poprzednie[w[0]][4]+"'::DATE"
                    stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
                    if stat != 'OK':
                        break
                    dane += w[0].strip() + ','
    dane = dane[:-1] + '.'


#-------------------------------------------------------------------------------
#---  Pobranie szablonow dla skladnika (98)
#-------------------------------------------------------------------------------

if Funkcja == 98 and stat == "OK":
    sql = " SELECT sz.lista_id, sz.opis, "
    sql += " COALESCE((SELECT skladniki FROM rs_kp_szablony_list_plac_wersje WHERE firma_id=sz.firma_id AND lista_id=sz.lista_id ORDER BY data_od DESC LIMIT 1),'brrak'),"
    sql += " (SELECT skladniki_dr FROM rs_kp_szablony_list_plac_wersje WHERE firma_id=sz.firma_id AND lista_id=sz.lista_id ORDER BY data_od DESC LIMIT 1)"
    sql += " FROM rs_kp_szablony_list_plac sz"
    sql += " WHERE sz.firma_id='"+self.firma_id+"'"
    sql += " ORDER BY lista_id"
    stat, szablony, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Wystpi bd podczas pobierania listy szablonw: ' + stat
    else:
        dane = []
        for s in szablony:
            if s[2] != 'brrak':  # szablon nie ma zadnej wersji
                dane.append([s[0],s[1],CzyJestSkladnikWLiscie(s[2],Skladnik),CzyJestSkladnikWLiscie(s[3],Skladnik)])


#-------------------------------------------------------------------------------
#---   ANALIZA (99)
#-------------------------------------------------------------------------------

if Funkcja == 99 and stat == "OK":
    dod = []  # lista pomocnicza
    dod.append('do_podatku_dochodowego')
    dod.append('do_skladki_zus')
    dod.append('do_grupy_statystycznej')
    dod.append('do_brutto')
    dod.append('do_sumy_potracen')
    dod.append('do_sumy_zasilkow')
    dod.append('z_zus_do_podatku_dochodowego')
    dod.append('do_nagrody_z_zysku')
    dod.append('do_podstawy_zasilku')
    dod.append('druk_na_zbiorowce')

    SQL  = "SELECT skladnik_id, TRIM(skladnik_id) || ' - ' || COALESCE(opis,''),COALESCE(kolejnosc_obliczen,0) "
    SQL += " FROM rs_kp_skladniki_placowe "
    SQL += " WHERE firma_id='"+self.firma_id+"'"
    SQL += " ORDER BY skladnik_id;"
    stat, listaskladnikow, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
    else:
        #rsglobal.ZapiszDoLogow('analiza:' + str(listaskladnikow))
        dane = []
        for skladnik in listaskladnikow:
            analiza = ''
            # sprawdzenie w listach plac
            SQL = "SELECT count(*) FROM rs_kp_listy_plac_osoby_skladniki WHERE firma_id='" + self.firma_id + "' "
            SQL += "AND skladnik_id='" + skladnik[0] + "';"
            stat, d, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
            if stat != 'OK':
                stat = u'Bd sprawdzenia powizania ze skadnikami osb w licie pac'
                break
            elif d[0][0] > 0:
                analiza = u"Wystpuje w policzonych listach pac.\n"

            # sprawdzenie w szablonach
            SQL = "SELECT lista_id FROM rs_kp_szablony_list_plac_wersje WHERE firma_id='" + self.firma_id + "' "
            SQL += "AND to_tsvector(skladniki) @@ to_tsquery('" + skladnik[0].strip() + "') order by lista_id;"
            stat, d, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
            if stat != 'OK':
                stat = u'Bd sprawdzenia w szablonach'
                break
            elif len(d) > 0:
                analiza += u"Wystpuje w szablonach list pac: "
                for w in d:
                    analiza += w[0].strip() + ','
                analiza = analiza[:-1] + '.\n'

            # sprawdzenie wlaczonych opcji
            SQL = "SELECT "
            for w in dod:
                SQL += w + ","
            SQL += " data_od FROM rs_kp_skladniki_placowe_wersje WHERE firma_id='" + self.firma_id + "' "
            SQL += "AND skladnik_id='" + skladnik[0] + "' ORDER BY data_od DESC LIMIT 1;"
            stat, d, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
            if stat != 'OK':
                stat = u'Bd sprawdzenia powizania z wersjami skadnikw'
                break
            elif len(d) == 0:
                analiza += u"Brak wersji skadnika.\n"
            else:
                pierwszy = True
                for i in range(10):
                    if d[0][i]:
                        if pierwszy:
                            analiza += 'Wczone sumy:'
                            pierwszy = False
                        analiza += dod[i] + ','
                if not pierwszy:
                    analiza = analiza[:-1] + ".\n"

            # sprawdzenie w skladnikach
            SQL = "SELECT spw.skladnik_id, COALESCE(sp.kolejnosc_obliczen,0) FROM rs_kp_skladniki_placowe_wersje spw"
            SQL += " INNER JOIN rs_kp_skladniki_placowe sp USING (firma_id, skladnik_id) WHERE firma_id='" + self.firma_id + "' "
            SQL += "AND to_tsvector(algorytm) @@ to_tsquery('" + skladnik[0].strip() + "') order by skladnik_id;"
            stat, d, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
            if stat != 'OK':
                stat = u'Bd sprawdzenia w skadnikach'
                break
            elif len(d) > 0:
                analiza += u"Wystpuje w algorytmach skadnikw: "
                for w in d:
                    analiza += w[0].strip()
                    if w[1] <= skladnik[2]:
                        analiza += '!!!'
                    analiza += ','
                analiza = analiza[:-1] + '.\n'

            if analiza == '':
                analiza = u'                     Nie wystpuje nigdzie.\n'
            dane.append('\n' + skladnik[1] + '\n' + analiza)
        #rsglobal.ZapiszDoLogow('analiza:' + str(dane))
