# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_skladniki_placowe_wersje.py
# Purpose:     obsluga grida edytowalnego z wersjami skadnika pacowego
# Author:      Micha Raburski
# Created:     2015/07/10
# RCS-ID:      $Id: fs_kp_skladniki_placowe_wersje $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Mikoaj Kozowski - 2021-01-29 (12300) Problem z updatem bez "data do"
# Wojciech Skowron - 2022-05-05 (12850) Kontrola dat

from funkcje import fs_kp_skladniki_placowe_pom

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Skladnik':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_skladniki_placowe_wersje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5]: 
            Skladnik=str(klucze['Skladnik'])
        
dane = []
wyn1 = []
wyn2 = []

UprModyf=((self.oddzial_id,'061015') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#WS 2022-05-05
def sprawdz_daty(self, data_od, data_do, nr_wiersza, Skladnik, dane, wyn2):
    if data_do not in ['None', '', '    -  -  ', '-  -'] and data_od > data_do:
        wyn2.append((nr_wiersza, 0))
        dane.append('DATY ZAKRES$'+str(int(nr_wiersza)))

    if data_od[8:] != '01':
        wyn2.append((nr_wiersza, 0))
        dane.append('DATAOD PIERWSZY')

    data_od = rsglobal.ZmienNaNULL(data_od)
    data_do = rsglobal.ZmienNaNULL(data_do)

    SEL = """SELECT 1 FROM rs_kp_skladniki_placowe_wersje
             WHERE firma_id='{self.firma_id}' AND skladnik_id='{Skladnik}' AND data_od!={data_od}
                   AND data_do IS NULL AND data_od<={data_od}
             LIMIT 1;""".format(**locals())
    rsglobal.ZapiszDoLogow('Kontrola daty do poprzedniej wersji: '+SEL)
    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = u'Bd kontroli daty do poprzedniej wersji: '+stat
        dane.append(stat)
        wyn2.append((nr_wiersza, 0))
    elif len(d) > 0:
        stat = 'DATADO PUSTA'
        dane.append(stat)
        wyn2.append((nr_wiersza, 0))
    else:
        SEL = """SELECT 1 FROM rs_kp_skladniki_placowe_wersje
                 WHERE firma_id='{self.firma_id}' AND skladnik_id='{Skladnik}' AND data_od!={data_od}
                       AND ((CASE WHEN {data_do} IS NULL THEN data_do>={data_od} ELSE data_do BETWEEN {data_od} AND {data_do} END 
                             OR (data_do IS NULL AND data_od<={data_od})) 
                            OR (CASE WHEN {data_do} IS NULL 
                                THEN data_od>={data_od} 
                                ELSE data_od BETWEEN {data_od} AND {data_do} 
                                END))
                 LIMIT 1;""".format(**locals())
        rsglobal.ZapiszDoLogow('Kontrola zazbiania dat: '+SEL)
        stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
        if stat != 'OK':
            stat = u'Bd kontroli zazbiania si dat: '+stat
            dane.append(stat)
            wyn2.append((nr_wiersza, 0))
        elif len(d) > 0:
            stat = 'DATY ZAZEB'
            dane.append(stat)
            wyn2.append((nr_wiersza, 0))

    if data_do != 'NULL':
        SEL = """SELECT 1 FROM rs_kp_skladniki_placowe_wersje
                 WHERE firma_id='{self.firma_id}' AND skladnik_id='{Skladnik}'
                       AND data_od>{data_od}
                 LIMIT 1;""".format(**locals())
        rsglobal.ZapiszDoLogow('Kontrola daty do: '+SEL)
        stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
        if stat != 'OK':
            stat = u'Bd sprawdzania daty do: '+stat
            dane.append(stat)
            wyn2.append((nr_wiersza, 0))
        elif len(d) > 0 and data_do.strip("'")[8:] != str(rsglobal.PodajOstatniDzien(data_do.strip("'"))).zfill(2):
            stat = 'DATADO OSTATNI'
            dane.append(stat)
            wyn2.append((nr_wiersza, 1))

    SEL = """SELECT data_do FROM rs_kp_skladniki_placowe_wersje
             WHERE firma_id='{self.firma_id}' AND skladnik_id='{Skladnik}'
                   AND data_od<{data_od}
             ORDER BY data_od DESC LIMIT 1;""".format(**locals())
    rsglobal.ZapiszDoLogow('Kontrola daty do w poprzednim wierszu: '+SEL)
    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = u'Bd sprawdzania daty do w poprzednim wierszu: '+stat
        dane.append(stat)
        wyn2.append((nr_wiersza, 0))
    elif len(d) > 0:
        data_do_poprzedni_wiersz = d[0][0]
        if data_do_poprzedni_wiersz[8:] != str(rsglobal.PodajOstatniDzien(data_do_poprzedni_wiersz)).zfill(2):
            stat = 'DATADO OSTATNI POPRZEDNI WIERSZ'
            dane.append(stat)
            wyn2.append((nr_wiersza, 0))

    return dane, wyn2


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT skladnik_id FROM rs_kp_skladniki_placowe_wersje"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+Skladnik+"'"
                DELETE = "DELETE FROM rs_kp_skladniki_placowe_wersje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+Skladnik+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"='"+wart+"'"
                    SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'data_od':
                        wart = wart.strip()
                        if wart in ['','-  -']:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BL')
                            
                    elif pole == 'data_do':
                        wart = wart.strip()
                        if not wart in ['','-  -']:  #MK 2021-01-29
                            if not rsglobal.SprawdzCzyToData(wart):
                                wyn2.append((WierszeNr[i],1))
                                dane.append('DATADO BL')
                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_kp_skladniki_placowe_wersje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['data_do',]:
                        if wart.strip() in ['','-  -']:
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+wart+"',"
                    elif pole in ['data_od','algorytm']:
                        SET+=pole+"='"+str(wart.replace("'","''"))+"',"
                    elif pole in ['na_liscie_plac','na_pasku_plac','zapis_do_listy_plac','pogrubienie',
                                  'do_podatku_dochodowego', 'do_skladki_zus', 'do_grupy_statystycznej', 'do_brutto', 'do_sumy_potracen',
                                  'do_sumy_zasilkow', 'z_zus_do_podatku_dochodowego', 'do_nagrody_z_zysku', 'do_podstawy_zasilku', 'druk_na_zbiorowce']:
                        if wart:
                            SET+=pole+"=TRUE,"
                        else:
                            SET+=pole+"=FALSE,"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+Skladnik+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['data_od']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)

        #WS 2022-05-05 - kontrola zazbiania si dat
        if stat == 'OK':
            # ptla po wszystkich zmodyfikowanych wierszach
            for pola, wartosci, klucz, nr_wiersza in zip(Update[0], Update[1], Update[2], Update[-1]):
                stat = 'OK'

                if 'data_od' in pola:
                    data_od = wartosci[pola.index('data_od')]
                else:
                    data_od = klucz[Update[3].index('data_od')]

                if 'data_do' in pola:
                    data_do = wartosci[pola.index('data_do')]
                else:
                    SEL = """SELECT data_do FROM rs_kp_skladniki_placowe_wersje
                             WHERE firma_id='{self.firma_id}' AND skladnik_id='{Skladnik}'
                                   AND data_od='{data_od}';""".format(**locals())
                    rsglobal.ZapiszDoLogow('Pobranie danych wiersza przed kontrola dat: '+SEL)
                    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
                    if stat != 'OK':
                        stat = u'Bd pobrania danych wiersza: '+stat
                        dane.append(stat)
                        wyn2.append((nr_wiersza, 0))
                    else:
                        data_do = d[0][0]

                if stat == 'OK':
                    dane, wyn2 = sprawdz_daty(self, data_od, data_do, nr_wiersza, Skladnik, dane, wyn2)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'data_od':
                        wart = wart.strip()
                        if wart in ['','-  -']:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BL')
                            
                    elif pole == 'data_do':
                        wart = wart.strip()
                        if not wart in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                wyn2.append((WierszeNr[i],1))
                                dane.append('DATADO BL')
                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_skladniki_placowe_wersje "
                KOLUMNY="(firma_id,skladnik_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Skladnik+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    KOLUMNY+=","+pole
                    if pole in ['data_od','data_do']:
                        if wart.strip() in ['','-  -']:
                            VALUES+=",NULL"
                        else:
                            VALUES+=",'"+wart+"'"
                    elif pole in ['algorytm']:
                        VALUES+=",'"+str(wart.replace("'","''"))+"'"

                    elif pole in ['na_liscie_plac','na_pasku_plac','zapis_do_listy_plac','pogrubienie',
                                  'do_podatku_dochodowego', 'do_skladki_zus', 'do_grupy_statystycznej', 'do_brutto', 'do_sumy_potracen',
                                  'do_sumy_zasilkow', 'z_zus_do_podatku_dochodowego', 'do_nagrody_z_zysku', 'do_podstawy_zasilku', 'druk_na_zbiorowce']:
                        if wart:
                            VALUES+=",TRUE"
                        else:
                            VALUES+=",FALSE"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

        #WS 2022-05-05 - kontrola zazbiania si dat
        if stat == 'OK':
            for wartosci, nr_wiersza in zip(Insert[0], Insert[-1]):
                stat = 'OK'

                data_od = wartosci[Insert[1].index('data_od')]
                data_do = wartosci[Insert[1].index('data_do')]

                dane, wyn2 = sprawdz_daty(self, data_od, data_do, nr_wiersza, Skladnik, dane, wyn2)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT data_od,data_do,na_liscie_plac,na_pasku_plac,zapis_do_listy_plac,pogrubienie,algorytm" \
         ",do_podatku_dochodowego, do_skladki_zus, do_grupy_statystycznej, do_brutto, do_sumy_potracen," \
         " do_sumy_zasilkow, z_zus_do_podatku_dochodowego, do_nagrody_z_zysku, do_podstawy_zasilku, druk_na_zbiorowce" \
         " FROM rs_kp_skladniki_placowe_wersje" \
         " WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+Skladnik+"'" \
         " ORDER BY data_od,data_do;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)