# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_stale_wartosci.py
# Purpose:     obsluga grida edytowalnego z wartociami staych kadrowych
# Author:      Marcin Natkaski
# Created:     2014/08/22
# RCS-ID:      $Id: fs_kp_stale_wartosci.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-01-31 Aleksander Bargie (11383) - Wartoci stae - bdne zaokrglenia
# 2021-10-19 Aleksander Bargie (12676) Daty obowizywania staych i wersji skadnikw uzalezni od daty wypaty listy

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Stala':[1,5,8],'StalaF':[1,5],'GrupaF':[1,5],'DataF':[1,5],'Data':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_stale_wartosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Stala=rsglobal.Dekoduj(klucze['Stala'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        StalaF=rsglobal.Dekoduj(klucze['StalaF'])
        GrupaF=rsglobal.Dekoduj(klucze['GrupaF'])
        DataF=rsglobal.Dekoduj(klucze['DataF'])
        
    if Funkcja in [8,]: 
        Stala=rsglobal.Dekoduj(klucze['Stala'])
        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

UprIns=((self.oddzial_id,'051047') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'051047') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'051047') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []



if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#------- POBRANIE PARY STALA - FORMAT (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat=='OK':
    SEL = "SELECT stala_id, format FROM rs_kp_typy_stalych WHERE firma_id='"+self.firma_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SEL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu listy formatw: '+stat
        dane.append(stat)
        
#------------------------------ -------------------------------------------------
#------- POBRANIE DOMYLNYCH TYPW DANYCH (7)
#-------------------------------------------------------------------------------

if Funkcja == 7 and stat=='OK':
    #sprwdmy czy nie naruszymy klucza
    SQR=" SELECT stala_id FROM rs_kp_stale WHERE"
    SQR+=" firma_id='"+self.firma_id+"' AND data_od=now()::DATE ;"
    stat,dane,dump,dump = self.PolSQL.Execute(SQR,3)
    if stat<>'OK':
        stat='Bad sprawdzania klucza'
        dane.append(stat)
    elif len(dane)>0:
        stat='Nie mona doda wartoci domylnych z dzisiejsz dat. Istniej ju pozycje z dzisiejsz dat.'
        dane.append(stat)
    else:
        SQL= "INSERT INTO rs_kp_stale"
        SQL+=" SELECT firma_id,now()::DATE,stala_id, 0,0,'',False "
        SQL+=" FROM rs_kp_typy_stalych "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND domyslna;"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd dodawania domylnych danych: '+stat
            dane.append(stat)
            
#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU GRUPY (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT nazwa,grupa,format FROM rs_kp_typy_stalych"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND stala_id='"+Stala+"' "
    if self.operator_id <> STANDARD_OPERATOR_ID:
        # jeeli operator<>anakonda to sprawdzamy dostp do grup
        sql+="AND grupa in (SELECT grupa FROM rs_grupy_stalych_upr "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)+");"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu staej: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kp_stale "
                WHERE = "WHERE firma_id='"+self.firma_id+"' "
                SQLFU = "SELECT stala_id FROM rs_kp_stale"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' " 
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['stala_id','data_od']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    rsglobal.ZapiszDoLogow(str(Update), 5)
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT stala_id FROM rs_kp_stale"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'stala_id':
                        stat = 'Nie mona modyfikowa identyfikatora staej. Prosz usun wiersz lub zmieni warto kolumny data do.'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                    elif pole == 'data_od':   
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR DATA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'BL DATA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)   
               
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_kp_stale "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['stala_id', 'wart_text',]:
                            SET+=pole+"='"+wart+"',"
                            
                        elif pole in ['wart_bool', 'wg_daty_wyplaty']:  #AB 19.10.21r
                            if wart == 0:
                                SET+=pole+"='False',"
                            else:
                                SET+=pole+"='True',"
                                
                        elif pole in ['wart_int',]:
                            SET+=pole+"='"+str(wart)+"',"
                        #AB 31.01.19r
                        elif pole in ['wart_num']:
                            SET+=pole+"='%.6f'," % wart

                        elif pole in ['data_od',]:
                            SET+=pole+"='"+str(wart)+"',"  
                            
                            
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['stala_id','data_od',]:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    rsglobal.ZapiszDoLogow(sql,5)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'stala_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR STALA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart)>10:
                            stat = 'Warto w kolumnie staa moe mie maksymalnie 10 znakw'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    
                    elif pole == 'data_od':   
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR DATA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'BL DATA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_kp_stale "
                    KOLUMNY="(firma_id"
                    VALUES=" VALUES ('"+self.firma_id+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['stala_id', 'wart_text',]:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
    
                        elif pole in ['wart_bool', 'wg_daty_wyplaty']:  #AB 19.10.21r
                            KOLUMNY+=","+pole
                            if wart == 0:
                                VALUES+=",FALSE"
                            else:
                                VALUES+=",TRUE"
                            
                        elif pole in ['data_od']:
                            KOLUMNY+=","+pole
                            if wart.strip() == '':
                                VALUES+=",NULL"
                            else:
                                VALUES+=",'"+wart+"'"
                        if pole in ['wart_num', 'wart_int',]:
                            KOLUMNY+=","+pole
                            #AB 31.01.19r
                            VALUES+=",%.6f" %wart
        
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':
    if stat=='OK':
        SQL ="SELECT a.stala_id, b.nazwa,b.grupa, a.data_od,b.format, a.wart_int,a.wart_num,a.wart_text,a.wart_bool, a.wg_daty_wyplaty "  #AB 19.10.21r
        SQL+=" FROM rs_kp_stale a INNER JOIN rs_kp_typy_stalych b "
        SQL+=" ON (a.firma_id=b.firma_id AND a.stala_id=b.stala_id) "
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' "
        if self.operator_id <> STANDARD_OPERATOR_ID:
            # jeeli operator<>anakonda to sprawdzamy dostp do grup
            SQL+="AND b.grupa in (SELECT grupa FROM rs_grupy_stalych_upr "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)+")"
        
        #dane filtru uzywane tylko przy zwyklym odczycie do grida
        if StalaF <> '':
            SQL+=" AND a.stala_id LIKE '"+StalaF+"%'"
        if GrupaF <> '':
            SQL+=" AND b.grupa LIKE '"+GrupaF+"%'"
        if DataF <> '    -  -  ':
            SQL+=" AND (a.stala_id,a.data_od) in "
            SQL+=" (SELECT stala_id,data_od  from rs_kp_stale "
            SQL+=" WHERE data_od<='"+DataF+"'"
            SQL+="ORDER BY  (data_od,stala_id) DESC "
            SQL+=" LIMIT (select count(distinct stala_id) from rs_kp_stale))"
        SQL+=" ORDER BY a.stala_id ;"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)