# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szablony_list_plac.py
# Purpose:     obsluga grida edytowalnego z list szablonw list pac
# Author:      Micha Raburski
# Created:     2015/07/17
# RCS-ID:      $Id: fs_kp_szablony_list_plac.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-02-11 Aleksander Bargie (11398) Do szablonw list dodac 'czy_karty_pracy'
# 2022-09-04 Aleksander Bargie (13145) [KP] Blokada ZUS w szablonach jeli s zamknite listy
# 2023-05-17 Jan Raburski (13421) - Dodanie kolumny dywidenda

stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
if stat=='OK':
    Funkcja = klucze['Funkcja']
                                                                                                                #AB 11.02.19r
    SlPar={'Szablon':[10,15],'SzablonF':[1,5,15],'OpisF':[1,5,15], 'SzablonS':[15],'Zus':[1,5,15],'Pit':[1,5,15],'KP':[1,5,15],'Tytulem':[1,5,15],'Dywidenda':[1,5,15]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista!='':
        stat='Uwaga : wywoanie funkcji fs_kp_szablony_list_plac z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    if Funkcja in [1,5,15]: 
        SzablonF=rsglobal.Dekoduj(klucze['SzablonF'])
        OpisF=rsglobal.Dekoduj(klucze['OpisF'])
        Zus=rsglobal.Dekoduj(klucze['Zus'])
        Pit=rsglobal.Dekoduj(klucze['Pit'])
        #AB 11.02.19r
        KP=rsglobal.Dekoduj(klucze['KP'])
        Dywidenda=rsglobal.Dekoduj(klucze['Dywidenda'])
        Tytulem=rsglobal.Dekoduj(klucze['Tytulem'])
    if Funkcja in [10,15]: 
        Szablon=rsglobal.Dekoduj(klucze['Szablon'])
    if Funkcja == 15: 
        SzablonS=rsglobal.Dekoduj(klucze['SzablonS'])

dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'061023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=UprIns or ((self.oddzial_id,'061022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprDel=((self.oddzial_id,'061024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------- SKOPIOWANIE SZABLONU LISTY PAC (15)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 15:
    # sprawdzenie czy s uprawnienia do dodawania szablonw
    if not UprIns:
        stat='BR UPR INS'
        dane.append(stat)
    
    # sprawdzenie czy nowy szablon ma niewykorzystywany symbol
    if stat == 'OK':
        SQL = "SELECT lista_id FROM rs_kp_szablony_list_plac WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
        stat,DListy,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat!='OK':
            stat = u'Bd sprawdzania wystpowania nowego symbolu listy: '+stat
        if stat=='OK':
            if len(DListy) > 0:
                stat = u'Podano uywany symbol listy'
                
    # wstawienie nowego szablonu
    if stat == 'OK':
        SQLIns = "INSERT INTO rs_kp_szablony_list_plac (firma_id,lista_id,opis,"     #AB 11.02.19r
        SQLIns += "do_deklaracji_zus_z_data_wyplaty,do_deklaracji_pit_z_data_wyplaty,czy_karty_pracy,tekst_na_przelewie,czy_dywidenda) VALUES ('"
        SQLIns += self.firma_id+"','"+Szablon+"','Nowa lista','"+str(Zus)
                                        #AB 11.02.19r
        SQLIns += "','"+str(Pit)+"','"+str(KP)+"','"+str(Tytulem).strip().replace("\\","\\\\").replace("'","`")+"','"+str(Dywidenda)+"' );"
        
        # skopiowanie ostatniej listy pl ze starego szablonu
        SQL="SELECT skladniki FROM rs_kp_szablony_list_plac_wersje WHERE firma_id='"+self.firma_id+"' AND lista_id='"+SzablonS+"' ORDER BY data_od DESC LIMIT 1"
        stat,DListy,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = u'Bd pobierania skadnikw ze starego szablonu: '+stat
        if stat=='OK':
            if len(DListy) > 0:
                SQLIns+="INSERT INTO rs_kp_szablony_list_plac_wersje (firma_id,lista_id,data_od,skladniki) VALUES ('"+self.firma_id+"','"+Szablon+"',NOW()::DATE,'"+DListy[0][0]+"')"
            stat,dump,dump,dump = self.PolSQL.Execute(SQLIns,1)
            if stat != 'OK':
                stat = u'Bd kopiowania szablonu listy pac: '+stat
                
                
#-------------------------------------------------------------------------------
#---   POBIERANIE OPISU SZABLONU LISTY PAC (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat == 'OK':
    sql = "SELECT opis FROM rs_kp_szablony_list_plac WHERE firma_id = '"+self.firma_id+"' AND lista_id='"+str(Szablon)+"';"
    stat,DSzablon,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DSzablon)>0:
            dane=[DSzablon[0][0]]


#-------------------------------------------------------------------------------
#---   DELETE (1)
#-------------------------------------------------------------------------------
            
if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)

        # sprawdzanie DELETE 
        if stat == 'OK':
            for i in xrange(len(Delete[0])):
                if stat == 'OK':
                    DELETE = "DELETE FROM rs_kp_szablony_list_plac "
                    WHERE = "WHERE firma_id='"+self.firma_id+"' "
                    for j in xrange(len(Delete[0][i])):
                        pole = Delete[1][j]
                        wart = Delete[0][i][j]
                        if pole in ['lista_id',]:
                            WHERE += " AND "+pole+"='"+wart+"'"
                            Lista = wart
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE+WHERE),1)
                    if stat != 'OK':
                        stat = u"Nie mona usun szablonu "+Lista.strip()+u" poniewa jest on wykorzystywany w innych tabelach"
                        dane.append(stat)     

#-------------------------------------------------------------------------------
#---   UPDATE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            
            for i in xrange(len(Update[0])):
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                #nietypowo najpierw klucz bo potrzebujemy lokacji do sprawdzenia pola 'liczba'
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['lista_id',]:
                        WHERE+=" AND "+pole+"='"+wart+"'"
            
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]    
                    if pole == 'lista_id':
                        if wart.strip()=='':
                            dane.append('SZABLON BR')
                            wyn2.append((WierszeNr[i],0))
                        elif len(wart.strip())>10:
                            dane.append('SZABLON DL')
                            wyn2.append((WierszeNr[i],0))
                            
                    elif pole == 'opis':
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],1))
                            dane.append('OPIS BR')
                        elif len(wart.strip())>150:
                            dane.append('OPIS DL')
                            wyn2.append((WierszeNr[i],0))
                            
                    elif pole == 'tekst_na_przelewie':
                        if len(wart.strip())>70:
                            wyn2.append((WierszeNr[i],4))
                            dane.append('TEKST DL')

                    elif pole == 'konto_id':
                        if wart != '':
                            stat,DTest,dump,dump = self.PolSQL.Execute("SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+wart+"'",3)
                            if stat != 'OK':
                                stat = 'Bd pobierania opisu konta bankowego:'+stat
                            elif len(DTest) == 0:
                                wyn2.append((WierszeNr[i],5))
                                dane.append('KONTO BL')
                    #AB 04.09.22r
                    elif pole == 'do_deklaracji_zus_z_data_wyplaty':
                        stat,DTest2,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_kp_listy_plac " + WHERE + "AND stan IN ('Z', 'K');",3)
                        if stat != 'OK':
                            stat = 'Bd szukania list pac:'+stat
                        elif len(DTest2) > 0:
                            wyn2.append((WierszeNr[i],5))
                            dane.append('ZAMK LISTY')

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                        
                # wykonanie UPDATE
                if stat == 'OK':
                    sql = ''
                    UPDATE = "UPDATE rs_kp_szablony_list_plac "
                    SET = 'SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        
                        if pole in ['lista_id', 'opis', 'tekst_na_przelewie','konto_id']:
                            if wart.strip()=='':
                                SET+=pole+"=NULL,"
                            else:
                                SET+=pole+"='"+str(wart).strip().replace("\\","\\\\").replace("'","`")+"',"
                                                                                                            #AB 11.02.19rF
                        if pole in ['do_deklaracji_zus_z_data_wyplaty', 'do_deklaracji_pit_z_data_wyplaty', 'czy_karty_pracy','czy_dywidenda']:
                            SET += pole+"='"+str(wart)+"',"

                    SET = SET.strip(",")
                    WHERE += ";"
                    sql += UPDATE+SET+WHERE
                    stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat != 'OK':
                        stat = "Bd przy modyfikowaniu danych: "+stat   
                        dane.append(stat)  
    
#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)
 
        if stat == 'OK':
            WierszeNr = Insert[-1]

            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole = Insert[1][j]
                    wart = Insert[0][i][j]
                    
                    if pole == 'lista_id':
                        if wart.strip()=='':
                            dane.append('SZABLON BR')
                            wyn2.append((WierszeNr[i],0))
                        elif len(wart.strip())>10:
                            dane.append('SZABLON DL')
                            wyn2.append((WierszeNr[i],0))

                    elif pole == 'opis':
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],1))
                            dane.append('OPIS BR')
                        elif len(wart.strip())>150:
                            dane.append('OPIS DL')
                            wyn2.append((WierszeNr[i],0))
                            
                    elif pole == 'tekst_na_przelewie':
                        if len(wart.strip())>70:
                            wyn2.append((WierszeNr[i],4))
                            dane.append('TEKST DL')

                    elif pole == 'konto_id':
                        if wart != '':
                            stat,DTest,dump,dump = self.PolSQL.Execute("SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+wart+"'",3)
                            if stat != 'OK':
                                stat = 'Bd pobierania opisu konta bankowego:'+stat
                            elif len(DTest) == 0:
                                wyn2.append((WierszeNr[i],5))
                                dane.append('KONTO BL')

        #czy nie bylo jakis bledow po drodze
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_szablony_list_plac "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                                                                                                        #AB 11.02.19r
                    if pole in ['do_deklaracji_zus_z_data_wyplaty', 'do_deklaracji_pit_z_data_wyplaty', 'czy_karty_pracy','czy_dywidenda']:
                        KOLUMNY += ","+pole
                        VALUES += ",'"+str(wart)+"'"
                           
                    if pole in ['lista_id','opis', 'tekst_na_przelewie','konto_id']:
                        if str(wart)=='':
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart).strip().replace("\\","\\\\").replace("'","`")+"'"
                        
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
                
            if sqlIns!='': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat!='OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)  

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete  5-select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5,15) and stat == 'OK':    
    SQL  = "SELECT slp.lista_id,COALESCE(slp.opis,''),slp.do_deklaracji_zus_z_data_wyplaty,"
                                                    #AB 11.02.19r
    SQL += "slp.do_deklaracji_pit_z_data_wyplaty, slp.czy_karty_pracy, slp.czy_dywidenda, slp.tekst_na_przelewie,slp.konto_id,kb.bank"
    SQL += " FROM rs_kp_szablony_list_plac slp "
    SQL+=" LEFT OUTER JOIN rs_konta_bankowe kb USING (firma_id,konto_id) "
    SQL += " WHERE slp.firma_id='"+self.firma_id+"'"
    if SzablonF != '':
        SQL += " AND LOWER(slp.lista_id) LIKE LOWER('"+SzablonF+"%')"
    if OpisF != '':
        SQL += " AND LOWER(slp.opis) LIKE LOWER('"+OpisF+"%')"
    SQL+=" ORDER BY slp.lista_id;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat!='OK':
        stat="Bd przy pobieraniu danych: "+stat