# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szablony_list_plac_wersje.py
# Purpose:     obsluga grida edytowalnego z wersjami szablonu listy pac
# Author:      Micha Raburski
# Created:     2015/08/10
# RCS-ID:      $Id: fs_kp_szablony_list_plac_wersje $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2022-07-26 Wojciech Skowron (13086) - Poprawka w sprawdzaniu skadnikw
# 2022-09-23 Wojciech Skowron (13171) - Kontrola na skadniki 'PIT%'

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Szablon':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szablony_list_plac_wersje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5]: 
            Szablon=str(klucze['Szablon'])
        
dane = []
wyn1 = []
wyn2 = []

UprModyf=((self.oddzial_id,'061025') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT lista_id FROM rs_kp_szablony_list_plac_wersje"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
                DELETE = "DELETE FROM rs_kp_szablony_list_plac_wersje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"='"+wart+"'"
                    SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU != '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL != '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'data_od':
                        if wart.strip() in ['','-  -']:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BL')    
                            
                    elif pole == 'data_do':
                        if not wart.strip() in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                wyn2.append((WierszeNr[i],1))
                                dane.append('DATADO BL')    
                    
                    elif pole == 'skladniki':
                        if wart != '':
                            LSklad = wart.split(',')
                            LSkladBl = ''
                            for sklad in LSklad:
                                SQL="SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+sklad.strip()+"'"  #WS 2022-07-26 - dodany strip()
                                stat,DSklad,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat<>'OK':
                                    stat = u'Bd sprawdzania skadnika obliczanego na wersji szabloniu listy pac: '+stat
                                if stat == 'OK' and len(DSklad) == 0:
                                    LSkladBl += sklad+','

                            if stat =='OK' and len(LSkladBl) > 0:
                                wyn2.append((WierszeNr[i],2))
                                dane.append('SKLADNIKI BL$'+LSkladBl.strip(','))
                    elif pole == 'skladniki_dr':
                        if wart != '':
                            LSklad = wart.split(',')
                            LSkladBl = ''
                            for sklad in LSklad:
                                SQL = "SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id='" + self.firma_id + "' AND skladnik_id='"+sklad.strip()+"'"  #WS 2022-07-26 - dodany strip()
                                stat, DSklad, dump, dump = self.PolSQL.Execute(SQL, 3)
                                if stat != 'OK':
                                    stat = u'Bd sprawdzania skadnika drukowanego na wersji szabloniu listy pac: ' + stat
                                if stat == 'OK' and len(DSklad) == 0:
                                    LSkladBl += sklad + ','

                            if stat == 'OK' and len(LSkladBl) > 0:
                                wyn2.append((WierszeNr[i], 3))
                                dane.append('SKLADNIKI_DR BL$' + LSkladBl.strip(','))

                    #WS 2022-09-23
                    if pole in ['skladniki', 'skladniki_dr']:
                        if wart != '':
                            skladniki = wart.split(',')
                            skladniki = [s.strip() for s in skladniki]
                            bledy = []
                            for skl in skladniki:
                                if skladniki.count(skl) > 1:
                                    wyn2.append((WierszeNr[i], 2 if pole == 'skladniki' else 3))
                                    dane.append('SKLADNIKI DUPLI$'+skl)
                                    break
                            skladniki_pit = [skl for skl in skladniki if skl.startswith('PIT')]
                            if any(skladniki_pit) and len(skladniki_pit) != len(skladniki):
                                wyn2.append((WierszeNr[i], 2 if pole == 'skladniki' else 3))
                                dane.append("SKLADNIKI PIT")
                        
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_kp_szablony_list_plac_wersje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['data_do',]:
                        if wart.strip() in ['','-  -']:
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+wart+"',"
                    elif pole in ['data_od','skladniki','skladniki_dr']:
                        SET+=pole+"='"+str(wart)+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['data_od']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'data_od':
                        if wart.strip() in ['','-  -']:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BL')    
                            
                    elif pole == 'data_do':
                        if not wart.strip() in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                wyn2.append((WierszeNr[i],1))
                                dane.append('DATADO BL')    
                    
                    elif pole == 'skladniki':
                        if wart != '':
                            LSklad = wart.split(',')
                            LSkladBl = ''
                            for sklad in LSklad:
                                SQL="SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id='"+self.firma_id+"' AND skladnik_id='"+sklad.strip()+"'"  #WS 2022-07-26 - dodany strip()
                                stat,DSklad,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat<>'OK':
                                    stat = u'Bd sprawdzania skadnika obliczanego na wersji szabloniu listy pac: '+stat
                                if stat == 'OK' and len(DSklad) == 0:
                                    LSkladBl += sklad+','
                            
                            if stat =='OK' and len(LSkladBl) > 0:
                                wyn2.append((WierszeNr[i],2))
                                dane.append('SKLADNIKI BL$'+LSkladBl.strip(','))

                    elif pole == 'skladniki_dr':
                        if wart != '':
                            LSklad = wart.split(',')
                            LSkladBl = ''
                            for sklad in LSklad:
                                SQL = "SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id='" + self.firma_id + "' AND skladnik_id='"+sklad.strip()+"'"  #WS 2022-07-26 - dodany strip()
                                stat, DSklad, dump, dump = self.PolSQL.Execute(SQL, 3)
                                if stat != 'OK':
                                    stat = u'Bd sprawdzania skadnika drukowanego na wersji szabloniu listy pac: ' + stat
                                if stat == 'OK' and len(DSklad) == 0:
                                    LSkladBl += sklad + ','

                            if stat == 'OK' and len(LSkladBl) > 0:
                                wyn2.append((WierszeNr[i], 3))
                                dane.append('SKLADNIKI_DR BL$' + LSkladBl.strip(','))

                    #WS 2022-09-23
                    if pole in ['skladniki', 'skladniki_dr']:
                        if wart != '':
                            skladniki = wart.split(',')
                            skladniki = [s.strip() for s in skladniki]
                            bledy = []
                            for skl in skladniki:
                                if skladniki.count(skl) > 1:
                                    wyn2.append((WierszeNr[i], 2 if pole == 'skladniki' else 3))
                                    dane.append('SKLADNIKI DUPLI$'+skl)
                                    break
                            skladniki_pit = [skl for skl in skladniki if skl.startswith('PIT')]
                            if any(skladniki_pit) and len(skladniki_pit) != len(skladniki):
                                wyn2.append((WierszeNr[i], 2 if pole == 'skladniki' else 3))
                                dane.append("SKLADNIKI PIT")
                                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_szablony_list_plac_wersje "
                KOLUMNY="(firma_id,lista_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Szablon+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    KOLUMNY+=","+pole
                    if pole in ['data_od','data_do']:
                        if wart.strip() in ['','-  -']:
                            VALUES+=",NULL"
                        else:
                            VALUES+=",'"+wart+"'"
                    elif pole in ['skladniki','skladniki_dr']:
                        VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT data_od,data_do,skladniki,skladniki_dr"
    SQL+=" FROM rs_kp_szablony_list_plac_wersje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND lista_id='"+Szablon+"'"
    SQL+=" ORDER BY data_od,data_do;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)