# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_harmonogram.py
# Purpose:     odsluga grida z harmonogramem szkoleń
# Author:      Marcin Natkaski
# Created:     2012/06/14
# RCS-ID:      $Id: fs_kp_szkolenia_harmonogram.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

import datetime

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'
DataWaznosci=''

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'FSzkolenie':[5,6,10,11],'FStan':[5,6,10,11],'FMiejsce':[5,6,10,11],'FData':[5,6,10,11],
    'FGodzina':[5,6,10,11],'FProwadzacy':[5,6,10,11],'FProwadzacyObcy':[5,6,10,11],'Szkolenie':[6,10,11,12],
    'Data':[6,10,11,12],'Godzina':[6,10,11,12],'Miejsce':[6,10,11,12],'Stan':[10,11],'SzkolenieU':[12],
    'DataU':[12],'GodzinaU':[12],'MiejsceU':[12]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_harmonogram z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [5,6,10,11]:
        FSzkolenie=rsglobal.Dekoduj(klucze['FSzkolenie'])
        FStan=rsglobal.Dekoduj(klucze['FStan'])
        FMiejsce=rsglobal.Dekoduj(klucze['FMiejsce'])
        FData=rsglobal.Dekoduj(klucze['FData'])
        FGodzina=rsglobal.Dekoduj(klucze['FGodzina'])
        FProwadzacy=rsglobal.Dekoduj(klucze['FProwadzacy'])
        FProwadzacyObcy=rsglobal.Dekoduj(klucze['FProwadzacyObcy'])
        
    if Fun in [6,10,11,12]:
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Godzina=rsglobal.Dekoduj(klucze['Godzina'])
        Miejsce=rsglobal.Dekoduj(klucze['Miejsce'])
        
    if Fun in [10,11]:
        Stan=rsglobal.Dekoduj(klucze['Stan'])
        
    if Fun in [12]:
        SzkolenieU=rsglobal.Dekoduj(klucze['SzkolenieU'])
        MiejsceU=rsglobal.Dekoduj(klucze['MiejsceU'])
        DataU=rsglobal.Dekoduj(klucze['DataU'])
        GodzinaU=rsglobal.Dekoduj(klucze['GodzinaU'])

UprUsuwanie = ((self.oddzial_id,'053204') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja = ((self.oddzial_id,'053202') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- ZMIANA KLUCZA SZKOLENIA - 12
#-------------------------------------------------------------------------------

if Fun==12 and stat=='OK':
    if not UprEdycja:
        stat='Brak uprawnie do edytowania szkolenia.'

    # robimy krtkie testy danych
    if Data=='    -  -  ':
        stat='Prosz poda dat szkolenia.' 
    if not rsglobal.SprawdzCzyToData(Data):
        stat='Podana data jest bdna.'
    if Godzina=='  :  ':
        stat='Prosze poda godzin szkolenia.'
    if Miejsce=='':
        stat='Prosze poda miejsce szkolenia.'
    elif Miejsce<>'':
        SQL="SELECT kod FROM rs_szkolenia_miejsca WHERE kod='"+Miejsce+"' ;"
        stat,d,wyn1,dump =self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd podczas pobierania symbolu miejsca szkolenia.'
        if len(d)==0:
            stat='Podany symbol miejsca nie istnieje w bazie danych.'
            
    #Sprawdzamy czy nie naruszymy klucza
    SQL=''
    
    if stat<>'OK':
        stat='Bd sprawdzania klucza szkolenia : '+stat
    
    if stat=='OK':
        SQL= "SELECT szkolenie_id FROM rs_szkolenia_harmonogram WHERE"
        SQL+="(firma_id,szkolenie_id,data,godzina,miejsce) = "
        SQL+=" ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"');"
        stat,d,wyn1,dump =self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd sprawdzania unikalnoci klucza szkolenia :'+stat
        elif len(d)>0:
            stat='Istnieje szkolenie o podanym kluczu'

    if stat=='OK':
        # Jeeli z kluczami jest wszystko ok, to robimy update
        UPD= " UPDATE rs_szkolenia_harmonogram SET"
        UPD+=" (firma_id,szkolenie_id,data,godzina,miejsce) = "
        UPD+=" ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"') "
        UPD+=" WHERE (firma_id,szkolenie_id,data,godzina,miejsce) = "
        UPD+=" ('"+self.firma_id+"','"+SzkolenieU+"','"+DataU+"','"+GodzinaU+"','"+MiejsceU+"')"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD, 1)
        if stat<>'OK':
            stat='Bd zmiany stanu szkolenia : '+stat
            
    if stat=='OK':
        # Jeeli z kluczami jest wszystko ok, to robimy update
        UPD= " UPDATE rs_szkolenia_harmonogram SET"
        UPD+=" (firma_id,szkolenie_id,data,godzina,miejsce) = "
        UPD+=" ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"') "
        UPD+=" WHERE (firma_id,szkolenie_id,data,godzina,miejsce) = "
        UPD+=" ('"+self.firma_id+"','"+SzkolenieU+"','"+DataU+"','"+GodzinaU+"','"+MiejsceU+"')"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD, 1)
        if stat<>'OK':
            stat='Bd zmiany stanu szkolenia : '+stat
            
            
#-------------------------------------------------------------------------------
#--- ZAMYKANIE - 10
#-------------------------------------------------------------------------------

if Fun==10 and stat=='OK':
    if not UprEdycja:
        stat='Brak uprawnie do edytowania szkolenia.'
    
    if stat=='OK':
        spr= "SELECT s.typ_szkolenia FROM rs_szkolenia s JOIN rs_szkolenia_typy t ON s.firma_id=t.firma_id AND s.typ_szkolenia=t.kod "
        spr+="WHERE s.firma_id = '"+self.firma_id+"' and s.szkolenie_id='"+Szkolenie+"';"
        stat,sp,dump,dump = self.PolSQL.Execute(spr, 3)
        if stat<>'OK':
            stat=u'Bd sprawdzenia typu szkolenia'
        elif len(sp)==0:
            stat=u'Nie mona zamkn. Typ dla szkolenia '+Szkolenie.strip()+u' nie istnieje '

    if stat == 'OK':
        if Stan=='W':
            #---Zmieniamy tylko stan szkolenia w harmonogramie i nic wicej
            SQL =" UPDATE rs_szkolenia_harmonogram SET stan='Z'"
            SQL+=" WHERE (firma_id,szkolenie_id,data,godzina,miejsce)"
            SQL+=" =('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"');"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
            if stat<>'OK':
                stat='Bd zmiany stanu szkolenia : '+stat
        else:
            #---Pobieranie wszystkich pracownikw przypitych do szkolenia-----------------
            SEL= "SELECT pracownik_id FROM rs_szkolenia_harmonogram_pracownicy "
            SEL+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
            SEL+=" AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' AND obecny "
            stat,prac,wyn1,dump =self.PolSQL.Execute(SEL, 3)
            if stat<>'OK':
                stat='Bd pobierania listy pracownikw w szkoleniu : '+stat        
            #---Pobranie iloci dni ze szkolenia. Jeeli 0 to bezterminowe------------------
            if stat=='OK':
                SQL="SELECT okres_waznosci FROM rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'; "
                stat,il,wyn1,dump =self.PolSQL.Execute(SQL, 3)
                if stat=='OK':
                    if il[0][0]<>0: 
                        #--Jeeli szkolenie ma dni wanoci to trzeba przygotowa sobie termin wanoci 
                        DataWaznosci = datetime.datetime.strptime(Data, "%Y-%m-%d").date()                            
                        DataWaznosci = DataWaznosci + datetime.timedelta(days=il[0][0])
                        DataWaznosci = "'"+DataWaznosci.strftime("%Y-%m-%d")+"'"
                    else:
                        DataWaznosci= 'NULL'
                else:
                    stat='Bd pobierania liczby dni wanoci szkolenia : '+stat
            #---Wpisywanie pracownikom w ptli odbytego szkolenia w ich kartotece
            if stat=='OK':
                for i in xrange(len(prac)):
                    pracownik=rsglobal.Dekoduj(prac[i][0])
                    INS=" INSERT INTO rs_kp_dane_osobowe_szkolenia "
                    INS+=" (firma_id, pracownik_id, szkolenie_id, data_szkolenia, data_waznosci)"
                    INS+=" VALUES ('"+self.firma_id+"','"+pracownik+"','"+str(sp[0][0])+"', '"+Data+"', "+DataWaznosci+");  "
                    if INS<>'':
                        rsglobal.ZapiszDoLogow('INS:'+str(INS))
                        stat,dump,dump,dump = self.PolSQL.Execute(INS, 1)
                        if stat<>'OK':
                            stat='Bd dodawania pracownikw do szkolenia : '+stat
            #---Zmiana stanu szkolenia na O
            if stat=='OK':
                UPD= "UPDATE rs_szkolenia_harmonogram SET stan='O'"
                UPD+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
                UPD+=" AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
                if UPD<>'':
                    stat,dump,dump,dump = self.PolSQL.Execute(UPD, 1)
                    if stat<>'OK':
                        stat='Bd zmiany stanu szkolenia : '+stat

#-------------------------------------------------------------------------------
#--- OTWIERANIE - 11
#-------------------------------------------------------------------------------

if Fun==11 and stat=='OK':
    if not UprEdycja:
        stat='Brak uprawnie do edytowania szkolenia.'
    if stat=='OK':
        spr= "SELECT s.typ_szkolenia FROM rs_szkolenia s JOIN rs_szkolenia_typy t ON s.firma_id=t.firma_id AND s.typ_szkolenia=t.kod "
        spr+="WHERE s.firma_id = '"+self.firma_id+"' and s.szkolenie_id='"+Szkolenie+"';"
        stat,sp,dump,dump = self.PolSQL.Execute(spr, 3)
        if stat<>'OK':
            stat=u'Bd sprawdzenia typu szkolenia'
        elif len(sp)==0:
            stat=u'Nie mona otworzy. Typ dla szkolenia '+Szkolenie.strip()+u' nie istnieje '
    if stat=='OK':
        if Stan=='O':
            #---Pobieranie wszytstkich pracownikw przypitych do szkolenia
            SEL= "SELECT pracownik_id FROM rs_szkolenia_harmonogram_pracownicy "
            SEL+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
            SEL+=" AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
            stat,prac,wyn1,dump =self.PolSQL.Execute(SEL, 3)
            if stat<>'OK':
                stat='Bd pobierania listy pracownikw w szkoleniu : '+stat
            #---Usuwanie im w ptli odbytego szkolenia w ich kartotece
            if stat=='OK':
                for i in xrange(len(prac)):
                    pracownik=rsglobal.Dekoduj(prac[i][0])
                    DEL=" DELETE FROM rs_kp_dane_osobowe_szkolenia "
                    DEL+=" WHERE (firma_id, pracownik_id, szkolenie_id, data_szkolenia)"
                    DEL+=" = ('"+self.firma_id+"','"+pracownik+"','"+str(sp[0][0])+"', '"+Data+"' ); "
                    if DEL<>'':
                        stat,dump,dump,dump = self.PolSQL.Execute(DEL, 1)
                        if stat<>'OK':
                            stat='Bd usuwania pracownikw w szkoleniu : '+stat                
            #---Zmiana stanu szkolenia na Z
            if stat=='OK':
                UPD= "UPDATE rs_szkolenia_harmonogram SET stan='Z'"
                UPD+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
                UPD+=" AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
                if UPD<>'':
                    stat,dump,dump,dump = self.PolSQL.Execute(UPD, 1)
                    if stat<>'OK':
                        stat='Bd zmiany stanu szkolenia : '+stat
        else:
            #--Zmieniamy tylko stan i nic wicej
            UPD= "UPDATE rs_szkolenia_harmonogram SET stan='W'"
            UPD+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
            UPD+=" AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
            stat,dump,dump,dump = self.PolSQL.Execute(UPD, 1)
            if stat<>'OK':
                stat='Bd zmiany stanu szkolenia : '+stat
        
#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':    
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania szkolenia.'
    #--Sprawdzam stan szkolenia przed usuwaniem
    if stat=='OK':
        SQL= " SELECT stan from rs_szkolenia_harmonogram"
        SQL+= " WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
        SQL+= " AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"'  AND stan='O'"
        stat,st,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd pobierania stanu szkolenia:'+stat
        if len(st)>0:
            stat='Nie mona usuwa szkolenia w stanie O  '
    #-- Jeeli stan rny od O to usuwamy
    if stat=='OK':
        DELETE = "DELETE FROM rs_szkolenia_harmonogram"
        DELETE+= " WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"' "
        DELETE+= " AND data='"+Data+"' AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
        stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat='Bd usuwania szkolenia z harmonogramu : '+stat
            
                
#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy szkole
#-------------------------------------------------------------------------------

if Fun in (5,6)  and stat == 'OK':    
    SQL = "SELECT sh.szkolenie_id, sh.data, substring(sh.godzina::text from 0 for 6), "
    SQL+= " sh.miejsce,sm.opis, COALESCE((kpd.imie||' '||kpd.nazwisko),''), COALESCE(kont.nazwa,''), COALESCE(sh.stan,'')"
    SQL+= " FROM rs_szkolenia_harmonogram sh "
    SQL+= " LEFT OUTER JOIN rs_kp_dane_osobowe kpd ON (sh.firma_id=kpd.firma_id AND sh.prowadzacy_pracownik=kpd.pracownik_id) "
    SQL+= " LEFT OUTER JOIN rs_kontrahenci kont ON (sh.firma_id=kont.firma_id AND sh.prowadzacy_kontrahent=kont.kontrahent_id) "
    SQL+= " LEFT OUTER JOIN rs_szkolenia_miejsca sm on (sh.firma_id=sm.firma_id AND sh.miejsce=sm.kod)"
    SQL+= " WHERE sh.firma_id='"+self.firma_id+"' "
    
    if FSzkolenie<>'':
        SQL+= " AND szkolenie_id='"+FSzkolenie+"' "
    if FData<> '    -  -  ':
        SQL+= " AND data='"+FData+"' "
    if FGodzina<>'  :  ':
        SQL+= " AND substring(sh.godzina::text from 0 for 6)='"+FGodzina+"' "
    if FMiejsce<>'':
        SQL+= " AND miejsce='"+FMiejsce+"' "
    if FProwadzacy<>'':
        SQL+= " AND prowadzacy_pracownik='"+FProwadzacy+"' "
    if FProwadzacyObcy<>'':
        SQL+= " AND prowadzacy_kontrahent='"+FProwadzacyObcy+"' "
    SQL+=" ORDER BY sh.szkolenie_id, sh.data,substring(sh.godzina::text from 0 for 6),  sh.miejsce"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy szkole : '+stat   