 # -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_umowy_o_prace_dane
# Purpose:     dodawanie/edycja danych umowy o prace
# Author:      Mariusz Rajfura
# Created:     2009/09/24
# RCS-ID:      $Id: fs_kp_umowy_o_prace_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2022-04-22 (12970) Aleksander Bargie - [KP] Kopiowa wszystkie dane ostatniego angau przy dodawaniu nowej umowy
# 2022-05-23 (13030) Aleksander Bargie - Wpisanie daty do w umowie lub angazu powioduje zmiane stanu zatrudnienia na Z

puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')

def SprNakladanieDat(self, Fun, Pracownik, Zatrudnienie, Umowa, Data_Od, Data_Do):
    stat = 'OK'
    SELECT ="SELECT umowa_id FROM rs_kp_umowy_o_prace"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    SELECT+=" AND zatrudnienie_id = "+str(Zatrudnienie)

    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        SELECT+=" AND ("
        SELECT+=" ( do_kiedy IS NOT NULL AND '"+Data_Od+"' >= od_kiedy AND '"+Data_Od+"' <= do_kiedy )"

        #jesli podano date do
        if Data_Do != 'NULL':
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            SELECT+=" OR (od_kiedy > '"+Data_Od+"' AND od_kiedy <= '"+Data_Do+"' )"

            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            SELECT+=" OR (do_kiedy IS NOT NULL AND do_kiedy >= '"+Data_Od+"' AND do_kiedy <= '"+Data_Do+"' )"

            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            SELECT+=" OR (do_kiedy IS NOT NULL AND '"+Data_Do+"' > od_kiedy AND '"+Data_Do+"' <= do_kiedy)"
        SELECT+=");"

    #sprawdzenie unikalnosci zakresow przed UPDATE
    if Fun in (3,4):
        #w przypadku edycji moze sie zdarzyc, ze jedna z dat nie jest modyfikowana
        #wtedy nie mamy jej wartosci. poniewaz mamy pelne dane klucza, to mozemy
        #pobrac te niemodyfikowana wartosc z tabeli
        if Data_Od == None or Data_Do == None:
            sql ="SELECT od_kiedy,do_kiedy FROM rs_kp_umowy_o_prace"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql,2)
            if stat != 'OK':
                stat = 'Bd pobrania dat z umowy o prace : '+stat
            else:
                if len(d) != 1:
                    stat = 'Brak danych umowy o prace : '+stat
                else:
                    if Data_Od == None:
                        Data_Od = str(d[0][0])
                        if Data_Od == 'None':
                            Data_Od = 'NULL'
                    if Data_Do == None:
                        Data_Do = str(d[0][1])
                        if Data_Do == 'None':
                            Data_Do = 'NULL'

        #wykluczenie z SELECT modyfikowanej pozycji
        SELECT+=" AND umowa_id != "+str(Umowa)+" AND ("

        #sprawdzamy, czy data poczatkowa nie miesci sie
        #w jakims dokladnie okreslonym zakresie od-do
        SELECT+="( do_kiedy IS NOT NULL AND '"+Data_Od+"' >= od_kiedy AND '"+Data_Od+"' <= do_kiedy )"

        if Data_Do != 'NULL':
            SELECT+=" AND ("
            #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
            SELECT+=" (od_kiedy >= '"+Data_Od+"' AND od_kiedy <= '"+Data_Do+"' )"

            #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
            SELECT+=" OR (do_kiedy IS NOT NULL AND do_kiedy >= '"+Data_Od+"' AND do_kiedy <= '"+Data_Do+"' )"

            #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
            SELECT+=" OR (do_kiedy IS NOT NULL AND '"+Data_Do+"' >= od_kiedy AND '"+Data_Do+"' <= do_kiedy)"
            SELECT+=")"

        SELECT+=");"

    stat,d,dump,dump = self.PolSQL.Execute(SELECT,2)
    if stat != 'OK':
        stat = 'Bd sprawdzenia pokrywania si zakresw dat umw o prac : '+stat

    if stat == 'OK':
        if len(d) > 0:
            stat = 'BL_POKRYWANIA_DAT'

    return stat

#-------------------------------------------------------------------------------

Pracownik = klucze[0]
Zatrudnienie = klucze[1]
Umowa = klucze[2]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','umowy_o_prace','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052032') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun ==  7 and stat == 'OK':
    Data = str(klucze[3])

    sql ="SELECT umowa_id FROM rs_kp_umowy_o_prace"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id != "+str(Umowa)    
    sql+=" AND (do_kiedy =(date '"+ str(Data) + "' - interval '1 day'));"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia poprzedniej umowy'+stat

#-------------------------------------------------------------------------------

if Fun ==  8 and stat == 'OK':
    Data = str(klucze[3])

    sql ="SELECT umowa_id FROM rs_kp_umowy_o_prace"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id != "+str(Umowa)    
    sql+=" AND (od_kiedy =(date '"+ str(Data) + "' + interval '1 day'));"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia nastpnej umowy'+stat

#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    #czy edycja dotyczy ostatniej umowy
    sql ="SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+";"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia ostatniego numeru umowy o prac : '+stat
    else:
        if d[0][0] in ['None','']:
            stat = 'Brak umw u prac - edycja niedostpna'

DataZawarcia = None
OdKiedy = None
DoKiedy = None
OdKiedyZus = None
DoKiedyZus = None
RodzajUmowy = None

if Fun in (1,2) and stat == 'OK':
    sql ="SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+";"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru z kartoteki umw o prac : '+stat
    else:
        if d[0][0] in ['None','']:
            Umowa = 1
        else:
           Umowa = int(d[0][0])+1

if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'umowa_id':
            continue

        elif pole == 'data_zawarcia':
            if wart == '    -  -  ':
                dane.append('BR_DATA_ZAWARCIA')
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    DataZawarcia = wart
                else:
                    dane.append('BL_DATA_ZAWARCIA')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'od_kiedy':
            if wart == '    -  -  ':
                dane.append('BR_OD_KIEDY')
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    OdKiedy = wart
                else:
                    dane.append('BL_OD_KIEDY')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'do_kiedy':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
                DoKiedy = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    DoKiedy = wart
                    wartosci[i] = "'"+wart+"'"
                else:
                    dane.append('BL_DO_KIEDY')

        elif pole == 'od_kiedy_zus':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
                OdKiedyZus = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    OdKiedyZus = wart
                    wartosci[i] = "'"+wart+"'"
                    if Umowa > 1:
                        sql = """SELECT MAX(od_kiedy_zus), MAX(do_kiedy_zus)
                                 FROM rs_kp_umowy_o_prace 
                                 WHERE (firma_id, pracownik_id, zatrudnienie_id) = (%s, %s, %s) AND umowa_id < %s;"""
                        args = [self.firma_id, Pracownik, Zatrudnienie, Umowa]
                        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
                        stat, daty_zus, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = u"Bd sprawdzania dat ZUS: " + stat
                        elif len(daty_zus) != 1:
                            stat = u"Nie udao si pobra danych  do weryfikacji dat ZUS."
                        else:
                            w = daty_zus[0]
                            if w[0] not in puste:  # by zapisany do ZUS, ale nie wypisany, wic nei powinien zaczyna kolejnego okresu
                                if w[1] in puste or w[0] > w[1]:
                                    stat = u"Rejestracja w ZUS od {} musi zosta zakoczona przed rozpoczciem " \
                                           u"kolejnego okresu.".format(w[0])
                else:
                    dane.append('BL_OD_KIEDY_ZUS')
            
        elif pole == 'do_kiedy_zus':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
                DoKiedyZus = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    DoKiedyZus = wart
                    wartosci[i] = "'"+wart+"'"
                else:
                    dane.append('BL_DO_KIEDY_ZUS')

        elif pole == 'rodzaj_umowy_id':
            if wart == '':
                dane.append('BR_RODZAJ_UMOWY')
            else:
                RodzajUmowy = wart
                sql ="SELECT kod FROM rs_umowy_rodzaj"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu rodzaju umowy : '+stat)
                elif len(d) == 0:
                    dane.append('BL_RODZAJ_UMOWY')
            wartosci[i] = "'"+wart+"'"

        elif pole == 'typ_pracownika_id':
            if wart == '':
                dane.append('BR_TYP_PRACOWNIKA')
            else:
                sql ="SELECT kod FROM rs_typy_pracownikow"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu typu pracownika : '+stat)
                elif len(d) == 0:
                    dane.append('BL_TYP_PRACOWNIKA')
            wartosci[i] = "'"+wart+"'"

        else:
            #pozostale pola
            wartosci[i] = "'"+wart+"'"

    if len(dane) > 0:
        stat = dane[0]

if stat == 'OK':
    #umowa na czas probny i okreslony musi miec date do_kiedy
    if RodzajUmowy in ('PR','CO'):
        if DoKiedy in (None,'NULL'):
            stat = 'BR_DO_KIEDY_RODZAJ_UMOWY'

if Fun in (1,2) and stat == 'OK':
    #w przypadku dodawania umowa na czas nieokrelony powinna mie puste do_kiedy
    if RodzajUmowy == 'CN':
        if not DoKiedy in (None,'NULL'):
            stat = 'BL_DO_KIEDY_CZAS_NIEOKRESLONY'

if stat == 'OK':
    if DoKiedy != None:
        if OdKiedy > DoKiedy:
            stat = 'BL_OD_DO_KIEDY'
            dane.append(stat)

    if DataZawarcia > OdKiedy:
        stat = 'BL_ZAWARCIA_OD_KIEDY'
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    sql ="SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+";"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru z kartoteki umw o prac : '+stat
    else:
        if d[0][0] in ['None','']:
            Umowa = 1
        else:
            Umowa = int(d[0][0])+1
    if stat == 'OK':
        inspola = "firma_id,pracownik_id,zatrudnienie_id,umowa_id"
        inswart = "'"+self.firma_id+"','"+Pracownik+"',"+str(Zatrudnienie)+","+str(Umowa)

        for i in xrange(len(pola)):
            if pola[i] != 'umowa_id':
                inspola += ","+pola[i]
                inswart += ","+wartosci[i]
            if pola[i] == 'od_kiedy':
                data_od = wartosci[i]

        INSERT = "INSERT INTO rs_kp_umowy_o_prace ("+inspola+") VALUES ("+inswart+");"
        #AB 22.04.22r
        # INSERT+= "INSERT INTO rs_kp_angaze (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
        # INSERT+= "VALUES('"+self.firma_id+"','"+Pracownik+"',"+str(Zatrudnienie)+","+str(Umowa)+",1);"
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat != 'OK':
            stat = 'Bd dodawania nowej umowy o prac : '+stat
            dane.append(stat)

    if stat == 'OK':
        if Umowa > 1:  #AB 23.05.22r do_kiedy na NULL
            INSUM = """INSERT INTO rs_kp_angaze
                        (firma_id, pracownik_id, umowa_id, angaz_id, od_kiedy, do_kiedy, zatrudnienie_id, miejsce_id, komorka_id,
                         rodzaj_pracownika_id, grupa_pracownikow_id, etat, stanowisko_id, zawod_wykonywany_id,
                          stanowisko_kosztow_id, grupa_zaszeregowania, kategoria_zaszeregowania, placa, stawka, 
                          dodatek_fun, ryczalt, dodatek1, dodatek2, kalendarz_id, stanowisko_miejsce_id, 
                          lista_id, zerowy_pit, ulga_kl_sr, ulga_rodz_plus, ulga_na_powrot, ulga_dla_emeryta)
                        SELECT * FROM (SELECT firma_id, pracownik_id, umowa_id+1, 1, %s::DATE, NULL, zatrudnienie_id, miejsce_id, komorka_id,
                                        rodzaj_pracownika_id, grupa_pracownikow_id, etat, stanowisko_id, zawod_wykonywany_id,
                                         stanowisko_kosztow_id, grupa_zaszeregowania, kategoria_zaszeregowania, placa, stawka, 
                                         dodatek_fun, ryczalt, dodatek1, dodatek2, kalendarz_id, stanowisko_miejsce_id, 
                                         lista_id, zerowy_pit, ulga_kl_sr, ulga_rodz_plus, ulga_na_powrot, ulga_dla_emeryta
                                       FROM rs_kp_angaze s
                                       WHERE firma_id = %s
                                           AND pracownik_id = %s
                                           AND zatrudnienie_id = %s
                                           AND umowa_id = %s - 1
                                           AND angaz_id = (SELECT MAX(angaz_id)
                                                            FROM rs_kp_angaze s2
                                                            WHERE (s2.firma_id, s2.pracownik_id, s2.zatrudnienie_id, s2.umowa_id) = 
                                                                  (s.firma_id,   s.pracownik_id,  s.zatrudnienie_id,  s.umowa_id)
                                                            )
                         UNION 
                        SELECT %s, %s, %s, 1, %s::DATE, NULL::DATE, %s, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL) AS x
                        ORDER BY grupa_pracownikow_id IS NOT NULL DESC
                        LIMIT 1;
                        
                                             
                        INSERT INTO rs_kp_angaze_skladniki
                            (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id, skladnik_id, data_od, data_do, kwota)
                            SELECT firma_id, pracownik_id, zatrudnienie_id, umowa_id + 1, 1, skladnik_id, data_od, data_do, kwota
                            FROM rs_kp_angaze_skladniki s
                            WHERE firma_id = %s
                                AND pracownik_id = %s
                                AND zatrudnienie_id = %s
                                AND umowa_id = %s - 1
                                AND angaz_id = (SELECT MAX(angaz_id)
                                                 FROM rs_kp_angaze_skladniki s2
                                                 WHERE (s2.firma_id, s2.pracownik_id, s2.zatrudnienie_id, s2.umowa_id) = 
                                                       (s.firma_id,   s.pracownik_id,  s.zatrudnienie_id,  s.umowa_id)
                                                 );"""
            args = [data_od, self.firma_id, Pracownik, Zatrudnienie, Umowa, self.firma_id, Pracownik, Umowa, data_od,
                    Zatrudnienie, self.firma_id, Pracownik, Zatrudnienie, Umowa]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSUM, args))
            stat, dump, dump, dump = self.PolSQL.Execute(INSUM, 1, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd kopiowania poprzedniego angau : ' + stat
                rsglobal.ZapiszDoLogow(stat)
                dane.append(stat)

        else:
            INSERT= "INSERT INTO rs_kp_angaze (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
            INSERT+= "VALUES('"+self.firma_id+"','"+Pracownik+"',"+str(Zatrudnienie)+","+str(Umowa)+",1);"
            stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
            if stat != 'OK':
                stat = 'Bd dodawania angau na nowej umowie: '+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_umowy_o_prace SET "

    for i in xrange(len(pola)):
        UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE = UPDATE[:-1]
    UPDATE+= " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    UPDATE+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+";"
    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat != 'OK':
        stat = 'Bd aktualizacji danych umowy o prac : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    RodzajUmowy = ''
    TypPracownika = ''
    IloscAngazy = 0

    SELECT ="SELECT * FROM rs_kp_umowy_o_prace"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    SELECT+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych umowy o prac : '+stat
        dane.append(stat)

    if stat == 'OK':
        #pobranie ilosci angazy: brak angazy pozwala edytowac calosc umowy
        #istanieje angaze pozwalaja tylko na edycje reprezentanta i ukladu zbiorowego
        sql ="SELECT angaz_id FROM rs_kp_angaze"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND umowa_id = "+str(Umowa)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o liczbie angay do umowy : '+stat
        else:
            IloscAngazy = len(d)

    if stat == 'OK':
        for i in xrange(len(dane[0])):
            pole = wyn1[i][0]
            wart = str(dane[0][i])

            if pole == 'rodzaj_umowy_id':
                if (self.oddzial_id,'011680') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_umowy_rodzaj WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        RodzajUmowy = 'Bd pobrania opisu ze sownika rodzaju umowy : '+stat
                    else:
                        if len(d) == 0:
                            RodzajUmowy = 'Bdny kod rodzaju umowy.'
                        else:
                            RodzajUmowy = str(d[0][0])
                else:
                    RodzajUmowy = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'typ_pracownika_id':
                if (self.oddzial_id,'011690') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_typy_pracownikow WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        TypPracownika = 'Bd pobrania opisu ze sownika typw pracownikw : '+stat
                    else:
                        if len(d) == 0:
                            TypPracownika = 'Bdny kod typu pracownika.'
                        else:
                            TypPracownika = str(d[0][0])
                else:
                    TypPracownika = 'Brak uprawnie do sownika. Poinformuj administratora.'

        # JR 2023-05-20 (13422)
        sql = "SELECT COALESCE(pracownik, False) FROM rs_kp_dane_osobowe "
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            CzyPracownik = False
        else:
            CzyPracownik = d[0][0]

    wyn2 = [RodzajUmowy,TypPracownika,IloscAngazy, CzyPracownik]
