# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_zatrudnienie_dane
# Purpose:     dodawanie/edycja danych umowy o prace
# Author:      Mariusz Rajfura
# Created:     2009/09/24
# RCS-ID:      $Id: fs_kp_zatrudnienie_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2016-10-21 - Marcin Natkaski - (10084) - umoliwienie edytowania nieostatnich zatrudnie
# 2017-03-03 (10290) Piotr Witkowski - Zmiany w oknie Zatrudnienie - umowy
# 2018-05-14 (11033) Aleksander Bargie - Bdnie wywietlane dane o uldze w oknie edycji zatrudnienia
# 2018-06-12 (10869) Aleksander Bargie - Dodanie staw w zatrudnieniu
# 2018-06-11 (11109) Aleksander Bargie - BLAD dodawania zatrudnienia
# 2018-06-11 (11162) Aleksander Bargie - BLAD dodawania zatrudnienia
# 2018-09-07 (11212) Aleksander Bargie [KP] czy_absencje w zatrudnieniu
# 2019-03-26 (11433) Wojciech Skowron - Funkcja 6 pobierajaca daty do stazy z ostatniego zatrudnienia
# 2019-04-03 (11433) Wojciech Skowron - Poprawka w insert (insertowanie dat do stay) oraz update (spr czy data pusta)
# 2020-02-14 (11858) Aleksander Bargie - Brak opisu pola rdo naboru w zatrudnieniu
# 2021-03-26 (12417) Aleksander Bargie Zatrudnienie - nowe pola
# 2021-04-26 (12461) Wojciech Skowron - Ubezpieczenie RSA, data obowizywania od, data obowizywania do

from datetime import datetime

Pracownik = klucze[0]
Numer = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','zatrudnienie','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052022') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

# 2016-10-21 - Marcin Natkaski

#if Fun in (3,4) and stat == 'OK':
    # #czy edycja dotyczy ostatniego zatrudnienia
    # sql ="SELECT MAX(numer_id) FROM rs_kp_zatrudnienie"
    # sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"
    #
    # stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    # if stat != 'OK':
    #     stat = 'Bd sprawdzenia ostatniego numeru zatrudnienia : '+stat
    # else:
    #     if d[0][0] in ['None','']:
    #         stat = 'Brak zatrudnienia - edycja niedostpna'
    #     else:
    #         if Numer != int(d[0][0]):
    #             stat = 'To nie jest ostatnie zatrudnienie. Modyfikacja niedostpna.'

if Fun in (1,2,3,4) and stat == 'OK':
    #WS 2021-04-26
    UbezpieczenieRSA = None
    DataOd = None
    DataDo = None
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'numer_id':
            continue

        elif pole == 'stan_pracownika_id':
            if Fun in (1,2):
                wart = 'A'
            wartosci[i] = "'"+wart+"'"

        elif pole == 'zrodlo_naboru_id':
            if wart == '':
                wartosci[i] = "NULL"
            else:
                sql ="SELECT kod FROM rs_zrodla_naboru"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu rda naboru : '+stat)
                elif len(d) == 0:
                    dane.append('BL_ZRODLO_NABORU')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'ubezpieczenie_id':
            if wart == '':
                wartosci[i] = "NULL"
            else:
                sql ="SELECT kod FROM rs_rodzaje_ubezpieczen"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu ubezpieczenia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_UBEZPIECZENIE')
                wartosci[i] = "'"+wart+"'"

        #WS 2021-04-26
        elif pole == 'ubezpieczenie_rsa':
            if wart == '':
                wartosci[i] = "NULL"
                UbezpieczenieRSA = ''
            else:
                sql ="SELECT kod FROM rs_rodzaje_ubezpieczen"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu ubezpieczenia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_UBEZPIECZENIE_RSA')
                wartosci[i] = "'"+wart+"'"
                UbezpieczenieRSA = wart

        elif pole == 'urzad_skarbowy_id':
            if wart == '':
                wartosci[i] = "NULL"
            else:
                sql ="SELECT kod FROM rs_urzedy_skarbowe"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu urzdu skarbowego : '+stat)
                elif len(d) == 0:
                    dane.append('Brak podanego urzdu skarbowego')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'oddzial_nfz_id':
            if wart == '':
                wartosci[i] = "NULL"
            else:
                sql ="SELECT kod FROM rs_oddzialy_nfz"
                sql+=" WHERE kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania kodu oddziau NFZ : '+stat)
                elif len(d) == 0:
                    dane.append('Brak podanego oddziau NFZ')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'glowne_miejsce_pracy':
            wartosci[i] = str(wart)

        elif pole == 'start_rok_urlop':
            if wart == 0 or wart < 2009:
                dane.append('BL_START_ROK_URLOP')
            wartosci[i] = str(wart)

        elif pole == 'urlop_wykorzystany':
            if wart < 0:
                dane.append('BL_URLOP_WYKORZYSTANY')
            wartosci[i] = str(wart)

        elif pole == 'urlop_zalegly':
            if wart < 0:
                dane.append('BL_URLOP_ZALEGLY')
            wartosci[i] = str(wart)

        elif pole == 'start_rok_zwolnienie':
            if wart == 0 or wart < 2009:
                dane.append('BL_START_ROK_ZWOLNIENIE')
            wartosci[i] = str(wart)

        elif pole == 'choroba_wykorzystana':
            if wart < 0:
                dane.append('BL_CHOROBA_WYKORZYSTANA')
            wartosci[i] = str(wart)
            
        #WS 2021-04-26
        elif pole == 'data_obowiazywania_od':
            if wart not in ('    -  -  ', '', 'None'):
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA_OD')
                else:
                    wartosci[i] = "'"+wart+"'"
                    DataOd = wart
            else:
                wartosci[i] = "NULL"
                DataOd = ''

        #WS 2021-04-26
        elif pole == 'data_obowiazywania_do':
            if wart not in ('    -  -  ', '', 'None'):
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA_DO')
                else:
                    wartosci[i] = "'"+wart+"'"
                    DataDo = wart
            else:
                wartosci[i] = "NULL"
                DataDo = ''
            
        elif pole in ('przyczyna_wyrejestrowania_zus','podst_prawna_rozw_stos_pracy','kod_rozw_stos_pracy'):
            if wart == '':
                wartosci[i] = "NULL"
            else:
                #sql ="SELECT kod FROM rs_urzedy_skarbowe"
                #sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                #stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                #if stat != 'OK':
                #    dane.append('Bd pobrania kodu urzdu skarbowego : '+stat)
                #elif len(d) == 0:
                #    dane.append('Brak podanego urzdu skarbowego')
                wartosci[i] = "'"+wart+"'"
        elif pole in ('dane_globalne','pit_11_8','pit_40','koszty_podwyzszone','emerytalne','rentowe','chorobowe',
                                                            #AB 07.09.18r
                      'wypadkowe','zdrowotne','fp','fgsp', 'czy_absencje'):
            #pozostale pola
            wartosci[i] = str(wart)
        else:
            wartosci[i] = "'"+wart+"'"

    #WS 2021-04-26
    if UbezpieczenieRSA is None:
        sql ="SELECT ubezpieczenie_rsa FROM rs_kp_zatrudnienie"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND numer_id = "+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            dane.append('Bd pobrania kodu ubezpieczenia : '+stat)
        elif len(d) == 0:
            dane.append('Bd pobrania kodu ubezpieczenia : '+stat)
        else:
            if d[0][0].strip() not in ('', 'None'):
                UbezpieczenieRSA = d[0][0].strip()
            else:
                UbezpieczenieRSA = ''

    #WS 2021-04-26
    if DataOd is None:
        sql ="SELECT data_obowiazywania_od FROM rs_kp_zatrudnienie"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND numer_id = "+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            dane.append('Bd pobrania daty obowizywania od : '+stat)
        elif len(d) == 0:
            dane.append('Bd pobrania daty obowizywania oo : '+stat)
        else:
            if d[0][0] not in ('    -  -  ', '', 'None'):
                DataOd = d[0][0]
            else:
                DataOd = ''

    #WS 2021-04-26
    if DataDo is None:
        sql ="SELECT data_obowiazywania_do FROM rs_kp_zatrudnienie"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND numer_id = "+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            dane.append('Bd pobrania daty obowizywania do : '+stat)
        elif len(d) == 0:
            dane.append('Bd pobrania daty obowizywania do : '+stat)
        else:
            if d[0][0] not in ('    -  -  ', '', 'None'):
                DataDo = d[0][0]
            else:
                DataDo = ''

    #WS 2021-04-26
    if UbezpieczenieRSA is not None and UbezpieczenieRSA == '' and (DataOd != '' or DataDo != ''):
        dane.append('BR_UBEZPIECZENIE_RSA')
    elif UbezpieczenieRSA is not None and UbezpieczenieRSA != '' and DataOd == '' and DataDo == '':
        dane.append('BR_DAT')
    else:
        if DataOd == '' and DataDo != '':
            dane.append('BR_DATA_OD')
        elif DataOd != '' and DataDo == '':
            dane.append('BR_DATA_DO')
        elif DataOd != '' and DataDo != '' and DataOd > DataDo:
            dane.append('BL_DATY_WIEKSZA')

    if len(dane) > 0:
        stat = dane[0]

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    sql ="SELECT MAX(numer_id) FROM rs_kp_zatrudnienie"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru z kartoteki zatrudnienia : '+stat
    else:
        if d[0][0] in ['None','']:
            Numer = 1
        else:
            Numer = int(d[0][0])+1

    if stat == 'OK':
        inspola = "firma_id,pracownik_id,numer_id"
        inswart = "'"+self.firma_id+"','"+Pracownik+"',"+str(Numer)

        for i in xrange(len(pola)):
            #AB 2018-07-26
            if pola[i].strip() in ('staz_ogolem', 'staz_do_urlopu', 'staz_do_zasilku', 'staz_do_nagrody', 'staz_do_dodatku'):
                if wartosci[i][1:-1] in ('    -  -  ', '', None):
                    #WS 2019-04-03
                    inspola += "," + pola[i]
                    inswart += "," + 'NULL'
                    # UPDATE += pola[i] + " = NULL,"
                else:
                    dateString = wartosci[i][1:-1]
                    #WS 2019-04-03
                    # date = datetime.strptime(dateString, '%Y-%m-%d')
                    if rsglobal.SprawdzCzyToData(dateString):
                        date = datetime.strptime(dateString, '%Y-%m-%d')
                        if date > datetime.now():
                            stat = 'DATA_STAZ_ZA_DUZA'
                        #WS 2019-04-03
                        inspola += ","+pola[i]
                        inswart += ","+wartosci[i]
                        # UPDATE += pola[i] + "=" + wartosci[i] + ","
                    else:
                        stat = 'BL_DATA_STAZ'

            elif pola[i].strip() in ('eksport_ZUA', 'eksport_ZCNA'):
                inspola += "," + pola[i]
                inswart += "," + 'NULL'

            elif pola[i] == 'koszty_podwyzszone':

                wart = True if wartosci[i] == 'True' else False
                inspola += "," + "koszty_podwyzszone"
                inswart += "," + str(wart)

                wart = False if wartosci[i] == 'True' else True
                inspola += "," + "koszty_podstawowe"
                inswart += "," + str(wart)

            #AB 14.05.18r dodanie domylnie 'B' dla ulgi jeli nie jest uzupeniona
            elif pola[i] == 'ulga':
                inspola += "," + "ulga"
                if wartosci[i].strip("'") in ('B', 'P', 'S'):  #MK 2021-02-04
                    inswart += "," + str(wartosci[i])  #MK 2021-02-04
                else:
                    inswart += ",'B'"
            #AB 11.06.18r dodanie stay
            elif pola[i] not in('numer_id', 'eksport_ZUA', 'eksport_ZCNA', 'staz_ogolem', 'staz_do_urlopu',
#AB 2018-07-16 
                                'staz_do_zasilku', 'staz_do_nagrody', 'staz_do_dodatku'):
                inspola += ","+pola[i]
                inswart += ","+wartosci[i]

        INSERT = "INSERT INTO rs_kp_zatrudnienie ("+inspola+") VALUES ("+inswart+");"
        INSERT+= "INSERT INTO rs_kp_umowy_o_prace (firma_id, pracownik_id, zatrudnienie_id, umowa_id) "
        INSERT+= "VALUES('"+self.firma_id+"','"+Pracownik+"',"+str(Numer)+",1);"
        INSERT+= "INSERT INTO rs_kp_angaze (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
        INSERT+= "VALUES('"+self.firma_id+"','"+Pracownik+"',"+str(Numer)+",1,1);"
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat != 'OK':
            stat = 'Bd dodawania nowego zatrudnienia : '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_zatrudnienie SET "

    for i in xrange(len(pola)):
        # Jeden checkbox obsuguje dwa pola
        if pola[i] == 'koszty_podwyzszone':
            wart = True if wartosci[i] == 'True' else False
            UPDATE += "koszty_podwyzszone="+str(wart)+","

            wart = False if wartosci[i] == 'True' else True
            UPDATE += "koszty_podstawowe="+str(wart)+","

        elif pola[i] in ('dane_globalne','pit_11_8','pit_40','emerytalne','rentowe','chorobowe',
                                                            #AB 07.09.18r
                       'wypadkowe','zdrowotne','fp','fgsp', 'czy_absencje'):
            UPDATE+= pola[i]+"="+wartosci[i]+","

        #AB 2018-07-26
        elif pola[i].strip() in ('staz_ogolem', 'staz_do_urlopu', 'staz_do_zasilku',
                               'staz_do_nagrody', 'staz_do_dodatku'):
            #WS 2019-04-03
            if wartosci[i][1:-1] in ('    -  -  ', '', None):
            # if wart in ('    -  -  ', '', None):
                UPDATE += pola[i] + " = NULL,"
            else:
                dateString = wartosci[i][1:-1]
                #WS 2019-04-03
                # date = datetime.strptime(dateString, '%Y-%m-%d')
                if rsglobal.SprawdzCzyToData(dateString):
                    date = datetime.strptime(dateString, '%Y-%m-%d')
                    if date > datetime.now():
                        stat = 'DATA_STAZ_ZA_DUZA'
                    UPDATE += pola[i] + "=" + wartosci[i] + ","
                else:
                    stat = 'BL_DATA_STAZ'

        else:
            UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND numer_id = "+str(Numer)+";"
    if stat == 'OK':
        stat, d, dump, dump = self.PolSQL.Execute(UPDATE,1)
        if stat != 'OK':
            stat = 'Bd aktualizacji danych zatrudnienia : '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    StanPracownika  = ''
    ZrodloNaboru    = ''
    IloscUmow       = 0
    Ubezpieczenie   = ''
    Urzad           = ''
    #AB 30.03.21r
    WyrejZUS        = ''
    RozwStosPrac    = ''
    KodRozwStosPrac = ''
    OddzNFZ         = ''
    #WS 2021-04-26
    UbezpieczenieRSA= ''

    SELECT ="SELECT * FROM rs_kp_zatrudnienie"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND numer_id = "+str(Numer)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych zatrudnienia : '+stat
        dane.append(stat)

    if stat == 'OK':
        #pobranie ilosci umow o prace: brak umow pozwala edytowac calosc zatrudnienia
        #istniejace umowy pozwalaja tylko na ograniczona edycje
        sql ="SELECT umowa_id FROM rs_kp_umowy_o_prace"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND zatrudnienie_id = "+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o liczbie umw doczonych do zatrudnienia : '+stat
        else:
            IloscUmow = len(d)

    if stat == 'OK':
        for i in xrange(len(dane[0])):
            pole = wyn1[i][0]
            wart = str(dane[0][i])

            if pole == 'stan_pracownika_id' and not wart in ['','None']:
                if (self.oddzial_id,'011600') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_stany_pracownika WHERE kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        StanPracownika = 'Bd pobrania opisu ze sownika statusw pracownika : '+stat
                    else:
                        if len(d) > 0:
                            StanPracownika = str(d[0][0])
                else:
                    StanPracownika = 'Brak uprawnie do sownika. Poinformuj administratora.'
                        #AB 14.02.20r
            elif pole == 'zrodlo_naboru_id'  and not wart in ['','None']:
                if (self.oddzial_id,'011670') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_zrodla_naboru WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        ZrodloNaboru = 'Bd pobrania opisu ze sownika rde naboru : '+stat
                    else:
                        if len(d) > 0:
                            ZrodloNaboru = str(d[0][0])
                else:
                    ZrodloNaboru = 'Brak uprawnie do sownika. Poinformuj administratora.'
                    
            elif pole == 'ubezpieczenie_id' and not wart in ['','None']:
                if (self.oddzial_id,'011790') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_rodzaje_ubezpieczen WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        Ubezpieczenie = u'Bd pobrania opisu ze sownika ubezpiecze : '+stat
                    else:
                        if len(d) > 0:
                            Ubezpieczenie = str(d[0][0])
                else:
                    Ubezpieczenie = 'Brak uprawnie do sownika. Poinformuj administratora.'
            #WS 2021-04-26
            elif pole == 'ubezpieczenie_rsa' and not wart in ['','None']:
                if (self.oddzial_id,'011790') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_rodzaje_ubezpieczen WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        UbezpieczenieRSA = u'Bd pobrania opisu ze sownika ubezpiecze : '+stat
                    else:
                        if len(d) > 0:
                            UbezpieczenieRSA = str(d[0][0])
                else:
                    UbezpieczenieRSA = 'Brak uprawnie do sownika. Poinformuj administratora.'
            #AB 18.05.18r Dodanie opisu urzedu skarbowego
            elif pole == 'urzad_skarbowy_id' and wart not in ['', 'None']:
                if (self.oddzial_id, '011630') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_urzedy_skarbowe WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK' or len(d) == 0:
                        Urzad = u'Bd pobrania opisu ze sownika urzdw skarbowych : '+stat
                    else:
                        Urzad = str(d[0][0])
                else:
                    Urzad = 'Brak uprawnie do sownika. Poinformuj administratora.'
            #AB 30.03.21r Dodanie opisu przczyn wyrejestrowania, podstawy rozw. stos. prac. oraz kody rozw. stos. prac
            elif pole == 'przyczyna_wyrejestrowania_zus' and wart not in ['', 'None']:
                if (self.oddzial_id, '211530') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_kp_zus_kody_przyczyn_wyrejestrowania WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK' or len(d) == 0:
                        WyrejZUS = u'Bd pobrania opisu ze sownika : '+stat
                    else:
                        WyrejZUS = str(d[0][0])
                else:
                    WyrejZUS = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'podst_prawna_rozw_stos_pracy' and wart not in ['', 'None']:
                if (self.oddzial_id, '211520') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_kp_zus_kody_podstawy_rozwiazania_stos_pracy WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK' or len(d) == 0:
                        RozwStosPrac = u'Bd pobrania opisu ze sownika : '+stat
                    else:
                        RozwStosPrac = str(d[0][0])
                else:
                    RozwStosPrac = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'kod_rozw_stos_pracy' and wart not in ['', 'None']:
                if (self.oddzial_id, '211510') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_kp_zus_kody_rozwiazania_stosunku_pracy WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK' or len(d) == 0:
                        KodRozwStosPrac = u'Bd pobrania opisu ze sownika : '+stat
                    else:
                        KodRozwStosPrac = str(d[0][0])
                else:
                    KodRozwStosPrac = 'Brak uprawnie do sownika. Poinformuj administratora.'
            #AB 30.03.21r dodane brakujace pobieranie od razu opisu oddzialu nfz
            elif pole == 'oddzial_nfz_id' and wart not in ['', 'None']:
                if (self.oddzial_id, '211290') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_oddzialy_nfz WHERE kod = '"+wart+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK' or len(d) == 0:
                        OddzNFZ = u'Bd pobrania opisu ze sownika : '+stat
                    else:
                        OddzNFZ = str(d[0][0])
                else:
                    OddzNFZ = 'Brak uprawnie do sownika. Poinformuj administratora.'

        # JR 2023-05-20 (13422)
        sql = "SELECT pracownik FROM rs_kp_dane_osobowe "
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            CzyPracownik = False
        else:
            CzyPracownik = d[0][0]

    wyn2 = [StanPracownika, ZrodloNaboru, IloscUmow, Ubezpieczenie, UbezpieczenieRSA, Urzad, WyrejZUS, RozwStosPrac, KodRozwStosPrac,
            OddzNFZ, CzyPracownik]

#WS 2019-03-27
#-------------------------------------------------------------------------------
#--- POBRANIE DAT DO STAY DLA OSTATNIEGO ZATRUDNIENIA (6)
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    sql ="SELECT staz_do_dodatku, staz_ogolem, staz_do_urlopu, staz_do_zasilku, staz_do_nagrody FROM rs_kp_zatrudnienie"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    sql+=" AND COALESCE(staz_do_dodatku, staz_ogolem, staz_do_urlopu, staz_do_zasilku, staz_do_nagrody) IS NOT NULL"
    sql+=" ORDER BY numer_id DESC LIMIT 1;"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania dat do stay z ostatniego zatrudnienia : '+stat

