# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_zestawienia_placowe.py
# Purpose:     Edycja/usuwanie/pobieranie zestawie pacowych
# Author:      Wojciech Skowron
# Created:     2019/08/19
# RCS-ID:      $Id: fs_kp_zestawienia_placowe.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#WS 2019-10-07 Wojciech Skowron - (11675) Kolumna 'zmiana orientacji'
#JR 2019-10-26 Jan Raburski - (11718) Wydruk zestawien ze skladnikow
#JR 2021-12-21 Jan Raburski - (12713) Totalna przewalka w wydruku zestawien
#JR 2023-07-13 Jan Raburski - (13483) Kopiowanie zestawien placowych

import rsglobal

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych
7. Kopiowanie zestawienia
30. Wydruk zestawienia - pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprDel = (((self.oddzial_id,'063004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDod = (((self.oddzial_id,'063003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprMod = (((self.oddzial_id,'063002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDod
UprPrz = (((self.oddzial_id,'063001') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod or UprDod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

if stat == 'OK' and Funkcja == 7:
    Numer = rsglobal.Dekoduj(klucze['Numer'])
    StaryNumer = rsglobal.Dekoduj(klucze['StaryNumer'])


#-------------------------------------------------------------------------------
#-------- SPRAWDZENIE DANYCH DO INSERT/UPDATE
#-------------------------------------------------------------------------------

def SprawdzPole(self, pole, wart, nrWiersza, dane, wyn2):
    stat = 'OK'

    if pole == 'zestawienie_id':
        if wart.strip() == '':
            dane.append('BR ID')
            wyn2.append((nrWiersza,0))
        elif len(wart.strip()) > 4:
            dane.append('BL DL ID')
            wyn2.append((nrWiersza,0))

    elif pole == 'opis':
        if len(wart.strip()) > 30:
            dane.append('BL DL OPIS')
            wyn2.append((nrWiersza,1))

    elif pole == 'skladniki':
        if wart.strip() != "":
            nieprawidlowe = []

            skladniki = wart.split(",")
            for skladnik in skladniki:
                SEL = """SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE skladnik_id='{}' AND firma_id='{}';"""
                SEL = SEL.format(skladnik.strip(), self.firma_id)
                stat, d, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania skadnikw pacowych: '+stat
                    dane.append(stat)
                    wyn2.append((nrWiersza,2))
                else:
                    if len(d) == 0 and skladnik != '':
                        nieprawidlowe.append(skladnik)

            if len(nieprawidlowe) > 0:
                dane.append('Nieprawidowy skadnik: '+",".join(nieprawidlowe))
                wyn2.append((nrWiersza,2))

    elif pole == 'grupy':
        if wart.strip() != "":
            nieprawidlowe = []

            grupy = wart.split(",")
            for grupa in grupy:
                SEL = """SELECT kod FROM rs_grupy_pracownikow WHERE kod='{}' AND firma_id='{}';"""
                SEL = SEL.format(grupa.strip(), self.firma_id)
                stat, d, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania grup pracownikw: '+stat
                    dane.append(stat)
                    wyn2.append((nrWiersza,3))
                else:
                    if len(d) == 0 and grupa != '':
                        nieprawidlowe.append(grupa)

            if len(nieprawidlowe) > 0:
                dane.append('Nieprawidowa grupa: '+",".join(nieprawidlowe))
                wyn2.append((nrWiersza,3))

    elif pole == 'komorki':
        if wart.strip() != "":
            nieprawidlowe = []

            komorki = wart.split(",")
            for komorka in komorki:
                SEL = """SELECT kod FROM rs_komorki_zatrudniajace WHERE kod='{}' AND firma_id='{}';"""
                SEL = SEL.format(komorka.strip(), self.firma_id)
                stat, d, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania komrek zatrudniajcych: '+stat
                    dane.append(stat)
                    wyn2.append((nrWiersza,4))
                else:
                    if len(d) == 0 and komorka != '':
                        nieprawidlowe.append(komorka)

            if len(nieprawidlowe) > 0:
                dane.append('Nieprawidowa komrka: '+",".join(nieprawidlowe))
                wyn2.append((nrWiersza,4))

    elif pole == 'szablony':
        if wart.strip() != "":
            nieprawidlowe = []

            szablony = wart.split(",")
            for szablon in szablony:
                SEL = """SELECT lista_id FROM rs_kp_szablony_list_plac WHERE lista_id='{}' AND firma_id='{}';"""
                SEL = SEL.format(szablon.strip(), self.firma_id)
                stat, d, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania szablonw list pac: '+stat
                    dane.append(stat)
                    wyn2.append((nrWiersza,5))
                else:
                    if len(d) == 0 and szablon != '':
                        nieprawidlowe.append(szablon)

            if len(nieprawidlowe) > 0:
                dane.append('Nieprawidowy szablon: '+",".join(nieprawidlowe))
                wyn2.append((nrWiersza,5))

    return stat

#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat='BR UPR MOD'
            dane.append(stat)
        else:
            for pola, wartosci, nrWiersza in zip(Update[0], Update[1], Update[-1]):
                for pole, wart in zip(pola, wartosci):
                    stat = SprawdzPole(self, pole, wart, nrWiersza, dane, wyn2)

    if len(Insert[0]) > 0:
        if not UprDod:
            stat='BR UPR DOD'
            dane.append(stat)
        else:
            pola = Insert[1]

            for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
                for pole, wart in zip(pola, wartosci):
                    stat = SprawdzPole(self, pole, wart, nrWiersza, dane, wyn2)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Delete[0]) > 0:
    if not UprDel:
        stat = 'BR UPR DEL'
        dane.append(stat)
    else:
        DEL = ''
        pola = Delete[1]

        for wartosci in Delete[0]:
            DEL += """DELETE FROM rs_kp_zestawienia_placowe WHERE firma_id='{}'""".format(self.firma_id)
            for pole, wart in zip(pola, wartosci):
                DEL += " AND "+pole+"='"+wart+"'"

            DEL += ";"

        if stat == "OK" and DEL != '':
            rsglobal.ZapiszDoLogow(DEL)
            stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL),1,CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd przy usuwaniu danych: "+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Update[0]) > 0:
    UPD = ''

    for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
        UPD += "UPDATE rs_kp_zestawienia_placowe SET "
        for pole, wart in zip(pola, wartosci):
            if pole in ['zestawienie_id', 'opis', 'skladniki', 'grupy', 'komorki', 'szablony']:
                UPD += pole+"='"+str(wart).strip()+"',"
            elif pole in ['suma_grupa', 'suma_komorka', 'suma_szablon', 'suma_lista', 'zmiana_orientacji']:
                UPD += pole+"="+str(bool(wart))+","

        UPD = UPD.strip(",")
        UPD += " WHERE firma_id='"+self.firma_id+"'"

        for pole, wart in zip(Update[3], klucz): # petla po kluczu
            UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

        UPD += ";"
    if UPD != '':
        rsglobal.ZapiszDoLogow(UPD)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Insert[0]) > 0:
    INS = ''
    pola = Insert[1]

    for wartosci in Insert[0]:
        INSERT  = "INSERT INTO rs_kp_zestawienia_placowe "
        KOLUMNY = "(firma_id"
        VALUES  = " VALUES ('"+self.firma_id+"'"
        for pole, wart in zip(pola, wartosci):
            if pole in ['zestawienie_id', 'opis', 'skladniki', 'grupy', 'komorki', 'szablony']:
                KOLUMNY += ","+pole
                VALUES+=",'"+str(wart).strip()+"'"
            elif pole in ['suma_grupa', 'suma_komorka', 'suma_szablon', 'suma_lista', 'zmiana_orientacji']:
                KOLUMNY += ","+pole
                VALUES+=","+str(bool(wart))

        KOLUMNY+=")"
        VALUES+=");"
        INS += INSERT+KOLUMNY+VALUES
    if INS != '':
        rsglobal.ZapiszDoLogow(INS, 5)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy dodawaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   7 - KOPIOWANIE ZESTAWIENIA
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 7:
    if not UprDod:
        stat='BR UPR DOD'
        dane.append(stat)
    if stat == 'OK':
        if StaryNumer.strip() == '':
            stat = 'BR ID'
            dane.append('BR ID')
        elif len(StaryNumer.strip()) > 4:
            stat = 'BL DL ID'
            dane.append('BL DL ID')
    if stat == 'OK':
        if Numer.strip() == '':
            stat = 'BR ID'
            dane.append('BR ID')
        elif len(Numer.strip()) > 4:
            stat = 'BL DL ID'
            dane.append('BL DL ID')

    if stat == 'OK':
        SQL = "SELECT zestawienie_id FROM rs_kp_zestawienia_placowe WHERE firma_id = '" + self.firma_id + "' AND zestawienie_id = '" + Numer + "';"
        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat == 'OK':
            if len(d) > 0:
                stat = 'Symbol jest ju uywany'
            else:
                SQL = "SELECT zestawienie_id FROM rs_kp_zestawienia_placowe WHERE firma_id = '" + self.firma_id + "' AND zestawienie_id = '" + StaryNumer + "';"
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat == 'OK':
                    if len(d) == 0:
                        stat = 'Bdny sybol zestawienia'

    if stat == 'OK':
        INS = "INSERT INTO rs_kp_zestawienia_placowe (firma_id,zestawienie_id,opis,skladniki,grupy,komorki,szablony,suma_grupa,suma_komorka,suma_szablon,suma_lista, zmiana_orientacji)"
        INS += " SELECT firma_id,'"+Numer+"',opis,skladniki,grupy,komorki,szablony,suma_grupa,suma_komorka,suma_szablon,suma_lista, zmiana_orientacji"
        INS += " FROM rs_kp_zestawienia_placowe WHERE firma_id='" + self.firma_id + "' AND zestawienie_id='" + StaryNumer + "';"
        stat, d, wyn1, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd dodawania nagwka: ' + stat
        if stat == 'OK':
            INS = "INSERT INTO rs_kp_zestawienia_placowe_kolumny (firma_id,zestawienie_id,lp,nagl1,nagl2,warunek_case)"
            INS += " SELECT firma_id, '" + Numer + "',lp,nagl1,nagl2,warunek_case"
            INS += " FROM rs_kp_zestawienia_placowe_kolumny WHERE firma_id='" + self.firma_id + "' AND zestawienie_id='" + StaryNumer + "';"
            stat, d, wyn1, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd dodawania kolumn: ' + stat

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrz:
        stat='BR UPR PRZ'
        dane.append(stat)
    else:
        SEL = """SELECT zestawienie_id,opis,skladniki,grupy,komorki,szablony,suma_grupa,suma_komorka,suma_szablon,suma_lista,zmiana_orientacji 
                   FROM rs_kp_zestawienia_placowe WHERE firma_id='{} ' 
               ORDER BY zestawienie_id;""".format(self.firma_id)
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
        else:
            for d in dane:
                d[0] = d[0].strip()


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH DO WYDRUKU ZESTAWIENIA
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 30:
    IdZestawienia = klucze['ID']
    ListyOd = klucze['DataListOd']
    ListyDo = klucze['DataListDo']
    WyplatyOd = klucze['DataWyplatOd']
    WyplatyDo = klucze['DataWyplatDo']
    if not rsglobal.SprawdzCzyToData(ListyOd) and ListyOd != '    -  -  ':
        stat = "Niepoprawna data list od "
        dane.append(stat)
    if not rsglobal.SprawdzCzyToData(ListyDo) and ListyDo != '    -  -  ':
        stat = "Niepoprawna data list do "
        dane.append(stat)
    if not rsglobal.SprawdzCzyToData(WyplatyOd) and WyplatyOd != '    -  -  ':
        stat = "Niepoprawna data wypat od "
        dane.append(stat)
    if not rsglobal.SprawdzCzyToData(WyplatyDo) and WyplatyDo != '    -  -  ':
        stat = "Niepoprawna data wypat do "
        dane.append(stat)

    if stat == 'OK':
        SQL = "SELECT lp, nagl1, nagl2, warunek_case"
        SQL += " FROM rs_kp_zestawienia_placowe_kolumny WHERE firma_id='" + self.firma_id + "' AND zestawienie_id='"+IdZestawienia+"'"
        SQL += " ORDER BY lp"
        stat, lkolumny, wyn1, wyn2 = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu definicji kolumn zestawienia: "+stat
        dane.append(stat)
    if stat == 'OK':
        SQL = "SELECT zestawienie_id,opis,TRIM(COALESCE(skladniki,'')),TRIM(COALESCE(grupy,'')),TRIM(COALESCE(komorki)),TRIM(COALESCE(szablony)),"
        SQL += " suma_grupa,suma_komorka,suma_szablon,zmiana_orientacji, suma_lista"
        SQL += " FROM rs_kp_zestawienia_placowe WHERE firma_id='" + self.firma_id + "' AND zestawienie_id='"+IdZestawienia+"'"
        stat,definicja,wyn1,wyn2 = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu definicji zestawienia: "+stat
        dane.append(stat)
    if stat == 'OK':
        skladniki = rsglobal.Dekoduj(str(definicja[0][2])).replace('[', '').replace(']', '')
        grupy = rsglobal.Dekoduj(str(definicja[0][3])).replace('[', '').replace(']', '')
        komorki = rsglobal.Dekoduj(str(definicja[0][4])).replace('[', '').replace(']', '')
        szablony = rsglobal.Dekoduj(str(definicja[0][5])).replace('[', '').replace(']', '')
        sumagrupa = definicja[0][6]
        sumakomorka = definicja[0][7]
        sumaszablon = definicja[0][8]
        zmianaorientacji = definicja[0][9]
        sumalista = definicja[0][10]
        #--- kolumny selecta
        if len(lkolumny) == 0:
            SQL = "SELECT lpos.skladnik_id, skp.skrot, SUM(lpos.wartosc) "
            if (not sumagrupa) and (not sumakomorka) and (not sumaszablon) and (not sumalista):
                SQL += ",lpos.pracownik_id, TRIM(dos.nazwisko) || ' ' || TRIM(dos.imie)"
            elif sumagrupa:
                SQL += ",ang.grupa_pracownikow_id, TRIM(grp.opis)"
            elif sumakomorka:
                SQL += ",ang.komorka_id, TRIM(koz.opis)"
            elif sumaszablon:
                SQL += ",lp.lista_id,TRIM(szab.opis)"
            elif sumalista:
                SQL += ",TRIM(lp.numer_listy_id), lpos.pracownik_id || ' ' || TRIM(dos.nazwisko) || ' ' || TRIM(dos.imie)"
        else:  # wprost zdefiniowane kolumny
            SQL = "SELECT lpos.skladnik_id, skp.skrot"
            for w in lkolumny:
                SQL += ", SUM(CASE WHEN " + w[3].strip() + " THEN lpos.wartosc ELSE 0 END)"
        #--- joiny w zaleznosci
        SQL += " FROM rs_kp_listy_plac_osoby_skladniki lpos"
        SQL += " INNER JOIN rs_kp_listy_plac lp USING(firma_id,numer_listy_id)"
        SQL += " INNER JOIN rs_kp_skladniki_placowe skp USING(firma_id,skladnik_id)"
        SQL += " INNER JOIN rs_kp_angaze ang USING(firma_id,pracownik_id,zatrudnienie_id,umowa_id,angaz_id)"
        #if not sumagrupa and not sumakomorka and not sumaszablon and not sumalista:
        SQL += " INNER JOIN rs_kp_dane_osobowe dos USING(firma_id,pracownik_id)"
        #elif sumagrupa:
        SQL += " INNER JOIN rs_grupy_pracownikow grp ON (lpos.firma_id=grp.firma_id AND ang.grupa_pracownikow_id=grp.kod)"
        #elif sumakomorka:
        SQL += " INNER JOIN rs_komorki_zatrudniajace koz ON (lpos.firma_id=koz.firma_id AND ang.komorka_id=koz.kod)"
        #elif sumaszablon:
        SQL += " INNER JOIN rs_kp_szablony_list_plac szab ON (lpos.firma_id=szab.firma_id AND lp.lista_id=szab.lista_id)"
        SQL += " INNER JOIN rs_kp_zatrudnienie zatr ON (lpos.firma_id=zatr.firma_id AND lpos.pracownik_id=zatr.pracownik_id AND lpos.zatrudnienie_id=zatr.numer_id)"
        #elif sumalista:
        #SQL += " INNER JOIN rs_kp_dane_osobowe dos USING(firma_id,pracownik_id)"
        #--- klauzula WHERE
        SQL += " WHERE lpos.firma_id='" + self.firma_id + "'"
        if rsglobal.SprawdzCzyToData(ListyOd):
            SQL += " AND lp.data_od>='" + ListyOd + "'"
        if rsglobal.SprawdzCzyToData(ListyDo):
            SQL += " AND lp.data_do<='" + ListyDo + "'"
        if rsglobal.SprawdzCzyToData(WyplatyOd):
            SQL += " AND lp.data_wyplaty>='" + WyplatyOd + "'"
        if rsglobal.SprawdzCzyToData(WyplatyDo):
            SQL += " AND lp.data_wyplaty<='" + WyplatyDo + "'"
        if skladniki not in ['', 'None']:
            l = skladniki.split(',')
            skladniki = ''
            for w in l:
                skladniki += "'" + w + "',"
            skladniki = skladniki[:-1]
            SQL += " AND TRIM(lpos.skladnik_id) IN (" + str(skladniki) + ") "
        if grupy not in ['', 'None']:
            l = grupy.split(',')
            grupy = ''
            for w in l:
                grupy += "'" + w + "',"
            grupy = grupy[:-1]
            SQL += " AND TRIM(ang.grupa_pracownikow_id) IN (" + str(grupy) + ") "
        if komorki not in ['', 'None']:
            l = komorki.split(',')
            komorki = ''
            for w in l:
                komorki += "'" + w + "',"
            komorki = komorki[:-1]
            SQL += " AND TRIM(ang.komorka_id) IN (" + str(komorki) + ") "
        if szablony not in ['', 'None']:
            l = szablony.split(',')
            szablony = ''
            for w in l:
                szablony += "'" + w + "',"
            szablony = szablony[:-1]
            SQL += " AND TRIM(lp.lista_id) IN (" + str(szablony) + ") "
        #--- grupowanie
        SQL += " GROUP BY lpos.skladnik_id, skp.skrot "
        if len(lkolumny) == 0:
            if not sumagrupa and not sumakomorka and not sumaszablon and not sumalista:
                SQL += ",lpos.pracownik_id, TRIM(dos.nazwisko) || ' ' || TRIM(dos.imie)"
            elif sumagrupa:
                SQL += ",ang.grupa_pracownikow_id, TRIM(grp.opis)"
            elif sumakomorka:
                SQL += ",ang.komorka_id, TRIM(koz.opis)"
            elif sumaszablon:
                SQL += ",lp.lista_id,TRIM(szab.opis)"
            elif sumalista:
                SQL += ",lp.numer_listy_id, lpos.pracownik_id || ' ' || TRIM(dos.nazwisko) || ' ' || TRIM(dos.imie)"
        rsglobal.ZapiszDoLogow('zestawienie:'+SQL,5)
        rsglobal.ZapiszDoLogow('grupy:'+grupy+'|',5)
        stat, sumy, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych zestawienia: " + stat
            dane.append(stat)
        else:
            dane = [definicja, sumy, lkolumny]
            rsglobal.ZapiszDoLogow('zestawienie dane:'+SQL,5)
