# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_zestawienia_placowe_kolumny.py
# Purpose:     Edycja/usuwanie/pobieranie zestawie pacowych
# Author:      Bartosz Pagan
# Created:     2022/01/12
# RCS-ID:      $Id: fs_kp_zestawienia_placowe_kolumny.py $
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2022-04-07 Wojciech Skowron - (12811) Podmiana '/` na ''

import rsglobal

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'zestawienie_id': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK' and Funkcja in (1, 5):
    zestawienie_id = klucze['zestawienie_id']

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprDel = (((self.oddzial_id,'063004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDod = (((self.oddzial_id,'063003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprMod = (((self.oddzial_id,'063002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDod
UprPrz = (((self.oddzial_id,'063001') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod or UprDod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']


#-------------------------------------------------------------------------------
#-------- SPRAWDZENIE DANYCH DO INSERT/UPDATE/DELETE
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat='BR UPR MOD'
            dane.append(stat)

    if len(Insert[0]) > 0:
        if not UprDod:
            stat='BR UPR DOD'
            dane.append(stat)

    if len(Delete[0]) > 0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Delete[0]) > 0:
    rsglobal.ZapiszDoLogow(Delete)

    # wykonanie DELETE
    if stat == 'OK':
        DELETE = ''
        pola = Delete[1]


        for wartosci in Delete[0]:

            DELETE+="DELETE FROM rs_kp_zestawienia_placowe_kolumny"
            DELETE+=" WHERE firma_id='"+self.firma_id+"' AND zestawienie_id='"+str(zestawienie_id)+"'"
            for pole, wart in zip(pola, wartosci):
                DELETE += " AND "+pole+"='"+str(wart)+"'"
            DELETE += ";"

        if stat == "OK" and DELETE != '':

            stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd usuwania rozliczenia: '+stat
                dane.append(stat)
#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Update[0]) > 0:
    UPD = ''

    for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
        UPD += "UPDATE rs_kp_zestawienia_placowe_kolumny SET "
        for pole, wart in zip(pola, wartosci):
            if pole in ['lp', 'nagl1', 'nagl2', 'warunek_case']:
                if isinstance(wart, basestring):
                    wart = wart.replace("`", "'").replace("'", "''")  #WS 2022-04-07
                UPD += pole+"='"+str(wart).strip()+"',"

        UPD = UPD.strip(",")
        UPD += " WHERE firma_id='{}' AND zestawienie_id = '{}'".format(self.firma_id, zestawienie_id)

        for pole, wart in zip(Update[3], klucz): # petla po kluczu
            UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

        UPD += ";"
    if UPD != '':
        rsglobal.ZapiszDoLogow(UPD)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Insert[0]) > 0:
    INS = ''
    pola = Insert[1]

    for wartosci in Insert[0]:
        INSERT  = "INSERT INTO rs_kp_zestawienia_placowe_kolumny "
        KOLUMNY = "(firma_id, zestawienie_id"
        VALUES  = " VALUES ('"+self.firma_id+"','"+zestawienie_id+"'"
        for pole, wart in zip(pola, wartosci):
            if pole in ['lp', 'nagl1', 'nagl2', 'warunek_case']:
                if isinstance(wart, basestring):
                    wart = wart.replace("`", "'").replace("'", "''")  #WS 2022-04-07
                KOLUMNY += ","+pole
                VALUES+=",'"+str(wart).strip()+"'"

        KOLUMNY+=")"
        VALUES+=");"
        INS += INSERT+KOLUMNY+VALUES
    if INS != '':
        rsglobal.ZapiszDoLogow(INS, 5)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy dodawaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrz:
        stat='BR UPR PRZ'
        dane.append(stat)
    else:
        SEL = """SELECT lp::INT, nagl1, nagl2, warunek_case 
                   FROM rs_kp_zestawienia_placowe_kolumny WHERE firma_id='{}' AND zestawienie_id = '{}'
               ORDER BY lp;""".format(self.firma_id, zestawienie_id)  #TODO
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
