# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_zmienne_placowe_pom.py
# Purpose:     grid z badaniami pracownika
# Author:      Konrad Opieka
# Created:     2015/10/18
# RCS-ID:      $Id: fs_kp_zmienne_placowe_pom.py
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# Jan Raburski 2018 i 2019 - dodawanie zmiennych potrzebnch do obliczen list plac
# Aleksander Bargie 2020-10-01 - (12150) rs_kp_szablony_dokumentow_pola - zmieni
# Wojciech Skowron   2021-02-09 - (12317) podmiana polskich znakw w polu ko.typdok,
#                                         zmiana na LEFT OUTER JOIN w zapytaniu na dane osobowe
# Wojciech Skowron   2021-05-04 - (12469) nowe zmienne
# 2023-08-28 Jan Raburski (13512) - przejcie w dniach roboczych na kalendarz

import time
import rsglobal
import rs_anakonda_daty

#-------------------------------------------------------------------------------

#Funkcja ma za zanadnie zmieni w tekcie przychodzcym pod parametrem 'Tresc' 
#zmienne podane w sposb $$....$$. W przypadku, gdy wiemy, e ktra zmienna moe 
#zawiera polskie znaki uywamy funkcji Podmiana

def Podmiana(wyrazenie):
    wyrazenie = wyrazenie.replace('','&#261;')
    wyrazenie = wyrazenie.replace('','&#263;')
    wyrazenie = wyrazenie.replace('','&#281;')
    wyrazenie = wyrazenie.replace('','&#322;')
    wyrazenie = wyrazenie.replace('','&#324;')
    wyrazenie = wyrazenie.replace('','&#243;')
    wyrazenie = wyrazenie.replace('','&#347;')
    wyrazenie = wyrazenie.replace('','&#378;')
    wyrazenie = wyrazenie.replace('','&#380;')
    wyrazenie = wyrazenie.replace('','&#260;')
    wyrazenie = wyrazenie.replace('','&#262;')
    wyrazenie = wyrazenie.replace('','&#280;')
    wyrazenie = wyrazenie.replace('','&#321;')
    wyrazenie = wyrazenie.replace('','&#323;')
    wyrazenie = wyrazenie.replace('','&#211;')
    wyrazenie = wyrazenie.replace('','&#346;')
    wyrazenie = wyrazenie.replace('','&#377;')
    wyrazenie = wyrazenie.replace('','&#379;')
    return wyrazenie

#-------------------------------------------------------------------------------

#Funkcja ma za zanadnie zmieni float w tekst z okrelon liczb miejsc po przecinku

def rsstr(wartosc, liczba_miejsc = 2):
    tekst = str(wartosc)
    gdzie = tekst.find('.')
    if gdzie < 0:
        return tekst
    ile = len(tekst) - gdzie - 1
    if ile == 1:
        tekst += '0'
    return tekst


#-------------------------------------------------------------------------------
#---   Pobranie danych do wydruku i podmiana ich w tekcie
#-------------------------------------------------------------------------------

def PodmienNule(Lista):
    for i,x in enumerate(Lista):
        for j,y in enumerate(x):
            if y == None:
                Lista[i][j]=''
            elif str(type(y)) not in ["<type 'bool'>", "<type 'int'>", "<type 'float'>"]:
                Lista[i][j]=y.strip().replace('Null','').replace('','').replace('None','')
    return Lista


def PodmienDanymi(self,Tresc,Pracownik,Zatrudnienie,Umowa,Angaz,ListaPlac='',TylkoPodajWartosci = False,Absencja=[],CzlonekRodziny=0):
    # wywolanie z obslugi absencji ma zatrudnienie, umowe i angaz=0
    # zeby nie zaburzac pobierania brane jest zatrudnienie gdzie czy_absencje=True i pomijane umowa i angaz
    # Absencja lista [TypAbsencji,DataOd,DataDo]
    SWartosci = {}
    PESEL = ''
    Szablon = ''
    DataListyOd = ''
    DataListyDo = ''
    DataWypl = ''
    FP = False
    FGSP = False
    UbEmer = False
    UbRent = False
    UbWypadk = False
    UbZdrow = False
    PIT11_8 = False
    PIT40 = False
    DataZUSOd = ''
    DataZUSDo = ''
    UlgaZatr = 'B' # Brak ulgi
    KosztyPodwZatr = False
    CzyKartyPracy = True

    SQL ="SELECT TRIM(pole_id) FROM rs_kp_szablony_dokumentow_pola"
    stat,LParametry,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd przy pobieraniu danych dotyczcych pl'+stat
    LParametry=PodmienNule(LParametry)

    # Oddzial centrala
    SQL ="SELECT nazwa, nip, regon,adr_kod, adr_miej,adr_ulica,adr_nry FROM rs_oddzialy WHERE centrala AND firma_id='"+self.firma_id+"';"
    stat,LOdz01,dump,dump = self.PolSQL.Execute(SQL,3)
    LOdz01=PodmienNule(LOdz01)

    # Dane osobowe
    SQL ="SELECT nazwisko, imie, imie_drugie, data_urodzenia, imie_ojca, imie_matki, " #0-5
    #AB 01.10.20r
    SQL+="rodowe, narodowosc, rk.nazwa AS obywatelstwo, pesel, nip, COALESCE(akcjonariusz,FALSE), " # 6-11
    SQL+="rdtt.opis AS typ_dokumentu, dokument_nr, dokument_data_waznosci, miejsce_urodzenia, nie_rezydent "  # 12-16
    SQL+="FROM rs_kp_dane_osobowe rkdo "
    SQL+="LEFT OUTER JOIN rs_kraje rk ON rkdo.obywatelstwo_kraj=rk.kraj "  #WS 2021-02-09 - LEFT OUTER
    SQL+="LEFT OUTER JOIN rs_dokumenty_tozsamosci_typy rdtt ON rkdo.dokument_id=rdtt.kod "  #WS 2021-02-09 - LEFT OUTER
    SQL+="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    stat,LOsobowe,dump,dump = self.PolSQL.Execute(SQL,3)
    LOsobowe=PodmienNule(LOsobowe)
    
    # Adres zameldowania
    SQL ="SELECT kod_pocztowy, miejscowosc, ulica, nr_domu, nr_mieszkania, poczta, telefon, email " #0-7
    SQL+="FROM rs_kp_adresy WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='1';"
    stat,LZamel,dump,dump = self.PolSQL.Execute(SQL,3)
    LZamel = PodmienNule(LZamel)
    if len(LZamel) == 0:
        LZamel = [['', '', '', '', '', '', '', '']]
    
    # Adres zamieszkania
    SQL ="SELECT kod_pocztowy, miejscowosc, ulica, nr_domu, nr_mieszkania, poczta, telefon, email " #0-7
    SQL+="FROM rs_kp_adresy WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='2';"
    stat,LZamie,dump,dump = self.PolSQL.Execute(SQL,3)
    LZamie=PodmienNule(LZamie)
    if len(LZamie) == 0:
        LZamie = [['', '', '', '', '', '', '', '']]

    # Adres korespondencyjny
    SQL ="SELECT kod_pocztowy, miejscowosc, ulica, nr_domu, nr_mieszkania, poczta, telefon, email " #0-7
    SQL+="FROM rs_kp_adresy WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='3';"
    stat,LKores,dump,dump = self.PolSQL.Execute(SQL,3)
    LKores=PodmienNule(LKores)
    if len(LKores) == 0:
        LKores = [['', '', '', '', '', '', '', '']]

    # Adres Pit
    SQL ="SELECT kod_pocztowy, miejscowosc, ulica, nr_domu, nr_mieszkania, poczta, telefon, email " #0-7
    SQL+="FROM rs_kp_adresy WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='4';"
    stat,LPit,dump,dump = self.PolSQL.Execute(SQL,3)
    LPit=PodmienNule(LPit)
    if len(LPit) == 0:
        LPit = [['', '', '', '', '', '', '', '']]

    # Zatrudnienie
    SQL ="SELECT fp,fgsp, pit_11_8, pit_40, ulga, koszty_podwyzszone, emerytalne, rentowe, chorobowe, zdrowotne," #0-9
    SQL+="stan_pracownika_id, start_rok_urlop,urlop_wykorzystany, urlop_zalegly, start_rok_zwolnienie, choroba_wykorzystana, glowne_miejsce_pracy," # 10-16
    SQL+="zrodlo_naboru_id,zwolnienie_id,COALESCE(zwolnienie_data::TEXT,''),ubezpieczenie_id,urzad_skarbowy_id,oddzial_nfz_id,dane_globalne," # 17-23
    SQL+=" COALESCE(eksport_zua::TEXT,''),COALESCE(eksport_zcna::TEXT,''), koszty_podstawowe, wypadkowe, COALESCE(staz_do_dodatku::TEXT,'')," # 24-28
    SQL+=" COALESCE(staz_ogolem::TEXT,''),COALESCE(staz_do_urlopu::TEXT,''),COALESCE(staz_do_zasilku::TEXT,''),COALESCE(staz_do_nagrody::TEXT,'')," # 29-32
    #WS 2021-05-04
    SQL+=" COALESCE(onfz.opis,''),COALESCE(ru.opis,''),COALESCE(us.opis,''),COALESCE(sp.opis,'') " # 33-36
    SQL+=" FROM rs_kp_zatrudnienie z"
    SQL+=" LEFT OUTER JOIN rs_oddzialy_nfz onfz ON (z.oddzial_nfz_id=onfz.kod) "  #WS 2021-05-04
    SQL+=" LEFT OUTER JOIN rs_rodzaje_ubezpieczen ru ON (z.firma_id=ru.firma_id AND z.ubezpieczenie_id=ru.kod) "  #WS 2021-05-04
    SQL+=" LEFT OUTER JOIN rs_urzedy_skarbowe us ON (z.firma_id=us.firma_id AND z.urzad_skarbowy_id=us.kod) "  #WS 2021-05-04
    SQL+=" LEFT OUTER JOIN rs_stany_pracownika sp ON (z.stan_pracownika_id=sp.kod) "  #WS 2021-05-04
    SQL+=" WHERE z.firma_id='"+self.firma_id+"' "
    if Zatrudnienie > 0:
        SQL+="AND pracownik_id='"+Pracownik+"' AND numer_id="+str(Zatrudnienie)+";"
    else:
        SQL+="AND pracownik_id='"+Pracownik+"' AND czy_absencje;"
    rsglobal.ZapiszDoLogow("LZatrudnienie:" + SQL, 1)
    stat,LZatrudnienie,dump,dump = self.PolSQL.Execute(SQL,3)
    LZatrudnienie=PodmienNule(LZatrudnienie)

    # Umowa o prace
    if Umowa > '0':
        SQL ="SELECT umowa_id, data_zawarcia, od_kiedy, do_kiedy, COALESCE(od_kiedy_zus::TEXT,''),COALESCE(do_kiedy_zus::TEXT,''), " #0-5
        SQL+="COALESCE(rodzaj_umowy_id,''), start_rok_urlop, COALESCE(typ_pracownika_id,''), " # 6-8
        #WS 2021-05-04
        SQL+="COALESCE(ur.opis,''),COALESCE(tp.opis,'')" # 9-10
        SQL+=" FROM rs_kp_umowy_o_prace uop "
        SQL+=" LEFT OUTER JOIN rs_umowy_rodzaj ur ON (uop.firma_id=ur.firma_id AND uop.rodzaj_umowy_id=ur.kod) "  #WS 2021-05-04
        SQL+=" LEFT OUTER JOIN rs_typy_pracownikow tp ON (uop.firma_id=tp.firma_id AND uop.typ_pracownika_id=tp.kod) "  #WS 2021-05-04
        SQL+=" WHERE uop.firma_id='"+self.firma_id+"' "
        SQL+=" AND pracownik_id='"+Pracownik+"' AND zatrudnienie_id='"+Zatrudnienie+"' AND umowa_id='"+Umowa+"';"
        stat,LUmowy,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(LUmowy)>0:
            LUmowy=PodmienNule(LUmowy)
            # Umowa o prace - od kiedy zus (ze starych umow)
            SQL ="SELECT MAX(COALESCE(od_kiedy_zus::TEXT,'')),MAX(COALESCE(do_kiedy_zus::TEXT,'')) " #0-1
            SQL+=" FROM rs_kp_umowy_o_prace WHERE firma_id='"+self.firma_id+"' "
            SQL+=" AND pracownik_id='"+Pracownik+"' AND zatrudnienie_id='"+Zatrudnienie+"';"
            stat,pomzus,dump,dump = self.PolSQL.Execute(SQL,3)
            pomzus=PodmienNule(pomzus)
            LUmowy[0][4]=pomzus[0][0]
            if pomzus[0][0] < pomzus[0][1]: #wstawiamy date wyrejestrowania jesli jest wieksza od ostatniej daty zarejestrowania
                LUmowy[0][5]=pomzus[0][1]
            LUmowy=PodmienNule(LUmowy)
    else:
        LUmowy=[]

    # Anga
    if Angaz > '0':
        SQL = "SELECT COALESCE(od_kiedy::TEXT,''), COALESCE(do_kiedy::TEXT,''), a.miejsce_id,mp.opis, a.komorka_id,kz.opis, " #0-5
        SQL += "a.grupa_pracownikow_id,gp.opis, a.stanowisko_id,sp.opis, etat, " #6-10
        SQL += "grupa_zaszeregowania, placa, stawka, dodatek_fun, ryczalt, " #11-15
    #    SQL+="a.rodzaj_pracownika_id, a.typ_pracownika_id, a.zawod_wykonywany_id, a.stanowisko_kosztow_id,a.kategoria_zaszeregowania," #16-20
        SQL += "a.rodzaj_pracownika_id, '1', a.zawod_wykonywany_id, a.stanowisko_kosztow_id,a.kategoria_zaszeregowania," #16-20
        SQL += "a.dodatek1, a.dodatek2, a.kalendarz_id, a.stanowisko_miejsce_id,a.lista_id, a.komorka_id, a.zerowy_pit," # 21-27
        #WS 2021-05-04
        SQL += "COALESCE(rp.opis,''),COALESCE(spm.opis,''),COALESCE(zsk.opis,''),"  # 28-30
        SQL += "ulga_kl_sr, ulga_rodz_plus, ulga_na_powrot, ulga_dla_emeryta,"  # 31-34
        SQL += "rsf_slownie(placa), rsf_slownie(stawka), rsf_slownie(dodatek_fun)"  # 35-37
        SQL += " FROM rs_kp_angaze a "
        SQL += " LEFT OUTER JOIN rs_miejsca_pracy mp ON (a.firma_id=mp.firma_id AND a.miejsce_id=mp.kod) "
        SQL += " LEFT OUTER JOIN rs_komorki_zatrudniajace kz ON (a.firma_id=kz.firma_id AND a.komorka_id=kz.kod) "
        SQL += " LEFT OUTER JOIN rs_grupy_pracownikow gp ON (a.firma_id=gp.firma_id AND a.grupa_pracownikow_id=gp.kod) "
        SQL += " LEFT OUTER JOIN rs_stanowiska_pracy sp ON (a.firma_id=sp.firma_id AND a.stanowisko_id=sp.kod) "
        SQL += " LEFT OUTER JOIN rs_rodzaje_pracownikow rp ON (a.firma_id=rp.firma_id AND a.rodzaj_pracownika_id=rp.kod) "  #WS 2021-05-04
        SQL += " LEFT OUTER JOIN rs_kp_stanowiska_pracy_miejsca spm ON (a.firma_id=spm.firma_id AND a.stanowisko_miejsce_id=spm.kod) "  #WS 2021-05-04
        SQL += " LEFT OUTER JOIN rs_zawody_specjalnosci_klasyfikacja zsk ON (a.firma_id=zsk.firma_id AND a.zawod_wykonywany_id=zsk.kod) "  #WS 2021-05-04
        SQL += " WHERE a.firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
        SQL += " AND zatrudnienie_id='"+Zatrudnienie+"' AND umowa_id='"+Umowa+"' AND angaz_id='"+Angaz+"';"
        stat,LAngaze,dump,dump = self.PolSQL.Execute(SQL,3)
        LAngaze=PodmienNule(LAngaze)
    else:
        LAngaze=[]

    # Lista pac
    if ListaPlac != '':
        SQL = "SELECT data_od,data_do,data_wyplaty,lista_id,numer_listy_id, COALESCE(grupa_pracownikow,''), " # 0-5
        SQL+=" do_deklaracji_zus_z_data_wyplaty, do_deklaracji_pit_z_data_wyplaty, COALESCE(konto_id,'') " # 6-8
        SQL+=" FROM rs_kp_listy_plac "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id='"+ListaPlac+"';"
        stat,LListaPlac,dump,dump = self.PolSQL.Execute(SQL,3)
        LListaPlac=PodmienNule(LListaPlac)
        if stat == 'OK':
            SQL = "SELECT czy_karty_pracy "
            SQL+=" FROM rs_kp_listy_plac lp INNER JOIN rs_kp_szablony_list_plac USING (firma_id, lista_id)"
            SQL+=" WHERE lp.firma_id='"+self.firma_id+"' AND numer_listy_id='"+ListaPlac+"';"
            stat,LCzyKartyPracy,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat == 'OK':
                if len(LCzyKartyPracy) > 0:
                    CzyKartyPracy = LCzyKartyPracy[0][0]
        LListaPlac=PodmienNule(LListaPlac)
        # sumy zmiennych dla wszystkich pracownikow z listy
        # daty od do porownywane z angazu i z listy plac
        DataFiltraOd = LListaPlac[0][0]
        if LAngaze[0][0] > DataFiltraOd:
            DataFiltraOd = LAngaze[0][0]
        DataFiltraDo = LListaPlac[0][1]
        if LAngaze[0][1] != '':
            if LAngaze[0][1] < DataFiltraDo:
                DataFiltraDo = LAngaze[0][1]

        if stat == 'OK' and CzyKartyPracy:
            #SQL = "SELECT ROUND(SUM(a.placa + ROUND(a.stawka * 168 * a.etat,2)),2) FROM rs_kp_angaze a "
            #SQL+=" INNER JOIN rs_kp_listy_plac_osoby lp USING (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
            #SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND numer_listy_id='"+ListaPlac+"';"
            SQL =  "SELECT ROUND(SUM(COALESCE(a.placa,0) + ROUND(COALESCE(a.stawka,0) * 168 * COALESCE(a.etat,1),2)),2),  "
            SQL += " ROUND(SUM(COALESCE(a.placa,0) * (kp.godz_normalne+kp.godz_nadliczbowe_100) / a.etat * 0.01),2), "
            SQL += " ROUND(SUM(COALESCE(a.placa,0) * (kp.godz_krotkich_zwoln) / a.etat * 0.01),2) "
            SQL += " FROM rs_kp_listy_plac_osoby lp "
            SQL += " INNER JOIN rs_kp_angaze a USING (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
            SQL += " INNER JOIN rs_kp_angaze_karty_pracy kp USING (firma_id, pracownik_id, zatrudnienie_id,umowa_id,angaz_id) "
            SQL += " WHERE a.firma_id='"+self.firma_id+"' AND numer_listy_id='"+ListaPlac+"'"
            SQL += " AND kp.rok = '" + LListaPlac[0][0][:4] + "' AND kp.mc = '" + LListaPlac[0][0][5:7] + "'"
            rsglobal.ZapiszDoLogow("LSumaPodstaw:"+SQL, 1)
            stat,LSumaPodstaw,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                return 'Ktry z pracownikw listy ma w angau etat = 0',''
        if stat == 'OK' and CzyKartyPracy:
            SQL = "SELECT lp.pracownik_id, COALESCE(an.dodatek_fun,0) * (1 - ("
            SQL += " SUM(CASE WHEN (typ_absencji_id IN ('6A','6B','6S','6T','7','8','9','O','R')"
            #SQL += " OR (kod_zus='311' and typ_absencji_id IN ('8','O','R')) OR (kod_zus='312' and typ_absencji_id='8') OR (kod_zus='321' AND typ_absencji_id='9') )"
            #SQL += " AND a.od_kiedy>=lp.data_od AND a.do_kiedy<=lp.data_do )"
            SQL += " AND a.od_kiedy>='"+DataFiltraOd+"' AND a.do_kiedy<='"+DataFiltraDo+"' )"
            SQL += " THEN dni_kalendarzowe / 30 "
            ##SQL += " WHEN (typ_absencji_id NOT IN ('6A','6B','6S','6T','7','8','9','O','R')"
            #SQL += " AND a.od_kiedy>=lp.data_od AND a.do_kiedy<=lp.data_do) "
            ##SQL += " AND a.od_kiedy>='"+DataFiltraOd+"' AND a.do_kiedy<='"+DataFiltraDo+"' )"
            ##SQL += " THEN dni_robocze / kp.dni_harmonogramu ELSE 0 END )) ),"
            SQL += " ELSE 0 END )) ),"
            SQL += " SUM(CASE WHEN (typ_absencji_id IN ('1','2','5C')"
            #SQL += " AND a.od_kiedy>=lp.data_od AND a.do_kiedy<=lp.data_do )"
            SQL += " AND a.od_kiedy>='"+DataFiltraOd+"' AND a.do_kiedy<='"+DataFiltraDo+"' )"
            SQL += " THEN ROUND(COALESCE(an.placa,0) * (dni_robocze * 8 * an.etat) / an.etat * 0.01,2) ELSE 0 END) "
            SQL += " FROM rs_kp_listy_plac_osoby lp  "
            SQL += " LEFT OUTER JOIN rs_kp_dane_osobowe_absencje a USING (firma_id, pracownik_id) "
            SQL += " INNER JOIN rs_kp_angaze_karty_pracy kp USING (firma_id, pracownik_id, zatrudnienie_id,umowa_id,angaz_id) "
            SQL += " INNER JOIN rs_kp_angaze an USING (firma_id, pracownik_id, zatrudnienie_id,umowa_id,angaz_id) "
            SQL += " WHERE a.firma_id='"+self.firma_id+"' AND lp.numer_listy_id='"+ListaPlac+"'"
            SQL += " AND kp.rok = '" + LListaPlac[0][0][:4] + "' AND kp.mc = '" + LListaPlac[0][0][5:7] + "'"
            SQL += " GROUP BY lp.pracownik_id, an.dodatek_fun"
            rsglobal.ZapiszDoLogow("dziwne daty sql"+SQL, 1)
            stat,LAbsDoProwizji,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK' and CzyKartyPracy:
            #rsglobal.ZapiszDoLogow("dziwne daty"+str(LListaPlac[0][0])+str(LListaPlac[0][1]), 1)
            dlod = rs_anakonda_daty.ZamienDate(str(LListaPlac[0][0]))
            dldo = rs_anakonda_daty.ZamienDate(str(LListaPlac[0][1]))
            #JR dninom = str(rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, Pracownik, dlod, dldo))
            dninom = str(rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, Pracownik, Zatrudnienie, Umowa, Angaz, dlod))
            if dninom == '0':
                stat = 'Brak uzupenionych dni w kalendarzu.'
            else:
                SQL = "SELECT SUM(CASE WHEN up.typ_pracownika_id='G'"
                SQL += " THEN 1.0 * kp.godz_sobotnie * an.stawka "
                SQL += " WHEN up.typ_pracownika_id<>'G'"
                SQL += " THEN 1.0 * kp.godz_sobotnie * an.placa * (1.0 / "+dninom+" / 8.0 / an.etat) ELSE 0.0 END  )"
                SQL += " FROM rs_kp_listy_plac_osoby lp  "
                SQL += " INNER JOIN rs_kp_angaze_karty_pracy kp USING (firma_id, pracownik_id, zatrudnienie_id,umowa_id,angaz_id) "
                SQL += " INNER JOIN rs_kp_umowy_o_prace up USING (firma_id, pracownik_id, zatrudnienie_id,umowa_id) "
                SQL += " INNER JOIN rs_kp_angaze an USING (firma_id, pracownik_id, zatrudnienie_id,umowa_id,angaz_id) "
                SQL += " WHERE lp.firma_id='"+self.firma_id+"' AND lp.numer_listy_id='"+ListaPlac+"'"
                SQL += " AND kp.rok = '" + LListaPlac[0][0][:4] + "' AND kp.mc = '" + LListaPlac[0][0][5:7] + "'"
                rsglobal.ZapiszDoLogow("dziwne daty sql"+SQL, 1)
                stat,LDoplSoboty,dump,dump = self.PolSQL.Execute(SQL,3)
                rsglobal.ZapiszDoLogow("dziwne daty sql"+str(LDoplSoboty), 1)
        if stat == 'OK' and CzyKartyPracy:
            SQL = "SELECT SUM(dni_harmonogramu), SUM(dni_przepracowane), SUM(godz_normalne), SUM(godz_nadliczbowe_50), SUM(godz_nadliczbowe_100),"  # 0 - 4
            SQL += " SUM(godz_nadliczbowe_0), SUM(godz_sobotnie), SUM(godz_doplat_tylko), SUM(godz_nocne), SUM(godz_krotkich_zwoln)"  # 5 - 9
            SQL += " FROM rs_kp_listy_plac_osoby lp "
            SQL += " INNER JOIN rs_kp_angaze_karty_pracy kp "
            SQL += " ON kp.firma_id=lp.firma_id AND kp.pracownik_id=lp.pracownik_id "
            SQL += " AND kp.zatrudnienie_id=lp.zatrudnienie_id AND kp.umowa_id=lp.umowa_id AND kp.angaz_id=lp.angaz_id "
            SQL += " WHERE lp.firma_id='" + self.firma_id + "' AND lp.numer_listy_id='" + ListaPlac + "'"
            SQL += " AND rok = '" + LListaPlac[0][0][:4] + "' AND mc = '" + LListaPlac[0][0][5:7] + "'"
            stat, LKartyPracySumy, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat == 'OK' and LUmowy != []:
            if LUmowy[0][8] not in ('M','G','P'):
                stat = "Niepoprawny typ pracownika (rny od 'M','G','P')"
    else:
        LListaPlac = []

    # Rodzina
    if stat == 'OK' and CzlonekRodziny > 0:
        SQL ="SELECT pokrewienstwo_id, niepelnosprawnosc_id, COALESCE(data_urodzenia::TEXT,'') " #0-2
        SQL+="FROM rs_kp_rodzina WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND pracownik_id='"+Pracownik+"' AND rodzina_id="+str(CzlonekRodziny)+";"
        stat,LRodzina,dump,dump = self.PolSQL.Execute(SQL,3)
        LRodzina = PodmienNule(LRodzina)
    else:
        LRodzina = []

    # liczby dni i godzin absencji
    if stat == 'OK' and len(Absencja) > 0:
        SQL ="SELECT przechodni " #0-2
        SQL+=" FROM rs_kp_absencje_rodzaje WHERE firma_id='"+self.firma_id+"' ;"
        stat,LPrzechodni,dump,dump = self.PolSQL.Execute(SQL,3)
        LPrzechodni = PodmienNule(LPrzechodni)
        SQL ="SELECT sum(dni_kalendarzowe), sum(dni_robocze), sum(godziny_robocze) " #0-2
        SQL+=" FROM rs_kp_dane_osobowe_absencje WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND pracownik_id='"+Pracownik+"' AND typ_absencji_id like '"+Absencja[0]+"%' "
        if CzlonekRodziny > 0:
            SQL+=" AND rodzina_id="+str(CzlonekRodziny)
        SQL+=" AND EXTRACT( YEAR FROM od_kiedy) = "+Absencja[1][0:4]+";"
        stat,LCzasAbsencji,dump,dump = self.PolSQL.Execute(SQL,3)
        SQL ="SELECT typ_absencji_id, sum(dni_kalendarzowe), sum(dni_robocze), sum(godziny_robocze) " #0-2
        SQL+=" FROM rs_kp_dane_osobowe_absencje WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND pracownik_id='"+Pracownik+"' AND typ_absencji_id like '"+Absencja[0]+"%' "
        if CzlonekRodziny > 0:
            SQL+=" AND rodzina_id="+str(CzlonekRodziny)
        SQL+=" AND EXTRACT( YEAR FROM od_kiedy) = "+Absencja[1][0:4]
        SQL+=" GROUP BY typ_absencji_id ORDER BY typ_absencji_id;"
        stat,LLCzasAbsencji,dump,dump = self.PolSQL.Execute(SQL,3)
    else:
        LPrzechodni = []
        LCzasAbsencji = []
        LLCzasAbsencji = []

    if stat == 'OK':
        # zmienne suce do wyliczenia innych zmiennych
        if len(LOsobowe) > 0:
            PESEL = LOsobowe[0][9]
        if len(LListaPlac) > 0:
            DataListyOd = LListaPlac[0][0]
            DataListyDo = LListaPlac[0][1]
            DataWypl = LListaPlac[0][2]
            Szablon = LListaPlac[0][3]
        if len(LZatrudnienie) > 0:
            FP = LZatrudnienie[0][0]
            FGSP = LZatrudnienie[0][1]
            PIT11_8 = LZatrudnienie[0][2]
            PIT40 = LZatrudnienie[0][3]
            UlgaZatr = LZatrudnienie[0][4]
            KosztyPodwZatr = LZatrudnienie[0][5]
            UbEmer = LZatrudnienie[0][6]
            UbRent = LZatrudnienie[0][7]
            UbChorob = LZatrudnienie[0][8]
            UbWypadk = LZatrudnienie[0][27]
            UbZdrow = LZatrudnienie[0][9]
        if len(LUmowy) > 0:
            DataZUSOd = LUmowy[0][4]
            DataZUSDo = LUmowy[0][5]
        if len(LAngaze) > 0:
            DataAngOd = LAngaze[0][0]
            DataAngDo = LAngaze[0][1]

    # karty pracy (na podstawie angau oraz daty do listy pac)
    if stat == 'OK' and DataListyDo != '' and CzyKartyPracy:
        SQL ="SELECT dni_harmonogramu, dni_przepracowane, godz_normalne, godz_nadliczbowe_50, godz_nadliczbowe_100," # 0 - 4
        SQL+=" godz_nadliczbowe_0, godz_sobotnie, godz_doplat_tylko, godz_nocne, godz_krotkich_zwoln" # 5 - 9
        SQL+=" FROM rs_kp_angaze_karty_pracy "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
        SQL+=" AND zatrudnienie_id='"+Zatrudnienie+"' AND umowa_id='"+Umowa+"' AND angaz_id='"+Angaz+"'"
        SQL+=" AND rok = '"+DataListyDo[:4]+"' AND mc = '"+DataListyDo[5:7]+"'"
        stat, LKartyPracy, dump, dump = self.PolSQL.Execute(SQL, 3)
    else:
        LKartyPracy = []

    # jak nie ma wiersza to wstawiamy -1 do danych z karty pracy
    if stat == 'OK' and LKartyPracy == []:
        for kl in ['kozatrumoprangazkp.dniharm','kozatrumoprangazkp.dniprac','kozatrumoprangazkp.godznorm','kozatrumoprangazkp.godznad50',
                   'kozatrumoprangazkp.godznad100','kozatrumoprangazkp.godznad0','kozatrumoprangazkp.godzsob','kozatrumoprangazkp.godzdoplat',
                   'kozatrumoprangazkp.godznoc','kozatrumoprangazkp.godzkrotzw']:
            SWartosci[kl] = 0
            Tresc = Tresc.replace('$$'+kl+'$$','0')

    # procenty PPK (na podstawie daty do listy pac)
    if stat == 'OK' and DataListyDo != '':
        SQL ="SELECT skladka_prac_podst,skladka_prac_dodat,skladka_firma_podst,skladka_firma_dodat,skladka_obnizona" # 0 - 4
        SQL+=" FROM rs_kp_dane_osobowe_ppk "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
        SQL+=" AND data_przystapienia <='"+DataListyDo+"' AND (data_rezygnacji >'"+DataListyDo+"' OR data_rezygnacji IS NULL);"
        stat, LPPK, dump, dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(LPPK) == 0:
                LPPK = [[0.0, 0.0, 0.0, 0.0, False]]
    else:
        LPPK = []

    if stat == 'OK':
        Tresc = Tresc.replace('>9</symbol>','></symbol><text>"       "</text>')
        for par in LParametry:
          try:  # po to, zeby zobaczyc na jakim polu sie ewentualnie uwala:
            pole = par[0]

            # zmienne systemowe
            czas = time.strftime("%Y.%m.%d %H:%M")
            if pole == 'zs.data':
                SWartosci[pole] = czas[0:10]
                Tresc = Tresc.replace('$$' + pole + '$$', czas[0:10])
            if pole == 'zs.czas':
                SWartosci[pole] = czas[11:]
                Tresc = Tresc.replace('$$' + pole + '$$', czas[11:])

            # Oddzial 01
            if len(LOdz01)>0:
                if pole == 'admoddz01.nazwa':
                    SWartosci[pole] = LOdz01[0][0]
                    zmienione=Podmiana(LOdz01[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'admoddz01.nip':
                    SWartosci[pole] = LOdz01[0][1]
                    zmienione=Podmiana(LOdz01[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'admoddz01.regon':
                    SWartosci[pole] = LOdz01[0][2]
                    zmienione=Podmiana(LOdz01[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'admoddz01adr.kodpocztowy':
                    SWartosci[pole] = LOdz01[0][3]
                    zmienione=Podmiana(LOdz01[0][3])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'admoddz01adr.miejscowosc':
                    SWartosci[pole] = LOdz01[0][4]
                    zmienione=Podmiana(LOdz01[0][4])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'admoddz01adr.ulica':
                    SWartosci[pole] = LOdz01[0][5]
                    zmienione=Podmiana(LOdz01[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'admoddz01adr.nrulicy':
                    SWartosci[pole] = LOdz01[0][6]
                    zmienione=Podmiana(LOdz01[0][6])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)

            # Dane osobowe
            if len(LOsobowe)>0:
                if pole == 'ko.nazwisko':
                    SWartosci[pole] = LOsobowe[0][0]
                    zmienione=Podmiana(LOsobowe[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.imie':
                    SWartosci[pole] = LOsobowe[0][1]
                    zmienione=Podmiana(LOsobowe[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.imiedr':
                    SWartosci[pole] = LOsobowe[0][2]
                    zmienione=Podmiana(LOsobowe[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.dataur':
                    SWartosci[pole] = LOsobowe[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LOsobowe[0][3]))
                if pole == 'ko.miejsceur':
                    SWartosci[pole] = LOsobowe[0][15]
                    zmienione=Podmiana(LOsobowe[0][15])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'abs.wieklata': # wiek w latach liczony do daty od absencji
                    dod = str(LOsobowe[0][3])
                    if len(Absencja) > 0:
                        SWartosci[pole] = int(rs_anakonda_daty.OkresPomiedzy(dod,str(Absencja[1]))[0:4] )
                    else:
                        SWartosci[pole] = int(rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'ko.imieoj':
                    SWartosci[pole] = LOsobowe[0][4]
                    zmienione=Podmiana(LOsobowe[0][4])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.imiemat':
                    SWartosci[pole] = LOsobowe[0][5]
                    zmienione=Podmiana(LOsobowe[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.nazwiskorod':
                    SWartosci[pole] = LOsobowe[0][6]
                    zmienione=Podmiana(LOsobowe[0][6])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.narodow':
                    SWartosci[pole] = LOsobowe[0][7]
                    zmienione=Podmiana(LOsobowe[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.obywat':
                    SWartosci[pole] = LOsobowe[0][8]
                    zmienione=Podmiana(LOsobowe[0][8])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'ko.pesel':
                    SWartosci[pole] = LOsobowe[0][9]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LOsobowe[0][9]))
                if pole == 'ko.nip':
                    SWartosci[pole] = LOsobowe[0][10]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LOsobowe[0][10]))
                if pole == 'ko.akcjonariusz':
                    if LOsobowe[0][11]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'ko.nierezydent':  #JR 2022-11-04
                    if LOsobowe[0][16]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                #AB 01.10.20r
                if pole == 'ko.typdok':
                    SWartosci[pole] = LOsobowe[0][12]
                    #WS 2021-02-09
                    zmienione=Podmiana(LOsobowe[0][12])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                    # Tresc = Tresc.replace('$$'+pole+'$$',str(LOsobowe[0][12]))
                if pole == 'ko.doknr':
                    SWartosci[pole] = LOsobowe[0][13]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LOsobowe[0][13]))
                if pole == 'ko.dokdatawaz':
                    SWartosci[pole] = LOsobowe[0][14]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LOsobowe[0][14]))

            # Adres zameldowania
            if len(LZamel)>0:
                if pole == 'koadr1.stzamkod':
                    SWartosci[pole] = LZamel[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamel[0][0]))
                if pole == 'koadr1.stzammiej':
                    SWartosci[pole] = LZamel[0][1]
                    zmienione=Podmiana(LZamel[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr1.stzamul':
                    SWartosci[pole] = LZamel[0][2]
                    zmienione=Podmiana(LZamel[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr1.stzamnrul':
                    SWartosci[pole] = LZamel[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamel[0][3]))
                if pole == 'koadr1.stzamnrmiesz':
                    SWartosci[pole] = LZamel[0][4]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamel[0][4]))
                if pole == 'koadr1.stzampocz':
                    SWartosci[pole] = LZamel[0][5]
                    zmienione=Podmiana(LZamel[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr1.stzamtel':
                    SWartosci[pole] = LZamel[0][6]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamel[0][6]))
                if pole == 'koadr1.stzammail':
                    SWartosci[pole] = LZamel[0][7]
                    zmienione=Podmiana(LZamel[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
            
            # Adres zamieszkania
            if len(LZamie)>0:
                if pole == 'koadr2.zamkod':
                    SWartosci[pole] = LZamie[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamie[0][0]))
                if pole == 'koadr2.zammiej':
                    SWartosci[pole] = LZamie[0][1]
                    zmienione=Podmiana(LZamie[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr2.zamul':
                    SWartosci[pole] = LZamie[0][2]
                    zmienione=Podmiana(LZamie[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr2.zamnrul':
                    SWartosci[pole] = LZamie[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamie[0][3]))
                if pole == 'koadr2.zamnrmiesz':
                    SWartosci[pole] = LZamie[0][4]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamie[0][4]))
                if pole == 'koadr2.zampocz':
                    SWartosci[pole] = LZamie[0][5]
                    zmienione=Podmiana(LZamie[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr2.zamtel':
                    SWartosci[pole] = LZamie[0][6]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZamie[0][6]))
                if pole == 'koadr2.zammail':
                    SWartosci[pole] = LZamie[0][7]
                    zmienione=Podmiana(LZamie[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                
            # Adres korespondencyjny
            if len(LKores)>0:
                if pole == 'koadr3.korkod':
                    SWartosci[pole] = LKores[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LKores[0][0]))
                if pole == 'koadr3.kormiej':
                    SWartosci[pole] = LKores[0][1]
                    zmienione=Podmiana(LKores[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr3.korul':
                    SWartosci[pole] = LKores[0][2]
                    zmienione=Podmiana(LKores[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr3.kornrul':
                    SWartosci[pole] = LKores[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LKores[0][3]))
                if pole == 'koadr3.kornrmiesz':
                    SWartosci[pole] = LKores[0][4]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LKores[0][4]))
                if pole == 'koadr3.korpocz':
                    SWartosci[pole] = LKores[0][5]
                    zmienione=Podmiana(LKores[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr3.kortel':
                    SWartosci[pole] = LKores[0][6]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LKores[0][6]))
                if pole == 'koadr3.kormail':
                    SWartosci[pole] = LKores[0][7]
                    zmienione=Podmiana(LKores[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
            
            # Adres pit
            if len(LPit)>0:
                if pole == 'koadr4.pitkod':
                    SWartosci[pole] = LPit[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LPit[0][0]))
                if pole == 'koadr4.pitmiej':
                    SWartosci[pole] = LPit[0][1]
                    zmienione=Podmiana(LPit[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr4.pitul':
                    SWartosci[pole] = LPit[0][2]
                    zmienione=Podmiana(LPit[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr4.pitnrul':
                    SWartosci[pole] = LPit[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LPit[0][3]))
                if pole == 'koadr4.pitnrmiesz':
                    SWartosci[pole] = LPit[0][4]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LPit[0][4]))
                if pole == 'koadr4.pitpocz':
                    SWartosci[pole] = LPit[0][5]
                    zmienione=Podmiana(LPit[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)
                if pole == 'koadr4.pittel':
                    SWartosci[pole] = LPit[0][6]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LPit[0][6]))
                if pole == 'koadr4.pitmail':
                    SWartosci[pole] = LPit[0][7]
                    zmienione=Podmiana(LPit[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$',zmienione)

            # Zatrudnienie
            if len(LZatrudnienie)>0:
                if pole == 'kozatr.ulga':  # ulga
                    SWartosci[pole] = str(LZatrudnienie[0][4])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LZatrudnienie[0][4]))
                if pole == 'kozatr.kopodw':  # koszty podwyszone
                    if LZatrudnienie[0][5]:
                        SWartosci[pole] = '1'
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = '0'
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'kozatr.stanprac':  # stan_pracownika_id
                    SWartosci[pole] = str(LZatrudnienie[0][10])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][10]))
                if pole == 'kozatr.rokurlop':  # start_rok_urlop
                    SWartosci[pole] = str(int(LZatrudnienie[0][11]))
                    Tresc = Tresc.replace('$$'+pole+'$$',str(int(LZatrudnienie[0][11])))
                if pole == 'kozatr.urlopwyk':  # urlop_wykorzystany
                    SWartosci[pole] = str(LZatrudnienie[0][12])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][12]))
                if pole == 'kozatr.urlopzal':  # urlop_zalegly
                    SWartosci[pole] = str(LZatrudnienie[0][13])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][13]))
                if pole == 'kozatr.rokzwol':  # start_rok_zwolnienie
                    SWartosci[pole] = str(int(LZatrudnienie[0][14]))
                    Tresc = Tresc.replace('$$'+pole+'$$',str(int(LZatrudnienie[0][14])))
                if pole == 'kozatr.chorwyk':  # choroba_wykorzystana
                    SWartosci[pole] = str(LZatrudnienie[0][15])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][15]))
                if pole == 'kozatr.glowmiej':  # gwne miejsce pracy
                    if LZatrudnienie[0][16]:
                        SWartosci[pole] = '1'
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = '0'
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'kozatr.zrnabor':  # zrodlo_naboru_id
                    SWartosci[pole] = str(LZatrudnienie[0][17])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][17]))
                if pole == 'kozatr.zwol':  # zwolnienie_id
                    SWartosci[pole] = str(LZatrudnienie[0][18])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][18]))
                if pole == 'kozatr.zwoldata':  # zwolnienie_data
                    SWartosci[pole] = str(LZatrudnienie[0][19])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][19]))
                if pole == 'kozatr.ubezp':  # ubezpieczenie_id
                    SWartosci[pole] = str(LZatrudnienie[0][20])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][20]))
                if pole == 'kozatr.urzsk':  # urzad_skarbowy_id
                    SWartosci[pole] = str(LZatrudnienie[0][21])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][21]))
                if pole == 'kozatr.oddznfz':  # oddzial_nfz_id
                    SWartosci[pole] = str(LZatrudnienie[0][22])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][22]))
                if pole == 'kozatr.daneglob':  # dane_globalne
                    if LZatrudnienie[0][23]:
                        SWartosci[pole] = '1'
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = '0'
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'kozatr.ekspzua':  # eksport_zua
                    SWartosci[pole] = str(LZatrudnienie[0][24])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][24]))
                if pole == 'kozatr.ekspzcna':  # eksport_zcna
                    SWartosci[pole] = str(LZatrudnienie[0][25])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][25]))
                if pole == 'kozatr.kopodst':  # koszty podstawowe
                    if LZatrudnienie[0][26]:
                        SWartosci[pole] = '1'
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = '0'
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'kozatr.stazdata':  # staz do dodatku
                    SWartosci[pole] = str(LZatrudnienie[0][28])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LZatrudnienie[0][28]))
                if pole == 'kozatr.stazlatadodatek':  # lata stazu do dodatku
                    dod = str(LZatrudnienie[0][28])
                    if DataListyOd == '':
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,DataListyOd)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'kozatr.stazlatadodateklista':  # lata stazu do dodatku plus liczba dni w zakresie dat listy
                    dod = str(LZatrudnienie[0][28])
                    if DataListyOd == '':
                        xlata1 = int(rs_anakonda_daty.OkresPomiedzy(dod)[0:4])
                        xlata2 = xlata1 + 1
                        SWartosci[pole] = str([[xlata1, 0], [xlata2, 0]])
                    else:
                        xlata1 = int(rs_anakonda_daty.OkresPomiedzy(dod,DataListyOd)[0:4])
                        xlata2 = int(rs_anakonda_daty.OkresPomiedzy(dod,DataListyDo)[0:4])
                        if xlata1 == xlata2:
                            xlata2 = xlata1 + 1
                            xdni1 = int(DataListyDo[8:10])
                            xdni2 = 0
                        else:
                            xdni1 = int(dod[8:10]) - 1
                            xdni2 = int(DataListyDo[8:10]) - int(dod[8:10]) + 1
                        SWartosci[pole] = str([[xlata1, xdni1], [xlata2, xdni2]])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'kozatr.stazlataogolem':  # lata stazu ogolem
                    dod = str(LZatrudnienie[0][29])
                    if DataListyOd == '':
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,DataListyOd)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'kozatr.stazlataurlop':  # lata stazu do urlopu
                    dod = str(LZatrudnienie[0][30])
                    if DataListyOd == '':
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,DataListyOd)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'abs.stazmceurlop':  # miesiace stazu do urlopu
                    dod = str(LZatrudnienie[0][30])
                    if DataListyOd != '':
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,DataListyOd)[0:4] )
                    elif len(Absencja)>0:
                        SWartosci[pole] = rs_anakonda_daty.OkresPomiedzy(dod,Absencja[1])
                        SWartosci[pole] = int(SWartosci[pole][0:4])*12 + int(SWartosci[pole][5:7])
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'kozatr.stazlatazasilek':  # lata stazu do zasilku
                    dod = str(LZatrudnienie[0][31])
                    if DataListyOd == '':
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,DataListyOd)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'kozatr.stazlatanagroda':  # lata stazu do nagrody jubileuszowej
                    dod = str(LZatrudnienie[0][32])
                    if DataWypl == '':
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,DataListyDo)[0:4])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                #WS 2021-05-04
                if pole == 'kozatr.oddznfzopis':  # opis z rs_oddzialy_nfz
                    SWartosci[pole] = str(LZatrudnienie[0][33])
                    zmienione = Podmiana(LZatrudnienie[0][33])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                #WS 2021-05-04
                if pole == 'kozatr.ubezpopis':  # opis z rs_rodzaje_ubezpieczen
                    SWartosci[pole] = str(LZatrudnienie[0][34])
                    zmienione = Podmiana(LZatrudnienie[0][34])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                #WS 2021-05-04
                if pole == 'kozatr.urzskopis':  # opis z rs_urzedy_skarbowe
                    SWartosci[pole] = str(LZatrudnienie[0][35])
                    zmienione = Podmiana(LZatrudnienie[0][35])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                #WS 2021-05-04
                if pole == 'kozatr.zwolopis':  # zwolnienie_id - opis z rs_stany_pracownika
                    SWartosci[pole] = str(LZatrudnienie[0][36])
                    zmienione = Podmiana(LZatrudnienie[0][36])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))

            # Umowa o prace
            if len(LUmowy)>0:
                if pole == 'kozatrumopr.nr':
                    SWartosci[pole] = str(LUmowy[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][0]))
                if pole == 'kozatrumopr.datazawar':
                    SWartosci[pole] = LUmowy[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][1]))
                if pole == 'kozatrumopr.dataobowod':
                    SWartosci[pole] = LUmowy[0][2]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][2]))
                if pole == 'kozatrumopr.dataobowdo':
                    SWartosci[pole] = LUmowy[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][3]))
                if pole == 'kozatrumopr.datazusod':
                    SWartosci[pole] = LUmowy[0][4]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][4]))
                if pole == 'kozatrumopr.datazusdo':
                    SWartosci[pole] = LUmowy[0][5]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][5]))
                if pole == 'kozatrumopr.rodzumowy':
                    SWartosci[pole] = LUmowy[0][6]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][6]))
                #if pole == 'kozatrumopr.rokurlop':
                #    SWartosci[pole] = str(int(LUmowy[0][7]))
                #    Tresc = Tresc.replace('$$'+pole+'$$',str(int(LUmowy[0][7])))
                if pole == 'kozatrumopr.typprac':
                    SWartosci[pole] = LUmowy[0][8]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LUmowy[0][8]))
                #WS 2021-05-04
                if pole == 'kozatrumopr.rodzumowyopis':  # opis z rs_umowy_rodzaj
                    SWartosci[pole] = LUmowy[0][9]
                    zmienione = Podmiana(LUmowy[0][9])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                #WS 2021-05-04
                if pole == 'kozatrumopr.typpracopis':  # opis z rs_typy_pracownikow
                    SWartosci[pole] = LUmowy[0][10]
                    zmienione = Podmiana(LUmowy[0][10])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                
            # Anga
            if len(LAngaze)>0:
                if pole == 'kozatrumoprangaz.dataobowod':
                    SWartosci[pole] = LAngaze[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LAngaze[0][0]))
                if pole == 'kozatrumoprangaz.dataobowdo':
                    SWartosci[pole] = LAngaze[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LAngaze[0][1]))
                if pole == 'kozatrumoprangaz.miejscepr':
                    SWartosci[pole] = LAngaze[0][3]
                    zmienione=Podmiana(LAngaze[0][3])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                if pole == 'kozatrumoprangaz.komzatr':
                    SWartosci[pole] = LAngaze[0][5]
                    zmienione=Podmiana(LAngaze[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                if pole == 'kozatrumoprangaz.komzatrkod':
                    SWartosci[pole] = LAngaze[0][26]
                    zmienione=Podmiana(LAngaze[0][26])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                if pole == 'kozatrumoprangaz.grprackod':
                    SWartosci[pole] = LAngaze[0][6]
                    zmienione=Podmiana(LAngaze[0][6])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                if pole == 'kozatrumoprangaz.grprac':
                    SWartosci[pole] = LAngaze[0][7]
                    zmienione=Podmiana(LAngaze[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                if pole == 'kozatrumoprangaz.stankod':
                    SWartosci[pole] = LAngaze[0][8]
                    zmienione=Podmiana(LAngaze[0][8])
                if pole == 'kozatrumoprangaz.stan':
                    SWartosci[pole] = LAngaze[0][9]
                    zmienione=Podmiana(LAngaze[0][9])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(zmienione))
                if pole == 'kozatrumoprangaz.etat':
                    SWartosci[pole] = str(LAngaze[0][10])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LAngaze[0][10]))
                if pole == 'kozatrumoprangaz.etatprocent':
                    SWartosci[pole] = rsstr(round(LAngaze[0][10]*100.0,2))
                    Tresc = Tresc.replace('$$'+pole+'$$',str(round(LAngaze[0][10]*100.0,2)))
                if pole == 'kozatrumoprangaz.zaszer':
                    SWartosci[pole] = LAngaze[0][11]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LAngaze[0][11]))
                if pole == 'kozatrumoprangazwynagr.plzasad':
                    SWartosci[pole] = str(LAngaze[0][12])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LAngaze[0][12]))
                if pole == 'kozatrumoprangazwynagr.stawzas':
                    SWartosci[pole] = str(LAngaze[0][13])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LAngaze[0][13]))
                if pole == 'kozatrumoprangazwynagr.dodfunkc':
                    SWartosci[pole] = str(LAngaze[0][14])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LAngaze[0][14]))
                if pole == 'kozatrumoprangazwynagr.rycz':
                    SWartosci[pole] = str(LAngaze[0][15])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LAngaze[0][15]))
                if pole == 'kozatrumoprangaz.rodzprac':  # rodzaj pracownika
                    SWartosci[pole] = str(LAngaze[0][16])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LAngaze[0][16]))
                if pole == 'kozatrumoprangaz.zawod':  # zawd wykonywany
                    SWartosci[pole] = str(LAngaze[0][18])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LAngaze[0][18]))
                if pole == 'kozatrumoprangaz.stankoszt':  # stanowisko kosztw
                    SWartosci[pole] = str(LAngaze[0][19])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LAngaze[0][19]))
                if pole == 'kozatrumoprangaz.katzaszer':  # kategoria zaszeregowania
                    SWartosci[pole] = str(LAngaze[0][20])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LAngaze[0][20]))
                if pole == 'kozatrumoprangaz.dodatek1':  # dodatek1
                    SWartosci[pole] = str(LAngaze[0][21])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LAngaze[0][21]))
                if pole == 'kozatrumoprangaz.dodatek2':  # dodatek2
                    SWartosci[pole] = str(LAngaze[0][22])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LAngaze[0][22]))
                if pole == 'kozatrumoprangaz.kalendarz':  # kalendarz
                    SWartosci[pole] = str(LAngaze[0][23])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LAngaze[0][23]))
                if pole == 'kozatrumoprangaz.stanmiej':  # stanowisko miejsce
                    SWartosci[pole] = str(LAngaze[0][24])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LAngaze[0][24]))
                if pole == 'kozatrumoprangaz.szlista':  # lista (szablon)
                    SWartosci[pole] = str(LAngaze[0][25])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LAngaze[0][25]))
                if pole == 'kozatrumoprangaz.zerowypit':  # czy zerowy pit
                    if LAngaze[0][27]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                #WS 2021-05-04
                if pole == 'kozatrumoprangaz.rodzpracopis':  # opis z rs_rodzaje_pracownikow
                    SWartosci[pole] = str(LAngaze[0][28])
                    zmienione = Podmiana(LAngaze[0][28])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(zmienione))
                #WS 2021-05-04
                if pole == 'kozatrumoprangaz.stanmiejopis':  # opis z rs_kp_stanowiska_pracy_miejsca
                    SWartosci[pole] = str(LAngaze[0][29])
                    zmienione = Podmiana(LAngaze[0][29])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(zmienione))
                #WS 2021-05-04
                if pole == 'kozatrumoprangaz.zawodopis':  # zawd wykonywany - opis z rs_zawody_specjalnosci_klasyfikacja
                    SWartosci[pole] = str(LAngaze[0][30])
                    zmienione = Podmiana(LAngaze[0][30])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(zmienione))
                #JR 2021-12-21
                if pole == 'kozatrumoprangaz.ulgaklsr':  # czy ulga dla klasy sredniej
                    if LAngaze[0][31]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$', '1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$', '0')
                if pole == 'kozatrumoprangaz.ulgarodzplus':  # czy ulga rodzina 4+
                    if LAngaze[0][32]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$', '1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$', '0')
                if pole == 'kozatrumoprangaz.ulganapowrot':  # czy ulga na powrot
                    if LAngaze[0][33]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$', '1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$', '0')
                if pole == 'kozatrumoprangaz.ulgadlaemeryta':  # czy ulga dla emeryta
                    if LAngaze[0][34]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$', '1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$', '0')

            # Angae - Karty pracy
            if len(LKartyPracy)>0:
                if pole == 'kozatrumoprangazkp.dniharm':  # dni harmonogramu
                    if LKartyPracy[0][0] < 1:
                        return 'Brak dni wg harmonogramu w karcie pracy', None
                    SWartosci[pole] = str(LKartyPracy[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][0]))
                if pole == 'kozatrumoprangazkp.dniprac':  # dni przepracowane
                    SWartosci[pole] = str(LKartyPracy[0][1])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][1]))
                if pole == 'kozatrumoprangazkp.godznorm':  # godziny normalne
                    SWartosci[pole] = str(LKartyPracy[0][2])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][2]))
                if pole == 'kozatrumoprangazkp.godznad50':  # godziny nadliczbowe 50
                    SWartosci[pole] = str(LKartyPracy[0][3])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][3]))
                if pole == 'kozatrumoprangazkp.godznad100':  # godziny nadliczbowe 100
                    SWartosci[pole] = str(LKartyPracy[0][4])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][4]))
                if pole == 'kozatrumoprangazkp.godznad0':  # godziny nadliczbowe 0
                    SWartosci[pole] = str(LKartyPracy[0][5])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][5]))
                if pole == 'kozatrumoprangazkp.godzsob':  # godziny sobotnie
                    SWartosci[pole] = str(LKartyPracy[0][6])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][6]))
                if pole == 'kozatrumoprangazkp.godzdoplat':  # godziny tylko dopat
                    SWartosci[pole] = str(LKartyPracy[0][7])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][7]))
                if pole == 'kozatrumoprangazkp.godznoc':  # godziny nocne
                    SWartosci[pole] = str(LKartyPracy[0][8])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][8]))
                if pole == 'kozatrumoprangazkp.godzkrotzw':  # godziny krtkich zwolnie
                    SWartosci[pole] = str(LKartyPracy[0][9])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(LKartyPracy[0][9]))

            # data bieca
            if pole == 'lpdaty.rok':
                SWartosci[pole] = rsglobal.PodajDzis()[:4]
                Tresc = Tresc.replace('$$'+pole+'$$', rsglobal.PodajDzis()[:4])
            if pole == 'lpdaty.poczrokbiez':
                SWartosci[pole] = rsglobal.PodajDzis()[:4]+'-01-01'
                Tresc = Tresc.replace('$$'+pole+'$$',rsglobal.PodajDzis()[:4]+'-01-01')

                    
            # Lista pac
            if len(LListaPlac)>0:
                if pole == 'lpdaty.dataod':
                    SWartosci[pole] = LListaPlac[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][0])
                if pole == 'lpdaty.poczroklpod':
                    SWartosci[pole] = LListaPlac[0][0][:4]+'-01-01'
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][0][:4]+'-01-01')
                if pole == 'lpdaty.dataodmc':
                    SWartosci[pole] = LListaPlac[0][0][5:7]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][0][5:7])
                if pole == 'lpdaty.datado':
                    SWartosci[pole] = LListaPlac[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][1])
                if pole == 'lpdaty.poczroklpdo':
                    SWartosci[pole] = LListaPlac[0][1][:4]+'-01-01'
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][1][:4]+'-01-01')
                if pole == 'lpdaty.datadomc':
                    SWartosci[pole] = LListaPlac[0][1][5:7]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][1][5:7])
                if pole == 'lpdaty.datawyplaty':
                    SWartosci[pole] = LListaPlac[0][2]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][2])
                if pole == 'lpdaty.datawyplatymc':
                    SWartosci[pole] = LListaPlac[0][2][5:7]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][2][5:7])
                if pole == 'lpdaty.poczrokdatawypl':
                    SWartosci[pole] = LListaPlac[0][2][:4]+'-01-01'
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][2][:4]+'-01-01')
                if pole == 'lp.szablon':
                    SWartosci[pole] = LListaPlac[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][3])
                if pole == 'lp.lista':
                    SWartosci[pole] = LListaPlac[0][4]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][4])
                if pole == 'lp.grupa_prac':
                    SWartosci[pole] = LListaPlac[0][5]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][5])
                if pole == 'lp.ddzusdw':
                    if LListaPlac[0][6]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'lp.ddpitdw':
                    if LListaPlac[0][7]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'lp.konto_b':
                    SWartosci[pole] = LListaPlac[0][8]
                    Tresc = Tresc.replace('$$'+pole+'$$',LListaPlac[0][8])

            # pozstae pola - wyliczane tylko jesli jest angaz i lista
            if (len(LAngaze)>0) and (len(LListaPlac)>0):
                if pole == 'abs.wieklata': # wiek w latach liczony do daty listy do - UWAGA: nazwa zmiennej moze byc mylaca
                    dod = str(LOsobowe[0][3])
                    if DataListyDo != '':
                        SWartosci[pole] = int(rs_anakonda_daty.OkresPomiedzy(dod,str(DataListyDo))[0:4])
                if pole == 'abs.wieklatamc': # wiek w latach i miesiacach liczony do daty listy od - UWAGA: nazwa zmiennej moze byc mylaca
                    dod = str(LOsobowe[0][3])
                    if DataListyOd != '':
                        SWartosci[pole] = rs_anakonda_daty.OkresPomiedzy(dod,str(DataListyOd))[2:7]
                        if SWartosci[pole][3:5] == '00' and dod[5:7] < DataListyOd[5:7]:  # wazne sa miesiace
                            SWartosci[pole] = SWartosci[pole][0:3] + '01'
                if pole == 'abs.wieklatawyp': # wiek w latach liczony do daty wyplaty listy- UWAGA: nazwa zmiennej moze byc mylaca
                    dod = rs_anakonda_daty.DodajKilkaDni(str(LOsobowe[0][3]),1)
                    if DataWypl != '':
                        SWartosci[pole] = int(rs_anakonda_daty.OkresPomiedzy(dod,str(DataWypl))[0:4])
                if pole == 'abs.wieklatamcwyp': # wiek w latach i miesiacach liczony do daty wyplaty listy - UWAGA: nazwa zmiennej moze byc mylaca
                    dod = rs_anakonda_daty.DodajKilkaDni(str(LOsobowe[0][3]),1)
                    if DataWypl != '':
                        SWartosci[pole] = rs_anakonda_daty.OkresPomiedzy(dod,str(DataWypl))[2:7]
                        if SWartosci[pole][3:5] == '00' and dod[5:7] < DataWypl[5:7]:  # wazne sa miesiace
                            SWartosci[pole] = SWartosci[pole][0:3] + '01'
                if pole == 'zmx.X_suma_podstaw' and CzyKartyPracy: # suma podstaw dla osob z listy
                    SWartosci[pole] = str(LSumaPodstaw[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LSumaPodstaw[0][0]))
                if pole == 'lp.dodfunkcyjny' and CzyKartyPracy: # suma dodatku funkcyjnego dla osob z listy z potraceniami, kod ubezp<>'12'
                    s = 0
                    for w in LAbsDoProwizji:
                        s += rsglobal.RSRound(w[1])
                    SWartosci[pole] = s
                    Tresc = Tresc.replace('$$'+pole+'$$',str(s))
                if pole == 'lp.doplsoboty' and CzyKartyPracy: # suma doplat za soboty dla osob z listy
                    SWartosci[pole] = LDoplSoboty[0][0]
                    #rsglobal.ZapiszDoLogow("dziwne daty"+str(LDoplSoboty[0][0]), 1)
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LDoplSoboty[0][0]))
                if pole == 'lp.grezerwy' and CzyKartyPracy: # suma godz.kr.zwolnien dla osob z listy
                    s = 0
                    for w in LAbsDoProwizji:
                        s += rsglobal.RSRound(w[2],2)
                    s += LSumaPodstaw[0][2]
                    SWartosci[pole] = s
                    Tresc = Tresc.replace('$$'+pole+'$$',str(s))
                    #SWartosci[pole] = str(LSumaPodstaw[0][2])
                    #Tresc = Tresc.replace('$$'+pole+'$$',str(LKartyPracySumy[0][9]))
                if pole == 'lp.gprzep' and CzyKartyPracy: # suma godz.przepracowanych dla osob z listy
                    SWartosci[pole] = str(LKartyPracySumy[0][2] + LKartyPracySumy[0][4])
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LKartyPracySumy[0][2] + LKartyPracySumy[0][4]))
                if pole == 'lp.gprzelicz' and CzyKartyPracy: # suma godz.przeliczeniowych dla osob z listy
                    SWartosci[pole] = LSumaPodstaw[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(LSumaPodstaw[0][1]))
                if pole == 'zmx.X_czy046':
                    if Szablon in ['100','101','105','106','151']:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_30k':
                    if DataWypl == '':
                        SWartosci[pole] = -1
                        Tresc = Tresc.replace('$$'+pole+'$$','-1')
                    else:
                        DataWyplTest =DataWypl[:4]+'-12-31'
                        SQL = "SELECT wart_num FROM rs_kp_stale WHERE firma_id='"+self.firma_id+"' AND stala_id='SZ14' AND data_od <= '"+DataWyplTest+"' ORDER BY data_od DESC LIMIT 1"
                        stat,D30K,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':
                            return u'Bd pobierania danych do X30K : '+stat,None
                        if len(D30K) == 0:
                            SWartosci[pole] = -1
                            Tresc = Tresc.replace('$$'+pole+'$$','-1')
                        else:
                            SWartosci[pole] = D30K[0][0]
                            Tresc = Tresc.replace('$$'+pole+'$$',str(D30K[0][0]))
                if pole == 'lpdaty.dniang':
                    DataPocz= DataAngOd
                    if DataPocz == '' or DataPocz < DataListyOd:
                        DataPocz = DataListyOd
                    DataKon= DataAngDo
                    if DataKon == '' or DataKon > DataListyDo:
                        DataKon = DataListyDo
                    if DataPocz > DataKon:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$',str(0))
                    else:
                        IleDni = rsglobal.IleDniWZakresieDat(DataPocz,DataKon)
                        SWartosci[pole] = IleDni
                        Tresc = Tresc.replace('$$'+pole+'$$',str(IleDni))
                if pole == 'lpdaty.dnimcdatawypl':
                    if DataWypl == '':
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                    else:
                        Pocz = 1
                        Kon = int(rsglobal.PodajOstatniDzien(DataWypl))
                        IleDni = Kon - Pocz + 1
                        SWartosci[pole] = IleDni
                        Tresc = Tresc.replace('$$'+pole+'$$',str(IleDni))
                if pole == 'lpdaty.dnimcdatawyplzang':
                    if DataWypl == '':
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                    else:
                        if DataAngOd == '':
                            Pocz = 1
                        elif DataAngOd[:7] < DataWypl[:7]: # anga zaczty przed miesicem daty wypaty
                            Pocz = 1
                        elif DataAngOd[:7] == DataWypl[:7]: # anga zaczty w miesicu wypaty
                            Pocz = int(DataAngOd[8:])
                        else:
                            Pocz = 40 # anga po dacie wypaty

                        if DataAngDo == '': # anga w toku
                            Kon = int(rsglobal.PodajOstatniDzien(DataWypl))
                        elif DataAngDo[:7] > DataWypl[:7]: # anga skoczony po miesicu daty wypaty
                            Kon = int(rsglobal.PodajOstatniDzien(DataWypl))
                        elif DataAngDo[:7] == DataWypl[:7]: # anga skoczony w miesicu wypaty
                            Kon = int(DataAngDo[8:])
                        else:
                            Kon = 0 # anga po dacie wypaty

                        if Kon < Pocz: # co nie tak - data wypaty poza angaem
                            SWartosci[pole] = 0
                            Tresc = Tresc.replace('$$'+pole+'$$','0')
                        else:
                            IleDni = Kon - Pocz + 1
                            SWartosci[pole] = IleDni
                            Tresc = Tresc.replace('$$'+pole+'$$',str(IleDni))
                if pole == 'lpdaty.dnimcdatado':
                    if DataListyDo == '':
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                    else:
                        Pocz = 1
                        Kon = int(rsglobal.PodajOstatniDzien(DataListyDo))
                        IleDni = Kon - Pocz + 1
                        SWartosci[pole] = IleDni
                        Tresc = Tresc.replace('$$'+pole+'$$',str(IleDni))
                if pole == 'lpdaty.dnimcdatadozang':
                    if DataListyDo == '':
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                    else:
                        if DataAngOd == '':
                            Pocz = 1
                        elif DataAngOd[:7] < DataListyDo[:7]: # anga zaczty przed miesicem daty do z listy
                            Pocz = 1
                        elif DataAngOd[:7] == DataListyDo[:7]: # anga zaczty w miesicu daty do listy
                            Pocz = int(DataAngOd[8:])
                        else:
                            Pocz = 40 # anga po dacie do listy
                        if DataAngDo == '': # anga w toku
                            Kon = int(rsglobal.PodajOstatniDzien(DataListyDo))
                        elif DataAngDo[:7] > DataListyDo[:7]: # anga skoczony po miesicu daty do listy
                            Kon = int(rsglobal.PodajOstatniDzien(DataListyDo))
                        elif DataAngDo[:7] == DataListyDo[:7]: # anga skoczony w miesicu daty do listy
                            Kon = int(DataAngDo[8:])
                        else:
                            Kon = 0 # anga po dacie do listy
                        if Kon < Pocz: # co nie tak - data listy do poza angaem
                            SWartosci[pole] = 0
                            Tresc = Tresc.replace('$$'+pole+'$$','0')
                        else:
                            IleDni = Kon - Pocz + 1
                            SWartosci[pole] = IleDni
                            Tresc = Tresc.replace('$$'+pole+'$$',str(IleDni))
                if pole == 'kozatrumoprangazkp.dninom':
                    if DataListyDo != '':
                        dlod = rs_anakonda_daty.ZamienDate(DataListyOd)
                        dldo = rs_anakonda_daty.ZamienDate(DataListyDo)
                        #JR SWartosci[pole] = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, Pracownik, dlod,dldo)
                        SWartosci[pole] = rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, Pracownik, Zatrudnienie, Umowa, Angaz, dlod)
                        Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'kozatrumoprangazkp.dninompoprzmc':
                    if DataListyDo != '':
                        dldo = rs_anakonda_daty.DodajKilkaDni(DataListyOd, -1)
                        dlod = dldo[:-2] + '01'
                        dlod = rs_anakonda_daty.ZamienDate(dlod)
                        dldo = rs_anakonda_daty.ZamienDate(dldo)
                        #JR SWartosci[pole] = rs_anakonda_daty.LiczbaDniPracujacychWgKalendarza(self, Pracownik, dlod,dldo)
                        SWartosci[pole] = rs_anakonda_daty.LiczbaDniNominalnychDlaAngazuWMiesiacu(self, Pracownik, Zatrudnienie, Umowa, Angaz, dlod)
                        Tresc = Tresc.replace('$$'+pole+'$$', str(SWartosci[pole]))
                        rsglobal.ZapiszDoLogow('dninom: dlod-'+str(dlod)+", dldo-"+str(dldo)+", wynik-"+str(SWartosci[pole]))
                if pole == 'lpdaty.dnilisty':
                    if DataListyDo == '':
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                    else:
                        IleDni = rsglobal.IleDniWZakresieDat(DataListyOd,DataListyDo)
                        SWartosci[pole] = IleDni
                        Tresc = Tresc.replace('$$'+pole+'$$',str(IleDni))
                if pole == 'zmx.X_czyfgsp':
                    if FGSP and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyDo):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_czyfp':
                    if FP and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyDo):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_pd': # podatek dochodowy
                    if PIT11_8 or PIT40:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_pd_indku': # indywidualne koszty uzyskania
                    if UlgaZatr ==  'B': # brak
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                    else:
                        if UlgaZatr == 'S': # zwykla
                            ZmUlgi = 'SP12'
                        else: # podwyszona (DO ZMIANY)
                            ZmUlgi = 'SP12'
                        if len(LListaPlac) > 0:
                            SQL = "SELECT wart_num FROM rs_kp_stale WHERE firma_id='"+self.firma_id+"' AND stala_id='"+ZmUlgi+"' AND data_od <= '"+DataListyDo+"' ORDER BY data_od DESC LIMIT 1"
                            stat,DUlgaZatr,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                return u'Bd pobierania danych do ulgi zatrudnienia : '+stat,None
                            if len(DUlgaZatr) == 0:
                                SWartosci[pole] = -1
                                Tresc = Tresc.replace('$$'+pole+'$$','-1')
                            else:
                                SWartosci[pole] = DUlgaZatr[0][0]
                                Tresc = Tresc.replace('$$'+pole+'$$',str(DUlgaZatr[0][0]))
                if pole == 'zmx.X_pd_uzysk': # koszty uzyskania
                    if KosztyPodwZatr:
                        ZmKosztow = 'SP11'
                    else:
                        ZmKosztow = 'SP10'
                    if len(LListaPlac) > 0:
                        SQL = "SELECT wart_num FROM rs_kp_stale WHERE firma_id='"+self.firma_id+"' AND stala_id='"+ZmKosztow+"' AND data_od <= '"+DataListyDo+"' ORDER BY data_od DESC LIMIT 1"
                        stat,DKosztyZatr,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':
                            return u'Bd pobierania danych do kosztw uzyskania : '+stat,None
                        if len(DKosztyZatr) == 0:
                            SWartosci[pole] = -1
                            Tresc = Tresc.replace('$$'+pole+'$$','-1')
                        else:
                            SWartosci[pole] = DKosztyZatr[0][0]
                            Tresc = Tresc.replace('$$'+pole+'$$',str(DKosztyZatr[0][0]))
                if pole == 'dpwartstal.rb':
                    SQL = "SELECT wart_int FROM rs_kp_stale WHERE firma_id='" + self.firma_id + "' AND stala_id='RB' ORDER BY data_od DESC LIMIT 1"
                    stat,w,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':
                        return u'Bd pobierania danych wartoci staych : '+stat,None
                    if len(w)==1:
                        SWartosci[pole] = str(w[0][0])
                        Tresc = Tresc.replace('$$'+pole+'$$', str(w[0][0]))
                if pole == 'zmx.X_ue': # ubezpieczenie emerytalne
                    if UbEmer and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyOd):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_ur': # ubezpieczenie rentowe
                    if UbRent and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyOd):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_uw': # ubezpieczenie wypadkowe (chorobowe?)
                    if UbWypadk and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyOd):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_uch': # ubezpieczenie chorobowe
                    if UbChorob and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyOd):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
                if pole == 'zmx.X_uz': # ubezpieczenie zdrowotne
                    if UbZdrow and DataZUSOd != '' and DataZUSOd <= DataListyDo and (DataZUSDo == '' or DataZUSDo >= DataListyOd):
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')


            if pole == 'ko.plec': # pe
                if PESEL == '': # Brak
                    SWartosci[pole] = 'B'
                    Tresc = Tresc.replace('$$'+pole+'$$','B')
                elif PESEL [-2] in ['0','2','4','6','8']: # kobieta
                    SWartosci[pole] = 'K'
                    Tresc = Tresc.replace('$$'+pole+'$$','K')
                else: # mczyzna
                    SWartosci[pole] = 'M'
                    Tresc = Tresc.replace('$$'+pole+'$$','M')
            if pole == 'ko.nr': # id pracownika
                if Pracownik != '':
                    SWartosci[pole] = str(Pracownik)
                    Tresc = Tresc.replace('$$'+pole+'$$', str(Pracownik))
            if pole == 'ko.ror': # rachunek ror pracownika
                SQL = "SELECT numer_rachunku FROM rs_kp_dane_osobowe_ror WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Pracownik)+"' ORDER BY procent DESC LIMIT 1"
                stat,ror,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':
                    return u'Bd pobierania danych do rachunku ror : '+stat,None
                if len(ror)==1:
                    SWartosci[pole] = str(ror[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(ror[0][0]))
            if pole == 'ko.rorproc': # procent wyplaty odprowadzany na ror pracownika
                SQL = "SELECT sum(procent) FROM rs_kp_dane_osobowe_ror WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Pracownik)+"'"
                stat,ror,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':
                    return u'Bd pobierania procentu do rachunku ror : '+stat,None
                else:
                    SWartosci[pole] = str(ror[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(ror[0][0]))
            if pole == 'ko.rorkwota': # kwota wyplaty odprowadzany na ror pracownika
                SQL = "SELECT sum(kwota) FROM rs_kp_dane_osobowe_ror WHERE firma_id='" + self.firma_id + "' AND pracownik_id='" + str(Pracownik)+"'"
                stat,ror,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':
                    return u'Bd pobierania kwoty do rachunku ror : '+stat,None
                else:
                    SWartosci[pole] = str(ror[0][0])
                    Tresc = Tresc.replace('$$'+pole+'$$', str(ror[0][0]))

            # czlonek rodziny
            if len(LRodzina) > 0:
                if pole == 'abs.pokr': # stopien pokrewienstwa
                    SWartosci[pole] = LRodzina[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',LRodzina[0][0])
                if pole == 'abs.niepelnospr': # stopien niepelnosprawnosci
                    SWartosci[pole] = LRodzina[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$',LRodzina[0][1])
                if pole == 'abs.wiekdzieckalata': # wiek dziecka w latach liczony do daty od absencji
                    dod = str(LRodzina[0][2])
                    if len(Absencja) > 0:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod,str(Absencja[0][1]))[0:4] )
                    else:
                        SWartosci[pole] = int( rs_anakonda_daty.OkresPomiedzy(dod)[0:4] )
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))

            if len(LPrzechodni) > 0:
                if pole == 'abs.przechodni': #
                    if LPrzechodni[0][0]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
            else:
                if pole == 'abs.przechodni': #
                    SWartosci[pole] = 0
                    Tresc = Tresc.replace('$$'+pole+'$$','0')

            if len(LCzasAbsencji) > 0:
                if pole == 'abs.ldniwroku': #
                    SWartosci[pole] = LCzasAbsencji[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'abs.lgodzwroku': #
                    SWartosci[pole] = LCzasAbsencji[0][0] * 8
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'abs.ldnirobwroku': #
                    SWartosci[pole] = LCzasAbsencji[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'abs.lgodzrobwroku': #
                    SWartosci[pole] = LCzasAbsencji[0][2]
                    Tresc = Tresc.replace('$$'+pole+'$$',str(SWartosci[pole]))
                if pole == 'abs.lldniwroku': # slownik do uzycia w funkcji
                    lldniwroku = {}
                    for w in LLCzasAbsencji:
                        lldniwroku[w[0]] = w[1]
                    SWartosci[pole] = lldniwroku
                if pole == 'abs.llgodzwroku': # slownik do uzycia w funkcji
                    llgodzwroku = {}
                    for w in LLCzasAbsencji:
                        llgodzwroku[w[0]] = w[1] * 8
                    SWartosci[pole] = llgodzwroku
                if pole == 'abs.lldnirobwroku': # slownik do uzycia w funkcji
                    lldnirobwroku = {}
                    for w in LLCzasAbsencji:
                        lldnirobwroku[w[0]] = w[2]
                    SWartosci[pole] = lldnirobwroku
                if pole == 'abs.llgodzrobwroku': # slownik do uzycia w funkcji
                    llgodzrobwroku = {}
                    for w in LLCzasAbsencji:
                        llgodzrobwroku[w[0]] = w[3]
                    SWartosci[pole] = llgodzrobwroku
            
            # PPK
            if len(LPPK) > 0:
                if pole == 'koppk.skpracpodst':  # skladka pracownika podstawowa
                    SWartosci[pole] = LPPK[0][0]
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LPPK[0][0]))
                if pole == 'koppk.skpracdodat':  # skladka pracownika dodatkowa
                    SWartosci[pole] = LPPK[0][1]
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LPPK[0][1]))
                if pole == 'koppk.skfirmypodst':  # skladka firmy podstawowa
                    SWartosci[pole] = LPPK[0][2]
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LPPK[0][2]))
                if pole == 'koppk.skfirmydodat':  # skladka firmy dodatkowa
                    SWartosci[pole] = LPPK[0][3]
                    Tresc = Tresc.replace('$$'+pole+'$$', rsstr(LPPK[0][3]))
                if pole == 'koppk.skobnizona':  # skladka obnizona
                    if LPPK[0][4]:
                        SWartosci[pole] = 1
                        Tresc = Tresc.replace('$$'+pole+'$$','1')
                    else:
                        SWartosci[pole] = 0
                        Tresc = Tresc.replace('$$'+pole+'$$','0')
          except:
            return 'Bdy obliczania pola: ' + pole,''
        #else:   # ustawiamy zera na potrzeby oblicze list plac
        #    SWartosci['koppk.skpracpodst'] = 0

#        LPrzechodni = []
#        LCzasAbsencji = []
#        LLCzasAbsencji = []


    if stat == 'OK':
        if TylkoPodajWartosci:
            return 'OK', SWartosci
        else:
            return 'OK', Tresc
    else:
        return stat, ''