# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kursy_walut.py
# Purpose:     obsuga kursw walut
# Author:      Tomasz Romanczuk, gruntowne odwieenie: Jan Kaliszewski
# Created:     2006/12/08
# RCS-ID:      $Id: fs_kursy_walut.py $
# Copyright:   (c) 2006-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Jan Kaliszewski, 2009-10-24 - patrz metryczka powyej (przy okazji #0000254)


#-------------------------------------------------------------------------------
# Funkcja oraz klucze (ich liczba rna dla rnych funkcji) i inne zmienne:

Fun = klucze[-1]
waluta, data, nr_tabeli = klucze[0:3]
if Fun in (3, 5):
    nowe_klucze = klucze[3]
firma_id = self.firma_id

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
# Pomocnicze definicje...

if Fun in (2, 3, 5):
    def _sprawdzWalute(zapytaj, firma_id, waluta):
        u'Sprawd czy w ogle jest w bazie taka waluta.'
        
        if waluta:
            stat, Jest, dump, dump = zapytaj(
                    "SELECT kod FROM rs_waluty"
                    " WHERE firma_id='" + firma_id + "'"
                    " AND kod='" + waluta + "'",
                    3
            )
            if stat != 'OK':
                return ('Bd pobierania danych waluty z bazy '
                        'przy sprawdzaniu ("%s").' % stat)
            elif not Jest:
                return 'BL WAL'
        return 'OK'


if Fun in (3, 5):
    def _dajFiltrPobierania(firma_id, waluta, data, nr_tabeli, nowe_klucze):
        u'Utwrz i zwr filtr pobierania kursw walut.'
        
        filtr = "(firma_id='" + firma_id + "'"
        if waluta:
            filtr += " AND waluta='" + waluta + "'"
        if data != '    -  -  ':
            filtr += " AND (data>='" + data + "')"
        if nr_tabeli:
            filtr += " AND nr_tabeli LIKE '" + nr_tabeli + "%'"
        filtr += ')'
        if nowe_klucze:
            filtr += (
                    " OR ((firma_id='" + firma_id + "') AND ("
                    + " OR ".join(
                            "(waluta='%s' AND data='%s' AND nr_tabeli='%s')"
                            % (waluta, data, nr_tabeli)
                            for waluta, data, nr_tabeli in nowe_klucze)
                    + "))"
            )
        return rsglobal.Dekoduj(filtr)

#-------------------------------------------------------------------------------
# Ustalenie uprawnie:

if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz = UprDod = UprUsuw = True
else:
    UprPrz = (self.oddzial_id,'014011') in self.uprawnienia
    UprDod = (self.oddzial_id,'014013') in self.uprawnienia
    UprUsuw = (self.oddzial_id,'014014') in self.uprawnienia

#-------------------------------------------------------------------------------
#--- DELETE kursw walut: 1
#-------------------------------------------------------------------------------

if Fun == 1 and stat == "OK":
    if UprUsuw:
        if waluta is None:
            # wszystkie waluty
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(
                    "DELETE FROM rs_kursy_walut"
                    " WHERE firma_id='%s' AND data='%s' AND nr_tabeli='%s'"
                    % (firma_id, data, nr_tabeli),
                    1
            )
        else:
            # wybrana waluta
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(
                    "DELETE FROM rs_kursy_walut"
                    " WHERE firma_id='%s' AND waluta='%s'"
                    " AND data='%s' AND nr_tabeli='%s'"
                    % (firma_id, waluta, data, nr_tabeli),
                    1
            )
            if stat != 'OK':
                stat = ('Bd przy usuwaniu z bazy danych '
                        'informacji o kursach walut ("%s").' % stat)
    else:
        stat = 'Brak uprawnie do usuwania kursw walut.'

#-------------------------------------------------------------------------------
#--- INSERT "pustych" kursw walut: 2
#-------------------------------------------------------------------------------

if Fun == 2 and stat == "OK":
    if UprDod:
        
        # sprawdzenie waluty:
        if not waluta:
            stat = 'Brak kodu waluty.'
        elif waluta == 'PLN':
            stat = 'Nie mona dodawa kursw dla waluty PLN.'
        else:
            stat = _sprawdzWalute(self.PolSQL.Execute, firma_id, waluta)
            if stat == 'BL WAL':
                stat = 'Nieprawidowy kod waluty.',
            
        # waciwe dodanie "pustego" notowania waluty:
        if stat == 'OK':
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(
                    "INSERT INTO rs_kursy_walut"
                    " (firma_id, waluta, data, nr_tabeli,"
                    " ilosc_waluty, kurs_sredni, kurs_zakup, kurs_sprzedaz)"
                    " VALUES ('%s','%s','%s','%s','%d','%.4f','%.4f','%.4f')"
                    % (firma_id, waluta, data, nr_tabeli, 1, 0, 0, 0),
                    1
            )
            if stat != 'OK':
                stat = ('Bd przy dodawaniu wpisu ("%s").' % stat.strip())
    else:
        stat = 'Brak uprawnie do dodawania kursw walut.'
        
#-------------------------------------------------------------------------------
#--- SELECT kursw walut: 3
#-------------------------------------------------------------------------------

if Fun == 3 and stat == "OK":
    if UprPrz:
        stat = _sprawdzWalute(self.PolSQL.Execute, firma_id, waluta)
        if stat == 'OK':
            filtr = _dajFiltrPobierania(
                    firma_id, waluta, data, nr_tabeli, nowe_klucze)
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(
                    "SELECT waluta, data, nr_tabeli, ilosc_waluty,"
                    " kurs_sredni, kurs_zakup, kurs_sprzedaz"
                    " FROM rs_kursy_walut"
                    " WHERE " + filtr + " ORDER BY data, nr_tabeli, waluta",
                    2
            )
            if stat != 'OK':
                stat = ('Bd przy pobieraniu z bazy danych '
                        'informacji o kursach walut ("%s").' % stat)
            
    else:
        stat = 'Brak uprawnie do przegldania kursw walut.'
        
#-------------------------------------------------------------------------------
#--- Wygeneruj FILTR kursw walut (bez wykonywania SELECT-a): 5
#-------------------------------------------------------------------------------

if Fun == 5 and stat == "OK":
    if UprPrz:
        stat = _sprawdzWalute(self.PolSQL.Execute, firma_id, waluta)
        if stat == 'OK':
            dane = _dajFiltrPobierania(
                    firma_id, waluta, data, nr_tabeli, nowe_klucze)
    else:
        stat = 'Brak uprawnie do przegldania kursw walut.'
