# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kursy_walut_dane.py
# Purpose:     dodawanie i edycja kursw walut
# Author:      Tomasz Romanczuk, gruntowne odwieenie: Jan Kaliszewski
# Created:     2006/12/15
# RCS-ID:      $Id: fs_kursy_walut_dane.py $
# Copyright:   (c) 2006-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Pawe Wjcikowski, 2009-06-24 - przejscie na funkcje
# Jan Kaliszewski, 2009-10-24 - patrz metryczka powyej (przy okazji #0000254)


from rs_pobieranie_kursow_walut import RekordTabeliKursow

#-------------------------------------------------------------------------------
# Funkcja, klucze i zmienne stanu:

Fun = klucze[-1]
if Fun in (1, 2, 3, 4):
    pola_na_wartosci = dict(zip(pola, wartosci))
        
waluta, data, nr_tabeli = klucze[0:3]
firma_id = self.firma_id

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
# Ustalenie uprawnie:

if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz = UprMod = UprDod = True
else:
    UprPrz = (self.oddzial_id,'014011') in self.uprawnienia
    UprMod = (self.oddzial_id,'014012') in self.uprawnienia
    UprDod = (self.oddzial_id,'014013') in self.uprawnienia

#-------------------------------------------------------------------------------
#--- INSERT: 1 - z pobieraniem, 2 - bez pobierania
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 2):
    if UprDod:
        # sprawdzenie waluty:
        if waluta == 'PLN':
            stat = 'BL WAL PLN'
        else:
            stat, daneW, dump, dump = self.PolSQL.Execute(
                    "SELECT kod FROM rs_waluty"
                    " WHERE firma_id='" + firma_id + "'"
                    " AND kod='" + waluta + "'; ", 3
            )
            if stat != 'OK':
                stat = ('Bd pobierania danych waluty z bazy'
                        ' przy sprawdzaniu: %s' % stat)
            elif not daneW:
                stat = 'BL WAL'
        
        # sprawdzenie czy kurs ju aby nie istnieje:
        if stat == 'OK':
            dump, _dane, dump, dump = self.PolSQL.Execute(
                    "SELECT * FROM rs_kursy_walut"
                    " WHERE firma_id='" + firma_id + "'"
                    " AND waluta='" + waluta + "'"
                    " AND data='" + data + "'"
                    " AND nr_tabeli='" + nr_tabeli + "'",
                    3
            )
            if _dane:
                stat = 'KURS ISTN'

        # sprawdzenie iloci waluty oraz kursw
        if stat == 'OK':
            ilosc_waluty = pola_na_wartosci['ilosc_waluty']
            if not (isinstance(ilosc_waluty, int)
                  and ilosc_waluty in xrange(1, 99999)):
                stat = 'BL ILWAL'
            else:
                pola_bledy = (
                        ('kurs_sredni', 'BL SREDN'),
                        ('kurs_zakup', 'BL ZAKUP'),
                        ('kurs_sprzedaz', 'BL SPRZ'),
                )
                for pole, kod_bledu in pola_bledy:
                    wart = pola_na_wartosci[pole]
                    if not (isinstance(wart, float) and wart >= 0):
                        stat = kod_bledu
                        break
        if stat=='OK' and len(nr_tabeli)>20:
            stat = 'Maksymalna dugo numeru tabeli to 20 znakw'
            
        # waciwy INSERT
        if stat == 'OK':
            pola_str = ','.join(['firma_id'] + pola)
            wartosci_str = ','.join(
                    map(RekordTabeliKursow.formatujWart, [firma_id] + wartosci))
            stat, dump, dump, dump = self.PolSQL.Execute(
                    "INSERT INTO rs_kursy_walut"
                    " (" + pola_str + ") VALUES (" + wartosci_str + ")",
                    1
            )
            if stat != 'OK':
                stat = 'Wystpi bd podczas dodawania danych ("%s").' % stat
    else:
        stat = 'Brak uprawnie do dodawania kursw walut.'

#-------------------------------------------------------------------------------
#--- UPDATE: 3 - z pobieraniem, 4 - bez pobierania
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3, 4):
    if UprMod:
        
        # sprawdzenie iloci waluty oraz kursw
        if stat == 'OK':
            ilosc_waluty = pola_na_wartosci.get('ilosc_waluty')
            if (ilosc_waluty is not None
                  and not (isinstance(ilosc_waluty, int)
                           and ilosc_waluty in xrange(1, 99999))):
                stat = 'BL ILWAL'
            else:
                pola_bledy = (
                        ('kurs_sredni', 'BL SREDN'),
                        ('kurs_zakup', 'BL ZAKUP'),
                        ('kurs_sprzedaz', 'BL SPRZ'),
                )
                for pole, kod_bledu in pola_bledy:
                    wart = pola_na_wartosci.get(pole)
                    if (wart is not None
                          and not (isinstance(wart, float) and wart >= 0)):
                        stat = kod_bledu
                        break
        
        # waciwy UPDATE
        if stat == 'OK':
            pola_wartosci_str = ','.join(
                    map(RekordTabeliKursow.formatujPoleWart, pola, wartosci))
            stat, dump, dump, dump = self.PolSQL.Execute(
                    "UPDATE rs_kursy_walut SET " + pola_wartosci_str + " WHERE"
                    " firma_id='" + firma_id + "'"
                    " AND waluta='" + waluta + "'"
                    " AND data='" + data + "'"
                    " AND nr_tabeli='" + nr_tabeli + "'",
                    1
            )
            if stat != 'OK':
                stat = ('Wystpi bd podczas '
                        'modyfikowania danych ("%s").' % stat)
    else:
        stat = 'Brak uprawnie do edycji kursw walut.'

#-------------------------------------------------------------------------------
#--- SELECT: sam (5) lub po INSERT (1) bd UPDATE (3)
#-------------------------------------------------------------------------------

if Fun in (1, 3, 5) and stat == 'OK':
    if UprPrz:
        stat, dane, wyn1, tr = self.PolSQL.Execute(
                "SELECT * FROM rs_kursy_walut"
                " WHERE firma_id='" + firma_id + "'"
                " AND waluta='" + waluta + "'"
                " AND data='" + data + "'"
                " AND nr_tabeli='" + nr_tabeli + "'",
                3
        )
        if stat != 'OK':
            stat = 'Wystpi bd podczas pobierania danych ("%s").' % stat
    else:
        stat = 'Brak uprawnie do przegldania kursw walut.'
