# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kursy_walut_pobierz.py
# Purpose:     pobieranie kursw walut z Internetu
# Author:      Jan Kaliszewski
# Created:     2009/10/24
# RCS-ID:      $Id: fs_kursy_walut_pobierz.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------


from rs_pobieranie_kursow_walut import dajImporterKursow,       \
                                       dajUtworzImporterKursow, \
                                       RekordTabeliKursow,      \
                                       BladImportuKursowWalut

#-------------------------------------------------------------------------------
# Funkcja i zmienne stanu:

Fun = klucze[-1]
for i, _klucz in enumerate(klucze[:-1]):
    klucze[i] = _klucz.strip()
firma_id = self.firma_id

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
# Definicje wyjtkw

class StatNieOK(Exception):
    u'Wyjtek zgaszany, gdy zwracany stat ma by inny ni "OK".'

    def __init__(self, stat, dane=None):
        self.stat = stat
        if dane is None:
            dane = []
        self.dane = dane


#-------------------------------------------------------------------------------
# Pocztek obsugi stat

try:

#-------------------------------------------------------------------------------
# Sprawdzenie uprawnie
    
    if (self.operator_id != STANDARD_OPERATOR_ID  # czy moe dodawa kursy
          and not (self.oddzial_id, '014013') in self.uprawnienia):
        raise StatNieOK('Brak uprawnie do dodawania kursw walut.')

#-------------------------------------------------------------------------------
#--- SELECT: dla podanego bank_id zwr nazw banku - rda kursw walut
#-------------------------------------------------------------------------------

    if Fun == 1:
        bank_id = klucze[0]
        stat, dane, dump, dump = self.PolSQL.Execute(
                "SELECT bank_nazwa FROM rs_definicje_bankow_w_kursach_walut"
                " WHERE firma_id='" + firma_id + "'"
                " AND bank_id='" + bank_id + "'",
                3
        )
        if stat != 'OK' or not dane:
            raise StatNieOK('Nie udao si okreli nazwy banku.')
            
#-------------------------------------------------------------------------------
#--- SELECT: dla podanego tabela_id zwr nazw tabeli kursw
#-------------------------------------------------------------------------------

    elif Fun == 2:
        bank_id, tabela_id = klucze[0:2]
        stat, dane, dump, dump = self.PolSQL.Execute(
                "SELECT nazwa FROM rs_definicje_bankow_w_kursach_walut_tabele"
                " WHERE firma_id='" + firma_id + "'"
                " AND bank_id='" + bank_id + "'"
                " AND tabela_id='" + tabela_id + "'",
                3
        )
        if stat != 'OK' or not dane:
            raise StatNieOK('Nie udao si okreli nazwy tabeli.')
            
#-------------------------------------------------------------------------------
#--- IMPORT kursw z Internetu:
#--- 3 - z ewentualnym pytaniem, 4 - ponownie bez pytania, 5 - z harmonogramu
#-------------------------------------------------------------------------------

    elif Fun in (3, 4, 5):
        bank_id, tabela_id, podana_data = klucze[0:3]
        if Fun == 5:
            czy_data_z_pliku = klucze[3]  # 'koniecznie' lub 'opcjonalnie' lub ''
        else:
            czy_data_z_pliku = ''

        importer_kursow = dajImporterKursow(bank_id)
        if not importer_kursow:
            # (jeszcze nie utworzono importera dla tego banku)

            #-------------------------------------------------------------------
            # Pobranie z bazy info o banku (wzorzec url, parametry etc.)
            
            stat, _dane, dump, dump = self.PolSQL.Execute(
                    "SELECT wzorzec_url, parametry, format_pliku, struktura_pliku"
                    " FROM rs_definicje_bankow_w_kursach_walut"
                    " WHERE firma_id='" + firma_id + "'"
                    " AND bank_id='" + bank_id + "'",
                    3
            )
            if stat != 'OK':
                raise StatNieOK('Bd przy pobieraniu z bazy danych definicji '
                                'banku - rdle kursw walut (%s).' % stat)
            if not _dane:
                raise StatNieOK('Nie zdefiniowano banku "%s".' % bank_id)

            wzorzec_url, parametry, format_pliku, struktura_pliku = _dane[0]

            #-------------------------------------------------------------------
            # Pobranie z bazy info o wszystkich tabelach kursw dla tego banku
            
            stat, _dane, dump, dump = self.PolSQL.Execute(
                    "SELECT tabela_id, nazwa, alt_wzorzec_url"
                    " FROM rs_definicje_bankow_w_kursach_walut_tabele"
                    " WHERE firma_id='" + firma_id + "'"
                    " AND bank_id='" + bank_id + "'",
                    3
            )
            if stat != 'OK':
                raise StatNieOK('Bd przy pobieraniu z bazy danych definicji '
                                'tabel kursw (%s).' % stat)
            if not _dane:
                raise StatNieOK('Nie zdefiniowano tabel kursw dla banku "%s".'
                                % bank_id)

            tabele = dict((tabela_id, (nazwa, wzorzec))
                          for (tabela_id, nazwa, wzorzec) in _dane)

            #-------------------------------------------------------------------
            # Utworzenie nowego importera

            importer_kursow = dajUtworzImporterKursow(
                    format_pliku, bank_id, wzorzec_url, tabele,
                    struktura_pliku, parametry,
            )

        #-----------------------------------------------------------------------
        # Pobranie z Internetu kursw walut

        # [przy ponownym wywoaniu (a wic przy Fun==4) importer uyje cache'a]
        (waluty_na_rekordy, nr_tabeli, data
        ) = importer_kursow.zaimportuj(tabela_id, podana_data, czy_data_z_pliku)
        pobrane_waluty = set(waluty_na_rekordy.iterkeys())

        #-----------------------------------------------------------------------
        # Pobranie z bazy dostpnych walut (wszystkich oprcz PLN)
        # oraz ewentualnych kursw dla danej daty i numeru tabeli

        stat, _dane_wal, dump, dump = self.PolSQL.Execute(
                "SELECT kod FROM rs_waluty"
                " WHERE firma_id='" + firma_id + "' AND kod <> 'PLN'",
                2
        )
        if stat != 'OK':
            raise StatNieOK('Bd przy pobieraniu z bazy danych '
                            'informacji o walutach ("%s").' % stat)
                            
        znane_waluty = set(wal[0] for wal in _dane_wal)
        if not znane_waluty:
            raise StatNieOK('W systemie nie ma adnych zagranicznych walut '
                            '- najpierw naley je doda.')

        stat, _dane_zajete_wal, dump, dump = self.PolSQL.Execute(
                "SELECT waluta FROM rs_kursy_walut"
                " WHERE firma_id='" + self.firma_id + "' AND data='"
                + data + "' AND nr_tabeli='" + nr_tabeli + "'",
                3
        )
        if stat != 'OK':
            raise StatNieOK('Bd przy pobieraniu z bazy danych '
                            'informacji o kursach walut ("%s").' % stat)
                            
        zajete_waluty = set(wal[0] for wal in _dane_zajete_wal)
        
        #-----------------------------------------------------------------------
        # Przefiltrowanie pobranych kursw pod wzgldem dostpnych walut
        
        wolne_waluty = znane_waluty - zajete_waluty
        if not wolne_waluty:
            raise StatNieOK('Dla podanej daty i numeru tabeli "%s" s ju w'
                            ' systemie wpisy dla wszystkich dostpnych walut.'
                            % nr_tabeli)
        
        pobrane_wolne_waluty = sorted(pobrane_waluty & wolne_waluty)
        if not pobrane_wolne_waluty:
            if zajete_waluty:
                zajete_str = 's ju wpisy dla %s' % ', '.join(sorted(zajete_waluty))
            else:
                zajete_str = 'zagranicznych walut, ktre s w systemie'
            raise StatNieOK('Pobrana tabela kursw "%s" obejmuje nastpujce'
                            ' waluty, dla ktrych kursy nie zostan dodane: %s.'
                            '\nByoby moliwe dodanie kursw dla walut: %s (%s).'
                            % (nr_tabeli,
                               ', '.join(sorted(pobrane_waluty)),
                               ', '.join(sorted(wolne_waluty)),
                               zajete_str))

        #-----------------------------------------------------------------------
        # Ewentualny powrt i pytanie do uytkownika...
        
        pobrane_zajete_waluty = sorted(pobrane_waluty & zajete_waluty)
        if pobrane_zajete_waluty and Fun == 3:
            raise StatNieOK('PYTAJ', dane=(pobrane_wolne_waluty,
                                           pobrane_zajete_waluty,
                                           nr_tabeli))
        
        #-----------------------------------------------------------------------
        # Zapisanie kursw do bazy:

        pola_spoza_rekordow = ['firma_id', 'data', 'nr_tabeli']
        wartosci_spoza_rekordow = map(
                RekordTabeliKursow.formatujWart, [firma_id, data, nr_tabeli])
        spoza_rekordow = dict(zip(pola_spoza_rekordow, wartosci_spoza_rekordow))
        
        zapisane_waluty = []
        bledy = []
        for waluta in pobrane_wolne_waluty:
            rekord = waluty_na_rekordy[waluta]
            pola_na_wartosci = rekord.daj_zawartosc()
            pola_na_wartosci.update(spoza_rekordow)
            pola_str = ','.join(pola_na_wartosci.iterkeys())
            wartosci_str = ','.join(pola_na_wartosci.itervalues())
            stat, dump, dump, dump = self.PolSQL.Execute(
                    "INSERT INTO rs_kursy_walut"
                    " (" + pola_str + ") VALUES (" + wartosci_str + ")",
                    1
            )
            if stat == 'OK':
                zapisane_waluty.append(waluta)
            else:
                bledy.append('Problem przy dodawaniu pobranego'
                             ' z Internetu kursu waluty %s ("%s").'
                             % (waluta, stat))
            
        if bledy:
            if zapisane_waluty:
                bledy.append('(Bez problemw dodano kursy walut: %s)'
                             % ', '.join(zapisane_waluty))
            raise StatNieOK('BL DOD', dane=[zapisane_waluty, nr_tabeli, bledy])

        dane = [zapisane_waluty, nr_tabeli]

#-------------------------------------------------------------------------------

except (BladImportuKursowWalut, StatNieOK), exc:
    stat = exc.stat
    dane = exc.dane

else:
    stat = 'OK'
