# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_lokacje.py
# Purpose:     obsluga grida edytowalnego z list lokacji
# Author:      Pawe Wjcikowski
# Created:     2010/02/04
# RCS-ID:      $Id: fs_lokacje.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-03-24 Mariusz Rajfura - sprawdzenie istnienia lokacji przed INSERT (4404)
# 2015-03-10 Marcin Natkaski - przejcie na sowniki w parametrach (8816)

from funkcje import fs_dokumenty_magazynowe_lokacje_pom

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Lokacja':[10,],'MagazynF':[1,5],'TylkoWolneF':[1,5],'TylkoUzyteF':[1,5],'WszystkieF':[1,5],'LokacjaF':[1,5],
            'OpisF':[1,5],'LokalizacjaF':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_lokacje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        MagazynF=rsglobal.Dekoduj(klucze['MagazynF'])
        TylkoWolneF=rsglobal.Dekoduj(klucze['TylkoWolneF'])
        TylkoUzyteF=rsglobal.Dekoduj(klucze['TylkoUzyteF'])
        WszystkieF=rsglobal.Dekoduj(klucze['WszystkieF'])
        LokacjaF=rsglobal.Dekoduj(klucze['LokacjaF'])
        LokalizacjaF=rsglobal.Dekoduj(klucze['LokalizacjaF'])
        OpisF=rsglobal.Dekoduj(klucze['OpisF'])
    
    if Funkcja in [10,]: 
        Lokacja=rsglobal.Dekoduj(klucze['Lokacja'])

dane = []
wyn1 = []
wyn2 = []
LokacjaID = ''
LKl = []

UprIns=((self.oddzial_id,'014133') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=UprIns or ((self.oddzial_id,'014132') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprDel=((self.oddzial_id,'014134') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#---   POBIERANIE OPISU (10)
#-------------------------------------------------------------------------------

if Funkcja == 10:
    if ((self.oddzial_id,'014000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        sql = "SELECT opis FROM rs_lokacje WHERE firma_id = '"+self.firma_id+"' AND lokacja_id='"+str(Lokacja)+"';"
        stat,DLok,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(DLok)>0:
                dane=[DLok[0][0]]
    else:
        stat='Brak uprawnie do lokacji. Poinformuj administratora.'
        dane.append(stat)

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien do magazynow i ustawienie domyslnego filtra na dozwolone magazyny
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':
    if MagazynF <> '': 
        sql = "SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id LIKE '"+MagazynF+"%';"
        stat,mag,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat == 'Bd pobrania listy magazynw: '+stat
            dane.append(stat)
    DozwMagazyny = ''
    if stat == 'OK' and self.operator_id <> STANDARD_OPERATOR_ID:
        sql ="SELECT magazyn_id FROM rs_magazyny_upr"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        if MagazynF <> '': 
            sql+=" AND magazyn_id LIKE '"+MagazynF+"%'"
        sql+=" AND operator_id IN "+str(self.operatorzy).replace('[','(').replace(']',')')+";"
        stat,dm,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy dozwolonych magazynw: '+stat
            dane.append(stat)
        elif len(dm) == 0:
            stat = 'BR UPR MAGS'
            dane.append(stat)
        elif len(dm) > 0:
            for i in xrange(len(dm)):
                DozwMagazyny += "'"+str(dm[i][0])+"',"
            DozwMagazyny = DozwMagazyny[:-1]

#-------------------------------------------------------------------------------
#---   DELETE (1)
#-------------------------------------------------------------------------------
            
if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        # sprawdzanie DELETE 
        if stat == 'OK':
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_lokacje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['lokacja_id',]:
                        if wart<>'':
                            sql ="SELECT lokacja_id FROM rs_artykuly_przyjecia"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat<>'OK':
                                stat="Bdy przy sprawdzaniu powizania lokacji : "+stat   
                                dane.append(stat)
                            else:
                                if len(d) <> 0:
                                    stat = "Lokacja '"+wart+"' jest wykorzystywana. Usunicie niemoliwe."
                                    dane.append(stat)
                            #lokacja jest w lokalizacjach
                            if stat=='OK':
                                sql2 = "SELECT lokacja_id from rs_lokalizacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+str(wart)+"';"
                                stat,g,dump,dump = self.PolSQL.Execute(sql2,3)
                                if stat<>'OK':
                                    stat="Bdy przy sprawdzaniu powizania lokacji : "+stat   
                                    dane.append(stat)
                                elif len(g) <> 0:
                                    stat = "Niektre usuwane lokacje s ju wykorzystywane w lokalizacjach. Usunicie niemoliwe."
                                    dane.append(stat)
                            if stat=='OK':
                                WHERE += " AND "+pole+"='"+wart+"'"
            if stat == 'OK':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE+WHERE),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)     

#-------------------------------------------------------------------------------
#---   UPDATE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)
        if stat == 'OK':
            WierszeNr = Update[-1]
            
            for i in xrange(len(Update[0])):
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                #nietypowo najpierw klucz bo potrzebujemy lokacji do sprawdzenia pola 'liczba'
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['lokacja_id',]:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                        LokacjaID=rsglobal.Dekoduj(wart)
                        LokacjaPom=rsglobal.Dekoduj(wart)
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'lokacja_id':
                        if wart.strip()=='':
                            stat = 'BR LOKACJA'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip())>10:
                            stat = 'DL LOKACJA'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif not all(c in '1234567890abcdefghijklmnoprstuwxyzq$ABCDEFGHIJKLMNOPRSTUWXYZ-' for c in wart.strip()):
                            stat = 'W indeksie lokacji uyto niedozwolonych znakw. Dozwolone s cyfry i litery bez znakw diakrytycznych'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                        else:
                            LokacjaID=rsglobal.Dekoduj(wart)
                            LokacjaPom=rsglobal.Dekoduj(wart)
                    elif pole == 'magazyn_id':
                        if wart<>'':
                            sql ="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND magazyn_id='"+str(wart)+"' and czy_lokacje"
                            if DozwMagazyny <> '':
                                sql+=" AND magazyn_id IN ("+DozwMagazyny+")"
                            sql+=";" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu magazynu : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny lub nie obsujcy lokacji lub niedozwolony magazyn"
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                    elif pole == 'opis':
                        if len(wart.strip())==0:
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart.strip())>50:
                            stat = 'DL OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)

                    elif pole == 'liczba':
                        if wart < 0:
                            stat = 'BL LICZBA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        elif len(str(int(wart)))>5:
                            stat = 'DL LICZBA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat) 
                        # sprawdzamy czy nie zmniejszamy pojemnoci lokacji poniej jej aktualnego poziomu zapenienia
                        elif wart<>0:
                            SQL="SELECT rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete_dokl')::NUMERIC "
                            SQL+=" FROM rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id='"+LokacjaPom+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu zajtoci lokacji : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdn lokacj :"+LokacjaPom.strip()
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                elif wart < d[0][0]:
                                    stat = "Nie mona zmieni pojemnoci na lokacji "+LokacjaPom.strip()+" na mniejsz ni teraz jest zajta."
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                    
                    elif pole == 'artykul_id':
                        if wart<>'':
                            SQL ="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND artykul_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu artykuu : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny symbol artykuu"
                                    wyn2.append((WierszeNr[i],7))
                                    dane.append(stat)
                                    
                    elif pole == 'kontrahent_id':
                        if wart<>'':
                            SQL ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND kontrahent_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu kontrahenta : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny symbol kontrahenta"
                                    wyn2.append((WierszeNr[i],11))
                                    dane.append(stat)
                                    
                    elif pole == 'kateg_artykulu':
                        if wart<>'':
                            SQL ="SELECT kod FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND kod='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu kategorii artykuu : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny symbol kategorii artykuu"
                                    wyn2.append((WierszeNr[i],8))
                                    dane.append(stat)
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_lokacje "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole in ['lokacja_id', 'opis', 'magazyn_id','artykul_id','kateg_artykulu','kontrahent_id']: 
                            if wart.strip()=='':
                                SET+=pole+"=NULL,"
                            else:
                                SET+=pole+"='"+str(wart).strip()+"',"
                        elif pole in ['liczba']:
                            if wart=='':
                                SET+=pole+"=NULL,"
                            else:
                                SET+=pole+"="+str(wart)+","
                        elif pole in ['stan_minimalny']:
                            if wart=='':
                                SET+=pole+"=0,"
                            else:
                                SET+=pole+"="+wart.strip('%')+","
                    SET=SET.strip(",")
                    WHERE+=";"
                    sql+=UPDATE+SET+WHERE
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat = "Bd przy modyfikowaniu danych: "+stat   
                        dane.append(stat)  
                    else:
                        LKl.append(LokacjaID)
    
#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)
 
        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'lokacja_id':
                        wart = rsglobal.Dekoduj(wart).strip()
                        if wart=='':
                            stat = 'BR LOKACJA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart)>10:
                            stat = 'DL LOKACJA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif not all(c in '1234567890abcdefghijklmnqoprstuwxyz$ABCDEFGHIJKLMNQOPRSTUWXYZ-' for c in wart.strip()):
                            stat = 'W indeksie lokacji uyto niedozwolonych znakw. Dozwolone s cyfry i litery bez znakw diakrytycznych'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                        else:
                            LokacjaID=wart
                            sql ="SELECT lokacja_id FROM rs_lokacje"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND lokacja_id='"+wart+"';"

                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia lokacji: '+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL LOKACJA IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'opis':
                        if len(wart.strip())==0:
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart.strip())>50:
                            stat = 'DL OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)

                    elif pole == 'magazyn_id':
                        if wart<>'':
                            sql ="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND magazyn_id='"+str(wart)+"' and czy_lokacje"
                            if DozwMagazyny <> '':
                                sql+=" AND magazyn_id IN ("+DozwMagazyny+")"
                            sql+=";" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu magazynu : "+stat   
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny lub nie obsujcy lokacji lub niedozwolony magazyn"
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)

                    elif pole == 'liczba':
                        if wart < 0:
                            stat = 'BL LICZBA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        elif len(str(int(wart)))>5:
                            stat = 'DL LICZBA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat) 

                    elif pole == 'artykul_id':
                        if wart<>'':
                            SQL ="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND artykul_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu artykuu : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny symbol artykuu"
                                    wyn2.append((WierszeNr[i],7))
                                    dane.append(stat)
                
                    elif pole == 'kontrahent_id':
                        if wart<>'':
                            SQL ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND kontrahent_id='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu kontrahenta : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny symbol kontrahenta"
                                    wyn2.append((WierszeNr[i],11))
                                    dane.append(stat)
                                    
                    elif pole == 'kateg_artykulu':
                        if wart<>'':
                            SQL ="SELECT kod FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND kod='"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat = "Bdy przy sprawdzaniu kategorii artykuu : "+stat
                                dane.append(stat)
                            else:
                                if len(d) == 0:
                                    stat = "Wprowadzono bdny symbol kategorii artykuu"
                                    wyn2.append((WierszeNr[i],8))
                                    dane.append(stat)


        #czy nie bylo jakis bledow po drodze
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_lokacje "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['lokacja_id','opis','magazyn_id','artykul_id','kateg_artykulu','kontrahent_id']:
                        if str(wart)=='':
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart).strip()+"'"
                    if pole in ['liczba','zajete','do_wydania']:
                        if str(wart)=='':
                            KOLUMNY+=","+pole
                            VALUES+=",0"
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=","+str(wart)
                    if pole in ['stan_minimalny']:
                        if str(wart)=='':
                            KOLUMNY+=","+pole
                            VALUES+=",0"
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=","+wart.strip('%')

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)  
                else:
                    LKl.append(LokacjaID)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete  5-select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':    
    Zajete="rsf_podaj_dane_lokacji(l.firma_id,l.lokacja_id,'zajete')::NUMERIC"
    ZajeteDokl="rsf_podaj_dane_lokacji(l.firma_id,l.lokacja_id,'zajete_dokl')::NUMERIC"
    Filtr = " l.firma_id='"+self.firma_id+"'"
    if DozwMagazyny <> '':
        Filtr += " AND (l.magazyn_id IN ("+DozwMagazyny+") OR l.magazyn_id IS NULL)"
    if MagazynF <> '':
       Filtr += " AND l.magazyn_id like '"+MagazynF+"%'"
    if not WszystkieF:
        if TylkoWolneF:
            Filtr += " AND (l.liczba-"+Zajete+"<>0 OR l.liczba=0)"
        if TylkoUzyteF:
            Filtr += " AND "+Zajete+"<>0"
    if LokacjaF <> '':
        Filtr += " AND l.lokacja_id LIKE '"+LokacjaF+"%'"
    if LokalizacjaF <> '':
        Filtr += " AND lk.lokalizacja_id LIKE '"+LokalizacjaF+"%'"
    if OpisF <> '':
        Filtr += " AND l.opis LIKE '"+OpisF+"%'"
    if len(LKl) > 0:
        LKluczy=[]
        for k in LKl:
            LKluczy.append(rsglobal.Dekoduj(k))
        Filtr += " OR (l.firma_id='"+self.firma_id+"' AND l.lokacja_id in ("+str(LKluczy)[1:-1]+"))"
    SQL ="SELECT TRIM(l.lokacja_id),COALESCE(l.opis,''),COALESCE(l.magazyn_id,''),COALESCE(lk.lokalizacja_id,''),l.liczba,"
    SQL+=Zajete+","+ZajeteDokl+", l.do_wydania, COALESCE(l.artykul_id,''), COALESCE(l.kateg_artykulu,''), l.stan_minimalny::TEXT||'%',TRIM(kontrahent_id) "
    SQL+=" FROM rs_lokacje l LEFT JOIN rs_lokalizacje lk ON (l.firma_id=lk.firma_id AND l.lokacja_id=lk.lokacja_id) "
    SQL+=" WHERE "+Filtr
    SQL+=" ORDER BY l.lokacja_id;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat
        dane.append(stat)