#!/usr/bin/python
# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:			fs_magazyny.py
# Purpose:		dodaje/pobiera/usuwa magazyny
# Author:		Marcin Grzeda
# Created:		2008/23/04
# RCS-ID:		$Id: fs_magazyny.py $
# Copyright:	(c) 2017 RecordSystem
# Licence:		GNU GPL
# -------------------------------------------------------------------------------
# 2011-01-25 Mariusz Rajfura - nowe pole 'czy_przeterminowane' (4227)
# 2017-07-11 Piotr Witkowski    (10622) Okno Magazyny i wybr magazynu do wymiany grida i refaktoryzacji
# 2020-03-13 Mikoaj Kozowski  (11893) Obsuga Kolumny "det." (czy magazyn detaliczny)
# 2020-09-07 Aleksander Bargie (12093) [HD] Spis z natury w handlu
# 2023-11-16 Jan Raburski       (13605) Filtr na magazyn

from funkcje import fs_sprawdz_analityke

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {'Oddzial': [3, 5, 6], 'Opis': [3, 5, 6], 'Magazyn': [3, 6, 8], 'MagazynN': [3, ],
                                                                #AB 07.09.20r
             'OkrojonyWidok': [3, 5, 6], 'CzyLokacje': [3, 5, 6],  'Detal': [3, 5, 6], }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_magazyny z numerem ' + str(Funkcja) + ' bez parametrw: ' + Lista

if stat == 'OK':
    if Funkcja in [3, ]:
        MagazynN = klucze['MagazynN']
    if Funkcja in [3, 6, 8]:
        Magazyn = klucze['Magazyn']
    if Funkcja in [3, 5, 6]:
        MagazynFiltr = klucze['MagazynFiltr']
        Oddzial = klucze['Oddzial']
        Opis = klucze['Opis']
        CzyLokacje = klucze['CzyLokacje']
        OkrojonyWidok = klucze['OkrojonyWidok']
        #AB 07.09.20r
        Detal = klucze['Detal']

if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []

    UprPrz = (((self.oddzial_id, '031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprDod = (((self.oddzial_id, '031013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprMod = (((self.oddzial_id, '031012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDod
    UprDel = (((self.oddzial_id, '031014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprZmianaKlucza = (((self.oddzial_id, '031015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

# -------------------------------------------------------------------------------
# Zmiana klucza - 3
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [3, ]:
    if not UprZmianaKlucza:
        stat = 'UPR UPD'
        dane.append(stat)
    else:
        stat = fs_sprawdz_analityke.CzyMoznaUsunac(self, 'rs_magazyny', Magazyn, '')
        if stat == 'OK':
            Update = "UPDATE rs_magazyny SET magazyn_id = '" + MagazynN + "'"
            Update += " WHERE magazyn_id='" + Magazyn + "' AND firma_id='" + self.firma_id + "'"
            stat, dump, dump, dump = self.PolSQL.Execute(Update, 1)
            if stat != 'OK':
                stat = 'BL UPD'
                dane.append(stat)

# -------------------------------------------------------------------------------
# -- Usuwanie 6 -- #
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [6, ]:
    if not UprDel:
        stat = 'UPR UPD'
        dane.append(stat)
    else:
        stat = fs_sprawdz_analityke.CzyMoznaUsunac(self, 'rs_magazyny', Magazyn, '')
        if stat == 'OK':
            Delete = "DELETE FROM rs_magazyny WHERE magazyn_id='" + Magazyn + "' AND firma_id = '" + self.firma_id + "';"
            stat, dump, dump, dump = self.PolSQL.Execute(Delete, 1)
            if stat != 'OK':
                stat = 'BL DEL'
                dane.append(stat)

# -------------------------------------------------------------------------------
# -- pobieranie
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [3, 5, 6]:
    SELECT = "SELECT magazyn_id,opis,handlowy,brakow,oddzial_id,czy_ceny,czy_lokacje,"
    SELECT += " czy_przeterminowane, detaliczny"  #MK 2020-03-13
    SELECT += " FROM rs_magazyny WHERE firma_id='" + self.firma_id + "'"
    if Oddzial != '':
        SELECT += " AND oddzial_id LIKE '" + Oddzial + "%'"
    if MagazynFiltr != '':
        SELECT += " AND magazyn_id LIKE '" + MagazynFiltr + "%'"
    if Opis != '':
        SELECT += " AND opis LIKE '" + Opis + "%'"
    if CzyLokacje not in ['', False]:
        SELECT += " AND czy_lokacje = '" + str(CzyLokacje) + "'"
    #AB 07.09.20r
    if Detal is not None:
        SELECT += " AND detaliczny = " + str(Detal) + " "

    if OkrojonyWidok and self.operator_id != STANDARD_OPERATOR_ID:
        Select = "SELECT DISTINCT magazyn_id FROM rs_magazyny_upr WHERE firma_id='" + self.firma_id + "'"
        Select += " AND operator_id in " + str(self.operatorzy).replace("[", "(").replace("]", ")") + ";"

        stat, d, dump, dump = self.PolSQL.Execute(Select, 3)
        if stat != 'OK':
            stat = 'BL SEL UPR MAG'
            dane.append(stat)
        else:
            if len(d) > 0:
                ListaMagazynow = "("
                for wiersz in d:
                    ListaMagazynow = ListaMagazynow + "'" + str(wiersz[0]) + "',"
                ListaMagazynow = ListaMagazynow.rstrip(",") + ")"
                SELECT += " AND magazyn_id in " + ListaMagazynow
            else:
                SELECT += " AND FALSE"
    SELECT += " ORDER BY magazyn_id ;"
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK':
        stat = "BL SQL PRZ"
        dane.append(stat)

# -------------------------------------------------------------------------------
# -- sprawdzenie dostpnych magazynw
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [7] and self.operator_id != STANDARD_OPERATOR_ID:
    Select = "SELECT DISTINCT magazyn_id,magazyn_id||'-'||opis FROM rs_magazyny_upr "
    Select += "JOIN rs_magazyny  USING (firma_id,magazyn_id) WHERE firma_id='" + self.firma_id + "'"
    Select += " AND operator_id in " + str(self.operatorzy).replace("[", "(").replace("]", ")") + ";"
    stat, dane, dump, dump = self.PolSQL.Execute(Select, 3)
    if stat != 'OK':
        stat = 'Bdy sprawdzenia dostpnych magazynw.'
        dane.append(stat)

# -------------------------------------------------------------------------------
# -- sprawdzenie dostpnych magazynw dla dowodow dostaw przygodowanie wydan WMS
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 9:
    if self.operator_id != STANDARD_OPERATOR_ID:
        Select = "SELECT DISTINCT magazyn_id,magazyn_id||'-'||opis FROM rs_magazyny_upr "
        Select += "JOIN rs_magazyny  USING (firma_id,magazyn_id) WHERE firma_id='" + self.firma_id + "'"
        Select += " AND czy_lokacje=true "
        Select += " AND operator_id in " + str(self.operatorzy).replace("[", "(").replace("]", ")") + ";"
    else:
        Select = "SELECT DISTINCT magazyn_id,magazyn_id||'-'||opis FROM rs_magazyny "
        Select += " WHERE firma_id='" + self.firma_id + "' AND czy_lokacje=true;"

    stat, dane, dump, dump = self.PolSQL.Execute(Select, 3)
    if stat != 'OK':
        stat = 'Bdy sprawdzenia dostpnych magazynw.'
        dane.append(stat)

# -------------------------------------------------------------------------------
# -- sprawdzenie czy magazyn istnieje
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 8:
    Select = "SELECT 1 FROM rs_magazyny WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "';"
    stat, dane, dump, dump = self.PolSQL.Execute(Select, 3)
    if stat != 'OK':
        stat = 'Bdy sprawdzenia poprawnoci magazynu.'
        dane.append(stat)
