# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_magazyny_dane.py
# Purpose:     dodawanie/edycja danych magazynu
# Author:      Pawe Wojcikowski
# Created:     2009/08/30
# RCS-ID:      $Id: fs_magazyny_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-01-25 Mariusz Rajfura - nowe pole 'czy_przeterminowane' (4227)
# 2020-03-13 Mikoaj Kozowski (11893) Obsuga Checkboxa "det." (czy magazyn detaliczny)
Magazyn = rsglobal.Dekoduj(klucze[0]).strip()

Fun = klucze[-1]
stat = 'OK'
dane = []
wyn2 = []

UprDodawanie=((self.oddzial_id,'031013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'031012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie

#-------------------------------------------------------------------------------
#--- Insert (1,2)
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat="UPR INS"
        dane.append(stat)

    if Magazyn in ('','None',None):
        stat='BR SYMBOL'
        dane.append(stat)
        
    elif Magazyn == '**':
        stat='BL SYMBOL'
        dane.append(stat)
                    
    elif stat=='OK':
        sel="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"
        stat,d,dump,dump=self.PolSQL.Execute(sel,3)
        if stat <> 'OK':
            stat = 'Bdy przy sprawdzaniu symbolu :'+stat
            dane.append(stat)
        elif len(d) > 0:
                stat='SM JEST'
                dane.append(stat)

    if stat == 'OK':
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'opis':
                if wart == '':
                    stat='BR OPIS'
                    dane.append(stat)
                wartosci[i] = "'"+wart+"'"
                
            elif pole == 'oddzial_id':
                if wart == '':
                    stat='BR ODDZIAL'
                    dane.append(stat) 
                else:
                    sql="SELECT oddzial_id,opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bdy przy sprawdzaniu oddzialu :'+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat='BL ODDZIAL'
                        dane.append(stat)
                wartosci[i] = "'"+wart+"'"
            
            elif pole in ('handlowy','brakow','czy_ceny','czy_lokacje','czy_przeterminowane','tylko_pelne_opakowania','jednoraz_art_na_dokum','detaliczny'):  #MK 2020-03-13
                wartosci[i] = str(wart)
                
            # sprawdzenie poprawnoci wpisanego kolejkowania
            elif pole == 'kolejkowanie':
                if wart<>'':
                    from funkcje import fs_kolejkowanie_pom
                    stat,wartk=fs_kolejkowanie_pom.SprawdzPoprawnoscListyKolejkowania(wart)
                    if stat=='OK':
                        wartosci[i]="'"+wartk+"'"
                else:
                    wartosci[i]="''"
            
            
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
   
    if stat=='OK':            
        INSERT = "INSERT INTO rs_magazyny "
        Pola = "firma_id, magazyn_id"
        Wartosci = "'"+self.firma_id+"','"+Magazyn+"'"
        for i in xrange(len(pola)):
            if pola[i] <> 'magazyn_id':
                Pola += ","+pola[i]
                Wartosci+= ","+wartosci[i]
        
        INSERT += "("+Pola+") VALUES ("+Wartosci+");"
                        
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat<>'OK':
            stat = 'Bd dodawania nowego magazynu: '+stat
            dane.append(stat)             

        
#-------------------------------------------------------------------------------
#--- Update (3,4)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat=='OK':
    if not UprEdycja:
        stat="UPR UPD"
    
    if stat == 'OK':
        #blokada magazynu
        sql ="SELECT magazyn_id='"+Magazyn+"' FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o magazynie: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak magazynu o numerze '+Magazyn
            dane.append(stat)
        
    if stat == 'OK':        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]    

            if pole == 'opis':
                if wart == '':
                    stat='BR OPIS'
                    dane.append(stat)
                wartosci[i] = "'"+wart+"'"

            elif pole in ('handlowy','brakow','czy_przeterminowane','tylko_pelne_opakowania','jednoraz_art_na_dokum'):
                wartosci[i] = str(wart)

            elif pole == 'czy_ceny':
                wart = str(wart)
                wartosci[i] = str(wart)
                
                #edytowano pole czy_ceny, trzeba sprawdzic, czy w tym czasie nie pojawily sie dokumenty
                #edycja jest dostepna tylko w pustym magazynie
                sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' LIMIT 1;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia dokumentw w magazynie: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = 'BL DOKUM IST'
                    dane.append(stat)

            elif pole == 'czy_lokacje':
                wart = str(wart)
                wartosci[i] = str(wart)
                
                #edytowano pole czy_lokacje
                #edycja jest dostepna tylko w pustym/wyczyszczonym magazynie

                #czy jakies ilosci na stanie
                sql ="SELECT artykul_id FROM rs_artykuly_magazyny"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
                sql+=" AND ilosc1>0 LIMIT 1;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania informacji o stanach w tym magazynie: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = 'BL STANY IST'
                    dane.append(stat)

                if stat == 'OK':
                    #czy istnieja dokumenty w stanie W,G
                    sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND stan<>'Z'"
                    sql+=" AND (magazyn_skad='"+Magazyn+"' OR magazyn_dokad='"+Magazyn+"')"
                    sql+=" LIMIT 1;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia dokumentw w magazynie: '+stat
                        dane.append(stat)
                    elif len(d) > 0:
                        stat = 'BL DOKUM-WG IST'
                        dane.append(stat)
                        
            # sprawdzenie poprawnoci wpisanego kolejkowania
            elif pole == 'kolejkowanie':
                if wart<>'':
                    from funkcje import fs_kolejkowanie_pom
                    stat,wartk=fs_kolejkowanie_pom.SprawdzPoprawnoscListyKolejkowania(wart)
                    if stat=='OK':
                        wartosci[i]="'"+wartk+"'"
                else:
                    wartosci[i]="''"

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]        

    if stat == 'OK':
        UPDATE = "UPDATE rs_magazyny SET "
        
        for i in range(len(pola)):
            UPDATE += pola[i]+"="+str(wartosci[i])+","
            
        UPDATE = UPDATE[0:-1]
        UPDATE+=" WHERE firma_id ='"+self.firma_id+"' AND magazyn_id = '"+Magazyn+"';"
                       
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE, 1)
        if stat<>'OK':
            stat = 'Bdy modyfikowania danych:'+stat
            dane.append(stat)  

            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    SELECT ="SELECT * FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> "OK":
        stat = "Bd przy pobieraniu danych magazynu: "+stat   
        dane.append(stat)

    if stat == 'OK':
        #informacja o tym, czy w magazynie wystawiono jakis dokumentu
        #od tego zalezy edycja pola czy_ceny
        sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o dokumentach w magazynie: '+stat
        else:
            wyn2.append(len(d))
    
    #informacja o tym, czy magazyn jest pusty
    #od tego zalezy edycja pola czy_lokacje
    if stat == 'OK':
        #czy sa jakies ilosci na stanie
        sql ="SELECT artykul_id FROM rs_artykuly_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND ilosc1>0 LIMIT 1;"
        stat,dStany,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stanach w tym magazynie: '+stat
            
    if stat == 'OK':
        #czy sa jakies dokumenty w stanie W,G
        sql ="SELECT dokument_id FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND stan<>'Z'"
        sql+=" AND (magazyn_skad='"+Magazyn+"' OR magazyn_dokad='"+Magazyn+"')"
        sql+=" LIMIT 1;"
        stat,dDokum,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o dokumentach w magazynie: '+stat

    if stat == 'OK':
        wyn2.append(len(dStany)==0 and len(dDokum)==0) 
