# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_magazyny_parametry_dokumentow.py
# Purpose:     wyswietla, dodaje,usuwa parametry dla dokumentow w magazynie
# Author:      Michal Raburski
# Created:     2011/05/06 (mnie wiecej - opis poprawial mariusz)
# RCS-ID:      $Id: fs_magazyny_parametry_dokumentow.py$
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-06-03 Mariusz Rajfura - wielokrotne definicje dokumentu w magazynie (4638)

# FUNKCJE
#
# 1 - zapis danych
# 5 - pobranie danych

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'MagazynF':[1,5]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_magazyny_parametry_dokumentow z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1,5]:
        Magazyn=rsglobal.Dekoduj(klucze['MagazynF'])

dane = []
DaneI = []

UprModyf=(((self.oddzial_id,'031032') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'031034') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

  
#-------------------------------------------------------------------------------
#-------  USUWANIE
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    
            
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_magazyny_dokumenty_parametry "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['dokument_id','wersje_cenowe','kontrahenci']:
                        WHERE+=" AND "+pole+"=TRIM('"+str(wart.strip())+"')"
                        
                sql+=DELETE+WHERE+";"

            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy usuwaniu danych: "+stat   
                dane.append(stat)        

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprModyf:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)
        
        if stat=='OK':
            # testy - na razie puste
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole== 'dokument_id':
                        if wart.strip()=='':
                            stat='Nie podano dokumentu'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            SQL="SELECT dokument_id FROM rs_typy_dokumentow_m" 
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+rsglobal.Dekoduj(wart)+"';"
                            stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneTest)==0:
                                    stat='Niepoprawny dokument : '+wart
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                    
                    elif pole== 'wersje_cenowe':
                        if wart.strip()<>'':
                            LKodow=wart.split(',')
                            for kod in LKodow:
                                if stat=='OK':
                                    SQL="SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"'"
                                    SQL+=" AND kod='"+rsglobal.Dekoduj(kod)+"'"
                                    stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        if len(DaneTest)==0:
                                            stat='Niepoprawna wersja cenowa : '+kod
                                            wyn2.append((WierszeNr[i],1))
                                            dane.append(stat)
                                    
                    elif pole== 'kontrahenci':
                        if wart.strip()<>'':
                            LKodow=wart.split(',')
                            for kod in LKodow:
                                if stat=='OK':
                                    SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                                    SQL+=" AND kontrahent_id='"+rsglobal.Dekoduj(kod)+"'"
                                    stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        if len(DaneTest)==0:
                                            stat='Niepoprawny kontrahent : '+kod
                                            wyn2.append((WierszeNr[i],2))
                                            dane.append(stat)
                    
                    elif pole== 'lokacja_id':
                        if wart.strip()<>'':
                            SQL="SELECT COALESCE(magazyn_id,'') FROM rs_lokacje WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND lokacja_id='"+rsglobal.Dekoduj(wart)+"'"
                            stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneTest)==0:
                                    stat='Niepoprawna lokacja : '+wart
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)
                                elif not DaneTest[0][0].strip() in ['',Magazyn.strip()]:
                                    stat='Wybrana lokacja nie pasuje do magazynu : '+Magazyn
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)
                        
        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_magazyny_dokumenty_parametry "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=rsglobal.Dekoduj(Update[1][i][j])
                    if pole == 'lokacja_id' and wart == '':
                        SET+=pole+" = NULL,"
                    elif pole =='karta_przyjecia':
                        SET+=pole+"='"+str(wart)+"',"
                    else:
                        SET+=pole+"=TRIM('"+str(wart)+"'),"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id ='"+str(Magazyn)+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND TRIM("+pole+")='"+str(wart).strip()+"' "
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat=u"Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)

                                    
#-------------------------------------------------------------------------------
#--------- INSERT
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if not UprModyf:
        stat='Brak uprawnie do dodawania danych'
        dane.append(stat)
    if stat=='OK':
        WierszeNr = Insert[-1]
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'dokument_id':
                        if wart.strip()=='':
                            stat='Nie podano dokumentu'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            SQL="SELECT dokument_id FROM rs_typy_dokumentow_m" 
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+rsglobal.Dekoduj(wart)+"';"
                            stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneTest)==0:
                                    stat='Niepoprawny dokument : '+wart
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                    
                    elif pole == 'wersje_cenowe':
                        if wart.strip()<>'':
                            LKodow=wart.split(',')
                            for kod in LKodow:
                                if stat=='OK':
                                    SQL="SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"'"
                                    SQL+=" AND kod='"+rsglobal.Dekoduj(kod)+"'"
                                    stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        if len(DaneTest)==0:
                                            stat='Niepoprawna wersja cenowa : '+kod
                                            wyn2.append((WierszeNr[i],1))
                                            dane.append(stat)
                                    
                    elif pole == 'kontrahenci':
                        if wart.strip()<>'':
                            LKodow=wart.split(',')
                            for kod in LKodow:
                                if stat=='OK':
                                    SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                                    SQL+=" AND kontrahent_id='"+rsglobal.Dekoduj(kod)+"'"
                                    stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                                    if stat=='OK':
                                        if len(DaneTest)==0:
                                            stat='Niepoprawny kontrahent : '+kod
                                            wyn2.append((WierszeNr[i],2))
                                            dane.append(stat)
                                            
                    elif pole == 'lokacja_id':
                        if wart.strip()<>'':
                            SQL="SELECT COALESCE(magazyn_id,'') FROM rs_lokacje WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND lokacja_id='"+rsglobal.Dekoduj(wart)+"'"
                            stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneTest)==0:
                                    stat='Niepoprawna lokacja : '+wart
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)
                                elif not DaneTest[0][0].strip() in ['',Magazyn.strip()]:
                                    stat='Wybrana lokacja nie pasuje do magazynu : '+Magazyn
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)

    if stat=='OK':    
        sqlIns=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_magazyny_dokumenty_parametry "
            KOLUMNY="(firma_id,magazyn_id"
            VALUES=" VALUES ('"+self.firma_id+"','"+Magazyn+"'"
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=rsglobal.Dekoduj(Insert[0][i][j])
                KOLUMNY+=","+pole
                if pole == 'lokacja_id' and wart == '':
                    VALUES+=",NULL"
                elif pole == 'karta_przyjecia':
                    VALUES += ",'"+str(wart)+"'"
                else:
                    VALUES+=",TRIM('"+wart.strip()+"')"
            KOLUMNY+=")"
            VALUES+=");"
            sqlIns+=INSERT+KOLUMNY+VALUES
            
        if sqlIns<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
            if stat<>'OK':
                stat=u"Bd przy dodawaniu danych: "+stat   
                dane.append(stat)                   


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in [1,4,5,6] and stat=='OK':
    # pobranie danych 
    SQL="SELECT TRIM(dokument_id),TRIM(wersje_cenowe),TRIM(kontrahenci),TRIM(COALESCE(lokacja_id,'')),karta_przyjecia "
    SQL+="FROM rs_magazyny_dokumenty_parametry "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' "
    SQL+="ORDER BY dokument_id;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat   
        dane.append(stat)        