# -*- coding: ISO8859-2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_menu.py
# Purpose:     edycja uprawnie grupy do funkcji w menu
#
# Author:      Piotr Szydeko
# Created:     2009/02/17
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2021-01-20 Wojciech Skowron - (12258) uprawnienia do modyfikacji daj uprawnienia do przegldania

# klucze: [grupa, "UPR-GR"] -> [wszystkie, udostepnione]
# klucze: [grupa, lista, "USTAW"]

Fun = klucze[-1]

UprMod = ((self.oddzial_id, '001230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprPrz = ((self.oddzial_id, '001240') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

stat = "OK"
dane = []

#---   Pobranie listy uprawnie i uprawnie nadanych grupie
# zwraca [pozycjeMenu, udostepnione]
#   pozycjeMenu: lista z [menu_id, rodzic_id, opis]
#   udostepnione: lista z [menu_id]
if Fun == 'UPR-GR':
    if not UprPrz:
        stat = 'UPR PRZ'

    grupa = klucze[0]
    
    if stat == 'OK':
        stat, pozycjeMenu, none, none = self.PolSQL.Execute("SELECT menu_id, rodzic_id, opis FROM rs_menu ORDER BY rodzic_id, menu_id", 2)
        if stat != "OK":
            stat = "BL SEL POZ"

    if stat == 'OK':
        stat, udostepnione, none, none = self.PolSQL.Execute("SELECT menu_id FROM rs_grupa_menu LEFT JOIN rs_menu USING(menu_id)"
                                   " WHERE grupa_id=%s AND firma_id=%s ORDER BY rs_menu.rodzic_id, menu_id", 2,
                                   (grupa, self.firma_id))
        if stat != "OK":
            stat = "BL SEL DOS"

    if stat == 'OK':
        dane = [pozycjeMenu, udostepnione]


#---   Ustawienie uprawnie
elif Fun == 'USTAW':
    if not UprMod:
        stat = 'UPR MOD'
        
    grupa = klucze[0]
    lista = klucze[1]
    lista.insert(0, self.firma_id)
    lista.insert(1, grupa)

    if stat == 'OK':
        stat, none, none, none = self.PolSQL.Execute("SELECT rsf_ustaw_uprawnienia(%s)", 1, [str(lista)])
        if stat != 'OK':
            stat = 'BL UST:%s' % stat

    if stat =='OK':
        SQL = "INSERT INTO rs_rodo_dziennik_anakonda (firma_id, zmieniona_grupa, zmieniony_operator,"
        SQL += "opis) VALUES('" + self.firma_id + "','" + grupa + "',NULL,'Zmieniono menu dla grupy: " + grupa + "');"
        stat, none, none, none = self.PolSQL.Execute(SQL,1)
        if stat != 'OK':
            stat = 'BLAD INSERTU DO DZIENNIKA RODO: %s' % stat

else:
    stat = 'BL FUN'
