# -*- coding: iso8859_2 -*-

# -------------------------------------------------------------------------------
# Name:        fs_obroty_wyszukiwanie.py
# Purpose:     grid obrotow z dok.magaz lub stanow biez z uwzgl.lokacji
#
# Author:      Mariusz Rajfura
# Created:     2010/02/25
# RCS-ID:      $Id: fs_obroty_wyszukiwanie.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2016-10-11 Piotr Witkowski (10039) przejcie na nowego grida
# 2017-10-02 Piotr Witkowski (10665) [MG] Obroty/wyszukiwanie - dodatkowe kolumny
# 2018-12-06 Aleksander Bargie (11309) [MG] Zwielokrotnione pozycje w oknie Obroty magazynowe/wyszukiwanie

# klucz[0][...] = wspolny filtr dotyczacy calego grida
# klucz[1][...] = filtr dotyczacy obrotow
# klucz[2][...] = filtr dotyczacy wyszukiwania

MagazynOdF = rsglobal.Dekoduj(klucze[0][0]).strip()
MagazynDoF = rsglobal.Dekoduj(klucze[0][1]).strip()
KategoriaOdF = rsglobal.Dekoduj(klucze[0][2]).strip()
KategoriaDoF = rsglobal.Dekoduj(klucze[0][3]).strip()
ArtykulOdF = rsglobal.Dekoduj(klucze[0][4]).strip()
ArtykulDoF = rsglobal.Dekoduj(klucze[0][5]).strip()

CBTerminPrzydF = rsglobal.Dekoduj(klucze[0][6])
TerminPrzydOdF = rsglobal.Dekoduj(klucze[0][7])
TerminPrzydDoF = rsglobal.Dekoduj(klucze[0][8])

CBNrSeriiF = rsglobal.Dekoduj(klucze[0][9])
NrSeriiOdF = rsglobal.Dekoduj(klucze[0][10]).strip()
NrSeriiDoF = rsglobal.Dekoduj(klucze[0][11]).strip()

CBCecha1OpisF = rsglobal.Dekoduj(klucze[0][12])
Cecha1OpisF = rsglobal.Dekoduj(klucze[0][13]).strip()

CBCecha1WartoscF = rsglobal.Dekoduj(klucze[0][14])
Cecha1WartoscOdF = rsglobal.Dekoduj(klucze[0][15]).strip()
Cecha1WartoscDoF = rsglobal.Dekoduj(klucze[0][16]).strip()

CBDokumentF = rsglobal.Dekoduj(klucze[0][17])
DokumentF = rsglobal.Dekoduj(klucze[0][18]).strip()

CBPaletaF = rsglobal.Dekoduj(klucze[0][19])
PaletaOdF = rsglobal.Dekoduj(klucze[0][20]).strip()
PaletaDoF = rsglobal.Dekoduj(klucze[0][21]).strip()

DataOdF = rsglobal.Dekoduj(klucze[1][0])
DataDoF = rsglobal.Dekoduj(klucze[1][1])
NiezeroweF = rsglobal.Dekoduj(klucze[1][2])
ProduktF = rsglobal.Dekoduj(klucze[1][3])

CBLokacjaF = rsglobal.Dekoduj(klucze[2][0])
LokacjaOdF = rsglobal.Dekoduj(klucze[2][1]).strip()
LokacjaDoF = rsglobal.Dekoduj(klucze[2][2]).strip()

DostepneF = klucze[2][3]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

# -------------------------------------------------------------------------------
# sprawdzenie uprawnien do magazynow
# przy okazji sprawdzimy istnienie magazynow, aby niepotrzebnie nie przeszukiwac bazy
# -------------------------------------------------------------------------------

if MagazynOdF <> '' or MagazynDoF <> '':
    sql = "SELECT magazyn_id FROM rs_magazyny WHERE firma_id='" + self.firma_id + "'"
    if MagazynOdF <> '':
        sql += "AND magazyn_id >= '" + MagazynOdF + "'"
    if MagazynDoF <> '':
        sql += "AND magazyn_id <= '" + MagazynDoF + "'"
    sql += ";"

    stat, mag, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy magazynw: ' + stat
    elif len(mag) == 0:
        stat = 'BL_MAGAZYNY_ZAKRES'

DozwMagazyny = ''
if stat == 'OK' and self.operator_id <> STANDARD_OPERATOR_ID:
    sql = "SELECT magazyn_id FROM rs_magazyny_upr"
    sql += " WHERE firma_id='" + self.firma_id + "'"
    if MagazynOdF <> '':
        sql += " AND magazyn_id >= '" + MagazynOdF + "'"

    if MagazynDoF <> '':
        sql += " AND magazyn_id <= '" + MagazynDoF + "'"

    sql += " AND operator_id IN " + str(self.operatorzy).replace('[', '(').replace(']', ')') + ";"
    stat, dm, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy dozwolonych magazynw: ' + stat
    elif len(dm) == 0:
        stat = 'BR_DOZW_MAG'
    else:
        for i in xrange(len(dm)):
            DozwMagazyny += "'" + str(dm[i][0]) + "',"
        DozwMagazyny = DozwMagazyny[:-1]

# -------------------------------------------------------------------------------
# obroty z wyczonym dokumentem - 1
# -------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if DataOdF == '    -  -  ':
        dane.append('BR_DATAOD')
    elif not rsglobal.SprawdzCzyToData(DataOdF):
        dane.append('BL_DATAOD')

    if DataDoF == '    -  -  ':
        dane.append('BR_DATADO')
    elif not rsglobal.SprawdzCzyToData(DataOdF):
        dane.append('BL_DATADO')

    if len(dane) == 0:
        if DataOdF > DataDoF:
            dane.append('BL_DATAOD_DO')

    # jesli byly jakies bledy
    if len(dane) > 0:
        stat = dane[0]

    if stat == 'OK':
        sql = "SELECT a.kateg_artykulu, om.artykul_id, a.nazwa, COALESCE(a.jm1,''), COALESCE(a.jm2,''),"
        sql += " SUM( CASE WHEN om.data<'" + DataOdF + "' THEN om.ilosc1*om.typ_znak ELSE 0 END) AS il_pocz1,"
        sql += " SUM( CASE WHEN om.data<'" + DataOdF + "' THEN om.ilosc2*om.typ_znak ELSE 0 END) AS il_pocz2,"
        sql += " SUM( CASE WHEN om.data<'" + DataOdF + "' THEN om.ilosc1*om.cena1*om.typ_znak ELSE 0 END) AS wa_pocz,"
        sql += " SUM( CASE WHEN om.data>='" + DataOdF + "' AND om.data<='" + DataDoF + "' THEN om.ilosc1*om.typ_znak ELSE 0 END) AS il_okr1,"
        sql += " SUM( CASE WHEN om.data>='" + DataOdF + "' AND om.data<='" + DataDoF + "' THEN om.ilosc2*om.typ_znak ELSE 0 END) AS il_okr2,"
        sql += " SUM( CASE WHEN om.data>='" + DataOdF + "' AND om.data<='" + DataDoF + "' THEN om.ilosc1*om.cena1*om.typ_znak ELSE 0 END) AS wa_okr,"
        sql += " SUM( CASE WHEN om.data<='" + DataDoF + "' THEN om.ilosc1*om.typ_znak ELSE 0 END) AS il_konc1,"
        sql += " SUM( CASE WHEN om.data<='" + DataDoF + "' THEN om.ilosc2*om.typ_znak ELSE 0 END) AS il_konc2,"
        sql += " SUM( CASE WHEN om.data<='" + DataDoF + "' THEN om.ilosc1*om.cena1*om.typ_znak ELSE 0 END) AS wa_konc"

        if CBTerminPrzydF:
            sql += " ,COALESCE(om.termin_przyd::TEXT,''::TEXT)"
        else:
            sql += " ,''"

        if CBNrSeriiF:
            sql += " ,COALESCE(om.nr_serii,''::TEXT)"
        else:
            sql += " ,''"

        if CBCecha1OpisF:
            sql += " ,COALESCE(om.cecha1_opis,''::TEXT)"
        else:
            sql += " ,''"

        if CBCecha1WartoscF:
            sql += ", COALESCE(om.cecha1_wartosc,''::TEXT)"
        else:
            sql += " ,''"

        if CBDokumentF:
            sql += " ,rsf_podaj_numer_dokumentu_na_wydruk('" + self.firma_id + "'"
            sql += "    ,'[\"'||om.magazyn_id||'\",\"'||om.dokument_id||'\",\"'||om.data||"
            sql += "     '\",\"'||om.numer||'\"]','M') AS dokument"
        else:
            sql += " ,''"

        if CBPaletaF:
            sql += " ,COALESCE(pp.nr_palety_id,''::TEXT)"
        else:
            sql += " ,''"

        sql += " FROM rs_obroty_magazynowe om"
        sql += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        sql += " LEFT JOIN rs_dokumenty_magazynowe_pozycje_palety pp ON om.firma_id=pp.firma_id AND om.dokument_id=pp.dokument_id AND om.data=pp.data ANd om.numer=pp.numer "
        sql += " WHERE om.firma_id='" + self.firma_id + "' "

        if DozwMagazyny <> '':
            sql += " AND om.magazyn_id IN (" + DozwMagazyny + ")"

        if MagazynOdF <> '':
            sql += " AND om.magazyn_id >= '" + MagazynOdF + "'"
        if MagazynDoF <> '':
            sql += " AND om.magazyn_id <= '" + MagazynDoF + "'"

        if KategoriaOdF <> '':
            sql += " AND a.kateg_artykulu >= '" + KategoriaOdF + "'"
        if KategoriaDoF <> '':
            sql += " AND a.kateg_artykulu <= '" + KategoriaDoF + "'"

        if ArtykulOdF <> '':
            sql += " AND om.artykul_id >= '" + ArtykulOdF + "'"
        if ArtykulDoF <> '':
            sql += " AND om.artykul_id <= '" + ArtykulDoF + "'"

        if TerminPrzydOdF <> '    -  -  ':
            sql += " AND om.termin_przyd >= '" + TerminPrzydOdF + "'"
        if TerminPrzydDoF <> '    -  -  ':
            sql += " AND (om.termin_przyd <= '" + TerminPrzydDoF + "' OR om.termin_przyd IS NULL)"

        if NrSeriiOdF <> '':
            sql += " AND om.nr_serii >= '" + NrSeriiOdF + "'"
        if NrSeriiDoF <> '':
            sql += " AND (om.nr_serii <= '" + NrSeriiDoF + "' OR om.nr_serii IS NULL)"

        if PaletaOdF <> '':
            sql += " AND trim(pp.nr_palety_id)>='" + PaletaOdF + "'"
        if PaletaDoF <> '':
            sql += " AND (trim(pp.nr_palety_id)<='" + PaletaDoF + "' OR pp.nr_palety_id IS NULL)"

        if Cecha1OpisF <> '':
            sql += " AND om.cecha1_opis = '" + Cecha1OpisF + "'"

        if Cecha1WartoscOdF <> '':
            if Cecha1WartoscDoF == '' and ('_' in Cecha1WartoscOdF or '%' in Cecha1WartoscOdF):
                if not '%' in Cecha1WartoscOdF:
                    Cecha1WartoscOdF = Cecha1WartoscOdF + '%'
                sql += " AND UPPER(om.cecha1_wartosc) LIKE UPPER('" + Cecha1WartoscOdF + "')"
            else:
                sql += " AND om.cecha1_wartosc >= '" + Cecha1WartoscOdF + "'"

        if Cecha1WartoscDoF <> '':
            if Cecha1WartoscOdF == '' and ('_' in Cecha1WartoscDoF or '%' in Cecha1WartoscDoF):
                if not '%' in Cecha1WartoscDoF:
                    Cecha1WartoscDoF = Cecha1WartoscDoF + '%'
                sql += " AND UPPER(om.cecha1_wartosc) LIKE UPPER('" + Cecha1WartoscDoF + "')"
            else:
                sql += " AND (om.cecha1_wartosc <= '" + Cecha1WartoscDoF + "' OR om.cecha1_wartosc IS NULL)"

        if ProduktF <> '':
            sql += " AND om.produkt_id LIKE '" + ProduktF + "%'"

        if CBDokumentF and DokumentF <> '':
            sql += " AND om.dokument_id = '" + DokumentF + "'"

        sql += " GROUP BY a.kateg_artykulu, om.artykul_id, a.nazwa, a.jm1, a.jm2"

        if CBTerminPrzydF:
            sql += " ,om.termin_przyd"

        if CBNrSeriiF:
            sql += " ,om.nr_serii"

        if CBPaletaF:
            sql += " ,pp.nr_palety_id"

        if CBCecha1OpisF:
            sql += " ,om.cecha1_opis"

        if CBCecha1WartoscF:
            sql += ", om.cecha1_wartosc"

        if CBDokumentF:
            sql += ",dokument"

        if NiezeroweF:
            sql += " HAVING ("
            sql += " (SUM( CASE WHEN om.data<'" + DataOdF + "' THEN om.ilosc1*om.typ_znak ELSE 0 END)<>0) OR"
            sql += " (SUM( CASE WHEN om.data<'" + DataOdF + "' THEN om.ilosc1*om.cena1*om.typ_znak ELSE 0 END)<>0) OR"
            sql += " (SUM( CASE WHEN om.data>='" + DataOdF + "' AND om.data<='" + DataDoF + "' THEN om.ilosc1*om.typ_znak ELSE 0 END)<>0) OR"
            sql += " (SUM( CASE WHEN om.data>='" + DataOdF + "' AND om.data<='" + DataDoF + "' THEN om.ilosc1*om.cena1*om.typ_znak ELSE 0 END)<>0) OR"
            sql += " (SUM( CASE WHEN om.data<='" + DataDoF + "' THEN om.ilosc1*om.typ_znak ELSE 0 END)<>0) OR"
            sql += " (SUM( CASE WHEN om.data<='" + DataDoF + "' THEN om.ilosc1*om.cena1*om.typ_znak ELSE 0 END)<>0))"

        sql += " ORDER BY a.kateg_artykulu, om.artykul_id;"
        stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z obrotw magazynowych dla funkcji 1: ' + stat

# -------------------------------------------------------------------------------
# Wyszukiwanie - 2
# -------------------------------------------------------------------------------

if Fun == 2 and stat == 'OK':
    sql = "SELECT ap.magazyn_id,"

    if CBLokacjaF:
        sql += " COALESCE(ap.lokacja_id,''::TEXT),"
    else:
        sql += " '',"

    sql += " ap.artykul_id, a.nazwa,"
    sql += " COALESCE(a.jm1,''::TEXT), COALESCE(a.jm2,''::TEXT),"
    sql += " SUM(ap.ilosc1), SUM(ap.rezerwacja1), SUM(ap.ilosc1-ap.rezerwacja1),"
    sql += " SUM(ap.ilosc2), SUM(ap.rezerwacja2), SUM(ap.ilosc2-ap.rezerwacja2)"

    if CBTerminPrzydF:
        sql += " ,COALESCE(ap.termin_przyd::TEXT,''::TEXT)"
    else:
        sql += " ,''"

    if CBNrSeriiF:
        sql += " ,COALESCE(ap.nr_serii,''::TEXT)"
    else:
        sql += " ,''"

    if CBCecha1OpisF:
        sql += " ,COALESCE(ap.cecha1_opis,''::TEXT)"
    else:
        sql += " ,''"

    if CBCecha1WartoscF:
        sql += ", COALESCE(ap.cecha1_wartosc,''::TEXT)"
    else:
        sql += " ,''"

    if CBDokumentF:
        sql += " ,rsf_podaj_numer_dokumentu_na_wydruk('" + self.firma_id + "'"
        sql += "    ,'[\"'||ap.magazyn_id||'\",\"'||ap.dokument_id||'\",\"'||ap.data||"
        sql += "     '\",\"'||ap.numer||'\"]','M') AS dokument"
    else:
        sql += " ,''"

    if CBPaletaF:
        sql += " ,COALESCE(pp.nr_palety_id,''::TEXT)"
    else:
        sql += " ,''"

    sql += " FROM rs_artykuly_przyjecia ap"
    sql += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    sql += "LEFT JOIN rs_dokumenty_magazynowe_pozycje_palety pp ON ap.firma_id=pp.firma_id "
    sql += "AND ap.dokument_id=pp.dokument_id AND ap.data=pp.data AND ap.numer=pp.numer "
    sql += "AND ap.nr_poz=pp.nr_poz AND ap.nr_ppoz=pp.nr_ppoz "
    sql += " WHERE ap.firma_id='" + self.firma_id + "' AND ap.ilosc1>0 AND NOT ap.wirtualne"

    if DozwMagazyny <> '':
        sql += " AND ap.magazyn_id IN (" + DozwMagazyny + ")"

    if MagazynOdF <> '':
        sql += " AND ap.magazyn_id >= '" + MagazynOdF + "'"
    if MagazynDoF <> '':
        sql += " AND ap.magazyn_id <= '" + MagazynDoF + "'"

    if KategoriaOdF <> '':
        sql += " AND a.kateg_artykulu >= '" + KategoriaOdF + "'"
    if KategoriaDoF <> '':
        sql += " AND a.kateg_artykulu <= '" + KategoriaDoF + "'"

    if ArtykulOdF <> '':
        sql += " AND ap.artykul_id >= '" + ArtykulOdF + "'"
    if ArtykulDoF <> '':
        sql += " AND ap.artykul_id <= '" + ArtykulDoF + "'"

    if CBNrSeriiF:
        if NrSeriiOdF <> '':
            sql += " AND ap.nr_serii >= '" + NrSeriiOdF + "'"
        if NrSeriiDoF <> '':
            sql += " AND (ap.nr_serii <= '" + NrSeriiDoF + "' OR ap.nr_serii IS NULL)"

    if CBTerminPrzydF:
        if TerminPrzydOdF <> '    -  -  ':
            sql += " AND ap.termin_przyd >= '" + TerminPrzydOdF + "'"
        if TerminPrzydDoF <> '    -  -  ':
            sql += " AND (ap.termin_przyd <= '" + TerminPrzydDoF + "' OR termin_przyd IS NULL)"

    if CBPaletaF:
        if PaletaOdF.strip() <> '':
            sql += " AND trim(pp.nr_palety_id)>='" + PaletaOdF + "'"
        if PaletaDoF.strip() <> '':
            sql += " AND (trim(pp.nr_palety_id)<='" + PaletaOdF + "' OR termin_przyd IS NULL)"

    if CBCecha1OpisF and Cecha1OpisF <> '':
        sql += " AND ap.cecha1_opis = '" + Cecha1OpisF + "'"

    if CBCecha1WartoscF:
        if Cecha1WartoscOdF <> '':
            if Cecha1WartoscDoF == '' and ('_' in Cecha1WartoscOdF or '%' in Cecha1WartoscOdF):
                if not '%' in Cecha1WartoscOdF:
                    Cecha1WartoscOdF = Cecha1WartoscOdF + '%'
                sql += " AND UPPER(ap.cecha1_wartosc) LIKE UPPER('" + Cecha1WartoscOdF + "')"
            else:
                sql += " AND ap.cecha1_wartosc >= '" + Cecha1WartoscOdF + "'"
        if Cecha1WartoscDoF <> '':
            if Cecha1WartoscOdF == '' and ('_' in Cecha1WartoscDoF or '%' in Cecha1WartoscDoF):
                if not '%' in Cecha1WartoscDoF:
                    Cecha1WartoscDoF = Cecha1WartoscDoF + '%'
                sql += " AND UPPER(ap.cecha1_wartosc) LIKE UPPER('" + Cecha1WartoscDoF + "')"
            else:
                sql += " AND (ap.cecha1_wartosc <= '" + Cecha1WartoscDoF + "' OR ap.cecha1_wartosc IS NULL)"

    if CBLokacjaF:
        if LokacjaOdF <> '':
            sql += " AND ap.lokacja_id >= '" + LokacjaOdF + "'"

        if LokacjaDoF <> '':
            # jesli podano LOKACJE_DO, to dopisuje do filtru takze warunek
            # aby wyswietlily sie artykuly z pustymi lokacjami, gdyz
            # pusta lokacja jest mniejsza od dowolnej, podanej.
            sql += " AND (ap.lokacja_id <= '" + LokacjaDoF + "' OR ap.lokacja_id IS NULL)"

    if DostepneF:
        sql += " AND ap.ilosc1-ap.rezerwacja1>0"

    if CBDokumentF and DokumentF <> '':
        sql += " AND ap.dokument_id = '" + DokumentF + "'"

    # GROUP BY
    sql += " GROUP BY ap.magazyn_id,"
    if CBLokacjaF:
        sql += " ap.lokacja_id,"
    sql += " ap.artykul_id, a.nazwa, a.jm1, a.jm2"

    if CBTerminPrzydF:
        sql += " ,ap.termin_przyd"

    if CBNrSeriiF:
        sql += " ,ap.nr_serii"

    if CBCecha1OpisF:
        sql += " ,ap.cecha1_opis"

    if CBCecha1WartoscF:
        sql += ", ap.cecha1_wartosc"

    if CBDokumentF:
        sql += ",dokument"

    if CBPaletaF:
        sql += " ,pp.nr_palety_id"

    # ORDER BY
    sql += " ORDER BY ap.magazyn_id,"
    if CBLokacjaF:
        sql += " ap.lokacja_id,"
    sql += " ap.artykul_id, a.nazwa;"
    stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)

    if stat <> 'OK':
        stat = 'Bd pobrania danych dla wyszukiwania: ' + stat

# -------------------------------------------------------------------------------
# obroty z wczonym dokumentem - 3
# -------------------------------------------------------------------------------

if Fun == 3 and stat == 'OK':
    if DataOdF == '    -  -  ':
        dane.append('BR_DATAOD')
    elif not rsglobal.SprawdzCzyToData(DataOdF):
        dane.append('BL_DATAOD')

    if DataDoF == '    -  -  ':
        dane.append('BR_DATADO')
    elif not rsglobal.SprawdzCzyToData(DataOdF):
        dane.append('BL_DATADO')

    if len(dane) == 0:
        if DataOdF > DataDoF:
            dane.append('BL_DATAOD_DO')

    # jesli byly jakies bledy
    if len(dane) > 0:
        stat = dane[0]

    if stat == 'OK':
        sql = "SELECT om.data, om.dokument_id, om.numer, om.kontrahent_id, om.nr_faktury, om.nr_poz||'/'||om.nr_ppoz,"  # 1-6
        sql += "om.artykul_id,om.cena1, COALESCE(a.jm1,''),"  # 7-9
        sql += " SUM(CASE WHEN typ_znak=1 THEN om.ilosc1 ELSE 0 END) AS il_przych,"
        sql += " SUM(CASE WHEN typ_znak=1 THEN ROUND(om.ilosc1*cena1,2) ELSE 0 END) AS wart_przych,"
        sql += " SUM(CASE WHEN typ_znak=-1 THEN om.ilosc1 ELSE 0 END) AS il_rozch,"
        sql += " SUM(CASE WHEN typ_znak=-1 THEN ROUND(om.ilosc1*cena1,2) ELSE 0 END) AS wart_rozch"
        sql += ",om.termin_przyd, om.nr_serii, pp.nr_palety_id "
        sql += " FROM rs_obroty_magazynowe om"
        sql += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        #AB 6.12.18r
        sql += " LEFT JOIN rs_dokumenty_magazynowe_pozycje_palety pp USING(firma_id, dokument_id, data, numer, nr_poz, nr_ppoz)"
        sql += " WHERE om.firma_id='" + self.firma_id + "' AND om.data>='" + DataOdF + "' AND om.data<='" + DataDoF + "'"

        if DozwMagazyny <> '':
            sql += " AND om.magazyn_id IN (" + DozwMagazyny + ")"

        if MagazynOdF <> '':
            sql += " AND om.magazyn_id >= '" + MagazynOdF + "'"
        if MagazynDoF <> '':
            sql += " AND om.magazyn_id <= '" + MagazynDoF + "'"

        if KategoriaOdF <> '':
            sql += " AND a.kateg_artykulu >= '" + KategoriaOdF + "'"
        if KategoriaDoF <> '':
            sql += " AND a.kateg_artykulu <= '" + KategoriaDoF + "'"

        if ArtykulOdF <> '':
            sql += " AND om.artykul_id >= '" + ArtykulOdF + "'"
        if ArtykulDoF <> '':
            sql += " AND om.artykul_id <= '" + ArtykulDoF + "'"

        if TerminPrzydOdF <> '    -  -  ':
            sql += " AND om.termin_przyd >= '" + TerminPrzydOdF + "'"
        if TerminPrzydDoF <> '    -  -  ':
            sql += " AND (om.termin_przyd <= '" + TerminPrzydDoF + "' OR om.termin_przyd IS NULL)"

        if NrSeriiOdF <> '':
            sql += " AND om.nr_serii >= '" + NrSeriiOdF + "'"
        if NrSeriiDoF <> '':
            sql += " AND (om.nr_serii <= '" + NrSeriiDoF + "' OR om.nr_serii IS NULL)"

        if PaletaOdF <> '':
            sql += " AND trim(pp.nr_palety_id)>='" + str(PaletaOdF) + "'"
        if PaletaDoF <> '':
            sql += " AND (trim(pp.nr_palety_id)<='" + str(PaletaDoF) + "' OR om.termin_przyd IS NULL)"

        if Cecha1OpisF <> '':
            sql += " AND om.cecha1_opis = '" + Cecha1OpisF + "'"

        if Cecha1WartoscOdF <> '':
            sql += " AND om.cecha1_wartosc >= '" + Cecha1WartoscOdF + "'"
        if Cecha1WartoscDoF <> '':
            sql += " AND (om.cecha1_wartosc <= '" + Cecha1WartoscDoF + "' OR om.cecha1_wartosc IS NULL)"

        if ProduktF <> '':
            sql += " AND om.produkt_id LIKE '" + ProduktF + "%'"

        if CBDokumentF and DokumentF <> '':
            sql += " AND om.dokument_id = '" + DokumentF + "'"

        sql += " GROUP BY om.data, om.dokument_id, om.numer, om.kontrahent_id, om.nr_faktury,"
        sql += " om.nr_poz||'/'||om.nr_ppoz,om.artykul_id,om.cena1, COALESCE(a.jm1,'')"
        sql += " ,om.termin_przyd, om.nr_serii,pp.nr_palety_id"

        if NiezeroweF:
            sql += " HAVING ("
            sql += " (SUM(CASE WHEN typ_znak=1 THEN om.ilosc1 ELSE 0 END)<>0) OR"
            sql += " (SUM(CASE WHEN typ_znak=-1 THEN om.ilosc1 ELSE 0 END)<>0))"

        sql += " ORDER BY om.data, om.dokument_id, om.numer;"
        stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z obrotw magazynowych dla funkcji 3 : ' + stat
