# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_oddzialy_dane.py
# Purpose:      
# Author:      mr
# Created:     2009/03/27
# RCS-ID:      $Id: fs_oddzialy_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2016-06-20 Piotr Witkowski (6892) Opcja "czy podatnik UE w danych oddziau
# 2018-01-17 Aleksander Bargie (9546) Usunicie nadmiarowych wci i zmiana kodowania z UTF-8 na iso 8859-2
# 2018-01-23 Aleksander Bargie (10899) W pobieraniu danych o urzdzie skarbowym dodanie filtru na firm
# 2020-01-14 Wojciech Skowron   (11814) Obsuga checkboxa centrala
# 2021-12-03 Bartosz Pagan   - (12755) Dodanie kontrolki KasaSprzedaz

Symbol = klucze[0].strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

UprDodawanie = ((self.oddzial_id,'001130') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
if UprDodawanie:
    UprEdytowanie = True
else:    
    UprEdytowanie = ((self.oddzial_id,'001110') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))


# sprawdzenie danych


if stat=='OK':
    if len(Symbol) != 2:
        stat='BL_SYMB_DLG'
        dane.append(stat)
    else:
        sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+Symbol+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if (Fun in [3,4,7] and len(d)==0):
                stat='BL_SYMB_BRAK'
                dane.append(stat)
            elif (Fun in [1,2] and len(d) > 0):
                stat='BL_SYMB_UZYW'
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------

if  ((Fun==1) or (Fun==2)) and UprDodawanie: 
    if (stat=='OK'):
        sql="INSERT INTO rs_oddzialy (firma_id,oddzial_id) VALUES ('"+self.firma_id+"','"+Symbol+"');"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql,1)
        if stat!='OK':
            stat='BL_SQL_spr'
            dane.append(stat)
                
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if (stat=='OK') and ((Fun==3) or (Fun==4)) and UprEdytowanie:
    upd = "UPDATE rs_oddzialy SET "

    for i in range(len(pola)):

        pole = pola[i].lower()
        wart = wartosci[i]

        if pole == 'nip':
            if wart!='':
                stat = rsglobal.SprNip(wart)
                if stat!='OK':
                    dane.append(stat)

        if pole == 'regon':
            if wart!='':
                stat = rsglobal.SprRegon(wart)
                if stat!='OK':
                    dane.append(stat)

        if pole == 'pesel':
            if wart!='':
                stat = rsglobal.SprPesel(wart)
                if stat!='OK':
                    dane.append(stat)

        if pole == 'adr_kraj':
            if len(wart) == 2:
                sql="SELECT kraj FROM rs_kraje WHERE kraj = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if len(d) != 1:
                        stat = 'BL_KRAJ'
                        dane.append(stat)
            elif len(wart) != 0:
                    stat = 'BL_KRAJ_DLG'
                    dane.append(stat)

        if pole == 'urzad_skarbowy_id':
            if len(wart) > 4:
                stat = 'BL_URZ_DLG'
                dane.append(stat)
            elif len(wart) != 0:
                #AB dodanie firmy w where
                sql = "SELECT kod FROM rs_urzedy_skarbowe WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat == 'OK':
                    if len(d) != 1:
                        stat = 'BL_URZ'
                        dane.append(stat)

        if pole == 'region': # mod. PW data: 30.07.09r. - mantis zag. 2315 /tylko te 2 linijki/
            if str(wart) != '':
                sql = "SELECT kod FROM rs_regiony WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat == 'OK':
                    if len(d) != 1:
                        stat = 'BL_REGION'
                        dane.append(stat)

        if pole == 'wersja_sprzedaz':
            if str(wart) != '':
                sql = "SELECT kod FROM rs_wersje_cenowe WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat == 'OK':
                    if len(d) != 1:
                        stat = 'BL_WER_SPRZED'
                        dane.append(stat)

        if pole == 'wersja_magazyn':
            if str(wart) != '':
                sql = "SELECT kod FROM rs_wersje_cenowe WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if len(d) != 1:
                        stat = 'BL_WER_MAGAZ'
                        dane.append(stat)

        #WS 2020-01-14
        if pole == 'centrala':
            if wart:
                sql = "SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' and centrala;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if len(d) != 0:
                        stat = 'BL_CENTRALA$'+d[0][0]
                        dane.append(stat)

        if stat == 'OK':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+str(wart)+"'"

            upd += pole + "=" + str(wart)+","


    if stat == 'OK':
        upd = upd[0:len(upd)-1]
        sql = upd+" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Symbol+"';"

        stat, d, wyn1, dump = self.PolSQL.Execute(sql,1)
        if stat != 'OK':
            stat = 'BL_SQL_spr'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if (stat=='OK') and (Fun in (5,3,1)):
    sql="SELECT * FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Symbol+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat!='OK':
        stat='BL_SQL_spr'
        dane.append(stat)


#--------------------------------------------------------------------------------
#-- Pobieranie opisow do slownikow
#-------------------------------------------------------------------------------

if (Fun == 9) and (stat == 'OK'):

    #kraj
    if klucze[1] != '':
        if ((self.oddzial_id, '011000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kraje WHERE kraj = '"+klucze[1]+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        wyn2.append('')

    #urzd skarbowy
    if klucze[2] != '':
        if ((self.oddzial_id, '011630') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            #AB dodanie firmy w where
            dump, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_urzedy_skarbowe WHERE firma_id='"+self.firma_id+"' AND kod = '"+klucze[2]+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        wyn2.append('')

    #region
    if klucze[3] != '':
        if ((self.oddzial_id, '011000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_regiony WHERE firma_id='"+self.firma_id+"' AND kod = '"+klucze[3]+"';", 3)
            rsglobal.ZapiszDoLogow("SELECT opis FROM rs_regiony WHERE firma_id='"+self.firma_id+"' AND kod = '"+klucze[3]+"';", 1)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        wyn2.append('')
    
    #wersja cenowa sprzedazy
    if klucze[4] != '':
        if ((self.oddzial_id, '011000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+klucze[4]+"';", 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        wyn2.append('')
            

    #wersja cenowa magazynu
    if klucze[5] != '':
        if ((self.oddzial_id,'011000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump, d, dump, dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+klucze[5]+"';",3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        wyn2.append('')

    #osoba fizyczna
    dump, d, dump, dump = self.PolSQL.Execute("SELECT osoba_fizyczna FROM rs_firmy WHERE firma_id='" + self.firma_id+"';", 3)
    if len(d) == 0:
        wyn2.append('Bd pobrania informacji czy osoba fizyczna')
    else:
        wyn2.append(d[0][0])

    if klucze[6] != '':
        if ((self.oddzial_id, '171000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = """SELECT nazwa 
                     FROM rs_kasy_banki
                     WHERE firma_id='{}' AND okres_id='{}' AND kasa_bank_id='{}'
                     ;""".format(self.firma_id, self.okres_id, klucze[6])
            dump, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kas. Poinformuj administratora.')
    else:
        wyn2.append('')
