
# -*- coding: iso8859_2 -*-

#s-----------------------------------------------------------------------------
# Name:        fs_okresy.py
# Purpose:     wczytuje/usuwa dane z list okresw ksigowych
#              oraz tworzy dokument BO
#
# Author:      Micha Raburski
# Created:     2006/02/16
# Modified:    2008/04/04
# RCS-ID:      $Id: fs_okresy.py $
# Copyright:   (c) 2004-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# Funkcja, ktra dodaje pozycj
# 2011.02.22 - Micha Raburski - (4277) BO czciowe i refaktoryzacja kodu
# 2013.03.31 - Jan Raburski - BK automatyczne i refaktorycja kodu

def fs_okresy_zapis_w(Firma,OkresNast,DataBK,NrDok,Stare,Nowe,Lp):
    rsglobal.ZapiszDoLogow('Saldem '+Stare[0],1)
    war1=0
    war2=0
    war3=0
    war4=0
    Waluta=Stare[2]
    SaldoS=Stare[3]-Stare[4]
    SaldoWS=Stare[5]-Stare[6]
    KontoWn=''
    KontoMa=''
    if Nowe<>None:
        SaldoN=Nowe[3]-Nowe[4]
        SaldoWN=Nowe[5]-Nowe[6]
    else:
        SaldoN=0
        SaldoWN=0
    if SaldoS<>SaldoN:
        Wn=SaldoS-SaldoN
        if Wn>0:
            war1=Wn
            KontoWn=rsglobal.Dekoduj(Stare[0])
        else:
            war2=-Wn
            KontoMa=rsglobal.Dekoduj(Stare[0])
    if SaldoWS<>SaldoWN:
        Wn=SaldoWS-SaldoWN
        if Wn>0:
            war3=Wn
            KontoWn=rsglobal.Dekoduj(Stare[0])
        else:
            war4=-Wn
            KontoMa=rsglobal.Dekoduj(Stare[0])
    KursWn=1
    KursMa=1
    if Waluta<>'PLN':
        if war3>0 and war1>0:
            KursWn=war3/war1
        elif war4>0 and war1>0:
            KursMa=war4/war2
    SQLP ="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
    SQLP+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
    SQLP+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
    SQLP+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
    SQLP+="VALUES ('"+Firma+"','"+OkresNast+"','BK','00001','"+DataBK+"',"+str(NrDok)+","+str(Lp)+",0,1,"
    SQLP+="'',NULL,NULL,NULL,NULL,NULL,"
    SQLP+="'"+KontoWn+"',"+str(war1)+",'',0,NULL,'Bilans otwarcia',NULL,'','"+Waluta+"',"+str(KursWn)+","+str(war3)+",FALSE,"
    SQLP+="'"+KontoMa+"',"+str(war2)+",'',0,NULL,'Bilans otwarcia',NULL,'"+Waluta+"',"+str(KursMa)+","+str(war4)+",FALSE);"
    return SQLP,war1,war2,war3,war4


##--------------------------------------------------------------

def fs_okresy_zapis_r(Polaczenie,Firma,Okres,OkresNast,DataBK,NrDok,Stare,Nowe,Lp):
    # zapis roznic w rozrachunkach - tylko dopisane operacje
    rsglobal.ZapiszDoLogow('Rozrachunki '+Stare[0],1)
    SQLP=''
    SPozycji={}
    war1=0
    war2=0
    war3=0
    war4=0
    # pobranie nierozliczonych operacji ze starego okresu
    SQL="SELECT r.konto,r.waluta,r.saldo_wn,r.saldo_ma,r.saldo_wal_wn,r.saldo_wal_ma,r.symbol_dok," #0-6
    SQL+="r.data_wyst,r.data_wplywu,r.termin_plat,r.data_zapl,r.kontrahent_id,"#7-11
    SQL+="r.tresc,r.projekt_id,r.kurs,r.seria,r.f_typ,r.f_wyznacznik_id,r.f_data,r.f_numer,r.platnosc_id, " #12-20
    SQL+=" rozliczone_wn, rozliczone_ma, rozliczone_wal_wn,rozliczone_wal_ma,kwota_wn,kwota_ma,COALESCE(r.data_rozlicz::TEXT,'')," #21 -27
    SQL+=" COALESCE(r.pdk_dowod_id,'')||'/'||COALESCE(r.pdk_nazwa_id,'')||" 
    SQL+="'/'||COALESCE(r.pdk_data::TEXT,'')||'/'||COALESCE(r.pdk_numer::TEXT,'')||'/'||COALESCE(r.pdk_nr_poz::TEXT,'')||'/'||COALESCE(r.pdk_nr_ppoz::TEXT,'')" # 28 - numer pierwotny dowodu
    SQL+=" FROM rs_rozrachunki r WHERE r.firma_id='"+Firma+"'  AND r.okres_id='"+Okres+"'"
    SQL+=" AND r.konto='"+rsglobal.Dekoduj(Stare[0])+"'"
    SQL+=" AND (r.saldo_wn <> 0 OR r.saldo_ma <> 0) AND r.rozliczone_wn=0 AND r.rozliczone_ma=0 "
    SQL+=" ORDER BY r.konto,r.waluta,r.data_rozlicz DESC,data;"
    stat,DaneR,dump,dump = Polaczenie.Execute(SQL,3)
    # pobranie rozrachunkow z BO
    if stat=='OK':
        if Nowe<>None:
            SQL="SELECT dp.waluta_wn, dp.waluta_ma,dp.data, dp.tresc_wn, dp.tresc_ma"
            SQL+=" FROM rs_dowody_ksiegowe_pozycje dp"
            SQL+=" WHERE dp.firma_id='"+Firma+"'  AND dp.okres_id='"+OkresNast+"'"
            SQL+=" AND (dp.konto_wn='"+rsglobal.Dekoduj(Stare[0])+"' OR dp.konto_ma='"+rsglobal.Dekoduj(Stare[0])+"')"
            SQL+=" AND dp.dowod_id='BO' "
            SQL+=" ORDER BY dp.waluta_wn,dp.data;"
            stat,DaneBO,dump,dump = Polaczenie.Execute(SQL,3)
        else:
            DaneBO=[]
    
    if stat=='OK':
        # dodawanie rozrachunkow ktorych brak
        s=0
        while s<len(DaneR):
            konto=DaneR[s]
            Tresc='Nr:'+str(konto[15])
            n=0
            while n<len(DaneBO):
                if Tresc in DaneBO[n][3]:
                    break
                if Tresc in DaneBO[n][4]:
                    break
                n+=1
            if n==len(DaneBO):
                from funkcje import fs_okresy_pom
                (SQL,Lp,SPozycji)=fs_okresy_pom.DodajPozycjeRozrachunkowaNaBilansOtwarcia(Firma,OkresNast,DataBK,Lp,konto,'',True,'',NrDok,SPozycji,True)
                SQLP+=SQL
                war1+=konto[2]
                war2+=konto[3]
                war3+=konto[4]
                war4+=konto[5]
            s+=1

    return SQLP,war1,war2,war3,war4,Lp

##--------------------------------------------------------------

def fs_okresy_zapis_n(Firma,OkresNast,DataBK,NrDok,Nowe,Lp):
    war1=-Nowe[3]
    war2=-Nowe[4]
    war3=-Nowe[5]
    war4=-Nowe[6]
    Waluta=Nowe[2]
    KontoWn=''
    KontoMa=''
    if war1<>0 or war3<>0:
        KontoWn=rsglobal.Dekoduj(Nowe[0])
    if war2<>0 or war4<>0:
        KontoMa=rsglobal.Dekoduj(Nowe[0])
    KursWn=1
    KursMa=1
    if Waluta<>'PLN':
        if war3>0 and war1>0:
            KursWn=war3/war1
        elif war4>0 and war1>0:
            KursMa=war4/war2
    SQLP ="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
    SQLP+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
    SQLP+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
    SQLP+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
    SQLP+="VALUES ('"+Firma+"','"+OkresNast+"','BK','00001','"+DataBK+"',"+str(NrDok)+","+str(Lp)+",0,1,"
    SQLP+="'',NULL,NULL,NULL,NULL,NULL,"
    SQLP+="'"+KontoWn+"',"+str(war1)+",'',0,NULL,'Bilans otwarcia',NULL,'','"+Waluta+"',"+str(KursWn)+","+str(war3)+",FALSE,"
    SQLP+="'"+KontoMa+"',"+str(war2)+",'',0,NULL,'Bilans otwarcia',NULL,'"+Waluta+"',"+str(KursMa)+","+str(war4)+",FALSE);"
    return SQLP,war1,war2,war3,war4

##--------------------------------------------------------------

def fs_okresy_zapis_syntetyki(Firma,OkresNast,DataBK,NrDok,Konto,Waluta,Wn,Ma,WWn,WMa,Lp):
    war1=Wn
    war2=Ma
    war3=WWn
    war4=WMa
    if war1==0 and war2==0 and war3==0 and war4==0:
        return ''
    KontoWn=''
    KontoMa=''
    if war1<>0 or war3<>0:
        KontoWn=Konto
    if war2<>0 or war4<>0:
        KontoMa=Konto
    KursWn=1
    KursMa=1
    if Waluta<>'PLN':
        if war3>0 and war1>0:
            KursWn=war3/war1
        elif war4>0 and war1>0:
            KursMa=war4/war2
    SQLP ="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
    SQLP+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
    SQLP+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
    SQLP+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
    SQLP+="VALUES ('"+Firma+"','"+OkresNast+"','BK','00001','"+DataBK+"',"+str(NrDok)+","+str(Lp)+",0,1,"
    SQLP+="'',NULL,NULL,NULL,NULL,NULL,"
    SQLP+="'"+KontoWn+"',"+str(war1)+",'',0,NULL,'Bilans otwarcia',NULL,'','"+Waluta+"',"+str(KursWn)+","+str(war3)+",FALSE,"
    SQLP+="'"+KontoMa+"',"+str(war2)+",'',0,NULL,'Bilans otwarcia',NULL,'"+Waluta+"',"+str(KursMa)+","+str(war4)+",FALSE);"
    return SQLP

##--------------------------------------------------------------

def SprawdzPoprawnoscOkresow(Polaczenie, Firma, Okres, OkresNast):
    # wraca ze statem oraz Rok, Mc, DataPoczatkowaNastepnegoOkresu
    stat='OK'
    dane=[]
    stat,Dane,dump,dump = Polaczenie.Execute("SELECT okres_id,data_do FROM rs_definicje_okresow WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"';",3)        
    if stat=='OK':
        if len(Dane)==0:
            stat='Podany okres z ktrego robi si bilans jest nieprawidowy :'+Okres  
        else:
            #pobieramy Rok i Mc
            dane.append(rsglobal.Dekoduj(Dane[0][1][0:4]))
            dane.append(rsglobal.Dekoduj(Dane[0][1][5:7]))
                  
    #-----------------------------------------------
    #SPRAWDZENIE OKRESU DO KTOREGO ROBI SIE BILANS  
    #-----------------------------------------------
    if stat=='OK':
        if OkresNast=='':
            stat='Nie podano okresu do ktrego robi si bilans'        
    if stat=='OK':
        stat,Dane,dump,dump = Polaczenie.Execute("SELECT okres_id,data_od FROM rs_definicje_okresow WHERE firma_id='"+Firma+"' AND okres_id='"+OkresNast+"';",3)
    if stat=='OK':
        if len(Dane)==0:
            stat='Podany okres do ktrego robi si bilans jest nieprawidowy :'+OkresNast        
        else:
            #pobieramy dat pocztkow nowego okresu
            dane.append(rsglobal.Dekoduj(Dane[0][1]))

    #-----------------------------------------------
    #SPRAWDZENIE OKRESU BILANSOWANEGO CZY JEST CO NAJWYEJ 1 OTWARTY MIESIAC
    #-----------------------------------------------
    if stat=='OK':
        stat,Dane,dump,dump = Polaczenie.Execute("SELECT count(*) FROM rs_definicje_okresow_miesiace WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"' AND NOT zamkniety;",3)        
        if stat=='OK':
            if len(Dane)==1:
                if Dane[0][0] > 1:
                    stat='W podanym okresie jest wicej ni jeden niezamknity miesic'
            else:
                stat='Bdy w pobieraniu miesicy okresw. Poinformuj serwis.'

    return (stat,dane)

##--------------------------------------------------------------

def SprawdzCzyKontaNMajaSaldaZerowe(Polaczenie, Firma, Okres, Rok, Mc):
    SQL="SELECT kontos_id,konto_id FROM rs_plan_kont WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"' "
    SQL+=" AND do_bilansu='N' AND (NOT pozabilansowe) ORDER BY kontos_id,konto_id;"
    
    stat,Dane,dump,dump = Polaczenie.Execute(SQL,3)
    LKont=[]
    LKontNZer=[]
    dane=[]
    if stat=='OK':
        for konto in Dane:
            if konto[1] in (None,''):
                LKont.append(rsglobal.Dekoduj(konto[0]))
            elif not konto[0] in LKont:
                LKont.append(rsglobal.Dekoduj(konto[0]+'-'+konto[1]))
           
        for konto in LKont:
            if stat =='OK':
                SQL="SELECT konto,sum(saldo_wn),sum(saldo_ma) FROM rs_stany_kont WHERE firma_id='"+Firma+"' AND okres_id='"+Okres+"' "
                SQL+=" AND konto LIKE '"+konto+"%' AND rok='"+Rok+"' AND miesiac='"+Mc+"'GROUP BY konto HAVING SUM(saldo_wn-saldo_ma)<>0 ;"
                stat,Dane,dump,dump = Polaczenie.Execute(SQL,3)            
                if stat=='OK':
                    for KontoBl in Dane:
                        if not KontoBl[0] in LKontNZer:
                            LKontNZer.append(KontoBl[0])
                            dane.append('Dla konta niewchodzcego do BO : '+KontoBl[0]+' s niezerowe salda : wn = '+str(KontoBl[1])+' , ma = '+str(KontoBl[2]))
    return (stat,dane)



################################################################################
#-------------------------------------------------------------------------------
#   GWNA CZʦ OKNA
#-------------------------------------------------------------------------------
################################################################################


if self.operator_id == STANDARD_OPERATOR_ID:
    UprDel=True
    UprBO=True
else:
    UprDel=False
    UprBO=(self.oddzial_id,'071019') in self.uprawnienia

Fun=klucze[-1]

stat = "OK"
dane = []

#@##############################################################################
#---   SPRAWDZENIE Z JAKIEGO OKRESU JEST DATA
#@##############################################################################

if Fun==15:
    Select= "SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+rsglobal.Dekoduj(klucze[0])+"');"
    stat,dane,dump,dump = self.PolSQL.Execute(Select,3)



################################################################################
#-------------------------------------------------------------------------------
#---   UTWORZENIE DOKUMENTU BO W KOLEJNYM OKRESIE (10)
#-------------------------------------------------------------------------------
################################################################################

if Fun ==10:
    #-------------------------------------------
    # - SPRAWDZENIE DANYCH
    #-------------------------------------------
    if not UprBO:
        stat='Brak uprawnie do tworzenia BO'
        
    if stat=='OK':
        Okres=rsglobal.Dekoduj(klucze[0])
        OkresNast=rsglobal.Dekoduj(klucze[1])
        CzyCalkowite = klucze[2]
        Konto = rsglobal.Dekoduj(klucze[3])
        Techniczne=''
        Rok='2000'
        Mc='12'        
        SKwotaWn=0
        SKwotaMa=0
        LCzesciowe=[]    # lista kont, ktre s rozliczane czciowo
        
        #-----------------------------------------------
        #SPRAWDZENIE OKRESU Z KTOREGO ROBI SIE BILANS
        #-----------------------------------------------
        if Okres=='':
            stat='Nie podano okresu z ktrego robi si bilans'        
            

    if stat=='OK':
        (stat,Dane)=SprawdzPoprawnoscOkresow(self.PolSQL, self.firma_id, Okres, OkresNast)
        if stat=='OK':
            Rok=Dane[0]
            Mc=Dane[1]
            DataOdNast=Dane[2]

    

    #-----------------------------------------------
    #SPRAWDZENIE CZY WSZYSTKIE KONTA "N" MAJ SALDO 0
    #-----------------------------------------------

    if stat=='OK':
        stat,dane=SprawdzCzyKontaNMajaSaldaZerowe(self.PolSQL, self.firma_id, Okres, Rok, Mc)
        if stat=='OK':
            if len(dane)>0:
                stat='LISTA NIEWCHODZACYCH'
        
    #-----------------------------------------------
    #SPRAWDZENIE CZY ISTNIEJ BO I JAKI MAJ STAN
    #-----------------------------------------------

    # pobranie wszystkich BO i ich kont syntetycznych. Jeli BO czciowe to ma maksymalnie 2 syntetyki.
    # Jeli caociowe to ma minimum 3 syntetyki.
    
    if stat=='OK':
        SQL="SELECT DISTINCT d.stan,d.dowod_id,d.nazwa_id,d.data,d.numer,"
        SQL+=" COUNT(DISTINCT (STRING_TO_ARRAY(dp.konto_wn,'-'))[1])"
        SQL+=" FROM rs_dowody_ksiegowe d "
        SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresNast+"'"
        SQL+=" AND dowod_id='BO'"
        SQL+=" GROUP BY d.stan,d.firma_id,d.dowod_id,d.nazwa_id,d.data,d.numer"
        stat,DBOWn,dump,dump = self.PolSQL.Execute(SQL,3)            
        
        SQL="SELECT DISTINCT d.stan,d.dowod_id,d.nazwa_id,d.data,d.numer,"
        SQL+=" COUNT(DISTINCT (STRING_TO_ARRAY(dp.konto_ma,'-'))[1])"
        SQL+=" FROM rs_dowody_ksiegowe d "
        SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresNast+"'"
        SQL+=" AND dowod_id='BO'"
        SQL+=" GROUP BY d.stan,d.firma_id,d.dowod_id,d.nazwa_id,d.data,d.numer"
        stat,DBOMa,dump,dump = self.PolSQL.Execute(SQL,3)            
        
        # sownik dok. BO. Klucz to kluczBO, a dane to [stan,liczba kont,czciowa syntetyka]
        SDokBO={}
        for poz in DBOWn+DBOMa:
            klucz=(poz[1],poz[2],poz[3],poz[4])
            if klucz in SDokBO:
                #dodanie liczby kont do istniejcego BO
                SDokBO[klucz][1]=SDokBO[klucz][1]+poz[5]
            else:
                # nowe BO
                SDokBO[klucz]=[poz[0],poz[5],'']
        
        # jeli pene (dotyczy te czciowego) BO to musi mie wszystkie czciowe zamknite oraz nie moe by zwykego.
        for kl in SDokBO.keys():
            # BO Czciowe
            if SDokBO[kl][1]<=4:
                # niezamknite
                if SDokBO[kl][0]<>'Z':
                    stat="Istniej niezamknite czciowe dowody BO dla okresu "+OkresNast
            # BO normalne istnieje
            else:
                if SDokBO[kl][0]=='W':
                    stat='Dokument caociowy BO w okresie '+OkresNast+' istnieje i jest otwarty. Usu dokument by tworzy BO'
                else:
                    stat='Dokument caociowy BO w okresie '+OkresNast+' istnieje i nie jest otwarty.'

    if stat=='OK':
        # jeli s jakiekolwiek BO to s czciowe (lub robimy nowe czciowe) i potrzebne jest konto techniczne
        if len(SDokBO)>0 or not CzyCalkowite:
            # pobieramy konto techniczne
            SQL="SELECT kontos_id FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND okres_id='"+OkresNast+"' AND techniczne='BO';"
            stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3) 
            if stat=='OK':
                if len(Dane)==0:
                    stat="Brak konta technicznego BO dla okresu "+OkresNast
            if stat=='OK':
                Techniczne=rsglobal.Dekoduj(Dane[0][0].strip())

                # jeli tu jestemy to znaczy, e wszystkie BO s czciowe
                # pobieramy te list kont czciowych
                for kl in SDokBO.keys():
                    if stat=='OK':
                        SQL="SELECT DISTINCT konto_wn,konto_ma"
                        SQL+=" FROM rs_dowody_ksiegowe_pozycje "
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresNast+"'"
                        SQL+=" AND dowod_id='BO' AND nazwa_id='"+rsglobal.Dekoduj(kl[1])+"'"
                        SQL+=" AND data='"+rsglobal.Dekoduj(kl[2])+"' AND numer="+str(kl[3])+";"
                        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3) 
                        if stat=='OK':
                            for d in Dane:
                                KontoSWn=d[0]
                                KontoSMa=d[1]
                                
                                if not CzyCalkowite:
                                    if len(KontoSWn)>3:
                                        if KontoSWn <> Techniczne:
                                            if KontoSWn==Konto:                            
                                                stat='Istnieje ju czciowe BO dla podanego konta'
                                
                                    if len(KontoSMa)>3:
                                        if KontoSMa <> Techniczne:
                                            if KontoSMa==Konto:                            
                                                stat='Istnieje ju czciowe BO dla podanego konta'
                                                
                                if len(KontoSWn)>3:
                                    if KontoSWn <> Techniczne:
                                        if not KontoSWn in LCzesciowe:
                                            LCzesciowe.append(KontoSWn)
                                
                                if len(KontoSMa)>3:
                                    if KontoSMa <> Techniczne:
                                        if not KontoSMa in LCzesciowe:
                                            LCzesciowe.append(KontoSMa)    


#-------------------------------------------------------------------------------
#---   TESTY WYKONANE - TWORZENIE WACIWE
#-------------------------------------------------------------------------------

    # najpierw przygotowywane s zapytania a potem wykonywane jednym odwoaniem do serwera
    if stat=='OK':
        SQLN=''
        
        # pobranie numeru BO
        SQL="SELECT COALESCE(MAX(numer)+1,1) FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+OkresNast+"' AND dowod_id='BO' AND nazwa_id='00001';"
        stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)            
    if stat=='OK':
        NrDok=str(DNr[0][0])
        
        #-----------------------------------------------
        # DODANIE NAGWKA DOKUMENTU BO
        #-----------------------------------------------
        SQLN="INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer,stan,kwota_wn,kwota_ma,symbol_dok,data_wyst,"
        SQLN+="data_wplywu, termin_plat, data_zapl, kontrahent_id, rejestr,data_rejestru, nr_faktury, nr_dok_mag, projekt_id) "
        SQLN+=" VALUES ('"+self.firma_id+"','"+OkresNast+"','BO','00001','"+DataOdNast+"',"+NrDok+",'W',0,0,'',NULL,"
        SQLN+="NULL, NULL,NULL, NULL, NULL, NULL, NULL, NULL,NULL);"

        #-----------------------------------------------
        # POBRANIE POZYCJI Z TYPU 'W' - WCHODZCE SALDEM
        #-----------------------------------------------
        if CzyCalkowite:
            SQL="SELECT sk.konto,sk.waluta,sk.saldo_wn,sk.saldo_ma,sk.saldo_wal_wn,sk.saldo_wal_ma FROM rs_stany_kont sk "
            SQL+=" INNER JOIN rs_plan_kont pk ON (sk.firma_id=pk.firma_id AND sk.okres_id=pk.okres_id "
            SQL+=" AND pk.kontos_id=(STRING_TO_ARRAY(sk.konto,'-'))[1] AND (pk.konto_id='' OR pk.konto_id IS NULL))"
            SQL+=" WHERE sk.firma_id='"+self.firma_id+"' AND sk.okres_id='"+Okres+"' AND pk.do_bilansu='W'"
            SQL+=" AND sk.rok='"+Rok+"' AND sk.miesiac='"+Mc+"' AND (sk.saldo_wn <> 0 OR sk.saldo_ma <> 0) ORDER BY sk.konto,sk.waluta;"
            stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)            
        else:
            Dane=[]

    if stat=='OK':
        Lp=1
        SqLP=''
        #sownik ktrego kluczem jest konto syntetyczne, a elementem mu przypisanym jest 
        #lista [waluta,saldo_wn,saldo_ma,saldo_wal_wn,saldo_wal_ma]
        SWalWart={}
        #przebieg zliczajcy sumy do syntetyki
        for konto in Dane:
            #sprawdzenie jakimi kwotami konto wejdzie do bilansu
            kwotawn=konto[2]
            kwotama=konto[3]
            kwotawalwn=konto[4]
            kwotawalma=konto[5]
            if kwotawn>=0 and kwotama>=0:
                kwotawn=round(max(konto[2]-konto[3],0),2)
                kwotama=round(max(konto[3]-konto[2],0),2)
                kwotawalwn=round(max(konto[4]-konto[5],0),2)
                kwotawalma=round(max(konto[5]-konto[4],0),2)
                
            if kwotawn <> 0 or kwotama <>0:
                # wogle nie ma takiej syntetyki
                Synt=rsglobal.Dekoduj(konto[0]).split('-')[0]
                    
                if not Synt in SWalWart:
                    SWalWart[Synt]=[[konto[1],kwotawn,kwotama,kwotawalwn,kwotawalma]]
            
                # syntetyka jest, ale nie wiadomo czy z taka waluta
                else:
                    KwotyWal=SWalWart[Synt]
                    Jest=False
                    for wal in KwotyWal:
                        #znalazl walute
                        if wal[0]==konto[1]:
                            Jest=True
                            wal[1]+=kwotawn
                            wal[2]+=kwotama
                            wal[3]+=kwotawalwn
                            wal[4]+=kwotawalma
                    if not Jest:
                        # nie znalazl waluty
                        KwotyWal.append([konto[1],kwotawn,kwotama,kwotawalwn,kwotawalma])
                    
                    SWalWart[Synt]=KwotyWal
        
        #przebiegi wstawiajace pozycje
        ListaKl=SWalWart.keys()
        ListaKl.sort()

        SQLP=''
        SQLP2=''
        SQLP3=''
        SQLP4=''
        Pozabilansowe=False
        
        for kontos in ListaKl:
            #sprawdzenie czy jest to seria kont pozabilansowych
            SQLPozab="SELECT pozabilansowe FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kontos_id='"+kontos+"';"
            stat,Danepozab,dump,dump = self.PolSQL.Execute(SQLPozab,3)                
            if len(Danepozab)>0:
                Pozabilansowe=Danepozab[0][0]
            
            LWalut=SWalWart[kontos]
            for wal in LWalut:
                # po kolei zapisywana jest syntetyka - walutami
                KursWn=1
                KursMa=1
                if wal[0] <> 'PLN':
                    KursWn=1
                    KursMa=1
                
                SQLP+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
                SQLP+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
                SQLP+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
                SQLP+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
                SQLP+="VALUES ('"+self.firma_id+"','"+OkresNast+"','BO','00001','"+DataOdNast+"',"+NrDok+","+str(Lp)+",0,1,"
                SQLP+="'',NULL,NULL,NULL,NULL,NULL,"
                SQLP+="'"+kontos+"',"+str(wal[1])+",'',0,NULL,'Bilans otwarcia',NULL,'','"+rsglobal.Dekoduj(wal[0])+"',"+str(KursWn)+","+str(wal[3])+",FALSE,"
                SQLP+="'"+kontos+"',"+str(wal[2])+",'',0,NULL,'Bilans otwarcia',NULL,'"+rsglobal.Dekoduj(wal[0])+"',"+str(KursMa)+","+str(wal[4])+",FALSE);"
                Lp+=1
            
            # zapisywanie analityki
            
            for konto in Dane:
                #konto z aktualnie przetwarzanej syntetyki
                Synt = str(konto[0]).split('-')[0]

                #dodawanie kwot do sum na naglowek dokumentu BO
                if (kontos==Synt):
                    if not Pozabilansowe:
                        SKwotaWn+=kwotawn
                        SKwotaMa+=kwotama
                
                if (kontos==Synt) and (konto[0].find('-') >0):
                    kwotawn=konto[2]
                    kwotama=konto[3]
                    kwotawalwn=konto[4]
                    kwotawalma=konto[5]
                    if kwotawn>=0 and kwotama>=0:
                        kwotawn=round(max(konto[2]-konto[3],0),2)
                        kwotama=round(max(konto[3]-konto[2],0),2)
                        kwotawalwn=round(max(konto[4]-konto[5],0),2)
                        kwotawalma=round(max(konto[5]-konto[4],0),2)

                    if kwotawn <> 0 or kwotama <>0:
                        KursWn=1
                        KursMa=1
                        if wal[0] <> 'PLN':
                            KursWn=1
                            KursMa=1
                        
                        
                        SQLP2+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
                        SQLP2+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
                        SQLP2+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
                        SQLP2+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
                        SQLP2+="VALUES ('"+self.firma_id+"','"+OkresNast+"','BO','00001','"+DataOdNast+"',"+NrDok+","+str(Lp)+",0,1,"
                        SQLP2+="'',NULL,NULL,NULL,NULL,NULL,"
                        
                        if kwotawn <> 0:
                            SQLP2+="'"+rsglobal.Dekoduj(konto[0])+"',"+str(kwotawn)+",'',0,NULL,'Bilans otwarcia',NULL,'','"+rsglobal.Dekoduj(konto[1])+"',"+str(KursWn)+","+str(kwotawalwn)+",FALSE,"
                        else:
                            SQLP2+="'',0,'',0,NULL,'',NULL,'','"+rsglobal.Dekoduj(konto[1])+"',"+str(KursWn)+",0,FALSE,"
                            
                        if kwotama <> 0:                        
                            SQLP2+="'"+rsglobal.Dekoduj(konto[0])+"',"+str(kwotama)+",'',0,NULL,'Bilans otwarcia',NULL,'"+rsglobal.Dekoduj(konto[1])+"',"+str(KursMa)+","+str(kwotawalma)+",FALSE);"
                        else:
                            SQLP2+="'',0,'',0,NULL,'',NULL,'"+rsglobal.Dekoduj(konto[1])+"',"+str(KursMa)+",0,FALSE);"
                        Lp+=1

        
        #-----------------------------------------------
        # POBRANIE POZYCJI Z TYPU 'R' - WCHODZCE ROZRACHUNKAMI
        #-----------------------------------------------
        
        # pomocnicze pobranie daty do okresu
        SQL="SELECT data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"';"
        stat,DOkrPom,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        DataDoOkr=DOkrPom[0][0]
        SPozycji={}
        # pobranie rozrachunkw do bilansu
        SQL="SELECT r.konto,r.waluta,r.saldo_wn,r.saldo_ma,r.saldo_wal_wn,r.saldo_wal_ma,r.symbol_dok," #0-6
        SQL+="r.data_wyst,r.data_wplywu,r.termin_plat,r.data_zapl,r.kontrahent_id,"#7-11
        SQL+="r.tresc,r.projekt_id,r.kurs,r.seria,r.f_typ,r.f_wyznacznik_id,r.f_data,r.f_numer,r.platnosc_id," #12-20
        SQL+=" rozliczone_wn, rozliczone_ma, rozliczone_wal_wn,rozliczone_wal_ma,kwota_wn,kwota_ma," #21 -26
        SQL+=" COALESCE(r.data_rozlicz::TEXT,''),COALESCE(r.pdk_dowod_id,'')||'/'||COALESCE(r.pdk_nazwa_id,'')||" # 27 - data rozliczenia
        SQL+="'/'||COALESCE(r.pdk_data::TEXT,'')||'/'||COALESCE(r.pdk_numer::TEXT,'')||'/'||COALESCE(r.pdk_nr_poz::TEXT,'')||'/'||COALESCE(r.pdk_nr_ppoz::TEXT,'')" # 28 - numer pierwotny dowodu
        SQL+=" FROM rs_rozrachunki r " 
        SQL+=" INNER JOIN rs_plan_kont pk ON (r.firma_id=pk.firma_id AND r.okres_id=pk.okres_id "
        SQL+=" AND pk.kontos_id=(STRING_TO_ARRAY(r.konto,'-'))[1] AND (pk.konto_id='' OR pk.konto_id IS NULL))"
        SQL+=" WHERE r.firma_id='"+self.firma_id+"'  AND r.okres_id='"+Okres+"'"
        if not CzyCalkowite:
            if Konto[-1]=='%':
                SQL+=" AND r.konto LIKE '"+Konto+"%'"
            else:
                SQL+=" AND r.konto='"+Konto+"'"
        SQL+=" AND (r.saldo_wn <> 0 OR r.saldo_ma <> 0) "
        SQL+=" AND ((r.rozliczone_wn=0 AND r.rozliczone_ma=0) OR data_rozlicz>'"+DataDoOkr+"')"
        SQL+=" AND pk.do_bilansu='R' ORDER BY r.konto,r.waluta,r.data_rozlicz DESC,"
        SQL+=" CASE WHEN r.rozliczone_wn = 0 AND r.rozliczone_ma = 0 THEN 1 ELSE 2 END,data;"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat=='OK':        
        SWalWart={}
        Pozabilansowe=False
        #przebieg zliczajcy sumy do syntetyki
        for konto in Dane:
            #ignorujemy analityk z kont o dugoci 3 i takie co byy rozliczane czsciowo
            if konto[0].find('-') > -1 and not (konto[0] in LCzesciowe):
                # wogle nie ma takiej syntetyki
                Synt=rsglobal.Dekoduj(konto[0]).split('-')[0]
                
                #sprawdzenie czy jest to seria kont pozabilansowych
                SQLPozab="SELECT pozabilansowe FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kontos_id='"+Synt+"';"
                stat,Danepozab,dump,dump = self.PolSQL.Execute(SQLPozab,3)                
                if len(Danepozab)>0:
                    Pozabilansowe=Danepozab[0][0]

                #dodawanie kwot do sum na naglowek dokumentu BO
                if not Pozabilansowe:
                    SKwotaWn+=konto[2]
                    SKwotaMa+=konto[3]
                
                RozliczoneWczesniej= (konto[21]<>0 or konto[22]<>0)
                
                if not Synt in SWalWart:
                    # jeli nierozliczone
                    if RozliczoneWczesniej:
                        SWalWart[Synt]=[[konto[1],konto[21],konto[22],konto[23],konto[24]]]
                    else:
                        SWalWart[Synt]=[[konto[1],konto[2],konto[3],konto[4],konto[5]]]
                        
                # syntetyka jest, ale nie wiadomo czy z taka waluta
                else:
                    KwotyWal=SWalWart[Synt]
                    Jest=False
                    for wal in KwotyWal:
                        #znalazl walute
                        if wal[0]==konto[1]:
                            Jest=True
                            if RozliczoneWczesniej:
                                wal[1]+=konto[21]
                                wal[2]+=konto[22]
                                wal[3]+=konto[23]
                                wal[4]+=konto[24]
                            else:
                                wal[1]+=konto[2]
                                wal[2]+=konto[3]
                                wal[3]+=konto[4]
                                wal[4]+=konto[5]
    
                    if not Jest:
                        # nie znalazl waluty
                        if RozliczoneWczesniej:
                            KwotyWal.append([konto[1],konto[21],konto[22],konto[23],konto[24]])
                        else:
                            KwotyWal.append([konto[1],konto[2],konto[3],konto[4],konto[5]])
                        
                    SWalWart[Synt]=KwotyWal
        
        ListaKl=SWalWart.keys()
        ListaKl.sort()
        
        #sprawdzenie czy nie ma rozrachunkw na koncie pozabilansowym ktre jest przed dowoln syntetyk
        CzyDlWieksza3=False
        for konto in Dane:
            if not konto[0] in LCzesciowe: # ignorujemy konta wczeniej rozliczone z kontem technicznym
                if konto[0].find('-') > -1:
                    CzyDlWieksza3=True
                if not CzyDlWieksza3:
                    RozliczoneWczesniej= (konto[21]<>0 or konto[22]<>0)
                    from funkcje import fs_okresy_pom
                    (SQLP4,Lp,SPozycji)=fs_okresy_pom.DodajPozycjeRozrachunkowaNaBilansOtwarcia(self.firma_id,OkresNast,DataOdNast,Lp,konto,SQLP4,CzyCalkowite,Techniczne,NrDok,SPozycji)
                    #sprawdzenie czy jest to seria kont pozabilansowych
                    SQLPozab="SELECT pozabilansowe FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kontos_id='"+str(konto[0])+"';"
                    stat,Danepozab,dump,dump = self.PolSQL.Execute(SQLPozab,3)                
                    if len(Danepozab)>0:
                        Pozabilansowe=Danepozab[0][0]
    
                    #dodawanie kwot do sum na naglowek dokumentu BO
                    if not Pozabilansowe:
                        if RozliczoneWczesniej:
                            SKwotaWn+=konto[21]
                            SKwotaMa+=konto[22]
                        else:
                            SKwotaWn+=konto[2]
                            SKwotaMa+=konto[3]
                
        
        for kontos in ListaKl:
            LWalut=SWalWart[kontos]
            for wal in LWalut:
                # po kolei zapisywana jest syntetyka - walutami
                KursWn=1
                KursMa=1
                if wal[0] <> 'PLN':
                    KursWn=1
                    KursMa=1
                SQLP3+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
                SQLP3+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
                SQLP3+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
                SQLP3+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
                SQLP3+="VALUES ('"+self.firma_id+"','"+OkresNast+"','BO','00001','"+DataOdNast+"',"+NrDok+","+str(Lp)+",0,1,"
                SQLP3+="'',NULL,NULL,NULL,NULL,NULL,"
                SQLP3+="'"+kontos+"',"+str(wal[1])+",'',0,NULL,'Bilans otwarcia',NULL,'','"+rsglobal.Dekoduj(wal[0])+"',"+str(KursWn)+","+str(wal[3])+",FALSE,"
                SQLP3+="'"+kontos+"',"+str(wal[2])+",'',0,NULL,'Bilans otwarcia',NULL,'"+rsglobal.Dekoduj(wal[0])+"',"+str(KursMa)+","+str(wal[4])+",FALSE);"

                Lp+=1
        
            # zapisywanie analityki
            CzyDlWieksza3=False
            CzyByly=False
            for konto in Dane:
                RozliczoneWczesniej= (konto[21]<>0 or konto[22]<>0)
                Synt=rsglobal.Dekoduj(konto[0]).split('-')[0]
                if kontos==Synt:
                    if not konto[0] in LCzesciowe: # ignorujemy konta wczeniej rozliczone z kontem technicznym
                        #ju byy
                        CzyByly=True
                        from funkcje import fs_okresy_pom
                        SQLP4,Lp,SPozycji=fs_okresy_pom.DodajPozycjeRozrachunkowaNaBilansOtwarcia(self.firma_id,OkresNast,DataOdNast,Lp,konto,SQLP4,CzyCalkowite,Techniczne,NrDok,SPozycji)
                elif not konto[0] in LCzesciowe:
                    #jestemy ju za tym kontem oraz ju konto si skoczyo
                    #tak dugo wstawiamy pozycje jak dugo s konta dugoci 3
                    if CzyByly:
                        if konto[0].find('-')>-1:
                            CzyDlWieksza3=True
                        if not CzyDlWieksza3:
                            from funkcje import fs_okresy_pom
                            SQLP4,Lp,SPozycji=fs_okresy_pom.DodajPozycjeRozrachunkowaNaBilansOtwarcia(self.firma_id,OkresNast,DataOdNast,Lp,konto,SQLP4,CzyCalkowite,Techniczne,NrDok,SPozycji)
                            #sprawdzenie czy jest to seria kont pozabilansowych
                            SQLPozab="SELECT pozabilansowe FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kontos_id='"+Synt+"';"
                            stat,Danepozab,dump,dump = self.PolSQL.Execute(SQLPozab,3)                
                            if len(Danepozab)>0:
                                Pozabilansowe=Danepozab[0][0]

                            #dodawanie kwot do sum na naglowek dokumentu BO
                            if not Pozabilansowe:
                                if RozliczoneWczesniej:
                                    SKwotaWn+=konto[21]
                                    SKwotaMa+=konto[22]
                                else:
                                    SKwotaWn+=konto[2]
                                    SKwotaMa+=konto[3]
                
    
        # wszystkie konta zostay rozliczone poza kontami rozliczonymi wczeniej z polem technicznym.
        # teraz dodajemy te konta do bilansu. Dodajemy je jedn sum.
        # to lista wn, ma, wn wal, ma wal
        SQLP5=''
        LWartTech=[0,0,0,0]
        if CzyCalkowite:
            for konto in Dane:
                if konto[0] in LCzesciowe:
                    LWartTech[0]+=konto[2]
                    LWartTech[1]+=konto[3]
                    LWartTech[2]+=konto[4]
                    LWartTech[3]+=konto[5]

        if LWartTech<>[0,0,0,0]:
            SQLP5="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
            SQLP5+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,"
            SQLP5+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
            SQLP5+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
            SQLP5+=" VALUES ('"+self.firma_id+"','"+OkresNast+"','BO','00001','"+DataOdNast+"',"+NrDok+","+str(Lp)+",0,1,"
            SQLP5+="'',NULL,NULL,NULL,NULL,NULL,"
            SQLP5+="'"+Techniczne+"',"+str(LWartTech[0])+",'',0,NULL,'',NULL,'','PLN',1,"+str(LWartTech[2])+",FALSE,"
            SQLP5+="'"+Techniczne+"',"+str(LWartTech[1])+",'',0,NULL,'',NULL,'PLN',1,"+str(LWartTech[3])+",FALSE);"
            
        if SQLP+SQLP2+SQLP3+SQLP4+SQLP5 <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(SQLN,1)            
            if stat=='OK' and SQLP<> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLP,1)            
            if stat=='OK' and SQLP2<> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLP2,1)            
            if stat=='OK' and SQLP3<> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLP3,1)            
            if stat=='OK' and SQLP4<> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLP4,1)            
            if stat=='OK' and SQLP5<> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLP5,1)            
        else:
            stat='Brak danych do BO dla podanego konta.'

################################################################################
#-------------------------------------------------------------------------------
#---   UTWORZENIE DOKUMENTU BK W KOLEJNYM OKRESIE (11)
#-------------------------------------------------------------------------------
################################################################################

if Fun ==11:
    #-------------------------------------------
    # - SPRAWDZENIE DANYCH
    #-------------------------------------------
    if not UprBO:
        stat='BR UPR BO'
        
    if stat=='OK':
        Okres=rsglobal.Dekoduj(klucze[0])
        OkresNast=rsglobal.Dekoduj(klucze[1])
        DataBK=rsglobal.Dekoduj(klucze[2])

        if not rsglobal.SprawdzCzyToData(DataBK):
            stat = 'BL DATABK'

    if stat=='OK':
        (stat,Dane)=SprawdzPoprawnoscOkresow(self.PolSQL, self.firma_id, Okres, OkresNast)
        if stat=='OK':
            Rok=Dane[0]
            Mc=Dane[1]
            DataOdNast=Dane[2]

    if stat=='OK':
        (stat,dane)=SprawdzCzyKontaNMajaSaldaZerowe(self.PolSQL, self.firma_id, Okres, Rok, Mc)
        if stat=='OK':
            if len(dane)>0:
                stat='LISTA NIEWCHODZACYCH'

    if stat=='OK':
        # czy by calkowity BO
        SQL="SELECT "
        SQL+=" COUNT(DISTINCT konto_wn)"
        SQL+=" FROM rs_dowody_ksiegowe_pozycje "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresNast+"'"
        SQL+=" AND dowod_id='BO' AND POSITION('-' IN konto_wn) = 0"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)            
        if stat=='OK':
            if int(Dane[0][0])<4:
                stat='Nie byo cakowitego bilansu otwarcia'

    if stat=='OK':
        # czy sa zamkniete wszystkie BO i BK
        SQL="SELECT "
        SQL+=" COUNT(*)"
        SQL+=" FROM rs_dowody_ksiegowe "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresNast+"'"
        SQL+=" AND (dowod_id='BO' OR dowod_id='BK') AND stan<>'Z'"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)            
        if stat=='OK':
            if int(Dane[0][0])>0:
                stat='Nie wszystkie bilanse lub korekty s zamknite'

    if stat=='OK':
        # pobranie numeru BK
        SQL="SELECT COALESCE(MAX(numer)+1,1) FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+OkresNast+"' AND dowod_id='BK' AND nazwa_id='00001';"
        stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)            
        if stat=='OK':
            NrDok=str(DNr[0][0])
        #-----------------------------------------------
        # DODANIE NAGWKA DOKUMENTU BK
        #-----------------------------------------------
        SQLN="INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer,stan,kwota_wn,kwota_ma,symbol_dok,data_wyst,"
        SQLN+="data_wplywu, termin_plat, data_zapl, kontrahent_id, rejestr,data_rejestru, nr_faktury, nr_dok_mag, projekt_id) "
        SQLN+=" VALUES ('"+self.firma_id+"','"+OkresNast+"','BK','00001','"+DataBK+"',"+NrDok+",'W',0,0,'',NULL,"
        SQLN+="NULL, NULL,NULL, NULL, NULL, NULL, NULL, NULL,NULL);"

    if stat=='OK':
        # pobranie sald ze starego okresu
        SQL="SELECT "
        SQL+=" sk.konto, pk.do_bilansu, sk.waluta,"
        SQL+=" sk.saldo_wn,sk.saldo_ma,sk.saldo_wal_wn,sk.saldo_wal_ma"
        SQL+=" FROM rs_stany_kont sk"
        SQL+=" INNER JOIN rs_plan_kont pk ON (sk.firma_id=pk.firma_id AND sk.okres_id=pk.okres_id"
        SQL+=" AND pk.kontos_id=(STRING_TO_ARRAY(sk.konto,'-'))[1])"
        SQL+=" WHERE sk.firma_id='"+self.firma_id+"' AND sk.okres_id='"+Okres+"' AND pk.do_bilansu<>'N' AND sk.miesiac='"+Mc+"' AND (pk.konto_id='' OR pk.konto_id IS NULL)"
        SQL+=" ORDER BY sk.konto, sk.waluta"
        stat,SaldaStare,dump,dump = self.PolSQL.Execute(SQL,3)            
        rsglobal.ZapiszDoLogow('SALDA STARE',1)
        for poz in SaldaStare:
            rsglobal.ZapiszDoLogow(str(poz),1)
        if stat=='OK':
            # pobranie sald z nowego okresu
            SQL="SELECT "
            SQL+=" sk.konto, pk.do_bilansu, sk.waluta,"
            SQL+=" sk.saldo_wn,sk.saldo_ma,sk.saldo_wal_wn,sk.saldo_wal_ma"
            SQL+=" FROM rs_stany_kont sk"
                # join przez okres stary powoduje, e brane s pod uwag stare typy kont, a nie te z nowego okresu
            SQL+=" INNER JOIN rs_plan_kont pk ON (sk.firma_id=pk.firma_id AND pk.okres_id='"+Okres+"'" 
            SQL+=" AND pk.kontos_id=(STRING_TO_ARRAY(sk.konto,'-'))[1])"
            SQL+=" WHERE sk.firma_id='"+self.firma_id+"' AND sk.okres_id='"+OkresNast+"' AND pk.do_bilansu<>'N' AND sk.miesiac='00' AND (pk.konto_id='' OR pk.konto_id IS NULL)"
            SQL+=" ORDER BY sk.konto, sk.waluta"
            stat,SaldaNowe,dump,dump = self.PolSQL.Execute(SQL,3)
            rsglobal.ZapiszDoLogow('SALDA NOWE',1)
            for poz in SaldaNowe:
                rsglobal.ZapiszDoLogow(str(poz),1)
                
        if stat=='OK':
            # wyszukanie roznic i przygotowanie insertow
            SQLI=SQLN
            s=0
            n=0
            KontoSyntWn=0
            KontoSyntMa=0
            KontoSyntWalWn=0
            KontoSyntWalMa=0
            KontoSynt='   '
            KontoSyntWaluta=''
            NrPoz=1
            while True:
                # inicjujemy puste by nie pobiera jeli wychodzimy poza skal
                KontoS =''
                KontoN =''

                if s<len(SaldaStare):
                    KontoS=SaldaStare[s][0]
                    KontoSSynt = str(KontoS).split('-')[0]
                if n<len(SaldaNowe):
                    KontoN=SaldaNowe[n][0]
                    KontoNSynt = str(KontoN).split('-')[0]
                TypKonta=SaldaStare[s][1]
                rsglobal.ZapiszDoLogow('KontoS '+KontoS+' KontoN '+KontoN,1)
                if KontoSSynt<>KontoSynt and KontoNSynt<>KontoSynt:
                    rsglobal.ZapiszDoLogow('KONTO SYNT '+KontoSynt,1)
                    if KontoSynt.strip()<>'':
                        if KontoSyntWn<> 0 or KontoSyntMa <> 0 or KontoSyntWalWn <> 0 or KontoSyntWalMa <> 0:
                            # zapis syntetyki
                            rsglobal.ZapiszDoLogow('KONTO SYNT zapis '+KontoSynt+' Nr poz '+str(NrPoz),1)
                            SQLI+=fs_okresy_zapis_syntetyki(self.firma_id,OkresNast,DataBK,NrDok,KontoSynt,KontoSyntWaluta,KontoSyntWn,KontoSyntMa,KontoSyntWalWn,KontoSyntWalMa,NrPoz)
                            NrPoz+=1

                    if KontoN <> '':
                        KontoSynt=min(KontoS,KontoN)
                    else:
                        KontoSynt=KontoS

                    if KontoSynt.find('-') == -1:
                        # nie bedzie dodatkowej syntetyki
                        KontoSynt='   '
                    if KontoSynt==KontoS and s<len(SaldaStare):
                        KontoSyntWaluta=SaldaStare[s][2]
                    elif n<len(SaldaNowe):
                        KontoSyntWaluta=SaldaNowe[n][2]
                    
                    KontoSynt = KontoSynt.split('-')[0]
                    KontoSyntWn=0
                    KontoSyntMa=0
                    KontoSyntWalWn=0
                    KontoSyntWalMa=0


                rsglobal.ZapiszDoLogow('KONTA '+KontoS+' '+KontoN,1)
                if KontoN==KontoS:
                    rsglobal.ZapiszDoLogow('Zgodne konta '+KontoN+' '+TypKonta+' Nr poz '+str(NrPoz),1)
                    # zgodne konta badamy salda
                    if TypKonta<>SaldaNowe[n][1]:
                        stat='Niezgodno typw dla konta w planie kont: '+KontoS
                        break
                    if TypKonta=='W':
                        # konta przechodzace saldem
                        SaldoS=round(SaldaStare[s][3]-SaldaStare[s][4],4)
                        SaldoWalS=round(SaldaStare[s][5]-SaldaStare[s][6],4)
                        if (SaldoS<>round(SaldaNowe[n][3]-SaldaNowe[n][4],4)) or (SaldoWalS<>round(SaldaNowe[n][5]-SaldaNowe[n][6],4)):
                            #stat+=',SW:'+KontoS  
                            (SQL,wn,ma,wwn,wma)=fs_okresy_zapis_w(self.firma_id,OkresNast,DataBK,NrDok,SaldaStare[s],SaldaNowe[n],NrPoz)
                            SQLI+=SQL
                            KontoSyntWn+=wn
                            KontoSyntMa+=ma
                            KontoSyntWalWn+=wwn
                            KontoSyntWalMa+=wma
                            NrPoz+=1
                    elif TypKonta=='R':
                        # konta przechodzace nierozliczonymi transakcjami
                        SaldoSWn=SaldaStare[s][3]
                        SaldoSMa=SaldaStare[s][4]
                        SaldoWalSWn=SaldaStare[s][5]
                        SaldoWalSMa=SaldaStare[s][6]
                        if SaldoSWn<>SaldaNowe[n][3] or SaldoSMa<>SaldaNowe[n][4] or SaldoWalSWn<>SaldaNowe[n][5] or SaldoWalSMa<>SaldaNowe[n][6]:
                            (SQL,wn,ma,wwn,wma,NrPoz)=fs_okresy_zapis_r(self.PolSQL,self.firma_id,Okres,OkresNast,DataBK,NrDok,SaldaStare[s],SaldaNowe[n],NrPoz)
                            SQLI+=SQL
                            KontoSyntWn+=wn
                            KontoSyntMa+=ma
                            KontoSyntWalWn+=wwn
                            KontoSyntWalMa+=wma
                            #NrPoz+=1
                    s+=1
                    n+=1
                elif KontoS<KontoN or KontoN == '':
                    rsglobal.ZapiszDoLogow('Brak w BO starego konta '+KontoN+' '+TypKonta+' Nr poz '+str(NrPoz),1)
                    # brak w BO starego konta, jesli salda rozne to do korekty
                    if TypKonta=='W':
                        if round(SaldaStare[s][3]-SaldaStare[s][4],4)<>0 or round(SaldaStare[s][5]-SaldaStare[s][6],4)<>0:
                            #stat+=',O:'+KontoS
                            (SQL,wn,ma,wwn,wma)=fs_okresy_zapis_w(self.firma_id,OkresNast,DataBK,NrDok,SaldaStare[s],None,NrPoz)
                            SQLI+=SQL
                            KontoSyntWn+=wn
                            KontoSyntMa+=ma
                            KontoSyntWalWn+=wwn
                            KontoSyntWalMa+=wma
                            NrPoz+=1
                    elif TypKonta=='R':
                        if SaldaStare[s][3]<>0 or SaldaStare[s][4]<>0 or SaldaStare[s][5]<>0 or SaldaStare[s][6]<>0:
                            (SQL,wn,ma,wwn,wma,NrPoz)=fs_okresy_zapis_r(self.PolSQL,self.firma_id,Okres,OkresNast,DataBK,NrDok,SaldaStare[s],None,NrPoz)
                            SQLI+=SQL
                            KontoSyntWn+=wn
                            KontoSyntMa+=ma
                            KontoSyntWalWn+=wwn
                            KontoSyntWalMa+=wma
                            #NrPoz+=1
                    s+=1
                else:
                    rsglobal.ZapiszDoLogow('Brak nowego konta w starym okresie '+KontoN+' '+TypKonta+' Nr poz '+str(NrPoz),1)
                    # brak nowego konta w starym okresie
                    #stat+=',Z:'+KontoN
                    if n<len(SaldaNowe):
                        (SQL,wn,ma,wwn,wma)=fs_okresy_zapis_n(self.firma_id,OkresNast,DataBK,NrDok,SaldaNowe[n],NrPoz)
                        SQLI+=SQL
                        KontoSyntWn+=wn
                        KontoSyntMa+=ma
                        KontoSyntWalWn+=wwn
                        KontoSyntWalMa+=wma
                        NrPoz+=1
                    n+=1
                    if (s==len(SaldaStare)-1) and (n>len(SaldaNowe)-1):
                        rsglobal.ZapiszDoLogow('Break1',1)
                        break
                
                if (s>len(SaldaStare)-1) and (n>len(SaldaNowe)-1):
                    rsglobal.ZapiszDoLogow('Break2',1)
                    break
            
            rsglobal.ZapiszDoLogow('Zapis Syntetyki (dla niepustych kont) '+str((self.firma_id,OkresNast,DataBK,NrDok,KontoSynt,KontoSyntWaluta,KontoSyntWn,KontoSyntMa,KontoSyntWalWn,KontoSyntWalMa,NrPoz)),1)
            if KontoSynt.strip() <> '':
                rsglobal.ZapiszDoLogow('TADAM '+' Nr poz '+str(NrPoz),1)
                if KontoSyntWn<> 0 or KontoSyntMa <> 0 or KontoSyntWalWn <> 0 or KontoSyntWalMa <> 0:
                    SQLI+=fs_okresy_zapis_syntetyki(self.firma_id,OkresNast,DataBK,NrDok,KontoSynt,KontoSyntWaluta,KontoSyntWn,KontoSyntMa,KontoSyntWalWn,KontoSyntWalMa,NrPoz)
                    NrPoz+=1

    if stat=='OK' and SQLI<> SQLN:
        stat,dump,dump,dump = self.PolSQL.Execute(SQLI,1)            


################################################################################
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------
################################################################################

if Fun == 6 :
    if UprDel:
        Okr=klucze[0]
        stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT firma_id FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okr+"';",3)
        if len(dane) >0:
            stat='Dla wybranego okresu istniej ju dowody ksigowe'

        if stat == 'OK':
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT firma_id FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okr+"';",3)
            if len(dane)>0:
                stat='Dla wybranego okresu istniej ju raporty/wycigi'
        if stat == 'OK':
            stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okr+"';" ,1)
    else:
        stat='Brak uprawnie do usuwania okresu'


################################################################################
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5 -select, 6 -delete)
#-------------------------------------------------------------------------------
################################################################################

if (Fun in [5,6]) and (stat=='OK'):
    # pobranie danych o dokumentach
    Select= "SELECT data_od,data_do,zamkniety,okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' ORDER BY data_od;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    
if stat=='LISTA NIEWCHODZACYCH':
    stat='OK'
