
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_okresy_dane.py
# Purpose:     zakladanie nowego okresu ksiegowy, przenosi dane ustawienia z wybranego
#              do nowego, aktualizuje dane
#
# Author:      Michal Raburski
# Created:     many years ago
# Modified:    2009/06/15 Mariusz Rajfura  mantis:2133
# RCS-ID:      $Id: fs_grupy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-22 Mariusz Rajfura  kopiowanie danych kas/bankow do nowego okresu ksiegowego
#                             z uzyciem funkcji rsglobal.PolaTabeli (4691)
# 2011-08-31 Mariusz Rajfura  kopiowanie pozostalych rzeczy do nowego okresu z uzyciem
#                             z uzyciem funkcji rsglobal.PolaTabeli (4691)
# 2012-09-07 Mariusz Rajfura (6052) nowe pole 'odpis_zm_wart_w_przyszlym_mies'
# 2018-01-26 Aleksander Bargie (10906) dodanie rs_wzory_dekretacji_dostaw do kopiowanych tabel
# 2022-05-30 Aleksander Bargie (12797) [KS] zakadanie nowego okresu

#-------------------------------------------------------------------------------
#tworzy liste miesiecy, od daty do daty wg typu:
# 0 = pelna lista miesiecy wynikajaca z dat od-do
# 1 = lista miesiecy brakujacych z przodu do danej daty (bez koncowego) 
# 2 = lista miesiecy brakujacych z tylu od danej daty (bez poczatkowego)

def ListaMiesiecy(DataOd,DataDo,Typ):
    
    LiMies = []
    Rok = int(DataOd[0:4])
    Mies = int(DataOd[5:7])
    RokK = int(DataDo[0:4])
    MiesK = int(DataDo[5:7])
    
    while 1:
        # wypelniamy nowe
        if Typ == 0:
            LiMies.append([str(Rok),('0'+str(Mies))[-2:]])
            if Rok == RokK and Mies == MiesK:
                break
            Mies += 1
            if Mies == 13:
                Rok += 1
                Mies = 1
        
        # uzupelniamy z przodu
        elif Typ == 1:   
            if Rok == RokK and Mies == MiesK:
                break
            LiMies.append([str(Rok),('0'+str(Mies))[-2:]])
            
            Mies += 1
            if Mies == 13:
                Rok += 1
                Mies = 1
        
        #uzupelniamy z tylu
        elif Typ == 2:
            if RokK == Rok and MiesK == Mies:
                break
            LiMies.append([str(RokK),('0'+str(MiesK))[-2:]])
            MiesK -= 1
            if MiesK == 0:
                RokK -= 1
                MiesK = 12

    return LiMies

#-------------------------------------------------------------------------------
# Tworzy string PolaK, zawieracy pola do kopiowania z tabeli Tabela
# na postawie pol zawartych w stringu Pola
# Jesli pole=='okres_id', to wpisuje podany Okres 

def KopiaPol(Pola, Tabela, Okres):
    PolaK = ''
    for pole in Pola.split(','):
        if PolaK <> '':
            PolaK += ","
        if pole == 'okres_id':
            PolaK += "'"+Okres+"'"
        else:
            PolaK += Tabela+'.'+pole
                
    return PolaK

#-------------------------------------------------------------------------------
# Funkcja tworzy string do wykonania kopiowania danych z podanej tabeli i okresu
# w podanej firmie do nowego okresu ksiegowego w tej samej firmie

def UtworzSqlDoKopiowania(PolSQL,Tabela,Firma,ZOkresu,DoOkresu):
    global KopiaPol
    import rsglobal
    stat = 'OK'
    SQL = ''

    # utworzenie prefixu (aliasu) do wskazania zrodla kopiowania
    # z pierwszych liter czlonow nazwy tabeli
    lnazwa = Tabela.split('_')
    prefix = ''
    for i in xrange(len(lnazwa)):
        prefix += lnazwa[i][0]
    
    stat, listapol = rsglobal.PolaTabeli(PolSQL, Tabela, [])
    if stat == 'OK':
        pola = str(listapol).replace("[","").replace("]","").replace("'","").replace(" ","")
        polakopia = KopiaPol(pola,prefix,DoOkresu)
    
        SQL =" INSERT INTO "+Tabela+" ("+pola+")"
        SQL+=" SELECT "+polakopia
        SQL+=" FROM "+Tabela+" "+prefix
        SQL+=" WHERE "+prefix+".firma_id='"+Firma+"'"
        SQL+=" AND "+prefix+".okres_id='"+ZOkresu+"'"
        
        if Tabela in ('rs_wzory_dekretacji','rs_wzory_dekretacji_pozycje'):
            # ominiecie wzorow dla BO i BK, ktore sa tworzone od nowa
            SQL+=" AND "+prefix+".dowod_id<>'BO' AND "+prefix+".dowod_id<>'BK'"
        
        SQL+=";"

    return stat, SQL

#-------------------------------------------------------------------------------

# struktura klucze[]
# 0 - okres, jesli zakladanie nowego, moze zawierac nr okresu do skopiowania
# 1 - data pocz okresu
# 2 - data konc okresu
# 3 - poprzednia data pocz okresu (dot.edycji)
# 4 - poprzednia data konc okresu (dot.edycji)
# ostatni param = funkcja

Okres = klucze[0].strip()
DataOd = klucze[1].strip()
DataDo = klucze[2].strip()
DataOdP = klucze[3].strip()
DataDoP = klucze[4].strip()
OdpisZmWartWPrzyszlymMies = klucze[5]
DlugoscSyntetyki = klucze[6]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

UprDodawanie = self.operator_id == STANDARD_OPERATOR_ID
UprEdytowanie = UprDodawanie or (self.oddzial_id,'071012') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID


# sprawdzenie uprawnien
if Fun == 1:
    if not UprDodawanie:
        stat = 'BR_UPR_DOD'
        dane.append(stat)

if Fun ==  3:
    if not UprEdytowanie:
        stat = 'BR_UPR_MOD'
        dane.append(stat)


# kontrola danych       
if Fun in (1,3) and stat == 'OK':
    
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat = 'BL_DATA_OD'
        dane.append(stat)
        
    if not rsglobal.SprawdzCzyToData(DataDo):
        stat = 'BL_DATA_DO'
        dane.append(stat)
        
    if stat == 'OK':
        if DataOd > DataDo:
            stat = 'BL_DATA_ODDO'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   DODANIE NOWEGO OKRESU  - 1
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    
    Nr = str(DataOd)[2:4]
    
    sql = "SELECT max(okres_id) FROM rs_definicje_okresow WHERE firma_id = '"+self.firma_id+"'"
    sql += " AND okres_id LIKE '"+Nr+"%';"
    
    stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
    
    if stat <> 'OK':
        stat = 'Bd pobrania definicji okresw ksigowych: '+stat
        dane.append(stat)
    
    if stat == 'OK':
        if Dane[0][0] == 'None':
            Nr += ' '
        elif Dane[0][0] == Nr+' ':
            Nr += 'a'
        else:
            Znak = Dane[0][0]
            Znak = Znak[2:3]
            Znak = chr(ord(Znak)+1)
            Jest = False
            
            # ta petla pozwala zalozyc prawidlowy okres
            # nawet wtedy, gdy by zalozony okres z wykrzyknikiem
            # lub innymi dziwnymi znakami, chyba, ze wyjdzie poza 'z'
            # mariusz rajfura  mantis:2133
            
            while 1:
                if ord(Znak) in range(ord('a'),ord('z')+1):
                    Jest = True
                    break
                Znak = chr(ord(Znak)+1)
                if ord(Znak) > ord('z'):
                    break
                
            Nr += Znak

            if not Jest:
                stat = u"Bdny identyfikator okresu: "+Nr
                dane.append(stat)
            
    
    if stat=='OK':
        Zap = ''

        #zapis nowego okresu
        Zap+="INSERT INTO rs_definicje_okresow"
        Zap+=" (firma_id,okres_id,data_od,data_do,zamkniety,odpis_zm_wart_w_przyszlym_mies,dlug_syntetyki)"
        Zap+= " VALUES"
        Zap+=" ('"+self.firma_id+"','"+Nr+"','"+DataOd+"','"+DataDo+"',FALSE,"+str(OdpisZmWartWPrzyszlymMies)+","+str(DlugoscSyntetyki)+");"
        
        #zapis okresw - nowych miesicy
        LMies = ListaMiesiecy(DataOd,DataDo,0)
        SQL=''
        for mies in LMies:
            SQL += " INSERT INTO rs_definicje_okresow_miesiace (firma_id,okres_id,rok,miesiac,zamkniety)"
            SQL += " VALUES ('"+self.firma_id+"','"+Nr+"','"+mies[0]+"','"+mies[1]+"',False);"
            
        Zap += SQL
            
        #zapis nag\u0142\xf3wka wzoru bilansu otwarcia
        Zap+=" INSERT INTO rs_wzory_dekretacji (firma_id,okres_id,dowod_id,nazwa_id,nazwa,czy_symbol_dok,"
        Zap+="mod_symbol_dok,symbol_dok,czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,"
        Zap+="czy_kontrahent_id,mod_kontrahent_id,dod_kontrahent,kontrahent_id,czy_rejestr,mod_rejestr,"
        Zap+="rejestr,czy_data_rejestru,dod_pozycje,typ_wzoru,waluta)"
        Zap+=" VALUES ('"+self.firma_id+"','"+Nr+"','BO','00001','Bilans otwarcia',FALSE,"
        Zap+="FALSE,'',FALSE,FALSE,FALSE,FALSE,"
        Zap+="FALSE,FALSE,FALSE,NULL,FALSE,FALSE,"
        Zap+="NULL,FALSE,TRUE,'S','PLN');"
        
        #zapis pozycji wzoru bilansu otwarcia
        pola="firma_id,okres_id,dowod_id,nazwa_id,nr_poz,czy_symbol_dok,mod_symbol_dok,symbol_dok,"
        ski = "'%s','%s','%s','%s',%s,%s,%s,'%s',"
        pola+= "czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,czy_kontrahent_id,mod_kontrahent_id,kontrahent_id,"
        ski += "%s,%s,%s,%s,%s,%s,%s,"
        pola+= "czy_konto_wn,mod_konto_wn,konto_wn,czy_konto_vat_wn,mod_konto_vat_wn,konto_vat_wn,mod_stawka_vat_wn,stawka_vat_wn,czy_tresc_wn,mod_tresc_wn,tresc_wn,czy_sposob_rozl,mod_sposob_rozl,sposob_rozl,"
        ski += "%s,%s,'%s',%s,%s,'%s',%s,%s,%s,%s,'%s',%s,%s,%s,"
        pola+= "czy_konto_ma,mod_konto_ma,konto_ma,czy_konto_vat_ma,mod_konto_vat_ma,konto_vat_ma,mod_stawka_vat_ma,stawka_vat_ma,czy_tresc_ma,mod_tresc_ma,tresc_ma";
        ski += "%s,%s,'%s',%s,%s,'%s',%s,%s,%s,%s,'%s'"
        
        dane = (self.firma_id,Nr,'BO','00001','1','TRUE','TRUE','',
                'TRUE','FALSE','TRUE','FALSE','TRUE','TRUE','NULL',
                'TRUE','TRUE','','FALSE','FALSE','','FALSE','NULL','TRUE','TRUE','','FALSE','FALSE','NULL',
                'TRUE','TRUE','','FALSE','FALSE','','FALSE','NULL','TRUE','TRUE','')
        
        Zap+= ("INSERT INTO rs_wzory_dekretacji_pozycje ("+pola+") VALUES ("+ski+");") % dane

        #zapis nag\u0142\xf3wka wzoru korekty bilansu otwarcia
        Zap+= "INSERT INTO rs_wzory_dekretacji (firma_id,okres_id,dowod_id,nazwa_id,nazwa,czy_symbol_dok,"
        Zap+="mod_symbol_dok,symbol_dok,czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,"
        Zap+="czy_kontrahent_id,mod_kontrahent_id,dod_kontrahent,kontrahent_id,czy_rejestr,mod_rejestr,"
        Zap+="rejestr,czy_data_rejestru,dod_pozycje,typ_wzoru,waluta)"
        Zap+= " VALUES ('"+self.firma_id+"','"+Nr+"','BK','00001','Bilans otwarcia - korekta',FALSE,"
        Zap+="FALSE,'',FALSE,FALSE,FALSE,FALSE,"
        Zap+="FALSE,FALSE,FALSE,NULL,FALSE,FALSE,"
        Zap+="NULL,FALSE,TRUE,'S','PLN');"

        #zapis pozycji wzoru korekty bilansu otwarcia
        pola="firma_id,okres_id,dowod_id,nazwa_id,nr_poz,czy_symbol_dok,mod_symbol_dok,symbol_dok,"
        ski ="'%s','%s','%s','%s',%s,%s,%s,'%s',"
        pola+= "czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,czy_kontrahent_id,mod_kontrahent_id,kontrahent_id,"
        ski += "%s,%s,%s,%s,%s,%s,%s,"
        pola+= "czy_konto_wn,mod_konto_wn,konto_wn,czy_konto_vat_wn,mod_konto_vat_wn,konto_vat_wn,mod_stawka_vat_wn,stawka_vat_wn,czy_tresc_wn,mod_tresc_wn,tresc_wn,czy_sposob_rozl,mod_sposob_rozl,sposob_rozl,"
        ski += "%s,%s,'%s',%s,%s,'%s',%s,%s,%s,%s,'%s',%s,%s,%s,"
        pola+= "czy_konto_ma,mod_konto_ma,konto_ma,czy_konto_vat_ma,mod_konto_vat_ma,konto_vat_ma,mod_stawka_vat_ma,stawka_vat_ma,czy_tresc_ma,mod_tresc_ma,tresc_ma";
        ski += "%s,%s,'%s',%s,%s,'%s',%s,%s,%s,%s,'%s'"
        
        dane = (self.firma_id,Nr,'BK','00001','1','TRUE','TRUE','',
                'TRUE','FALSE','TRUE','FALSE','TRUE','TRUE','NULL',
                'TRUE','TRUE','','FALSE','FALSE','','FALSE','NULL','TRUE','TRUE','','FALSE','FALSE','NULL',
                'TRUE','TRUE','','FALSE','FALSE','','FALSE','NULL','TRUE','TRUE','')

        Zap+= ("INSERT INTO rs_wzory_dekretacji_pozycje ("+pola+") VALUES ("+ski+");") % dane
        
        #jesli wybrano okres, z ktorego nalezy przepisac ustawienia okresu ksiegowego
        #tworzymy sql-e do kopiowania tabel z podanego okresu

        if Okres <> '':
            ListaTabel = ['rs_grupy_analityczne',
                          'rs_plan_kont',  
                          'rs_konta_analityczne',
                          'rs_wzory_dekretacji',  
                          'rs_wzory_dekretacji_pozycje',  
                          'rs_wzory_dekretacji_faktur',  
                          'rs_wzory_dekretacji_magazynow',  
                          'rs_wzory_dekretacji_przeksiegowan',  
                          'rs_wzory_dekretacji_roznice_kursowe',
                          #AB dodanie rs_wzory_dekretacji_dostaw
                          'rs_wzory_dekretacji_dostaw',
                          'rs_wzory_dekretacji_upr',
                          'rs_wzory_dekretacji_typy',
                          'rs_wzory_dekretacji_plac',  #AB 30.05.22r
                          'rs_kasy_banki',
                          'rs_kasy_banki_pozycje',  #AB 30.05.22r
                          'rs_kasy_banki_upr',
                          'rs_kasy_banki_plik_kolumny',
                          'rs_kasy_banki_plik_dekretacja',
                          'rs_kasy_banki_sposoby_zaplaty',  #AB 30.05.22r
                          ]

            if stat == 'OK':
                for Tabela in ListaTabel:
                    stat,sql = UtworzSqlDoKopiowania(self.PolSQL,Tabela,self.firma_id,Okres,Nr)
                    if stat == 'OK':
                        Zap += sql
                    else:
                        break
            
                    
        if stat == 'OK':
            stat,d,dump,dump = self.PolSQL.Execute(Zap,1)
            if stat == 'OK':
                #zmienna Okres staje sie Nr dla pobrania danych
                Okres = Nr  
            else:
                stat = 'Bd zakadania nowego okresu ksigowego '+Nr+' :'+stat

        
#-------------------------------------------------------------------------------
#---   MODYFIKACJA OKRESU KSIEGOWEGO - 3
#-------------------------------------------------------------------------------
 
if Fun == 3 and stat == 'OK':
    
    #sprawdzenie kwestii definicji miesiecy
    
    sql = "SELECT rok,miesiac,zamkniety FROM rs_definicje_okresow_miesiace"
    sql +=" WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+Okres+"';"
    
    stat,DaneMies,dump,dump = self.PolSQL.Execute(sql,3)
    
    if stat <> 'OK':
        stat = 'Bd pobrania definicji okresw ksigowych :'+stat
        dane.append(stat)
        
    SQL = ''
    
    if stat == 'OK':
        SQL+=" UPDATE rs_definicje_okresow "
        SQL+=" SET data_od='"+DataOd+"',data_do='"+DataDo+"'"
        SQL+=" ,odpis_zm_wart_w_przyszlym_mies="+str(OdpisZmWartWPrzyszlymMies)
        SQL+=" ,dlug_syntetyki="+str(DlugoscSyntetyki)
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+Okres+"';"
        
        #jak nie ma miesiecy wogole to robimy to tak:
        #zapis okresw - miesicy - ju dla nowych dat
        
        if DaneMies == []:
            LMies = ListaMiesiecy(DataOd,DataDo,0)
            for mies in LMies:
                SQL+=" INSERT INTO rs_definicje_okresow_miesiace (firma_id,okres_id,rok,miesiac,zamkniety)"
                SQL+=" VALUES ('"+self.firma_id+"','"+Okres+"','"+mies[0]+"','"+mies[1]+"',False);"
        
        else:
            #modyfikujemy aktualne daty
            
            #sprawdzamy, czy w przypadku skracacania okresow z przodu lub z tylu
            #istnieja dowody ksiegowe w zakresach dat, ktore maja byc usuniety
            
            if (DataOd > DataOdP) or (DataDo < DataDoP):
                sql = "SELECT COUNT(*) FROM rs_dowody_ksiegowe"
                sql+= " WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+Okres+"' AND ("
                
                if DataOd > DataOdP:
                    sql += "( data >= '"+DataOdP+"' AND data < '"+DataOd+"' )"
                 
                if DataDo < DataDoP:
                    if DataOd >DataOdP:
                        sql += " OR "
                        
                    sql += "( data > '"+DataDo+"' AND data <= '"+DataDoP+"' )"
                    
                sql += ");"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat == 'OK':
                    if int(d[0][0]) > 0:
                        stat = 'Dowody ksigowe poza podanym okresem ('+str(d[0][0])+').\nModyfikacja niemoliwa.'
                        dane.append(stat)
                else:
                    stat = 'Bd pobrania informacji o dowodach ksigowych: '+stat
                    dane.append(stat)
            
            if stat == 'OK':
                
                LMiesDod = []
                LMiesUsu = []
            
                #dodajemy z przodu nowe miesiace
                if DataOd < DataOdP:
                    LMiesDod.extend(ListaMiesiecy(DataOd,DataOdP,1))

                #usuwamy z przodu stare miesiace
                if DataOd > DataOdP:
                    LMiesUsu.extend(ListaMiesiecy(DataOdP,DataOd,1))
                
                #dodajemy z tylu nowe miesiace
                if DataDo > DataDoP:
                    LMiesDod.extend(ListaMiesiecy(DataDoP,DataDo,2))

                #usuwamy z tylu stare miesiace
                if DataDo < DataDoP:
                    LMiesUsu.extend(ListaMiesiecy(DataDo,DataDoP,2))
                
                #sprawdzanie czy nie zostan usunite zamknite miesice
            
                OK = 'OK'
                for MiesUsu in LMiesUsu:
                    for Miesiac in DaneMies:
                        if MiesUsu[0]==str(Miesiac[0]) and MiesUsu[1]==str(Miesiac[1]) and Miesiac[2]:
                            OK=Miesiac[0]+'/'+Miesiac[1]
                            break
                    if OK <> 'OK':
                        break
            
                if OK <> 'OK':
                    stat = 'Nie mona zmieni dat okresu - zamknity miesic '+OK
                    dane.append(stat)
                
            if stat == 'OK':
                for mies in LMiesDod:
                    SQL+=" INSERT INTO rs_definicje_okresow_miesiace (firma_id,okres_id,rok,miesiac,zamkniety)"
                    SQL+=" VALUES ('"+self.firma_id+"','"+Okres+"','"+mies[0]+"','"+mies[1]+"',False);"
                
                for mies in LMiesUsu:
                    SQL+=" DELETE FROM rs_definicje_okresow_miesiace WHERE firma_id='"+self.firma_id+"'"
                    SQL+=" AND okres_id='"+Okres+"' AND rok='"+mies[0]+"' AND miesiac='"+mies[1]+"';"

    if stat == 'OK' and SQL <> '':
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji okresu ksigowego: '+stat
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH 
#-------------------------------------------------------------------------------

if stat == 'OK':
    sql = "SELECT * FROM rs_definicje_okresow WHERE okres_id='"+Okres+"'"
    sql += " AND firma_id='"+self.firma_id+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bd pobrania danych okresu ksigowego: '+stat
