
# -*- coding: iso8859_2 -*-

#s-----------------------------------------------------------------------------
# Name:        fs_okresy.py
# Purpose:     wczytuje/usuwa dane z list okresw ksigowych
#              oraz tworzy dokument BO
#
# Author:      Micha Raburski
# Created:     2013/03/26
# Modified:    2013/03/26
# RCS-ID:      $Id: fs_okresy_pom.py $
# Copyright:   (c) 2004-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2021-12-14 Aleksander Bargie - (12766) Zmiany w zamykaniu paragonw i faktur

# Funkcja, ktra dodaje pozycj z rozrachunkow


##--------------------------------------------------------------

def DodajPozycjeRozrachunkowaNaBilansOtwarcia(firma_id,OkresNast,DataOdNast,Lp,konto,SQL,CzyCalkowite,Techniczne,NrDok,SPozycji,BK=False):
    import rsglobal
    #konto z aktualnie przetwarzanej syntetyki
    if konto[6] in (None,'None'):
        SymbDok='NULL'
    else:
        SymbDok="'"+rsglobal.Dekoduj(konto[6])+"'"
                    
    if konto[7] in ('',None,'None'):
        DataWyst='NULL'
    else:
        DataWyst="'"+rsglobal.Dekoduj(konto[7])+"'"
        
    if konto[8] in ('',None,'None'):
        DataWpl='NULL'
    else:
        DataWpl="'"+rsglobal.Dekoduj(konto[8])+"'"
        
    if konto[9] in ('',None,'None'):
        TerminPlat='NULL'
    else:
        TerminPlat="'"+rsglobal.Dekoduj(konto[9])+"'"
        
    if konto[10] in ('',None,'None'):
        DataZapl='NULL'
    else:
        DataZapl="'"+rsglobal.Dekoduj(konto[10])+"'"
        
    if konto[11] in ('',None,'None'):
        Kontr='NULL'
    else:
        Kontr="'"+rsglobal.Dekoduj(konto[11])+"'"

    if konto[20] in ('',None,'None',0,'0'):
        Platnosc='NULL'
    else:
        Platnosc=str(konto[20])

    Tresc='Nr:'+str(konto[15])
    if not konto[12] in (None,'None'):
        Tresc=rsglobal.Dekoduj(konto[12])[0:99-len(Tresc)]+' '+Tresc

    if konto[13] in ('',None,'None'):
        Projekt='NULL'
    else:
        Projekt="'"+rsglobal.Dekoduj(konto[13])+"'"
    
    Kurs =1
    if not konto[14] in (0,1,'',None,'None'):
        Kurs= konto[14]
    if not BK:
        SymbolDowodu='BO'
    else:
        SymbolDowodu='BK'
    # jeli rozliczone wczeniej
    if (konto[21]<>0 or konto[22]<>0):
        KwotaWn=konto[21]
        KwotaMa=konto[22]
        KwotaWalWn=konto[23]
        KwotaWalMa=konto[24]
    else:
        KwotaWn=konto[2]
        KwotaMa=konto[3]
        KwotaWalWn=konto[4]
        KwotaWalMa=konto[5]

    DataRozlicz=konto[27]
    NrPierw=konto[28]

    # sprawdzamy, czy nie istnieje ju odpowiedni rozrachunek i nie zwikszamy jego wartoci jedynie
    if KwotaWn<>0:
        KontoWn=rsglobal.Dekoduj(konto[0])
    elif not CzyCalkowite and KwotaMa<>0:
        KontoWn=Techniczne
    else:
        KontoWn=''        

    if KwotaMa<>0:
        KontoMa=rsglobal.Dekoduj(konto[0])
    elif not CzyCalkowite and KwotaWn<>0:
        KontoMa=Techniczne
    else:
        KontoMa=''        

    KluczPoz=(SymbDok,DataWyst,DataWpl,TerminPlat,DataZapl,Kontr,KontoWn,KontoMa,konto[25],konto[26],NrPierw)
    if (not KluczPoz in SPozycji) or DataRozlicz=='':
        # nie byo jeszcze pozycji pasujcej do tego rozrachunku
        SQL+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,nr_pozw,"
        SQL+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,platnosc_id,"
        SQL+="konto_wn,kwota_wn,konto_vat_wn,kwota_vat_wn,stawka_vat_wn,tresc_wn,projekt_wn,sposob_rozl,waluta_wn,kurs_wn,kwota_wal_wn,nkup,"
        SQL+="konto_ma,kwota_ma,konto_vat_ma,kwota_vat_ma,stawka_vat_ma,tresc_ma,projekt_ma,waluta_ma,kurs_ma,kwota_wal_ma,pnop)"
        SQL+=" VALUES ('"+firma_id+"','"+OkresNast+"','"+SymbolDowodu+"','00001','"+DataOdNast+"',"+NrDok+","+str(Lp)+",0,1,"
        SQL+=SymbDok+","+DataWyst+","+DataWpl+","+TerminPlat+",NULL,"+Kontr+","+Platnosc+","
        if KwotaWn<>0:
            SQL+="'"+rsglobal.Dekoduj(konto[0])+"',"+str(KwotaWn)+",'',0,NULL,'"+Tresc+"',"+Projekt+",'','"+rsglobal.Dekoduj(konto[1])+"',"+str(Kurs)+","+str(KwotaWalWn)+",FALSE,"
        elif not CzyCalkowite and KwotaMa<>0:
            SQL+="'"+Techniczne+"',"+str(KwotaMa)+",'',0,NULL,'"+Tresc+"',"+Projekt+",'','"+rsglobal.Dekoduj(konto[1])+"',"+str(Kurs)+","+str(KwotaWalMa)+",FALSE,"
        else:
            SQL+="'',0,'',0,NULL,'',NULL,'','"+str(konto[1])+"',"+str(Kurs)+",0,FALSE,"
            
        if KwotaMa<>0:
            SQL+="'"+rsglobal.Dekoduj(konto[0])+"',"+str(KwotaMa)+",'',0,NULL,'"+Tresc+"',"+Projekt+",'"+rsglobal.Dekoduj(konto[1])+"',"+str(Kurs)+","+str(KwotaWalMa)+",FALSE);"
        elif not CzyCalkowite and KwotaWn<>0:
            SQL+="'"+Techniczne+"',"+str(KwotaWn)+",'',0,NULL,'"+Tresc+"',"+Projekt+",'"+rsglobal.Dekoduj(konto[1])+"',"+str(Kurs)+","+str(KwotaWalWn)+",FALSE);"
        else:
            SQL+="'',0,'',0,NULL,'',NULL,'"+str(konto[1])+"',"+str(Kurs)+",0,FALSE);"
        
        SPozycji[KluczPoz]=Lp
        Lp+=1
    else:
        NrPoz=str(SPozycji[KluczPoz])
        SQL+="UPDATE rs_dowody_ksiegowe_pozycje SET "
        if KwotaWn<>0:
            SQL+="kwota_wn=kwota_wn+ "+str(KwotaWn)
            SQL+=",kwota_wal_wn=kwota_wal_wn+ "+str(KwotaWalWn)
        elif not CzyCalkowite and KwotaMa<>0:
            SQL+="kwota_wn=kwota_wn+ "+str(KwotaMa)
            SQL+="kwota_wal_wn=kwota_wal_wn+ "+str(KwotaWalMa)
            
        if KwotaMa<>0:
            SQL+="kwota_ma=kwota_ma+ "+str(KwotaMa)
            SQL+=",kwota_wal_ma=kwota_wal_ma+ "+str(KwotaWalMa)
        elif not CzyCalkowite and KwotaWn<>0:
            SQL+="kwota_ma=kwota_ma+ "+str(KwotaWn)
            SQL+="kwota_wal_ma=kwota_wal_ma+ "+str(KwotaWalWn)
        SQL+="WHERE firma_id='"+firma_id+"' AND okres_id='"+OkresNast+"' AND dowod_id='"+SymbolDowodu+"'"
        SQL+=" AND nazwa_id='00001' AND data='"+DataOdNast+"' AND numer="+NrDok+" AND nr_poz="+NrPoz+";"

    return SQL,Lp,SPozycji

#AB 14.12.21r
def PodajOkresDlaDaty(self, Data):
    """Metoda zwraca symbol okresu dla wskazanej daty, w formacie:

     stat, okres
     """
    import rsglobal

    sql = """SELECT okres_id 
             FROM rs_definicje_okresow
             WHERE firma_id = %s AND %s BETWEEN data_od AND data_do
             ;"""
    stat, okres, dump, dump = self.PolSQL.Execute(sql, 3, [self.firma_id, Data], CzyDodawacBlad=True)
    if stat != 'OK':
        return stat, None
    elif len(okres) < 1:
        return "Nie odnaleziono okresu ksigowego.", None
    else:
        return stat, rsglobal.Dekoduj(okres[0][0])
