# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_operacje.py
# Purpose:     zwraca liste operacji z kont wg podanego filtru
#
# Author:      Mariusz Rajfura
#
# Created:     2009/06/29
# RCS-ID:      $Id: fs_operacje.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# klucze: jesli jest podany filtr z reki z , to on ma pierszenstwo wykonania
# 2016-06-01 Piotr Witkowski (9853) Proba o zwikszenie limity wywietlanych wierszy na gridzie operacji
# 2018-03-19 Aleksander Bargie 10961 - przygotowanie do bdw w tworzeniu pliku .xlsx
# 2021-11-03 Wojciech Skowron - (12174) Poprawiona obsuga pliku
# 2024-02-20 Wojciech Skowron - (13695) Przyjmowany stat z ZapiszXLSZDanych


from funkcje import fs_pliki_office
import tempfile
import binascii
import rsglobal


KontoF = rsglobal.Dekoduj(klucze[0])
DataOdF = rsglobal.Dekoduj(klucze[1])
DataDoF = rsglobal.Dekoduj(klucze[2])
DataKsiegKosztow = rsglobal.Dekoduj(klucze[3])
Naglowek = rsglobal.Dekoduj(klucze[5])
Kolumny = rsglobal.Dekoduj(klucze[6])
Funkcja = rsglobal.Dekoduj(klucze[7])

stat = 'OK'
dane = []
wyn1 = []

#Pobranie okresu dla dziaa w planie kont jeli podana jest data ksigowania kosztw
OkresAktywny=self.okres_id
if not DataKsiegKosztow in ['','    -  -  ',None]:
    if rsglobal.SprawdzCzyToData(DataKsiegKosztow):
        Select= "SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+DataKsiegKosztow+"');"
        stat,DOkr,dump,dump = self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(DOkr)>0:
                if DOkr[0][0]<> 'Brak':
                    OkresAktywny=rsglobal.Dekoduj(DOkr[0][0])
if stat=='OK':
# pobranie dat pocztkowej i kocowej dla tego okresu
    SQL="SELECT data_od,data_do FROM rs_definicje_okresow WHERE "
    SQL+=" firma_id='"+self.firma_id +"' AND okres_id='"+OkresAktywny+"';"
    stat,DOkr,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        DataOkrOd=rsglobal.Dekoduj(DOkr[0][0])
        DataOkrDo=rsglobal.Dekoduj(DOkr[0][1])

if stat=='OK':
    Filtr =" FROM rs_operacje WHERE firma_id = '"+self.firma_id+"' " \
           " AND COALESCE(data_ksieg_kosztow,data)>='"+DataOkrOd+"'" \
           " AND COALESCE(data_ksieg_kosztow,data)<='"+DataOkrDo+"'"

    if KontoF != '':
        Filtr+=" AND konto LIKE '"+KontoF+"%'"
    
    if DataOdF != '    -  -  ':
        if rsglobal.SprawdzCzyToData(DataOdF):
            Filtr+=" AND COALESCE(data_ksieg_kosztow,data) >= '"+DataOdF+"'"
        else:
            stat='Bdna data pocztkowa: '+DataOdF

if stat=='OK':
    if DataDoF != '    -  -  ':
        if rsglobal.SprawdzCzyToData(DataDoF):
            Filtr+=" AND COALESCE(data_ksieg_kosztow,data) <= '"+DataDoF+"'"
        else:
            stat='Bdna data kocowa: '+DataDoF
            
if stat=='OK':
    if len(dane)==0 and DataOdF != '    -  -  ' and DataDoF != '    -  -  ':
        if DataOdF > DataDoF:
            stat='Data pocztkowa jest starsza od daty kocowej.'

# sprawdzenie czy nie przekraczamy liczby 130000 wierszy #PW 2017-04-19 ?(10460)
if stat=='OK' and Funkcja == 5:
    SQLTest = "SELECT COUNT(*) "+Filtr
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQLTest,3)
    if stat != 'OK':
        stat = 'Bdy testowania liczby wierszy pobranych:'+stat
    elif dane[0][0] > 130000 and Funkcja==5:
        stat ='Pobrano '+str(dane[0][0])+' wierszy (limit 130000). Prosz o podanie bardziej szczegowych filtrw lub zapisa do pliku XLS'
    elif dane[0][0] == 0 and Funkcja==6:
        stat = u'Brak danych'

# faktyczne pobranie danych
if stat=='OK' and Funkcja in [5,6]:
    sql ="SELECT konto,dowod_id,nazwa_id,data,numer,kwota_wn,kwota_ma,"
    sql+=" symbol_dok,tresc,seria "+Filtr
    sql+=" ORDER BY dowod_id,nazwa_id,konto,data,numer,nr_poz,nr_ppoz;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania operacji: '+stat


# --#############################################################################
#   FUNKCJA TWORZACA XLS (6)
# --#############################################################################

if stat == 'OK' and Funkcja ==6:
    Kodowanie = 'iso8859_2'
    Plik = tempfile.mktemp('.xlsx')
    try:  #AB otoczenie w try/except
        stat = fs_pliki_office.ZapiszXLSZDanych(dane,Plik,wyn1,Naglowek,Kodowanie,Kolumny) #dodatkowy parametr Kolumny  #WS 2024-02-20 - stat=
        if stat == 'OK':
            #WS 2021-11-03
            with open(Plik, 'rb') as p:
                dane = [binascii.hexlify(buffer(p.read()))]
            # dane = [binascii.hexlify(buffer(open(Plik, 'rb').read()))]
    except Exception, e:
        stat = str(e)
        rsglobal.ZapiszDoLogow(stat, 1)

