# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_operatorzy.py
# Purpose:     pobiera liste operatorow, dezaktuwuje/aktywuje
#
# Author:      Mariusz Rajfura
# Created:     2009/05/06
# RCS-ID:      $Id: fs_operatorzy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-08-08 Mariusz Rajfura    (5985)  dane do grida sortowane wg 'nazwisko,imie'
# 2017-12-20 Rafa Woniak      (10536) refaktoryzacja rsoperatorzy i podokien
# 2020-11-13 Aleksander Bargie (12186) [AD] Zmiana w dodawaniu operatora
# 2021-10-07 Aleksander Bargie (12662) [WF] zmiana w F1 z operatorw
# 2021-12-06 Bartosz Pagan (12757) Operatorzy - pobierz log

import time
from datetime import datetime, timedelta

#RW pobieranie danych z kluczy
stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    if stat == 'OK':
        if Fun in [3, 7]:
            Id = str(klucze['Id'])
        if Fun in [3]:
            Nazwa= klucze['Nazwa']
        if Fun in [3, 5, 6]:
            BezTechnicznych = klucze['BezTechnicznych']
        if Fun in [5, 6]:  #AB 07.10.21r
            WF = klucze['WF']
        else:
            WF = False
        if WF:  #AB 07.10.21r
            komorka  = klucze['komorka']
            dokument = klucze['dokument']
            stan     = klucze['stan']
dane = []
firma_id = self.firma_id  #AB 07.10.21r

#-------------------------------------------------------------------------------
#---   POBRANIE LOGOW OPERATORA (7)
#-------------------------------------------------------------------------------

if Fun == 7 and stat == 'OK':
    if self.operator_id <> STANDARD_OPERATOR_ID:
        stat = "Tylko operator 'anakonda' moe pobra log operatora."
        
    if stat == 'OK':
        sql ="SELECT login FROM rs_operatorzy WHERE operator_id="+Id+";"
        stat,OpLogin,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania loginu operatora: '+stat
        elif len(OpLogin) == 0:
            stat = 'Brak operatora o kodzie '+Id
    #BP 2021-12-06
    if stat == 'OK':
        LogOperatora = rsglobal.LogFile+'-'+Id
        try:
            with open(LogOperatora,'rb') as d:
                dzis = datetime.now().strftime("%Y.%m.%d")
                wczoraj = (datetime.now() - timedelta(days=1)).strftime("%Y.%m.%d")
                dLog = ['Log operatora: ('+Id+') '+rsglobal.Dekoduj(OpLogin[0][0])+'\n']
                dLog.append('Plik: '+LogOperatora+'\nCzas pobrania: '+time.ctime()+'\n')
                dLog.append('===================================================\n\n\n')


                mozeDopisywac = False
                for ln in d:
                    if mozeDopisywac:
                        dLog.append(ln)
                    elif ln.startswith(dzis) or ln.startswith(wczoraj):
                        mozeDopisywac = True
                        dLog.append(ln)
                dLog = ''.join(dLog)
                dane.append([dLog])

        except:
            import traceback
            rsglobal.ZapiszDoLogow(traceback.format_exc())
            stat = "Brak pliku '"+LogOperatora+"'\ndla operatora '"+rsglobal.Dekoduj(OpLogin[0][0])+"'"


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3 - update )
#-------------------------------------------------------------------------------
if stat=='OK' and Fun==3 and self.operator_id==STANDARD_OPERATOR_ID:

    rsglobal.ZapiszDoLogow(Id,1)
    rsglobal.ZapiszDoLogow(Nazwa,1)
    duplikat = False
    sql = "SELECT duplikat FROM rs_operatorzy WHERE operator_id={}".format(Id)
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)

    rsglobal.ZapiszDoLogow("sql: {}".format(sql))
    rsglobal.ZapiszDoLogow("duplikat: {}".format(dane))

    if stat == 'OK':
        duplikat = dane[0][0]

    if stat == 'OK' and not duplikat:
        upd="DROP USER "+str(Nazwa)
        ss,dump,dump,dump = self.PolSQL.Execute(upd,1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow("drop: {}".format(ss))
        #ignoruje ewentualne niepowodzenie operacji DROP USER
        if self.PolSQL2 is not self.PolSQL:
            # to samo na serwerze do raportw itp
            dump, dump, dump, dump = self.PolSQL2.Execute(upd, 1)

    if stat == 'OK':
        upd="UPDATE rs_operatorzy SET aktywny = FALSE WHERE operator_id = "+Id+";"
        stat,dump,dump,dump = self.PolSQL.Execute(upd,1)
        if stat<>'OK':
            stat='Bd deaktywacji operatora: '+stat

    
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select wszystkich    6 - select tylko aktywnych
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (3,5,6):

    where="WHERE TRUE"
    if Fun==6:
        where+=" AND aktywny "
    if BezTechnicznych:
        where+=" AND NOT login= 'raporty' AND NOT login= 'harmonogram' "

    if WF:  #AB 07.10.21r
        komorka  = komorka.strip()
        dokument = dokument.strip()
        stan     = stan.strip()
        where += " AND operator_id IN (SELECT DISTINCT operator_id FROM rs_wf_uprawnienia_szczegoly WHERE firma_id ='{}'" \
                 " AND dokument_id = '{}' AND komorka_id = '{}' AND przejscia LIKE '%\\'{}\\',%')".format(firma_id, dokument, komorka, stan)
    
    if where=="WHERE TRUE":
        where=''
    #AB 13.11.20r
    sql="SELECT operator_id,aktywny,login,imie,nazwisko, duplikat FROM rs_operatorzy "+where+"ORDER BY nazwisko,imie;"
    stat,dane,wyn2,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bd pobrania listy operatorw: '+stat