import re

# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_dane.py
# Purpose:     wczytuje/edytuje/zapisuje dane operatora
# Author:      Micha Raburski
# Created:     2006/08/31
# RCS-ID:      $Id: fs_operatorzy_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# dodanie pola e-mail Dariusz Boduch 14.02.2009 - matis: 1748
# dodanie pola stanowisko pracy - Pawe Wjcikowski 25.09.09r. mantis : 2580
# dodanie pola pracownik_id - mariusz rajfura 15.10.09r. mantis : 2686
# dodanie pola lista_dzialow - mariusz rajfura 22.06.11r. mantis: 4715
# poszerzenie pola lista_dzialow do VARCHAR(600) - mariusz rajfura 08.08.11r. mantis:4829
# 2013-04-24 Mariusz Rajfura     (6798) checkboxy: pos, czas_pracy
# 2013-07-22 Mariusz Rajfura     (7048) nowe pole 'kontrahent_id'
# 2018-02-23 Rafa Woniak      (10946) nowe pole 'ems'
# 2022-02-09 Wojciech Skowron   (12895) nowe pole 'kateg_kontrahentow'
# 2022-05-12 Wojciech Skowron   (13018) nowe pole 'miejsca_uzytkowania'
# 2022-07-28 Wojciech Skowron   (13110) nowe pole 'akceptacja_kwota'
# 2023-06-07 Wojciech Skowron   (13436) nowe pola 'kontrahent_pracownik' i 'kontrahenci_zaliczki'
# 2023-09-13 Aleksander Bargie (13436) nowe pole 'ksef_token'

stat='OK'
dane=[]
Operator = klucze[0]
Fun = klucze[-1]

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------
if Fun in (3,4):
    # pobranie dotychczasowych danych operatora
    sql ="SELECT pos,czas_pracy FROM rs_operatorzy WHERE operator_id="+str(Operator)+";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania dotychczasowych danych operatora: '+stat
    elif len(d) == 0:
        stat = 'Brak operatora o podanym numerze'
        
    if stat == 'OK':
        # opcje uruchamiania innych modulow niz standardowa anakonda
        Moduly = []
        if d[0][0]:
            Moduly.append('pos')
        if d[0][1]:
            Moduly.append('czas_pracy')
        
    # ---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole=='dni_hasla':
                if wart < 0:
                    stat="HAS DNI"
                    dane.append(stat)

            elif pole=='dlug_hasla':
                if wart < 8:
                    stat="HAS MIN"
                    dane.append(stat)       
            
            elif pole=='generator_oddzial_id':
                sql ="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat=='OK':
                    if len(d)==0:
                        stat="BL ODDZ"
                        dane.append(stat)

            elif pole=='kod_dostepu':
                if wart<>'':
                    sql ="SELECT operator_id FROM rs_operatorzy WHERE kod_dostepu='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':                   
                        if len(d)<>0:
                            stat="BL KOD"
                            dane.append(stat)   
                                 
            elif pole=='zastepca_id':
                sql = "SELECT operator_id FROM rs_operatorzy WHERE operator_id="+str(wart)+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat=='OK':
                    if len(d)==0:
                        stat='BL ZAST'
                        dane.append(stat)
                        
            elif pole=='handlowiec_id':
                if wart<>'':
                    sql ="SELECT kod FROM rs_handlowcy"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"';"
                    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(dane)==0:
                            stat='BL HANDL'
                        else:
                            wartosci[i]="'"+wart+"'"
                    else:
                        stat='BL SQL HANDL'
                else:
                    wartosci[i]="NULL"       

            elif pole=='stanowisko_id':
                if wart<>'':
                    sql ="SELECT kod FROM rs_stanowiska_pracy"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"';"
                    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(dane)==0:
                            stat='BL STPRACY'
                        else:
                            wartosci[i]="'"+wart+"'"
                    else:
                        stat='BL SQL STPRACY'
                else:
                    wartosci[i]="NULL" 
                    
            elif pole=='pracownik_id':
                if wart != '':
                    wartosci[i]="'"+wart+"'"
                    sql ="SELECT pracownik_id FROM rs_kp_dane_osobowe"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+wart+"';"
                    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(dane)==0:
                            stat='BL PRACOWNIK'
                    else:
                        stat='BL SQL PRACOWNIK'
                else:
                    wartosci[i]="NULL" 

            elif pole=='lista_dzialow':
                if wart != '':
                    wart = wart.replace('\r','').replace('\n','')
                    wartosci[i] = "'"+wart+"'"
                    if len(wart) > 600:
                        stat='BL LISTA_DZIALOW ZA DLUGA'
                else:
                    wartosci[i] = 'NULL'
            
            elif pole=='pos':
                if wart:
                    Moduly.append('pos')
                else:
                    Moduly.remove('pos')

            elif pole=='czas_pracy':
                if wart:
                    Moduly.append('czas_pracy')
                else:
                    Moduly.remove('czas_pracy')

            elif pole=='kontrahent_id':
                if wart<>'':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND kontrahent_id='"+str(wart)+"';"
                    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(dane)==0:
                            stat='BL KONTRAHENT'
                        else:
                            wartosci[i]="'"+wart+"'"
                    else:
                        stat='BL SQL KONTRAHENT'
                else:
                    wartosci[i]="NULL"

            #WS 2022-02-09
            elif pole=='kateg_kontrahentow':
                if wart != '':
                    try:
                        kateg_podane = [str(kateg).strip() for kateg in wart.split(',') if str(kateg).strip() != '']
                        kateg_prawidlowe = []
                        kateg_nieprawidlowe = []

                        sql ="SELECT kod FROM rs_kateg_kontrahentow"
                        sql+=" WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND kod IN ('"+"','".join(kateg_podane)+"');"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            stat='Bd weryfikacji kategorii kontrahentw: '+stat
                        else:
                            if len(d) > 0:
                                kateg_prawidlowe = [str(kateg[0]).strip() for kateg in d]

                            kateg_nieprawidlowe = set(kateg_podane) ^ set(kateg_prawidlowe)
                            if len(kateg_nieprawidlowe) > 0:
                                stat = 'BL KATEG KONTRAHENTOW$'+", ".join(kateg_nieprawidlowe)
                            else:
                                kateg_podane = list(set(kateg_podane))
                                kateg_podane.sort()
                                wartosci[i] = "'"+",".join(kateg_podane)+"'"
                    except:
                        import traceback
                        stat = 'Bd weryfikacji kategorii kontrahentw: '+traceback.format_exc()
                else:
                    wartosci[i] = "NULL"

            #WS 2022-05-12
            elif pole=='miejsca_uzytkowania':
                if wart != '':
                    try:
                        miejsca_podane = [str(miejsca).strip() for miejsca in wart.split(',') if str(miejsca).strip() != '']
                        miejsca_prawidlowe = []
                        miejsca_nieprawidlowe = []

                        sql ="SELECT kod FROM rs_miejsca_uzytkowania"
                        sql+=" WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND kod IN ('"+"','".join(miejsca_podane)+"');"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            stat='Bd weryfikacji miejsc uytkowania: '+stat
                        else:
                            if len(d) > 0:
                                miejsca_prawidlowe = [str(miejsca[0]).strip() for miejsca in d]

                            miejsca_nieprawidlowe = set(miejsca_podane) ^ set(miejsca_prawidlowe)
                            if len(miejsca_nieprawidlowe) > 0:
                                stat = 'BL MIEJSCA UZYTKOWANIA$'+", ".join(miejsca_nieprawidlowe)
                            else:
                                miejsca_podane = list(set(miejsca_podane))
                                miejsca_podane.sort()
                                wartosci[i] = "'"+",".join(miejsca_podane)+"'"
                    except:
                        import traceback
                        stat = 'Bd weryfikacji miejsc uytkowania: '+traceback.format_exc()
                else:
                    wartosci[i] = "NULL"

            #WS 2022-07-28
            elif pole=='akceptacja_kwota':
                if not (-10**10 < wart < 10**10):
                    stat = 'BL AKCEPT KWOTA'

            #AB 2023-09-14
            elif pole=='ksef_token':
                pattern = r'[^A-Z^0-9]'
                if re.search(pattern, wart.upper()):
                    stat = 'Token KSeF zawiera niepoprawne znaki(dopuszczalne a-z, A-Z, 0-9, bez polskich znakw)'
                elif len(wart) not in(40, 0):
                    stat = 'Token KSeF musi zawiera dokadnie 40 znakw'

            #WS 2023-06-07
            elif pole=='kontrahent_pracownik':
                if wart != '':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;"
                    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(dane)==0:
                            stat='BL KONTRAHENT PRACOWNIK'
                        else:
                            wartosci[i]="'"+wart+"'"
                    else:
                        stat='Bd weryfikacji symbolu pracownika (kontrahenta): '+stat
                else:
                    wartosci[i]="NULL"

            #WS 2022-06-07
            elif pole=='kontrahenci_zaliczki':
                if wart != '':
                    try:
                        kontrahenci_podani = [str(kontrahenci).strip() for kontrahenci in wart.split(',') if str(kontrahenci).strip() != '']
                        kontrahenci_prawidlowi = []
                        kontrahenci_nieprawidlowi = []

                        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                        sql+=" WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND kontrahent_id IN ('"+"','".join(kontrahenci_podani)+"') AND aktywny;"
                        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                        if stat != 'OK':
                            stat='Bd weryfikacji symboli kontrahentw: '+stat
                        else:
                            if len(d) > 0:
                                kontrahenci_prawidlowi = [str(kontrahenci[0]).strip() for kontrahenci in d]

                            kontrahenci_nieprawidlowi = set(kontrahenci_podani) ^ set(kontrahenci_prawidlowi)
                            if len(kontrahenci_nieprawidlowi) > 0:
                                stat = 'BL KONTRAHENCI ZALICZKI$'+", ".join(kontrahenci_nieprawidlowi)
                            else:
                                kontrahenci_podani = list(set(kontrahenci_podani))
                                kontrahenci_podani.sort()
                                wartosci[i] = "'"+",".join(kontrahenci_podani)+"'"
                    except:
                        import traceback
                        stat = 'Bd weryfikacji symboli kontrahentw: '+traceback.format_exc()
                else:
                    wartosci[i] = "NULL"

    if stat=='OK':
        if len(Moduly) > 0:
            if str(Operator)=='0':
                stat = 'BL ANAKONDA Z MODULAMI'
            elif len(Moduly)>1:
                stat = 'BL PONAD 1 MODUL'
                
    if stat == 'OK':
        where = " WHERE operator_id="+str(Operator)+";"
        upd = "UPDATE rs_operatorzy SET "
    
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
        
            if pole in ['dni_hasla','dlug_hasla','czy_rozgloszenie','czy_wielokrotne','zlozone_haslo',
                        'zastepca_id','handlowiec_id','stanowisko_id','czy_uproszczone_zamow','pracownik_id',
                        'pos','ems','czas_pracy','kontrahent_id', 'kateg_kontrahentow', 'miejsca_uzytkowania',  #WS 2022-02-09
                        'akceptacja_kwota',  #WS 2022-07-28
                        'kontrahent_pracownik', 'kontrahenci_zaliczki']:  #WS 2023-06-07
                upd+=pole+"="+str(wart)+","
            elif pole in ['generator_oddzial_id','email','kod_dostepu','email_uzytkownik','email_haslo',
                        'email_serwer','email_port','email_szyfrowanie', 'ksef_token']:  #AB 2023-09-13
                upd+=pole+"='"+str(wart)+"',"
            elif pole in ['lista_dzialow']:
                upd+=pole+"="+str(wart)+","

        upd = upd[0:len(upd)-1]+where
        
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem
#-------------------------------------------------------------------------------
if Fun in (3,5) and stat == 'OK':
    # pobranie danych operatora
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_operatorzy WHERE operator_id="+str(Operator)+";", 3)
