# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pan_odebrano.py
# Purpose:     ilosci zadeklarowane jako przekazane przechodza z produkcji
#              na ekspedycje jako odebrane
#
# Author:      Mariusz Rajfura
# Created:     2010/06/15
# RCS-ID:      $Id: fs_pan_odebrano.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Artykul = rsglobal.Dekoduj(klucze[0]).strip()
Odebrano = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
# POBRANIE LISTY ARTYKULOW PRZEKAZANYCH > ODEBRANYCH
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    sql ="SELECT ppp.artykul_id,a.nazwa,SUM(ppp.przekazano), SUM(ppp.odebrano),0"
    sql+=" FROM ("
    sql+="  SELECT DISTINCT pp.artykul_id,pp.przekazano,pp.odebrano,pp.partia_id"
    sql+="   FROM rs_produkcja_plan pp"
    sql+="   INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+="   WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id=o.generator_oddzial_id"
    sql+="   AND pp.przekazano>0" #AND" (pp.przekazano>pp.odebrano OR pp.odebrano IS NULL)"
    sql+="   ORDER BY pp.artykul_id) AS ppp"
    sql+=" INNER JOIN rs_artykuly a ON (a.firma_id='"+self.firma_id+"' AND a.artykul_id=ppp.artykul_id)"
    sql+=" GROUP BY ppp.artykul_id,a.nazwa ORDER BY ppp.artykul_id;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy przekazanych artykuw: '+stat
    else:
        #wypelniam kolumne pozostalo do odebrania
        DoUsuniecia = []
        for i in xrange(len(dane)):
            if dane[i][2] == dane[i][3]:
                DoUsuniecia.append(i)
            dane[i][4] = dane[i][2] - dane[i][3]

        #usuwam odebrane - dluzsza historia
        if len(DoUsuniecia) > 0:
            DoUsuniecia.reverse()
            for i in DoUsuniecia:
                del dane[i]


#-------------------------------------------------------------------------------
# POBRANIE ILOSCI DLA PODANEGO ARTYKULU Z KLAWIATURY
#-------------------------------------------------------------------------------

if Fun == 13 and stat == 'OK':
    sql ="SELECT ppp.artykul_id,a.nazwa,SUM(ppp.przekazano), SUM(ppp.odebrano),0"
    sql+=" FROM ("
    sql+="  SELECT DISTINCT pp.artykul_id,pp.przekazano,pp.odebrano,pp.partia_id"
    sql+="   FROM rs_produkcja_plan pp"
    sql+="   INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+="   WHERE pp.firma_id='"+self.firma_id+"' AND pp.artykul_id='"+Artykul+"'"
    sql+="   AND pp.oddzial_id=o.generator_oddzial_id"
    sql+="   AND pp.przekazano>0" # AND (pp.przekazano>pp.odebrano OR pp.odebrano IS NULL)"
    sql+="   ORDER BY pp.artykul_id) AS ppp"
    sql+=" INNER JOIN rs_artykuly a ON (a.firma_id='"+self.firma_id+"' AND a.artykul_id=ppp.artykul_id)"
    sql+=" GROUP BY ppp.artykul_id,a.nazwa;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych artykuu: '+stat
    elif len(dane) == 0:
        stat = 'Brak iloci do pobrania dla artykuu '+Artykul
    else:
        dane[0][4] = dane[0][2] - dane[0][3]


#-------------------------------------------------------------------------------
# WPISANIE ILOSCI ODEBRANEJ DO WYBRANEGO ARTYKULU
#-------------------------------------------------------------------------------

if Fun == 14 and stat == 'OK':
    if Odebrano == 0:
        stat = 'Nie podano iloci do odebrania'
        
    if stat == 'OK':
        #zablokowanie procesow dla wybranego artykulu
        sql ="SELECT pp.artykul_id,pp.przekazano,pp.odebrano,pp.partia_id"
        sql+=" FROM rs_produkcja_plan pp"
        sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
        sql+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id=o.generator_oddzial_id"
        sql+=" AND pp.artykul_id='"+Artykul+"'"
        sql+=" AND pp.przekazano>0 AND (pp.przekazano>pp.odebrano OR pp.odebrano IS NULL)"
        sql+=" FOR UPDATE NOWAIT;"
        stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych artykuu: '+stat
        elif len(dane) == 0:
            stat = 'Bdny kod artkuu '+Artykul
        
        #wybieram poszczegolne partie i przygotowuje sql dla aktualizacji
        #wg partia_id
        Slownik = {}
        for i in xrange(len(dane)):
            Partia = dane[i][3]
            if not Slownik.has_key(Partia):
                Slownik[Partia] = dane[i]
    
        NryPartii = Slownik.keys()
        NryPartii.sort()
        
        UPD = ''
        DoOdebrania = Odebrano
        
        for Partia in NryPartii:
            if DoOdebrania == 0:
                #jesli rozdysponowalismy cala ilosc
                break
            
            d = Slownik[Partia]
            JuzOdebrano = d[2]
            #pozostalo do odebrania = przekazano - odebrano
            ArtykulDoOdebrania = d[1]-d[2]
            
            if DoOdebrania > ArtykulDoOdebrania:
                Ilosc = ArtykulDoOdebrania
            else:
                Ilosc = DoOdebrania
            DoOdebrania -= Ilosc
            
            UPD+="UPDATE rs_produkcja_plan SET odebrano="+str(JuzOdebrano+Ilosc)
            UPD+=" WHERE partia_id="+str(Partia)+"; "

        if DoOdebrania > 0:
            #to oznacza, ze w czasie podejmowania decyzji
            #zmnieszyla sie ilosc do odebrania
            #np w wyniku dzialania innego operatora
            stat = 'Moliwa ilo do odebrania jest mniejsza ni zadeklarowana'
        
    if stat == 'OK':
        stat,dane,dump,dump = self.PolSQL.Execute(UPD,1)
