# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pan_przekazanie.py
# Purpose:     zadania z tabeli rs_produkcja_plan
#
# Author:      Mariusz Rajfura
# Created:     2010/06/14
# RCS-ID:      $Id: fs_pan_przekazanie.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Artykul = rsglobal.Dekoduj(klucze[0]).strip()
Przekazano = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
# POBRANIE LISTY ARTYKULOW ZREALIZOWANYCH > PRZEKAZANYCH
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    sql ="SELECT ppp.artykul_id,a.nazwa,SUM(ppp.zrealizowano), SUM(ppp.przekazano),0"
    sql+=" FROM ("
    sql+="  SELECT DISTINCT pp.artykul_id,pp.zrealizowano,pp.przekazano,pp.partia_id"
    sql+="   FROM rs_produkcja_plan pp"
    sql+="   INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+="   WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id=o.generator_oddzial_id"
    sql+="   AND pp.zrealizowano>0" # AND (pp.zrealizowano>pp.przekazano OR pp.przekazano IS NULL)"
    sql+="   ORDER BY pp.artykul_id) AS ppp"
    sql+=" INNER JOIN rs_artykuly a ON (a.firma_id='"+self.firma_id+"' AND a.artykul_id=ppp.artykul_id)"
    sql+=" GROUP BY ppp.artykul_id,a.nazwa ORDER BY ppp.artykul_id;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy zrealizowanych artykuw: '+stat
    else:
        DoUsuniecia = []
        #wypelniam kolumne pozostalo do przekazania
        for i in xrange(len(dane)):
            if dane[i][2] == dane[i][3]:
                DoUsuniecia.append(i)
            dane[i][4] = dane[i][2] - dane[i][3]
            
        #usuwam zakonczone - dluzsza historia
        if len(DoUsuniecia) > 0:
            DoUsuniecia.reverse()
            for i in DoUsuniecia:
                del dane[i]

#-------------------------------------------------------------------------------
# POBRANIE ILOSCI DLA PODANEGO ARTYKULU Z KLAWIATURY
#-------------------------------------------------------------------------------

if Fun == 13 and stat == 'OK':
    sql ="SELECT ppp.artykul_id,a.nazwa,SUM(ppp.zrealizowano), SUM(ppp.przekazano),0"
    sql+=" FROM ("
    sql+="  SELECT DISTINCT pp.artykul_id,pp.zrealizowano,pp.przekazano,pp.partia_id"
    sql+="   FROM rs_produkcja_plan pp"
    sql+="   INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+="   WHERE pp.firma_id='"+self.firma_id+"' AND pp.artykul_id='"+Artykul+"'"
    sql+="   AND pp.oddzial_id=o.generator_oddzial_id"
    sql+="   AND pp.zrealizowano>0" # AND (pp.zrealizowano>pp.przekazano OR pp.przekazano IS NULL)"
    sql+="   ORDER BY pp.artykul_id) AS ppp"
    sql+=" INNER JOIN rs_artykuly a ON (a.firma_id='"+self.firma_id+"' AND a.artykul_id=ppp.artykul_id)"
    sql+=" GROUP BY ppp.artykul_id,a.nazwa;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych artykuu: '+stat
    elif len(dane) == 0:
        stat = 'Brak iloci do przekazania dla artykuu '+Artykul
    else:
        dane[0][4] = dane[0][2] - dane[0][3]


#-------------------------------------------------------------------------------
# WPISANIE ILOSCI PRZEKAZANEJ DO WYBRANEGO ARTYKULU
#-------------------------------------------------------------------------------

if Fun == 14 and stat == 'OK':
    if Przekazano == 0:
        stat = 'Nie podano iloci do przekazania'
        
    if stat == 'OK':
        #zablokowanie procesow dla wybranego artykulu
        sql ="SELECT pp.artykul_id,pp.zrealizowano,pp.przekazano,pp.partia_id"
        sql+=" FROM rs_produkcja_plan pp"
        sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
        sql+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id=o.generator_oddzial_id"
        sql+=" AND pp.artykul_id='"+Artykul+"'"
        sql+=" AND pp.zrealizowano>0 AND (pp.zrealizowano>pp.przekazano OR pp.przekazano IS NULL)"
        sql+=" FOR UPDATE NOWAIT;"
        stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych artykuu: '+stat
        elif len(dane) == 0:
            stat = 'Bdny kod artkuu '+Artykul
        
        #wybieram poszczegolne partie i przygotowuje sql dla aktualizacji
        #wg partia_id
        Slownik = {}
        for i in xrange(len(dane)):
            Partia = dane[i][3]
            if not Slownik.has_key(Partia):
                Slownik[Partia] = dane[i]
    
        NryPartii = Slownik.keys()
        NryPartii.sort()
        
        UPD = ''
        DoPrzekazania = Przekazano
        
        for Partia in NryPartii:
            if DoPrzekazania == 0:
                #jesli rozdysponowalismy cala ilosc
                break
            
            d = Slownik[Partia]
            JuzPrzekazano = d[2]
            #pozostalo do przekazania = zrealizowano - przekazano
            ArtykulDoPrzekazania = d[1]-d[2]
            
            if DoPrzekazania > ArtykulDoPrzekazania:
                Ilosc = ArtykulDoPrzekazania
            else:
                Ilosc = DoPrzekazania
            DoPrzekazania -= Ilosc
            
            UPD+="UPDATE rs_produkcja_plan SET przekazano="+str(JuzPrzekazano+Ilosc)
            UPD+=" WHERE partia_id="+str(Partia)+"; "

        if DoPrzekazania > 0:
            #to oznacza, ze w czasie podejmowania decyzji
            #zmnieszyla sie ilosc do przekazania
            #np w wyniku dzialania innego operatora
            stat = 'Moliwa ilo do przekazania jest mniejsza ni zadeklarowana'
        
    if stat == 'OK':
        stat,dane,dump,dump = self.PolSQL.Execute(UPD,1)
