# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pan_tworzenie_mm.py
# Purpose:     tworzenie dokumentu MM z odebranych zadan produkcyjnych
#
# Author:      Mariusz Rajfura
# Created:     2010/06/18
# RCS-ID:      $Id: fs_pan_tworzenie_mm.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#klucze[0][0,1,2,3] dokument mm dla ilosci odebranych (magazyn,dokument,data,numer)
#klucze[1][0] string zawierajacy numery partii przy tworzeniu/usuwaniu dokumentow
#klucze[1][1] tabela zawierajacy listy: nr pozycji,artykul,partia,ilosc1

Magazyn = rsglobal.Dekoduj(klucze[0][0])
Dokument = rsglobal.Dekoduj(klucze[0][1])
Data = rsglobal.Dekoduj(klucze[0][2])
Numer = rsglobal.Dekoduj(klucze[0][3])

NryPartii = klucze[1][0]
NryPozycjiArtykuluPartiiIlosci = klucze[1][1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# POBRANIE DANYCH MAGAZYNU DO TWORZENIA DOKUMENTU - 11
# ORAZ SPRAWDZENIE UPRAWNIEN TWORZENIA DOKUMENTU MM W MAGAZYNIE
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    sql ="SELECT pd.magazyn_pw, pd.magazyn_mm FROM rs_produkcja_dokumenty pd"
    sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+=" WHERE pd.firma_id='"+self.firma_id+"' AND pd.oddzial_id=o.generator_oddzial_id;"

    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o magazynie: '+stat
    elif len(dane) == 0:
        stat = 'Brak zdefiniowanego magazynu dla wystawienia dokumentu z panelu'

    if stat == 'OK':
        Magazyn = str(dane[0][0]).strip()
        
        sql ="SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania dziau dla operatora: '+stat
        else:
            Oddzial = str(d[0][0])
            
    if stat == 'OK':
        if not ((Oddzial,'032013') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
            stat = "Brak uprawnie do dodawania dokumentw magazynowych w oddziale "+Oddzial
    
    if stat == 'OK':
        sql ="SELECT wprowadzanie, zamykanie FROM rs_dokumenty_m_upr"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' and operator_id="+str(self.operator_id)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania uprawnie do dok.magazynowych: '+stat
        elif len(d) == 0:
            stat = 'Brak uprawnie do dokumentw '+Dokument+' w magazynie '+Magazyn
        elif not (d[0][0] and d[0][1]):
            stat = 'Brak uprawnie do wprowadzania i zamykania '+Dokument+' w magazynie '+Magazyn


#-------------------------------------------------------------------------------
# SPRAWDZENIE CZY ISTNIEJA PROCESY DO TWORZENIA MM
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    dane1 = []
    dane2 = []
    NryPartii = ''
    
    sql ="SELECT DISTINCT pp.artykul_id,a.nazwa,pp.odebrano,pp.partia_id"
    sql+=" FROM rs_produkcja_plan pp"
    sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+=" INNER JOIN rs_artykuly a ON (a.firma_id='"+self.firma_id+"' AND a.artykul_id=pp.artykul_id)"
    sql+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id=o.generator_oddzial_id"
    sql+=" AND pp.odebrano>0 AND pp.mm_dokument_id IS NULL"
    sql+=" ORDER BY pp.artykul_id, pp.partia_id"

    stat,dane2,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy odebranych zada: '+stat

    if stat == 'OK' and len(dane2) > 0:
        #z zapisow analitycznych zrobimy tabele dane1 zawierajaca sumy
        #i ilosci dla artykulow
        #nrypartii beda potrzebne przy tworzeniu dokumentu,
        #aby zapytanie o odebrane procesy nie roznilo sie
        #o odebrane w miedzyczasie procesy, gdy operator zastanawial
        #sie nad wystawieniem dokumentu z wybranych w tej funkcji procesow
        
        Artykul = dane2[0][0]
        Nazwa = dane2[0][1]
        Partia = dane2[0][3]
        Odebrano = 0
        
        for d in dane2:
            if Artykul <> d[0]:
                dane1.append([Artykul,Nazwa,Odebrano])
                Artykul = d[0]
                Nazwa = d[1]
                Odebrano = 0
                
            if Partia <> d[3]:
                NryPartii += str(Partia)+','
                Partia = d[3]
            
            Odebrano += d[2]
            
        dane1.append([Artykul,Nazwa,Odebrano])
        NryPartii = '('+NryPartii+str(Partia)+')'

    if stat == 'OK':
        dane = [dane1,dane2,NryPartii,[]]


#-------------------------------------------------------------------------------
# UTWORZENIE NOWEGO DOKUMENTU MAGAZYNOWEGO W STANIE 'W'
#-------------------------------------------------------------------------------

if Fun == 13 and stat == 'OK':
    NryPozycjiArtykuluPartiiIlosci = []
    
    sql ="SELECT pd.wersja_pw, pd.magazyn_mm, pd.kontrahent_id"
    sql+=" FROM rs_produkcja_dokumenty pd"
    sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+=" WHERE pd.firma_id='"+self.firma_id+"' AND pd.oddzial_id=o.generator_oddzial_id;"

    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o wersji cenowej: '+stat
    else:
        Wersja = str(d[0][0])
        MagazynDokad = str(d[0][1]).strip()
        Kontrahent = str(d[0][2]).strip()

    if stat == 'OK':
        #pobieramy dane zakonczonych partii i blokujemy je
        sql ="SELECT pp.artykul_id,pp.partia_id,pp.odebrano"
        sql+=" FROM rs_produkcja_plan pp"
        sql+=" WHERE partia_id IN "+NryPartii
        sql+=" AND mm_dokument_id IS NULL"
        sql+=" ORDER BY pp.artykul_id,pp.partia_id FOR UPDATE NOWAIT;"

        stat,PozycjeZPlanu,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania listy zakoczonych procesw: '+stat
        elif len(PozycjeZPlanu) == 0:
            stat = 'Brak zakoczonych procesw do utworzenia dokumentw.'
    
    if stat == 'OK':
        #robie slowniki, aby otrzymac pojedyncze zapisy
        #taki DISTINCT w pythonie
        
        SlownikArtykul = {}
        SlownikArtykulPartia = {}
        
        for i in PozycjeZPlanu:
            if not SlownikArtykul.has_key(i[0]):
                SlownikArtykul[i[0]] = eval(str(i))

            if not SlownikArtykulPartia.has_key((i[0],i[1])):
                SlownikArtykulPartia[(i[0],i[1])] = eval(str(i))

        #przygotowuje kolejnosc aby artykuly ukladaly sie w dokumencie
        #tak, jak na podgladzie w oknie - poza tym to ladnie wyglada
        KolejnoscArtykul = SlownikArtykul.keys()
        KolejnoscArtykul.sort()

        KolejnoscArtykulPartia = SlownikArtykulPartia.keys()
        KolejnoscArtykulPartia.sort()

        #zeruje ilosci dla artykulow
        for i in SlownikArtykul.keys():
            ProcesArtykul = SlownikArtykul[i]
            ProcesArtykul[2] = 0
            SlownikArtykul[i] = ProcesArtykul

        #sumuje ilosci dla artykulow
        for i in SlownikArtykulPartia.keys():
            ProcesArtykulPartia = SlownikArtykulPartia[i]
            Artykul = ProcesArtykulPartia[0]
            Odebrano = ProcesArtykulPartia[2]
            
            ProcesArtykul = SlownikArtykul[Artykul]
            ProcesArtykul[2] += Odebrano
        
        #sql dla INSERT naglowkow dokumentow -> rs_dokumenty_magazynowe
        INS_Dok = ''
        
        #sql dla INSERT pozycji dokumentow -> rs_dokumenty_magazynowe_pozycje
        INS_Poz = ''
        
        #sql dla UPDATE procesow w planie -> rs_produkcja_plan
        UPD_Plan = ''

        #sprawdzimy, czy w magazynie pobierac ceny
        sql ="SELECT czy_ceny FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"

        sql,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu cen w magazynie '+Magazyn
        elif len(d) <> 1:
            stat = 'Bdny numer magazynu '+Magazyn
        else:
            StosowacCeny = d[0][0]

    if stat == 'OK':
        #czy dwie jednostki miar
        sql ="SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu dwch jednostek miar: '+stat
        elif len(d) == 0:
            stat = 'Brak firmy o podanym kodzie '+self.firma_id
        else:
            DwieJM = d[0][0]    

    if stat == 'OK':
        #pobranie numeru dla nowego dokumentu
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        sql+="'[\\\'"+Magazyn+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','MM');"

        stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania nowego numeru dla '+Dokument+' z magazynu '+Magazyn
        else:
            Numer = dane[0][0]

        #pobranie numeru w magazynie dokad
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        sql+="'[\\\'"+MagazynDokad+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\']','MM');"

        stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania nowego numeru dla '+Dokument+' z magazynu '+MagazynDokad
        else:
            NumerDokad = dane[0][0]

    if stat == 'OK':
        LiczPozDM = 0

        for i in KolejnoscArtykul:
            Proces = SlownikArtykul[i]
            
            Artykul = str(Proces[0])
            Odebrano1 = Proces[2]
            Cena1Jm = 0
            Cena2Jm = 0
            
            if Odebrano1 > 0:
                if StosowacCeny:
                    sql ="SELECT rsf_podaj_ceny('"+self.firma_id+"',"
                    sql+="'"+Artykul+"','"+Wersja+"','PLN','"+Data+"');"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bdy przy pobieraniu ceny :'+stat
                        break
                    
                    elif len(d)>0:
                        Ceny = rsglobal.rseval(d[0][0])
                        if len(Ceny)>0:
                            Cena1Jm = Ceny[0]
                            Cena2Jm = Ceny[1]
                            
                if stat == 'OK' and DwieJM:
                    sql ="SELECT przelicznik FROM rs_artykuly"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                    sql+=" AND aktywny;"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        stat = 'Bd pobrania przelicznika dla artykuu '+stat
                        break
                    elif len(d) == 0:
                        stat = 'Brak artykuu o kodzie '+Artykul
                        break
                    else:
                        Przelicznik = d[0][0]
                
            if stat == 'OK' and Odebrano1 > 0:
                Odebrano2 = Odebrano1
                if DwieJM:
                    Odebrano2 = round(Odebrano1*Przelicznik,4)
                    
                LiczPozDM += 1
                INS_Poz+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
                INS_Poz+=" (firma_id, magazyn_id, dokument_id, data,"
                INS_Poz+="  numer, nr_poz, nr_ppoz, artykul_id,"
                INS_Poz+="  ilosc1, ilosc2,"
                INS_Poz+="  cena1, cena2,"
                INS_Poz+="  cena_wal1, cena_wal2)"
                INS_Poz+=" VALUES"
                INS_Poz+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"','"+Data+"',"
                INS_Poz+="  "+str(Numer)+","+str(LiczPozDM)+",0,'"+Artykul+"',"
                INS_Poz+="  "+str(Odebrano1)+","+str(Odebrano2)+","
                INS_Poz+="  "+str(Cena1Jm)+","+str(Cena2Jm)+","
                INS_Poz+="  "+str(Cena1Jm)+","+str(Cena2Jm)+"); "
            
                for j in KolejnoscArtykulPartia:
                    if Artykul == j[0]:
                        Partia = j[1]
                        NryPozycjiArtykuluPartiiIlosci.append([LiczPozDM,Artykul,Partia,Odebrano1])

    if stat == 'OK':
        if LiczPozDM == 0:
            #brak pozycji odebranych - kasuje numer dokumentu
            Numer = 0
        else:
            #naglowek dokumentu
            INS_Dok ="INSERT INTO rs_dokumenty_magazynowe"
            INS_Dok+=" (firma_id, magazyn_id, dokument_id,"
            INS_Dok+=" data, numer, wersja, numer_dokad,"
            INS_Dok+=" magazyn_skad, magazyn_dokad, kontrahent_id)"
            INS_Dok+=" VALUES "
            INS_Dok+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dokument+"',"
            INS_Dok+="'"+Data+"',"+str(Numer)+",'"+Wersja+"',"+str(NumerDokad)+","
            INS_Dok+="'"+Magazyn+"','"+MagazynDokad+"','"+Kontrahent+"'); "

    if stat == 'OK' and Numer > 0:
        UPDATE = INS_Dok + INS_Poz
        
        stat,dane,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd tworzenia dokumentu: '+stat

    NumerNaWydruk = ''
    
    if stat == 'OK' and Numer > 0:
        sql ="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"',"
        sql+="'[\\\'"+Magazyn+"\\\',\\\'"+Dokument+"\\\',\\\'"+Data+"\\\',\\\'"+str(Numer)+"\\\']','M');"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru dokumentu '+Dokument+' '+str(Numer)+' na wydruk'
        else:
            NumerNaWydruk = str(d[0][0])

    if stat == 'OK':
        dane = []
        dane.append([Magazyn,Dokument,Data,Numer,NumerNaWydruk,NryPozycjiArtykuluPartiiIlosci])


#-------------------------------------------------------------------------------
# POWIAZANIE PROCESOW Z PLANU PRODUKCJI Z POZYCJAMI DOKUMENTU MAGAZYNOWEGO
#-------------------------------------------------------------------------------

if Fun == 14 and stat == 'OK':
    #blokujemy wybrane wczesniej partie
    sql ="SELECT partia_id FROM rs_produkcja_plan"
    sql+=" WHERE partia_id IN "+NryPartii+" ORDER BY partia_id FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania procesw do powizania z dokumentem: '+stat

    #WAZNE: musimy pobrac numery pozycji i podpozycji z dokumentu MM
    #w celu wpisania wlasciwych numerow podpozycji
    #PONIEWAZ zmiana stanu dokumentu MM z W->G zmienia numery podpozycji
    #z 0 (zero) na 1 (jeden), a nie chce przyjmowac, ze to sie nie zmieni
    #i na szywno wpisywac 1 (jeden) w nr_ppoz
    #artykul_id, ilosc1 to dodatkowe sprawdzenie
    
    if stat == 'OK':
        sql ="SELECT artykul_id, ilosc1, nr_poz, nr_ppoz"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
        sql+=" AND numer="+str(Numer)+" ORDER BY nr_poz,nr_ppoz FOR UPDATE NOWAIT; "
        stat,dPozDM,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji z utworzonego dokumentu: '+stat
            
    if stat == 'OK':
        #tworzymy sql-a do powiazania partii z pozycjami dokumentu magazynowego
        #dla ilosci pobranej
        UPD_Plan = ''
        for i in NryPozycjiArtykuluPartiiIlosci:
            NrPoz = i[0]
            Artykul = rsglobal.Dekoduj(i[1]).strip()
            Partia = i[2]
            Ilosc1 = i[3]
            NrPPoz = None
            
            #dla kazdej parti identyfikujemy jej pozycje w dokumencie
            for j in dPozDM:
                if rsglobal.Dekoduj(j[0]).strip() == Artykul and j[1] == Ilosc1 and j[2] == NrPoz:
                    NrPPoz = j[3]
                    break
                
            if NrPPoz == None:
                stat = 'Nie znaleziono pozycji '+str(NrPoz)+' dla artykuu '+Artykul
                stat+= ' w iloci '+str(Ilosc1)+' w utworzonym dokumencie'
                break
    
            UPD_Plan+= "UPDATE rs_produkcja_plan SET"
            UPD_Plan+=" oper_mm="+str(self.operator_id)+","
            UPD_Plan+=" mm_magazyn_id='"+Magazyn+"',"
            UPD_Plan+=" mm_dokument_id='"+Dokument+"',"
            UPD_Plan+=" mm_data='"+Data+"',"
            UPD_Plan+=" mm_numer="+str(Numer)+","
            UPD_Plan+=" mm_nr_poz="+str(NrPoz)+","
            UPD_Plan+=" mm_nr_ppoz="+str(NrPPoz)
            UPD_Plan+=" WHERE firma_id='"+self.firma_id+"'"
            UPD_Plan+=" AND partia_id="+str(Partia)+"; "

    if stat == 'OK':
        stat,d,dump,dump = self.PolSQL.Execute(UPD_Plan,1)
        if stat <> 'OK':
            stat = 'Bd operacji powizania dokumentu z planem produkcji: '+stat


#-------------------------------------------------------------------------------
# USUNIECIE STWORZONEGO DOKUMENTU MAGAZYNOWEGO
#-------------------------------------------------------------------------------

if Fun == 23 and stat == 'OK':
    #blokada stworzonego dokumentu
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    sql+=" AND numer="+str(Numer)+" FOR UPDATE NOWAIT; "

    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
    if stat <> 'OK':
        stat = 'Bd przygotowania danych do wycofania dokumentu: '+stat
        
    if stat == 'OK':
        UPD =" DELETE FROM rs_dokumenty_magazynowe"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        UPD+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
        UPD+=" AND numer="+str(Numer)+"; "

        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd usunicia stworzonego dokumentu: '+stat


#-------------------------------------------------------------------------------
# USUNIECIE POWIAZANIE POZYCJI DOKUMENTU MAGAZYNOWEGO Z rs_produkcja_plan
#-------------------------------------------------------------------------------

if Fun == 24 and stat == 'OK':
    #blokada wybranych wczesniej partii
    sql ="SELECT partia_id FROM rs_produkcja_plan"
    sql+=" WHERE partia_id IN "+NryPartii+" FOR UPDATE NOWAIT; "
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
    if stat <> 'OK':
        stat = 'Bd pobrania danych do wycofania powizana procesw z dokumentem magazynowym: '+stat
        
    if stat == 'OK':
        UPD+="UPDATE rs_produkcja_plan SET"
        UPD+=" oper_mm=NULL, mm_magazyn_id=NULL, mm_dokument_id=NULL,"
        UPD+=" mm_data=NULL, mm_numer=NULL, mm_nr_poz=NULL, mm_nr_ppoz=NULL"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND partia_id IN "+NryPartii+"; "
        
        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd wycofania powizania planu produkcji z dokumentem magazynowym: '+stat
