# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pan_tworzenie_pw.py
# Purpose:     tworzenie dokumentu PW z zamknietych zadan produkcyjnych
#
# Author:      Mariusz Rajfura
# Created:     2010/06/07
# RCS-ID:      $Id: fs_pan_tworzenie_pw.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-04-04 Mariusz Rajfura  nadawanie numeru dla dokumentu PW w tym samym magazynie
#                             dla dobrych i brakow - blad typu danych (5612)


#klucze[0][0,1,2,3] dokument pw dla ilosci zrealizowanych (magazyn,dokument,data,numer)
#klucze[1][0,1,2,3] dokument pw dla ilosci brakow (magazyn,dokument,data,numer)
#klucze[2][0] string zawierajacy numery partii przy tworzeniu/usuwaniu dokuemntow

Magazyn1 = rsglobal.Dekoduj(klucze[0][0])
Dokument1 = rsglobal.Dekoduj(klucze[0][1])
Data1 = rsglobal.Dekoduj(klucze[0][2])
Numer1 = rsglobal.Dekoduj(klucze[0][3])

Magazyn2 = rsglobal.Dekoduj(klucze[1][0])
Dokument2 = rsglobal.Dekoduj(klucze[1][1])
Data2 = rsglobal.Dekoduj(klucze[1][2])
Numer2 = rsglobal.Dekoduj(klucze[1][3])

NryPartii = klucze[2][0]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# POBRANIE DANYCH MAGAZYNOW DO TWORZENIA DOKUMENTU - 11
# ORAZ SPRAWDZENIE UPRAWNIEN TWORZENIA DOKUMENTOW PW W TYCH MAGAZYNACH
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    sql ="SELECT pd.magazyn_pw,magazyn_braki FROM rs_produkcja_dokumenty pd"
    sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+=" WHERE pd.firma_id='"+self.firma_id+"' AND pd.oddzial_id=o.generator_oddzial_id;"

    stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o magazynie: '+stat
    elif len(dane) == 0:
        stat = 'Brak zdefiniowanego magazynu dla wystawienia dokumentu z panelu'

    if stat == 'OK':
        Magazyn1 = str(dane[0][0]).strip()
        Magazyn2 = str(dane[0][1]).strip()
        
        sql ="SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania dziau dla operatora: '+stat
        else:
            Oddzial = str(d[0][0])
            
    if stat == 'OK':
        if not ((Oddzial,'032013') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
            stat = "Brak uprawnie do dodawania dokumentw magazynowych w oddziale "+Oddzial
    
    if stat == 'OK':
        sql ="SELECT wprowadzanie, zamykanie FROM rs_dokumenty_m_upr"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn1+"'"
        sql+=" AND dokument_id='"+Dokument1+"' and operator_id="+str(self.operator_id)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania uprawnie do dok.magazynowych: '+stat
        elif len(d) == 0:
            stat = 'Brak uprawnie do dokumentw '+Dokument1+' w magazynie '+Magazyn1
        elif not (d[0][0] and d[0][1]):
            stat = 'Brak uprawnie do wprowadzania i zamykania '+Dokument1+' w magazynie '+Magazyn1

    if stat == 'OK':
        sql ="SELECT wprowadzanie, zamykanie FROM rs_dokumenty_m_upr"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn2+"'"
        sql+=" AND dokument_id='"+Dokument2+"' and operator_id="+str(self.operator_id)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania uprawnie do dok.magazynowych: '+stat
        elif len(d) == 0:
            stat = 'Brak uprawnie do dokumentw '+Dokument2+' w magazynie '+Magazyn2
        elif not (d[0][0] and d[0][1]):
            stat = 'Brak uprawnie do wprowadzania i zamykania '+Dokument2+' w magazynie '+Magazyn21


#-------------------------------------------------------------------------------
# SPRAWDZENIE CZY ISTNIEJA PROCESY DO TWORZENIA PW
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    dane1 = []
    dane2 = []
    NryPartii = ''
    
    sql ="SELECT DISTINCT pp.artykul_id,a.nazwa,pp.zrealizowano,pp.braki,pp.partia_id"
    sql+=" FROM rs_produkcja_plan pp"
    sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+=" INNER JOIN rs_artykuly a ON (a.firma_id='"+self.firma_id+"' AND a.artykul_id=pp.artykul_id)"
    sql+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id=o.generator_oddzial_id"
    sql+=" AND (pp.zrealizowano>0 OR pp.braki>0)"
    sql+=" AND pp.pw_dokument_id IS NULL AND pp.pw2_dokument_id IS NULL"
    sql+=" ORDER BY pp.artykul_id, pp.partia_id"

    stat,dane2,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy zrealizowanych zada: '+stat

    if stat == 'OK' and len(dane2) > 0:
        #z zapisow analitycznych zrobimy tabele dane1 zawierajaca sumy
        #i ilosci dla artykulow
        #nrypartii beda potrzebne przy tworzeniu dokumentow,
        #aby zapytanie o zamkniete procesy nie roznilo sie
        #o zakonczone w miedzyczasie procesy, gdy operator zastanawial
        #sie nad wystawieniem dokumentow z wybranych w tej funkcji procesow
        
        Artykul = dane2[0][0]
        Nazwa = dane2[0][1]
        Partia = dane2[0][4]
        Zrealizowano = 0
        Braki = 0
        
        for d in dane2:
            if Artykul <> d[0]:
                dane1.append([Artykul,Nazwa,Zrealizowano,Braki])
                Artykul = d[0]
                Nazwa = d[1]
                Zrealizowano = 0
                Braki = 0
                
            if Partia <> d[4]:
                NryPartii += str(Partia)+','
                Partia = d[4]
            
            Zrealizowano += d[2]
            Braki += d[3]
            
        dane1.append([Artykul,Nazwa,Zrealizowano,Braki])
        NryPartii = '('+NryPartii+str(Partia)+')'

    if stat == 'OK':
        dane = [dane1,dane2,NryPartii]


#-------------------------------------------------------------------------------
# UTWORZENIE NOWEGO DOKUMENTU MAGAZYNOWEGO W STANIE 'W'
#-------------------------------------------------------------------------------

if Fun == 13 and stat == 'OK':
    #Zmienne dla magazynu zrealizowanych koncza sie '1'
    #Zmienne dla magazynu brakow koncza sie '2'
    
    sql ="SELECT pd.wersja_pw, pd.kontrahent_id, pd.wersja_pw_braki, pd.kontrahent_id_braki"
    sql+=" FROM rs_produkcja_dokumenty pd"
    sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id="+str(self.operator_id)+")"
    sql+=" WHERE pd.firma_id='"+self.firma_id+"' AND pd.oddzial_id=o.generator_oddzial_id;"

    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o wersji cenowej: '+stat
    else:
        Wersja1 = str(d[0][0])
        Kontrahent1 = str(d[0][1])
        Wersja2 = str(d[0][2])
        Kontrahent2 = str(d[0][3])

    if stat == 'OK':
        #pobieramy dane zakonczonych partii i blokujemy je
        sql ="SELECT artykul_id, partia_id, zrealizowano, braki"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE partia_id IN "+NryPartii
        sql+=" AND pw_dokument_id IS NULL AND pw2_dokument_id IS NULL"
        sql+=" ORDER BY artykul_id, partia_id FOR UPDATE NOWAIT;"

        stat,PozycjeZPlanu,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania listy zakoczonych procesw: '+stat
        elif len(PozycjeZPlanu) == 0:
            stat = 'Brak zakoczonych procesw do utworzenia dokumentw.'
    
    if stat == 'OK':
        #robie slowniki, aby otrzymac pojedyncze zapisy
        #taki DISTINCT w pythonie
        
        SlownikArtykul = {}
        SlownikArtykulPartia = {}
        
        for i in PozycjeZPlanu:
            if not SlownikArtykul.has_key(i[0]):
                SlownikArtykul[i[0]] = eval(str(i))

            if not SlownikArtykulPartia.has_key((i[0],i[1])):
                SlownikArtykulPartia[(i[0],i[1])] = eval(str(i))

        #przygotowuje kolejnosc aby artykuly ukladaly sie w dokumencie
        #tak, jak na podgladzie w oknie - poza tym to ladnie wyglada

        KolejnoscArtykul = SlownikArtykul.keys()
        KolejnoscArtykul.sort()

        KolejnoscArtykulPartia = SlownikArtykulPartia.keys()
        KolejnoscArtykulPartia.sort()
        
        #zeruje ilosci dla artykulow
        for i in SlownikArtykul.keys():
            ProcesArtykul = SlownikArtykul[i]
            ProcesArtykul[2] = 0
            ProcesArtykul[3] = 0
            SlownikArtykul[i] = ProcesArtykul

        #sumuje ilosci dla artykulow
        for i in SlownikArtykulPartia.keys():
            ProcesArtykulPartia = SlownikArtykulPartia[i]
            Artykul = ProcesArtykulPartia[0]
            Zrealizowano = ProcesArtykulPartia[2]
            Braki = ProcesArtykulPartia[3]
            
            ProcesArtykul = SlownikArtykul[Artykul]
            ProcesArtykul[2] += Zrealizowano
            ProcesArtykul[3] += Braki
            
            SlownikArtykul[Artykul] = ProcesArtykul
        
        #sql dla INSERT naglowkow dokumentow -> rs_dokumenty_magazynowe
        INS_Dok1 = ''
        INS_Dok2 = ''
        
        #sql dla INSERT pozycji dokumentow -> rs_dokumenty_magazynowe_pozycje
        INS_Poz1 = ''
        INS_Poz2 = ''
        
        #sql dla UPDATE procesow w planie -> rs_produkcja_plan
        UPD_Plan = ''

        #sprawdzimy, czy w magazynie(1) zrealizowanych pobierac ceny
        sql ="SELECT czy_ceny FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn1+"';"

        sql,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu cen w magazynie '+Magazyn1
        elif len(d) <> 1:
            stat = 'Bdny numer magazynu '+Magazyn1
        else:
            StosowacCeny1 = d[0][0]

        #sprawdzimy, czy w magazynie(2) brakow pobierac ceny
        sql ="SELECT czy_ceny FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn2+"';"

        sql,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu cen w magazynie '+Magazyn2
        elif len(d) <> 1:
            stat = 'Bdny numer magazynu '+Magazyn2
        else:
            StosowacCeny2 = d[0][0]
            
    if stat == 'OK':
        #czy dwie jednostki miary
        sql ="SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o stosowaniu dwch jednostek miar: '+stat
        elif len(d) == 0:
            stat = 'Brak firmy o podanym kodzie '+self.firma_id
        else:
            DwieJM = d[0][0]    

    if stat == 'OK':
        #pobranie numeru dla nowego dokumentu - zrealizowano
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        sql+="'[\\\'"+Magazyn1+"\\\',\\\'"+Dokument1+"\\\',\\\'"+Data1+"\\\']','M');"

        stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania nowego numeru dla '+Dokument1+' z magazynu '+Magazyn1
        else:
            Numer1 = int(dane[0][0])

    if stat == 'OK':
        if Magazyn1 == Magazyn2:
            #jesli magazyn dobrych i brakow to ten sam magazyn
            #to na wszelki wypadek, chociaz to nie powinno tak byc
            Numer2 = Numer1 + 1
        else:
            #pobranie numeru dla nowego dokumentu - braki
            sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
            sql+="'[\\\'"+Magazyn2+"\\\',\\\'"+Dokument2+"\\\',\\\'"+Data2+"\\\']','M');"

            stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
            if stat <> 'OK':
                stat = 'Bd pobrania nowego numeru dla '+Dokument2+' z magazynu '+Magazyn2
            else:
                Numer2 = int(dane[0][0])

    if stat == 'OK':
        LiczPozDM1 = 0
        LiczPozDM2 = 0

        for i in KolejnoscArtykul:
            Cena1Magazyn1 = 0
            Cena2Magazyn1 = 0
            Cena1Magazyn2 = 0
            Cena2Magazyn2 = 0
        
            Proces = SlownikArtykul[i]
            Artykul = str(Proces[0])
            Zrealizowano1 = Proces[2]
            Braki1 = Proces[3]

            if Zrealizowano1 > 0 or Braki1 > 0:
                if StosowacCeny1:
                    sql ="SELECT rsf_podaj_ceny('"+self.firma_id+"',"
                    sql+="'"+Artykul+"','"+Wersja1+"','PLN','"+Data1+"');"

                    stat,d1,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bdy przy pobieraniu ceny :'+stat
                        break
                    
                    if stat == 'OK':
                        if len(d1)>0:
                            Ceny = rsglobal.rseval(d1[0][0])
                            if len(Ceny)>0:
                                Cena1Magazyn1 = Ceny[0]
                                Cena2Magazyn1 = Ceny[1]
                    
                if StosowacCeny2 and stat == 'OK':
                    sql ="SELECT rsf_podaj_ceny('"+self.firma_id+"',"
                    sql+="'"+Artykul+"','"+Wersja2+"','PLN','"+Data2+"');"

                    stat,d2,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bdy przy pobieraniu ceny :'+stat
                        break
                    
                    if stat == 'OK':
                        if len(d2)>0:
                            Ceny = rsglobal.rseval(d2[0][0])
                            if len(Ceny)>0:
                                Cena1Magazyn2 = Ceny[0]
                                Cena2Magazyn2 = Ceny[1]

                if stat == 'OK' and DwieJM:
                    sql ="SELECT przelicznik,COALESCE(cecha1_opis,'') FROM rs_artykuly"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                    sql+=" AND aktywny;"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        stat = 'Bd pobrania przelicznika dla artykuu '+stat
                        break
                    elif len(d) == 0:
                        stat = 'Brak artykuu o kodzie '+Artykul
                        break
                    elif d[0][1]<>'':
                        stat = 'Artyku '+Artykul.strip()+' posiada cech, dla ktrej nie mona poda wartoci'
                    else:
                        Przelicznik = d[0][0]
                
            if stat == 'OK' and Zrealizowano1 > 0:
                #dopisujemy INSERT dla pozycji zrealizowanych
                Zrealizowano2 = Zrealizowano1
                if DwieJM:
                    Zrealizowano2 = rsglobal.RSRound(Zrealizowano1*Przelicznik,4)
                    
                LiczPozDM1 += 1
                INS_Poz1+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
                INS_Poz1+=" (firma_id, magazyn_id, dokument_id, data,"
                INS_Poz1+="  numer, nr_poz, nr_ppoz, artykul_id,"
                INS_Poz1+="  ilosc1, ilosc2,"
                INS_Poz1+="  cena1, cena2,"
                INS_Poz1+="  cena_wal1, cena_wal2)"
                INS_Poz1+=" VALUES"
                INS_Poz1+=" ('"+self.firma_id+"','"+Magazyn1+"','"+Dokument1+"','"+Data1+"',"
                INS_Poz1+="  "+str(Numer1)+","+str(LiczPozDM1)+",0,'"+Artykul+"',"
                INS_Poz1+="  "+str(Zrealizowano1)+","+str(Zrealizowano2)+","
                INS_Poz1+="  "+str(Cena1Magazyn1)+","+str(Cena2Magazyn1)+","
                INS_Poz1+="  "+str(Cena1Magazyn1)+","+str(Cena2Magazyn1)+"); "

                #tworzymy sql-a do powiazania procesow z pozycja dokumentu magazynowego
                #dla ilosci zrealizowanej
            
                for j in KolejnoscArtykulPartia:
                    if Artykul == j[0]:
                        Partia = j[1]

                        UPD_Plan+= "UPDATE rs_produkcja_plan SET"
                        UPD_Plan+=" oper_pw="+str(self.operator_id)+","
                        UPD_Plan+=" pw_magazyn_id='"+Magazyn1+"',"
                        UPD_Plan+=" pw_dokument_id='"+Dokument1+"',"
                        UPD_Plan+=" pw_data='"+Data1+"',"
                        UPD_Plan+=" pw_numer="+str(Numer1)+","
                        UPD_Plan+=" pw_nr_poz="+str(LiczPozDM1)+", pw_nr_ppoz=0"
                        UPD_Plan+=" WHERE firma_id='"+self.firma_id+"'"
                        UPD_Plan+=" AND partia_id="+str(Partia)+"; "

            if stat == 'OK' and Braki1 > 0:
                #dopisujemy INSERT dla pozycji brakow
                Braki2 = Braki1
                if DwieJM:
                    Braki2 = round(Braki1*Przelicznik,4)
                    
                LiczPozDM2 += 1
                INS_Poz2+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
                INS_Poz2+=" (firma_id, magazyn_id, dokument_id, data,"
                INS_Poz2+="  numer, nr_poz, nr_ppoz, artykul_id,"
                INS_Poz2+="  ilosc1, ilosc2,"
                INS_Poz2+="  cena1, cena2,"
                INS_Poz2+="  cena_wal1, cena_wal2)"
                INS_Poz2+=" VALUES"
                INS_Poz2+=" ('"+self.firma_id+"','"+Magazyn2+"','"+Dokument2+"','"+Data2+"',"
                INS_Poz2+="  "+str(Numer2)+","+str(LiczPozDM2)+",0,'"+Artykul+"',"
                INS_Poz2+="  "+str(Braki1)+","+str(Braki2)+","
                INS_Poz2+="  "+str(Cena1Magazyn2)+","+str(Cena2Magazyn2)+","
                INS_Poz2+="  "+str(Cena1Magazyn2)+","+str(Cena2Magazyn2)+"); "

                #tworzymy sql-a do powiazania procesow z pozycja dokumentu magazynowego
                #dla ilosci brakow
            
                for j in KolejnoscArtykulPartia:
                    if Artykul == j[0]:
                        Partia = j[1]
                        
                        #FIXME: nazwy pol dla magazynu brakow
                        UPD_Plan+= "UPDATE rs_produkcja_plan SET"
                        UPD_Plan+=" oper_pw2="+str(self.operator_id)+","
                        UPD_Plan+=" pw2_magazyn_id='"+Magazyn2+"',"
                        UPD_Plan+=" pw2_dokument_id='"+Dokument2+"',"
                        UPD_Plan+=" pw2_data='"+Data2+"',"
                        UPD_Plan+=" pw2_numer="+str(Numer2)+","
                        UPD_Plan+=" pw2_nr_poz="+str(LiczPozDM2)+", pw2_nr_ppoz=0"
                        UPD_Plan+=" WHERE firma_id='"+self.firma_id+"'"
                        UPD_Plan+=" AND partia_id="+str(Partia)+"; "

    
    if stat == 'OK':
        if LiczPozDM1 == 0:
            #brak pozycji zrealizowanych - kasuje numer dokumentu
            Numer1 = 0
            
        if LiczPozDM2 == 0:
            #brak pozycji brakow - kasuje numer dokumentu
            Numer2 = 0
        elif Magazyn1 == Magazyn2:
            #to na wypadek, gdyby magazyn dobrych i brakow byly tym samym
            if Numer1 == 0:
                #jesli nie bylo dobrych, to braki dostaja numer poprzedni,
                #ktory byl zarezerwowany dla dobrych
                Numer2 -= 1
        
        if LiczPozDM1 > 0:
            INS_Dok1 ="INSERT INTO rs_dokumenty_magazynowe"
            INS_Dok1+=" (firma_id, magazyn_id, dokument_id,"
            INS_Dok1+=" data, numer, wersja,"
            INS_Dok1+=" magazyn_dokad, kontrahent_id)"
            INS_Dok1+=" VALUES "
            INS_Dok1+=" ('"+self.firma_id+"','"+Magazyn1+"','"+Dokument1+"',"
            INS_Dok1+="'"+Data1+"',"+str(Numer1)+",'"+Wersja1+"',"
            INS_Dok1+="'"+Magazyn1+"','"+Kontrahent1+"');"

        if LiczPozDM2 > 0:
            INS_Dok2 ="INSERT INTO rs_dokumenty_magazynowe"
            INS_Dok2+=" (firma_id, magazyn_id, dokument_id,"
            INS_Dok2+=" data, numer, wersja,"
            INS_Dok2+=" magazyn_dokad, kontrahent_id)"
            INS_Dok2+=" VALUES "
            INS_Dok2+=" ('"+self.firma_id+"','"+Magazyn2+"','"+Dokument2+"',"
            INS_Dok2+="'"+Data2+"',"+str(Numer2)+",'"+Wersja2+"',"
            INS_Dok2+="'"+Magazyn2+"','"+Kontrahent2+"');"

            
    if stat == 'OK' and (Numer1 > 0 or Numer2 > 0):
        UPDATE = INS_Dok1 + INS_Poz1 + INS_Dok2 + INS_Poz2 + UPD_Plan
        
        stat,dane,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd tworzenia dokumentw: '+stat

    NumerNaWydruk1 = ''
    NumerNaWydruk2 = ''
        
    if stat == 'OK' and LiczPozDM1 > 0:
        sql ="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"',"
        sql+="'[\\\'"+Magazyn1+"\\\',\\\'"+Dokument1+"\\\',\\\'"+Data1+"\\\',\\\'"+str(Numer1)+"\\\']','M');"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru dokumentu '+Dokument1+' '+str(Numer1)+' na wydruk'
        else:
            NumerNaWydruk1 = str(d[0][0])

    if stat == 'OK' and LiczPozDM2 > 0:
        sql ="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"',"
        sql+="'[\\\'"+Magazyn2+"\\\',\\\'"+Dokument2+"\\\',\\\'"+Data2+"\\\',\\\'"+str(Numer2)+"\\\']','M');"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru dokumentu '+Dokument2+' '+str(Numer2)+' na wydruk'
        else:
            NumerNaWydruk2 = str(d[0][0])

    if stat == 'OK':
        dane = []
        dane.append([Magazyn1,Dokument1,Data1,Numer1,NumerNaWydruk1])
        dane.append([Magazyn2,Dokument2,Data2,Numer2,NumerNaWydruk2])


#-------------------------------------------------------------------------------
# USUNIECIE WPISOW O POZYCJACH DOKUMENTOW MAGAZYNOWYCH I TYCH DOKUMENTOW MAG.
#-------------------------------------------------------------------------------

if Fun == 23 and stat == 'OK':
    sql ="SELECT partia_id FROM rs_produkcja_plan"
    sql+=" WHERE partia_id IN "+NryPartii+" FOR UPDATE NOWAIT; "
    
    if Numer1 > 0:
        sql+="SELECT stan FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn1+"'"
        sql+=" AND dokument_id='"+Dokument1+"' AND data='"+Data1+"'"
        sql+=" AND numer="+str(Numer1)+" FOR UPDATE NOWAIT; "

        sql+="SELECT nr_poz FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn1+"'"
        sql+=" AND dokument_id='"+Dokument1+"' AND data='"+Data1+"'"
        sql+=" AND numer="+str(Numer1)+" FOR UPDATE NOWAIT; "

    if Numer2 > 0:
        sql+="SELECT stan FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn2+"'"
        sql+=" AND dokument_id='"+Dokument2+"' AND data='"+Data2+"'"
        sql+=" AND numer="+str(Numer2)+" FOR UPDATE NOWAIT; "

        sql+="SELECT nr_poz FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn2+"'"
        sql+=" AND dokument_id='"+Dokument2+"' AND data='"+Data2+"'"
        sql+=" AND numer="+str(Numer2)+" FOR UPDATE NOWAIT; "
        
    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
    if stat <> 'OK':
        stat = 'Bd przygotowania danych do wycofania dokumentw: '+stat
        
    if stat == 'OK':
        UPD ="UPDATE rs_produkcja_plan SET"
        UPD+=" oper_pw=0, pw_magazyn_id=NULL, pw_dokument_id=NULL,"
        UPD+=" pw_data=NULL, pw_numer=0, pw_nr_poz=0, pw_nr_ppoz=0,"
        UPD+=" oper_pw2=0, pw2_magazyn_id=NULL, pw2_dokument_id=NULL,"
        UPD+=" pw2_data=NULL, pw2_numer=0, pw2_nr_poz=0, pw2_nr_ppoz=0"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND partia_id IN "+NryPartii+"; "
        
        if Numer1 > 0:
            UPD+=" DELETE FROM rs_dokumenty_magazynowe"
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn1+"'"
            UPD+=" AND dokument_id='"+Dokument1+"' AND data='"+Data1+"'"
            UPD+=" AND numer="+str(Numer1)+"; "
            
        if Numer2 > 0:
            UPD+=" DELETE FROM rs_dokumenty_magazynowe"
            UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn2+"'"
            UPD+=" AND dokument_id='"+Dokument2+"' AND data='"+Data2+"'"
            UPD+=" AND numer="+str(Numer2)+"; "

        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd wycofania tworzenia dokumentw: '+stat
