# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pan_zadania.py
# Purpose:     zadania z tabeli rs_produkcja_plan
#
# Author:      Jan Kaliszewski, Mariusz Rajfura
# Created:     2010/03/15
# RCS-ID:      $Id: fs_pan_zadania.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#klucze[0] - lista z kluczem pozycji
#klucze[1] - lista z filtrem
#klucze[2] - ilosci dot.partii 


# 2013-07-01 Mariusz Rajfura (6998) oddzial_id do filtrow w rs_procesy_artykuly
# 2013-11-05 Mariusz Rajfura (7278) linia produkcyjna do filtrow
# 2013-11-13 Mariusz Rajfura (7379) opcja 'dostepne' dla filtrowania zadan oczekujacych

Oddzial = rsglobal.Dekoduj(klucze[0][0]).strip()
Data = rsglobal.Dekoduj(klucze[0][1]).strip()
Zmiana = rsglobal.Dekoduj(klucze[0][2]).strip()
Proces = rsglobal.Dekoduj(klucze[0][3]).strip()
Artykul = rsglobal.Dekoduj(klucze[0][4]).strip()
Urzadzenie = rsglobal.Dekoduj(klucze[0][5]).strip()
GodzMinuta = rsglobal.Dekoduj(klucze[0][6]).strip()

GodzinaOdF = rsglobal.Dekoduj(klucze[1][0]).strip()
GodzinaDoF = rsglobal.Dekoduj(klucze[1][1]).strip()
ArtykulF = rsglobal.Dekoduj(klucze[1][2]).strip()
UrzadzenieF = rsglobal.Dekoduj(klucze[1][3]).strip()
KategoriaArtykuluF = rsglobal.Dekoduj(klucze[1][4]).strip()
OczekujaceF = klucze[1][5]
LiniaProdukcyjnaF = rsglobal.Dekoduj(klucze[1][6]).strip()
DostepneF = klucze[1][7]

Zrealizowano = klucze[2][0]
Braki = klucze[2][1]
Fun = klucze[-1]

#-------------------------------------------------------------------------------
#FIXME: !!!
#Jak ustalic nastepnego operatora w przypadku automatycznego uruchamiania
#nastepnego procesu, zwlaszcza w przypadku, gdy kilku operatorow ma 
#uprawnienia do tego samego stanowiska?
#Do tego, jak sprawdzic, czy wybrany operator jest wogole dostepny?
#Bo mozna przypisac proces operatowi na urlopie :-)
#To jest proteza na czas testow.
NastOper = {}

#testing
NastOper['222'] = 223   #ciast->oper
NastOper['223'] = 224   #oper->piec
NastOper['224'] = 225   #piec->bryg
NastOper['225'] = 227   #bryg->ekspe

#moje ustawienia lokalne (mariusz)
NastOper['1'] = 2
NastOper['2'] = 3
NastOper['3'] = 4
NastOper['4'] = 5
#-------------------------------------------------------------------------------


stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprStart = ((self.oddzial_id,'501001') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprKoniec = (self.oddzial_id,'501002') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprWstrzymanie = (self.oddzial_id,'501003') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprWznowienie = (self.oddzial_id,'501004') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprPrzerwanie = (self.oddzial_id,'501005') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

WHERE =" firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND data='"+Data+"'"
WHERE+=" AND zmiana='"+Zmiana+"' AND proces_id='"+Proces+"' AND artykul_id='"+Artykul+"'"
WHERE+=" AND urzadzenie_id='"+Urzadzenie+"' AND godz_minuta='"+GodzMinuta+":00'"

#-------------------------------------------------------------------------------
# POBRANIE DANYCH DO GRIDA Z KATEGORIAMI ARTYKULOW
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    SEL ="SELECT kod, opis FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"'"
    if KategoriaArtykuluF <> '':
        SEL+=" AND kod LIKE '"+KategoriaArtykulowF+"%'"
    SEL+=" ORDER BY kod;"
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy z kategoriami artykuw: '+stat

#-------------------------------------------------------------------------------
# POBRANIE DANYCH DO GRIDA Z ARTYKULAMI
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    SEL ="SELECT artykul_id, nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
    if ArtykulF <> '':
        SEL+=" AND artykul_id LIKE '"+ArtykulF+"%'"
    SEL+=" AND aktywny ORDER BY artykul_id;"
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy artykuw: '+stat

#-------------------------------------------------------------------------------
# POBRANIE DANYCH DO GRIDA Z URZADZENIAMI
#-------------------------------------------------------------------------------

if Fun == 13 and stat == 'OK':
    SEL ="SELECT u.urzadzenie_id, u.nazwa FROM rs_urzadzenia u"
    SEL+=" INNER JOIN rs_operatorzy o ON (u.oddzial_id=o.generator_oddzial_id)"
    SEL+=" WHERE firma_id='"+self.firma_id+"' AND o.operator_id='"+str(self.operator_id)+"'"
    if UrzadzenieF <> '':
        SEL+=" AND u.urzadzenie_id LIKE '"+UrzadzenieF+"%'"
    SEL+=" ORDER BY u.urzadzenie_id;"
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy urzdze: '+stat

#-------------------------------------------------------------------------------
# WYSTARTOWANIE ZADANIA OCZEKUJACEGO - 21
#-------------------------------------------------------------------------------

if Fun == 21 and stat == 'OK':
    if not UprStart:
        stat = 'Brak uprawnie do startu procesu'

    if stat == 'OK':
        SEL ="SELECT partia_id,kolejnosc,oper_poczatek FROM rs_produkcja_plan"
        SEL+=" WHERE "+WHERE+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(SEL, 2)
        if stat <> 'OK':
            stat = 'Brak pozycji o podanym kluczu: '+stat
    
    if stat == 'OK':
        sql ="SELECT kolejnosc FROM rs_produkcja_plan "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(d[0][0])
        sql+=" AND kolejnosc<"+str(d[0][1])+" AND (oper_koniec IS NULL or oper_koniec=0)"
        sql+=" ORDER BY kolejnosc DESC LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o caej partii '+stat
        elif len(d) > 0:
            stat = 'Poprzedni proces w tej partii nie jest zakoczony.\nStart nastpnego procesu niemoliwy.'

    if stat == 'OK' and len(wyn2) == 0:
        UPD="UPDATE rs_produkcja_plan"
        UPD+=" SET oper_poczatek="+str(self.operator_id)+", czas_poczatek=NOW()"
        UPD+=" WHERE "+WHERE+";"
        
        stat,d,dump,dump = self.PolSQL.Execute(UPD, 1)
        rsglobal.ZapiszDoLogow('Update startujacy proces  '+str(UPD),1)
        rsglobal.ZapiszDoLogow('Stat update startujacego proces  '+str(stat),1)

        if stat <> 'OK':
            stat = 'Bd aktualizacji zadania: '+stat

#-------------------------------------------------------------------------------
# ZAKONCZENIE ZADANIA W TOKU - 22
# JESLI PROCES MA URUCHAMIAC NASTEPNY PROCES, TO STARTUJEMY NASTEPNY
# JESLI TO OSTATNI PROCES, TO WPISUJEMY ILOSCI DO CALEJ PARTII
# ORAZ AKTUALIZUJEMY ILOSC W rs_produkcja_sumy
#-------------------------------------------------------------------------------

if Fun == 22 and stat == 'OK':
    if not UprKoniec:
        stat = 'Brak uprawnie do zakoczeniu procesu'

    if stat == 'OK':
        sql ="SELECT partia_id,kolejnosc,artykul_id,oddzial_id,data,zmiana,czas_poczatek"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE "+WHERE+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych pozycji: '+stat
        else:
            Partia = d[0][0]
            Kolejnosc = d[0][1]
            Artykul = str(d[0][2]).strip()
            OddzialProd = str(d[0][3]).strip()
            OddzialZam = OddzialProd
            Data = str(d[0][4])
            Zmiana = str(d[0][5]).strip()
            CzasWprowadzenia = str(d[0][6]).strip()

    if stat == 'OK':
        sql ="SELECT nastepny_proces FROM rs_procesy_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' and oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND proces_id='"+Proces+"' AND artykul_id='"+Artykul+"' AND urzadzenie_id='"+Urzadzenie+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych procesu : '+stat
        else:
            NastepnyProces = d[0][0]
        rsglobal.ZapiszDoLogow('Nastepny proces do wystartowania  '+str(NastepnyProces),1)
        
    if stat == 'OK':
        #pobranie ewentualnych nastepnych procesow
        sql ="SELECT kolejnosc FROM rs_produkcja_plan "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        sql+=" AND kolejnosc>"+str(Kolejnosc)+" ORDER BY kolejnosc;"
        stat,nastepne,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o caej partii '+stat
        rsglobal.ZapiszDoLogow('Jest nastepny proces do wystartowania  '+str(nastepne),1)

    if stat == 'OK':
        #zamkniecie procesu
        UPD="UPDATE rs_produkcja_plan"
        UPD+=" SET oper_koniec="+str(self.operator_id)+", czas_koniec=NOW()"
        UPD+=" WHERE "+WHERE+";"
        
        if len(nastepne) == 0:
            #jesli to ostatni proces, sprawdzamy, czy podano ilosci: Zrealizowane, Braki
            if Zrealizowano == None or Braki == None:
                stat = 'Zakoczenie ostatniego procesu wymaga podania iloci zrealizowanej i brakw'
            else:
                #wpisanie do wszystkich pozycji partii ilosci: Zrealizowano, Braki
                UPD+="UPDATE rs_produkcja_plan"
                UPD+=" SET zrealizowano="+str(Zrealizowano)+", braki="+str(Braki)
                UPD+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)+"; "

            Zrealizowano1 = Zrealizowano
            Zrealizowano2 = Zrealizowano
            Braki1 = Braki
            Braki2 = Braki
            
            if stat == 'OK':
                sql ="SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    stat = 'Bd pobrania informacji o stosowaniu dwch jednostek miar: '+stat
                elif len(d) == 0:
                    stat = 'Brak firmy o podanym kodzie '+self.firma_id
                else:
                    DwieJM = d[0][0]    

                if stat == 'OK' and DwieJM:
                    sql ="SELECT przelicznik FROM rs_artykuly"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                    sql+=" AND aktywny;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        stat = 'Bd pobrania przelicznika dla artykuu '+stat
                    elif len(d) == 0:
                        stat = 'Brak artykuu o kodzie '+Artykul
                    else:
                        Zrealizowano2 = round(Zrealizowano1*d[0][0],4)
                        Braki2 = round(Braki1*d[0][0],4)
                
                #FIXME: 
                #pobieram artykuly, ktorych ilosc zrealizowana jest
                #mniejsza od ilosci zamowionej
                #do tych artykulow dodaje ilosci do wyrownania ilosci
                #zamowionej ze zrealizowana.
                #Nadmiar ilosci zrealizowanej, ktora nie mozna dodac
                #jest pomijana
                
                sql ="SELECT data,oddzial_zam,oddzial_prod,zmiana,czas_wprowadzenia,"
                sql+=" zamowione1,wyprodukowane1"
                sql+=" FROM rs_produkcja_sumy WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND artykul_id='"+Artykul+"' AND zamowione1 < wyprodukowane1 FOR UPDATE NOWAIT;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania informacji o sumach na produkcji: '+stat
                    
                elif len(d) == 1:
                    #aktualizujemy
                    UPD+="UPDATE rs_produkcja_sumy SET"
                    UPD+=" wyprodukowane1=wyprodukowane1+"+str(Zrealizowano1)+","
                    UPD+=" wyprodukowane2=wyprodukowane2+"+str(Zrealizowano2)+","
                    UPD+=" braki1=braki1+"+str(Braki1)+","
                    UPD+=" braki2=braki2+"+str(Braki2)
                    UPD+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
                    UPD+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
                    UPD+=" AND zmiana='"+Zmiana+"' AND artykul_id='"+Artykul+"'"
                    UPD+=" AND czas_wprowadzenia='"+CzasWprowadzenia+"'; "
                elif len(d) == 0:
                    #dodajemy zapis, zeby zobaczyc, ze dziala :-)
                    UPD+="INSERT INTO rs_produkcja_sumy"
                    UPD+=" (firma_id,data,oddzial_zam,oddzial_prod,"
                    UPD+="  zmiana,artykul_id,czas_wprowadzenia,"
                    UPD+="  wyprodukowane1,wyprodukowane2,"
                    UPD+="  braki1,braki2)"
                    UPD+=" VALUES "
                    UPD+=" ('"+self.firma_id+"','"+Data+"','"+OddzialZam+"','"+OddzialProd+"',"
                    UPD+="  '"+Zmiana+"','"+Artykul+"','"+CzasWprowadzenia+"',"
                    UPD+="  "+str(Zrealizowano1)+","+str(Zrealizowano2)+","
                    UPD+="  "+str(Braki1)+","+str(Braki2)+"); "
                
        elif NastepnyProces:            
            #FIXME: !!!
            #uruchomienie nastepnego procesu z przypisaniem do operatora
            #Pki co ustawiamy zawsze operatora systemowego o nazwie produkcja_start
            #W nowych firmach operator taki bdzie si zakada z id==3, ale ze wzgldu na starte firmy,
            #musimy pobiera jego ID
##            SELOP="SELECT operator_id from rs_operatorzy where login='produkcja_start';"
##            stat,id,dump,dump = self.PolSQL.Execute(SELOP,3)
##            if stat<>'OK':
##                stat='Bld pobierania indeksu operatora systemowego startujcego nastpny proces.'
##            elif len(id)==0:
##                stat='Nie istnieje systemowy operator startujcy nastpny proces.'
##            
##            if stat=='OK':
                #uruchamiamy nastepny proces
                UPD+="UPDATE rs_produkcja_plan"
                UPD+=" SET oper_poczatek="+str(self.operator_id)+", czas_poczatek=NOW()"
                UPD+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)+" AND kolejnosc="+str(nastepne[0][0])+";"
                
    if stat == 'OK' and len(wyn2) == 0:
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd aktualizacji danych : '+stat


#-------------------------------------------------------------------------------
# SPRAWDZENIE, CZY PODANY PROCES JEST OSTATNIM W PARTII
#-------------------------------------------------------------------------------

if Fun == 23 and stat == 'OK':
    sql ="SELECT partia_id,kolejnosc FROM rs_produkcja_plan"
    sql+=" WHERE "+WHERE+" FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych pozycji: '+stat
    else:
        Partia = d[0][0]
        Kolejnosc = d[0][1]
        
    if stat == 'OK':
        #pobranie ewentualnych nastepnych procesow
        sql ="SELECT kolejnosc FROM rs_produkcja_plan "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        sql+=" AND kolejnosc>"+str(Kolejnosc)+" ORDER BY kolejnosc;"
        stat,nastepne,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o caej partii '+stat

        elif len(nastepne) == 0:
            wyn2.append(True)
        else:
            wyn2.append(False)

#-------------------------------------------------------------------------------
# WSTRZYMANIE PROCESU - 24
#-------------------------------------------------------------------------------

if Fun == 24 and stat == 'OK':
    if not UprWstrzymanie:
        stat = 'Brak uprawnie do wstrzymania procesu'


#-------------------------------------------------------------------------------
# WZNOWIENIE PROCESU - 25
#-------------------------------------------------------------------------------

if Fun == 25 and stat == 'OK':
    if not UprWstrzymanie:
        stat = 'Brak uprawnie do wznowienia procesu'
    

#-------------------------------------------------------------------------------
# PRZERWANIE PROCESU - 26
#-------------------------------------------------------------------------------

if Fun == 26 and stat == 'OK':
    if not UprPrzerwanie:
        stat = 'Brak uprawnie do przerwania procesu'


#-------------------------------------------------------------------------------
# SELECT - 5
#-------------------------------------------------------------------------------

if Fun in (5,21,22) and stat == 'OK':
    SEL ="SELECT pp.artykul_id, a.nazwa, pp.data::TEXT, pp.godz_minuta,"                  # 0-3
    SEL+=" pp.do_produkcji, pp.zrealizowano, COALESCE(pp.uwagi,''::TEXT), pp.proces_id,"  # 4-7
    SEL+=" pp.urzadzenie_id, pp.zmiana, pp.oddzial_id, pp.partia_id,"                     # 8-11
    SEL+=" pp.zamowiono, pp.braki, pp.kolejnosc"                                          # 12-14
    SEL+=" FROM rs_produkcja_plan pp"
    SEL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SEL+=" INNER JOIN rs_procesy_artykuly pa ON(pp.firma_id=pa.firma_id AND pp.oddzial_id=pa.oddzial_id AND pp.proces_id=pa.proces_id AND pp.artykul_id=pa.artykul_id AND pp.urzadzenie_id=pa.urzadzenie_id)"
    SEL+=" INNER JOIN rs_urzadzenia u ON (pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id)"
    
    if OczekujaceF:
        SEL+=" INNER JOIN rs_operatorzy o ON(pa.stanowisko_pocz=o.stanowisko_id AND pp.oddzial_id=o.generator_oddzial_id)"
    else:
        SEL+=" INNER JOIN rs_operatorzy o ON(pa.stanowisko_pocz=o.stanowisko_id AND pp.oddzial_id=o.generator_oddzial_id)"
        
    SEL+=" WHERE pp.firma_id='"+self.firma_id+"'"
    SEL+=" AND o.operator_id='"+str(self.operator_id)+"'"
        
    if KategoriaArtykuluF <> '':
        SEL+=" AND a.kateg_artykulu LIKE '"+KategoriaArtykuluF+"%'"    

    if ArtykulF <> '':
        SEL+=" AND pp.artykul_id LIKE '"+ArtykulF+"%'"

    if UrzadzenieF <> '':
        SEL+=" AND pp.urzadzenie_id LIKE '"+UrzadzenieF+"%'"

    if LiniaProdukcyjnaF <> '':
        # jesli urzadzenie nie ma przypisanej linii produkcyjnej, to tez spelnia warunek
        SEL+=" AND COALESCE(u.linia_id,'"+LiniaProdukcyjnaF+"')='"+LiniaProdukcyjnaF+"'"

    #Jesli podana godzina jest wczesniejsza niz biezaca (o 1 minute), to oznacza,
    #ze interesuje nas nastepny dzien. To samo dotyczy GodzinaDoF
    
    if GodzinaOdF <> '':
        SEL+=" AND (data||' '||godz_minuta)::TIMESTAMP >="
        SEL+="  CASE WHEN '"+GodzinaOdF+"' < SUBSTRING( (NOW()::TIME - INTERVAL '1 MINUTE')::TEXT FROM 1 FOR 5)"
        SEL+="  THEN ( (NOW() + INTERVAL '1 DAY')::DATE||' '||'"+GodzinaOdF+"'||':00')::TIMESTAMP"
        SEL+="  ELSE (NOW()::DATE||' '||'"+GodzinaOdF+"'||':00')::TIMESTAMP"
        SEL+="  END"

    if GodzinaDoF <> '':
        SEL+=" AND (data||' '||godz_minuta)::TIMESTAMP <="
        SEL+="  CASE WHEN '"+GodzinaDoF+"' < SUBSTRING( (NOW()::TIME - INTERVAL '1 MINUTE')::TEXT FROM 1 FOR 5)"
        SEL+="  THEN ( (NOW() + INTERVAL '1 DAY')::DATE||' '||'"+GodzinaDoF+"'||':00')::TIMESTAMP"
        SEL+="  ELSE (NOW()::DATE||' '||'"+GodzinaDoF+"'||':00')::TIMESTAMP"
        SEL+="  END"
        
    if OczekujaceF:
        #oczekujace nie maja przydzielonego operator
        SEL+=" AND (pp.oper_poczatek IS NULL OR pp.oper_poczatek=0)"
    else:
        #jesli nie oczekujace, to w toku, 
        #zmienim pobieranie procesw w toku tak, e nie interesuje nas operator, ktry wystartowa automatycznie proces
        SEL+=" AND (pp.oper_poczatek IS NOT NULL AND pp.oper_koniec IS NULL) "   
    SEL+=" ORDER BY pp.data, pp.godz_minuta;"
    rsglobal.ZapiszDoLogow('1111111111111111111111'+SEL,1)
    stat,dane,dump,dump = self.PolSQL.Execute(SEL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z planu produkcji: '+stat

    if stat == 'OK' and OczekujaceF and DostepneF and len(dane) > 0:
        # opcja 'dostepne' dla oczekujacych oznacza, ze zostawiamy tylko te procesy,
        # ktore operator moze wystartowac, czyli spelniaja kryteria do startu procesu
        # czyli po

        dousuniecia = []

        for i in xrange(len(dane)):
            partia = dane[i][11]
            kolejnosc = dane[i][14]
            
            sql ="SELECT kolejnosc FROM rs_produkcja_plan "
            sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(partia)
            sql+=" AND kolejnosc<"+str(kolejnosc)+" AND oper_koniec IS NULL"
            sql+=" ORDER BY kolejnosc DESC LIMIT 1;"
            rsglobal.ZapiszDoLogow('SELECT POBIERAJACY ZADANIA   '+sql,1)
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o caej partii '+stat
                break
            elif len(d) > 0:
                dousuniecia.append(i)

        if stat == 'OK' and len(dousuniecia) > 0:
            # usuwamy wiersze z wynikow SELECTA; od konca listy aby nie zaburzyc kolejnosci
            for i in xrange(len(dousuniecia)-1,-1,-1):
                dane.pop(dousuniecia[i])
