# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_paragony_fiskalne.py
# Purpose:     wczytuje/usuwa/wstawia dane z paragonami fiskalnymi
# Author:      Micha Raburski
# Created:     2007/04/23
# RCS-ID:      $Id: fs_paragony_fiskalne.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# dodawanie z rs_oddzialy wersji sprzedaz (jesli jest) jesli nie to z klucza - Dariusz Boduch 2009-02-16 - mantis:1726
# 27.02.2009 - Dariusz Boduch - dodanie i obsuga pola przedplata matis:1799
# 09.03.2009 - Dariusz Boduch - obsuga bdnej daty od do mantis: 531
# 11.03.2009 - Dariusz Boduch - tworzenie faktury z grupy paragonow mantis: 1885
# 16.03.2009 - Dariusz Boduch - poprawki, mantis: 1895
# 17.03.2009 - Dariusz Boduch - poprawki, mantis: 1907
# 24.04.2009 - dariusz Boduch - dodanie funkcjonalnosci - nie sumowac artykulow podczas tworzenia faktur z paragonow mantis: 2028
# 04.10.2009 - mariusz rajfura - dodanie pola kasa_id do filtra
# 29.09.2009 i 15.10.2009 - Jan Kaliszewski - usprawnienie spr. czy jest kasa w Fun==1
# 12.12.2010 - mariusz rajfura - Kontrola stawek VAT z terminami ich obowiazywania,kontrola istnienia kodow druk.fisk,
#                                blokada zamykania parag.jesli Data!=biezacej. Wszystkie poprawki w Fun==10
# 12.05.2011 - Mariusz Rajfura - kontrola tworzenia wz-ki z param.dla wz w podanym magazynie (4578)
# 19.09.2011 - Mariusz Rajfura - blokady SELECT FOR UPDATE dla paragonow fiskalnych (4926)
# 2013-02-03 Mariusz Rajfura       (6478) kontrola blokady kontrahenta przed wystawieniem faktury
# 2016-03-15 Piotr Witkowski       (9723) okno gwne paragonw fiskalnych - refaktoryzacja
# 2017-10-18 Rafa Woniak        (10782) dodanie pobierania danych czy oddzielny wat
# 2019-08-06 Wojciech Skowron     (11579) Przy tworzeniu faktur - czy_mpp ustawiane na True jesli zaznaczone u patnika lub kontrahenta
# 2019-12-13 Jan Raburski         (11789) wydruk NIP na paragonie
# 2020-03-23 Mikoaj Kozowski    (11906) Uzupenianie pola 'kod_gtu' w pozycjach faktury przy tworzeniu faktur z paragonow
# 2021-02-02 Mikoaj Kozowski    (12305) Uzupenianie salda pocztkowego w raporcie kasowym
# 2021-11-02 Wojciech Skowron     (12674) Wpisanie sum z pozycji do stawek vat i nagwka faktury po insertach pozycji w tworzeniu faktur z paragonow
# 2021-12-14 Aleksander Bargie - (12766) Zmiany w zamykaniu paragonw i faktur
# 2022-04-06 Wojciech Skowron   - (12855) Dodatkowa kolumna 'aktywne_platnosci'
# 2022-04-12 Wojciech Skowron   - (12851/12855) Weryfikacja sposobw zapaty w patnociach z definicj przy zamykaniu
# 2022-04-26 Aleksander Bargie - (12993) Bd podczas zamykania paragonu
# 2023-08-17 Aleksander Bargie - (13515) [SP] zamykanie paragonu

from funkcje import fs_magazyny_parametry_dokumentow_pom
from funkcje import fs_dokumenty_magazynowe_pom
from funkcje import fs_okresy_pom
from funkcje import fs_raporty_wyciagi_pom

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    filtry = [1,2,5,6,11,12,17,21]
    SlPar={'Oddzial':[1,6,16,10,11,12,13,14,16,17,20,21,22,23],'Kasa':[1,6,16,10,11,12,13,14,16,17,20,21,22,23],
           'Data':[6,16,10,11,12,13,14,16,17,20,21,22,23],'Numer':[6,16,10,11,12,13,14,16,17,20,21,22,23],
           'OddzialF':filtry,'KasaF':filtry,'DataOdF':filtry,'DataDoF':filtry,
           'StanF':filtry,'WersjaF':filtry,'WyznF':filtry,
           'KlFakt':[12,13,14,17,21],'ListaParagonow':[12,] }

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_paragony_fiskalne z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,6,16,10,11,12,13,14,16,17,20,21,22,23]:
        Oddzial = str(klucze['Oddzial'])
        Kasa = str(klucze['Kasa'])
    if Funkcja in [6,16,10,11,12,13,14,16,17,20,21,22,23]:
        Data = str(klucze['Data'])
        Numer = klucze['Numer']
    if Funkcja in filtry:
        OddzialF = str(klucze['OddzialF'])
        KasaF = str(klucze['KasaF'])
        DataOdF = str(klucze['DataOdF'])
        DataDoF = str(klucze['DataDoF'])
        StanF = str(klucze['StanF'])
        WersjaF = str(klucze['WersjaF'])
        WyznF = str(klucze['WyznF'])
if stat=='OK':
    if Funkcja in [12,13,14,17,21]:
        KlFakt = klucze['KlFakt']
if stat=='OK':
    if Funkcja in [12,]:
        ListaParagonow = klucze['ListaParagonow']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

#Wersja = rsglobal.Dekoduj(klucze[4])


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE , CZY NA PARAGONIE S POZYCJE INNE NI USUGI (22) 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 22:
    SQL="SELECT COUNT(*) FROM rs_paragony_fiskalne_pozycje pp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id='"+Oddzial+"' AND pp.kasa_id='"+Kasa+"'"
    SQL+=" AND pp.data='"+Data+"' AND pp.numer="+str(Numer)+" AND NOT a.typ_artykulu IN ('31','99')"

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE , CZY DOKUMENT Z PARAGONU JEST ZAMKNIETY (20) 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 20:
    SQL="SELECT dm.stan,dm.magazyn_id,dm.dokument_id,dm.data,dm.numer FROM rs_paragony_fiskalne pf LEFT OUTER JOIN rs_dokumenty_magazynowe dm "
    SQL+=" ON (pf.firma_id=dm.firma_id AND pf.magazyn_id=dm.magazyn_id AND pf.dokument_id=dm.dokument_id "
    SQL+=" AND pf.data_dm=dm.data AND pf.numer_dm=dm.numer) WHERE pf.firma_id='"+self.firma_id+"' "
    SQL+=" AND pf.oddzial_id='"+Oddzial+"' AND pf.kasa_id='"+Kasa+"' AND pf.data='"+Data+"' AND pf.numer="+str(Numer)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(dane)==0:
            stat='STAN SPR BL'
    if stat=='OK':
        if dane[0][0] in ('G','Z'):
            stat='STAN DOK BL'

#-------------------------------------------------------------------------------
#---   POBRANIE DOKUMENTU MAGAZYNOWEGO I JEGO STANU Z PARAGONU (23) 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 23:
    SQL="SELECT dm.magazyn_id,dm.dokument_id,dm.data,dm.numer,dm.stan FROM rs_paragony_fiskalne p "
    SQL+=" INNER JOIN rs_dokumenty_magazynowe dm ON (dm.firma_id=p.firma_id AND dm.magazyn_id=p.magazyn_id "
    SQL+=" AND dm.dokument_id=p.dokument_id AND dm.data=p.data_dm AND dm.numer=numer_dm)"
    SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.oddzial_id='"+Oddzial+"' AND p.kasa_id='"+Kasa+"'"
    SQL+=" AND p.data='"+Data+"' AND p.numer="+str(Numer)

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)            
            
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1) 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 1 :
    if not (((self.oddzial_id,'025013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR INS'

    if stat=='OK':
        if self.oddzial_id != OddzialF:
            stat = u'Nie mona doda paragonu w oddziale innym, ni jest si zalogowanym'

    if stat=='OK':    
        #sprawdzenie czy istniej niezamknite paragony w oddziale
        SQL="SELECT * FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND oddzial_id='"+self.oddzial_id+"' AND stan='W';"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest)>0:
                stat="ISTN OTW"
                dane.append(stat)

    if stat=='OK':
        sql="SELECT kasa_id,COALESCE(kontrahent_domyslny,'') FROM rs_kasy_fiskalne WHERE firma_id='"+self.firma_id
        sql+="' AND oddzial_id='"+self.oddzial_id+"' AND kasa_id='"+Kasa+"';"
        stat,JestKasa,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat=='OK' and not JestKasa:
            stat="KASY BR"
            dane.append(stat)
            
        if stat=='OK':
            if JestKasa[0][1]=='':
                Kontrahent='NULL'
            else:
                Kontrahent="'"+JestKasa[0][1]+"'"
                
        if stat=="OK":         
            Dzis=rsglobal.PodajDzis()
            sql="SELECT max(numer) FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"
            sql+=self.oddzial_id+"' AND kasa_id='"+Kasa+"' AND data='"+Dzis+"';"
            stat,nrmin,dump,dump = self.PolSQL.Execute(sql,3)
            if len(nrmin)==0:
                Nr=1
            else:
                Nr=nrmin[0][0]+1
            sql="SELECT wersja_sprzedaz FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"';"
            stat,wersprz,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat<>'OK':
                stat = 'WER CEN SQL'
            if len(wersprz) == 1:
                if str(wersprz[0][0]).strip() not in ('None',None,''):
                    WersjaS = "'"+str(wersprz[0][0])+"'"
                    sql="SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod = "+WersjaS+";"
                    stat,DTest,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat=='OK':
                        if len(DTest)==0:
                            stat = 'WER CEN BR'
                    
                else:
                    WersjaS = 'NULL'
                    
        if stat=='OK':
            SQL="INSERT INTO rs_paragony_fiskalne ("
            SQL+=" firma_id,oddzial_id,data,numer,stan,do_zaplaty,kasa_id,wersja,kontrahent_id) "
            SQL+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Dzis+"','"+str(Nr)+"','W',0,"
            SQL+="'"+Kasa+"',"+WersjaS+","+Kontrahent+");"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat=='OK':
            wyn2.append([self.oddzial_id,Kasa,Dzis,Nr])
              

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY AUTOMATYCZNIE TWORZYC DOKUMENT (16) - jeli tak - zwraca klucz, jak nie to '' 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 16:
    Mag=''
    NrMag=0
    dane=['',0]
    sql="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND handlowy"
    stat,DaneMag,dump,dump = self.PolSQL.Execute(sql,3)

    if stat=='OK':
        if len(DaneMag)==1:
            Mag=rsglobal.Dekoduj(DaneMag[0][0])
            #pobranie numeru dokumentu WZ
            sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Mag+"\\\',\\\'WZ\\\',\\\'"+Data+"\\\']','M');"
            stat,Test,dump,dump = self.PolSQL.Execute(sql,3)
            if stat=='OK':
                if Test[0][0]=='OK':
                    sql="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Mag+"\\\',\\\'WZ\\\',\\\'"+Data+"\\\']','M');"
                    stat,DNr,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if DNr[0][0] in (None,'None',''):
                            stat='Bdy w pobieraniu numeru dokumentu'
                        else:
                            NrMag=DNr[0][0]
                else:
                    stat=Test[0][0]
    
    if stat=='OK':
        dane=[Mag,NrMag]

    
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6) 
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6 :
    if not (((self.oddzial_id,'025014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR DEL'
    
    if stat=='OK':
        sql ="SELECT stan FROM rs_paragony_fiskalne"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        sql+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"

        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Paragon fiskalny zablokowany przez innego operatora. Operacja usunicia niemoliwa.'
        elif len(stan)==0:
            stat='US BR'
        elif stan[0][0]=='W':
            DEL ="DELETE FROM rs_paragony_fiskalne"
            DEL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            DEL+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            stat,dump,dump,dump = self.PolSQL.Execute(DEL,1)
        else:
            stat='ZAM US'


#-------------------------------------------------------------------------------        
#--- POBRANIE DANYCH DO ZAMKNIECIA (10)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 10:
    if not (((self.oddzial_id,'025016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='Brak uprawnie do zamykania paragonw'        
    
    if stat=='OK':
        sql ="SELECT stan FROM rs_paragony_fiskalne"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        sql+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"  #AB 2023-08-17

        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(stan)==0:
                stat='Brak podanego paragonu fiskalnego'
        else:
            stat = "Paragon jest aktualnie edytowany przez innego operatora"  #AB 2023-08-17
    
    if stat=='OK':
        if stan[0][0]<>'W':
            stat='Paragon fiskalny jest w stanie innym ni W i nie mona go zamkn'

    if stat=='OK':
        sql="SELECT NOW()::DATE='"+Data+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia daty paragonu: '+stat
            dane.append(stat)
        elif not d[0][0]:
            stat = 'Data paragonu niezgodna z dat biec. Zamknicie niemoliwe.'
            dane.append(stat)
    
    if stat=='OK':        
        SQL="SELECT a.nazwa,pfp.cena_brutto1,pfp.ilosc1,kfv.kod,pfp.wartosc_brutto,"   # 0-4
        SQL+=" pfp.rabat,pfp.cena_przed_rabatem1,pfp.stawka_vat,pfp.wartosc_brutto_przed_rabatem,"   # 5-8
        SQL+=" TRIM(COALESCE(pf.nip,''))"   # 9
        SQL+=" FROM rs_paragony_fiskalne_pozycje pfp"
        SQL+=" INNER JOIN rs_paragony_fiskalne pf USING (firma_id,oddzial_id,data,numer) "
        SQL+=" LEFT OUTER JOIN rs_kasy_fiskalne_vat kfv ON (kfv.firma_id=pfp.firma_id AND kfv.oddzial_id=pfp.oddzial_id AND kfv.kasa_id=pf.kasa_id AND kfv.stawka_vat=pfp.stawka_vat) "
        SQL+=" INNER JOIN rs_artykuly a ON (a.firma_id=pfp.firma_id AND a.artykul_id=pfp.artykul_id) "
        SQL+=" WHERE pfp.firma_id='"+self.firma_id+"' AND pfp.oddzial_id='"+Oddzial+"'"
        SQL+=" AND pfp.kasa_id='"+Kasa+"' AND pfp.data='"+Data+"' AND pfp.numer="+str(Numer)+";"

        stat,dane,wyn1,dump = self.PolSQL.Execute(SQL ,3)
        if len(dane)==0:
            stat='Brak pozycji na paragonie'
        if stat=='OK':
            for poz in dane:
                if poz[4] == 0:
                    stat='Warto brutto na jednej z pozycji rwna 0. Nie mona zamkn paragonu'
                    break
                elif poz[3] == 'None':
                    stat="Brak kodu stawki VAT '"+rsglobal.Dekoduj(poz[7])+"' dla drukarki fiskalnej."
                    break
    bledy = []  #AB 26.04.22r
    if stat=='OK':
        Stawki = []
        for i in xrange(len(dane)):
            Stawka = rsglobal.Dekoduj(dane[i][7])
            if not Stawka in Stawki:
                Stawki.append(Stawka)

        #czy liczba sprawdzanych stawek rowna liczbie stawek spelniajacych warunek
        #zgodnosci z terminem ich obowiazywania
        sql ="SELECT COUNT(*)="+str(len(Stawki))+" FROM rs_stawki_vat_okresy"
        sql+=" WHERE stawka_vat IN "+str(Stawki).replace('[','(').replace(']',')')
        sql+=" AND '"+Data+"'>=od_dnia"
        sql+=" AND CASE WHEN do_dnia IS NULL"
        sql+=" THEN TRUE ELSE '"+Data+"'<=do_dnia END;"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia stawek VAT z terminami ich obowizywania: '+stat
            bledy.append(stat)  #AB 26.04.22r
        elif not d[0][0]:
            stat = 'W pozycjach paragonu wystpuj stawki VAT poza terminem ich obowizywania.'
            bledy.append(stat)  #AB 26.04.22r

    #WS 2022-04-12
    if stat=='OK':
        okres_dla_daty = None
        kasa_bank_id = None
        stat, d_okres = fs_okresy_pom.PodajOkresDlaDaty(self, Data)
        if stat == 'OK':
            okres_dla_daty = d_okres
            stat, d_kasabank = fs_raporty_wyciagi_pom.PodajDomyslnaKase(self, okres_dla_daty, Oddzial)
            if stat == 'OK':
                kasa_bank_id = d_kasabank['kasa_bank_id']

        if stat == 'OK':
            SEL = """SELECT sposob_zaplaty FROM rs_paragony_fiskalne_platnosci plat
                     WHERE sposob_zaplaty NOT IN (SELECT sposob_zaplaty FROM rs_kasy_banki_sposoby_zaplaty WHERE (firma_id, okres_id, kasa_bank_id)=(plat.firma_id,'{okres_dla_daty}','{kasa_bank_id}'))
                           AND kwota != 0 AND (firma_id, oddzial_id, kasa_id, data, numer)=('{self.firma_id}','{Oddzial}','{Kasa}','{Data}',{Numer});""".format(**locals())
            stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
            if stat != 'OK':
                stat = 'Bd sprawdzenia danych patnoci paragonu: '+stat
                bledy.append(stat)  #AB 26.04.22r
            elif len(d) > 0:
                for wiersz in d:
                    stat = "Podano niezerow kwot dla sposobu zapaty '"+wiersz[0].strip()+"' nieistniejcego wrd sposobw zapaty zdefiniowanych dla kasy/banku"
                    bledy.append(stat)  #AB 26.04.22r

    if stat=='OK':
        sql ="SELECT typ_kasy_id, zaokrag_piatki, zaokrag_sumy"
        sql+=" FROM rs_kasy_fiskalne WHERE kasa_id='" + Kasa + "';"

        stat, d, dump, dump = self.PolSQL.Execute(sql,2)
        if stat != 'OK':
            stat = 'BL SQL TYP DR'
            bledy.append(stat)  #AB 26.04.22r
        elif d:
            wyn2.extend(d[0])
        else:
            stat="KASY BR"
            bledy.append(stat)  #AB 26.04.22r

    #WS 2022-04-12
    if stat=='OK':
        if len(bledy) > 0:  #AB 26.04.22r
            stat = bledy[0]
            dane = bledy

#-------------------------------------------------------------------------------
#--- ZAMKNIECIE (11,31 - zamknicie z POSa)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (11,31):
    if not (((self.oddzial_id,'025016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='Brak uprawnie do zamykania paragonw'
        
    if stat=='OK':
        sql ="SELECT stan FROM rs_paragony_fiskalne"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        sql+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql+=" FOR UPDATE NOWAIT;"

        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(stan)==0:
                stat='Brak paragonu do zamknicia'
        else:
            stat = 'Paragon jest edytowany przez kogo innego. Zamknicie niemoliwe.'

    if stat=='OK':    
        if stan[0][0]<>'W':
            stat='Paragon nie jest w stanie W. Zamknicie niemoliwe'
            
    if stat=='OK':
        SQLZam=''   
        #------------------------------------------
        #-- TWORZENIE  WYCIGU BANKOWEGO
        #------------------------------------------
        #AB 14.12.21r przejcie na uycie pom'w
        #sprawdzenie okresu paragonu
        Okres=''
        KasaBank=''
        # KontoKB=''
        KwotaPar='0'
        NrWyc='1'
        NrPozWyc='1'
        Saldo='0'
        TworzycWyc=True
        # PodajOkresDlaDaty

        # SQL = "SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='" + self.firma_id + "' "
        # SQL += " AND data_od<='" + Data + "' AND data_do >='" + Data + "'"
        # stat, DaneOkr, dump, dump = self.PolSQL.Execute(SQL, 3)
        #
        # if stat == 'OK':
        #     if len(DaneOkr) == 1:
        #         Okres = rsglobal.Dekoduj(DaneOkr[0][0])

        # PodajOkresDlaDaty

        # stat, Okres = fs_okresy_pom.PodajOkresDlaDaty(self, Data)

        # PodajSymbolKasy

        # if stat=='OK' and Okres != '':
        #     #--- jeli jest tylko 1 kasa_bank to tworzy wycig bankowy
        #     SQL="SELECT kasa_bank_id,konto FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'"
        #     stat,DaneKB,dump,dump = self.PolSQL.Execute(SQL,3)
        #
        #     if stat=='OK':
        #         if len(DaneKB)==1:
        #             KasaBank=rsglobal.Dekoduj(DaneKB[0][0])
        #             KontoKB=rsglobal.Dekoduj(DaneKB[0][1])

        # PodajSymbolKasy

        # if stat == 'OK' and Okres != '':
        #     stat, dane_kasy = fs_raporty_wyciagi_pom.PodajDomyslnaKase(self, Okres)
        #     if stat == 'OK':
        #         if dane_kasy is None:
        #             KasaBank = ''
        #         else:
        #             KasaBank = dane_kasy['kasa_bank_id']

        # PodajUtworzRaportKasowy

        # if stat=='OK' and KasaBank != '':
        #     #--- mamy okres, i kas i moemy tworzy wycig.
        #     #--- najpierw sprawdzamy czy nie istnieje ju otwarty wycig.
        #     #--- Jeli tak - pobieramy klucz - jeli nie - wstawiamy nowy dokument
        #     SQL="SELECT stan,numer FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' "
        #     SQL+="AND okres_id='"+Okres+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' "
        #     SQL+="ORDER BY numer DESC LIMIT 1"
        #
        #     stat,DaneWyc,dump,dump = self.PolSQL.Execute(SQL,3)
        #
        #     if stat=='OK':
        #         if len(DaneWyc)==1:
        #             #jest wycig - sprawdzamy stan
        #             if DaneWyc[0][0]=='W':
        #                 NrWyc=str(DaneWyc[0][1])
        #                 TworzycWyc=False
        #             else:
        #                 from funkcje import fs_raporty_wyciagi_pom
        #                 stat,NrWyc=fs_raporty_wyciagi_pom.PodajNumerRaportu(self,KasaBank,Data)
        #                 NrWyc=str(NrWyc)
        #                 if NrWyc =='0':
        #                     stat='Uwaga! Przyznano 0 jako nowy numer raportu/wycigu dla kasy '+KasaBank
        #                     stat+="\nSprawd czy w kasie jest wisany sposb numeracji raportw"
        #
        # #MK 2021-02-01 - poczatek
        # if stat=='OK' and KasaBank != '' and TworzycWyc:
        #     SQLSaldo="SELECT saldo_konc FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' "
        #     SQLSaldo+="AND okres_id='"+Okres+"' AND kasa_bank_id='"+KasaBank+"' AND (data<'"+Data+"' OR (data='"+Data+"' AND numer<"+NrWyc+")) ORDER BY data desc, numer desc LIMIT 1;"
        #
        #     stat,DaneSaldo,dump,dump = self.PolSQL.Execute(SQLSaldo, 3)
        #
        #     if stat=='OK':
        #         if len(DaneSaldo)==1:
        #             Saldo=str(DaneSaldo[0][0])
        # #MK 2021-02-01 - koniec
        #
        # if stat=='OK' and KasaBank <>'':
        #     if TworzycWyc:
        #         #tworzenie nagwka wycigu bankowego
        #         SQLZam="INSERT INTO rs_raporty_wyciagi (firma_id,okres_id,kasa_bank_id,data,numer,stan, saldo_pocz, saldo_konc) "  #MK 2021-02-01
        #         SQLZam+="VALUES ('"+self.firma_id+"','"+Okres+"','"+KasaBank+"','"+Data+"',"+NrWyc+",'W',"+Saldo+","+Saldo+");"  #MK 2021-02-01
        #     else:
        #         #pobranie numeru pozycji ktra bdzie dodawano do istniejcego wycigu
        #         SQL="SELECT max(nr_poz) FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' "
        #         SQL+="AND okres_id='"+Okres+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' "
        #         SQL+=" AND numer="+str(NrWyc)
        #         stat,DaneWBP,dump,dump = self.PolSQL.Execute(SQL,3)
        #         if stat=='OK':
        #             if len(DaneWBP)>0:
        #                 if DaneWBP[0][0] not in [0,None]:
        #                     NrPozWyc=str(DaneWBP[0][0]+1)

        # PodajUtworzRaportKasowy

        # if stat == 'OK' and KasaBank != '':
        #     stat, NrWyc, NrPozWyc = fs_raporty_wyciagi_pom.PodajUtworzRaportKasowy(self, Okres, KasaBank, Data)
        #
        # #Tworzenie pozycji
        # if stat=='OK' and KasaBank <>'':
        #     #pobranie kwoty
        #     SQL="SELECT do_zaplaty FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        #     SQL+="AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)
        #     stat,DanePar,dump,dump = self.PolSQL.Execute(SQL,3)
        #     if stat=='OK':
        #         if len(DanePar)>0:
        #             KwotaPar=str(DanePar[0][0])
        #
        # if stat=='OK' and KwotaPar != '0':
        #     KontoKasy=''
        #     #pobranie konta z kasy fiskalnej
        #     SQL="SELECT konto FROM rs_kasy_fiskalne WHERE firma_id='"+self.firma_id+"'"
        #     SQL+=" AND oddzial_id='"+Oddzial+"' AND kasa_id='"+Kasa+"';"
        #     stat,DaneKasy,dump,dump = self.PolSQL.Execute(SQL,3)
        #     if stat=='OK':
        #         if len(DaneKasy)>0:
        #             KontoKasy=rsglobal.Dekoduj(DaneKasy[0][0])
        #
        #
        #     if stat=='OK':
        #         #dodanie pozycji wycigu
        #         Tresc='Paragon '+Oddzial+'/'+Kasa+'/'+Data+'/'+str(Numer)
        #         SQLZam+="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz,"
        #         SQLZam+="stan_poz,typ,konto,kwota,tresc) VALUES"
        #         SQLZam+=" ('"+self.firma_id+"','"+Okres+"','"+KasaBank+"','"+Data+"',"+NrWyc+","+NrPozWyc+",0,"
        #         SQLZam+="'W','P','"+KontoKasy+"',"+KwotaPar+",'"+Tresc+"');"

        stat = fs_raporty_wyciagi_pom.ZapiszDoRaportu(self, Data, 'PA', {'oddzial_id': Oddzial, 'numer': Numer,
                                                                         'kasa_id': Kasa})

        if stat=='OK':
            #--- Update na stan paragonu
            SQLZam+="UPDATE rs_paragony_fiskalne SET stan='Z' WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            stat,dump,dump,dump = self.PolSQL.Execute(SQLZam,1)


#-------------------------------------------------------------------------------
#--- UTWORZENIE FAKTURY Z PARAGONU (12)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 12:
    if not (((self.oddzial_id,'022013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR DOD FAKT'
    NabywcaNIP = 'abcy'
    DataFakt = rsglobal.Dekoduj(KlFakt[1])
    for w in ListaParagonow:
        if stat=='OK':
            #sql = "SELECT stan,TRIM(COALESCE(wyznacznik_id,'')),wersja FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
            #sql+= " AND oddzial_id='"+str(w[0])+"' AND kasa_id='"+str(w[1])+"' AND data='"+str(w[2])+"' AND numer="+str(w[3])+";"
            SQL = "SELECT stan, TRIM(COALESCE(wyznacznik_id,'')), wersja, REPLACE(TRIM(COALESCE(nip,'')),'-','') FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id
            SQL += "' AND oddzial_id='"+str(w[0])+"' AND kasa_id='"+str(w[1])+"' AND data='"+str(w[2])+"' AND numer="+str(w[3])+";"
            stat,stan,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat == 'OK':
                if len(stan)==0:
                    stat = 'PARF BR'
                elif stan[0][1] != '':
                    stat = 'IS FAK'
                elif NabywcaNIP != stan[0][3]:
                    if NabywcaNIP == 'abcy':
                        NabywcaNIP = stan[0][3]
                    else:
                        stat = 'Prba utworzenia faktury dla paragonw z rnym NIP-em'
            else:
                stat='Bdy tworzenia faktury z paragonu '+stat
    if stat == 'OK':
        if DataFakt >= '2020-01-01':
            if NabywcaNIP == '':
                stat = 'Brak NIP na paragonie'

    #prba utworzenia faktury
    if stat=='OK':
        Wersja='NULL'            
        WyznFakt=rsglobal.Dekoduj(KlFakt[0])
        DataFakt=rsglobal.Dekoduj(KlFakt[1])
        NumerFakt=KlFakt[2]

        KontrFakt=rsglobal.Dekoduj(KlFakt[4]).strip()
        CzySklejac = rsglobal.Dekoduj(KlFakt[5])
        Waluta='PLN'
        Kurs=1
        
        #Sprawdzenie kontrahenta
        sql = "SELECT kontrahent_id,zamawiajacy_id,platnik_id,zablokowany,REPLACE(TRIM(COALESCE(nip,'')),'-','') FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrFakt+"' AND aktywny;"
        stat,danek,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='KONTR BL SQL'
        if len(danek)==0:
            stat = 'KONTR BL'
        elif danek[0][3]:
            stat = 'BL ZABLOKOWANY'
        elif NabywcaNIP != danek[0][4] and NabywcaNIP != '':
            stat = "NIP kontrahenta niezgodny z paragonem"
        else:
            Zamawiaj=rsglobal.Dekoduj(danek[0][1]).strip()
            if Zamawiaj in ('None',''):
                Zamawiaj = KontrFakt
            
            Platnik=rsglobal.Dekoduj(danek[0][2]).strip()
            if Platnik in ('None',''):
                Platnik = KontrFakt
    
    #kontrola Zamawiajacego i Platnika: przypadek w pewnym sensie niemozliwy, bo zamawiajacy i platnik
    #powinni by w bazie rs_kontrahenci -> obslugiwane ze wzgledu na ewent.problemy przy synchronizacji baz
    #mariusz rajfura  mantis:3474  2010/04/16
    
    if stat == 'OK' and KontrFakt != Zamawiaj:
        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Zamawiaj+"' AND aktywny;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych zamawiajcego: '+stat
        elif len(d) != 1:
            stat = 'Brak zamawiajcego '+Zamawiaj+' lub zamawiajcy jest nieaktywny'

    if stat == 'OK' and KontrFakt != Platnik:
        sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE"
        sql+=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych patnika: '+stat
        elif len(d) != 1:
            stat = 'Brak patnika '+Platnik+' lub patnik jest nieaktywny'

    #WS 2019-08-06
    if stat == 'OK':
        CzyMPP = False

        SEL = """SELECT BOOL_OR(czy_mpp) FROM rs_kontrahenci WHERE firma_id = '{}' AND kontrahent_id in ('{}','{}');"""
        SEL = SEL.format(self.firma_id, Platnik or 'NULL', KontrFakt or 'NULL')
        stat,DMPP,dump,dump = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd przy pobieraniu danych patnika/kontrahenta: '+stat
        elif DMPP[0][0]:
            CzyMPP = True

    #Sprawdzenie wyznacznika
    if stat=='OK':
        sql = "SELECT wyznacznik_id,czy_korekta,typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+WyznFakt+"';"
        stat,danew,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='WYZN BL SQL'
        if len(danew)==0:
            stat = 'WYZN BL'
        if stat=='OK':
            if danew[0][1]:
                stat = "WYZN KOR"
        if stat=='OK':        
            if not danew[0][2] in ('BP','DU','EK','KR','WW','ZA','ZU','RR','ZL','FZ'):
                stat = "TYP FAKT BL"
   
    if stat=='OK':        
        ListaPar='(' 
        for w in ListaParagonow:
            ListaPar=ListaPar+"'"+str(w[0]).strip()+"'"+'||'+"'"+str(w[1]).strip()+"'"+'||'+"'"+str(w[2])+"'"+'||'+"'"+str(w[3])[:-2]+"'"+','
            
        ListaPar=ListaPar[:-1]+')'
        FiltrPar="firma_id='"+self.firma_id+"' AND oddzial_id||kasa_id||data||numer in"+ListaPar
       #RW dodanie dodatkowej dane do poprania
    if stat=='OK':
        sql="SELECT spos_zaplaty,handlowiec,sposob_odbioru_faktury,spos_dostawy,dni,projekt_id, osobny_rachunek_vat"
        sql+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+KontrFakt+"' AND data_od <= '"+DataFakt+"'ORDER BY data_od DESC LIMIT 1;"
        stat,DaneKF,wyn1,dump=self.PolSQL.Execute(sql,3)
        if len(DaneKF)==0:
            SpZap='NULL'
            Hand='NULL'
            SpOF='NULL'
            SpD='NULL'
            Dni='0'
            Proj='NULL'
            OddzielnyVAT="False"
        else:
            SpZap=rsglobal.Dekoduj(DaneKF[0][0])
    
            if SpZap=='None':
                SpZap='NULL'
            else:
                SpZap="'"+SpZap+"'"
    
            Hand=rsglobal.Dekoduj(DaneKF[0][1])
            if Hand=='None':
                Hand='NULL'
            else:
                Hand="'"+Hand+"'"

            SpOF=rsglobal.Dekoduj(DaneKF[0][2])
            if SpOF=='None':
                SpOF='NULL'
            else:
                SpOF="'"+SpOF+"'"

            SpD=rsglobal.Dekoduj(DaneKF[0][3])
            if SpD=='None':
                SpD='NULL'
            else:
                SpD="'"+SpD+"'"
            
            Proj=rsglobal.Dekoduj(DaneKF[0][5])
            if Proj=='None':
                Proj='NULL'
            else:
                Proj="'"+Proj+"'"
            if DaneKF[0][6] in [True,False]:
                OddzielnyVAT = DaneKF[0][6]
            else:
                OddzielnyVAT = False

            Dni=str(DaneKF[0][4])
            Dni=rsglobal.Dekoduj(Dni[0:Dni.find('.')])
        Stan = ListaParagonow[0][4]

    #MK 2020-04-22
    if stat == 'OK':
        sqlw = "SELECT ozn_trans,ozn_sprzedaz"
        sqlw += " FROM rs_wyznaczniki"
        sqlw += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id = '" + WyznFakt + "';"
        stat, dww, dump, dump = self.PolSQL.Execute(sqlw, 3)
        if stat != 'OK':
            stat = 'Bdy przy sprawdzaniu danych wyznacznika :' + stat
            dane.append(stat)
        if dww != []:
            OznTrans = dww[0][0]
            OznSprz = dww[0][1]
        #RW sprawdzanie check boxa z informacj czy oddzielne konto vat
        if Stan<>'W':  
            SQL='INSERT INTO rs_faktury '
            SQL=SQL+'(firma_id,wyznacznik_id,data,numer,oddzial_id,stan,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,'
            SQL=SQL+'dostawy_od_dnia,dostawy_do_dnia,kierowca,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,'
            SQL=SQL+'termin_zaplaty,handlowiec,sposob_odbioru_faktury,sposob_dostawy,upust,upust_wartosc,upust_wartosc_wal,'
            SQL=SQL+'rabat,rabat_wartosc,rabat_wartosc_wal,kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,'
            SQL=SQL+'kwota_netto_wal,kwota_vat_wal,wartosc_opakowan_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,numer_z_rs, z_paragonow, projekt_id, osobny_rachunek_vat,czy_mpp,ozn_trans,ozn_sprzedaz)' #WS 2019-08-06 - dodane czy_mpp #MK 2020-04-22
            SQL=SQL+' VALUES '
            SQL=SQL+"('"+self.firma_id+"','"+WyznFakt+"','"+DataFakt+"',"+str(NumerFakt)+",'"+self.oddzial_id+"','W','"+KontrFakt+"','"+Zamawiaj+"','"+Platnik+"','"+KontrFakt+"',"
            SQL=SQL+"NULL,NULL,NULL,'"+Waluta+"',"+str(Kurs)+",NULL,NULL,"+Wersja+","+SpZap+","+Dni+",NULL,"
            SQL=SQL+"date '"+DataFakt+"' + integer '"+Dni+"',"+Hand+","+SpOF+","+SpD+",0,0,0,"
            SQL=SQL+"0,0,0,0,0,0,0,"
            SQL=SQL+"0,0,0,0,'','','',TRUE,"+Proj+","+str(OddzielnyVAT)+","+str(CzyMPP) #WS 2019-08-06 - dodane CzyMPP
            if OznTrans not in ('None', ''):
                SQL=SQL+ ",'" + str(OznTrans) + "'"  # MK 2020-04-21
            else:
                SQL=SQL+ ",NULL"
            if OznSprz not in ('None', ''):
                SQL=SQL+ ",'" + str(OznSprz) + "'"  # MK 2020-04-21
            else:
                SQL=SQL+ ",NULL"
            SQL = SQL + ");"
            stat,daneP,wyn1,dump=self.PolSQL.Execute(SQL,1)
            if stat =='OK':
                if CzySklejac:
                    SQLPP="SELECT firma_id,"               
                    SQLPP+="artykul_id,SUM(ilosc1),SUM(ilosc2),cena_przed_rabatem1,cena_przed_rabatem2,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2,"                                                         
                    SQLPP+="rabat,ROUND((cena_przed_rabatem1 - cena_netto1)*SUM(ilosc1),2),stawka_vat,SUM(wartosc_netto),SUM(wartosc_vat),SUM(wartosc_brutto),"                
                    SQLPP+="cena_netto1,cena_netto2,cena_netto1,cena_netto2,SUM(wartosc_netto),SUM(wartosc_vat),SUM(wartosc_brutto),cecha1_opis,cecha1_wartosc" 
                    SQLPP+=" FROM rs_paragony_fiskalne_pozycje WHERE "+FiltrPar+" GROUP BY firma_id,nr_poz,artykul_id,stawka_vat,rabat,cena_przed_rabatem1,cena_przed_rabatem2,cena_netto1,"
                    SQLPP+="cena_netto2,cena_brutto1,cena_brutto2,cecha1_opis,cecha1_wartosc ;"
                else:
                    SQLPP="SELECT firma_id,"               
                    SQLPP+="artykul_id,ilosc1,ilosc2,cena_przed_rabatem1,cena_przed_rabatem2,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2,"                                                         
                    SQLPP+="rabat,round((cena_przed_rabatem1 - cena_netto1)*ilosc1,2),stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,"                
                    SQLPP+="cena_netto1,cena_netto2,cena_netto1,cena_netto2,wartosc_netto,wartosc_vat,wartosc_brutto,cecha1_opis,cecha1_wartosc" 
                    SQLPP+=" FROM rs_paragony_fiskalne_pozycje WHERE "+FiltrPar+"; "
                
                stat,danePP,wyn1,dump=self.PolSQL.Execute(SQLPP,3)
            if stat =='OK':
                NrPoz=1
                for w in danePP:
                    if stat =='OK':
                        #pozycje
                        KodGtu = "(SELECT kod_gtu FROM rs_artykuly WHERE firma_id='" + self.firma_id + "' AND artykul_id='" +w[1]+ "')"  #MK 2020-03-24
                        SQLP="INSERT INTO rs_faktury_pozycje "
                        SQLP+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"                                                        
                        SQLP+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"       
                        SQLP+="upust,upust_wartosc,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,"            
                        SQLP+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto," 
                        SQLP+="cecha1_opis,cecha1_wartosc,kod_gtu) "
                        SQLP+="VALUES ('"+str(w[0])+"','"+WyznFakt+"','"+DataFakt+"',"+str(NumerFakt)+","+str(NrPoz)+",0,"  
                        SQLP+=" '"+str(w[1])+"',"+str(w[2])+","+str(w[3])+","+str(w[4])+","+str(w[5])+","+str(w[6])+","+str(w[7])+","+str(w[8])+","+str(w[9])+"," 
                        SQLP+=" "+str(w[10])+","+str(w[11])+",'"+str(w[12])+"',"+str(w[13])+","+str(w[14])+","+str(w[15])+",'',NULL,"  
                        SQLP+=" "+str(w[16])+","+str(w[17])+","+str(w[18])+","+str(w[19])+","+str(w[20])+","+str(w[21])+","+str(w[22])+","
                        SQLP+="'"+str(w[23])+"','"+str(w[24])+"',"+KodGtu+")"   #MK 2020-03-24
                        stat,daneP,wyn1,dump=self.PolSQL.Execute(SQLP,1)
                        NrPoz=NrPoz+1

                #WS 2021-11-02
                if stat == 'OK':
                    DELSV = "DELETE FROM rs_faktury_vat WHERE firma_id='"+self.firma_id+"'"
                    DELSV += " AND wyznacznik_id='"+str(WyznFakt)+"' AND data='"+str(DataFakt)+"' "
                    DELSV += " AND numer='"+str(NumerFakt)+"';"
                    stat, dump, dump, dump = self.PolSQL.Execute(DELSV, 1)
                    if stat != 'OK':
                        stat = 'Bdy usuwania danych stawek VAT faktury '+stat

                if stat == 'OK':
                    INSSV = "INSERT INTO rs_faktury_vat (firma_id, wyznacznik_id, data, numer, stawka_vat,"
                    INSSV += " wartosc_netto, wartosc_vat, wartosc_brutto,"
                    INSSV += " wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto)"
                    INSSV += " SELECT firma_id, wyznacznik_id, data, numer, stawka_vat,"
                    INSSV += " SUM(wartosc_netto), SUM(wartosc_vat), SUM(wartosc_brutto),"
                    INSSV += " SUM(wartosc_wal_netto), SUM(wartosc_wal_vat), SUM(wartosc_wal_brutto)"
                    INSSV += " FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"'"
                    INSSV += " AND wyznacznik_id='"+str(WyznFakt)+"' AND data='"+str(DataFakt)+"'"
                    INSSV += " AND numer='"+str(NumerFakt)+"'"
                    INSSV += " GROUP BY firma_id, wyznacznik_id, data, numer, stawka_vat;"
                    stat, dump, dump, dump = self.PolSQL.Execute(INSSV, 1)
                    if stat != 'OK':
                        stat = 'Bdy dodawania danych stawek VAT faktury '+stat

                if stat == 'OK':
                    INSN = "UPDATE rs_faktury f"
                    INSN += " SET kwota_netto=fp.suma_wartosc_netto,"
                    INSN += " kwota_vat=fp.suma_wartosc_vat,"
                    INSN += " do_zaplaty=fp.suma_wartosc_brutto,"
                    INSN += " kwota_netto_wal=fp.suma_wartosc_wal_netto,"
                    INSN += " kwota_vat_wal=fp.suma_wartosc_wal_vat,"
                    INSN += " do_zaplaty_wal=fp.suma_wartosc_wal_brutto"
                    INSN += " FROM ("
                    INSN += " SELECT firma_id, wyznacznik_id, data, numer,"
                    INSN += " SUM(wartosc_netto) AS suma_wartosc_netto, SUM(wartosc_vat) AS suma_wartosc_vat, SUM(wartosc_brutto) AS suma_wartosc_brutto,"
                    INSN += " SUM(wartosc_wal_netto) AS suma_wartosc_wal_netto, SUM(wartosc_wal_vat) AS suma_wartosc_wal_vat, SUM(wartosc_wal_brutto) AS suma_wartosc_wal_brutto"
                    INSN += " FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"'"
                    INSN += " AND wyznacznik_id='"+str(WyznFakt)+"' AND data='"+str(DataFakt)+"'"
                    INSN += " AND numer='"+str(NumerFakt)+"' GROUP BY firma_id, wyznacznik_id, data, numer"
                    INSN += " ) AS fp WHERE (f.firma_id, f.wyznacznik_id, f.data, f.numer)="
                    INSN += " (fp.firma_id, fp.wyznacznik_id, fp.data, fp.numer);"
                    stat, dump, dump, dump = self.PolSQL.Execute(INSN, 1)
                    if stat != 'OK':
                        stat = 'Bdy aktualizacji kwot nagwka faktury '+stat

        else: 
            for w in ListaParagonow:
                Wyznacznik = KlFakt[0]
                DataFak = KlFakt[1]
                Numer = KlFakt[2]
                
                Kasa = w[1]
                Nr = w[3]
                DataPar = w[2] 
                
                Insert = "INSERT INTO rs_paragony_fiskalne_pozycje ("
                Insert+="firma_id,oddzial_id,kasa_id,data,numer,nr_poz,artykul_id,ilosc1,"
                Insert+="ilosc2,cena_przed_rabatem1,cena_przed_rabatem2,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2,"
                Insert+="rabat,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto"
                Insert+=") SELECT "
                Insert+="'"+self.firma_id+"','"+self.oddzial_id+"','"+str(Kasa)+"','"+str(DataPar)+"','"+str(Nr)+"',nr_poz,artykul_id,ilosc1,"
                Insert+="ilosc2,cena_upust1,cena_upust2,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2,upust,"
                Insert+="stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto"
                Insert+=" FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND "
                Insert+="wyznacznik_id='"+str(Wyznacznik)+"' AND data='"+str(DataFak)+"' "
                Insert+="AND numer='"+str(Numer)+"';"
                Insert+=" UPDATE rs_paragony_fiskalne SET czy_przedplata=TRUE "
                Insert+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+str(w[0])+"' AND "
                Insert+=" kasa_id='"+str(w[1])+"' AND data='"+str(w[2])+"' AND numer="+str(w[3])
                stat,dane,dump,dump = self.PolSQL.Execute(Insert,1)
                if stat<>'OK':
                    stat='Bdy sprawdzania danych paragonu '+stat

        #zapisanie klucza faktury w paragonie
        if stat=='OK':
            for w in ListaParagonow:
                SQLK="UPDATE rs_paragony_fiskalne SET wyznacznik_id='"+WyznFakt+"',f_data='"+DataFakt+"',f_numer="+str(NumerFakt)
                SQLK+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+str(w[0])+"' AND kasa_id='"+str(w[1])+"' AND data='"+str(w[2])+"' AND numer="+str(w[3])
                stat,dump,dump,dump=self.PolSQL.Execute(SQLK,1)

            
#-------------------------------------------------------------------------------
#--- UTWORZENIE DOKUMENTU MAGAZYNOWEGO Z PARAGONU (13,14)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [13,14]:
    Dok=KlFakt

    Mag=rsglobal.Dekoduj(Dok[0])
    Dokum=rsglobal.Dekoduj(Dok[1])
    DataDM=rsglobal.Dekoduj(Dok[2])
    NrDM=str(Dok[3])
    CzyZamykac=Dok[4]
    CzyUsuwacPozDok=False
    #sprawdzanie czy mozna utworzyc dokument magazynowy z paragonu (czy przedplata)
    Select = "SELECT czy_przedplata,stan,COALESCE(kontrahent_id,'') FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id
    Select +="' AND oddzial_id='"+Oddzial+"' AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,przed,dump,dump = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat='CZYPRZED BL'
    if stat=='OK':        
        if len(przed)==0:
            stat='PAR BR'
    if stat=='OK':        
        if przed[0][0]:
            stat='CZYPRZED'
    if stat== 'OK':
        if przed[0][1]=='W' and Funkcja==13:
            stat='ZAM NIE PAR'
    #--- sprawdzenie czy data jest poprawna
    if stat=='OK':
        stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date(\'"+str(DataDM)+"\');",3)  
    if stat=='OK':
        Dane = d[0][0]
        if Dane != 2:
            stat = "DATA BL"

    # pobranie potencjalnego kontrahenta na WZ
    if stat=='OK':
        Kontrahent=rsglobal.Dekoduj(przed[0][2])
    #--- sprawdzenie istnienia dokumentu magazynowego
    if stat=='OK':
        sql="SELECT stan FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id
        sql+="' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dokum+"' AND data='"+DataDM+"' AND numer="+NrDM+";"
        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(stan)>0:
            if stan[0][0]=='W': 
                CzyUsuwacPozDok=True
            else:
                stat='DM IS'
    #--- sprawdzenie czy dokument jest na wydanie 
    if stat=='OK':
        sql="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dokum+"';"
        stat,stan,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':        
        if len(stan)==0:
            stat='TYP DOK BR'
        elif stan[0][0]<>'W':
            stat='TYP DOK BL'
    #--- sprawdzenie czy nie ma pniejszych dokumentw
    if stat=='OK':
        sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Mag+"\\\',\\\'"+Dokum+"\\\',\\\'"+DataDM+"\\\',\\\'\\\']','M');"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':        
        if dane[0][0]<>'OK':
            stat='DATA DOK'
    #--- sprawdzenie zakresu dat dokumentw magazynowych
    if stat=='OK':
        sql="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+Mag+"','"+DataDM+"',2);"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':        
        Dane = d[0][0]
        if Dane != 1:
            stat = "DATA ZK"


    #--------------------------------------
    #--- tworzenie dokumentu magazynowego
    #--------------------------------------
    if stat=='OK':
        KontrDok='NULL'
        Wersja='NULL'
        SQL="SELECT czy_kontrahent FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dokum+"';"
        stat,DaneDok,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DaneDok)==0:
                stat='Brak typu dokumentu '+Dokum
            else:
                if DaneDok[0][0]:
                    # jeli podany na paragonie to wstawiamy. 
                    if Kontrahent<>'':
                        KontrDok="'"+Kontrahent+"'"
                    else:    
                        #Alternatywnie:
                        #--- sprawdzenie, ile magazynow handlowych
                        #--- jesli tylko jeden handlowy, to wstawiamy kontrahenta
                        SQL ="SELECT magazyn_id FROM rs_magazyny"
                        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"' AND handlowy;"
                        stat,DaneMagH,dump,dump = self.PolSQL.Execute(SQL,3)
                        
                        if stat=='OK' and len(DaneMagH) == 1:
                            SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' ORDER BY kontrahent_id LIMIT 1;"
                            stat,DaneKontr,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneKontr) > 0:
                                    KontrDok="'"+rsglobal.Dekoduj(DaneKontr[0][0])+"'"

        #--- nagwek
        if stat == 'OK' and not CzyUsuwacPozDok:
            # jesli bedzie dodawany naglowek to ustawiamy i kontrolujemy
            # parametry dokumentu w magazynie
            SParam = {}
            SParam['wersja'] = Wersja
            SParam['kontrahent_id'] = KontrDok.replace("'","")
            
            stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Mag,Dokum,SParam)
            if stat == 'OK':
                stat = fs_magazyny_parametry_dokumentow_pom.SprawdzParametryDlaDokumentu(self,Mag,Dokum,SParam)
                if stat == 'OK':
                    # sprawdzone i uzupelnione parametry dla dokumentu
                    Wersja = SParam['wersja']        
                    KontrDok = SParam['kontrahent_id']
                    
                    if Wersja in ('','NULL'):
                        Wersja = 'NULL'
                    else:
                        Wersja = "'"+Wersja+"'"

                    if KontrDok in ('','NULL'):
                        KontrDok = 'NULL'
                    else:
                        KontrDok = "'"+KontrDok+"'"

        if stat == 'OK':
            if not CzyUsuwacPozDok:                        
                SQL ="INSERT INTO rs_dokumenty_magazynowe"
                SQL+=" (firma_id,magazyn_id,dokument_id,data,numer,"
                SQL+="  stan,magazyn_skad,kontrahent_id,wersja)"
                SQL+=" VALUES "
                SQL+=" ('"+self.firma_id+"','"+Mag+"','"+Dokum+"','"+DataDM+"',"+NrDM+","
                SQL+="  'W','"+Mag+"',"+KontrDok+","+Wersja+");"
            else:
                #usunicie pozycji - nagwek ju istnieje
                SQL="DELETE FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' " 
                SQL+=" AND magazyn_id='"+Mag+"' AND dokument_id='"+Dokum+"' AND data='"+DataDM+"' AND numer="+NrDM+";"
        
        #--- pozycje
        FiltrPar="pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id='"+Oddzial+"' AND pp.kasa_id='"+Kasa+"'"
        FiltrPar+=" AND pp.data='"+Data+"' AND pp.numer="+str(Numer)+" AND NOT a.typ_artykulu IN ('31','99')"
        
        SQLP="INSERT INTO rs_dokumenty_magazynowe_pozycje "
        SQLP+="(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,cecha1_opis,cecha1_wartosc,ilosc1,ilosc2,"
        SQLP+="cena1,cena2,cena_pierw1,cena_pierw2,nr_serii,cena_wal1,cena_wal2,cena_pierw_wal1,cena_pierw_wal2) "

        SQLP+="SELECT pp.firma_id,'"+Mag+"','"+Dokum+"','"+DataDM+"',"+NrDM+",pp.nr_poz,0,pp.artykul_id,pp.cecha1_opis,pp.cecha1_wartosc,pp.ilosc1,pp.ilosc2,"
        SQLP+="0,0,0,0,'',0,0,0,0 "
        SQLP+=" FROM rs_paragony_fiskalne_pozycje pp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE "+FiltrPar+";"

        if stat=='OK':
            stat,dane,wyn1,dump=self.PolSQL.Execute(SQL+SQLP,1)

        #pobranie pozycji z dodanego dokumentu magazynowego i w przypadku luk w numeracji
        #spowodowanej ominieciem pozycji uslug (31,99) przenumerowanie istniejacych pozycji
        #tzn. sprawdzenie po kolei, czy pozycje posiadaj kolejne numery poczawszy od 1
        if stat=='OK':
            sql = "SELECT nr_poz FROM rs_dokumenty_magazynowe_pozycje"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dokum+"'"
            sql+=" AND data='"+DataDM+"' AND numer="+NrDM+" ORDER BY nr_poz;"
            stat,dpoz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania pozycji z tworzonego dokumentu magazynowego: '+stat
            elif len(dpoz) > 0:
                UpdNum = ''
                for i in xrange(len(dpoz)):
                    if dpoz[i][0] != i+1:
                        UpdNum+="UPDATE rs_dokumenty_magazynowe_pozycje SET nr_poz="+str(i+1)
                        UpdNum+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dokum+"'"
                        UpdNum+="  AND data='"+DataDM+"' AND numer="+NrDM+" AND nr_poz="+str(dpoz[i][0])+";"
                 
                if len(UpdNum) > 0:
                    stat,d,dump,dump = self.PolSQL.Execute(UpdNum,1)
                    if stat != 'OK':
                        stat = 'Bd przenumerowania pozycji w tworzonym dokumencie magazynowym: '+stat
            
        # wstawienie iloci -1 w te pola ilo, gdzie artyku ma dynamiczny przelicznik i proporcjonaln ilo
        # nie jest to konieczne, ale dobrze wyglda
        if stat =='OK':
            stat = fs_dokumenty_magazynowe_pom.UstawIlosciProporcjonalneNaMinus1(self,Mag,Dokum,DataDM,NrDM)


#-------------------------------------------------------------------------------
#--- WSTAWIENIE DANYCH DOKUMENTU DO PARAGONU (17)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 17:
    Dok=KlFakt

    Mag=rsglobal.Dekoduj(Dok[0])
    Dokum=rsglobal.Dekoduj(Dok[1])
    DataDM=rsglobal.Dekoduj(Dok[2])
    NrDM=str(Dok[3])

    #zapisanie klucza dokumentu w paragonie        
    SQL="UPDATE rs_paragony_fiskalne SET magazyn_id='"+Mag+"',dokument_id='"+Dokum+"',data_dm='"+DataDM+"',"
    SQL+=" numer_dm="+NrDM+" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    SQL+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)

    stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,1)

           
#-------------------------------------------------------------------------------
#--- CZYSZCZENIE DANYCH PO NIEUDANYM TWORZENIU (21)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 21:
    Dok=KlFakt

    Mag=rsglobal.Dekoduj(Dok[0])
    Dokum=rsglobal.Dekoduj(Dok[1])
    DataDM=rsglobal.Dekoduj(Dok[2])
    NrDM=str(Dok[3])

    #sprawdzenie czy mona usun dokument
    SQL="SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\""+Mag+"\",\""+Dokum+"\""
    SQL+=" ,\""+DataDM+"\","+NrDM+"]','M');"
    stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,3)

    #jeli mona - usuwamy. Jeli nie - zostawiamy
    if len(dane)>0 and dane[0][0]=='OK':
        SQL="UPDATE rs_paragony_fiskalne SET magazyn_id=NULL,dokument_id=NULL,data_dm=NULL,"
        SQL+=" numer_dm=0 WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        SQL+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

        SQL+="DELETE FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        SQL+=" AND dokument_id = '"+Dokum+"' AND data = '"+DataDM+"' AND numer = "+NrDM+";"

        stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,1)

            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete, 1 - insert,2-update,11- koncowe zamkniecie paragonu,
#---   12 - faktura, 17 - dokument magazynowy, 21 - czyszczenie)
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [1,2,5,6,11,12,17,21]):
    #sprawdzenie czy nie ma otwartych paragonw z wczeniejszego dnia. Jeli s to usuwamy i informujemy operatora
    SQL="SELECT * FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND oddzial_id='"+self.oddzial_id+"' AND stan='W' AND data < current_date;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if wyn2:
        if len(wyn2)==0:
            wyn2=[None]
    else:
        wyn2=[None]
    wyn2.append(len(DTest)>0)
    if len(DTest)>0:
        SQL="DELETE FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND oddzial_id='"+self.oddzial_id+"' AND stan='W' AND data < current_date;"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

    #pobranie dozwolonych oddzialow
    if self.operator_id != STANDARD_OPERATOR_ID:
        LOddz=['ZASLEPKA']
        for upr in self.uprawnienia:
            if not upr[0] in LOddz:
                LOddz.append(rsglobal.Dekoduj(upr[0]))
    
    # pobranie danych o dokumentach
    Filtr = "p.firma_id='"+self.firma_id+"'"
    if OddzialF != '':
        Filtr+=" AND oddzial_id='"+OddzialF+"'"
    if KasaF != '':
        Filtr+=" AND kasa_id='"+KasaF+"'"
    if DataOdF not in ('','    -  -  '):
        Filtr+=" AND data >= '"+DataOdF+"'"        
    if DataDoF not in ('','    -  -  '):
        Filtr+=" AND data <= '"+DataDoF+"'"        
    if StanF != '':
        Filtr+=" AND stan ='"+StanF+"'"        
    if WersjaF != '':
        Filtr+=" AND wersja ='"+WersjaF+"'"        
    if WyznF != '':
        Filtr+=" AND wyznacznik_id ='"+WyznF+"'"        
    if self.operator_id != STANDARD_OPERATOR_ID:
        Filtr+=" AND oddzial_id in ("+str(LOddz)[1:-1]+")"

    #WS 2022-04-06 - pobranie 'aktywne_platnosci'
    SELECT ="SELECT stan,oddzial_id,kasa_id,data,numer,wersja,czy_przedplata,do_zaplaty,"
    SELECT+="CASE WHEN (wyznacznik_id IS NOT NULL AND f_data IS NOT NULL AND f_numer IS NOT NULL)"
    SELECT+=" THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||wyznacznik_id||'\",\"'||f_data||'\",\"'||f_numer||'\"]','F')"
    SELECT+=" ELSE '' END ,"
    SELECT+="CASE WHEN (magazyn_id IS NOT NULL AND dokument_id IS NOT NULL AND data_dm IS NOT NULL AND numer_dm IS NOT NULL)"
    SELECT+=" THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||magazyn_id||'\",\"'||dokument_id||'\",\"'||data_dm||'\",\"'||numer_dm||'\"]','M')"
    SELECT+=" ELSE '' END, False, "
    SELECT+=" (o.kasa_sprzedaz IS NOT NULL AND"  #WS 2022-04-06
    SELECT+=" (EXISTS (SELECT 1 FROM rs_kasy_banki_sposoby_zaplaty WHERE (firma_id, okres_id, kasa_bank_id)=(p.firma_id, okr.okres_id, o.kasa_sprzedaz)))"  #WS 2022-04-06
    SELECT+=" OR EXISTS (SELECT 1 FROM rs_paragony_fiskalne_platnosci WHERE (firma_id, oddzial_id, kasa_id, data, numer)=(p.firma_id, p.oddzial_id, p.kasa_id, p.data, p.numer))) as aktywne_platnosci "  #WS 2022-04-06
    SELECT+=" FROM rs_paragony_fiskalne p "
    SELECT+=" LEFT OUTER JOIN rs_oddzialy o USING (firma_id, oddzial_id)"  #WS 2022-04-06
    SELECT+=" LEFT OUTER JOIN rs_definicje_okresow okr ON (okr.firma_id=o.firma_id AND p.data BETWEEN okr.data_od AND okr.data_do)"  #WS 2022-04-06
    SELECT+=" WHERE "+Filtr+" ORDER BY oddzial_id,data DESC,numer DESC;"

    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT,3)
    

# dla komser== 11:
def dolozDodatkoweDane(dodatkoweDane, nazwa, row, desc, zwroc=[]):
    nowe = []
    doZwrocenia = [None] * len(zwroc)
    for d, info in zip(row, desc):
        if d == "None":
            d = None
        if info[0] not in ("z_czas", "z_typ", "z_op_id"):
            nowe.append((info[0], d))
        if info[0] in zwroc:
            doZwrocenia[zwroc.index(info[0])] = d
    dodatkoweDane.append((nazwa.upper(), nowe))
    return doZwrocenia

# komser: no to jesli mamy cos do przeslania to zapisujemy
if stat == "OK" and Funkcja == 11 and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    # komser: sprawdzamy czy dane maj by przesyane dalej
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        komserDane = []

        stat, paragon, desc, dump = self.PolSQL.Execute("SELECT * FROM rs_paragony_fiskalne"
            " WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s", 3,
            (self.firma_id, Oddzial, Kasa, Data, Numer))
        if stat == "OK":
            stat, pozycje, pdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_paragony_fiskalne_pozycje"
                " WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s ORDER BY nr_poz", 3,
                (self.firma_id, Oddzial, Kasa, Data, Numer))
        if stat == "OK" and paragon:
            komserDaneParagonu = []
            Mag, Dokum, DataDM, NrDM = dolozDodatkoweDane(komserDaneParagonu, "PARAGON", paragon[0], desc,
                ["magazyn_id", "dokument_id", "data_dm", "numer_dm"])
            Mag = rsglobal.Dekoduj(Mag)
            Dokum = rsglobal.Dekoduj(Dokum)
            for pozycja in pozycje:
                dolozDodatkoweDane(komserDaneParagonu, "POZYCJA", pozycja, pdesc)

        if stat == "OK" and paragon:
            komserDane.extend(komserDaneParagonu)

            stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja", "dodatkowe-dane:", komserDane],
                ["fs_komser_paragony_fiskalne", klucze, pola, wartosci])

