# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_paragony_fiskalne_platnosci.py
# Purpose:     Uzupenianie patnoci w paragonach fiskalnych
# Author:      Bartosz Pagan
# Created:     2022/02/08
# RCS-ID:      $Id: fs_paragony_fiskalne_platnosci.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2022-02-23 Wojciech Skowron (12855) Patnoci w paragonach fiskalnych

from funkcje import fs_okresy_pom
from funkcje import fs_raporty_wyciagi_pom

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Oddzial': [1, 5], 'Kasa': [1, 5], 'Data': [1, 5], 'Numer': [1, 5],}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = "Uwaga: wywoanie funkcji fs_paragony_fiskalne_platnosci z numerem "+str(Funkcja)+" bez parametrw: "+Lista

    if Funkcja in [1, 5]:
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
        Kasa = rsglobal.Dekoduj(klucze['Kasa'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(str(klucze['Numer']))

UprMod = (((self.oddzial_id, '025012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH (1)   -----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if not UprMod > 0:
        stat = 'UPR_MOD'

    sposoby_zaplaty = []
    do_zaplaty_paragon = 0  # kwota do_zaplaty pobrana z paragonu
    do_zaplaty_suma = 0  # suma do_zaplaty pobrana z grida
    okres_dla_daty = None
    stan = 'Z'

    if stat == 'OK':
        SEL = """SELECT do_zaplaty, stan FROM rs_paragony_fiskalne 
                 WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s;"""
        zmienne = [self.firma_id, Oddzial, Kasa, Data, Numer]
        rsglobal.ZapiszDoLogow('Pobranie do_zaplaty z paragonu: '+self.PolSQL.Mogrify(SEL, zmienne))
        stat, d_par, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
        if stat != 'OK':
            stat = 'Bd pobrania danych paragonu fiskalnego: '+stat
        else:
            do_zaplaty_paragon = d_par[0][0]
            stan = d_par[0][1]

    if stat == 'OK':
        if stan != 'W':
            stat = 'BL_STAN'
            dane.append(stat)

    if stat == 'OK':
        stat, d_okres = fs_okresy_pom.PodajOkresDlaDaty(self, Data)
        if stat == 'OK':
            okres_dla_daty = d_okres

    if stat == 'OK':
        stat, d_kasabank = fs_raporty_wyciagi_pom.PodajDomyslnaKase(self, okres_dla_daty, Oddzial)
        if stat == 'OK':
            kasa_bank_id = d_kasabank['kasa_bank_id']

    # if stat == 'OK':
    #     SEL = """SELECT sposob_zaplaty FROM rs_kasy_banki_sposoby_zaplaty
    #              WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s;"""
    #     zmienne = [self.firma_id, okres_dla_daty, kasa_bank_id]
    #     rsglobal.ZapiszDoLogow('Pobranie sposobw zapaty dla kasy banku: '+self.PolSQL.Mogrify(SEL, zmienne))
    #     stat, d_spos, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
    #     if stat != 'OK':
    #         stat = 'Bd pobrania sposobw zapaty kasy banku: '+stat
    #     else:
    #         sposoby_zaplaty = [d[0] for d in d_spos]

    if stat == 'OK':
        pola_klucz = Update[3]
        for pola, wartosci, wartosci_klucz in zip(Update[0], Update[1], Update[2]):
            # for pole, wart in zip(pola_klucz, wartosci_klucz):
            #     if pole == 'sposob_zaplaty':
            #         if wart not in sposoby_zaplaty:
            #             stat = 'BL_SPOS'
            #             dane.append(stat)

            for pole, wart in zip(pola, wartosci):
                if pole == 'kwota':
                    if wart >= 0:
                        do_zaplaty_suma += wart
                    else:
                        stat = 'BL_KWOTA_UJEMNA'
                        dane.append(stat)

        if len(Update[2]) > 0:
            zmienne = []

            WHERE = 'sposob_zaplaty NOT IN ('
            WHERE += '%s,'*len(Update[2])
            WHERE = WHERE.strip(',')
            WHERE += ')'
            zmienne.extend([str(wart[0]) for wart in Update[2]])

            # pobranie sumy kwot z wierszy ktre nie zostay zmodyfikowane
            SEL = "SELECT SUM(kwota) FROM rs_paragony_fiskalne_platnosci WHERE "+WHERE+" AND firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s;"
            zmienne.extend([self.firma_id, Oddzial, Kasa, Data, Numer])
            rsglobal.ZapiszDoLogow('Pobranie sumy kwot dla niezmodyfikowanych wierszy: '+self.PolSQL.Mogrify(SEL, zmienne))
            stat, d_suma, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
            if stat != 'OK':
                stat = 'Bd pobrania sumy kwot dla niezmodyfikowanych wierszy: '+stat
            else:
                do_zaplaty_suma += d_suma[0][0]

        rsglobal.ZapiszDoLogow('Suma kwot: '+str(do_zaplaty_suma))
        rsglobal.ZapiszDoLogow('do_zaplaty na paragonie: ' + str(do_zaplaty_paragon))
        if do_zaplaty_suma != do_zaplaty_paragon:
            stat = 'BL_SUMA'
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ----------------------   INSERT/UPDATE (1)   ----------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja == 1:
    SQL = ''
    TYP = ''
    zmienne = []

    for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
        for pole, wart in zip(Update[3], klucz): # petla po kluczu
            if pole == 'sposob_zaplaty':
                SEL = """SELECT 1 FROM rs_paragony_fiskalne_platnosci 
                         WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s AND sposob_zaplaty=%s;"""
                rsglobal.ZapiszDoLogow('Sprawdzenie czy istnieje wiersz w patnociach: '+self.PolSQL.Mogrify(SEL, [self.firma_id, Oddzial, Kasa, Data, Numer, str(wart)]))
                stat, d_plat, wyn1, dump = self.PolSQL.Execute(SEL, 3, [self.firma_id, Oddzial, Kasa, Data, Numer, str(wart)])
                if stat != 'OK':
                    stat = 'Bd pobrania danych patnoci paragonu: '+stat
                elif len(d_plat) > 0:
                    TYP = 'UPDATE'
                else:
                    TYP = 'INSERT'

        if TYP == 'UPDATE':
            SQL += "UPDATE rs_paragony_fiskalne_platnosci SET "
            for pole, wart in zip(pola, wartosci):
                if pole in ['kwota']:
                    SQL += pole+"=%s,"
                    zmienne.append(str(wart))

            SQL = SQL.strip(",")
            SQL += """ WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s"""
            zmienne.extend([self.firma_id, Oddzial, Kasa, Data, Numer])

            for pole, wart in zip(Update[3], klucz):
                SQL+= " AND "+pole+"=%s"
                zmienne.append(str(wart))

            SQL += ";"
        elif TYP == 'INSERT':
            KOLUMNY = "INSERT INTO rs_paragony_fiskalne_platnosci (firma_id, oddzial_id, kasa_id, data, numer"
            VALUES = " VALUES (%s, %s, %s, %s, %s"

            czy_zapisywac = False
            for pole, wart in zip(pola, wartosci):
                if pole in ['kwota'] and wart > 0:
                    if not czy_zapisywac:
                        zmienne.extend([self.firma_id, Oddzial, Kasa, Data, Numer])
                        czy_zapisywac = True
                    KOLUMNY += ","+pole
                    VALUES+=",%s"
                    zmienne.append(wart)

            for pole, wart in zip(Update[3], klucz):
                KOLUMNY += ","+pole
                VALUES+=",%s"
                if czy_zapisywac:
                    zmienne.append(str(wart))

            KOLUMNY+=")"
            VALUES+=");"
            if czy_zapisywac:
                SQL += KOLUMNY+VALUES

    rsglobal.ZapiszDoLogow('Zapis do patnoci: '+self.PolSQL.Mogrify(SQL, zmienne))
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
    if stat != 'OK':
        stat = 'Bd modyfikacji danych:' + stat
        dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

# ------------------------------------------------------------------------------------------------------------
# ---   POBRANIE DANYCH
# ------------------------------------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1, 5]:
    stat, d_okres = fs_okresy_pom.PodajOkresDlaDaty(self, Data)
    if stat == 'OK':
        okres_dla_daty = d_okres
        stat, d_kasabank = fs_raporty_wyciagi_pom.PodajDomyslnaKase(self, okres_dla_daty, Oddzial)

    if stat == 'OK' and d_kasabank is not None:
        kasa_bank_id = d_kasabank['kasa_bank_id']

        SEL = """SELECT sposob_zaplaty, opis, kwota FROM (
                 SELECT kbs.lp, kbs.sposob_zaplaty, s.opis,
                        (CASE WHEN plat.kwota IS NULL THEN (CASE WHEN kbs.lp = 1 AND SUM(COALESCE(plat.kwota, 0)) OVER (PARTITION BY NULL) = 0 THEN par.do_zaplaty ELSE 0 END) ELSE COALESCE(plat.kwota, 0) END)::NUMERIC(16,4) AS kwota
                 FROM rs_kasy_banki_sposoby_zaplaty kbs
                 JOIN rs_sposoby_zaplaty s ON (kbs.firma_id=s.firma_id AND kbs.sposob_zaplaty=s.kod)
                 JOIN rs_paragony_fiskalne par ON (par.firma_id=s.firma_id)
                 LEFT OUTER JOIN rs_paragony_fiskalne_platnosci plat ON (kbs.firma_id=plat.firma_id AND kbs.sposob_zaplaty=plat.sposob_zaplaty AND par.oddzial_id=plat.oddzial_id AND par.kasa_id=plat.kasa_id AND par.data=plat.data AND par.numer=plat.numer)
                 WHERE kbs.firma_id=%s AND kbs.okres_id=%s AND kbs.kasa_bank_id=%s AND par.oddzial_id=%s AND par.kasa_id=%s AND par.data=%s AND par.numer=%s
                 UNION
                 SELECT kbs.lp, plat.sposob_zaplaty, s.opis,
                        plat.kwota
                 FROM rs_paragony_fiskalne_platnosci plat 
                 JOIN rs_sposoby_zaplaty s ON (plat.firma_id=s.firma_id AND plat.sposob_zaplaty=s.kod)
                 JOIN rs_paragony_fiskalne par ON (par.firma_id=s.firma_id AND par.oddzial_id=plat.oddzial_id AND par.kasa_id=plat.kasa_id AND par.data=plat.data AND par.numer=plat.numer)
                 LEFT OUTER JOIN rs_kasy_banki_sposoby_zaplaty kbs ON (kbs.firma_id=plat.firma_id AND kbs.sposob_zaplaty=plat.sposob_zaplaty AND kbs.okres_id=%s AND kbs.kasa_bank_id=%s)
                 WHERE plat.firma_id=%s AND plat.oddzial_id=%s AND plat.kasa_id=%s AND plat.data=%s AND plat.numer=%s
                 ORDER BY lp NULLS LAST) wynik;"""
        zmienne = [self.firma_id, okres_dla_daty, kasa_bank_id, Oddzial, Kasa, Data, Numer,
                   okres_dla_daty, kasa_bank_id, self.firma_id, Oddzial, Kasa, Data, Numer]
        rsglobal.ZapiszDoLogow('Pobranie danych patnoci: '+self.PolSQL.Mogrify(SEL, zmienne))
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, zmienne)
        if stat != 'OK':
            stat = 'Bd pobrania danych: ' + stat
