# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki.py
# Purpose:     wczytuje/usuwa dane z kasami/bankami
#
# Author:      Micha Raburski
# Created:     2007/02/12
# RCS-ID:      $Id: fs_kasy_banki.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#2011-02-17 Mariusz Rajfura - nowe pole na gridzie 'techniczne' (4277)
#2017-09-13 Rafa Woniak (10721) Refaktoryzacja
#2019-05-20 Wojciech Skowron (11488) Poprawka w funkcji 15

import rsglobal

KluczeDod=pola
stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'KontoS':[6,12,15],'Konto':[6],'KontoSF':[5,6],'KontoF':[5,6],'NazwaF':[5,6],
           'SyntF':[5,6],'DataKsiegKosztow':[5,6,11,12,13,15,21]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_plan_kont z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6]:
        KontoSF = klucze['KontoSF']
        KontoF = klucze['KontoF']
        NazwaF = klucze['NazwaF']
        SyntF = klucze['SyntF']
    if Funkcja in [6,12,15]:
        KontoS = klucze['KontoS']
    if Funkcja in [6]:
        Konto = klucze['Konto']
    #WS 2019-05-20
    if Funkcja in [5,6,11,12,13,15,21]:
    # if Funkcja in [5,6,11,12,13,21]:
        DataKsiegKosztow = klucze['DataKsiegKosztow']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    KontoPl=''
    DKonta=[]
    DaneKonta=[]
    LSprawdzac=[]

#-------------------------------------------------------------------------------

UprUsuwanie=((self.oddzial_id,'073014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#Pobranie okresu dla dziaa w planie kont jeli podana jest data ksigowania kosztw
OkresAktywny=self.okres_id
if not DataKsiegKosztow in ['','    -  -  ',None]:
    if rsglobal.SprawdzCzyToData(DataKsiegKosztow):
        Select= "SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+DataKsiegKosztow+"');"
        stat,DOkr,dump,dump = self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(DOkr)>0:
                if DOkr[0][0]<> 'Brak':
                    OkresAktywny=rsglobal.Dekoduj(DOkr[0][0])

if OkresAktywny==None:
    stat="BL OKR"


#-------------------------------------------------------------------------------
#---   POBRANIE SYNTETYKI Z OKRESU (21)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 21:
    SQL ="SELECT dlug_syntetyki FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+OkresAktywny+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)


#-------------------------------------------------------------------------------
#---   POBRANIE OPISU KONTA (15)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==15:
    #WS 2019-05-20
    # Konto=rsglobal.Dekoduj(klucze[0])
    if KontoS in [None,'None','']:
        dane=[['']]
    else:
        SQL= "SELECT rsf_podaj_nazwe_konta('"+self.firma_id+"','"+OkresAktywny+"','"+KontoS+"');"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CO I JAK Z PODANYM W FILTRZE KONTEM (12)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 12:
    sql = ''
    WPorzadku=False
    #znalezienie bazowego konta.
    LBufor=KontoS.split('-')
    bufor=''
    pierwsze=True
    for kaw in LBufor:
        if stat=='OK':
            if pierwsze:
                pierwsze=False
            else:
                bufor+='-'
                
            bufor+=kaw
            #test - jeli konto istnieje to bdziemy probowac dalej
            sql="SELECT kontos_id,konto_id,grupa1,grupa2,grupa3,grupa4,grupa5 FROM rs_plan_kont WHERE firma_id='"
            sql+=self.firma_id+"' "
            sql+=" AND okres_id='"+OkresAktywny+"' AND TRIM('- ' FROM kontos_id||'-'||konto_id)='"+bufor+"';" 
            stat,DKonta,dump,dump = self.PolSQL.Execute(sql,3)

        if stat=='OK':
            if len(DKonta)>0:
                KontoPl=bufor
                DaneKonta=DKonta
    
    #sprawdzenie czy konto jest poprawne
    if KontoPl <> KontoS and len(DaneKonta)>0 and DaneKonta[0][2] in (None,'None',''):
        dane=['',[]]
                
    #sprawdzenie czy podane konto nie jest czescia analityki
    sql="SELECT kontos_id,konto_id FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' "
    sql+=" AND okres_id='"+OkresAktywny+"' AND TRIM('- ' FROM kontos_id||'-'||konto_id) LIKE '"+KontoPl+"%';" 
    stat,DTestAn,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DTestAn)>1:
            dane=['',[]]
        
              
    #jeli znalaz konto, oraz nie jest rwne temu co weszo na pocztku to 
    #znaczy, e poda cz danych grupy.
    if stat=='OK' and KontoPl <> '' and len(DaneKonta)>0 and dane==[]:
        #Mamy grupy i mamy koncowke klucza - probujemy to polaczyc
        GdzieGrupa=len(KontoPl.split('-'))
        # jeli jest bd w koncie to od tego momentu dodaje grupy do listy do sprawdzenia
        WPorzadku=True
        
        for i in range(5):
            if stat=='OK':
                if DaneKonta[0][i+2] not in (None,'None',''):
                    sql="SELECT kontrahenci,odbiorcy,dostawcy,pracownicyk,inni,pracownicy,zlecenia,konta_kosztow,"
                    sql+="magazyny,oddzialy,stawki_vat,lista,dlugosc,dzialy_firmy,projekty FROM rs_grupy_analityczne"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"'  AND grupa_id='"
                    sql+=rsglobal.Dekoduj(DaneKonta[0][i+2])+"';"
                    stat,DGrupy,dump,dump = self.PolSQL.Execute(sql,3)
                    
                    if stat=='OK':
                        if len(DGrupy)==0:
                            stat='BL DEF GR'
                
                    if stat=='OK':
                        #wiemy e jest grupa do sprawdzenia. Albo mamy do niej kawaek konta, albo zapisujemy, e naley j sprawdzi.
                        if (len(LBufor)>=GdzieGrupa+i+1) and WPorzadku:
                            TestGr=rsglobal.Dekoduj(LBufor[GdzieGrupa+i])
                        else:
                            TestGr=''
                    
                        #sprawdzenie czy podana w koncie przykadowym wartosc jest OK
                        
                        #to s zmienne, ktre w oknie klienta bd syyy do stwierdzenia co jeszcze trzeba sprawdzi 
                        Rodz=-1
                        Dl=0
                        sql=''
                        
                        #kontrahenci
                        if DGrupy[0][0]:
                            Rodz=0
                            if TestGr<>'':
                                sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                                sql+="AND kontrahent_id='"+TestGr+"';"
                            
                        #odbiorcy
                        elif DGrupy[0][1]:
                            Rodz=1
                            if TestGr<>'':
                                sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kontrahent_id='"+TestGr+"' AND odbiorca;"
                            
                        #dostawcy
                        elif DGrupy[0][2]:
                            Rodz=2
                            if TestGr<>'':
                                sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kontrahent_id='"+TestGr+"' AND dostawca;"
                            
                        #pracownicy - kontr
                        elif DGrupy[0][3]:
                            Rodz=3
                            if TestGr<>'':
                                sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kontrahent_id='"+TestGr+"' AND pracownik;"
                            
                        #inni - kontr
                        elif DGrupy[0][4]:
                            Rodz=4
                            if TestGr<>'':
                                sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kontrahent_id='"+TestGr+"' AND inny;"
                            
                        #pracownicy (przyszociowe)
                        elif DGrupy[0][5]:
                            Rodz=5
                            if TestGr<>'':
                                sql=""
                            
                        #zlecenia
                        elif DGrupy[0][6]:
                            Rodz=6
                            if TestGr<>'':
                                sql="SELECT * FROM rs_numery_zlecen WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kod='"+TestGr+"';"

                        #konta kosztow
                        elif DGrupy[0][7]:
                            Rodz=7
                            if TestGr<>'':
                                sql="SELECT * FROM rs_konta_kosztow WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kod='"+TestGr+"';"
    
                        #magazyny
                        elif DGrupy[0][8]:
                            Rodz=8
                            if TestGr<>'':
                                sql="SELECT * FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND magazyn_id='"+TestGr+"';"
                            
                        #oddzialy
                        elif DGrupy[0][9]:
                            Rodz=9
                            if TestGr<>'':
                                sql="SELECT * FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND oddzial_id='"+TestGr+"';"
    
                        #stawki vat
                        elif DGrupy[0][10]:
                            Rodz=10
                            if TestGr<>'':
                                sql="SELECT * FROM rs_stawki_vat WHERE kod='"+TestGr+"';"
                            
                        # konta z definiowanej grupy analitycznej
                        elif DGrupy[0][11]:
                            Rodz=11
                            Dl=DGrupy[0][12]
                            if TestGr<>'':
                                sql="SELECT * FROM rs_konta_analityczne WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND okres_id='"+OkresAktywny+"' "
                                sql+=" AND grupa_id='"+rsglobal.Dekoduj(DaneKonta[0][i+2])+"' AND kontoa_id='"+TestGr+"';"
    
                        #dziay firmy
                        elif DGrupy[0][13]:
                            Rodz=13
                            if TestGr<>'':
                                sql="SELECT * FROM rs_dzialy_firmy WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND kod='"+TestGr+"';"
                            
                        #projekty
                        elif DGrupy[0][14]:
                            Rodz=14
                            if TestGr<>'':
                                sql = "SELECT rsf_opis_symbol_projektu('"+self.firma_id+"','"+TestGr+"');"
                                stat,wyn,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'Bd pobrania danych projektu : '+stat
                                else:
                                    wyn = rsglobal.rseval(wyn[0][0])
                                    if len(wyn)>0:
                                        #czy nastapila zamiana identyfikatora projektu na projekt_id
                                        if TestGr <> wyn[1].strip():
                                           TestGr = wyn[1].strip()
                                           #niepusta lista wyn2 daje sygnal, ze nastapila zamiana
                                           #identyfikatora projektu na projekt_id
                                           wyn2.append(TestGr)
                                           #to pozwala w przyszlosci dokonywac innych zmian 'w locie'
                                           #funkcja WstawKontoPoZamianach sprawdza dlugosc listy wyn2
                                           #i w przypadku niezerowej podmienia zawartosc calej kontrolki
                                
                                sql="SELECT * FROM rs_projekty WHERE firma_id='"+self.firma_id+"' "
                                sql+=" AND projekt_id='"+TestGr+"';"
                        
                        if sql <> '':
                            stat,DTest,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat=='OK':
                                if len(DTest)==1:
                                    KontoPl+='-'+TestGr
                                else:
                                    WPorzadku=False
                                    LSprawdzac.append([Rodz,DaneKonta[0][i+2],Dl])
                        else:
                            WPorzadku=False
                            LSprawdzac.append([Rodz,DaneKonta[0][i+2],Dl])

    if stat=='OK':
        if not WPorzadku:
            dane=[KontoPl,LSprawdzac]
        else:
            dane=[KontoPl,['OK']]


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE POPRAWNOCI KONTA (11)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 11:
    stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_plan_kont('"+self.firma_id+"','"+OkresAktywny+"');" ,3)


#-------------------------------------------------------------------------------
#---   POBRANIE PLANU KONT Z GRUPAMI ANALITYCZNYMI (13)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 13:
    # dodatkowa informacja, czy dana grupa analityczna dotyczy kontrahenta
    # mantis: 2127  mariusz rajfura
    # usunito filtr na okres id ze wzgldu na dat ksigowania kosztw
    dane = []
    wyn1 = []
    kontrahenci = {}
    
    sql = "SELECT okres_id,grupa_id FROM rs_grupy_analityczne"
    sql += " WHERE firma_id='"+self.firma_id+"' "
    sql += " AND kontrahenci AND NOT (NOT odbiorcy AND NOT dostawcy AND pracownicyk AND NOT inni);"
    stat,ga,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bd pobrania grup analitycznych: '+stat
        
    if stat == 'OK':
        for i in ga:
            kontrahenci[(i[0],i[1])] = True

        sql = "SELECT okres_id,kontos_id,konto_id,nazwa,"
        sql += " grupa1,grupa2,grupa3,grupa4,grupa5,COALESCE(rozrachunkowe,FALSE),COALESCE(pozabilansowe,FALSE)"
        sql += " FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bd pobrania planu kont: '+stat

    if stat=='OK':
        for konto in d:
            okres=konto[0]
            magrupy = 0
            jestkontrah = 0
                
            for licz in range(4,9):
                grupa = konto[licz]
                if grupa <> 'None':
                    magrupy = 1
                    if kontrahenci.has_key((okres,grupa)):
                        #podaje numer grupy w ktrej jest kontrahent
                        jestkontrah = licz - 3

            dane.append((konto[0],konto[1],konto[2],konto[3],str(magrupy),str(jestkontrah),konto[9],konto[10]))

    # Pobranie okresw obrachunkowych
    if stat=='OK':
        sql = "SELECT okres_id,data_od,data_do"
        sql += " FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"';"
        
        stat,wyn1,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bd pobrania okresw: '+stat

        
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6 :
    if not UprUsuwanie:
        stat='UPR DEL'

    if stat=='OK':
        #sprawdzenie czy konto nie jest uzywane
        KontoTest=KontoS
        if Konto.strip() <> '':
            KontoTest+='-'+Konto.strip()
            
        SQL="SELECT COUNT(*) FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id
        SQL+="' AND okres_id='"+OkresAktywny+"' "
        SQL+=" AND ( konto_wn LIKE '"+KontoTest+"%' OR konto_ma LIKE '"+KontoTest+"%'" 
        SQL+=" OR konto_vat_wn LIKE '"+KontoTest+"%' OR konto_vat_ma LIKE '"+KontoTest+"%');" 
        stat,DIlosc,dump,dump = self.PolSQL.Execute(SQL, 3)
    
    if stat=='OK':
        if DIlosc[0][0]>0:
            stat='UZ US'
    
    if stat=='OK':
        #sprawdzenie czy konto nie ma analityki w planie kont
        SQL="SELECT COUNT(*) FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"' "
        SQL+=" AND kontos_id||'-'||konto_id LIKE '"+KontoTest+"%';" 
        stat,DIlosc,dump,dump = self.PolSQL.Execute(SQL, 3)
    
    if stat=='OK':
        if DIlosc[0][0]>1:
            stat='PLK US'
            
    if stat=='OK':
        SQL="DELETE FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"' "
        SQL+=" AND kontos_id='" + KontoS + "' AND konto_id='" + Konto + "';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (stat=='OK') and (Funkcja in [5,6]):
        Filtr = " (firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"' "
        if KontoSF <> '':
            Filtr+=" AND kontos_id LIKE '"+KontoSF+"%'"
        if KontoF <> '':
            Filtr+=" AND konto_id LIKE '"+KontoF+"%'"
        if NazwaF<> '':
            Filtr+=" AND nazwa LIKE '"+NazwaF+"%'"
        if SyntF:
            Filtr+=" AND konto_id=''"

        Filtr+=')'

        #pobranie klucza wynikaj\u0105cego z numer\xf3w nowych kluczy
        if KluczeDod <> []:
            Filtr+=" OR ((firma_id='"+self.firma_id+"'AND okres_id='"+OkresAktywny+"') AND ("
            Pierwszy = True
            for kl in KluczeDod:
                if not Pierwszy:
                    Filtr+=" OR "
                else:
                    Pierwszy = False
                Filtr+="(kontos_id='"+rsglobal.Dekoduj(kl[0])+"' AND konto_id='"+rsglobal.Dekoduj(kl[1])+"')"
            Filtr+='))'

        Select="SELECT kontos_id,konto_id,nazwa,pozabilansowe,rozrachunkowe,do_bilansu,"
        Select+=" waluta,grupa1,grupa2,grupa3,grupa4,grupa5,tworzyc_platnosc,COALESCE(techniczne,''::TEXT) "
        Select+=" FROM rs_plan_kont WHERE "+Filtr+" ORDER BY kontos_id,konto_id;"

        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)