# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_plan_kont_dane.py
# Purpose:     dodaje/edytuje konto
#
# Author:      Mariusz Rajfura
# Created:     2009/06/22
# RCS-ID:      $Id: fs_plan_kont_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-02-17 Mariusz Rajfura  nowe pole 'techniczne' (4277)
# 2012-03-22 Mariusz Rajfura  info o uzywaniu konta do ustawienia edycji (5575,5574)

# klucze:
# 0 - konto syntetyczne
# 1 - konto analityczne
# 2 - poprzednie konto analityczne - potrzebne do ewentualnego UPDATE

KontoS = rsglobal.Dekoduj(klucze[0])
Konto = rsglobal.Dekoduj(klucze[1])
KontoPoprz = rsglobal.Dekoduj(klucze[2])
DataKsiegKosztow = rsglobal.Dekoduj(klucze[3])

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

Nazwa = None
DoBilansu = None
Pozabilansowe = None
Rozrachunkowe = None
CzySaldoJednostronne = None
TworzycPlatnosc = None
Techniczne = None

upd = ''

Grupa1 = 'NULL'
Grupa2 = 'NULL'
Grupa3 = 'NULL'
Grupa4 = 'NULL'
Grupa5 = 'NULL'

UprDodaj=((self.oddzial_id,'073013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdytuj=((self.oddzial_id,'073012') in self.uprawnienia) or UprDodaj

#Pobranie okresu dla dziaa w planie kont jeli podana jest data ksigowania kosztw
OkresAktywny=self.okres_id
if not DataKsiegKosztow in ['','    -  -  ',None]:
    if rsglobal.SprawdzCzyToData(DataKsiegKosztow):
        Select= "SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+DataKsiegKosztow+"');"
        stat,DOkr,dump,dump = self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(DOkr)>0:
                if DOkr[0][0]<> 'Brak':
                    OkresAktywny=rsglobal.Dekoduj(DOkr[0][0])

if Fun in (1,2):
    if UprDodaj == 0:
        stat = 'BR_UPR_DOD'
        
if Fun in(3,4):
    if UprEdytuj == 0:
        stat = 'BR_UPR_MOD'

        
#-------------------------------------------------------------------------------
#--- KONTROLA DANYCH 
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (1,2):
    #kontrola przed zakladaniem
    #czy nie puste
    if KontoS == '':
        stat = 'BL_K_PUSTE'
        dane.append(stat)
    else:
        if KontoS[0] not in ('0123456789'):
            stat = 'BL_K_CYFRA'
            dane.append(stat)
        
if stat=='OK' and Fun in (1,2):
    #czy konto jest istnieje
    sql = "SELECT konto_id FROM rs_plan_kont"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+OkresAktywny+"'"
    sql+=" AND kontos_id='"+KontoS+"' AND konto_id = '"+Konto+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bd pobrania konta : '+stat
    else:
        if len(d) > 0:
            stat = 'BL_K_UZYW'
            dane.append(stat)

if stat=='OK' and Fun in (1,2,3,4):
    #kontrola przed zakladaniem, modyfikacja

    if Fun in (3,4):
        #sprawdzenie istnienia konta modyfikowanego i jego blokada
        sql = "SELECT konto_id FROM rs_plan_kont"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"'"
        sql+=" AND kontos_id='"+KontoS+"' AND konto_id='"+KontoPoprz+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bd pobrania konta : '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak modyfikowanego konta.'
            dane.append(stat)
    
    #pobranie grup do sprawdzenia
    sql = "SELECT grupa_id FROM rs_grupy_analityczne"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id ='"+OkresAktywny+"';"
    stat,gr,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bd pobrania grup analitycznych : '+stat
    else:
        grupy = []
        for g in gr:
            grupy.append(g[0])
        
        for ln in xrange(len(pola)):
            
            pole = pola[ln]
            wart = wartosci[ln]
            
            if pole == 'konto_id':
                wart = "'"+wart+"'"
            
            elif pole == 'nazwa':
                if wart == '':
                    dane.append('BL_PUSTA_NAZWA')
                else:
                    Nazwa = wart
                    wart = "'"+wart+"'"
                    
            elif pole == 'do_bilansu':
                if wart not in ('WRN'):
                    dane.append('BL_DO_BILANSU')
                else:
                    DoBilansu = wart
                    wart = "'"+wart+"'"

            elif pole == 'techniczne':
                wart = rsglobal.Dekoduj(wart).strip()
                if wart not in ('BO',''):
                    dane.append('BL_TECH')
                else:
                    if wart == '':
                        wart = 'NULL'
                    else:
                        wart = "'"+wart+"'"
                    Techniczne =  wart
                        
            elif pole == 'rozrachunkowe':
                wart = str(wart)
                Rozrachunkowe = wart
            
            elif pole == 'pozabilansowe':
                wart = str(wart)
                Pozabilansowe = wart
            
            elif pole == 'czy_saldo_jednostronne':
                wart = str(wart)
                CzySaldoJednostronne = wart
        
            elif pole == 'tworzyc_platnosc':
                wart = str(wart)
                TworzycPlatnosc = wart
                
            elif pole == 'waluta':
                if wart == '':
                    dane.append('BL_WALUTA')
                else:
                    sql ="SELECT kod FROM rs_waluty "
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if len(d) == 1:
                            Waluta = wart
                            wart = "'"+wart+"'"
                        else:
                            dane.append('BL_WALUTA')
                    else:
                        stat='Bd pobrania waluty : '+stat
                
            elif pole == 'grupa1':
                if wart == '':
                    wart = 'NULL'
                else:
                    if not wart in grupy:
                        dane.append('BL_GR1')
                    else:
                        Grupa1 = "'"+wart+"'"
                        wart = Grupa1
                        
            elif pole == 'grupa2':
                if wart == '':
                    wart = 'NULL'
                else:
                    if not wart in grupy:
                        dane.append('BL_GR2')
                    else:
                        Grupa2 = "'"+wart+"'"
                        wart = Grupa2
            
            elif pole == 'grupa3':
                if wart == '':
                    wart = 'NULL'
                else:
                    if not wart in grupy:
                        dane.append('BL_GR3')
                    else:
                        Grupa3 = "'"+wart+"'"
                        wart = Grupa3
                        
            elif pole == 'grupa4':
                if wart == '':
                    wart = 'NULL'
                else:
                    if not wart in grupy:
                        dane.append('BL_GR4')
                    else:
                        Grupa4 = "'"+wart+"'"
                        wart = Grupa4
                        
            elif pole == 'grupa5':
                if wart == '':
                    wart = 'NULL'
                else:
                    if not wart in grupy:
                        dane.append('BL_GR5')
                    else:
                        Grupa5 = "'"+wart+"'"
                        wart = Grupa5
                        
            #w zmiennej upd przy okazji kontroli zrobimy sekwencje string pole=wartosc
            #jesli UPDATE
            if Fun in (3,4):
                upd += pole+'='+wart+','
    
    #czy byly jakies bledy w polach 
    if len(dane) > 0:
        stat = dane[0]                    
                        
# jesli INSERT, sprawdzamy, czy nie ma pustych grup przed wypelnionymi
# i czy grupy nie powtarzaja sie

if stat=='OK' and Fun in (1,2):
    
    if Grupa2 <> 'NULL':
        if Grupa1 == 'NULL':
            dane.append('BR_GR1')
        else:
            if Grupa2 == Grupa1:
                dane.append('BL_POWT_GR2')
    
    if Grupa3 <> 'NULL':
        if Grupa2 == 'NULL':
            dane.append('BR_GR2')
        else:
            if Grupa3 == Grupa2:
                dane.append('BL_POWT_GR3')
                
        if Grupa1 <> 'NULL':
            if Grupa3 == Grupa1:
                dane.append('BL_POWT_GR3')
                
    if Grupa4 <> 'NULL':
        if Grupa3 == 'NULL':
            dane.append('BR_GR3')
        else:
            if Grupa4 == Grupa3:
                dane.append('BL_POWT_GR4')
        
        if Grupa2 <> 'NULL':
            if Grupa4 == Grupa2:
                dane.append('BL_POWT_GR4')    

        if Grupa1 <> 'NULL':
            if Grupa4 == Grupa1:
                dane.append('BL_POWT_GR4')    
    
    if Grupa5 <> 'NULL':
        if Grupa4 == 'NULL':
            dane.append('BR_GR4')
        else:
            if Grupa5 == Grupa4:
                dane.append('BL_POWT_GR5')
                
        if Grupa3 <> 'NULL':
            if Grupa5 == Grupa3:
                dane.append('BL_POWT_GR5')
                
        if Grupa2 <> 'NULL':
            if Grupa5 == Grupa2:
                dane.append('BL_POWT_GR5')

        if Grupa1 <> 'NULL':
            if Grupa5 == Grupa1:
                dane.append('BL_POWT_GR5')

if stat=='OK':    
    if len(dane) > 0:
        stat = dane[0]
        
if stat=='OK' and Fun in (3,4) and not Techniczne in (None,''):
    #czy wypelnienie pola 'techniczne' dotyczy tylko konta syntetycznego
    # a nie konta, ktore posiada analityki lub grupy analityczne
    sql ="SELECT COALESCE(grupa1,''::TEXT)||COALESCE(grupa2,''::TEXT)||"
    sql+=" COALESCE(grupa3,''::TEXT)||COALESCE(grupa4,''::TEXT)||"
    sql+=" COALESCE(grupa5,''::TEXT) FROM rs_plan_kont"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"'"
    sql+=" AND kontos_id='"+KontoS+"';"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia konta syntetycznego: '+stat
        dane.append(stat)
    elif len(d) > 1:
        stat = 'BL_TECH_ANALITYKI'
        dane.append(stat)
    elif len(rsglobal.Dekoduj(d[0][0])) > 0:
        stat = 'BL_TECH_GRUPY'
        dane.append(stat)
    
        
#-------------------------------------------------------------------------------
#---- DODAWANIE KONTA 1-z pobraniem   2-bez pobrania
#-------------------------------------------------------------------------------
        
if stat=='OK' and Fun in (1,2):
    
    sql ="INSERT INTO rs_plan_kont ("
    sql+=" firma_id,okres_id,kontos_id,konto_id,nazwa,"
    sql+=" pozabilansowe,rozrachunkowe,czy_saldo_jednostronne,"
    sql+=" tworzyc_platnosc,do_bilansu,waluta,"
    sql+=" grupa1,grupa2,grupa3,grupa4,grupa5,techniczne)"
    sql+=" VALUES ('"+self.firma_id+"','"+OkresAktywny+"',"
    sql+="'"+KontoS+"','"+Konto+"','"+Nazwa+"',"
    sql+=Pozabilansowe+","+Rozrachunkowe+","+CzySaldoJednostronne+","
    sql+=TworzycPlatnosc+",'"+DoBilansu+"','"+Waluta+"',"
    sql+=Grupa1+","+Grupa2+","+Grupa3+","+Grupa4+","+Grupa5+","+Techniczne+");"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,1)
    if stat<>'OK':
        stat = 'Bd dodania konta '+KontoS+' '+Konto+' : '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---- MODYFIKACJA 3-z pobraniem  4-bez pobrania
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (3,4):
    sql ="UPDATE rs_plan_kont SET " + upd[0:len(upd)-1]
    sql+= " WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+OkresAktywny+"'"
    sql+= " AND kontos_id = '"+KontoS+"' AND konto_id = '"+KontoPoprz+"';"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,1)
    if stat<>'OK':
        stat = 'Bd aktualizacji konta '+KontoS+' '+Konto+' : istnieje ju konto o podanym kluczu'
        dane.append(stat)


#-------------------------------------------------------------------------------
# Pobranie informacji o uzyciu konta - liczba wierszy z kontem (9) 
#-------------------------------------------------------------------------------

if Fun == 9 and stat == 'OK':
    KontoTest = KontoS
    if Konto.strip() <> '':
        KontoTest+='-'+Konto.strip()
        
    SQL ="SELECT COUNT(*) FROM rs_dowody_ksiegowe_pozycje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresAktywny+"' "
    SQL+=" AND ( konto_wn LIKE '"+KontoTest+"%' OR konto_ma LIKE '"+KontoTest+"%'" 
    SQL+=" OR konto_vat_wn LIKE '"+KontoTest+"%' OR konto_vat_ma LIKE '"+KontoTest+"%');" 

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania informacji o uyciu konta: '+stat


#-------------------------------------------------------------------------------
#---- POBRANIE DANYCH  
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (1,3,5):
    sql = "SELECT * FROM rs_plan_kont"
    sql+= " WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+OkresAktywny+"'"
    sql+= " AND kontos_id = '"+KontoS+"' AND konto_id = '"+Konto+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z planu kont : '+stat
