#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_platnosci.py
# Purpose:          przeglda usuwa zamyka otwiera platnosci
# Author:           Dariusz Boduch
# Created:          2008/11/27
# RCS-ID:           $Id: fs_platnosci.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# 2012-01-05 Mariusz Rajfura  zmiana domyslnego porzadku na gridzie (5353)
# 2012-02-08 Mariusz Rajfura  Fun==2: popr.pobierania numeru, zwracanie nowego klucza (5512)
#                             blokada rozbicia dla stanu==U
# 2012-03-15 Mariusz Rajfura  popr.ustawiania numeru sekwencji dla pustej tabeli rs_platnosci (5544)
# 2013-05-07 Mariusz Rajfura (6836) pobranie domyslnego konta bankowego przy zakladaniu
# 2015-06-18 Piotr Witkowski (8216) refaktoryzacja patnoci (byo Hala Wola - zamknicie patnoci) 
# 2015-12-15 Piotr Witkowski (9454) [KS] Zmiany w patnociach
# 2018-06-21 Aleksander Bargie Kwota_vat  w patnociach (11111)
# 2019-12-20 Wojciech Skowron (11770) Poprawka - "Bdne konto id" komunikat podczas zmiany konta w patnociach
# 2021-11-29 Aleksander Bargie Rozbijanie patnoci dla pracownika (12739)

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'KontoId':[2,5,6,7,8,9,10,17],'Kontrahent':[2,5,6,7,8,9,10,17],'Stan':[2,5,6,7,8,9,10,17],
           'DataOd':[2,5,6,7,8,9,10,17],'DataDo':[2,5,6,7,8,9,10,17],'DataZapl':[2,5,6,7,8,9,10,17],
           'Hist':[2,5,6,7,8,9,10,17],'DataPli':[2,5,6,7,8,9,10,17],'Platnosc':[6,7,8,9,17,18],
           'NowyTermPlat':[9],'PozostawKwotaBiez':[9],'Pracownik':[2,5,6,7,8,9,10,17],
           'Ktory':[2,5,6,7,8,9,10,17],'NrListy':[2,5,6,7,8,9,10,17],
           'ListaPlatnosci':[10], 'NoweKonto':[10]} #WS 2019-12-20

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_platnosci z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

    if stat=='OK':
        if Funkcja in [2,5,6,7,8,9,10,17]:
            KontoId = str(klucze['KontoId'])
            Kontrahent = str(klucze['Kontrahent'])
            Pracownik = str(klucze['Pracownik'])
            Ktory = str(klucze['Ktory'])
            Stan = str(klucze['Stan'])
            DataOd = str(klucze['DataOd'])
            DataDo = str(klucze['DataDo'])
            DataZapl = str(klucze['DataZapl'])
            Hist = klucze['Hist']
            DataPli = str(klucze['DataPli'])
            NrListy = str(klucze['NrListy'])
    if stat=='OK':
        #WS 2019-12-20
        if Funkcja in [6,7,8,9,17,18]:
        # if Funkcja in [6,7,8,9,10,17,18]:
            Platnosc = str(klucze['Platnosc'])

    if stat=='OK':
        if Funkcja in [9]:
            NowyTermPlat = str(klucze['NowyTermPlat'])
            PozostawKwotaBiez= klucze['PozostawKwotaBiez']

    #WS 2019-12-20
    if stat=='OK':
        if Funkcja in [10]:
            ListaPlatnosci = klucze['ListaPlatnosci']
            NoweKonto = klucze['NoweKonto']

dane = []
wyn1 = []
wyn2 = []
LArtPoziom=[]


#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprEdy =(self.oddzial_id,'076702') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprOtw =(self.oddzial_id,'076707') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprZam =(self.oddzial_id,'076706') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprUsuw=(self.oddzial_id,'076704') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprDod =(self.oddzial_id,'076703') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprLaczenieWPary=(self.oddzial_id,'076708') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------

Pusty=[None,'','None','    -  -  ']
self.NowaPlatnoscId='x'
#sprawdzenie poprawnoci danych z klucza "O
if not Funkcja in [11,18]:
    if DataOd not in Pusty:
        if not rsglobal.SprawdzCzyToData(DataOd):
            stat='BL DATAOD'

    if DataDo not in Pusty:
        if not rsglobal.SprawdzCzyToData(DataDo):
            stat='BL DATADO'

    if DataZapl not in Pusty:
        if not rsglobal.SprawdzCzyToData(DataZapl):
            stat='BL DATAZAPL'

    if DataPli not in Pusty:
        if not rsglobal.SprawdzCzyToData(DataPli):
            stat='BL DATAPLI'

    if DataOd not in Pusty and DataDo not in Pusty:
        if DataOd>DataDo:
            stat='BL ZAKR DAT'

    if KontoId.strip()<>'':
        stat,daneK,wyn1,dump=self.PolSQL.Execute("SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id = '"+KontoId+"' ;",3)
        if stat<>'OK':
            stat='BL SQL KONTO'
            dane.append(stat)
        else:
            if len(daneK)==0:
                stat='BL KONTO'
                dane.append(stat)

    if Kontrahent.strip()<>'' and Ktory == 'Kontrahent':
        stat,daneKo,wyn1,dump=self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"' ;",3)
        if stat<>'OK':
            stat='BL SQL KONTR'
            dane.append(stat)
        else:
            if len(daneKo)==0:
                stat='BL KONTR'
                dane.append(stat)

    if Pracownik.strip()<>'' and Ktory == 'Pracownik':
        sql ="SELECT pracownik_id FROM rs_kp_dane_osobowe"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji z kartoteki osobowej : '+stat
        elif len(d) == 0:
            stat = 'Osoba o podanym numerze nie istnieje.'


#-------------------------------------------------------------------------------
#-- CZENIE ROZRACHUNKW W PARY PATNOCI ID (11)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 11:
    if not UprLaczenieWPary:
        stat = 'UPR PARY'
        dane.append(stat)

    if stat == 'OK':
        sql ="UPDATE rs_rozrachunki SET seria_rozl=r.seria::TEXT "
        sql+=" FROM rs_rozrachunki r "
        sql+=" WHERE rs_rozrachunki.firma_id='"+self.firma_id+"' AND rs_rozrachunki.okres_id='"+self.okres_id+"'"
        sql+=" AND NOT rs_rozrachunki.platnosc_id IS NULL AND rs_rozrachunki.data_rozlicz IS NULL"
        sql+=" AND r.data_rozlicz IS NULL"
        sql+=" AND (rs_rozrachunki.seria_rozl IS NULL OR TRIM(rs_rozrachunki.seria_rozl) IN ('0',''))"
        sql+=" AND ((rs_rozrachunki.kwota_wn<>0 AND r.kwota_ma <>0) "
        sql+=" OR (rs_rozrachunki.kwota_ma>0 AND r.kwota_ma <0))"
        sql+=" AND rs_rozrachunki.firma_id=r.firma_id AND rs_rozrachunki.okres_id=r.okres_id"
        sql+=" AND rs_rozrachunki.konto=r.konto AND rs_rozrachunki.platnosc_id=r.platnosc_id;"
        stat,dump,dump,dump = self.PolSQL.Execute(sql,1)

#-------------------------------------------------------------------------------
#-- dodawanie 2
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 2:
    if not UprDod:
        stat = 'UPR DOD'
        dane.append(stat)

    if stat == 'OK':
        sql ="SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"';"
        stat,KontaBankowe,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy kont bankowych: '+stat

    if stat == 'OK':
        # zablokowanie platnosci na czas dodawania nowego rekordu
        # zakladamy, ze operator moze chwile poczekac na zablokowanie
        sql = "SELECT platnosc_id FROM rs_platnosci FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd zablokowania tabeli patnoci: '+stat

    if stat == 'OK':
        # pobranie maksymalnego bigserial
        sql = "SELECT max(platnosc_id) FROM rs_platnosci;"
        stat,MaksymalnyNumer,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania maksymalnego numeru patnosci: '+stat

    if stat == 'OK' and MaksymalnyNumer[0][0] > 0:
        # ustawiamy wlasciwy numer dla sekwecji, bo moze sie zdarzyc,
        # ze byl robiony import tabeli rs_platnosci i wtedy sekwencja jest nieaktualna
        # to taki mechanizm 'samonaprawy'
        # uwaga: nie mozemy uzyc currval(), bo moze byc w danej sesji jeszcze nie zainicjowane
        # uwaga2: jesli tabela rs_platnosci jest pusta nie ustawiamy numeru sekwencji na 0,
        #         bo generuje blad

        sql = "SELECT setval('rs_platnosci_platnosc_id_seq',"+str(MaksymalnyNumer[0][0])+");"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd ustawiania biecego numeru sekwecji dla patnoci: '+stat

    if stat == 'OK':
        # mamy zblokowana tabele na firme, teraz dodajemy nowy rekord
        sql = "INSERT INTO rs_platnosci"
        PolaN="firma_id, stan, kwota_platnosci,uregulowano, op_wpr "
        WartosciN = "'"+self.firma_id+"', 'W', 0, 0, "+str(self.operator_id)
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat <> 'OK':
            stat = 'BL INS'
            dane.append(stat)

    if stat == 'OK':
        # pobranie nowego bigserial w ramach firmy:
        # to powinien byc nasz ostatnio zalozony
        sql = "SELECT max(platnosc_id) FROM rs_platnosci WHERE firma_id='"+self.firma_id+"';"
        stat,daneB,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru patnosci: '+stat

    if stat == 'OK':
        # natychmiast odblokowujemy tabele platnosci
        self.PolSQL.Commit()

        # zachowujemy nowy numer dla dalszych celow
        self.NowaPlatnoscId=daneB[0][0]

        # nr nowej platnosci przekazany do okienka
        wyn2.append(daneB[0][0])

        # jesli zdefiniowano tylko jedno konto, to przekazujemy jego nume dla wpisania przy dodawaniu
        if len(KontaBankowe) == 1:
            wyn2.append(KontaBankowe[0][0])
        else:
            wyn2.append('')


#-------------------------------------------------------------------------------
# -- usuwanie 6
#-------------------------------------------------------------------------------

if (Funkcja == 6) and stat=='OK':
    if not UprUsuw:
        stat='UPR DEL'
        dane.append(stat)
    if stat=='OK':
        # pobranie stanu, platnosci pierwotnej, kwoty platnosci
        SQL = " SELECT stan FROM rs_platnosci WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(Platnosc)+" ; "
        stat,daneu,dump,dump=self.PolSQL.Execute(SQL,3)

        if stat <> 'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        if len (daneu) == 0:
            stat='BR STAN'
            dane.append(stat)
        if stat=='OK':
            StanU=daneu[0][0]
            if StanU<>'W':
                stat='BL STAN'
                dane.append(stat)
    if stat=='OK':
        Filtr = " firma_id = '" + self.firma_id + "' AND platnosc_id = '" + str(Platnosc) + "' "
        Delete="UPDATE  rs_platnosci SET stan='U' WHERE "+Filtr+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
        if stat!="OK":
            stat="BL DEL"
            dane.append(stat)


#-------------------------------------------------------------------------------
# -- Zamykanie 7,17
#-------------------------------------------------------------------------------

if Funkcja in [7,17,18] and stat=='OK':
    if not UprZam:
        stat='UPR ZAM'
        dane.append(stat)

    if stat=='OK':
        # pobranie stanu
        SQL = " SELECT stan FROM rs_platnosci WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(Platnosc)+" ; "
        stat,danes,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        if len (danes) == 0:
            stat='BR STAN'
            dane.append(stat)
        if stat=='OK':
            StanP=danes[0][0]
            if StanP=='U':
                stat='BL STAN OTWU'
                dane.append(stat)

    if stat=='OK':
        if StanP == 'W':
            NastStanP = 'A'
        elif StanP == 'A':
            NastStanP='P'
        elif StanP == 'P':
            NastStanP='Z'
        elif StanP =='Z':
            stat ='BL STANZ'
            dane.append(stat)

    if stat == 'OK':
        Filtr="WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(Platnosc)+" ; "
        sql="UPDATE rs_platnosci SET stan='"+NastStanP+"' "
        if NastStanP=='Z':
            sql=sql+Filtr
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                stat='BL ZAM'
                dane.append(stat)
        elif NastStanP=='A':
            sql=sql+", op_zatw="+str(self.operator_id)+" "+Filtr
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                stat='BL UPD ZATW'
                dane.append(stat)
        elif NastStanP=='P':
            sql=sql+", op_zapl="+str(self.operator_id)+", data_pli=clock_timestamp() "+Filtr
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                stat='BL UPD ZAPL'
                dane.append(stat)

#-------------------------------------------------------------------------------
# -- Otwieranie 8
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat=='OK':
    if not UprOtw :
        stat="UPR OTW"
        dane.append(stat)

    if stat=='OK':
        # pobranie stanu
        SQL = " SELECT stan FROM rs_platnosci WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(Platnosc)+" ; "
        stat,danes,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        if len (danes) == 0:
            stat='BR STAN'
            dane.append(stat)
        StanP=danes[0][0]
        if StanP=='U':
            stat='BL STAN OTWU'
            dane.append(stat)

    if stat=='OK':
        if StanP == 'Z':
            NastStanP = 'P'
        if StanP == 'P':
            NastStanP = 'A'
        if StanP == 'A':
            NastStanP = 'W'
        elif StanP =='W':
            stat='BL STAN OTW'
            dane.append(stat)

    if stat=='OK':
        Filtr="WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(Platnosc)+" ; "
        sql="UPDATE rs_platnosci SET stan='"+NastStanP+"' "+Filtr
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL OTW'
            dane.append(stat)
    if stat=='OK':
        sql="UPDATE rs_platnosci SET op_ed="+str(self.operator_id)+" "+Filtr
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL EDY'
            dane.append(stat)

#-------------------------------------------------------------------------------
# -- rozbijanie 9 #
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 9:
    if not UprEdy:
        stat='UPR EDY'
        dane.append(stat)
    if stat=='OK':
        #pobieranie danych z platnosci pierwotnej
        if Ktory =="Pracownik":
        #AB 21.06.18r Blokada rozbijania patnoci z kwot VAT != 0
            sql = "SELECT platnosc_id, konto_id, COALESCE(pracownik_id,'') AS pracownik_id, stan, numer_listy_id, kwota_oryg, kwota_platnosci, kwota_vat, "  #AB 29.11.21r dopisany przecinek
            sql+=" COALESCE(CAST(op_wpr AS TEXT),'') AS op_wpr, COALESCE(CAST(op_zatw AS TEXT),'') as op_zatw,"
            sql+=" konto_fk, stan "
            sql+=" FROM rs_platnosci WHERE platnosc_id="+str(Platnosc)+" ; "
        else:
        #AB 21.06.18r Blokada rozbijania patnoci z kwot VAT != 0
            sql = "SELECT platnosc_id, konto_id, COALESCE(kontrahent_id,'') AS kontrahent_id, stan, nr_faktury, kwota_oryg, kwota_platnosci, kwota_vat, "
            sql+=" COALESCE(CAST(op_wpr AS TEXT),'') AS op_wpr, COALESCE(CAST(op_zatw AS TEXT),'') as op_zatw,"
            sql+=" konto_fk, stan "
            sql+=" FROM rs_platnosci WHERE platnosc_id="+str(Platnosc)+" ; "

        stat,daneR,wyn1,dump = self.PolSQL.Execute(sql ,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z patnosci: '+stat
        elif len(daneR) == 0:
            stat = 'Brak patnoci o podanym numerze.'
        else:
            DaneR = rssql.RSTableRowset(daneR,wyn1)
            if DaneR.GetVal(0,"stan") == 'U':
                stat = 'Nie mona rozbija patnoci w stanie U.'
        #AB 21.06.18r Blokada rozbijania patnoci z kwot VAT != 0
            if int(DaneR.GetVal(0,"kwota_vat")) != 0:
                stat = 'Nie mona rozbija patnoci o kwocie VAT rnej ni 0'

    if stat == 'OK':
        if Ktory =="Pracownik":
            KontrR=DaneR.GetVal(0,"pracownik_id")
            NrFaktR=DaneR.GetVal(0,"numer_listy_id")
        else:
            KontrR=DaneR.GetVal(0,"kontrahent_id")
            NrFaktR=DaneR.GetVal(0,"nr_faktury")
        PlatnoscIdR=DaneR.GetVal(0,"platnosc_id")
        KontoIdR=DaneR.GetVal(0,"konto_id")
        StanR=DaneR.GetVal(0,"stan")
        KwotaOrygR=DaneR.GetVal(0,"kwota_oryg")
        KwotaPlR=DaneR.GetVal(0,"kwota_platnosci")
        OpWpR=DaneR.GetVal(0,"op_wpr")
        OpZtR=DaneR.GetVal(0,"op_zatw")
        if OpWpR<>'':
            OpWprR=str(OpWpR)
        else:
            OpWprR='NULL'

        if OpZtR<>'':
            OpZatwR=str(OpZtR)
        else:
            OpZatwR='NULL'

        if KontrR<>'':
            KontrR="'"+KontrR+"'"
        else:
            KontrR='NULL'

        KontoFK=DaneR.GetVal(0,"konto_fk")
        if KontoFK in (None,'None'):
            KontoFK='NULL'
        else:
            KontoFK="'"+KontoFK+"'"

        NKwotaPlR=KwotaPlR - PozostawKwotaBiez

        sql = "INSERT INTO rs_platnosci"

        if Ktory =="Pracownik":
            PolaN="platnosc_pierw, firma_id, konto_id, pracownik_id, stan, numer_listy_id, termin_plat, kwota_oryg, kwota_platnosci, "
        else:
            PolaN="platnosc_pierw, firma_id, konto_id, kontrahent_id, stan, nr_faktury, termin_plat, kwota_oryg, kwota_platnosci, "
        PolaN+=" uregulowano, op_ed,op_wpr,op_zatw,konto_fk"
        WartosciN = str(PlatnoscIdR)+", '"+self.firma_id+"','"+KontoIdR+"', "+KontrR+", '"+StanR+"' "
        WartosciN += ", '"+NrFaktR+"', '"+NowyTermPlat+"', "+str(KwotaOrygR)+", "+str(NKwotaPlR)+", 0, "
        WartosciN+=str(self.operator_id)+", "+OpWprR+", "+OpZatwR+", "+KontoFK
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat!='OK':
            stat='BL ROZB INS'
            dane.append(stat)
        #update pozostaej kwoty w patnoci rozbijanej
        if stat=='OK':
            Filtr="WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(PlatnoscIdR)+" ; "
            sql="UPDATE rs_platnosci SET kwota_platnosci="+str(PozostawKwotaBiez)+", op_ed="+str(self.operator_id)+" "+Filtr
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                stat='BL ROZB UPD'
                dane.append(stat)

#-------------------------------------------------------------------------------
# -- grupowa zmiana konta #
#-------------------------------------------------------------------------------

if Funkcja == 10:
    if not UprEdy:
        stat='UPR EDY'
        dane.append(stat)
    if stat=='OK':
        #WS 2019-12-20
        # NoweKonto=Platnosc[-1]
        # Platnosci=Platnosc[:-1]

        stat,daneK,wyn1,dump=self.PolSQL.Execute("SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id = '"+str(NoweKonto)+"' ;",3)
        if stat<>'OK':
            stat='BL SQL KONTO'
            dane.append(stat)
        else:
            if len(daneK)==0:
                stat='BL KONTO'
                dane.append(stat)
    if stat=='OK':
        Platn='('
        #WS 2019-12-20
        for w in ListaPlatnosci:
        # for w in Platnosci:
            Platn+="'"+str(w)+"',"
        Platn=Platn[:-1]
        Platn=Platn+')'

        Filtr="WHERE firma_id='"+self.firma_id+"' AND platnosc_id in "+str(Platn)+" ; "
        sql="UPDATE rs_platnosci SET konto_id='"+str(NoweKonto)+"', op_ed="+str(self.operator_id)+" "+Filtr
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL NEW KONTO UPD'
            dane.append(stat)

#-------------------------------------------------------------------------------
# -- przegladanie 5 #
#-------------------------------------------------------------------------------

if (Funkcja in [2,5,6,7,8,9,10,17]) and stat=='OK':
    Filtr = "( p.firma_id = '" + self.firma_id+"'"
    if KontoId <> '':
        Filtr+=" AND p.konto_id LIKE '" + KontoId+ "%'"
    if Ktory=="Kontrahent":
        Filtr+=" AND p.kontrahent_id IS NOT NULL "
        if Kontrahent <>'':
            Filtr+=" AND p.kontrahent_id LIKE '" + Kontrahent + "%' "
    if Ktory=="Pracownik":
        Filtr+=" AND p.pracownik_id IS NOT NULL "
        if NrListy.strip() <>'':
            Filtr+=" AND p.numer_listy_id LIKE '" + NrListy + "%'"
        if Pracownik <>'':
            Filtr+=" AND p.pracownik_id LIKE '" + Pracownik + "%'"
    if Stan <> '':
        Filtr+=" AND p.stan = UPPER('"+Stan+"')"
    if DataOd <> '    -  -  ':
        Filtr+=" AND p.termin_plat >= '" + DataOd + "'"
    if DataDo <> '    -  -  ':
        Filtr+=" AND p.termin_plat <= '" + DataDo + "'"
    if DataZapl <> '    -  -  ':
        Filtr+=" AND p.data_zapl= '"+ DataZapl + "'"
    if not Hist:
        Filtr+=" AND p.stan<>'Z' AND p.stan<>'U'"
    if DataPli <> '    -  -  ':
        Filtr+=" AND p.data_pli= '"+ DataPli + "'"
    Filtr+=" ) "
    if self.NowaPlatnoscId<>'x':
        Filtr+=" OR p.platnosc_id ="+str(self.NowaPlatnoscId)
    #pobranie danych
    if Ktory =="Pracownik":
        SQL="SELECT p.stan,p.konto_id, p.termin_plat, p.pracownik_id ||' - '|| k.nazwisko || ' ' || k.imie,COALESCE(p.numer_listy_id,''),"
        #AB 21.06.18r dodanie kwoty vat
        SQL+=" p.kwota_platnosci, p.kwota_oryg, p.kwota_vat, p.uregulowano, COALESCE(CAST(p.data_zapl AS TEXT),''),"
        SQL+=" COALESCE(CAST(p.data_pli AS TEXT),''), COALESCE(konto_fk,''), p.platnosc_id "
        SQL+=" FROM rs_platnosci p LEFT OUTER JOIN rs_kp_dane_osobowe k ON (p.pracownik_id=k.pracownik_id AND p.firma_id=k.firma_id)"
        SQL+=" WHERE "+Filtr
        SQL+=" ORDER BY p.termin_plat,COALESCE(p.numer_listy_id,'');"
    else:
        SQL="SELECT p.stan,p.konto_id, p.termin_plat, p.kontrahent_id ||' - '|| k.nazwa,COALESCE(p.nr_faktury,''),"
        #AB 21.06.18r dodanie kwoty vat
        SQL+=" p.kwota_platnosci, p.kwota_oryg, p.kwota_vat, p.uregulowano, COALESCE(CAST(p.data_zapl AS TEXT),''),"
        SQL+=" COALESCE(CAST(p.data_pli AS TEXT),''), COALESCE(konto_fk,''), p.platnosc_id "
        SQL+=" FROM rs_platnosci p LEFT OUTER JOIN rs_kontrahenci k ON (p.kontrahent_id=k.kontrahent_id AND p.firma_id=k.firma_id)" 
        SQL+=" WHERE "+Filtr
        SQL+=" ORDER BY p.termin_plat,COALESCE(p.nr_faktury,'');"

    stat,dane,wyn1,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
    if stat!="OK":
        stat="BL_SQL"
        dane.append(stat)