# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_platnosci_pliki_pli.py
# Purpose:      
# Author:      Jan Raburski
# Created:     2008/12/16
# RCS-ID:      $Id: fs_platnosci_pliki_pli.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2018-06-28 Jan Raburski pobieranie nip i kwoty_vat dla MPP
# 2019-10-20 Jan Raburski dodanie pobierania danych dla pracownikow
# 2019-11-30 (11753) Jan Raburski sprawdzanie kont kontrahentow z biala lista
# 2022-08-26 (13134) Aleksander Bargie  Bd sprawdzania certyfikatu przy sprawdzaniu biaej listy przy tworzeniu pliku pli
import datetime
import re
from time import sleep

#klucze= Lista platnosc_id, CzyPracownicy
import const

Lista         = klucze[0]
CzyPracownicy = klucze[1]
ssl           = klucze[2]  #AB 26.08.22r
biala_lista   = klucze[3]  #AB 26.08.22r

stat = "OK"
dane = []
#sprawdzenie uprawnie:
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprZam = True
    else:
        UprZam = ((self.oddzial_id,'076706') in self.uprawnienia)
if stat=='OK':
    if not UprZam:
        stat=u'Brak uprawnie do zamykania patnoci'
        dane.append(stat)
    elif CzyPracownicy:
        Lista = str(Lista).replace('[', '(').replace(']', ')')
        SQL = "SELECT CAST(current_date AS TEXT) as data, p.konto_id, p.pracownik_id, ROUND(p.kwota_platnosci,2) as kwota, "   #0-3
        SQL += " COALESCE(p.numer_listy_id,'') || '-' || TRIM(COALESCE(p.nr_faktury,'')), k.konto, o.nazwa, o.adr_kod, o.adr_poczta, o.adr_miej, o.adr_ulica, o.adr_nry, "  # 4-11
        #SQL += "TRIM(do.imie) || ' ' || TRIM(do.nazwisko), kt.adr_kod, kt.adr_poczta, kt.adr_miej, kt.adr_ulica, kt.adr_nry, COALESCE(kt.bank_konto,''), "
        SQL += " TRIM(dos.imie) || ' ' || TRIM(dos.nazwisko), '', '', '', '', '', COALESCE(ror.numer_rachunku,''), "  #12-18
        #SQL += " p.platnosc_id, dos.pracownik_id, kt.bank_nazwa, kt.fax, k.pli_folder, k.pli_typ, dos.nip, 0 "
        SQL += " p.platnosc_id, dos.pracownik_id, '', '', k.pli_folder, k.pli_typ, dos.nip, 0, ror.procent, "  # 19-27
        #SQL += " COALESCE(ang.lista_id,'BRAK')=lp.lista_id as czy_glowna_lista "  #28
        SQL += " False as czy_glowna_lista "  #28     JR 12696
        SQL += " FROM rs_kp_dane_osobowe_ror ror "
        SQL += " INNER JOIN rs_platnosci p ON (p.firma_id=ror.firma_id AND p.pracownik_id=ror.pracownik_id)"
        SQL += " LEFT OUTER JOIN rs_konta_bankowe k ON (p.firma_id=k.firma_id AND p.konto_id=k.konto_id) "
        SQL += " LEFT OUTER JOIN rs_oddzialy o ON (p.firma_id=o.firma_id and o.oddzial_id='" + self.oddzial_id + "') "
        SQL += " LEFT OUTER JOIN rs_kp_dane_osobowe dos  ON (p.firma_id=dos.firma_id AND p.pracownik_id=dos.pracownik_id) "
        #SQL += "INNER JOIN rs_kp_dane_osobowe_ror ror  ON (p.firma_id=ror.firma_id AND p.pracownik_id=ror.pracownik_id) "
        SQL += " LEFT OUTER JOIN rs_kp_listy_plac lp  ON (lp.firma_id=ror.firma_id AND lp.numer_listy_id=TRIM(p.numer_listy_id)) "
        #JR 12696 SQL += " LEFT OUTER JOIN rs_kp_angaze ang  ON (ang.firma_id=ror.firma_id AND ang.pracownik_id=p.pracownik_id AND  ang.lista_id=lp.lista_id) "
        SQL += " WHERE ror.procent>0 AND ror.firma_id='" + self.firma_id + "' AND p.platnosc_id in " + str(Lista) + " "
        SQL += " ORDER BY p.konto_id, p.numer_listy_id, p.pracownik_id, ror.procent desc;"
        rsglobal.ZapiszDoLogow('platnosci:'+SQL)
        stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = u'Bd pobierania danych do wykonania plikw pli:' + str(stat)
            dane = [[stat]]
    else:
        Lista=str(Lista).replace('[','(').replace(']',')')
        SQL="SELECT CAST(current_date AS TEXT) as data, p.konto_id, p.kontrahent_id, ROUND(p.kwota_platnosci,2) as kwota, " # 0-3
        SQL+="p.nr_faktury, k.konto, o.nazwa, o.adr_kod, o.adr_poczta, o.adr_miej, o.adr_ulica, o.adr_nry, "  # 4-11
        SQL+="kt.nazwa, kt.adr_kod, kt.adr_poczta, kt.adr_miej, kt.adr_ulica, kt.adr_nry, COALESCE(kt.bank_konto,''), " # 12-18
        SQL+=" p.platnosc_id, kt.kontrahent_id, kt.bank_nazwa, kt.dostawca, k.pli_folder, k.pli_typ, kt.nip, p.kwota_vat, " # 19-26
        SQL+=" kt.nie_sprawdzac_bialej_listy " # 27
        SQL+="FROM rs_platnosci p "
        SQL+="LEFT OUTER JOIN rs_konta_bankowe k ON (p.firma_id=k.firma_id AND p.konto_id=k.konto_id) "
        SQL+="LEFT OUTER JOIN rs_oddzialy o ON (p.firma_id=o.firma_id and o.oddzial_id='"+self.oddzial_id+"') "
        SQL+="LEFT OUTER JOIN rs_kontrahenci kt  ON (p.firma_id=kt.firma_id AND p.kontrahent_id=kt.kontrahent_id) "
        # JR SQL+="WHERE p.firma_id='"+self.firma_id+"' AND p.platnosc_id in "+str(Lista)+" AND p.kwota_vat>=0 "
        SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.platnosc_id in "+str(Lista)
        SQL+=" ORDER BY p.konto_id, p.kontrahent_id, p.kwota_vat ;"
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat!='OK':
            stat=u'Bd pobierania danych do wykonania plikw pli:'+str(stat)
            dane.append(stat)
        if stat == 'OK':
            SQL = "SELECT sprawdzac_biala_liste FROM rs_firmy WHERE firma_id='" + self.firma_id + "'"
            stat, biala, dump, dump = self.PolSQL.Execute(SQL,3)
            if stat != 'OK':
                stat = u'Bd pobierania danych z defnicji firmy:' + str(stat)
                dane.append(stat)
            else:
                if biala[0][0] and biala_lista:  #AB 26.08.22r
                    # sprawdzanie czy konta sa na bialej liscie
                    for d in dane:
                        if (not d[22]) or d[27]:
                            d.append("OK")
                        else:
                            # tylko dostaawcow sprawdzamy, inne przelewy nie
                            nip = re.sub('[^0-9]', '', d[25])
                            konto = re.sub('[^0-9]', '', d[18])
                            wyn = rsglobal.SprNip(nip)
                            if wyn == 'BL_NIP_DLUG':
                                d.append('NIP ma dugo inn ni 10 znakw')
                            elif wyn == 'BL_NIP_CRC':
                                d.append('NIP jest niepoprawny')
                            else:
                                wyn = rsglobal.SprIBAN(konto)
                                if wyn == 'BL_IBAN_DLUG':
                                    d.append('numer konta ma dugo inn ni 26 znakw')
                                elif wyn == 'BL_IBAN_CRC':
                                    d.append("numer konta jest niepoprawny")
                            if wyn == 'OK':
                                sleep(0.1)
                                if ssl:
                                    wyn = rsglobal.SprawdzNaBialejLiscie(konto, nip, verbose=True, liczba_prob=5, verify=ssl, self_fun=self)  #AB 26.08.22r
                                else:
                                    wyn = rsglobal.SprawdzNaBialejLiscie(konto, nip, verbose=True, liczba_prob=5, verify=ssl)  #AB 26.08.22r
                                if wyn[0] is None:
                                    if isinstance(wyn[1], basestring) and wyn[1].startswith("Otrzymano kod odpowiedzi: "):  #AB 26.08.22r
                                        stat = "Podczas sprawdzania biaej listy wystapi bd. {}".format(wyn[1])
                                        break
                                    d.append("bd sprawdzania biaej listy: {}".format(wyn[1]))
                                elif wyn[0] is False:
                                    d.append("pary NIP - numer konta nie odnaleziono na licie, id potwierdzenia: {}".format(wyn[1]))
                                elif wyn[0] == 'SSL':  #AB 26.08.22r
                                    stat = wyn[1]
                                    break
                                else:
                                    d.append("OK")
                    if not ssl:
                        komunikat = "Utworzono pliki PLI bez weryfikacji poprawnoci certyfikatu SSL API"
                        tresc = """{}
                        Firma {}
                        Operator {} 
                        Czas {}""".format(komunikat, self.firma_id, self.operator_id, str(datetime.datetime.now())[:-7])
                        rsglobal.RSWyslijEmail(const.MAIL_SERWISOWY, komunikat, tresc, [], 0, self.PolSQL)
                elif biala[0][0] and not biala_lista:
                    komunikat = "Utworzono pliki PLI bez weryfikacji biaej listy"
                    tresc = """{}
                    Firma {}
                    Operator {} 
                    Czas {}""".format(komunikat, self.firma_id, self.operator_id, str(datetime.datetime.now())[:-7])
                    rsglobal.RSWyslijEmail(const.MAIL_SERWISOWY, komunikat, tresc, [], 0, self.PolSQL)

