# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pliki_office_pom.py
# Purpose:     funkcje pomocnicze do obslugi plikow pakietu office
# Author:      Mariusz Rajfura
# Created:     2013/10/24
# RCS-ID:      $Id: fs_pliki_office_pom.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-03-29, Aleksander Bargie 10961 - przygotowanie do wczytania pliku .xlsx w nowszych wersjach openpyxxl


def OdczytajTrescXLS(TrescPlikuXLS, dehexlify=False):
    # funkcja tworzy slownik z danymi arkuszy w formie tabeli z przeslanej tresci pliku xls(xlsx)
    # slownik jako klucze zawiera nazwy arkuszy, do ktorych sa przypisane dane w formie tabeli,
    # a takze klucz z nazwa pierwszego arkusza

    import binascii
    import openpyxl
    import rsglobal
    import os.path
    import os
    import tempfile

    # AB 29.03.18r Dodanie informacji o wersji biblioteki
    pyxlver = [int(x) for x in openpyxl.__version__.split('.')]
    dane = {}
    stat = 'OK'

    try:
        if dehexlify:
            TrescPlikuXLS = binascii.unhexlify(TrescPlikuXLS)
        
        tempdir = tempfile.mkdtemp(prefix='impxls')
        NazwaPlikuRoboczego = 'ymport'
        SciezkaPlikuRoboczego = os.path.join(tempdir, NazwaPlikuRoboczego)

        plik = open(SciezkaPlikuRoboczego, "wb")
        plik.write(TrescPlikuXLS)
        plik.close()
        #AB 29.03.18r rna funkcja zalenie od wersji openpyxl
        if pyxlver[0] > 2 or (pyxlver[1] == 2 and pyxlver[1] >= 4):
            workbook = openpyxl.load_workbook(SciezkaPlikuRoboczego, use_iterators=True)
        else:
            workbook = openpyxl.load_workbook(SciezkaPlikuRoboczego, read_only=True)
        
        worksheets = workbook.get_sheet_names()
        
        firstsheet = ''
        
        for sheetname in worksheets:
            zeszyt = []
            
            sheet = workbook.get_sheet_by_name(sheetname)
            
            if firstsheet == '':
                firstsheet = sheetname
            
            for r in sheet.iter_rows():
                wiersz = []
                for c in r:
                    wiersz.append(c.internal_value)

                zeszyt.append(wiersz)
            
            dane[sheetname] = zeszyt
            
        if firstsheet <> '':
            dane['__PierwszyArkusz__'] = firstsheet

        os.remove(SciezkaPlikuRoboczego)
        os.rmdir(tempdir)

    except Exception,e:
        stat = 'Bd odczytu arkusza XLS : '+str(e)
        rsglobal.ZapiszDoLogow(stat,1)

    return stat,dane

#-------------------------------------------------------------------------------
