#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_pos.py
# Purpose:		centralne okno moduu POS pozwalajce na wprowadzanie pozycji paragonu
# Author:		Michal Raburski
# Created:		2013/02/25
# RCS-ID:		$Id: fs_pos.py $
# Copyright:	(c) 2013 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------

# FUNKCJE
# 5- pobranie kontrahenta
# 11 - pobranie danych podstawowych artykuw
# 12 - pobranie cen kontrahenta (te 5)
# 14 - utworzenie paragonu fiskalnego z danych z grida
# 16 - usunicie paragonu powstaego z grida bo le si zamkn

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Drukarka':[5,14], 'Kontrahent':[12,14],'Pozycje':[14], 'Paragon':[16]}    
    SlPar={}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_pos z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja == 5:
        Drukarka = rsglobal.Dekoduj(klucze['Drukarka'])
        
    if Funkcja == 12:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])
        
    if Funkcja == 14:
        Drukarka = rsglobal.Dekoduj(klucze['Drukarka'])
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])
        Pozycje = klucze['Pozycje']
        
    if Funkcja == 16:
        Paragon=klucze['Paragon']
        Kasa=Paragon[0]
        Data=Paragon[1]
        Numer=str(Paragon[2])
        
UprDodawaniePar = (((self.oddzial_id,'025013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZamykaniePar = (((self.oddzial_id,'025016') in self.uprawnienia) or UprDodawaniePar or (self.operator_id == STANDARD_OPERATOR_ID))
UprDodawaniePoz = (((self.oddzial_id,'025023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwaniePoz  = (((self.oddzial_id,'025024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprKontrahenci  = (((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDrukarki     = (((self.oddzial_id,'014060') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#-------  POBRANIE KONTRAHENTA DOMYLNEGO NA PODSTAWIE DRUKARKI FISKALNEJ (5)
#-------------------------------------------------------------------------------

if Funkcja == 5 and stat == "OK":
    SQL="SELECT COALESCE(kontrahent_domyslny,'') FROM rs_kasy_fiskalne WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND kasa_id='"+Drukarka+"';"
    stat,DaneK,dump,dump = self.PolSQL.Execute(SQL,3,None,None,True)
    if stat<>'OK':
        stat='Bdy pobierania domylnego kontrahenta : '+stat
    
    if stat=='OK':
        if len(DaneK)==0:
            stat='Podana drukarka ma nieprawidowy symbol lub jest przypisana do oddziau innego ni zalogowany'
    
    if stat=='OK':
        Kontrahent=DaneK[0][0]    

#-------------------------------------------------------------------------------
#-------  POBRANIE ARTYKUW DO WYKORZYSTANIA (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == "OK":
    # na podstawie kontrahenta pobieramy jego ceny dla artykuw (z uwzgldnieniem wersji cenowej, upustw, cen specjalnych itp)
    
    if stat=='OK':
        Dzis=rsglobal.PodajDzis()
        
        # pobranie artykuu, nazwy, cen, vatu oraz kodw EAN
        SQL ="SELECT TRIM(a.artykul_id),a.nazwa,"
        SQL+=" rsf_podaj_vat_artykulu(a.firma_id,a.artykul_id,'"+Dzis+"'),TRIM(COALESCE(ae.ean,''))"
        SQL+=" FROM rs_artykuly a LEFT OUTER JOIN rs_artykuly_ean ae USING (firma_id,artykul_id)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.aktywny AND a.typ_artykulu IN ('01','02','03');"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3,None,None,True)
        if stat <> 'OK':
            stat = 'Bd przy pobieraniu danych artykuw : '+stat

#-------------------------------------------------------------------------------
#-------  POBRANIE CEN ARTYKUW DLA KONTRAHENTA (5,11)
#-------------------------------------------------------------------------------
        
if Funkcja in (5, 12) and stat == "OK":
    # na podstawie kontrahenta pobieramy jego ceny dla artykuw (z uwzgldnieniem wersji cenowej, upustw, cen specjalnych itp)
    
    Dzis=rsglobal.PodajDzis()
    
    # pobranie artykuu, nazwy, cen, vatu oraz kodw EAN
    SQL ="SELECT TRIM(a.artykul_id),CASE WHEN '"+Kontrahent+"'='' THEN '[0,0,0,0,0,0,0,0,0]' "
    SQL+=" ELSE rsf_podaj_ceny_dla_kontrahenta(a.firma_id,'"+Kontrahent+"','PLN','"+Dzis+"',a.artykul_id,'',-1) END"
    SQL+=" FROM rs_artykuly a "
    SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.aktywny AND a.typ_artykulu IN ('01','02','03');"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3,None,None,True)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu cen artykuw dla kontrahenta : '+stat
        
    wyn2=[Kontrahent]
    
#-------------------------------------------------------------------------------
#-------  UTWORZENIE PARAGONU (14)
#-------------------------------------------------------------------------------

if Funkcja == 14 and stat == "OK":
    rsglobal.ZapiszDoLogow('Pozycje '+str(Pozycje),1)
    # sprawdzenie czy s pozycje do wstawienia
    if len(Pozycje)==0:
        stat='Brak pozycji do wstawienia na paragon'
        
    # sprawdzenie czy istniej niezamknite paragony dla kasy
    if stat=='OK':
        SQL="SELECT * FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kasa_id='"+Drukarka+"' AND stan='W';"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest)>0:
                stat="Istniej otwarte paragony dla kasy, utworzenie nowego paragonu niemoliwe"

    # sprawdzenie istnienia kasy fiskalnej
    if stat=='OK':
        SQL="SELECT kasa_id FROM rs_kasy_fiskalne WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        SQL+=" AND kasa_id='"+Drukarka+"';"
        stat,JestKasa,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat=='OK' and len(JestKasa)==0:
            stat="Brak podanej kasy fiskalnej"

    
    # pobranie daty i numeru paragonu
    if stat=='OK':
        Data=rsglobal.PodajDzis()
        SQL="SELECT MAX(numer) FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        SQL+=" AND kasa_id='"+Drukarka+"' AND data='"+Data+"';"
        stat,NrMax,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(NrMax)==0:
                Nr=1
            else:
                Nr=NrMax[0][0]+1

    # pobranie wersji sprzeday w oparciu o kontahenta
    Wersja='NULL'
    if stat=='OK' and Kontrahent<>'':
        SQL="SELECT rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"','"+Kontrahent+"','"+Data+"','wersja')"
        stat,DaneK,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DaneK)>0:
                if not DaneK[0][0] in ('None',''):
                    Wersja="'"+DaneK[0][0]+"'"
    
    # ustawienie kontrahenta
    if Kontrahent=='':
        Kontr='NULL'
    else:
        Kontr="'"+Kontrahent+"'"
        
    # wstawienie nagwka paragonu
    SQL="INSERT INTO rs_paragony_fiskalne ("
    SQL+=" firma_id,oddzial_id,data,numer,stan,do_zaplaty,kasa_id,wersja,kontrahent_id) "
    SQL+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Data+"','"+str(Nr)+"','W',0,"
    SQL+="'"+Drukarka+"',"+Wersja+","+Kontr+");"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
    if stat=='OK':
        dane.append([self.oddzial_id,Drukarka,Data,Nr])
            
    # wstawienie pozycji paragonu
    NrPoz=0
    for poz in Pozycje:
        if stat=='OK':
            Art=poz[1]
            if Art.strip()<>'':
                NrPoz+=1
                Przelicznik="(SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"')"
                CenaB1=str(poz[3])
                CenaB2=" ROUND("+CenaB1+'*'+Przelicznik+",2) "
                Ilosc1=str(poz[4])
                Ilosc2=" ROUND("+Ilosc1+'*'+Przelicznik+",2) "
                VAT=" rsf_podaj_vat_artykulu('"+self.firma_id+"','"+Art+"','"+Data+"') "
                VATL=" CASE WHEN "+VAT+" IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE "+VAT+"::INT END "
                CenaN1="ROUND("+CenaB1+"*100/(100+"+VATL+"),2)"
                CenaN2=" ROUND("+CenaN1+'*'+Przelicznik+",2) "
                WartoscN=" ROUND("+CenaN1+"*"+Ilosc1+",2)"
                WartoscB=" ROUND("+CenaB1+"*"+Ilosc1+",2)"
                WartoscV=WartoscB+" - "+WartoscN
                
                SQL="INSERT INTO rs_paragony_fiskalne_pozycje "
                SQL+="(firma_id,oddzial_id,kasa_id,data,numer,nr_poz,"
                SQL+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2,"
                SQL+="stawka_vat,wartosc_netto, wartosc_vat, wartosc_brutto) "
                SQL+=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','"+Drukarka+"','"+Data+"',"+str(Nr)+","+str(NrPoz)+","
                SQL+="'"+Art+"',"+Ilosc1+","+Ilosc2+","+CenaN1+","+CenaN2+","+CenaB1+","+CenaB2+","
                SQL+=VAT+","+WartoscN+","+WartoscV+","+WartoscB+");"
                rsglobal.ZapiszDoLogow('SQL '+SQL,1)
                stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
                if stat<>'OK':
                    stat="Bdy wstawiania pozycji paragonu :"+stat 

#-------------------------------------------------------------------------------
#-------  USUNIIE PARAGONU PO NIEUDANYM ZAMYKANIU (16)
#-------------------------------------------------------------------------------

    
if Funkcja == 16 and stat == "OK":
    SQL ="SELECT stan FROM rs_paragony_fiskalne"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
    stat,stan,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Paragon fiskalny zablokowany przez innego operatora. Operacja usunicia niemoliwa.'
    elif len(stan)==0:
        stat='Brak paragonu do usunicia'
    elif stan[0][0]<>'W':
        stat='Aby usun paragon musi by on w stanie W'
    
    if stat=='OK':
        SQL ="DELETE FROM rs_paragony_fiskalne"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        SQL+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)