# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_procesy.py
# Purpose:     produkcja/kartoteka procesow - grid: zmiana,klucza,usuw,przegl,wybor,pobr.opisu
#
# Author:      Mariusz Rajfura
# Created:     2009/10/22
# RCS-ID:      $Id: fs_procesy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Marcin Natkaski 2014-05-27 - (7710) dodanie do grida kolumny "nieobecno"
# 2020-10-06 Mikoaj Kozowski  (12095) Refaktoryzacja - przejcie na sowniki
# 2021-10-26 Aleksander Bargie  (12686) Poprawi wywietlane opisu procesu w danych pozycji procesu(produkcja)

# Proces = rsglobal.Dekoduj(klucze[0]).strip()
# ProcesN = rsglobal.Dekoduj(klucze[1]).strip()
#
# ProcesF = rsglobal.Dekoduj(klucze[2][0]).strip()
# NazwaF = rsglobal.Dekoduj(klucze[2][1]).strip()
#
# Klucze_Id = klucze[3]
#
# Fun = klucze[-1]
# stat = 'OK'
# dane = []
# wyn1 = []

stat = "OK"
#MK 2020-10-26 - pocztek

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']
    SlPar = {'Proces':[6,7,9], 'ProcesN':[7], 'ProcesF':[5,6,7], 'NazwaF':[5,6,7], 'Klucze_Id':[5,6,7],}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_procesy z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [6,7,9]:
        Proces = rsglobal.Dekoduj(klucze['Proces'])
    if Fun in [7]:
        ProcesN = rsglobal.Dekoduj(klucze['ProcesN'])
    if Fun in [5,6,7]:
        ProcesF = rsglobal.Dekoduj(klucze['ProcesF'])
        NazwaF = rsglobal.Dekoduj(klucze['NazwaF'])
        Klucze_Id = rsglobal.Dekoduj(klucze['Klucze_Id'])

UprUsuwanie = ((self.oddzial_id,'047004') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprZmKlucza = ((self.oddzial_id,'047005') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
#-------------------------------------------------------------------------------
# Pobranie opisu procesu - 9
#-------------------------------------------------------------------------------

if Fun == 9:
    sql ="SELECT nazwa FROM rs_procesy"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+Proces+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(d)>0:
            dane.append(d[0][0].strip())
        else:
            dane.append('Bdny symbol procesu')  #AB 2021-10-27
    else:
        dane.append('Bd pobrania opisu procesu')

#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania procesw'

    if stat == 'OK':
        sql ="SELECT proces_id FROM rs_procesy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+Proces+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o procesie : '+stat
        elif len(d) == 0:
            stat = 'Proces o podanym numerze nie istnieje.'

    if stat == 'OK':
        DELETE ="DELETE FROM rs_procesy"
        DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+Proces+"';"

        stat,d,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat = 'Proces uywany w innych kartotekach. Usunicie niemoliwe.'

#-------------------------------------------------------------------------------
# ZMIANA KLUCZA - 7
#-------------------------------------------------------------------------------

if Fun == 7:
    if not UprZmKlucza:
        stat = 'Brak uprawnie do zmiany klucza procesu'

    if stat == 'OK':
        sql ="SELECT proces_id FROM rs_procesy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+Proces+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o procesie : '+stat
        elif len(d) == 0:
            stat = 'Proces o podanym numerze nie istnieje.'

    if stat == 'OK':
        sql ="SELECT proces_id FROM rs_procesy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+ProcesN+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o procesie : '+stat
        elif len(d) > 0:
            stat = 'Proces o podanym numerze ju istnieje.'

    if stat == 'OK':
        UPDATE ="UPDATE rs_procesy SET proces_id = '"+ProcesN+"'"
        UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+Proces+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(UPDATE, 1)
        if stat <> 'OK':
            stat = 'Bd zmiany klucza procesu : '+stat

#-------------------------------------------------------------------------------
# SELECT 5,6,7
#-------------------------------------------------------------------------------

if Fun in (5,6,7) and stat == 'OK':
    FILTR = "(firma_id = '"+self.firma_id+"'"
    if ProcesF <> '':
        FILTR += " AND proces_id LIKE '"+ProcesF+"%'"
    if NazwaF <> '':
        FILTR += " AND nazwa LIKE '"+NazwaF+"%'"
    FILTR += ")"
    
    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (firma_id = '"+self.firma_id+"' AND proces_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i][0])+"'"
        FILTR += "))"
    
    SELECT ="SELECT proces_id,nazwa,nieobecnosc FROM rs_procesy WHERE "+FILTR+" ORDER BY proces_id;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy procesw : '+stat
