# -*- coding: iso8859_2 -*-
#------------------------------------------------------------------------------------
# Name:        fs_procesy_artykuly_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji procesow
# Author:      Dariusz Boduch, 
# Created:     2009/11/30
# RCS-ID:      $Id:$
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#------------------------------------------------------------------------------------
# 2013-03-04 Mariusz Rajfura (6633) edycja kontrolek zalezna od artykul->czy_produkcja_ciagla
# 2017-03-28 Piotr Witkowski (10385) Refaktoryzacja receptury

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Proces':[1,2,3,4,5,],'Artykul':[1,2,3,4,5,10],'Urzadzenie':[1,2,3,4,5,],
           'ProcesP':[1,2,3,4,],'ArtykulP':[1,2,3,4,],'UrzadzenieP':[1,2,3,4,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_procesy_artykuly_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,2,3,4,5,10]:
        Artykul = klucze['Artykul']
    if Funkcja in [1,2,3,4,5,]:
        Proces = klucze['Proces']
        Urzadzenie = klucze['Urzadzenie']
    if Funkcja in [1,2,3,4,]:
        ProcesP = klucze['ProcesP']
        ArtykulP = klucze['ArtykulP']
        UrzadzenieP = klucze['UrzadzenieP']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    ProcesN = None
    ArtykulN = None
    UrzadzenieN = None

if stat=='OK' and Funkcja in [1,2,3,4,5,]:
    WHERE = " firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND proces_id='"+Proces+"'"
    WHERE+= " AND artykul_id='"+Artykul+"' AND urzadzenie_id='"+Urzadzenie+"'"

if stat=='OK' and Funkcja in [1,2,3,4,]:
#klucz dla poprzednich wartosci kluczy (przy modyfikacji)
    WHEREP = " firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND proces_id='"+ProcesP+"'"
    WHEREP+= " AND artykul_id='"+ArtykulP+"' AND urzadzenie_id='"+UrzadzenieP+"'"

    UprDodawanie = ((self.oddzial_id,'047013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    UprEdycja = ((self.oddzial_id,'047012') in self.uprawnienia) or UprDodawanie or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
# SPRAWDZENIE UPRAWNIE
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (1,2):
    if not UprDodawanie:
        stat = 'UPR INS'
        dane.append(stat)

if stat=='OK' and Funkcja in (3,4):
    if not UprEdycja:
        stat = 'UPR MOD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- Pobranie danych artykuu (10)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 10:
    sql ="SELECT COALESCE(nazwa,''),czy_produkcja_ciagla FROM rs_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych artykulu: '+stat

  
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

ZmianaCecha = None
ZmianaCzas = None

if stat=='OK' and Funkcja in (3,4):
    # jesli modyfikacja, to pobieramy dane zmiany procesu, a przy okazji blokujemy
    sql ="SELECT zmiana_cecha,zmiana_czas FROM rs_procesy_artykuly"
    sql+=" WHERE "+WHEREP+" FOR UPDATE NOWAIT;"

    stat,dBylo,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania modyfikowanej pozycji: '+stat
    elif len(dBylo) == 0:
        stat = 'Brak pozycji o podanym kluczu.'

if stat=='OK' and  Funkcja in (1,2,3,4):
    Kolejnosc = 0
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'proces_id':
            wart = wart.strip()
            ProcesN = wart
            wartosci[i] = "'"+wart+"'"
            if wart == '':
                stat = 'BR PROC'
                dane.append(stat)
            else:
                sql = "SELECT proces_id FROM rs_procesy WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND proces_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat <> 'OK':
                    stat = 'Bdy pobierania danych procesu: '+stat
                    dane.append(stat) 
                elif len(d) == 0:
                    stat = 'BL PROC'
                    dane.append(stat)

        elif pole == 'artykul_id':
            ArtykulN = wart
            wart = wart.strip()
            wartosci[i] = "'"+wart+"'"
            if wart == '':
                stat = 'BR ART'
                dane.append(stat)
            else:
                sql = "SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND artykul_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat <> 'OK':
                    stat = 'Bdy pobierania artykuu: '+stat
                    dane.append(stat) 
                elif len(d) == 0:
                    stat = 'BL ART'
                    dane.append(stat)
            
        elif pole == 'urzadzenie_id':
            UrzadzenieN = wart
            wart = wart.strip()
            wartosci[i] = "'"+wart+"'"
            if wart == '':
                stat = 'BL URZADZ'
                dane.append(stat)
            else:
                sql = "SELECT urzadzenie_id FROM rs_urzadzenia WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND urzadzenie_id = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat <> 'OK':
                    stat = 'Bdy pobierania urzdzenia: '+stat
                    dane.append(stat) 
                elif len(d) == 0:
                    stat = 'BL URZADZ'
                    dane.append(stat)

        # pole 'czas' kontrolowane na koncu

        elif pole == 'czas_nastepny':
            if wart < 0:
                stat = 'BL CZAS_NASTEPNY'
                dane.append(stat)

        elif pole == 'stanowisko_pocz':
            wart = wart.strip()
            wartosci[i] = "'"+wart+"'"
            if wart == '':
                stat = 'BR STPOCZ'
                dane.append(stat)
            else:
                sql = "SELECT kod FROM rs_stanowiska_pracy WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND kod = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat <> 'OK':
                    stat = 'Bdy pobierania stanowiska pocz: '+stat
                    dane.append(stat) 
                elif len(d) == 0:
                    stat = 'BL STPOCZ'
                    dane.append(stat)

        elif pole == 'stanowisko_koniec':
            wart = wart.strip()
            wartosci[i] = "'"+wart+"'"
            if wart == '':
                stat = 'BR STKONIEC'
                dane.append(stat)
            else:
                sql = "SELECT kod FROM rs_stanowiska_pracy WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND kod = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat <> 'OK':
                    stat = 'Bdy pobierania stanowiska kocowego: '+stat
                    dane.append(stat) 
                elif len(d) == 0:
                    stat = 'BL STKONIEC'
                    dane.append(stat)
                    
        # pole 'maks_ilosc' kontrolowane na koncu

        elif pole == 'kolejnosc':
            Kolejnosc = wart
            if wart < 1:
                stat = 'BL KOLEJNOSC'
                dane.append(stat)

        elif pole == 'zmiana_cecha':
            wart = wart.strip()
            ZmianaCecha = wart
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                wartosci[i] = "'"+wart+"'"

        elif pole == 'zmiana_czas':
            wart = wart.strip()
            ZmianaCzas = wart
            if wart == ':':
                wartosci[i] = 'NULL'
            else:
                wartosci[i] = "'"+wart+":00'::TIME"
                stat,dump,dump,dump = self.PolSQL.Execute("SELECT "+wartosci[i]+";",2)
                if stat <> 'OK':
                    stat = 'BL ZMIANA CZAS'
                    dane.append(stat)
                else:
                    #jakas kontrola sensownosci zakresu czasu zmiany
                    sql ="SELECT "+wartosci[i]+">='00:01:00'::TIME AND "+wartosci[i]+"<='23:59:00'::TIME;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bdna operacja sprawdzenia zakresu czasu: '+stat
                        dane.append(stat)
                    elif not d[0][0]:
                        stat = 'BL ZMIANA CZAS ZAKRES'
                        dane.append(stat)


    #czy byly bledy
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
            
    if Funkcja in (1,2) and stat == 'OK' and ZmianaCecha <> '' and ZmianaCzas == ':':
        stat = 'BL ZMIANA WPISZ CZAS'
        dane.append(stat)

    if Funkcja in (1,2) and stat == 'OK' and ZmianaCecha == '' and ZmianaCzas <> ':':
        stat = 'BL ZMIANA WPISZ CECHA'
        dane.append(stat)
            
    if Funkcja in (3,4) and stat == 'OK' and (ZmianaCecha <> None or ZmianaCzas <> None):
        #jesli modyfikowano zmiana_cecha lub zmiana_czas
        if ZmianaCecha == None:
            #jesli nie modyfikowano cechy, pobieramy jej dotychczasowa wartosc
            ZmianaCecha = rsglobal.Dekoduj(dBylo[0][0]).strip()
            if ZmianaCecha == 'None':
                ZmianaCecha = ''
                
        if ZmianaCzas == None:
            #jesli nie modyfikowano czasu, pobieramy jego dotychczasowa wartosc
            ZmianaCzas = rsglobal.Dekoduj(dBylo[0][1]).strip()
            if ZmianaCzas == 'None':
                ZmianaCzas = ':'
    
    if Funkcja in (3,4) and stat == 'OK' and ZmianaCecha <> '' and ZmianaCzas == ':':
        stat = 'BL ZMIANA WPISZ CZAS'
        dane.append(stat)

    if Funkcja in (3,4) and stat == 'OK' and ZmianaCecha == '' and ZmianaCzas <> ':':
        stat = 'BL ZMIANA WPISZ CECHA'
        dane.append(stat)
      
    #w przypadku INSERT sprawdzam czy nie ma w bazie pozycji z kluczem proces, artykul,urzadzenie
    if Funkcja in (1,2) and stat=='OK':
        sql ="SELECT proces_id FROM rs_procesy_artykuly WHERE "+WHERE+";"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
        if stat <> 'OK':
            stat = 'Bdy sprawdzania klucza: '+stat
            dane.append(stat) 
        elif len(d) > 0:
            stat = 'KLUCZ ISTN'
            dane.append(stat)

    #sprawdzam czy przypadku aktualizacji pol kluczowych tj procesu/artykulu/urzadzenia taki klucz juz istnieje
    #zamiast zwracac niewiele mowiacy tekst 'Blad modyfikacji'
    #takie ceregiele wynikaja z tego, ze kolejnosc nie jest polem kluczowym, a musi byc unikalna
    if Funkcja in (3,4) and stat == 'OK' and (ProcesN <> None or ArtykulN <> None or UrzadzenieN <> None):
        sql ="SELECT proces_id FROM rs_procesy_artykuly WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' "
        if ProcesN <> None:
            sql+=" AND proces_id='"+ProcesN+"'"
        else:
            sql+=" AND proces_id='"+Proces+"'"

        if ArtykulN <> None:
            sql+=" AND artykul_id='"+ArtykulN+"'"
        else:
            sql+=" AND artykul_id='"+Artykul+"'"

        if UrzadzenieN <> None:
            sql+=" AND urzadzenie_id='"+UrzadzenieN+"'"
        else:
            sql+=" AND urzadzenie_id='"+Urzadzenie+"'"

        sql+=";"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
        if stat<>'OK':
            stat = 'Bd sprawdzania nowego klucza: '+stat
            dane.append(stat) 
        elif len(d) > 0:
            stat = 'KLUCZ ISTN'
            dane.append(stat)
            

#------------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (1,2 ):
    inspola = "firma_id,oddzial_id,proces_id,artykul_id,urzadzenie_id"
    inswart = "'"+self.firma_id+"','"+self.oddzial_id+"','"+Proces+"','"+Artykul+"','"+Urzadzenie+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ('proces_id','artykul_id','urzadzenie_id'): # te pola ignorujemy
            pass
        elif pole in ('stanowisko_pocz','stanowisko_koniec','zmiana_cecha','zmiana_czas'):
            inspola += ","+pole
            inswart += ","+wart
            
        elif pole in ('czas','maks_ilosc','kolejnosc','nastepny_proces','czas_nastepny'):
            inspola += ","+pole
            inswart += ","+str(wart)
        else:
            inspola += ","+pole
            inswart += ",'"+wart+"'"
            
    INSERT = "INSERT INTO rs_procesy_artykuly ("+inspola+") VALUES ("+inswart+");"        
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
    if stat <> 'OK':
        stat = 'Bd przy dodawaniu pozycji : '+stat   
        dane.append(stat)
    
                
#------------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (3,4):
    UPDATE = "UPDATE rs_procesy_artykuly SET "
    for i in range(len(pola)):
        wart = wartosci[i]
        pole = pola[i]
        if pole in ('proces_id','artykul_id','urzadzenie_id','stanowisko_pocz','stanowisko_koniec','zmiana_cecha','zmiana_czas'):
            UPDATE += pole+"="+wart+","
        elif pole in ('czas','maks_ilosc','kolejnosc','nastepny_proces','czas_nastepny'):
            UPDATE += pole+"="+str(wart)+","
        else:
            UPDATE += pole+"='"+str(wart)+"',"
    
    UPDATE = UPDATE[:-1]+" WHERE "+WHEREP+";"
    
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji pozycji : '+stat 
        dane.append(stat)


if stat == 'OK' and Funkcja in (1,2,3,4):
    # kontrola prawidlowosci wypelnienienia kontrolek
    # zalezna od innych danych
    
    sql ="SELECT pa.czas,pa.maks_ilosc,a.czy_produkcja_ciagla"
    sql+=" FROM rs_procesy_artykuly pa"
    sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    sql+=" WHERE pa.firma_id='"+self.firma_id+"' AND pa.oddzial_id='"+self.oddzial_id+"' AND pa.proces_id='"+Proces+"'"
    sql+=" AND pa.artykul_id='"+Artykul+"' AND pa.urzadzenie_id='"+Urzadzenie+"';"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych do kontroli: '+stat
    elif len(d) == 0:
        stat = 'Brak wpisu o podanym kluczu'
    else:
        bledy = []
        if d[0][2]:
            # jesli produkcja ciagla
            if d[0][0] <= 0:
                bledy.append('BL CZAS')
            
            if d[0][1] < 0:
                bledy.append('BL MAKSILOSC')
                
        else:
            if d[0][1] <= 0:
                bledy.append('BL WYDAJNOSC')
        
        if len(bledy) > 0:
            dane = bledy
            stat = dane[0]
        

#------------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (1,3,5):
    SELECT ="SELECT * FROM rs_procesy_artykuly"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SELECT+=" AND proces_id='"+Proces+"' AND artykul_id='"+Artykul+"' AND urzadzenie_id='"+Urzadzenie+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych: '+stat
        dane.append(stat)
    
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # [0] proces opis
        if ((self.oddzial_id,'047000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT nazwa FROM rs_procesy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND proces_id='"+tr.GetVal(0,"proces_id")+"';"
            st,d,dump,dump = self.PolSQL.Execute(sql,3)
            if st <> 'OK':
                wyn2.append('Bd pobrania opisu procesu: '+st)
            elif len(d) == 0:
                wyn2.append('Brak procesu o podanym kodzie')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do przegldania procesw. Poinformuj administratora.')
                
        # [1] artykul opis
        # [2] artykul czy_produkcja_ciagla
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT nazwa,czy_produkcja_ciagla FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            st,d,dump,dump = self.PolSQL.Execute(sql,3)
            if st <> 'OK':
                wyn2.append('Bd pobrania opisu artykuu: '+st)
                wyn2.append(False)
            elif len(d) == 0:
                wyn2.append('Brak artykuu o podanym kodzie')
                wyn2.append(False)
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
                wyn2.append(rsglobal.Dekoduj(d[0][1]))
        else:
            wyn2.append('Brak uprawnie do przegldania artykuw. Poinformuj administratora.')
            wyn2.append('Brak uprawnie do przegldania artykuw. Poinformuj administratora.')
    
        # [3] urzadzenie opis
        if ((self.oddzial_id,'029110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT nazwa FROM rs_urzadzenia"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+tr.GetVal(0,"urzadzenie_id")+"';"
            st,d,dump,dump = self.PolSQL.Execute(sql,3)
            if st <> 'OK':
                wyn2.append('Bd pobrania opisu urzdzenia: '+st)
            elif len(d) == 0:
                wyn2.append('Brak urzdzenia o podanym kodzie')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do przegldania urzdze. Poinformuj administratora.')
        
        # [4] stanowisko_pocz opis
        if ((self.oddzial_id,'011080') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_stanowiska_pracy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"stanowisko_pocz")+"';"
            st,d,dump,dump = self.PolSQL.Execute(sql,3)
            if st <> 'OK':
                wyn2.append('Bd pobrania opisu stanowiska: '+st)
            elif len(d) == 0:
                wyn2.append('Brak stanowiska o podanym kodzie')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do przegldania stanowisk. Poinformuj administratora.')
    
        # [5] stanowisko_koniec opis
        if ((self.oddzial_id,'011080') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT opis FROM rs_stanowiska_pracy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"stanowisko_koniec")+"';"
            st,d,dump,dump = self.PolSQL.Execute(sql,3)
            if st <> 'OK':
                wyn2.append('Bd pobrania opisu stanowiska: '+st)
            elif len(d) == 0:
                wyn2.append('Brak stanowiska o podanym kodzie')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do przegldania stanowisk. Poinformuj administratora.')
