# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_procesy_dane.py
# Purpose:     produkcja - edycja danych procesu
# Author:      Mariusz Rajfura
# Created:     2009/10/22
# RCS-ID:      $Id: fs_urzadzenia_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-04-29 Mariusz Rajfura (6825) nowe pole 'ean'

from funkcje import fs_pliki_global

Fun = klucze[-1]
if Fun==11:
    NazwaPliku=klucze[0]
    TrescPliku=klucze[1]
else:
    Proces = rsglobal.Dekoduj(klucze[0]).strip()

dane = []
wyn1 = []
wyn2 = []

stat = 'OK'

UprDodawanie = ((self.oddzial_id,'047003') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = ((self.oddzial_id,'047002') in self.uprawnienia or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   DODANIE OBRAZKA (11)
#-------------------------------------------------------------------------------

if Fun==11:
    if stat=='OK':
        SQL="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
        SQL+="('"+self.firma_id+"','"+NazwaPliku+"','rs_procesy',FALSE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat=='OK':
            SQL="SELECT max(plik_id) FROM rs_pliki WHERE firma_id='"+self.firma_id+"' AND tabela='rs_procesy';"
            stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            NrPliku=str(DNum[0][0])
            #wrzucamy plik na serwer
            stat=fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)
        if stat=='OK':
            dane=[NrPliku]
       
#-------------------------------------------------------------------------------
#---   USUWANIE OBRAZKA (12)
#-------------------------------------------------------------------------------

if Fun==12:
    if stat=='OK':
        SQL="SELECT plik_id FROM rs_procesy WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND proces_id = '"+Proces+"' AND NOT plik_id IS NULL"
        stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':    
        if len(DPlik)>0:
            stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
            if stat=='OK':
                SQL="UPDATE rs_procesy SET plik_id =NULL WHERE firma_id='"+self.firma_id+"' "
                SQL+=" AND proces_id = '"+Proces+"';"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            
        
#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat = 'BR_UPR_INS'
        
    if stat == 'OK':
        if Proces == '':
            stat = 'BR_PROCES'
            dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT proces_id FROM rs_procesy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND proces_id = '"+Proces+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia symbolu procesu : '+stat
        elif len(d) > 0:
            stat = 'BL_URZADZENIE_IST'
    
    if stat == 'OK':             
        inspola = 'firma_id'
        inswart = "'"+self.firma_id+"'"
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['proces_id','opis']:
                wart = "'"+wart+"'"
                
            elif pole == 'nazwa':
                if wart == '':
                    dane.append('BR_NAZWA')
                wart = "'"+wart+"'"
            
            elif pole in ['proporcjonalny','nieobecnosc']:
                if wart:
                    wart='TRUE'
                else:
                    wart='FALSE'

            elif pole == 'plik_id':
                if wart in ['0',0]:
                    wart = "NULL"
                else:
                    sql ="SELECT plik_id FROM rs_pliki"
                    sql+=" WHERE plik_id='"+str(wart)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if len(d)==0:
                            stat='Brak zapisywanego pliku'
            
            elif pole == 'ean':
                if wart == '':
                    wart = "NULL"
                else:
                    for znak in wart:
                        if not znak in ('0123456789'):
                            stat = 'BL_EAN'
                            dane.append(stat)
                            break
                    if stat == 'OK':
                        wart = "'"+wart+"'"
                        sql ="SELECT proces_id FROM rs_procesy"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND ean="+wart+";"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia kodu EAN w procesach: '+stat
                            dane.append(stat)
                        elif len(d) > 0:
                            stat = 'BL_EAN_IST'
                            dane.append(stat)
                            
            inspola += ","+pole
            inswart += ","+str(wart)
        
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
            
        if stat == 'OK':
            INSERT = "INSERT INTO rs_procesy ("+inspola+") VALUES ("+inswart+");"
            stat,d,dump,dump = self.PolSQL.Execute(INSERT, 1)
            if stat <> 'OK':
                stat = 'Bd dodawania nowego procesu : '+stat


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if not UprEdycja:
        stat = 'BR_UPR_UPD'

    if stat == 'OK':             
        sqlupd = ''
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'nazwa':
                if wart == '':
                    dane.append('BR_NAZWA')
                wart = "'"+wart+"'"

            elif pole == 'opis':
                wart = "'"+wart+"'"
                
            elif pole in ['proporcjonalny','nieobecnosc']:
                if wart:
                    wart='TRUE'
                else:
                    wart='FALSE'

            elif pole == 'plik_id':
                if wart in ['0',0]:
                    wart = "NULL"
                else:
                    sql ="SELECT plik_id FROM rs_pliki"
                    sql+=" WHERE plik_id='"+str(wart)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if len(d)==0:
                            stat='Brak zapisywanego pliku'
            
            elif pole == 'ean':
                if wart == '':
                    wart = "NULL"
                else:
                    for znak in wart:
                        if not znak in ('0123456789'):
                            stat = 'BL_EAN'
                            dane.append(stat)
                            break
                    if stat == 'OK':
                        wart = "'"+wart+"'"
                        sql ="SELECT proces_id FROM rs_procesy"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND proces_id<>'"+Proces+"'"
                        sql+=" AND ean="+wart+";"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia kodu EAN w procesach: '+stat
                            dane.append(stat)
                        elif len(d) > 0:
                            stat = 'BL_EAN_IST'
                            dane.append(stat)
                    
            sqlupd += pole+"="+str(wart)+","
        
        if stat == 'OK':    
            if len(dane) > 0:
                stat = dane[0]
            
        if stat == 'OK' and len(sqlupd) > 0:
            sqlupd = sqlupd[:-1]
            UPDATE ="UPDATE rs_procesy SET "+sqlupd
            UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND proces_id='"+Proces+"';"
            
            stat,d,dump,dump = self.PolSQL.Execute(UPDATE, 1)
            if stat <> 'OK':
                stat = 'Bd aktualizacji danych procesu : '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem  1-insert z pobraniem )
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    SELECT ="SELECT * FROM rs_procesy"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND proces_id='"+Proces+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych procesu'
        dane.append(stat)
