# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_produkcja_plan.py
# Purpose:     wyswietla, dodaje,usuwa dane planu produkcji
# Author:      Dariusz Boduch, Micha Raburski
# Created:     2010/01/25
# RCS-ID:      $Id: fs_produkcja_plan.py$
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2011.01.21 MR (4176) nowa wersja okna z planem produkcji
# 2011.07.01 Mariusz Rajfura - pobieranie z zamowien dla nowej wersji planu (4272)
# 2013-03-21 Mariusz Rajfura (6707) nowy opcja: grid dla prod.nieciaglej (analityczny)
# 2013-04-23 Mariusz Rajfura (6801) kontrola czynnosci przypisanych do partii przed usunieciem
# 2013-04-23 Mariusz Rajfura (6806) nowe pole na gridzie nieciaglej 'przewodnik', dodanie w planie produkcji
# 2013-04-30 Mariusz Rajfura (6827) nowe pole 'technologia_id'
# 2013-05-02 Mariusz Rajfura (6826) usuwanie partii: kontrola uzycia numeru partii w pozycjach dok.mag
# 2014-05-28 Marcin Natkaski(7339) dodanie do filtrw kontrolki "Tylko z czasem zakoczenia"
# 2016-07-18 Piotr Witkowski (9955) refaktoryzacja okna

# FUNKCJE NA OKNIE:
# 27 - zakoczenie partii produkcyjnej
# 18 - wstawienie danych do produkcji planu przy produkcji niecigej
# 19 - wstawienie "produkcji" wykonanej czciowo
# 24 - pobranie typu artykulu
# 23 - sprawdzenie technologii produkcji
# 22 - sprawdzenie kalendarza produkcyjnego
# 21 - pobranie listy urzadzen z procesow-artykulow z podana kolejnoscia na liscie procesow
# 20 - pobranie informacji o podstawowym artykule
# 13 - pobranie listy dozwolonych oddziaw (13)
# 14 - pobranie danych dla trjek artyku/proces/urzdzenie
# 7,8 - import
# 6  - delete 
# 11 - sprawdzenie czy trzeba czyci dane z zamwie
# 12 - pobieranie danych z zamwie
# 5,6,9,12 - pobranie danych


from funkcje import fs_produkcja_plan_pom

stat='OK'
filtr = [5,6,9,11,12,]
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'OddzialF':filtr,'DataOdF':filtr,'DataDoF':filtr,
           'ZmianaF':filtr,'GodzOdF':filtr,'GodzDoF':filtr,
           'DataEkspF':filtr,'ZmianaEkspF':filtr,'KategArtF':filtr,
           'ArtykulF':filtr,'ProcesF':filtr,'UrzadzenieF':filtr,
           'DataNaKiedyF':filtr,'CzyUwagiF':filtr,'CzekaF':filtr,
           'ProdukowaneF':filtr,'ZakonczoneF':filtr,
           'NoweF':filtr,'ZmIloscF':filtr,'ZmCzasF':filtr,
           'NiezgZamF':filtr,'NiezrealizowaneF':filtr,'AnalitykaF':filtr,
           'PolsyntetykaF':filtr,'SyntetykaF':filtr,'NieciaglaF':filtr,
           'NrZamowieniaF':filtr,'NiezakonczoneF':filtr,'CzasKoncaF':filtr,
           'Partia':[6,19,27],'LArtykulow':[14,],'DataCzas':[18,27],
           'Kalendarz':[18,22],'Priorytet':[18,],'NrZamowienia':[18,],
           'DataNaKiedy':[18,],'SProd':[18,],'Oddzial':[7,8,18,19],
           'Przewodnik':[18,],'Technologia':[18,23],
           'Artykul':[19,20,21,24,],'Data':[19,],'Zmiana':[7,8,19,],'Proces':[19,],
           'Urzadzenie':[19,],'GodzMin':[19,],'Ilosc':[19,],
           'Braki':[19,],'Kolejnosc':[21],'DataS':[7,8],'DataN':[7,8]
           }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_produkcja_plan z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in filtr:
        OddzialF = klucze['OddzialF']
        DataOdF = klucze['DataOdF']
        DataDoF = klucze['DataDoF']
        ZmianaF = klucze['ZmianaF']
        GodzOdF = klucze['GodzOdF']
        GodzDoF = klucze['GodzDoF']
        DataEkspF = klucze['DataEkspF']
        ZmianaEkspF = klucze['ZmianaEkspF']
        KategArtF = klucze['KategArtF']
        ArtykulF = klucze['ArtykulF']
        ProcesF = klucze['ProcesF']
        UrzadzenieF = klucze['UrzadzenieF']
        DataNaKiedyF = klucze['DataNaKiedyF']
        CzyUwagiF = klucze['CzyUwagiF']
        CzekaF = klucze['CzekaF']
        ProdukowaneF =klucze['ProdukowaneF']
        ZakonczoneF = klucze['ZakonczoneF']
        NoweF = klucze['NoweF']
        ZmIloscF = klucze['ZmIloscF']
        ZmCzasF =  klucze['ZmCzasF']
        NiezgZamF =klucze['NiezgZamF']
        NiezrealizowaneF = klucze['NiezrealizowaneF']
        AnalitykaF = klucze['AnalitykaF']
        PolsyntetykaF= klucze['PolsyntetykaF']
        SyntetykaF= klucze['SyntetykaF']
        NieciaglaF= klucze['NieciaglaF']
        NrZamowieniaF= klucze['NrZamowieniaF']
        NiezakonczoneF=klucze['NiezakonczoneF']
        CzasKoncaF= klucze['CzasKoncaF']
    if Funkcja in [6,19,27]:
        Partia= klucze['Partia']
    if Funkcja in [14,]:
        LArtykulow= klucze['LArtykulow']
    if Funkcja in [18,27]:
        DataCzas= klucze['DataCzas']
    if Funkcja in [18,23]:
        Technologia= klucze['Technologia']
    if Funkcja in [18,22]:
        Kalendarz= klucze['Kalendarz']
    if Funkcja in [18,19]:
        Oddzial= klucze['Oddzial']
    if Funkcja in [18,]:
        Priorytet= klucze['Priorytet']
        NrZamowienia= klucze['NrZamowienia']
        DataNaKiedy= klucze['DataNaKiedy']
        SProd= klucze['SProd']
        Przewodnik= klucze['Przewodnik']
    if Funkcja in [19,20,21,24,]:
        Artykul= klucze['Artykul']
    if Funkcja in [19,]:
        Data= klucze['Data']
    if Funkcja in [19,]:
        Zmiana= klucze['Zmiana']
        Proces= klucze['Proces']
        Urzadzenie= klucze['Urzadzenie']
        GodzMin= klucze['GodzMin']
        Ilosc= klucze['Ilosc']
        Braki= klucze['Braki']
    if Funkcja in [21,]:
        Kolejnosc= klucze['Kolejnosc']
    if Funkcja in [7,8]:
        Oddzial= klucze['Oddzial']
        DataS= klucze['DataS']
        DataN= klucze['DataN']
        Zmiana= klucze['Zmiana']
if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []


UprOddzialy=(((self.oddzial_id,'047001') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 
UprProcesy=(((self.oddzial_id,'047001') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 
UprArtykuly=(((self.oddzial_id,'013011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 
UprUrzadzenia=(((self.oddzial_id,'046001') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 

UprIns=((self.oddzial_id,'048003') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprUpd=((self.oddzial_id,'048002') in self.uprawnienia or UprIns or (self.operator_id == STANDARD_OPERATOR_ID))
UprDel=((self.oddzial_id,'048004') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# ZAKOCZENIE PRODUKCJI CZʦCIOWO ZREALIZOWANEJ
# parametry : Partia, DataCzas
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==27:
    if not UprUpd:
        stat = 'Brak uprawnie do edycji danych planu produkcji'

    if stat =='OK':
        # zablokowanie caej partii, by nikt nie grzeba w danych w tym czasie
        SQL="SELECT * FROM rs_produkcja_plan WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND partia_id="+str(Partia)
        stat,DBlokada,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd blokowania partii '+str(Partia)+':'+stat
    
    if stat == 'OK':
        # wstawienie czasu koca produkcji do planu
        SQL="UPDATE rs_produkcja_plan SET czas_koniec = '"+DataCzas+"'"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat='Bd koczenia produkcji dla partii '+str(Partia)+' :'+stat


#-------------------------------------------------------------------------------
# WSTAWIENIE DANYCH DO PLANU PRODUKCJI PRZY PRODUKCJI NIECIGEJ (18)
# parametry : DataCzas, Kaledarz, Priorytet, NrZamowienia, DataNaKiedy, SProd, Oddzial
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==18:
    if not UprIns:
        stat = 'Brak uprawnie do wstawiania danych do planu produkcji'

    if stat=='OK':
        KluczeProd=SProd.keys()
        KluczeProd.sort()

        Art=''
        Lp=-1
        for kl in KluczeProd:
            if stat=='OK':
                # nowy artyku. Musimy pobra nowy nr partii
                if kl[0]<>Art:
                    Art=kl[0]
                    CzasPocz=DataCzas
                    CzasKonca=DataCzas
                    # pobranie wsplnego numeru partii
                    Partia=-1
                    SQLPartia="SELECT NEXTVAL('rs_produkcja_partia_id');"
                    stat,DPartia,dump,dump=self.PolSQL.Execute(SQLPartia,3)
                    if stat=='OK':
                        Partia=DPartia[0][0]
        
                # dla kadego urzdzenia osobno ustawiamy plan zajtoci. 
                # Zaley on od artykuu, urzdzenia, proiorytetu, czasu pocztku
                # iloci do wyprodukowania oraz terminw w kalendarzu produkcyjnym
                Kolejnosc=kl[1]
                Lp=1
                for poz in SProd[kl]:
                    if stat=='OK':
                        stat,CzasTmp=fs_produkcja_plan_pom.WstawPlanProdukcjiDoUrzadzenia(self,Art,Oddzial,poz[0].strip(),poz[1],
                                                                                          Kolejnosc,CzasPocz,Priorytet,Partia,Kalendarz,
                                                                                          Lp,NrZamowienia,DataNaKiedy,False,Przewodnik,
                                                                                          Technologia)
                    if stat=='OK':
                        if CzasTmp>CzasKonca:
                            CzasKonca=CzasTmp
                    Lp+=1
                # ostatni czas poprzedniej kolejnosci staje si nowym pocztkiem nowej kolejnosci
                if stat=='OK':
                    CzasPocz=CzasKonca
                

#-------------------------------------------------------------------------------
# WSTAWIENIE WYKONANEJ PRODUKCJI DO PLANU PRODUKCJI (19)
# parametry Oddzial, Partia, Data, Zmiana, Proces, Artykul, Urzadzenie, GodzMin, Ilosc
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==19:
    if not UprUpd:
        stat = 'Brak uprawnie do edycji planu produkcji'

    if stat=='OK':
        # zablokowanie caej partii, by nikt nie grzeba w danych w tym czasie
        SQL="SELECT * FROM rs_produkcja_plan WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND oddzial_id='"+Oddzial+"' AND partia_id="+str(Partia)
        stat,DBlokada,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd blokowania partii :'+stat
    
    if stat=='OK':
        # pobranie kolejnosci wartoci dostpnej oraz do wykonania z pozycji
        SQL="SELECT kolejnosc,COALESCE(do_produkcji,0),COALESCE(zrealizowano,0),COALESCE(dostepne,0),COALESCE(braki,0)"
        SQL+=" FROM rs_produkcja_plan WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND oddzial_id='"+Oddzial+"' AND data='"+Data+"' AND zmiana='"+Zmiana+"'"
        SQL+=" AND proces_id='"+Proces+"' AND artykul_id='"+Artykul+"'"
        SQL+=" AND urzadzenie_id='"+Urzadzenie+"' AND godz_minuta='"+GodzMin+"';"
        stat,DKolej,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobrania kolejnoci dla pozycji :'+stat
    
    if stat=='OK':
        Kolej=DKolej[0][0]
        DoProdukcji=DKolej[0][1]
        Zrealizowano=DKolej[0][2]
        Dostepne=DKolej[0][3]
        BrakiPocz=DKolej[0][4]
        
        if float(Zrealizowano)+float(Ilosc)<0:
            stat='Nie mona zrealizowa podanej iloci bo ilo wynikowa jest mniejsza od 0'

        if float(BrakiPocz)+float(Braki)<0:
            stat='Nie mona zrealizowa podanej iloci brakw bo ilo wynikowa brakw jest mniejsza od 0'
                    
    if stat=='OK':
        # wstawienie wykonania i brakw do pozycji
        SQL="UPDATE rs_produkcja_plan SET zrealizowano=COALESCE(zrealizowano,0)+ "+str(Ilosc)+","
        SQL+=" braki=COALESCE(braki,0)+ "+str(Braki)
        SQL+=" WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND oddzial_id='"+Oddzial+"' AND data='"+Data+"' AND zmiana='"+Zmiana+"'"
        SQL+=" AND proces_id='"+Proces+"' AND artykul_id='"+Artykul+"'"
        SQL+=" AND urzadzenie_id='"+Urzadzenie+"' AND godz_minuta='"+GodzMin+"';"
        
        # zmiana dostpnoci w danej kolejnosci
        if Kolej>1:
            SQL+=" UPDATE rs_produkcja_plan SET dostepne=COALESCE(dostepne,0)- "+str(Ilosc)+" - "+str(Braki)
            SQL+=" WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND partia_id='"+str(Partia)+"' AND kolejnosc="+str(Kolej)+";"
        
        # zmiana dostpnoci w nastpnej kolejnoci
        SQL+=" UPDATE rs_produkcja_plan SET dostepne=COALESCE(dostepne,0)+ "+str(Ilosc)
        SQL+=" WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND partia_id='"+str(Partia)+"' AND kolejnosc="+str(Kolej)+"+1;"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat='Bd realizacji produkcji :'+stat


#-------------------------------------------------------------------------------
# SPRAWDZENIE CZY PRODUKCJA CIAGLA DLA ARTYKULU (20)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==20:
    SQL="SELECT czy_produkcja_ciagla FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)

                
#-------------------------------------------------------------------------------
# POBRANIE LISTY URZADZEN DLA ARTYKULU I KOLEJNOSCI Z PROCESOW-ARTYKULOW (21)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==21:
    # Podana kolejnosc (proces) moze byc realizowana na kilka sposobow (urzadzen)
    # wybieramy wszystkie urzadzenia.
    sql ="SELECT pa.urzadzenie_id,COALESCE(u.grupa_id,'')"
    sql+=" FROM rs_procesy_artykuly pa"
    sql+=" INNER JOIN rs_urzadzenia u USING(firma_id,urzadzenie_id)"
    sql+=" WHERE pa.firma_id='"+self.firma_id+"' AND pa.oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND pa.artykul_id='"+Artykul+"'"
    sql+=" AND pa.kolejnosc="+str(Kolejnosc)
    sql+=" ORDER BY pa.urzadzenie_id;"
    
    stat,Urz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy urzdze dla kroku nr '+str(Kolejnosc)
    elif len(Urz) == 0:
        stat = 'Brak przydzielonych urzdze dla kroku nr '+str(Kolejnosc)
    
    if stat=='OK':
        # Wybieramy wszystkie podane urzadzenia podane wprost,
        # a takze te urzadzenia, ktore naleza do grup, ktore sa wpisane
        # w urzadzeniach podanych wprost czyli otrzymanych z rs_procesy_artykuly.
        # Zapytanie przygotowuje puste kolumny, ktore zostana wypelnione na oknie.
        # kol: 2-ilosc, 3-wydajnosc, 4-czas uzycia, 5-wolne od
        LUrz = []
        LGrup = []
        for u in Urz:
            if not u in LUrz:
                LUrz.append(rsglobal.Dekoduj(u[0]))
            if u[1] <> '' and not u[1] in LGrup:
                LGrup.append(rsglobal.Dekoduj(u[1]))
        
        LUrz = str(LUrz).replace('[','(').replace(']',')')
        
        sql ="SELECT DISTINCT urzadzenie_id,nazwa,0,0,'',''"
        sql+=" FROM rs_urzadzenia WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND (urzadzenie_id IN "+LUrz

        if len(LGrup) > 0:
            LGrup = str(LGrup).replace('[','(').replace(']',')')
            sql+=" OR grupa_id IN "+LGrup
            
        sql+=") ORDER BY urzadzenie_id;"
        
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy moliwych do wykorzystania urzdze: '+stat
        if stat=='OK' and len(dane)>0:
            # pobranie wydajnosci dla urzadzen z procesow artykulow
            for i in xrange(len(dane)):
                sql ="SELECT proces_id,maks_ilosc"
                sql+=" FROM rs_procesy_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
                sql+=" AND artykul_id='"+Artykul+"'"
                sql+=" AND urzadzenie_id='"+rsglobal.Dekoduj(dane[i][0])+"'"
                sql+=" AND kolejnosc="+str(Kolejnosc)
                sql+=" ORDER BY proces_id;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)

                if stat <> 'OK':
                    stat = 'Bd pobrania wydajnoci procesu: '+stat
                    dane = [stat]
                    break
                elif len(d) == 1:
                    # jesli tylko jeden proces w tej kolejnosci dla tego artykulu
                    # to wpisujemy wydajnosc
                    dane[i][3] = d[0][1]

        if stat=='OK' and len(dane)>0:
            # pobranie czasu od kiedy wolne urzadzenie wg planu produkcji
            for i in xrange(len(dane)):
                sql ="SELECT data_konca::TEXT||' '||godz_minuta_konca::TEXT"
                sql+=" FROM rs_produkcja_plan"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND urzadzenie_id='"+rsglobal.Dekoduj(dane[i][0])+"'"
                sql+=" ORDER BY data_konca DESC, godz_minuta_konca DESC LIMIT 1;"

                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania czasu ostatniego uycia urzdzenia: '+stat
                    dane = [stat]
                    break
                elif len(d) == 1:
                    # jesli tylko jeden proces w tej kolejnosci dla tego artykulu
                    # to wpisujemy wydajnosc
                    dane[i][5] = d[0][0]


#-------------------------------------------------------------------------------
# POBRANIE TYPU ARTYKULU (24)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==24:
    SQL ="SELECT typ_artykulu FROM rs_artykuly"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania typu artykulu: '+stat
    elif len(dane) == 0:
        stat = 'Bdny kod artykuu'


#-------------------------------------------------------------------------------
# SPRAWDZENIE TECHNOLOGII PRODUKCJI (23)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==23:
    SQL ="SELECT kod FROM rs_technologie_produkcji"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Technologia+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia technologii produkcji: '+stat
    elif len(dane) == 0:
        stat = 'Bdny kod technologii produkcji'


#-------------------------------------------------------------------------------
# SPRAWDZENIE KALENDARZA PRODUKCJI (22)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja==22:
    SQL ="SELECT kalendarz_id FROM rs_kp_kalendarze"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id='"+Kalendarz+"' AND typ='P';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia kalendarza: '+stat
    elif len(dane) == 0:
        stat = 'Bdny kod kalendarza lub kalendarz nie jest typu P (produkcyjny)'


#-------------------------------------------------------------------------------
    
if stat =='OK' and Funkcja in (5,6,9,12):
# SPRAWDZANIE POPRAWNOSCI FILTRA

    #ODDZIAL
    if stat=='OK':
        if OddzialF=='':
            stat = u'ODDZ BR'
            dane.append(stat)
        else:
            sql="SELECT opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(OddzialF)+"'; "
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = u'ODDZ BL SQL'
                dane.append(stat)
            elif d==[]:
                stat = u'ODDZ BL'
                dane.append(stat)
  
    if stat=='OK':
        #SPRAWDZENIE CZY OPERATOR MA UPRAWNIENIA DO ODDZIALU Z FILTRA
        if self.operator_id == STANDARD_OPERATOR_ID:
            sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
        else:
            sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
            sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
            sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
            sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
            sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
            sql+=" ORDER BY o.oddzial_id;"
        
        stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
        else:
            if len(oddz) == 0:
                stat = 'Brak oddziaw, do ktrych uytkownik ma prawa.'
            else:
                UprOddzialy = '('
                for i in oddz:
                    UprOddzialy += "'"+str(i[0])+"',"
        
                UprOddzialy = UprOddzialy[:-1]+")"
        if OddzialF not in UprOddzialy:
            stat='UPR ODDZ'
            dane.append(stat)
    
    #DATAODF
    if stat=='OK' and DataOdF <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataOdF):
            stat = 'DATA BL ODF'
            dane.append(stat)
            
    #DATADOF
    if stat=='OK' and DataDoF <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataDoF):
            stat = 'DATA BL DOF'
            dane.append(stat)
    
    #GODZODF
    if stat=='OK' and GodzOdF <> '  :  ':
        stat,dump,dump,dump = self.PolSQL.Execute("SELECT '"+GodzOdF+"'::TIME;",2)
        if stat <> 'OK':
            stat = 'GODZODF BL'
            dane.append(stat)

    #GODZODF
    if stat=='OK' and GodzDoF <> '  :  ':
        stat,dump,dump,dump = self.PolSQL.Execute("SELECT '"+GodzDoF+"'::TIME;",2)
        if stat <> 'OK':
            stat = 'GODZDOF BL'
            dane.append(stat)
    
    #DATAEKSP
    if stat=='OK' and DataEkspF <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataEkspF):
            stat = 'DATA BL EKSPF'
            dane.append(stat)
    
    #KATEGORIA ARTYKULU
    if stat=='OK' and KategArtF<>'':
        sql="SELECT opis FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"' AND kod LIKE '"+str(KategArtF)+"%' ; "
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'KA BL SQL'
            dane.append(stat)
        elif len(d)==0:
            stat = 'KA BL'
            dane.append(stat)   
            
    #ARTYKUL
    if stat=='OK' and ArtykulF<>'':
        sql="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id like '"+str(ArtykulF)+"%' ; "
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'ART BL SQL'
            dane.append(stat)
        elif len(d)==0:
            stat = 'ART BL'
            dane.append(stat)
    
    #PROCES
    if stat=='OK' and ProcesF<>'':
        sql="SELECT proces_id FROM rs_procesy WHERE firma_id='"+self.firma_id+"' AND proces_id = '"+str(ProcesF)+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'PROC BL SQL'
            dane.append(stat)
        elif len(d)==0:
            stat = 'PROC BL'
            dane.append(stat)   
    
    #URZDZENIE
    if stat=='OK' and UrzadzenieF<>'':
        sql="SELECT urzadzenie_id FROM rs_urzadzenia WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id = '"+str(UrzadzenieF)+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'URZ BL SQL'
            dane.append(stat)
        elif len(d)==0:
            stat = 'URZ BL'
            dane.append(stat)   
            
    #DATANAKIEDYF
    if stat=='OK' and DataNaKiedyF <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataNaKiedyF):
            stat = 'DATA BL NAKIEDYF'
            dane.append(stat)
            
    
#-------------------------------------------------------------------------------
# POBRANIE LISTY DOZWOLONYCH ODDZIALOW (13)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 13:
    if self.operator_id == STANDARD_OPERATOR_ID:
        sql ="SELECT oddzial_id FROM rs_oddzialy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**'"
        sql+=" ORDER BY oddzial_id;"
    else:
        sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
        sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
        sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
        sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
        sql+=" ORDER BY o.oddzial_id;"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat


#-------------------------------------------------------------------------------
# POBRANIE DANYCH DLA TRJEK ARTYKU/PROCES/URZDZENIE (14)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 14:
    dane=[]
    for poz in LArtykulow:
        if stat=='OK':
            Art=poz[0]
            Nazwa='Brak nazwy'
            Ilosc=0
            for proc in poz[1:]:
                if stat=='OK':
                    Proces=proc[0].split(' - ')[0].strip()
                    Urzadzenie=proc[1].split(' - ')[0].strip()
                    SQL="SELECT pa.maks_ilosc,a.nazwa FROM rs_procesy_artykuly pa "
                    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
                    SQL+=" WHERE pa.firma_id='"+self.firma_id+"' AND pa.proces_id='"+Proces+"'"
                    SQL+=" AND pa.artykul_id='"+Art+"' AND pa.urzadzenie_id='"+Urzadzenie+"';"
                    stat,DIlosc,dump,dump = self.PolSQL.Execute(SQL,3)        
                if stat=='OK':
                    if len(DIlosc)>0:
                        if DIlosc[0][0]>0:
                            if DIlosc[0][0]< Ilosc or Ilosc==0:
                                Ilosc=DIlosc[0][0]
                                Nazwa=DIlosc[0][1]
                    else:
                        Ilosc=-1
                        break
            
            if stat=='OK':
                dane.append([Art.strip(),Ilosc,Nazwa])


#-------------------------------------------------------------------------------
# IMPORT - 7,8
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja in (7,8):
    if not (UprIns and UprDel):
        stat = 'UPR_KOPIOWANIA'
        dane.append(stat)
    
    if stat == 'OK':
        #sprawdzam poprawnosc klucza
        if Oddzial=='':
            stat = u'BR_ODDZ'
            dane.append(stat)
        else:
            sql="SELECT opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(Oddzial)+"'; "
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = u'Bd pobrania danych oddziau: '+stat
                dane.append(stat)
            elif len(d) == 0:
                stat = u'BL_ODDZ'
                dane.append(stat)
  
        if stat=='OK':
            #SPRAWDZENIE CZY OPERATOR MA UPRAWNIENIA DO ODDZIALU Z FILTRA
            if self.operator_id == STANDARD_OPERATOR_ID:
                    sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
            else:
                sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
                sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
                sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
                sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
                sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
                sql+=" ORDER BY o.oddzial_id;"
            
            stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
            else:
                if len(oddz) == 0:
                    stat = 'Brak oddziaw, do ktrych uytkownik ma prawa.'
                else:
                    UprOddzialy = '('
                    for i in oddz:
                        UprOddzialy += "'"+str(i[0])+"',"
            
                    UprOddzialy = UprOddzialy[:-1]+")"
            if Oddzial not in UprOddzialy:
                stat='UPR ODDZ'
                dane.append(stat)
        
        #ZMIANA
        if stat == 'OK':
            if not Funkcja in (7,8):
                #przy kopiowaniu nie wymuszamy podania zmiany
                if Zmiana == '':
                    stat='ZMIANA BR'
                    dane.append(stat)
        
        # DATY
        if stat == 'OK':
            if DataS == '    -  -  ':
                stat = 'BR_DATA_Z_KIEDY'
                dane.append(stat)
            elif not rsglobal.SprawdzCzyToData(DataS):
                stat='BL_DATA_Z_KIEDY'
                dane.append(stat)

        if stat == 'OK':
            if DataN =='    -  -  ':
                stat='BR_DATA_NA_KIEDY'
                dane.append(stat)
            elif not rsglobal.SprawdzCzyToData(DataN):
                stat='BL_DATA_NA_KIEDY'
                dane.append(stat)
        
        if stat == 'OK':
            if DataN <= DataS:
                stat='ZAKR DAT BL'
                dane.append(stat)
        
        #SPRAWDZAM, CZY W DNIU, NA KTRY MA BY SKOPIOWANY PLAN NIE MA POZYCJI. JESLI SA, TO KOMUNIKAT I NADPISANIE NOWYCH
        if stat == 'OK' and Funkcja == 7:
            sql="SELECT oper_poczatek, oper_koniec, oper_przekazanie FROM rs_produkcja_plan"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"'"
            sql+=" AND data_na_kiedy='"+DataN+"'"
            if Zmiana <> '':
                sql+=" AND zmiana='"+Zmiana+"'"
            sql+=";"

            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd sprawdzania operacji do usunicia przed kopiowniem: '+stat
                dane.append(stat)
            elif len(d)>0:
                for i in xrange(len(d)):
                    if d[i][0] > 0 or d[i][1] or d[i][2] > 0:
                        stat ='Nie mona skasowa procesw z dnia '+DataN
                        if Zmiana <> '':
                            stat+=' i zmiany produkcyjnej '+Zmiana
                        stat+=' gdy s lub byy ju w realizacji.'
                        dane = [stat]
                        break
                    
                    stat='ISTN POZ'
                    dane.append(stat)
                    
        if stat == 'OK' and Funkcja == 8:
            DELETE ="DELETE FROM rs_produkcja_plan "
            DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+Oddzial+"' "
            DELETE+=" AND data_na_kiedy='"+DataN+"'"
            if Zmiana <> '':
                DELETE+=" AND zmiana='"+Zmiana+"'"
            DELETE+=";"
            
            stat,d,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = 'Bd usuwania procesw z planu produkcji: '+stat
                dane.append(stat)
                
        if stat == 'OK' and Funkcja == 8:
            #pobranie numerow parti dla kopiowanego okresu
            sql ="SELECT DISTINCT partia_id FROM rs_produkcja_plan"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            sql+=" AND data_na_kiedy='"+DataS+"'"
            if Zmiana <> '':
                sql+=" AND zmiana='"+Zmiana+"'"
            sql+=";"

            stat,danePARTII,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania numerw partii dla kopiowanego zakresu: '+stat
                dane.append(stat)
            elif len(danePARTII) == 0:
                stat = 'W podanym zakresie nie ma adnej pozycji do skopiowania'
                dane.append(stat)

        if stat == 'OK' and Funkcja == 8:
            sql = "SELECT '"+DataN+"'::DATE - '"+DataS+"'::DATE;"
            stat,Interval,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = "Bd obliczenia rnicy dat: "+stat
                dane.append(stat)
            
        if stat == 'OK' and Funkcja == 8:
            INSERT = ''
            Partie = ''
            for i in xrange(len(danePARTII)):
                sql ="SELECT NEXTVAL('rs_produkcja_partia_id');"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania nowego numeru partii produkcyjnej: '+stat
                    dane.append(stat)
                    break

                PartiaN = d[0][0]
                Partie += str(PartiaN)+","
                
                sql = "SELECT '"+DataN+"'::DATE - '"+DataS+"'::DATE;"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = "Bd obliczenia rnicy dat: "+stat
                    dane.append(stat)
                    break
                
                INSERT+="INSERT INTO rs_produkcja_plan "
                INSERT+=" (firma_id, oddzial_id, data, data_na_kiedy, zmiana, proces_id, artykul_id, urzadzenie_id,"
                INSERT+="  godz_minuta, uwagi, zamowiono, do_produkcji, partia_id, kolejnosc) "
                INSERT+=" SELECT  '"+self.firma_id+"', '"+Oddzial+"',"
                INSERT+=" data+INTERVAL '"+str(Interval[0][0])+" DAYS', data_na_kiedy+INTERVAL '"+str(Interval[0][0])+" DAYS',"
                INSERT+=" p.zmiana, p.proces_id,p.artykul_id,p.urzadzenie_id,"
                INSERT+=" p.godz_minuta,p.uwagi,0,p.do_produkcji, "+str(PartiaN)+", p.kolejnosc"
                INSERT+=" FROM rs_produkcja_plan p WHERE p.firma_id='"+self.firma_id+"' AND p.partia_id="+str(danePARTII[i][0])+"; "
                
            if stat == 'OK' and len(INSERT) > 0:
                stat,d,dump,dump = self.PolSQL.Execute(INSERT, 1)
                if stat <> 'OK':
                    stat = 'Bd kopiowania danych z podanego zakresu: '+stat
                    dane.append(stat) 
            
                if stat == 'OK':
                    Partie = Partie[:-1]
                    #pobierzemy ilosc skopiowanych pozycji procesow dla informacji dla operatora
                    sql ="SELECT COUNT(*) FROM rs_produkcja_plan"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id IN ("+Partie+");"

                    stat,wyn2,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania informacji o iloci skopiowanych pozycji: '+stat
                        dane.append(stat)

    
#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 6:
    if not UprDel:
        stat = 'UPR DEL'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT partia_id FROM rs_produkcja_plan"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND partia_id = '"+str(Partia)+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru partii produkcyjnej dla procesu: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak procesu o podanym kluczu: '+stat
            dane.append(stat)

    # Sprawdzamy, czy istnieja pozycje dokumentow magazynowych, na ktorych uzyto numeru usuwanej partii
    if stat == 'OK':
        sql ="SELECT DISTINCT magazyn_id,dokument_id,data,numer"
        sql+=" FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        sql+=" ORDER BY magazyn_id,data;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia numeru partii na pozycjach dokumentw magazynowych: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'Istniej pozycje dokumentw magazynowych, ktre maj wpisany nr usuwanej partii:\n'
            for i in xrange(len(d)):
                stat += 'Mag '+str(d[i][0])+' '+str(d[i][1]+' '+str(d[i][2])+' nr '+rsglobal.UsunKropkaZero(d[i][3])+'\n')
            stat += '\nUsunicie niemoliwe.'
            dane.append(stat)

    # Sprawdzamy czy istnieja czynnosci na kartach pracy przypisane do usuwanej partii 
    if stat == 'OK':
        sql ="SELECT DISTINCT data FROM rs_kp_karty_pracy_czynnosci"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND partia_id='"+str(Partia)+"'"
        sql+=" ORDER BY data;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia czynnoci na kartach pracy: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'Do partii przypisano czynnoci na kartach pracy w dniach:\n'
            for i in xrange(len(d)):
                if i > 0:
                    stat+=', '
                stat+=d[i][0]
            stat+= '\nUsunicie niemoliwe.'
            dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT oper_poczatek,oper_koniec,oper_przekazanie"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND partia_id="+str(Partia)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych dla calego zadania: '+stat
            dane.append(stat)
        elif len(d) == 0:
            stat = 'Brak procesw o podanym numerze partii produkcyjnej: '+stat
            dane.append(stat)
    
    #jakas forma sprawdzenia, czy ktorys z procesow zadania byl juz w uzyciu
    #teraz kontroluje kody operatorow
    if stat == 'OK':
        for i in xrange(len(d)):
            if d[i][0] > 0 or d[i][1] > 0 or d[i][2] > 0:
                stat = 'Zadanie w trakcie realizacji. Usuniecie niemoliwe.'
                dane.append(stat)
                break

    if stat == 'OK':
        DELETE ="DELETE FROM rs_produkcja_plan "
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)+";"

        stat,d,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat = 'Bd usuwania zadania z planu: '+stat
            dane.append(stat)

                                                          
#-------------------------------------------------------------------------------
# SPRAWDZENIE CZY TRZEBA CZYCI DANE Z ZAMWIE - 11
# UWAGA: WARUNKI WYBORU TAKIE SAME,
# JAK W FUNKCJI 12 - POBIERANIE DANYCH Z ZAMOWIEN
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 11:
    if not UprUpd:
        stat = 'UPR EDY'
    
    if stat=='OK' and DataOdF == '    -  -  ':
        stat = "Nie podano w filtrze daty, pod jak bd wpisywane iloci z zamowie. Naley poda konkretn dat od."

    if stat == 'OK' and not rsglobal.SprawdzCzyToData(DataOdF):
        stat = 'Bdna data w filtrze.'

    if stat == 'OK':
        sql ="SELECT COUNT(*) FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' "
        sql+=" AND oddzial_id = '"+OddzialF+"' AND data='"+DataOdF+"'"
        sql+=" AND zamowiono>0;"
        
        stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z planu produkcji: '+stat


#-------------------------------------------------------------------------------
# POBIERANIE DANYCH Z ZAMWIE - 12
# UWAGA: WARUNKI WYBORU TAKIE SAME,
# JAK W FUNKCJI 11 - SPRAWDZENIE, CZY JUZ POBIERANO (Z WYJATKIEM ZAMOWIONO>0)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 12:
    SQLUPD = ''
    
    if not UprUpd:
        stat = 'UPR EDY'

    if stat == 'OK' and DataOdF == '    -  -  ':
        stat = "Nie podano w filtrze daty, pod jak bd wpisywane iloci z zamowie. Naley poda konkretn dat od."

    if stat == 'OK' and not rsglobal.SprawdzCzyToData(DataOdF):
        stat = 'Bdna data od w filtrze.'
        
          
    # pobranie danych z sum zamowien produkcji
    if stat == 'OK':
        sql ="SELECT ps.zmiana_p,ps.artykul_id,SUM(ps.zamowione1),a.nazwa"
        sql+=" FROM rs_produkcja_sumy ps"
        sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        sql+=" WHERE ps.firma_id='"+self.firma_id+"'"
        sql+=" AND ps.oddzial_prod='"+OddzialF+"' AND ps.data='"+DataOdF+"'"
        sql+=" GROUP BY ps.zmiana_p,ps.artykul_id,a.nazwa"
        sql+=" ORDER BY ps.zmiana_p,ps.artykul_id; " 

        stat,dSumyZam,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania iloci z zamowie: '+stat
    
    # Pobranie numerow partii do wpisania ilosci z zamowien
    if stat == 'OK':
        sql ="SELECT DISTINCT partia_id"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' "
        sql+=" AND oddzial_id = '"+OddzialF+"' AND data='"+DataOdF+"';"
        
        stat,dPartie,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z planu produkcji: '+stat
    
    if stat == 'OK' and len(dPartie) > 0:
        # pobranie danych z partii spelniajacych warunki filtru 
        Partie = "("
        for p in dPartie:
            Partie += str(p[0])+","
        Partie = Partie[:-1]+")"
        
        sql ="SELECT partia_id,zmiana,artykul_id,data,godz_minuta,do_produkcji"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE partia_id IN "+Partie
        sql+=" ORDER BY partia_id,data,godz_minuta;"
        
        stat,dPozPP,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z wybranych partii: '+stat
            
    if stat == 'OK' and len(dPartie) > 0:
        # czyszczenie poprzednich zamwie 
        SQLUPD ="UPDATE rs_produkcja_plan SET zamowiono=0"
        SQLUPD+=" WHERE partia_id IN "+Partie+";"
        
        sZmianaArtykul = {}
        Partia = None
        for i in xrange(len(dPozPP)):
            if Partia <> dPozPP[i][0]:
                
                # Pierwszy proces w danej partii
                Partia = dPozPP[i][0]
                Zmiana = dPozPP[i][1]
                Artykul = dPozPP[i][2]
                Data = dPozPP[i][3]
                GodzMinuta = dPozPP[i][4]
                DoProdukcji = dPozPP[i][5]
                klucz = (Zmiana,Artykul)
                
                for j in xrange(len(dSumyZam)):
                    if Zmiana == dSumyZam[j][0] and Artykul == dSumyZam[j][1]:
                        if not klucz in sZmianaArtykul:
                            sZmianaArtykul[klucz] = []
                        sZmianaArtykul[klucz].append([Partia,Zmiana,Artykul,Data,GodzMinuta,DoProdukcji])
                        
        if stat == 'OK' and len(sZmianaArtykul.keys()) > 0:
            # Istnieja partie, w ktore mozna wpisywac sumy z zamowien
            
            for i in xrange(len(dSumyZam)):
                # Dla poszczegolnych sum zamowien rozpisujemy zamowione ilosci
                # na kolejne partie aby zamowiono <= do_produkcji.
                # Nadwyzka wpisywana jest do ostatniej partii.
                klucz = (dSumyZam[i][0],dSumyZam[i][1])
                
                if klucz in sZmianaArtykul:
                    # jesli istnieja partie dla wpisania podanej sumy
                    ListaPartii = sZmianaArtykul[klucz]
            
                    # Tworzymy slownik czasow startu dla kazdej partii
                    # [data+godz_minuta+str(partia_id)] = kolejnosc
                    # Partia_id dodana do klucza, aby ulozyc partie
                    # nawet w przypadku identycznego czasu startu partii
                    
                    sCzasyStartow = {}
                    for j in xrange(len(ListaPartii)):
                        CzasStartu = ListaPartii[j][3]+ListaPartii[j][4]+str(ListaPartii[j][0])
                        sCzasyStartow[CzasStartu] = j
                    
                    if stat <> 'OK':
                        break
                    
                    # lista czasow startu ulozona chronologicznie
                    lCzasyStartow = sCzasyStartow.keys()
                    lCzasyStartow.sort()
                    
                    for CzasStartu in lCzasyStartow:
                        nrpoz = sCzasyStartow[CzasStartu]
                        Partia = ListaPartii[nrpoz][0]
                        Zamowiono = min(ListaPartii[nrpoz][5],dSumyZam[i][2])
                        if Zamowiono == 0:
                            break
                        
                        SQLUPD+= "UPDATE rs_produkcja_plan"
                        SQLUPD+=" SET zamowiono=zamowiono+"+str(Zamowiono)
                        SQLUPD+=" WHERE partia_id="+str(ListaPartii[nrpoz][0])+";"
                        dSumyZam[i][2] -= Zamowiono
                    
                    if dSumyZam[i][2] > 0:
                        # Pozostala ilosc w ostatnia partie
                        CzasStartu = lCzasyStartow[-1]
                        nrpoz = sCzasyStartow[CzasStartu]
                        Partia = ListaPartii[nrpoz][0]

                        SQLUPD+= "UPDATE rs_produkcja_plan"
                        SQLUPD+=" SET zamowiono=zamowiono+"+str(dSumyZam[i][2])
                        SQLUPD+=" WHERE partia_id="+str(ListaPartii[nrpoz][0])+";"
                        dSumyZam[i][2] = 0
                        
                if stat <> 'OK':
                    break


    if stat == 'OK' and SQLUPD <>'':
        stat,dump,dump,dump = self.PolSQL.Execute(SQLUPD, 1)
        if stat <> 'OK':
            stat = 'Bd aktualizacji planu produkcji ilociami pobranymi z zamwie: '+stat
            
    if stat == 'OK':
        # Oddzielne ustawienie wynikow, poniewaz dane z zamowien
        # sa niezalezne od danych z planu produkcji
        LNiepobrane = []
        for i in xrange(len(dSumyZam)):
            if dSumyZam[i][2] > 0:
                LNiepobrane.append('  Ilo='+rsglobal.UsunKropkaZero(dSumyZam[i][2]).rjust(15)+
                                   '  Zmiana='+dSumyZam[i][0]+
                                   '  Art='+dSumyZam[i][1].strip()+'  '+dSumyZam[i][3])



        wyn2.append(len(dSumyZam)>0)    # [0] czy byly zamowienia
        wyn2.append(LNiepobrane)        # [1] lista niepobranych


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,6,9,12)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5,6,9,12) and len(dane) == 0:
    # pobranie danych 
    Filtr= "pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id='"+OddzialF+"' "
    if DataOdF <> '    -  -  ':
        Filtr+=" AND pp.data>='"+DataOdF+"' "
    if DataDoF <> '    -  -  ':
        Filtr+=" AND pp.data<='"+DataDoF+"' "
    if ZmianaF<>'':
        Filtr+= " AND pp.zmiana = '"+ZmianaF+"' "
    if GodzOdF<>'  :  ':
        Filtr+= " AND pp.godz_minuta >= '"+GodzOdF+"' "
    if GodzDoF<>'  :  ':
        Filtr+= " AND pp.godz_minuta <= '"+GodzDoF+"' "
    if DataEkspF <> '    -  -  ':
        Filtr+=" AND pp.data_ekspedycja='"+DataEkspF+"' "
    if ZmianaEkspF<>'':
        Filtr+= " AND pp.zmiana_ekspedycja = '"+ZmianaEkspF+"' "
    if KategArtF<>'':
        Filtr+= " AND a.kateg_artykulu LIKE '"+KategArtF+"%' "
    if ArtykulF<>'':
        Filtr+= " AND pp.artykul_id LIKE '"+ArtykulF+"%' "
    if ProcesF<>'':
        Filtr+= " AND pp.proces_id = '"+ProcesF+"' "
    if UrzadzenieF <> '':
        Filtr+=" AND pp.urzadzenie_id = '"+UrzadzenieF+"'"
    if DataNaKiedyF <> '    -  -  ':
        Filtr+=" AND pp.data_na_kiedy='"+DataNaKiedyF+"' "
    if CzyUwagiF:
        Filtr+=" AND TRIM(COALESCE(pp.uwagi,'')) <> '' "
    if NrZamowieniaF <> '':
        Filtr+= " AND pp.nr_zamowienia LIKE '"+NrZamowieniaF+"%' "
    
        
    FiltrKolorow=''
    if CzekaF:
        FiltrKolorow+="OR (pp.czas_poczatek IS NULL) "
    if ProdukowaneF:
        FiltrKolorow+="OR (NOT pp.czas_poczatek IS NULL AND pp.czas_koniec IS NULL) "
    if ZakonczoneF:
        FiltrKolorow+="OR (NOT pp.czas_koniec IS NULL) "
    if NiezakonczoneF:
        FiltrKolorow+="OR (pp.czas_koniec IS NULL)"
    if NoweF:
        FiltrKolorow+="OR (NOT pp.zatwierdzone) "
    if ZmIloscF:
        FiltrKolorow+="OR (pp.zmienione_ilosc) "
    if ZmCzasF:
        FiltrKolorow+="OR (pp.zmienione_czas) "
    if NiezgZamF:
        FiltrKolorow+="OR (pp.zamowiono>pp.do_produkcji) "
    if FiltrKolorow<>'':
        Filtr+=" AND ("+FiltrKolorow[3:]+")"
    
    if NiezrealizowaneF:
        Filtr+=" AND (COALESCE(zrealizowano,0)+COALESCE(braki,0)<do_produkcji) "
    
    if CzasKoncaF:
        Filtr+=" AND czas_koniec is NOT NULL "
        
    # ustawienie wartoci pl zalene od uprawnie
    if UprProcesy<>0:
        PoleProcesOpis=" COALESCE(p.nazwa,'') "
    else:
        PoleProcesOpis="'Brak uprawnie do przegldania danych procesw'"

    if UprArtykuly<>0:
        PoleArtOpis=" COALESCE(a.nazwa,'') "
    else:
        PoleArtOpis="'Brak uprawnie do przegldania danych artykuw'"
        
    if UprUrzadzenia<>0:
        PoleUrzadzenieOpis=" COALESCE(u.nazwa,'') "
    else:
        PoleUrzadzenieOpis="'Brak uprawnie do przegldania danych urzdze'"

    PoleKolorowanie="CASE WHEN zatwierdzone THEN 'T' ELSE 'F' END||CASE WHEN zmienione_ilosc THEN 'T' ELSE 'F' END||"
    PoleKolorowanie+="CASE WHEN zmienione_czas THEN 'T' ELSE 'F' END"
    
    SQL ="SELECT COALESCE(pp.artykul_id,''),"+PoleArtOpis+", pp.zmiana, "
    SQL+=" COALESCE(pp.proces_id,''),"+PoleProcesOpis+",COALESCE(pp.urzadzenie_id,''),"+PoleUrzadzenieOpis+", "
    SQL+=" pp.data||' '||SUBSTRING(pp.godz_minuta::TEXT FROM 1 FOR 5), COALESCE(pp.uwagi,''),"
    SQL+=" pp.zamowiono, pp.do_produkcji, pp.zrealizowano, pp.braki,pp.data_na_kiedy,"
    SQL+=" COALESCE(pp.data_ekspedycja::TEXT,''),COALESCE(pp.zmiana_ekspedycja::TEXT,''),"
    SQL+=" SUBSTRING(COALESCE(pp.czas_poczatek::TEXT,'') FOR 19),SUBSTRING(COALESCE(pp.czas_koniec::TEXT,'') FOR 19),"
    SQL+=" SUBSTRING(COALESCE(pp.czas_przekazanie::TEXT,'') FOR 19),pp.przekazano,pp.odebrano,"
    SQL+=" COALESCE(pp.data_konca||' '||SUBSTRING(pp.godz_minuta_konca::TEXT FROM 1 FOR 5),''),"+PoleKolorowanie+","
    SQL+=" pp.partia_id,pp.kolejnosc,pp.lp "
    SQL+=" FROM rs_produkcja_plan pp "
    SQL+=" LEFT OUTER JOIN rs_procesy p ON(pp.firma_id=p.firma_id AND pp.proces_id=p.proces_id) "
    SQL+=" LEFT OUTER JOIN rs_artykuly a ON(pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
    SQL+=" LEFT OUTER JOIN rs_urzadzenia u ON(pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id) "
    SQL+=" WHERE "+Filtr+" "
    SQL+=" ORDER BY pp.partia_id, pp.kolejnosc;"
    
    stat,Dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd pobrania planu produkcji: "+stat
        dane = []
        dane.append(stat)
        
    if stat=='OK':
        if AnalitykaF:
            SQL ="SELECT COALESCE(pp.artykul_id,''),"+PoleArtOpis+", pp.zmiana, "
            SQL+=" COALESCE(pp.proces_id,''),"+PoleProcesOpis+",COALESCE(pp.urzadzenie_id,''),"+PoleUrzadzenieOpis+", "
            SQL+=" pp.data||' '||SUBSTRING(pp.godz_minuta::TEXT FROM 1 FOR 5), COALESCE(pp.uwagi,''),"
            SQL+=" pp.zamowiono, pp.dostepne, pp.do_produkcji, pp.zrealizowano, pp.braki,pp.data_na_kiedy,"
            SQL+=" CASE WHEN a.czy_produkcja_ciagla THEN '0:00' ELSE "
            SQL+=" rsf_podaj_godziny_wykonania(COALESCE(pp.zrealizowano,0)+COALESCE(pp.braki,0),pp.liczba_urzadzen,pa.maks_ilosc) END,"
            SQL+=" CASE WHEN a.czy_produkcja_ciagla THEN '0:00' ELSE "
            SQL+=" rsf_podaj_godziny_wykonania(COALESCE(pp.do_produkcji,0)-(COALESCE(pp.zrealizowano,0)+COALESCE(pp.braki,0)),pp.liczba_urzadzen,pa.maks_ilosc) END,"
            SQL+=" pp.liczba_urzadzen,pp.priorytet::INT,"
            SQL+=" COALESCE(pp.data_ekspedycja::TEXT,''),COALESCE(pp.zmiana_ekspedycja::TEXT,''),"
            SQL+=" SUBSTRING(COALESCE(pp.czas_poczatek::TEXT,'') FOR 19),SUBSTRING(COALESCE(pp.czas_koniec::TEXT,'') FOR 19),"
            SQL+=" SUBSTRING(COALESCE(pp.czas_przekazanie::TEXT,'') FOR 19),pp.przekazano,pp.odebrano,"
            SQL+=" COALESCE(pp.data_konca||' '||SUBSTRING(pp.godz_minuta_konca::TEXT FROM 1 FOR 5),''),"+PoleKolorowanie+","
            SQL+=" pp.partia_id,pp.kolejnosc,pp.lp "
            SQL+=" FROM rs_produkcja_plan pp "
            SQL+=" LEFT OUTER JOIN rs_procesy p ON (pp.firma_id=p.firma_id AND pp.proces_id=p.proces_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly a ON (pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_urzadzenia u ON (pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id) "
            SQL+=" LEFT OUTER JOIN rs_procesy_artykuly pa ON (pp.firma_id=pa.firma_id AND pp.artykul_id=pa.artykul_id "
            SQL+=" AND pp.proces_id=pa.proces_id AND pp.urzadzenie_id=pa.urzadzenie_id) "
            SQL+=" WHERE "+Filtr+" AND pa.oddzial_id='"+OddzialF+"' "
            SQL+=" ORDER BY pp.partia_id, pp.kolejnosc;"
            
            stat,Dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat="Bd pobrania planu produkcji: "+stat
                dane = []
                dane.append(stat)
            else:
                dane=Dane

        elif NieciaglaF:
            SQL ="SELECT pp.artykul_id,"+PoleArtOpis+",COALESCE(pp.nr_zamowienia,''),COALESCE(pp.przewodnik,''),"
            SQL+=" pp.data_na_kiedy,"
            SQL+=" pp.proces_id,"+PoleProcesOpis+",pp.urzadzenie_id,"+PoleUrzadzenieOpis+","
            SQL+=" pp.kolejnosc,pp.data||' '||SUBSTRING(pp.godz_minuta::TEXT FROM 1 FOR 5),"
            SQL+=" pp.data_konca||' '||SUBSTRING(pp.godz_minuta_konca::TEXT FROM 1 FOR 5),"
            SQL+=" pp.zamowiono, pp.dostepne, pp.do_produkcji, pp.zrealizowano, pp.braki,"
            SQL+=" CASE WHEN a.czy_produkcja_ciagla THEN '0:00' ELSE "
            SQL+=" rsf_podaj_godziny_wykonania(COALESCE(pp.zrealizowano,0)+COALESCE(pp.braki,0),pp.liczba_urzadzen,pa.maks_ilosc) END,"
            SQL+=" pp.priorytet,SUBSTRING(COALESCE(pp.czas_poczatek::TEXT,'') FOR 19),"
            SQL+=" SUBSTRING(COALESCE(pp.czas_koniec::TEXT,'') FOR 19),COALESCE(pp.uwagi,''),"
            SQL+=" pp.partia_id,"+PoleKolorowanie+",pp.lp,pp.zmiana "
            SQL+=" FROM rs_produkcja_plan pp "
            SQL+=" LEFT OUTER JOIN rs_procesy p ON (pp.firma_id=p.firma_id AND pp.proces_id=p.proces_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly a ON (pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_urzadzenia u ON (pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id) "
            SQL+=" LEFT OUTER JOIN rs_procesy_artykuly pa ON (pp.firma_id=pa.firma_id AND pp.artykul_id=pa.artykul_id "
            SQL+=" AND pp.proces_id=pa.proces_id AND pp.urzadzenie_id=pa.urzadzenie_id) "
            SQL+=" WHERE "+Filtr+" AND pa.oddzial_id='"+OddzialF+"' AND a.czy_produkcja_ciagla=false "
            SQL+=" ORDER BY pp.partia_id, pp.kolejnosc, pp.lp;"
            stat,Dane,wyn1,dump = self.PolSQL.Execute(SQL,3)

            if stat<>'OK':
                stat="Bd pobrania planu produkcji: "+stat
                dane = []
                dane.append(stat)
            else:
                dane=Dane

        else:
            SQL ="SELECT COALESCE(pp.artykul_id,''),"+PoleArtOpis+", pp.zmiana, "
            SQL+=" COALESCE(pp.proces_id,''),"+PoleProcesOpis+",COALESCE(pp.urzadzenie_id,''),"+PoleUrzadzenieOpis+", "
            SQL+=" pp.data||' '||SUBSTRING(pp.godz_minuta::TEXT FROM 1 FOR 5), COALESCE(pp.uwagi,''),"
            SQL+=" COALESCE(pp.zamowiono,0), COALESCE(pp.do_produkcji,0), COALESCE(pp.zrealizowano,0), COALESCE(pp.braki,0),pp.data_na_kiedy,"
            SQL+=" COALESCE(pp.data_ekspedycja::TEXT,''),COALESCE(pp.zmiana_ekspedycja::TEXT,''),"
            SQL+=" SUBSTRING(COALESCE(pp.czas_poczatek::TEXT,'') FOR 19),SUBSTRING(COALESCE(pp.czas_koniec::TEXT,'') FOR 19),"
            SQL+=" SUBSTRING(COALESCE(pp.czas_przekazanie::TEXT,'') FOR 19),pp.przekazano,pp.odebrano,"
            SQL+=" COALESCE(pp.data_konca||' '||SUBSTRING(pp.godz_minuta_konca::TEXT FROM 1 FOR 5),''),"+PoleKolorowanie+","
            SQL+=" pp.partia_id,pp.kolejnosc,pp.lp "
            SQL+=" FROM rs_produkcja_plan pp "
            SQL+=" LEFT OUTER JOIN rs_procesy p ON(pp.firma_id=p.firma_id AND pp.proces_id=p.proces_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly a ON(pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_urzadzenia u ON(pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id) "
            SQL+=" WHERE "+Filtr+" "
            SQL+=" ORDER BY pp.partia_id, pp.kolejnosc;"

            rsglobal.ZapiszDoLogow('sql '+SQL,1)
            
            stat,Dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat="Bd pobrania planu produkcji: "+stat
                dane = []
                dane.append(stat)
                
            if PolsyntetykaF:
                SKlucze={}
                SPozycje={}
                
                for poz in Dane:
                    Nowy=False
                    klucz=(poz[0],poz[23],poz[25])
                    klpoz=(poz[0],poz[23])
                    if not klucz in SKlucze:
                        SKlucze[klucz]=1
                        if not klpoz in SPozycje:
                            # nowy klucz do SPozycje (nie wymaga dalszych przetwarza
                            # wiersz zawiera nazw art, start plan, il. zamw, il.  do prod, il zreal.,braki, dat na kiedy,
                                          #  czas pocztku, czas koca, przekazane, odebrane , koniec plan, kolorowanie i partia
                            SPozycje[klpoz]=[poz[0],poz[1],poz[7]]+poz[9:14]+poz[16:18]+poz[19:24]
                            Nowy=True
                        else:
                            # # nowy klucz w SKlucze, ale stary w SPozycje. Dodajemy ilo (bo rni si LP)
                            SPozycje[klpoz][3]=SPozycje[klpoz][3]+poz[9]
                            SPozycje[klpoz][4]=SPozycje[klpoz][4]+poz[10]
                            SPozycje[klpoz][5]=SPozycje[klpoz][5]+poz[11]
                            SPozycje[klpoz][6]=SPozycje[klpoz][6]+poz[12]
                            SPozycje[klpoz][10]=SPozycje[klpoz][10]+poz[20]
                            rsglobal.ZapiszDoLogow('SPozycje[klpoz][11] '+str(SPozycje[klpoz][11]),1)
                            rsglobal.ZapiszDoLogow('poz[21] '+str(poz[21]),1)

                            SPozycje[klpoz][11]=str(SPozycje[klpoz][11])+poz[21]
                    
                    
                    if not Nowy:
                        # jeli nie dodany wiersz to moze wpyn na rne wartoci (czasy, kolorowanie itp)
                        # start plan (2)
                        if poz[7] < SPozycje[klpoz][2]:
                            SPozycje[klpoz][2]=poz[7]
                        # czas pocz (8)
                        if poz[16] < SPozycje[klpoz][8] and poz[16] <>'':
                            SPozycje[klpoz][8]=poz[16]
                        # czas koniec (9)
                        if poz[17] > SPozycje[klpoz][9] or poz[17]=='':
                            if not SPozycje[klpoz][9]=='':
                                SPozycje[klpoz][9]=poz[17]
                        # koniec plan (12)
                        if poz[21] < SPozycje[klpoz][12]:
                            SPozycje[klpoz][12]=poz[21]
                        # kolorowanie (13)
                        if poz[22][0]=='F':
                            SPozycje[klpoz][13]='F'+SPozycje[klpoz][13][1:]
                        if poz[22][1]=='T':
                            SPozycje[klpoz][13]=SPozycje[klpoz][13][0]+'T'+SPozycje[klpoz][13][2]
                        if poz[22][2]=='T':
                            SPozycje[klpoz][13]=SPozycje[klpoz][13][:2]+'T'
                dane=[]
                Klucze=eval(str(SPozycje.keys()))
                Klucze.sort()
                for klucz in Klucze:
                    dane.append(SPozycje[klucz])
                    
            elif SyntetykaF:
                SKlucze={}
                SPozycje={}
                
                for poz in Dane:
                    klucz=(poz[0],poz[23],poz[25])
                    klpoz=(poz[0])
                    if not klucz in SKlucze:
                        SKlucze[klucz]=1
                        if not klpoz in SPozycje:
                            # nowy klucz do SPozycje (nie wymaga dalszych przetwarza)
                            # wiersz zawiera 0. nazw art,
                            #                1. il. zamw,
                            #                2. il. do prod,
                            #                3. il zreal.,
                            #                4. braki,
                            #                5. przekazane,
                            #                6. odebrane 
                            
                            SPozycje[klpoz]=[poz[1]]+poz[9:13]+poz[19:21]
                            
                        else:
                            # # nowy klucz w SKlucze, ale stary w SPozycje. Dodajemy ilo (bo rni si LP)
                            SPozycje[klpoz][1]=SPozycje[klpoz][1]+poz[9]
                            SPozycje[klpoz][2]=SPozycje[klpoz][2]+poz[10]
                            SPozycje[klpoz][3]=SPozycje[klpoz][3]+poz[11]
                            SPozycje[klpoz][4]=SPozycje[klpoz][4]+poz[12]
                            SPozycje[klpoz][5]=SPozycje[klpoz][5]+poz[19]
                            SPozycje[klpoz][6]=SPozycje[klpoz][6]+poz[20]

                dane=[]
                Klucze=eval(str(SPozycje.keys()))
                Klucze.sort()
                for klucz in Klucze:
                    dane.append([klucz]+SPozycje[klucz])
            else:
                dane=[]