# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_produkcja_plan_czynnosci.py
# Purpose:     produkcja/karty pracy: kartoteka czynnosci: grid
#
# Author:      Mariusz Rajfura
# Created:     2013/04/12
# RCS-ID:      $Id: fs_produkcja_plan_czynnosci.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-04-23 Mariusz Rajfura (6801) usuwane czynnosci aktualizaja plan produkcji
# 2013-04-26 Mariusz Rajfura (6817) dodanie do filtru pracownika
# 2013-05-08 Mariusz Rajfura (6852) kontrola pracownika w rejestracji uproszczonej
# 2013-05-22 Mariusz Rajfura (6891) dodat.inf.dla pracownika, nowe pole 'przewodnik'
# 2014-03-03 Marcin Natkanski (7710) obsluga pobierania/usuwanie pozycji, gdzie proces == nieobecnosc
# 2021-03-16  - Aleksander Bargie (12395) Doda trim na imi i nazwisko


#-------------------------------------------------------------------------------

def LiczbaMinut2Godzina(Minuty):
    wynik = '  :  '
    IloscGodzin = int(Minuty / 60 )
    IloscMinut = int( Minuty % 60 )
    wynik = ("%02d" % IloscGodzin) + ":"+ ("%02d" % IloscMinut)
    return wynik

#-------------------------------------------------------------------------------

stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'DataF':[5,6], 'PracownikF':[5,10],
           'Oddzial':[6], 'Pracownik':[6], 'DataOd':[6], 'DataDo':[6],
           'Data':[6], 'Numer':[6],'Proces':[6] }
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_produkcja_plan_czynnosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in (5,6,10): 
        PracownikF = rsglobal.Dekoduj(klucze['PracownikF'])

    if Funkcja in (5,6): 
        DataF = rsglobal.Dekoduj(klucze['DataF'])

    if Funkcja == 6:
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])
        Proces = rsglobal.Dekoduj(klucze['Proces'])

#Klucze_Id = klucze['Klucze_Id']

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprUsuwanie = ((self.oddzial_id,'048104') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
# SPRAWDZENIE KODU PRACOWNIKA - 10
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat == 'OK':
    sql ="SELECT pracownik_id,imie||nazwisko FROM rs_kp_dane_osobowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikF+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych pracownika: '+stat


#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania czynnoci'
    #Sprawdzamy czy usuwamy normalny proces czy nieobecnosc
    if stat == 'OK':
        SQL = "SELECT nieobecnosc from rs_procesy where firma_id='"+self.firma_id+"' "
        SQL+= "AND proces_id='"+Proces+"';"
        stat,nieobecnosc,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Nie mona sprawdzi typu procesu'
        else:
            nieobecnosc = nieobecnosc[0][0]
            
     #-----------------------------------------------------   
            
    if stat == 'OK':
        sql ="SELECT godziny_normalne,zrealizowano,braki,partia_id,kolejnosc,lp"
        sql+=" FROM rs_kp_karty_pracy_czynnosci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        sql+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
        sql+=" AND data_do='"+DataDo+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql+=" FOR UPDATE NOWAIT;"
        stat,Czynnosc,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Nie mona zablokowa usuwanej czynnoci'
        elif len(Czynnosc) == 0:
            stat = 'Czynno o podanym numerze nie istnieje.'

        sql ="SELECT * FROM rs_kp_karty_pracy_dni"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        sql+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
        sql+=" AND data_do='"+DataDo+"' AND data='"+Data+"'"
        sql+=" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Nie mona zablokowa dziennej karty czynnoci. Sprbuj za chwil.'
        elif len(d) == 0:
            stat = 'Dzienna karta pracy nie istnieje.'

    # Sprawdzenie procesu w planie produkcji
    if stat == 'OK' and not nieobecnosc:
        sql ="SELECT * FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Czynnosc[0][3])
        sql+=" AND kolejnosc="+str(Czynnosc[0][4])+" AND lp="+str(Czynnosc[0][5])
        sql+=" FOR UPDATE;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Nie mona zablokowa procesu w planie produkcji do modyfikacji. Sprbuj za chwil.'
        elif len(d) == 0:
            stat = 'Brak przypisanego procesu w planie produkcji. Usuwanie niemoliwe.'

    # Pobranie nastepnego procesu w planie do aktualizacji ilosci dostepnej do produkcji
    if stat == 'OK' and not nieobecnosc:
        sql ="SELECT partia_id,kolejnosc,lp FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Czynnosc[0][3])
        sql+=" AND kolejnosc>"+str(Czynnosc[0][4])
        sql+=" ORDER by kolejnosc,lp LIMIT 1;"
        stat,DaneNastProcesu,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych nastpnego procesu: '+stat

    # Pobranie poprzedniego procesu w partii. Wykorzystane do sprawdzenia, czy to pierwszy proces w partii.
    if stat == 'OK' and not nieobecnosc:
        sql ="SELECT partia_id,kolejnosc,lp FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Czynnosc[0][3])
        sql+=" AND kolejnosc<"+str(Czynnosc[0][4])
        sql+=" ORDER by kolejnosc,lp LIMIT 1;"
        stat,DanePoprzProcesu,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych poprzedniego procesu: '+stat

    if stat == 'OK':
        # aktualizacja sum zbiorczych: godziny normalne
        UPDATE ="UPDATE rs_kp_karty_pracy_dni"
        UPDATE+=" SET godziny_normalne=godziny_normalne- "+str(Czynnosc[0][0])
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        UPDATE+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
        UPDATE+=" AND data_do='"+DataDo+"' AND data='"+Data+"';"
    
        if not nieobecnosc:
            # aktualizacja procesu na planie produkcji
            UPDATE+="UPDATE rs_produkcja_plan SET"
    
            if len(DanePoprzProcesu) > 0:
                # Aktulizacja, jesli nie jest to pierwszy proces w partii
                UPDATE+=" dostepne=COALESCE(dostepne,0)+ "+str(Czynnosc[0][1])+","
                
            UPDATE+=" zrealizowano=COALESCE(zrealizowano,0)- "+str(Czynnosc[0][1])+","
            UPDATE+=" braki=COALESCE(braki,0)- "+str(Czynnosc[0][2])
            UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Czynnosc[0][3])
            UPDATE+=" AND kolejnosc="+str(Czynnosc[0][4])+" AND lp="+str(Czynnosc[0][5])+"; "
            
            # aktualizacja nastepnego procesu w partii jesli taki istnieje
            if len(DaneNastProcesu) > 0:
                UPDATE+="UPDATE rs_produkcja_plan SET"
                UPDATE+=" dostepne=COALESCE(dostepne,0)- "+str(Czynnosc[0][1])
                UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(DaneNastProcesu[0][0])
                UPDATE+=" AND kolejnosc="+str(DaneNastProcesu[0][1])+" AND lp="+str(DaneNastProcesu[0][2])+"; "
            
        # usuniecie wlasciwej czynnosci
        DELETE ="DELETE FROM rs_kp_karty_pracy_czynnosci"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        DELETE+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
        DELETE+=" AND data_do='"+DataDo+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        
        SQL = DELETE+UPDATE
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Czynno uywana w innych tabelach. Usunicie niemoliwe.'


#-------------------------------------------------------------------------------
# SELECT 5,6
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat == 'OK':
    FILTR = "(kpc.firma_id='"+self.firma_id+"' AND kpc.data='"+DataF+"'"
    if PracownikF <> '':
        FILTR+=" AND kpc.pracownik_id='"+PracownikF+"'"
    FILTR+=")"
    
    if not rsglobal.SprawdzCzyToData(DataF):
        stat = 'Bdna data w filtrze'

##    #uzupelnienie podgladu o klucze nowe lub zmienione
##    if len(Klucze_Id) > 0:
##        FILTR += " OR (firma_id = '"+self.firma_id+"' AND urzadzenie_id IN ("
##        for i in xrange(len(Klucze_Id)):
##            if i > 0:
##                FILTR += ","
##            FILTR += "'"+str(Klucze_Id[i][0])+"'"
##        FILTR += "))"

    if stat == 'OK':                       #AB 16.03.21r dodanie TRIM
        SELECT ="SELECT kpc.pracownik_id, TRIM(kpdo.nazwisko)||' '||TRIM(kpdo.imie) AS nazwisko_imie,"
        SELECT+=" kpc.proces_id,p.nazwa,kpc.urzadzenie_id,u.nazwa,"
        SELECT+=" COALESCE(kpc.przewodnik,''),kpc.nr_zamowienia,kpc.godziny_normalne::TEXT,"
        SELECT+=" kpc.zrealizowano,kpc.braki,"
        SELECT+=" kpc.artykul_id,a.nazwa,kpc.data_od,kpc.data_do,"
        SELECT+=" kpc.data,kpc.numer,kpc.oddzial_id"
        SELECT+=" FROM rs_kp_karty_pracy_czynnosci kpc"
        SELECT+=" INNER JOIN rs_kp_dane_osobowe kpdo USING(firma_id,pracownik_id)"
        SELECT+=" INNER JOIN rs_procesy p USING(firma_id,proces_id)"
        SELECT+=" LEFT JOIN rs_urzadzenia u USING(firma_id,urzadzenie_id)"
        SELECT+=" LEFT JOIN rs_artykuly a USING(firma_id,artykul_id)"
        SELECT+=" WHERE "+FILTR+" ORDER BY nazwisko_imie;"
        stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy czynnoci: '+stat
        else:
            
            # Przekazanie dodatkowych informacji dla operatora grida
            slow = {}
            SumaMinut = 0

            # Suma minut z grida, niezaleznie od tego, czy jest podany pracownik
            for i in xrange(len(dane)):
                SumaMinut += int( dane[i][8].split('.')[0] )

            if PracownikF <> '':
                if len(dane) > 0:
                    # Jesli byl jakis wpis, to juz mamy nazwisko i imie,
                    # a sumy beda dotyczyc jego
                    slow['NazwiskoImie'] = dane[0][1]
                else:
                    # Brak wpisow czynnosci, wiec pobieramy dane pracownika z kartoteki osobowej
                    sql ="SELECT TRIM(nazwisko)||' '||TRIM(imie) FROM rs_kp_dane_osobowe"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikF+"';"
                    stat,DanePrac,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania danych pracownika: '+stat
                    elif len(DanePrac) > 0:
                        slow['NazwiskoImie'] = DanePrac[0][0]

            slow['SumaMinut'] = SumaMinut
            slow['SumaGodzinMinut'] = LiczbaMinut2Godzina(SumaMinut)
            wyn2.append(slow)
            
            # Teraz zamiana ilosci minut na postac 'gg:mm'
            for i in xrange(len(dane)):
                dane[i][8] = LiczbaMinut2Godzina(int( dane[i][8].split('.')[0] ))
