# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_produkcja_plan_czynnosci_dane.py
# Purpose:     produkcja/karty pracy: kartoteka czynnosci: edycja
#
# Author:      Mariusz Rajfura
# Created:     2013/04/15
# RCS-ID:      $Id: fs_produkcja_plan_czynnosci_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-04-23 Mariusz Rajfura (6801) dodawane czynnosci aktualizaja plan produkcji
# 2013-04-26 Mariusz Rajfura (6817) dostosowanie do pracy jako oddzielny modul
# 2013-05-22 Mariusz Rajfura (6891) nowe pole 'przewodnik', pobranie opisow przy wczytywaniu partii
# 2014-03-03 Marcin Natkanski (7709) obsluga godzin przygotowania
# 2014-05-15 Marcin Natkanski (7710) obsluga nieobecnosc

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

# 1,2 -dodawanie
# 3,4 - edycja
# 5 - pobranie danych
# 11 - pobranie domyslnych danych dla dodawania
# 21 - pobranie opisu oddzialu
# 22 - pobranie opisu pracownika
# 23 - pobranie opisu artykulu
# 24 - pobranie opisu procesu
# 25 - pobranie opisu urzadzenia
# 31 - pobranie danych na pdst nr partii, ew.takze na pdst. procesu
# 32 - pobranie kodu i opisu artykulu na podstawie kodu EAN
# 33 - pobranie kodu i opisu procesu na podstawie kodu EAN
# 34 - pobranie kodu i opisu urzadzenia na podstawie kodu EAN
# 35 - pobranie listy procesw, ktre s zwolnieniami

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Oddzial':[1,2,3,4,5,21], 'Pracownik':[1,2,3,4,5,22],
           'DataOd':[1,2], 'DataDo':[1,2,3,4,5], 'Data':[1,2,3,4,5],
           'Numer':[1,2,3,4,5], 'Artykul':[23], 'Proces':[24], 'Urzadzenie':[25],
           'Partia':[31], 'ArtykulEAN':[32], 'ProcesEAN':[33], 'UrzadzenieEAN':[34]}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_produkcja_plan_czynnosci_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in (1,2,3,4,5,21):
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])

    if Funkcja in (1,2,3,4,5,22):
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])

    if Funkcja in (1,2,3,4,5):
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])
        
    if Funkcja in (1,2,3,4):    
        Proces = rsglobal.Dekoduj(klucze['Proces'])

    if Funkcja in (23,):
        Artykul = rsglobal.Dekoduj(klucze['Artykul'])

    if Funkcja in (24,):
        Proces = rsglobal.Dekoduj(klucze['Proces'])

    if Funkcja in (25,):
        Urzadzenie = rsglobal.Dekoduj(klucze['Urzadzenie'])

    if Funkcja in (31,):
        Partia = rsglobal.Dekoduj(klucze['Partia'])

    if Funkcja in (32,):
        ArtykulEAN = rsglobal.Dekoduj(klucze['ArtykulEAN'])

    if Funkcja in (33,):
        ProcesEAN = rsglobal.Dekoduj(klucze['ProcesEAN'])

    if Funkcja in (34,):
        UrzadzenieEAN = rsglobal.Dekoduj(klucze['UrzadzenieEAN'])


UprDodawanie = ((self.oddzial_id,'048101') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprEdycja = UprDodawanie or ((self.oddzial_id,'048101') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
# SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Funkcja in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Funkcja in (3,4) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR MOD'
        

#-------------------------------------------------------------------------------
# POBRANIE DANYCH DOMYSLNYCH DLA DODAWANIA (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    dane = []
    dane.append([self.oddzial_id])
    
#-------------------------------------------------------------------------------
#  POBRANIE LISTY PROCESW - ZWOLNIE (35)
#-------------------------------------------------------------------------------

if Funkcja == 35:
    SELECT ="SELECT trim(proces_id) FROM rs_procesy"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND nieobecnosc;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o procesach - zwolnieniach : '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
# POBRANIE OPISU ODDZIALU (21)
#-------------------------------------------------------------------------------

if Funkcja == 21 and stat == 'OK':
    sql ="SELECT opis FROM rs_oddzialy"
    sql+=" WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+Oddzial+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu oddziau: '+stat


#-------------------------------------------------------------------------------
# POBRANIE OPISU PRACOWNIKA (22)
#-------------------------------------------------------------------------------

if Funkcja == 22 and stat == 'OK':
    sql ="SELECT COALESCE(nazwisko,'')||' '||COALESCE(imie) FROM rs_kp_dane_osobowe"
    sql+=" WHERE firma_id='"+self.firma_id+"'AND pracownik_id='"+Pracownik+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu pracownika: '+stat


#-------------------------------------------------------------------------------
# POBRANIE OPISU ARTYKULU (23)
#-------------------------------------------------------------------------------

if Funkcja == 23 and stat == 'OK':
    sql ="SELECT nazwa FROM rs_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"'AND artykul_id='"+Artykul+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu artykuu: '+stat


#-------------------------------------------------------------------------------
# POBRANIE OPISU PROCESU (24)
#-------------------------------------------------------------------------------

if Funkcja == 24 and stat == 'OK':
    sql ="SELECT nazwa FROM rs_procesy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND proces_id='"+Proces+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu procesu: '+stat


#-------------------------------------------------------------------------------
# POBRANIE OPISU URZADZENIA (25)
#-------------------------------------------------------------------------------

if Funkcja == 25 and stat == 'OK':
    sql ="SELECT nazwa FROM rs_urzadzenia"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+Urzadzenie+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania opisu urzdzenia: '+stat


#-------------------------------------------------------------------------------
# POBRANIE DANYCH NA PDST PARTII (31)
#-------------------------------------------------------------------------------

if Funkcja == 31 and stat == 'OK':
    slow = {}
    sql ="SELECT pp.artykul_id,COALESCE(pp.nr_zamowienia,''),COALESCE(pp.przewodnik,''),pp.oddzial_id,"
    sql+=" a.nazwa"
    sql+=" FROM rs_produkcja_plan pp"
    sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    sql+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.partia_id="+Partia+";"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z planu produkcji: '+stat
    elif len(d) > 0:
        slow['Artykul'] = d[0][0]
        slow['NrZamowienia'] = d[0][1]
        slow['Przewodnik'] = d[0][2]
        slow['Oddzial'] = d[0][3]
        slow['ArtykulOpis'] = d[0][4]
        
        # jesli podano proces, to mozna sprobowac odnalezc precyzyjniej w ramach partii
        if 'MozeTenProces' in klucze:
            sql ="SELECT pp.urzadzenie_id,u.nazwa"
            sql+=" FROM rs_produkcja_plan pp"
            sql+=" INNER JOIN rs_urzadzenia u USING(firma_id,urzadzenie_id)"
            sql+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.partia_id="+Partia
            sql+=" AND pp.proces_id='"+rsglobal.Dekoduj(klucze['MozeTenProces'])+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych z planu produkcji: '+stat
            elif len(d) == 1:
                slow['Urzadzenie'] = d[0][0]
                slow['UrzadzenieOpis'] = d[0][1]
    
    if stat == 'OK':
        dane.append([slow])


#-------------------------------------------------------------------------------
# POBRANIE KODU I OPISU ARTYKULU NA PODSTAWIE EAN (32)
#-------------------------------------------------------------------------------

if Funkcja == 32 and stat == 'OK':
    sql ="SELECT ae.artykul_id,COALESCE(a.nazwa,'')"
    sql+=" FROM rs_artykuly_ean ae"
    sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    sql+=" WHERE ae.firma_id='"+self.firma_id+"'"
    sql+=" AND ae.ean='"+ArtykulEAN+"' AND ae.glowny;"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania artykuu na pdst.kodu EAN: '+stat


#-------------------------------------------------------------------------------
# POBRANIE KODU I OPISU PROCESU NA PODSTAWIE EAN (33)
#-------------------------------------------------------------------------------

if Funkcja == 33 and stat == 'OK':
    sql ="SELECT proces_id,COALESCE(nazwa,'')"
    sql+=" FROM rs_procesy"
    sql+=" WHERE firma_id='"+self.firma_id+"'AND ean='"+ProcesEAN+"';"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania procesu na pdst.kodu EAN: '+stat


#-------------------------------------------------------------------------------
# POBRANIE KODU I OPISU URZADZENIA NA PODSTAWIE EAN (34)
#-------------------------------------------------------------------------------

if Funkcja == 34 and stat == 'OK':
    sql ="SELECT urzadzenie_id,COALESCE(nazwa,'')"
    sql+=" FROM rs_urzadzenia"
    sql+=" WHERE firma_id='"+self.firma_id+"'AND ean='"+UrzadzenieEAN+"';"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania urzdzenia na pdst.kodu EAN: '+stat


#-------------------------------------------------------------------------------
# SPRAWDZENIE DANYCH 
#-------------------------------------------------------------------------------

if Funkcja in (1,2,3,4) and stat == 'OK':
    GodzinyNormalne = 0
    GodzinyPrzygotowania = 0
    # Sprawdzamy czy proces jest nieobecnoci
    nieobecnosc = False
    SQL = "Select nieobecnosc from rs_procesy where proces_id='"+Proces+"';"
    stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
    if len(d)>0 and d[0][0] == True:
        nieobecnosc = True
    
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'oddzial_id':
            if wart == '':
                stat = 'BR ODDZIAL'
                dane.append(stat)
            else:
                sql ="SELECT nazwa FROM rs_oddzialy"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia oddziau: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL ODDZIAL'
                    dane.append(stat)
            wartosci[i] = "'"+wart+"'"

        elif pole == 'pracownik_id':
            if wart == '':
                stat = 'BR PRACOWNIK'
                dane.append(stat)
            else:
                sql ="SELECT nazwisko,imie FROM rs_kp_dane_osobowe"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia pracownika: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL PRACOWNIK'
                    dane.append(stat)
            wartosci[i] = "'"+wart+"'"
                
        elif pole == 'data':
            if wart == '    -  -  ':
                stat = 'BR DATA'
                dane.append(stat)
            elif not rsglobal.SprawdzCzyToData(wart):
                stat = 'BL DATA'
                dane.append(stat)
            wartosci[i] = "'"+wart+"'"

        elif pole == 'proces_id':
            if wart == '':
                stat = 'BR PROCES'
                dane.append(stat)
            else:
                sql ="SELECT nazwa FROM rs_procesy"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND proces_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia procesu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL PROCES'
                    dane.append(stat)
            wartosci[i] = "'"+wart+"'"

        elif pole == 'urzadzenie_id':
            if not nieobecnosc:
                if wart == '':
                    stat = 'BR URZADZENIE'
                    dane.append(stat)
                else:
                    sql ="SELECT nazwa FROM rs_urzadzenia"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia urzdzenia: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL URZADZENIE'
                        dane.append(stat)
                wartosci[i] = "'"+wart+"'"
            else:
                wartosci[i] = 'null'

        elif pole == 'artykul_id': 
            if not nieobecnosc:
                if wart == '':
                    stat = 'BR ARTYKUL'
                    dane.append(stat)
                else:
                    sql ="SELECT nazwa FROM rs_artykuly"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"' AND aktywny;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia artykuu: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL ARTYKUL'
                        dane.append(stat)
                wartosci[i] = "'"+wart+"'"
            else:
                wartosci[i] = 'null'
                
        elif pole == 'nr_zamowienia':
            if not nieobecnosc:
                if wart == '' :
                    stat = 'BR NR_ZAMOWIENIA'
                    dane.append(stat)
                wartosci[i] = "'"+wart+"'"
            else:
                wartosci[i] = 'null'
                
        elif pole == 'godziny_normalne':
            GodzinyNormalne = wart
            if wart < 0 :
                stat = 'BL GODZINY_NORMALNE'
                dane.append(stat)
            wartosci[i] = str(wart)
            
        elif pole == 'godziny_przygotowania':
            GodzinyPrzygotowania = wart
            if wart < 0 :
                stat = 'BL GODZINY_PRZYGOTOWANIA'
                dane.append(stat)
            wartosci[i] = str(wart)

        elif pole == 'zrealizowano':
            if wart < 0 :
                stat = 'BL ZREALIZOWANO'
                dane.append(stat)
            wartosci[i] = str(wart)
                
        elif pole == 'braki':
            if wart < 0 :
                stat = 'BL BRAKI'
                dane.append(stat)
            wartosci[i] = str(wart)

    # czy byly bledy
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    # sprawdzenie zapisu w planie produkcji
    if stat == 'OK' and not nieobecnosc:
        sql ="SELECT partia_id,kolejnosc,lp,COALESCE(przewodnik,'')"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        for i in xrange(len(pola)):
            pole = pola[i]
            if pole in ('oddzial_id','proces_id','urzadzenie_id',
                        'artykul_id','nr_zamowienia'):
                sql+=" AND "+pole+"="+wartosci[i]
            elif pole in ('przewodnik',):
                if wartosci[i] <> '':
                    sql+=" AND "+pole+"='"+wartosci[i]+"'"
        sql += ";"

        stat,DanePlanu,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z planu produkcji: '+stat
        elif len(DanePlanu) == 0:
            stat = 'BR DANE PLANU'
            dane.append(stat)

    # Pobranie nastepnego procesu w partii do aktualizacji ilosci dostepnej do produkcji
    if stat == 'OK' and not nieobecnosc:
        sql ="SELECT partia_id,kolejnosc,lp FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(DanePlanu[0][0])
        sql+=" AND kolejnosc>"+str(DanePlanu[0][1])
        sql+=" ORDER by kolejnosc,lp LIMIT 1;"
        stat,DaneNastProcesu,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych nastpnego procesu: '+stat

    # Pobranie poprzedniego procesu w partii. Wykorzystane do sprawdzenia, czy to pierwszy proces partii
    if stat == 'OK' and not nieobecnosc:
        sql ="SELECT partia_id,kolejnosc,lp FROM rs_produkcja_plan"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(DanePlanu[0][0])
        sql+=" AND kolejnosc<"+str(DanePlanu[0][1])
        sql+=" ORDER by kolejnosc,lp LIMIT 1;"
        stat,DanePoprzProcesu,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych poprzedniego procesu: '+stat


#-------------------------------------------------------------------------------
# DODAWANIE (1,2)
#-------------------------------------------------------------------------------

if Funkcja in (1,2) and stat == 'OK':
    # DataOd i DataDo na podstawie Data: poczatek i koniec miesiaca
    DataOd = Data[:8]+'01'
    DataDo = Data[:8]+str(rsglobal.PodajOstatniDzien(Data)).zfill(2)

    # pobranie kolejnego numeru czynnosci dla pracownika w ramach klucza
    sql ="SELECT MAX(numer) FROM rs_kp_karty_pracy_czynnosci"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    sql+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
    sql+=" AND data_do='"+DataDo+"' AND data='"+Data+"';"

    stat,MaxNum,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania nowego numeru: '+stat
    elif len(MaxNum) == 0:
        Numer = 1
    else:
        Numer = MaxNum[0][0]+1
    
    # Ilosci: zrealizowano, braki
    # Potrzebne do aktualizacji procesow w planie produkcji
    Zrealizowano = 0
    Braki = 0
    
    if stat == 'OK':
        Pola = "firma_id"
        Wart = "'"+self.firma_id+"'"
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            Pola += ","+pole
            if pole == 'numer':
                Wart += ","+str(Numer)
            elif pole == 'data_od':
                Wart += ",'"+DataOd+"'"
            elif pole == 'data_do':
                Wart += ",'"+DataDo+"'"
            elif pole == 'przewodnik':
                if wart == '':
                    Wart += ",NULL"
                else:
                    Wart += ",'"+wart+"'"
            else:
                Wart += ","+wart
            if pole == 'zrealizowano':
                Zrealizowano = wartosci[i]
            elif pole == 'braki':
                Braki = wartosci[i]
        
        if not nieobecnosc:
            # Dolaczenie danych opisujacych proces w planie produkcji
            Pola += ",partia_id,kolejnosc,lp"
            Wart += ","+str(DanePlanu[0][0])+","+str(DanePlanu[0][1])+","+str(DanePlanu[0][2])
        
        INS = ""
            
        # Sprawdzenie istnienia rekordu w tabeli glownej dla czynnosci
        SQLFU ="SELECT * FROM rs_kp_karty_pracy"
        SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        SQLFU+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
        SQLFU+=" AND data_do='"+DataDo+"' FOR UPDATE;"
        
        stat,d,p,dump = self.PolSQL.Execute(SQLFU,3)
        if stat <> 'OK':
            stat = 'Nie mona zablokowa czynnoci do modyfikacji. Sprbuj za chwil'
        elif len(d) == 0:
            # Rekord dla tego okresu
            INS+="INSERT INTO rs_kp_karty_pracy"
            INS+=" (firma_id,oddzial_id,pracownik_id,data_od,data_do)"
            INS+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Pracownik+"','"+DataOd+"','"+DataDo+"'); "
    
        # Sprawdzenie istnienia rekordu w tabeli agregujacej
        SQLFU ="SELECT * FROM rs_kp_karty_pracy_dni"
        SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        SQLFU+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
        SQLFU+=" AND data_do='"+DataDo+"' AND data='"+Data+"' FOR UPDATE;"
        
        stat,DniDane,DniPola,dump = self.PolSQL.Execute(SQLFU,3)
        if stat <> 'OK':
            stat = 'Nie mona zablokowa czynnoci do modyfikacji. Sprbuj za chwil'
        elif len(DniDane) == 0:
            # Rekord dla tego dnia
            INS+="INSERT INTO rs_kp_karty_pracy_dni"
            INS+=" (firma_id,oddzial_id,pracownik_id,data_od,data_do,"
            INS+=" data,godziny_normalne,godziny_przygotowania)"
            INS+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Pracownik+"','"+DataOd+"','"+DataDo+"',"
            INS+="'"+Data+"',"+str(GodzinyNormalne)+", "
            INS+=" '"+str(GodzinyPrzygotowania)+"'); "
        else:
            # Dosumowanie do karty dziennej
            INS+="UPDATE rs_kp_karty_pracy_dni"
            INS+=" SET godziny_normalne=godziny_normalne+ "+str(GodzinyNormalne)
            INS+=" , godziny_przygotowania=godziny_przygotowania+ "+str(GodzinyPrzygotowania)
            INS+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            INS+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
            INS+=" AND data_do='"+DataDo+"' AND data='"+Data+"'; "
        
        # Rekord nowej czynnosci
        INS+="INSERT INTO rs_kp_karty_pracy_czynnosci ("+Pola+")"
        INS+=" VALUES ("+Wart+"); "
        if not nieobecnosc:
            # Aktualizacja wykonanych ilosci w procesach planu produkcji
            INS+="UPDATE rs_produkcja_plan SET"
            
            if len(DanePoprzProcesu) > 0:
                # Aktualizacja, jesli nie jest to pierwszy proces w partii
                INS+=" dostepne=COALESCE(dostepne,0)- "+str(Zrealizowano)+","
                
            INS+=" zrealizowano=COALESCE(zrealizowano,0)+ "+str(Zrealizowano)+","
            INS+=" braki=COALESCE(braki,0)+ "+str(Braki)+","
            INS+=" czas_poczatek=COALESCE(czas_poczatek,now()) "
            INS+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(DanePlanu[0][0])
            INS+=" AND kolejnosc="+str(DanePlanu[0][1])+" AND lp="+str(DanePlanu[0][2])+"; "
            
            # Aktualizacja dostepnej ilosci w nastepnym procesie jesli taki jest
            if len(DaneNastProcesu) > 0:
                INS+="UPDATE rs_produkcja_plan SET"
                INS+=" dostepne=COALESCE(dostepne,0)+ "+str(Zrealizowano)
                INS+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(DaneNastProcesu[0][0])
                INS+=" AND kolejnosc="+str(DaneNastProcesu[0][1])+" AND lp="+str(DaneNastProcesu[0][2])+"; "
            
        if stat=='OK':
            # poszerzony kod bledu
            stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
            if stat <> 'OK':
                stat = 'Bd dodawania nowej czynnosci. '+stat


#-------------------------------------------------------------------------------
# EDYCJA (3,4)
#-------------------------------------------------------------------------------

if Funkcja in (3,4) and stat == 'OK':
    SQLFU ="SELECT * FROM rs_kp_karty_pracy_czynnosci"
    SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    SQLFU+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
    SQLFU+=" AND data_do='"+DataDo+"' AND data='"+Data+"' AND numer="+str(Numer)
    SQLFU+=" FOR UPDATE;"
    stat,CzynnDane,CzynnPola,dump = self.PolSQL.Execute(SQLFU,3)
    if stat <> 'OK':
        stat = 'Nie mona zablokowa czynnoci do modyfikacji. Sprbuj za chwil'
    elif len(d) == 0:
        stat = 'Brak pozycji o podanym kluczu'
    
    SQLFU ="SELECT * FROM rs_kp_karty_pracy_dni"
    SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    SQLFU+=" AND pracownik_id='"+Pracownik+"' AND data_od='"+DataOd+"'"
    SQLFU+=" AND data_do='"+DataDo+"' AND data='"+Data+"' FOR UPDATE;"
    
    stat,DniDane,DniPola,dump = self.PolSQL.Execute(SQLFU,3)
    if stat <> 'OK':
        stat = 'Nie mona zablokowa czynnoci do modyfikacji. Sprbuj za chwil'
    elif len(d) == 0:
        stat = 'Brak pozycji o podanym kluczu'
    
    if stat == 'OK':
        UPD = "UPDATE rs_produkcja_plan_czynnosci SET "
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            UPD += pole+"="+wart+","
        UPD = UPD[:-1]
        
        # FIXME aktualizacja sum
        
        stat,dump,dump,dump = self.PolSQL.Update(UPD,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji danych: '+stat


#-------------------------------------------------------------------------------
# POBRANIE DANYCH (5,3,1)
#-------------------------------------------------------------------------------

if Funkcja in (5,3,1) and stat == 'OK':
    SELECT ="SELECT * FROM rs_kp_karty_pracy_czynnosci"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    SELECT+=" AND pracownik_id='"+Pracownik+"' AND data='"+Data+"'"
    SELECT+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"'"
    SELECT+=" AND numer="+str(Numer)+";"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych czynnoci: '+stat
    elif len(dane) == 0:
        stat = 'Brak danych o podanym kluczu'
        
    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] oddzial - opis
        if tr.GetVal(0,"oddzial_id") <> 'None':
            sql ="SELECT opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND oddzial_id='"+tr.GetVal(0,"oddzial_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania nazwy oddzialu: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod oddziau')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('')

        # [1] pracownik - nazwisko i imie
        if tr.GetVal(0,"pracownik_id") <> 'None':
            sql ="SELECT COALESCE(nazwisko,'')||' '||COALESCE(imie)"
            sql+=" FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND pracownik_id='"+tr.GetVal(0,"pracownik_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania danych pracownika: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod pracownika')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('')

        # [2] proces - nazwa
        if tr.GetVal(0,"proces_id") <> 'None':
            sql ="SELECT nazwa FROM rs_procesy WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND proces_id='"+tr.GetVal(0,"proces_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania nazwy procesu: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny symbol procesu')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('')
        
        # [3] urzadzenia - nazwa
        if tr.GetVal(0,"urzadzenie_id") <> 'None':
            sql ="SELECT nazwa FROM rs_urzadzenia WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND urzadzenie_id='"+tr.GetVal(0,"urzadzenie_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania nazwy urzadzenia: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod urzadzenia')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('')

        # [4] artykul - nazwa
        if tr.GetVal(0,"artykul_id") <> 'None':
            sql ="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania nazwy artykuu: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod artykuu')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('')
