# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_produkcja_plan_dane.py
# Purpose:     plan produkcji - edycja/dodawanie danych 
# Author:      Dariusz Boduch
# Created:     2010/02/01
# RCS-ID:      $Id: fs_produkcja_plan_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-03-03 Mariusz Rajfura (6633) edycja pozycji analitycznej planu

import datetime
from funkcje import fs_produkcja_plan_pom

#-------------------------------------------------------------------------------

Oddzial = rsglobal.Dekoduj(klucze[0]).strip()
Data = rsglobal.Dekoduj(klucze[1]).strip()
Zmiana = rsglobal.Dekoduj(klucze[2]).strip()
Proces = rsglobal.Dekoduj(klucze[3]).strip()
Artykul = rsglobal.Dekoduj(klucze[4]).strip()
Urzadzenie = rsglobal.Dekoduj(klucze[5]).strip()
GodzMin = rsglobal.Dekoduj(klucze[6]).strip()
Partia = klucze[7]
Kolejnosc = klucze[8]
LP = klucze[9]

Fun = klucze[-1]
stat = 'OK'
dane = []
wyn2 = []

Ilosc = 0
Uwagi = 'NULL'
Proces1Poz = None

DataN = None
GodzMinN = None
UwagiN = None
IloscN = None
Znak = None
Interval = None
DataNaKiedyN = None
UrzadzenieN = None
NrZamowieniaN = None

Urzadzenie1Poz = None
PartiaWRealizacji = False
ProcesWRealizacji = False

BladZajetosci=[False,False,False]

UprIns=((self.oddzial_id,'048003') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprUpd=((self.oddzial_id,'048002') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#--- sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprIns:
        stat = 'BR_UPR_INS'

if Fun in (3,4):
    if not UprUpd:
        stat = 'BR_UPR_EDY'

                    
#-------------------------------------------------------------------------------
#--- sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    if Oddzial == '':
        stat='BR_ODDZIAL'
        dane.append(stat)
    else:
        sql ="SELECT oddzial_id FROM rs_oddzialy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzania danych oddziau: '+stat
        else:
            if len(d) == 0:
                stat = 'BL_ODDZIAL'
                dane.append(stat)
                
    if stat == 'OK':
        if Data == '    -  -  ':
            stat == 'BR_DATA'
            dane.append(stat)
        else:
            if not rsglobal.SprawdzCzyToData(Data):
                stat = 'BL_DATA'
                dane.append(stat)
                
    if stat == 'OK':
        if Artykul == '':
            stat = 'BR_ARTYKUL'
            dane.append(stat)
        else:
            sql ="SELECT artykul_id, aktywny FROM rs_artykuly"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Artykul+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat='Bd sprawdzenia symbolu artykuu: '+stat
                dane.append(stat)
            else:
                if len(d) == 0:
                    stat='BL_ARTYKUL'
                    dane.append(stat)
                else:
                   if not d[0][1]:
                    stat='AKT_ARTYKUL'
                    dane.append(stat)

if Fun in (3,4) and stat == 'OK':
    sql ="SELECT kolejnosc,proces_id,urzadzenie_id, czas, maks_ilosc"
    sql+=" FROM rs_procesy_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    sql+=" ORDER BY kolejnosc;"
    stat,danePA,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania procesw z receptury dla artykuu: '+stat
        dane.append(stat)
    elif len(danePA) == 0:
        stat = 'Podany artyku nie ma zdefiniowanych procesw w recepturze.'
        dane.append(stat)

if Fun in(3,4) and stat == 'OK':
    sql ="SELECT oper_poczatek,oper_koniec,oper_przekazanie,"
    sql+=" godz_minuta,data,data_na_kiedy,czas_poczatek IS NOT NULL"
    sql+=" FROM rs_produkcja_plan"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND partia_id="+str(Partia)
    sql+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)
    sql+=" FOR UPDATE NOWAIT;"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z pozycji: '+stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak procesu o podanej partii i kolejnoci: '+stat
        dane.append(stat)
            
    if stat == 'OK':
        GodzMinutaX = rsglobal.Dekoduj(d[0][3])
        DataX = rsglobal.Dekoduj(d[0][4])
        DataNaKiedyX = rsglobal.Dekoduj(d[0][5])
        ProcesWRealizacji = d[0][6]
        
        #pobranie danych wszystkich pozycji dla partii - dodatkowo blokada FOR UPDATE
        sql ="SELECT oper_poczatek,oper_koniec,oper_przekazanie,data,godz_minuta,"
        sql+=" kolejnosc,lp,data_konca,godz_minuta_konca"
        sql+=" FROM rs_produkcja_plan"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND partia_id="+str(Partia)
        sql+=" ORDER BY kolejnosc FOR UPDATE NOWAIT;"

        stat,danePP,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych dla caego zadania: '+stat
            dane.append(stat)
        elif len(danePP) == 0:
            stat = 'Brak procesw o podanym numerze partii produkcyjnej: '+stat
            dane.append(stat)
    
    #jakas forma sprawdzenia, czy ktorys z procesow zadania byl juz w uzyciu
    #teraz kontroluje kody operatorow
    if stat == 'OK':
        if ProcesWRealizacji:
            PartiaWRealizacji = True
        else:
            for i in xrange(len(danePP)):
                if danePP[i][0] > 0 or danePP[i][1] > 0 or danePP[i][2] > 0:
                    PartiaWRealizacji = True
                    break

if Fun in (3,4) and stat == 'OK':
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole == 'zmiana':
            Zmiana = wart
            if wart=='':
                stat='BR_ZMIANA'
                dane.append(stat)
            wartosci[i] = "'"+wart+"'"

        elif pole == 'godz_minuta':
            wart = rsglobal.Dekoduj(wart)
            GodzMinN = wart
            if wart == '  :  ':
                stat='BR_TIME'
                dane.append(stat)
            elif ProcesWRealizacji:
                stat = 'Proces '+Proces+' w trakcie realizacji. Modyfikacja czasu rozpoczecia niemoliwa'
                dane.append(stat)
            else:
                stat,d,dump,dump = self.PolSQL.Execute("SELECT '"+wart+"'::TIME;",2)
                if stat <> 'OK':
                    stat='BL_TIME'
                    dane.append(stat)

        elif pole == 'data':
            if Fun in (3,4):
                DataN = wart
                if not rsglobal.SprawdzCzyToData(wart):
                    stat='BL_DATA'
                    dane.append(stat)
                elif ProcesWRealizacji:
                    stat = 'Proces '+Proces+' w trakcie realizacji. Modyfikacja czasu rozpoczecia niemoliwa'
                    dane.append(stat)

        elif pole == 'data_na_kiedy':
            DataNaKiedyN = wart
            if wart == '    -  -  ':
                stat = 'BR_DATA_NA_KIEDY'
                dane.append(stat)
            elif not rsglobal.SprawdzCzyToData(wart):
                stat = 'BL_DATA_NA_KIEDY'
                dane.append(stat)

        elif pole == 'uwagi':
            if wart.strip() <> '':
                UwagiN = "'"+wart.strip()+"'"
            else:
                UwagiN = 'NULL'
                
        elif pole == 'do_produkcji':
            Ilosc = wart
            IloscN = wart
            if wart == 0:
                stat = 'BR_ILOSC'
                dane.append(stat)
            else:
                if PartiaWRealizacji:
                    stat = 'Zadanie w trakcie realizacji. Zmiana iloci niemoliwa.'
                    dane.append(stat)
                    
                if stat == 'OK':
                    for i in xrange(len(danePA)):
                        if danePA[i][4] > 0:
                           if Ilosc > danePA[i][4]:
                               stat ='Podana do wyprodukowania ilo '+str(Ilosc)
                               stat+=' przekracza maksymaln ilo dla procesu '+rsglobal.Dekoduj(danePA[i][1]).strip()
                               stat+=' = '+str(danePA[i][4])
                               dane.append(stat)
                               
        elif pole == 'urzadzenie_id':
            UrzadzenieN = wart
            wart = wart.strip()
            if wart == '':
                stat = 'BR URZADZENIE'
                dane.append(stat)
            else:
                sql ="SELECT oddzial_id FROM rs_urzadzenia"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+wart+"';"
        
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia urzdzenia: '+stat
                elif len(d) == 0:
                    stat = 'BL_URZADZENIE'
                    dane.append(stat)
                elif rsglobal.Dekoduj(d[0][0]) <> '**':
                    if rsglobal.Dekoduj(d[0][0]) <> Oddzial:
                        stat = 'BL_URZADZ_ODDZ'
                        dane.append(stat)
                    
            if stat=='OK':
                sql ="SELECT * FROM rs_procesy_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND proces_id='"+Proces+"'"
                sql+=" AND artykul_id='"+Artykul+"' AND urzadzenie_id='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia urzdzenia w procesach-artykuach: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_URZADZ_PROC_ART'
                    dane.append(stat)

        elif pole == 'nr_zamowienia':
            if wart.strip() <> '':
                NrZamowieniaN = "'"+wart.strip()+"'"
            else:
                NrZamowieniaN = 'NULL'


                               
    #jesli byly jakies bledy, stat = pierwszy blad z listy        
    if len(dane) > 0:
        stat = dane[0]
    
    #jesli zakladamy, to data_na_kiedy musi byc wypelniona
    if stat == 'OK' and Fun in (1,2):
        if DataNaKiedyN == None:
            stat = 'BR_DATA_NA_KIEDY'
            dane.append(stat)
    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = ''

    #aktualizacja nr_zamowienia we wszystkich pozycjach
    if NrZamowieniaN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET nr_zamowienia="+NrZamowieniaN
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)+";"

    #aktualizacja urzadzenia
    if UrzadzenieN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET urzadzenie_id='"+UrzadzenieN+"'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        UPDATE+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"
    
    #aktualizacja ilosci do produkcji we wszystkich pozycjach
    if IloscN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET do_produkcji="+str(IloscN)
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)+";"
        
    #aktualizacja opisu w wybranej pozycji
    if UwagiN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET uwagi="+UwagiN
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        UPDATE+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"

    #aktualizacja data_na_kiedy
    if DataNaKiedyN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET data_na_kiedy='"+DataNaKiedyN+"'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)+";"
        
    #aktualizacja data
    if DataN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET data='"+DataN+"'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        UPDATE+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"
        
    #aktualizacja godz_minuta
    if GodzMinN <> None:
        UPDATE+="UPDATE rs_produkcja_plan SET godz_minuta='"+GodzMinN+"'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        UPDATE+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"
        
    #jesli zaktualizowano date lub czas lub urzdzenie to przesuwamy nasz pozycj w czasie
    if stat == 'OK' and Fun in (3,4) and (DataN <> None or GodzMinN <> None or UrzadzenieN<>None):
        SQL="SELECT do_produkcji,kalendarz_id,data,godz_minuta FROM rs_produkcja_plan "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
        SQL+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"
        stat,DProdTmp,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd pobierania pozycji z planu produkcji : '+stat
        elif len(DProdTmp)==0:
            stat='Brak modyfikowanej pozycji w bazie'
            
        if stat=='OK':
            if UrzadzenieN<>None:
                UrzadzenieTmp=UrzadzenieN
            else:
                UrzadzenieTmp=Urzadzenie
                
            if IloscN<>None:
                IloscTmp=IloscN
            else:
                IloscTmp=DProdTmp[0][0]
                
            Kalendarz=DProdTmp[0][1]
            
            if DataN<>None:
                DataTmp=DataN
            else:
                DataTmp=DProdTmp[0][2]
                
            if GodzMinN<>None:
                GodzMinTmp=GodzMinN
            else:
                GodzMinTmp=DProdTmp[0][3]
            
            stat,CzasKonca=fs_produkcja_plan_pom.WstawPlanProdukcjiDoUrzadzenia(self,Artykul,Oddzial,UrzadzenieTmp,IloscTmp,
                       Kolejnosc,DataTmp+' '+GodzMinTmp,15,Partia,Kalendarz,LP,'','',True)
                       
        if stat=='OK':
            UPDATE+="UPDATE rs_produkcja_plan SET data_konca='"+CzasKonca[0:10]+"',godz_minuta_konca='"+CzasKonca[11:]+"'"
            UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
            UPDATE+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"
            
        if stat=='OK':
            # sprawdzenie kolizji na urzadzeniach i w ramach partii w celu poinformowania operatora
    
            # sprawdzenie czy nasza nowa pozycja nie zachodzi na jak inn na urzdzeniu w tym okresie
            CzasPoczZaj=" (data||' '||godz_minuta)::TIMESTAMP "
            CzasKoncaZaj=" (data_konca||' '||godz_minuta_konca)::TIMESTAMP "
                        
            SQL="SELECT "+CzasKoncaZaj+" FROM rs_produkcja_plan "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+Urzadzenie+"'"
            SQL+=" AND ("+CzasPoczZaj+","+CzasKoncaZaj+") OVERLAPS ('"+DataTmp+' '+GodzMinTmp+"'::TIMESTAMP,'"+CzasKonca+"'::TIMESTAMP)"
            SQL+=" AND NOT (firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
            SQL+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+")"
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)    
            if stat<>'OK':
                stat='Bd sprawdzania zajtoci na urzdzeniu :'+stat
            elif len(DTest)>0:
                BladZajetosci[0]=True

            # sprawdzenie czy nasza nowa pozycja nie zachodzi na jak wczeniejsz w ramach partii
            SQL="SELECT DISTINCT kolejnosc FROM rs_produkcja_plan "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
            SQL+=" AND kolejnosc<>"+str(Kolejnosc)
            SQL+=" AND ("+CzasPoczZaj+","+CzasKoncaZaj+") OVERLAPS ('"+DataTmp+' '+GodzMinTmp+"'::TIMESTAMP,'"+CzasKonca+"'::TIMESTAMP)"
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)    
            if stat<>'OK':
                stat='Bd sprawdzania zajtoci w ramach partii :'+stat
            if stat=='OK':
                for poz in DTest:
                    if poz[0]<Kolejnosc:
                        BladZajetosci[1]=True
                    elif poz[0]>Kolejnosc:
                        BladZajetosci[2]=True
                
                    
    # UPDATE OSTATECZNY
    if stat=='OK' and UPDATE <> '':
        stat,d,dump,dump = self.PolSQL.Execute(UPDATE, 1)
        if stat <> 'OK':
            stat = 'BL_UPDATE'
   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem  1-insert z pobraniem )
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    wyn2 = []
    
    if GodzMinN <> None:
        GodzMin = GodzMinN
    
    if DataN <> None:
        Data = DataN

    if UrzadzenieN <> None:
        Urzadzenie = UrzadzenieN

    SELECT ="SELECT * FROM rs_produkcja_plan"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
    SELECT+=" AND kolejnosc="+str(Kolejnosc)+" AND lp="+str(LP)+";"
    
    rsglobal.ZapiszDoLogow('SQL '+SELECT,1)

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    rsglobal.ZapiszDoLogow('len '+str(len(dane)),1)
    if stat <> 'OK':
        stat = 'Bd pobrania danych urzdzenia'
        dane.append(stat) 

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # [0] artykul - czy_produkcja_ciagla
        sql ="SELECT czy_produkcja_ciagla FROM rs_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych artykuu dla produkcji: '+stat
        else:
            wyn2.append(d[0][0])

        # [1] stan procesu: 0=oczekuje 1=trwa 2=zakonczony  -1=inny
        if tr.GetVal(0,"czas_poczatek") in ('None','','NULL'):
            wyn2.append(0)
        elif not tr.GetVal(0,"czas_poczatek") in ('None','','NULL') and tr.GetVal(0,"czas_koniec") in ('None','','NULL'):
            wyn2.append(1)
        elif not tr.GetVal(0,"czas_poczatek") in ('None','','NULL') and not tr.GetVal(0,"czas_koniec") in ('None','','NULL'):
            wyn2.append(2)
        else:
            wyn2.append(-1)
        
        # [2] opis artykulu
        if ((self.oddzial_id,'013011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu z katalogu artykuow : '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod artykuu.')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do katalogu artykuw. Poinformuj administratora.')

        # [3] opis urzadzenia
        if ((self.oddzial_id,'029100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT nazwa FROM rs_urzadzenia WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND urzadzenie_id='"+tr.GetVal(0,"urzadzenie_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu z katalogu urzdze : '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod urzdzenia.')
                else:
                    wyn2.append(str(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do katalogu urzdze. Poinformuj administratora.')

        # informacja o komunikatach o nachodzeniu na siebie kawakw planu po zapisie danych
        wyn2.append(BladZajetosci)