# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_produkcja_plan_pom.py
# Purpose:     funkcje pomocnicze do planu produkcji
# Author:      Micha Raburski
# Created:     2013/03/13
# RCS-ID:      $Id: fs_produkcja_plan_pom.py$
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-04-23 Mariusz Rajfura (6806) nowe pole na gridzie nieciaglej 'przewodnik', dodanie w planie produkcji
# 2013-04-30 Mariusz Rajfura (6827) nowe pole 'technologia_id' dodawane w planie produkcji

import rsglobal
import math 

#-------------------------------------------------------------------------------
# FUNKCJA WSTAWIAJCA DANE DO PLANU PRODUKCJI
#-------------------------------------------------------------------------------

def WstawPlanProdukcjiDoUrzadzenia(self,Artykul,Oddzial,Urzadzenie,Ilosc,Kolejnosc,DataCzas,Priorytet,NrPartii,
    Kalendarz,Lp,NrZamowienia,DataNaKiedy,CzyTylkoDataKonca,Przewodnik,Technologia):
    # parametry
    # self - obiekt, ktry zawiera poczenie do bazy, firm oddzia, uprawnienia uytkownika itp
    # Artykul - artyku, ktry bdziemy wstawia
    # Oddzial - oddzia do ktrego wstawiamy produkcj
    # Urzadzenie - urzdzenie na ktrym naley umieci plan produkcji
    # Ilosc - ile sztuk bdzie zamwione do produkcji
    # Kolejnosc - pole porzdkowe wpisywane podczas wstawienia danych
    # DataCzas - czas od ktrego zaczynamy szuka wolnego miejsca
    # Priorytet - priorytet zamwienia. 0 najniszy. Priorytet uwzgldnia jedynie zajto rwnego mu lub wyszego priorytetu
    # NrPartii - Nr zamwienia ktrego dotyczy wstawienie
    # Kalendarz - kalendarz kadrowy mwicy o czasie pracy ludzi na danym urzdzeniu
    # Lp - kolejno proceus podczas produkcji. Pomaga znale wydajno urzdzenia
    # NrZamowienia - numer zamwienia wpisywany do wstawianej pozycji
    # DataNaKiedy - data na kiedy wpisywana do wstawianej pozycji
    # CzyTylkoDataKonca - pole techniczne. Jeli False to normalnie tworzy plan produkcji. 
    #          Jeli True to podaje czas koca wyliczony na podstawie wydajnoci ignorujc priorytety itp.
    # Przewodnik - numer dokumentu obiegowego dla calego procesu produkcji artykulu
    # Technologia - kod ze slownika, dane specyficzne
    
    # jeli liczymy "na twardo" to po prostu ustawiamy priorytet na 15 co w praktyce ignoruje wszystkie zajtoci
    if CzyTylkoDataKonca:
        Priorytet=15
    
    # pobranie procesu oraz wydajnoci godzinowej urzdzenia
    Kolejnosc=str(Kolejnosc)
    Data=DataCzas[0:10]
    Godz=DataCzas[11:]
    
    SQL="SELECT proces_id,maks_ilosc FROM rs_procesy_artykuly WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND artykul_id='"+Artykul+"' AND urzadzenie_id='"+Urzadzenie+"' AND kolejnosc="+Kolejnosc
    stat,DProces,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return ['Bd pobierania procesu z rs_procesy_artykuly : '+stat,'']
    
    if len(DProces)==0:
        return ['Brak danych w rs_procesy_artykuly dla artykuu '+Artykul+", urzdzenia "+Urzadzenie+" i kolejnoci "+Kolejnosc,'']
    
    Proces=DProces[0][0].strip()
    MaksIlosc=DProces[0][1]
    
    # wyznaczenie ile czasu w minutach bdzie potrzebne na wykonanie danej pracy na urzdzeniu
    # zmienna "pocztkowa"
    CzasPracy=math.ceil((60/float(MaksIlosc))*Ilosc)
    
    # zmienne, ktrymi bdziemy manewrowa
    CzasPozostaly=int(CzasPracy) # - zmienna mwica ile minut zostao do analizy. 
                                 # Zmienia si razem z trafionymi zmianami i resetuje jeli zaczynamy od nowa
    PoczGlobalny=str(DataCzas)   # zmienna pocztku analizy. Nie zmienia si z trafieniami,
                                 # ale przesuwa w przd jeli zaczynamy od nowa
    KoniecGlobalny=''            # pole techniczne uzupeniane na kocu algorytmu
    CzasPocz=str(DataCzas)       # zmienna aktualnego czasu analizy. zmienia si z trafieniami,
                                 # gdy zaczynamy od nowa wyrwnuje si z pocztkiem globalnym
    DataAkt=str(Data)            # zmienna pomocnicza zgodna z analizowanym czasem
    
    # pobranie czasw kalendarzowych do sownika. Powinny by "wszystkie" dni od daty pocztkowej.
    # jeli kiedy zabraknie dni to zwrcony bdzie bd
    SQL="SELECT dzien, COALESCE(od_kiedy1::TEXT,''),COALESCE(do_kiedy1::TEXT,''),"
    SQL+="COALESCE(od_kiedy2::TEXT,''),COALESCE(do_kiedy2::TEXT,''),"
    SQL+="COALESCE(od_kiedy3::TEXT,''),COALESCE(do_kiedy3::TEXT,'')"
    SQL+=" FROM rs_kp_kalendarze_dni WHERE firma_id='"+self.firma_id+"' AND kalendarz_id='"+Kalendarz+"'"
    SQL+=" AND dzien>='"+Data+"' ORDER BY dzien;"
    stat,DKalendarz,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return ['Bd pobierania kalendarza : '+stat,'']
    
    SKalendarz={}
    
    for poz in DKalendarz:
        # zakadamy, e zmiany s wypenione w kolejnoci i parami (na kocu czas trwania w minutach)
        SKalendarz[poz[0]]=[]
        if poz[1]<>'':
            SKalendarz[poz[0]].append((poz[1],poz[2]))
        if poz[3]<>'':
            SKalendarz[poz[0]].append((poz[3],poz[4]))
        if poz[5]<>'':
            SKalendarz[poz[0]].append((poz[5],poz[6]))
    
    # ptla gwna po czasie realizacji, kalendarzu i zmianach kalendarzowych
    while CzasPozostaly>0:
        # jeli nie ma aktualnego dnia w kalendarzu to zgaszamy bd
        if not DataAkt in SKalendarz:
            return ['Brak dnia '+DataAkt+' w kalendarzu '+Kalendarz+' a jest on potrzebny do stworzenia planu produkcji.','']
    
        # dla dnia sprawdzamy czy jego zmiany mog by w sposb cigy wykorzystane do produkcji
        LZmian=SKalendarz[DataAkt]
        
        if len(LZmian)==0:
            SQL="SELECT '"+DataAkt+"'::DATE+1;"
            stat,DDatyAkt,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                return ['Bdy w obliczaniu nastpnej daty aktualnej '+stat,'']
            DataAkt=DDatyAkt[0][0]
        
        for poz in LZmian:
            PoczZmiany=DataAkt+' '+poz[0]
            KonZmiany=DataAkt+' '+poz[1]
            #jeli koniec zmiany wikszy ni pocztek czasu to jest sens analizowa czasy
            # pozwoli to te na wielokrotne testowanie w ramach tej samej zmiany 
            while KonZmiany>CzasPocz and CzasPozostaly>0:
                # jako pocztek analizy wybieramy wikszy z pocztkw
                if PoczZmiany>CzasPocz:
                    PoczTmp=PoczZmiany
                    # jeli to pierwsze przesunicie pocztku to pocztek globalny 
                    # ustawiamy na pocztek analizowanej zmiany
                    if  CzasPozostaly==int(CzasPracy):
                        PoczGlobalny=PoczZmiany
                else:
                    PoczTmp=CzasPocz
                    
                
                # jako koniec analizy wybieramy albo koniec zmiany albo (jeli minuty mieszcz si w tej zmianie)
                # ustalony czas pocztku + pozostae minuty
                SQL="SELECT '"+PoczTmp+"'::TIMESTAMP+ INTERVAL '"+str(CzasPozostaly)+" MINUTES';"
                stat,DKonProd,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    return ['Bd pobierania testowego czasu koca produkcji : '+stat,'']
                
                if KonZmiany>DKonProd[0][0]:
                    KoniecTmp=DKonProd[0][0]
                    MinutyDoOdjecia=int(CzasPozostaly)
                else:
                    KoniecTmp=KonZmiany
                    # wyznaczamy ile minut nam to "zajmie"
                    SQL="SELECT (EXTRACT(EPOCH FROM '"+KoniecTmp+"'::TIMESTAMP-'"+PoczTmp+"'::TIMESTAMP)/60)::INT"
                    stat,DMinuty,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        return ['Bd pobierania zakresu czasu uytego w zmianie : '+stat,'']
                    MinutyDoOdjecia=DMinuty[0][0]
                    
                # sprawdzenie czy w zakresie PoczTmp, KoniecTmp jest zajte urzdzenie. 
                # jeli tak to resetujemy wyszukiwanie i jako nowy pocztek ustawiamy koniec zajtoci urzdzenia w tej zmianie
                
                # zmienne pomocnicze
                CzasPoczZaj=" (data||' '||godz_minuta)::TIMESTAMP "
                CzasKoncaZaj=" (data_konca||' '||godz_minuta_konca)::TIMESTAMP "
                    
                SQL="SELECT "+CzasKoncaZaj+" FROM rs_produkcja_plan "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+Urzadzenie+"' AND priorytet>="+str(Priorytet)
                SQL+=" AND ("+CzasPoczZaj+","+CzasKoncaZaj+") OVERLAPS ('"+PoczTmp+"'::TIMESTAMP,'"+KoniecTmp+"'::TIMESTAMP)"
                SQL+=" ORDER BY "+CzasKoncaZaj+" DESC;"
                stat,DZajetosc,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    return ['Bd testu zajtosci urzdzenia : '+stat,'']
                
                # jeli nic nie ma to usuwamy minuty i przesuwamy czas na koniec zmiany. 
                # to nam wyjdzie z ptli dla jednej zmiany i rozpocznie kolejn zmian w dniu
                if len(DZajetosc)==0:
                    CzasPozostaly=CzasPozostaly-MinutyDoOdjecia
                    CzasPocz=KonZmiany
                    
                # jeli s dane to znaczy, e urzdzenie jest zajte i musimy zacz analiz niejako od pocztku.
                # zaczynamy j od koca zajtoci urzdzenia wynikej ze znalezionych rekordw w rs_produkcja plan.
                # resetujemy PoczGlobalny,CzasPocz, CzasPozostaly i jedziemy dalej ze zmianami
                else:
                    CzasPozostaly=int(CzasPracy)
                    PoczGlobalny=DZajetosc[0][0]
                    CzasPocz=DZajetosc[0][0]
                
                # jeli pozostay czas jest rwny 0 to ustalamy technicznie czas zakonczenia
                if CzasPozostaly==0:
                    KoniecGlobalny=str(KoniecTmp)
            
            # jeli tu jestemy CzasPozostaly>0 to musimy przeskoczyc do nastepnego dnia lub dnia z CzasPocz
            # jeli zdy si zmieni.
            if CzasPozostaly>0:
                if DataAkt <> CzasPocz[0:10]:
                    DataAkt=CzasPocz[0:10]
                else:
                    SQL="SELECT '"+DataAkt+"'::DATE+1;"
                    stat,DDatyAkt,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        return ['Bdy w obliczaniu nastpnej daty aktualnej '+stat,'']
                    DataAkt=DDatyAkt[0][0]
    
    if not CzyTylkoDataKonca:
        # wyszukiwanie wolnego miejsca zakoczyo si sukcesem. Wstawiamy rekord do planu produkcji
        
        Przewodnik = Przewodnik.strip()
        if Przewodnik == '':
            Przewodnik = "NULL"
        else:
            Przewodnik = "'"+Przewodnik+"'"

        Technologia = Technologia.strip()
        if Technologia == '':
            Technologia = "NULL"
        else:
            Technologia = "'"+Technologia+"'"
        
        SQL+="INSERT INTO rs_produkcja_plan "
        SQL+="(firma_id,priorytet,oddzial_id,data,zmiana,"
        SQL+="proces_id,artykul_id,urzadzenie_id,godz_minuta,do_produkcji,"
        SQL+="partia_id,kolejnosc,data_na_kiedy,data_ekspedycja,zmiana_ekspedycja,"
        SQL+="lp,data_konca,godz_minuta_konca,nr_zamowienia,kalendarz_id,"
        SQL+="przewodnik,technologia_id) "
        SQL+="VALUES ('"+self.firma_id+"',"+str(Priorytet)+",'"+Oddzial+"','"+PoczGlobalny[0:10]+"','"+str(Priorytet)+"',"
        SQL+="'"+Proces+"','"+Artykul+"','"+Urzadzenie+"','"+PoczGlobalny[11:]+"',"+str(Ilosc)+","
        SQL+=str(NrPartii)+","+str(Kolejnosc)+",'"+DataNaKiedy+"',NULL,NULL,"
        SQL+=str(Lp)+",'"+KoniecGlobalny[0:10]+"','"+KoniecGlobalny[11:]+"','"+NrZamowienia+"','"+Kalendarz+"',"
        SQL+=Przewodnik+","+Technologia+");"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            return ['Bd wstawiania pozycji do planu produkcji : '+stat,'']
        
    return ['OK',KoniecGlobalny]