# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_spis_z_natury.py
# Purpose:     wczytuje/usuwa dane ze spisami z natury
#
# Author:      Marcin Grzeda
# Created:     2006/05/22
# RCS-ID:      $Id: fs_projekty.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2017-08-23 Piotr Witkowski (10676) Refaktoryzacja

from funkcje import fs_sprawdz_analityke

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'ProjektId':[1,6,7],'ProjektIdF':[1,5,6,7],'NazwaF':[1,5,6,7],'DataOdF':[1,5,6,7],'DataDoF':[1,5,6,7],
             'Aktywny':[1,5,6,7],'LKl':[1,5,6,7],'Projekt_Nowy':[7,]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = "Uwaga: wywoanie funkcji fs_kierowcy_wersje_przewoznicy z numerem "+str(Funkcja)+" bez parametrw: "+Lista

    if Funkcja in [7,]:
        Projekt_Nowy = klucze['Projekt_Nowy']
    if Funkcja in [1,6,7]:
        ProjektId = klucze['ProjektId']
    if Funkcja in [1,5,6,7]:
        ProjektIdF = klucze['ProjektIdF']
        NazwaF = klucze['NazwaF']
        DataOdF = klucze['DataOdF']
        DataDoF = klucze['DataDoF']
        Aktywny = klucze['Aktywny']
        LKl = klucze['LKl']

UprPrzegladanie=((self.oddzial_id,'027010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDodawanie=((self.oddzial_id,'027013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUsuwanie=((self.oddzial_id,'027014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprZmianaKlucza=((self.oddzial_id,'027015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
if not UprPrzegladanie:
    stat = "Brak uprawnie do okna"

#-------------------------------------------------------------------------------
#---   ZMIANA KLUCZA (7)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 7:
    if not UprZmianaKlucza:
        stat="Brak uprawnie do zmiany klucza"     
        dane.append(stat)
    
    if stat=="OK":             
        sql ="SELECT projekt_id FROM rs_projekty"
        sql+=" WHERE projekt_id = '"+ProjektId+"' and firma_id = '"+self.firma_id+"' FOR UPDATE NOWAIT;"
        stat,d,dum,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bd przy sprawdzaniu symbolu projektu :'+stat
            dane.append(stat)
        elif len(d) == 0:
            stat="Podany symbol projekt nie istnieje."   
            dane.append(stat)
    
    stat = fs_sprawdz_analityke.CzyMoznaUsunac(self,'rs_projekty',ProjektId,'')
    
    if stat=="OK":            
        sql ="SELECT projekt_id FROM rs_projekty"
        sql+=" WHERE projekt_id = '"+Projekt_Nowy+"' and firma_id = '"+self.firma_id+"'"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd przy sprawdzaniu nowego symbolu projektu :'+stat
            dane.append(stat)
        elif len(d) > 0:    
            stat="Podany symbol projektu jest ju wykorzystywany."   
            dane.append(stat)
    
    if stat=="OK":
        UPDATE ="UPDATE rs_projekty SET projekt_id = '"+Projekt_Nowy+"'"
        UPDATE+=" WHERE projekt_id = '"+ProjektId+"' AND firma_id = '"+self.firma_id+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd zmiany symbolu projektu : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if not UprDodawanie:
        stat='UPR INS'
        dane.append(stat)    
    else:    
        stat,d,w1,t = self.PolSQL.Execute("SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+ProjektId+"';",3)
        if len(d)==0:
            stat,dump,dump,dump = self.PolSQL.Execute("INSERT INTO rs_projekty (firma_id,projekt_id,nazwa,opis) VALUES ('"+self.firma_id+"','"+ProjektId+"','','');" ,1)
            LKl.append(ProjektId)
        else:
            stat='UZ ID'


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprUsuwanie:
        stat='UPR DEL'
        dane.append(stat)    
    else:    
        stat = fs_sprawdz_analityke.CzyMoznaUsunac(self,'rs_projekty',ProjektId,'')
        if stat == 'OK':
            stat,dane,dump,dump = self.PolSQL.Execute("SELECT COUNT(projekt_id) FROM rs_kontrahenci_fakturowanie WHERE projekt_id='"+ProjektId+"';",3)
            if int(dane[0][0]) == 0:
                stat,dane,dump,dump = self.PolSQL.Execute("SELECT COUNT(projekt_id) FROM rs_faktury WHERE projekt_id='"+ProjektId+"';",3)
                if int(dane[0][0]) == 0:        
                    stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+ProjektId+"';" ,1)
                    if stat <> 'OK':
                        stat = 'Bd usuwania projektu. Projekt moe by wykorzystany w innych tabelach: '+stat
                else:
                    stat='BL POW'
            else:
                stat='BL POW'


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete, 1 - insert, 7 - zmiana klucza)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,5,6,7]:
    Filtr="WHERE firma_id='"+self.firma_id+"'"
    if ProjektIdF <> '':
        Filtr=Filtr+" AND projekt_id LIKE '"+ProjektIdF+"%'"
    if NazwaF <> '':
        Filtr=Filtr+" AND nazwa LIKE '"+NazwaF+"%'"        
    if DataOdF <> '    -  -  ':
        Filtr=Filtr+" AND data_od>='"+DataOdF+"'"                
    if DataDoF <> '    -  -  ':
        Filtr=Filtr+" AND data_do<='"+DataDoF+"'"
    if Aktywny==True:
        Filtr=Filtr+" AND aktywny=True"
        
    if len(LKl) > 0:
        LKluczy=[]
        for k in LKl:
            LKluczy.append(rsglobal.Dekoduj(k))
        Filtr=Filtr+" OR (firma_id='"+self.firma_id+"' AND projekt_id in ("+str(LKluczy)[1:-1]+") )"

    Select ="SELECT COALESCE(identyfikator,''),projekt_id,nazwa,opis,COALESCE(data_od::text,''),COALESCE(data_do::text,''),COALESCE(handlowiec_wiad,''),COALESCE(dzial_wiad,'') FROM rs_projekty "+Filtr
    Select+=" ORDER BY projekt_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)