
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_przeszacowania_pozycje.py
# Purpose:     wyswietla, dodaje,usuwa pozycje przeszacowa operujac na tabeli rs_arkusze_przeszacowania_pozycje
# Author:      Marcin Wlodarczyk, Pawe Wjcikowski
# Created:     2008/11/12
# RCS-ID:      $Id: fs_przeszacowania_pozycje.py$
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2015-06-23 Piotr Witkowski (0008808) refaktoryzacja przeszacowania pozycje - nowy grid
#
# Funkcje:
# 1. Update danych - odwierzenie danych przy przegldaniu grida
# 4. Insert danych - dodanie nowego  srodka do bazy danych
# 5. Select - pobranie informacji z bazy danych
# 6. Delete danych - usunicoe srodka z bazy danych
# 10.Sprawdzenie czy istnieje rodek trway o podanym identyfikatorze

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Numer':[1,4,5,6,10],'SrodekId':[1,4,5,6,10],'Data':[1,4,5,6,10]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_platnosci z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,4,5,6,10]: 
            Numer = str(klucze['Numer'])
            SrodekId = str(klucze['SrodekId'])
            Data = str(klucze['Data'])

dane = []


#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprDodawanie=(((self.oddzial_id,'174323') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))    
UprEdycja=(((self.oddzial_id,'174322') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
UprUsuwanie=(((self.oddzial_id,'174324') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
 
 
#-------------------------------------------------------------------------------
#---   Sprawdzenie SrodekId (10)
#-------------------------------------------------------------------------------

if stat == "OK" and klucze['Funkcja'] == 10:
    spr1="SELECT srodek_id FROM rs_srodki_trwale WHERE firma_id= '"+str(self.firma_id)+\
        "' AND srodek_id = '"+SrodekId+"';"
    stat,d2,dump,dump = self.PolSQL.Execute(spr1,3)
    if stat<>'OK':
        stat="Bdy w pobieraniu danych rodka : "+stat   
        dane.append(stat)  
    else:  
        if len(d2) == 0:
            stat = "BL_BRAK"
            dane.append(stat)
        
    if stat == "OK":
        spr2="SELECT * FROM rs_arkusze_przeszacowania_pozycje WHERE srodek_id='"+SrodekId+"' AND " 
        spr2+="numer='"+Numer+"' AND data='"+Data+"' AND firma_id='"+str(self.firma_id)+"';"
        stat,d2,dump,dump = self.PolSQL.Execute(spr2,3)
        if stat<>'OK':
            stat="Bdy w sprawdzaniu danych : "+stat   
            dane.append(stat)   
        else:
            if len(d2) not in [[],0]:
                stat = "POZYCJA_EXT"
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (4)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 4:
    if not UprEdycja:
        stat="Brak uprawnie do dodawania danych."
        
    if stat=="OK":
        query="INSERT INTO rs_arkusze_przeszacowania_pozycje (firma_id, data, srodek_id, numer," 
        query+="rach_przed, rach_przesz, rach_po, podat_przed, podat_przesz, podat_po, powod   )"
        query+=" VALUES ('"+self.firma_id+"','"+Data+"','"+SrodekId+"','"+Numer+"',"
        query+="(SELECT wartosc_aktualna FROM rs_srodki_trwale WHERE firma_id = '"+str(self.firma_id)+"' AND srodek_id = '"+SrodekId+"'),"
        query+="0,(SELECT wartosc_aktualna FROM rs_srodki_trwale WHERE firma_id = '"+str(self.firma_id)+"' AND srodek_id = '"+SrodekId+"'),"
        query+="(SELECT wartosc_aktualna_p FROM rs_srodki_trwale WHERE firma_id = '"+str(self.firma_id)+"' AND srodek_id = '"+SrodekId+"'),0,"
        query+="(SELECT wartosc_aktualna_p FROM rs_srodki_trwale WHERE firma_id = '"+str(self.firma_id)+"' AND srodek_id = '"+SrodekId+"'),'');"
        stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
        if stat<>'OK':
            stat="Bd przy dodawaniu danych : "+stat   
            dane.append(stat)   


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1: 
    if not UprEdycja:
        stat="Brak uprawnie do edycji danych."
        
    if stat=="OK":
        Update=klucze['Update']
        for i in xrange(len(Update[0])):  
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                
                if pole == 'rach_po':
                    if wart < 0:
                        stat = "BL RACH_PO"
                        dane.append(stat)
                elif pole == 'podat_po': 
                    if wart < 0:
                        stat = "BL PODAT_PO"
                        dane.append(stat)  
                        
    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):
            UPDATE="UPDATE rs_arkusze_przeszacowania_pozycje "
            SET='SET '
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['rach_przesz','rach_po','podat_przesz','podat_po']: 
                    SET+=pole+"="+str(wart)+","
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+Numer
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                WHERE+=" AND "+pole+"='"+wart+"'"
            WHERE+=";"    
            sql+=UPDATE+SET+WHERE;
        if sql<>'': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)    
            if stat<>'OK':
                stat="Bd przy modyfikowaniu danych : "+stat   
                dane.append(stat)   


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 6:
    if not UprUsuwanie:
        stat='UPR DEL' 
   
    if stat=="OK":    
        sql1="DELETE FROM rs_arkusze_przeszacowania_pozycje WHERE firma_id='"+self.firma_id+"' " 
        sql1+="AND srodek_id='"+SrodekId+"' AND numer="+Numer+" AND data='"+Data+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(sql1,1)
        if stat<>'OK':
            stat="Bd przy usuwaniu danych : "+stat   
            dane.append(stat)   


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [1,4,5,6]):
    sql="SELECT app.srodek_id,st.nazwa,app.rach_przed,app.rach_przesz,app.rach_po,app.podat_przed,"
    sql+="app.podat_przesz,app.podat_po FROM rs_arkusze_przeszacowania_pozycje app INNER JOIN "
    sql+="rs_srodki_trwale st ON (app.firma_id = st.firma_id AND app.srodek_id = st.srodek_id) "
    sql+="WHERE app.firma_id='"+self.firma_id+"' AND app.numer = "+Numer+" AND app.data = '"+Data+ "' "
    sql+="ORDER BY srodek_id;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych : "+stat   
        dane.append(stat)   