#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi.py
# Purpose:          dodaje/pobiera/usuwa raporty wycigi
# Author:           Marcin Grzeda,Micha Raburski,Piotr Witkowski
# Created:          2016/03/09
# RCS-ID:           $Id: fs_raporty_wyciagi.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#2009-05-15 Dariusz Boduch - Wprowadzanie salda pocztkowego w raporcie/wycigu mantis: 1066
#2011-04-24 Mariusz Rajfura - obsluga typu 'N' - niezidentyfikoway (4528)
#2011-05-30 Mariusz Rajfura - zaleglosci typu 'N' wchodzi 'z minusem' (4637)
#2011-06-01 Mariusz Rajfura - dane konta przeciwstawnego do dow.ksieg dla typu N przy zamykaniu raportu (4639)
#2012-07-16 Mariusz Rajfura - przy zamykaniu raportu uzupelnienie dat wplywu i odbioru na korektach (5911)
#2012-07-20 Mariusz Rajfura - blokada uzupelnienie dat wplywu i odbioru na korektach przy zamykaniu raportu (5939)
#                             wstawianie dat potwierdzenia korekt w raporcie
#2012-08-09 Mariusz Rajfura - pobranie info o liscie dozwolonych kas w okresie (5981)
#2016-03-09 Piotr Witkowski (9614) Refaktoryzacja Raportw Wycigw i Raportw pozycji
#2021-08-30 Wojciech Skowron (12620) Usunicie z raportu pozycji o kwotach zerowych przy zmianie stanu G -> Z
#2022-04-09 Jan Raburski (12964) Dekretacja wg sposobow zaplaty
#2023-07-27 Wojciech Skowron (13467) Usunicie klucza raportu z zaliczki przy usuwaniu


from funkcje import fs_korekty_pom


def PodajNumerRozrachunkowDoPary(Typ,Firma,Okres,Wyzn,Data,Numer,Konto,Platnosc,PolSQL,self):
    RozrWn=0
    RozrMa=0
    stat='OK'
    
    #sprawdzamy czy wybrane konto ju ma BO
    from funkcje import fs_rozrachunki_pom
    stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,Okres)
    if stat <>'OK':
        return stat,RozrWn,RozrMa
    
    LOkresow=Wyn[0]
    DataGr=Wyn[1]            

    # w przypadku, gdy  jest to faktura 
    if Typ in ['F','K','D']:
        if not (Okres in ['','None'] or Wyzn in ['','None'] or Data in ['','None'] or Numer in [0,'None']):
            SQL="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+") "
            SQL+=" AND f_wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' "
            SQL+=" AND f_numer="+str(Numer)+" AND kwota_wn !=0 LIMIT 1;"
            stat,DSeriaRozl,dump,dump=PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DSeriaRozl)>0:
                    RozrMa=str(DSeriaRozl[0][0])

    #Sprawdzamy jaki powinien byc numer rozrachunku przeciwnego w przypadku, gdy 
    # jest to patno
    elif Typ=='P':
        SQL="SELECT r.seria FROM rs_rozrachunki r WHERE "
        SQL+=" r.firma_id='"+Firma+"' AND r.okres_id IN ("+LOkresow+") AND r.platnosc_id="+str(Platnosc)
        SQL+=" AND r.konto='"+Konto+"' AND r.saldo_ma !=0 AND data_rozlicz IS NULL LIMIT 1;"
        stat,DSeriaRozl,dump,dump=PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DSeriaRozl)>0:
                RozrWn=str(DSeriaRozl[0][0])

    return stat,RozrWn,RozrMa


#-##############################################################################
# GWNA CZʦ FUNKCJI
#-##############################################################################

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Kasa':[6,7,8,9,10,11,12,13,22],'Data':[6,7,8,9,10,11,12,13,22],'Numer':[6,7,8,9,10,11,12,13,22],'Okres':[11,20],
           'Kurs':[7,8,9],'KasaBankF':[5,6,25],'DataOdF':[5,6,13],'DataDoF':[5,6,13],'StanF':[5,6],'KwotaU':[22]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_raporty_wyciagi z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [6,7,8,9,10,11,12,13,22]:
            Kasa = str(klucze['Kasa'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [7,8,9]:
            Kurs = klucze['Kurs']
        if Funkcja in [5,6,25]:
            KasaBankF = klucze['KasaBankF']
        if Funkcja in [5,6]:
            StanF = klucze['StanF']
        if Funkcja in [5,6,13]:
            DataOdF = klucze['DataOdF']
            DataDoF = klucze['DataDoF']
        if Funkcja in [22]:
            KwotaU = klucze['KwotaU']
        if Funkcja in [11,20]:
            Okres = klucze['Okres']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

    puste_pola = ['    -  -  ','',[],'None']
    UpdateZaleglosci=''
    debug=7


OkrPar=self.okres_id
# harmonogramowe czenie w pary
if Funkcja in [11,20]:
    if Okres<>'' :
        OkrPar=Okres

LPrz=['ZASLEPKA']
LDel=[]
LUpd=[]
LZam=[]
LPrzyg=[]
LOtw=[]


# sprawdzenie kasy
if Funkcja == 25:
    if self.operator_id != STANDARD_OPERATOR_ID:
        SQL = "SELECT 1 FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkrPar+"' AND kasa_bank_id = '"+KasaBankF+"'"
        SQL+=" AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+"; "
    else:
        SQL = "SELECT 1 FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id = '"+KasaBankF+"'"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat != 'OK' or len(dane)==0:
        stat = u'Podano bdn kas lub nie ma uprawnie do kasy podanej w filtrze dla wybranego okresu'

# pobranie uprawnie do Kas/Bankw dla operatora
if stat=='OK':
    if self.operator_id != STANDARD_OPERATOR_ID:
        SQL="SELECT kasa_bank_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie "
        SQL+=" FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkrPar+"'"
        SQL+=" AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+"; "
        stat,Upr,wyn1,tr = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            UprDel=(self.oddzial_id,'172014') in self.uprawnienia
            UprUpd=(self.oddzial_id,'172012') in self.uprawnienia
            UprZam=(self.oddzial_id,'172016') in self.uprawnienia
            UprOtw=(self.oddzial_id,'172017') in self.uprawnienia
            UprPrzyg=((self.oddzial_id,'172018') in self.uprawnienia) or UprZam
            for d in Upr:
                if d[1] or d[2] or d[3] or d[4] or d[5] or d[6]:
                    LPrz.append(rsglobal.Dekoduj(d[0]))
                if UprDel:
                    if d[3]:
                        LDel.append(rsglobal.Dekoduj(d[0]))
                if UprUpd:
                    if d[1] or d[2]:
                        LUpd.append(rsglobal.Dekoduj(d[0]))
                if UprZam:
                    if d[5]:
                        LZam.append(rsglobal.Dekoduj(d[0]))
                if UprPrzyg:
                    if d[5]:
                        LPrzyg.append(rsglobal.Dekoduj(d[0]))
                if UprOtw:
                    if d[6]:
                        LOtw.append(rsglobal.Dekoduj(d[0]))
    else:
        UprDel=True
        UprUpd=True
        UprZam=True
        UprOtw=True
        UprPrzyg=True


#-------------------------------------------------------------------------------
# Pobranie listy dozwolonych kas (14)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 14:
    if self.operator_id != STANDARD_OPERATOR_ID:
        sql = "SELECT DISTINCT kasa_bank_id FROM rs_kasy_banki_upr"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")+";"
    else:
        sql = "SELECT kasa_bank_id FROM rs_kasy_banki"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania listy dozwolonych kas: '+stat
    else:
        # dodatkowa informacja czy to operator anakonda
        # bo moze byc tylko jedna kasa w danym okresie,
        # a operator anakonda ma mozliwosc edycji listy kas/bankow
        wyn2 = [self.operator_id == STANDARD_OPERATOR_ID]


#-------------------------------------------------------------------------------
#rozliczanie zaleglosci z dowodow dostaw 20
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 20:
    if stat=='OK':
        Select="SELECT poz.kasa_bank_id,poz.data,poz.numer,poz.nr_poz,poz.nr_ppoz,poz.tresc,poz.platnik_id,poz.kierowca,poz.typ,poz.kwota "
        Select+="FROM rs_raporty_wyciagi_pozycje poz INNER JOIN rs_raporty_wyciagi nagl ON (poz.firma_id=nagl.firma_id "
        Select+="AND poz.kasa_bank_id=nagl.kasa_bank_id AND poz.data=nagl.data AND poz.numer=nagl.numer) "
        Select+="WHERE poz.firma_id='"+self.firma_id+"' AND poz.okres_id='"+str(OkrPar)+"' AND poz.typ_fakt='D' AND nagl.stan='Z' "
        Select+="AND data_fakt is NULL ORDER BY nr_poz,nr_ppoz DESC;"
        stat,d_poz_rap,dump,dump=self.PolSQL.Execute(Select,3)
        if stat<>"OK":
            stat='Bd pobierania pozycji raportw wycigw : '+stat
            d_poz_rap=[]
            
    if stat=='OK':        
        rozliczone_i_nie=[]
        from funkcje import fs_dowody_dostaw_pom
        for poz_raportu in d_poz_rap:
            if stat=='OK':
                Kasa_rap=rsglobal.Dekoduj(poz_raportu[0])
                Data_rap=rsglobal.Dekoduj(poz_raportu[1])
                Numer_rap=rsglobal.Dekoduj(poz_raportu[2])
                NrPoz_rap=poz_raportu[3]
                NrPpoz_rap=poz_raportu[4]
                Tresc_rap=rsglobal.Dekoduj(poz_raportu[5])
                data_dostawy_rap="20"+Tresc_rap[0:2]+"-"+Tresc_rap[2:4]+"-"+Tresc_rap[4:6]
                #TODO tutaj
                if data_dostawy_rap >= '2016-10-01':
                    Oddzial_rap=Tresc_rap[6]

                    Oddzial_rap=Tresc_rap[6:8]
                    Trasa_rap = Tresc_rap[8:12]
                    Tryb_rap = Tresc_rap[12:14]
                    NrDowodu_rap=Tresc_rap[14:]
                    Trasa_sql = " AND trasa ='"+Trasa_rap+"'"
                else:
                    Oddzial_rap="0"+Tresc_rap[6]
                    # pobranie listy tras
                    stat,Trasy_rap=fs_dowody_dostaw_pom.PodajTrasyDlaOddzialuZKoncowkiTras(self.PolSQL,self.firma_id,Oddzial_rap,Tresc_rap[7:9])
                    if stat<>"OK":
                        rozliczone_i_nie[-1].append(stat)
                        continue

                    if len(Trasy_rap) ==0:
                        stat=" Nie znaleziono tras dla odziau "+Oddzial_rap+" i kocwki trasy "+Tresc_rap[7:9]
                        rozliczone_i_nie[-1].append(stat)
                        continue
                        
                    Tryb_rap=Tresc_rap[6]+Tresc_rap[9]
                    NrDowodu_rap=Tresc_rap[10:]
                    Trasa_sql = " AND trasa IN ("+str(Trasy_rap)[1:-1]+") "

                Kontrahent_rap=rsglobal.Dekoduj(poz_raportu[6])
                Kierowca_rap=rsglobal.Dekoduj(poz_raportu[7])
                Typ_rap=rsglobal.Dekoduj(poz_raportu[8])
                Kwota_rap=rsglobal.Dekoduj(poz_raportu[9])
                rozliczone_i_nie.append([Kasa_rap,Data_rap,Numer_rap,NrPoz_rap,NrPpoz_rap,Tresc_rap])
                # Pobieranie waluty raportu
                Sql="SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkrPar+"'"
                Sql+=" AND kasa_bank_id='"+Kasa_rap+"';"
                stat,d_wal_rap,dump,dump=self.PolSQL.Execute(Sql,3)
                if stat<>'OK':
                    stat='Wystpiy bdy pobierania waluty: '+stat
                    rozliczone_i_nie[-1].append(stat)
                    continue
                if len(d_wal_rap)==0:
                    rozliczone_i_nie[-1].append(' z powodu bdnej kasy')                    
                    continue                                
                    
                Waluta_rap=rsglobal.Dekoduj(d_wal_rap[0][0])    
                SELECT_DOWOD="SELECT oddzial_id,trasa,data,tryb_dostawy,numer,f_wyznacznik_id,f_data,f_numer"
                SELECT_DOWOD+=" FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'" 
                SELECT_DOWOD+=" AND data='"+data_dostawy_rap+"' AND oddzial_id='"+Oddzial_rap+"'"
                SELECT_DOWOD+= Trasa_sql + " AND tryb_dostawy='"+Tryb_rap+"'"
                SELECT_DOWOD+=" AND numer="+NrDowodu_rap+" AND platnik_id='"+Kontrahent_rap+"';"
                stat,d_dowod,dump,dump=self.PolSQL.Execute(SELECT_DOWOD,3)
                if stat<>'OK':
                    stat='Wystpiy bdy pobierania dowodu dostawy : '+stat
                    rozliczone_i_nie[-1].append(stat)
                    continue
    
                if len(d_dowod)>1:
                    rozliczone_i_nie[-1].append(' z powodu znalezienia wicej ni jednego dowodu dostawy o podanych parametrach')
                    continue      
                          
                if len(d_dowod)==0:
                    rozliczone_i_nie[-1].append(' z powodu braku podanego dowodu dostawy')
                    continue                
                    
                f_wyznacznik=rsglobal.Dekoduj(d_dowod[0][5])
                if f_wyznacznik.strip()=='None':
                    rozliczone_i_nie=rozliczone_i_nie[0:-1]
                    continue
                
                f_data=rsglobal.Dekoduj(d_dowod[0][6])
                f_numer=d_dowod[0][7]
                SELECT_ZALEGL="SELECT nr_zal,waluta,kurs,platnik_id,kierowca,projekt_id,do_zaplaty,do_zaplaty_wal,ureg_kwota FROM rs_zaleglosci"
                SELECT_ZALEGL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+f_wyznacznik+"' AND data='"+f_data+"' AND numer="+str(f_numer)
                SELECT_ZALEGL+=" AND typ_dok='F' ORDER BY abs(ureg_kwota) ASC LIMIT 1 FOR UPDATE"
                stat,d_zal,dump,dump=self.PolSQL.Execute(SELECT_ZALEGL,3)
                if stat<>'OK':
                    stat='Wystpiy bdy pobierania zalegoci : '+stat
                    rozliczone_i_nie[-1].append(stat)
                    continue
                
                if len(d_zal)<>1:
                    rozliczone_i_nie=rozliczone_i_nie[0:-1]
                    continue                            
                    
                NrZal_zal=d_zal[0][0]
                Waluta_zal=rsglobal.Dekoduj(d_zal[0][1])
                Kurs_zal=rsglobal.Dekoduj(d_zal[0][2])
                Platnik_id_zal=rsglobal.Dekoduj(d_zal[0][3])
                Kierowca_id_zal=rsglobal.Dekoduj(d_zal[0][4])
                Projekt_zal=rsglobal.Dekoduj(d_zal[0][5])
                KwotaDoZaplaty_zal=d_zal[0][6]
                KwotaDoZaplatyWal_zal=d_zal[0][7]
                KwotaUreg_zal=d_zal[0][8]
                if Platnik_id_zal!=Kontrahent_rap:
                    rozliczone_i_nie[-1].append(' poniewa wystpia niezgodno kontrahenta w pozycji raportu z patnikiem w zalegoci.')
                    continue                
    
                #symbol wplaty daje informacje jaki byl sposob regulacji i jaka pozycja raportu reguluje dana zaleglosci.
                # Zaleglosci moga byc rowniez kompensowane.                
                SymbolWplaty=Kasa_rap+"/"+Data_rap+"/"+rsglobal.UsunKropkaZero(str(Numer_rap))+"/"+rsglobal.UsunKropkaZero(str(NrPoz_rap))
                
                # dodatkowy test czy ju tego przed chwil nie rozliczylimy, by unikn sytuacji z podwjnym rozliczeniem
                SQL="SELECT * FROM rs_raporty_wyciagi_pozycje "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Kasa_rap+"' AND data='"+Data_rap+"'"
                SQL+=" AND numer="+str(Numer_rap)+" AND nr_poz="+str(NrPoz_rap)+" AND tresc='"+Tresc_rap+"'"
                SQL+=" AND NOT data_fakt IS NULL;"
                stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Wystpiy bdy testowania zalegoci : '+stat
                    rozliczone_i_nie[-1].append(stat)
                    continue
                if len(DTest)>0:
                    continue
                
                if KwotaUreg_zal==0:
                    if Typ_rap=='W':
                        KwotaZRaportu=-Kwota_rap
                    else:
                        KwotaZRaportu=Kwota_rap
                    if Waluta_zal==Waluta_rap:                            
                        if KwotaDoZaplatyWal_zal==KwotaZRaportu:
                            UREG_KWOTA="ureg_kwota=do_zaplaty"
                        else:
                            UREG_KWOTA="ureg_kwota="+str(KwotaZRaportu*Kurs_zal) 
                    elif Waluta_rap=='PLN':
                        if KwotaDoZaplatyPLN_zal==KwotaZRaportu:
                            UREG_KWOTA="ureg_kwota=do_zaplaty"
                        else:
                            UREG_KWOTA="ureg_kwota="+str(KwotaZRaportu)
                    else:
                        rozliczone_i_nie[-1].append(' z powodu niezgodnoci walut zalegoci i raportu.')
                        continue
                    
                    UpdateZaleglosci= " UPDATE rs_zaleglosci SET "+UREG_KWOTA+",ureg_data='"+Data_rap+"',symbol_wplaty='"+SymbolWplaty+"'"
                    UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZal_zal)+";"
                
                    if KwotaDoZaplatyWal_zal!=KwotaZRaportu:
                        UpdateZaleglosci+=" INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,typ_dok,wyznacznik_id,data,numer,"
                        UpdateZaleglosci+="oddzial_id,CASE WHEN do_zaplaty - ureg_kwota >= 0 THEN 'P' ELSE 'N' END ,typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZal_zal)+"; "
                else: #zaleglosc jest uregulowana
                    if Typ_rap=='W':
                        KwotaZRaportu=-Kwota_rap
                    else:
                        KwotaZRaportu=Kwota_rap
                    if Waluta_zal==Waluta_rap:
                        KwotaUreg=KwotaZRaportu*Kurs_zal
                        KwotaUregWal=KwotaZRaportu
                    else:
                        KwotaUreg=KwotaZRaportu
                        KwotaUregWal=round(KwotaZRaportu/Kurs_zal,2)
                        
                    if KwotaUreg<0:
                        Z_Czy_N="'Z'"
                    else:
                        Z_Czy_N="'N'"
                    
                    UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                    UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                    UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                    UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,symbol_wplaty,opis,numer_z_rs)"
                    UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                    UpdateZaleglosci+="data,numer,oddzial_id,"+Z_Czy_N+",typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                    UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                    UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus,0,0,"+str(KwotaUreg)+",'"+Data_rap+"',NULL,'','"+SymbolWplaty+"',"
                    UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZal_zal)+"; "
                
                    UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                    UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                    UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                    UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                    UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                    UpdateZaleglosci+="data,numer,oddzial_id,"+Z_Czy_N+",typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                    UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                    UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaUregWal)+",0,NULL,NULL,'',"
                    UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZal_zal)+"; "        
        
                
                UpdateRaporty="UPDATE rs_raporty_wyciagi_pozycje SET wyznacznik_id='"+f_wyznacznik+"',data_fakt='"+f_data+"',numer_fakt="+str(f_numer)
                UpdateRaporty+=" WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Kasa_rap+"' AND data='"+Data_rap+"'"
                UpdateRaporty+=" AND numer="+str(Numer_rap)+" AND nr_poz="+str(NrPoz_rap)+" AND nr_ppoz="+str(NrPpoz_rap)+";"
                
                #-------------------------------------------------------------------------------
                # cz aktualizujca pozycje dowodu ksigowego, w zalenoci od stanu zmienia te operacje i rozrachunki
                #-------------------------------------------------------------------------------
                
                # pobranie stanu i klucza dowodu ksigowego dotyczcego raportu wycigu
                KlRap=Kasa_rap.strip()+'/'+Data_rap+'/'+str(Numer_rap)
                SQL="SELECT stan,okres_id,dowod_id,nazwa_id,data,numer FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND REPLACE(symbol_dok,' ','')='"+KlRap+"';"
                stat,DDowKs,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Wystpiy bdy pobierania danych dowodu ksigowego : '+stat
                    rozliczone_i_nie[-1].append(stat)
                    continue
    
                if len(DDowKs)==0:
                    rozliczone_i_nie[-1].append(' poniewa brak danych odpowiedniego dowodu ksigowego dla raportu/wycigu. ')
                    continue
                
                KlFakt=f_wyznacznik+'/'+f_data+'/'+rsglobal.UsunKropkaZero(str(f_numer))
                Filtr=" firma_id='"+self.firma_id+"' AND okres_id='"+DDowKs[0][1]
                Filtr+="' AND dowod_id='"+DDowKs[0][2]+"' AND nazwa_id='"+DDowKs[0][3]+"' AND data='"+DDowKs[0][4]+"'"
                Filtr+=" AND numer="+str(DDowKs[0][5])+" AND nr_poz="+str(NrPoz_rap)+" AND nr_ppoz="+str(NrPpoz_rap)+";"
                
                # update pozycji dowodu ksigowego
                UPDDanymiFakt="UPDATE rs_dowody_ksiegowe_pozycje SET tresc_wn=tresc_wn||' "+KlFakt+"',"
                UPDDanymiFakt+=" tresc_ma=tresc_ma||' "+KlFakt+"' WHERE "+Filtr
                
                # jeli stan = Z to update na operacjach i rozrachunkach
                if DDowKs[0][0]=='Z':
                    UPDDanymiFakt+="UPDATE rs_operacje SET tresc=tresc||' "+KlFakt+"'"
                    UPDDanymiFakt+=" WHERE "+Filtr
                                    
                    UPDDanymiFakt+="UPDATE rs_rozrachunki SET tresc=tresc||' "+KlFakt+"'"
                    UPDDanymiFakt+=" WHERE "+Filtr
                    
                # ostateczna zmiana danych
                stat,dump,dump,dump=self.PolSQL.Execute(UpdateZaleglosci+UpdateRaporty+UPDDanymiFakt,1)
                if stat<>'OK':
                    stat='Wystpiy bdy w trakcie modyfikowania raportu, zalegoci i dowodw ksigowych: '+stat
                    rozliczone_i_nie[-1].append(stat)
                else:
                    rozliczone_i_nie[-1].append('OK')

        dane=rozliczone_i_nie
    
    


#-------------------------------------------------------------------------------
# sprawdzenie danych przychodzcych(<> 20)
#-------------------------------------------------------------------------------

if Funkcja in [5,6,13]:
    if not rsglobal.SprawdzCzyToData(DataOdF):        
        if DataOdF not in puste_pola:
            stat="BL DOD"
            dane.append(stat)
    if not rsglobal.SprawdzCzyToData(DataDoF):
        if DataDoF not in puste_pola:
            stat="BL DDO"
            dane.append(stat)

#-------------------------------------------------------------------------------

if Funkcja in [3,4,6,10,11]:
    if not rsglobal.SprawdzCzyToData(Data):
        if Data != '    - -  ':
            stat="BR DAT"
            dane.append(stat)
        else:
            stat="BL DAT"
            dane.append(stat)
    if Kasa=='':
        stat="BR KAS"
        dane.append(stat)
    if Numer=='':
        stat='BR NUM'
        dane.append(stat)


#-------------------------------------------------------------------------------
# czenie rozrachunkw w pary
#-------------------------------------------------------------------------------

if Funkcja in [10,11] and stat=='OK':
    if (self.operator_id == STANDARD_OPERATOR_ID):
        Uprawnienia=True
    else:
        Uprawnienia= UprZam and (Kasa in LZam)

    if stat=='OK':
        #pobieramy list pozycji dla ktrych ponownie bdziemy pobiera numer
        SQL="SELECT nr_poz,nr_ppoz,typ_fakt,wyznacznik_id,data_fakt,numer_fakt,konto,platnosc_id "
        SQL+=" FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND okres_id='"+OkrPar+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' "
        SQL+=" AND numer="+str(Numer)+" AND typ_fakt IN ('F','K','P','D');"
        
        stat,DPoz,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        for poz in DPoz:
            if stat=='OK':
                stat,p_nr_rozr_wn,p_nr_rozr_ma=PodajNumerRozrachunkowDoPary(rsglobal.Dekoduj(poz[2]),self.firma_id,OkrPar,rsglobal.Dekoduj(poz[3]),rsglobal.Dekoduj(poz[4]),poz[5],rsglobal.Dekoduj(poz[6]),poz[7],self.PolSQL,self)
            if stat=='OK':
                if p_nr_rozr_wn != 0 or p_nr_rozr_ma != 0:
                    # pobranie pozycji z dowodw ksigowych pasujcej do pozycji raportu
                    SQL="SELECT dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz FROM rs_dowody_ksiegowe_pozycje "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkrPar+"' "
                    SQL+=" AND rw_kasa_bank_id='"+Kasa+"' AND rw_data='"+Data+"' " 
                    SQL+=" AND rw_numer="+str(Numer)+" AND rw_nr_poz="+str(poz[0])+" AND rw_nr_ppoz="+str(poz[1])+";"
                    stat,DPozDok,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if len(DPozDok)>0:
                            dok=DPozDok[0]
                            if poz[2] in ['F','K','D']:
                                Strona='ma'
                                seria=str(p_nr_rozr_ma)
                            else:
                                Strona='wn'
                                seria=str(p_nr_rozr_wn)
                                
                            SQL="UPDATE rs_rozrachunki SET seria_rozl="+seria
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkrPar+"' "
                            SQL+=" AND dowod_id='"+rsglobal.Dekoduj(dok[0])+"' AND nazwa_id='"+rsglobal.Dekoduj(dok[1])+"'"
                            SQL+=" AND data='"+rsglobal.Dekoduj(dok[2])+"' AND numer="+str(dok[3])
                            SQL+=" AND nr_poz="+str(dok[4])+" AND nr_ppoz="+str(dok[5])
                            SQL+=" AND kwota_"+Strona+"<>0;"
                            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                            


#-------------------------------------------------------------------------------
#  Pobranie stanu (7,8,9)
#-------------------------------------------------------------------------------

if Funkcja in [7,8,9,12] and stat == 'OK':
    #Na pocztek sprawdzamy czy raport istnieje i czy ma stan 'W' lub 'G'
    SQL="Select stan,kompensata from rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT"
    stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='BL BLOKADA'
        dane.append(stat)
    elif rsglobal.Dekoduj(d[0][0])=='Z':
        stat='BL STAN'
        dane.append(stat)
    elif d[0][0] == 'G' and Funkcja in [7,12]:
        stat='BL STANG'
        dane.append(stat)
    elif d[0][0] == 'W' and Funkcja ==8:
        stat='BL STANW'
        dane.append(stat)
    elif d[0][0] != 'G' and Funkcja ==9:
        stat='BL STANO'
        dane.append(stat)
    if stat=='OK':
        kompensata=d[0][1]

    if not (self.operator_id == STANDARD_OPERATOR_ID) and stat=='OK':
        if d[0][0]=='W':
            if not (UprPrzyg and (Kasa in LPrzyg)):
                stat='UPR PRZYG'
                dane.append(stat)

        elif d[0][0]=='G' and Funkcja ==8:
            if not (UprZam and (Kasa in LZam)):
                stat='UPR ZAM'
                dane.append(stat)
                
        elif d[0][0]=='G' and Funkcja ==9:
            if not (UprOtw and (Kasa in LOtw)):
                stat='UPR OTW'
                dane.append(stat)
    

#-------------------------------------------------------------------------------
#Otwieranie raportow (9)
#-------------------------------------------------------------------------------

if Funkcja==9 and stat=='OK':
    SQL="UPDATE rs_raporty_wyciagi SET stan ='W' WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
    SQL+="UPDATE rs_raporty_wyciagi_pozycje SET stan_poz='W' WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)    


#-------------------------------------------------------------------------------
#Przygotowanie raportow (7,12)
#-------------------------------------------------------------------------------

if Funkcja in [7,12] and stat=='OK':
    #Ponisze zapytanie sprawdza czy raport ma wogle jakie pozycje. Raport bez pozycji nie moe by zamkniety
    Sql="SELECT nr_poz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
    stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat=='OK' and len(d)<=0:
        stat="BR PPOZ"
        dane.append(stat)
    if stat=='OK':
        SQL="UPDATE rs_raporty_wyciagi SET stan ='G' WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
        SQL+="UPDATE rs_raporty_wyciagi_pozycje SET stan_poz='G' WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)


#-------------------------------------------------------------------------------
#Zamykanie raportow (8,12)
#-------------------------------------------------------------------------------

if Funkcja in [8,12] and stat=='OK':
    #pobranie waluty z kasy/banku
    Sql="Select waluta from rs_kasy_banki WHERE firma_id='"+self.firma_id+"'"
    Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
    stat,DWaluty,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat=='OK':
        WalutaRap=rsglobal.Dekoduj(DWaluty[0][0])
    
        #sprawdzamy czy stan wszystkich poprzednich raportw jest rwny 'Z'
        Sql="SELECT stan FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND (data<'"+Data+"' OR (data='"+Data+"' AND numer<"+Numer+")) AND stan<>'Z' "
        Sql+=" ORDER BY data desc, numer desc LIMIT 1;" 
        stat,dtest,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat=='OK':
        if len(dtest)>0:
            stat='BL STAN WCZ'
            dane.append(stat)
            
    #jeli wszystko jest ok, to przepisujemy stan pocztkowy i wyliczamy kocowy biorc dane z ostatniego wiersza.
    if stat=='OK':
        Sql="SELECT saldo_konc FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND (data<'"+Data+"' OR (data='"+Data+"' AND numer<"+Numer+")) "
        Sql+=" ORDER BY data desc, numer desc LIMIT 1;" 
        
        stat,dsaldok,dump,dump=self.PolSQL.Execute(Sql,3)
        
    if stat=='OK':
        if len(dsaldok)>0:
            SaldoK=str(dsaldok[0][0])
            Upd="UPDATE rs_raporty_wyciagi SET saldo_pocz="+SaldoK+", saldo_konc=wplaty-wyplaty+"+SaldoK
            Upd+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer        
            stat,dump,dump,dump=self.PolSQL.Execute(Upd,1)

    #WS 2021-08-30 - usunicie zerowych pozycji jeli raport z definicji
    if stat=='OK':
        Sql="SELECT 1 FROM rs_kasy_banki_pozycje"
        Sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"';"
        stat,d,dump,dump = self.PolSQL.Execute(Sql,3)
        if stat == 'OK' and len(d) > 0:
            Sql="DELETE FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" AND kwota=0;"
            stat,dump,dump,dump=self.PolSQL.Execute(Sql,1)
            
    if stat=='OK':
        #-------------------------------------------------------------------
        #---Sprawdzanie poprawnosci pozycji
        #-------------------------------------------------------------------
         
        #Ponisze zapytanie sprawdza czy raport ma wogle jakie pozycje. Raport bez pozycji nie moe by zamkniety
        Sql="SELECT nr_poz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
    
    if stat=='OK':
        if len(d)<=0:
            stat="BR PPOZ"
            dane.append(stat)
                
    if stat=='OK':                
        #sprawdzenie czy raport w PLN i kurs = 1 lub czy walutowy i kurs != 1:
        SQL="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
        if WalutaRap=='PLN':
            SQL+=" AND kurs != 1;"
        else:
            SQL+=" AND kurs=1;"
            
        stat,TestKurPoz,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        if len(TestKurPoz)>0:
            stat='BL KUR POZ$'+str(TestKurPoz[0][0])+' numer podpozycji: '+str(TestKurPoz[0][1])
            dane.append(stat)
                
    if stat=='OK':
        #A to zapytanie wypisuje liste blednych pozycji, ktre nie maj wpisanych danych konta mimo ze nie sa zadnym z typow 'F','K','D'. 
        #Takie pozycje sa niepoprawne, gdy s podpozycjami albo gdy nie maj podpozycji.
        #Innymi sowy s poprawne jedynie wtedy gdy s pozycjami rozbitymi na podpozycje.   
        Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE TRIM(COALESCE(konto,''))='' AND typ_fakt not in ('F','K','D')"
        Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
        Sql+=" AND (nr_ppoz!=0 or (nr_ppoz=0 AND NOT nr_poz in (SELECT nr_poz FROM rs_raporty_wyciagi_pozycje"
        Sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
        Sql+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_ppoz>0 )));" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)>0:
                stat='BR KONT FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
                
    if stat=='OK':
        #To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionej wyznacznika 
        #!!! ZMIANA - wyznacznik moe by rwny ''!!!
        Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE typ_fakt in ('F','K','D') AND wyznacznik_id is NULL"
        Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)<>0:
                stat='BR WYZN FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            
    if stat=='OK':
        #To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionej daty
        Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE typ_fakt in ('F','K') AND data_fakt is NULL"
        Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)<>0:
                stat='BR DAT FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)

    if stat == 'OK':
        # To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionego numeru
        Sql = "SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE typ_fakt in ('F','K') AND (numer_fakt=0 OR numer_fakt is NULL)"
        Sql += " AND firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
        Sql += " AND kasa_bank_id='" + Kasa + "' AND data='" + Data + "' AND numer=" + Numer
        stat, d, dump, dump = self.PolSQL.Execute(Sql, 3)
        if stat == 'OK':
            if len(d) != 0:
                stat = 'BR NR FAKT POZ$' + str(d[0][0]) + ' numer podpozycji: ' + str(d[0][1])
                dane.append(stat)

    #JR 2022-04-09 (12964)
    if stat == 'OK':
        # pobranie sposobow zaplaty i kont
        if stat == 'OK':
            Sql = "SELECT sposob_zaplaty, konto FROM rs_kasy_banki_sposoby_zaplaty WHERE "
            Sql += " firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
            Sql += " AND kasa_bank_id='" + Kasa + "'"
            stat, sposoby_konta, dump, dump = self.PolSQL.Execute(Sql, 3)
        # To zapytanie wypisuje liste pozycji, ktre maja wypelniony blednie sposob zaplaty
        if stat == 'OK':
            # To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionego numeru
            Sql = "SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE sposob_zaplaty IS NOT NULL"
            if len(sposoby_konta) > 0:
                war = ""
                for w in sposoby_konta:
                    war += "'" + w[0] + "',"
                Sql += " AND NOT sposob_zaplaty IN (" + war[0:-1] + ") "
            Sql += " AND firma_id='" + self.firma_id + "' AND okres_id='" + self.okres_id + "'"
            Sql += " AND kasa_bank_id='" + Kasa + "' AND data='" + Data + "' AND numer=" + Numer
            stat, d, dump, dump = self.PolSQL.Execute(Sql, 3)
            if stat == 'OK':
                if len(d) > 0:
                    stat = 'BL SPOS ZAPL$' + str(d[0][0]) + ' numer podpozycji: ' + str(d[0][1])
                    dane.append(stat)

    if stat=='OK':
        #Jesli raport jest kompensata to kazda pozycja musi mie wypenione zarwno dane dotyczce konta jak i faktury
        if kompensata:
            #1)wypisujemy wszystkie pozycje ktore nie maja wpisanego konta. Sa one niepoprawne, bo to kompensata.
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE konto='' and firma_id='"+self.firma_id+"'"
            Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if stat=='OK':
                if len(d)<>0:
                    stat='BR KOMP KONT$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                    dane.append(stat)
                
            if stat=='OK':    
                #2)wypisujemy wszystkie pozycje ktre maj nie wypelnione dane dotyczce faktury. Sa one niepoprawne, bo to kompensata     
                Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE wyznacznik_id='' and firma_id='"+self.firma_id+"'"
                Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
                stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                if stat=='OK':
                    if len(d)<>0:
                        stat='BR KOMP WYZN$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                        dane.append(stat)
            
    if stat=='OK':
        #Standardowe sprawdzenie czy typ w pozycji raportu jest poprawny. Dopuszczalne s dwie moliwoci 'P' i 'W'
        Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE typ not in ('P','W')"
        Sql+=" AND  firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)<>0:
                stat='BL TYP1 POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            
    if stat=='OK':    
        #Standardowe sprawdzenie czy kwota w pozycji jest wpisana poprawnie. NIE MOZE BYC ROWNA 0!!!
        Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE kwota=0 AND  firma_id='"+self.firma_id+"'"
        Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)<>0:
                stat='BL KWOT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            
    if stat=='OK':    
        #Standardowe sprawdzenie czy jest wpisana tre w sytuacji gdy mamy wypelnine konto. 
        #Jeli konto jest wpisane musi byc wpisana tresc.
        Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE konto<>'' AND tresc='' AND  firma_id='"+self.firma_id+"'"
        Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)<>0:
                stat='BR TRES POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            
    if stat=='OK':
        #Sprawdzamy czy wpisane w pozycjach numery kont sa poprawne. I czy podane konta s ksigowane
        Sql="SELECT konto,nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE konto<>'' AND firma_id='"+self.firma_id+"'"
        Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)>0:
                i=0
                while i < len(d):
                    if stat=='OK':
                        stat,d_p,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+rsglobal.Dekoduj(d[i][0])+"');",3)
                    if stat=='OK':
                        if d_p != None:
                            if rsglobal.rseval(rsglobal.Dekoduj(d_p[0][0]))[0]=='':
                                stat='BL KONT POZ$'+str(d[i][1])+' podpozycji numer: '+str(d[i][2])
                                dane.append(stat)
                            elif not rsglobal.rseval(rsglobal.Dekoduj(d_p[0][0]))[2]:
                                stat='BL KONT NIE KSIE$'+str(d[i][1])+' podpozycji numer: '+str(d[i][2])
                                dane.append(stat)
                                
                        else:
                            stat='BL KRYT KONT POZ'
                            dane.append(stat)
                    i=i+1
                    
                    
    if stat=='OK':                    
        #--------------------------------------------------------------------------------------------------
        #---------------------------------------Z A L E G L O S C I ---------------------------------------
        #---Zakonczyl sie etap podstawowego sprawdzania. Nastepnym etapem bedzie dokonanie odpowiednich 
        #---zapisow do zaleglosci
        #--------------------------------------------------------------------------------------------------
        stat,dump,dump,dump=self.PolSQL.Execute("BEGIN;",1)
        #Pobieramy pozycji ktre odnosz si do korekt lub faktur, Ich zamykanie wymaga zmian w zaleglosciach
        #z nimi zwiazanymi
        rsglobal.ZapiszDoLogow('Z A L E G L O S C I',debug)
        Sql="SELECT typ, typ_fakt,wyznacznik_id,data_fakt,numer_fakt,kwota,platnik_id,nr_poz,nr_ppoz"
        Sql+=" FROM rs_raporty_wyciagi_pozycje WHERE wyznacznik_id<>'' AND typ_fakt in ('F','K') AND firma_id='"+self.firma_id+"'"
        Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
    
    if stat=='OK':
        if len(d)>0:        #jesli lista pozycji z wpisanymi danymi faktury jest rozna od 0
            #pobieramy walute raportu. Jest ona okrelona przez wybr Kasy. Z konkretn kas jest zwizana jedna waluta
            rsglobal.ZapiszDoLogow('sa pozycje z faktura',debug)
            Sql="SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"';"
            stat,d_wal_rap,dump,dump=self.PolSQL.Execute(Sql,3)
            if stat=='OK':
                if len(d_wal_rap)==0:
                    stat= "BL SQL WAL"
                    dane.append(stat)
                
                
    if stat=='OK':                
        if len(d)>0:
            WalutaRap=d_wal_rap[0][0]
            #Bdziemy teraz w ptli iterowac po pozycjach ktre maja wpisane dane faktury
            i=0
            while i < len(d) and stat=='OK':
                rsglobal.ZapiszDoLogow('!!! WHILE 2 '+str(i)+' '+stat,debug)
                TypDokF=d[i][0]

                #W tym zapytaniu pobieramy zaleglosci zwiazane z pozycja d[i] poprzez fakture.
                #Zalezy nam na tym zeby w sytuacji gdy istnieja zaleglosci pobrac nieuregulowana.
                #Moze istniec tylko jedna nieuregulowana zaleglosc zwiazana z dana faktura.
                #Jest ona ostatnia zalegloscia. I zawiera informacje o obecnym stanie.
                #W celu jej wylowienia wprowadzamy zmienna porzadek. Nie moemy napisac prostego
                #warunku ureg_kwota=0 bo chcemy tez wiedziec czy istnieja wogle jakie zaleglosci
                #zwiazane z nasza pozycja
                Sql="SELECT platnik_id,kurs,waluta,ureg_kwota,do_zaplaty,do_zaplaty_wal,nr_zal"
                Sql+=",CASE WHEN ureg_kwota=0 THEN 1 ELSE 0 END AS porzadek,rodzaj FROM rs_zaleglosci"
                Sql+=" WHERE firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                Sql+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                Sql+=" AND numer="+str(d[i][4])+" ORDER BY porzadek DESC FOR UPDATE;"
                stat,d_f,dump,dump = self.PolSQL.Execute(Sql,3)
                if stat=='OK':
                    if len(d_f)==0:   #Nie ma zadnej zaleglosci zwiazanej z nasza pozycja. Sytuacja juz jest zla bo oznacza ze mamy do czynienia z niezamknieta faktura lub korekta ewentualnie korekta lub faktura nie istnieje
                        if d[i][1]=='F': #Mamy do czynienia z faktura. Sprawdzamy powod nie istnienia zadnej zaleglosci
                            #Probujemy pobrac fakture o podanym kluczu
                            Sql="SELECT platnik_id FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"'"
                            Sql+=" AND data='"+rsglobal.Dekoduj(d[i][3])+"' AND numer="+str(d[i][4])
                            stat,d_f,dump,dump = self.PolSQL.Execute(Sql,3)
                            if stat=='OK':
                                if len(d_f)==0: #Faktura o podanym kluczu nie istnieje
                                    stat='BL FAKT POZ$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                                else: #Faktura istnieje wiec musi bys nie zamknieta
                                    stat='NIE ZAM FAKT POZ$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                        elif d[i][1]=='K': #Mamy do czynienia z korekta. Sprawdzamy powd nie istnienia zadnej zaleglosci
                            #Probujemy pobrac korekte o podanym kluczu
                            Sql="SELECT platnik_id FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"'"
                            Sql+=" AND data='"+rsglobal.Dekoduj(d[i][3])+"' AND numer="+str(d[i][4])
                            stat,d_f,dump,dump = self.PolSQL.Execute(Sql,3)
                            if stat=='OK':
                                if len(d_f)==0: #Korekta o podanym kluczu nie istnieje
                                    stat='BL KOR POZ$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                                else: #Korekta istnieje wiec musi byc nie zamknieta
                                    stat='NIE ZAM KOR POZ FAKT$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)


                    elif (d_f[0][0]<>d[i][6]) and (d[i][6]<>'None'): #Zaleglosc istnieje ale platnik jest inny niz ten wpisany w pozycji
                        stat='INNY PLAT$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                        dane.append(stat)

                    else: #Zaleglosc istnieje i platnik jest taki sam jak w aktualnej pozycji raportu
                        rsglobal.ZapiszDoLogow('Zaleglosci istnieje i platnik jest taki sam ja w aktualnej pozycji raportu ',debug)
                        KursZZaleglosci=d_f[0][1]
                        WalutaZZaleglosci=d_f[0][2]
                        KwotaDoZaplatyWal=d_f[0][5]
                        KwotaDoZaplatyPLN = d_f[0][4]
                        NrZaleglosci=d_f[0][6]
                        RodzajZ=d_f[0][8]
                        KwotaZRaportu=d[i][5]
                        KwotaUreg=d_f[0][3]
                        if KwotaUreg==0:
                            rsglobal.ZapiszDoLogow('KwotaUreg==0',debug)
                            if WalutaZZaleglosci==WalutaRap:
                                rsglobal.ZapiszDoLogow('WalutaZZaleglosci==WalutaRap',debug)
                                SymbolWplaty=Kasa+"/"+Data+"/"+rsglobal.UsunKropkaZero(Numer)+"/"+rsglobal.UsunKropkaZero(d[i][7]) #symbol wplaty daje informacje jaki byl sposob regulacji i jaka pozycja raportu reguluje dana zaleglosci. Zaleglosci moga byc rowniez kompensowane.
                                if (KwotaDoZaplatyWal>0) and TypDokF=='P':
                                    if KwotaDoZaplatyWal==KwotaZRaportu:
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                    if KwotaDoZaplatyWal>KwotaZRaportu:
                                        KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+=" INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    if KwotaDoZaplatyWal<KwotaZRaportu:
                                        KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                elif (KwotaDoZaplatyWal>0) and TypDokF=='W':
                                    KwotaZRaportu=-KwotaZRaportu
                                    if KwotaDoZaplatyWal==KwotaZRaportu:
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                    if KwotaDoZaplatyWal>KwotaZRaportu:
                                        KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    if KwotaDoZaplatyWal<KwotaZRaportu:
                                        KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                elif (KwotaDoZaplatyWal<=0) and TypDokF=='W':
                                    if KwotaDoZaplatyWal==-KwotaZRaportu:
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                    if KwotaDoZaplatyWal<-KwotaZRaportu:
                                        KwotaUreg=-KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    if KwotaDoZaplatyWal>-KwotaZRaportu:
                                        KwotaUreg=-KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,"
                                        UpdateZaleglosci+="dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                elif (KwotaDoZaplatyWal<=0) and TypDokF=='P':
                                    if KwotaDoZaplatyWal==KwotaZRaportu:
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                    if KwotaDoZaplatyWal<KwotaZRaportu:
                                        KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota= "+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    if KwotaDoZaplatyWal>KwotaZRaportu:
                                        KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                        UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota= "+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                        UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                        UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                        UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                        UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                        UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                        UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                        UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                        UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                        UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                        UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                        UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                        UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "

                            else: #Waluty raportu i zaleglosci sa rozne
                                if WalutaRap=='PLN':
                                    SymbolWplaty=Kasa+"/"+Data+"/"+rsglobal.UsunKropkaZero(Numer)+"/"+rsglobal.UsunKropkaZero(d[i][7])
                                    if (KwotaDoZaplatyPLN>0) and TypDokF=='P':
                                        if KwotaDoZaplatyPLN==KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyPLN>KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+=" INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyPLN<KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    elif (KwotaDoZaplatyPLN>0) and TypDokF=='W':
                                        KwotaZRaportu=-KwotaZRaportu
                                        if KwotaDoZaplatyPLN==KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyPLN>KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyPLN<KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    elif (KwotaDoZaplatyPLN<=0) and TypDokF=='W':
                                        if KwotaDoZaplatyPLN==-KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyPLN<-KwotaZRaportu:
                                            KwotaUreg=-KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyPLN>-KwotaZRaportu:
                                            KwotaUreg=-KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,"
                                            UpdateZaleglosci+="dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    elif (KwotaDoZaplatyPLN<=0) and TypDokF=='P':
                                        if KwotaDoZaplatyPLN==KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyPLN<KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota= "+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyPLN>KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota= "+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"

                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                else:
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci!=WalutaRap',debug)
                                    stat='ROZNE WAL$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)

                        else:
                            SymbolWplaty=Kasa+"/"+Data+"/"+rsglobal.UsunKropkaZero(Numer)+"/"+rsglobal.UsunKropkaZero(d[i][7])
                            rsglobal.ZapiszDoLogow('KwotaUreg!=0',debug)
                            if WalutaZZaleglosci==WalutaRap:
                                rsglobal.ZapiszDoLogow('WalutaZZaleglosci==WalutaRap',debug)
                                if TypDokF=='P':
                                    KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                    KwotaUregWal=KwotaZRaportu
                                else:
                                    KwotaUreg=-KwotaZRaportu*KursZZaleglosci
                                    KwotaUregWal=-KwotaZRaportu
                                if -KwotaUreg>0:
                                    UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                    UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                    UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                    UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,symbol_wplaty,opis,numer_z_rs)"
                                    UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                    UpdateZaleglosci+="data,numer,oddzial_id,'Z',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                    UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                    UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus,0,0,"+str(KwotaUreg)+",'"+Data+"',NULL,'','"+SymbolWplaty+"',"
                                    UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "

                                    UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                    UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                    UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                    UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                                    UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                    UpdateZaleglosci+="data,numer,oddzial_id,'Z',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                    UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                    UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaUregWal)+",0,NULL,NULL,'',"
                                    UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                else:
                                    UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                    UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                    UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                    UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,symbol_wplaty,opis,numer_z_rs)"
                                    UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                    UpdateZaleglosci+="data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                    UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                    UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus,0,0,"+str(KwotaUreg)+",'"+Data+"',NULL,'','"+SymbolWplaty+"',"
                                    UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "

                                    UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                    UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                    UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                    UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                                    UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                    UpdateZaleglosci+="data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                    UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                    UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaUregWal)+",0,NULL,NULL,'',"
                                    UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                            else: #Waluty raporotu i zaleglosci sa rozne
                                if WalutaRap=='PLN':
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci==WalutaRap',debug)
                                    if TypDokF=='P':
                                        KwotaUreg=KwotaZRaportu
                                        KwotaUregWal=KwotaZRaportu/KursZZaleglosci
                                    else:
                                        KwotaUreg=-KwotaZRaportu
                                        KwotaUregWal=-KwotaZRaportu/KursZZaleglosci
                                    if -KwotaUreg>0:
                                        UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                        UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                        UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                        UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,symbol_wplaty,opis,numer_z_rs)"
                                        UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                        UpdateZaleglosci+="data,numer,oddzial_id,'Z',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                        UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                        UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus,0,0,"+str(KwotaUreg)+",'"+Data+"',NULL,'','"+SymbolWplaty+"',"
                                        UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                        UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                        UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                        UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                                        UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                        UpdateZaleglosci+="data,numer,oddzial_id,'Z',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                        UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                        UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaUregWal)+",0,NULL,NULL,'',"
                                        UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    else:
                                        UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                        UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                        UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                        UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,symbol_wplaty,opis,numer_z_rs)"
                                        UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                        UpdateZaleglosci+="data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                        UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                        UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus,0,0,"+str(KwotaUreg)+",'"+Data+"',NULL,'','"+SymbolWplaty+"',"
                                        UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "

                                        UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                        UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                        UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                        UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                                        UpdateZaleglosci+=" SELECT firma_id,typ_dok,wyznacznik_id,"
                                        UpdateZaleglosci+="data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                        UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                        UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaUregWal)+",0,NULL,NULL,'',"
                                        UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                else:
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci!=WalutaRap',debug)
                                    stat='ROZNE WAL$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)

                        if stat=='OK':
                            stat,dump,dump,dump=self.PolSQL.Execute(UpdateZaleglosci,1)
                            if not stat=='OK':
                                stat,dump,dump,dump=self.PolSQL.Execute("SELECT SETVAL('rs_zaleglosci_nr_zal_seq',(SELECT MAX(nr_zal)+1 FROM rs_zaleglosci))",1)
                                if stat=='OK':
                                    stat,d_z,dump,dump=self.PolSQL.Execute(UpdateZaleglosci,1)
                            if stat<>"OK":
                                stat='BL UPD POZ ZAL'
                                dane.append(stat)


                    i=i+1
    
    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
    
    # obsluga typu 'N' niezidentyfikowany - tworzenie nadplaty w zaleglosciach
    if stat == 'OK':
        sql ="SELECT typ_fakt,platnik_id,kurs,kwota,COALESCE(kierowca,''::TEXT),nr_poz,nr_ppoz"
        sql+=" FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND typ_fakt='N' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+rsglobal.Dekoduj(Kasa)+"'"
        sql+=" AND data='"+rsglobal.Dekoduj(Data)+"' AND numer="+Numer+";" 

        stat,dPozN,dump,dump=self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = "'Bd pobrania pozycji z raporty-wyciagu dla typu 'N'"
            dane.append(stat)
        
        elif len(dPozN) > 0:
            UpdateZaleglosci = ''

            for i in xrange(len(dPozN)):
                TypDok = "'"+rsglobal.Dekoduj(dPozN[i][0])+"'"
                Kontrah = "'"+rsglobal.Dekoduj(dPozN[i][1])+"'"
                if Kontrah == "'None'":
                    Kontrah = 'Null'
                Kurs = dPozN[i][2]
                DoZaplaty = -1*dPozN[i][3]
                DoZaplatyWal = -1*rsglobal.RSRound(Kurs* dPozN[i][3],2)
                
                Oddzial = "'"+self.oddzial_id+"'"
                Handlowiec = 'NULL'
                
                #pobranie oddzialu i handlowca z ostatniej faktury
                #najpierw sprobujemy dla kontrahenta, bo to zapytanie jest
                #malo kosztowne, gdyz rs_faktury posiadaja indeks na kontrahencie
                sql ="SELECT oddzial_id,COALESCE(handlowiec,''::TEXT) FROM rs_faktury"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kontrahent_id="+Kontrah
                sql+=" ORDER BY data DESC, numer DESC LIMIT 1;"
                
                stat,dOstF,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania danych z ostatniej faktury dla kontrahenta: '+stat
                    dane.append(stat)
                    break
                elif len(dOstF) == 1:
                    Oddzial = "'"+rsglobal.Dekoduj(dOstF[0][0])+"'"
                    if rsglobal.Dekoduj(dOstF[0][1]) != '':
                        Handlowiec = "'"+rsglobal.Dekoduj(dOstF[0][1])+"'"
                else:
                    sql ="SELECT oddzial_id,COALESCE(handlowiec,''::TEXT) FROM rs_faktury"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND platnik_id="+Kontrah
                    sql+=" ORDER BY data DESC, numer DESC LIMIT 1;"

                    stat,dOstF,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'Bd pobrania danych z ostatniej faktury dla patnika: '+stat
                        dane.append(stat)
                        break
                    elif len(dOstF) == 1:
                        Oddzial = "'"+rsglobal.Dekoduj(dOstF[0][0])+"'"
                        if rsglobal.Dekoduj(dOstF[0][1]) != '':
                            Handlowiec = "'"+rsglobal.Dekoduj(dOstF[0][1])+"'"

                Kierowca = rsglobal.Dekoduj(dPozN[i][4]).strip()
                if Kierowca == '':
                    Kierowca = 'NULL'
                else:
                    Kierowca = "'"+Kierowca+"'"
                    
                SymbolWplaty = "'"+Kasa+"/"+Data+"/"+rsglobal.UsunKropkaZero(Numer)+"/"+\
                               rsglobal.UsunKropkaZero(dPozN[i][5])+"'"
                                             
                UpdateZaleglosci+="INSERT INTO rs_zaleglosci ("
                UpdateZaleglosci+=" firma_id,typ_dok,oddzial_id,rodzaj,ureg_kwota,"
                UpdateZaleglosci+=" kontrahent_id,zamawiajacy_id,platnik_id,handlowiec,"
                UpdateZaleglosci+=" waluta,kurs,termin_zaplaty,"
                UpdateZaleglosci+=" czy_bonus,do_zaplaty,do_zaplaty_wal,symbol_wplaty"
                UpdateZaleglosci+=" ) VALUES ("
                UpdateZaleglosci+=" '"+self.firma_id+"',"+TypDok+","+Oddzial+",'N',0,"
                UpdateZaleglosci+=" "+Kontrah+","+Kontrah+","+Kontrah+","+Handlowiec+","
                UpdateZaleglosci+=" '"+rsglobal.Dekoduj(DWaluty[0][0])+"',"+str(Kurs)+",'"+Data+"',"
                UpdateZaleglosci+=" FALSE, "+str(DoZaplaty)+", "+str(DoZaplatyWal)+","+SymbolWplaty+"); "
                
            if stat == 'OK' and UpdateZaleglosci != '':
                stat,dump,dump,dump = self.PolSQL.Execute(UpdateZaleglosci,1)
                if stat != 'OK':
                    stat = 'Bd dodania zalegoci dla typu N: '+stat
                    dane.append(stat)    
                
            
    if stat=='OK':    
        Sql="SELECT nr_poz,suma FROM (SELECT SUM(CASE WHEN (nr_ppoz!=0 AND typ='P') OR (nr_ppoz=0 AND typ='W')"
        Sql+=" THEN round(-kwota,2) ELSE round(kwota,2) END) AS suma"
        Sql+=", nr_poz, SUM(nr_ppoz) AS ppoz FROM rs_raporty_wyciagi_pozycje "
        Sql+="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' "
        Sql+="AND data='"+Data+"' AND numer="+Numer+" GROUP BY nr_poz) AS tabela WHERE suma!=0 AND ppoz!=0;" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)>0:
                stat="BL SUM KWOT PPOZ$"+str(d[0][0])
                dane.append(stat)      
        
    if len(dane)>0:
        stat=dane[-1]    
        

        #----------------------------------
        # Zamknicie patnoci z pozycji wycigu
        #----------------------------------
    if stat=='OK':
        sql="UPDATE rs_platnosci SET uregulowano=rwp.kwota, data_zapl=rwp.data"
        sql+=" FROM rs_raporty_wyciagi_pozycje rwp WHERE rwp.firma_id='"+self.firma_id+"'"
        sql+=" AND rwp.okres_id='"+self.okres_id+"' AND rwp.kasa_bank_id='"+Kasa+"' "
        sql+=" AND rwp.data='"+Data+"' AND rwp.numer="+Numer+" AND NOT rwp.platnosc_id IS NULL"
        sql+=" AND rs_platnosci.firma_id=rwp.firma_id AND rs_platnosci.platnosc_id=rwp.platnosc_id;"
        
        sql+=" INSERT INTO rs_platnosci (platnosc_pierw,firma_id,konto_id,kontrahent_id,stan,dowod,nr_faktury,termin_plat,"
        sql+=" kwota_oryg,kwota_platnosci,konto_fk) "
        sql+=" SELECT platnosc_pierw,firma_id,konto_id,kontrahent_id,stan,dowod,nr_faktury,termin_plat,"
        sql+=" kwota_oryg,kwota_platnosci-uregulowano,konto_fk"
        sql+=" FROM rs_platnosci p WHERE p.platnosc_id IN "
        sql+=" (SELECT platnosc_id FROM rs_raporty_wyciagi_pozycje rwp"
        sql+=" WHERE rwp.firma_id='"+self.firma_id+"' AND rwp.okres_id='"+self.okres_id+"' AND rwp.kasa_bank_id='"+Kasa+"'"
        sql+=" AND rwp.data='"+Data+"' AND rwp.numer="+Numer+" AND NOT rwp.platnosc_id IS NULL)"
        sql+=" AND p.uregulowano!=p.kwota_platnosci;"

        sql+="UPDATE rs_platnosci SET stan='Z'"
        sql+=" FROM rs_raporty_wyciagi_pozycje rwp WHERE rwp.firma_id='"+self.firma_id+"'"
        sql+=" AND rwp.okres_id='"+self.okres_id+"' AND rwp.kasa_bank_id='"+Kasa+"' "
        sql+=" AND rwp.data='"+Data+"' AND rwp.numer="+Numer+" AND NOT rwp.platnosc_id IS NULL"
        sql+=" AND rs_platnosci.firma_id=rwp.firma_id AND rs_platnosci.platnosc_id=rwp.platnosc_id;"
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
    if stat=='OK':
        if len(d)>0:
            stat="BL ZAM PLAT$"+str(stat)
            dane.append(stat)      

        #----------------------------------
        #Wykonywanie zamykania - tworzenie dowodu ksigowego
        #----------------------------------
    if stat=='OK':           
        Sql="SELECT dowod_id, nazwa_id,konto,waluta,zamykac_dowod FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"';"
        stat,d,wyn,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)==0:
                stat='BL SQL DOW'
                dane.append(stat)

    if stat=='OK':
        DowodId=rsglobal.Dekoduj(d[0][0])
        DowodNazwa=rsglobal.Dekoduj(d[0][1])
        Konto=rsglobal.Dekoduj(d[0][2])
        Waluta=rsglobal.Dekoduj(d[0][3])
        ZamykacDowod=rsglobal.Dekoduj(d[0][4])
        Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND okres_id=\\\'"+self.okres_id+"\\\' AND dowod_id=\\\'"+DowodId+"\\\'"
        Warunek+=" AND nazwa_id=\\\'"+DowodNazwa+"\\\' AND data=\\\'"+Data+"\\\'"
        sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\""+self.okres_id+"\",\""+DowodId+"\",\""+DowodNazwa+"\",\""+Data+"\"]','D');"
        stat,d,wyn,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if d[0][0]=='OK':
                sql="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\""+self.okres_id+"\",\""+DowodId+"\",\""+DowodNazwa+"\",\""+Data+"\"]','D');"
                stat,d,wyn,dump=self.PolSQL.Execute(sql,3)
            else:
                d=[]
                
    if stat=='OK':
        if len(d)==0:
            stat='BL DATA DOW SA POZ'
            dane.append(stat)
            
    if stat=='OK':        
        Nr=d[0][0]
        Sql="SELECT kurs FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL SQL KURS$'+stat
            dane.append(stat)            
        
    if stat=='OK':        
        Kurs=d[0][0]        
        SymbolRaportu=Kasa.strip()+'/'+Data+'/'+Numer
        Insert="INSERT INTO rs_dowody_ksiegowe (firma_id, okres_id, dowod_id, nazwa_id, data, numer,stan,symbol_dok)"
        Insert+=" VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+DowodId+"','"+DowodNazwa+"','"+Data+"',"+str(Nr)+",'W','"+SymbolRaportu+"');"
        
        stat,d,dump,dump=self.PolSQL.Execute(Insert,1)
        
    if stat=='OK':
        Select="SELECT kasa_bank_id,data,numer,nr_poz,nr_ppoz,stan_poz,typ,symbol_dok,platnik_id,kierowca,typ_fakt,wyznacznik_id," #0 -11
        Select+="data_fakt,numer_fakt,konto,kwota,tresc,kurs,platnosc_id,TRIM(COALESCE(sposob_zaplaty,'')) FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'" #12-19
        Select+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer                   
        stat,d_s,dump,dump=self.PolSQL.Execute(Select,3)
        
    if stat == 'OK':
        #JR 2022-04-09 (12964) - uwzglednienie kont dla sposobow platnosci
        # zapamietujemy konto z naglowka definicji zeby je ewentualnie zastapic kontem ze sposobu platosci
        KontoNagl = Konto
        for wiersz in d_s:
            if stat == 'OK':
                Konto = KontoNagl  # przywracamy konto glowne
                p_kasa_bank_id=rsglobal.Dekoduj(wiersz[0])
                p_data=rsglobal.Dekoduj(wiersz[1])
                p_numer=wiersz[2]
                p_nr_poz=wiersz[3]
                p_nr_ppoz=wiersz[4]
                p_stan_poz=rsglobal.Dekoduj(wiersz[5])
                p_typ=rsglobal.Dekoduj(wiersz[6])
                p_symbol_dok=rsglobal.Dekoduj(wiersz[7])
                p_platnik_id=rsglobal.Dekoduj(wiersz[8])
                p_kierowca=rsglobal.Dekoduj(wiersz[9])
                p_typ_fakt=rsglobal.Dekoduj(wiersz[10])
                p_wyznacznik_id=rsglobal.Dekoduj(wiersz[11])
                p_data_fakt=rsglobal.Dekoduj(wiersz[12])
                p_numer_fakt=wiersz[13]
                p_konto=rsglobal.Dekoduj(wiersz[14])
                p_kwota=rsglobal.Dekoduj(wiersz[15])
                p_tresc=rsglobal.Dekoduj(wiersz[16]).replace("'","\\\'")
                if p_tresc in (None,'None',''):
                    p_tresc='.'
                p_kurs_wn=wiersz[17]
                p_kurs_ma=wiersz[17]
                platnosc_id=wiersz[18]
                p_sposob_zaplaty = wiersz[19]
                p_waluta_wn=Waluta
                p_waluta_ma=Waluta
                p_nr_pozw=1
                Tresc=p_tresc
                p_nr_rozr_wn=0
                p_nr_rozr_ma=0

                # JR 2022-04-09 (12964) - uwzglednienie kont dla sposobow platnosci
                for p in sposoby_konta:
                    if p_sposob_zaplaty.strip() == p[0].strip():
                        Konto = p[1]

                #Jaka tresc jesli faktura
                if (p_typ_fakt in ['F','K']):
                    p_tresc='faktura '+p_wyznacznik_id+'/'+p_data_fakt+'/'+str(p_numer_fakt)
                
                #Sprawdzamy jaki powinien byc numer rozrachunku przeciwnego
                stat,p_nr_rozr_wn,p_nr_rozr_ma=PodajNumerRozrachunkowDoPary(p_typ_fakt,self.firma_id,self.okres_id,p_wyznacznik_id,p_data_fakt,p_numer_fakt,p_konto,platnosc_id,self.PolSQL,self)
    
            if stat=='OK':
                #Jaki termin platnosci
                if (p_typ_fakt in ['F','K']) and ((p_typ == 'P' and p_kwota > 0) or (p_typ == 'W' and p_kwota < 0)):
                    sql="Select COALESCE(termin_zaplaty::TEXT,'') FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND typ_dok='"+p_typ_fakt+"'"
                    sql+=" AND wyznacznik_id='"+p_wyznacznik_id+"' AND data='"+p_data_fakt+"' AND numer="+str(p_numer_fakt)+" LIMIT 1"
                    stat,d_termin,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if len(d_termin)==1:
                            if d_termin[0][0] == '':
                                p_termin_plat='NULL'
                            else:
                                p_termin_plat="'"+rsglobal.Dekoduj(d_termin[0][0])+"'"                                
                        
                else:
                    p_termin_plat="NULL"    
                        
            if stat=='OK':
                #Jakie konto. W przypadku kiedy mamy do czynienia z pozycja  powsta w trakcie regulacji korekty
                # naley odnale fakture, z ktrej utworzono t korekte.(moze byc tak ze korekta powstala z korekty a ta korekta 
                #z jeszcze innej korekty. Dlatego poszukujemy w gb a znajdziemy pierwsz fakture) Jak ju znajdziemy fakture to
                #na podstawie wzoru dekretacji tej faktury wybieramy konto. 
                # Dowody dostaw pobieraj dane warunkw z kontrahenta wpisanego w pozycji sigajc do jego 
                # ostatniej faktury. Jeli jej nie ma to siga do danych kontrahenta
                
                #---------------------------------------------------------------
                # FAKTURY I KOREKTY
                #---------------------------------------------------------------
                if (p_typ_fakt in ['F','K']):
                    r_typ_dok=p_typ_fakt
                    r_wyznacznik_id=p_wyznacznik_id
                    r_data_fakt=p_data_fakt
                    r_numer_fakt=p_numer_fakt
                    KorektaWart=False
                    while r_typ_dok<>'F' and not KorektaWart and stat=='OK':
                        rsglobal.ZapiszDoLogow('!!! WHILE 3 '+r_typ_dok+' '+stat+' '+r_wyznacznik_id+' '+r_data_fakt+' '+str(r_numer_fakt),1)
                        sql="SELECT typ_dok_p,COALESCE(wyznacznik_id_p,''),COALESCE(data_p::TEXT,''),COALESCE(numer_p,0)"
                        sql+=" FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND wyznacznik_id='"+r_wyznacznik_id+"' AND data='"+r_data_fakt+"' AND numer="+str(r_numer_fakt)
                        stat,d_korekty,dump,dump=self.PolSQL.Execute(sql,3)
                        if stat=='OK':
                            if len(d_korekty)>0:
                                # korekta wartociowa bez numeru pierwotnego
                                if d_korekty[0][1]=='':
                                    KorektaWart=True
                                else:
                                    # normalny dokument pierwotny korekty
                                    r_typ_dok=rsglobal.Dekoduj(d_korekty[0][0])
                                    r_wyznacznik_id=rsglobal.Dekoduj(d_korekty[0][1])
                                    r_data_fakt=rsglobal.Dekoduj(d_korekty[0][2])
                                    r_numer_fakt=d_korekty[0][3]
                            else:
                                stat='BR KOR$'+r_wyznacznik_id+'/'+r_data_fakt+'/'+str(r_numer_fakt)+' z pozycji '+str(p_nr_poz)+' i podpozycji:'+str(p_nr_ppoz)
                                dane.append(stat)
                    
                    if stat=='OK':
                        #pobranie wartosci zmiennych z ktorych bedzie robiony warunek
                        if p_typ_fakt=='F':
                            tabelapom='rs_faktury'
                        else:
                            tabelapom='rs_korekty'
           
                        SQLWar="SELECT platnik_id,waluta,projekt_id,kontrahent_id,zamawiajacy_id,sposob_zaplaty,kierowca,handlowiec,wersja"
                        SQLWar+=" FROM "+tabelapom+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+p_wyznacznik_id+"' "
                        SQLWar+=" AND data='"+p_data_fakt+"' AND numer="+str(p_numer_fakt)
                        stat,dwar,dump,dump = self.PolSQL.Execute(SQLWar,3)
                    
                    if stat=='OK':
                        if len(dwar)==0:
                            stat='BR FAKT$'+p_wyznacznik_id+'/'+p_data_fakt+'/'+str(p_numer_fakt)+' z pozycji '+str(p_nr_poz)+' i podpozycji:'+str(p_nr_ppoz)
                            dane.append(stat)
                        
                # pobranie danych pomocniczych dla dowodu dostawy
                if p_typ_fakt =='D':
                    r_wyznacznik_id=p_wyznacznik_id
                    # najpierw z ostatniej faktury dla patnika
                    SQLWar="SELECT platnik_id,waluta,projekt_id,kontrahent_id,zamawiajacy_id,sposob_zaplaty,kierowca,handlowiec,wersja"
                    SQLWar+=" FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+p_wyznacznik_id+"' "
                    SQLWar+=" AND platnik_id='"+p_platnik_id+"' AND data<='"+p_data+"'"
                    SQLWar+=" ORDER BY data DESC, numer DESC LIMIT 1"
                    stat,dwar,dump,dump = self.PolSQL.Execute(SQLWar,3)
                    
                    if stat=='OK':
                        # jeli nie ma to niepene dane z danych do fakturowania (waluta to PLN a kierowca pusty)
                        if len(dwar)==0:
                            SQLWar="SELECT COALESCE(k.platnik_id,k.kontrahent_id),'PLN',kf.projekt_id,k.kontrahent_id,"
                            SQLWar+="COALESCE(k.zamawiajacy_id,k.kontrahent_id),kf.spos_zaplaty,'',kf.handlowiec,kf.wersja "
                            SQLWar+=" FROM rs_kontrahenci k "
                            SQLWar+=" LEFT OUTER JOIN rs_kontrahenci_fakturowanie kf USING (firma_id,kontrahent_id) "
                            SQLWar+=" WHERE firma_id='"+self.firma_id+"' AND k.kontrahent_id='"+p_platnik_id+"'"
                            SQLWar+=" AND kf.data_od <='"+p_data+"'"
                            SQLWar+=" ORDER BY kf.data_od DESC LIMIT 1"
                            stat,dwar,dump,dump = self.PolSQL.Execute(SQLWar,3)    
                            
                            if stat=='OK':
                                if len(dwar)==0:
                                    stat='Brak moliwoci pobrania danych dla dowodu dostawy dla patnika '+p_platnik_id+' i wyznacznika '+p_wyznacznik_id+' z pozycji '+str(p_nr_poz)+' i podpozycji:'+str(p_nr_ppoz)
                                    dane.append(stat)
                                    
                # wsplna cz dla wszystkich trzech typw dokumentw
                if (p_typ_fakt in ['F','K','D']):        
                    if stat=='OK':
                        WarPlatnik=rsglobal.Dekoduj(dwar[0][0]).strip()
                        WarWaluta=rsglobal.Dekoduj(dwar[0][1]).strip()
                        WarProjektId=rsglobal.Dekoduj(dwar[0][2]).strip()
                        WarKontrahent=rsglobal.Dekoduj(dwar[0][3]).strip()
                        WarZamawiajacy=rsglobal.Dekoduj(dwar[0][4]).strip()
                        WarSposobZaplaty=rsglobal.Dekoduj(dwar[0][5]).strip()
                        WarKierowca=rsglobal.Dekoduj(dwar[0][6]).strip()
                        WarHandlowiec=rsglobal.Dekoduj(dwar[0][7]).strip()
                        WarWersja=rsglobal.Dekoduj(dwar[0][8]).strip()
           
                        #sql="SELECT konto_wn,warunek,COALESCE(czy_kontrahent,TRUE),konto_wn_z_kontrahenta FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"  #JR 2022-01-26 (12846)
                        sql="SELECT konto_wn,warunek,COALESCE(czy_kontrahent,FALSE),konto_wn_z_kontrahenta FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                        sql+=" AND wyznacznik_id='"+r_wyznacznik_id+"' AND ((COALESCE(konto_wn,'') != '') OR konto_wn_z_kontrahenta)"
                        stat,d_konto,dump,dump=self.PolSQL.Execute(sql,3)
                        Znalazl=False

                    if stat=='OK':
                        DodawacPlatnika = True
                        if len(d_konto)>0:
                            for kon in d_konto:
                                if not Znalazl:
                                    if kon[1] in ('',None,'None'):
                                        Znalazl=True
                                    else:
                                        try:
                                            SprWar=rsglobal.Dekoduj(kon[1])
                                            if kon[3]:
                                                Znalazl=True
                                            elif eval(SprWar):
                                                Znalazl=True
                                        except Exception,e:
                                            stat="BL WAR$"+r_wyznacznik_id+' warunek:'+str(SprWar)+' problem :'+str(e)
                                            dane.append(stat)
                                        
                                    if stat=='OK' and Znalazl:    
                                        #sprawdzenie warunkw
                                        if kompensata:
                                            Konto=p_konto
                                        if kon[3]:
                                            SQL ="SELECT COALESCE(konto_odbiorca,'') FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                                            SQL+=" AND kontrahent_id='"+WarPlatnik+"'"
                                            stat,DKontoWn,dump,dump = self.PolSQL.Execute(SQL,3)            
                                            if stat =='OK':
                                                p_konto=rsglobal.Dekoduj(DKontoWn[0][0])
                                        else:
                                            p_konto=rsglobal.Dekoduj(kon[0])
                                        DodawacPlatnika = kon[2]
                                        
                    if stat=='OK':
                        if not Znalazl:
                            if p_typ_fakt=='F':
                                stat='BR WZOR DEKR$'+r_wyznacznik_id+' dla pozycji '+str(p_nr_poz)+' i podpozycji '+str(p_nr_ppoz)
                            elif p_typ_fakt=='K':
                                stat='BR WZOR DEKR$'+r_wyznacznik_id+' dla korekty z wyzn. '+p_wyznacznik_id+' dla pozycji '+str(p_nr_poz)+' i podpozycji '+str(p_nr_ppoz)
                            elif p_typ_fakt=='D':
                                stat='BR WZOR DEKR$'+r_wyznacznik_id+' dla dowodu dostawy z wyzn. '+p_wyznacznik_id+' dla pozycji '+str(p_nr_poz)+' i podpozycji '+str(p_nr_ppoz)
                            dane.append(stat)

                    if stat=='OK':
                        if p_konto<>'' and DodawacPlatnika:
                            p_konto=p_konto+"-"+p_platnik_id

                
            # dalsza cz wsplna algorytmu
            if stat=='OK':    
                if p_nr_ppoz>0 and p_typ=='P': 
                    przypadek=1
                elif  p_nr_ppoz>0 and p_typ=='W':
                    przypadek=2
                elif p_nr_ppoz==0:
                    sql="SELECT MAX(nr_ppoz) FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+p_kasa_bank_id+"' AND data='"+p_data+"'"
                    sql+=" AND numer="+str(p_numer)+" AND nr_poz="+str(p_nr_poz)+";"
                    d_smax=[]
                    stat,d_smax,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if len(d_smax)>0:
                            if d_smax[0][0]==0:
                                przypadek=3
                            else:
                                przypadek=4
                        else:        
                            stat='BL SEL IL POZ'
                            dane.append(stat)
                    else:
                        stat='BL SEL IL POZ'
                        dane.append(stat)
                   
            if stat=='OK':
                if (wiersz[17] not in (1,0)):
                    p_kwota_pln=round(wiersz[17]*p_kwota,2)
                else:
                    p_kwota_pln=p_kwota
                
                
                #Jaka Tresc Wn
                if przypadek==3 and p_typ=='P' and kompensata:
                    p_tresc_wn=Tresc
                elif (przypadek==1) or (przypadek==4 and p_typ=='W'):
                    p_tresc_wn=''
                else:
                    p_tresc_wn=p_tresc

                #Jaka Tresc Ma
                if przypadek==3 and p_typ=='W' and kompensata:
                    p_tresc_wn=Tresc
                if (przypadek==2) or (przypadek==4 and p_typ=='P'):
                    p_tresc_ma=''
                else:
                    p_tresc_ma=p_tresc
                
                #Jakie Konto Wn
                if (przypadek==2) or (przypadek==3 and p_typ=='W'):
                    p_konto_wn=p_konto
                elif (przypadek==3 or przypadek==4) and (p_typ=='P'):
                    p_konto_wn=Konto
                else:
                    p_konto_wn=''
                
                #Jakie Konto Ma
                if (przypadek==1) or (przypadek==3 and p_typ=='P'):    
                    p_konto_ma=p_konto
                elif (przypadek==3 or przypadek==4) and (p_typ=='W'):
                    p_konto_ma=Konto
                else:
                    p_konto_ma=''
                
                #Jaka kwota Wn
                if przypadek==1 or (przypadek==4 and p_typ=='W'):
                    p_kwota_wn=0
                    p_kwota_wal_wn=0
                else:
                    p_kwota_wn=p_kwota_pln
                    p_kwota_wal_wn=p_kwota
                
                #Jaka kwota Ma
                if przypadek==2 or (przypadek==4 and p_typ=='P'):
                    p_kwota_ma=0
                    p_kwota_wal_ma=0
                else:
                    p_kwota_ma=p_kwota_pln
                    p_kwota_wal_ma=p_kwota
                
                if p_platnik_id in ['','None']:
                    p_platnik_id='NULL'
                else:
                    p_platnik_id="'"+p_platnik_id+"'"
                
                #----------------------------------
                # OBSUGA FAKTUR I KOREKT NAPISANA NA WIEO
                #----------------------------------
                
                # obsuga pozycji nagwkowej gdzie faktury/korekty wpisane
                # do podpozycji
                
                CzyPozycjaFakturowa=False
                
                #jest szansa, e jest to nagwek kilku podpozycji fakturowych
                if p_nr_ppoz==0 and p_typ_fakt=='':
                    SQL="SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
                    SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+p_kasa_bank_id+"'"
                    SQL+=" AND data='"+p_data+"' AND numer="+str(p_numer)+" AND nr_poz="+str(p_nr_poz)
                    SQL+=" AND nr_ppoz>0 AND typ_fakt IN ('F','K') ;"
                    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        CzyPozycjaFakturowa=len(DTest)>0
                    
            if stat=='OK':
                #jeli to nagwek podpozycji fakturowych lub podpozycja fakturowa
                if CzyPozycjaFakturowa or (p_typ_fakt in ['F','K'] and p_nr_ppoz>0):
                    if (p_typ=='P' and CzyPozycjaFakturowa) or (p_typ=='W' and p_typ_fakt in ['F','K']):
                        p_tresc_wn=p_tresc
                        if CzyPozycjaFakturowa:
                            p_konto_wn=Konto
                        else:
                            p_konto_wn=p_konto
                        p_kwota_wn=p_kwota_pln
                        p_kwota_wal_wn=p_kwota
                        p_tresc_ma=''
                        p_konto_ma='' 
                        p_kwota_ma=0
                        p_kwota_wal_ma=0                                    
                    else:
                        p_tresc_wn=''
                        p_konto_wn='' 
                        p_kwota_wn=0
                        p_kwota_wal_wn=0    
                        p_tresc_ma=p_tresc
                        if CzyPozycjaFakturowa:
                            p_konto_ma=Konto
                        else:
                            p_konto_ma=p_konto
                        p_kwota_ma=p_kwota_pln
                        p_kwota_wal_ma=p_kwota
                
                # typ dokumentu 'N' - niezidentyfikowany
                if p_typ_fakt == 'N':
                    if p_nr_ppoz > 0:
                        # jesli to podpozycja, to strona przeciwstawna w pozycji glownej
                        p_tresc_wn=''
                        p_konto_wn='' 
                        p_kwota_wn=0
                        p_kwota_wal_wn=0
                    else:
                        # strona przeciwstawna z ogolnej definicji raportu-wyciagu
                        p_tresc_wn=p_tresc
                        p_konto_wn=Konto 
                        p_kwota_wn=p_kwota_pln
                        p_kwota_wal_wn=p_kwota
                        
                if platnosc_id in (0,'0',None,'None'):
                    platnosc_id='NULL'
                InsertPoz="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id, nazwa_id, data, numer, nr_poz, nr_ppoz,"
                InsertPoz+="nr_pozw,kontrahent_id,tresc_wn,tresc_ma,symbol_dok,data_zapl,termin_plat,konto_wn,kwota_wn,kwota_wal_wn,"
                InsertPoz+="konto_ma,kwota_ma,kwota_wal_ma,kurs_wn,waluta_wn,kurs_ma,waluta_ma,seria_wn,seria_ma,sposob_rozl,"
                InsertPoz+="rw_kasa_bank_id,rw_data,rw_numer,rw_nr_poz,rw_nr_ppoz,platnosc_id) VALUES ('"+self.firma_id+"',"
                InsertPoz+="'"+self.okres_id+"','"+DowodId+"','"+DowodNazwa+"','"+Data+"',"+str(Nr)+","+str(p_nr_poz)+","+str(p_nr_ppoz)
                InsertPoz+=","+str(p_nr_pozw)+","+p_platnik_id+",'"+p_tresc_wn+"','"+p_tresc_ma+"','"+p_symbol_dok+"','"+Data+"',"
                InsertPoz+=p_termin_plat+",'"+p_konto_wn+"',"+str(p_kwota_wn)+","+str(p_kwota_wal_wn)+",'"+p_konto_ma+"',"+str(p_kwota_ma)+","
                InsertPoz+=str(p_kwota_wal_ma)+","+str(p_kurs_wn)+",'"+p_waluta_wn+"',"+str(p_kurs_ma)+",'"+p_waluta_ma+"',"
                InsertPoz+=str(p_nr_rozr_wn)+","+str(p_nr_rozr_ma)+",'','"+p_kasa_bank_id+"','"+p_data+"',"
                InsertPoz+=str(p_numer)+","+str(p_nr_poz)+","+str(p_nr_ppoz)+","+str(platnosc_id)+")"
                stat,dump,dump,dump=self.PolSQL.Execute(InsertPoz,1)
                if stat<>'OK':
                    stat='BL ZAM POZ'
                    dane.append(stat)
            
    
    if stat=='OK':    
        if len(dane)<>0:
            stat=dane[-1]

    if stat=='OK':
        UpdateDow="Update rs_dowody_ksiegowe SET kwota_wn=(SELECT SUM(kwota_wn) FROM rs_dowody_ksiegowe_pozycje"
        UpdateDow+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodId+"'"
        UpdateDow+=" AND nazwa_id='"+DowodNazwa+"' AND data='"+Data+"' AND numer="+str(Nr)+"),"
        UpdateDow+="kwota_ma=(SELECT SUM(kwota_ma) FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"'"
        UpdateDow+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodId+"' AND nazwa_id='"+DowodNazwa+"' AND data='"+Data+"'"
        UpdateDow+=" AND numer="+str(Nr)+") WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UpdateDow+=" AND dowod_id='"+DowodId+"' AND nazwa_id='"+DowodNazwa+"' AND data='"+Data+"' AND numer="+str(Nr)+"; "
        
        Update="Update rs_raporty_wyciagi SET stan='Z' WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Update+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
        
        UpdatePoz="Update rs_raporty_wyciagi_pozycje SET stan_poz='Z' WHERE  firma_id='"+self.firma_id+"'"
        UpdatePoz+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
    
        stat,dump,dump,dump=self.PolSQL.Execute(UpdateDow+Update+UpdatePoz,1)
        if stat<>'OK':
            stat='BL ZAM'
            dane.append(stat)
        else:
            stat,dump,dump,dump=self.PolSQL.Execute("COMMIT;",1)
        
            # skoro si udao to prbujemy jeszcze zamkn dowd
            if ZamykacDowod:
                from funkcje import fs_dowody_ksiegowe_pom
                stat2=fs_dowody_ksiegowe_pom.SprawdzDowodKsiegowy(self,DowodId,DowodNazwa,Data,Nr)
                if stat2<>['OK']:
                    wyn2=["Raport wycig zamknito. \n Wystpiy bdy przygotowania dowodu ksigowego do zamknicia: \n"+stat2[0]]
                else:
                    stat2=fs_dowody_ksiegowe_pom.ZamknijDowodKsiegowy(self,DowodId,DowodNazwa,Data,Nr)
                    if stat2<>'OK':
                        wyn2=["Raport wycig zamknito. \n Wystpiy bdy zamykania dowodu ksigowego : \n"+stat2]
    if stat<>'OK':    
        dump,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)
        

        
#-------------------------------------------------------------------------------
# DELETE
#-------------------------------------------------------------------------------

if (Funkcja in [6]) and (stat=='OK'):
    if (self.operator_id == STANDARD_OPERATOR_ID):
        Uprawnienia=True
    else:
        Uprawnienia= UprDel and (Kasa in LDel)

    if not Uprawnienia:
        stat='UPR DEL'
        dane.append(stat)
        
    if stat=='OK':
        Select="SELECT stan FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Select+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
        stat,d,wyn1,wyn2=self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat='BL BLOKADA'
        dane.append(stat)
    elif d[0][0]<> 'W':
        stat='DEL STAN'
        dane.append(stat)

    if stat=="OK":
        Select="SELECT nr_poz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
        Select+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" AND stan_poz<>'W';"
        stat,d,wyn1,wyn2=self.PolSQL.Execute(Select,3)
    if stat=='OK':
        if len(d)>0:
            stat='DEL STANP'
            dane.append(stat)
            
    if stat=="OK":
        #WS 2023-07-27
        SQL = """SELECT z.zaliczka_id, z.stan, rpoz.nr_poz, rpoz.nr_ppoz,
                        z.kwota_brutto-(SELECT COALESCE(SUM(zp.kwota_brutto),0) FROM rs_wf_zaliczki_pozycje zp WHERE rpoz.zaliczka_id=zp.zaliczka_id) AS saldo_zam
                 FROM rs_raporty_wyciagi_pozycje rpoz
                 LEFT OUTER JOIN rs_wf_zaliczki z USING (zaliczka_id)
                 WHERE rpoz.firma_id=%s AND rpoz.okres_id=%s AND rpoz.kasa_bank_id=%s AND rpoz.data=%s AND rpoz.numer=%s;"""
        zmienne = [self.firma_id, self.okres_id, Kasa, Data, Numer]

        rsglobal.ZapiszDoLogow('Zaliczki do zmiany: ' + self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_zaliczki, wyn1_rk, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych pozycji'
        else:
            for ppoz in d_zaliczki:
                if ppoz[0] not in (None, 0):
                    SQL = """UPDATE rs_wf_zaliczki
                             SET rk_o_okres_id=NULL, rk_o_kasa_bank_id=NULL, rk_o_data=NULL, rk_o_numer=NULL, 
                                 rk_o_nr_poz=NULL, rk_o_nr_ppoz=NULL, saldo=0
                             WHERE zaliczka_id=%s AND 
                                   rk_o_okres_id=%s AND rk_o_kasa_bank_id=%s AND rk_o_data=%s AND rk_o_numer=%s AND
                                   rk_o_nr_poz=%s AND rk_o_nr_ppoz=%s;
                             UPDATE rs_wf_zaliczki
                             SET rk_z_okres_id=NULL, rk_z_kasa_bank_id=NULL, rk_z_data=NULL, rk_z_numer=NULL, 
                                 rk_z_nr_poz=NULL, rk_z_nr_ppoz=NULL, saldo=%s, stan='R'
                             WHERE zaliczka_id=%s AND 
                                   rk_z_okres_id=%s AND rk_z_kasa_bank_id=%s AND rk_z_data=%s AND rk_z_numer=%s AND
                                   rk_z_nr_poz=%s AND rk_z_nr_ppoz=%s;"""
                    zmienne = [ppoz[0], self.okres_id, Kasa, Data, Numer, ppoz[2], ppoz[3],
                               ppoz[4], ppoz[0], self.okres_id, Kasa, Data, Numer, ppoz[2], ppoz[3]]

                    rsglobal.ZapiszDoLogow('Usuniecie rk z zaliczki: ' + self.PolSQL.Mogrify(SQL, zmienne))
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
                    if stat != 'OK':
                        rsglobal.ZapiszDoLogow(stat)
                        stat = 'Bd aktualizowania danych zaliczki'
                        dane.append(stat)

        DeletePoz="DELETE FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        DeletePoz+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
        Delete="DELETE FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Delete+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
        stat,dump,dump,dump=self.PolSQL.Execute(DeletePoz+Delete,1)
        if stat<>'OK':
            stat='BL DEL'
            dane.append(stat)


#--------------------------------------------------------------------------------
#-- DODAWANIE SALDA POCZATKOWEGO
#--------------------------------------------------------------------------------

if (Funkcja ==22) and (stat=='OK'):
    DataU= Data
    KasaU=Kasa
    if not rsglobal.SprawdzCzyToData(DataU):
        if Data != '    - -  ':
            stat="BR DAT"
            dane.append(stat)
        else:
            stat="BL DAT"
            dane.append(stat)
            
    if Kasa=='':
        stat="BR KAS"
        dane.append(stat)
    else:
        sql = "SELECT kasa_bank_id FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"'"
        sql+= " AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaU+"' ; "
        stat,dane_k,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bd sprawdzania poprawnoci kasy: '+stat
            dane.append(stat)
        else:
            if len(dane_k)==0:
                stat='Bdny symbol kasy: '+Kasa
                dane.append(stat)
    
    #Sprawdzenie czy to pierwszy wyciag (najwczesniejsza data w danym okresie i kasie)
    if stat=='OK':
        sql="SELECT min(data) FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaU+"' ; "
        stat,dane_d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bd sprawdzania daty: '+stat
        else:
            MinData=dane_d[0][0]
            if MinData!=DataU:
                stat='Wybrany raport nie jest raportem o najwczeniejszej dacie'
                dane.append(stat)
    
    #Sprawdzenie czy saldo pocztkowe=0
    if stat=='OK':
        sql = "SELECT saldo_pocz FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        sql+= " AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaU+"' AND data='"+DataU+"'; "
        stat,dane_d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bd pobrania salda pocztkowego: '+stat
        else:
            SaldoPocz=dane_d[0][0]
            if SaldoPocz!=0:
                stat='Saldo pocztkowe jest rne od 0'
                dane.append(stat)
        
    
    if stat=='OK':
        if (self.operator_id == STANDARD_OPERATOR_ID):
            Uprawnienia=True
        else:
            Uprawnienia= (Kasa in LUpd)
        
    if Uprawnienia:
        Upd="UPDATE rs_raporty_wyciagi SET saldo_pocz=saldo_pocz +"+str(KwotaU)+" ,saldo_konc=saldo_konc+"+str(KwotaU)
        Upd+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaU+"' ;"
        stat,dump,dump,dump=self.PolSQL.Execute(Upd,1)
        if stat<>'OK':
            stat='Bd dodania salda pocztkowego: '+stat
            dane.append(stat)
    else:
        stat='UPR UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
# WSTAWIANIE DAT POTWIERDZEN DO KOREKT Z RAPORTU (13)
#-------------------------------------------------------------------------------

if Funkcja == 13 and stat == 'OK':
    dane = []
    DataWplywu = DataOdF
    DataOdbioru = DataDoF

    sql ="SELECT wyznacznik_id,data_fakt,numer_fakt"
    sql+=" FROM rs_raporty_wyciagi_pozycje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer='"+Numer+"'"
    sql+=" AND typ_fakt='K'"
    sql+=" ORDER BY nr_poz,nr_ppoz;"
    stat,PozKor,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania pozycji korekt z raportu: '+stat

    if stat == 'OK':
        for k in PozKor:
            WyznacznikK = rsglobal.Dekoduj(k[0])
            DataK = rsglobal.Dekoduj(k[1])
            NumerK = rsglobal.Dekoduj(k[2])
            
            # tylko korekty, ktore moga byc potwierdzone takimi datami
            if DataK <= DataWplywu and DataK <= DataOdbioru:
                stat,Opis = fs_korekty_pom.WstawDateWplywuIOdbioru(self.PolSQL,self.firma_id,WyznacznikK,DataK,NumerK,DataWplywu,DataOdbioru,'K')
                if stat != 'OK':
                    dane.append([Opis])
                    break


#-------------------------------------------------------------------------------
# POBIERANIE DANYCH
#-------------------------------------------------------------------------------

if (Funkcja in [5,3,4,6]) and (stat=='OK'):
    Sql="SELECT r.stan,r.kasa_bank_id,r.data,r.numer,r.saldo_pocz,r.wplaty,r.wyplaty,r.saldo_konc,k.waluta,r.kurs,r.kompensata "
    Sql+="FROM rs_raporty_wyciagi r INNER JOIN rs_kasy_banki k ON (r.firma_id=k.firma_id AND r.okres_id=k.okres_id AND r.kasa_bank_id=k.kasa_bank_id) "
    Sql+="WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id='"+self.okres_id+"'"
    if KasaBankF<>'':
        Sql=Sql+" AND r.kasa_bank_id='"+KasaBankF+"'"
    if DataOdF != '    -  -  ':
        Sql=Sql+" AND r.data>='"+DataOdF+"'"
    if DataDoF != '    -  -  ':
        Sql=Sql+" AND r.data<='"+DataDoF+"'"
    if StanF<>'':
        Sql=Sql+" AND r.stan='"+StanF+"'"
    
    #uwzgldnienie tych kas do ktrych operator ma uprawnienia
    if self.operator_id != STANDARD_OPERATOR_ID:
        Sql=Sql+" AND r.kasa_bank_id IN ("+str(LPrz)[1:-1]+")"
        
    Sql=Sql+" ORDER BY r.data desc, r.numer desc ; "
    stat,dane,dump,dump=self.PolSQL.Execute(Sql,3)
    wyn2=[]
    wyn2.append(str(LUpd))

#-------------------------------------------------------------------------------

def dolozDodatkoweDane(dodatkoweDane, nazwa, row, desc):
    nowe = []
    for d, info in zip(row, desc):
        if d == "None":
            d = None
        if info[0] not in ("z_czas", "z_typ", "z_op_id"):
            nowe.append((info[0], d))
    dodatkoweDane.append((nazwa.upper(), nowe))


#-------------------------------------------------------------------------------
# ZAMYKANIE RAPORTU Z POZIOMU KOMSERA
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK" and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    # komser: sprawdzamy czy dane maj by przesyane dalej
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        komserDane = []
        stat, raport, desc, dump = self.PolSQL.Execute("SELECT * FROM rs_raporty_wyciagi"
            " WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND data=%s AND numer=%s", 3,
            (self.firma_id, self.okres_id, Kasa, Data, Numer))
        if stat == "OK":
            stat, pozycje, pdesc, dump = self.PolSQL.Execute("SELECT * FROM rs_raporty_wyciagi_pozycje"
                " WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND data=%s AND numer=%s", 3,
                (self.firma_id, self.okres_id, Kasa, Data, Numer))
            if stat == "OK" and raport:
                dolozDodatkoweDane(komserDane, "RAP_WYC", raport[0], desc)
            for pozycja in pozycje:
                dolozDodatkoweDane(komserDane, "RWYCPOZ", pozycja, pdesc)
            klucze['Funkcja']=12
            stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja", "dodatkowe-dane:", komserDane],
				["fs_komser_raporty_wyciagi", klucze, pola, wartosci])