
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_raporty_wyciagi_klucz.py
# Purpose:     insert/update faktury
#
# Author:      Marcin Grzeda
# Created:     2007/01/19
# RCS-ID:      $Id: fs_raporty_wyciagi_klucz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


#ZMIANY 
# Micha R - blokada by nie pozwala dodawa jak co jest pniej lub jest nie zamknite 2008-03-27
# Micha R - zdjcie blokady 2008-07-01
# Dariusz Boduch - blokada na dodawanie raportu - wyciagu z data zamknietego miesiaca - matis: 2277
# 2021-06-25 Wojciech Skowron - przepisanie pozycji z rs_kasy_banki_pozycje do rs_raporty_wyciagi_pozycje
#                               przy dodawaniu raportu (12539)

Fun=klucze[-1]

stat = "OK"
dane = []


#-------------------------------------------------------------------------------
#--- pobranie numeru w numeracji automatycznej (11)
#-------------------------------------------------------------------------------

if Fun == 11:
    KasaBank=klucze[0]
    Data=klucze[1]
    
    dane=[0]
    
    SQL="SELECT TRIM(COALESCE(sposob_numeracji,'')) FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
    stat,DKasy,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bdy pobierania danych kasy/banku'
    
    if stat == 'OK':
        if len(DKasy)>0:
            from funkcje import fs_raporty_wyciagi_pom
            stat,Nr=fs_raporty_wyciagi_pom.PodajNumerRaportu(self,KasaBank,Data)
            if stat =='OK':
                dane=[Nr]

#-------------------------------------------------------------------------------
#--- sprawdzenie czy to kompensata i czy automatycznie (10)
#-------------------------------------------------------------------------------

if Fun == 10:
    if ((self.oddzial_id,'171000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        KasaBank=klucze[0]
        Sql="SELECT kompensata,TRIM(COALESCE(sposob_numeracji,'')) FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat=='OK':
            if len(d)>0:
                dane=d
            else:
                dane=None
        else:
            stat='BL POB KOMP'
    else:
        stat='UPR PRZ KAS'
            
#-------------------------------------------------------------------------------
#--- Sprawdzenie czy nie ma dziur w numeracji (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    stat='OK'
    dane= []
    KasaBank=klucze[0]
    Data=klucze[1]
    Numer=klucze[2]
    
    # sprawdzenie typu numeracji. Jeli nie ma pewnoci to zakadamy, e dzienna (domylna)
    TypN='D'
    
    SQL="SELECT DISTINCT DATE_PART('day',data) FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND kasa_bank_id='"+KasaBank+"' AND DATE_PART('year',data)='"+Data[0:4]+"' AND DATE_PART('month',data)='"+Data[5:7]+"';"
    rsglobal.ZapiszDoLogow('SQL '+SQL,1)
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        # jeli w danym miesicu jest wicej ni jeden raport
        if len(DTest) > 0:
            # sprawdzamy czy jest tylko jedna jedynka wtedy numerujemy miesicznie
            SQL="SELECT COUNT(*) FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND kasa_bank_id='"+KasaBank+"' AND DATE_PART('year',data)='"+Data[0:4]+"'"
            SQL+=" AND DATE_PART('month',data)='"+Data[5:7]+"' AND numer=1;"
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat == 'OK':
                if DTest[0][0] == 1:
                    TypN='M'
                
    if stat =='OK':
        SQL="SELECT DISTINCT DATE_PART('month',data) FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kasa_bank_id='"+KasaBank+"' AND DATE_PART('year',data)='"+Data[0:4]+"';"
        rsglobal.ZapiszDoLogow('SQL '+SQL,1)
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            # jeli w danym roku jest wicej ni jeden raport miesicznie
            if len(DTest) > 0:
                # sprawdzamy czy jest tylko jedna jedynka wtedy numerujemy rocznie
                SQL="SELECT COUNT(*) FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND kasa_bank_id='"+KasaBank+"' AND DATE_PART('year',data)='"+Data[0:4]+"'"
                SQL+=" AND numer=1;"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat == 'OK':
                    if DTest[0][0] == 1:
                        TypN='R'
        
    # sprawdzamy czy midzy datami nie ma przerwy
    if stat == 'OK':
        SQL="SELECT MAX(data),MAX(data)+1,MAX(data) IS NULL FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kasa_bank_id='"+KasaBank+"';"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            # jeli data nie jest pusta
            if not DTest[0][2]:
                if DTest[0][1]<Data:
                    dane.append('- ostatnia data wystawienia raportu dla wybranej kasy to '+DTest[0][0]+' a wybrana to '+Data)
        
    
    # sprawdzamy czy w numeracji nie ma dziury
    if stat == 'OK':
        # pobieramy ostatni numer
        SQL="SELECT COALESCE(MAX(numer),0) FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kasa_bank_id='"+KasaBank+"'"
        if TypN == 'D':
            SQL+=" AND data='"+Data+"'"
        elif TypN == 'M':
            SQL+=" AND DATE_PART('year',data)='"+Data[0:4]+"' AND DATE_PART('month',data)='"+Data[5:7]+"'"
        elif TypN == 'R':
            SQL+=" AND DATE_PART('year',data)='"+Data[0:4]+"'"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if DTest[0][0]+1 < Numer:
                if DTest[0][0] == 0:
                    dane.append('- oczekiwany dokument o numerze 1 a wybrany to '+str(Numer))
                else:
                    dane.append('- ostatni wykorzystywany numer to '+str(DTest[0][0])+' a wybrany to '+str(Numer))


#-------------------------------------------------------------------------------
#--- Pobranie nowego numeru (1)
#-------------------------------------------------------------------------------

if Fun == 1:
    if ((self.oddzial_id,'172010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        KasaBank=klucze[1]
        Data=klucze[2]
        Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND okres_id=\\\'"+self.okres_id+"\\\' AND kasa_bank_id=\\\'"+KasaBank+"\\\' AND data=\\\'"+Data+"\\\'"
        Select = "SELECT rsf_klucz_where_new('rs_raporty_wyciagi','"+Warunek+"','numer');"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    else:
        stat = 'UPR SEL'   


#-------------------------------------------------------------------------------
#--- INSERT DANYCH(2)     
#-------------------------------------------------------------------------------
        
if Fun == 2 and stat == "OK":
    if not (((self.oddzial_id,'172013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat = 'UPR INS'
    
    if stat=='OK':
        wart = wartosci

        for i in range(len(pola)):
            pole=pola[i]
            wart=wartosci[i]
            if pole == "kasa_bank_id":
                KasaBank = wart
            if pole == "data":
                Data = wart
            if pole == "numer":
                Numer = wart
            if pole == "kompensata":
                Kompensata = wart 

        if KasaBank =='':
            stat = "BR_KAS"
            dane.append(stat)
        
    if stat=='OK':    
        if Data == "    -  -  ":
            stat = "BR_DAT"
            dane.append(stat)
        else:
            if not rsglobal.SprawdzCzyToData(Data):
                stat='BL_DAT'
                dane.append(stat)

    #sprawdzenie czy dodawany dokument nie ma daty w zamknietym miesiacu
    if stat=='OK':
        Rok=Data[:4]
        Mc=Data[5:7]
        FILTR=" firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND rok='"+Rok+"' AND miesiac='"+Mc+"'"
    	stat,DaneZam,wyn1,tr = self.PolSQL.Execute("SELECT zamkniety FROM rs_definicje_okresow_miesiace WHERE "+FILTR+" ;",3) 
    	rsglobal.ZapiszDoLogow(' sds 12121',1)
    	rsglobal.ZapiszDoLogow(stat,1)
    	rsglobal.ZapiszDoLogow(DaneZam,1)
    	if len(DaneZam)>0:
    	    if DaneZam[0][0]:
    	        stat="Nie mona doda raportu / wycigu, rok "+Rok+", miesic "+Mc+" jest zamknity"
    	        dane.append(stat)
    
    #sprawdzenie uprawnie do dodawania wycigu wzgldem kasy/banku
    if self.operator_id <> STANDARD_OPERATOR_ID:
        if stat=='OK':
            SQL="SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
            SQL+=" AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+" AND kasa_bank_id='"+KasaBank+"' AND wprowadzanie;"
            
            stat,Upr,wyn1,tr = self.PolSQL.Execute(SQL,3)        
        
        if stat=='OK':
            if len(Upr)==0:
                stat = "BR UPR KAS"
        
    if stat=='OK':
        sql="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+"','"+Data+"',3);"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK' and d[0][0]<>1:
            stat="BL DATA ZAK"
            dane.append(stat)
                  
    if stat=='OK':
        sql="SELECT rsf_sprawdz_date_z_okresem('"+self.firma_id+"','"+self.okres_id+"','"+Data+"');"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK' and d[0][0]<>1:
            stat="BL DATA OKR"
            dane.append(stat)
    
    if stat=='OK':
        if Numer =='':
            stat = "BR_NUM"
            dane.append(stat)
            
       
    #sprawdzenie czy wszystkie nastpne wycigi s otwarte
    if stat=='OK':
        Select="SELECT data FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        Select+="AND kasa_bank_id='"+KasaBank+"' AND (data>'"+Data+"' OR (data='"+Data+"' AND numer>"+Numer+" )) AND stan = 'Z'" 
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)            
    
    if stat=='OK':
        if len(d)>0:
            stat='DOK POZN'

        
    if stat=='OK':                
        Select="SELECT saldo_konc FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND (data<'"+Data+"' OR (data='"+Data+"' AND numer<"+Numer+")) ORDER BY data desc, numer desc LIMIT 1;" 
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)
    
    if stat=='OK':
        if len(d)==0:
            SaldoKonc=0
        else:
            SaldoKonc=d[0][0]
            
    if stat == 'OK':        
        Insert = "INSERT INTO rs_raporty_wyciagi (firma_id,okres_id,kasa_bank_id,data,numer,kompensata,stan,kurs,saldo_pocz,saldo_konc) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"','"+Data+"',"+Numer+","+str(Kompensata)+",'W',1.0,"+str(SaldoKonc)+","+str(SaldoKonc)+");"
        stat,dump,dump,dump = self.PolSQL.Execute(Insert,1)
        
        if stat<>'OK':
            stat='BL_INS'
            dane.append(stat)

    #WS 2021-06-25
    if stat == 'OK':
        Select="SELECT 1 FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)

        if stat<>'OK':
            stat='BL_SEL_KASY_BANKI'
            dane.append(stat)
        elif len(d) > 0:
            Insert ="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz,stan_poz,typ,symbol_dok,platnik_id,kierowca,konto,tresc)"
            Insert+=" SELECT firma_id,okres_id,kasa_bank_id,'"+Data+"',"+Numer+",nr_poz,0,'W',typ,symbol_dok,platnik_id,kierowca,konto,tresc"
            Insert+=" FROM rs_kasy_banki_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
            stat,dump,dump,dump = self.PolSQL.Execute(Insert,1)

            if stat<>'OK':
                stat='BL_INS_KASY_BANKI'
                dane.append(stat)
        
    if stat == 'OK':        
        Select="SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
        stat,d,dump,dump = self.PolSQL.Execute(Select,3)
    
    if stat == 'OK':        
        if len(d)>0:
            wyn2=d[0][0]
        else:
            wyn2=''
