#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi_pom.py
# Purpose:          funkcje pomocnicze do raportw/wycigw
# Author:           Micha Raburski
# Created:          2014/01/21
# RCS-ID:           $Id: fs_raporty_wyciagi_pom.py $
# Copyright:        (c) 2014 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# FUNKCJA PODAJCA NUMER RAPORTU ZGODNIE Z NUMERACJ W KASIE BANKU
#-------------------------------------------------------------------------------
# 2021-12-14 Aleksander Bargie - (12766) Zmiany w zamykaniu paragonw i faktur
# 2021-12-23 Aleksander Bargie - PolSQL.kurs.mogrify na PolSQL.Polaczenie.cursor().mogrify
# 2022-01-07 Aleksander Bargie - (12805) Tworzenie pozycji raportu kasowego podczas zamykania paragonu - poprawka
#                                 pobierania konta z kasy
# 2022-03-30 Wojciech Skowron   - (12854) Przekazanie oddziau do PodajDomyslnaKase(), zmiana w PodajDomyslnaKase() oraz
#                                 ZapiszDoRaportu()
# 2022-04-20 Wojciech Skowron   - (12855) Osobne pozycje przy zapisie do raportu/wyciagu dla rnych sposob zap.

puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')
def PodajNumerRaportu(self,Kasa,Data):
    # parametry
    # self - obiekt techniczny zawierajcy firm, okres, poczenie do bazy itp.
    # Kasa - sprawdzana Kasa/Bank do raprotu/wycigu
    # Data - dzie na ktry wykonujemy analiz. 
    
    import rsglobal
        
    # pobranie typu numeracji
    SQL="SELECT TRIM(COALESCE(sposob_numeracji,'')) FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
    stat,DKasy,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bdy pobierania danych kasy/banku :'+stat,0
    
    # jeli nie ma kasy to zwracamy 0
    if len(DKasy) == 0:
        return 'OK', 0
    
    # jeli nie ma numeracji to zwracamy 0
    Numeracja = DKasy[0][0]
    if Numeracja == '':
        return 'OK', 0
    
    # jeli jest to pobieramy odpowiednie dane
    if Numeracja == 'D':
        SQL="SELECT COALESCE(MAX(numer),0)+1 FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"';" 
        stat,DNr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bdy pobierania numeru raportu/wycigu :'+stat,0
    
        return "OK",DNr[0][0]
    
    if Numeracja == 'M':
        # sprawdzenie czy nie ma raportw z pniejsz dat w danym miesicu
        SQL="SELECT data FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
        SQL+=" AND SUBSTRING(data::TEXT FROM 1 FOR 7)='"+Data[:7]+"' AND data >'"+Data+"';" 
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bdy pobierania numeru raportu/wycigu :'+stat,0
        if len(DTest)>0:
            return 'Ze wzgldu na wczon automatyczn numeracj nie mona doda raportu/wycigu, poniewa istniej raporty/wycigi z pniejsz dat ',0

        # pobranie numeru dla numeracji miesicznej
        SQL="SELECT COALESCE(MAX(numer),0)+1 FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
        SQL+=" AND data>='"+Data[:7]+"-01' AND data <='"+Data+"';" 
        stat,DNr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bdy pobierania numeru raportu/wycigu :'+stat,0
    
        return "OK",DNr[0][0]
    
    if Numeracja == 'R':
        # sprawdzenie czy nie ma raportw z pniejsz dat w danym roku
        SQL="SELECT data FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
        SQL+=" AND SUBSTRING(data::TEXT FROM 1 FOR 4)='"+Data[:4]+"' AND data >'"+Data+"';" 
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bdy pobierania numeru raportu/wycigu :'+stat,0
        if len(DTest)>0:
            return 'Ze wzgldu na wczon automatyczn numeracj nie mona doda raportu/wycigu, poniewa istniej raporty/wycigi z pniejsz dat ',0

        # pobranie numeru dla numeracji rocznej
        SQL="SELECT COALESCE(MAX(numer),0)+1 FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
        SQL+=" AND data>='"+Data[:4]+"-01-01' AND data <='"+Data+"';" 
        stat,DNr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bdy pobierania numeru raportu/wycigu :'+stat,0
    
        return "OK",DNr[0][0]
    
    
    return "OK",0

#AB 14.12.21r
#WS 2022-03-30 - Oddzial
def PodajDomyslnaKase(self, Okres, Oddzial):
    """Metoda zwraca dane kasy na raport kasowy dla wskazanego okresu ksigowego i oddziau.
    algorytm:

    1. Kasa_id z danych oddziau,
    2. Jeli jest tylko jedna kasa w firmie w danym okresie

    format:
        stat, {kasa_bank_id, konto, dowod_id, nazwa_id}"""
    import rsglobal
    def zwroc_blad(tresc):
        '''skrotowiec bo blad wraca komunikat w stacie i  None. pozwala pilnowac by zawsze wracac odpowiednia ilosc elementow'''
        return tresc, None

    sql = """SELECT kasa_sprzedaz 
             FROM rs_oddzialy 
             WHERE firma_id = %s AND oddzial_id = %s
             ;"""

    rsglobal.ZapiszDoLogow("Pobranie kasy z oddzialu j5y6jhfj456fgh")
    #WS 2022-03-30 - self.oddzial_id -> Oddzial
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, [self.firma_id, str(Oddzial)]))
    stat, kasa_sprzedaz, dump, dump = self.PolSQL.Execute(sql, 3, [self.firma_id, str(Oddzial)], CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        return zwroc_blad(stat)
    else:
        rsglobal.ZapiszDoLogow(kasa_sprzedaz)
        kasa_sprzedaz = '' if kasa_sprzedaz[0][0] in (None, [], 'None') else kasa_sprzedaz[0][0]
        rsglobal.ZapiszDoLogow(kasa_sprzedaz)

    sql2 = """SELECT kasa_bank_id, konto, dowod_id, nazwa_id
             FROM rs_kasy_banki
             WHERE firma_id = %s AND okres_id=%s
             ;"""
    if kasa_sprzedaz:
        sql2 = sql2.replace(';', " ORDER BY kasa_bank_id = '{}' DESC;".format(kasa_sprzedaz))
    rsglobal.ZapiszDoLogow("Pobranie danych kasy/banku jghj5")
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql2, [self.firma_id, str(Okres)]))
    stat, kasy, wyn1, dump = self.PolSQL.Execute(sql2, 3, [self.firma_id, str(Okres)], CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        return zwroc_blad(stat)
    elif len(kasy) < 1:
        return "Nie odnaleziono adnych kas w okresie {}".format(Okres), None
    else:
        kasa = kasy[0]
        if kasa_sprzedaz:
            if kasa_sprzedaz.strip() != kasa[0].strip():
                return "W okresie {} nie odnaleziono kasy {}".format(Okres, kasa_sprzedaz), None
        elif len(kasy) != 1:
            return 'OK', None
        out = {'kasa_bank_id': rsglobal.Dekoduj(kasa[0]), 'konto': rsglobal.Dekoduj(kasa[1]),
               'dowod_id': rsglobal.Dekoduj(kasa[2]), 'nazwa_id': rsglobal.Dekoduj(kasa[3])}
        return stat, out

#AB 14.12.21r
def PodajUtworzRaportKasowy(self, Okres, Kasa, Data):
    """Dla kasy, w dniu i okresie powinien by 1 raport kasowy. Metoda ta zwraca jego klucz. Jeli nie istnieje, tworzy
    nowy, jeli jest wiele, zwraca najwyszy numer. Argumenty:

    Okres
    Kasa
    Data

    format:
        stat, nr_wyciagu, nowa_poz"""
    import rsglobal
    def zwroc_blad(tresc):
        '''skrotowiec bo blad wraca komunikat w stacie i 2x None. pozwala pilnowac by zawsze wracac odpowiednia ilosc elementow'''
        return tresc, None, None

    sql1 = """SELECT stan, numer
              FROM rs_raporty_wyciagi
              WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND data=%s
              ORDER BY numer DESC
              LIMIT 1
              ;"""
    rsglobal.ZapiszDoLogow("Pobranie ostatniego wyciagu asdfasdf2")
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql1, [self.firma_id, Okres, Kasa, Data]))
    stat, raporty, wyn1, dump = self.PolSQL.Execute(sql1, 3, [self.firma_id, Okres, Kasa, Data], CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        return zwroc_blad(stat)

    if len(raporty) == 0:
        Tworzyc = True
        numer = 1
    else:
        if raporty[0][0] == 'W':
            Tworzyc = False
            numer = raporty[0][1]
        else:
            Tworzyc = True
            stat, numer = PodajNumerRaportu(self, Kasa, Data)
            if stat != 'OK':
                return zwroc_blad(stat)
            if str(numer) == '0':
                stat  = "Uwaga! Przyznano 0 jako nowy numer raportu/wycigu dla kasy {} \n"
                stat += "Sprawd czy w kasie jest wpisany sposb numeracji raportw."
                stat = stat.format(Kasa)
                return zwroc_blad(stat)

    if Tworzyc:
        sql2 = """SELECT saldo_konc 
                  FROM rs_raporty_wyciagi 
                  WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s 
                        AND (data<%s OR (data=%s and numer<%s))
                  ORDER BY data desc, numer DESC 
                  LIMIT 1
                  ;"""
        rsglobal.ZapiszDoLogow("Pobranie salda koncowego vsdfcv234")
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql2, [self.firma_id, Okres, Kasa, Data, Data, numer]))
        stat, Saldo, dump, dump = self.PolSQL.Execute(sql2, 3, [self.firma_id, Okres, Kasa, Data, Data, numer], CzyDodawacBlad=True)

        if stat == 'OK':
            if len(Saldo) == 1:
                Saldo = Saldo[0][0]
            else:
                Saldo = 0
            sql3 = """INSERT INTO rs_raporty_wyciagi 
                            (firma_id, okres_id, kasa_bank_id, data, numer, stan, saldo_pocz, saldo_konc)
                      VALUES(%s,       %s,       %s,           %s,   %s,    'W',  %s,         %s        )
                      ;"""
            rsglobal.ZapiszDoLogow("Dodanie naglowka raportu/wyciagu g4tvb2")
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql3, [self.firma_id, Okres, Kasa, Data, numer, Saldo, Saldo]))
            stat, dump, dump, dump = self.PolSQL.Execute(sql3, 1, [self.firma_id, Okres, Kasa, Data, numer, Saldo, Saldo], CzyDodawacBlad=True)
            if stat != 'OK':
                return zwroc_blad(stat)
        else:
            return zwroc_blad(stat)
        nr_poz = 1
    else:
        sql4 = """SELECT MAX(nr_poz) 
                   FROM rs_raporty_wyciagi_pozycje
                   WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND data=%s AND numer=%s
                   ;"""
        rsglobal.ZapiszDoLogow("Pobranie nr. poz z raportu/wyciagu bh357")
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql4, [self.firma_id, Okres, Kasa, Data, numer]))
        stat, DaneWBP, dump, dump = self.PolSQL.Execute(sql4, 3, [self.firma_id, Okres, Kasa, Data, numer], CzyDodawacBlad=True)
        if stat == 'OK':
            if len(DaneWBP) > 0 and DaneWBP[0][0] not in [0, None]:
                nr_poz = DaneWBP[0][0]+1
            else:
                nr_poz = 1
        else:
            return zwroc_blad(stat)

    return stat, str(numer), str(nr_poz)


#AB 14.12.21r
def ZapiszDoRaportu(self, Data, Typ, Dane):
    """Metoda dopisuje do raportu kasowego pozycje w oparciu o zmienn dane. Raport jest wybierany z/dodawany do kasy
     1. z danych oddziau lub 2. jedynej kasy w firmie(w przeciwnym razie nic si nei dodaje i wraca 'OK')

     Argumenty:
    Data
    Typ
    Dane

    zwraca stat"""
    from funkcje import fs_okresy_pom
    import rsglobal

    stat, Okres = fs_okresy_pom.PodajOkresDlaDaty(self, Data)
    if stat != 'OK':
        return stat

    #WS 2022-03-30
    stat, dane_kasy = PodajDomyslnaKase(self, Okres, Dane['oddzial_id'])
    # stat, dane_kasy = PodajDomyslnaKase(self, Okres)
    if stat == 'OK':
        if dane_kasy is None:
            rsglobal.ZapiszDoLogow("Nie znaleziono kasy, nie bedzie raportu")
            return 'OK'
        else:
            rsglobal.ZapiszDoLogow('Uzupelnianie danych kasyq')
            rsglobal.ZapiszDoLogow(dane_kasy)
            KasaRaport = dane_kasy['kasa_bank_id']
            DowodKB  = dane_kasy['dowod_id']
    else:
        return stat

    stat, NrWyc, NrPozWyc = PodajUtworzRaportKasowy(self, Okres, KasaRaport, Data)
    if stat != 'OK':
        return stat

    if Typ == 'FA':
        Platnik = Dane['platnik_id']
        Wyzn    = Dane['wyznacznik_id']
        Numer   = Dane['numer']
        Kwota   = Dane['kwota']
        INSWyc = """INSERT INTO rs_raporty_wyciagi_pozycje 
                          (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz, 
                            stan_poz,typ, platnik_id, typ_fakt, wyznacznik_id, data_fakt, numer_fakt, kwota)
                    VALUES(%s,         %s,      %s,        %s,   %s,   %s,     0,
                               'W',  'P',      %s,        'F',         %s,         %s,         %s,       %s)
                    ;"""

        rsglobal.ZapiszDoLogow("INSWyc153f")
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSWyc, [self.firma_id, Okres, KasaRaport, Data, NrWyc, NrPozWyc,
                                                                 Platnik, Wyzn, Data, Numer, Kwota]))
        stat, dump, dump, dump = self.PolSQL.Execute(INSWyc, 1, [self.firma_id, Okres, KasaRaport, Data, NrWyc, NrPozWyc,
                                                                 Platnik, Wyzn, Data, Numer, Kwota], CzyDodawacBlad=True)
        if stat != 'OK':
            return stat
    elif Typ == 'PA':
        Oddzial = Dane['oddzial_id']
        Numer   = Dane['numer']
        KasaPar = Dane['kasa_id']

        SelPar = """SELECT do_zaplaty
                    FROM rs_paragony_fiskalne
                    WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s
                    ;"""

        rsglobal.ZapiszDoLogow("SelPar153f")
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SelPar, [self.firma_id, Oddzial, KasaPar, Data, Numer]))
        stat, DanePar, dump, dump = self.PolSQL.Execute(SelPar, 3, [self.firma_id, Oddzial, KasaPar, Data, Numer], CzyDodawacBlad=True)
        if stat != 'OK':
            return stat
        Kwota = DanePar[0][0]
        if Kwota in (0, '0', 0.0):
            self.PolSQL.Rollback()
            return 'OK'

        SelKasy = """SELECT konto
                     FROM rs_kasy_fiskalne
                     WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s
                     ;"""
        rsglobal.ZapiszDoLogow("SelKasy153f")
        #AB 07.01.22r zmiana KasaRaport na KasaPar
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SelKasy, [self.firma_id, Oddzial, KasaPar]))
        stat, DaneKasy, dump, dump = self.PolSQL.Execute(SelKasy, 3, [self.firma_id, Oddzial, KasaPar], CzyDodawacBlad=True)
        if stat != 'OK':
            return stat
        if len(DaneKasy)>0:
            KontoKasy = rsglobal.Dekoduj(DaneKasy[0][0])
            if KontoKasy in puste:
                KontoKasy = None
        else:
            #AB 07.01.22r
            # KontoKasy = ''
            return "Nie odnaleziono kasy {} w oddziale {}. Poinformuj administratora.".format(KasaPar, Oddzial)

        #WS 2022-04-20 - pobranie sposobw zapaty i utworzenie dla kadego z nich osobnej pozycji
        SelPlat = """SELECT plat.sposob_zaplaty, kwota, lp
                     FROM rs_paragony_fiskalne_platnosci plat
                     LEFT OUTER JOIN rs_kasy_banki_sposoby_zaplaty sz ON (sz.firma_id=plat.firma_id AND sz.sposob_zaplaty=plat.sposob_zaplaty AND sz.okres_id=%s AND kasa_bank_id=%s)
                     WHERE plat.firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s AND kwota > 0
                     UNION 
                     SELECT sposob_zaplaty, %s AS kwota, lp
                     FROM rs_kasy_banki_sposoby_zaplaty
                     WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s AND lp=1 AND NOT EXISTS (SELECT 1 FROM rs_paragony_fiskalne_platnosci
                     WHERE firma_id=%s AND oddzial_id=%s AND kasa_id=%s AND data=%s AND numer=%s AND kwota > 0)
                     ORDER BY lp NULLS LAST;"""
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SelPlat, [Okres, KasaRaport,
                                                             self.firma_id, Oddzial, KasaPar, Data, Numer,
                                                             Kwota,
                                                             self.firma_id, Okres, KasaRaport,
                                                             self.firma_id, Oddzial, KasaPar, Data, Numer]))
        stat, DaneParPlat, dump, dump = self.PolSQL.Execute(SelPlat, 3, [Okres, KasaRaport,
                                                                         self.firma_id, Oddzial, KasaPar, Data, Numer,
                                                                         Kwota,
                                                                         self.firma_id, Okres, KasaRaport,
                                                                         self.firma_id, Oddzial, KasaPar, Data, Numer], CzyDodawacBlad=True)
        if stat != 'OK':
            return stat
        elif len(DaneParPlat) > 0:
            for i, wiersz in enumerate(DaneParPlat):
                NrPoz = int(float(NrPozWyc))+i
                SposobZaplaty = rsglobal.Dekoduj(wiersz[0])
                Kwota = wiersz[1]

                Tresc = 'Paragon {Oddzial}/{KasaPar}/{Data}/{Numer:.0f}'.format(**locals())
                INSPoz = """INSERT INTO rs_raporty_wyciagi_pozycje 
                                  (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz, 
                                   stan_poz,typ, konto, kwota, tresc, sposob_zaplaty)
                            VALUES(%s,         %s,      %s,        %s,   %s,   %s,   0,
                                       'W',  'P',   %s,    %s,    %s,       %s)
                            ;"""

                rsglobal.ZapiszDoLogow("INSPoz153f")
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSPoz, [self.firma_id, Okres, KasaRaport, Data, NrWyc, NrPoz,
                                                                    KontoKasy, Kwota, Tresc, SposobZaplaty]))
                stat, dump, dump, dump = self.PolSQL.Execute(INSPoz, 1, [self.firma_id, Okres, KasaRaport, Data, NrWyc, NrPoz,
                                                                         KontoKasy, Kwota, Tresc, SposobZaplaty], CzyDodawacBlad=True)
                if stat != 'OK':
                    return stat
        else:
            Tresc = 'Paragon {Oddzial}/{KasaPar}/{Data}/{Numer:.0f}'.format(**locals())
            INSPoz = """INSERT INTO rs_raporty_wyciagi_pozycje 
                              (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz, 
                                stan_poz,typ, konto, kwota, tresc)
                        VALUES(%s,         %s,      %s,        %s,   %s,   %s,    0,
                                   'W',  'P',   %s,    %s,    %s)
                        ;"""

            rsglobal.ZapiszDoLogow("INSPoz153f")
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSPoz, [self.firma_id, Okres, KasaRaport, Data, NrWyc, NrPozWyc,
                                                                KontoKasy, Kwota, Tresc]))
            stat, dump, dump, dump = self.PolSQL.Execute(INSPoz, 1,
                                                         [self.firma_id, Okres, KasaRaport, Data, NrWyc, NrPozWyc,
                                                          KontoKasy, Kwota, Tresc], CzyDodawacBlad=True)
            if stat != 'OK':
                return stat

    else:
        return 'Nieobsugiwany typ dokumentu ({}) do zapisania w raporcie kasowym.'.format(Typ)

    return stat
