#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi_pozycje.py
# Purpose:          dodaje/pobiera/usuwa faktury
# Author:           Piotr Witkowski
# Created:          2016/03/10
# RCS-ID:           $Id: fs_raporty_wyciagi_pozycje.py $
# Copyright:        Record System(c) 2016
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

# 2007-02-12 Marcin Grzeda    ()      funkcja fs_raporty_wyciagi_pozycje
# 2016-03-10 Piotr Witkowski  (9614)  Refaktoryzacja Raportw Wycigw i Raportw pozycji
# 2021-06-26 Wojciech Skowron (12539) Funkcja 12 - Sprawdzenie, czy s definicje pozycji dla kasy/banku
# 2023-07-27 Wojciech Skowron (13467) Usunicie klucza raportu z zaliczki przy usuwaniu

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'KasaBank':[5,6,7,10,11,12],'Data':[5,6,7,10],'Numer':[5,6,7,10],
           'NrPoz':[6,7],'NrPPoz':[6,7],
           'SymbolF':[5,6,7],'PlatnikF':[5,6,7],'KontoF':[5,6,7],'KierowcaF':[5,6,7]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_raporty_wyciagi_pozycje z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [5,6,7,10,11,12]:
            KasaBank = str(klucze['KasaBank'])
        if Funkcja in [5,6,7,10]:
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [6,7]:
            NrPoz = klucze['NrPoz']
            NrPPoz = klucze['NrPPoz']
        if Funkcja in [5,6,7]:
            SymbolF = klucze['SymbolF']
            PlatnikF = klucze['PlatnikF']
            KontoF = klucze['KontoF']
            KierowcaF = klucze['KierowcaF']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = ['    -  -  ','',[]]

if self.okres_id=='':
    stat='BR_OKR'
    dane.append(stat)
if KasaBank=='':
    stat='BR_KAS'
    dane.append(stat)
    
UprPrz=(self.oddzial_id,'172020') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel=(self.oddzial_id,'172024') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprDod=(self.oddzial_id,'172023') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)

    
#-------------------------------------------------------------------------------
#sprawdzenie czy mona dodawa w wybranej kasie/banku (11)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==11:
    if self.operator_id != STANDARD_OPERATOR_ID:
        if UprDod:
            sql = "SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            sql+=" AND kasa_bank_id='"+KasaBank+"' AND (wprowadzanie OR edycja) AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
            stat,uprd,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                UprDod= UprDod and len(uprd)>0
            
    dane=[[str(UprDod)]]

#-------------------------------------------------------------------------------
#sprawdzenie kolejnych parametrw
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja not in (11,12):
    if not rsglobal.SprawdzCzyToData(Data):
        stat='BL_DAT'
        dane.append(stat)
    if Numer=='':
        stat='BR_NR'
        dane.append(stat)

if stat=='OK' and Funkcja in [6,7]:
    if NrPoz=='':
        stat='BR_NR_POZ'
        dane.append(stat)
    if NrPPoz=='':
        stat='BR_NR_PPOZ'
        dane.append(stat)
    #sprawdzenie czy raport jest w stanie W
    if stat=='OK':
        sql="SELECT stan FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,DaneTest,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DaneTest)==0:
            stat="BR RAP"
        elif DaneTest[0][0] != 'W':
            stat="ZAM RAP"

#-------------------------------------------------------------------------------
#--- kopiowanie pozycji/podpozycji (7)
#-------------------------------------------------------------------------------

#jeli nr_ppoz=0 to kopiujemy ca pozycj z podpozycjami. Jeli jest != 0 to tylko podpozycj w ramach pozycji

if (Funkcja ==7) and (stat=='OK'):
    #--- sprawdzenie czy pozycja kopiowana istnieje
    FiltrRap= "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    FiltrRap+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
    
    sql="SELECT * FROM rs_raporty_wyciagi_pozycje WHERE "+FiltrRap
    sql+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+";"
    stat,DaneTest,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DaneTest)==0:
            stat="BR POZ K"

    if stat=='OK':
        Ile='5000'
        if NrPPoz<>'0.0':
            sql="UPDATE rs_raporty_wyciagi_pozycje SET nr_ppoz=nr_ppoz+"+Ile+" WHERE "+FiltrRap
            sql+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz>"+str(NrPPoz)+";"

            sql+="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,"
            sql+="nr_ppoz,stan_poz,typ,symbol_dok,platnik_id,kierowca,typ_fakt,wyznacznik_id,data_fakt,numer_fakt,"
            sql+="konto,kurs,kwota,tresc,platnosc_id)"
            sql+=" SELECT firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,"
            sql+="nr_ppoz+1,'W',typ,symbol_dok,platnik_id,kierowca,typ_fakt,wyznacznik_id,data_fakt,numer_fakt,"
            sql+="konto,kurs,kwota,tresc,platnosc_id FROM rs_raporty_wyciagi_pozycje WHERE "+FiltrRap
            sql+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+";"
            
            sql+="UPDATE rs_raporty_wyciagi_pozycje SET nr_ppoz=nr_ppoz-("+Ile+"-1) WHERE "+FiltrRap
            sql+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz>"+Ile+";"
        else:
            sql="UPDATE rs_raporty_wyciagi_pozycje SET nr_poz=nr_poz+"+Ile+" WHERE "+FiltrRap
            sql+=" AND nr_poz>"+str(NrPoz)+";"
            
            sql+="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,"
            sql+="nr_ppoz,stan_poz,typ,symbol_dok,platnik_id,kierowca,typ_fakt,wyznacznik_id,data_fakt,numer_fakt,"
            sql+="konto,kurs,kwota,tresc,platnosc_id)"
            sql+=" SELECT firma_id,okres_id,kasa_bank_id,data,numer,nr_poz+1,"
            sql+="nr_ppoz,'W',typ,symbol_dok,platnik_id,kierowca,typ_fakt,wyznacznik_id,data_fakt,numer_fakt,"
            sql+="konto,kurs,kwota,tresc,platnosc_id FROM rs_raporty_wyciagi_pozycje WHERE "+FiltrRap
            sql+=" AND nr_poz="+str(NrPoz)+";"
            
            sql+="UPDATE rs_raporty_wyciagi_pozycje SET nr_poz=nr_poz-("+Ile+"-1) WHERE "+FiltrRap
            sql+=" AND nr_poz>"+Ile+";"
        
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            
#-------------------------------------------------------------------------------
#--- usuwanie pozycji (6)
#-------------------------------------------------------------------------------

if (Funkcja ==6) and (stat=='OK'):
    if not UprDel:
        stat='BR_UPR_DEL'
        dane.append(stat)
        
    #sprawdzenie czy mona usuwa w wybranej kasie/banku
    if stat=='OK' and self.operator_id != STANDARD_OPERATOR_ID:
        sql = "SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND usuwanie AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
        stat,upru,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(upru)==0:
                stat='BR_UPR_DEL_KASA'
                dane.append(stat)

    if stat == 'OK':
        #WS 2023-07-27
        SQL = """SELECT z.zaliczka_id, z.stan, rpoz.nr_ppoz,
                        z.kwota_brutto-(SELECT COALESCE(SUM(zp.kwota_brutto),0) FROM rs_wf_zaliczki_pozycje zp WHERE rpoz.zaliczka_id=zp.zaliczka_id) AS saldo_zam
                 FROM rs_raporty_wyciagi_pozycje rpoz
                 LEFT OUTER JOIN rs_wf_zaliczki z USING (zaliczka_id)
                 WHERE rpoz.firma_id=%s AND rpoz.okres_id=%s AND rpoz.kasa_bank_id=%s AND rpoz.data=%s AND rpoz.numer=%s AND rpoz.nr_poz=%s"""
        zmienne = [self.firma_id, self.okres_id, KasaBank, Data, Numer, NrPoz]
        if NrPPoz != '0.0':
            SQL += " AND nr_ppoz=%s"
            zmienne.append(NrPPoz)
        SQL += "; "

        rsglobal.ZapiszDoLogow('Zaliczki do zmiany: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_zaliczki, wyn1_rk, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych pozycji'
        else:
            for ppoz in d_zaliczki:
                if ppoz[0] not in (None, 0):
                    SQL = """UPDATE rs_wf_zaliczki
                             SET rk_o_okres_id=NULL, rk_o_kasa_bank_id=NULL, rk_o_data=NULL, rk_o_numer=NULL, 
                                 rk_o_nr_poz=NULL, rk_o_nr_ppoz=NULL, saldo=0
                             WHERE zaliczka_id=%s AND 
                                   rk_o_okres_id=%s AND rk_o_kasa_bank_id=%s AND rk_o_data=%s AND rk_o_numer=%s AND
                                   rk_o_nr_poz=%s AND rk_o_nr_ppoz=%s;
                             UPDATE rs_wf_zaliczki
                             SET rk_z_okres_id=NULL, rk_z_kasa_bank_id=NULL, rk_z_data=NULL, rk_z_numer=NULL, 
                                 rk_z_nr_poz=NULL, rk_z_nr_ppoz=NULL, saldo=%s, stan='R'
                             WHERE zaliczka_id=%s AND 
                                   rk_z_okres_id=%s AND rk_z_kasa_bank_id=%s AND rk_z_data=%s AND rk_z_numer=%s AND
                                   rk_z_nr_poz=%s AND rk_z_nr_ppoz=%s;"""
                    zmienne = [ppoz[0], self.okres_id, KasaBank, Data, Numer, NrPoz, ppoz[2],
                               ppoz[3], ppoz[0], self.okres_id, KasaBank, Data, Numer, NrPoz, ppoz[2]]

                    rsglobal.ZapiszDoLogow('Usuniecie rk z zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
                    if stat != 'OK':
                        rsglobal.ZapiszDoLogow(stat)
                        stat = 'Bd aktualizowania danych zaliczki'
                        dane.append(stat)
        
    if stat=='OK':
        #przesuniecie pozycji/podpozycji o 1000 w d
        if NrPPoz<>'0.0':
            #podpozycja
            Delete="UPDATE rs_raporty_wyciagi_pozycje SET nr_ppoz=nr_ppoz+1000 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Delete+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz
            Delete+=" AND nr_ppoz>"+NrPPoz+";"    
        else:
            #pozycja
            Delete="UPDATE rs_raporty_wyciagi_pozycje SET nr_poz=nr_poz+1000 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Delete+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz>"+NrPoz+";"

        Delete+="DELETE FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        Delete+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz
        if NrPPoz<>'0.0':
            Delete+=" AND nr_ppoz="+NrPPoz
        Delete+="; "
        #przesuniecie pozycji/podpozycji o 1001 w gr
        if NrPPoz<>'0.0':
            #podpozycja
            Delete+="UPDATE rs_raporty_wyciagi_pozycje SET nr_ppoz=nr_ppoz-1001 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Delete+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz
            Delete+=" AND nr_ppoz>"+NrPPoz+";"    
        else:
            #pozycja
            Delete+="UPDATE rs_raporty_wyciagi_pozycje SET nr_poz=nr_poz-1001 WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Delete+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz>"+NrPoz+";"

        stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
        if stat<>'OK':
            stat='BL_DEL'
            dane.append(stat)


#-------------------------------------------------------------------------------
# SPRAWDZENIE, CZY NIE MA ZEROWEJ POZYCJI
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja not in (11,12) and not Data in [None,'None','','    -  -  '] and Numer<>'0':
    NrZmieniony=0
    # dodatkowy test na poprawno klucza
    if rsglobal.SprawdzCzyToData(Data):
        #rsglobal.ZapiszDoLogow('TEST ZMIANY POZYCJI ZERO W POZYCJE '+str(klucze),1)
        SQL="SELECT min(nr_poz),max(nr_poz) FROM rs_raporty_wyciagi_pozycje "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer+";"
        
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTest)>0:
                if DTest[0][0]==0:
                    rsglobal.ZapiszDoLogow('ZMIANA POZYCJI ZERO W POZYCJE '+str(klucze),1)
                    SQL="UPDATE rs_raporty_wyciagi_pozycje SET nr_poz="+str(DTest[0][1]+1)
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
                    SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer
                    SQL+=" AND nr_poz=0;"
                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    if stat=='OK':
                        NrZmieniony=DTest[0][1]+1
                        NrPoz=str(DTest[0][1]+1)
                

#-------------------------------------------------------------------------------
#-------------Pobieranie Pozycji (5,6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6,7]:
    if not UprPrz:
        stat='BR_UPR_PRZ'
        dane.append(stat)
    if stat=='OK':
        #przed zmian - zmieniony sposb pobierania numeru faktury - 2008-03-27 D. Boduch
        #Sql="SELECT stan_poz,typ,nr_poz,nr_ppoz,kwota,platnik_id,kierowca,konto,typ_fakt || ' - ' || wyznacznik_id || '/' || data_fakt || '/' || numer_fakt, tresc, symbol_dok FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer
        #po zmianie
        Sql="SELECT stan_poz,typ,nr_poz,nr_ppoz,kwota,platnik_id,kierowca,konto,CASE WHEN wyznacznik_id IS NOT NULL AND data_fakt IS NOT NULL THEN typ_fakt || ' - ' || rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||wyznacznik_id||'\",\"'||data_fakt||'\",\"'|| numer_fakt||'\"]',typ_fakt) END, tresc, symbol_dok FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+Numer        
        if SymbolF<>'':
            Sql=Sql+" AND symbol_dok='"+SymbolF+"'"
        if PlatnikF<>'':
            Sql=Sql+" AND platnik_id='"+PlatnikF+"'"
        if KontoF<>'':
            Sql=Sql+" AND konto='"+KontoF+"'"
        if KierowcaF<>'':
            Sql=Sql+" AND kierowca='"+KierowcaF+"'"
        Sql=Sql+" ORDER BY nr_poz, nr_ppoz;"
        
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL_PRZ'
            dane.append(stat)

#-------------------------------------------------------------------------------
#--- Sprawdzenie, czy s definicje pozycji dla kasy/banku (10)
#-------------------------------------------------------------------------------

#WS 2021-06-26
if stat == 'OK' and Funkcja == 12:
    SQL = "SELECT 1 FROM rs_kasy_banki_pozycje"
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat='BL_SEL_KASY_BANKI'
        dane.append(stat)
    elif len(d) > 0:
        dane = [True]
    else:
        dane = [False]
