#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi_pozycje_dane.py
# Purpose:          dodaje/pobiera/usuwa raporty/wycigi
# Author:           Micha Raburski,Marcin Grzeda
# Created:          2007/02/15
# RCS-ID:           $Id: fs_raporty_wyciagi_pozycje_dane.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-24 Mariusz Rajfura    - nowy typ dokumentu 'N' - niezidentyfikowany (4528)
# 2011-05-20 Mariusz Rajfura    - zapis pozycji/podpozycji pobranych z zaleglosci (4583)
# 2011-05-26 Mariusz Rajfura    - usuniecie wpisywania kontrahenta dla podpozycji z zaleglosci (4626)
# 2011-09-09 Mariusz Rajfura    - popr.zapisu dla wartosci==None w Fun==16 (4999)
# 2012-01-05 Mariusz Rajfura    - dodawanie podpozycji do pozycji ze zmiana pozycji w podpoz (4642)
# 2021-06-26 Wojciech Skowron   - moliwe wprowadzanie tylko kwot jeli pozycje utworzone z definicji w kasy/banki (12539)
# 2021-10-14 Aleksander Bargie - Raporty wycigi, pozycje utworzone z definicji, zerowanie, sprawdzenie 'zgrania typu'  (12671)
# 2022-04-06 Wojciech Skowron   - sposb zapaty na pozycji raportu kasowego (12853)
# 2022-04-26 Aleksander Bargie - raport kasowy pozycje - blad insert (12992)
# 2023-07-20 Wojciech Skowron   - Nowe pole 'zaliczka_id' w pozycjach raportu/wyciagu (13441)
# 2023-07-25 Wojciech Skowron   - Pobranie danych zaliczki (13467)
# 2023-09-04 Wojciech Skowron   - Przy zamykaniu, zmiana stanu zaliczki na 'Z' i wyzerowanie salda
# 2024-02-27 Aleksander Bargie - Raport kasowy - wpata na d.d. - zablokowa moliwo wprowadzenia razy tego samego
#                                 numeru d.d. (13706)


KasaBank=rsglobal.Dekoduj(klucze[0])
Data=klucze[1]
Numer=klucze[2]
NrPoz=klucze[3]
NrPpoz=klucze[4]
Fun=klucze[-1]
stat='OK'
dane=[]
puste_pola = ['    -  -  ','',[],'None']
CzyPodpozycja=(Fun==20)
Symbol=''
Tresc=''
DozwolonePola = []  #WS 2021-06-26
RKZal = TypZal = KontrahentZal = KontoZal = TrescZal = ''  #WS 2023-07-25
KwotaZal = SaldoPoprzZal = 0  #WS 2023-07-25
Zaliczka = ZaliczkaPoprz = None  #WS 2023-07-25

#Lista funkcji:
#1,2 - INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#3,4 - Update danych
#10 - pobranie numeru pozycji
#11 - pobranie numeru podpozycji
#12 - pobranie danych 1 zalegoci
#13 - policzenie propozycji kwoty przy zliczeniu
#14 - zapis zliczenia na pozycj
#15 - sprawdzenie czy kasa jest tylko w oddziale
#16 - pobranie wielu zalegoci
#17 - pobranie danych dostawy
#18 - pobranie danych 1 patnoci
#19 - pobranie danych wielu patnoci
#20 - wstawienie sumy podpozycji w pozycj po kopiowaniu podpozycji
#21 - pobranie danych zaliczki
#22 - wpisanie klucza raportu do zaliczki i zmiana jej stanu

#-------------------------------------------------------------------------------
#sprawdzenie uprawnien
#-------------------------------------------------------------------------------

UprUpd= ((self.oddzial_id,'172022') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprIns= ((self.oddzial_id,'172023') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

if UprUpd and (self.operator_id != STANDARD_OPERATOR_ID):
    sql = "SELECT kasa_bank_id FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    sql+=" AND kasa_bank_id='"+KasaBank+"' AND (wprowadzanie OR edycja) AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
    stat,uprd,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        UprUpd= len(uprd)>0
        UprIns= UprIns and len(uprd)>0

#-------------------------------------------------------------------------------
#sprawdzenie, czy s definicje pozycji dla kasy/banku
#-------------------------------------------------------------------------------

if stat == 'OK':
    stat,d,dump,dump=self.WykonajFunkcje('fs_raporty_wyciagi_pozycje',{'Funkcja': 12, 'KasaBank': KasaBank},[],[],False)
    if stat == 'OK':
        if d[0]:
            # jeli pozycje utworzone s z definicji to moliwa jest jedynie edycja kwot
            if Fun not in [3,4,5,10,11]:
                stat = 'BLOK_DEF_POZ'
            else:
                DozwolonePola = ['kwota']

#-------------------------------------------------------------------------------
#pobranie danych dostawy (17)
#-------------------------------------------------------------------------------

if Fun==17 and stat=='OK':
    Trasa=klucze[0]
    Data=klucze[1]
    Tryb=klucze[2]
    Numer=klucze[3]
    dane=[]
    sql = "SELECT kontrahent_id,kierowca,platnik_id FROM rs_dowody_dostaw WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(dane)>0:
            Platnik=rsglobal.Dekoduj(dane[0][2])
            Kontrahent=rsglobal.Dekoduj(dane[0][0])
            Kierowca=rsglobal.Dekoduj(dane[0][1])
            sql = "SELECT SUM(cena_brutto1*ilosc_dost1) FROM rs_dowody_dostaw_pozycje WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
            stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='BL SQL KWOT DOST'
            else:
                dane[0]=dane[0]+[Platnik,Kierowca,Kontrahent]
        else:
            stat='BL KLUCZ DOST'
    else:
        stat='BL SQL DOST'


#-------------------------------------------------------------------------------
#sprawdzenie przychodzcych parametrw
#-------------------------------------------------------------------------------

if Fun not in [17,] and stat=='OK':
    #tylko to jest sprawdzane dla 15
    if KasaBank=='':
        stat='BR KAS'
        dane.append(stat)

    if Fun != 15:
        if not rsglobal.SprawdzCzyToData(Data):
            stat='BL DAT'
            dane.append(stat)
        if Numer=='':
            stat='BR NR'
            dane.append(stat)


    if Fun in [11,]:
        if NrPoz=='':
            stat='BR_NR_POZ'
            dane.append(stat)


#-------------------------------------------------------------------------------
#sprawdzenie czy kasa jest tylko w oddziale (15)
#-------------------------------------------------------------------------------

if Fun==15 and stat=='OK':
    dane=[]
    sql = "SELECT tylko_oddzial FROM rs_kasy_banki WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)


#-------------------------------------------------------------------------------
#pobranie kolejnego numeru pozycji do dodania (10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat=='OK':
    sql = "SELECT nr_poz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" ORDER BY nr_poz DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat=='OK':
        if len(dane)==0:
            dane = 1
        else:
            dane = int(dane[0][0]) + 1


#-------------------------------------------------------------------------------
#pobranie kolejnego numeru podpozycji do dodania (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat=='OK': # warunek
    dane=[]
    sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+NrPoz+" ORDER BY nr_ppoz DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat=='OK':
        if len(dane)==0:
            dane = 1
        else:
            dane = int(dane[0][0]) + 1

#-------------------------------------------------------------------------------
# zliczenie sumy podpozycji przy zliczaniu (13)
#-------------------------------------------------------------------------------

if Fun == 13 and stat=='OK':
    sql = "SELECT SUM(CASE WHEN typ='P' THEN kwota ELSE -kwota END),SUM(nr_ppoz) "
    sql+=" FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz!=0"
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)


#-------------------------------------------------------------------------------
# zapis zliczenia na pozycj (14)
#-------------------------------------------------------------------------------

if Fun == 14 and stat=='OK':
    Kwota=klucze[5]
    if UprUpd:
        sql = "SELECT * FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(d)>0:
                sql="UPDATE rs_raporty_wyciagi_pozycje SET kwota=CASE WHEN typ='W' THEN -"+str(Kwota)+" ELSE "+str(Kwota)+" END "
                sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
                sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0"
                stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            else:
                stat='BR POZ SUM'
    else:
        stat='UPR UPD'


#-------------------------------------------------------------------------------
# pobranie danych pojedyczej zalegoci na pozycj (12)
#-------------------------------------------------------------------------------

if Fun == 12 and stat=='OK':
    NrZalegl=klucze[3]
    dane=['','','',0,'','',0,False]
    sql = "SELECT typ_dok,wyznacznik_id,data,numer,platnik_id,kierowca,do_zaplaty_wal,do_zaplaty,waluta"
    sql+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZalegl)+";"
    stat,DaneZal,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DaneZal)>0:
            #jeli waluta zalegoci - PLN to w razie czego uzupeniamy kwot walutow
            if DaneZal[0][8]=='PLN':
                if rsglobal.Dekoduj(DaneZal[0][6])=='None' or DaneZal[0][6]==0:
                    DaneZal[0][6]=DaneZal[0][7]

            #sprawdzenie waluty kasy/banku i zalegoci
            sql = "SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
            stat,DaneKasa,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                if len(DaneKasa)>0:
                    #jeli zgodne waluty
                    dane[7]=(DaneZal[0][8]==DaneKasa[0][0])

                    #lub niezgodne waluty, ale kasa jest w PLN
                    if (not dane[7]) and DaneKasa[0][0]=='PLN':
                        DaneZal[0][6]=DaneZal[0][7]
                        dane[7]=True

                #waluta jest zastpowana informacj, czy waluty s zgodne
                dane=DaneZal[0][0:7]+[dane[7]]

#-------------------------------------------------------------------------------
# pobranie danych wielu zalegoci na pozycje (16)
#-------------------------------------------------------------------------------

if Fun == 16 and stat=='OK':
    #Numery zalegoci, symbol i tre na pozycje
    Numery=klucze[4][0]
    Symbol=rsglobal.Dekoduj(klucze[4][1])
    Tresc=rsglobal.Dekoduj(klucze[4][2])
    suma=0

    #sprawdzenie czy na wycigu w pozycji nie ma ju patnoci
    sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"'"
    sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" AND nr_poz="+str(NrPoz)+" AND platnosc_id>0;"
    stat,DTest,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DTest)>0:
            stat='IS POZ PLAT'

    #sprawdzenie waluty - czy si zgadzaj z kas/bankiem
    if stat=='OK':
        sql = "SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
        stat,DWal,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            for NrZalegl in Numery:
                if stat=='OK':
                    sql = "SELECT waluta FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZalegl)+";"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        if len(d)<>0:
                            if (d[0][0]<>DWal[0][0]) and DWal[0][0]<>'PLN':
                                stat='Waluta w zalegoci numer '+str(NrZalegl)+' nie pasuje do waluty raportu/wycigu'
                                dane.append(stat)

    #wstawienie kolejnych zalegoci do raportu/wycigu

    if stat=='OK':
        for NrZalegl in Numery:
            if stat=='OK':
                sql = "SELECT typ_dok, wyznacznik_id,data,numer,platnik_id,kierowca,do_zaplaty_wal,do_zaplaty"
                sql+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZalegl)+";"
                stat,DZal,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    if len(DZal)>0:
                        sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                        sql+=" AND nr_poz="+str(NrPoz)+" ORDER BY nr_ppoz DESC LIMIT 1"
                        stat,d_nr,dump,dump = self.PolSQL.Execute(sql ,3)
                        if stat=='OK':
                            if len(d_nr)==0:
                                NrPpoz = 1
                            else:
                                NrPpoz = int(d_nr[0][0]) + 1

                            # kierowca
                            if DZal[0][5] in ['None',None]:
                                DZal[0][5]='NULL'
                            else:
                                DZal[0][5]="'"+DZal[0][5]+"'"

                            # wyznacznik
                            if DZal[0][1] in ['None',None]:
                                DZal[0][1]='NULL'
                            else:
                                DZal[0][1]="'"+DZal[0][1]+"'"

                            # data
                            if DZal[0][2] in ['None',None]:
                                DZal[0][2]='NULL'
                            else:
                                DZal[0][2]="'"+DZal[0][2]+"'"


                            #ustawienie parametrw inserta wzgldem waluty i wartoci (dodatnia/ujemna) - domyslnie >0 i PLN
                            NrWaluty=7
                            TypZnak='P'
                            ZnakKw=''
                            if DWal[0][0]<>'PLN':
                                NrWaluty=6
                            if DZal[0][NrWaluty]<0:
                                TypZnak='W'
                                ZnakKw='-1*'

                            Ins="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz,"
                            Ins+="stan_poz,typ,typ_fakt,wyznacznik_id,data_fakt,"
                            Ins+="numer_fakt,platnik_id,kierowca,kwota) VALUES "
                            Ins+="('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"','"+Data+"',"+str(Numer)+","+str(NrPoz)+","+str(NrPpoz)+","
                            Ins+="'W','"+TypZnak+"','"+rsglobal.Dekoduj(DZal[0][0])+"',"+rsglobal.Dekoduj(DZal[0][1])+","+rsglobal.Dekoduj(DZal[0][2])+","
                            Ins+=str(DZal[0][3])+",'"+rsglobal.Dekoduj(DZal[0][4])+"',"+rsglobal.Dekoduj(DZal[0][5])+","+ZnakKw+str(DZal[0][NrWaluty])+");"

                            stat,dump,dump,dump = self.PolSQL.Execute(Ins ,1)


    CzyPodpozycja=True

# UWAGA!!! Wstawienie sumy podpozycji w pozycj jest zdecydowanie niej


#-------------------------------------------------------------------------------
# pobranie danych wielu patnoci na pozycje (19)
#-------------------------------------------------------------------------------

if Fun == 19 and stat=='OK':
    #Numery patnoci, symbol i tre na pozycje
    Numery=klucze[4][0]
    Symbol=rsglobal.Dekoduj(klucze[4][1])
    Tresc=rsglobal.Dekoduj(klucze[4][2])
    suma=0

    #sprawdzenie czy na wycigu w pozycji nie ma ju zalegoci
    sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"'"
    sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" AND nr_poz="+str(NrPoz)+" AND typ_fakt IN ('D','F','K','N');"
    stat,DTest,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DTest)>0:
            stat='BL POZ DLA PLAT'

    #sprawdzenie waluty - czy si zgadzaj z kas/bankiem
    if stat=='OK':
        sql = "SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"';"
        stat,DWal,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if DWal[0][0]<>'PLN':
                stat='WAL KASY NIE PLN'
                dane.append(stat)

    #wstawienie kolejnych patnoci do raportu/wycigu
    if stat=='OK':
        for NrPlatnosci in Numery:
            if stat=='OK':
                sql = "SELECT kontrahent_id,kwota_platnosci,konto_fk,nr_faktury"
                sql+=" FROM rs_platnosci WHERE firma_id='"+self.firma_id+"' AND platnosc_id="+str(NrPlatnosci)+";"
                stat,DPlat,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    if len(DPlat)>0:
                        sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                        sql+=" AND nr_poz="+str(NrPoz)+" ORDER BY nr_ppoz DESC LIMIT 1"
                        stat,d_nr,dump,dump = self.PolSQL.Execute(sql ,3)
                        if stat=='OK':
                            if len(d_nr)==0:
                                NrPpoz = 1
                            else:
                                NrPpoz = int(d_nr[0][0]) + 1

                            #ustawienie parametrw inserta wzgldem wartoci (dodatnia/ujemna) - domyslnie >0
                            TypZnak='W'
                            ZnakKw=''
                            if DPlat[0][1]<0:
                                TypZnak='P'
                                ZnakKw='-1*'

                            # platnik
                            if DPlat[0][0] in ['None',None]:
                                DPlat[0][0]='NULL'
                            else:
                                DPlat[0][0]="'"+DPlat[0][0]+"'"

                            Ins="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz,"
                            Ins+="stan_poz,typ,typ_fakt,platnik_id,platnosc_id,kwota,konto,tresc) VALUES "
                            Ins+="('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"','"+Data+"',"+str(Numer)+","+str(NrPoz)+","+str(NrPpoz)+","
                            Ins+=" 'W','"+TypZnak+"','P',"+rsglobal.Dekoduj(DPlat[0][0])+","+str(NrPlatnosci)+","
                            Ins+=" "+ZnakKw+str(DPlat[0][1])+",'"+rsglobal.Dekoduj(DPlat[0][2])+"','"+rsglobal.Dekoduj(DPlat[0][3])+"');"

                            stat,dump,dump,dump = self.PolSQL.Execute(Ins ,1)

    CzyPodpozycja=True
# UWAGA!!! Wstawienie sumy podpozycji w pozycj jest zdecydowanie niej


#-------------------------------------------------------------------------------
# pobranie danych zaliczki (21)
#-------------------------------------------------------------------------------

#WS 2023-07-25
if stat == 'OK' and Fun in (1, 2, 3, 4, 21,):
    if Fun == 21:
        Zaliczka = klucze[6]
    else:
        if 'zaliczka_id' in pola:
            Zaliczka = wartosci[pola.index('zaliczka_id')]

    if Fun in (3, 4):
        SQL = """SELECT rpoz.zaliczka_id,
                        z.kwota_brutto AS saldo_otw,
                        z.kwota_brutto-(SELECT COALESCE(SUM(zp.kwota_brutto),0) FROM rs_wf_zaliczki_pozycje zp WHERE rpoz.zaliczka_id=zp.zaliczka_id) AS saldo_zam
                 FROM rs_raporty_wyciagi_pozycje rpoz
                 LEFT OUTER JOIN rs_wf_zaliczki z USING (firma_id, zaliczka_id)
                 WHERE rpoz.firma_id=%s AND rpoz.okres_id=%s AND rpoz.kasa_bank_id=%s
                       AND rpoz.data=%s AND rpoz.numer=%s AND rpoz.nr_poz=%s AND rpoz.nr_ppoz=%s;"""
        zmienne = [self.firma_id, self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz]
        rsglobal.ZapiszDoLogow('Dane zaliczki poprzedniej: ' + self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_zal, wyn1_zal, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych zaliczki'
        else:
            DanePoprzZaliczki = rssql.RSTableRowset2(d_zal, wyn1_zal)[0]

            ZaliczkaPoprz = DanePoprzZaliczki['zaliczka_id']
            SaldoPoprzZal = DanePoprzZaliczki['saldo_zam']

    if stat == 'OK' and Zaliczka is not None:  # zaliczka zostaa wpisana/zmieniona
        if Zaliczka == 0:
            RKZal = 'U'  # zaliczka usuwana z raportu
        else:
            SQL = """SELECT stan,
                            rk_o_okres_id, rk_o_kasa_bank_id, rk_o_data, rk_o_numer, rk_o_nr_poz, rk_o_nr_ppoz,
                            rk_z_okres_id, rk_z_kasa_bank_id, rk_z_data, rk_z_numer, rk_z_nr_poz, rk_z_nr_ppoz,
                            z.kontrahent_id, z.kwota_brutto AS saldo_otw,
                            z.kwota_brutto-(SELECT COALESCE(SUM(zp.kwota_brutto),0) FROM rs_wf_zaliczki_pozycje zp WHERE z.zaliczka_id=zp.zaliczka_id) AS saldo_zam
                     FROM rs_wf_zaliczki z
                     WHERE z.firma_id=%s AND z.zaliczka_id=%s;"""
            zmienne = [self.firma_id, Zaliczka]

            rsglobal.ZapiszDoLogow('Rk zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
            stat, d_rk, wyn1_rk, dump = self.PolSQL.Execute(SQL, 3, zmienne)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd pobrania danych zaliczki'
            elif len(d_rk) == 0:
                stat = 'BL_ZAL'
            else:
                DaneZaliczki = rssql.RSTableRowset2(d_rk, wyn1_rk)[0]

                StanZal = DaneZaliczki['stan']

                if StanZal == 'K':
                    stat = 'ZAL_K'
                else:
                    RKZal = ''
                    KontrahentZal = DaneZaliczki['kontrahent_id']
                    KwotaZal = 0
                    TrescZal = 'Zaliczka nr '+str(int(Zaliczka))

                    if DaneZaliczki['rk_o_okres_id'] in ('', 'None'):
                        if StanZal == 'A':
                            # raport otwierajcy
                            RKZal = 'O'
                            TypZal = 'W'
                            KwotaZal = DaneZaliczki['saldo_otw']
                        else:
                            stat = 'ZAL_A'
                    elif DaneZaliczki['rk_z_okres_id'] in ('', 'None'):
                        if StanZal == 'R':
                            # raport zamykajcy
                            RKZal = 'Z'
                            if DaneZaliczki['saldo_zam'] < 0:
                                TypZal = 'W'
                            else:
                                TypZal = 'P'
                            KwotaZal = DaneZaliczki['saldo_zam']
                        else:
                            stat = 'ZAL_R'
                    else:
                        stat = 'ZAL_K'

                if stat == 'OK':
                    SQL = """SELECT konto_zaliczek
                             FROM rs_kasy_banki
                             WHERE firma_id=%s AND okres_id=%s AND kasa_bank_id=%s;"""
                    zmienne = [self.firma_id, self.okres_id, KasaBank]

                    rsglobal.ZapiszDoLogow('Kasa bank konto zaliczek: '+self.PolSQL.Mogrify(SQL, zmienne))
                    stat, d_konto, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
                    if stat != 'OK':
                        rsglobal.ZapiszDoLogow(stat)
                        stat = 'Bd pobrania konta zaliczek'
                    else:
                        KontoZal = d_konto[0][0].strip()+'-'+DaneZaliczki['kontrahent_id'].strip() if d_konto[0][0] not in ('', 'None') else 'BRAK'

                if stat == 'OK' and Fun == 21:
                    dane = [TypZal, KontrahentZal, abs(KwotaZal), KontoZal, TrescZal]


#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [1,2,3,4]:
    #sprawdzenie kompensaty i waluty
    Sql="SELECT rb.kompensata,kb.waluta FROM rs_raporty_wyciagi rb INNER JOIN rs_kasy_banki kb USING (firma_id,okres_id,kasa_bank_id)"
    Sql+=" WHERE rb.firma_id='"+self.firma_id+"' AND rb.okres_id='"+self.okres_id+"' AND rb.kasa_bank_id='"+KasaBank+"' AND rb.data='"+Data+"'"
    Sql+=" AND rb.numer="+str(Numer)+";"
    stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat<>'OK':
        stat='BL SEL KOMP'
        dane.append(stat)
    else:
        kompensata=d[0][0]
        waluta=d[0][1]


    #zmienna ktra mwi czy na pozycji s patnoci, zalegoci czy puste
    TypPPoz=0
    #pobranie ewentualnego typu podpozycji
    Sql="SELECT DISTINCT CASE WHEN typ_fakt IN ('F','K','D','N') THEN 1 WHEN typ_fakt='P' THEN 2 ELSE 3 END "
    Sql+=" FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    Sql+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+NrPoz+" AND nr_ppoz>0;"
    stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat=='OK':
        if len(d)>1:
            stat='DWA TYP PPOZ'
            dane.append(stat)
        elif len(d)==1:
            TypPPoz=d[0][0]

    #jeli update
    if Fun in [3,4] and stat=='OK':
        Sql ="SELECT konto,COALESCE(typ_fakt, '') AS typ_fakt,wyznacznik_id,data_fakt,numer_fakt,kwota,"  #AB 14.10.21r
        Sql+=" tresc,platnik_id,platnosc_id,kurs,nr_ppoz,typ "
        Sql+=" FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
        Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
        Sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
        Sql+=" AND nr_ppoz="+str(NrPpoz)+" FOR UPDATE;"

        stat,d,wyn1,wyn2=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL POB KONT'
            dane.append(stat)
        else:
            KontoS=rsglobal.Dekoduj(d[0][0])
            TypFaktS=d[0][1]
            WyznacznikS=d[0][2]
            DataFaktS=d[0][3]
            NumerFaktS=d[0][4]
            KwotaS=d[0][5]
            TrescS=d[0][6]
            PlatnikS=rsglobal.Dekoduj(d[0][7])
            PlatnoscS=d[0][8]
            KursS=d[0][9]
            NrPPozS=d[0][10]
            ZmianaKontaLubPlat=0
            TypS=d[0][11]

    # jeli insert
    elif Fun in [1,2] and stat=='OK':
        KontoS=''
        TypFaktS=''
        WyznacznikS=''
        DataFaktS=''
        NumerFaktS=0
        KwotaS=0
        TrescS=''
        PlatnikS=''
        PlatnoscS=0
        KursS=1
        NrPPozS=0
        ZmianaKontaLubPlat=3
        TypS=''

    #sprawdzenie kolejnych pl w ptli
    if stat=='OK':
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole=='konto':
                if Fun in [3,4]:
                    ZmianaKontaLubPlat+=1
                KontoS=wart
                if wart<>'':
                    Sql="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    stat,d,dump,dump = self.PolSQL.Execute(Sql,3)
                    if d != None:
                        if rsglobal.rseval(rsglobal.Dekoduj(d[0][0]))[0]=='':
                            stat='BL KONT'
                            dane.append(stat)
                        elif not rsglobal.rseval(rsglobal.Dekoduj(d[0][0]))[2]:
                            stat='BL KONT NIE KSIE'
                            dane.append(stat)
                    else:
                        stat='BL KRYT KONT'
                        dane.append(stat)

            elif pole=='typ_fakt':
                TypFaktS=wart
                #To s dozwolone typy
                if wart not in ['F','K','P','D','','N']:
                    stat='BL TYP FAKT'
                    dane.append(stat)

                # jeli tak jest to istniej ju inne podpozycje i trzeba sprawdzi zgodno typw
                elif TypPPoz>0:
                    #dodajemy patno na pozycj z innym typem podpozycji
                    if wart=='P' and TypPPoz != 2:
                        stat='BL TYP PPOZ PLAT'
                        dane.append(stat)
                    #dodajemy zalego na pozycj z innym typem podpozycji
                    elif wart in ['F','K','N'] and TypPPoz != 1:
                        stat='BL TYP PPOZ ZAL'
                        dane.append(stat)
                    #dodajemy dowd dostawy na pozycj z innym typem podpozycji
                    elif wart =='D' and TypPPoz != 1:
                        stat='BL TYP PPOZ DOST'
                        dane.append(stat)
                    #dodajemy pusty typ na podpozycj
                    elif wart.strip() =='' and TypPPoz != 3:
                        stat='BL TYP PPOZ PUST'
                        dane.append(stat)

            elif pole=='wyznacznik_id':
                WyznacznikS=wart
                if wart.strip()<>'':
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+wart+"';",3)
                    if len(dane_wyn) == 0:
                        stat="BL WYZN"
                        dane.append(stat)

            elif pole=='data_fakt':
                DataFaktS=wart
                if wart not in puste_pola:
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL DAT'
                        dane.append(stat)

            elif pole=='numer_fakt':
                NumerFaktS=wart

            elif pole=='kurs':
                if wart==0:
                    stat='KURS 0'
                    dane.append(stat)
                KursS=wart

            elif pole=='typ':
                if RKZal not in ('', 'U'):  #WS 2023-07-25
                    wartosci[i] = TypZal
                    wart = wartosci[i]

                if wart not in ('P','W'):
                    stat='BL TYP'
                    dane.append(stat)
                TypS=wart
            
            elif pole=='kwota':
                if RKZal not in ('', 'U'):  #WS 2023-07-25
                    wartosci[i] = abs(KwotaZal)

                wartosci[i]=round(wartosci[i],2)
                KwotaS=wartosci[i]
                
            elif pole=='tresc':
                TrescS=wart
            
            elif pole == "nr_ppoz":
                NrPPozS = wart
            
            elif pole=='platnik_id':
                if RKZal not in ('', 'U'):  #WS 2023-07-25
                    wartosci[i] = KontrahentZal
                    wart = wartosci[i]

                if Fun in [3,4]:
                    ZmianaKontaLubPlat+=2
                PlatnikS=wart
                if wart != "":
                    sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat='Bd sprawdzania kontrahenta : '+stat
                        dane.append(stat)
                    elif len(d)==0:
                        stat='BL PLAT'
                        dane.append(stat)    
                        
            elif pole=='platnosc_id':
                PlatnoscS=wart
                if wart not in ["",'None',0]:
                    sql = "SELECT platnosc_id FROM rs_platnosci WHERE platnosc_id='"+str(wart)+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if len(d)==0:
                        stat='BL PLATNOSCI'
                        dane.append(stat)    
                else:
                    wartosci[i]=''
                
            elif pole=='kierowca':
                if wart != "":
                    sql = "SELECT kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if len(d)==0:
                        stat='BL KIER'
                        dane.append(stat)

            #WS 2022-04-06
            elif pole=='sposob_zaplaty':
                if wart != '':
                    sql = "SELECT 1 FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if len(d)==0:
                        stat='BL SPOSOB'
                        dane.append(stat)
                    else:
                        sql = "SELECT 1 FROM rs_kasy_banki_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND sposob_zaplaty='"+wart+"';"
                        dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if len(d)==0:
                            stat='BL SPOSOB KASABANK'
                            dane.append(stat)

            #WS 2023-07-20
            elif pole == 'zaliczka_id':
                if wart != 0:
                    sql = "SELECT zaliczka_id FROM rs_wf_zaliczki WHERE firma_id='"+self.firma_id+"' AND zaliczka_id="+str(wart)+";"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if len(d)==0:
                        stat='BL ZALICZKA'
                        dane.append(stat)
                else:
                    wartosci[i] = ''
        
        #sprawdzenie czy dodawany typ pasuje do ju istniejcych podpozycji
        if not NrPPozS in [0,'0']:
            if not ((TypPPoz==1 and TypFaktS in ['F','K','D','N']) or \
                    (TypPPoz==2 and TypFaktS=='P') or \
                    (TypPPoz==3 and TypFaktS.strip() in ['']) or \
                    (TypPPoz==0)):
                stat='TYP NIEZGRANY'
                dane.append(stat)    

        # sprawdzenie czy dane wpisane w koncie oraz w patniku s dobrze zsynchronizowane. Uwzgldniane s rwnie zalenoci zwizane z tym, czy
        # s spenione zalenoci pomidzy podpozycj a pozycj.
        # zmienna ZmianaKontaLubPlat wynosi 0 gdy nie zmienione, 1 gdy zm konto, 2 - zm. patnik, 3 - zm. patniki i konto
        
        #sprawdzanie w zaleznosci od wartosci checkboxa z KASY/BANKI
        if stat=='OK':
            Pomin=False
            sql = "SELECT nie_sprawdzac_konta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' "
            sql+= "AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+str(KasaBank)+"';"          
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='Bedy przy sprawdzaniu kontrahenta i konta.'
                dane.append(stat) 
            else:
                if d<>[]:
                    if d[0][0]:
                        Pomin=True  
            if ZmianaKontaLubPlat>0 and stat=='OK' and Pomin==False:
                # pobranie patnika z konta
                PlatKonta=''
                if KontoS<>'':
                    SQL="SELECT rsf_sprawdz_czy_kontrahent_w_koncie('"+self.firma_id+"','"+self.okres_id+"','"+KontoS+"')"
                    stat,DKonta,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if int(DKonta[0][0])>0:
                            KontoPodz=KontoS.split('-')
                            PlatKonta=KontoPodz[int(DKonta[0][0])-1]
                        
                        # sprawdzenie lokalne patnika 
                        # ten warunek wystarczy by sprawdzi lokaln zgodno. 
                        if PlatKonta != '' and (not PlatnikS in ['None',None,'']):
                            #rsglobal.ZapiszDoLogow('platnicy '+str(PlatKonta)+' '+str(PlatnikS)+' '+str(PlatnikS=='None'),1)
                            if PlatKonta.strip() != PlatnikS.strip():
                                stat='PLAT KONTO NIEZGODNE'
                                dane.append(stat)    

                    if stat=='OK':
                        # jeli podpozycja i patnik ='' i jest Platnik konta to rwnie globalnie 
                        if (not NrPPozS in [0,'0']) and PlatnikS in ['None','',None] and PlatKonta != '':
                            SQL="SELECT COALESCE(platnik_id,'') FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                            SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
                            SQL+=" AND nr_ppoz=0"
                            stat,DPlat,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                #rsglobal.ZapiszDoLogow('Platnik0 '+str(DPlat),1)
                                if not DPlat[0][0] in  ['',None]:
                                    if PlatKonta.strip() != DPlat[0][0].strip():
                                        stat='Patnik z konta nie zgadza si z patnikiem z pozycji 0 o symbolu '+DPlat[0][0].strip()
                                        dane.append(stat)         
                                                
                # zostao sprawdzenie zmiany kontrahenta w pozycji w d
                if stat=='OK':
                    if NrPPozS in [0,'0'] and (not PlatnikS in ['None','',None]):
                        SQL="SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                        SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
                        SQL+=" AND rsf_sprawdz_czy_kontrahent_w_koncie(firma_id,okres_id,konto)::INT>0 AND platnik_id IS NULL AND nr_ppoz>0"
                        SQL+=" AND SPLIT_PART(konto,'-',rsf_sprawdz_czy_kontrahent_w_koncie(firma_id,okres_id,konto)::INT)<>'"+PlatnikS+"'"
                        stat,DPola,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat=='OK':
                            if len(DPola)>0:
                                stat='Podpozycje zawierajce innego patnika w koncie ni w pozycji : '
                                for wiersz in DPola:
                                    stat+=str(wiersz[0])+','
                                stat=stat[:-1]        
                        
        #sprawdzenie czy dane dla typu kompensata s uzupenione
        if kompensata and stat=='OK':
            if (TypFaktS.strip() in puste_pola):
                stat='KOMP BR TYP FAKT'
                dane.append(stat)
            elif (TrescS.strip() in puste_pola):
                stat='KOMP BR TRESC'
                dane.append(stat)
            elif (WyznacznikS.strip() in puste_pola):
                stat='KOMP BR WYZN'
                dane.append(stat)
            elif (DataFaktS in puste_pola):
                stat='KOMP BR DAT FAKT'
                dane.append(stat)
            elif (NumerFaktS==0):
                stat='KOMP BR NR FAKT'
                dane.append(stat)
            elif (KontoS.strip()==''):
                stat='KOMP BR KONT'
                dane.append(stat)
                
        if TypFaktS.strip()=='D' and stat=='OK':
            if PlatnikS.strip()=='':
                stat='BR PLAT D'
                dane.append(stat)
            if WyznacznikS.strip() in puste_pola:
                stat='BR WYZN D'
                dane.append(stat)
            if DataFaktS not in puste_pola:
                stat='IS DAT D'
                dane.append(stat)
            if NumerFaktS!=0:
                stat='IS NR D'
                dane.append(stat)

        if KwotaS==0 and TypFaktS.strip()<> '' and stat=='OK':
            stat='BR KWOT'
            dane.append(stat)            

        if KursS==1 and waluta != 'PLN'  and stat=='OK':
            stat='KURS WAL 1'
            dane.append(stat)                   

        if KursS!=1 and waluta=='PLN'  and stat=='OK':
            stat='KURS PL NIE 1'
            dane.append(stat)                   

        #sprawdzenie czy przy wpisanym wyznaczniku wpisany jest typ F,K,D
        if not WyznacznikS.strip() in puste_pola:
            if not TypFaktS.strip() in ['F','K','D']:
                stat='WYZN TYP FKD'
                dane.append(stat)    

        if stat=='OK':
            if KontoS not in puste_pola :
                if ((TypFaktS.strip() in ['F','K','D']) or (WyznacznikS.strip() not in puste_pola) or (DataFaktS not in puste_pola) or (NumerFaktS!=0)) and (not kompensata):
                    stat='KONT LUB FAKT'
                    dane.append(stat)    
                elif TrescS=='':
                    stat='BR TRES'
                    dane.append(stat)

            if TypFaktS in ['F','K']:
                if (WyznacznikS.strip() in puste_pola) or (DataFaktS in puste_pola) or  (NumerFaktS==0):
                    stat="BR ZAL PAR"
                    
                if stat=='OK':
                    sql = "SELECT platnik_id FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"'"
                    sql=sql+" AND wyznacznik_id='"+WyznacznikS+"' AND typ_dok='"+TypFaktS+"'"
                    sql=sql+" AND data='"+DataFaktS+"' AND numer="+str(NumerFaktS)+";"
                    stat,d,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
                    if stat=='OK':
                        if len(d)==0:
                            stat="BL ZAL"
                            dane.append(stat)
                        elif d[0][0].strip()<> PlatnikS.strip():
                            stat="BL PLATZ"
                            dane.append(stat)
            # zalego z patnoci
            elif TypFaktS=='P':
                if KontoS in puste_pola:
                    stat="BR KONTA PL"
                    dane.append(stat)
                elif PlatnoscS==0:
                    stat="BR PLATNOSCI"
                    dane.append(stat)
                #sprawdzenie,czy patno istnieje jest wyej. Tu sprawdzamy czy patno i konto s wpisane
            # dane z dowodw dostaw
            elif TypFaktS=='D':
                if len(TrescS)<11:
                    stat='KR TRESCS'
                    dane.append(stat)
                if stat=="OK":  #AB 2024-02-27
                    SQL = "SELECT kasa_bank_id ||'/'|| data ||'/'|| numer ||' poz. '|| nr_poz || " \
                          "CASE WHEN nr_ppoz != 0 THEN '/'|| nr_ppoz ELSE '' END " \
                          "FROM rs_raporty_wyciagi_pozycje ddp WHERE firma_id=%s AND tresc=%s;"
                    args = [self.firma_id, TrescS]
                    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))

                    stat, Powtorki,dump,dump=self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat='BL SPR DUP'
                    elif len(Powtorki) > 0:
                        stat = 'BL DUP DD$'+'\n'.join([x[0] for x in Powtorki])

                if stat=="OK":
                    from funkcje import fs_dowody_dostaw_pom
                    data_dostawy_rap="20"+TrescS[0:2]+"-"+TrescS[2:4]+"-"+TrescS[4:6]

                    if data_dostawy_rap < '2016-10-01':
                        Oddzial_rap="0"+TrescS[6]

                        stat,Trasy_rap=fs_dowody_dostaw_pom.PodajTrasyDlaOddzialuZKoncowkiTras(self.PolSQL,self.firma_id,Oddzial_rap,TrescS[7:9])
                        if stat=="OK":
                            if len(Trasy_rap) ==0:
                                stat=" Nie znaleziono tras dla odziau "+Oddzial_rap+" i kocwki trasy "+TrescS[7:9]
                                dane.append(stat)

                            Tryb_rap=TrescS[6]+TrescS[9]
                            NrDowodu_rap=TrescS[10:]
                            Trasa_sql = " AND ddp.trasa IN ("+str(Trasy_rap)[1:-1]+")"

                    else:
                        Oddzial_rap=TrescS[6:8]
                        Trasa_rap = TrescS[8:12]
                        Tryb_rap = TrescS[12:14]
                        NrDowodu_rap=TrescS[14:]
                        Trasa_sql = " AND ddp.trasa ='"+Trasa_rap+"'"

                if stat=='OK':
                    SQL="SELECT SUM(ddp.cena_brutto1*ddp.ilosc_dost1) FROM rs_dowody_dostaw_pozycje ddp"
                    SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,data,oddzial_id,trasa,tryb_dostawy,numer)"
                    SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.data='"+data_dostawy_rap+"'"
                    SQL+=" AND ddp.oddzial_id='"+Oddzial_rap+"' "+Trasa_sql
                    SQL+=" AND ddp.tryb_dostawy='"+Tryb_rap+"' AND ddp.numer="+NrDowodu_rap
                    if PlatnikS != '':
                        SQL+=" AND dd.platnik_id='"+PlatnikS+"'"

                    rsglobal.ZapiszDoLogow(SQL, args)
                    stat,DDowodu,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
                    if stat<>'OK':
                        stat='BL SPR DOW'
                if stat=='OK':
                    if len(DDowodu)==0:
                        stat='BR DOW DOST'
                        dane.append(stat)
                    elif DDowodu[0][0] in [0,None]:                        
                        stat='BR DOW DOST'
                        dane.append(stat)
    
    # czy byly jakies bledy
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
    
    # sprawdzenie danych dla typu 'N' - niezidentyfikowany
    if stat == 'OK' and TypFaktS == 'N':
        if KontoS.strip() == '':
            stat = 'BR KONTO DLA N'
            dane.append(stat)
        
        if PlatnikS.strip() == '':
            stat = 'BR PLATNIK DLA N'
            dane.append(stat)
            
        if TypS.strip() != 'P':
            stat = 'BL TYP DLA N'
            dane.append(stat)
        
                        
#-------------------------------------------------------------------------------
#--- Insert danych (1,2)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [1,2]:
    if UprIns:
        sql = "INSERT INTO rs_raporty_wyciagi_pozycje"
        PolaN="firma_id,okres_id,kasa_bank_id,data,numer,stan_poz"
        WartosciN = "'"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"','"+Data+"',"+str(Numer)+",'W'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            #WS 2022-04-06 - sposob_zaplaty
            #WS 2023-07-20 - zaliczka_id
            if pole in ['stan_poz','typ','symbol_dok','typ_fakt','wyznacznik_id','tresc','konto']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['data_fakt','numer_fakt','platnik_id','kierowca','platnosc_id','sposob_zaplaty','zaliczka_id']:  #AB 26.04.22r
                PolaN += ","+pole
                if wart in puste_pola:
                    WartosciN += ",NULL"
                else:
                    WartosciN += ",'"+str(wart)+"'"
            else:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                NrPoz = wart
            elif pole == "nr_ppoz":
                NrPpoz == wart
                if NrPpoz<>'0':
                    CzyPodpozycja=True
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        
        SQL = ""
        SQLRenum = ""
        Robic=False
        if NrPpoz == '1':
            # nowa podpozycja

            # sprawdzamy czy pozycja ma warto 0. Jeli nie to
            # kopiujemy istniejaca pozycje 0 na podpozycje
            SQLKwota="SELECT kwota FROM rs_raporty_wyciagi_pozycje "
            SQLKwota+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            SQLKwota+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
            SQLKwota+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0;"
            stat,DKwota,dump,dump = self.PolSQL.Execute(SQLKwota ,3)
            if stat=='OK':
                if len(DKwota)>0:
                    if DKwota[0][0]<>0:
                        Robic=True
                        
            if stat=='OK' and Robic:
                stat, ListaPol = rsglobal.PolaTabeli(self.PolSQL, 'rs_raporty_wyciagi_pozycje')
            
                if stat=='OK':
                    SQL="INSERT INTO rs_raporty_wyciagi_pozycje ("
                    for i in xrange(len(ListaPol)):
                        if i > 0:
                            SQL+=","
                        SQL+=ListaPol[i]
                    SQL+=") (SELECT "
                    for i in xrange(len(ListaPol)):
                        if i > 0:
                            SQL+=","
                        if ListaPol[i] == 'nr_ppoz':
                            # kopia istniejacej pozycji jako podpozycja 1000
                            # bo bedzie do zamiany na nr_ppoz=1
                            SQL+="1000"
                        else:
                            SQL+=ListaPol[i]
                            
                    SQL+=" FROM rs_raporty_wyciagi_pozycje"
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                    SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                    SQL+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0);"
                    
                    # zamiana miejsc w podpozycjach
                    # nowa podpozycja na miejsce nr 2
                    SQLRenum ="UPDATE rs_raporty_wyciagi_pozycje SET nr_ppoz=2"
                    SQLRenum+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                    SQLRenum+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                    SQLRenum+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=1;"
    
                    # istniejaca pozycja skopiowana jako podpozycja 1000 na miejsce nr 1
                    SQLRenum+="UPDATE rs_raporty_wyciagi_pozycje SET nr_ppoz=1"
                    SQLRenum+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                    SQLRenum+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                    SQLRenum+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=1000;"
                    
                    # WANE: dodawana podpozycja z numeru 1 zmienila sie na nr 2
                    # tym samym zmienil sie klucz do wczytania danych
                    NrPpoz = 2
            
        SQL += sql + SQLRenum
        
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        
        if stat<>'OK':
            stat='BL INS'
            dane.append(stat)
    else:
        stat='BR_UPR_INS'
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- Update danych (3,4)
#-------------------------------------------------------------------------------

if (Fun in [3,4]) and (stat=='OK'):
    if not UprUpd:
        stat='BR_UPR_UPD'
        dane.append(stat)
    
    if stat=='OK':
        sql = "UPDATE rs_raporty_wyciagi_pozycje SET "
        Filtr = "firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if len(DozwolonePola) == 0 or pole in DozwolonePola:  #WS 2021-06-26
                #WS 2022-04-06 - sposob_zaplaty
                #WS 2023-07-20 - zaliczka_id
                if pole in ['stan_poz','typ','symbol_dok','konto','typ_fakt','wyznacznik_id','tresc']:
                    sql += pole+"='"+str(wart)+"',"
                elif pole in ['numer_fakt','kwota','kierowca','platnik_id','data_fakt','platnosc_id','kurs','sposob_zaplaty','zaliczka_id']:  #AB 26.04.22r
                    sql += pole+"="
                    if wart in puste_pola:
                        sql += "NULL,"
                    else:
                        sql += "'"+str(wart)+"',"
                elif wart == "NULL":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"="+str(wart)+","
                if pole == "nr_poz":
                    NrPoz = wart
                elif pole == "nr_ppoz":
                    NrPpoz == wart
                    if NrPpoz<>'0':
                        CzyPodpozycja=True
                if pole in ['kwota','typ','kurs']:
                    if NrPpoz<>'0':
                        CzyPodpozycja=True
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)

        
#-------------------------------------------------------------------------------
# wstawienie sumy podpozycji w pozycj (16,19) lub po insercie/updacie podpozycji
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4,16,19,20] and CzyPodpozycja and stat=='OK':   
    sql = "SELECT SUM(CASE WHEN typ='P' THEN kwota ELSE -kwota END),SUM(nr_ppoz),COALESCE(AVG(kurs),1) FROM rs_raporty_wyciagi_pozycje "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz!=0"
    
    stat,d_suma,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        suma=d_suma[0][0]
        kurs=d_suma[0][2]
        
        TypZnak='P'
        TypZnakPrz='W'
        if suma<0:
            TypZnak='W'
            TypZnakPrz='P'
            suma=-1*suma

        # to jest update, ktry tak zmienia typ pozycji by pasowa do wzorca
        UpdPoz="UPDATE rs_raporty_wyciagi_pozycje SET typ='"+TypZnak+"',kwota=-1*kwota "
        UpdPoz+="WHERE  firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        UpdPoz+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
        UpdPoz+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz>0 AND typ='"+TypZnakPrz+"';"
        
        PoleSymbolIns=''
        PoleSymbolUpd=''
        
        if Symbol<>'':
            PoleSymbolIns=",symbol_dok"
            PoleSymbolUpd=",symbol_dok='"+Symbol+"'"
            Symbol=",'"+Symbol+"'"
        
        sql = "SELECT * FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0;"
        stat,DTest,dump,dump=self.PolSQL.Execute(sql,3)

        sql=UpdPoz
        
    if stat=='OK':
        if len(DTest)>0:
            sql+="UPDATE rs_raporty_wyciagi_pozycje SET stan_poz='W',typ='"+TypZnak+"',kwota="+str(suma)+PoleSymbolUpd
            sql+=", typ_fakt='', wyznacznik_id=NULL, data_fakt=NULL, numer_fakt=NULL, konto='', tresc='',"
            sql+=" platnosc_id=NULL,kurs="+str(kurs)+" WHERE  firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"'"
            sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0;"
        else:
            sql+="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id,okres_id,kasa_bank_id,data,numer,nr_poz,nr_ppoz"
            sql+=" ,stan_poz,typ,kwota"+PoleSymbolIns+",kurs)"
            sql+=" VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"','"+Data+"',"+str(Numer)+","+str(NrPoz)+",0,"
            sql+=" 'W','"+TypZnak+"',"+str(suma)+Symbol+","+str(kurs)+");"

        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        

#-------------------------------------------------------------------------------
# SPRAWDZENIE, CZY NIE MA ZEROWEJ POZYCJI
#-------------------------------------------------------------------------------

if stat=='OK' and not Data in [None,'None','','    -  -  '] and Numer!=0:
    NrZmieniony=0
    
    SQL="SELECT min(nr_poz),max(nr_poz) FROM rs_raporty_wyciagi_pozycje "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DTest)>0:
            if DTest[0][0]==0:
                rsglobal.ZapiszDoLogow('ZMIANA POZYCJI ZERO W POZYCJE DANE '+str(klucze),3)
                SQL="UPDATE rs_raporty_wyciagi_pozycje SET nr_poz="+str(DTest[0][1]+1)
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
                SQL+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                SQL+=" AND nr_poz=0;"
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat=='OK':
                    NrZmieniony=DTest[0][1]+1
                    NrPoz=str(DTest[0][1]+1)
                

#-------------------------------------------------------------------------------
#SELECT
#-------------------------------------------------------------------------------

if (Fun in [1,2,3,4,5]) and (stat=='OK'):
    Sql="SELECT * FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
    Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"'"
    Sql+=" AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPpoz)
    
    stat,dane,wyn1,dump=self.PolSQL.Execute(Sql,3)
    if stat<>'OK':
        stat='BL PRZ'
        dane.append(stat)
    
if stat=='OK' and Fun not in [15,17,12,21]:
    #sprawdzenie istnienia podpozycji
    CzyPlatnosci=False
    CzyZaleglosci=False
    Sql="SELECT * FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz!=0;"
    stat,DTest,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat=='OK':
        if len(DTest)>0:
            #sprawdzenie czy w podpozycjach s patnoci
            sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"'"
            sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
            sql+=" AND nr_poz="+str(NrPoz)+" AND platnosc_id>0;"
            stat,DTestPlat,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                CzyPlatnosci=(len(DTestPlat)>0)
            
                #sprawdzenie czy w podpozycjach s zalegoci
                sql = "SELECT nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE firma_id = '"+self.firma_id+"'"
                sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)
                sql+=" AND nr_poz="+str(NrPoz)+" AND typ_fakt IN ('D','F','K');"
                stat,DTestZal,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    CzyZaleglosci=(len(DTestZal)>0)
    if stat=='OK':
        #uprawnienia do zmiany danych; uprawnienia do insert; czy w pozycji s podpozycje; numer pozycji po zmianie z zera
        wyn2=[str(UprUpd),str(UprIns),len(DTest)>0,CzyPlatnosci,CzyZaleglosci,NrZmieniony]


#-------------------------------------------------------------------------------
# aktualizacja klucza raportu, salda i stanu w zaliczce (22)
#-------------------------------------------------------------------------------

#WS 2023-07-25
if stat == 'OK' and Fun in (1, 2, 3, 4,) and RKZal != '':
    if RKZal == 'O':
        SQL = """UPDATE rs_wf_zaliczki
                 SET rk_o_okres_id=%s, rk_o_kasa_bank_id=%s, rk_o_data=%s, rk_o_numer=%s, 
                     rk_o_nr_poz=%s, rk_o_nr_ppoz=%s, saldo=%s
                 WHERE zaliczka_id=%s;"""
        zmienne = [self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz, KwotaZal, Zaliczka]

        rsglobal.ZapiszDoLogow('Update rko zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd aktualizowania danych zaliczki'
    elif RKZal == 'Z':
        #WS 2023-09-04
        SQL = """UPDATE rs_wf_zaliczki
                 SET rk_z_okres_id=%s, rk_z_kasa_bank_id=%s, rk_z_data=%s, rk_z_numer=%s, 
                     rk_z_nr_poz=%s, rk_z_nr_ppoz=%s, saldo=0, stan='Z'
                 WHERE zaliczka_id=%s;"""
        zmienne = [self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz, Zaliczka]

        rsglobal.ZapiszDoLogow('Update rkz zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd aktualizowania danych zaliczki'
    elif RKZal == 'U':
        SQL = """UPDATE rs_wf_zaliczki
                 SET rk_o_okres_id=NULL, rk_o_kasa_bank_id=NULL, rk_o_data=NULL, rk_o_numer=NULL, 
                     rk_o_nr_poz=NULL, rk_o_nr_ppoz=NULL, saldo=0
                 WHERE zaliczka_id=%s AND 
                       rk_o_okres_id=%s AND rk_o_kasa_bank_id=%s AND rk_o_data=%s AND rk_o_numer=%s AND
                       rk_o_nr_poz=%s AND rk_o_nr_ppoz=%s;
                 UPDATE rs_wf_zaliczki
                 SET rk_z_okres_id=NULL, rk_z_kasa_bank_id=NULL, rk_z_data=NULL, rk_z_numer=NULL, 
                     rk_z_nr_poz=NULL, rk_z_nr_ppoz=NULL, saldo=%s, stan='R'
                 WHERE zaliczka_id=%s AND 
                       rk_z_okres_id=%s AND rk_z_kasa_bank_id=%s AND rk_z_data=%s AND rk_z_numer=%s AND
                       rk_z_nr_poz=%s AND rk_z_nr_ppoz=%s;"""
        zmienne = [Zaliczka, self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz,
                   SaldoPoprzZal, Zaliczka, self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz]

        rsglobal.ZapiszDoLogow('Usuniecie rk zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd aktualizowania danych zaliczki'

    if ZaliczkaPoprz is not None and ZaliczkaPoprz != 0 and ZaliczkaPoprz != Zaliczka:
        SQL = """UPDATE rs_wf_zaliczki
                 SET rk_o_okres_id=NULL, rk_o_kasa_bank_id=NULL, rk_o_data=NULL, rk_o_numer=NULL, 
                     rk_o_nr_poz=NULL, rk_o_nr_ppoz=NULL, saldo=0
                 WHERE zaliczka_id=%s AND 
                       rk_o_okres_id=%s AND rk_o_kasa_bank_id=%s AND rk_o_data=%s AND rk_o_numer=%s AND
                       rk_o_nr_poz=%s AND rk_o_nr_ppoz=%s;
                 UPDATE rs_wf_zaliczki
                 SET rk_z_okres_id=NULL, rk_z_kasa_bank_id=NULL, rk_z_data=NULL, rk_z_numer=NULL, 
                     rk_z_nr_poz=NULL, rk_z_nr_ppoz=NULL, saldo=%s, stan='R'
                 WHERE zaliczka_id=%s AND 
                       rk_z_okres_id=%s AND rk_z_kasa_bank_id=%s AND rk_z_data=%s AND rk_z_numer=%s AND
                       rk_z_nr_poz=%s AND rk_z_nr_ppoz=%s;"""
        zmienne = [ZaliczkaPoprz, self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz,
                   SaldoPoprzZal, ZaliczkaPoprz, self.okres_id, KasaBank, Data, Numer, NrPoz, NrPpoz]

        rsglobal.ZapiszDoLogow('Usuniecie rk poprzedniej zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd aktualizowania danych zaliczki'
