#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_reklamacje.py
# Purpose:     grid reklamacji
#
# Author:      Mariusz Rajfura
# Created:     2012/03/21
# RCS-ID:      $Id: fs_reklamacje.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-04-01 Mariusz Rajfura  zmiana sort SELECT,filtr stanu (5607,5595)
# 2012-04-23 Mariusz Rajfura  mod.edycji: kontrahent_id opcjonalny (5670)
# 2020-10-25 Wojciech Skowron (12170) pobieranie/usuwanie/zmiana klucza reklamacji tylko z kontrahentem zdefiniowanym dla operatora
# 2020-12-14 Jan Raburski (12223) dla kontrahenta z operatorow przegladanie wszystkich oddzialow,
# 2021-02-05 Aleksander Bargie (12311) Problem z wydrukiem reklamacji z innego oddziau ni operator jest zalogowany
# 2022-07-13 Aleksander Bargie (12989) Komunikat gdy tworzenie raportu pdf nie powiedzie si


import rs_print_util
import tempfile
from funkcje import fs_pliki_global

Fun = klucze[-1]  #AB 05.02.21r przeniesione na poczatek
Data = rsglobal.Dekoduj(klucze[0][0])
Numer = rsglobal.Dekoduj(klucze[0][1])
DataN = rsglobal.Dekoduj(klucze[0][2])
NumerN = rsglobal.Dekoduj(klucze[0][3])
if Fun in (8, 9, 10, 11):  #AB 05.02.21r
    Oddzial = rsglobal.Dekoduj(klucze[0][4])

DataOdF = rsglobal.Dekoduj(klucze[1][0])
DataDoF = rsglobal.Dekoduj(klucze[1][1])
ZastrzezenieF = rsglobal.Dekoduj(klucze[1][2]).strip()
KontrahentF = rsglobal.Dekoduj(klucze[1][3]).strip()
ArtykulF = rsglobal.Dekoduj(klucze[1][4]).strip()
PrzyczynaNiezgodnosciF = rsglobal.Dekoduj(klucze[1][5]).strip()
StanF = rsglobal.Dekoduj(klucze[1][6]).strip()

# nowe klucze
Klucze = klucze[2]


stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprUsuwanie = ((self.oddzial_id,'027104') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprZmianaKlucza = ((self.oddzial_id,'027105') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

KontrahentOp = ''
#WS 2020-10-25 - pobranie kontrahent_id z rs_operatorzy
if Fun in [5,6,7,12]:
    SEL = "SELECT kontrahent_id FROM rs_operatorzy WHERE operator_id={}".format(self.operator_id)
    stat, dane_op, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania kontrahent_id dla zalogowanego operatora: '+stat
    elif len(dane_op) == 0:
        stat = 'Bd pobrania kontrahent_id dla zalogowanego operatora'
    else:
        KontrahentOp = dane_op[0][0].strip() if dane_op[0][0].strip() not in ('None', '') else ''

# dla funkcji 6 i 7 sprawdzamy czy mona edytowa reklamacj (jeli nie modyfikowano od 30 dni to nie)
if Fun in [6,7] and stat == 'OK':
    SQL = "SELECT NOW()::DATE - COALESCE(data_modyfikacji,NOW()::DATE) FROM rs_reklamacje "
    SQL += " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SQL += " AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat, DModyf, dump, dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd pobrania informacji o datach reklamacji: '+stat
    elif len(DModyf) == 0:
        stat = 'Reklamacja o podanym kluczu nie istnieje.'
    elif DModyf[0][0] > 30:
        stat = 'Nie mona dokonywa zmian w reklamacji, bo bya ona modyfikowana wicej ni 30 dni temu'
    
#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie or KontrahentOp != '':
        stat = 'UPR DEL'

    if stat == 'OK':
        sql ="SELECT data,numer FROM rs_reklamacje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        # jr if KontrahentOp != '':  #WS 2020-10-25
        #    sql+=" AND kontrahent_id='"+KontrahentOp+"'"
        sql += " AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat, d, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o reklamacji: '+stat
        elif len(d) == 0:
            stat = 'Reklamacja o podanym kluczu nie istnieje.'

    if stat == 'OK':
        DELETE = "DELETE FROM rs_reklamacje"
        DELETE += " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        DELETE += " AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat, d, dump, dump = self.PolSQL.Execute(DELETE, 1)
        if stat != 'OK':
            stat = 'Reklamacja uywana w innych tabelach. Usunicie niemoliwe.'

#-------------------------------------------------------------------------------
# ZMIANA KLUCZA (7)
#-------------------------------------------------------------------------------

if Fun == 7 and stat == 'OK':
    if not UprZmianaKlucza or KontrahentOp != '':
        stat = 'UPR ZM KLUCZA'

    if stat == 'OK':
        sql = "SELECT data,numer FROM rs_reklamacje"
        sql += " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        # jr if KontrahentOp != '':  #WS 2020-10-25
        #    sql+=" AND kontrahent_id='"+KontrahentOp+"'"
        sql += " AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat, d, dump ,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o reklamacji: '+stat
        elif len(d) == 0:
            stat = 'Reklamacja o podanym kluczu nie istnieje.'

    if stat == 'OK':
        sql = "SELECT data,numer FROM rs_reklamacje"
        sql += " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql += " AND data='"+DataN+"' AND numer="+str(NumerN)+";"
        stat, d, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o reklamacji: '+stat
        elif len(d) > 0:
            stat = 'Reklamacja o podanym kluczu ju istnieje. Zmiana klucza niemoliwa.'

    if stat == 'OK':
        UPD = "UPDATE rs_reklamacje SET data_modyfikacji=NOW()::DATE,data='"+DataN+"',numer="+str(NumerN)
        UPD += " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        UPD += " AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat, dump, dump, dump = self.PolSQL.Execute(UPD,1)
        if stat != 'OK':
            stat = 'Bd zmiany klucza reklamacji: '+stat

#-------------------------------------------------------------------------------
# WYGENEROWANIE PDF ARKUSZA REKLAMACJI 8 (wydruk) ,9 (mail - rozpatrywanie), 10 (mail uznany), 11 (mail nieuznany)
#-------------------------------------------------------------------------------

if Fun in [8,9,10,11] and stat == 'OK':
    stat, Dane, dump, dump=self.WykonajFunkcje('fs_wydruki_reklamacja',[Data,Numer, Oddzial],[],[],False)  #AB 05.02.21r dodany arg. oddzial
    
    if stat == "OK":
        if len(Dane)==0:
            stat = 'Nie istnieje reklamacja o podanym kluczu'

    if stat == 'OK':
        CzyKonsumencka=Dane[0][0];           NrDok=Dane[0][1];                  FormaZgl=Dane[0][2]
        DataDost=Dane[0][3];                 NazwaArt=Dane[0][4];               IloscDost=Dane[0][5]
        IloscRekl=Dane[0][6];                NrParagonu=Dane[0][7];             Zglaszajacy=Dane[0][8]
        Przyjmujacy=Dane[0][9];              Zastrzezenie=Dane[0][10];          TrybPost=Dane[0][11]
        PrzyczynaNiezg=Dane[0][12];          DzialKoryg=Dane[0][13];            ArkuszNiezg=Dane[0][14]
        SposZalatwienia=Dane[0][15];         InfZwrotna=Dane[0][16];             Kontr=Dane[0][17]
        KontrNazwa=Dane[0][18];
    
        Tresc=[]

        #-------------------------
        # OBRBKA TRECI
        #-------------------------
        
        # nagwek
        Nagl=[]
        
        if CzyKonsumencka:
            Nagl.append([u"ARKUSZ REKLAMACJI KONSUMENCKIEJ WYROBU NIEZGODNEGO"])
            Nagl.append([u"NR "+NrDok+"   (od klienta indywidualnego)"])
        else:
            Nagl.append([u"ARKUSZ REKLAMACJI WYROBU NIEZGODNEGO"])
            Nagl.append([u"NR "+NrDok+"   (od odbiorcw)"])
        

        # Cz przyjmujcego zgoszenie
        Przyjm=[]
        
        Przyjm.append([u"CZʦ UZUPENIANA PRZEZ PRZYJMUJCEGO ZGOSZENIE"])
        Przyjm.append([u"Data zgoszenia: "+Data+u"          Forma zgoszenia: "+FormaZgl])

        if CzyKonsumencka:
            Przyjm.append([u"Data zakupu: "+DataDost])

        Przyjm.append([u"Nazwa towaru: "+NazwaArt])

        if CzyKonsumencka:
            Przyjm.append([u"Ilo: "+str(IloscRekl)+u"          Nr paragonu:"+NrParagonu])
        else:
            Przyjm.append([u"Wielko dostawy: "+str(IloscDost)+u"          Ilo zwrcona:"+str(IloscRekl)])

        Przyjm.append([u"Kontrahent: "+Kontr.strip()+' - '+KontrNazwa])
        Przyjm.append([u"Dane zgaszajcego: "+Zglaszajacy])
        Przyjm.append([u"Informacj przyj: "+Przyjmujacy])
        TekstPrzyj=u"Opis niezgodnoci (krtki opis skadanych zastrzee): "+Zastrzezenie
        LPrzyj=rsglobal.RSTextWrap(TekstPrzyj,80)
        for w in LPrzyj:
            Przyjm.append([w])
        #Przyjm.append([rs_print_util.Paragraf(u"Opis niezgodnoci (krtki opis skadanych zastrzee): "+rsglobal.Dekoduj(Zastrzezenie),'Normal')])
        
        # Cz rozpatrujcego zgoszenie
        Rozpatr=[]
        Licznik=0
        Rozpatr.append([u"CZʦ UZUPENIANA PRZEZ ROZPATRUJCEGO ZGOSZENIE"])
        Rozpatr.append([u"Tryb postpowania: "+TrybPost])
        Rozpatr.append([u"Przyczyna niezgodnoci: Arkusz niezgodnoci "+ArkuszNiezg])
        Rozpatr.append([u"Dziaania korygujce/zapobiegawcze: Arkusz niezgodnoci "+ArkuszNiezg])
        TekstRozp=u"Informacja o sposobie zaatwienia reklamacji: "+SposZalatwienia
        LRozp=rsglobal.RSTextWrap(TekstRozp,80)
        for w in LRozp:
            Licznik+=1
            Rozpatr.append([w])
        #TrescSpZal=u"Informacja o sposobie zaatwienia reklamacji: "+SposZalatwienia
        #Rozpatr.append([rs_print_util.Paragraf(TrescSpZal,'Normal')])
        Rozpatr.append([u""])
        Rozpatr.append([u"Protok sporzdzi: "+('.'*130)])
        Rozpatr.append([u"(Imi, nazwisko, data i podpis)"])
        
        if CzyKonsumencka:
            Rozpatr.append([u"Informacja zwrotna do klienta: "+InfZwrotna])
        
        #-------------------------
        # OBRBKA WIZUALNA
        #-------------------------
        
        # Nagowek
        TNagl=rs_print_util.Table(Nagl)
        TNagl.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
            ('FONT', (0,0), (-1,-1), 'DejaVu-Bold', 12),
            ('ALIGN', (0,0), (-1,-1),'CENTER'),
            ]))

        # Cz przyjmujcego zgoszenie
        KolumnyTabelki=[19*rs_print_util.cm]
        TPrzyjm=rs_print_util.Table(Przyjm,KolumnyTabelki)
        TPrzyjm.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
            ('FONT', (0,0), (-1,-1), 'DejaVu', 10),
            ('ALIGN', (0,0), (-1,-1),'LEFT'),
            ('FONT', (0,0), (0,0), 'DejaVu-Bold', 10),
            ('ALIGN', (0,0), (0,0),'CENTER'),
            ('BOX', (0,1), (-1,-1), 0.25, rs_print_util.colors.black),
            ]))
            
        # Cz rozpatrujcego zgoszenie
        KolumnyTabelki=[19*rs_print_util.cm]
        TRozpatr=rs_print_util.Table(Rozpatr,KolumnyTabelki)
        
        TRozpatr.setStyle(rs_print_util.TableStyle([('TEXTCOLOR',(0,0),(-1,-1),rs_print_util.colors.black),
            ('FONT', (0,0), (-1,-1), 'DejaVu', 10),
            ('ALIGN', (0,0), (-1,-1),'LEFT'),
            ('FONT', (0,0), (0,0), 'DejaVu-Bold', 10),
            ('ALIGN', (0,0), (0,0),'CENTER'),
            ('FONT', (0,6+Licznik), (0,6+Licznik), 'DejaVu', 5),
            ('ALIGN', (0,6+Licznik), (0,6+Licznik),'CENTER'),
            ('BOX', (0,1), (-1,-1), 0.25, rs_print_util.colors.black),
            ]))
        
        # ZOENIE STRONY W CAO
        Tresc.append(TNagl)
        Tresc.append(rs_print_util.Spacer(1,1*rs_print_util.cm))
        Tresc.append(TPrzyjm)
        Tresc.append(rs_print_util.Spacer(1,0.4*rs_print_util.cm))  
        Tresc.append(TRozpatr)
        
        NazwaPliku=tempfile.mktemp('.pdf')
        #AB 13.07.22r dodana zwrotka z ZrobPdf
        stat = rs_print_util.ZrobPdf(self.firma_id,NazwaPliku,'',Tresc,rs_print_util.ZrobNaglowekReportlab,ozdobniki=4,
                             rysujNaKolejnych=rs_print_util.ZrobNaglowekReportlab)
        if stat != 'OK':
            stat = "Wystpi problem podczas generowania pliku w formacie PDF"

#-------------------------------------------------------------------------------
# PRZYGOTOWANIE PLIKU DLA WYDRUKU (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat =='OK':
    stat,dane=fs_pliki_global.PobierzZwyklyPlikZSerwera(NazwaPliku)

#-------------------------------------------------------------------------------
# WYSANIE MAILA Z POWIADOMIENIEM O REKLAMACJI (9,10,11)
#-------------------------------------------------------------------------------

if Fun in [9,10,11] and stat == 'OK':
    # zmiana na rozpatrywany
    if Fun == 9:
        TypPow='RE001'
        Temat="Informacja o rozpoczciu rozpatrywania reklamacji "+Data+"/"+str(Numer)+" z oddziau "+self.oddzial_id
    # zmiana na uznany/nieuznany
    else:
        TypPow='RE002'
        if Fun == 10:
            Temat="Informacja o pozytywnym rozpatrzeniu reklamacji "+Data+"/"+str(Numer)+" z oddziau "+self.oddzial_id
        else:
            Temat="Informacja o negatywnym rozpatrzeniu reklamacji "+Data+"/"+str(Numer)+" z oddziau "+self.oddzial_id
    
    Tresc="W zaczniku znajduje si arkusz zmodyfikowanej reklamacji"
    
    # pobranie adresw na ktre ma to pj dla konkretnego oddziau
    SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND powiadomienie='"+TypPow+"' AND oddzial_id IN ('"+self.oddzial_id+"','**');"
    stat,DPoczta,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
    if stat <> 'OK':    
        stat="Bd pobierania listy kont pocztowych : "+stat
    
    if stat=='OK':
        # wysanie maili
        for mail in DPoczta:
            rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[NazwaPliku],0,self.PolSQL)

    
#-------------------------------------------------------------------------------
# SELECT 5,6,7
#-------------------------------------------------------------------------------

if Fun in (5,6,7) and stat == 'OK':
    Filtr = "r.firma_id='" + self.firma_id + "'"
    
    if DataOdF != '    -  -  ':
        Filtr += " AND r.data>='" + DataOdF + "'"
    if DataDoF != '    -  -  ':
        Filtr += " AND r.data<='" + DataDoF + "'"
    if ZastrzezenieF != '':
        Filtr += " AND r.zastrzezenie='" + ZastrzezenieF + "'"
    #WS 2020-10-25  #JR 2020-12-14
    if KontrahentOp != '':
        Filtr += " AND r.kontrahent_id='" + KontrahentOp + "'"
    else:
        Filtr += " AND r.oddzial_id='" + self.oddzial_id + "'"
    if KontrahentF != '':
        Filtr += " AND r.kontrahent_id='" + KontrahentF + "'"
    if ArtykulF != '':
        Filtr += " AND r.artykul_id='" + ArtykulF + "'"
    if PrzyczynaNiezgodnosciF != '':
        Filtr += " AND r.przyczyna_niezgodnosci='" + PrzyczynaNiezgodnosciF + "'"

    if StanF == 'N':
        Filtr += " AND NOT r.uznana"
    elif StanF == 'U':
        Filtr += " AND r.uznana"
    elif StanF == 'R':
        Filtr += " AND r.uznana IS NULL"
    
    if DataN <> '    -  -  ' and NumerN <> 0:
        # reklamacja ze zmienionym kluczem
        Filtr += " OR (r.firma_id='"+self.firma_id+"' AND r.oddzial_id='"+self.oddzial_id+"'"
        Filtr += " AND data='"+DataN+"' AND r.numer="+str(NumerN)+")"

    # klucze dodane
    for i in xrange(len(Klucze)):
        Filtr += " OR (r.firma_id='"+self.firma_id+"' AND r.oddzial_id='"+self.oddzial_id+"'"
        Filtr += " AND data='"+rsglobal.Dekoduj(Klucze[i][0])+"' AND r.numer="+str(Klucze[i][1])+")"

    #WS 2020-12-21 - oddzial_id
    SELECT ="SELECT r.data,r.numer,r.oddzial_id,"
    SELECT+="COALESCE(r.kontrahent_id||' - '||k.nazwa,''::TEXT),"
    SELECT+=" r.artykul_id||' - '||a.nazwa,"
    # zamiana pola 'uznana' na litere wg schematu:
    # True->U(znana), False->N(ieuznana), NULL->R(ozpatrywana)
    SELECT+=" CASE"
    SELECT+="  WHEN r.uznana IS NULL THEN 'R'::TEXT"
    SELECT+="  WHEN r.uznana THEN 'U'::TEXT"
    SELECT+="  ELSE 'N'::TEXT"
    SELECT+=" END AS wirtualny_stan,r.konsumencka"
    SELECT+=" FROM rs_reklamacje r"
    SELECT+=" LEFT JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
    SELECT+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SELECT+=" WHERE "+Filtr
    SELECT+=" ORDER BY r.numer DESC;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy reklamacji: '+stat

#-------------------------------------------------------------------------------
# KONTRAHENT_ID DLA OPERATORA 12
#-------------------------------------------------------------------------------

if Fun == 12 and stat == 'OK':
    dane = [KontrahentOp]
