
 #!/usr/bin/python
# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_reklamacje.py
# Purpose:     grid reklamacji
#
# Author:      Mariusz Rajfura
# Created:     2012/03/21
# RCS-ID:      $Id: fs_reklamacje.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

"""
027300 - Reklamacje klientw
027310 - Osoby rozpatrujce reklamacje
    027311 - Przegldanie
    027312 - Modyfikacja
027320 - Dodawanie
027330 - Dane osobowe
    027331 - Przegldanie
    027332 - Modyfikacja
027340 - Tre
    027341 - Przegldanie
    027342 - Modyfikacja
027350 - Dodatkowe pytania
    027351 - Przegldanie
    027352 - Modyfikacja
027360 - Przebieg zgoszenia
    027361 - Przegldanie
    027362 - Modyfikacja
027370 - Zamykanie

Funkcje:
5 - pobranie danych
6 - otwieranie
7 - zamykanie
8 - otwieranie z pobraniem danych
9 - zamykanie z pobraniem danych
"""
admin = (self.operator_id == STANDARD_OPERATOR_ID)
Upr                  = admin or (self.oddzial_id, '027300') in self.uprawnienia
UprOsRozpMod         = admin or (self.oddzial_id, '027312') in self.uprawnienia
UprOsRozpPrzegl      = admin or (self.oddzial_id, '027311') in self.uprawnienia or UprOsRozpMod
UprDod               = admin or (self.oddzial_id, '027320') in self.uprawnienia
UprDaneOsMod         = admin or (self.oddzial_id, '027332') in self.uprawnienia
UprDaneosprzegl      = admin or (self.oddzial_id, '027331') in self.uprawnienia or UprDaneOsMod
UprTrescMod          = admin or (self.oddzial_id, '027342') in self.uprawnienia
UprTrescPrzegl       = admin or (self.oddzial_id, '027341') in self.uprawnienia or UprTrescMod
UprDodPytMod         = admin or (self.oddzial_id, '027352') in self.uprawnienia
UprDodPytPrzegl      = admin or (self.oddzial_id, '027351') in self.uprawnienia or UprDodPytMod
UprPrzebiegZglMod    = admin or (self.oddzial_id, '027362') in self.uprawnienia
UprPrzebiegZglPrzegl = admin or (self.oddzial_id, '027361') in self.uprawnienia or UprPrzebiegZglMod
UprZamykanie         = admin or (self.oddzial_id, '027370') in self.uprawnienia
stat = 'OK'
Fun  = -1

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK' and not Upr:
    stat = 'Brak uprawnie do reklamacji klientw'

if stat == 'OK':
    Fun = klucze['Funkcja']
    SlPar = {'zgloszenie_id': [6, 7, 8, 9], 'Kolumny': [1, 3, 5, 8, 9], 'zgloszenia': [1, 3, 5, 8, 9]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_reklamacje_klientow z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK' and Fun in (6, 7, 8, 9):
    zgloszenie_id = klucze['zgloszenie_id']

if stat == 'OK' and Fun in (1, 3, 5, 8, 9):
    Kolumny = 'z.' + ', z.'.join(klucze['Kolumny'])
    Filtry = klucze['Filtry']
    zgloszenia = klucze['zgloszenia']

dane = []
wyn1 = []
wyn2 = []
firma_id = self.firma_id


def Execute(self, zapytanie, tryb):
    rsglobal.ZapiszDoLogow(zapytanie)
    return self.PolSQL.Execute(zapytanie, tryb, CzyDodawacBlad=True)


# -------------------------------------------------------------------------------
# POBRANIE LISTY REKLAMACJI (5)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3, 5, 8, 9):
    where = ''
    where2 = ''
    for klucz, wartosc in Filtry.iteritems():
        if klucz in ('stan', 'forma_zgloszenia'):  # normalne pola tekstowe
            where += " AND z.{klucz}='{wartosc}'".format(**locals())
        else:  # jako ostatnie zakresy
            kolumna = klucz[:-3]
            warunek = klucz[-2:]
            where += " AND z.{kolumna}{znak}'{wartosc}'::DATE {dodatek}".format(znak='<' if warunek == 'do' else '>=',
                                                                                dodatek=" + INTERVAL '1 day'" if warunek == 'do' else '',
                                                                                **locals())
    if zgloszenia:
        zgloszenia = "'" + "','".join(zgloszenia) + "'"
        where2 = " OR (z.firma_id='{firma_id}' AND z.zgloszenie_id IN ({zgloszenia}))".format(**locals())

    if not UprDod:
        where += " AND (rsf_getuserid() = o.operator_id OR p.wprowadzone IS NULL)"


    if where2:
        where += where2

    sql = """SELECT DISTINCT {Kolumny}
     FROM rs_rodo_reklamacje_zgloszenia z
     LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING (firma_id, zgloszenie_id)
     LEFT JOIN rs_rodo_reklamacje_osoby o ON (o.firma_id=z.firma_id AND o.aktywny AND (TRIM(o.oddzial_id) IN ('', '**')
                                                    OR p.oddzial_id=o.oddzial_id OR TRIM(p.oddzial_id) = '') 
                                         )
                                         AND (o.transport AND (p.transport OR p.dalej_transport)
                                           OR o.produkt AND (p.produkt OR p.dalej_produkt)
                                           OR o.obsluga AND (p.obsluga  OR p.dalej_obsluga)
                                           OR o.inne AND (p.inne OR p.dalej_inne))
     WHERE z.firma_id='{firma_id}'
        {where}
     ORDER BY zgloszenie_id DESC
    ;""".format(**locals())
    rsglobal.ZapiszDoLogow(sql)
    stat, dane, dump, dump = Execute(self, sql, 3)
    if stat != 'OK':
        stat = 'Bd pobrania treci reklamacji: ' + stat

# -------------------------------------------------------------------------------
# OTWARCIE ZGLOSZENIA REKLAMACJI (6, 8 - z pobraniem)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (6, 8):
    sql = """SELECT stan FROM rs_rodo_reklamacje_zgloszenia 
             WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};""".format(**locals())
    stat, stan, dump, dump = Execute(self, sql, 3)
    if stat != 'OK' or len(stan) != 1:
        stat = 'Bd sprawdzania stanu reklamacji: ' + stat
    else:
        if len(stan) != 1:
            stat = 'Nie odnaleziono zgoszenia {zgloszenie_id}, prosimy odwiey dane i sprbowa ponownie'\
                .format(**locals())
        else:
            if stan[0][0] != 'Z':
                stat = 'Nie mona otworzy zgoszenia w stanie "{}"'.format(stan[0][0])
            else:
                sql = """UPDATE rs_rodo_reklamacje_zgloszenia
                         SET stan='W'
                         WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};
                      """.format(**locals())
                stat, dump, dump, dump = Execute(self, sql, 1)
                if stat != 'OK':
                    stat = 'Bd otwierania reklamacji: ' + stat


# -------------------------------------------------------------------------------
# ZAMKNIECIE ZGLOSZENIA REKLAMACJI (7, 9 - z pobraniem)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (7, 9):
    sql = """SELECT stan FROM rs_rodo_reklamacje_zgloszenia 
             WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};""".format(**locals())
    stat, stan, dump, dump = Execute(self, sql, 3)
    if stat != 'OK' or len(stan) != 1:
        stat = 'Bd sprawdzania stanu reklamacji: ' + stat
    else:
        if len(stan) != 1:
            stat = 'Nie odnaleziono zgoszenia {zgloszenie_id}, prosimy odwiey dane i sprbowa ponownie'\
                .format(**locals())
        else:
            if stan[0][0] != 'W':
                stat = 'Nie mona zamkn zgoszenia w stanie "{}"'.format(stan[0][0])
            else:
                sql = """UPDATE rs_rodo_reklamacje_zgloszenia
                         SET stan='Z'
                         WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};
                      """.format(**locals())
                stat, dump, dump, dump = Execute(self, sql, 1)
                if stat != 'OK':
                    stat = 'Bd zamykania reklamacji: ' + stat

# -------------------------------------------------------------------------------
# POBRANIE FORM ZGASZANIA REKLAMACJI (15)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (15, ):
    sql = "SELECT kod FROM rs_rodo_reklamacje_forma_zgloszenia WHERE firma_id = '"+self.firma_id+"';"
    stat, dane, dump, dump = Execute(self, sql, 3)
    if stat != 'OK':
        stat = 'Bd pobrania form zgaszania reklamacji: ' + stat
