# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_reklamacje_klientow_dane.py
# Purpose:     edycja pojedynczej reklamacji klienta
# Author:      Aleksander Bargie
# Created:     2020/01/20
# RCS-ID:      $Id: fs_reklamacje_klientow_dane.py $
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2020-07-20 Aleksander Bargie - (11870) Uwagi do reklamacji klientw po spotkaniu
# 2021-06-17 Aleksander Bargie - (12533) zmieni komunikat przy reklamacjach RODO
# 2022-06-21 Aleksander Bargie - (13062) Reklamacje klientw - sprawdzanie uprawnie operatora do pobrania zacznika
# 2022-07-06 Wojciech Skowron   - (13074) E-mail do operatora zgaszajcego reklamacj gdy pojawia si pytanie dod - wycofane
# 2022-07-08 Jan Raburski - (13089) Uporzadkowanie osob do ktorych sa wysylane maile
# 2022-07-19 Aleksander Bargie - (13100) Reklamacje klientw - prawdopodobnie po wysaniu odpowiedzi ostatecznej  okno si psuje
# 2022-08-10 Wojciech Skowron   - (13103) Sprawdzenie adresu e-mail przed wysaniem odpowiedzi ostatecznej
# 2022-08-17 Aleksander Bargie - (13123) Reklamacje RODO - bd wysyania odpowiedzi ostatecznej
# 2022-09-22 Wojciech Skowron   - (13103) Poprawki
# 2022-01-09 Aleksander Bargie - (13301) reklamacje klientw - drobne zmiany
# 2023-01-13 Aleksander Bargie - (13308) Reklamacje RODO - kontynuacja
# 2023-01-25 Aleksander Bargie - (13325)  zamknicie ?kontynuacji ? reklamacji nie wysya maili z informacj o jej zamkniciu .
# Aleksander Bargie - 2023-03-30 (13376) - Wysyka SMS za porednictwem modemu UART

import rsglobal
from funkcje import fs_pliki_global
from funkcje import fs_reklamacje_klientow_pdf as pdf

import os
import re
funkcja = kod_funkcji.co_filename

def AktualizujaOstatniaAktywnosc(self, firma_id, zgloszenie_id):
    sql = """UPDATE rs_rodo_reklamacje_zgloszenia SET ostatnia_aktywnosc=NOW()
             WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}""".format(**locals())
    rsglobal.ZapiszDoLogow(sql)
    stat, dump, dump, dump = self.PolSQL.Execute(sql, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd aktualizacji czasu modyfikacji reklamacji: '+stat
    return stat


def SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id=None, plik_id=None):  #AB 21.06.22r
    uprawnienia = 0
    stat = 'OK'
    if zgloszenie_id is None and plik_id is None:
        stat = u"Nie podano id zgoszenia ani pliku podczas sprawdzania uprawnie"
    elif zgloszenie_id is None:
        sql = """SELECT zgloszenie_id FROM rs_rodo_reklamacje_zgloszenia_zalaczniki
                 WHERE nr_pliku = %s ;"""
        args = [plik_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
        stat, zgl, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobierania numru zgoszenia: '+stat
        elif len(zgl) == 0:
            stat = u'Nie odnaleziono zgoszenia powizanego z plikiem.'
        else:
            zgloszenie_id = zgl[0][0]

    if stat == 'OK':
        sql = """SELECT EXISTS(SELECT z.zgloszenie_id
         FROM rs_rodo_reklamacje_zgloszenia z
         LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING (firma_id, zgloszenie_id)
         LEFT JOIN rs_rodo_reklamacje_osoby o ON (o.firma_id=z.firma_id AND o.aktywny AND (TRIM(o.oddzial_id) IN ('', '**')
                                                        OR p.oddzial_id=o.oddzial_id OR TRIM(p.oddzial_id) = '') 
                                             )
         WHERE z.firma_id='{firma_id}' AND z.zgloszenie_id={zgloszenie_id}
          AND (p.wprowadzone IS NULL OR
            (p.wprowadzone = (SELECT MAX(wprowadzone) FROM rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji
                                      WHERE firma_id=p.firma_id AND zgloszenie_id=p.zgloszenie_id)
            AND ((o.transport AND p.transport)
                   OR (o.produkt AND p.produkt)
                   OR (o.obsluga AND p.obsluga)
                   OR (o.inne AND p.inne))))
            AND (rsf_getuserid() = o.operator_id OR p.wprowadzone IS NULL)) 
        ;""".format(**locals())
        rsglobal.ZapiszDoLogow(sql)
        stat, dane, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd sprawdzania uprawnie do  reklamacji: '+stat
    else:
        uprawnienia = 2 if dane[0][0] else 0
    if stat == 'OK' and uprawnienia == 0:
        sql = """SELECT EXISTS(SELECT z.zgloszenie_id
         FROM rs_rodo_reklamacje_zgloszenia z
         LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING (firma_id, zgloszenie_id)
         LEFT JOIN rs_rodo_reklamacje_osoby o ON (o.firma_id=z.firma_id AND o.aktywny AND (TRIM(o.oddzial_id) IN ('', '**')
                                                        OR p.oddzial_id=o.oddzial_id OR TRIM(p.oddzial_id) = '') 
                                             )
                                         AND (o.transport AND (p.transport OR p.dalej_transport)
                                           OR o.produkt AND (p.produkt OR p.dalej_produkt)
                                           OR o.obsluga AND (p.obsluga  OR p.dalej_obsluga)
                                           OR o.inne AND (p.inne OR p.dalej_inne))
         WHERE z.firma_id='{firma_id}' AND z.zgloszenie_id={zgloszenie_id}
            AND (rsf_getuserid() = o.operator_id OR p.wprowadzone IS NULL)) 
        ;""".format(**locals())
        rsglobal.ZapiszDoLogow(sql)
        stat, dane, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd sprawdzania uprawnie do  reklamacji: '+stat
        else:
            uprawnienia = 1 if dane[0][0] else 0
    return stat, uprawnienia


#AB 2022-07-13 usuniety argument kolumna ktory nie byl wykorzystywany
def PrzygotujListeEmaili(self, firma_id, oddzial_id, warunek):  #JR 22.07.08r
    SQLMAILE = """SELECT email, oddzial_id, produkt, obsluga, transport, inne, glowny
                  FROM rs_rodo_reklamacje_osoby
                  WHERE firma_id='{firma_id}' AND email ~ '[^@]+@[^@]+\\\\.[^@]+' AND aktywny 
                  AND {warunek}
                  AND oddzial_id IN ('{oddzial_id}', '**');""".format(**locals())
    rsglobal.ZapiszDoLogow(SQLMAILE)
    stat, MAILE, dump, dump = self.PolSQL.Execute(SQLMAILE, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobierania listy maili: ' + stat
        return stat, []
    # lista maili do wysylki
    maile = []
    rsglobal.ZapiszDoLogow('MAILE:'+str(MAILE))
    for wiersz in MAILE:  # wskazanie adresata (drugi i kolejny glowny pojda jak cc
        if wiersz[6] and wiersz[1] == oddzial_id:
            maile.append(wiersz[0])
    for wiersz in MAILE:  # reszta jako cc
        if not wiersz[6] or (wiersz[6] and wiersz[1] != oddzial_id):
            maile.append(wiersz[0])
    if maile == []:
        stat = 'Brak osb speniajcych warunki do otrzymania maila.'

    return stat, maile


"""
027300 - Reklamacje klientw
027320 - Dodawanie
027330 - Dane osobowe
    027331 - Przegldanie
    027332 - Modyfikacja
027340 - Tre
    027341 - Przegldanie
    027342 - Modyfikacja
027350 - Dodatkowe pytania
    027351 - Przegldanie
    027352 - Modyfikacja
027360 - Przebieg zgoszenia
    027361 - Przegldanie
    027362 - Modyfikacja
027370 - Zamykanie
"""

stat = 'OK'
firma_id = self.firma_id
Puste = ('', '    -  -  ', None, 'None', 'NULL')
plik_z_configiem = 'rodo.conf'
#AB 2022-07-13
odp_ostateczna_podzial = "##Uwagi dodatkowe"  # trzymac zgodnosc z komunikatem w RSReklamacjeKlientowDane.py
oddzial_id = self.oddzial_id  #AB 2022-08-17

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

#AB 2022-08-17
if stat == 'OK':
    Upr = ((oddzial_id, '027300') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    if not Upr:
        stat = 'Brak uprawnie do reklamacji klientw'

    UprDodawanie      = ((oddzial_id, '027320') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

    UprDaneOsMod      = ((oddzial_id, '027352') in self.uprawnienia or UprDodawanie)
    UprDaneOsPrzegl   = ((oddzial_id, '027351') in self.uprawnienia or UprDaneOsMod)

    UprTrescMod       = ((oddzial_id, '027342') in self.uprawnienia or UprDodawanie)
    UprTrescPrzegl    = ((oddzial_id, '027341') in self.uprawnienia or UprTrescMod)

    UprPrzebiegMod    = ((oddzial_id, '027362') in self.uprawnienia or UprDodawanie)
    UprPrzebiegPrzegl = ((oddzial_id, '027361') in self.uprawnienia or UprPrzebiegMod)

    UprZamykanie      = ((oddzial_id, '027370') in self.uprawnienia or UprDodawanie)
if stat == 'OK':
    Fun   = klucze['Funkcja']
    SlPar = {'naglowek':       [3, ],  'pytania':    [3, ],  'zgloszenie_id':   [3, 5, 11, 21, 31, 36, 41, 51, 53, 61],  #AB 13.01.23r
             'zawartoscPliku': [11, ], 'nazwaPliku': [11, ], 'nr_pliku':        [15, ],
             'pytanie':        [21, ], 'oddzial_id': [31, ], 'dodatkowe_email': [31, ],
             'produkt':        [31, ], 'obsluga':    [31, ], 'transport':       [31, ],
             'inne':           [31, ], 'informacja': [31, ], 'maile':           [36, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji '+funkcja+' z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in (3, ):
        naglowek = klucze['naglowek']
        pytania  = klucze['pytania']
        przebieg = klucze['przebieg']
    if Fun in (3, 5, 11, 21, 31, 36, 41, 51, 53, 61):  #AB 13.01.23r
        zgloszenie_id = klucze['zgloszenie_id']
    if Fun in (11, ):
        zawartoscPliku = klucze['zawartoscPliku']
        nazwaPliku     = klucze['nazwaPliku']
    if Fun in (15, ):
        nr_pliku = klucze['nr_pliku']
    if Fun in (21, ):
        pytanie = klucze['pytanie']
    if Fun in (31, ):
        oddzial_id      = klucze['oddzial_id']
        produkt         = klucze['produkt']
        obsluga         = klucze['obsluga']
        transport       = klucze['transport']
        inne            = klucze['inne']
        informacja      = klucze['informacja']
        dodatkowe_email = klucze['dodatkowe_email']
    if Fun in (36, ):
        maile = klucze['maile']

dane             = []
wyn1             = []
wyn2             = []
Formy            = []
FormyWyn1        = []
Zgloszenie       = []
ZgloszenieWyn1   = []
Pliki            = []
PlikiWyn1        = []
Pytania          = []
PytaniaWyn1      = []
Przebieg         = []
PrzebiegWyn1     = []


# ---------------------------------------------------------------------------------------------------------------------
#                                          1, 3, 5 - Pobranie form
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3, 5, ):
    SQLFormy = """SELECT firma_id, kod, opis, czy_kto_przyjal 
    FROM rs_rodo_reklamacje_forma_zgloszenia 
    WHERE firma_id='{firma_id}';""".format(**locals())
    rsglobal.ZapiszDoLogow(SQLFormy)

    stat, Formy, FormyWyn1, dump = self.PolSQL.Execute(SQLFormy, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania form zgosze: {stat}".format(**locals())


# ---------------------------------------------------------------------------------------------------------------------
#        21, 41, 51 - Pobranie numeru operatora z danymi do wysyki maili podczas kontaktu ze zgaszajcym
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (21, 41, 51, ):
    SQLOPPYT = """SELECT * FROM (SELECT operator_id FROM rs_operatorzy ro WHERE login ='emailreklamacje'
                                    UNION 
                                    SELECT 0) op
                      ORDER BY 1 DESC 
                      LIMIT 1;"""
    rsglobal.ZapiszDoLogow(SQLOPPYT)

    stat, op, dump, dump = self.PolSQL.Execute(SQLOPPYT, 3, CzyDodawacBlad=True)
    if stat != 'OK' or len(op) != 1:
        stat = "Bd pobierania danych do wysyki wiadomoci email: {stat}".format(**locals())
    else:
        mail_operator = op[0][0]


# ---------------------------------------------------------------------------------------------------------------------
#        13, 21, 41, 51 - Pobranie aktualnych danych zgloszenia i informacji o osobie rozpatrujacej reklamacje
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (13, 21, 31, 36, 41, 51):
    SQLDANE = """SELECT *
    FROM rs_rodo_reklamacje_zgloszenia z
    LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING(firma_id, zgloszenie_id)
    WHERE firma_id=%s AND zgloszenie_id=%s
    ORDER BY informacja_kiedy DESC;"""
    args = [firma_id, zgloszenie_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLDANE, args))  #AB 13.01.23r

    stat, dane_zgl, dane_zgl_wyn1, dump = self.PolSQL.Execute(SQLDANE, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych zgoszenia: {stat}".format(**locals())
    else:
        rsglobal.ZapiszDoLogow(dane_zgl)
        rsglobal.ZapiszDoLogow(dane_zgl_wyn1)

        data_zgloszenia = dane_zgl[0][[w[0] for w in dane_zgl_wyn1].index('data_zgloszenia')]
        SQLOSOBA = """SELECT * 
        FROM rs_rodo_reklamacje_osoby 
        WHERE firma_id='{firma_id}' AND operator_id=rsf_getuserid() AND aktywny ;
        """.format(**locals())
        rsglobal.ZapiszDoLogow(SQLOSOBA)
        stat, dane_osoby, dane_osoby_wyn1, dump = self.PolSQL.Execute(SQLOSOBA, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(dane_osoby)
        if stat != 'OK':
            stat = "Bd pobierania informacji o osobie obsugujcej reklamacje: {stat}".format(**locals())
        else:
            if dane_osoby:
                stopka = dane_osoby[0][[w[0] for w in dane_osoby_wyn1].index('stopka')]
            else:
                stopka = ''

# ---------------------------------------------------------------------------------------------------------------------
#                                             1 - Dodanie reklamacji
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, ):
    if not UprDodawanie:
        stat = "Brak uprawnie do dodawania reklamacji."
    else:
        INSERT = """INSERT INTO rs_rodo_reklamacje_zgloszenia (firma_id, zgloszenie_id, stan, data_zgloszenia, 
                                                               ostatnia_aktywnosc, wprowadzil)
        VALUES('{firma_id}', 
               (SELECT COALESCE(max(zgloszenie_id), 0)+1 FROM rs_rodo_reklamacje_zgloszenia WHERE firma_id='{firma_id}'), 
               'W', NOW()::DATE, NOW(), rsf_getuserid());""".format(**locals())
        rsglobal.ZapiszDoLogow(INSERT)

        stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania zgoszenia: {stat}".format(**locals())
        else:
            SQLNumer = """SELECT COALESCE(max(zgloszenie_id), 0) 
            FROM rs_rodo_reklamacje_zgloszenia WHERE firma_id='{firma_id}';""".format(**locals())

            rsglobal.ZapiszDoLogow(SQLNumer)
            stat, Numer, NumerWyn1, dump = self.PolSQL.Execute(SQLNumer, 3, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow("pobrano numer: "+str(Numer))
            if stat != 'OK':
                stat = "Bd pobierania numeru zgoszenia: {stat}".format(**locals())
            else:
                zgloszenie_id = Numer[0][0]

# ---------------------------------------------------------------------------------------------------------------------
#                                             61 - Kontynuacja reklamacji
# ---------------------------------------------------------------------------------------------------------------------
#AB 13.01.23r
if stat == 'OK' and Fun in (61, ):
    if not UprDodawanie:
        stat = "Brak uprawnie do dodawania reklamacji."
    else:
        INSERT = """INSERT INTO rs_rodo_reklamacje_zgloszenia AS z
(firma_id, zgloszenie_id, stan, data_zgloszenia,forma_zgloszenia, zglasza_imie_nazwisko, zglasza_email, zglasza_tel_komorkowy, zglasza_tel_stacjonarny, zglasza_inne, przyjal, wprowadzil, rodo, 
tresc_zgloszenia,
ostatnia_aktywnosc,  rodo_opis)
SELECT firma_id, (SELECT COALESCE(max(zgloszenie_id), 0)+1 FROM rs_rodo_reklamacje_zgloszenia z2 WHERE z2.firma_id=%s),
                        'W',    data_zgloszenia,forma_zgloszenia, zglasza_imie_nazwisko, zglasza_email, zglasza_tel_komorkowy, zglasza_tel_stacjonarny, zglasza_inne, przyjal, rsf_getuserid(), rodo, 
'Kontynuacja reklamacji nr '|| zgloszenie_id || ' z dnia ' || data_zgloszenia ||'\r\n'|| tresc_zgloszenia || '\r\nUdzielono odpowiedzi dnia ' || rozpatrzone::DATE || '\r\n' || tresc_odpowiedzi,
NOW(), rodo_opis
FROM rs_rodo_reklamacje_zgloszenia where firma_id = %s and zgloszenie_id = %s
;"""

        args = [firma_id, firma_id, zgloszenie_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSERT, args))

        stat, dump, dump, dump = self.PolSQL.Execute(INSERT, 1, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania zgoszenia: {stat}".format(**locals())
        else:
            SQLNumer = """SELECT COALESCE(max(zgloszenie_id), 0) 
            FROM rs_rodo_reklamacje_zgloszenia WHERE firma_id='{firma_id}';""".format(**locals())

            rsglobal.ZapiszDoLogow(SQLNumer)
            stat, Numer, NumerWyn1, dump = self.PolSQL.Execute(SQLNumer, 3, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow("pobrano numer: "+str(Numer))
            if stat != 'OK':
                stat = "Bd pobierania numeru zgoszenia: {stat}".format(**locals())
            else:
                dane = Numer[0][0]
        #AB 25.01.23r
        if stat == 'OK':
            SQLPRZEB = """SELECT p.oddzial_id, p.inne, p.transport, p.obsluga, p.produkt
                        FROM rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p
                        WHERE firma_id=%s AND zgloszenie_id=%s
                        ORDER BY p.informacja_kiedy DESC
                        LIMIT 1;"""
            args = [firma_id, zgloszenie_id]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLPRZEB, args))

            stat, ZGL, dump, dump = self.PolSQL.Execute(SQLPRZEB, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd podczas sprawdzania danych: {stat}".format(**locals())
            elif not ZGL:
                stat = "Nie odnaleziono zgoszenia {}".format(zgloszenie_id)
            else:
                wiersz = ZGL[0]
                oddzial_id, inne, transport, obsluga, produkt = wiersz

        if stat == 'OK':
            INSPRZEBIEG = """INSERT INTO rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji
                                      (firma_id,    zgloszenie_id, wprowadzone,  oddzial_id,    produkt,   obsluga,   transport,   inne,   
                                      informacja_kto, informacja_kiedy)
                                VALUES(%s,           %s,             NOW(),    %s,              %s,         %s,         %s,         %s, 
                                      rsf_getuserid(),       NOW());"""

            args = [firma_id, dane, oddzial_id, produkt, obsluga, transport, inne]
            args = [str(x) if isinstance(x, basestring) else x for x in args]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSPRZEBIEG, args))
            stat, dump, dump, dump = self.PolSQL.Execute(INSPRZEBIEG, 1, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u'Bd wprowadzania przekazania: ' + stat

# ---------------------------------------------------------------------------------------------------------------------
#                                          3 - Aktualizacja danych reklamacji
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."
    if stat == 'OK':
        if not UprTrescMod:
            stat = "Brak uprawnie do edycji reklamacji."
        else:
            if naglowek:  #AB 2022-07-13
                if 'tresc_odpowiedzi' in naglowek and odp_ostateczna_podzial.upper() not in naglowek['tresc_odpowiedzi'].upper():
                    stat = "Brak tekstu '{}' w odpowiedzi ostateczniej".format(odp_ostateczna_podzial)
                if stat == 'OK':
                    for k in naglowek:  #AB 19.07.22
                        if isinstance(naglowek[k], basestring):
                            naglowek[k] = rsglobal.Dekoduj(naglowek[k]).replace("\\", "\\\\").replace("'", "\\\'")
                    UPDATENAGLOWEK = "UPDATE rs_rodo_reklamacje_zgloszenia SET "+\
                                     ', '.join(["{}={}".format(k, 'NULL' if v == '    -  -  ' else "'"+str(v)+"'") for k, v in naglowek.iteritems()])+\
                                     ", ostatnia_aktywnosc=NOW() WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};".format(**locals())

                    # UPDATENAGLOWEK = UPDATENAGLOWEK.format(**locals())  #WS 2022-09-22 - przeniesienie .format wyej
                    rsglobal.ZapiszDoLogow(UPDATENAGLOWEK)
                    stat, dump, dump, dump = self.PolSQL.Execute(UPDATENAGLOWEK, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd aktualizacji zgoszenia: {stat}".format(**locals())
            if stat == 'OK':
                UPDATEPYTANIA  = ''
                UPDATEPRZEBIEG = ''
                INSPYTANIA     = ''
                for pytanie in pytania:
                    for k in pytanie:  #AB 19.07.22
                        if isinstance(pytanie[k], basestring):
                            pytanie[k] = rsglobal.Dekoduj(pytanie[k]).replace("\\", "\\\\").replace("'", "\\\'")
                    if pytanie['pytanie_kiedy'] in Puste:
                        tresc = pytanie['pytanie']
                        INSPYTANIA = """INSERT INTO rs_rodo_reklamacje_zgloszenia_pytania_dodatkowe 
                                        ( firma_id,     zgloszenie_id,   pytanie, pytanie_kiedy, pytanie_kto)
                                        VALUES
                                        ('{firma_id}', {zgloszenie_id}, '{tresc}',  NOW(),     rsf_getuserid()); """
                        INSPYTANIA = INSPYTANIA.format(**locals())

                    else:
                        UPDATEPYTANIA += "UPDATE rs_rodo_reklamacje_zgloszenia_pytania_dodatkowe SET "+\
                                         "odpowiedz='"+pytanie['odpowiedz']+"'" \
                                         ", odpowiedz_kiedy=NOW(), odpowiedz_kto=rsf_getuserid()" \
                                         " WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}" \
                                         "AND pytanie_kiedy='"+pytanie['pytanie_kiedy']+"'; "
                        UPDATEPYTANIA = UPDATEPYTANIA.format(**locals())

                for przystanek in przebieg:
                    for k in przystanek:  #AB 19.07.22
                        if isinstance(przystanek[k], basestring):
                            przystanek[k] = rsglobal.Dekoduj(przystanek[k]).replace("\\", "\\\\").replace("'", "\\\'")
                    UPDATEPRZEBIEG += "UPDATE rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji SET "+\
                                     "informacja='"+przystanek['informacja']+"'" \
                                     ", informacja_kiedy=NOW(), informacja_kto=rsf_getuserid()" \
                                     " WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id} " \
                                     "AND to_char(wprowadzone, 'YYYY-MM-DD HH24:MI:SS')='"+przystanek['wprowadzone']+"';"
                    UPDATEPRZEBIEG = UPDATEPRZEBIEG.format(**locals())

                SQL = INSPYTANIA+UPDATEPYTANIA+UPDATEPRZEBIEG

                if SQL:
                    rsglobal.ZapiszDoLogow(SQL)
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd aktualizacji pyta: {stat}".format(**locals())
            if stat == 'OK' and not naglowek:
                stat = AktualizujaOstatniaAktywnosc(self, firma_id, zgloszenie_id)

# ---------------------------------------------------------------------------------------------------------------------
#                                             11 - Dodanie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (11, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."
    if stat == 'OK':
        if not UprTrescMod:
            stat = "Brak uprawnie do modyfikacji zgoszenia."
        else:
            INSPLIKI = """INSERT INTO rs_pliki (  firma_id,    nazwa,   tabela,            kompresja)
                          VALUES ('{firma_id}','{nazwaPliku}','rs_rodo_reklamacje_zgloszenia_zalaczniki', FALSE);""".format(**locals())
            rsglobal.ZapiszDoLogow(INSPLIKI)
            stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd dodawania pliku: {stat}".format(**locals())
            else:
                SQLNumerPliku = """SELECT max(plik_id) 
                                   FROM rs_pliki 
                                   WHERE firma_id='{firma_id}' AND tabela='rs_rodo_reklamacje_zgloszenia_zalaczniki';""".format(**locals())
                rsglobal.ZapiszDoLogow(SQLNumerPliku)
                stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrp))
                if stat != 'OK':
                    stat = "Bd pobierania numeru zaczonika: {stat}".format(**locals())
                else:
                    NumerPliku = nrp[0][0]
                    stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, zawartoscPliku)

                    if stat != 'OK':
                        stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())
                    else:
                        INSZALACZNIKI = """INSERT INTO rs_rodo_reklamacje_zgloszenia_zalaczniki
                                                  (  firma_id,    zgloszenie_id,    nr_pliku,          opis  )
                                            VALUES ('{firma_id}','{zgloszenie_id}','{NumerPliku}','{nazwaPliku}');""".format(**locals())

                        rsglobal.ZapiszDoLogow(INSZALACZNIKI, 5)
                        stat, dump, dump, dump = self.PolSQL.Execute(INSZALACZNIKI, 1, CzyDodawacBlad=True)
                        if stat != 'OK':
                            stat = 'Bd dodawania rekordu o nowym pliku: '+stat
                        else:
                            dane = [{'nr_pliku': NumerPliku}]
                            if stat == 'OK':
                                stat = AktualizujaOstatniaAktywnosc(self, firma_id, zgloszenie_id)


# ---------------------------------------------------------------------------------------------------------------------
#                                             15 - Pobranie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (15, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, plik_id=nr_pliku)  #AB 21.06.22r
        if stat == 'OK' and upr == 0:
            stat = "Brak uprawnie do reklamacji."

    if stat == 'OK':
        stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, nr_pliku)
        dane = [Tresc]

# ---------------------------------------------------------------------------------------------------------------------
#                                           21 - Wysanie pytania
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (21, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."

    if stat == 'OK':
        if not UprTrescMod:
            stat = "Brak uprawnie do modyfikacji zgoszenia."
        else:
            SQLKONTAKTPYT = """SELECT zglasza_email, zgloszenie_id, data_zgloszenia, zglasza_tel_komorkowy
                                   FROM rs_rodo_reklamacje_zgloszenia 
                                   WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};""".format(**locals())
            rsglobal.ZapiszDoLogow(SQLKONTAKTPYT)

            stat, KONTAKTPYT, dump, dump = self.PolSQL.Execute(SQLKONTAKTPYT, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobierania adresu email: {stat}".format(**locals())
            elif not KONTAKTPYT:
                stat = "Nie odnaleziono zgoszenia {}".format(zgloszenie_id)
            else:
                wysylka = 'mail'
                if KONTAKTPYT[0][0] in ('', 'None', None, 'NULL'):
                    if KONTAKTPYT[0][3] in ('', 'None', None, 'NULL'):
                        #WS 2022-09-22
                        stat = 'Do wysania przez system pytania dodatkowego potrzebny jest poprawny adres e-mail bd telefon komrkowy'
                        # stat = 'W zgoszeniu nie ma ani adresu e-mail, ani numeru telefonu komrkowego do kontaktu.'
                        wysylka = 'nic'
                    else:
                        wysylka = 'sms'

                if wysylka == 'mail':
                    Temat = "Pytanie dotyczce reklamacji nr {nr} z {data}".format(nr=KONTAKTPYT[0][1], data=KONTAKTPYT[0][2])
                    Tresc = pytanie+'\n'+stopka
                    #WS 2022-08-10
                    if not rsglobal.SprawdzAdresEmail(KONTAKTPYT[0][0]):
                        stat = 'Nieprawidowy adres e-mail.'
                    else:
                        stat = rsglobal.RSWyslijEmail(KONTAKTPYT[0][0], Temat, Tresc, [], mail_operator, self.PolSQL)
                        if stat != 'OK':
                            rsglobal.ZapiszDoLogow(stat)
                elif wysylka == 'sms':
                    stat = rsglobal.WyslijSms(KONTAKTPYT[0][3], pytanie, self.firma_id, self.PolSQL, funkcja)  #AB 23.03.23r

            # if stat == 'OK':
                #WS 2022-07-06
            #     op = KONTAKTPYT[0][4]
            #     SEL = """SELECT imie, nazwisko, email FROM rs_operatorzy
            #              WHERE operator_id={op};""".format(**locals())
            #     stat, d, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
            #     if stat != 'OK':
            #         stat = 'Bd pobrania adresu e-mail operatora zgaszajcego reklamacj: {stat}'.format(**locals())
            #     else:
            #         imie = d[0][0].strip()
            #         nazwisko = d[0][1].strip()
            #         email = d[0][2].strip()
            #         if email != '':
            #             stat = rsglobal.RSWyslijEmail(email, 'Dodano wpis do reklamacji {nr} z {data}'.format(nr=KONTAKTPYT[0][1], data=KONTAKTPYT[0][2]),
            #                                           'Pytanie dodatkowe: '+pytanie+'\n'+'Wpisu dokona/a '+imie+' '+nazwisko,
            #                                           [], 0, polsql=self.PolSQL)
            #             if stat != 'OK':
            #                 stat = 'Bd podczas wysyania wiadomoci e-mail: '+stat
            #                 rsglobal.ZapiszDoLogow(stat)

            if stat == 'OK':
                INSERTMAIL = """INSERT INTO rs_rodo_reklamacje_zgloszenia_pytania_dodatkowe 
                                ( firma_id,     zgloszenie_id,   pytanie, pytanie_kiedy, pytanie_kto)
                                VALUES
                                ('{firma_id}', {zgloszenie_id}, '{pytanie}',  NOW(),     rsf_getuserid())"""
                INSERTMAIL = INSERTMAIL.format(**locals())
                stat, dump, dump, dump = self.PolSQL.Execute(INSERTMAIL, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Wysano pytanie, ale nie powioda si aktualizacja danych w systemie: '+stat

                if stat == 'OK':
                    stat = AktualizujaOstatniaAktywnosc(self, firma_id, zgloszenie_id)

# ---------------------------------------------------------------------------------------------------------------------
#                                           31 - Przekazywanie zgoszenia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (31, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."
    if stat == 'OK':
        if not UprPrzebiegMod:
            stat = u"Brak uprawnie do przekazywania zgoszenia."
        #  elif informacja.strip() == '':
        #      stat = "Nie wpisano odpowiedzi w przekazaniu."
        else:
            UPDPRZEBIEG = """UPDATE rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji
                             SET dalej_produkt={produkt}, dalej_obsluga={obsluga}, dalej_transport={transport}, dalej_inne={inne}, 
                                 dalej_oddzial_id='{oddzial_id}'
                             WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id} 
                                 AND informacja_kiedy=(SELECT max(informacja_kiedy) 
                                                       FROM rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji 
                                                       WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id});""".format(**locals())

    INSPRZEBIEG = """INSERT INTO rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji
                              (firma_id,    zgloszenie_id, wprowadzone,  oddzial_id,    produkt,   obsluga,   transport,   inne,   informacja,   
                              informacja_kto, informacja_kiedy,  dodatkowe_email)
                      VALUES('{firma_id}', {zgloszenie_id},   NOW(),    '{oddzial_id}', {produkt}, {obsluga}, {transport}, {inne}, '{informacja}', 
                              rsf_getuserid(),       NOW(),    '{dodatkowe_email}');""".format(**locals())

    rsglobal.ZapiszDoLogow(INSPRZEBIEG)
    rsglobal.ZapiszDoLogow(UPDPRZEBIEG)
    stat, dump, dump, dump = self.PolSQL.Execute(UPDPRZEBIEG+INSPRZEBIEG, 1, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = u'Bd wprowadzania przekazania: '+stat
    if stat == 'OK':
        stat = AktualizujaOstatniaAktywnosc(self, firma_id, zgloszenie_id)

        # rozeslanie maili
        if stat == 'OK':
            #JR 2022-07-08 (13089)
            #warunki = ['FALSE']
            #if produkt:
            #    warunki.append('produkt')
            #if inne:
            #    warunki.append('inne')
            #if obsluga:
            #    warunki.append('obsluga')
            #if transport:
            #    warunki.append('transport')
            #warunki = ' OR '.join(warunki)
            #SQLMAILE = """SELECT email
            #              FROM rs_rodo_reklamacje_osoby
            #              WHERE firma_id='{firma_id}' AND email ~ '[^@]+@[^@]+\\\\.[^@]+' AND aktywny
            #              AND ({warunki})
            #              AND (oddzial_id IN ('', '{oddzial_id}', '**') OR '{oddzial_id}'='' );""".format(**locals())
            #rsglobal.ZapiszDoLogow(SQLMAILE)
            #stat, MAILE, dump, dump = self.PolSQL.Execute(SQLMAILE, 3, CzyDodawacBlad=True)
            #if stat != 'OK':
            #    stat = 'Bd pobierania listy maili: '+stat
            #else:
            #    # lista maili do wysylki
            #    maile = []
            #    rsglobal.ZapiszDoLogow(MAILE)
            #    for wiersz in MAILE:
            #        maile.append(wiersz[0])
            #    for mail in dodatkowe_email.split(','):
            #        if mail.strip():
            #            maile.append(mail.strip())
            #    # tworzenie pdfa
            #    if maile:
            #        PDF = pdf.ReklamacjeKilentowPDF(selfSerwera=self, ZgloszenieID=zgloszenie_id)
            #        rsglobal.ZapiszDoLogow(self.KatalogPlikow)
            #        stat, plik = PDF.GenerujPDFZeStanemZgloszenia()
            #        rsglobal.ZapiszDoLogow(stat)
            #        rsglobal.ZapiszDoLogow(plik)
            #        if stat != ['OK']:
            #            stat = "\n".join(stat)
            #        else:
            #            stat = 'OK'
            #        rsglobal.ZapiszDoLogow(maile)
            #        if stat == 'OK':
            #            Temat = "Przekazano reklamacj nr {zgloszenie_id} z {data_zgloszenia}".format(**locals())
            #            Tresc = "W zaczniku PDF z przebiegiem reklamacji."
            #            stat = rsglobal.RSWyslijEmail(maile[0], Temat, Tresc, [plik], 0, self.PolSQL, cc=', '.join(maile[1:]))
            if produkt or obsluga or transport or inne:
                # tworzenie pdfa
                PDF = pdf.ReklamacjeKilentowPDF(selfSerwera=self, ZgloszenieID=zgloszenie_id)
                rsglobal.ZapiszDoLogow(self.KatalogPlikow)
                stat, plik = PDF.GenerujPDFZeStanemZgloszenia()
                rsglobal.ZapiszDoLogow(stat)
                rsglobal.ZapiszDoLogow(plik)
                if stat != ['OK']:
                    stat = "\n".join(stat)
                else:
                   stat = 'OK'
                if stat == 'OK':
                    Temat = "Przekazano reklamacj nr {zgloszenie_id} z {data_zgloszenia}".format(**locals())
                    Tresc = "W zaczniku PDF z przebiegiem reklamacji."
            mailedod = []
            for mail in dodatkowe_email.split(','):
                if mail.strip():
                    mailedod.append(mail.strip())

            if mailedod != []:
                stat = rsglobal.RSWyslijEmail(mailedod[0], Temat, Tresc, [plik], 0, self.PolSQL, cc=', '.join(mailedod[1:]))
            else:
                if oddzial_id.strip() == '':
                    oddzial_id = '**'
                if stat == 'OK' and produkt:
                    stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial_id, 'produkt')
                    if stat == 'OK':
                        stat = rsglobal.RSWyslijEmail(maile[0], Temat, Tresc, [plik], 0, self.PolSQL, cc=', '.join(maile[1:]))

                if stat == 'OK' and obsluga:
                    stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial_id, 'obsluga')
                    if stat == 'OK':
                        stat = rsglobal.RSWyslijEmail(maile[0], Temat, Tresc, [plik], 0, self.PolSQL, cc=', '.join(maile[1:]))

                if stat == 'OK' and transport:
                    stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial_id, 'transport')
                    if stat == 'OK':
                        stat = rsglobal.RSWyslijEmail(maile[0], Temat, Tresc, [plik], 0, self.PolSQL, cc=', '.join(maile[1:]))

                if stat == 'OK' and inne:
                    stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial_id, 'inne')
                    if stat == 'OK':
                        stat = rsglobal.RSWyslijEmail(maile[0], Temat, Tresc, [plik], 0, self.PolSQL, cc=', '.join(maile[1:]))


# ---------------------------------------------------------------------------------------------------------------------
#                                         41 - Wysanie informacji o RODO
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (41, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."

    if stat == 'OK':
        if not UprTrescMod:
            stat = "Brak uprawnie do modyfikacji zgoszenia."
        else:
            SQLKONTAKTPYT = """SELECT zglasza_email, data_zgloszenia, rodo_opis, zglasza_tel_komorkowy
                                   FROM rs_rodo_reklamacje_zgloszenia 
                                   WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};""".format(**locals())
            rsglobal.ZapiszDoLogow(SQLKONTAKTPYT)

            stat, KONTAKTPYT, dump, dump = self.PolSQL.Execute(SQLKONTAKTPYT, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobierania adresu email: {stat}".format(**locals())
            elif not KONTAKTPYT:
                stat = "Nie odnaleziono zgoszenia {}".format(zgloszenie_id)
            else:
                wysylka = 'mail'
                if KONTAKTPYT[0][0] in ('', 'None', None, 'NULL'):
                    if KONTAKTPYT[0][3] in ('', 'None', None, 'NULL'):
                        #WS 2022-08-10
                        stat = 'Do wysania przez system informacji o RODO potrzebny jest poprawny adres e-mail bd telefon komrkowy'
                        # stat = 'W zgoszeniu nie ma ani adresu e-mail, ani numeru telefonu komrkowego do kontaktu.'
                        wysylka = 'nic'
                    else:
                        wysylka = 'sms'

                if wysylka == 'mail':
                    Temat = "Potwierdzenie przyjcia reklamacji"  #AB 17.06.21r
                    Tresc = KONTAKTPYT[0][2]+'\n'+stopka
                    #WS 2022-08-10
                    if not rsglobal.SprawdzAdresEmail(KONTAKTPYT[0][0]):
                        stat = 'Nieprawidowy adres e-mail.'
                    else:
                        stat = rsglobal.RSWyslijEmail(KONTAKTPYT[0][0], Temat, Tresc, [], mail_operator, self.PolSQL)
                        if stat != 'OK':
                            rsglobal.ZapiszDoLogow(stat)
                elif wysylka == 'sms':
                    stat = rsglobal.WyslijSms(KONTAKTPYT[0][3], KONTAKTPYT[0][2], self.firma_id, self.PolSQL, funkcja)  #AB 23.03.23r

            if stat == 'OK':
                SQLRODO = """UPDATE rs_rodo_reklamacje_zgloszenia SET rodo=TRUE, ostatnia_aktywnosc=NOW() 
                WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}""".format(**locals())
                stat, dump, dump, dump = self.PolSQL.Execute(SQLRODO, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Wysano informacj o RODO, ale nie powioda si aktualizacja danych w systemie: '+stat

# ---------------------------------------------------------------------------------------------------------------------
#                                         51 - Wysanie odpowiedzi ostatecznej
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (51, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."

    if stat == 'OK':
        if not UprZamykanie:
            stat = "Brak uprawnie do zamykania zgoszenia."
        else:
            SQLODP = """SELECT rodo, zglasza_email, data_zgloszenia, tresc_odpowiedzi, zglasza_tel_komorkowy, 
                            p.oddzial_id, p.inne, p.transport, p.obsluga, p.produkt, dodatkowe_email
                        FROM rs_rodo_reklamacje_zgloszenia 
                        LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING(firma_id, zgloszenie_id)
                        WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}
                        ORDER BY p.informacja_kiedy DESC
                        LIMIT 1;""".format(**locals())  #AB 2022-07-13
            rsglobal.ZapiszDoLogow(SQLODP)

            stat, ZGL, dump, dump = self.PolSQL.Execute(SQLODP, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd podczas sprawdzania danych: {stat}".format(**locals())
            elif not ZGL:
                stat = "Nie odnaleziono zgoszenia {}".format(zgloszenie_id)
            elif ZGL[0][0] in Puste or not ZGL[0][0] or ZGL[0][0] == 'FALSE':
                stat = "W zgoszeniu nie wyraono zgody na przetwarzanie danych."
            elif odp_ostateczna_podzial.strip() in Puste:  #AB 2022-07-13
                stat = "Brak odpowiedzi ostatecznej"
            elif odp_ostateczna_podzial.lower() not in ZGL[0][3].lower():  #AB 2022-07-13
                stat = "W odpowiedzi brakuje tekstu '{}'".format(odp_ostateczna_podzial)
            else:
                wysylka = 'mail'
                if ZGL[0][1] in ('', 'None', None, 'NULL'):
                    wysylka = 'sms'
                    if ZGL[0][4] in ('', 'None', None, 'NULL'): #AB 2022-08-17
                        stat = 'W zgoszeniu nie ma ani adresu e-mail, ani numeru telefonu komrkowego do kontaktu.'
                #WS 2022-08-10

                if wysylka == 'mail':   #AB 2022-08-17
                    if not rsglobal.SprawdzAdresEmail(ZGL[0][1]):
                        stat = 'Nieprawidowy adres e-mail.'

                if stat == 'OK':
                    #AB 2022-07-13
                    do_zglaszajacego, do_ostatniego_dzialu = re.split(odp_ostateczna_podzial, ZGL[0][3], re.IGNORECASE)
                    do_zglaszajacego = do_zglaszajacego.strip()
                    do_ostatniego_dzialu = do_ostatniego_dzialu.strip()

                    rsglobal.ZapiszDoLogow("Bedziemy zamykac")
                    if wysylka == 'mail':
                        Temat = "Rozpatrzenie reklamacji nr " \
                                "{zgloszenie_id} z {data}".format(data=ZGL[0][2], **locals())
                        Tresc = do_zglaszajacego+'\n'+stopka
                        stat = rsglobal.RSWyslijEmail(ZGL[0][1], Temat, Tresc, [], mail_operator, self.PolSQL)
                        if stat != 'OK':
                            rsglobal.ZapiszDoLogow(stat)
                    elif wysylka == 'sms':
                        stat = rsglobal.WyslijSms(ZGL[0][4], do_zglaszajacego, self.firma_id, self.PolSQL, funkcja)  #AB 23.03.23r

                    if do_ostatniego_dzialu not in Puste:  #AB 2022-07-13
                        oddzial         = ZGL[0][5]
                        inne            = ZGL[0][6]
                        transport       = ZGL[0][7]
                        obsluga         = ZGL[0][8]
                        produkt         = ZGL[0][9]
                        dodatkowe_email = ZGL[0][10]
                        Temat = "Rozpatrzenie reklamacji  nr " \
                                "{zgloszenie_id} z {data}".format(data=ZGL[0][2], **locals())

                        mailedod = []
                        for mail in dodatkowe_email.split(','):
                            if mail.strip() not in Puste:
                                mailedod.append(mail.strip())
                        rsglobal.ZapiszDoLogow("Wysyka maili dodatkowych do: {} (do_ostatniego_dzialu)".format(mailedod), 1)
                        rsglobal.ZapiszDoLogow("produkt {produkt}, obsluga {obsluga}, transport {transport}, inne {inne}".format(**locals()), 1)
                        if mailedod != []:
                            stat = rsglobal.RSWyslijEmail(mailedod[0], Temat, do_ostatniego_dzialu, [], 0, self.PolSQL, cc=', '.join(mailedod[1:]))
                        else:
                            if oddzial.strip() == '':
                                oddzial = '**'   #AB 2022-08-17 wszedzie oddzial_id na oddzial
                            if stat == 'OK' and produkt:
                                stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial, 'produkt')
                                if stat == 'OK':
                                    stat = rsglobal.RSWyslijEmail(maile[0], Temat, do_ostatniego_dzialu, [], 0, self.PolSQL, cc=', '.join(maile[1:]))

                            if stat == 'OK' and obsluga:
                                stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial, 'obsluga')
                                if stat == 'OK':
                                    stat = rsglobal.RSWyslijEmail(maile[0], Temat, do_ostatniego_dzialu, [], 0, self.PolSQL, cc=', '.join(maile[1:]))

                            if stat == 'OK' and transport:
                                stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial, 'transport')
                                if stat == 'OK':
                                    stat = rsglobal.RSWyslijEmail(maile[0], Temat, do_ostatniego_dzialu, [], 0, self.PolSQL, cc=', '.join(maile[1:]))

                            if stat == 'OK' and inne:
                                stat, maile = PrzygotujListeEmaili(self, self.firma_id, oddzial, 'inne')
                                if stat == 'OK':
                                    stat = rsglobal.RSWyslijEmail(maile[0], Temat, do_ostatniego_dzialu, [], 0, self.PolSQL, cc=', '.join(maile[1:]))

            if stat == 'OK':
                SQLRODO = """UPDATE rs_rodo_reklamacje_zgloszenia SET rozpatrzone=NOW(), stan='Z', data_zamkniecia=NOW()::DATE, ostatnia_aktywnosc=NOW()
                WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}""".format(**locals())
                rsglobal.ZapiszDoLogow(SQLRODO)
                stat, dump, dump, dump = self.PolSQL.Execute(SQLRODO, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Wysano informacj o RODO, ale nie powioda si aktualizacja danych w systemie: '+stat

# ---------------------------------------------------------------------------------------------------------------------
#                                         53 - Zamkniecie reklamacji
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (53, ):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr < 2:
            stat = "Brak uprawnie do reklamacji."
    if not UprZamykanie:
        stat = "Brak uprawnie do zamykania zgoszenia."
    else:
        SQLODP = """SELECT rodo
                               FROM rs_rodo_reklamacje_zgloszenia 
                               WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id};""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLODP)

        stat, ODP, dump, dump = self.PolSQL.Execute(SQLODP, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd podczas sprawdzania danych: {stat}".format(**locals())
        elif not ODP:
            stat = "Nie odnaleziono zgoszenia {}".format(zgloszenie_id)
        elif ODP[0][0] in Puste or not ODP[0][0] or ODP[0][0] == 'FALSE':
            stat = "W zgoszeniu nie wyraono zgody na przetwarzanie danych."
        if stat == 'OK':
            SQLRODO = """UPDATE rs_rodo_reklamacje_zgloszenia SET rozpatrzone=NOW(), stan='Z', data_zamkniecia=NOW()::DATE, ostatnia_aktywnosc=NOW() 
            WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}""".format(**locals())
            stat, dump, dump, dump = self.PolSQL.Execute(SQLRODO, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd zamykania reklamacji: '+stat

# ---------------------------------------------------------------------------------------------------------------------
#                                              3, 5 - Pobranie danych
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3, 5):
    if not UprDodawanie:
        stat, upr = SprawdzUprawnieniaDoReklamacji(self, firma_id, zgloszenie_id)
        if stat == 'OK' and upr == 0:
            stat = "Brak uprawnie do reklamacji."
    else:
        upr = 2

    if stat == 'OK':

        formulka_rodo = ''
        if os.path.exists(plik_z_configiem):
            with open(plik_z_configiem) as config:
                for line in config:
                    line = unicode(line, 'iso8859-2')
                    if not line.strip().startswith('#'):
                        found = re.findall('^((?:\w|\s)+)=(.*)$', line)
                        if found:
                            for pair in found:
                                if pair[0] == 'tresc_rodo':
                                    formulka_rodo = pair[1]
        warunek = "z.firma_id='{firma_id}' AND z.zgloszenie_id={zgloszenie_id}".format(**locals())
        dane_os = ['zglasza_imie_nazwisko', 'zglasza_email', 'zglasza_tel_komorkowy', 'zglasza_tel_stacjonarny', 'zglasza_inne']
        if UprDaneOsPrzegl:
            dane_os = ", ".join(dane_os)
        else:
            dane_os = "'' as "+(", '' as ".join(dane_os))
        SQLZgloszenie = """SELECT p.oddzial_id, p.inne, p.transport, p.obsluga, p.produkt, zgloszenie_id, stan, data_zgloszenia, 
                               data_zamkniecia, forma_zgloszenia || ' - ' || f.opis AS forma_zgloszenia, {dane_os}, 
                               przyjal, o.imie ||' '||o.nazwisko AS wprowadzil, rodo, tresc_zgloszenia, tresc_odpowiedzi, 
                               z.rozpatrzone, to_char(ostatnia_aktywnosc, 'YYYY-MM-DD HH24:MI:SS') AS ostatnia_aktywnosc, 
                               COALESCE(rodo_opis, 'brak') AS rodo_opis 
                           FROM rs_rodo_reklamacje_zgloszenia z
                           LEFT JOIN rs_operatorzy o on o.operator_id = z.wprowadzil
                           LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING(firma_id, zgloszenie_id)
                           LEFT JOIN rs_rodo_reklamacje_forma_zgloszenia f ON f.firma_id = z.firma_id AND f.kod=z.forma_zgloszenia
                           WHERE {warunek}
                           ORDER BY p.informacja_kiedy DESC
                           LIMIT 1;""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLZgloszenie)
        stat, Zgloszenie, ZgloszenieWyn1, dump = self.PolSQL.Execute(SQLZgloszenie, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobierania danych zgoszenia: {stat}".format(**locals())
        elif len(Zgloszenie) != 1:
            stat = "Nie odnaleziono zgoszenia o numerze {zgloszenie_id}".format(**locals())

        if stat == 'OK' and Zgloszenie[0][-1] == 'brak':
            SQL = "UPDATE rs_rodo_reklamacje_zgloszenia z SET rodo_opis='{formulka_rodo}' WHERE {warunek} ; ".format(**locals())

            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd aktualizacji komunikatu o RODO: {stat}".format(**locals())
            else:
                Zgloszenie[0][-1] = formulka_rodo

        if stat == 'OK':
            SQLPliki = """SELECT z.firma_id, zgloszenie_id, nr_pliku, opis
                          FROM rs_rodo_reklamacje_zgloszenia_zalaczniki z JOIN rs_pliki p ON p.firma_id=z.firma_id  AND p.plik_id=z.nr_pliku 
                          AND p.tabela ='rs_rodo_reklamacje_zgloszenia_zalaczniki'
                          WHERE {warunek};""".format(**locals())

            rsglobal.ZapiszDoLogow(SQLPliki)
            stat, Pliki, PlikiWyn1, dump = self.PolSQL.Execute(SQLPliki, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania plikw dla zgoszenia: {stat}".format(**locals())

        if stat == 'OK':
            SQLPytania = """SELECT firma_id, zgloszenie_id, pytanie, pytanie_kiedy, COALESCE(p.imie||' '||p.nazwisko, '') as pytanie_kto,
                                 odpowiedz, odpowiedz_kiedy, COALESCE(o.imie||' '||o.nazwisko, '') as odpowiedz_kto
                            FROM rs_rodo_reklamacje_zgloszenia_pytania_dodatkowe z
                            LEFT JOIN rs_operatorzy p ON p.operator_id = z.pytanie_kto
                            LEFT JOIN rs_operatorzy o ON o.operator_id = z.odpowiedz_kto
                            WHERE {warunek}
                            ORDER BY pytanie_kiedy ASC;""".format(**locals())

            rsglobal.ZapiszDoLogow(SQLPytania)
            stat, Pytania, PytaniaWyn1, dump = self.PolSQL.Execute(SQLPytania, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania pyta do zgoszenia: {stat}".format(**locals())

        if stat == 'OK' and UprPrzebiegPrzegl:
            SQLPrzebieg = """SELECT firma_id, zgloszenie_id, to_char(wprowadzone, 'YYYY-MM-DD HH24:MI:SS') AS wprowadzone, oddzial_id, produkt, obsluga, transport, inne, 
            informacja, COALESCE(o.imie||' '||o.nazwisko, '') AS informacja_kto, to_char(informacja_kiedy, 'YYYY-MM-DD HH24:MI:SS') AS informacja_kiedy, dalej_produkt, 
            dalej_obsluga, dalej_transport, dalej_inne, dalej_oddzial_id, dodatkowe_email,  rozpatrzone
        FROM rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji z
        LEFT JOIN rs_operatorzy o ON o.operator_id = z.informacja_kto
        WHERE {warunek}
        ORDER BY wprowadzone;""".format(**locals()) # order jest ASC poniewaz dodajac na oknie kolejnosc jest odwracana

            rsglobal.ZapiszDoLogow(SQLPrzebieg)
            stat, Przebieg, PrzebiegWyn1, dump = self.PolSQL.Execute(SQLPrzebieg, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobierania przebiegu zgoszenia: {stat}".format(**locals())

        dane = [{'Formy':      [Formy,      FormyWyn1],
                 'Zgloszenie': [Zgloszenie, ZgloszenieWyn1],
                 'Pliki':      [Pliki,      PlikiWyn1],
                 'Pytania':    [Pytania,    PytaniaWyn1],
                 'Przebieg':   [Przebieg,   PrzebiegWyn1]
                 }]
        wyn2 = upr
