# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_reklamacje_klientow_osoby.py
# Purpose:     Wywietlanie i edycja danych osb rozpatrujcych reklamacje
# Author:      Wojciech Skowron
# Created:     2019/12/19
# RCS-ID:      $Id: fs_reklamacje_klientow_osoby.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2020-02-11 Wojciech Skowron   - (11855) Poprawki
# 2022-07-11 Aleksander Bargie - (13090) [SP] kolumna 'glowny' w rs_rodo_reklamacje_osoby

import rsglobal

"""
027310 - Osoby rozpatrujce reklamacje
    027311 - Przegldanie
    027312 - Modyfikacja
"""

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprMod    = (((self.oddzial_id,'027312') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrzegl = (((self.oddzial_id,'027311') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'BR_UPR_MOD'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            DEL = ''
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_rodo_reklamacje_osoby WHERE firma_id='{}'""".format(self.firma_id)
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"="+str(wart)

                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat = 'BR_UPR_MOD'
            dane.append(stat)

        if stat == 'OK':
            for pola, wartosci, nrWiersza in zip(Update[0], Update[1], Update[-1]):
                for pole, wart in zip(pola, wartosci):
                    if pole == 'oddzial_id':
                        wart = wart.strip()

                        if wart not in ('','**'):
                            SQL = """SELECT oddzial_id FROM rs_oddzialy
                                     WHERE firma_id='{}' AND oddzial_id='{}';""".format(self.firma_id,wart)
                            stat, oddzial, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                wyn2.append((nrWiersza, 1))
                                dane.append('BL_SQL_ODDZIAL$'+stat)
                            elif len(oddzial) == 0:
                                wyn2.append((nrWiersza, 1))
                                dane.append('BL_ODDZIAL$'+wart)
                    elif pole == 'operator_id':
                        wart = wart.strip()

                        if wart in ('','None'):
                            wyn2.append((nrWiersza, 3))
                            dane.append('BR_OPERATOR' + str(wart))
                        else:
                            SQL = """SELECT operator_id FROM rs_operatorzy
                                     WHERE operator_id={};""".format(wart if wart not in ('','None') and wart.isdigit() else 'NULL')
                            stat, operator, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                wyn2.append((nrWiersza, 3))
                                dane.append('BL_SQL_OPERATOR$' + stat)
                            elif len(operator) == 0:
                                wyn2.append((nrWiersza, 3))
                                dane.append('BL_OPERATOR$' + str(wart))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            UPD = ''

            for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
                UPD += "UPDATE rs_rodo_reklamacje_osoby SET "
                for pole, wart in zip(pola, wartosci):
                    if pole != 'osoba_id':
                        if pole == 'operator_id':
                            UPD += pole+"="+str(wart)+","
                        else:
                            UPD += pole+"='"+str(wart).strip()+"',"

                UPD = UPD.strip(",")
                UPD += " WHERE firma_id='"+self.firma_id+"'"

                for pole, wart in zip(Update[3], klucz): # petla po kluczu
                    UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

                UPD += ";"
            if UPD != '':
                rsglobal.ZapiszDoLogow(UPD)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0]) > 0:
        if not UprMod:
            stat = 'BR_UPR_MOD'
            dane.append(stat)

        if stat == 'OK':
            pola = Insert[1]

            for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
                for pole, wart in zip(pola, wartosci):
                    if pole == 'oddzial_id':
                        wart = wart.strip()

                        if wart not in ('', '**'):
                            SQL = """SELECT oddzial_id FROM rs_oddzialy
                                     WHERE firma_id='{}' AND oddzial_id='{}';""".format(self.firma_id, wart)
                            stat, oddzial, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                wyn2.append((nrWiersza, 1))
                                dane.append('BL_SQL_ODDZIAL$' + stat)
                            elif len(oddzial) == 0:
                                wyn2.append((nrWiersza, 1))
                                dane.append('BL_ODDZIAL$' + wart)
                    elif pole == 'operator_id':
                        wart = wart.strip()

                        if wart in ('','None'):
                            wyn2.append((nrWiersza, 3))
                            dane.append('BR_OPERATOR' + str(wart))
                        else:
                            SQL = """SELECT operator_id FROM rs_operatorzy
                                     WHERE operator_id={};""".format(wart if wart not in ('','None') and wart.isdigit() else 'NULL')
                            stat, operator, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                            if stat != 'OK':
                                wyn2.append((nrWiersza, 3))
                                dane.append('BL_SQL_OPERATOR$' + stat)
                            elif len(operator) == 0:
                                wyn2.append((nrWiersza, 3))
                                dane.append('BL_OPERATOR$' + str(wart))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            INS = ''
            pola = Insert[1]

            for wartosci in Insert[0]:
                INSERT  = "INSERT INTO rs_rodo_reklamacje_osoby "
                KOLUMNY = "(firma_id"
                VALUES  = " VALUES ('"+self.firma_id+"'"

                for pole, wart in zip(pola, wartosci):
                    if pole != 'osoba_id':
                        KOLUMNY += ","+pole
                        if pole == 'operator_id':
                            VALUES+=","+str(wart)
                        else:
                            VALUES+=",'"+str(wart).strip()+"'"

                KOLUMNY+=")"
                VALUES+=");"
                INS += INSERT+KOLUMNY+VALUES
            if INS != '':
                rsglobal.ZapiszDoLogow(INS)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrzegl:
        stat = 'BR_UPR_PRZ'
        dane.append(stat)
    #AB 10.07.22r dodana kolumna 'glowny'
    SEL = """SELECT osoba_id, TRIM(oddzial_id), imie_nazwisko, operator_id::TEXT, email, telefon,
                    produkt, obsluga, transport, inne, glowny, aktywny, stopka
             FROM rs_rodo_reklamacje_osoby WHERE firma_id='{}' 
             ORDER BY osoba_id;""".format(self.firma_id)
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL,3,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
    #WS 2020-02-11
    else:
        stat2,nr,dump,dump = self.PolSQL.Execute('SELECT "last_value" FROM rs_rodo_reklamacje_osoby_osoba_id_seq;', 3,
                                                 CzyDodawacBlad=True)
        if stat2 != 'OK':
            rsglobal.ZapiszDoLogow(stat2)
            wyn2 = 0
        else:
            wyn2 = nr[0][0]

