# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_zlecenia_transportowe.py
# Purpose:     Obsuga
# Author:      Aleksander Bargie
# Created:     2023/06/21
# RCS-ID:      $Id: fs_rodo_dziennik_asi.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
""" Modyfikacja = 002302"""
from funkcje import fs_pliki_global

stat = 'OK'
firma_id = self.firma_id
oddzial_id = self.oddzial_id
Puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'wpis_id': [3, 5, 11, 12], 'zawartoscPliku': [11, ], 'nazwaPliku': [11, ], 'nr_pliku': [12, 15, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [3, 5, 11]:
        wpis_id  = int(klucze['wpis_id'])
    if Fun in (11, ):
        zawartoscPliku = klucze['zawartoscPliku']
        nazwaPliku     = klucze['nazwaPliku']
    if Fun in (12, 15):
        nr_pliku = int(klucze['nr_pliku'])

if stat == 'OK':
    UprMod  = ((oddzial_id, '002302') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))


pola_edytowalne = ['kategoria_id', 'czynnosc_id', 'opis', ]

dane = []
wyn1 = []
wyn2 = []

# ---------------------------------------------------------------------------------------------------------------------
#                                          1, 3 - Sprawdzanie danych
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3):
    if 'kategoria_id' in klucze:
        wart = klucze['kategoria_id']
        if wart != '':
            SPR ="SELECT kod FROM rs_rodo_dziennik_asi_kategorie "
            SPR+="WHERE firma_id=%s AND kod=%s;"
            zmienne = [firma_id, wart]
            stat, d, dump, dump = self.PolSQL.Execute(SPR, 3, zmienne, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'KAT SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'KAT BL'
                dane.append(stat)
        else:
            stat = 'KAT BR'
            dane.append(stat)
    elif Fun == 1:
        stat = 'KAT BR'
        dane.append(stat)

    if 'czynnosc_id' in klucze:
        wart = klucze['czynnosc_id']
        wart = wart.strip()
        if wart == '':
            stat = 'CZYNNOSC BR'
            dane.append(stat)
        else:
            SPR ="SELECT kod FROM rs_rodo_dziennik_asi_czynnosci "
            SPR+="WHERE firma_id=%s AND kod=%s;"
            zmienne = [firma_id, wart]
            stat, d, dump, dump = self.PolSQL.Execute(SPR, 3, zmienne, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'CZYNNOSC SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'CZYNNOSC BL'
                dane.append(stat)
    elif Fun == 1:
        stat = 'CZYNNOSC BR'
        dane.append(stat)

if len(dane) > 0:
    stat = dane[0]


# ---------------------------------------------------------------------------------------------------------------------
#                                          1 - Dodawanie wpisu
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, ):
    pola = []
    args = []
    for pole in pola_edytowalne:
        if pole in klucze:
            pola.append(pole)
            args.append(klucze[pole])
    wartosci = ['%s' for x in pola]
    pola.append('zmodyfikowal')
    wartosci.append('rsf_getuserid()')
    pola.append('firma_id')
    wartosci.append('%s')
    args.append(firma_id)

    INS = """INSERT INTO rs_rodo_dziennik_asi 
              ({})
              VALUES({});""".format(', '.join(pola), ', '.join(wartosci))

    rsglobal.ZapiszDoLogow(INS)
    rsglobal.ZapiszDoLogow(args)
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INS, args))
    stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd podczas dodawania wpisu: " + stat

    if stat == 'OK':
        SEL = """SELECT MAX(wpis_id)
                 FROM rs_rodo_dziennik_asi;"""
        rsglobal.ZapiszDoLogow('SQL rs_rodo_dziennik_asi numer: '+SEL)
        stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania numeru nowego wpisu: '+stat
        else:
            wpis_id = dane[0][0]


# ---------------------------------------------------------------------------------------------------------------------
#                                          3 - Aktualizacja danych
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3, ):
    SET  = []
    args = []
    for pole in pola_edytowalne:
        if pole in klucze:
            SET.append(pole + "=%s")
            args.append(klucze[pole])

    args.append(wpis_id)

    UPD = """UPDATE rs_rodo_dziennik_asi 
              SET {}
              WHERE wpis_id = %s;""".format(', '.join(SET))

    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(UPD, args))
    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd podczas edycji pozycji: " + stat

# ---------------------------------------------------------------------------------------------------------------------
#                                             11 - Dodanie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (11, ):
    if not UprMod:
        stat = "Brak uprawnie do modyfikacji wpisu"

    if stat == 'OK':
        INSPLIKI = """INSERT INTO rs_pliki (  firma_id,      nazwa,            tabela,     kompresja)
                                    VALUES ('{firma_id}','{nazwaPliku}','rs_rodo_dziennik_asi_zalaczniki', FALSE);""".format(**locals())
        rsglobal.ZapiszDoLogow(INSPLIKI)
        stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania pliku: {stat}".format(**locals())

    if stat == 'OK':
        SQLNumerPliku = """SELECT max(plik_id) 
                           FROM rs_pliki 
                           WHERE firma_id='{firma_id}' AND tabela='rs_rodo_dziennik_asi_zalaczniki';""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLNumerPliku)
        stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrp))
        if stat != 'OK':
            stat = "Bd pobierania numeru zacznika: {stat}".format(**locals())
        else:
            NumerPliku = nrp[0][0]
            stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, zawartoscPliku)

            if stat != 'OK':
                stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())
            else:
                if stat == 'OK':
                    INSZALACZNIKI = """INSERT INTO rs_rodo_dziennik_asi_zalaczniki
                                               (  firma_id,    wpis_id,    nr_pliku   )
                                        VALUES ('{firma_id}','{wpis_id}','{NumerPliku}');""".format(**locals())

                    rsglobal.ZapiszDoLogow(INSZALACZNIKI, 5)
                    stat, dump, dump, dump = self.PolSQL.Execute(INSZALACZNIKI, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd dodawania rekordu o nowym pliku: ' + stat
                    else:
                        dane = [{'nr_pliku': NumerPliku}]


# ---------------------------------------------------------------------------------------------------------------------
#                                             12 - Usunicie pliku
# ---------------------------------------------------------------------------------------------------------------------


if stat == 'OK' and Fun in (12, ):
    if not UprMod:
        stat = "Brak uprawnie do modyfikacji wpisu"

    if stat == 'OK':
        SEL = """SELECT nazwa FROM rs_pliki WHERE plik_id={nr_pliku};""".format(**locals())
        stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobrania nazwy usuwanego pliku: {stat}".format(**locals())
        elif len(dane) == 0:
            stat = "Plik nie istnieje"
        else:
            nazwa_pliku = dane[0][0]

    if stat == 'OK':
        stat = fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow, nr_pliku)

    if stat == 'OK':
        DEL= """DELETE FROM rs_rodo_dziennik_asi_zalaczniki WHERE nr_pliku={nr_pliku}; \n""".format(**locals())
        rsglobal.ZapiszDoLogow(DEL,5)
        stat,dump,dump,dump = self.PolSQL.Execute(DEL,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd podczas usuwania pliku: '+stat


# ---------------------------------------------------------------------------------------------------------------------
#                                             15 - Pobranie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (15, ):
    stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, nr_pliku)
    dane = [Tresc]


# ---------------------------------------------------------------------------------------------------------------------
#                                          25 - Pobranie przewidywanego numeru zlecenia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (25, ):
    SEL = """SELECT COALESCE(MAX(wpis_id), 0) + 1
             FROM rs_rodo_dziennik_asi;"""
    rsglobal.ZapiszDoLogow('SQL rs_rodo_dziennik_asi numer: '+SEL)
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru nowego wpisu: '+stat



# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1-dodawanie, 3-aktualizacja, 5-odczyt)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3, 5, 6):
    SEL = """SELECT da.firma_id, wpis_id, kategoria_id, k.opis as kateg_opis, czynnosc_id, c.opis as czynnosc_opis, 
                    zmodyfikowal, o.imie||' '||o.nazwisko as zmodyfikowal_opis, zmodyfikowano, da.opis
             FROM rs_rodo_dziennik_asi as da
             JOIN rs_rodo_dziennik_asi_czynnosci c on c.firma_id=da.firma_id AND c.kod=da.czynnosc_id
             JOIN rs_rodo_dziennik_asi_kategorie k on k.firma_id=da.firma_id AND k.kod=da.kategoria_id
             LEFT JOIN rs_operatorzy o on o.operator_id = da.zmodyfikowal
             WHERE da.firma_id=%s and wpis_id=%s"""
    zmienne = [firma_id, wpis_id]  # firma zostaje po to, by nie pobiera danych o wpisach z innych firm, nie jest
                                   # potrzebna by znale wpis
    SEL = SEL + " ORDER BY wpis_id DESC;"
    rsglobal.ZapiszDoLogow('SQL rs_rodo_dziennik_asi: '+self.PolSQL.Mogrify(SEL, zmienne))
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
    if stat != 'OK':
        stat = 'Bd pobrania listy wpisw '+stat

    if stat in ('OK',) and dane:
        SQLPliki = """SELECT z.firma_id, wpis_id, nr_pliku, nazwa AS opis
                      FROM rs_rodo_dziennik_asi_zalaczniki z JOIN rs_pliki p ON p.firma_id=z.firma_id  AND p.plik_id=z.nr_pliku 
                      AND p.tabela ='rs_rodo_dziennik_asi_zalaczniki'
                      WHERE wpis_id={wpis_id};""".format(**locals())

        rsglobal.ZapiszDoLogow(SQLPliki)
        stat, Pliki, PlikiWyn1, dump = self.PolSQL.Execute(SQLPliki, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania plikw dla wpisu: {stat}".format(**locals())
        else:
            wyn2 = [Pliki, PlikiWyn1]
if dane is None:
    dane = []
