# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_rotacja_opakowan.py
# Purpose:     wczytuje dane rotacji opakowa
# Author:      Piotr Witkowski
# Created:     2017/03/31
# RCS-ID:      $Id: fs_rotacja_opakowan.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2017-09-20 Rafa Woniak (0010732) rotacja opakowa - operator,
#   zaktualizowanie zapytan eby wypeniay kolumny operatora
# 2017-11-13 Rafa Woniak (0010812) dodanie druku do kompensaty midzy kierowcami
# 2018-01-15 Rafa Woniak (0010886) poprawienie syntetyki
# 2018-03-12 Aleksander Bargie (10945) Zaprojektowa Anakondowe okno EMS - dodanie rotacji z reczne = False
# 2018-04-20 Aleksander Bargie (11017) dodatkowe filtry w rotacji opakowan
# 2018-05-21 Aleksander Bargie (11047) Zmiana w filtrze daty - rotacja opakowa.
# 2018-08-31 Aleksander Bargie (11205) Tymczasowo notowa czas wykonania zapyta i wysya mail jeli co bdzie
# duej trwao
# 2018-09-26 Aleksander Bargie (11239) Sprawdzi synchronizacj aplikacji mobilnej i Anakondy w EMS.
# 2019-04-17 Aleksander Bargie (11470) Maile z rotacji opakowa - zwikszy prg z 15 sekund do minuty
# 2023-11-24 Wojciech Skowron   (13615) Rnica%
# 2023-12-07 Wojciech Skowron   (13633) Rnica

# Funkcje:
# 1 - Dodawanie - rotacja opakowa dane
# 5 - Pobieranie danych do edycji rotacji opakowa (dane)
# 6 - Pobieranie danych do rotacji opakowa
# 7 - Pobranie czasu z serwera oraz oddziau z uprawnie operatora
# 8 - Pobranie listy opakowa do wywietlania w filtrze
# 9 - Pobieranie przewonika
# 10 - Pobranie przewonika do wydruku
# 11 - Pobranie danych do wydruku
# 12 - Pobieranie opisu drigiego kierowcy
# 21 - Tworzenie dokumentow magazynowych (Magda Kozlowska)


from funkcje import fs_rotacja_opakowan_pom
#AB 31.08.18r
from time import time
from datetime import datetime
wykonania = {}

stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Oddzial': [1, 5, 6, 9, 10, 11, 21], 'Kierowca': [1, 5, 6, 9, 10, 11],
             #AB 20.04.18r Umoliwienie filtrowania po dacie
             'Przewoznik': [6, ], 'Opakowanie': [6, ], 'OdDnia': [6, ], 'DoDnia': [6, ], 'OdGodziny': [6, ],
             'DoGodziny': [6, ], 'Reczne': [6, ], 'Ujemne': [6, ], 'Analityka': [6, ],'Zakres': [6, ],
             'CzasZapisu': [10, 11], 'MKierowcami': [6, ], 'Kierowca2': [12]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_rotacja_opakowan "'
        stat += 'z numerem ' + str(Funkcja) + ' bez parametrw: ' + Lista

if stat == 'OK':
    if Funkcja in [1, 5, 6, 9, 10, 11, 21, ]:
        Oddzial = klucze['Oddzial']
    if Funkcja in [1, 5, 6, 9, 10, 11, ]:
        #AB
        if 'Kod' in klucze:
            SQL = "SELECT kod, opis FROM rs_kierowcy WHERE firma_id ='" + self.firma_id + "' and upper(uid_karty) like upper('%" + klucze['Kod'] + "%')"
            #AB 31.08.18r
            start = time()
            stat, wyn2, dump, dump = self.PolSQL.Execute(SQL, 3)
            wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]
            if stat == 'OK' and len(wyn2) == 1:
                Kierowca = rsglobal.Dekoduj(wyn2[0][0])
            elif stat == 'OK' and len(wyn2) == 0:
                stat = 'Nie odnaleziono kierowcy o wskazanym Id karty.'
            elif stat == 'OK' and len(wyn2) > 1:
                stat = 'Bd: Karta przypisana do wicej ni 1 kierowcy, naley poprawi dane.'
            else:
                stat = 'Bd pobrania sybolu kierowcy: ' + stat
        else:
            Kierowca = klucze['Kierowca']
    if Funkcja in [6, ]:
        Zakres = klucze['Zakres']
        Przewoznik = klucze['Przewoznik']
        Opakowanie = klucze['Opakowanie']
        OdDnia = klucze['OdDnia']
        DoDnia = klucze['DoDnia']
#AB 20-04-18 Dodanie godziny w filtrach
        OdGodziny = klucze['OdGodziny']
        DoGodziny = klucze['DoGodziny']
        Reczne = klucze['Reczne']
        Ujemne = klucze['Ujemne']
        Analityka = klucze['Analityka']
        MKierowcami = klucze['MKierowcami']
    if Funkcja in [10, 11, ]:
        CzasZapisu = klucze['CzasZapisu']
    if Funkcja in [12, ]:
        Kierowca2 = klucze['Kierowca2']

if stat == 'OK':
    dane = []
    wyn1 = []
    if 'Kod' not in klucze:
        wyn2 = []
#AB 20-04-18 Dodanie godziny w filtrach
    puste = ['', '    -  -  ', u'  :  ', 'Null', None]

    if Funkcja == 1:
        Update = []
        Update = klucze['Update']

    if Funkcja == 6:
        if OdDnia not in puste:
            if not rsglobal.SprawdzCzyToData(OdDnia):
                stat = u'Bdna warto daty od dnia'
        if stat == 'OK' and DoDnia not in puste:
            if not rsglobal.SprawdzCzyToData(DoDnia):
                stat = u'Bdna warto daty do dnia'
#AB 20-04-18 Dodanie godziny w filtrach
        if stat == 'OK' and (OdDnia in puste or DoDnia in puste):
            if OdGodziny not in puste or DoGodziny not in puste:
                stat = u'Filtrowanie wg. godziny tylko w ramach 1 dnia'
        if stat == 'OK' and (OdGodziny not in puste or DoGodziny not in puste):
            if DoDnia != OdDnia:
                stat = u'Filtrowanie wg. godziny tylko w ramach 1 dnia'
        if stat == 'OK' and OdGodziny not in puste and DoGodziny not in puste:
            if OdGodziny > DoGodziny:
                stat = u'Godzina od  jest wiksza ni godzina do'

# -------------------------------------------------------------------------------
# Pobranie czasu z serwera oraz oddziau z uprawnie operatora
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 7, ]:
    # AB 21-05-18 Uzupenianie daty od dat dzisiejsz
    Select = "SELECT CURRENT_TIMESTAMP::TIMESTAMP, CURRENT_DATE, "
    Select += "CURRENT_DATE,CURRENT_TIME;"
#AB 31.08.18r
    start = time()
    stat, Dane, dump, dump = self.PolSQL.Execute(Select, 3)
    wykonania[Select] = [time() - start, datetime.now().isoformat(' ')]
    dane = [Dane[0][0], Dane[0][1][0:10], Dane[0][2][0:10], '']

    if stat == 'OK' and int(self.operator_id) > 0:
        Select = "SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial WHERE "
        Select += "firma_id='" + self.firma_id + "' AND operator_id=" + str(self.operator_id) + ";"
#AB 31.08.18r
        start = time()
        stat, d, dump, tr = self.PolSQL.Execute(Select, 3)
        wykonania[Select] = [time() - start, datetime.now().isoformat(' ')]
        if stat != 'OK':
            stat = 'Bdy pobierania oddziau z uprawnie operatora :' + stat
        else:
            dane[3] = d

# -------------------------------------------------------------------------------
# Pobranie listy opakowa do wywietlania w filtrze
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 8:
    sql = "SELECT DISTINCT art.artykul_id,art.artykul_id||' - '||art.nazwa FROM rs_artykuly AS art "
    sql += " WHERE art.firma_id='" + self.firma_id + "' AND art.aktywny AND art.rotacja"
    sql += " ORDER BY art.artykul_id ASC;"
#AB 31.08.18r
    start = time()
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
    wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]
    if stat != "OK":
        stat = "Bd pobrania listy opakowa do wywietlania w filtrze."
        dane.append(stat)

# -------------------------------------------------------------------------------
# Pobranie przewonika
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 9]:
    dzien = rsglobal.PodajNrDniaTygodnia(rsglobal.PodajDzis())
    SQL = "SELECT przewoznik_00,"
    SQL += "przewoznik_0" + str(int(dzien))
    SQL += "\nFROM rs_kierowcy k JOIN rs_kierowcy_przewoznicy p "
    SQL += "ON p.firma_id=k.firma_id and p.kierowca_id=k.kod "
    SQL += "\nWHERE p.firma_id='" + self.firma_id + "' AND data_od=(SELECT max(pp.data_od) "
    SQL += "FROM rs_kierowcy_przewoznicy pp "
    SQL += "\n\tWHERE p.firma_id=pp.firma_id and p.kierowca_id=pp.kierowca_id "
    SQL += "and pp.data_od<='" + rsglobal.PodajDzis() + "') "
    SQL += "\nAND kierowca_id ='" + Kierowca + "' "
    SQL += "AND (przewoznik_00 IS NOT NULL OR przewoznik_0" + str(int(dzien)) + " IS NOT NULL);"
#AB 31.08.18r
    start = time()
    stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
    wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]
    if stat != "OK":
        stat = u"Bd pobrania przewonika."
        dane.append(stat)
    elif len(d) == 0:
        stat = u'Na dzie dzisiejszy nie jest przypisany przewonik do kierowcy'
        dane.append(stat)
    else:
        if d[0][1] not in ['', 'None', 'Null', None]:
            Przewoznik = d[0][1]
        elif d[0][0] not in ['', 'None', 'Null', None]:
            Przewoznik = d[0][0]
        else:
            stat = u'Na dzie dzisiejszy nie jest przypisany przewonik do kierowcy'

# -------------------------------------------------------------------------------
# Pobranie przewonika do wydruku
# -------------------------------------------------------------------------------

# RW Zmodyfikowaem funkcje eby pobieraa dodatkowe informacje,
# eby na wypadek drukowania kompensat midzy kierowcami
if stat == 'OK' and Funkcja == 11:
    SQL = "SELECT DISTINCT * FROM"
    SQL += " (SELECT DISTINCT r.przewoznik_id, k.nazwa,"
    SQL += " o.oddzial_id||'-'||o.opis,r.opakowanie_id,r.wydania,r.przyjecia "
    SQL += " FROM rs_opakowania_rotacja r JOIN rs_oddzialy o USING (firma_id, oddzial_id) "
    SQL += " JOIN rs_kontrahenci k ON r.firma_id=k.firma_id and r.przewoznik_id=k.kontrahent_id "
    SQL += " WHERE r.firma_id='" + self.firma_id + "' AND r.oddzial_id ='" + Oddzial + "' "
    SQL += " AND r.kierowca_id ='" + Kierowca + "' "
    SQL += " AND to_char(r.czas_zapisu, 'YYYY-MM-DD HH24:MI:SS') ='" + CzasZapisu + "') as rr"
    SQL += " FULL OUTER JOIN"
    SQL += " (SELECT DISTINCT s.kierowca_id, s.przewoznik_id,"
    SQL += " b.nazwa,s.opakowanie_id,s.wydania,s.przyjecia"
    SQL += " FROM rs_opakowania_rotacja s "
    SQL += " JOIN rs_kontrahenci b ON s.firma_id=b.firma_id AND s.przewoznik_id=b.kontrahent_id"
    SQL += " WHERE s.firma_id='" + self.firma_id + "' AND s.oddzial_id ='" + Oddzial + "' "
    SQL += " AND s.kierowca_id <>'" + Kierowca + "'"
    SQL += " AND to_char(s.czas_zapisu, 'YYYY-MM-DD HH24:MI:SS') ='" + CzasZapisu + "') as aa  "
    SQL += " ON rr.opakowanie_id=aa.opakowanie_id ;"

    # AB 31.08.18r
    start = time()
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]
    if stat != "OK":
        stat = u"Bd pobrania przewonika do wydruku."
        dane.append(stat)
    elif len(dane) == 0:
        stat = u"Brak przypisanego przewonika do kierowcy"
        dane.append(stat)

# -------------------------------------------------------------------------------
# Pobranie danych do wydruku
# -------------------------------------------------------------------------------

# RW dodaem pobranie jaki jest numer w celu wybrania jaki druk ma zostac wygenerowany
if stat == 'OK' and Funkcja == 10:
    SQL = "SELECT r.opakowanie_id||'-'||a.nazwa as opakowanie_id,"
    SQL += "r.stan_pocz,r.wydania,r.przyjecia,r.stan_konc, r.dm_numer FROM rs_opakowania_rotacja r "
    SQL += "JOIN rs_artykuly a ON r.firma_id=a.firma_id and r.opakowanie_id=a.artykul_id "
    SQL += "\nWHERE r.firma_id='" + self.firma_id + "' AND r.oddzial_id ='" + Oddzial + "' "
    SQL += "AND r.kierowca_id ='" + Kierowca + "' "
    SQL += "AND to_char(r.czas_zapisu, 'YYYY-MM-DD HH24:MI:SS') ='" + CzasZapisu + "' ;"
#AB 31.08.18r
    start = time()
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]
    if stat != "OK":
        stat = u"Bd pobrania danych do wydruku."
        dane.append(stat)
    elif len(dane) == 0:
        stat = u"Brak danych do wydruku"
        dane.append(stat)

# -------------------------------------------------------------------------------
# RW pobieranie opisu drigiego kierowcy
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    SQL = "SELECT opis FROM rs_kierowcy WHERE kod='" + Kierowca2 + "';"
#AB 31.08.18r
    start = time()
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]

# -------------------------------------------------------------------------------
# Tworzenie dokumentw magazynowych
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 21:
    SQL = "SELECT 1"
#AB 31.08.18r
    start = time()
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]

# -------------------------------------------------------------------------------
# DODAWANIE (1,2) (rotacja opakowa dane)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1:
    # Pobranie przewonika
    dane = []
    #AB mozliwosc wyboru czy dodane recznie
    if 'Recznie' in klucze:
        reczne = klucze['Recznie']
    else:
        reczne = True
    czas_zapisu = Dane[0][0]
    if len(Update[0]) > 0:
        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):
            insp = "(firma_id,oddzial_id,kierowca_id,czas_zapisu,reczne,przewoznik_id,operator_id "
            insw = "('" + self.firma_id + "','" + Oddzial + "','" + Kierowca + "','"
            insw += czas_zapisu + "',"+str(reczne)+",'" + Przewoznik + "','" + str(self.operator_id) + "' "

            for j in xrange(len(Update[2][i])):
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])
                if pole == 'opakowanie_id':
                    insp += "," + pole
                    insw += ",'" + wart + "'"
                    opakowanie = wart

            SQL = "SELECT COALESCE(stan_konc,0) FROM rs_opakowania_rotacja "
            SQL += "WHERE firma_id='" + self.firma_id + "' and oddzial_id='" + Oddzial + "' "
            SQL += "and kierowca_id='" + Kierowca + "' and opakowanie_id='" + opakowanie + "' "
            #AB 25.09.18r
            SQL += "AND czas_zapisu <= '" + czas_zapisu + "' "
            SQL += "ORDER BY czas_zapisu DESC LIMIT 1"
            rsglobal.ZapiszDoLogow(SQL, 5)
#AB 31.08.18r
            start = time()
            stat, d, wyn1, dump = self.PolSQL.Execute(SQL, 3)
            wykonania[SQL] = [time() - start, datetime.now().isoformat(' ')]
            if stat != 'OK':
                stat = 'Bd pobrania danych opakowania przy dodawaniu: ' + stat
                dane.append(stat)

            if len(d) == 1:
                stan_poczatkowy = d[0][0]
            else:
                stan_poczatkowy = 0
            stan_koncowy = stan_poczatkowy
            wydano = False
            przyjecia = False
            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]

                if pole == 'wydania':
                    if int(wart) < 0:
                        wyn2.append((WierszeNr[i], 2))
                        dane.append(u"Wartoci 'wydanie' nie mog by ujemne")
                    elif int(wart) > 9999:
                        wyn2.append((WierszeNr[i], 2))
                        dane.append(u"Wartoci 'wydanie' przekracza 4 znaki")
                    else:
                        wydano = True
                        insp += "," + pole
                        insw += "," + str(wart)
                        stan_koncowy += int(wart)

                if pole == 'przyjecia':
                    przyjecia = True
                    if int(wart) < 0:
                        wyn2.append((WierszeNr[i], 3))
                        dane.append(u"Wartoci 'przyjcie' nie mog by ujemne")
                    elif int(wart) > 9999:
                        wyn2.append((WierszeNr[i], 3))
                        dane.append(u"Wartoci 'przyjcie' przekracza 4 znaki")
                    else:
                        insp += "," + pole
                        insw += "," + str(wart)
                        stan_koncowy -= int(wart)
            if not wydano:
                insp += ",wydania"
                insw += ",0"
            if not przyjecia:
                insp += ",przyjecia"
                insw += ",0"

            insp += ",stan_pocz,stan_konc)"
            insw += "," + str(stan_poczatkowy) + "," + str(stan_koncowy) + ")"

            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]

            rsglobal.ZapiszDoLogow("INSERT INTO rs_opakowania_rotacja " + insp + " VALUES " + insw + ";", 1)
            # wykonanie
            if stat == 'OK':
                INS = "INSERT INTO rs_opakowania_rotacja " + insp + " VALUES " + insw + ";"
#AB 31.08.18r
                start = time()
                stat, d, dump, dump = self.PolSQL.Execute(INS, 1)
                wykonania[INS] = [time() - start, datetime.now().isoformat(' ')]
                if stat != 'OK':
                    stat = 'Bd dodawania nowej pozycji: ' + stat
                    dane.append(stat)
            #AB 25.09.18r
            if stat == 'OK':
                roznica = stan_koncowy - stan_poczatkowy
                if roznica != 0:
                    UPD  = "UPDATE rs_opakowania_rotacja "
                    UPD += "SET stan_pocz=stan_pocz+{roznica}, stan_konc=stan_konc+{roznica} "
                    UPD += "WHERE firma_id='{firma}' AND oddzial_id='{oddzial}' AND kierowca_id='{kier}' "
                    UPD += "AND opakowanie_id='{opak}' AND czas_zapisu >'{czas}'"
                    UPD = UPD.format(firma   = self.firma_id,
                                     oddzial = Oddzial,
                                     kier    = Kierowca,
                                     opak    = opakowanie,
                                     roznica = roznica,
                                     czas    = czas_zapisu)
                    rsglobal.ZapiszDoLogow(UPD, 5)
                    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1)
                    if stat != 'OK':
                        stat = 'Bd dodawania nowej pozycji: ' + stat
                        dane.append(stat)


# -------------------------------------------------------------------------------
# SELECT (5,3,1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 5]:
    sql = "SELECT DISTINCT artykul_id,nazwa, 0,0 FROM rs_artykuly "
    sql += " WHERE firma_id='" + self.firma_id + "' AND aktywny AND rotacja ORDER BY artykul_id "
#AB 31.08.18r
    start = time()
    stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
    wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]
    if stat != 'OK':
        stat = 'Bd pobrania danych pozycji: ' + stat
        dane.append(stat)

# -------------------------------------------------------------------------------
# SELECT Rotacja Opakowa
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if Analityka:
        sql = "SELECT r.oddzial_id,r.kierowca_id||'-'||k.opis as kierowca_id,"
        sql += "r.opakowanie_id||'-'||a.nazwa as opakowanie_id,"
        sql += "r.stan_pocz,r.wydania,r.przyjecia,"
        sql += "0,0,"  #WS 2023-11-24 - zalepka na roznice pobierana w syntetyce
        sql += "r.stan_konc,to_char(r.czas_zapisu, 'YYYY-MM-DD HH24:MI:SS'),"
        sql += "o.login FROM rs_opakowania_rotacja r "
        sql += "JOIN rs_kierowcy k ON r.firma_id=k.firma_id and r.kierowca_id=k.kod "
        sql += "JOIN rs_artykuly a ON r.firma_id=a.firma_id and r.opakowanie_id=a.artykul_id "
        sql += "JOIN rs_operatorzy o ON o.operator_id=r.operator_id "
        sql += " WHERE r.firma_id='" + self.firma_id + "' "
        if Oddzial:
            sql += "AND r.oddzial_id='" + Oddzial + "' "
        else:
            if len(Zakres) > 0 and type(Zakres) == type([]):
                sql += "AND ( "
                i = 1
                for oddzial in Zakres:
                    if i != len(Zakres):
                        sql += "r.oddzial_id='" + str(oddzial[0]) + "' OR "
                    else:
                        sql += "r.oddzial_id='" + str(oddzial[0]) + "' )"
                    i += 1
        if Kierowca:
            sql += "AND r.kierowca_id='" + Kierowca + "' "
        if Przewoznik:
            sql += "AND r.przewoznik_id='" + Przewoznik + "' "
        if Opakowanie:
            sql += "AND r.opakowanie_id='" + Opakowanie + "' "
        if OdDnia not in puste:
#AB 20-04-18 Dodanie godziny w filtrach
            sql += " AND r.czas_zapisu>='" + OdDnia + (" " + OdGodziny + ":00' " if OdGodziny not in puste else "' ")
        if DoDnia not in puste:
            sql += " AND r.czas_zapisu<='" + DoDnia + (" " + DoGodziny + ":59' " if DoGodziny not in puste else " 23:59:59' ")
        # RW sprawdzanie checkboxa
        if MKierowcami:
            sql += " AND dm_numer='-2'"
        if Reczne:
            sql += " AND reczne='" + str(Reczne) + "' "
        if Ujemne:
            sql += " AND r.stan_konc<0 "
        sql += "  ORDER BY r.czas_zapisu ASC;"
#AB 31.08.18r
        start = time()
        stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
        wykonania[sql] = [time() - start, datetime.now().isoformat(' ')]
        if stat != 'OK':
            stat = 'Bd pobrania danych rotacji opakowa: ' + stat
            dane.append(stat)

    # syntetyka
    else:
        #AB 01.10.19r Pocztek nowego selecta
        ogr_oddzialy = int(self.operator_id) != 0
        if ogr_oddzialy:
            Select = """SELECT DISTINCT ''''||string_agg(oddzial_id, ''', ''')||'''' AS oddzialy 
    FROM rs_grupa_operator_oddzial 
    WHERE firma_id='{}' AND operator_id = {};""".format(self.firma_id, self.operator_id)
            stat, oddzialy, dump, dump = self.PolSQL.Execute(Select, 3)
            if stat != 'OK':
                stat = 'Bdy pobierania oddziau z uprawnie operatora :' + stat
            else:
                oddzialy = oddzialy[0][0]
            if Oddzial:
                if Oddzial not in oddzialy and '**' not in oddzialy:
                    stat = "Brak uprawnie do oddziau {}".format(Oddzial)
            if '**' in oddzialy:
                ogr_oddzialy = False
        if stat == 'OK':
            """select wyglda tak:
            SELECT kolumny from
            (zapytanie na rotacje z zakresu dat
            union
            zapytanie na rotacje spoza zakresu dat)
            join na artykuly(kirowcow) by pobra nazw, nie moe by w zapytaniach w rodku, bo wtedy grupowanie nie 
            korzysta z indeksw i dziaa wolniej"""

            #WS 2023-11-24 - roznica_proc
            #WS 2023-12-07 - roznica, zmiana w obliczaniu roznica_proc
            SelZewPoczatek = """SELECT oddzial_id, kierowca_id ||'-'||coalesce(opis, 'Kierowca usunity') as kierowca_id, opakowanie_id||'-'||coalesce(nazwa, 'Artyku usunity') AS opakowanie_id, 
                                stan_pocz, wydania, przyjecia,
                                wydania-przyjecia AS roznica,
                                (CASE WHEN '{oddzial}' != '' AND wydania != 0 THEN GREATEST((wydania-przyjecia)/wydania*100, 0) ELSE 0 END) AS roznica_proc,
                                stan_konc,
                                czas_zapisu, operator_id FROM (
                             """.format(oddzial=Oddzial, analityka=Analityka) \
                if Kierowca or Opakowanie \
                else """SELECT oddzial_id, '' as kierowca_id, opakowanie_id||'-'||coalesce(nazwa, 'Artyku usunity') AS opakowanie_id,
                                sum(stan_pocz) AS stan_pocz, sum(wydania) AS wydania, sum(przyjecia) AS przyjecia, 
                                sum(wydania)-sum(przyjecia) AS roznica,
                                (CASE WHEN '{oddzial}' != '' AND sum(wydania) != 0 THEN GREATEST((sum(wydania)-sum(przyjecia))/sum(wydania)*100, 0) ELSE 0 END) AS roznica_proc,
                                sum(stan_konc) AS stan_konc,
                                CASE WHEN sum(przyjecia)=0 AND sum(przyjecia)=0 THEN 'poza zakresem dat' ELSE '' END 
                                AS czas_zapisu, '' AS operator_id
                                FROM (""".format(oddzial=Oddzial, analityka=Analityka)

            SelZewnKoniec = """) AS r LEFT JOIN rs_artykuly ON '{firma}'=firma_id and opakowanie_id=artykul_id 
                                      LEFT JOIN rs_kierowcy k ON '{firma}'=k.firma_id and kierowca_id=kod
                           {war_ujemne}
                           {group}
                               ;""".format(firma=self.firma_id,
                                           war_ujemne="" if not Ujemne else ('WHERE stan_konc<0' if not Opakowanie
                                                  and not Kierowca else 'WHERE sum(stan_konc)<0'),
                                           group='GROUP BY opakowanie_id, oddzial_id, nazwa' if not Opakowanie
                                                  and not Kierowca else '')

            war_w_zakresie = """{war_oddz}
              AND czas_zapisu>='{od}'  
              AND czas_zapisu<='{do}' 
              """.format(war_oddz="AND oddzial_id='"+Oddzial+"'" if Oddzial  # jesli filtr, to oddzial z filtra
                                   else ('AND oddzial_id in ('+oddzialy+')' if ogr_oddzialy  # jesli uprawnienia, to wg. uprawnien
                                        else ''),  # jesli brak ograniczen, to bez warunku
                         od=OdDnia + (" " + OdGodziny + ":00 " if OdGodziny not in puste else " "),
                         do=DoDnia + (" " + DoGodziny + ":59 " if DoGodziny not in puste else " 23:59:59"))

            war_przed_zakresem = """AND czas_zapisu<'{od}'
                                 """.format(od=OdDnia + (" " + OdGodziny + ":00 " if OdGodziny not in puste else " "))

            war_filtr = """{war_oddz}
                           {war_opak}
                           {war_reczne}
                           {war_kierowca}
                           {war_przewoznik}
                        """.format(war_oddz="AND oddzial_id='"+Oddzial+"'" if Oddzial  # jesli filtr, to oddzial z filtra
                                            else ('AND oddzial_id in ('+oddzialy+')' if ogr_oddzialy  # jesli uprawnienia, to wg. uprawnien
                                                 else ''),  # jesli brak ograniczen, to bez warunku
                                   war_opak="AND opakowanie_id='"+Opakowanie+"'" if Opakowanie else '',
                                   war_reczne="AND reczne='"+str(Reczne)+"'" if Reczne else '',
                                   war_kierowca="AND kierowca_id='"+Kierowca+"'" if Kierowca else '',
                                   war_przewoznik="AND przewoznik_id='"+Przewoznik+"'" if Przewoznik else '')

            war_poza_zakresem = """AND czas_zapisu<'{od}'
      AND (kierowca_id, opakowanie_id, oddzial_id) IN (SELECT DISTINCT kierowca_id, opakowanie_id, oddzial_id FROM rs_opakowania_rotacja r2 WHERE firma_id='{firma}'
                         {war_filtr}
                         {war_przed_zakresem}
                         EXCEPT
                         SELECT DISTINCT kierowca_id, opakowanie_id, oddzial_id FROM rs_opakowania_rotacja r1 WHERE firma_id='{firma}'
                         {war_w_zakresie} )""".format(firma=self.firma_id,
                                                    od=OdDnia+(" "+OdGodziny+":00 " if OdGodziny not in puste else ""),
                                                    war_filtr=war_filtr,
                                                    war_przed_zakresem=war_przed_zakresem,
                                                    war_w_zakresie=war_w_zakresie)

            WzorStan = """(SELECT sum(stan_konc)
                           FROM rs_opakowania_rotacja JOIN (SELECT MAX(czas_zapisu) AS czas_zapisu, 
                                                                   opakowanie_id, kierowca_id
                                                            FROM rs_opakowania_rotacja
                                                            WHERE firma_id = r.firma_id
                                                              AND oddzial_id = r.oddzial_id
                                                              AND kierowca_id = r.kierowca_id
                                                              {war_w_zakresie}
                                                              {war_do}
                                                            GROUP BY opakowanie_id, kierowca_id) ostatni 
                                                      USING (opakowanie_id, kierowca_id, czas_zapisu)
                           WHERE firma_id=r.firma_id
                             AND oddzial_id=r.oddzial_id
                             AND opakowanie_id=r.opakowanie_id
                             AND kierowca_id = r.kierowca_id
         )"""

            Wzor = """SELECT oddzial_id, kierowca_id, opakowanie_id,
           """+WzorStan.format(war_w_zakresie='', war_do=war_przed_zakresem)+"""
                                AS stan_pocz,
           {wydania} AS wydania,
           {przyjecia} AS przyjecia,
           """+WzorStan.format(war_w_zakresie='',
                               war_do="AND czas_zapisu<='"+DoDnia + (" "+DoGodziny+":59' " if DoGodziny not in puste
                                                                     else " 23:59:59'"))+"""
                                AS stan_konc,
    '{czas}' AS czas_zapisu,
    '' AS operator_id
    FROM rs_opakowania_rotacja r
    WHERE firma_id='{firma}'  
      {war_filtr}
      {war_w_zakresie}
      {war_poza_zakresem}
    GROUP BY firma_id, oddzial_id, opakowanie_id, kierowca_id"""


            sel = (SelZewPoczatek +
                    Wzor.format(wydania="SUM(wydania)",
                               przyjecia="SUM(przyjecia)",
                               czas="",
                               firma=self.firma_id,
                               war_filtr=war_filtr,
                               war_w_zakresie=war_w_zakresie,
                               war_poza_zakresem='')
                   + " UNION " +
                   Wzor.format(wydania="0",
                               przyjecia="0",
                               czas="poza zakresem dat",
                               firma=self.firma_id,
                               war_filtr=war_filtr,
                               war_w_zakresie='',
                               war_poza_zakresem=war_poza_zakresem)
                   + SelZewnKoniec
                   )
            rsglobal.ZapiszDoLogow("Nowy SELECT: " + '\n'.join([line for line in sel.splitlines() if line.strip() != '']))


        #AB 01.10.19r Koniec  nowego selecta


        # 1. jeli pozostae kontrolki s puste albo wypeniony jest tylko oddzia,
        # to w gridzie wywietla sumy wartoci
        #  w podziale na opakowania z pominiciem kierowcw.
        filtr = ''
        filtr2 = ''
        if Oddzial:
            filtr += "AND r.oddzial_id='" + Oddzial + "' "
            filtr2 += "AND r.oddzial_id='" + Oddzial + "' "
        else:
            if len(Zakres) > 0 and type(Zakres) == type([]):
                filtr += "AND ( "
                filtr2 += "AND ( "
                i = 1
                for oddzial in Zakres:
                    if i != len(Zakres):
                        filtr += "r.oddzial_id='" + str(oddzial[0]) + "' OR "
                        filtr2 += "r.oddzial_id='" + str(oddzial[0]) + "' OR "
                    else:
                        filtr += "r.oddzial_id='" + str(oddzial[0]) + "' )"
                        filtr2 += "r.oddzial_id='" + str(oddzial[0]) + "' )"
                    i += 1
        if OdDnia not in puste:
#AB 20-04-18 Dodanie godziny w filtrach
            filtr += " AND r.czas_zapisu>='" + OdDnia + (" " + OdGodziny + ":00' " if OdGodziny not in puste else "' ")
            filtr2 += " AND r.czas_zapisu<'" + OdDnia + (" " + OdGodziny + ":00' " if OdGodziny not in puste else "' ")
        if DoDnia not in puste:
            filtr += " AND r.czas_zapisu<='" + DoDnia + (" " + DoGodziny + ":59' " if DoGodziny not in puste else " 23:59:59' ")
        if Reczne:
            filtr += " AND r.reczne='" + str(Reczne) + "' "
            filtr2 += " AND r.reczne='" + str(Reczne) + "' "
        if Ujemne:
            filtr += " AND r.stan_konc<0 "
            filtr2 += " AND r.stan_konc<0 "
        if Kierowca:
            filtr += "AND r.kierowca_id='" + Kierowca + "' "
            filtr2 += "AND r.kierowca_id='" + Kierowca + "' "
        if Przewoznik:
            filtr += "AND r.przewoznik_id='" + Przewoznik + "' "
            filtr2 += "AND r.przewoznik_id='" + Przewoznik + "' "
        if Opakowanie:
            filtr += "AND r.opakowanie_id='" + Opakowanie + "' "
            filtr2 += "AND r.opakowanie_id='" + Opakowanie + "' "


        def UstawSumy(filtr, co):
            if co == 'stan_pocz':
                wart = "\n\t(SELECT sum(kk.stan_pocz) "
            elif co == 'stan_konc':
                wart = "\n\t(SELECT sum(kk.stan_konc) "
            wart += "FROM rs_opakowania_rotacja kk WHERE kk.firma_id=r.firma_id "
            wart += "AND kk.oddzial_id=r.oddzial_id AND kk.opakowanie_id=r.opakowanie_id "
            wart += filtr.replace('r.', 'kk.') + "\n\t\tAND kk.czas_zapisu = "
            if co == 'stan_pocz':
                wart += "(Select min(kkk.czas_zapisu) "
            elif co == 'stan_konc':
                wart += "(Select max(kkk.czas_zapisu) "
            wart += "FROM rs_opakowania_rotacja kkk WHERE kkk.firma_id=r.firma_id "
            wart += "AND kkk.opakowanie_id=r.opakowanie_id "
            wart += filtr.replace('r.', 'kkk.') + " AND kkk.kierowca_id=kk.kierowca_id "
            return wart


        # 2. Jeli wpisany kierowca wywietla sumy dla opakowa
        # RW drobne zmiany w zapytaniu , dodanie k.oddzial_id = kkk.oddzial_id
        if not Kierowca and not Opakowanie:
            # chyba trzeba zmodyfikowa stan konc
            sql = "SELECT r.oddzial_id,'',"
            sql += "r.opakowanie_id||'-'||a.nazwa as opakowanie_id,"
            sql += UstawSumy(filtr2, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id )),SUM(r.wydania),SUM(r.przyjecia),"
            sql += UstawSumy(filtr, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id )),'','' "
            sql += "FROM rs_opakowania_rotacja r "
            sql += "JOIN rs_artykuly a ON r.firma_id=a.firma_id and r.opakowanie_id=a.artykul_id "
            sql += " WHERE r.firma_id='" + self.firma_id + "' "  # ,r.czas_zapisu"
            sql += filtr
            sql += "GROUP BY r.firma_id,r.oddzial_id,r.opakowanie_id,r.opakowanie_id||'-'||a.nazwa "
            sql += " \nUNION \n"
            sql += "SELECT r.oddzial_id,'',"
            sql += "r.opakowanie_id||'-'||a.nazwa as opakowanie_id,"
            sql += UstawSumy(filtr2, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id)),0,0,"
            sql += UstawSumy(filtr2, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id))"
            # sql += ",r.czas_zapisu::TEXT "
            sql += "\n\t,'poza zakresem dat','' "
            sql += "\nFROM rs_opakowania_rotacja r "
            sql += "JOIN rs_artykuly a ON r.firma_id=a.firma_id and r.opakowanie_id=a.artykul_id "
            sql += "\nWHERE r.firma_id='" + self.firma_id + "' "  # ,r.czas_zapisu"
            sql += filtr2
            sql += " \nAND  "
            sql += "NOT EXISTS (SELECT 1 FROM rs_opakowania_rotacja rr "
            #AB 13.11.18r
            sql += "WHERE rr.firma_id=r.firma_id "
            sql += filtr.replace('r.', 'rr.')
            sql += " AND r.opakowanie_id = rr.opakowanie_id) "
            sql += "\nGROUP BY r.firma_id,r.oddzial_id,r.opakowanie_id,"
            sql += "r.opakowanie_id||'-'||a.nazwa ;"



        elif Kierowca or Opakowanie:
            sql = "SELECT r.oddzial_id,r.kierowca_id||'-'||k.opis as kierowca_id,"
            sql += "r.opakowanie_id||'-'||a.nazwa as opakowanie_id,\n\t "
            sql += UstawSumy(filtr, 'stan_pocz')
            sql += "AND kk.oddzial_id = kkk.oddzial_id ) AND kk.kierowca_id = r.kierowca_id),SUM(r.wydania),SUM(r.przyjecia), \n\t"
            sql += UstawSumy(filtr, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id ) AND kk.kierowca_id = r.kierowca_id) ,'','' "
            sql += "\nFROM rs_opakowania_rotacja r "
            sql += "JOIN rs_kierowcy k ON r.firma_id=k.firma_id and r.kierowca_id=k.kod "
            sql += "JOIN rs_artykuly a ON r.firma_id=a.firma_id and r.opakowanie_id=a.artykul_id "
            sql += "\nWHERE r.firma_id='" + self.firma_id + "' " + filtr
            sql += "\nGROUP BY r.kierowca_id||'-'||k.opis,r.opakowanie_id||'-'||a.nazwa,"
            sql += "r.firma_id,r.oddzial_id,r.kierowca_id,r.opakowanie_id "
            sql += "\n\nUNION\n\n"
            sql += "SELECT r.oddzial_id,r.kierowca_id||'-'||k.opis as kierowca_id,"
            sql += "r.opakowanie_id||'-'||a.nazwa as opakowanie_id,\n\t "
            sql += UstawSumy(filtr2, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id)),0,0, \n\t"
            sql += UstawSumy(filtr2, 'stan_konc')
            sql += "AND kk.oddzial_id = kkk.oddzial_id))"
            sql += ",'poza zakresem dat','' "
            sql += "\nFROM rs_opakowania_rotacja r "
            sql += "JOIN rs_kierowcy k ON r.firma_id=k.firma_id and r.kierowca_id=k.kod "
            sql += "JOIN rs_artykuly a ON r.firma_id=a.firma_id and r.opakowanie_id=a.artykul_id "
            sql += "\nWHERE r.firma_id='" + self.firma_id + "' "  # ,r.czas_zapisu"
            sql += filtr2
            sql += " \nAND  "
            sql += "NOT EXISTS (SELECT 1 FROM rs_opakowania_rotacja rr "
            sql += "WHERE rr.firma_id=r.firma_id "
            sql += filtr.replace('r.', 'rr.') + " AND r.opakowanie_id = rr.opakowanie_id) "
            sql += "\nGROUP BY r.firma_id,r.oddzial_id,r.opakowanie_id,"
            sql += "r.opakowanie_id||'-'||a.nazwa,r.kierowca_id||'-'||k.opis;"
#AB 31.08.18r
        start = time()
        rsglobal.ZapiszDoLogow('Stary SQL:' + sql, 5)

        #AB 01.10.19r Zmiana na wykonanie nowego selecta
        # Uaga, wykonywany jest sel, ktry sklejamy sporo wyej, nie sql
        stat, dane, wyn1, dump = self.PolSQL.Execute(sel, 3)
        wykonania[sel] = [time() - start, datetime.now().isoformat(' ')]
        if stat != 'OK':
            stat = 'Bd pobrania danych rotacji opakowa: ' + stat
            dane.append(stat)
        else:
            #WS 2023-11-23
            dump,d,dump,dump = self.PolSQL.Execute("SELECT dopuszczalna_roznica FROM rs_oddzialy WHERE firma_id='{self.firma_id}' AND oddzial_id='{Oddzial}';".format(**locals()), 3)
            if len(d) == 0:
                wyn2.append(0)
            else:
                wyn2.append(d[0][0])

#AB 31.08.18r
wysylac = False
for key, value in wykonania.iteritems():
    #AB 17.04.19r
    if value[0] > 60:
        wysylac = True
if wysylac:
    rsglobal.RSWyslijEmail('abargiel@recordsystem.com.pl', 'Odnaleziono dugie wykonanie Selecta w Rotacji opakowa',
                           str(wykonania).replace('],',']<br>'),  [], 0, self.PolSQL)

# -------------------------------------------------------------------------------
# Tworzenie i zamykanie dokumentow magazynowych
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 21:
    stat = fs_rotacja_opakowan_pom.UtworzIZapiszDokumentyZRotacjiOpakowan(self, Oddzial)
