# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rotacja_opakowan_pom.py
# Purpose:     wczytuje dane rotacji opakowa
# Author:      Magda Kozlowska
# Created:     2017/08/01
# RCS-ID:      $Id: fs_rotacja_opakowan_pom.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Funkcje:
#



def UtworzIZapiszDokumentyZRotacjiOpakowan(self,Oddzial):
    import rsglobal
    
    # sprawdzic, ile dni od teraz nie byly tworzone dokumenty magazynowe
    # dla kazdego dnia najpierw utworzyc przychodowy i zamknac
    # potem rozchodowy i zamknac
    # przychodwy wg cen z wersji cenowej

    # Sprawdzenie czy dla podanego oddziau sa dane w rs_opakowania_rotacja_magazyny       #MK
    SQL = "SELECT magazyn_id,dokument_przyjecia,dokument_wydania,wersje_cenowe_id FROM rs_opakowania_rotacja_magazyny WHERE firma_id='%s' AND oddzial_id='%s';" % (
    self.firma_id, Oddzial)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        return u'Bd pobierania danych o dokumentach dla oddziau.'
    if len(dane) == 0:
        return u'Brak zdefiniowanych danych dokumentw magazynowych dla podanego oddziau.'
    Magazyn=dane[0][0]
    DokPrz=dane[0][1]
    DokWyd=dane[0][2]
    Wersja=dane[0][3]

    # Sprawdzenie czy istnieje definicja Magazynu w podanym Oddziale     #MK
    SQL = "SELECT magazyn_id FROM rs_magazyny WHERE firma_id='%s' AND oddzial_id='%s' and magazyn_id='%s';" % (self.firma_id, Oddzial, Magazyn)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        return u'Bd pobierania magazynu'
    if len(dane) == 0:
        return u'Magazyn '+Magazyn+' nie naley do oddziau '+Oddzial+'.'

    # Sprawdzenie czy zdefiniowany dokument przychodowy jest typu 'P'     #MK
    SQL = "SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='%s' and dokument_id='%s';" % (self.firma_id, DokPrz)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        return u'Bd pobierania typu dokumentu przychodowego.'
    if len(dane) == 0:
        return u'Brak definicji dokumentu '+DokPrz+'.'
    if dane[0][0]  <> 'P':
        return u'Dokument '+DokPrz+' nie jest przychodowym dokumentem magazynowym.'

    # Sprawdzenie czy zdefiniowany dokument rozchodowy jest typu 'W'     #MK
    SQL = "SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='%s' and dokument_id='%s';" % (self.firma_id, DokWyd)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        return u'Bd pobierania typu dokumentu rozchodowego.'
    if len(dane) == 0:
        return u'Brak definicji dokumentu '+DokWyd+'.'
    if dane[0][0] <> 'W':
        return u'Dokument '+DokWyd+' nie jest rozchodowym dokumentem magazynowym.'

    # Sprawdzenie czy istnieje wersja cenowa     #MK
    SQL = "SELECT kod FROM rs_wersje_cenowe WHERE firma_id='%s' and kod='%s';" % (self.firma_id, Wersja)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        return u'Bd pobierania wersji cenowej.'
    if len(dane) == 0:
        return u'Brak wersji cenowej '+Wersja+'.'

    # Wyznaczenie minimalnej daty, dla ktrej nie s jeszcze utworzone dokumenty magazynowe      #MK
    SQL = "SELECT min(cast(czas_zapisu as date)) as data FROM rs_opakowania_rotacja WHERE firma_id='%s' AND oddzial_id='%s' AND dm_numer is null;" % (self.firma_id, Oddzial)
    #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQL, 1)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        return u'Bd pobierania daty dokumentu'
    if len(dane) == 0:
        return u'Brak danych do utworzenia dokumentw magazynowych'
    DataOd=dane[0][0]
    if not rsglobal.SprawdzCzyToData(DataOd):
        return u'Brak danych do utworzenia dokumentw magazynowych'

    # Tworzenie dokumentw przychodowych i rozchodowych (w ptli) dla kadego dnia poczwszy od DataOd    #MK
    Data=DataOd
    while Data<=rsglobal.PodajDzis():

        # Pobranie iloci dla opakowa do dokumentu przychodowego     #MK
        SQLPRZ = "SELECT r.opakowanie_id,sum(r.przyjecia), a.przelicznik," \
                 "rsf_podaj_cene_n1('%s',r.opakowanie_id,'%s','PLN','%s'), rsf_podaj_cene_n2('%s',r.opakowanie_id,'%s','PLN','%s') " \
                 "FROM rs_opakowania_rotacja r " \
                 "INNER JOIN rs_artykuly a USING(firma_id) " \
                 "WHERE r.firma_id='%s' AND r.oddzial_id='%s' AND cast(czas_zapisu as date)='%s' and r.opakowanie_id=a.artykul_id and r.przyjecia>0 and r.dm_numer is null " \
                 "GROUP BY r.opakowanie_id, a.przelicznik; " % (self.firma_id, str(Wersja), str(Data), self.firma_id, str(Wersja), str(Data),self.firma_id, Oddzial,str(Data))
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLPRZ, 1)
        stat, daneprz, dump, dump = self.PolSQL.Execute(SQLPRZ, 3)
        if stat <> 'OK':
            return u'Bd pobierania sumy iloci przyjtych dla opakowania'
        if len(daneprz) > 0:
            SQLNUMSPR = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\']','M');" % (
                self.firma_id, Magazyn, DokPrz, str(Data))
            # rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLNUM, 1)
            stat, danenumspr, dump, dump = self.PolSQL.Execute(SQLNUMSPR, 3)
            if danenumspr[0][0] <> 'OK':
                return u'Ze wzgldu na sposb numeracji nie mona doda dokumentu '  + DokPrz +  ' z dat '  + Data +'.'

            SQLNUM = "SELECT rsf_podaj_nowy_numer_dokumentu('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\']','M');" % (
            self.firma_id, Magazyn, DokPrz, str(Data))
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLNUM, 1)
            stat, danenum, dump, dump = self.PolSQL.Execute(SQLNUM, 3)
            if stat <> 'OK':
                return u'Bd wyznaczania numeru dokumentu przychodowego.'
            if len(danenum) == 0:
                return u'Bd wyznaczania numeru dokumentu przychodowego.'
            Numer = danenum[0][0]

            # dodanie naglowka dokumentu przychodowego    #MK
            SQLINS = "INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_dokad,wersja) VALUES ('%s','%s','%s','%s',%s,'%s','%s');" % (
                self.firma_id, Magazyn, DokPrz, str(Data), str(Numer), Magazyn, Wersja)
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLINS, 1)
            stat, nroid, dump, dump = self.PolSQL.Execute(SQLINS, 1)
            if stat <> 'OK':
                return u'Bd dodawania przychodowego dokumentu magazynowego'

            # dodanie pozycji dokumentu przychodowego     #MK
            SQLINSPOZ = "INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,cena1,cena2,cena_wal1, cena_wal2) " \
                        "VALUES ('%s','%s','%s','%s',%s,%s,%s,'%s',%s,%s,%s,%s,%s,%s);"
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLINSPOZ, 1)

            nr_poz = 0
            for opakowanie in daneprz:
                Artykul = opakowanie[0]
                Ilosc = opakowanie[1]
                Przelicznik = opakowanie[2]
                Cena1 = opakowanie[3]
                Cena2 = opakowanie[4]
                nr_poz+=1

                stat, dump, dump, dump = self.PolSQL.Execute(SQLINSPOZ % (self.firma_id, Magazyn, DokPrz, str(Data), str(Numer), str(nr_poz), '0', Artykul, str(Ilosc),
                    str(round(Ilosc * Przelicznik, 4)), str(Cena1), str(Cena2), str(Cena1), str(Cena2)), 1)
                if stat <> 'OK':
                    return u'Bd dodawania pozycji dokumentu przychodowego'

            # wyznaczenie kwoty i kwoty walutowej przychodowego dokumentu magazynowego     #MK
            SQLKWOTA = "UPDATE rs_dokumenty_magazynowe set kwota=(select sum(ilosc1*cena1) from rs_dokumenty_magazynowe_pozycje where firma_id='%s' and magazyn_id='%s' and dokument_id='%s' and data='%s' and numer=%s), " \
                       "kwota_wal=(select sum(ilosc1*cena_wal1) from rs_dokumenty_magazynowe_pozycje where firma_id='%s' and magazyn_id='%s' and dokument_id='%s' and data='%s' and numer=%s) " \
                       "WHERE firma_id='%s' and magazyn_id='%s' and dokument_id='%s' and data='%s' and numer=%s " \
                       % (self.firma_id, str(Magazyn), str(DokPrz), str(Data), str(Numer), self.firma_id, str(Magazyn), str(DokPrz), str(Data), str(Numer), self.firma_id, str(Magazyn), str(DokPrz), str(Data), str(Numer))
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLKWOTA, 1)
            stat, dump, dump, dump = self.PolSQL.Execute(SQLKWOTA, 1)
            if stat<> 'OK':
                return u'Bd wyznaczania kwoty dokumentu przychodowego'

            # zamknicie dokumentu przychodowego z W na G
            Klucze = {}
            Klucze['Mag'] = Magazyn
            Klucze['Typ'] = DokPrz
            Klucze['Data'] = Data
            Klucze['Numer'] = Numer
            Klucze['Funkcja'] = 18

            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
            if stat <> 'OK':
                return str(u'Bd zamknicia dokumentu ' + Magazyn + '/' + DokPrz+ '/' + Data + '/' + Numer +  ' z W na G: ' + stat)
                #rsglobal.ZapiszDoLogow('MAGDA SQL 7 G na Z', 1)

            # zamknicie dokumentu przychodowego z G na Z
            Klucze['Funkcja'] = 29
            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
            if stat <> 'OK':
                return str(u'Bd zamknicia dokumentu ' + Magazyn + '/' + DokPrz+ '/' + Data + '/' + Numer +  ' z G na Z : ' + stat)
            #rsglobal.ZapiszDoLogow('MAGDA SQL 8 ', 1)

            # wpisanie klucza dokumentu przychodowego w rs_opakowania_rotacja     #MK
            SQLROT = "UPDATE rs_opakowania_rotacja SET dm_magazyn='%s', dm_id='%s', dm_data='%s', dm_numer=%s " \
                     "WHERE firma_id='%s' and oddzial_id='%s' and cast(czas_zapisu as date)='%s' and przyjecia>0 and dm_numer is null " % (str(Magazyn), str(DokPrz), str(Data), str(Numer), self.firma_id, str(Oddzial), str(Data))
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLROT, 1)
            stat, dump, dump, dump = self.PolSQL.Execute(SQLROT, 1)
            if stat <> 'OK':
                return u'Bd uzupenienia danych dokumentu przychodowego w rotacji opakowa'

            self.PolSQL.CommitCzysty()

        # Pobranie iloci dla opakowa do dokumentu rozchodowego    #MK
        SQLWYD = "SELECT r.opakowanie_id, sum(r.wydania), a.przelicznik FROM rs_opakowania_rotacja r " \
                 "INNER JOIN rs_artykuly a USING(firma_id) " \
                 "WHERE r.firma_id='%s' AND r.oddzial_id='%s' AND cast(czas_zapisu as date)='%s' and r.opakowanie_id=a.artykul_id and r.wydania>0 and r.dm_numer is null " \
                 "GROUP BY r.opakowanie_id, a.przelicznik; " % (self.firma_id, Oddzial, str(Data))
        #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLWYD, 1)
        stat, danewyd, dump, dump = self.PolSQL.Execute(SQLWYD, 3)
        if stat <> 'OK':
            return u'Bd pobierania sumy iloci wydanych dla opakowania'
        if len(danewyd) > 0:
            SQLNUMSPRW = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\']','M');" % (
                self.firma_id, Magazyn, DokWyd, str(Data))
            # rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLNUM, 1)
            stat, danenumsprw, dump, dump = self.PolSQL.Execute(SQLNUMSPRW, 3)
            if danenumsprw[0][0] <> 'OK':
                return u'Ze wzgldu na sposb numeracji nie mona doda dokumentu ' + DokWyd + ' z dat ' + Data + '.'
            SQLNUMW = "SELECT rsf_podaj_nowy_numer_dokumentu('%s','[\\\'%s\\\',\\\'%s\\\',\\\'%s\\\']','M');" % (
                self.firma_id, Magazyn, DokWyd, str(Data))
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLNUMW, 1)
            stat, danenumw, dump, dump = self.PolSQL.Execute(SQLNUMW, 3)
            if stat <> 'OK':
                return u'Bd wyznaczania numeru dokumentu rozchodowego.'
            if len(danenumw) == 0:
                return u'Bd wyznaczania numeru dokumentu rozchodowego.'
            Numer = danenumw[0][0]

            # dodanie naglowka dokumentu rozchodowego    #MK
            SQLINSW = "INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,magazyn_skad) VALUES ('%s','%s','%s','%s',%s,'%s');" % (
                self.firma_id, Magazyn, DokWyd, str(Data), str(Numer), Magazyn)
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLINSW, 1)
            stat, nroid, dump, dump = self.PolSQL.Execute(SQLINSW, 1)
            if stat <> 'OK':
                return u'Bd dodawania rozchodowego dokumentu magazynowego'

            # dodanie pozycji dokumentu rozchodowego     #MK
            SQLINSPOZW = "INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2) " \
                            "VALUES ('%s','%s','%s','%s',%s,%s,%s,'%s',%s,%s);"
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLINSPOZW, 1)

            nr_poz = 0
            for opakowanie in danewyd:
                Artykul = opakowanie[0]
                Ilosc = opakowanie[1]
                Przelicznik = opakowanie[2]
                nr_poz += 1

                stat, dump, dump, dump = self.PolSQL.Execute(SQLINSPOZW % (self.firma_id, Magazyn, DokWyd, str(Data), str(Numer), str(nr_poz), '0', Artykul, str(Ilosc), str(round(Ilosc * Przelicznik, 4))), 1)
                if stat <> 'OK':
                    return u'Bd dodawania pozycji dokumentu rozchodowego'

            # zamknicie dokumentu rozchodowego z W na G
            Klucze = {}
            Klucze['Mag'] = Magazyn
            Klucze['Typ'] = DokWyd
            Klucze['Data'] = Data
            Klucze['Numer'] = Numer
            Klucze['Funkcja'] = 18

            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
            if stat <> 'OK':
                #rsglobal.ZapiszDoLogow('MAGDA SQL komunikat'+str('Bd zamknicia dokumentu ' + DokWyd +  'z W na G: ' + stat+ str(Klucze)), 1)
                return str(u'Bd zamknicia dokumentu ' + Magazyn + '/' + DokWyd+ '/' + Data + '/' + Numer +  ' z W na G: ' + stat)
            #rsglobal.ZapiszDoLogow('MAGDA SQL 7 G na Z', 1)

            # zamknicie dokumentu z G na Z
            Klucze['Funkcja'] = 29
            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [], False)
            if stat <> 'OK':
                return str(u'Bd zamknicia dokumentu ' + Magazyn + '/' + DokWyd+ '/' + Data + '/' + Numer +  ' z G na Z : ' + stat)
            #rsglobal.ZapiszDoLogow('MAGDA SQL 8 ', 1)

            # wpisanie klucza dokumentu w rs_opakowania_rotacja     #MK
            SQLROTW = "UPDATE rs_opakowania_rotacja SET dm_magazyn='%s', dm_id='%s', dm_data='%s', dm_numer=%s" \
                         "WHERE firma_id='%s' and oddzial_id='%s' and cast(czas_zapisu as date)='%s' and wydania>0 and dm_numer is null " % (
                         str(Magazyn), str(DokWyd), str(Data), str(Numer), self.firma_id, str(Oddzial), str(Data))
            #rsglobal.ZapiszDoLogow('MAGDA SQL:' + SQLROTW, 1)
            stat, dump, dump, dump = self.PolSQL.Execute(SQLROTW, 1)
            if stat <> 'OK':
                return u'Bd uzupenienia danych dokumentu rozchodowego w rotacji opakowa'

            self.PolSQL.CommitCzysty()

        Data=rsglobal.PrzesunDateODni(Data,1)

    return 'OK'