# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rozbij_pozycje_dokumentu_magazynowego
# Purpose:     
#
# Author:      Michal Raburski
#
# Created:     2006/02/15
# RCS-ID:      $Id: fs_rozbij_pozycje_dokumentu_magazynowego.py $
# Copyright:        (c) 2008 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#2011.02.02 - Mariusz Rajfura - nowe pole 'produkt_id' (4223)
#2011.04.11 - Mariusz Rajfura - uaktualnienie wirtualnych artykulow-przyjecia (4458)

import math
from funkcje import fs_dokumenty_magazynowe_lokacje_pom

Mag = rsglobal.Dekoduj(klucze[0])
Dok = rsglobal.Dekoduj(klucze[1])
Data = rsglobal.Dekoduj(klucze[2])
Numer = klucze[3]
NrPoz = klucze[4]
Fun = klucze[-1]

stat='OK'

CzyLokSkad=False
CzyLokDokad=False
LLokacji=[]
   
#-------------------------------------------------------------------------------
# ROZBICIE (1)
#-------------------------------------------------------------------------------

if Fun==1:
    #sprawdzenie stanu dokumentu i jego typu
    Filtr="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)
    
    SQLStan="SELECT stan,f_wyznacznik_id,f_data,f_numer,k_wyznacznik_id,k_data,k_numer," # 0-6
    SQLStan+="COALESCE(magazyn_skad,''),COALESCE(magazyn_dokad,'') " # 7-8
    SQLStan+=" FROM rs_dokumenty_magazynowe "+Filtr 
    stat,dstan,dump,dump=self.PolSQL.Execute(SQLStan,2)
    
    if stat=='OK':
        #jesli G to otwarcie dokumentu
        if len(dstan)==0:
            stat='Brak wybranego dokumentu magazynowego'
        elif dstan[0][0] not in ('W','G'):
            stat='Dokument nie jest w stanie W lub G - rozbicie niemoliwe'
    
    # sprawdzenie czy otwierana pozycja miaa tabelk. Jeli tak to rozbicie niemoliwe 
    if stat=='OK':
        if dstan[0][0]=='G':
            SQLTestPoz="SELECT czy_lokacje FROM rs_dokumenty_magazynowe_pozycje "+Filtr+" AND nr_poz="+str(NrPoz)+";"
            stat,DTestPoz,dump,dump=self.PolSQL.Execute(SQLTestPoz,2)
            if stat=='OK':
                if len(DTestPoz)==0:
                    stat='Brak wybranej pozycji dokumentu magazynowego'
                elif DTestPoz[0][0]:
                    stat='Wybrana pozycja posiada tabelk z lokacjami - rozbicie jej ze stanu G jest niemoliwe.'
     
    #-----------------------------------------------------------------------
    # OBSUGA LOKACJI
    #-----------------------------------------------------------------------
    # sprawdzenie, czy po rozbiciu artyku zmieci si na lokacji. Jeli tak to przygotowanie danych do update'u
    # UWAGA - jeli stan jest G i byy dane z tabelki z lokacjami to rozbicie bdzie niemoliwe. W przeciwnym wypadku
    # albo wszystko byo wpisane na pozycjach, albo tabelki w stanie W s ignorowane 
    # (i trzeba o nie pomniejszy iloci na lokacjach)
    # robimy to tylko gdy lokacje prowadzone s wzgldem drugiej jednostki miar
    if stat=='OK':
        if self.lokacje_jm=='2':
            MagSkad=rsglobal.Dekoduj(dstan[0][7])
            MagDokad=rsglobal.Dekoduj(dstan[0][8])
            
            if MagSkad<>'':
                # sprawdzenie czy lokacje bd uywane
                sql ="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagSkad+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania informacji o magazynie SKD: '+stat
                    dane.append(stat)
                elif len(d) <> 1:
                    stat = 'Brak magazynu SKD'
                    dane.append(stat)
                    
                if stat=='OK':
                    CzyLokSkad=d[0][0]
            
            if stat=='OK' and MagDokad<>'':
                sql ="SELECT czy_lokacje FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagDokad+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania informacji o magazynie DOKD: '+stat
                    dane.append(stat)
                elif len(d) <> 1:
                    stat = 'Brak magazynu DOKD'
                    dane.append(stat)
                
                if stat=='OK':
                    CzyLokDokad=d[0][0]    
            
            # jeli jest to m.in. dokument wydania (MM,WZ itp) to zmieniamy "do_wydania" funkcjami
            if stat=='OK' and CzyLokSkad:
                stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Numer,NrPoz,'-',True,False)                   
            
    if stat=='OK':
        Stan=dstan[0][0]

        #-----------------------------------------------------------------------
        # ROZBIJANIE W STANIE "G"
        #-----------------------------------------------------------------------
        # jeli stan G to rozbijamy pozycj bez przechodzenia przez stan W
        if Stan=='G':
            # sprawdzamy czy mona rozbi pozycj na podpozycje
            SQL="SELECT nr_ppoz,ilosc1,czy_rozbicie FROM rs_dokumenty_magazynowe_pozycje "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
            SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+";"
            stat,DTestPoz,dump,dump=self.PolSQL.Execute(SQL,2)
            if stat=='OK':
                for poz in DTestPoz:
                    if stat=='OK':
                        ilosc=poz[1]
                        c,d=math.modf(ilosc)
                        if c <> 0:
                            stat='Niecakowita ilo w rozbijanej pozycji - rozbicie niemoliwe'
                        elif poz[2]:
                            stat='W podanym numerze pozycji istniej rozbite podpozycje - rozbicie niemoliwe'
 

            # jeli tak to przenumerowujemy nr ppoz na ujemny i kopiujemy kad pozycj odpowiedni liczb razy.
            if stat=='OK':
                SQL="UPDATE rs_dokumenty_magazynowe_pozycje SET nr_ppoz=-1*nr_ppoz "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
                SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+";"
                
                i=1
                for poz in DTestPoz:
                    for j in xrange(poz[1]):
                        SQL+="INSERT INTO rs_dokumenty_magazynowe_pozycje "
                        SQL+="(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
                        SQL+="artykul_id,ilosc1,ilosc2,cena1,cena2,nr_serii,termin_przyd,cena_wal1,cena_wal2,"
                        SQL+="dokument_przych,czy_cena,czy_seria,czy_rozbicie,dostawca_id,lokacja_skad,lokacja_dokad,"
                        SQL+="cecha1_opis,cecha1_wartosc,zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,"
                        SQL+="produkt_id,wejscie_data,wejscie_magazyn,opakowanie_id,paleta_id,wsp_ilosci_opakowanie,"
                        SQL+="wsp_ilosci_paleta,wsp_ilosci_lokacja) "
                        SQL+=" SELECT firma_id,magazyn_id,dokument_id,data,numer,nr_poz,"+str(i)+","
                        SQL+="artykul_id,1,ROUND(ilosc2/ilosc1,4),cena1,cena2,nr_serii,termin_przyd,cena_wal1,cena_wal2,"
                        SQL+="dokument_przych,czy_cena,czy_seria,TRUE,dostawca_id,lokacja_skad,lokacja_dokad,"
                        SQL+="cecha1_opis,cecha1_wartosc,zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,"
                        SQL+="produkt_id,wejscie_data,wejscie_magazyn,opakowanie_id,paleta_id,wsp_ilosci_opakowanie, "
                        SQL+="wsp_ilosci_paleta,wsp_ilosci_lokacja"
                        SQL+=" FROM rs_dokumenty_magazynowe_pozycje "
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"'"
                        SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
                        SQL+=" AND nr_ppoz="+str(-1*poz[0])+";"
                        i=i+1
                        
            # usuwamy pozycje z ujemnym nr_ppoz.
            if stat=='OK':
                SQL+="DELETE FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+Data+"'"
                SQL+=" AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz<=0;"
               
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            
            # przeliczamy ilo lokacyjn na nowo utworzonych pozycjach
            if stat=='OK':
                from funkcje import fs_dokumenty_magazynowe_lokacje_pom
                stat = fs_dokumenty_magazynowe_lokacje_pom.UstawWspIIloscLokacyjnaNaDM(self,Mag,Dok,Data,Numer,NrPoz,0,True)
            
        #-----------------------------------------------------------------------
        # ROZBIJANIE W STANIE "W"
        #-----------------------------------------------------------------------
         
        elif Stan=='W':               
            if stat=='OK':
                #sprawdzenie czy jest tylko 1 taka pozycja
                SQL="SELECT artykul_id,ilosc1,ilosc2,cena1,cena2,nr_serii,termin_przyd,cena_wal1,cena_wal2," # 0 - 8
                SQL+="dokument_przych,czy_cena,czy_seria,dostawca_id,lokacja_skad,lokacja_dokad,cecha1_opis,cecha1_wartosc," # 9 -16
                SQL+="zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,produkt_id," # 17 - 22
                SQL+="COALESCE(opakowanie_id,''),COALESCE(paleta_id,''),COALESCE(wsp_ilosci_opakowanie,0),"# 23 - 25
                SQL+="COALESCE(wsp_ilosci_paleta,0),COALESCE(wsp_ilosci_lokacja,0)" # 26 - 27
                SQL+=" FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
                SQL+=" AND dokument_id='"+Dok+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0;"
            
                stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,2)
            
            if stat=='OK':    
                if len(dane)==0:
                    stat='Nie mona rozbija podpozycji na podpozycje'
                elif len(dane) > 1:
                    stat='Za duo pozycji o tym numerze'
            
            if stat=='OK':
                ilosc=dane[0][1]
                c,d=math.modf(ilosc)
                if c <> 0:
                    stat='Niecakowita ilo'
                    
            if stat=='OK':        
                #wykonanie podzialu
                art=rsglobal.Dekoduj(dane[0][0])
                il2=dane[0][2]/dane[0][1]
                cena1=dane[0][3]
                cena2=dane[0][4]
                seria=rsglobal.Dekoduj(dane[0][5])
                if seria in (None,'None'):
                    seria="NULL"
                else:
                    seria = "'"+seria+"'"
                    
                termin=dane[0][6]
                if termin == 'None':
                    termin="NULL"
                else:
                    termin = "'"+termin+"'"
                cenaw1=dane[0][7]
                cenaw2=dane[0][8]
                dp=rsglobal.Dekoduj(dane[0][9])
                czyc=dane[0][10]
                if czyc:
                    czyc='TRUE'
                else:
                    czyc='FALSE'
                czys=dane[0][11]
                if czys:
                    czys='TRUE'
                else:
                    czys='FALSE'
                    
                dost=rsglobal.Dekoduj(dane[0][12])
                if dost in (None,'None'):
                    dost='NULL'
                else:
                    dost="'"+dost+"'"
            
                LokSkad=dane[0][13]
                if LokSkad in (None,'None'):
                    LokSkad='NULL'
                else:
                    LokSkad="'"+rsglobal.Dekoduj(LokSkad)+"'"
                    
                LokDokad=dane[0][14]
                if LokDokad in (None,'None'):
                    LokDokad='NULL'
                else:
                    LokDokad="'"+rsglobal.Dekoduj(LokDokad)+"'"
                    
                CechaOpis=dane[0][15]
                if CechaOpis in (None,'None'):
                    CechaOpis='NULL'
                else:
                    CechaOpis="'"+rsglobal.Dekoduj(CechaOpis)+"'"
            
                CechaWart=dane[0][16]
                if CechaWart in (None,'None'):
                    CechaWart='NULL'
                else:
                    CechaWart="'"+rsglobal.Dekoduj(CechaWart)+"'"
                    
                ZOWyzn=dane[0][17]
                if ZOWyzn in (None,'None'):
                    ZOWyzn='NULL'
                    ZOData='NULL'
                    ZONr='NULL'
                    ZONrPoz='NULL'
                    ZONrPPoz='NULL'
                else:
                    ZOWyzn="'"+rsglobal.Dekoduj(ZOWyzn)+"'"
                    ZOData="'"+rsglobal.Dekoduj(dane[0][18])+"'"
                    ZONr=str(dane[0][19])
                    ZONrPoz=str(dane[0][20])
                    ZONrPPoz=str(dane[0][21])

                Produkt=dane[0][22]
                if Produkt in (None,'None'):
                    Produkt='NULL'
                else:
                    Produkt="'"+rsglobal.Dekoduj(Produkt)+"'"
                    
                if dane[0][23] == '':
                    Opak='NULL'
                else:
                    Opak="'"+rsglobal.Dekoduj(dane[0][23])+"'"
                    
                if dane[0][24] == '':
                    Paleta='NULL'
                else:
                    Paleta="'"+rsglobal.Dekoduj(dane[0][24])+"'"
                    
                WspOpak = str(dane[0][25])
                WspPaleta = str(dane[0][26])
                WspLokacja = str(dane[0][27])
            
                Insert="INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
                Insert+="artykul_id,ilosc1,ilosc2,cena1,cena2,nr_serii,termin_przyd,cena_wal1,cena_wal2,dokument_przych,"
                Insert+="czy_cena,czy_seria,czy_rozbicie,dostawca_id,lokacja_skad,lokacja_dokad,cecha1_opis,cecha1_wartosc,"
                Insert+="zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,produkt_id,"
                Insert+="opakowanie_id,paleta_id,wsp_ilosci_opakowanie,wsp_ilosci_paleta,wsp_ilosci_lokacja)"
                Insert+=" VALUES('"+self.firma_id+"','"+Mag+"','"+Dok+"','"+Data+"',"+str(Numer)+","+str(NrPoz)+",%s,"
                Insert+="'"+art+"',1,"+str(il2)+","+str(cena1)+","+str(cena2)+","+seria+","+termin+","+str(cenaw1)+","
                Insert+=str(cenaw2)+",'"+dp+"',"+czyc+","+czys+",TRUE,"+dost+","+LokSkad+","+LokDokad+","+CechaOpis
                Insert+=","+CechaWart+","+ZOWyzn+","+ZOData+","+ZONr+","+ZONrPoz+","+ZONrPPoz+","+Produkt+","
                Insert+=Opak+","+Paleta+","+WspOpak+","+WspPaleta+","+WspLokacja+");"
            
                SQLPoz=''
                i=1
                while i <= ilosc:
                    SQLPoz+=Insert % (str(i))
                    i=i+1
                
                if SQLPoz <> '':    
                    SQLPoz+="DELETE FROM rs_dokumenty_magazynowe_pozycje "+Filtr+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0;"
                    
                    stat,dump,dump,dump=self.PolSQL.Execute(SQLPoz,1)
                
    # jeli jest dokument wydania i jest ok to zmieniamy "do_wydania" funkcjami
    if stat=='OK' and CzyLokSkad:
        stat=fs_dokumenty_magazynowe_lokacje_pom.ZmienIlosciDoWydaniaWLokacjach(self,Mag,Dok,Data,Numer,NrPoz,'+',True,True)   

    # jeli jest dokument przyjecia i jest ok i druga jednostka jest na lokacjach to zmieniamy "zajete" funkcjami
    # i sprawdzamy poprawno danych na lokacjach
    if stat=='OK':
        # odwieenie wirtualnych artykuw przyjcia
        stat=fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Mag,Dok,Data,Numer,NrPoz)
            
