# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rozliczenia_miedzyokresowe_dekretacja.py
# Purpose:     Dekretuje rozliczenia
# Author:      Marcin Wlodarczyk
# Modyfikacja: Jan Raburski
# Created:     2008/08/11
# RCS-ID:      $Id: fs_rozliczenia_miedzyokresowe_dekretacja.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 29-11-2010 - Mariusz Rajfura - pobieranie checkboxa 'pobierac_na_rejestr' z pierwszej pozycji
#              wzoru dekretacji przy tworzeniu dekretow dla rozliczen miedzyokresowych  mantis:4103
# 2013-01-10 Mariusz Rajfura (6135)  mozliwosc tworzenia korekty (kwoty ujemne)

Dowod = klucze[0]
Nazwa = klucze[1]
DataKsiegowania = klucze[2]
Konto_ma = klucze[3]
Grupa = klucze[4]
Numer = 1
NumerPozycji=1
stat = "OK"
dane = []
rozliczenie = []
KwotaCalkowita = 0
NumerPozycji = 0 

UprDekretacji = ((self.oddzial_id,'173016') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

if not UprDekretacji:
    stat='UPR DEK'    
    dane.append(stat)

if stat == 'OK':
    if DataKsiegowania == '    -  -  ':
        stat='PUS DATA'
        dane.append(stat)
    elif not rsglobal.SprawdzCzyToData(DataKsiegowania): 
        stat='BL DATA'
        dane.append(stat)

if stat == 'OK':
    query ="SELECT odpis_data FROM rs_rozliczenia_miedzyokresowe"
    query+=" WHERE firma_id='"+self.firma_id+"' AND ABS(kwota_akt)>0 AND"
    query+=" ((odpis_data IS NOT NULL AND"
    query+=" odpis_data < date(date '"+str(DataKsiegowania[:8])+"01' - interval '1 month')) or"
    query+=" (odpis_data IS NULL AND data_pierwszego_odpisu < date(date '"+str(DataKsiegowania[:8])+"01')))"
    if Grupa<>'':
        query+= " AND grupa='"+str(Grupa)+"'"
    query+= ";"
    stat,dane,dump,dump = self.PolSQL.Execute(str(query),3)
    if len(dane)>0:
        stat= 'BL DEKR'
        dane.append(stat)

if stat == 'OK':
    query ="SELECT odpis_data FROM rs_rozliczenia_miedzyokresowe"
    query+=" WHERE firma_id='"+self.firma_id+"' AND odpis_data >'"+str(DataKsiegowania[:8])+"01'"
    query+=" AND odpis_data< date(date '"+str(DataKsiegowania[:8])+"01' +interval '1 month')"
    query+=" AND ABS(kwota_akt)>0"
    if Grupa<>'':
        query+= " AND grupa='"+str(Grupa)+"'"
        query+= ";"
    stat,dane,dump,dump = self.PolSQL.Execute(str(query),3)
    if len(dane)>0:
        stat= 'BL DEKR IST'
        dane.append(stat)

if stat == 'OK':
    query ="SELECT odpis_data FROM rs_rozliczenia_miedzyokresowe"
    query+=" WHERE firma_id='"+self.firma_id+"' AND odpis_data>'"+str(DataKsiegowania)+"'"
    query+=" AND ABS(kwota_akt)>0"
    if Grupa<>'':
        query+= " AND grupa='"+str(Grupa)+"'"
        query+= ";"
    stat,dane,dump,dump = self.PolSQL.Execute(str(query),3)
    if len(dane)>0:
        stat= 'BL DEKR WCZESN'
        dane.append(stat)

if stat=='OK' and Grupa<>'':
    sql="SELECT kod FROM rs_grupy_rozliczen WHERE firma_id='"+self.firma_id+"' AND kod='"+Grupa+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if len(d) == 0 :
        stat = "BL GRUPA"
        dane.append(stat)
   
if str(Konto_ma) == '' and stat == 'OK':
    stat = "PUS KONTO"
    dane.append(stat)

if (str(Dowod) == '' or str(Nazwa) == '') and stat == 'OK':
    stat = "PUS DOWOD"
    dane.append(stat)

if stat=='OK':
    sql ="SELECT wd.firma_id, wd.okres_id, wd.dowod_id, wd.nazwa_id, wd.typ_wzoru,"
    sql+=" wdp.pobierac_na_rejestr"
    sql+=" FROM rs_wzory_dekretacji wd"
    sql+=" INNER JOIN rs_wzory_dekretacji_pozycje wdp ON"
    sql+=" (wd.firma_id=wdp.firma_id AND wd.okres_id=wdp.okres_id"
    sql+="  AND wd.dowod_id=wdp.dowod_id AND wd.nazwa_id=wdp.nazwa_id AND wdp.nr_poz=1)"
    sql+=" WHERE wd.firma_id='"+self.firma_id+"' AND wd.okres_id='"+self.okres_id+"'"
    sql+=" AND wd.dowod_id='"+str(Dowod)+"' AND wd.nazwa_id='"+str(Nazwa)+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if len(d) == 0 :
        stat = "BL DOWOD"
        dane.append(stat)
    else:
        if d[0][4]!="S":
            stat = "BL TYP DOWODU"
            dane.append(stat)
        elif d[0][2] in ('BO','BK'):
            stat = "BL DOWOD BO BK"
            dane.append(stat)
        else:
            PobieracNaRejestr = str(d[0][5])
        
if stat =='OK': 
    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+Konto_ma+"');"
    DaneTmp = self.PolSQL.Execute(sql,3)[1]
    if (DaneTmp <> []) and (DaneTmp <> None):
        Dane = rsglobal.rseval(DaneTmp[0][0])
    if Dane[0] == '':
        stat='BL_KONTO_MA'
        dane.append(stat) 

if stat == 'OK': 
    sql ="SELECT fk_od,fk_do FROM rs_zakresy_dat WHERE firma_id = '"+self.firma_id+"';"
    stat,data,dump,dump = self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        ZakresDataOd = data[0][0]
        ZakresDataDo = data[0][1]
        if ZakresDataOd <> 'None':
            if DataKsiegowania < ZakresDataOd:
                stat = 'BL ZAKRES DATA'
                dane.append(stat)
        if ZakresDataDo <> 'None':
            if DataKsiegowania > ZakresDataDo:
                stat = 'BL ZAKRES DATA'
                dane.append(stat)

if stat == 'OK':    
    sql ="SELECT data_od,data_do FROM rs_definicje_okresow WHERE firma_id = '"+self.firma_id+"'"
    sql+=" AND okres_id = '"+self.okres_id+"';"
    stat,data,dump,dump = self.PolSQL.Execute(sql,3)
    OkresOd = data[0][0]
    OkresDo = data[0][1]
    if not (DataKsiegowania <= OkresDo and DataKsiegowania >= OkresOd):
        stat='BL OKRES DATA'
        dane.append(stat)
    
if stat == "OK":
    sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+self.okres_id+"\\\',"
    sql+="\\\'"+Dowod+"\\\',\\\'"+Nazwa+"\\\',\\\'"+DataKsiegowania+"\\\']','D');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        if len(dane)==1:
            if dane[0][0] <> 'OK':
                stat='BL DOWOD DATA'
                dane.append(stat)
                
if stat == 'OK':
    sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+self.okres_id+"\\\',"
    sql+="\\\'"+Dowod+"\\\',\\\'"+Nazwa+"\\\',\\\'"+DataKsiegowania+"\\\']','D');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)        
    Numer = rsglobal.Dekoduj(dane[0][0])

# wlasciwy zapis            
if stat == 'OK' and UprDekretacji:
    query ="INSERT INTO rs_dowody_ksiegowe (firma_id, okres_id, dowod_id,nazwa_id,data,numer,stan,kwota_wn, " 
    query+= "kwota_ma,data_wyst) "
    query+= "VALUES ('"+self.firma_id+"','"+self.okres_id+"', '"+Dowod+"', '"+Nazwa+"', '"+DataKsiegowania+"',"
    query+= "'"+str(Numer)+"','W',0,0,'"+DataKsiegowania+"');"
    stat,dump,dump,dump = self.PolSQL.Execute(str(query),1)

if stat=="OK":
    query ="SELECT konto,opis,kwota_akt,odpis_kwota,odpis_ostatni,projekt_id,"
    query+=" numer,kwota_pierwszego_odpisu,odpis_data,kwota_pocz" 
    query+=" FROM rs_rozliczenia_miedzyokresowe WHERE firma_id='"+self.firma_id+"'" 
    query+=" AND abs(kwota_akt)>0 AND (odpis_data<'"+str(DataKsiegowania)+"'"
    query+=" OR odpis_data IS NULL) AND (data_pierwszego_odpisu <= '"+str(DataKsiegowania)+"'"
    query+=" OR data_pierwszego_odpisu IS NULL)" 
    if Grupa<>'':
        query+=" AND grupa='"+Grupa+"'"
    query+=";"
    stat,data,dump,dump = self.PolSQL.Execute(str(query),3)
    if stat=='OK':
        if len(data)==0:
            stat ='BRAK ROZL'
        else:
            for rozliczenie in data:
                Konto_wn = rozliczenie[0]
                Tresc = rozliczenie[1]
                
                # wszystkie kwoty obliczamy jako dodatnie
                # w przypadku korekt na koniec zamieniamy je na ujemne
                KwotaAktualna = abs(rozliczenie[2])
                Kwota = abs(rozliczenie[3])
                KwotaOstatniego = abs(rozliczenie[4])
                Projekt = rozliczenie[5]    
                NumerRozliczenia = rozliczenie[6]
                KwotaPierwszegoOdpisu = abs(rozliczenie[7])
                DataOdpisu = rozliczenie[8]
                NumerPozycji+= 1

                # kwota_pocz decyduje, czy to korekta, czy nie
                KwotaPocz = rozliczenie[9]
                Korekta = False
                if KwotaPocz < 0:
                    Korekta = True
                
                if str(DataOdpisu) in [ "None", None, '' ] and not KwotaPierwszegoOdpisu in [0,None]:
                    Kwota=KwotaPierwszegoOdpisu
                if (KwotaAktualna == KwotaOstatniego) and stat=='OK':
                    Kwota=KwotaOstatniego
                KwotaCalkowita+=Kwota
                
                if Korekta:
                    #zamian kwot na ujemne
                    Kwota = 0-Kwota
                    KwotaCalkowita = 0-KwotaCalkowita
            
                query = "INSERT INTO rs_dowody_ksiegowe_pozycje ("
                query+= " firma_id, okres_id, dowod_id,"
                query+= " nazwa_id,data,numer,"
                query+= " kwota_wn, kwota_ma, kwota_wal_wn, kwota_wal_ma," 
                query+= " projekt_wn, projekt_ma, konto_wn, konto_ma,"
                query+= " tresc_wn, tresc_ma, nr_pozw, nr_ppoz,nr_poz,"
                query+= " data_wyst,pobierac_na_rejestr)"
                query+= " VALUES ("
                query+= "'"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"',"
                query+= "'"+Nazwa+"', '"+DataKsiegowania+"',"+str(Numer)+","
                query+= str(Kwota)+","+str(Kwota)+","+str(Kwota)+","+str(Kwota)+",'"
                query+= Projekt+"','"+Projekt+"','"+Konto_wn+"','"+Konto_ma+"',"
                query+= "'"+Tresc+"','"+Tresc+"',1,0,'"+str(NumerPozycji)+"',"
                query+= "'"+DataKsiegowania+"',"+PobieracNaRejestr+");"
                
                stat,dump,dump,dump = self.PolSQL.Execute(str(query),1)
                if stat=='OK':
                    # UWAGA:
                    # kwota_akt=kwota_akt- "+str(Kwota) musi byc z odstepem, bo w przypadku
                    # kwot ujemnych powstanie znak komentarza czyli np. SET kwota_akt=kwota_akt--200.0,....
                    # i dalsza czesc sql-a nie bedzie wykonywana,
                    # a UPDATE ZMODYFIKUJE WSZYSTKIE ROZLICZENIA !!!
                    
                    query ="UPDATE rs_rozliczenia_miedzyokresowe SET kwota_akt=kwota_akt- "+str(Kwota)+","
                    query+=" odpis_data='"+str(DataKsiegowania)+"' WHERE numer="+str(NumerRozliczenia)+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(str(query),1)
                    
if stat == 'OK' and UprDekretacji:
    query ="UPDATE rs_dowody_ksiegowe SET kwota_wn = "+str(KwotaCalkowita)+", kwota_ma = "+str(KwotaCalkowita)
    query+=" WHERE firma_id ='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id= '"+Dowod+"'"
    query+=" AND nazwa_id = '"+Nazwa+"' AND data=  '"+DataKsiegowania+"' AND numer = "+str(Numer)+" AND stan ='W';"
    stat,dump,dump,dump = self.PolSQL.Execute(str(query),1)

