#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_rozliczenie_produkcji.py
# Purpose:     pobiera dane do tabeli/ pozwala usun rozliczenie
# Author:      Micha Raburski
# Created:     2006/03/02
# RCS-ID:      $Id: fs_rozliczenie_produkcji.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2017-03-20 Piotr Witkowski (10384) Refaktoryzacja rozlicze produkcji
# Funkcja : 5- pobieranie / 6- usuwanie z pobieraniem / 7- obliczanie
# wraca z OK lub opisem bledu (oraz z danymi)

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'OddzF':[5,6,7], 'DataOdF':[5,6,7], 'OddzF':[5,6,7],
           'Oddzial':[6,7],'DataOd':[6,7],'DataDo':[6,7],'ArtK':[6,7],
           'Wersja':[7,] }

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_rozliczenie_produkcji z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6,7]:
        OddzF = klucze['OddzF']
        DataOdF = klucze['DataOdF']
        DataDoF = klucze['DataDoF']
    if Funkcja in [6,7]:
        Oddzial = klucze['Oddzial']
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']
        ArtK = klucze['ArtK']
    if Funkcja in [7,]:
        Wersja = klucze['Wersja']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6 :
    if ((self.oddzial_id,'043004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        SQL ="DELETE FROM rs_rozliczenia_produkcji WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        SQL+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    else:
        stat='Brak uprawnie do usuwania rozlicze'


#-------------------------------------------------------------------------------
#---  OBLICZANIE ROZLICZENIA PRODUKCJI (7)
#-------------------------------------------------------------------------------
if stat=='OK' and Funkcja == 7:
    if ((self.oddzial_id,'043005') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        #inicjalizacja sum koncowych
        WP=0
        WS=0
        WE=0
        WO=0
        KP=0
        KS=0
        KE=0
        KO=0

        #sprawdzenie numerw zlece
        SQL="SELECT kod FROM rs_numery_zlecen WHERE firma_id='"+self.firma_id+"' ORDER BY kod;"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(dane)==0:
            NrZl=''
            SQL=" INSERT INTO rs_numery_zlecen (firma_id,kod,opis) VALUES ('"+self.firma_id+"','','poddstawowe') "
            self.PolSQL.Execute(SQL,1)
        else:
            NrZl=rsglobal.Dekoduj(dane[0][0])
            
        #pobranie listy magazynw
        if Oddzial=='**':
            SQL="SELECT DISTINCT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"';"
            stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
        else:
            SQL="SELECT DISTINCT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"';"
            stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
            OddzD=Oddzial

        if len(dane)<>0:
            LMag=[]
            for mag in dane:
                LMag.append(rsglobal.Dekoduj(mag[0]))
                
        #pobranie listy par magazyn/typ dokumentu
            SQL="SELECT DISTINCT magazyn_id,dokument_id FROM rs_dokumenty_magazyny "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND magazyn_id IN ("+str(LMag)[1:-1]+");"
            stat,DaneMD,dump,dump = self.PolSQL.Execute(SQL,3)
        else:
            DaneMD=[]
            
        #inicjalizacja zmiennych    
        
        #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk]
        LElem={}
        #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk]
        LOpak={}
        #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk]
        LSur={}
        #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,wartosc_kalk]
        LWyr={}  

        #obsluga par magazyn/dokument w petli 
        for para in DaneMD:
            Mag=rsglobal.Dekoduj(para[0])
            Dok=rsglobal.Dekoduj(para[1])
            
            #pobranie danych
            SQL="SELECT data,nr_zlecenia,artykul_id,ilosc1,ilosc2,wartosc,typ FROM rs_obroty_magazynowe "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' "
            SQL+="AND data>='"+str(DataOd)+"' AND data<='"+str(DataDo)+"';"
            stat,LObroty,dump,dump = self.PolSQL.Execute(SQL,3)
            for obrot in LObroty:
                Data=obrot[0]
                NrZlec=rsglobal.Dekoduj(obrot[1])
                if NrZlec == 'None':
                    NrZlec=NrZl
                    
                Art=rsglobal.Dekoduj(obrot[2])
                Ilosc1=obrot[3]
                Ilosc2=obrot[4]
                Wart=obrot[5]
                Typ=rsglobal.Dekoduj(obrot[6])
                
                Klucz=(NrZlec,Art)
                
                #W zalenoci od typu P/W
                
                #------------------------------------------
                #PRZYJECIE
                #------------------------------------------
                if Typ=='P' and (Art.strip()==ArtK.strip() or ArtK==''):
                    SQL="SELECT typ_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                    
                    if dane[0][0] in ['02','03','11'] and stat == 'OK':
                        #sprawdzenie ceny kalkulacyjnej
                        if Wersja <> 'None':
                            SQL="SELECT rsf_podaj_cene_n1('"+self.firma_id+"','"+Art+"','"+Wersja+"','PLN','"+Data+"')"
                            stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                            CenaK=dane[0][0]
                        else:
                            CenaK=0

                        #zapisanie do sownika
                        if not Klucz in LWyr:
                            LWyr[Klucz]=[Ilosc1,Ilosc2,Wart,CenaK*(Ilosc1)]
                        else:
                            Wyr =LWyr[Klucz]
                            Wyr[0]=Wyr[0]+Ilosc1
                            Wyr[1]=Wyr[1]+Ilosc2
                            Wyr[2]=Wyr[2]+Wart
                            Wyr[3]=Wyr[3]+CenaK*(Ilosc1)
                            LWyr[Klucz]=Wyr
                            
                        #pobranie receptury
                        if Oddzial=='**':
                            SQL="SELECT oddzial_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
                            OddzD= self.PolSQL.Execute(SQL,3)[0][0]
                        #rsglobal.ZapiszDoLogow('REC',1)
                        SQL="SELECT rsf_receptury_podaj('"+self.firma_id+"','"+OddzD+"','"+Art+"','"+Data+"')"
                        stat,DRec,dump,dump = self.PolSQL.Execute(SQL,3)
                        #rsglobal.ZapiszDoLogow('DRec '+str(DRec),1)

                        #Analiza receptury
                        if DRec[0][0] not in ["BR","NZ","[]"] and stat == 'OK':
                            Rec=rsglobal.rseval(DRec[0][0])
                            for El in Rec:
                                #rsglobal.ZapiszDoLogow('aaaaaaaaaaaaa '+str(NrZlec)+'  '+str(El))
                                Kl=(NrZlec,El[1])
                                #Zapisanie elementu/pproduktu
                                if El[0]=='03':
                                    if not Kl in LElem:
                                        LElem[Kl]=[0,0,0,El[2]*Ilosc1,El[3]*Ilosc1,0]
                                    else:
                                        Elem =LElem[Kl]
                                        Elem[3]=Elem[3]+(El[2]*Ilosc1)
                                        Elem[4]=Elem[4]+(El[3]*Ilosc1)
                                        LElem[Kl]=Elem
                                    
                                #Zapisanie surowca
                                elif El[0]=='04':
                                    if not Kl in LSur:
                                        LSur[Kl]=[0,0,0,El[2]*Ilosc1,El[3]*Ilosc1,0]
                                    else:
                                        Sur =LSur[Kl]
                                        Sur[3]=Sur[3]+(El[2]*Ilosc1)
                                        Sur[4]=Sur[4]+(El[3]*Ilosc1)
                                        LSur[Kl]=Sur
                                        
                                #Zapisanie opakowania
                                elif El[0]=='05':
                                    if not Kl in LOpak:
                                        LOpak[Kl]=[0,0,0,El[2]*Ilosc1,El[3]*Ilosc1,0]
                                    else:
                                        Opak =LOpak[Kl]
                                        Opak[3]=Opak[3]+(El[2]*Ilosc1)
                                        Opak[4]=Opak[4]+(El[3]*Ilosc1)
                                        LOpak[Kl]=Opak
                                        
                 
                #------------------------------------------
                #WYDANIE
                #------------------------------------------
                elif Typ=='W' and (Art==ArtK or ArtK=='') and stat == 'OK':
                    SQL="SELECT typ_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                    
                    #---------------------------------
                    #Zapisanie elementu
                    #---------------------------------
                    if dane[0][0] in ['02','03','11']:
                        if dane[0][0]=='03':
                            if not Klucz in LElem:
                                LElem[Klucz]=[Ilosc1,Ilosc2,Wart,0,0,0]
                            else:
                                Elem =LElem[Klucz]
                                Elem[0]=Elem[0]+Ilosc1
                                Elem[1]=Elem[1]+Ilosc2
                                Elem[2]=Elem[2]+Wart
                                LElem[Klucz]=Elem
                                
                        elif dane[0][0] in ['02','11']:
                            #sprawdzenie ceny kalkulacyjnej
                            if Wersja <> 'None':
                                SQL="SELECT rsf_podaj_cene_n1('"+self.firma_id+"','"+Art+"','"+Wersja+"','PLN','"+Data+"')"
                                stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                                CenaK=dane[0][0]
                            else:
                                CenaK=0
                                
                            if not Klucz in LWyr:
                                LWyr[Klucz]=[-1*Ilosc1,-1*Ilosc2,-1*Wart,-1*CenaK*(Ilosc1)]
                            else:
                                Wyr =LWyr[Klucz]
                                Wyr[0]=Wyr[0]-Ilosc1
                                Wyr[1]=Wyr[1]-Ilosc2
                                Wyr[2]=Wyr[2]-Wart
                                Wyr[3]=Wyr[3]-CenaK*(Ilosc1)
                                LWyr[Klucz]=Wyr
                            
                        #odejmujemy surowce kalkulacyjne wykorzystane przy produkcji elementu
                        if Oddzial=='**':
                            SQL="SELECT oddzial_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
                            OddzD= self.PolSQL.Execute(SQL,3)[0][0]
                        SQL="SELECT rsf_receptury_podaj('"+self.firma_id+"','"+OddzD+"','"+Art+"','"+Data+"')"
                        stat,DRec,dump,dump = self.PolSQL.Execute(SQL,3)

                        #Analiza receptury
                        if DRec[0][0] not in ["BR","NZ","[]"]:
                            Rec=rsglobal.rseval(DRec[0][0])
                            for El in Rec:
                                Kl=(NrZlec,El[1])
                                #Zapisanie elementu/pproduktu
                                if El[0]=='03':
                                    if not Kl in LElem:
                                        LElem[Kl]=[0,0,0,El[2]*Ilosc1*-1,El[3]*Ilosc1*-1,0]
                                    else:
                                        Elem =LElem[Kl]
                                        Elem[3]=Elem[3]-(El[2]*Ilosc1)
                                        Elem[4]=Elem[4]-(El[3]*Ilosc1)
                                        LElem[Kl]=Elem
                                    
                                #Zapisanie surowca
                                elif El[0]=='04':
                                    if not Kl in LSur:
                                        LSur[Kl]=[0,0,0,El[2]*Ilosc1*-1,El[3]*Ilosc1*-1,0]
                                    else:
                                        Sur =LSur[Kl]
                                        Sur[3]=Sur[3]-(El[2]*Ilosc1)
                                        Sur[4]=Sur[4]-(El[3]*Ilosc1)
                                        LSur[Kl]=Sur
                                        
                                #Zapisanie opakowania
                                elif El[0]=='05':
                                    if not Kl in LOpak:
                                        LOpak[Kl]=[0,0,0,El[2]*Ilosc1*-1,El[3]*Ilosc1*-1,0]
                                    else:
                                        Opak =LOpak[Kl]
                                        Opak[3]=Opak[3]-(El[2]*Ilosc1)
                                        Opak[4]=Opak[4]-(El[3]*Ilosc1)
                                        LOpak[Kl]=Opak
                        
                                
                    #---------------------------------
                    #Zapisanie surowca
                    #---------------------------------
                    elif dane[0][0]=='04':
                        if not Klucz in LSur:
                            LSur[Klucz]=[Ilosc1,Ilosc2,Wart,0,0,0]
                        else:
                            Sur =LSur[Klucz]
                            Sur[0]=Sur[0]+Ilosc1
                            Sur[1]=Sur[1]+Ilosc2
                            Sur[2]=Sur[2]+Wart
                            LSur[Klucz]=Sur
                            
                    #---------------------------------        
                    #Zapisanie opakowania
                    #---------------------------------
                    elif dane[0][0]=='05':
                        if not Klucz in LOpak:
                            LOpak[Klucz]=[Ilosc1,Ilosc2,Wart,0,0,0]
                        else:
                            Opak =LOpak[Klucz]
                            Opak[0]=Opak[0]+Ilosc1
                            Opak[1]=Opak[1]+Ilosc2
                            Opak[2]=Opak[2]+Wart
                            LOpak[Klucz]=Opak
                            
        #------------------------------------------
        #policzenie wartoci kalkulacyjnej dla elementw/surowcw/opakowa
        #------------------------------------------
        
        if stat == 'OK' and Wersja <> 'None':
            for Kl in LElem:
                Elem=LElem[Kl]
                if stat == 'OK' and Elem[3] <> 0:
                    SQL="SELECT rsf_podaj_cene_n1('"+self.firma_id+"','"+Kl[1]+"','"+Wersja+"','PLN','"+Data+"')"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                    CenaK=dane[0][0]
                    Elem[5]=Elem[3]*CenaK
                    LElem[Kl]=Elem
                    
            for Kl in LSur:
                Sur=LSur[Kl]
                if stat == 'OK' and Sur[3] <> 0:
                    SQL="SELECT rsf_podaj_cene_n1('"+self.firma_id+"','"+Kl[1]+"','"+Wersja+"','PLN','"+Data+"')"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                    CenaK=dane[0][0]
                    Sur[5]=Sur[3]*CenaK
                    LSur[Kl]=Sur
                    
            for Kl in LOpak:
                Opak=LOpak[Kl]
                if stat == 'OK' and Opak[3] <> 0:
                    SQL="SELECT rsf_podaj_cene_n1('"+self.firma_id+"','"+Kl[1]+"','"+Wersja+"','PLN','"+Data+"')"
                    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
                    CenaK=dane[0][0]
                    Opak[5]=Opak[3]*CenaK
                    LOpak[Kl]=Opak

        #------------------------------------------
        # ZAPIS DANYCH
        #------------------------------------------
        
        # wyczyszczenie ewentualnych pozostaoci
        if stat == 'OK':
            SQL="DELETE FROM rs_rozliczenia_produkcji_elementy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            SQL+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"'"
            self.PolSQL.Execute(SQL,1)

            SQL="DELETE FROM rs_rozliczenia_produkcji_opakowania WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            SQL+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"'"
            self.PolSQL.Execute(SQL,1)

            SQL="DELETE FROM rs_rozliczenia_produkcji_surowce WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            SQL+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"'"
            self.PolSQL.Execute(SQL,1)

            SQL="DELETE FROM rs_rozliczenia_produkcji_wyroby WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            SQL+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"'"
            self.PolSQL.Execute(SQL,1)

            UPD ="UPDATE rs_rozliczenia_produkcji SET wart_produkcji=0,wart_surowcow=0,wart_elementow=0,wart_opakowan=0,"
            UPD+="kalk_produkcji=0,kalk_surowcow=0,kalk_elementow=0,kalk_opakowan=0 WHERE firma_id='"+self.firma_id+"'"
            UPD+=" AND oddzial_id='"+Oddzial+"' AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"'"
            self.PolSQL.Execute(UPD,1)

            # wstawienie elementw i policzenie sum
            Ins=''
            for Kl in LElem:
                Elem=LElem[Kl]
                Ins+=" INSERT INTO rs_rozliczenia_produkcji_elementy (firma_id,oddzial_id,data_od,data_do,"
                Ins+=" artykul_id_k,nr_zlecenia,artykul_id,ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk) "
                Ins+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+str(DataOd)+"','"+str(DataDo)+"','"+ArtK+"','"+Kl[0]+"',"
                Ins+="'"+Kl[1]+"',"+str(Elem[0])+","+str(Elem[1])+","+str(Elem[2])+","+str(Elem[3])+","+str(Elem[4])+","+str(Elem[5])+");"
                WE=WE+Elem[2]
                KE=KE+Elem[5]
            if Ins<>'':
                self.PolSQL.Execute(Ins,1)

            # wstawienie opakowan i policzenie sum
            Ins=''
            for Kl in LOpak:
                Opak=LOpak[Kl]
                Ins+=" INSERT INTO rs_rozliczenia_produkcji_opakowania (firma_id,oddzial_id,data_od,data_do,artykul_id_k,"
                Ins+="nr_zlecenia,artykul_id,ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk) "
                Ins+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+str(DataOd)+"','"+str(DataDo)+"','"+ArtK+"','"+Kl[0]+"',"
                Ins+="'"+Kl[1]+"',"+str(Opak[0])+","+str(Opak[1])+","+str(Opak[2])+","+str(Opak[3])+","+str(Opak[4])+","+str(Opak[5])+");"
                WO=WO+Opak[2]
                KO=KO+Opak[5]
            if Ins<>'':
                self.PolSQL.Execute(Ins,1)

            # wstawienie surowcw i policzenie sum
            Ins=''
            for Kl in LSur:
                Sur=LSur[Kl]
                Ins+=" INSERT INTO rs_rozliczenia_produkcji_surowce (firma_id,oddzial_id,data_od,data_do,artykul_id_k,"
                Ins+="nr_zlecenia,artykul_id,ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk) "
                Ins+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+str(DataOd)+"','"+str(DataDo)+"','"+ArtK+"',"
                Ins+="'"+Kl[0]+"','"+Kl[1]+"',"+str(Sur[0])+","+str(Sur[1])+","+str(Sur[2])+","+str(Sur[3])+","+str(Sur[4])+","+str(Sur[5])+");"
                WS=WS+Sur[2]
                KS=KS+Sur[5]

            if Ins<>'':
                self.PolSQL.Execute(Ins,1)

            # wstawienie wyrobw i policzenie sum
            Ins=''
            for Kl in LWyr:
                Wyr=LWyr[Kl]
                Ins+=" INSERT INTO rs_rozliczenia_produkcji_wyroby (firma_id,oddzial_id,data_od,data_do,artykul_id_k,"
                Ins+="nr_zlecenia,artykul_id,ilosc1,ilosc2,wartosc,wartosc_kalk) "
                Ins+=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+str(DataOd)+"','"+str(DataDo)+"','"+ArtK+"','"+Kl[0]+"'"
                Ins+=",'"+Kl[1]+"',"+str(Wyr[0])+","+str(Wyr[1])+","+str(Wyr[2])+","+str(Wyr[3])+");"
                WP=WP+Wyr[2]
                KP=KP+Wyr[3]
            if Ins<>'':
                 self.PolSQL.Execute(Ins,1)

            #wstawienie sum
            UPD="UPDATE rs_rozliczenia_produkcji SET wart_produkcji="+str(WP)+",wart_surowcow="+str(WS)+",wart_elementow="+str(WE)
            UPD+=",wart_opakowan="+str(WO)+",kalk_produkcji="+str(KP)+",kalk_surowcow="+str(KS)+",kalk_elementow="+str(KE)
            UPD+=",kalk_opakowan="+str(KO)+",data_obl=now() WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
            UPD+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND artykul_id_k='"+ArtK+"'"
            self.PolSQL.Execute(UPD,1)

    else:
        stat='Brak uprawnie do obliczania rozliczenia produkcji'


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete, 7- obliczanie)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6,7]:
    #wyznaczenie oddziaw
    if (self.operator_id == STANDARD_OPERATOR_ID):
        LOdd=['**']
    else:
        SQL= "SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial WHERE firma_id='"+self.firma_id+"'"
        SQL+="AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";"
        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
        if len(dane)<>0:
            LOdd=[]
            for odd in dane:
                LOdd.append(rsglobal.Dekoduj(odd[0]))
            
    if '**' in LOdd:
        War=''
    else:
        buf=str(LOdd)
        buf=buf[1:-1]
        War=' AND oddzial_id IN ('+buf+')'

    #ustawienie filtra
    Filtr=''
    if OddzF <> '':
        Filtr=" oddzial_id='"+OddzF+"'"
        
    if DataOdF <> '    -  -  ':
        if Filtr=='':
            Filtr=" data_od>='"+DataOdF+"'"
        else:
            Filtr=Filtr+" AND data_od>='"+DataOdF+"'"
            
    if DataDoF <> '    -  -  ':
        if Filtr=='':
            Filtr=" data_do<='"+DataDoF+"'"
        else:
            Filtr=Filtr+" AND data_do<='"+DataDoF+"'"
    
    if Filtr <> '':        
        War+=' AND '+Filtr
            
    #select waciwy
    SQL= "SELECT oddzial_id,data_od,data_do,artykul_id_k,data_obl,wart_produkcji,"
    SQL+="wart_surowcow,wart_elementow,wart_opakowan,wersja,kalk_produkcji,kalk_surowcow,"
    SQL+="kalk_elementow,kalk_opakowan FROM rs_rozliczenia_produkcji WHERE firma_id='"+self.firma_id+"'"
    SQL+=War+" ORDER BY data_od,data_do,artykul_id_k;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)