# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rozliczenie_produkcji_klucz.py
# Purpose:     zapisuje nowy dokument i pobiera dane do tabeli
#
# Author:      Micha Raburski
# Created:     2006/02/27
# RCS-ID:      $Id: fs_rozliczenie_produkcji_klucz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2013-06-06 Mariusz Rajfura (6904) kontrola typu dodawanego artykulu
# 2017-03-20 Piotr Witkowski (10384) Refaktoryzacja rozlicze produkcji

#pola - pola filtrw 
# pola[0] - oddzia do filtra 
# pola[1] - data od do filtra 
# pola[2] - data do do filtra
# wraca z OK lub opisem bledu (oraz z danymi w pierwszym przypadku)

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Oddzial':[1],'DataOd':[1],'DataDo':[1],'Artykul':[1],'Wersja':[1],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_rozliczenie_produkcji_klucz z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1]:
        Oddzial = klucze['Oddzial']
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']
        Art = klucze['Artykul']
        Wersja = klucze['Wersja']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    #Lista oddziaw do ktrych operator ma uprawnienia
    LOdd=[]

#---   INSERT DANYCH (1)
if stat=='OK' and Funkcja == 1:
    if not (((self.oddzial_id,'043003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='BR UPR'

    if Oddzial=='':
        stat='BR ODD'

    if stat=='OK':
        SQL="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='%s' AND oddzial_id='%s';" % (self.firma_id,Oddzial)
        stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(wyn)==0:
                stat='BL ODD'
        else:
            stat='BL KOM'

    #sprawdzenie uprawnie do oddziau
    if stat=='OK':    
        if (self.operator_id <> STANDARD_OPERATOR_ID):
            SQL="SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial WHERE firma_id='"+self.firma_id+"' "
            SQL+="AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";"
            stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
            if len(dane)<>0:
                for odd in dane:
                    LOdd.append(rsglobal.Dekoduj(odd[0]))
                
                if (not (Oddzial in LOdd)) and (not ('**' in LOdd)):
                    stat='BR UPRO'
            else:
                stat='BR UPRO'
        
    #sprawdzenie dat    
    if stat=='OK' and DataOd=='    -  -  ':
        stat='BR DOD'
    
    if stat=='OK'and not rsglobal.SprawdzCzyToData(DataOd):
        stat='BL DOD'
    
    if stat=='OK' and DataDo=='    -  -  ':
        stat='BR DDO'
    
    if stat=='OK' and not rsglobal.SprawdzCzyToData(DataDo):
        stat='BL DDO'
    
    if stat=='OK' and Wersja<>'':
        SQL="SELECT kod FROM rs_wersje_cenowe WHERE firma_id='%s' AND kod='%s';" % (self.firma_id,Wersja)
        stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(wyn)==0:
                stat='BL WER'
        else:
            stat='BL KOM'
    
    if stat=='OK' and Art<>'':
        sql ="SELECT artykul_id,typ_artykulu FROM rs_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
        stat,wyn,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(wyn)==0:
                stat='BL ART'
            elif not wyn[0][1] in ('02','03','11'):
                stat='BL TYP ART'
        else:
            stat='BL KOM'
    
    if stat=='OK':
        SQL="SELECT firma_id FROM rs_rozliczenia_produkcji WHERE firma_id='%s' AND oddzial_id='%s' " % (self.firma_id,Oddzial)
        SQL+=" AND data_od='%s' AND data_do='%s' AND artykul_id_k='%s';" % (DataOd,DataDo,Art)
        stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(wyn)>0:
                stat='UZ NR'
        else:
            stat='BL KOM'
    
    if stat=='OK':    
        if Wersja=='':
            Wersja='NULL'
        else:
            Wersja="'"+Wersja+"'"
            
        Ins= "INSERT INTO rs_rozliczenia_produkcji (firma_id,oddzial_id,data_od,data_do,artykul_id_k,wersja,wart_produkcji,"
        Ins+="wart_surowcow,wart_elementow,wart_opakowan,kalk_produkcji,kalk_surowcow,kalk_elementow,kalk_opakowan) VALUES "
        Ins+="('%s','%s','%s','%s','%s',%s,0,0,0,0,0,0,0,0);" % (self.firma_id,Oddzial,str(DataOd),str(DataDo),Art,Wersja)
        stat,nroid,dump,dump = self.PolSQL.Execute(Ins,1)
        
        #pobranie danych
        if stat=='OK':
            #pobranie oddziaw
            if (self.operator_id == STANDARD_OPERATOR_ID):
                LOdd=['**']
            else:
                SQL= "SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial WHERE firma_id='"+self.firma_id+"' "
                SQL+="AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";"
                stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
                if len(dane)<>0:
                    LOdd=[]
                    for odd in dane:
                        LOdd.append(rsglobal.Dekoduj(odd[0]))
            
            if '**' in LOdd:
                War=''
            else:
                buf=str(LOdd)
                buf=buf[1:-1]
                War=' AND oddzial_id IN ('+buf+')'
            
            #pobranie filtra do zapytania
            if pola <> []:
                OddF=pola[0]
                OdF=pola[1]
                DoF=pola[2]
            
                Filtr=''
                if OddF <> '':
                    Filtr=" oddzial_id='"+OddF+"'"
        
                if OdF <> '    -  -  ':
                    if Filtr=='':
                        Filtr=" data_od>='"+OdF+"'"
                    else:
                        Filtr=Filtr+" AND data_od>='"+OdF+"'"
                if DoF <> '    -  -  ':
                    if Filtr=='':
                        Filtr=" data_do<='"+DoF+"'"
                    else:
                        Filtr=Filtr+" AND data_do<='"+DoF+"'"
                if Filtr <> '':        
                    War=War+' AND '+Filtr            

            #select waciwy
            Select ="SELECT oddzial_id,data_od,data_do,artykul_id_k,data_obl,wart_produkcji,wart_surowcow,wart_elementow,"
            Select+="wart_opakowan,wersja,kalk_produkcji,kalk_surowcow,kalk_elementow,kalk_opakowan FROM rs_rozliczenia_produkcji "
            Select+=" WHERE firma_id='"+self.firma_id+"'"+War+" ORDER BY data_od,data_do;"
            stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
else:
    stat
    stat='BL FUN'
