#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_rozrachunki.py
# Purpose:          dodaje i rozlicza rozrachunki
# Author:           Micha Raburski
# Created:          2007/02/12
# RCS-ID:           $Id: fs_rozrachunki.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

#2009.02.11 Micha Raburski (1746) Poprawki w kwotach_bo_*
#2009.02.20 Dariusz Boduch (1796) Zdjecie blokady na salda = 0
#2012.01.26 Micha Raburski (5423) Blokada rozliczania dla kont przeniesionych czciowym BO
#2012.02.24 Micha Raburski (5482) Znak / ju nie rozdziela dokumentw
#2013.01.23 Micha Raburski (6339) zmiana funkcji cofajcej rozrachunki
#2014.01.17 Micha Raburski (7585) zdjcie testu na to czy data rozliczenia pasuje do okresu jakiego rozrachunku
#2017.10.31 Rafa Woniak (10734) zmian poziomu zapisu logw
#2018.11.21 Aleksander Bargie (11284) [KS] sprawdzac czy istnieje okres dla daty rozliczenia (byo:Studzieniec - problem z rozrachunkami)
#2022.04.26 Aleksander Bargie (12998) Problem z polskimi znakami w opisie kontrahenta na oknie rozliczania rozrachunkw w SPC

dl=10

from funkcje import fs_rozrachunki_pom
from funkcje import fs_korekty_pom 
import rsglobal

#-------------------------------------------------------------------------------
# FUNKCJA POBIERAJCA LIST OPERACJI Z WIERSZA PLIKU
#-------------------------------------------------------------------------------

# UWAGA - jeli zmieniamy inserty w rozrachunkach to trzeba te zmieni insert w 
# w fs_rozrachunki_pom w rozliczaniu jednostronnym

def PobierzOperacjeZWiersza(Firma,Okres,Konto,PolSQL,Wiersz,Dok,Kwota,self):
    import rsglobal
    from funkcje import fs_rozrachunki_pom
    LNWyk=[]
    LWyk=[]
    LOper=[]
    stat='OK'

    #sprawdzamy czy wybrane konto ju ma BO
    stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,Okres)
    if stat <> 'OK':
        return 'Bd pobierania okresw dla rozrachunkw w pobieraniu operacji z wiersza : '+stat
    
    LOkresow=Wyn[0]
    DataGr=Wyn[1]            
    
    def PodajDokumentPochodny(DokBazowy,Koncowka):
        # sprawdzamy czy da si z numeru bazowego wyci odpowiednio duo znakw. Jeli tak to ok, 
        # jeli nie to wyrzucamy cay nr bazowy i wstawiamy nr kocwki
        
        if DokBazowy==Koncowka:
            return DokBazowy
        
        Liczba=0
        for i in range(len(Koncowka)):
            if Liczba==0:
                if not DokBazowy[-i-1] in ('0123456789'):
                    Liczba=i
        
        if Liczba==0:
            Koniec=DokBazowy[:-(len(Koncowka))]+Koncowka
        else:
            Koniec=DokBazowy[:-Liczba]+Koncowka
        return Koniec
    
    def PodajPodstaweBazowa(DokBazowy,Koncowka):
        # pobieramy niezmienn cz numeru bazowego i koncowki
        DokPoch=PodajDokumentPochodny(DokBazowy,Koncowka)
        Baza=''
        for i in range(len(DokBazowy)):
            if DokBazowy[:i]==DokPoch[:i]:
                Baza=DokBazowy[:i]
        
        return Baza
    
    SumaWiersza=0
    # POBRANIE NUMERW OPERACJI PO DOKUMENTACH Z WIERSZA
    # zakadamy, e na pocztku jest podany poprawny numer dokumentu z anakondy.
    # jeli nie ma dziwnego formatowania (czyli znakw - i , wiadczcych o podaniu kolejnych lub zakresie)
    # to pobieramy po prostu operacj zwizan z wierszem. Jeli jest to wiemy, e bdzie to zakres i
    # od koca zmieniamy znaki w dokumencie bazowym. Mona podawa jedynie zakres numeryczny.
    Miejsce=len(Dok)
    if Dok.find('-') <> -1:
        Miejsce=Dok.find('-')
    if Dok.find(',') <> -1:
        if Dok.find(',') < Miejsce:
            Miejsce=Dok.find(',')
            
    DokBazowy=Dok[:Miejsce]

    #sprawdzenie istnienia dokumentu bazowego (od razu jest dodawany do sumy wiersza)
    SQL="SELECT seria,saldo_wn FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+")"
    SQL+=" AND konto='"+Konto+"' AND TRIM(tresc)='"+DokBazowy+"' AND data_rozlicz IS NULL;" 
    stat,DaneDok,dump,dump=PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        if len(DaneDok)==0:
            LNWyk.append(Wiersz.strip('\n')+'   - nie znaleziono dokumentu '+DokBazowy+' lub jest rozliczony')
            return stat,LWyk,LNWyk,[]
        
        KwotaTest=DaneDok[0][1]
        if KwotaTest==0:
            LNWyk.append(Wiersz.strip('\n')+'   - znaleziono dokument, ale zapis po stronie MA')
            return stat,LWyk,LNWyk,[]
        
        if KwotaTest>0: 
            LOper.append([DaneDok[0][0],3])
        else:
            LOper.append([DaneDok[0][0],4])
        SumaWiersza+=KwotaTest

        LZakr=Dok.split(',')
        PozycjaOK=True
        # Kazdy zakres jest analizowany osobno
        for zakr in LZakr:
            SumaZakr=0
            if PozycjaOK:
                # jeli zakres to wiersz bazowy to go ignorujemy
                if zakr==DokBazowy:
                    continue
                
                #dzielimy tekst na czci wzgldem '-'. Bdzie jeden lub dwa kawaki
                PodzielonyZakres=zakr.split('-')
            
                if len(PodzielonyZakres)>2:
                    LNWyk.append(Wiersz.strip('\n')+'   - bdny format zakresw :'+zakr)
                    PozycjaOK=False
                    continue
                
                #jeden dokument - to podstawienie dokadnie jednej kocwki
                # zakadamy, e wycinamy maksymaln liczb znakw z dokumentu bazowego
                if len(PodzielonyZakres)==1:
                    if stat=='OK' and SumaZakr==0:
                        LOperBuf=[]
                        
                        Koniec=PodajDokumentPochodny(DokBazowy,PodzielonyZakres[0])
                        # jeli ostatni dokument zostanie znaleziony to zakadamy, e mam to co trzeba. 
                        if DokBazowy < Koniec:
                        #sprawdzenie istnienia dokumentu kocowego
                            SQL="SELECT seria,saldo_wn FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+")"
                            SQL+=" AND konto='"+Konto+"' AND TRIM(tresc)='"+Koniec+"' AND data_rozlicz IS NULL;" 
                            stat,DaneDok,dump,dump=PolSQL.Execute(SQL,3)
            
                            if stat=='OK':
                                if len(DaneDok)==0:
                                    continue
                    
                                KwotaTest=DaneDok[0][1]
                                if KwotaTest==0:
                                    continue
                                        
                                #jeli jest ostatni to go dodajemy do sumy zakresu
                                SumaZakr+=KwotaTest
                                #LNWyk.append(Wiersz.strip('\n')+'   - SUMAZ JEDNA '+str(SumaZakr)+' zmiana o '+str(KwotaTest))
                                if KwotaTest>0: 
                                    LOperBuf.append([DaneDok[0][0],3])
                                else:
                                    LOperBuf.append([DaneDok[0][0],4])
                    
                    # nie udao si znale rozrachunku
                    if SumaZakr==0 and stat=='OK':
                        LNWyk.append(Wiersz.strip('\n')+'   - zakres nie znaleziony (problem z zakresem lub sum wartoci dokumentw)')
                        return stat,LWyk,LNWyk,[]
                  
                    if SumaZakr<>0:
                        LOper=LOper+LOperBuf
                        SumaWiersza=SumaWiersza+SumaZakr          
                
                #podany zakres od-do
                else:
                    Poczatek=PodajDokumentPochodny(DokBazowy,PodzielonyZakres[0])
                    Koniec=PodajDokumentPochodny(Poczatek,PodzielonyZakres[1])
                    # niezmienialna podstawa zakresu (reszta jest zmieniana przez licznik)
                    DokPodst=PodajPodstaweBazowa(Poczatek,PodzielonyZakres[1])
                    Licznik=Poczatek[len(DokPodst):]
                    DlLicznika=len(Licznik)
                    DokAkt=Poczatek
                    
                    LOperBuf=[]
                    if stat=='OK' and SumaZakr==0:        
                        KwotaPocz=0
                        if Poczatek <> DokBazowy:
                            #sprawdzenie istnienia dokumentu pocztkowego
                            SQL="SELECT seria,saldo_wn FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+")"
                            SQL+=" AND konto='"+Konto+"' AND TRIM(tresc)='"+Poczatek+"' AND data_rozlicz IS NULL;" 
                            stat,DaneDok,dump,dump=PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneDok)==0:
                                    continue
                
                                KwotaTest=DaneDok[0][1]
                                if KwotaTest==0:
                                    continue
                                    
                            #jeli jest ok to go dodajemy do sumy zakresu
                            SumaZakr+=KwotaTest
                            KwotaPocz=KwotaTest
                            if KwotaTest>0: 
                                LOperBuf.append([DaneDok[0][0],3])
                            else:
                                LOperBuf.append([DaneDok[0][0],4])
                        
                            
                            # jeli ostatni dokument zostanie znaleziony to zakadamy, e mamy zakres. 
                            # Potem lecimy po kolei z zakresem. Musz zosta znalezione wszystkie dokumenty po trasie 
                            #i ich suma nie moe przekroczy sumy z pliku. Zakdamy, e koniec zakresu jest wikszy ni dokument bazowy.
                           
                        if stat=='OK':
                            if len(Poczatek)>=len(Koniec):
                                if Poczatek >= Koniec:
                                    SumaZakr=KwotaPocz
                                    continue
                                    
                            #sprawdzenie istnienia dokumentu kocowego
                            SQL="SELECT seria,saldo_wn FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+")"
                            SQL+=" AND konto='"+Konto+"' AND TRIM(tresc)='"+Koniec+"' AND data_rozlicz IS NULL;" 
                            stat,DaneDok,dump,dump=PolSQL.Execute(SQL,3)
                            if stat=='OK':
                                if len(DaneDok)==0:
                                    SumaZakr=KwotaPocz
                                    continue
                
                                KwotaTest=DaneDok[0][1]
                                if KwotaTest==0:
                                    SumaZakr=KwotaPocz
                                    continue
                                
                                #jeli jest ostatni to go dodajemy do sumy zakresu
                                SumaZakr+=KwotaTest
                                
                                if KwotaTest>0: 
                                    LOperBuf.append([DaneDok[0][0],3])
                                else:
                                    LOperBuf.append([DaneDok[0][0],4])
                                    
                                    
                            if stat=='OK':
                                # ptla po pozostaych dokumentach "w rodku zakresu"
                                ZakresOK=True
                                while (DokAkt<Koniec or len(Koniec)>len(DokAkt)) and ZakresOK:
                                    Licznik=str(int(Licznik)+1)
                                    while len(Licznik)<DlLicznika:
                                        Licznik='0'+Licznik
                                    DokAkt=DokPodst+Licznik
                                    if DokAkt <> Koniec:
                                        #kolejny dokument z zakresu - sprawdzamy czy istnieje
                                        SQL="SELECT seria,saldo_wn FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+")"
                                        SQL+=" AND konto='"+Konto+"' AND TRIM(tresc)='"+DokAkt+"' AND data_rozlicz IS NULL;" 
                                        stat,DaneDok,dump,dump=PolSQL.Execute(SQL,3)
                                        if stat=='OK':
                                            if len(DaneDok)==0:
                                                ZakresOK=False
                                            else:
                                                KwotaTest=DaneDok[0][1]
                                                if KwotaTest==0:
                                                    ZakresOK=False
                                
                                            #jeli istnieje to go dodajemy do sumy zakresu
                                            if ZakresOK:
                                                SumaZakr+=KwotaTest
                                                if KwotaTest>0: 
                                                    LOperBuf.append([DaneDok[0][0],3])
                                                else:
                                                    LOperBuf.append([DaneDok[0][0],4])
                                            
                                            #sprawdzamy, czy suma wszystkiego nie jest wiksza ni kwota w wierszu
                                            if Kwota >0:
                                                if SumaZakr+SumaWiersza>Kwota:
                                                    ZakresOK=False
                                            elif rsglobal.RSRound(SumaZakr+SumaWiersza,2)<rsglobal.RSRound(Kwota,2):
                                                ZakresOK=False
                                
                                    if not ZakresOK:
                                        SumaZakr=KwotaPocz
                                        continue                
                
                    if SumaZakr==KwotaPocz:
                        SumaZakr=0
                                        
                    # w adnym zakresie si nie udao znale
                    if SumaZakr==0 and stat=='OK':
                        LNWyk.append(Wiersz.strip('\n')+'   - zakres nie znaleziony (problem z zakresem lub sum wartoci dokumentw)')
                        return stat,LWyk,LNWyk,[]
                  
                    if SumaZakr<>0:
                        LOper=LOper+LOperBuf
                        SumaWiersza=SumaWiersza+SumaZakr          
            
        # pozycja le sformatowana - przechodzimy do nastpnej pozycji
        if not PozycjaOK:
            return stat,LWyk,LNWyk,[]

        #sprawdzenie czy kwota jest poprawna
        if round(SumaWiersza -Kwota,2)<>0:
            LNWyk.append(Wiersz.strip('\n')+" - niezgodna suma dokumentw z pozycji = "+str(SumaWiersza)+" z wartoci podan w wierszu o "+str(SumaWiersza-Kwota))
            return stat,LWyk,LNWyk,[]
        else:
            LWyk.append(Wiersz.strip('\n'))
            
        return stat,LWyk,LNWyk,LOper


#-##############################################################################
# FUNKCJA ROZLICZAJCE DWIE KONKRETNE LISTY
#-##############################################################################


def RozliczDwieListy(Lista1,Lista2,Kwota,WiecejNizJeden,PolSQL,Data,Firma,Okres,Wybrane,CzyJednaData,self=None):
    global dl
    from funkcje import fs_rozrachunki_pom
    stat='OK'
    
    #sprawdzamy czy wybrane konto ju ma BO
    stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,Okres)
    if stat =='OK':
        LOkresow=rsglobal.Dekoduj(Wyn[0])
        DataGr=rsglobal.Dekoduj(Wyn[1])

    
    while stat=='OK' and len(Lista1)>0 and len(Lista2)>0 and (Kwota>0 or WiecejNizJeden):
        Oper1=Lista1[0]
        Oper2=Lista2[0]
        OperN1=0
        OperN2=0
        
        #pobranie danych o pozycjach
        pola="dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id," # (0-11)
        pola+="konto,kwota_wn,kwota_ma,saldo_wn,saldo_ma,rozliczone_wn,rozliczone_ma,tresc,waluta,kurs,"                         # (12-21)
        pola+="kwota_wal_wn,kwota_wal_ma,saldo_wal_wn,saldo_wal_ma,rozliczone_wal_wn,rozliczone_wal_ma,data_rozlicz,seria_prz,"   # (22-29)
        pola+="kwota_bo_wn,kwota_bo_ma,kwota_bo_wal_wn,kwota_bo_wal_ma,firma_id,okres_id,"   # (30-35)
        pola+="COALESCE(f_typ,''),f_wyznacznik_id,f_data,f_numer,platnosc_id,COALESCE(data_ksieg_kosztow::TEXT,''),"   # (36-41)
        pola+="COALESCE(pdk_okres_id,''),pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"   # (42-48)
    
        # Operacja 1
        stat,Dane1,dump,dump=PolSQL.Execute("SELECT "+pola+" FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+") AND seria="+Oper1+" FOR UPDATE NOWAIT",3)
        # Operacja 2
        if stat == 'OK':
            stat,Dane2,dump,dump=PolSQL.Execute("SELECT "+pola+" FROM rs_rozrachunki WHERE firma_id='"+Firma+"' AND okres_id IN ("+LOkresow+") AND seria="+Oper2+" FOR UPDATE NOWAIT",3)
        
        # sprawdzenie czy ktrykolwiek z typw jest rnic kursow (typ wzoru W)
        if stat == 'OK':
            SQL = "SELECT typ_wzoru FROM rs_wzory_dekretacji WHERE firma_id='"+Firma+"' AND typ_wzoru = 'W'"
            SQL+= "AND ((okres_id = '"+Dane1[0][35]+"' AND dowod_id='"+Dane1[0][0]+"' AND nazwa_id='"+Dane1[0][1]+"') "
            SQL+= "OR (okres_id = '"+Dane2[0][35]+"' AND dowod_id='"+Dane2[0][0]+"' AND nazwa_id='"+Dane2[0][1]+"'));"
            stat,DTypWzoru,dump,dump=PolSQL.Execute(SQL,3)
            if stat == 'OK':
                CzyRoznicaKursowa = (len(DTypWzoru) > 0)
                
        if stat == 'OK':
            if not CzyJednaData:
                # uwzgldnienie daty ksigowania kosztow
                if Dane1[0][41]<>'':
                    Data=Dane1[0][41]
                else:
                    Data=Dane1[0][2]
                if Dane2[0][41]<>'':
                    Data=str(max(Data,Dane2[0][41]))
                else:
                    Data=str(max(Data,Dane2[0][2]))
        
        # sprawdzenie czy Data naley do dostpnych okresw
        #AB 21.11.18r
            stat, okresy, dump, dump = self.PolSQL.Execute("SELECT data_od, data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"';", 3)
            rsglobal.ZapiszDoLogow(okresy, 5)
            rsglobal.ZapiszDoLogow(Data, 5)
            if stat != 'OK':
                stat = 'Bd sprawdzania poprawnoci daty rozliczenia: ' + stat
            elif len(okresy) == 0:
                stat = 'Bd sprawdzania poprawnoci daty rozliczenia: nie odnaleziono adnego okresu ksigowego.'
            else:
                ok = False
            for okres in okresy:
                if okres[0] <= Data <= okres[1]:
                    ok = True
            if not ok:
                stat = 'Na '+Data+' nie ma wprowadzonego okresu ksigowego.'


            Okres1=rsglobal.Dekoduj(Dane1[0][35])
            Okres2=rsglobal.Dekoduj(Dane2[0][35])
        
        #pobranie walut i kursw
        if stat=='OK': 
            Waluta1=rsglobal.Dekoduj(Dane1[0][20])
            Kurs1=Dane1[0][21]
            Waluta2=rsglobal.Dekoduj(Dane2[0][20])
            Kurs2=Dane2[0][21]

        # sprawdzenie czy rozliczamy t sam walut
        if stat == 'OK':
            RozneWaluty = (Waluta1 <> Waluta2)
            Jednowalutowo = False
            
            if RozneWaluty and not CzyRoznicaKursowa:
                # pobieramy saldo w PLN
                SalWn1=Dane1[0][15]
                SalMa1=Dane1[0][16]
                SalWn2=Dane2[0][15]
                SalMa2=Dane2[0][16]
            else:
                # pobieramy saldo walutowe. Jeli ktrykolwiek rozrachunek nie ma wartoci walutowej a ma w PLN to rozliczamy jednowalutowo - tylko PLN
                SalWn1=Dane1[0][24]
                SalMa1=Dane1[0][25]
                SalWn2=Dane2[0][24]
                SalMa2=Dane2[0][25]
                
                if (SalWn1 == 0 and SalMa1 == 0) or (SalWn2 == 0 and SalMa2 == 0):
                    # pobieramy saldo PLN
                    Jednowalutowo = True
                    SalWn1=Dane1[0][15]
                    SalMa1=Dane1[0][16]
                    SalWn2=Dane2[0][15]
                    SalMa2=Dane2[0][16]
            
            #sprawdzenie kwot (czy po dobrych stronach)
            OK=False,0
            if SalWn1 <> 0:
                if SalWn2 <> 0:
                    #Obie strony Wn
                    OK=((SalWn1*SalWn2 < 0),min(abs(SalWn1),abs(SalWn2)),1)
                elif SalMa2 <> 0:
                    #Gora Wn Dol Ma
                    OK=((SalWn1*SalMa2 > 0),min(abs(SalWn1),abs(SalMa2)),2)
            elif SalMa1 <> 0:
                if SalWn2 <> 0:
                    # Gora Ma Dol Wn
                    OK=((SalMa1*SalWn2 > 0),min(abs(SalMa1),abs(SalWn2)),3)
                elif SalMa2 <> 0:
                    #obie strony Ma
                    OK=((SalMa1*SalMa2 < 0),min(abs(SalMa1),abs(SalMa2)),4)    
            
            if not OK[0]:
                stat='Nie mona rozliczy tych operacji - bdnie dobrane strony'
    
        #za dua kwota rozliczenia
        if stat=='OK':
            if not WiecejNizJeden:
                if rsglobal.RSRound(OK[1],2) < rsglobal.RSRound(Kwota,2):
                    stat='Kwota rozliczenia wiksza ni kwota jednej z operacji'
        
        if stat=='OK':
            #jeli tak to rwnoczenie Kwota==0
            if WiecejNizJeden:
                Kwota=OK[1]
            TypRozl=OK[2]
    
    
        # wybieramy rozrachunek "wiodcy" - ten o mniejszej dacie. Jeli rwny to Oper 1.
        # dla niego ustalamy wartoci rozliczenia walutowego i zwykego. Potem te wartoci bd rozliczone na tym drugim rozrachunku
        if stat == 'OK':
            if RozneWaluty and not CzyRoznicaKursowa:
                KwotaRozl1 = rsglobal.RSRound(Kwota/Kurs1,2)
                KwotaRozl2 = rsglobal.RSRound(Kwota/Kurs2,2)
                KwotaRozlPln1 = rsglobal.RSRound(Kwota,2)
                KwotaRozlPln2 = rsglobal.RSRound(Kwota,2)
                RoznKursowa1=0
                RoznKursowa2=0
            elif Jednowalutowo:
                KwotaRozl1 = 0
                KwotaRozl2 = 0
                KwotaRozlPln1 = rsglobal.RSRound(Kwota,2)
                KwotaRozlPln2 = rsglobal.RSRound(Kwota,2)
                RoznKursowa1=0
                RoznKursowa2=0
            else:
                KwotaRozl1 = Kwota
                KwotaRozl2 = Kwota
               
                # wiodca jest operacja 1
                if Dane1[0][2] <= Dane2[0][2]:  
                    KwotaRozlPln1 = rsglobal.RSRound(Kwota * Kurs1,2)
                    KwotaRozlPln2 = rsglobal.RSRound(Kwota * Kurs1,2)
                    RoznKursowa1=0
                    RoznKursowa2=rsglobal.RSRound(rsglobal.RSRound(Kwota * Kurs2,2) - rsglobal.RSRound(Kwota * Kurs1,2),2)
                # wiodca jest operacja 2
                else:
                    KwotaRozlPln1 = rsglobal.RSRound(Kwota * Kurs2,2)
                    KwotaRozlPln2 = rsglobal.RSRound(Kwota * Kurs2,2)
                    RoznKursowa1=rsglobal.RSRound(rsglobal.RSRound(Kwota * Kurs1,2) - rsglobal.RSRound(Kwota * Kurs2,2),2)
                    RoznKursowa2=0
            
    
        #----------------------------------------------------
        #WACIWE ROZLICZENIE
        #----------------------------------------------------

        #OPERACJA 1 - przygotowanie zapyta
        if stat=='OK':
            if TypRozl in [1,2]:
                Str='wn'
                if SalWn1 > 0:
                    Znak=1
                else:
                    Znak=-1

                NrStrony1=13
            else:
                Str='ma'
                if SalMa1 > 0:
                    Znak=1
                else:
                    Znak=-1

                NrStrony1=14
            
            Upd1="UPDATE rs_rozrachunki SET rozliczone_"+Str+"="+str(Znak*KwotaRozlPln1)+",rozliczone_wal_"+Str+"="+str(Znak*KwotaRozl1)+","
            Upd1+="data_rozlicz='"+Data+"',seria_prz="+str(Oper2)+", roznica_kursowa="+str(RoznKursowa1)
            Upd1+=" WHERE seria="+str(Oper1)+";"
            
            Ins1=''
            Sel1=''
            
            stat,dump,dump,dump=PolSQL.Execute(Upd1,1)
        
        if stat == 'OK':
            # sprawdzenie czy po rozliczeniu operacji naley zrobi kolejn operacj do rozliczenia
            SQL="SELECT saldo_wn=rozliczone_wn AND saldo_ma=rozliczone_ma AND saldo_wal_wn=rozliczone_wal_wn "
            SQL+=" AND saldo_wal_ma=rozliczone_wal_ma FROM rs_rozrachunki WHERE seria="+str(Oper1)+";"
            stat,DCzyIns,dump,dump=PolSQL.Execute(SQL,3)        
        if stat == 'OK':
            if not DCzyIns[0][0]:
                if Dane1[0][7]=='None':
                    DataWyst='NULL' 
                else:
                    DataWyst="'"+rsglobal.Dekoduj(Dane1[0][7])+"'"
                if Dane1[0][8]=='None':
                    DataWpl='NULL' 
                else:
                    DataWpl="'"+rsglobal.Dekoduj(Dane1[0][8])+"'"
                if Dane1[0][9]=='None':
                    TerminPl='NULL' 
                else:
                    TerminPl="'"+rsglobal.Dekoduj(Dane1[0][9])+"'"
                if Dane1[0][10]=='None':
                    DataZapl='NULL' 
                else:
                    DataZapl="'"+rsglobal.Dekoduj(Dane1[0][10])+"'"
                if Dane1[0][11]=='None':
                    Kontr='NULL' 
                else:
                    Kontr="'"+rsglobal.Dekoduj(Dane1[0][11])+"'"
                if Dane1[0][6]=='None':
                    SymbDok='NULL' 
                else:
                    SymbDok="'"+rsglobal.Dekoduj(Dane1[0][6])+"'"    
                if Dane1[0][0]<>'BO':
                    KwotaBOWn='NULL' 
                else:
                    KwotaBOWn=str(Dane1[0][30])
                if Dane1[0][0]<>'BO':
                    KwotaBOMa='NULL' 
                else:
                    KwotaBOMa=str(Dane1[0][31])
                if Dane1[0][0]<>'BO':
                    KwotaBOWalWn='NULL' 
                else:
                    KwotaBOWalWn=str(Dane1[0][32])
                if Dane1[0][0]<>'BO':
                    KwotaBOWalMa='NULL' 
                else:
                    KwotaBOWalMa=str(Dane1[0][33])
                    
                if Dane1[0][36]=='':
                    FTyp='NULL' 
                    FWyzn='NULL' 
                    FData='NULL' 
                    FNr='NULL' 
                else:
                    FTyp="'"+rsglobal.Dekoduj(Dane1[0][36])+"'" 
                    FWyzn="'"+rsglobal.Dekoduj(Dane1[0][37])+"'" 
                    FData="'"+rsglobal.Dekoduj(Dane1[0][38])+"'"  
                    FNr=str(Dane1[0][39])
                
                PlatnoscId=str(Dane1[0][40])
                if PlatnoscId in ('None',None,'','0'):
                    PlatnoscId='NULL' 
                
                if Dane1[0][41]=='':
                    DataPrzychodu='NULL' 
                else:
                    DataPrzychodu="'"+rsglobal.Dekoduj(Dane1[0][41])+"'"
                    
                if Dane1[0][42]=='':
                    PDKOkresId='NULL'
                    PDKDowodId='NULL'
                    PDKNazwaId='NULL'
                    PDKData='NULL'
                    PDKNumer='0'
                    PDKNrPoz='0'
                    PDKNrPPoz='0'
                else:
                    PDKOkresId="'"+rsglobal.Dekoduj(Dane1[0][42])+"'" 
                    PDKDowodId="'"+rsglobal.Dekoduj(Dane1[0][43])+"'" 
                    PDKNazwaId="'"+rsglobal.Dekoduj(Dane1[0][44])+"'" 
                    PDKData="'"+rsglobal.Dekoduj(Dane1[0][45])+"'" 
                    PDKNumer=str(Dane1[0][46])
                    PDKNrPoz=str(Dane1[0][47])
                    PDKNrPPoz=str(Dane1[0][48])
            
                Ins1="INSERT INTO rs_rozrachunki (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,"
                Ins1+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto,"
                Ins1+="kwota_wn,kwota_ma,saldo_wn,saldo_ma,rozliczone_wn,rozliczone_ma,tresc,waluta,kurs,"
                Ins1+="kwota_wal_wn,kwota_wal_ma,saldo_wal_wn,saldo_wal_ma,rozliczone_wal_wn,rozliczone_wal_ma,data_rozlicz,seria_prz,"
                Ins1+="kwota_bo_wn,kwota_bo_ma,kwota_bo_wal_wn,kwota_bo_wal_ma,"
                Ins1+="f_typ,f_wyznacznik_id,f_data,f_numer,platnosc_id,data_ksieg_kosztow,"
                Ins1+="pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz)"
                Ins1+=" VALUES ('"+Firma+"','"+Okres1+"','"+rsglobal.Dekoduj(Dane1[0][0])+"','"+rsglobal.Dekoduj(Dane1[0][1])+"','"+rsglobal.Dekoduj(Dane1[0][2])+"',"+str(Dane1[0][3])+","+str(Dane1[0][4])+","+str(Dane1[0][5])+","
                Ins1+=SymbDok+","+DataWyst+","+DataWpl+","+TerminPl+","+DataZapl+","+Kontr+",'"+Wybrane+"',"
                if TypRozl in [1,2]:    #strona wn
                    Ins1+=str(Dane1[0][13])+",0,"+str(Dane1[0][15] - (KwotaRozlPln1*Znak))+",0,0,0,'"+rsglobal.Dekoduj(Dane1[0][19]).replace("'","\\'")+"','"+Waluta1+"',"+str(Kurs1)+","
                    Ins1+=str(Dane1[0][22])+",0,"+str(Dane1[0][24] - (KwotaRozl1*Znak))+",0,0,0,NULL,0,"
                else:                   #strona ma
                    Ins1+="0,"+str(Dane1[0][14])+",0,"+str(Dane1[0][16]-(KwotaRozlPln1*Znak))+",0,0,'"+rsglobal.Dekoduj(Dane1[0][19]).replace("'","\\'")+"','"+Waluta1+"',"+str(Kurs1)+","
                    Ins1+="0,"+str(Dane1[0][23])+",0,"+str(Dane1[0][25]-(KwotaRozl1*Znak))+",0,0,NULL,0,"
                Ins1+=KwotaBOWn+","+KwotaBOMa+","+KwotaBOWalWn+","+KwotaBOWalMa
                Ins1+=","+FTyp+","+FWyzn+","+FData+","+FNr+","+PlatnoscId+","+DataPrzychodu
                Ins1+=","+PDKOkresId+","+PDKDowodId+","+PDKNazwaId+","+PDKData+","+PDKNumer+","+PDKNrPoz+","+PDKNrPPoz+");"
           
                #Select do pobrania nowego numeru serii, z ktrym bdzie dalsze rozliczanie tej pozycji.
                Sel1="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+Firma+"'"
                Sel1+=" AND okres_id='"+Okres1+"' AND dowod_id='"+rsglobal.Dekoduj(Dane1[0][0])+"'"
                Sel1+=" AND nazwa_id='"+rsglobal.Dekoduj(Dane1[0][1])+"' AND data='"+rsglobal.Dekoduj(Dane1[0][2])+"'"
                Sel1+=" AND numer="+str(Dane1[0][3])+" AND nr_poz="+str(Dane1[0][4])+" AND nr_ppoz="+str(Dane1[0][5])
                Sel1+=" AND rozliczone_wn=0 AND rozliczone_ma=0"
                if TypRozl in [1,2]:
                    Sel1+=" AND kwota_wn="+str(Dane1[0][13])
                    if not Jednowalutowo:
                        Sel1+=" AND saldo_wal_wn <> 0"
                else:
                    Sel1+=" AND kwota_ma="+str(Dane1[0][14])
                    if not Jednowalutowo:
                        Sel1+=" AND saldo_wal_ma <> 0"
                stat,dump,dump,dump=PolSQL.Execute(Ins1,1)
    
        #OPERACJA 2 - przygotowanie zapyta
        if stat=='OK':
            if TypRozl in [1,3]:
                Str='wn'
                if SalWn2 > 0:
                    Znak=1
                else:
                    Znak=-1

                NrStrony2=13
            else:
                Str='ma'
                if SalMa2 > 0:
                    Znak=1
                else:
                    Znak=-1

                NrStrony2=14

            Upd2="UPDATE rs_rozrachunki SET rozliczone_"+Str+"="+str(Znak*KwotaRozlPln2)+",rozliczone_wal_"+Str+"="+str(Znak*KwotaRozl2)+","
            Upd2+="data_rozlicz='"+Data+"',seria_prz="+str(Oper1)+", roznica_kursowa="+str(RoznKursowa2)
            Upd2+=" WHERE seria="+str(Oper2)+";"
            
            Ins2=''
            Sel2=''
            stat,dump,dump,dump=PolSQL.Execute(Upd2,1)
            
        if stat == 'OK':    
            # sprawdzenie czy po rozliczeniu operacji naley zrobi kolejn operacj do rozliczenia
            SQL="SELECT saldo_wn=rozliczone_wn AND saldo_ma=rozliczone_ma AND saldo_wal_wn=rozliczone_wal_wn "
            SQL+=" AND saldo_wal_ma=rozliczone_wal_ma FROM rs_rozrachunki WHERE seria="+str(Oper2)+";"
            stat,DCzyIns,dump,dump=PolSQL.Execute(SQL,3)        
        if stat == 'OK':
            if not DCzyIns[0][0]:
                if Dane2[0][7]=='None':
                    DataWyst='NULL' 
                else:
                    DataWyst="'"+rsglobal.Dekoduj(Dane2[0][7])+"'"
                if Dane2[0][8]=='None':
                    DataWpl='NULL' 
                else:
                    DataWpl="'"+rsglobal.Dekoduj(Dane2[0][8])+"'"
                if Dane2[0][9]=='None':
                    TerminPl='NULL' 
                else:
                    TerminPl="'"+rsglobal.Dekoduj(Dane2[0][9])+"'"
                if Dane2[0][10]=='None':
                    DataZapl='NULL' 
                else:
                    DataZapl="'"+rsglobal.Dekoduj(Dane2[0][10])+"'"
                if Dane2[0][11]=='None':
                    Kontr='NULL' 
                else:
                    Kontr="'"+rsglobal.Dekoduj(Dane2[0][11])+"'"
                if Dane2[0][6]=='None':
                    SymbDok='NULL' 
                else:
                    SymbDok="'"+rsglobal.Dekoduj(Dane2[0][6])+"'"    
                if Dane2[0][0]<>'BO':
                    KwotaBOWn='NULL' 
                else:
                    KwotaBOWn=str(Dane2[0][30])
                if Dane2[0][0]<>'BO':
                    KwotaBOMa='NULL' 
                else:
                    KwotaBOMa=str(Dane2[0][31])
                if Dane2[0][0]<>'BO':
                    KwotaBOWalWn='NULL' 
                else:
                    KwotaBOWalWn=str(Dane2[0][32])
                if Dane2[0][0]<>'BO':
                    KwotaBOWalMa='NULL' 
                else:
                    KwotaBOWalMa=str(Dane2[0][33])
                    
                if Dane2[0][36]=='':
                    FTyp='NULL' 
                    FWyzn='NULL' 
                    FData='NULL' 
                    FNr='NULL' 
                else:
                    FTyp="'"+rsglobal.Dekoduj(Dane2[0][36])+"'" 
                    FWyzn="'"+rsglobal.Dekoduj(Dane2[0][37])+"'" 
                    FData="'"+rsglobal.Dekoduj(Dane2[0][38])+"'"  
                    FNr=str(Dane2[0][39])
                    
                PlatnoscId=str(Dane2[0][40])
                if PlatnoscId in ('None',None,'','0'):
                    PlatnoscId='NULL' 
                    
                if Dane2[0][41]=='':
                    DataPrzychodu='NULL' 
                else:
                    DataPrzychodu="'"+rsglobal.Dekoduj(Dane2[0][41])+"'"
                
                if Dane2[0][42]=='':
                    PDKOkresId='NULL'
                    PDKDowodId='NULL'
                    PDKNazwaId='NULL'
                    PDKData='NULL'
                    PDKNumer='0'
                    PDKNrPoz='0'
                    PDKNrPPoz='0'
                else:
                    PDKOkresId="'"+rsglobal.Dekoduj(Dane2[0][42])+"'" 
                    PDKDowodId="'"+rsglobal.Dekoduj(Dane2[0][43])+"'" 
                    PDKNazwaId="'"+rsglobal.Dekoduj(Dane2[0][44])+"'" 
                    PDKData="'"+rsglobal.Dekoduj(Dane2[0][45])+"'" 
                    PDKNumer=str(Dane2[0][46])
                    PDKNrPoz=str(Dane2[0][47])
                    PDKNrPPoz=str(Dane2[0][48])
                    
                Ins2="INSERT INTO rs_rozrachunki (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,"
                Ins2+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto,"
                Ins2+="kwota_wn,kwota_ma,saldo_wn,saldo_ma,rozliczone_wn,rozliczone_ma,tresc,waluta,kurs,"
                Ins2+="kwota_wal_wn,kwota_wal_ma,saldo_wal_wn,saldo_wal_ma,rozliczone_wal_wn,rozliczone_wal_ma,data_rozlicz,seria_prz,"
                Ins2+="kwota_bo_wn,kwota_bo_ma,kwota_bo_wal_wn,kwota_bo_wal_ma,"
                Ins2+="f_typ,f_wyznacznik_id,f_data,f_numer,platnosc_id,data_ksieg_kosztow,"
                Ins2+="pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz)"
                Ins2+=" VALUES ('"+Firma+"','"+Okres2+"','"+rsglobal.Dekoduj(Dane2[0][0])+"','"+rsglobal.Dekoduj(Dane2[0][1])+"','"+rsglobal.Dekoduj(Dane2[0][2])+"',"+str(Dane2[0][3])+","+str(Dane2[0][4])+","+str(Dane2[0][5])+","
                Ins2+=SymbDok+","+DataWyst+","+DataWpl+","+TerminPl+","+DataZapl+","+Kontr+",'"+Wybrane+"',"
                if TypRozl in [1,3]:    #strona wn
                    Ins2+=str(Dane2[0][13])+",0,"+str(Dane2[0][15]- (KwotaRozlPln2*Znak))+",0,0,0,'"+rsglobal.Dekoduj(Dane2[0][19]).replace("'","\\'")+"','"+Waluta2+"',"+str(Kurs2)+","
                    Ins2+=str(Dane2[0][22])+",0,"+str(Dane2[0][24]- (KwotaRozl2*Znak))+",0,0,0,NULL,0,"
                else:                   #strona ma
                    Ins2+="0,"+str(Dane2[0][14])+",0,"+str(Dane2[0][16]- (KwotaRozlPln2*Znak))+",0,0,'"+rsglobal.Dekoduj(Dane2[0][19]).replace("'","\\'")+"','"+Waluta2+"',"+str(Kurs2)+","
                    Ins2+="0,"+str(Dane2[0][23])+",0,"+str(Dane2[0][25]- (KwotaRozl2*Znak))+",0,0,NULL,0,"
                Ins2+=KwotaBOWn+","+KwotaBOMa+","+KwotaBOWalWn+","+KwotaBOWalMa
                Ins2+=","+FTyp+","+FWyzn+","+FData+","+FNr+","+PlatnoscId+","+DataPrzychodu
                Ins2+=","+PDKOkresId+","+PDKDowodId+","+PDKNazwaId+","+PDKData+","+PDKNumer+","+PDKNrPoz+","+PDKNrPPoz+");"
           
                #Select do pobrania nowego numeru serii, z ktrym bdzie dalsze rozliczanie tej pozycji.
                Sel2="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+Firma+"'"
                Sel2+=" AND okres_id='"+Okres2+"' AND dowod_id='"+rsglobal.Dekoduj(Dane2[0][0])+"'"
                Sel2+=" AND nazwa_id='"+rsglobal.Dekoduj(Dane2[0][1])+"' AND data='"+rsglobal.Dekoduj(Dane2[0][2])+"'"
                Sel2+=" AND numer="+str(Dane2[0][3])+" AND nr_poz="+str(Dane2[0][4])+" AND nr_ppoz="+str(Dane2[0][5])
                Sel2+=" AND rozliczone_wn=0 AND rozliczone_ma=0"
                if TypRozl in [1,3]:
                    Sel2+=" AND kwota_wn="+str(Dane2[0][13])
                    if not Jednowalutowo:
                        Sel2+=" AND saldo_wal_wn <> 0"
                else:
                    Sel2+=" AND kwota_ma="+str(Dane2[0][14])
                    if not Jednowalutowo:
                        Sel2+=" AND saldo_wal_ma <> 0"

                stat,dump,dump,dump=PolSQL.Execute(Ins2,1)
        if stat=='OK':
            #rozliczenie sald na kontach z dwch stron
            Fun1=''
            Fun2=''
            if TypRozl in [2,3]:    
                if TypRozl==2:
                    Typ1='W'
                    Typ2='M'
                else:
                    Typ1='M'
                    Typ2='W'
                    
                Fun1="SELECT rsf_zapisz_stan_konta_tylko_salda('"+Firma+"','"+Data+"','"+Wybrane+"','"+Typ1+"',"+str(KwotaRozlPln1*-1*Znak)+",'"+Waluta1+"',"+str(KwotaRozl1*-1*Znak)+");"
                Fun2="SELECT rsf_zapisz_stan_konta_tylko_salda('"+Firma+"','"+Data+"','"+Wybrane+"','"+Typ2+"',"+str(KwotaRozlPln2*-1*Znak)+",'"+Waluta2+"',"+str(KwotaRozl2*-1*Znak)+");"
        
                #------------------------------------------------------------
                #-- wykonanie na bazie tych wszystkich operacji
                #------------------------------------------------------------
                stat,WynSQL,dump,dump=PolSQL.Execute(Fun1,3)
                if stat == 'OK':
                    if WynSQL<>[['OK']]:
                        stat = 'Bdy zmiany salda :'+WynSQL[0][0]
                        
                if stat == 'OK':        
                    stat,WynSQL,dump,dump=PolSQL.Execute(Fun2,3)
                    if stat == 'OK':
                        if WynSQL<>[['OK']]:
                            stat = 'Bdy zmiany salda :'+WynSQL[0][0]
                    
                #stat,dump,dump,dump=PolSQL.Execute(Fun1+Fun2,1)

        #jesli si nie udao to robimy Rollback
        if stat<> 'OK':
            PolSQL.Rollback()
            
        #jesli si udao to robimy Commit i pobieramy numery nowych operacji
        if stat=='OK':
            PolSQL.Commit()
            
            if Sel1=='':
                Lista1.remove(Lista1[0])
            else:
                stat,DaneOp,dump,dump=PolSQL.Execute(Sel1,3)
                if stat=='OK':
                    if len(DaneOp)>0:
                        Lista1[0]=rsglobal.Dekoduj(str(DaneOp[0][0]))
                    else:
                        Lista1.remove(Lista1[0])
            
        if stat=='OK':                
            if Sel2=='':
                Lista2.remove(Lista2[0])
            else:
                stat,DaneOp,dump,dump=PolSQL.Execute(Sel2,3)
                if stat=='OK':
                    if len(DaneOp)>0:
                        Lista2[0]=rsglobal.Dekoduj(str(DaneOp[0][0]))
                    else:
                        Lista2.remove(Lista2[0])

        if Kwota >0:
            Kwota=0

    return stat,Lista1,Lista2,Kwota


#-##############################################################################
#- GWNA FUNKCJA
#-##############################################################################

LOper=klucze[0]
Data=rsglobal.Dekoduj(klucze[1])
Kwota=klucze[2]
Konto=rsglobal.Dekoduj(klucze[3])
Wybrane=rsglobal.Dekoduj(klucze[4])
KontoC=rsglobal.Dekoduj(klucze[5])
ObustronneF=klucze[6]
NrZamowieniaF=klucze[7]
NierozliczoneF=klucze[8]


# 5 - pobranie danych, 6 - rozliczenie czciowe, 7 - rozliczenie jednego konta, 9 - rozlicznie wielu kont,
# 8 - cofanie, 11 - poprzednie,12 - nastpne,15 - rozliczanie z pliku, 19 - rozliczanie wielu kont harmonogramem
# 17 - sprawdzenie czy kontrahent ma wczone 'tworzy zalego', 25 - naprawa rozlicze midzyokresowych
Fun=klucze[-1] 
stat='OK'
dane=[]
OkresRozl=self.okres_id
if Fun==19:
    OkresRozl=rsglobal.Dekoduj(klucze[9])
    
#wiemy tu, e bdzie wicej ni jeden rozrachunek do zrobienia, bo kwota=0
WiecejNizJeden=(Kwota==0)
#Czy Rozliczone Pary
CzyRozliczonePary=False
CzyJednaData=True
# lista bdw rozliczania par
LBledowPar=[]

#debug level
dl=1


#-------------------------------------------------------------------------------
#wstpne sprawdzenie danych ktre przyszy
#-------------------------------------------------------------------------------

if not rsglobal.SprawdzCzyToData(Data):        
    if Data not in ('','    -  -  '):
        stat="BL DATA"

if Konto=='' and Fun<>17:        
    stat="BR KONTO"
    
if Fun in [6,7,8,9,11,12,15,19] and stat=='OK':
    stat,KontoTest,dump,dump=self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresRozl+"','"+Konto+"');",3)
    OpisK=eval(KontoTest[0][0])[1]
    if OpisK=='':
        stat="BL KONTO"

#sprawdzenie czy rozliczanie a nie select - jesli tak to sprawdzenie czy konto jest rozrachunkowe
if stat=='OK':
    if Fun in [6,7,8,9,15,19]:
        if not eval(KontoTest[0][0])[3]:
            stat="BL KO NIEROZRACHUNKOWE"
            
if stat=='OK' and Wybrane<>'' and Fun<>8:
    stat,KontoWTest,dump,dump=self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresRozl+"','"+Wybrane+"');",3)
    OpisKW=eval(KontoWTest[0][0])[1]
    if OpisKW=='':
        stat="BL KWYBRANE"
        

if stat=='OK' and Wybrane<>'' and Fun in [6,7,8,9,15,19]:
    #sprawdzamy czy wybrane konto ju ma BO
    if stat == 'OK':
        stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,OkresRozl)
        if stat =='OK':
            LOkresow=rsglobal.Dekoduj(Wyn[0])
            DataGr=rsglobal.Dekoduj(Wyn[1])

if stat=='OK' and Wybrane<>'' and Fun in [6,7,8,9,15,19]:            
    # sprawdzenie czy wybrane konto jest ju przeniesione do BO. Jeli tak to przerywamy.    
    SQL="SELECT konto FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"' AND konto='"+Wybrane+"'"
    SQL+=" AND okres_id=(SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND data_od> (SELECT data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+OkresRozl+"') ORDER BY data_od LIMIT 1) AND miesiac='00';"
    stat,DTestBO,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DTestBO)>0:
            stat="Konto "+Wybrane+" jest ju przeniesione do nowego okresu rozliczeniowego i nie mona go rozlicza w aktualnie wybranym okresie"

#-------------------------------------------------------------------------------
# sprawdzenie czy tworzy zalego dla kontrahenta
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==17:
    # zamiast listy operacji wysyamy kontrahenta
    Kontr=klucze[0]
    SQL="SELECT k.kontrahent_id,COALESCE(kf.tworzyc_zaleglosc,FALSE) "
    SQL+=" FROM rs_kontrahenci k LEFT OUTER JOIN rs_kontrahenci_fakturowanie kf USING (firma_id,kontrahent_id)"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"' ORDER BY data_od DESC LIMIT 1;"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)

#-###############################################################
# PRZYGOTOWANIE LIST OPERACJI DO ROZLICZENIA ZGODNIE Z ZAWARTOSCI 
# PRZYSANEGO PLIKU
#-###############################################################

if Fun ==15 and Wybrane <> '' and stat=='OK':
    DanePlik=LOper[0]
    ListaOper=[]
    CzyJednaData=False
    ListaOper.append([int(LOper[1][0]),1])
    
    #sownik do poczenia wiersza i operacji do rozliczenia. Jeli na koniec co nie zostanie rozliczone z wiersza, 
    #ktry mia by rozliczony to trafi do nierozliczonych. Jego wypenienie jest gwarancj, e co byo do rozliczenia
    SRozlicz={}
    LWyk=[]
    LNWyk=[]
    
    if len(DanePlik)==0:
        stat='Brak danych w pliku'
    
    if stat=='OK':
        WierszTest=DanePlik[0].replace(chr(10),'').replace(chr(13),'').replace(chr(160),'')
        WierszTest=WierszTest.strip()
        
        #sprawdzenie separatora dziesitnego - trzeci znak od koca. Moe by ',' lub '.'
        ZnakDz=WierszTest[-3]
        if not ZnakDz in [',','.']:
            stat='Bdna skadnia pliku - nieprawidowy separator dziesitny : '+ZnakDz
            
    if stat=='OK':
        #sprawdzenie rozdzielnika wiersza. Na razie moe by ';' lub ','
        if WierszTest.count(';')>0:
            ZnakKol=';'
        else:
            ZnakKol=','
            
        if WierszTest.count(';')>1:
            stat='Bdna skadnia pliku - zdefiniowano wicej ni 2 kolumny'            
        
        if ZnakKol==',' and WierszTest[:-3].count(',')==0:
            stat='Bdna skadnia pliku - znak podziau wiersza na kolumny jest inny ni ";" i ","'            

    if stat=="OK":
        #wydaje si, e skadnia pierwszego wiersza jest ok. Lecimy wiersz po wierszu i analizujemy    
        for wiersz in DanePlik:
            if stat=='OK':
                wiersz=rsglobal.Dekoduj(wiersz)
                #wiersz ma wycity znak koca wiersza, usunite spacje i " i dzielony jest na kolumny
                wierszbuf=wiersz.strip('\n').replace(' ','').replace('"','').split(ZnakKol)
                # nie udao si usun znaku inaczej :(
                wierszbuf=eval(str(wierszbuf).replace('\\xa0',''))
                if len(wierszbuf)<>2:
                    LNWyk.append(wiersz.strip('\n')+'   - za duo kolumn w wierszu')
                    continue
            
                # Kwota to kwota pozycji, SumaKwot to suma zakresw w pozycji,
                Dok=wierszbuf[0]
                Kwota=wierszbuf[1].replace(',','.')
                Kwota=float(Kwota)
                stat,LWykBuf,LNWykBuf,LOperBuf=PobierzOperacjeZWiersza(self.firma_id,self.okres_id,Wybrane,self.PolSQL,wiersz,Dok,Kwota,self)
                if LOperBuf <> []:
                    SRozlicz[wiersz.strip('\n')]=LOperBuf
                LWyk=LWyk+LWykBuf
                LNWyk=LNWyk+LNWykBuf
                ListaOper=ListaOper+LOperBuf
                
        if len(ListaOper) > 1:
            LOper=ListaOper
        else:
            LOper=[]


#-###############################################################
#ROZLICZANIE AUTOMATYCZNE KONTA - CZʦ ROZLICZAJCA PARY 
#-###############################################################

if Fun in [7,9,19] and Wybrane <> '' and stat=='OK':
    if not (((self.oddzial_id,'076106') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR ROZL'
    # blokujemy konto na rozliczanie przez kogokolwiek innego
    SQL="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkresow+")"
    SQL+=" AND konto='"+Wybrane+"' AND rozliczone_wn=0 AND rozliczone_ma=0 FOR UPDATE NOWAIT;"
    stat,daneBl,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='ZAM WYK'
        
    if stat=='OK':
        #pobranie tych operacji dla wybranego konta, ktre maj wpisane, e bd z czym konkretnym rozliczane.
        SQL="SELECT r.seria,rr.seria,r.dowod_id,r.nazwa_id,r.data,r.numer,r.nr_poz,r.nr_ppoz,r.kwota_wn,r.kwota_ma,"
        SQL+="rr.dowod_id,rr.nazwa_id,rr.data,rr.numer,rr.nr_poz,rr.nr_ppoz,rr.kwota_wn,rr.kwota_ma "
        SQL+=" FROM rs_rozrachunki r INNER JOIN rs_rozrachunki rr ON (r.firma_id=rr.firma_id"
        SQL+=" AND r.konto=rr.konto AND (rr.seria::TEXT = ANY ( STRING_TO_ARRAY ("
        SQL+=" REPLACE(r.seria_rozl,' ',''),','))))"
        SQL+=" WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id IN ("+LOkresow+")"
        SQL+=" AND r.konto='"+Wybrane+"' AND r.rozliczone_wn=0 AND r.rozliczone_ma=0"
        SQL+=" AND NOT r.seria_rozl IN ('','0');"
        stat,danePar,dump,dump=self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        # mamy pary do wsplnego rozliczenia.
        LBledowPar=[]
        for para in danePar:
            if stat=='OK':
                #sprawdzenie co da si rozliczy z nich. Moe si okaza, e co ju zostao rozliczone.
                # Moe by nawet rozliczone w tym przebiegu wczeniej. Za kadym razem sprawdzamy czy obie 
                # operacje jeszcze nadaj si do rozliczenia.
                OpRozl1='0'
                OpRozl2='0'
                Oper1=str(para[0])
                Oper2=str(para[1])
                
                Dowod1=rsglobal.Dekoduj(para[2])
                Nazwa1=rsglobal.Dekoduj(para[3])
                Data1=rsglobal.Dekoduj(para[4])
                Nr1=str(para[5])
                NrPoz1=str(para[6])
                NrPPoz1=str(para[7])
                KwWn1=str(para[8])
                KwMa1=str(para[9])
                
                Dowod2=rsglobal.Dekoduj(para[10])
                Nazwa2=rsglobal.Dekoduj(para[11])
                Data2=rsglobal.Dekoduj(para[12])
                Nr2=str(para[13])
                NrPoz2=str(para[14])
                NrPPoz2=str(para[15])
                KwWn2=str(para[16])
                KwMa2=str(para[17])
                
                #sprawdzamy jaka operacja naprawd bdzie rozliczana w przypadku operacji 1
                SQL="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"'  AND okres_id IN ("+LOkresow+")"
                SQL+=" AND dowod_id='"+Dowod1+"' AND nazwa_id='"+Nazwa1+"' AND data='"+Data1+"' AND numer="+Nr1
                SQL+=" AND nr_poz="+NrPoz1+" AND nr_ppoz="+NrPPoz1+" AND konto='"+Wybrane+"' AND kwota_wn="+KwWn1
                SQL+=" AND kwota_ma="+KwMa1+" AND rozliczone_wn=0 AND rozliczone_ma=0;"
                stat,daneOper1,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(daneOper1)>0:
                    OpRozl1=str(daneOper1[0][0])
                    
                if OpRozl1>0:
                    #sprawdzamy jaka operacja naprawd bdzie rozliczana w przypadku operacji 2
                    SQL="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"'  AND okres_id IN ("+LOkresow+")"
                    SQL+=" AND dowod_id='"+Dowod2+"' AND nazwa_id='"+Nazwa2+"' AND data='"+Data2+"' AND numer="+Nr2
                    SQL+=" AND nr_poz="+NrPoz2+" AND nr_ppoz="+NrPPoz2+" AND konto='"+Wybrane+"' AND kwota_wn="+KwWn2
                    SQL+=" AND kwota_ma="+KwMa2+" AND rozliczone_wn=0 AND rozliczone_ma=0;"
                    stat,daneOper2,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat=='OK':
                        if len(daneOper2)>0:
                            OpRozl2=str(daneOper2[0][0])
        
            if stat=='OK':
                #mamy dwie operacje, ktre rozliczamy tak jak normaln list
                if OpRozl1<>'0' and OpRozl2<>'0':
                   wynik=RozliczDwieListy([OpRozl1],[OpRozl2],0,True,self.PolSQL,max(Data1,Data2),self.firma_id,OkresRozl,Wybrane,CzyJednaData,self)
                   stat=wynik[0] 
                   if stat=='OK':
                       CzyRozliczonePary=True
                   else:
                       LBledowPar.append(stat+' - rozrachunki '+str(OpRozl1)+' i '+str(OpRozl2))
                       stat='OK'
                
        
#-###############################################################
#ROZLICZANIE AUTOMATYCZNE KONTA - TWORZENIE LIST DO ROZLICZENIA POJEDYNCZEGO,
# KTRE ROZLICZY CAO
#-###############################################################

    if stat=='OK':
        #sprawdzenie czy sumy po obu stronach s rwne
        SQL="SELECT SUM(saldo_wal_wn-saldo_wal_ma) FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id IN ("+LOkresow+") AND konto = '"+Wybrane+"' AND (rozliczone_wn=0 AND rozliczone_ma=0);"
        stat,SumyKW,dump,dump=self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow('SQL '+str(SQL),5)
        rsglobal.ZapiszDoLogow('SumyKW '+str(SumyKW),5)

    if stat=='OK':
        Saldo=SumyKW[0][0]
        if SumyKW[0][0] <> 0:
            LOper=[]
            if Fun==7:
                if not CzyRozliczonePary and LBledowPar==[]:
                    stat="BL ROZNSALD"

    if stat=='OK':
        if SumyKW[0][0]==0:
            CzyJednaData=False
            #jeli konto da si rozliczy to pobieramy operacje
            SQL="SELECT seria,CASE WHEN kwota_ma>0 THEN 1 WHEN kwota_ma<0 THEN 2 WHEN kwota_wn>0 THEN 3"
            SQL+=" WHEN kwota_wn<0 THEN 4 ELSE 0 END FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND okres_id IN ("+LOkresow+") AND konto = '"+Wybrane+"' AND (rozliczone_wn=0 AND rozliczone_ma=0);"
            stat,LOper,dump,dump=self.PolSQL.Execute(SQL,3)
        

#-###############################################################
#ROZLICZANIE POJEDYNCZE
#-###############################################################

if Fun in [6,7,9,15,19] and LOper<>[] and stat=='OK':
    if not (((self.oddzial_id,'076106') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR ROZL'
    
    if stat=='OK':
        # zrobienie 4 list - kada z innym typem operacji. Potem bdziemy rozlicza parami typw.
        # Ma Plus, Ma Minus, Winien Plus, Winien Minus
        LOperMaP=[]
        LOperMaM=[]
        LOperWnP=[]
        LOperWnM=[]
        Operacje=[]
        for oper in LOper:
            if oper[1]==1:
                LOperMaP.append(str(oper[0]))
            elif oper[1]==2:
                LOperMaM.append(str(oper[0]))
            elif oper[1]==3:
                LOperWnP.append(str(oper[0]))
            elif oper[1]==4:
                LOperWnM.append(str(oper[0]))
            
            Operacje.append(str(oper[0]))

        #----------------------------------------------------------------
        # PODSTAWOWE TESTY NA LIST OPERACJI (ORAZ ICH BLOKADA)
        #----------------------------------------------------------------
        LKorektDoDatWpl=[]
        #pobranie danych o pozycjach do testw (i sprawdzenie czy s korekty)
        SQL= "SELECT seria,rozliczone_wal_wn,rozliczone_wal_ma,data,kwota_wn," # 0-4
        SQL+=" f_typ,f_wyznacznik_id,f_data,f_numer,COALESCE(data_ksieg_kosztow::TEXT,'')" # 5-9
        SQL+=" FROM rs_rozrachunki"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkresow+")"
        SQL+=" AND seria IN ("+str(Operacje)[1:-1]+") FOR UPDATE NOWAIT;"
        stat,Dane,dump,dump=self.PolSQL.Execute(SQL,3,False,True)
        if stat<>'OK':
            stat='Bd pobierania rozrachunkw na wyczno.\n Sprbuj wykona t sam operacj za chwil.\n Bd :\n'+stat
            
    if stat=='OK':
        rsglobal.ZapiszDoLogow('Data '+Data,5)
        rsglobal.ZapiszDoLogow('Operacje '+str(Operacje),5)
        for oper in Operacje:
            jest=False
            rozl=False
            for poz in Dane:
                rsglobal.ZapiszDoLogow('Pozycja '+str(poz),5)
                if stat=='OK':
                    if str(poz[0])==oper:
                        jest=True
                        if poz[1]>0 or poz[2]>0:
                            stat="Operacja "+oper+" jest ju rozliczona"
                            break
                        if poz[9] <> '':
                            if poz[9] > Data and not (Data in ['','    -  -  ']):
                                stat='Data operacji '+oper+' pniejsza ni data rozliczenia'    
                        elif poz[3] > Data and not (Data in ['','    -  -  ']):
                            stat='Data operacji '+oper+' pniejsza ni data rozliczenia'    
                            
                if stat=='OK':
                    # jeli operacja po stronie Wn
                    if poz[4]<>0:
                        # jeli typ faktury to korekta
                        if poz[5]=='K':
                            if not poz[6:] in LKorektDoDatWpl:
                                LKorektDoDatWpl.append(poz[6:])
                            
            if stat=='OK' and not jest:
                stat="Brak operacji "+oper+" w bazie danych"                
                
            if stat <>'OK':
                break
        
        #----------------------------------------------------------------
        # EWENTUALNE POBRANIE DATY WPYWU DO WPISANIA NA KOREKTY
        #----------------------------------------------------------------
        if stat=='OK':
            DataWpl=''
            # jeli jest jedna operacja po stronie MA (na +) i s korekty
            if len(LOperMaP)==1 and LKorektDoDatWpl<>[]:
                # pobranie daty z operacji MA
                SQL="SELECT data FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' AND seria="+LOperMaP[0]
                stat,DaneDaty,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat=='OK':
                    if len(DaneDaty)>0:
                        DataWpl=DaneDaty[0][0]
                        
        #----------------------------------------------------------------
        # PTLA PO LISTACH ROZRACHUNKW
        #----------------------------------------------------------------
    
        #Parujemy odpowiednie typy list
    
        # + i - po stronie ma 
    if stat=='OK':
        rsglobal.ZapiszDoLogow('Data2 '+Data,5)
        rsglobal.ZapiszDoLogow('czyjednadata '+str(CzyJednaData),5)
        wynik=RozliczDwieListy(LOperMaP,LOperMaM,Kwota,WiecejNizJeden,self.PolSQL,Data,self.firma_id,OkresRozl,Wybrane,CzyJednaData,self)
        stat=wynik[0]
    if stat=='OK':
        LOperMaP=wynik[1]
        LOperMaM=wynik[2]
        Kwota=wynik[3]
        
        # + i - po stronie wn 
        wynik=RozliczDwieListy(LOperWnP,LOperWnM,Kwota,WiecejNizJeden,self.PolSQL,Data,self.firma_id,OkresRozl,Wybrane,CzyJednaData,self)
        stat=wynik[0]
    if stat=='OK':
        LOperWnP=wynik[1]
        LOperWnM=wynik[2]
        Kwota=wynik[3]
        
        # + wn i ma
        wynik=RozliczDwieListy(LOperWnP,LOperMaP,Kwota,WiecejNizJeden,self.PolSQL,Data,self.firma_id,OkresRozl,Wybrane,CzyJednaData,self)
        stat=wynik[0]
    if stat=='OK':
        LOperWnP=wynik[1]
        LOperMaP=wynik[2]
        Kwota=wynik[3]
        
        # - wn i ma
        wynik=RozliczDwieListy(LOperWnM,LOperMaM,Kwota,WiecejNizJeden,self.PolSQL,Data,self.firma_id,OkresRozl,Wybrane,CzyJednaData,self)
        stat=wynik[0]
    if stat=='OK':
        LOperWnM=wynik[1]
        LOperMaM=wynik[2]
        Kwota=wynik[3]

    # wpisanie daty wpywu i daty odbioru do odpowiednich korekt
    if stat=='OK' and DataWpl<>'':
        for korekta in LKorektDoDatWpl:
            if stat=='OK':
                stat,opis = fs_korekty_pom.WstawDateWplywuIOdbioru(self.PolSQL,self.firma_id,korekta[0],korekta[1],korekta[2],DataWpl,DataWpl,'P')
        
    if stat=='OK':
        self.PolSQL.Commit()
    else:
        self.PolSQL.Rollback()


#-##############################################################################
# ROZLICZENIE Z PLIKU - UWZGLDNIENIE TEGO CO NIE ROZLICZYO SI PO WYBRANIU DO ROZLICZENIA (15 cd)
#-##############################################################################
        
if Fun ==15 and Wybrane <> '' and stat=='OK':
    if SRozlicz <> {}:
        for wiersz in SRozlicz.keys():
            if stat=='OK':
                LBuf=SRozlicz[wiersz]
                OperBuf=''
                for w in LBuf:
                    OperBuf+=str(w[0])+','
                
                OperBuf=OperBuf.strip(',')
                SQL="SELECT * FROM rs_rozrachunki r1 INNER JOIN rs_rozrachunki r2 USING (firma_id,okres_id,dowod_id,"
                SQL+="nazwa_id,data,numer,nr_poz,nr_ppoz,konto,kwota_wn,kwota_ma) WHERE r1.firma_id='"+self.firma_id+"' "
                SQL+="AND r1.okres_id IN ("+LOkresow+") AND r1.konto='"+Wybrane+"' and r1.data_rozlicz IS NULL "
                SQL+="AND r2.seria IN ("+OperBuf+");"
                stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DTest)>0:
                    LWyk.remove(wiersz)
                    LNWyk.append(wiersz+' - nie wykonano penego rozliczenia')
            else:
                LWyk.remove(wiersz)
                LNWyk.append(wiersz+' - problemy z testowaniem potencjalnie rozliczonego wiersza :'+stat)



#-##############################################################################
#COFANIE ROZRACHUNKOW DO DNIA (8)
#-##############################################################################

if Fun==8 and stat=='OK':
    if not (((self.oddzial_id,'076107') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR COF'
        
    if stat=='OK':
        if Wybrane=='':
            Wybr=Konto
        else:
            Wybr=Wybrane
            
    if stat=='OK':
        #sprawdzenie czy podane konto do cofania
        if KontoC.strip()=='':
            stat='BR KONTOC'
            
    if stat == 'OK':
        #sprawdzamy czy ju istnieje BO
        stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,self.okres_id)
        if stat =='OK':
            LOkresowCof=Wyn[0]
            DataGrCof=Wyn[1]            

    if stat=='OK':
        #pobranie kont ktre bed zmieniane
        SQL="SELECT DISTINCT konto FROM rs_rozrachunki "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkresowCof+") AND konto LIKE '"+KontoC+"%' "
        SQL+=" AND data_rozlicz >='"+Data+"' "
        SQL+=" ORDER BY konto;"
        stat,DaneK,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        #ptla po kontach
        for konto in DaneK:
            
            if stat=='OK':
                # dla kadego konta pobieramy list rozrachunkw, ktre bd zmieniane
                SQL="SELECT seria,seria_prz FROM rs_rozrachunki "
                SQL+="WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkresowCof+") AND konto = '"+rsglobal.Dekoduj(konto[0])+"' "
                SQL+=" AND data_rozlicz >='"+Data+"' "
                SQL+=" ORDER BY seria FOR UPDATE NOWAIT;"
                stat,Dane,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                LRozr=[]
                for rozr in Dane:
                    if not rozr[0] in LRozr:
                        LRozr.append(rozr[0])
                    if not rozr[1] in LRozr:
                        LRozr.append(rozr[1])
                        
                stat=fs_rozrachunki_pom.CofnijRozrachunki(self,LRozr,rsglobal.Dekoduj(konto[0]))
            
            if stat=='OK':
                self.PolSQL.Commit()
            else:
                self.PolSQL.Rollback()

                
#-##############################################################################
# POBIERANIE DANYCH (5,6,7,9,11,12,13,15)
#-##############################################################################

# jeli Funkcja to 9 lub 19 to chcemy mimo wszystko pobra nastpne konto do rozliczenia
StatPom='OK'
if Fun in [9,19] and stat<>'OK':
    StatPom=str(stat)
    stat='OK'

if ((Fun in [5,6,7,9,11,12,13,15,19]) or (Fun==8 and Wybrane <> ''))  and stat=='OK':
    if Fun <> 19:
        if not (((self.oddzial_id,'076100') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
            stat='UPR PRZ'
        
        # pobranie potencjalnych okresw testw
    if stat=='OK':
        stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,OkresRozl)
    if stat=='OK':    
        FiltrOkr=" AND okres_id IN ("+LOkr[0]+") "
        
    if stat=='OK':    
        FiltrObustronny=''
        if ObustronneF and Fun <> 9:
            FiltrObustronny=' GROUP BY konto HAVING SUM(saldo_wn) <> 0 AND SUM(saldo_ma) <> 0 '
        
        TestDatyR = "data_rozlicz > (SELECT data_do FROM rs_definicje_okresow "
        TestDatyR+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+OkresRozl+"')"
        
        if NierozliczoneF:
            RozliczWn = " rozliczone_wn "
            RozliczMa = " rozliczone_ma "
        else:
            RozliczWn = " (CASE WHEN "+TestDatyR+" THEN 0 ELSE rozliczone_wn END) "
            RozliczMa = " (CASE WHEN "+TestDatyR+" THEN 0 ELSE rozliczone_ma END) "
            

        #Pierwsze pobieranie
        if Fun in [5,9,19] and Wybrane=='':
            Sql="SELECT konto FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' "+FiltrOkr
            Sql+=" AND konto LIKE '"+Konto+"%' AND "+RozliczWn+"=0 AND "+RozliczMa+"=0 "
            Sql+=FiltrObustronny
            Sql+=" ORDER BY konto LIMIT 1;"
            stat,DKontoW,dump,dump=self.PolSQL.Execute(Sql,3)
            if stat<>'OK':
                stat='BL KONT'
            elif len(DKontoW)==0:
                stat='BR WYBR'
            else:
                Wybrane=rsglobal.Dekoduj(DKontoW[0][0])
                
        #Poprzednie konto        
        elif Fun==11:
            Sql="SELECT konto FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' "+FiltrOkr
            Sql+=" AND konto LIKE '"+Konto+"%' AND konto <'"+Wybrane+"' AND "+RozliczWn+"=0 AND "+RozliczMa+"=0 "
            Sql+=FiltrObustronny+" ORDER BY konto DESC LIMIT 1;"
            stat,DKontoW,dump,dump=self.PolSQL.Execute(Sql,3)
            if stat<>'OK':
                stat='BL KONN'
            elif len(DKontoW)>0:
                Wybrane=rsglobal.Dekoduj(DKontoW[0][0])
                
        #Nastpne konto        
        elif Fun in [9,12,19] and Wybrane<>'':
            Sql="SELECT konto FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' "+FiltrOkr
            Sql+=" AND konto LIKE '"+Konto+"%' AND konto >'"+Wybrane+"' AND "+RozliczWn+"=0 AND "+RozliczMa+"=0 "
            Sql+=FiltrObustronny+" ORDER BY konto LIMIT 1;"
            stat,DKontoW,dump,dump=self.PolSQL.Execute(Sql,3)
            if stat<>'OK':
                stat='BL KONN'
            elif len(DKontoW)>0:
                Wybrane=rsglobal.Dekoduj(DKontoW[0][0])

        #Mamy wybrane Konto i pobieramy dane do grida 
        if stat=='OK' and Wybrane<>'':
            
            #sprawdzamy czy wybrane konto ju ma BO
            stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,OkresRozl)
            if stat =='OK':
                LOkresow=Wyn[0]
                DataGr=Wyn[1]
            
        if stat=='OK' and not Fun in [9,19]:            
            PoleNrZam="''"
            PoleKontr="''"
            JoinFaktur=""
            if NrZamowieniaF:
                PoleNrZam="COALESCE (f.zamowienie_nr,'')"
                PoleKontr="COALESCE (f.kontrahent_id,k.kontrahent_id,'')"
                JoinFaktur =" LEFT OUTER JOIN rs_faktury f ON "
                JoinFaktur+="(f.firma_id=r.firma_id AND f.wyznacznik_id=r.f_wyznacznik_id "
                JoinFaktur+=" AND f.data=r.f_data AND f.numer=r.f_numer AND r.f_typ='F') "
                JoinFaktur+=" LEFT OUTER JOIN rs_korekty k ON "
                JoinFaktur+="(k.firma_id=r.firma_id AND k.wyznacznik_id=r.f_wyznacznik_id "
                JoinFaktur+=" AND k.data=r.f_data AND k.numer=r.f_numer AND r.f_typ='K') "
            
            if NierozliczoneF:
                FiltrDatyRozlicz="FALSE"
            else:
                FiltrDatyRozlicz="data_rozlicz>'"+DataGr+"'"
            
            SQL="SELECT FALSE,okres_id,r.dowod_id||'/'||r.data||'/'||r.numer::TEXT||'/'||r.nr_poz::TEXT||'/'||r.nr_ppoz::TEXT,r.symbol_dok,"
            SQL+=" r.data,COALESCE(r.data_wyst::TEXT,''),r.saldo_wn,r.saldo_ma,r.kwota_wn,r.kwota_ma,rozliczone_wn,rozliczone_ma,"
            SQL+=" COALESCE(data_rozlicz::TEXT,''),r.tresc,r.waluta,r.saldo_wal_wn,r.saldo_wal_ma,"
            SQL+=" r.kwota_wal_wn,r.kwota_wal_ma,COALESCE(r.termin_plat::TEXT,''),"+PoleNrZam+","+PoleKontr+",COALESCE(r.data_ksieg_kosztow::TEXT,''),r.seria"
            SQL+=" FROM rs_rozrachunki r "+JoinFaktur+" WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id IN ("+LOkresow+")"
            SQL+=" AND r.konto='"+Wybrane+"' AND ((r.rozliczone_wn=0 AND r.rozliczone_ma=0) OR "+FiltrDatyRozlicz+") "
            SQL+=" ORDER BY r.data,r.dowod_id||'/'||r.data||'/'||r.numer::TEXT||'/'||r.nr_poz::TEXT||'/'||r.nr_ppoz::TEXT;"
            stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
            
        #Pobieramy reszt danych (salda i opis konta)
        if stat=='OK':
            #AB 27.04.22r 
            # stat,DK,dump,dump=self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresRozl+"','"+Wybrane+"');",3)
            stat,DK,dump,dump=self.PolSQL.Execute("SELECT rsf_podaj_nazwe_konta('"+self.firma_id+"','"+OkresRozl+"','"+Wybrane+"');",3)
            KontoW=str(Wybrane)
            # OpisW=eval(DK[0][0])[1]
            OpisW=DK[0][0]
            #konto pocztkowe
            KontoP=Konto
            Wybrane=Wybrane[len(Konto):]
            Gdzie=Wybrane.find('-')
            if Gdzie==-1:
                KontoP=KontoP+Wybrane
            else:
                KontoP=KontoP+Wybrane[0:Gdzie]

            if Fun == 19:
                SaldoWnP = 0
                SaldoMaP = 0
                SaldoWnW = 0
                SaldoMaW = 0
            else:
                #salda konta pocztkowego
                stat,SaldoWnP,SaldoMaP=fs_rozrachunki_pom.PodajAktualnyStanKonta(self,OkresRozl,KontoP)
    
                if stat=='OK':
                    stat,SaldoWnW,SaldoMaW=fs_rozrachunki_pom.PodajAktualnyStanKonta(self,OkresRozl,KontoW)

        if stat=='OK':
            wyn1=[KontoP,KontoW,OpisW,SaldoWnP,SaldoMaP,SaldoWnW,SaldoMaW,LBledowPar]
            if Fun==15:
                wyn2=[LWyk,LNWyk]       

#-------------------------------------------------------------------------------
# to dla funkcji 9 pobiera dane
#-------------------------------------------------------------------------------

if Fun in [9,19]:
    wyn2=StatPom

if Fun==7 and stat<>'OK':
    wyn1=[LBledowPar]

#-------------------------------------------------------------------------------
# FUNKCJA NAPRAWIAJCA ROZRACHUNKI MIDZYOKRESOWE (25)
#-------------------------------------------------------------------------------
    
if Fun == 25 and stat == 'OK':
    if self.operator_id <> STANDARD_OPERATOR_ID:
        stat = 'Brak uprawnie do uruchomienia funkcji naprawy rozlicze midzyokresowych'
    
    if stat == 'OK':
        LBledow = []
        Konto = klucze[3]
        # pobranie okresu wczeniejszego
        stat,OkresPoprz = fs_rozrachunki_pom.PodajPoprzedniOkres(self,self.okres_id)
        
    if stat == 'OK':
        # pobranie dat od-do aktualnego okresu
        SQL = "SELECT data_od,data_do FROM rs_definicje_okresow "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"';"
        stat,DatyOkr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania dat aktualnego okresu: '+stat
    
    if stat == 'OK':
        DataOd =DatyOkr[0][0]
        DataDo =DatyOkr[0][1]
        
        # pobranie rozrachunkw rozliczanych midzyokresowo ze starego okresu
        SQL = "SELECT r.seria,r.seria_prz,COALESCE(r.pdk_dowod_id,r.dowod_id),COALESCE(r.pdk_nazwa_id,r.nazwa_id)" # 0 - 3
        SQL+=",COALESCE(r.pdk_data,r.data),COALESCE(r.pdk_numer,r.numer),COALESCE(r.pdk_nr_poz,r.nr_poz)," # 4 - 6
        SQL+=" COALESCE(r.pdk_nr_ppoz,r.nr_ppoz),data_rozlicz, " # 7 - 8
        SQL+=" COALESCE(r.symbol_dok,''),COALESCE(r.termin_plat::TEXT,''),COALESCE(r.kontrahent_id,''), r.konto," # 9 - 12
        SQL+=" r.rozliczone_wn,r.rozliczone_ma,r.kwota_wn,r.kwota_ma" # 13 - 16
        SQL+=" FROM rs_rozrachunki r WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id = '"+OkresPoprz+"'"
        SQL+= " AND data_rozlicz>='"+DataOd+"' AND data_rozlicz <='"+DataDo+"'"
        if Konto <> '':
            SQL+=" AND r.konto = '"+Konto+"'"
        stat,DRozr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania listy rozrachunkw ze starego okresu: '+stat
        
    if stat == 'OK':
        # ptla po uzyskanej licie rozrachunkw
        for poz in DRozr:
            NrDowodu = poz[2]+'/'+poz[3]+'/'+poz[4]+'/'+str(poz[5])+'/'+str(poz[6])+'/'+str(poz[7])+' o numerze serii '+str(poz[0])
            if stat == 'OK':
                # sprawdzenie istnienia rozrachunku przeciwnego
                SQL = "SELECT firma_id,okres_id,seria_prz,data_rozlicz FROM rs_rozrachunki WHERE seria = "+str(poz[1])
                stat,DRozrPrz,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd pobierania rozrachunku przeciwnego z nowego okresu: '+stat
            
            if stat == 'OK':
                if len(DRozrPrz) == 0:
                    LBledow.append('Brak rozrachunku przeciwnego dla rozrachunku '+NrDowodu)
                    continue
                if DRozrPrz[0][0] <> self.firma_id:
                    LBledow.append('Rozrachunek przeciwny jest z firmy '+DRozrPrz[0][0]+' dla rozrachunku '+NrDowodu)
                    continue
                if DRozrPrz[0][1] <> self.okres_id:
                    LBledow.append('Rozrachunek przeciwny jest z okresu '+DRozrPrz[0][1]+' dla rozrachunku '+NrDowodu)
                    continue
                # sprawdzenie czy przeciwny rozrachunek zosta ju rozliczony. Jeli ma inny numer serii przeciwnej ni 
                # ten z okresu wczeniejszego to zakadamy, e jest obsuony.
                if DRozrPrz[0][2] <> poz[0]:
                    continue
                
                rsglobal.ZapiszDoLogow('Poz '+str(poz),5)
                rsglobal.ZapiszDoLogow('Robimy, bo jest rozjazd ',5)
            
                # pobranie odpowiednika tego rozrachunku w nowym okresie
                SQL="SELECT seria,saldo_wn,saldo_ma FROM rs_rozrachunki "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
                SQL+=" AND konto='"+rsglobal.Dekoduj(poz[12])+"'"
                SQL+=" AND COALESCE(symbol_dok,'')='"+rsglobal.Dekoduj(poz[9])+"'"
                SQL+=" AND COALESCE(kontrahent_id,'')='"+rsglobal.Dekoduj(poz[11])+"'"
                SQL+=" AND kwota_wn="+str(poz[15])+" AND kwota_ma="+str(poz[16])
                SQL+=" AND data_rozlicz IS NULL;" 
                rsglobal.ZapiszDoLogow('SQL Test Nowy '+SQL,5)
                stat,DRozrNowy,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat <> 'OK':
                    stat= 'Bdy pobierania danych rozrachunku do rozliczenia :'+stat
                
            if stat == 'OK':
                if len(DRozrNowy) == 0:
                    LBledow.append('Rozrachunek w nowym okresie jest ju rozliczony lub nie ma rozrachunku o podobnych parametrach dla rozrachunku '+NrDowodu)
                    continue          
            
                if len(DRozrNowy) > 1:
                    LBledow.append('Rozrachunek w nowym okresie zosta wyznaczony niejednoznacznie dla rozrachunku '+NrDowodu)
                    continue          
            
                Kwota = poz[13]
                if Kwota == 0:
                    Kwota = poz[14]
                
                KwotaN = DRozrNowy[0][1]
                if KwotaN == 0:
                    KwotaN = DRozrNowy[0][2]
                
                # sprawdzenie czy kwoty dadz si rozliczy
                if (Kwota  > 0 and Kwota > KwotaN) or (Kwota < 0 and Kwota < KwotaN):
                    LBledow.append('Rozrachunek w nowym okresie ma za mae saldo by go rozliczy z rozrachunkiem '+NrDowodu)
                    continue       
            
                rsglobal.ZapiszDoLogow('Zaczynamy Import '+str((DRozrNowy[0][0],poz[1],Kwota,poz[8],poz[12])),5)
                
                # jeli tak rozliczamy rozrachunek poowicznie i zmieniamy nr serii w rozrachunku w nowym okresie   
                stat,dump=fs_rozrachunki_pom.RozliczJednostronnieRozrachunek(self,DRozrNowy[0][0],poz[1],Kwota,poz[8],poz[12])
                if stat <> 'OK':
                    stat = 'Bdy rozliczania jednostronnego rozrachunku :'+stat                    
                 
    # obsuga listy bdw 
    if stat =='OK':
        if len(LBledow)>0:
            dane = LBledow