#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_rozrachunki_pom.py
# Purpose:          funkcje pomocnicze rozrachunkw dziki czemu mona z nich korzysta w rnych funkcjach
# Author:           Micha Raburski
# Created:          2013/01/24
# RCS-ID:           $Id: fs_rozrachunki_pom.py $
# Copyright:        (c) 2013 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

import rsglobal

#-------------------------------------------------------------------------------
# FUNKCJA COFAJCA WYBRANE ROZRACHUNKI
#-------------------------------------------------------------------------------

def CofnijRozrachunki(self,ListaRozrachunkow,Konto):
    import rsglobal
    if len(ListaRozrachunkow)==0:
        return 'OK'
    #sprawdzamy czy wybrane konto ju ma BO
    stat,Wyn=PodajOkresyDlaRozrachunkow(self,self.okres_id)
    if stat <>'OK':
        return stat

    stat,CzyOK = SprawdzCzyBOWNastepnymOkresie(self,self.okres_id)
    if stat <>'OK':
        return stat
    
    if not CzyOK:
        return 'Dla nastpnego okresu ju utworzono BO i cofanie rozrachunkw w poprzednim okresie jest niemoliwe'
        
    LOkresow=Wyn[0]
    DataGr=Wyn[1]            
        
    # pobieramy numery serii przeciwnej bo te rozrachunki te bdziemy cofa.
    SQL="SELECT seria,seria_prz FROM rs_rozrachunki "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkresow+")"
    SQL+=" AND seria IN ("+str(ListaRozrachunkow)[1:-1]+") AND NOT data_rozlicz IS NULL FOR UPDATE NOWAIT;"
    stat,DaneR,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania przeciwnych numerw serii podczas cofania rozrachunkw :'+stat
    
    LRozr=[]
    for rozr in DaneR:
        if not rozr[0] in LRozr:
            LRozr.append(rozr[0])
        if not rozr[1] in LRozr:
            LRozr.append(rozr[1])
    rsglobal.ZapiszDoLogow('LRozr2 '+str(LRozr),1)
    if len(LRozr)==0:
        return 'OK'
    
    # sprawdzenie czy na ktrymkolwiek rozrachunku jest rnica kursowa. Jeli tak to przerywamy
    SQL="SELECT DISTINCT rk_dowod_id||'/'||rk_nazwa_id||'/'||rk_data||'/'||rk_numer FROM rs_rozrachunki "
    SQL+=" WHERE seria IN ("+str(LRozr)[1:-1]+") AND NOT rk_dowod_id IS NULL;"
    stat,DaneRK,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania informacji o rozliczonych rnicach kursowych na cofanych rozrachunkach :'+stat
    
    if len(DaneRK) > 0:
        stat="Istniej dowody rnic kursowych, ktre naley wycofa by cofn podane rozrachunki : "
        for poz in DaneRK:
            stat+=poz[0]+","
        return stat.strip(',')
        
    for seria in LRozr:
        rsglobal.ZapiszDoLogow('Seria '+str(seria),1)
        # pobieramy saldo i parametry definiujce dla cofanego rozrachunku.
        SQL="SELECT seria,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,kwota_wn,kwota_ma," # 0-9
        SQL+="rozliczone_wn,rozliczone_ma,rozliczone_wal_wn,rozliczone_wal_ma,saldo_wal_wn,saldo_wal_ma," # 10-15
        SQL+=" data_rozlicz,konto,waluta,kwota_wal_wn,kwota_wal_ma,saldo_wn,saldo_ma " # 16-20
        SQL+=" FROM rs_rozrachunki " 
        SQL+=" WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND seria ="+str(seria)+";"
        stat,DaneR,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return 'Bdy pobierania danych rozrachunkw podczas cofania rozrachunkw :'+stat
    
        if len(DaneR)==0:
            return "Bdy w danych - nie mona znale rozrachunku o numerze serii "+str(seria)
        rsglobal.ZapiszDoLogow('DaneR '+str(DaneR),1)
        roz=DaneR[0]
    
        # jeli kwoty walutowe obie 0 to rozliczamy tylko wzgldem kwot w PLN
        RoznicaKursowa = (roz[17]==0) and (roz[18]==0)
        rsglobal.ZapiszDoLogow('Roznica kursowa '+str(RoznicaKursowa),1)
        rsglobal.ZapiszDoLogow('ZACZYNAM '+str(roz),1)
        # zmieniamy saldo jego pniejszych rozrachunkw
        SQL="UPDATE rs_rozrachunki SET saldo_wn=saldo_wn+"+str(roz[10])+",saldo_ma=saldo_ma+"+str(roz[11])+","
        SQL+="saldo_wal_wn=saldo_wal_wn+"+str(roz[12])+",saldo_wal_ma=saldo_wal_ma+"+str(roz[13])
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+rsglobal.Dekoduj(roz[1])+"'"
        SQL+=" AND dowod_id='"+rsglobal.Dekoduj(roz[2])+"' AND nazwa_id='"+rsglobal.Dekoduj(roz[3])+"'"
        SQL+=" AND data='"+rsglobal.Dekoduj(roz[4])+"' AND numer="+str(roz[5])+" AND nr_poz="+str(roz[6])
        SQL+=" AND nr_ppoz="+str(roz[7])+" AND kwota_wn="+str(roz[8])+" AND kwota_ma="+str(roz[9])
        if RoznicaKursowa:
            SQL+=" AND (ABS(saldo_wn)<ABS("+str(roz[19])+") OR ABS(saldo_ma)< ABS("+str(roz[20])+"))"
        else:
            SQL+=" AND (ABS(saldo_wal_wn)<=ABS("+str(roz[14])+") OR ABS(saldo_wal_ma)<= ABS("+str(roz[15])+"))"
            SQL+=" AND NOT seria = "+str(seria)
        rsglobal.ZapiszDoLogow('SQL '+str(SQL),1)            
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            return 'Bdy zmiany salda rozrachunkw podczas cofania rozrachunkw :'+stat
        
        # sprawdzamy czy istnieje nierozliczona wersja rozrachunku
        SQL="SELECT * FROM rs_rozrachunki "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+rsglobal.Dekoduj(roz[1])+"'"
        SQL+=" AND dowod_id='"+rsglobal.Dekoduj(roz[2])+"' AND nazwa_id='"+rsglobal.Dekoduj(roz[3])+"'"
        SQL+=" AND data='"+rsglobal.Dekoduj(roz[4])+"' AND numer="+str(roz[5])+" AND nr_poz="+str(roz[6])
        SQL+=" AND nr_ppoz="+str(roz[7])+" AND kwota_wn="+str(roz[8])+" AND kwota_ma="+str(roz[9])
        SQL+=" AND data_rozlicz IS NULL"
        stat,DaneTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return 'Bdy analizy otwartoci rozrachunkw podczas cofania rozrachunkw :'+stat
        
        # jeli istnieje to usuwamy cofany rozrachunek
        if len(DaneTest)>0:
            rsglobal.ZapiszDoLogow('DELETE',1)
            SQL="DELETE FROM rs_rozrachunki WHERE seria="+str(roz[0])+";"
        else:
            rsglobal.ZapiszDoLogow('UPDATE',1)
            # a jeli nie istnieje to czycimy rozrachunek, ktry mia znikn i robimy z niego nierozliczon wersj
            SQL="UPDATE rs_rozrachunki SET data_rozlicz=NULL, rozliczone_wn=0, rozliczone_ma=0,"
            SQL+="rozliczone_wal_wn=0, rozliczone_wal_ma=0,seria_prz=0,roznica_kursowa=0,"
            SQL+="saldo_wn=rozliczone_wn, saldo_ma=rozliczone_ma,"
            SQL+="saldo_wal_wn=rozliczone_wal_wn, saldo_wal_ma=rozliczone_wal_ma WHERE seria="+str(roz[0])+";"
            
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            return 'Bdy zmiany stanu cofanego rozrachunku podczas cofania rozrachunkw :'+stat
        
        # zmiana stanw kont (tylko salda)
        #DaRoz=roz[16][0:8]+'-01'
        DaRoz=roz[16]
        SQL="SELECT rsf_zapisz_stan_konta_tylko_salda('"+self.firma_id+"',"
        SQL+="'"+rsglobal.Dekoduj(DaRoz)+"','"+rsglobal.Dekoduj(roz[17])+"','W',"
        SQL+=str(roz[10])+",'"+rsglobal.Dekoduj(roz[18])+"',"+str(roz[12])+");"
        stat,WynSQL,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return 'Bdy zmiany sald podczas cofania rozrachunkw :'+stat
        elif WynSQL <> [['OK']]:
            return 'Bdy zmiany sald podczas cofania rozrachunkw :'+WynSQL[0][0]
        
        SQL="SELECT rsf_zapisz_stan_konta_tylko_salda('"+self.firma_id+"',"
        SQL+="'"+rsglobal.Dekoduj(DaRoz)+"','"+rsglobal.Dekoduj(roz[17])+"','M',"
        SQL+=str(roz[11])+",'"+rsglobal.Dekoduj(roz[18])+"',"+str(roz[13])+");"
        stat,WynSQL,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return 'Bdy zmiany sald podczas cofania rozrachunkw :'+stat
        elif WynSQL <> [['OK']]:
            return 'Bdy zmiany sald podczas cofania rozrachunkw :'+WynSQL[0][0]
        
    return 'OK'

#-------------------------------------------------------------------------------
#--- FUNKCJA SPRAWDZAJCA CZY W PODANYM OKRESIE ISTNIEJE BO
#-------------------------------------------------------------------------------

def PodajOkresyDlaRozrachunkowDlaDaty(PolSQL,Firma,Data):
    # t funkcj mona wykorzystywa w harmonogramie i innych funkcjach
    # parametry
    #
    # PolSQL - zmienna rodowiskowa zawierajca poczenie z serwerem
    # Data - data, dla ktrej wybieramy okres pocztkowy, dla ktrego sprawdzane jest czy wywietla wczeniejszy okres
    #
    # zwraca stat,Filtr okresw
    
    SQL="SELECT rsf_podaj_okres_dla_daty('"+Firma+"','"+Data+"');"
    stat,DOkr,dump,dump=PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania informacji o okresie pocztkowym :'+stat,''
    if len(DOkr) == 0:
        return 'Podano dat, dla ktrej nie ma okresu obrachunkowego',''
    
    Okres = rsglobal.Dekoduj(DOkr[0][0])
    
    # pobranie informacji czy dla danego okresu jest BO
    SQL="SELECT konto FROM rs_stany_kont WHERE firma_id='"+Firma+"'"
    SQL+=" AND okres_id='"+Okres+"' AND miesiac='00' LIMIT 1;"
    stat,DStanow,dump,dump=PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania stanw kont do analizy :'+stat,''
    
    # jest normalnie, nie pobieramy danych z poprzedniego okresu
    if len(DStanow)>0:
        return 'OK',"'"+Okres+"'"
    
    # pobranie okresu poprzedniego w stosunku do naszego okresu
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+Firma+"'"
    SQL+=" AND data_do < (SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+Firma+"'"
    SQL+=" AND okres_id='"+Okres+"') ORDER BY data_do DESC LIMIT 1;"
    stat,DOkres,dump,dump=PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania danych okresw do analizy :'+stat,''
    
    if len(DOkres) == 0:
        # jest normalnie, nie pobieramy danych z poprzedniego okresu
        return 'OK',"'"+Okres+"'"
    
    # podajemy, ktry okres bdzie dodatkowo uwzgldniany i z jak dat ma by wywietlana informacja o rozliczeniu
    
    return 'OK',"'"+rsglobal.Dekoduj(DOkres[0][0])+"','"+Okres+"'"
    
#-------------------------------------------------------------------------------
        
def PodajOkresyDlaRozrachunkow(self,Okres):
    # t funkcj mona wykorzystywa w innych funkcjach, nie nadaje si do harmonogramu, bo harmonogram nie ma self
    # parametry
    #
    # self - zmienna rodowiskowa
    # Okres - okres, dla ktrego sprawdzane jest czy wywietla wczeniejszy okres
    #
    # zwraca stat,[Filtr okresw, data graniczna widocznoci rozliczenia]
    
    # pobranie informacji o aktualnym okresie
    Okres = rsglobal.Dekoduj(Okres)
    
    SQL="SELECT data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+Okres+"'"
    stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania informacji o okresie :'+stat,[]
    
    if len(DOkr) == 0:
        return 'Podano nieistniejcy okres obrachunkowy',[]
    
    DataGr=rsglobal.Dekoduj(DOkr[0][0])
    
    # pobranie informacji czy dla danego okresu jest BO
    SQL="SELECT konto FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+Okres+"' AND miesiac='00' LIMIT 1;"
    stat,DStanow,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania stanw kont do analizy :'+stat,[]
    
    # jest normalnie, nie pobieramy danych z poprzedniego okresu
    if len(DStanow)>0:
        return 'OK',["'"+Okres+"'",DataGr]
    
    # pobranie okresu poprzedniego w stosunku do naszego okresu
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND data_do < (SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+Okres+"') ORDER BY data_do DESC LIMIT 1;"
    stat,DOkres,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania danych okresw do analizy :'+stat,[]
    
    if len(DOkres) == 0:
        # jest normalnie, nie pobieramy danych z poprzedniego okresu
        return 'OK',["'"+Okres+"'",DataGr]
    
    # podajemy, ktry okres bdzie dodatkowo uwzgldniany i z jak dat ma by wywietlana informacja o rozliczeniu
    
    return 'OK',["'"+rsglobal.Dekoduj(DOkres[0][0])+"','"+Okres+"'",DataGr]

#-------------------------------------------------------------------------------
#--- FUNKCJA PODAJCA POPRZEDNI OKRES
#-------------------------------------------------------------------------------

def PodajPoprzedniOkres(self,Okres):
    # pobranie okresu wczeniejszego, ktrego moe dotyczy pobranie danych
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND data_do < (SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+Okres+"') ORDER BY data_do DESC LIMIT 1;"
    stat,DOkres,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania danych okresw do analizy :'+stat,''
    
    if stat == 'OK':
        if len (DOkres)>0:
            return 'OK',DOkres[0][0]
            
    return 'OK',''

#-------------------------------------------------------------------------------
#--- FUNKCJA PODAJCA OKRES I JEGO POPRZEDNIKA 
#-------------------------------------------------------------------------------

def PodajOkresyZWczesniejszym(self,Okres):
    # pobranie okresu wczeniejszego, ktrego moe dotyczy pobranie danych
    LOkr="'"+Okres+"'"
        
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND data_do < (SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+Okres+"') ORDER BY data_do DESC LIMIT 1;"
    stat,DOkres,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania danych okresw do analizy :'+stat,''
    
    if stat == 'OK':
        if len (DOkres)>0:
            LOkr+=",'"+rsglobal.Dekoduj(DOkres[0][0])+"'"
            
    return 'OK',LOkr

#-------------------------------------------------------------------------------
#--- FUNKCJA ROZLICZAJCA ROZRACHUNEK JEDNOSTRONNIE
#-------------------------------------------------------------------------------

def RozliczJednostronnieRozrachunek(self,Seria,SeriaPrz,Kwota,Data,Konto):
    #pobranie danych o rozrachunku
    SQL="SELECT dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id," # (0-11)
    SQL+=" konto,kwota_wn,kwota_ma,saldo_wn,saldo_ma,rozliczone_wn,rozliczone_ma,tresc,waluta,kurs,"                         # (12-21)
    SQL+=" kwota_wal_wn,kwota_wal_ma,saldo_wal_wn,saldo_wal_ma,rozliczone_wal_wn,rozliczone_wal_ma,data_rozlicz,seria_prz,"   # (22-29)
    SQL+=" kwota_bo_wn,kwota_bo_ma,kwota_bo_wal_wn,kwota_bo_wal_ma,firma_id,okres_id,"   # (30-35)
    SQL+=" COALESCE(f_typ,''),f_wyznacznik_id,f_data,f_numer,platnosc_id,COALESCE(data_ksieg_kosztow::TEXT,''),"   # (36-41)
    SQL+=" COALESCE(pdk_okres_id,''),pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz"   # (42-48)
    SQL+=" FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"' AND seria="+str(Seria)+" FOR UPDATE NOWAIT"
    
    # Operacja 1
    stat,Dane1,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return "Bd pobierania informacji o rozrachunku :"+stat,0

    Okres1 = Dane1[0][35]
    SQL="SELECT data_od<='"+Data+"' AND data_do>='"+Data+"' FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres1+"'"
    stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)        
    if stat <> 'OK':
        return "Bd pobierania danych okresw :"+stat,0
        
    if not DOkr[0][0]:
        return 'Data rozliczenia nie pasuje do okresu rozliczanego rozrachunku',0
                        
    #pobranie waluty i kursu    
    Waluta1=rsglobal.Dekoduj(Dane1[0][20])
    Kurs1=Dane1[0][21]

    #sprawdzenie kwot (czy po dobrych stronach)
    SalWn1=Dane1[0][15]
    SalMa1=Dane1[0][16]
    if SalWn1 == 0:
        Saldo=SalMa1
        Strona='ma'
    else:
        Saldo=SalWn1
        Strona='wn'
        
    #----------------------------------------------------
    #WACIWE ROZLICZENIE
    #----------------------------------------------------
    
    Upd1="UPDATE rs_rozrachunki SET rozliczone_"+Strona+"="+str(Kwota)+",rozliczone_wal_"+Strona+"="+str(Kwota/Kurs1)+","
    Upd1+="data_rozlicz='"+Data+"',seria_prz="+str(SeriaPrz)
    Upd1+=" WHERE seria="+str(Seria)+";"
    
    # zapis nowego numeru przeciwnego do nowej serii
    Upd1+="UPDATE rs_rozrachunki SET seria_prz="+str(Seria)
    Upd1+=" WHERE seria="+str(SeriaPrz)+";"

    stat,dump,dump,dump=self.PolSQL.Execute(Upd1,1)
    if stat <> 'OK':
        return 'Bdy rozliczania jednostronnego rozrachunku :'+stat,0
    
    # rozliczenie jest czciowe i tworzymy podrozrachunek
    SeriaNowa=0
    if Kwota <> Saldo:
        if Dane1[0][7]=='None':
            DataWyst='NULL' 
        else:
            DataWyst="'"+rsglobal.Dekoduj(Dane1[0][7])+"'"
        if Dane1[0][8]=='None':
            DataWpl='NULL' 
        else:
            DataWpl="'"+rsglobal.Dekoduj(Dane1[0][8])+"'"
        if Dane1[0][9]=='None':
            TerminPl='NULL' 
        else:
            TerminPl="'"+rsglobal.Dekoduj(Dane1[0][9])+"'"
        if Dane1[0][10]=='None':
            DataZapl='NULL' 
        else:
            DataZapl="'"+rsglobal.Dekoduj(Dane1[0][10])+"'"
        if Dane1[0][11]=='None':
            Kontr='NULL' 
        else:
            Kontr="'"+rsglobal.Dekoduj(Dane1[0][11])+"'"
        if Dane1[0][6]=='None':
            SymbDok='NULL' 
        else:
            SymbDok="'"+rsglobal.Dekoduj(Dane1[0][6])+"'"    
        if Dane1[0][0]<>'BO':
            KwotaBOWn='NULL' 
        else:
            KwotaBOWn=str(Dane1[0][30])
        if Dane1[0][0]<>'BO':
            KwotaBOMa='NULL' 
        else:
            KwotaBOMa=str(Dane1[0][31])
        if Dane1[0][0]<>'BO':
            KwotaBOWalWn='NULL' 
        else:
            KwotaBOWalWn=str(Dane1[0][32])
        if Dane1[0][0]<>'BO':
            KwotaBOWalMa='NULL' 
        else:
            KwotaBOWalMa=str(Dane1[0][33])
            
        if Dane1[0][36]=='':
            FTyp='NULL' 
            FWyzn='NULL' 
            FData='NULL' 
            FNr='NULL' 
        else:
            FTyp="'"+rsglobal.Dekoduj(Dane1[0][36])+"'" 
            FWyzn="'"+rsglobal.Dekoduj(Dane1[0][37])+"'" 
            FData="'"+rsglobal.Dekoduj(Dane1[0][38])+"'"  
            FNr=str(Dane1[0][39])
        PlatnoscId=str(Dane1[0][40])
        if PlatnoscId in ('None',None,'','0'):
            PlatnoscId='NULL' 
            
        if Dane1[0][41]=='':
            DataPrzychodu='NULL' 
        else:
            DataPrzychodu="'"+rsglobal.Dekoduj(Dane1[0][41])+"'"
        
        if Dane1[0][42]=='':
            PDKOkresId='NULL'
            PDKDowodId='NULL'
            PDKNazwaId='NULL'
            PDKData='NULL'
            PDKNumer='0'
            PDKNrPoz='0'
            PDKNrPPoz='0'
        else:
            PDKOkresId="'"+rsglobal.Dekoduj(Dane1[0][42])+"'" 
            PDKDowodId="'"+rsglobal.Dekoduj(Dane1[0][43])+"'" 
            PDKNazwaId="'"+rsglobal.Dekoduj(Dane1[0][44])+"'" 
            PDKData="'"+rsglobal.Dekoduj(Dane1[0][45])+"'" 
            PDKNumer=str(Dane1[0][46])
            PDKNrPoz=str(Dane1[0][47])
            PDKNrPPoz=str(Dane1[0][48])
            
        Ins1="INSERT INTO rs_rozrachunki (firma_id,okres_id,dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,"
        Ins1+="symbol_dok,data_wyst,data_wplywu,termin_plat,data_zapl,kontrahent_id,konto,"
        Ins1+="kwota_wn,kwota_ma,saldo_wn,saldo_ma,rozliczone_wn,rozliczone_ma,tresc,waluta,kurs,"
        Ins1+="kwota_wal_wn,kwota_wal_ma,saldo_wal_wn,saldo_wal_ma,rozliczone_wal_wn,rozliczone_wal_ma,data_rozlicz,seria_prz,"
        Ins1+="kwota_bo_wn,kwota_bo_ma,kwota_bo_wal_wn,kwota_bo_wal_ma,"
        Ins1+="f_typ,f_wyznacznik_id,f_data,f_numer,platnosc_id,data_ksieg_kosztow,"
        Ins1+="pdk_okres_id,pdk_dowod_id,pdk_nazwa_id,pdk_data,pdk_numer,pdk_nr_poz,pdk_nr_ppoz)"
        Ins1+=" VALUES ('"+self.firma_id+"','"+Okres1+"','"+rsglobal.Dekoduj(Dane1[0][0])+"','"+rsglobal.Dekoduj(Dane1[0][1])+"','"+rsglobal.Dekoduj(Dane1[0][2])+"',"+str(Dane1[0][3])+","+str(Dane1[0][4])+","+str(Dane1[0][5])+","
        Ins1+=SymbDok+","+DataWyst+","+DataWpl+","+TerminPl+","+DataZapl+","+Kontr+",'"+Konto+"',"
        if Strona == 'wn':    #strona wn
            Ins1+=str(Dane1[0][13])+",0,"+str(Dane1[0][15]-Kwota)+",0,0,0,'"+rsglobal.Dekoduj(Dane1[0][19]).replace("'","\\'")+"','"+Waluta1+"',"+str(Kurs1)+","
            Ins1+=str(Dane1[0][22])+",0,"+str((Dane1[0][15]-Kwota)/Kurs1)+",0,0,0,NULL,0,"
        else:                 #strona ma
            Ins1+="0,"+str(Dane1[0][14])+",0,"+str(Dane1[0][16]-Kwota)+",0,0,'"+rsglobal.Dekoduj(Dane1[0][19]).replace("'","\\'")+"','"+Waluta1+"',"+str(Kurs1)+","
            Ins1+="0,"+str(Dane1[0][23])+",0,"+str((Dane1[0][16]-Kwota)/Kurs1)+",0,0,NULL,0,"
        Ins1+=KwotaBOWn+","+KwotaBOMa+","+KwotaBOWalWn+","+KwotaBOWalMa
        Ins1+=","+FTyp+","+FWyzn+","+FData+","+FNr+","+PlatnoscId+","+DataPrzychodu
        Ins1+=","+PDKOkresId+","+PDKDowodId+","+PDKNazwaId+","+PDKData+","+PDKNumer+","+PDKNrPoz+","+PDKNrPPoz+");"
        stat,dump,dump,dump=self.PolSQL.Execute(Ins1,1)
        if stat <> 'OK':
            return 'Bdy tworzenia podrozrachunku podczas rozliczania jednostronnego rozrachunku :'+stat,0       
   
        #Select do pobrania nowego numeru serii, z ktrym bdzie dalsze rozliczanie tej pozycji.
        Sel1="SELECT seria FROM rs_rozrachunki WHERE firma_id='"+self.firma_id+"'"
        Sel1+=" AND okres_id='"+Okres1+"' AND dowod_id='"+rsglobal.Dekoduj(Dane1[0][0])+"'"
        Sel1+=" AND nazwa_id='"+rsglobal.Dekoduj(Dane1[0][1])+"' AND data='"+rsglobal.Dekoduj(Dane1[0][2])+"'"
        Sel1+=" AND numer="+str(Dane1[0][3])+" AND nr_poz="+str(Dane1[0][4])+" AND nr_ppoz="+str(Dane1[0][5])
        Sel1+=" AND rozliczone_wn=0 AND rozliczone_ma=0"
        if Strona == 'wn':
            Sel1+=" AND kwota_wn="+str(Dane1[0][13])+";"
        else:
            Sel1+=" AND kwota_ma="+str(Dane1[0][14])+";"

        stat,DSeria,dump,dump=self.PolSQL.Execute(Sel1,3)
        if stat <> 'OK':
            return 'Bdy pobierania numeru serii nowego rozrachunku :'+stat,0       

        SeriaNowa=DSeria[0][0]
    
    return stat,SeriaNowa


#-------------------------------------------------------------------------------
#-- FUNKCJA PODAJCA STAN KONTA Z PLANU KONT Z UWZGLDNIENIEM UWOLNIENIA OKRESW W ROZRACHUNKW
#-------------------------------------------------------------------------------

def PodajAktualnyStanKonta(self,Okres,Konto):
    SumaWn=0
    SumaMa=0
    
    # pobranie okresu poprzedniego
    stat,LOkr=PodajOkresyDlaRozrachunkow(self,Okres)
    if stat <> 'OK':
        return 'Bdy pobierania okresu : '+stat,0,0
    LOkr=LOkr[0]
    
    # pobranie dat max dla okresw
    SQL="SELECT okres_id,data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkr+")"
    stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bdy pobierania danych okresw :'+stat,0,0       
    
    if LOkr.find(',') > 0:
        for poz in DOkr:
            if poz[0] == Okres:
                DataOkr=poz[1]
            else:
                DataOkrP=poz[1]
    else:
        DataOkr=DOkr[0][1]
        DataOkrP=''
    
    # ZAPYTANIE PRZYSZOCIOWE
    SQL="SELECT SUM(saldo_wn),SUM(saldo_ma)"
    SQL+=" FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id IN ("+LOkr+")"
    SQL+=" AND (konto='"+Konto+"' OR konto LIKE '"+Konto+"-%')"
    if LOkr.find(',') > 0:
        SQL+=" AND CASE WHEN okres_id='"+Okres+"' THEN rok||miesiac='"+DataOkr[:4]+DataOkr[5:7]+"'"
        SQL+=" ELSE rok||miesiac='"+DataOkrP[:4]+DataOkrP[5:7]+"' END;"
    else:
        SQL+=" AND rok='"+DataOkr[:4]+"' AND miesiac='"+DataOkr[5:7]+"';"
    stat,DKont,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bdy pobierania danych kont :'+stat,0,0       

    # analizujemy dane w ptli
    stat,DSum,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return 'Bdy pobierania sum ze stanw kont :'+stat,0,0       

    return 'OK',DSum[0][0],DSum[0][1]

#-------------------------------------------------------------------------------
#-- SPRAWDZANIE CZY DLA PODANEGO OKRESU ISTNIEJE BO W NASTPNYM OKRESIE
#-------------------------------------------------------------------------------

def SprawdzCzyBOWNastepnymOkresie(self,Okres):
    # pobranie okresu pniejszego ze sprawdzeniem czy istnieje BO
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND data_od > (SELECT data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND okres_id='"+Okres+"') ORDER BY data_od DESC LIMIT 1;"
    rsglobal.ZapiszDoLogow('SQLOkr '+SQL,1)
    stat,DOkres,dump,dump=self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('DOkres '+str(DOkres),1)
    if stat<>'OK':
        return 'Bdy pobierania danych okresw do analizy :'+stat,False
        
    if len(DOkres) ==0:
        return 'OK',True
    
    SQL="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+DOkres[0][0]+"'"
    SQL+=" AND dowod_id='BO';"
    rsglobal.ZapiszDoLogow('SQLBO '+SQL,1)
    stat,DBO,dump,dump=self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('DBO '+str(DBO),1)
    if stat<>'OK':
        return 'Bdy pobierania danych dowodu BO do analizy :'+stat,False
        
    if len(DBO) ==0:
        return 'OK',True
    
    return 'OK', DBO[0][0] <> 'Z'
    
    