# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_select_for_update.py
# Purpose:     obsuga blokad danych w anakondzie
#
# Author:      Micha Raburski
#
# Created:     2011/09/08
# RCS-ID:      $Id: fs_select_for_update.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-09-16 Mariusz Rajfura - blokady dla korekt (4928)
# 2011-09-16 Mariusz Rajfura - blokady dla dowodow dostaw (4929)
# 2011-09-16 Mariusz Rajfura - blokady dla zamowien odbiorcow (4930)
# 2011-09-19 Mariusz Rajfura - blokady dla paragonow fiskalnych (4926)
# 2011-09-19 Mariusz Rajfura - blokady dla dowodow ksiegowych (4925)
# 2011-09-21 Mariusz Rajfura - blokady dla zamowien dostawcow (4931)
# 2011-10-03 Mariusz Rajfura - blokady dla stanu G: dok.mag,fakt,kor (5075)
# 2012-09-20 Mariusz Rajfura (6087) oddzial_id w kluczu dowodow dostaw
# 2022-05-10 Wojciech Skowron (13004) nowy stan 'M' dla dk
# 2022-05-25 Aleksander Bargie (13014) Zagadnienia - dekret merytoryczny


# DOSTPNE TYPY I KLUCZE
# DokMag    -  (magazyn_id,dokument_id, data,numer)
# Fakt      -  (wyznacznik_id,data,numer)
# Kor       -  (wyznacznik_id,data,numer)
# DowDost   -  (trasa,data,tryb_dostawy,numer)
# ZamOdb    -  (wyznacznik_id,data,numer)
# ParagFisk -  (oddzial_id,kasa_id,data,numer)
# DowKsieg  -  (dowod_id,nazwa_id,data,numer)
# ZamDost   -  (wyznacznik_id,data,numer)
# RapWyc    -  (kasa_bank_id,data,numer)
# Dost      -  (data,numer)

import rsglobal

#-------------------------------------------------------------------------------

def ZalozBlokade(self,Typ,Klucz):
    SQL=''
    # przed woeniem nowej zawsze zdejmujemy star blokad
    if Typ in self.PolSQL.SelectForUpdate:
        del self.PolSQL.SelectForUpdate[Typ]

    self.PolSQL.STypyBlokad = {'DokMag':'dokument magazynowy', 'Fakt':'faktura', 'Kor':'korekta', 'DowDost': 'dowd dostawy',
                        'ZamOdb':'zamwienie od odbiorcy', 'ParagFisk':'paragon fiskalny', 'DowKsieg':'dowod ksigowy',
                        'ZamDost':'zamwienie do dostawcy', 'RapWyc':'raport wycigu', 'Dostawy':'dostawa'}
    if Typ=='DokMag':
        SQLTest="SELECT stan FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND magazyn_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND dokument_id='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[2])+"'"
        SQLTest+=" AND numer='"+str(Klucz[3])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND magazyn_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND dokument_id='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[2])+"'"
                SQL+=" AND numer="+str(Klucz[3])+" FOR UPDATE NOWAIT;"

    elif Typ=='Fakt':
        SQLTest="SELECT stan FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND numer='"+str(Klucz[2])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND numer="+str(Klucz[2])+" FOR UPDATE NOWAIT;"

    elif Typ=='Kor':
        SQLTest="SELECT stan FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND numer='"+str(Klucz[2])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND numer="+str(Klucz[2])+" FOR UPDATE NOWAIT;"

    elif Typ=='DowDost':
        SQLTest="SELECT stan FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND oddzial_id='"+rsglobal.Dekoduj(Klucz[4])+"'"
        SQLTest+=" AND trasa='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND tryb_dostawy='"+rsglobal.Dekoduj(Klucz[2])+"'"
        SQLTest+=" AND numer='"+str(Klucz[3])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('0','1','2'):
                SQL="SELECT * FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND oddzial_id='"+rsglobal.Dekoduj(Klucz[4])+"'"
                SQL+=" AND trasa='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND tryb_dostawy='"+rsglobal.Dekoduj(Klucz[2])+"'"
                SQL+=" AND numer="+str(Klucz[3])+" FOR UPDATE NOWAIT;"

    elif Typ=='ZamOdb':
        SQLTest="SELECT stan FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND numer='"+str(Klucz[2])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0]=='W':
                SQL="SELECT * FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND numer="+str(Klucz[2])+" FOR UPDATE NOWAIT;"

    elif Typ=='ParagFisk':
        SQLTest="SELECT stan FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND oddzial_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND kasa_id='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[2])+"'"
        SQLTest+=" AND numer='"+str(Klucz[3])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0]=='W':
                SQL="SELECT * FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND oddzial_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND kasa_id='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[2])+"'"
                SQL+=" AND numer="+str(Klucz[3])+" FOR UPDATE NOWAIT;"

    elif Typ=='DowKsieg':
        okres_id = rsglobal.Dekoduj(Klucz[4]) if len(Klucz) == 5 else self.okres_id  #AB 25.05.22r
        SQLTest="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND okres_id='"+rsglobal.Dekoduj(okres_id)+"'"
        SQLTest+=" AND dowod_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND nazwa_id='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[2])+"'"
        SQLTest+=" AND numer='"+str(Klucz[3])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            #WS 2022-05-10
            if dane[0][0] in ('M','W','G'):
            # if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND okres_id='"+rsglobal.Dekoduj(self.okres_id)+"'"
                SQL+=" AND dowod_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND nazwa_id='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[2])+"'"
                SQL+=" AND numer="+str(Klucz[3])+" FOR UPDATE NOWAIT;"

    elif Typ=='ZamDost':
        SQLTest="SELECT stan FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND numer='"+str(Klucz[2])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND numer="+str(Klucz[2])+" FOR UPDATE NOWAIT;"

    elif Typ=='RapWyc':
        SQLTest="SELECT stan FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQLTest+=" AND kasa_bank_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
        SQLTest+=" AND numer='"+str(Klucz[2])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                SQL+=" AND kasa_bank_id='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[1])+"'"
                SQL+=" AND numer="+str(Klucz[2])+" FOR UPDATE NOWAIT;"

    elif Typ=='Dostawy':
        SQLTest="SELECT stan FROM rs_dostawy WHERE firma_id='"+self.firma_id+"'"
        SQLTest+=" AND data='"+rsglobal.Dekoduj(Klucz[0])+"'"
        SQLTest+=" AND numer='"+str(Klucz[1])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQLTest,3)
        if stat=='OK':
            if dane[0][0] in ('W','G'):
                SQL="SELECT * FROM rs_dostawy WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(Klucz[0])+"'"
                SQL+=" AND numer="+str(Klucz[1])+" FOR UPDATE NOWAIT;"

    if SQL<>'':
        self.PolSQL.SelectForUpdate[Typ]=SQL

#-------------------------------------------------------------------------------

def ZdejmijBlokade(self,Typ):
    if Typ in self.PolSQL.SelectForUpdate:
        del self.PolSQL.SelectForUpdate[Typ]
        
#-------------------------------------------------------------------------------

def WykonajBlokade(self):
    return self.PolSQL.WykonajSelectForUpdate(self)


#-------------------------------------------------------------------------------
#--- GWNA CZʦ OKNA
#-------------------------------------------------------------------------------

Typ = klucze[0]
Klucz = klucze[1]
Fun = klucze[-1]

stat='OK'
if Fun==1:
    ZalozBlokade(self,Typ,Klucz)
elif Fun==2:
    ZdejmijBlokade(self,Typ)
elif Fun==3:
    stat=WykonajBlokade(self)