# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_serwis_zgloszenia_dane.py
# Purpose:     wczytuje/edytuje dane zgloszenia do serwisu 
# Author:      Dariusz Boduch
# Created:     2008/08/02
# RCS-ID:      $Id: fs_serwis_zgloszenia_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# drobne modyfikacje - Pawe Wjcikowski <koniec 05.07.2009r>
#--- klucze to [Artykul,NrSerii,Kontrahent,KodUzytkownika,NrZgloszenia]

NrZgloszenia=rsglobal.Dekoduj(klucze[0])
Artykul=rsglobal.Dekoduj(klucze[1])
NrSerii=rsglobal.Dekoduj(klucze[2])
Kontrahent=rsglobal.Dekoduj(klucze[3])

NrZgloszeniaK=NrZgloszenia
ArtykulK=Artykul
NrSeriiK=NrSerii
KontrahentK=Kontrahent

Fun=klucze[-1]
stat='OK'
dane=[]


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

UprDodawanie=(((self.oddzial_id,'029213') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdytowanie=(((self.oddzial_id,'029212') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (1,2 - insert; 3,4 - update)
#-------------------------------------------------------------------------------

dane = []
PolaDod=[]
WartDod=[]

#sprawdzenie klucza
if Artykul.strip() in ('',None,'None'):
    stat='BR ART'
    dane.append(stat)
if NrSerii.strip() in ('','None',None):
    stat='BR NRS'
    dane.append(stat)
if Kontrahent.strip() in ('','None',None):
    stat='BR KONTR'
    dane.append(stat)

if Fun in [1,2,3,4] and stat=='OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == 'artykul_id':
            if wart.strip() =='':
                stat = "BR ART"
                dane.append(stat)
            else:
                Select="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                Select+="AND artykul_id = '"+wart+"';"
                stat,danez,dump,dupm=self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if len(danez)==0:
                        stat='BL ART'
                        dane.append(stat)
                    else:
                        ArtykulK=wart
                                                
        if pole == 'nr_serii' and stat=='OK':
            if wart.strip() =='':
                stat = "BR NRS"
                dane.append(stat)
            else:
                NrSeriiK=wart
        
        if pole == 'kontrahent_id' and stat=='OK':
            if wart.strip() =='':
                stat = "BR KONTR"
                dane.append(stat)
            else:
                Select="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                Select+="AND kontrahent_id = '"+wart+"';"
                stat,danek,dump,dupm=self.PolSQL.Execute(Select,3)
                if stat<>'OK':
                    stat='BLEDY KONTR'
                    dane.append(stat) 
                if len(danek)==0 and stat=='OK':
                    stat='BL KONTR'
                    dane.append(stat)
                else:
                    KontrahentK=wart
                    
        if pole == 'osoba_id'and stat=='OK':
            if wart.strip() <> '':
                Select="SELECT * FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' AND "
                Select+="kontrahent_id='"+KontrahentK+"' AND osoba_id='"+wart+"';"
                stat,daneKO,dump,dump=self.PolSQL.Execute(Select,3)
                if stat <>'OK':
                    stat='BLEDY OSOBA'
                    dane.append(stat)
                if len(daneKO)==0 and stat=='OK':
                    stat='BL OS'
                    dane.append(stat)

        if pole == 'zgloszenie_rodzaj'and stat=='OK':
            if wart.strip()<>'':
                Select="SELECT * FROM rs_zgloszenia_rodzaje WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                stat,daneZR,dump,dump=self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if len(daneZR)==0:
                        stat='BL ZGL RODZ'
                        dane.append(stat)

        if pole == 'zgloszenie_status' and stat=='OK':
            if wart.strip()<>'':
                Select="SELECT * FROM rs_zgloszenia_statusy WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                stat,daneZS,dump,dump=self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if len(daneZS)==0:
                        stat='BL ZGL STAT'
                        dane.append(stat)
                                   
        if pole == 'zgloszenie_data'and stat=='OK':
            if wart<>'    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    stat='BL DATA ZGL'
                    dane.append(data)
                        
        if pole == 'zgloszenie_termin'and stat=='OK':
            if wart<>'    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    stat='BL DATA TERM'
                    dane.append(data)
                         
                                    
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    if not UprDodawanie:
        stat='UPR INS'
        dane.append(stat)    
    if stat=="OK":   
        #Sprawdzenie klucza czy podany artykul jest w bazie
        Select="SELECT * FROM rs_serwis_urzadzenia WHERE firma_id='"+self.firma_id+"' AND "
        Select+="artykul_id='"+Artykul+"' AND  nr_serii='"+NrSerii+"' AND kontrahent_id='"+Kontrahent+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(dane)==0:
                stat='BL KL'
                dane.append(stat)
            else:
                ins = "INSERT INTO rs_serwis_zgloszenia"
                Pola="firma_id,artykul_id,nr_serii,kontrahent_id"
                Wartosci="'"+self.firma_id+"','"+Artykul+"','"+NrSerii+"','"+Kontrahent+"'"
                for i in range(len(pola)):
                    pole = pola[i]
                    wart = wartosci[i]               
                    if pole in []:
                        Pola= Pola+","+pole
                        Wartosci= Wartosci+",'"+wart+"'"
                    elif pole in ['zgloszenie_data','zgloszenie_termin','osoba_id','zgloszenie_rodzaj',
                                'zgloszenie_status','zgloszenie_opis_usterki','zgloszenie_stan_techniczny',
                                'zgloszenie_opis_rozwiazania']:
                        Pola= Pola+","+pole
                        if wart=='    -  -  ' or wart=='':
                            Wartosci= Wartosci+",NULL"
                        else:
                            Wartosci= Wartosci+",'"+wart+"'"
        
                ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"
                stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
                if stat=='OK':
                    Select="SELECT max(zgloszenie_id) from rs_serwis_zgloszenia WHERE firma_id='"+self.firma_id+"'"
                    Select+=" AND artykul_id='"+Artykul+"' AND nr_serii='"+NrSerii+"' AND kontrahent_id='"+Kontrahent+"';"
                    stat,dane,dump,dump = self.PolSQL.Execute(Select,3)
                    NrZgloszeniaIns=dane[0][0]              
        
        
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprEdytowanie:
        stat='UPR UPD'
        dane.append(stat)    
    if stat=="OK":        
        where = " WHERE firma_id='"+self.firma_id+"' AND zgloszenie_id = '"+str(NrZgloszenia)+"'"
        where+= " AND artykul_id='"+Artykul+"' AND nr_serii='"+NrSerii+"' AND kontrahent_id='"+Kontrahent+"'; "
   
        upd = "UPDATE rs_serwis_zgloszenia SET "
    
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['osoba_id','zgloszenie_rodzaj','zgloszenie_status','zgloszenie_opis_usterki',
                        'zgloszenie_stan_techniczny','zgloszenie_opis_rozwiazania','zgloszenie_data',
                        'zgloszenie_termin']:
                if wart=='    -  -  ' or wart == '':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+wart+"',"
        upd = upd[0:len(upd)-1]+where
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (5,3,1):
    # pobranie danych zgloszenia
    if NrZgloszenia==0:
        NrZgloszenia=NrZgloszeniaIns

    SELECT = "SELECT CAST (zgloszenie_id AS TEXT) as zgloszenie_nr ,* "
    FROM = " FROM rs_serwis_zgloszenia "
    WHERE = "WHERE firma_id = '"+self.firma_id+"' AND zgloszenie_id='"+str(NrZgloszenia)+"' " 
    WHERE+= "AND artykul_id='"+ArtykulK+"' AND nr_serii='"+NrSeriiK+"' AND kontrahent_id='"+KontrahentK+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT+FROM+WHERE,3)

    #pobranie danych do opisow

    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        #--- artykul
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+ArtykulK+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #---kontrahent
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentK+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')
        
        #---zglaszajacy

        if ((self.oddzial_id,'012030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT imie||' '||nazwisko FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"'"
            Select+=" AND kontrahent_id='"+KontrahentK+"' AND osoba_id='"+str(dane[0][6])+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select,3)     
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw osb - osoby. Poinformuj administratora.')
        
        #---rodzaj zgloszenia

        if ((self.oddzial_id,'011460') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT opis FROM rs_zgloszenia_rodzaje WHERE firma_id='"+self.firma_id+"' AND kod='"+str(dane[0][9])+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select,3)           
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika rodzajw zgosze. Poinformuj administratora.')
        
        #---status zgl

        if ((self.oddzial_id,'011460') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT opis FROM rs_zgloszenia_statusy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(dane[0][13])+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika statusw zgosze. Poinformuj administratora.')       
