#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_slowniki_pozycje_dane.py
# Purpose:		dodawanie/pobieranie/usuwanie pozycji slownikow
# Author:		Marcin Grzeda
# Created:		2007/04/20
# RCS-ID:		$Id: fs_slowniki_pozycje_dane.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------
# sprawdzenie przed usuwaniem/zmiana klucza wystepowania kodu na dowodach ksiegowych
# dla wybranych tabel, ktore moga byc kontami analitycznymi  mariusz rajfura mantis:675  2009/08/12
# 2014-11-28 - Marcin Natkaski - obsuga sownika rs_lokalizacje_rodzaje (8521)
# 2019-05-13 - Wojciech Skowron - RSSLowniki - refaktoryzacja - klucze w postaci sownika zamiast listy (11486)
# 2019-10-03 - Wojciech Skowron - Pola numeryczne w sownikach (10710)
# 2021-03-24 - Wojciech Skowron - Sprawdzenie, czy kod lub inny kod z tym samym opisem ju istnieje (12380)
# 2022-05-26 - Alekdander Bargie - Zablokowac w slownikach mozliwosc dodania w kodzie pustego tekstu (12996)

from funkcje import fs_sprawdz_analityke

if isinstance(klucze, dict):
    dane = []
    wyn2 = []
    stat = "OK"

    if not 'Funkcja' in klucze:
        stat = 'Brak podanej funkcji w kluczach'
        Fun = 999

    if stat == 'OK':
        Fun = klucze['Funkcja']

        SlPar = {'Tabela':[1,5,6,9], 'Etykiety':[1,5,6], 'Typy':[1]}
        Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
        if Lista != '':
            stat = 'Uwaga : wywoanie funkcji fs_slowniki_pozycje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

    if stat == 'OK':
        if Fun in [1,5,6,9]:
            Tabela = klucze['Tabela']
        if Fun in [1,5,6]:
            Etykiety = klucze['Etykiety']
        if Fun in [1,]:  #AB 26.05.22r
            kol  = klucze['Kolumny']
            Kolumny = {}
            for e, k in zip(Etykiety, kol):
                Kolumny[e] = k

        if Fun == 1:
            Typy = klucze['Typy']
else:
    Tabela = klucze[0]
    Etykiety=klucze[1]
    Typy=klucze[2]

    dane=[]
    stat='OK'
    wyn2=[]
    Fun=klucze[-1]

if stat == 'OK':
    sql ="SELECT slownik_id,menu_id,nazwa,typ,dlugosc,pola,funkcja"
    sql+=" FROM rs_slowniki WHERE tabela = '"+Tabela+"';"
    stat,opis,dump,dump = self.PolSQL.Execute(sql,3)
    #WS
    if stat != 'OK':
        stat = 'Bd pobrania danych o sownikach'

if stat == 'OK':
    UprPrz = opis[0][0]
    UprEdycja = opis[0][1]
    Typ = opis[0][3]
    Dlugosc = opis[0][4]
    Pola = opis[0][5]
    bufor = '00000'+str(int(UprEdycja)+1)
    bufor = bufor[len(bufor)-6:len(bufor)]
    UprDodawanie = bufor
    bufor = '00000'+str(int(UprEdycja)+2)
    bufor = bufor[len(bufor)-6:len(bufor)]
    UprUsuwanie = bufor
    bufor = '00000'+str(int(UprEdycja)+3)
    bufor = bufor[len(bufor)-6:len(bufor)]
    UprZmKl = bufor

#-------------------------------------------------------------------------------
#---Sprawdzenia dla sownika rs_lokalizacje_rodzaje
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [1,] and Tabela == 'rs_lokalizacje_rodzaje':
# if Fun in [1,] and Tabela =='rs_lokalizacje_rodzaje':
    stat = 'OK'
    if isinstance(klucze, dict):
        Update = klucze['Update']
        Insert = klucze['Insert']
    else:
        Update=klucze[-2]
        Insert=klucze[-3]
    dozwolone_znaki = ('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','R','S','T','U','W','X','Y','Z')
    if len(Update[0])>0:
        if len(Update[1][0][0])<>2 and Update[0][0][0]<>'opis':
            bledy=True
            stat = 'Kod sownika musi skada si z dwch wielkich liter bez polskich znakw'
            dane.append(stat)
        if ((Update[1][0][0][0] not in dozwolone_znaki) or (Update[1][0][0][1] not in dozwolone_znaki)) and Update[0][0][0]<>'opis':
            bledy=True
            stat = 'Kod "'+Update[1][0][0]+'" zawiera niedozwolone znaki. W kodzie moga byc uywane wycznie wielkie litery bez polskich znakw.' 
            dane.append(stat)
            
    # dodawanie pozycji
    if len(Insert[0])>0:
        for i in xrange(len(Insert[0])):            
            if len(Insert[0][i][0])<>2:
                bledy=True
                stat = 'Kod sownika musi skada si z dwch wielkich liter bez polskich znakw'
                dane.append(stat)
            if (Insert[0][i][0][0] not in dozwolone_znaki) or (Insert[0][i][0][1] not in dozwolone_znaki):
                bledy=True
                stat = 'Kod "'+Insert[0][i][0]+'" zawiera niedozwolone znaki. W kodzie moga byc uywane wycznie wielkie litery bez polskich znakw.' 
                dane.append(stat)
    

#-------------------------------------------------------------------------------
# pobranie struktury slownika (9)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 9:
# if Fun == 9:
    dane = opis
    
    #jesli slownik edytowalny, sprawdzamy wartosc domyslna w bazie
    # dla wybranych pol z wybranej tabeli slownika
    pola = []
    if dane[0][3] == 'Z':
        if Tabela == 'rs_wersje_cenowe':
           pola.append('po_przecinku')
    
    for i in xrange(len(pola)):
        sql ="SELECT column_default,data_type FROM information_schema.columns"
        sql+=" WHERE table_name='"+Tabela+"' AND column_name='"+pola[i]+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = "Bd odczytania wartoci domylnej dla pola '"+pola[i]+"'\n"+\
                   "z tabeli '"+Tabela+"'"
            break
        
        elif d[0][0] <> 'None':
            #jesli jest podana wartosc domyslna,
            # robimy konwersje do odpowiedniego typu
            
            #obsluga pozostalych typow pojawi sie w razie potrzeb
            if d[0][1].lower() in ('smallint','int','bigint'):
                wyn2.append([pola[i],int( d[0][0])])


#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if (self.operator_id == STANDARD_OPERATOR_ID):
    UprPrzegl=True
    UprDel=True
    UprUpd=True
    UprIns=True
    UprZmianaKlucza=True
else:    
    UprPrzegl=(self.oddzial_id,UprPrz) in self.uprawnienia
    UprUpd=(self.oddzial_id,UprEdycja) in self.uprawnienia
    UprIns=(self.oddzial_id,UprDodawanie) in self.uprawnienia
    UprDel=(self.oddzial_id,UprUsuwanie) in self.uprawnienia
    UprZmianaKlucza=(self.oddzial_id,UprZmKl) in self.uprawnienia


#-------------------------------------------------------------------------------
# Edycja slownika (1)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 1:
# if (Fun in [1]):
    if isinstance(klucze, dict):
        Update = klucze['Update']
        Insert = klucze['Insert']
        Delete = klucze['Delete']
    else:
        Update=klucze[-2]
        Insert=klucze[-3]
        Delete=klucze[-4]
    
    if stat=='OK':
        DlPola={}
        SELECT= "SELECT column_name,character_maximum_length"
        SELECT+= " FROM INFORMATION_SCHEMA.COLUMNS"
        SELECT+=" WHERE TABLE_NAME = '"+Tabela+"' AND character_maximum_length is not NULL "
        st,d_long,dump,dump=self.PolSQL.Execute(SELECT,3)
        if st=='OK':
            for kol in d_long:
                DlPola[kol[0]]=kol[1] 
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

        if len(Delete[0])>0:
            if not UprDel:
                stat='UPR DEL'
                dane.append(stat)
            
            if stat =='OK':
                if Tabela in ('rs_dzialy_firmy', 'rs_konta_kosztow', 'rs_numery_zlecen', 'rs_stawki_vat'):
                    bledy = False
                    for i in Delete[0]:
                        stat = fs_sprawdz_analityke.CzyMoznaUsunac(self, Tabela, str(i[0]), '')
                        if stat <> 'OK':
                            bledy = True
                            dane.append(stat)
                    if bledy:
                        stat = dane[-1]
                if Tabela =='rs_lokalizacje_rodzaje':
                    bledy=False
                    for i in Delete[0]:
                        SQL = "SELECT lokalizacja_id FROM rs_lokalizacje WHERE lokalizacja_id like '%"+i[0]+"%' LIMIT 1;"
                        stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                        #WS
                        if stat != "OK":
                            bledy=True
                            dane.append(stat)
                        else:
                            if len(d)>0:
                                bledy=True
                                stat='Rodzaj lokalizacji "'+i[0]+'" jest uywany i nie mona go usuwa'
                                dane.append(stat)
                    if bledy:
                        stat = dane[-1]
                            

#-------------------------------------------------------------------------------
#--- DELETE    
#-------------------------------------------------------------------------------
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM "+Tabela+" "
                if Typ not in ['I']:
                    WHERE="WHERE firma_id='"+self.firma_id+"' AND"
                else:
                    WHERE="WHERE "
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if Typy[Etykiety.index(pole)] in ['b','n']:   
                        WHERE+=" "+pole+"="+str(wart)+" AND"
                    else:
                        WHERE+=" "+pole+"='"+wart+"'"+" AND"

                    if Tabela == 'rs_hale_produkcyjne' and pole == 'hala_id' and wart == '00':
                        stat = 'Nie mona usun hali o kodzie 00'
                    
                sql+=DELETE+WHERE.rstrip('AND')+";"
                
                
            if sql<>'' and stat == 'OK': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- Sprawdzanie danych do Update
#-------------------------------------------------------------------------------

        if len(Update[0])>0:
            if UprUpd or UprZmianaKlucza:
                if Tabela in ('rs_dzialy_firmy', 'rs_konta_kosztow', 'rs_numery_zlecen', 'rs_stawki_vat'):
                    bledy = False
                    for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                        for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                            if Update[0][i][j] == 'kod':
                                stat = fs_sprawdz_analityke.CzyMoznaUsunac(self, Tabela, str(Update[2][i][j]), '')
                                if stat <> 'OK':
                                    bledy = True
                                    dane.append(stat)
                    if bledy:
                        stat = dane[-1]
                # Sprawdzamy czy typ lokalizacji nie jest uywany w lokalizacjach        
                if Tabela == 'rs_lokalizacje_rodzaje':
                    bledy = False
                    for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                        for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                            if Update[0][i][j] == 'kod':
                                SQL = "SELECT lokalizacja_id FROM rs_lokalizacje WHERE lokalizacja_id like '%"+str(Update[2][i][j])+"%' LIMIT 1;"
                                stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                #WS
                                if stat != "OK":
                                    bledy=True
                                    dane.append(stat)
                                else:
                                    if len(d) > 0:
                                        bledy = True
                                        stat='Rodzaj lokalizacji "'+str(Update[2][i][j])+'" jest uywany i nie mona go zmienia'
                                        dane.append(stat)
                                    
                    if bledy:
                        stat = dane[-1]
                    
                if stat == 'OK':
                    for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                        for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                            pole=Update[0][i][j]
                            wart=Update[1][i][j]
                            if pole in DlPola:
                                rsglobal.ZapiszDoLogow(pole,5)
                                if pole in DlPola and len(wart)>DlPola[pole]:
                                    stat='BL DL POLA$'+" "+Kolumny[pole]+" w wierszu : "+str(Update[-1][i])+\
                                         " maksymalnie : "+str(DlPola[pole])
                                    dane.append(stat)
                                    wyn2.append([Update[-1][i],Etykiety.index(pole)])
                            if pole == 'kod' and len(str(wart).strip()) == 0:  #AB 26.05.22r
                                stat='BL DL POLA$'+" "+Kolumny[pole]+" w wierszu : "+str(Update[-1][i])+ \
                                     " zawarto nie moe by pusta"
                                dane.append(stat)
                                wyn2.append([Update[-1][i],Etykiety.index(pole)])

                             
                        
            else:
                stat='UPR UPD'
                dane.append(stat)
            
#-------------------------------------------------------------------------------
#--- UPDATE       
#-------------------------------------------------------------------------------

        if stat=='OK':
            rsglobal.ZapiszDoLogow('UPDATE',1)
            sql=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                UPDATE="UPDATE "+Tabela+" "
                SET='SET '
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if Typy[Etykiety.index(pole)] in ['b']: 
                        if wart in [True,1]:
                            SET+=pole+"=True,"
                        else:
                            SET+=pole+"=False,"
                    elif Typy[Etykiety.index(pole)] in ['s']:
                        if wart<>'':
                            SET+=pole+"='"+wart+"',"
                        else:
                            SET+=pole+"=null,"
                    elif Typy[Etykiety.index(pole)] in ['n']:
                        if wart<>'':
                            SET+=pole+"="+str(wart)+","
                SET=SET.strip(",")
                if Typ not in ['I']:
                    WHERE=" WHERE firma_id='"+self.firma_id+"' AND"
                else:
                    WHERE=" WHERE "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=Update[2][i][j]
                    if Typy[Etykiety.index(pole)] in ['s']:   
                        WHERE+=" "+pole+"='"+wart+"' AND"
                    else:
                        WHERE+=" "+pole+"="+str(wart)+" AND"
                        
                    if Tabela == 'rs_hale_produkcyjne' and pole == 'hala_id' and wart == '00':
                        stat = 'Nie mona zmienia hali o kodzie 00'
                    
                WHERE=WHERE.rstrip('AND')
                sql+=UPDATE+SET+WHERE+";"
            if sql<>'': 
                st,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if st<>'OK':
                    stat='BL UPD'
                    dane.append(stat)
                    
#-------------------------------------------------------------------------------
#--- Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------
                
        if len(Insert[0])>0:
            if UprIns:
                #rsglobal.ZapiszDoLogow(str(Insert))
                if Insert[0][0][0]!='':
                    for i in xrange(len(Insert[0])):
                        kod = opis = None  #WS 2021-03-24

                        for j in xrange(len(Insert[0][i])):
                            pole=Insert[1][j]
                            wart=Insert[0][i][j]
                            if pole in DlPola and len(wart)>DlPola[pole]:
                                stat='BL DL POLA$'+" "+Kolumny[pole]+" w wierszu : "+str(Insert[-1][i])+" maksymalnie : "+str(DlPola[pole])
                                #rsglobal.ZapiszDoLogow(stat,5)
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],Etykiety.index(pole)])
                            #WS 2021-03-24
                            if pole == 'kod':
                                kod = wart.strip()
                                if len(kod)==0:  #AB 26.05.22r
                                    stat='BL DL POLA$'+" "+Kolumny[pole]+" w wierszu : "+str(Insert[-1][i])+" zawarto nie moe by pusta"
                                    #rsglobal.ZapiszDoLogow(stat,5)
                                    dane.append(stat)
                                    wyn2.append([Insert[-1][i],Etykiety.index(pole)])

                            if pole == 'opis':
                                opis = wart.strip()

                        #WS 2021-03-24
                        if kod is not None and opis is not None:
                            SQL = "SELECT opis from "+Tabela+" WHERE firma_id='"+self.firma_id+"' AND kod='"+kod+"';"
                            stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],Etykiety.index('kod')])
                            elif len(d) > 0:
                                stat='Kod '+kod+' ju istnieje z opisem: '+d[0][0]
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],Etykiety.index('kod')])

                            SQL = "SELECT kod from "+Tabela+" WHERE firma_id='"+self.firma_id+"' "
                            SQL += " AND UPPER(REPLACE(opis, ' ', ''))=UPPER(REPLACE('"+opis+"', ' ', ''));"
                            stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],Etykiety.index('opis')])
                            elif len(d) > 0:
                                stat='Wprowadzony opis posiada ju kod: '+d[0][0]
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],Etykiety.index('opis')])
                    rsglobal.ZapiszDoLogow('OTO JAKI JEST STAT PO PRZEJSCIU : '+str(stat),1)
                else:
                    stat='BL PUS'
                    dane.append(stat)

                #WS 2021-03-24
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
            else:
                stat='UPR INS'
                dane.append(stat)            
                
#-------------------------------------------------------------------------------
#--- INSERT
#-------------------------------------------------------------------------------
    
        if stat=='OK':
            #rsglobal.ZapiszDoLogow('INSERT ',1)   
            sql=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO "+Tabela+" "
                if Pola == 0:
                    KOLUMNY="("
                    VALUES=" VALUES ("
                else:
                    KOLUMNY="(firma_id,"
                    VALUES=" VALUES ('"+self.firma_id+"',"
                    if Pola>1:
                        KOLUMNY+='oddzial_id,'
                        VALUES+="'"+self.oddzial_id+"',"
                    
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if Typy[Etykiety.index(pole)] in ['b']:
                        KOLUMNY+=pole+","
                        if wart in [True,1]:
                            VALUES+="TRUE,"
                        if wart in [False,0]:
                            VALUES+="FALSE,"
                    elif Typy[Etykiety.index(pole)] in ['s']:
                        if wart<>'':
                            KOLUMNY+=pole+","
                            VALUES+="'"+wart+"',"
                    
                    elif Typy[Etykiety.index(pole)] in ['n']:
                        if wart<>'':
                            KOLUMNY+=pole+","
                            VALUES+=str(wart)+","
                    
                KOLUMNY=KOLUMNY.rstrip(',')+")"
                VALUES=VALUES.rstrip(',')+");"
                sql+=INSERT+KOLUMNY+VALUES
            if sql<>'': 
                st,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if st<>'OK':
                    stat='BL INS'
                    dane.append(stat)

if stat=='OK' and Fun == 1:
    Select="SELECT uid_karty FROM rs_kierowcy WHERE TRIM(uid_karty)<>'' "
    Select+=" AND firma_id='"+self.firma_id+"' GROUP BY uid_karty HAVING COUNT(uid_karty)>1"
    stat,d,wyn,dump=self.PolSQL.Execute(Select,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia unikalnoci kart w systemie '+stat
    elif len(d)==1:
        stat="Karta o numerze "+d[0][0]+" jest wprowadzona wicej ni jeden raz."
    elif len(d)>1:
        stat="Karty o numerach "
        for x in d:
            stat+=x[0]+","
        stat= stat[:-1]+" s wprowadzone wicej ni jeden raz."


#-------------------------------------------------------------------------------
#--- POBIERANIE DANYCH
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in [1,5,6]:
# if (Fun in [1,5,6]) and (stat=='OK'):
    if UprPrzegl:    
        Select="SELECT "
        for i in Etykiety:
            #RW usuwamy niepotrzbne spacje z uid karty
            if i == "uid_karty":
                Select += "TRIM(uid_karty),"
            else:
                Select+=i+","
        if Pola > 0:
            WHERE=" WHERE firma_id='"+self.firma_id+"' "
        else:
            WHERE=" "
        Select=Select.rstrip(',')+" FROM "+Tabela+WHERE+" ORDER BY "+Etykiety[0]+";"
        #WS 2019-10-03
        stat,dane,wyn1,dump=self.PolSQL.Execute(Select,3)
        # stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych ze sownika : '+stat
    else:
        stat = "UPR PRZ"