
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_slowniki_wczytaj_opis.py
# Purpose:     wczytuje opis slownika uwzgldniajc uprawnienia operatora 
#
# Author:      Jan Raburski
# Created:     2005/10/28
# RCS-ID:      $Id: fs_slowniki_wczytaj_opis.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-05-13 - Wojciech Skowron - RSSLowniki - refaktoryzacja - klucze w postaci sownika zamiast listy (11486)

# klucze[0] - nazwa tabeli ze slownikiem
# klucze[1] - kod
# wraca z opisem kodu

if isinstance(klucze, dict):
    dane = []
    wyn2 = []
    stat = "OK"

    if not 'Funkcja' in klucze:
        stat = 'Brak podanej funkcji w kluczach'
        Fun = 999

    if stat == 'OK':
        Fun = klucze['Funkcja']

        SlPar = {'Tabela':[5], 'Kod':[5]}
        Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
        if Lista != '':
            stat = 'Uwaga : wywoanie funkcji fs_slowniki_wczytaj_opis z numerem '+str(Fun)+' bez parametrw: '+Lista

    if stat == 'OK':
        tabela = klucze['Tabela']
        kod = klucze['Kod']
else:
    Fun = 5

    tabela = klucze[0]
    kod = klucze[1]
    stat = 'OK'
    dane = []
    wyn1 = []
    wyn2 = []

# to obejscie zamiast numeru funkcji, aby nie przerabiac okienek juz wykorzystujacych tego fs-a bez numeru funkcji
# jesli klucz[0] to lista, i zawiera nazwe rs_gminy, to oznacza pobranie 3 opisow: gminy, powiatu i wojewodztwa
# mariusz rajfura 2010/05/06

if stat == "OK" and Fun == 5:
    if isinstance(tabela, list) and tabela[0].lower() == 'rs_gminy':
    # if type(tabela) == type([]) and tabela[0].lower() == 'rs_gminy':
        dane = [['','','']]

        if not ((self.oddzial_id,'011860') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
            dane[0][0] = dane[0][1] = dane[0][2] = 'Brak uprawnie do sownika gmin. Powiadom administratora.'
        else:
            kod = rsglobal.Dekoduj(kod).strip()
            if len(kod) == 7:
                sql = "SELECT opis FROM rs_gminy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+kod+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane[0][0] = 'Bd pobrania opisu ze sownika gmin : '+stat
                else:
                    if len(d) == 0:
                        dane[0][0] = 'Bdny kod gminy.'
                    else:
                        dane[0][0] = str(d[0][0])

            if stat == 'OK':
                kod = kod[:4].strip()
                if len(kod) == 4:
                    sql = "SELECT opis FROM rs_gminy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+kod+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        dane[0][1] = 'Bd pobrania opisu ze sownika gmin : '+stat
                    else:
                        if len(d) == 0:
                            dane[0][1] = 'Bdny kod powiatu.'
                        else:
                            dane[0][1] = str(d[0][0])

            if stat == 'OK':
                kod = kod[:2].strip()
                if len(kod) == 2:
                    sql = "SELECT opis FROM rs_gminy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+kod+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        dane[0][2] = 'Bd pobrania opisu ze sownika gmin : '+stat
                    else:
                        if len(d) == 0:
                            dane[0][2] = 'Bdny kod wojewdztwa.'
                        else:
                            dane[0][2] = str(d[0][0])

    else:
        #to jest stara czesc funkcji, ktora byla do 2010/05/06  mariusz rajfura
        dane=['']
        stat,opis,dump,dump = self.PolSQL.Execute("SELECT slownik_id,menu_id,nazwa,typ,dlugosc,pola,funkcja FROM rs_slowniki WHERE tabela = \'%s\';" % tabela,3)
        if stat=='OK':
            if len(opis)>0:
                rsglobal.ZapiszDoLogow(opis,6)
                dlug = opis[0][4]
                kod = kod + '                                                            '
                kod = kod[0:dlug]
                inne = opis[0][3]=='I'
                if inne:
                    funkcja = rsglobal.rseval(opis[0][6])
                    polekod, dump, dump, dump = funkcja[0]
                slownik = opis[0][0]
                if ((self.oddzial_id,slownik) in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    if inne:
                        stat,wyn,dump,dump = self.PolSQL.Execute("SELECT * FROM %s WHERE %s='%s';" % (tabela,polekod,kod),3)
                        if stat=='OK':
                            if len(wyn)>0:
                                dane[0]=wyn[0][1]
                    else:
                        if opis[0][5]==1:
                            stat,wyn,dump,dump = self.PolSQL.Execute("SELECT opis FROM %s WHERE firma_id=\'%s\' AND kod='%s';" % (tabela,self.firma_id,kod),3)
                        else:
                            stat,wyn,dump,dump = self.PolSQL.Execute("SELECT opis FROM %s WHERE firma_id=\'%s\' AND oddzial_id=\'%s\' AND kod='%s';" % (tabela,self.firma_id,self.oddzial_id,kod),3)
                        if stat=='OK':
                            if len(wyn)>0:
                                dane[0]=wyn[0][0]

                else:
                    stat='OK'
                    dane=['Brak uprawnie do sownika. Poinformuj administratora.']
        #WS
        else:
            stat='Bd pobrania danych o sownikach.'
