# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_spis_z_natury.py
# Purpose:     wczytuje/usuwa dane ze spisami z natury
# Author:      Piotr Witkowski
# Created:     2016/02/04
# RCS-ID:      $Id: fs_spis_z_natury.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2011-05-12 Mariusz Rajfura     (4578) pobranie domyslnych parametrow dla tworzonych dokumentow
#2012-10-03 Mariusz Rajfura     (6126) sprawdzenie zamkn.dok przed otwieraniem spisu
#2015-12-18 Piotr Witkowski     (9476) reafaktoryzacja spisu z natury + pozycje
#2018-10-16 Aleksander Bargie (11623) WMS - spis z natury - Anakonda - zmiany w tworzeniu spisu
#2020-09-07 Aleksander Bargie (12093) [HD] spis z natury w handlu]

from funkcje import fs_magazyny_parametry_dokumentow_pom
from funkcje import fs_spis_z_natury_pom


stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
    
if stat=='OK':    
    Funkcja = klucze['Funkcja']    
    SlPar={'DataOdF':[5,6,7,8],'DataDoF':[5,6,7,8],'DataDoF':[5,6,7,8],'MagF':[5,6,7,8],
           'KatF':[5,6,7,8],'Data':[6,7,8],'Mag':[6,7,8],'Kat':[6,7,8],
           'DokRW':[7],'DokPW':[7],'Kontrahent':[7],'KontoKosztow':[7]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_spis_z_natury z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [5,6,7,8]:               
            DataOdF = str(klucze['DataOdF'])
            DataDoF = str(klucze['DataDoF'])
            MagF    = str(klucze['MagF'])
            KatF    = str(klucze['KatF'])
        if Funkcja in [6,7,8]:
            Data    = str(klucze['Data'])
            Mag     = str(klucze['Mag'])
            Kat     = str(klucze['Kat'])
        if Funkcja in [7]:                 
            DokRW = str(klucze['DokRW'])
            DokPW = str(klucze['DokPW']) 
            Kontrahent   = str(klucze['Kontrahent'])
            KontoKosztow = str(klucze['KontoKosztow'])

dane = []
wyn1 = []
wyn2 = []

rsglobal.ZapiszDoLogow('klucze '+str(klucze))

if stat=='OK' and DataOdF <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdF):
        stat='DATAOD BL'
if stat=='OK' and DataDoF <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoF):
        stat='DATADO BL'
if stat=='OK' and (DataOdF <> '    -  -  ') and (DataDoF <> '    -  -  '):
    if DataOdF > DataDoF:
        stat='DATA BL'
#AB 07.09.20r
if stat == 'OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprDodawanie  = True  # dodawanie
        UprUsuwanie   = True  # usuwanie
        UprPrzegl     = True  # przegladanie
        UprZamykanie  = True  # zamykanie
        UprOtwieranie = True  # otwieranie
        UprPrzeglPoz  = True  # przegldanie pozycji
    else:
        UprDodawanie  = (self.oddzial_id, '033013') in self.uprawnienia  # dodawanie
        UprUsuwanie   = (self.oddzial_id, '033014') in self.uprawnienia  # usuwanie
        UprPrzegl     = (self.oddzial_id, '033011') in self.uprawnienia  # przegladanie
        UprZamykanie  = (self.oddzial_id, '033016') in self.uprawnienia  # zamykanie
        UprOtwieranie = (self.oddzial_id, '033017') in self.uprawnienia  # otwieranie
        UprPrzeglPoz  = (self.oddzial_id, '033020') in self.uprawnienia  # przegldanie pozycji
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
        #AB 07.09.20r
    if not UprUsuwanie:
        stat='UPR DEL'
    if stat=='OK':
        Filtr="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        Filtr+=" AND kateg_artykulu='"+Kat+"' AND data='"+Data+"'"
        stat,dane,dump,dump = self.PolSQL.Execute("SELECT stan FROM rs_inwentaryzacja "+Filtr+";",3)
        if stat<>'OK':
            stat="Bd pobrania stanu: "+stat
            if len(dane) ==0:
                stat='DEL BR'
            elif dane[0][0] =='Z':
                stat='DEL BL'
        else:
            DELETE = "DELETE FROM rs_inwentaryzacja "+Filtr+";"
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE ,1)
            if stat <> 'OK':
                stat = "Bd usunicia danych: "+stat


#-------------------------------------------------------------------------------
#---   ZAMKNICIE SPISU (7)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 7:
        #AB 07.09.20r
    if not UprZamykanie:
        stat='UPR ZAM'

    if stat == 'OK' and Kontrahent.strip() == '':
        SEL = "SELECT 1  FROM rs_typy_dokumentow_m WHERE firma_id='" + self.firma_id + "'"
        SEL += " AND dokument_id='" + DokPW + "' AND czy_kontrahent;"
        stat, Dane, dump, dump = self.PolSQL.Execute(SEL, 3)
        if stat <> 'OK':
            stat = 'Bdy sprawdzania wymagalnoci kontrahenta dla typu dokumentu magazynowego ' + DokPW
        elif len(Dane) <> 0:
            stat = 'ZAM BL KON PW'
            dane.append(stat)

    if stat == 'OK' and Kontrahent.strip() == '':
        SEL = "SELECT 1  FROM rs_typy_dokumentow_m WHERE firma_id='" + self.firma_id + "'"
        SEL += " AND dokument_id='" + DokRW + "' AND czy_kontrahent;"
        stat, Dane, dump, dump = self.PolSQL.Execute(SEL, 3)
        if stat <> 'OK':
            stat = 'Bdy sprawdzania wymagalnoci kontrahenta dla typu dokumentu magazynowego ' + DokRW
        elif len(Dane) <> 0:
            stat = 'ZAM BL KON RW'
            dane.append(stat)
    
    if stat=='OK':
        SEL="SELECT data FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"'"
        SEL+=" AND data>'"+Data+"' AND stan IN ('Z','K') AND (magazyn_skad='"+Mag+"' OR  magazyn_dokad='"+Mag+"');"
        stat,Dane,dump,dump = self.PolSQL.Execute(SEL,3)
        if stat<>'OK':
            stat='Bdy pobierania daty z dokumentw magazynowych podczas pierwszego testu'
        elif len(Dane)<>0:
            stat='ZAM BL ST'
            dane.append(stat)        
        
    # sprawdzenie czy wczeniejsze dokumenty s pozamykane
    if stat=='OK':
        SEL="SELECT data FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND data<='"+Data+"'"
        SEL+=" AND stan IN ('W','G') AND (magazyn_skad='"+Mag+"' OR  magazyn_dokad='"+Mag+"') ;"
        stat,Dane,dump,dump = self.PolSQL.Execute(SEL,3)
        if stat<>'OK':
            stat='Bdy pobierania daty z dokumentw magazynowych podczas drugiego testu'
        elif len(Dane)<>0:
            stat='ZAM BL ML'
            dane.append(stat)        

    #---------------------------------------------------------------------------
    #--- zmiana stanu spisu z natury na Z
    #---------------------------------------------------------------------------
    
    if stat=="OK":
        UPDATE = "UPDATE rs_inwentaryzacja SET stan='Z' WHERE firma_id='"+self.firma_id
        UPDATE+="' AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
        if stat <> 'OK':
            stat = "Bd zmiany stanu spisu z natury na Z: "+stat

    #---------------------------------------------------------------------------
    #--- SPRAWDZENIE JAKIE TYPY DOKUMENTW POWINNY BY STWORZONE
    #---------------------------------------------------------------------------

    if stat=="OK":
        SQL = "SELECT DISTINCT CASE WHEN ilosc_ks1-ilosc1>0 THEN 1 ELSE -1 END"
        SQL+= " FROM rs_inwentaryzacja_pozycje_przyjecia WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"'"
        SQL+=" AND ilosc_ks1 <> ilosc1;"  
        stat, DTest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bdy sprawdzenia danych przed tworzeniem RW/PW : '+stat

        if stat=='OK':
            for poz in DTest:
                if stat=='OK':
                    if poz[0] == 1 and DokRW=='':
                        stat="Na podstawie wprowadzonych danych powinien by utworzony dokument rozchodowy,"
                        stat+="dla ktrego nie podano typu dokumentu. Podczas zamykania spisu naley poda typ dokumentu rozchodowego."
                    elif poz[0] == -1 and DokPW=='':
                        stat="Na podstawie wprowadzonych danych powinien by utworzony dokument przychodowy, dla ktrego"
                        stat+="nie podano typu dokumentu. Podczas zamykania spisu naley poda typ dokumentu przychodowego."

    #---------------------------------------------------------------------------
    #--- STWORZENIE RW - robimy na zamknitym spisie, by nie zmieniao wartoci spisu
    #---------------------------------------------------------------------------

    if stat == 'OK' and DokRW <> '' :
        stat = fs_spis_z_natury_pom.UtworzDokumentPodczasZamykaniaSpisuZNatury(self, Data, Mag, Kat, DokRW, Kontrahent, KontoKosztow, 'W')
    
    #---------------------------------------------------------------------------
    #--- STWORZENIE PW - robimy na zamknitym spisie, by nie zmieniao wartoci spisu
    #---------------------------------------------------------------------------
            
    if stat == 'OK' and DokPW <> '':
        stat = fs_spis_z_natury_pom.UtworzDokumentPodczasZamykaniaSpisuZNatury(self, Data, Mag, Kat, DokPW, Kontrahent, KontoKosztow, 'P')
            
#-------------------------------------------------------------------------------
#---   OTWARCIE SPISU (8)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 8:
        #AB 07.09.20r
    if not UprOtwieranie:
        stat='UPR OTW'

    # najpierw czycimy dokumenty RW/PW a potem robimy testy czy jest ok
    if stat == 'OK':
        sql = "SELECT COALESCE(dokument_rw,''),COALESCE(dokument_pw,''),czy_dokumenty_po FROM rs_inwentaryzacja"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        sql+=" AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';" 
        stat,DSpisu,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia dokumentw przypietych do spisu: '+stat
        elif DSpisu[0][2]:
            stat="ZAM BL PO"

    if stat=='OK':
        DokRW=DSpisu[0][0].strip()
        DokPW=DSpisu[0][1].strip()
        
        if DokRW <> '':
            # otwarcie dokumentu (Z -> G)
            Magazyn,Dok,Data,Nr=DokRW.split('/')
            KluczeDok={}
            KluczeDok['Mag'] = Magazyn
            KluczeDok['Typ'] = Dok
            KluczeDok['Data']  = Data
            KluczeDok['Numer'] = Nr
            KluczeDok['Funkcja'] = 31
            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)
            if stat <> 'OK':
                stat='Bdy otwierania dokumentu rozchodowego z Z na G : '+stat
                
            # otwarcie dokumentu (G -> W)
            if stat == 'OK':
                KluczeDok['Funkcja']=20
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)  
                if stat <> 'OK':
                    stat='Bdy otwierania dokumentu rozchodowego z G na W : '+stat
                
            # usunicie dokumentu
            if stat == 'OK':
                KluczeDok['Funkcja']=26
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)  
                if stat <> 'OK':
                    stat='Bdy usuwania dokumentu rozchodowego : '+stat
                    
        if stat=='OK' and DokPW <> '':
            # otwarcie dokumentu (Z -> G)
            Magazyn,Dok,Data,Nr=DokPW.split('/')
            KluczeDok={}
            KluczeDok['Mag'] = Magazyn
            KluczeDok['Typ'] = Dok
            KluczeDok['Data']  = Data
            KluczeDok['Numer'] = Nr
            KluczeDok['Funkcja'] = 31
            stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)
            if stat <> 'OK':
                stat='Bdy otwierania dokumentu przychodowego z Z na G : '+stat
                
            # otwarcie dokumentu (G -> W)
            if stat == 'OK':
                KluczeDok['Funkcja']=20
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)  
                if stat <> 'OK':
                    stat='Bdy otwierania dokumentu przychodowego z G na W : '+stat
                    
            # usunicie dokumentu
            if stat == 'OK':
                KluczeDok['Funkcja']=26
                stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", KluczeDok, [], [],False)  
                if stat <> 'OK':
                    stat='Bdy usuwania dokumentu przychodowego : '+stat
                    
    if stat == 'OK':
        # sprawdzenie czy istnieja pozniejsze zamkniete dokumenty
        SEL="SELECT data FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND data>'"+Data+"'"
        SEL+=" AND stan <> 'W' AND (magazyn_skad='"+Mag+"' OR  magazyn_dokad='"+Mag+"') ;"
        stat,Dane,dump,dump = self.PolSQL.Execute(SEL,3)
        if stat=='OK' and len(Dane)<>0:
            stat='ZAM BL PZN'
            dane.append(stat)        

    if stat=='OK':
        UPD = "UPDATE rs_inwentaryzacja SET stan='W', dokument_rw='', dokument_pw=''"
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        UPD+=" AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat <> 'OK':
            stat = 'Bd otwierania inwentaryzacji: '+stat


#-------------------------------------------------------------------------------
#---   TWORZENIE DOKUMENTU RW (9)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 9:
    #sprawdzenie uprawnien do dokumentu RW w magazynie
    if (self.operator_id <> STANDARD_OPERATOR_ID):
        SEL="SELECT wprowadzanie FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"
        SEL+=Mag+"' AND dokument_id='RW' AND operator_id IN "+self.operatorzy+" AND wprowadzanie;"
        stat,dane,dump,dump = self.PolSQL.Execute(SEL,3)
        if len(dane)==0:
            stat='UPR DOD RW'
            
    if stat == 'OK':
        # pobranie domyslnych paramtetrow dla dokumentu w magazynie
        SParam = {}
        SParam['wersja'] = ''
        SParam['kontrahent_id'] = ''
        
        stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Mag,'RW',SParam)
        if stat <> 'OK':
            stat == "Bd pobrania domylnych parametrw dla dokumentu w magazynie"
        else:
            Wersja = SParam['wersja']
            Kontrahent = SParam['kontrahent_id']
            
            if Wersja in ('','NULL'):
                Wersja = 'NULL'
            else:
                Wersja = "'"+Wersja+"'"
                
            if Kontrahent in ('','NULL'):
                Kontrahent = 'NULL'
            else:
                Kontrahent = "'"+Kontrahent+"'"
    
    if stat=='OK':
        #--- jest ok dodajemy dokument
        sql="SELECT dokument_rw FROM rs_inwentaryzacja WHERE firma_id='"+self.firma_id
        sql+="' AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
        stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
        if stat <> 'OK':
            stat = "Bd pobrabrania dokumentu rw: "+stat
        elif stat=='OK' and dane[0][0] not in (None,'None',''):
            stat="ISTN BL RW"

        #pobranie kolejnego numeru
    if stat=='OK':
        sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Mag+"\\\',\\\'RW\\\',\\\'"+Data+"\\\']','M');"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = "Bd pobrania kolejnego numeru dokumentu"
        elif dane[0][0]=='OK':
            sql = "SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Mag+"\\\',\\\'RW\\\',\\\'"+Data+"\\\']','M');"
            stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
            if dane[0][0] in (None,'None',''):
                stat='POB BL NR'
        elif stat=='OK':
            stat='RW BL'

    if stat=='OK':
        Nr= str(dane[0][0])
        InsN ="INSERT INTO rs_dokumenty_magazynowe"
        InsN+=" (firma_id,magazyn_id,dokument_id,data,numer,stan,magazyn_skad,"
        InsN+="  kontrahent_id,wersja) "
        InsN+=" VALUES"
        InsN+=" ('"+self.firma_id+"','"+Mag+"','RW','"+Data+"',"+Nr+",'W','"+Mag+"',"
        InsN+="  "+Kontrahent+","+Wersja+");"

        InsP=''
        Lp=1
        sql = "SELECT artykul_id,round(ilosc_ks1-ilosc1,2),round(ilosc_ks2-ilosc2,2) FROM rs_inwentaryzacja_pozycje WHERE firma_id='"
        sql+= self.firma_id+"' AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            for poz in dane:
                if poz[1]>0:
                    InsP+="INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2) "
                    InsP+=" VALUES ('"+self.firma_id+"','"+Mag+"','RW','"+Data+"',"+Nr+","+str(Lp)+",0,'"+rsglobal.Dekoduj(poz[0])+"',"+str(poz[1])+","+str(poz[2])+");"
                    Lp=Lp+1

        if not (InsP <> "" and stat == 'OK'):
            stat="POZ BR"
        else:
            stat,dump,dump,dump = self.PolSQL.Execute(InsN+InsP,1)
            rsglobal.ZapiszDoLogow('7.'+stat,1)
            if stat<>'OK':
                stat = "Bd dodawania dokumentu magazynowego do spisu: "+stat
            if stat=='OK':
                DokRW=Mag+'/RW/'+Data+'/'+Nr
                sql = "UPDATE rs_inwentaryzacja SET dokument_rw=\'"+DokRW+"\' WHERE firma_id='"+self.firma_id
                sql+="' AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
                stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
                if stat<>'OK':
                    stat = "Bd aktualizacji dokumentu rw: "+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete, 7 - zamknij)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja in [5,6,7,8,9]:
    # pobranie danych o dokumentach
    Select="SELECT i.stan,i.data,i.magazyn_id||' - '||m.opis,COALESCE(i.kateg_artykulu||' - '||k.opis,"
    Select+=" i.kateg_artykulu||' - '),COALESCE(dokument_rw,''),COALESCE(dokument_pw,'')"
    Select+=" FROM rs_inwentaryzacja i "
    Select+=" LEFT OUTER JOIN rs_kateg_artykulow k ON (i.firma_id=k.firma_id AND i.kateg_artykulu=k.kod) "
    Select+=" LEFT OUTER JOIN rs_magazyny m ON (i.firma_id=m.firma_id AND i.magazyn_id=m.magazyn_id) "
    Select+="WHERE i.firma_id='"+self.firma_id+"' AND NOT m.detaliczny "
    if MagF <> '':
        Select += " AND i.magazyn_id='"+MagF+"'"
    if KatF <> '':
        Select +=" AND i.kateg_artykulu='"+KatF+"'"
    if DataOdF <> '    -  -  ':
        Select +=" AND i.data>='"+DataOdF+"'"
    if DataDoF <> '    -  -  ':
        Select +=" AND i.data<='"+DataDoF+"'"
                            #AB 16.10.18r
    Select+=" ORDER BY i.data DESC, i.magazyn_id,i.kateg_artykulu;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat
