
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_spis_z_natury_klucz.py
# Purpose:     dodaje dane ze spisami z natury
#
# Author:      Micha Raburski
# Created:     2006/06/24
# RCS-ID:      $Id: fs_spis_z_natury_klucz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2015-12-18 Piotr Witkowski     (9476) refaktoryzacja spisu z natury + pozycje dodanie wyn1, wyn2 oraz dopisanie
#                                      brakujcej kolumny w select
#2020-09-07 Aleksander Bargie (12093) [HD] Spis z natury w handlu

from funkcje import fs_spis_z_natury_pom

Data = klucze[0]
Mag = klucze[1]
Kat = klucze[2]
Aktywne = klucze[3]
IlosciNiez = klucze[4]
Data2 = klucze[5]
DataOdF = pola[0]
DataDoF = pola[1]
MagF = pola[2]
KatF = pola[3]

stat = "OK"
dane = []
wyn1=[]
wyn2=[]
#AB 07.09.20r
UprDodawanie = self.operator_id == STANDARD_OPERATOR_ID
if self.operator_id == STANDARD_OPERATOR_ID:
    UprDodawanie = True
else:
    UprDodawanie = (self.oddzial_id,'033013') in self.uprawnienia
#dodawanie nowego spisu
if not UprDodawanie:
    stat='UPR DOD'
    wart.append(stat)

if stat=='OK':
    #sprawdzenie magazynu
    if Mag=='':
        stat='BR MAG'
        wart.append(stat)
    Mag = (Mag+'    ')[0:4]
                                                                                                                                #AB 07.09.20r
    ok,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='%s' AND magazyn_id='%s';" % (self.firma_id,Mag),3)
    if ok=='OK':
        if len(wyn)==0:
            stat='BL MAG'
            wart.append(stat)
    else:
        stat='BL OG'
                                                                                                                                #AB 07.09.20r
    ok,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='%s' AND magazyn_id='%s' AND NOT detaliczny;" % (self.firma_id,Mag),3)
    if ok=='OK':
        if len(wyn)==0:
            stat='BL MAG DET'
            wart.append(stat)
    else:
        stat='BL OG'

    #sprawdzenie kategorii
    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT kategoria FROM rs_magazyny_kategorie WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';",3)
    if stat=='OK':
        if len(wyn)>0:
            stat,wyn,dump,dump = self.PolSQL.Execute("SELECT kategoria FROM rs_magazyny_kategorie WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND kategoria LIKE '"+Kat.strip()+"%';",3)
            if len(wyn)==0:
                stat='BL KAT'
                wart.append(stat)

    #sprawdzenie istnienia spisu z natury
    Filtr="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
    Filtr=Filtr+" AND kateg_artykulu='"+Kat+"' AND data='"+Data+"'"                
    ok,wyn,wyn1,tr = self.PolSQL.Execute("SELECT stan FROM rs_inwentaryzacja "+Filtr+";",3)        
    if ok=='OK':
        if len(wyn)<>0:
            stat='BL SPIS'
            wart.append(stat)
    else:
        stat='BL OG'
    
    #sprawdzenie czy nie ma utworzonego i zamknietego spisu z data pozniejsza
    if stat=='OK':
        SEL="SELECT data FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND data>'"+Data+"' AND stan='Z' AND magazyn_id='"+Mag+"' ;"
        stat,dane,wyn1,tr = self.PolSQL.Execute(SEL,3)
        if len(dane)<>0:
            stat='STARSZE ZAM'
            dane.append(stat)    
    
    #pobranie danych - jesli sa, to tworzony jest spis
    Select = "SELECT am.artykul_id,am.ilosc1,am.ilosc2 FROM rs_artykuly_magazyny am INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    Select += "WHERE am.firma_id='"+self.firma_id+"' AND am.magazyn_id='"+Mag+"'"
    if Aktywne:
        Select=Select+" AND a.aktywny"
    if Kat.strip() !='':
        Select += " AND a.kateg_artykulu LIKE '"+Kat.strip()+"%'"
    if IlosciNiez:
        Select += " AND am.ilosc1 != 0"
    elif Data2 != '    -  -  ':
        Select += " AND ((am.ilosc1 != 0) OR (am.ost_przychod>='"+Data2+"' OR am.ost_rozchod>='"+Data2+"'))"

    Select=Select+";"
    stat,wyn,wyn1,tr = self.PolSQL.Execute(Select,3)    
    if stat<>'OK':
        stat='Bd pobrania danych artykuw: '+stat
        wart.append(stat)

    if stat=='OK':        
        #dodawanie nagwka spisu z natury
        Ins="INSERT INTO rs_inwentaryzacja (firma_id,magazyn_id,kateg_artykulu,data,stan) VALUES "
        Ins+="('"+self.firma_id+"','"+Mag+"','"+Kat+"','"+Data+"','W');"
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        if stat<>"OK":
            stat='Bd wstawiania nagwka spisu z natury : '+stat
        
    
    if stat=='OK':
        #dodawanie pozycji
        for art in wyn:
            Ins="INSERT INTO rs_inwentaryzacja_pozycje "
            Ins+=" (firma_id,magazyn_id,kateg_artykulu,data,artykul_id,ilosc1,ilosc2,ilosc_ks1,ilosc_ks2,recznie)"
            Ins+=" VALUES ('"+self.firma_id+"','"+Mag+"','"+Kat+"','"+Data+"','"+str(art[0])+"',0,0,"+str(art[1])+","
            Ins+=str(art[2])+",FALSE);"
            stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
            if stat<>"OK":
                stat='Bd wstawiania pozycji spisu z natury : '+stat   

    if stat=='OK':
        # wstawienie
        for art in wyn:
            if stat=='OK':
                stat=fs_spis_z_natury_pom.OdswiezPozycjeArtykulowPrzyjecWSpisieZNatury(self, Data, Mag, Kat, str(art[0]))
            
if stat=='OK':
    # pobranie danych o dokumentach
    Filtr="WHERE NOT m.detaliczny AND i.firma_id='"+self.firma_id+"'"
    if MagF != '':
        Filtr=Filtr+" AND i.magazyn_id='"+MagF+"'"
    if KatF != '':
        Filtr=Filtr+" AND i.kateg_artykulu='"+KatF+"'"        
    if DataOdF != '    -  -  ':
        Filtr=Filtr+" AND i.data>='"+DataOdF+"'"                
    if DataDoF != '    -  -  ':
        Filtr=Filtr+" AND i.data<='"+DataDoF+"'"                
    Select="SELECT i.stan,i.data,i.magazyn_id||' - '||m.opis,COALESCE(i.kateg_artykulu||' - '||k.opis,i.kateg_artykulu||' - '),COALESCE(dokument_rw,''),COALESCE(dokument_pw,'') FROM rs_inwentaryzacja i LEFT OUTER JOIN rs_kateg_artykulow k ON (i.firma_id=k.firma_id AND i.kateg_artykulu=k.kod) LEFT OUTER JOIN rs_magazyny m ON (i.firma_id=m.firma_id AND i.magazyn_id=m.magazyn_id) "
    Select+=Filtr+" ORDER BY i.data DESC, i.magazyn_id,i.kateg_artykulu;"
    stat,wyn1,dump,dump = self.PolSQL.Execute(Select,3) 
    if stat<>'OK':
        stat='Bd pobrania danych inwentaryzacji: '+stat 
        wart.append(stat)