#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_spis_z_natury_pom.py
# Purpose:          funkcje pomocnicze do tworzenia przyj w spisie z natury
# Author:           Micha Raburski
# Created:          2013/06/27
# RCS-ID:           $Id: fs_spis_z_natury_pom.py $
# Copyright:        (c) 2013 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

#2018-10-16 Aleksander Bargie (11623) WMS - spis z natury - Anakonda - zmiany w tworzeniu spisu
#2018-10-23 Aleksander Bargie (11266) WMS - spis z natury - zamykanie
#2020-07-08 Aleksander Bargie (12046) Zamykanie spisu z natury dla magazynw detalicznych
#2023-06-28 Aleksander Bargie (13471) Zamykanie dokumentu w magazynie handlowym trwa ponad 30 minut gdy obecny jest w
#                                      nim niezamknity spis z natury

import rsglobal
from funkcje import fs_magazyny_parametry_dokumentow_pom
from funkcje import fs_kolejkowanie_pom

#-------------------------------------------------------------------------------
# FUNKCJA ODWIEAJCA LIST POZYCJI ARTYKUW PRZYJ (AP) W SPISIE Z NATURY
#-------------------------------------------------------------------------------

def OdswiezPozycjeArtykulowPrzyjecWSpisieZNatury(self, Data, Magazyn, Kategoria, Artykul):
    # parametry :
    # self - zmienna przekazujca "rodowisko" funkcji
    # Data - data spisu
    # Magazyn - magazyn spisu
    # Kategoria - analizowana kategoria artykuw
    # Artykul - artyku do odwieenia
    #
    # wraca ze stat (czy jest OK) 
     
    # pomocnicza zmienna
    FiltrPozycji=" firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"'"
    FiltrPozycji+=" AND data='"+Data+"' AND artykul_id='"+Artykul+"'"
     
    # sprawdzenie istnienia spisu z natury (jeli nie to ok i wychodzimy)
    # i czy jest otwarty (jeli nie to wychodzimy z bdem)
    SQL="SELECT stan FROM rs_inwentaryzacja WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"' AND data='"+Data+"'"
    stat,DSpis,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania danych ze spisu : '+stat
    if len(DSpis)==0:
        return 'OK'
    if DSpis[0][0]<>'W':
        return 'Podany spis z natury nie jest otwarty'
    
    # sprawdzenie czy artyku pasuje do kategorii spisu (jeli nie to ok i wychodzimy)
    if Kategoria.strip()<>'':
        SQL="SELECT kateg_artykulu FROM rs_artykuly WHERE  firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return 'Bdy pobierania danych artykuu : '+stat
        if len(DArt)==0:
            return 'Podano bdny symbol artykuu :'+Artykul
        
        #ma si tak zaczyna
        if DArt[0][0].strip().find(Kategoria.strip())<>0: 
            return 'OK'
    
    # sprawdzamy czy pozycja z tym artykuem istnieje na spisie
    SQL="SELECT artykul_id FROM rs_inwentaryzacja_pozycje WHERE "+FiltrPozycji+";"
    stat,DPoz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return 'Bdy pobierania pozycji spisu z natury : '+stat

    if len(DPoz)==0:
        # jeli nie to wstawiamy pozycj do spisu z natury 
        SQL="INSERT INTO rs_inwentaryzacja_pozycje (firma_id,magazyn_id,kateg_artykulu,data,artykul_id)"
        SQL+=" VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Kategoria+"','"+Data+"','"+Artykul+"');"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            return 'Bdy wstawiania pozycji do spisu z natury : '+stat
    else:
        # jeli tak to usuwamy istniejce dane z AP
        SQL="DELETE FROM rs_inwentaryzacja_pozycje_przyjecia WHERE "+FiltrPozycji+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            return 'Bdy usuwania pozycji przyj ze spisu z natury : '+stat
    #AB 16.10.18r
    # sprawdzamy czy magazyn zawiera lokacje
    #JR 26.06.20r
    # i czy jest detaliczny
    SQL = "SELECT czy_lokacje, detaliczny FROM rs_magazyny WHERE firma_id='{}' AND magazyn_id='{}';".format(self.firma_id, Magazyn)
    stat, MLok, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return 'Bdy pobierania danych magazynu : ' + stat
    lokacje = MLok[0][0]
    detaliczny = MLok[0][1]

    # pobranie listy przyj do wstawienia
    #AB 16.10.18r
    if lokacje:
        SQL = """SELECT a.data, a.dokument_id, a.numer, a.nr_poz, a.nr_ppoz, cena1, termin_przyd, COALESCE(nr_serii, ''), COALESCE(cecha1_wartosc, ''), ilosc1, ilosc2, lokacja_id, p.nr_palety_id
FROM rs_artykuly_przyjecia a
  JOIN rs_dokumenty_magazynowe_pozycje_palety p 
        ON (a.firma_id = p.firma_id AND a.magazyn_id = p.magazyn_id AND a.data = p.DATA AND a.dokument_id = p.dokument_id 
        AND a.numer = p.numer AND a.nr_poz = p.nr_poz AND a.nr_ppoz = p.nr_ppoz)
WHERE a.firma_id = '{firma}' AND a.magazyn_id = '{magazyn}' AND a.artykul_id = '{artykul}' AND ilosc1>0 AND NOT wirtualne
ORDER BY a.data, a.numer, a.nr_poz, a.nr_ppoz;""".format(firma=self.firma_id, magazyn=Magazyn, artykul=Artykul)
    else:
        SQL="SELECT data,dokument_id,numer,nr_poz,nr_ppoz,cena1,termin_przyd,COALESCE(nr_serii,''),"
        SQL+="COALESCE(cecha1_wartosc,''),ilosc1,ilosc2 FROM rs_artykuly_przyjecia WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND magazyn_id='"+Magazyn+"' AND artykul_id='"+Artykul+"' AND ilosc1>0 AND NOT wirtualne"
        SQL+=" ORDER BY data,numer,nr_poz,nr_ppoz;"
    stat,DaneAP,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bd pobierania pozycji z artykuw przyj : '+stat   
    
    # wstawienie nowych danych z AP        
    i=1
    Ins=''
    for poz in DaneAP:
        TerminPrzyd=str(poz[6])
        if TerminPrzyd in ('-  -',None,'None'):
            TerminPrzyd='NULL'
        else:
            TerminPrzyd="'"+TerminPrzyd+"'"
                    
        Ins+="INSERT INTO rs_inwentaryzacja_pozycje_przyjecia "
        Ins+=" (firma_id, magazyn_id, kateg_artykulu, data, artykul_id, lp,"
        Ins+=" ap_data, ap_dokument_id, ap_numer, ap_nr_poz, ap_nr_ppoz,"
        Ins+=" cena1, termin_przyd,nr_serii, cecha1_wartosc,"
        #AB 16.10.18r
        if lokacje:
            Ins+=" ilosc1, ilosc2, ilosc_ks1, ilosc_ks2, lokacja_id, nr_palety_id)"
        else:
            Ins+=" ilosc1, ilosc2, ilosc_ks1,ilosc_ks2)"
        Ins+=" VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Kategoria+"','"+Data+"','"+Artykul+"',"+str(i)+","
        Ins+=" '"+str(poz[0])+"','"+str(poz[1])+"',"+str(poz[2])+","+str(poz[3])+","+str(poz[4])+","
        Ins+=str(poz[5])+","+TerminPrzyd+",'"+str(poz[7])+"','"+str(poz[8])+"',"
        #AB 16.10.18r
        if lokacje:
            Ins+=" 0,0,"+str(poz[9])+","+str(poz[10])+",'"+str(poz[11])+"','"+str(poz[12])+"');"
        else:
            Ins+=" 0,0,"+str(poz[9])+","+str(poz[10])+");"
        i+=1
    
    if Ins<>'':    
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        if stat<>"OK":
            return 'Bd wstawiania pozycji do listy przyj spisu z natury : '+stat   

    if not detaliczny:
        # pobranie sum z pozycji artykuw przyjcia spisu z natury
        SQL="SELECT COALESCE(SUM(ilosc_ks1),0),COALESCE(SUM(ilosc_ks2),0), COUNT(*)"
        SQL+=" FROM rs_inwentaryzacja_pozycje_przyjecia WHERE "+FiltrPozycji+";"
        stat,DSumy,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat != "OK":
            return 'Bd pobierania sum z pozycji z artykuw przyj spisu : '+stat
    else:
        # pobranie ilosci z artykuly-magazyny - moga byc ujemne
        SQL = "SELECT COALESCE(ilosc1,0),COALESCE(ilosc2,0), 1"
        SQL += " FROM rs_artykuly_magazyny WHERE firma_id='" + self.firma_id +"'"
        SQL +=" AND magazyn_id='" + Magazyn + "' AND artykul_id='" + Artykul + "';"
        stat, DSumy, dump, dump = self.PolSQL.Execute(SQL,3)
        if stat != "OK":
            return 'Bd pobierania iloci z artykuw magazyny : '+stat
    if stat == 'OK':
        if len(DSumy) > 0:
            # wstawienie nowej iloci ksigowej do pozycji spisu
            SQL = "UPDATE rs_inwentaryzacja_pozycje SET ilosc_ks1="+str(DSumy[0][0])+",ilosc_ks2="+str(DSumy[0][1])
            SQL += " WHERE "+FiltrPozycji+";"
            stat, dump, dump, dump = self.PolSQL.Execute(SQL,1)
            if stat != "OK":
                return 'Bd wstawiania sum do pozycji spisu z natury : '+stat
    
    return stat

#-------------------------------------------------------------------------------
# FUNKCJA PRZYPORZDKOWUJCA ILOCI STWIERDZONE W POZYCJE ARTYKUW PRZYJ
#-------------------------------------------------------------------------------

def WstawIlosciStwierdzoneDoPozycjiArtykulowPrzyjeciaNaSpisieZNatury(self, Data, Magazyn, Kategoria, Artykul, Odwrotnie = False):
    # parametry :
    # self - zmienna przekazujca "rodowisko" funkcji
    # Data - data spisu
    # Magazyn - magazyn spisu
    # Kategoria - analizowana kategoria artykuw
    # Artykul - artyku do odwieenia
    #
    # wraca ze stat (czy jest OK) i z informacj czy konieczne jest wypenienie cen w dodanej pozycji
    
    # pomocnicza zmienna
    FiltrPozycji=" firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"'"
    FiltrPozycji+=" AND data='"+Data+"' AND artykul_id='"+Artykul+"'"
    
    # pobranie rodzaju sortowania do wstawiania danych
    stat,OrderZDanych = fs_kolejkowanie_pom.PodajOrderByDokumentuLubTekstu(self.PolSQL,self.firma_id,[Magazyn],'','ap_data',Odwrotnie)
    if stat != 'OK':
        return 'Bdy pobrania kolejkowania w magazynie',False
    
    if OrderZDanych == '':
        return 'Brak okrelonego kolejkowania w artykuach przyjecia',False
                
    # pobranie iloci stwierdzonej z pozycji spisu (jesli brak danych i nie TworzycPozycje to koniec)
    SQL="SELECT ilosc1 FROM rs_inwentaryzacja_pozycje WHERE "+FiltrPozycji+";"
    stat,DIlosc,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bd pobierania iloci stwierdzonej z pozycji spisu : '+stat,False   
    
    if len(DIlosc)==0:
            return "OK",False
    
    Ilosc=DIlosc[0][0]
    
    # usunicie ze spsiu dodanych sztucznie pozycji
    SQL="DELETE FROM rs_inwentaryzacja_pozycje_przyjecia WHERE "+FiltrPozycji+" AND ilosc_ks1=0;"
    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
    if stat<>"OK":
        return 'Bd usuwania dodanych sztucznie pozycji przyj spisu z natury : '+stat,False
    
    # wyczyszczenie aktualnych pozycji przyj spisu
    SQL="UPDATE rs_inwentaryzacja_pozycje_przyjecia SET ilosc1=0,ilosc2=0 WHERE "+FiltrPozycji+";"
    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
    if stat<>"OK":
        return 'Bd czyszczenia pozycji przyj spisu z natury : '+stat,False
    
    # pobranie pozycji ze spisu artykuu przyj w odpowiedniej kolejnoci
    SQL="SELECT lp,ilosc_ks1 FROM rs_inwentaryzacja_pozycje_przyjecia WHERE "+FiltrPozycji+" ORDER BY "+OrderZDanych
    stat,DPoz,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bd pobierania pozycji przyj spisu z natury : '+stat,False   
    
    # pobranie przelicznika artykuu
    SQL="SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,DPrzel,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bd pobierania przelicznika dla artykuu : '+stat,False   
    if len(DPrzel)==0:
        return 'Podany artyku nie istnieje',False   
    
    Przel=DPrzel[0][0]
    
    # uzupenienie tego co si da na pobranych pozycjach
    for poz in DPoz:
        Nr = poz[0]
        IloscS = min(Ilosc,poz[1])
        if IloscS > 0:
            SQL="UPDATE rs_inwentaryzacja_pozycje_przyjecia SET ilosc1="+str(IloscS)
            SQL+=",ilosc2="+str(rsglobal.RSRound(IloscS*Przel,4))
            SQL+=" WHERE "+FiltrPozycji+" AND lp="+str(Nr)+";"
            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            if stat != "OK":
                return 'Bd wstawienia iloci stwierdzonych na pozycje przyj spisu z natury : '+stat,False
            
            Ilosc = Ilosc - IloscS
    
    # jeli jest nadwyka to :
    if Ilosc>0:
        # pobieramy ostatni cen na magazynie
        SQL="SELECT cena1 FROM rs_artykuly_przyjecia WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND magazyn_id='"+Magazyn+"' AND artykul_id='"+Artykul+"'"
        SQL+=" ORDER BY data DESC,numer DESC LIMIT 1;"
        stat,DCena,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>"OK":
            return 'Bd pobierania ceny dla artykuu : '+stat,False   
    
        if len(DCena) == 0:
            Cena = 0
        else:
            Cena = DCena[0][0]

        if Cena == 0:     #JR 2020-05-25 (11985)
            # sprawdzamy czy magazyn detaliczny, jeli tak pobieramy ostatnia cene z artykulow
            SQL = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='" + self.firma_id + "'"
            SQL += " AND magazyn_id='" + Magazyn + "';"
            stat, DCena, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != "OK":
                return 'Bd sprawdzania czy magazyn detaliczny : ' + stat, False
            if DCena[0][0]:
                SQL = "SELECT ost_cena1 FROM rs_artykuly "
                SQL += " WHERE firma_id='" + self.firma_id + "' "
                SQL += " AND artykul_id='" + Artykul + "';"
                stat, DCena, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    return 'Bd pobrania cen z artykuw: ' + stat, False
                if len(DCena) > 0:
                    Cena = DCena[0][0]

        # wstawiamy pozycj
        SQL+="SELECT COALESCE(MAX(lp),0) FROM rs_inwentaryzacja_pozycje_przyjecia "
        SQL+=" WHERE "+FiltrPozycji+";"
        stat,DLp,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>"OK":
            return 'Bd pobierania lp z przyj spisu z natury : '+stat,False   
    
        lp=str(DLp[0][0]+1)
        
        SQL="INSERT INTO rs_inwentaryzacja_pozycje_przyjecia "
        SQL+="(firma_id, magazyn_id, kateg_artykulu, data, artykul_id, lp,"
        SQL+=" cena1, ilosc1, ilosc2,nr_serii,cecha1_wartosc) VALUES "
        SQL+=" ('"+self.firma_id+"','"+Magazyn+"','"+Kategoria+"','"+Data+"','"+Artykul+"',"+lp+","
        SQL+=str(Cena)+","+str(Ilosc)+","+str(rsglobal.RSRound(Ilosc*Przel,4))+",'','')"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>"OK":
            return 'Bd wstawiania pozycji przyj spisu z natury : '+stat,False        
        
        # jeli cena rwna 0 to przekazujemy to dalej
        return 'OK',Cena==0
    
    return 'OK',False

#-------------------------------------------------------------------------------
# FUNKCJA ZMIENIAJCA ILOCI STWIERDZONE W NAGWKOWEJ CZʦCI NA PODSTAWIE ARTYKUW PRZYJ
#-------------------------------------------------------------------------------

def WstawIloscStwierdzonaDoPozycjiArtykuluNaSpisieZNatury(self, Data, Magazyn, Kategoria, Artykul):
    # parametry :
    # self - zmienna przekazujca "rodowisko" funkcji
    # Data - data spisu
    # Magazyn - magazyn spisu 
    # Kategoria - analizowana kategoria artykuw 
    # Artykul - artyku do odwieenia 
    #
    # wraca ze stat (czy jest OK) 

    # pomocnicza zmienna
    FiltrPozycji=" firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"'"
    FiltrPozycji+=" AND data='"+Data+"' AND artykul_id='"+Artykul+"'"

    # pobranie sumy iloci stwierdzonej z pozycji spisu
    SQL="SELECT COALESCE(SUM(ilosc1),0),COALESCE(SUM(ilosc2),0)"
    SQL+=" FROM rs_inwentaryzacja_pozycje_przyjecia WHERE "+FiltrPozycji+";"
    stat,DSumy,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat!="OK":
        return 'Bd pobierania sum z pozycji z artykuw przyj spisu : '+stat

    # wstawienie nowej iloci stwierdzonej do pozycji spisu
    SQL="UPDATE rs_inwentaryzacja_pozycje SET ilosc1="+str(DSumy[0][0])+",ilosc2="+str(DSumy[0][1])
    SQL+=" WHERE "+FiltrPozycji+";"
    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
    if stat!="OK":
        return 'Bd wstawiania sum do pozycji spisu z natury : '+stat

    return 'OK'

#-------------------------------------------------------------------------------
# FUNKCJA PODAJCA DLA PODANYCH PARAMETRW ISTNIEJEJCY OTWARTY SPIS Z NATURY
#-------------------------------------------------------------------------------

def PodajDatyIKategorieSpisow(self,Magazyn,DataDM,Artykul):
    # parametry :
    # self - zmienna przekazujca "rodowisko" funkcji
    # Magazyn - magazyn dokumentu 
    # Data - data dokumentu
    # Artykul - artyku do odnalezienia 
    #
    # wraca ze stat (czy jest OK) oraz list [Data,Kategoria] spisu z natury
    
    LSpisy=[]
    
    # pobieramy kategori artykuu
    SQL="SELECT kateg_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bd pobierania kategorii z artykuu : '+stat   
    
    # sprawdzamy istnienie odpowiedniego otwartego spisu z natury
    SQL="SELECT data,kateg_artykulu FROM rs_inwentaryzacja WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND magazyn_id='"+Magazyn+"' AND data>='"+DataDM+"' AND stan='W'"
    stat,DSpis,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bd pobierania danych spisu : '+stat   
    
    # przeszukujemy wyniki szukajc pasujcych
    
    for spis in DSpis:
        if spis[1]=='' or DArt[0][0].strip().find(spis[1].strip())==0:
            LSpisy.append([spis[0],spis[1]])
        
    return 'OK',LSpisy

#-------------------------------------------------------------------------------
# FUNKCJA TWORZCA DOKUMENT PODCZAS ZAMYKANIA SPISU Z NATURY
#-------------------------------------------------------------------------------


def UtworzDokumentPodczasZamykaniaSpisuZNatury(self, Data, Magazyn, Kategoria, Dok, Kontrahent, KontoKosztow, Typ):
    # parametry :
    # self - zmienna przekazujca "rodowisko" funkcji
    # Magazyn - magazyn dokumentu 
    # Data - data dokumentu
    # Dok - dokument, ktry ma zosta stworzony
    # Kontrahent - kontrahent do umieszczenia na dokumencie
    # KontoKosztow - konto kosztw do umieszczenia na dokumencie
    # Typ (P,W) - przychodowy albo rozchodowy
    #
    # wraca ze stat (czy jest OK) 
    DPoz = []
    if Typ == 'W':
        OpisTypu='rozchodowy'
        OpisTypuJ='rozchodowego'
        ZnakPoz='>'
        PoleMag='magazyn_skad'
    else:
        OpisTypu='przychodowy'
        OpisTypuJ='przychodowego'
        ZnakPoz='<'
        PoleMag='magazyn_dokad'

    # sprawdzamy czy magazyn detaliczny, jeli tak to uwzgledniamy ilosci ujemne bez orzyjec
    SQL = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='" + self.firma_id + "'"
    SQL += " AND magazyn_id='" + Magazyn + "';"
    stat, Detal, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != "OK":
        return 'Bd sprawdzania czy magazyn detaliczny : ' + stat, False
    detaliczny = Detal[0][0]

    #AB 08.07.20r usuniete and Typ = 'P'
    if detaliczny:
        #JR 2020-06-25
        # pobranie pozycji do wstawienia, szukanie ceny w artykulach jesli nie ma w magazynie
        SQL  = "SELECT artykul_id,magazyn_id,'','',0,0,0," # 0 - 6
        SQL += " ABS(ilosc_ks1-ilosc1),ABS(ilosc_ks2-ilosc2), rsf_podaj_ostatnia_cene_n1_w_mag_firmie(firma_id,artykul_id,magazyn_id),"
        SQL += " '','','' "  # 7 -12
        SQL += ",'', '' " #  13-14
        SQL += " FROM rs_inwentaryzacja_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        SQL += " AND kateg_artykulu='"+Kategoria+"' AND data='"+Data+"' AND ilosc_ks1-ilosc1"+ZnakPoz+"0"
        stat, DPoz, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            return 'Bdy pobierania danych na pozycje dokumentu (detal)'+OpisTypuJ+' : '+stat
        if Typ == 'P':
            # sprawdzenie zerowych cen dla pozycji
            BezCen = ''
            for w in DPoz:
                if w[9] == 0:
                    # moze jest w przyjeciach?
                    SQL = "SELECT cena1 FROM rs_inwentaryzacja_pozycje_przyjecia"
                    SQL += " WHERE firma_id='" + self.firma_id + "' AND magazyn_id='" + Magazyn + "'"
                    SQL += " AND kateg_artykulu='" + Kategoria + "' AND data='" + Data + "' AND artykul_id='" + w[0] + "';"
                    stat, DCena, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':
                        return 'Bdy pobierania danych na pozycje dokumentu (detal - przyjcia)' + OpisTypuJ + ' : ' + stat
                    if len(DCena) > 0:
                        if DCena[0][0] > 0:
                            w[9] = DCena[0][0]
                        else:
                            BezCen += w[0] + ','
            if BezCen != '':
                return 'Uzupenij ceny dla artykuw: ' + BezCen[:-1] + '.'
    else:
        # pobranie pozycji do wstawienia
        SQL  = "SELECT artykul_id,magazyn_id,ap_data,ap_dokument_id,ap_numer,ap_nr_poz,ap_nr_ppoz," # 0 - 6
        SQL+=" ABS(ilosc_ks1-ilosc1),ABS(ilosc_ks2-ilosc2), cena1,COALESCE(termin_przyd::TEXT,''),COALESCE(nr_serii,''),COALESCE(cecha1_wartosc,'') "  # 7 -12
        #AB 23.10.18r
        SQL+=",COALESCE(lokacja_id,''), COALESCE(nr_palety_id,'') " #  13-14
        SQL += " FROM rs_inwentaryzacja_pozycje_przyjecia WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        SQL += " AND kateg_artykulu='"+Kategoria+"' AND data='"+Data+"' AND ilosc_ks1-ilosc1"+ZnakPoz+"0"
        stat, DPoz, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            return 'Bdy pobierania danych na pozycje dokumentu '+OpisTypuJ+' : '+stat

    if len(DPoz) == 0:
        return "OK"
    
    # sprawdzenie poprawnoci dokumentu 
    SQL="SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dok+"'"
    stat, DTest, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return 'Bdy pobierania danych o dokumencie '+Dok+' : '+stat
    
    if len(DTest) == 0 :
        return 'Podano bdny kod dokumentu '+OpisTypuJ+' : '+Dok
    
    if DTest[0][0]<>Typ:
        return 'Jako typ dokumentu '+OpisTypuJ+' naley poda typ o rodzaju "'+Typ+'"'

    # sprawdzenie uprawnie do dokumentu 
    if self.operator_id != '0':
        SQL="SELECT wprowadzanie FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        SQL+=" AND dokument_id='"+Dok+"' AND operator_id IN "+self.operatorzy+" AND wprowadzanie;"
        stat,DTestUpr,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
             return 'Bdy sprawdzania uprawnie do dokumentu '+OpisTypuJ
        
        if len(DTestUpr)==0:
            return 'Brak uprawnie do dodawania dokumentw'
            
    # pobranie domylnych parametrw w magazynie
    SParam = {}
    SParam['wersja'] = ''
    SParam['kontrahent_id'] = ''
        
    stat,SParam = fs_magazyny_parametry_dokumentow_pom.UzupelnijDomyslneParametryDlaDokumentu(self,Magazyn,Dok,SParam)
    if stat != 'OK':
        return 'Bdy pobierania domylnych parametrw dokumentu '+OpisTypuJ+' : '+stat
                
    Wersja = SParam['wersja']
    if Kontrahent=='':
        Kontrahent = SParam['kontrahent_id']
            
    if Wersja in ('','NULL'):
        Wersja = 'NULL'
    else:
        Wersja = "'"+Wersja+"'"
        
    if Kontrahent in ('','NULL'):
        Kontrahent = 'NULL'
    else:
        Kontrahent = "'"+Kontrahent+"'"
    
    if KontoKosztow in ('','NULL'):
        KontoKosztow = 'NULL'
    else:
        KontoKosztow = "'"+KontoKosztow+"'"
            
    # pobranie numeracji dokumentu
    stat,DTest,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Dok+"\\\',\\\'"+Data+"\\\']','M');",3)            
    if stat != 'OK':
        return ' Bdy sprawdzania czy mona doda dokument '+OpisTypu+' : '+stat
    
    if DTest[0][0] != 'OK':
        return DTest[0][0]
        
    stat,DNumer,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+Magazyn+"\\\',\\\'"+Dok+"\\\',\\\'"+Data+"\\\']','M');",3)        
    if stat != 'OK':
        return ' Bdy pobierania numeru dokumentu '+OpisTypuJ+' : '+stat
    
    if DNumer[0][0] in (None,'None',''):
        return ' Bdy pobierania numeru dokumentu '+OpisTypuJ

    # wstawienie nagwka
    Nr= str(DNumer[0][0])
    InsN ="INSERT INTO rs_dokumenty_magazynowe"
    InsN+=" (firma_id,magazyn_id,dokument_id,data,numer,stan,"+PoleMag+","
    InsN+="  kontrahent_id,wersja, konto_kosztow) "
    InsN+=" VALUES"
    InsN+=" ('"+self.firma_id+"','"+Magazyn+"','"+Dok+"','"+Data+"',"+Nr+",'W','"+Magazyn+"',"
    InsN+="  "+Kontrahent+","+Wersja+","+KontoKosztow+");"
        
    # wstawienie pozycji
    InsP=''
    #AB 23.10.18r
    INSPAL = ''
    Lp=1
    for poz in DPoz:
        #AB 23.10.18r
        pal = rsglobal.Dekoduj(poz[14])
        lok = rsglobal.Dekoduj(poz[13])
        if Typ=='W':
            KluczAP=  self.firma_id+rsglobal.Dekoduj(poz[1])+rsglobal.Dekoduj(poz[3])+rsglobal.Dekoduj(poz[2])  # firma,magazyn,dokument,data,
            KluczAP+= rsglobal.UsunKropkaZero(poz[4]).zfill(4)+rsglobal.UsunKropkaZero(poz[5]).zfill(4)        # numer, nr_poz
            KluczAP+= rsglobal.UsunKropkaZero(poz[6]).zfill(4)
        else:
            KluczAP=''
            Przelicznik="(SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+rsglobal.Dekoduj(poz[0])+"')"
            CechaOpis="(SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+rsglobal.Dekoduj(poz[0])+"')"
            Cena1=str(poz[9])
            Cena2="ROUND("+Cena1+"/"+Przelicznik+",2)"
            TerminPrzyd=poz[10]
            if TerminPrzyd == '':
                TerminPrzyd='NULL'
            else:
                TerminPrzyd="'"+TerminPrzyd+"'"

        InsP += "INSERT INTO rs_dokumenty_magazynowe_pozycje "
        InsP += "(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
        InsP += " artykul_id,ilosc1,ilosc2,dokument_przych " 
        if Typ == 'P':
            InsP+=",cena1,cena2,cena_wal1,cena_wal2,termin_przyd,nr_serii,cecha1_opis,cecha1_wartosc "
    #AB 23.10.18r
        if lok.strip() not in ('', None):
            if Typ == 'P':
                InsP += ", lokacja_dokad "
            else:
                InsP += ", lokacja_skad "
        InsP += " ) VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Dok+"','"+Data+"',"+Nr+","+str(Lp)+",0,'"
        InsP += rsglobal.Dekoduj(poz[0])+"',"+str(poz[7])+","+str(poz[8])+",'"+KluczAP+"'"
        if Typ == 'P':
            InsP+=","+Cena1+","+Cena2+","+Cena1+","+Cena2+","+TerminPrzyd+",'"+rsglobal.Dekoduj(poz[11])+"',"+CechaOpis+",'"+rsglobal.Dekoduj(poz[12])+"'"
    #AB 23.10.18r
        if lok.strip() not in ('', None):
            InsP += ", '" + lok + "'"
        InsP += ");"

        #AB 23.10.18r
        if pal not in ('', None):

            INSPAL += """INSERT INTO rs_dokumenty_magazynowe_pozycje_palety
                    (firma_id, magazyn_id, dokument_id, "data", numer, nr_poz, nr_ppoz, nr_palety_id)
                VALUES('{}',      '{}',       '{}',      '{}',   {},     {},      0,       '{}');
      """.format(self.firma_id, Magazyn,       Dok,      Data,   Nr,     Lp,               pal)

        Lp += 1

                                                        #AB 23.10.18r
    stat,dump,dump,dump = self.PolSQL.Execute(InsN+InsP +'\n' + INSPAL, 1)
    if stat<>'OK':
        return 'Bdy tworzenia dokumentu magazynowego : '+stat
        
    # zamknicie dokumentu z W na G
    Klucze={}     
    Klucze['Mag'] = Magazyn
    Klucze['Typ'] = Dok
    Klucze['Data'] = Data
    Klucze['Numer'] = Nr
    Klucze['Funkcja'] = 18

    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [],False)
    if stat<>'OK':
        rsglobal.ZapiszDoLogow(str(Klucze), 5)
        return 'Bd zamknicia dokumentu '+OpisTypuJ+' z W na G : '+stat
    
    # zamknicie dokumentu z G na Z
    Klucze['Funkcja'] = 29
    stat, dump, dump, dump = self.WykonajFunkcje("fs_dokumenty_magazynowe", Klucze, [], [],False)
    if stat<>'OK':
        return 'Bd zamknicia dokumentu '+OpisTypuJ+' z G na Z : '+stat
    
    # zapis numeru dokumentu do nagwka spisu
    KluczDok=Magazyn+'/'+Dok+'/'+Data+'/'+Nr
    SQL="UPDATE rs_inwentaryzacja SET "
    if Typ=='W':
        SQL+="dokument_rw='"+KluczDok+"'"
    else:    
        SQL+="dokument_pw='"+KluczDok+"'"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    SQL+=" AND kateg_artykulu='"+Kategoria+"' AND data='"+Data+"';" 
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    
    return stat

#-------------------------------------------------------------------------------
# FUNKCJA TWORZCA DOKUMENT PODCZAS ZAMYKANIA SPISU Z NATURY
#-------------------------------------------------------------------------------
#AB 28.06.23r
def ZaktualizujSpisyPoZmianachNaDokumencieMagazynowym(self, Magazyn, Data, Dokument, Numer):
    SQL =  "SELECT DISTINCT artykul_id FROM rs_dokumenty_magazynowe_pozycje "
    SQL += "WHERE firma_id=%s AND magazyn_id=%s AND dokument_id=%s AND data=%s AND numer=%s;"
    args = [self.firma_id, Magazyn, Dokument, Data, Numer]
    rsglobal.ZapiszDoLogow("SQL art do zaktualizowania na spisach:")
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, artykuly, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow("Bd podczas aktualizacji spisw z natury: "+ stat)
        return "Bd podczas aktualizacji spisw z natury: "+ stat
    for art in artykuly:
        art = art[0]
        stat, LDataKat = PodajDatyIKategorieSpisow(self, Magazyn, Data, art)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow("Bd podczas aktualizacji spisw z natury2: "+ stat)
            return "Bd podczas aktualizacji spisw z natury: "+ stat
        # dla kadego pasujcego spisu
        for spis in LDataKat:
            DataSpisu = spis[0]
            KategSpisu = spis[1]
            # odwieamy przyjcia spisu dla naszego artykuu
            stat = OdswiezPozycjeArtykulowPrzyjecWSpisieZNatury(self, DataSpisu, Magazyn, KategSpisu, art)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow("Bd podczas aktualizacji spisw z natury3: " + stat)
                return "Bd podczas aktualizacji spisw z natury: " + stat
            # przeliczamy iloci stwierdzone na pozycjach spisu
            stat, dump = WstawIlosciStwierdzoneDoPozycjiArtykulowPrzyjeciaNaSpisieZNatury(self, DataSpisu, Magazyn,
                                                                                          KategSpisu, art)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow("Bd podczas aktualizacji spisw z natury4: " + stat)
                return "Bd podczas aktualizacji spisw z natury: " + stat
    return 'OK'

