# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_spis_z_natury_pozycje.py
# Purpose:     wczytuje/usuwa dane pozycji spisu z natury
# Author:      Piotr Witkowski
# Created:     2016/02/04
# RCS-ID:      $Id: fs_spis_z_natury_pozycje.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2015-12-18 Piotr Witkowski (9476) reafaktoryzacja spisu z natury + pozycje
# 2020-05-26 Jan Raburski (11985) import inwentaryzacji z kolektora
# 2020-06-20 Jan Raburski (12000) eksport pozycji do kolektora

from funkcje import fs_spis_z_natury_pom

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
    
if stat == 'OK':
    Funkcja = klucze['Funkcja']    
    SlPar = {'Data': [1, 5, 6, 10, 11], 'Mag': [1, 5, 6, 10, 11], 'Kat': [1, 5, 6, 10, 11], 'Art': [1, 6],
             'plik': [10], 'separator': [10], 'poprzecinku': [10], 'kolumnyimport': [10]} #MK 2020-05-26/27

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat='Uwaga : wywoanie funkcji fs_spis_z_natury_pozycje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat == 'OK':
        if Funkcja in [1,5,6,10,11]:   #MK 2020-05-27, JR 2020-06-20
            Data  = str(klucze['Data'])
            Mag = str(klucze['Mag'])
            Kat = str(klucze['Kat'])
        if Funkcja in [1,6]:                 
            Art = str(klucze['Art'])
        if Funkcja in [10]:
            Plik = str(klucze['plik']) #MK 2020-05-26
            Separator = str(klucze['separator'])  #JR 2020-06-20
            PoPrzecinku = klucze['poprzecinku']  #JR 2020-06-20
            KolumnyImport = klucze['kolumnyimport'].strip()  #JR 2020-06-20
if stat == 'OK' and Funkcja in [1, 6]:
    SQL = "SELECT detaliczny FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
    stat, dmag, dump, dump = self.PolSQL.Execute(SQL,3)
    if stat == 'OK' and len(dmag) == 1:
        Detaliczny = dmag[0][0]
        if self.operator_id == STANDARD_OPERATOR_ID:
            UprDodawanie = True
            UprUsuwanie  = True
            UprPozPrzyj  = True
        elif Detaliczny:
            UprDodawanie = (self.oddzial_id, '097230') in self.uprawnienia  # dodawanie
            UprUsuwanie  = (self.oddzial_id, '097240') in self.uprawnienia  # usuwanie
            UprPozPrzyj  = (self.oddzial_id, '097210') in self.uprawnienia  # przegldanie pozycji spisu z przyj
        else:
            UprDodawanie = (self.oddzial_id, '033023') in self.uprawnienia  # dodawanie
            UprUsuwanie  = (self.oddzial_id, '033024') in self.uprawnienia  # usuwanie
            UprPozPrzyj  = (self.oddzial_id, '033030') in self.uprawnienia  # przegldanie pozycji spisu z przyj
    else:
        stat = u'Bd sprawdzania danych magazynu.'


dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if not UprDodawanie:
        stat='UPR DOD'
    if stat=='OK':
        SQL = "SELECT kateg_artykulu,typ_artykulu, czy_detal or tylko_detal as handel, tylko_detal FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
        stat,dart,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            #sprawdzenie czy istnieje artyku
            if len(dart) == 0:
                stat='ART BL'

            #sprawdzenie czy kategoria artykuu pasuje do klucza
            elif not (Kat.strip() ==dart[0][0][0:len(Kat.strip())]) and (Kat.strip() <> ''):
                stat='ART BL KTG'
            elif dart[0][1] in ('31','99'):
                stat='ART BL TYP'
            elif not dart[0][2] and Detaliczny:
                stat = u'Nie mona doda artykuu {} w magazynie nie detalicznym.'.format(Art)
            elif dart[0][3] and not Detaliczny:
                stat = u'Artyku {} mona wykorzystywa jedynie w magazynie detalicznym.'.format(Art)
            else:
            #sprawdzenie czy kategoria pasuje do magazynu
                SQL = "SELECT kategoria FROM rs_magazyny_kategorie WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
                stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat=='OK' and len(wyn)>0:
                    SQL = "SELECT kategoria FROM rs_magazyny_kategorie WHERE firma_id='"+self.firma_id+"'"
                    SQL +=" AND magazyn_id='"+Mag+"' AND kategoria='"+rsglobal.Dekoduj(dart[0][0])+"';"
                    stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat=='OK' and len(wyn)==0:
                        SQL = "SELECT kategoria FROM rs_magazyny_kategorie WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';"
                        stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
                        if len(wyn)<>0:
                            stat='ART BL KAT'

        if stat=='OK':
            SQL = "SELECT artykul_id FROM rs_inwentaryzacja_pozycje WHERE firma_id='"+self.firma_id
            SQL+= "' AND artykul_id='"+Art+"' AND kateg_artykulu='"+Kat+"' AND magazyn_id='"+Mag+"' AND data='"+Data+"';"
            stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(dane)>0:
                    stat='ART WYST'
                    dane.append(stat)
            else:
                stat='Bdy sprawdzania danych'+stat
                dane.append(stat) 

        if stat=='OK':
            SQL = "INSERT INTO rs_inwentaryzacja_pozycje (firma_id,magazyn_id,kateg_artykulu,data,artykul_id,ilosc1,"
            SQL+= "ilosc2,ilosc_ks1,ilosc_ks2,recznie) VALUES ('"+self.firma_id+"','"+Mag+"','"+Kat.strip()
            SQL+= "','"+Data+"','"+Art+"',0,0,0,0,True);"
            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat = "Bd przy dodawaniu danych: "+stat

#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprUsuwanie:
        stat='UPR DEL'
    if stat =='OK':
        SQL = "SELECT recznie FROM rs_inwentaryzacja_pozycje WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
        SQL+= " AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND artykul_id='"+Art+"';"
        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd przy sprawdzeniu rcznego usuwania danych: "+stat

        if len(dane)>0 and dane[0][0]:
            SQL = "DELETE FROM rs_inwentaryzacja_pozycje WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
            SQL += " AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND artykul_id='"+Art+"';"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat = "Bd przy usuwaniu danych: "+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,5,6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,5,6]:
    SQL = "SELECT ip.artykul_id,a.nazwa,ip.ilosc1,lower(a.jm1),ip.ilosc2,lower(a.jm2),recznie,a.przelicznik "
    SQL += "FROM rs_inwentaryzacja_pozycje ip INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE ip.firma_id='"+self.firma_id+"'"
    SQL += " AND ip.magazyn_id='"+Mag+"' AND ip.kateg_artykulu='"+Kat+"' AND ip.data='"+Data+"' ORDER BY a.kateg_artykulu,a.artykul_id;"
    stat, dane, wyn1, tr = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat

#-------------------------------------------------------------------------------
#---   IMPORT POZYCJI Z KOLEKTORA (10) #JR 2020-05-26
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [10]:
    #rsglobal.ZapiszDoLogow(Plik,5)
    # import tylko do spisu bez pozycji
    # plik o strukturze: nazwa, kod (ean albo artykul_id), ilosc, reszta kolumn pomijana
    # separator w parametrach domyslnie przecinek
    # jesli poprzecinku>0 to oznacza ze w ilosci nie ma kropki dziesietnej
    # czesc dziesietna ma stala dlugosc

    SQL = "SELECT COUNT(*) "
    SQL += "FROM rs_inwentaryzacja_pozycje  WHERE firma_id='"+self.firma_id+"'"
    SQL += " AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
    stat, ile, dump, dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu liczby pozycji: "+stat
    elif ile[0][0] == 0:
        stat = "W spisie brak pozycji - import iloci niemoliwy."

    # poniewaz w spisie moze wystapic ten sam artykul z roznymi kodami ean
    # a niektore kody moga dotyczyc opakowan zbiorczych (szesciopak)
    # wiec tworzymy slownik zawierajacy artykul_id oraz ilosc1 i ilosc2
    if stat == 'OK':
        Poz = {}
        wiersze = Plik.splitlines()
        i = 0
        for wiersz in wiersze:
            i += 1
            wi = wiersz.split(Separator)
            if len(wi) < 2:
                stat = 'Nieprawidowa liczba kolumn: ' + str(len(wi)) + 'w wierszu: ' + str(i)
                break

            # zamiana / izolacja kolumn, mamy nie wiadomo co
            # chcemy miec:nazwa (lubi nic), kod, ilosc
            w = []
            if KolumnyImport.find('N') > -1:
                w.append(wi[KolumnyImport.find('N')])
            else:
                w.append('')
            if KolumnyImport.find('A') > -1:
                w.append(wi[KolumnyImport.find('A')])
            else:
                stat = 'Brak zdefiniowanej kolumny z artykul_id'
                break
            if KolumnyImport.find('I') > -1:
                w.append(wi[KolumnyImport.find('I')])
            else:
                stat = 'Brak zdefiniowanej kolumny z iloci artykuu'
                break

            # wyszukanie artykulu, najpierw po kodzie EAN, jeli brak to po artykul_id, jesli brak to ArtTymcz
            SQL = "SELECT artykul_id, przelicznik, zbiorczy, liczba_sztuk_w_opakowaniu FROM rs_artykuly_ean"
            SQL += " INNER JOIN rs_artykuly USING (firma_id, artykul_id) WHERE firma_id = '" + self.firma_id + "'"
            SQL += " AND ean='" + w[1].strip() + "';"
            stat, art, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd szukania kodu EAN ' + stat
                break
            if len(art) > 0:
                Art = art[0][0].strip()
                Przelicznik = art[0][1]
                Zbiorczy = art[0][2]
                if not Zbiorczy:
                    LiczbaSztuk = 1
                else:
                    LiczbaSztuk = art[0][3]
            else:
                SQL = "SELECT artykul_id, przelicznik FROM rs_artykuly"
                SQL += " WHERE firma_id = '" + self.firma_id + "'"
                SQL += " AND artykul_id='" + w[1].strip() + "';"
                stat, art, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = 'Bd szukania artykuu ' + stat
                    break
                if len(art) > 0:
                    Art = art[0][0].strip()
                    Przelicznik = art[0][1]
                    Zbiorczy = False
                    LiczbaSztuk = 1
                else:
                    stat = 'Brak artykuu dla kodu: ' + w[1].strip() + ". Wiersz: " + str(i) + "."
                    break

            # dodanie ilosci do slownika
            Ilosc = w[2].strip()
            if Ilosc != '':
                if PoPrzecinku > 0:
                    # bez przecinka, stala liczna miejsc dziesietnych
                    if len(Ilosc) < PoPrzecinku:
                        stat = 'Liczba znakw w iloci mniejsza ni liczba miejsc po przecinku. Wiersz: ' + str(i)
                        break
                    Ilosc = Ilosc[:-PoPrzecinku] + '.' + Ilosc[-PoPrzecinku:]
                try:
                    Ilosc = float(Ilosc)
                except:
                    stat = 'Bdna ilo: ' + str(Ilosc)+'. Wiersz:' + str(i)
                    break

                if Poz.has_key(Art):
                    Poz[Art][0] += rsglobal.RSRound(Ilosc * LiczbaSztuk,3)
                    Poz[Art][1] += rsglobal.RSRound(Ilosc * Przelicznik * LiczbaSztuk, 3)
                else:
                    Poz[Art] = [rsglobal.RSRound(Ilosc * LiczbaSztuk,3), rsglobal.RSRound(Ilosc * Przelicznik * LiczbaSztuk, 3)]

    # pobranie wierszy spisu w celu ich aktualizacji
    if stat =='OK':
        SQL = "SELECT artykul_id FROM rs_inwentaryzacja_pozycje"
        SQL+= " WHERE firma_id='"+self.firma_id+"'"
        SQL+= " AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
        stat,pozycje,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych z pozycji spisu: "+stat

    Zaimportowane = 0
    if stat == 'OK':
        # update na ilosci pozycji
        for w in pozycje:
            Art = w[0].strip()
            if Poz.has_key(Art):
                Zaimportowane += 1
                UPDPOZ = "UPDATE rs_inwentaryzacja_pozycje SET ilosc1=ilosc1+ " + str(Poz[Art][0]) + ", ilosc2=ilosc2+ " + str(Poz[Art][1])
                UPDPOZ += " WHERE firma_id='"+self.firma_id+"' AND artykul_id='" + Art + "'"
                UPDPOZ += " AND magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"';"
                del Poz[Art]   # usuniecie obsluzonych, co zostanie to do wstawienia
                stat, dump, dump, dump = self.PolSQL.Execute(UPDPOZ, 1)
                if stat != 'OK':
                    stat = "Bd aktualizacji pozycji spisu: " + stat
                    break
                # przeliczenie ilosci na przyjeciach pozycji spisu z natury
                stat, wyn2 = fs_spis_z_natury_pom.WstawIlosciStwierdzoneDoPozycjiArtykulowPrzyjeciaNaSpisieZNatury(self, Data, Mag, Kat, Art, False)
                if stat != 'OK':
                    stat = "Bd aktualizacji pozycji przyj spisu: " + stat
                    break

        if stat == 'OK':
            # wstawienie pozycji ktorych nie bylo w spisie
            lista = Poz.keys()
            for w in lista:
                if Poz[w][0] == 0:   # nie wstawiamy pozycji zerowych
                    continue
                Zaimportowane += 1
                INSPOZ = "INSERT INTO rs_inwentaryzacja_pozycje (firma_id, magazyn_id, kateg_artykulu,"
                INSPOZ += " data, artykul_id, ilosc1, ilosc2, recznie) VALUES ("
                INSPOZ += "'" + self.firma_id + "','" + Mag + "','" + Kat + "',"
                INSPOZ += "'" + Data + "','" + w.strip() + "'," + str(Poz[w][0]) + "," + str(Poz[w][1])
                INSPOZ += ", TRUE);"
                stat, dump, dump, dump = self.PolSQL.Execute(INSPOZ, 1)
                if stat != 'OK':
                    stat = "Bd wstawiania pozycji spisu: " + stat
                    break
                # przeliczenie ilosci na przyjeciach pozycji spisu z natury
                stat,wyn2=fs_spis_z_natury_pom.WstawIlosciStwierdzoneDoPozycjiArtykulowPrzyjeciaNaSpisieZNatury(self, Data, Mag, Kat, w.strip(), False)
                if stat != 'OK':
                    stat = "Bd aktualizacji pozycji przyj spisu: " + stat
                    break
    if stat == 'OK':
        dane = [[Zaimportowane]]


#-------------------------------------------------------------------------------
#---   EKSPORT POZYCJI DLA KOLEKTORA (10) #JR 2020-06-20
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [11]:
    # pobranie danych do eksportu pliku do kolektora
    SQL = "SELECT ip.artykul_id, ar.nazwa, COALESCE(ae.ean,''), COALESCE(am.ost_cena1,0), COALESCE(ip.ilosc_ks1,0) FROM rs_inwentaryzacja_pozycje ip"
    SQL += " INNER JOIN rs_artykuly ar USING (firma_id,artykul_id) "
    SQL += " LEFT OUTER JOIN rs_artykuly_magazyny am USING (firma_id,artykul_id,magazyn_id) "
    SQL += " LEFT OUTER JOIN rs_artykuly_ean ae USING (firma_id,artykul_id) "
    SQL += " WHERE ip.firma_id='"+self.firma_id+"'"
    SQL += " AND ip.magazyn_id='"+Mag+"' AND ip.kateg_artykulu='"+Kat+"' AND ip.data='"+Data+"' ORDER BY ip.artykul_id;"
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat != "OK":
        stat = "Bd pobierania danych: " + stat
        dane.append(stat)
