# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_sprawdz_analityke.py
# Purpose:     Sprawdza, czy w rs_dowody_ksiegowe_pozycje wystepuje konto analityczne
#              zdefiniowane w rs_grupy_analitycze.
#
# Author:      Mariusz Rajfura
# Created:     2009/08/07
# RCS-ID:      $Id: fs_sprawdz_analityke.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def CzyMoznaUsunac(obj, TypKontaAnal, KontoAnal, GrupaAnal=''):
    TypKontaAnal = TypKontaAnal.strip().lower()
    KontoAnal = KontoAnal.strip()
    GrupaAnal = GrupaAnal.strip()
    stat = 'OK'
    okresy = []
    grupy = []
    konta = []
    dowody = []
    OKRESY = {}
    Robic = False
    
    #dowody ksiegowe musimy pobierac z okresem_id, bo kazdy okres ma wlasne ustawienia grup analitycznych
    SQL ="SELECT DISTINCT konto_wn, konto_ma, konto_vat_wn,konto_vat_ma,okres_id"
    SQL+=" FROM rs_dowody_ksiegowe_pozycje"
    SQL+=" WHERE firma_id = '"+obj.firma_id+"' AND ("
    
    sql ="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+obj.firma_id+"';"
    stat,okresy,dump,dump = obj.PolSQL.Execute(sql,2)
    
    if stat <> 'OK':
        stat = 'Bd listy okresw ksigowych : '+stat

    if stat == 'OK' and len(okresy) > 0:
        liczokr = 0
        for okres in okresy:
            grupy = []
            konta = []
            
            sql = "SELECT grupa_id FROM rs_grupy_analityczne"
            sql+=" WHERE firma_id='"+obj.firma_id+"' AND okres_id = '"+str(okres[0])+"' AND"
            
            GrupySql = ''
            sqlgrup = ''
            
            if TypKontaAnal == 'rs_konta_analityczne':
                #w przypadku konta z listy grupe mamy juz podana (bo i tak musimy wiedziec, z ktorej grupy)
                #okres jest tez tylko jeden - biezacy i musi by prawidlowo wybrany
                #bo dostep do tej funkcji jest tylko z Ksiegowosci, a ta wymaga poprawnego okresu
                
                if okres[0] == obj.okres_id:
                    grupy = [[GrupaAnal]]
                    GrupySql = "('"+GrupaAnal+"')"
                
            elif TypKontaAnal == 'rs_kontrahenci':
                sqlgrup = "kontrahenci"
                
            elif TypKontaAnal == 'rs_pracownicy':
                sqlgrup = "pracownicy"
                
            elif TypKontaAnal == 'rs_numery_zlecen':
                sqlgrup = "zlecenia"
                
            elif TypKontaAnal == 'rs_konta_kosztow':
                sqlgrup = "konta_kosztow"
            
            elif TypKontaAnal == 'rs_magazyny':
                sqlgrup = "magazyny"
            
            elif TypKontaAnal == 'rs_oddzialy':
                sqlgrup = "oddzialy"
                
            elif TypKontaAnal == 'rs_stawki_vat':
                sqlgrup = "stawki_vat"
            
            elif TypKontaAnal == 'rs_dzialy_firmy':
                sqlgrup = "dzialy_firmy"
            
            elif TypKontaAnal == 'rs_projekty':
                sqlgrup = "projekty"
                
            else:
                stat = 'Bdna funkcja '+TypKontaAnal
            
            #jesli TypKontaAnal jest poprawny i musimy zapytac o liste grup
            if stat == 'OK' and sqlgrup <> '':
                sql += " " + sqlgrup + " = True ;"
                
                stat,grupy,dump,dump = obj.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    stat = 'Bd pobrania grup analitycznych : '+stat
                    
            #jesli mamy lub dostalismy z LISTY jakies grupy
            #tworzymy zapytanie o liste kont zawierajaca szukane grupy
            
            if stat == 'OK' and len(grupy) > 0:
                GrupySql = "("
                liczgrup = 0
                for g in grupy:
                    liczgrup += 1
                    if liczgrup > 1:
                        GrupySql += ","
                    GrupySql += "'"+str(g[0])+"'"
                GrupySql += ")"
                       
                #pobieramy konta, ktore maja interesujace nas grupy
                sql ="SELECT kontos_id,konto_id,grupa1,grupa2,grupa3,grupa4,grupa5"
                sql+=" FROM rs_plan_kont"
                sql+=" WHERE firma_id = '"+obj.firma_id+"' AND okres_id = '"+str(okres[0])+"'"
                sql+=" AND (" 
                sql+=" grupa1 IN "+GrupySql+" OR"
                sql+=" grupa2 IN "+GrupySql+" OR"
                sql+=" grupa3 IN "+GrupySql+" OR"
                sql+=" grupa4 IN "+GrupySql+" OR"
                sql+=" grupa5 IN "+GrupySql+");"
                
                stat,konta,dump,dump = obj.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    stat = 'Bd pobrania grup analitycznych z planu kont : '+stat
                
            #jesli dostalismy liste kont z szukanymi grupami,
            #to robimy zapytanie, ktore pobierze wszystkie pozycje dowodow
            #zawierajace wybrane konta
            
            #zachowamy w slowniku OKRESY zachowamy szukanych liste grup i liste kont, ktore zawieraly te grupy
            #konta na ktorych
            #slownik OKRESY wykorzystany przgladajac dowody
            
            OKRESY[okres[0]] = (grupy, konta)
            
            if stat == 'OK' and len(grupy) > 0 and len(konta) > 0:
                Robic = True
                liczokr += 1
                
                if liczokr > 1:
                    SQL+=" OR"
                    
                SQL+=" (okres_id = '"+str(okres[0])+"' AND ("
                
                liczkont = 0
                for k in konta:
                    liczkont += 1
                    konto = k[0]
                    if k[1] <> '':
                        konto+='-'+k[1]
                    if liczkont > 1:
                        SQL+=" OR "
                    
                    #byc moze zamiast LIKE uzyc SUBSTRING lub POSITION
                    #by bylo szybciej, to moga pokazac testy na duzej bazie
                    #mariusz
                    
                    SQL+=" konto_wn LIKE '"+str(konto)+"-%' OR"
                    SQL+=" konto_ma LIKE '"+str(konto)+"-%' OR"
                    SQL+=" konto_vat_wn LIKE '"+str(konto)+"-%' OR"
                    SQL+=" konto_vat_ma LIKE '"+str(konto)+"-%'"
                
                #mozna jeszcze sprawdzic, czy to ostatnia grupa analityczna
                #jesli nie, to mozna dostwic minus za KontoAnal
                # (!) do zrobienia - bedzie mniej dowodow po SELECT
                # nie przeszkadza w testowaniu funkcjonalnosci
                    
                SQL+= ") AND ("
                SQL+=" POSITION('-"+KontoAnal+"' IN konto_wn) > 0 OR"
                SQL+=" POSITION('-"+KontoAnal+"' IN konto_ma) > 0 OR"
                SQL+=" POSITION('-"+KontoAnal+"' IN konto_vat_wn) > 0 OR"
                SQL+=" POSITION('-"+KontoAnal+"' IN konto_vat_ma) > 0"
                SQL+= ")) "
    
    SQL+=");"
    
    #teraz pobieramy dowody wg zlozonego zapytania
    if stat == 'OK' and Robic:
        stat,dowody,dump,dump = obj.PolSQL.Execute(SQL,2)
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji z dowodw ksigowych : '+stat
    
    #jesli zapytanie zwrocilo jakies dowody do sprawdzenia
    #zaczynamy przeszukiwac
    
    if stat == 'OK' and len(dowody) > 0:
        for dowod in dowody:
            #na wszelki wypadek, zeby nie trafil sie EXCEPT
            if not OKRESY.has_key(dowod[4]):
                continue
        
            grupy = OKRESY[dowod[4]][0]
            konta = OKRESY[dowod[4]][1]
            
            for g in grupy:
                grupa = g[0]
            
                for k in konta:
                    konto = k[0]
                    if k[1] <> '':
                        konto+='-'+k[1]
            
                    #pozycja szukanej grupy
                    poz = 0
                    if grupa == k[2]:
                        poz = 1
                    elif grupa == k[3]:
                        poz = 2
                    elif grupa == k[4]:
                        poz = 3
                    elif grupa == k[5]:
                        poz = 4
                    elif grupa == k[6]:
                        poz = 5
                    
                    if poz == 0:
                        continue
                        #w tym koncie nie ma szukanej teraz grupy
                        #wiec go omijamy
                
                    dlug = len(konto)
                    ileminusow = konto.count('-') + poz
                
                    #konto_wn
                    if dowod[0][:dlug] == konto:
                        splitdow = dowod[0].split('-')
                        if len(splitdow) > ileminusow:
                            if splitdow[ileminusow] == KontoAnal:
                                stat = "Nie mona usun/zmieni '"+KontoAnal+"' - uyte w dow.ksig. (konto wn)"
                                break
                    
                    #konto_ma
                    if dowod[1][:dlug] == konto:
                        splitdow = dowod[1].split('-')
                        if len(splitdow) > ileminusow:
                            if splitdow[ileminusow] == KontoAnal:
                                stat = "Nie mona usun/zmieni '"+KontoAnal+"' - uyte w dow.ksig. (konto ma)"
                                break
                    
                    #konto_vat_wn        
                    if dowod[2][:dlug] == konto:
                        splitdow = dowod[2].split('-')
                        if len(splitdow) > ileminusow:
                            if splitdow[ileminusow] == KontoAnal:
                                stat = "Nie mona usun/zmieni '"+KontoAnal+"' - uyte w dow.ksig. (konto VAT wn)"
                                break
                    
                    #konto_vat_ma
                    if dowod[3][:dlug] == konto:
                        splitdow = dowod[3].split('-')
                        if len(splitdow) > ileminusow:
                            if splitdow[ileminusow] == KontoAnal:
                                stat = "Nie mona usun/zmieni '"+KontoAnal+"' - uyte w dow.ksig. (konto VAT ma)"
                                break
                    
                #jesli znaleziono pozycje dowodu z podanym kontem analitycznym
                #wyskakujemy z petli sprawdzania grup
                if stat <> 'OK':
                    break
                
            #jesli znaleziono pozycje dowodu z podanym kontem analitycznym
            #wyskakujemy z petli sprawdzania grup
            if stat <> 'OK':
                break
            
    return(stat)
