#!/usr/bin/python
# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:             fs_sprawdz_czy_aktywny_vat_pom.py
# Purpose:          funkcja pomocnicza dziki czemu mona z niej korzysta w rnych funkcjach
# Author:           Aleksander Bargie
# Created:          2018/02/12
# RCS-ID:           $Id: fs_sprawdz_czy_aktywny_vat_pom.py $
# Copyright:        (c) 2018 RecordSystem
# Licence:          GNU GPL
# -------------------------------------------------------------------------------# -------------------------------------------------------------------------------
# FUNKCJA SPRAWDZAJCA CZY NIPY NALE DO AKTYWNYCH PATNIKW VAT
# -------------------------------------------------------------------------------
import warnings


def SprAktywnychPlatnikowVAT(nip, data=None):
    import rsglobal
    import re
    # dodane by w wynikach nie byo CryptographyDeprecationWarning itd. na pythonie >=2.7.9 nie powinno by potrzebne
    warnings.filterwarnings('ignore')
    import requests
    if not rsglobal.SprNip(nip):
        return None, 'Bdny NIP: ' + nip

    if data is not None and not rsglobal.SprawdzCzyToData(data):
        return None, 'Bdna data: ' + data

    parametrDaty = ''
    if data is not None:
        sprawdz = 'SprawdzNIPNaDzien'
        parametrDaty = '<ns:Data>'+data+'</ns:Data>'
    else:
        sprawdz = 'SprawdzNIP'
    url = "https://sprawdz-status-vat.mf.gov.pl"
    headers = {'content-type': 'text/xml'}
    headers['SOAPAction'] = 'http://www.mf.gov.pl/uslugiBiznesowe/uslugiDomenowe/AP/WeryfikacjaVAT/2018/03/01/WeryfikacjaVAT/' + sprawdz
    body = """<?xml version="1.0" encoding="UTF-8"?>
    <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ns="http://www.mf.gov.pl/uslugiBiznesowe/uslugiDomenowe/AP/WeryfikacjaVAT/2018/03/01">
    <soapenv:Header/>
    <soapenv:Body>
    <ns:NIP>{}</ns:NIP>
    {}
    </soapenv:Body>
    </soapenv:Envelope>""".format(nip, parametrDaty)

    rsglobal.ZapiszDoLogow(body, 5)
    rsglobal.ZapiszDoLogow(headers, 5)
    response = requests.post(url, data=body, headers=headers)
    warnings.filterwarnings('default')
    match = re.search("<Komunikat>(.*)</Komunikat>", response.text)
    rsglobal.ZapiszDoLogow(str(response), 5)
    rsglobal.ZapiszDoLogow(str(response.text), 5)
    if match:
        if match.group(1) == 'Niepoprawny Numer Identyfikacji Podatkowej':
            platnik = None
        elif match.group(1) == 'Podmiot o podanym identyfikatorze podatkowym NIP jest zarejestrowany jako podatnik VAT zwolniony':
            platnik = False
        if match.group(1) == 'Podmiot o podanym identyfikatorze podatkowym NIP nie jest zarejestrowany jako podatnik VAT':
            platnik = False
        if match.group(1) == 'Podmiot o podanym identyfikatorze podatkowym NIP jest zarejestrowany jako podatnik VAT czynny':
            platnik = True

        return platnik, match.group(1)
    else:
        return None, 'Bd sprawdzania NIPu: ' + nip
