# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_srodki_trwale.py
# Purpose:     
#
# Author:      Pawel W, Marcin Wlodarczyk,Micha Raburski
# Created:     2008/08/11
# RCS-ID:      $Id: fs_srodki_trwale.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2009/09/20  nowe pole 'typ_srodka', blokada 'FOR UPDATE' Mariusz Rajfura  mantis: 1755, 
# 2013-02-15 Mariusz Rajfura (6532) nowy uklad kolumn w gridzie, popr.kontrola przy dodawaniu,kopiowaniu
# 2017-10-21 Piotr Witkowski (10788) Uwzgldnienie nowej klasyfikacji rodkw trwaych od 2018r
# 2020-09-29 Wojciech Skowron (8273) Checkbox 'umarzane'
# 2022-07-08 Aleksander Bargie (13081) [KS] W kartotece rodkw trwaych doda nr serii z moliwoci wyszukiwania
# 2022-10-26 Jan Raburski (13227) [KS] Filtr na miejsce uzytkowania

import rsglobal


Fun = klucze[-1]

Srodek         = rsglobal.Dekoduj(klucze[0]).strip()
Srodek_Nowy    = rsglobal.Dekoduj(klucze[1]).strip()
if Fun in (5, 6, 7, 9):
    SrodekF        = rsglobal.Dekoduj(klucze[2][0]).strip()
    NazwaF         = rsglobal.Dekoduj(klucze[2][1]).strip()
    GrupaF         = rsglobal.Dekoduj(klucze[2][2]).strip()
    SymbolKSTF     = rsglobal.Dekoduj(klucze[2][3]).strip()
    SymbolKST2018F = rsglobal.Dekoduj(klucze[2][4]).strip()
    UzytkownikIdF  = rsglobal.Dekoduj(klucze[2][5]).strip()
    DostawcaIdF    = rsglobal.Dekoduj(klucze[2][6]).strip()
    TypSrodkaF     = rsglobal.Dekoduj(klucze[2][7]).strip()
    UmarzaneF      = rsglobal.Dekoduj(klucze[2][8])  #WS 2020-09-29
    NrSeriiF       = rsglobal.Dekoduj(klucze[2][9])  #AB 10.07.22r
    MiejsceUzytkowania = rsglobal.Dekoduj(klucze[2][10])  #JR 2022-10-26
else:
    SrodekF        = ''
    NazwaF         = ''
    GrupaF         = ''
    SymbolKSTF     = ''
    SymbolKST2018F = ''
    UzytkownikIdF  = ''
    DostawcaIdF    = ''
    TypSrodkaF     = ''
    UmarzaneF      = ''
    NrSeriiF       = ''
    MiejsceUzytkowania = ''

klucze_id = klucze[3]

stat = "OK"
dane = []
wyn1 = []

UprDodawanie=((self.oddzial_id,'174103') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUsuwanie=((self.oddzial_id,'174104') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprZmianaKlucza=((self.oddzial_id,'174105') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   ZMIANA KLUCZA (7)
#-------------------------------------------------------------------------------

if Fun == 7:
    if not UprZmianaKlucza:
        stat="Brak uprawnie do zmiany klucza"     
        dane.append(stat)
    
    if stat=="OK":             
        sql ="SELECT srodek_id FROM rs_srodki_trwale"
        sql+=" WHERE srodek_id = '"+Srodek+"' and firma_id = '"+self.firma_id+"' FOR UPDATE NOWAIT;"
        stat,d,dum,dump = self.PolSQL.Execute(sql,3)
        if stat!='OK':
            stat = 'Bd przy sprawdzaniu numeru rodka:$'+stat
            dane.append(stat)
        elif len(d) == 0:
            stat="Podany rodek nie istnieje"   
            dane.append(stat)
    
    if stat=="OK":            
        sql ="SELECT srodek_id FROM rs_srodki_trwale"
        sql+=" WHERE srodek_id = '"+Srodek_Nowy+"' and firma_id = '"+self.firma_id+"'"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd przy sprawdzaniu numeru nowego rodka:$'+stat
            dane.append(stat)
        elif len(d) > 0:    
            stat="Podany numer rodka jest ju wykorzystywany"   
            dane.append(stat)
    
    if stat=="OK":
        UPDATE ="UPDATE rs_srodki_trwale SET srodek_id = '"+Srodek_Nowy+"'"
        UPDATE+=" WHERE srodek_id = '"+Srodek+"' AND firma_id = '"+self.firma_id+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat != 'OK':
            stat = 'Bd zmiany numeru rodka trwaego : '+stat
            dane.append(stat)
        else:
            klucze_id.append(Srodek_Nowy)        

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1:
    if not UprDodawanie:
        stat='UPR INS'
    
    if stat=='OK':
        sql ="SELECT srodek_id FROM rs_srodki_trwale"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND srodek_id = '"+Srodek+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql, 3 )
        if stat != 'OK':
            stat = 'Bd sprawdzenia unikalnoci numeru rodka trwaego : '+stat
        elif len(d) > 0:
            stat="BL EXT"
            
    if stat == 'OK':
        INSERT ="INSERT INTO rs_srodki_trwale (firma_id,srodek_id)"
        INSERT+="VALUES ('"+self.firma_id+"','"+str(Srodek)+"'); "
 
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT ,1)
        if stat != 'OK':
            stat = 'Bd dodawania kartoteki nowego rodkta trwaego : '+stat
        else:
            klucze_id.append(Srodek)


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE PRZED KOPIOWANIEM DANYCH (11)
#-------------------------------------------------------------------------------

if Fun == 11 :
    if not UprDodawanie:
        stat='UPR INS'
    
    if stat=='OK':
        sql = "SELECT srodek_id FROM rs_srodki_trwale"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(Srodek_Nowy)+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia numeru nowego rodka trwaego : '+stat
        elif len(d) > 0:
            stat="BL EXT"
            

#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH (9)
#-------------------------------------------------------------------------------

if Fun == 9:
    if not UprDodawanie:
        stat='UPR INS'
    
    if stat == 'OK':
        INS="INSERT INTO rs_srodki_trwale (firma_id,srodek_id,nazwa,typ_srodka,opis,grupa,symbol_kst,konto_ewid,konto_umorz"
        INS+=",konto_amort,uzytkownik_id,dostawca_id,faktura,waluta,data_zakupu"
        INS+=",wartosc_przyjecia,data_przyjecia,wartosc_poczatkowa,wartosc_aktualna,wartosc_umorzenia,"
        INS+="procent_umorzenia,stawka_procent,stawka_wartosc,metoda_amortyzacji,okres_amortyzacji,czy_podatkowa, "
        INS+="konto_amort_p,konto_umorz_p,wartosc_poczatkowa_p,wartosc_aktualna_p,wartosc_umorzenia_p,procent_umorzenia_p,"
        INS+="stawka_procent_p,stawka_wartosc_p,metoda_amortyzacji_p,okres_amortyzacji_p)"
        
        INS+="SELECT '"+self.firma_id+"','"+str(Srodek_Nowy)+"',nazwa,typ_srodka,opis,grupa,symbol_kst,konto_ewid,konto_umorz"
        INS+=",konto_amort,uzytkownik_id,dostawca_id,faktura,waluta,data_zakupu "
        INS+=",wartosc_przyjecia,data_przyjecia,wartosc_poczatkowa,wartosc_poczatkowa,0"
        INS+=",0,stawka_procent,stawka_wartosc,metoda_amortyzacji,okres_amortyzacji,czy_podatkowa, "
        INS+="konto_amort_p,konto_umorz_p,wartosc_poczatkowa_p,wartosc_poczatkowa_p,0,0,"
        INS+="stawka_procent_p,stawka_wartosc_p,metoda_amortyzacji_p,okres_amortyzacji_p "
        INS+=" FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(Srodek)+"' ;"
        
        stat,dump,dump,dump = self.PolSQL.Execute(INS, 1)
        if stat != 'OK':
            stat = "BL INS"
            dane.append(stat)
        else:
            klucze_id.append(Srodek_Nowy) 
            
            #policzenie rodka trwaego    
            from funkcje import fs_srodki_trwale_tworzenie_planu
            stat=fs_srodki_trwale_tworzenie_planu.StworzPlanSrodkaTrwalego(self.firma_id,str(Srodek_Nowy),self.PolSQL)
     

#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 :
    if not UprUsuwanie:
        stat='UPR DEL'
        
    if stat=='OK':    
        sql ="SELECT data_odpisu IS NULL,data_likwidacji IS NULL, data_sprzedazy IS NULL"
        sql+=" FROM rs_srodki_trwale"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND srodek_id = '"+Srodek+"' FOR UPDATE NOWAIT;"
        stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych rodka przed usuwaniem : '+stat
            
    if stat=='OK':
        if len(dane)==0:
            stat='BR SRODKA'
    if stat=='OK':            
        if not dane[0][0]:
            stat='WYP DATA ODP'
    if stat=='OK':
        if not dane[0][1]:
            stat='WYP DATA LIKW'
    if stat=='OK':
        if not dane[0][2]:
            stat='WYP DATA SPRZED'

    if stat=='OK':    
        sql ="SELECT srodek_id FROM rs_srodki_trwale_przeszacowania" 
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND srodek_id = '"+Srodek+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bad pobrania informacji o przeszacowaniu : '+stat
        elif len(d)!=0:
            stat='SRODEK W PRZ'    
            dane.append(stat)
            
    if stat=='OK':                    
        sql ="SELECT srodek_id FROM rs_srodki_trwale_umorzenia" 
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND srodek_id = '"+Srodek+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bad pobrania informacji o przeszacowaniu : '+stat
        elif len(d)!=0:
            stat='SRODEK W UM'    
            dane.append(stat)

    if stat=='OK':
        sql ="Select opis from rs_srodki_trwale_miejsca_uzytkowania st "
        sql+="INNER JOIN rs_miejsca_uzytkowania mu ON (st.firma_id=mu.firma_id AND st.miejsce_id=mu.kod) "
        sql+="WHERE st.firma_id='"+self.firma_id+"' AND st.srodek_id='"+Srodek+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bad pobrania informacji o miejscu uzytkowania : '+stat
        elif len(d)>0:
            lista = ''
            for numer in d:
                lista+=str(numer[0])+', '
            stat = "Nie mona usun rodka, poniewa najduje si w: "+lista.strip(', ')
                            
    if stat=='OK':
        DEL ="DELETE FROM rs_arkusze_przeszacowania_pozycje WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+Srodek+"';"
        DEL+="DELETE FROM rs_srodki_trwale_plan WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+Srodek+"';"
        DEL+="DELETE FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+Srodek+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(DEL ,1)
        if stat != 'OK':
            stat = 'Bd usuwania kartoteki rodka trwaego : '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------
        
if Fun in (1,5,6,7,9) and stat=='OK':
    Filtr="st.firma_id='"+self.firma_id+"'"
    if SrodekF != '':
        Filtr += " AND upper(st.srodek_id) LIKE upper('"+str(SrodekF)+"%')"
    if NazwaF != '':
        Filtr += " AND upper(st.nazwa) LIKE upper('"+str(NazwaF)+"%')"
    if GrupaF != '':
        Filtr += " AND upper(st.grupa)=upper('"+str(GrupaF)+"')"
    if SymbolKSTF != '':
        Filtr += " AND upper(st.symbol_kst)=upper('"+str(SymbolKSTF)+"')"
    if SymbolKST2018F != '':
        Filtr += " AND upper(st.symbol_kst_2018)=upper('"+str(SymbolKST2018F)+"')"
    if UzytkownikIdF != '':
        Filtr += " AND upper(st.uzytkownik_id)=upper('"+str(UzytkownikIdF)+"')"
    if DostawcaIdF != '':
        Filtr += " AND upper(st.dostawca_id)=upper('"+str(DostawcaIdF)+"')"
    if TypSrodkaF != '':
        Filtr += " AND upper(st.typ_srodka)=upper('"+str(TypSrodkaF)+"')"
    #WS 2020-09-29
    if UmarzaneF:
        Filtr += " AND wartosc_aktualna != 0 AND data_sprzedazy IS NULL and data_likwidacji IS NULL"
    #AB 10.07.22r
    if NrSeriiF != '':
        Filtr += " AND REPLACE(upper(st.nr_serii), ' ', '') LIKE REPLACE(upper('"+str(NrSeriiF)+"'), ' ', '')||'%'"

    #JR 2022-10-26
    if MiejsceUzytkowania != '':
        Filtr += " AND mu.miejsce_id='"+MiejsceUzytkowania+"' AND mu.data_od<=CURRENT_DATE AND (mu.data_do IS NULL OR mu.data_do>=CURRENT_DATE)"

    if klucze_id != []: #uzywane przy dodawaniu/kopiowaniu, tak zeby dodawany srodek byl widoczny podzial na dodawanie, kopiowanie ze wzgledu na rzne formaty danych
        for k in klucze_id: 
            if str(k[0])!= '[]':
                Filtr+=" OR (st.firma_id='" + self.firma_id + "' AND st.srodek_id='" +rsglobal.Dekoduj(k[0])+ "')"
    
    SQL = "SELECT st.srodek_id,COALESCE(st.nazwa,''::TEXT),"
    SQL += " COALESCE(st.grupa,''::TEXT),COALESCE(st.symbol_kst,''::TEXT),COALESCE(st.symbol_kst_2018,''::TEXT),"
    SQL += " CASE WHEN (SELECT COUNT(*) FROM rs_srodki_trwale_plan"
    SQL += "  WHERE firma_id=st.firma_id AND srodek_id=st.srodek_id) > 0 THEN TRUE ELSE FALSE END,"
    SQL += " COALESCE(st.data_zakupu::TEXT,''::TEXT),st.wartosc_poczatkowa,"
    SQL += " st.wartosc_aktualna,st.wartosc_umorzenia,st.stawka_wartosc,"
    SQL += " COALESCE(st.typ_srodka,''::TEXT),COALESCE(st.uzytkownik_id,''::TEXT),COALESCE(st.dostawca_id,''::TEXT)"
    SQL += " FROM rs_srodki_trwale st"
    #JR 2022-10-26
    if MiejsceUzytkowania != '':
        SQL += " INNER JOIN rs_srodki_trwale_miejsca_uzytkowania mu USING(firma_id,srodek_id)"
    SQL += " WHERE "+Filtr+" ORDER BY st.srodek_id;"
    rsglobal.ZapiszDoLogow("STJR:" + SQL)
    stat, dane, wyn1, tr = self.PolSQL.Execute(SQL, 3)
    
    if stat != 'OK':
        stat = 'Bd pobrania listy rodkw trwaych : '+stat

#-------------------------------------------------------------------------------
#---  Przeliczenie planu rodka trwaego (10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat=='OK':
    from funkcje import fs_srodki_trwale_tworzenie_planu
    stat=fs_srodki_trwale_tworzenie_planu.StworzPlanSrodkaTrwalego(self.firma_id,Srodek,self.PolSQL)