# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_srodki_trwale_dane.py
# Purpose:     kartoteka rodkw trwalych
#
# Author:      Marcin Wodarczyk, Pawe Wojcikowski,Micha Raburski
# Created:     2008/10/09
# RCS-ID:      $Id: fs_kartoteka_srodkow_dane.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2012-08-22 Mariusz Rajfura - mozliwosc wpisania daty odpisu (5901)
# 2017-10-21 Piotr Witkowski (10788) Uwzgldnienie nowej klasyfikacji rodkw trwaych od 2018r
# 2022-07-01 Aleksander Bargie (13082) [KS] Obsuga plikw binarnych w rodkach trwaych
# 2022-07-08 Aleksander Bargie (13081) [KS] W kartotece rodkw trwaych doda nr serii z moliwoci wyszukiwania


Srodek = klucze[0]
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
# POBRANIE INFORMACJI O DOKONANEJ AMORTYZACJI (8)
#-------------------------------------------------------------------------------
if Fun == 8 and stat == 'OK':
    sql ="SELECT COUNT(*)>0 FROM rs_srodki_trwale_plan"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+Srodek+"' AND umorzone;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania informacji o dokonanych umorzeniach: '+stat


#-------------------------------------------------------------------------------
#--- SPRAWDZAM CZY ISTNIEJE ZAPIS W rs_srodki_trwale_dekrety 
#-------------------------------------------------------------------------------

if klucze[-1]==7:
    Typ=klucze[1]
    SrodekId=klucze[2]
    SQL="SELECT srodek_id, typ, okres_id, dowod_id, nazwa_id, data, numer FROM rs_srodki_trwale_dekrety "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"' AND srodek_id='"+SrodekId+"' AND okres_id='"+self.okres_id+"' ;"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        stat='Bd sprawdzania dekretu: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- ZAPIS DO rs_srodki_trwale_dekrety i uzupenienie utworzonego dowodu ksig.
#-------------------------------------------------------------------------------

if klucze[-1] == 6:
    DowodId=klucze[0][0]
    NazwaId=klucze[0][1]
    Data=klucze[0][2]
    Numer=klucze[0][3]
    Typ=klucze[1]
    SrodekId=klucze[2]
    #pobranie danych do update
    SQL="SELECT data_sprzedazy, data_likwidacji, konto_ewid, wartosc_poczatkowa, wartosc_aktualna, SUBSTRING(srodek_id||' - '||nazwa FROM 1 FOR 100) as tresc, waluta "
    SQL+="FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"'; "
    stat,dst,nst,dump = self.PolSQL.Execute(SQL ,3)
    DaneST = rssql.RSTableRowset(dst,nst)
    if stat<>'OK':
        stat='Bd pobrania danych rodka trwaego: '+stat
        dane.append(stat)  
    else:
        DataSprzedazy=DaneST.GetVal(0,"data_sprzedazy")
        DataLikwidacji=DaneST.GetVal(0,"data_likwidacji")
        KontoEwid=DaneST.GetVal(0,"konto_ewid")
        if  KontoEwid.strip() in (None, '', 'None'):
            stat='Brak konta ewidencyjnego dla rodka trwaego'
            dane.append(stat)
        WartPocz=DaneST.GetVal(0,"wartosc_poczatkowa")
        WartAkt=DaneST.GetVal(0,"wartosc_aktualna")
        Tresc=DaneST.GetVal(0,"tresc").strip()
        Waluta=DaneST.GetVal(0,"waluta").strip()

        
        if (DataSprzedazy in (None,'    -  -  ', 'None')) and (DataLikwidacji in (None,'    -  -  ', 'None')):
            Kwota=WartAkt
            Konto='konto_wn'
        else:
            Kwota=WartPocz
            Konto='konto_ma'
        
        
        UPDATE="UPDATE rs_dowody_ksiegowe SET tresc='"+Tresc+"' WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodId+"' AND nazwa_id='"+NazwaId+"' "
        UPDATE+="AND data='"+Data+"' AND numer="+str(Numer)+"; "
    
                      
        UPDATEP="UPDATE rs_dowody_ksiegowe_pozycje SET "+Konto+" = '"+KontoEwid+"', kwota_wn="+str(Kwota)+", kwota_ma="+str(Kwota)+", tresc_wn='"+Tresc+"', "
        UPDATEP+="tresc_ma='"+Tresc+"', waluta_wn='"+Waluta+"', waluta_ma='"+Waluta+"' WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodId+"' AND nazwa_id='"+NazwaId+"' "
        UPDATEP+="AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz=1 AND nr_ppoz=0; "
        
    
        INSERT="INSERT INTO rs_srodki_trwale_dekrety  (firma_id, srodek_id, typ, okres_id, dowod_id, nazwa_id, data, numer) "
        INSERT+="VALUES ('"+self.firma_id+"', '"+SrodekId+"', '"+Typ+"', '"+self.okres_id+"', '"+DowodId+"', '"+NazwaId+"', '"+Data+"', "+str(Numer)+") ; "
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE+UPDATEP+INSERT ,1)
        if stat<>'OK':
            stat='Bd zapisu: '+stat
            dane.append(stat)    

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (4,3) and stat=='OK':
    if not (((self.oddzial_id,'174102') in self.uprawnienia) or ((self.oddzial_id,'174103') in self.uprawnienia) \
            or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'
    
    if stat=='OK':
        DataOdpisu = ''
        DataPrzyjecia = ''
        DataWprowadzeniaDoSystemu = ''
        
        # pobranie danych uzupelniajacych do sprawdzenia i przy okazji zablokowanie do edycji
        sql = "SELECT * FROM rs_srodki_trwale"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+Srodek+"' FOR UPDATE;"
        stat,DaneSrodka,nagl,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania biecych danych rodka: '+stat
        elif len(DaneSrodka) == 0:
            stat = 'Brak rodka o podanym numerze.'
        
    if stat=='OK':
        #---   Sprawdzenie danych
        CzyPodatkowa = None
        KontoAmortyzacjiP = ''
        KontoUmorzeniaP = ''
        CzyLiczycPlan=False
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['data_sprzedazy', 'data_likwidacji','data_przyjecia','wartosc_poczatkowa',
                        'wartosc_aktualna','stawka_procent','metoda_amortyzacji','okres_amortyzacji',
                        'wartosc_poczatkowa_p','wartosc_aktualna_p','stawka_procent_p','metoda_amortyzacji_p',
                        'okres_amortyzacji_p','data_wprowadzenia_do_systemu','wartosc_koncowa','wartosc_koncowa_p',
                        'data_odpisu','wartosc_przyjecia','stawka_wartosc','stawka_wartosc_p']:
                    
                    CzyLiczycPlan=True
            
            if pole in ['data_zakupu', 'data_sprzedazy', 'data_likwidacji','data_przyjecia',
                        'data_wprowadzenia_do_systemu','data_odpisu'] and stat== "OK":
                if wart <> "    -  -  ":
                    if rsglobal.SprawdzCzyToData(wart):
                        wartosci[i]="'"+wartosci[i]+"'"
                    else:
                        stat = "BL "+pole
                        dane.append(stat)
                else:
                    wartosci[i] = 'NULL'
                    
                if pole == 'data_przyjecia':
                    DataPrzyjecia = wart
                elif pole == 'data_wprowadzenia_do_systemu':
                    DataWprowadzeniaDoSystemu = wart
                elif pole == 'data_odpisu':
                    DataOdpisu = wart
            
            elif (pole in ["konto_ewid", "konto_umorz", "konto_amort"]) and stat=="OK":                    
                if wart == '':
                    stat='BR '+pole
                    dane.append(stat) 
                else:
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL '+pole
                            dane.append(stat)
                        else:
                            if not Dane[2]:
                                stat = 'BL NKSIEG '+pole
                                dane.append(stat)
                            
            elif pole=='grupa' and stat== "OK":
                if wart == '':
                    stat = "BR GRUPA"
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL GRUPA"
                            dane.append(stat)
            
            elif pole=='typ_srodka' and stat== "OK":
                if wart == '':
                    stat = "BR TYP"
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_typy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL TYP"
                            dane.append(stat)
                        
            elif pole=='symbol_kst' and stat== "OK":
                if wart == '':
                    stat = "BR SYMBOL"
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_klasyfikacja_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL SYMBOL"
                            dane.append(stat)

            elif pole=='symbol_kst_2018' and stat== "OK":
                if wart == '':
                    stat = "BR SYMBOL"
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_klasyfikacja_srodkow_trwalych_2018 WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL SYMBOL"
                            dane.append(stat)
                        
            elif pole in ['uzytkownik_id','dostawca_id'] and stat == "OK":
                if wart <> '':
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL "+pole
                            dane.append(stat)
                        
            elif pole=='waluta' and stat== "OK":
                if wart == '':
                    stat = "BR WALUTA"
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL WALUTA"
                            dane.append(stat)
            #AB 01.07.22r
            elif pole=='zagadnienie_id' and stat== "OK":
                if wart != 0:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT zagadnienie_id FROM rs_wf_zagadnienia WHERE firma_id='"+self.firma_id+"' AND zagadnienie_id='"+str(wart)+"';", 3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL ZAG"
                            dane.append(stat)
                        
            elif pole in ['metoda_amortyzacji','metoda_amortyzacji_p'] and stat== "OK":
                if wart == '':
                    stat = "BR "+pole
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_metody_amortyzacji WHERE kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL "+pole
                            dane.append(stat)
                        else:
                            if not wart in ['C','L']:
                                stat = "NO "+pole
                                dane.append(stat)
                        
            elif pole in ['okres_amortyzacji','okres_amortyzacji_p'] and stat== "OK":
                if wart == '':
                    stat = "BR "+pole
                    dane.append(stat)
                else:
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_okresy_amortyzacji WHERE kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL "+pole
                            dane.append(stat)

            elif pole == 'konto_umorz_p':
                KontoUmorzeniaP = wart
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL konto_umorz_p'
                            dane.append(stat)
                        else:
                            if not Dane[2]:
                                stat = 'BL NKSIEG konto_umorz_p'
                                dane.append(stat)
                                
            elif pole == 'konto_amort_p':
                KontoAmortyzacjiP = wart
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL konto_amort_p'
                            dane.append(stat)
                        else:
                            if not Dane[2]:
                                stat = 'BL NKSIEG konto_amort_p'
                                dane.append(stat)
                                
            elif pole == 'czy_podatkowa':
                CzyPodatkowa = wart
                
        if stat == 'OK':
            #konto amortyzacji podatkowej jest zalezne od pola czy_podatkowa==True
            if type(CzyPodatkowa) == type(True):
                #jesli zmieniono stan czy_podatkowa
                if CzyPodatkowa:
                    if KontoUmorzeniaP == '':
                        stat = 'BR konto_umorz_p'
                        dane.append(stat)
                    if KontoAmortyzacjiP == '':
                        stat = 'BR konto_amort_p'
                        dane.append(stat)


        if stat == 'OK':
            # jesli modyfikowano date odpisu i nie jest to data pusta, to jej kontrola
            if not DataOdpisu in ('','    -  -  '):
                tr = rssql.RSTableRowset(DaneSrodka,nagl)
                if DataPrzyjecia == '':
                    DataPrzyjecia = rsglobal.Dekoduj(tr.GetVal(0,'data_przyjecia'))
                if DataWprowadzeniaDoSystemu == '':
                    DataWprowadzeniaDoSystemu = rsglobal.Dekoduj(tr.GetVal(0,'data_wprowadzenia_do_systemu'))

                if DataOdpisu < DataPrzyjecia:
                    stat = 'BL ODPIS PRZED PRZYJECIEM'


        #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+Srodek+"'"
            upd = "UPDATE rs_srodki_trwale SET "
            
            for i in xrange(len(pola)):
                pole=pola[i]
                wart=rsglobal.Dekoduj(wartosci[i])
                if pole in ['data_odpisu','data_przeszac','data_zakupu','data_przyjecia','wartosc_przyjecia',
                            'data_sprzedazy','data_likwidacji','czy_podatkowa','wartosc_poczatkowa',
                            'wartosc_aktualna','wartosc_umorzenia','procent_umorzenia','stawka_procent',
                            'stawka_wartosc','wartosc_poczatkowa_p','wartosc_aktualna_p','wartosc_umorzenia_p',
                            'procent_umorzenia_p','stawka_procent_p','stawka_wartosc_p','data_wprowadzenia_do_systemu',
                            'wartosc_koncowa','wartosc_koncowa_p']:                                
                    upd+=pole+"="+str(wart)+","
                #AB 10.07.22r
                elif pole in ['nazwa','grupa','symbol_kst','symbol_kst_2018','nr_serii','opis','konto_ewid','konto_umorz',
                              'konto_amort','konto_umorz_p','konto_amort_p','waluta','faktura','metoda_amortyzacji',
                              'okres_amortyzacji','metoda_amortyzacji_p','okres_amortyzacji_p','typ_srodka']:
                    upd+=pole+"='"+str(wart)+"',"

                elif pole in ['uzytkownik_id','dostawca_id']:
                    if wart=='':
                        upd+=pole+"=NULL,"
                    else:
                        upd+=pole+"='"+str(wart)+"',"
                #AB 01.07.22r
                elif pole in ('zagadnienie_id', ):
                    if wart:
                        upd+=pole+"="+str(wart)+","
                    else:
                        upd+=pole+"=NULL,"
                    
            upd = upd[0:len(upd)-1]+where
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
            
            #policzenie rodka trwaego    
            if stat=='OK' and CzyLiczycPlan:
                from funkcje import fs_srodki_trwale_tworzenie_planu
                stat=fs_srodki_trwale_tworzenie_planu.StworzPlanSrodkaTrwalego(self.firma_id,Srodek,self.PolSQL)

                 
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    Grupa = ''
    SymbolKST = ''
    SymbolKST2018 = ''
    TypSrodka = ''
    Waluta = ''
    Uzytkownik = ''
    Dostawca = ''
    MetodaAmort = ''
    OkresAmort = ''
    MetodaAmortP = ''
    OkresAmortP = ''
    
    pobranie ="SELECT * FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"'" 
    pobranie +=" AND srodek_id='"+Srodek+"' ;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(pobranie,3)
   
    if stat <> 'OK':
        stat = 'Bd pobrania danych rodka trwaego : '+stat
    else:
        for i in xrange(len(wyn1)):
            pole = wyn1[i][0]
            wart = str(dane[0][i])
            if pole == 'grupa':
                if ((self.oddzial_id,'011540') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat == 'OK':
                        if len(d) > 0:
                            Grupa =  str(d[0][0])
                    else:
                        Grupa = 'Bd pobrania opisu grupy rodka trwaego'
                else:
                    Grupa = 'Brak uprawnie do sownika. Poinformuj administratora.'
           
           
            if pole == 'symbol_kst':
                if ((self.oddzial_id,'011550') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_klasyfikacja_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            SymbolKST = str(d[0][0])
                    else:
                        SymbolKST = 'Bd pobrania opisu klasyfikacji rodka trwaego'
                else:
                    SymbolKST = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'symbol_kst_2018':
                if ((self.oddzial_id,'011550') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_klasyfikacja_srodkow_trwalych_2018 WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            SymbolKST2018 = str(d[0][0])
                    else:
                        SymbolKST2018 = 'Bd pobrania opisu klasyfikacji rodka trwaego 2018'
                else:
                    SymbolKST2018 = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'typ_srodka':
                if ((self.oddzial_id,'011650') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_typy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            TypSrodka = str(d[0][0])
                    else:
                        TypSrodka = 'Bd pobrania opisu typu rodka trwaego'
                else:
                    TypSrodka = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'waluta':
                if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            Waluta = str(d[0][0])
                    else:
                        Waluta = 'Bd pobrania opisu waluty'
                else:
                    Waluta = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif pole == 'uzytkownik_id':
                if ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            Uzytkownik = str(d[0][0])
                    else:
                        Uzytkownik = 'Bd pobrania opisu uytkownika'
                else:
                    Uzytkownik = 'Brak uprawnie do katalogu. Poinformuj administratora.'
                                
            elif pole == 'dostawca_id':
                if ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            Dostawca = str(d[0][0])
                    else:
                        Dostawca = 'Bd pobrania opisu dostawcy'
                else:
                    Dostawca = 'Brak uprawnie do katalogu. Poinformuj administratora.'
            
            elif pole == 'metoda_amortyzacji':
                if ((self.oddzial_id,'011520') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_metody_amortyzacji WHERE kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            MetodaAmort = str(d[0][0])
                    else:
                        MetodaAmort = 'Bd pobrania opisu metody amortyzacji'
                else:
                    MetodaAmort = 'Brak uprawnie do sownika. Poinformuj administratora.'
                    
            elif pole == 'okres_amortyzacji':
                if ((self.oddzial_id,'011530') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_okresy_amortyzacji WHERE kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            OkresAmort = str(d[0][0])
                    else:
                        OkresAmort = 'Bd pobrania opisu okresu amortyzacji'
                else:
                    OkresAmort = 'Brak uprawnie do sownika. Poinformuj administratora.'

            elif pole == 'metoda_amortyzacji_p':
                if ((self.oddzial_id,'011520') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_metody_amortyzacji WHERE kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            MetodaAmortP = str(d[0][0])
                    else:
                        MetodaAmortP = 'Bd pobrania opisu metody amortyzacji'
                else:
                    MetodaAmortP = 'Brak uprawnie do sownika. Poinformuj administratora.'
                    
            elif pole == 'okres_amortyzacji_p':
                if ((self.oddzial_id,'011530') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_okresy_amortyzacji WHERE kod='"+wart+"';" ,3)
                    if stat=='OK':
                        if len(d) > 0:
                            OkresAmortP = str(d[0][0])
                    else:
                        OkresAmortP = 'Bd pobrania opisu okresu amortyzacji'
                else:
                    OkresAmortP = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
    wyn2 = [Grupa,SymbolKST,SymbolKST2018,TypSrodka,Waluta,Uzytkownik,Dostawca,MetodaAmort,OkresAmort,MetodaAmortP,OkresAmortP]