# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_srodki_trwale_pliki.py
# Author:      Aleksander Bargie
# Created:     2022/07/01
# RCS-ID:      $Id: fs_srodki_trwale_pliki.py $
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_pliki_global
import rsglobal


'''
174140 - Pliki
174141 - Przegldanie
174143 - Dodawanie
174144 - Usuwanie'''

stat = "OK"
firma_id = self.firma_id

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {
        'NazwaPliku': [1], 'TrescPliku': [1],
        'PlikId': [2, 6],  'SrodekId': [1, 2, 5, 6],
    }
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_srodki_trwale_pliki ' \
               'z numerem ' + str(Funkcja) + ' bez parametrw: ' + Lista

if stat == "OK":
    SrodekId = klucze['SrodekId']

    if Funkcja in [2, 6]:
        PlikId = klucze['PlikId']
    if Funkcja == 1:
        NazwaPliku = klucze['NazwaPliku']
        TrescPliku = klucze['TrescPliku']

dane = []
LPlik = []

# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
# -------------------------------------------------------------------------------

UprIns = ((self.oddzial_id, '174143') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

UprDel = ((self.oddzial_id, '174144') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if stat == 0 and Funkcja == 1 and not UprIns:
    stat = 'UPR INS'

if stat == 0 and Funkcja == 6 and not UprDel:
    stat = 'UPR DEL'

if stat == 'OK':
    WHERE = " WHERE firma_id='" + firma_id + "' "
    WHERE += "AND srodek_id='" + str(SrodekId) + "' "
    # sprawdzenie poprawnoci rodka trwaego
    SQL = "SELECT srodek_id FROM rs_srodki_trwale " + WHERE + "FOR UPDATE NOWAIT;"
    stat, STest, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd sprawdzania poprawnoci rodka trwaego' + stat
if stat == 'OK' and len(STest) == 0:
    stat = 'BR_ST'


# -------------------------------------------------------------------------------
# ---   INSERT DANYCH (1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:

    if stat == 'OK':
        INSPLIKI = """INSERT INTO rs_pliki (  firma_id,      nazwa,            tabela,     kompresja)
                                    VALUES ('{firma_id}','{NazwaPliku}','rs_srodki_trwale_pliki', FALSE);""".format(**locals())
        rsglobal.ZapiszDoLogow(INSPLIKI)
        stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania pliku: {stat}".format(**locals())

    if stat == 'OK':
        SQLNumerPliku = """SELECT max(plik_id) 
                           FROM rs_pliki 
                           WHERE firma_id='{firma_id}' AND tabela='rs_srodki_trwale_pliki';""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLNumerPliku)
        stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrp))
        if stat != 'OK':
            stat = "Bd pobierania numeru zacznika: {stat}".format(**locals())
        else:
            NumerPliku = nrp[0][0]
            stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, TrescPliku)

            if stat != 'OK':
                stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())
            else:
                INSPLIKIZAG = ''
                if stat == 'OK':
                    INSZALACZNIKI = """INSERT INTO rs_srodki_trwale_pliki
                                               (  firma_id,    srodek_id,    nr_pliku   )
                                        VALUES ('{firma_id}','{SrodekId}','{NumerPliku}');
                                        {INSPLIKIZAG}""".format(**locals())

                    rsglobal.ZapiszDoLogow(INSZALACZNIKI, 5)
                    stat, dump, dump, dump = self.PolSQL.Execute(INSZALACZNIKI, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd dodawania rekordu o nowym pliku: ' + stat

# -------------------------------------------------------------------------------
# ---   PLIK POBIERANY DO KLIENTA (2)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 2:
    SQL = "SELECT nr_pliku FROM rs_srodki_trwale_pliki "
    SQL += WHERE + " AND nr_pliku=" + str(PlikId) + ";"
    stat, SPlik, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru pliku' + stat

    if stat == 'OK':
        if len(SPlik) == 0:
            stat = "Plik pochodzi z zagadnienia. Mona go usun w przepywie dokumentw."
    stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, PlikId)
    dane = [Tresc]


# -------------------------------------------------------------------------------
# ---   DELETE DANYCH (6)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    test = """select 1 from rs_wf_zagadnienia_pliki where nr_pliku = %s"""
    args = [PlikId]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(test, args))
    stat, plk, dump, dump = self.PolSQL.Execute(test, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd szukania pliku w zagadnieniach: " + stat
    elif len(plk)>0:
        stat = "Plik zosta przepisany z zagadnienia. Mona go usun w przepywie dokumentw."
    if stat == 'OK':
        SQL =  "DELETE FROM rs_srodki_trwale_pliki WHERE nr_pliku="+str(PlikId)+";"
        SQL += "DELETE FROM rs_pliki WHERE plik_id="+str(PlikId)+";"
        rsglobal.ZapiszDoLogow(SQL, 5)
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
        if stat != 'OK':
            stat = 'Bd przy usuwaniu pliku' + stat

    if stat == 'OK':
        stat = fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow, PlikId)

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5 -select, 6 -delete)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 5, 6]:
    SQL = """SELECT p.plik_id, p.nazwa 
             FROM rs_srodki_trwale_pliki s 
             JOIN rs_pliki p ON p.firma_id=s.firma_id  AND p.plik_id=s.nr_pliku AND p.tabela ='rs_srodki_trwale_pliki' 
             WHERE s.firma_id='{}' AND srodek_id='{}'
             UNION
             SELECT p.plik_id, p.nazwa 
             FROM  rs_pliki p 
             JOIN rs_wf_zagadnienia_pliki z ON p.firma_id=z.firma_id  AND p.plik_id=z.nr_pliku AND p.tabela ='rs_wf_zagadnienia_pliki' 
                 AND z.zagadnienie_id = (SELECT zagadnienie_id 
                                         FROM rs_srodki_trwale st 
                                         WHERE st.firma_id=p.firma_id AND st.srodek_id='{}')
             WHERE p.firma_id='{}'""".format(firma_id, SrodekId, SrodekId, firma_id)
    stat, dane, wyn1, tr = self.PolSQL.Execute(SQL, 3)
    rsglobal.ZapiszDoLogow(SQL)
    if stat != 'OK':
        stat = 'Bd przy pobieraniu danych' + stat
