# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_srodki_trwale_tworzenie_plan.py
# Purpose:     funkcja tworzenia planu rodka trwaego
# Author:      Micha Raburski
# Created:     2008/12/20
# RCS-ID:      $Id: fs_srodki_trwale_tworzenie_planu.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#uwzgldnienie wartosci koncowej, Dariusz Boduch 2010/09/14, mantis: 2105
#uwzglednienie zawieszenia amortyzacji, Dariusz Boduch 2010/09/21, mantis: 3587
#mocne przeorganizowanie funkcji, Micha Raburski 2010/11/17, mantis: 3970

def StworzPlanSrodkaTrwalego(Firma,SrodekId,PolSQL):
    import rsglobal
    debug=10
    
    #pobranie danych rodka
    SQL="SELECT data_przyjecia,data_sprzedazy,data_likwidacji,data_odpisu,metoda_amortyzacji," # 0-4
    SQL+="okres_amortyzacji,wartosc_poczatkowa,wartosc_aktualna,stawka_procent,stawka_wartosc,"# 5-9
    SQL+="metoda_amortyzacji_p,okres_amortyzacji_p,wartosc_poczatkowa_p,wartosc_aktualna_p,"   # 10-13
    SQL+="stawka_procent_p,stawka_wartosc_p,data_wprowadzenia_do_systemu,data_przeszac,"       # 14-17
    SQL+="wartosc_koncowa,wartosc_koncowa_p"                                                   # 18-19
    SQL+=" FROM rs_srodki_trwale WHERE firma_id='"+Firma+"' AND srodek_id='"+SrodekId+"' ; "
    
    stat,DSrodka,dump,dump=PolSQL.Execute(SQL,3)
    if stat<> "OK":
        return stat

    if len(DSrodka)==0:
        return "BR SRODKA"
    
    # sprawdzenie czy rodek nie jest aktualnie wpisany na niezamknit amortyzacj
    SQL="SELECT srodek_id FROM rs_arkusze_amortyzacji_pozycje ap INNER JOIN rs_arkusze_amortyzacji a USING(firma_id,data,numer)"
    SQL+=" WHERE ap.firma_id='"+Firma+"' AND ap.srodek_id='"+SrodekId+"' AND a.stan='W';"
    stat,DPrzeszac,dump,dump=PolSQL.Execute(SQL,3)
    if stat<> "OK":
        return stat

    if len(DPrzeszac)>0:
        return 'Nie mona przeliczy planu rodka trwaego '+SrodekId.strip()+', bo znajduje si on na otwartym arkuszu amortyzacji.'
    
    # pobranie zmian wartoci rodka
    SQL="SELECT rok,miesiac,rach_przesz,podat_przesz"
    SQL+=" FROM rs_srodki_trwale_przeszacowania WHERE firma_id='"+Firma+"' AND srodek_id='"+SrodekId+"'"
    SQL+="ORDER BY rok,miesiac;"
    stat,DPrzeszac,dump,dump=PolSQL.Execute(SQL,3)
    if stat<> "OK":
        return stat
    
    #pobranie zawiesze srodka trwalego
    SQL="SELECT data_od, data_do FROM rs_srodki_trwale_zawieszenia_amortyzacji"
    SQL+=" WHERE firma_id='"+Firma+"' AND srodek_id='"+str(SrodekId)+"';"

    stat,DSrodkaZaw,dump,dump=PolSQL.Execute(SQL,3)
    if stat<> "OK":
        return stat
    
    Zawieszenia=[]
    for poz in DSrodkaZaw:
        RokP = int(poz[0][0:4])
        McP = int(poz[0][5:7])
        RokK = int(poz[1][0:4])
        McK = int(poz[1][5:7])
        while RokP< RokK or (RokP==RokK and McP<=McK):
            Zawieszenia.append([RokP,McP])
            McP+=1
            if McP==13:
                McP=1
                RokP+=1
         
    #Pobranie daty ostatniej zmiany stawki srodka trwaego
    DataZmStawki='None'
    SQL="SELECT data FROM rs_srodki_trwale_zmiany_stawki "
    SQL+="WHERE firma_id='"+Firma+"' AND srodek_id='"+str(SrodekId)+"'ORDER BY data DESC LIMIT 1;"
    stat,DZmianySt,dump,dump=PolSQL.Execute(SQL,3)
    if stat<>"OK":
        return 'Bdy pobierania zmiany stawki :'+stat
    
    if len(DZmianySt)>0:
        DataZmStawki=DZmianySt[0][0]
        
    DataPrz=rsglobal.Dekoduj(DSrodka[0][0])
    DataSprz=rsglobal.Dekoduj(DSrodka[0][1])
    DataLik=rsglobal.Dekoduj(DSrodka[0][2])
    DataOdpisu=rsglobal.Dekoduj(DSrodka[0][3])
    MetodaAm=rsglobal.Dekoduj(DSrodka[0][4])
    OkresAm=rsglobal.Dekoduj(DSrodka[0][5])
    WartPoczAm=DSrodka[0][6]
    WartAktAm=DSrodka[0][7]
    StawkaPrAm=DSrodka[0][8]
    StawkaWartAm=rsglobal.RSRound(DSrodka[0][9],2)
    MetodaAmP=rsglobal.Dekoduj(DSrodka[0][10])
    OkresAmP=rsglobal.Dekoduj(DSrodka[0][11])
    WartPoczAmP=DSrodka[0][12]
    WartAktAmP=DSrodka[0][13]
    StawkaPrAmP=DSrodka[0][14]
    StawkaWartAmP=rsglobal.RSRound(DSrodka[0][15],2)
    DataSystem=rsglobal.Dekoduj(DSrodka[0][16])
    DataZmianyWart=rsglobal.Dekoduj(DSrodka[0][17])
    WartKoncowa=rsglobal.Dekoduj(DSrodka[0][18])
    WartKoncowaP=rsglobal.Dekoduj(DSrodka[0][19])
    
    #sprawdzenie, czy jest sens tworzy plan
    
    #Usuniemy to jeli jest data likwidacji lub sprzeday lub bdziemy przelicza
    SQL="DELETE FROM rs_srodki_trwale_plan WHERE firma_id='"+Firma+"' AND srodek_id='"+SrodekId+"' AND NOT umorzone"     
    
    if DataPrz=='None':
        return "OK"
    
    if DataSprz<>'None':
        SQL+=" AND rok||miesiac>='"+DataSprz[0:4]+DataSprz[5:7]+"';"
        stat,dump,dump,dump=PolSQL.Execute(SQL,1)
        return stat
    
    if DataLik<>'None':
        SQL+=" AND rok||miesiac>='"+DataLik[0:4]+DataLik[5:7]+"';"
        stat,dump,dump,dump=PolSQL.Execute(SQL,1)
        return stat
    
    #---------------------------------------------------------------------------
    #wybieramy dat od ktrej zmieniamy plan. 
    #---------------------------------------------------------------------------
    
    RokP=0
    McP=0
    #jesli wart. byla juz zmieniana to moemy zmienia od nastpnego miesica po zmianie wartoci
    CzyZmWPrzyszlymMies=False
    if DataZmianyWart<>'None':
        # sprawdzamy czy w okresie gdy bya robiona zmiana zmieniamy w miesicu czy po miesicy zmiany
        SQLOkr="SELECT odpis_zm_wart_w_przyszlym_mies FROM rs_definicje_okresow WHERE firma_id='"+Firma+"'"
        SQLOkr+=" AND data_od<='"+DataZmianyWart+"' AND data_do >='"+DataZmianyWart+"';"
        stat,DOkr,dump,dump=PolSQL.Execute(SQLOkr,3)
        if stat<>'OK':
            return "Bd pobierania danych okresw: "+stat
        if len(DOkr)==0:
            return "Brak okresu dla podanej daty zmiany wartoci: "+DataZmianyWart

        # data zmiany jest waniejsza ni data amortyzacji. Wczeniejszy plan nie bdzie ju zmieniany
        RokP = DataZmianyWart[0:4]
        McP = DataZmianyWart[5:7]        
        
        if DOkr[0][0]:
            #zmieniamy w nastpnym miesicu
            CzyZmWPrzyszlymMies=True
            SQL+=" AND rok||miesiac>'"+DataZmianyWart[0:4]+DataZmianyWart[5:7]+"'"
            # przesuwamy o 1 miesic
            McP=str(int(McP)+1)
            if McP=='13':
                McP='1'
                RokP=str(int(RokP)+1)
            if len(McP)==1:
                McP='0'+McP
        else:
            #zmieniamy w tym miesicu
            SQL+=" AND rok||miesiac>='"+DataZmianyWart[0:4]+DataZmianyWart[5:7]+"'"
        
    # uwzgldniamy te dat zmiany stawki rodka 
    if DataZmStawki<>'None' and ((RokP<int(DataZmStawki[0][0:4])) or (RokP==int(DataZmStawki[0][0:4]) and McP<int(DataZmStawki[0][5:7]))):
        SQL+=" AND rok||miesiac>='"+DataZmStawki[0:4]+DataZmStawki[5:7]+"'"
        RokP = DataZmStawki[0:4]
        McP = DataZmStawki[5:7]
        
    if RokP>0:   
        # to s kwoty, ktre zostan nieusunite mimo nieumorzenia
        sql="SELECT SUM(rach_kwota),SUM(podat_kwota) from rs_srodki_trwale_plan "
        sql+=" WHERE firma_id='"+Firma+"' AND srodek_id='"+str(SrodekId)+"' "
        sql+=" AND rok||miesiac<'"+str(RokP)+str(McP)+"' AND NOT umorzone;"
        stat,danePrzesz,wyn1,wyn2=PolSQL.Execute(sql,3)                        
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu daty zmiany wartoci :'+stat
        elif len(danePrzesz)<>0:
            WartA=danePrzesz[0][0]
            WartAP=danePrzesz[0][1]     
            WartAktAm=WartAktAm-WartA   
            WartAktAmP=WartAktAmP-WartAP   
    
    SRokMc={}
    
    if WartAktAm <>0:
        SPlan=ObliczKolejneAmortyzacjeSrodkaTrwalego(MetodaAm, OkresAm, DataPrz, DataSystem, DataOdpisu, WartPoczAm,
                              WartAktAm, StawkaPrAm, StawkaWartAm,DataZmianyWart,WartKoncowa,Zawieszenia,DSrodkaZaw,
                              DataZmStawki,'L',DPrzeszac,CzyZmWPrzyszlymMies)
        for kl in SPlan:
            SRokMc[kl]=SPlan[kl]+['NULL',0,0,0,False]

    if WartAktAmP <>0:
        SPlanP=ObliczKolejneAmortyzacjeSrodkaTrwalego(MetodaAmP, OkresAmP, DataPrz, DataSystem, DataOdpisu, WartPoczAmP,
                              WartAktAmP, StawkaPrAmP, StawkaWartAmP,DataZmianyWart,WartKoncowaP,Zawieszenia,DSrodkaZaw,
                              DataZmStawki,'P',DPrzeszac,CzyZmWPrzyszlymMies)
        for kl in SPlanP:
            if kl in SRokMc:
                SRokMc[kl]=SRokMc[kl][0:5]+SPlanP[kl]
            else:
                SRokMc[kl]=['NULL',0,0,0,False]+SPlanP[kl]

    #zapis waciwy planu
    #dodanie ; do koncowki zapytania usuwajcego
    SQL+=";"
       
    stat,dump,dump,dump=PolSQL.Execute(SQL,1)
    if stat<>'OK':
        return 'Bdy usuwania pozycji planu '+stat
    
    SQL=''
    Klucze=SRokMc.keys()
    Klucze.sort()
    for kl in Klucze:
        poz=SRokMc[kl]
        
        Mc='0'+str(kl[1])
        Mc=Mc[-2:]
        SQL+="INSERT INTO rs_srodki_trwale_plan (firma_id,srodek_id,rok,miesiac,umorzone,"
        SQL+="rach_metoda,rach_procent,rach_kwota,rach_kwota_po,podat_metoda,podat_procent,podat_kwota,podat_kwota_po) VALUES "
        SQL+="('"+Firma+"','"+SrodekId+"','"+str(kl[0])+"','"+Mc+"',"+str(poz[4])+","
        SQL+=poz[0]+","+str(poz[1])+","+str(poz[2])+","+str(poz[3])+","+poz[5]+","+str(poz[6])+","+str(poz[7])+","+str(poz[8])+");"
    if SQL <> '':
        stat,dump,dump,dump=PolSQL.Execute(SQL,1)
        if stat<>'OK':
            rsglobal.ZapiszDoLogow('Bdy tworzenia planu rodka: '+stat,1)
            stat='Bdy tworzenia planu rodka: '+stat+'. Sprawd czy nie zmieniasz planu w danych, ktre ju s rozliczone lub zostay zmienione w pniejszych miesicach'
    return stat

#-------------------------------------------------------------------------------

def ObliczKolejneAmortyzacjeSrodkaTrwalego(Metoda,Okres,DataPrz,DataSystem,DataOdpisu,WartPocz,
                  WartAkt,StawkaProc,StawkaWart,DataZmianyWart,WartKonc,Zawieszenia,DSrodkaZaw,
                  DataZmStawki,RodzajAm,DPrzeszac,CzyZmWPrzyszlymMies):
    import rsglobal
    debug=10
    RokP = 0
    McP = 0
    if RodzajAm=='L':
        WartAkt=WartAkt-WartKonc
        WartPocz=WartPocz-WartKonc
    
    SPlan={}
    
#-------------------------------------------------------------------------------
# Metoda caociowa
#-------------------------------------------------------------------------------
    
    if Metoda=='C':
        SPrzeszac=0
        for poz in DPrzeszac:
            if RodzajAm=='L':
                SPrzeszac+=poz[2]
            else:
                SPrzeszac+=poz[3]
                
        if DataOdpisu=='None' and len(DPrzeszac)==0:
            if DataSystem <> 'None':
                RokP=int(DataSystem[0:4])
                McP=int(DataSystem[5:7])
                SPlan[(RokP,McP)]=["'C'",100,WartPocz-SPrzeszac,0,False]
            else:
                RokP=int(DataPrz[0:4])
                McP=int(DataPrz[5:7])
                SPlan[(RokP,McP)]=["'C'",100,WartAkt-SPrzeszac,0,False]
        
        for poz in DPrzeszac:
            Rok=int(poz[0])
            Mc=int(poz[1])
            if CzyZmWPrzyszlymMies:
                Mc+=1
                if Mc==13:
                    Mc=1
                    Rok+=1
        
            klucz=(str(Rok),str(Mc))
            if RodzajAm=='L':
                SPlan[klucz]=["'C'",100,poz[2],0,False]
            else:
                SPlan[klucz]=["'C'",100,poz[3],0,False]

#-------------------------------------------------------------------------------
#Metoda liniowa
#-------------------------------------------------------------------------------
    
    elif (Metoda=='L') and StawkaWart>0:
        # RokP i McP to miesic w ktrym zaczynamy rozlicza.
        # sprawdzamy ktra z poniszych dat jest najwiksza
        RokP=0
        McP=0
        # pierwsza jest data zmiany wartosci
        if DataZmianyWart<>'None':
            RokP = int(DataZmianyWart[0:4])
            McP = int(DataZmianyWart[5:7])
            # zmieniamy od przyszego miesica
            if CzyZmWPrzyszlymMies:
                McP+=1
                if McP==13:
                    McP=1
                    RokP+=1
            
        # porwnujemy to z data ostatniego umorzenia
        if DataOdpisu<>'None' and (RokP<int(DataOdpisu[0:4]) or (RokP==int(DataOdpisu[0:4]) and McP<int(DataOdpisu[5:7]))):
            RokP=int(DataOdpisu[0:4])
            McP=int(DataOdpisu[5:7])    
            if RokP<> 0:
                McP=McP+1
                if McP==13:
                    RokP=RokP+1
                    McP=1

        #porwnanie ze zmian stawki oprocentowania
        if DataZmStawki<>'None' and (RokP<int(DataZmStawki[0:4]) or (RokP==int(DataZmStawki[0:4]) and McP<=int(DataZmStawki[5:7]))):
            RokP = int(DataZmStawki[0:4])
            McP = int(DataZmStawki[5:7])
            
        # jeli nie byo odpisu to jest to nowy rodek. Sprawdzamy dat wprowadzenia do systemu
        if RokP==0:
            if DataSystem<>'None':
                RokP = int(DataSystem[0:4])
                McP = int(DataSystem[5:7])

            # jeli w nowym rodku data systemowa jest niewypeniona to podajemy dat przyjcia rodka.
            # jest ona wypeniona zawsze bo inaczej algorytm wyszed wczeniej z funkcji
            else:
                RokP = int(DataPrz[0:4])
                McP = int(DataPrz[5:7])
                McP=McP+1
                if McP==13:
                    RokP=RokP+1
                    McP=1
        rsglobal.ZapiszDoLogow('DataSystem '+DataSystem+' '+str(RokP)+' '+str(McP),debug)
        rsglobal.ZapiszDoLogow('DataPrz '+DataPrz+' '+str(RokP)+' '+str(McP),debug)
        
        # mamy dat od ktrej tworzymy plan i poniej go ju budujemy
        # ROZLICZANIE MIESICZNE   
        if Okres=='M':
            Mc=McP
            Rok=RokP
 
            while WartAkt > 0:
                KwotaMc=StawkaWart
                
                if Mc==12:
                    #obliczenie kwoty w grudniu tak, by dokadnie zamykaa rok rozliczeniowy
                    IleMc=13-McP 
                    KwotaMc= rsglobal.RSRound(WartPocz*StawkaProc*0.01*IleMc/12,2)-(StawkaWart*(IleMc-1))
                KwotaMc=rsglobal.RSRound(min(KwotaMc,WartAkt),2)

                #ZAWIESZENIE SRODKA w wybranym roku i miesicu
                if [Rok,Mc] in Zawieszenia:
                    SPlan[(Rok,Mc)]=["'L'",0,0,WartAkt+WartKonc,False]
                else:
                    WartAkt=rsglobal.RSRound(WartAkt-KwotaMc,2)
                    if WartAkt<KwotaMc*0.1:
                        SPlan[(Rok,Mc)]=["'L'",StawkaProc,KwotaMc+WartAkt,WartKonc,False]
                        WartAkt=0
                    else:
                        SPlan[(Rok,Mc)]=["'L'",StawkaProc,KwotaMc,WartAkt+WartKonc,False]
    
                Mc=Mc+1
                if Mc==13:
                    Rok=Rok+1
                    Mc=1
                    McP=1
    return SPlan