# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_srodki_trwale_zmiana_miejsca.py
# Purpose:     obsuga grida ze zmian miejsc rodkw trwaych
# Author:      Wojciech Skowron
# Created:     2022/05/20
# RCS-ID:      $Id: fs_srodki_trwale_zmiana_miejsca.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

# 2022-06-13 Wojciech Skowron   - (13053) Uwzgldnienie zastpstw
# 2022-09-27 Wojciech Skowron   - (13177) Do zmiany miej uytkowania nie pobiera zlikwidowanych ani sprzedanych rodkw
# 2022-10-28 Wojciech Skowron   - (13233) Poprawka w filtrze na daty
# 2022-12-09 Wojciech Skowron   - (13270) DOdatkowe filtry - numer rodka, serii, nazwa rodka
# 2022-12-14 Aleksander BArgie - (13280) Zmany miejsca uytkowania
# 2023-02-27 Wojciech Skowron   - (13353) Informacja o przypisanym rodku trwaym (e-mail)

import rssql

stat = 'OK'

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'MiejsceF': [1,5], 'ZmianaOdF': [1,5], 'ZmianaDoF': [1,5], 'NieZaakceptowaneF': [1,5], 'WszystkieF': [1,5],
             'NrSrodkaF': [1,5], 'NrSeriiF': [1,5], 'NazwaSrodkaF': [1,5],  #WS 2022-12-09
             'Srodek': [20], 'Miejsce': [11, 12, 20], 'Operator': [12], 'DataOd': [20]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_srodki_trwale_zmiana_miejsca z numerem '\
               +str(Funkcja)+' bez parametrw: '+Lista

dane = []
wyn1 = []
wyn2 = []
emaile_bledy = []
MiejscaOp = []

Puste = (None, '', '    -  -  ', 'None', '-  -')

Insert = []
Update = []
Delete = []
oddzial_id = self.oddzial_id
UprPodglad = ((oddzial_id, '806000') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprZmiana = ((oddzial_id, '174600') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

if stat == 'OK':
    if Funkcja == 1:
        Update = klucze['Update']

    if Funkcja in (1, 5, 20):
        MiejsceF = rsglobal.Dekoduj(klucze['MiejsceF'])
        ZmianaOdF = rsglobal.Dekoduj(klucze['ZmianaOdF'])
        ZmianaDoF = rsglobal.Dekoduj(klucze['ZmianaDoF'])
        NieZaakceptowaneF = rsglobal.Dekoduj(klucze['NieZaakceptowaneF'])
        WszystkieF = rsglobal.Dekoduj(klucze['WszystkieF'])
        NrSrodkaF = rsglobal.Dekoduj(klucze['NrSrodkaF'])  #WS 2022-12-09
        NrSeriiF = rsglobal.Dekoduj(klucze['NrSeriiF'])  #WS 2022-12-09
        NazwaSrodkaF = rsglobal.Dekoduj(klucze['NazwaSrodkaF'])  #WS 2022-12-09

    if Funkcja in (11, 12):
        Miejsce = rsglobal.Dekoduj(klucze['Miejsce']).strip()

    if Funkcja == 12:
        Operator = rsglobal.Dekoduj(klucze['Operator'])

    if Funkcja == 20:
        Srodek = rsglobal.Dekoduj(klucze['Srodek'])
        Miejsce = rsglobal.Dekoduj(klucze['Miejsce'])
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])


def czy_dobry_zakres_operator_id(liczba):
    return str(liczba).strip().isdigit() and (0 <= int(liczba) <= (2**16)/2)


# -------------------------------------------------------------------------------
# ---   POBRANIE MIEJSC Z OPERATORA (10)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (10, 11, 20, 1, 5):
    SEL = """SELECT CONCAT(op.miejsca_uzytkowania, (',' || zast.miejsca_uzytkowania))
             FROM rs_operatorzy op
             LEFT OUTER JOIN rs_operatorzy zast ON (op.operator_id=zast.zastepca_id)
             WHERE op.operator_id={self.operator_id};""".format(**locals())
    rsglobal.ZapiszDoLogow('Pobranie miejsc dla zalogowanego op: '+SEL)
    stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania miejsc uytkowania zdefiniowanych dla zalogowanego operatora'
    else:
        MiejscaOp = []
        if d[0][0] not in Puste:
            MiejscaOp = d[0][0].split(",")

        if Funkcja == 10:
            dane = MiejscaOp

# -------------------------------------------------------------------------------
# ---   POBRANIE LISTY OPERATORW (11)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    SQL = """SELECT DISTINCT op.operator_id, op.aktywny, op.login, op.imie, op.nazwisko, op.duplikat
             FROM rs_operatorzy op
             LEFT OUTER JOIN rs_operatorzy zastepuje ON (op.operator_id=zastepuje.zastepca_id)
             LEFT OUTER JOIN rs_operatorzy zastepca ON (op.zastepca_id=zastepca.operator_id)
             WHERE NOT op.login='raporty' AND NOT op.login='harmonogram' AND (op.aktywny AND COALESCE(zastepca.aktywny, True))
                   AND %s=ANY(array_cat(string_to_array(op.miejsca_uzytkowania, ','), string_to_array(zastepuje.miejsca_uzytkowania, ','))) ORDER BY op.nazwisko,op.imie;"""
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, [Miejsce]))
    stat, dane, wyn2, dump = self.PolSQL.Execute(SQL, 3, [Miejsce])
    if stat != 'OK':
        stat = 'Bd pobrania listy operatorw: '+stat

# -------------------------------------------------------------------------------
# ---   POBRANIE IMIENIA I NAZWISKA OPERATORA (12)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    if Operator == '' or not czy_dobry_zakres_operator_id(Operator):
        Operator = None

    SQL = """SELECT CONCAT(op.imie, ' ', op.nazwisko)
             FROM rs_operatorzy op
             LEFT OUTER JOIN rs_operatorzy zastepuje ON (op.operator_id=zastepuje.zastepca_id)
             LEFT OUTER JOIN rs_operatorzy zastepca ON (op.zastepca_id=zastepca.operator_id)
             WHERE NOT op.login='raporty' AND NOT op.login='harmonogram' AND (op.aktywny AND COALESCE(zastepca.aktywny, True))
                   AND %s=ANY(array_cat(string_to_array(op.miejsca_uzytkowania, ','), string_to_array(zastepuje.miejsca_uzytkowania, ','))) AND op.operator_id=%s;"""
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, [Miejsce, Operator]))
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, [Miejsce, Operator])
    if stat != 'OK':
        stat = 'Bd pobrania danych operatora: '+stat

# -------------------------------------------------------------------------------
# ---   AKCEPTUJ (20)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 20:
    if not UprZmiana:
        stat = 'BR_UPR_MOD'

    if stat == 'OK':
        # pobranie daty przekazania
        SQL = """SELECT przekazanie_miejsce, to_char(przekazanie_kiedy, 'YYYY-MM-DD'), przyjecie_kto, op.zastepca_id
                 FROM rs_srodki_trwale_miejsca_uzytkowania mu
                 LEFT OUTER JOIN rs_operatorzy op ON (mu.przyjecie_kto=op.operator_id)
                 WHERE firma_id=%s AND miejsce_id=%s AND srodek_id=%s AND data_od=%s;"""
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, [self.firma_id, Miejsce, Srodek, DataOd]))
        stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, [self.firma_id, Miejsce, Srodek, DataOd])
        if stat != 'OK':
            stat = "Bd pobrania daty przekazania: "+stat
        elif len(d) == 0:
            stat = 'Brak wiersza o podanym kluczu: ('+Miejsce+', '+Srodek+', '+DataOd+')'
        else:
            przekazanie_miejsce = rsglobal.Dekoduj(d[0][0]).strip()
            przekazanie_kiedy = rsglobal.Dekoduj(d[0][1]).strip()
            przyjecie_kto = rsglobal.Dekoduj(d[0][2])
            zast_przyjecie_kto = rsglobal.Dekoduj(d[0][3])

        if stat == 'OK':
            if przekazanie_miejsce not in MiejscaOp:
                stat = 'BR_UPR_MIEJSCE_PRZEKAZ$'+przekazanie_miejsce

            if int(self.operator_id) not in (przyjecie_kto, zast_przyjecie_kto):
                stat = 'BR_UPR_OP_AKCEPT'

        if stat == 'OK':
            # wpisanie daty przekazania jako dat do aktualnego wiersza i utworzenie nowego
            UPDINS = """UPDATE rs_srodki_trwale_miejsca_uzytkowania 
                        SET data_do=%s, przyjecie_kiedy=NOW(), przyjecie_kto=%s
                        WHERE firma_id=%s AND miejsce_id=%s AND srodek_id=%s AND data_od=%s;
                        INSERT INTO rs_srodki_trwale_miejsca_uzytkowania (firma_id, miejsce_id, srodek_id, data_od)
                        VALUES (%s, %s, %s, %s::DATE + INTERVAL '1 DAY');"""
            args = [przekazanie_kiedy, self.operator_id, self.firma_id, Miejsce, Srodek, DataOd, self.firma_id, przekazanie_miejsce,
                    Srodek, przekazanie_kiedy]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(UPDINS, args))  #AB 14.12.22r data od = data_do + dzien
            stat, dump, dump, dump = self.PolSQL.Execute(UPDINS, 1, args)
            if stat != 'OK':
                stat = "Bd przy akceptowaniu zmiany: "+stat
                dane.append(stat)

# -------------------------------------------------------------------------------
# ---   SPRAWDZENIE I ZAPIS ZMIAN (1)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprZmiana or len(MiejscaOp) == 0:
            stat = 'BR_UPR_MOD'
            dane.append(stat)

        if stat == 'OK':
            # pobranie wczeniej zapisanych wartoci dla wierszy w ktrych co si zmienio
            # i zapisanie ich do sownika poprzednie_wart, gdzie kluczem jest klucz wiersza
            SQL = """SELECT miejsce_id, srodek_id, data_od, przekazanie_miejsce, przyjecie_kto::TEXT, COALESCE(to_char(przyjecie_kiedy, 'YYYY-MM-DD HH24:MI:SS'),'') as przyjecie_kiedy
                     FROM rs_srodki_trwale_miejsca_uzytkowania
                     WHERE firma_id=%s AND (miejsce_id, srodek_id, data_od) IN ("""
            zmienne = [self.firma_id]

            klucze = Update[2]
            SQL += "(%s, %s, %s),"*len(klucze)
            for klucz in klucze:
                zmienne.extend([str(klucz[0]), str(klucz[1]), str(klucz[2])])

            SQL = SQL.strip(",")+");"
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify('Pobr wczeniejszych wart: '+SQL, zmienne))
            stat, d, w1, w2 = self.PolSQL.Execute(SQL, 3, zmienne)
            if stat != 'OK':
                stat = 'Bad pobrania wczeniej zapisanych wartoci: '+stat
                dane.append(stat)
            else:
                tr = rssql.RSTableRowset2(d, w1)

                poprzednie_wart = {}
                for wiersz in tr:
                    poprzednie_wart[(wiersz['miejsce_id'], wiersz['srodek_id'], wiersz['data_od'])] = wiersz

        if stat == 'OK':
            emaile = []  #WS 2023-02-27

            for i, (pola, wartosci, klucz, nr_wiersza) in enumerate(zip(Update[0], Update[1], Update[2], Update[-1])):
                # sprawdzenie czy operator ma uprawnienia do miejsca w modyfikowanym wierszu
                miejsce_id = Update[2][i][Update[3].index('miejsce_id')].strip()
                if miejsce_id not in MiejscaOp:
                    wyn2.append((nr_wiersza, 0))
                    dane.append('BR_UPR_MIEJSCE$'+miejsce_id)
                # sprawdzenie czy wiersz nie zosta ju zaakceptowany
                if poprzednie_wart[tuple(klucz)]['przyjecie_kiedy'] != '':
                    wyn2.append((nr_wiersza, 0))
                    dane.append('BL_WIERSZ')

                for pole, wart in zip(pola, wartosci):
                    if pole == 'przekazanie_miejsce':
                        wart = str(wart).strip()

                        if wart in Puste:
                            wyn2.append((nr_wiersza, 6))
                            dane.append('BR_PRZEKAZ_MIEJ')
                        else:
                            SQL = """SELECT 1 FROM rs_miejsca_uzytkowania
                                     WHERE firma_id=%s AND kod=%s;"""
                            stat, miejsce, dump, dump = self.PolSQL.Execute(SQL, 3, [self.firma_id, wart])
                            if stat != 'OK':
                                wyn2.append((nr_wiersza, 6))
                                dane.append('Bd weryfikacji miejsca uytkowania ze sownikiem: '+stat)
                            elif len(miejsce) == 0:
                                wyn2.append((nr_wiersza, 6))
                                dane.append('BL_PRZEKAZ_MIEJ$'+wart)
                            else:
                                if 'przyjecie_kto' in pola:
                                    przyjecie_kto = str(wartosci[pola.index('przyjecie_kto')]).strip()
                                else:
                                    przyjecie_kto = str(poprzednie_wart[tuple(klucz)]['przyjecie_kto'])

                                if przyjecie_kto not in Puste and czy_dobry_zakres_operator_id(przyjecie_kto):
                                    # sprawdzenie czy miejsce prawidowe dla operatora
                                    SQL = """SELECT %s=ANY(array_cat(string_to_array(op.miejsca_uzytkowania, ','), string_to_array(zastepuje.miejsca_uzytkowania, ','))), op.aktywny AND COALESCE(zastepca.aktywny, True)
                                             FROM rs_operatorzy op
                                             LEFT OUTER JOIN rs_operatorzy zastepuje ON (op.operator_id=zastepuje.zastepca_id)
                                             LEFT OUTER JOIN rs_operatorzy zastepca ON (op.zastepca_id=zastepca.operator_id)
                                             WHERE NOT op.login='raporty' AND NOT op.login='harmonogram'
                                                   AND op.operator_id=%s;"""
                                    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify('Spr. miejsce i op: '+SQL, [wart, przyjecie_kto]))
                                    stat, miejsce_op, dump, dump = self.PolSQL.Execute(SQL, 3, [wart, przyjecie_kto])
                                    if stat != 'OK':
                                        wyn2.append((nr_wiersza, 6))
                                        dane.append('Bd weryfikacji miejsca uytkowania z id operatora: '+stat)
                                    elif len(miejsce_op) == 0:
                                        wyn2.append((nr_wiersza, 11))
                                        dane.append('BL_OPERATOR$'+przyjecie_kto)
                                    elif not miejsce_op[0][1]:
                                        wyn2.append((nr_wiersza, 11))
                                        dane.append('BL_OP_NIEAKT')
                                    elif not miejsce_op[0][0]:
                                        wyn2.append((nr_wiersza, 6))
                                        dane.append('BL_PRZEKAZ_MIEJ_OP')
                                elif 'przyjecie_kto' not in pola:
                                    wyn2.append((nr_wiersza, 11))
                                    dane.append('BR_OPERATOR')

                    elif pole == 'przyjecie_kto':
                        wart = str(wart).strip()

                        if wart in Puste:
                            wyn2.append((nr_wiersza, 11))
                            dane.append('BR_OPERATOR')
                        else:
                            SQL = """SELECT op.operator_id, op.aktywny AND COALESCE(zastepca.aktywny, True), op.email, op.imie, op.nazwisko
                                     FROM rs_operatorzy op
                                     LEFT OUTER JOIN rs_operatorzy zastepca ON (op.zastepca_id=zastepca.operator_id)
                                     WHERE op.operator_id=%s AND NOT op.login='raporty' AND NOT op.login='harmonogram';"""
                            stat, operator, wyn_operator, dump = self.PolSQL.Execute(SQL, 3, [wart if wart not in Puste and czy_dobry_zakres_operator_id(wart) else None])
                            if stat != 'OK':
                                wyn2.append((nr_wiersza, 11))
                                dane.append('Bd weryfikacji id operatora: '+stat)
                            elif len(operator) == 0:
                                if 'BL_OPERATOR$'+wart not in dane:
                                    wyn2.append((nr_wiersza, 11))
                                    dane.append('BL_OPERATOR$'+wart)
                            elif not operator[0][1]:
                                if 'BL_OP_NIEAKT' not in dane:
                                    wyn2.append((nr_wiersza, 11))
                                    dane.append('BL_OP_NIEAKT')
                            else:
                                if 'przekazanie_miejsce' in pola:
                                    przekazanie_miejsce = str(wartosci[pola.index('przekazanie_miejsce')]).strip()
                                else:
                                    przekazanie_miejsce = str(poprzednie_wart[tuple(klucz)]['przekazanie_miejsce']).strip()

                                if przekazanie_miejsce not in Puste:
                                    if 'BL_PRZEKAZ_MIEJ_OP' not in dane:
                                        # sprawdzenie czy operator zgodny z miejscem
                                        SQL = """SELECT %s=ANY(array_cat(string_to_array(op.miejsca_uzytkowania, ','), string_to_array(zastepuje.miejsca_uzytkowania, ',')))
                                                 FROM rs_operatorzy op
                                                 LEFT OUTER JOIN rs_operatorzy zastepuje ON (op.operator_id=zastepuje.zastepca_id)
                                                 LEFT OUTER JOIN rs_operatorzy zastepca ON (op.zastepca_id=zastepca.operator_id)
                                                 WHERE NOT op.login='raporty' AND NOT op.login='harmonogram' AND (op.aktywny AND COALESCE(zastepca.aktywny, True))
                                                       AND op.operator_id=%s;"""
                                        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify('Spr. op i miejsce: '+SQL, [przekazanie_miejsce, wart]))
                                        stat, miejsce_op, dump, dump = self.PolSQL.Execute(SQL, 3, [przekazanie_miejsce, wart])
                                        if stat != 'OK':
                                            wyn2.append((nr_wiersza, 11))
                                            dane.append('Bd weryfikacji id operatora z miejscem uytkowania: '+stat)
                                        elif not miejsce_op[0][0] and 'BL_PRZEKAZ_MIEJ$'+przekazanie_miejsce not in dane:
                                            wyn2.append((nr_wiersza, 11))
                                            dane.append('BL_OP_PRZEKAZ_MIEJ')
                                        else:
                                            #WS 2023-02-27
                                            tr_operator = rssql.RSTableRowset2(operator, wyn_operator)[0]

                                            email_operator = str(tr_operator['operator_id'])+' - '+tr_operator['imie']+' '+tr_operator['nazwisko']
                                            email_adres = tr_operator['email'] if tr_operator['email'].strip() not in Puste else None
                                            email_srodek = poprzednie_wart[tuple(klucz)]['srodek_id']
                                            emaile.append([email_operator, email_adres, email_srodek])
                                elif 'przekazanie_miejsce' not in pola:
                                    wyn2.append((nr_wiersza, 6))
                                    dane.append('BR_PRZEKAZ_MIEJ')

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            UPD = ''
            zmienne = []
            zapisywac = False

            for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
                UPD += "UPDATE rs_srodki_trwale_miejsca_uzytkowania SET przekazanie_kto=%s, przekazanie_kiedy=NOW(),"
                zmienne.append(self.operator_id)
                for pole, wart in zip(pola, wartosci):
                    if pole in ('przekazanie_miejsce', 'przyjecie_kto'):
                        zapisywac = True
                        UPD += pole+"=%s,"
                        zmienne.append(str(rsglobal.Dekoduj(wart)).strip())

                UPD = UPD.strip(",")
                UPD += " WHERE firma_id=%s AND (data_do>=NOW()::DATE OR data_do IS NULL) AND przyjecie_kiedy IS NULL"
                zmienne.append(self.firma_id)

                for pole, wart in zip(Update[3], klucz):  # petla po kluczu
                    UPD += " AND "+pole+"=%s"
                    zmienne.append(str(rsglobal.Dekoduj(wart)))

                UPD += ";"
            if zapisywac:
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify('Zapis zmiana miejsca: '+UPD, zmienne))
                stat,dump,dump,dump=self.PolSQL.Execute(UPD, 1, zmienne)
                if stat != 'OK':
                    stat = "Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)
                #WS 2023-02-27 - informacja e-mailem do operatora o przekazaniu rodka
                else:
                    for email in emaile:
                        email_operator = email[0]
                        email_adres = email[1]
                        email_srodek = email[2]
                        email_temat = 'Informacja o przypisanym rodku trwaym.'
                        email_tresc = 'Informujemy, e rodek trway o numerze: '+email_srodek.strip()+' zosta przypisany do Pani / Pana i oczekuje na potwierdzenie przyjcia.'
                        if email_adres is not None:
                            stat_email = rsglobal.RSWyslijEmail(email_adres, email_temat, email_tresc, [], 0, self.PolSQL)
                            if stat_email != 'OK':
                                emaile_bledy.append("Bd przy wysyaniu wiadomoci e-mail do operatora "+email_operator+": "+stat_email)
                        else:
                            emaile_bledy.append("Dla operatora "+email_operator+" nie wprowadzono adresu e-mail na ktry mona by wysa informacj o przekazaniu rodka trwaego")

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (1,5,20)
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5, 20):
    if not UprZmiana and not UprPodglad:
        stat = 'BR_UPR'

    if stat == 'OK':
        MiejscaOpDoZapytania = "','".join(MiejscaOp)
        War = 'FALSE'
        WarFiltry = ''
        zmienne = []

        if (UprPodglad and len(MiejscaOp) > 0 and not WszystkieF) or (not UprPodglad and len(MiejscaOp) > 0):
            War = """((stmu.miejsce_id IN ('{MiejscaOpDoZapytania}') OR (stmu.przekazanie_miejsce IN ('{MiejscaOpDoZapytania}') AND stmu.przyjecie_kto = '{self.operator_id}')) AND (stmu.data_do>=NOW()::DATE OR stmu.data_do IS NULL))""".format(**locals())
        elif UprPodglad and ((len(MiejscaOp) > 0 and WszystkieF) or len(MiejscaOp) == 0):
            War = 'TRUE'

        if UprPodglad:
            if MiejsceF != '':
                WarFiltry += ' AND (miejsce_id=%s OR przekazanie_miejsce=%s)'
                zmienne.extend([MiejsceF, MiejsceF])

            if NieZaakceptowaneF:
                WarFiltry += " AND COALESCE(stmu.przekazanie_miejsce,'')!='' AND COALESCE(stmu.przyjecie_kto::TEXT,'')!='' AND przyjecie_kiedy IS NULL"

            if ZmianaOdF not in Puste and rsglobal.SprawdzCzyToData(ZmianaOdF):
                WarFiltry += " AND przekazanie_kiedy::DATE >= '{}'".format(ZmianaOdF)  #WS 2022-10-28

            if ZmianaDoF not in Puste and rsglobal.SprawdzCzyToData(ZmianaDoF):
                WarFiltry += " AND przekazanie_kiedy::DATE <= '{}'".format(ZmianaDoF)  #WS 2022-10-28

            #WS 2022-12-09
            if NrSrodkaF != '':
                WarFiltry += ' AND stmu.srodek_id LIKE %s'
                zmienne.append(NrSrodkaF+'%')

            #WS 2022-12-09
            if NrSeriiF != '':
                WarFiltry += ' AND st.nr_serii LIKE %s'
                zmienne.append(NrSeriiF+'%')

            #WS 2022-12-09
            if NazwaSrodkaF != '':
                WarFiltry += ' AND st.nazwa LIKE %s'
                zmienne.append(NazwaSrodkaF+'%')

        WszystkieWar = WszystkieF if (UprPodglad and len(MiejscaOp) > 0) else False

        SEL = """SELECT stmu.miejsce_id, mu1.opis AS miejsce_opis, stmu.srodek_id, st.nazwa AS srodek_nazwa, stmu.data_od, stmu.data_do,
                        TRIM(COALESCE(stmu.przekazanie_miejsce,'')) AS przekazanie_miejsce, COALESCE(mu2.opis,'') AS przekazanie_miejsce_opis,
                        COALESCE(stmu.przekazanie_kto::TEXT,'') AS przekazanie_kto, COALESCE(CONCAT(op1.imie, ' ', op1.nazwisko),'') as przekazanie_imie_nazwisko, COALESCE(to_char(stmu.przekazanie_kiedy, 'YYYY-MM-DD HH24:MI:SS'),'') as przekazanie_kiedy,
                        COALESCE(stmu.przyjecie_kto::TEXT,'') AS przyjecie_kto, COALESCE(CONCAT(op2.imie, ' ', op2.nazwisko),'') as przyjecie_kto_imie_nazwisko, COALESCE(to_char(stmu.przyjecie_kiedy, 'YYYY-MM-DD HH24:MI:SS'),'') as przyjecie_kiedy,
                        CASE WHEN stmu.przekazanie_miejsce IN ('{MiejscaOpDoZapytania}') AND COALESCE(stmu.przekazanie_miejsce,'')!='' AND {self.operator_id} IN (stmu.przyjecie_kto,op2.zastepca_id) AND NOT {WszystkieWar} AND przyjecie_kiedy IS NULL THEN 2
                             WHEN stmu.przekazanie_miejsce IN ('{MiejscaOpDoZapytania}') AND COALESCE(stmu.przekazanie_miejsce,'')!='' AND COALESCE(stmu.przyjecie_kto::TEXT,'')!='' AND NOT {WszystkieWar} AND przyjecie_kiedy IS NOT NULL THEN 3
                             WHEN stmu.miejsce_id IN ('{MiejscaOpDoZapytania}') AND NOT {WszystkieWar} AND przyjecie_kiedy IS NULL THEN 1
                             ELSE 4 END AS tryb
                 FROM rs_srodki_trwale_miejsca_uzytkowania stmu
                 LEFT OUTER JOIN rs_miejsca_uzytkowania mu1 ON (stmu.firma_id=mu1.firma_id AND stmu.miejsce_id=mu1.kod)
                 LEFT OUTER JOIN rs_miejsca_uzytkowania mu2 ON (stmu.firma_id=mu2.firma_id AND stmu.przekazanie_miejsce=mu2.kod)
                 LEFT OUTER JOIN rs_srodki_trwale st ON (stmu.firma_id=st.firma_id AND stmu.srodek_id=st.srodek_id)
                 LEFT OUTER JOIN rs_operatorzy op1 ON (stmu.przekazanie_kto=op1.operator_id)
                 LEFT OUTER JOIN rs_operatorzy op2 ON (stmu.przyjecie_kto=op2.operator_id)
                 WHERE stmu.firma_id='{self.firma_id}' AND {War} {WarFiltry} AND (st.data_sprzedazy IS NULL OR st.data_sprzedazy > NOW()::DATE) AND (st.data_likwidacji IS NULL OR st.data_likwidacji > NOW()::DATE) ORDER BY stmu.miejsce_id, stmu.srodek_id, stmu.data_od;""".format(**locals())
        rsglobal.ZapiszDoLogow('Pobr danych zmiana miejsca: '+SEL)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, zmienne)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
        else:
            wyn2 = list(set(emaile_bledy))  #WS 2023-02-27
