# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_status
# Purpose:     zwraca informacje o statusie wymiany plikw midzy serwerami
#
# Author:      Piotr Szydeko
# Created:     2009/01/02
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

import datetime

Fun = 7
if klucze:
    Fun = klucze[-1]

stat = "OK"
dane = []

komser = rs_anakonda_server_komser.zarzadcaTransportu
IN = rs_anakonda_server_komser.Magazyn.IN
OUT = rs_anakonda_server_komser.Magazyn.OUT

UprPrz = self.operator_id == STANDARD_OPERATOR_ID or (self.oddzial_id, '001810') in self.uprawnienia

if not UprPrz:
    stat = "UPR"
elif not komser.uruchomiony:
    stat = "BL ZATRZYMANY"
elif Fun == 7:
    nazwa = komser.opcje["komsernazwa"]
    klienci = [x.strip() for x in komser.opcje["komserklienci"].split(",")]
    katalog = komser.opcje["komserkatalog"]
    wyswietleni = {}
    wyn2 = [unicode(nazwa)]
    # dla kadego klienta zwrcona bdzie picioelementowa lista:
    #   1. nazwa
    #   2. kiedy by wygenerowany ostatni plik dla niego
    #   3.           potwierdzony przez niego ostatni odbir pliku
    #   4.       ostatni plik od niego zosta odebrany
    #   5.       ostatni plik od niego zosta przetworzony poprawnie
    for serwer in klienci:
        if serwer in wyswietleni:
            continue
        wyswietleni[serwer] = None
        if not os.path.isdir(os.path.join(katalog, serwer)):
            row = [unicode(serwer), u"BRAK", u"KATALOGU", u"DLA", unicode(serwer)]
        else:
            row = [unicode(serwer)]
            for kier in (IN, OUT):
                skatalog = os.path.join(katalog, serwer, kier)
                if not os.path.isdir(skatalog):
                    row.extend([u"brak", u"katalogu"])
                else:
                    files = [os.path.join(skatalog, x) for x in os.listdir(skatalog) if not x.startswith("_")]
                    tstampd = os.stat(skatalog).st_mtime + 600
                    tstamp = min([os.stat(x).st_mtime for x in files if os.path.isfile(x)] + [tstampd])
                    if tstamp != tstampd:
                        row.append(unicode(datetime.datetime.fromtimestamp(tstamp).strftime("%Y-%m-%d %T")))
                    else:
                        row.append(u"")
                    starekat = os.path.join(skatalog, "stare")
                    if not os.path.isdir(starekat):
                        row.append(u"---")
                    else:
                        tstamp = os.stat(starekat).st_mtime
                        row.append(unicode(datetime.datetime.fromtimestamp(tstamp).strftime("%Y-%m-%d %T")))
        dane.append(row)

elif Fun == 8:
    msg = ""
    msg += "Zapis wykonania ostatnich wywoa przetwarzania danych:\n\n"
    stat, dane, none, none = self.PolSQL.Execute("select uruchomione, stat, COALESCE(wypisane || '\\n', '') from rs_harmonogram_zadan_log where harmzad_id = (select harmzad_id from rs_harmonogram_zadan where nazwa='fs_komser_wczytaj') order by uruchomione desc limit 5", 2)
    if stat == "OK":
        for row in dane:
            msg += "  %s %s\n%s" % (row[0], row[1], row[2])
    else:
        msg += stat + "\n"

    msg += "\n---------------------------------------------------\n"
    msg += "Kocwka logu harmonogramu zada\n\n"

    if True:
        lines = []
        plik_log = open("harmonogram.log")
        plik_log.seek(0, 2)
        if plik_log.tell() > 2**21:
            plik_log.seek(-2**21, 2)
        for line in plik_log:
            lines.append(line)
            if len(lines) == 51:
                lines.pop(0)
        msg += "".join(lines)

    msg += "\n---------------------------------------------------\n"
    msg += "Zawarto najstarszych nieprzetworzonych plikw\n\n"

    klienci = [x.strip() for x in komser.opcje["komserklienci"].split(",")]
    katalog = komser.opcje["komserkatalog"]
    for serwer in klienci:
        skatalog = os.path.join(katalog, serwer, OUT)
        msg += "Katalog %s\n" % skatalog
        if not os.path.isdir(skatalog):
            msg += "\tnie istnieje\n"
            continue
        pliki = os.walk(skatalog).next()[2]
        pliki = [(int(os.path.splitext(x)[0].split("_")[-1]), x) for x in pliki if x[0] not in (".", "_")]
        if not pliki:
            continue
        pierwszy = min(pliki)[1]
        sciezka = os.path.join(skatalog, pierwszy)
        msg += "PLIK    %s zawiera:\n" % sciezka
        msg += open(sciezka).read()
        msg += "\n"

    dane = [msg]
