# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje.py
# Purpose:     grid ubojow
# Author:      Mariusz Rajfura
# Created:     2013/09/09
# RCS-ID:      $Id: fs_uboje.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_dokumenty_magazynowe_pom

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'StanF':(5,6,11,12,21), 'KontrahentF':(5,6,11,12,21),
           'DataOdF':(5,6,11,12,21), 'DataDoF':(5,6,11,12,21),
           'Data':(6,11,12,21), 'NumerUboju':(6,11,12,21),
           'MagazynZywca':(12,),'DokumentPZ':(12,), 'DataPZ':(12,),
           'MagazynPoltusz':(12,),'DokumentPW':(12,), 'DataPW':(12,),
           }
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,6,11,12,21): 
        StanF = rsglobal.Dekoduj(klucze['StanF'])
        KontrahentF = rsglobal.Dekoduj(klucze['KontrahentF'])
        DataOdF = rsglobal.Dekoduj(klucze['DataOdF'])
        DataDoF = rsglobal.Dekoduj(klucze['DataDoF'])

    if Funkcja in (6,11,12,21): 
        Data = rsglobal.Dekoduj(klucze['Data'])
        NumerUboju = rsglobal.Dekoduj(klucze['NumerUboju'])

    if Funkcja in (12,): 
        MagazynZywca = rsglobal.Dekoduj(klucze['MagazynZywca'])
        DokumentPZ = rsglobal.Dekoduj(klucze['DokumentPZ'])
        DataPZ = rsglobal.Dekoduj(klucze['DataPZ'])
        MagazynPoltusz = rsglobal.Dekoduj(klucze['MagazynPoltusz'])
        DokumentPW = rsglobal.Dekoduj(klucze['DokumentPW'])
        DataPW = rsglobal.Dekoduj(klucze['DataPW'])
        
UprUsuwanie = (((self.oddzial_id,'601004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZamykanie = (((self.oddzial_id,'601006') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprOtwieranie = (((self.oddzial_id,'601007') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrzygotowanie = (((self.oddzial_id,'601008') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   USUWANIE UBOJU (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania ubojw'

    if stat == 'OK':
        sql = "SELECT stan FROM rs_uboje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" FOR UPDATE;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia uboju: '+stat
        elif len(d) == 0:
            stat = 'Brak uboju o podanym kluczu'
        elif rsglobal.Dekoduj(d[0][0]) <> 'W':
            stat = 'Ubj w stanie '+d[0][0]+'. Usunicie niemoliwe.'

    if stat == 'OK':
        DELETE ="DELETE FROM rs_uboje"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        DELETE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(DELETE,1)
        if stat <> 'OK':
            stat = 'Bd usuwania uboju: '+stat


#-------------------------------------------------------------------------------
#---   PRZYGOTOWANIE UBOJU W->G (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    if not UprPrzygotowanie:
        stat = 'Brak uprawnie do przygotowania ubojw do produkcji'

    if stat == 'OK':
        sql = "SELECT stan,liczba_sztuk FROM rs_uboje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" FOR UPDATE;"
        
        stat,uboj,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia uboju: '+stat
        elif len(uboj) == 0:
            stat = 'Brak uboju o podanym kluczu'
        elif uboj[0][0] <> 'W':
            stat = 'Ubj w stanie '+uboj[0][0]+'. Przygotowanie niemoliwe.'
        elif uboj[0][1] == 0:
            stat = 'Nie podano planowanej iloci sztuk do uboju. Przygotowanie niemoliwe.'

    if stat == 'OK':
        sql ="SELECT ilosc1 FROM rs_uboje_zywce"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" ORDER BY nr_poz; "
        
        stat,zywce,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o ywcach do uboju: '+stat
        elif len(zywce) == 0:
            stat = 'Brak pozycji ywcw do uboju'

        if stat == 'OK':
            suma = 0
            for i in xrange(len(zywce)):
                suma += zywce[i][0]
        
            if suma <> uboj[0][1]:
                stat = 'Niezgodna z zadeklarowan liczba ywcw do uboju.\n'+\
                       'Zadeklarowano '+rsglobal.UsunKropkaZero(uboj[0][1])+' szt'+\
                       ' a zarejestrowano '+rsglobal.UsunKropkaZero(suma)+' szt'

    if stat == 'OK':
        UPDATE ="UPDATE rs_uboje SET stan='G'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        UPDATE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd przygotowania danych uboju do produkcji: '+stat


#-------------------------------------------------------------------------------
#---   OTWARCIE UBOJU G->W (21)
#-------------------------------------------------------------------------------

if Funkcja == 21 and stat == 'OK':
    if not UprOtwieranie:
        stat = 'Brak uprawnie do otwierania przygotowanych ubojw do produkcji'

    if stat == 'OK':
        sql = "SELECT stan FROM rs_uboje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" FOR UPDATE;"
        
        stat,uboj,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia uboju: '+stat
        elif len(uboj) == 0:
            stat = 'Brak uboju o podanym kluczu'
        elif uboj[0][0] <> 'G':
            stat = 'Ubj w stanie '+uboj[0][0]+'. Otwarcie niemoliwe.'

    if stat == 'OK':
        sql ="SELECT artykul_id FROM rs_uboje_poltusze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"
        
        stat,zywce,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o ptuszach z uboju: '+stat
        elif len(zywce) > 0:
            stat = 'Ubj posiada ptusze z uboju. Otwarcie niemoliwe.'

    if stat == 'OK':
        UPDATE ="UPDATE rs_uboje SET stan='W'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        UPDATE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd otwarcia danych uboju do edycji: '+stat


#-------------------------------------------------------------------------------
#---   ZAMKNIECIE UBOJU G->Z (11)
#-------------------------------------------------------------------------------

if Funkcja == 12 and stat == 'OK':
    if not UprZamykanie:
        stat = 'Brak uprawnie do zamykania ubojw.'

    if stat == 'OK':
        if not rsglobal.SprawdzCzyToData(DataPZ):
            stat = 'BL_DATA_PZ'

    if stat == 'OK':
        if not rsglobal.SprawdzCzyToData(DataPW):
            stat = 'BL_DATA_PW'

    if stat == 'OK':
        if DataPW < DataPZ:
            stat = 'BL_DATA_PZ_PW'

    if stat == 'OK':
        sql = "SELECT stan,kontrahent_id FROM rs_uboje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" FOR UPDATE;"
        
        stat,uboj,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia uboju: '+stat
        elif len(uboj) == 0:
            stat = 'Brak uboju o podanym kluczu'
        elif uboj[0][0] <> 'G':
            stat = 'Ubj w stanie '+uboj[0][0]+'. Zamkniecie niemoliwe.'

    if stat == 'OK':
        if DataPZ < Data:
            stat = 'BL_DATA_PZ_UBOJ'

    if stat == 'OK':
        if DataPW < Data:
            stat = 'BL_DATA_PW_UBOJ'


    if stat == 'OK':
        # lista pomierzonych poltusz
        sql ="SELECT up.numer_ubojowy,up.numer_poltuszy,up.artykul_id,"  # 0-2
        sql+=" up.ilosc1,up.ilosc2,"                                     # 3-4
        sql+=" COALESCE(a.cecha1_opis,''),COALESCE(up.klasyf_europ,'')"  # 5-6
        sql+=" FROM rs_uboje_poltusze up"
        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        sql+=" WHERE up.firma_id='"+self.firma_id+"' AND up.oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND up.data='"+Data+"' AND up.numer_uboju="+str(NumerUboju)
        sql+=" ORDER BY up.numer_ubojowy, up.numer_poltuszy; "
        
        stat,poltusze,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy ptusz z uboju: '+sql
        elif len(poltusze) == 0:
            stat = 'Brak pozycji ptuszy z uboju'

    if stat == 'OK':
        # pobranie zywcow, cecha1_wartosc=''
        sql ="SELECT uz.nr_poz,uz.artykul_id,uz.status,uz.ilosc1,uz.ilosc2," # 0-4
        sql+=" COALESCE(a.cecha1_opis,''),''"                                # 5-6
        sql+=" FROM rs_uboje_zywce uz"
        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        sql+=" WHERE uz.firma_id='"+self.firma_id+"' AND uz.oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND uz.data='"+Data+"' AND uz.numer_uboju="+str(NumerUboju)
        sql+=" ORDER BY uz.nr_poz; "
        
        stat,zywce,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy ywcw do uboju: '+sql
        elif len(zywce) == 0:
            stat = 'Brak pozycji ywcw do uboju.'

    if stat == 'OK':
        sql ="SELECT magazyn_id FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynZywca+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia magazynu ywca: '+stat
        elif len(d) == 0:
            stat = 'BL_MAGAZYN_PZ'

    if stat == 'OK':
        sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokumentPZ+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia symbolu dokumentu przyjcia ywca: '+stat
        elif len(d) == 0:
            stat = 'BL_DOKUMENT_PZ'

    if stat == 'OK':
        sql ="SELECT magazyn_id FROM rs_magazyny"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynPoltusz+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia magazynu ptusz: '+stat
        elif len(d) == 0:
            stat = 'BL_MAGAZYN_PW'

    if stat == 'OK':
        sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokumentPW+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia symbolu dokumentu przyjcia ptusz: '+stat
        elif len(d) == 0:
            stat = 'BL_DOKUMENT_PW'

    NumerPZ = 0
    NumerPW = 0
    INSPZ = ''
    INSPW = ''
    
    NrSerii = Data[2:4]+Data[5:7]+Data[8:]+'-'+rsglobal.UsunKropkaZero(NumerUboju)

    if stat == 'OK':
        #pobranie numeru dla nowego dokumentu PZ
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        sql+="'[\\\'"+MagazynZywca+"\\\',\\\'"+DokumentPZ+"\\\',\\\'"+DataPZ+"\\\']','M');"

        stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania nowego numeru dla '+DokumentPZ+' z magazynu '+MagazynZywca
        else:
            NumerPZ = int(dane[0][0])
            
    if stat == 'OK':
        # dodanie naglowka przyjecia zywca
        INSPZ ="INSERT INTO rs_dokumenty_magazynowe"
        INSPZ+=" (firma_id,magazyn_id,dokument_id,"
        INSPZ+=" data,numer,magazyn_dokad,kontrahent_id)"
        INSPZ+=" VALUES "
        INSPZ+=" ('"+self.firma_id+"','"+MagazynZywca+"','"+DokumentPZ+"',"
        INSPZ+="'"+DataPZ+"',"+str(NumerPZ)+",'"+MagazynZywca+"','"+rsglobal.Dekoduj(uboj[0][1])+"'); "

        # dodanie pozycji zywcow
        for i in xrange(len(zywce)):
            NumerZywca = rsglobal.UsunKropkaZero(zywce[i][0])
            Artykul = rsglobal.Dekoduj(zywce[i][1])
            Ilosc1 = rsglobal.Dekoduj(zywce[i][3])
            Ilosc2 = rsglobal.Dekoduj(zywce[i][4])
            Cecha1Opis = rsglobal.Dekoduj(zywce[i][5]).strip()
            Cecha1Wartosc = rsglobal.Dekoduj(zywce[i][6]).strip()
            
            if Cecha1Opis == '':
                Cecha1Opis = 'NULL'
                Cecha1Wartosc = ''
            else:
                Cecha1Opis = "'"+Cecha1Opis+"'"
                
            if Cecha1Wartosc == '':
                Cecha1Wartosc = 'NULL'
            else:
                Cecha1Wartosc = "'"+Cecha1Wartosc+"'"
                
            INSPZ+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
            INSPZ+=" (firma_id, magazyn_id, dokument_id, data,"
            INSPZ+="  numer, nr_poz, nr_ppoz, artykul_id,"
            INSPZ+="  ilosc1, ilosc2, cecha1_opis, cecha1_wartosc,"
            INSPZ+="  czy_seria,nr_serii)"
            INSPZ+=" VALUES"
            INSPZ+=" ('"+self.firma_id+"','"+MagazynZywca+"','"+DokumentPZ+"','"+DataPZ+"',"
            INSPZ+="  "+str(NumerPZ)+","+str(i+1)+",0,'"+Artykul+"',"
            INSPZ+="  "+str(Ilosc1)+","+str(Ilosc2)+","+Cecha1Opis+","+Cecha1Wartosc+","
            INSPZ+="  TRUE,'"+NrSerii+"-"+rsglobal.UsunKropkaZero(NumerZywca)+"'); "


    if stat == 'OK':
        #pobranie numeru dla nowego dokumentu PW
        sql ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        sql+="'[\\\'"+MagazynPoltusz+"\\\',\\\'"+DokumentPW+"\\\',\\\'"+DataPW+"\\\']','M');"

        stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd pobrania nowego numeru dla '+DokumentPW+' z magazynu '+MagazynPoltusz
        else:
            NumerPW = int(dane[0][0])

    if stat == 'OK':
        # dodanie naglowka przyjecia poltusz
        INSPW ="INSERT INTO rs_dokumenty_magazynowe"
        INSPW+=" (firma_id,magazyn_id,dokument_id,"
        INSPW+=" data,numer,magazyn_dokad)"
        INSPW+=" VALUES "
        INSPW+=" ('"+self.firma_id+"','"+MagazynPoltusz+"','"+DokumentPW+"',"
        INSPW+="'"+DataPW+"',"+str(NumerPW)+",'"+MagazynPoltusz+"'); "

        NrSerii = Data[2:4]+Data[5:7]+Data[8:]+'-'+rsglobal.UsunKropkaZero(NumerUboju)

        # dodanie pozycji poltusz
        for i in xrange(len(poltusze)):
            NumerUbojowy = rsglobal.UsunKropkaZero(poltusze[i][0])
            Artykul = rsglobal.Dekoduj(poltusze[i][2])
            Ilosc1 = rsglobal.Dekoduj(poltusze[i][3])
            Ilosc2 = rsglobal.Dekoduj(poltusze[i][4])
            Cecha1Opis = rsglobal.Dekoduj(poltusze[i][5]).strip()
            Cecha1Wartosc = rsglobal.Dekoduj(poltusze[i][6]).strip()
            
            if Cecha1Opis == '':
                Cecha1Opis = 'NULL'
                Cecha1Wartosc = ''
            else:
                Cecha1Opis = "'"+Cecha1Opis+"'"
                
            if Cecha1Wartosc == '':
                Cecha1Wartosc = 'NULL'
            else:
                Cecha1Wartosc = "'"+Cecha1Wartosc+"'"

            INSPW+="INSERT INTO rs_dokumenty_magazynowe_pozycje"
            INSPW+=" (firma_id,magazyn_id,dokument_id,data,"
            INSPW+="  numer,nr_poz,nr_ppoz,artykul_id,"
            INSPW+="  ilosc1,ilosc2,cecha1_opis,cecha1_wartosc,"
            INSPW+="  czy_seria,nr_serii)"
            INSPW+=" VALUES"
            INSPW+=" ('"+self.firma_id+"','"+MagazynPoltusz+"','"+DokumentPW+"','"+DataPW+"',"
            INSPW+="  "+str(NumerPW)+","+str(i+1)+",0,'"+Artykul+"',"
            INSPW+="  "+str(Ilosc1)+","+str(Ilosc2)+","+Cecha1Opis+","+Cecha1Wartosc+","
            INSPW+="  TRUE,'"+NrSerii+"-"+NumerUbojowy+"'); "
            
    if stat == 'OK':
        INSERT = ''
        INSERT += INSPZ
        INSERT += INSPW

        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
        if stat <> 'OK':
            stat = 'Bd dodawania dokumentw magazynowych: '+stat
            
    if stat == 'OK':
        stat = fs_dokumenty_magazynowe_pom.ZamknijDokumentMagazynowy(self,MagazynZywca,DokumentPZ,DataPZ,NumerPZ,'W','Z')

    if stat == 'OK':
        stat = fs_dokumenty_magazynowe_pom.ZamknijDokumentMagazynowy(self,MagazynPoltusz,DokumentPW,DataPW,NumerPW,'W','Z')

    if stat == 'OK':
        # zamkniecie uboju
        UPDATE ="UPDATE rs_uboje SET stan='Z'"
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        UPDATE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+"; "
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
        if stat <> 'OK':
            stat = 'Bd zamkniecia uboju: '+stat
        

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,6)
#-------------------------------------------------------------------------------

if Funkcja in (5,6,11,12,21) and stat=='OK':
    SQL ="SELECT u.stan,u.data,u.numer_uboju,u.liczba_sztuk,u.kontrahent_id,k.nazwa"
    SQL+=" FROM rs_uboje u"
    SQL+=" INNER JOIN rs_kontrahenci k USING(firma_id,kontrahent_id)"
    SQL+=" WHERE u.firma_id='"+self.firma_id+"' AND u.oddzial_id='"+self.oddzial_id+"'"

    if StanF <> '':
        SQL+=" AND u.stan='"+StanF+"'"

    if KontrahentF <> '':
        SQL+=" AND u.kontrahent_id='"+KontrahentF+"'"

    if DataOdF <> '    -  -  ':
        SQL+=" AND u.data>='"+DataOdF+"'"

    if DataDoF <> '    -  -  ':
        SQL+=" AND u.data<='"+DataDoF+"'"
        
    SQL+=" ORDER BY u.data DESC,u.numer_uboju DESC;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
