# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_artykuly.py
# Purpose:     grid podgladu artykulow z modulu linii ubojowej
#              uprawnienia identyczne, jak fs_artykuly.py
#              grid wartosci cech dla artykulow
# Author:      Mariusz Rajfura
# Created:     2013/09/09
# RCS-ID:      $Id: fs_uboje_artykuly.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'ArtykulF':(5,), 'NazwaF':(5,), 'KluczeF':(5,),
           'Cecha1OpisF':(25,),
           'Magazyn':(11,), 'Dokument':(11,), 'Data':(11,), 'Numer':(11,) }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_artykuly z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,): 
        ArtykulF = rsglobal.Dekoduj(klucze['ArtykulF'])
        NazwaF = rsglobal.Dekoduj(klucze['NazwaF'])
        KluczeF = rsglobal.Dekoduj(klucze['KluczeF'])
    
    if Funkcja in (11,):
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])

    if Funkcja in (25,): 
        Cecha1OpisF = rsglobal.Dekoduj(klucze['Cecha1OpisF'])


#-------------------------------------------------------------------------------
#---   POBRANIE STANU DOKUMENTU
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    sql+=" AND numer="+str(Numer)+"; "
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
    elif len(dane) == 0:
        stat = 'Brak dokumentu o podanym kluczu'
    

#-------------------------------------------------------------------------------
#---   KATALOG WARTOSCI DLA CECHY ARTYKULOW - POBRANIE DANYCH (25)
#-------------------------------------------------------------------------------

if Funkcja == 25 and stat=='OK':
    SQL ="SELECT wartosc,COALESCE(opis,'')"
    SQL+=" FROM rs_artykuly_cechy_wartosci"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha1OpisF+"'"
    SQL+=" ORDER BY kod;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   KATALOG ARTYKULOW - POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------

if Funkcja in (5,) and stat=='OK':
    MagazynF = ''
    
    if KluczeF.has_key('Magazyn'):
        # magazyn z klucza dokumentu
        MagazynF = KluczeF['Magazyn']
        
    elif KluczeF.has_key('MagazynF'):
        # magazyn z warunkow filtrowania
        MagazynF = KluczeF['MagazynF']
    
    if MagazynF == '':
        # bez magazynu tylko podglad artykulow do pobrania indeksu
        SQL ="SELECT artykul_id,nazwa,'',COALESCE(jm1,''),'',COALESCE(jm2,''),'',''"
        SQL+=" FROM rs_artykuly"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND aktywny"
        if ArtykulF <> '':
            SQL+=" AND UPPER(artykul_id) LIKE UPPER('"+ArtykulF+"%')"
    
        if NazwaF <> '':
            SQL+=" AND UPPER(nazwa) LIKE UPPER('"+NazwaF+"%')"
            
        SQL+=" ORDER BY artykul_id;"
        
        stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
            
    else:
        # wywolano z magazynem, wiec podamy stany (z cechami)

        sql ="SELECT ap.artykul_id,a.nazwa,"
        sql+=" SUM(ap.ilosc1),COALESCE(a.jm1,''),"
        sql+=" SUM(ap.ilosc2),COALESCE(a.jm2,''),"
        sql+=" TRIM(COALESCE(ap.cecha1_opis,'')),TRIM(COALESCE(ap.cecha1_wartosc,''))"
        sql+=" FROM rs_artykuly_przyjecia ap"
        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        sql+=" WHERE ap.firma_id='"+self.firma_id+"' AND ap.magazyn_id='"+MagazynF+"'"
        sql+=" AND NOT ap.wirtualne AND (ap.ilosc1>0 OR ap.ilosc2>0)"
        # tylko artykuly podlegajace filtrowaniu
        if ArtykulF <> '':
            sql+=" AND UPPER(ap.artykul_id) LIKE UPPER('"+ArtykulF+"%')"
        if NazwaF <> '':
            sql+=" AND UPPER(a.nazwa) LIKE UPPER('"+NazwaF+"%')"
            
        sql+=" GROUP BY ap.artykul_id,a.nazwa,a.jm1,a.jm2,ap.cecha1_opis,ap.cecha1_wartosc"
        sql+=" ORDER BY ap.artykul_id,ap.cecha1_opis,ap.cecha1_wartosc;"
        
        stat,stanym,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania sum z pozycji aktualnego dokumentu: '+stat

        if stat == 'OK':
            # czy podano klucz dokumentu do skorygowania stanow magazynowych
            if KluczeF.has_key('Magazyn') and KluczeF.has_key('Dokument') and \
               KluczeF.has_key('Data') and KluczeF.has_key('Numer'):
                   
                sql ="SELECT dm.stan,tdm.typ_dokumentu"
                sql+=" FROM rs_dokumenty_magazynowe dm"
                sql+=" INNER JOIN rs_typy_dokumentow_m tdm USING (firma_id,dokument_id)"
                sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+KluczeF['Magazyn']+"'"
                sql+=" AND dm.dokument_id='"+KluczeF['Dokument']+"' AND dm.data='"+KluczeF['Data']+"'"
                sql+=" AND dm.numer="+str(KluczeF['Numer'])+"; "
                
                stat,dokn,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania stanu dokumentu: '+stat
                elif len(dokn) == 0:
                    stat = 'Brak aktualnego dokumentu o podanym kluczu: '+stat


                elif dokn[0][0] in ('W','G'):
                    # dokument niezamkniety, wiec trzeba go uwzglednic
                    # sumujemy identycznie, jak stany z artykulow przyjec
                    
                    sql ="SELECT dmp.artykul_id,a.nazwa,"
                    sql+=" SUM(dmp.ilosc1),COALESCE(a.jm1,''),"
                    sql+=" SUM(dmp.ilosc2),COALESCE(a.jm2,''),"
                    sql+=" TRIM(COALESCE(dmp.cecha1_opis,'')),TRIM(COALESCE(dmp.cecha1_wartosc,''))"
                    sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
                    sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                    sql+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+KluczeF['Magazyn']+"'"
                    sql+=" AND dmp.dokument_id='"+KluczeF['Dokument']+"' AND dmp.data='"+KluczeF['Data']+"'"
                    sql+=" AND dmp.numer="+str(KluczeF['Numer'])
                    # tylko artykuly podlegajace filtrowaniu
                    if ArtykulF <> '':
                        sql+=" AND UPPER(dmp.artykul_id) LIKE UPPER('"+ArtykulF+"%')"
                    if NazwaF <> '':
                        sql+=" AND UPPER(a.nazwa) LIKE UPPER('"+NazwaF+"%')"
                        
                    sql+=" GROUP BY dmp.artykul_id,a.nazwa,a.jm1,a.jm2,dmp.cecha1_opis,dmp.cecha1_wartosc "
                    sql+=" ORDER BY dmp.artykul_id,dmp.cecha1_opis,dmp.cecha1_wartosc; "
                    
                    stat,dokp,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania sum z pozycji aktualnego dokumentu: '+stat
                    
                    if stat == 'OK' and len(dokp) > 0:
                        # slownik po artykulach-przyjeciach z magazynu:
                        # pozycja kazdego zapisu z sum artykulow-magazynow-przyjec
                        SArt = {}
                        
                        for i in xrange(len(stanym)):
                            art = stanym[i][0]
                            cecha1opis = stanym[i][6]
                            cecha1wartosc = stanym[i][7]
                            SArt[(art,cecha1opis,cecha1wartosc)] = i
                        
                        # aktualizacja pobranych stanow magazynowych sumami z dokumentu
                        for i in xrange(len(dokp)):
                            art = dokp[i][0]
                            nazwa = dokp[i][1]
                            ilosc1 = dokp[i][2]
                            jm1 = dokp[i][3]
                            ilosc2 = dokp[i][4]
                            jm2 = dokp[i][5]
                            cecha1opis = dokp[i][6]
                            cecha1wartosc = dokp[i][7]
                            
                            if SArt.has_key((art,cecha1opis,cecha1wartosc)):
                                poz = SArt[(art,cecha1opis,cecha1wartosc)]
                            else:
                                stanym.append([art,nazwa,0,jm1,0,jm2,cecha1opis,cecha1wartosc])
                                poz = len(stanym)-1
                                
                            if dokn[0][1] == 'P':
                                # dokument przychodowy
                                stanym[poz][2] += ilosc1
                                stanym[poz][4] += ilosc2
                            elif dokn[0][1] == 'W':
                                # dokument przychodowy
                                stanym[poz][2] -= ilosc1
                                stanym[poz][4] -= ilosc2

        if stat == 'OK':
            # lista artykulow, na ktorych nie ma stanow w artykulach-przyjeciach
            # i dlatego nalezy je pobrac z katalogu artykulow aby operator
            # mogl wybrac indeks, ktry ma stan zerowy
            
            LArt = ''
            if len(stanym) > 0:
            # slownik artykulow, ktore sa juz ze stanami i nie nalezy ich pobierac
                SArt = {}
                for poz in stanym:
                    art = poz[0]
                    if not art in SArt:
                        SArt[art] = 0
                
                LArt = "("
                for art in SArt.keys():
                    LArt+= "'"+rsglobal.Dekoduj(art)+"',"
                LArt = LArt[:-1]+")"
                
            sql ="SELECT artykul_id,nazwa,COALESCE(jm1,''),COALESCE(jm2,'')"
            sql+=" FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"'"

            # ogolny filtr dla grida
            if ArtykulF <> '':
                sql+=" AND UPPER(artykul_id) LIKE UPPER('"+ArtykulF+"%')"
            if NazwaF <> '':
                sql+=" AND UPPER(nazwa) LIKE UPPER('"+NazwaF+"%')"
            
            # artykuly do ominiecia
            if LArt <> '':
                sql+=" AND NOT artykul_id IN "+LArt
                
            sql+=" ORDER BY artykul_id; "
            
            stat,arty,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania pozostaych artykuw: '+stat
            elif len(arty) > 0:
                # dopisanie listy artykulow z katalogu do listy artykulow ze stanami
                for a in arty:
                    artykul = a[0]
                    nazwa = a[1]
                    jm1 = a[2]
                    jm2 = a[3]
                    stanym.append([artykul,nazwa,0,jm1,0,jm2,'',''])
                        
        if stat == 'OK':
            # zapytanie dla pustej struktury wyn1
            sql = "SELECT '','','','','','','','';"
            stat,d,wyn1,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd zapytania: '+stat
                
            for i in xrange(len(stanym)):
                # formatowanie liczb
                sql ="SELECT to_char("+str(stanym[i][2])+",'99 999 990.9999'),"
                sql+="       to_char("+str(stanym[i][4])+",'99 999 990.9999');"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd formatowania: '+stat
                    break
                
                stanym[i][2] = d[0][0]
                stanym[i][4] = d[0][1]
                if stanym[i][3] == 'None':
                    stanym[i][3] = ''
                if stanym[i][5] == 'None':
                    stanym[i][5] = ''
                
                dane.append(stanym[i])
