# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_dane
# Purpose:     dodawanie/edycja danych uboju
# Author:      Mariusz Rajfura
# Created:     2013/09/10
# RCS-ID:      $Id: fs_uboje_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = {}
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Data':[1,2,3,4,5],'NumerUboju':[1,2,3,4,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if Fun in (1,2,3,4,5):
    Data = rsglobal.Dekoduj(klucze['Data'])
    NumerUboju = rsglobal.Dekoduj(klucze['NumerUboju'])

Zmieniac = False

UprDodawanie = (((self.oddzial_id,'601003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'601002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    # pobranie danych, aby mozna sprawdzac dane w sytacji, gdy nie wszystkie
    # zmienily sie, a trzeba sprawdzic wzajemne zaleznosci
    sql ="SELECT * FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    sql+=" FOR UPDATE NOWAIT;"
    
    stat,Bylo,nagl,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych do sprawdzenia: '+stat
    elif len(Bylo) == 0:
        stat = 'Brak uboju o podanym kluczu.'
    
    if stat == 'OK':
        tr = rssql.RSTableRowset(Bylo,nagl)
        if tr.GetVal(0,"stan") <> 'W':
            stat = 'Ubj w stanie '+tr.GetVal(0,"stan")+'. Edycja niemoliwa.'

if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    

        if pole == 'data':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA')
                else:
                    DoKiedy = wart
            else:    
                stat='BR_DATA'
                dane.append(stat)

        elif pole == 'kontrahent_id':
            wart = wart.strip()
            if wart=='':
                stat = 'BR_KONTRAHENT'
                dane.append(stat)        
            else:
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(wart)+"'"
                sql+=" AND aktywny;"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia kontrahenta: '+stat)
                elif len(d) == 0:
                    dane.append('BL_KONTRAHENT')

        elif pole == 'liczba_sztuk':
            if wart < 0:
                dane.append('BL_LICZBA_SZTUK')

    if stat == 'OK':
        if len(dane) > 0:
            # jesli byly jakies bledy
            stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    # pobranie nowego numeru uboju
    sql ="SELECT COALESCE(MAX(numer_uboju),0)+1"
    sql+=" FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"';"

    stat,NowyNrUboju,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danego numeru uboju: '+stat
    else:
        # numer dla INSERT i SELECT
        NumerUboju = NowyNrUboju[0][0]
        
    if stat == 'OK':
        INSERT = "INSERT INTO rs_uboje"
        Pola="firma_id,oddzial_id,data,numer_uboju"
        Wartosci="'"+str(self.firma_id)+"','"+self.oddzial_id+"','"+Data+"',"+str(NumerUboju)
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]        
            if pole in ['kontrahent_id']:
                Pola= Pola+","+pole
                Wartosci += ",'"+str(wart)+"'" 
    
            elif pole in ['liczba_sztuk']:
                Pola += ","+pole
                Wartosci += ","+str(wart) 
        
            
        INSERT += " ("+Pola+") VALUES ("+Wartosci+");"
        
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT ,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':   
    UPDATE = "UPDATE rs_uboje SET "        
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
            
        if pole in ['kontrahent_id']:
            UPDATE += pole+"='"+wart+"',"
        elif pole in ['liczba_sztuk']:
            UPDATE += pole+"="+str(wart)+","

    UPDATE = UPDATE[:-1]     
    UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"' "
    UPDATE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"   
    
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych uboju: '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem, 1-insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_uboje"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SELECT+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych uboju: '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # kontrahent
        klucz = 'KontrahentOpis'
        if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_kontrahenci"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2[klucz] = 'Bd pobrania opisu kontrahenta: '+stat
            else:
                if len(d) == 0:
                    wyn2[klucz] = 'Bdny numer kontrahenta.'
                else:
                    wyn2[klucz] = rsglobal.Dekoduj(d[0][0])
        else:
            wyn2[klucz] = 'Brak uprawnie do kartoteki kontrahentw. Poinformuj administratora.'

        # suma pozycji zywcow z dokumentu ubojowego
        sql ="SELECT ilosc1,ilosc2 FROM rs_uboje_zywce"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" ORDER BY nr_poz; "
        
        stat,poz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania sum z pozycji ywcw: '+stat
        else:
            sztuki = 0
            waga = 0
            for p in poz:
                sztuki += p[0]
                waga += p[1]
                
            wyn2['LiczbaPozycjiZywcow'] = len(poz)
            wyn2['SumaSztukZywcow'] = sztuki
            wyn2['SumaWagiZywcow'] = waga


        # suma pozycji poltusz z dokumentu ubojowego
        sql ="SELECT ilosc1,ilosc2 FROM rs_uboje_poltusze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" ORDER BY numer_ubojowy; "
        
        stat,poz,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania sum z pozycji ptusz: '+stat
        else:
            sztuki = 0
            waga = 0
            for p in poz:
                sztuki += p[0]
                waga += p[1]

            wyn2['LiczbaPozycjiPoltusz'] = len(poz)
            wyn2['SumaSztukPoltusz'] = sztuki
            wyn2['SumaWagiPoltusz'] = waga
