# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje.py
# Purpose:     grid dokumentow magazynowych obslugiwany z modulu ubojowego
# Author:      Mariusz Rajfura
# Created:     2013/09/18
# RCS-ID:      $Id: fs_uboje_dokumenty_magazynowe.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_dokumenty_magazynowe_pom
from funkcje import fs_uboje_pom

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'StanF':(5,6),'MagazynF':(5,6,22), 'DokumentF':(5,6),
           'DataOdF':(5,6), 'DataDoF':(5,6), 'KluczeF':(5,6),
           'TypDokumentowF':(22,),
           'Magazyn':(6,18,28,11), 'Dokument':(6,18,28,11), 'Data':(6,18,28,11), 'Numer':(6,18,28,11),
           'ListaDokumentow':(12,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_dokumenty_magazynowe z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in (5,6,18,28): 
        StanF = rsglobal.Dekoduj(klucze['StanF'])
        MagazynF = rsglobal.Dekoduj(klucze['MagazynF'])
        DokumentF = rsglobal.Dekoduj(klucze['DokumentF'])
        DataOdF = rsglobal.Dekoduj(klucze['DataOdF'])
        DataDoF = rsglobal.Dekoduj(klucze['DataDoF'])
        KluczeF = rsglobal.Dekoduj(klucze['KluczeF'])

    if Funkcja in (6,18,28,11): 
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])

    if Funkcja in (12,): 
        ListaDokumentow = rsglobal.Dekoduj(klucze['ListaDokumentow'])

    if Funkcja in (22,): 
        MagazynF = rsglobal.Dekoduj(klucze['MagazynF'])
        TypDokumentowF = rsglobal.Dekoduj(klucze['TypDokumentowF'])


UprDodawanie = (((self.oddzial_id,'032013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = (((self.oddzial_id,'032014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   SUMY POZYCJI Z DOKUMENTU/DOKUMENTOW
#-------------------------------------------------------------------------------

if Funkcja in (11,12) and stat == 'OK':
    if Funkcja == 11:
        kl = {}
        kl['Magazyn'] = Magazyn
        kl['Dokument'] = Dokument
        kl['Data'] = Data
        kl['Numer'] = Numer
    else:
        kl = ListaDokumentow
    
    stat,dane,wyn1,wyn2 = fs_uboje_pom.PodajSumyPozycjiDokumentuMagazynowego(self,Klucze=kl)


#-------------------------------------------------------------------------------
#--- POBRANIE LISTY MAGAZYNOW
#-------------------------------------------------------------------------------

if Funkcja == 21 and stat == 'OK':
    # filtr magazynow wynikajacy z uprawnien
    FiltrMag = ''
    if self.operator_id <> STANDARD_OPERATOR_ID:
        sql ="SELECT DISTINCT magazyn_id"
        sql+=" FROM rs_dokumenty_m_upr"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND operator_id IN "+self.operatorzy
        sql+=" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"

        stat,dmag,dump,dump = self.PolSQL.Execute(sql,3)       
        if stat <> 'OK':
            stat = 'Bd pobrania listy dozwolonych magazynw: '+stat
        elif len(dmag) == 0:
            # to lepsze, niz komunikat, bo nic nie pokaze
            FiltrMag = " AND m.magazyn_id IN ('')"
        else:
            FiltrMag = " AND m.magazyn_id IN ("
            for i in xrange(len(dmag)):
                if i > 0:
                    FiltrMag += ","
                FiltrMag += "'"+rsglobal.Dekoduj(dmag[i][0])+"'"
            FiltrMag += ")"

    if stat == 'OK':
        sql ="SELECT m.magazyn_id,m.opis,m.oddzial_id,o.opis"
        sql+=" FROM rs_magazyny m"
        sql+=" INNER JOIN rs_oddzialy o USING(firma_id,oddzial_id)"
        sql+=" WHERE m.firma_id='"+self.firma_id+"'"+FiltrMag
        sql+=" ORDER BY m.oddzial_id,m.magazyn_id;"
        
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy magazynw: '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE LISTY TYPOW DOKUMENTOW MAGAZYNOWYCH
#-------------------------------------------------------------------------------

if Funkcja == 22 and stat == 'OK':
    # filtr wynikajacy z uprawnien do dokumentow z magazynu
    # jesli w filtrze byl dostepny magazyn
    FiltrDok = ''

    # jesli podano magazyn, to lista do filtrowania, wynikajaca z uprawnien
    if self.operator_id <> STANDARD_OPERATOR_ID:
        if MagazynF <> '':
            sql ="SELECT DISTINCT dokument_id"
            sql+=" FROM rs_dokumenty_m_upr"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynF+"'"
            sql+=" AND operator_id IN "+self.operatorzy
            sql+=" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"
    
            stat,ddok,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania listy dozwolonych dokumentw z magazynu: '+stat
            elif len(ddok) == 0:
                # to lepsze, niz komunikat, bo nic nie pokaze
                FiltrDok = " AND tdm.dokument_id IN ('')"
            else:
                FiltrDok = " AND tdm.dokument_id IN ("
                for i in xrange(len(ddok)):
                    if i > 0:
                        FiltrDok += ","
                    FiltrDok += "'"+rsglobal.Dekoduj(ddok[i][0])+"'"
                FiltrDok += ")"

    if stat == 'OK':
        sql ="SELECT tdm.dokument_id,tdm.typ_dokumentu,tdm.nazwa_dokumentu"
        sql+=" FROM rs_typy_dokumentow_m tdm"
        sql+=" WHERE tdm.firma_id='"+self.firma_id+"'"+FiltrDok
        if TypDokumentowF <> '':
            sql+=" AND tdm.typ_dokumentu='"+TypDokumentowF+"'"
    
        sql+=" ORDER BY tdm.dokument_id;"
    
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy typw dokumentw: '+stat


#-------------------------------------------------------------------------------
# dopisanie do FILTRA uprawnien do magazynow i typow dokumentow
# dzieki temu na gridzie nie pokaze sie to, do czego uzytkownik nie ma uprawnien,
# a tym samym nie wywola operacji na dokumencie, ktorego nie zobaczy
#-------------------------------------------------------------------------------

# FIXME: o co chodzi?
NiezamknieteF = True


FILTR = ''
if Funkcja in (5,):
    if self.operator_id <> STANDARD_OPERATOR_ID:
        if NiezamknieteF:
            #jesli wybrano opcje Niezamkniete
            #pobieramy do filtra wszystkie dozwolone magazyny i
            #dozwolone dokumenty w magazynach
    
            sql ="SELECT DISTINCT magazyn_id,dokument_id"
            sql+=" FROM rs_dokumenty_m_upr"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND operator_id IN "+self.operatorzy
            sql+=" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"
            stat,dmag,dump,dump = self.PolSQL.Execute(sql,3)       
            if stat <> 'OK':
                stat = 'Bd pobrania listy dozwolonych magazynw: '+stat
            elif len(dmag) == 0:
                stat = 'Brak dozwolonych magazynw'
            else:
                FILTR += " AND ("
                licz = 0
                for i in xrange(len(dmag)):
                    licz += 1
                    if licz > 1:
                        FILTR += " OR "
                    FILTR += " (dm.magazyn_id='"+rsglobal.Dekoduj(dmag[i][0])+"' AND dm.dokument_id='"+rsglobal.Dekoduj(dmag[i][1])+"')"
                FILTR += ")"
                
        if stat=='OK':
            sql ="SELECT magazyn_id FROM rs_magazyny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagazynF+"';"
            stat,mag,dump,dump=self.PolSQL.Execute(sql, 3)
            dl=len(mag)
            
            sql ="SELECT typ_dokumentu FROM rs_typy_dokumentow_m"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokumentF+"';"
            stat,dok,dump,dump=self.PolSQL.Execute(sql, 3)
            dl=dl+len(dok)
            
            if dl>0:
                if dl==2:
                    stat,upr,dump,dump=self.PolSQL.Execute("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+MagazynF+"','"+DokumentF+"',6);",3)        
                    if stat=='OK':
                        if len(upr)==0:
                            #brak danych
                            stat="Brak uprawnie do dokumentw w podanym magazynie."
                        elif not upr[0][0]:
                            #nie ma uprawnie
                            stat="Brak uprawnie do dokumentw w podanym magazynie."
                        else:
                            #wszystko ok
                            dane=[""]
                            
                # podany jeden magazyn
                elif len(mag)==1:
                    SQL="SELECT DISTINCT dokument_id FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND dokument_id LIKE '"+DokumentF+"%' "
                    SQL+=" AND magazyn_id='"+MagazynF+"' AND operator_id in "+self.operatorzy
                    SQL+=" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"
                    stat,upr,dump,dump=self.PolSQL.Execute(SQL,3)        
                    if len(upr)==0:
                        stat="Brak uprawnie do operacji na podanym magazynie."
                    else:
                        Lu=''
                        for u in upr:
                            Lu=Lu+"'"+rsglobal.Dekoduj(u[0])+"',"
                        FILTR += " AND dm.dokument_id IN ("+Lu[0:-1]+")"
                        
                # podany jeden dokument
                elif len(dok)==1:   
                    SQL="SELECT DISTINCT magazyn_id FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND dokument_id= '"+DokumentF+"' "
                    SQL+=" AND magazyn_id LIKE '"+MagazynF+"%' AND operator_id in "+self.operatorzy
                    SQL+=" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"
                    stat,upr,dump,dump=self.PolSQL.Execute(SQL,3)        
                    if len(upr)==0:
                        stat="Brak uprawnie do operacji na podanym typie dokumentu."
                    else:
                        Lu=''
                        for u in upr:
                            Lu=Lu+"'"+rsglobal.Dekoduj(u[0])+"',"
                        FILTR += " AND (dm.magazyn_skad IN ("+Lu[0:-1]+") OR dm.magazyn_dokad IN ("+Lu[0:-1]+"))"
    
    
    #pobranie klucza wynikajacego z numerow nowych kluczy
    if KluczeF <> []:
        FILTR +=" OR ((dm.firma_id='"+self.firma_id+"') AND ("
        Pierwszy = True
        for klucz in KluczeF:
            if not Pierwszy:
                FILTR+=" OR "
            else:
                Pierwszy = False
            FILTR+=" (dm.magazyn_id='"+str(klucz[0])+"' AND dm.dokument_id='"+str(klucz[1])+"' AND dm.data='"+str(klucz[2])+"' AND dm.numer="+str(klucz[3])+")"
        FILTR+='))'


#-------------------------------------------------------------------------------
#--- USUWANIE DOKUMENTU MAGAZYNOWEGO
#-------------------------------------------------------------------------------

if Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania dokumentw magazynowych'

    if stat == 'OK':
        sql ="SELECT stan FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu dokumentu: '+stat
        elif len(d) == 0:
            stat = 'Brak dokumentu o podanym kluczu'
        elif d[0][0] <> 'W':
            stat = 'Dokument w stanie '+d[0][0]+'. Usunicie niemoliwe.'

    if stat == 'OK':
        stat = fs_dokumenty_magazynowe_pom.UsunDokumentMagazynowy(self,Magazyn,Dokument,Data,Numer)


#-------------------------------------------------------------------------------
#--- ZAMYKANIE DOKUMENTU MAGAZYNOWEGO
#-------------------------------------------------------------------------------

if Funkcja == 18:
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
    elif len(d) == 0:
        stat = 'Brak dokumentu o podanym kluczu'
    elif not d[0][0] in ('W','G'):
        stat = 'Dokument w stanie '+d[0][0]+'. Zamknicie niemoliwe.'

    if stat == 'OK':
        stat = fs_dokumenty_magazynowe_pom.ZamknijDokumentMagazynowy(self,Magazyn,Dokument,Data,Numer,rsglobal.Dekoduj(d[0][0]),'Z')


#-------------------------------------------------------------------------------
#--- OTWIERANIE DOKUMENTU MAGAZYNOWEGO
#-------------------------------------------------------------------------------

if Funkcja == 28:
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
    elif len(d) == 0:
        stat = 'Brak dokumentu o podanym kluczu'
    elif d[0][0] == 'W':
        stat = 'Dokument jest ju otwarty.'
    elif d[0][0] == 'K':
        stat = 'Dokument w stanie '+d[0][0]+'. Otwarcie niemoliwe.'

    if stat == 'OK':
        stat = fs_dokumenty_magazynowe_pom.OtworzDokumentMagazynowy(self,Magazyn,Dokument,Data,Numer,rsglobal.Dekoduj(d[0][0]),'W')
        

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,6)
#-------------------------------------------------------------------------------

if Funkcja in (5,6,18,28) and stat=='OK':
    SQL ="SELECT dm.stan,dm.magazyn_id,dm.dokument_id,dm.data::TEXT,dm.numer,"
    SQL+=" COALESCE(dm.magazyn_skad,''),COALESCE(dm.magazyn_dokad,''),"
    SQL+=" COALESCE(dm.kontrahent_id,''),COALESCE(k.nazwa,''),FALSE"
    SQL+=" FROM rs_dokumenty_magazynowe dm"
    SQL+=" LEFT JOIN rs_kontrahenci k USING(firma_id,kontrahent_id)"
    SQL+=" WHERE (dm.firma_id='"+self.firma_id+"'"
    
    if StanF <> '':
        SQL+=" AND dm.stan='"+StanF+"'"

    if MagazynF <> '':
        SQL+=" AND dm.magazyn_id='"+MagazynF+"'"

    if DokumentF <> '':
        SQL+=" AND dm.dokument_id='"+DokumentF+"'"

    if DataOdF <> '    -  -  ':
        SQL+=" AND dm.data>='"+DataOdF+"'"

    if DataDoF <> '    -  -  ':
        SQL+=" AND dm.data<='"+DataDoF+"'"
    
    SQL+=")" + FILTR 

    SQL+=" ORDER BY dm.magazyn_id,dm.dokument_id,dm.data,dm.numer;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
