# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_dane
# Purpose:     dodawanie/edycja danych uboju
# Author:      Mariusz Rajfura
# Created:     2013/09/20
# RCS-ID:      $Id: fs_uboje_dokumenty_magazynowe_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_uboje_pom

dane = []
wyn1 = []
wyn2 = {}
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Magazyn':(1,2,3,4,5,11),'Dokument':(1,2,3,4,5,11),
           'Data':[1,2,3,4,5,11],'Numer':[1,2,3,4,5,11]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_dokumenty_magazynowe_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if Fun in (1,2,3,4,5,11):
    Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
    Dokument = rsglobal.Dekoduj(klucze['Dokument'])
    Data = rsglobal.Dekoduj(klucze['Data'])
    Numer = rsglobal.Dekoduj(klucze['Numer'])


UprDodawanie = (((self.oddzial_id,'03213') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'032012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SUMY POZYCJI Z DOKUMENTU
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    kl = {}
    kl['Magazyn'] = Magazyn
    kl['Dokument'] = Dokument
    kl['Data'] = Data
    kl['Numer'] = Numer
    
    stat,dane,wyn1,wyn2 = fs_uboje_pom.PodajSumyPozycjiDokumentuMagazynowego(self,Klucze=kl)


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    # pobranie danych, aby mozna sprawdzac dane w sytacji, gdy nie wszystkie
    # zmienily sie, a trzeba sprawdzic wzajemne zaleznosci
    sql ="SELECT * FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" FOR UPDATE NOWAIT;"
    
    stat,Bylo,nagl,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych do sprawdzenia: '+stat
    elif len(Bylo) == 0:
        stat = 'Brak dokumentu o podanym kluczu.'
    
    if stat == 'OK':
        tr = rssql.RSTableRowset(Bylo,nagl)
        if tr.GetVal(0,"stan") <> 'W':
            stat = 'Dokument w stanie '+tr.GetVal(0,"stan")+'. Edycja niemoliwa.'

if Fun in (3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    

        if pole == 'kontrahent_id':
            wart = wart.strip()
            if wart=='':
                stat = 'BR_KONTRAHENT'
                dane.append(stat)        
            else:
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(wart)+"'"
                sql+=" AND aktywny;"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia kontrahenta: '+stat)
                elif len(d) == 0:
                    dane.append('BL_KONTRAHENT')

    if stat == 'OK':
        if len(dane) > 0:
            # jesli byly jakies bledy
            stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':   
    UPDATE = "UPDATE rs_dokumenty_magazynowe SET "        
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
            
        if pole in ['kontrahent_id']:
            UPDATE += pole+"='"+wart+"',"

    UPDATE = UPDATE[:-1]

    UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    UPDATE+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji nagwka dokumentu: '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem, 1-insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_dokumenty_magazynowe"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    SELECT+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych dokumentu: '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # opisy slownikow i inne informacja
        
        # czy kontrahent jest konieczny
        
        sql ="SELECT czy_kontrahent FROM rs_typy_dokumentow_m"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dokument+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o wymogu podania kontrahenta: '+stat
        else:
            wyn2['CzyKontrahent'] = d[0][0]
    
    if stat == 'OK':
        wyn2['Stan'] = tr.GetVal(0,'stan')
        
        klucz = 'MagazynOpis'
        if (self.oddzial_id,'031010') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT opis FROM rs_magazyny"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2[klucz] = 'Bd pobrania opisu magazynu: '+stat
            else:
                if len(d) == 0:
                    wyn2[klucz] = 'Bdny numer magazynu.'
                else:
                    wyn2[klucz] = rsglobal.Dekoduj(d[0][0])
        else:
            wyn2[klucz] = 'Brak uprawnie do kartoteki magazynw. Poinformuj administratora.'

        klucz = 'DokumentOpis'
        if (self.oddzial_id,'014020') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa_dokumentu FROM rs_typy_dokumentow_m"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+tr.GetVal(0,"dokument_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2[klucz] = 'Bd pobrania opisu typu dokumentu: '+stat
            else:
                if len(d) == 0:
                    wyn2[klucz] = 'Bdny symbol dokumentu.'
                else:
                    wyn2[klucz] = rsglobal.Dekoduj(d[0][0])
        else:
            wyn2[klucz] = 'Brak uprawnie do katalogu typw dokumentw magazynowych. Poinformuj administratora.'

        klucz = 'KontrahentOpis'
        if tr.GetVal(0,"kontrahent_id") <> 'None': 
            if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT nazwa FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2[klucz] = 'Bd pobrania opisu kontrahenta: '+stat
                else:
                    if len(d) == 0:
                        wyn2[klucz] = 'Bdny numer kontrahenta.'
                    else:
                        wyn2[klucz] = rsglobal.Dekoduj(d[0][0])
            else:
                wyn2[klucz] = 'Brak uprawnie do kartoteki kontrahentw. Poinformuj administratora.'
        else:
            wyn2[klucz] = ''
