# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_dokumenty_magazynowe_pozycje.py
# Purpose:     grid pozycji dokumentu magazynowego z modulu uboju
# Author:      Mariusz Rajfura
# Created:     2013/09/21
# RCS-ID:      $Id: fs_uboje_dokumenty_magazynowe_pozycje.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_uboje_pom

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Magazyn':(5,6,11), 'Dokument':(5,6,11), 'Data':(5,6,11), 'Numer':(5,6,11),
           'NrPoz':(6,), 'NrPPoz':(6,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_dokumenty_magazynowe_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,6,11): 
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])

    if Funkcja in (6,): 
        NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])
        NrPPoz = rsglobal.Dekoduj(klucze['NrPPoz'])

UprUsuwanie = (((self.oddzial_id,'032024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   SUMY POZYCJI Z DOKUMENTU
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    kl = {}
    kl['Magazyn'] = Magazyn
    kl['Dokument'] = Dokument
    kl['Data'] = Data
    kl['Numer'] = Numer
    
    stat,dane,wyn1,wyn2 = fs_uboje_pom.PodajSumyPozycjiDokumentuMagazynowego(self,Klucze=kl)


#-------------------------------------------------------------------------------
#---   USUWANIE POZYCJI (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania pozycji dokumentu'

    if stat == 'OK':
        sql = "SELECT stan FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu dokumentu: '+stat
        elif len(d) == 0:
            stat = 'Brak dokumentu o podanym kluczu'
        elif d[0][0] <> 'W':
            stat = 'Dokument w stanie '+d[0][0]+'. Usunicie niemoliwe.'

    if stat == 'OK':
        # zablokowanie pozycji
        sql = "SELECT artykul_id FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+str(NrPPoz)+" FOR UPDATE;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pozycji: '+stat
        elif len(d) == 0:
            stat = 'Brak pozycji o podanym kluczu'

    if stat == 'OK':
        klucze = []
        klucze.append(Magazyn)
        klucze.append(Dokument)
        klucze.append(Data)
        klucze.append(Numer)
        klucze.append('')       ##SymbolF=klucze[4]
        klucze.append('')       ##CenaF=klucze[5]
        klucze.append('')       ##NrSeriiF=klucze[6]
        klucze.append('')       ##Waluta=klucze[7]
        klucze.append(False)    ##DwieJednMiar=klucze[8]
        klucze.append([])       ##Klucze=klucze[9]
        klucze.append(0)        ##PozycjaN=klucze[10]
        klucze.append(NrPoz)    ##Pozycja=klucze[11]
        klucze.append('')       ##Stan=klucze[12]
        klucze.append(NrPPoz)   ##PPozycja=klucze[13]
        klucze.append(10)       ##Fun=klucze[-1]

        stat,dump,dump,dump = self.WykonajFunkcje("fs_dokumenty_magazynowe_pozycje", klucze, [], [],False)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,6)
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat=='OK':
    SELECT ="SELECT dmp.nr_poz,dmp.nr_ppoz,dmp.artykul_id,a.nazwa,"
    SELECT+=" dmp.ilosc1,dmp.ilosc2,COALESCE(dmp.cecha1_opis,''),COALESCE(dmp.cecha1_wartosc,''),"
    SELECT+=" COALESCE(dmp.nr_serii,'')"
    SELECT+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
    SELECT+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SELECT+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Magazyn+"'"
    SELECT+=" AND dmp.dokument_id='"+Dokument+"' AND dmp.data='"+Data+"' AND dmp.numer="+str(Numer)
    SELECT+=" ORDER BY dmp.nr_poz,dmp.nr_ppoz; "
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)

    # pobranie dodatkowych informacji
    if stat == 'OK':
        # pobranie biezacego stanu

        sql = "SELECT stan FROM rs_dokumenty_magazynowe"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu dokumentu: '+stat
        elif len(d) == 0:
            stat = 'Brak dokumentu o podanym kluczu'
        else:
            wyn2['Stan'] = d[0][0]
