# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_dokumenty_magazynowe_pozycje_dane
# Purpose:     dodawanie/edycja pozycji dokumentu magazynowego w module ubojni
# Author:      Mariusz Rajfura
# Created:     2013/09/21
# RCS-ID:      $Id: fs_uboje_dokumenty_magazynowe_pozycje_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_uboje_pom

dane = []
wyn1 = []
wyn2 = {}
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Magazyn':(1,2,3,4,5,10,21,22),'Dokument':(1,2,3,4,5,10,21,22),
           'Data':(1,2,3,4,5,10,21,22),'Numer':(1,2,3,4,5,10,21,22),
           'NrPoz':(1,2,3,4,5),'NrPPoz':(1,2,3,4,5),
           'Artykul':(11,),
           'DataUboju':(31,),'NumerUbojowy':(31,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_dokumenty_magazynowe_pozycje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if Fun in (1,2,3,4,5,10,21,22):
    Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
    Dokument = rsglobal.Dekoduj(klucze['Dokument'])
    Data = rsglobal.Dekoduj(klucze['Data'])
    Numer = rsglobal.Dekoduj(klucze['Numer'])

if Fun in (1,2,3,4,5):
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])
    NrPPoz = rsglobal.Dekoduj(klucze['NrPPoz'])

if Fun in (11,):
    Artykul = rsglobal.Dekoduj(klucze['Artykul'])

if Fun in (31,):
    DataUboju = rsglobal.Dekoduj(klucze['DataUboju'])
    NumerUbojowy = rsglobal.Dekoduj(klucze['NumerUbojowy'])


UprDodawanie = (((self.oddzial_id,'032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'032022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
# POBRANIE DANYCH POLTUSZY Z UBOJU 
#-------------------------------------------------------------------------------

if Fun == 31 and stat == 'OK':
    sql ="SELECT up.artykul_id,a.nazwa,up.ilosc1,up.ilosc2,"    
    sql+=" COALESCE(a.jm1,''),COALESCE(a.jm2,''),"
    sql+=" COALESCE(a.cecha1_opis,''),COALESCE(up.klasyf_europ,''),a.czy_seria,up.numer_uboju"
    sql+=" FROM rs_uboje_poltusze up"
    sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    sql+=" WHERE up.firma_id='"+self.firma_id+"' AND up.oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND up.data='"+DataUboju+"' AND up.numer_ubojowy="+str(NumerUbojowy)+"; "
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z uboju '+sql
    elif len(dane) > 0:
        # wygodne do pobierania na oknie upakowanie pobranych danych
        # w formie slownika
        wyn2['Artykul'] = dane[0][0]
        wyn2['ArtykulOpis'] = dane[0][1]
        wyn2['Ilosc1'] = dane[0][2]
        wyn2['Ilosc2'] = dane[0][3]
        wyn2['ArtykulJm1'] = dane[0][4]
        wyn2['ArtykulJm2'] = dane[0][5]
        wyn2['ArtykulCecha1Opis'] = dane[0][6]
        wyn2['ArtykulCecha1Wartosc'] = dane[0][7]
        wyn2['CzySeria'] = dane[0][8]
        wyn2['ArtykulCecha1Slownik'] = False
        wyn2['NumerUboju'] = dane[0][9]
        
        if wyn2['ArtykulCecha1Opis'] <> '':
            # czy cecha posiada slownik wartosci
            sql ="SELECT kod FROM rs_artykuly_cechy_wartosci"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kod='"+rsglobal.Dekoduj(wyn2['ArtykulCecha1Opis'])+"'; "
            
            stat,cechy,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania sownika wartoci dla cechy: '+stat
            else:
                wyn2['ArtykulCecha1Slownik'] = len(cechy) > 0
        

#-------------------------------------------------------------------------------
#---  POBRANIE NUMERU NOWEJ POZYCJI
#-------------------------------------------------------------------------------

if Fun == 22 and stat == 'OK':
    # pobranie nowego numeru pozycji i podpozycji dokumentu
    sql ="SELECT COALESCE(MAX(nr_poz),0)+1,0"
    sql+=" FROM rs_dokumenty_magazynowe_pozycje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    sql+=" AND numer="+str(Numer)+" ;"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania numeru nowej pozycji: '+sql


#-------------------------------------------------------------------------------
#---   SUMY POZYCJI Z DOKUMENTU
#-------------------------------------------------------------------------------

if Fun == 21 and stat == 'OK':
    kl = {}
    kl['Magazyn'] = Magazyn
    kl['Dokument'] = Dokument
    kl['Data'] = Data
    kl['Numer'] = Numer
    
    stat,dane,wyn1,wyn2 = fs_uboje_pom.PodajSumyPozycjiDokumentuMagazynowego(self,Klucze=kl)


#-------------------------------------------------------------------------------
#--- POBRANIE STANU DOKUMENTU
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    sql+=" AND numer="+str(Numer)+" ;"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
    elif len(dane) == 0:
        stat = 'Brak dokumentu o podanym kluczu.'


#-------------------------------------------------------------------------------
#--- POBRANIE INFORMACJI O CESZE DLA ARTYKULU, JM1, JM2, CZY_SERIA
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    sql ="SELECT COALESCE(cecha1_opis,''),COALESCE(jm1,''),COALESCE(jm2,''),czy_seria"
    sql+=" FROM rs_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'; "

    wyn2['ArtykulCecha1Opis'] = ''
    wyn2['ArtykulCecha1Slownik'] = False
    wyn2['ArtykulJm1'] = ''
    wyn2['ArtykulJm2'] = ''
    wyn2['CzySeria'] = False
    
    stat,cecha,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia cechy dla artykuu: '+stat
    elif len(cecha) == 1:
        wyn2['ArtykulCecha1Opis'] = cecha[0][0]
        wyn2['ArtykulJm1'] = cecha[0][1]
        wyn2['ArtykulJm2'] = cecha[0][2]
        wyn2['CzySeria'] = cecha[0][3]
        
        if cecha[0][0] <> '':
            # czy cecha posiada slownik wartosci
            sql ="SELECT kod FROM rs_artykuly_cechy_wartosci"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kod='"+rsglobal.Dekoduj(cecha[0][0])+"'; "
            
            stat,cechy,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania sownika wartoci dla cechy: '+stat
            else:
                wyn2['ArtykulCecha1Slownik'] = len(cechy) > 0


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':
    # sprawdzenie stanu dokumentu
    sql ="SELECT stan FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    sql+=" AND numer="+str(Numer)+" ;"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu dokumentu: '+stat
    elif len(d) == 0:
        stat = 'Brak dokumentu o podanym kluczu.'
    elif d[0][0] <> 'W':
        stat = 'Dokument w stanie '+d[0][0]+'. Dodawanie/edycja niemoliwa.'

    if Fun in (3,4) and stat == 'OK':
        # pobranie danych, aby mozna sprawdzac dane w sytacji, gdy nie wszystkie
        # zmienily sie, a trzeba sprawdzic wzajemne zaleznosci

        sql ="SELECT * FROM rs_dokumenty_magazynowe_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
        sql+=" AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
        sql+=" AND nr_ppoz="+str(NrPPoz)+" FOR UPDATE; "
        
        stat,Bylo,nagl,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych do sprawdzenia: '+stat
        elif len(Bylo) == 0:
            stat = 'Brak pozycji podanym kluczu.'
        
        tr = rssql.RSTableRowset(Bylo,nagl)


if Fun in (1,2,3,4) and stat == 'OK':

    Artykul = None
    Cecha1Opis = None
    Cecha1Wartosc = None
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    

        if pole == 'data':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA')
                else:
                    DoKiedy = wart
            else:    
                stat='BR_DATA'
                dane.append(stat)

        elif pole == 'artykul_id':
            wart = wart.strip()
            if wart=='':
                stat = 'BR_ARTYKUL'
                dane.append(stat)        
            else:
                Artykul = wart
                sql ="SELECT artykul_id FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                sql+=" AND aktywny;"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia artykuu: '+stat)
                elif len(d) == 0:
                    dane.append('BL_ARTYKUL')

        elif pole == 'ilosc1':
            if wart <= 0:
                dane.append('BL_ILOSC1')

        elif pole == 'ilosc2':
            if wart <= 0:
                dane.append('BL_ILOSC2')
                
        elif pole == 'cecha1_opis':
            # cecha kontrolowana dla artykulow
            Cecha1Opis = wart

        elif pole == 'cecha1_wartosc':
            # cecha kontrolowana dla artykulow
            Cecha1Wartosc = wart

    if stat == 'OK':
        if len(dane) > 0:
            # jesli byly jakies bledy
            stat = dane[0]
    
    if stat == 'OK':
        if Fun in (3,4):
            
            if Artykul == None:
                Artykul = rsglobal.Dekoduj(tr.GetVal(0,"artykul_id"))

            if Cecha1Opis == None:
                Cecha1Opis = rsglobal.Dekoduj(tr.GetVal(0,"cecha1_opis"))
                if Cecha1Opis in ('None',):
                    Cecha1Opis = ''

            if Cecha1Wartosc == None:
                Cecha1Wartosc = rsglobal.Dekoduj(tr.GetVal(0,"cecha1_wartosc"))
                if Cecha1Wartosc in ('None',):
                    Cecha1Wartosc = ''
        
        # sprawdzenie obslugi cechy
        sql ="SELECT COALESCE(cecha1_opis,''),COALESCE(cecha1_opis,'')='"+Cecha1Opis+"'"
        sql+=" FROM rs_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'; "

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania cechy dla artykuu: '+stat
        elif len(d) == 0:
            stat = 'Brak artykuu o podanym symbole'
        elif not d[0][1]:
            stat = 'W artykule jest inna cecha '+d[0][0]
            
        if stat == 'OK' and d[0][0] <> '':
            if Cecha1Wartosc == '':
                stat = 'BR_CECHA1WARTOSC'
            
            if stat == 'OK':
                # czy podana cecha jest zeslownikowana
                sql ="SELECT COALESCE(wartosc,'')"
                sql+=" FROM rs_artykuly_cechy_wartosci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha1Opis+"'; "
    
                stat,cechy,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania listy cech dla artykuw: '+stat
                elif len(cechy) > 0:
                    # czy podana wartosc cechy jest w slowniku wartosci
                    jest = False
                    for c in cechy:
                        if c[0].strip() == Cecha1Wartosc.strip():
                            jest = True
                            break
                    if not jest:
                        stat = 'BL_CECHA1WARTOSC'

    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    # pobranie nowego numeru pozycji dokumentu
    sql ="SELECT COALESCE(MAX(nr_poz),0)+1"
    sql+=" FROM rs_dokumenty_magazynowe_pozycje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    sql+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    sql+=" AND numer="+str(Numer)+" ;"

    stat,NowaPozycja,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania numeru pozycji dokumentu: '+stat
    else:
        # numer dla INSERT i SELECT
        NrPoz = NowaPozycja[0][0]
        NrPPoz = 0
        
    if stat == 'OK':
        INSERT = "INSERT INTO rs_dokumenty_magazynowe_pozycje"
        Pola="firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz"
        Wartosci ="'"+str(self.firma_id)+"','"+Magazyn+"','"+Dokument+"','"+Data+"'"
        Wartosci+=","+str(Numer)+","+str(NrPoz)+","+str(NrPPoz)

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]        
            if pole in ['artykul_id']:
                Pola= Pola+","+pole
                Wartosci += ",'"+str(wart)+"'" 
    
            elif pole in ['ilosc1','ilosc2']:
                Pola += ","+pole
                Wartosci += ","+str(wart) 

            elif pole in ['cecha1_opis','cecha1_wartosc','nr_serii']:
                Pola += ","+pole
                if wart == '':
                    Wartosci += ",NULL" 
                else:
                    Wartosci += ",'"+wart+"'"
        
        INSERT += " ("+Pola+") VALUES ("+Wartosci+");"
        
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT ,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':   
    UPDATE = "UPDATE rs_dokumenty_magazynowe_pozycje SET "        
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
            
        if pole in ['artykul_id']:
            UPDATE += pole+"='"+wart+"',"
        elif pole in ['ilosc1','ilosc2']:
            UPDATE += pole+"="+str(wart)+","
        elif pole in ['cecha1_opis','cecha1_wartosc','nr_serii']:
            if wart == '':
                UPDATE += pole+"=NULL,"
            else:
                UPDATE += pole+"='"+wart+"',"

    UPDATE = UPDATE[:-1] 
    
    UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    UPDATE+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    UPDATE+=" AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
    UPDATE+=" AND nr_ppoz="+str(NrPPoz)+"; "
    
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych pozycji: '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem, 1-insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_dokumenty_magazynowe_pozycje"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    SELECT+=" AND dokument_id='"+Dokument+"' AND data='"+Data+"'"
    SELECT+=" AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)
    SELECT+=" AND nr_ppoz="+str(NrPPoz)+"; "

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania pozycji dokumentu: '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # artykul
        klucz = 'ArtykulOpis'
        if (self.oddzial_id,'013000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2[klucz] = 'Bd pobrania opisu artykuu: '+stat
            else:
                if len(d) == 0:
                    wyn2[klucz] = 'Bdny numer artykuu.'
                else:
                    wyn2[klucz] = rsglobal.Dekoduj(d[0][0])
        else:
            wyn2[klucz] = 'Brak uprawnie do kartoteki artykuw. Poinformuj administratora.'
