# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_poltusze_dane
# Purpose:     dane poltuszy, pomiary miesnosci ultrafomem i wazenie
# Author:      Mariusz Rajfura
# Created:     2013/09/12
# RCS-ID:      $Id: fs_uboje_poltusze_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2013-10-10 Mariusz Rajfura (7272) pobranie kontrolek z czasami pomiarow

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'


# Dla odroznienia wywolania funkcji INSERT/UPDATE ze zwyklego okna, 
# od okna zapisow na ultrafomie, w kluczach jest przekazywany klucz 'Reczna'==True
# ze wzgledu inny zakres pokazywanych kontrolek na oknie, a tym samym wymog ich kontroli 
# i obsluge bledow. W przydku okna ultrafomu czesc kontroli jest juz wykonywana na oknie
# aby nie przerywac mechanizmu automatycznego zapisu pomiarow na wolnym sprzecie do obslugi
# uboju

# Czy o dodawanie/edycja reczna
Reczna = False

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Data':[1,2,3,4,5,6,10,15],'NumerUboju':[1,2,3,4,5,6,10,15],
           'NumerUbojowy':[1,2,3,4,5,6],'NumerPoltuszy':[1,2,3,4,5,6],
           'Artykul':(30,), 'DataUbicia':(11,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista


if Fun in (1,2,3,4,5,6,10,15):
    Data = rsglobal.Dekoduj(klucze['Data'])
    NumerUboju = rsglobal.Dekoduj(klucze['NumerUboju'])
    
    if klucze.has_key('Reczna'):
        Reczna = rsglobal.Dekoduj(klucze['Reczna'])
    

if Fun in (1,2,3,4,5,6):
    NumerUbojowy = rsglobal.Dekoduj(klucze['NumerUbojowy'])
    NumerPoltuszy = rsglobal.Dekoduj(klucze['NumerPoltuszy'])

if Fun in (30,):
    Artykul = rsglobal.Dekoduj(klucze['Artykul'])

if Fun in (11,):
    DataUbicia = rsglobal.Dekoduj(klucze['DataUbicia'])


UprDodawanie = (((self.oddzial_id,'603003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'603002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ARTYKULU - 30
#-------------------------------------------------------------------------------

if Fun == 30 and stat == 'OK':
    sql ="SELECT artykul_id,nazwa,COALESCE(cecha1_opis,'')"
    sql+=" FROM rs_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND aktywny;"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych artykuu: '+sql
        

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH UBOJU - 10
#-------------------------------------------------------------------------------

if Fun == 10  and stat == 'OK':
    sql ="SELECT u.stan,u.liczba_sztuk,u.kontrahent_id,k.nazwa"
    sql+=" FROM rs_uboje u"
    sql+=" INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
    sql+=" WHERE u.firma_id='"+self.firma_id+"' AND u.oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND u.data='"+Data+"' AND u.numer_uboju="+str(NumerUboju)+";"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych uboju: '+stat
    elif len(dane) == 0:
        stat = 'Brak uboju o podanym kluczu.'
    elif dane[0][0] <> 'G':
        stat = 'Ubj w stanie '+dane[0][0]+'. Pomiary ptusz niemoliwe.'


#-------------------------------------------------------------------------------
#--- POBRANIE NOWEGO NUMERU UBOJOWEGO,POLTUSZY,ARTYKULU - 11
#-------------------------------------------------------------------------------

if Fun == 11  and stat == 'OK':
    # po zmianie sposobu numeracji numer_poltuszy=0 
    sql ="SELECT numer_ubojowy,0,artykul_id"
    sql+=" FROM rs_uboje_poltusze"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data_ubicia='"+DataUbicia+"'"
    sql+=" ORDER BY numer_ubojowy DESC"
    sql+=" LIMIT 1;"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania nowego numeru ubojowego: '+stat

    elif len(d) == 0:
        # nie bylo poltusz w tym dniu czyli startujemy
        dane = [[1,0,'']]
    else:
        # kolejny numer ubojowy
        dane = [[ d[0][0]+1, 0, d[0][2] ]]


#-------------------------------------------------------------------------------
#--- POBRANIE POLTUSZ DO GRIDA PODGLADU - 25
#-------------------------------------------------------------------------------
if Fun == 15 and stat == 'OK':
    sql ="SELECT p.numer_ubojowy,p.ilosc1,p.artykul_id,a.nazwa,"
    sql+=" p.ilosc2,replace(to_char(p.uf_miesnosc,'9999,9'),',','.'),"
    sql+=" COALESCE(p.klasyf_europ,'')"
    sql+=" FROM rs_uboje_poltusze p"
    sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    sql+=" WHERE p.firma_id='"+self.firma_id+"' AND p.oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND p.data='"+Data+"' AND p.numer_uboju="+str(NumerUboju)
    sql+=" ORDER BY p.numer_ubojowy DESC;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = "Bd pobrania ptusz z uboju: "+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (dodawanie, edycja)
#-------------------------------------------------------------------------------
if Fun in (1,2,3,4) and stat == 'OK':
    # sprawdzenie danych uboju
    sql ="SELECT stan FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+"; "

    stat,uboj,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych uboju: '+sql
    elif len(uboj) == 0:
        stat = 'Brak uboju o podanym kluczu'
    elif uboj[0][0] <> 'G':
        stat = 'Ubj w stanie '+uboj[0][0]+'. Dodawanie/edycja pomiarw niemoliwa.'

if Fun in (3,4) and stat == 'OK':
    # pobranie danych, aby mozna sprawdzac dane w sytacji, gdy nie wszystkie
    # zmienily sie, a trzeba sprawdzic wzajemne zaleznosci
    sql ="SELECT * FROM rs_uboje_poltusze"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    sql+=" AND numer_ubojowy="+str(NumerUbojowy)+" AND numer_poltuszy="+str(NumerPoltuszy)
    sql+=" FOR UPDATE NOWAIT;"
    
    stat,Bylo,nagl,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych do sprawdzenia: '+stat
    elif len(Bylo) == 0:
        stat = 'Brak ptuszy o podanym kluczu.'
    
    if stat == 'OK':
        tr = rssql.RSTableRowset(Bylo,nagl)
        if not tr.GetVal(0,'recznie'):
            stat = 'Ptusza zapisana na stanowisku ubojowym. Edycja niemoliwa.'


if Fun in (1,2,3,4) and stat == 'OK':
    
    DataUbicia = None
    Artykul = None
    KlasyfEurop = None
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    

        if pole == 'data':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA')
            else:    
                stat='BR_DATA'
                dane.append(stat)

        elif pole == 'data_ubicia':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA_UBICIA')
                else:
                    DataUbicia = wart
            else:    
                stat='BR_DATA_UBICIA'
                dane.append(stat)

        elif pole == 'artykul_id':
            wart = wart.strip()
            if wart=='':
                stat = 'BR_ARTYKUL'
                dane.append(stat)        
            else:
                Artykul = wart
                sql ="SELECT artykul_id,COALESCE(cecha1_opis,'') FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                sql+=" AND aktywny;"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia artykuu: '+stat)
                elif len(d) == 0:
                    dane.append('BL_ARTYKUL')

        elif pole == 'ilosc1':
            if wart < 1:
                dane.append('BL_ILOSC1')

        elif pole == 'ilosc2':
            if wart <= 0:
                dane.append('BL_ILOSC2')
        
        elif pole == 'klasyf_europ':
            KlasyfEurop = wart

    if stat == 'OK':
        if len(dane) > 0:
            # jesli byly jakies bledy
            stat = dane[0]

    if stat == 'OK' and Reczna:
        # Dodawanie/edycja pozycji recznej.
        # Sprawdzenie, czy artykul musi miec okreslona klase miesa (klasyf_europ)
        # ktora pozniej jest wartoscia cechy i jednoczesnie numerem serii
        # przy tworzeniu dokumentu magazynowego
        # Funkcja zapisu na stanowisku ultrafomu kontroluje na oknie
        # aby umozliwic automatyczny zapis pomiarow
        
        if Artykul == None:
            # artykul nie byl modyfikowany wiec trzeba go pobrac z dotychczasowych danych
            Artykul = tr.GetVal(0,'artykul_id')
            
        if KlasyfEurop == None:
            KlasyfEurop = tr.GetVal(0,'klasyf_europ')
            
        sql ="SELECT COALESCE(cecha1_opis,'') FROM rs_artykuly"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(Artykul)+"'; "
        stat,cecha,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia cechy w artykule: '+stat
            dane.append(stat)
            
        elif cecha[0][0] <> '':
            # cecha jest konieczna czyli musi byc wyliczona klasa miesa
            if KlasyfEurop in (None,'','None'):
                stat = 'BR_CECHA1WARTOSC'
                dane.append(stat)
            
            if stat == 'OK':
                # czy cecha posiada slownik wartosci
                sql ="SELECT kod FROM rs_artykuly_cechy_wartosci"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+rsglobal.Dekoduj(cecha[0][0])+"'; "
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia wartoci cechy: '+stat
                    dane.append(stat)
                    
                elif len(d) > 0:
                    # poniewaz slownik zawiera dopuszczalne wartosci,
                    # to sprawdzamy czy podana wartosc wystepuje w slowniku

                    sql ="SELECT kod FROM rs_artykuly_cechy_wartosci"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND kod='"+rsglobal.Dekoduj(cecha[0][0])+"'"
                    sql+=" AND wartosc='"+rsglobal.Dekoduj(KlasyfEurop)+"'; "

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia wartoci cechy w sowniku: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL_CECHA1WARTOSC'
                        dane.append(stat)


if Fun in (1,2) and stat == 'OK' and not Reczna:
    # pobranie ostatniego numeru ubojowego do sprawdzenia
    # tylko na stanowisku ubojowym
    sql ="SELECT MAX(COALESCE(numer_ubojowy,0))"
    sql+=" FROM rs_uboje_poltusze"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data_ubicia='"+DataUbicia+"';"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania ostatniego numeru ubojowego: '+sql

    elif NumerUbojowy <= d[0][0]:
        stat = 'BL_NUMER_UBOJOWY'
        # w wyn2 propozycja nowego numeru ubojowego do zmiany na oknie
        wyn2.append(d[0][0]+1)

if Fun in (1,2) and stat == 'OK' and Reczna:
    if NumerUbojowy == 0:
        stat = 'BR_NUMER_UBOJOWY'
        dane.append(stat)

    if stat == 'OK':
        # kontrola proponowanego numeru ubojowego dla zapiszu recznego
        sql ="SELECT * FROM rs_uboje_poltusze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data_ubicia='"+DataUbicia+"'"
        sql+=" AND numer_ubojowy="+str(NumerUbojowy)+";"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia nowego numeru ubojowego dla daty ubicia: '+sql
    
        elif len(d) > 0:
            stat = 'BL_NUMER_UBOJOWY_ZAJETY'
            dane.append(stat)
    
    if stat == 'OK':
        # kontrola proponowanego numeru ubojowego dla zapiszu recznego
        sql ="SELECT * FROM rs_uboje_poltusze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" AND numer_ubojowy="+str(NumerUbojowy)+" AND numer_poltuszy="+str(NumerPoltuszy)+"; "
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia nowego numeru ubojowego: '+sql
            dane.append(stat)
    
        elif len(d) > 0:
            stat = 'BL_NUMER_UBOJOWY_IST'
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    INSERT = "INSERT INTO rs_uboje_poltusze"
    Pola="firma_id,oddzial_id,data,numer_uboju,numer_ubojowy,numer_poltuszy"
    Wartosci="'"+str(self.firma_id)+"','"+self.oddzial_id+"','"+Data+"',"+\
             str(NumerUboju)+","+str(NumerUbojowy)+","+str(NumerPoltuszy)

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['artykul_id','klasyf_europ','uf_ramka','data_ubicia']:
            Pola= Pola+","+pole
            Wartosci += ",'"+str(wart)+"'" 

        elif pole in ['czas_pomiaru','czas_wazenia']:
            if wart <> '':
                Pola= Pola+","+pole
                Wartosci += ",'"+str(wart)+"'" 

        elif pole in ['ilosc1','ilosc2','miesnosc_konc',
                      'uf_miesnosc','uf_t1','uf_t2','uf_m1','uf_m2',
                      'uf_w1','uf_w2','uf_oper','uf_pist','recznie']:
            Pola += ","+pole
            Wartosci += ","+str(wart) 
        
    INSERT += " ("+Pola+") VALUES ("+Wartosci+");"
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT ,1)
    if stat<>'OK':
        stat = 'Bdy dodawania danych:'+stat
        dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK' and Reczna: 
    UPDATE ="UPDATE rs_uboje_poltusze SET "

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ('artykul_id',):
            UPDATE+=pole+"='"+str(wart)+"'," 
        
        elif pole in ('klasyf_europ',):
            if wart <> '':
                UPDATE+=pole+"='"+str(wart)+"'," 
            else:
                UPDATE+=pole+"=NULL," 
                
        elif pole in ('ilosc1','ilosc2','miesnosc_konc'):
            UPDATE+=pole+"="+str(wart)+","

    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    UPDATE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    UPDATE+=" AND numer_ubojowy="+str(NumerUbojowy)+" AND numer_poltuszy="+str(NumerPoltuszy)+"; "
    
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych: '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem, 1-insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_uboje_poltusze"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SELECT+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    SELECT+=" AND numer_ubojowy="+str(NumerUbojowy)+" AND numer_poltuszy="+str(NumerPoltuszy)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych uboju: '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        # [0] artykul
        if (self.oddzial_id,'013000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu artykulu: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny numer artykuu.')
                else:
                    wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do kartoteki artykuw. Poinformuj administratora.')
        
        # [1] czas_pomiaru
        if tr.GetVal(0,"czas_pomiaru") in ('None','NULL'):
            wyn2.append('')
        else:
            wyn2.append(tr.GetVal(0,"czas_pomiaru"))
        
        # [2] czas_wazenia
        if tr.GetVal(0,"czas_wazenia") in ('None','NULL'):
            wyn2.append('')
        else:
            wyn2.append(tr.GetVal(0,"czas_wazenia"))
