# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_pom.py
# Purpose:     zbior funkcji wykorzystywanych w module ubojni
# Author:      Mariusz Rajfura
# Created:     2013/09/06
# RCS-ID:      $Id: fs_uboje_pom.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def PodajSumyPozycjiDokumentuMagazynowego(self,Klucze):
    import rsglobal
    
    # dla danych drukowanych 
    odstep = u'   '
    
    stat = 'OK'
    dane = []
    wyn1 = []
    wyn2 = {}

    dokumenty = []
    if isinstance(Klucze, dict):
        dokumenty.append([Klucze['Magazyn'],
                          Klucze['Dokument'],
                          Klucze['Data'],
                          Klucze['Numer']])
    elif isinstance(Klucze, (list,tuple)):
        dokumenty.extend(Klucze)
    
    WHERE = "(firma_id,magazyn_id,dokument_id,data,numer) IN ("
    for i in xrange(len(dokumenty)):
        if i > 0:
            WHERE+=","
        WHERE+="('"+self.firma_id+"',"+\
                "'"+rsglobal.Dekoduj(dokumenty[i][0])+"',"+\
                "'"+rsglobal.Dekoduj(dokumenty[i][1])+"',"+\
                "'"+rsglobal.Dekoduj(dokumenty[i][2])+"',"+\
                                 str(dokumenty[i][3])+")"
    
    WHERE += ")"

    sql ="SELECT dmp.artykul_id,a.nazwa,"
    sql+=" SUM(dmp.ilosc1),COALESCE(a.jm1,''),"
    sql+=" SUM(dmp.ilosc2),COALESCE(a.jm2,''),"
    sql+=" COALESCE(dmp.cecha1_opis,''),COALESCE(dmp.cecha1_wartosc,'')"
    sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
    sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    sql+=" WHERE "+WHERE
    sql+=" GROUP BY dmp.artykul_id,a.nazwa,a.jm1,a.jm2,dmp.cecha1_opis,dmp.cecha1_wartosc "
    sql+=" ORDER BY dmp.artykul_id,dmp.cecha1_opis,dmp.cecha1_wartosc; "

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania sum z pozycji aktualnego dokumentu: '+stat
        return stat,dane,wyn1,wyn2
    
    SIlosc1 = 0
    SIlosc2 = 0
    for i in xrange(len(dane)):
        SIlosc1 += dane[i][2]
        SIlosc2 += dane[i][4]

    # formatowanie sum do wydruku
    sql ="SELECT "
    sql+="to_char("+str(SIlosc1)+",'999 999 990.9999'),"
    sql+="to_char("+str(SIlosc2)+",'999 999 990.9999');"
    stat,SumyStr,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd formatowania: '+stat
        return stat,dane,wyn1,wyn2
    
    # lista z opisami naglowkow
    naglowki = []
    naglowki.append(odstep+u'Sumy pozycji z dokumentw:')
    for i in xrange(len(dokumenty)):
        magazyn = dokumenty[i][0]
        dokument = dokumenty[i][1]
        data = dokumenty[i][2]
        numer = dokumenty[i][3]
        
        sql ="SELECT dm.stan,COALESCE(dm.kontrahent_id,''),COALESCE(k.nazwa,'')"
        sql+=" FROM rs_dokumenty_magazynowe dm"
        sql+=" LEFT JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
        sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+magazyn+"'"
        sql+=" AND dokument_id='"+dokument+"' AND dm.data='"+data+"'"
        sql+=" AND numer="+str(numer)+"; "

        stat,dokn,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z nagwka dokumentu: '+stat
            return stat,dane,wyn1,wyn2
        elif len(dokn) == 0:
            stat = 'Brak dokumentu o podanym kluczu: '+sql
            return stat,dane,wyn1,wyn2
        
            
        naglowki.append(odstep+'Stan ('+dokn[0][0]+')  dokument '+\
                        magazyn+'/'+dokument+'/'+data+'/'+rsglobal.UsunKropkaZero(numer)+'  '+\
                        dokn[0][1]+' '+dokn[0][2])
    
    naglowki.append(len(naglowki[-1])*'-')

    szer_art = 10
    szer_nazwa = 20
    szer_cecha1opis = 5
    szer_cecha1wartosc = 5
    
    pozycje = []
    for i in xrange(len(dane)):
        sql ="SELECT "
        sql+=" to_char("+str(dane[i][2])+",'999 999 990.9999'),"
        sql+=" to_char("+str(dane[i][4])+",'999 999 990.9999');"

        stat,liczby,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd formatowania liczb: '+sql
            return stat,dane,wyn1,wyn2
        
        art = dane[i][0].strip().ljust(szer_art)
        nazwa = dane[i][1].strip().ljust(szer_nazwa)
        ilosc1 = liczby[0][0]
        jm1 = dane[i][3].ljust(4)
        ilosc2 = liczby[0][1]
        jm2 = dane[i][5].ljust(4)
        cecha1opis = dane[i][6].strip().ljust(szer_cecha1opis)
        cecha1wartosc = dane[i][7].strip().ljust(szer_cecha1wartosc)
        
        pozycje.append(odstep+art+' '+nazwa+' '+ilosc1+' '+jm1+' '+\
                       ilosc2+' '+jm2+' '+cecha1opis+' '+cecha1wartosc)
    
    sumystr = []
    sumystr.append(odstep+(szer_art+szer_nazwa+2)*' '+SumyStr[0][0]+7*' '+SumyStr[0][1])
    # podkreslenie
    if len(pozycje) > 0:
        sumystr.insert(0,len(pozycje[-1])*'-')
    else:
        sumystr.insert(0,len(sumystr[0])*'-')
    
    wyn2['Sumy'] = [SIlosc1,SIlosc2]
    wyn2['SumyStr'] = sumystr
    wyn2['Naglowki'] = naglowki
    wyn2['Pozycje'] = pozycje
    
    return stat,dane,wyn1,wyn2

#-------------------------------------------------------------------------------
