# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_zywce_dane
# Purpose:     dodawanie/edycja danych zywca
# Author:      Mariusz Rajfura
# Created:     2013/09/10
# RCS-ID:      $Id: fs_uboje_zywce_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def PodajSumyZPozycjiZywca(self, Data, NumerUboju):
    # funkcja podaje dane na postawie juz zapisanych pozycji zywcow
    
    wynik = {}
    # suma pozycji z dokumentu ubojowego
    sql ="SELECT ilosc1,ilosc2 FROM rs_uboje_zywce"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    sql+=" ORDER BY nr_poz; "
    
    stat,poz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania sum z pozycji ywcw: '+stat
        return stat, wynik
    
    sztuki = 0
    waga = 0
    for p in poz:
        sztuki += p[0]
        waga += p[1]
        
    wynik['LiczbaPozycjiZywcow'] = len(poz)
    wynik['SumaSztukZywcow'] = sztuki
    wynik['SumaWagiZywcow'] = waga

    sql ="SELECT liczba_sztuk FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+"; "
    
    stat,nagl,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z nagwka uboju: '+stat
        return stat, wynik
    
    wynik['DeklarowanaLiczbaPozycjiZywcow'] = nagl[0][0]

    return stat, wynik

#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = {}
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Data':[1,2,3,4,5,10],'NumerUboju':[1,2,3,4,5,10], 'NrPoz':[1,2,3,4,5],
           'Artykul':(30,) }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_zywce_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if Fun in (1,2,3,4,5,10,11):
    Data = rsglobal.Dekoduj(klucze['Data'])
    NumerUboju = rsglobal.Dekoduj(klucze['NumerUboju'])

if Fun in (1,2,3,4,5):
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

if Fun in (30,):
    Artykul = rsglobal.Dekoduj(klucze['Artykul'])


UprDodawanie = (((self.oddzial_id,'602003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'602002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ARTYKULU - 30
#-------------------------------------------------------------------------------

if Fun == 30 and stat == 'OK':
    sql ="SELECT artykul_id,nazwa,COALESCE(jm1,''),COALESCE(jm2,'')"
    sql+=" FROM rs_artykuly"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND aktywny;"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych artykuu: '+sql
        

#-------------------------------------------------------------------------------
#--- POBRANIE STANU UBOJU
#-------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    sql ="SELECT stan FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu uboju: '+stat
    elif len(dane) == 0:
        stat = 'Brak uboju o podanym kluczu.'


#-------------------------------------------------------------------------------
#--- POBRANIE SUM Z POZYCJI ZYWCA
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    stat, sumy = PodajSumyZPozycjiZywca(self, Data, NumerUboju)
    if stat == 'OK':
        wyn2.update(sumy)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':
    # spradzenie stanu uboju
    sql ="SELECT stan FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia stanu uboju: '+stat
    elif len(d) == 0:
        stat = 'Brak uboju o podanym kluczu.'
    elif not d[0][0] in ('W','G'):
        stat = 'Ubj w stanie '+d[0][0]+'. Dodawanie/edycja niemoliwa.'

if Fun in (3,4) and stat == 'OK':
    if stat == 'OK':
        # pobranie danych, aby mozna sprawdzac dane w sytacji, gdy nie wszystkie
        # zmienily sie, a trzeba sprawdzic wzajemne zaleznosci
        sql ="SELECT * FROM rs_uboje_zywce"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" AND nr_poz="+str(NrPoz)+" FOR UPDATE NOWAIT;"
        
        stat,Bylo,nagl,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych do sprawdzenia: '+stat
        elif len(Bylo) == 0:
            stat = 'Brak ywca o podanym kluczu.'
        
        tr = rssql.RSTableRowset(Bylo,nagl)


if Fun in (1,2,3,4) and stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    

        if pole == 'data':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL_DATA')
                else:
                    DoKiedy = wart
            else:    
                stat='BR_DATA'
                dane.append(stat)

        elif pole == 'artykul_id':
            wart = wart.strip()
            if wart=='':
                stat = 'BR_ARTYKUL'
                dane.append(stat)        
            else:
                sql ="SELECT artykul_id FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                sql+=" AND aktywny;"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia artykuu: '+stat)
                elif len(d) == 0:
                    dane.append('BL_ARTYKUL')

        elif pole == 'ilosc1':
            if wart <= 0:
                dane.append('BL_ILOSC1')

        elif pole == 'ilosc2':
            if wart <= 0:
                dane.append('BL_ILOSC2')

    if stat == 'OK':
        if len(dane) > 0:
            # jesli byly jakies bledy
            stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    # pobranie nowego numeru uboju
    sql ="SELECT COALESCE(MAX(nr_poz),0)+1"
    sql+=" FROM rs_uboje_zywce"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"

    stat,NowyNrZywca,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania numeru ywca: '+stat
    else:
        # numer dla INSERT i SELECT
        NrPoz = NowyNrZywca[0][0]
        
    if stat == 'OK':
        INSERT = "INSERT INTO rs_uboje_zywce"
        Pola="firma_id,oddzial_id,data,numer_uboju,nr_poz"
        Wartosci="'"+str(self.firma_id)+"','"+self.oddzial_id+"','"+Data+"',"+str(NumerUboju)+","+str(NrPoz)
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]        
            if pole in ['artykul_id']:
                Pola= Pola+","+pole
                Wartosci += ",'"+str(wart)+"'" 
    
            elif pole in ['ilosc1','ilosc2']:
                Pola += ","+pole
                Wartosci += ","+str(wart) 
        
        INSERT += " ("+Pola+") VALUES ("+Wartosci+");"
        
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT ,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':   
    UPDATE = "UPDATE rs_uboje_zywce SET "        
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
            
        if pole in ['artykul_id']:
            UPDATE += pole+"='"+wart+"',"
        elif pole in ['ilosc1','ilosc2']:
            UPDATE += pole+"="+str(wart)+","

    UPDATE = UPDATE[:-1]     
    UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"' "
    UPDATE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    UPDATE+=" AND nr_poz="+str(NrPoz)+";"   
    
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych uboju: '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem, 1-insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_uboje_zywce"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    SELECT+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
    SELECT+=" AND nr_poz="+str(NrPoz)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych ywca: '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # artykul
        klucz = 'ArtykulOpis'
        if (self.oddzial_id,'013000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2[klucz] = 'Bd pobrania opisu artykuu: '+stat
            else:
                if len(d) == 0:
                    wyn2[klucz] = 'Bdny numer artykuu.'
                else:
                    wyn2[klucz] = rsglobal.Dekoduj(d[0][0])
        else:
            wyn2[klucz] = 'Brak uprawnie do kartoteki artykuw. Poinformuj administratora.'

        # suma pozycji z dokumentu ubojowego
        stat, sumy = PodajSumyZPozycjiZywca(self, Data, NumerUboju)
        if stat == 'OK':
            wyn2.update(sumy)
            
        
