
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_umowy.py
# Purpose:     wczytuje/usuwa dane z umowami
#
# Author:      Micha� Raburski,Pawel Wojcikowski, Marcin Wlodarczyk
# Created:     2008/08/11
# RCS-ID:      $Id: fs_repertorium.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat="OK"

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=="OK":
    Funkcja = klucze['Funkcja']
    
    SlPar={'Oddzial':[1,5],'Kontrahent':[1,5],'NumerUmowy':[1,5],'TypUmowy':[1,5],'Osoba':[1,5],
           'UmowaOd':[1,5],'UmowaDo':[1,5],'ZawarcieOd':[1,5],'ZawarcieDo':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_umowy z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=="OK":
    if Funkcja in [1,5]:
        Oddzial = klucze['Oddzial']
        Kontrahent = klucze['Kontrahent']
        NumerUmowy = klucze['NumerUmowy']
        TypUmowy = klucze['TypUmowy'].strip()
        OsobaOdp = klucze['Osoba']
        UmowaOd = klucze['UmowaOd']
        UmowaDo = klucze['UmowaDo']
        DataZawarciaOd = klucze['ZawarcieOd']
        DataZawarciaDo = klucze['ZawarcieDo']
        
    
dane = []
wyn1 = []
wyn2 = []

UprDel=((self.oddzial_id,'015024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprPrz=((self.oddzial_id,'015020') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

LPrz=[]
LUsun=[]

#-------------------------------------------------------------------------------
#----------------SPRAWDZANIE UPRAWNIEN DO DANEGO TYPU UMOWY
#-------------------------------------------------------------------------------

if Funkcja in [1,5] and stat == "OK":
    SQL ="SELECT umowa_typ,przegladanie,usuwanie "
    SQL+="FROM rs_umowy_typy_upr WHERE firma_id='"+self.firma_id+"' "
    SQL+="AND operator_id IN "+str(self.operatorzy).replace('[','(').replace(']',')')+";"
    stat,DTyp,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> "OK":
        stat = 'UPR PO BL'   
        dane.append(stat)
    else:  
        i=0
        while i < len(DTyp):
            if DTyp[i][1]==True:
                LPrz.append(DTyp[i][0].strip()) 
            if DTyp[i][2]==True:
                LUsun.append(DTyp[i][0].strip())
            i=i+1
        LPrz.append('')
        LUsun.append('')
        LUsun.append('NULL')
        LUsun.append('None')
    
    
#-------------------------------------------------------------------------------
#--- Sprawdzanie kontrahenta (2)
#-------------------------------------------------------------------------------

if Funkcja == 2 and stat == "OK":
    SQL ="SELECT kontrahent_id FROM rs_kontrahenci "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';"
    stat,d,w1,t = self.PolSQL.Execute(SQL,3)
    if stat <> "OK":
        stat='KONTR BL'
        dane.append(stat)
    else:
        if len(d) == 0:
            stat='KONTR BR'
            dane.append(stat)
        
        
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Delete = []

if stat=="OK" and Funkcja == 1:
    Delete=klucze['Delete']
    
    
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1  and stat == "OK":
    if len(Delete[0])>0:
        if ((not UprDel) or (not TypUmowy in LUsun)) and (not self.operator_id == STANDARD_OPERATOR_ID):
            stat='DEL UPR BR'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == "OK":
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT umowa_id FROM rs_umowy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_umowy "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ('umowa_id'):  
                        WHERE += " AND "+pole+"='"+str(wart)+"'"
                        SQLFU += " AND "+pole+"='"+str(wart)+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(SQLFU,3)
                if stat <> "OK":
                    stat = 'DEL SPR BL'
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLDEL,1)
                if stat <> "OK":
                    stat = 'DEL SQL BL'   
                    dane.append(stat)
        
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if Funkcja == 5 and stat == "OK":
    if not UprPrz:
        stat='POD UPR BR'
        dane.append(stat)
    
    if stat == "OK":
        def AddFiltr(nazwa,pole):
            if pole <> '':
                filtr=" AND upper(%s) LIKE upper('%s%s')"%(str(nazwa),str(pole),"%")
            else:
                return ""    
            return filtr
        
        Filtr = "(u.firma_id='%s'"%(self.firma_id)
        if Oddzial <> '':
            Filtr+=AddFiltr('u.oddzial_id',Oddzial)
 
        if Kontrahent <> '':
            Filtr+=AddFiltr('u.kontrahent_id',Kontrahent)
            
        if OsobaOdp <> '':
            Filtr+=AddFiltr('u.osoba_id',OsobaOdp)
        
        if NumerUmowy <> '':
            Filtr+=AddFiltr('u.umowa_nr',NumerUmowy)
     
        if TypUmowy <> '':
            if (not TypUmowy in LPrz) and (not self.operator_id == STANDARD_OPERATOR_ID):
                Filtr+=" AND u.umowa_typ= 'zzz'"
            else:
                Filtr+=AddFiltr('u.umowa_typ',TypUmowy) 
                  
        if TypUmowy == '' and (not self.operator_id == STANDARD_OPERATOR_ID):
            Filtr+=" AND (u.umowa_typ in "+str(LPrz).replace('[','(').replace(']',')').replace('u','')+" OR u.umowa_typ IS NULL)"
        
        if DataZawarciaOd <> '    -  -  ':
            Filtr+=" AND u.umowa_data>='"+str(DataZawarciaOd)+"'"
        
        if DataZawarciaDo <> '    -  -  ':
            Filtr+=" AND u.umowa_data<='"+str(DataZawarciaDo)+"'"       
        
        if UmowaOd <> '    -  -  ':
            Filtr+=" AND u.data_od>='"+str(UmowaOd)+"'"
        
        if UmowaDo <> '    -  -  ':
            Filtr+=" AND u.data_do<='"+str(UmowaDo)+"'"   
        Filtr +=')'
        
        SELECT ="SELECT u.umowa_id,u.oddzial_id,u.kontrahent_id,k.nazwa,u.umowa_nr,"
        SELECT+="u.umowa_typ,u.umowa_data,u.data_od,u.data_do,u.osoba_id "
        SELECT+="FROM rs_umowy u "
        SELECT+="LEFT JOIN rs_kontrahenci k USING (firma_id,kontrahent_id) "
        SELECT+="WHERE %s"%(Filtr)
        SELECT+=" ORDER BY u.umowa_id,u.oddzial_id,u.umowa_data,u.umowa_typ;"
        stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT,3)
        if stat <> "OK":
            stat = 'PO BL'  
            dane.append(stat)
