# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_umowy_pliki.py
# Purpose:     wyswietla, dodaje, usuwa z bazy danych informacje o 
#              zalacznikach do umw                                
# Author:      Marcin Wodarczyk, Pawe Wjcikowski
# Created:     2008/08/29
# RCS-ID:      $Id: fs_umowa_pliki.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

from funkcje import fs_pliki_global
import rsglobal

stat="OK"

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=="OK":
    Funkcja = klucze['Funkcja']
    
    SlPar={'PlikId':[2,6],'UmowaId':[1,2,5,6],'NazwaPliku':[1],'TrescPliku':[1],'TypUmowy':[1,2,5,6]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_umowy_pliki z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=="OK":
    UmowaId = klucze['UmowaId']
    TypUmowy = klucze['TypUmowy'].strip()
    if Funkcja in [2,6]:
        PlikId = klucze['PlikId']
    if Funkcja == 1:
        NazwaPliku = klucze['NazwaPliku']
        TrescPliku= klucze['TrescPliku']

dane = []
LPlik = []

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

UprIns=((self.oddzial_id,'015027') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel=((self.oddzial_id,'015028') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if Funkcja == 1 :
    if not UprIns:
        stat='UPR INS'

if Funkcja == 6 :
    if not UprDel:
        stat='UPR DEL'

if stat=='OK':
    #sprawdzenie poprawnoci umowy
    SQL="SELECT umowa_id FROM rs_umowy WHERE firma_id='"+self.firma_id+"' AND umowa_id = "+str(UmowaId)+" FOR UPDATE NOWAIT;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat='Bd sprawdzania poprawnoci umowy'+stat
if stat=='OK':
    if len(DTest)==0:
        stat='BR UM'
        
        
#-------------------------------------------------------------------------------
#----------------SPRAWDZANIE UPRAWNIEN DO DANEGO TYPU UMOWY
#-------------------------------------------------------------------------------

if Funkcja in [1,2,5,6] and stat == 'OK':
    SQL ="SELECT umowa_typ,pliki "
    SQL+="FROM rs_umowy_typy_upr WHERE firma_id='"+self.firma_id+"' "
    SQL+="AND operator_id IN "+str(self.operatorzy).replace('[','(').replace(']',')')+";"
    stat,DTyp,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania uprawnie do typw umw'+stat   
        
    else:  
        i=0
        while i < len(DTyp):
            if DTyp[i][1]==True:
                LPlik.append(DTyp[i][0].strip()) 
            i=i+1
            
        LPlik.append('')
        LPlik.append('NULL')
        LPlik.append('None')
    
    if stat == 'OK':
        if (not TypUmowy in LPlik) and (not self.operator_id == STANDARD_OPERATOR_ID):
            stat=u'Brak uprawnie'
            wyn2=u'Brak uprawnie'
    
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------
    
if Funkcja == 1:
    if stat=='OK':
        #wstawiamy plik do bazy
        SQL ="INSERT INTO rs_umowy_pliki (umowa_id,umowa_plik) "
        SQL+="VALUES ("+str(UmowaId)+",'"+NazwaPliku+"');"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd wykonania wstawienia pliku do bazy.'+stat
        
    if stat=='OK':
        # pobranie dodanego numeru pliku umowy
        SQL="SELECT max(plik_id) FROM rs_umowy_pliki WHERE umowa_id="+str(UmowaId)
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania numeru pliku umowy'+stat
    if stat=='OK':
        if len(DNum)==0:
            stat='PR DOD'
    
    if stat=='OK':
        PlikId=str(DNum[0][0])
        
        # wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i poczenie klucza z obu tabel.
        SQL ="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) "
        SQL+="VALUES ('"+self.firma_id+"','"+NazwaPliku+"','rs_umowy_pliki',FALSE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd wstawiania pustego rekordu'+stat
        
    if stat=='OK':
        SQL ="SELECT max(plik_id) FROM rs_pliki "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND tabela='rs_umowy_pliki';"
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania numeru pliku'+stat
    if stat=='OK':
        NrPliku=str(DNum[0][0])
        #wrzucamy plik na serwer
        stat=fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)
    if stat=='OK':
        SQL="UPDATE rs_umowy_pliki SET nr_pliku="+NrPliku+" WHERE umowa_id="+str(UmowaId)+" AND plik_id="+PlikId
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd przy dodawaniu pliku na serwer'+stat

       
#-------------------------------------------------------------------------------
#---   POBRANIE PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------
    
if Funkcja in [2,6]:
    if stat=='OK':
        SQL ="SELECT nr_pliku FROM rs_umowy_pliki "
        SQL+="WHERE umowa_id="+str(UmowaId)+" AND plik_id="+str(PlikId)+";"
        stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobrania numeru pliku'+stat
        
    if stat=='OK':
        if len(DPlik)==0:
            stat="Brak pliku o numerze "+str(PlikId)+" w umowie "+str(UmowaId)

 
#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if Funkcja == 2:   
    if stat=='OK':
        stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        dane=[Tresc]    
            
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 :
    if stat=='OK':
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        
    if stat == 'OK':
        SQL = "SELECT nr_pliku from rs_umowy_pliki where plik_id = '"+str(PlikId)+"';"
        stat, nr_pliku, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd przy pobieraniu danych do sprawdzenia'+stat
        if len(nr_pliku) == 1:
            SQL = "DELETE FROM rs_umowy_pliki WHERE plik_id='" + str(PlikId) + "';"
            SQL += "DELETE FROM rs_pliki WHERE plik_id="+str(nr_pliku[0][0])+";"
            rsglobal.ZapiszDoLogow(SQL, 5)
            stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                stat = 'Bd przy usuwaniu pliku'+stat

        elif len(nr_pliku) == 0:
            stat = 'Brak pliku do usunicia'
        else:
            stat = 'Mona usun tylko jeden plik'

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if Funkcja in [1,5,6] and stat=='OK':
    SQL ="SELECT plik_id,umowa_plik FROM rs_umowy_pliki "
    SQL+="WHERE umowa_id='"+str(UmowaId)+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu danych'+stat
