# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_urzadzenia.py
# Purpose:     produkcja/kartoteka urzadzen - grid: zmiana,klucza,usuw,przegl,wybor,pobr.opisu
#
# Author:      Mariusz Rajfura
# Created:     2009/10/20
# RCS-ID:      $Id: fs_urzadzenia.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2021-11-29 Bartosz Pagan (12738) okno Urzdzenia do refaktoryzacji

"""
Funkcje:

5. SELECT
6. DELETE
7. ZMIANA KLUCZA
9. Pobranie opisu urzadzenia
"""
stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Urzadzenie':[6,7,9], 'UrzadzenieN':[7],
             'UrzadzenieF':[5,6,7],'NazwaF':[5,6,7],'OddzialF':[5,6,7],'NastepnyPrzegladF':[5,6,7], 'DodaneUrzadzenia':[5,6,7]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":

    if Funkcja == 5:
        Klucze_Id         = klucze['DodaneUrzadzenia']

        UrzadzenieF       = rsglobal.Dekoduj(klucze['UrzadzenieF']).strip()
        NazwaF            = rsglobal.Dekoduj(klucze['NazwaF']).strip()
        OddzialF          = rsglobal.Dekoduj(klucze['OddzialF']).strip()
        NastepnyPrzegladF = rsglobal.Dekoduj(klucze['NastepnyPrzegladF']).strip()

    if  Funkcja == 6:
        Urzadzenie        = rsglobal.Dekoduj(klucze['Urzadzenie']).strip()
        Klucze_Id         = klucze['DodaneUrzadzenia']
        UrzadzenieF       = rsglobal.Dekoduj(klucze['UrzadzenieF']).strip()
        NazwaF            = rsglobal.Dekoduj(klucze['NazwaF']).strip()
        OddzialF          = rsglobal.Dekoduj(klucze['OddzialF']).strip()
        NastepnyPrzegladF = rsglobal.Dekoduj(klucze['NastepnyPrzegladF']).strip()

    if  Funkcja == 7:
        Urzadzenie        = rsglobal.Dekoduj(klucze['Urzadzenie']).strip()
        UrzadzenieN       = rsglobal.Dekoduj(klucze['UrzadzenieN']).strip()
        Klucze_Id         = klucze['DodaneUrzadzenia']
        UrzadzenieF       = rsglobal.Dekoduj(klucze['UrzadzenieF']).strip()
        NazwaF            = rsglobal.Dekoduj(klucze['NazwaF']).strip()
        OddzialF          = rsglobal.Dekoduj(klucze['OddzialF']).strip()
        NastepnyPrzegladF = rsglobal.Dekoduj(klucze['NastepnyPrzegladF']).strip()

    elif Funkcja == 9:
        Urzadzenie        = rsglobal.Dekoduj(klucze['Urzadzenie']).strip()


Fun = Funkcja
dane = []
wyn1 = []
GrupaProdukcja = '046'

UprUsuwanie = ((self.oddzial_id,'046004') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprZmKlucza = ((self.oddzial_id,'046005') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
# Pobranie opisu urzadzenia - 9
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 9:
    sql ="SELECT nazwa FROM rs_urzadzenia"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+Urzadzenie+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if len(d)>0:
            dane.append(d[0][0].strip())
        else:
            dane.append('Bdny nr urzdzenia')
    else:
        dane.append('Bd pobrania opisu urzdzenia')

#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania urzdze'

    if stat == 'OK':
        sql ="SELECT urzadzenie_id FROM rs_urzadzenia"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+Urzadzenie+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o urzdzeniu : '+stat
        elif len(d) == 0:
            stat = 'Urzdzenie o podanym numerze nie istnieje.'

    if stat == 'OK':
        DELETE ="DELETE FROM rs_urzadzenia"
        DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+Urzadzenie+"';"

        stat,d,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat != 'OK':
            stat = 'Urzdzenie uywane w innych kartotekach. Usunicie niemoliwe.'

#-------------------------------------------------------------------------------
# ZMIANA KLUCZA - 7
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 7:
    if not UprZmKlucza:
        stat = 'Brak uprawnie do zmiany klucza urzdzenia.'

    if stat == 'OK':
        sql ="SELECT urzadzenie_id FROM rs_urzadzenia"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+Urzadzenie+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o urzdzeniu : '+stat
        elif len(d) == 0:
            stat = 'Urzdzenie o podanym numerze nie istnieje.'

    if stat == 'OK':
        sql ="SELECT urzadzenie_id FROM rs_urzadzenia"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+UrzadzenieN+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o urzdzeniu : '+stat
        elif len(d) > 0:
            stat = 'Urzdzenie o podanym numerze ju istnieje.'

    if stat == 'OK':
        UPDATE ="UPDATE rs_urzadzenia SET urzadzenie_id = '"+UrzadzenieN+"'"
        UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+Urzadzenie+"';"
        rsglobal.ZapiszDoLogow(UPDATE)
        stat,d,dump,dump = self.PolSQL.Execute(UPDATE, 1)
        if stat != 'OK':
            stat = 'Bd zmiany klucza urzdzenia : '+stat

#-------------------------------------------------------------------------------
# SELECT 5,6,7
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (5,6,7):
    FILTR = "(firma_id = '"+self.firma_id+"'"
    if UrzadzenieF != '':
        FILTR += " AND urzadzenie_id LIKE '"+UrzadzenieF+"%'"
    if NazwaF != '':
        FILTR += " AND UPPER(nazwa) LIKE UPPER('"+NazwaF+"%')"
    if OddzialF != '' and OddzialF != '**':
        FILTR += " AND oddzial_id LIKE '"+OddzialF+"%'"
    if NastepnyPrzegladF != '':
        if not rsglobal.SprawdzCzyToData(NastepnyPrzegladF):
            stat = "Bdna data 'Przegld do'"
        FILTR += " AND nastepny_przeglad IS NOT NULL AND nastepny_przeglad <= '"+NastepnyPrzegladF+"'"
    FILTR += ")"
    
    #lista dozwolonych oddzialow dla urzadzen dolozona do filtra
    if stat == 'OK' and self.operator_id != STANDARD_OPERATOR_ID:
        #czy operator posiada uprawnienia do wszystkich oddzialow czyli '**' w grupie produkcja
        sql ="SELECT menu_id FROM rs_grupa_menu WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND menu_id LIKE '"+GrupaProdukcja+"%'"
        sql+=" AND grupa_id IN (SELECT grupa_id FROM rs_grupa_operator_oddzial"
        sql+=" WHERE oddzial_id = '**' AND operator_id = "+str(self.operator_id)+");"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat != 'OK':
            stat = 'Bd sprawdzenia uprawnie operatora : '+stat
        else:
            if len(d) == 0:
                #nie posiada uprawnien do wszystkich oddzialow, wiec odczytamy
                #liste oddzialow z self.uprawnienia
                Oddzialy = ''
                for i in self.uprawnienia:
                    if str(i[1][:3]) == GrupaProdukcja:
                        Oddzial = str(i[0])
                        if not Oddzial in Oddzialy:
                            if Oddzialy != '':
                                Oddzialy += ","
                            Oddzialy += "'"+Oddzial+"'"
                
                if Oddzialy == '':
                        stat = 'Brak oddzialw do ktrych uytkownik ma prawa.'
                else:
                    FILTR += " AND oddzial_id IN ("+Oddzialy+",'**')"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if stat == 'OK' and len(Klucze_Id) > 0:
        FILTR += " OR (firma_id = '"+self.firma_id+"' AND urzadzenie_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i][0]).replace("\\", "\\\\").replace("'", "\\\'")+"'"
        FILTR += "))"
    
    if stat == 'OK':
        SELECT ="SELECT urzadzenie_id,nazwa,oddzial_id,nastepny_przeglad,koszt_1h"
        SELECT+=" FROM rs_urzadzenia WHERE "+FILTR+" ORDER BY urzadzenie_id;"
        rsglobal.ZapiszDoLogow(SELECT)
        stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
        if stat != 'OK':
            stat = 'Bd pobrania listy urzdze : '+stat
