# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_urzadzenia_dane.py
# Purpose:     produkcja - edycja danych urzadzenia
# Author:      Mariusz Rajfura
# Created:     2009/10/21
# RCS-ID:      $Id: fs_urzadzenia_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-02-18 Mariusz Rajfura (6571) nowe pole 'koszt_1robh'
# 2013-02-28 Mariusz Rajfura (6626) nowe pole 'liczba_urzadzen'
# 2013-03-08 Mariusz Rajfura (6660) nowe pole 'grupa_id'
# 2013-04-29 Mariusz Rajfura (6824) nowe pole 'ean'
# 2013-11-03 Mariusz Rajfura (7277) nowe pole 'linia_id'
# 2021-11-29 Bartosz Pagan (12738) okno Urzdzenia do refaktoryzacji

"""
Funkcje:

1. INSERT
3. UPDATE
5. SELECT
"""


stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Fun = klucze['Funkcja']

    SlPar = {'Urzadzenie':[1, 2, 3, 4, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":

    if Fun in (1,2,3,4,5):
        Urzadzenie = rsglobal.Dekoduj(klucze['Urzadzenie']).strip()
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = ((self.oddzial_id,'046003') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = ((self.oddzial_id,'046002') in self.uprawnienia or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#--- sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2):
    if not UprDodawanie:
        stat = 'BR_UPR_INS'

if stat == 'OK' and Fun in (3,4):
    if not UprDodawanie:
        stat = 'BR_UPR_INS'

#-------------------------------------------------------------------------------
#--- sprawdzenie danych
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2,3,4):
    if Urzadzenie == '':
        stat = 'BR_URZADZENIE'
        dane.append(stat)

    if stat == 'OK' and Fun in (1,2):
        sql ="SELECT urzadzenie_id FROM rs_urzadzenia"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND urzadzenie_id = '"+Urzadzenie+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia symbolu urzdzenia : '+stat
        elif len(d) > 0:
            stat = 'BL_URZADZENIE_IST'

    if stat == 'OK':
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'urzadzenie_id':
                wartosci[i] = "'"+wart+"'"
                
            elif pole == 'nazwa':
                if wart == '':
                    dane.append('BR_NAZWA')
                wartosci[i] = "'"+wart+"'"
            
            elif pole == 'nastepny_przeglad':
                if wart == '    -  -  ':
                    wart = 'NULL'
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        dane.append('BL_NASTEPNY_PRZEGLAD')
                    else:
                        #minimalna walidacja, aby nie wpisa starej daty
                        if wart < '2009-01-01':
                            dane.append('BL_NASTEPNY_PRZEGLAD_ZAKRES')
                    wart = "'"+wart+"'"
                wartosci[i] = wart
            
            elif pole == 'oddzial_id':
                if wart == '':
                    dane.append('BR_ODDZIAL')
                else:
                    sql ="SELECT oddzial_id FROM rs_oddzialy"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        dane.append('Bd sprawdzenia symbolu oddzialu')
                    else:
                        if len(d) == 0:
                            dane.append('BL_ODDZIAL')
                        else:
                            #sprawdzenie oddzialu w liscie dozwolonych oddzialow
                            if self.operator_id != STANDARD_OPERATOR_ID:
                                if wart == '**':
                                    #czy operator posiada uprawnienia do wszystkich oddzialow czyli '**' w grupie produkcja
                                    sql ="SELECT menu_id FROM rs_grupa_menu WHERE firma_id = '"+self.firma_id+"'"
                                    sql+=" AND menu_id LIKE '046%'"
                                    sql+=" AND grupa_id IN (SELECT grupa_id FROM rs_grupa_operator_oddzial"
                                    sql+=" WHERE oddzial_id = '**' AND operator_id = "+str(self.operator_id)+");"
                                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                                    if stat != 'OK':
                                        stat = 'Bd sprawdzenia uprawnie operatora : '+stat
                                    elif len(d) == 0:
                                        dane.append('BR_UPR_ODDZIAL')
                                else:
                                    if not (wart,'046003') in self.uprawnienia:
                                        dane.append('BR_UPR_ODDZIAL')

                wartosci[i] = "'"+wart+"'"
                        
            elif pole == 'koszt_1h':
                if wart < 0:
                    dane.append('BL_KOSZT_1H')
                wartosci[i] = str(wart)
    
            elif pole == 'koszt_1robh':
                if wart < 0:
                    dane.append('BL_KOSZT_1ROBH')
                wartosci[i] = str(wart)
    
            elif pole == 'liczba_urzadzen':
                if wart < 0:
                    dane.append('BL_LICZBA_URZADZEN')
                wartosci[i] = str(wart)
    
            elif pole == 'grupa_id':
                if wart == '':
                    wart = "NULL"
                else:
                    wart = "'"+wart+"'"
                    sql ="SELECT kod FROM rs_grupy_urzadzen"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod="+wart+";"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        dane.append('Bd sprawdzenia grupy urzdze')
                    elif len(d) == 0:
                        dane.append('BL_GRUPA')
                wartosci[i] = str(wart)

            elif pole == 'ean':
                if wart == '':
                    wartosci[i] = "NULL"
                else:
                    if not wart.isdigit():
                        stat = 'BL_EAN'
                        dane.append(stat)
                        break

                    if stat == 'OK':
                        wartosci[i] = "'"+wart+"'"
                        sql ="SELECT urzadzenie_id FROM rs_urzadzenia"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND ean="+wartosci[i]+";"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat != 'OK':
                            stat = 'Bd sprawdzenia kodu EAN w urzadzeniach: '+stat
                            dane.append(stat)
                        elif len(d) > 0:
                            stat = 'BL_EAN_IST'
                            dane.append(stat)

            elif pole == 'linia_id':
                if wart == '':
                    wart = "NULL"
                else:
                    wart = "'"+wart+"'"
                    sql ="SELECT kod FROM rs_linie_produkcyjne"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod="+wart+";"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        dane.append('Bd sprawdzenia linii produkcyjnej')
                    elif len(d) == 0:
                        dane.append('BL_LINIA')
                wartosci[i] = str(wart)

    
    #jesli byly jakies bledy, stat = pierwszy blad z listy
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]


#------------------------------------------------------------------------------------
#---   DODAWANIE DANYCH (1 -insert z pobraniem, 2 -insert)
#------------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = 'firma_id'
    inswart = "'"+self.firma_id+"'"

    for i in xrange(len(pola)):
        inspola += ","+pola[i]
        inswart += ","+wartosci[i]
            
    INSERT = "INSERT INTO rs_urzadzenia ("+inspola+") VALUES ("+inswart+");"
    
    stat,d,dump,dump = self.PolSQL.Execute(INSERT, 1)
    if stat != 'OK':
        stat = 'Bd dodawania nowego urzdzenia: '+stat


#------------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-update z pobraniem, 4 -update)
#------------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    sqlupd = ''
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        sqlupd += pola[i]+"="+wartosci[i]+","
    
    if stat == 'OK':
        if len(sqlupd) > 0:    
            sqlupd = sqlupd[:-1]
            
            UPDATE ="UPDATE rs_urzadzenia SET "+sqlupd
            UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+Urzadzenie+"';"
                
            stat,d,dump,dump = self.PolSQL.Execute(UPDATE, 1)
            if stat != 'OK':
                stat = 'Bd aktualizacji danych urzdzenia: '+stat


#------------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem  1-insert z pobraniem )
#------------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    SELECT ="SELECT * FROM rs_urzadzenia"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+Urzadzenie+"';"            
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych urzdzenia'
        dane.append(stat) 
        
    if stat=='OK' and len(dane)==1:
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] oddzial - opis
        if tr.GetVal(0,"oddzial_id") != 'None':
            if ((self.oddzial_id,'001100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND oddzial_id='"+tr.GetVal(0,"oddzial_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania nazwy oddzialu: '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod oddziau')
                    else:
                        wyn2.append(str(d[0][0]))
            else:
                wyn2.append('Brak uprawnie do katalogu. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [1] grupa urzadzen - opis
        if tr.GetVal(0,"grupa_id") != 'None':
            if ((self.oddzial_id,'211080') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_grupy_urzadzen WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+tr.GetVal(0,"grupa_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania nazwy grupy: '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod grupy urzdze')
                    else:
                        wyn2.append(str(d[0][0]))
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [2] linia produkcyjna - opis
        if tr.GetVal(0,"linia_id") != 'None':
            if ((self.oddzial_id,'211130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                sql ="SELECT opis FROM rs_linie_produkcyjne WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND kod='"+tr.GetVal(0,"linia_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania nazwy linii: '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod linii produkcyjnej')
                    else:
                        wyn2.append(str(d[0][0]))
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')
