# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_korespondencja_przychodzaca_dane.py
# Purpose:     Dodawanie i edycja danych archiwalnych kontrahenta
# Author:      Wojciech Skowron
# Created:     2021/07/26
# RCS-ID:      $Id: fs_wf_korespondencja_przychodzaca_dane.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2022-07-14 Aleksander Bargie (13094) [WF] Podgld plikw binarnych z zagadnienia w korespondencji przychodzcej.
# 2022-07-20 Aleksander Bargie (13099) Zmiany w korespondencji przychodzcej
# 2022-10-03 Aleksander Bargie (13187) [WF] Podczas tworzenia zagadnienia z korespondencji przychodzcej nie kopiuje si symbol dok, data i kwota
# 2022-10-05 Aleksander Bargie (13191) [WF] Umoliwi dodanie zagadnienia w modyfikacji korespondencji przychodzcej
# 2022-10-05 Aleksander Bargie (13191) [WF] Podczas dodawania zagadnienia w korespondencji przychodzcej przycina komentarz w historii zagadnienia
# 2023-02-21 Aleksander Bargie (13359) Korespondencja przychodzca - drobiazgi
# 2023-05-10 Aleksander Bargie (13413) NIP w korespondencji przychodzcej
# 2023-07-07 Aleksander Bargie (13473) zmiany w sprawdzaniu pary kontrahent - dokument
# 2023-08-17 Aleksander Bargie (13514) Korespondencja przychodzca, sortowa opcje dla "Przypisz do:" podczas tworzenia zagadnienia po nazwisku a potem imieniu
# 2023-08-17 Aleksander Bargie (13517) WF - bd podczas dodawania zagadnienia
# 2023-08-29 Aleksander Bargie (13509) Upora si ze znakami specjalnymi w danych pobieranych z GUS (usunicie pobrania klucza GUS w tym fs_ie)
# 2023-09-08 Aleksander Bargie (13544) Modyfikacja w korespondencji nie aktualizuje zagadnienia
# 2023-11-10 Wojciech Skowron   (13598) Poprawiony numer uprawnie dla sownika rs_wf_rodzaje_dokumentow
import rsglobal
from funkcje import fs_pliki_global, fs_wf_zagadnienia_pom, fs_dowody_ksiegowe_pom  #AB 2023-07-07


"""
302100 Korespondencja przychodzca
302110 Przegldanie
302120 Modyfikacja
"""

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}
nieedytowalne_ins = ['numer']
nieedytowalne_upd = ['data', 'numer']
#AB 2022-07-14
Pliki, PlikiWyn1 = [], []
Operatorzy = []  #AB 2023-07-07
firma_id = self.firma_id
Oddzial  = self.oddzial_id
#AB 2022-07-15
aktualizowac_zagadnienie = False
pola_z_zagadnienia = ('dokument_id', 'komorka_id', 'temat', 'opis', 'kontrahent_id', 'nip', 'nadawca_nazwa',
                      'nadawca_adres', 'symbol_dokumentu', 'data_dokumentu', 'kwota_brutto')  #AB 2023-09-08
Puste = ('', '    -  -  ', '-  -', None, 'None', 'NULL')

#AB 2023-08-17 zmieniony order
SQLOperatorzy = """SELECT DISTINCT operator_id || ' - ' || o.nazwisko || ' ' || o.imie AS op, o.nazwisko, o.imie, operator_id
                   FROM rs_wf_uprawnienia_szczegoly 
                   JOIN rs_operatorzy o USING (operator_id)
                   WHERE  firma_id = %s AND dokument_id = %s
                   ORDER BY o.nazwisko, o.imie, operator_id;"""

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Oddzial': [1, 2, 3, 4, 5, 10, 11, 21], 'Rok': [1, 2, 3, 4, 5, 21], 'Numer': [3, 4, 5, 21],  #AB 05.10.22r
             'TworzycZagadnienie': [1, 2], #'Zagadnienie': [10], #AB 2022-07-15
             'Kontrahent': [11], 'NazwaPliku': [12], 'PrzypnijDo': [1, 2, 21],#AB 2023-02-21
             'ZawartoscPliku': [12], 'nr_pliku': [15, ], 'Dokument': [35, ], 'NIP': [45, ]}  #AB 2023-05-10

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_korespondencja_przychodzaca_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 2, 3, 4, 5, 10, 11, 12, 21]:  #AB 05.10.22r
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])

    if Funkcja in [1, 2, 3, 4, 5, 12, 21]:  #AB 05.10.22r
        Rok = rsglobal.Dekoduj(klucze['Rok'])

    if Funkcja in [3, 4, 5, 12, 21]:  #AB 05.10.22r
        Numer = rsglobal.Dekoduj(klucze['Numer'])

    if Funkcja in [1, 2, 21]:  #AB 2023-02-21
        PrzypnijDo = klucze['PrzypnijDo']

    if Funkcja in [1, 2]:
        TworzycZagadnienie = klucze['TworzycZagadnienie']

    if Funkcja == 21:  #AB 05.10.22r
        TworzycZagadnienie = True
    #AB 2022-07-15
    # if Funkcja == 10:
    #     Zagadnienie = rsglobal.Dekoduj(klucze['Zagadnienie'])

    if Funkcja == 11:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])

    if Funkcja == 12:
        NazwaPliku = rsglobal.Dekoduj(klucze['NazwaPliku'])
        ZawartoscPliku = rsglobal.Dekoduj(klucze['ZawartoscPliku'])

    if Funkcja == 15:  #AB 2022-07-14
        nr_pliku = rsglobal.Dekoduj(klucze['nr_pliku'])
        Oddzial  = self.oddzial_id

    if Funkcja == 35:  #AB 2023-02-21
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])

    if Funkcja == 45:  #AB 2023-05-08
        NIP = rsglobal.Dekoduj(klucze['NIP'])  #AB 2023-05-10

# -------------------------------------------------------------------------------
# -----------------------------   UPRAWNIENIA   ---------------------------------
# -------------------------------------------------------------------------------

UprMod = ((Oddzial, '302120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprSel = ((Oddzial, '302110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH (1, 3)   --------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR_MOD'

    if stat == 'OK':
        kontrahent = ''
        nazwa = ''
        adres = ''

        for pole, wart in zip(pola, wartosci):
            #AB 2022-07-15
            if not aktualizowac_zagadnienie and pole in pola_z_zagadnienia and Funkcja in (3, 4):  # zakomentowac 3,4
                aktualizowac_zagadnienie = True
            if pole == 'data':
                if wart in ('', '-  -', '    -  -  ', 'None'):
                    stat = 'BR_DATA'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA'
                    dane.append(stat)
                elif Funkcja in (1, 2) and wart < rsglobal.PodajDzis():
                    stat = 'BL_DATA_WSTECZ'
                    dane.append(stat)

            elif pole == 'dokument_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_DOKUMENT"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                elif Funkcja in (1, 2) and TworzycZagadnienie:
                    stat = "BR_DOKUMENT_ZAG"
                    dane.append(stat)
            #AB 2022-07-15
            # elif pole == 'zagadnienie_id':
            #     if wart != 0:
            #         SQL = "SELECT 1 FROM rs_wf_zagadnienia WHERE firma_id='{firma_id}' AND zagadnienie_id={wart};".format(**locals())
            #         stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            #         if stat == 'OK':
            #             if len(d) == 0:
            #                 stat = "BL_ZAGADNIENIE"
            #                 dane.append(stat)
            #         else:
            #             stat = 'Bdy sprawdzania danych: '+stat
            #             dane.append(stat)

            elif pole == 'komorka_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_komorki_zatrudniajace WHERE firma_id='{firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KOMORKA"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                else:
                    stat = "BR_KOMORKA"
                    dane.append(stat)

            elif pole == 'kontrahent_id':
                kontrahent = wart.strip()
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_kontrahenci WHERE firma_id='{firma_id}' AND kontrahent_id='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KONTRAHENT"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'nadawca_nazwa':
                nazwa = wart.strip()

            elif pole == 'nadawca_adres':
                adres = wart.strip()

        if Funkcja in (3, 4) and (nazwa == '' or adres == '' or kontrahent == ''):
            SQL = """SELECT COALESCE(nadawca_nazwa, ''), COALESCE(nadawca_adres, ''), COALESCE(kontrahent_id, '')
                     FROM rs_wf_korespondencja_przychodzaca
                     WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' AND rok='{Rok}' AND numer={Numer};
                  """.format(**locals())
            stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobrania danych pozycji"
                dane.append(stat)
            else:
                nazwa = d[0][0] if nazwa == '' else nazwa
                adres = d[0][1] if adres == '' else adres
                kontrahent = d[0][2] if kontrahent == '' else kontrahent

        if (nazwa == '' or adres == '') and kontrahent == '':
            stat = "BR_NADAWCA"
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------------   INSERT (1)   ------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2):
    Numer = 1
    SEL = """SELECT MAX(numer)+1 FROM rs_wf_korespondencja_przychodzaca 
             WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' AND rok='{Rok}';"""
    SEL = SEL.format(**locals())
    stat, dane_numer, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bad dodania danych:' + stat
        dane.append(stat)
    elif len(dane_numer) > 0 and dane_numer[0][0] > 0:
        Numer = dane_numer[0][0]

    INS = "INSERT INTO rs_wf_korespondencja_przychodzaca "
    Pola = "firma_id, oddzial_id, rok, numer "
    Wartosci = "'{firma_id}', '{Oddzial}', '{Rok}', {Numer}".format(**locals())

    #AB 2023-07-07
    NIP        = wartosci[pola.index('nip')]              if 'nip'              in pola else ''
    Kontrahent = wartosci[pola.index('kontrahent_id')]    if 'kontrahent_id'    in pola else ''
    Symbol     = wartosci[pola.index('symbol_dokumentu')] if 'symbol_dokumentu' in pola else ''
    if stat == 'OK':
        for pole, wart in zip(pola, wartosci):
            if pole not in nieedytowalne_ins:
                if pole in ['zagadnienie_id']:
                    Pola += ","+pole
                    #AB 2022-07-15
                    Wartosci += ",NULL"
                    # if wart == 0:
                    #     Wartosci += ",NULL"
                    # else:
                    #     Wartosci += ","+str(wart)
                else:
                    Pola += ","+pole
                    Wartosci += ","+rsglobal.ZmienNaNULL(wart)

        INS += "("+Pola+") VALUES ("+Wartosci+");"

        stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(INS)
        if stat != 'OK':
            stat = 'Bd dodania danych: '+stat
            dane.append(stat)

        if len(dane) > 0:
            stat = dane[0]

    if Symbol not in Puste and (NIP not in Puste or Kontrahent not in Puste):  #AB 2023-08-17
        stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'KP', str(Kontrahent), str(NIP),
                                                                               str(Symbol), [Oddzial, Rok, Numer])
        if stat == 'OK' and komunikat:
            wyn2['Powtorka'] = komunikat
    else:
        rsglobal.ZapiszDoLogow("NIP   Kontrahent Symbol:   {}   {}  {}".format(NIP, Kontrahent, Symbol))

# -------------------------------------------------------------------------------
# --------------------------   UPDATE (3)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    #AB 2023-07-07
    SEL = """SELECT * FROM rs_wf_korespondencja_przychodzaca WHERE (firma_id, oddzial_id, rok, numer) = (%s, %s, %s, %s)"""
    args = [self.firma_id, Oddzial, Rok, Numer]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SEL, args))
    stat, poprz_dane, poprz_wyn1, dump = self.PolSQL.Execute(SEL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych: " + stat
    if len(poprz_dane) == 0:
        stat = "Nie odnaleziono wpisu"
    else:
        tr_poprzednie = rssql.RSTableRowset(poprz_dane, poprz_wyn1)
        NIP        = tr_poprzednie.GetVal(0, 'nip')
        Kontrahent = tr_poprzednie.GetVal(0, 'kontrahent_id')
        Symbol     = tr_poprzednie.GetVal(0, 'symbol_dokumentu')

    UPD = "UPDATE rs_wf_korespondencja_przychodzaca SET "
    NIP        = wartosci[pola.index('nip')]              if 'nip'              in pola else NIP
    Kontrahent = wartosci[pola.index('kontrahent_id')]    if 'kontrahent_id'    in pola else Kontrahent
    Symbol     = wartosci[pola.index('symbol_dokumentu')] if 'symbol_dokumentu' in pola else Symbol
    if stat == 'OK':
        for pole, wart in zip(pola, wartosci):
            if pole not in nieedytowalne_upd:
                #AB 2022-07-15
                # if pole in ['zagadnienie_id']:
                #     if wart == 0:
                #         UPD += pole+"=NULL,"
                #     else:
                #         UPD += pole+"="+str(wart)+","
                # else:
                if pole not in ['zagadnienie_id']:
                    UPD += pole+"="+rsglobal.ZmienNaNULL(wart)+","

        UPD = UPD[0:-1]
        UPD += " WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' AND rok='{Rok}' AND numer={Numer};".format(**locals())

        stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(UPD)
        if stat != 'OK':
            stat = 'Bd modyfikacji danych:' + stat
            dane.append(stat)

        if len(dane) > 0:
            stat = dane[0]
    if stat == 'OK':  #AB 2023-08-17
        if Symbol not in Puste and (NIP not in Puste or Kontrahent not in Puste):
            stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'KP', str(Kontrahent),
                                                                                   str(NIP),
                                                                                   str(Symbol), [Oddzial, Rok, Numer])
            if stat == 'OK' and komunikat:
                wyn2['Powtorka'] = komunikat
        else:
            rsglobal.ZapiszDoLogow("NIP   Kontrahent Symbol:   {}   {}  {}".format(NIP, Kontrahent, Symbol))

# -------------------------------------------------------------------------------
# -----------------   TWORZENIE ZAGADNIENIA PO INSERCIE (1)   -------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2, 21) and TworzycZagadnienie:  #AB 05.10.22r
    SEL_ZAG = "SELECT nextval('rs_wf_zagadnienia_zagadnienie_id_seq');"
    rsglobal.ZapiszDoLogow(SEL_ZAG)
    stat, dane_zagadnienie_id, dump, dump = self.PolSQL.Execute(SEL_ZAG, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania numeru nowego zagadnienia: '+stat
        dane.append(stat)
    else:
        zagadnienie_id = dane_zagadnienie_id[0][0]

    if stat == 'OK':
        if Funkcja in (1, 2):  #AB 05.10.22r
            dokument_id      = wartosci[pola.index('dokument_id')]
            komorka_id       = wartosci[pola.index('komorka_id')]
            nip              = wartosci[pola.index('nip')]
            kontrahent_id    = wartosci[pola.index('kontrahent_id')]
            kontrahent_nazwa = wartosci[pola.index('nadawca_nazwa')]
            kontrahent_adres = wartosci[pola.index('nadawca_adres')]
            temat            = wartosci[pola.index('temat')]
            opis             = wartosci[pola.index('opis')]
            #AB 03.10.22r
            kwota_brutto     = wartosci[pola.index('kwota_brutto')]
            data_dokumentu   = wartosci[pola.index('data_dokumentu')]
            symbol_dokumentu = wartosci[pola.index('symbol_dokumentu')]
            data_dokumentu = data_dokumentu if rsglobal.SprawdzCzyToData(data_dokumentu) else None
        else:  #AB 05.10.22r
            sql_dane_zag = """SELECT *
                               FROM rs_wf_korespondencja_przychodzaca
                               WHERE firma_id=%s AND oddzial_id=%s AND rok=%s AND numer=%s;"""
            args = [firma_id, Oddzial, Rok, Numer]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql_dane_zag, args))
            stat, dane_zag, sql_dane_zag_wyn1, dump = self.PolSQL.Execute(sql_dane_zag, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Podczas pobierania danych z korespondecji przychodzcej wystpi bd: {}".format(stat)
            elif len(dane_zag) < 1:
                stat = u"Nie odnaleziono wpisu w korespondecji przychodzcej"
            else:
                tr = rssql.RSTableRowset(dane_zag, sql_dane_zag_wyn1)
                dokument_id      = tr.GetVal(0, "dokument_id")
                komorka_id       = tr.GetVal(0, "komorka_id")
                nip              = tr.GetVal(0, "nip")
                kontrahent_id    = tr.GetVal(0, "kontrahent_id")
                kontrahent_nazwa = tr.GetVal(0, "nadawca_nazwa")
                kontrahent_adres = tr.GetVal(0, "nadawca_adres")
                temat            = tr.GetVal(0, "temat")
                opis             = tr.GetVal(0, "opis")
                kwota_brutto     = tr.GetVal(0, "kwota_brutto")
                data_dokumentu   = tr.GetVal(0, "data_dokumentu")
                symbol_dokumentu = tr.GetVal(0, "symbol_dokumentu")
                PrzypnijDo       = PrzypnijDo  #AB 2023-02-21

        if stat == 'OK':  #AB 2023-02-21
            if kontrahent_id is not None and kontrahent_id.strip() in Puste:
                kontrahent_id = None
            if dokument_id is not None and dokument_id.strip() in Puste:
                dokument_id = None
            if PrzypnijDo is not None and PrzypnijDo.strip() in Puste:
                PrzypnijDo = None
            INS_ZAG = """INSERT INTO rs_wf_zagadnienia 
                                     (firma_id, zagadnienie_id, dokument_id, komorka_id, 
                                      kwota_brutto, data_dokumentu, symbol_dokumentu, 
                                      temat, opis, nip, kontrahent_id, kontrahent_nazwa, kontrahent_adres,
                                      wprowadzenie_czas, wprowadzenie_kto, modyfikacja_czas, modyfikacja_kto,
                                      zamkniete, zaksiegowane, operator_id) 
                                     VALUES 
                                     (%s, %s,  %s, %s,
                                      %s, %s, %s,
                                      %s, %s, %s, %s, %s, %s, 
                                      NOW(), rsf_getuserid(), NOW(), rsf_getuserid(), 
                                      False, False, %s);"""
            args = [firma_id, zagadnienie_id, dokument_id, komorka_id,
                    kwota_brutto, data_dokumentu, symbol_dokumentu,
                    temat, opis, nip, kontrahent_id, kontrahent_nazwa, kontrahent_adres,
                    PrzypnijDo]
            INS_HISTORIA = ""
            wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                           VALUES('{}', {}, NOW() + INTERVAL '{} microseconds', rsf_getuserid(), '{}', '{}');
                        """.format(firma_id, '{}', '{}', '{}', '{}')
            if dokument_id  is not None:
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 0, "Typ dokumentu", "=> {}".format(dokument_id.strip("' ")))
            if komorka_id != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 1, "Komrka org.", "=> {}".format(komorka_id.strip("' ")))
            if kontrahent_id is not None:
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 2, "Kontrahent", "=> {}".format(kontrahent_id.strip("' ")))
            if temat != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 3, "Wprowadzono temat", "=> " + temat.strip("' ")[:47])#AB 06.10.22r
            if opis != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 4, "Wprowadzono opis", "=> " + opis.strip("' ")[:47])#AB 06.10.22r
            #AB 03.10.22r
            if kwota_brutto  != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 5, "Kwota brutto", "=> " + str(kwota_brutto).strip("' "))
            if data_dokumentu  != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 6, "Data dokumentu", "=> " + str(data_dokumentu).strip("' "))
            if symbol_dokumentu  != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 7, "Symbol dokumentu", "=> " + str(symbol_dokumentu).strip("' "))
            if PrzypnijDo  != 'NULL':  #AB 2023-02-21
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 8, "Przypisano do ", "=> " + str(PrzypnijDo).strip("' "))
            if nip != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 9, "NIP", "=> {}".format(nip.strip("' ")))
            if kontrahent_nazwa != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 10, "Nazwa kontr.", "=> {}".format(kontrahent_nazwa.strip("' ")[:47]))
            if kontrahent_adres != 'NULL':
                INS_HISTORIA += wzor_hist.format(zagadnienie_id, 11, "Adres kontr.", "=> {}".format(kontrahent_adres.strip("' ")[:47]))

            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INS_ZAG+INS_HISTORIA, args))
            stat, dump, dump, dump = self.PolSQL.Execute(INS_ZAG+INS_HISTORIA, 1, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd tworzenia zagadnienia: '+stat
            dane.append(stat)
        else:
            UPD_ZAG = """UPDATE rs_wf_korespondencja_przychodzaca SET zagadnienie_id={zagadnienie_id} 
                      WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' AND rok='{Rok}' AND numer={Numer};
                      """.format(**locals())
            stat, dump, dump, dump = self.PolSQL.Execute(UPD_ZAG, 1, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow(UPD_ZAG)
            if stat != 'OK':
                stat = 'Bd dodawania numeru zagadnienia do pozycji:' + stat
                dane.append(stat)

# -------------------------------------------------------------------------------
# -----------------   AKTUALIZACJA DANYCH W ZAGADNIENIU   -----------------------
# -------------------------------------------------------------------------------
#AB 2022-07-15
if stat == 'OK' and aktualizowac_zagadnienie:  # dac and funkcja 3, 4
    sql_zag_pole   = """(SELECT {}
                         FROM rs_wf_korespondencja_przychodzaca
                         WHERE  firma_id=%s AND oddzial_id=%s AND rok=%s AND numer=%s)"""
    SQL = """SELECT zamkniete, zaksiegowane, zagadnienie_id
             FROM rs_wf_zagadnienia
             WHERE zagadnienie_id = {};
          ;""".format(sql_zag_pole.format('zagadnienie_id'))
    args_klucz_zag = [firma_id, Oddzial, Rok, Numer]
    args           = args_klucz_zag
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, test_zag, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych powizanego zagadnienia: " + stat
    elif len(test_zag) > 0 and test_zag[0][2] != 0:
        zagadnienie_id = test_zag[0][2]
        zamkniete      = test_zag[0][0]
        zaksiegowane   = test_zag[0][1]
        if zaksiegowane or zamkniete:
            stat = "Nie mona modyfikowa danych przepisanych na zagadnienie ktre zostao ju {}".format('zaksigowane' if zaksiegowane else 'zamknite')
        else:

            if stat == 'OK':
                stat, poprzednie = fs_wf_zagadnienia_pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)
            if stat == 'OK':
                args = []
                SQL = """UPDATE rs_wf_zagadnienia
                         SET"""
                for pole in pola_z_zagadnienia:
                    SQL += " {}={},".format(pole.replace("nadawca", "kontrahent"), sql_zag_pole.format(pole))
                    args += args_klucz_zag
                SQL = SQL.strip(',')
                SQL += """ WHERE zagadnienie_id = %s ;"""
                args.append(zagadnienie_id)
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, args, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd aktualizacji danych powizanego zagadnienia: " + stat
            if stat == 'OK':
                stat, nowe = fs_wf_zagadnienia_pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

            if stat == 'OK':
                INSHISTORIA = ""
                opoznienie_hist = 2  # dodawanie zag konczy na 11, tu zaczynamy od 20(dodawane jest zero w zapytaniu) aby uniknac konfliktu czasu mod.
                argshistoria = []
                wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                            VALUES('{}', {}, NOW() + INTERVAL '{}0 microseconds', rsf_getuserid(), %s, %s);
                            """.format(firma_id, zagadnienie_id, '{}')
                rsglobal.ZapiszDoLogow(nowe)
                rsglobal.ZapiszDoLogow(poprzednie)
                for pole in pola_z_zagadnienia:
                    pole = pole.replace("nadawca", "kontrahent")
                    n, p = nowe[pole], poprzednie[pole]
                    if n != p:
                        if pole == 'dokument_id':
                            SELRODZ = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_rodzaje_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS poprzedni, 
                                                (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_rodzaje_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                                          ;""".format(firma_id, p, firma_id, n)
                            rsglobal.ZapiszDoLogow(SELRODZ)
                            stat, rodzaje, dump, dump = self.PolSQL.Execute(SELRODZ, 3, CzyDodawacBlad=True)
                            rsglobal.ZapiszDoLogow("pobrano rodzaje: {}".format(rodzaje))
                            if stat != 'OK':
                                stat = "Bd pobierania danych rodzajw dokumentw: {stat}".format(**locals())
                            else:
                                poprzedni, nowy = rodzaje[0]
                                if poprzedni in Puste:
                                    poprzedni = ''
                                if nowy in Puste:
                                    nowy = ''
                                if len(poprzedni) + len(nowy) > 46:
                                    zapas_poprzedni = max(23 - len(nowy), 0)
                                    zapas_nowy      = max(23 - len(poprzedni), 0)
                                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                                    nowy            = nowy[:23+zapas_nowy]
                                INSHISTORIA += wzor_hist.format(opoznienie_hist)
                                argshistoria.append("(Kor. przych.) Typ dokumentu")
                                argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'komorka_id':
                            SELKOM = """SELECT COALESCE((SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_komorki_zatrudniajace WHERE (firma_id, kod) = ('{}','{}')), '') AS poprzedni, 
                                               COALESCE((SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_komorki_zatrudniajace WHERE (firma_id, kod) = ('{}','{}')), '') AS nowy
                                        ;""".format(firma_id, p, firma_id,  n)
                            rsglobal.ZapiszDoLogow(SELKOM)
                            stat, komorki, dump, dump = self.PolSQL.Execute(SELKOM, 3, CzyDodawacBlad=True)
                            rsglobal.ZapiszDoLogow("pobrano komrki: {}".format(komorki))
                            if stat != 'OK':
                                stat = "Bd pobierania danych komrek zatrudniajcych: {stat}".format(**locals())
                            else:
                                poprzedni, nowy = komorki[0]
                                if poprzedni in Puste:
                                    poprzedni = ''
                                if nowy in Puste:
                                    nowy = ''
                                if len(poprzedni) + len(nowy) > 46:
                                    zapas_poprzedni = max(23 - len(nowy), 0)
                                    zapas_nowy      = max(23 - len(poprzedni), 0)
                                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                                    nowy            = nowy[:23+zapas_nowy]
                                INSHISTORIA += wzor_hist.format(opoznienie_hist)
                                argshistoria.append("(Kor. przych.) Komrka org.")
                                argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'temat':
                            poprzedni, nowy = p.strip(), n.strip()
                            if poprzedni in Puste:
                                poprzedni = ''
                            if nowy in Puste:
                                nowy = ''
                            if len(poprzedni) + len(nowy) > 46:
                                zapas_poprzedni = max(23 - len(nowy), 0)
                                zapas_nowy      = max(23 - len(poprzedni), 0)
                                poprzedni       = poprzedni[:23+zapas_poprzedni]
                                nowy            = nowy[:23+zapas_nowy]
                            INSHISTORIA += wzor_hist.format(opoznienie_hist)
                            argshistoria.append("(Kor. przych.) Temat")
                            argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'opis':
                            poprzedni, nowy = p.strip(), n.strip()
                            if poprzedni in Puste:
                                poprzedni = ''
                            if nowy in Puste:
                                nowy = ''
                            if len(poprzedni) + len(nowy) > 46:
                                zapas_poprzedni = max(23 - len(nowy), 0)
                                zapas_nowy      = max(23 - len(poprzedni), 0)
                                poprzedni       = poprzedni[:23+zapas_poprzedni]
                                nowy            = nowy[:23+zapas_nowy]
                            INSHISTORIA += wzor_hist.format(opoznienie_hist)
                            argshistoria.append("(Kor. przych.) Zmodyfikowano opis")
                            argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'kontrahent_id':
                            SELKON = """SELECT COALESCE((SELECT TRIM(kontrahent_id)||' - '||TRIM(nazwa) FROM rs_kontrahenci WHERE (firma_id, kontrahent_id) = ('{}','{}')), '') AS poprzedni, 
                                               COALESCE((SELECT TRIM(kontrahent_id)||' - '||TRIM(nazwa) FROM rs_kontrahenci WHERE (firma_id, kontrahent_id) = ('{}','{}')), '') AS nowy
                                        ;""".format(firma_id, p, firma_id,  n)
                            rsglobal.ZapiszDoLogow(SELKON)
                            stat, kontrahenci, dump, dump = self.PolSQL.Execute(SELKON, 3, CzyDodawacBlad=True)
                            rsglobal.ZapiszDoLogow("pobrano kontrahentw: {}".format(kontrahenci))
                            if stat != 'OK':
                                stat = "Bd pobierania danych kontrahentw: {stat}".format(**locals())
                            else:
                                poprzedni, nowy = kontrahenci[0]
                                if poprzedni in Puste:
                                    poprzedni = ''
                                if nowy in Puste:
                                    nowy = ''
                                if len(poprzedni) + len(nowy) > 46:
                                    zapas_poprzedni = max(23 - len(nowy), 0)
                                    zapas_nowy      = max(23 - len(poprzedni), 0)
                                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                                    nowy            = nowy[:23+zapas_nowy]
                                INSHISTORIA += wzor_hist.format(opoznienie_hist)
                                argshistoria.append("(Kor. przych.) Kontrahent")
                                argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'nip':
                            poprzedni, nowy = p.strip(), n.strip()
                            if poprzedni in Puste:
                                poprzedni = ''
                            if nowy in Puste:
                                nowy = ''
                            if len(poprzedni) + len(nowy) > 46:
                                zapas_poprzedni = max(23 - len(nowy), 0)
                                zapas_nowy      = max(23 - len(poprzedni), 0)
                                poprzedni       = poprzedni[:23+zapas_poprzedni]
                                nowy            = nowy[:23+zapas_nowy]
                            INSHISTORIA += wzor_hist.format(opoznienie_hist)
                            argshistoria.append("(Kor. przych.) Zmodyfikowano NIP")
                            argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'kontrahent_nazwa':
                            poprzedni, nowy = p.strip(), n.strip()
                            if poprzedni in Puste:
                                poprzedni = ''
                            if nowy in Puste:
                                nowy = ''
                            if len(poprzedni) + len(nowy) > 46:
                                zapas_poprzedni = max(23 - len(nowy), 0)
                                zapas_nowy      = max(23 - len(poprzedni), 0)
                                poprzedni       = poprzedni[:23+zapas_poprzedni]
                                nowy            = nowy[:23+zapas_nowy]
                            INSHISTORIA += wzor_hist.format(opoznienie_hist)
                            argshistoria.append("(Kor. przych.) Zmodyfikowano nazw kontr.")
                            argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        if pole == 'kontrahent_adres':
                            poprzedni, nowy = p.strip(), n.strip()
                            if poprzedni in Puste:
                                poprzedni = ''
                            if nowy in Puste:
                                nowy = ''
                            if len(poprzedni) + len(nowy) > 46:
                                zapas_poprzedni = max(23 - len(nowy), 0)
                                zapas_nowy      = max(23 - len(poprzedni), 0)
                                poprzedni       = poprzedni[:23+zapas_poprzedni]
                                nowy            = nowy[:23+zapas_nowy]
                            INSHISTORIA += wzor_hist.format(opoznienie_hist)
                            argshistoria.append("(Kor. przych.) Zmodyfikowano adres kontr.")
                            argshistoria.append("{} => {}".format(poprzedni, nowy).strip())
                        opoznienie_hist += 1
                    if stat != 'OK':
                        INSHISTORIA = None  # AB 17.06.22r
                        break
                if INSHISTORIA:
                    rsglobal.ZapiszDoLogow(INSHISTORIA)
                    argshistoria = [str(x) if isinstance(x, unicode) else x for x in argshistoria]
                    stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, argshistoria, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

            if stat == 'OK':
                stat = fs_wf_zagadnienia_pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH (1, 3, 5)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    if not UprSel > 0:
        stat = 'UPR_SEL'

    if stat == 'OK':
        SEL = """SELECT * FROM rs_wf_korespondencja_przychodzaca
                 WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' AND rok='{Rok}' AND numer={Numer};"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat

    if stat == 'OK':
        Komorka = TypWysylki = PrzyczynaZwrotu = ''

        tr = rssql.RSTableRowset2(dane, wyn1)[0]

        if tr["komorka_id"].strip() not in ('', 'None'):
            if ((Oddzial,'011710') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_komorki_zatrudniajace WHERE firma_id='"+firma_id+"' AND kod='"+tr["komorka_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    Komorka = 'Bd pobrania opisu komrki zatrudniajcej: '+stat
                else:
                    if len(d) == 0:
                        Komorka = 'Bdna komrka zatrudniajca'
                    else:
                        Komorka = str(d[0][0])
            else:
                Komorka = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if tr["dokument_id"].strip() not in ('', 'None'):
            if ((Oddzial,'211502') in self.uprawnienia) or ((Oddzial,'301100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_wf_rodzaje_dokumentow WHERE firma_id='"+firma_id+"' AND kod='"+tr["dokument_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    TypWysylki = 'Bd pobrania opisu rodzaju dokumentu: '+stat
                else:
                    if len(d) == 0:
                        TypWysylki = 'Bdny rodzaj dokumentu'
                    else:
                        TypWysylki = str(d[0][0])
            else:
                TypWysylki = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if stat in ('OK',):  #AB 2022-07-14
            SQLPliki = """SELECT z.firma_id, zagadnienie_id, nr_pliku, nazwa AS opis
                          FROM rs_wf_zagadnienia_pliki z JOIN rs_pliki p ON p.firma_id=z.firma_id  AND p.plik_id=z.nr_pliku 
                          AND p.tabela ='rs_wf_zagadnienia_pliki'
                          WHERE zagadnienie_id = '{}';""".format(tr["zagadnienie_id"])

            rsglobal.ZapiszDoLogow(SQLPliki)
            stat, Pliki, PlikiWyn1, dump = self.PolSQL.Execute(SQLPliki, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania plikw dla zgoszenia: {stat}".format(**locals())

        if stat in ('OK',):  #AB 2023-02-21

            args = [firma_id, str(tr["dokument_id"])]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLOperatorzy, args))

            stat, Operatorzy, OperatorzyWyn1, dump = self.PolSQL.Execute(SQLOperatorzy, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania operatorw do przekazania: {stat}".format(**locals())
        #AB 2023-07-07
        wyn2['Opisy']      = [Komorka, TypWysylki, PrzyczynaZwrotu]
        wyn2['Pliki']      = [Pliki, PlikiWyn1]
        wyn2['Operatorzy'] = Operatorzy
##AB 2022-07-15
# # -------------------------------------------------------------------------------
# # --------------------   POBRANIE DANYCH ZAGADNIENIA (10)   ---------------------
# # -------------------------------------------------------------------------------
#
# if stat == 'OK' and Funkcja == 10:
#     SEL = """SELECT komorka_id, kontrahent_id, temat, opis, dokument_id FROM rs_wf_zagadnienia
#              WHERE firma_id='{firma_id}' AND zagadnienie_id={Zagadnienie};"""
#     SEL = SEL.format(**locals())
#     rsglobal.ZapiszDoLogow(SEL)
#     stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
#     if stat != 'OK':
#         stat = 'Bd pobrania danych zagadnienia: '+stat

# -------------------------------------------------------------------------------
# --------------------   POBRANIE DANYCH KONTRAHENTA (11)   ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    SQL = "SELECT " \
          "nazwa , " \
          "CONCAT(TRIM(adrk_kod), ' ', " \
          "       TRIM(CASE WHEN adrk_poczta != '' THEN adrk_poczta ELSE adrk_miej END), ', ', " \
          "       TRIM(adrk_miej), ', ', " \
          "       TRIM(adrk_ulica), ', ', TRIM(adrk_nry)), " \
          "CONCAT(TRIM(adr_kod), ' ', " \
          "       TRIM(CASE WHEN adr_poczta != '' THEN adr_poczta ELSE adr_miej END), ', ', " \
          "       TRIM(adr_miej), ', ', " \
          "       TRIM(adr_ulica), ', ', TRIM(adr_nry)), nip " \
          "FROM rs_kontrahenci "
    SEL = SQL + """ WHERE firma_id='{firma_id}' AND aktywny  AND kontrahent_id='{Kontrahent}';"""
    SEL = SEL.format(**locals())
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych kontrahenta: '+stat

# -------------------------------------------------------------------------------
# -------------------   DODANIE PLIKU DO ZAGADNIENIA (12)   ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    SEL_ZAG = "SELECT zagadnienie_id FROM rs_wf_korespondencja_przychodzaca " \
              "WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' AND rok='{Rok}' AND numer={Numer};".format(**locals())
    rsglobal.ZapiszDoLogow(SEL_ZAG)
    stat, dane_zagadnienie_id, dump, dump = self.PolSQL.Execute(SEL_ZAG, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania numeru zagadnienia przypisanego do pozycji: '+stat
        dane.append(stat)
    elif len(dane_zagadnienie_id) == 0:
        stat = 'Brak zagadnienia przypisanego do pozycji'
        dane.append(stat)
    else:
        zagadnienie_id = dane_zagadnienie_id[0][0]
        if zagadnienie_id == 0:
            stat = 'Brak zagadnienia przypisanego do pozycji'
            dane.append(stat)

    if stat == 'OK':
        INSPLIKI = """INSERT INTO rs_pliki (  firma_id,      nazwa,            tabela,     kompresja)
                                    VALUES ('{firma_id}','{NazwaPliku}','rs_wf_zagadnienia_pliki', FALSE);""".format(**locals())
        rsglobal.ZapiszDoLogow(INSPLIKI)
        stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania pliku: {stat}".format(**locals())

    if stat == 'OK':
        SQLNumerPliku = """SELECT max(plik_id) 
                           FROM rs_pliki 
                           WHERE firma_id='{firma_id}' AND tabela='rs_wf_zagadnienia_pliki';""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLNumerPliku)
        stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrp))
        if stat != 'OK':
            stat = "Bd pobierania numeru zacznika: {stat}".format(**locals())
        else:
            NumerPliku = nrp[0][0]
            stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, ZawartoscPliku)
    
            if stat != 'OK':
                stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())
            else:
                INSZALACZNIKI = """INSERT INTO rs_wf_zagadnienia_pliki
                                           (  firma_id,    zagadnienie_id,    nr_pliku   )
                                    VALUES ('{firma_id}','{zagadnienie_id}','{NumerPliku}');""".format(**locals())
    
                rsglobal.ZapiszDoLogow(INSZALACZNIKI, 5)
                stat, dump, dump, dump = self.PolSQL.Execute(INSZALACZNIKI, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd dodawania rekordu o nowym pliku: ' + stat
                else:
                    dane = [{'nr_pliku': NumerPliku}]
                    sql = """UPDATE rs_wf_zagadnienia SET modyfikacja_czas=NOW(), modyfikacja_kto=rsf_getuserid()
                             WHERE firma_id='{firma_id}' AND zagadnienie_id={zagadnienie_id}""".format(**locals())
                    rsglobal.ZapiszDoLogow(sql)
                    stat, dump, dump, dump = self.PolSQL.Execute(sql, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd aktualizacji czasu modyfikacji zagadnienia: ' + stat

                if stat == 'OK':
                    wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                                   VALUES('{}', {}, NOW() + INTERVAL '{} microseconds', rsf_getuserid(), '{}', '{}');
                                """.format(firma_id, zagadnienie_id, '{}', '{}', '{}')
                    npl = NazwaPliku if len(NazwaPliku) <= 35 else (NazwaPliku[:32] + '...')
                    INSHISTORIA = wzor_hist.format(0, "Doczono plik {}".format(npl), " ")
                    rsglobal.ZapiszDoLogow(INSHISTORIA)
                    stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

# ---------------------------------------------------------------------------------------------------------------------
#                                             15 - Pobranie pliku
# ---------------------------------------------------------------------------------------------------------------------
#AB 2022-07-14
if stat == 'OK' and Funkcja in (15, ):
    SQL = """SELECT 1 
             FROM rs_wf_zagadnienia_pliki zp
             WHERE nr_pliku = %s
             AND firma_id = %s
             AND zagadnienie_id IN (SELECT zagadnienie_id 
                                    FROM rs_wf_korespondencja_przychodzaca kp 
                                    WHERE kp.firma_id = zp.firma_id);"""
    args = [nr_pliku, firma_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, test, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd szukania pliku: " + stat
    elif len(test) == 0:
        stat = "Plik {} nie odnaleziony".format(nr_pliku)
    if stat == 'OK':
        stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, nr_pliku)
        dane = [Tresc]


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE ODBIORCOW ( 25)   --------------------
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (1, 3, 5, 25, ):  #AB 2022-07-14
    if not UprSel > 0:
        stat = 'UPR_SEL'

    if stat == 'OK':
        SEL = """SELECT DISTINCT ON(LOWER(nadawca_nazwa), LOWER(COALESCE(nadawca_adres, ''))) nadawca_nazwa, COALESCE(nadawca_adres, '')
                 FROM rs_wf_korespondencja_przychodzaca
                 WHERE firma_id='{self.firma_id}' AND kontrahent_id IS NULL AND nadawca_nazwa IS NOT NULL;"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat, adresy, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat
    wyn2['adresy'] = adresy


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE OPERATOROW ( 35)   --------------------
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (35, ):  #AB 2023-02-21
    if not UprSel > 0:
        stat = 'UPR_SEL'

    if stat in ('OK',):
        args = [firma_id, Dokument]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLOperatorzy, args))

        stat, dane, wyn1, dump = self.PolSQL.Execute(SQLOperatorzy, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania operatorw do przekazania: {stat}".format(**locals())

# ---------------------------------------------------------------------------------------------------------------------
#                                    45 - Pobranie danych kontrahenta i klucza do BIR  #AB 2023-05-10
# ---------------------------------------------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (45, ):
    args = [firma_id]
    NIP = "%" + NIP.replace('-', '').replace(' ', '') + "%"
    war = "AND nip like %s;"
    args.append(NIP)

    SQL = "SELECT kontrahent_id, " \
          " nazwa , " \
          "CASE WHEN TRIM(adrk_miej) != '' " \
          "THEN CONCAT(TRIM(adrk_kod), ' ', " \
          "            TRIM(CASE WHEN adrk_poczta != '' THEN adrk_poczta ELSE adrk_miej END), ', ', " \
          "            TRIM(adrk_miej), ', ', " \
          "            TRIM(adrk_ulica), ', ', TRIM(adrk_nry)) " \
          "ELSE CONCAT(TRIM(adr_kod), ' ', " \
          "            TRIM(CASE WHEN adr_poczta != '' THEN adr_poczta ELSE adr_miej END), ', ', " \
          "            TRIM(adr_miej), ', ', " \
          "            TRIM(adr_ulica), ', ', TRIM(adr_nry)) END, nip " \
          "FROM rs_kontrahenci " \
          "WHERE firma_id = %s  AND aktywny " + war

    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych kontrahentw: {stat}".format(**locals())
