# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_ksiazka_nadawcza.py
# Purpose:     Obsuga grida ksiki nadawczej
# Author:      Wojciech Skowron
# Created:     2021/04/28
# RCS-ID:      $Id: fs_wf_ksiazka_nadawcza.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2021-08-19    Aleksander Bargie  (12612) [WF] wydruk ksiki nadawczej
# 2022-02-18    Wojciech Skowron    (12744) Na wydruk pobierane typy wysyek tylko 0% lub 1%
# 2023-02-27    Wojciech Skowron    (13360) Pobranie data_potwierdzenia (Data ZPO na gridzie), opis dla przyczyna_zwrotu

import rsglobal

"""
302210 Przegldanie
302220 Modyfikacja
"""

stat = 'OK'
firma_id   = self.firma_id  #AB 20.08.21r
oddzial_id = self.oddzial_id  #AB 20.08.21r

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'DataNadaniaOdF':       [5,6],
             'DataNadaniaDoF':       [5,6],
             'DataWplywuOdF':        [5,6],
             'DataWplywuDoF':        [5,6],
             'DataPotwierdzeniaOdF': [5,6],
             'DataPotwierdzeniaDoF': [5,6],
             'DataNaZwrocieOdF':     [5,6],
             'DataNaZwrocieDoF':     [5,6],
             'ZagadnienieF':         [5,6],
             'KomorkaF':             [5,6],
             'KontrahentF':          [5,6],
             'NazwaF':               [5,6],
             'AdresF':               [5,6],
             'TypWysylkiF':          [5,6],
             'PrzyczynaZwrotuF':     [5,6],
             'Oddzial':              [5,6],
             'Data':                 [6, 15],  #AB 20.08.21r
             'Numer':                [6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_ksiazka_nadawcza z numerem ' + str(Funkcja)
        stat += ' bez parametrw: ' + Lista

if stat == 'OK' and Funkcja in (5,6):
    Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
    DataNadaniaOdF       = rsglobal.Dekoduj(klucze['DataNadaniaOdF'])
    DataNadaniaDoF       = rsglobal.Dekoduj(klucze['DataNadaniaDoF'])
    DataWplywuOdF        = rsglobal.Dekoduj(klucze['DataWplywuOdF'])
    DataWplywuDoF        = rsglobal.Dekoduj(klucze['DataWplywuDoF'])
    DataPotwierdzeniaOdF = rsglobal.Dekoduj(klucze['DataPotwierdzeniaOdF'])
    DataPotwierdzeniaDoF = rsglobal.Dekoduj(klucze['DataPotwierdzeniaDoF'])
    DataNaZwrocieOdF     = rsglobal.Dekoduj(klucze['DataNaZwrocieOdF'])
    DataNaZwrocieDoF     = rsglobal.Dekoduj(klucze['DataNaZwrocieDoF'])
    ZagadnienieF         = rsglobal.Dekoduj(klucze['ZagadnienieF'])
    KomorkaF             = rsglobal.Dekoduj(klucze['KomorkaF'])
    KontrahentF          = rsglobal.Dekoduj(klucze['KontrahentF'])
    NazwaF               = rsglobal.Dekoduj(klucze['NazwaF'])
    AdresF               = rsglobal.Dekoduj(klucze['AdresF'])
    TypWysylkiF          = rsglobal.Dekoduj(klucze['TypWysylkiF'])
    PrzyczynaZwrotuF     = rsglobal.Dekoduj(klucze['PrzyczynaZwrotuF'])

if stat == 'OK' and Funkcja in (6, 15):  #AB 20.08.21r
    Data = rsglobal.Dekoduj(klucze['Data'])

if stat == 'OK' and Funkcja == 6:
    Numer = rsglobal.Dekoduj(klucze['Numer'])

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------
#AB 20.08.21r zamiana Oddzial na self.oddzial_id
UprMod = ((self.oddzial_id, '302220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprPrz = ((self.oddzial_id, '302210') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

# -------------------------------------------------------------------------------
# --------------------   Pobranie danych na wydruk(15)   ------------------------
# -------------------------------------------------------------------------------
#AB 20.08.21r
if stat == 'OK' and Funkcja in (15, ):
    if not UprPrz > 0:
        stat = 'UPR_MOD'
    else:
        SEL = """SELECT rwtw.opis AS "Uwagi", rwkn.firma_id, rwkn.oddzial_id, rwkn.data, rwkn.numer, 
                        rwkn.zagadnienie_id, rwkn.komorka_id, rwkn.kontrahent_id, rwkn.adresat_nazwa,
                        rwkn.adresat_adres, rwkn.typ_wysylki, rwkn.data_wplywu, rwkn.data_potwierdzenia, 
                        rwkn.data_na_zwrocie, rwkn.przyczyna_zwrotu, rwkn.temat, rwkn.opis   
                 FROM rs_wf_ksiazka_nadawcza rwkn 
                    JOIN rs_wf_typy_wysylki rwtw ON (rwtw.firma_id, rwtw.kod) = (rwkn.firma_id, rwkn.typ_wysylki)
                 WHERE rwkn.firma_id = '{}' AND rwkn.oddzial_id = '{}' AND rwkn.data='{}' and rwkn.typ_wysylki LIKE '1%'
                 ORDER BY rwkn.numer;""".format(firma_id, oddzial_id, Data)
        rsglobal.ZapiszDoLogow(SEL)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobierania danych: '+stat
        if stat == 'OK':
            #WS 2022-02-18 - warunek na typ wysyki od 0 lub 1
            SEL = """SELECT rwkn.typ_wysylki, rwtw.opis, count(rwkn.typ_wysylki) as wyslano
                     FROM rs_wf_ksiazka_nadawcza rwkn 
                        JOIN rs_wf_typy_wysylki rwtw ON (rwtw.firma_id, rwtw.kod) = (rwkn.firma_id, rwkn.typ_wysylki)
                     WHERE rwkn.firma_id = '{}' AND rwkn.oddzial_id = '{}' AND rwkn.data='{}' AND (rwkn.typ_wysylki LIKE '0%' OR rwkn.typ_wysylki LIKE '1%')
                     GROUP BY rwkn.typ_wysylki, rwtw.opis;""".format(firma_id, oddzial_id, Data)
            rsglobal.ZapiszDoLogow(SEL)
            stat, pods, wyn1_pods, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd pobierania danych do podsumowania: '+stat
            else:
                wyn2 = []
                wyn2.append((pods, wyn1_pods))
        if stat == 'OK':
            SEL = """SELECT nazwa, adr_ulica, adr_nry, adr_kod, adr_miej, nip, tel1, email 
                     FROM rs_oddzialy 
                     WHERE firma_id='{}' AND centrala;""".format(firma_id)
            rsglobal.ZapiszDoLogow(SEL)
            stat, adr, wyn1_adr, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd pobierania adresu: '+stat
            else:
                wyn2.append((adr, wyn1_adr))
        if stat == 'OK':
            SEL = """SELECT imie, nazwisko FROM rs_operatorzy WHERE operator_id = rsf_getuserid();"""
            rsglobal.ZapiszDoLogow(SEL)
            stat, op, wyn1_op, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd pobierania danych operatora: ' + stat
            else:
                wyn2.append((op, wyn1_op))


# -------------------------------------------------------------------------------
# --------------------   USUWANIE Z POBRANIEM(6)   ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (6, ):
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        DEL = """DELETE FROM rs_wf_ksiazka_nadawcza WHERE firma_id='{firma_id}' AND oddzial_id='{Oddzial}' 
                                                          AND data='{Data}' AND numer={Numer};""".format(**locals())
        rsglobal.ZapiszDoLogow(DEL)
        stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd usuwania danych: '+stat

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH(5,6)   -------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, 6):
    if not UprPrz > 0:
        stat = 'UPR_PRZ'
        dane.append(stat)
    else:
        filtry = ''
        filtry_lista = []
        if DataNadaniaOdF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataNadaniaOdF):
            filtry_lista.append(" data>='"+DataNadaniaOdF+"'")
        if DataNadaniaDoF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataNadaniaDoF):
            filtry_lista.append(" data<='"+DataNadaniaDoF+"'")
        if DataWplywuOdF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataWplywuOdF):
            filtry_lista.append(" data_wplywu>='"+DataWplywuOdF+"'")
        if DataWplywuDoF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataWplywuDoF):
            filtry_lista.append(" data_wplywu<='"+DataWplywuDoF+"'")
        if DataPotwierdzeniaOdF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataPotwierdzeniaOdF):
            filtry_lista.append(" data_potwierdzenia>='"+DataPotwierdzeniaOdF+"'")
        if DataPotwierdzeniaDoF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataPotwierdzeniaDoF):
            filtry_lista.append(" data_potwierdzenia<='"+DataPotwierdzeniaDoF+"'")
        if DataNaZwrocieOdF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataNaZwrocieOdF):
            filtry_lista.append(" data_na_zwrocie>='"+DataNaZwrocieOdF+"'")
        if DataNaZwrocieDoF not in ('', '    -  -  ','None') and rsglobal.SprawdzCzyToData(DataNaZwrocieDoF):
            filtry_lista.append(" data_na_zwrocie<='"+DataNaZwrocieDoF+"'")
        if ZagadnienieF != 'None':
            filtry_lista.append(" zagadnienie_id="+str(ZagadnienieF))
        if KomorkaF != '':
            filtry_lista.append(" upper(komorka_id) LIKE upper('"+KomorkaF+"%')")
        if KontrahentF != '':
            filtry_lista.append(" upper(kontrahent_id) LIKE upper('"+KontrahentF+"%')")
        if NazwaF != '':
            filtry_lista.append(" upper(adresat_nazwa) LIKE upper('%"+NazwaF+"%')")
        if AdresF != '':
            filtry_lista.append(" upper(adresat_adres) LIKE upper('%"+AdresF+"%')")
        if TypWysylkiF != '':
            filtry_lista.append(" typ_wysylki LIKE '"+TypWysylkiF+"%'")
        if PrzyczynaZwrotuF != '':
            filtry_lista.append(" przyczyna_zwrotu='"+PrzyczynaZwrotuF+"'")
        if len(filtry_lista) > 0:
            filtry = " AND "+" AND ".join(filtry_lista)

        #WS 2023-02-27 - data_potwierdzenia, opis dla przyczyna_zwrotu
        SEL = """SELECT data, numer, komorka_id || ' - ' || z.opis, kontrahent_id, adresat_nazwa, adresat_adres, 
                        typ_wysylki || ' - ' || w.opis, przyczyna_zwrotu || ' - ' || pz.opis,
                        data_potwierdzenia, zagadnienie_id
                 FROM rs_wf_ksiazka_nadawcza  k
                 LEFT JOIN rs_komorki_zatrudniajace z ON (z.firma_id, z.kod) = (k.firma_id, k.komorka_id)
                 LEFT JOIN rs_wf_typy_wysylki w ON (w.firma_id, w.kod) = (k.firma_id, k.typ_wysylki)
                 LEFT JOIN rs_wf_przyczyny_zwrotu pz ON (pz.firma_id, pz.kod) = (k.firma_id, k.przyczyna_zwrotu)
                 WHERE k.firma_id='{firma_id}' AND oddzial_id='{Oddzial}' {filtry}
                 ORDER BY data DESC, numer DESC;
              """.format(**locals())
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(SEL)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych: '+stat
