# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_ksiazka_nadawcza_dane.py
# Purpose:     Dodawanie i edycja danych archiwalnych kontrahenta
# Author:      Wojciech Skowron
# Created:     2021/04/28
# RCS-ID:      $Id: fs_wf_ksiazka_nadawcza_dane.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2021-08-02 Wojciech Skowron - Nie pozwala na wprowadzenie daty wstecz
# 2022-04-04 Aleksander Bargie - (12917) Sekretariat - zmiany

import rsglobal

"""
302200 Ksika nadawcza
302210 Przegldanie
302220 Modyfikacja
"""

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
nieedytowalne_ins = ['numer']
nieedytowalne_upd = ['data', 'numer']

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Oddzial': [1, 2, 3, 4, 5, 10, 11, 15], 'Data': [1, 2, 3, 4, 5], 'Numer': [3, 4, 5],
             'Zagadnienie': [10], 'Kontrahent': [11]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_ksiazka_nadawcza_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 2, 3, 4, 5, 10, 11, 15]:
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])

    if Funkcja in [1, 2, 3, 4, 5]:
        Data = rsglobal.Dekoduj(klucze['Data'])

    if Funkcja in [3, 4, 5]:
        Numer = rsglobal.Dekoduj(klucze['Numer'])

    if Funkcja == 10:
        Zagadnienie = rsglobal.Dekoduj(klucze['Zagadnienie'])

    if Funkcja == 11:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])

# -------------------------------------------------------------------------------
# -----------------------------   UPRAWNIENIA   ---------------------------------
# -------------------------------------------------------------------------------

UprMod = ((Oddzial, '302220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprSel = ((Oddzial, '302210') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH (1, 3)   --------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR_MOD'

    if stat == 'OK':
        kontrahent = ''
        nazwa = ''
        adres = ''
        
        for pole, wart in zip(pola, wartosci):
            if pole == 'data':
                if wart in ('', '-  -', '    -  -  ', 'None'):
                    stat = 'BR_DATA'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA'
                    dane.append(stat)
                #WS 2021-08-02
                elif Funkcja in (1, 2) and wart < rsglobal.PodajDzis():
                    stat = 'BL_DATA_WSTECZ'
                    dane.append(stat)

            elif pole == 'zagadnienie_id':
                if wart != 0:
                    SQL = "SELECT 1 FROM rs_wf_zagadnienia WHERE firma_id='{self.firma_id}' AND zagadnienie_id={wart};".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_ZAGADNIENIE"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'komorka_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_komorki_zatrudniajace WHERE firma_id='{self.firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KOMORKA"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'kontrahent_id':
                kontrahent = wart.strip()  #WS 2021-08-02
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_kontrahenci WHERE firma_id='{self.firma_id}' AND kontrahent_id='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KONTRAHENT"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'typ_wysylki':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_wf_typy_wysylki WHERE firma_id='{self.firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_TYP_WYSYLKI"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                #WS 2021-08-02
                else:
                    stat = "BR_TYP_WYSYLKI"
                    dane.append(stat)

            elif pole == 'przyczyna_zwrotu':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_wf_przyczyny_zwrotu WHERE firma_id='{self.firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_PRZYCZYNA_ZWROTU"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'data_wplywu':
                if wart not in ('', '-  -', '    -  -  ', 'None') and not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA_WPLYWU'
                    dane.append(stat)

            elif pole == 'data_potwierdzenia':
                if wart not in ('', '-  -', '    -  -  ', 'None') and not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA_POTWIERDZENIA'
                    dane.append(stat)

            elif pole == 'data_na_zwrocie':
                if wart not in ('', '-  -', '    -  -  ', 'None') and not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA_NA_ZWROCIE'
                    dane.append(stat)
            #AB 04.04.22r
            elif pole == 'data_na_zwrocie2':
                if wart not in ('', '-  -', '    -  -  ', 'None') and not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA_NA_ZWROCIE2'
                    dane.append(stat)

            elif pole == 'data_na_zwrocie3':
                if wart not in ('', '-  -', '    -  -  ', 'None') and not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA_NA_ZWROCIE3'
                    dane.append(stat)

            #WS 2021-08-02
            elif pole == 'adresat_nazwa':
                nazwa = wart.strip()

            #WS 2021-08-02
            elif pole == 'adresat_adres':
                adres = wart.strip()

        #WS 2021-08-02
        if Funkcja in (3, 4) and (nazwa == '' or adres == '' or kontrahent == ''):
            SQL = """SELECT COALESCE(adresat_nazwa, ''), COALESCE(adresat_adres, ''), COALESCE(kontrahent_id, '')
                     FROM rs_wf_ksiazka_nadawcza
                     WHERE firma_id='{self.firma_id}' AND oddzial_id='{Oddzial}' AND data='{Data}' AND numer={Numer};
                  """.format(**locals())
            rsglobal.ZapiszDoLogow(SQL)
            stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobrania danych pozycji"
                dane.append(stat)
            else:
                nazwa = d[0][0] if nazwa == '' else nazwa
                adres = d[0][1] if adres == '' else adres
                kontrahent = d[0][2] if kontrahent == '' else kontrahent

        #WS 2021-08-02
        if (nazwa == '' or adres == '') and kontrahent == '':
            stat = "BR_NADAWCA"
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------------   INSERT (1)   ------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2):
    Numer = 1
    SEL = """SELECT MAX(numer)+1 FROM rs_wf_ksiazka_nadawcza 
             WHERE firma_id='{self.firma_id}' AND oddzial_id='{Oddzial}' AND data='{Data}';"""
    SEL = SEL.format(**locals())
    stat, dane_numer, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd dodania danych:' + stat
        dane.append(stat)
    elif len(dane_numer) > 0 and dane_numer[0][0] > 0:
        Numer = dane_numer[0][0]

    INS = "INSERT INTO rs_wf_ksiazka_nadawcza "
    Pola = "firma_id, oddzial_id, numer "
    Wartosci = "'{self.firma_id}', '{Oddzial}', {Numer}".format(**locals())

    for pole, wart in zip(pola, wartosci):
        if pole not in nieedytowalne_ins:
            if pole in ['zagadnienie_id']:
                Pola += ","+pole
                if wart == 0:
                    Wartosci += ",NULL"
                else:
                    Wartosci += ","+str(wart)
            else:
                Pola += ","+pole
                Wartosci += ","+rsglobal.ZmienNaNULL(wart)

    INS += "("+Pola+") VALUES ("+Wartosci+");"

    stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(INS)
    if stat != 'OK':
        stat = 'Bd dodania danych: '+stat
        dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# --------------------------   UPDATE (3)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    UPD = "UPDATE rs_wf_ksiazka_nadawcza SET "
    DataNowa = Data
    NumerNowy = Numer

    for pole, wart in zip(pola, wartosci):
        if pole not in nieedytowalne_upd:
            if pole in ['zagadnienie_id']:
                if wart == 0:
                    UPD += pole+"=NULL,"
                else:
                    UPD += pole+"="+str(wart)+","
            else:
                UPD += pole+"="+rsglobal.ZmienNaNULL(wart)+","

        if pole == 'data':
            DataNowa = wart

            NumerNowy = 1
            SEL = """SELECT MAX(numer)+1 FROM rs_wf_ksiazka_nadawcza 
                     WHERE firma_id='{self.firma_id}' AND oddzial_id='{Oddzial}' AND data='{DataNowa}';"""
            SEL = SEL.format(**locals())
            stat, dane_numer, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd modyfikacji danych:' + stat
                dane.append(stat)
            elif len(dane_numer) > 0 and dane_numer[0][0] > 0:
                NumerNowy = dane_numer[0][0]

    if NumerNowy != Numer:
        UPD += "numer="+str(NumerNowy)+","

    UPD = UPD[0:-1]
    UPD += " WHERE firma_id='{self.firma_id}' AND oddzial_id='{Oddzial}' AND data='{Data}' AND numer={Numer};".format(**locals())

    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(UPD)
    if stat != 'OK':
        stat = 'Bd modyfikacji danych:' + stat
        dane.append(stat)
    else:
        Data = DataNowa
        Numer = NumerNowy

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH (1, 3, 5)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    if not UprSel > 0:
        stat = 'UPR_SEL'

    if stat == 'OK':
        SEL = """SELECT * FROM rs_wf_ksiazka_nadawcza
                 WHERE firma_id='{self.firma_id}' AND oddzial_id='{Oddzial}' AND data='{Data}' AND numer={Numer};"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat

    if stat == 'OK':
        Komorka = TypWysylki = PrzyczynaZwrotu = ''

        tr = rssql.RSTableRowset2(dane, wyn1)[0]

        if tr["komorka_id"].strip() not in ('', 'None'):
            if ((Oddzial,'011710') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_komorki_zatrudniajace WHERE firma_id = '"+self.firma_id+"' AND kod='"+tr["komorka_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    Komorka = 'Bd pobrania opisu komrki zatrudniajcej: '+stat
                else:
                    if len(d) == 0:
                        Komorka = 'Bdna komrka zatrudniajca'
                    else:
                        Komorka = str(d[0][0])
            else:
                Komorka = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if tr["typ_wysylki"].strip() not in ('', 'None'):
            if ((Oddzial,'211540') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_wf_typy_wysylki WHERE firma_id = '"+self.firma_id+"' AND kod='"+tr["typ_wysylki"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    TypWysylki = 'Bd pobrania opisu typu wysyki: '+stat
                else:
                    if len(d) == 0:
                        TypWysylki = 'Bdny typ wysyki'
                    else:
                        TypWysylki = str(d[0][0])
            else:
                TypWysylki = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if tr["przyczyna_zwrotu"].strip() not in ('', 'None'):
            if ((Oddzial,'211550') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_wf_przyczyny_zwrotu WHERE firma_id = '"+self.firma_id+"' AND kod='"+tr["przyczyna_zwrotu"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    PrzyczynaZwrotu = 'Bd pobrania opisu przyczyny zwrotu: '+stat
                else:
                    if len(d) == 0:
                        PrzyczynaZwrotu = 'Bdna przyczyna zwrotu'
                    else:
                        PrzyczynaZwrotu = str(d[0][0])
            else:
                PrzyczynaZwrotu = 'Brak uprawnie do sownika. Poinformuj administratora.'

        wyn2 = [Komorka, TypWysylki, PrzyczynaZwrotu]

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE ODBIORCOW ( 15)   --------------------
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (1, 3, 5, 15, ):
    if not UprSel > 0:
        stat = 'UPR_SEL'

    if stat == 'OK':
        SEL = """SELECT DISTINCT ON(LOWER(adresat_nazwa), LOWER(COALESCE(adresat_adres, ''))) adresat_nazwa, COALESCE(adresat_adres, '')
                 FROM rs_wf_ksiazka_nadawcza
                 WHERE firma_id='{self.firma_id}' AND kontrahent_id IS NULL AND adresat_nazwa IS NOT NULL;"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat, adresy, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat
    wyn2.append(adresy)

# -------------------------------------------------------------------------------
# --------------------   POBRANIE DANYCH ZAGADNIENIA (10)   ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    SEL = """SELECT komorka_id, kontrahent_id, temat, opis FROM rs_wf_zagadnienia
             WHERE firma_id='{self.firma_id}' AND zagadnienie_id={Zagadnienie};"""
    SEL = SEL.format(**locals())
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych zagadnienia: '+stat

# -------------------------------------------------------------------------------
# --------------------   POBRANIE DANYCH KONTRAHENTA (11)   ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    SEL = """SELECT CASE WHEN nazwa_f1 IS NOT NULL AND TRIM(nazwa_f1) != '' THEN CONCAT(nazwa_f1, nazwa_f2) ELSE nazwa END,
                    CONCAT(adrk_kod, ' ', adrk_miej, ', ', adrk_ulica, ' ', adrk_nry),
                    CONCAT(adr_kod, ' ', adr_miej, ', ', adr_ulica, ' ', adr_nry)
             FROM rs_kontrahenci
             WHERE firma_id='{self.firma_id}' AND kontrahent_id='{Kontrahent}';"""
    SEL = SEL.format(**locals())
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych kontrahenta: '+stat
