# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_rodzaje_dokumentow.py
# Purpose:     Wywietlanie i edycja rodzajw dokumentw oraz ich stanw i przej
# Author:      Wojciech Skowron
# Created:     2021/02/26
# RCS-ID:      $Id: fs_wf_rodzaje_dokumentow.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2021-10-14 Aleksander Bargie (12669) [WF] rozszerzenia funkcjonalnoci

import ast
import rsglobal

"""
301100 Rodzaje dokumentw
301110 Przegldanie
301120 Modyfikacja
"""

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Update': [1], 'Insert': [1], 'Delete': [1], 'KodF': [1, 5, 15], 'OpisF': [1, 5], 'ZDefinicjamiF': [1, 5]} #AB 14.10.21r
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_rodzaje_dokumentow z numerem ' + str(Funkcja)
        stat += ' bez parametrw: ' + Lista


dane = []
wyn1 = []
wyn2 = []
zmienione = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprMod = (((self.oddzial_id, '301120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrz = (((self.oddzial_id, '301110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

if stat == 'OK' and Funkcja in (1, 5, 15):  #AB 14.10.21r
    KodF = rsglobal.Dekoduj(klucze['KodF']).strip()

if stat == 'OK' and Funkcja in (1, 5):  #AB 14.10.21r
    OpisF = rsglobal.Dekoduj(klucze['OpisF']).strip()
    ZDefinicjamiF = rsglobal.Dekoduj(klucze['ZDefinicjamiF'])

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            DEL = ''
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}'""".format(self.firma_id)
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"='"+str(wart)+"'"

                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

        if stat == 'OK':
            for pola, wartosci, klucz, nrWiersza in zip(Update[0], Update[1], Update[2], Update[-1]):
                stany = None
                przejscia = None

                for pole, wart in zip(pola, wartosci):
                    wart = wart.strip()

                    if pole == 'rodzaj':
                        if len(wart) == 0:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BR_RODZAJ')
                        elif len(wart) > 7:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BL_RODZAJ_DL')

                    elif pole == 'opis':
                        if len(wart) > 50:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BR_OPIS')

                    if pole == 'stany':
                        if wart not in ('', '[]', 'None'):
                            stany = ast.literal_eval(wart)
                        else:
                            stany = []

                    elif pole == 'przejscia':
                        if wart not in ('', '[]', 'None'):
                            przejscia = ast.literal_eval(wart)
                        else:
                            przejscia = []

                # Zmodyfikowano tylko przejcia - pobranie stanw
                if stany is None:
                    SQL = "SELECT stany FROM rs_wf_rodzaje_dokumentow WHERE firma_id='"+self.firma_id+"'"
                    for pole, wart in zip(Update[3], klucz):  # petla po kluczu
                        SQL+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"
                    stat,dane_stany,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_STANY_SQL')
                    elif dane_stany[0][0].strip() not in ('', '[]', 'None'):
                        stany = ast.literal_eval(dane_stany[0][0])
                    else:
                        stany = []

                # Zmodyfikowano tylko stany - pobranie przej
                if przejscia is None:
                    SQL = "SELECT przejscia FROM rs_wf_rodzaje_dokumentow WHERE firma_id='"+self.firma_id+"'"
                    for pole, wart in zip(Update[3], klucz):  # petla po kluczu
                        SQL+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"
                    stat,dane_przejscia,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_SQL')
                    elif dane_przejscia[0][0].strip() not in ('', '[]', 'None'):
                        przejscia = ast.literal_eval(dane_przejscia[0][0])
                    else:
                        przejscia = []

                # Sprawdzenie czy jeli stany niepuste to przejcia te i odwrotnie
                if len(przejscia) > 0 and len(stany) == 0:
                    wyn2.append((nrWiersza, 2))
                    dane.append('BR_STANY')
                if len(stany) > 0 and len(przejscia) == 0:
                    wyn2.append((nrWiersza, 3))
                    dane.append('BR_PRZEJSCIA')

                # Weryfikacja stanw ze sownikiem
                for stan in stany:
                    SQL = "SELECT 1 FROM rs_wf_stany_dokumentow WHERE firma_id='"+self.firma_id+"' AND kod='"+stan.strip()+"'"
                    stat,dane_stan,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_STANY_SLOWNIK_SQL')
                    elif len(dane_stan) == 0:
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_STANY_SLOWNIK$'+stan.strip())

                # Sprawdzenie czy przejcia s zapisane prawidowo - czy s to pary,
                # czy adna para nie ma dwch takich samych stanw i czy znajduj si w kolumnie stanw
                for przejscie in przejscia:
                    if len(przejscie) != 2:
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_LICZBA')
                        break
                    stan1 = przejscie[0]
                    stan2 = przejscie[1]
                    if stan1 == stan2:
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_ROWNE')
                        break
                    if (stan1 not in stany or stan2 not in stany) and len(stany) > 0:
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_STANY$'+str([stan1,stan2]))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            UPD = ''

            for pola, wartosci, klucz in zip(Update[0], Update[1], Update[2]):
                UPD += "UPDATE rs_wf_rodzaje_dokumentow SET "
                for pole, wart in zip(pola, wartosci):
                    UPD += pole+"='"+wart.replace("'","''")+"',"
                    if pole == 'kod':
                        zmienione.append(wart.strip())

                UPD = UPD.strip(",")
                UPD += " WHERE firma_id='"+self.firma_id+"'"

                for pole, wart in zip(Update[3], klucz):  # petla po kluczu
                    UPD+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

                UPD += ";"
            if UPD != '':
                rsglobal.ZapiszDoLogow(UPD)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

        if stat == 'OK':
            pola = Insert[1]

            for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
                stany = None
                przejscia = None

                for pole, wart in zip(pola, wartosci):
                    wart = wart.strip()

                    if pole == 'rodzaj':
                        if len(wart) == 0:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BR_RODZAJ')
                        elif len(wart) > 7:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BL_RODZAJ_DL')

                    elif pole == 'opis':
                        if len(wart) > 50:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BR_OPIS')

                    elif pole == 'stany':
                        if wart not in ('', '[]', 'None'):
                            stany = ast.literal_eval(wart)
                        else:
                            stany = []

                    elif pole == 'przejscia':
                        if wart not in ('', '[]', 'None'):
                            przejscia = ast.literal_eval(wart)
                        else:
                            przejscia = []

                # Sprawdzenie czy jeli stany niepuste to przejcia te i odwrotnie
                if len(przejscia) > 0 and len(stany) == 0:
                    wyn2.append((nrWiersza, 2))
                    dane.append('BR_STANY')
                if len(stany) > 0 and len(przejscia) == 0:
                    wyn2.append((nrWiersza, 3))
                    dane.append('BR_PRZEJSCIA')

                # Weryfikacja stanw ze sownikiem
                for stan in stany:
                    SQL = "SELECT 1 FROM rs_wf_stany_dokumentow WHERE firma_id='"+self.firma_id+"' AND kod='"+stan.strip()+"'"
                    stat,dane_stan,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_STANY_SLOWNIK_SQL')
                    elif len(dane_stan) == 0:
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_STANY_SLOWNIK$'+stan.strip())

                # Sprawdzenie czy przejcia s zapisane prawidowo - czy s to pary,
                # czy adna para nie ma dwch takich samych stanw i czy znajduj si w kolumnie stanw
                for przejscie in przejscia:
                    if len(przejscie) != 2:
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_LICZBA')
                        break
                    stan1 = przejscie[0]
                    stan2 = przejscie[1]
                    if stan1 == stan2:
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_ROWNE')
                        break
                    if (stan1 not in stany or stan2 not in stany) and len(stany) > 0:
                        wyn2.append((nrWiersza, 3))
                        dane.append('BL_PRZEJSCIA_STANY$'+str([stan1,stan2]))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            INS = ''
            pola = Insert[1]

            for wartosci in Insert[0]:
                INSERT  = "INSERT INTO rs_wf_rodzaje_dokumentow "
                KOLUMNY = "(firma_id"
                VALUES  = " VALUES ('"+self.firma_id+"'"

                for pole, wart in zip(pola, wartosci):
                    KOLUMNY += ","+pole
                    VALUES += ",'"+wart.replace("'","''")+"'"
                    if pole == 'kod':
                        zmienione.append(wart.strip())

                KOLUMNY += ")"
                VALUES += ");"
                INS += INSERT+KOLUMNY+VALUES
            if INS != '':
                rsglobal.ZapiszDoLogow(INS)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrz:
        stat = 'UPR_PRZ'
        dane.append(stat)
    else:
        filtry = ''
        filtry_lista = []
        if KodF != '':
            filtry_lista.append(" UPPER(kod) LIKE UPPER('"+KodF+"%')")
        if OpisF != '':
            filtry_lista.append(" UPPER(opis) LIKE UPPER('%"+OpisF+"%')")
        if ZDefinicjamiF:
            filtry_lista.append(" stany IS NOT NULL AND stany != '' AND przejscia IS NOT NULL AND przejscia != ''")
        if len(filtry_lista) > 0:
            filtry = " AND (firma_id='"+self.firma_id+"' AND "+" AND ".join(filtry_lista)+")"

        # dodane/zmienione wiersze pobior si nawet jeli nie s zgodne z filtrem
        dodane_klucze = ''
        if Funkcja == 1 and (len(Insert[0]) > 0 or len(Update[0]) > 0):
            dodane_klucze += " OR (firma_id='"+self.firma_id+"' AND kod in ('"+"','".join(zmienione)+"'))"

        SEL = """SELECT TRIM(kod), opis, stany, przejscia
                 FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{self.firma_id}' {filtry} {dodane_klucze}
                 ORDER BY kod;""".format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
#-------------------------------------------------------------------------------
#---   POBRANIE OPISU (15)
#-------------------------------------------------------------------------------

#AB 14.10.21r
if stat == 'OK' and Funkcja in (15, ):
    if not UprPrz:
        stat = 'Brak uprawnie do przegldania rodzajw dokumentw. Poinformuj serwis.'
        dane.append(stat)
    else:
        filtry = ''
        filtry_lista = []
        if KodF != '':
            filtry_lista.append(" UPPER(kod) = UPPER('"+KodF+"')")
        if len(filtry_lista) > 0:
            filtry = " AND (firma_id='"+self.firma_id+"' AND "+" AND ".join(filtry_lista)+")"

        SEL = """SELECT TRIM(kod), opis, stany, przejscia
                 FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{self.firma_id}' {filtry}
                 ;""".format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ZE SOWNIKA STANW
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    if not UprPrz:
        stat = 'UPR_PRZ'
        dane.append(stat)
    else:
        SEL = """SELECT False, kod, opis
                 FROM rs_wf_stany_dokumentow WHERE firma_id='{self.firma_id}'
                 ORDER BY kod;""".format(**locals())
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)
