# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_uprawnienia.py
# Purpose:     Wywietlanie i edycja uprawnie do dokumentw
# Author:      Wojciech Skowron
# Created:     2021/03/29
# RCS-ID:      $Id: fs_wf_uprawnienia.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2021-07-12 Wojciech Skowron (12566) Funkcja 11 - wypenienie rs_wf_uprawnienia_szczegoly
# 2021-11-17 Wojciech Skowron (12712) Prawy stan przej wybierany ze wszystkich stanw dla rodzaju
# 2021-12-14 Wojciech Skowron (12771) Funkcja 10 - ORDER BY kod

import ast
import rsglobal
import rssql

"""
301200 Uprawnienia
301210 Przegldanie
301220 Modyfikacja
"""

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

stat = "OK"

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Update': [1], 'Insert': [1], 'Delete': [1], 'OperatorF': [1, 5], 'NazwiskoF': [1, 5], 'DokumentF': [1, 5],
             'DokumentOpisF': [1, 5], 'KomorkaF': [1, 5], 'KomorkaOpisF': [1, 5], 'Rodzaj': [10]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_uprawnienia z numerem ' + str(Funkcja)
        stat += ' bez parametrw: ' + Lista


dane = []
wyn1 = []
wyn2 = []
dodane = []  # zapamitanie kluczy dodawanych/modyfikowanych wierszy

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprMod = (((self.oddzial_id, '301220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrz = (((self.oddzial_id, '301210') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprMod
UprOperatorzy = (((self.oddzial_id, '001320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

if stat == 'OK' and Funkcja in (1, 5):
    OperatorF = rsglobal.Dekoduj(klucze['OperatorF']).strip()
    NazwiskoF = rsglobal.Dekoduj(klucze['NazwiskoF']).strip()
    DokumentF = rsglobal.Dekoduj(klucze['DokumentF']).strip()
    DokumentOpisF = rsglobal.Dekoduj(klucze['DokumentOpisF']).strip()
    KomorkaF = rsglobal.Dekoduj(klucze['KomorkaF']).strip()
    KomorkaOpisF = rsglobal.Dekoduj(klucze['KomorkaOpisF']).strip()

if stat == 'OK' and Funkcja == 9:
    Operator = rsglobal.Dekoduj(klucze['Operator']).strip()

if stat == 'OK' and Funkcja == 10:
    Rodzaj = rsglobal.Dekoduj(klucze['Rodzaj']).strip()

#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            DEL = ''
            pola = Delete[1]

            for wartosci in Delete[0]:
                DEL += """DELETE FROM rs_wf_uprawnienia WHERE firma_id='{}'""".format(self.firma_id)
                for pole, wart in zip(pola, wartosci):
                    DEL += " AND "+pole+"='"+str(wart)+"'"

                DEL += ";"

            if stat == "OK" and DEL != '':
                rsglobal.ZapiszDoLogow(DEL)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL), 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---------------------   SPRAWDZENIE DANYCH UPDATE (1) -------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0]) > 0 or len(Insert[0]) > 0:
        if not UprMod:
            stat = 'UPR_MOD'
            dane.append(stat)

    if stat == 'OK' and len(Update[0]) > 0:
        for pola, wartosci, wartosci_klucz, nrWiersza in zip(Update[0], Update[1], Update[2], Update[-1]):
            pola_klucz = Update[3]

            stany = None
            przejscia = None
            rodzaj = None
            stany_rodzaj = []

            for pole, wart in zip(pola, wartosci):
                wart = str(wart).strip()

                if pole == 'operator_id':
                    if len(wart) == 0:
                        wyn2.append((nrWiersza, 0))
                        dane.append('BR_OPERATOR')
                    elif len(wart) > 5:
                        wyn2.append((nrWiersza, 0))
                        dane.append('BL_OPERATOR_DL')
                    else:
                        SQL = "SELECT 1 FROM rs_operatorzy WHERE operator_id={};"
                        SQL = SQL.format(wart)
                        stat,dane_operator,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            wyn2.append((nrWiersza, 0))
                            dane.append('BL_OPERATOR_SQL')
                        elif len(dane_operator) == 0:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BL_OPERATOR_ID')

                elif pole == 'dokument_id':
                    if len(wart) == 0:
                        wyn2.append((nrWiersza, 2))
                        dane.append('BR_DOKUMENT')
                    elif len(wart) > 7:
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_DOKUMENT_DL')
                    else:
                        SQL = "SELECT 1 FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}' AND kod='{}';"
                        SQL = SQL.format(self.firma_id, wart)
                        stat,dane_dokument,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            wyn2.append((nrWiersza, 2))
                            dane.append('BL_DOKUMENT_SQL')
                        elif len(dane_dokument) == 0:
                            wyn2.append((nrWiersza, 2))
                            dane.append('BL_DOKUMENT_ID')
                        else:
                            rodzaj = wart

                elif pole == 'komorka_id':
                    if len(wart) == 0:
                        wyn2.append((nrWiersza, 4))
                        dane.append('BR_KOMORKA')
                    elif len(wart) > 10:
                        wyn2.append((nrWiersza, 4))
                        dane.append('BL_KOMORKA_DL')
                    else:
                        SQL = "SELECT 1 FROM rs_komorki_zatrudniajace WHERE firma_id='{}' AND kod='{}';"
                        SQL = SQL.format(self.firma_id, wart)
                        stat,dane_komorka,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            wyn2.append((nrWiersza, 4))
                            dane.append('BL_KOMORKA_SQL')
                        elif len(dane_komorka) == 0:
                            wyn2.append((nrWiersza, 4))
                            dane.append('BL_KOMORKA_ID')

                elif pole == 'stany':
                    if wart not in ('', '[]', 'None'):
                        stany = ast.literal_eval(wart)
                    else:
                        stany = []

                elif pole == 'przejscia':
                    if wart not in ('', '[]', 'None'):
                        przejscia = ast.literal_eval(wart)
                    else:
                        przejscia = []

            # Zmodyfikowano tylko przejcia - pobranie stanw
            if stany is None:
                SQL = "SELECT stany FROM rs_wf_uprawnienia WHERE firma_id='"+self.firma_id+"'"
                for pole, wart in zip(pola_klucz, wartosci_klucz):  # petla po kluczu
                    SQL+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"
                stat,dane_stany,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    wyn2.append((nrWiersza, 6))
                    dane.append('BL_STANY_SQL')
                elif dane_stany[0][0].strip() not in ('', '[]', 'None'):
                    stany = ast.literal_eval(dane_stany[0][0])
                else:
                    stany = []

            # Zmodyfikowano tylko stany - pobranie przej
            if przejscia is None:
                SQL = "SELECT przejscia FROM rs_wf_uprawnienia WHERE firma_id='"+self.firma_id+"'"
                for pole, wart in zip(pola_klucz, wartosci_klucz):  # petla po kluczu
                    SQL+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"
                stat,dane_przejscia,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_SQL')
                elif dane_przejscia[0][0].strip() not in ('', '[]', 'None'):
                    przejscia = ast.literal_eval(dane_przejscia[0][0])
                else:
                    przejscia = []

            # Sprawdzenie czy jeli stany niepuste to przejcia te i odwrotnie
            if len(przejscia) > 0 and len(stany) == 0:
                wyn2.append((nrWiersza, 6))
                dane.append('BR_STANY')
            if len(stany) > 0 and len(przejscia) == 0:
                wyn2.append((nrWiersza, 7))
                dane.append('BR_PRZEJSCIA')

            if len(stany) > 0:
                # Pobranie rodzaju jeli nie zosta zmodyfikowany
                if rodzaj is None:
                    SQL = "SELECT dokument_id FROM rs_wf_uprawnienia WHERE firma_id='"+self.firma_id+"'"
                    for pole, wart in zip(pola_klucz, wartosci_klucz):  # petla po kluczu
                        SQL+= " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"
                    stat,dane_rodzaj,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 6))
                        dane.append('BL_RODZAJ_SQL')
                        rodzaj = ''
                    else:
                        rodzaj = dane_rodzaj[0][0].strip()

                # Pobranie stanw zdefiniowanych dla rodzaju z rs_wf_rodzaje_dokumentow uwzgldniajc drzewo
                rodzaj_tmp = rodzaj
                while len(rodzaj_tmp) > 0:
                    SQL = "SELECT stany FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}' AND kod='{}';"
                    SQL = SQL.format(self.firma_id, rodzaj_tmp)
                    stat,dane_rodzaj_stany,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 6))
                        dane.append('BL_RODZAJ_STANY_SQL')
                        break
                    elif len(dane_rodzaj_stany) > 0:
                        if dane_rodzaj_stany[0][0].strip() not in ('', '[]', 'None'):
                            stany_rodzaj = ast.literal_eval(dane_rodzaj_stany[0][0])
                            break

                    rodzaj_tmp = rodzaj_tmp[:-1]

            # Weryfikacja stanw ze sownikiem rs_wf_stany_dokumentow oraz z definicj z rs_wf_rodzaje_dokumentow
            for stan in stany:
                SQL = "SELECT 1 FROM rs_wf_stany_dokumentow WHERE firma_id='{}' AND kod='{}';"
                SQL = SQL.format(self.firma_id, stan.strip())
                stat,dane_stan,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    wyn2.append((nrWiersza, 6))
                    dane.append('BL_STANY_SLOWNIK_SQL')
                elif len(dane_stan) == 0:
                    wyn2.append((nrWiersza, 6))
                    dane.append('BL_STANY_SLOWNIK$'+stan.strip())
                elif stan not in stany_rodzaj:
                    wyn2.append((nrWiersza, 6))
                    dane.append("Stan '"+stan.strip()+"' nie wystpuje w definicji stanw dla rodzaju dokumentw '"+rodzaj+"' lub wyszego w hierarchii")

            # Sprawdzenie czy przejcia s zapisane prawidowo - czy s to pary,
            # czy adna para nie ma dwch takich samych stanw i czy znajduj si w kolumnie stanw
            for przejscie in przejscia:
                if len(przejscie) != 2:
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_LICZBA')
                    break
                stan1 = przejscie[0]
                stan2 = przejscie[1]
                if stan1 == stan2:
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_ROWNE')
                    break
                #WS 2021-11-17
                if (stan1 not in stany or stan2 not in stany_rodzaj) and len(stany) > 0:
                # if (stan1 not in stany or stan2 not in stany) and len(stany) > 0:
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_STANY$'+str([stan1,stan2]))

#-------------------------------------------------------------------------------
#---------------------   SPRAWDZENIE DANYCH INSERT (1) -------------------------
#-------------------------------------------------------------------------------

    if stat == 'OK' and len(Insert[0]) > 0:
        pola = Insert[1]

        for wartosci, nrWiersza in zip(Insert[0], Insert[-1]):
            stany = None
            przejscia = None
            rodzaj = None
            stany_rodzaj = []

            for pole, wart in zip(pola, wartosci):
                wart = str(wart).strip()

                if pole == 'operator_id':
                    if len(wart) == 0:
                        wyn2.append((nrWiersza, 0))
                        dane.append('BR_OPERATOR')
                    elif len(wart) > 5:
                        wyn2.append((nrWiersza, 0))
                        dane.append('BL_OPERATOR_DL')
                    else:
                        SQL = "SELECT 1 FROM rs_operatorzy WHERE operator_id={};"
                        SQL = SQL.format(wart)
                        stat,dane_operator,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            wyn2.append((nrWiersza, 0))
                            dane.append('BL_OPERATOR_SQL')
                        elif len(dane_operator) == 0:
                            wyn2.append((nrWiersza, 0))
                            dane.append('BL_OPERATOR_ID')

                elif pole == 'dokument_id':
                    if len(wart) == 0:
                        wyn2.append((nrWiersza, 2))
                        dane.append('BR_DOKUMENT')
                    elif len(wart) > 7:
                        wyn2.append((nrWiersza, 2))
                        dane.append('BL_DOKUMENT_DL')
                    else:
                        SQL = "SELECT 1 FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}' AND kod='{}';"
                        SQL = SQL.format(self.firma_id, wart)
                        stat,dane_dokument,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            wyn2.append((nrWiersza, 2))
                            dane.append('BL_DOKUMENT_SQL')
                        elif len(dane_dokument) == 0:
                            wyn2.append((nrWiersza, 2))
                            dane.append('BL_DOKUMENT_ID')
                        else:
                            rodzaj = wart

                elif pole == 'komorka_id':
                    if len(wart) == 0:
                        wyn2.append((nrWiersza, 4))
                        dane.append('BR_KOMORKA')
                    elif len(wart) > 10:
                        wyn2.append((nrWiersza, 4))
                        dane.append('BL_KOMORKA_DL')
                    else:
                        SQL = "SELECT 1 FROM rs_komorki_zatrudniajace WHERE firma_id='{}' AND kod='{}';"
                        SQL = SQL.format(self.firma_id, wart)
                        stat,dane_komorka,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                        if stat != 'OK':
                            wyn2.append((nrWiersza, 4))
                            dane.append('BL_KOMORKA_SQL')
                        elif len(dane_komorka) == 0:
                            wyn2.append((nrWiersza, 4))
                            dane.append('BL_KOMORKA_ID')

                elif pole == 'stany':
                    if wart not in ('', '[]', 'None'):
                        stany = ast.literal_eval(wart)
                    else:
                        stany = []

                elif pole == 'przejscia':
                    if wart not in ('', '[]', 'None'):
                        przejscia = ast.literal_eval(wart)
                    else:
                        przejscia = []

            # Sprawdzenie czy jeli stany niepuste to przejcia te i odwrotnie
            if len(przejscia) > 0 and len(stany) == 0:
                wyn2.append((nrWiersza, 6))
                dane.append('BR_STANY')
            if len(stany) > 0 and len(przejscia) == 0:
                wyn2.append((nrWiersza, 7))
                dane.append('BR_PRZEJSCIA')

            if len(stany) > 0:
                # Pobranie stanw zdefiniowanych dla rodzaju z rs_wf_rodzaje_dokumentow uwzgldniajc drzewo
                rodzaj_tmp = rodzaj
                while len(rodzaj_tmp) > 0:
                    SQL = "SELECT stany FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}' AND kod='{}';"
                    SQL = SQL.format(self.firma_id, rodzaj_tmp)
                    stat,dane_rodzaj_stany,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat != 'OK':
                        wyn2.append((nrWiersza, 6))
                        dane.append('BL_RODZAJ_STANY_SQL')
                        break
                    elif len(dane_rodzaj_stany) > 0:
                        if dane_rodzaj_stany[0][0].strip() not in ('', '[]', 'None'):
                            stany_rodzaj = ast.literal_eval(dane_rodzaj_stany[0][0])
                            break

                    rodzaj_tmp = rodzaj_tmp[:-1]

            # Weryfikacja stanw ze sownikiem rs_wf_stany_dokumentow oraz z definicj z rs_wf_rodzaje_dokumentow
            for stan in stany:
                SQL = "SELECT 1 FROM rs_wf_stany_dokumentow WHERE firma_id='{}' AND kod='{}';"
                SQL = SQL.format(self.firma_id, stan.strip())
                stat,dane_stan,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    wyn2.append((nrWiersza, 6))
                    dane.append('BL_STANY_SLOWNIK_SQL')
                elif len(dane_stan) == 0:
                    wyn2.append((nrWiersza, 6))
                    dane.append('BL_STANY_SLOWNIK$'+stan.strip())
                elif stan not in stany_rodzaj:
                    wyn2.append((nrWiersza, 6))
                    dane.append("Stan '"+stan.strip()+"' nie wystpuje w definicji stanw dla rodzaju dokumentw '"+rodzaj+"' lub wyszego w hierarchii")

            # Sprawdzenie czy przejcia s zapisane prawidowo - czy s to pary,
            # czy adna para nie ma dwch takich samych stanw i czy znajduj si w kolumnie stanw
            for przejscie in przejscia:
                if len(przejscie) != 2:
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_LICZBA')
                    break
                stan1 = przejscie[0]
                stan2 = przejscie[1]
                if stan1 == stan2:
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_ROWNE')
                    break
                #WS 2021-11-17
                if (stan1 not in stany or stan2 not in stany_rodzaj) and len(stany) > 0:
                # if (stan1 not in stany or stan2 not in stany) and len(stany) > 0:
                    wyn2.append((nrWiersza, 7))
                    dane.append('BL_PRZEJSCIA_STANY$'+str([stan1,stan2]))

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Update[0]) > 0 and UprMod:
    UPD = ''

    for pola, wartosci, wartosci_klucz in zip(Update[0], Update[1], Update[2]):
        UPD += "UPDATE rs_wf_uprawnienia SET "

        dodane.append({})
        for pole, wart in zip(pola, wartosci):
            if pole in ['operator_id']:
                UPD += pole+"="+str(wart)+","
            elif pole in ['wprowadzanie', 'modyfikacja', 'zamykanie', 'otwieranie', 'ksiegowanie']:
                UPD += pole+"="+str(bool(wart))+","
            elif pole in ['dokument_id', 'komorka_id', 'stany', 'przejscia']:
                UPD += pole+"='"+wart.replace("'","''")+"',"

            if pole in ['operator_id', 'dokument_id', 'komorka_id']:
                dodane[-1][pole] = wart

        UPD = UPD.strip(",")
        UPD += " WHERE firma_id='"+self.firma_id+"'"

        pola_klucz = Update[3]
        for pole, wart in zip(pola_klucz, wartosci_klucz):  # petla po kluczu
            UPD += " AND "+pole+"='"+str(rsglobal.Dekoduj(wart))+"'"

            # uzupenienie o wartoci pl klucza, ktre nie ulegy zmianie
            if pole not in dodane[-1]:
                dodane[-1][pole] = wart

        UPD += ";"

    if UPD != '':
        rsglobal.ZapiszDoLogow(UPD)
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy modyfikowaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1 and len(Insert[0]) > 0 and UprMod:
    INS = ''
    pola = Insert[1]

    for wartosci in Insert[0]:
        INSERT  = "INSERT INTO rs_wf_uprawnienia "
        KOLUMNY = "(firma_id"
        VALUES  = " VALUES ('"+self.firma_id+"'"

        dodane.append({})
        for pole, wart in zip(pola, wartosci):
            if pole in ['operator_id']:
                KOLUMNY += ","+pole
                VALUES += ","+str(wart)
            elif pole in ['wprowadzanie', 'modyfikacja', 'zamykanie', 'otwieranie', 'ksiegowanie']:
                KOLUMNY += ","+pole
                VALUES += ","+str(bool(wart))
            elif pole in ['dokument_id', 'komorka_id', 'stany', 'przejscia']:
                KOLUMNY += ","+pole
                VALUES += ",'"+wart.replace("'","''")+"'"

            if pole in ['operator_id', 'dokument_id', 'komorka_id']:
                dodane[-1][pole] = wart

        KOLUMNY += ")"
        VALUES += ");"
        INS += INSERT+KOLUMNY+VALUES

    if INS != '':
        rsglobal.ZapiszDoLogow(INS)
        stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(INS),1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy dodawaniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -update, 1 -delete, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    if not UprPrz:
        stat = 'UPR_PRZ'
        dane.append(stat)
    else:
        filtry = ''
        filtry_lista = []
        if OperatorF != '':
            filtry_lista.append(" u.operator_id="+OperatorF)
        if NazwiskoF != '':
            filtry_lista.append(" UPPER(o.nazwisko) LIKE UPPER('"+NazwiskoF+"%')")
        if DokumentF != '':
            filtry_lista.append(" UPPER(u.dokument_id) LIKE UPPER('"+DokumentF+"%')")
        if DokumentOpisF != '':
            filtry_lista.append(" UPPER(r.opis) LIKE UPPER('%"+DokumentOpisF+"%')")
        if KomorkaF != '':
            filtry_lista.append(" UPPER(u.komorka_id) LIKE UPPER('"+KomorkaF+"%')")
        if KomorkaOpisF != '':
            filtry_lista.append(" UPPER(k.opis) LIKE UPPER('%"+KomorkaOpisF+"%')")
        if len(filtry_lista) > 0:
            filtry = " AND (u.firma_id='"+self.firma_id+"' AND "+" AND ".join(filtry_lista)+")"

        # dodane/zmienione wiersze pobior si nawet jeli nie s zgodne z filtrem
        dodane_klucze = ''
        if Funkcja == 1 and (len(Insert[0]) > 0 or len(Update[0]) > 0):
            for klucz in dodane:
                dodane_klucze += " OR (u.firma_id='"+self.firma_id+"' AND u.operator_id="+str(klucz['operator_id'])
                dodane_klucze += " AND u.dokument_id='"+klucz['dokument_id']+"' AND u.komorka_id='"+klucz['komorka_id']+"')"

        SEL = """SELECT u.operator_id::TEXT, CONCAT(o.nazwisko, ' ', o.imie) AS nazwisko_imie, 
                        TRIM(u.dokument_id), r.opis AS dokument_opis,
                        TRIM(u.komorka_id), k.opis AS komorka_opis, 
                        u.stany, u.przejscia,
                        u.wprowadzanie, u.modyfikacja, u.zamykanie, u.otwieranie, u.ksiegowanie
                 FROM rs_wf_uprawnienia u
                 INNER JOIN rs_operatorzy o ON o.operator_id=u.operator_id
                 INNER JOIN rs_wf_rodzaje_dokumentow r ON r.firma_id=u.firma_id AND r.kod=u.dokument_id
                 INNER JOIN rs_komorki_zatrudniajace k ON k.firma_id=u.firma_id AND k.kod=u.komorka_id
                 WHERE u.firma_id='{self.firma_id}' {filtry} {dodane_klucze}
                 ORDER BY u.dokument_id, u.komorka_id;""".format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE OPERATORA (9)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 9:
    if not UprOperatorzy:
        stat = 'Brak uprawnie do kartoteki operatorw.'
        dane.append(stat)
    else:
        SQL = "SELECT CONCAT(nazwisko, ' ', imie) AS nazwisko_imie FROM rs_operatorzy WHERE operator_id="+str(Operator)+";"
        rsglobal.ZapiszDoLogow(SQL)
        stat,d,dump,dump =self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych operatora'
            dane.append(stat)
        elif len(d) == 0:
            dane = ['']
        elif len(d) > 0:
            dane = [d[0][0]]

#-------------------------------------------------------------------------------
#---   POBRANIE STANW ZDEFINIOWANYCH DLA RODZAJU (10)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    if not UprPrz:
        stat = 'UPR_PRZ'
        dane.append(stat)
    else:
        # Pobranie stanw zdefiniowanych dla rodzaju z rs_wf_rodzaje_dokumentow uwzgldniajc drzewo
        stany_rodzaj = []
        rodzaj_tmp = Rodzaj
        while len(rodzaj_tmp) > 0:
            SQL = "SELECT stany FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}' AND kod='{}';"
            SQL = SQL.format(self.firma_id, rodzaj_tmp)
            stat,dane_rodzaj_stany,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd przy pobieraniu danych: "+stat
                dane.append(stat)
                break
            elif len(dane_rodzaj_stany) > 0:
                if dane_rodzaj_stany[0][0].strip() not in ('', '[]', 'None'):
                    stany_rodzaj = ast.literal_eval(dane_rodzaj_stany[0][0])
                    break

            rodzaj_tmp = rodzaj_tmp[:-1]

        if len(stany_rodzaj) > 0:
            SQL = "SELECT False, kod, opis FROM rs_wf_stany_dokumentow WHERE firma_id='{}' AND kod in ('{}') ORDER BY kod;"  #WS 2021-12-14
            SQL = SQL.format(self.firma_id, "', '".join(stany_rodzaj))
            stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd przy pobieraniu danych: "+stat
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   WYPENIENIE RS_WF_UPRAWNIENIA_SZCZEGOLY (11)
#-------------------------------------------------------------------------------

#WS 2021-07-12
if stat == 'OK' and Funkcja == 11:
    puste = ['None', '']

    uprawnienia_szczegoly = {}
    rodzaje = []
    komorki = []

    # Pobranie wszystkich kodw z rs_wf_rodzaje_dokumentow
    SQL = "SELECT kod FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{}' ORDER BY kod;"
    SQL = SQL.format(self.firma_id)
    stat,dane_rodzaje,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych rodzajw dokumentw: "+stat
        dane.append(stat)
    else:
        rodzaje = [d[0] for d in dane_rodzaje]

    if stat == 'OK':
        # Pobranie wszystkich kodw z rs_komorki_zatrudniajace
        SQL = "SELECT kod FROM rs_komorki_zatrudniajace WHERE firma_id='{}' ORDER BY kod;"
        SQL = SQL.format(self.firma_id)
        stat,dane_komorki,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych komrek zatrudniajcych: "+stat
            dane.append(stat)
        else:
            komorki = [d[0] for d in dane_komorki]

    if stat == 'OK':
        # Usunicie danych z rs_wf_uprawnienia_szczegoly
        DEL = "DELETE FROM rs_wf_uprawnienia_szczegoly WHERE firma_id='{}';"
        DEL = DEL.format(self.firma_id)
        rsglobal.ZapiszDoLogow(DEL)
        stat,dump,dump,dump = self.PolSQL.Execute(DEL, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd usuwania szczegowych danych uprawnie: "+stat
            dane.append(stat)

    if stat == 'OK':
        # Pobranie danych z rs_wf_uprawnienia
        SQL = "SELECT * FROM rs_wf_uprawnienia WHERE firma_id='{}' ORDER BY dokument_id, komorka_id;"
        SQL = SQL.format(self.firma_id)
        stat,dane_uprawnienia,nagl_uprawnienia,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobierania danych uprawnie do rodzajw dokumentw: "+stat
            dane.append(stat)

    if stat == 'OK':
        # Iteracja po danych z rs_wf_uprawnienia
        uprawnienia = rssql.RSTableRowset2(dane_uprawnienia, nagl_uprawnienia)

        # stany i przejcia
        for wiersz in uprawnienia:
            rodzaje_szczegoly = ([r for r in rodzaje if r.startswith(wiersz['dokument_id'].strip())] if wiersz['dokument_id'].strip() != '**' else rodzaje)
            komorki_szczegoly = ([k for k in komorki if k.startswith(wiersz['komorka_id'].strip())] if wiersz['komorka_id'].strip() != '**' else komorki)

            for rodzaj in rodzaje_szczegoly:
                for komorka in komorki_szczegoly:
                    uprawnienia_szczegoly[(wiersz['operator_id'], rodzaj, komorka)] = [wiersz['stany'], wiersz['przejscia'], [wiersz['wprowadzanie'], wiersz['modyfikacja'], wiersz['zamykanie'], wiersz['otwieranie'], wiersz['ksiegowanie']]]

        # insert
        INS = """INSERT INTO rs_wf_uprawnienia_szczegoly
                 (firma_id, operator_id, dokument_id, komorka_id, stany, przejscia, wprowadzanie, modyfikacja, zamykanie, otwieranie, ksiegowanie)
                 VALUES """
        
        for klucz, wart in uprawnienia_szczegoly.items():
            INS += """('{firma_id}', '{operator_id}', '{dokument_id}', '{komorka_id}', '{stany}', '{przejscia}', 
                       {wprowadzanie}, {modyfikacja}, {zamykanie}, {otwieranie}, {ksiegowanie}),
                   """.format(firma_id     = self.firma_id,
                              operator_id  = klucz[0],
                              dokument_id  = klucz[1],
                              komorka_id   = klucz[2],
                              stany        = wart[0].replace("'", "''"),
                              przejscia    = wart[1].replace("'", "''"),
                              wprowadzanie = wart[2][0],
                              modyfikacja  = wart[2][1],
                              zamykanie    = wart[2][2],
                              otwieranie   = wart[2][3],
                              ksiegowanie  = wart[2][4])

        INS = INS.strip()[:-1] + ";"
        stat,dump,dump,dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd aktualizowania szczegw uprawnie do rodzajw dokumentw: "+stat
            dane.append(stat)
