# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_zagadnienia.py
# Purpose:     Edycja danych zagadnienia, dodawanie i odczyt komentarzy oraz plikw
# Author:      Aleksander Bargie
# Created:     2021/05/25
# RCS-ID:      $Id: fs_wf_zagadnienia.py $
# Copyright:   (c) 2021 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2021-10-06 Aleksander Bargie (12661) [WF] poprawki i zmiany
# 2021-11-17 Aleksander Bargie (12709) [WF] Opisy kodw w Zagadnieniach
# 2021-12-03 Wojciech Skowron   (12751) [WF] Usuwanie zacznikw - funkcja 12
# 2021-12-06 Wojciech Skowron   (12759) [WF] Pozwoli Anakondzie wywietla/edytowa wszystkie zagadnienia
# 2021-12-15 Bartosz Pagan     (12774) [WF] symbol dokumentu plus drobiazgi
# 2022-01-26 Wojciech Skowron   (12835) [WF] Ksigowanie w zagadnieniach - funkcja 10, funkcja 40,
#                                            pobranie klucza dowodu ksigowego w funkcji 5
# 2022-05-20 Aleksander Bargie (13014) Zagadnienia - dekret merytoryczny
# 2022-06-17 Aleksander Bargie (13054) [WF] sprawdzanie kontrahenta i faktury
# 2022-09-20 Aleksander Bargie (13170) Znaki grone dla SQL w edycji zanych zagadnienia
# 2023-03-09 Aleksander Bargie (13378) WF - nie dziaa kontrola pary kontrahent-faktura przy pniejszym wpisaniu kontrahenta
# 2023-05-05 Aleksander Bargie (13412) NIP w zagadnieniach
# 2023-07-07 Wojciech Skowron   (13439) [WF] Zaliczki - Nowe pole 'zaliczka' w Zagadnieniach
# 2023-08-16 Wojciech Skowron   (13487) Akceptacja zaliczki przy zamykaniu
# 2023-08-18 Wojciech Skowron   (13485) Zmiana stanu zaliczki na 'R' przy ksigowaniu
# 2023-08-29 Aleksander Bargie (13509) Upora si ze znakami specjalnymi w danych pobieranych z GUS (usunicie pobrania klucza GUS w tym fs_ie)
# 2023-10-23 Wojciech Skowron   (13584) Zmiana stanu zaliczki na 'K' zamiast na 'R' przy ksigowaniu
# 2023-11-17 Wojciech Skowron   (13550) Otwarcie zagadnienia z zaliczki
# 2023-11-29 Wojciech Skowron   (13532) Zamiana xml na html jeli podgld
# 2024-01-03 Wojciech Skowron   (13650) Blokada usuwania zacznikw dodanych z dokumentw KSeF


import binascii
import random
from StringIO import StringIO
import tempfile
import zipfile

import rsglobal
from funkcje import fs_pliki_global, fs_dowody_ksiegowe_pom  #AB 2023-07-07
from funkcje import fs_wf_zagadnienia_pom as pom

"""
303000 Przegldanie
"""

"""Funkcje:
 1. Insert z pobraniem danych
 3. Update z pobraniem danych
 5. Pobranie danych
 8. Zamykanie dokumentu 
 9. Otwieranie dokumentu
10. Ksigowanie dokumentu
11. Dodanie zacznika
12. Usunicie zacznika
15. Pobranie zacznika
21. Dodanie komentarza
23. Edycja komentarza
35. Pobranie danych operatora
40. Sprawdzenie uprawnie
45. Pobranie danych kontrahenta
"""

Puste = ('', '    -  -  ', '-  -', None, 'None', 'NULL')

stat = "OK"
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    #WS 2023-08-16 - akcept_zaliczki
    SlPar = {'naglowek':   [1, 3, ],   'zagadnienie_id': [3, 5, 8, 9, 10, 11, 12, 15, 21, 23, 40],
             'zawartoscPliku': [11, ], 'nazwaPliku': [11, ],    'nr_pliku':      [12, 15],
             'komentarz_id':   [23, ], 'komentarz':  [23, ],    'operator_id':   [35, ],
             'operacja':       [40, ], 'NIP':        [45],      'kontrahent_id': [45, ],
             'akcept_zaliczki':[8, ],  'Podglad':    [15],      'nazwa_pobieranego_pliku': [15]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista

dane            = []
wyn1            = []
wyn2            = []
Zagadnienie     = []
ZagadnienieWyn1 = []
Pliki           = []
PlikiWyn1       = []
Komentarze      = []
KomentarzeWyn1  = []
Historia        = []
HistoriaWyn1    = []
firma_id = self.firma_id

if stat == 'OK':
    if Fun in (1, 3, ):
        naglowek = klucze['naglowek']
    if Fun in (1, 3, 5, 8, 9, 10, 11, 12, 15, 21, 23, 40):
        zagadnienie_id = klucze['zagadnienie_id']

        if Fun in (1, ):
            wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                        VALUES('{}', {}, NOW() + INTERVAL '{} microseconds', rsf_getuserid(), '{}', {});
                        """.format(firma_id, '{}', '{}', '{}', '{}')#AB 20.09.22r
        else:
            wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                        VALUES('{}', {}, NOW() + INTERVAL '{} microseconds', rsf_getuserid(), '{}', {});
                        """.format(firma_id, zagadnienie_id, '{}', '{}', '{}')#AB 20.09.22r
    if Fun in (8, ):
        akcept_zaliczki = klucze['akcept_zaliczki']  #WS 2023-08-16
    if Fun in (10, ):
        if 'uproszczone' in klucze:
            uproszczone = klucze['uproszczone']
        else:
            uproszczone = False
    if Fun in (11, ):
        zawartoscPliku = klucze['zawartoscPliku']
        nazwaPliku     = klucze['nazwaPliku']
    if Fun in (12, 15):
        nr_pliku = klucze['nr_pliku']
    if Fun in (15, ):
        podglad = klucze['Podglad']  #WS 2023-11-29
        nazwa_pobieranego_pliku = klucze['nazwa_pobieranego_pliku']  #WS 2023-11-29
    if Fun in (21, ):
        komentarz = klucze['komentarz']
    if Fun in (23, ):
        komentarz_id = klucze['komentarz_id']
        komentarz    = klucze['komentarz']
    if Fun in (35, ):
        operator_id = klucze['operator_id']
    #WS 2022-01-26
    if Fun in (40, ):
        operacja = klucze['operacja']
    if Fun in (45, ):
        NIP           = klucze['NIP']
        kontrahent_id = klucze['kontrahent_id']

#WS 2021-12-06
if stat == 'OK' and Fun in (3, 11, 12, 21, 23):
    SQLZamZak = """SELECT zamkniete FROM rs_wf_zagadnienia WHERE zagadnienie_id='{zagadnienie_id}';"""
    SQLZamZak = SQLZamZak.format(**locals())
    rsglobal.ZapiszDoLogow(SQLZamZak)
    stat, zam_zak, dump, dump = self.PolSQL.Execute(SQLZamZak, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd sprawdzania statusu zagadnienia: {stat}".format(**locals())
    elif zam_zak[0][0]:
        stat = "Nie mona modyfikowa zagadnienia zamknitego."

def Execute(self, zapytanie, tryb):
    rsglobal.ZapiszDoLogow(zapytanie)
    return self.PolSQL.Execute(zapytanie, tryb, CzyDodawacBlad=True)

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprPrz = (((self.oddzial_id, '303000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZam = (((self.oddzial_id, '303000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprOtw = (((self.oddzial_id, '303000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprMod = (((self.oddzial_id, '303000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

# ---------------------------------------------------------------------------------------------------------------------
#                                          40 - Sprawdzenie uprawnienie
# ---------------------------------------------------------------------------------------------------------------------

#WS 2022-01-26
if stat == 'OK' and Fun in (40, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, operacja,
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

# ---------------------------------------------------------------------------------------------------------------------
#                                          1 - Dodawanie danych zagadnienia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, ):

    SQLUprDod = """SELECT wprowadzanie
                   FROM rs_wf_uprawnienia_szczegoly
                   WHERE firma_id='{firma_id}' AND operator_id={operator_id} AND dokument_id = '{dokument_id}'
                     AND komorka_id = '{komorka_id}'
                     ;""".format(firma_id=firma_id, operator_id=self.operator_id, dokument_id=naglowek['dokument_id'],
                                 komorka_id=naglowek['komorka_id'])
    rsglobal.ZapiszDoLogow(SQLUprDod)
    stat, dod, dump, dump = self.PolSQL.Execute(SQLUprDod, 7, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd sprawdzania uprawnie do wprowadzania: {stat}".format(**locals())
    else:
        UprDod = ((dod if dod else False) and UprPrz) or (self.operator_id == STANDARD_OPERATOR_ID)
        if not UprDod:
            stat = "Brak uprawnie do wprowadzania dokumentw {} dla komrki {}.".format(naglowek['dokument_id'].strip(),
                                                                                    naglowek['komorka_id'].strip())
    if stat == 'OK':
        stat = pom.CzyMozePrzyjac(self, firma_id, naglowek['operator_id'], naglowek['dokument_id'], naglowek['komorka_id'],
                              naglowek['stan'] if 'stan' in naglowek else None, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
        if stat == 'OK':
            ins_kol  = ['firma_id',         'modyfikacja_czas',     'modyfikacja_kto',  'wprowadzenie_czas',
                        'wprowadzenie_kto', 'zamkniete',            'zaksiegowane']
            ins_wart = ["'"+firma_id+"'",   'NOW()',                'rsf_getuserid()',  'NOW()',
                        'rsf_getuserid()',  'FALSE',                'FALSE']
            args = []#AB 20.09.22r
            INS = """INSERT INTO rs_wf_zagadnienia({})
                     VALUES({})
                     ;"""
            for k, v in naglowek.iteritems():
                if v == '    -  -  ':#AB 20.09.22r
                    v = None
                if isinstance(v, basestring):#AB 20.09.22r
                    v = str(v).strip()
                ins_kol.append(k)
                ins_wart.append('%s')#AB 20.09.22r
                args.append(v)

            INS = INS.format(', '.join(ins_kol), ', '.join(ins_wart))

            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INS, args))#AB 20.09.22r
            stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd dodawania zagadnienia: {stat}".format(**locals())

        if stat == 'OK':
            SQLNumerZag = """SELECT max(zagadnienie_id) 
                               FROM rs_wf_zagadnienia 
                               WHERE firma_id='{firma_id}' AND modyfikacja_kto=rsf_getuserid() 
                               AND wprowadzenie_kto=rsf_getuserid();""".format(**locals())
            rsglobal.ZapiszDoLogow(SQLNumerZag)
            stat, nrz, dump, dump = self.PolSQL.Execute(SQLNumerZag, 3, CzyDodawacBlad=True)
            rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrz))
            if stat != 'OK':
                stat = "Bd pobierania numeru zagadnienia: {stat}".format(**locals())
            else:
                zagadnienie_id = nrz[0][0]

        if stat == 'OK':
            INSHISTORIA = ""
            ARGSHISTORIA = []#AB 20.09.22r
            zmiany = 0
            for k, v in naglowek.iteritems():
                if isinstance(v, basestring):
                    v = v.strip()
                if v in Puste:
                    v = ''
                if k == 'operator_id':  #AB 17.11.21r
                    SELOP = """SELECT (SELECT login||' - '||nazwisko||' '||imie AS login FROM rs_operatorzy WHERE operator_id = {}) AS login
                            ;""".format(v)
                    rsglobal.ZapiszDoLogow(SELOP)
                    stat, loginy, dump, dump = self.PolSQL.Execute(SELOP, 3, CzyDodawacBlad=True)
                    rsglobal.ZapiszDoLogow("pobrano login: {}".format(loginy))
                    if stat != 'OK':
                        stat = "Bd pobierania danych operatora: {stat}".format(**locals())
                    else:
                        login = loginy[0][0][:46]
                        INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Przypisano do", "%s")#AB 20.09.22r
                        ARGSHISTORIA.append(str("=> {}".format(login)))
                elif k == 'dokument_id':  #AB 17.11.21r
                    SELRODZ = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_rodzaje_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                                  ;""".format(firma_id,  v)
                    rsglobal.ZapiszDoLogow(SELRODZ)
                    stat, rodzaje, dump, dump = self.PolSQL.Execute(SELRODZ, 3, CzyDodawacBlad=True)
                    rsglobal.ZapiszDoLogow("pobrano rodzaj: {}".format(rodzaje))
                    if stat != 'OK':
                        stat = "Bd pobierania danych rodzajw dokumentw: {stat}".format(**locals())
                    else:
                        nowy = rodzaje[0][0][:46]
                        INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Typ dokumentu", "%s")#AB 20.09.22r
                        ARGSHISTORIA.append(str("=> {}".format(nowy)))
                elif k == 'komorka_id':  #AB 17.11.21r
                    SELKOM = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_komorki_zatrudniajace WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                                ;""".format(firma_id,  v)
                    rsglobal.ZapiszDoLogow(SELKOM)
                    stat, komorki, dump, dump = self.PolSQL.Execute(SELKOM, 3, CzyDodawacBlad=True)
                    rsglobal.ZapiszDoLogow("pobrano komrk: {}".format(komorki))
                    if stat != 'OK':
                        stat = "Bd pobierania danych komrki zatrudniajcej: {stat}".format(**locals())
                    else:
                        nowy = komorki[0][0][:46]
                        INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Komrka org.", "%s")#AB 20.09.22r
                        ARGSHISTORIA.append(str("=> {}".format(nowy)))
                elif k == 'stan':  #AB 17.11.21r
                    SELSTAN = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_stany_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                                  ;""".format(firma_id,  v)
                    rsglobal.ZapiszDoLogow(SELSTAN)
                    stat, stany, dump, dump = self.PolSQL.Execute(SELSTAN, 3, CzyDodawacBlad=True)
                    rsglobal.ZapiszDoLogow("pobrano stan: {}".format(stany))
                    if stat != 'OK':
                        stat = "Bd pobierania danych stanu: {stat}".format(**locals())
                    else:
                        nowy = stany[0][0][:46]
                        INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Stan", "%s")#AB 20.09.22r
                        ARGSHISTORIA.append(str("=> {}".format(nowy)))
                elif k == 'kontrahent_id':  #AB 17.11.21r
                    SELKON = """SELECT (SELECT TRIM(kontrahent_id)||' - '||TRIM(nazwa) FROM rs_kontrahenci WHERE (firma_id, kontrahent_id) = ('{}','{}')) AS nowy
                                ;""".format(firma_id,  v)
                    rsglobal.ZapiszDoLogow(SELKON)
                    stat, kontrahenci, dump, dump = self.PolSQL.Execute(SELKON, 3, CzyDodawacBlad=True)
                    rsglobal.ZapiszDoLogow("pobrano kontrahenta: {}".format(kontrahenci))
                    if stat != 'OK':
                        stat = "Bd pobierania danych kontrahenta: {stat}".format(**locals())
                    else:
                        nowy = kontrahenci[0][0][:46]
                        INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Kontrahent", "%s".format(nowy))#AB 20.09.22r
                        ARGSHISTORIA.append(str("=> {}".format(nowy)))
                elif k == 'tagi':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Tagi", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'kontrahent_nazwa':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Nazwa kontr.", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'kontrahent_adres':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Adres kontr.", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'nip':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "NIP", "%s")#AB 5.05.23r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'temat':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Temat", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'opis':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Wprowadzono opis", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'symbol_dokumentu':  #AB 17.06.22r
                    if v not in Puste:
                        #AB 2023-07-07
                        kontrahent = naglowek['kontrahent_id'] if 'kontrahent_id' in naglowek else ''  #AB 20.09.22r
                        NIP        = naglowek['nip']           if 'nip'           in naglowek else ''  #AB 20.09.22r
                        if kontrahent not in Puste or NIP not in Puste:
                            stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'ZG', str(kontrahent), str(NIP), str(v), [zagadnienie_id])
                            if stat == 'OK' and komunikat and komunikat not in wyn2:
                                wyn2.append(komunikat)

                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Symbol dokumentu", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                elif k == 'kwota_brutto':
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Kwota brutto", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v)))
                elif k == 'data_dokumentu' and v not in Puste:
                    INSHISTORIA += wzor_hist.format(zagadnienie_id, zmiany, "Data dokumentu", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("=> {}".format(v.strip()[:47])))
                zmiany += 1
                if stat != 'OK':
                    INSHISTORIA = None  #AB 17.06.22r
                    break
            if INSHISTORIA and stat == 'OK':
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSHISTORIA, ARGSHISTORIA))#AB 20.09.22r
                stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, ARGSHISTORIA, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

# ---------------------------------------------------------------------------------------------------------------------
#                                          3 - Aktualizacja danych zagadnienia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3, ):

    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)
    rsglobal.ZapiszDoLogow("Poprzednie dane {}".format(poprzednie))

    if stat == 'OK':
        # nowy stan w pom.SprawdzUprawnienia kontroluje przejscia, ale ta kontrola nie ma sensu gdy zmienia sie dokument,
        # operatora lub komorke, tutaj dajemy None i nie beda przejscia sprawdzane jesli zmodyfikowano ktoras z tych
        # danych
        nowy_stan = naglowek['stan'] if ('stan' in naglowek) else None
        kwota_brutto = naglowek['kwota_brutto'] if ('kwota_brutto' in naglowek) else poprzednie['kwota_brutto']  #WS 2022-07-03
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja',
                               poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                               nowy_stan, kwota_brutto, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
        rsglobal.ZapiszDoLogow("argumenty do sprawdzenia: {}".format((self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja',
                                                            poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                                            nowy_stan)))
    if stat == 'OK':
        stat = pom.CzyMozePrzyjac(self, firma_id,
                              naglowek['operator_id'] if 'operator_id' in naglowek else poprzednie['operator_id'],
                              naglowek['dokument_id'] if 'dokument_id' in naglowek else poprzednie['dokument_id'],
                              naglowek['komorka_id'] if 'komorka_id' in naglowek else poprzednie['komorka_id'],
                              naglowek['stan'] if 'stan' in naglowek else None, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

    if stat == 'OK':
        UPDATENAGLOWEK = "UPDATE rs_wf_zagadnienia SET "
        args = []
        #AB 2023-07-07
        if 'kontrahent_id' in naglowek and naglowek['kontrahent_id'] not in Puste:
            naglowek['nip'] = ''
        for k, v in naglowek.iteritems():#AB 20.09.22r
            if v == '    -  -  ':
                v = None
            if isinstance(v, basestring):#AB 20.09.22r
                v = str(v).strip()
            if args:#AB 20.09.22r
                UPDATENAGLOWEK += ", "
            UPDATENAGLOWEK += "{}=%s".format(k)
            args.append(v)
        UPDATENAGLOWEK += ", modyfikacja_czas=NOW(), modyfikacja_kto=rsf_getuserid() WHERE firma_id='{firma_id}' AND zagadnienie_id={zagadnienie_id};"#AB 20.09.22r

        UPDATENAGLOWEK = UPDATENAGLOWEK.format(**locals())
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(UPDATENAGLOWEK, args))#AB 20.09.22r
        stat, dump, dump, dump = self.PolSQL.Execute(UPDATENAGLOWEK, 1, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd aktualizacji zagadnienia: {stat}".format(**locals())

    if stat == 'OK':
        INSHISTORIA = ""
        ARGSHISTORIA = []#AB 20.09.22r
        zmiany = 0
        for k, v in naglowek.iteritems():
            if isinstance(poprzednie[k], basestring):
                poprzednie[k] = poprzednie[k].strip()
            if isinstance(v, basestring):
                v = v.strip()
            if v in Puste:
                v = ''
            if str(poprzednie[k]) in Puste:
                poprzednie[k] = ''
            if k == 'operator_id':  #AB 17.11.21r
                SELOP = """SELECT (SELECT login||' - '||nazwisko||' '||imie AS login FROM rs_operatorzy WHERE operator_id = {}) AS login2, 
                                  (SELECT login||' - '||nazwisko||' '||imie AS login FROM rs_operatorzy WHERE operator_id = {}) AS login
                            ;""".format(poprzednie[k], v)
                rsglobal.ZapiszDoLogow(SELOP)
                stat, loginy, dump, dump = self.PolSQL.Execute(SELOP, 3, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow("pobrano loginy: {}".format(loginy))
                if stat != 'OK':
                    stat = "Bd pobierania danych operatorw: {stat}".format(**locals())
                else:
                    poprzedni, nowy = loginy[0]
                    if poprzedni in Puste:
                        poprzedni = ''
                    if len(poprzedni) + len(nowy) > 46:
                        zapas_poprzedni = max(23 - len(nowy.strip()), 0)
                        zapas_nowy      = max(23 - len(poprzedni.strip()), 0)
                        poprzedni       = poprzedni.strip()[:23+zapas_poprzedni]
                        nowy            = nowy.strip()[:23+zapas_nowy]
                    INSHISTORIA += wzor_hist.format(zmiany, "Przypisano do", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'dokument_id':  #AB 17.11.21r
                SELRODZ = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_rodzaje_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS poprzedni, 
                                    (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_rodzaje_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                              ;""".format(firma_id, poprzednie[k], firma_id,  v)
                rsglobal.ZapiszDoLogow(SELRODZ)
                stat, rodzaje, dump, dump = self.PolSQL.Execute(SELRODZ, 3, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow("pobrano rodzaje: {}".format(rodzaje))
                if stat != 'OK':
                    stat = "Bd pobierania danych rodzajw dokumentw: {stat}".format(**locals())
                else:
                    poprzedni, nowy = rodzaje[0]
                    if poprzedni in Puste:
                        poprzedni = ''
                    if len(poprzedni) + len(nowy) > 46:
                        zapas_poprzedni = max(23 - len(nowy), 0)
                        zapas_nowy      = max(23 - len(poprzedni), 0)
                        poprzedni       = poprzedni[:23+zapas_poprzedni]
                        nowy            = nowy[:23+zapas_nowy]
                    INSHISTORIA += wzor_hist.format(zmiany, "Typ dokumentu", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'komorka_id':  #AB 17.11.21r
                SELKOM = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_komorki_zatrudniajace WHERE (firma_id, kod) = ('{}','{}')) AS poprzedni, 
                                   (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_komorki_zatrudniajace WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                            ;""".format(firma_id, poprzednie[k], firma_id,  v)
                rsglobal.ZapiszDoLogow(SELKOM)
                stat, komorki, dump, dump = self.PolSQL.Execute(SELKOM, 3, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow("pobrano komrki: {}".format(komorki))
                if stat != 'OK':
                    stat = "Bd pobierania danych komrek zatrudniajcych: {stat}".format(**locals())
                else:
                    poprzedni, nowy = komorki[0]
                    if poprzedni in Puste:
                        poprzedni = ''
                    if len(poprzedni) + len(nowy) > 46:
                        zapas_poprzedni = max(23 - len(nowy), 0)
                        zapas_nowy      = max(23 - len(poprzedni), 0)
                        poprzedni       = poprzedni[:23+zapas_poprzedni]
                        nowy            = nowy[:23+zapas_nowy]
                    INSHISTORIA += wzor_hist.format(zmiany, "Komrka org.", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'stan':  #AB 17.11.21r
                SELSTAN = """SELECT (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_stany_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS poprzedni, 
                                    (SELECT TRIM(kod)||' - '||TRIM(opis) FROM rs_wf_stany_dokumentow WHERE (firma_id, kod) = ('{}','{}')) AS nowy
                              ;""".format(firma_id, poprzednie[k], firma_id,  v)
                rsglobal.ZapiszDoLogow(SELSTAN)
                stat, stany, dump, dump = self.PolSQL.Execute(SELSTAN, 3, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow("pobrano stany: {}".format(stany))
                if stat != 'OK':
                    stat = "Bd pobierania danych stanw: {stat}".format(**locals())
                else:
                    poprzedni, nowy = stany[0]
                    if poprzedni in Puste:
                        poprzedni = ''
                    if len(poprzedni) + len(nowy) > 46:
                        zapas_poprzedni = max(23 - len(nowy), 0)
                        zapas_nowy      = max(23 - len(poprzedni), 0)
                        poprzedni       = poprzedni[:23+zapas_poprzedni]
                        nowy            = nowy[:23+zapas_nowy]
                    INSHISTORIA += wzor_hist.format(zmiany, "Stan", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'kontrahent_id':  #AB 17.11.21r
                SELKON = """SELECT (SELECT TRIM(kontrahent_id)||' - '||TRIM(nazwa) FROM rs_kontrahenci WHERE (firma_id, kontrahent_id) = ('{}','{}')) AS poprzedni, 
                                   (SELECT TRIM(kontrahent_id)||' - '||TRIM(nazwa) FROM rs_kontrahenci WHERE (firma_id, kontrahent_id) = ('{}','{}')) AS nowy
                            ;""".format(firma_id, poprzednie[k], firma_id,  v)
                rsglobal.ZapiszDoLogow(SELKON)
                stat, kontrahenci, dump, dump = self.PolSQL.Execute(SELKON, 3, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow("pobrano kontrahentw: {}".format(kontrahenci))
                if stat != 'OK':
                    stat = "Bd pobierania danych kontrahentw: {stat}".format(**locals())
                else:
                    poprzedni, nowy = kontrahenci[0]
                    if poprzedni in Puste:
                        poprzedni = ''
                    if len(poprzedni) + len(nowy) > 46:
                        zapas_poprzedni = max(23 - len(nowy), 0)
                        zapas_nowy      = max(23 - len(poprzedni), 0)
                        poprzedni       = poprzedni[:23+zapas_poprzedni]
                        nowy            = nowy[:23+zapas_nowy]
                    if nowy not in Puste:  #AB 09.03.23r
                        symbol = naglowek['symbol_dokumentu'] if 'symbol_dokumentu' in naglowek else poprzednie['symbol_dokumentu']
                        #AB 2023-07-07
                        NIP    = naglowek['nip']              if 'nip'              in naglowek else poprzednie['nip']  # AB 20.09.22r
                        if (nowy not in Puste or NIP not in Puste) and symbol not in Puste:
                            stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'ZG',
                                                                                                   v,
                                                                                                   NIP, symbol,
                                                                                                   [zagadnienie_id])
                            if stat == 'OK' and komunikat and komunikat not in wyn2:
                                wyn2.append(komunikat)
                    INSHISTORIA += wzor_hist.format(zmiany, "Kontrahent", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'nip':
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                if nowy not in Puste:  #AB 2023-07-07
                    symbol = naglowek['symbol_dokumentu'] if 'symbol_dokumentu' in naglowek else poprzednie['symbol_dokumentu']
                    kontr  = naglowek['kontrahent_id']    if 'kontrahent_id'    in naglowek else poprzednie['kontrahent_id']
                    if (nowy not in Puste or kontr not in Puste) and symbol not in Puste:
                        stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'ZG',
                                                                                               kontr,
                                                                                               v, symbol,
                                                                                               [zagadnienie_id])
                        if stat == 'OK' and komunikat and komunikat not in wyn2:
                            wyn2.append(komunikat)
                INSHISTORIA += wzor_hist.format(zmiany, "NIP", "%s")#AB 05.05.23r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'kontrahent_adres':
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                INSHISTORIA += wzor_hist.format(zmiany, "Adres kontr.", "%s")#AB 05.05.23r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'kontrahent_nazwa':
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                INSHISTORIA += wzor_hist.format(zmiany, "Nazwa kontr.", "%s")#AB 05.05.23r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'tagi':
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                INSHISTORIA += wzor_hist.format(zmiany, "Tagi", "%s")#AB 20.09.22r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'temat':
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                INSHISTORIA += wzor_hist.format(zmiany, "Temat", "%s")#AB 20.09.22r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'opis':
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                INSHISTORIA += wzor_hist.format(zmiany, "Zmodyfikowano opis", "%s")#AB 20.09.22r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'symbol_dokumentu':  #BP 2021-12-16
                poprzedni, nowy = poprzednie[k].strip(), v.strip()
                if len(poprzedni) + len(nowy) > 46:
                    zapas_poprzedni = max(23 - len(nowy), 0)
                    zapas_nowy      = max(23 - len(poprzedni), 0)
                    poprzedni       = poprzedni[:23+zapas_poprzedni]
                    nowy            = nowy[:23+zapas_nowy]
                if nowy not in Puste:  #AB 2023-07-07
                    kontrahent = naglowek['kontrahent_id'] if 'kontrahent_id' in naglowek else poprzednie['kontrahent_id']
                    NIP        = naglowek['nip']           if 'nip'           in naglowek else poprzednie['nip']  #AB 20.09.22r
                    if kontrahent not in Puste or NIP not in Puste:
                        stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'ZG', kontrahent,
                                                                                               NIP, v, [zagadnienie_id])
                        if stat == 'OK' and komunikat and komunikat not in wyn2:
                            wyn2.append(komunikat)

                INSHISTORIA += wzor_hist.format(zmiany, "Symbol dokumentu", "%s")#AB 20.09.22r
                ARGSHISTORIA.append(str("{} => {}".format(poprzedni, nowy).strip()))
            elif k == 'kwota_brutto':
                INSHISTORIA += wzor_hist.format(zmiany, "Kwota brutto", "%s")#AB 20.09.22r
                ARGSHISTORIA.append(str("{} => {}".format(poprzednie[k], v).strip()))
            elif k == 'data_dokumentu':
                if v != poprzednie[k]:
                    INSHISTORIA += wzor_hist.format(zmiany, "Data dokumentu", "%s")#AB 20.09.22r
                    ARGSHISTORIA.append(str("{} => {}".format(poprzednie[k], v).strip()))
            zmiany += 1
            if stat != 'OK':
                INSHISTORIA = None  #AB 17.06.22r
                break
        if INSHISTORIA:
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INSHISTORIA, ARGSHISTORIA))#AB 20.09.22r
            stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, ARGSHISTORIA, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())


# ---------------------------------------------------------------------------------------------------------------------
#                                             11 - Dodanie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (11, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
    if stat == 'OK':
        args = [zagadnienie_id]
        SQL = """SELECT firma_id,okres_id,dowod_id,nazwa_id,data,numer
                 FROM rs_dowody_ksiegowe
                 WHERE zagadnienie_id=%s
                 ;"""
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, dk, nagldk, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd szukania dowodu ksigowego: " + stat
    if stat == 'OK':
        INSPLIKI = """INSERT INTO rs_pliki (  firma_id,      nazwa,            tabela,     kompresja)
                                    VALUES ('{firma_id}','{nazwaPliku}','rs_wf_zagadnienia_pliki', FALSE);""".format(**locals())
        rsglobal.ZapiszDoLogow(INSPLIKI)
        stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania pliku: {stat}".format(**locals())

    if stat == 'OK':
        SQLNumerPliku = """SELECT max(plik_id) 
                           FROM rs_pliki 
                           WHERE firma_id='{firma_id}' AND tabela='rs_wf_zagadnienia_pliki';""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLNumerPliku)
        stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrp))
        if stat != 'OK':
            stat = "Bd pobierania numeru zacznika: {stat}".format(**locals())
        else:
            NumerPliku = nrp[0][0]
            stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, zawartoscPliku)

            if stat != 'OK':
                stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())
            else:
                INSPLIKIZAG = ''
                if len(dk)>0:
                    DaneDK = rssql.RSTableRowset(dk,nagldk)
                    firma_id = DaneDK.GetVal(0,"firma_id")
                    okres_id = DaneDK.GetVal(0,"okres_id")
                    dowod_id = DaneDK.GetVal(0,"dowod_id")
                    nazwa_id = DaneDK.GetVal(0,"nazwa_id")
                    data     = DaneDK.GetVal(0,"data")
                    numer    = DaneDK.GetVal(0,"numer")
                    if firma_id != self.firma_id:
                        stat = "Problem z powizaniem dowodu ksigowego i zagadnienia. Poinformuj administratora"
                    else:
                        INSPLIKIZAG = """INSERT INTO rs_dowody_ksiegowe_pliki (dowod_plik, nr_pliku, firma_id, okres_id, dowod_id, nazwa_id, data, numer)
                                         SELECT SUBSTRING(p.nazwa,1,100), nr_pliku, '{firma_id}', '{okres_id}', '{dowod_id}', '{nazwa_id}', '{data}', {numer}
                                         FROM rs_wf_zagadnienia_pliki zp
                                         JOIN rs_pliki p ON zp.nr_pliku = p.plik_id
                                         WHERE zagadnienie_id={zagadnienie_id} AND NOT EXISTS (SELECT 1 FROM rs_dowody_ksiegowe_pliki dkp WHERE zp.nr_pliku=dkp.nr_pliku);""".format(**locals())
                        rsglobal.ZapiszDoLogow('Pliki zagadnienie dowod: '+INSPLIKIZAG)
                if stat == 'OK':
                    INSZALACZNIKI = """INSERT INTO rs_wf_zagadnienia_pliki
                                               (  firma_id,    zagadnienie_id,    nr_pliku   )
                                        VALUES ('{firma_id}','{zagadnienie_id}','{NumerPliku}');
                                        {INSPLIKIZAG}""".format(**locals())

                    rsglobal.ZapiszDoLogow(INSZALACZNIKI, 5)
                    stat, dump, dump, dump = self.PolSQL.Execute(INSZALACZNIKI, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd dodawania rekordu o nowym pliku: ' + stat
                    else:
                        dane = [{'nr_pliku': NumerPliku}]
                        stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)
                if stat == 'OK':
                    #AB 06.10.21r
                    if len(nazwaPliku) > 50:
                        nazwaPliku = nazwaPliku[:30] + '...' + nazwaPliku[-17:]
                    INSHISTORIA = wzor_hist.format(0, "Doczono plik", "'" + nazwaPliku + "'") #AB 20.09.22r
                    rsglobal.ZapiszDoLogow(INSHISTORIA)
                    stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())


# ---------------------------------------------------------------------------------------------------------------------
#                                             12 - Usunicie pliku
# ---------------------------------------------------------------------------------------------------------------------

#WS 2021-12-03
if stat == 'OK' and Fun in (12, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

    if stat == 'OK':
        SEL = """SELECT nazwa FROM rs_pliki WHERE plik_id={nr_pliku};""".format(**locals())
        stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobrania nazwy usuwanego pliku: {stat}".format(**locals())
        elif len(dane) == 0:
            stat = "Plik nie istnieje"
        else:
            nazwa_pliku = dane[0][0]

    #WS 2024-01-03
    if stat == 'OK':
        SEL = """SELECT 1 FROM rs_wf_ksef_dokumenty WHERE plik_id={nr_pliku};""".format(**locals())
        stat, d, dump, dump = self.PolSQL.Execute(SEL, 3)
        if stat != 'OK':
            stat = "Bd sprawdzania usuwanego pliku: {stat}".format(**locals())
        elif len(d) > 0:
            stat = "Nie mona usun zacznika bdcego dokumentem KSeF"

    if stat == 'OK':
        DEL= """DELETE FROM rs_dowody_ksiegowe_pliki WHERE nr_pliku={nr_pliku}; \n""".format(**locals())
        DEL+= """DELETE FROM rs_wf_zagadnienia_pliki WHERE nr_pliku={nr_pliku}; \n""".format(**locals())
        DEL+= """DELETE FROM rs_pliki                WHERE plik_id={nr_pliku}; \n""".format(**locals())
        rsglobal.ZapiszDoLogow(DEL,5)
        stat,dump,dump,dump = self.PolSQL.Execute(DEL,1,CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd podczas usuwania pliku: '+stat
        else:
            dane = [{'nr_pliku': nr_pliku}]
            stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)
        if stat == 'OK':
            if len(nazwa_pliku) > 50:
                nazwa_pliku = nazwa_pliku[:30] + '...' + nazwa_pliku[-17:]
            INSHISTORIA = wzor_hist.format(0, "Usunito plik", "'" + nazwa_pliku + "'") #AB 20.09.22r
            rsglobal.ZapiszDoLogow(INSHISTORIA)
            stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

    if stat == 'OK':
        stat = fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow, nr_pliku)


# ---------------------------------------------------------------------------------------------------------------------
#                                             21 - Dodanie komentarza
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (21, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
    if stat == 'OK':
        INSKOMENTARZ = """INSERT INTO rs_wf_zagadnienia_komentarze (firma_id, zagadnienie_id, komentarz, wprowadzenie_czas, wprowadzenie_kto, modyfikacja_czas, modyfikacja_kto)
                                                          VALUES ('{firma_id}','{zagadnienie_id}','{komentarz}', NOW(), rsf_getuserid(), NOW(), rsf_getuserid());""".format(**locals())
        rsglobal.ZapiszDoLogow(INSKOMENTARZ)
        stat, dump, dump, dump = self.PolSQL.Execute(INSKOMENTARZ, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania komentarza: {stat}".format(**locals())
    if stat == 'OK':
        stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)
    if stat == 'OK':
        SQLNRKOMENT = "SELECT COUNT(komentarz_id) " \
                      "FROM rs_wf_zagadnienia_komentarze " \
                      "WHERE firma_id='{}' AND zagadnienie_id='{}';".format(firma_id, zagadnienie_id)

        rsglobal.ZapiszDoLogow(SQLNRKOMENT)
        stat, Koment, dump, dump = self.PolSQL.Execute(SQLNRKOMENT, 3, CzyDodawacBlad=True)
        if stat != 'OK' or len(Koment) != 1:
            stat = u"Bd pobierania numeru dodanego komentarza: {stat}".format(**locals())
    if stat == 'OK':
        INSHISTORIA = wzor_hist.format(0, "Dodano komentarz: {}".format(Koment[0][0]), "''") #AB 20.09.22r
        rsglobal.ZapiszDoLogow(INSHISTORIA)
        stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())


# ---------------------------------------------------------------------------------------------------------------------
#                                             23 - Edycja komentarza
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (23, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
    if stat == 'OK':
        UPDKOMENTARZ = """UPDATE rs_wf_zagadnienia_komentarze 
                          SET komentarz = '{komentarz}', modyfikacja_czas = NOW(), modyfikacja_kto = rsf_getuserid()
                          WHERE komentarz_id = {komentarz_id} ;""".format(**locals())
        rsglobal.ZapiszDoLogow(UPDKOMENTARZ)
        stat, dump, dump, dump = self.PolSQL.Execute(UPDKOMENTARZ, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania komentarza: {stat}".format(**locals())
    if stat == 'OK':
        stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)
    if stat == 'OK':
        INSHISTORIA = wzor_hist.format(0, "Zmodyfikowano komentarz: {}".format(komentarz_id), "''") #AB 20.09.22r
        rsglobal.ZapiszDoLogow(INSHISTORIA)
        stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

# ---------------------------------------------------------------------------------------------------------------------
#                                             35 - Pobranie danych operatora
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (35, ):
    SELOP = """SELECT login, imie, nazwisko FROM rs_operatorzy WHERE operator_id={operator_id};""".format(**locals())
    rsglobal.ZapiszDoLogow(SELOP)
    stat, dane, dump, dump = self.PolSQL.Execute(SELOP, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobrania danych operatora: {stat}".format(**locals())
    elif len(dane) <1:
        stat = "Nie odnaleziono operatora {}".format(operator_id)

# ---------------------------------------------------------------------------------------------------------------------
#                                             15 - Pobranie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (15, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'cokolwiek',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
    if stat in ('OK', 'Operator posiada uprawnienia tylko do przegldania.'):
        stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, nr_pliku)
        #WS 2023-11-29 - transformacja faktury ksef .xml do .html
        if stat == 'OK' and podglad and nazwa_pobieranego_pliku.endswith('.xml'):
            try:
                TempTresc = binascii.unhexlify(Tresc)
                with zipfile.ZipFile(StringIO(TempTresc), "r") as z:
                    TempTresc = z.read('YouWontKnow')
                    if 'kodSystemowy="FA' in TempTresc:  # sprawdzenie czy to faktura ksef
                        TrescHtml = rsglobal.TransformujZXSL(xml_tresc=TempTresc, xsl_sciezka='xsd/fa.xsl')
                        nazwa_pobieranego_pliku = nazwa_pobieranego_pliku.replace('.xml', '.html')

                        # przygotowanie do przesania
                        TmpPlik = tempfile.mktemp('.html')
                        with open(TmpPlik, 'wb') as p:
                            p.write(TrescHtml)
                            Tresc = fs_pliki_global.PrzygotujPlikDoPrzeslania(TmpPlik)
                        os.remove(TmpPlik)

                        if Tresc is None:
                            stat = 'Bd przetwarzania pliku xml'
            except:
                import traceback
                stat = 'Bd przetwarzania pliku xml'
                rsglobal.ZapiszDoLogow(stat+': '+traceback.format_exc())

        dane = [Tresc, nazwa_pobieranego_pliku]

# ---------------------------------------------------------------------------------------------------------------------
#                                    45 - Pobranie danych kontrahenta
# ---------------------------------------------------------------------------------------------------------------------
#AB 05.05.23r
if stat == 'OK' and Fun in (45, ):
    args = [firma_id]
    if NIP:
        NIP = "%" + NIP.replace('-', '').replace(' ', '') + "%"
        war = "AND nip like %s;"
        args.append(NIP)
    else:
        war = "AND kontrahent_id = %s"
        args.append(kontrahent_id)

    SQL = "SELECT kontrahent_id, " \
          "nazwa, " \
          "CASE WHEN TRIM(adrk_miej) != '' " \
          "THEN CONCAT(TRIM(adrk_kod), ' ', " \
          "            TRIM(CASE WHEN adrk_poczta != '' THEN adrk_poczta ELSE adrk_miej END), ', ', " \
          "            TRIM(adrk_miej), ', ', TRIM(adrk_ulica), ', ', TRIM(adrk_nry)) " \
          "ELSE CONCAT(TRIM(adr_kod), ' ', " \
          "            TRIM(CASE WHEN adr_poczta != '' THEN adr_poczta ELSE adr_miej END), ', ', " \
          "            TRIM(adr_miej), ', ', TRIM(adr_ulica), ', ', TRIM(adr_nry)) END, nip " \
          "FROM rs_kontrahenci " \
          "WHERE firma_id = %s AND aktywny " + war

    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych kontrahentw: {stat}".format(**locals())


# ---------------------------------------------------------------------------------------------------------------------
#                                             8 - Zamykanie zagadnienia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (8, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'zamykanie',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

    if stat == 'OK':
        SQLUprZam = """SELECT zamykanie
                       FROM rs_wf_uprawnienia_szczegoly
                       WHERE firma_id='{firma_id}' AND operator_id={operator_id} AND dokument_id = '{dokument_id}'
                         AND komorka_id = '{komorka_id}'
                         ;""".format(firma_id=firma_id, operator_id=self.operator_id,
                                     dokument_id=poprzednie['dokument_id'],
                                     komorka_id=poprzednie['komorka_id'])
        rsglobal.ZapiszDoLogow(SQLUprZam)
        stat, zam, dump, dump = self.PolSQL.Execute(SQLUprZam, 7, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd sprawdzania uprawnie do zamykania: {stat}".format(**locals())
        else:
            UprZam = ((zam if zam else False) and UprPrz) or ( self.operator_id == STANDARD_OPERATOR_ID)
            if not UprZam:
                stat = "Brak uprawnie do zamykania dokumentw {} dla komrki {}.".format(naglowek['dokument_id'].strip(),
                                                                                             naglowek['komorka_id'].strip())

    if stat == 'OK':
        ZAMKZAG = """UPDATE rs_wf_zagadnienia SET zamkniete=TRUE WHERE zagadnienie_id='{zagadnienie_id}';""".format(**locals())
        rsglobal.ZapiszDoLogow(ZAMKZAG)
        stat, dump, dump, dump = self.PolSQL.Execute(ZAMKZAG, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd zamykania zagadnienia: {stat}".format(**locals())
        else:
            stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)

    #WS 2023-08-16
    if stat == 'OK' and poprzednie['zaliczka_id_akcept'] != 0 and poprzednie['zaliczka_id_akcept'] not in Puste:
        SQL = "SELECT kontrahent_id, stan FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
        zmienne = [poprzednie['zaliczka_id_akcept']]

        rsglobal.ZapiszDoLogow('Spr kontr zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_kontr, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania danych przed akceptacj zaliczki'
        elif d_kontr[0][1] != 'W':
            stat = 'Nie mona zaakceptowa zaliczki w stanie innym ni W.'
        else:
            SQL = "UPDATE rs_wf_zaliczki SET stan=%s, akceptacja_czas=NOW(), akceptacja_operator=%s WHERE zaliczka_id=%s;"
            zmienne = ['A' if akcept_zaliczki else 'U', self.operator_id, poprzednie['zaliczka_id_akcept']]

            rsglobal.ZapiszDoLogow('Akcept zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd akceptowania zaliczki'

        if stat == 'OK':
            INSHISTORIA = wzor_hist.format(0, "Zaakceptowano zaliczk" if akcept_zaliczki else "Anulowano zaliczk", str(poprzednie['zaliczka_id_akcept']))
            rsglobal.ZapiszDoLogow(INSHISTORIA)
            stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

    if stat == 'OK':
        INSHISTORIA = wzor_hist.format(1, "Zamknito zagadnienie", "''") #AB 20.09.22r
        rsglobal.ZapiszDoLogow(INSHISTORIA)
        stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())


# ---------------------------------------------------------------------------------------------------------------------
#                                             9 - Otwieranie zagadnienia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (9, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'otwieranie',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

    if stat == 'OK':
        SQLUprOtw = """SELECT otwieranie
                       FROM rs_wf_uprawnienia_szczegoly
                       WHERE firma_id='{firma_id}' AND operator_id={operator_id} AND dokument_id = '{dokument_id}'
                         AND komorka_id = '{komorka_id}'
                         ;""".format(firma_id=firma_id, operator_id=self.operator_id,
                                     dokument_id=poprzednie['dokument_id'],
                                     komorka_id=poprzednie['komorka_id'])
        rsglobal.ZapiszDoLogow(SQLUprOtw)
        stat, otw, dump, dump = self.PolSQL.Execute(SQLUprOtw, 7, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd sprawdzania uprawnie do otwierania: {stat}".format(**locals())
        else:
            UprZam = ((otw if otw else False) and UprPrz) or (self.operator_id == STANDARD_OPERATOR_ID)
            if not UprZam:
                stat = "Brak uprawnie do otwierania dokumentw {} dla komrki {}.".format(naglowek['dokument_id'].strip(),
                                                                                          naglowek['komorka_id'].strip())
    #WS 2023-11-17
    if stat == 'OK':
        SQL = "SELECT rk_o_kasa_bank_id IS NOT NULL FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
        zmienne = [poprzednie['zaliczka_id_akcept']]

        rsglobal.ZapiszDoLogow('Spr rk_o zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, zal, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania danych zaliczki przed otwarciem'
        elif len(zal) > 0 and zal[0][0]:
            stat = 'Zaliczka zostaa wypacona. Otwarcie zagadnienia niemoliwe.'
    if stat == 'OK':
        ZAMKZAG = """UPDATE rs_wf_zagadnienia SET zamkniete=FALSE WHERE zagadnienie_id='{zagadnienie_id}';""".format(**locals())
        rsglobal.ZapiszDoLogow(ZAMKZAG)
        stat, dump, wyn1, dump = self.PolSQL.Execute(ZAMKZAG, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd otwierania zagadnienia: {stat}".format(**locals())
        else:
            stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)
    #WS 2023-11-17
    if stat == 'OK':
        SQL = "UPDATE rs_wf_zaliczki SET stan='W', akceptacja_czas=NULL, akceptacja_operator=NULL WHERE zaliczka_id=%s;"
        zmienne = [poprzednie['zaliczka_id_akcept']]

        rsglobal.ZapiszDoLogow('Zmiana zaliczki po otwarciu: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd zmiany zaliczki'
    if stat == 'OK':
        INSHISTORIA = wzor_hist.format(0, "Otwarto zagadnienie", "''") #AB 20.09.22r
        rsglobal.ZapiszDoLogow(INSHISTORIA)
        stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

# ---------------------------------------------------------------------------------------------------------------------
#                                             10 - Ksigowanie zagadnienia
# ---------------------------------------------------------------------------------------------------------------------

#WS 2022-01-26
if stat == 'OK' and Fun in (10, ):
    stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

    if stat == 'OK':
        stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja' if uproszczone else 'ksiegowanie',
                                      poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                      STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

    if stat == 'OK':
        SQLDowKsieg = """SELECT dowod_id ||'/'|| nazwa_id ||'/'|| data ||'/'|| numer
                         FROM rs_dowody_ksiegowe
                         WHERE zagadnienie_id={zagadnienie_id};""".format(**locals())
        rsglobal.ZapiszDoLogow('Ksiegowanie spr dowodu: '+SQLDowKsieg)
        stat, zaks, dump, dump = self.PolSQL.Execute(SQLDowKsieg, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobrania klucza dowodu ksigowego powizanego z zagadnieniem: {stat}".format(**locals())
        elif len(zaks) == 0:
            stat = "Bd ksigowania zagadnienia - nie odnaleziono dowodu ksigowego"
        else:
            ZAKSZAG = """UPDATE rs_wf_zagadnienia SET zaksiegowane=TRUE WHERE zagadnienie_id={zagadnienie_id} AND not zamkniete;""".format(**locals())
            rsglobal.ZapiszDoLogow('Ksiegowanie update: '+ZAKSZAG)
            stat, dump, wyn1, dump = self.PolSQL.Execute(ZAKSZAG, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd otwierania zagadnienia: {stat}".format(**locals())
            elif wyn1 != 'UPDATE 1':
                stat = "Nie mona zaksigowa zamknitego zagadnienia."
            else:
                stat = pom.AktualizujaOstatniaAktywnosc(self, firma_id, zagadnienie_id)

            if stat == 'OK':
                INSHISTORIA = wzor_hist.format(0, "Zaksigowano zagadnienie", "'"+zaks[0][0]+"'") #AB 20.09.22r
                rsglobal.ZapiszDoLogow('Ksiegowanie historia: '+INSHISTORIA)
                stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

            #WS 2023-08-18
            if stat == 'OK':
                SQL = "SELECT BOOL_AND(zaksiegowane) FROM rs_wf_zagadnienia WHERE firma_id=%s AND zaliczka_id=%s;"
                args = [self.firma_id, poprzednie['zaliczka_id']]
                rsglobal.ZapiszDoLogow('Spr przed rozliczeniem zaliczki: '+self.PolSQL.Mogrify(SQL, args))
                stat, d_zaksieg, dump, dump = self.PolSQL.Execute(SQL, 3, args)
                if stat != 'OK':
                    rsglobal.ZapiszDoLogow(stat)
                    stat = 'Bd sprawdzania zaksiegowanych zagadnien dla zaliczki'
                elif d_zaksieg[0][0]:
                    SQL = """SELECT z.kwota_brutto-(SELECT COALESCE(SUM(zp.kwota_brutto),0) FROM rs_wf_zaliczki_pozycje zp WHERE z.zaliczka_id=zp.zaliczka_id) AS saldo
                             FROM rs_wf_zaliczki z
                             WHERE z.firma_id=%s AND z.zaliczka_id=%s;"""
                    zmienne = [self.firma_id, poprzednie['zaliczka_id']]
                    rsglobal.ZapiszDoLogow('Nowe saldo zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
                    stat, d_saldo, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
                    if stat != 'OK':
                        rsglobal.ZapiszDoLogow(stat)
                        stat = 'Bd pobrania danych zaliczki'
                    else:
                        stan = 'K'  #WS 2023-10-23 R -> K
                        saldo = d_saldo[0][0]
                        if saldo == 0:
                            stan = 'Z'
                        UPD_ZAL = """UPDATE rs_wf_zaliczki SET stan='{stan}', saldo={saldo}
                                     WHERE firma_id=%s AND zaliczka_id=%s;""".format(**locals())
                        args = [self.firma_id, poprzednie['zaliczka_id']]
                        rsglobal.ZapiszDoLogow('Zaliczka rozliczona: '+self.PolSQL.Mogrify(UPD_ZAL, args))
                        stat, dump, dump, dump = self.PolSQL.Execute(UPD_ZAL, 1, args)
                        if stat != 'OK':
                            stat = 'Bd zmiany stanu zaliczki na rozliczona:'+stat
                            dane.append(stat)

# ---------------------------------------------------------------------------------------------------------------------
#                            POBRANIE DANYCH (1 - insert 3 - update, 5 - select)
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3, 5, ):
    tylko_przegladanie = False

    if Fun not in (1, 3, ):  # nie sprawdzamy podczas dodawania
        stat, poprzednie = pom.PoprzednieDaneZagadnienia(self, firma_id, zagadnienie_id)

        if stat == 'OK':
            stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'cokolwiek',
                                          poprzednie['stan'], poprzednie['komorka_id'], poprzednie['dokument_id'],
                                          STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
            if stat == 'Operator posiada uprawnienia tylko do przegldania.':
                stat = 'OK'
                tylko_przegladanie = True

    warunek = "z.zagadnienie_id='{zagadnienie_id}'".format(**locals())

    if stat in ('OK',):
        #WS 2024-01-03 - czy_mozna_usuwac
        SQLPliki = """SELECT z.firma_id, z.zagadnienie_id, z.nr_pliku, p.nazwa AS opis, kd.numer IS NULL AS czy_mozna_usuwac
                      FROM rs_wf_zagadnienia_pliki z 
                      JOIN rs_pliki p ON p.firma_id=z.firma_id AND p.plik_id=z.nr_pliku 
                      LEFT OUTER JOIN rs_wf_ksef_dokumenty kd ON z.zagadnienie_id=kd.zagadnienie_id AND kd.plik_id=z.nr_pliku 
                      AND p.tabela ='rs_wf_zagadnienia_pliki'
                      WHERE {warunek};""".format(**locals())

        rsglobal.ZapiszDoLogow(SQLPliki)
        stat, Pliki, PlikiWyn1, dump = self.PolSQL.Execute(SQLPliki, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania plikw dla zgoszenia: {stat}".format(**locals())

    if stat == 'OK':
        SQLKomentarze = """SELECT komentarz_id, komentarz, to_char(wprowadzenie_czas, 'YYYY-MM-DD HH24:MI:SS') AS wprowadzenie_czas, CONCAT(wprowadzenie_kto, ' - ', opw.nazwisko , ' ', opw.imie) AS wprowadzenie_kto, 
                                  to_char(modyfikacja_czas, 'YYYY-MM-DD HH24:MI:SS') AS modyfikacja_czas, CONCAT(modyfikacja_kto, ' - ', opm.nazwisko , ' ', opm.imie) AS modyfikacja_kto
                           FROM rs_wf_zagadnienia_komentarze z
                           JOIN rs_operatorzy opm ON modyfikacja_kto = opm.operator_id
                           JOIN rs_operatorzy opw ON wprowadzenie_kto = opw.operator_id
                           WHERE {warunek}
                           ORDER BY wprowadzenie_czas ASC;""".format(**locals())

        rsglobal.ZapiszDoLogow(SQLKomentarze)
        stat, Komentarze, KomentarzeWyn1, dump = self.PolSQL.Execute(SQLKomentarze, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania komentarzy do zgoszenia: {stat}".format(**locals())

    if stat == 'OK':
        SQLPrzebieg = """SELECT to_char(zmiana_czas, 'YYYY-MM-DD HH24:MI:SS') AS zmiana_czas, 
                                CONCAT(zmiana_kto, ' - ', op.nazwisko , ' ', op.imie) AS zmiana_kto, zmiana_co, zmiana_wartosc
                        FROM rs_wf_zagadnienia_historia z
                        JOIN rs_operatorzy op ON zmiana_kto = op.operator_id
                        WHERE {warunek}
                        ORDER BY zmiana_czas DESC;""".format(**locals())

        rsglobal.ZapiszDoLogow(SQLPrzebieg)
        stat, Historia, HistoriaWyn1, dump = self.PolSQL.Execute(SQLPrzebieg, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd pobierania przebiegu zgoszenia: {stat}".format(**locals())

    if stat == 'OK':
        #WS 2022-01-26 - dowod_ksiegowy, okres_dowodu_ksiegowego
        #AB 05.05.23r dodany nip
        #WS 2023-07-07 - zaliczka
        #WS 2023-08-16 - zaliczka_id_akcept
        SQLZagadnienie = """SELECT zagadnienie_id, rwz.operator_id, CONCAT(op.nazwisko , ' ', op.imie) AS operator_opis,
                       dokument_id, dok.opis AS dokument_opis, komorka_id, kom.opis AS komorka_opis, rwz.stan, stan.opis AS stan_opis, tagi, 
                       temat, rwz.opis, COALESCE(rwz.kwota_brutto, 0) AS kwota_brutto, rwz.kontrahent_id, 
                       rwz.kontrahent_nazwa, rwz.kontrahent_adres, rwz.nip,
                       kontr.nazwa AS kontrahent_opis, 
                       to_char(wprowadzenie_czas, 'YYYY-MM-DD HH24:MI:SS') AS wprowadzenie_czas, CONCAT(wprowadzenie_kto,' - ', wpr.nazwisko, ' ', wpr.imie) AS wprowadzenie_kto , 
                       to_char(modyfikacja_czas, 'YYYY-MM-DD HH24:MI:SS') AS modyfikacja_czas, CONCAT(modyfikacja_kto,' - ', zmod.nazwisko, ' ', zmod.imie)  AS modyfikacja_kto, 
                       zamkniete, zaksiegowane, data_dokumentu, symbol_dokumentu,
                       COALESCE(dk.dowod_id ||'/'|| dk.nazwa_id ||'/'|| dk.data ||'/'|| dk.numer, '') AS dowod_ksiegowy,
                       dk.okres_id AS okres_dowodu_ksiegowego,
                       zaliczka_id || '/' || zaliczka_nr_poz AS zaliczka,
                       COALESCE(zaliczka_id_akcept::TEXT, '') AS zaliczka_id_akcept
                FROM rs_wf_zagadnienia rwz
                LEFT JOIN rs_kontrahenci kontr USING (firma_id, kontrahent_id)
                LEFT JOIN rs_operatorzy op     USING (operator_id)
                LEFT JOIN rs_wf_rodzaje_dokumentow dok ON (dok.firma_id, dok.kod)   = (rwz.firma_id, dokument_id)
                LEFT JOIN rs_komorki_zatrudniajace kom ON (kom.firma_id, kom.kod)   = (rwz.firma_id, komorka_id)
                LEFT JOIN rs_wf_stany_dokumentow  stan ON (stan.firma_id, stan.kod) = (rwz.firma_id, rwz.stan)
                LEFT JOIN rs_operatorzy wpr  ON rwz.wprowadzenie_kto = wpr.operator_id 
                LEFT JOIN rs_operatorzy zmod ON rwz.modyfikacja_kto  = zmod.operator_id 
                LEFT OUTER JOIN rs_dowody_ksiegowe dk USING (zagadnienie_id)
                WHERE zagadnienie_id = {zagadnienie_id}
                ;""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLZagadnienie)
        stat, Zagadnienie, ZagadnienieWyn1, dump = Execute(self, SQLZagadnienie, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych zagadnienia: ' + stat
        elif len(Zagadnienie) == 0:
            stat = 'Nie odnaleziono zagadnienia {zagadnienie_id}.'.format(**locals())
    dane = [{'Zagadnienie': [Zagadnienie, ZagadnienieWyn1],
             'Pliki':       [Pliki,       PlikiWyn1],
             'Komentarze':  [Komentarze,  KomentarzeWyn1],
             'Historia':    [Historia,    HistoriaWyn1]
             }]
    wyn1 = tylko_przegladanie
