# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_zagadnienia_dane_dekret.py
# Purpose:     Dodawanie i edycja dowodw ksigowych w oparciu o zagadnienie, forma uproszczona
# Author:      Aleksander Bargie
# Created:     2022/05/12
# RCS-ID:      $Id: fs_wf_zagadnienia_dane_dekret.py $
# Copyright:   (c) 2022 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2023-01-03  Aleksander Bargie (13292) - Blad dekretu w zagadnieniach
# 2023-02-03  Aleksander Bargie (13340) - zmieni komunikat

import rsglobal
from funkcje import fs_okresy_pom
from funkcje import fs_wf_zagadnienia_pom as pom

from datetime import datetime, timedelta

"""
303000 Przegldanie
"""

"""Funkcje:
"""

Puste = ('', '    -  -  ', '-  -', None, 'None', 'NULL')

stat = "OK"
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'zagadnienie_id': [1, 5, 6, 10, 15, 16], 'naglowek': [1, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga : wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista

dane          = []
wyn1          = []
wyn2          = []
naglowek_dane = []
naglowek_wyn1 = []
firma_id      = self.firma_id
okr           = self.okres_id


def PodajOpisKonta(self, konto, Okres):
    rsglobal.ZapiszDoLogow("konto {} okres {}".format(konto, Okres))
    kontos = konto.split("-")[0]
    kontoa = konto[len(kontos)+1:30].strip()
    slq_konto  = "SELECT * FROM rs_plan_kont "
    slq_konto += "WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND kontos_id='"+kontos+"' "
    slq_konto += "ORDER BY konto_id;"
    stat, dane_konta, nagl_konta, dump = self.PolSQL.Execute(slq_konto, 3, CzyDodawacBlad=True)
    if len(dane_konta) == 0:
        rsglobal.ZapiszDoLogow("return 1")
        return ''

    wp = rssql.RSTableRowset(dane_konta, nagl_konta)

    kontocz = ""
    kontor = kontoa
    wynik =-1
    nazwakr=""
    for i in range(len(dane_konta)):
        KontoPoz=wp.GetVal(i, 'konto_id')
        if KontoPoz=="":
            pocz = wp.GetVal(i, 'nazwa')
        if KontoPoz == kontocz:
            wynik = i
            if KontoPoz != "":
                nazwakr=wp.GetVal(i, 'nazwa')
            if kontor != "":
                gdzie = kontor.find("-")
                if gdzie > -1:
                    kontocz = kontocz+"-"+kontor[0:gdzie]
                    kontor = kontor[gdzie+1:len(kontor)]
                else:
                    kontocz= kontocz+"-"+kontor
                    kontor=""
                kontocz=kontocz.strip("-")

    #jeli konto cae znalezione
    if wp.GetVal(wynik, 'konto_id')==kontoa:
        rsglobal.ZapiszDoLogow("return 2")
        if wp.GetVal(wynik, 'konto_id') != "":
            return wp.GetVal(wynik, 'nazwa')
        else:
            return pocz
        
    #nie jest to konto znalezione w caoci po drodze, ani konto z grupami
    if (not wp.GetVal(wynik, 'konto_id')==kontoa) and (wp.GetVal(wynik, 'grupa1')==None):
        rsglobal.ZapiszDoLogow("return 3")
        return ''

    #pobranie danych grup analitycznych
    sql_grupy  = "SELECT * FROM rs_grupy_analityczne WHERE firma_id='{}' AND okres_id='{}';".format(self.firma_id, Okres)
    rsglobal.ZapiszDoLogow(sql_grupy)
    stat, dane_grup, nagl_grup, dump = self.PolSQL.Execute(sql_grupy, 3, CzyDodawacBlad=True)
    if len(dane_grup) == 0:
        rsglobal.ZapiszDoLogow("return 4")
        return ''
    danegr = rssql.RSTableRowset(dane_grup, nagl_grup)

    #--- petla po grupach. wszystko musi sie zgadzac
    i = 1

    #ze wzgledu na zmiane algorytmu musimy pobrac jeszcze raz kontor
    # poniewaz powyzej nie wyszedl z funkcji wiec wiemy, ze mamy grupy analityczne

    kontor=kontoa[len(wp.GetVal(wynik, 'konto_id')):]
    kontor=kontor.strip("-").strip()
    rsglobal.ZapiszDoLogow("wp.GetVal(wynik, ) {}".format(wp.GetVal(wynik, "grupa"+str(i)), "grupa"+str(i)))

    while i < 6 and kontor != "" and wp.GetVal(wynik, "grupa"+str(i)) is not None:
        grupa = wp.GetVal(wynik, "grupa"+str(i))
        gdzie = kontor.find("-")
        if gdzie > -1:
            kod = kontor[0:gdzie]
            kontor = kontor[gdzie+1:len(kontor)]
            kontor=kontor.strip()
        else:
            kod = str(kontor)
            kontor = ""
        rsglobal.ZapiszDoLogow("kontor {}".format(repr(kontor)))

        if len(dane_grup) == 0:
            rsglobal.ZapiszDoLogow("return 5")
            rsglobal.ZapiszDoLogow(str(danegr))
            return ''

        wybrany=[]
        rsglobal.ZapiszDoLogow("grupa {}".format(grupa))
        for j in xrange(len(dane_grup)):
            if danegr.GetVal(j, "grupa_id") == grupa:
                wybrany=j

        if wybrany==[]:
            rsglobal.ZapiszDoLogow("return 6")
            return ""

        if danegr.GetVal(wybrany, "kontrahenci"):
            FiltrK=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kod+"'"
            FOdb=""
            if danegr.GetVal(wybrany, "odbiorcy"):
                if FOdb=="":
                    FOdb+=" AND (odbiorca"

            if danegr.GetVal(wybrany, "dostawcy"):
                if FOdb=="":
                    FOdb+=" AND (dostawca"
                else:
                    FOdb+=" OR dostawca"

            if danegr.GetVal(wybrany, "pracownicyk"):
                if FOdb=="":
                    FOdb+=" AND (pracownik"
                else:
                    FOdb+=" OR pracownik"

            if danegr.GetVal(wybrany, "inni"):
                if FOdb=="":
                    FOdb+=" AND (inny"
                else:
                    FOdb+=" OR inny"

            if FOdb != "":
                FOdb+=")"


            stat, kontr_dane, kontr_nagl, dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci "+FiltrK+FOdb+";", 3)
            kontr = rssql.RSTableRowset(kontr_dane, kontr_nagl)
            #return "SELECT nazwa FROM rs_kontrahenci "+FiltrK+FOdb+";"+str(len(kontr))
            if len(kontr) == 0:
                rsglobal.ZapiszDoLogow("return 7")
                return ""
            else:
                nazwakr= kontr.GetVal(0, 'nazwa')


        if danegr.GetVal(wybrany, "pracownicy"):
            pass

        if danegr.GetVal(wybrany, "zlecenia"):
            stat, zlec_dane, zlec_nagl, dump  = self.PolSQL.Execute("SELECT opis FROM rs_numery_zlecen WHERE firma_id='"+self.firma_id+"' AND kod='"+kod+"';", 3)
            zlec = rssql.RSTableRowset(zlec_dane, zlec_nagl)
            if len(zlec) == 0:
                rsglobal.ZapiszDoLogow("return 8")
                return ""
            else:
                nazwakr= zlec.GetVal(0, 'opis')

        if danegr.GetVal(wybrany, "konta_kosztow"):
            stat, kk_dane, kk_nagl, dump  = self.PolSQL.Execute("SELECT opis FROM rs_konta_kosztow WHERE firma_id='"+self.firma_id+"' AND kod='"+kod+"';", 3)
            kk = rssql.RSTableRowset(kk_dane, kk_nagl)
            if len(kk) == 0:
                rsglobal.ZapiszDoLogow("return 9")
                return ""
            else:
                nazwakr= kk.GetVal(0, 'opis')

        if danegr.GetVal(wybrany, "magazyny"):
            stat, mag_dane, mag_nagl, dump  = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+kod+"';", 3)
            mag = rssql.RSTableRowset(mag_dane, mag_nagl)
            if len(mag) == 0:
                rsglobal.ZapiszDoLogow("return 10")
                return ""
            else:
                nazwakr= mag.GetVal(0, 'opis')

        if danegr.GetVal(wybrany, "oddzialy"):
            stat, oddzial_dane, oddzial_nagl, dump  = self.PolSQL.Execute("SELECT opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+kod+"';", 3)
            oddzial = rssql.RSTableRowset(oddzial_dane, oddzial_nagl)
            if len(oddzial_dane) == 0:
                rsglobal.ZapiszDoLogow("return 11")
                return ""
            else:
                nazwakr= oddzial.GetVal(0, 'opis')

        if danegr.GetVal(wybrany, "stawki_vat"):
            stat, stawkaVAT_dane, stawkaVAT_nagl, dump  = self.PolSQL.Execute("SELECT opis FROM rs_stawki_vat WHERE kod='"+kod+"';", 3)
            stawkaVAT = rssql.RSTableRowset(stawkaVAT_dane, stawkaVAT_nagl)
            if len(stawkaVAT_dane) == 0:
                rsglobal.ZapiszDoLogow("return 12")
                return ""
            else:
                nazwakr= stawkaVAT.GetVal(0, 'opis')

        if danegr.GetVal(wybrany, "lista"):
            stat, lista_dane, lista_nagl, dump  = self.PolSQL.Execute("SELECT nazwa FROM rs_konta_analityczne WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND grupa_id='"+grupa+"' AND kontoa_id='"+kod+"';", 3)
            lista = rssql.RSTableRowset(lista_dane, lista_nagl)
            if len(lista_dane) == 0:
                rsglobal.ZapiszDoLogow("return 13")
                return ""
            else:
                nazwakr= lista.GetVal(0, 'nazwa')

        if danegr.GetVal(wybrany, "dzialy_firmy"):
            stat, dzial_dane, dzial_nagl, dump  = self.PolSQL.Execute("SELECT opis FROM rs_dzialy_firmy WHERE firma_id='"+self.firma_id+"' AND kod='"+kod+"';", 3)
            dzial = rssql.RSTableRowset(dzial_dane, dzial_nagl)
            if len(dzial_dane) == 0:
                rsglobal.ZapiszDoLogow("return 14")
                return ""
            else:
                nazwakr= dzial.GetVal(0, 'opis')

        if danegr.GetVal(wybrany, "projekty"):
            stat, proj_dane, proj_nagl, dump  = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+kod+"';", 3)
            proj = rssql.RSTableRowset(proj_dane, proj_nagl)
            if len(proj_dane) == 0:
                rsglobal.ZapiszDoLogow("return 15")
                return ""
            else:
                nazwakr= proj.GetVal(0, 'nazwa')

        i=i+1

    #--- nie cale konto znalezione (za dlugie w stosunku do ilosci grup)
    rsglobal.ZapiszDoLogow("kontor {}".format(repr(kontor)))
    if kontor != "":
        rsglobal.ZapiszDoLogow("return 16")
        return ""

    if str(nazwakr)=="None":
        nazwakr=""

    rsglobal.ZapiszDoLogow("return 17")
    return nazwakr


if stat == 'OK':
    if Fun in (1, ):
        naglowek = klucze['naglowek']

    if Fun in (1, 5, 6, 10, 15, 16):
        zagadnienie_id = klucze['zagadnienie_id']
        wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                    VALUES('{}', {}, NOW(), rsf_getuserid(), '{}', '{}');
                    """.format(firma_id, zagadnienie_id, '{}', '{}')

if stat == 'OK' and Fun in (1, 5, 6, 10):
    SQLZAG = """SELECT z.firma_id, z.dokument_id, z.stan, dk.stan as stan_dow, z.temat, z.kontrahent_id, z.komorka_id, 
                       z.zamkniete, z.zaksiegowane, z.kwota_brutto, z.data_dokumentu, z.symbol_dokumentu
                FROM rs_wf_zagadnienia z
                FULL OUTER JOIN rs_dowody_ksiegowe dk USING (zagadnienie_id)                
                WHERE z.zagadnienie_id=%s;
                    """
    args = [zagadnienie_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLZAG, args))
    stat, dane_zag, nagl_zag, dump = self.PolSQL.Execute(SQLZAG, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych zagadnienia: {}".format(stat)
    elif len(dane_zag) > 0:
        DaneZag = rssql.RSTableRowset(dane_zag, nagl_zag)
        firma_id         = DaneZag.GetVal(0, "firma_id")
        dokument_id      = DaneZag.GetVal(0, "dokument_id")
        stan             = DaneZag.GetVal(0, "stan")
        stan_dow         = DaneZag.GetVal(0, "stan_dow")
        temat            = DaneZag.GetVal(0, "temat")
        kontrahent_id    = DaneZag.GetVal(0, "kontrahent_id")
        komorka_id       = DaneZag.GetVal(0, "komorka_id")
        zamkniete        = DaneZag.GetVal(0, "zamkniete")
        zaksiegowane     = DaneZag.GetVal(0, "zaksiegowane")
        kwota_brutto     = DaneZag.GetVal(0, "kwota_brutto")
        data_dokumentu   = DaneZag.GetVal(0, "data_dokumentu")
        symbol_dokumentu = DaneZag.GetVal(0, "symbol_dokumentu")
    else:
        stat = "Nie odnaleziono zagadnienia {}".format(zagadnienie_id)

    #  wstepne sprawdzenie czci danych

    if stat == 'OK' and firma_id != self.firma_id:
        stat = "Zagadnienie {} nie jest z firmy {}".format(zagadnienie_id, self.firma_id)

if stat == 'OK' and Fun == 5:
    # trzeba doda dk
    if stat == 'OK' and not zaksiegowane:
        if kontrahent_id in Puste:
            stat = "Brak kontrahenta w zagadnieniu"
        if stat == 'OK' and stan in Puste:
            stat = "Brak stanu w zagadnieniu"
        if stat == 'OK' and komorka_id in Puste:
            stat = "Brak komrki w zagadnieniu"
        if stat == 'OK' and data_dokumentu in Puste:
            stat = "Brak daty dokumentu w zagadnieniu"
        if stat == 'OK' and kwota_brutto == 0:
            stat = "Kwota brutto musi by rna ni 0."
        if stat == 'OK' and symbol_dokumentu in Puste:
            stat = "Wymagane uzupenienie symbolu dokumentu."
        if stat == 'OK':
            stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja', stan,
                                          komorka_id, dokument_id, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
        if stat == 'OK':  # pobranie danych do dekretu
            SQLDekret = """SELECT dowod_id, nazwa_id 
                           FROM rs_kontrahenci_dekrety
                           WHERE firma_id = %s AND kontrahent_id = %s and dokument_kod = %s;"""
            args = [self.firma_id, kontrahent_id, dokument_id]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLDekret, args))
            stat, dane_dekret, nagl_dekret, dump = self.PolSQL.Execute(SQLDekret, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bad pobierania danych do dekretacji: {}".format(stat)
            elif len(dane_dekret) > 0:
                Dekret = rssql.RSTableRowset(dane_dekret, nagl_dekret)
                dowod_id = Dekret.GetVal(0, 'dowod_id')
                nazwa_id = Dekret.GetVal(0, 'nazwa_id')
            else:
                stat = "Nie odnaleziono danych jak dekretowa dokumenty {} dla kontrahenta {}".format(dokument_id, kontrahent_id)

        if stat == 'OK':  # pobranie zakresu dat dla ksiegowosci
            SQLZakres = """SELECT fk_od, fk_do 
                           FROM rs_zakresy_dat
                           WHERE firma_id = %s;"""
            args = [self.firma_id]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLZakres, args))
            stat, dane_zakres, nagl_zakres, dump = self.PolSQL.Execute(SQLZakres, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bad pobierania zakresu dat: {}".format(stat)
            elif len(dane_zakres) > 0:
                Zakres = rssql.RSTableRowset(dane_zakres, nagl_zakres)
                fk_od = Zakres.GetVal(0, 'fk_od')
                fk_do = Zakres.GetVal(0, 'fk_do')
            else:
                fk_od = None
                fk_do = None

        if stat == 'OK':
            data_ok = False
            data_dowodu = data_dokumentu
            while not data_ok:
                if fk_od not in Puste and data_dowodu < fk_od:
                    data_dowodu = fk_od
                if fk_do not in Puste and data_dowodu > fk_do:
                    stat = "Nie mona doda dowodu ksigowego z dat {}".format(data_dokumentu)  #AB 03.02.23r
                    break
                stat, Okres = fs_okresy_pom.PodajOkresDlaDaty(self, data_dowodu)
                if stat != 'OK':
                    break
                self.okres_id = Okres
                SQL = "SELECT rsf_sprawdz_czy_mozna_dodac_dokument(%s, %s,'D');"
                args = [self.firma_id, repr([str(Okres), str(dowod_id), str(nazwa_id), str(data_dowodu)])]
                rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
                stat, mozna, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd sprawdzania czy mona doda dokument: {}'.format(stat)
                elif mozna[0][0] != 'OK':
                    stat = 'Bd sprawdzania czy mona doda dokument: {}'.format(mozna[0][0])
                else:
                    data_ok = True

                if not data_ok:
                    data_dowodu = (datetime.strptime(data_dowodu, "%Y-%m-%d").date() + timedelta(days=1)).strftime("%Y-%m-%d")

        if stat == 'OK':
            Klucze = [dowod_id, nazwa_id, data_dowodu, None, False, None, None,
                      {'zagadnienie_id': zagadnienie_id, 'uproszczone': True}, 10]
            stat, klucz_dowodu, dump, dump = self.WykonajFunkcje("fs_dowody_ksiegowe_klucz", Klucze, [], [], False)

        if stat == 'OK':
            Klucze = [dowod_id, nazwa_id, data_dowodu, None, False, None, None,
                      {'zagadnienie_id': zagadnienie_id, 'uproszczone': True}, 12]
            stat, dump, dump, dump = self.WykonajFunkcje("fs_dowody_ksiegowe_klucz", Klucze, [], [], False)

        if stat == 'OK':
            rsglobal.ZapiszDoLogow(repr(klucz_dowodu))
            numer_dowodu = klucz_dowodu[3]  #AB 03.01.23r zmiana nr_fakt na symbol_dok
            SQL = """UPDATE rs_dowody_ksiegowe 
                     SET kontrahent_id = %s, symbol_dok = %s, data_wyst = %s, stan = 'M', tresc = %s
                     WHERE zagadnienie_id = %s;
                     UPDATE rs_dowody_ksiegowe_pozycje
                     SET tresc_ma= %s, tresc_wn=%s
                     WHERE (tresc_ma IS NULL OR tresc_ma  = '') 
                        AND (firma_id, okres_id, dowod_id, nazwa_id, data, numer) IN (SELECT firma_id, okres_id, dowod_id, nazwa_id, data, numer 
                                                                                       FROM rs_dowody_ksiegowe 
                                                                                       WHERE zagadnienie_id = %s);
                     UPDATE rs_dowody_ksiegowe_pozycje
                     SET konto_ma=concat(rtrim(trim(konto_ma), '-'), '-', %s), kwota_ma = %s, kwota_wal_ma = %s
                     WHERE konto_ma LIKE %s
                        AND (firma_id, okres_id, dowod_id, nazwa_id, data, numer) IN (SELECT firma_id, okres_id, dowod_id, nazwa_id, data, numer 
                                                                                       FROM rs_dowody_ksiegowe 
                                                                                       WHERE zagadnienie_id = %s);
                     """
            # SQL += wzor_hist.format("Utworzono dowd ksigowy", "{}/{}/{}/{}".format(klucz_dowodu[0], klucz_dowodu[1],
            #                                                                          klucz_dowodu[2], klucz_dowodu[3]))

            args = [kontrahent_id, symbol_dokumentu, data_dokumentu, temat,  zagadnienie_id, temat, temat,
                    zagadnienie_id, kontrahent_id, kwota_brutto, kwota_brutto, '200%', zagadnienie_id]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd aktualizacji danych dowodu ksigowego: {}'.format(stat)


def Execute(self, zapytanie, tryb):
    rsglobal.ZapiszDoLogow(zapytanie)
    return self.PolSQL.Execute(zapytanie, tryb, CzyDodawacBlad=True)


# ---------------------------------------------------------------------------------------------------------------------
#                                          1 - Edycja danych zagadnienia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, ):
    Update = klucze['Update']
    WierszeNr = Update[-1]
    UPD = ""
    upd_args = []
    for i in xrange(len(Update[0])):
        wartosci = Update[1][i]
        pola     = Update[0][i]
        nr_poz  = str(Update[2][i][Update[3].index('nr_poz')])
        nr_ppoz = str(Update[2][i][Update[3].index('nr_ppoz')])
        kwota_wn = wartosci[pola.index('kwota_wn')] if 'kwota_wn' in pola else None
        UPD += """ UPDATE rs_dowody_ksiegowe_pozycje 
                   SET kwota_wn = %s, kwota_wal_wn = %s
                   WHERE (firma_id, okres_id, dowod_id, nazwa_id, data, numer) 
                      IN (SELECT firma_id, okres_id, dowod_id, nazwa_id, data, numer 
                          FROM rs_dowody_ksiegowe 
                          WHERE zagadnienie_id = %s) AND nr_poz = %s AND nr_ppoz = %s;
               """
        upd_args += [kwota_wn, kwota_wn, zagadnienie_id, nr_poz, nr_ppoz]
    if UPD:
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(UPD, upd_args))
        stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, upd_args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd aktualizacji pozycji dowodu ksigowego: {}'.format(stat)

    if stat == 'OK' and 'termin_plat' in naglowek:
        UPD = """ UPDATE rs_dowody_ksiegowe 
                  SET termin_plat = %s
                  WHERE zagadnienie_id = %s;
              """
        upd_args = [str(naglowek['termin_plat']) if str(naglowek['termin_plat']) not in Puste else None, zagadnienie_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(UPD, upd_args))
        stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, upd_args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd aktualizacji nagwka dowodu ksigowego: {}'.format(stat)


# ---------------------------------------------------------------------------------------------------------------------
#                            POBRANIE DANYCH (1 - update, 5 - select)
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 5, ):

    if Fun in (1, 3, 5):
        if stat == 'OK':
            stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'cokolwiek', stan,
                                          komorka_id, dokument_id, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
            if stat == 'Operator posiada uprawnienia tylko do przegldania.':
                stat = 'OK'

    if stat == 'OK':  #AB 03.01.23r zmiana nr_fakt na symbol_dok
        SQL = """SELECT dk.kontrahent_id || ' - ' || k.nazwa AS kontrahent, dk.tresc, dk.symbol_dok, z.kwota_brutto, 
                        dk.termin_plat, dk.stan, dk.data, dk.okres_id
                 FROM rs_dowody_ksiegowe dk
                 JOIN rs_wf_zagadnienia z USING(zagadnienie_id)
                 FULL OUTER JOIN rs_kontrahenci k ON (dk.firma_id, dk.kontrahent_id) = (k.firma_id, k.kontrahent_id)
                 WHERE dk.zagadnienie_id=%s;"""
        args = [zagadnienie_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, naglowek_dane, naglowek_wyn1, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat  != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
        elif len(naglowek_dane) <1:
            stat = "Nie udao si pobra danych dowodu ksigowego."
        else:
            nagl = rssql.RSTableRowset(naglowek_dane, naglowek_wyn1)
            stan = nagl.GetVal(0, 'stan')
            okres_id = nagl.GetVal(0, 'okres_id')
            if stan != 'M':
                stat = 'Dowd nie jest w stanie \'M\''

    if stat == 'OK':
        SQL = """SELECT nr_poz::INT, konto_wn, dp.kwota_wn, nr_ppoz
                 FROM rs_dowody_ksiegowe d
                 JOIN rs_dowody_ksiegowe_pozycje dp USING (firma_id, okres_id, dowod_id, nazwa_id, data, numer) 
                 WHERE zagadnienie_id=%s AND konto_wn LIKE %s
                 ORDER BY nr_poz, nr_ppoz;"""
        args = [zagadnienie_id, '5%']
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat  != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
        else:
            for wiersz in dane:
                opis, opis2 = '', ''
                konto = wiersz[1].strip('- ')
                opis2 = PodajOpisKonta(self, konto, okres_id)
                rsglobal.ZapiszDoLogow("opis {} dla konta {}".format(opis2, konto))
                if len(konto.strip('- ').split('-')) > 1:
                    konto = '-'.join(konto.split('-')[:-1]).strip('- ')
                    opis = PodajOpisKonta(self, konto, okres_id)
                    rsglobal.ZapiszDoLogow("opis {} dla konta {}".format(opis, konto))
                opisy = "{}, {}".format(opis, opis2).strip(', ')
                wiersz[1] = opisy



    wyn1 = [{'naglowek': [naglowek_dane, naglowek_wyn1]
             }]

self.okres_id = okr


# ---------------------------------------------------------------------------------------------------------------------
#                            ZDJECIE BLOKADY DOWODU KSIEGOWEGO (16)
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (16, ):
    klucze = ['DowKsieg', [], 2]
    stat, dump, dump, dump = self.WykonajFunkcje("fs_select_for_update", klucze, [], [], False)

    if stat != 'OK':
        RSMess.RSFakt('Bd zdejmowania zabezpieczenia z dowodu ksigowego.')


# ---------------------------------------------------------------------------------------------------------------------
#                            BLOKADA DOWODU KSIEGOWEGO (15)
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (15, ):
    SQL = """SELECT okres_id, dowod_id, nazwa_id, data, numer, stan
                 FROM rs_dowody_ksiegowe
                 WHERE zagadnienie_id=%s;"""
    args = [zagadnienie_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, naglowek_dane, naglowek_wyn1, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat  != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
    elif len(naglowek_dane) == 1:
        nagl = rssql.RSTableRowset(naglowek_dane, naglowek_wyn1)
        okres_id = nagl.GetVal(0, 'okres_id')
        dowod_id = nagl.GetVal(0, 'dowod_id')
        nazwa_id = nagl.GetVal(0, 'nazwa_id')
        data     = nagl.GetVal(0, 'data')
        numer    = nagl.GetVal(0, 'numer')
        stan     = nagl.GetVal(0, 'stan')
        if stan != 'M':
            stat = 'Dowd nie jest w stanie \'M\''
        if stat == 'OK':
            Klucze = ['DowKsieg', [dowod_id, nazwa_id, data, numer, okres_id], 1]
            stat, dump, dump, dump = self.WykonajFunkcje("fs_select_for_update", Klucze, [], [], False)
            if stat != 'OK':
                stat = 'Nie mona edytowa dowodu ksigowego {}/{}/{}/{}[{}] poniewa jest przez kogo zablokowany.'.format(dowod_id, nazwa_id, data, numer, okres_id)
                klucze = ['DowKsieg', [], 2]
                stat, dump, dump, dump = self.WykonajFunkcje("fs_select_for_update", klucze, [], [], False)

                if stat != 'OK':
                    RSMess.RSFakt('Bd zdejmowania zabezpieczenia z dowodu ksigowego.')


# ---------------------------------------------------------------------------------------------------------------------
#                            USUWANIE DK DO ZAGADNIENIA (6)
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (6, ):
    stat = pom.SprawdzUprawnienia(self, firma_id, self.operator_id, zagadnienie_id, 'modyfikacja', stan,
                                      komorka_id, dokument_id, STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)
    if stat == 'OK' and stan_dow != 'M':
        stat = 'Dowd nie jest w stanie \'M\''
    if stat == 'OK':
        SQL = """SELECT TRIM(dowod_id), TRIM(nazwa_id), data, numer::INT
                 FROM rs_dowody_ksiegowe
                 WHERE zagadnienie_id = %s;"""
        args = [zagadnienie_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, dk, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            "Bad pobierania danych dowodu: " + stat
        elif len(dk) <1:
            stat = "Nie odnaleziono dowodu do usunicia"
    if stat == 'OK':
        klucz_dowodu = dk[0]
        SQL = """DELETE FROM rs_dowody_ksiegowe WHERE zagadnienie_id = %s;
                 UPDATE rs_wf_zagadnienia SET zaksiegowane = FALSE WHERE zagadnienie_id = %s;"""
        SQL += wzor_hist.format("Usunito pusty dekret", "{}/{}/{}/{}".format(klucz_dowodu[0], klucz_dowodu[1],
                                                                                 klucz_dowodu[2], klucz_dowodu[3]))
        args = [zagadnienie_id, zagadnienie_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd usuwania dowodu ksigowego: "+stat


# ---------------------------------------------------------------------------------------------------------------------
#                            POBRANIE CZY KONTRAHENT OBSLUGUJE DEKRET DANEGO ZAGADNIENIA (10)
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (10, ):
    SQL = """SELECT EXISTS(SELECT *
             FROM rs_kontrahenci_dekrety
             WHERE firma_id=%s AND kontrahent_id=%s AND dokument_kod=%s AND dowod_id IS NOT NULL 
                AND nazwa_id IS NOT NULL AND TRIM(dowod_id) != '' AND TRIM(nazwa_id) != ''
             );"""
    args = [firma_id, kontrahent_id, dokument_id]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat  != 'OK':
        stat = "Bd sprawdzania moliwoci dekretacji przez kontrahenta: "+stat
    else:
        dane = dane[0]

