# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_zaliczki.py
# Purpose:     Obsuga grida zaliczek
# Author:      Wojciech Skowron
# Created:     2023/06/22
# RCS-ID:      $Id: fs_wf_zaliczki.py $
# Copyright:   (c) 2023 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2023-09-14 Wojciech Skowron - (13545) Zmiana w uprawnieniach
# 2023-10-23 Wojciech Skowron - (13585) Funkcja zmiany stanu na R/K (7)
# 2024-01-29 Wojciech Skowron - (13669) Spr czy jest zagadnienie (10), zamykanie zagadnienia przy anulowaniu

from funkcje import fs_wf_zagadnienia_pom

import rsglobal

"""
Funkcje:
5 - Pobranie danych
6 - Anulowanie zaliczki
7 - Zmiana stanu na R/K
 """

"""
305000 Zaliczki
305200 Modyfikacja
"""

stat = 'UPR_PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrz = ((self.oddzial_id, '305000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod = ((self.oddzial_id, '305200') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


Puste = (None, '', '    -  -  ', 'None', '-  -', [])
KontrahentPracownikOp = []
KontrahenciZaliczkiOp = []
ListaPrac = []
SQLListaPrac = 'NULL'

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Zaliczka': [6,7,11], 'StanF': [5,6,7], 'DataOdF': [5,6,7], 'DataDoF': [5,6,7],
             'PracownikF': [5,6,7], 'NowaZaliczkaF': [5,6,7], 'ZamykacZagadnienie': [6], 'ZmienNaStan': [7]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_zaliczki z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK' and Funkcja in (5, 6, 7, ):
    StanF = klucze['StanF']
    DataOdF = klucze['DataOdF']
    DataDoF = klucze['DataDoF']
    PracownikF = klucze['PracownikF']
    NowaZaliczkaF = klucze['NowaZaliczkaF']

if stat == 'OK' and Funkcja in (6, ):
    ZamykacZagadnienie = klucze['ZamykacZagadnienie']  #WS 2024-01-29

if stat == 'OK' and Funkcja in (6, 7, 11, ):
    Zaliczka = klucze['Zaliczka']

if stat == 'OK' and Funkcja in (7, ):
    ZmienNaStan = klucze['ZmienNaStan']  #WS 2023-10-23


# -------------------------------------------------------------------------------
# --------------------   POBRANIE LISTY PRACOWNIKW(10)  ------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, 6, 7, 10, ):
    SQL = """SELECT COALESCE(kontrahent_pracownik, ''), COALESCE(kontrahenci_zaliczki, '')
             FROM rs_operatorzy
             WHERE operator_id=%s;"""
    zmienne = [self.operator_id]

    rsglobal.ZapiszDoLogow('Operator zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
    stat, d_op, wyn1, dump = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        stat = 'Bd pobrania danych operatora'
    else:
        KontrahentPracownikOp = [str(d_op[0][0]).strip()] if d_op[0][0] not in Puste else []
        KontrahenciZaliczkiOp = d_op[0][1].split(',') if d_op[0][1] not in Puste else []

        #WS 2023-09-14
        if len(KontrahenciZaliczkiOp+KontrahentPracownikOp) > 0:
            ListaPrac = [str(prac) for prac in KontrahenciZaliczkiOp+KontrahentPracownikOp]
            SQLListaPrac = "%s,"*len(KontrahenciZaliczkiOp+KontrahentPracownikOp)
            SQLListaPrac = SQLListaPrac.strip(',')
        # if len(PracownicyAkcept) > 0:
        #     ListaPrac = [str(prac) for prac in PracownicyAkcept]
        #     SQLListaPrac = "%s,"*len(PracownicyAkcept)
        elif self.operator_id == STANDARD_OPERATOR_ID or UprPrz > 0:
            SQLListaPrac = 'z.kontrahent_id'
        else:
            SQLListaPrac = 'NULL'

        if Funkcja == 10:
            dane = d_op


# -------------------------------------------------------------------------------
# --------------------   ANULOWANIE Z POBRANIEM(6)   ----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (6, ):
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        #WS 2024-01-29 - zagadnienie_id
        SQL = "SELECT rk_o_kasa_bank_id, kontrahent_id, zagadnienie_id FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
        zmienne = [Zaliczka]

        rsglobal.ZapiszDoLogow('Spr rk o zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_rko, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania danych przed anulowaniem zaliczki'
        elif self.operator_id != STANDARD_OPERATOR_ID and d_rko[0][1].strip() not in KontrahentPracownikOp:
            stat = 'BL_ANUL_KONTR$'+d_rko[0][1]
        elif d_rko[0][0] not in Puste:
            stat = 'BL_ANUL_RKO'
        else:
            #WS 2024-01-29 - zamknicie zagadnienia lub usunicie klucza zaliczki
            zagadnienie_id = d_rko[0][2]
            if zagadnienie_id != 0:
                wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                                       VALUES('{}', %s, NOW() + INTERVAL '{} microseconds', rsf_getuserid(), '{}', %s);
                                       """.format(self.firma_id, '{}', '{}')

                stat, poprzednie = fs_wf_zagadnienia_pom.PoprzednieDaneZagadnienia(self, self.firma_id, zagadnienie_id)
                if stat == 'OK':
                    if ZamykacZagadnienie:
                        stat = fs_wf_zagadnienia_pom.SprawdzUprawnienia(self, self.firma_id, self.operator_id, zagadnienie_id,
                                                                        'zamykanie',
                                                                        poprzednie['stan'], poprzednie['komorka_id'],
                                                                        poprzednie['dokument_id'],
                                                                        STANDARD_OPERATOR_ID=STANDARD_OPERATOR_ID)

                        if stat == 'OK':
                            ZAMKZAG = """UPDATE rs_wf_zagadnienia SET zamkniete=TRUE WHERE zagadnienie_id=%s;"""
                            zmienne = [zagadnienie_id]
                            rsglobal.ZapiszDoLogow('Zamknicie zagadnienia: '+self.PolSQL.Mogrify(ZAMKZAG, zmienne))
                            stat, dump, dump, dump = self.PolSQL.Execute(ZAMKZAG, 1, zmienne)
                            if stat != 'OK':
                                stat = "Bd zamykania zagadnienia: {stat}".format(**locals())
                            else:
                                stat = fs_wf_zagadnienia_pom.AktualizujaOstatniaAktywnosc(self, self.firma_id, zagadnienie_id)

                            if stat == 'OK':
                                INSHISTORIA = wzor_hist.format(0, "Anulowano zaliczk")
                                INSHISTORIA += wzor_hist.format(1, "Zamknito zagadnienie")
                                zmienne = [zagadnienie_id, poprzednie['zaliczka_id_akcept'],
                                           zagadnienie_id, '']
                                rsglobal.ZapiszDoLogow('Zmiana historii zagadnienia: '+self.PolSQL.Mogrify(INSHISTORIA, zmienne))
                                stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, zmienne)
                                if stat != 'OK':
                                    stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())
                    else:
                        SQL = "UPDATE rs_wf_zagadnienia SET zaliczka_id_akcept=NULL WHERE zagadnienie_id=%s;"
                        zmienne = [zagadnienie_id]
                        rsglobal.ZapiszDoLogow('Usunicie klucza zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
                        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
                        if stat != 'OK':
                            rsglobal.ZapiszDoLogow(stat)
                            stat = 'Bd usuwania klucza zaliczki'

                        if stat == 'OK':
                            INSHISTORIA = wzor_hist.format(0, "Anulowano zaliczk")
                            zmienne = [zagadnienie_id, poprzednie['zaliczka_id_akcept']]
                            rsglobal.ZapiszDoLogow('Zmiana historii zagadnienia: '+self.PolSQL.Mogrify(INSHISTORIA, zmienne))
                            stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, zmienne)
                            if stat != 'OK':
                                stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

            if stat == 'OK':
                SQL = "UPDATE rs_wf_zaliczki SET stan='U' WHERE zaliczka_id=%s;"
                zmienne = [Zaliczka]
                rsglobal.ZapiszDoLogow('Anulowanie zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
                stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
                if stat != 'OK':
                    rsglobal.ZapiszDoLogow(stat)
                    stat = 'Bd anulowania zaliczki'


# -------------------------------------------------------------------------------
# -------------------   AKCEPTOWANIE Z POBRANIEM(7)   ---------------------------
# -------------------------------------------------------------------------------

# if stat == 'OK' and Funkcja in (7, ):
#     SQL = "SELECT kontrahent_id, stan FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
#     zmienne = [Zaliczka]
#
#     rsglobal.ZapiszDoLogow('Spr kontr zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
#     stat, d_kontr, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
#     if stat != 'OK':
#         rsglobal.ZapiszDoLogow(stat)
#         stat = 'Bd sprawdzania danych przed akceptacj zaliczki'
#     elif self.operator_id != STANDARD_OPERATOR_ID and d_kontr[0][0].strip() not in PracownicyAkcept:
#         stat = 'BL_AKCEPT_KONTR$'+d_kontr[0][0]
#     elif d_kontr[0][1] != 'W':
#         stat = 'BL_AKCEPT_STAN'
#     else:
#         SQL = "UPDATE rs_wf_zaliczki SET stan='A', akceptacja_czas=NOW(), akceptacja_operator=%s WHERE zaliczka_id=%s;"
#         zmienne = [self.operator_id, Zaliczka]
#
#         rsglobal.ZapiszDoLogow('Akcept zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
#         stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
#         if stat != 'OK':
#             rsglobal.ZapiszDoLogow(stat)
#             stat = 'Bd akceptowania zaliczki'

# -------------------------------------------------------------------------------
# -------------------------   ZMIANA STANU (7)   --------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (7, ):
    SQL = "SELECT kontrahent_id, stan FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
    zmienne = [Zaliczka]

    rsglobal.ZapiszDoLogow('Spr kontr zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
    stat, d_zal, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        stat = 'Bd sprawdzania danych przed zmian stanu zaliczki'
    elif self.operator_id != STANDARD_OPERATOR_ID and d_zal[0][0].strip() not in KontrahentPracownikOp:
        stat = 'BL_ZMIANA_STANU_KONTR'
    elif d_zal[0][1].strip() in ('R', 'K'):
        if d_zal[0][1].strip() == 'R':
            SQL = "UPDATE rs_wf_zaliczki SET stan='K' WHERE zaliczka_id=%s AND stan='R';"
            zmienne = [Zaliczka]
        else:
            SQL = "UPDATE rs_wf_zaliczki SET stan='R' WHERE zaliczka_id=%s AND stan='K';"
            SQL += "UPDATE rs_wf_zaliczki SET stan='Z' WHERE zaliczka_id=%s AND stan='R' AND saldo=0;"
            zmienne = [Zaliczka, Zaliczka]

        rsglobal.ZapiszDoLogow('Zmiana stanu zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd zmiany stanu zaliczki'


# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH(5, 6)   ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, 6, 7, ):
    if len(KontrahenciZaliczkiOp+KontrahentPracownikOp) == 0 and self.operator_id != STANDARD_OPERATOR_ID:
        stat = 'UPR_WYB'  #WS 2023-09-14
    else:
        zmienne = [self.firma_id]
        zmienne.extend(ListaPrac)

        Filtry = ''

        if StanF.strip() not in Puste:
            Filtry += "AND z.stan = %s"
            zmienne.append(StanF.strip())

        if PracownikF.strip() not in Puste and PracownikF.strip() in KontrahenciZaliczkiOp+KontrahentPracownikOp:
            Filtry += "AND z.kontrahent_id LIKE %s"
            zmienne.append(PracownikF.strip()+'%')

        if DataOdF not in Puste:
            Filtry += "AND z.data >= %s"
            zmienne.append(DataOdF)

        if DataDoF not in Puste:
            Filtry += "AND z.data <= %s"
            zmienne.append(DataDoF)

        if Filtry != '':
            Filtry = Filtry.strip('AND ')
            Filtry = " AND (("+Filtry+")"

            if NowaZaliczkaF not in Puste:
                Filtry += " OR z.zaliczka_id=%s)"
                zmienne.append(NowaZaliczkaF)
            else:
                Filtry += ")"

        SQL = """SELECT stan, data, zaliczka_id, k.nazwa AS pracownik, 
                        kwota_brutto, opis, 
                        op.login AS operator_akcept, to_char(akceptacja_czas, 'YYYY-MM-DD HH24:MI:SS'),
                        saldo, k.kontrahent_id AS pracownik_id
                 FROM rs_wf_zaliczki z
                 JOIN rs_kontrahenci k USING (firma_id, kontrahent_id)
                 LEFT OUTER JOIN rs_operatorzy op ON (z.akceptacja_operator=op.operator_id)
                 WHERE firma_id=%s AND z.kontrahent_id IN ({SQLListaPrac})
                       {Filtry}
                 ORDER BY data DESC, zaliczka_id DESC;""".format(**locals())

        rsglobal.ZapiszDoLogow('Zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dane, wyn1, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych zaliczek'

# -------------------------------------------------------------------------------
# --------------------   SPR CZY JEST ZAGADNIENIE(11)   -------------------------
# -------------------------------------------------------------------------------

#WS 2024-01-29
if stat == 'OK' and Funkcja in (11, ):
    SQL = "SELECT zagadnienie_id FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
    zmienne = [Zaliczka]
    stat, d_zag, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        stat = "Bd sprawdzania zagadnienia dla zaliczki: "+stat
    else:
        dane = d_zag[0]
