# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_zaliczki_dane.py
# Purpose:     Dodawanie i edycja nagwkw zaliczkek
# Author:      Wojciech Skowron
# Created:     2023/06/22
# RCS-ID:      $Id: fs_wf_zaliczki_dane.py $
# Copyright:   (c) 2023 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2023-11-10 Wojciech Skowron   (13598) Poprawiony numer uprawnie dla sownika rs_wf_rodzaje_dokumentow

import rsglobal
from funkcje import fs_wf_zagadnienia_pom


"""
305000 Zaliczki
305200 Modyfikacja
"""


stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}
aktualizowac_zagadnienie = False
edytowalne_ins = ['data', 'dokument_id', 'komorka_id', 'kwota_brutto', 'kontrahent_id', 'opis']
edytowalne_upd = ['dokument_id', 'komorka_id', 'kwota_brutto', 'kontrahent_id', 'opis']
pola_z_zagadnienia = ['dokument_id', 'komorka_id', 'kwota_brutto', 'kontrahent_id']

Puste = (None, '', '    -  -  ', 'None', '-  -', [])
KontrahentPracownikOp = []
ListaPrac = []
KontrahentZal = None

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Oddzial': [1, 2, 3, 4, 5, 10], 'Zaliczka': [3, 4, 5, 10],
             'PrzypnijDo': [1, 2, 10], 'StanZagadnienia': [1, 2, 10], 'TematZagadnienia': [1, 2, 10], 'OpisZagadnienia': [1, 2, 10],
             'TworzycZagadnienie': [1, 2]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_zaliczki_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 2, 3, 4, 5, 10]:
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])

    if Funkcja in [3, 4, 5, 10]:
        Zaliczka = rsglobal.Dekoduj(klucze['Zaliczka'])

    if Funkcja in [1, 2, 10]:
        PrzypnijDo = rsglobal.Dekoduj(klucze['PrzypnijDo'])
        StanZagadnienia = klucze['StanZagadnienia']
        TematZagadnienia = klucze['TematZagadnienia']
        OpisZagadnienia = klucze['OpisZagadnienia']

    if Funkcja in [1, 2]:
        TworzycZagadnienie = klucze['TworzycZagadnienie']

    if Funkcja == 10:
        TworzycZagadnienie = True

# -------------------------------------------------------------------------------
# ------------------   POBRANIE KONTRAHENTA/PRACOWNIKA   ------------------------
# -------------------------------------------------------------------------------

if stat == 'OK':
    SQL = """SELECT COALESCE(kontrahent_pracownik, ''), COALESCE(kontrahenci_zaliczki, '')
             FROM rs_operatorzy
             WHERE operator_id=%s;"""
    zmienne = [self.operator_id]

    rsglobal.ZapiszDoLogow('Operator zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
    stat, d_op, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        stat = 'Bd pobrania danych operatora'
    else:
        KontrahentPracownikOp = [str(d_op[0][0]).strip()] if d_op[0][0] not in Puste else []
        KontrahenciZaliczkiOp = d_op[0][1].split(',') if d_op[0][1] not in Puste else []

        if Funkcja not in (1, 2,):
            SQL = """SELECT kontrahent_id
                     FROM rs_wf_zaliczki
                     WHERE zaliczka_id=%s;"""
            zmienne = [Zaliczka]

            rsglobal.ZapiszDoLogow('Kontrahent zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
            stat, d_kontr, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd pobrania danych zaliczki'
            elif len(d_kontr) == 0:
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Zaliczka nie istnieje'
            else:
                KontrahentZal = d_kontr[0][0].strip()
        elif self.operator_id != STANDARD_OPERATOR_ID:
            KontrahentZal = KontrahentPracownikOp[0]

        #WS 2023-09-14
        if len(KontrahenciZaliczkiOp+KontrahentPracownikOp) > 0:
            ListaPrac = [str(prac) for prac in KontrahenciZaliczkiOp+KontrahentPracownikOp]
            SQLListaPrac = "%s,"*len(KontrahenciZaliczkiOp+KontrahentPracownikOp)
            SQLListaPrac = SQLListaPrac.strip(',')
        elif self.operator_id == STANDARD_OPERATOR_ID:
            SQLListaPrac = 'z.kontrahent_id'
        else:
            SQLListaPrac = 'NULL'


# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrz = (self.oddzial_id, '305000') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod = (self.oddzial_id, '305200') in self.uprawnienia and KontrahentZal in KontrahentPracownikOp or (self.operator_id == STANDARD_OPERATOR_ID)

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH (1, 3)   --------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR_MOD'

    if stat == 'OK' and Funkcja in (3, 4):
        SQL = "SELECT stan FROM rs_wf_zaliczki WHERE zaliczka_id=%s;"
        zmienne = [Zaliczka]

        rsglobal.ZapiszDoLogow('Spr stanu zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_stan, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania stanu przed usuniciem pozycji zaliczki'
        elif d_stan[0][0] != 'W':
            stat = 'BL_MOD_STAN'

    if stat == 'OK':
        kontrahent = ''
        nazwa = ''
        adres = ''

        for pole, wart in zip(pola, wartosci):
            if not aktualizowac_zagadnienie and pole in pola_z_zagadnienia:
                aktualizowac_zagadnienie = True
            if pole == 'data':
                if wart in Puste:
                    stat = 'BR_DATA'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA'
                    dane.append(stat)

            if pole == 'dokument_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_wf_rodzaje_dokumentow WHERE firma_id=%s AND kod=%s;"
                    zmienne = [self.firma_id, wart]
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, zmienne)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_DOKUMENT"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                elif Funkcja in (1, 2) and TworzycZagadnienie:
                    stat = "BR_DOKUMENT_ZAG"
                    dane.append(stat)

            elif pole == 'komorka_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_komorki_zatrudniajace WHERE firma_id=%s AND kod=%s;"
                    zmienne = [self.firma_id, wart]
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, zmienne)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KOMORKA"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                else:
                    stat = "BR_KOMORKA"
                    dane.append(stat)

            if pole == 'kwota_brutto':
                if wart <= 0:
                    stat = 'BR_KWOTA_ZALICZKI'
                    dane.append(stat)

            if pole == 'kontrahent_id':
                wart = wart.strip()
                if self.operator_id != STANDARD_OPERATOR_ID and KontrahentPracownikOp[0] in Puste:
                    stat = 'BR_PRACOWNIK'
                    dane.append(stat)
                elif self.operator_id == STANDARD_OPERATOR_ID and wart in Puste:
                    stat = 'BR_PRACOWNIK'
                    dane.append(stat)
                elif self.operator_id != STANDARD_OPERATOR_ID and KontrahentPracownikOp[0] != wart:
                    stat = 'BL_MOD_PRAC$'+wart
                    dane.append(stat)
                else:
                    SQL = "SELECT 1 FROM rs_kontrahenci WHERE firma_id=%s AND kontrahent_id=%s AND aktywny;"
                    zmienne = [self.firma_id, wart]
                    rsglobal.ZapiszDoLogow('Spr pracownika zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, zmienne)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_PRACOWNIK"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------------   INSERT (1)   ------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2):

    SQL = """SELECT nextval('rs_wf_zaliczki_zaliczka_id_seq');"""
    stat, d_zaliczka, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru nowej zaliczki: '+stat
        dane.append(stat)
    else:
        Zaliczka = d_zaliczka[0][0]

        INS = "INSERT INTO rs_wf_zaliczki "
        Pola = "firma_id, stan, zaliczka_id "
        Wartosci = "%s, 'W', %s "
        zmienne = [self.firma_id, Zaliczka]

        for pole, wart in zip(pola, wartosci):
            if pole in edytowalne_ins:
                Pola += ","+pole
                Wartosci += ",%s"
                if pole == 'kontrahent_id' and self.operator_id != STANDARD_OPERATOR_ID:
                    zmienne.append(KontrahentPracownikOp[0])
                else:
                    if wart not in Puste:
                        zmienne.append(str(wart))
                    else:
                        zmienne.append(None)

        INS += "("+Pola+") VALUES ("+Wartosci+");"

        rsglobal.ZapiszDoLogow('Ins zaliczki: '+self.PolSQL.Mogrify(INS, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, zmienne)
        rsglobal.ZapiszDoLogow(INS)
        if stat != 'OK':
            stat = 'Bd dodania danych: '+stat
            dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# --------------------------   UPDATE (3)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    UPD = "UPDATE rs_wf_zaliczki SET "
    zmienne = []

    for pole, wart in zip(pola, wartosci):
        if pole in edytowalne_upd:
            if pole != 'kontrahent_id' or self.operator_id == STANDARD_OPERATOR_ID:
                UPD += pole+"=%s,"
                if wart not in Puste:
                    zmienne.append(str(wart))
                else:
                    zmienne.append(None)

    UPD = UPD[0:-1]
    UPD += " WHERE firma_id=%s and zaliczka_id=%s;"
    zmienne.extend([self.firma_id, Zaliczka])

    rsglobal.ZapiszDoLogow('Upd zaliczki: '+self.PolSQL.Mogrify(UPD, zmienne))
    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, zmienne)
    rsglobal.ZapiszDoLogow(UPD)
    if stat != 'OK':
        stat = 'Bd modyfikacji danych:' + stat
        dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]

# -------------------------------------------------------------------------------
# -----------------   TWORZENIE ZAGADNIENIA PO INSERCIE (1)   -------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2, 10) and TworzycZagadnienie:
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        SQL = "SELECT stan FROM rs_wf_zaliczki WHERE firma_id=%s AND zaliczka_id=%s;"
        args = [self.firma_id, Zaliczka]
        rsglobal.ZapiszDoLogow('Spr przed tworzeniem zagadnienia: '+self.PolSQL.Mogrify(SQL, args))
        stat, d_stan, dump, dump = self.PolSQL.Execute(SQL, 3, args)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania stanu zaliczki przed tworzeniem zagadnienia'
        elif d_stan[0][0] != 'W':
            stat = 'BL_MOD_STAN'

    if stat == 'OK':
        stat, zagadnienie_id = fs_wf_zagadnienia_pom.UtworzZagadnienie(self=self, firma_id=self.firma_id, tabela='rs_wf_zaliczki',
                                                                       pola_klucz=['firma_id', 'zaliczka_id'],
                                                                       wartosci_klucz=[self.firma_id, Zaliczka],
                                                                       pola_z_zagadnienia=pola_z_zagadnienia,
                                                                       przypnij_do=PrzypnijDo,
                                                                       stan=StanZagadnienia,
                                                                       temat=TematZagadnienia,
                                                                       opis=OpisZagadnienia,
                                                                       pola_dodatkowe_odpowiedniki={'zaliczka_id_akcept': 'zaliczka_id'},
                                                                       pola_dodatkowe_historia={'zaliczka_id_akcept': 'Zaliczka do akcept.'})

    if stat == 'OK':
        UPD_ZAL = """UPDATE rs_wf_zaliczki SET zagadnienie_id=%s 
                     WHERE firma_id=%s AND zaliczka_id=%s;
                     """
        args = [zagadnienie_id, self.firma_id, Zaliczka]
        rsglobal.ZapiszDoLogow('Zagadnienie w zaliczce: '+self.PolSQL.Mogrify(UPD_ZAL, args))
        stat, dump, dump, dump = self.PolSQL.Execute(UPD_ZAL, 1, args)
        rsglobal.ZapiszDoLogow(UPD_ZAL)
        if stat != 'OK':
            stat = 'Bd dodawania numeru zagadnienia do nagwka zaliczki:'+stat
            dane.append(stat)


# -------------------------------------------------------------------------------
# -----------------   AKTUALIZACJA DANYCH W ZAGADNIENIU   -----------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3, 4) and aktualizowac_zagadnienie:
    stat = fs_wf_zagadnienia_pom.AktualizujZagadnienie(self=self, firma_id=self.firma_id, tabela='rs_wf_zaliczki',
                                                       pola_klucz=['firma_id', 'zaliczka_id'],
                                                       wartosci_klucz=[self.firma_id, Zaliczka],
                                                       pola_z_zagadnienia=pola_z_zagadnienia,
                                                       prefix='(Zaliczki) ',
                                                       pola_dodatkowe_odpowiedniki={'zaliczka_id_akcept': 'zaliczka_id'},
                                                       pola_dodatkowe_historia={'zaliczka_id_akcept': 'Zaliczka do akcept.'})

# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH (1, 3, 5)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    if not UprPrz > 0:
        stat = 'UPR_PRZ'

    if stat == 'OK':
        SEL = """SELECT z.*,
                        CASE WHEN rk_o_kasa_bank_id IS NOT NULL THEN rk_o_kasa_bank_id || '/' || rk_o_data || '/' || rk_o_numer || '/' || rk_o_nr_poz || '/' || rk_o_nr_ppoz ELSE '' END AS rk_o,
                        CASE WHEN rk_z_kasa_bank_id IS NOT NULL THEN rk_z_kasa_bank_id || '/' || rk_z_data || '/' || rk_z_numer || '/' || rk_z_nr_poz || '/' || rk_z_nr_ppoz ELSE '' END AS rk_z,
                        to_char(akceptacja_czas, 'YYYY-MM-DD HH24:MI:SS') AS czas_akcept,
                        op.login AS operator_akcept
                 FROM rs_wf_zaliczki z
                 LEFT OUTER JOIN rs_operatorzy op ON (z.akceptacja_operator=op.operator_id)
                 WHERE z.firma_id=%s AND z.zaliczka_id=%s AND z.kontrahent_id IN ({SQLListaPrac});""".format(**locals())
        zmienne = [self.firma_id, Zaliczka]
        zmienne.extend(ListaPrac)
        rsglobal.ZapiszDoLogow('Dane zaliczki: '+self.PolSQL.Mogrify(SEL, zmienne))
        stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat

    if stat == 'OK':
        Komorka = Dokument = Pracownik = ''

        tr = rssql.RSTableRowset2(dane, wyn1)[0]

        if tr["komorka_id"].strip() not in ('', 'None'):
            if ((Oddzial,'011710') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_komorki_zatrudniajace WHERE firma_id='"+self.firma_id+"' AND kod='"+tr["komorka_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    Komorka = 'Bd pobrania opisu komrki zatrudniajcej: '+stat
                else:
                    if len(d) == 0:
                        Komorka = 'Bdna komrka zatrudniajca'
                    else:
                        Komorka = str(d[0][0])
            else:
                Komorka = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if tr["dokument_id"].strip() not in ('', 'None'):
            if ((Oddzial,'211502') in self.uprawnienia) or ((Oddzial,'301100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_wf_rodzaje_dokumentow WHERE firma_id='"+self.firma_id+"' AND kod='"+tr["dokument_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    Dokument = 'Bd pobrania opisu rodzaju dokumentu: '+stat
                else:
                    if len(d) == 0:
                        Dokument = 'Bdny rodzaj dokumentu'
                    else:
                        Dokument = str(d[0][0])
            else:
                Dokument = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if tr["kontrahent_id"].strip() not in Puste:
            if ((Oddzial,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id=%s AND kontrahent_id=%s;"
                zmienne = [self.firma_id, str(tr["kontrahent_id"])]
                stat, d, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
                if stat != 'OK':
                    Komorka = 'Bd pobrania nazwy kontrahenta: '+stat
                else:
                    if len(d) == 0:
                        Pracownik = 'Bdny kontrahent'
                    else:
                        Pracownik = str(d[0][0])
            else:
                Pracownik = 'Brak uprawnie do kartoteki kontrahentw. Poinformuj administratora.'
        #
        # if stat in ('OK',):
        #     SQLPliki = """SELECT z.firma_id, zagadnienie_id, nr_pliku, nazwa AS opis
        #                   FROM rs_wf_zagadnienia_pliki z JOIN rs_pliki p ON p.firma_id=z.firma_id  AND p.plik_id=z.nr_pliku
        #                   AND p.tabela ='rs_wf_zagadnienia_pliki'
        #                   WHERE zagadnienie_id = '{}';""".format(tr["zagadnienie_id"])
        #
        #     rsglobal.ZapiszDoLogow(SQLPliki)
        #     stat, Pliki, PlikiWyn1, dump = self.PolSQL.Execute(SQLPliki, 3, CzyDodawacBlad=True)
        #     if stat != 'OK':
        #         stat = u"Bd pobierania plikw dla zgoszenia: {stat}".format(**locals())

        if stat in ('OK',):
            SQLOperatorzy = """SELECT DISTINCT operator_id || ' - ' || o.nazwisko || ' ' || o.imie AS op, operator_id
                               FROM rs_wf_uprawnienia_szczegoly 
                               JOIN rs_operatorzy o USING (operator_id)
                               WHERE  firma_id = %s AND dokument_id = %s AND komorka_id = %s
                               ORDER BY operator_id;""".format()

            args = [self.firma_id, str(tr["dokument_id"]), str(tr["komorka_id"])]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLOperatorzy, args))

            stat, Operatorzy, OperatorzyWyn1, dump = self.PolSQL.Execute(SQLOperatorzy, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania operatorw do przekazania: {stat}".format(**locals())

        wyn2['Opisy']      = [Komorka, Dokument, Pracownik]
        # wyn2['Pliki']      = [Pliki, PlikiWyn1]
        wyn2['Operatorzy'] = Operatorzy
