# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_zaliczki_pozycje.py
# Purpose:     Obsuga grida pozycji zaliczek
# Author:      Wojciech Skowron
# Created:     2023/06/22
# RCS-ID:      $Id: fs_wf_zaliczki_pozycje.py $
# Copyright:   (c) 2023 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2023-09-14 Wojciech Skowron - (13545) Zmiana w uprawnieniach

import rsglobal

"""
Funkcje:
5 - Pobranie danych pozycji
6 - Usuniecie pozycji zaliczki
 """

"""
305000 Zaliczki
305200 Modyfikacja
"""

stat = 'OK'

Puste = (None, '', '    -  -  ', 'None', '-  -', [])
KontrahentPracownikOp = []
ListaPrac = []
KontrahentZal = None

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Zaliczka': [5,6], 'NrPoz': [6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_zaliczki_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in (5, 6, ):
        Zaliczka = klucze['Zaliczka']

    if Funkcja in (6, ):
        NrPoz = klucze['NrPoz']


# -------------------------------------------------------------------------------
# ------------------   POBRANIE KONTRAHENTA/PRACOWNIKA   ------------------------
# -------------------------------------------------------------------------------

if stat == 'OK':
    SQL = """SELECT COALESCE(kontrahent_pracownik, ''), COALESCE(kontrahenci_zaliczki, '')
             FROM rs_operatorzy
             WHERE operator_id=%s;"""
    zmienne = [self.operator_id]

    rsglobal.ZapiszDoLogow('Operator zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
    stat, d_op, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        stat = 'Bd pobrania danych operatora'
    else:
        KontrahentPracownikOp = [str(d_op[0][0]).strip()] if d_op[0][0] not in Puste else []
        KontrahenciZaliczkiOp = d_op[0][1].split(',') if d_op[0][1] not in Puste else []

        SQL = """SELECT kontrahent_id
                 FROM rs_wf_zaliczki
                 WHERE zaliczka_id=%s;"""
        zmienne = [Zaliczka]

        rsglobal.ZapiszDoLogow('Kontrahent zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_kontr, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych zaliczki'
        elif len(d_kontr) == 0:
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Zaliczka nie istnieje'
        else:
            KontrahentZal = d_kontr[0][0].strip()

        #WS 2023-09-14
        if len(KontrahenciZaliczkiOp+KontrahentPracownikOp) > 0:
            ListaPrac = [str(prac) for prac in KontrahenciZaliczkiOp+KontrahentPracownikOp]
            SQLListaPrac = "%s,"*len(KontrahenciZaliczkiOp+KontrahentPracownikOp)
            SQLListaPrac = SQLListaPrac.strip(',')
        elif self.operator_id == STANDARD_OPERATOR_ID:
            SQLListaPrac = 'z.kontrahent_id'
        else:
            SQLListaPrac = 'NULL'


# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrz = (self.oddzial_id, '305000') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod = (self.oddzial_id, '305200') in self.uprawnienia and KontrahentZal in KontrahentPracownikOp or (self.operator_id == STANDARD_OPERATOR_ID)


# -------------------------------------------------------------------------------
# ---------------------   USUWANIE Z POBRANIEM(6)   -----------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (6, ):
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        SQL = "SELECT z.stan, zp.zagadnienie_id " \
              "FROM rs_wf_zaliczki z " \
              "JOIN rs_wf_zaliczki_pozycje zp USING (zaliczka_id)" \
              "WHERE z.zaliczka_id=%s AND nr_poz=%s;"
        zmienne = [Zaliczka, NrPoz]

        rsglobal.ZapiszDoLogow('Spr stanu zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_stan, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania stanu przed usuniciem pozycji zaliczki'
        elif d_stan[0][0] != 'A':
            stat = 'BL_DEL_STAN'
        elif d_stan[0][1] != 0:
            stat = 'BL_DEL_ZAG'
        else:
            SQL = "DELETE FROM rs_wf_zaliczki_pozycje WHERE zaliczka_id=%s AND nr_poz=%s;"
            zmienne = [Zaliczka, NrPoz]

            rsglobal.ZapiszDoLogow('Del poz zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
            stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, zmienne)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd usuwania pozycji zaliczki'


# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH(5, 6)   ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5, 6, ):
    if not UprPrz > 0:
        stat = 'UPR_PRZ'
    else:
        #WS 2023-09-14
        SQL = """SELECT zpoz.nr_poz, zpoz.symbol_dokumentu, zpoz.data_dokumentu, 
                        COALESCE(k.nazwa, zpoz.kontrahent_nazwa) AS kontrahent, 
                        zpoz.kwota_brutto, zpoz.zagadnienie_id
                 FROM rs_wf_zaliczki_pozycje zpoz
                 JOIN rs_wf_zaliczki z USING (firma_id, zaliczka_id)
                 LEFT OUTER JOIN rs_kontrahenci k ON zpoz.firma_id=k.firma_id AND zpoz.kontrahent_id=k.kontrahent_id
                 WHERE zpoz.firma_id=%s AND zpoz.zaliczka_id=%s AND z.kontrahent_id IN ({SQLListaPrac})
                 ORDER BY zpoz.nr_poz;""".format(**locals())
        zmienne = [self.firma_id, Zaliczka]
        zmienne.extend(ListaPrac)
        rsglobal.ZapiszDoLogow('Poz zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, dane, wyn1, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych pozycji zaliczki'
