# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_wf_zaliczki_pozycje_dane.py
# Purpose:     Dodawanie i edycja danych pozycji zaliczek
# Author:      Wojciech Skowron
# Created:     2023/06/22
# RCS-ID:      $Id: fs_wf_zaliczki_pozycje_dane.py $
# Copyright:   (c) 2023 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------
# 2023-07-07 Aleksander Bargie (13473) zmiany w sprawdzaniu pary kontrahent - dokument
# 2023-08-18 Wojciech Skowron   (13495) Zablokowa moliwo wprowadzania pozycji jeeli zaliczka nie jest wypacona
# 2023-08-29 Aleksander Bargie (13509) Upora si ze znakami specjalnymi w danych pobieranych z GUS (usunicie pobrania klucza GUS w tym fs_ie)
# 2023-09-14 Wojciech Skowron   (13545) Zmiana w uprawnieniach
# 2023-09-19 Wojciech Skowron   (13549) Funkcja pobrania stanw (36)
# 2023-10-23 Wojciech Skowron   (13585) Zmiany w zaliczkach
# 2023-10-31 Wojciech Skowron   (13591) Pobranie stanu zaliczki w funkcji 5
# 2023-11-10 Wojciech Skowron   (13598) Poprawiony numer uprawnie dla sownika rs_wf_rodzaje_dokumentow

import ast
import rsglobal
from funkcje import fs_pliki_global, fs_wf_zagadnienia_pom, fs_dowody_ksiegowe_pom  #AB 2023-07-07

"""
305000 Zaliczki
305200 Modyfikacja
"""

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}
nieedytowalne_ins = ['zaliczka_id', 'nr_poz', 'zagadnienie_id']
nieedytowalne_upd = ['zaliczka_id', 'nr_poz', 'zagadnienie_id']
Pliki, PlikiWyn1 = [], []
Operatorzy = []  #AB 2023-07-07
firma_id = self.firma_id
Oddzial  = self.oddzial_id
aktualizowac_zagadnienie = False
pola_z_zagadnienia = ('dokument_id', 'komorka_id', 'kontrahent_id', 'nip', 'kontrahent_nazwa', 'kontrahent_adres',
                      'symbol_dokumentu', 'data_dokumentu', 'kwota_brutto')
Puste = (None, '', '    -  -  ', 'None', '-  -', [])
KontrahentPracownikOp = []
ListaPrac = []
KontrahentZal = None

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']
    SlPar = {'Oddzial': [1, 2, 3, 4, 5, 10, 11, 21], 'Zaliczka': [1, 2, 3, 4, 5, 21], 'NrPoz': [3, 4, 5, 21],
             'TworzycZagadnienie': [1, 2],
             'Kontrahent': [11], 'NazwaPliku': [12],
             'PrzypnijDo': [1, 2, 21], 'StanZagadnienia': [1, 2, 21], 'TematZagadnienia': [1, 2, 21], 'OpisZagadnienia': [1, 2, 21],
             'ZawartoscPliku': [12], 'nr_pliku': [15, ],
             'Dokument': [35, 36, ], 'Komorka': [35, 36, ], 'Operator': [36, ],
             'NIP': [45, ]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wf_zaliczki_pozycje_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 2, 3, 4, 5, 10, 11, 12, 21]:  
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])

    if Funkcja in [1, 2, 3, 4, 5, 12, 21]:
        Zaliczka = rsglobal.Dekoduj(klucze['Zaliczka'])

    if Funkcja in [3, 4, 5, 12, 21]:  
        NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

    if Funkcja in [1, 2, 21]:
        PrzypnijDo = klucze['PrzypnijDo']
        StanZagadnienia = klucze['StanZagadnienia']
        TematZagadnienia = klucze['TematZagadnienia']
        OpisZagadnienia = klucze['OpisZagadnienia']

    if Funkcja in [1, 2]:
        TworzycZagadnienie = klucze['TworzycZagadnienie']

    if Funkcja == 21:
        TworzycZagadnienie = True

    if Funkcja == 11:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])

    if Funkcja == 12:
        NazwaPliku = rsglobal.Dekoduj(klucze['NazwaPliku'])
        ZawartoscPliku = rsglobal.Dekoduj(klucze['ZawartoscPliku'])

    if Funkcja == 15:
        nr_pliku = rsglobal.Dekoduj(klucze['nr_pliku'])
        Oddzial  = self.oddzial_id

    if Funkcja == 35:
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Komorka = rsglobal.Dekoduj(klucze['Komorka'])

    if Funkcja == 36:
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Komorka = rsglobal.Dekoduj(klucze['Komorka'])
        Operator = rsglobal.Dekoduj(klucze['Operator'])

    if Funkcja == 45:
        NIP = rsglobal.Dekoduj(klucze['NIP'])  

# -------------------------------------------------------------------------------
# ------------------   POBRANIE KONTRAHENTA/PRACOWNIKA   ------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1, 2, 3, 4, 5, 12, 21]:
    SQL = """SELECT COALESCE(kontrahent_pracownik, ''), COALESCE(kontrahenci_zaliczki, '')
             FROM rs_operatorzy
             WHERE operator_id=%s;"""
    zmienne = [self.operator_id]

    rsglobal.ZapiszDoLogow('Operator zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
    stat, d_op, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat)
        stat = 'Bd pobrania danych operatora'
    else:
        KontrahentPracownikOp = [str(d_op[0][0]).strip()] if d_op[0][0] not in Puste else []
        KontrahenciZaliczkiOp = d_op[0][1].split(',') if d_op[0][1] not in Puste else []

        SQL = """SELECT kontrahent_id
                 FROM rs_wf_zaliczki
                 WHERE zaliczka_id=%s;"""
        zmienne = [Zaliczka]

        rsglobal.ZapiszDoLogow('Kontrahent zaliczki: '+self.PolSQL.Mogrify(SQL, zmienne))
        stat, d_kontr, dump, dump = self.PolSQL.Execute(SQL, 3, zmienne)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd pobrania danych zaliczki'
        elif len(d_kontr) == 0:
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Zaliczka nie istnieje'
        else:
            KontrahentZal = d_kontr[0][0].strip()

        #WS 2023-09-14
        if len(KontrahenciZaliczkiOp+KontrahentPracownikOp) > 0:
            ListaPrac = [str(prac) for prac in KontrahenciZaliczkiOp+KontrahentPracownikOp]
            SQLListaPrac = "%s,"*len(KontrahenciZaliczkiOp+KontrahentPracownikOp)
            SQLListaPrac = SQLListaPrac.strip(',')
        elif self.operator_id == STANDARD_OPERATOR_ID:
            SQLListaPrac = 'z.kontrahent_id'
        else:
            SQLListaPrac = 'NULL'


# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprPrz = (self.oddzial_id, '305000') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod = (self.oddzial_id, '305200') in self.uprawnienia and KontrahentZal in KontrahentPracownikOp or (self.operator_id == STANDARD_OPERATOR_ID)

# -------------------------------------------------------------------------------
# ----------------------   SPRAWDZANIE DANYCH (1, 3)   --------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 2, 3, 4):
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        SQL = "SELECT stan, rk_o_kasa_bank_id FROM rs_wf_zaliczki WHERE zaliczka_id={Zaliczka};".format(**locals())
        stat, d_stan, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania stanu zaliczki przed modyfikacj danych'
        elif (Funkcja in (1, 2) and d_stan[0][0] not in ('A', 'K')) or (Funkcja in (3, 4) and d_stan[0][0] not in ('A',)):  #WS 2023-10-23
            stat = 'BL_MOD_STAN'
        elif d_stan[0][1] in Puste:   #WS 2023-08-18
            stat = 'BL_NIEWYPLACONA'

        if stat == 'OK' and Funkcja in (3, 4):
            #WS 2023-10-23
            SQL = """SELECT zag.zaksiegowane
                     FROM rs_wf_zaliczki_pozycje zp
                     LEFT OUTER JOIN rs_wf_zagadnienia zag USING (zagadnienie_id)
                     WHERE zp.zaliczka_id={Zaliczka} AND zp.nr_poz={NrPoz};""".format(**locals())
            stat, d_zagadnienie, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd sprawdzania stanu zagadnienia przed modyfikacj danych'
            elif d_zagadnienie[0][0]:
                stat = 'BL_ZAKSIEGOWANA'   #WS 2023-10-23

    if stat == 'OK':
        kontrahent = ''
        nazwa = ''
        adres = ''

        for pole, wart in zip(pola, wartosci):
            if not aktualizowac_zagadnienie and pole in pola_z_zagadnienia:
                aktualizowac_zagadnienie = True
            if pole == 'dokument_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_wf_rodzaje_dokumentow WHERE firma_id='{firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_DOKUMENT"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                elif Funkcja in (1, 2) and TworzycZagadnienie:
                    stat = "BR_DOKUMENT_ZAG"
                    dane.append(stat)

            elif pole == 'komorka_id':
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_komorki_zatrudniajace WHERE firma_id='{firma_id}' AND kod='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KOMORKA"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)
                else:
                    stat = "BR_KOMORKA"
                    dane.append(stat)

            elif pole == 'kontrahent_id':
                kontrahent = wart.strip()
                if wart.strip() != '':
                    SQL = "SELECT 1 FROM rs_kontrahenci WHERE firma_id='{firma_id}' AND kontrahent_id='{wart}';".format(**locals())
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                    if stat == 'OK':
                        if len(d) == 0:
                            stat = "BL_KONTRAHENT"
                            dane.append(stat)
                    else:
                        stat = 'Bdy sprawdzania danych: '+stat
                        dane.append(stat)

            elif pole == 'kontrahent_nazwa':
                nazwa = wart.strip()

            elif pole == 'kontrahent_adres':
                adres = wart.strip()

            elif pole == 'data_wystawienia':
                if wart in ('', '-  -', '    -  -  ', 'None'):
                    stat = 'BR_DATA'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL_DATA'
                    dane.append(stat)

        if Funkcja in (3, 4) and (nazwa == '' or adres == '' or kontrahent == ''):
            SQL = """SELECT COALESCE(kontrahent_nazwa, ''), COALESCE(kontrahent_adres, ''), COALESCE(kontrahent_id, '')
                     FROM rs_wf_zaliczki_pozycje
                     WHERE firma_id='{firma_id}' AND zaliczka_id={Zaliczka} AND nr_poz={NrPoz};
                  """.format(**locals())
            stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobrania danych pozycji"
                dane.append(stat)
            else:
                nazwa = d[0][0] if nazwa == '' else nazwa
                adres = d[0][1] if adres == '' else adres
                kontrahent = d[0][2] if kontrahent == '' else kontrahent

        if (nazwa == '' or adres == '') and kontrahent == '':
            stat = "BR_KONTRAHENT"
            dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# ---------------------------   INSERT (1)   ------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2):
    NrPoz = 1
    SEL = """SELECT MAX(nr_poz)+1 FROM rs_wf_zaliczki_pozycje
             WHERE firma_id='{firma_id}' AND zaliczka_id={Zaliczka};"""
    SEL = SEL.format(**locals())
    stat, dane_numer, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bad dodania danych:' + stat
        dane.append(stat)
    elif len(dane_numer) > 0 and dane_numer[0][0] > 0:
        NrPoz = dane_numer[0][0]

    if stat == 'OK':  #AB 2023-07-07
        INS = "INSERT INTO rs_wf_zaliczki_pozycje "
        Pola = "firma_id, zaliczka_id, nr_poz "
        Wartosci = "'{firma_id}', {Zaliczka}, {NrPoz}".format(**locals())
        NIP        = wartosci[pola.index('nip')]              if 'nip'              in pola else ''
        Kontrahent = wartosci[pola.index('kontrahent_id')]    if 'kontrahent_id'    in pola else ''
        Symbol     = wartosci[pola.index('symbol_dokumentu')] if 'symbol_dokumentu' in pola else ''

        #AB 2023-07-07
        if Symbol not in Puste and (NIP not in Puste or Kontrahent not in Puste):
            stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'ZA', str(Kontrahent), str(NIP),
                                                                                   str(Symbol), [-1, -1])
            if stat == 'OK' and komunikat:
                wyn2['Powtorka'] = komunikat
        else:
            rsglobal.ZapiszDoLogow("NIP   Kontrahent Symbol:   {}   {}  {}".format(NIP, Kontrahent, Symbol))

    if stat == 'OK':  #AB 2023-07-07
        for pole, wart in zip(pola, wartosci):
            if pole not in nieedytowalne_ins:
                if pole in ['zagadnienie_id']:
                    Pola += ","+pole
                    Wartosci += ",NULL"
                else:
                    Pola += ","+pole
                    Wartosci += ","+rsglobal.ZmienNaNULL(wart)

        INS += "("+Pola+") VALUES ("+Wartosci+");"
        UPD_STAN = """UPDATE rs_wf_zaliczki SET stan='A' WHERE zaliczka_id={Zaliczka} AND stan='K';""".format(**locals())  #WS 2023-10-23

        stat, dump, dump, dump = self.PolSQL.Execute(INS+UPD_STAN, 1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(INS)
        if stat != 'OK':
            stat = 'Bd dodania danych: '+stat
            dane.append(stat)

        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# --------------------------   UPDATE (3)   -------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (3, 4):
    #AB 2023-07-07
    SEL = """SELECT * FROM rs_wf_zaliczki_pozycje WHERE (firma_id, zaliczka_id, nr_poz) = (%s, %s, %s)"""
    args = [self.firma_id, Zaliczka, NrPoz]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SEL, args))
    stat, poprz_dane, poprz_wyn1, dump = self.PolSQL.Execute(SEL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych: " + stat
    elif len(poprz_dane) == 0:
        stat = "Nie odnaleziono wpisu"
    else:
        tr_poprzednie = rssql.RSTableRowset(poprz_dane, poprz_wyn1)
        NIP        = tr_poprzednie.GetVal(0, 'nip')
        Kontrahent = tr_poprzednie.GetVal(0, 'kontrahent_id')
        Symbol     = tr_poprzednie.GetVal(0, 'symbol_dokumentu')
    if stat == 'OK':
        UPD = "UPDATE rs_wf_zaliczki_pozycje SET "
        NIP        = wartosci[pola.index('nip')]              if 'nip'              in pola else NIP
        Kontrahent = wartosci[pola.index('kontrahent_id')]    if 'kontrahent_id'    in pola else Kontrahent
        Symbol     = wartosci[pola.index('symbol_dokumentu')] if 'symbol_dokumentu' in pola else Symbol
        if Symbol not in Puste and (NIP not in Puste or Kontrahent not in Puste):
            stat, komunikat = fs_dowody_ksiegowe_pom.SprawdzPareKontrahentDokument(self, 'ZA', str(Kontrahent), str(NIP),
                                                                                   str(Symbol), [Zaliczka, NrPoz])
            if stat == 'OK' and komunikat:
                wyn2['Powtorka'] = komunikat
        else:
            rsglobal.ZapiszDoLogow("NIP   Kontrahent Symbol:   {}   {}  {}".format(NIP, Kontrahent, Symbol))

    if stat == 'OK':

        for pole, wart in zip(pola, wartosci):
            if pole not in nieedytowalne_upd:
                if pole not in ['zagadnienie_id']:
                    UPD += pole+"="+rsglobal.ZmienNaNULL(wart)+","

        UPD = UPD[0:-1]
        UPD += " WHERE firma_id='{firma_id}' AND zaliczka_id={Zaliczka} AND nr_poz={NrPoz};".format(**locals())

        stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(UPD)
        if stat != 'OK':
            stat = 'Bd modyfikacji danych:' + stat
            dane.append(stat)

        if len(dane) > 0:
            stat = dane[0]

# -------------------------------------------------------------------------------
# -----------------   TWORZENIE ZAGADNIENIA PO INSERCIE (1)   -------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and len(dane) == 0 and Funkcja in (1, 2, 21) and TworzycZagadnienie:
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        SQL = "SELECT stan FROM rs_wf_zaliczki WHERE firma_id=%s AND zaliczka_id=%s;"
        args = [self.firma_id, Zaliczka]
        rsglobal.ZapiszDoLogow('Spr przed tworzeniem zagadnienia: '+self.PolSQL.Mogrify(SQL, args))
        stat, d_stan, dump, dump = self.PolSQL.Execute(SQL, 3, args)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania stanu zaliczki przed tworzeniem zagadnienia'
        elif d_stan[0][0] != 'A':
            stat = 'BL_MOD_STAN'
        else:
            #WS 2023-10-23
            SQL = """SELECT zag.zaksiegowane
                     FROM rs_wf_zaliczki_pozycje zp
                     LEFT OUTER JOIN rs_wf_zagadnienia zag USING (zagadnienie_id)
                     WHERE zp.zaliczka_id={Zaliczka} AND zp.nr_poz={NrPoz};""".format(**locals())
            stat, d_zagadnienie, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd sprawdzania stanu zagadnienia przed modyfikacj danych'
            elif d_zagadnienie[0][0]:
                stat = 'BL_ZAKSIEGOWANA'   #WS 2023-10-23

    if stat == 'OK':
        stat, zagadnienie_id = fs_wf_zagadnienia_pom.UtworzZagadnienie(self=self, firma_id=self.firma_id, tabela='rs_wf_zaliczki_pozycje',
                                                                       pola_klucz=['firma_id', 'zaliczka_id', 'nr_poz'],
                                                                       wartosci_klucz=[self.firma_id, Zaliczka, NrPoz],
                                                                       pola_z_zagadnienia=pola_z_zagadnienia,
                                                                       przypnij_do=PrzypnijDo,
                                                                       stan=StanZagadnienia,
                                                                       temat=TematZagadnienia,
                                                                       opis=OpisZagadnienia,
                                                                       pola_dodatkowe_odpowiedniki={'zaliczka_id': 'zaliczka_id', 'zaliczka_nr_poz': 'nr_poz'})

    if stat == 'OK':
        INSHISTORIA = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                         VALUES(%s, %s, NOW() + INTERVAL '99 microseconds', rsf_getuserid(), %s, %s);"""
        args = [firma_id, zagadnienie_id, "Zaliczka", "=> "+str(Zaliczka)+'/'+str(int(NrPoz))]
        stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, args)
        if stat != 'OK':
            stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

    if stat == 'OK':
        UPD_ZAL = """UPDATE rs_wf_zaliczki_pozycje SET zagadnienie_id=%s 
                     WHERE firma_id=%s AND zaliczka_id=%s AND nr_poz=%s;
                     """
        args = [zagadnienie_id, self.firma_id, Zaliczka, NrPoz]
        rsglobal.ZapiszDoLogow('Zagadnienie na poz zaliczki: '+self.PolSQL.Mogrify(UPD_ZAL, args))
        stat, dump, dump, dump = self.PolSQL.Execute(UPD_ZAL, 1, args)
        if stat != 'OK':
            stat = 'Bd dodawania numeru zagadnienia do pozycji zaliczki:'+stat
            dane.append(stat)

# -------------------------------------------------------------------------------
# -----------------   AKTUALIZACJA DANYCH W ZAGADNIENIU   -----------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3, 4) and aktualizowac_zagadnienie:
    stat = fs_wf_zagadnienia_pom.AktualizujZagadnienie(self=self, firma_id=self.firma_id, tabela='rs_wf_zaliczki_pozycje',
                                                       pola_klucz=['firma_id', 'zaliczka_id', 'nr_poz'],
                                                       wartosci_klucz=[self.firma_id, Zaliczka, NrPoz],
                                                       pola_z_zagadnienia=pola_z_zagadnienia,
                                                       prefix='(Zaliczki) ',
                                                       pola_dodatkowe_odpowiedniki={'zaliczka_id': 'zaliczka_id', 'zaliczka_nr_poz': 'nr_poz'})


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE DANYCH (1, 3, 5)   ---------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 3, 5, ):
    if not UprPrz > 0:
        stat = 'UPR_PRZ'

    if stat == 'OK':
        #WS 2023-09-14
        SEL = """SELECT zpoz.* 
                 FROM rs_wf_zaliczki_pozycje zpoz
                 JOIN rs_wf_zaliczki z USING (firma_id, zaliczka_id)
                 WHERE zpoz.firma_id=%s AND zpoz.zaliczka_id=%s AND zpoz.nr_poz=%s
                       AND z.kontrahent_id IN ({SQLListaPrac});"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        zmienne = [self.firma_id, Zaliczka, NrPoz]
        zmienne.extend(ListaPrac)
        stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat

    if stat == 'OK':
        Komorka = Dokument = StanZaliczki = ''
        Zaksiegowane = False

        tr = rssql.RSTableRowset2(dane, wyn1)[0]

        if tr["komorka_id"].strip() not in ('', 'None'):
            if ((Oddzial,'011710') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_komorki_zatrudniajace WHERE firma_id='"+firma_id+"' AND kod='"+tr["komorka_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    Komorka = 'Bd pobrania opisu komrki zatrudniajcej: '+stat
                else:
                    if len(d) == 0:
                        Komorka = 'Bdna komrka zatrudniajca'
                    else:
                        Komorka = str(d[0][0])
            else:
                Komorka = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if tr["dokument_id"].strip() not in ('', 'None'):
            if ((Oddzial,'211502') in self.uprawnienia) or ((Oddzial,'301100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                SQL = "SELECT opis FROM rs_wf_rodzaje_dokumentow WHERE firma_id='"+firma_id+"' AND kod='"+tr["dokument_id"]+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
                if stat != 'OK':
                    Dokument = 'Bd pobrania opisu rodzaju dokumentu: '+stat
                else:
                    if len(d) == 0:
                        Dokument = 'Bdny rodzaj dokumentu'
                    else:
                        Dokument = str(d[0][0])
            else:
                Dokument = 'Brak uprawnie do sownika. Poinformuj administratora.'

        if stat in ('OK',):  
            SQLPliki = """SELECT z.firma_id, zagadnienie_id, nr_pliku, nazwa AS opis
                          FROM rs_wf_zagadnienia_pliki z JOIN rs_pliki p ON p.firma_id=z.firma_id  AND p.plik_id=z.nr_pliku 
                          AND p.tabela ='rs_wf_zagadnienia_pliki'
                          WHERE zagadnienie_id = '{}';""".format(tr["zagadnienie_id"])

            rsglobal.ZapiszDoLogow(SQLPliki)
            stat, Pliki, PlikiWyn1, dump = self.PolSQL.Execute(SQLPliki, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania plikw dla zgoszenia: {stat}".format(**locals())

        if stat in ('OK',):  
            SQLOperatorzy = """SELECT DISTINCT operator_id || ' - ' || o.nazwisko || ' ' || o.imie AS op, operator_id
                               FROM rs_wf_uprawnienia_szczegoly 
                               JOIN rs_operatorzy o USING (operator_id)
                               WHERE  firma_id = %s AND dokument_id = %s AND komorka_id = %s
                               ORDER BY operator_id;""".format()

            args = [firma_id, str(tr["dokument_id"]), str(tr["komorka_id"])]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLOperatorzy, args))

            stat, Operatorzy, OperatorzyWyn1, dump = self.PolSQL.Execute(SQLOperatorzy, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania operatorw do przekazania: {stat}".format(**locals())

        if stat  == 'OK':
            #WS 2023-10-23
            SQLStan = """SELECT zaksiegowane FROM rs_wf_zagadnienia WHERE zagadnienie_id=%s;"""
            args = [str(tr["zagadnienie_id"])]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLStan, args))

            stat, Zaksiegowane, dump, dump = self.PolSQL.Execute(SQLStan, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania stanu zagadnienia: {stat}".format(**locals())

        if stat  == 'OK':
            #WS 2023-10-31
            SQLStanZaliczki = """SELECT stan FROM rs_wf_zaliczki WHERE firma_id=%s AND zaliczka_id=%s;"""
            args = [self.firma_id, Zaliczka]
            rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLStanZaliczki, args))

            stat, StanZaliczki, dump, dump = self.PolSQL.Execute(SQLStanZaliczki, 3, args, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = u"Bd pobierania stanu zaliczki: {stat}".format(**locals())

        wyn2['Opisy']        = [Komorka, Dokument]
        wyn2['Pliki']        = [Pliki, PlikiWyn1]
        wyn2['Operatorzy']   = Operatorzy
        wyn2['Zaksiegowane'] = Zaksiegowane
        wyn2['StanZaliczki'] = StanZaliczki
#
# # -------------------------------------------------------------------------------
# # --------------------   POBRANIE DANYCH ZAGADNIENIA (10)   ---------------------
# # -------------------------------------------------------------------------------
#
# if stat == 'OK' and Funkcja == 10:
#     SEL = """SELECT komorka_id, kontrahent_id, temat, opis, dokument_id FROM rs_wf_zagadnienia
#              WHERE firma_id='{firma_id}' AND zagadnienie_id={Zagadnienie};"""
#     SEL = SEL.format(**locals())
#     rsglobal.ZapiszDoLogow(SEL)
#     stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
#     if stat != 'OK':
#         stat = 'Bd pobrania danych zagadnienia: '+stat

# -------------------------------------------------------------------------------
# --------------------   POBRANIE DANYCH KONTRAHENTA (11)   ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    SQL = "SELECT " \
          "nazwa , " \
          "CONCAT(TRIM(adrk_kod), ' ', " \
          "       TRIM(CASE WHEN adrk_poczta != '' THEN adrk_poczta ELSE adrk_miej END), ', ', " \
          "       TRIM(adrk_miej), ', ', " \
          "       TRIM(adrk_ulica), ', ', TRIM(adrk_nry)), " \
          "CONCAT(TRIM(adr_kod), ' ', " \
          "       TRIM(CASE WHEN adr_poczta != '' THEN adr_poczta ELSE adr_miej END), ', ', " \
          "       TRIM(adr_miej), ', ', " \
          "       TRIM(adr_ulica), ', ', TRIM(adr_nry)), nip " \
          "FROM rs_kontrahenci "
    SEL = SQL + """ WHERE firma_id='{firma_id}' AND aktywny  AND kontrahent_id='{Kontrahent}';"""
    SEL = SEL.format(**locals())
    rsglobal.ZapiszDoLogow(SEL)
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych kontrahenta: '+stat

# -------------------------------------------------------------------------------
# -------------------   DODANIE PLIKU DO ZAGADNIENIA (12)   ---------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    if not UprMod > 0:
        stat = 'UPR_MOD'
    else:
        SQL = "SELECT stan FROM rs_wf_zaliczki WHERE zaliczka_id={Zaliczka};".format(**locals())
        stat, d_stan, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            rsglobal.ZapiszDoLogow(stat)
            stat = 'Bd sprawdzania stanu przed modyfikacj danych'
        elif d_stan[0][0] != 'A':
            stat = 'BL_MOD_STAN'
        else:
            #WS 2023-10-23
            SQL = """SELECT zag.zaksiegowane
                     FROM rs_wf_zaliczki_pozycje zp
                     LEFT OUTER JOIN rs_wf_zagadnienia zag USING (zagadnienie_id)
                     WHERE zp.zaliczka_id={Zaliczka} AND zp.nr_poz={NrPoz};""".format(**locals())
            stat, d_zagadnienie, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat)
                stat = 'Bd sprawdzania stanu zagadnienia przed modyfikacj danych'
            elif d_zagadnienie[0][0]:
                stat = 'BL_ZAKSIEGOWANA'   #WS 2023-10-23

    if stat == 'OK':
        SEL_ZAG = "SELECT zagadnienie_id FROM rs_wf_zaliczki_pozycje " \
                  "WHERE firma_id='{firma_id}' AND zaliczka_id={Zaliczka} AND nr_poz={NrPoz};".format(**locals())
        rsglobal.ZapiszDoLogow(SEL_ZAG)
        stat, dane_zagadnienie_id, dump, dump = self.PolSQL.Execute(SEL_ZAG, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania numeru zagadnienia przypisanego do pozycji: '+stat
            dane.append(stat)
        elif len(dane_zagadnienie_id) == 0:
            stat = 'Brak zagadnienia przypisanego do pozycji'
            dane.append(stat)
        else:
            zagadnienie_id = dane_zagadnienie_id[0][0]
            if zagadnienie_id == 0:
                stat = 'Brak zagadnienia przypisanego do pozycji'
                dane.append(stat)

    if stat == 'OK':
        INSPLIKI = """INSERT INTO rs_pliki (  firma_id,      nazwa,            tabela,     kompresja)
                                    VALUES ('{firma_id}','{NazwaPliku}','rs_wf_zagadnienia_pliki', FALSE);""".format(**locals())
        rsglobal.ZapiszDoLogow(INSPLIKI)
        stat, dump, dump, dump = self.PolSQL.Execute(INSPLIKI, 1, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd dodawania pliku: {stat}".format(**locals())

    if stat == 'OK':
        SQLNumerPliku = """SELECT max(plik_id) 
                           FROM rs_pliki 
                           WHERE firma_id='{firma_id}' AND tabela='rs_wf_zagadnienia_pliki';""".format(**locals())
        rsglobal.ZapiszDoLogow(SQLNumerPliku)
        stat, nrp, dump, dump = self.PolSQL.Execute(SQLNumerPliku, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow("pobrano numer: "+str(nrp))
        if stat != 'OK':
            stat = "Bd pobierania numeru zacznika: {stat}".format(**locals())
        else:
            NumerPliku = nrp[0][0]
            stat = fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow, NumerPliku, ZawartoscPliku)

            if stat != 'OK':
                stat = "Bd wstawiania pliku na serwer: {stat}".format(**locals())
            else:
                INSZALACZNIKI = """INSERT INTO rs_wf_zagadnienia_pliki
                                           (  firma_id,    zagadnienie_id,    nr_pliku   )
                                    VALUES ('{firma_id}','{zagadnienie_id}','{NumerPliku}');""".format(**locals())

                rsglobal.ZapiszDoLogow(INSZALACZNIKI, 5)
                stat, dump, dump, dump = self.PolSQL.Execute(INSZALACZNIKI, 1, CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'Bd dodawania rekordu o nowym pliku: ' + stat
                else:
                    dane = [{'nr_pliku': NumerPliku}]
                    sql = """UPDATE rs_wf_zagadnienia SET modyfikacja_czas=NOW(), modyfikacja_kto=rsf_getuserid()
                             WHERE firma_id='{firma_id}' AND zagadnienie_id={zagadnienie_id}""".format(**locals())
                    rsglobal.ZapiszDoLogow(sql)
                    stat, dump, dump, dump = self.PolSQL.Execute(sql, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = 'Bd aktualizacji czasu modyfikacji zagadnienia: ' + stat

                if stat == 'OK':
                    wzor_hist = """INSERT INTO rs_wf_zagadnienia_historia (firma_id, zagadnienie_id, zmiana_czas, zmiana_kto, zmiana_co, zmiana_wartosc) 
                                   VALUES('{}', {}, NOW() + INTERVAL '{} microseconds', rsf_getuserid(), '{}', '{}');
                                """.format(firma_id, zagadnienie_id, '{}', '{}', '{}')
                    npl = NazwaPliku if len(NazwaPliku) <= 35 else (NazwaPliku[:32] + '...')
                    INSHISTORIA = wzor_hist.format(0, "Doczono plik {}".format(npl), " ")
                    rsglobal.ZapiszDoLogow(INSHISTORIA)
                    stat, dump, dump, dump = self.PolSQL.Execute(INSHISTORIA, 1, CzyDodawacBlad=True)
                    if stat != 'OK':
                        stat = "Bd aktualizacji historii zagadnienia: {stat}".format(**locals())

# ---------------------------------------------------------------------------------------------------------------------
#                                             15 - Pobranie pliku
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (15, ):
    if not UprPrz > 0:
        stat = 'UPR_PRZ'
    else:
        SQL = """SELECT 1 
                 FROM rs_wf_zagadnienia_pliki zp
                 WHERE nr_pliku = %s
                 AND firma_id = %s
                 AND zagadnienie_id IN (SELECT zagadnienie_id 
                                        FROM rs_wf_zaliczki_pozycje zal 
                                        WHERE zal.firma_id = zp.firma_id);"""
        args = [nr_pliku, firma_id]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
        stat, test, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = "Bd szukania pliku: " + stat
        elif len(test) == 0:
            stat = "Plik {} nie odnaleziony".format(nr_pliku)
        if stat == 'OK':
            stat, Tresc = fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow, nr_pliku)
            dane = [Tresc]


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE ODBIORCOW ( 25)   --------------------
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (1, 3, 5, 25, ):  
    if not UprPrz > 0:
        stat = 'UPR_PRZ'

    if stat == 'OK':
        SEL = """SELECT DISTINCT ON(LOWER(kontrahent_nazwa), LOWER(COALESCE(kontrahent_adres, ''))) kontrahent_nazwa, COALESCE(kontrahent_adres, '')
                 FROM rs_wf_zaliczki_pozycje
                 WHERE firma_id='{self.firma_id}' AND kontrahent_id IS NULL AND kontrahent_nazwa IS NOT NULL;"""
        SEL = SEL.format(**locals())
        rsglobal.ZapiszDoLogow(SEL)
        stat, adresy, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd pobrania danych: '+stat
    wyn2['adresy'] = adresy


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE OPERATOROW ( 35)   --------------------
# -------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (35, ):  
    if not UprPrz > 0:
        stat = 'UPR_PRZ'

    if stat in ('OK',):
        SQLOperatorzy = """SELECT DISTINCT operator_id || ' - ' || o.nazwisko || ' ' || o.imie AS op, operator_id
                           FROM rs_wf_uprawnienia_szczegoly 
                           JOIN rs_operatorzy o USING (operator_id)
                           WHERE  firma_id = %s AND dokument_id = %s AND komorka_id = %s
                           ORDER BY operator_id;""".format()

        args = [firma_id, Dokument, Komorka]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLOperatorzy, args))

        stat, dane, wyn1, dump = self.PolSQL.Execute(SQLOperatorzy, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania operatorw do przekazania: {stat}".format(**locals())


# -------------------------------------------------------------------------------
# ---------------------   POBRANIE STANW ( 36)   --------------------
# -------------------------------------------------------------------------------
#WS 2023-09-19
if stat == 'OK' and Funkcja in (36, ):
    if not UprPrz > 0:
        stat = 'UPR_PRZ'

    if stat in ('OK',):
        SQLOperatorzy = """SELECT stany
                           FROM rs_wf_uprawnienia_szczegoly 
                           JOIN rs_operatorzy o USING (operator_id)
                           WHERE firma_id = %s AND dokument_id = %s AND komorka_id = %s AND operator_id = %s
                           ORDER BY operator_id;"""

        args = [firma_id, Dokument, Komorka, Operator]
        rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQLOperatorzy, args))

        stat, dane, wyn1, dump = self.PolSQL.Execute(SQLOperatorzy, 3, args, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = u"Bd pobierania stanw: {stat}".format(**locals())
        else:
            dane = ast.literal_eval(dane[0][0])

# ---------------------------------------------------------------------------------------------------------------------
#                                    45 - Pobranie danych kontrahenta i klucza do BIR  
# ---------------------------------------------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (45, ):
    args = [firma_id]
    NIP = "%" + NIP.replace('-', '').replace(' ', '') + "%"
    war = "AND nip like %s;"
    args.append(NIP)

    SQL = "SELECT kontrahent_id, " \
          " nazwa , " \
          "CASE WHEN TRIM(adrk_miej) != '' " \
          "THEN CONCAT(TRIM(adrk_kod), ' ', " \
          "            TRIM(CASE WHEN adrk_poczta != '' THEN adrk_poczta ELSE adrk_miej END), ', ', " \
          "            TRIM(adrk_miej), ', ', " \
          "            TRIM(adrk_ulica), ', ', TRIM(adrk_nry)) " \
          "ELSE CONCAT(TRIM(adr_kod), ' ', " \
          "            TRIM(CASE WHEN adr_poczta != '' THEN adr_poczta ELSE adr_miej END), ', ', " \
          "            TRIM(adr_miej), ', ', " \
          "            TRIM(adr_ulica), ', ', TRIM(adr_nry)) END, nip " \
          "FROM rs_kontrahenci " \
          "WHERE firma_id = %s  AND aktywny " + war

    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(SQL, args))
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd pobierania danych kontrahentw: {stat}".format(**locals())
