# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_dowod_dostawy
# Purpose:      
# Author:      Dariusz Boduch - Micha Raburski
# Created:     2007/06/21
# RCS-ID:      $Id: fs_wydruki_dowod_dostawy.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2011-07-11 Mariusz Rajfura - drukowanie informacji o poziomie zwrotow (4748)
# 2012-09-20 Mariusz Rajfura  (6087) oddzial_id w kluczu
# 2020-05-06 Jan Raburski (11964) wydruk listy opakowan
# 2021-01-04 Wojciech Skowron (12236) format wydruku dowodu 'L'
# 2021-02-04 Wojciech Skowron (12289) Korzystanie z danych archiwalnych
# 2023-05-12 Wojciech Skowron (13390) Zmiana w kolumnach -
#                                     cena_upust1 bez aliasu "netto", pobranie cena_netto1, obliczenie procent_upust

#klucze= trasa,data,tryb_dostawy,numer,oddzial

Trasa=klucze[0]
Data=klucze[1]
Tryb=klucze[2]
Nr=str(klucze[3])
Oddzial=klucze[4]

stat = "OK"
dane = []

WZMag = ''
WZDok = ''
WZData = ''
WZNr = ''

if stat=='OK':
    #--- sprawdzenie nagwka-kontrahent 
    #WS 2021-02-04
    nazwa = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'nazwa') AS nazwa"
    adr_kod = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'adr_kod') AS adr_kod"
    adr_miej = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'adr_miej') AS adr_miej"
    adr_ulica = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'adr_ulica') AS adr_ulica"
    adr_nry = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'adr_nry') AS adr_nry"
    nasz_symb = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'nasz_symb') AS nasz_symb"
    sql = "SELECT dd.kontrahent_id, {nazwa}, {adr_kod}, {adr_miej}, {adr_ulica}, {adr_nry}, k.tel1, k.nip, {nasz_symb},"
    # sql ="SELECT dd.kontrahent_id, k.nazwa, k.adr_kod, k.adr_miej, k.adr_ulica, k.adr_nry, k.tel1, k.nip, k.nasz_symb,"
    sql+="COALESCE(wz_magazyn_id,'') AS wz_mag,COALESCE(wz_dokument_id,'') AS wz_dok,wz_data,wz_numer,dd.platnik_id"  #JR 2020-05-06 dodanie platnik_id
    sql+=" FROM rs_dowody_dostaw dd"
    sql+=" LEFT OUTER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
    sql+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+Nr+";"
    sql = sql.format(**locals())  #WS 2021-02-04
    stat,daneK,naglK,dump= self.PolSQL.Execute(sql,3)
    DaneK = rssql.RSTableRowset(daneK,naglK)
    if len(daneK)>0:
        kontrahent = DaneK.GetVal(0,"kontrahent_id")
        knazwa = DaneK.GetVal(0,"nazwa")
        WZMag = DaneK.GetVal(0,"wz_mag")
        WZDok = DaneK.GetVal(0,"wz_dok")
        WZData = DaneK.GetVal(0,"wz_data")
        WZNr = str(DaneK.GetVal(0,"wz_numer"))
        platnik = str(DaneK.GetVal(0,"platnik_id"))  #JR 2020-05-06
    else:
        stat='Bd pobrania danych kontrahenta w dowodzie: '+Trasa+', '+Data+', '+Tryb+', '+Nr

if stat=='OK':
    #--- pobranie rnych pl z danych do fakturowania
    CenaD='-1'
    CzyDrukowacOpakowania = False
   
    SQL="SELECT kf.wersja_detaliczna,wc.czy_cena_brutto,kf.czy_drukowac_opakowania_na_dd FROM rs_kontrahenci_fakturowanie kf "
    SQL+=" INNER JOIN rs_wersje_cenowe wc ON (kf.firma_id=wc.firma_id AND kf.wersja_detaliczna=wc.kod)"
    SQL+=" WHERE kf.firma_id='"+self.firma_id+"' AND kf.kontrahent_id='"+str(kontrahent)+"'"
    SQL+=" AND kf.data_od<='"+Data+"' ORDER BY kf.data_od DESC LIMIT 1"
    stat,daneWC,naglWC,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd pobrania wersji cenowej "+stat
    else:
        if len(daneWC)>0:
            WersjaC=rsglobal.Dekoduj(daneWC[0][0])
            if WersjaC not in ('',None, 'None'):
                if daneWC[0][1]:
                    CenaD="rsf_podaj_cene_b1(ddp.firma_id,ddp.artykul_id,'"+WersjaC+"','PLN',ddp.data)"
                else:
                    CenaD="rsf_podaj_cene_dla_kontrahenta(ddp.firma_id, '', 'PLN',ddp.data::TEXT, ddp.artykul_id,'b1','"+WersjaC+"', 0)"
            CzyDrukowacOpakowania = daneWC[0][2]   #JR 2020-05-06
            if not CzyDrukowacOpakowania:    # sprawdzenie czy u platnika nie ma wlaczonego drukowania
                SQL = "SELECT czy_drukowac_opakowania_na_dd FROM rs_kontrahenci_fakturowanie kf "
                SQL += " WHERE kf.firma_id='" + self.firma_id + "' AND kf.kontrahent_id='" + str(platnik) + "'"
                SQL += " AND kf.data_od<='" + Data + "' ORDER BY kf.data_od DESC LIMIT 1"
                stat, daneWC, naglWC, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':
                    stat = "Bd czy drukowa opakowania zwrotne " + stat
                else:
                    if len(daneWC) > 0:
                        CzyDrukowacOpakowania = daneWC[0][0]

if stat=='OK':                             
    #--- pobranie pozycji dowodu z artykuami
    #WS 2023-05-12 - cena_upust1 bez aliasu "netto", pobranie cena_netto1, zalepka na procent_upust (obliczany dalej)
    filtr="ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"' AND ddp.trasa='"+Trasa+"' AND ddp.data='"+Data+"' AND ddp.tryb_dostawy='"+Tryb+"'  AND ddp.numer="+Nr
    pola="ao.obcy_id as artykul_k,ap.obcy_id as artykul_p,ao.obca_nazwa as nazwa_k,ap.obca_nazwa as nazwa_p,ao.obca_jm as obca_jmk, ap.obca_jm as obca_jmp "
    pola+=",ddp.artykul_id as artykul, a.nazwa as nazwa,ddp.ilosc_zam1 as zamowiono,ddp.ilosc_pobr1 as pobrano,ddp.ilosc_dost1 as dostarczono,ddp.ilosc_zwr1 as zwroty, ddp.ilosc_rozst1 as rozstawiono"
    pola+=",ddp.cena_upust1,ddp.stawka_vat as vat,"+CenaD+" as cenadet,ddp.cena_brutto1 as brutto,lower(trim(a.jm1)) as jm"
    pola+=", ddp.cena_netto1, 0 as procent_upust"
    From="rs_dowody_dostaw dd "
    From=From+"LEFT OUTER JOIN rs_dowody_dostaw_pozycje ddp on (dd.firma_id=ddp.firma_id AND dd.oddzial_id=ddp.oddzial_id AND dd.trasa=ddp.trasa AND dd.tryb_dostawy=ddp.tryb_dostawy AND dd.data=ddp.data AND dd.numer=ddp.numer) "
    From=From+"LEFT OUTER JOIN rs_artykuly a on (ddp.firma_id=a.firma_id AND ddp.artykul_id=a.artykul_id) "
    From=From+"LEFT OUTER JOIN rs_artykuly_obce ao on (ddp.firma_id=ao.firma_id AND ddp.artykul_id=ao.artykul_id AND dd.kontrahent_id=ao.kontrahent_id ) "
    From=From+"LEFT OUTER JOIN rs_artykuly_obce ap on (ddp.firma_id=ap.firma_id AND ddp.artykul_id=ap.artykul_id AND dd.platnik_id=ap.kontrahent_id ) " 
    stat,daneP,naglP,dump=self.PolSQL.Execute("Select "+pola+" FROM "+From+" WHERE "+filtr+" AND ddp.artykul_id IS NOT NULL ORDER BY ddp.nr_poz;",3)
    if stat=='OK':
        DaneP = rssql.RSTableRowset2(daneP,naglP)
    else:
        stat= "Bd pobierania danych pozycji dowodu :"+stat
        
    if stat=='OK': 
        #---dane oddzialu
        sql ="SELECT oddzial_id, nazwa, adr_kod, adr_miej, adr_ulica, adr_nry, nip,tel1"
        sql+=" FROM rs_oddzialy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"';"
        stat,daneO,naglO,dump= self.PolSQL.Execute(sql,3)
        DaneO = rssql.RSTableRowset(daneO,naglO)
        if len(daneO)>0:
            oddzial = DaneO.GetVal(0,"oddzial_id")
            onazwa = DaneO.GetVal(0,"nazwa")
        else:   
            stat='Bd pobrania danych oddzialu : '+Oddzial+' '

    if stat=='OK':
        #--dane dowodu
        SQL="SELECT td.opis as topis, dd.trasa as trasa, t.opis as opis, dd.numer::TEXT as numer," # 0-3
        SQL+=" dd.data as data, dd.kierowca as kierowca, k.opis as kopis, dd.tryb_dostawy as tryb, dd.stan as stan," #4-8
        SQL+=" dd.numer_zamowienia as znumer,dd.data_zamowienia as zdata, " # 9-10
        SQL+=" dd.korekta AS korekta,COALESCE(oddzial_id_p,'') AS oddzialp, trasa_p AS trasap,data_p AS datap," #11-14
        SQL+="tryb_dostawy_p AS trybp, numer_p::TEXT AS numerp,dd.czy_zmodyfikowany" # 15-17
        SQL+=" FROM rs_dowody_dostaw dd "
        SQL+=" LEFT OUTER JOIN rs_trasy t on(dd.firma_id=t.firma_id and dd.oddzial_id=t.oddzial_id and dd.trasa=t.kod)"
        SQL+=" LEFT OUTER JOIN rs_kierowcy k on(dd.firma_id=k.firma_id and dd.kierowca=k.kod) "
        SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td on (dd.firma_id=td.firma_id AND dd.tryb_dostawy=td.kod)"
        SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"'AND dd.data='"+Data+"'"
        SQL+=" AND dd.trasa='"+Trasa+"'AND dd.tryb_dostawy='"+Tryb+"' AND dd.numer='"+Nr+"';"
        stat,daneD,naglD,dump= self.PolSQL.Execute(SQL,3)
        DaneD = rssql.RSTableRowset(daneD,naglD)
        if stat<>'OK':
            stat="Bd w pobieraniu danych dowodu :"+stat
        
    if stat=='OK':
        #----CZY DRUKOWA CENY I JAK SORTOWAC
        filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"'" \
              " AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        SQL = "SELECT czy_ceny_na_dowodach, czy_wg_indeksow FROM rs_kontrahenci_fakturowanie WHERE "+filtr
        stat,daneC,naglC,dump=self.PolSQL.Execute(SQL,3)
        DaneC=rssql.RSTableRowset(daneC,naglC)
        if len(daneC)==0:
            daneC=[[True,True]]
    
    if stat=='OK':
        #----pobranie wersji cenowej z danych do fakturowania
        stat,daneWC,naglWC,dump=self.PolSQL.Execute("SELECT wersja_detaliczna FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)
        if stat<>'OK':
            stat="Bd w pobieraniu wersji cenowej z danych do fakturowania: "+stat

    if stat == 'OK':    # JR 2020-05-06
        # ----pobranie czy drukowac opakowania na dd z danych do fakturowania
        SQL = "SELECT czy_drukowac_opakowania_na_dd FROM rs_kontrahenci_fakturowanie kf "
        SQL += " WHERE kf.firma_id='" + self.firma_id + "' AND kf.kontrahent_id='" + str(kontrahent) + "'"
        SQL += " AND kf.data_od<='" + Data + "' ORDER BY kf.data_od DESC LIMIT 1"
        stat, druk, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = "Bd pobrania drukowania opakowac " + stat
        else:
            CzyDrukowacOpakowania = False
            if len(druk) > 0:
                CzyDrukowacOpakowania = druk[0][0]
                if not CzyDrukowacOpakowania:  # sprawdzenie czy u platnika nie ma wlaczonego drukowania
                    SQL = "SELECT czy_drukowac_opakowania_na_dd FROM rs_kontrahenci_fakturowanie kf "
                    SQL += " WHERE kf.firma_id='" + self.firma_id + "' AND kf.kontrahent_id='" + str(platnik) + "'"
                    SQL += " AND kf.data_od<='" + Data + "' ORDER BY kf.data_od DESC LIMIT 1"
                    stat, druk, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':
                        stat = "Bd czy drukowa opakowania zwrotne " + stat
                    else:
                        if len(druk) > 0:
                            CzyDrukowacOpakowania = druk[0][0]

    #----dane Centrali- oddzia '01'
    if stat=='OK':        
        stat,daneG,naglG,dump= self.PolSQL.Execute("SELECT oddzial_id, nazwa, adr_kod, adr_miej, adr_ulica, adr_nry, nip FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='01';",3)
        DaneG = rssql.RSTableRowset(daneG,naglG)
        if stat<>'OK':
            stat="Bd w pobieraniu danych Centrali"
    
    #----czy drukowac zaleglosci
    daneZK=[]
    naglZK=[]
    if stat=='OK':
        SQL="SELECT zaleglosci_dowody_dostaw FROM rs_kontrahenci_fakturowanie WHERE  firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1;"
        stat,daneZ,naglZ,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd sprawdzania danych kontrahenta: '+stat
            dane.append(stat)
        else:
            if len(daneZ)>0:
                if daneZ[0][0]:
                    SQL="SELECT CASE WHEN (wyznacznik_id IS NOT NULL AND data IS NOT NULL AND numer IS NOT NULL) "
                    SQL+=" THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||wyznacznik_id||'\",\"'||data||'\",\"'||numer||'\"]',typ_dok)"
                    SQL+=" ELSE wyznacznik_id||'/'||data||'/'||numer END, " 
                    SQL+="  data, termin_zaplaty, do_zaplaty "
                    SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND typ_dok in ('F','K') AND ureg_kwota=0 "
                    SQL+=" AND kontrahent_id='"+kontrahent+"' AND termin_zaplaty<='"+Data+"'"
                    SQL+=" ORDER BY  data, numer, wyznacznik_id ; "
                    stat,daneZK,naglZK,dump=self.PolSQL.Execute(SQL,3) 

    #----czy drukowac poziom zwrotow
    daneZWR = []
    naglZWR = []
    if stat == 'OK':
        # pobranie z danych do fakturowania
        sql ="SELECT drukowac_poziom_zwrotow"
        sql+=" FROM rs_kontrahenci_fakturowanie "
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+rsglobal.Dekoduj(kontrahent)+"'"
        sql+=" AND data_od<='"+Data+"'"
        sql+=" ORDER BY data_od DESC LIMIT 1;"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych do fakturowania: '+stat
            dane.append(stat)
        elif len(d) == 1 and d[0][0]:
            # pobranie poziomu dla oddzialu z dowodu
            sql ="SELECT procent_zwrotow,procent_zwrotow_wartosc"
            sql+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"'"
            sql+=" AND artykul_id IS NULL AND oddzial_id='"+Oddzial+"';"
    
            stat,daneZWR,naglZWR,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o zwrotach dla oddziau: '+stat
                dane.append(stat)
            elif len(daneZWR) == 0:
                # pobranie poziomu dla oddzialu '**'
                sql ="SELECT procent_zwrotow,procent_zwrotow_wartosc"
                sql+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"'"
                sql+=" AND artykul_id IS NULL AND oddzial_id='**';"
    
                stat,daneZWR,naglZWR,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania informacji o zwrotach: '+stat
                    dane.append(stat)
                    
    #----- pobieramy Nr Kontrahenta
    if stat == 'OK':
        NrKontrahenta=''
        SQL="SELECT rsf_podaj_numer_obcy_kontrahenta('"+self.firma_id+"','"+Oddzial+"','"+Trasa+"','"+Data+"','"+Tryb+"',"+Nr+");"
        stat,DaneNrKontr,Dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = 'Bd pobrania informacji o numerze kontrahenta: '+stat
            dane.append(stat)
        elif len(DaneNrKontr)>0:
            NrKontrahenta=DaneNrKontr[0][0]
         
    #------ pobieramy informacje o potencjalnej blokadzie kontrahenta
    if stat == 'OK':
        DataBlokady=''
        from funkcje import fs_blokada_kontr_pom
        stat,LKontr=fs_blokada_kontr_pom.PodajListeKontrahentowDoBlokady(self.PolSQL,self.firma_id,Data,True,4,kontrahent,4)
        if stat<>'OK':
            stat='Bd sprawdzania blokady kontrahenta '+stat
        elif len(LKontr)>0:
            if '-' in LKontr[0][2]:
                DataBlokady=LKontr[0][2]
            else:
                DataBlokady=Data

    #------ pobieramy informacje o potencjalnych paletach do wydrukowania
    if stat == 'OK':
        SQL= "SELECT ddp.paleta_id,p.opis,ddp.liczba_palet FROM rs_dowody_dostaw_palety ddp"
        SQL+=" INNER JOIN rs_palety p USING (firma_id,paleta_id)"
        SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"' AND ddp.trasa='"+Trasa+"'"
        SQL+=" AND ddp.data='"+Data+"' AND ddp.tryb_dostawy='"+Tryb+"' AND ddp.numer="+Nr+" AND ddp.drukowac;"
        stat,DPalety,NPalety,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd sprawdzania palet do wydruku: '+stat

    if stat == 'OK':
        SQL = "SELECT nr_poz,termin_przyd, SUM(ilosc1) FROM rs_dokumenty_magazynowe_pozycje"

    # sprawdzamy, czy z dowodem dostawy jest powizany dokument magazynowy
    if stat == 'OK':
        DTerminy = []
        if WZMag != '' and WZDok != '':
            # jeli tak to sprawdzamy czy jest zamknity
            FiltrDM = "firma_id='"+self.firma_id+"' AND magazyn_id='"+WZMag+"' AND dokument_id= '"+WZDok+"'" \
                    " AND data = '"+WZData+"' AND numer = "+WZNr

            SQL = "SELECT stan FROM rs_dokumenty_magazynowe WHERE "+FiltrDM
            stat,DDokMag,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd sprawdzania stanu dokumentu magazynowego: '+stat

            if stat == 'OK':
                # jeli jest zamknity to pobieramy terminy przydatnoci jeli s wpisane
                if len(DDokMag) > 0:
                    if DDokMag[0][0] in ['Z','K']:

                        SQL = "SELECT nr_poz,termin_przyd,SUM(ilosc1) FROM rs_dokumenty_magazynowe_pozycje " \
                              " WHERE "+FiltrDM+ " AND NOT termin_przyd IS NULL GROUP BY nr_poz,termin_przyd "
                        stat,DTerminy,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat='Bd pobrania terminw przydatnoci z pozycji dokumentu magazynowego: '+stat

    # budujemy sownik do terminw przydatnoci (klucz to pozycja, a wynik to lista tupli (termin, ilo) )
    if stat == 'OK':
        STerminy = {}
        for poz in DTerminy:
            if not poz[0] in STerminy:
                STerminy[poz[0]] = []
            STerminy[poz[0]].append([poz[1],poz[2]])

    #------ pobieramy informacje o opakowaniach zwrotnych
    if stat == 'OK':
        OpakZwr = []
        if CzyDrukowacOpakowania:
            SQL= "SELECT TRIM(artykul_id) || ' ' || nazwa FROM rs_artykuly"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND rotacja AND rotacja_na_dd ORDER BY artykul_id;"
            stat,OpakZwr,dumo,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania opakowa zwrotnych: '+stat

    #------ format wydruku dowodu  #WS 2021-01-04
    FormatWydrukuDowodu = ''
    if stat == 'OK':
        SQL="SELECT format_dowodu_dostawy FROM rs_kontrahenci_fakturowanie "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND data_od<='"+Data+"'"
        SQL+="ORDER BY data_od DESC LIMIT 1;"
        stat,daneFWD,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = 'Bd pobrania formatu wydruku dowodu kontrahenta: '+stat
            dane.append(stat)
        elif len(daneFWD) > 0:
            FormatWydrukuDowodu = daneFWD[0][0]

    #------ % upust  #WS 2023-05-12
    if stat == 'OK':
        for i in range(len(daneP)):
            if DaneP[0]['cena_netto1'] != 0:
                daneP[i][19] = rsglobal.RSRound(((DaneP[i]['cena_netto1'] - DaneP[i]['cena_upust1']) / DaneP[i]['cena_netto1']) * 100.0, 2)

if stat =='OK':
    #WS 2021-01-04 - FormatWydrukuDowodu
    dane=str([daneP,naglP,daneK,naglK,daneO,naglO,daneD,naglD,daneC,naglC,daneG,naglG,
          daneZK,naglZK,daneZWR,naglZWR,NrKontrahenta,DataBlokady,DPalety,NPalety,STerminy,OpakZwr,FormatWydrukuDowodu])
