#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_wydruki_dowod_wz.py
# Purpose:          wydruk dowodu wz jesli dostawy uproszczone
# Author:           Dariusz Boduch
# Created:          2008/11/24
# RCS-ID:           $Id: fs_wydruki_dowod_wz.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# 2012-09-21 Mariusz Rajfura     (6087) przekazanie oddzial_id w kluczu
# 2020-12-22 Aleksander Bargie (12230) [SP] zmiana wydruku d.d.
# 2021-01-20 Aleksander Bargie (12279) [SP] zmiany w wydruku d.d.
# 2021-01-28 Aleksander Bargie (12293) Uproszczone DD z ustawion faktur zbiorcz - poprawi kiedy drukowana jest budowa
# 2021-02-04 Wojciech Skowron   (12289) Korzystanie z danych archiwalnych


#klucze: Trasa,Data,Tryb,Numer,Oddzial
Trasa=klucze[0]
Data=klucze[1]
Tryb=klucze[2]
Numer=klucze[3]
Oddzial=klucze[4]

stat = "OK"
dane = []
#sprawdzenie poprawnosci danych
if Trasa.strip() in (None,'','None') and stat=='OK':
    stat='Brak trasy'
if Data in (None,'    -  -  ','None') and stat=='OK':
    stat='Brak daty'
if Data not in (None,'    -  -  ','None') and stat=='OK':
     if not rsglobal.SprawdzCzyToData(Data):
            stat='Bdna data'
if Tryb.strip() in (None,'','None') and stat=='OK':
    stat='Brak trybu'
if Numer in (None,'','None') and stat=='OK':
    stat='Brak Numeru'
if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
else:
    UprPrz=(self.oddzial_id,'028021') in self.uprawnienia

if not UprPrz:
    stat='UPR PRZ'

#AB 22.12.20r.
if stat == 'OK':
    stat, czy_zbiorcza, dump, dump = self.PolSQL.Execute("SELECT czy_zbiorcza_dla_oddzialow FROM rs_firmy WHERE firma_id = '{}';".format(self.firma_id), 3)
    if stat != 'OK':
        stat = 'Bd pobierania danych firmy'
    else:
        if len(czy_zbiorcza) == 0:
            stat = 'Brak danych firmy'


if stat=='OK' and czy_zbiorcza[0][0]: #AB 28.01.21r powrot do oddzielnego kodu i nazwy kontrahenta
    #WS 2021-02-04 - podmiana odb.nazwa/bud.nazwa/prze.nazwa na rsf
    odb_nazwa = "rsf_podaj_pole_z_danych_kontrahenta(odb.firma_id, odb.kontrahent_id, '"+Data+"', 'nazwa')"
    bud_nazwa = "rsf_podaj_pole_z_danych_kontrahenta(bud.firma_id, bud.kontrahent_id, '"+Data+"', 'nazwa')"
    prze_nazwa = "rsf_podaj_pole_z_danych_kontrahenta(prze.firma_id, prze.kontrahent_id, '"+Data+"', 'nazwa')"
    SQL = """SELECT dd.oddzial_id, data, trasa, numer, tryb_dostawy, coalesce(samochod, '') as samochod, kierowca, 
             k.opis AS kierowca_opis, COALESCE(ro.opis, '') as oddzial, COALESCE(ro.tel1, '') as tel1, COALESCE(cen.nazwa,'') as centrala_nazwa, 
             COALESCE(cen.adr_ulica, '') as adr_ulica, COALESCE(cen.adr_nry, '') as adr_nry, COALESCE(cen.adr_kod, '') as adr_kod, 
             COALESCE(cen.adr_miej, '') as adr_miej, COALESCE(dd.platnik_id, '') as platnik_id, {odb_nazwa} as platnik_nazwa, 
             dd.kontrahent_id, {bud_nazwa} as budowa, przewoznik_id, {prze_nazwa} as przewoznik, coalesce(budowa, '') AS uwagi
             FROM rs_dowody_dostaw dd
             JOIN rs_kierowcy k ON (dd.firma_id, dd.kierowca) = (k.firma_id, k.kod)
             JOIN rs_oddzialy ro ON (dd.firma_id, dd.oddzial_id) = (ro.firma_id, ro.oddzial_id)
             JOIN rs_oddzialy cen ON (dd.firma_id, TRUE) = (cen.firma_id, cen.centrala)
             FULL OUTER JOIN rs_kontrahenci odb ON (dd.firma_id, dd.platnik_id) = (odb.firma_id, odb.kontrahent_id)
             JOIN rs_kontrahenci bud ON (dd.firma_id, dd.kontrahent_id) = (bud.firma_id, bud.kontrahent_id)
             JOIN rs_kontrahenci prze ON (dd.firma_id, dd.przewoznik_id) = (prze.firma_id, prze.kontrahent_id)
             WHERE dd.firma_id='{self.firma_id}' AND dd.oddzial_id='{Oddzial}' AND trasa='{Trasa}' AND "data"='{Data}' AND tryb_dostawy='{Tryb}' AND numer={Numer};
             """.format(**locals())
    rsglobal.ZapiszDoLogow(SQL)
    stat, daneN, naglN, dump = self.PolSQL.Execute(SQL, 3)
    if stat != "OK":
        stat = "Bd w pobieraniu danych dowodu dostawy"
    else:
        if len(daneN)==0:
            stat = 'Brak danych dowodu dostawy'
else:
    if stat=='OK':

       #pobieranie danych nagwka
        SELECT="SELECT kierowca,kierowca2,samochod,samochod2,kontrahent_id,CAST(numer AS TEXT) as numer,budowa "
        FROM="FROM rs_dowody_dostaw "
        WHERE="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' "
        WHERE+="AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)+" ;"
        stat,daneN,naglN,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
        if stat!="OK":
            stat="Bd w pobieraniu danych dowodu dostawy"
        else:
            if len(daneN)==0:
                stat='Brak danych dowodu dostawy'

    if stat=='OK':
        DaneN = rssql.RSTableRowset(daneN,naglN)
        Kontrahent=DaneN.GetVal(0,"kontrahent_id")
        Kierowca1=DaneN.GetVal(0,"kierowca")
        Kierowca2=DaneN.GetVal(0,"kierowca2")
        #pobieranie danych oddzialu
        SELECT = "SELECT oddzial_id,nazwa,nazwa1,nazwa2,adr_kod,adr_poczta,adr_miej,adr_ulica,adr_nry,regon,nip,tel1,tel2,fax,email "
        FROM = "FROM rs_oddzialy "
        WHERE = "WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' ;"
        stat,daneO,naglO,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
        if stat!='OK':
            stat="Bd pobierania danych oddziau"
        else:
            if len(daneO)==0:
                stat='Brak danych oddziau'

    if stat=='OK':
        #pobieranie danych kontrahenta
        SELECT = "SELECT kontrahent_id,nazwa,adr_kod,adr_poczta,adr_miej,adr_ulica,adr_nry, tel1,nip "
        #WS 2021-02-04
        FROM = " FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+Kontrahent+"','"+Data+"') "
        WHERE = ";"
        # FROM = " FROM rs_kontrahenci "
        # WHERE = "WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"' ;"
        stat,daneK,naglK,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
        if stat!='OK':
            stat='Bd pobierania danych kontrahenta'
        else:
            if len(daneK)==0:
                stat='Brak danych kontrahenta'
    if stat=='OK':
        #pobieranie danych kierowcy1
        stat,daneK1,naglK1,dump=self.PolSQL.Execute("SELECT opis FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+Kierowca1+"' ;",3)
        if stat!='OK':
            stat='Bd pobierania danych kierowcy'
        else:
            if len(daneK1)==0:
                stat='Brak danych kierowcy'


    if stat=='OK':
        if len(Kierowca2.strip())>0:
        #pobieranie danych kierowcy2
            stat,daneK2,naglK2,dump=self.PolSQL.Execute("SELECT opis FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+Kierowca2+"' ;",3)
            if stat!='OK':
                stat='Bd pobierania danych kierowcy 2'
            else:
                if len(daneK1)==0:
                    stat='Brak danych kierowcy 2'

if stat=='OK':
    #pobieranie pozycji dowodu
    filtr="ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"' AND ddp.trasa='"+Trasa+"' AND ddp.data='"+Data+"' AND ddp.tryb_dostawy='"+Tryb+"'  AND ddp.numer="+str(Numer)
    pola="ao.obcy_id as artykul_k,ap.obcy_id as artykul_p,ao.obca_nazwa as nazwa_k,ap.obca_nazwa as nazwa_p,ao.obca_jm as obca_jmk, ap.obca_jm as obca_jmp,ddp.artykul_id as artykul, a.nazwa as nazwa,ddp.ilosc_pobr1 as pobrano,lower(trim(a.jm1)) as jm"
    From="rs_dowody_dostaw dd "
    From=From+"LEFT OUTER JOIN rs_dowody_dostaw_pozycje ddp on (dd.firma_id=ddp.firma_id AND dd.oddzial_id=ddp.oddzial_id AND dd.trasa=ddp.trasa AND dd.tryb_dostawy=ddp.tryb_dostawy AND dd.data=ddp.data AND dd.numer=ddp.numer) "
    From=From+"LEFT OUTER JOIN rs_artykuly a on (ddp.firma_id=a.firma_id AND ddp.artykul_id=a.artykul_id) "
    From=From+"LEFT OUTER JOIN rs_artykuly_obce ao on (ddp.firma_id=ao.firma_id AND ddp.artykul_id=ao.artykul_id AND dd.kontrahent_id=ao.kontrahent_id ) "
    From=From+"LEFT OUTER JOIN rs_artykuly_obce ap on (ddp.firma_id=ap.firma_id AND ddp.artykul_id=ap.artykul_id AND dd.platnik_id=ap.kontrahent_id ) "
    stat,daneP,naglP,dump=self.PolSQL.Execute("Select "+pola+" FROM "+From+" WHERE "+filtr+" AND ddp.artykul_id IS NOT NULL ORDER BY ddp.nr_poz;",3)
    DaneP = rssql.RSTableRowset(daneP,naglP)
#AB 22.12.20r.
if not czy_zbiorcza[0][0]:
    if stat=='OK':
        #--- pobranie sporzdzajcego
        stat,daneS,naglS,dump= self.PolSQL.Execute("SELECT imie,nazwisko FROM rs_operatorzy WHERE operator_id ="+str(self.operator_id),3)

        if stat !="OK":
            stat="Bdy w pobieraniu sporzdzajcego"

    if stat=='OK':
        #--- pobranie danych centrali
        stat,daneCentr,naglCentr,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        if stat<>"OK":
            stat = 'Bdy w pobieraniu danych centrali.'
            dane.append(stat)

    if stat=='OK':
        #           0     1     2     3     4     5      6     7      8      9      10    11    12   13
        dane=str([daneN,naglN,daneO,naglO,daneK,naglK,daneK1,naglK1,daneK2,naglK2,daneP,naglP,daneS,naglS,daneCentr,naglCentr])

#AB 22.12.20r.
elif stat == 'OK' and czy_zbiorcza[0][0]:
    dane = str([daneN, naglN, daneP, naglP])

