# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_faktura.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/01/23
# RCS-ID:      $Id: fs_wydruki_faktura.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-08-16 Mariusz Rajfura     (6002) przekazanie listy paragonow do faktury
# 2012-09-21 Mariusz Rajfura     (6096) pobranie opcji 'tylko_numery_dowodow_dostaw'
# 2019-01-23 Wojciech Skowron   (11359) pobranie nr_bdo do daneOddz/daneDod
# 2019-03-20 Wojciech Skowron   (11329) pobranie 'czy_pdf_z_dowodami_dostaw'
# 2019-04-08 Wojciech Skowron   (11329) pobieranie 'cena_przed_upustem', 'tylko_numery_dowodow_dostaw'
#                                       i 'czy_pdf_z_dowodami_dostaw' najpierw dla kontrahenta, a potem ew. dla patnika
# 2019-07-31 Wojciech Skowron   (11569) pobranie 'czy_mpp' do daneN
# 2020-07-09 Aleksander Bargie (12044) Wydruki faktur - kod CN
# 2021-02-04 Wojciech Skowron   (12289) Korzystanie z danych archiwalnych
# 2021-02-23 Wojciech Skowron   (12316) Pobranie danych o DD do dostawy-upust2
# 2021-02-26 Wojciech Skowron   (12363) Grupowanie i sortowanie DD na wydruku dostawy-upust2 po dp.cena_upust1
# 2021-03-01 Wojciech Skowron   (12363) Pobranie 'atest' z rs_artykuly

from funkcje import fs_global_konta

#klucze= data,wyznacznik,numer,CzyDrukowacBiuro
Data=klucze[0]
Wyzn=klucze[1]
Nr=str(klucze[2])
CzyDrB=klucze[3]

stat = "OK"
dane = []

CzyOdwrotneObciazenie=False

#pobranie wyznacznikw dostpnych
Lista=[self.firma_id,self.oddzial_id,'',self.operator_id]
sql = "SELECT rsf_podaj_liste_wyznacznikow('"+str(Lista).replace("'",'"')+"','"+str([]).replace("'",'"')+"','"+str([]).replace("'",'"')+"','"+str([]).replace("'",'"')+"');"
stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat<>"OK":
    stat = 'Bd w pobieraniu wyznacznikw.'
    dane.append(stat)

LW=wyzn[0][0]
if not Wyzn in LW:
    stat='Brak uprawnie do wydruku faktury z tym wyznacznikiem.'
    dane.append(stat)
#jeli uprawniony wyznacznik    
if stat=='OK':
    Filtr="firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
    Firma=self.firma_id
    KlPom=str([Wyzn,Data,Nr]).replace("'",'"')
    #dane nagwka faktury
    
    SELECT="SELECT stan, numer_z_rs,wersja,handlowiec,oddzial_id,kontrahent_id,zamawiajacy_id,platnik_id "
    SELECT+=",miejsce_dostawy_id,kwota_netto,kwota_vat,do_zaplaty,termin_zaplaty,sposob_zaplaty,kraj_opodatkowania "
    SELECT+=",waluta,kwota_netto_wal,do_zaplaty_wal,kwota_vat_wal "
    SELECT+=", rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','F') as nr_fakt, opis as opis_fakt, kwota_vat_wal "
    SELECT+=", waga,nr_samochodu,data_zaladunku,data_przychodu,zamowienie_nr "
    SELECT+=", dostawy_od_dnia, dostawy_do_dnia "
    SELECT+=", czy_mpp " #WS 2019-07-31
    stat,daneN,naglN,dump= self.PolSQL.Execute(SELECT+" FROM rs_faktury WHERE "+Filtr+";",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych faktury.'
        dane.append(stat)
if stat=='OK': 
    DaneN = rssql.RSTableRowset(daneN,naglN)
    #dane stawek i wartoci vat
    stat,daneSV,naglSV,dump= self.PolSQL.Execute("SELECT wartosc_netto,opis,wartosc_vat,wartosc_brutto,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,stawka_vat FROM rs_faktury_vat fv INNER JOIN rs_stawki_vat sv ON (fv.stawka_vat=sv.kod) WHERE "+Filtr+";",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych stawek VAT faktury.'
        dane.append(stat)
if stat=="OK":    
    DaneSV = rssql.RSTableRowset(daneSV,naglSV)
    #dane opisu sposobu zapaty
    stat,daneSP,naglSP,dump= self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+DaneN.GetVal(0,"sposob_zaplaty")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu opisu sposobu zapaty.'
        dane.append(stat)
if stat=="OK":    
    DaneSP = rssql.RSTableRowset(daneSP,naglSP)
    #dane oddziau wystawiajcego faktur
    #WS 2019-01-23
    # stat,daneOddz,naglOddz,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,adk_kod as adrk_kod,adk_miej as adrk_miej,adk_poczta as adrk_poczta,adk_ulica as adrk_ulica,adk_nry as adrk_nry,nr_gios,konto_bank,konto_nr,faktura_miej FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    stat,daneOddz,naglOddz,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,adk_kod as adrk_kod,adk_miej as adrk_miej,adk_poczta as adrk_poczta,adk_ulica as adrk_ulica,adk_nry as adrk_nry,nr_gios,konto_bank,konto_nr,faktura_miej,nr_bdo FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych oddziau.'
        dane.append(stat)
        
if stat=='OK':
    # podmiana nazwy i numeru konta bankowego jeli kontrahent ma wpisane subkonto
    kontrahent=DaneN.GetVal(0,"kontrahent_id")
    platnik = DaneN.GetVal(0,"platnik_id")
    Konto=''
    
    if not platnik in ('',None,'None',kontrahent):
        SQL="SELECT platnosc_subkonto FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"'"
        SQL+=" AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,DKontaBankowego,dump,dump= self.PolSQL.Execute(SQL,3)        
        if stat=='OK':
            if len(DKontaBankowego)>0:
                if not DKontaBankowego[0][0] in ('',None):
                    Konto=rsglobal.Dekoduj(DKontaBankowego[0][0])        
                    
    if Konto=='' and stat=='OK':
        SQL="SELECT platnosc_subkonto FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"'"
        SQL+=" AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,DKontaBankowego,dump,dump= self.PolSQL.Execute(SQL,3)        
    
        if stat=='OK':
            if len(DKontaBankowego)>0:
                if not DKontaBankowego[0][0] in ('',None,'None'):
                    Konto=rsglobal.Dekoduj(DKontaBankowego[0][0])
          
if stat=='OK' and Konto <> '':
    KNazwa=fs_global_konta.PodajNazweBankuKonta(self,Konto)
    if KNazwa[:4] =='BLAD':
        stat='Bd pobierania nazwy konta bankowego z subkonta'
    elif not KNazwa=='Brak':
        # brutalne podstawienie nazwy konta i samego konta w danych oddziau
        daneOddz[0][18]=KNazwa
        daneOddz[0][19]=Konto
    
if stat=="OK":
    #czy drukowa biuro - pobranie danych centrali
    if CzyDrB:
        #WS 2019-01-23
        # stat,daneDod,naglDod,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry, adk_kod as adrk_kod,adk_miej as adrk_miej, adk_poczta as adrk_poczta,adk_ulica as adrk_ulica,adk_nry as adrk_nry,nr_gios,konto_bank,konto_nr FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        stat,daneDod,naglDod,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry, adk_kod as adrk_kod,adk_miej as adrk_miej, adk_poczta as adrk_poczta,adk_ulica as adrk_ulica,adk_nry as adrk_nry,nr_gios,konto_bank,konto_nr,nr_bdo FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        if stat<>"OK":
            stat = 'Bdy w pobieraniu danych centrali.'
            dane.append(stat)  
    else:
        daneDod=None
        naglDod=None
if stat=="OK":        
    #wybr sposobu sortowania artykuw na fakturze
    filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
    stat,daneC,naglC,dump=self.PolSQL.Execute("SELECT czy_ceny_na_dowodach, czy_wg_indeksow FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu sposobu indeksowania artykuw\nna fakturze.'
        dane.append(stat)
    if len(daneC) >0:
        DaneC=rssql.RSTableRowset(daneC,naglC)    
        Sort1=DaneC.GetVal(0,"czy_wg_indeksow")
    else:
        filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,daneC,naglC,dump=self.PolSQL.Execute("SELECT czy_ceny_na_dowodach, czy_wg_indeksow FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)
        if stat<>"OK":
            stat = 'Bd w pobieraniu sposobu indeksowania artykuw\nna fakturze.'
            dane.append(stat)
        if len(daneC) >0:
            DaneC=rssql.RSTableRowset(daneC,naglC)    
            Sort1=DaneC.GetVal(0,"czy_wg_indeksow")
        else:
            Sort1=False
        
    if Sort1:
        OrderBy= "CASE WHEN (fp.nr_ppoz=0 OR NOT fp.zestaw) THEN COALESCE(ao.obcy_id,'')"
        OrderBy+=" ELSE (SELECT COALESCE(pao.obcy_id,'') "
        OrderBy+=" FROM rs_faktury_pozycje pfp LEFT OUTER JOIN rs_artykuly_obce pao "
        OrderBy+=" ON (pao.firma_id=pfp.firma_id AND pao.kontrahent_id=f.kontrahent_id "
        OrderBy+=" AND pao.artykul_id=pfp.artykul_id) "
        OrderBy+=" WHERE pfp.firma_id='"+self.firma_id+"' AND pfp.wyznacznik_id='"+Wyzn+"' AND pfp.data='"+Data+"'"
        OrderBy+=" AND pfp.numer="+Nr+" AND pfp.nr_poz=fp.nr_poz AND pfp.nr_ppoz=0"
        OrderBy+="  ) END,"
        OrderBy+= "CASE WHEN (fp.nr_ppoz=0 OR NOT fp.zestaw) THEN fp.artykul_id"
        OrderBy+=" ELSE (SELECT pfp.artykul_id "
        OrderBy+=" FROM rs_faktury_pozycje pfp WHERE pfp.firma_id='"+self.firma_id+"'"
        OrderBy+=" AND pfp.wyznacznik_id='"+Wyzn+"' AND pfp.data='"+Data+"'"
        OrderBy+=" AND pfp.numer="+Nr+" AND pfp.nr_poz=fp.nr_poz AND pfp.nr_ppoz=0"
        OrderBy+="  ) END,"
        OrderBy+= "CASE WHEN (fp.nr_ppoz=0 OR NOT fp.zestaw) THEN '' ELSE COALESCE(ao.obcy_id,'') END,"
        OrderBy+= "CASE WHEN (fp.nr_ppoz=0 OR NOT fp.zestaw) THEN '' ELSE fp.artykul_id END"
    else:
        OrderBy='fp.nr_poz,fp.nr_ppoz'
if stat=="OK":  
    #pobranie pozycji normalnych
    Jm='CASE WHEN a.faktura_w_jm2 THEN UPPER(a.jm2) ELSE UPPER(jm1) END AS jm1'
    Ilosc='CASE WHEN a.faktura_w_jm2 THEN fp.ilosc2 ELSE fp.ilosc1 END AS ilosc1'
    CenaNU='CASE WHEN a.faktura_w_jm2 THEN fp.cena_upust2 ELSE fp.cena_upust1 END AS cena_upust1'
    CenaNUWal='CASE WHEN a.faktura_w_jm2 THEN fp.cena_upust_wal2 ELSE fp.cena_upust_wal1 END AS cena_upust_wal1'
    CenaB='CASE WHEN a.faktura_w_jm2 THEN fp.cena_brutto2 ELSE fp.cena_brutto1 END AS cena_brutto1'
    CenaN1DoUpustu='CASE WHEN a.faktura_w_jm2 THEN fp.cena_netto2 ELSE fp.cena_netto1 END AS cena_netto1'
    
    Pola=" ao.obcy_id as obcy_idk, ao.obca_nazwa as obca_nazwak,upper(ao.obca_jm) as obca_jmk, ap.obcy_id as obcy_idp, "
    Pola+=" ap.obca_nazwa as obca_nazwap, upper(ap.obca_jm) as obca_jmp,CAST(fp.nr_poz AS TEXT) as poz,CAST(fp.nr_ppoz AS TEXT) as ppoz, "
    #AB 13.07.20
    Pola+=" a.nazwa as nazwa,"
    Pola+=" coalesce((SELECT COALESCE(CASE WHEN kod_cn = '' THEN NULL ELSE kod_cn END, sww_pkwiu, '') "
    Pola+="  FROM rs_artykuly_stawki_vat "
    Pola+="  WHERE firma_id=fp.firma_id AND artykul_id=fp.artykul_id AND od_dnia<=fp.data "
    Pola+="  ORDER BY od_dnia DESC LIMIT 1), '') as sww_pkwiu, "
    # Pola+="rsf_podaj_sww_pkwiu_artykulu(fp.firma_id,fp.artykul_id,fp.data::TEXT) AS sww_pkwiu,"
    Pola+=Jm+","+Ilosc+","+CenaNU+",fp.wartosc_netto,sv.opis,fp.wartosc_vat, "
    Pola+=" fp.wartosc_brutto,fp.nr_serii, fp.artykul_id,"+CenaNUWal+",fp.wartosc_wal_netto, fp.wartosc_wal_vat,fp.wartosc_wal_brutto, "+CenaB+", "
    Pola+=CenaN1DoUpustu+" ,fp.cena_netto2,cena_wal1, cena_wal2, fp.upust as upust, fp.upust_wartosc as wart_upust, "
    Pola+=" fp.cecha1_opis,TRIM(COALESCE(fp.cecha1_wartosc,'')) AS cecha1_wartosc, COALESCE(zestaw,FALSE) AS zestaw, "
    Pola+=" a.atest"  #WS 2021-03-01

    From='  FROM rs_faktury_pozycje fp INNER JOIN rs_faktury f ON (f.firma_id=fp.firma_id AND f.wyznacznik_id=fp.wyznacznik_id '
    From+=' AND f.data=fp.data AND f.numer=fp.numer) INNER JOIN rs_artykuly a ON (f.firma_id=a.firma_id AND fp.artykul_id=a.artykul_id) '
    From+=' INNER JOIN rs_stawki_vat sv ON fp.stawka_vat=sv.kod LEFT OUTER JOIN rs_artykuly_obce ao '
    From+=' ON (f.firma_id=ao.firma_id AND f.kontrahent_id=ao.kontrahent_id AND fp.artykul_id=ao.artykul_id) '
    From+=' LEFT OUTER JOIN rs_artykuly_obce ap ON (f.firma_id=ap.firma_id AND f.platnik_id=ap.kontrahent_id '
    From+=' AND fp.artykul_id=ap.artykul_id)'
    SELECT="SELECT "+Pola+From+" WHERE f.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+Wyzn+"' AND f.data='"+Data+"' AND f.numer="+Nr+" ORDER BY "+OrderBy+";"
    stat,daneP,naglP,dump= self.PolSQL.Execute("SELECT "+Pola+From+" WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"' AND fp.data='"+Data+"' AND fp.numer="+Nr+" ORDER BY "+OrderBy+";",3)
    if stat<>"OK":
        rsglobal.ZapiszDoLogow("SELECT "+Pola+From+" WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"' AND fp.data='"+Data+"' AND fp.numer="+Nr+" ORDER BY "+OrderBy+";")
        stat='Bd w pobieraniu pozycji faktury.'
        dane.append(stat)
if stat=="OK":   
    #pobranie pozycji opisowych
    Pola=' CAST(fpo.nr_poz AS TEXT),fpo.opis_pozycji,fpo.wartosc_netto,sv.opis,fpo.wartosc_vat,fpo.wartosc_brutto, '
    Pola+='fpo.wartosc_wal_netto, fpo.wartosc_wal_vat, fpo.wartosc_wal_brutto'
    From=' FROM rs_faktury_pozycje_opisowe fpo LEFT OUTER JOIN rs_stawki_vat sv ON fpo.stawka_vat=sv.kod '
    stat,daneO,naglO,dump= self.PolSQL.Execute("SELECT "+Pola+From+" WHERE "+Filtr+" ORDER BY fpo.nr_poz;",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu pozycji opisowych faktury.'
        dane.append(stat)
    elif len(daneP)+len(daneO)==0:
        stat = 'Brak wprowadzonych pozycji na fakturze.'
        dane.append(stat)
if stat=="OK":    
    #tekst przed i po stopce,teks naglowka,wsprzdne pocztku wydruku adresu odbiorcy faktury - koperta 
    SQLWyzn="SELECT tekst_nad_podp,tekst_pod_podp, tekst_naglowka, koperta_wiersz, koperta_kolumna,"
    SQLWyzn+="typ_faktury,adres_korespondencyjny,data_tekst FROM rs_wyznaczniki "
    SQLWyzn+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';"
    stat,daneW,naglW,dump= self.PolSQL.Execute(SQLWyzn,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu tekstu przed i pod podpisem.'
        dane.append(stat)
if stat=="OK":
    #dane podpisu
    stat,danePodp,naglPodp,dump= self.PolSQL.Execute("SELECT czy_upow FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"kontrahent_id")+"' AND data_od < '"+Data+"' ORDER BY data_od ASC LIMIT 1;",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych dot. podpisu odbiorcy.'
        dane.append(stat)
if stat=="OK":    
    #dane kontrahenta
    #WS 2021-02-04
    stat,daneK,naglK,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id, bank_nazwa, bank_konto FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"kontrahent_id")+"','"+Data+"');", 3)
    # stat,daneK,naglK,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id, bank_nazwa, bank_konto FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"kontrahent_id")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych kontrahenta.'
        dane.append(stat)
    DaneK = rssql.RSTableRowset(daneK,naglK)
    #sprawdzenie krajw wszystkich mozliwych miejsc
    #WS 2021-02-04
    k_kraj = "rsf_podaj_pole_z_danych_kontrahenta(f.firma_id, f.kontrahent_id, '"+Data+"', 'kraj')"
    z_kraj = "rsf_podaj_pole_z_danych_kontrahenta(f.firma_id, f.zamawiajacy_id, '"+Data+"', 'kraj')"
    p_kraj = "rsf_podaj_pole_z_danych_kontrahenta(f.firma_id, f.platnik_id, '"+Data+"', 'kraj')"
    md_kraj = "rsf_podaj_pole_z_danych_kontrahenta(f.firma_id, f.miejsce_dostawy_id, '"+Data+"', 'kraj')"
    SQLKraje = "SELECT ({k_kraj}='PL' OR {k_kraj}='') AND ({z_kraj}='PL' OR {z_kraj}='') AND ({p_kraj}='PL' OR {p_kraj}='') AND ({md_kraj}='PL' OR {md_kraj}='') as czy_kraj "
    SQLKraje += " FROM rs_faktury f "
    # SQLKraje= "SELECT (k.kraj='PL' OR k.kraj IS NULL) AND (z.kraj='PL' OR z.kraj IS NULL) AND (p.kraj='PL' OR p.kraj IS NULL) AND (md.kraj='PL' OR md.kraj IS NULL) as czy_kraj "
    # SQLKraje=SQLKraje+"FROM rs_faktury f LEFT OUTER JOIN rs_kontrahenci k ON (f.firma_id=k.firma_id AND f.kontrahent_id=k.kontrahent_id) "
    # SQLKraje=SQLKraje+" LEFT OUTER JOIN rs_kontrahenci z ON (f.firma_id=z.firma_id AND f.zamawiajacy_id=z.kontrahent_id) "
    # SQLKraje=SQLKraje+" LEFT OUTER JOIN rs_kontrahenci p ON (f.firma_id=p.firma_id AND f.platnik_id=p.kontrahent_id) "
    # SQLKraje=SQLKraje+" LEFT OUTER JOIN rs_kontrahenci md ON (f.firma_id=md.firma_id AND f.miejsce_dostawy_id=md.kontrahent_id) "
    SQLKraje=SQLKraje+" WHERE f.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+Wyzn+"' AND f.data='"+Data+"' AND f.numer="+Nr+";"
    SQLKraje=SQLKraje.format(**locals())  #WS 2021-02-04
    stat,daneKraje,naglKraje,dump= self.PolSQL.Execute(SQLKraje,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych kraju kontrahenta.'
        dane.append(stat)
if stat=="OK":    
    #sprawdzenie kraju opodatkowania
    SQLKrajO= "SELECT kraj,nazwa,czy_ue FROM rs_kraje WHERE kraj='"+DaneN.GetVal(0,"kraj_opodatkowania")+"';"
    stat,daneKrajO,naglKrajO,dump= self.PolSQL.Execute(SQLKrajO,3)    
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych kraju opodatkowania.'
        dane.append(stat)
if stat=="OK":
    #sprawdzenie czy faktura jest z paragonu
    SQLPar= "SELECT kasa_id,data,numer FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND f_data='"+Data+"' AND f_numer="+Nr+";"
    stat,danePar,naglPar,dump= self.PolSQL.Execute(SQLPar,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych paragonu.'
        dane.append(stat)
    else:
        ListaParagonow = []
        if len(danePar)>0:
            NrPar=danePar[0][0]+"/"+danePar[0][1]+"/"+str(danePar[0][2])[0:-2]
            
            for i in xrange(len(danePar)):
                ListaParagonow.append(danePar[i][0]+"/"+danePar[i][1]+"/"+rsglobal.UsunKropkaZero(danePar[i][2]))
        else:
            NrPar=''
if stat=="OK":          
    #pobranie danych do zestawienia z dowodw dostaw
    #WS 2021-02-04
    SQL = "SELECT dd.data, CAST(dd.numer AS TEXT), dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.kontrahent_id, rsf_podaj_pole_z_danych_kontrahenta(dd.firma_id, dd.kontrahent_id, '"+Data+"', 'nazwa') AS nazwa,"
    # SQL='SELECT dd.data, CAST(dd.numer AS TEXT), dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.kontrahent_id, ko.nazwa,'
    SQL+=' dp.artykul_id, sum(dp.ilosc_dost1) AS "Dost", sum(dp.ilosc_rozl_f1)*-1 AS "Zwr",dd.numer_mpt,'
    SQL+=" dd.numer_zamowienia, dd.data_zamowienia,"
    SQL+=' rsf_podaj_numer_obcy_kontrahenta(dd.firma_id,dd.oddzial_id,dd.trasa,dd.data,dd.tryb_dostawy,dd.numer) AS "NrObcy"'
    SQL+=" FROM rs_dowody_dostaw_pozycje dp "
    SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
    SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (dd.firma_id=td.firma_id AND dd.tryb_dostawy=td.kod)"
    # SQL+=" LEFT OUTER JOIN rs_kontrahenci ko ON (dd.firma_id=ko.firma_id AND dd.kontrahent_id=ko.kontrahent_id)"  #WS 2021-02-04
    SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.f_wyznacznik_id='"+Wyzn+"' AND dd.f_data='"+Data+"'"
    SQL+=" AND dd.f_numer="+Nr
    SQL+=" GROUP BY dd.firma_id, dd.data, dd.numer, dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.kontrahent_id, nazwa,"  #WS 2021-02-04
    SQL+=" dp.artykul_id, dd.numer_mpt, dd.numer_zamowienia, dd.data_zamowienia, "
    SQL+=" rsf_podaj_numer_obcy_kontrahenta(dd.firma_id,dd.oddzial_id,dd.trasa,dd.data,dd.tryb_dostawy,dd.numer)"
    SQL+=" ORDER BY dd.kontrahent_id, dd.data,dd.oddzial_id,dd.trasa,dd.tryb_dostawy, dd.numer, dp.artykul_id;"
    stat,daneD,naglD,dump= self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych dowodw dostaw.'
        dane.append(stat)
if stat=='OK':
    #pobranie nr telefonu oddziau, w ktrym wystawia si fakture
    stat,daneT,naglT,dump=self.PolSQL.Execute("SELECT tel1, tel2, fax, email, drukowac_podpisy FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+self.oddzial_id+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych dod. oddziau,\nw ktrym wystawiana jest faktura.'
        dane.append(stat)
if stat=="OK":    
    #pobranie danych operatora
    stat,daneOP,naglOP,dump=self.PolSQL.Execute("SELECT imie, nazwisko FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych operatora.'
        dane.append(stat)
if stat=="OK":    
    #dane platnika
    #WS 2021-02-04
    stat,danePL,naglPL,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,pesel,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,adrk_kod,adrk_miej,adrk_poczta,adrk_ulica,adrk_nry,kontrahent_id,nazwa_pelna FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"platnik_id")+"','"+Data+"');", 3)
    # stat,danePL,naglPL,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,pesel,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,adrk_kod,adrk_miej,adrk_poczta,adrk_ulica,adrk_nry,kontrahent_id,nazwa_pelna FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"platnik_id")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych patnika faktury.'
        dane.append(stat)
if stat=='OK':
    #dane zamawiajacego
    #WS 2021-02-04
    stat,daneZAM,naglZAM,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"zamawiajacy_id")+"','"+Data+"');", 3)
    # stat,daneZAM,naglZAM,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"zamawiajacy_id")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych zamawiajcego'
        dane.append(stat)    
if stat=='OK':
    #dane miejsca dostawy
    #WS 2021-02-04
    stat,daneMiejDost,naglMiejDost,dump=self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"miejsce_dostawy_id")+"','"+Data+"');", 3)
    # stat,daneMiejDost,naglMiejDost,dump=self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"miejsce_dostawy_id")+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych miejsca dostawy'
        dane.append(stat)
if stat=='OK':
    #pobranie odsetek za zwloke
    stat,daneProc,naglProc,dump=self.PolSQL.Execute("SELECT odsetki_zobow,odsetki_nalez,odsetki_podat FROM rs_procenty_odsetek WHERE firma_id='"+self.firma_id+"' and data_od = (SELECT max(data_od) from rs_procenty_odsetek where firma_id='"+self.firma_id+"' AND data_od<='"+Data+"');",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych odsetek'
        dane.append(stat)
if stat=='OK':
    DaneCPU=[[False]]
    #czy drukowac cene przed upustem
    kontrahent=DaneN.GetVal(0,"kontrahent_id")
    platnik = DaneN.GetVal(0,"platnik_id")
    #WS 2019-04-08
    filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1"
    # filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
    stat,daneCPU,naglCPU,dump=self.PolSQL.Execute("SELECT cena_przed_upustem FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)

    if stat<>"OK":
        stat = 'Bd w pobieraniu danych czy drukowa cen przed upustem.'
        dane.append(stat)
    #WS 2019-04-08
    if len(daneCPU)>0:
    # if len(daneCPU)>0 and daneCPU[0][0]:
        DaneCPU=daneCPU
    else:
        #WS 2019-04-08
        filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1"
        # filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,daneCPU,naglCPU,dump=self.PolSQL.Execute("SELECT cena_przed_upustem FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)

        if stat<>"OK":
            stat = 'Bd w pobieraniu danych czy drukowa cen przed upustem.'
            dane.append(stat)
        else:
            if len(daneCPU)>0:
                DaneCPU=daneCPU    
if stat=='OK':
    #pobranie danych konta patnika (konto id z danych do fakturoiwania)
    platnik = DaneN.GetVal(0,"platnik_id")
    SQLKtoId="SELECT k.bank as bank,k.konto as konto "
    SQLKtoId+="FROM rs_kontrahenci_fakturowanie f "
    SQLKtoId+="LEFT OUTER JOIN rs_konta_bankowe k ON(f.firma_id=k.firma_id AND f.konto_id=k.konto_id) "
    SQLKtoId+="WHERE f.firma_id='"+self.firma_id+"' "
    SQLKtoId+="AND f.kontrahent_id='"+platnik+"' "
    SQLKtoId+="AND f.data_od=(SELECT MAX(data_od) FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' "
    SQLKtoId+="AND kontrahent_id='"+platnik+"' and data_od<='"+Data+"') ;"
    stat,daneKtoId,naglKtoId,dump=self.PolSQL.Execute(SQLKtoId,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych konta przypisanego do patnika'
        dane.append(stat)   

if stat=="OK":          
    #pobranie danych do zestawienia z dowodw dostaw dla wydruku dostawy-upusty
    Filtr="dd.firma_id='"+self.firma_id+"' AND dd.f_wyznacznik_id='"+Wyzn+"' AND dd.f_data='"+Data+"' AND dd.f_numer="+Nr+" AND a.typ_artykulu not in ('99','31') "
    #WS 2021-02-04
    Pola='dd.data, CAST(dd.numer AS TEXT), dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.kontrahent_id, rsf_podaj_pole_z_danych_kontrahenta(dd.firma_id, dd.kontrahent_id, \''+Data+'\', \'nazwa\') AS nazwa, dp.artykul_id, sum(dp.ilosc_dost1) as "Dost", sum(dp.ilosc_rozl_f1)*-1 as "Zwr",dd.numer_mpt, dd.numer_zamowienia, dd.data_zamowienia, a.jm1 AS "jm",'
    # Pola='dd.data, CAST(dd.numer AS TEXT), dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.kontrahent_id, ko.nazwa, dp.artykul_id, sum(dp.ilosc_dost1) as "Dost", sum(dp.ilosc_rozl_f1)*-1 as "Zwr",dd.numer_mpt, dd.numer_zamowienia, dd.data_zamowienia, a.jm1 AS "jm",'
    Pola+=' rsf_podaj_numer_obcy_kontrahenta(dd.firma_id,dd.oddzial_id,dd.trasa,dd.data,dd.tryb_dostawy,dd.numer) AS "NrObcy"'
    From=' FROM rs_dowody_dostaw_pozycje dp INNER JOIN rs_dowody_dostaw dd on(dd.firma_id=dp.firma_id AND dd.oddzial_id=dp.oddzial_id AND dd.trasa=dp.trasa AND dd.data=dp.data AND dd.tryb_dostawy=dp.tryb_dostawy AND dd.numer=dp.numer) '
    From+=' LEFT OUTER JOIN rs_tryby_dostaw td on (dd.firma_id=td.firma_id AND dd.tryb_dostawy=td.kod) '
    # From+=' LEFT OUTER JOIN rs_kontrahenci ko on(dd.firma_id=ko.firma_id AND dd.kontrahent_id=ko.kontrahent_id)'  #WS 2021-02-04
    From+='  LEFT OUTER JOIN rs_artykuly a ON(dp.firma_id=a.firma_id AND dp.artykul_id=a.artykul_id) '
    stat,daneDU,naglDU,dump= self.PolSQL.Execute("SELECT "+Pola+From+" WHERE "+Filtr+" GROUP BY dd.firma_id,dd.data, dd.numer, dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.kontrahent_id, nazwa, dp.artykul_id, dd.numer_mpt, dd.numer_zamowienia, dd.data_zamowienia,a.jm1 ORDER BY dd.kontrahent_id, dd.data,dd.oddzial_id,dd.trasa,dd.tryb_dostawy, dd.numer, dp.artykul_id;",3)  #WS 2021-02-04
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych dowodw dostaw.'
        dane.append(stat)

#WS 2021-02-23
if stat=="OK":
    #pobranie danych do zestawienia z dowodw dostaw dla wydruku dostawy-upust2
    Pola+=", dp.cena_upust1 "  #WS 2021-02-26
    From+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=dd.firma_id AND k.kontrahent_id=dd.kontrahent_id) "
    #WS 2021-02-26 - dp.cena_upust1
    stat,daneDU2,naglDU2,dump= self.PolSQL.Execute("SELECT "+Pola+From+" WHERE "+Filtr+" GROUP BY dd.platnik_id,dd.kontrahent_id, k.nazwa, COALESCE(k.zamawiajacy_id,dd.kontrahent_id), dp.artykul_id, dp.cena_upust1, dd.firma_id,dd.data, dd.numer, dd.tryb_dostawy, dd.oddzial_id, dd.trasa, dd.numer_mpt, dd.numer_zamowienia, dd.data_zamowienia,a.jm1 ORDER BY dd.platnik_id, dd.kontrahent_id, dp.artykul_id, dp.cena_upust1, dd.data,dd.oddzial_id,dd.trasa,dd.tryb_dostawy,dd.numer;",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych dowodw dostaw.'
        dane.append(stat)

#WS 2021-02-23
if stat=="OK":
    #pobranie oddziaw z dowodw dostaw
    SQLOddzialy = " SELECT DISTINCT o.oddzial_id, o.opis FROM rs_dowody_dostaw_pozycje dp "
    SQLOddzialy += " INNER JOIN rs_oddzialy o USING (firma_id,oddzial_id) "
    SQLOddzialy += " INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
    SQLOddzialy += " LEFT OUTER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQLOddzialy += " WHERE "+Filtr+" ORDER BY o.oddzial_id;"
    stat,daneDU2O,naglDU2O,dump = self.PolSQL.Execute(SQLOddzialy,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych oddziaw z dowodw dostaw.'
        dane.append(stat)

#WS 2021-02-23
if stat=="OK":
    LiczbaDowodow=0
    #pobranie liczby dowodw dostaw
    SQLiczbaDowodow = " SELECT COUNT(*) FROM "
    SQLiczbaDowodow += " (SELECT DISTINCT dd.firma_id, dd.oddzial_id, dd.trasa, dd.data, dd.tryb_dostawy, dd.numer FROM "
    SQLiczbaDowodow += " rs_dowody_dostaw dd "
    SQLiczbaDowodow += " INNER JOIN rs_dowody_dostaw_pozycje dp USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)"
    SQLiczbaDowodow += " LEFT OUTER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQLiczbaDowodow += " WHERE "+Filtr+") AS d;"
    stat,daneDU2LD,dump,dump = self.PolSQL.Execute(SQLiczbaDowodow,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu liczby dowodw dostaw.'
        dane.append(stat)
    else:
        LiczbaDowodow=daneDU2LD[0][0]

if stat=='OK':
    DaneTNDD=[[False]]
    #czy drukowac tylko numery dowodow dostaw
    kontrahent=DaneN.GetVal(0,"kontrahent_id")
    platnik = DaneN.GetVal(0,"platnik_id")
    #WS 2019-04-08
    filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1"
    # filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
    stat,daneTNDD,dump,dump=self.PolSQL.Execute("SELECT tylko_numery_dowodow_dostaw FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)

    if stat<>"OK":
        stat = 'Bd w pobieraniu danych czy drukowa tylko numery dowodw dostaw.'
        dane.append(stat)
    #WS 2019-04-08
    if len(daneTNDD)>0:
    # if len(daneTNDD)>0 and daneTNDD[0][0]:
        DaneTNDD=daneTNDD
    else:
        #WS 2019-04-08
        filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1"
        # filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,daneTNDD,dump,dump=self.PolSQL.Execute("SELECT tylko_numery_dowodow_dostaw FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)

        if stat<>"OK":
            stat = 'Bd w pobieraniu danych czy drukowa tylko numery dowodw dostaw.'
            dane.append(stat)
        else:
            if len(daneTNDD)>0:
                DaneTNDD=daneTNDD

#WS 2019-03-20
if stat=='OK':
    #WS 2019-04-08 - domyslnie True
    DanePDFDD=[[True]]
    #czy drukowac pdf z dowodami dostaw
    kontrahent = DaneN.GetVal(0,"kontrahent_id")
    platnik = DaneN.GetVal(0,"platnik_id")
    #WS 2019-04-08 - zamiana platnika na kontrahenta
    filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1"
    stat,danePDFDD,dump,dump=self.PolSQL.Execute("SELECT czy_pdf_z_dowodami_dostaw FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)

    if stat<>"OK":
        stat = 'Bd w pobieraniu danych czy drukowa pdf z dowodami dostaw.'
        dane.append(stat)
    #WS 2019-04-08
    if len(danePDFDD)>0:
    # if len(DanePDFDD)>0 and DanePDFDD[0][0]:
        DanePDFDD=danePDFDD
    else:
        #WS 2019-04-08 - zamiana kontrahenta na platnika
        filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND data_od<='"+Data+"' ORDER BY data_od DESC LIMIT 1"
        stat,danePDFDD,dump,dump=self.PolSQL.Execute("SELECT czy_pdf_z_dowodami_dostaw FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)

        if stat<>"OK":
            stat = 'Bd w pobieraniu danych czy drukowa pdf z dowodami dostaw.'
            dane.append(stat)
        else:
            if len(danePDFDD)>0:
                DanePDFDD=danePDFDD

#WS 2019-03-20
#WS 2021-02-23 - 47,48,49,50,51
if stat=="OK": # 0   1      2      3      4      5       6        7       8        9      10    11
    dane=str([daneN,naglN,daneSV,naglSV,daneSP,naglSP,daneOddz,naglOddz,daneDod,naglDod,daneP,naglP,
    # 12   13    14    15     16        17     18    19      20        21        22        23       24
    daneO,naglO,daneW,naglW,danePodp,naglPodp,daneK,naglK,daneKraje,naglKraje,daneKrajO,naglKrajO,NrPar,
    # 25    26     27   28     29    30     31     32     33      34       35            36           37     38
    daneD,naglD,daneT,naglT,daneOP,naglOP,danePL,naglPL,daneZAM,naglZAM,daneMiejDost,naglMiejDost,daneProc,naglProc,
    #  39      40        41       42     43         44          45        46       47      48      49       50         51
    DaneCPU,daneKtoId,naglKtoId,daneDU,naglDU,ListaParagonow,DaneTNDD,DanePDFDD,daneDU2,naglDU2,daneDU2O,naglDU2O,LiczbaDowodow])
# if stat=="OK": # 0   1      2      3      4      5       6        7       8        9      10    11
#     dane=str([daneN,naglN,daneSV,naglSV,daneSP,naglSP,daneOddz,naglOddz,daneDod,naglDod,daneP,naglP,
#     # 12   13    14    15     16        17     18    19      20        21        22        23       24
#     daneO,naglO,daneW,naglW,danePodp,naglPodp,daneK,naglK,daneKraje,naglKraje,daneKrajO,naglKrajO,NrPar,
#     # 25    26     27   28     29    30     31     32     33      34       35            36           37     38
#     daneD,naglD,daneT,naglT,daneOP,naglOP,danePL,naglPL,daneZAM,naglZAM,daneMiejDost,naglMiejDost,daneProc,naglProc,
#     #  39      40        41       42     43         44          45      46
#     DaneCPU,daneKtoId,naglKtoId,daneDU,naglDU,ListaParagonow,DaneTNDD])