# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wydruki_faktura_cmr.py
# Purpose:     pobranie danych uzupelniajacych do wydruku cmr podczonego do faktury
# Author:      Micha Raburski
# Created:     2014/01/23
# RCS-ID:      $Id: fs_wydruki_faktura_cmr.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2021-02-04 Wojciech Skowron   (12289) Korzystanie z danych archiwalnych

Fun = klucze[-1]

stat = 'OK'
dane = []

UprDruk = (self.oddzial_id,'022019') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID

if not UprDruk:
    stat='Brak uprawnie do wydruku dokumentu CMR.'
    
Wyzn = klucze[0]
Data = klucze[1]
Numer = str(klucze[2])

NrDok=''

# pobranie numeru faktury
if stat=='OK':
    SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\""+Wyzn+"\",\""+Data+"\",\""+str(Numer)+"\"]','F');"
    stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania numeru faktury : '+stat
    
    if stat=='OK':
        NrDok = DNr[0][0]
    
# pobranie adresu oddziau, numeru weterynaryjnego, kwalifikacji krajw, kraj pochodzenia
if stat == 'OK':
    SQL = "SELECT TRIM(COALESCE(o.nazwa1,'')),TRIM(COALESCE(o.nazwa2,'')),TRIM(COALESCE(o.nazwa,'')),TRIM(COALESCE(o.adr_kod,'')),"
    SQL+= "TRIM(COALESCE(o.adr_miej,'')),TRIM(COALESCE(o.adr_ulica,'')),TRIM(COALESCE(o.adr_nry,'')), "
    SQL+= "COALESCE(k.nazwa,'Polska')"
    SQL+= " FROM rs_oddzialy o LEFT OUTER JOIN rs_kraje k ON (k.kraj=o.adr_kraj)"
    SQL+= " WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id='"+self.oddzial_id+"';"
    stat,DAdres,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania adresu z danych oddziau : '+stat
    
    if stat=='OK':
        if DAdres[0][0] <> '' or DAdres[0][1] <> '':
            Nazwa = DAdres[0][0]+' '+DAdres[0][1]
            Nazwa = Nazwa.strip()
        else:
            Nazwa = DAdres[0][2]
            
        AdrKod = DAdres[0][3]
        AdrMiej = DAdres[0][4]
        AdrUlica = DAdres[0][5]
        AdrNr = DAdres[0][6]
        PochodzenieKraj = DAdres[0][7]

# pobranie danych z faktury
if stat=='OK':
    SQL="SELECT COALESCE(kontrahent_id,''),COALESCE(miejsce_dostawy_id,kontrahent_id,'') FROM rs_faktury "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)
    stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych z faktury : '+stat
    
    if stat=='OK':
        Nabywca = DFakt[0][0]
        MiejsceDost = DFakt[0][1]


# pobranie danych nabywcy
if stat == 'OK':
    NabNazwa=''
    NabKod = ''
    NabMiej = ''
    NabUlica = ''
    NabNr = ''
    NabKraj=''
    
    if Nabywca <>'':
        SQL="SELECT k.nazwa,TRIM(COALESCE(k.adr_kod,'')),TRIM(COALESCE(k.adr_miej,'')),"
        SQL+="TRIM(COALESCE(k.adr_ulica,'')),TRIM(COALESCE(k.adr_nry,'')),kr.nazwa"
        #WS 2021-02-04
        SQL+=" FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+Nabywca+"','"+Data+"') k LEFT OUTER JOIN rs_kraje kr ON (kr.kraj=k.kraj);"
        # SQL+=" FROM rs_kontrahenci k LEFT OUTER JOIN rs_kraje kr ON (kr.kraj=k.kraj)"
        # SQL+=" WHERE k.firma_id='"+self.firma_id+"' AND k.kontrahent_id='"+Nabywca+"'"
        stat,DNab,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(DNab)>0:
                NabNazwa=DNab[0][0]
                NabKod = DNab[0][1]
                NabMiej = DNab[0][2]
                NabUlica = DNab[0][3]
                NabNr = DNab[0][4]
                NabKraj=DNab[0][5]

# pobranie danych miejsca dostawy
if stat == 'OK':
    MDNazwa=''
    MDKod = ''
    MDMiej = ''
    MDUlica = ''
    MDNr = ''
    MDKraj=''
    if MiejsceDost <>'':
        SQL="SELECT k.nazwa,TRIM(COALESCE(k.adr_kod,'')),TRIM(COALESCE(k.adr_miej,'')),"
        SQL+="TRIM(COALESCE(k.adr_ulica,'')),TRIM(COALESCE(k.adr_nry,'')),kr.nazwa"
        #WS 2021-02-04
        SQL+=" FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+MiejsceDost+"','"+Data+"') k LEFT OUTER JOIN rs_kraje kr ON (kr.kraj=k.kraj);"
        # SQL+=" FROM rs_kontrahenci k LEFT OUTER JOIN rs_kraje kr ON (kr.kraj=k.kraj)"
        # SQL+=" WHERE k.firma_id='"+self.firma_id+"' AND k.kontrahent_id='"+MiejsceDost+"'"
        stat,DMD,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(DMD)>0:
                MDNazwa=DMD[0][0]
                MDKod = DMD[0][1]
                MDMiej = DMD[0][2]
                MDUlica = DMD[0][3]
                MDNr = DMD[0][4]
                MDKraj=DMD[0][5]
            
# pobranie danych specyficznych dla cmr
if stat == 'OK':
    CechyINum = ''
    Ilosc = ''
    SposOpak =''
    RodzajTowaru = ''
    NrStat = ''
    WagaBrutto = ''
    Objetosc = ''
    Instrukcja = ''
    
    SQL="SELECT cmr_cechy_i_numery,cmr_ilosc,cmr_spos_opakowania,cmr_rodzaj_towaru,"
    SQL+=" cmr_nr_statyst,cmr_waga_brutto,cmr_objetosc,cmr_instrukcja"
    SQL+=" FROM rs_faktury_hdi WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
    SQL+=" AND data='"+Data+"' AND numer="+str(Numer)  
    stat,DCMR,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DCMR) > 0:
            CechyINum=DCMR[0][0]
            Ilosc = DCMR[0][1]
            SposOpak = DCMR[0][2]
            RodzajTowaru = DCMR[0][3]
            NrStat = DCMR[0][4]
            WagaBrutto=DCMR[0][5]  
            Objetosc=DCMR[0][6]  
            Instrukcja=DCMR[0][7]  

if stat=='OK':
    dane = [NrDok,Nazwa,AdrKod,AdrMiej,AdrUlica,AdrNr,PochodzenieKraj,
            NabNazwa,NabKod,NabMiej,NabUlica,NabNr,NabKraj,
            MDNazwa,MDKod,MDMiej,MDUlica,MDNr,MDKraj,
            CechyINum,Ilosc,SposOpak,RodzajTowaru,NrStat,WagaBrutto,Objetosc,Instrukcja]