# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wydruki_faktura_hdi.py
# Purpose:     pobranie danych uzupelniajacych do wydruku HDI przypitego do faktury 
# Author:      Micha Raburski
# Created:     2014/01/05
# RCS-ID:      $Id: fs_wydruki_faktura_hdi.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2021-02-04 Wojciech Skowron   (12289) Korzystanie z danych archiwalnych

Fun = klucze[-1]

stat = 'OK'
dane = []

UprDruk = (self.oddzial_id,'022019') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID

if not UprDruk:
    stat='Brak uprawnie do wydruku dokumentu HDI.'
    
Wyzn = klucze[0]
Data = klucze[1]
Numer = str(klucze[2])
Typ = klucze[3]

NrDok=''

# pobranie numeru faktury
if stat=='OK':
    SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\""+Wyzn+"\",\""+Data+"\",\""+str(Numer)+"\"]','F');"
    stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania numeru faktury : '+stat
    
    if stat=='OK':
        NrDok = DNr[0][0]
    
# pobranie adresu oddziau, numeru weterynaryjnego, kwalifikacji krajw, kraj pochodzenia
if stat == 'OK':
    SQL = "SELECT TRIM(COALESCE(o.nazwa1,'')),TRIM(COALESCE(o.nazwa2,'')),TRIM(COALESCE(o.nazwa,'')),TRIM(COALESCE(o.adr_kod,'')),"
    SQL+= "TRIM(COALESCE(o.adr_miej,'')),TRIM(COALESCE(o.adr_ulica,'')),TRIM(COALESCE(o.adr_nry,'')), "
    SQL+= "COALESCE(k.nazwa,'Polska'),o.nr_weterynaryjny,o.hdi_kwalifikacja_ue,o.hdi_kwalifikacja_kraje,o.hdi_kwalifikacja_krajowa,"
    SQL+=" TRIM(COALESCE(o.adr_powiat,'')),TRIM(COALESCE(o.adr_wojew,'')) "
    SQL+= " FROM rs_oddzialy o LEFT OUTER JOIN rs_kraje k ON (k.kraj=o.adr_kraj)"
    SQL+= " WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id='"+self.oddzial_id+"';"
    stat,DAdres,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania adresu z danych oddziau : '+stat
    
    if stat=='OK':
        if DAdres[0][0] <> '' or DAdres[0][1] <> '':
            Nazwa = DAdres[0][0]+' '+DAdres[0][1]
            Nazwa = Nazwa.strip()
        else:
            Nazwa = DAdres[0][2]
            
        AdrKod = DAdres[0][3]
        AdrMiej = DAdres[0][4]
        AdrUlica = DAdres[0][5]
        AdrNr = DAdres[0][6]
        PochodzenieKraj = DAdres[0][7]
        NrWet = DAdres[0][8]
        KwalifUE = DAdres[0][9]
        KwalifZagr = DAdres[0][10]
        KwalifKraj = DAdres[0][11]
        Powiat = DAdres[0][12]
        Wojew = DAdres[0][13]
        
        if Typ =='1':
            Adres = Nazwa+'; '+AdrUlica+' '+AdrNr+', '+AdrKod+' '+AdrMiej
        else:
            Adres=AdrKod+' '+AdrMiej+'; '+AdrUlica+' '+AdrNr
        
# pobranie artykuw
if stat == 'OK':
    SQL = "SELECT DISTINCT a.artykul_id,a.nazwa "
    SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+="  WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"'"
    SQL+=" AND fp.data = '"+Data+"' and fp.numer = "+Numer+" AND a.hdi='"+Typ+"' ORDER BY artykul_id;"
    stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
    OpisArt=''
    for poz in DArt:
        OpisArt+=poz[1].strip()+','
    OpisArt = OpisArt.strip(',')

# pobranie rodzajw opakowa, transportu i miejsca wysyki i pozostaych pl dla HDI3
if stat == 'OK':
    #WS 2021-02-04
    SQL="SELECT fh.rodzaje_opakowan,fh.srodek_transportu,rsf_podaj_pole_z_danych_kontrahenta(k.firma_id,k.kontrahent_id,'"+Data+"','adr_miej') AS adr_miej, "
    # SQL="SELECT fh.rodzaje_opakowan,fh.srodek_transportu,k.adr_miej, "
    SQL+="COALESCE(fh.przewoznik_id,''),COALESCE(fh.metoda_przetwarzania,''),COALESCE(fh.cel_przewozu,''),fh.material_kat_3,"
    SQL+="fh.produkt_przetworzony_kat_3,fh.gatunek_zwlok1,fh.liczba_zwlok1,fh.gatunek_zwlok2,fh.liczba_zwlok2,"
    SQL+="fh.nr_kolczyka,COALESCE(fh.czas_odkazenia::TEXT,''),COALESCE(f.kontrahent_id,'')"
    SQL+="FROM rs_faktury f "
    SQL+="LEFT OUTER JOIN rs_faktury_hdi fh USING (firma_id,wyznacznik_id,data,numer) "
    SQL+="LEFT OUTER JOIN rs_kontrahenci k ON "
    SQL+="(k.firma_id=f.firma_id AND k.kontrahent_id=COALESCE(f.miejsce_dostawy_id,f.kontrahent_id))"
    SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+Wyzn+"'"
    SQL+=" AND f.data='"+Data+"' AND f.numer="+Numer
    stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych faktury : '+stat

    if stat=='OK':
        RodzOpak = DFakt[0][0]
        Transport = DFakt[0][1]
        MiejDost = DFakt[0][2]
        Przewoznik = DFakt[0][3]
        MetPrzetw = DFakt[0][4]
        CelPrzew = DFakt[0][5]
        MatKat3 = DFakt[0][6]
        ProdPrzetwKat3 = DFakt[0][7]
        GatunekZw1 = DFakt[0][8]
        LiczbaZw1 = DFakt[0][9]
        GatunekZw2 = DFakt[0][10]
        LiczbaZw2 = DFakt[0][11]
        Kolczyk = DFakt[0][12]
        CzasOdkaz = DFakt[0][13]
        Nabywca = DFakt[0][14]
                    
# pobranie danych przewonika
if stat == 'OK' and Typ =='3':
    if Przewoznik =='':
        PrzewNazwa=''
        PrzewAdres=''
        PrzewAdres1=''
        PrzewAdres2=''
        PrzewNrZatw=''
    else:
        SQL="SELECT k.nazwa,TRIM(COALESCE(k.adr_kod,'')),TRIM(COALESCE(k.adr_miej,'')),"
        SQL+="TRIM(COALESCE(k.adr_ulica,'')),TRIM(COALESCE(k.adr_nry,'')),TRIM(COALESCE(k.nr_weterynaryjny))"
        #WS 2021-02-04
        SQL+=" FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+Przewoznik+"','"+Data+"') k;"
        # SQL+=" FROM rs_kontrahenci k WHERE k.firma_id='"+self.firma_id+"' AND k.kontrahent_id='"+Przewoznik+"'"
        stat,DPrzew,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            PrzewNazwa=DPrzew[0][0]
            PrzewKod = DPrzew[0][1]
            PrzewMiej = DPrzew[0][2]
            PrzewUlica = DPrzew[0][3]
            PrzewNr = DPrzew[0][4]
            PrzewNrZatw = DPrzew[0][5]
            
            PrzewAdres1 =PrzewKod+' '+PrzewMiej
            PrzewAdres2 =PrzewUlica+' '+PrzewNr
            PrzewAdres=PrzewAdres1+'; '+PrzewAdres2

# pobranie danych nabywcy
if stat == 'OK' and Typ =='3':
    if Nabywca =='':
        NabNazwa=''
        NabAdres=''
        NabAdres1=''
        NabAdres2=''
        NabNrZatw=''
    else:
        SQL="SELECT k.nazwa,TRIM(COALESCE(k.adr_kod,'')),TRIM(COALESCE(k.adr_miej,'')),"
        SQL+="TRIM(COALESCE(k.adr_ulica,'')),TRIM(COALESCE(k.adr_nry,'')),TRIM(COALESCE(k.nr_weterynaryjny))"
        #WS 2021-02-04
        SQL+=" FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+Nabywca+"','"+Data+"') k;"
        # SQL+=" FROM rs_kontrahenci k WHERE k.firma_id='"+self.firma_id+"' AND k.kontrahent_id='"+Nabywca+"'"
        stat,DNab,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            NabNazwa=DNab[0][0]
            NabKod = DNab[0][1]
            NabMiej = DNab[0][2]
            NabUlica = DNab[0][3]
            NabNr = DNab[0][4]
            NabNrZatw = DNab[0][5]
            
            NabAdres1 =NabKod+' '+NabMiej
            NabAdres2 =NabUlica+' '+NabNr
            NabAdres=NabAdres1+'; '+NabAdres2
        
# pobranie masy netto artykuw
if stat == 'OK':
    MasaN=''
    SQL = "SELECT DISTINCT UPPER(a.jm2),SUM(fp.ilosc2) "
    SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+="  WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"'"
    SQL+=" AND fp.data = '"+Data+"' and fp.numer = "+Numer+" AND a.hdi='"+Typ+"' GROUP BY UPPER(a.jm2) ORDER BY UPPER(a.jm2);"
    stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        for poz in DArt:
            MasaN+=str(poz[1])+' '+poz[0].strip()+','
        MasaN = MasaN.strip(',')

# pobranie numerw partii
if stat == 'OK':
    NumeryPartii=''
    if Typ == '1':
        SQL = "SELECT DISTINCT SUBSTRING(nr_serii FOR 10) "
        SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+="  WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"'"
        SQL+=" AND fp.data = '"+Data+"' and fp.numer = "+Numer+" AND a.hdi='1' ORDER BY SUBSTRING(nr_serii FOR 10);"
        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            NumeryPartii=''
            for poz in DArt:
                NumeryPartii+=poz[0].strip()+','
            NumeryPartii = NumeryPartii.strip(',')

if stat=='OK':
    if Typ == '1':
        dane = [NrDok,Adres,NrWet,KwalifUE,KwalifZagr,KwalifKraj,OpisArt,RodzOpak,MasaN,PochodzenieKraj,
            NumeryPartii,Transport,MiejDost,AdrMiej]
    elif Typ == '3':
        dane = [AdrMiej,Powiat,Wojew,NrDok,Transport,PrzewNazwa,PrzewAdres,PrzewNrZatw,Nazwa,Adres,NrWet,MetPrzetw,
                CelPrzew,MatKat3,ProdPrzetwKat3,OpisArt,MasaN,GatunekZw1,LiczbaZw1,GatunekZw2,LiczbaZw2,
                Kolczyk,NabNazwa,NabAdres,NabNrZatw,CzasOdkaz]