# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wydruki_faktury.py
# Purpose:     pobranie danych uzupelniajacych do wydruku faktury 
# Author:      Mariusz Rajfura
# Created:     2009/04/23
# RCS-ID:      $Id: fs_wydruki_faktury.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2017-10-31 Rafa Woniak (10734) zmiana zapisu do logw z 1 na 5
# 2018-12-27 Jan Raburski (11318) wczytanie czy drukowac fakture
# 2019-05-10 Wojciech Skowron (11480) Wysyanie grupowe maili z fakturami
# 2019-08-02 Wojciech Skowron (11574) Przy wysyaniu faktur e-mailem: pobieranie adresu docelowego najpierw od kontrahenta, potem od patnika
# 2019-08-08 Wojciech Skowron (11574) Wysyanie e-mailem faktur tylko w stanie 'Z' lub 'K'
# 2023-03-23 Aleksander Bargie (13349) wysyanie faktur pdf mailem - uwagi

import os
import tempfile
import traceback
import binascii

Fun = klucze[-1]

stat = 'OK'
dane = []

UprDruk = (self.oddzial_id,'022019') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID

if not UprDruk:
    stat='Brak uprawnie do wydruku faktury.'
    
if stat=='OK' and Fun==9:
    
    wyzn = klucze[0]
    data = klucze[1]
    numer = str(klucze[2])

    #WS 2019-08-08 - pobranie stanu
    sql="SELECT z_paragonow,waluta,kontrahent_id,platnik_id,stan in ('Z','K') FROM rs_faktury WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND wyznacznik_id='"+wyzn+"' AND data = '"+data+"' and numer = "+numer+" ;"
    stat,dfakt,dump,dump = self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='Bd pobrania danych z faktury: '+stat
    
    if stat=='OK':
        if len(dfakt)==0:
            stat='Brak faktury o podanym wyznaczniku: '+wyzn+"/"+data+"/"+numer

    if stat=='OK':
        sql="SELECT plik_wydruku, typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+wyzn+"';"
        rsglobal.ZapiszDoLogow('sql '+sql,5)
        stat,dwyzn,dump,dump = self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow('dwyzn '+str(dwyzn),5)
        if stat<>'OK':
            stat='Bd pobrania pliku wydruku dla wyznacznika: '+stat
    
    if stat=='OK':
        if len(dwyzn)==0:
            stat='Brak definicji wyznacznika: '+wyzn
    
    # pobranie informacji czy bdzie drukowane HDI/HDI3
    if stat=='OK':
        SQL= "SELECT DISTINCT a.hdi "
        SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+="  WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+wyzn+"'"
        SQL+=" AND fp.data = '"+data+"' and fp.numer = "+numer+" ;"
        stat,dhdi,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobrania informacji o hdi: '+stat
           
        HDI = False
        HDI3 = False         
        for poz in dhdi:
            if poz[0] == '1':
                HDI = True
            elif poz[0] == '3':
                HDI3 = True

    if stat=='OK':
        sql="SELECT czy_drukowac_faktury, czy_pdf_faktury, czy_pdf_z_dowodami_dostaw FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+dfakt[0][2]+"' AND data_od<='"+data+"' ORDER BY data_od DESC LIMIT 1;"
        rsglobal.ZapiszDoLogow('sql '+sql,5)
        stat,dkontr,dump,dump = self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow('dkontr '+str(dkontr),5)
        if stat != 'OK':
            stat='Bd pobrania danych do fakturowania kontrahenta: '+stat
        elif len(dkontr) == 0:
            sql="SELECT czy_drukowac_faktury, czy_pdf_faktury, czy_pdf_z_dowodami_dostaw FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+dfakt[0][3]+"' AND data_od<='"+data+"' ORDER BY data_od DESC LIMIT 1;"
            rsglobal.ZapiszDoLogow('sql '+sql,5)
            stat,dkontr,dump,dump = self.PolSQL.Execute(sql,3)
            rsglobal.ZapiszDoLogow('dkontr '+str(dkontr),5)
            if stat != 'OK':
                stat='Bd pobrania danych do fakturowania patnika: '+stat
            elif len(dkontr) == 0:
                dkontr = [[True,False,False]]

    if stat=='OK':
        if len(dwyzn)==0:
            stat='Brak definicji wyznacznika: '+wyzn


    if stat=='OK':
        dane = str([dfakt[0][0],dfakt[0][1],dwyzn[0][0],dwyzn[0][1],HDI,HDI3,dkontr,dfakt[0][4]]) #WS 2019-08-08 - pobranie stanu

#-------------------------------------------------------------------------------
# -- wysylka faktur e-mailem - 10
#-------------------------------------------------------------------------------

#WS 2019-05-10
if stat == 'OK' and Fun == 10:
    wyzn = klucze[0]
    data = klucze[1]
    numer = str(klucze[2])
    trescZalacznika = klucze[3]

    SELECT = "SELECT email_uzytkownik, imie, nazwisko FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3)
    if stat != "OK":
        stat = "BL_SQL_OP"
    else:
        if dane[0][0] in (None, ''):
            stat = "BL_OP"
        else:
            nadawca = dane[0][0]
            imie = dane[0][1]
            nazwisko = dane[0][2]

    if stat == "OK":
        Firma = self.firma_id
        KlPom = str([wyzn,data,numer]).replace("'",'"')
        SELECT = "SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','F');"
        stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3)
        if stat != 'OK':
            stat = "BL_RSF_NR_DOK"
        else:
            nr_dok = dane[0][0]

    #WS 2019-08-02 - pobieranie docelowego adresu e-mail najpierw od kontrahenta, potem od patnika; poprawione sprawdzanie czy e-mail wypeniony
    if stat == "OK":
        SELECT = "SELECT email FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id=("
        SELECT += "SELECT kontrahent_id FROM rs_faktury "
        SELECT += " WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+wyzn+"' AND data='"+data+"' AND numer="+numer+");"
        stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3,CzyDodawacBlad=True)
        if stat != "OK":
            stat = "Bd pobrania adresu e-mail kontrahenta faktury: "+stat
        else:
            if len(dane) == 0 or dane[0][0].strip() in ('','None',None):
                SELECT = "SELECT email FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id=("
                SELECT += "SELECT platnik_id FROM rs_faktury "
                SELECT += " WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+wyzn+"' AND data='"+data+"' AND numer="+numer+");"
                stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3,CzyDodawacBlad=True)
                if stat != "OK":
                    stat = "Bd pobrania adresu e-mail patnika faktury: "+stat
                elif len(dane) == 0 or dane[0][0].strip() in ('','None',None):
                    stat = "BL_PLAT_EMAIL"
                else:
                    adresat = dane[0][0].strip()
            else:
                adresat = dane[0][0].strip()

    if stat == "OK":
        temat = "Faktura nr "+nr_dok
        tresc = "W zaczniku faktura.\n\nPozdrawiam\n"+imie+" "+nazwisko

        Blad = False
        trescZalacznika = binascii.unhexlify(trescZalacznika)
        try:
            zalacznik = os.path.join(tempfile.gettempdir(), nr_dok.replace('/', '_')+'.pdf')
            tmp = open(zalacznik, 'wb')
            tmp.write(trescZalacznika)
            tmp.close()
        except EnvironmentError, e:
            rsglobal.ZapiszDoLogow(traceback.format_exc(), 5)
            stat = "BL_OS"
            Blad = True

        if not Blad:
            #AB 23.03.23r
            cc = None
            if ',' in adresat:
                cc = ','.join(adresat.split(',')[1:])
                adresat = adresat.split(',')[0].strip()

            stat = rsglobal.RSWyslijEmail(adresat, temat, tresc, [zalacznik], self.operator_id, polsql=self.PolSQL,
                                          cc=cc, bcc=nadawca)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat, 5)
                stat = "BL_RSWYSLIJEMAIL"
            else:
                rsglobal.ZapiszDoLogow(u'Wysano e-mail z faktur nr '+nr_dok+' do '+adresat, 5)
