#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_wydruki_harmonogram_produkcji.py
# Purpose:          wydruk harmonogramu produkcji
# Author:           Dariusz Boduch
# Created:          2010/02/12
# RCS-ID:           $Id: fs_wydruki_harmonogram_produkcji.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# 2013-05-07 Mariusz Rajfura (6847) prawidlowe przekazanie parametrow do wydruku

Slow = klucze[0]
Oddzial = Slow['Oddzial']
Data = Slow['DataNaKiedy']
Zmiana = Slow['Zmiana']
GodzOd = Slow['GodzOd']
GodzDo = Slow['GodzDo']
KategArt = Slow['KategArt']
Artykul = Slow['Artykul']
Proces = Slow['Proces']
Urzadzenie = Slow['Urzadzenie']
CzyUwagi = Slow['CzyUwagi']
CzyZFiltra = Slow['CzyZFiltra']     # to oznacza DrukujWybrane

stat = "OK"
dane = []
puste=['','    -  -  ','None',None]
##sprawdzenie poprawnosci danych
if Oddzial.strip() in puste:
    stat='Brak oddziau. Do wykonania wydruku naley wypeni poprawnie nastpujce pola w filtrze: oddzia, dat na kiedy, proces.'
if Data in puste and stat=='OK':
    stat='Brak daty na kiedy. Do wykonania wydruku naley wypeni poprawnie nastpujce pola w filtrze: oddzia, dat na kiedy, proces.'
if Proces.strip() in puste:
    stat='Brak symbolu procesu. Do wykonania wydruku naley wypeni poprawnie nastpujce pola w filtrze: oddzia, dat na kiedy, proces.'
if Data not in puste and stat=='OK':
    if not rsglobal.SprawdzCzyToData(Data):
        stat='Bdna data'
if stat=='OK':
    sql="SELECT proces_id FROM rs_procesy WHERE firma_id='"+self.firma_id+"' AND proces_id = '"+str(Proces)+"' ; "
    rsglobal.ZapiszDoLogow(sql,1)
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania Procesu: '+stat
    else:
        if d==[]:
            stat = 'Bdny symbol procesu'
if KategArt not in puste and stat=='OK':
    sql="SELECT opis FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"' AND kod = '"+str(KategArt)+"' ; "
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania kategorii art.: '+stat
        dane.append(stat)
    else:
        if d==[]:
            stat = 'Bdny symbol kategorii artykuu.'

if Artykul not in puste and stat=='OK':
    sql="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(Artykul)+"' ; "
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania artykuu: '+stat
    else:
        if d==[]:
            stat = 'Bdny symbol artykuu'

if stat=='OK':
    #pobieranie danych
    FILTR =" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id='"+Oddzial+"'"
    FILTR+=" AND pp.data_na_kiedy='"+Data+"' AND pp.proces_id = '"+Proces+"' "
    if CzyZFiltra:
        if Zmiana<>'':
            FILTR+= " AND pp.zmiana = '"+Zmiana+"' "
        if GodzOd<>'  :  ':
            FILTR+= " AND pp.godz_minuta >= '"+GodzOd+"' "
        if GodzDo<>'  :  ':
            FILTR+= " AND pp.godz_minuta <= '"+GodzDo+"' "
        if KategArt<>'':
            FILTR+= " AND a.kateg_artykulu = '"+KategArt+"' "
        if Artykul<>'':
            FILTR+= " AND pp.artykul_id like '"+Artykul+"%' "
        if Urzadzenie<>'':
            FILTR+=" AND pp.urzadzenie_id = '"+Urzadzenie+"' "
        if CzyUwagi:
            FILTR+=" AND trim(coalesce(pp.uwagi,'')) <> '' "
            
    SELECT="SELECT upper(to_char('"+Data+"'::date, 'Day')), pp.zmiana, COALESCE(a.kateg_artykulu,'') as ArtKateg, COALESCE(ka.opis,'') as KategOpis, "
    SELECT+=" pp.artykul_id, a.nazwa, pp.godz_minuta, pp.proces_id, p.nazwa, COALESCE(pp.urzadzenie_id,''), COALESCE(u.nazwa,''), pp.do_produkcji, COALESCE(pp.uwagi,''), "
    SELECT+=" COALESCE(o.imie,''), COALESCE(o.nazwisko,'') "
    SELECT+="FROM rs_produkcja_plan pp "
    SELECT+="LEFT OUTER JOIN rs_procesy p ON(pp.firma_id=p.firma_id AND pp.proces_id=p.proces_id) "
    SELECT+="LEFT OUTER JOIN rs_artykuly a ON(pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
    SELECT+="LEFT OUTER JOIN rs_kateg_artykulow ka ON(pp.firma_id=ka.firma_id AND a.kateg_artykulu=ka.kod) "
    SELECT+="LEFT OUTER JOIN rs_urzadzenia u ON(pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id) "
    SELECT+="LEFT OUTER JOIN rs_operatorzy o ON( o.operator_id='"+str(self.operator_id)+"' ) "
    #ORDERBY=" ORDER BY a.kateg_artykulu, pp.zmiana, pp.godz_minuta "
    ORDERBY=" ORDER BY pp.data,pp.godz_minuta "
    rsglobal.ZapiszDoLogow(SELECT+FILTR+ORDERBY,1)
    stat,dane,dump,dump = self.PolSQL.Execute(SELECT+FILTR+ORDERBY,3)
    if stat<>'OK':
        stat='Bd pobierania danych: '+stat