#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_wydruki_harmonogram_produkcji_sumy.py
# Purpose:          wydruk harmonogramu produkcji - sumy czyli dla wszystkich procesw
# Author:           Micha Raburski
# Created:          2013/11/13
# RCS-ID:           $Id: fs_wydruki_harmonogram_produkcji_sumy.py $
# Copyright:        (c) 2013 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

Slow = klucze[0]
Oddzial = Slow['Oddzial']
Data = Slow['DataNaKiedy']
Zmiana = Slow['Zmiana']
GodzOd = Slow['GodzOd']
GodzDo = Slow['GodzDo']
KategArt = Slow['KategArt']
Artykul = Slow['Artykul']
Proces = Slow['Proces']
Urzadzenie = Slow['Urzadzenie']
CzyUwagi = Slow['CzyUwagi']
CzyZFiltra = Slow['CzyZFiltra']     # to oznacza DrukujWybrane

stat = "OK"
dane = []
puste=['','    -  -  ','None',None]
##sprawdzenie poprawnosci danych
if Oddzial.strip() in puste:
    stat='Brak oddziau. Do wykonania wydruku naley wypeni poprawnie nastpujce pola w filtrze: oddzia, dat na kiedy.'
if Data in puste and stat=='OK':
    stat='Brak daty na kiedy. Do wykonania wydruku naley wypeni poprawnie nastpujce pola w filtrze: oddzia, dat na kiedy.'
if Data not in puste and stat=='OK':
    if not rsglobal.SprawdzCzyToData(Data):
        stat='Bdna data'

if Proces not in puste and stat=='OK':
    sql="SELECT proces_id FROM rs_procesy WHERE firma_id='"+self.firma_id+"' AND proces_id = '"+str(Proces)+"' ; "
    rsglobal.ZapiszDoLogow(sql,1)
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania Procesu: '+stat
    else:
        if d==[]:
            stat = 'Bdny symbol procesu'

if KategArt not in puste and stat=='OK':
    sql="SELECT opis FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"' AND kod = '"+str(KategArt)+"' ; "
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania kategorii art.: '+stat
        dane.append(stat)
    else:
        if d==[]:
            stat = 'Bdny symbol kategorii artykuu.'

if Artykul not in puste and stat=='OK':
    sql="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(Artykul)+"' ; "
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzania artykuu: '+stat
    else:
        if d==[]:
            stat = 'Bdny symbol artykuu'

if stat=='OK':
    #pobieranie danych
            
    SQL="SELECT upper(to_char('"+Data+"'::date, 'Day')),TRIM(o.imie)||' '||TRIM(o.nazwisko), "
    SQL+=" TRIM(pp.proces_id)||' - '||TRIM(p.nazwa), TRIM(pp.urzadzenie_id)||' - '||TRIM(u.nazwa),"
    SQL+=" pp.artykul_id, a.nazwa,SUM(pp.do_produkcji),MIN(pp.data||' '||pp.godz_minuta),MAX(pp.data||' '||pp.godz_minuta),"
    SQL+="SUM(pp.do_produkcji)/COUNT(partia_id) "

    SQL+="FROM rs_produkcja_plan pp "
    SQL+="LEFT OUTER JOIN rs_procesy p ON (pp.firma_id=p.firma_id AND pp.proces_id=p.proces_id) "
    SQL+="LEFT OUTER JOIN rs_artykuly a ON (pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
    SQL+="LEFT OUTER JOIN rs_urzadzenia u ON (pp.firma_id=u.firma_id AND pp.urzadzenie_id=u.urzadzenie_id) "
    SQL+="LEFT OUTER JOIN rs_operatorzy o ON ( o.operator_id='"+str(self.operator_id)+"' ) "

    SQL+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id='"+Oddzial+"'"
    SQL+=" AND pp.data_na_kiedy='"+Data+"'"
    if CzyZFiltra:
        if Proces <> '':
            SQL+=" AND pp.proces_id = '"+Proces+"' "
        if Zmiana<>'':
            SQL+= " AND pp.zmiana = '"+Zmiana+"' "
        if GodzOd<>'  :  ':
            SQL+= " AND pp.godz_minuta >= '"+GodzOd+"' "
        if GodzDo<>'  :  ':
            SQL+= " AND pp.godz_minuta <= '"+GodzDo+"' "
        if KategArt<>'':
            SQL+= " AND a.kateg_artykulu = '"+KategArt+"' "
        if Artykul<>'':
            SQL+= " AND pp.artykul_id like '"+Artykul+"%' "
        if Urzadzenie<>'':
            SQL+=" AND pp.urzadzenie_id = '"+Urzadzenie+"' "
        if CzyUwagi:
            SQL+=" AND trim(coalesce(pp.uwagi,'')) <> '' "    
    SQL+=" GROUP BY o.imie, o.nazwisko, pp.proces_id,p.nazwa, pp.urzadzenie_id, u.nazwa, pp.artykul_id, a.nazwa "
    SQL+=" ORDER BY pp.proces_id,pp.urzadzenie_id,MIN(pp.data||' '||pp.godz_minuta) "
    rsglobal.ZapiszDoLogow("SQL "+SQL,1)
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych: '+stat