#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_wydruki_kontrola_dokumentow_ksiegowych.py
# Purpose:          wydruk raportu kontroli poprawnosci przebiegu dekretacji automatycznej
# Author:           Dariusz Boduch
# Created:          2009/11/10
# RCS-ID:           $Id: fs_wydruki_kontrola_dokumentow_ksiegowych.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
#klucze: DataOd,DataDo
DataOd=klucze[0]
DataDo=klucze[1]

stat = "OK"
dane = []
Dane_roz=[]

#sprawdzenie poprawnosci danych
if DataOd.strip() in (None,'    -  -  ','None') and stat=='OK':
    stat='Brak daty od'
if DataDo in (None,'    -  -  ','None') and stat=='OK':
    stat='Brak daty do'
if DataOd not in (None,'    -  -  ','None') and stat=='OK':
     if not rsglobal.SprawdzCzyToData(DataOd):
            stat='Bdna data od'
if DataDo not in (None,'    -  -  ','None') and stat=='OK':
     if not rsglobal.SprawdzCzyToData(DataDo):
            stat='Bdna data do'

#---------------------------------------
#FAKTURY, KOREKTY
#---------------------------------------
if stat=='OK':
    #pobieranie poprawnoci faktur
    # sprawdzam czy wszystkie faktury z podanego okresu sa zaksiegowane 
    DaneF=[]
    NaglF=[]
    SELECT="SELECT CASE WHEN (count(*))=0 THEN 'OK' ELSE round(sum(do_zaplaty),2)::TEXT END as dane_fakt FROM rs_faktury WHERE "\
           " firma_id='"+self.firma_id+"' " \
           " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan<>'K' ;"

    stat,DaneF,NaglF,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu danych zaksigowanych faktur"

if stat=='OK':
    #pobieranie poprawnoci korekt
    # sprawdzam czy wszystkie korekty z podanego okresu sa zaksiegowane
    DaneK=[]
    NaglK=[]
    SELECT="SELECT CASE WHEN (count(*))=0 THEN 'OK' ELSE round(sum(do_zaplaty- do_zaplaty_p),2)::TEXT END as dane_kor FROM rs_korekty WHERE "\
           " firma_id='"+self.firma_id+"' " \
           " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan<>'K' ;"

    stat,DaneK,NaglK,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu danych zaksigowanych korekt"

if stat=='OK':
    #sprawdzam czy wszystkie dowody ksigowe powstae z dekretacji faktur s zamknite (stan 'Z') 
    DaneDK=[]
    NaglDK=[]
    SELECT="SELECT CASE WHEN (count(*))=0 THEN 'OK' ELSE round(sum(kwota_wn),2)::TEXT END as dane_d_k "\
           " FROM rs_dowody_ksiegowe dk LEFT OUTER JOIN rs_wzory_dekretacji wd " \
           " USING(firma_id, okres_id, dowod_id, nazwa_id) "\
           " WHERE dk.firma_id='"+self.firma_id+"' AND dk.okres_id='"+self.okres_id+"' AND "\
           " dk.data>='"+DataOd+"' AND dk.data<='"+DataDo+"' AND dk.stan <> 'Z' AND wd.typ_wzoru='F' ;"
    stat,DaneDK,NaglDK,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu danych zamknitych dowodw ksigowych"

if stat=='OK':
    #pobieram sumy kwot z zaksiegowanych faktur, korekt i zamknietych dowodow ksiegowych utworzonych z faktur
    #faktury
    DaneSF=[]
    NaglSF=[]
    SELECT="SELECT sum(do_zaplaty) as sum_fakt FROM rs_faktury WHERE "\
           " firma_id='"+self.firma_id+"' " \
           " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan='K' ;"

    stat,DaneSF,NaglSF,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu kwot zaksigowanych faktur"

if stat=='OK':
    #korekty
    DaneSK=[]
    NaglSK=[]
    SELECT="SELECT SUM(do_zaplaty - do_zaplaty_p) as sum_kor FROM rs_korekty WHERE "\
           " firma_id='"+self.firma_id+"' " \
           " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan='K' ;"
    stat,DaneSK,NaglSK,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu kwot zaksigowanych korekt"

if stat=='OK':
    #dowody ksiegowe
    DaneSDK=[]
    NaglSDK=[]
    SELECT="SELECT sum(kwota_wn) as sum_kwota_wn "\
           " FROM rs_dowody_ksiegowe dk LEFT OUTER JOIN rs_wzory_dekretacji wd "\
           " USING(firma_id, okres_id, dowod_id, nazwa_id) "\
           " WHERE dk.firma_id='"+self.firma_id+"' AND dk.okres_id='"+self.okres_id+"' AND "\
           " dk.data>='"+DataOd+"' AND dk.data<='"+DataDo+"' AND dk.stan = 'Z' AND wd.typ_wzoru='F' ;"
    stat,DaneSDK,NaglSDK,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu sum zamknitych dowodw ksigowych"
        
#---------------------------------------
#DOKUMENTY MAGAZYNOWE
#---------------------------------------
if stat=='OK':
    #pobieram dokumenty magazynowe ze wzorw dekretacji
    SELECT=" SELECT dokument_id FROM rs_wzory_dekretacji "\
           " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND typ_wzoru='M' ;"
    stat,DaneM,NaglM,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu dokumentw magazynowych ze wzorw dekretacji"
    Dok_Mag="( "
    for w in DaneM:
        Dok_Mag+="'"+str(w[0])+"',"
    self.Dok_Mag=Dok_Mag[:-1]+")"
    
    # sprawdzam czy wszystkie dokumenty magazynowe z podanego okresu sa zaksiegowane
    DaneDM=[]
    NaglDM=[]
    SELECT= "SELECT CASE WHEN (count(*))=0 THEN 'OK' ELSE round(sum(kwota),2)::TEXT END as dane_d_m "\
            " FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' " \
            " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan<>'K' ;" #AND dokument_id IN "+self.Dok_Mag+" "
    
    stat,DaneDM,NaglDM,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu sum zamknitych dowodw ksigowych"

if stat=='OK':
    #sprawdzam czy wszystkie dowody ksigowe powstae z dekretacji dokumentow magazynowych s zamknite (stan 'Z') 
    DaneDKM=[]
    NaglDKM=[]
    SELECT="SELECT CASE WHEN (count(*))=0 THEN 'OK' ELSE round(sum(kwota_wn),2)::TEXT END as dane_d_k "\
           " FROM rs_dowody_ksiegowe dk LEFT OUTER JOIN rs_wzory_dekretacji wd " \
           " USING(firma_id, okres_id, dowod_id, nazwa_id) "\
           " WHERE dk.firma_id='"+self.firma_id+"' AND dk.okres_id='"+self.okres_id+"' AND "\
           " dk.data>='"+DataOd+"' AND dk.data<='"+DataDo+"' AND dk.stan <> 'Z' AND wd.typ_wzoru='M' ;"
    stat,DaneDKM,NaglDKM,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu danych zamknitych dowodw ksigowych wygenerowanych z dokumentw magazynowych"

if stat=='OK':
    #pobieram sumy kwot z zaksiegowanych dokumentow magazynowych i zamknietych dowodow ksiegowych utworzonych z faktur
    #dokumenty magazynowe
    DaneSDM=[]
    NaglSDM=[]
    SELECT= "SELECT sum(abs(kwota)) as dane_sd_m "\
            " FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' " \
            " AND data>='"+DataOd+"' AND data<='"+DataDo+"' AND stan='K' AND dokument_id IN "+self.Dok_Mag+" ;"
    
    stat,DaneSDM,NaglSDM,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu sum zamknitych dokumentw magazynowych"

if stat=='OK':
    #sumy z zamknitych dowodw ksigowych
    DaneSDKM=[]
    NaglSDKM=[]
    SELECT="SELECT sum(abs(kwota_wn)) as sum_kwota_wn "\
           " FROM rs_dowody_ksiegowe dk LEFT OUTER JOIN rs_wzory_dekretacji wd " \
           " USING(firma_id, okres_id, dowod_id, nazwa_id) "\
           " WHERE dk.firma_id='"+self.firma_id+"' AND dk.okres_id='"+self.okres_id+"' AND "\
           " dk.data>='"+DataOd+"' AND dk.data<='"+DataDo+"' AND dk.stan = 'Z' AND wd.typ_wzoru='M' ;"
    stat,DaneSDKM,NaglSDKM,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu sum zamknitych dowodw ksigowych "

#-------------------------------------------------------------------------------------
#SPRAWDZENIE CZY POZYCJE DOWODOW KSIEGOWYCH ZGADZAJA SIE Z OPERACJAMI I ROZRACHUNKAMI 
#WG KONTA MA I SUM KWOTY MA                                                               
#-------------------------------------------------------------------------------------

if stat=='OK':
    #pobieram konta_ma z pozycji ze sprawdzanych dowodow ksiegowych 
    SELECT=" SELECT konto_ma  FROM rs_dowody_ksiegowe_pozycje dk "\
           " LEFT OUTER JOIN rs_wzory_dekretacji wd "\
           " USING(firma_id, okres_id, dowod_id, nazwa_id) "\
           " WHERE dk.firma_id='"+self.firma_id+"' AND dk.data>='"+DataOd+"' "\
           " AND dk.data<='"+DataDo+"' AND wd.typ_wzoru in ('F','M') "\
           " GROUP BY konto_ma ORDER BY konto_ma ;"
    stat,Dane_K,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd pobierania kont ma zamknitych dowodw ksigowych "

if stat=='OK' and len(Dane_K)>0:    
    #dla kazdego konta sprawdzam sume kwoty ma w operacjach i rozrachunkach
    #jesli sa rowne = OK inaczej zwracam kwoty i konto
    
    
    for w in Dane_K:
        SELECT= " SELECT sum(kp.kwota_ma) FROM rs_dowody_ksiegowe_pozycje kp "\
                " INNER JOIN rs_dowody_ksiegowe k ON(kp.firma_id=k.firma_id AND kp.okres_id=k.okres_id "\
                " AND kp.dowod_id=k.dowod_id AND kp.nazwa_id=k.nazwa_id AND kp.data=k.data AND kp.numer=k.numer) "\
                " WHERE kp.firma_id='"+self.firma_id+"' AND kp.data>='"+DataOd+"' "\
                " AND kp.data<='"+DataDo+"' AND kp.konto_ma='"+str(w[0])+"' "\
                " AND kp.dowod_id not in ('BO','BK') AND k.stan='Z' ;"
        stat,Dane_dk,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat!="OK":
            stat="Bd w pobieraniu sum kwot ma zamknitych dowodw ksigowych "
        
        SELECT= " SELECT sum(kwota_ma) FROM rs_operacje "\
                " WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' "\
                " AND data<='"+DataDo+"' AND konto='"+str(w[0])+"' "\
                " AND dowod_id not in ('BO','BK') ;"
        stat,Dane_do,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat!="OK":
            stat="Bd w pobieraniu sum kwot ma z operacji "

         
        SELECT= " SELECT sum(kwota_ma) FROM rs_rozrachunki "\
                " WHERE firma_id='"+self.firma_id+"' AND data>='"+DataOd+"' "\
                " AND data<='"+DataDo+"' AND konto='"+str(w[0])+"' "\
                " AND dowod_id not in ('BO','BK') ;"
        stat,Dane_dr,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat!="OK":
            stat="Bd w pobieraniu sum kwot ma z rozrachunkw "
            
        if Dane_dk[0][0]<>Dane_do[0][0]<>Dane_dr:
            Dane_roz.append([w[0],Dane_dk[0][0],Dane_do[0][0],Dane_dr[0][0]])

#-----------------------------------------------------------------------------------------
#SPRAWDZENIE CZY ZESTAWIENIE OBROTOW I SALD ZA WSZYSTKIE KONTA MA ZGODNE KWOTY SUM PARAMI 
#-----------------------------------------------------------------------------------------
if stat=='OK':
   
    RokOd= str(DataOd[:4])
    McOd= str(DataOd[5:7])
    RokDo= str(DataDo[:4])
    McDo= str(DataDo[5:7])
    Dane_spr=[]
    Poziom=1
    
    
    #pobranie listy kont z tabeli rs_stany_kont
    SQL=" SELECT  CASE WHEN ( length(konto_id)=0 or konto_id is null ) THEN  "\
        " kontos_id ELSE kontos_id||'-'||konto_id  END "\
        " FROM rs_plan_kont WHERE firma_id='"+self.firma_id+"' "\
        " AND okres_id='"+self.okres_id+"' ORDER BY 1 ;"
    stat,DaneKont,dump,dump = self.PolSQL.Execute(SQL,3)        
    if stat=='OK':
        if len(DaneKont)==0:
            stat="Brak kont "
    
    if stat=='OK':
        ListaKont = []
        #stworzenie pelnej list kont w oparciu o pobrana liste
        for konto in DaneKont:
            Konto=rsglobal.Dekoduj(konto[0])
            if not Konto in ListaKont:
                Poz=Konto.count("-")
          
                if Poz <= Poziom:
                    if not Konto in ListaKont:
                        ListaKont.append(Konto)
                bufor = Konto
                indeks = 0
                while indeks <> -1:
                    indeks = bufor.rfind("-")
                    if indeks <> -1:
                        bufor = bufor[0:indeks]
                        Poz = Poz-1
                    if not bufor in ListaKont:
                         if (bufor >= DaneKont[0][0]) and Poz <=Poziom:
                            ListaKont.append(bufor)
        
        #pobranie sum kont dla wszystkich kont (i potem wyszukiwanie)
        #Suma bilansu otwarcia
        SQL="SELECT konto,sum(kwota_wn) AS bown,sum(kwota_ma) AS boma FROM rs_stany_kont "\
            " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "\
            " AND rok = '"+RokDo+"' "\
            " AND miesiac = '00' GROUP BY konto ORDER BY konto;"
        stat,DaneBO,dump,dump = self.PolSQL.Execute(SQL,3)            
    if stat=='OK':
        #Suma obrotow narastajaca
        SQL="SELECT konto,sum(kwota_wn) AS narwn,sum(kwota_ma) AS narma FROM rs_stany_kont "\
            " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "\
            " AND  miesiac <> '00' "\
            " AND (rok<='"+RokDo+"' and miesiac <='"+McDo+"') GROUP BY konto ORDER BY konto;"
        stat,DaneNAR,dump,dump = self.PolSQL.Execute(SQL,3)            
    if stat=='OK':
        #Saldo
        SQL="SELECT konto,sum(saldo_wn) AS salwn,sum(saldo_ma) AS salma FROM rs_stany_kont "\
            " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "\
            " AND rok = '"+RokDo+"' AND miesiac = '"+McDo+"' GROUP BY konto ORDER BY konto;"
        stat,DaneSAL,dump,dump = self.PolSQL.Execute(SQL,3)            
    if stat=='OK':
        #pobranie danych dla kolejnych kont
        for Konto in ListaKont:
            if stat=='OK':
                KontoS = Konto[0:3]
                KontoA = ""
                if len(Konto)>3:
                    KontoA = Konto[4:len(Konto)]
                KontoA = KontoA.strip()
    
                #Pobranie danych konta
                SQL="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+Konto+"');"
                stat,DaneParK,dump,dump = self.PolSQL.Execute(SQL,3)            
                if stat=='OK':
                    if len(DaneParK)==0:
                        stat="Bdy w definicji konta : "+KontoS+"-"+KontoA  
                        
                if stat=='OK':
                    DaneKonta=eval(DaneParK[0][0])

                    Rozrachunkowe = DaneKonta[3]
                    Pozabilansowe = DaneKonta[4]
                    Jednostronne  = DaneKonta[7]
     
            if stat=='OK':
                BOWn=0
                BOMa=0
                if len(DaneBO)>0:
                    for BO in DaneBO:
                        if (Konto==BO[0]) or (BO[0][0:len(Konto)+1] == Konto+'-'):
                            if BO[1] not in (None,'None',0):
                                BOWn+=rsglobal.RSRound(BO[1],2)
                            if BO[2] not in (None,'None',0):
                                BOMa+=rsglobal.RSRound(BO[2],2)
                
            
                NARWn=0
                NARMa=0
                if len(DaneNAR)>0:
                    for NAR in DaneNAR:
                        if (Konto==NAR[0]) or (NAR[0][0:len(Konto)+1] == Konto+'-'):
                            if NAR[1] not in (None,'None',0):
                                NARWn+=rsglobal.RSRound(NAR[1],2)
                            if NAR[2] not in (None,'None',0):
                                NARMa+=rsglobal.RSRound(NAR[2],2)
    
                if Rozrachunkowe:
                    SALWn=0
                    SALMa=0
                    if len(DaneSAL)>0:
                        for SAL in DaneSAL:
                            if (Konto==SAL[0]) or (SAL[0][0:len(Konto)+1] == Konto+'-'):
                                if SAL[1] not in (None,'None',0):
                                    SALWn+=rsglobal.RSRound(SAL[1],2)
                                if SAL[2] not in (None,'None',0):
                                    SALMa+=rsglobal.RSRound(SAL[2],2)
                
                else:
                    if (BOWn+NARWn) > (BOMa+NARMa):
                        SALWn = rsglobal.RSRound(BOWn+NARWn-BOMa-NARMa,2)
                        SALMa = 0
                    else:
                        SALWn = 0
                        SALMa = rsglobal.RSRound(BOMa+NARMa-BOWn-NARWn,2)
    
                if Jednostronne:
                    if SALWn>SALMa:
                        SALWn=rsglobal.RSRound(SALWn-SALMa,2)
                        SALMa=0
                    else:
                        SALMa=rsglobal.RSRound(SALMa-SALWn,2)
                        SALWn=0
    
            #if (BOWn <> 0) or (BOMa <> 0) or (OBRWn <> 0) or (OBRMa <> 0) or (NARWn <> 0) or (NARMa <> 0) or (SALWn <> 0) or (SALMa <> 0):
            if (BOWn <> 0) or (BOMa <> 0) or (NARWn <> 0) or (NARMa <> 0) or (SALWn <> 0) or (SALMa <> 0):
                Dane_spr.append([Konto,Pozabilansowe,BOWn,BOMa,NARWn,NARMa,SALWn,SALMa])
            
            #porwnanie sald kont dla rozrachunkw i stanw kont
            Dane_spr_1=[]
            DaneRozr=[]
            DaneStKont=[]
            SQL=" SELECT sum(saldo_wn),sum(saldo_ma) "\
                " FROM rs_rozrachunki "\
                " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "\
                " AND data<='"+DataDo+"' AND konto = '"+Konto+"' ;"
            stat,DaneRozr,dump,dump = self.PolSQL.Execute(SQL,3)            
            if stat<>'OK':
                stat="Bdy w pobraniu z rozrachunkw sum sald konta: "+Konto  
            
            
            SQL=" SELECT saldo_wn,saldo_ma "\
                " FROM rs_stany_kont "\
                " WHERE firma_id='"+self.firma_id+"' AND rok='"+RokDo+"' "\
                " AND miesiac='"+McDo+"' AND konto = '"+Konto+"'  and okres_id='"+self.okres_id+"' ;"
            stat,DaneStKont,dump,dump = self.PolSQL.Execute(SQL,3)            
            if stat<>'OK':
                stat="Bdy w pobraniu ze stanw kont sald konta: "+Konto
            else:
                if DaneRozr and DaneStKont:
                    if not (DaneRozr[0][0]==0 and DaneRozr[0][1]==0 and DaneStKont==[]):
                        if (DaneRozr[0][0]<>DaneStKont[0][0]) or (DaneRozr[0][1]<>DaneStKont[0][1]):
                            Dane_spr_1.append([Konto,DaneRozr,DaneStKont])  
       
    if stat=='OK':
        Dane_roz.sort()
        Dane_spr.sort()
        Dane_spr_1.sort()    
                
if stat=='OK':
    #           0     1     2     3     4     5      6     7      8      9        10       11    12      13     14      15       16     17      18        19       20       21       22      
    dane=str([DaneF,NaglF,DaneK,NaglK,DaneDK,NaglDK,DaneSF,NaglSF,DaneSK,NaglSK,DaneSDK,NaglSDK,DaneDM,NaglDM,DaneDKM,NaglDKM,DaneSDM,NaglSDM,DaneSDKM,NaglSDKM,Dane_roz,Dane_spr,Dane_spr_1]) 