# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_korekta.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/01/29
# RCS-ID:      $Id: fs_wydruki_korekta.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-04-05 Mariusz Rajfura    (6745) dopasowanie pobrania danych dla korekty wartosciowej
# 2019-01-30 Wojciech Skowron  (11359) pobranie nr_bdo do daneOddz
# 2019-07-31 Wojciech Skowron  (11569) pobranie 'czy_mpp' do daneN
# 2020-07-13 Wojciech Skowron  (12045) kod CN
# 2021-02-04 Wojciech Skowron  (12289) Korzystanie z danych archiwalnych
# 2021-03-24 Aleksander Bagie (12354) Usun '!!!' z wydrukw
# 2023-12-04 Wojciech Skowron  (13623) Pobranie 'korekta_zaliczki' do daneN

#klucze= data,wyznacznik,numer,CzyDrukowacBiuro
from funkcje import fs_global_konta

Data=klucze[0]
Wyzn=klucze[1]
Nr=str(klucze[2])
CzyDrB=klucze[3]

stat = "OK"
dane = []

#pobranie wyznacznikw dostpnych
Lista=[self.firma_id,self.oddzial_id,'',self.operator_id]
sql = "SELECT rsf_podaj_liste_wyznacznikow('"+str(Lista).replace("'",'"')+"','"+str([]).replace("'",'"')+"','"+str([]).replace("'",'"')+"','"+str([]).replace("'",'"')+"');"
stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat<>'OK':
    stat = 'Bd w pobieraniu wyznacznikw.'
    dane.append(stat)
LW=wyzn[0][0]
if not Wyzn in LW:
    stat = 'Brak uprawnie do wydruku korekty z tym wyznacznikiem.'
    dane.append(stat)
#jeli uprawniony wyznacznik
if stat == 'OK':
    Filtr="firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
    FiltrK="k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+Wyzn+"' AND k.data='"+Data+"' AND k.numer="+Nr
    FiltrN="k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+Wyzn+"' AND k.data='"+Data+"' AND k.numer="+Nr
    Firma=self.firma_id
    KlPom=str([Wyzn,Data,Nr]).replace("'",'"')
#pobranie danych naglowka korekty
    #WS 2019-07-31 - czy_mpp
    #WS 2023-12-04 - korekta_zaliczki
    SQLN="SELECT k.waluta,k.stan,k.numer_z_rs,k.wersja,k.handlowiec,k.do_zaplaty-k.do_zaplaty_p AS rozn_do_zaplaty " # 0-5
    SQLN+=",k.kwota_netto-k.kwota_netto_p AS rozn_netto,k.do_zaplaty_wal-k.do_zaplaty_wal_p AS rozn_do_zaplaty_wal " # 6-7
    SQLN+=",k.kwota_netto_wal-k.kwota_netto_wal_p AS rozn_netto_wal,k.kwota_vat-k.kwota_vat_p AS rozn_vat " # 8-9
    SQLN+=",k.tytul_zmniejszenia_podatku,k.typ_dok_p,k.wyznacznik_id_p,k.data_p,CAST(k.numer_p AS TEXT) as nr_p,k.oddzial_id " # 10-15
    SQLN+=",k.kontrahent_id,k.zamawiajacy_id,k.platnik_id,k.miejsce_dostawy_id,k.kwota_netto,k.kwota_vat,k.do_zaplaty " #16-22
    SQLN+=",k.termin_zaplaty, pf.numer_z_rs as nrrspf, pk.numer_z_rs as nrrspk,k.opis, " #23-26
    SQLN+="k.wyznacznik_id_o as wyznacznik_o,k.data_o as data_o,CAST(k.numer_o AS TEXT) as numer_o, k.kwota_netto_p as kwota_n_p " #27-30
    SQLN+=",k.kwota_netto as kwota_n, rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','K') as nr_kor " #31-32
    SQLN+=", k.kraj_opodatkowania, k.kwota_vat_wal-k.kwota_vat_wal_p AS rozn_vat_wal, k.sposob_zaplaty "#33-35
    SQLN+=", COALESCE(wo.data_tekst,'') AS data_tekst_o, COALESCE(wp.data_tekst,'') AS data_tekst_p "# 36-37
    SQLN+=", COALESCE(pf.data_przychodu::TEXT,pk.data_przychodu::TEXT,'') AS data_przychodu_p" # 38
    SQLN+=", k.dostawy_od_dnia,k.dostawy_do_dnia" # 39-40
    SQLN+=", k.czy_mpp, wk.czy_korekta_zaliczki AND wk.typ_faktury='FZ' AS korekta_zaliczki" # 41-42
    SQLN+=" FROM rs_korekty k "
    SQLN+=" LEFT OUTER JOIN rs_faktury pf ON (k.firma_id=pf.firma_id AND k.wyznacznik_id_p=pf.wyznacznik_id "
    SQLN+=" AND k.data_p=pf.data AND k.numer_p=pf.numer) "
    SQLN+=" LEFT OUTER JOIN rs_korekty pk ON (k.firma_id=pk.firma_id AND k.wyznacznik_id_p=pk.wyznacznik_id "
    SQLN+=" AND k.data_p=pk.data AND k.numer_p=pk.numer) "
    SQLN+=" LEFT OUTER JOIN rs_wyznaczniki wk ON (wk.firma_id=k.firma_id AND wk.wyznacznik_id=k.wyznacznik_id) "  #WS 2023-12-04
    SQLN+=" LEFT OUTER JOIN rs_wyznaczniki wo ON (wo.firma_id=k.firma_id AND wo.wyznacznik_id=k.wyznacznik_id_o) "
    SQLN+=" LEFT OUTER JOIN rs_wyznaczniki wp ON (wp.firma_id=k.firma_id AND wp.wyznacznik_id=k.wyznacznik_id_p) "
    SQLN+=" WHERE "+FiltrN+";"
    stat,daneN,naglN,dump= self.PolSQL.Execute(SQLN,3)
    if stat<>'OK':
        stat = 'Bdy w pobieraniu danych korekty'
        dane.append(stat)
if stat == 'OK':
    DaneN = rssql.RSTableRowset(daneN,naglN)
    TypDokP = DaneN.GetVal(0,"typ_dok_p")
    WyzDokP = DaneN.GetVal(0,"wyznacznik_id_p")
    DataDokP = DaneN.GetVal(0,"data_p")
    NrDokP = DaneN.GetVal(0,"nr_p")
    WyzDokO = DaneN.GetVal(0,"wyznacznik_o")
    DataDokO = DaneN.GetVal(0,"data_o")
    NrDokO = DaneN.GetVal(0,"numer_o")
#pobranie danych stawek VAT i tytulu zmniejszenia podatku   
    stat,daneSV,naglSV,dump= self.PolSQL.Execute("SELECT wartosc_netto,opis,wartosc_vat,wartosc_brutto,wartosc_netto_p,wartosc_vat_p,wartosc_brutto_p,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,wartosc_wal_netto_p,wartosc_wal_vat_p,wartosc_wal_brutto_p FROM rs_korekty_vat fv INNER JOIN rs_stawki_vat sv ON (fv.stawka_vat=sv.kod) WHERE "+Filtr+";",3)
    if stat <>'OK':
        stat = 'Bd w pobieraniu danych stawek VAT korekty'
        dane.append(stat)
if stat == 'OK':       
    DaneSV = rssql.RSTableRowset(daneSV,naglSV)
    if DaneN.GetVal(0,"tytul_zmniejszenia_podatku") in ('','None'):
        TytZmPod='BRAK!'  #AB 20.03.21r
    else:
        stat,daneT,naglT,dump= self.PolSQL.Execute("SELECT opis FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id='"+self.firma_id+"' AND kod='"+DaneN.GetVal(0,"tytul_zmniejszenia_podatku")+"';",3)
        if stat != 'OK':
            stat = 'Bd w pobieraniu danych tytuu zmniejszenia podatku'
            dane.append(stat)
        if stat == 'OK':
            DaneT = rssql.RSTableRowset(daneT,naglT)
            TytZmPod=DaneT.GetVal(0,"opis")
if stat == 'OK':
    #pobranie danych oddzialu wystawiajacego korekte
    #WS 2019-01-30
    stat,daneOddz,naglOddz,dump=self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr,faktura_miej,nr_bdo FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    # stat,daneOddz,naglOddz,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr,faktura_miej FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    if stat<>'OK':
        stat='Bd w pobieraniu danych oddziau.'
        dane.append(stat)
        
if stat=='OK':
    # podmiana nazwy i numeru konta bankowego jeli kontrahent ma wpisane subkonto
    kontrahent=DaneN.GetVal(0,"kontrahent_id")
    platnik = DaneN.GetVal(0,"platnik_id")
    Konto=''
    
    if not platnik in ('',None,'None',kontrahent):
        SQL="SELECT platnosc_subkonto FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"'"
        SQL+=" AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,DKontaBankowego,dump,dump= self.PolSQL.Execute(SQL,3)        
        if stat=='OK':
            if len(DKontaBankowego)>0:
                if not DKontaBankowego[0][0] in ('',None):
                    Konto=rsglobal.Dekoduj(DKontaBankowego[0][0])        
    
    if stat=='OK' and Konto=='':
        SQL="SELECT platnosc_subkonto FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"'"
        SQL+=" AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,DKontaBankowego,dump,dump= self.PolSQL.Execute(SQL,3)        
        if stat=='OK':
            if len(DKontaBankowego)>0:
                if not DKontaBankowego[0][0] in ('',None,'None'):
                    Konto=rsglobal.Dekoduj(DKontaBankowego[0][0])
    
if stat=='OK' and Konto != '':
    KNazwa=fs_global_konta.PodajNazweBankuKonta(self,Konto)
    if KNazwa[:4] =='BLAD':
        stat='Bd pobierania nazwy konta bankowego z subkonta'
    elif not KNazwa=='Brak':
        # brutalne podstawienie nazwy konta i samego konta w danych oddziau
        daneOddz[0][13]=KNazwa
        daneOddz[0][14]=Konto
        
if stat == 'OK':
    if CzyDrB:
        #pobranie danych centrali
        #WS 2019-01-30
        stat,daneDod,naglDod,dump=self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr,nr_bdo FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        # stat,daneDod,naglDod,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        if stat<>'OK':
            stat='Bd w pobieraniu danych centrali.'
            dane.append(stat)
    else:
        daneDod=None
        naglDod=None
if stat=="OK":        
    #wybr sposobu sortowania artykuw na fakturze
    filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
    stat,daneC,naglC,dump=self.PolSQL.Execute("SELECT czy_ceny_na_dowodach, czy_wg_indeksow FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu sposobu indeksowania artykuw\nna fakturze.'
        dane.append(stat)
    if len(daneC) >0:
        DaneC=rssql.RSTableRowset(daneC,naglC)    
        Sort1=DaneC.GetVal(0,"czy_wg_indeksow")
    else:
        filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
        stat,daneC,naglC,dump=self.PolSQL.Execute("SELECT czy_ceny_na_dowodach, czy_wg_indeksow FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)
        if stat<>"OK":
            stat = 'Bd w pobieraniu sposobu indeksowania artykuw\nna fakturze.'
            dane.append(stat)
        if len(daneC) >0:
            DaneC=rssql.RSTableRowset(daneC,naglC)    
            Sort1=DaneC.GetVal(0,"czy_wg_indeksow")
        else:
            Sort1=False
        
    if Sort1== True:
        OrderBy= "CASE WHEN (fp.nr_ppoz=0 OR NOT fp.zestaw) THEN COALESCE(ao.obcy_id,'')"
        OrderBy+=" ELSE (SELECT COALESCE(pao.obcy_id,'') "
        OrderBy+=" FROM rs_faktury_pozycje pfp LEFT OUTER JOIN rs_artykuly_obce pao "
        OrderBy+=" ON (pao.firma_id=pfp.firma_id AND pao.kontrahent_id=k.kontrahent_id "
        OrderBy+=" AND pao.artykul_id=pfp.artykul_id) "
        OrderBy+=" WHERE pfp.firma_id='"+self.firma_id+"' AND pfp.wyznacznik_id='"+Wyzn+"' AND pfp.data='"+Data+"'"
        OrderBy+=" AND pfp.numer="+Nr+" AND pfp.nr_poz=fp.nr_poz AND pfp.nr_ppoz=0"
        OrderBy+="  ) END,"
        OrderBy+= "CASE WHEN (fp.nr_ppoz=0 OR NOT fp.zestaw) THEN fp.artykul_id"
        OrderBy+=" ELSE (SELECT pfp.artykul_id "
        OrderBy+=" FROM rs_faktury_pozycje pfp WHERE pfp.firma_id='"+self.firma_id+"'"
        OrderBy+=" AND pfp.wyznacznik_id='"+Wyzn+"' AND pfp.data='"+Data+"'"
        OrderBy+=" AND pfp.numer="+Nr+" AND pfp.nr_poz=fp.nr_poz AND pfp.nr_ppoz=0"
        OrderBy+="  ) END,"
        OrderBy+= "CASE WHEN (fp.nr_ppoz=0 OR NOT zestaw) THEN '' ELSE COALESCE(ao.obcy_id,'') END,"
        OrderBy+= "CASE WHEN (fp.nr_ppoz=0 OR NOT zestaw) THEN '' ELSE fp.artykul_id END"
    else:
        OrderBy='fp.nr_poz,fp.nr_ppoz'
if stat == 'OK':
    #pobranie pozycji normalnych
    Jm='CASE WHEN a.faktura_w_jm2 THEN UPPER(a.jm2) ELSE UPPER(a.jm1) END AS jm1'
    IloscP='CASE WHEN a.faktura_w_jm2 THEN fp.ilosc2_p ELSE fp.ilosc1_p END AS ilosc1_p'
    Ilosc='CASE WHEN a.faktura_w_jm2 THEN fp.ilosc2 ELSE fp.ilosc1 END AS ilosc1'
    CenaPN='CASE WHEN a.faktura_w_jm2 THEN fp.cena_netto2_p ELSE fp.cena_netto1_p END AS cena_netto1_p'
    CenaN='CASE WHEN a.faktura_w_jm2 THEN fp.cena_netto2 ELSE fp.cena_netto1 END AS cena_netto1'
    CenaPNU='CASE WHEN a.faktura_w_jm2 THEN fp.cena_upust2_p ELSE fp.cena_upust1_p END AS cena_upust1_p'
    CenaNU='CASE WHEN a.faktura_w_jm2 THEN fp.cena_upust2 ELSE fp.cena_upust1 END AS cena_upust1'
    CenaPNUWal='CASE WHEN a.faktura_w_jm2 THEN fp.cena_upust_wal2_p ELSE fp.cena_upust_wal1_p END AS cena_upust_wal1_p'
    CenaNUWal='CASE WHEN a.faktura_w_jm2 THEN fp.cena_upust_wal2 ELSE fp.cena_upust_wal1 END AS cena_upust_wal1'
    CenaB='CASE WHEN a.faktura_w_jm2 THEN fp.cena_brutto2 ELSE fp.cena_brutto1 END AS cena_brutto1'
    
    Pola='CAST(fp.nr_poz AS TEXT) as poz,CAST(fp.nr_ppoz AS TEXT) as ppoz,fp.artykul_id as artykul '
    #WS 2020-07-13
    Pola += ' ,a.nazwa as nazwa, '
    Pola += "(SELECT kod_cn FROM rs_artykuly_stawki_vat WHERE firma_id=fp.firma_id AND artykul_id=fp.artykul_id AND od_dnia<=k.data_o ORDER BY od_dnia DESC LIMIT 1) AS cn,"
    Pola += "(SELECT sww_pkwiu FROM rs_artykuly_stawki_vat WHERE firma_id=fp.firma_id AND artykul_id=fp.artykul_id AND od_dnia<=k.data_o ORDER BY od_dnia DESC LIMIT 1) AS pkwiu,"
    Pola += Jm+','+IloscP+','+CenaPN+','+CenaPNU
    # Pola+=' ,a.nazwa as nazwa,rsf_podaj_sww_pkwiu_artykulu(fp.firma_id,fp.artykul_id,k.data_o::TEXT) AS sww_pkwiu,'+Jm+','+IloscP+','+CenaPN+','+CenaPNU
    Pola+=' ,fp.wartosc_netto_p,sv1.opis as ovat1,fp.wartosc_vat_p,fp.wartosc_brutto_p,'+Ilosc+','+CenaN
    Pola+=' ,'+CenaNU+',fp.wartosc_netto,sv2.opis as ovat2,fp.wartosc_vat,fp.wartosc_brutto,fp.nr_serii '
    Pola+=' ,'+CenaPNUWal+',fp.wartosc_wal_netto_p,'+CenaNUWal+',fp.wartosc_wal_netto,ao.obcy_id as obcy_idk '
    Pola+=' ,ao.obca_nazwa as obca_nazwak,ao.obca_jm as obca_jmk,ap.obcy_id as obcy_idp,ap.obca_nazwa as obca_nazwap '
    Pola+=' ,ap.obca_jm as obca_jmp, fp.wartosc_wal_vat, fp.wartosc_wal_brutto, fp.wartosc_wal_vat_p, fp.wartosc_wal_brutto_p '
    Pola+=" ,fp.cecha1_opis,TRIM(COALESCE(CASE WHEN cecha1_wartosc='None' THEN '' ELSE fp.cecha1_wartosc END,'')) AS cecha1_wartosc"
    Pola+=" ,COALESCE(fp.zestaw,FALSE) AS zestaw"
    
    From=' FROM rs_korekty k LEFT OUTER JOIN rs_korekty_pozycje fp ON (k.firma_id=fp.firma_id AND k.wyznacznik_id=fp.wyznacznik_id AND k.data=fp.data AND k.numer=fp.numer) '
    From+=' INNER JOIN rs_artykuly a ON (k.firma_id=a.firma_id AND fp.artykul_id=a.artykul_id) '
    From+=' INNER JOIN rs_stawki_vat sv1 ON fp.stawka_vat_p=sv1.kod '
    From+=' INNER JOIN rs_stawki_vat sv2 ON fp.stawka_vat=sv2.kod '
    From+=' LEFT OUTER JOIN rs_artykuly_obce ao ON (k.firma_id=ao.firma_id AND k.kontrahent_id=ao.kontrahent_id AND fp.artykul_id=ao.artykul_id) '
    From+=' LEFT OUTER JOIN rs_artykuly_obce ap ON (k.firma_id=ap.firma_id AND k.platnik_id=ap.kontrahent_id AND fp.artykul_id=ap.artykul_id)'
    stat,daneP,naglP,dump= self.PolSQL.Execute("SELECT "+Pola+From+" WHERE "+FiltrK+" ORDER BY "+OrderBy+";",3)
    if stat<>'OK':
        stat='Bd w pobieraniu pozycji korekty.'
        dane.append(stat)
if stat == 'OK':
    #pobranie pozycji opisowych
    Pola='CAST(fpo.nr_poz AS TEXT),fpo.opis_pozycji,fpo.wartosc_netto_p,sv1.opis as ovat1,fpo.wartosc_vat_p, '
    Pola+='fpo.wartosc_brutto_p,fpo.wartosc_netto,sv2.opis as ovat2,fpo.wartosc_vat,fpo.wartosc_brutto, '
    Pola+=' fpo.wartosc_wal_netto, fpo.wartosc_wal_vat, fpo.wartosc_wal_brutto, fpo.wartosc_wal_netto_p, '
    Pola+=' fpo.wartosc_wal_vat_p, fpo.wartosc_wal_brutto_p, fpo.opis_pozycji_p '
    From=' FROM rs_korekty_pozycje_opisowe fpo LEFT OUTER JOIN rs_stawki_vat sv1 ON fpo.stawka_vat_p=sv1.kod LEFT OUTER JOIN rs_stawki_vat sv2 ON fpo.stawka_vat=sv2.kod '
    stat,daneO,naglO,dump= self.PolSQL.Execute("SELECT "+Pola+From+" WHERE "+Filtr+" ORDER BY fpo.nr_poz;",3)
    if stat<>'OK':
        stat='Bd w pobieraniu pozycji opisowych korekty.'
        dane.append(stat)
    elif len(daneP)+len(daneO)==0:
        stat='Brak wprowadzonych pozycji na korekcie.'
        dane.append(stat)
        
if stat == 'OK':
    #tekst przed i po stopce z wyznacznika korekty
    stat,daneW,naglW,dump= self.PolSQL.Execute("SELECT tekst_nad_podp,tekst_pod_podp FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';",3)
    if stat<>'OK':
        stat='Bd w pobieraniu tekstu przed i pod podpisem.'
        dane.append(stat)
if stat == 'OK':
    #dane kontrahenta
    #WS 2021-02-04
    stat,daneK,naglK,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id, bank_nazwa, bank_konto FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"kontrahent_id")+"','"+Data+"');", 3)
    # stat,daneK,naglK,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id, bank_nazwa, bank_konto FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"kontrahent_id")+"';",3)
    if stat<>'OK':
        stat='Bd w pobieraniu danych kontrahenta.'
        dane.append(stat)
if stat == 'OK':
    #sprawdzenie krajw wszystkich mozliwych miejsc
    #WS 2021-02-04
    k_kraj = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.kontrahent_id, '"+Data+"', 'kraj')"
    z_kraj = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.zamawiajacy_id, '"+Data+"', 'kraj')"
    p_kraj = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.platnik_id, '"+Data+"', 'kraj')"
    md_kraj = "rsf_podaj_pole_z_danych_kontrahenta(k.firma_id, k.miejsce_dostawy_id, '"+Data+"', 'kraj')"
    SQLKraje = "SELECT ({k_kraj}='PL' OR {k_kraj}='') AND ({z_kraj}='PL' OR {z_kraj}='') AND ({p_kraj}='PL' OR {p_kraj}='') AND ({md_kraj}='PL' OR {md_kraj}='') as czy_kraj "
    SQLKraje += " FROM rs_korekty k "
    # SQLKraje = "SELECT (ko.kraj='PL' OR ko.kraj IS NULL) AND (z.kraj='PL' OR z.kraj IS NULL) AND (p.kraj='PL' OR p.kraj IS NULL) AND (md.kraj='PL' OR md.kraj IS NULL) as czy_kraj "
    # SQLKraje=SQLKraje+"FROM rs_korekty k LEFT OUTER JOIN rs_kontrahenci ko ON (k.firma_id=ko.firma_id AND k.kontrahent_id=ko.kontrahent_id) "
    # SQLKraje=SQLKraje+" LEFT OUTER JOIN rs_kontrahenci z ON (k.firma_id=z.firma_id AND k.zamawiajacy_id=z.kontrahent_id) "
    # SQLKraje=SQLKraje+" LEFT OUTER JOIN rs_kontrahenci p ON (k.firma_id=p.firma_id AND k.platnik_id=p.kontrahent_id) "
    # SQLKraje=SQLKraje+" LEFT OUTER JOIN rs_kontrahenci md ON (k.firma_id=md.firma_id AND k.miejsce_dostawy_id=md.kontrahent_id) "
    SQLKraje=SQLKraje+" WHERE k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+Wyzn+"' AND k.data='"+Data+"' AND k.numer="+Nr+";"
    SQLKraje=SQLKraje.format(**locals())  #WS 2021-02-04
    stat,daneKraje,naglKraje,dump= self.PolSQL.Execute(SQLKraje,3)    
    if stat<>'OK':
        stat='Bd w pobieraniu danych kraju kontrahenta.'
        dane.append(stat)
if stat == 'OK':
    #pobranie nr telefonu oddziau, w ktrym wystawia si fakture
    stat,daneT,naglT,dump=self.PolSQL.Execute("SELECT tel1, tel2, drukowac_podpisy,fax,email FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+self.oddzial_id+"';",3)
    if stat<>"OK":
        stat="Bd w pobieraniu nr telefonu oddz."
        dane.append(stat)    
if stat == 'OK':    
    #pobranie danych faktury oryg.
    stat,daneNN,naglNN,dump= self.PolSQL.Execute("SELECT wyznacznik_id_p, data_p,CAST(numer_p AS TEXT) as numer_p,wyznacznik_id_o,data_o,CAST(numer_o AS TEXT) as numer_o, numer_z_rs FROM rs_korekty WHERE "+Filtr+";",3)
    if stat!= 'OK':
        stat = 'Bd w pobieraniu danych faktury oryginalnej.'
        dane.append(stat)
if stat == 'OK':   
    if daneNN[0][3] in ('','None',None):
        wyznacznik=str(daneNN[0][0])
    else:
        wyznacznik=str(daneNN[0][3])
    
    if daneNN[0][4] in ('','None',None):
        data=daneNN[0][1]
    else:
        data=daneNN[0][4]
    
    if daneNN[0][5] in ('','None',None):
        numer=str(daneNN[0][2])
    else:
        numer=str(daneNN[0][5])

    if wyznacznik=='None' and data=='None':
        # korekta wartosciowa nie posiada danych faktury oryginalnej
        daneFO = []
        naglFO = []
    else:
        stat,daneFO,naglFO,dump= self.PolSQL.Execute("SELECT wyznacznik_id,data,CAST(numer AS TEXT) as numer, numer_z_rs, data_przychodu FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wyznacznik+"' AND data='"+data+"' AND numer="+numer+";",3)
        if stat<>"OK":
            stat='Bd w pobieraniu danych faktury oryg.'
            dane.append(stat)

if stat == 'OK':   
    #pobranie tekstu do nagwka faktury
    stat,daneNg,naglNg,dump=self.PolSQL.Execute("SELECT tekst_naglowka FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';",3)
    if stat<>"OK":
        stat="Bd w pobieraniu nagwka"
        dane.append(stat)
if stat == 'OK':
    #pobranie danych operatora
    stat,daneOP,naglOP,dump=self.PolSQL.Execute("SELECT imie, nazwisko FROM rs_operatorzy WHERE operator_id = '"+str(self.operator_id)+"'",3)
    if stat<>"OK":
        stat="Bd w pobieraniu danych operatora"
        dane.append(stat)
if stat == 'OK':
    #dane platnika
    #WS 2021-02-04
    stat,danePL,naglPL,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,pesel,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,adrk_kod,adrk_miej,adrk_poczta,adrk_ulica,adrk_nry,kontrahent_id, nazwa_pelna FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"platnik_id")+"','"+Data+"');", 3)
    # stat,danePL,naglPL,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,pesel,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,adrk_kod,adrk_miej,adrk_poczta,adrk_ulica,adrk_nry,kontrahent_id, nazwa_pelna FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"platnik_id")+"';",3)
    if stat<>'OK':
        stat='Bd pobierania danych patnika.'
        dane.append(stat)
if stat == 'OK':
    #numery dokumentow z funkcji
    Firma=self.firma_id
    KlPierw = str([WyzDokP,DataDokP,NrDokP]).replace("'",'"')
    KlOryg = str([WyzDokO,DataDokO,NrDokO]).replace("'",'"')
    stat,daneNFP,naglNFP,dump=self.PolSQL.Execute("SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPierw+"','"+TypDokP+"');",3)
    if stat<>'OK':
        stat='Bd pobierania numeru dokumentu korygowanego.'
        dane.append(stat)
if stat == 'OK':
    if WyzDokO not in ('None',None) or DataDokO not in ('None',None):
        stat,daneNFO,naglNFO,dump=self.PolSQL.Execute("SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlOryg+"','F');",3)
        if stat<>'OK':
            stat='Bd pobierania numeru dokumentu oryginalnego'
            dane.append(stat)
    else:
        daneNFO=[[u'None']]
        naglNFO=['None']
if stat=="OK":  
    #wsprzdne pocztku wydruku adresu odbiorcy faktury - koperta
    stat,daneWR,naglWR,dump = self.PolSQL.Execute("SELECT koperta_wiersz, koperta_kolumna FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych wsprzdnych wydruku.'
        dane.append(stat)
if stat=='OK':
    #dane zamawiajacego
    #WS 2021-02-04
    stat,daneZAM,naglZAM,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"zamawiajacy_id")+"','"+Data+"');", 3)
    # stat,daneZAM,naglZAM,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"zamawiajacy_id")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych zamawiajcego'
        dane.append(stat)    
if stat=='OK':
    #dane miejsca dostawy
    #WS 2021-02-04
    stat,daneMiejDost,naglMiejDost,dump=self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rsf_dane_kontrahenta('"+self.firma_id+"','"+DaneN.GetVal(0,"miejsce_dostawy_id")+"','"+Data+"');", 3)
    # stat,daneMiejDost,naglMiejDost,dump=self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"miejsce_dostawy_id")+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych miejsca dostawy'
        dane.append(stat)

if stat=='OK':        
    #pobranie danych konta patnika (konto id z danych do fakturoiwania)
    platnik = DaneN.GetVal(0,"platnik_id")
    SQLKtoId="SELECT k.bank as bank,k.konto as konto "
    SQLKtoId+="FROM rs_kontrahenci_fakturowanie f "
    SQLKtoId+="LEFT OUTER JOIN rs_konta_bankowe k ON(f.firma_id=k.firma_id AND f.konto_id=k.konto_id) "
    SQLKtoId+="WHERE f.firma_id='"+self.firma_id+"' "
    SQLKtoId+="AND f.kontrahent_id='"+platnik+"' "
    SQLKtoId+="AND f.data_od=(SELECT MAX(data_od) FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' "
    SQLKtoId+="AND kontrahent_id='"+platnik+"' and data_od<='"+Data+"') ;"
    stat,daneKtoId,naglKtoId,dump=self.PolSQL.Execute(SQLKtoId,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych konta przypisanego do patnika'
        dane.append(stat)   

if stat == 'OK':
    #czy adres korespondencyjny z wyznacznika orygianlnej faktury
    # wsprzdne pocztku wydruku adresu odbiorcy faktury - koperta 
    SQLWyznO="SELECT adres_korespondencyjny FROM rs_wyznaczniki "
    SQLWyznO+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyzDokO+"';"
    stat,daneWO,naglWO,dump= self.PolSQL.Execute(SQLWyznO,3)

    stat,daneW,naglW,dump= self.PolSQL.Execute("SELECT tekst_nad_podp,tekst_pod_podp FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"';",3)
    if stat<>'OK':
        stat='Bd w pobieraniu tekstu przed i pod podpisem.'
        dane.append(stat)

if stat == 'OK':  
    #           0     1      2     3       4        5        6        7       8      9    10    11    12            
    dane=str([daneN,naglN,daneSV,naglSV,TytZmPod,daneOddz,naglOddz,daneDod,naglDod,daneP,naglP,daneO,naglO,
              # 13    14   15     16     17        18      19     20    21     22     23     24     25     26
              daneW,naglW,daneK,naglK,daneKraje,naglKraje,daneT,naglT,daneFO,naglFO,daneNg,naglNg,daneOP,naglOP,
              # 27     28      29     30      31      32      33     34     35      36         37           38
              danePL,naglPL,daneNFP,naglNFP,daneNFO,naglNFO,daneWR,naglWR,daneZAM,naglZAM,daneMiejDost,naglMiejDost,
              #   39      40        41      42
              daneKtoId,naglKtoId,daneWO,naglWO])  