# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wydruki_korekty.py
# Purpose:     pobranie danych uzupelniajacych do wydruku korekty 
# Author:      Mariusz Rajfura
# Created:     2009/05/15
# RCS-ID:      $Id: fs_wydruki_korekty.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-05-10 Wojciech Skowron   (11480) Wysyanie grupowe maili z korektami
# 2019-08-02 Wojciech Skowron   (11574) Przy wysyaniu korekt e-mailem: pobieranie adresu docelowego najpierw od kontrahenta, potem od patnika
# 2019-08-08 Wojciech Skowron   (11574) Wysyanie e-mailem korekt tylko w stanie 'Z' lub 'K'
# 2023-03-23 Aleksander Bargie (13349) wysyanie faktur pdf mailem - uwagi

import binascii
import os
import tempfile
import traceback

Fun = klucze[-1]

stat = 'OK'
dane = []

UprDruk = (self.oddzial_id,'023019') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID

if not UprDruk:
    stat='Brak uprawnie do wydruku korekty.'
  
if stat=='OK' and Fun==9:
    
    wyzn = klucze[0]
    data = klucze[1]
    numer = str(klucze[2])
    
    sql="SELECT plik_wydruku FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND wyznacznik_id='"+wyzn+"';"
    
    stat,dwyzn,dump,dump = self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat = 'Bd pobrania pliku wydruku dla wyznacznika: '+stat
    
    if stat=='OK':
        if len(dwyzn)==0:
            stat='Brak definicji wyznacznika: '+wyzn
            
    if stat=='OK':  
        #WS 2019-08-08 - pobranie stanu
        sql="SELECT waluta, kontrahent_id, platnik_id, stan in ('Z','K') FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+wyzn+"' AND data='"+data+"' AND numer="+numer+";"
        
        stat,dwalut,dump,dump = self.PolSQL.Execute(sql,3)
        
        if stat<>'OK':
            stat = 'Bd pobrania waluty z korekty: '+stat
            
        if stat=='OK':
            if len(dwalut)==0:
                stat = 'Brak korekty o podanym kluczu: '+wyzn+"/"+data+"/"+numer
    #sprawdzam czy wydruk faktury korygujacej zbiorczej DB, mantis: 3307
    dnrzbiorczy=[[0.0]]
    if stat=='OK':
        sql="SELECT nr_zbiorczy FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+wyzn+"' AND data='"+data+"' AND numer="+numer+";" 
        stat,dnrzbiorczy,dump,dump = self.PolSQL.Execute(sql,3)
       
        if stat<>'OK':
            stat = 'Bd sprawdzania nr zbiorczego z korekty: '+stat

    if stat=='OK':
        sql="SELECT czy_drukowac_korekty, czy_pdf_korekty FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+dwalut[0][1]+"' AND data_od<='"+data+"' ORDER BY data_od DESC LIMIT 1;"
        rsglobal.ZapiszDoLogow('sql '+sql,5)
        stat,dkontr,dump,dump = self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow('dkontr '+str(dkontr),5)
        if stat != 'OK':
            stat='Bd pobrania danych do fakturowania kontrahenta: '+stat
        elif len(dkontr) == 0:
            sql="SELECT czy_drukowac_korekty, czy_pdf_korekty FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+dwalut[0][2]+"' AND data_od<='"+data+"' ORDER BY data_od DESC LIMIT 1;"
            rsglobal.ZapiszDoLogow('sql '+sql,5)
            stat,dkontr,dump,dump = self.PolSQL.Execute(sql,3)
            rsglobal.ZapiszDoLogow('dkontr '+str(dkontr),5)
            if stat != 'OK':
                stat='Bd pobrania danych do fakturowania patnika: '+stat
            elif len(dkontr) == 0:
                dkontr = [[True,False,False]]

    if stat=='OK':
        dane=str([dwyzn[0][0],dwalut[0][0],dnrzbiorczy[0][0],dkontr,dwalut[0][3]]) #WS 2019-08-08 - pobranie stanu

#-------------------------------------------------------------------------------
# -- wysylka korekt e-mailem - 10
#-------------------------------------------------------------------------------

#WS 2019-05-10
if stat == 'OK' and Fun == 10:
    wyzn = klucze[0]
    data = klucze[1]
    numer = str(klucze[2])
    trescZalacznika = klucze[3]

    SELECT = "SELECT email_uzytkownik, imie, nazwisko FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3)
    if stat != "OK":
        stat = "BL_SQL_OP"
    else:
        if dane[0][0] in (None, ''):
            stat = "BL_OP"
        else:
            nadawca = dane[0][0]
            imie = dane[0][1]
            nazwisko = dane[0][2]

    if stat == "OK":
        Firma = self.firma_id
        KlPom = str([wyzn,data,numer]).replace("'",'"')
        SELECT = "SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','K');"
        stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3)
        if stat != 'OK':
            stat = "BL_RSF_NR_DOK"
        else:
            nr_dok = dane[0][0]

    #WS 2019-08-02 - pobieranie docelowego adresu e-mail najpierw od kontrahenta, potem od patnika; poprawione sprawdzanie czy e-mail wypeniony
    if stat == "OK":
        SELECT = "SELECT email FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id=("
        SELECT += "SELECT kontrahent_id FROM rs_korekty "
        SELECT += " WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+wyzn+"' AND data='"+data+"' AND numer="+numer+");"
        stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3,CzyDodawacBlad=True)
        if stat != "OK":
            stat = "Bd pobrania adresu e-mail kontrahenta korekty: "+stat
        else:
            if len(dane) == 0 or dane[0][0].strip() in ('','None',None):
                SELECT = "SELECT email FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id=("
                SELECT += "SELECT platnik_id FROM rs_korekty "
                SELECT += " WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+wyzn+"' AND data='"+data+"' AND numer="+numer+");"
                stat,dane,dump,dump = self.PolSQL.Execute(SELECT,3,CzyDodawacBlad=True)
                if stat != "OK":
                    stat = "Bd pobrania adresu e-mail patnika korekty: "+stat
                elif len(dane) == 0 or dane[0][0].strip() in ('','None',None):
                    stat = "BL_PLAT_EMAIL"
                else:
                    adresat = dane[0][0].strip()
            else:
                adresat = dane[0][0].strip()

    if stat == "OK":
        temat = "Korekta nr "+nr_dok
        tresc = "W zaczniku korekta.\n\nPozdrawiam\n"+imie+" "+nazwisko

        Blad = False
        trescZalacznika = binascii.unhexlify(trescZalacznika)
        try:
            zalacznik = os.path.join(tempfile.gettempdir(), nr_dok.replace('/', '_')+'.pdf')
            tmp = open(zalacznik, 'wb')
            tmp.write(trescZalacznika)
            tmp.close()
        except EnvironmentError, e:
            rsglobal.ZapiszDoLogow(traceback.format_exc(), 5)
            stat = "BL_OS"
            Blad = True

        if not Blad:
            #AB 23.03.23r
            cc = None
            if ',' in adresat:
                cc = ','.join(adresat.split(',')[1:])
                adresat = adresat.split(',')[0].strip()
            stat = rsglobal.RSWyslijEmail(adresat, temat, tresc, [zalacznik], self.operator_id, polsql=self.PolSQL,
                                          cc=cc,  bcc=nadawca)
            if stat != 'OK':
                rsglobal.ZapiszDoLogow(stat, 5)
                stat = "BL_RSWYSLIJEMAIL"
            else:
                rsglobal.ZapiszDoLogow(u'Wysano e-mail z korekt nr '+nr_dok+' do '+adresat, 5)
