# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_listy_plac.py
# Purpose:     Pobranie danych do wydruku listy plac
# Author:      Marcin Natkaski
# Created:     2015/12/19
# RCS-ID:      $Id: fs_wydruki_listy_plac.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2022-03-11 Aleksander Bargie (12920) - Graficzny wydruk listy pac


if len(klucze) > 1:
    # wydruki sum
    #Numer = rsglobal.Dekoduj(str(klucze[0]))
    Numery = "("
    for w in klucze:
        Numery += "'" + w + "',"
    Numery = Numery[:-1] + ")"
    Sumy = True
else:
    # wydruk pojedynczej listy
    Numer = klucze[0]
    Sumy = False


stat = "OK"
dane = []

#Dane pobierane s w czterech rnych zapytaniach bo nie ma sensu komplikowa niskokosztowych zapyta
if stat == 'OK':
    #pobieramy nazw firmy
    SQL="SELECT opis FROM rs_firmy WHERE firma_id='"+self.firma_id+"' ;"
    stat,firma,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd pobierania nazwy firmy: '+stat

if stat == 'OK':  #AB 11.03.22r
    #pobieramy dane oddziau
    SQL = """SELECT nazwa, adr_kod, adr_miej, adr_ulica, adr_nry  
             FROM rs_oddzialy ro 
             WHERE firma_id ='{}' AND centrala; """.format(self.firma_id)
    stat, oddz, o_wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania danych oddziau: '+stat
    else:
        oddzial = {}
        for x in xrange(len(o_wyn1)):
            oddzial[o_wyn1[x][0]] = oddz[0][x]

if not Sumy:
  if stat == 'OK':
    #pobieramy opis, grupe pracowikow, data od, data do, data wypatu
    SQL=" SELECT opis, grupa_pracownikow, data_od, data_do, data_wyplaty FROM rs_kp_listy_plac"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id='"+Numer+"';"
    stat,lista,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd pobierania danych listy: '+stat
else:
  lista = []

if not Sumy:
  if stat == 'OK':
    #pobieramy liste skladnikow do wydruku
    SQL  =" SELECT skladniki_dr, skladniki FROM rs_kp_szablony_list_plac_wersje sz INNER JOIN rs_kp_listy_plac lp "
    SQL +=" USING (firma_id, lista_id )"
    SQL +=" WHERE lp.firma_id='"+self.firma_id+"' AND lp.numer_listy_id='"+Numer+"'"
    SQL +=" AND sz.data_od<=lp.data_od ORDER BY sz.data_od DESC LIMIT 1;"
    stat,skladniki,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'Bd pobierania skladnikow drukowanych: '+stat
    else:
        rsglobal.ZapiszDoLogow('skladniki: ' + str(skladniki), 5)
else:
    # pobieramy liste skladnikow do zbiorowki
    SQL = " SELECT spw.skladnik_id, sp.skrot FROM rs_kp_skladniki_placowe_wersje spw INNER JOIN rs_kp_skladniki_placowe sp "
    SQL += " USING (firma_id, skladnik_id )"
    SQL += " WHERE spw.firma_id='" + self.firma_id + "' AND druk_na_zbiorowce"
    SQL += " ORDER BY spw.data_od DESC LIMIT 1;"
    stat, skladniki, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania skladnikow drukowanych: ' + stat
    else:
        rsglobal.ZapiszDoLogow('skladniki: ' + str(skladniki), 5)

if not Sumy:
  if stat == 'OK':
#    SQL= " SELECT s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,sum(s.wartosc),s.data_od,'',  "
    SQL= " SELECT s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,sum(s.wartosc),'','',  "
    SQL+=" (SELECT pogrubienie FROM rs_kp_skladniki_placowe_wersje WHERE firma_id =s.firma_id AND skladnik_id=s.skladnik_id"
    SQL+=" AND data_od <= s.data_od AND (data_do >=s.data_od OR data_do IS NULL) ORDER BY data_od DESC LIMIT 1) as pogrub"
    SQL+=" FROM rs_kp_listy_plac_osoby_skladniki s INNER JOIN rs_kp_dane_osobowe d USING (firma_id,pracownik_id)  "
    SQL+=" INNER JOIN rs_kp_skladniki_placowe z USING (firma_id, skladnik_id)"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer_listy_id='"+Numer+"' AND "
    SQL+=" (SELECT na_liscie_plac FROM rs_kp_skladniki_placowe_wersje WHERE firma_id =s.firma_id AND skladnik_id=s.skladnik_id "
    SQL+=" AND data_od <= s.data_od AND (data_do >=s.data_od OR data_do IS NULL) ORDER BY data_od DESC LIMIT 1)"
#    SQL+=" GROUP BY s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,s.data_od,pogrub  "
    SQL+=" GROUP BY s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,pogrub  "
    SQL+=" ORDER BY d.nazwisko, d.imie, s.pracownik_id, s.skladnik_id"
    stat,pracownicy,dump,dump = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('wydruk1: '+SQL, 5)
    if stat != 'OK':
        stat = 'Bd pobierania pracownikw: '+stat
    elif len(pracownicy) == 0:
        stat='Brak skadnikw do wydruku listy pac.'
        dane.append(stat)

    if stat == 'OK':
        #rsglobal.ZapiszDoLogow('skladniki_len: ' + str(len(skladniki)), 5)
        if len(skladniki) == 1:
            skladniki_dr = skladniki[0][0].split(',')
            if len(skladniki_dr) <= 1:
                skladniki_dr = skladniki[0][1].split(',')
            #rsglobal.ZapiszDoLogow('skladniki_dr: ' + str(skladniki_dr), 5)
            if len(skladniki_dr) > 1:
                #zmiana kolejnosci skladnikow, wyrzucenie niepotrzebnych
                pracownicynowy = []
                pracownicytemp = []
                pracownik = pracownicy[0][0]
                for wpr in pracownicy:
                    if wpr[0] != pracownik:
                        # zmiana sortu
                        for wsk in skladniki_dr:
                            for w in pracownicytemp:
                                if wsk.strip() == w[3].strip():
                                    pracownicynowy.append(w)
                                    break
                        # wyzerowanie zmiennych
                        pracownik = wpr[0]
                        pracownicytemp = []
                    pracownicytemp.append(wpr)
                # ostatni pracownik
                rsglobal.ZapiszDoLogow('pracownicytemp: ' + str(pracownicytemp), 5)
                for wsk in skladniki_dr:
                    for w in pracownicytemp:
                        if wsk.strip() == w[3].strip():
                            pracownicynowy.append(w)
                            break
            else:
                pracownicynowy = pracownicy
        else:
            pracownicynowy = pracownicy
        rsglobal.ZapiszDoLogow('pracownicynowy: ' + str(pracownicynowy), 5)
else:
  # sumy
  if stat == 'OK':
      # SQL = " SELECT s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,sum(s.wartosc),s.data_od,'',  "
      SQL = " SELECT s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,sum(s.wartosc),'','',  "
      SQL += " (SELECT pogrubienie FROM rs_kp_skladniki_placowe_wersje WHERE firma_id =s.firma_id AND skladnik_id=s.skladnik_id"
      SQL += " AND data_od <= s.data_od AND (data_do >=s.data_od OR data_do IS NULL) ORDER BY data_od DESC LIMIT 1) as pogrub"
      SQL += " FROM rs_kp_listy_plac_osoby_skladniki s INNER JOIN rs_kp_dane_osobowe d USING (firma_id,pracownik_id)  "
      SQL += " INNER JOIN rs_kp_skladniki_placowe z USING (firma_id, skladnik_id)"
      SQL += " WHERE firma_id='" + self.firma_id + "' AND numer_listy_id IN " + Numery + " AND "
      SQL += " (SELECT druk_na_zbiorowce FROM rs_kp_skladniki_placowe_wersje WHERE firma_id =s.firma_id AND skladnik_id=s.skladnik_id "
      SQL += " AND data_od <= s.data_od AND (data_do >=s.data_od OR data_do IS NULL) ORDER BY data_od DESC LIMIT 1)"
      # SQL += " GROUP BY s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,s.data_od,pogrub  "
      SQL += " GROUP BY s.pracownik_id,d.imie, d.nazwisko,s.skladnik_id, z.skrot,pogrub  "
      SQL += " ORDER BY d.nazwisko, d.imie, s.pracownik_id, s.skladnik_id"
      stat, pracownicy, dump, dump = self.PolSQL.Execute(SQL, 3)
      rsglobal.ZapiszDoLogow('zbiorowka: ' + SQL, 5)
      if stat != 'OK':
          stat = 'Bd pobierania pracownikw: ' + stat
      elif len(pracownicy) == 0:
          stat = 'Brak skadnikw do wydruku zbiorwki.'
          dane.append(stat)

      pracownicynowy = pracownicy
      rsglobal.ZapiszDoLogow('pracownicynowy: ' + str(pracownicynowy), 5)

if not Sumy:
    if stat == 'OK':
        #JR 2022-09-13 (13153) zmiana w liczeniu etatow
        #SQL=" SELECT SUM(a.etat) FROM rs_kp_angaze a INNER JOIN rs_kp_listy_plac_osoby b "
        #SQL+=" USING (firma_id, pracownik_id, zatrudnienie_id, umowa_id, angaz_id) "
        #SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND b.numer_listy_id='"+Numer+"' "
        SQL = " SELECT SUM(wartosc) FROM  rs_kp_listy_plac_osoby_skladniki "
        SQL += " WHERE firma_id='"+self.firma_id+"' AND numer_listy_id='"+Numer+"' AND TRIM(skladnik_id)='A_009'"
        stat,etaty,dump,dump = self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow('wydruk2: '+SQL, 5)
        if stat != 'OK':
            stat = 'Bd pobierania etatw: '+stat
else:
    etaty = [0]

if not Sumy:
    if stat == 'OK':
        SQL=" SELECT a.pracownik_id, TRIM(a.wartosc1) FROM rs_kp_dane_osobowe_dane_dodatkowe a INNER JOIN rs_kp_listy_plac_osoby b "
        SQL+=" USING (firma_id, pracownik_id) "
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND b.numer_listy_id='"+Numer+"' AND a.typ_id='RS001' ORDER BY a.pracownik_id, a.lp"
        stat,spadkobiercy,dump,dump = self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow('wydruk3:' +SQL, 5)
        if stat != 'OK':
            stat = 'Bd pobierania spadkobiercw: '+stat
else:
    spadkobiercy = []



if stat == 'OK':
    dane.append(firma)
    dane.append(lista)
    dane.append(pracownicynowy)
    dane.append(etaty)
    dane.append(spadkobiercy)
    dane.append(oddzial)  #AB 11.03.22r
