# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_raport_dostepnosci.py
# Purpose:     podanie danych do raportu dostpnoci w DD
# Author:      Micha Raburski
# Created:     2014/10/01
# RCS-ID:      $Id: fs_wydruki_raport_dostepnosci.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = 'OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'LMagazyn':[5],'LKatArt':[5],'LDokumMag':[5],'DataOd':[5],'DataDo':[5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_wydruki_raport_dostepnosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
if stat=='OK':
    if Funkcja == 5: 
        LMag=klucze['LMagazyn']
        LKatArt=klucze['LKatArt'].split(',')
        LDokMag=str(klucze['LDokumMag'].split(','))
        DataOd=klucze['DataOd']
        DataDo=klucze['DataDo']

if stat == 'OK':
    dane = []
    
    # sownik. klucz to artyku 
    #              0         1            2           3               4        5
    # warto to nazwa,ilo magazyn, ilo DD, ilo z DD bez WZ, Ilo WZ, braki
    # 
    SArt={}
    
# pobranie iloci z dowodw dostaw nie majcych dokumentu WZ 
# pniejszych ni 2014-09-31 (by historia nie przeszkadzaa)
if stat == 'OK':
    SQL = "SELECT a.artykul_id, a.nazwa,dd.wz_data IS NULL, SUM(ddp.ilosc_zam1) FROM rs_dowody_dostaw_pozycje ddp"
    SQL+= " INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)"
    SQL+= " INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" WHERE ddp.firma_id = '"+self.firma_id+"' AND ddp.oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND ddp.data >='"+DataOd+"' AND ddp.data <='"+DataDo+"' AND ("
    for kat in LKatArt:
        SQL+="a.kateg_artykulu LIKE '"+kat+"%' OR "
    SQL=SQL[:-4]+") GROUP BY a.artykul_id, a.nazwa,dd.wz_data IS NULL HAVING SUM(ddp.ilosc_zam1) > 0"

    stat,DDD,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        for w in DDD:
            if not w[0] in SArt:
                SArt[w[0]] = [w[1],0.0,w[3],0.0,0.0,0.0]
            else:
                SArt[w[0]][2] += w[3]
            
            # jeli nie ma WZ
            if w[2]:
                SArt[w[0]][3] += w[3]
                SArt[w[0]][5] += - w[3]

if stat == 'OK':    
    # pobranie iloci z magazynu
    SQL = "SELECT a.artykul_id,am.ilosc1 FROM rs_artykuly_magazyny am "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+=" WHERE am.firma_id='"+self.firma_id+"' AND magazyn_id IN ("+str(LMag.split(','))[1:-1]+") AND ("
    for kat in LKatArt:
        SQL+="a.kateg_artykulu LIKE '"+kat+"%' OR "
    SQL=SQL[:-4]+")"
    rsglobal.ZapiszDoLogow('SQL2 '+SQL,1)
    stat,DMagaz,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        for w in DMagaz:
            if w[0] in SArt:
                SArt[w[0]][1] += w[1]
                SArt[w[0]][5] += w[1]
        
# pobranie iloci z niezamknitych WZ 
if stat == 'OK':
    SQL = "SELECT a.artykul_id,SUM(dmp.ilosc1) FROM rs_dokumenty_magazynowe_pozycje dmp "
    SQL+= " INNER JOIN rs_dokumenty_magazynowe dm USING(firma_id,magazyn_id,dokument_id,data,numer)"    
    SQL+= " INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"    
    SQL+= " WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id IN ("+str(LMag.split(','))[1:-1]+")"
    SQL+= " AND dmp.dokument_id IN ("+LDokMag[1:-1]+")"
    SQL+= " AND dm.stan IN ('W','G') AND dmp.data >='"+DataOd+"' AND dmp.data <='"+DataDo+"' AND ("
    for kat in LKatArt:
        SQL+="a.kateg_artykulu LIKE '"+kat+"%' OR "
    SQL=SQL[:-4]+") GROUP BY a.artykul_id"
    stat,DWZ,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        for w in DWZ:
            if w[0] in SArt:
                SArt[w[0]][4] = w[1]
                SArt[w[0]][5] += - w[1]

# przygotowanie listy pozycji ze sownika
if stat =='OK':
    dane=[]
    KlSlow=SArt.keys()
    KlSlow.sort()
    for art in KlSlow:
        poz=SArt[art]
        if poz[5] >= 0:
            Ilosc = 0.0 
        else:
            Ilosc = -1.0*poz[5] 
        # ostateczny wiersz - Symbol, Nazwa, Ilosc
        w=[art.strip(), poz[0].strip(), poz[1], poz[2], poz[3], poz[4], Ilosc]
        dane.append(w)