# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_raport_porownawczy_dddm.py
# Purpose:     podanie danych do raportu porwnawczego midzy DD i DM
# Author:      Micha Raburski
# Created:     2013/09/11
# RCS-ID:      $Id: fs_wydruki_raport_porownawczy_dddm.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


DataOd = klucze[0]
DataDo = klucze[1]
LMag = klucze[2]

stat = "OK"
dane = []

# sownik. klucz to artyku + dokument DD + dokument WZ + dokument ZW (jeli wystpuj)
# wynik to reszta pozycji, ktra potem trafia na wydruk
SDane={}

# sownik pomocniczy prawie jak SDane, tylko dokumenty WZ i ZW nie s w kluczu. Po obrbce WZ i ZW SDanePom przeksztacany jest na SDane
SDanePom={}

NrWZ="CASE WHEN wz.firma_id IS NULL THEN '' ELSE rsf_podaj_numer_dokumentu_na_wydruk(wz.firma_id,'[\"'||wz.magazyn_id||'\",\"'||wz.dokument_id||'\",\"'||wz.data||'\",\"'||wz.numer||'\"]', 'M') END"
NrZW="CASE WHEN zw.firma_id IS NULL THEN '' ELSE rsf_podaj_numer_dokumentu_na_wydruk(zw.firma_id,'[\"'||zw.magazyn_id||'\",\"'||zw.dokument_id||'\",\"'||zw.data||'\",\"'||zw.numer||'\"]', 'M') END"

# pobranie danych dla dowodw dostaw 
SQL="SELECT ddp.data,ddp.trasa,ddp.tryb_dostawy, ddp.numer,ddp.artykul_id,a.nazwa,a.jm1," # 0-6
SQL+="SUM(ddp.ilosc_dost1),SUM(ddp.ilosc_zwr1)" # 7-8
SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id,trasa,data,tryb_dostawy,numer) "
SQL+=" INNER JOIN rs_artykuly a ON (a.firma_id=ddp.firma_id AND a.artykul_id=ddp.artykul_id) "
SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+self.oddzial_id+"'"
SQL+=" AND ddp.data>='"+DataOd+"' AND ddp.data<='"+DataDo+"'"
SQL+=" GROUP BY ddp.data,ddp.trasa,ddp.tryb_dostawy, ddp.numer,ddp.artykul_id,a.nazwa,a.jm1;"
stat,DDowDostWZ,dump,dump=self.PolSQL.Execute(SQL,3)
if stat == 'OK':
    for poz in DDowDostWZ:
        DataDD=poz[0]
        TrasaDD=poz[1]
        TrybDD=poz[2]
        NrDD=poz[3]
        KluczDD=DataDD[2:4]+DataDD[5:7]+DataDD[8:10]+self.oddzial_id[-1:]+TrasaDD[-2:]+TrybDD[-1:]+str(NrDD)

        KluczSl=(poz[4],KluczDD)
        
        # nowy wiersz (nazwa art, jm, ilo dost, ilosc zwr,ilo WZ, ilo ZW, dokument WZ, dokument ZW)
        SDanePom[KluczSl] = [poz[5], poz[6], poz[7], poz[8], 0 ,0,'', '']

# pobranie danych dla dowodw dostaw poczonych z ich wystawionymi WZ lub ich korektami
SQL="SELECT dd.data,dd.trasa,dd.tryb_dostawy, dd.numer,wz.artykul_id,a.nazwa,a.jm1," # 0-6
SQL+=NrWZ+",CASE WHEN wz.ilosc1 IS NULL THEN 0 WHEN tdm.typ_dokumentu='W' THEN wz.ilosc1 ELSE -wz.ilosc1 END" # 7-8
SQL+=" FROM rs_dowody_dostaw dd "
SQL+=" LEFT OUTER JOIN rs_dokumenty_magazynowe wzn ON (wzn.firma_id=dd.firma_id AND wzn.magazyn_id=dd.wz_magazyn_id"
SQL+=" AND wzn.dokument_id=dd.wz_dokument_id AND wzn.data=dd.wz_data AND wzn.numer=dd.wz_numer AND wzn.stan IN ('Z','K'))"
SQL+=" LEFT OUTER JOIN rs_dokumenty_magazynowe_pozycje wz ON (wz.firma_id=wzn.firma_id AND wz.magazyn_id=wzn.magazyn_id"
SQL+=" AND wz.dokument_id=wzn.dokument_id AND wz.data=wzn.data AND wz.numer=wzn.numer)"
SQL+=" LEFT OUTER JOIN rs_typy_dokumentow_m tdm ON (tdm.firma_id=wz.firma_id AND tdm.dokument_id=wz.dokument_id)"
SQL+=" INNER JOIN rs_artykuly a ON (a.firma_id=wz.firma_id AND a.artykul_id=wz.artykul_id) "
SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' AND dd.data>='"+DataOd+"' AND dd.data<='"+DataDo+"';"
stat,DDowDostWZ,dump,dump=self.PolSQL.Execute(SQL,3)
if stat == 'OK':
    for poz in DDowDostWZ:
        DataDD=poz[0]
        TrasaDD=poz[1]
        TrybDD=poz[2]
        NrDD=poz[3]
        KluczDD=DataDD[2:4]+DataDD[5:7]+DataDD[8:10]+self.oddzial_id[-1:]+TrasaDD[-2:]+TrybDD[-1:]+str(NrDD)

        KluczSl=(poz[4],KluczDD)
        
        if KluczSl in SDanePom:
            # dodajemy iloci z WZ
            SDanePom[KluczSl][6]=poz[7]
            SDanePom[KluczSl][4]+=poz[8]
            
        else:
            # nowy wiersz (nazwa art, jm, ilo dost, ilosc zwr,ilo WZ, ilo ZW, dokument WZ, dokument ZW)
            SDanePom[KluczSl] = [poz[5], poz[6], 0, 0, poz[8],0,poz[7], '']
    
# pobranie danych dla dowodw dostaw poczonych z ich wystawionymi ZW lub ich korektami
SQL="SELECT dd.data,dd.trasa,dd.tryb_dostawy, dd.numer,zw.artykul_id,a.nazwa,a.jm1," # 0-6
SQL+=NrZW+",CASE WHEN zw.ilosc1 IS NULL THEN 0 WHEN tdm.typ_dokumentu='W' THEN -zw.ilosc1 ELSE zw.ilosc1 END" # 7-8
SQL+=" FROM rs_dowody_dostaw dd "
SQL+=" LEFT OUTER JOIN rs_dokumenty_magazynowe zwn ON (zwn.firma_id=dd.firma_id AND zwn.magazyn_id=dd.zw_magazyn_id"
SQL+=" AND zwn.dokument_id=dd.zw_dokument_id AND zwn.data=dd.zw_data AND zwn.numer=dd.zw_numer AND zwn.stan IN ('Z','K'))"
SQL+=" LEFT OUTER JOIN rs_dokumenty_magazynowe_pozycje zw ON (zw.firma_id=zwn.firma_id AND zw.magazyn_id=zwn.magazyn_id"
SQL+=" AND zw.dokument_id=zwn.dokument_id AND zw.data=zwn.data AND zw.numer=zwn.numer)"
SQL+=" LEFT OUTER JOIN rs_typy_dokumentow_m tdm ON (tdm.firma_id=zw.firma_id AND tdm.dokument_id=zw.dokument_id)"
SQL+=" INNER JOIN rs_artykuly a ON (a.firma_id=zw.firma_id AND a.artykul_id=zw.artykul_id) "
SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' AND dd.data>='"+DataOd+"' AND dd.data<='"+DataDo+"';"
stat,DDowDostZW,dump,dump=self.PolSQL.Execute(SQL,3)
if stat == 'OK':
    for poz in DDowDostZW:
        DataDD=poz[0]
        TrasaDD=poz[1]
        TrybDD=poz[2]
        NrDD=poz[3]
        KluczDD=DataDD[2:4]+DataDD[5:7]+DataDD[8:10]+self.oddzial_id[-1:]+TrasaDD[-2:]+TrybDD[-1:]+str(NrDD)

        KluczSl=(poz[4],KluczDD)
        
        if KluczSl in SDanePom:
            # dodajemy iloci z ZW
            SDanePom[KluczSl][7]=poz[7]
            SDanePom[KluczSl][5]+=poz[8]
        else:
            # nowy wiersz (nazwa art, jm, ilo dost, ilosc zwr,ilo WZ, ilo ZW, dokument WZ, dokument ZW)
            SDanePom[KluczSl] = [poz[5], poz[6], 0, 0, 0, poz[8],'' ,poz[7]]
    
# Przeksztacenie SDanePom W SDane
if stat=='OK':
    for klucz in SDanePom:
        poz=SDanePom[klucz]
        SDane[(klucz[0],klucz[1],poz[-2],poz[-1])]=poz[:-2]
    
# pobranie danych dla dokumentw magazynowych 
if stat == 'OK' and LMag<>'':
    LMag="('"+LMag.replace(",","','")+"')"
    SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(dmp.firma_id,'[\"'||dmp.magazyn_id||'\",\"'||dmp.dokument_id||'\",\"'||dmp.data||'\",\"'||dmp.numer||'\"]', 'M')," # 0
    SQL+=" COALESCE(dm.kor_dm_dokument_id,dm.dokument_id),a.artykul_id,a.nazwa,a.jm1,dmp.ilosc1" # 1-5
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp "
    SQL+=" INNER JOIN rs_dokumenty_magazynowe dm USING (firma_id,magazyn_id,dokument_id,data,numer)"
    SQL+=" LEFT OUTER JOIN rs_dowody_dostaw ddwz ON (ddwz.firma_id=dm.firma_id AND ddwz.wz_magazyn_id=dm.magazyn_id"
    SQL+=" AND ddwz.wz_dokument_id=dm.dokument_id AND ddwz.wz_data=dm.data AND ddwz.wz_numer=dm.numer)"
    SQL+=" LEFT OUTER JOIN rs_dowody_dostaw ddzw ON (ddzw.firma_id=dm.firma_id AND ddzw.zw_magazyn_id=dm.magazyn_id"
    SQL+=" AND ddzw.zw_dokument_id=dm.dokument_id AND ddzw.zw_data=dm.data AND ddzw.zw_numer=dm.numer)"
    SQL+=" INNER JOIN  rs_artykuly a ON (a.firma_id=dmp.firma_id AND a.artykul_id=dmp.artykul_id)"
    SQL+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id IN "+LMag
    SQL+=" AND dmp.data>='"+DataOd+"' AND dmp.data<='"+DataDo+"'"
    SQL+=" AND ddwz.firma_id IS NULL AND ddzw.firma_id IS NULL"
    SQL+=" AND dm.stan IN ('Z','K')"
    SQL+=" AND COALESCE(dm.kor_dm_dokument_id,dm.dokument_id) IN ('WZ','ZW');"
    stat,DDowDost,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat == 'OK':
        for poz in DDowDost:
            if poz[1] == 'WZ':
                # jeli dokument WZ
                KluczSl=(poz[2],'ZZZZZZ',poz[0],'')
                if KluczSl in SDane:    
                    SDane[KluczSl][4]+=poz[5]
                else:
                    # nowy wiersz (nazwa art, jm, ilo dost, ilosc zwr,ilo WZ, ilo ZW)
                    SDane[KluczSl] = [poz[3], poz[4],0, 0, poz[5], 0]
            else:
                # jeli dokument ZW
                KluczSl=(poz[2],'ZZZZZZ','',poz[0])
                if KluczSl in SDane:    
                    SDane[KluczSl][5]+=poz[5]
                else:
                    # nowy wiersz (nazwa art, jm, ilo dost, ilosc zwr,ilo WZ, ilo ZW)
                    SDane[KluczSl] = [poz[3], poz[4],0, 0, 0, poz[5]]
    
    
# przygotowanie listy pozycji ze sownika
if stat =='OK':
    dane=[]
    KlSlow=SDane.keys()
    KlSlow.sort()
    
    for klucz in KlSlow:
        poz=SDane[klucz]
        NrDD=klucz[1]
        if NrDD == 'ZZZZZZ':
            NrDD=''
        NrDD=rsglobal.UsunKropkaZero(NrDD)
        if rsglobal.RSRound(poz[2]-poz[4],2) <> 0 or rsglobal.RSRound(poz[3]-poz[5]) <>0:
            # ostateczny wiersz - Nr DD, Art, Nazwa, Jm, Il dost, Il zwr, Nr WZ, Nr ZW, Ilosc WZ, Ilosc ZW, Rozn WZ, Rozn ZW
            w=[NrDD, klucz[0].strip(), poz[0], poz[1], rsglobal.RSRound(poz[2],2), rsglobal.RSRound(poz[3],2),
               klucz[2], klucz[3], rsglobal.RSRound(poz[4],2), rsglobal.RSRound(poz[5],2), 
               rsglobal.RSRound(poz[2]-poz[4],2), rsglobal.RSRound(poz[3]-poz[5])]
           
            dane.append(w)