# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_faktura.py
# Purpose:     Pobranie danych do wydruku rejestru zakupu 
# Author:      Micha Raburski
# Created:     2007/01/23
# RCS-ID:      $Id: fs_wydruki_faktura.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze= DataOd,DataDo,Rejestr
#2009.01.25 Micha Raburski - dodanie drugiego formatu wydruku  (1659)
# dodanie coalesce do query w danych kontrahenta (jeden null powodowal zwrot None ) Dariusz Boduch 2009-02-19 mantis: 1789
# 2010.11.18 - cakowita przerbka formatu pobieranych danych
# 2019.06.25 - Mikoaj Kozowski - Dodanie obsugi kontrolek dat rejestru od i do (11379)

DataOd = klucze[0]
DataDo = klucze[1]
DataRejestruOd = klucze[2]
DataRejestruDo = klucze[3]
DataWplywuOd= klucze[4]
DataWplywuDo= klucze[5]
Rejestry = klucze[6]
StanDowodu = klucze[7]
DniPrzeterminowania = klucze[8].strip()
NaDzien = klucze[9]

stat = "OK"
dane = []
wyn2 = []

#MK Dodanie daty rejestru do sprawdzania uzupenienia przynajmniej jednej daty 2019-06-25 mantis: 11379
#sprawdzenie poprawnosci kluczy
if DataOd=='    -  -  ' and DataWplywuOd=='    -  -  ' and NaDzien=='    -  -  ' and DataRejestruOd=='    -  -  ':
    stat='Brak daty od lub daty wpywu od lub daty przeterminowania lub daty rejestru od'
    dane.append(stat)  
    
if stat=='OK':
    if NaDzien<>'    -  -  ':
        if not rsglobal.SprawdzCzyToData(NaDzien):
            stat='Bdna data przeterminowania'
            dane.append(stat)
        elif DniPrzeterminowania=='':
            stat='Nie podano dni przeterminowania przy podanej dacie przeterminowania'
            dane.append(stat)
        else:
            try:
                Buf=int(DniPrzeterminowania)
            except:
                stat='Podano dni przeterminowania nie bdce liczb'
                dane.append(stat)

if stat=='OK':
    if DniPrzeterminowania<>'' and NaDzien=='    -  -  ':
        stat='Nie podano daty przeterminowania przy podanych dniach przeterminowania'
        dane.append(stat)
    
if stat=='OK':
    if DataOd<>'    -  -  ':
        if DataDo=='   -  -  ':
            stat='Data do nie jest wypeniona przy wypenionej dacie od'
            dane.append(stat)  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat='Bdna data od'
                dane.append(stat)                  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat='Bdna data do'
                dane.append(stat)
        if stat=='OK':
            if DataDo<DataOd:
                stat='Niepoprawny zakres dat'
                dane.append(stat)                    

if stat=='OK':
    if DataWplywuOd<>'    -  -  ':
        if DataWplywuDo=='   -  -  ':
            stat='Data wpywu do nie jest wypeniona przy wypenionej dacie wpywu od'
            dane.append(stat)  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataWplywuOd):
                stat='Bdna data wpywu od'
                dane.append(stat)                  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataWplywuDo):
                stat='Bdna data wpywu do'
                dane.append(stat)                  
        if stat=='OK':
            if DataWplywuDo<DataWplywuOd:
                stat='Niepoprawny zakres dat wpywu'
                dane.append(stat)
#MK Dodanie sprawdze daty rejestru 2019-06-25 mantis: 11379 - poczatek

if stat == 'OK':
    if DataRejestruOd <> '    -  -  ':
        if DataRejestruDo == '   -  -  ':
            stat = 'Data rejestru do nie jest wypeniona przy wypenionej dacie rejestru od'
            dane.append(stat)
        if stat == 'OK':
            if not rsglobal.SprawdzCzyToData(DataRejestruOd):
                stat = 'Bdna data rejestru od'
                dane.append(stat)
        if stat == 'OK':
            if not rsglobal.SprawdzCzyToData(DataRejestruDo):
                stat = 'Bdna data rejestru do'
                dane.append(stat)
        if stat == 'OK':
            if DataRejestruDo < DataRejestruOd:
                stat = 'Niepoprawny zakres dat rejestru'
                dane.append(stat)
#MK Dodanie sprawdze daty rejestru 2019-06-25 mantis: 11379 - koniec

#--- sprawdzenie czy jest pomijanie nazwy w okresach miesicach
if stat=='OK':
    Rok=DataOd[:4]
    Mc=DataOd[5:7]
    OrderByNazwa=",dk.nazwa_id"
    
    sql="SELECT numerowanie_pomijac_nazwe FROM rs_definicje_okresow_miesiace WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND okres_id='"+self.okres_id+"' AND rok='"+Rok+"' AND miesiac='"+Mc+"';"
    stat,TestNr,dump,dump = self.PolSQL.Execute(sql,3)    
    if stat<>'OK':
        stat='Bd pobierania danych o numeracji :'+stat
        dane.append(stat)
        
if stat=='OK':
    if len(TestNr)>0:
        if TestNr[0][0]:    
            OrderByNazwa=""

    #przerobienie rejestrw
    Rejestry=Rejestry.replace(',',"','")
    
#-------------------------------------------------------------------------------
#-- POBRANIE LISTY DOWODW SPENIAJCYCH KRYTERIA PRZETERMINOWANIA
#-------------------------------------------------------------------------------

FiltrDowodow=''
if stat=='OK' and NaDzien<>'    -  -  ':
    # pobranie okresu na dzie w celu zmniejszenia liczby przegldanych rozrachunkw
    SQL="SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+NaDzien+"');"
    stat,DaneOkr,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych okresu :'+stat
        dane.append(stat)
    
    if stat=='OK':
        if len(DaneOkr)==0:
            stat='Brak danych okresu dla daty '+NaDzien
            dane.append(stat)
            
    if stat=='OK':
        if DaneOkr[0][0]=='Brak':
            stat='Brak danych okresu dla daty '+NaDzien
            dane.append(stat)
    
    if stat=='OK':
        OkrRozrach=rsglobal.Dekoduj(DaneOkr[0][0])
        
        SQL="SELECT DISTINCT COALESCE(r.pdk_okres_id,r.okres_id),COALESCE(r.pdk_dowod_id,r.dowod_id),"
        SQL+=" COALESCE(r.pdk_nazwa_id,r.nazwa_id),COALESCE(r.pdk_data,r.data),COALESCE(r.pdk_numer,r.numer)" #,"
        SQL+=" FROM rs_rozrachunki r"
        SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dkp ON dkp.firma_id='"+self.firma_id+"'"
        SQL+=" AND dkp.okres_id=COALESCE(r.pdk_okres_id,r.okres_id) AND dkp.dowod_id=COALESCE(r.pdk_dowod_id,r.dowod_id)"
        SQL+=" AND dkp.nazwa_id=COALESCE(r.pdk_nazwa_id,r.nazwa_id) AND dkp.data=COALESCE(r.pdk_data,r.data)"
        SQL+=" AND dkp.numer=COALESCE(r.pdk_numer,r.numer) AND dkp.nr_poz=COALESCE(r.pdk_nr_poz,r.nr_poz)"
        SQL+=" AND dkp.nr_ppoz=COALESCE(r.pdk_nr_ppoz,r.nr_ppoz)"
        SQL+=" WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id='"+OkrRozrach+"' AND NOT r.termin_plat IS NULL"
        SQL+=" AND r.termin_plat+"+DniPrzeterminowania+"<'"+NaDzien+"'"
        SQL+=" AND (r.data_rozlicz IS NULL OR r.data_rozlicz>'"+NaDzien+"') "
        SQL+=" AND dkp.pobierac_na_rejestr AND dkp.konto_ma=r.konto"
        SQL+=" AND NOT COALESCE(r.pdk_dowod_id,r.dowod_id) IN ('BO','BK') ORDER BY COALESCE(r.pdk_data,r.data)"
        stat,DaneDK,dump,dump = self.PolSQL.Execute(SQL,3)

        if stat<>'OK':
            stat='Bd pobierania danych rozrachunkw :'+stat
            dane.append(stat)

    if stat=='OK':
        if len(DaneDK)==0:
            stat='Brak dowodw przeterminowanych o podanych parametrach przeterminowania'
    
    # zoenie filtra na list dowodw    
    if stat=='OK':
        FiltrDowodow=" AND ("
        Or=''
        DataOdAkt=DaneDK[0][3]
        DataDoAkt=DaneDK[-1][3]
        for poz in DaneDK:
            FiltrDowodow+=Or+"(dk.okres_id='"+rsglobal.Dekoduj(poz[0])+"' AND dk.dowod_id='"+rsglobal.Dekoduj(poz[1])+"'"
            FiltrDowodow+=" AND dk.nazwa_id='"+rsglobal.Dekoduj(poz[2])+"' AND dk.data='"+rsglobal.Dekoduj(poz[3])+"'"
            FiltrDowodow+=" AND dk.numer="+str(poz[4])+")" 
            Or=' OR '
        FiltrDowodow+=")"
                
#-------------------------------------------------------------------------------
#-- POBRANIE WACIWYCH DANYCH
#-------------------------------------------------------------------------------
#MK Rozdzielenie dat ksigowania i rejestru od siebie 2019-06-19 mantis: 11379
if stat=='OK':
    # pobranie stawek vat, ktre wystpi na wydruku
    SQL= " SELECT DISTINCT dkp.stawka_vat_wn FROM rs_dowody_ksiegowe dk "
    SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
    SQL+=" WHERE dk.firma_id='"+self.firma_id+"'"
    if DataOd <> '    -  -  ':
        SQL+=" AND dk.data >= '"+DataOd+"' "
        SQL+=" AND dk.data <= '"+DataDo+"' "
    if DataRejestruOd <> '    -  -  ':
        SQL+=" AND dk.data_rejestru >= '"+DataRejestruOd+"' "
        SQL+=" AND dk.data_rejestru <= '"+DataRejestruDo+"' "
    if DataWplywuOd <> '    -  -  ':
        SQL+=" AND dk.data_wplywu >= '"+DataWplywuOd+"' "
        SQL+=" AND dk.data_wplywu <= '"+DataWplywuDo+"' "
    if Rejestry<>'':
        SQL+=" AND dk.rejestr IN ('"+Rejestry+"') "
    else:
        SQL+=" AND COALESCE(dk.rejestr,'')<>'' "
    SQL+=" AND NOT dkp.zamkniecie_kregu AND dkp.pobierac_na_rejestr AND NOT dkp.stawka_vat_wn IS NULL"
    if StanDowodu<>'':
        SQL+=" AND dk.stan='"+str(StanDowodu)+"'"
    SQL+=FiltrDowodow+";"

    stat,DaneST,dump,dump = self.PolSQL.Execute(SQL,3)                
if stat=='OK':
    LStawek=[]
    for st in DaneST:
        if st[0] in self.ListaStawekZn:
            LStawek.append((1,st[0])) 
        else:
            LStawek.append((2,st[0])) 
    LStawek.sort()
    LStawek.reverse()
    if FiltrDowodow=='':
        if DataOd<>'    -  -  ':
            DataOdAkt=DataOd
            DataDoAkt=DataDo
        elif DataRejestruOd<>'    -  -  ':
            DataOdAkt=DataRejestruOd
            DataDoAkt=DataRejestruDo
        else:
            DataOdAkt=DataWplywuOd
            DataDoAkt=DataWplywuDo
            
    FWZakresie=" AND dk.data_wplywu >='"+DataOdAkt+"' AND dk.data_wplywu<='"+DataDoAkt+"'"
    FSpozaZakr=" AND (dk.data_wplywu <'"+DataOdAkt+"' OR dk.data_wplywu >'"+DataDoAkt+"')"

    SQL="SELECT dk.data,dk.symbol_dok,COALESCE(dk.data_wyst::TEXT,''),COALESCE(k.kontrahent_id,''),COALESCE(k.nip,dkk.nip,'')," #0-4
    SQL+="CASE WHEN NOT k.kontrahent_id IS NULL THEN TRIM(COALESCE(k.nazwa,''))||'@#@ '||COALESCE(k.adr_kod,'')||' '||TRIM(COALESCE(k.adr_miej,''))||', '||TRIM(COALESCE(k.adr_ulica,''))||' '||TRIM(COALESCE(k.adr_nry,''))" # 5
    SQL+="ELSE TRIM(COALESCE(dkk.nazwa,''))||'@#@ '||COALESCE(dkk.adr_kod,'')||' '||TRIM(COALESCE(dkk.adr_miej,''))||', '||TRIM(COALESCE(dkk.adr_ulica,''))||' '||TRIM(COALESCE(dkk.adr_nry,'')) END," # 5 cd
    SQL+="TRIM(dk.dowod_id)||'/'||TRIM(dk.nazwa_id)||'/'||dk.data||'/'||dk.numer,dk.data_wplywu,dk.data_rejestru," # 6-8
    
    # kwota brutto 9
    SQL+=" SUM(COALESCE(dkp.kwota_ma,0)+COALESCE(dkp.kwota_vat_ma,0)),"
    # kolumy pobierane w podziale na typy rozliczenia VAT (10-13)
    SQL+="SUM(CASE WHEN dkp.sposob_rozl IN ('B','D','M') THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl IN ('W','Z') THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='N' THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='P' THEN dkp.kwota_vat_wn ELSE 0 END),"
    
    # ptla pobierajca kolejne stawki VAT (14+)
    for stawka in LStawek:
        SQL+="SUM(CASE WHEN dkp.stawka_vat_wn='"+rsglobal.Dekoduj(stawka[1])+"' THEN dkp.kwota_wn ELSE 0 END),"
        SQL+="SUM(CASE WHEN dkp.stawka_vat_wn='"+rsglobal.Dekoduj(stawka[1])+"' THEN dkp.kwota_vat_wn ELSE 0 END),"
             
    #sumy do tabelki (podzia na z okresem i bez) +Przesunicie 14-39
    SQL+="SUM(CASE WHEN dkp.stawka_vat_wn IN ("+str(self.ListaStawekZn)[1:-1]+") "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.stawka_vat_wn IN ("+str(self.ListaStawekZn)[1:-1]+") "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.stawka_vat_wn = '00' "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.stawka_vat_wn = '00' "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.stawka_vat_wn = 'zw' "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.stawka_vat_wn = 'zw' "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl IN ('B','D','M') "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl IN ('B','D','M') "+FWZakresie+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl IN ('B','D','M') "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl IN ('B','D','M') "+FSpozaZakr+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='W' "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='W' "+FWZakresie+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='W' "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='W' "+FSpozaZakr+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='N' "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='N' "+FWZakresie+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='N' "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='N' "+FSpozaZakr+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='P' "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='P' "+FWZakresie+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='P' "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='P' "+FSpozaZakr+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='Z' "+FWZakresie+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='Z' "+FWZakresie+" THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='Z' "+FSpozaZakr+" THEN dkp.kwota_wn ELSE 0 END),"
    SQL+="SUM(CASE WHEN dkp.sposob_rozl ='Z' "+FSpozaZakr+" THEN dkp.kwota_vat_wn ELSE 0 END)"

    # tabele i filtry wydruku
    SQL+=" FROM rs_dowody_ksiegowe dk INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
    SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (dk.firma_id=k.firma_id AND dk.kontrahent_id=k.kontrahent_id)"
    SQL+=" LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk "
    SQL+="ON (dk.firma_id=dkk.firma_id AND dk.dowod_id=dkk.dowod_id AND dk.nazwa_id=dkk.nazwa_id AND dk.data=dkk.data AND dk.numer=dkk.numer) "
    SQL+=" INNER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod) "

#MK Rozdzielenie dat ksigowania i rejestru od siebie 2019-06-19 mantis: 11379
    SQL+=" WHERE dk.firma_id='"+self.firma_id+"'"
    if DataOd <> '    -  -  ':
        SQL += " AND dk.data >= '" + DataOd + "' "
        SQL += " AND dk.data <= '" + DataDo + "' "
    if DataRejestruOd <> '    -  -  ':
        SQL += " AND dk.data_rejestru >= '" + DataRejestruOd + "' "
        SQL += " AND dk.data_rejestru <= '" + DataRejestruDo + "' "
    if DataWplywuOd <> '    -  -  ':
        SQL+=" AND dk.data_wplywu >= '"+DataWplywuOd+"' "
        SQL+=" AND dk.data_wplywu <= '"+DataWplywuDo+"' "
    if Rejestry<>'':
        SQL+=" AND dk.rejestr IN ('"+Rejestry+"') "
    else:
        SQL+=" AND COALESCE(dk.rejestr,'')<>'' "
    SQL+=" AND NOT dkp.zamkniecie_kregu AND dkp.pobierac_na_rejestr AND rv.typ='Z' "
    if StanDowodu<>'':
        SQL+=" AND dk.stan='"+str(StanDowodu)+"' "
    SQL+=FiltrDowodow
    SQL+=" GROUP BY dk.data_wplywu,dk.symbol_dok,dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.rejestr,dk.kwota_wn,"
    SQL+="k.kontrahent_id,k.nazwa,k.nip,k.adr_kod,k.adr_miej,k.adr_ulica,k.adr_nry,"
    SQL+="dkk.nazwa,dkk.nip,dkk.adr_kod,dkk.adr_miej,dkk.adr_ulica,dkk.adr_nry,dk.data_wyst,dk.data_rejestru"
    SQL+=" ORDER BY dk.data,dk.dowod_id"+OrderByNazwa+",dk.numer;"
    rsglobal.ZapiszDoLogow(SQL,5)
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)   
    wyn2= LStawek