# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_rejestr_zakupu_sumy.py
# Purpose:     pobranie danych do wydruku rejestru sum
# Author:      Dariusz Boduch, Micha Raburski
# Created:     2009/01/23
# RCS-ID:      $Id: fs_wydruki_rejestr_zakupu_sumy.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2010.11.29 - cakowita przerbka formatu pobieranych danych
# 2019.06.19 - Mikoaj Kozowski - Dodanie obsugi kontrolek dat rejestru od i do (11379)
#klucze= DataOd,DataDo,DataRejestruOd,DataRejestruDo,DataWplywuOd,DataWplywuDo,StanDowodu,Rejestr

DataOd = klucze[0]
DataDo = klucze[1]
DataRejestruOd = klucze[2]
DataRejestruDo = klucze[3]
DataWplywuOd= klucze[4]
DataWplywuDo= klucze[5]
StanDowodu = klucze[6]
Rejestr = klucze[7]
DniPrzeterminowania = klucze[8].strip()
NaDzien = klucze[9]

stat = "OK"
dane = []
LStawek=[]
#MK Dodanie daty rejestru do sprawdzania uzupenienia przynajmniej jednej daty 2019-06-19 mantis: 11379
#sprawdzenie poprawnosci kluczy
if DataOd=='    -  -  ' and DataWplywuOd=='    -  -  ' and NaDzien=='    -  -  ' and DataRejestruOd=='    -  -  ':
    stat='Brak daty ksigowania od lub daty wpywu od lub daty rejestru od lub przeterminowania'
    dane.append(stat)  

if stat=='OK':
    if NaDzien<>'    -  -  ':
        if not rsglobal.SprawdzCzyToData(NaDzien):
            stat='Bdna data przeterminowania'
            dane.append(stat)
        elif DniPrzeterminowania=='':
            stat='Nie podano dni przeterminowania przy podanej dacie przeterminowania'
            dane.append(stat)
        else:
            try:
                Buf=int(DniPrzeterminowania)
            except:
                stat='Podano dni przeterminowania nie bdce liczb'
                dane.append(stat)

if stat=='OK':
    if DniPrzeterminowania<>'' and NaDzien=='    -  -  ':
        stat='Nie podano daty przeterminowania przy podanych dniach przeterminowania'
        dane.append(stat)

if stat=='OK':
    if DataOd<>'    -  -  ':
        if DataDo=='   -  -  ':
            stat='Data do nie jest wypeniona przy wypenionej dacie od'
            dane.append(stat)  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataOd):
                stat='Bdna data od'
                dane.append(stat)                  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataDo):
                stat='Bdna data do'
                dane.append(stat)
        if stat=='OK':
            if DataDo<DataOd:
                stat='Niepoprawny zakres dat'
                dane.append(stat)                    
#MK Dodanie sprawdze daty rejestru 2019-06-19 mantis: 11379 - poczatek
if stat=='OK':
    if DataRejestruOd<>'    -  -  ':
        if DataRejestruDo=='   -  -  ':
            stat='Data rejestru do nie jest wypeniona przy wypenionej dacie od'
            dane.append(stat)
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataRejestruOd):
                stat='Bdna data rejestru od'
                dane.append(stat)
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataRejestruDo):
                stat='Bdna data rejestru do'
                dane.append(stat)
        if stat=='OK':
            if DataRejestruDo<DataRejestruOd:
                stat='Niepoprawny zakres dat rejestru'
                dane.append(stat)
#MK Dodanie sprawdze daty rejestru 2019-06-19 mantis: 11379 - koniec

if stat=='OK':
    if DataWplywuOd<>'    -  -  ':
        if DataWplywuDo=='   -  -  ':
            stat='Data wpywu do nie jest wypeniona przy wypenionej dacie wpywu od'
            dane.append(stat)  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataWplywuOd):
                stat='Bdna data wpywu od'
                dane.append(stat)                  
        if stat=='OK':
            if not rsglobal.SprawdzCzyToData(DataWplywuDo):
                stat='Bdna data wpywu do'
                dane.append(stat)                  
        if stat=='OK':
            if DataWplywuDo<DataWplywuOd:
                stat='Niepoprawny zakres dat wpywu'
                dane.append(stat)                

#-------------------------------------------------------------------------------
#-- POBRANIE LISTY DOWODW SPENIAJCYCH KRYTERIA PRZETERMINOWANIA
#-------------------------------------------------------------------------------

FiltrDowodow=''
if stat=='OK' and NaDzien<>'    -  -  ':
    # pobranie okresu na dzie w celu zmniejszenia liczby przegldanych rozrachunkw
    SQL="SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+NaDzien+"');"
    stat,DaneOkr,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych okresu :'+stat
        dane.append(stat)
    
    if stat=='OK':
        if len(DaneOkr)==0:
            stat='Brak danych okresu dla daty '+NaDzien
            dane.append(stat)
            
    if stat=='OK':
        if DaneOkr[0][0]=='Brak':
            stat='Brak danych okresu dla daty '+NaDzien
            dane.append(stat)
    
    if stat=='OK':
        OkrRozrach=rsglobal.Dekoduj(DaneOkr[0][0])
        
        SQL="SELECT DISTINCT COALESCE(r.pdk_okres_id,r.okres_id),COALESCE(r.pdk_dowod_id,r.dowod_id),"
        SQL+=" COALESCE(r.pdk_nazwa_id,r.nazwa_id),COALESCE(r.pdk_data,r.data),COALESCE(r.pdk_numer,r.numer)" #,"
        SQL+=" FROM rs_rozrachunki r"
        SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dkp ON dkp.firma_id='"+self.firma_id+"'"
        SQL+=" AND dkp.okres_id=COALESCE(r.pdk_okres_id,r.okres_id) AND dkp.dowod_id=COALESCE(r.pdk_dowod_id,r.dowod_id)"
        SQL+=" AND dkp.nazwa_id=COALESCE(r.pdk_nazwa_id,r.nazwa_id) AND dkp.data=COALESCE(r.pdk_data,r.data)"
        SQL+=" AND dkp.numer=COALESCE(r.pdk_numer,r.numer) AND dkp.nr_poz=COALESCE(r.pdk_nr_poz,r.nr_poz)"
        SQL+=" AND dkp.nr_ppoz=COALESCE(r.pdk_nr_ppoz,r.nr_ppoz)"
        SQL+=" WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id='"+OkrRozrach+"' AND NOT r.termin_plat IS NULL"
        SQL+=" AND r.termin_plat+"+DniPrzeterminowania+"<'"+NaDzien+"'"
        SQL+=" AND (r.data_rozlicz IS NULL OR r.data_rozlicz>'"+NaDzien+"') "
        SQL+=" AND dkp.pobierac_na_rejestr AND dkp.konto_ma=r.konto"
        SQL+=" AND NOT COALESCE(r.pdk_dowod_id,r.dowod_id) IN ('BO','BK') ORDER BY COALESCE(r.pdk_data,r.data)"
        stat,DaneDK,dump,dump = self.PolSQL.Execute(SQL,3)

        if stat<>'OK':
            stat='Bd pobierania danych rozrachunkw :'+stat
            dane.append(stat)

    if stat=='OK':
        if len(DaneDK)==0:
            stat='Brak dowodw przeterminowanych o podanych parametrach przeterminowania'
    
    # zoenie filtra na list dowodw    
    if stat=='OK':
        FiltrDowodow=" AND ("
        Or=''
        DataOdAkt=DaneDK[0][3]
        DataDoAkt=DaneDK[-1][3]
        for poz in DaneDK:
            FiltrDowodow+=Or+"(dk.okres_id='"+rsglobal.Dekoduj(poz[0])+"' AND dk.dowod_id='"+rsglobal.Dekoduj(poz[1])+"'"
            FiltrDowodow+=" AND dk.nazwa_id='"+rsglobal.Dekoduj(poz[2])+"' AND dk.data='"+rsglobal.Dekoduj(poz[3])+"'"
            FiltrDowodow+=" AND dk.numer="+str(poz[4])+")" 
            Or=' OR '
        FiltrDowodow+=")"

#-------------------------------------------------------------------------------
#-- POBRANIE WACIWYCH DANYCH
#-------------------------------------------------------------------------------
    #MKRozdzielenie dat ksigowania i rejestru od siebie 2019-06-19 mantis: 11379

if stat=='OK':
    # pobranie stawek vat, ktre wystpi na wydruku
    SQL= " SELECT DISTINCT dkp.stawka_vat_wn FROM rs_dowody_ksiegowe dk "
    SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer)"
    SQL+=" INNER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod)"
    SQL+=" WHERE dk.firma_id='"+self.firma_id+"' "
    if DataOd <> '    -  -  ':
        SQL+=" AND dk.data >= '"+DataOd+"' "
        SQL+=" AND dk.data <= '"+DataDo+"' "
    if DataRejestruOd <> '    -  -  ':
        SQL+=" AND dk.data_rejestru >= '"+DataRejestruOd+"' "
        SQL+=" AND dk.data_rejestru <= '"+DataRejestruDo+"' "
    if DataWplywuOd <> '    -  -  ':
        SQL+=" AND dk.data_wplywu >= '"+DataWplywuOd+"' "
        SQL+=" AND dk.data_wplywu <= '"+DataWplywuDo+"' "
    if StanDowodu<>'':
        SQL+=" AND dk.stan='"+str(StanDowodu)+"' "
    if Rejestr <>'':
        SQL+=" AND dk.rejestr IN ("
        LRej=Rejestr.split(',')
        for rej in LRej:
            SQL+="'"+rsglobal.Dekoduj(rej)+"',"
        SQL=SQL.rstrip(',')
        SQL+=") "
    SQL+=" AND NOT dkp.stawka_vat_wn IS NULL AND NOT dk.rejestr IS NULL "
    SQL+="AND NOT dkp.zamkniecie_kregu AND dkp.pobierac_na_rejestr AND rv.typ='Z'"
    SQL+=FiltrDowodow
    
    stat,DaneST,dump,dump = self.PolSQL.Execute(SQL,3)                
    
    if stat=='OK':
        LStawek=[]
        for st in DaneST:
            if st[0] in self.ListaStawekZn:
                LStawek.append((1,st[0])) 
            else:
                LStawek.append((2,st[0])) 
            
        LStawek.sort()
        LStawek.reverse()

    
if stat=='OK':    
    SQL="SELECT dk.rejestr, rv.opis,"
    # ptla pobierajca kolejne stawki VAT (2+)
    for stawka in LStawek:
        SQL+="SUM(CASE WHEN dkp.stawka_vat_wn='"+rsglobal.Dekoduj(stawka[1])+"' THEN dkp.kwota_wn ELSE 0 END),"
        SQL+="SUM(CASE WHEN dkp.stawka_vat_wn='"+rsglobal.Dekoduj(stawka[1])+"' THEN dkp.kwota_vat_wn ELSE 0 END),"
    SQL=SQL.strip(',')
    SQL+=" FROM rs_dowody_ksiegowe dk "
    SQL+="INNER JOIN rs_dowody_ksiegowe_pozycje dkp "
    SQL+="USING (firma_id,okres_id,dowod_id,nazwa_id,data,numer) "
    SQL+="LEFT OUTER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod) "
    SQL+="WHERE dk.firma_id='"+self.firma_id+"' "
    #MK Rozdzielenie dat ksigowania i rejestru od siebie 2019-06-19 mantis: 11379
    if DataOd <> '    -  -  ':
        SQL+=" AND dk.data >= '"+DataOd+"' "
        SQL+=" AND dk.data <= '"+DataDo+"' "
    if DataRejestruOd <> '    -  -  ':
        SQL+=" AND dk.data_rejestru >= '"+DataRejestruOd+"' "
        SQL+=" AND dk.data_rejestru <= '"+DataRejestruDo+"' "
    if DataWplywuOd <> '    -  -  ':
        SQL+=" AND dk.data_wplywu >= '"+DataWplywuOd+"' "
        SQL+=" AND dk.data_wplywu <= '"+DataWplywuDo+"' "
    if Rejestr <>'':
        SQL+=" AND dk.rejestr IN ("
        LRej=Rejestr.split(',')
        for rej in LRej:
            SQL+="'"+rsglobal.Dekoduj(rej)+"',"
        SQL=SQL.rstrip(',')
        SQL+=") "
    if StanDowodu<>'':
        SQL+="AND dk.stan='"+str(StanDowodu)+"' "
    SQL+=FiltrDowodow
    SQL+=" AND NOT dkp.stawka_vat_wn IS NULL AND NOT dk.rejestr IS NULL "
    SQL+=" AND NOT dkp.zamkniecie_kregu AND dkp.pobierac_na_rejestr AND rv.typ='Z'"
    SQL+=" GROUP BY dk.rejestr, rv.opis ORDER BY dk.rejestr "

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat= u'Bd pobierania danych rejestrw'
        dane.append(stat)
        
    wyn2= LStawek

# pobranie danych do tabelki z kwotami rozbiciem na sposoby rozliczenia VAT
#MK Rozdzielenie dat ksigowania i rejestru od siebie 2019-06-19 mantis: 11379
if stat=='OK':
    SQL="SELECT srv.kod, srv.opis, sum(dkp.kwota_wn), sum(dkp.kwota_vat_wn) "
    SQL+="FROM rs_dowody_ksiegowe dk "
    SQL+="INNER JOIN rs_dowody_ksiegowe_pozycje dkp "
    SQL+="ON (dk.firma_id=dkp.firma_id AND dk.okres_id=dkp.okres_id AND dk.dowod_id=dkp.dowod_id "
    SQL+="AND dk.nazwa_id=dkp.nazwa_id AND dk.data=dkp.data AND dk.numer=dkp.numer) "
    SQL+="LEFT OUTER JOIN rs_sposob_rozl_vat srv ON (dkp.sposob_rozl=srv.kod) "
    SQL+="INNER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod) "
    SQL+="WHERE dk.firma_id='"+self.firma_id+"' "
    if StanDowodu<>'':
        SQL+="AND dk.stan='"+str(StanDowodu)+"' "
    if DataOd <> '    -  -  ':
        SQL+=" AND dk.data >= '"+DataOd+"' "
        SQL+=" AND dk.data <= '"+DataDo+"' "
    if DataRejestruOd <> '    -  -  ':
        SQL+=" AND dk.data_rejestru >= '"+DataRejestruOd+"' "
        SQL+=" AND dk.data_rejestru <= '"+DataRejestruDo+"' "
    if DataWplywuOd <> '    -  -  ':
        SQL+=" AND dk.data_wplywu >= '"+DataWplywuOd+"' "
        SQL+=" AND dk.data_wplywu <= '"+DataWplywuDo+"' "
    if Rejestr <>'':
        SQL+=" AND dk.rejestr IN ("
        LRej=Rejestr.split(',')
        for rej in LRej:
            SQL+="'"+rsglobal.Dekoduj(rej)+"',"
        SQL=SQL.rstrip(',')
        SQL+=") "
    SQL+=" AND NOT dkp.stawka_vat_wn IS NULL "
    SQL+=" AND NOT dk.rejestr IS NULL AND NOT dkp.zamkniecie_kregu AND dkp.pobierac_na_rejestr AND rv.typ='Z'"
    SQL+=FiltrDowodow
    SQL+=" GROUP BY srv.kod, srv.opis ORDER BY srv.kod "
    stat,wyn1,dump,dump = self.PolSQL.Execute(SQL,3)