# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_sprawdzenie_produkcji
# Purpose:     funkcja pobierajca dane do wydruku sprawdzenia produkcji w sumach produkcji
# Author:      Micha Raburski
# Created:     2015/01/30
# RCS-ID:      $Id: fs_wydruki_sprawdzenie_produkcji.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Oddzial':[1],'DataOd':[1],'DataDo':[1],'MagPW':[1],'KontrProd':[1],'KontrBraki':[1],'MagZW':[1],
           'MagRW':[1],'KontrRW':[1],'MagSkadPrz':[1],'MagDokadPrz':[1],'JM':[1]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_wydruki_sprawdzenie_produkcji z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun == 1:
        Oddzial=rsglobal.Dekoduj(klucze['Oddzial'])
        DataOd=rsglobal.Dekoduj(klucze['DataOd'])
        DataDo=rsglobal.Dekoduj(klucze['DataDo'])
        MagPW=rsglobal.Dekoduj(klucze['MagPW'])
        # zmiana rcznej listy na tak akceptowan przez zapytanie
        LKontrProd = rsglobal.Dekoduj(klucze['KontrProd']).split(',')
        KontrProd = ''
        for kontr in LKontrProd:
            KontrProd += "'"+kontr+"',"
        KontrProd = KontrProd.strip(',')
        
        KontrBraki=rsglobal.Dekoduj(klucze['KontrBraki'])
        MagZW=rsglobal.Dekoduj(klucze['MagZW'])
        MagRW=rsglobal.Dekoduj(klucze['MagRW'])
        KontrRW=rsglobal.Dekoduj(klucze['KontrRW'])
        MagSkadPrz=rsglobal.Dekoduj(klucze['MagSkadPrz'])
        MagDokadPrz=rsglobal.Dekoduj(klucze['MagDokadPrz'])
        JM=rsglobal.Dekoduj(klucze['JM'])

if Fun==1 and stat=='OK':
    SPoz ={} # kluczem jest artyku, a wynikiem lista kolejnych pl raportu
    Naglowek = ''
    KodJm = ''
    
    # pobranie produkcji z brakami
    SQL="SELECT om.artykul_id,a.nazwa, SUM(CASE WHEN om.dokument_id IN ('PM','PW') THEN om.ilosc"+JM+" ELSE 0 END) "
    SQL+=" - SUM(CASE WHEN om.dokument_id='RR' THEN om.ilosc"+JM+" ELSE 0 END)"
    SQL+=" FROM rs_obroty_magazynowe om INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+=" WHERE om.firma_id='"+self.firma_id+"' AND om.magazyn_id='"+MagPW+"'"
    SQL+=" AND om.data>='"+DataOd+"' AND om.data<='"+DataDo+"' AND om.kontrahent_id IN ("+KontrProd+",'"+KontrBraki+"')"
    SQL+=" AND om.dokument_id IN ('PM','PW','RR') GROUP BY om.artykul_id, a.nazwa;"
    stat,DProd,dump,dump= self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat=u'Bd pobierania danych dotyczcych produkcji z brakami :'+stat
    
    if stat == 'OK':
        for w in DProd:
            if w[2] > 0:
                SPoz[(w[0],w[1])] = [w[2],0,0,0,0,0,0,0,0]
    
        # pobranie pozostaoci
        SQL="SELECT om.artykul_id,a.nazwa, SUM(om.ilosc"+JM+") "
        SQL+=" FROM rs_obroty_magazynowe om INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" WHERE om.firma_id='"+self.firma_id+"' AND om.magazyn_id='"+MagRW+"'"
        SQL+=" AND om.data>='"+DataOd+"' AND om.data<='"+DataDo+"' AND om.kontrahent_id = '"+KontrRW+"'"
        SQL+=" AND om.dokument_id = 'RW' GROUP BY om.artykul_id, a.nazwa;"
        stat,DPozost,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat=u'Bd pobierania danych dotyczcych pozostaoci :'+stat
        
        if stat == 'OK':
            for w in DPozost:
                if (w[0],w[1]) in SPoz:
                    SPoz[(w[0],w[1])][1] = w[2]
    
    if stat == 'OK':
        # pobranie brakw
        SQL="SELECT om.artykul_id,a.nazwa, SUM(CASE WHEN om.dokument_id='PW' THEN om.ilosc"+JM+" ELSE 0 END) "
        SQL+=" - SUM(CASE WHEN om.dokument_id='RR' THEN om.ilosc"+JM+" ELSE 0 END)"
        SQL+=" FROM rs_obroty_magazynowe om INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" WHERE om.firma_id='"+self.firma_id+"' AND om.magazyn_id='"+MagPW+"'"
        SQL+=" AND om.data>='"+DataOd+"' AND om.data<='"+DataDo+"' AND om.kontrahent_id = '"+KontrBraki+"'"
        SQL+=" AND om.dokument_id IN ('PW','RR') GROUP BY om.artykul_id, a.nazwa;"
        stat,DBraki,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat=u'Bd pobierania danych dotyczcych brakw :'+stat
    
        if stat == 'OK':
            for w in DBraki:
                if (w[0],w[1]) in SPoz:
                    SPoz[(w[0],w[1])][2] = w[2]

    if stat == 'OK':
        # sprzeda dostarczona
        SQL="SELECT ddp.artykul_id,a.nazwa, SUM(ddp.ilosc_dost"+JM+") "
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"'"
        SQL+=" AND ddp.data>='"+DataOd+"' AND ddp.data<='"+DataDo+"' GROUP BY ddp.artykul_id, a.nazwa;"
        stat,DSpDost,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat=u'Bd pobierania danych dotyczcych sprzeday dostarczonej :'+stat
        
        if stat == 'OK':
            for w in DSpDost:
                if (w[0],w[1]) in SPoz:
                    SPoz[(w[0],w[1])][5] = w[2]
                    
    if stat == 'OK':
        # zwroty
        SQL="SELECT ddp.artykul_id,a.nazwa, SUM(ddp.ilosc_zwr"+JM+") "
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"'"
        SQL+=" AND ddp.data>='"+DataOd+"' AND ddp.data<='"+DataDo+"' GROUP BY ddp.artykul_id, a.nazwa;"
        stat,DSpZwr,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat=u'Bd pobierania danych dotyczcych zwrotw :'+stat
        
        if stat == 'OK':
            for w in DSpZwr:
                if (w[0],w[1]) in SPoz:
                    SPoz[(w[0],w[1])][6] = w[2]
                    
    if stat == 'OK':
        # przerzut midzy zakadami 
        SQL="SELECT om.artykul_id,a.nazwa, SUM(om.ilosc"+JM+") "
        SQL+=" FROM rs_obroty_magazynowe om INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" INNER JOIN rs_dokumenty_magazynowe dm ON (dm.firma_id= om.firma_id AND dm.magazyn_id = om.magazyn_id "
        SQL+=" AND dm.dokument_id = om.dokument_id AND dm.data = om.data AND dm.numer = om.numer)"
        SQL+=" WHERE om.firma_id='"+self.firma_id+"' AND dm.magazyn_skad='"+MagSkadPrz+"' AND dm.magazyn_dokad='"+MagDokadPrz+"'"
        SQL+=" AND om.data>='"+DataOd+"' AND om.data<='"+DataDo+"' GROUP BY om.artykul_id, a.nazwa;"
        stat,DPrzerz,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat=u'Bd pobierania danych dotyczcych przerzutw midzyzakadowych :'+stat
        
        if stat == 'OK':
            for w in DPrzerz:
                if (w[0],w[1]) in SPoz:
                    SPoz[(w[0],w[1])][8] = w[2]
    
    if stat == 'OK':
        KlSlow = SPoz.keys()
        KlSlow.sort()
        for kl in KlSlow:
            # % pozostaoci w stosunku do produkcji
            if SPoz[kl][0] > 0:
                SPoz[kl][3] = rsglobal.RSRound(SPoz[kl][1]/SPoz[kl][0]*100,0)
            elif SPoz[kl][1] > 0:
                SPoz[kl][3] = 100
    
            # % brakw w stosunku do produkcji
            if SPoz[kl][0] > 0:
                SPoz[kl][4] = rsglobal.RSRound(SPoz[kl][2]/SPoz[kl][0]*100,0)
            elif SPoz[kl][2] > 0:
                SPoz[kl][4] = 100
    
            # % zwrotw w stosunku do sprzeday
            if SPoz[kl][5] > 0:
                SPoz[kl][7] = rsglobal.RSRound(SPoz[kl][6]/SPoz[kl][5]*100,0)
            elif SPoz[kl][6] > 0:
                SPoz[kl][7] = 100
    
    if stat == 'OK':
        # zmiana sownika na list, ktra si znajdzie na wydruku
        LPoz = []
        for kl in KlSlow:
            LPoz.append([kl[0],kl[1]] + SPoz[kl])
    
        # pobranie nazwy oddziau
        SQL="SELECT nazwa FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
        stat,DOddz,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat=u'Bd pobierania danych oddziau :'+stat
    
    if stat == 'OK':
        # pobranie jednostki miar
        if len(LPoz) > 0:
            SQL="SELECT jm"+JM+" FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id='"+LPoz[0][0].split('-')[0].strip()+"'"
            stat,DArt,dump,dump= self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat=u'Bd pobierania danych artykuu :'+stat
            else:
                KodJm = DArt[0][0].strip()
            
    if stat == 'OK':
        Naglowek = DOddz[0][0].strip()+' - PRODUKCJA, BRAKI, POZOSTAOCI WYBRANEGO ASORYTMENTU W OKRESIE '+DataOd+' - '+DataDo
    
        dane=[LPoz,Naglowek,KodJm]