# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_sumy_dostaw_zwrotow_sklep
# Purpose:     Pobranie danych do zestawienia dostaw/zwrotw do sklepw firmowych
# Author:      Micha Raburski
# Created:     2011/09/14
# RCS-ID:      $Id: fs_wydruki_sumy_dostaw_zwrotow_sklep.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-02-21 Mariusz Rajfura  nowe zestawienie 'Sumy korekt dla sklepow firmowych' (5477)

#klucze= dataod,datado,czydostawy
DataOd=klucze[0]
DataDo=klucze[1]
Kontrahent=klucze[2]
Typ=klucze[3]

stat = "OK"
dane = []

if Typ in ('DOSTAW','KOREKT RCZNYCH DOSTAW'):
    Ilosc='ilosc_dost1'
else:
    Ilosc='ilosc_zwr1'

WersjaDet="rsf_podaj_pole_z_danych_do_fakturowania(k.firma_id,k.kontrahent_id,dp.data,'wersja_detaliczna')"
CenaDet=" CASE WHEN wc.czy_cena_brutto IS NULL OR wc.kod='' THEN 0 "
CenaDet+=" WHEN wc.czy_cena_brutto THEN rsf_podaj_cene_b1(dp.firma_id,dp.artykul_id,wc.kod,'PLN',dp.data)"
CenaDet+=" ELSE rsf_podaj_cene_dla_kontrahenta(dp.firma_id, '', 'PLN',dp.data::TEXT, dp.artykul_id,'b1',wc.kod, 0) END"
WspolStawki="100/(100+CASE WHEN dp.stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE dp.stawka_vat::INT END)"

# data, kontrahent, suma detaliczna
SQL= "SELECT dp.data,TRIM(k.kontrahent_id)||' - '||TRIM(k.nazwa),SUM(ROUND("+Ilosc+"*"+CenaDet+",2)),"
# suma detaliczna vat 5%
SQL+="SUM(CASE WHEN dp.stawka_vat='05' THEN ROUND("+Ilosc+"*"+CenaDet+",2) ELSE 0 END), "
# suma detaliczna vat 8%
SQL+="SUM(CASE WHEN dp.stawka_vat='08' THEN ROUND("+Ilosc+"*"+CenaDet+",2) ELSE 0 END), "
# suma detaliczna vat 23%
SQL+="SUM(CASE WHEN dp.stawka_vat='23' THEN ROUND("+Ilosc+"*"+CenaDet+",2) ELSE 0 END), "
# suma netto%
SQL+="SUM(ROUND("+Ilosc+"*dp.cena_upust1,2)), "
# VAT 5%
SQL+="SUM(CASE WHEN dp.stawka_vat='05' THEN ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2) ELSE 0 END),"
# VAT 8%
SQL+="SUM(CASE WHEN dp.stawka_vat='08' THEN ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2) ELSE 0 END),"
# VAT 23%
SQL+="SUM(CASE WHEN dp.stawka_vat='23' THEN ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2) ELSE 0 END),"
# VAT Razem oraz na razie puste sumy WZ i ZW na dzie
SQL+="SUM(ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2)),0,0"

SQL+=" FROM rs_dowody_dostaw_pozycje dp "
SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)"
SQL+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=dd.firma_id AND k.kontrahent_id=dd.kontrahent_id)"
SQL+=" LEFT OUTER JOIN rs_wersje_cenowe wc ON (wc.firma_id='"+self.firma_id+"' AND wc.kod="+WersjaDet+")"
SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.oddzial_id='"+self.oddzial_id+"'"
SQL+=" AND dp.data<='"+DataDo+"' AND dp.data>='"+DataOd+"'"
SQL+=" AND dd.kontrahent_id='"+Kontrahent+"'"

if Typ == 'KOREKT AUTOMATYCZNYCH':
    SQL+=" AND dd.korekta AND dd.czy_automatycznie"
if Typ in ('KOREKT RCZNYCH DOSTAW','KOREKT RCZNYCH ZWROTW'):
    SQL+=" AND dd.korekta AND NOT dd.czy_automatycznie"
    
SQL+=" GROUP BY k.kontrahent_id,k.nazwa,dp.data ORDER BY k.kontrahent_id,k.nazwa,dp.data"
stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
if stat=='OK':
    # zrobienie sum WZ i ZW
    SQL="SELECT dm.data,SUM(CASE WHEN COALESCE(dm.kor_dm_dokument_id,dm.dokument_id)='WZ' THEN "
    SQL+=" CASE WHEN td.typ_dokumentu='W' THEN dm.kwota ELSE -dm.kwota END ELSE 0 END),"
    SQL+="SUM(CASE WHEN COALESCE(dm.kor_dm_dokument_id,dm.dokument_id)='ZW' THEN "
    SQL+=" CASE WHEN td.typ_dokumentu='P' THEN dm.kwota ELSE -dm.kwota END ELSE 0 END)"
    SQL+=" FROM rs_dokumenty_magazynowe dm INNER JOIN rs_magazyny m USING (firma_id,magazyn_id)"
    SQL+=" INNER JOIN rs_typy_dokumentow_m td USING (firma_id,dokument_id)"
    SQL+=" WHERE dm.firma_id='"+self.firma_id+"' AND m.oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND COALESCE(dm.kor_dm_dokument_id,dm.dokument_id) IN ('WZ','ZW') AND dm.data>='"+DataOd+"'"
    SQL+=" AND dm.data<='"+DataDo+"' AND dm.kontrahent_id='"+Kontrahent+"'GROUP BY dm.data ORDER BY dm.data"
    stat,DaneWZ,dump,dump=self.PolSQL.Execute(SQL,3)

if stat=='OK':
    for poz in DaneWZ:
        Jest=False
        for i in xrange(len(dane)):
            if not Jest:
                if poz[0]>=dane[i][0]:
                # jeli daty si zgadzaj to dodaj wartoci do pozycji
                    if poz[0]==dane[i][0]:
                        dane[i][11]=poz[1]
                        dane[i][12]=poz[2]
                        Jest=True
                else:
                    Jest=True
                    dane.insert(i,[poz[0],dane[i][1],0,0,0,0,0,0,0,0,0,poz[1],poz[2]])
        if not Jest:
            # nr kontrahenta dla nieznalezionych wierszy
            InsertKontrahent = Kontrahent
            if len(dane)> 0:
                # jesli byly jakies dane dla kontrahenta, to numer kontrahenta pobieramy z grida,
                # z pierwszego wiersza aby mial taka sama postac jak inne wpisy
                InsertKontrahent = dane[0][1]
                
            dane.append([poz[0],InsertKontrahent,0,0,0,0,0,0,0,0,0,poz[1],poz[2]])
