# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_zest_obrotow_i_sald.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2009/03/18
# RCS-ID:      $Id: fs_wydruki_zest_obrotow_i_sald.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#26.03.2009 - Dariusz Boduch - opcja czy nie drukowa nazw kont mantis: 1943
#17.05.2009 - Mariusz Rajfura - fun==9 pobierajacej param.konta mantis: 2057
#10.05.2022 - Aleksander Bargie - Problem z polskimi znakami w opisie konta w zestawieniu obrotw i sald w SPC

from funkcje import fs_rozrachunki_pom

Fun = klucze[-1]

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH DO ZESTAWIENIA - SELECTY - 5 (Zestawienie obroty i salda), 6 - 5+miesiczne
#-------------------------------------------------------------------------------

if Fun in (5,6):
    # dotychczasowe cialo fukcji (Michal,Darek)
    Rok = klucze[0]
    Mc = klucze[1]
    KontoOd = klucze[2]
    KontoDo = klucze[3]
    Poziom = int(klucze[4])
    NieDrukowacNazw = klucze[5]
    ObrotyZBO = klucze[6]
    
    #sprawdzenie poprawnosci kluczy
    #sprawdzenie roku
    try:
        if int(Rok)<1950 or int(Rok)>2100:
            stat='Niepoprawny rok wykonania raportu'
    except:
        stat='Niepoprawny rok wykonania raportu: '+str(Rok)
    #sprawdzenie miesiaca
    if stat=='OK':
        if Mc not in ['01','02','03','04','05','06','07','08','09','10','11','12']:
            stat='Niepoprawny miesic wykonania raportu: '+str(Mc)

    if stat=='OK':
        Data = Rok+'-'+Mc+'-'+'01'
        sql = "SELECT data_od, data_do FROM rs_definicje_okresow"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
        if stat <> 'OK':
            stat = 'Bd pobrania danych okresu ksigowego : '+stat
            dane.append(stat)
        else:
            if len(d) == 1:
                data_poczatek = str(d[0][0])[:8]+'01'
                #if Data < str(d[0][0]):
                if Data < data_poczatek:
                    stat = 'Data wynikajca z roku i miesica jest wczeniejsza od daty pocztku okresu ksigowego'
                    dane.append(stat)
                
                if Data > str(d[0][1]):
                    stat = 'Data wynikajca z roku i miesica jest pniejsza ni data koca okresu okresu ksigowego'
                    dane.append(stat)
                    
            else:
                stat = 'Brak zdefiniowanego okresu ksigowego '+str(self.okres_id)
                dane.append(stat)

    if stat=='OK':
        if not '_' in KontoOd:
            if KontoOd=='':
                stat='Nie podano konta od'
            
            if stat=='OK':
                if KontoDo=='':
                    stat='Nie podano konta do'
    
    if stat =='OK':
        if '_' in KontoOd:
            FiltrKont=" AND konto LIKE '"+KontoOd+"%' "
        else:
            FiltrKont=" AND (((konto>='"+KontoOd+"') AND (konto<='"+KontoDo+"')) OR (konto LIKE '"+KontoDo+"%')) "
    
    if stat =='OK':
        #pobranie listy kont z tabeli rs_stany_kont
        SQL="SELECT DISTINCT konto FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+self.okres_id+"' "+FiltrKont
        SQL+=" ORDER BY konto ASC;"
        stat,DaneKont,dump,dump = self.PolSQL.Execute(SQL,3)        
        if stat <> 'OK':
            stat='Bdy pobierania konta : '+stat
    if stat=='OK':
        if len(DaneKont)==0:
            stat="Brak kont mieszczcych si w zakresie o podanych parametrach"
    
    if stat=='OK':
        ListaKont = []
        #stworzenie pelnej list kont w oparciu o pobrana liste
        for konto in DaneKont:
            Konto=rsglobal.Dekoduj(konto[0])
            if not Konto in ListaKont:
                Poz=Konto.count("-")
          
                if Poz <= Poziom:
                    if not Konto in ListaKont:
                        ListaKont.append(Konto)

                bufor = Konto
                indeks = 0
                while indeks <> -1:
                    indeks = bufor.rfind("-")
                    if indeks <> -1:
                        bufor = bufor[0:indeks]
                        Poz = Poz-1
                    if not bufor in ListaKont:
                         if (bufor >= KontoOd or '_' in KontoOd) and Poz <=Poziom:
                            ListaKont.append(bufor)

        #pobranie sum kont dla wszystkich kont (i potem wyszukiwanie)
        #Suma bilansu otwarcia
        SQL="SELECT konto,sum(kwota_wn) AS bown,sum(kwota_ma) AS boma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
        SQL+=" AND miesiac = '00' "+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneBO,dump,dump = self.PolSQL.Execute(SQL,3)            
        
    if stat=='OK':
        #Obroty w miesiacu
        SQL="SELECT konto,sum(kwota_wn) AS obrwn,sum(kwota_ma) AS obrma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND rok = '"+Rok+"' "
        SQL+=" AND miesiac = '"+Mc+"' "+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneOBR,dump,dump = self.PolSQL.Execute(SQL,3)            
    
    if stat=='OK':  
        #Suma obrotow narastajaca
        SQL="SELECT konto,sum(kwota_wn) AS narwn,sum(kwota_ma) AS narma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND (rok||miesiac) <= ('"+Rok+"'||'"+Mc+"') "
        SQL+=" AND miesiac <> '00' "+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneNAR,dump,dump = self.PolSQL.Execute(SQL,3)            
        
    if stat=='OK':  
        #Saldo
        SQL="SELECT konto,sum(saldo_wn) AS salwn,sum(saldo_ma) AS salma FROM rs_stany_kont "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND rok = '"+Rok+"' "
        SQL+=" AND miesiac = '"+Mc+"'"+FiltrKont
        SQL+=" GROUP BY konto ORDER BY konto;"
        stat,DaneSAL,dump,dump = self.PolSQL.Execute(SQL,3)            

    if stat=='OK':  
       # sprawdzenie istnienia BO
        stat,Wyn=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,self.okres_id)
        if stat <> 'OK':
            stat = 'Bd pobierania okresw dla rozrachunkw : '+stat

    if stat == 'OK':
        LOkresow=Wyn[0]
        DataGr=Wyn[1]                        
        IstniejeBO=(LOkresow.find(',')==-1)

    if stat=='OK':  
        #pobranie danych dla kolejnych kont
        for Konto in ListaKont:
            if stat=='OK':
                KontoS = Konto[0:3]
                KontoA = ""
                if len(Konto)>3:
                    KontoA = Konto[4:len(Konto)]
                KontoA = KontoA.strip()
    
                #Pobranie opisow
                Nazwa=""
                SQL="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+Konto+"');"
                stat,DaneParK,dump,dump = self.PolSQL.Execute(SQL,3)            

            if stat=='OK':
                if len(DaneParK)==0:
                    stat="Bdy w definicji konta : "+KontoS+"-"+KontoA  
                    
            if stat=='OK':
                #AB 10.05.22r
                # DaneKonta=eval(DaneParK[0][0])
                DaneKonta=rsglobal.rseval(DaneParK[0][0])
                if NieDrukowacNazw:
                    Nazwa = '     '
                else:
                    Nazwa = DaneKonta[1]
                Rozrachunkowe = DaneKonta[3]
                Pozabilansowe = DaneKonta[4]
                Jednostronne  = DaneKonta[7]
 
                BOWn=0
                BOMa=0
                for BO in DaneBO:
                    if (Konto==BO[0]) or (BO[0][0:len(Konto)+1] == Konto+'-'):
                        if BO[1] not in (None,'None',0):
                            BOWn+=rsglobal.RSRound(BO[1],2)
                        if BO[2] not in (None,'None',0):
                            BOMa+=rsglobal.RSRound(BO[2],2)
                
                OBRWn=0
                OBRMa=0
                for OBR in DaneOBR:
                    if (Konto==OBR[0]) or (OBR[0][0:len(Konto)+1] == Konto+'-'):
                        if OBR[1] not in (None,'None',0):
                            OBRWn+=rsglobal.RSRound(OBR[1],2)
                        if OBR[2] not in (None,'None',0):
                            OBRMa+=rsglobal.RSRound(OBR[2],2)
            
                NARWn=0
                NARMa=0
                for NAR in DaneNAR:
                    if (Konto==NAR[0]) or (NAR[0][0:len(Konto)+1] == Konto+'-'):
                        if NAR[1] not in (None,'None',0):
                            NARWn+=rsglobal.RSRound(NAR[1],2)
                        if NAR[2] not in (None,'None',0):
                            NARMa+=rsglobal.RSRound(NAR[2],2)
    
                if Rozrachunkowe and IstniejeBO:
                    SALWn=0
                    SALMa=0
                    for SAL in DaneSAL:
                        if (Konto==SAL[0]) or (SAL[0][0:len(Konto)+1] == Konto+'-'):
                            if SAL[1] not in (None,'None',0):
                                SALWn+=rsglobal.RSRound(SAL[1],2)
                            if SAL[2] not in (None,'None',0):
                                SALMa+=rsglobal.RSRound(SAL[2],2)
                else:
                    if (BOWn+NARWn) > (BOMa+NARMa):
                        SALWn = rsglobal.RSRound(BOWn+NARWn-BOMa-NARMa,2)
                        SALMa = 0
                    else:
                        SALWn = 0
                        SALMa = rsglobal.RSRound(BOMa+NARMa-BOWn-NARWn,2)
                    
                    if BOWn>BOMa:
                        BOWn=rsglobal.RSRound(BOWn-BOMa,2)
                        BOMa=0
                    else:
                        BOMa=rsglobal.RSRound(BOMa-BOWn,2)
                        BOWn=0
    
                if Jednostronne:
                    if BOWn>BOMa:
                        BOWn=rsglobal.RSRound(BOWn-BOMa,2)
                        BOMa=0
                    else:
                        BOMa=rsglobal.RSRound(BOMa-BOWn,2)
                        BOWn=0
                    
                    if SALWn>SALMa:
                        SALWn=rsglobal.RSRound(SALWn-SALMa,2)
                        SALMa=0
                    else:
                        SALMa=rsglobal.RSRound(SALMa-SALWn,2)
                        SALWn=0

                #obsuga obrotw z BO dziaa tylko dla zestawienia bez miesicznych
                # BO jest dodawane do sumy narastajco po uwzgldnieniu sald jednostronnych
                if Fun==5:
                    if ObrotyZBO:
                        NARWn=NARWn+BOWn
                        NARMa=NARMa+BOMa
                            
                if (BOWn <> 0) or (BOMa <> 0) or (OBRWn <> 0) or (OBRMa <> 0) or (NARWn <> 0) or (NARMa <> 0) or (SALWn <> 0) or (SALMa <> 0):
                    dane.append([Konto,Nazwa,Pozabilansowe,BOWn,BOMa,OBRWn,OBRMa,NARWn,NARMa,SALWn,SALMa])
    
    if stat=='OK':  
        dane.sort()

#-------------------------------------------------------------------------------
#---   POBRANIE PARAMETROW KONTA - 9
#-------------------------------------------------------------------------------

if Fun == 9:
    okres = klucze[0]
    konto = klucze[1]
    
    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+okres+"','"+konto+"');"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania parametrw konta:' + stat
        
    if stat == 'OK':
        dd = rsglobal.rseval(d[0][0])
        if dd[1] <> '':
            dane.append(dd)
        else:
            stat = 'Bdne konto: ' + konto