# -*- coding: iso8859_2 -*-
# -----------------------------------------------------------------------------
# Name:        fs_wydruki_zestawienie_srodkow_dla_grupy_analityka.py
# Purpose:     pobiera dane do wydruku zestawienia srodkow trwalych wg grupy - analityka
# Author:      Micha Raburski
# Created:     2011/08/25
# RCS-ID:      $Id: fs_wydruki_zestawienie_srodkow_dla_grupy_analityka.py $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2018-01-04 Piotr Witkowski (10880) Dodatkowa kolumna w zestawieniu rodkw trwaych
# 2020-09-10 Jan Raburski (12109) Grupa od i Grupa do

# klucze: data od, data do, grupa

DataOd = klucze[0]
DataDo = klucze[1]
GrupaOd = klucze[2]
GrupaDo = klucze[3]
Rodzaj = klucze[4]

stat = "OK"
dane = []

# sprawdzanie poprawnosci kluczy
#if Grupa.strip() <> '':
#    stat,DaneG,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' and kod='"+Grupa+"' ;",3)
#    if stat == 'OK':
#        if len(DaneG) == 0:
#            stat = 'Podano bdny symbol grupy'
#            dane.append(stat)

#    if stat == 'OK':
#        GrupaOp = Grupa.strip() + ' - ' + DaneG[0][0].strip()
#else:
#    GrupaOp = "wszystkie rodki"

# wczytanie grup
SQL = "SELECT kod FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' "
if GrupaOd != '':
    SQL += " and kod>='"+GrupaOd+"' "
if GrupaDo != '':
    SQL += " and kod<='" + GrupaDo + "' "
SQL += " ORDER BY kod;"
stat,DaneG,dump,dump = self.PolSQL.Execute(SQL,3)
if stat != 'OK':
    stat = 'Bd pobierania grup.'
    dane.append(stat)
elif len(DaneG)==0:
    stat='Brak grup z podanego zakresu.'
    dane.append(stat)
if stat=='OK':
    Grupy = "("
    for w in DaneG:
        Grupy += "'" + w[0].strip() + "',"
    Grupy = Grupy[:-1] + ")"


if stat == 'OK':
    FiltrRodzaj = " AND data_przyjecia <='" + DataDo + "' AND (data_sprzedazy IS NULL OR data_sprzedazy>='" + DataOd + "')"
    FiltrRodzaj += " AND (data_likwidacji IS NULL OR data_likwidacji>='" + DataOd + "')"
    if Rodzaj == 2:
        FiltrRodzaj += " AND data_sprzedazy >= '" + DataOd + "' AND data_sprzedazy<= '" + DataDo + "' "
    elif Rodzaj == 3:
        FiltrRodzaj += " AND data_likwidacji >= '" + DataOd + "' AND data_likwidacji<= '" + DataDo + "' "
    elif Rodzaj == 4:
        FiltrRodzaj += " AND data_przyjecia >= '" + DataOd + "' "
    # pozostale
    elif Rodzaj == 5:
        FiltrRodzaj += " AND (NOT (data_sprzedazy >= '" + DataOd + "' AND data_sprzedazy<= '" + DataDo + "') OR data_sprzedazy IS NULL)"
        FiltrRodzaj += " AND (NOT (data_likwidacji >= '" + DataOd + "' AND data_likwidacji<= '" + DataDo + "') OR data_likwidacji IS NULL)"
        FiltrRodzaj += " AND NOT data_przyjecia >= '" + DataOd + "' "

# waciwe pobranie danych   
if stat == 'OK':
    # NAJPIERW POBIERAMY LIST RODKW TRWAYCH Z ICH PODSTAWOWYMI PARAMETRAMI
    SQL = "SELECT srodek_id, nazwa, COALESCE(data_sprzedazy::TEXT,data_likwidacji::TEXT,''),symbol_kst,"  # 0 -3
    SQL += "stawka_procent, wartosc_poczatkowa,wartosc_aktualna,wartosc_umorzenia,COALESCE(data_przyjecia::TEXT,''),"  # 4 - 8
    SQL += " symbol_kst_2018 " # 9
    SQL += " FROM rs_srodki_trwale "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND grupa IN " + Grupy
    #if Grupa.strip() <> '':
    #    SQL += " AND grupa='" + Grupa + "'"
    SQL += FiltrRodzaj

    SQL += " ORDER BY srodek_id;"
    stat, daneST, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = 'Bd pobierania danych rodkw trwaych : ' + stat
        dane.append(stat)
    elif len(daneST) == 0:
        stat = 'Brak rodkw trwaych do zestawienia'
        dane.append(stat)

if stat == 'OK':
    SSrodki = {}
    LSrodkow = ''
    for w in daneST:
        # klucz - rodek
        # wartoci - nazwa, wartosc pocztkowa, zwikszenie i zmniejszenie wartoci pocztkowej, [0-3]
        #      bieca warto pocztkowa, symbol KST, stopa umorzenia, pocztkowe umorzenie, [4-7]
        #      zwikszenie i zmniejszenie umorzenia, bieca warto umorzenia, [8-10]
        #      data_przyjecia,data_likwidacji/sprzeday, symbol KST 2018 [11-13]
        SSrodki[w[0]] = [w[1], w[5], 0, 0, 0, w[3], w[4], w[7], 0, 0, 0, w[8], w[2], w[9]]
        LSrodkow += "'" + rsglobal.Dekoduj(w[0]) + "',"
    LSrodkow = LSrodkow.strip(',')

    # -----------------------------
    # pobranie danych przeszacowa
    # -----------------------------
    PrzeszPlusOkres = "CASE WHEN (rok||'-'||miesiac >=SUBSTRING('" + DataOd + "' FROM 1 FOR 7) "
    PrzeszPlusOkres += "AND rok||'-'||miesiac <=SUBSTRING('" + DataDo + "' FROM 1 FOR 7)) AND (rach_przesz>0 OR (rach_przesz<0 AND korekta)) THEN rach_przesz ELSE 0 END"

    PrzeszMinusOkres = "CASE WHEN rok||'-'||miesiac >=SUBSTRING('" + DataOd + "' FROM 1 FOR 7) "
    PrzeszMinusOkres += "AND rok||'-'||miesiac <=SUBSTRING('" + DataDo + "' FROM 1 FOR 7) AND rach_przesz<0 AND NOT korekta THEN -rach_przesz ELSE 0 END"

    PrzeszPlusPo = "CASE WHEN rok||'-'||miesiac>SUBSTRING('" + DataDo + "' FROM 1 FOR 7) AND (rach_przesz>0 OR (rach_przesz<0 AND korekta)) THEN rach_przesz ELSE 0 END"

    PrzeszMinusPo = "CASE WHEN rok||'-'||miesiac>SUBSTRING('" + DataDo + "' FROM 1 FOR 7) AND rach_przesz<0 AND NOT korekta THEN -rach_przesz ELSE 0 END"

    SQL = "SELECT srodek_id,SUM(" + PrzeszPlusOkres + ") ,SUM(" + PrzeszMinusOkres + ") ,SUM(" + PrzeszPlusPo + "), "
    SQL += "SUM(" + PrzeszMinusPo + ") FROM rs_srodki_trwale_przeszacowania "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND srodek_id IN (" + LSrodkow + ") GROUP BY srodek_id ORDER BY srodek_id"

    stat, DanePrzesz, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = 'Bd pobierania danych przeszacowa rodkw trwaych : ' + stat
        dane.append(stat)

if stat == 'OK':
    for przesz in DanePrzesz:
        DSrodka = SSrodki[przesz[0]]
        # zmiana pocztkowej wartoci pocztkowej
        DSrodka[1] = rsglobal.RSRound(DSrodka[1] - przesz[1] + przesz[2] - przesz[3] + przesz[4], 2)
        # zmiana zwikszenia wartoci pocztkowej
        DSrodka[2] = rsglobal.RSRound(przesz[1], 2)
        # zmiana zmniejszenia wartoci pocztkowej
        DSrodka[3] = rsglobal.RSRound(przesz[2], 2)

        SSrodki[przesz[0]] = DSrodka

    # -----------------------------
    # pobranie danych umorze 
    # -----------------------------
    UmorzOkres = "CASE WHEN rok||'-'||miesiac>=SUBSTRING('" + DataOd + "' FROM 1 FOR 7) "
    UmorzOkres += "AND rok||'-'||miesiac <=SUBSTRING('" + DataDo + "' FROM 1 FOR 7) THEN rach_umorz ELSE 0 END"

    UmorzPo = "CASE WHEN rok||'-'||miesiac >SUBSTRING('" + DataDo + "' FROM 1 FOR 7) THEN rach_umorz ELSE 0 END"

    SQL = "SELECT srodek_id,SUM(" + UmorzOkres + ") ,SUM(" + UmorzPo + ") FROM rs_srodki_trwale_umorzenia "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND srodek_id IN (" + LSrodkow + ") GROUP BY srodek_id ORDER BY srodek_id"
    rsglobal.ZapiszDoLogow('!!! SQL ' + SQL, 1)
    stat, DaneUm, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = 'Bd pobierania danych umorze rodkw trwaych : ' + stat
        dane.append(stat)

if stat == 'OK':
    for um in DaneUm:
        DSrodka = SSrodki[um[0]]
        # zmiana pocztkowej wartoci umorzenia
        DSrodka[7] = rsglobal.RSRound(DSrodka[7] - um[1] - um[2], 2)
        # zmiana zwikszenia wartoci umorzenia
        DSrodka[8] = rsglobal.RSRound(um[1], 2)

        SSrodki[um[0]] = DSrodka

# -----------------------------
# zmiany danych zalene od dat przyjcia/likwidacji/sprzeday oraz wyliczenie wartoci kocowych
# -----------------------------
if stat == 'OK':
    for sr in SSrodki:
        DSrodka = SSrodki[sr]

        # jeli data przyjcia w okresie to przesuwamy warto pocztkow i pocztkow warto umorzon
        #  do zwikszenia odpowiednich wartoci
        if DSrodka[11] >= DataOd:
            DSrodka[2] += DSrodka[1]
            DSrodka[1] = 0
            DSrodka[8] += DSrodka[7]
            DSrodka[7] = 0

        # jeli data likwidacji/sprzedazy w okresie to wyrwnujemy 
        # zmian na - z sum wartoci pocztkowej i przyrostem
        # to samo robimy z umorzeniem
        if DSrodka[12] <> '':
            if DSrodka[12] <= DataDo:
                DSrodka[3] = DSrodka[2] + DSrodka[1]
                DSrodka[9] = DSrodka[7] + DSrodka[8]

        # z poprzednich kolumn wyliczamy warto kocow rodka
        DSrodka[4] = DSrodka[2] + DSrodka[1] - DSrodka[3]
        DSrodka[10] = DSrodka[7] + DSrodka[8] - DSrodka[9]


    # przygotowujemy dane do wydruku
    Klu = SSrodki.keys()
    Klu.sort()
    DaneSr = []
    for kl in Klu:
        DaneSr.append([kl] + SSrodki[kl])
    #dane = [DaneSr, GrupaOp]
    dane = [DaneSr]
    wyn1 = Grupy[1:-1].replace("'", "")