# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wyslij_log.py
# Purpose:     wysyanie wiadomoci z logiem, emailem lub poczt wewntrzn
#
# Author:      Piotr Szydeko
# Created:     2009/04/03
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

import tempfile
import socket

#klucze:
# 0: operator_id do ktrego ma by wysana wiadomo, moe by te nazwa
# 1: nazwa pliku logu
# 2: log - tre logu
# 3: loglevel

stat = "OK"
dane = []

#  --------------  zebranie dostarczonych danych

adresat_id = klucze[0]
nazwaPliku = klucze[1]
tresc = klucze[2]
loglevelKlienta = klucze[3]

email = None
hostname = socket.gethostname()

#  --------------  sprawdzenie otrzymanych danych
if stat == "OK":
    try:
        adresat_id = int(adresat_id)
        stat, d, none, none = self.PolSQL.Execute("SELECT operator_id, email FROM rs_operatorzy WHERE operator_id=%s", 2, (adresat_id, ))
    except ValueError:
        stat, d, none, none = self.PolSQL.Execute("SELECT operator_id, email FROM rs_operatorzy WHERE operator=%s", 2, (adresat_id, ))
    if stat != "OK":
        stat = "Bd SQL: sprawdzanie operatora (%s)" % stat
    elif not d:
        stat = "Bd: operator %s nie istnieje" % adresat_id
    else:
        adresat_id, email = d[0]
        if email == "None":
            email = None

if stat == "OK" and not tresc:
    stat = "Bd: Pusta tre wiadomoci"

# usu zbdne escapowanie znakw specjalnych, sam si bd musia nimi zaj jeli bdzie taka potrzeba
tresc = tresc.replace("\\'", "'").replace("\\\\", "\\")


# ---------------------------------------------------
#  --------------  wysanie logu

emailstat = "OK"
if stat == "OK" and email:
    #  ----------  w tej sytuacji wylij to mailem
    try:
        #  ------  zapisz zacznik w pliku tymczasowym
        tempdir = tempfile.mkdtemp(prefix='rslog')
        sciezkaZalacznika = os.path.join(tempdir, nazwaPliku)
        plik = open(sciezkaZalacznika, "wb")
        plik.write(tresc)
        plik.close()
    except IOError, exc:
        emailstat = "Nie mona zapisa zacznika: %s" % exc
        sciezkaZalacznika = None

    #  ----------  wysanie wiadomoci
    if emailstat == "OK":

        temat = "[Anakonda %s] Log klienta - operator %s" % (hostname, self.operator_id)
        trescWiadomosci = "W zaczniku zawarto dziennika Anakondy utworzonego dla operatora %s\n"
        trescWiadomosci += "firma %r, oddzia %r, okres_id %r, IP klienta %s, loglevel %s"""
        trescWiadomosci = trescWiadomosci % (self.operator_id, self.firma_id, self.oddzial_id, self.okres_id, self.adres_ip, loglevelKlienta)
        emailstat = rsglobal.RSWyslijEmail(email, temat, trescWiadomosci, [sciezkaZalacznika])

    #  ----------  jeli byy zaczniki to posprztaj
    if emailstat == "OK" and sciezkaZalacznika:
        os.remove(sciezkaZalacznika)
        os.rmdir(tempdir)
        sciezkaZalacznika = None

    #if emailstat != "OK":
    #    rsglobal.ZapiszDoLogow("fs_wyslij_log: nie mozna wyslac maila: %r" % emailstat, 2)

if (stat == "OK" and not email) or (email and emailstat != "OK"):
    #  ----------  operator bez adresu email lub prba wysania maila nie powioda si, wylij poczt wewntrzn

    query = "SELECT nextval('rs_wiadomosci_id')"
    stat, wiadomosc_id, none, none = self.PolSQL.Execute(query, 4)
    zalacz = len(tresc) > 2048

    if stat == "OK":
        temat = "Log klienta - operator %s" % self.operator_id
        trescWiadomosci = "Zapis komunikatw i bdw z wykonania programu, operator %s\n"
        trescWiadomosci += "firma %r, oddzia %r, okres_id %r, IP klienta %s, loglevel %s\n"""
        trescWiadomosci = trescWiadomosci % (self.operator_id, self.firma_id, self.oddzial_id, self.okres_id, self.adres_ip, loglevelKlienta)
        if email:
            trescWiadomosci += "Prba wysania maila zakoczya si bdem: %s\n" % emailstat
        if zalacz:
            trescWiadomosci += "Zawarto pliku %s w zaczniku." % nazwaPliku
        else:
            trescWiadomosci += "\n----------------------------------------------------------------------\n\n"
            trescWiadomosci += tresc

        query = ("INSERT INTO rs_wiadomosci (firma_id, wiadomosc_id, operator_id, naglowek, tresc, priorytet, usunieta)"
            " VALUES (%s, %s, %s, %s, %s, 'N', FALSE)")
        stat, none, none, none = self.PolSQL.Execute(query, 1, (self.firma_id, wiadomosc_id, self.operator_id, temat, trescWiadomosci))
    if stat == "OK":
        query = "INSERT INTO rs_wiadomosci_operatorzy(wiadomosc_id,folder_id,operator_id,usunieta,nowa) VALUES (%s, 0, %s, FALSE, TRUE)"
        stat, none, none, none = self.PolSQL.Execute(query, 1, (wiadomosc_id, adresat_id))

    if zalacz:
        if stat == "OK":
            query = "SELECT nextval('rs_zalaczniki_id')"
            stat, zalacznik_id, none, none = self.PolSQL.Execute(query, 4)
        if stat == "OK":
            query = "INSERT INTO rs_zalaczniki(zalacznik_id, nazwa, zalacznik) VALUES (%s, %s, %s)"
            stat, none, none, none = self.PolSQL.Execute(query, 1, (zalacznik_id, nazwaPliku, self.PolSQL.Binary(tresc)))
        if stat == "OK":
            query = "INSERT INTO rs_wiadomosci_zalaczniki(wiadomosc_id, zalacznik_id) VALUES (%s, %s)"
            stat, none, none, none = self.PolSQL.Execute(query, 1, (wiadomosc_id, zalacznik_id))

if email:
    dane = [emailstat]
else:
    dane = [None]
