#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_wyznaczniki.py
# Purpose:		dodaje/pobiera/usuwa wyznaczniki
# Author:		Marcin Grzeda
# Created:		2008/23/04
# RCS-ID:		$Id: fs_wyznaczniki.py $
# Copyright:	(c) 2008 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------

# 2013-05-21 Mariusz Rajfura  (6862) COALESCE dla plik_wydruku
# 2023-11-30 Wojciech Skowron (13623) CzyKorektaZaliczki, Funkcja 10

#klucze:
# 0: Wyznacznik_id

Wyznacznik=klucze[0]
WyznacznikS=klucze[1]
TypDokumentu=klucze[2][0]
CzyKorekta=klucze[2][1]
NiezbUpr=klucze[3]
UprWyzn=klucze[4]

#WS 2023-11-30
CzyKorektaZaliczki=None
if len(klucze[2]) > 2:
    CzyKorektaZaliczki = klucze[2][2]

Fun=klucze[-1]
stat = "OK"
dane = []
puste_pola = ['    -  -  ','',[]]

if self.operator_id != STANDARD_OPERATOR_ID:
    if (Fun in [1]) and (not (self.oddzial_id,'021013') in self.uprawnienia):
        stat='UPR INS'
        dane.append(stat)
    if (Fun in [3]) and (not (self.oddzial_id,'021015') in self.uprawnienia):
        stat='UPR ZM KLUCZ'
        dane.append(stat)
    if (Fun in [6]) and (not (self.oddzial_id,'021014') in self.uprawnienia):
        stat='UPR DEL'
        dane.append(stat)
    if (Fun in [1,3,5,6,10]) and (not (self.oddzial_id,'021011') in self.uprawnienia):
        stat='UPR PRZ'
        dane.append(stat)

#------------------------------------------------------------------------------
# -- Dodawanie 1 --
#------------------------------------------------------------------------------
if Fun in [1] and stat=='OK':
    Insert="INSERT INTO rs_wyznaczniki (firma_id,wyznacznik_id,opis,typ_faktury) VALUES ('"+self.firma_id+"','"+Wyznacznik.strip()+"','nowy wyznacznik','KR')"
    st,dump,dump,dump=self.PolSQL.Execute(Insert,1)
    if st<>'OK':
        stat='BL INS'
        dane.append(stat) 

#------------------------------------------------------------------------------
# -- Zmiana Klucza --(3)
#------------------------------------------------------------------------------
if Fun in [3] and stat=='OK':
    Upd="UPDATE rs_wyznaczniki SET wyznacznik_id = '"+Wyznacznik+"' WHERE wyznacznik_id='"+WyznacznikS+"' AND firma_id='"+self.firma_id+"' ;"
    st,dump,dump,dump=self.PolSQL.Execute(Upd,1)
    if st<>'OK':
        stat='BL UPD'
        dane.append(stat)
        
#------------------------------------------------------------------------------
# -- Usuwanie 6 -- #
#------------------------------------------------------------------------------
if Fun in [6] and stat=='OK':
    Delete="DELETE FROM rs_wyznaczniki WHERE wyznacznik_id='"+Wyznacznik+"' AND firma_id = '"+self.firma_id+"';"
    st,dump,dump,dump=self.PolSQL.Execute(Delete,1)
    if st!="OK":
        stat="BL DEL"
        dane.append(stat)

#------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6, 8 wybr-- #
#------------------------------------------------------------------------------

if (Fun in [1,3,5,6,8]) and (stat=='OK'):
    Filtr="WHERE firma_id='"+self.firma_id+"'"
    if Fun==8 and self.operator_id != STANDARD_OPERATOR_ID:
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        Sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','"+str(NiezbUpr).replace("'",'"')+"','"+str(UprWyzn)+"');"
        st,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if st=='OK' and len(d)>0 and rsglobal.rseval(str(d[0][0]))[0]=='OK':
            ListaWyznacznikow=rsglobal.rseval(str(d[0][0]))[1]
            if len(ListaWyznacznikow)>0:
                Filtr+=" AND wyznacznik_id in "+"("+rsglobal.Dekoduj(str(ListaWyznacznikow)[1:-1])+")"
            else:
                Filtr+=" AND False"
        else:
            stat='BL SQL LIS WYZN'
            dane.append(stat)
    
    if TypDokumentu!=None and stat=='OK':
        Filtr+=" AND typ_faktury in "+TypDokumentu
    
    if CzyKorekta!=None and stat=='OK':
        rsglobal.ZapiszDoLogow(str(CzyKorekta),1)
        if str(CzyKorekta)=='True':
            Filtr+=" AND czy_korekta " 
        else:
            Filtr+=" AND (NOT czy_korekta OR czy_korekta is NULL) "

    #WS 2023-11-30
    if CzyKorektaZaliczki is not None and stat == 'OK':
        if CzyKorektaZaliczki is True:
            Filtr+=" AND czy_korekta_zaliczki "
        else:
            Filtr+=" AND (NOT czy_korekta_zaliczki OR czy_korekta_zaliczki is NULL) "
            
    if stat=='OK':
        SELECT ="SELECT wyznacznik_id,opis,typ_faktury,COALESCE(plik_wydruku,''),czy_korekta"
        SELECT+=" FROM rs_wyznaczniki "+Filtr+" ORDER BY wyznacznik_id;"	
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SELECT,3)
        if stat!="OK":
            stat="BL SQL PRZ"
            dane.append(stat)

#------------------------------------------------------------------------------
# -- Pobranie wyznacznikw dla korekt zaliczkowych 10 --
#------------------------------------------------------------------------------

#WS 2023-11-30
if stat=='OK' and Fun == 10:
    SEL = "SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND typ_faktury='FZ';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SEL, 3)

