# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wyznaczniki_dane.py
# Purpose:     wyznaczniki edycja
# Author:      Pawe Wojcikowski
# Created:     2009/08/30
# RCS-ID:      $Id: fs_wyznaczniki_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-08-28 Mariusz Rajfura (6028) nowe pola: miejsce_dostawy,handlowiec
# 2013-05-21 Mariusz Rajfura (6862) polaczenie pola 'plik_wydruku' ze slownikiem
# 2020-04-08 Mikoaj Kozowski (11914) obsuga pl "ozn_sprzedaz" i "ozn_trans"
# 2023-12-04 Wojciech Skowron  (13623) obsuga pola "czy_korekta_zaliczki"

Wyznacznik = rsglobal.Dekoduj(klucze[0]).strip()

Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprEdycja=((self.oddzial_id,'021012') in self.uprawnienia) or ((self.oddzial_id,'021013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- Update (3,4)
#-------------------------------------------------------------------------------

if Fun in [3,4]:
    if not UprEdycja:
        stat = "UPR UPD"
        dane.append(stat)

    if stat == 'OK':
        typ_faktury = None  #WS 2023-12-04
        czy_korekta_zaliczki = None  #WS 2023-12-04

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'opis':
                wart = wart.strip()
                if wart == '':
                    dane.append('BR OPIS')
                    
            elif pole == 'typ_faktury':
                wart = wart.strip()
                if wart == '':
                    dane.append('BR TYP')
                else:
                    sql="SELECT kod FROM rs_typy_faktur WHERE kod='"+wart+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        dane.append('Bdy przy sprawdzaniu typu :'+stat)
                    elif len(d) == 0:
                        dane.append('BL TYP')
                        typ_faktury = 'BLAD'
                    else:
                        typ_faktury = wart  #WS 2023-12-04

            elif pole == 'miejsce_dostawy':
                wart = wart.strip()
                if wart != '':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"' AND aktywny;"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        dane.append('Bdy przy sprawdzaniu miejsca dostawy :'+stat)
                    elif len(d) == 0:
                        dane.append('BL MIEJSCE_DOSTAWY')
                        
            elif pole == 'handlowiec':
                wart = wart.strip()
                if wart != '':
                    sql="SELECT kod FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        dane.append('Bdy przy sprawdzaniu handlowca :'+stat)
                    elif len(d) == 0:
                        dane.append('BL HANDLOWIEC')

            elif pole == 'plik_wydruku':
                if wart != '':
                    sql="SELECT kod FROM rs_typy_wydrukow_faktur WHERE kod='"+wart+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        dane.append('Bdy przy sprawdzaniu pliku wydruku :'+stat)
                    elif len(d) == 0:
                        dane.append('BL PLIK_WYDRUKU')

            elif pole == 'ozn_trans': #MK 2020-04-08
                if wart != '':
                    sql="SELECT kod FROM rs_transakcje_oznaczenia WHERE kod='"+wart+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        dane.append('Bdy przy sprawdzaniu oznacze transakcji :'+stat)
                    elif len(d) == 0:
                        dane.append('BL OZN_TRANS')

            elif pole == 'ozn_sprzedaz': #MK 2020-04-08
                if wart != '':
                    sql="SELECT kod FROM rs_oznaczenia_sprzedaz WHERE kod='"+wart+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        dane.append('Bdy przy sprawdzaniu oznacze sprzeday :'+stat)
                    elif len(d) == 0:
                        dane.append('BL OZN_SPRZ')

            elif pole == 'czy_korekta_zaliczki':  #WS 2023-12-04 - musi by typ FZ jeli zaznaczone czy_korekta_zaliczki
                if wart:
                    czy_korekta_zaliczki = wart

                    if typ_faktury is None:
                        sql="SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'; "
                        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                        if stat != 'OK':
                            dane.append('Bdy przy sprawdzaniu czy_korekta_zaliczki :'+stat)
                        else:
                            typ_faktury = d[0][0].strip()

                    if typ_faktury not in ('BLAD', 'FZ'):
                        dane.append('BL CZY_KOREKTA_ZALICZKI TYP F')

                
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
        
    if stat == 'OK':
        
        WHERE = " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'; "
        UPD = "UPDATE rs_wyznaczniki SET "

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if wart=='':
                wart='NULL'
            else:
                wart= "'"+str(wart)+"'"
            UPD += pole+"="+str(wart)+","

        #WS 2023-12-04 - zaznacza czy_korekta jeli zaznaczono czy_korekta_zaliczki
        if czy_korekta_zaliczki and 'czy_korekta' not in pola:
            UPD += "czy_korekta=TRUE,"
        UPD = UPD[:-1]+WHERE
                   
        stat,dump,dump,dump = self.PolSQL.Execute(UPD ,1)
        if stat<>'OK':
            stat = 'Bdy modyfikowania danych:'+stat
            dane.append(stat)  
            
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat=='OK':
    SELECT ="SELECT * FROM rs_wyznaczniki"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych : "+stat   
        dane.append(stat)

    if stat=='OK' and len(dane)==1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # typ_faktury [0]
        if (self.oddzial_id,'011240') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_typy_faktur WHERE kod='"+tr.GetVal(0,"typ_faktury")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu typu faktury: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika typw faktur. Poinformuj administratora.')

        # miejsce_dostawy [1]
        kod = tr.GetVal(0,"miejsce_dostawy")
        if kod in ('','None'):
            wyn2.append('')
        else:
            if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT nazwa FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kod+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania nazwy kontrahenta: '+stat)
                elif len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(rsglobal.Dekoduj(d[0][0]))
            else:
                wyn2.append('Brak uprawnie do kartoteki kontrahentw. Poinformuj administratora.')

        # handlowiec [2]
        kod = tr.GetVal(0,"handlowiec")
        if kod in ('','None'):
            wyn2.append('')
        else:
            if (self.oddzial_id,'011220') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT opis FROM rs_handlowcy"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+kod+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania opisu handlowca: '+stat)
                elif len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(rsglobal.Dekoduj(d[0][0]))
            else:
                wyn2.append('Brak uprawnie do sownika handlowcw. Poinformuj administratora.')

        # plik_wydruku [3]
        if (self.oddzial_id,'211100') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_typy_wydrukow_faktur WHERE kod='"+tr.GetVal(0,"plik_wydruku")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu pliku wydruku faktury: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika typw wydrukw faktur. Poinformuj administratora.')

        # oznaczenie transakcje [4] #MK 2020-04-08
        if (self.oddzial_id, '211430') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_transakcje_oznaczenia WHERE kod='" + tr.GetVal(0, "ozn_trans") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia transakcji: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia transakcji. Poinformuj administratora.')

        # oznaczenie sprzedaz [5] #MK 2020-04-08
        if (self.oddzial_id, '211440') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_oznaczenia_sprzedaz WHERE kod='" + tr.GetVal(0, "ozn_sprzedaz") + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu oznaczenia sprzeday: ' + stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika oznaczenia sprzeday. Poinformuj administratora.')
