# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_dane.py
# Purpose:     dodawanie/edycja wzoru dekretacji
#
# Author:      Mariusz Rajfura
# Created:     2009/07/30
# RCS-ID:      $Id: fs_wzory_dekretacji_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2018-10-16 Aleksander Bargie (11260) - Wzory dekretacji - pusty string w kontrahent_id
# 2019-02-19 Wojciech Skowron - Refaktoryzacja (10389) - klucze w postaci slownika zamiast listy
# 2019-02-19 Wojciech Skowron - Refaktoryzacja (10389) - obsuga bdw
# 2019-06-18 Wojciech Skowron - (11515) Wzr dekretacji pac - pole warunek w nagwku
# 2020-03-30 Wojciech Skowron - (11913) Oznaczenia JPK we wzorach dekretacji
# 2024-02-23 Wojciech Skowron - (13700) Sprzeda usug

import rsglobal

stat = 'OK'
#WS
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,2,3,4,5], 'Nazwa':[1,2,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    DowodId = rsglobal.Dekoduj(klucze['Dowod']).strip()
    NazwaId = rsglobal.Dekoduj(klucze['Nazwa']).strip()

# DowodId = rsglobal.Dekoduj(klucze[0]).strip()
# NazwaId = rsglobal.Dekoduj(klucze[1]).strip()
# Fun = klucze[-1]

dane = []
wyn1 = []
wyn2 = []

ProjektyPodzial = None
ZespolKont = None

if Fun in (1,2):
    if not ((self.oddzial_id,'074113') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR_UPR_INS'
        
if Fun in (3,4):
    if not ((self.oddzial_id,'074112') in self.uprawnienia or (self.oddzial_id,'074113') in self.uprawnienia or \
            self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR_UPR_UPD'

# przed dodawaniem
if stat == 'OK' and Fun in (1,2):
    if DowodId == '':
        #WS 2019-04-16
        stat = 'BR_DOWODU'
        dane.append(stat)
        # dane.append('BR_DOWODU')
    else:
        if DowodId in ('BO','BK'):
            #WS 2019-04-16
            stat = 'BL_REZERW'
            dane.append(stat)
            # dane.append('BL_REZERW')

    if NazwaId == '':
        #WS 2019-04-16
        stat = 'BR_NAZWY'
        dane.append(stat)
        # dane.append(stat)
    
    if len(dane) == 0:
        sql ="SELECT dowod_id,projekty_podzial,zespol_kont FROM rs_wzory_dekretacji"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat != 'OK':
            #WS 2019-04-16
            stat = 'BL_SQL_LISTA'
            dane.append(stat)
            # dane.append('Bd pobrania listy wzorw dekretacji : '+stat)
        else:
            if len(d) > 0:
                #WS 2019-04-16
                stat = 'BL_WZOR_ISTN'
                dane.append(stat)
                # dane.append('BL_WZOR_ISTN')

# przed edycj
if stat == 'OK' and Fun in (3,4,5):
    sql ="SELECT projekty_podzial,zespol_kont FROM rs_wzory_dekretacji"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"';"
        
    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
    if stat != 'OK':
        stat = 'BL_SQL_POBR'
        dane.append(stat)
        # dane.append('Bd pobrania wzoru dekretacji : '+stat)
    elif len(d)==0:
        #WS 2019-04-16
        stat = 'BR_WZORU'
        dane.append(stat)
        # dane.append('BR_WZORU')
    else:
        ProjektyPodzial = d[0][0]
        ZespolKont = d[0][1].strip()

                
if len(dane) > 0:
    stat = dane[0]


    
#zmienne zainicjowane, ze wzglegu na zasieg

sqlinsertpola = "firma_id,okres_id,"
sqlinsertwart = "'"+self.firma_id+"','"+self.okres_id+"',"
sqlupdate = ''
opisy = ('waluta_opis','typ_wzoru_opis','typ_wzoru_opis','kontrahent_opis','rejestr_opis','konto_opis','oddzial_opis',
         'wyznacznik_opis','magazyn_opis','dokument_opis','ureg_typ_opis',
         'ozn_trans_opis','ozn_sprzedaz_opis','ozn_nabycie_opis')  #WS 2020-03-30

if stat == 'OK' and Fun in (1,2,3,4):                
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ('dowod_id','nazwa_id','symbol_dok'):
            wart = "'"+wart+"'"
        
        elif pole == 'nazwa':
            if wart == '':
                #WS 2019-04-17
                stat = 'BR_OPISU'
                dane.append(stat)
                # dane.append('BR_OPISU')
            else:
                wart = "'"+wart+"'"
                
        elif pole == 'waluta':
            if wart == '':
                #WS 2019-04-17
                stat = 'BR_WALUTY'
                dane.append(stat)
                # dane.append('BR_WALUTY')
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_waluty WHERE firma_id = '"+self.firma_id+"' AND kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_WALUTA'
                    dane.append(stat)
                    # dane.append('Bd pobrania kodu waluty : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_WALUTA'
                        dane.append(stat)
                        # dane.append('BL_WALUTA')
        
        elif pole == 'typ_wzoru':
            if wart == '':
                #WS 2019-04-17
                stat = 'BR_TYPWZORU'
                dane.append(stat)
                # dane.append('BR_TYPWZORU')
            else:
                if not wart in ('S','D','Z','F','K','M','R','P','W'):
                    #WS 2019-04-17
                    stat = 'BL_TYPWZORU'
                    dane.append(stat)
                    # dane.append('BL_TYPWZORU')
                else:
                    wart = "'"+wart+"'"
                    
        elif pole == 'kontrahent_id':
            rsglobal.ZapiszDoLogow('WART: \'' + wart + '\'', 5)
            rsglobal.ZapiszDoLogow('WARTSTRIP: \'' + wart.strip() + '\'', 5)
            #AB 16.10.18r
            if wart.strip() == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"            
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_KONTRAH'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych kontrahenta : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_KONTRAH'
                        dane.append(stat)
                        # dane.append('BL_KONTRAH')

        elif pole == 'rejestr':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_rejestry_vat"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_REJESTR'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych rejestru VAT : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_REJESTR'
                        dane.append(stat)
                        # dane.append('BL_REJESTR')

        elif pole == 'konto_id':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"            
                sql ="SELECT konto_id FROM rs_konta_bankowe"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND konto_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_KONTOBANK'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych konta bankowego : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_KONTOBANK'
                        dane.append(stat)
                        # dane.append('BL_KONTOBANK')
        
        elif pole == 'oddzial_id':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"            
                sql ="SELECT oddzial_id FROM rs_oddzialy"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_ODDZIAL'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych oddzialu : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_ODDZIAL'
                        dane.append(stat)
                        # dane.append('BL_ODDZIAL')

        elif pole == 'wyznacznik_id':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT wyznacznik_id FROM rs_wyznaczniki"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_WYZNACZNIK'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych wyznacznika : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_WYZNACZNIK'
                        dane.append(stat)
                        # dane.append('BL_WYZNACZNIK')

        elif pole == 'magazyn_id':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT magazyn_id FROM rs_magazyny"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND magazyn_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_MAGAZYN'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych magazynu : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_MAGAZYN'
                        dane.append(stat)
                        # dane.append('BL_MAGAZYN')
        
        elif pole == 'dokument_id':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND dokument_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_DOKUMENT'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych dokumentu magazynowego : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_DOKUMENT'
                        dane.append(stat)
                        # dane.append('BL_DOKUMENT')
        
        elif pole == 'ureg_typ':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_typy_zaplat"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat != 'OK':
                    #WS 2019-04-17
                    stat = 'BL_SQL_TYPZAPL'
                    dane.append(stat)
                    # dane.append('Bd pobrania danych typu zapaty : '+stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-17
                        stat = 'BL_TYPZAPL'
                        dane.append(stat)
                        # dane.append('BL_TYPZAPL')

        #WS 2020-03-30
        elif pole == 'ozn_trans':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_transakcje_oznaczenia"
                sql+=" WHERE kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'BL_SQL_OZN_TRANS'
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_OZN_TRANS'
                    dane.append(stat)

        #WS 2020-03-30
        elif pole == 'ozn_sprzedaz':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_oznaczenia_sprzedaz"
                sql+=" WHERE kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'BL_SQL_OZN_SPRZEDAZ'
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_OZN_SPRZEDAZ'
                    dane.append(stat)

        #WS 2020-03-30
        elif pole == 'ozn_nabycie':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_oznaczenia_nabycie"
                sql+=" WHERE kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2,CzyDodawacBlad=True)
                if stat != 'OK':
                    stat = 'BL_SQL_OZN_NABYCIE'
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'BL_OZN_NABYCIE'
                    dane.append(stat)

        elif pole == 'projekty_podzial':
            ProjektyPodzial = wart
            
        elif pole == 'zespol_kont':
            ZespolKont = wart.strip()
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"

        #WS 2019-06-18
        elif pole == 'warunek':
            if wart == '':
                wart = "''"
            else:
                wart = "'"+wart+"'"
                        
        if type(wart) == type(True):               
            if wart:
                wart = 'True'
            else:
                wart = 'False'
        
        if Fun in (1,2) and pole not in opisy:
            if (i > 0) and (i < len(pola)) :
                sqlinsertpola += ','
                sqlinsertwart += ','
            sqlinsertpola += pole
            sqlinsertwart += wart
            
        elif Fun in (3,4) and not (pole in ('dowod_id','nazwa_id',) or pole in opisy):
            if sqlupdate != '':
                sqlupdate += ','
            sqlupdate+=pole+" = " +wart
    
    if stat=='OK':
        if not ProjektyPodzial:
            if not ZespolKont in ['',None,'None']:
                #WS 2019-04-17
                stat = 'BL_ZESPOL_KONT'
                dane.append(stat)
                # dane.append('BL_ZESPOL_KONT')
                 
        elif ZespolKont in ['',None,'None']:
            #WS 2019-04-17
            stat = 'BL_ZESPOL_KONT'
            dane.append(stat)
            # dane.append('BL_ZESPOL_KONT')
        else:
            CzyZespol=True
            for znak in ZespolKont:
                if CzyZespol:
                    if not znak in ['4','5','7','8']:
                        CzyZespol=False
                        #WS 2019-04-17
                        stat = 'BL_ZESPOL_KONT'
                        dane.append(stat)
                        # dane.append('BL_ZESPOL_KONT')
        
    if len(dane) > 0:
        stat = dane[0]
        
#-------------------------------------------------------------------------------
# INSERT   1 - pobraniem  2-bez pobrania
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2) and sqlinsertpola != '':
    sql ="INSERT INTO rs_wzory_dekretacji ("+sqlinsertpola+") VALUES ("+sqlinsertwart+");"
    stat,d,dump,dump = self.PolSQL.Execute(sql,1)
    if stat != 'OK':
        #WS 2019-04-16
        stat = 'BL_INS'
        dane.append(stat)
        # dane.append('Bd dodawania nowego wzoru dekretacji : '+stat)
            
#-------------------------------------------------------------------------------
# UPDATE   3 - pobraniem  4-bez pobrania
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3,4) and sqlupdate != '':
    sql ="UPDATE rs_wzory_dekretacji SET "+sqlupdate
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,1)
    if stat != 'OK':
        #WS 2019-04-16
        stat = 'BL_UPD'
        dane.append(stat)
        # dane.append('Bd modyfikacji wzoru dekretacji : '+stat)

#-------------------------------------------------------------------------------
# SELECT - 5
#-------------------------------------------------------------------------------
if stat == 'OK' and Fun in (1,3,5):
    sql ="SELECT d.dowod_id,d.nazwa_id,d.dod_pozycje,d.nazwa,d.waluta,w.opis as waluta_opis,d.typ_wzoru,"
    sql+="wd.opis as typ_wzoru_opis,d.symbol_dok,d.czy_symbol_dok,d.mod_symbol_dok,d.czy_data_wyst,"
    sql+="d.czy_data_wplywu, d.czy_termin_plat,d.czy_data_zapl,d.kontrahent_id,"
    sql+="k.nazwa as kontrahent_opis,d.czy_kontrahent_id,d.mod_kontrahent_id,d.dod_kontrahent,"
    sql+="d.rejestr,r.opis as rejestr_opis,d.czy_rejestr,d.mod_rejestr,d.konto_id,"
    sql+="kt.bank||' '||kt.konto as konto_opis,"
    sql+="d.czy_konto_id,d.mod_konto_id,d.czy_data_rejestru,d.oddzial_id,o.opis as oddzial_opis,"
    sql+="d.wyznacznik_id,wz.opis as wyznacznik_opis,d.magazyn_id,m.opis as magazyn_opis,d.dokument_id,dok.nazwa_dokumentu as dokument_opis,"
    sql+="d.ureg_typ,t.opis as ureg_typ_opis,d.czy_zw,d.projekty_podzial,d.zespol_kont,d.sumarycznie "
    sql+=",warunek " #WS 2019-06-18
    sql+=",d.ozn_trans,ot.nazwa as ozn_trans_opis,d.czy_ozn_trans,d.mod_ozn_trans," #WS 2020-03-30
    sql+="d.ozn_sprzedaz,os.nazwa as ozn_sprzedaz_opis,d.czy_ozn_sprzedaz,d.mod_ozn_sprzedaz,"  #WS 2020-03-30
    sql+="d.ozn_nabycie,onab.nazwa as ozn_nabycie_opis,d.czy_ozn_nabycie,d.mod_ozn_nabycie,d.import," #WS 2020-03-30
    sql+="d.sprzedaz_uslug,d.mod_sprzedaz_uslug"  #WS 2024-02-23
    sql+=" FROM rs_wzory_dekretacji d "
    sql+=" LEFT OUTER JOIN rs_waluty w ON d.waluta=w.kod AND d.firma_id=w.firma_id "
    sql+=" LEFT OUTER JOIN rs_typy_wzorow_dekretacji wd ON d.typ_wzoru=wd.kod "
    sql+=" LEFT OUTER JOIN rs_kontrahenci k ON d.firma_id = k.firma_id AND d.kontrahent_id=k.kontrahent_id"
    sql+=" LEFT OUTER JOIN rs_rejestry_vat r ON d.firma_id = r.firma_id AND d.rejestr=r.kod"
    sql+=" LEFT OUTER JOIN rs_konta_bankowe kt ON d.firma_id = kt.firma_id AND d.konto_id=kt.konto_id"
    sql+=" LEFT OUTER JOIN rs_oddzialy o ON d.firma_id = o.firma_id AND d.oddzial_id=o.oddzial_id"
    sql+=" LEFT OUTER JOIN rs_wyznaczniki wz ON d.firma_id = wz.firma_id AND d.wyznacznik_id=wz.wyznacznik_id"
    sql+=" LEFT OUTER JOIN rs_magazyny m ON d.firma_id = m.firma_id AND d.magazyn_id=m.magazyn_id"
    sql+=" LEFT OUTER JOIN rs_typy_dokumentow_m dok ON d.firma_id = dok.firma_id AND d.dokument_id=dok.dokument_id"
    sql+=" LEFT OUTER JOIN rs_typy_zaplat t ON d.firma_id = t.firma_id AND d.ureg_typ=t.kod"
    sql+=" LEFT OUTER JOIN rs_transakcje_oznaczenia ot ON d.ozn_trans=ot.kod"  #WS 2020-03-30
    sql+=" LEFT OUTER JOIN rs_oznaczenia_sprzedaz os ON d.ozn_sprzedaz=os.kod"  #WS 2020-03-30
    sql+=" LEFT OUTER JOIN rs_oznaczenia_nabycie onab ON d.ozn_nabycie=onab.kod"  #WS 2020-03-30
    sql+=" WHERE d.firma_id = '"+self.firma_id+"' AND d.okres_id = '"+self.okres_id+"'"
    sql+=" AND d.dowod_id = '"+DowodId+"' AND d.nazwa_id = '"+NazwaId+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        #WS 2019-04-16
        stat = 'BL_SEL'
        dane.append(stat)
        # stat = 'Bd pobrania nagwka wzoru dekretacji : '+stat
