#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_wzory_dekretacji_dostawy.py
# Purpose:		dodaje/pobiera/usuwa wzory dekretacji dostaw
# Author:		Piotr Witkowski
# Created:		2016/12/20
# RCS-ID:		$Id: fs_wzory_dekretacji_dostaw.py $
# Copyright:	(c) 2016 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------
#2016-12-21 Piotr Witkowski (10166) Wzory dekretacji
#2019-02-18 Wojciech Skowron (10389) Refaktoryzacja - klucze w postaci slownika zamiast listy, zmiana w sprawdzaniu uprawnien
#2019-04-15 Wojciech Skowron (10389) Refaktoryzacja - obsluga bledow

#WS
# Dowod = klucze[0]
# Nazwa=klucze[1]
# NrPoz=klucze[2]
#
# Fun=klucze[-1]
stat = "OK"
dane = []

#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,4,5,6], 'Nazwa':[1,4,5,6], 'NrPoz':[4,6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_dostaw z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    if Fun in [4,6]:
        NrPoz = klucze['NrPoz']

#WS
# if self.operator_id <> STANDARD_OPERATOR_ID:
#     UprDodawanie=(self.oddzial_id,'074123') in self.uprawnienia
#     UprUsuwanie=(self.oddzial_id,'074124') in self.uprawnienia
#     UprPrzegl=(self.oddzial_id,'074120') in self.uprawnienia
# else:
#     UprUsuwanie = UprPrzegl = UprDodawanie =True

#-------------------------------------------------------------------------------
#--- KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS

if Fun in [1,4,5,6] and stat == 'OK':
    if not ((self.oddzial_id,'074120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_PRZ'

if Fun == [1,4] and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_INS'

if Fun == 6 and stat == 'OK':
    if not ((self.oddzial_id,'074124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_DEL'

#-------------------------------------------------------------------------------
#--- DODAWANIE (1)
#-------------------------------------------------------------------------------

if (Fun == 1) and stat == 'OK':
    # if UprDodawanie:
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_dostaw','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        Nr = dane[0][0]
        Ins="INSERT INTO rs_wzory_dekretacji_dostaw (firma_id,okres_id,dowod_id,nazwa_id,nr_poz) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"',"+str(Nr)+");"
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_DOD'
    # else:
    #     stat="UPR INS"

#-------------------------------------------------------------------------------
#--- USUWANIE (6)
#-------------------------------------------------------------------------------

if (Fun == 6) and stat == 'OK':
    # if UprUsuwanie:
    NrPoz = float(NrPoz)

    Delete ="DELETE FROM rs_wzory_dekretacji_dostaw"
    Delete+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Delete+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz = "+str(NrPoz)+"; "

    Update ="UPDATE rs_wzory_dekretacji_dostaw SET nr_poz = nr_poz+1000"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(NrPoz)+"; "
    Update+="UPDATE rs_wzory_dekretacji_dostaw SET nr_poz = nr_poz-1001"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(1000+NrPoz)+"; "

    stat,dump,dump,dump=self.PolSQL.Execute(Delete+Update,1)
    if stat != 'OK':
        #WS 2019-04-15
        stat = 'BL_DEL'
        # stat = 'Bd usuwania pozycji: '+stat
    # else:
    #     stat="UPR DEL"

#-------------------------------------------------------------------------------
#--- KOPIOWANIE (4)
#-------------------------------------------------------------------------------

if (Fun == 4) and stat == 'OK':
    # if UprDodawanie:
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_dostaw','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        NrNowy=dane[0][0]
        Kopiuj="INSERT INTO rs_wzory_dekretacji_dostaw ( firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+="nr_poz,konto_ma,konto_wn,konto_vat_wn,stawka_vat_wn,czy_kontrahent,pobierac_na_rejestr,warunek,sposob_rozl  ) "
        Kopiuj+="SELECT  firma_id, okres_id, dowod_id, nazwa_id,"+str(NrNowy)+", konto_ma, konto_wn, konto_vat_wn, "
        Kopiuj+= " stawka_vat_wn, czy_kontrahent, pobierac_na_rejestr, warunek, sposob_rozl "
        Kopiuj+="FROM rs_wzory_dekretacji_dostaw WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+NrPoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Kopiuj,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_KOP'
    # else:
    #     stat="UPR INS"

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1,4,5,6)
#-------------------------------------------------------------------------------

if (Fun in [1,4,5,6]) and (stat=='OK'):
    # if UprPrzegl:
    Filtr="firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    #Select="SELECT nr_poz,wyznacznik_id,konto_wn,czy_kontrahent,konto_ma,stawka_vat_ma,konto_vat_ma,konto_vat_ma_kor,warunek FROM rs_wzory_dekretacji_dostaw WHERE "+Filtr+" ORDER BY nr_poz;"

    Select="SELECT d.nr_poz,d.konto_wn,d.sposob_rozl,d.konto_vat_wn,d.stawka_vat_wn,d.konto_ma,d.czy_kontrahent,"
    Select+="d.warunek FROM rs_wzory_dekretacji_dostaw d "#JOIN rs_sposob_rozl_vat v ON d.sposob_rozl=v.kod "
    Select+="WHERE "+Filtr+" ORDER BY nr_poz;"
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_SEL'
    # else:
    #     stat="UPR PRZ"


