#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_wzory_dekretacji_faktury.py
# Purpose:		dodaje/pobiera/usuwa wzory dekretacji faktury
# Author:		Micha Raburski
# Created:		2007/02/14
# RCS-ID:		$Id: fs_wzory_dekretacji_faktury.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-09 Mariusz Rajfura  'firma_id' do Warunku dla rsf_klucz_where_new (4873)
# 2011-10-04 Mariusz Rajfura  usuwanie pozycji z chwilowym przenumerowaniem (5082)
# 2019-02-15 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-15 Wojciech Skowron  refaktoryzacja (10389) - obsluga bledow
# 2020-03-23 Wojciech Skowron  kod_gtu (11909)

#WS
# Dowod = klucze[0]
# Nazwa=klucze[1]
# NrPoz=klucze[2]

# Fun=klucze[-1]
dane = []
stat = "OK"

#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,4,5,6], 'Nazwa':[1,4,5,6], 'NrPoz':[4,6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_faktur z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    if Fun in [4,6]:
        NrPoz = klucze['NrPoz']

#WS
# if self.operator_id != STANDARD_OPERATOR_ID:
#     UprDodawanie=(self.oddzial_id,'074123') in self.uprawnienia
#     UprUsuwanie=(self.oddzial_id,'074124') in self.uprawnienia
#     UprPrzegl=(self.oddzial_id,'074120') in self.uprawnienia
# else:
#     UprUsuwanie = UprPrzegl = UprDodawanie =True

#-------------------------------------------------------------------------------
#--- KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS

if Fun in [1,4,5,6] and stat == 'OK':
    if not ((self.oddzial_id,'074120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_PRZ'

if Fun == [1,4] and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_INS'

if Fun == 6 and stat == 'OK':
    if not ((self.oddzial_id,'074124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_DEL'

#-------------------------------------------------------------------------------
#--- DODAWANIE (1)
#-------------------------------------------------------------------------------

if (Fun == 1) and stat == 'OK':
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_faktur','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        Nr = dane[0][0]
        Ins="INSERT INTO rs_wzory_dekretacji_faktur (firma_id,okres_id,dowod_id,nazwa_id,nr_poz) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"',"+str(Nr)+");"
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_DOD'

#-------------------------------------------------------------------------------
#--- KOPIOWANIE (4)
#-------------------------------------------------------------------------------

if (Fun == 4) and stat == 'OK':
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_faktur','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        NrNowy=dane[0][0]
        Kopiuj="INSERT INTO rs_wzory_dekretacji_faktur ( firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+="nr_poz, wyznacznik_id, konto_wn, czy_kontrahent, konto_ma, konto_vat_ma, konto_vat_ma_kor, stawka_vat_ma, warunek, dekretowac, konto_wn_z_kontrahenta, kod_gtu) "  #WS 2020-03-23
        Kopiuj+="SELECT  firma_id, okres_id, dowod_id, nazwa_id,"+str(NrNowy)+", wyznacznik_id, konto_wn, czy_kontrahent,"
        Kopiuj+= " konto_ma, konto_vat_ma, konto_vat_ma_kor, stawka_vat_ma, warunek, dekretowac, konto_wn_z_kontrahenta, kod_gtu " #WS 2020-03-23
        Kopiuj+="FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+NrPoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Kopiuj,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_KOP'

#-------------------------------------------------------------------------------
#--- USUWANIE (6)
#-------------------------------------------------------------------------------

if (Fun == 6) and stat == 'OK':
    NrPoz=float(NrPoz)

    Delete="DELETE FROM rs_wzory_dekretacji_faktur"
    Delete+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Delete+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz = "+str(NrPoz)+"; "

    Update="UPDATE rs_wzory_dekretacji_faktur SET nr_poz = nr_poz+1000"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(NrPoz)+"; "
    Update+="UPDATE rs_wzory_dekretacji_faktur SET nr_poz = nr_poz-1001"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(1000+NrPoz)+"; "

    stat,dump,dump,dump=self.PolSQL.Execute(Delete+Update,1)
    if stat != 'OK':
        #WS 2019-04-15
        stat = 'BL_DEL'
        # stat = 'Bd usuwania pozycji: '+stat

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1,4,5,6)
#-------------------------------------------------------------------------------

if (Fun in [1,4,5,6]) and (stat=='OK'):
    Filtr="firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    Select="SELECT nr_poz,wyznacznik_id,konto_wn,czy_kontrahent,konto_ma,stawka_vat_ma,konto_vat_ma,konto_vat_ma_kor,warunek FROM rs_wzory_dekretacji_faktur WHERE "+Filtr+" ORDER BY nr_poz;"
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_SEL'