# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_faktur_dane.py
# Purpose:     wczytuje/edytuje dane pozycji wzoru dekretacji faktury
#
# Author:      Micha Raburski
# Created:     2007/02/15
# RCS-ID:      $Id: fs_wzory_dekretacji_faktur_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-02-19 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-16 Wojciech Skowron  refaktoryzacja (10389) - sprawdzanie bdw
# 2020-03-23 Wojciech Skowron  kod_gtu (11909)
# 2022-02-11 Wojciech Skowron  dla stawki > 0 konto vat powinno by puste, poprawione spr czy konto vat niepuste (12870)

#klucze = [Przecena,KluczPoz,funkcja]
#Przecena=dowod,nazwa
#KluczPoz=nr_poz

stat='OK'
#WS
# Dowod=rsglobal.Dekoduj(klucze[0][0])
# Nazwa=rsglobal.Dekoduj(klucze[0][1])
# NrP=str(rsglobal.Dekoduj(klucze[1][0]))

#WS
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,3,4,5], 'Nazwa':[1,3,4,5], 'NrPoz':[1,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_faktur_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

    WHERE = " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPoz) #NrP #WS

#-------------------------------------------------------------------------------
#---   KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
    if not (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
# if klucze[-1] in [3,4]:
#     if (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
#     stat = "OK"
    dane = []
    stawka_vat_ma = None  #WS 2022-02-11
    konto_vat_ma = None  #WS 2022-02-11

    #sprawdzenie danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole=="wyznacznik_id":
            if wart == "":
                stat="BR WYZN"
                dane.append(stat)
            else:
                sql = "SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"';"
                #WS 2019-04-16
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL WYZN'
                    dane.append(stat)
                else:
                    if len(d)==0:
                        stat='BL WYZN'
                        dane.append(stat)

        elif pole == "konto_wn":
            if wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL K WN'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K WN'
                            dane.append(stat)

        elif pole == "konto_ma":
            if wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL K MA'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K MA'
                            dane.append(stat)

        elif pole=="stawka_vat_ma":
            if wart == "":
                stat="BR VAT"
                dane.append(stat)
            else:
                sql = "SELECT kod FROM rs_stawki_vat WHERE  kod='"+wart+"';"
                #WS 2019-04-16
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL VAT'
                    dane.append(stat)
                else:
                    if len(d)==0:
                        stat='BL VAT'
                        dane.append(stat)
                    else:
                        stawka_vat_ma = wart.strip()  #WS 2022-02-11

        elif pole == "konto_vat_ma":
            #WS 2022-02-11 - sprawdzenie czy konto niepuste niej
            if wart == "":
                konto_vat_ma = ''
                # stat="BR K VMA"
                # dane.append(stat)
            else:
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL VMA'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K VMA'
                            dane.append(stat)
                        else:
                            konto_vat_ma = wart.strip()  #WS 2022-02-11

        elif pole == "konto_vat_ma_kor":
            if wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL K VMAKOR'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K VMAKOR'
                            dane.append(stat)

    #WS 2022-02-11 - pobranie stawki i konta vat ma jeli nie zostay wyedytowane
    if 'stawka_vat_ma' not in pola or 'konto_vat_ma' not in pola:
        sql = "SELECT COALESCE(stawka_vat_ma, ''), COALESCE(konto_vat_ma, '') FROM rs_wzory_dekretacji_faktur "+WHERE+";"
        stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobrania stawki i konta VAT ma: '+stat
            dane.append(stat)
        else:
            if 'stawka_vat_ma' not in pola:
                stawka_vat_ma = DaneTmp[0][0].strip()
            if 'konto_vat_ma' not in pola:
                konto_vat_ma = DaneTmp[0][1].strip()

    #WS 2022-02-11
    if stawka_vat_ma is not None and stawka_vat_ma == '':
        stat = "BR VAT"
        dane.append(stat)

    #WS 2022-02-11 - konto vat wymagane jeli stawka > 0, jeli 0/zw itp. to ma by puste
    if stawka_vat_ma is not None and konto_vat_ma is not None:
        if stawka_vat_ma.isdigit() and int(stawka_vat_ma) > 0:
            if konto_vat_ma == '':
                stat = "BR K VMA"
                dane.append(stat)
        elif konto_vat_ma != '':
            stat = "NIEPUSTE K VMA"
            dane.append(stat)

    #WS 2022-02-11
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    #Jak ok to update
    if stat=='OK':
        upd = "UPDATE rs_wzory_dekretacji_faktur SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ['wyznacznik_id','konto_wn','konto_ma','stawka_vat_ma','konto_vat_ma','konto_vat_ma_kor','warunek']:
                upd=upd+pole+"='"+str(wart)+"',"
            elif pole in ['czy_kontrahent','dekretowac','konto_wn_z_kontrahenta','kod_gtu']:  #WS 2020-03-23
                upd=upd+pole+"="+str(wart)+","


        upd = upd[0:len(upd)-1]+WHERE+";"
        rsglobal.ZapiszDoLogow(upd,1)
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        #WS 2019-04-16
        if stat != 'OK':
            stat = 'BL UPD'
    # else:
    #     stat='UPR UPD'
   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

#WS
if (Fun in [5,3,1]) and (stat=='OK'):
# if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    # pobranie danych kasy/banku
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wzory_dekretacji_faktur "+WHERE+";",3)
    #WS 2019-04-16
    if stat != 'OK':
        stat = 'BL SEL'
    else:
        # pobranie sownika
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)

            #--- wyznacznik
            if ((self.oddzial_id,'021000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+tr.GetVal(0,"wyznacznik_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #--- stawka vat
            if ((self.oddzial_id,'011120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat_ma")+"';",3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
