# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_klucz.py
# Purpose:     
#
# Author:      Marcin Wlodarczyk
# Created:     2008/08/11
# RCS-ID:      $Id: fs_wzory_dekretacji_klucz.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-07-26 Mariusz Rajfura  nowe pola w kopiowaniu wzoru dekretacji magazynu (4810)
# 2015-02-10 Micha Raburski - (8742) zmiana pl wzorw dekretacji rnic kursowych
# 2019-02-15 Wojciech Skowron - (10389) refaktoryzacja  - klucze w postaci slownika zamiast listy
# 2019-04-16 Wojciech Skowron - (10389) refaktoryzacja  - sprawdzanie bdw
# 2020-03-21 Wojciech Skowron - (11909) pole kod_gtu w rs_wzory_dekretacji_pozycje i _faktur
# 2020-03-30 Wojciech Skowron - (11913) oznaczenia JPK w nagwkach wzorw dekretacji (kopiowanie)
# 2021-02-15 Wojciech Skowron - (12335) kopiowanie wzoru plac
# 2022-02-16 Wojciech Skowron - (12879) kopiowanie warunku z nagwka
# 2024-02-23 Wojciech Skowron - (13700) Sprzeda usug

stat = "OK"
#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1], 'Nazwa':[1], 'Okres':[1], 'DowodStary':[1], 'NazwaStara':[1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_klucz z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    Okres = rsglobal.Dekoduj(klucze['Okres'])
    DowodStary = rsglobal.Dekoduj(klucze['DowodStary'])
    NazwaStara = rsglobal.Dekoduj(klucze['NazwaStara'])

# Dowod = rsglobal.Dekoduj(klucze[0])
# Nazwa = rsglobal.Dekoduj(klucze[1])
# Okres = rsglobal.Dekoduj(klucze[2])
# DowodStary = rsglobal.Dekoduj(klucze[3])
# NazwaStara = rsglobal.Dekoduj(klucze[4])
# Fun = klucze[-1]

    dane = []

    sql = "SELECT okres_id FROM rs_definicje_okresow WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+Okres+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        #WS 2019-04-16
        stat = 'BL SPR OKRES'
        # stat = 'Bd sprawdzenia istnienia okresu: '+stat
    elif len(d)==0:
        stat = 'BL OKRES'

if stat == 'OK': 
    #sprawdzanie czy istnieje juz wzr dekretacji o podanym dowodzie i nazwie
    query ="SELECT COUNT (*) FROM rs_wzory_dekretacji WHERE firma_id='"+str(self.firma_id)+"'"
    query+=" AND okres_id = '"+str(Okres)+"' AND dowod_id = '"+str(Dowod)+"' AND nazwa_id = '"+str(Nazwa)+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(query,3)
    #WS 2019-04-16
    if stat != 'OK':
        stat = 'BL SEL'

    if str(dane) != '[[0]]' and stat =='OK':
        stat = 'BL EXT'
        
if (Fun in [1]) and (stat=='OK'):
    query="INSERT INTO rs_wzory_dekretacji (firma_id,okres_id,dowod_id,nazwa_id,"
    Pola = "nazwa,typ_wzoru,czy_symbol_dok,konto_id,czy_konto_id,mod_konto_id," 
    Pola += "mod_symbol_dok, symbol_dok, czy_data_wyst, czy_data_wplywu, czy_termin_plat, czy_data_zapl, czy_kontrahent_id, "
    Pola += "mod_kontrahent_id, dod_kontrahent, kontrahent_id, czy_rejestr, mod_rejestr, rejestr, czy_data_rejestru, "
    Pola += "oddzial_id, wyznacznik_id, magazyn_id, dokument_id, waluta, ureg_typ, czy_zw, dod_pozycje,"
    Pola += "projekty_podzial, zespol_kont, sumarycznie, "
    Pola += "ozn_trans, czy_ozn_trans, mod_ozn_trans,"  #WS 2020-03-30
    Pola += "ozn_sprzedaz, czy_ozn_sprzedaz, mod_ozn_sprzedaz,"  #WS 2020-03-30
    Pola += "ozn_nabycie, czy_ozn_nabycie, mod_ozn_nabycie, import, "  #WS 2020-03-30
    Pola += "warunek, "  #WS 2022-02-16
    Pola += "sprzedaz_uslug, mod_sprzedaz_uslug "  #WS 2024-02-23
    Select="SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji "
    Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
    query=query+Pola+") "+Select+Where
    stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)
    
    if stat == 'OK':
        query="INSERT INTO rs_wzory_dekretacji_faktur (firma_id,okres_id,dowod_id,nazwa_id,"
        Pola = "nr_poz, wyznacznik_id, konto_wn, czy_kontrahent, konto_ma, konto_vat_ma, stawka_vat_ma, warunek,"
        Pola+="konto_vat_ma_kor, dekretowac, konto_wn_z_kontrahenta, kod_gtu "  #WS 2020-03-21 - kod_gtu
        Select="SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji_faktur "
        Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        query=query+Pola+") "+Select+Where
        stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)
 
    if stat == 'OK':
        query="INSERT INTO rs_wzory_dekretacji_magazynow (firma_id,okres_id,dowod_id,nazwa_id,"
        Pola = "nr_poz, konto_wn, konto_ma, magazyn_id, wyznacznik_id, kontrahent_id, z_wylaczeniem, pozostali, "
        Pola+= "zlecenie_wn, zlecenie_ma, konto_koszt_wn, konto_koszt_ma, magazyn_wn, magazyn_ma, projekt_wn, projekt_ma, czy_zw, " 
        Pola+="magazyn_dokad, magazyn_dokad_wn, magazyn_dokad_ma, "
        Pola+="konto_mag_wn_01, konto_mag_wn_02, konto_mag_wn_03, konto_mag_wn_04, konto_mag_wn_05, "
        Pola+="konto_mag_wn_11, konto_mag_wn_12, konto_mag_wn_21, konto_mag_wn_31, konto_mag_wn_99, "
        Pola+="konto_mag_ma_01, konto_mag_ma_02, konto_mag_ma_03, konto_mag_ma_04, konto_mag_ma_05, "
        Pola+="konto_mag_ma_11, konto_mag_ma_12, konto_mag_ma_21, konto_mag_ma_31, konto_mag_ma_99 "
        Select="SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji_magazynow "
        Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        query=query+Pola+") "+Select+Where
        stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)

    if stat == 'OK':
        query="INSERT INTO rs_wzory_dekretacji_roznice_kursowe (firma_id,okres_id,dowod_id,nazwa_id,"
        Pola = "nr_poz, konto_rozr, konto_przec_dod, konto_przec_uj "
        Select="SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji_roznice_kursowe "
        Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        query=query+Pola+") "+Select+Where
        stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)
        
    if stat == 'OK':
        query="INSERT INTO rs_wzory_dekretacji_pozycje (firma_id,okres_id,dowod_id,nazwa_id,"
        Pola = "nr_poz, czy_symbol_dok, mod_symbol_dok, symbol_dok, czy_data_wyst, czy_data_wplywu, czy_termin_plat, czy_data_zapl, "
        Pola += "czy_kontrahent_id, mod_kontrahent_id, kontrahent_id, czy_konto_wn, mod_konto_wn, konto_wn, czy_konto_vat_wn, mod_konto_vat_wn, " 
        Pola += "konto_vat_wn, mod_stawka_vat_wn, stawka_vat_wn, czy_tresc_wn, mod_tresc_wn, tresc_wn, czy_projekt_wn, mod_projekt_wn, projekt_wn, "
        Pola += "czy_sposob_rozl, mod_sposob_rozl, sposob_rozl, czy_nkup, czy_konto_ma, mod_konto_ma, konto_ma, czy_konto_vat_ma, mod_konto_vat_ma, "
        Pola += "konto_vat_ma, mod_stawka_vat_ma, stawka_vat_ma, czy_tresc_ma, mod_tresc_ma, tresc_ma, czy_projekt_ma, mod_projekt_ma, projekt_ma, czy_pnop,"
        Pola += "zamkniecie_kregu, pobierac_na_rejestr, czy_data_ksieg_kosztow, czy_przeliczac_kwote_ma, kod_gtu "  #WS 2020-03-21 - kod_gtu
        
        Select="SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji_pozycje "
        Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        query=query+Pola+") "+Select+Where
        stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)
        
    if stat == 'OK':
        query="INSERT INTO rs_wzory_dekretacji_przeksiegowan (firma_id,okres_id,dowod_id,nazwa_id,"
        Pola = "nr_poz, konto_bazowe, konto_wn, konto_ma, rodzaj, tresc, ujemne "
        Select="SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji_przeksiegowan "
        Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        query=query+Pola+") "+Select+Where
        stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)

    if stat == 'OK':
        Kopiuj ="INSERT INTO rs_wzory_dekretacji_dostaw ( firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+="nr_poz,konto_ma,konto_wn,konto_vat_wn,stawka_vat_wn,czy_kontrahent,pobierac_na_rejestr,warunek,sposob_rozl  ) "
        Kopiuj+="SELECT  firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',nr_poz, konto_ma, konto_wn, konto_vat_wn, "
        Kopiuj+="stawka_vat_wn, czy_kontrahent, pobierac_na_rejestr, warunek, sposob_rozl "
        Kopiuj+="FROM rs_wzory_dekretacji_dostaw "
        Kopiuj+="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        stat,dump,dump,dump=self.PolSQL.Execute(Kopiuj,1)

    #WS 2021-02-15
    if stat == 'OK':
        query = "INSERT INTO rs_wzory_dekretacji_plac (firma_id,okres_id,dowod_id,nazwa_id,"
        Pola = "nr_poz,strona,konto,czy_dzial,czy_pracownik,czy_zmieniac_znak,skladniki,tresc "
        Select = "SELECT firma_id,'"+Okres+"','"+str(Dowod)+"','"+str(Nazwa)+"',"+Pola+" FROM rs_wzory_dekretacji_plac "
        Where = "WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' AND dowod_id='"+DowodStary+"' AND nazwa_id='"+NazwaStara+"';"
        query=query+Pola+") "+Select+Where
        stat,dane,wyn1,tr = self.PolSQL.Execute(query,1)

    #WS 2019-04-16
    if stat != 'OK':
        stat = 'BL INS'
