#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_wzory_dekretacji_magazynow.py
# Purpose:		dodaje/pobiera/usuwa wzory dekretacji faktury
# Author:		Marcin Grzeda
# Created:		2007/02/14
# RCS-ID:		$Id: fs_wzory_dekretacji_magazynow.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

# 2011-07-26 Mariusz Rajfura  nowe pola w kopiowaniu wzoru dekretacji magazynu (4810)
# 2011-08-09 Mariusz Rajfura  'firma_id' do Warunku dla rsf_klucz_where_new (4873)
# 2019-02-15 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-15 Wojciech Skowron  refaktoryzacja (10389) - obsluga bledow

#WS
# Dowod = klucze[0]
# Nazwa=klucze[1]
# NrPoz=klucze[2]

# Fun=klucze[-1]
dane = []
stat = "OK"

#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,4,5,6], 'Nazwa':[1,4,5,6], 'NrPoz':[4,6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_magazynow z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    if Fun in [4,6]:
        NrPoz = klucze['NrPoz']

#WS
# if self.operator_id != STANDARD_OPERATOR_ID:
#     UprDodawanie = (self.oddzial_id,'074123') in self.uprawnienia
#     UprUsuwanie = (self.oddzial_id,'074124') in self.uprawnienia
#     UprPrzegl = (self.oddzial_id,'074120') in self.uprawnienia
# else:
#     UprUsuwanie = UprPrzegl = UprDodawanie =True

#-------------------------------------------------------------------------------
#--- KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS

if Fun in [1,4,5,6] and stat == 'OK':
    if not ((self.oddzial_id,'074120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_PRZ'

if Fun == [1,4] and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_INS'

if Fun == 6 and stat == 'OK':
    if not ((self.oddzial_id,'074124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_DEL'

#-------------------------------------------------------------------------------
#--- DODAWANIE (1)
#-------------------------------------------------------------------------------

if (Fun == 1) and stat == 'OK':
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_magazynow','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        Nr = dane[0][0]
        rsglobal.ZapiszDoLogow('NR '+str(Nr),1)
        Ins="INSERT INTO rs_wzory_dekretacji_magazynow (firma_id,okres_id,dowod_id,nazwa_id,nr_poz) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"',"+str(Nr)+");"
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_DOD'

#-----------------------------------------------INSERT--------------------------------
#--- KOPIOWANIE (4)
#-------------------------------------------------------------------------------

if (Fun == 4) and stat == 'OK':
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_magazynow','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        NrNowy = dane[0][0]
        rsglobal.ZapiszDoLogow(NrNowy,0)

        Kopiuj="INSERT INTO rs_wzory_dekretacji_magazynow ( firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+="nr_poz, konto_wn, konto_ma, magazyn_id, wyznacznik_id, kontrahent_id, z_wylaczeniem, pozostali, zlecenie_wn, zlecenie_ma,"
        Kopiuj+=" konto_koszt_wn, konto_koszt_ma, magazyn_wn, magazyn_ma, projekt_wn, projekt_ma, czy_zw,"
        Kopiuj+=" konto_mag_wn_01, konto_mag_wn_02, konto_mag_wn_03, konto_mag_wn_04, konto_mag_wn_05,"
        Kopiuj+=" konto_mag_wn_11, konto_mag_wn_12, konto_mag_wn_21, konto_mag_wn_31, konto_mag_wn_99,"
        Kopiuj+=" konto_mag_ma_01, konto_mag_ma_02, konto_mag_ma_03, konto_mag_ma_04, konto_mag_ma_05,"
        Kopiuj+=" konto_mag_ma_11, konto_mag_ma_12, konto_mag_ma_21, konto_mag_ma_31, konto_mag_ma_99 "
        Kopiuj+=") "
        Kopiuj+=" SELECT  firma_id, okres_id, dowod_id, nazwa_id,"+str(NrNowy)+", konto_wn, konto_ma, magazyn_id, wyznacznik_id, kontrahent_id,"
        Kopiuj+=" z_wylaczeniem, pozostali, zlecenie_wn, zlecenie_ma,konto_koszt_wn, konto_koszt_ma, magazyn_wn, "
        Kopiuj+=" magazyn_ma, projekt_wn, projekt_ma, czy_zw, "
        Kopiuj+=" konto_mag_wn_01, konto_mag_wn_02, konto_mag_wn_03, konto_mag_wn_04, konto_mag_wn_05,"
        Kopiuj+=" konto_mag_wn_11, konto_mag_wn_12, konto_mag_wn_21, konto_mag_wn_31, konto_mag_wn_99,"
        Kopiuj+=" konto_mag_ma_01, konto_mag_ma_02, konto_mag_ma_03, konto_mag_ma_04, konto_mag_ma_05,"
        Kopiuj+=" konto_mag_ma_11, konto_mag_ma_12, konto_mag_ma_21, konto_mag_ma_31, konto_mag_ma_99 "
        Kopiuj+=" FROM rs_wzory_dekretacji_magazynow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+NrPoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Kopiuj,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_KOP'

#-------------------------------------------------------------------------------
#--- USUWANIE (6)
#-------------------------------------------------------------------------------

if (Fun == 6) and stat == 'OK':
    Delete="DELETE FROM rs_wzory_dekretacji_magazynow WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz = "+NrPoz+";"
    #WS 2019-04-15
    # st,dump,dump,dump=self.PolSQL.Execute(Delete,1)
    Update="UPDATE rs_wzory_dekretacji_magazynow SET nr_poz=nr_poz-1 WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+NrPoz+";"
    stat,dump,dump,dump=self.PolSQL.Execute(Delete+Update,1)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_DEL'

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1,4,5,6)
#-------------------------------------------------------------------------------

if (Fun in [1,4,5,6]) and (stat == 'OK'):
    Filtr="firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    Select="SELECT nr_poz,konto_wn,konto_ma,magazyn_id,wyznacznik_id,kontrahent_id,z_wylaczeniem,pozostali,zlecenie_wn,zlecenie_ma,konto_koszt_wn,konto_koszt_ma,magazyn_wn,magazyn_ma,projekt_wn,projekt_ma FROM rs_wzory_dekretacji_magazynow WHERE "+Filtr+" ORDER BY nr_poz;"
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_SEL'