#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_wzory_dekretacji_plac.py
# Purpose:		dodaje/pobiera/usuwa wzory dekretacji pac
# Author:		Wojciech Skowron
# Created:		2019/05/15
# RCS-ID:		$Id: fs_wzory_dekretacji_plac.py $
# Copyright:	(c) 2019 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

stat = "OK"
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,4,5,6], 'Nazwa':[1,4,5,6], 'NrPoz':[4,6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_plac z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    if Fun in [4,6]:
        NrPoz = klucze['NrPoz']

#-------------------------------------------------------------------------------
#--- KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in [1,4,5,6] and stat == 'OK':
    if not ((self.oddzial_id,'074120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_PRZ'

if Fun == [1,4] and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_INS'

if Fun == 6 and stat == 'OK':
    if not ((self.oddzial_id,'074124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_DEL'

#-------------------------------------------------------------------------------
#--- DODAWANIE (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 1:
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_plac','"+Warunek+"','nr_poz');",3)
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        Nr = dane[0][0]
        Ins="INSERT INTO rs_wzory_dekretacji_plac (firma_id,okres_id,dowod_id,nazwa_id,nr_poz) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"',"+str(Nr)+");"
        rsglobal.ZapiszDoLogow(Ins,5)
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        if stat != 'OK':
            stat = 'BL_INS_DOD'

#-------------------------------------------------------------------------------
#--- USUWANIE (6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 6:
    NrPoz = float(NrPoz)

    Delete ="DELETE FROM rs_wzory_dekretacji_plac"
    Delete+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Delete+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz = "+str(NrPoz)+"; "

    Update ="UPDATE rs_wzory_dekretacji_plac SET nr_poz = nr_poz+1000"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(NrPoz)+"; "
    Update+="UPDATE rs_wzory_dekretacji_plac SET nr_poz = nr_poz-1001"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(1000+NrPoz)+"; "

    rsglobal.ZapiszDoLogow(Delete+'\n'+Update,5)
    stat,dump,dump,dump=self.PolSQL.Execute(Delete+Update,1)
    if stat != 'OK':
        stat = 'BL_DEL'

#-------------------------------------------------------------------------------
#--- KOPIOWANIE (4)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 4:
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_plac','"+Warunek+"','nr_poz');",3)
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        NrNowy=dane[0][0]
        Kopiuj= "INSERT INTO rs_wzory_dekretacji_plac (firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+="nr_poz, strona, konto, czy_dzial, czy_pracownik, czy_zmieniac_znak, skladniki) "
        Kopiuj+="SELECT firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+=str(NrNowy)+", strona, konto, czy_dzial, czy_pracownik, czy_zmieniac_znak, skladniki "
        Kopiuj+="FROM rs_wzory_dekretacji_plac WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+NrPoz+";"
        rsglobal.ZapiszDoLogow(Kopiuj,5)
        stat,dump,dump,dump=self.PolSQL.Execute(Kopiuj,1)
        if stat != 'OK':
            stat = 'BL_INS_KOP'

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1,4,5,6)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in [1,4,5,6]:
    Filtr="firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"

    Select= "SELECT nr_poz, strona, konto, czy_dzial, czy_pracownik, czy_zmieniac_znak, skladniki "
    Select+="FROM rs_wzory_dekretacji_plac "
    Select+="WHERE "+Filtr+" ORDER BY nr_poz;"
    rsglobal.ZapiszDoLogow(Select,5)
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
    if stat != 'OK':
        stat = 'BL_SEL'


