# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_plac_dane.py
# Purpose:     wczytuje/edytuje dane pozycji wzoru dekretacji pac
# Author:      Wojciech Skowron
# Created:     2019/05/15
# RCS-ID:      $Id: fs_wzory_dekretacji_plac_dane.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,2,3,4,5,9], 'Nazwa':[1,2,3,4,5,9], 'NrPoz':[1,2,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_plac_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    if Fun in [1,2,3,4,5]:
        NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

    if Fun in [1,2,3,4,5]:
        WHERE = " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPoz)

#-------------------------------------------------------------------------------
#---   KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat == 'OK':
    if not (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH PRZED INSERT/UPDATE
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat == 'OK':
    dane = []

    #sprawdzenie danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == "strona":
            if wart != "":
                stat = 'OK' if wart in ('W', 'M') else 'BLAD'
                if stat != 'OK':
                    stat = 'BL STRONA'
                    dane.append(stat)

        elif pole == "konto":
            if wart != "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    stat = 'BL SQL KONTO'
                else:
                    if d in ([], None) or d[0][0][0] == '':
                        stat = 'BL KONTO'
                        dane.append(stat)

        elif pole == "skladniki":
            if wart != "":
                skladniki = wart.split(",")
                for skladnik in skladniki:
                    sql = "SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE skladnik_id='"+skladnik.strip()+"';"
                    stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                    if stat != 'OK':
                        stat = 'BL SQL SKLADNIKI'
                        break
                    else:
                        if (d in ([], None) or d[0][0] == '') and skladnik != '':
                            stat = 'Nieprawidowy skadnik: '+skladnik
                            dane.append(stat)

#-------------------------------------------------------------------------------
#---   INSERT  (1- pobraniem  2- bez pobrania)
#-------------------------------------------------------------------------------

    if stat == 'OK' and Fun in [1,2]:
        insertpola = "firma_id,okres_id,dowod_id,nazwa_id,nr_poz,"+",".join(pola)
        insertwart = "'"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"',"+str(NrPoz)
        for i, pole in enumerate(pola):
            if pole in ['strona','konto','skladniki','tresc']:
                insertwart += ",'"+str(wartosci[i])+"'"
            elif pole in ['czy_dzial','czy_pracownik','czy_zmieniac_znak']:
                insertwart += ","+str(wartosci[i])

        ins = "INSERT INTO rs_wzory_dekretacji_plac ("+insertpola+") VALUES ("+insertwart+");"

        rsglobal.ZapiszDoLogow(ins,5)
        stat,dump,dump,dump = self.PolSQL.Execute(ins,1)
        if stat != 'OK':
            stat = 'BL INS'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobraniem, 4- bez pobrania)
#-------------------------------------------------------------------------------

    if stat == 'OK' and Fun in [3,4]:
        upd = "UPDATE rs_wzory_dekretacji_plac SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ['strona','konto','skladniki','tresc']:
                upd=upd+pole+"='"+str(wart)+"',"
            elif pole in ['czy_dzial','czy_pracownik','czy_zmieniac_znak']:
                upd=upd+pole+"="+str(wart)+","

        upd = upd[0:len(upd)-1]+WHERE+";"
        rsglobal.ZapiszDoLogow(upd,5)
        stat,dump,dump,dump = self.PolSQL.Execute(upd,1)
        if stat != 'OK':
            stat = 'BL UPD'

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1 -insert z pobraniem, 3 -update z pobraniem, 5 -select)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in [1,3,5]:
    SQL= "SELECT strona, konto, czy_dzial, czy_pracownik, czy_zmieniac_znak, skladniki, tresc "
    SQL+="FROM rs_wzory_dekretacji_plac "+WHERE+";"
    rsglobal.ZapiszDoLogow(SQL,5)
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'BL SEL'

#-------------------------------------------------------------------------------
#---   POBRANIE NOWEGO NUMERU POZYCJI
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 9:
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_plac','"+Warunek+"','nr_poz');",3)
    if stat != 'OK':
        stat = 'BL POBR NR'