#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_wzory_dekretacji_pozycje.py
# Purpose:		dodaje/pobiera/usuwa pozycje wzoru dekretacji
# Author:		Dariusz Boduch
# Created:		2008/06/16
# RCS-ID:		$Id: fs_wzory_dekretacji_pozycje.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------
# modyikacja 2009/08/05  mariusz rajfura  mantis:1513 uzupelnione pola przy kopiowaniu
# modyikacja 2009/08/11  mariusz rajfura  mantis:2366 kopiowanie z wyborem miejsca wklejenia
# 2019-02-18 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, sprawdzenie uprawnien do przegladania
# 2019-04-15 Wojciech Skowron  refaktoryzacja (10389) - obsluga bledow
# 2020-03-21 Wojciech Skowron - pole kod_gtu (11909)

#WS
# Dowod = rsglobal.Dekoduj(klucze[0]).strip()
# Nazwa = rsglobal.Dekoduj(klucze[1]).strip()
# NrPoz = klucze[2]
#
# Fun = klucze[-1]
stat = "OK"
dane = []
wyn1 = []

#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,4,6], 'Nazwa':[1,4,6], 'NrPoz':[4,6], 'NowyNr':[4]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_pozycje z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    if Fun in [4,6]:
        NrPoz = klucze['NrPoz']
    if Fun == 4:
        NowyNr = klucze['NowyNr']

#-------------------------------------------------------------------------------
#--- KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if not ((self.oddzial_id,'074120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_PRZ'

if Fun == 4 and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_INS'

if Fun == 6 and stat == 'OK':
    if not ((self.oddzial_id,'074124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_DEL'

#-------------------------------------------------------------------------------
#--- USUWANIE (6)
#-------------------------------------------------------------------------------

if (Fun == 6) and (stat == 'OK'):
    NrPoz = float(NrPoz)
    
    Delete ="DELETE FROM rs_wzory_dekretacji_pozycje"
    Delete+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Delete+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz = "+str(NrPoz)+"; "
    
    Update ="UPDATE rs_wzory_dekretacji_pozycje SET nr_poz = nr_poz+1000"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(NrPoz)+"; "
    Update+="UPDATE rs_wzory_dekretacji_pozycje SET nr_poz = nr_poz-1001"
    Update+=" WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    Update+=" AND dowod_id = '"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz > "+str(1000+NrPoz)+"; "
    
    stat,dump,dump,dump=self.PolSQL.Execute(Delete+Update,1)
    if stat<>'OK':
        #WS 2019-04-15
        stat = 'BL_DEL'
        # stat = 'Bd usuwania pozycji: '+stat

#-------------------------------------------------------------------------------
#--- KOPIOWANIE (4)
#-------------------------------------------------------------------------------

if (Fun == 4) and (stat == 'OK'):
    NrPoz = int(NrPoz)
    # NowyNr = klucze[3] #WS
    sqlrenum1 = ''
    sqlrenum2 = ''
    
    if NowyNr == 0:
        stat = 'BL_NR_POZ'
        # stat = 'Nr pozycji, pod ktry wklei nowy dekret musi by wikszy od 0.'
        dane.append(stat)

    if stat == 'OK':
        sql ="SELECT max(nr_poz) FROM rs_wzory_dekretacji_pozycje"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        sql+=" AND dowod_id = '"+Dowod+"' AND nazwa_id = '"+Nazwa+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            #WS 2019-04-15
            stat = 'BL_POBR_NR'
            # stat = 'Bd pobrania maksymalnego numeru pozycji dla wzoru dekretacji : '+stat
            dane.append(stat)
        else:
            if NowyNr > d[0][0]+1:
                stat = 'Nr pozycji nie moe by wiekszy ni '+str(d[0][0]+1).split('.')[0]
                dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT nr_poz FROM rs_wzory_dekretacji_pozycje"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        sql+=" AND dowod_id = '"+Dowod+"' AND nazwa_id = '"+Nazwa+"'"
        sql+=" AND nr_poz = "+str(NrPoz)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            #WS 2019-04-15
            stat = 'BL_SEL_KOP'
            # stat = 'Bd pobrania pozycji dla wzoru dekretacji : '+stat
            dane.append(stat)
        else:
            if len(d) > 0:
                sqlrenum1 =" UPDATE rs_wzory_dekretacji_pozycje SET nr_poz = nr_poz + 1000"
                sqlrenum1+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                sqlrenum1+=" AND dowod_id = '"+Dowod+"' AND nazwa_id = '"+Nazwa+"'"
                sqlrenum1+=" AND nr_poz >= "+str(NowyNr)+"; "
            
                sqlrenum2 =" UPDATE rs_wzory_dekretacji_pozycje SET nr_poz = nr_poz - 999"
                sqlrenum2+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                sqlrenum2+=" AND dowod_id = '"+Dowod+"' AND nazwa_id = '"+Nazwa+"'"
                sqlrenum2+=" AND nr_poz > "+str(NowyNr)+"; "

    if stat == 'OK':  
        Insert ="firma_id,okres_id,dowod_id,nazwa_id,nr_poz,czy_symbol_dok, mod_symbol_dok,symbol_dok,"
        Insert+="czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,czy_kontrahent_id,"
        Insert+="mod_kontrahent_id,kontrahent_id,czy_konto_wn,mod_konto_wn,konto_wn,czy_konto_vat_wn,"
        Insert+="mod_konto_vat_wn,konto_vat_wn,mod_stawka_vat_wn,stawka_vat_wn,czy_tresc_wn,"
        Insert+="mod_tresc_wn,tresc_wn,czy_projekt_wn,mod_projekt_wn,projekt_wn,czy_sposob_rozl,"
        Insert+="mod_sposob_rozl,sposob_rozl,czy_nkup,czy_konto_ma,mod_konto_ma,konto_ma,czy_konto_vat_ma,"
        Insert+="mod_konto_vat_ma,konto_vat_ma,mod_stawka_vat_ma,stawka_vat_ma,czy_tresc_ma,mod_tresc_ma,"
        Insert+="tresc_ma,czy_projekt_ma,mod_projekt_ma,projekt_ma,czy_pnop,zamkniecie_kregu,pobierac_na_rejestr,"
        Insert+="czy_data_ksieg_kosztow,czy_przeliczac_kwote_ma,kod_gtu"  #WS 2020-03-21 - kod_gtu

        Select ="firma_id,okres_id,dowod_id,nazwa_id,"+str(NowyNr)+",czy_symbol_dok, mod_symbol_dok,symbol_dok,"
        Select+="czy_data_wyst,czy_data_wplywu,czy_termin_plat,czy_data_zapl,czy_kontrahent_id,"
        Select+="mod_kontrahent_id,kontrahent_id,czy_konto_wn,mod_konto_wn,konto_wn,czy_konto_vat_wn,"
        Select+="mod_konto_vat_wn,konto_vat_wn,mod_stawka_vat_wn,stawka_vat_wn,czy_tresc_wn,"
        Select+="mod_tresc_wn,tresc_wn,czy_projekt_wn,mod_projekt_wn,projekt_wn,czy_sposob_rozl,"
        Select+="mod_sposob_rozl,sposob_rozl,czy_nkup,czy_konto_ma,mod_konto_ma,konto_ma,czy_konto_vat_ma,"
        Select+="mod_konto_vat_ma,konto_vat_ma,mod_stawka_vat_ma,stawka_vat_ma,czy_tresc_ma,mod_tresc_ma,"
        Select+="tresc_ma,czy_projekt_ma,mod_projekt_ma,projekt_ma,czy_pnop,zamkniecie_kregu,pobierac_na_rejestr,"
        Select+="czy_data_ksieg_kosztow,czy_przeliczac_kwote_ma,kod_gtu"  #WS 2020-03-21 - kod_gtu
        
        #jesli pozycja zrodlowa ulegnie przenumerowaniu, bo stanie sie pozniejsza niz nowo wstawiana,
        #to musimy uwzglednic jej zmieniony numer przy pobieraniu danych do inserta
        if NowyNr <= NrPoz:
            NrPoz += 1000

        SQL =sqlrenum1
        SQL+="INSERT INTO rs_wzory_dekretacji_pozycje ("+Insert+") SELECT "+Select
        SQL+=" FROM rs_wzory_dekretacji_pozycje"
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND dowod_id = '"+Dowod+"'"
        SQL+=" AND nazwa_id = '"+Nazwa+"' AND nr_poz = "+str(NrPoz)+";"
        SQL+=sqlrenum2
        
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat != 'OK':
            #WS 2019-04-15
            stat = 'BL_INS_KOP'
            # stat = 'Bd kopiowania pozycji: '+stat
        
#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1,4,6)
#-------------------------------------------------------------------------------

if (stat == 'OK') and (Fun in [1,4,6]):
    sql ="SELECT nr_poz,konto_wn,tresc_wn,konto_vat_wn,konto_ma,tresc_ma,konto_vat_ma"
    sql+=" FROM rs_wzory_dekretacji_pozycje"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    sql+=" AND dowod_id = '"+Dowod+"' AND nazwa_id = '"+Nazwa+"' ORDER BY nr_poz;"        
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        #WS 2019-04-15
        stat = 'BL_SEL_POBR'
        # stat = 'Bd pobrania listy pozycji dla wzoru dekretacji : '+stat
