# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_dane.py
# Purpose:     dodawanie/edycja pozycji wzoru dekretacji
#
# Author:      Mariusz Rajfura
# Created:     2009/07/30
# RCS-ID:      $Id: fs_wzory_dekretacji_pozycje_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-08 Mariusz Rajfura  'firma_id' do Warunku dla rsf_klucz_where_new (4873)
# 2018-10-16 Aleksander Bargie (11260) - Wzory dekretacji - pusty string w kontrahent_id
# 2019-02-19 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy
# 2019-04-16 Wojciech Skowron  refaktoryzacja (10389) - sprawdzanie bdw

stat = 'OK'
#WS
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,2,3,4,5,9], 'Nazwa':[1,2,3,4,5,9], 'NrPoz':[1,2,3,4,5,9]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_pozycje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    DowodId = rsglobal.Dekoduj(klucze['Dowod'])
    NazwaId = rsglobal.Dekoduj(klucze['Nazwa'])
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

# DowodId = rsglobal.Dekoduj(klucze[0]).strip()
# NazwaId = rsglobal.Dekoduj(klucze[1]).strip()
# NrPoz = rsglobal.Dekoduj(klucze[2])

# Fun = klucze[-1]
dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2,9) and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR_UPR_INS'
        dane.append(stat)
        
if Fun in (3,4) and stat == 'OK':
    if not ((self.oddzial_id,'074122') in self.uprawnienia or (self.oddzial_id,'074123') in self.uprawnienia or \
            self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR_UPR_UPD'
        dane.append(stat)

#-------------------------------------------------------------------------------

sqlrenum1 = ''
sqlrenum2 = ''

if stat == 'OK' and Fun in (1,2):
    if NrPoz == 0:
        stat = 'BL_POZYCJA'
        dane.append(stat)

    if stat == 'OK':
        sql ="SELECT max(nr_poz) FROM rs_wzory_dekretacji_pozycje"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            #WS 2019-04-15
            stat = 'BL_POBR_MAX_NR'
            # stat = 'Bd pobrania maksymalnego numeru pozycji dla wzoru dekretacji : '+stat
            dane.append(stat)
        else:
            if NrPoz > d[0][0]+1:
                stat = 'Nr pozycji nie moe by wiekszy ni '+str(d[0][0]+1).split('.')[0]
                dane.append(stat)
        
    if stat == 'OK':
        sql ="SELECT nr_poz FROM rs_wzory_dekretacji_pozycje"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"'"
        sql+=" AND nr_poz = "+str(NrPoz)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            #WS 2019-04-15
            stat = 'BL_POBR_NR'
            # stat = 'Bd pobrania pozycji dla wzoru dekretacji : '+stat
            dane.append(stat)
        else:
            if len(d) > 0:
                sqlrenum1 =" UPDATE rs_wzory_dekretacji_pozycje SET nr_poz = nr_poz + 1000"
                sqlrenum1+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                sqlrenum1+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"'"
                sqlrenum1+=" AND nr_poz >= "+str(NrPoz)+"; "
                
                sqlrenum2 =" UPDATE rs_wzory_dekretacji_pozycje SET nr_poz = nr_poz - 999"
                sqlrenum2+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                sqlrenum2+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"'"
                sqlrenum2+=" AND nr_poz > "+str(NrPoz)+"; "

if stat == 'OK':
    #zmienne dla INSERT, UPDATE zainicjowane, ze wzgledu na zasieg
    sqlinsertpola = "firma_id,okres_id,dowod_id,nazwa_id,nr_poz"
    sqlinsertwart = "'"+self.firma_id+"','"+self.okres_id+"','"+DowodId+"','"+NazwaId+"',"+str(NrPoz)
    sqlupdate = ''

if stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ('symbol_dok','konto_wn','konto_ma','konto_vat_wn','konto_vat_ma','tresc_wn','tresc_ma'):
            wart = "'"+wart+"'"
        
        elif pole == 'kontrahent_id':
            #AB 16.10.18r
            if wart.strip() == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"            
                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    #WS 2019-04-16
                    # dane.append('Bd pobrania danych kontrahenta : '+stat)
                    stat = 'BL_SQL_KONTRAH'
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-16
                        stat = 'BL_KONTRAH'
                        dane.append(stat)
                        # dane.append('BL_KONTRAH')
        
        #UWAGA: sposob_rozl == '' oznacza, ze 'NIE PODLEGA'
        elif pole == 'sposob_rozl':
            wart = "'"+wart+"'"            
            sql ="SELECT kod FROM rs_sposob_rozl_vat WHERE kod = "+wart+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql,2)
            if stat <> 'OK':
                #WS 2019-04-16
                # dane.append('Bd pobrania danych sposobu rozliczenia VAT: '+stat)
                stat = 'BL_SQL_SPOS_ROZL'
                dane.append(stat)
            else:
                if len(d) == 0:
                    #WS 2019-04-16
                    stat = 'BL_SPOS_ROZL'
                    dane.append(stat)
                    # dane.append('BL_SPOS_ROZL')

        elif pole == 'stawka_vat_wn':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_stawki_vat WHERE kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    #WS 2019-04-16
                    # dane.append('Bd pobrania stawki VAT wn : '+stat)
                    stat = 'BL_SQL_ST_VAT_WN'
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-16
                        stat = 'BL_ST_VAT_WN'
                        dane.append(stat)
                        # dane.append('BL_ST_VAT_WN')
        
        elif pole == 'projekt_wn':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT projekt_id FROM rs_projekty WHERE firma_id = '"+self.firma_id+"' AND projekt_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    #WS 2019-04-16
                    # dane.append('Bd pobrania projektu wn : '+stat)
                    stat = 'BL_SQL_PROJ_WN'
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-16
                        stat = 'BL_PROJ_WN'
                        dane.append(stat)
                        # dane.append('BL_PROJ_WN')

        elif pole == 'stawka_vat_ma':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT kod FROM rs_stawki_vat WHERE kod = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    #WS 2019-04-16
                    # dane.append('Bd pobrania stawki VAT ma : '+stat)
                    stat = 'BL_SQL_ST_VAT_MA'
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-16
                        stat = 'BL_ST_VAT_MA'
                        dane.append(stat)
                        # dane.append('BL_ST_VAT_MA')
        
        elif pole == 'projekt_ma':
            if wart == '':
                wart = 'NULL'
            else:
                wart = "'"+wart+"'"
                sql ="SELECT projekt_id FROM rs_projekty WHERE firma_id = '"+self.firma_id+"' AND projekt_id = "+wart+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    #WS 2019-04-16
                    # dane.append('Bd pobrania projektu ma : '+stat)
                    stat = 'BL_SQL_PROJ_MA'
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        #WS 2019-04-16
                        stat = 'BL_PROJ_MA'
                        dane.append(stat)
                        # dane.append('BL_PROJ_MA')
        
        if type(wart) == type(True):               
            if wart:
                wart = 'True'
            else:
                wart = 'False'
        
        #wylaczenie pol kluczowych
        if not pole in ('dowod_id','nazwa_id','nr_poz'):
            #pola kluczowe dla INSERT ustawione przed petla
            if Fun in (1,2):
                if (i > 0) and (i < len(pola)) :
                    sqlinsertpola += ','
                    sqlinsertwart += ','
            
                sqlinsertpola += pole
                sqlinsertwart += wart
                
            #pola kluczowe dla UPDATE do zmiany bed ewent. w funkcji ZMIANA_KLUCZA/POZYCJI
            elif Fun in (3,4):
                if sqlupdate <> '':
                    sqlupdate += ','
                sqlupdate += pole+" = " +wart
                        
    if len(dane) > 0:
        stat = dane[0]
        
#-------------------------------------------------------------------------------
# INSERT   1 - pobraniem  2-bez pobrania
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,2):
    sql = sqlrenum1
    sql+="INSERT INTO rs_wzory_dekretacji_pozycje ("+sqlinsertpola+") VALUES ("+sqlinsertwart+");"
    sql+=sqlrenum2
    stat,d,dump,dump = self.PolSQL.Execute(sql,1)
    if stat <> 'OK':
        #WS 2019-04-16
        stat = 'BL_INS'
        dane.append(stat)
        # dane.append('Bd dodawania nowej pozycji do wzoru dekretacji : '+stat)
            
#-------------------------------------------------------------------------------
# UPDATE   3 - pobraniem  4-bez pobrania
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3,4):
    sql ="UPDATE rs_wzory_dekretacji_pozycje SET "+sqlupdate
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"' AND nr_poz = "+str(NrPoz)+";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,1)
    if stat <> 'OK':
        #WS 2019-04-16
        stat = 'BL_UPD'
        dane.append(stat)
        # dane.append('Bd modyfikacji pozycji wzoru dekretacji : '+stat)

#-------------------------------------------------------------------------------
# Fun == 9 , Pobranie nowego numeru pozycji
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 9:
    Warunek ="firma_id=''"+self.firma_id+"'' AND okres_id = ''"+self.okres_id+"''"
    Warunek+=" AND dowod_id = ''"+str(DowodId)+"'' AND nazwa_id = ''"+str(NazwaId)+"''"
    sql ="SELECT rsf_klucz_where_new('rs_wzory_dekretacji_pozycje','"+Warunek+"','nr_poz');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        #WS 2019-04-16
        stat = 'BL_POBR_NOWY_NR'
        dane.append(stat)
        # stat = 'Bd pobrania nowego numeru pozycji dla wzoru dekretacji : '+stat

#-------------------------------------------------------------------------------
# SELECT 1,3,5
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1,3,5):
    sql ="SELECT * FROM rs_wzory_dekretacji_pozycje"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    sql+=" AND dowod_id = '"+DowodId+"' AND nazwa_id = '"+NazwaId+"' AND nr_poz = "+str(NrPoz)+";"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        #WS 2019-04-16
        stat = 'BL_SEL'
        dane.append(stat)
        # stat = 'Bd pobrania danych pozycji wzoru dekretacji : '+stat
        
    #pobranie opisow slownikowych zgodnie z uprawnieniami
    Kontrahent = ''
    SposobRozl = ''
    StawkaVatWn = ''
    ProjektWn = ''
    StawkaVatMa = ''
    ProjektMa = ''
    
    if stat == 'OK' and len(dane) > 0:
        for i in range(len(wyn1)):
            if wyn1[i][0] == 'kontrahent_id':
                if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT nazwa FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kontrahent_id = '"+str(dane[0][i])+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        Kontrahent = 'Bd pobrania opisu kontrahenta : '+stat
                    else:
                        if len(d) == 1:
                            Kontrahent = d[0][0]
                else:
                    Kontrahent = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif wyn1[i][0] == 'sposob_rozl':
                if (self.oddzial_id,'011210') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT opis FROM rs_sposob_rozl_vat WHERE kod = '"+str(dane[0][i])+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        SposobRozl = 'Bd pobrania opisu sposobu rozliczenia VAT : '+stat
                    else:
                        if len(d) == 1:
                            SposobRozl = d[0][0]
                else:
                    SposobRozl = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif wyn1[i][0] == 'stawka_vat_wn':
                if (self.oddzial_id,'011120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT opis FROM rs_stawki_vat WHERE kod = '"+str(dane[0][i])+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        StawkaVatWn = 'Bd pobrania opisu stawki VAT wn : '+stat
                    else:
                        if len(d) == 1:
                            StawkaVatWn = d[0][0]
                else:
                    StawkaVatWn = 'Brak uprawnie do sownika. Poinformuj administratora.'
            
            elif wyn1[i][0] == 'projekt_wn':
                if (self.oddzial_id,'027000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT opis FROM rs_projekty WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND projekt_id = '"+str(dane[0][i])+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        ProjektWn = 'Bd pobrania opisu projektu wn : '+stat
                    else:
                        if len(d) == 1:
                            ProjektWn = d[0][0]
                else:
                    ProjektWn = 'Brak uprawnie do sownika. Poinformuj administratora.'
                    
            elif wyn1[i][0] == 'stawka_vat_ma':
                if (self.oddzial_id,'011120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT opis FROM rs_stawki_vat WHERE kod = '"+str(dane[0][i])+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        StawkaVatMa = 'Bd pobrania opisu stawki VAT ma : '+stat
                    else:
                        if len(d) == 1:
                            StawkaVatMa = d[0][0]
                else:
                    StawkaVatMa = 'Brak uprawnie do sownika. Poinformuj administratora.'
                    
            elif wyn1[i][0] == 'projekt_ma':
                if (self.oddzial_id,'027000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT opis FROM rs_projekty WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND projekt_id = '"+str(dane[0][i])+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if stat <> 'OK':
                        ProjektMa = 'Bd pobrania opisu projektu ma : '+stat
                    else:
                        if len(d) == 1:
                            ProjektMa = d[0][0]
                else:
                    ProjektMa = 'Brak uprawnie do sownika. Poinformuj administratora.'

    wyn2 = [Kontrahent,SposobRozl,StawkaVatWn,ProjektWn,StawkaVatMa,ProjektMa]
