#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_wzory_dekretacji_roznice_kursowe.py
# Purpose:		dodaje/pobiera/usuwa wzory dekretacji rnic kursowych
# Author:		Micha Raburski
# Created:		2013/10/17
# RCS-ID:		$Id: fs_wzory_dekretacji_roznice_kursowe.py $
# Copyright:	(c) 2013 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

# 2015-02-10 Micha Raburski - (8742) zmiana pl wzorw dekretacji rnic kursowych
# 2019-02-18 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-15 Wojciech Skowron  refaktoryzacja (10389) - obsluga bledow

#WS
# Dowod = klucze[0]
# Nazwa=klucze[1]
# NrPoz=klucze[2]
#
# Fun=klucze[-1]
stat = "OK"
dane = []

#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,4,5,6], 'Nazwa':[1,4,5,6], 'NrPoz':[4,6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_roznice_kursowe z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = klucze['Dowod']
    Nazwa = klucze['Nazwa']
    if Fun in [4,6]:
        NrPoz = klucze['NrPoz']

#WS
# if self.operator_id != STANDARD_OPERATOR_ID:
#     UprDodawanie=(self.oddzial_id,'074123') in self.uprawnienia
#     UprUsuwanie=(self.oddzial_id,'074124') in self.uprawnienia
#     UprPrzegl=(self.oddzial_id,'074120') in self.uprawnienia
# else:
#     UprUsuwanie = UprPrzegl = UprDodawanie =True

#-------------------------------------------------------------------------------
#--- KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS

if Fun in [1,4,5,6] and stat == 'OK':
    if not ((self.oddzial_id,'074120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_PRZ'

if Fun == [1,4] and stat == 'OK':
    if not ((self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_INS'

if Fun == 6 and stat == 'OK':
    if not ((self.oddzial_id,'074124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR_DEL'

#-------------------------------------------------------------------------------
#--- DODAWANIE (1)
#-------------------------------------------------------------------------------

if (Fun == 1) and stat == 'OK':
    #WS
    # if not UprDodawanie:
    #     stat="UPR INS"
    
    # if stat =='OK':
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    st,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_roznice_kursowe','"+Warunek+"','nr_poz');",3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_POBR_NR'
    else:
        Nr = dane[0][0]
        Ins="INSERT INTO rs_wzory_dekretacji_roznice_kursowe (firma_id,okres_id,dowod_id,nazwa_id,nr_poz) VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"',"+str(Nr)+");"
        stat,dump,dump,dump=self.PolSQL.Execute(Ins,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_DOD'
    
#-------------------------------------------------------------------------------
#--- USUWANIE (6)
#-------------------------------------------------------------------------------

if (Fun == 6) and stat == 'OK':
    #WS
    # if not UprUsuwanie:
    #     stat="UPR DEL"
    
    # if stat == 'OK':
    Del ="DELETE FROM rs_wzory_dekretacji_roznice_kursowe"
    Del+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    Del+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+NrPoz+";"

    #WS 2019-04-16
    # stat,dump,dump,dump=self.PolSQL.Execute(Del,1)
    # if stat <> 'OK':
    #     #WS 2019-04-15
    #     stat = 'BL_DEL'
    #     # stat = 'Bd usuwania pozycji dekretacji: '+stat
    #     dane.append(stat)
    #
    # if stat == 'OK':
    #przenumerowanie pozostalych pozycji
    Upd ="UPDATE rs_wzory_dekretacji_roznice_kursowe SET nr_poz=nr_poz+1000"
    Upd+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    Upd+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz>"+NrPoz+";"
    Upd+="UPDATE rs_wzory_dekretacji_roznice_kursowe SET nr_poz=nr_poz-1001"
    Upd+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    Upd+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz>"+NrPoz+";"

    #WS 2019-04-16
    stat,dump,dump,dump=self.PolSQL.Execute(Del+Upd,1)
    # stat,dump,dump,dump=self.PolSQL.Execute(Upd,1)
    if stat <> 'OK':
        #WS 2019-04-15
        stat = 'BL_DEL'
        # stat = 'Bd przenumerowania pozycji wzoru dekretacji.'
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- KOPIOWANIE (4)
#-------------------------------------------------------------------------------

if (Fun == 4) and stat == 'OK':
    #WS
    # if not UprDodawanie:
    #     stat="UPR INS"
        
    # if stat == 'OK':
    Warunek ="firma_id=''"+self.firma_id+"''"
    Warunek+=" AND okres_id=''"+self.okres_id+"'' AND dowod_id=''"+Dowod+"''"
    Warunek+=" AND nazwa_id=''"+Nazwa+"''"
    stat,dane,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_wzory_dekretacji_roznice_kursowe','"+Warunek+"','nr_poz');",3)
        
    if stat == 'OK':
        NrNowy=dane[0][0]
        Kopiuj="INSERT INTO rs_wzory_dekretacji_roznice_kursowe (firma_id, okres_id, dowod_id, nazwa_id, "
        Kopiuj+="nr_poz, konto_rozr, konto_przec_dod, konto_przec_uj) "
        Kopiuj+=" SELECT firma_id, okres_id, dowod_id, nazwa_id,"+str(NrNowy)+",konto_rozr, konto_przec_dod, konto_przec_dod "
        Kopiuj+=" FROM rs_wzory_dekretacji_roznice_kursowe WHERE firma_id='"+self.firma_id+"' "
        Kopiuj+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+NrPoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Kopiuj,1)
        #WS 2019-04-15
        if stat != 'OK':
            stat = 'BL_INS_KOP'
    #WS 2019-04-15
    else:
        stat = 'BL_POBR_NR'

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1,4,5,6)
#-------------------------------------------------------------------------------

if (Fun in [1,4,5,6]) and (stat=='OK'):
    Filtr="firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    Select="SELECT nr_poz, konto_rozr, konto_przec_dod, konto_przec_uj FROM rs_wzory_dekretacji_roznice_kursowe WHERE "+Filtr+" ORDER BY nr_poz;"        
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
    #WS 2019-04-15
    if stat != 'OK':
        stat = 'BL_SEL'