# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_xml
# Purpose:     transfer do/z xml
# Author:      Jan Raburski
# Created:     2012/01/26
# RCS-ID:      $Id: fs_xml.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2020-10-27 (12172) Aleksander Bargie - Przeniesienie sklepw Doroty do harmonogramu

# klasy pomocnicze dla pracy z xmlpt
# przyklad wykorzystania w fs_zamowienia_odbiorcy_import_xml.py

from xml.dom import minidom

#rsf_podaj_nowy_numer_dokumentu

listawezlow=[]

class XmlToRS:

    def __init__(self):
        pass
    
#---------------------------------------

    def Inicjuj(self, document_xml):
        #--- parsuje dokument
        self.doc=None
        try:
            self.doc=minidom.parseString(document_xml)
        except:
            self.doc=None
        return self.doc<>None
    
#---------------------------------------

    def CzyJestTag(self, tag):
        # sprawdza czy podany tag wystepuje w dokumencie
        # przydatne do sprawdzenia typu xml (np. czy jest to zamowienie)
##        wezel=None
##        try:
##            wezel=self.doc.getElementsByTagName(tag)
##        except:
##            wezel=None
##        return wezel<>None
        liczba=0
        try:
            liczba=len(self.doc.getElementsByTagName(tag))
        except:
            liczba=0
        return liczba>0
    
###---------------------------------------
##
##    def PodajWezly(self,listatagow,start=None):
##        if start==None:
##            start=self.doc
##        wezel=start.getElementsByTagName(listatagow[0])[0]
##        for i in xrange(len(listatagow)):
##            if i==len(listatagow)-2:
##                break
##            wezel=wezel.getElementsByTagName(listatagow[i+1])[0]
##        wezly=wezel.getElementsByTagName(listatagow[-1])
##        return wezly
##    
##    
##    
#---------------------------------------

    def PodajWezly(self,listatagow,start=None,indeks=0):
        global listawezlow
        if indeks==0:
            listawezlow=[]
        if start==None:
            start=self.doc
        wezly=start.getElementsByTagName(listatagow[indeks])
        if indeks==len(listatagow)-1:
            for w in wezly:
                listawezlow.append(w)
            return
        indeks+=1
        for w in wezly:
            self.PodajWezly(listatagow,w,indeks)
        return listawezlow
    
    
#---------------------------------------

    def PodajWezel(self,listatagow,start=None):
        if start==None:
            start=self.doc
        wezel=start.getElementsByTagName(listatagow[0])[0]
        for i in xrange(len(listatagow)):
            if i==len(listatagow)-1:
                break
            wezel=wezel.getElementsByTagName(listatagow[i+1])[0]
        return wezel
    
    
#---------------------------------------

    def PodajWartosc(self,listatagow,start=None):
        if start==None:
            start=self.doc
        return self.PodajWezel(listatagow,start).firstChild.nodeValue
    
#---------------------------------------

    def PodajListeWartosci(self,miejsce,klucze,start=None):
        if start==None:
            start=self.doc
        wezel=self.PodajWezel(miejsce,start)
        lista=[]
        for tag in klucze:
            lista.append(wezel.getElementsByTagName(tag)[0].firstChild.nodeValue)
        return lista
    
#---------------------------------------

    def PodajListeWierszy(self,miejsce,klucze,start=None):
        if start==None:
            start=self.doc
        wezly=self.PodajWezly(miejsce,start)
        wiersze=[]
        for wezel in wezly:
            wiersz=[]
            for tag in klucze:
                wiersz.append(wezel.getElementsByTagName(tag)[0].firstChild.nodeValue)
                #wiersz.append(wezel.getElementsByTagName(tag).firstChild.nodeValue)
            wiersze.append(wiersz)
        return wiersze
    

    
#---------------------------------------

class RSToXml:

    def __init__(self):
        pass

    def Inicjuj(self,root, tryb=1):
        #--- inicjuje nowy dokument
        #--- tryb=1 - przez minidom, tryb=2 - tekstowo
        self.Tryb=tryb
        if self.Tryb==1:
            self.doc=minidom.Document()
            self.docRoot=self.doc.createElement(root)
            self.doc.appendChild(self.docRoot)
        else:
            self.wiersze=[]
            self.wiersze.append('<'+root+'> ')
            self.Root=root
    
    def WstawWRoot(self,nazwa):
        #--- tworzy element i wstawia go w root
        if self.Tryb==1:
            nowy=self.doc.createElement(nazwa)
            self.docRoot.appendChild(nowy)
        else:
            self.wiersze.append(' <'+nazwa+'> ')

    def WstawTekst(self,tekst):
        #--- tworzy element i wstawia go w root
        if self.Tryb==2:
            self.wiersze.append(tekst)

    def WstawW(self,wco,co):
        #--- wstawia podany element w pierwszy element o nazwie "wco"
        element=self.ZnajdzPierwszyElement(wco)
        element.appendChild(co)

    def WstawNowyW(self,wco,nazwa,zamknac=0):
        #--- wstawia nowy element w pierwszy element o nazwie "wco"
        #--- jesli zamknac>0 to od razu domyka
        if self.Tryb==1:
            element=self.ZnajdzPierwszyElement(wco)
            element.appendChild(self.TworzNowy(nazwa))
        else:
            if zamknac>0:
                self.wiersze.append(' <'+nazwa+'/> ')
            else:
                self.wiersze.append(' <'+nazwa+'> ')

    def WstawNowyWZWartoscia(self,wco,nazwa,wartosc):
        #--- wstawia nowy element z wartoscia w pierwszy element o nazwie "wco"
        if self.Tryb==1:
            nowy=self.doc.createElement(nazwa)
            nowawartosc=self.doc.createTextNode(wartosc)
            nowy.appendChild(nowawartosc)
            element=self.ZnajdzPierwszyElement(wco)
            element.appendChild(nowy)
        else:
            self.wiersze.append(' <'+nazwa+'>'+str(wartosc)+'</'+nazwa+'> ')

    def WstawWElement(self,wco,co):
        #--- wstawia podany element w podany element
        wco.appendChild(co)

    def WstawNowyWElement(self,wco,nazwa):
        #--- wstawia nowy element w podany element
        wco.appendChild(self.TworzNowy(nazwa))

    def WstawNowyWElementZWartoscia(self,wco,nazwa,wartosc):
        #--- wstawia nowy element z wartoscia w podany element
        nowy=self.doc.createElement(nazwa)
        nowawartosc=self.doc.createTextNode(wartosc)
        nowy.appendChild(nowawartosc)
        wco.appendChild(nowy)

    def TworzNowy(self,nazwa):
        #--- tworzy nowy element
        return self.doc.createElement(nazwa)

    def TworzNowyZWartoscia(self,nazwa,wartosc):
        #--- tworzy nowy element z wartoscia (tylko str)
        nowy=self.doc.createElement(nazwa)
        nowawartosc=self.doc.createTextNode(wartosc)
        nowy.appendChild(nowawartosc)
        return nowy

    def Zamknij(self,nazwa):
        #--- zamyka znacznik
        if self.Tryb==2:
            self.wiersze.append(' </'+nazwa+'> ')

    def ZnajdzPierwszyElement(self,nazwa):
        #--- szuka pierwszego elementu o podanej nazwie
        elements = self.doc.getElementsByTagName(nazwa)
        return elements.pop()
    
    def InicjujZAtrybutem(self,root,atrybut,wartosc):
        #--- inicjuje nowy dokument z atrybutem
        self.doc=minidom.Document()
        self.docRoot=self.doc.createElement(root)
        self.doc.appendChild(self.docRoot)
        self.docRoot.setAttribute(atrybut,wartosc)
        
    def WstawAtrybutW(self,wco,atrybut,wartosc):
        #--- wstawia atrybut w pierwszy element o nazwie "wco"
        element=self.ZnajdzPierwszyElement(wco)
        element.setAttribute(atrybut,wartosc)

    #AB 28.10.20r
    def PodajXML(self ,pretty=False, utf8=False):
        #--- zwraca xml w postaci tekstu
        try:
            if pretty:
                if utf8:
                    return self.doc.toprettyxml(indent='', newl='\n',encoding='UTF-8')
                else:
                    return self.doc.toprettyxml(indent='', newl='\n',encoding='ISO-8859-2')
            else:
                return self.doc.toxml()
        except:
            return ''
                  
    def ZapiszPlik(self,nazwa,pretty=False,poczatek=''):
        #--- zapisuje xml w postaci tekstu do pliku o podanej nazwie
        if self.Tryb==2:
            #self.wiersze.append(' </'+self.Root+'> ')
            self.doc=poczatek+''.join(self.wiersze)
        try:
            plik = None
            plik = open(nazwa,"w")
            #AB 28.10.20r
            if self.Tryb == 1:
                # if pretty:
                #     plik.write(self.doc.toprettyxml(indent='', newl='\n',encoding='ISO-8859-2'))
                # else:
                #     plik.write(self.doc.toxml())
                tresc = self.PodajXML(pretty=pretty)
                if tresc == '':
                    return False
                plik = None
                plik = open(nazwa, "w")
                plik.write(tresc)
                plik.close()
            else:
                plik.write(self.doc)
            plik.close()
        except:
            if plik<>None:
                plik.close()
            return False
        return True
