# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_xml_dowod_dostawy.py
# Purpose:     Pobranie danych dowodu dostawy w celu eksportu do pliku XML dla ECOD
# Author:      Wojciech Skowron
# Created:     2019/09/21
# RCS-ID:      $Id: fs_xml_dowod_dostawy.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-11-13 W.Skowron  - pola UnitNetPrice i NetAmount (11735)
# 2020-10-27 (12172) Aleksander Bargie - Przeniesienie sklepw Doroty do harmonogramu
from string import strip
import os
import posixpath

from funkcje import fs_xml
import rssql

stat = "OK"
dane = []

if 'klucze' not in locals():
    klucze = {'Funkcja': -1}
    stat   = '-1'


if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {'Trasa':[1,2], 'Data':[1,2], 'TrybDostawy':[1,2], 'Numer':[1,2], 'CzyWszystko':[1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_xml_dowod_dostawy z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    Trasa = rsglobal.Dekoduj(klucze['Trasa'])
    Data = rsglobal.Dekoduj(klucze['Data'])
    TrybDostawy = rsglobal.Dekoduj(klucze['TrybDostawy'])
    Numer = rsglobal.Dekoduj(klucze['Numer'])

    if Funkcja == 1:
        CzyWszystko = klucze['CzyWszystko']

if stat == 'OK' and Funkcja == 1 and CzyWszystko:
    SQL = """SELECT data_eksportu FROM rs_dowody_dostaw WHERE firma_id='{firma_id}' and oddzial_id='{oddzial_id}'
             and trasa='{trasa}' and data='{data}' and tryb_dostawy='{tryb_dostawy}' and numer='{numer}';
          """.format(firma_id     = self.firma_id,
                     oddzial_id   = self.oddzial_id,
                     trasa        = Trasa,
                     data         = Data,
                     tryb_dostawy = TrybDostawy,
                     numer        = Numer)
    rsglobal.ZapiszDoLogow(SQL)
    stat,daneDE,naglDE,dump= self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)
    if stat != "OK":
        stat = "Bd pobrania danych dowodu dostawy: "+stat
    else:
        if daneDE[0][0] not in (None, '','None'):
            stat = "Dowd dostawy zosta wyeksportowany w dniu: "+daneDE[0][0]

if stat == 'OK' and Funkcja == 1:
    # Dowod dostawy
    SQL = """SELECT d.trasa, d.data, d.tryb_dostawy, d.numer, d.kontrahent_id, d.platnik_id, d.numer_zamowienia, d.data_zamowienia, z.zamowienie_nr, z.zamowienie_data, d.opak_dostarczone1
             FROM rs_dowody_dostaw d
             LEFT OUTER JOIN rs_zamowienia_odbiorcy z 
             ON (d.firma_id = z.firma_id AND d.z_wyznacznik_id = z.wyznacznik_id AND d.z_data = z.data AND d.z_numer = z.numer)
             WHERE d.firma_id='{firma_id}' and d.oddzial_id='{oddzial_id}'
             and d.trasa='{trasa}' and d.data='{data}' and d.tryb_dostawy='{tryb_dostawy}' and d.numer='{numer}';
          """.format(firma_id     = self.firma_id,
                     oddzial_id   = self.oddzial_id,
                     trasa        = Trasa,
                     data         = Data,
                     tryb_dostawy = TrybDostawy,
                     numer        = Numer)
    rsglobal.ZapiszDoLogow(SQL)
    stat,daneN,naglN,dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

    if stat == 'OK':
        DaneN = rssql.RSTableRowset(daneN,naglN)
    else:
        stat = "Bd pobrania danych dowodu dostawy: "+stat

    # Oddzial
    if stat == 'OK':
        SQL = """SELECT gln,nip,konto_nr,nazwa,nazwa1,nazwa2,adr_kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry
                 FROM rs_oddzialy 
                 WHERE firma_id='{firma_id}' and oddzial_id='{oddzial_id}';
              """.format(firma_id     = self.firma_id,
                         oddzial_id   = self.oddzial_id)
        stat,daneO,naglO,dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

        if stat == 'OK':
            DaneO = rssql.RSTableRowset(daneO,naglO)
        else:
            stat = "Bd pobrania danych oddziau: "+stat

    # Kontrahent
    if stat == 'OK':
        Kontr=DaneN.GetVal(0,"kontrahent_id")

        SQL = """SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_dowody_dostaw,nasz_symb,coalesce(xml_bez_cdata,False) as "xml_bez_cdata",ftp_nazwa,ftp_katalog
                 FROM rs_kontrahenci 
                 WHERE firma_id='{firma_id}' and kontrahent_id='{kontrahent_id}';
              """.format(firma_id      = self.firma_id,
                         kontrahent_id = Kontr)
        rsglobal.ZapiszDoLogow(SQL)
        stat,daneK,naglK,dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

        if stat == 'OK':
            DaneK = rssql.RSTableRowset(daneK,naglK)
        else:
            stat = "Bd pobrania danych kontrahenta dowodu dostawy: "+stat

    # Patnik
    if stat == 'OK':
        Plat=DaneN.GetVal(0,"platnik_id")
        if Plat in ('','None',None,Kontr):
            daneP=daneK
            naglP=naglK
        else:
            SQL = """SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_dowody_dostaw,nasz_symb,coalesce(xml_bez_cdata,False) as "xml_bez_cdata",ftp_nazwa,ftp_katalog
                     FROM rs_kontrahenci 
                     WHERE firma_id='{firma_id}' and kontrahent_id='{kontrahent_id}';
                  """.format(firma_id      = self.firma_id,
                             kontrahent_id = Plat)
            rsglobal.ZapiszDoLogow(SQL)
            stat,daneP,naglP,dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

        if stat == 'OK':
            DaneP = rssql.RSTableRowset(daneP,naglP)
        else:
            stat = "Bd pobrania danych patnika dowodu dostawy: "+stat

    # Przewonik
    if stat == 'OK':
        SQL = """SELECT k.gln
                 FROM rs_trasy_przewoznicy p
                 JOIN rs_kontrahenci k ON (k.firma_id = p.firma_id and k.kontrahent_id = p.przewoznik_id)
                 WHERE p.firma_id='{firma_id}' and p.kod='{trasa}' and p.od_dnia>='{data}';
              """.format(firma_id = self.firma_id,
                         trasa    = Trasa,
                         data     = Data)
        rsglobal.ZapiszDoLogow(SQL)
        stat,danePrzew,naglPrzew,dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

        if stat == 'OK':
            DanePrzew = rssql.RSTableRowset(danePrzew,naglPrzew)
        else:
            stat = "Bd pobrania danych przewonika dowodu dostawy: "+stat

    # Pozycje dowodu
    if stat == 'OK':
        #WS 2019-11-13 - pobranie artykul_id, cena_netto
        SQL = """SELECT dp.trasa,dp.data,dp.tryb_dostawy,dp.numer,dp.nr_poz,dp.artykul_id,dp.ilosc_zam1,dp.ilosc_dost1,a.artykul_id,a.typ_artykulu,a.nazwa,ae.ean,a.jm1,
                        aok.obcy_id as obcy_idk,aok.obca_nazwa as obca_nazwak,aok.obcy_ean as obcy_eank,aok.obca_jm as obca_jmk,
                        aop.obcy_id as obcy_idp,aop.obca_nazwa as obca_nazwap,aop.obcy_ean as obcy_eanp,aop.obca_jm as obca_jmp,
                        dp.cena_upust1 as cena_netto
                 FROM rs_dowody_dostaw_pozycje dp JOIN rs_dowody_dostaw d USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)
                 LEFT OUTER JOIN rs_artykuly_obce aok ON (dp.firma_id=aok.firma_id AND d.kontrahent_id=aok.kontrahent_id AND dp.artykul_id=aok.artykul_id)
                 LEFT OUTER JOIN rs_artykuly_obce aop ON (dp.firma_id=aop.firma_id AND d.platnik_id=aop.kontrahent_id AND dp.artykul_id=aop.artykul_id)
                 LEFT OUTER JOIN rs_artykuly a ON (dp.firma_id=a.firma_id AND dp.artykul_id=a.artykul_id)
                 LEFT OUTER JOIN rs_artykuly_ean ae ON (dp.firma_id=ae.firma_id AND dp.artykul_id=ae.artykul_id AND ae.glowny)
                 WHERE dp.firma_id='{firma_id}' and dp.oddzial_id='{oddzial_id}'
                       and dp.trasa='{trasa}' and dp.data='{data}' and dp.tryb_dostawy='{tryb_dostawy}' and dp.numer='{numer}'
                 ORDER BY dp.nr_poz;
              """.format(firma_id     = self.firma_id,
                         oddzial_id   = self.oddzial_id,
                         trasa        = Trasa,
                         data         = Data,
                         tryb_dostawy = TrybDostawy,
                         numer        = Numer)
        rsglobal.ZapiszDoLogow(SQL)
        stat,daneDP,naglDP,dump = self.PolSQL.Execute(SQL,3,CzyDodawacBlad=True)

        if stat == 'OK':
            DaneDP = rssql.RSTableRowset(daneDP,naglDP)
        else:
            stat = "Bd pobrania danych pozycji dowodu dostawy: "+stat

    if stat == 'OK':
        dane=str([daneN,naglN,daneK,naglK,daneP,naglP,daneO,naglO,danePrzew,naglPrzew,daneDP,naglDP])

if stat == 'OK' and Funkcja == 2:
    SQL = """UPDATE rs_dowody_dostaw SET data_eksportu=CURRENT_DATE WHERE firma_id='{firma_id}' and oddzial_id='{oddzial_id}'
             and trasa='{trasa}' and data='{data}' and tryb_dostawy='{tryb_dostawy}' and numer='{numer}';
          """.format(firma_id     = self.firma_id,
                     oddzial_id   = self.oddzial_id,
                     trasa        = Trasa,
                     data         = Data,
                     tryb_dostawy = TrybDostawy,
                     numer        = Numer)
    rsglobal.ZapiszDoLogow(SQL)
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1,CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd zapisu daty eksportu: "+stat

#AB 27.10.20r dodana caa klasa z klienta oraz przerobiona by dzialac importowana i odpalana z harmonogramu
class RSDowodDostawyXml:
    def __init__(self):
        self.dd = fs_xml.RSToXml()

#-------------------------------------------------------------------------------

    def ZapiszDowodDostawy(self, Trasa, Data, Tryb, Numer, CzyWszystko, firma_id, oddzial_id, WykonajFunkcje):
        Numer = str(Numer)
        import rsglobal
        #--- POBRANIE DANYCH
        Klucze = {'Trasa':Trasa, 'Data':Data, 'TrybDostawy':Tryb, 'Numer':Numer, 'Funkcja':1, 'CzyWszystko':CzyWszystko}
        stat,dane,dump,dump=WykonajFunkcje('fs_xml_dowod_dostawy', Klucze, [], [], [0, firma_id, oddzial_id, ''])
        if stat != "OK":
            return stat

        Dane=eval(dane)
        #Dane nagwka
        DaneN=rssql.RSTableRowset2(Dane[0],Dane[1])
        #Dane kontrahenta
        DaneK=rssql.RSTableRowset2(Dane[2],Dane[3])
        #Dane patnika
        DaneP=rssql.RSTableRowset2(Dane[4],Dane[5])
        #Dane oddzialu
        DaneO=rssql.RSTableRowset2(Dane[6],Dane[7])
        #Dane przewonika
        DanePrzew=rssql.RSTableRowset2(Dane[8],Dane[9])
        #Dane pozycji
        DaneDP=rssql.RSTableRowset2(Dane[10],Dane[11])

        if len(DaneN)==0:
            return 'Brak dowodu dostawy o podanych parametrach'

        if len(DaneDP)==0:
            return 'Brak pozycji na dowodzie dostawy'

        self.dd.Inicjuj("Document-ReceivingAdvice")

        #--------------------------------------

        self.dd.WstawWRoot("ReceivingAdvice-Header")

        Data = DaneN[0]["data"]
        Trasa = DaneN[0]["trasa"]
        Tryb = DaneN[0]["tryb_dostawy"]

        if Data < '2016-10-01':
            NrDD=Data[2:4]+Data[5:7]+Data[8:10]+oddzial_id[-1]+Trasa[-2:]+Tryb[-1]+rsglobal.UsunKropkaZero(Numer)
        else:
            NrDD=Data[2:4]+Data[5:7]+Data[8:10]+oddzial_id+Trasa+Tryb+rsglobal.UsunKropkaZero(Numer)

        NrZamowieniaDD = DaneN[0]["numer_zamowienia"]
        NrZamowieniaZO = DaneN[0]["zamowienie_nr"]
        if NrZamowieniaDD not in (None,'','None'):
            NrZamowienia   = NrZamowieniaDD
            DataZamowienia = DaneN[0]["data_zamowienia"]
        elif NrZamowieniaZO not in (None,'','None'):
            NrZamowienia   = NrZamowieniaZO
            DataZamowienia = DaneN[0]["zamowienie_data"]
        else:
            NrZamowienia   = 'BRAK'
            DataZamowienia = None

        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Header","ReceivingAdviceNumber",NrDD.encode('utf-8')) #WS 2019-10-17 - UTF8
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Header","ReceivingAdviceDate",str(Data))
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Header","GoodsReceiptDate",str(Data))
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Header","BuyerOrderNumber",NrZamowienia.encode('utf-8')) #WS 2019-10-17 - UTF8
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Header","DespatchNumber",NrDD.encode('utf-8')) #WS 2019-10-17 - UTF8
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Header","DocumentFunctionCode",'O')

        #--------------------------------------

        self.dd.WstawWRoot("ReceivingAdvice-Parties")

        self.dd.WstawNowyW("ReceivingAdvice-Parties","Buyer")
        #WS 2019-11-14
        t = strip(DaneP[0]["gln"])
        if t in ('','None'):
            t = 'BRAK'
        self.dd.WstawNowyWZWartoscia("Buyer","ILN",t)
        # self.dd.WstawNowyWZWartoscia("Buyer","ILN",strip(DaneP[0]["gln"]))
        self.dd.WstawNowyWZWartoscia("Buyer","TaxID",strip(DaneP[0]["nip"]))
        Nazwa=strip(DaneP[0]["nazwa_f1"])
        if Nazwa in (None,'','None'):
            Nazwa=strip(DaneP[0]["nazwa"])
        else:
            Nazwa=Nazwa+" "+strip(DaneP[0]["nazwa_f2"])
        self.dd.WstawNowyWZWartoscia("Buyer","Name",Nazwa.encode('utf-8'))
        self.dd.WstawNowyWZWartoscia("Buyer","StreetAndNumber",strip(DaneP[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneP[0]["adr_nry"]))
        self.dd.WstawNowyWZWartoscia("Buyer","CityName",strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        self.dd.WstawNowyWZWartoscia("Buyer","PostalCode",strip(DaneP[0]["adr_kod"]))
        self.dd.WstawNowyWZWartoscia("Buyer","Country","PL")

        self.dd.WstawNowyW("ReceivingAdvice-Parties","Seller")
        #WS 2019-11-14
        t = strip(DaneO[0]["gln"])
        if t in ('','None'):
            t = 'BRAK'
        self.dd.WstawNowyWZWartoscia("Seller","ILN",t)
        # self.dd.WstawNowyWZWartoscia("Seller","ILN",strip(DaneO[0]["gln"]))
        self.dd.WstawNowyWZWartoscia("Seller","TaxID",strip(DaneO[0]["nip"]))
        if not strip(DaneP[0]["nasz_symb"]) in [None,'','None']:
            self.dd.WstawNowyWZWartoscia("Seller","CodeByBuyer",strip(DaneP[0]["nasz_symb"].encode('utf-8'))) #WS 2019-10-17 - UTF8
        Nazwa1 = strip(DaneO[0]["nazwa1"])
        Nazwa2 = strip(DaneO[0]["nazwa2"])
        if Nazwa1 in (None,'','None'):
            Nazwa = strip(DaneO[0]["nazwa"])
        else:
            Nazwa = strip(Nazwa1)
            if Nazwa2 not in (None,'','None'):
                Nazwa+=" "+strip(DaneO[0]["nazwa2"])
        self.dd.WstawNowyWZWartoscia("Seller","Name",Nazwa.encode('utf-8'))
        self.dd.WstawNowyWZWartoscia("Seller","StreetAndNumber",strip(DaneO[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneO[0]["adr_nry"]))
        self.dd.WstawNowyWZWartoscia("Seller","CityName",strip(DaneO[0]["adr_miej"]).encode('utf-8'))
        self.dd.WstawNowyWZWartoscia("Seller","PostalCode",strip(DaneO[0]["adr_kod"]))
        self.dd.WstawNowyWZWartoscia("Seller","Country","PL")

        if DaneK != DaneP:
            self.dd.WstawNowyW("ReceivingAdvice-Parties","DeliveryPoint")
            #WS 2019-11-14
            t = strip(DaneK[0]["gln"])
            if t in ('','None'):
                t = 'BRAK'
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","ILN",t)
            # self.dd.WstawNowyWZWartoscia("DeliveryPoint","ILN",strip(DaneK[0]["gln"]))
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","TaxID",strip(DaneK[0]["nip"]))
            Nazwa=strip(DaneK[0]["nazwa_f1"])
            if Nazwa in (None,'','None'):
                Nazwa=strip(DaneK[0]["nazwa"])
            else:
                Nazwa=Nazwa+" "+strip(DaneK[0]["nazwa_f2"])
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","Name",Nazwa.encode('utf-8'))
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","StreetAndNumber",strip(DaneK[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneK[0]["adr_nry"]))
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","CityName",strip(DaneK[0]["adr_miej"]).encode('utf-8'))
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","PostalCode",strip(DaneK[0]["adr_kod"]))
            self.dd.WstawNowyWZWartoscia("DeliveryPoint","Country","PL")

        if len(DanePrzew) > 0:
            self.dd.WstawNowyW("ReceivingAdvice-Parties","FreightForwarder")
            #WS 2019-11-14
            t = strip(DanePrzew[0]["gln"])
            if t in ('','None'):
                t = 'BRAK'
            self.dd.WstawNowyWZWartoscia("FreightForwarder","ILN",t)
            # self.dd.WstawNowyWZWartoscia("FreightForwarder","ILN",strip(DanePrzew[0]["gln"]))

        #--------------------------------------

        self.dd.WstawWRoot("ReceivingAdvice-Consignment")
        self.dd.WstawNowyW("ReceivingAdvice-Consignment","Packing-Sequence")

        self.dd.WstawNowyW("Packing-Sequence","Packing-Reference")
        self.dd.WstawNowyWZWartoscia("Packing-Reference","PackageId",'1')
        self.dd.WstawNowyWZWartoscia("Packing-Reference","PackageNumber","{0:.3f}".format(rsglobal.RSRound(DaneN[0]["opak_dostarczone1"],3)))

        nrpoz=0
        SumaOdebranychIlosci = 0
        for w in DaneDP:
            nrpoz=nrpoz+1
            wiersz=self.dd.TworzNowy("Line")
            artyk=self.dd.TworzNowy("Line-Item")
            self.dd.WstawNowyWElementZWartoscia(artyk,"LineNumber",strip(str(nrpoz)))
            t=strip(w["obcy_eank"])
            if t in (None,'','None'):
                t=strip(w["obcy_eanp"])
            if t in (None,'','None'):
                t=strip(w["ean"])
            #WS 2019-11-13
            if t in (None,'','None'):
                t=strip(w["artykul_id"])
            self.dd.WstawNowyWElementZWartoscia(artyk,"EAN",t)
            t=strip(w["obcy_idk"])
            if t in (None,'','None'):
                t=strip(w["obcy_idp"])
            if t in (None,'','None'):
                t=strip(w["artykul_id"])
            self.dd.WstawNowyWElementZWartoscia(artyk,"BuyerItemCode",t.encode('utf-8'))
            t=strip(w["artykul_id"])
            self.dd.WstawNowyWElementZWartoscia(artyk,"SupplierItemCode",t.encode('utf-8'))
            self.dd.WstawNowyWElementZWartoscia(artyk,"QuantityReceived","{0:.3f}".format(rsglobal.RSRound(w["ilosc_dost1"],3)))
            self.dd.WstawNowyWElementZWartoscia(artyk,"OrderedQuantity","{0:.3f}".format(rsglobal.RSRound(w["ilosc_zam1"],3)))
            self.dd.WstawNowyWElementZWartoscia(artyk,"UnitPacksize","1.0")
            #WS 2019-10-22
            if strip(w["jm1"]) in ('','None'):
                return 'Import niemoliwy. Dokument '+NrDD+' posiada nieuzupenion jednostk miary w poz. '+str(nrpoz)+'.'
            t=strip(w["jm1"])[0]
            if t in ["s","S"]:
                t="PCE"
            elif t in ["k","K"]:
                t="KGM"
            else:
                return 'Nierozpoznana jednostka miary, poz.'+str(nrpoz)
            self.dd.WstawNowyWElementZWartoscia(artyk,"UnitOfMeasure",t)
            t=strip(w["obca_nazwak"])
            if t in (None,'','None'):
                t=strip(w["obca_nazwap"])
            if t in (None,'','None'):
                t=strip(w["nazwa"])
            if t in (None,'','None'):
                t=''
            if t:
                if DaneP[0]["xml_bez_cdata"]:
                    self.dd.WstawNowyWElementZWartoscia(artyk,"ItemDescription",t.encode('utf-8'))
                else:
                    #WS 2019-12-10
                    nowy = self.dd.doc.createElement("ItemDescription")
                    nowawartosc = self.dd.doc.createCDATASection(t.encode('utf-8'))
                    nowy.appendChild(nowawartosc)
                    artyk.appendChild(nowy)
                    # self.dd.WstawNowyWElementZWartoscia(artyk,"ItemDescription","<![CDATA["+t.encode('utf-8')+"]]>")
            if w["typ_artykulu"].strip() == '21':
                self.dd.WstawNowyWElementZWartoscia(artyk,"ItemType","RC")
            else:
                self.dd.WstawNowyWElementZWartoscia(artyk,"ItemType","CU")

            self.dd.WstawNowyWElementZWartoscia(artyk,"QuantityDifference","{0:.3f}".format(rsglobal.RSRound(w["ilosc_zam1"]-w["ilosc_dost1"],3)))

            #WS 2019-11-13
            self.dd.WstawNowyWElementZWartoscia(artyk,"UnitNetPrice","{0:.2f}".format(rsglobal.RSRound(w["cena_netto"],2)))
            self.dd.WstawNowyWElementZWartoscia(artyk,"NetAmount","{0:.2f}".format(rsglobal.RSRound(w["cena_netto"]*w["ilosc_dost1"],2)))

            self.dd.WstawWElement(wiersz,artyk)
            if NrZamowienia != 'BRAK':
                zamow=self.dd.TworzNowy("Line-Order")
                self.dd.WstawNowyWElementZWartoscia(zamow,"BuyerOrderNumber",NrZamowienia.encode('utf-8')) #WS 2019-10-17 - UTF8
                if DataZamowienia not in (None,'','None'):
                    self.dd.WstawNowyWElementZWartoscia(zamow,"BuyerOrderDate",DataZamowienia)
                self.dd.WstawWElement(wiersz,zamow)

            self.dd.WstawW("Packing-Sequence",wiersz)

            SumaOdebranychIlosci += w["ilosc_dost1"]

        #--------------------------------------

        self.dd.WstawWRoot("ReceivingAdvice-Summary")
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Summary","TotalLines",str(nrpoz))
        self.dd.WstawNowyWZWartoscia("ReceivingAdvice-Summary","TotalGoodsReceiptAmount","{0:.3f}".format(rsglobal.RSRound(SumaOdebranychIlosci,3)))

        #--------------------------------------

        nazwapliku = "{}_{}_{}_{}_{}".format(oddzial_id,Trasa,Data,Tryb,rsglobal.UsunKropkaZero(Numer))

        #WS 2019-10-22
        ftp_nazwa = strip(DaneK[0]["ftp_nazwa"])
        ftp_katalog = strip(DaneK[0]["ftp_katalog"])
        if ftp_nazwa in ['', 'None']:
            ftp_nazwa = strip(DaneP[0]["ftp_nazwa"])
            ftp_katalog = strip(DaneP[0]["ftp_katalog"])
        if ftp_nazwa in ['', 'None']:
            ftp_nazwa = ''

        if ftp_nazwa != '':
        # if DaneP[0]["ftp_nazwa"] not in [None, '', 'None']:
            xml = self.dd.PodajXML()

            #WS 2019-10-22
            arg = {'plik': xml, 'sciezka': posixpath.join(firma_id, ftp_nazwa.strip('/'),
                                                          ftp_katalog.strip('/'),
                                                          nazwapliku + ".xml"),
                   'typ': 'dd', 'nazwa': ftp_nazwa,}
            stat, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', {'Funkcja': 7, 'Argumenty': arg}, [], [])
            # arg = {'plik': xml, 'sciezka': posixpath.join(firma_id, DaneP[0]["ftp_nazwa"].strip('/'),
            #                                               DaneP[0]["ftp_katalog"].strip('/'),
            #                                               nazwapliku + ".xml"),
            #        'typ': 'dd', 'nazwa': DaneP[0]["ftp_nazwa"],}
            # stat, dane, dump, dump = RSLogin.WykonajFunkcje('fs_ftp_obsluga', {'Funkcja': 7, 'Argumenty': arg})
            if stat != "OK":
                return 'Bdy wysyania dowodu dostawy na serwer - ' + stat, True

        else:
            #WS 2019-10-22
            folder = strip(DaneK[0]["folder_dowody_dostaw"])
            if folder in ['','None']:
                folder = strip(DaneP[0]["folder_dowody_dostaw"])
            if folder in ['','None']:
                folder = ''

            # if DaneP[0]["folder_dowody_dostaw"] in [None,'','None']:
            #     folder=''
            if folder != '':
                if os.name not in ['nt','dos']:
                    Znak='/'
                else:
                    Znak='\\'
                folder=folder+Znak
                # folder=strip(DaneP[0]["folder_dowody_dostaw"])+Znak

            if not self.dd.ZapiszPlik(folder+nazwapliku+".xml"):
                return u"Bdy zapisu pliku: "+folder+nazwapliku+".xml"
            else:
                if stat == 'OK' :
                    Klucze = {'Trasa':Trasa, 'Data':Data, 'TrybDostawy':Tryb, 'Numer':Numer, 'Funkcja':2, 'CzyWszystko':2}
                    stat,dane,dump,dump = WykonajFunkcje('fs_xml_dowod_dostawy',Klucze, [], [], [0, firma_id, oddzial_id, ''])
                    if stat != "OK":
                        return 'Bdy zapisu daty eksportu - '+stat

        #WS 2019-10-22
        return 'OK', ftp_nazwa != ''
        # return 'OK', DaneP[0]["ftp_nazwa"] not in [None, '', 'None']
