# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_xml_faktura.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/03/24
# RCS-ID:      $Id: fs_xml_faktura.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-09-10, J.Raburski, wczytanie czy_mpp, Mantis:11642
# 2019-09-18, A. Bargie (11643) eksport faktur na ftp
# 2019-12-04  W. Skowron (11757) dodanie adresu dostawy w sekcji Delivery nagwka
# 2020-10-27 (12172) Aleksander Bargie - Przeniesienie sklepw Doroty do harmonogramu
# 2022-02-03 (12856) Aleksander Bargie - Eksport faktur ze stawk VAT 0 - TaxAmount zawsze rwny 1
# 2022-02-15 (12878) Aleksander Bargie - Nie dziaa w spc wysyanie faktur na ftpa doroty w harmonogramie
# 2023-10-25 (13592) Jan Raburski       - dodanie nr_bdo do pliku

# klucze= Wyznacznik,Data,Numer,CzyWszytko,Typ
from string import strip
import os
import posixpath

from funkcje import fs_xml
import rsglobal, rssql  #AB 15.02.22r
if 'klucze' in locals():

    Wyznacznik=klucze[0]
    Data=klucze[1]
    Numer=str(klucze[2])
    CzyZZamowien=klucze[3]
    CzyWszystko=klucze[4]
    Typ=klucze[5]
    CzyZapis=klucze[6]
    stat = "OK"
    dane = []



    #sprawdzam czy faktura bya exportowana (tylko przy exporcie wielu)
    if CzyWszystko and Typ=='oryginal':
        SQL="SELECT data_exportu FROM rs_faktury WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
        stat,daneDE,naglDE,dump= self.PolSQL.Execute(SQL,3)
        if stat <>"OK":
            stat="Bdy w pobieraniu danych faktury"
        else:
            if daneDE[0][0] not in (None, '','None'):
                stat="Faktura zostaa wyexportowana w dniu: "+daneDE[0][0]

    if stat=='OK':
        #--- pobranie nagwka faktury
        Firma=self.firma_id
        KlPom=str([Wyznacznik,Data,Numer]).replace("'",'"')
        SQL= "SELECT f.dostawy_do_dnia,f.termin_zaplaty,f.dni,f.kontrahent_id,f.platnik_id,f.miejsce_dostawy_id,f.oddzial_id,f.numer_z_rs,f.zamowienie_nr,f.zamowienie_data, rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','F') as nr_fakt, czy_mpp "
        SQL+=" FROM rs_faktury f"
        SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+Wyznacznik+"' AND f.data='"+Data+"' AND numer="+Numer+" "
        if CzyZZamowien:
            SQL+=" AND trim(coalesce(f.zamowienie_nr,''))<>'' AND f.zamowienie_data is not null "
        SQL+=";"
        stat,daneN,naglN,dump= self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)


        #rsglobal.ZapiszDoLogow(daneN,1)
        if stat <>"OK":
            stat="Bdy w pobieraniu nagwka"
        else:
            if len(daneN)==0 and CzyZZamowien:
                stat='Faktura nie ma danych o zamwieniu'

        if stat=='OK':
            DaneN = rssql.RSTableRowset(daneN,naglN)

        #--- dane kontrahenta
        if stat=="OK":
            Kontr=DaneN.GetVal(0,"kontrahent_id")

            #AB 18.09.19r dodane ftp
            SQL='SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_faktury,nasz_symb,coalesce(xml_bez_cdata,False) as "xml_bez_cdata", ftp_nazwa, ftp_katalog'
            SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
            stat,daneK,naglK,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu kontrahenta"

        #--- dane platnika
        if stat=="OK":
            Plat=DaneN.GetVal(0,"platnik_id")
            if Plat in ('','None',None,Kontr):
                daneP=daneK
                naglP=naglK
            else:
                #AB 18.09.19r dodane ftp
                SQL='SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_faktury,nasz_symb,coalesce(xml_bez_cdata,False) as "xml_bez_cdata", ftp_nazwa, ftp_katalog '
                SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Plat+"';"
                stat,daneP,naglP,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu patnika"

        #WS 2019-12-04
        #--- dane miejsca dostawy
        if stat=="OK":
            Dost=DaneN.GetVal(0,"miejsce_dostawy_id")
            if Dost in ('','None',None,Kontr):
                daneM=daneK
                naglM=naglK
            else:
                SQL='SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry'
                SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Dost+"';"
                stat,daneM,naglM,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu miejsca dostawy"

        #--- dane oddzialu
        if stat=="OK":
            Oddz=DaneN.GetVal(0,"oddzial_id")

            SQL="SELECT gln,nip,konto_nr,nazwa,nazwa1,nazwa2,adr_kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry, COALESCE(nr_bdo,'') as nr_bdo"
            SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddz+"';"
            stat,daneO,naglO,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu oddziau"

        #--- stawki VAT
        if stat=="OK":
            SQL="SELECT stawka_vat,wartosc_vat,wartosc_netto,wartosc_brutto"
            SQL+=" FROM rs_faktury_vat WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+";"
            stat,daneSV,naglSV,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu stawek VAT"

        #--- pozycje faktury
        if stat=="OK":
            SQL="SELECT fp.artykul_id,a.nazwa,ae.ean,a.jm1,"
            SQL+="aok.obcy_id as obcy_idk,aok.obca_nazwa as obca_nazwak,aok.obcy_ean as obcy_eank,aok.obca_jm as obca_jmk,"
            SQL+="aop.obcy_id as obcy_idp,aop.obca_nazwa as obca_nazwap,aop.obcy_ean as obcy_eanp,aop.obca_jm as obca_jmp,"
            SQL+="fp.ilosc1,fp.cena_netto1,fp.cena_upust1,fp.stawka_vat,rsf_podaj_sww_pkwiu_artykulu(fp.firma_id,fp.artykul_id,fp.data::TEXT) AS sww_pkwiu,fp.wartosc_netto,fp.wartosc_vat"
            SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_faktury f ON (fp.firma_id=f.firma_id AND fp.wyznacznik_id=f.wyznacznik_id AND fp.data=f.data ANd fp.numer=f.numer)"
            SQL+=" LEFT OUTER JOIN rs_artykuly_obce aok ON (fp.firma_id=aok.firma_id AND f.kontrahent_id=aok.kontrahent_id AND fp.artykul_id=aok.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly_obce aop ON (fp.firma_id=aop.firma_id AND f.platnik_id=aop.kontrahent_id AND fp.artykul_id=aop.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly a ON (fp.firma_id=a.firma_id AND fp.artykul_id=a.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly_ean ae ON (fp.firma_id=ae.firma_id AND fp.artykul_id=ae.artykul_id AND ae.glowny) "
            SQL+=" WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyznacznik+"' AND fp.data='"+Data+"' AND fp.numer="+Numer+" "
            if CzyZZamowien:
                SQL+=" AND trim(coalesce(f.zamowienie_nr,''))<>'' AND f.zamowienie_data is not null "
            SQL+="ORDER BY fp.nr_poz,fp.nr_ppoz;"
            stat,danePF,naglPF,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu pozycji"

        #--- dane dowodu dostawy
        if stat=="OK":
            SQL="SELECT oddzial_id,trasa,data,tryb_dostawy,numer"
            SQL+=" FROM rs_dowody_dostaw "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND f_wyznacznik_id='"+Wyznacznik+"' AND f_data='"+Data+"' AND f_numer="+Numer+" "
            stat,daneDD,naglDD,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu dowodu dostawy"

        #--- dane operatora
        if stat=='OK':
            SQL="SELECT login FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"' "
            stat,daneOp,naglOp,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu danych operatora"

        if Typ=='oryginal' and CzyZapis:
            #Zapis zwrotny w rs_faktury z dat exportu UWAGA -> kopiowane do fs_ftp_obsluga, w przypadku zmian, spradzic tam
            if stat=='OK':
                UPD="UPDATE rs_faktury SET data_exportu=CURRENT_DATE WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+"; "
                stat,dump,dump,dump= self.PolSQL.Execute(UPD,1)
                if stat <>"OK":
                    stat="Bdy zapisu daty exportu "+stat

        if stat=='OK':
            dane=str([daneN,naglN,daneK,naglK,daneP,naglP,daneO,naglO,daneSV,naglSV,danePF,naglPF,daneOp,naglOp,daneDD,naglDD,daneM,naglM])

#AB 27.10.20r dodana caa klasa z klienta oraz przerobiona by dzialac importowana i odpalana z harmonogramu
class RSFakturaXml:
    def __init__(self):
        self.fakt = fs_xml.RSToXml()

    # -------------------------------------------------------------------------------

    def ZapiszFakture(self, Wyznacznik, Data, Numer, Typ, CzyStandard, TylkoZamowienia, CzyWszystko, firma_id, WykonajFunkcje):
        Numer = str(Numer)
        # --- POBRANIE DANYCH
        stat, dane, dump, dump = WykonajFunkcje('fs_xml_faktura',
                                                [Wyznacznik, Data, Numer, TylkoZamowienia, CzyWszystko, Typ, False],
                                                [], [], [0, firma_id, '', ''])
        if stat != "OK":
            return 'Bdy pobierania danych - ' + stat
        Dane = eval(dane)
        # Dane nagwka
        DaneN = rssql.RSTableRowset2(Dane[0], Dane[1])
        # Dane kontrahenta
        DaneK = rssql.RSTableRowset2(Dane[2], Dane[3])
        # Dane patnika
        DaneP = rssql.RSTableRowset2(Dane[4], Dane[5])
        # Dane oddzialu
        DaneO = rssql.RSTableRowset2(Dane[6], Dane[7])
        # Dane stawek vat
        DaneSV = rssql.RSTableRowset2(Dane[8], Dane[9])
        # Dane pozycji
        DaneFP = rssql.RSTableRowset2(Dane[10], Dane[11])
        # Dane operatora
        DaneOp = rssql.RSTableRowset2(Dane[12], Dane[13])
        # Dane dowodu dostawy
        DaneDD = rssql.RSTableRowset2(Dane[14], Dane[15])
        # WS 2019-12-04
        # Dane miejsca dostawy
        DaneM = rssql.RSTableRowset2(Dane[16], Dane[17])
        if len(DaneN) == 0:
            return 'Brak faktury o podanych parametrach'

        if len(DaneFP) == 0:
            return 'Brak pozycji na fakturze'

        if len(DaneDD) >= 1:
            # AB 12.11.19r
            dowody = ",".join(sorted([DD["data"][2:4] + DD["data"][5:7] + DD["data"][8:10] + DD["oddzial_id"] + DD[
                "trasa"] + DD["tryb_dostawy"] + str(int(DD["numer"])) for DD in DaneDD]))

        # self.DrukujParagon(DaneFP)
        # return
        self.fakt.Inicjuj("Document-Invoice")

        # --------------------------------------
        self.fakt.WstawWRoot("Invoice-Header")

        NrFakt = strip(DaneN[0]["nr_fakt"])

        NrDok = strip(DaneN[0]["numer_z_rs"])
        if NrDok in (None, '', 'None'):
            ##            NrFakt=strip(Wyznacznik)+"/"+Data+"/"+strip(Numer[0:Numer.find('.')])
            if not CzyStandard:
                nazwapliku = strip(DaneN[0]["kontrahent_id"]) + "_" + strip(Wyznacznik) + "_" + Data + "_" + strip(
                    Numer[0:Numer.find('.')])
            else:
                nazwapliku = strip(Wyznacznik) + "_" + Data + "_" + strip(Numer[0:Numer.find('.')])
        else:
            if not CzyStandard:
                nazwapliku = strip(DaneN[0]["kontrahent_id"]) + "_" + strip(NrDok[3:8]) + "_" + strip(
                    NrDok[2:3]) + "_" + strip(NrDok[9:11])
            else:
                nazwapliku = strip(NrDok[3:8]) + "_" + strip(NrDok[2:3]) + "_" + strip(NrDok[9:11])
        ##            NrFakt=strip(NrFakt[3:8])+"/"+strip(NrFakt[2:3])+"/"+strip(NrFakt[9:11])

        if Typ == 'oryginal':
            TypDokumentu = "O"
        elif Typ == 'duplikat':
            TypDokumentu = "D"

        if not CzyStandard:
            self.fakt.WstawNowyWZWartoscia("Invoice-Header", "KontrahentId",
                                           strip(DaneN[0]["kontrahent_id"].encode('utf-8')))  # WS 2019-10-17 - UTF8
        self.fakt.WstawNowyWZWartoscia("Invoice-Header", "InvoiceNumber",
                                       NrFakt.encode('utf-8'))  # WS 2019-10-17 - UTF8
        self.fakt.WstawNowyWZWartoscia("Invoice-Header", "InvoiceDate", str(Data))
        self.fakt.WstawNowyWZWartoscia("Invoice-Header", "SalesDate", str(Data))
        if Typ == 'duplikat':
            DataDuplikatu = rsglobal.PodajDzis()
            self.fakt.WstawNowyWZWartoscia("Invoice-Header", "InvoiceDuplicateDate", DataDuplikatu)
        self.fakt.WstawNowyWZWartoscia("Invoice-Header", "InvoiceCurrency", "PLN")
        self.fakt.WstawNowyWZWartoscia("Invoice-Header", "InvoicePaymentDueDate", str(DaneN[0]["termin_zaplaty"]))
        self.fakt.WstawNowyWZWartoscia("Invoice-Header", "DocumentFunctionCode", TypDokumentu)
        uwagi = []
        if DaneN[0]["czy_mpp"]:
            uwagi.append("Mechanizm Podzielonej Patnoci".encode('utf-8'))
        if len(DaneDD) > 0:
            uwagi.append("Dowody dostaw:".encode('utf-8') + dowody.encode('utf-8'))
        if len(uwagi) > 0:
            self.fakt.WstawNowyWZWartoscia("Invoice-Header", "Remarks", ' '.join(uwagi))
        # JR 2019-12-10 dla stokrotki
        self.fakt.WstawNowyW("Invoice-Header", "Order")
        self.fakt.WstawNowyWZWartoscia("Order", "BuyerOrderNumber",
                                       (DaneN[0]["zamowienie_nr"].encode('utf-8')).strip()[0:35])  # JR 2019-12-10
        self.fakt.WstawNowyWZWartoscia("Order", "BuyerOrderDate", str(DaneN[0]["zamowienie_data"]))

        self.fakt.WstawNowyW("Invoice-Header", "Delivery")
        # WS 2019-12-04
        t = strip(DaneM[0]["gln"])
        if t in (None, '', 'None'):
            t = 'BRAK'
        self.fakt.WstawNowyWZWartoscia("Delivery", "DeliveryLocationNumber", t)
        # self.fakt.WstawNowyWZWartoscia("Delivery","DeliveryLocationNumber",DaneK[0]["gln"])
        # AB 12.11.19r
        self.fakt.WstawNowyWZWartoscia("Delivery", "DeliveryDate", str(Data))
        self.fakt.WstawNowyWZWartoscia("Delivery", "DespatchNumber",
                                       strip(DaneN[0]["kontrahent_id"].encode('utf-8')) + str(Data) + "1")
        # WS 2019-12-04
        Nazwa = strip(DaneM[0]["nazwa_f1"])
        if Nazwa in (None, '', 'None'):
            Nazwa = strip(DaneM[0]["nazwa"])
        else:
            Nazwa = Nazwa + " " + strip(DaneM[0]["nazwa_f2"])
        self.fakt.WstawNowyWZWartoscia("Delivery", "Name", Nazwa.encode('utf-8'))
        t1 = strip(DaneM[0]["adr_ulica"])
        t2 = strip(DaneM[0]["adr_nry"])
        t = 'BRAK'
        if t1 not in (None, '', 'None'):
            t = t1.encode('utf-8')
            if t2 not in (None, '', 'None'):
                t += " " + t2
        self.fakt.WstawNowyWZWartoscia("Delivery", "StreetAndNumber", t)
        t = strip(DaneM[0]["adr_miej"]).encode('utf-8')
        if t in (None, '', 'None'):
            t = 'BRAK'
        self.fakt.WstawNowyWZWartoscia("Delivery", "CityName", t)
        t = strip(DaneM[0]["adr_kod"])
        if t in (None, '', 'None'):
            t = 'BRAK'
        self.fakt.WstawNowyWZWartoscia("Delivery", "PostalCode", t)
        self.fakt.WstawNowyWZWartoscia("Delivery", "Country", "PL")

        # if len(DaneDD)==0:
        #     self.fakt.WstawNowyWZWartoscia("Delivery","DeliveryDate",str(Data))
        # else:
        #     self.fakt.WstawNowyWZWartoscia("Delivery","DeliveryDate",str(DaneDD[0]["data"]))
        # if dowody != '':
        #     self.fakt.WstawNowyWZWartoscia("Delivery","DespatchNumber",dowody)
        # else:
        #     self.fakt.WstawNowyWZWartoscia("Delivery","DespatchNumber",strip(DaneN[0]["kontrahent_id"].encode('utf-8'))+str(Data)+"1") #WS 2019-10-17 - UTF8

        # --------------------------------------
        self.fakt.WstawWRoot("Invoice-Parties")
        self.fakt.WstawNowyW("Invoice-Parties", "Buyer")
        # WS 2019-12-04
        t = strip(DaneP[0]["gln"])
        if t in (None, '', 'None'):
            t = 'BRAK'
        self.fakt.WstawNowyWZWartoscia("Buyer", "ILN", t)
        # self.fakt.WstawNowyWZWartoscia("Buyer","ILN",strip(DaneP[0]["gln"]))
        self.fakt.WstawNowyWZWartoscia("Buyer", "TaxID", strip(DaneP[0]["nip"]))
        self.fakt.WstawNowyWZWartoscia("Buyer", "AccountNumber", strip(DaneP[0]["bank_konto"]))
        Nazwa = strip(DaneP[0]["nazwa_f1"])
        if Nazwa in (None, '', 'None'):
            Nazwa = strip(DaneP[0]["nazwa"])
        else:
            Nazwa = Nazwa + " " + strip(DaneP[0]["nazwa_f2"])
        self.fakt.WstawNowyWZWartoscia("Buyer", "Name", Nazwa.encode('utf-8'))
        self.fakt.WstawNowyWZWartoscia("Buyer", "StreetAndNumber",
                                       strip(DaneP[0]["adr_ulica"]).encode('utf-8') + " " + strip(
                                           DaneP[0]["adr_nry"]))
        self.fakt.WstawNowyWZWartoscia("Buyer", "CityName", strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        self.fakt.WstawNowyWZWartoscia("Buyer", "PostalCode", strip(DaneP[0]["adr_kod"]))
        self.fakt.WstawNowyWZWartoscia("Buyer", "Country", "PL")
        self.fakt.WstawNowyW("Invoice-Parties", "Seller")
        # WS 2019-12-04
        t = strip(DaneO[0]["gln"])
        if t in (None, '', 'None'):
            t = 'BRAK'
        self.fakt.WstawNowyWZWartoscia("Seller", "ILN", t)
        # self.fakt.WstawNowyWZWartoscia("Seller","ILN",strip(DaneO[0]["gln"]))
        self.fakt.WstawNowyWZWartoscia("Seller", "TaxID", strip(DaneO[0]["nip"]))
        self.fakt.WstawNowyWZWartoscia("Seller", "AccountNumber", strip(DaneO[0]["konto_nr"]))
        if not strip(DaneP[0]["nasz_symb"]) in [None, '', 'None']:
            self.fakt.WstawNowyWZWartoscia("Seller", "CodeByBuyer",
                                           strip(DaneP[0]["nasz_symb"].encode('utf-8')))  # WS 2019-10-17 - UTF8
        Nazwa = strip(DaneO[0]["nazwa1"])
        if Nazwa in (None, '', 'None'):
            Nazwa = strip(DaneO[0]["nazwa"])
        else:
            Nazwa = strip(Nazwa) + " " + strip(DaneO[0]["nazwa2"])
        self.fakt.WstawNowyWZWartoscia("Seller", "Name", Nazwa.encode('utf-8'))
        self.fakt.WstawNowyWZWartoscia("Seller", "StreetAndNumber",
                                       strip(DaneO[0]["adr_ulica"]).encode('utf-8') + " " + strip(
                                           DaneO[0]["adr_nry"]))
        self.fakt.WstawNowyWZWartoscia("Seller", "CityName", strip(DaneO[0]["adr_miej"]).encode('utf-8'))
        self.fakt.WstawNowyWZWartoscia("Seller", "PostalCode", strip(DaneO[0]["adr_kod"]))
        self.fakt.WstawNowyWZWartoscia("Seller", "Country", "PL")
        if strip(DaneO[0]["nr_bdo"]) != '':
            self.fakt.WstawNowyWZWartoscia("Seller", "UtilizationRegisterNumber", strip(DaneO[0]["nr_bdo"]))
        if not CzyStandard:
            self.fakt.WstawNowyWZWartoscia("Seller", "Operator", strip(DaneOp[0]["login"]))

        # --------------------------------------
        self.fakt.WstawWRoot("Invoice-Lines")
        nrpoz = 0
        for w in DaneFP:
            nrpoz = nrpoz + 1
            wiersz = self.fakt.TworzNowy("Line")
            artyk = self.fakt.TworzNowy("Line-Item")
            self.fakt.WstawNowyWElementZWartoscia(artyk, "LineNumber", strip(str(nrpoz)))
            t = strip(w["obcy_eank"])
            if t in (None, '', 'None'):
                t = strip(w["obcy_eanp"])
            if t in (None, '', 'None'):
                t = strip(w["ean"])
            self.fakt.WstawNowyWElementZWartoscia(artyk, "EAN", t)
            t = strip(w["obcy_idk"])
            if t in (None, '', 'None'):
                t = strip(w["obcy_idp"])
            if t in (None, '', 'None'):
                t = strip(w["artykul_id"])
            self.fakt.WstawNowyWElementZWartoscia(artyk, "BuyerItemCode", t.encode('utf-8'))
            t = strip(w["artykul_id"])
            self.fakt.WstawNowyWElementZWartoscia(artyk, "SupplierItemCode", t.encode('utf-8'))
            t = strip(w["obca_nazwak"])
            if t in (None, '', 'None'):
                t = strip(w["obca_nazwap"])
            if t in (None, '', 'None'):
                t = strip(w["nazwa"])
            if DaneP[0]["xml_bez_cdata"]:
                self.fakt.WstawNowyWElementZWartoscia(artyk, "ItemDescription", t.encode('utf-8'))
            else:
                # WS 2019-12-10
                nowy = self.fakt.doc.createElement("ItemDescription")
                nowawartosc = self.fakt.doc.createCDATASection(t.encode('utf-8'))
                nowy.appendChild(nowawartosc)
                artyk.appendChild(nowy)
                # self.fakt.WstawNowyWElementZWartoscia(artyk,"ItemDescription","<![CDATA["+t.encode('utf-8')+"]]>")
            self.fakt.WstawNowyWElementZWartoscia(artyk, "ItemType", "CU")
            self.fakt.WstawNowyWElementZWartoscia(artyk, "InvoiceQuantity", str(rsglobal.RSRound(w["ilosc1"], 2)))  #AB 03.02.22r
            # WS 2019-10-22
            if strip(w["jm1"]) in ('', 'None'):
                return 'Import niemoliwy. Dokument ' + NrFakt + ' posiada nieuzupenion jednostk miary w poz. ' + str(
                    nrpoz) + '.'
            t = strip(w["jm1"])[0]
            if t in ["s", "S"]:
                t = "PCE"
            elif t in ["k", "K"]:
                t = "KGM"
            else:
                # RSMess.RSFakt('Nierozpoznana jednostka miary, poz.'+str(nrpoz))
                return 'Nierozpoznana jednostka miary, poz.' + str(nrpoz)
            self.fakt.WstawNowyWElementZWartoscia(artyk, "UnitOfMeasure", t)
            # nowe pole wymagane przez REAL ilosc artykulu w opakowniu zbiorczym
            self.fakt.WstawNowyWElementZWartoscia(artyk, "InvoiceUnitPacksize", "1.0")
            self.fakt.WstawNowyWElementZWartoscia(artyk, "InvoiceUnitNetPrice",
                                                  str(rsglobal.RSRound(w["cena_upust1"], 2)))  #AB 03.02.22r
            t = strip(w["stawka_vat"])[0:2]
            if t == "zw":
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxRate", "zw.")
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "E")
            elif t == "22":
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxRate", "22.00")
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "S")
            elif t == "23":
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxRate", "23.00")
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "S")
            else:
                t = t[1] + ".00"
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxRate", t)
                self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "S")
                tax = self.fakt.TworzNowy("TaxReference")
                self.fakt.WstawNowyWElementZWartoscia(tax, "ReferenceType", "PKWiU")
                self.fakt.WstawNowyWElementZWartoscia(tax, "ReferenceNumber", w["sww_pkwiu"])
                self.fakt.WstawWElement(artyk, tax)
            self.fakt.WstawNowyWElementZWartoscia(artyk, "TaxAmount", str(rsglobal.RSRound(w["wartosc_vat"], 2)))  #AB 03.02.22r
            self.fakt.WstawNowyWElementZWartoscia(artyk, "NetAmount", str(rsglobal.RSRound(w["wartosc_netto"], 2)))  #AB 03.02.22r
            self.fakt.WstawWElement(wiersz, artyk)
            zamow = self.fakt.TworzNowy("Line-Order")
            self.fakt.WstawNowyWElementZWartoscia(zamow, "BuyerOrderNumber",
                                                  (DaneN[0]["zamowienie_nr"].encode('utf-8')).strip()[
                                                  0:35])  # JR 2019-12-10 #WS 2019-10-17 - UTF8
            self.fakt.WstawNowyWElementZWartoscia(zamow, "BuyerOrderDate", str(DaneN[0]["zamowienie_data"]))
            self.fakt.WstawWElement(wiersz, zamow)
            # AB 12.11.19r
            # if len(DaneDD)==1:
            #     # jeden dowod dostawy
            #     dowodd=self.fakt.TworzNowy("Line-Delivery")
            #     self.fakt.WstawNowyWElementZWartoscia(dowodd,"DeliveryLocationNumber",DaneK[0]["gln"].strip())
            #     self.fakt.WstawNowyWElementZWartoscia(dowodd,"DeliveryDate",str(DaneDD[0]["data"]))
            #     self.fakt.WstawNowyWElementZWartoscia(dowodd,"DespatchNumber",dowody)
            #     self.fakt.WstawWElement(wiersz,dowodd)

            self.fakt.WstawW("Invoice-Lines", wiersz)

        # --------------------------------------
        self.fakt.WstawWRoot("Invoice-Summary")
        netto = 0
        nettop = 0
        vat = 0
        brutto = 0
        for w in DaneSV:
            netto += w["wartosc_netto"]
            vat += w["wartosc_vat"]
            brutto += w["wartosc_brutto"]
            #AB 03.02.22r
            if w["wartosc_vat"] > 0 or w["stawka_vat"] == '00':  #stawka 0% nie ma wartoci vat, ale jest opodatkowana
                nettop += w["wartosc_netto"]
        self.fakt.WstawNowyWZWartoscia("Invoice-Summary", "TotalLines", str(nrpoz))
        self.fakt.WstawNowyWZWartoscia("Invoice-Summary", "TotalNetAmount", str(rsglobal.RSRound(netto, 2)))  #AB 03.02.22r
        self.fakt.WstawNowyWZWartoscia("Invoice-Summary", "TotalTaxableBasis", str(rsglobal.RSRound(nettop, 2)))  #AB 03.02.22r
        self.fakt.WstawNowyWZWartoscia("Invoice-Summary", "TotalTaxAmount", str(rsglobal.RSRound(vat, 2)))  #AB 03.02.22r
        self.fakt.WstawNowyWZWartoscia("Invoice-Summary", "TotalGrossAmount", str(rsglobal.RSRound(brutto, 2)))  #AB 03.02.22r

        # --------------------------------------
        self.fakt.WstawNowyW("Invoice-Summary", "Tax-Summary")
        for w in DaneSV:
            tax = self.fakt.TworzNowy("Tax-Summary-Line")
            t = strip(w["stawka_vat"])[0:2]
            if t == "zw":
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxRate", "zw.")
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "E")
            elif t == "22":
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxRate", "22.00")
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "S")
            elif t == "23":
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxRate", "23.00")
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "S")
            else:
                t = t[1] + ".00"
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxRate", t)
                self.fakt.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "S")
            self.fakt.WstawNowyWElementZWartoscia(tax, "TaxAmount", str(rsglobal.RSRound(w["wartosc_vat"], 2)))  #AB 03.02.22r
            self.fakt.WstawNowyWElementZWartoscia(tax, "TaxableBasis", str(rsglobal.RSRound(w["wartosc_netto"], 2)))  #AB 03.02.22r
            self.fakt.WstawNowyWElementZWartoscia(tax, "TaxableAmount", str(rsglobal.RSRound(w["wartosc_netto"], 2)))  #AB 03.02.22r
            self.fakt.WstawNowyWElementZWartoscia(tax, "GrossAmount", str(rsglobal.RSRound(w["wartosc_brutto"], 2)))  #AB 03.02.22r
            self.fakt.WstawW("Tax-Summary", tax)

        # WS 2019-10-22
        ftp_nazwa = strip(DaneK[0]["ftp_nazwa"])
        ftp_katalog = strip(DaneK[0]["ftp_katalog"])
        if ftp_nazwa in ['', 'None']:
            ftp_nazwa = strip(DaneP[0]["ftp_nazwa"])
            ftp_katalog = strip(DaneP[0]["ftp_katalog"])
        if ftp_nazwa in ['', 'None']:
            ftp_nazwa = ''

        # AB 18.09.19r #WS 2019-10-22
        if ftp_nazwa != '':
            # if DaneP[0]["ftp_nazwa"] not in [None, '', 'None']:
            xml = self.fakt.PodajXML()

            # WS 2019-10-22
            arg = {'plik': xml, 'typ': 'faktura', 'nazwa': ftp_nazwa,
                   'sciezka': posixpath.join(firma_id, ftp_nazwa.strip('/'),
                                             ftp_katalog.strip('/'), nazwapliku + ".xml")}
            stat, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', {'Funkcja': 7, 'Argumenty': arg}, [], [])
            # arg = {'plik': xml, 'typ': 'faktura', 'nazwa': DaneP[0]["ftp_nazwa"],
            #        'sciezka': posixpath.join(firma_id, DaneP[0]["ftp_nazwa"].strip('/'),
            #                                  DaneP[0]["ftp_katalog"].strip('/'), nazwapliku + ".xml")}
            # stat, dane, dump, dump = self.WykonajFunkcje('fs_ftp_obsluga', {'Funkcja': 7, 'Argumenty': arg})
            if stat != "OK":
                return 'Bdy wysyania faktury na serwer - ' + stat, True

        else:
            # WS 2019-10-22
            folder = strip(DaneK[0]["folder_faktury"])
            if folder in ['', 'None']:
                folder = strip(DaneP[0]["folder_faktury"])
            if folder in ['', 'None']:
                folder = ''

            # if DaneP[0]["folder_faktury"] in [None,'','None']:
            #     folder=''
            if folder != '':
                if os.name not in ['nt', 'dos']:
                    Znak = '/'
                else:
                    Znak = '\\'
                folder = folder + Znak
                # folder=strip(DaneP[0]["folder_faktury"])+Znak

            if not self.fakt.ZapiszPlik(folder + nazwapliku + ".xml"):
                return u"Bdy zapisu pliku: " + folder + nazwapliku + ".xml"
            else:
                if stat == 'OK':
                    stat, dane, dump, dump = WykonajFunkcje('fs_xml_faktura',
                                                            [Wyznacznik, Data, Numer, TylkoZamowienia, CzyWszystko,
                                                             Typ, True], [], [], [0, firma_id, '', ''])
                    if stat != "OK":
                        return 'Bdy zapisu daty eksportu - ' + stat

        # AB 18.09.19r #WS 2019-10-22
        return 'OK', ftp_nazwa != ''
        # return 'OK', DaneP[0]["ftp_nazwa"] not in [None, '', 'None']
