# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_xml_korekta.py
# Purpose:      
# Author:      Dariusz Boduch
# Created:     2007/10/12
# RCS-ID:      $Id: fs_xml_korekta.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2015-02-09, J.Raburski, korekty dla Tesco, Mantis:8611
# 2019-09-10, J.Raburski, wczytanie czy_mpp, Mantis:11642
# 2019-12-11  W.Skowron,  wczytanie xml_bez_cdata, Mantis:11756
# 2020-10-27 (12172) Aleksander Bargie - Przeniesienie sklepw Doroty do harmonogramu
# 2021-04-02 (12429) Aleksander Bargie - [SP] kontrola daty zwrotu w korekcie przy tworzeniu xml
# 2021-06-09 (12526) Aleksander Bargie - Wysyanie korekt na ftp przez harmonogram, poprawka testu
# 2022-02-03 Aleksander Bargie - Eksport faktur ze stawk VAT 0 - TaxAmount zawsze rwny 1  (12856)
# 2022-02-08 Aleksander Bargie - Bd tworzenia korekt w xml   (12862)
# 2023-10-25 (13592) Jan Raburski - Dodanie BDO do sekcji Seller

#klucze= Wyznacznik,Data,Numer
from string import strip
import os
import posixpath

from funkcje import fs_xml
import rsglobal, rssql
if 'klucze' in locals():

    Wyznacznik=klucze[0]
    Data=klucze[1]
    Numer=str(klucze[2])
    CzyWszystko=klucze[3]
    Typ=klucze[4]
    CzyZapis=klucze[5]

    stat = "OK"
    dane = []

    #sprawdzam czy korekta bya exportowana (tylko przy exporcie wielu)
    if CzyWszystko and Typ=='oryginal':
        SQL="SELECT data_exportu FROM rs_korekty WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
        stat,daneDE,naglDE,dump= self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)
        if stat <>"OK":
            stat="Bdy w pobieraniu danych korekty"
        else:
            if daneDE[0][0] not in (None, '','None'):
                stat="Korekta zostaa wyexportowana w dniu: "+daneDE[0][0]

    if stat=='OK':
        #--- pobranie nagwka korekty
        Firma=self.firma_id
        KlPom=str([Wyznacznik,Data,Numer]).replace("'",'"')
        SQL= "SELECT k.dostawy_do_dnia,k.termin_zaplaty,k.dni,k.kontrahent_id,k.platnik_id,k.miejsce_dostawy_id,k.oddzial_id, "
        SQL+="k.numer_z_rs, k.wyznacznik_id_o,k.data_o,CAST (k.numer_o AS TEXT) as numer_o, k.waluta, k.sposob_zaplaty, t.opis as opis, k.wyznacznik_id_p,k.data_p, "
        SQL+="CAST (k.numer_p AS TEXT) as numer_p,k.typ_dok_p, rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','K') as nr_kor,"
        SQL+=" k.tytul_zmniejszenia_podatku, COALESCE(k.opis,'') as opis_korekty, czy_mpp, ecod"
        SQL+=" FROM rs_korekty k "
        SQL+=" LEFT OUTER JOIN rs_wyznaczniki w USING(firma_id, wyznacznik_id) "
        SQL+=" LEFT OUTER JOIN rs_tytuly_zmniejszenia_podatku t ON (k.firma_id=t.firma_id AND k.tytul_zmniejszenia_podatku=t.kod)"
        SQL+=" WHERE k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+Wyznacznik+"' AND k.data='"+Data+"' AND k.numer="+Numer+";"
        stat,daneN,naglN,dump= self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow(SQL)
        DaneN = rssql.RSTableRowset(daneN,naglN)

        TypDokP = DaneN.GetVal(0,"typ_dok_p")
        WyzDokP = DaneN.GetVal(0,"wyznacznik_id_p")
        DataDokP = DaneN.GetVal(0,"data_p")
        NrDokP = DaneN.GetVal(0,"numer_p")
        WyzDokO = DaneN.GetVal(0,"wyznacznik_id_o")
        DataDokO = DaneN.GetVal(0,"data_o")
        NrDokO = DaneN.GetVal(0,"numer_o")

        if stat <>"OK":
            stat="Bdy w pobieraniu nagwka"

        #--- dane kontrahenta
        if stat=="OK":
            Kontr=DaneN.GetVal(0,"kontrahent_id")

            #AB 24.09.19r dodane ftp
            SQL="SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_korekty,nasz_symb, coalesce(xml_bez_cdata,False) as xml_bez_cdata, ftp_nazwa, ftp_katalog"
            SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
            stat,daneK,naglK,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu kontrahenta"

        #--- dane platnika
        if stat=="OK":
            Plat=DaneN.GetVal(0,"platnik_id")
            if Plat in ('','None',None,Kontr):
                daneP=daneK
                naglP=naglK
            else:
                #AB 24.09.19r dodane ftp
                SQL="SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_korekty,nasz_symb, coalesce(xml_bez_cdata,False) as xml_bez_cdata, ftp_nazwa, ftp_katalog"
                SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Plat+"';"
                stat,daneP,naglP,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu patnika"



        #--- dane oddzialu
        if stat=="OK":
            Oddz=DaneN.GetVal(0,"oddzial_id")

            SQL="SELECT gln,nip,konto_nr,nazwa,nazwa1,nazwa2,adr_kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,COALESCE(nr_bdo,'') as nr_bdo"
            SQL+=" FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddz+"';"
            stat,daneO,naglO,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu oddziau"

        #--- stawki VAT
        if stat=="OK":
            SQL="SELECT stawka_vat,wartosc_vat,wartosc_vat_p,wartosc_netto,wartosc_netto_p,wartosc_brutto,wartosc_brutto_p"
            SQL+=" FROM rs_korekty_vat WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer  #+" AND (wartosc_netto!=wartosc_netto_p OR wartosc_vat!=wartosc_vat_p);"
            stat,daneSV,naglSV,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu stawek VAT"


        #--- pozycje korekty
        if stat=="OK":
            SQL="SELECT kp.artykul_id,a.nazwa,ae.ean,a.jm1,"
            SQL+="aok.obcy_id as obcy_idk,aok.obca_nazwa as obca_nazwak,aok.obcy_ean as obcy_eank,aok.obca_jm as obca_jmk,"
            SQL+="aop.obcy_id as obcy_idp,aop.obca_nazwa as obca_nazwap,aop.obcy_ean as obcy_eanp,aop.obca_jm as obca_jmp,"
            SQL+="kp.ilosc1, kp.ilosc1_p,kp.cena_netto1, kp.cena_netto1_p,kp.cena_upust1, kp.cena_upust1_p,kp.stawka_vat, "
            SQL+="kp.stawka_vat_p,rsf_podaj_sww_pkwiu_artykulu(kp.firma_id,kp.artykul_id,f.data_o::TEXT) AS sww_pkwiu,kp.wartosc_netto as wartn,kp.wartosc_netto_p as wartnp,kp.wartosc_vat as wartv,"
            SQL+=" kp.wartosc_vat_p as wartvp"
            SQL+=" FROM rs_korekty_pozycje kp INNER JOIN rs_korekty f ON (kp.firma_id=f.firma_id AND kp.wyznacznik_id=f.wyznacznik_id AND kp.data=f.data AND kp.numer=f.numer)"
            SQL+=" LEFT OUTER JOIN rs_artykuly_obce aok ON (kp.firma_id=aok.firma_id AND f.kontrahent_id=aok.kontrahent_id AND kp.artykul_id=aok.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly_obce aop ON (kp.firma_id=aop.firma_id AND f.platnik_id=aop.kontrahent_id AND kp.artykul_id=aop.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly a ON (kp.firma_id=a.firma_id AND kp.artykul_id=a.artykul_id) "
            SQL+=" LEFT OUTER JOIN rs_artykuly_ean ae ON (kp.firma_id=ae.firma_id AND kp.artykul_id=ae.artykul_id AND ae.glowny) "
            SQL+=" WHERE kp.firma_id='"+self.firma_id+"' AND kp.wyznacznik_id='"+Wyznacznik+"' AND kp.data='"+Data+"' AND kp.numer="+Numer
            #SQL+=" AND (wartosc_netto!=wartosc_netto_p OR wartosc_vat!=wartosc_vat_p) ORDER BY kp.nr_poz,kp.nr_ppoz;"
            SQL+="  ORDER BY kp.nr_poz,kp.nr_ppoz;"
            stat,danePF,naglPF,dump= self.PolSQL.Execute(SQL,3)

            if stat <>"OK":
                stat="Bdy w pobieraniu pozycji"

        #--- sownie
        if stat=="OK":
            stat,daneSL,naglSL,dump= self.PolSQL.Execute("SELECT CASE WHEN (SUM(wartosc_brutto-wartosc_brutto_p)) IS NOT NULL THEN rsf_slownie(SUM(wartosc_brutto-wartosc_brutto_p)) ELSE '' END as slownie FROM rs_korekty_vat WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu wartoci sownie"
        #--- dane faktury korygowanej (zamwienie,data zamwienia, data faktury)
        if stat=="OK":
            if TypDokP=='F':
                x='p'
            else:
                x='o'
            stat,daneFO,naglFO,dump=self.PolSQL.Execute("SELECT f.zamowienie_nr,f.zamowienie_data,f.data FROM rs_korekty k LEFT OUTER JOIN rs_faktury f ON (k.firma_id=f.firma_id AND k.wyznacznik_id_"+x+"=f.wyznacznik_id AND k.data_"+x+"=f.data AND k.numer_"+x+"=f.numer) WHERE k.firma_id='"+self.firma_id+"' AND k.wyznacznik_id='"+Wyznacznik+"' AND k.data='"+Data+"' AND k.numer="+Numer,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu danych faktury korygowanej"

        #--- sumy dla stawek VAT z pozycji
        if stat=="OK":
            #stat,danePV,naglPV,dump=self.PolSQL.Execute("SELECT stawka_vat, sum(wartosc_netto) as wartosc_netto,sum(wartosc_vat) as wartosc_vat,sum(wartosc_brutto) as wartosc_brutto,stawka_vat_p,sum(wartosc_netto_p) as wartosc_netto_p,sum(wartosc_vat_p) as wartosc_vat_p,sum(wartosc_brutto_p) as wartosc_brutto_p FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND (wartosc_netto!=wartosc_netto_p OR wartosc_vat!=wartosc_vat_p) GROUP BY stawka_vat, stawka_vat_p;",3)
            stat,danePV,naglPV,dump=self.PolSQL.Execute("SELECT stawka_vat, sum(wartosc_netto) as wartosc_netto,sum(wartosc_vat) as wartosc_vat,sum(wartosc_brutto) as wartosc_brutto,stawka_vat_p,sum(wartosc_netto_p) as wartosc_netto_p,sum(wartosc_vat_p) as wartosc_vat_p,sum(wartosc_brutto_p) as wartosc_brutto_p FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" GROUP BY stawka_vat, stawka_vat_p;",3)
            if stat <>"OK":
                stat="Bdy w pobieraniu danych"

        #--- dane gln miejsca dostawy
        if stat=="OK":
            Dost=DaneN.GetVal(0,"miejsce_dostawy_id")
            if Dost in (None,'None',''):
                daneOD=daneK
                naglOD=naglK
            else:
                SQL="SELECT gln,nip,bank_konto,nazwa,nazwa_f1,nazwa_f2,kraj,adr_kod,adr_miej,adr_ulica,adr_poczta,adr_nry,folder_korekty,nasz_symb"
                SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Dost+"';"
                stat,daneOD,naglOD,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu miejsca dostawy"

        #---numery f. oryg. lub pierw. z funkcji
        Firma=self.firma_id
        KlPierw = str([WyzDokP,DataDokP,NrDokP]).replace("'",'"')
        KlOryg = str([WyzDokO,DataDokO,NrDokO]).replace("'",'"')
        #rsglobal.ZapiszDoLogow(WyzDokP+' '+DataDokP+' '+NrDokP+'   '+WyzDokO+' '+DataDokO+' '+NrDokO,0)
        if WyzDokO.strip() in ('None','',None):
            Funkcja="rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPierw+"','"+TypDokP+"')"
        else:
            Funkcja="rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlOryg+"','F')"

        stat,daneNF,naglNF,dump=self.PolSQL.Execute("SELECT "+Funkcja+";",3)
        #rsglobal.ZapiszDoLogow(daneNF,0)

        #--- dane operatora
        if stat=='OK':
            SQL="SELECT login FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"' "
            stat,daneOp,naglOp,dump= self.PolSQL.Execute(SQL,3)
            if stat <>"OK":
                stat="Bdy w pobieraniu danych operatora"

        if Typ=='oryginal' and CzyZapis:
            #Zapis zwrotny w rs_korekty z dat exportu UWAGA -> kopiowane do fs_ftp_obsluga, w przypadku zmian, spradzic tam
            if stat=='OK':
                UPD="UPDATE rs_korekty SET data_exportu=CURRENT_DATE WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+"; "
                stat,dump,dump,dump= self.PolSQL.Execute(UPD,1)
                if stat <>"OK":
                    stat="Bdy zapisu daty exportu "+stat

        if stat=='OK':
            dane=str([daneN,naglN,daneK,naglK,daneP,naglP,daneO,naglO,daneSV,naglSV,danePF,naglPF,daneSL,naglSL,daneFO,naglFO,danePV,naglPV,daneOD,naglOD,daneNF,naglNF,daneOp,naglOp])


#AB 27.10.20r dodana caa klasa z klienta oraz przerobiona by dzialac importowana i odpalana z harmonogramu
class RSKorektaXml:
    def __init__(self):
        self.korekta = fs_xml.RSToXml()


    def ZapiszKorekte(self, Wyznacznik, Data, Numer, Typ, CzyStandard, CzyWszystko, CzyTesco, CzyCarrefour,
                      firma_id, WykonajFunkcje):
        Numer = str(Numer)
        # --- POBRANIE DANYCH
        stat, dane, dump, dump = WykonajFunkcje('fs_xml_korekta',
                                                [Wyznacznik, Data, Numer, CzyWszystko, Typ, False],
                                                [], [], [0, firma_id, '', ''])
        if stat != "OK":
            return 'Bedy pobierania danych - ' + stat

        Dane = eval(dane)
        # Dane nagwka
        DaneN = rssql.RSTableRowset2(Dane[0], Dane[1])
        # Dane kontrahenta
        DaneK = rssql.RSTableRowset2(Dane[2], Dane[3])
        # Dane patnika
        DaneP = rssql.RSTableRowset2(Dane[4], Dane[5])
        # Dane oddzialu
        DaneO = rssql.RSTableRowset2(Dane[6], Dane[7])
        # Dane stawek vat
        DaneSV = rssql.RSTableRowset2(Dane[8], Dane[9])
        # Dane pozycji
        DaneFP = rssql.RSTableRowset2(Dane[10], Dane[11])
        # Dane Sownie
        DaneSL = rssql.RSTableRowset2(Dane[12], Dane[13])
        # Dane Faktry Oryg.
        DaneFO = rssql.RSTableRowset2(Dane[14], Dane[15])
        # print DaneFO
        # Sumy dla stawek VAT z pozycji
        DanePV = rssql.RSTableRowset2(Dane[16], Dane[17])
        # Dane gln miejsca dostawy
        DaneOD = rssql.RSTableRowset2(Dane[18], Dane[19])
        # numery faktur z funkcji
        DaneNF = rssql.RSTableRowset2(Dane[20], Dane[21])
        # dane operatora
        DaneOp = rssql.RSTableRowset2(Dane[22], Dane[23])
        if len(DaneN) == 0:
            return 'Brak korekty o podanych parametrach'

        if len(DaneFP) == 0:
            return 'Brak pozycji na korekcie'
        # self.DrukujParagon(DaneFP)
        # return
        self.korekta.Inicjuj("Document-Invoice")

        # --------------------------------------
        self.korekta.WstawWRoot("Invoice-Header")
        # NrDok=strip(DaneN[0]["numer_z_rs"])
        NrKor = strip(DaneN[0]["nr_kor"])
        if DaneN[0]["data_o"].strip() not in (None, '', 'None'):
            DataO = DaneN[0]["data_o"]
        else:
            DataO = DaneN[0]["data_p"]
        NrFakO = DaneNF[0][0].strip()
        ZamNr = DaneFO[0]["zamowienie_nr"].strip()[0:16]
        if ZamNr.strip() in (None, '', 'None'):
            ZamNr = ''
        ZamData = str(DaneFO[0]["zamowienie_data"])
        if ZamData.strip() in (None, '', 'None'):
            ZamData = ''
        PowodKorekty = str(DaneN[0]["opis"])
        if PowodKorekty in (None, '', 'None'):
            PowodKorekty = ''
        DowodZwrotu = ''
        if CzyTesco or CzyCarrefour:
            # --- '2' - zwrot, '3' - rabat
            PowodKorekty = str(DaneN[0]["tytul_zmniejszenia_podatku"])
            if PowodKorekty == '00':
                PowodKorekty = '2'
            else:
                PowodKorekty = '3'
            # --- pobranie numeru zwrotu Tesco z opisu
            # print str(DaneN[0]["opis"]).split()
            # try:
            #    DowodZwrotu=str(DaneN[0]["opis_korekty"]).split()[2]
            #    DataZwrotu=str(DaneN[0]["opis_korekty"]).split()[5]
            # except:
            #    return "Brak numeru dokumentu zwrotu w opisie korekty"

            # JR 2020-06-15
            # tekst w formacie:  Dowd zwrotu 2005250201052110 z dnia 2020-05-25
            # moze byc kilka dowodow w wierszu, moze byc kilka wierszy, nr dowodu zwrotu moze by obcy (inna dlugosc)
            try:
                wiersze = str(DaneN[0]["opis_korekty"]).strip().splitlines()
                if len(wiersze) == 0:
                    return "Brak numeru dokumentu zwrotu w opisie korekty"
                # RSMess.RSFakt(str(len(wiersze))+':'+str(wiersze))
                for wiersz in wiersze:
                    w = wiersz.split()
                    # RSMess.RSFakt(str(w))
                    i = 0
                    j = len(w)
                    DataZwrotu = w[i * 6 + 5]
                    while (i + 1) * 6 <= j:
                        DowodZwrotu += w[i * 6 + 2] + ', '
                        i += 1
                if len(DowodZwrotu) > 0:
                    DowodZwrotu = DowodZwrotu[:-2]
            except:
                return "Brak numeru dokumentu zwrotu w opisie korekty"
            if not rsglobal.SprawdzCzyToData(DataZwrotu) and DaneN[0]["ecod"]:
                return u'Niepoprawna data zwrotu.'
            if DataZwrotu > Data and DaneN[0]["ecod"]:
                return u'Data zwrotu nie moe by pniejsza od daty korekty.'

        # nazwapliku=NrKor
        NrDok = strip(DaneN[0]["numer_z_rs"])
        if NrDok in (None, '', 'None'):
            ##            NrFakt=strip(Wyznacznik)+"/"+Data+"/"+strip(Numer[0:Numer.find('.')])
            if not CzyStandard:
                nazwapliku = strip(DaneN[0]["kontrahent_id"]) + "_" + strip(Wyznacznik) + "_" + Data + "_" + strip(
                    Numer[0:Numer.find('.')])
            else:
                nazwapliku = strip(DaneN[0]["kontrahent_id"]) + "_" + strip(Wyznacznik) + "_" + Data + "_" + strip(
                    Numer[0:Numer.find('.')])
        else:
            if not CzyStandard:
                nazwapliku = strip(NrDok[3:8]) + "_" + strip(NrDok[2:3]) + "_" + strip(NrDok[9:11])
            else:
                nazwapliku = strip(NrDok[3:8]) + "_" + strip(NrDok[2:3]) + "_" + strip(NrDok[9:11])
        ##            NrFakt=strip(NrFakt[3:8])+"/"+strip(NrFakt[2:3])+"/"+strip(NrFakt[9:11])

        if Typ == 'oryginal':
            TypDokumentu = "C"
        elif Typ == 'duplikat':
            TypDokumentu = "R"

        if not CzyStandard:
            self.korekta.WstawNowyWZWartoscia("Invoice-Header", "KontrahentId",
                                           strip(DaneN[0]["kontrahent_id"].encode('utf-8')))  # WS 2019-10-17 - UTF8
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "InvoiceNumber",
                                       NrKor.encode('utf-8'))  # WS 2019-10-17 - UTF8
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "InvoiceDate", str(Data))
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "SalesDate", str(Data))
        if Typ == 'duplikat':
            DataDuplikatu = rsglobal.PodajDzis()
            self.korekta.WstawNowyWZWartoscia("Invoice-Header", "InvoiceDuplicateDate", DataDuplikatu)
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "InvoiceCurrency", str(DaneN[0]["waluta"]))
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "InvoicePaymentDueDate", str(DaneN[0]["termin_zaplaty"]))
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "DocumentFunctionCode", TypDokumentu)
        self.korekta.WstawNowyWZWartoscia("Invoice-Header", "CorrectionReason", PowodKorekty.encode('utf-8'))
        uwagi = ""
        if DaneN[0]["czy_mpp"]:
            uwagi = "Mechanizm Podzielonej Patnoci "
        if CzyCarrefour:
            if len(DowodZwrotu) > 10:
                uwagi += DowodZwrotu
        if uwagi != '':
            self.korekta.WstawNowyWZWartoscia("Invoice-Header", "Remarks", uwagi.encode('utf-8'))
        # self.korekta.WstawNowyW("Invoice-Header","Reference")
        # self.korekta.WstawNowyWZWartoscia("Reference","InvoiceReferenceNumber",NrFakO)
        # self.korekta.WstawNowyWZWartoscia("Reference","InvoiceReferenceDate",strip(DataO))
        # self.korekta.WstawNowyW("Invoice-Header","Delivery")
        # self.korekta.WstawNowyWZWartoscia("Delivery","DeliveryLocationNumber",DaneOD[0]["gln"])#/ Zmiana pobierania GLN
        # self.korekta.WstawNowyWZWartoscia("Delivery","DeliveryLocationNumber",DaneK[0]["gln"]) #/po zmianie
        # self.korekta.WstawNowyWZWartoscia("Delivery","DeliveryDate",str(DaneFO[0]["data"]))
        # self.korekta.WstawNowyWZWartoscia("Delivery","DespatchNumber",strip(DaneN[0]["kontrahent_id"])+str(DaneFO[0]["data"])+"1")

        # Zmiana pobierania - w sekcji Buyer - pobieramy dane platnika, sekcja Payer jako opcjionalna usunieta - wg wskazowek z COMARCH
        # --------------------------------------
        ##        self.korekta.WstawWRoot("Invoice-Parties")
        ##        self.korekta.WstawNowyW("Invoice-Parties","Buyer")
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","ILN",strip(DaneK[0]["gln"]))
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","TaxID",strip(DaneK[0]["nip"]))
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","AccountNumber",strip(DaneK[0]["bank_konto"]))
        ##
        ##        Nazwa=strip(DaneK[0]["nazwa_f1"])
        ##        if Nazwa in (None,'','None'):
        ##            Nazwa=strip(DaneK[0]["nazwa"])
        ##        else:
        ##            Nazwa=Nazwa+" "+strip(DaneP[0]["nazwa_f2"])
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","Name",Nazwa.encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","StreetAndNumber",strip(DaneK[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneK[0]["adr_nry"]))
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","CityName",strip(DaneK[0]["adr_miej"]).encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","PostalCode",strip(DaneK[0]["adr_kod"]))
        ##        self.korekta.WstawNowyWZWartoscia("Buyer","Country","PL")
        ##
        ##        self.korekta.WstawNowyW("Invoice-Parties","Payer")
        ##        self.korekta.WstawNowyWZWartoscia("Payer","ILN",strip(DaneP[0]["gln"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","TaxID",strip(DaneP[0]["nip"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","AccountNumber",strip(DaneP[0]["bank_konto"]))
        ##
        ##        Nazwa=strip(DaneP[0]["nazwa_f1"])
        ##        if Nazwa in (None,'','None'):
        ##            Nazwa=strip(DaneP[0]["nazwa"])
        ##        else:
        ##            Nazwa=Nazwa+" "+strip(DaneP[0]["nazwa_f2"])
        ##        self.korekta.WstawNowyWZWartoscia("Payer","Name",Nazwa.encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","StreetAndNumber",strip(DaneP[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneP[0]["adr_nry"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","CityName",strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","PostalCode",strip(DaneP[0]["adr_kod"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","Country","PL")
        ##
        ##        self.korekta.WstawNowyW("Invoice-Parties","Invoicee")
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","ILN",strip(DaneP[0]["gln"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","TaxID",strip(DaneP[0]["nip"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","AccountNumber",strip(DaneP[0]["bank_konto"]))
        ##
        ##        Nazwa=strip(DaneP[0]["nazwa_f1"])
        ##        if Nazwa in (None,'','None'):
        ##            Nazwa=strip(DaneP[0]["nazwa"])
        ##        else:
        ##            Nazwa=Nazwa+" "+strip(DaneP[0]["nazwa_f2"])
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","Name",Nazwa.encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","StreetAndNumber",strip(DaneP[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneP[0]["adr_nry"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","CityName",strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","PostalCode",strip(DaneP[0]["adr_kod"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","Country","PL")
        ##

        # Po zmianie -  jesli nie zadziala - nalezy dodac pole GLN Zamawiajacego w danych podstawowych kontrahenta i pobierac je (tylko w przypadku AUCHAN)

        # --------------------------------------
        self.korekta.WstawWRoot("Invoice-Parties")
        self.korekta.WstawNowyW("Invoice-Parties", "Buyer")
        self.korekta.WstawNowyWZWartoscia("Buyer", "ILN", strip(DaneP[0]["gln"]))
        if CzyTesco:
            # nip z kreskami
            t = strip(DaneP[0]["nip"])
            self.korekta.WstawNowyWZWartoscia("Buyer", "TaxID", t[0:3] + '-' + t[3:5] + '-' + t[5:7] + '-' + t[7:10])
        else:
            self.korekta.WstawNowyWZWartoscia("Buyer", "TaxID", strip(DaneP[0]["nip"]))
        self.korekta.WstawNowyWZWartoscia("Buyer", "AccountNumber", strip(DaneP[0]["bank_konto"]))

        Nazwa = strip(DaneP[0]["nazwa_f1"])
        if Nazwa in (None, '', 'None'):
            Nazwa = strip(DaneP[0]["nazwa"])
        else:
            Nazwa = Nazwa + " " + strip(DaneP[0]["nazwa_f2"])
        self.korekta.WstawNowyWZWartoscia("Buyer", "Name", Nazwa.encode('utf-8'))
        self.korekta.WstawNowyWZWartoscia("Buyer", "StreetAndNumber",
                                       strip(DaneP[0]["adr_ulica"]).encode('utf-8') + " " + strip(
                                           DaneP[0]["adr_nry"]))
        self.korekta.WstawNowyWZWartoscia("Buyer", "CityName", strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        self.korekta.WstawNowyWZWartoscia("Buyer", "PostalCode", strip(DaneP[0]["adr_kod"]))
        self.korekta.WstawNowyWZWartoscia("Buyer", "Country", "PL")

        ##        self.korekta.WstawNowyW("Invoice-Parties","Payer")
        ##        self.korekta.WstawNowyWZWartoscia("Payer","ILN",strip(DaneP[0]["gln"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","TaxID",strip(DaneP[0]["nip"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","AccountNumber",strip(DaneP[0]["bank_konto"]))

        ##        Nazwa=strip(DaneP[0]["nazwa_f1"])
        ##        if Nazwa in (None,'','None'):
        ##            Nazwa=strip(DaneP[0]["nazwa"])
        ##        else:
        ##            Nazwa=Nazwa+" "+strip(DaneP[0]["nazwa_f2"])
        ##        self.korekta.WstawNowyWZWartoscia("Payer","Name",Nazwa.encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","StreetAndNumber",strip(DaneP[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneP[0]["adr_nry"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","CityName",strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","PostalCode",strip(DaneP[0]["adr_kod"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payer","Country","PL")

        ##        self.korekta.WstawNowyW("Invoice-Parties","Invoicee")
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","ILN",strip(DaneP[0]["gln"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","TaxID",strip(DaneP[0]["nip"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","AccountNumber",strip(DaneP[0]["bank_konto"]))

        ##        Nazwa=strip(DaneP[0]["nazwa_f1"])
        ##        if Nazwa in (None,'','None'):
        ##            Nazwa=strip(DaneP[0]["nazwa"])
        ##        else:
        ##            Nazwa=Nazwa+" "+strip(DaneP[0]["nazwa_f2"])
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","Name",Nazwa.encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","StreetAndNumber",strip(DaneP[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneP[0]["adr_nry"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","CityName",strip(DaneP[0]["adr_miej"]).encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","PostalCode",strip(DaneP[0]["adr_kod"]))
        ##        self.korekta.WstawNowyWZWartoscia("Invoicee","Country","PL")

        # -------------------------------------------------------------------------------
        self.korekta.WstawNowyW("Invoice-Parties", "Seller")
        self.korekta.WstawNowyWZWartoscia("Seller", "ILN", strip(DaneO[0]["gln"]))
        self.korekta.WstawNowyWZWartoscia("Seller", "TaxID", strip(DaneO[0]["nip"]))
        self.korekta.WstawNowyWZWartoscia("Seller", "AccountNumber", strip(DaneO[0]["konto_nr"]))
        if not strip(DaneP[0]["nasz_symb"]) in [None, '', 'None']:
            self.korekta.WstawNowyWZWartoscia("Seller", "CodeByBuyer",
                                           strip(DaneP[0]["nasz_symb"].encode('utf-8')))  # WS 2019-10-17 - UTF8
        Nazwa = strip(DaneO[0]["nazwa1"])
        if Nazwa in (None, '', 'None'):
            Nazwa = strip(DaneO[0]["nazwa"])
        else:
            Nazwa = strip(Nazwa) + " " + strip(DaneO[0]["nazwa2"])
        self.korekta.WstawNowyWZWartoscia("Seller", "Name", Nazwa.encode('utf-8'))
        self.korekta.WstawNowyWZWartoscia("Seller", "StreetAndNumber",
                                       strip(DaneO[0]["adr_ulica"]).encode('utf-8') + " " + strip(
                                           DaneO[0]["adr_nry"]))
        self.korekta.WstawNowyWZWartoscia("Seller", "CityName", strip(DaneO[0]["adr_miej"]).encode('utf-8'))
        self.korekta.WstawNowyWZWartoscia("Seller", "PostalCode", strip(DaneO[0]["adr_kod"]))
        self.korekta.WstawNowyWZWartoscia("Seller", "Country", "PL")
        if strip(DaneO[0]["nr_bdo"]) != '':
            self.korekta.WstawNowyWZWartoscia("Seller", "UtilizationRegisterNumber", strip(DaneO[0]["nr_bdo"]))
        if not CzyStandard:
            self.korekta.WstawNowyWZWartoscia("Seller", "Operator", strip(DaneOp[0]["login"]))
        ##        self.korekta.WstawNowyW("Invoice-Parties","Payee")
        ##        self.korekta.WstawNowyWZWartoscia("Payee","ILN",strip(DaneO[0]["gln"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payee","TaxID",strip(DaneO[0]["nip"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payee","AccountNumber",strip(DaneO[0]["konto_nr"]))
        ##
        ##        Nazwa=strip(DaneO[0]["nazwa1"])
        ##        if Nazwa in (None,'','None'):
        ##            Nazwa=strip(DaneO[0]["nazwa"])
        ##        else:
        ##            Nazwa=strip(Nazwa)+" "+strip(DaneO[0]["nazwa2"])
        ##        self.korekta.WstawNowyWZWartoscia("Payee","Name",Nazwa.encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Payee","StreetAndNumber",strip(DaneO[0]["adr_ulica"]).encode('utf-8')+" "+strip(DaneO[0]["adr_nry"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payee","CityName",strip(DaneO[0]["adr_miej"]).encode('utf-8'))
        ##        self.korekta.WstawNowyWZWartoscia("Payee","PostalCode",strip(DaneO[0]["adr_kod"]))
        ##        self.korekta.WstawNowyWZWartoscia("Payee","Country","PL")
        # --------------------------------------
        self.korekta.WstawWRoot("Invoice-Lines")
        nrpoz = 0
        brt = 0
        for w in DaneFP:
            ilosc1 = w["ilosc1"]
            ilosc1p = w["ilosc1_p"]
            cenan = w["cena_upust1"]
            cenanp = w["cena_upust1_p"]
            wartV = w["wartv"]
            wartVp = w["wartvp"]
            wartN = w["wartn"]
            wartNp = w["wartnp"]
            nrpoz = nrpoz + 1
            wiersz = self.korekta.TworzNowy("Line")
            artyk = self.korekta.TworzNowy("Line-Item")
            self.korekta.WstawNowyWElementZWartoscia(artyk, "LineNumber", strip(str(nrpoz)))
            t = strip(w["obcy_eank"])
            if t in (None, '', 'None'):
                t = strip(w["obcy_eanp"])
            if t in (None, '', 'None'):
                t = strip(w["ean"])
            self.korekta.WstawNowyWElementZWartoscia(artyk, "EAN", t)
            t = strip(w["obcy_idk"])
            if t in (None, '', 'None'):
                t = strip(w["obcy_idp"])
            if t in (None, '', 'None'):
                t = strip(w["artykul_id"])
            self.korekta.WstawNowyWElementZWartoscia(artyk, "BuyerItemCode", t.encode('utf-8'))
            t = strip(w["artykul_id"])
            self.korekta.WstawNowyWElementZWartoscia(artyk, "SupplierItemCode", t.encode('utf-8'))
            t = strip(w["obca_nazwak"])
            if t in (None, '', 'None'):
                t = strip(w["obca_nazwap"])
            if t in (None, '', 'None'):
                t = strip(w["nazwa"])
            # WS 2019-12-10
            if DaneP[0]["xml_bez_cdata"]:
                self.korekta.WstawNowyWElementZWartoscia(artyk, "ItemDescription", t.encode('utf-8'))
            else:
                # WS 2019-12-10
                nowy = self.korekta.doc.createElement("ItemDescription")
                nowawartosc = self.korekta.doc.createCDATASection(t.encode('utf-8'))
                nowy.appendChild(nowawartosc)
                artyk.appendChild(nowy)
                # self.korekta.WstawNowyWElementZWartoscia(artyk,"ItemDescription","<![CDATA["+t.encode('utf-8')+"]]>")
            self.korekta.WstawNowyWElementZWartoscia(artyk, "ItemType", "CU")
            self.korekta.WstawNowyWElementZWartoscia(artyk, "InvoiceQuantity", str(ilosc1))
            # WS 2019-10-22
            if strip(w["jm1"]) in ('', 'None'):
                return 'Import niemoliwy. Dokument ' + NrKor + ' posiada nieuzupenion jednostk miary w poz. ' + str(
                    nrpoz) + '.'
            t = strip(w["jm1"])[0]
            if t in ["s", "S"]:
                t = "PCE"
            elif t in ["k", "K"]:
                t = "KGM"
            else:
                return 'Nierozpoznana jednostka miary, poz.' + str(nrpoz)
                # RSMess.RSFakt('Nierozpoznana jednostka miary, poz.'+str(nrpoz))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "UnitOfMeasure", t)
            # nowe pole wymagane przez REAL ilosc artykulu w opakowniu zbiorczym
            self.korekta.WstawNowyWElementZWartoscia(artyk, "InvoiceUnitPacksize", "1.0")
            self.korekta.WstawNowyWElementZWartoscia(artyk, "InvoiceUnitNetPrice", str(w["cena_upust1"]))
            t = strip(w["stawka_vat"])[0:2]
            if t == "zw":
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxRate", "zw.")
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "E")
            elif t == "22":
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxRate", "22.00")
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "S")
            elif t == "23":
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxRate", "23.00")
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "S")
            else:
                t = t[1] + ".00"
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxRate", t)
                self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxCategoryCode", "S")
                tax = self.korekta.TworzNowy("TaxReference")
                self.korekta.WstawNowyWElementZWartoscia(tax, "ReferenceType", "PKWiU")
                self.korekta.WstawNowyWElementZWartoscia(tax, "ReferenceNumber", w["sww_pkwiu"])
                self.korekta.WstawWElement(artyk, tax)
            self.korekta.WstawNowyWElementZWartoscia(artyk, "TaxAmount", str(wartV))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "NetAmount", str(wartN))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousInvoiceQuantity", str(w["ilosc1_p"]))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousInvoiceUnitNetPrice", str(w["cena_upust1_p"]))
            p = strip(w["stawka_vat_p"])[0:2]
            if p == "zw":
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxRate", "zw.")
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxCategoryCode", "E")
            elif p == "22":
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxRate", "22.00")
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxCategoryCode", "S")
            elif p == "23":
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxRate", "23.00")
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxCategoryCode", "S")
            else:
                p = p[1] + ".00"
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxRate", p)
                self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxCategoryCode", "S")
            self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousTaxAmount", str(wartVp))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "PreviousNetAmount", str(wartNp))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "CorrectionInvoiceQuantity", str(ilosc1 - ilosc1p))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "CorrectionInvoiceUnitNetPrice", str(cenan - cenanp))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "CorrectionTaxAmount", str(wartV - wartVp))
            self.korekta.WstawNowyWElementZWartoscia(artyk, "CorrectionNetAmount", str(wartN - wartNp))
            self.korekta.WstawWElement(wiersz, artyk)
            zamow = self.korekta.TworzNowy("Line-Order")
            self.korekta.WstawNowyWElementZWartoscia(zamow, "BuyerOrderNumber",
                                                  ZamNr.encode('utf-8'))  # WS 2019-10-17 - UTF8
            self.korekta.WstawNowyWElementZWartoscia(zamow, "BuyerOrderDate", ZamData)
            self.korekta.WstawWElement(wiersz, zamow)
            faktO = self.korekta.TworzNowy("Line-Reference")
            self.korekta.WstawNowyWElementZWartoscia(faktO, "InvoiceReferenceNumber", NrFakO.encode('utf-8'))
            self.korekta.WstawNowyWElementZWartoscia(faktO, "InvoiceReferenceDate", strip(DataO))
            self.korekta.WstawWElement(wiersz, faktO)
            dost = self.korekta.TworzNowy("Line-Delivery")
            self.korekta.WstawNowyWElementZWartoscia(dost, "DeliveryLocationNumber", DaneK[0]["gln"])
            self.korekta.WstawNowyWElementZWartoscia(dost, "DeliveryDate", str(DaneFO[0]["data"]))
            self.korekta.WstawNowyWElementZWartoscia(dost, "DespatchNumber",
                                                  strip(DaneN[0]["kontrahent_id"].encode('utf-8')) + str(
                                                      DaneFO[0]["data"]) + "1")  # WS 2019-10-17 - UTF8
            self.korekta.WstawWElement(wiersz, dost)
            if CzyTesco:
                dzwrot = self.korekta.TworzNowy("Line-Returns")
                self.korekta.WstawNowyWElementZWartoscia(dzwrot, "ReturnsNoticeNumber",
                                                      DowodZwrotu.encode('utf-8'))  # WS 2019-10-17 - UTF8
                self.korekta.WstawNowyWElementZWartoscia(dzwrot, "ReturnsNoticeDate", DataZwrotu)
                self.korekta.WstawWElement(wiersz, dzwrot)
            if CzyCarrefour:
                dzwrot = self.korekta.TworzNowy("Line-Returns")
                if len(DowodZwrotu) < 11:
                    self.korekta.WstawNowyWElementZWartoscia(dzwrot, "ReturnsNoticeNumber",
                                                          DowodZwrotu.encode('utf-8'))  # WS 2019-10-17 - UTF8
                else:
                    self.korekta.WstawNowyWElementZWartoscia(dzwrot, "ReturnsNoticeNumber", '')
                self.korekta.WstawNowyWElementZWartoscia(dzwrot, "ReturnsNoticeDate", DataZwrotu)
                self.korekta.WstawWElement(wiersz, dzwrot)
            self.korekta.WstawW("Invoice-Lines", wiersz)

        # --------------------------------------
        self.korekta.WstawWRoot("Invoice-Summary")
        netto = 0
        netto_p = 0
        nettop = 0
        nettop_p = 0
        vat = 0
        vat_p = 0
        brutto = 0
        brutto_p = 0
        for w in DaneSV:
            netto += w["wartosc_netto"]
            netto_p += w["wartosc_netto_p"]
            vat += w["wartosc_vat"]
            vat_p += w["wartosc_vat_p"]
            brutto += w["wartosc_brutto"]
            brutto_p += w["wartosc_brutto_p"]
            #AB 03.02.22r
            if w["wartosc_vat"] > 0 or w["stawka_vat"] == '00':  #stawka 0% nie ma wartoci vat, ale jest opodatkowana
                nettop += w["wartosc_netto"]
            #AB 08.02.22r
            if w["wartosc_vat_p"] > 0 or w["stawka_vat"] == '00':  #stawka 0% nie ma wartoci vat, ale jest opodatkowana
                nettop_p += w["wartosc_netto_p"]

        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "TotalLines", str(nrpoz))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "TotalNetAmount", str(netto))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "TotalTaxableBasis", str(nettop))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "TotalTaxAmount", str(vat))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "TotalGrossAmount", str(brutto))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "PreviousTotalNetAmount", str(netto_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "PreviousTotalTaxableBasis", str(nettop_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "PreviousTotalTaxAmount", str(vat_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "PreviousTotalGrossAmount", str(brutto_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "CorrectionTotalNetAmount", str(netto - netto_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "CorrectionTotalTaxableBasis", str(nettop - nettop_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "CorrectionTotalTaxAmount", str(vat - vat_p))
        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "CorrectionTotalGrossAmount", str(brutto - brutto_p))

        self.korekta.WstawNowyWZWartoscia("Invoice-Summary", "GrossAmountInWords",
                                       (strip(DaneSL[0]["slownie"]).encode('utf-8')))

        # --------------------------------------
        self.korekta.WstawNowyW("Invoice-Summary", "Tax-Summary")
        for w in DaneSV:

            vat = w["wartosc_vat"]
            vatp = w["wartosc_vat_p"]
            netto = w["wartosc_netto"]
            nettop = w["wartosc_netto_p"]
            brutto = w["wartosc_brutto"]
            bruttop = w["wartosc_brutto_p"]

            tax = self.korekta.TworzNowy("Tax-Summary-Line")
            t = strip(w["stawka_vat"])[0:2]
            if t == "zw":
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxRate", "zw.")
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "E")

            elif t == "22":
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxRate", "22.00")
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "S")
            elif t == "23":
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxRate", "23.00")
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "S")
            else:
                t = t[1] + ".00"
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxRate", t)
                self.korekta.WstawNowyWElementZWartoscia(tax, "TaxCategoryCode", "S")
            self.korekta.WstawNowyWElementZWartoscia(tax, "TaxAmount", str(vat))
            # wg wersji 7.4
            # self.korekta.WstawNowyWElementZWartoscia(tax,"TaxableBasis",str(netto))
            self.korekta.WstawNowyWElementZWartoscia(tax, "TaxableAmount", str(netto))
            # wg wersji 7.4
            # self.korekta.WstawNowyWElementZWartoscia(tax,"GrossAmount",str(brutto))

            tp = strip(w["stawka_vat"])[0:2]
            if tp == "zw":
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxRate", "zw.")
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxCategoryCode", "E")
                self.korekta.WstawW("Tax-Summary", tax)
            elif tp == "22":
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxRate", "22.00")
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxCategoryCode", "S")
                self.korekta.WstawW("Tax-Summary", tax)
            elif tp == "23":
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxRate", "23.00")
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxCategoryCode", "S")
                self.korekta.WstawW("Tax-Summary", tax)
            else:
                tp = tp[1] + ".00"
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxRate", tp)
                self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxCategoryCode", "S")
            self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxAmount", str(vatp))
            # wg wersji 7.4
            # self.korekta.WstawNowyWElementZWartoscia(tax,"PreviousTaxableBasis",str(nettop))
            self.korekta.WstawNowyWElementZWartoscia(tax, "PreviousTaxableAmount", str(nettop))
            # wg wersji 7.4
            # self.korekta.WstawNowyWElementZWartoscia(tax,"PreviousGrossAmount",str(bruttop))
            self.korekta.WstawNowyWElementZWartoscia(tax, "CorrectionTaxAmount", str(vat - vatp))
            # wg wersji 7.4
            # self.korekta.WstawNowyWElementZWartoscia(tax,"CorrectionTaxableBasis",str(netto-nettop))
            self.korekta.WstawNowyWElementZWartoscia(tax, "CorrectionTaxableAmount", str(netto - nettop))
            # wg wersji 7.4
            # self.korekta.WstawNowyWElementZWartoscia(tax,"CorrectionGrossAmount",str(brutto-bruttop))
            self.korekta.WstawW("Tax-Summary", tax)

        # WS 2019-10-22
        ftp_nazwa = strip(DaneK[0]["ftp_nazwa"])
        ftp_katalog = strip(DaneK[0]["ftp_katalog"])
        if ftp_nazwa in ['', 'None']:
            ftp_nazwa = strip(DaneP[0]["ftp_nazwa"])
            ftp_katalog = strip(DaneP[0]["ftp_katalog"])
        if ftp_nazwa in ['', 'None']:
            ftp_nazwa = ''

        # AB 24.09.19r #WS 2019-10-22
        if ftp_nazwa != '':
            # if DaneP[0]["ftp_nazwa"] not in [None, '', 'None']:
            xml = self.korekta.PodajXML()

            # WS 2019-10-22
            arg = {'plik': xml, 'typ': 'korekta', 'nazwa': ftp_nazwa,
                   'sciezka': posixpath.join(firma_id, ftp_nazwa.strip('/'), ftp_katalog.strip('/'),
                                             nazwapliku + ".xml")}
            stat, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', {'Funkcja': 7, 'Argumenty': arg}, [], [])
            # arg = {'plik': xml, 'typ': 'korekta', 'nazwa': DaneP[0]["ftp_nazwa"],
            #        'sciezka': posixpath.join(firma_id, DaneP[0]["ftp_nazwa"].strip('/'), DaneP[0]["ftp_katalog"].strip('/'),
            #                                  nazwapliku + ".xml")}
            # stat, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', {'Funkcja': 7, 'Argumenty': arg})
            if stat != "OK":
                return 'Bdy wysyania faktury na serwer - ' + stat, True

        else:
            # WS 2019-10-22
            folder = strip(DaneK[0]["folder_korekty"])
            if folder in ['', 'None']:
                folder = strip(DaneP[0]["folder_korekty"])
            if folder in ['', 'None']:
                folder = ''

            # if DaneP[0]["folder_faktury"] in [None,'','None']:
            #     folder=''
            if folder != '':
                if os.name not in ['nt', 'dos']:
                    Znak = '/'
                else:
                    Znak = '\\'
                folder = folder + Znak
                # folder=strip(DaneP[0]["folder_korekty"])+Znak
            if not self.korekta.ZapiszPlik(folder + nazwapliku + ".xml"):
                return u"Bdy zapisu pliku: " + folder + nazwapliku + ".xml"
            else:
                if stat == 'OK':
                    stat, dane, dump, dump = WykonajFunkcje('fs_xml_korekta',
                                                                     [Wyznacznik, Data, Numer, CzyWszystko, Typ,
                                                                      True], [], [], [0, firma_id, '', ''])
                    if stat != "OK":
                        return 'Bedy pobierania danych - ' + stat

        # AB 18.09.19r #WS 2019-10-22
        return 'OK', ftp_nazwa != ''
        # return 'OK', DaneP[0]["ftp_nazwa"] not in [None, '', 'None']

