# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zakresy_dat.py
# Purpose:      
# Author:      Mariusz Rajfura
# Created:     2009/04/22
# RCS-ID:      $Id: fs_zakresy_dat.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2010-12-01 Mariusz Rajfura  pobieranie listy stawek VAT w funkcji PobierzZakresyDat (4099)
# 2011-11-03 Mariusz Rajfura  kontrola wybranych dat z 'data_minimum' (5159)
# 2018-05-15 Aleksander Bargie Zakresy dat z dokadnoci do oddziau (11034)
# 2018-05-28 Aleksander Bargie Czy dziala data minimalna w zakresie dat (11058)

#-------------------------------------------------------------------------------

def CzyWczesniejsza(DataWzorcowa, DataSprawdzana):
    if DataWzorcowa == '':
        return False
    else:
        return DataSprawdzana < DataWzorcowa

#-------------------------------------------------------------------------------

try:
    Fun = klucze[-1]
except:
    Fun = klucze['Funkcja']

SprzedOd = None
SprzedDo = None
MagazOd = None
MagazDo = None
FkOd = None
FkDo = None

stat = 'OK'
dane = []
wyn2 = []
pobrac = True

UprEdycja = ((self.oddzial_id, '001600' in self.uprawnienia) or self.operator_id==STANDARD_OPERATOR_ID)

if Fun==3 and not UprEdycja:
    stat = 'BR_UPR'
    dane.append(stat)

if stat=='OK' and Fun==5:    
    sql = "SELECT * FROM rs_zakresy_dat WHERE firma_id='"+self.firma_id+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    
    if stat=='OK':
        if len(dane) == 0:
            sql="INSERT INTO rs_zakresy_dat (firma_id) VALUES ('"+self.firma_id+"');"
            stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                dane.append(u'Bd inicjalizacji zakresw dat: '+stat)
            else:
                pobrac = True
        elif len(dane) == 1:
            pobrac = False
    else:
        dane.append(u'Bd pobrania zakresw dat: '+stat)

#AB 28-05-18 pobranie daty min dla obu funkcji zapisujacych dane
# -------------------------------------------------------------------------------
# ---   POBRANIE DATY MINIMUM ( 3, 13-update )
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3, 13):
    DataMinimum = ''
    sql = "SELECT COALESCE(data_minimum::TEXT,''::TEXT)"
    sql+= " FROM rs_zakresy_dat WHERE firma_id='"+self.firma_id+"';"
    stat,ZakresyDat,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        dane = []
        stat = u'Bd sprawdzenia daty minimum: '+stat
        dane.append(stat)
    elif len(ZakresyDat) == 1 and ZakresyDat <> '':
        DataMinimum = rsglobal.Dekoduj(ZakresyDat[0][0])

# -------------------------------------------------------------------------------
# ---   UPDATE DANYCH ( 3-update )
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun == 3:
    for i in range(len(pola)):

        pole = pola[i]
        wart = wartosci[i]

        if pole == 'sprzedaz_od':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    SprzedOd = wart
                    if CzyWczesniejsza(DataMinimum,SprzedOd):
                        stat = 'BL_SPRZED_OD_MINIMUM$'+DataMinimum
                        dane.append(stat)
                else:
                    stat = 'BL_SPRZED_OD'
                    dane.append(stat)

        elif pole == 'sprzedaz_do':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    SprzedDo = wart
                else:
                    stat = 'BL_SPRZED_DO'
                    dane.append(stat)

        elif pole == 'magazyn_od':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    MagazOd = wart
                    if CzyWczesniejsza(DataMinimum,MagazOd):
                        stat = 'BL_MAGAZ_OD_MINIMUM$'+DataMinimum
                        dane.append(stat)
                else:
                    stat = 'BL_MAGAZ_OD'
                    dane.append(stat)

        elif pole == 'magazyn_do':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    MagazDo = wart
                else:
                    stat = 'BL_MAGAZ_DO'
                    dane.append(stat)

        elif pole == 'fk_od':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    FkOd = wart
                    if CzyWczesniejsza(DataMinimum,FkOd):
                        stat = 'BL_KSIEG_OD_MINIMUM$'+DataMinimum
                        dane.append(stat)
                else:
                    stat = 'BL_KSIEG_OD'
                    dane.append(stat)

        elif pole == 'fk_do':
            if wart == '    -  -  ':
                wartosci[i] = 'NULL'
            else:
                if rsglobal.SprawdzCzyToData(wart):
                    FkDo = wart
                else:
                    stat = 'BL_KSIEG_DO'
                    dane.append(stat)

    # sprawdzenie wykonywane po zakonczeniu petli, dla lepszej czytelnosci
    # sprawdzenie par dat OD-DO, jesli obie pary dostepne

    if len(dane) == 0:
        if SprzedOd <> None and SprzedDo <> None and SprzedOd <> 'NULL' and SprzedDo <> 'NULL':
           if SprzedOd > SprzedDo:
               stat = 'BL_SPRZED_ODDO'
               dane.append(stat)

        if MagazOd <> None and MagazDo <> None and MagazOd <> 'NULL' and MagazDo <> 'NULL':
           if MagazOd > MagazDo:
               stat = 'BL_MAGAZ_ODDO'
               dane.append(stat)

        if FkOd <> None and FkDo <> None and FkOd <> 'NULL' and FkDo <> 'NULL':
            if FkOd > FkDo:
               stat = 'BL_KSIEG_ODDO'
               dane.append(stat)

    # czy jest OK po calym procesie kontroli
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[-1]


    # jesli stat=='OK', skladamy tekst UPDATE
    if stat=='OK':
        where = " WHERE firma_id='"+self.firma_id+"';"
        upd = "UPDATE rs_zakresy_dat SET "

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if wart == 'NULL':
                upd+=pole+"="+wart+","
            else:
                upd+=pole+"='"+wart+"',"

        upd = upd[0:len(upd)-1]+where

        stat,d,wyn1,dump = self.PolSQL.Execute(upd,1)
        if stat=='OK':
            pobrac = True
        else:
            dane.append(u'Bd aktualizacji zakresw dat: '+stat)
#AB 15.05.18r Dodanie selecta dla zakresow w oddzialach
if Fun == 13 and stat == 'OK':
    Dane = klucze['Update']
    sql = ''
    for i in range(len(Dane[0])):
        sql += "UPDATE rs_oddzialy SET "
        for j in range(len(Dane[0][i])):
            #AB 28-05-18 dodany warunek na date min
            if Dane[1][i][j] >= DataMinimum:
                if j > 0:
                    sql += ", "
                if Dane[1][i][j] == '':
                    val = 'NULL'
                else:
                   val = "'" + Dane[1][i][j] + "'"
                sql += Dane[0][i][j] + "=" + val + ""
            elif Dane[1][i][j] not in (None, 'None', '', '    -  -  '):
                stat = 'Data ' + Dane[0][i][j] + ' ' + Dane[1][i][j] + ' w oddziale ' + str(Dane[2][i][0])[:2] +\
                       ' jest wczeniejsza od daty minimalnej ' + DataMinimum
            elif Dane[1][i][j] in (None, 'None', '', '    -  -  '):
                if j > 0:
                    sql += ", "
                val = 'NULL'
                sql += Dane[0][i][j] + "=" + val + ""

        if stat == 'OK':
            sql += " WHERE firma_id ='" + self.firma_id + "' AND " + Dane[3][0] + " = '" + str(Dane[2][i][0])[:2] + "'; "
            stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 1)
        if stat != 'OK':
            dane.append(u'Bd zapisywania zakresw dat dla oddziaw: '+stat)
    rsglobal.ZapiszDoLogow(sql, 5)




#-------------------------------------------------------------------------------
#---   POBRANIE
#-------------------------------------------------------------------------------

if  stat=='OK' and pobrac:
    sql="SELECT * FROM rs_zakresy_dat WHERE firma_id='"+self.firma_id+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        dane.append(u'Bd pobrania zakresw dat1: '+stat)
        
if Fun == 5 and stat == 'OK':
    #pobranie listy stawek VAT dla zmiennych: RSGlobal.ListaStawek, RSGlobal.ListaStawekZn
    sql ="SELECT kod FROM rs_stawki_vat ORDER BY kod;"
    stat,dStawki,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = u'Bd pobrania listy stawek VAT: '+stat
        dane.append(stat)
    elif len(dStawki) == 0:
        stat = u'Brak zdefiniowanych stawek VAT w sowniku systemowym. Powiadom administratora systemu.'
        dane.append(stat)
    else:
        ListaStawek = []
        ListaStawekZn = []
        for i in xrange(len(dStawki)):
            Stawka = rsglobal.Dekoduj(dStawki[i][0])
            ListaStawek.append(Stawka)
            if not Stawka.isdigit():
                ListaStawekZn.append(Stawka)
                
        wyn2.append(['ListaStawek',ListaStawek])
        wyn2.append(['ListaStawekZn',ListaStawekZn])

#AB 15.05.18r Dodanie selecta dla zakresow w oddzialach
if Fun in (15, 13) and stat == 'OK':
    sql = "SELECT oddzial_id || ' - ' || opis, sprzedaz_od, sprzedaz_do, magazyn_od, magazyn_do FROM rs_oddzialy WHERE firma_id ='"
    sql += self.firma_id + "' AND oddzial_id != '**' ORDER BY oddzial_id;"
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        dane.append(u'Bd pobrania zakresw dat dla oddziaw: '+stat)
    rsglobal.ZapiszDoLogow(str(wyn1), 5)
