#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_zaleglosci.py
# Purpose:          przeglda zalegoci
# Author:           Micha Raburski
# Created:          2007/02/01
# RCS-ID:           $Id: fs_zaleglosci.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# Uwaga: w przypadku dodania nowego klucza nalezy poprawic i sprawdzic
# funkcje kompensaty (14), poniewaz funkcja pobiera dane od konca klucza

# 2011-05-09 Mariusz Rajfura 'Data uregulowania' do filtrow (4581)
# 2011-05-16 Mariusz Rajfura wybor checkboxem z grida (4583)
# 2011-05-30 Mariusz Rajfura kompensata dla sumy niezerowej (4620)
# 2011-06-07 Micha Raburski - zmiana sposobu rozliczania kompensat (4620)
# 2018-06-05 Aleksander Bargie kolumna Typ w zalegociach (11084)
# 2018-08-14 Aleksander Bargie - (11177) Wycofa zbdne informacje o MPP
# 2019-07-30 Aleksander Bargie - (11563) Bd przy filtrowaniu w przegldaniu zalegoci

def KompensujDwieZaleglosci(self,Zal1,Zal2,Data):
    import rsglobal
    stat='OK'
    LPodmiany=[0,0]
    SQL="SELECT typ_dok,COALESCE(wyznacznik_id,''),data,numer,oddzial_id,typ_dok_p,wyznacznik_id_p,data_p,numer_p," # 0-8
    SQL+=" kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli," #9-17
    SQL+="sposob_zaplaty,dni,data_odbioru, termin_zaplaty, handlowiec, sposob_odbioru_faktury," #18-23
    SQL+="czy_bonus,do_zaplaty,do_zaplaty_wal,symbol_wplaty,opis,numer_z_rs" #24-29
    SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(Zal1)+" AND ureg_data IS NULL FOR UPDATE"
    stat,DZal1,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return ('Bdy pobierania danych podanej nierozliczonej zalegoci o numerze '+str(Zal1)+" :"+stat,LPodmiany)
        
    if len(DZal1)==0:
        return ('Brak podanej nierozliczonej zalegoci o numerze '+str(Zal1),LPodmiany)
        
    SQL="SELECT typ_dok,COALESCE(wyznacznik_id,''),data,oddzial_id,numer,typ_dok_p,wyznacznik_id_p,data_p,numer_p,"
    SQL+=" kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,"
    SQL+="sposob_zaplaty,dni,data_odbioru, termin_zaplaty, handlowiec, sposob_odbioru_faktury,"
    SQL+="czy_bonus,do_zaplaty,do_zaplaty_wal,symbol_wplaty,opis,numer_z_rs"
    SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(Zal2)+" AND ureg_data IS NULL FOR UPDATE"
    stat,DZal2,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return ('Bdy pobierania danych podanej nierozliczonej zalegoci o numerze '+str(Zal2)+" :"+stat,LPodmiany)
        
    if len(DZal2)==0:
        return ('Brak podanej nierozliczonej zalegoci o numerze '+str(Zal2),LPodmiany)
    
    Wyzn1 =rsglobal.Dekoduj(DZal1[0][1])
    Wyzn2 =rsglobal.Dekoduj(DZal2[0][1])
    Wart1=DZal1[0][25]
    Wart2=DZal2[0][25]
    
    # sprawdzenie walut - tylko PLN
    if DZal1[0][14] <> 'PLN' or DZal2[0][14] <> 'PLN':
        return ('Bd - conajmniej jedna z podanych zalegoci jest walutowa.',LPodmiany)
    
    # wybranie opisu do ewentualnej nadpaty
    if Wyzn1 <>'' and Wyzn2 <> '':
        SymbWpl='Kompensata'
    elif Wyzn1=='':
        SymbWpl=rsglobal.Dekoduj(DZal1[0][27])
    else:
        SymbWpl=rsglobal.Dekoduj(DZal2[0][27])

    # sprawdzenie czy zapisy s rnych znakw
    if Wart1*Wart2>=0:
        return ('Nie mona rozliczy zapisw o tym samym znaku',LPodmiany)
    
    # wyliczenie rozliczanej kwoty
    KwotaRozl=min(abs(Wart1),abs(Wart2))
    
    # najpierw rozliczamy 
    if Wart1>0:
        Znak1='+'
        Znak2='-'
    else:
        Znak1='-'
        Znak2='+'
        
    SQL="UPDATE rs_zaleglosci SET ureg_data='"+Data+"',ureg_kwota= "+Znak1+str(KwotaRozl)+",symbol_wplaty='"+SymbWpl+"'"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(Zal1)+";"
    SQL+="UPDATE rs_zaleglosci SET ureg_data='"+Data+"',ureg_kwota= "+Znak2+str(KwotaRozl)+",symbol_wplaty='"+SymbWpl+"'"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(Zal2)+";"
    
    if abs(Wart1)<>KwotaRozl:
        TypDokF=rsglobal.Dekoduj(DZal1[0][0])
        if TypDokF in ('F','K'):
            SymbWplN=''
        else:
            SymbWplN=SymbWpl
            
        if Wart1>0:
            Rodzaj='P'
        else:
            Rodzaj='N'
        
        SQL+="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data, numer, oddzial_id,"
        SQL+="rodzaj, typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
        SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
        SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,"
        SQL+="symbol_wplaty,opis,numer_z_rs,ureg_kwota) SELECT "
        SQL+="firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,"
        SQL+="'"+Rodzaj+"',typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
        SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
        SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,"
        SQL+="do_zaplaty"+Znak2+str(KwotaRozl)+",do_zaplaty_wal"+Znak2+str(KwotaRozl)+","
        SQL+="'"+SymbWplN+"',opis,numer_z_rs,0"
        SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(Zal1)+";"
        
    elif abs(Wart2)<>KwotaRozl:
        TypDokF=rsglobal.Dekoduj(DZal2[0][0])
        if TypDokF in ('F','K'):
            SymbWplN=''
        else:
            SymbWplN=SymbWpl
            
        if Wart2>0:
            Rodzaj='P'
        else:
            Rodzaj='N'
        
        SQL+="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data, numer, oddzial_id,"
        SQL+="rodzaj, typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
        SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
        SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,"
        SQL+="symbol_wplaty,opis,numer_z_rs,ureg_kwota) SELECT "
        SQL+="firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,"
        SQL+="'"+Rodzaj+"',typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
        SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
        SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,"
        SQL+="do_zaplaty"+Znak1+str(KwotaRozl)+",do_zaplaty_wal"+Znak1+str(KwotaRozl)+","
        SQL+="'"+SymbWplN+"',opis,numer_z_rs,0"
        SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(Zal2)+";"

    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    
    if stat=="OK":
        # jeli by dodawany rekord do zalegoci to musimy go podstawi na licie
        if abs(Wart1)<>KwotaRozl:
            TypDokF=rsglobal.Dekoduj(DZal1[0][0])
            if TypDokF in ('F','K'):
                Warunek=" AND typ_dok='"+TypDokF+"' AND wyznacznik_id='"+rsglobal.Dekoduj(DZal1[0][1])+"'"
                Warunek+=" AND data='"+rsglobal.Dekoduj(DZal1[0][2])+"' AND numer="+str(DZal1[0][3])
            else:
                Warunek=" AND symbol_wplaty='"+SymbWpl+"'"
            
            SQL="SELECT nr_zal FROM rs_zaleglosci "
            SQL+="WHERE firma_id='"+self.firma_id+"'"+Warunek+" AND ureg_data IS NULL "
            SQL+=" ORDER BY nr_zal DESC FOR UPDATE NOWAIT;"
            stat,DZal1N,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DZal1N)>0:
                    LPodmiany[0]=DZal1N[0][0]
        
        elif abs(Wart2)<>KwotaRozl:
            TypDokF=rsglobal.Dekoduj(DZal2[0][0])
            if TypDokF in ('F','K'):
                Warunek=" AND typ_dok='"+TypDokF+"' AND wyznacznik_id='"+rsglobal.Dekoduj(DZal2[0][1])+"'"
                Warunek+=" AND data='"+rsglobal.Dekoduj(DZal2[0][2])+"' AND numer="+str(DZal2[0][3])
            else:
                Warunek=" AND symbol_wplaty='"+SymbWpl+"'"
            
            SQL="SELECT nr_zal FROM rs_zaleglosci "
            SQL+="WHERE firma_id='"+self.firma_id+"'"+Warunek+" AND ureg_data IS NULL "
            SQL+=" ORDER BY nr_zal DESC FOR UPDATE NOWAIT;"
            stat,DZal2N,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DZal2N)>0:
                    LPodmiany[1]=DZal2N[0][0]
    return (stat,LPodmiany)


#-------------------------------------------------------------------------------
#--- GWNA CZʦ OKNA
#-------------------------------------------------------------------------------

Oddzial=klucze[0]
Wyznacznik=klucze[1]
Kontrahent=klucze[2]
Platnik=klucze[3]
Handl=klucze[4]
NrZRS=klucze[5]
Term=str(klucze[6])
SposobZaplaty=klucze[7]
Hist=klucze[8]
TypDok=klucze[9]
RodzajDok=klucze[10]
DataUregulowania=klucze[11]

Fun=klucze[-1]

stat = "OK"
dane = []
wyn2 = []

#-------------------------------------------------------------------------------
# Kompensata (14)
#-------------------------------------------------------------------------------

if Fun in [14,] and stat=='OK':
    if not (((self.oddzial_id,'026015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR KOMP'

    if stat=='OK':
        Zaleglosci = klucze[-2][0]
        Data = rsglobal.Dekoduj(klucze[-2][1])
        
        if not rsglobal.SprawdzCzyToData(Data):
            stat = 'BL KOMP DATA'
            dane.append(stat)
            
    if stat == 'OK':
        SQL ="SELECT nr_zal,do_zaplaty,platnik_id, typ_dok,wyznacznik_id,data,numer,'','',0"
        SQL+=" FROM rs_zaleglosci "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND ureg_kwota=0"
        SQL+=" AND nr_zal IN "+str(Zaleglosci).replace("[","(").replace("]",")")
        SQL+=" ORDER BY COALESCE(data::TEXT,SPLIT_PART(symbol_wplaty,'/',2))"
        SQL+=" FOR UPDATE NOWAIT;"
        
        stat,DZal,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych kompensowanych zalegoci: '+stat
            dane.append(stat)
        elif len(DZal) < 2:
            stat = 'BL KOMP MIN DWIE POZ'
            dane.append(stat)
        elif len(DZal) <> len(Zaleglosci):
            stat = 'BL KOMP ROZNA ILOSC ZAPISOW'
            dane.append(stat)


    if stat == 'OK':
        # przegrupowanie zalegoci na dodatnie i ujemne
        Platnik=DZal[0][2]
        LPlus=[]
        LMinus=[]
        for zal in DZal:
            if stat=='OK':
                if Platnik<>zal[2]:
                    stat='BL PLAT'
            
            # pobranie faktury pierwotnej dla korekty
            if zal[3]=='K':
                SQL="SELECT COALESCE(wyznacznik_id_o,''),COALESCE(data_o::TEXT,''),COALESCE(numer_o,0)"
                SQL+=" FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(zal[4])+"'"
                SQL+=" AND data='"+rsglobal.Dekoduj(zal[5])+"' AND numer="+str(zal[6])
                stat,DKor,dump,dump = self.PolSQL.Execute(SQL,3)
                
                if stat=='OK':
                    if len(DKor)>0:
                        zal[7]=rsglobal.Dekoduj(DKor[0][0])
                        zal[8]=rsglobal.Dekoduj(DKor[0][1])
                        zal[9]=DKor[0][2]
            
            if stat=='OK':
                if zal[1]>0:
                    LPlus.append(zal)
                else:
                    LMinus.append(zal)
                
    if stat == 'OK':
        # przegldamy plus i sprawdzamy czy dla faktur nie ma korekt po stronie minus
        for zal in LPlus:
            if zal[3]=='F' and stat=='OK':
                # przejrzenie korekt 
                for zal2 in LMinus:
                    if zal2<>0:
                        if zal2[3]=='K' and zal<>0 and stat=='OK':
                            if zal[4:6]==zal2[7:9]:
                                stat,LPodst= KompensujDwieZaleglosci(self,zal[0],zal2[0],Data)
                                if stat=='OK':
                                    #za aktualn zalego wstawiamy jej nastpnika i wiemy, e bedzie nastpny w analizie
                                    if LPodst[0]>0:
                                        zalbuf=eval(str(zal))
                                        zalbuf[0]=LPodst[0]
                                        LPlus.insert(LPlus.index(zal)+1,zalbuf)
                                        
                                    elif LPodst[1]>0:
                                        zalbuf=eval(str(zal2))
                                        zalbuf[0]=LPodst[1]
                                        LMinus.insert(LMinus.index(zal2)+1,zalbuf)
    
                                    LPlus[LPlus.index(zal)]=0
                                    LMinus[LMinus.index(zal2)]=0
                                    zal=0
                                    zal2=0
            
        
        # rozliczamy reszt jak leci od najstarszych
        for zal in LPlus:
            if stat=='OK':
                for zal2 in LMinus:
                    if stat=='OK' and zal<>0 and zal2<>0:
                        stat,LPodst= KompensujDwieZaleglosci(self,zal[0],zal2[0],Data)
                        if stat=='OK':
                            #za aktualn zalego wstawiamy jej nastpnika i wiemy, e bedzie nastpny w analizie
                            if LPodst[0]>0:
                                zalbuf=eval(str(zal))
                                zalbuf[0]=LPodst[0]
                                LPlus.insert(LPlus.index(zal)+1,zalbuf)
                                
                            elif LPodst[1]>0:
                                zalbuf=eval(str(zal2))
                                zalbuf[0]=LPodst[1]
                                LMinus.insert(LMinus.index(zal2)+1,zalbuf)
        
                            LPlus[LPlus.index(zal)]=0
                            LMinus[LMinus.index(zal2)]=0
                            zal=0
                            zal2=0


#-------------------------------------------------------------------------------
# -- ZMIANA UREGULOWANIA Z JEDNEJ ZALEGOCI NA DRUG (12)
#-------------------------------------------------------------------------------

if Fun in [12,] and stat=='OK':
    if not (((self.oddzial_id,'026016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR ZM UREG'

    if stat=='OK':
        ZalUreg = klucze[-2][0]
        ZalNUreg = klucze[-2][1]
        
    if stat == 'OK':
        SQL="SELECT typ_dok,wyznacznik_id,data,numer,rodzaj,ureg_kwota,ureg_data,symbol_wplaty" #0-7
        SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND nr_zal="+str(ZalUreg)+" AND NOT ureg_data IS NULL FOR UPDATE NOWAIT"
        stat,DZalUreg,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat= 'Bdy pobierania danych podanej rozliczonej zalegoci o numerze '+str(ZalUreg)+" :"+stat
        elif len(DZalUreg)==0:
            stat= 'Brak podanej rozliczonej zalegoci o numerze '+str(ZalUreg)
        elif not DZalUreg[0][0] in ['F','K']:
            stat= 'Zalego o numerze '+str(ZalUreg)+" nie jest typu F lub K"
        
    if stat == 'OK':
        SQL="SELECT typ_dok,wyznacznik_id,data,numer,rodzaj,do_zaplaty" #0-5
        SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(ZalNUreg)+" AND ureg_data IS NULL FOR UPDATE NOWAIT"
        stat,DZalNUreg,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat= 'Bdy pobierania danych podanej nierozliczonej zalegoci o numerze '+str(ZalNUreg)+" :"+stat
        elif len(DZalNUreg)==0:
            stat= 'Brak podanej nierozliczonej zalegoci o numerze '+str(ZalNUreg)
        elif not DZalNUreg[0][0] in ['F','K']:
            stat= 'Zalego o numerze '+str(ZalNUreg)+" nie jest typu F lub K"
        
    # sprawdzamy, czy s tego samego typu
    if stat=='OK':
        if DZalNUreg[0][0]<>DZalUreg[0][0]:
            stat= "Wybrane zalegoci maj rne typy"
    
    # sprawdzamy, czy da si to przesun. 
    if stat=='OK':
        if DZalUreg[0][5]*DZalNUreg[0][5]<0:
            stat= 'Nie mona przesun kwoty uregulowanej do nieuregulowanej zalegoci'
    
    
    
    #Wyznaczamy te automatycznie dat i kwot przesunicia.(pomidzy dat nieuregulowanego dokumentu a dat uregulowania)
    if stat=='OK':
        KwotaUreg=cmp(DZalUreg[0][5],0)*min(abs(DZalUreg[0][5]),abs(DZalNUreg[0][5]))
        DataUreg=max(DZalUreg[0][6],DZalNUreg[0][2])
        
        
    # pobieramy dane historyczne uregulowania by zbudowa now list uregulowa 
    if stat=='OK':
        SQL="SELECT nr_zal,rodzaj,symbol_wplaty,ureg_kwota,ureg_data,ureg_typ,ureg_numer,do_zaplaty "
        SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(DZalUreg[0][0])+"'"
        SQL+=" AND wyznacznik_id='"+rsglobal.Dekoduj(DZalUreg[0][1])+"' AND data='"+rsglobal.Dekoduj(DZalUreg[0][2])+"'"
        SQL+=" AND numer="+str(DZalUreg[0][3])+" ORDER BY COALESCE(ureg_data::TEXT,'') FOR UPDATE NOWAIT;"
        stat,DZaleg,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat= 'Bdy pobierania danych historycznych uregulowa zalegoci o numerze '+str(ZalUreg)+" :"+stat
            
    if stat=='OK':
        # pobieramy kwot i zalego pocztkow (to ta z rodzajem "Z")
        ZalPocz=0
        for poz in DZaleg:
            if poz[1]=='Z':
                KwotaPocz=poz[7]
                ZalPocz=poz[0]
                break
        
        if ZalPocz==0:
            stat="Brak zalegoci pocztkowej dla zalegoci "+str(ZalUreg)
            
    if stat=='OK':
        # wstawiamy uregulowanie czci nieuregulowanej
        SQL="UPDATE rs_zaleglosci SET ureg_data='"+DataUreg+"',ureg_kwota= "+str(KwotaUreg)+","
        SQL+="symbol_wplaty='"+rsglobal.Dekoduj(DZalUreg[0][7])+"'"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(ZalNUreg)+";"
        
        # jeli nie rozliczamy caej zalegoci to tworzymy jej podzalego
        if abs(KwotaUreg)<>abs(DZalNUreg[0][5]):
            if DZalNUreg[0][5]>0:
                Rodzaj='P'
            else:
                Rodzaj='N'
                
            SQL+="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data, numer, oddzial_id,"
            SQL+="rodzaj, typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
            SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
            SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,"
            SQL+="symbol_wplaty,opis,numer_z_rs,ureg_kwota) SELECT "
            SQL+="firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,"
            SQL+="'"+Rodzaj+"',typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
            SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
            SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,"
            SQL+="do_zaplaty- "+str(KwotaUreg)+",do_zaplaty_wal- "+str(KwotaUreg)+","
            SQL+="'',opis,numer_z_rs,0"
            SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(ZalNUreg)+";"
    
        # usuwamy stare uregulowania/zalegoci przejciowe i czycimy zalego pocztkow
        FiltrZalUreg="firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(DZalUreg[0][0])+"'"
        FiltrZalUreg+=" AND wyznacznik_id='"+rsglobal.Dekoduj(DZalUreg[0][1])+"' AND data='"+rsglobal.Dekoduj(DZalUreg[0][2])+"'"
        FiltrZalUreg+=" AND numer="+str(DZalUreg[0][3])
        
        SQL+="DELETE FROM rs_zaleglosci WHERE "+FiltrZalUreg+" AND nr_zal<>"+str(ZalPocz)+";"
        
        SQL+="UPDATE rs_zaleglosci SET ureg_data=NULL,ureg_kwota=0,symbol_wplaty=''"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(ZalPocz)+";"
        
        # wstawiamy list regulacji wyrzucajc uregulowanie wybranej wczeniej zalegoci
        UregAkt=0
        for poz in DZaleg:
            if poz[3]<>0:
                if not ((poz[0]==ZalUreg) and abs(poz[3])==abs(KwotaUreg)):
                    # zmieniamy nieuregulowan zalego a potem tworzymy jej pomniejszon o uregulowanie kopi
                    if poz[0]==ZalUreg:
                        KwotaPom=poz[3]-KwotaUreg
                    else:
                        KwotaPom=poz[3]
                    KwotaPo="do_zaplaty- "+str(UregAkt)+"- "+str(KwotaPom)
                    KwotaPoWal="do_zaplaty_wal- "+str(UregAkt)+"- "+str(KwotaPom)
                    Rodzaj="CASE WHEN "+KwotaPo+">0 THEN 'N' ELSE 'P' END"
                    UregAkt+=KwotaPom                    
                    SQL+="UPDATE rs_zaleglosci SET ureg_data='"+rsglobal.Dekoduj(poz[4])+"',"
                    SQL+="ureg_kwota= "+str(KwotaPom)+",symbol_wplaty='"+rsglobal.Dekoduj(poz[2])+"' WHERE "+FiltrZalUreg+" AND ureg_data IS NULL;"

                    if UregAkt <> KwotaPocz:
                        SQL+="INSERT INTO rs_zaleglosci (firma_id,typ_dok,wyznacznik_id,data, numer, oddzial_id,"
                        SQL+="rodzaj, typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
                        SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
                        SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,"
                        SQL+="symbol_wplaty,opis,numer_z_rs,ureg_kwota) SELECT "
                        SQL+="firma_id,typ_dok,wyznacznik_id,data,numer,oddzial_id,"
                        SQL+=Rodzaj+",typ_dok_p,wyznacznik_id_p, data_p, numer_p, kontrahent_id,zamawiajacy_id,platnik_id,kierowca,"
                        SQL+="projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,"
                        SQL+="termin_zaplaty, handlowiec,sposob_odbioru_faktury,czy_bonus,"
                        SQL+=KwotaPo+","+KwotaPoWal+","
                        SQL+="'',opis,numer_z_rs,0"
                        SQL+=" FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(ZalPocz)+";"
                    
                    
                
        
    if stat=='OK':
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        
        
#-------------------------------------------------------------------------------
# -- zmiana daty ureg (10)
#-------------------------------------------------------------------------------

## zakomentowane zgodnie z decyzja (4581)
##if (Fun in [10]):
##    NrZal=klucze[0]
##    data_ureg=klucze[1]
##    kwota_ureg=klucze[2]
##    symbol_wplaty=rsglobal.Dekoduj(klucze[3])
##    termin_platnosci=rsglobal.Dekoduj(klucze[4])
##    if data_ureg<>'    -  -  ':
##        if not rsglobal.SprawdzCzyToData(data_ureg):
##            stat='BL DAT UREG'
##            dane.append(stat)
##    if not rsglobal.SprawdzCzyToData(termin_platnosci):
##        stat='BL TER PLAT'
##        dane.append(stat)
##    if kwota_ureg<>0:
##        SELECT="SELECT do_zaplaty,ureg_kwota FROM rs_zaleglosci WHERE nr_zal="+str(NrZal)+";"
##        st,d,dump,dump=self.PolSQL.Execute(SELECT,3)
##        if st<>'OK':
##            stat='BL PRZ KW UR'
##            dane.append(stat)
##        else:
##            #if kwota_ureg<>d[0][0] and kwota_ureg<>d[0][1]:
##            if kwota_ureg<>d[0][0] and kwota_ureg<>0:
##                stat='BL KW UREG'
##                dane.append(stat)
##    
##    
##    if stat=='OK':    
##        if data_ureg<>'    -  -  ':
##            Update="UPDATE rs_zaleglosci SET ureg_data='"+data_ureg+"',ureg_kwota="+str(kwota_ureg)+",symbol_wplaty='"+symbol_wplaty+"',termin_zaplaty='"+termin_platnosci+"' WHERE nr_zal="+str(NrZal)+";"
##        else:
##            Update="UPDATE rs_zaleglosci SET ureg_data=NULL,ureg_kwota="+str(kwota_ureg)+",symbol_wplaty='"+symbol_wplaty+"',termin_zaplaty='"+termin_platnosci+"' WHERE nr_zal="+str(NrZal)+";"
##        stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
##        if stat<>'OK':
##            stat='BL UPD DATA UREG'
##            dane.append(stat)


#-------------------------------------------------------------------------------
# pobranie kwoty limitu dla kontrahenta lub platnika (16)
# w przypadku znalezienia limitu, zwraca informacje, czy to limit dla
# kontrahenta czy tez platnika
#-------------------------------------------------------------------------------

if Fun == 16 and stat=='OK':
    JestLimit = False
    Kontrahent = rsglobal.Dekoduj(Kontrahent).strip()
    Platnik = rsglobal.Dekoduj(Platnik).strip()
    
    #czy sprawdzac Kontrahenta
    if Kontrahent <> '':
        #sprawdzamy najpierw kontrahenta
        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+Kontrahent+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia kontrahenta: '+stat
            dane.append(stat)
        elif len(d) == 1:
            #jest kontrahent, wiec sprawdzamy limit
            #pobranie limitu z ostatnich danych fakturowych dla konkretnego kontrahenta
            sql ="SELECT maks_wart,data_od FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
            sql+=" AND data_od <= NOW()::DATE"
            sql+=" ORDER BY data_od DESC LIMIT 1;"

            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania limitu dla kontrahenta '+Kontrahent
                dane.append(stat)
            elif len(d) == 1:
                #jest limit dla kontrahenta
                dane.append(['kontr.'+Kontrahent+'  ('+str(d[0][1])+')',d[0][0]])
                JestLimit = True
            
    if stat == 'OK' and not JestLimit and Platnik <> '':
        #nie udalo sie znalezc limitu dla Kontrahenta, a jest podany Platnik
        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+Platnik+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia patnika: '+stat
            dane.append(stat)
        elif len(d) == 1:
            #jest taki platnik, wiec sprawdzamy limit
            #pobranie limitu z ostatnich danych fakturowych dla konkretnego kontrahenta
            sql ="SELECT maks_wart,data_od FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"'"
            sql+=" AND data_od <= NOW()::DATE"
            sql+=" ORDER BY data_od DESC LIMIT 1;"

            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania limitu dla patnika '+Platnik
                dane.append(stat)
            elif len(d) == 1:
                #jest limit dla platnika
                dane.append(['pat.'+Platnik+'  ('+str(d[0][1])+')',d[0][0]])


#-------------------------------------------------------------------------------
# -- przegladanie (5,14)
#-------------------------------------------------------------------------------

if (Fun in [5,14,12]) and stat=='OK':
    if not (((self.oddzial_id,'026011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='BL UPR'

    if stat=='OK':
        Filtr = " z.firma_id = '" + self.firma_id+"'"        
        if self.operator_id<>STANDARD_OPERATOR_ID:
            oddzialy=[]
            for upr in self.uprawnienia:
                if rsglobal.Dekoduj(upr[1]) =='026011':
                    oddzialy.append(rsglobal.Dekoduj(upr[0]))
            Filtr+=" AND z.oddzial_id in ("+str(oddzialy).rstrip(']').lstrip('[').strip(',')+")"
        if self.handlowiec_id<>None:
            Filtr+=" AND z.handlowiec = '"+self.handlowiec_id+"'"
        if Oddzial <> '': 
            Filtr+=" AND z.oddzial_id = '" + Oddzial +"'"
        if Wyznacznik <> '': 
            Filtr+=" AND z.wyznacznik_id = '" + Wyznacznik +"'"
        if Kontrahent <>'': 
            Filtr+=" AND z.kontrahent_id LIKE '" + Kontrahent + "%'"
        if Platnik <> '':
            Filtr+=" AND z.platnik_id LIKE '" + Platnik + "%'"
        if Handl <> '':
            Filtr+=" AND z.handlowiec='" + Handl + "'"
        if SposobZaplaty.strip()<>'':
            Filtr+=" AND z.sposob_zaplaty='"+SposobZaplaty+"'"
        if NrZRS <> '':
            Filtr+=" AND z.numer_z_rs LIKE '" + NrZRS + "%'"
        if Term <> '0':
            Filtr+=" AND z.termin_zaplaty + integer '" + str(Term) + "'<= now()"        

        if not Hist:
            Filtr+=" AND"
            ZamknijFiltr = ''
            if DataUregulowania<>'    -  -  ':
                if not rsglobal.SprawdzCzyToData(DataUregulowania):
                    stat = 'BL DAT UREG'
                else:
                    Filtr+=" ((ureg_data IS NULL OR ureg_data='"+DataUregulowania+"') OR ("
                    ZamknijFiltr = "))"
                        
            Filtr+=" z.ureg_kwota=0 AND z.do_zaplaty<>0" + ZamknijFiltr
        elif DataUregulowania<>'    -  -  ':
            if not rsglobal.SprawdzCzyToData(DataUregulowania):
                stat = 'BL DAT UREG'
            else:
                Filtr+=" AND (ureg_data IS NULL OR ureg_data='"+DataUregulowania+"')"

        if TypDok<>'':
            Filtr+=" AND typ_dok in "+rsglobal.UsSl(TypDok)
        if RodzajDok<>"":
            Filtr+=" AND rodzaj in "+rsglobal.UsSl(RodzajDok)
            
        #pobranie wyznacznika, daty, numeru, typu dokumentu faktury/korekty
        SELECT=" SELECT FALSE,CASE WHEN z.wyznacznik_id IS NULL OR z.data IS NULL OR z.numer IS NULL "
        SELECT+="OR z.typ_dok IS NULL THEN z.wyznacznik_id||'/'||z.data||'/'||z.numer "
        SELECT+="ELSE rsf_podaj_numer_dokumentu_na_wydruk(z.firma_id,'[\"'||z.wyznacznik_id||'\",\"'||z.data||'\",\"'||z.numer||'\"]', z.typ_dok) END, "
        SELECT+="z.data,z.rodzaj, z.oddzial_id, z.platnik_id ||' - '||p.nazwa, z.sposob_zaplaty, z.termin_zaplaty, z.do_zaplaty, "
        SELECT+="z.handlowiec, z.projekt_id, z.ureg_kwota, z.ureg_data, z.kontrahent_id ||' - '||k.nazwa,z.symbol_wplaty,"
       #AB 14.08.18r
        #SELECT+="mpp_typ,"
        SELECT+=" z.nr_zal, z.numer_z_rs"
        
        FROM=" FROM rs_zaleglosci z LEFT OUTER JOIN rs_kontrahenci k ON (z.kontrahent_id=k.kontrahent_id AND z.firma_id=k.firma_id) LEFT OUTER JOIN rs_kontrahenci p ON (z.platnik_id=p.kontrahent_id AND z.firma_id=p.firma_id) " 
        WHERE=" WHERE "+Filtr
        ORDER=" ORDER BY z.data,z.wyznacznik_id,z.numer,z.nr_zal"
        #AB 30.07.19r dodany limit
        sql=SELECT+FROM+WHERE+ORDER + " LIMIT 100000;"
        stat,dane,wyn1,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        rsglobal.ZapiszDoLogow(sql, 5)
        if stat!="OK":
            stat="BL_SQL"
            dane=[stat]