#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_zaleglosci_sprawdzenie.py
# Purpose:          funkcja porownuje zaleglosc podanego kontrahenta w rs_zaleglosci
#                   z jego limitem, okreslonym w rs_kontrahenci_fakturowanie
#                   z uwzglednieniem podanej kwoty
# Author:           Mariusz Rajfura
# Created:          2010/07/26
# RCS-ID:           $Id: fs_zaleglosci_sprawdzenie.py $
# Copyright:        (c) 2010 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

#maks_wart == -1 oznacza BEZ LIMITU  mariusz rajfura  2010/08/13/ mantis:3802  

def SprawdzLimitKontrahenta(obj, Kontrahent, Kwota=0, Data=None):
    #wynik == 'OK' - kontrahent miesci sie w limicie
    #wynik == 'LIMIT' - kontrahent osiagnal/przekroczyl limit
    #kazdy inny kod oznacza blad przetwarzania danych lub blad wykonania SQL
    
    Kontrahent = str(Kontrahent).strip()
    if Kontrahent in ('', 'None'):
        return 'Brak kodu kontrahenta'

    sql ="SELECT kontrahent_id FROM rs_kontrahenci"
    sql+=" WHERE firma_id='"+obj.firma_id+"'"
    sql+=" AND kontrahent_id='"+Kontrahent+"';"

    stat,d,dump,dump = obj.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        return 'Bd sprawdzenia kontrahenta: '+stat
    elif len(d) == 0 or len(d) > 1:
        return 'Bdny kod kontrahenta'

    if stat == 'OK':
        #pobranie limitu z danych fakturowych dla konkretnego kontrahenta
        sql ="SELECT maks_wart FROM rs_kontrahenci_fakturowanie"
        sql+=" WHERE firma_id='"+obj.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
        if Data <> None:
            sql+= " AND data_od <= '"+Data+"'"
        sql+=" ORDER BY data_od DESC LIMIT 1;"

        stat,Limit,dump,dump = obj.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            return 'Bd pobrania limitu dla kontrahenta '+Kontrahent
        elif len(Limit) == 0 or Limit[0][0] == -1:
            #brak limitu dla kontrahenta lub limit==-1 czyli bez limitu
            return 'OK'

    if stat == 'OK':
        #sprawdzenie, czy sa jakies zaleglosci
        #kontrahent jest sprawdzany na LIKE, bo tak samo sa wyswietlane
        #zaleglosci w fs_zaleglosci
        sql ="SELECT do_zaplaty FROM rs_zaleglosci"
        sql+=" WHERE firma_id='"+obj.firma_id+"' AND kontrahent_id LIKE '"+Kontrahent+"%'"
        sql+=" AND do_zaplaty <> 0 AND ureg_kwota=0;"

        stat,d,dump,dump = obj.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            return 'Bd sprawdzenia dozwolonego limitu: '+stat
        elif len(d) == 0:
            #kontrahent nie posiada zadnych zaleglosci
            return 'OK'

    #naliczam sume zaleglosci
    SumaZaleg = 0
    for i in d:
        SumaZaleg += i[0]


    if Kwota == 0:
        #Nie podano kwoty, czyli sprawdzamy biezacy stan zalegosci w
        #porownaniu do limitu. W tym przypadku informacja o wykorzystaniu
        #limitu pojawia sie, kiedy suma zaleglosci osiaga wartosc limitu
        if SumaZaleg < Limit[0][0]:
            return 'OK'
        else:
            return 'LIMIT'
    
    #Jesli podano kwote, to sprawdzamy czy zmiesci sie w podanym limicie
    #z uwzglednieniem tej kwoty. Roznica w stosunku do sytuacji sprawdzanej
    #gdy Kwota==0, jest taka, ze Zaleglosci+Kwota==Limit nie zwracaja
    #kodu 'LIMIT' tylko 'OK'. Kod 'LIMIT' jest zwracany wtedy, gdy suma
    #zaleglosci+Kwota przekracza limit. Taka sytucja wystepuje
    #przy zamykaniu dokumetu
    if SumaZaleg+Kwota <= Limit[0][0]:
        #zaleglosc+kwota miesci sie w limicie
        return 'OK'
    else:
        #limit osiagniety lub nawet przekroczony
        return 'LIMIT'
