#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_dostawcy.py
# Purpose:		dodaje/pobiera/usuwa zamowienia dostawcy
# Author:		Marcin Grzeda
# Created:		2008/01/04
# RCS-ID:		$Id: fs_zamowienia_dostawcy.py $
# Copyright:	(c) 2017 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

# 2011-09-21 Mariusz Rajfura - blokady SELECT FOR UPDATE dla zamowien dosatwcy (4931)
# 2017-05-16 Piotr Witkowski - Refaktoryzacja okna (10501)
# 2021-06-08 Aleksander Bargie [MG] Status w zamwieniach do dostawcow  (12513)
# 2021-06-10 Wojciech Skowron - Usuwanie plikw przy usuwaniu zamwienia (12514)
# 2021-10-27 Aleksander Bargie [GM] zakleszczenie systemu (12688)
# 2023-08-19 Jan Raburski sprawdzenie wymagalnosci miejsca dostawy (13516)
# plus uporzadkowanie obslugi stat=='OK'
# 2023-09-20 Aleksander Bargie  Bd usuwania zamwienia dostawcy - problem z usuwaniem plikw

import rssql  #AB 29.10.21r
from funkcje import fs_zamowienia_dostawcy_pom

stat='OK'
firma_id = self.firma_id  #AB 29.10.21r
Oddzial  = self.oddzial_id  #AB 29.10.21r
puste = (None, '', '    -  -  ', 'None', '-  -')  #AB 29.10.21r

if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik':[6,7,8],'Data':[6,7,8],'Numer':[6,7,8],  #AB 29.10.21r
           'StanF':[5,6,7], 'WyznF':[5,6,],'DataOdF':[5,6,],
           'DataDoF':[5,6,],'KontrahentF':[5,6,],'TypF':[5,6,],
           'HandlowiecF':[5,6,],'ArtykulF':[5,6,],'KontrahentF':[5,6,],'Klucze':[5,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_zamowienia_dostawcy z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [6,7,8]:  #AB 29.10.21r
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [5,6,7]:
            StanF = str(klucze['StanF'])
        if Funkcja in [5,6,]:
            WyznF       = str(klucze['WyznF'])
            DataOdF     = str(klucze['DataOdF'])
            DataDoF     = str(klucze['DataDoF'])
            KontrahentF = str(klucze['KontrahentF'])
            TypF        = str(klucze['TypF'])
            HandlowiecF = str(klucze['HandlowiecF'])
            ArtykulF    = str(klucze['ArtykulF'])
            StatusF     = str(klucze['StatusF'])  #AB 08.06.21r
            Klucze      = []
        if Funkcja in [5,]:
            Klucze = klucze['Klucze']
if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = ['    -  -  ','',[]]
    format_daty = "%Y-%m-%d"

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    if LWyzn==[]:
        stat='BR LWYZN'
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrz=True
        UprEdy=True
        UprDel=True
        UprZam=True
        UprOtw=True
        LPrz=LWyzn
        LEdy=LWyzn
        LDel=LWyzn
        LZam=LWyzn
        LOtw=LWyzn
        LPrz.append('ZASLEPKA')
    else:
        UprPrz=(self.oddzial_id,'037010') in self.uprawnienia
        UprEdy=((self.oddzial_id,'037012') in self.uprawnienia) or ((self.oddzial_id,'037013') in self.uprawnienia)
        UprDel=(self.oddzial_id,'037014') in self.uprawnienia
        UprZam=(self.oddzial_id,'037016') in self.uprawnienia
        UprOtw=(self.oddzial_id,'037017') in self.uprawnienia

        LPrz=['ZASLEPKA']
        LEdy=[]
        LDel=[]
        LZam=[]
           
        if UprEdy and (Funkcja in [7,5]):
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]
                                 
        if stat=='OK':
            if UprPrz and Funkcja in [5,6]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[True,False,False,False,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LPrz=rsglobal.rseval(wyzn[0][0])[1]
                             
        if stat=='OK':                       
            if UprDel and Funkcja in [6]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LDel=rsglobal.rseval(wyzn[0][0])[1]
                                        
        if stat=='OK': 
            if UprZam and Funkcja in [7, ]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,False,True,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LZam=rsglobal.rseval(wyzn[0][0])[1]

        if stat == 'OK':
            if UprOtw and Funkcja in [8, ]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,False,False,True]');"
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LOtw=rsglobal.rseval(wyzn[0][0])[1]

if stat=='OK' and Funkcja in [5,6]:
#sprawdzanie poprawnoci dat 
    if DataOdF != '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataOdF):
            stat='BL DATAOD'
            dane.append(stat)
    if DataDoF != '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataDoF):
            stat='BL DATADO'
            dane.append(stat)
    if DataOdF<>'    -  -  ' and  DataDoF<>'    -  -  ':
        if DataOdF > DataDoF:
            stat='BL ZAKR DAT'
            dane.append(stat)
        

#-------------------------------------------------------------------------------
# -- Usuwanie 6 -- #
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6]:
    if not (UprDel and (Wyznacznik in LDel)) and self.operator_id != STANDARD_OPERATOR_ID:
        stat='UPR DEL'
        dane.append(stat)

    if stat =='OK':
        sql ="SELECT stan FROM rs_zamowienia_dostawcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Zamwienie dostawcy zablokowane przez innego operatora.'
            stat+= ' Operacja usunicia niemoliwa.'
            dane.append(stat)
        
    if stat=='OK':    
        Select= "SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\""+Wyznacznik+"\",\""+Data+"\","+Numer+"]','ZD')"
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
    if stat=='OK':
        if d[0][0]<>'OK':
            stat='NUM NOT LAST'
            dane.append(stat)

        
    if stat=='OK':
        Filtr = " firma_id = '" + self.firma_id + "' AND wyznacznik_id = '" + Wyznacznik + "'"
        Filtr+= " AND data = '" + Data + "' AND numer = " + Numer
        Select= "SELECT stan FROM rs_zamowienia_dostawcy WHERE" + Filtr
        st,d,dump,dump=self.PolSQL.Execute(Select,2);
        if st<>'OK':
            stat='BL SEL STAN'
            dane.append(stat)
        elif len(d)==0:
            stat='BL FILTR'
            dane.append(stat)
        elif d[0][0]<>'W':
            stat='BL STAN'
            dane.append(stat)
        else:
            # usunicie plikw zamwienia
            stat = fs_zamowienia_dostawcy_pom.UsunPlikiZamowienia(self,Wyznacznik,Data,Numer)  #AB 2023-09-20
            if stat == 'OK':
                Delete="DELETE FROM rs_zamowienia_dostawcy WHERE "+Filtr+";"
                st,dump,dump,dump=self.PolSQL.Execute(Delete,1)
                if st!="OK":
                    stat="BL DEL"
                    dane.append(stat)


#-------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6 -- #
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6]:
    if not UprPrz and self.operator_id != STANDARD_OPERATOR_ID:
        stat='UPR PRZ'
        dane.append(stat)
    if stat=='OK':       
        Filtr = " (zd.firma_id = '" + self.firma_id+"' AND zd.oddzial_id = '"+self.oddzial_id+"'"
        if WyznF not in puste_pola: 
            Filtr+=" AND zd.wyznacznik_id = '" + WyznF +"'"
        if DataOdF not in puste_pola: 
            Filtr+=" AND zd.data >= '" + DataOdF + "'"
        if DataDoF not in puste_pola: 
            Filtr+=" AND zd.data <= '" + DataDoF + "'"
        if KontrahentF not in puste_pola: 
            Filtr+=" AND zd.kontrahent_id LIKE '" + KontrahentF + "%'"
        if StanF not in puste_pola: 
            Filtr+=" AND zd.stan='" + StanF +"'"
        if TypF<>'':
            Filtr+=" AND zd.typ_zamowienia='"+TypF+"'"
        if HandlowiecF<>'':
            Filtr+=" AND zd.handlowiec='"+HandlowiecF+"'" 
        if not self.handlowiec_id in ('None',None,''):
            Filtr+=" AND zd.handlowiec='"+self.handlowiec_id+"'"
        if ArtykulF <>'':
            Filtr+=" AND zdp.artykul_id LIKE '"+ArtykulF+"%'"
        #AB 08.06.21r
        if StatusF != '':
            Filtr += " AND zd.status_zamowienia = '"+StatusF+"'"
        Filtr+=") "
        #rsglobal.ZapiszDoLogow(Klucze,1)
        if Klucze<>[]:
            Filtr+="OR (zd.firma_id='"+self.firma_id+"' AND zd.wyznacznik_id='"+Klucze[0][0]+"' AND zd.data='"+Klucze[0][1]+"' AND zd.numer="+Klucze[0][2]+") "
        
        SELECT ="SELECT zd.stan,zd.data,zd.wyznacznik_id,zd.numer,zd.kontrahent_id||' - '||kon.nazwa,zd.typ_zamowienia,zd.kwota_netto,zd.oddzial_id,zd.handlowiec,"
        SELECT+=" zd.zamowienie_nr, status_zamowienia "  #AB 08.06.21r
        FROM="FROM rs_zamowienia_dostawcy zd INNER JOIN rs_kontrahenci kon ON (zd.kontrahent_id=kon.kontrahent_id AND zd.firma_id=kon.firma_id)"
        if ArtykulF<>'':
            FROM+=" LEFT OUTER JOIN rs_zamowienia_dostawcy_pozycje zdp ON (zd.firma_id=zdp.firma_id "
            FROM+=" AND zd.wyznacznik_id=zdp.wyznacznik_id AND zd.data=zdp.data AND zd.numer=zdp.numer)"
        WHERE=" WHERE zd.wyznacznik_id in ("+str(LPrz)[1:-1]+") AND "+ Filtr
        ORDER=" ORDER BY zd.kontrahent_id,zd.data,zd.wyznacznik_id,zd.numer;"
        sql=SELECT+FROM+WHERE+ORDER
        #rsglobal.ZapiszDoLogow(sql,1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        if stat!="OK":
            stat="BL SQL PRZ"
            dane.append(stat)


#-------------------------------------------------------------------------------
# Zamykanie - 7
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [7]) and (len(LWyzn)>0):
    if not (UprZam and (Wyznacznik in LZam)) and self.operator_id != STANDARD_OPERATOR_ID:
        stat='UPR ZAM'
        dane.append(stat)
    if StanF=='W':
        NastStan='G'
    elif StanF=='G':
        NastStan='A'
    elif StanF=='A':
        NastStan='Z'

    if stat=='OK':
        #JR 2023-08-19 (13516) sprawdzenie wymagalnosci miejsca dostawy
        sql = "SELECT wymagane_miejsce_dostawy FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        stat, czymd, dump, dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych wyznacznika: ' + stat
            dane.append(stat)
        elif len(czymd) == 0:
            stat = 'Brak wyznacznika o podanym kluczu.'
            dane.append(stat)
        else:
            WymaganeMiejsceDostawy = czymd[0][0]

    if stat == 'OK':
        Filtr="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer='"+str(Numer)+"'"

        # pobranie stanu zamowienia - blokada dotyczy tylko stanow (W,G)
        # pole StanF nie musi byc podane -> prosciej jest sprawdzic stan niz dedukowac
        sql =" SELECT * FROM rs_zamowienia_dostawcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        
        stat,dZam,nZam,dump = self.PolSQL.Execute(sql,3)  #AB 29.10.21r
        if stat != 'OK':
            stat = 'Bd pobrania danych zamwienia: '+stat  #AB 29.10.21r
            dane.append(stat)
        elif len(dZam) == 0:  #AB 29.10.21r
            rsglobal.ZapiszDoLogow(sql)
            stat = 'Brak zamwienia o podanym kluczu.'
            dane.append(stat)
        else:  #AB 29.10.21r
            rsglobal.ZapiszDoLogow("zamowienie "*100)
            rsglobal.ZapiszDoLogow(dZam)
            DaneZ      = rssql.RSTableRowset(dZam, nZam)
            Projekt    = DaneZ.GetVal(0, "projekt_id")
            Kontrahent = DaneZ.GetVal(0, "kontrahent_id")
            Sprzedawca = DaneZ.GetVal(0, "sprzedawca_id")
            Oddzial_z  = DaneZ.GetVal(0, "oddzial_id")
            Miej_dost  = DaneZ.GetVal(0, "miejsce_dostawy_id")
            Waluta     = DaneZ.GetVal(0, "waluta")
            Spos_zapl  = DaneZ.GetVal(0, "sposob_zaplaty")
            Stan       = DaneZ.GetVal(0, "stan")
            Data       = DaneZ.GetVal(0, "dostawy_od_dnia")

            sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+self.oddzial_id+"\',\'"+Data+"\',1);"
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'BL KLUCZ DANE'
                dane.append(stat)
            if dane_wyn[0][0] != 1:
                stat = "ZK DATA"
                dane.append(stat)

            if Kontrahent in puste:
                stat = "BR KONTR"
                dane.append(stat)

            if Data in puste:
                stat = "BR DATA OD"
                dane.append(stat)
            else:
                sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+Kontrahent+"' AND aktywny;"
                stat, dane_wyn, dump, dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    stat = 'BL SQL DAN KONT'
                    dane.append(stat)
                if len(dane_wyn) == 0:
                    stat = "AKT KONTR"
                    dane.append(stat)

            if Sprzedawca in puste:
                SQL="SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci WHERE "
                SQL+=" firma_id='{firma_id}' AND kontrahent_id='{Kontrahent}'".format(**locals())
                stat,DPlat,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='Bd pobierania patnika z kontrahenta '+stat
                    dane.append(stat)
                else:
                    Sprzedawca = DPlat[0][0]
            else:
                sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='{firma_id}'" \
                      " AND kontrahent_id='{Sprzedawca}' AND aktywny;".format(**locals())
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat<>'OK':
                    stat='BL SQL DAN SPRZED'
                    dane.append(stat)
                if len(dane_wyn) == 0:
                    stat="AKT SPRZED"
                    dane.append(stat)

            if Wyznacznik in puste:
                stat="BR WYZN"
                dane.append(stat)

            if Numer <=0:
                stat="BL NUMER"
                dane.append(stat)

            if Oddzial_z in puste:
                stat="BR ODDZ"
                dane.append(stat)
            else:
                if Oddzial_z != Oddzial:
                    stat="NG ODDZ"
                    dane.append(stat)

            if Miej_dost in puste:
                if WymaganeMiejsceDostawy:
                    stat = 'Brak miejsca dostawy.'
                    dane.append(stat)
            else:
                stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='{firma_id}'"
                                                              " AND kontrahent_id='{Miej_dost}' AND aktywny;".format(**locals()), 3)
                if stat != 'OK':
                    stat='BL SQL MIEJDOST'
                    dane.append(stat)
                if len(dane_wyn) == 0:
                    stat= "AKT MIEJDOST"
                    dane.append(stat)

            if Waluta in puste:
                stat="BR WALUTA"
                dane.append(stat)

            if Spos_zapl in puste:
                stat="BR SPOSZAPL"
                dane.append(stat)

            if Projekt in puste:
                stat="BR PROJ"
                dane.append(stat)

    sql = """SELECT p.cecha1_opis != a.cecha1_opis AS rozne_cechy, 
                     TRIM(p.cecha1_opis) NOT IN (NULL, '') AND TRIM(p.cecha1_wartosc) IN (NULL, '') AS pusta_wart,
                     TRIM(p.cecha1_opis) IN (NULL, '') AND TRIM(p.cecha1_wartosc) NOT IN (NULL, '') AS wart_bez_opisu,
                     rsf_podaj_parametry_cechy(p.firma_id, p.cecha1_opis, p.cecha1_wartosc ,'poprawna') as poprawna,
                     p.cecha1_opis, p.cecha1_wartosc, a.cecha1_opis, artykul_id, nr_poz
             FROM rs_zamowienia_dostawcy_pozycje p
             JOIN rs_artykuly a USING (firma_id, artykul_id)
             WHERE firma_id='{firma_id}' AND wyznacznik_id='{Wyznacznik}'
             AND data='{Data}' AND numer={Numer}
             ;""".format(**locals())

    stat,dPoz,nPoz,dump = self.PolSQL.Execute(sql,3)  #AB 29.10.21r
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(sql)
        stat = 'Bd pobrania pozycji zamwienia: '+stat  #AB 29.10.21r
        dane.append(stat)
    elif len(dPoz) > 0:  #AB 29.10.21r
        rsglobal.ZapiszDoLogow("zamowienie "*100)
        rsglobal.ZapiszDoLogow(dPoz)
        DaneP          = rssql.RSTableRowset(dPoz, nPoz)
        nr_poz         = DaneP.GetVal(0, "nr_poz")
        rozne_cechy    = DaneP.GetVal(0, "rozne_cechy")
        pusta_wart     = DaneP.GetVal(0, "pusta_wart")
        wart_bez_opisu = DaneP.GetVal(0, "wart_bez_opisu")
        poprawna       = rsglobal.rseval(DaneP.GetVal(0, "poprawna"))
        if rozne_cechy:
            stat = 'BL CECHA${}'.format(int(nr_poz))
            dane.append(stat)
        elif pusta_wart:
            stat = 'BR CECHA WART${}'.format(int(nr_poz))
            dane.append(stat)
        elif wart_bez_opisu:
            stat = 'CECHA WART NIEPUSTA${}'.format(int(nr_poz))
            dane.append(stat)
        elif not poprawna[0]:
            stat = 'Pozycja {}:'.format(int(nr_poz)) + poprawna[1]
            dane.append(stat)



    if dane:
        stat = dane[0]
            
    if stat == 'OK':
        sql ="SELECT kontrahent_id, zamowienie_nr, projekt_id,"
        sql+=" dostawy_od_dnia,miejsce_dostawy_id"
        sql+=" FROM rs_zamowienia_dostawcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)
        if rsglobal.Dekoduj(Stan) in ('W','G'):
            sql+=" FOR UPDATE NOWAIT;"
        sql+=";"
        
        stat,dump,dump,dump=self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            if rsglobal.Dekoduj(Stan) in ('W','G'):
                stat='Zamwienie dostawcy zablokowane przez innego operatora. Zmiana stanu niemoliwa.'
            else:
                stat='Bd pobrania danych zamwienia: '+stat
            dane.append(stat)
    
    if stat=='OK':   
        SELECT="SELECT dp.nr_poz, dpo.nr_poz "
        FROM="FROM rs_zamowienia_dostawcy zd "
        FROM+="LEFT OUTER JOIN rs_zamowienia_dostawcy_pozycje dp ON (zd.firma_id=dp.firma_id AND zd.wyznacznik_id=dp.wyznacznik_id AND zd.data=dp.data AND zd.numer=dp.numer) "
        FROM+="LEFT OUTER JOIN rs_zamowienia_dostawcy_pozycje_opisowe dpo ON (zd.firma_id=dpo.firma_id AND zd.wyznacznik_id=dpo.wyznacznik_id AND zd.data=dpo.data AND zd.numer=dpo.numer) "
        WHERE="WHERE zd.firma_id='"+self.firma_id+"' AND zd.wyznacznik_id='"+Wyznacznik+"' AND zd.data='"+Data+"' AND zd.numer='"+str(Numer)+"'"
        stat,dane_p,dump,dump=self.PolSQL.Execute(SELECT + FROM + WHERE,3)
        if stat<>'OK':
            stat='BL_POZ'
            dane.append(stat)
        if dane_p==[[0.0,0.0]] or len(dane_p) == 0:
            stat='BR POZ'
            dane.append(stat)
            
    # sprawdzenie czy wszystkie artykuy s aktywne na pozycjach jednorazowych zamwienia
    if stat=="OK":
        SQL="SELECT zp.artykul_id FROM rs_zamowienia_dostawcy_pozycje zp "
        SQL+="INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE zp.firma_id='"+self.firma_id+"' AND zp.wyznacznik_id='"+Wyznacznik+"' AND zp.data='"+Data+"'"
        SQL+=" AND numer="+Numer+" AND NOT a.aktywny;"
        stat,DAkt,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat='Bd sprawdzania czy artykuy na zamwieniu s aktywne'
        elif len(DAkt)>0:
            stat="Nie mona zamkn zamwienia poniewa artyku "+DAkt[0][0].strip()+" jest nieaktywny"

    if stat=='OK':
        sql="UPDATE rs_zamowienia_dostawcy SET stan='"+NastStan+"' "+Filtr
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL_UPD$'+stat
            dane.append(stat)

# -------------------------------------------------------------------------------
# Otwieranie - 8
# -------------------------------------------------------------------------------
#AB 29.10.21r
if stat == 'OK' and (Funkcja in [8]) and (len(LWyzn) > 0):
    if not (UprOtw and (Wyznacznik in LOtw)) and self.operator_id != STANDARD_OPERATOR_ID:
        stat = 'UPR OTW'
        dane.append(stat)
    if stat == 'OK':

        # pobranie danych zamowienia
        sql = "SELECT * FROM rs_zamowienia_dostawcy"
        sql += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + Wyznacznik + "'"
        sql += " AND data='" + Data + "' AND numer=" + str(Numer) + ";"

        stat, dZam, nZam, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych zamwienia: ' + stat
            dane.append(stat)
        elif len(dZam) == 0:
            stat = 'Brak zamwienia o podanym kluczu.'
            dane.append(stat)
        else:
            rsglobal.ZapiszDoLogow("zamowienie " * 100)
            rsglobal.ZapiszDoLogow(sql)
            rsglobal.ZapiszDoLogow(dZam)
            DaneZ = rssql.RSTableRowset(dZam, nZam)
            Stan = DaneZ.GetVal(0, "stan")

        sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+self.oddzial_id+"\',\'"+Data+"\',1);"
        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'BL KLUCZ DANE'
            dane.append(stat)
        if dane_wyn[0][0] != 1:
            stat = "ZK DATA"
            dane.append(stat)

        if Stan != 'G':
            stat = 'BL STAN OTW'
            dane.append(stat)

        sql = "SELECT * FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id='{firma_id}' AND wyznacznik_id='{Wyznacznik}' " \
              "AND data='{Data}' AND numer={Numer} AND dostarczono1 != 0;".format(**locals())

        stat, dDost, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'Bd pobrania danych pozycji zamwienia: ' + stat
            dane.append(stat)
        elif len(dDost) != 0:
            stat = ' Nie mona otworzy zamwienia - zostao ju co dostarczone.'
            dane.append(stat)

        if dane:
            stat = dane[0]

        if stat == 'OK':
            upd = """UPDATE rs_zamowienia_dostawcy
                    SET stan='W'
                    WHERE firma_id='{firma_id}' AND wyznacznik_id='{Wyznacznik}' AND "data"='{Data}' AND numer={Numer};
                    """.format(**locals())
            stat, dump, dump, dump = self.PolSQL.Execute(upd, 1, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = 'Bd zmiany stanu zamwienia: ' + stat
                dane.append(stat)
                rsglobal.ZapiszDoLogow(stat)
