# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_klucz.py
# Purpose:     insert/update zamowienia dostawcy
#
# Author:      Marcin Grzeda, Michal Raburski
# Created:     2008/04/01
# RCS-ID:      $Id: fs_zamowienia_dostawcy_klucz.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-08-29 Mariusz Rajfura  (6028) pobieranie z rs_wyznaczniki 'miejsce_dostawy','handlowiec' na nowe zamowienie
# 2012-08-29 Mariusz Rajfura  (6030) pobieranie z danych do fakturowania: wersja,sposob_zaplaty,projekt_id
# 2012-09-03 Mariusz Rajfura  (6029) pobieranie z danych do fakturowania: waluza_zakup
# 2012-10-04 Mariusz Rajfura  (6130) wypelnienie 'dostawy_od_dnia' przy tworzeniu nowego zamowienia
# 2014-03-21 Micha Raburski  (7733) uwzgldnienie cech w pozycjach tworzonego zamwienia
# 2022-09-28 Wojciech Skowron (13138) eval -> rsglobal.rseval


Wyznacznik=klucze[0]
Data=klucze[1]
Numer=klucze[2]
DataK=klucze[3]
KontrahentK=klucze[4]
Pozycje=klucze[5]
# handlowiec_id lub 'OPERATORA' - wtedy uywany self.handlowiec_id
Handlowiec=klucze[6]
Fun=klucze[-1]
stat = "OK"
dane = []

Sprzedawca = ''

#--- SPRAWDZENIE DANYCH

if Fun in [1,2,3,4]:
    for i in range(len(pola)):
        pole = pola[i]
        wart= wartosci[i]
        if pole == 'wyznacznik_id':
            WyznacznikNowy = wart
            if wart == "":
                stat="BR WYZN"
                dane.append(stat)
            else:
                sql ="SELECT wyznacznik_id,COALESCE(miejsce_dostawy,''::TEXT),COALESCE(handlowiec,''::TEXT)"
                sql+=" FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+wart+"';"
                stat,dane_wyzn,dump,dump = self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    stat='BL SQL WYZN'
                    dane.append(stat)
                elif len(dane_wyzn) == 0:
                    stat="BL WYZN"
                    dane.append(stat)
                else:
                    MiejsceDostawyZWyznacznika = rsglobal.Dekoduj(dane_wyzn[0][1])
                    # miejsce_dostawy_id jest kluczem obcym i dlatego musi byc obsluzone, gdy NULL
                    if MiejsceDostawyZWyznacznika == '':
                        MiejsceDostawyZWyznacznika = "NULL"
                    else:
                        MiejsceDostawyZWyznacznika = "'"+MiejsceDostawyZWyznacznika+"'"
                        
                    HandlowiecZWyznacznika = rsglobal.Dekoduj(dane_wyzn[0][2])
                    # handlowiec jest kluczem obcym i dlatego musi byc obsluzone, gdy NULL
                    if HandlowiecZWyznacznika == '':
                        HandlowiecZWyznacznika = "NULL"
                    else:
                        HandlowiecZWyznacznika = "'"+HandlowiecZWyznacznika+"'"
                    
                    stat,dane_typ,dump,dump = self.PolSQL.Execute("SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+wart+"';",3) 
                    if stat<>'OK':
                        stat='BL SQL TYP FAKT'
                        dane.append(stat)
                    elif len(dane_typ) == 0:
                        stat='BL WYZN'
                        dane.append(stat)
                    else:
                        if dane_typ[0][0]<>'ZD':
                            stat='BL TYP FAKT'
                            dane.append(stat)

            if stat == "OK" and Fun in [1, 2]:
                #sprawdzenie czy operator ma prawo dodawa ten wyznacznik w danym oddziale
                if stat=='OK' and self.operator_id != STANDARD_OPERATOR_ID:
                    Lista = [self.firma_id, self.oddzial_id, self.operator_id]
                    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"', '[]', '[False,True,False,False,False,False]')"
                    stat, DaneW, dump, dump=self.PolSQL.Execute(sql,3)
                    if stat=='OK':
                        LWyzn=rsglobal.rseval(DaneW[0][0])[1]
                        if not wart.ljust(2) in LWyzn:
                            stat="BL UPR WYZN"
                    else:
                        stat='BL SQL WYZN'

        elif pole == 'data':
            DataNowa = wart
            if wart == "    -  -  ":
                stat="BR DATA"
                dane.append(stat)
            else:
                if not rsglobal.SprawdzCzyToData(wart):
                    stat="BL DATA"
                    dane.append(stat)
                else:
                    DataK=wart
        elif pole == 'numer':
            if wart<=0:
                stat="BL NUMER"
                dane.append(stat)        
        elif pole == 'kontrahent_id':
            if wart == "":
                stat="BR KONTR"
                dane.append(stat)
            else:
                KontrahentK=wart
                stat,dkon,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id,COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+KontrahentK+"' AND aktywny;", 3)
                if stat<>'OK' or len(dkon)==0:
                    stat='BL KONTR'
                    dane.append(stat)
                else:
                    Sprzedawca = dkon[0][1]
                    
                    
    #jesli byly bledy
    if len(dane) > 0:
        stat = dane[0]    

    if stat=='OK':
        if KontrahentK<>"": 
            if DataK<>"":
                sql ="SELECT dni,COALESCE(wersja,''::TEXT),upust,COALESCE(spos_zaplaty,''::TEXT),"
                sql+=" spos_dostawy,sposob_odbioru_faktury,COALESCE(projekt_id,''::TEXT),COALESCE(waluta_zakup,'PLN'::TEXT)"
                sql+=" FROM rs_kontrahenci_fakturowanie"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+KontrahentK+"' AND data_od <= '"+DataK+"'"
                sql+=" ORDER BY data_od DESC LIMIT 1;"
                st,dk,dump,dump = self.PolSQL.Execute(sql,3)
                
                if st<>'OK':
                    stat='BL SEL DAN FAKT'
                    dane.append(stat)
                elif len(dk) == 1:
                    Dni = dk[0][0]
                    pola.append('dni')
                    wartosci.append(Dni)
                    
                    pola.append('wersja')
                    if dk[0][1] != '':
                        Wersja = "'"+rsglobal.Dekoduj(dk[0][1])+"'"
                    else:
                        Wersja ="NULL"
                    wartosci.append(Wersja)
                       
                        
                    Upust = dk[0][2]
                    pola.append('upust')
                    wartosci.append(Upust)
                    pola.append('waluta')
                    wartosci.append("'"+rsglobal.Dekoduj(dk[0][7])+"'")
                    
                    pola.append('sposob_zaplaty')
                    if dk[0][3] != '':
                        SposZaplaty = "'"+rsglobal.Dekoduj(dk[0][3])+"'"
                    else:
                        SposZaplaty = "NULL"
                    wartosci.append(SposZaplaty)
                        
                    if dk[0][4] != u'None':
                        SposDostawy = rsglobal.Dekoduj(dk[0][4])
                        pola.append('sposob_dostawy')
                        wartosci.append(SposDostawy)
                        
                    if dk[0][5] != u'None':
                        SposobOdbioruFaktury = rsglobal.Dekoduj(dk[0][5])
                        pola.append('sposob_odbioru_faktury')
                        wartosci.append(SposobOdbioruFaktury)

                    pola.append('projekt_id')
                    if dk[0][6] != '':
                        Projekt = "'"+rsglobal.Dekoduj(dk[0][6])+"'"
                    else:
                        Projekt = "NULL"
                    wartosci.append(Projekt)

                else:
                    Dni = 0.0
                    pola.append('dni')
                    wartosci.append(Dni)
                    Wersja = "NULL"
                    pola.append('wersja')
                    wartosci.append(Wersja)
                    Upust = 0
                    pola.append('upust')
                    wartosci.append(Upust)
                    SposZaplaty = "NULL"
                    pola.append('sposob_zaplaty')
                    wartosci.append(SposZaplaty)
                    SposDostawy = "NULL"
                    pola.append('sposob_dostawy')
                    wartosci.append(SposDostawy)
                    Projekt = "NULL"
                    pola.append('projekt_id')
                    wartosci.append(Projekt)
                    SposobOdbioruFaktury = "NULL"
                    pola.append('sposob_odbioru_faktury')
                    wartosci.append(SposobOdbioruFaktury)
                    pola.append('waluta')
                    wartosci.append("'PLN'")
            else:
                stat=('BR DAT')
                dane.append(stat)
        else:
            stat='BR KONTR'
            dane.append(stat)

    # sprawdzenie czy potencjalne pozycje s w porzdku (artykuly)
    if stat=='OK':
        for poz in Pozycje:
            if stat=='OK':
                SQL="SELECT aktywny FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+poz[0]+"'"
                stat,DPom,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DPom)==0:
                    stat='BR ART$'+poz[0]
                elif not DPom[0][0]:
                    stat='ART NIEAKT$'+poz[0]

    if stat=='OK' and Handlowiec:
        if Handlowiec == "OPERATORA":
            Handlowiec = self.handlowiec_id
        if Handlowiec is not None:
            SQL = "SELECT kod FROM rs_handlowcy WHERE kod='%s'" % Handlowiec
            stat, dn, dump, dump = self.PolSQL.Execute(SQL, 2)
            if stat != "OK":
                stat = "BL SQL SPR HAND"
            elif not dn:
                stat = "BL HAND"

if Fun in (1,2) and stat=='OK':
    sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+WyznacznikNowy+"\\',\\'"+DataNowa+"\\']','ZD');"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia moliwoci dodania nowego zamwienia: '+stat
    elif d[0][0] != 'OK':
        stat=d[0][0]

           
#--- Pobieranie Numeru(10)
if Fun == 10 and stat=='OK':
    if ((self.oddzial_id,'037010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        if rsglobal.SprawdzCzyToData(Data):
            sql="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\'"+Wyznacznik+"\\',\\'"+Data+"\\']','ZD');"
            stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='BL SEL NUM'
                dane.append(stat)
        else:
            stat='BL DATA'
            dane.append(stat)
    else:
        stat = 'UPR SEL'   


#------------------------------------------------------------------------------
#
#          Kopiowanie zamowienia dostawcy (11)
#
#-------------------------------------------------------------------------------

if Fun == 11 and stat=='OK':
    if not ((self.oddzial_id,'037013') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat = 'UPR SEL'   
    
    if stat=='OK':
        parametry=klucze[3]

        sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+rsglobal.Dekoduj(klucze[0])+"\\',\\'"+rsglobal.Dekoduj(klucze[1])+"\\']','ZD');"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd sprawdzenia moliwoci dodania nowego zamwienia: '+stat
        elif d[0][0] != 'OK':
            stat=d[0][0]

    if stat == 'OK':
        if Wyznacznik == "":
            stat="BR WYZN"
            dane.append(stat)
        else:
            sql ="SELECT wyznacznik_id,COALESCE(miejsce_dostawy,''::TEXT),COALESCE(handlowiec,''::TEXT)"
            sql+=" FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"';"
            stat,dane_wyzn,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='BL SQL WYZN'
                dane.append(stat)
            if len(dane_wyzn) == 0:
                stat="BL WYZN"
                dane.append(stat)
            else:
                MiejsceDostawyZWyznacznika = rsglobal.Dekoduj(dane_wyzn[0][1])
                # miejsce_dostawy_id jest kluczem obcym i dlatego musi byc obsluzone, gdy NULL
                if MiejsceDostawyZWyznacznika == '':
                    MiejsceDostawyZWyznacznika = "NULL"
                else:
                    MiejsceDostawyZWyznacznika = "'"+MiejsceDostawyZWyznacznika+"'"
                    
                HandlowiecZWyznacznika = rsglobal.Dekoduj(dane_wyzn[0][2])
                if HandlowiecZWyznacznika == '':
                    HandlowiecZWyznacznika = "NULL"
                else:
                    HandlowiecZWyznacznika = "'"+HandlowiecZWyznacznika+"'"

            #sprawdzenie czy operator ma prawo dodawa ten wyznacznik w danym oddziale
            if stat=='OK' and self.operator_id != STANDARD_OPERATOR_ID:
                Lista = [self.firma_id, self.oddzial_id, self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"', '[]', '[False,True,False,False,False,False]')"
                stat, DaneW, dump, dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LWyzn=rsglobal.rseval(DaneW[0][0])[1]
                    if not Wyznacznik.ljust(2) in LWyzn:
                        stat="BL UPR WYZN"
                else:
                    stat='BL SQL WYZN'
        
            if stat=='OK':  
                if Data == "    -  -  ":
                    stat="BR DATA"
                    dane.append(stat)
                else:
                    if not rsglobal.SprawdzCzyToData(Data):
                        stat="BL DATA"
                        dane.append(stat)

            if Numer==0:
                stat="BL NUMER"
                dane.append(stat)
            
            if stat=="OK":
                Select="SELECT * FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
                st,d,wyn1,tr = self.PolSQL.Execute(Select,3)
                if st<>'OK':
                    stat="BL SQL SEL"
                    dane.append(stat)
                elif len(d)>0:
                    stat='ZAM ISTN'
                    dane.append(stat)
            if stat=='OK':       
                Select="SELECT * FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"' AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                st,d,wyn1,tr = self.PolSQL.Execute(Select,3)
                if st<>'OK':
                    stat="BL SQL SEL"
                    dane.append(stat)
                elif len(d)==0:
                    stat='BR ZAM'
                    dane.append(stat)

    

        

    if stat == 'OK' and parametry != 'None':
        #sprawdzenie, czy kontrahent,miejsce_dostawy z kopiowanego zamowienie sa poprawne i aktywne
        sql ="SELECT kontrahent_id, miejsce_dostawy_id"
        sql+=" FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
        sql+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
        stat,zd,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'BL SQL SEL'
        else:
            if len(zd) != 1:
                stat = 'BR ZAMOW'
            else:
                sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                sql+=" AND kontrahent_id = '"+str(zd[0][0])+"' AND aktywny;"
                stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL SEL'
                elif len(k) != 1:
                    stat = 'BL KONTR'
                    dane.append(stat)

                if str(zd[0][1]) != 'None':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kontrahent_id = '"+str(zd[0][1])+"' AND aktywny;"
                    stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'BL SQL SEL'
                    elif len(k) != 1:
                        stat = 'BL MIEJDOST'
                        dane.append(stat)
                        
            if len(dane) > 0:
                stat = dane[0]
     
     
        if stat=='OK':
            Waluta = "'PLN'"
            # pobranie waluty z danych do fakturowania
            sql ="SELECT COALESCE(waluta_zakup,'PLN'::TEXT)"
            sql+=" FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(zd[0][0])+"'"
            sql+=" AND data_od <= '"+Data+"'"
            sql+=" ORDER BY data_od DESC LIMIT 1;"
            stat,dk,dump,dump = self.PolSQL.Execute(sql,3)
            if stat != 'OK':
                stat = 'Bd pobrania danych do fakturowania: '+stat
            elif len(dk) == 1:
                Waluta = "'"+rsglobal.Dekoduj(dk[0][0])+"'"
        
        if stat=='OK':
            Insert="INSERT INTO rs_zamowienia_dostawcy (firma_id,wyznacznik_id,data,numer,oddzial_id,stan,"
            Insert+="kontrahent_id,miejsce_dostawy_id,dostawy_od_dnia,"
            Insert+="projekt_id,waluta,wersja,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,typ_zamowienia,"
            Insert+="handlowiec,sposob_odbioru_faktury,sposob_dostawy,upust,upust_wartosc,rabat,rabat_wartosc,"
            Insert+="kwota_netto,wartosc_opakowan,tekst_nad_podp,tekst_pod_podp)"
            Insert+=" SELECT firma_id,'"+Wyznacznik+"','"+Data+"',"+str(Numer)+",oddzial_id,'W',"
            Insert+="kontrahent_id,"+MiejsceDostawyZWyznacznika+",'"+Data+"',"
            Insert+="projekt_id,"+Waluta+",wersja,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,typ_zamowienia,"
            Insert+=HandlowiecZWyznacznika+",sposob_odbioru_faktury,sposob_dostawy,upust,0,rabat,0,"
            Insert+="0,0,tekst_nad_podp,tekst_pod_podp"
            Insert+=" FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
            Insert+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"     
            st,dump,dump,dump=self.PolSQL.Execute(Insert,1)
            if st<>'OK':
                stat='BL INS KOP'
                dane.append(stat)
            else:
                InsertPoz="INSERT INTO rs_zamowienia_dostawcy_pozycje (firma_id,wyznacznik_id,data,numer,nr_poz,"
                InsertPoz+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,"
                InsertPoz+="cena_upust1,cena_upust2,upust,upust_wartosc,"
                InsertPoz+="wartosc_netto,dostarczono1,dostarczono2,anulowano1,anulowano2) "
                InsertPoz+="SELECT firma_id,'"+Wyznacznik+"','"+Data+"',"+str(Numer)+",nr_poz,"
                InsertPoz+="artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,"
                InsertPoz+="cena_upust1,cena_upust2,upust,upust_wartosc,"
                InsertPoz+="round(ilosc1*cena_upust1,2),0,0,0,0 "
                InsertPoz+="FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                InsertPoz+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                
                InsertPozOpisowe=" INSERT INTO rs_zamowienia_dostawcy_pozycje_opisowe (firma_id,wyznacznik_id,data,numer,"
                InsertPozOpisowe+="nr_poz,opis_pozycji,wartosc_netto)"
                InsertPozOpisowe+=" SELECT firma_id,'"+Wyznacznik+"','"+Data+"',"+str(Numer)+","
                InsertPozOpisowe+="nr_poz,opis_pozycji,wartosc_netto FROM rs_zamowienia_dostawcy_pozycje_opisowe "
                InsertPozOpisowe+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                InsertPozOpisowe+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                
                rsglobal.ZapiszDoLogow(InsertPoz+InsertPozOpisowe,5)
                st,dump,dump,dump= self.PolSQL.Execute(InsertPoz+InsertPozOpisowe,1)
                if st<>'OK':
                    stat='BL INS POZ'
                    dane.append(stat)                
    
#--- INSERT DANYCH(2)     
        
if Fun in [1,2] and stat == "OK":
    if ((self.oddzial_id,'037013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Insert="INSERT INTO rs_zamowienia_dostawcy (firma_id,oddzial_id,stan"
        Values=") VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','W'"
        
        if Sprzedawca != '':
            pola.append('sprzedawca_id')
            wartosci.append(Sprzedawca)
            
        pola.append('handlowiec')
        if Handlowiec:
            wartosci.append(Handlowiec)
        else:
            wartosci.append(HandlowiecZWyznacznika)
        
        pola.append('miejsce_dostawy_id')
        wartosci.append(MiejsceDostawyZWyznacznika)
        
        for i in xrange(len(pola)):
            pole=pola[i]
            wart=wartosci[i]
            if pole in ['kontrahent_id','wyznacznik_id','data','sprzedawca_id']:
                Insert=Insert+","+pole
                Values=Values+",'"+wart+"'"

                if pole == 'data':
                    # powielenie daty zamowienia
                    Insert=Insert+",dostawy_od_dnia"
                    Values=Values+",'"+wart+"'"
                
            elif pole in ['miejsce_dostawy_id','wersja','sposob_zaplaty','projekt_id','handlowiec','waluta']:
                if len(wart)>0:
                    if (wart[0]=="'" and wart[-1]=="'") or wart=="NULL":
                        Insert=Insert+","+pole
                        Values=Values+","+wart
                    else:
                        Insert=Insert+","+pole
                        Values=Values+",'"+wart+"'"
                        
            elif pole in ['numer']:
                Insert=Insert+","+pole
                Values=Values+","+str(wart)
                
        Insert=Insert+Values+");"
        
        if len(Pozycje)>0:
            lp=1
            for poz in Pozycje:
                # jeli -1 to znaczy, e trzeba przeliczy wzgldem iloci 1. Inaczej - podana
                if poz[2]==-1:
                    Ilosc2="ROUND(("+str(poz[1])+"*(SELECT przelicznik FROM rs_artykuly "
                    Ilosc2+=" WHERE firma_id='"+self.firma_id+"' AND "
                    Ilosc2+=" artykul_id='"+rsglobal.Dekoduj(poz[0])+"'))+0.00000001,6)"
                else:
                    Ilosc2=str(poz[2])
                CechaWart=''
                if len(poz)>3: # w czwartej kolumnie jest warto cechy
                    CechaWart=poz[3].strip()
                    
                SQL="INSERT INTO rs_zamowienia_dostawcy_pozycje (firma_id"
                Values=") VALUES ('"+self.firma_id+"'"
                for i in xrange(len(pola)):
                    pole=pola[i]
                    wart=wartosci[i]
                    if pole in ['wyznacznik_id','data']:
                        SQL+=","+pole
                        Values+=",'"+wart+"'"
                    elif pole =='numer':
                        SQL+=","+pole
                        Values+=","+str(wart)

                SQL+=",nr_poz,artykul_id,ilosc1,ilosc2"
                Values+=","+str(lp)+",'"+rsglobal.Dekoduj(poz[0])+"',"+str(poz[1])+","+Ilosc2
                if CechaWart != '':
                    SQL+=",cecha1_opis,cecha1_wartosc"
                    Values+=",(SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+rsglobal.Dekoduj(poz[0])+"'),'"+CechaWart+"'"
                SQL+=Values+");"
                
                Insert+=SQL
                lp=lp+1
                
        #rsglobal.ZapiszDoLogow('INS ZAM '+Insert,1)
        stat,dump,dump,dump = self.PolSQL.Execute(Insert ,1)
        if stat<>'OK':
            stat='BL INS'
            dane.append(stat)
        else:
            # przeliczenie cen na zamwieniu
            for i in xrange(len(pola)):
                pole=pola[i]
                wart=wartosci[i]
                if pole =='wyznacznik_id':
                    WyznCena=rsglobal.Dekoduj(wart)
                elif pole=='data':
                    DataCena=rsglobal.Dekoduj(wart)
                elif pole =='numer':
                    NrCena=str(wart)
            from funkcje import fs_zamowienia_dostawcy_pom
            stat=fs_zamowienia_dostawcy_pom.PrzeliczCenyZamowienia(self.firma_id,WyznCena,DataCena,NrCena,self.PolSQL)
    else:
        stat = 'UPR INS'

        
#--- UPDATE DANYCH(3)

if Fun in [3,4] and stat == "OK":
    if ((self.oddzial_id,'037015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Update="UPDATE rs_zamowienia_dostawcy SET firma_id='"+self.firma_id+"'"
        Where=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        for i in xrange(len(pola)):
            pole=pola[i]
            wart=wartosci[i]
            if pole in ['kontrahent_id','wyznacznik_id',]:
                Update=Update+","+pole+"='"+wart+"'"
            elif pole in ['data',]:
                Update=Update+","+pole+"='"+wart+"' ,dostawy_od_dnia='"+wart+"'"
            elif pole in ['numer']:
                Update=Update+","+pole+"="+str(wart)
        Update=Update+Where
        stat,dump,dump,dump = self.PolSQL.Execute(Update,1)
        if stat<>'OK':
            stat='BL UPD'
            dane.append(stat)
    else:
        stat = 'UPR UPD'


if Fun in [1,2,3,4] and stat=='OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart= wartosci[i]
        if pole=='wyznacznik_id':
            Wyznacznik=wart
        elif pole=='data':
            Data=wart
        elif pole=='numer':
            Numer=wart


if Fun in [1,2,3,4,5] and stat=='OK':
    if ((self.oddzial_id,'037010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Sql="SELECT kontrahent_id,wyznacznik_id,data,numer FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,dane,wyn1,dump = self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL SEL'
            dane.append(stat)
    else:
        stat = 'UPR PRZ'