# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_pliki.py
# Purpose:     wyswietla, dodaje, usuwa z bazy danych informacje o 
#              zalacznikach do zamwie dostawcy                                
# Author:      Wojciech Skowron
# Created:     2021/06/10
# RCS-ID:      $Id: fs_zamowienia_dostawcy_pliki.py $
# Copyright:   (c) 2021 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

from funkcje import fs_pliki_global

stat = "OK"
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[1,2,5,6],'Data':[1,2,5,6],'Numer':[1,2,5,6],'Typ':[1],'Plik':[1],
           'Tresc':[1],'PlikId':[2,6]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_dostawcy_pliki z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
if stat == 'OK':
    if Funkcja in [1,2,5,6]:
        Wyzn = klucze["Wyznacznik"]
        Data = klucze["Data"]
        Nr = str(klucze["Numer"])
    if Funkcja in [1]:
        Typ = klucze["Typ"]
        Plik = klucze["Plik"]
        TrescPliku = klucze["Tresc"]
    if Funkcja in [2,6]:
        PlikId = str(klucze["PlikId"])
        

UprIns=((self.oddzial_id,'037043') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel=((self.oddzial_id,'037044') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

if Funkcja == 1 :
    if not UprIns:
        stat='UPR INS'

if Funkcja == 6 :
    if not UprDel:
        stat='UPR DEL'

if stat=='OK':
    #sprawdzenie poprawnoci zamwienia
    SQL="SELECT 1 FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
    SQL+=" AND data='"+Data+"' AND numer="+Nr+" FOR UPDATE NOWAIT;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat='Bdy sprawdzania zamwienia :'+stat
        
if stat=='OK':
    if len(DTest)==0:
        stat='BR ZAM'
    
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------
    
if Funkcja == 1:
        
    if stat=='OK':
        #wstawiamy plik do bazy
        SQL="INSERT INTO rs_zamowienia_dostawcy_pliki (firma_id,wyznacznik_id,data,numer,typ_pliku)"
        SQL+=" VALUES ('"+self.firma_id+"','"+Wyzn+"','"+Data+"',"+Nr+",'"+Typ+"');"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        
    if stat=='OK':
        # pobranie dodanego numeru pliku zamwienia dostawcy
        SQL="SELECT MAX(plik_id) FROM rs_zamowienia_dostawcy_pliki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        if len(DNum)==0:
            stat='PR DOD'
    
    if stat=='OK':
        PlikId=str(DNum[0][0])
        wyn2=PlikId
        
        # wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i poczenie klucza z obu tabel.
        SQL="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
        SQL+="('"+self.firma_id+"','"+Plik+"','rs_zamowienia_dostawcy_pliki',FALSE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        
    if stat=='OK':
        SQL="SELECT max(plik_id) FROM rs_pliki WHERE firma_id='"+self.firma_id+"' AND tabela='rs_zamowienia_dostawcy_pliki';"
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        NrPliku=str(DNum[0][0])
        #wrzucamy plik na serwer
        stat=fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)
    if stat=='OK':
        SQL="UPDATE rs_zamowienia_dostawcy_pliki SET nr_pliku="+NrPliku+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND plik_id="+PlikId
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

       
#-------------------------------------------------------------------------------
#---   POBRANIE PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------
    
if Funkcja in [2,6]:
    if stat=='OK':
        SQL="SELECT nr_pliku,typ_pliku FROM rs_zamowienia_dostawcy_pliki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND plik_id="+PlikId
        stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        if len(DPlik)==0:
            stat="Brak pliku o numerze "+PlikId+" w zamwieniu dostawcy "+Wyzn+'/'+Data+'/'+rsglobal.UsunKropkaZero(Nr)
        elif self.operator_id <> STANDARD_OPERATOR_ID:
            Typ = DPlik[0][1]
 
#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if Funkcja == 2:   
    if stat=='OK':
        stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        dane=[Tresc]    
            
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 :
    if stat=='OK':
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        
    if stat=='OK':    
        SQL="DELETE FROM rs_zamowienia_dostawcy_pliki WHERE plik_id="+PlikId+";"
        SQL+="DELETE FROM rs_pliki WHERE plik_id="+str(DPlik[0][0])
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
  
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 - select, 6 - delete, 1 - insert)
#-------------------------------------------------------------------------------

if (Funkcja in [1,5,6]) and (stat=='OK'):
    SQL="SELECT tp.opis,p.nazwa,zp.opis,zp.plik_id"
    SQL+=" FROM rs_zamowienia_dostawcy_pliki zp "
    SQL+=" INNER JOIN rs_typy_plikow_zamowien_odb tp ON (tp.firma_id=zp.firma_id AND tp.kod=zp.typ_pliku) "
    SQL+=" INNER JOIN rs_pliki p ON (p.firma_id=zp.firma_id AND p.plik_id=zp.nr_pliku) "
    SQL+=" WHERE zp.firma_id='"+self.firma_id+"' AND zp.wyznacznik_id='"+Wyzn+"' AND zp.data='"+Data+"' AND zp.numer="+Nr
    SQL+=" ORDER BY p.nazwa"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)