#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy.py
# Purpose:		dodaje/pobiera/usuwa zamowienia odbiorcy
# Author:		Marcin Grzeda
# Created:		2007/01/20
# RCS-ID:		$Id: fs_zamowienia_odbiorcy.py $
# Copyright:	(c) 2015 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

# 2010-11-25 Marcin Natkaski   (4085)  blokada modyfikacji wierszy dla zamwie ze stanem <> W
# 2011-09-16 Mariusz Rajfura    (4929)  blokada SELECT FOR UPDATE
# 2011-09-27 Mariusz Rajfura    (5050)  popr.SELECT dla checkboxa 'wg kontrahentow'
# 2015-12-24 Piotr Witkowski    (9496)  refaktoryzacja - okno gwne zamwie, Daty, pozycje opisowe, wartoci VAT
# 2019-08-12 Aleksander Bargie (11588) split payment w fakturach pro-forma
# 2019-10-15 Aleksander Bargie (11681) Zmiany w zamykaniu faktur i korekt ze wzgldu na mpp
# 2020-05-04 Jan Raburski (11965) Ograniczenie filtra do kontrahenta z operatora, jesli jest
# 2021-06-14 Aleksander Bargie [ZO] statusy w zamowieniach odbiorcow   (12529)
# 2021-10-26 Aleksander Bargie Import zamwie ze sklepw internetowych w zamwieniach odbiorcw    (12685)

# 5 - przegladanie
# 6 - usuwanie
# 7 - zamykanie
# 9 - zmiana priorytetu
#11 - pobranie danych operatora
#17 - sprawdzenie limitu
#21 - pobranie zamwie ze sklepw internetowych
#43 - przegladanie multiselect
from datetime import datetime, timedelta  #AB 26.20.21r

from funkcje import fs_global_sklepy_internetowe  #AB 26.20.21r
from funkcje import fs_zaleglosci_sprawdzenie
from funkcje import fs_zamowienia_odbiorcy_pom

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik_id':[5,6,7,9,17,43],'Data_od':[5,6,7,9,17,43],'Data_do':[5,6,7,9,17,43], 'Platnik_id':[5,6,7,9,17,43],
           'Kontrahent_id':[5,6,7,9,17,43], 'Stan':[5,6,7,9,17,43], 'Stale':[5,6,7,9,11,17,43],
           'Jednorazowe':[5,6,7,9,11,17,43],'Typ':[5,6,7,9,17,43],'Trasa':[5,6,7,9,17,43],'Handlowiec':[5,6,7,9,17,43],
           'WgKontrahentow':[5,6,7,9,11,17,43],'Artykul':[5,6,7,9,17,43],'Status':[5,6,7,9,17,43],
           'Wyznacznik':[5,6,7,9,17,43],'Data':[5,6,7,9,17,43],'Numer':[5,6,7,9,17,43],'Priorytet':[9], 'DodF':[5,43]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [5,6,7,9,17,43]:
            Wyznacznik_id = str(klucze['Wyznacznik_id'])
            Data_od = str(klucze['Data_od'])
            Data_do = str(klucze['Data_do'])
            Platnik_id = str(klucze['Platnik_id'])
            Kontrahent_id = str(klucze['Kontrahent_id'])
            Stan = str(klucze['Stan'])
            Typ = str(klucze['Typ'])
            Trasa = str(klucze['Trasa'])
            Handlowiec = str(klucze['Handlowiec'])
            Artykul = str(klucze['Artykul'])
            Status = str(klucze['Status'])
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [5,6,7,9,11,17,43]:
            Stale = klucze['Stale']
            Jednorazowe = klucze['Jednorazowe']
            WgKontrahentow = klucze['WgKontrahentow']
        if Funkcja in [9,]:
            Priorytet = str(klucze['Priorytet'])
        if Funkcja in [5,43]:
            DodF = klucze['DodF']

dane = []
wyn1 = []
wyn2 = []
Trasy = ''
firma_id = self.firma_id  #AB 26.20.21r

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

if stat == 'OK' and self.operator_id != STANDARD_OPERATOR_ID:    #JR 2020-05-04 (11965)
    # sprawdzenie czy operator ma wpisany symbol kontrahenta, jesli tak - zastepujemy tego z filtra
    sql = "SELECT COALESCE(kontrahent_id,'') FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)+";"
    stat,kont,dump,dump=self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        if kont[0][0].strip() != '':
            Kontrahent_id = kont[0][0]     # bez strip() bo jest robiony like

rsglobal.ZapiszDoLogow(Funkcja)
#pobranie uprawnie do wyznacznikw dla operatora
if stat=='OK' and self.operator_id == STANDARD_OPERATOR_ID:
    UprDod   = True
    UprPrz   = True
    UprEdy   = True
    UprDel   = True
    UprZam   = True
    UprPrior = True
    LPrz=LWyzn
    LEdy=LWyzn
    LDod=LWyzn
    LDel=LWyzn
    LZam=LWyzn
    LPrz.append('ZASLEPKA')
    rsglobal.ZapiszDoLogow(LDod)
else:
    UprPrz=(self.oddzial_id,'024010') in self.uprawnienia
    UprDod=(self.oddzial_id,'024013') in self.uprawnienia  #AB 26.20.21r
    UprEdy=(self.oddzial_id,'024012') in self.uprawnienia or UprDod
    UprDel=(self.oddzial_id,'024014') in self.uprawnienia
    UprZam=(self.oddzial_id,'024016') in self.uprawnienia
    UprPrior=(self.oddzial_id,'024017') in self.uprawnienia

    Lista=[self.firma_id,self.oddzial_id,self.operator_id]

    LPrz=LWyzn
    LPrz.append('ZASLEPKA')
    LEdy=[]
    LDod=[]
    LDel=[]
    LZam=[]

    if UprEdy and (Funkcja in [9,7,5]):
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LEdy=rsglobal.rseval(wyzn[0][0])[1]

    if stat == 'OK' and UprDod and Funkcja in [21, ]:  #AB 26.20.21r
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"
        stat, wyzn, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
        rsglobal.ZapiszDoLogow(sql)
        rsglobal.ZapiszDoLogow(stat)
        rsglobal.ZapiszDoLogow(wyzn)
        if stat == 'OK':
            LDod = rsglobal.rseval(wyzn[0][0])[1]
            rsglobal.ZapiszDoLogow(LDod)

    if stat=='OK':
        if UprDel and (Funkcja in [6,]):
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LDel=rsglobal.rseval(wyzn[0][0])[1]

    if stat=='OK':
        if UprZam and (Funkcja in [7,]):
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,False,True,False]');"
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LZam=rsglobal.rseval(wyzn[0][0])[1]

#Sprawdzanie poprawnoci danych
if stat == "OK" and Funkcja in [5,6,7]:
    if Data_od not in ('    -  -  '):
        if not rsglobal.SprawdzCzyToData(Data_od):
            stat = "DATA OD BL"
            dane.append(stat)
if stat == "OK" and Funkcja in [5,6,7]:
    if Data_do not in ('    -  -  '):
        if not rsglobal.SprawdzCzyToData(Data_do):
            stat="DATA DO BL"
            dane.apend(stat)
if stat == "OK" and Funkcja in [5,6,7]:
    if Data_od not in ('    -  -  ') and Data_do not in ('    -  -  '):
        if Data_od > Data_do:
            stat = "ZAKR BL"

if stat =='OK' and Funkcja not in (11, 21):  #AB 26.20.21r
    if Platnik_id.strip() != '':
        if Kontrahent_id.strip() != '':     # JR 2020-05-04 (11965) warunek na kontrahenta
            Platnik_id = ''
        else:
            sql="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' and kontrahent_id='"+str(Platnik_id)+"'"
            stat,dane_p,dump,dump=self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='PLATNIK BL SQL'
                dane.append(stat)
            if len(dane_p)==0:
                stat='PLATNIK BL'
                dane.append(stat)

if stat =='OK' and Funkcja not in (11, 21):  #AB 26.20.21r
    if Kontrahent_id.strip()<>'':
        sql="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' and kontrahent_id='"+str(Kontrahent_id)+"'"
        stat,dane_k,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='KONTR BL SQL'
            dane.append(stat)
        if len(dane_k)==0:
            stat='KONTR BL'
            dane.append(stat)

if stat =='OK' and Funkcja not in (11, 21):  #AB 26.20.21r
    if Typ.strip()<>'':
        sql="SELECT kod FROM rs_typy_zamowien WHERE firma_id = '"+self.firma_id+"' and kod='"+str(Typ)+"'"
        stat,dane_t,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='TYP BL SQL'
            dane.append(stat)
        if len(dane_t)==0:
            stat='TYP BL'
            dane.append(stat)

if stat =='OK' and Funkcja not in (11, 21):  #AB 26.20.21r
    if Trasa.strip()<>'':
        sql="SELECT kod FROM rs_trasy WHERE firma_id = '"+self.firma_id+"' and kod like '"+str(Trasa)+"%'"
        stat,dane_tr,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='TR BL SQL'
            dane.append(stat)
        if len(dane_tr)==0:
            stat='TR BL'
            dane.append(stat)

puste_pola = ['    -  -  ','',[]]
format_daty = "%Y-%m-%d"

Lista=[self.firma_id,self.oddzial_id,'',self.operator_id]
if stat == "OK":
    sql = "SELECT rsf_podaj_liste_wyznacznikow('"+str(Lista).replace("'",'"')+"','"+str([]).replace("'",'"')+"','"+str([]).replace("'",'"')+"','"+str([]).replace("'",'"')+"');"
    rsglobal.ZapiszDoLogow('!!! sql '+sql,1)
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    rsglobal.ZapiszDoLogow('!!! wyzn '+str(wyzn),1)
    if stat<>"OK":
        stat="WYZN BL"
        dane.append(stat)

       
#-------------------------------------------------------------------------------
# -- Usuwanie 6 -- #
#-------------------------------------------------------------------------------

if Funkcja in [6,] and stat=='OK':
    if not ((UprDel and (Wyznacznik in LDel)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="UPR DEL"   
        dane.append(stat)
        
    if stat=='OK':    
        Select= "SELECT rsf_sprawdz_czy_mozna_usunac_dokument('"+self.firma_id+"','[\""+Wyznacznik+"\",\""+Data+"\","+Numer+"]','ZO')"
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
    if stat=='OK':
        if d[0][0]<>'OK':
            stat='NUM NOT LAST'
            dane.append(stat)
    
    if stat=='OK':
        FiltrZam = " firma_id = '" + self.firma_id + "' AND wyznacznik_id = '" + Wyznacznik + "' AND data = '" + Data + "' AND numer = " + Numer
        Select="SELECT stan FROM rs_zamowienia_odbiorcy WHERE"+FiltrZam+" FOR UPDATE NOWAIT;"
        st,d,dump,dump=self.PolSQL.Execute(Select,3)
        if st<>'OK':
            stat="DEL BL STAN SEL"
            dane.append(stat)
        elif len(d)==0:
            stat="DEL BR ZAM"
            dane.append(stat)
        elif d[0][0] <> 'W':
            stat = "DEL BL STAN"
            dane.append(stat)
        else:
            # usunicie plikw zamwienia
            stat = fs_zamowienia_odbiorcy_pom.UsunPlikiZamowienia(self,Wyznacznik,Data,Numer,-1,-1,'')
            if stat == 'OK':
                # faktyczne usunicie zamwienia
                delete="DELETE FROM rs_zamowienia_odbiorcy WHERE "+FiltrZam+";"
    
                stat,dump,dump,dump=self.PolSQL.Execute(delete,1)
                if stat!="OK":
                    stat="DEL BL"
                    dane.append(stat)


#-------------------------------------------------------------------------------
# -- Zamykanie 7 -- #
#-------------------------------------------------------------------------------

if Funkcja in [7,] and stat=='OK':
    if not ((UprZam and (Wyznacznik in LZam)) or (UprEdy and Stan=='W' and (Wyznacznik in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="UPR ZAM"
        dane.append(stat)

    if stat == 'OK':
        sql="SELECT kontrahent_id IS NULL or kontrahent_id=''"
        sql+=",wyznacznik_id IS NULL or wyznacznik_id=''"
        sql+=",zamawiajacy_id IS NULL or zamawiajacy_id=''"
        sql+=",platnik_id IS NULL or platnik_id=''"
        sql+=",waluta IS NULL or waluta=''"
        sql+=",sposob_zaplaty IS NULL or sposob_zaplaty=''"
        sql+=",projekt_id IS NULL or projekt_id=''"
        sql+=",kontrahent_id,do_zaplaty,stan, termin_zaplaty"#termin musi byc ostatni
        sql+=" FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+Numer+";"
        stat,dn,dump,dump = self.PolSQL.Execute(sql,3)        
        if stat<>'OK':
            stat='ZAM BL SQL ZAM'
        elif len(dn)==0:
            stat="ZAM BR"

    if stat == 'OK':
        # oddzielne zalozenie blokady - nie miesza sie z bledami braku zamowienia
        sql ="SELECT stan FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Zamwienie odbiorcy jest zablokowane przez innego operatora. Operacja zmiany stanu niemoliwa.'
            dane.append(stat)

    if stat == 'OK':
        #blokowanie wierszy SELECT FOR UPDATE
        blokada  ="SELECT * FROM rs_zamowienia_odbiorcy_pozycje "
        blokada +="WHERE firma_id= '"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
        blokada +="AND data='"+Data+"' AND numer="+Numer+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(blokada,3)        
        if stat<>'OK':
            stat = 'Pozycje w Zamowieniu odbiorcy s zablokowane przez innego operatora. Operacja zmiany stanu niemoliwa.'
            dane.append(stat)

    if stat=="OK":
        #sprawdzenie, czy na zamowieniu wystepuja ilosci zerowe
        sql ="SELECT nr_poz FROM rs_zamowienia_odbiorcy_pozycje "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        sql+=" AND numer="+Numer+" AND ilosc1=0;"
        stat,braki,dump,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='ZAM BL SQL ZAM'
        elif len(braki) > 0:
            stat = 'IL ZEROWE BL'
        if stat=='OK':
            stat,dp,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer,3)
            if stat=="OK":
                stat,do,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_zamowienia_odbiorcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer,3)
            else:
                stat='POZ BL SQL ZAM'

            if stat=="OK":
                stat,ds,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_zamowienia_odbiorcy_pozycje_stale WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer,3)
            else:
                stat='POZ BL SQL OP ZAM'

            if stat=="OK" and len(dp)+len(do)+len(ds)==0:
                stat="POZ BR"

        if stat=="OK":
            if dn[0][0]:
                stat="KONTR BR"
    
        if stat=="OK":
            if dn[0][1]:
                stat="WYZN BR"
            
        if stat=="OK":
            if dn[0][2]:
                stat="ZAMAW BR"
    
        if stat=="OK":
            if dn[0][3]:
                stat="PLATNIK BR"
    
        if stat=="OK":
            if dn[0][4]:
                stat="WALUTA BR"
    
        if stat=="OK":
            if dn[0][5]:
                stat="SPOSZAPL BR"
    
        if stat=="OK":
            if dn[0][6]:
                stat="PROJ BR"
        if stat == 'OK':
            termin = dn[0][-1]
            if not rsglobal.SprawdzCzyToData(termin):
                termin = '2000-01-01'
        
        #sprawdzenie limitu KUKE
        if stat=="OK":
            from funkcje import fs_kontrahenci_kuke_pom
                
            SQL ="SELECT COALESCE(kontrahent_id,''),do_zaplaty FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            stat,DKuke,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat = 'Bd pobierania danych o kontrahencie '+stat
            if stat =='OK':
                if DKuke[0][0] <> '':
                    stat,Przekroczenie=fs_kontrahenci_kuke_pom.SprawdzLimitKuke(self,DKuke[0][0],rsglobal.PodajDzis(),DKuke[0][1])
                    if stat == 'OK':
                        if Przekroczenie > 0:
                            stat='Przekroczono kwote ubezpieczenia Kuke o '+str(Przekroczenie)
        #AB 12.08.19r
        czy_mpp = ''
        rsglobal.ZapiszDoLogow('  '*400)
        rsglobal.ZapiszDoLogow(termin)
        if stat == "OK" and termin >= '2019-11-01':
            SQL = "SELECT EXISTS(SELECT 1 FROM rs_zamowienia_odbiorcy_pozycje zop JOIN rs_artykuly a USING(firma_id, artykul_id) WHERE firma_id='" + self.firma_id + "'"
            SQL += " AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer + " AND a.czy_mpp);"
            stat, art_mpp, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                stat = 'Bd sprawdzania czy mpp w artykulach ' + stat
            if stat == 'OK':                                                              #AB 15.10.19r
                czy_mpp = ", czy_mpp=COALESCE((czy_mpp or ((kwota_netto + kwota_vat > 15000) AND "+str(art_mpp[0][0])+") AND NOT czy_stale), FALSE)"

                
        if stat=="OK":
            sql ="UPDATE rs_zamowienia_odbiorcy SET stan='G' "+ czy_mpp
            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            stat,dane,dump,dump = self.PolSQL.Execute(sql,1)


#-------------------------------------------------------------------------------
# Sprawdzenie limitu (17)
#-------------------------------------------------------------------------------

if Funkcja == 17 and stat == 'OK':
    sql ="SELECT kontrahent_id, do_zaplaty FROM rs_zamowienia_odbiorcy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+Numer+";"
    stat,dn,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia danych zamwienia: '+stat
    elif len(dn)==0:
        stat="ZAM BR"
        dane.append(stat)

    if stat == 'OK':
        #sprawdzenie kontrahenta
        sql ="SELECT kontrahent_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND kontrahent_id = '"+str(dn[0][0])+"' AND aktywny;"
        
        stat,k,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(k) <> 1:
                dane.append("KONTR BL NAKT")
        else:
            dane.append("KONTR BL SQL")
            
    if stat == 'OK':
        #porownanie stanu zaleglosci z limitem
        stat = fs_zaleglosci_sprawdzenie.SprawdzLimitKontrahenta(self,dn[0][0],dn[0][1],Data)
        if stat == 'LIMIT':
            #czytelny opis dla operatora
            stat = "Odbiorca '"+str(dn[0][0]).strip()+"' wykorzysta limit."


#-------------------------------------------------------------------------------
# -- Otwieranie 8 -- # Poki co nie ma jeszcze tej funkcjonalnosci
#-------------------------------------------------------------------------------

if Funkcja in [8,] and stat=='OK':
    st,Dane,dump,dump = self.PolSQL.Execute("SELECT * FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_p='"+Wyznacznik+"' AND data_p='"+Data+"' AND numer_p="+Numer,3)        
    if len(Dane)>0:
        stat="UZ KOR"

    if stat=="OK":
        sql="UPDATE rs_zamowienia_odbiorcy SET stan='W' WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        stat,dane,dump,dump=self.PolSQL.Execute(sql,1)

#-------------------------------------------------------------------------------
# -- Zmiana priorytetu 9 -- #
#-------------------------------------------------------------------------------

if Funkcja in [9,] and stat=='OK':
    if not ((UprPrior and (Wyznacznik in LEdy)) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="UPR PRIOR"   
        dane.append(stat)
        
    if stat=="OK":
        sql="UPDATE rs_zamowienia_odbiorcy SET priorytet='"+Priorytet+"' WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)

#-------------------------------------------------------------------------------
# -- Pobranie danych operatora 11 -- #
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,11,43]:
    SQL="SELECT czy_uproszczone_zamow FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
    stat,DOper,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='OPER BL'
    else:
        self.CzyUpr=DOper[0][0]

    # dodatkowo pobieramy dostpne trasy i jeli jedna to zwracamy do filtra
    if stat == 'OK':
        SQL = "SELECT trasa_id FROM rs_zamowienia_trasy_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)
        stat,DTrasy,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='TRASY BL'
        else:
            for poz in DTrasy:
                Trasy+="'"+poz[0]+"',"
            Trasy = Trasy.strip(',')
    if stat =='OK':
        dane = [DOper[0][0],Trasy]

#AB 26.20.21r
#-------------------------------------------------------------------------------
# -- Pobranie zamwie ze sklepu internetowego 21 -- #
#-------------------------------------------------------------------------------
if Funkcja == 21:
    rsglobal.ZapiszDoLogow("Fun 21")
    rsglobal.ZapiszDoLogow("UprDod")
    rsglobal.ZapiszDoLogow(UprDod)
    if not UprDod:
        stat = "Brak uprawnie do dodawania zamwie."

if stat == 'OK' and UprDod and Funkcja in [21, ]:

    SQL = """SELECT sklep_id, nazwa, wyznacznik_id 
             FROM rs_sklepy_internetowe 
             WHERE firma_id = '{firma_id}' AND typ = 'WOO';""".format(**locals())
    stat, SKLEPY, dump, dump = self.PolSQL.Execute(SQL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SQL)
    rsglobal.ZapiszDoLogow(SKLEPY)
    if stat != 'OK':
        stat = "Podczas pobierania listy sklepw wystpi bd: {}".format(stat)
    elif len(SKLEPY) == 0:
        stat = "Brak zdefiniowanych sklepw internetowych typu 'WOO'."
    else:
        bledy = []
        uwagi = []
        zaimportowano = []
        rsglobal.ZapiszDoLogow("Importttttt")
        for wiersz in SKLEPY:
            sklep_id, nazwa, wyznacznik = wiersz
            byl_blad = False

            rsglobal.ZapiszDoLogow("test wyznacznik not in LDod")
            rsglobal.ZapiszDoLogow(wyznacznik not in LDod)
            rsglobal.ZapiszDoLogow(wyznacznik)
            rsglobal.ZapiszDoLogow(LDod)
            if wyznacznik not in LDod:
                blad = "Sklep {}, brak uprawnie do dodawania dla wyznacznika {}".format(nazwa, wyznacznik)
                rsglobal.ZapiszDoLogow(blad)
                byl_blad = True
                bledy.append(blad)
                self.PolSQL.Rollback()
                continue
            try:
                pobierajka = fs_global_sklepy_internetowe.sklep_internetowy(self, sklep_id)

                status_polaczenie = pobierajka.polacz()
                if status_polaczenie not in ('200', 200):
                    blad = "Sklep {}, podczas nawizywania poczenia napotkano problem, funkcja zwrcia: {}".format(nazwa, status_polaczenie)
                    rsglobal.ZapiszDoLogow(blad)
                    byl_blad = True
                    bledy.append(blad)
                    self.PolSQL.Rollback()
                    continue

                status_art, zwrotka = pobierajka.sprawdz_przed_importem()
                rsglobal.ZapiszDoLogow("sprawdz_przed_importem")
                rsglobal.ZapiszDoLogow(status_art)
                rsglobal.ZapiszDoLogow(zwrotka)
                if status_art != 'OK':
                    blad = "Sklep {}, podczas sprawdzania danych artykuw napotkano problem, funkcja zwrcia: {}".format(nazwa, status_art)
                    rsglobal.ZapiszDoLogow(blad)
                    byl_blad = True
                    bledy.append(blad)
                    self.PolSQL.Rollback()
                    zaimportowano.append("Sklep {}, nie zaimportowano adnych zamwie (wystpiy bdy).".format(nazwa))
                    continue
                elif zwrotka:
                    for x in xrange(len(zwrotka)):
                        zwrotka[x] = "Sklep {}, {}".format(nazwa, zwrotka[x])
                    rsglobal.ZapiszDoLogow(zwrotka)
                    byl_blad = True
                    bledy += zwrotka
                    self.PolSQL.Rollback()
                    zaimportowano.append("Sklep {}, nie zaimportowano adnych zamwie (wystpiy bdy).".format(nazwa))
                    continue

                status_import, zaimportowani, zaktualizowani, zwrotka = pobierajka.importuj_platnikow()
                rsglobal.ZapiszDoLogow("importuj_platnikow")
                rsglobal.ZapiszDoLogow(status_import)
                rsglobal.ZapiszDoLogow(zaimportowani)
                rsglobal.ZapiszDoLogow(zaktualizowani)
                rsglobal.ZapiszDoLogow(zwrotka)
                for x in xrange(len(zwrotka)):
                    zwrotka[x] = "Sklep {}: {}".format(nazwa, zwrotka[x])
                uwagi += zwrotka
                if status_import not in ('OK', 'BRAK'):
                    blad = "Sklep {}, podczas importu patnikw napotkano problem, funkcja zwrcia: {}".format(nazwa, status_import)
                    rsglobal.ZapiszDoLogow(blad)
                    byl_blad = True
                    bledy.append(blad)
                    self.PolSQL.Rollback()
                    continue

                status_import_z, zaimportowane, zaktualizowane, zwrotka = pobierajka.importuj_zamowienia(str(datetime.now()-timedelta(days=7))[:10])

                rsglobal.ZapiszDoLogow("importuj_zamowienia")
                rsglobal.ZapiszDoLogow(status_import_z)
                rsglobal.ZapiszDoLogow(zaimportowane)
                rsglobal.ZapiszDoLogow(zaktualizowane)
                rsglobal.ZapiszDoLogow(zwrotka)

                for x in xrange(len(zwrotka)):
                    zwrotka[x] = "Sklep {}: {}".format(nazwa, zwrotka[x])
                bledy += zwrotka
                if status_import_z not in ('OK', 'BRAK'):
                    blad = "Sklep {}, podczas importu zamwie napotkano problem, funkcja zwrcia: {}".format(nazwa, status_import_z)
                    rsglobal.ZapiszDoLogow(blad)
                    byl_blad = True
                    bledy.append(blad)
                    self.PolSQL.Rollback()
                    continue
                elif status_import_z == 'OK':
                    if zaimportowane > 0:
                        zaimportowano.append("Sklep {}, liczba zaimportowanych zamwie: {}.".format(nazwa, zaimportowane))
                    else:
                        if byl_blad:
                            zaimportowano.append("Sklep {}, nie zaimportowano adnych zamwie (wystpiy bdy).".format(nazwa))
                            rsglobal.ZapiszDoLogow(bledy)
                        else:
                            zaimportowano.append("Sklep {}, brak nowych zamwie do importu.".format(nazwa))
                    self.PolSQL.Commit()
                elif status_import_z == 'BRAK':
                    zaimportowano.append("Sklep {}, brak nowych zamwie do importu.".format(nazwa))

            except:
                import traceback
                blad = "Sklep " + nazwa + " \n" + traceback.format_exc()
                rsglobal.ZapiszDoLogow(blad)
                byl_blad = True
                bledy.append(blad)
                self.PolSQL.Rollback()
        dane += zaimportowano
        wyn1 += bledy
        wyn2 += uwagi

#-------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6 , 7 zamykanie, 9 - zmiana priorytetu #, 43 - przegladanie multiselect
#-------------------------------------------------------------------------------
if (Funkcja in [5,6,7,9,43]) and (stat=='OK') and (len(wyzn[0][0])>0):
    #Jeli trasa w filtrze - wybieranie kontrahentow po trasie:
    Kontr=[]
    if Trasa.strip()<>'':
        SELECT="SELECT DISTINCT kontrahent_id FROM rs_kontrahenci_trasy WHERE firma_id='"+self.firma_id+"' "
        SELECT+="AND trasa like '"+str(Trasa)+"%' AND (data_do is NULL OR data_do > current_date)  "
        stat,dane_k,wyn1,wyn2=self.PolSQL.Execute(SELECT,3)
        if stat<>'OK':
            stat='KONTR BL SQL TR'
            dane.append(stat)
        if len(dane_k)>0:
            for w in dane_k:
                Kontr.append(rsglobal.Dekoduj(w[0]))
        Kontr.append('Zaslepka')
   
    KontrahentTrasa=str(Kontr).replace('[','(').replace(']',')')

    # pobieramy te kontrahentw jeli s uprawnienia do tras
    if stat=='OK':
        KontrTrasyUpr=[]
        if Trasy.strip()<>'':
            SELECT="SELECT DISTINCT kontrahent_id FROM rs_kontrahenci_trasy WHERE firma_id='"+self.firma_id+"' "
            SELECT+="AND trasa IN ("+str(Trasy)+") AND (data_do is NULL OR data_do > current_date)  "
            stat,dane_kupr,wyn1,wyn2=self.PolSQL.Execute(SELECT,3)
            if stat<>'OK':
                stat='KONTR BL SQL TRUPR'
            if len(dane_kupr)>0:
                for w in dane_kupr:
                    KontrTrasyUpr.append(rsglobal.Dekoduj(w[0]))
            KontrTrasyUpr.append('Zaslepka')

        KontrahentTrasaUpr=str(KontrTrasyUpr).replace('[','(').replace(']',')')

    
    if stat=='OK':
        #Pobranie oddzialow w ktorych operator ma uprawnienia do ZO
        #Wyznaczniki dla grupy ZO
        SELECT = "SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND typ_faktury = 'ZO' ;"
        stat,dane_w,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat<>'OK':
            stat='WYZN BL SQL GR'
            dane.append(stat)

        if len(dane_w)>0 and stat=='OK':
            Wyznaczniki="("
            for w in dane_w:
                Wyznaczniki=Wyznaczniki+"'"+str(w[0])+"'"+","
            Wyznaczniki=Wyznaczniki.rstrip(',')
            Wyznaczniki=Wyznaczniki+")"
        else:
            stat='WYZN BR GR'
            dane.append(stat)
        #pobranie grup wyznacznikow
        if stat=='OK':
            stat,dane_o,dump,dump=self.PolSQL.Execute("SELECT grupa_id FROM rs_wyznacznik_grupa_oddzial WHERE firma_id = '"+self.firma_id+"' and wyznacznik_id in "+Wyznaczniki+" ;",3)
            if stat<>'OK':
                stat = 'ODDZ BL SQL'
                dane.append(stat)
            else:
                if len(dane_o)==0:
                    stat = 'ODDZ BR GR'
                    dane.append(stat)
        if stat=='OK':
            Grupy="("
            for w in dane_o:
                Grupy=Grupy+"'"+str(w[0])+"'"+","
            Grupy=Grupy.rstrip(',')
            Grupy=Grupy+")"
        #pobranie oddzialow
        SELECT = "SELECT oddzial_id FROM rs_grupa_operator_oddzial WHERE firma_id = '"+self.firma_id+"' AND operator_id in "+str(self.operatorzy)+" AND grupa_id in "+Grupy+" ;"
        stat,dane_od,dump,dump=self.PolSQL.Execute(SELECT,3,CzyDodawacBlad=True)
        if stat=='OK':
            CzyWszystkie=False
            Oddzialy="('',"
            for w in dane_od:
                if str(w[0]) =='**':
                    CzyWszystkie=True
                    break
                Oddzialy=Oddzialy+"'"+str(w[0])+"'"+","
            Oddzialy=Oddzialy.rstrip(',')
            Oddzialy=Oddzialy+")"
        if self.operator_id == STANDARD_OPERATOR_ID:
            CzyWszystkie=True
        if CzyWszystkie:
            OddzialKlucz = ''
        else:
            OddzialKlucz = "AND f.oddzial_id in "+Oddzialy+""
  
    if stat == 'OK':
        #Dodajemy do klauzuli where warunki umieszczone w filtrze okienka
        Where = " (f.firma_id = '" + self.firma_id+"' "+OddzialKlucz+" "
        if Wyznacznik_id not in puste_pola: 
            Where+=" AND f.wyznacznik_id = '" + Wyznacznik_id +"'"
        if Data_od not in puste_pola: 
            Where+=" AND f.data >= '" + Data_od + "'"
        if Data_do not in puste_pola: 
            Where+=" AND f.data <= '" + Data_do + "'"
        if Platnik_id not in puste_pola: 
            Where+=" AND f.platnik_id LIKE '" + Platnik_id + "%'"
        if Kontrahent_id not in puste_pola: 
            Where+=" AND f.kontrahent_id LIKE '" + Kontrahent_id + "%' "
        if Trasa.strip()<>'':
            Where+=" AND f.kontrahent_id in "+KontrahentTrasa+" "
        if Trasy.strip()<>'':
            Where+=" AND f.kontrahent_id in "+KontrahentTrasaUpr+" "
        if Funkcja == 43:
            #multiselect do pobrania zamowien w stanie 'G' na dok.magazynowy
            Where+=" AND stan='G'"
        else:
            if Stan not in puste_pola: 
                Where+=" AND f.stan LIKE '" + Stan +"%'"

        if Stale==False:
            Where+=" AND f.czy_stale<>true"
        if Jednorazowe==False:
            Where+=" AND f.czy_stale<>false"
        if Typ<>'':
            Where+=" AND f.typ_zamowienia='"+Typ+"'"
        if Handlowiec<>'':
            Where+=" AND f.handlowiec='"+Handlowiec+"'" 
        if not self.handlowiec_id in ('None',None,''):
            Where+=" AND f.handlowiec='"+self.handlowiec_id+"'"
        if Artykul<>'':
            Where+=" AND (zp.artykul_id LIKE '"+Artykul+"%' OR zps.artykul_id LIKE '"+Artykul+"%')"
        #AB 08.06.21r
        if Status != '':
            Where += " AND f.status_zamowienia = '"+Status+"'"
        Where+=") "
        #Zmienna Klucze zawiera klucze (klucz czyli krotka [wyznacznik,data,numer]) zamwien, ktre chcielibymy 
        #zobaczy mimo e nie pasuj one do filtra okienka
        #na przykad kiedy dodamy nowe zamwienie, a jego klucz nie pasuje do aktualnie wypenionego filtra             !!!!!!!!!
        for klucz in DodF:
            Where+="OR (f.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+klucz[0]+"' AND f.data='"+klucz[1]+"' AND f.numer='"+klucz[2]+"') "
        if self.CzyUpr:
            SELECT="SELECT DISTINCT f.stan,f.data,f.wyznacznik_id,f.numer,f.kontrahent_id||' - '||k.nazwa,f.platnik_id,f.typ_zamowienia,f.priorytet,0,0,0,0,f.oddzial_id,f.czy_stale,f.handlowiec, f.status_zamowienia "
        else:
            SELECT="SELECT DISTINCT f.stan,f.data,f.wyznacznik_id,f.numer,f.kontrahent_id||' - '||k.nazwa,f.platnik_id,f.typ_zamowienia,f.priorytet,f.do_zaplaty,f.kwota_netto,f.kwota_vat,f.do_zaplaty_wal,f.oddzial_id,f.czy_stale,f.handlowiec, f.status_zamowienia "
        FROM="FROM rs_zamowienia_odbiorcy f INNER JOIN rs_kontrahenci k ON (f.kontrahent_id=k.kontrahent_id AND f.firma_id=k.firma_id)"
        if Artykul<>'':
            FROM+=" LEFT OUTER JOIN rs_zamowienia_odbiorcy_pozycje zp ON (f.firma_id=zp.firma_id "
            FROM+=" AND f.wyznacznik_id=zp.wyznacznik_id AND f.data=zp.data AND f.numer=zp.numer)" 
            FROM+=" LEFT OUTER JOIN rs_zamowienia_odbiorcy_pozycje_stale zps ON (f.firma_id=zps.firma_id "
            FROM+=" AND f.wyznacznik_id=zps.wyznacznik_id AND f.data=zps.data AND f.numer=zps.numer)"
        if str(wyzn[0][0])[1:-1] <> '':
            WHERE=" WHERE f.wyznacznik_id in ("+str(wyzn[0][0])[1:-1]+") AND "+ Where
        else:
            WHERE=" WHERE f.wyznacznik_id in ('Zaslepka') AND "+ Where
        if WgKontrahentow:
            ORDER=" ORDER BY f.kontrahent_id||' - '||k.nazwa, f.data, f.wyznacznik_id,f.numer;"	
        else:
            ORDER=" ORDER BY f.wyznacznik_id,f.data,f.numer;"

        sql=SELECT+FROM+WHERE+ORDER
        rsglobal.ZapiszDoLogow('!!! SQL '+sql,1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3,CzyDodawacBlad=True)

        if stat!="OK":
            stat="PRZ BL SQL"
            dane.append(stat)

