# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_daty_dane.py
# Purpose:     wczytuje/edytuje daty zamowienia odbiorcy
#
# Author:      Marcin Grzeda
# Created:     2007/10/13
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_daty_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-04 Mariusz Rajfura  refaktoryzacja

Wyznacznik = rsglobal.Dekoduj(klucze[0])
Data = rsglobal.Dekoduj(klucze[1])
Numer = rsglobal.Dekoduj(klucze[2])
NaKiedy = rsglobal.Dekoduj(klucze[3])
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprIns = (self.oddzial_id,'024063') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprUpd = (self.oddzial_id,'024062') in self.uprawnienia or UprIns

puste_pola=['','    -  -  ',None]


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4):
    if Fun in (1,2) and not UprIns:
        stat='UPR INS'
        dane.append(stat)
        
    if Fun in (3,4) and not UprUpd:
        stat='UPR UPD'
        dane.append(stat)
    
    if stat == 'OK':    
        if not rsglobal.SprawdzCzyToData(Data):
            stat = "BL KLUCZ"
            dane.append(stat)
            
    if stat == 'OK':
        sql ="SELECT stan FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
        if len(d) == 0:
            stat = "BL KLUCZ"
            dane.append(stat)
        elif d[0][0]<>'W':
            stat='BL STAN'
            dane.append(stat)
                    
    if stat == 'OK' and Fun in (3,4):
        sql ="SELECT * FROM rs_zamowienia_odbiorcy_daty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND zamowienie_na_kiedy='"+str(NaKiedy)+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
        if len(d) == 0:
            stat = "BL KLUCZ"
            dane.append(stat)

    if stat == "OK":
        for i in xrange(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            
            if pole == 'zamowienie_nr':
                if wart.strip()=='':
                    stat='BR NR'
                    dane.append(stat)
                    
            elif pole == 'zamowienie_data':
                if wart <> '    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL DAT ZAM'
                        dane.append(stat)
                        
            elif pole == 'zamowienie_na_kiedy':
                if wart <> '    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL NA KIEDY'
                        dane.append(stat)
                    else:
                        sql ="SELECT * FROM rs_zamowienia_odbiorcy_daty"
                        sql+=" WHERE firma_id='"+self.firma_id+"' "
                        sql+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                        sql+=" AND numer="+str(Numer)+" AND zamowienie_na_kiedy='"+str(wart)+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
                        if len(d) > 0:
                            stat = "DATA POWT"
                            dane.append(stat)    
                else:
                    stat='BR NA KIEDY'
                    dane.append(stat)
    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
         
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == "OK":
    sql = "INSERT INTO rs_zamowienia_odbiorcy_daty"
    PolaN="firma_id,wyznacznik_id,data,numer"
    WartosciN = "'"+self.firma_id+"','"+Wyznacznik+"','"+Data+"','"+str(Numer)+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['zamowienie_nr','zamowienie_data']:
            PolaN += ","+pole
            if wart.strip()=='':
                WartosciN += ",NULL"
            else:
                WartosciN += ",'"+str(wart)+"'"
        elif pole in ['zamowienie_na_kiedy']:
            PolaN += ","+pole
            WartosciN += ",'"+str(wart)+"'"
            NaKiedy=wart    
    sql += " ("+PolaN+") VALUES ("+WartosciN+");"
    stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
    if stat<>'OK':
        stat='BL INS'
        dane.append(stat)

    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == "OK":
    NaKiedyNowe = NaKiedy
    sql = "UPDATE rs_zamowienia_odbiorcy_daty SET "
    for i in range(len(pola)):
        wart = wartosci[i]
        pole = pola[i]
        if pole in ['zamowienie_nr','zamowienie_data']:
            sql += pole+"="
            if wart.strip()=='':
                sql += "NULL,"
            else:
                sql += "'"+str(wart)+"',"
        elif pole in ['zamowienie_na_kiedy']:
            sql += pole+"="
            sql += "'"+str(wart)+"',"
            NaKiedyNowe = rsglobal.Dekoduj(wart)
            
    sql = sql.strip(',')
    sql+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
    sql+=" AND wyznacznik_id='"+Wyznacznik+"' AND numer="+str(Numer)
    sql+=" AND zamowienie_na_kiedy='"+str(NaKiedy)+"';"

    stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
    if stat == 'OK':
        NaKiedy = NaKiedyNowe
    else:
        stat = 'BL UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
if Fun in (5,3,1) and stat == "OK":
    sql ="SELECT * FROM rs_zamowienia_odbiorcy_daty "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND zamowienie_na_kiedy='"+NaKiedy+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL SQL SEL'
        dane.append(stat)
