# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_import_xml.py
# Purpose:     obsluga import zamowien odbiorcow z pliku xml
#
# Author:      Jan Raburski
# Created:     2012/01/25
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_import_xml.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje.fs_xml import XmlToRS

Kontrahent = rsglobal.Dekoduj(klucze[0]).strip()
PlikXML = klucze[1]
Kodowanie = klucze[2]
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# LISTA KATALOGW DO IMPORTU PLIKOW XML (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    sql ="SELECT DISTINCT folder_zamowienia FROM rs_kontrahenci"
    sql+=" WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND folder_zamowienia IS NOT NULL AND TRIM(folder_zamowienia)<>''"
    sql+=" AND (folder_nr_zamowien IS NULL OR TRIM(folder_nr_zamowien)='');"
    
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy katalogw: '+stat


#-------------------------------------------------------------------------------
# LISTA KATALOGW DO IMPORTU PLIKOW XML - TYLKO NUMERY ZAMOWIEN (13)
#-------------------------------------------------------------------------------

if Fun == 13 and stat == 'OK':
    sql ="SELECT DISTINCT folder_nr_zamowien FROM rs_kontrahenci"
    sql+=" WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND folder_nr_zamowien IS NOT NULL AND TRIM(folder_nr_zamowien)<>''"
    sql+=" AND (folder_zamowienia IS NULL OR TRIM(folder_zamowienia)='');"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy katalogw: '+stat


#-------------------------------------------------------------------------------
# LISTA KATALOGW DO IMPORTU PLIKOW XML - NUMERY ZWROTOW Z KONTROLA ILOSCI (15)
#-------------------------------------------------------------------------------

if Fun == 15 and stat == 'OK':
    sql ="SELECT DISTINCT folder_zwroty FROM rs_kontrahenci"
    sql+=" WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND folder_zwroty IS NOT NULL AND TRIM(folder_zwroty)<>'';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy katalogw: '+stat


#-------------------------------------------------------------------------------
# UTWORZENIE ZAMOWIENIA Z PODANEGO PLIKU (12)
# WPISANIE NR ZAMOWIENIA DO FAKTURY (14)
# WPISANIE NR ZWROTU DO D.D. (16)
#-------------------------------------------------------------------------------

if Fun in [12,14,16] and stat == 'OK':
    #--- inicjacja
    xml=XmlToRS()
    if not xml.Inicjuj(PlikXML):
        stat='Niepoprawny plik XML'
    #--- sprawdzenie poprawnosci pliku (czy to zamowienie i czy dla nas)
    if stat=='OK':
        if Fun in [12,14]:
            TypDokumentu = 'Order'
            TypKom = 'zamwienia'
        elif Fun == 16:
            TypDokumentu = 'ReturnsAnnouncement'
            TypKom = 'dowodu dostawy'
        
        if not xml.CzyJestTag('Document-'+TypDokumentu):
            stat='Plik nie zawiera '+TypKom
                
    if stat=='OK':
        OddzialILN=xml.PodajWartosc([TypDokumentu+'-Parties','Seller','ILN'])
        sql ="SELECT oddzial_id FROM rs_oddzialy"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND gln='"+OddzialILN+"';"
        stat,oddzialy,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(oddzialy)==0:
                stat='Brak oddziau o GLN='+OddzialILN
            else:
                OddzialId=oddzialy[0][0]
        else:
            stat = 'Bd pobrania listy oddziaw: '+stat
    #--- wyszukanie kontrahenta i platnika
    if stat=='OK':
        PlatnikILN=xml.PodajWartosc([TypDokumentu+'-Parties','Buyer','ILN'])
        if xml.CzyJestTag('BuyerHeadquarters'):
            PlatnikILN=xml.PodajWartosc([TypDokumentu+'-Parties','BuyerHeadquarters','ILN'])
        sql ="SELECT kontrahent_id,zamawiajacy_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND gln='"+PlatnikILN+"';"
        stat,platnicy,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(platnicy)==0:
                stat='Brak patnika o GLN='+PlatnikILN
            elif len(platnicy)>1:
                stat='Wicej ni 1 patnik o GLN='+PlatnikILN
            else:
                PlatnikId=platnicy[0][0]
                ZamawiajacyId=platnicy[0][1].strip()
        else:
            stat = 'Bd pobrania patnika: '+stat
            
    if stat=='OK':
        KontrahentILN=xml.PodajWartosc([TypDokumentu+'-Parties','DeliveryPoint','ILN'])
        sql ="SELECT kontrahent_id,zamawiajacy_id FROM rs_kontrahenci"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND gln='"+KontrahentILN+"';"
        stat,kontrahenci,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(kontrahenci)==0:
                stat='Brak kontrahenta o GLN='+KontrahentILN
            elif len(kontrahenci)>1:
                stat='Wicej ni 1 kontrahent o GLN='+KontrahentILN
            else:
                KontrahentId=kontrahenci[0][0]
                if not kontrahenci[0][1].strip() in ['','None']:
                    ZamawiajacyId=kontrahenci[0][1].strip()
                    
                if ZamawiajacyId in ['','None']:
                    ZamawiajacyId=KontrahentId
        else:
            stat = 'Bd pobrania kontrahenta: '+stat

    if stat=='OK':
        if Fun in [12,14]:
            ZamowienieNr=xml.PodajWartosc(['Order-Header','OrderNumber'])
            ZamowienieData=xml.PodajWartosc(['Order-Header','OrderDate'])
            DataDostawy=xml.PodajWartosc(['Order-Header','ExpectedDeliveryDate'])
        elif Fun == 16:
            DowodNr = xml.PodajWartosc(['ReturnsAnnouncement-Header','DocumentNumber'])
            DataDowodu = xml.PodajWartosc(['ReturnsAnnouncement-Header','DocumentDate'])
            
    if stat=='OK':
        # sprawdzenie czy tabela rs_artykuly_zamowienia_oddzialy jest wypeniona w ramach firmy
        SQL = "SELECT * FROM rs_artykuly_zamowienia_oddzialy WHERE firma_id='"+self.firma_id+"' LIMIT 1"
        rsglobal.ZapiszDoLogow('!!! '+SQL,1)
        stat,DOddz,dump,dump = self.PolSQL.Execute(SQL,3)
        rsglobal.ZapiszDoLogow('DOddz '+str(DOddz),1)
        if stat <> 'OK':
            stat = u'Bd pobierania danych z rs_artykuly_zamowienia_oddzialy:'+stat
        else:
            # zmienna czy sprawdza oddzia w rs_artykuly_zamowienia_oddzialy
            CzySprOddz = (len(DOddz) > 0)
            rsglobal.ZapiszDoLogow('CzySprOddz '+str(CzySprOddz),1)
            
#-------------------------------------------------------------------------------
# UTWORZENIE ZAMOWIENIA Z PODANEGO PLIKU (12)
#-------------------------------------------------------------------------------
            
if Fun == 12 and stat == 'OK':
    #--- pobranie numeru i innych danych zamowienia
    if stat=='OK':
        sql ="SELECT wyznacznik_id,data,numer FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+KontrahentId+"' AND data='"+ZamowienieData+"'"
        sql+=" AND zamowienie_nr='"+ZamowienieNr+"';"
        stat,zamowienia,dump,dump = self.PolSQL.Execute(sql,3)
        if stat == 'OK':
            if len(zamowienia)>0:
                stat='Zamwienie ju istnieje - '+zamowienia[0][0]+'/'+zamowienia[0][1]+'/'+str(zamowienia[0][2])+'dla numeru zamwienia '+ZamowienieNr
        else:
            stat = 'Bd sprawdzania zamwie: '+stat


    #--- pobranie wyznacznika i danych do fakturowania
    if stat=='OK':
        Wyznacznik=''
        sql ="SELECT COALESCE(zamowienie,''),COALESCE(spos_zaplaty,'NULL'),COALESCE(spos_dostawy,'NULL'),COALESCE(projekt_id,'NULL')"
        sql+=" FROM rs_kontrahenci_fakturowanie"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+PlatnikId+"' ORDER BY data_od DESC"
        sql+=" LIMIT 1;"
        stat,wyznaczniki,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd szukanie wyznacznika: '+stat
            
        if stat=='OK':
            if len(wyznaczniki)>0:
                Wyznacznik=wyznaczniki[0][0].strip()
                SposZaplaty=wyznaczniki[0][1].strip()
                SposDostawy=wyznaczniki[0][2].strip()
                ProjektId=wyznaczniki[0][3].strip()
                
            #--- moze kontrahent ma inny ?
            sql ="SELECT zamowienie,spos_zaplaty,spos_dostawy,projekt_id FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+KontrahentId+"' ORDER BY data_od DESC"
            sql+=" LIMIT 1;"
            stat,wyznaczniki,dump,dump = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bd szukanie wyznacznika: '+stat
            
        if stat == 'OK':
            if len(wyznaczniki)>0:
                if not wyznaczniki[0][0].strip() in ('None',''):
                    Wyznacznik=wyznaczniki[0][0].strip()
                if not wyznaczniki[0][1].strip() in ('None',''):
                    SposZaplaty=wyznaczniki[0][1].strip()
                if not wyznaczniki[0][2].strip() in ('None',''):
                    SposDostawy=wyznaczniki[0][2].strip()
                if not wyznaczniki[0][3].strip() in ('None',''):
                    ProjektId=wyznaczniki[0][3].strip()
 
            if not SposZaplaty=='NULL':
                SposZaplaty="'"+SposZaplaty+"'"
            if not SposDostawy=='NULL':
                SposDostawy="'"+SposDostawy+"'"
            if not ProjektId=='NULL':
                ProjektId="'"+ProjektId+"'"
 
        if stat=='OK' and Wyznacznik=='':
            #--- nie ma w danych podstawowych szukamy w zamowieniach
            sql ="SELECT DISTINCT wyznacznik_id FROM rs_zamowienia_odbiorcy"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND kontrahent_id='"+KontrahentId+"'"
            sql+=" AND platnik_id='"+PlatnikId+"';"
            stat,wyznaczniki,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd szukanie wyznacznika: '+stat
        
        if stat=='OK':
            if len(wyznaczniki)>0:
                w=wyznaczniki[0][0].strip()
                if w<>'None' and w<>'':
                    Wyznacznik=w
                
        if stat=='OK' and Wyznacznik=='':
            stat='Brak wyznacznika zamwienia dla kontrahenta '+KontrahentId+' i patnika '+PlatnikId

    #---------------------------------------------------------------------------
    #- PTLA PO POZYCJACH ZAMWIENIA
    #- dla kadej pozycji - jeli trzeba - sprawdzamy oddzia artykuu dla kontrahenta
    # i jeli nie ma zamwienia dla danego oddziau to dodajemy jego nagwek
    #---------------------------------------------------------------------------

    #--- pobranie pozycji
    if stat == 'OK':
        Wiersze=xml.PodajListeWierszy(['Order-Lines','Line','Line-Item'],['EAN','BuyerItemCode','OrderedQuantity'])
        if len(Wiersze) == 0:
            stat = 'Brak pozycji dla zamwienia'
    
    if stat == 'OK':
        SOddzialy = {} # klucz to oddzia a wynik to nr zamwienia i nr pozycji kolejnej
        LBledy = ''
        LBledyGrOdb = ''
        LMail = []
        for wiersz in Wiersze:
            # pobranie artykuu z wiersza
            Art=''
            if stat =='OK':
                sql ="SELECT DISTINCT artykul_id FROM rs_artykuly_ean"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND ean='"+wiersz[0]+"';"
                stat,DArt,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd szukania artykuu: '+stat
                
                if stat =='OK':
                    if len(DArt)>0:
                        Art=DArt[0][0].strip()
                    
            if stat =='OK' and Art == '':
                #--- szukanie artykulu po symbolu obcym
                sql ="SELECT DISTINCT artykul_id FROM rs_artykuly_obce"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND (obcy_ean='"+wiersz[0]+"'"
                sql+=" OR obcy_id='"+wiersz[1]+"');"
                stat,DArt,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd szukania artykuu: '+stat
            
                if stat =='OK':
                    if len(DArt)>0:
                        Art=DArt[0][0].strip()
                        
            if stat =='OK' and Art == '':
                #--- szukanie artykulu po symbolu naszym
                sql ="SELECT DISTINCT artykul_id FROM rs_artykuly"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND artykul_id='"+wiersz[1]+"';"
                stat,DArt,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd szukania artykuu: '+stat

                if stat =='OK':
                    if len(DArt)>0:
                        Art=DArt[0][0].strip()
                           
            if stat =='OK' and Art == '':
                LBledy +='Nie znaleziono artykuu o kodzie EAN '+wiersz[0]+' i symbolu '+wiersz[1]+'\n'
                continue
            
            # pobranie oddziau dla znalezionego artykuu
            if stat =='OK':
                OddzTmp = ''
                # po staremu - brak danych w rs_artykuly_zamowienia_oddzialy
                if not CzySprOddz:
                    OddzTmp = OddzialId
                else:
                    rsglobal.ZapiszDoLogow('SZUKAMY ODDZIAU',1)
                    # pobranie oddziau z rs_artykuly_zamowienia_oddzialy
                    # sprawdzamy dla kontrahenta
                    SQL = "SELECT oddzial_id FROM rs_artykuly_zamowienia_oddzialy "
                    SQL+= " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND kontrahent_id='"+KontrahentId+"'"
                    stat,DOddz,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat <> 'OK':
                        stat = 'Bd szukania oddziau dla kontrahenta: '+stat
    
                    if stat =='OK':
                        if len(DOddz)>0:
                            OddzTmp=DOddz[0][0].strip()
                    
                    if stat =='OK' and OddzTmp == '':
                        # sprawdzamy dla patnika
                        SQL = "SELECT oddzial_id FROM rs_artykuly_zamowienia_oddzialy "
                        SQL+= " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND kontrahent_id='"+PlatnikId+"'"
                        stat,DOddz,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd szukania oddziau dla kontrahenta: '+stat
        
                        if stat =='OK':
                            if len(DOddz)>0:
                                OddzTmp=DOddz[0][0].strip()
            
                    if stat == 'OK':
                        if OddzTmp == '':
                            LBledy+= 'Nie znaleziono oddziau dla artykuu '+Art+' kontrahenta '+KontrahentId+' i patnika '+PlatnikId+'\n'
                            LMail.append(['',KontrahentId,Art,'Nie znaleziono oddziau dla artykuu '+Art+' kontrahenta '+KontrahentId+' i patnika '+PlatnikId])
                            continue
                rsglobal.ZapiszDoLogow('Oddz tmp '+OddzTmp,1)
                
            # sprawdzenie koniecznoci dodania nagwka zamwienia dla niepodanego wczeniej oddziau
            if stat == 'OK' and not OddzTmp in SOddzialy:
                #--- pobranie numeru dla zamowienia
                SQL ="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
                SQL+="'[\\\'"+Wyznacznik+"\\\',\\\'"+ZamowienieData+"\\\']','ZO') AS numer"
                stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd szukanie numeru zamwienia: '+stat
                elif len(DNr)>0:
                    ZamNr=DNr[0][0]
                else:
                    stat = 'Nie udao si pobra numeru zamwienia odbiorcy'
                    
                #--- insert naglowka
                if stat == 'OK':
                    SQL="INSERT INTO rs_zamowienia_odbiorcy "
                    SQL+=" (firma_id,wyznacznik_id,data,numer,oddzial_id,"
                    SQL+=" stan,kontrahent_id,platnik_id,dostawy_od_dnia,dostawy_do_dnia, "
                    SQL+=" zamowienie_nr,zamowienie_data,waluta,kurs,zamawiajacy_id,"
                    SQL+=" sposob_zaplaty,sposob_dostawy,projekt_id) VALUES ("
                    SQL+="'"+self.firma_id+"','"+Wyznacznik+"','"+ZamowienieData+"',"+ZamNr+",'"+OddzTmp+"',"
                    SQL+="'W','"+KontrahentId+"','"+PlatnikId+"','"+DataDostawy+"','"+DataDostawy+"',"
                    SQL+="'"+ZamowienieNr+"','"+ZamowienieData+"','PLN',1,'"+ZamawiajacyId+"',"
                    SQL+=SposZaplaty+","+SposDostawy+","+ProjektId+");"
                    rsglobal.ZapiszDoLogow('SQLN '+SQL,1)
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                    rsglobal.ZapiszDoLogow('stat '+stat,1)
            
                # dodanie oddziau na list zamwie
                if stat == 'OK':  
                    SOddzialy[OddzTmp] = [str(ZamNr),1]
                    
                    
            # wiemy, e nagowek istnieje i wybrano oddzia wic dodajemy pozycj
            if stat == 'OK':      
                Ilosc1=float(wiersz[2])
                
                SQL ="SELECT przelicznik,stawka_vat FROM rs_artykuly"
                SQL+=" WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND artykul_id='"+Art+"';"
                stat,DPrzel,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = u'Bd szukania przelicznika dla artykuu '+Art+': '+stat
                elif len(DPrzel) == 0:
                    LBledy += u'Brak przelicznika dla artykuu '+Art
                    continue

            # sprawdzamy, czymona zamwi ten artyku w oparciu o grupy odbiorcw - asortyment
            if stat == 'OK':
                SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+KontrahentId+"','"+Art+"','"+DataDostawy+"')"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd analizy grup odbiorcw dla kontrahenta '+KontrahentId+'i  artykuu '+Art+': '+stat
                    dane.append(stat)
                elif DTest[0][0] <> 'OK':
                    # dodajemy do listy bdw powiconych grupom odbiorcw
                    LBledyGrOdb += DTest[0][0]+'\n'
                    continue

            if stat == 'OK':      
                Przelicznik=float(DPrzel[0][0])
                StawkaVat=DPrzel[0][1]
                SQL="INSERT INTO rs_zamowienia_odbiorcy_pozycje "
                SQL+=" (firma_id,wyznacznik_id,data,numer,"
                SQL+=" nr_poz,nr_ppoz,data_od,data_do, artykul_id, "
                SQL+=" ilosc1,ilosc2,stawka_vat) VALUES ("
                SQL+="'"+self.firma_id+"','"+Wyznacznik+"','"+ZamowienieData+"',"+SOddzialy[OddzTmp][0]+","
                SQL+=str(SOddzialy[OddzTmp][1])+",0,'"+DataDostawy+"','"+DataDostawy+"','"+Art
                SQL+="',"+str(Ilosc1)+","+str(rsglobal.RSRound(Ilosc1*Przelicznik,3))+",'"+StawkaVat+"');"
                rsglobal.ZapiszDoLogow('SQLP '+SQL,1)
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat <> 'OK':
                    stat = u'Bdy wstawiania pozycji do zamwienia :'+stat+'\n ZAPYTANIE\n'+SQL
                rsglobal.ZapiszDoLogow('stat '+stat,1)
                if stat == 'OK':
                    SOddzialy[OddzTmp][1] += 1
        
            # sprawdzenie kwestii zeszotygodniowego zamwienia
            if stat == 'OK':
                # sprawdzenie czy istnieje zamwienie z zeszego tygodnia
                SQL = "SELECT wyznacznik_id,data,numer FROM rs_zamowienia_odbiorcy"
                SQL+= " WHERE firma_id = '"+self.firma_id+"' AND data = '"+ZamowienieData+"'::DATE - 7"
                SQL+=" AND oddzial_id='"+OddzTmp+"' AND kontrahent_id='"+KontrahentId+"';"
                stat,DZamTmp,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = u'Bdy sprawdzania historycznego zamwienia :'+stat+'\n ZAPYTANIE\n'+SQL
                elif len(DZamTmp) == 0:
                    LMail.append([OddzTmp,1,KontrahentId])
                else:
                    # sprawdzenie czy istnieje pozycja z zeszego tygodnia
                    SQL = "SELECT zop.ilosc1 FROM rs_zamowienia_odbiorcy_pozycje zop"
                    SQL+= " INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer)"
                    SQL+= " WHERE zop.firma_id = '"+self.firma_id+"' AND zop.data = '"+ZamowienieData+"'::DATE - 7"
                    SQL+=" AND zo.oddzial_id='"+OddzTmp+"' AND zo.kontrahent_id='"+KontrahentId+"' AND zop.artykul_id='"+Art+"';"
                    stat,DPozZamTmp,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat <> 'OK':
                        stat = u'Bdy sprawdzania historycznych pozycji zamwienia :'+stat+'\n ZAPYTANIE\n'+SQL
                    elif len(DPozZamTmp) == 0:
                        LMail.append([OddzTmp,3,KontrahentId,Art,0,Ilosc1])
                    elif len(DPozZamTmp) > 1:
                        LMail.append([OddzTmp,2,KontrahentId,Art])
                    elif DPozZamTmp[0][0]/Ilosc1> 1.5 or Ilosc1/DPozZamTmp[0][0] <0.5:
                        # sprawdzenie czy nie nastpia zmiana powyej 50% rnicy
                        LMail.append([OddzTmp,3,KontrahentId,Art,DPozZamTmp[0][0],Ilosc1])
        
        if stat == 'OK' and LBledy <> '':
            stat = LBledy

        # sprawdzenie czy istniej pozycje z zamwienia kontrahenta, ktre nie byy w tym zamwieniu
        if stat == 'OK':
            SQL = "SELECT zos.oddzial_id,zops.artykul_id,zops.ilosc1 FROM rs_zamowienia_odbiorcy_pozycje zops"
            SQL+= " INNER JOIN rs_zamowienia_odbiorcy zos USING (firma_id,wyznacznik_id,data,numer)"
            SQL+= " LEFT OUTER JOIN rs_zamowienia_odbiorcy_pozycje zop ON (zop.firma_id = zops.firma_id"
            SQL+= " AND zop.data = zops.data + 7 AND zop.artykul_id=zops.artykul_id)"
            SQL+= " LEFT OUTER JOIN rs_zamowienia_odbiorcy zo ON (zo.firma_id = zop.firma_id "
            SQL+= " AND zo.wyznacznik_id= zop.wyznacznik_id AND zo.data = zop.data + 7 "
            SQL+= " AND zo.numer = zop.numer AND zo.kontrahent_id = zos.kontrahent_id "
            SQL+= " AND zo.oddzial_id = zos.oddzial_id)"
            SQL+= " WHERE zops.firma_id = '"+self.firma_id+"' AND zops.data = '"+ZamowienieData+"'::DATE - 7 "
            SQL+= " AND zos.kontrahent_id = '"+KontrahentId+"'"
            # ten filtr mwi e nie znaleziono pozycji z artykuem albo artykuu dla tego samego oddziau (bo nagwka nie ma)
            SQL+= " AND zo.oddzial_id IS NULL"
            stat,DBrak,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = u'Bdy sprawdzania historycznych pozycji zamwienia, ktrych nie ma na aktualnym zamwieniu :'+stat+'\n ZAPYTANIE\n'+SQL
            
        if stat == 'OK':
            for poz in DBrak:
                LMail.append([poz[0],3,KontrahentId,poz[1],poz[2],0])
            # podstawienie treci mailowej do wyn2
            wyn2 = LMail

        # dodajemy bdy grup odbiorcw do wywietlenia. S one niekrytyczne i dlatego je dodajemy dopiero tutaj
        LBledy +=LBledyGrOdb
        wyn1 = [LBledy]

#-------------------------------------------------------------------------------
# WPISANIE NR ZAMOWIENIA DO FAKTURY (14)
#-------------------------------------------------------------------------------
        
if Fun == 14 and stat == 'OK':
    ##--- wyszukanie faktury
    #sql ="SELECT wyznacznik_id, numer, zamowienie_nr FROM rs_faktury"
    #sql+=" WHERE firma_id='"+self.firma_id+"'"
    ##sql+=" AND oddzial_id='"+self.oddzial_id+"'"
    #sql+=" AND kontrahent_id='"+KontrahentId+"' AND data='"+DataDostawy+"';"
    #stat,faktury,dump,dump = self.PolSQL.Execute(sql,3)
    #if stat == 'OK':
    #    if len(faktury)==0:
    #        stat='Brak faktury dla zamwienia nr - '+ZamowienieNr
    #else:
    #    stat = 'Bd szukania faktur: '+stat
    #
    ##--- wstawianie numeru i daty zamowienia do faktur
    #if stat=='OK':
    #    sql=''
    #    for f in faktury:
    #        if f[2].strip() in ['','None']:
    #            sql+="UPDATE rs_faktury SET zamowienie_nr='"+ZamowienieNr+"', zamowienie_data='"+ZamowienieData+"'"
    #            sql+=" WHERE firma_id='"+self.firma_id+"'"
    #            #sql+=" AND oddzial_id='"+self.oddzial_id+"'"
    #            sql+=" AND data='"+DataDostawy+"'"
    #            sql+=" AND wyznacznik_id='"+f[0]+"' AND Numer="+str(f[1])+";"
    #    if sql<>'':
    #        stat,faktury,dump,dump = self.PolSQL.Execute(sql,1)
    #    if stat <> 'OK':
    #        stat = 'Bd wstawiania zamwienia: '+stat

    #JR 2020-07-25 Mantis: 12065
    sql = "UPDATE rs_faktury SET zamowienie_nr='"+ZamowienieNr+"', zamowienie_data='"+ZamowienieData+"'"
    sql += " WHERE firma_id='"+self.firma_id+"'"
    sql += " AND kontrahent_id='"+KontrahentId+"' AND TRIM(COALESCE(zamowienie_nr,''))=''"
    sql += " AND dostawy_od_dnia <='" + DataDostawy + "' AND dostawy_do_dnia >='" + DataDostawy + "';"
    stat, faktury, status, dump = self.PolSQL.Execute(sql, 1)
    if stat != 'OK':
        stat = 'Bd wstawiania numeru zamwienia: '+stat
    elif status == 'UPDATE 0':
        stat = 'Nie znaleziono faktur do wstawienia numeru zamwienia'

#-------------------------------------------------------------------------------
# WPISANIE NR ZWROTU DO D.D. (16)
#-------------------------------------------------------------------------------

if Fun == 16 and stat == 'OK':
    LBledy = ''
    Wiersze = []
    
    # wyszukanie dowodu dostawy zwrotu
    SQL = "SELECT oddzial_id,trasa,data,tryb_dostawy,numer FROM rs_dowody_dostaw "
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND data = '"+DataDowodu+"'::DATE - 1 AND kontrahent_id='"+KontrahentId+"';"
    stat,DDowod,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DDowod)==0:
            stat='Brak dowodu dostawy dla dokumentu nr - '+DowodNr
        elif len(DDowod) > 1:
            stat='Znaleziono wicej ni jeden dowd dostawy dla dokumentu nr - '+DowodNr
    else:
        stat = 'Bd szukania dowodu dostawy: '+stat
        
    # skoro jest jeden to wpisujemy mu numer dowodu zwrotu
    if stat =='OK':
        SQL="UPDATE rs_dowody_dostaw SET dowod_zwrotu = '"+DowodNr+"'"
        SQL+=" WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+DDowod[0][0]+"' AND trasa = '"+DDowod[0][1]+"'"
        SQL+=" AND data = '"+DDowod[0][2]+"' AND tryb_dostawy='"+DDowod[0][3]+"' AND numer="+str(DDowod[0][4])
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'Bd zmiany nagwka dowodu dostawy: '+stat
        
        # porwnanie pozycji
    if stat =='OK':
        Wiersze=xml.PodajListeWierszy(['ReturnsAnnouncement-Lines','Line','Line-Item'],['EAN','BuyerItemCode','ReturnQuantity'])
    
    for wiersz in Wiersze:
        if stat == 'OK':
            Ilosc1=-1*float(wiersz[2])
            #--- szukanie artykulu po kodzie ean
            ArtykulId=''
            sql ="SELECT DISTINCT artykul_id FROM rs_artykuly_ean"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND ean='"+wiersz[0]+"';"
            stat,artykuly,dump,dump = self.PolSQL.Execute(sql,3)
            if stat == 'OK':
                if len(artykuly)>0:
                    ArtykulId=artykuly[0][0].strip()
            else:
                stat = 'Bd szukania artykuu po kodzie EAN: '+stat
                
        if stat == 'OK' and ArtykulId == '':
            #--- szukanie artykulu po symbolu obcym
            sql ="SELECT DISTINCT artykul_id FROM rs_artykuly_obce"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND (obcy_ean='"+wiersz[0]+"'"
            sql+=" OR obcy_id='"+wiersz[1]+"');"
            stat,artykuly,dump,dump = self.PolSQL.Execute(sql,3)
            if stat == 'OK':
                if len(artykuly)>0:
                    ArtykulId=artykuly[0][0].strip()
            else:
                stat = 'Bd szukania artykuu po symbolu obcym: '+stat
                    
        if stat == 'OK' and ArtykulId == '':
            #--- szukanie artykulu po symbolu naszym
            sql ="SELECT DISTINCT artykul_id FROM rs_artykuly"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND artykul_id='"+wiersz[1]+"';"
            stat,artykuly,dump,dump = self.PolSQL.Execute(sql,3)
            if stat == 'OK':
                if len(artykuly)>0:
                    ArtykulId=artykuly[0][0].strip()
            else:
                stat = 'Bd szukania artykuu po symbolu naszym: '+stat
            
        if stat == 'OK' and ArtykulId=='':
            LBledy +=u'Nie znaleziono artykuu o kodzie EAN '+wiersz[0]+' i symbolu '+wiersz[1]

        if stat == 'OK' and ArtykulId <> '':
            # pobranie artykuu z dowodu dostawySQL="UPDATE rs_dowody_dostaw SET dowod_zwrotu = '"+DowodNr+"'"
            SQL = "SELECT ilosc_zwr1 FROM rs_dowody_dostaw_pozycje"
            SQL+=" WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+DDowod[0][0]+"' AND trasa = '"+DDowod[0][1]+"'"
            SQL+=" AND data = '"+DDowod[0][2]+"' AND tryb_dostawy='"+DDowod[0][3]+"' AND numer="+str(DDowod[0][4])
            SQL+=" AND artykul_id='"+ArtykulId+"'"
            stat,DPoz,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd pobrania iloci zwrconej z dowodu dostawy: '+stat
                
            if stat == 'OK':
                if len(DPoz) == 0:
                    LBledy +=u"Brak artykuu '"+ArtykulId+"' w pozycjach dowodu dostawy\n"
                elif DPoz[0][0] <> Ilosc1:
                    LBledy +=u"Rzne iloci dla artykuu '"+ArtykulId+"' w pozycjach dowodu dostawy ("+str(DPoz[0][0])+") i w pliku XML ("+str(Ilosc1)+")\n"
    
    if stat =='OK':
        wyn1 = [LBledy]
        

#-------------------------------------------------------------------------------
# WYSANIE MAILI PO IMPORCIE Z XML (21)
#-------------------------------------------------------------------------------
        
if Fun == 21 and stat == 'OK':
    DaneDoMaila = klucze[2]
    
    for Oddzial in DaneDoMaila:                        
        Temat = "Lista spraw zwizana z importem zamwie z xml zrobionym dnia "+rsglobal.PodajDzis()+" dla oddziau "+Oddzial
        Tresc="Poniej znajduje si lista spraw, ktre dotycz importu zamwie z pliku.\n"
        
        Sprawy = DaneDoMaila[Oddzial]
        Sprawy.sort()
        
        SQLKontr = "SELECT nazwa,TRIM(adr_miej||' 'adr_kod||'; '||adr_ulica||' '||adr_nry),"
        SQLKontr+= " TRIM(tel1||' '||tel2) FROM rs_kontrahenci "
        SQLKontr+= " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = "
        
        SQLArt = "SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = "
        # informacja o braku zamwie
        Pierwsze = True
        for sprawa in Sprawy:
            if sprawa[0] == 1 and stat == 'OK':
                if Pierwsza:
                    Tresc+="\nLISTA KONTRAHENTW, KTRZY NIE MIELI ZAMWIE W ZESZYM TYGODNIU\n\n"
                    Pierwsza = False
                    
                stat,DKontr,dump,dump = self.PolSQL.Execute(SQLKontr+"'"+sprawa[1]+"'",3)
                if stat == 'OK':
                    if len(DKontr) == 0:
                        Tresc += "NIE ZNALEZIONO KONTRAHENTA O SYMBOLU "+sprawa[1]+'\n'
                    else:
                        Tresc+="  "+sprawa[1].strip()+'   '+DKontr[0][0].strip()+' '+DKontr[0][1].strip()+'   tel:'+DKontr[0][2]+'\n'
        
        
        # informacja o podwjnych pozycjach
        Pierwsze = True
        Kontr == ''
        for sprawa in Sprawy:
            if sprawa[0] == 2 and stat == 'OK':
                if Pierwsza:
                    Tresc+="\nLISTA KONTRAHENTW, KTRZY MIELI PODWJNE POZYCJE DLA ARTYKUW\n\n"
                    Pierwsza = False
                
                if Kontr <> sprawa[1]:
                    stat,DKontr,dump,dump = self.PolSQL.Execute(SQLKontr+"'"+sprawa[1]+"'",3)
                    if stat == 'OK':
                        if len(DKontr) == 0:
                            Tresc += "NIE ZNALEZIONO KONTRAHENTA O SYMBOLU "+sprawa[1]+'\n'
                        else:
                            Tresc+="  "+sprawa[1].strip()+'   '+DKontr[0][0].strip()+' '+DKontr[0][1].strip()+'   tel:'+DKontr[0][2]+'\n'
                            
                        Kontr = sprawa[1]
                
                if stat == 'OK':
                    stat,DArt,dump,dump = self.PolSQL.Execute(SQLArt+"'"+sprawa[2]+"'",3)
                    if stat == 'OK':
                        if len(DArt) == 0:
                            Tresc += "NIE ZNALEZIONO ARTYKUU O SYMBOLU "+sprawa[2]+'\n'
                        else:
                            Tresc+="    Artyku: "+sprawa[2].strip()+'   '+DArt[0][0].strip()+'\n'
                            
        
        # informacje i zmianach ilociowych na zamwieniach
        Pierwsze = True
        Kontr == ''
        for sprawa in Sprawy:
            if sprawa[0] == 3 and stat == 'OK':
                if Pierwsza:
                    Tresc+="\nLISTA KONTRAHENTW, KTRZY MIELI PODWJNE POZYCJE DLA ARTYKUW\n\n"
                    Pierwsza = False
                
                if Kontr <> sprawa[1]:
                    stat,DKontr,dump,dump = self.PolSQL.Execute(SQLKontr+"'"+sprawa[1]+"'",3)
                    if stat == 'OK':
                        if len(DKontr) == 0:
                            Tresc += "NIE ZNALEZIONO KONTRAHENTA O SYMBOLU "+sprawa[1]+'\n'
                        else:
                            Tresc+="  "+sprawa[1].strip()+'   '+DKontr[0][0].strip()+' '+DKontr[0][1].strip()+'   tel:'+DKontr[0][2]+'\n'
                            
                        Kontr = sprawa[1]
                
                if stat == 'OK':
                    stat,DArt,dump,dump = self.PolSQL.Execute(SQLArt+"'"+sprawa[2]+"'",3)
                    if stat == 'OK':
                        if len(DArt) == 0:
                            Tresc += "NIE ZNALEZIONO ARTYKUU O SYMBOLU "+sprawa[2]+'\n'
                        else:
                            WartS = sprawa[4]
                            WartN = sprawa[5]
                            Tresc+="    Artyku: "+sprawa[2].strip()+'   '+DArt[0][0].strip()+'\n'
                            Tresc+="    Warto stara : "+str(WartS) + "   Warto nowa : "+str(WartN)
                            
                            if WartS == 0:
                                Tresc+="  Zmiana : 100% (nowy)\n"
                            elif WartN == 0:
                                Tresc+="  Zmiana : -100% (usunity)\n"
                            else:
                                Tresc+="  Zmiana :"+str(rsglobal.RSRound(((WartN-WartS)/WartS)*100,1))+"%\n"
        
        
        # pobranie adresw na ktre ma to pj dla konkretnego oddziau
        SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND powiadomienie='S0002' AND oddzial_id IN ('"+Oddzial+"','**');"
        stat,DPoczta,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':    
            stat=u"Bd pobierania listy kont pocztowych dla oddziau "+Oddzial+" : "+stat
        if stat=='OK':
            for mail in DPoczta:
                rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,self.PolSQL)
    