# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_import_z_xls.py
# Purpose:     obsluga import zamowien odbiorcow z pliku xls
# Author:      Micha Raburski
# Created:     2012/09/16
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_import_z_xls.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2202-12-01 Jan Raburski (13263) obcinanie zamowien ilosciowo/procentowo

import datetime

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']
    
    # 1 - import pozycji z pliku
    
    SlPar = {'TrescPliku':[1], 'Data':[1], 'Typ':[1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_import_z_xls z numerem '+str(Fun)+' bez parametrw: '+Lista


if stat == 'OK':
    if Fun == 1:
        TrescPliku = str(klucze['TrescPliku'])
        Data = str(klucze['Data'])
        Typ = str(klucze['Typ'])
        
#-------------------------------------------------------------------------------
# IMPORT DANYCH Z PLIKU XLS DO ZAMOWIE ODBIORCW
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    # UWAGA : Na razie pliki z SPC to tylko z nazwy XLS, a w praktyce to CSV rozdzielone tabulatorem. 
    # sprawdziem, e tych "oryginalnych" plikw z SPC biblioteka do xls nie otwiera. Za to dziaaj 
    # proste zabiegi rozbijajce tre umieszczone poniej.
    
    # ZMIENNE:
    # SPlatnicy    [sybol patnika] = [Lista kontrahentw patnika, 
    #                   Sownik list kontrahentw z pliku podzielonych rzutem, Sownik [kontrahent] : lista oddziaw]  
    #               - sownik do analizy, ktrych kontrahentw nie byo
    # SKontrahenci [symbol_obcy] = [symbol,patnik,nazwa,adres,tel,Zamwienia(z rzutem), oddzial] - sownik sklepw 
    # SArtykuly    [symbol_obcy] = [symbol,nazwa,kolumna,przelicznik,vat]- sownik artykuw
    # SArtKontrOddz [symbol_obcy,art] = [oddzial] - sownik z oddziaem dla artykuu i kontrahenta
    # LIgnorOddz    [Artykul]                                        - lista zawierajca artyku ignorowane ze wzgldu na zerow ilo i ich nieuywanie
    # SKontrOddzZam [symbol_obcy,oddzial,rzut] = [wyznacznik_zam,data_zam,numer_zam,faktyczny oddzia] - sownik z zamwieniem dla kontrahenta i oddziau
    # SArtRzut     [Rzut] = [symbol_obcy]                            - sownik symboli artykuw z jednego rzutu
    # SZmianyPlik  [kontrahent,symbol_obcy,rzut] = [ilosc]           - sownik zmian stworzony na podstawie pliku
    # SZamowieniaBledy [sklep,rzut,oddzialzam] = [oddzial,blad]      - sownik sklepw dla bdw zamwie (brak lub za duo)
    # SZmianyDowody [oddzial,tryb,kontrahent,symbol_obcy_art,rzut] = [ilosc] - sownik zmian do zrobienia w dowodach dostaw
    # SSklepyBD    [oddzial,rzut] = [symbol_obcy]                    - sownik sklepw dla oddziau z brakiem danych
    # SZmiany      [oddzial,sklep_obcy,artykul_obcy,rzut] = [ilosc pocz, ilosc koncowa]  - sownik zmian dla oddziau trafiajcych do maila 
    # LBledy       [bd]                                            - lista bdw krytycznych wystpujcych podczas analizy pliku
    # LDowodyBledy [Oddzial,Tryb,Kontrahent]                         - lista sklepw dla ktrych znaleziono wicej ni 1 dowd dostawy
    # SZamRzut     [wyznacznik_id,data,numer,rzut,sklep_obcy]=[art]  - sownik zmienianych zamwie z list zmienionych artykuw
    # SZmienionychDD [oddzial]=[symbol dowodu]                       - sownik z dowodami faktycznie zmienionymi do wysania na maila
    # LZmianyProd  [oddzial,artykul_obcy,ilo,rzut,oddzialekspedycji]
    #                                                                - lista o zmianach zamwie do oddziaw produkujcych
    # LBledyProd  [oddzial,blad]                                     - lista bdw do wysania mailem do oddziaw produkujcych
    # SProdMail   [oddzial,artykul_obcy]=ilosc
    # LZmienionychWgLimitu [kontrahent, artykul, il.orginalna, il.zmieniona] - lista ze zmianami ilosci wynikajacych z limitow

    #-------------------------------------------------------------------------------
    #-- SPRAWDZENIE POPRAWNOCI PARAMETRW
    #-------------------------------------------------------------------------------
    
    if Data == '    -  -  ':
        stat = 'Podano pust dat - import niemoliwy'
    elif not rsglobal.SprawdzCzyToData(Data):
        stat = 'Podano nieprawidow dat - import niemoliwy'
    elif Typ == '':
        stat = 'Podano pusty typ - import niemoliwy'
    else:
        SQL = "SELECT kod FROM rs_typy_zamowien WHERE firma_id='"+self.firma_id+"' AND kod='"+Typ+"';"
        stat, DTest, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania danych typu zamwie : '+stat
        elif len(DTest) == 0:
            stat = 'Brak podanego typu zamwienia : '+Typ

    if stat == 'OK':
        # sprawdzenie czy tabela rs_artykuly_zamowienia_oddzialy jest wypeniona w ramach firmy
        SQL = "SELECT * FROM rs_artykuly_zamowienia_oddzialy WHERE firma_id='"+self.firma_id+"' LIMIT 1"
        stat, DOddz, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = u'Bd pobierania danych z rs_artykuly_zamowienia_oddzialy:'+stat
        else:
            # zmienna czy sprawdza oddzia w rs_artykuly_zamowienia_oddzialy
            CzySprOddz = (len(DOddz) > 0)
            
    #-------------------------------------------------------------------------------
    #-- OBRBKA PLIKU
    #-------------------------------------------------------------------------------
    
    if stat == 'OK':
        TrescPliku = TrescPliku.decode('cp1250').splitlines()
    
        # w pierwszym wierszu oczekujemy tekstu "Iloci pieczywa do dostarczenia"
        if not TrescPliku[0].split('\t')[0] == u'Iloci pieczywa do dostarczenia':
            stat = 'Oczekiwano napisu "Iloci pieczywa do dostarczenia" w pierwszej komrce, a jest :'+TrescPliku[0].split('\t')[0]
    
    # szukamy wiersza z dat dostawy i porwnujemy z podan na okienku dat
    if stat == 'OK':
        i = 1
        CzyDataDostawy = False
        while not CzyDataDostawy:
            if len(TrescPliku) < i+1:
                stat = "Brak daty dostawy w pliku"
                CzyDataDostawy = True
            # sprawdzenie czy w wierszu jest napis "Data dostawy"
            wiersz = TrescPliku[i].split('\t')
            if wiersz[0] == 'Data dostawy':
                CzyDataDostawy = True
                DataPlik = wiersz[1][6:]+'-'+wiersz[1][3:5]+'-'+wiersz[1][0:2]
                if DataPlik != Data:
                    stat = "Data dostawy z okienka nie zgadza si z dat podan w pliku :"+DataPlik
            i += 1
            
    #pobranie listy wszystkich rzutow
    if stat == 'OK':
        SQL = "SELECT DISTINCT COALESCE(rzut,'') FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"';"
        stat, DRzuty, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bdy pobierania listy rzutw : '+stat
    
    if stat == 'OK':
        SPlatnicy        = {}
        SKontrahenci     = {}       
        SArtykuly        = {}
        SArtKontrOddz    = {}
        SKontrOddzZam    = {}
        LIgnorOddz       = {}
        SArtRzut         = {}
        SZmianyPlik      = {}
        SZamowieniaBledy = {}
        SSklepyBD        = {}
        SZmiany          = {}
        SZmianyDowody    = {}
        LBledy           = []
        SZmienionychDD   = {}
        LZmianyProd      = []
        LBledyProd       = []
        SProdMail        = {}
        LZmienionychWgLimitu = []
        SArtKorekty = {}
        Rzut = ''
        while not len(TrescPliku) < i+1 and stat == 'OK':
            wiersz = TrescPliku[i].split('\t')
        
            # idziemy dalej. Teraz szukamy wiersza z napisem "Dostawa" i pobieramy jej warto do Rzutu
            if wiersz[0] == "Dostawa":
                if len(wiersz) > 1:
                    Rzut = str(wiersz[1])
                    i += 1
                    continue
            
            # W kolejnym wierszu s numery obce artykuw.
            if Rzut != '' and SArtRzut == {}:
                j = 0
                SArtRzut[Rzut] = []
                for art in wiersz:
                    if art.strip() != '':
                        Art = rsglobal.Dekoduj(art)
                        # tu jest konkretny artyku obcy. zapisujemy go do listy. List uzupeniamy w oparciu o pierwszego kontrahenta
                        if Art not in SArtykuly:
                            SArtykuly[Art]=['', '', j, 1, '']
                        SArtRzut[Rzut].append(Art)
                    j += 1
                        
                i += 2
                continue
            
            # dwa wiersze dalej zaczynaj si sklepy. Kady z nich oddzielnie zapisujemy do odpowiedniej struktury
            if Rzut != '' and SArtRzut != {}:
                # po wystpieniu sowa "RAZEM" przerywamy pobieranie sklepw i czekamy na sowo "Dostawa"    
                if wiersz[0] == 'RAZEM':
                    Rzut = ''
                    SArtRzut = {}
                    i += 1
                    continue
                
                # normalna obrbka pozycji
                
                # zakadamy, e w pierwszej kolumnie jest nazwa obca kontrahenta. Pobieramy dane kontrahenta
                KontrObcy = wiersz[0]
                
                #jeli jest on na licie sklepw z bdnymi zamwieniami lub jest pusty to pomijamy pozycj
                if KontrObcy in SZamowieniaBledy or KontrObcy.strip() == '':
                    i += 1
                    continue

                if KontrObcy in SKontrahenci:
                    Kontr = SKontrahenci[KontrObcy][0]
                    Plat = SKontrahenci[KontrObcy][1]
                else:
                    SQL = "SELECT kontrahent_id,COALESCE(platnik_id,kontrahent_id),nazwa,TRIM(tel1||' '||tel2) FROM rs_kontrahenci "
                    SQL += " WHERE firma_id='"+self.firma_id+"' AND TRIM( LEADING '0' FROM symbol_obcy)= '"+KontrObcy+"' AND aktywny;"
                    stat, DKontr, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':
                        LBledy.append(str(i+1)+' Bd pobierania danych kontrahenta na podstawie symbolu obcego : '+stat)
                        stat = 'OK'
                        i += 1
                        continue
                    if len(DKontr) == 0:
                        LBledy.append(str(i+1)+' Brak kontrahenta szukanego na podstawie symbolu obcego : '+KontrObcy)
                        i += 1
                        continue
                    
                    if len(DKontr) > 1:
                        ListaKontr = ''
                        for poz in DKontr:
                            ListaKontr += rsglobal.Dekoduj(poz[0])+","
                        LBledy.append(str(i+1)+' Kontrahent o symbolu obcym '+KontrObcy.strip()+" wystpuje wicej ni raz: "+ListaKontr.strip(','))
                        i += 1
                        continue
                    
                    Kontr = rsglobal.Dekoduj(DKontr[0][0])
                    Plat = rsglobal.Dekoduj(DKontr[0][1])
                    SKontrahenci[KontrObcy] = [Kontr, Plat, DKontr[0][2], wiersz[1]+';'+wiersz[2], DKontr[0][3], [], []]
                    
                # pobranie danych do analizy patnika
                if not Plat in SPlatnicy:
                    # pobranie listy kontrahentw dotyczcych patnika
                    SQL = "SELECT kontrahent_id,nazwa,TRIM(tel1||' '||tel2) FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"'"
                    SQL += " AND platnik_id='"+Plat+"' AND NOT kontrahent_id = '"+Plat+"' AND aktywny"
                    stat, DPlat, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':    
                        LBledy.append(str(i+1)+' Bd pobierania danych kontrahentw dla patnika '+Plat+' do analizy : '+stat)
                        stat = 'OK'
                        i += 1
                        continue
                    else:
                        # dodanie patnika do sownika
                        SPlatnicy[Plat] = [DPlat, {}, {}]
                        
                        # dodanie listy oddziaw dla kontrahentw, potencjalnie niewystpujcych na 
                        for kontrpl in DPlat:
                            for rzutpl in DRzuty:
                                # sprawdzenie jakie oddziay powinny by uwzgldniane w mailach dla konkretnego kontrahenta
                                SQL = "SELECT DISTINCT zo.oddzial_id FROM rs_zamowienia_odbiorcy zo"
                                SQL += " INNER JOIN rs_zamowienia_odbiorcy_pozycje_stale zop USING (firma_id,wyznacznik_id,data,numer)"
                                SQL += " INNER JOIN rs_tryby_dostaw td ON (td.firma_id=zop.firma_id AND td.kod=zop.tryb_dostawy)"
                                SQL += " WHERE zo.firma_id='"+self.firma_id+"' AND zo.typ_zamowienia='"+Typ+"'"
                                SQL += " AND zo.kontrahent_id='"+kontrpl[0]+"' AND zo.czy_stale AND td.rzut='"+rzutpl[0]+"';"
                                rsglobal.ZapiszDoLogow('SQL oddz '+SQL, 1)
                                stat, DKontrOddz, dump, dump = self.PolSQL.Execute(SQL, 3)
                                rsglobal.ZapiszDoLogow('stat '+stat+' '+str(DKontrOddz), 1)
                                if stat != 'OK':    
                                    LBledy.append(str(i+1)+' Bd pobierania danych o odziaach dla kontrahenta '+kontrpl+' do analizy : '+stat)
                                    stat = 'OK'
                                    i += 1
                                    continue
                                else:
                                    rsglobal.ZapiszDoLogow('poszlo',1)
                                    if len(DKontrOddz) == 0:
                                        rsglobal.ZapiszDoLogow('poszlo2', 1)
                                        SPlatnicy[Plat][2][(kontrpl[0], rzutpl[0])] = ['**']
                                    else:
                                        LOddz = []
                                        for poz in DKontrOddz:
                                            LOddz.append(poz[0])
                                        rsglobal.ZapiszDoLogow('poszlo3 '+str(LOddz), 1)
                                        SPlatnicy[Plat][2][(kontrpl[0], rzutpl[0])] = LOddz

                
                
                # dodanie rzutu do sownika dla patnika
                if not Rzut in SPlatnicy[Plat][1]:
                    rsglobal.ZapiszDoLogow('dodanie rzutu '+Rzut+' do patnika '+Plat, 1)
                    SPlatnicy[Plat][1][Rzut] = []
                
                # dodanie kontrahenta do rzutu w sowniku dla patnika i rzutu
                if not Kontr in SPlatnicy[Plat][1][Rzut]:
                    SPlatnicy[Plat][1][Rzut].append(Kontr)
                
                # jeli nazwa losowego artykuu jest pusta to szukamy nazw artykuw wg patnika a potem wg Kontrahenta
                LArt = SArtRzut[Rzut]
                if SArtykuly[LArt[0]][0] == '':
                    SQL = "SELECT TRIM(LEADING '0' FROM ao.obcy_id),ao.artykul_id FROM rs_artykuly_obce ao "
                    SQL += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
                    SQL += " WHERE ao.firma_id='"+self.firma_id+"'"
                    SQL += " AND ao.kontrahent_id='"+Plat+"' AND TRIM(LEADING '0' FROM ao.obcy_id) IN ("+str(LArt)[1:-1]+")"
                    SQL += " AND a.aktywny AND NOT ao.artykul_id IS NULL AND NOT ao.artykul_id='';"
                    stat, DArt, dump, dump = self.PolSQL.Execute(SQL, 3)
                    if stat != 'OK':    
                        LBledy.append(str(i+1)+' Bd pobierania danych artykuw na podstawie symbolu obcego : '+stat)
                        stat = 'OK'
                        i += 1
                        continue
                
                    # uzupenienie symboli w SArtykuly na podstawie patnika
                    for poz in DArt:
                        if poz[0] in SArtykuly:
                            SArtykuly[poz[0]][0] = rsglobal.Dekoduj(poz[1])
                    
                    # jeli nie wszystko uzupenione oraz kontrahent rny od patnika
                    if len(LArt) > len(DArt) and Kontr != Plat:
                        SQL = "SELECT TRIM(LEADING '0' FROM ao.obcy_id),ao.artykul_id FROM rs_artykuly_obce ao "
                        SQL += " INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
                        SQL += " WHERE ao.firma_id='"+self.firma_id+"'"
                        SQL += " AND ao.kontrahent_id='"+Kontr+"' AND TRIM(LEADING '0' FROM ao.obcy_id) IN ("+str(LArt)[1:-1]+")"
                        SQL += " AND a.aktywny AND NOT ao.artykul_id IS NULL AND NOT ao.artykul_id='';"
                        stat, DArt, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':    
                            LBledy.append(str(i+1)+' Bd pobierania danych artykuw na podstawie symbolu obcego : '+stat)
                            stat = 'OK'
                            i += 1
                            continue
                    
                        # uzupenienie symboli w SArtykuly ma podstawie kontrahenta
                        for poz in DArt:
                            if poz[0] in SArtykuly:
                                SArtykuly[poz[0]][0] = rsglobal.Dekoduj(poz[1])
                
                
                # jeli tabela rs_artykuly_zamowienia_oddzialy nie jest uzupeniona to uzupeniamy SKontrOddzZam
                PrzerwacBoOddzial = False
                if not CzySprOddz:
                    SKontrOddzZam[(KontrObcy, '**', Rzut)] = ['', '', 0, '']
                    SArtKontrOddz['**'] = ''
                    
                # jeli tabela rs_artykuly_zamowienia_oddzialy jest uzupeniona to uzupeniamy SArtKontrOddz    
                else:
                    LIgnorOddz = []
                    for kl in SArtykuly:
                        Art = SArtykuly[kl][0]
                        Ilosc = wiersz[SArtykuly[kl][2]]
                        if Ilosc != 'b/d':
                            Ilosc = float(Ilosc.replace(',', '.'))
                            #JR 2022-12-01 (13263) sprawdzenie limitow
                            if Ilosc > 0:
                                SQL = "SELECT rsf_podaj_ilosc_zamowiona_po_korekcie('"+self.firma_id+ "',"
                                SQL += "'"+Art+"','"+Kontr+"',"+str(Ilosc)+",'"+Data+"');"
                                stat, DLimit, dump, dump = self.PolSQL.Execute(SQL, 3)
                                rsglobal.ZapiszDoLogow('DLimit' + str(DLimit), 1)
                                if stat != 'OK':
                                    LBledy.append(str(i+1)+u' Bd sprawdzania limitu dostaw dla kontrahenta '+Kontr+' i artykuu '+Art+': '+stat)
                                    stat = 'OK'
                                    PrzerwacBoOddzial = True
                                    continue
                                if Ilosc > DLimit[0][0]:  #JR
                                    LZmienionychWgLimitu.append([Art, Kontr, str(Ilosc), str(DLimit[0][0])])
                                    Ilosc = DLimit[0][0]
                                    SArtKorekty[Kontr, Art, Rzut] = Ilosc

                        OddzTmp = ''


                        # sprawdzamy, czy warto analizowa dane. Jeli Ilosc = 0 oraz nie ma artykuu na zamwieniach kontrahenta/patnika
                        # (lub maj same 0) to ignorujemy taki artyku
                        if Ilosc == 0:
                            rsglobal.ZapiszDoLogow('!!! sprawdzenie '+Art+' '+Kontr,1)
                            SQL = "SELECT artykul_id FROM rs_zamowienia_odbiorcy_pozycje_stale zop "
                            SQL += "INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer)"
                            SQL += " WHERE zop.firma_id= '"+self.firma_id+"' AND zop.artykul_id='"+Art+"' AND zo.kontrahent_id = '"+Kontr+"'"
                            SQL += " AND dz_00+dz_01+dz_02+dz_03+dz_04+dz_05+dz_06+dz_07 > 0"
                            stat, DTest, dump, dump = self.PolSQL.Execute(SQL, 3)
                            rsglobal.ZapiszDoLogow('DTest'+str(DTest), 1)
                            if stat != 'OK':
                                LBledy.append(str(i+1)+u' Bd sprawdzania pustoci danych dla kontrahenta '+Kontr+' i artykuu '+Art+': '+stat)
                                stat = 'OK'
                                PrzerwacBoOddzial = True
                                continue
                            
                            # nie ma danych dla szukanych parametrw wic artyku nie jest uywany. Nie pobieramy dla niego oddziau a potem nie wpisujemy go na list zmian
                            if len(DTest) == 0:
                                LIgnorOddz.append(Art)
                                continue
    
                        # sprawdzenie oddziau dla kontrahenta i artykuu
                        SQL = "SELECT oddzial_id FROM rs_artykuly_zamowienia_oddzialy "
                        SQL += " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND kontrahent_id='"+Kontr+"'"
                        stat, DOddz, dump, dump = self.PolSQL.Execute(SQL, 3)
                        if stat != 'OK':
                            LBledy.append(str(i+1)+u' Bd szukania oddziau dla kontrahenta '+Kontr+': '+stat)
                            stat = 'OK'
                            PrzerwacBoOddzial = True
                            continue
    
                        if stat == 'OK':
                            if len(DOddz) > 0:
                                OddzTmp = DOddz[0][0].strip()
                    
                        if stat == 'OK' and OddzTmp == '':
                            # sprawdzamy dla patnika
                            SQL = "SELECT oddzial_id FROM rs_artykuly_zamowienia_oddzialy "
                            SQL += " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND kontrahent_id='"+Plat+"'"
                            stat, DOddz, dump, dump = self.PolSQL.Execute(SQL, 3)
                            if stat != 'OK':
                                LBledy.append(str(i+1)+u' Bd szukania oddziau dla patnika '+Plat+': '+stat)
                                stat = 'OK'
                                PrzerwacBoOddzial = True
                                continue
                            
                            if stat == 'OK':
                                if len(DOddz)>0:
                                    OddzTmp = DOddz[0][0].strip()
            
                        if stat == 'OK':
                            # jeli oddzia znaleziony i b/d to ju tu zapisujemy w mailu jaki sklep nie wysa zamwienia
                            if OddzTmp != '':
                                if Ilosc == 'b/d':
                                    if not (OddzTmp,Rzut) in SSklepyBD:
                                        SSklepyBD[(OddzTmp, Rzut)]=[]
                                    if not KontrObcy in SSklepyBD[(OddzTmp,Rzut)]:
                                        SSklepyBD[(OddzTmp, Rzut)].append(KontrObcy)
                            
                            if OddzTmp == '':
                                if Ilosc == 'b/d':
                                    LIgnorOddz.append(Art)
                                else:
                                    LBledy.append(str(i+1)+' Nie znaleziono oddziau dla artykuu '+Art.strip()+' (obcego '+kl+') kontrahenta '+Kontr+' i patnika '+Plat)
                                PrzerwacBoOddzial = True
                                continue
                            
                        rsglobal.ZapiszDoLogow('111 '+str((KontrObcy, Art, OddzTmp)), 1)
                        SArtKontrOddz[(KontrObcy, Art)] = OddzTmp
                        rsglobal.ZapiszDoLogow('222 '+str((KontrObcy, OddzTmp, Rzut)), 1)
                        SKontrOddzZam[(KontrObcy,OddzTmp,Rzut)] = ['', '', 0, '']

                if PrzerwacBoOddzial:
                    rsglobal.ZapiszDoLogow('!!! Przerwa bo oddzia',1)
                    i = i+1
                    continue
                                           
                # uzupenienie numeru zamwienia sklepu oraz jego oddziau
                # zamwienie powinno by dokadnie jedno. Jeli go nie ma to wysyamy potem maila 
                # do wszystkich potencjalnych adresatw. Jeli s dwa lub wicej to wysyamy do odpowiednich oddziaw.
                # uwzgldniany jest rzut z pozycji i oddziay z artykuw (jeli s).
                
                PrzerwacBoZamowienie = False
                rsglobal.ZapiszDoLogow('SKontrOddzZam '+str(SKontrOddzZam),1)
                rsglobal.ZapiszDoLogow('LIgnorOddz '+str(LIgnorOddz),1)
                for kl in SKontrOddzZam:
                    if kl[0] == KontrObcy:
                        rsglobal.ZapiszDoLogow('333 '+str((kl, SKontrOddzZam[kl])),1)
                        OddzTmp = kl[1]
                          
                        SQL = "SELECT DISTINCT zo.wyznacznik_id,zo.data,zo.numer,zo.oddzial_id FROM rs_zamowienia_odbiorcy zo"
                        SQL += " INNER JOIN rs_zamowienia_odbiorcy_pozycje_stale zop USING (firma_id,wyznacznik_id,data,numer)"
                        SQL += " INNER JOIN rs_tryby_dostaw td ON (td.firma_id=zop.firma_id AND td.kod=zop.tryb_dostawy)"
                        SQL += " WHERE zo.firma_id='"+self.firma_id+"' AND zo.typ_zamowienia='"+Typ+"'"
                        SQL += " AND zo.kontrahent_id='"+Kontr+"' AND zo.czy_stale AND td.rzut='"+Rzut+"'"
                        if OddzTmp != '**':
                            SQL += " AND zo.oddzial_id= '"+OddzTmp+"'"
                        rsglobal.ZapiszDoLogow('SQLZAM '+SQL, 1)
                        stat,DZam,dump,dump = self.PolSQL.Execute(SQL, 3)
                        rsglobal.ZapiszDoLogow('stat '+stat, 1)
                        rsglobal.ZapiszDoLogow('DZam '+str(DZam), 1)
                        if stat != 'OK':    
                            LBledy.append(str(i+1)+' Bd pobierania danych zamwie na podstawie symbolu obcego kontrahenta : '+stat)
                            stat = 'OK'
                            PrzerwacBoZamowienie = True
                            continue
                    
                        if len(DZam) == 0:
                            SZamowieniaBledy[(KontrObcy,Rzut,OddzTmp)] = [('**',"Brak zamwienia staego dla typu "+Typ+", kontrahenta,  rzutu "+Rzut+" i oddziau "+OddzTmp)]
                            PrzerwacBoZamowienie = True
                            continue
                    
                        if len(DZam) > 1:
                            SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)] = []
                            for poz in DZam:
                                if not (poz[3],'Wicej ni jedno zamwienie dla kontrahenta i rzutu') in SZamowieniaBledy[(KontrObcy,Rzut,OddzTmp)]:
                                    SZamowieniaBledy[(KontrObcy,Rzut,OddzTmp)].append((poz[3],'Wicej ni jedno zamwienie dla kontrahenta, rzutu '+Rzut+' i oddziau '+OddzTmp))
                    
                                SKontrahenci[KontrObcy][5].append(poz[0:3]+[Rzut])
                                SKontrahenci[KontrObcy][6].append(poz[3])
                    
                            PrzerwacBoZamowienie = True
                            continue
                    
                        # to si wykonuje gdy jest dokadnie jedno zamwienie dla oddziau
                        SKontrOddzZam[kl] = DZam[0][0:3]+[DZam[0][3]]
                        SKontrahenci[KontrObcy][5].append(DZam[0][0:3]+[Rzut])
                        SKontrahenci[KontrObcy][6].append(rsglobal.Dekoduj(DZam[0][3]))
                        if not CzySprOddz:
                            SArtKontrOddz['**'] = DZam[0][3]

                
                if PrzerwacBoZamowienie:
                    rsglobal.ZapiszDoLogow('!!! Przerwa bo zamwienie',1)
                    i += 1
                    continue

                # uzupenienie listy zmian do zrobienia na podstawie pliku
                for art in LArt:
                    # jeli nazwa artykuu pusta to znaczy e nie znaleziony lub artyku ''. Zgaszamy jako bd
                    if SArtykuly[art][0] == '':
                        blad=' Artyku o symbolu obcym '+art+' nie zosta znaleziony.'
                        if not blad in LBledy:
                            LBledy.append(blad)
                    
                    elif wiersz[SArtykuly[art][2]] == 'b/d':
                        # jeli b/d to trafia na list niezgoszonych sklepw
                        if not (SKontrahenci[KontrObcy][6][0], Rzut) in SSklepyBD:
                            SSklepyBD[(SKontrahenci[KontrObcy][6][0], Rzut)]=[]
                        if not KontrObcy in SSklepyBD[(SKontrahenci[KontrObcy][6][0], Rzut)]:
                            SSklepyBD[(SKontrahenci[KontrObcy][6][0], Rzut)].append(KontrObcy)
                    else:
                        # zakadamy, e bdziemy to zmienia
                        # ignorujemy artykuy niepobierane (Z LIgnorOddz)
                        # uzwgledniamy ewnetualne korekty
                        rsglobal.ZapiszDoLogow('Sprawdzenie '+art+' '+SArtykuly[art][0], 1)
                        if not SArtykuly[art][0] in LIgnorOddz:
                            rsglobal.ZapiszDoLogow('SArtKorekty :'+str(SArtKorekty))
                            rsglobal.ZapiszDoLogow('Kontr, art, KontrObcy : |{}| |{}| |{}|'.format(Kontr, art, KontrObcy))

                            #JR
                            if SArtKorekty.has_key((Kontr,SArtykuly[art][0], Rzut)):   #JR 2022-12-12 (13263)
                                SZmianyPlik[KontrObcy, art, Rzut] = [SArtKorekty[Kontr, SArtykuly[art][0], Rzut]]
                            else:
                                SZmianyPlik[KontrObcy, art, Rzut] = [float(wiersz[SArtykuly[art][2]].replace(',', '.'))]
                i += 1
            # pozostae typy wierszy - te nieobsugiwane (np. puste)
            else:
                i += 1
                
    
    #---------------------------------------------------------------------------
    #-- OBRBKA DANYCH
    #---------------------------------------------------------------------------
    rsglobal.ZapiszDoLogow('!!! ',1)
    if stat == 'OK':    #JR 11625 2019-08-31
        rsglobal.ZapiszDoLogow('SKontrOddzZam ' + str(SKontrOddzZam), 5)
        rsglobal.ZapiszDoLogow('SZmianyPlik ' + str(SZmianyPlik), 5)
        rsglobal.ZapiszDoLogow('SArtKontrOddz ' + str(SArtKontrOddz), 5)
        rsglobal.ZapiszDoLogow('SZamowieniaBledy ' + str(SZamowieniaBledy), 5)
        rsglobal.ZapiszDoLogow('LIgnorOddz ' + str(LIgnorOddz), 5)
        rsglobal.ZapiszDoLogow('SArtKorekty ' + str(SArtKorekty), 5)
        rsglobal.ZapiszDoLogow('SArtykuly ' + str(SArtykuly), 5)
        #rsglobal.ZapiszDoLogow('LArt ' + str(LArt), 5)
    else:
        rsglobal.ZapiszDoLogow('stat :szmianyplik' + str(stat), 5)

    if stat == 'OK':
        # pobranie nazwy pola (nr dnia) z ktrego bd pobierane i zmieniane dane
        Dzien = datetime.date(int(Data[0:4]),int(Data[5:7]),int(Data[8:])).weekday()+2
        if Dzien == 8:
            Dzien = 1
        PoleNrDnia = 'dz_0'+str(Dzien)
        
        # analizujemy kolejne pozycje do zmiany
        SQLZmiany = ''
        SZamRzut = {}
        for poz in SZmianyPlik:
            KontrObcy = poz[0]
            Art = poz[1]
            Rzut = poz[2]
            # wybieramy oddzia na podstawie kontrahenta i artykuu
            if not CzySprOddz:
                OddzTmp = SArtKontrOddz['**']
                WyznZ, DataZ, NrZ, OddzZ = SKontrOddzZam[KontrObcy, '**', Rzut]
            else:
                rsglobal.ZapiszDoLogow('Przed bladem '+Art,1)
                OddzTmp = SArtKontrOddz[(KontrObcy,SArtykuly[Art][0])]
                WyznZ, DataZ, NrZ, OddzZ = SKontrOddzZam[KontrObcy,OddzTmp,Rzut]
            
            # pobieramy zamwienie dla oddziau i kontrahenta i artykuu
            # to zamwienie bdziemy zmienia wic dodajemy je do listy
            if not (WyznZ, DataZ, NrZ, poz[2], poz[0]) in SZamRzut:
                SZamRzut[(WyznZ, DataZ, NrZ, poz[2], poz[0])] = []
            # zaznaczamy e na tym zamwieniu obrobilismy dany artyku
            SZamRzut[(WyznZ, DataZ, NrZ, poz[2], poz[0])].append(SArtykuly[poz[1]][0])

            # pobieramy sprawdzamy, czy na dzie tygodnia dla rzutu jest na zamwieniu dokadnie jeden tryb (lub jeden niezerowy). 
            # jeli nie to wysyamy komunikat. Jeli tak to go wykorzystujemy przy insertach/update'ach
            SQL = "SELECT SUM(zop."+PoleNrDnia+"),zop.tryb_dostawy FROM rs_zamowienia_odbiorcy_pozycje_stale zop"
            SQL += " INNER JOIN rs_tryby_dostaw td ON (zop.firma_id=td.firma_id AND zop.tryb_dostawy=td.kod)"
            SQL += " WHERE zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id='"+WyznZ+"' AND zop.data='"+DataZ+"'"
            SQL += " AND zop.numer="+str(NrZ)+" AND td.rzut='"+Rzut+"' GROUP BY zop.tryb_dostawy;"
            stat, DZamTryb, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':    
                LBledy.append('Bd pobierania danych pozycji zamwie do analizy trybw : '+stat)
                rsglobal.ZapiszDoLogow('blad 0', 1)
                continue
       
            TrybZam = ''
            if len(DZamTryb) == 1:
                TrybZam = rsglobal.Dekoduj(DZamTryb[0][1])
            else:
                for poztryb in DZamTryb:
                    if poztryb[0] > 0:
                        TrybZam += rsglobal.Dekoduj(poztryb[1])+","

                TrybZam = TrybZam.strip(',')
                # s co najmniej dwa niezerowe tryby dla rzutu w dniu na zamwieniu, rozdzielone przecinkiem
                if ',' in TrybZam:
                    buf = 'Zamwienie '+WyznZ+'/'+DataZ+'/'+str(NrZ)+' dla artykuu '+SArtykuly[poz[1]][0]+' ma wicej ni jeden tryb ('+TrybZam+') dla rzutu '+poz[2]
                    if not (KontrObcy, Rzut, OddzTmp) in SZamowieniaBledy:
                        SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)] = []
                    SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)].append((OddzZ, buf))
                    continue
                
                if TrybZam == '':
                    buf = 'Zamwienie '+WyznZ+'/'+DataZ+'/'+str(NrZ)+' dla artykuu '+SArtykuly[poz[1]][0]+' nie ma ani jednego trybu niezerowego dla rzutu '+poz[2]
                    if not (KontrObcy, Rzut, OddzTmp) in SZamowieniaBledy:
                        SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)]=[]
                    SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)].append((OddzZ,buf))
                    continue
            
            # pobranie pozycji z zamwienia z odpowiednimi parametrami
            SQL = "SELECT zop."+PoleNrDnia+",zop.tryb_dostawy FROM rs_zamowienia_odbiorcy_pozycje_stale zop"
            SQL += " WHERE zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id='"+WyznZ+"' AND zop.data='"+DataZ+"'"
            SQL += " AND zop.numer="+str(NrZ)+" AND zop.artykul_id='"+rsglobal.Dekoduj(SArtykuly[poz[1]][0])+"'"
            SQL += " AND zop.tryb_dostawy='"+TrybZam+"';"
            stat, DZamPoz, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':    
                LBledy.append('Bd pobierania danych pozycji zamwie do zmiany : '+stat)
                rsglobal.ZapiszDoLogow('blad 1', 1)
                continue
            
            # jeli s dwie takie pozycje to info i ignorujemy pozycj
            if len(DZamPoz) > 1:
                buf = 'Zamwienie '+WyznZ+'/'+DataZ+'/'+str(NrZ)+' dla artykuu '+SArtykuly[poz[1]][0]+' ma wicej ni jedn pozycj dla rzutu '+poz[2]
                if not (KontrObcy, Rzut, OddzTmp) in SZamowieniaBledy:
                    SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)]=[]
                SZamowieniaBledy[(KontrObcy, Rzut, OddzTmp)].append((OddzZ, buf))
                continue
        
            # jeli jej nie ma to dodajemy do zamwienia oraz dodajemy do listy ze zmianami
            elif len(DZamPoz) == 0:
                if SZmianyPlik[poz][0] > 0:
                    SQLZmiany += "INSERT INTO rs_zamowienia_odbiorcy_pozycje_stale"
                    SQLZmiany += " (firma_id,wyznacznik_id,data,numer,data_od,tryb_dostawy,artykul_id,"+PoleNrDnia+",data_do)"
                    SQLZmiany += " VALUES ('"+self.firma_id+"','"+WyznZ+"','"+DataZ+"',"+str(NrZ)+",'"+Data+"','"+TrybZam+"',"
                    SQLZmiany += "'"+SArtykuly[poz[1]][0]+"',"+str(SZmianyPlik[poz][0])+","
                    SQLZmiany += " rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+SArtykuly[poz[1]][0]+"',"
                    SQLZmiany += " (SELECT COALESCE(kontrahent_id,'') FROM rs_zamowienia_odbiorcy WHERE "
                    SQLZmiany += " firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznZ+"' AND data='"+DataZ+"' AND numer="+str(NrZ)+"),"
                    SQLZmiany += " (SELECT COALESCE(platnik_id,'') FROM rs_zamowienia_odbiorcy WHERE "
                    SQLZmiany += " firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznZ+"' AND data='"+DataZ+"' AND numer="+str(NrZ)+"),NULL));"
                    rsglobal.ZapiszDoLogow(' INSERT '+str(SQLZmiany.split(';')[-2]), 1)
                    SZmiany[OddzZ, KontrObcy, poz[1], Rzut] = [0, SZmianyPlik[poz][0]]
                    # zmiana ktra trafia na dowody dostaw
                    SZmianyDowody[OddzZ, TrybZam, KontrObcy, poz[1], Rzut] = [SZmianyPlik[poz][0]]
                continue
            
            # dokadnie 1 pozycja do update
            else:
                if SZmianyPlik[poz][0] != DZamPoz[0][0]:
                    SQLZmiany += "UPDATE rs_zamowienia_odbiorcy_pozycje_stale SET "+PoleNrDnia+"="+str(SZmianyPlik[poz][0])
                    SQLZmiany += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznZ+"' AND data='"+DataZ+"'"
                    SQLZmiany += " AND numer="+str(NrZ)+" AND artykul_id='"+rsglobal.Dekoduj(SArtykuly[poz[1]][0])+"'"
                    SQLZmiany += " AND tryb_dostawy='"+DZamPoz[0][1]+"';"
                    rsglobal.ZapiszDoLogow(' UPDATE '+str(SQLZmiany.split(';')[-2]), 1)
                    # sprawdzamy czy rnica jest wiksza ni o 50% i jeli tak to dodajemy do listy.
                    if SZmianyPlik[poz][0] == 0 or DZamPoz[0][0] == 0:
                        if SZmianyPlik[poz][0] != 0 or DZamPoz[0][0] != 0:
                            #rsglobal.ZapiszDoLogow(' SZmiany2 '+str([SKontrahenci[KontrObcy][6][0],KontrObcy,poz[1],poz[2]]),1)
                            SZmiany[OddzZ, KontrObcy, poz[1], poz[2]] = [DZamPoz[0][0], SZmianyPlik[poz][0]]
                    elif SZmianyPlik[poz][0]/DZamPoz[0][0] > 1.5 or SZmianyPlik[poz][0]/DZamPoz[0][0] < 0.5:
                        #rsglobal.ZapiszDoLogow(' SZmiany3 '+str([SKontrahenci[KontrObcy][6][0],KontrObcy,poz[1],poz[2]]),1)
                        SZmiany[OddzZ, KontrObcy, poz[1], poz[2]] = [DZamPoz[0][0], SZmianyPlik[poz][0]]
                    # zmiana ktra trafia na dowody dostaw
                    SZmianyDowody[OddzZ, DZamPoz[0][1], KontrObcy, poz[1], Rzut] = [SZmianyPlik[poz][0]]
        
        # wyszlismy ju z ptli wszystkich zmian. Dodatkowo sprawdzamy, 
        # ktre pozycje nie byy zmienione i te zerujemy. Zakadamy e przestali je zamawia.
        # info o tym wysyamy mailem
        
        for zam in SZamRzut:
            SQL = "SELECT zop."+PoleNrDnia+",zop.tryb_dostawy,zop.artykul_id,zop.data_od,a.nazwa FROM rs_zamowienia_odbiorcy_pozycje_stale zop"
            SQL += " INNER JOIN rs_tryby_dostaw td ON (zop.firma_id=td.firma_id AND zop.tryb_dostawy=td.kod)"
            SQL += " INNER JOIN rs_artykuly a ON (zop.firma_id=a.firma_id AND zop.artykul_id=a.artykul_id)"
            SQL += " WHERE zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id='"+zam[0]+"' AND zop.data='"+zam[1]+"'"
            SQL += " AND zop.numer="+str(zam[2])+" AND td.rzut='"+str(zam[3])+"' AND "+PoleNrDnia+">0 "
            SQL += " AND NOT zop.artykul_id IN ("
            for art in SZamRzut[zam]:
                SQL += "'"+art+"',"
            SQL = SQL.strip(',')+");"
            stat, DZamPoz, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':    
                LBledy.append('Bd pobierania danych pozycji zamwie do redukcji : '+stat)
                continue
        
            for poz in DZamPoz:
                KontrObcy = zam[4]
                SQLZmiany += "UPDATE rs_zamowienia_odbiorcy_pozycje_stale SET "+PoleNrDnia+"=0"
                SQLZmiany += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+zam[0]+"' AND data='"+zam[1]+"'"
                SQLZmiany += " AND numer="+str(zam[2])+" AND artykul_id='"+rsglobal.Dekoduj(poz[2])+"'"
                SQLZmiany += " AND tryb_dostawy='"+rsglobal.Dekoduj(poz[1])+"' AND data_od='"+rsglobal.Dekoduj(poz[3])+"';"
                # wstawienie artykuu do listy na maila
                Art = rsglobal.Dekoduj(poz[2])
                SZmiany[OddzZ, KontrObcy, Art, zam[3]] = [poz[0], 0]
                SArtykuly[Art]=[Art, '', -1, 1, '']
                # zmiana ktra trafia na dowody dostaw - pozycje do usunicia
                SZmianyDowody[OddzZ, poz[1], KontrObcy, rsglobal.Dekoduj(poz[2]), zam[3]] = [0]
                
        ZmianyRozbite = SQLZmiany.split(";")
        for SQL in ZmianyRozbite:
            if stat == 'OK':
                rsglobal.ZapiszDoLogow("SQL "+SQL, 1)
                if SQL != '':
                    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1)
                    if stat != 'OK':    
                        stat = 'Bd wprowadzenia zmian pozycji zamwie : '+stat
    
    if stat == 'OK':
        # uzupenienie sownika artykuw o nazwy i przeliczniki - potrzebne do maili i innych rzeczy
        for klucz in SArtykuly:
            if stat == 'OK':
                Art = SArtykuly[klucz][0]
                SQL = "SELECT nazwa, przelicznik,rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"') FROM rs_artykuly "
                SQL += "WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
                stat, DArt, dump, dump = self.PolSQL.Execute(SQL, 3)
                if stat != 'OK':    
                    stat = "Bd pobrania danych artykuu "+Art+" : "+stat
                else:
                    if len(DArt) == 0:
                        stat = 'Brak danych artykuu '+Art
            if stat == 'OK':
                SArtykuly[klucz][1] = DArt[0][0]
                SArtykuly[klucz][3] = DArt[0][1]
                SArtykuly[klucz][4] = DArt[0][2]
            
    #---------------------------------------------------------------------------
    #-- ZMIANA WARTOCI NA DOWODACH DOSTAW
    #---------------------------------------------------------------------------
    
    if stat == 'OK':
        LDowodyBledy = []
        # faktyczna obrbka kolejnych zmian 
        for klucz in SZmianyDowody:
            if stat == 'OK':
                Ilosc = SZmianyDowody[klucz][0]
                rsglobal.ZapiszDoLogow('Zm dowody '+str(klucz)+' '+str(Ilosc), 1)
                OddzialDD = rsglobal.Dekoduj(klucz[0])
                TrybDD = rsglobal.Dekoduj(klucz[1])
                KontrDD = rsglobal.Dekoduj(SKontrahenci[klucz[2]][0])
                ArtDD = rsglobal.Dekoduj(SArtykuly[klucz[3]][0])
                Przel = SArtykuly[klucz[3]][3]
                VAT = rsglobal.Dekoduj(SArtykuly[klucz[3]][4])
                IloscPrzel = rsglobal.RSRound(Ilosc*Przel,3)
                Rzut = klucz[4]
                #szukamy dowodu, ktry pasuje do klucza
                SQL = "SELECT trasa,numer,stan FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' "
                SQL += " AND oddzial_id='"+OddzialDD+"' AND data='"+Data+"' AND tryb_dostawy='"+TrybDD+"' "
                SQL += " AND kontrahent_id='"+KontrDD+"' AND stan IN ('0','1') AND NOT korekta;"
                rsglobal.ZapiszDoLogow('SQL szukaj dowod '+SQL,1)
                stat,DDowDost,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':    
                    stat='Bd pobrania nagwkw dowodw dostaw : '+stat
                
            if stat == 'OK':
                # nie ma dowdu dostawy to ignorujemy zmian
                if len(DDowDost)==0:
                    continue
                # jeli znaleziono wicej ni 1 dowd to zgaszamy mailem.
                elif len(DDowDost)>1:
                    if not (OddzialDD,TrybDD,KontrDD) in LDowodyBledy:
                        LDowodyBledy.append((OddzialDD,TrybDD,KontrDD))
                    continue    
                
                TrasaDD=rsglobal.Dekoduj(DDowDost[0][0])
                NumerDD=str(DDowDost[0][1])
                StanDD=DDowDost[0][2]
                
                FiltrDD=" firma_id='"+self.firma_id+"' AND oddzial_id='"+OddzialDD+"'"
                FiltrDD+=" AND trasa='"+TrasaDD+"' AND data='"+Data+"' AND tryb_dostawy='"+TrybDD+"'"
                FiltrDD+=" AND numer="+NumerDD+" "
                SymbolDD=OddzialDD+"/"+TrasaDD+"/"+Data+"/"+TrybDD+"/"+NumerDD

                # pobranie oddziau do ktrego ma i mail w sprawie zmiany na dowodzie dostawy
                # Informacje o tym ,e zmieniono dowd dostawy na maila
                # jest to oddzia ekspedycji tego dnia i suy te do wyliczenia oddziau produkcji 
                # podczas modyfikacji sum zamwie
                OddzialInfo=OddzialDD
                # sprawdzamy czy tego dnia jaki inny oddzia nie ma dyuru w zastpstwie
                SQL="SELECT rsf_podaj_oddzial_ekspedycji('"+self.firma_id+"','"+OddzialDD+"','"+TrasaDD+"',"
                SQL+="'"+Data+"','"+TrybDD+"');"
                stat,DOddzInfo,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':    
                    stat='Bd pobrania oddziau z rs_boksy_trasy_dni : '+stat
                if stat=='OK':
                    if len(DOddzInfo)>0:
                        if DOddzInfo[0][0]<>'':
                            OddzialInfo=rsglobal.Dekoduj(DOddzInfo[0][0])


                # szukamy pozycji dowodu dostawy do zmiany/usunicia
                SQL="SELECT nr_poz,ilosc_zam1,ilosc_pobr1 FROM rs_dowody_dostaw_pozycje "
                SQL+=" WHERE "+FiltrDD+" AND artykul_id='"+ArtDD+"';"
                stat,DDowPoz,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':    
                    stat='Bd pobrania pozycji dowodu dostawy : '+stat
                
            if stat=='OK':
                # jeli nie ma pozycji i zamwienie > 0 to robimy insert
                if len(DDowPoz)==0 and Ilosc>0:
                    # pobranie numeru pozycji
                    SQL="SELECT COALESCE(MAX(nr_poz)+1,1) FROM rs_dowody_dostaw_pozycje "
                    SQL+=" WHERE "+FiltrDD
                    stat,DPozMax,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat != 'OK':    
                        stat='Bd pobrania maksymalnego numeru pozycji dowodu dostawy : '+stat
                    else:
                        NrPoz=str(DPozMax[0][0])

                    if stat=='OK':
                        # pobranie cen artykuu dla kontrahenta
                        SQL = "SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"','"+KontrDD+"','PLN','"+Data+"','"+ArtDD+"','',-1);"
                        stat,DCeny,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat!= 'OK':
                            stat='Bdy pobierania cen dla kontrahenta '+stat
                    if stat=='OK':
                        LCeny=rsglobal.rseval(rsglobal.Dekoduj(DCeny[0][0]))
                        # jeli ceny zerowe to dodajemy do bdw i przerywamy analiz tej pozycji
                        if LCeny[7]==0:
                            blad=(OddzialDD,'Brak cen dla artykuu '+ArtDD.strip()+' i kontrahenta '+KontrDD)
                            if not blad in LDowodyBledy:
                                LDowodyBledy.append(blad)
                            if not blad[1] in LBledy:
                                LBledy.append(blad[1])
                            continue
                        
                        # Insert waciwy
                        SQL="INSERT INTO rs_dowody_dostaw_pozycje (firma_id,oddzial_id,trasa,data,tryb_dostawy,"
                        SQL+="numer,nr_poz,artykul_id,ilosc_zam1,ilosc_zam2,ilosc_pobr1,ilosc_pobr2,"
                        SQL+="ilosc_dost1,ilosc_dost2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
                        SQL+="cena_brutto1,cena_brutto2,stawka_vat) VALUES"
                        SQL+="('"+self.firma_id+"','"+OddzialDD+"','"+TrasaDD+"','"+Data+"','"+TrybDD+"',"
                        SQL+=NumerDD+","+NrPoz+",'"+ArtDD+"',"+str(Ilosc)+","+str(IloscPrzel)+","+str(Ilosc)+","+str(IloscPrzel)+","
                        SQL+=""+str(Ilosc)+","+str(IloscPrzel)+","+str(LCeny[0])+","+str(LCeny[1])+","
                        SQL+=str(LCeny[4])+","+str(LCeny[5])+","+str(LCeny[6])+","+str(LCeny[7])+",'"+VAT+"');"
                        rsglobal.ZapiszDoLogow("INSERT SQL "+SQL,1)
                        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                        if stat != 'OK':    
                            stat='Bd wstawiania pozycji dowodu dostawy : '+stat
                        LZmianyProd.append([OddzialDD,klucz[3],Ilosc,Rzut,OddzialInfo,''])

                # jeli pozycja jest i zamwienie = 0 to usuwamy pozycj i przenumerowujemy pozycje dowodu
                elif len(DDowPoz)>0 and Ilosc==0:
                    # usunicie pozycji
                    SQL="DELETE FROM rs_dowody_dostaw_pozycje WHERE "+FiltrDD
                    SQL+=" AND nr_poz="+str(DDowPoz[0][0])+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                    if stat != 'OK':    
                        stat='Bd usuwania pozycji dowodu dostawy : '+stat
                        
                    if stat=='OK':
                        # wstawienie rnicy z pozycji na 0 do sum zamwie
                        LZmianyProd.append([OddzialDD,klucz[3],-1*DDowPoz[0][1],Rzut,OddzialInfo,''])
                        
                        # przenumerowanie pozycji
                        stat=rsglobal.PrzenumerujPozycje(self.PolSQL,'rs_dowody_dostaw_pozycje',FiltrDD,DDowPoz[0][0])
                # jeli pozycja jest i zamwienie > 0 to jeli rne iloci to robimy update
                elif len(DDowPoz)>0 and Ilosc>0:
                    if Ilosc!=DDowPoz[0][1]:
                        SQL="UPDATE rs_dowody_dostaw_pozycje SET ilosc_zam1="+str(Ilosc)+",ilosc_zam2="+str(IloscPrzel)
                        # jeli pobrane rwne zamwione to te zmieniamy
                        if DDowPoz[0][1]==DDowPoz[0][2]:
                            SQL+=",ilosc_pobr1="+str(Ilosc)+",ilosc_pobr2="+str(IloscPrzel)
                        if StanDD=='0':
                            SQL+=",ilosc_dost1="+str(Ilosc)+",ilosc_dost2="+str(IloscPrzel)
                        SQL+=" WHERE "+FiltrDD+" AND nr_poz="+str(DDowPoz[0][0])
                        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                        if stat != 'OK':    
                            stat='Bd zmiany pozycji dowodu dostawy : '+stat
                        
                        # wstawienie rnicy z pozycji na dane z pliku do sum zamwie
                        LZmianyProd.append([OddzialDD,klucz[3],Ilosc-DDowPoz[0][1],Rzut,OddzialInfo,''])
                        
            if stat=='OK':
                # zmieniamy nagowek dowodu dostawy
                SQL="UPDATE rs_dowody_dostaw SET czy_zmodyfikowany=TRUE WHERE "+FiltrDD
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat != 'OK':    
                    stat='Bd zaznaczenia modyfikacji dowodu dostawy : '+stat

                # zapis do maila zmienionych dowodw dostaw
                if not OddzialInfo in SZmienionychDD:
                    SZmienionychDD[OddzialInfo]=[]
                if not SymbolDD in SZmienionychDD[OddzialInfo]:
                    SZmienionychDD[OddzialInfo].append(SymbolDD)
                    
    #---------------------------------------------------------------------------
    #-- ZMIANA WARTOCI NA SUMACH ZAMWIE
    #---------------------------------------------------------------------------
    
    # Dla zmienionych dowodw dostaw sprawdzamy czy s wystawione sumy zamwie.
    # jeli tak to zmieniamy, jeli nie to nie zmieniamy. Sprawdzamy dla kadego oddziau osobno.
    
    if stat=='OK':
        # sprawdzamy list oddziaw dla ktrych s dane w sumach zamwie
        SQL="SELECT DISTINCT oddzial_zam FROM rs_produkcja_sumy WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"';"
        
        stat,DOddzZZamowieniami,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':    
            stat='Bd pobrania oddziaw z rs_produkcja_sumy : '+stat
        
        
    if stat=='OK':    
        LZmianyProd.sort()
        for zmiana in LZmianyProd:
            if stat=='OK':
                # sprawdzamy czy dla oddziau s sumy zamwie
                if not [zmiana[0]] in DOddzZZamowieniami:
                    continue
                
                Oddzial=zmiana[0]
                Art=rsglobal.Dekoduj(SArtykuly[zmiana[1]][0])
                ArtNazwa=rsglobal.Dekoduj(SArtykuly[zmiana[1]][1])
                Ilosc=zmiana[2]
                Przel=SArtykuly[zmiana[1]][3]
                IloscPrzel=rsglobal.RSRound(Ilosc*Przel,3)
                Rzut=zmiana[3]
                
                # pobranie Oddziau produkujcego (pocztkowo rwny ekspedycyjnemu).
                OddzialProd=zmiana[4]
                SQL="SELECT rsf_podaj_oddzial_producenta('"+self.firma_id+"','"+zmiana[4]+"',"
                SQL+="'"+Art+"','"+Data+"','"+Rzut+"');"
                stat,DOddzProd,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':    
                    stat='Bd pobrania oddziau produkujcego z rs_artykuly_producenci : '+stat
            if stat=='OK':
                if len(DOddzProd)>0:
                    if DOddzProd[0][0]<>'':
                        OddzialProd=rsglobal.Dekoduj(DOddzProd[0][0])
                                
                # sprawdzamy czy artyku wystpuje na pozycjach
                SQL="SELECT zamowione1,oddzial_prod,czas_wprowadzenia FROM rs_produkcja_sumy "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
                SQL+=" AND oddzial_zam='"+Oddzial+"' AND zmiana='"+Rzut+"' AND artykul_id='"+Art+"' AND typ_odbiorcy IS NULL;"
                stat,DPozSum,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat != 'OK':    
                    stat='Bd pobrania pozycji z rs_produkcja_sumy : '+stat
                
            if stat=='OK':
                rsglobal.ZapiszDoLogow('Pozycja i ilosc '+str(len(DPozSum))+' '+str(Ilosc),1)
                # jeli artyku nie wystpuje na pozycjach i warto dodatnia to dodajemy zamwienie
                if len(DPozSum)==0:
                    if Ilosc>0:
                        SQL="INSERT INTO rs_produkcja_sumy (firma_id,data,oddzial_zam,oddzial_prod,"
                        SQL+="zmiana,artykul_id,zamowione1,zamowione2,czas_wprowadzenia) VALUES "
                        SQL+="('"+self.firma_id+"','"+Data+"','"+Oddzial+"','"+OddzialProd+"',"
                        SQL+="'"+Rzut+"','"+Art+"',"+str(Ilosc)+","+str(IloscPrzel)+",NOW())"
                        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                        rsglobal.ZapiszDoLogow("INS SQL "+SQL,1)
                        if stat != 'OK':    
                            stat='Bd wstawienia pozycji do rs_produkcja_sumy : '+stat
                        else:
                            kl=(OddzialProd,zmiana[1])
                            if not kl in SProdMail:
                                SProdMail[kl]=0
                            SProdMail[kl]+=Ilosc
                    continue
                
                # jeli artyku wystpuje na pozycjach 
                # jeli zmniejszenie przekracza ilo na pozycji to info do maila
                if Ilosc<0 and DPozSum[0][0]+Ilosc<0:
                    Buf='Nie mona zmniejszy pozycji sum zamwienia oddziau '+Oddzial+' i rzutu '+Rzut
                    Buf+=' dla artykuu '+Art+' poniewa zamwiono mniej ni naley wyda.'
                    LBledyProd.append([OddzialProd,Buf])
                    continue
                
                # a jeli nie przekracza to zmieniamy zamwienie 
                IloscZm=DPozSum[0][0]+Ilosc
                IloscZmPrzel=rsglobal.RSRound(IloscZm*Przel,3)
                SQL="UPDATE rs_produkcja_sumy SET zamowione1="+str(IloscZm)+",zamowione2="+str(IloscZmPrzel)
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
                SQL+=" AND oddzial_zam='"+Oddzial+"' AND zmiana='"+Rzut+"' AND artykul_id='"+Art+"' AND typ_odbiorcy IS NULL"
                SQL+=" AND czas_wprowadzenia='"+rsglobal.Dekoduj(DPozSum[0][2])+"';"
                rsglobal.ZapiszDoLogow("UPD SQL "+SQL,1)
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat != 'OK':    
                    stat='Bd edycji pozycji w rs_produkcja_sumy : '+stat
                else:
                    kl=(OddzialProd,zmiana[1])
                    if not kl in SProdMail:
                        SProdMail[kl]=0
                    SProdMail[kl]+=Ilosc
                
    # jeli wystpiy bdy na licie to je zwracamy operatorowi
    if stat == 'OK' and len(LBledy) > 0 :
        rsglobal.ZapiszDoLogow('LBledy ' + str(LBledy), 1)
        dane = LBledy
    
    #---------------------------------------------------------------------------
    #-- WYSANIE MAILI
    #---------------------------------------------------------------------------
    rsglobal.ZapiszDoLogow('Wyslanie '+stat,1)  
    if stat=='OK':
        Temat=''
        Tresc=''
        
        # pobieramy list wszystkich oddziaw a potem po kolei sprawdzamy co im wysa.
        SQL="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id"
        stat,DOddz,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':    
            stat='Bd pobierania listy oddziaw : '+stat

        if stat=='OK':
            # dla kadego oddziau skadamy tre maila 
            for poz in DOddz:
                if stat=='OK':
                    Oddzial=poz[0]
                    #-----------------------------------------------------------
                    # MAIL DOTYCZCY ZAMWIE
                    #-----------------------------------------------------------
                    
                    Wysylac=False
                    Temat="Lista spraw zwizana z importem zamwie z xls z dnia "+Data+" dla oddziau "+Oddzial
                    Tresc="Poniej znajduje si lista spraw, ktre dotycz importu zamwie z pliku.\n"
                    
                    #--- lista bdw oglnych
                    if len(LBledy)>0:
                        Tresc+="\n BDY OGLNE IMPORTU\n\n"
                        for blad in LBledy:
                            Wysylac=True    
                            Tresc+=blad+"\n"

                    #--- lista podwjnych zamwie
                    CzyPierwszyWSekcji=True
                    KluczeZamowBledy=SZamowieniaBledy.keys()
                    KluczeZamowBledy.sort()
                    for klucz in KluczeZamowBledy:
                        LBladowZam=SZamowieniaBledy[klucz]
                        for blad in LBladowZam:
                            if blad[0] in ('**',Oddzial):
                                if CzyPierwszyWSekcji:
                                    Wysylac=True    
                                    CzyPierwszyWSekcji=False
                                    Tresc+="\nLISTA BDW W WYSZUKIWANIU ZAMWIE DLA KONTRAHENTA\n\n"
                                DaneSkl=SKontrahenci[klucz[0]]
                                Tresc+="  "+DaneSkl[0].strip()+'   '+DaneSkl[2].strip()+' '+DaneSkl[3].strip()+'   tel:'+DaneSkl[4]+'\n'
                                Tresc+="    "+blad[1]+'\n\n'
                        
                    #--- lista sklepw z brakiem danych
                    CzyPierwszyWSekcji=True
                    KluczeBD=SSklepyBD.keys()
                    KluczeBD.sort()
                    for klucz in KluczeBD:
                        # sprawdzamy czy to ten oddzia
                        if klucz[0]==Oddzial:
                            if CzyPierwszyWSekcji:
                                Wysylac=True    
                                CzyPierwszyWSekcji=False
                                Tresc+="\nLISTA KONTRAHENTW, KTRZY NIE ZOYLI ZAMWIE\n"
                            Tresc+='\nRZUT '+klucz[1]+"\n"
                            
                            # wstawienie kolejnych sklepw (za pomoc numerw obcych)
                            for sklep in SSklepyBD[klucz]:
                                DaneSkl=SKontrahenci[sklep]
                                Tresc+="  "+DaneSkl[0].strip()+'   '+DaneSkl[2].strip()+' '+DaneSkl[3].strip()+'   tel:'+DaneSkl[4]+'\n'

                    #--- lista sklepw ktrych w ogle nie byo na licie
                    CzyPierwszyWSekcji=True
                    KluczeP=SPlatnicy.keys()
                    KluczeP.sort()
                    # ptla po patnikach
                    rsglobal.ZapiszDoLogow('!!! '+str(KluczeP),1)
                    for kluczp in KluczeP:
                        NowyPlatnik = True
                        KluczeRZ=SPlatnicy[kluczp][1].keys()
                        KluczeRZ.sort()    
                        LKontrSpr = SPlatnicy[kluczp][0]
                        LKontrSpr.sort()
                        
                        # ptla po rzutach
                        for rzut in KluczeRZ:
                            NowyRzut = True
                            LKontrRzutu = SPlatnicy[kluczp][1][rzut]
                            SKontrOddz = SPlatnicy[kluczp][2]
                            rsglobal.ZapiszDoLogow('!!! '+kluczp+' '+str(SKontrOddz),1)
                            # sprawdzamy dla kolejnych kontrahentw dla patnika czy wystpili w rzucie
                            for kontr in LKontrSpr:
                                if not kontr[0] in LKontrRzutu:
                                    # jeli oddzia pasuje do kontrahenta
                                    if '**' in SKontrOddz[(kontr[0],rzut)] or Oddzial in SKontrOddz[(kontr[0],rzut)]:
                                        if CzyPierwszyWSekcji:
                                            Wysylac=True    
                                            CzyPierwszyWSekcji=False
                                            Tresc+="\nLISTA KONTRAHENTW, KTRZY NIE WYSTPILI W PLIKU \n"
                                        if Wysylac and NowyPlatnik:
                                            NowyPlatnik = False
                                            Tresc+="\nDLA PATNIKA "+kluczp+"\n"
                                        if Wysylac and NowyRzut:
                                            Tresc+='\nRZUT '+rzut+"\n"
                            
                                        # wstawienie brakujcego sklepu 
                                        Tresc+="  "+kontr[0].strip()+'   '+kontr[1].strip()+'   tel:'+kontr[2]+'\n'                            
                    
                    #JR 2022-12-01 (13263) lista korekt ilosciowych
                    if len(LZmienionychWgLimitu) > 0:
                        Tresc += "\nLISTA SKORYGOWANYCH ILOCI\n\n"
                        Wysylac = True
                        for blad in LZmienionychWgLimitu:
                            Tresc += "Kontrahent:"+blad[1]+" Artyku: "+blad[0]+" Ilo: "+blad[2]+" Po korekcie:"+blad[3]+"\n"

                    #--- wysyamy maile - robi to pocztowe konto administracyjne anakondy
                    if Wysylac:
                        # pobranie adresw na ktre ma to pj dla konkretnego oddziau
                        SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND powiadomienie='S0001' AND oddzial_id IN ('"+Oddzial+"','**');"
                        stat,DPoczta,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':    
                            stat="(1) Bd pobierania listy kont pocztowych dla oddziau "+Oddzial+" : "+stat
                        if stat=='OK':
                            for mail in DPoczta:
                                rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,self.PolSQL)

                #---------------------------------------------------------------
                # MAIL DOTYCZCY ZMIAN NA DOWODACH DOSTAW
                #---------------------------------------------------------------
                
                if stat=='OK':
                    Wysylac=False
                    Temat="Lista bdw i dowodw dostaw zmieniona w zwizku z importem zamwie z xls z dnia "+Data+" dla oddziau "+Oddzial
                    Tresc=''
                    if Oddzial in SZmienionychDD:
                        Wysylac=True
                        Tresc+="LISTA ZMIENIONYCH DOWODW:\n\n"
                    
                        for dok in SZmienionychDD[Oddzial]:
                            Tresc+=" Dowd dostawy "+dok+'\n'
                        
                    #--- lista bdw z dowodw dostaw - podwjne dowody
                    LDowodyBledy.sort()
                    CzyPierwszyWSekcji=True
                    for poz in LDowodyBledy:
                        if poz[0]==Oddzial:
                            if len(poz)==3:
                                if CzyPierwszyWSekcji:
                                    Wysylac=True    
                                    CzyPierwszyWSekcji=False
                                    Tresc+="\n\nLISTA PODWJNYCH DOWODW\n\n"
                        
                                Tresc+=" Znaleziono wicej ni jeden dowd dla trybu "+poz[1].strip()+' i kontrahenta '+poz[2].strip()+'\n'

                    #--- lista bdw z dowodw dostaw - zerowe ceny wstawianego artykuu
                    CzyPierwszyWSekcji=True
                    for poz in LDowodyBledy:
                        if poz[0]==Oddzial:
                            if len(poz)==2:
                                if CzyPierwszyWSekcji:
                                    Wysylac=True    
                                    CzyPierwszyWSekcji=False
                                    Tresc+="\n\nLISTA ARTYKUW O ZEROWYCH CENACH\n\n"
                        
                                Tresc+=poz[1]+'\n'

                        #--- wysyamy maile - robi to pocztowe konto administracyjne anakondy
                    if Wysylac:
                        # pobranie adresw na ktre ma to pj dla konkretnego oddziau
                        SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND powiadomienie='E0001' AND oddzial_id IN ('"+Oddzial+"','**');"
                        stat,DPoczta,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':    
                            stat="(2) Bd pobierania listy kont pocztowych dla oddziau "+Oddzial+" : "+stat
                        if stat=='OK':
                            for mail in DPoczta:
                                rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,self.PolSQL)
                                
                #---------------------------------------------------------------
                # MAIL DOTYCZCY ZMIAN NA SUMACH ZAMWIE
                #---------------------------------------------------------------
                
                if stat=='OK':
                    Wysylac=False
                    Temat="Lista bdw i zmian w sumach zamwie zmieniona w zwizku z importem zamwie z xls z dnia "+Data+" dla oddziau "+Oddzial
                    Tresc=''
                    
                    # lista bdw z edycj sum zamwie
                    CzyPierwszyWSekcji=True
                    for poz in LBledyProd:
                        if poz[0]==Oddzial:
                            if CzyPierwszyWSekcji:
                                Wysylac=True    
                                CzyPierwszyWSekcji=False
                                Tresc+="LISTA BDW\n\n"
                                                
                            Tresc+=poz[1]+'\n'
                        
                    #--- lista zmian w sumach zamwie
                    CzyPierwszyWSekcji=True
                    for poz in SProdMail:
                        if poz[0]==Oddzial:
                            if CzyPierwszyWSekcji:
                                Wysylac=True    
                                CzyPierwszyWSekcji=False
                                Tresc+="\n\nLISTA ZMIAN W SUMACH ZAMWIE\n\n"
                        
                            Art=rsglobal.Dekoduj(SArtykuly[poz[1]][0])
                            ArtNazwa=rsglobal.Dekoduj(SArtykuly[poz[1]][1])
                            Tresc+='Zmieniono zamwienie na '+Art+' - '+ArtNazwa+' o '+str(SProdMail[poz])+'\n'

                        #--- wysyamy maile - robi to pocztowe konto administracyjne anakondy
                    if Wysylac:
                        # pobranie adresw na ktre ma to pj dla konkretnego oddziau
                        SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND powiadomienie='P0001' AND oddzial_id IN ('"+Oddzial+"','**');"
                        stat,DPoczta,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat != 'OK':    
                            stat="(3) Bd pobierania listy kont pocztowych dla oddziau "+Oddzial+" : "+stat
                        if stat=='OK':
                            for mail in DPoczta:
                                rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,self.PolSQL)