# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_import_z_xls_sap.py
# Purpose:     import z pliku csv(sap)
# Author:      Mariusz Rajfura
# Created:     2013/10/29
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_import_z_xls_sap.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------

def Data2RSData(data):
    try:
        return 'OK', data[6:]+'-'+data[3:5]+'-'+data[:2]
    except Exception, e:
        return 'BLAD', str(e)

#-------------------------------------------------------------------------------

import binascii
import datetime

from funkcje import fs_pliki_office_pom

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'TrescPliku':[1], 'ListaZamowien':[2]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_import_z_xls_sap z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun == 1:
        TrescPliku = klucze['TrescPliku']

    if Fun == 2:
        ListaZamowien = klucze['ListaZamowien']


#-------------------------------------------------------------------------------
# Import zamowien z pliku xls(x) (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    # w wyn2[] lista dodanych zamowien
    
    KolDataZam = 1
    KolObcyNrZam = 4
    KolKontrahentObcy = 6
    KolArtykul = 14
    KolIlosc1 = 15
    
    stat,arkusze = fs_pliki_office_pom.OdczytajTrescXLS(TrescPliku, dehexlify=True)
    if stat <> 'OK':
        dane.append(stat)

    if stat == 'OK':
        if not '__PierwszyArkusz__' in arkusze:
            stat = 'W pliku nie znaleziono adnego arkusza'
            dane.append(stat)

    if stat == 'OK':
        zeszyt = arkusze[arkusze['__PierwszyArkusz__']]
        if len(zeszyt) < 2:
            stat = 'Pierwszy arkusz '+arkusze['__PierwszyArkusz__']+' nie ma danych'
            if len(zeszyt) == 1:
                stat+= str(zeszyt[0])
            dane.append(stat)
    
    if stat == 'OK':
        if len(zeszyt[0]) < 16:
            stat = 'Arkusz musi mie conajmniej 16 kolumn'
            dane.append(stat)


    if stat == 'OK':
        # wszystkie zamowienia
        Zamowienia = []
        
        # biezace zamowienie
        zamow = []
        ObcyNrZam = ''
        
        for i in xrange(len(zeszyt)):
            if i == 0:
                # ominiecie linii naglowka
                continue

            if rsglobal.UsunKropkaZero(zeszyt[i][KolObcyNrZam]) <> ObcyNrZam:
                if ObcyNrZam <> '' and len(zamow) > 0:
                    Zamowienia.append(zamow)
                
                # biezace zamowienie
                zamow = []
                ObcyNrZam = rsglobal.UsunKropkaZero(zeszyt[i][KolObcyNrZam])

            KontrahentObcy = rsglobal.UsunKropkaZero(zeszyt[i][KolKontrahentObcy])
            Artykul = rsglobal.UsunKropkaZero(zeszyt[i][KolArtykul])
            Ilosc1 = zeszyt[i][KolIlosc1]

            stat,DataZam = Data2RSData(str(zeszyt[i][KolDataZam]))
            if stat <> 'OK':
                dane.append('wiersz '+str(i+1)+': bdny format daty: '+str(zeszyt[i][KolDataZam]))
            elif not rsglobal.SprawdzCzyToData(DataZam):
                dane.append('wiersz '+str(i+1)+': bdny format daty: '+str(zeszyt[i][KolDataZam]))

            # i+1 to nr wiersza z arkusza dla ewentualnego raportu dalszych bledow
            zamow.append([i+1,ObcyNrZam,DataZam,KontrahentObcy,Artykul,Ilosc1])

        # ostatnie zamowienie
        if ObcyNrZam <> '' and len(zamow) > 0:
            Zamowienia.append(zamow)

    # czy byly bledy odczytu zamowien z arkusza
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
            

    # zakladamy kolejne zamowienia
    if stat == 'OK':
        for zamow in Zamowienia:
            #               0     1        2           3          4       5    
            #zamow.append([i+1,ObcyNrZam,DataZam,KontrahentObcy,Artykul,Ilosc1])
            
            # dane do naglowka na podstawie pierwszej pozycji zamowienia
            WierszInfo = 'Wiersz '+str(zamow[0][0])+':'
            Wyznacznik = 'ZO'
            ObcyNrZamowienia = zamow[0][1]
            Data = zamow[0][2]
            KontrahentObcy = zamow[0][3]
    
            # pobranie naszego numeru kontrahenta
            sql ="SELECT kontrahent_id,COALESCE(platnik_id,kontrahent_id)"
            sql+=" FROM rs_kontrahenci"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND symbol_obcy='"+KontrahentObcy+"'; "
            
            stat,kth,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania kontrahenta: '+sql
                dane.append(stat)
            elif len(kth) == 0:
                stat = WierszInfo+' ZamObce: '+ObcyNrZam+' '+Data+' Brak kontrah.o symbolu obcym '+KontrahentObcy
                dane.append(stat)
            
            if stat <> 'OK':
                # po nastepne zamowienie
                stat = 'OK'
                continue
            
            Kontrahent = rsglobal.Dekoduj(kth[0][0])
            Platnik = rsglobal.Dekoduj(kth[0][1])
            Zamawiajacy = Kontrahent
            MiejsceDostawy = Kontrahent
            TypZamowienia = "'01'"
            Trasa = 'NULL'
            Kierowca = Trasa
            Projekt = 'NULL'
            Wersja = 'NULL'
            Waluta = "'PLN'"
            Kurs = 1.0
            SposZaplaty = 'NULL'
            SposDostawy = 'NULL'
            Dni = 0
            Handlowiec = 'NULL'
            TrybDostawy = "'01'"
            
            # pobieramy trase; kierowca taki sam, jak trasa (3 pierwsze znaki)
            sql ="SELECT COALESCE(trasa,'') FROM rs_kontrahenci_trasy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';"
            stat,tra,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania trasy dla kontrahenta: '+sql
                dane.append(stat)
            elif len(tra) == 0:
                stat = WierszInfo+' ZamObce: '+ObcyNrZam+' '+Data+' Kth obcy:'+KontrahentObcy+'  Brak trasy dla kontrah '+Kontrahent
                dane.append(stat)
            else:
                Trasa = "'"+rsglobal.Dekoduj(tra[0][0])+"'"
                Kierowca = "'"+rsglobal.Dekoduj(tra[0][0])[:3]+"'"
                
            # sprawdzenie kierowcy
            if stat == 'OK':
                sql ="SELECT kod FROM rs_kierowcy"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod="+Kierowca+";"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia kierowcy: '+sql
                    dane.append(stat)
                elif len(d) == 0:
                    stat = 'Brak kierowcy o symbolu '+Kierowca
                    dane.append(stat)
    
            if stat <> 'OK':
                # po nastepne zamowienie
                stat = 'OK'
                continue
        
            # pobieramy dane do fakturowania
            sql ="SELECT COALESCE(wersja,''),dni,COALESCE(handlowiec,''),"
            sql+=" COALESCE(spos_zaplaty,''),COALESCE(spos_dostawy,''),COALESCE(projekt_id,'')"
            sql+=" FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
            sql+=" AND data_od<='"+Data+"'"
            sql+=" ORDER BY data_od DESC LIMIT 1;"
            
            stat,fakt,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych do fakturowania: '+sql
                dane.append(stat)
                stat = 'OK'
                continue
    
            if len(fakt) > 0:
                if fakt[0][0] <> '':
                    Wersja = "'"+rsglobal.Dekoduj(fakt[0][0])+"'"
                    
                Dni = fakt[0][1]
                
                if fakt[0][2] <> '':
                    Handlowiec = "'"+rsglobal.Dekoduj(fakt[0][2])+"'"
    
                if fakt[0][3] <> '':
                    SposZaplaty = "'"+rsglobal.Dekoduj(fakt[0][3])+"'"
    
                if fakt[0][4] <> '':
                    SposDostawy = "'"+rsglobal.Dekoduj(fakt[0][4])+"'"
    
                if fakt[0][5] <> '':
                    Projekt = "'"+rsglobal.Dekoduj(fakt[0][5])+"'"
    
            
            # pobranie numeru nowego zamowienia
            sql ="SELECT COALESCE(MAX(numer),0)+1"
            sql+=" FROM rs_zamowienia_odbiorcy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
            sql+=" AND data='"+Data+"'; "
            
            stat,nowy,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania nowego numeru zamwienia: '+sql
                dane.append(stat)
                stat = 'OK'
                continue
            
            Numer = nowy[0][0]
            
            NaszNrZam = Wyznacznik+'/'+Data+'/'+rsglobal.UsunKropkaZero(Numer)
            
            # teraz tworzymy sql z calym zamowieniem
            INS ="INSERT INTO rs_zamowienia_odbiorcy"
            INS+=" (firma_id,wyznacznik_id,data,numer,oddzial_id,"
            INS+="  kontrahent_id,platnik_id,zamawiajacy_id,miejsce_dostawy_id,"
            INS+="  dostawy_od_dnia,dostawy_do_dnia,kierowca,"
            INS+="  projekt_id,sposob_dostawy,sposob_zaplaty,handlowiec,"
            INS+="  wersja,waluta,kurs,typ_zamowienia)"
            INS+=" VALUES"
            INS+=" ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+str(Numer)+",'"+self.oddzial_id+"',"
            INS+="  '"+Kontrahent+"','"+Platnik+"','"+Zamawiajacy+"','"+MiejsceDostawy+"',"
            INS+="  '"+Data+"','"+Data+"',"+Kierowca+","
            INS+="  "+Projekt+","+SposDostawy+","+SposZaplaty+","+Handlowiec+","
            INS+="  "+Wersja+","+Waluta+","+str(Kurs)+","+TypZamowienia+"); "
        
            # pozycje zamowienia
            for poz in xrange(len(zamow)):
                Artykul = zamow[poz][4]
                try:
                    Ilosc1 = float(zamow[poz][5])
                except Exception, e:
                    dane.append('Wiersz '+str(zamow[poz][0])+': Bd iloci. Zam.nr '+ObcyNrZam+' poz:'+str(poz+1)+'  '+str(Zamowienie[poz]))
                    continue
                    
                Ilosc2 = Ilosc1
                
                # pobranie danych z artykulow
                # stawka vat
                sql ="SELECT stawka_vat"
                sql+=" FROM rs_artykuly_stawki_vat"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                sql+=" AND od_dnia<='"+Data+"'"
                sql+=" ORDER BY od_dnia DESC LIMIT 1; "
                
                stat,vat,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania stawki VAT: '+sql
                    dane.append(stat)
                    stat = 'OK'
                    continue
                elif len(vat) == 0:
                    stat = 'Wiersz '+str(zamow[poz][0])+': ZamObce: '+ObcyNrZam+' poz: '+rsglobal.UsunKropkaZero(poz+1)+'  Nasze '+NaszNrZam+' Brak stawki vat dla art: '+Artykul
                    dane.append(stat)
                    stat = 'OK'
                    continue
                
                StawkaVat = "'"+rsglobal.Dekoduj(vat[0][0])+"'"
                
                # kolejna pozycja zamowienia
                INS+="INSERT INTO rs_zamowienia_odbiorcy_pozycje"
                INS+=" (firma_id,wyznacznik_id,data,numer,"
                INS+="  nr_poz,nr_ppoz,data_od,data_do,tryb_dostawy,"
                INS+="  artykul_id,ilosc1,ilosc2,stawka_vat)"
                INS+=" VALUES"
                INS+=" ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+str(Numer)+","
                INS+="  "+str(poz+1)+",0,'"+Data+"','"+Data+"',"+TrybDostawy+","
                INS+="  '"+Artykul+"',"+str(Ilosc1)+","+str(Ilosc2)+","+StawkaVat+"); "
    
            if stat == 'OK' and INS <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(INS,1,CzyDodawacBlad=True)
                
                if stat <> 'OK':
                    stat = 'Bd dodawania nowego zamwienia: '+INS
                    dane.append(stat)
                    stat = 'OK'
                    continue
                else:
                    wyn2.append([Wyznacznik,Data,Numer])
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                # nic nie zostanie dopisane
                wyn2 = []
