# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_klucz.py
# Purpose:     insert/update zamowienia odbiorcy
#
# Author:      Marcin Grzeda
# Created:     2007/01/19
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_klucz.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-09-03 Mariusz Rajfura (6029) pobieranie waluty z danych do fakturowania
# 2019-08-06 Aleksander Bargie - (11581) [SP] czy_mpp w zamowieniach odbiorcw
# 2020-05-04 Jan Raburski (11965) Ograniczenie filtra do kontrahenta z operatora, jesli jest
# 2020-05-18 Mikoaj Kozowski (11969) Zablokowanie moliwoci dodania zamwienia dla kontrahenta innego ni wpisany w operatora
# 2020-05-27 Mikoaj Kozowski (11991) Pobieranie wartoci TCOdbiorca do Funkcji 11 (kopiowanie) pod KontrahentK jako zalepka na bd w kopiowaniu
# 2020-07-13 Mikoaj Kozowski (12030) Refaktoryzacja + Zablokowanie moliwoci dodania zamwienia dla kontrahenta innego ni wpisany w operatora w kopiowaniu
# 2020-10-20 Mikoaj Kozowski (12074) Usunicie funkcji UPDATE, z uwagi na usunicie funkcjonalnoci zmiany klucza

stat = "OK"
KontrahentK=''
#MK 2020-07-17 - pocztek

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']
    SlPar = {'Wyznacznik':[1,2,3,4,5,10,11], 'Data':[1,2,3,4,5,10,11], 'Numer':[1,2,3,4,5,11], 'Stale':[11], 'Odbiorca':[2,11]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_klucz z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [1,2,3,4,5,10,11]:
        Wyznacznik = rsglobal.Dekoduj(klucze['Wyznacznik']) + '  '[0:2]  # upewniamy sie ze ma 2 znaki
        Wyznacznik = Wyznacznik[0:2]
    if Fun in [1,2,3,4,5,10,11]:
        Data = rsglobal.Dekoduj(klucze['Data'])
    if Fun in [1,2,3,4,5,11]:
        Numer = rsglobal.Dekoduj(klucze['Numer'])
    if Fun == 11:
        Stale = rsglobal.Dekoduj(klucze['Stale'])
    if 'parametry' in klucze:
        parametry = rsglobal.Dekoduj(klucze['parametry'])

#MK 2020-07-17 - koniec
if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

if stat == 'OK':                                                         #MK 2020-07-29 - rozdzieliem sprawdzanie statu i operatora
    if self.operator_id != STANDARD_OPERATOR_ID:  #JR 2020-05-04 (11965) # eby mc ustawia Kontrahenta dla Anakondy
    # sprawdzenie czy operator ma wpisany symbol kontrahenta, jesli tak - zastepujemy tego z klucza
        sql = "SELECT COALESCE(kontrahent_id,'') FROM rs_operatorzy WHERE operator_id=" + str(self.operator_id) + ";"
        stat, kont, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat == 'OK':
            if kont[0][0].strip() != '':
                KontrahentK = kont[0][0]
            else:   #MK 2020-07-27
                if Fun in [1,2,3,4,11]:
                    KontrahentK = rsglobal.Dekoduj(klucze['Odbiorca'])
    else:  #MK 2020-07-27
        KontrahentK = rsglobal.Dekoduj(klucze['Odbiorca'])

if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:

        UprEdy=True
        UprDod=True
        LEdy=LWyzn
        LDod=LWyzn
        
    else:
        UprEdy = (self.oddzial_id,'024015') in self.uprawnienia
        LEdy=[]

        if UprEdy and (Fun in [3,4]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]
        
        UprDod = ((self.oddzial_id,'024013') in self.uprawnienia)
        LDod=[]

        if UprDod and (Fun in [1,2,11]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LDod=rsglobal.rseval(wyzn[0][0])[1]
            rsglobal.ZapiszDoLogow('LDod:1'+str(LDod)+' Uprod:'+str(UprDod)+' wyzn:'+str(wyzn)+' lista:'+str(Lista)+' stat:'+stat,1)



#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------
if Fun in [1,2,3,4]:
    rsglobal.ZapiszDoLogow('kopiowanie',1)
    for i in range(len(pola)):
        pole = pola[i]
        wart= wartosci[i]
        if pole == 'wyznacznik_id':
            WyznacznikNowy = wart
            if wart == "":
                stat="BR WYZN"
                dane.append(stat)
            else:
                stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id=\'"+self.firma_id+"\' AND wyznacznik_id = \'"+wart+"\';",3)
                if len(dane_wyn) == 0:
                    stat="BL WYZN"
                    dane.append(stat)
                else:
                    stat,dane_typ,dump,dump = self.PolSQL.Execute("SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+wart+"';",3) 
                    if stat<>'OK':
                        stat='BL SQL TYP FAKT'
                        dane.append(stat)
                    elif len(dane_typ) == 0:
                        stat='BL WYZN'
                        dane.append(stat)
                    else:
                        if dane_typ[0][0]<>'ZO':
                            stat='BL TYP FAKT'
                            dane.append(stat) 
                    
        elif pole == 'data':
            DataNowa = wart
            if wart == "    -  -  ":
                stat="BR DAT"
                dane.append(stat)
            else:
                if not rsglobal.SprawdzCzyToData(wart):
                    stat="BL DAT"
                    dane.append(stat)
                else:
                    Data=wart
        elif pole == 'numer':
            if wart==0:
                stat="BL NUM"
                dane.append(stat)
        elif pole == 'kontrahent_id':
            if KontrahentK == "":  #MK 2020-05-20
                if wart !="":
                    KontrahentK=wart
                else:
                    stat = "BR KONTR"
                    dane.append(stat)
            
    if len(dane)>0:
        stat=dane[-1]
        
    if stat=='OK':
        if KontrahentK<>"": 
            if Data<>"":                                                           #AB 06.08.19r
                SQLKon = """SELECT k.zamawiajacy_id, k.platnik_id, k.zablokowany, COALESCE(k.czy_mpp or p.czy_mpp, FALSE) AS czy_mpp 
FROM rs_kontrahenci k FULL OUTER JOIN rs_kontrahenci p ON (k.firma_id=p.firma_id AND k.platnik_id=p.kontrahent_id) 
WHERE k.firma_id='{}' AND k.kontrahent_id='{}' AND k.aktywny;""".format(self.firma_id, KontrahentK)
                stat,d,dump,dump = self.PolSQL.Execute(SQLKon, 3)

                if d == None or len(d) == 0:
                    stat = "BL KONTR"
                    dane.append(stat)
                elif d[0][2]:
                    stat = "KONTR ZABL"
                    dane.append(stat)
                else:
                    if d[0][0].strip() not in ["",u'None']:
                        Zamawiajacy = rsglobal.Dekoduj(d[0][0])
                        pola.append('zamawiajacy_id')
                        wartosci.append(Zamawiajacy)
                    else:
                        Zamawiajacy = KontrahentK
                        pola.append('zamawiajacy_id')
                        wartosci.append(Zamawiajacy)
                    if d[0][1].strip() not in ["",u'None']:
                        Platnik = rsglobal.Dekoduj(d[0][1])
                        pola.append('platnik_id')
                        wartosci.append(Platnik)
                    else:
                        Platnik= KontrahentK
                        pola.append('platnik_id')
                        wartosci.append(Platnik)
                    #AB 06.08.19r
                    czy_mpp = rsglobal.Dekoduj(d[0][3])
                    pola.append('czy_mpp')
                    wartosci.append(czy_mpp)
                    
                     
                    pola.append('miejsce_dostawy_id')
                    wartosci.append(KontrahentK)      
                    
                    sql ="SELECT dni,wersja,upust,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,"
                    sql+=" projekt_id,COALESCE(waluta_sprzedaz,'PLN'::TEXT)"
                    sql+=" FROM rs_kontrahenci_fakturowanie"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentK+"' AND data_od<='"+Data+"'"
                    sql+=" ORDER BY data_od DESC LIMIT 1;"
                    
                    dump,dk,dump,dump = self.PolSQL.Execute(sql, 3)
                    if len(dk) == 1:
                        Dni = dk[0][0]
                        pola.append('dni')
                        wartosci.append(Dni)
                        if dk[0][1] != u'None':
                            Wersja =rsglobal.Dekoduj(dk[0][1])
                            pola.append('wersja')
                            wartosci.append(Wersja)
                        Upust = dk[0][2]
                        pola.append('upust')
                        wartosci.append(Upust)
                        pola.append('kurs')
                        wartosci.append(1)
                        pola.append('waluta')
                        wartosci.append(rsglobal.Dekoduj(dk[0][8]))
                        
                        if dk[0][3] != u'None':
                            SposZaplaty = rsglobal.Dekoduj(dk[0][3])
                            pola.append('sposob_zaplaty')
                            wartosci.append(SposZaplaty)
                        if dk[0][4] != u'None':
                            SposDostawy = rsglobal.Dekoduj(dk[0][4])
                            
                            pola.append('sposob_dostawy')
                            wartosci.append(SposDostawy)
                        if dk[0][5] != u'None':
                            Handlowiec = rsglobal.Dekoduj(dk[0][5])
                            pola.append('handlowiec')
                            wartosci.append(Handlowiec)
                        if dk[0][6] != u'None':
                            SposobOdbioruFaktury = rsglobal.Dekoduj(dk[0][6])
                            pola.append('sposob_odbioru_faktury')
                            wartosci.append(SposobOdbioruFaktury)
                        if dk[0][7] != u'None':
                            Projekt=rsglobal.Dekoduj(dk[0][7])
                            pola.append('projekt_id')
                            wartosci.append(Projekt)                        
                    else:
                        Dni = 0.0
                        pola.append('dni')
                        wartosci.append(Dni)
                        Wersja = "NULL"
                        pola.append('wersja')
                        wartosci.append(Wersja)
                        Upust = 0
                        pola.append('upust')
                        wartosci.append(Upust)
                        SposZaplaty = "NULL"
                        pola.append('sposob_zaplaty')
                        wartosci.append(SposZaplaty)
                        SposDostawy = "NULL"
                        pola.append('sposob_dostawy')
                        wartosci.append(SposDostawy)
                        Projekt = "NULL"
                        pola.append('projekt_id')
                        wartosci.append(Projekt)
                        Handlowiec = "NULL"
                        pola.append('handlowiec')
                        wartosci.append(Handlowiec)
                        SposobOdbioruFaktury = "NULL"
                        pola.append('sposob_odbioru_faktury')
                        wartosci.append(SposobOdbioruFaktury)
                        pola.append('kurs')
                        wartosci.append(1)
                        pola.append('waluta')
                        wartosci.append('PLN')
            else:
                stat=('BR DAT')
                dane.append(stat)
        else:
            stat='BR KONTR'
            dane.append(stat)

if len(dane)>0:
    stat=dane[-1]

if Fun in (1,2) and stat=='OK':
    sql="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+WyznacznikNowy+"\\',\\'"+DataNowa+"\\']','ZO');"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia moliwoci dodania nowego zamwienia: '+stat
    elif d[0][0] != 'OK':
        stat='Nie mona doda zamwienia z podan dat : '+d[0][0]


#-------------------------------------------------------------------------------
#--- Pobieranie Numeru(10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat=='OK':
    if ((self.oddzial_id,'024011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        if rsglobal.SprawdzCzyToData(Data):
            sql="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\'"+Wyznacznik+"\\',\\'"+Data+"\\']','ZO');"
            stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='BL SEL NUM'
                dane.append(stat)
        else:
            stat='BL DATA'
            dane.append(stat)
    else:
        stat = 'UPR SEL'   


#-------------------------------------------------------------------------------
#--- Sprawdzenie czy dany klucz jest OK (kopiowanie) (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat=='OK':
    Wyzn = Wyznacznik + ' ' #MK 2020-07-27
    Wyzn=Wyzn[0:2]

    sql ="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\'"+Wyzn.strip()+"\\',\\'"+Data+"\\']','ZO');"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia moliwoci dodania nowego zamwienia: '+stat
    elif d[0][0] != 'OK':
        stat='Nie mona doda zamwienia z podan dat :'+d[0][0]

    if stat == 'OK':
        stat,dane_typ,dump,dump = self.PolSQL.Execute("SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"';",3) 
        if stat<>'OK':
            stat='BL SQL TYP FAKT'
            dane.append(stat)
        elif len(dane_typ) == 0:
            stat='BL WYZN'
            dane.append(stat)
        else:
            if dane_typ[0][0]<>'ZO':
                stat='BL TYP FAKT'
                dane.append(stat)
    
    if stat == 'OK' and 'parametry' in klucze: #MK 2020-07-27
        #sprawdzenie, czy kontrahent,odbiorca,platnik,miejsce_dostawy z kopiowanego zamowienie sa poprawne i aktywne
        #AB 06.08.19r
        sql = """SELECT zo.kontrahent_id, zo.zamawiajacy_id, zo.platnik_id, miejsce_dostawy_id, COALESCE(zo.czy_mpp OR o.czy_mpp OR p.czy_mpp, FALSE) AS czy_mpp
FROM rs_zamowienia_odbiorcy zo 
JOIN rs_kontrahenci o USING (firma_id, kontrahent_id)
JOIN rs_kontrahenci p on (p.firma_id=zo.firma_id AND p.kontrahent_id=zo.platnik_id)
WHERE zo.firma_id='{}' AND zo.wyznacznik_id='{}' AND zo.data='{}' AND zo.numer={};
""".format(self.firma_id, rsglobal.Dekoduj(parametry[0]), rsglobal.Dekoduj(parametry[1]), parametry[2])

        stat,zo,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat != 'OK':
            stat = 'BL SQL SEL'
        else:
            if len(zo) != 1:
                stat = 'BR ZAMOW'
            else:
                sql ="SELECT kontrahent_id,zablokowany FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                sql+=" AND kontrahent_id = '"+str(zo[0][0])+"' AND aktywny;"
                stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL SEL'
                elif len(k) != 1:
                    stat = 'BL KONTR'
                    dane.append(stat)
                elif k[0][1]:
                    stat = 'KONTR ZABL'
                    dane.append(stat)

                if str(zo[0][1]) != 'None':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kontrahent_id = '"+str(zo[0][1])+"' AND aktywny;"
                    stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'BL SQL SEL'
                    elif len(k) != 1:
                        stat = 'BL ZAMAW'
                        dane.append(stat)

                if str(zo[0][2]) != 'None':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kontrahent_id = '"+str(zo[0][2])+"' AND aktywny;"
                    stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'BL SQL SEL'
                    elif len(k) != 1:
                        stat = 'BL PLAT'
                        dane.append(stat)

                if str(zo[0][3]) != 'None':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kontrahent_id = '"+str(zo[0][3])+"' AND aktywny;"
                    stat,k,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat != 'OK':
                        stat = 'BL SQL SEL'
                    elif len(k) != 1:
                        stat = 'BL MIEJDOST'
                        dane.append(stat)
                #AB 06.08.19r
                czy_mpp = zo[0][4]
                        
            if len(dane) > 0:
                stat = dane[0]

            if stat=='OK':
                Waluta = "'PLN'"
                # pobranie danych do fakturowania
                sql ="SELECT COALESCE(waluta_sprzedaz,'PLN'::TEXT)"
                sql+=" FROM rs_kontrahenci_fakturowanie"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+rsglobal.Dekoduj(zo[0][0])+"'"
                sql+=" AND data_od<='"+Data+"'"
                sql+=" ORDER BY data_od DESC LIMIT 1;"
                
                stat,df,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'Bd pobrania danych do fakturowania: '+stat
                elif len(df) == 1:
                    Waluta = "'"+rsglobal.Dekoduj(df[0][0])+"'"
    
    if stat=='OK':
        if not (UprDod and (Wyzn in LDod)) and self.operator_id != STANDARD_OPERATOR_ID:
            stat='UPR INS'
            dane.append(stat)    
    
    if stat=='OK':
        if Wyzn == "":
            stat="BR WYZN"
            dane.append(stat)
        else:
            stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyzn+"';",3)
            if len(dane_wyn) == 0:
                stat="BL WYZN"
                dane.append(stat)
                
        if Data == "    -  -  ":
            stat="BR DAT"
            dane.append(stat)
        else:
            if not rsglobal.SprawdzCzyToData(Data):
                stat="BL DAT"
                dane.append(stat)

        if Numer==0:
            stat="BL NUM"
            dane.append(stat)    
        
        if stat=="OK":
            Select="SELECT * FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
            st,d,wyn1,tr = self.PolSQL.Execute(Select,3)
            if st=='OK':
                if len(d)>0:
                    stat='ZAM ISTN'
                    dane.append(stat)
            else:
                stat="BL SQL SEL"
        
            if 'parametry' in klucze: #MK 2020-07-27
                Select="SELECT * FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"' AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                st,d,wyn1,tr = self.PolSQL.Execute(Select,3)
                if st=='OK':
                    if len(d)==0:
                        stat='BR ZAM'
                        dane.append(stat)
                else:
                    stat="BL SQL SEL"
                    dane.append(stat)

        if stat<>'OK':
            stat='UZ KLUCZ'
            dane.append(stat)
        elif stat=='OK' and 'parametry' in klucze: #MK 2020-07-27
            Insert="INSERT INTO rs_zamowienia_odbiorcy (firma_id,wyznacznik_id,data,numer,oddzial_id,stan,blokada_cen,"
            Insert+="czy_proforma,czy_stale,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,dostawy_od_dnia,dostawy_do_dnia,"
            Insert+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,typ_zamowienia,"
            Insert+="handlowiec,sposob_odbioru_faktury,sposob_dostawy,upust,upust_wartosc,upust_wartosc_wal,rabat,rabat_wartosc,rabat_wartosc_wal,"
            Insert+="kwota_netto,kwota_vat,wartosc_opakowan,do_zaplaty,kwota_netto_wal,kwota_vat_wal,do_zaplaty_wal,tekst_nad_podp,tekst_pod_podp,"        #AB 06.08.19r
            Insert+="priorytet,magazyn_id, czy_mpp)"
            Insert+=" SELECT firma_id,'"+Wyzn+"','"+Data+"',"+str(Numer)+",oddzial_id,'W',blokada_cen,"
            Insert+="czy_proforma,"+str(Stale)+",'"+KontrahentK+"' as kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,'"+Data+"','"+Data+"'," #MK 2020-05-18 #MK 2020-05-27
            Insert+="kierowca,projekt_id,"+Waluta+",kurs,nr_tabeli,data_tabeli,wersja,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,typ_zamowienia,"
            Insert+="handlowiec,sposob_odbioru_faktury,sposob_dostawy,upust,0,0,rabat,0,0,"
            Insert+="0,0,0,0,0,0,0,tekst_nad_podp,tekst_pod_podp,"#AB 06.08.19r
            Insert+="priorytet,magazyn_id, " + ('TRUE' if czy_mpp else 'FALSE')
            Insert+=" FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
            Insert+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
            stat,dump,dump,dump=self.PolSQL.Execute(Insert,1)
            if stat<>'OK':
                stat='BL INS KOP'
                dane.append(stat)
            else:
                Stawka="rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"')"
                
                # sprawdzenie poprawnoci stawek VAT na pozycjach
                SQLTest="SELECT artykul_id,"+Stawka+" FROM rs_zamowienia_odbiorcy_pozycje "
                SQLTest+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                SQLTest+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                stat,DTest,dump,dump=self.PolSQL.Execute(SQLTest,3)
                if stat=='OK':
                    if len(DTest)>0:
                        for poz in DTest:
                            if len(poz[1])>2:
                                stat=poz[1]
                
                if stat=='OK':
                    StawkaL="CASE WHEN "+Stawka+" IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE "+Stawka+"::INT END "
                    CenaB1="ROUND(cena_upust1*(100+"+StawkaL+")*0.01 ,2)"
                    CenaB2="ROUND(cena_upust2*(100+"+StawkaL+")*0.01 ,2)"
                    WartVAT="ROUND(wartosc_netto*"+StawkaL+"*0.01,2)"
                    WartB="ROUND(wartosc_netto*(100+"+StawkaL+")*0.01,2)"
                    WartWalVAT="ROUND(wartosc_wal_netto*"+StawkaL+"*0.01,2)"
                    WartWalB="ROUND(wartosc_wal_netto*(100+"+StawkaL+")*0.01,2)"
                    
                    InsertPoz="INSERT INTO rs_zamowienia_odbiorcy_pozycje (firma_id,wyznacznik_id,data,numer,nr_poz,"
                    InsertPoz+="nr_ppoz,data_od,data_do,artykul_id,ilosc1,ilosc2,cena_netto1,cena_netto2,"
                    InsertPoz+="cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,"
                    InsertPoz+="wartosc_netto,wartosc_vat,wartosc_brutto,nr_serii,termin_przyd,cena_wal1,cena_wal2,"
                    InsertPoz+="cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,tryb_dostawy) "
                    InsertPoz+="SELECT firma_id,'"+Wyzn+"','"+Data+"',"+str(Numer)+",nr_poz,"
                    InsertPoz+="nr_ppoz,CASE WHEN "+str(Stale)+"=False THEN '"+Data+"' ELSE data_od END,"
                    InsertPoz+="CASE WHEN "+str(Stale)+"=False THEN '"+Data+"' ELSE data_do END,artykul_id,ilosc1,"
                    InsertPoz+="ilosc2,cena_netto1,cena_netto2,"
                    InsertPoz+="cena_upust1,cena_upust2,"+CenaB1+","+CenaB2+",upust,upust_wartosc,"+Stawka+","
                    InsertPoz+="wartosc_netto,"+WartVAT+","+WartB+",nr_serii,termin_przyd,cena_wal1,cena_wal2,"
                    InsertPoz+="cena_upust_wal1,cena_upust_wal2,wartosc_wal_netto,"+WartWalVAT+","+WartWalB+",tryb_dostawy "
                    InsertPoz+="FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                    InsertPoz+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                    
                    InsertPozOpisowe=" INSERT INTO rs_zamowienia_odbiorcy_pozycje_opisowe (firma_id,wyznacznik_id,data,numer,"
                    InsertPozOpisowe+="nr_poz,opis_pozycji,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,wartosc_wal_netto,"
                    InsertPozOpisowe+="wartosc_wal_vat,wartosc_wal_brutto)"
                    InsertPozOpisowe+=" SELECT firma_id,'"+Wyzn+"','"+Data+"',"+str(Numer)+","
                    InsertPozOpisowe+="nr_poz,opis_pozycji,stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,wartosc_wal_netto,"
                    InsertPozOpisowe+="wartosc_wal_vat,wartosc_wal_brutto FROM rs_zamowienia_odbiorcy_pozycje_opisowe "
                    InsertPozOpisowe+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                    InsertPozOpisowe+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                    
                    InsertPozStale=" INSERT INTO rs_zamowienia_odbiorcy_pozycje_stale (firma_id,wyznacznik_id,data,numer,"
                    InsertPozStale+="data_od,data_do,tryb_dostawy,artykul_id,dz_00,dz_01,dz_02,dz_03,dz_04,dz_05,dz_06,dz_07,"
                    InsertPozStale+="op_00,op_01,op_02,op_03,op_04,op_05,op_06,op_07) "
                    InsertPozStale+=" SELECT firma_id,'"+Wyzn+"','"+Data+"',"+str(Numer)+","
                    InsertPozStale+="data_od,data_do,tryb_dostawy,artykul_id,dz_00,dz_01,dz_02,dz_03,dz_04,dz_05,dz_06,dz_07,"
                    InsertPozStale+="op_00,op_01,op_02,op_03,op_04,op_05,op_06,op_07 FROM rs_zamowienia_odbiorcy_pozycje_stale "
                    InsertPozStale+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                    InsertPozStale+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                    
                    #InsertVat=" INSERT INTO rs_zamowienia_odbiorcy_vat (firma_id,wyznacznik_id,data,numer,"
                    #InsertVat+="stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto) "
                    #InsertVat+=" SELECT firma_id,'"+Wyzn+"','"+Data+"',"+str(Numer)+","
                    #InsertVat+="stawka_vat,wartosc_netto,wartosc_vat,wartosc_brutto,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto "
                    #InsertVat+=" FROM rs_zamowienia_odbiorcy_vat "
                    #InsertVat+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(parametry[0])+"'"
                    #InsertVat+=" AND data='"+rsglobal.Dekoduj(parametry[1])+"' AND numer="+str(parametry[2])+";"
                    
                    stat,dump,dump,dump= self.PolSQL.Execute(InsertPoz+InsertPozStale+InsertPozOpisowe,1)
                    #st,dump,dump,dump= self.PolSQL.Execute(InsertVat,1)
                    if stat<>'OK':
                        stat='BL INS POZ'
                        dane.append(stat)





#-------------------------------------------------------------------------------
# -- Pobranie danych operatora 13 -- #
#-------------------------------------------------------------------------------
if stat=='OK' and Fun == 13:
    SELECT="SELECT czy_uproszczone_zamow FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat<>'OK':
        stat='BL OPER'
        dane.append(stat)
    else:
        self.CzyUpr=dane[0][0]


#--- INSERT DANYCH(2)     
        
if stat == "OK":
    if Fun in [1,2]:
        rsglobal.ZapiszDoLogow('UPR INS '+str(UprDod)+' !'+Wyznacznik+'! '+str(LDod),1)
        if not (UprDod and (Wyznacznik in LDod)) and self.operator_id != STANDARD_OPERATOR_ID:
            stat='UPR INS'
            dane.append(stat)

        if stat=='OK':
            Insert="INSERT INTO rs_zamowienia_odbiorcy (firma_id,oddzial_id,stan"
            Values=") VALUES ('"+self.firma_id+"','"+self.oddzial_id+"','W'"
            i=0
            BezHandlowca=True
            while i<len(pola):
                pole=pola[i]
                wart=wartosci[i]
                if pole in ['wyznacznik_id','data','zamawiajacy_id','platnik_id','waluta']:
                    Insert=Insert+","+pole
                    Values=Values+",'"+wart+"'"                     #AB 06.08.19r
                if pole in ['kontrahent_id']:                       #MK 2020-05-18
                    Insert=Insert+","+pole
                    Values=Values+",'"+KontrahentK+"'"
                if pole in ['numer','czy_stale','dni','upust','kurs', 'czy_mpp']:
                    Insert=Insert+","+pole
                    Values=Values+","+str(wart)
                if pole in ['projekt_id','sposob_zaplaty','sposob_dostawy','sposob_odbioru_faktury','wersja','miejsce_dostawy_id']:
                    if wart<>"NULL":
                        Insert=Insert+","+pole
                        Values=Values+",'"+wart+"'"
                    else:
                        Insert=Insert+","+pole
                        Values=Values+","+wart
                if pole in ['handlowiec']:
                    BezHandlowca=False
                    if str(self.handlowiec_id).strip()<>'None':
                        Insert=Insert+","+pole
                        Values=Values+",'"+str(self.handlowiec_id)+"'"
                    else:
                        if wart<>"NULL":
                            Insert=Insert+","+pole
                            Values=Values+",'"+wart+"'"
                        else:
                            Insert=Insert+","+pole
                            Values=Values+","+wart

                i+=1

            #if pole not in ['handlowiec']:
            if BezHandlowca:
                    if str(self.handlowiec_id).strip()<>'None':
                        Insert=Insert+","+'handlowiec'
                        Values=Values+",'"+str(self.handlowiec_id)+"'"


            Insert=Insert+Values+");"

            stat,dump,dump,dump = self.PolSQL.Execute(Insert ,1)

            if stat<>'OK':
                stat='BL INS'
                dane.append(stat)

#--- UPDATE DANYCH(3)

# if Fun in [3,4] and stat == "OK":
#     if not (UprEdy and (Wyznacznik in LEdy)) and self.operator_id != STANDARD_OPERATOR_ID:
#         stat='UPR UPD'
#         dane.append(stat)
#     if stat=='OK':
#         Update="UPDATE rs_zamowienia_odbiorcy SET firma_id='"+self.firma_id+"'"
#         Where=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
#         i=0
#         while i<len(pola):
#             pole=pola[i]
#             wart=wartosci[i]
#             if pole in ['kontrahent_id','wyznacznik_id','data','zamawiajacy_id','platnik_id']:
#                 Update=Update+","+pole+"='"+wart+"'"                #AB 06.08.19r                                                                      #MK 2020-10-20
#             if pole in ['numer','dni','upust','czy_stale','priorytet', 'czy_mpp']:
#                 Update=Update+","+pole+"="+str(wart)
#             if pole in ['sposob_zaplaty','sposob_dostawy','sposob_odbioru_faktury','wersja','handlowiec']:
#                 if wart<>"NULL":
#                     Update=Update+","+pole+"='"+wart+"'"
#                 else:
#                     Update=Update+","+pole+"="+wart
#             i+=1
#         Update=Update+Where
#         stat,dump,dump,dump = self.PolSQL.Execute(Update,1)
#         if stat<>'OK':
#             stat='BL UPD'
#             dane.append(stat)
  
if Fun in [1,2,3,4] and stat=='OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart= wartosci[i]
        if pole=='wyznacznik_id':
            Wyznacznik=wart
        elif pole=='data':
            Data=wart
        elif pole=='numer':
            Numer=wart


if Fun in [1,2,3,4,5] and stat=='OK':
    if ((self.oddzial_id,'024011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Sql="SELECT kontrahent_id,wyznacznik_id,data,numer,czy_stale FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,dane,wyn1,dump = self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL SEL'
            dane.append(stat)
    else:
        stat = 'UPR PRZ'