
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_pliki.py
# Purpose:     wyswietla, dodaje, usuwa z bazy danych informacje o 
#              zalacznikach do zamwie odbiorcy                                
# Author:      Micha Raburski
# Created:     2014/03/02
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_pliki.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

from funkcje import fs_pliki_global

stat = "OK"
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[1,2,5,6],'Data':[1,2,5,6],'Numer':[1,2,5,6],'Typ':[1],'Plik':[1],
           'Tresc':[1],'PlikId':[2,6],'KluczZlecenia':[1,2,5,6]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_pliki z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
if stat == 'OK':
    if Funkcja in [1,2,5,6]:
        Wyzn = klucze["Wyznacznik"]
        Data = klucze["Data"]
        Nr = str(klucze["Numer"])
        KluczZlecenia = klucze["KluczZlecenia"]
    if Funkcja in [1]:
        Typ = klucze["Typ"]
        Plik = klucze["Plik"]
        TrescPliku = klucze["Tresc"]
    if Funkcja in [2,6]:
        PlikId = str(klucze["PlikId"])
        

UprIns=((self.oddzial_id,'024073') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel=((self.oddzial_id,'024074') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

if Funkcja == 1 :
    if not UprIns:
        stat='UPR INS'

if Funkcja == 6 :
    if not UprDel:
        stat='UPR DEL'

if stat=='OK':
    #sprawdzenie poprawnoci zamwienia
    SQL="SELECT wyznacznik_id,stan FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
    SQL+=" AND data='"+Data+"' AND numer="+Nr+" FOR UPDATE NOWAIT;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat='Bdy zablokowania zamwienia :'+stat

if stat=='OK':
    Stan=DTest[0][1]
    
    # pobranie uprawnie do typw plikw
    STypow={}
    if self.operator_id <> STANDARD_OPERATOR_ID:
        SQL="SELECT DISTINCT typ_pliku,modyfikowac_w_zamknietym_zamowieniu "
        SQL+=" FROM rs_typy_plikow_zamowien_odb_upr WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
        stat,DTypy,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat='Bdy pobrania typw plikw, do ktrych operator ma uprawnienia :'+stat
            
        if stat=='OK':
            if len(DTypy)==0:
                stat= "Brak uprawnie do wywietlenia jakiegokolwiek typu dokumentu"
        
        if stat=='OK':
            for poz in DTypy:
                STypow[rsglobal.Dekoduj(poz[0])] = poz[1]
        
if stat=='OK':
    if len(DTest)==0:
        stat='BR ZAM'
    
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------
    
if Funkcja == 1:
    # sprawdzamy czy do tego typu operator ma uprawnienia
    if self.operator_id <> STANDARD_OPERATOR_ID:
        if not Typ in STypow:
            stat='Brak uprawnie operatora do dodawania typu pliku '+Typ
        elif Stan == 'Z':
            if not STypow[Typ]:
                stat='Brak uprawnie do modyfikacji plikw w zamknitych zamwieniach odbiorcw - dodawanie niemoliwe'
        
    if stat=='OK':
        #wstawiamy plik do bazy
        NrPoz = 'NULL'
        NrPPoz = 'NULL'
        NrZlec = 'NULL'
        if KluczZlecenia <> []:
            NrPoz = str(KluczZlecenia[3])
            NrPPoz = str(KluczZlecenia[4])
            NrZlec = "'"+str(KluczZlecenia[5])+"'"
            
        SQL="INSERT INTO rs_zamowienia_odbiorcy_pliki (firma_id,wyznacznik_id,data,numer,typ_pliku,nazwa,nr_poz,nr_ppoz,nr_zlec)"
        SQL+=" VALUES ('"+self.firma_id+"','"+Wyzn+"','"+Data+"',"+Nr+",'"+Typ+"','"+Plik+"',"+NrPoz+","+NrPPoz+","+NrZlec+");"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        
    if stat=='OK':
        # pobranie dodanego numeru pliku zamwienia odbiorcy
        SQL="SELECT MAX(plik_id) FROM rs_zamowienia_odbiorcy_pliki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        if len(DNum)==0:
            stat='PR DOD'
    
    if stat=='OK':
        PlikId=str(DNum[0][0])
        wyn2=PlikId
        
        # wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i poczenie klucza z obu tabel.
        SQL="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
        SQL+="('"+self.firma_id+"','"+Plik+"','rs_zamowienia_odbiorcy_pliki',FALSE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        
    if stat=='OK':
        SQL="SELECT max(plik_id) FROM rs_pliki WHERE firma_id='"+self.firma_id+"' AND tabela='rs_zamowienia_odbiorcy_pliki';"
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        NrPliku=str(DNum[0][0])
        #wrzucamy plik na serwer
        stat=fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)
    if stat=='OK':
        SQL="UPDATE rs_zamowienia_odbiorcy_pliki SET nr_pliku="+NrPliku+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND plik_id="+PlikId
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)

       
#-------------------------------------------------------------------------------
#---   POBRANIE PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------
    
if Funkcja in [2,6]:
    if stat=='OK':
        SQL="SELECT nr_pliku,typ_pliku FROM rs_zamowienia_odbiorcy_pliki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" AND plik_id="+PlikId
        
        stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        if len(DPlik)==0:
            stat="Brak pliku o numerze "+PlikId+" w zamwieniu odbiorcy "+Wyzn+'/'+Data+'/'+rsglobal.UsunKropkaZero(Nr)
        elif self.operator_id <> STANDARD_OPERATOR_ID:
            if not DPlik[0][1] in STypow:
                stat='Brak uprawnie operatora do typu pliku '+DPlik[0][1]
            else:
                Typ = DPlik[0][1]
 
#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if Funkcja == 2:   
    if stat=='OK':
        stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        dane=[Tresc]    
            
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 :
    # sprawdzamy czy do tego typu operator ma uprawnienia
    if self.operator_id <> STANDARD_OPERATOR_ID:
        rsglobal.ZapiszDoLogow('Test '+str(Typ in STypow),1)
        if not Typ in STypow:
            stat='Brak uprawnie operatora do usuwania typu pliku '+Typ
        elif Stan == 'Z':
            if not STypow[Typ]:
                stat='Brak uprawnie do modyfikacji plikw w zamknitych zamwieniach odbiorcw - usuwanie niemoliwe'
                
    if stat=='OK':
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        
    if stat=='OK':    
        SQL="DELETE FROM rs_zamowienia_odbiorcy_pliki WHERE plik_id="+PlikId+";"
        SQL+="DELETE FROM rs_pliki WHERE plik_id="+str(DPlik[0][0])
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
  
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 - select, 6 - delete, 1 - insert)
#-------------------------------------------------------------------------------

if (Funkcja in [1,5,6]) and (stat=='OK'):
    SQL="SELECT tp.opis,zp.nazwa,zp.opis,zp.plik_id"
    SQL+=" FROM rs_zamowienia_odbiorcy_pliki zp "
    SQL+=" INNER JOIN rs_typy_plikow_zamowien_odb tp ON (tp.firma_id=zp.firma_id AND tp.kod=zp.typ_pliku) "
    SQL+=" WHERE zp.firma_id='"+self.firma_id+"' AND zp.wyznacznik_id='"+Wyzn+"' AND zp.data='"+Data+"' AND zp.numer="+Nr
    if self.operator_id <> STANDARD_OPERATOR_ID:
        SQL+=" AND zp.typ_pliku IN ("+str(STypow.keys())[1:-1]+")"
    if KluczZlecenia <> []:
        SQL+=" AND zp.nr_poz="+str(KluczZlecenia[3])+" AND zp.nr_ppoz="+str(KluczZlecenia[4])
        SQL+=" AND zp.nr_zlec='"+KluczZlecenia[5]+"'"
    SQL+=" ORDER BY zp.nazwa"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)