#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pom.py
# Purpose:		funkcje wykorzystywane w zamowieniach odbiorcy
# Author:		Mariusz Rajfura
# Created:		2011/10/27 (mantis:5154)
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pom.py $
# Copyright:	(c) 2011 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

import rsglobal
from funkcje import fs_pliki_global

def PoziomZwrotowDlaKontrahenta(self, Kontrahent, Oddzial):
    dane = []
    sql ="SELECT TRIM(oddzial_id),procent_zwrotow_wartosc,procent_zwrotow"
    sql+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
    sql+=" WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND kontrahent_id='"+rsglobal.Dekoduj(Kontrahent)+"'"
    sql+=" AND artykul_id IS NULL AND oddzial_id IN ('"+Oddzial+"','**');"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o poziomach zwrotw: '+stat
        dane.append(stat)
        return stat,dane
    
    elif len(d) == 0:
        # brak danych o poziomie zwrotow
        dane = []
    elif len(d) == 1:
        # dane tylko dla jednego ze sprawdzanych oddzialow
        dane = [[d[0][1], d[0][2]]]
    elif rsglobal.Dekoduj(d[0][0]).strip() == rsglobal.Dekoduj(self.oddzial_id).strip():
        # dane oddzialu z dowodu na pozycji [0]
        dane = [[d[0][1], d[0][2]]]
    else:
        # dane oddzialu z dowodu na pozycji [1]
        dane = [[d[1][1], d[1][2]]]
    
    return stat,dane

#-------------------------------------------------------------------------------

def PoziomZwrotowDlaOdbiorcyZZamowieniaOdbiorcy(self, Wyznacznik, Data, Numer):
    # Pobranie informacji o poziomie zwrotow dla kontrahenta z zamowienia odbiorcy
    dane = []
    # pobranie kontrahenta z zamowienia
    sql ="SELECT kontrahent_id FROM rs_zamowienia_odbiorcy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania kontrahenta z zamwienia: '+stat
        return stat,dane
    
    elif len(d) == 0:
        stat = 'Brak zamowienia o podanym kluczu.'
        return stat,dane

    stat,dane = PoziomZwrotowDlaKontrahenta(self, d[0][0], self.oddzial_id)
    return stat,dane

#-------------------------------------------------------------------------------

def PoziomZwrotowDlaOdbiorcyZDowoduDostawy(self, Oddzial, Trasa, Data, TrybDostawy, Numer):
    # pobranie kontrahenta z dowodu
    sql="SELECT kontrahent_id FROM rs_dowody_dostaw"
    sql+=" WHERE firma_id='"+self.firma_id+"' "
    sql+=" AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"'"
    sql+=" AND tryb_dostawy='"+TrybDostawy+"' AND numer="+str(Numer)+";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania kontrahenta z dowodu dostawy: '+stat
    elif len(d) == 0:
        stat = 'Brak dowodu dostawy o podanym kodzie.'

    stat,dane = PoziomZwrotowDlaKontrahenta(self, d[0][0], Oddzial)
    return stat,dane

#-------------------------------------------------------------------------------

def UsunPlikiZamowienia(self,Wyzn,Data,Numer,NrPoz=-1,NrPPoz=-1,NrZlec=''):
    # pobranie listy plikw do usunicia
    SQL="SELECT nr_pliku,typ_pliku,plik_id FROM rs_zamowienia_odbiorcy_pliki WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND wyznacznik_id = '"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)
    if NrPoz <> -1:
        SQL+=" AND nr_poz = "+str(NrPoz)
    if NrPPoz <> -1:
        SQL+=" AND nr_ppoz = "+str(NrPPoz)
    if NrZlec <> '':
        SQL+=" AND nr_zlec LIKE '"+str(NrZlec)+"%'"

    stat,DPliki,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bdy pobierania listy plikw do usunicia: '+stat
    
    if len(DPliki) == 0:
        return 'OK'
    
    # pobranie typw do ktrych operator ma uprawnienia
    UprDel=((self.oddzial_id,'024074') in self.uprawnienia) or (self.operator_id == '0')
    if not UprDel:
        return u'Brak uprawnie do usuwania plikw przypitych do zamwienia'
    
    # pobranie stanu zamwienia
    SQL="SELECT stan FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND wyznacznik_id = '"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bdy zablokowania zamwienia :'+stat
        
    Stan = DTest[0][0]
    
    # pobranie uprawnie do typw plikw
    STypow={}
    if self.operator_id <> '0':
        SQL="SELECT DISTINCT typ_pliku,modyfikowac_w_zamknietym_zamowieniu "
        SQL+=" FROM rs_typy_plikow_zamowien_odb_upr WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
        stat,DTypy,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return 'Bdy pobrania typw plikw, do ktrych operator ma uprawnienia :'+stat
            
        if len(DTypy)==0:
            return "Brak uprawnie do usunicia jakiegokolwiek typu dokumentu"
        
        for poz in DTypy:
            STypow[rsglobal.Dekoduj(poz[0])] = poz[1]
        
    # sprawdzenie czy operator ma do tego uprawnienia
        for plik in DPliki:
            Typ = plik[1]
            if not Typ in STypow:
                return u'Brak uprawnie operatora do usuwania typu pliku '+Typ
            elif Stan == 'Z':
                if not STypow[Typ]:
                    return u'Brak uprawnie do modyfikacji plikw w zamknitych zamwieniach odbiorcw - usuwanie niemoliwe'
                
    # faktyczne usunicie wszystkich plikw
    for plik in DPliki:
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,plik[0])
        if stat <> 'OK':
            return u'Wystpi bd usunicia pliku binarnego '+str(plik[0])+' z serwera: '+stat
        
        
        SQL="DELETE FROM rs_zamowienia_odbiorcy_pliki WHERE plik_id="+str(plik[2])+";"
        SQL+="DELETE FROM rs_pliki WHERE plik_id="+str(plik[0])
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat <> 'OK':
            return u'Wystpi bd usunicia pliku '+str(plik[2])+' z serwera: '+stat
    
    return 'OK'