#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje.py
# Purpose:		dodaje/pobiera/usuwa zamowienia odbiorcy
# Author:		Marcin Grzeda
# Created:		2007/01/20
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------
# 06.04.2009 Dariusz Boduch (1960) automatyczna zmiana stanu ZO na 'Z' kiedy zamwienie jest zrealizowane poprzez anulowanie
# 2010-11-25 Marcin Natkaski (4085) blokada modyfikacji wierszy dla zamwie ze stanem <> W 
# 2011-01-25 Mariusz Rajfura (4225) dodanie pol: wyprodukowano1, wyprodukowano2 
# 2011-09-29 Mariusz Rajfura (5032) refaktoring okna 
# 2011-10-27 Mariusz Rajfura (5154) info o poziomie zwrotow dla kontrahenta 
# 2013-04-05 Mariusz Rajfura (6759) rozdzielenie kolumny artykulu z opisem na artykul i opis


from funkcje import fs_zamowienia_odbiorcy_pom

Wyznacznik = klucze[0]
Data=klucze[1]
Numer=klucze[2]
Art=klucze[3]
Tryb=klucze[4]
Cena=klucze[5]
DwieJednMiar=klucze[6]
NrPoz=klucze[7]
NrPpoz=klucze[8]

Fun=klucze[-1]
stat = "OK" 
dane = []
wyn1 = []
wyn2 = []
puste_pola = [[],"","    -  -  "]

if Fun<>11:
    if (Wyznacznik in puste_pola) and (stat== 'OK'):
        stat="BR_WYZ"
        dane.append(stat)
    if (Data in puste_pola) and (stat== 'OK'):
        stat="BR_DAT"
        dane.append(stat)
    if (Numer in puste_pola) and (stat== 'OK'):
        stat="BR_NR"
        dane.append(stat)

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

if self.operator_id != STANDARD_OPERATOR_ID:
    UprUsuwanie=(self.oddzial_id,'024024') in self.uprawnienia
    UprPrzegl=(self.oddzial_id,'024020') in self.uprawnienia
    UprPrzeglWal=(self.oddzial_id,'011130') in self.uprawnienia
    UprUpd=(self.oddzial_id,'024022') in self.uprawnienia
    UprAnul=(self.oddzial_id,'024026') in self.uprawnienia
    LPrz=LWyzn
    LPrz.append('ZASLEPKA')
    LUpd=[]
    LDel=[]
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    
         
    if UprUpd and (Fun in [5,6,8]):
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LUpd=rsglobal.rseval(wyzn[0][0])[1]
        
    if stat=='OK':
        if UprUsuwanie and (Fun in [6]):
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LDel=rsglobal.rseval(wyzn[0][0])[1]
else:
    UprUsuwanie = UprPrzegl = UprPrzeglWal = UprAnul = UprUpd = True
    LPrz=LWyzn
    LPrz.append('ZASLEPKA')
    LUpd=LWyzn
    LDel=LWyzn


#-------------------------------------------------------------------------------
# Pobranie informacji o poziomie zwrotow dla kontrahenta (15)
#-------------------------------------------------------------------------------

if Fun == 15 and stat == 'OK':
    stat,dane = fs_zamowienia_odbiorcy_pom.PoziomZwrotowDlaOdbiorcyZZamowieniaOdbiorcy(self,Wyznacznik,Data,Numer)

   
#-------------------------------------------------------------------------------
#---  ANULOWANIE POZYCJI (8)
#-------------------------------------------------------------------------------
       
if (Fun == 8) and (stat== 'OK'):
    if not UprAnul:
        stat='UPR ANUL'
        dane.append(stat)
    if stat=='OK':
        SQL="SELECT stan FROM rs_zamowienia_odbiorcy WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer = "+Numer+";"
        stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        elif len(d)==0:
            stat='BL KLUCZ'
            dane.append(stat)
        elif d[0][0] not in ('W','G'):
            stat='BL STAN ANUL'
            dane.append(stat)

    if stat=='OK':
        Anulowano = klucze[9]
        Select="SELECT z.dostarczono1,z.artykul_id,art.przelicznik,z.ilosc1,z.anulowano1 "
        Select+=" FROM rs_zamowienia_odbiorcy_pozycje z "
        Select+=" INNER JOIN rs_artykuly art ON (z.firma_id = art.firma_id AND z.artykul_id = art.artykul_id) "
        Select+=" WHERE z.firma_id='"+self.firma_id+"' AND z.wyznacznik_id = '"+Wyznacznik+"'"
        Select+=" AND z.data = '"+Data+"' AND z.numer = "+str(Numer)
        Select+=" AND z.nr_poz="+str(NrPoz)+" AND z.nr_ppoz = "+NrPpoz+";" 
        stat,d_z,dump,dump=self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat='BL SEL ANUL'
            dane.append(stat)
            
    if stat=='OK':
        if len(d_z)==0:
            stat='BR POZ ANUL'
            dane.append(stat)
        
    if stat=='OK':
        Dostarczono=d_z[0][0]
        Przelicznik=d_z[0][2]
        Ilosc1=d_z[0][3]
        AnulowanoStare=d_z[0][4]
        if Ilosc1-Dostarczono<Anulowano:
            stat='BL IL ANUL'
            dane.append(stat)
        
    if stat=='OK':    
        Anulowano2=round(Anulowano*Przelicznik,2)
        Update="UPDATE rs_zamowienia_odbiorcy_pozycje SET anulowano1="+str(Anulowano)+","
        Update+=" anulowano2="+str(Anulowano2)+" WHERE firma_id='"+self.firma_id+"'"
        Update+=" AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)
        Update+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz = "+NrPpoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
        if stat!="OK":
            stat="BL UPD ANUL"
            dane.append(stat)
            
        #------------------------------------------------
        # ewentualne anulowanie rezerwacji podpitych do pozycji
        #------------------------------------------------
    if stat=='OK':
        IleAnulowac=Anulowano-AnulowanoStare
        if IleAnulowac>0:
            # pobranie potencjalnych rezerwacji do anulowania
            SQL="SELECT ar.rezerwacja_id,ar.artykul_id,a.przelicznik,ar.magazyn_id,"
            SQL+=" ar.rezerwacja,ar.zrealizowano FROM rs_artykuly_rezerwacje ar "
            SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id_z='"+Wyznacznik+"'"
            SQL+=" AND data_z = '"+Data+"' AND numer_z = "+str(Numer)
            SQL+=" AND nr_poz_z="+str(NrPoz)+" AND nr_ppoz_z = "+NrPpoz
            SQL+=" AND rezerwacja-zrealizowano >0 ORDER BY rezerwacja_id"
            SQL+=" FOR UPDATE NOWAIT;"
            stat,DaneRez,dump,dump = self.PolSQL.Execute(SQL,3)
            
            if stat=='OK':
                #sprawdzenie, czy anulowana ilosc wymaga zmniejszenia
                #ilosci na rezerwacjach
                
                SumaRez = 0
                for poz in DaneRez:
                    SumaRez += poz[4] - poz[5]
                
                #biezacy stan zamowienia po uwzglednieniu anulacji
                sql ="SELECT ilosc1-dostarczono1-anulowano1"
                sql+=" FROM rs_zamowienia_odbiorcy_pozycje"
                sql+=" WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                sql+=" AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz="+NrPpoz+";"
                stat,DoRealizacji,dump,dump = self.PolSQL.Execute(sql,2)
                if stat <> 'OK':
                    stat = 'Bd pobrania nowych danych zamwienia: '+stat
                    dane.append(stat)

                if stat == 'OK' and SumaRez > DoRealizacji[0][0]:
                    #jesli na rezerwacjach wiecej niz do realizacji
                    DoWycofaniaZRez = SumaRez - DoRealizacji[0][0]

                    SQL = ''
                    for poz in DaneRez:
                        Zmniejszyc = min(DoWycofaniaZRez,poz[4]-poz[5])
                        if Zmniejszyc > 0:
                            #zmiana w rezerwacji
                            SQL+="UPDATE rs_artykuly_rezerwacje SET rezerwacja=rezerwacja-"+str(Zmniejszyc)
                            
                            if Zmniejszyc == poz[4]-poz[5]:
                                #jesli po zmniejszeniu rezerwacja bedzie zerowa, to zamykamy ja
                                #i odlaczamy ja od pozycji dokumentu
                                SQL+=", zamknieta=True, wyznacznik_id_z=NULL"
                                SQL+=", data_z=NULL, numer_z=NULL, nr_poz_z=NULL, nr_ppoz_z=NULL"
                            
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND rezerwacja_id="+str(poz[0])+";"
                            # zmiana rezerwacji w magazynach
                            SQL+="UPDATE rs_artykuly_magazyny SET rezerwacja1=rezerwacja1-"+str(Zmniejszyc)
                            SQL+=",rezerwacja2=rezerwacja2-"+str(rsglobal.RSRound(Zmniejszyc*poz[2],2))     
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(poz[3])+"' AND artykul_id='"+str(poz[1])+"';"
                            SQL+="UPDATE rs_artykuly SET rezerwacja1=rezerwacja1-"+str(Zmniejszyc)
                            SQL+=",rezerwacja2=rezerwacja2-"+str(rsglobal.RSRound(Zmniejszyc*poz[2],2))     
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(poz[1])+"';" 
                            
                        DoWycofaniaZRez -= Zmniejszyc
                        if DoWycofaniaZRez == 0:
                            exit
                            
                    if SQL <> '':
                        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                        if stat <> 'OK':
                            stat = 'Bd aktualizacji rezerwacji: '+stat
                            dane.append(stat)
                    
    if stat=='OK':
        #------------------------------------------------
        #sprawdzanie czy po anulowaniu mozna zamknac zamowienie 
        #------------------------------------------------
        Sql_spr = " SELECT count(*) FROM rs_zamowienia_odbiorcy_pozycje WHERE "
        Sql_spr += " firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" "
        Sql_spr += " and ilosc1 - dostarczono1 - anulowano1 > 0 "
        stat,danespr,dump,dump = self.PolSQL.Execute(Sql_spr,3)
        if stat!='OK':
            stat="BL SQL SPR ZAM"
            dane.append(stat)
            
    if stat=='OK':
        if danespr[0][0] == 0:
            UPDStan = "UPDATE rs_zamowienia_odbiorcy set stan='Z' "
            UPDStan += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' "
            UPDStan +=" AND data = '"+Data+"' AND numer = "+str(Numer)+" "
            stat,dump,dump,dump=self.PolSQL.Execute(UPDStan,1)
            if stat !='OK':
                stat="BL UPDSTAN"
                dane.append(stat)
   

#-------------------------------------------------------------------------------
# -- usuwanie (6)
#-------------------------------------------------------------------------------

if (Fun == 6) and (stat== 'OK'):
    if not (UprUsuwanie and (Wyznacznik in LDel)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat="BR_UPR_DEL"
        dane.append(stat)
    # Sprawdzanie stanu zamwienia przed usuniciem pozycji
    sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
    sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    sprSql +=" AND stan='W' AND numer="+Numer+" FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)
    if stat<>'OK':
        stat="Bdy zapytania sprawdzajcego stan zamwienia przed usuniciem danych "+stat
        dane.append(stat)
    elif len(d)==0:
        stat='STAN G'
        dane.append(stat)   
    #---
    if stat=='OK':
        # jeli na rezerwacjach co zrealizowano to nie mona usun pozycji
        SQL="SELECT * FROM rs_artykuly_rezerwacje WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND wyznacznik_id_z='"+Wyznacznik+"' AND data_z='"+Data+"'"
        SQL+=" AND numer_z="+Numer+" AND nr_poz_z="+NrPoz+" AND nr_ppoz_z="+NrPpoz
        SQL+=" AND zrealizowano>0;"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(DTest)>0:    
            stat="DEL REZER"
            dane.append(stat)
        
    if stat=='OK':
        #usuwamy rezerwacje i zdejmujemy je z magazynw
        SQL="SELECT ar.artykul_id,ar.magazyn_id,a.przelicznik,ar.rezerwacja-ar.zrealizowano"
        SQL+=" FROM rs_artykuly_rezerwacje ar INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+=" WHERE ar.firma_id='"+self.firma_id+"' AND ar.wyznacznik_id_z='"+Wyznacznik+"' AND ar.data_z='"+Data+"'"
        SQL+=" AND ar.numer_z="+Numer+" AND ar.nr_poz_z="+NrPoz+" AND ar.nr_ppoz_z="+NrPpoz
        SQL+=" AND ar.rezerwacja-ar.zrealizowano>0;"
        stat,DRezer,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        SQL=''
        for poz in DRezer:
            SQL+="UPDATE rs_artykuly_magazyny SET rezerwacja1=rezerwacja1-"+str(poz[3])
            SQL+=",rezerwacja2=rezerwacja2-"+str(rsglobal.RSRound(poz[3]*poz[2],2))     
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(poz[1])+"' AND artykul_id='"+str(poz[0])+"';"
            SQL+="UPDATE rs_artykuly SET rezerwacja1=rezerwacja1-"+str(poz[3])
            SQL+=",rezerwacja2=rezerwacja2-"+str(rsglobal.RSRound(poz[3]*poz[2],2))     
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(poz[0])+"';" 
        
        if SQL<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            
    # usuwamy pliki przypite do pozycji zamwienia
    if stat == 'OK':
        stat = fs_zamowienia_odbiorcy_pom.UsunPlikiZamowienia(self,Wyznacznik,Data,Numer,NrPoz,NrPpoz,'')
    
    # usuwamy pozycje
    if stat=='OK':
        Delete="DELETE FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+Numer+" AND nr_poz = "+NrPoz+" AND nr_ppoz = "+NrPpoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
        if stat!="OK":
            stat="BL_DEL"
            dane.append(stat)
            
    if stat=='OK':
        Update="UPDATE rs_zamowienia_odbiorcy_pozycje SET nr_poz=nr_poz-1 WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+Numer+" AND nr_poz > "+NrPoz+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
        if stat!="OK":
            stat="BL_UPD"
            dane.append(stat)

    
#-------------------------------------------------------------------------------
# -- pobieranie waluty 11, 5, 6
#-------------------------------------------------------------------------------

if (Fun in [11,5,6,8]) and (stat=='OK'):
    Sql="SELECT waluta FROM rs_zamowienia_odbiorcy WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer = "+Numer+";"
    dane=self.PolSQL.Execute(Sql,3)[1]
    if len(dane)==0:
        stat="BR_WAL"
    else:
        Waluta=dane[0][0]
        if Waluta<>'PLN':
            if not UprPrzeglWal:
                stat='BR_UPR_PRZ_WAL'
                dane.append(stat)
        
        if Fun==11 and stat=='OK':
            dane=Waluta                


#-------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6, anulowanie 8-- #
#-------------------------------------------------------------------------------

if (Fun in [5,6,8]) and (stat=='OK'):
    if not (UprPrzegl and (Wyznacznik in LPrz)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat="BR_UPR_PRZ"
        dane.append(stat)
    if stat=='OK':    
        if Waluta=='':
            stat="BR_WAL"

    if stat=='OK':    
        pola = "zop.nr_poz,zop.nr_ppoz,zop.artykul_id,art.nazwa,"
        pola+= "COALESCE(zop.cecha1_opis,''),COALESCE(zop.cecha1_wartosc,''),"
        pola+= " rsf_podaj_parametry_cechy(zop.firma_id,zop.cecha1_opis,zop.cecha1_wartosc,'opis'),"
        pola+= " zop.tryb_dostawy,zop.ilosc1,zop.cena_upust1"
        pola+=",zop.cena_upust_wal1"
        pola+=",zop.wartosc_netto"
        pola+=",zop.wartosc_wal_netto"
        pola+=",zop.dostarczono1,zop.anulowano1,SUM(ar.rezerwacja-ar.zrealizowano),zop.data_od,zop.data_do"
        pola+=",zop.ilosc2,zop.cena_upust2"
        pola+=",zop.cena_upust_wal2"
        pola+=",zop.dostarczono2,zop.anulowano2,ROUND(SUM(ar.rezerwacja-ar.zrealizowano)*art.przelicznik,4)"

        PolaGroupBy=pola
        PolaGroupBy=PolaGroupBy.replace(',ROUND(SUM(ar.rezerwacja-ar.zrealizowano)*art.przelicznik,4)','')
        PolaGroupBy=PolaGroupBy.replace(',SUM(ar.rezerwacja-ar.zrealizowano)','')
        PolaGroupBy+=",art.przelicznik,zop.z_op_id||'-'||o.login, zop.z_czas "
        pola += ",SUM(zop.wyprodukowano1)"
        pola += ",SUM(zop.wyprodukowano2)"
        
        pola+=",zop.artykul_id || ' - ' || art.nazwa,"
        pola+=" zop.z_op_id||'-'||o.login, zop.z_czas "
    
        Filtr = "(zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id='"+Wyznacznik+"' AND zop.data='"+Data+"' AND zop.numer="+str(Numer)+" "
        if Art <> '':
            Filtr = Filtr+"AND zop.artykul_id LIKE '"+Art+"%'"
        if Tryb <> '':
            Filtr = Filtr+"AND zop.tryb_dostawy='"+Tryb+"'"
        if Cena <> '' and Cena <> 0:
            Filtr = Filtr+"AND (zop.cena1="+Cena+" OR zop.cena2="+Cena+") "
        Filtr = Filtr+')'
    
        Select="SELECT "+pola+" FROM rs_zamowienia_odbiorcy_pozycje zop "
        Select+=" INNER JOIN rs_artykuly art ON (zop.firma_id = art.firma_id AND zop.artykul_id = art.artykul_id) "
        Select+=" LEFT OUTER JOIN rs_artykuly_rezerwacje ar ON "
        Select+=" (zop.firma_id = ar.firma_id AND zop.wyznacznik_id = ar.wyznacznik_id_z AND zop.data=ar.data_z AND zop.numer=ar.numer_z"
        Select+=" AND zop.nr_poz=ar.nr_poz_z AND zop.nr_ppoz=ar.nr_ppoz_z AND NOT ar.zamknieta) "
        Select+=" INNER JOIN rs_operatorzy o ON zop.z_op_id = o.operator_id"
        Select+=" WHERE "+Filtr+" GROUP BY "+PolaGroupBy+" ORDER BY zop.nr_poz,zop.nr_ppoz;"
        stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
        
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji zamwienia: '+stat
            dane.append(stat)
        
        if stat == 'OK':
            sql ="SELECT czy_stale,stan"
            sql+=" FROM rs_zamowienia_odbiorcy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
            sql+=" AND data='"+Data+"' AND numer="+Numer+";"
            stat,d,dump,dump=self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych z nagwka zamowienia: '+stat
                dane.append(stat)
            elif len(d) > 0:
                # czy stale (0)
                wyn2.append(d[0][0])
                # biezacy stan (1)
                wyn2.append(d[0][1])

        if stat == 'OK':
            # pobranie informacji o uprawnieniach do trasy (1)
            SQL = "SELECT rsf_podaj_uprawnienia_do_zamowienia_wzgledem_tras('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+")"
            stat,DTras,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = u"Wystpiy bdy sprawdzania uprawnie operatora do tras : "+stat
            else:
                wyn2.append(eval(DTras[0][0]))