# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji zamowienia odbiorcy
# Author:      Marcin Grzeda
# Created:     2007/03/22
# RCS-ID:      $Id:$
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2010-11-25 Marcin Natkaski (4085) blokada modyfikacji wierszy dla zamwie ze stanem <> W 
# 2011-10-07 Mariusz Rajfura (5073) blokada modyfikacji dla stanu <> 'W' 
# 2011-10-28 Mariusz Rajfura (5154) info o typie jednostek miar (czy calkowite) 
# 2014-06-11 Micha Raburski (7925) cechy w pozycjach zamwienia
# 2021-12-08 Wojciech Skowron (12745) obsuga stawki VAT w sprawdzaniu danych

Wyznacznik=rsglobal.Dekoduj(klucze[0]) 
Data=rsglobal.Dekoduj(klucze[1]) 
Numer=rsglobal.Dekoduj(klucze[2]) 
Poz=rsglobal.Dekoduj(klucze[3]) 
Ppoz=rsglobal.Dekoduj(klucze[4]) 
Ilosc1=rsglobal.Dekoduj(klucze[5]) 
Ilosc2=rsglobal.Dekoduj(klucze[6]) 
ArtykulId=rsglobal.Dekoduj(klucze[7]) 
Funkcja=klucze[-1]

stat='OK'

#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci

puste_pola = [[],"","    -  -  "]

LEdy=[]
LIns=[]

rsglobal.ZapiszDoLogow('0 datam',1)
if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    rsglobal.ZapiszDoLogow('1 '+sql,1)
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    rsglobal.ZapiszDoLogow('2 '+stat,1)
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    if LWyzn==[]:
        stat='BR LWYZN'
        
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprEdycja=True
        UprInsert=True
        LEdy=LWyzn
        LIns=LWyzn
    else:
        UprEdycja = ((self.oddzial_id,'024022') in self.uprawnienia)
        UprInsert = ((self.oddzial_id,'024023') in self.uprawnienia) 
        
        if UprEdycja and (Funkcja in [3,4]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]
        
        if UprInsert and (Funkcja in [1,2]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LIns=rsglobal.rseval(wyzn[0][0])[1]        


#-------------------------------------------------------------------------------
# Sprawdzanie waluty (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat=='OK': #sprawdzam walute
    dane=[]
    sql = "SELECT waluta,kurs,upust,wersja FROM rs_zamowienia_odbiorcy WHERE firma_id='%s' AND wyznacznik_id = '%s' AND data = '%s' AND numer = %s;" % (self.firma_id,Wyznacznik,Data,Numer)
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    


#-------------------------------------------------------------------------------
# Pobranie numeru nowej pozycji (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat=='OK': # warunek
    dane=[]
    wyn2=[]
    sql = "SELECT nr_poz FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data = '"+Data+"' AND numer="+Numer+" ORDER BY nr_poz DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    
    if len(dane)==0:
        dane = 1
    else:
        dane = int(dane[0][0]) + 1
    
    if stat=='OK':
        # pobranie stanu - dodatkowe sprawdzenie czy
        sql ="SELECT stan FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,dStan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania stanu zamwienia: '+stat
        elif len(dStan) == 0:
            stat = 'Brak zamwienia o podanym kluczu.'
        else:
            wyn2.append(dStan[0][0])

    if stat == 'OK':
        SQL = "SELECT rsf_podaj_uprawnienia_do_zamowienia_wzgledem_tras('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+str(Numer)+")"
        stat,DTras,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = u"Wystpiy bdy sprawdzania uprawnie operatora do tras : "+stat
        else:
            wyn2.append(eval(DTras[0][0]))



#-------------------------------------------------------------------------------
# Pobranie informacji o jednostakch miar i przeliczniku (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat=='OK':
    dane = []
    sql ="SELECT a.przelicznik,a.jm1,COALESCE(a.jm2,''::TEXT),j1.calkowita,j2.calkowita"
    sql+=" FROM rs_artykuly a"
    sql+=" LEFT JOIN rs_jednostki_miar j1 ON (j1.firma_id=a.firma_id AND j1.kod=a.jm1)"
    sql+=" LEFT JOIN rs_jednostki_miar j2 ON (j2.firma_id=a.firma_id AND j2.kod=a.jm2)"
    sql+=" WHERE a.artykul_id='"+Wyznacznik+"' AND a.firma_id='"+self.firma_id+"';"
    
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)


#-------------------------------------------------------------------------------
# Pobranie listy trybow dostawy (12)
#-------------------------------------------------------------------------------

if Funkcja == 12 and stat=='OK':
    sql = "SELECT kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy trybw dostaw: '+stat

#-------------------------------------------------------------------------------
#   pobranie informacji o cechach (25)
#-------------------------------------------------------------------------------

if (Funkcja == 25) and stat=='OK': 
    # wraca [cecha, opis cechy, liczba wartoci, domylna warto]
    Artykul= str(klucze[0])
    SQL ="SELECT TRIM(COALESCE(cecha1_opis,'')) FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,DCecha,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = u'Bdy pobierania danych cechy artykuu : '+stat
    if stat == 'OK':
        if len(DCecha)==0:
            dane=['','',0,'']
        elif DCecha[0][0] == '':
            dane=['','',0,'']
        else:
            dane.append(DCecha[0][0])
        
            SQL = "SELECT TRIM(COALESCE(opis,'')) FROM rs_artykuly_cechy WHERE firma_id='"+self.firma_id+"' AND kod='"+DCecha[0][0]+"';"
            stat,DOpisyCechy,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd pobrania opisu cechy artykuu : '+stat
            elif len(DOpisyCechy) == 0:
                stat = 'Brak cechy '+DCecha[0][0].strip()+' wystpujcej na artykule '+Artykul.strip()
            else:
                dane.append(DOpisyCechy[0][0])
    
            if stat == 'OK':
                SQL="SELECT lp,wartosc,domyslna FROM rs_artykuly_cechy_wartosci WHERE firma_id='"+self.firma_id+"' AND kod='"+DCecha[0][0]+"' ORDER BY lp,wartosc,domyslna"
                stat,DWartCechy,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania wartoci cechy artykuu : '+stat
                else:
                    dane.append(len(DWartCechy))
                    
                Dom=True    
                Domyslna=''
                Wczesniejsza = 0
                for poz in DWartCechy:
                    if Wczesniejsza <> poz[0]:
                        if not Dom:
                            Domyslna=''
                            break
                        Dom=False
                        Wczesniejsza=poz[0]
                        if poz[2]:
                            Domyslna+=poz[1].strip()
                            Dom =True
                    else:
                        if poz[2]:
                            Domyslna+=poz[1].strip()
                            Dom =True
                dane.append(Domyslna)


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-----------------------------------------------------------------------------

if Funkcja in [1,2,3,4] and stat=='OK':
    from funkcje import fs_artykuly_pom
    if stat=='OK':
        DataOdSp=''
        DataDoSp=''
        Kontr = ''
        Platnik = ''
        StawkaVAT = None  #WS 2021-12-08

        if Data not in puste_pola:
            dane_wyn = rsglobal.SprawdzCzyToData(Data)   
            if not dane_wyn:
                stat = "BL KLUCZ"
            else:
                sql="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+self.oddzial_id+"','"+Data+"',1);"
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                if dane_wyn <> 1:
                    stat="ZK DATA"
                    dane_wyn.append(stat)
            Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
            sql="SELECT wyznacznik_id,COALESCE(kontrahent_id,''),COALESCE(platnik_id,'') FROM rs_zamowienia_odbiorcy WHERE "+Filtr+";"
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
            if len(dane_wyn) == 0:
                stat = "BL KLUCZ"
                dane.append(stat)
            else:
                Kontr = dane_wyn[0][1]
                Platnik = dane_wyn[0][2]
        else:
            stat = "BL KLUCZ"
            dane.append(stat)
        
        if stat == "OK":
            dane = []
            NrPoz = Poz
            i = 0
            art_id = None
            if 'artykul_id' not in Pola and ('nr_serii' in Pola or 'termin_przyd' in Pola):
                sql = "SELECT artykul_id FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)+";"
                dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3)
                if Dane in puste_pola:
                    stat = "BL ART"
                    dane.append(stat)
                else:
                    art_id = Dane[0][0]
            
            DataOdSp=''
            DataDoSp=''
            CechaArt=''
            Cecha=''
            CechaWart=''
            if Funkcja in [3,4]:
                SQL="SELECT zop.data_od,zop.data_do,TRIM(COALESCE(a.cecha1_opis,'')),TRIM(COALESCE(zop.cecha1_opis,'')),"
                SQL+=" TRIM(COALESCE(zop.cecha1_wartosc,'')) FROM rs_zamowienia_odbiorcy_pozycje zop"
                SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                SQL+=" WHERE zop.firma_id='"+self.firma_id+"' AND zop.wyznacznik_id='"+Wyznacznik+"' AND zop.data='"+Data+"'"
                SQL+=" AND zop.numer="+Numer+" AND zop.nr_poz="+str(Poz)+" AND zop.nr_ppoz="+str(Ppoz)
                stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat <> 'OK':
                    stat = "Bd pobierania danych artykuu z pozycji zamwienia"
                    dane.append(stat)
                
                elif len(d)>0:
                    if d[0][0] in puste_pola:
                        DataOdSp=''
                    else:
                        DataOdSp=d[0][0]
                    if d[0][1] in puste_pola:
                        DataDoSp=''
                    else:
                        DataDoSp=d[0][1]
                  
                    CechaArt=d[0][2]
                    Cecha=d[0][3]
                    CechaWart=d[0][4]      
            
            
            SPR_ART=True   
            for pole in Pola:
                wart = Wartosci[i]
                if pole=='nr_poz':
                    if wart < 1:
                        stat = "BL NRPOZYCJI"
                        dane.append(stat)
                    sql = "SELECT nr_poz FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(wart)+";"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane <> []:
                        stat = "BR NRPOZYCJI"
                        dane.append(stat)
                elif pole == 'artykul_id':
                    if wart == '':
                        stat = "BR ART"
                        dane.append(stat)
                    sql = "SELECT artykul_id,aktywny,TRIM(COALESCE(cecha1_opis,'')),"
                    sql+=" rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+wart+"','"+Kontr+"','"+Platnik+"','"+Data+"') " # data zamwienia jest graniczna i by byo ok powinna by wyliczonym limitem
                    sql+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = "BL ART"
                        dane.append(stat)
                        SPR_ART=False #dodatkowa zmienna (zeby nie sprawdzac innych danych po artykule)
                    elif not Dane[0][1]:
                        stat = "ART AKT"
                        dane.append(stat)
                        SPR_ART=False
                    elif Data > Dane[0][3]: # jeli limit krtszy od daty
                        stat = "ART LIMIT$"+Kontr
                        dane.append(stat)
                        SPR_ART=False
                    else:
                        art_id = wart
                        CechaArt = Dane[0][2]
                        SPR_ART=True
                        
                elif pole == 'data_od':
                    if wart in puste_pola:
                        DataOdSp=''
                    else:
                        if not rsglobal.SprawdzCzyToData(wart):
                            stat= "BL DAT OD"
                            dane.append(stat)
                            DataOdSp=''
                        else:
                            DataOdSp=wart
                elif pole == 'data_do':
                    if wart in puste_pola:
                        DataDoSp=''
                    else:
                        if not rsglobal.SprawdzCzyToData(wart):
                            stat= "BL DAT DO"
                            dane.append(stat)
                            DataDoSp=''
                        else:
                            DataDoSp=wart
                elif pole == 'ilosc1':
                    if wart <= 0:
                        stat = "BL ILOSCART1"
                        dane.append(stat)
                elif pole == 'ilosc2':
                    if wart <= 0:
                        stat = "BL ILOSCART2"
                        dane.append(stat)
                #WS 2021-12-08
                elif pole == 'stawka_vat':
                    wart = rsglobal.Dekoduj(wart).strip()
                    StawkaVAT = wart
                    if wart == '':
                        stat = 'BR STAWKA_VAT'
                        dane.append(stat)
                    else:
                        sql ="SELECT kod FROM rs_stawki_vat WHERE kod='"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia stawki VAT: '+stat
                            dane.append(stat)
                        elif len(d) == 0:
                            stat = 'BL STAWKA_VAT'
                            dane.append(stat)
                elif pole == 'cena_netto1':
                    if wart < 0:
                        stat = "BL CENANETTO1"
                        dane.append(stat)
                elif pole == 'cena_netto2':
                    if wart < 0:
                        stat = "BL CENANETTO2"
                        dane.append(stat)
                elif pole == 'cena_brutto1':
                    if wart < 0:
                        stat = "BL CENABRUTTO1"
                        dane.append(stat)
                elif pole == 'cena_brutto2':
                    if wart < 0:
                        stat = "BL CENABRUTTO2"
                        dane.append(stat)
                elif pole == 'termin_przyd' and SPR_ART:
                    sql = "SELECT czy_termin FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(art_id)+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = "BR ART"
                        dane.append(stat)

                    if wart in puste_pola:
                        if Dane[0][0]: #czy termin
                            stat = "BR TERMIN"
                            dane.append(stat)
                    elif not rsglobal.SprawdzCzyToData(wart):
                        stat = "BL TERMIN"
                        dane.append(stat)
                elif pole == 'tryb_dostawy':
                    sql= "SELECT * FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"' "
                    st,D,dump,dump =self.PolSQL.Execute(sql,3)
                    if st<>'OK':
                        stat='BL SEL TRYB'
                        dane.append(stat)
                    elif len(D)==0:
                        stat='BL TRYB'
                        dane.append(stat)
                elif pole == 'cecha1_opis':
                    Cecha = wart.strip()                   
                elif pole == 'cecha1_wartosc':
                    CechaWart = wart.strip()           
                i= i+1
            
            if DataOdSp<>'' and DataDoSp<>'':
                if DataOdSp>DataDoSp:
                    stat= "BL DAT OD DO"
                    dane.append(stat)
                
    # sprawdzenie spjnoci informacji o cechach
    if stat == 'OK' :
        # jeli opis cechy pozycji inny ni artykuu
        if Cecha <> CechaArt:
            stat = 'BL CECHA'
            dane.append(stat)
        else:
            SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','poprawna')"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia wartoci cechy: '+stat
            else:
                Wynik=eval(d[0][0])
                if not Wynik[0]:
                    stat = Wynik[1]
                    dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
            
    #sprawdzenie co do iloci opakowa dla artykuu  
    if stat == 'OK':
        SQL ="SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_zamowienia_odbiorcy "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
        SQL+="AND data='"+Data+"' AND numer="+Numer+";"
        stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd przy pobieraniu kontrahenta do sprawdzenia opakowa z zamowie'
                         
    if stat == 'OK':         
       stat,SOpakArt = fs_artykuly_pom.PodajOpakowaniaDlaArtykulu(self,ArtykulId,Ilosc1,DKontr[0][0],CechaWart,'',1)
       if stat <> 'OK':
           dane.append(stat)

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,1]:
    if not (UprInsert and (Wyznacznik in LIns)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR INS'
        dane.append(stat)
    if stat=='OK':
        sql = "INSERT INTO rs_zamowienia_odbiorcy_pozycje"
        PolaN="firma_id,wyznacznik_id,data,numer"
        WartosciN = "'"+self.firma_id+"','"+Wyznacznik+"','"+Data+"','"+Numer+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id','nr_serii','stawka_vat','cecha1_opis','cecha1_wartosc']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['termin_przyd','data_od','data_do','tryb_dostawy']:
                PolaN += ","+pole
                if wart in puste_pola:
                    WartosciN += ",NULL"
                else:
                    WartosciN += ",'"+str(wart)+"'"
            else:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                Poz = wart
            elif pole == "nr_ppoz":
                Ppoz == wart
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        
        #sprawdzam stan przed INSERT i blokuje wiersze
        sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        sprSql +=" AND stan='W' AND numer='"+Numer+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)        
        if stat<>'OK':
            stat="Bdy zapytania sprawdzajcego stan zamwienia przed dodaniem danych "+stat
            dane.append(stat)           
        elif len(d)==0:
            stat='STAN GI'
            dane.append(stat)            
        #INSERT waciwy
        else:    
            stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
            if stat<>'OK':
                stat="Bdy zapytania dodajcego dane "+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [3,4]:
    if not (UprEdycja and (Wyznacznik in LEdy)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR UPD'
        dane.append(stat)
        
    if stat=='OK':
        UpdR = ''
        sql = "UPDATE rs_zamowienia_odbiorcy_pozycje SET "
        Filtr =" firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        Filtr+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
        Filtr+=" AND nr_ppoz="+str(Ppoz)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ['artykul_id','nr_serii','stawka_vat','cecha1_opis','cecha1_wartosc']:
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['termin_przyd','data_od','data_do','tryb_dostawy']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"
            elif pole == 'ilosc1':
                sql += pole+"="+str(wart)+","
                
                #sprawdzenie i ewentualna korekta rezerwacji podpietych do pozycji
                #aby ilosc na rezerwacjach nie przekroczyla ilosci w pozycji
                sqlr ="SELECT ar.rezerwacja_id,ar.artykul_id,a.przelicznik,"
                sqlr+=" ar.magazyn_id,ar.rezerwacja FROM rs_artykuly_rezerwacje ar "
                sqlr+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                sqlr+=" WHERE firma_id='"+self.firma_id+"'"
                sqlr+=" AND wyznacznik_id_z='"+Wyznacznik+"'"
                sqlr+=" AND data_z='"+Data+"' AND numer_z="+str(Numer)
                sqlr+=" AND nr_poz_z="+str(Poz)+" AND nr_ppoz_z="+str(Ppoz)
                sqlr+=" AND rezerwacja > 0 ORDER BY rezerwacja_id FOR UPDATE NOWAIT;"
                
                stat,DaneRez,dump,dump = self.PolSQL.Execute(sqlr,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania informacji o rezerwacji: '+stat
                    dane.append(stat)
                
                if stat == 'OK' and len(DaneRez) > 0:
                    #sprawdzenie, czy anulowana ilosc wymaga zmniejszenia
                    #ilosci na rezerwacjach
                
                    SumaRez = 0
                    for poz in DaneRez:
                        SumaRez += poz[4]
                    
                    if SumaRez > wart:
                        DoWycofaniaZRez = SumaRez - wart
                        
                        for poz in DaneRez:
                            Zmniejszyc = min(DoWycofaniaZRez,poz[4])
                            if Zmniejszyc > 0:
                                #zmiana w rezerwacji
                                UpdR+="UPDATE rs_artykuly_rezerwacje SET rezerwacja=rezerwacja-"+str(Zmniejszyc)
                                
                                if Zmniejszyc == poz[4]:
                                    #jesli po zmniejszeniu rezerwacja bedzie zerowa, to zamykamy ja
                                    #i odlaczamy ja od pozycji dokumentu
                                    UpdR+=", zamknieta=True, wyznacznik_id_z=NULL"
                                    UpdR+=", data_z=NULL, numer_z=NULL, nr_poz_z=NULL, nr_ppoz_z=NULL"
                                
                                UpdR+=" WHERE firma_id='"+self.firma_id+"' AND rezerwacja_id="+str(poz[0])+";"

                                # zmiana rezerwacji w magazynach
                                UpdR+="UPDATE rs_artykuly_magazyny SET rezerwacja1=rezerwacja1-"+str(Zmniejszyc)
                                UpdR+=",rezerwacja2=rezerwacja2-"+str(rsglobal.RSRound(Zmniejszyc*poz[2],2))     
                                UpdR+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(poz[3])+"' AND artykul_id='"+str(poz[1])+"';"
                                UpdR+="UPDATE rs_artykuly SET rezerwacja1=rezerwacja1-"+str(Zmniejszyc)
                                UpdR+=",rezerwacja2=rezerwacja2-"+str(rsglobal.RSRound(Zmniejszyc*poz[2],2))     
                                UpdR+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(poz[1])+"';" 
                            
                                DoWycofaniaZRez -= Zmniejszyc
                                
                            if DoWycofaniaZRez == 0:
                                break
                
            elif wart == "NULL":
                sql += pole+"="+str(wart)+","
            else:
                sql += pole+"="+str(wart)+","
            if pole == "nr_poz":
                Poz = wart
            elif pole == "nr_ppoz":
                Ppoz == wart
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        
        if stat == 'OK':
            #sprawdzam stan zamwienia przed UPDATE i blokuje wiersze
            sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
            sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
            sprSql +=" AND stan='W' AND numer='"+Numer+"' FOR UPDATE NOWAIT;"
            stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)            
            if stat<>'OK':
                stat="Bdy zapytania sprawdzajcego stan zamwienia przed dodaniem danych "+stat
                dane.append(stat)
            elif len(d)==0:
                stat='STAN GU'
                dane.append(stat)                
            #UPDATE waciwy
            else:
                stat,dump,dump,dump = self.PolSQL.Execute(sql+UpdR ,1)
                if stat <> 'OK':
                    stat = 'BL_SQL'
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY ARTYKU MOE BY UYTY W ZWIZKU Z GRUPAMI ODBIORCW (1,2,3,4)
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4] and stat=='OK':
    Art = "(SELECT artykul_id FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id ='"+Wyznacznik+"' " \
          " AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)+" AND nr_ppoz="+str(Ppoz)+" )"
    SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+Kontr+"',"+Art+",'"+Data+"')"
    stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = u'Bd sprawdzania moliwoci wykorzystania artykuu ze wzgldu na grupy odbiorcw: '+stat
    if stat == 'OK':
        if DArt[0][0] <> 'OK':
            stat = DArt[0][0]

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [5,3,1]:
    dane = []
    wyn2 = []
    
    where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
    if Ppoz not in puste_pola:
        where += " AND nr_ppoz="+str(Ppoz)
    sql = "SELECT * FROM rs_zamowienia_odbiorcy_pozycje "+where+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL SQL PRZ'
        dane.append(stat)

    # pobranie danych dodatkowych
    if stat=='OK':
        # stan (0)
        sql ="SELECT stan FROM rs_zamowienia_odbiorcy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,dStan,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania stanu zamwienia: '+stat
        elif len(dStan) == 0:
            stat = 'Brak zamwienia o podanym klucze.'
        else:
            wyn2.append(dStan[0][0])

        # pobranie informacji o uprawnieniach do trasy (1)
        if stat == 'OK':
            SQL = "SELECT rsf_podaj_uprawnienia_do_zamowienia_wzgledem_tras('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+str(Numer)+")"
            stat,DTras,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = u"Wystpiy bdy sprawdzania uprawnie operatora do tras : "+stat
            else:
                wyn2.append(eval(DTras[0][0]))

            
rsglobal.ZapiszDoLogow('99 '+stat,1)