#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje_stale.py
# Purpose:		dodaje/pobiera/usuwa zamowienia odbiorcy pozycje stale
# Author:		Marcin Grzeda
# Created:		2007/04/20
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje_stale.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

# 2010-11-25 Marcin Natkaski blokada modyfikacji wierszy dla zamwie ze stanem <> W (4085)
# 2011-07-18 Mariusz Rajfura  wirt.kolumna 'procent_zwrotow' (4752)
# 2011-10-27 Mariusz Rajfura - info o poziomie zwrotow dla kontrahenta (5154)
#                              blokada zapisu artykulu nieaktywnego lub modyfikacji ilosci
#                              dla artykulu nieaktywnego
# 2015-07-16 Piotr Witkowski refaktoryzacja - przejcie na nowego grida(6800)
# 2018-12-29 Jan Raburski - blokada zapisu artykuow z przekroczonym limitem dostaw (11346)
# 2019-07-03 Mikoaj Kozowski - Dodanie zasilania kolumny "Min." poprzez rsf_znajdz_minimum_logistyczne (11524)
# 2020-03-17 Mikoaj Kozowski - Dodanie sprawdzania podwojonych wartoci w pozycjach staych (11908)

# Funkcje:
# 1  - Edycja grida edytowalnego, 
# 5  - Pobranie danych do grida
# 13 - Pobranie procentu zwrotu dla artykulu
# 15 - Pobranie informacji o poziomie zwrotow dla kontrahenta
# 17 - pobranie informacji o przekroczeniu limitow dostaw dla kontrahenta

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
    
if stat=='OK':    
    Funkcja = klucze['Funkcja']    
    
    SlPar={'Wyznacznik':[1,5,13,15,17],'Data':[1,5,13,15,17], 'Numer':[1,5,13,15,17],
           'Artykul':[1,5,13], 'TrybDostawy':[1,5]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_pozycje_stale z numerem ' +str(Funkcja)+' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [1,5,13,15,17]:
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(int(klucze['Numer']))
    
    if stat=='OK':
        if Funkcja in [1,5,13]:
            Artykul = str(klucze['Artykul'])
    
    if stat=='OK':
        if Funkcja in [1,5]: 
            TrybDostawy = str(klucze['TrybDostawy'])

dane = []
wyn1 = []
wyn2 = []
LArtPoziom=[]


#-------------------------------------------------------------------------------
# Pobranie informacji o przekroczeniu limitow dostaw dla kontrahenta (17)
#-------------------------------------------------------------------------------
if stat == 'OK' and Funkcja == 17:    #JR (11346)
    # sprawdzenie limitw dostaw
    SELECT ="SELECT rsf_zamowienie_odbiorcy_sprawdz_limity("
    SELECT+=" '"+self.firma_id+"', '"+Wyznacznik+"',"
    SELECT+=" '"+Data+"', "+str(Numer)+")"
    stat,d,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat != "OK":
        stat = u"Wystpiy bdy podczas sprawdzania limitw dostaw."
    elif eval(d[0][0]) != []:
        p = eval(d[0][0])
        dane.append( u"Przekroczenie limitw dostaw dla:")
        for w in p:
            dane.append("Artyku:"+str(w[0])+", "+str(w[1])+", Limit:"+str(w[2])+", Zam.:"+str(w[3]))


#-------------------------------------------------------------------------------
# Pobranie informacji o poziomie zwrotow dla kontrahenta (15)
#-------------------------------------------------------------------------------

if Funkcja == 15 and stat == 'OK':
    stat,dane = fs_zamowienia_odbiorcy_pom.PoziomZwrotowDlaOdbiorcyZZamowieniaOdbiorcy(self,Wyznacznik,Data,Numer)


#-------------------------------------------------------------------------------
# Pobranie procentu zwrotu dla artykulu (13)
#-------------------------------------------------------------------------------

if Funkcja == 13 and stat == 'OK':
    Proc=0
    Opak=0
    
    sql ="SELECT zo.kontrahent_id,kazi.procent"
    sql+=" FROM rs_zamowienia_odbiorcy zo"
    sql+=" LEFT JOIN rs_kontrahenci_artykuly_zwroty_ilosciowe kazi"
    sql+="  ON (kazi.firma_id=zo.firma_id AND kazi.oddzial_id=zo.oddzial_id"
    sql+="      AND kazi.kontrahent_id=zo.kontrahent_id AND kazi.artykul_id='"+Artykul+"')"
    sql+=" WHERE zo.firma_id='"+self.firma_id+"' AND zo.wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND zo.data='"+Data+"' AND zo.numer="+str(Numer)+";"

    stat,dZam,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z nagwka zamowienia: '+stat
    elif len(dZam) == 0:
        dane.append('BR ZAM')
    else:
        Proc = dZam[0][1]

    if stat=='OK':
        SQL="SELECT ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND artykul_id='"+Artykul+"' ORDER BY opakowanie_id LIMIT 1"
        stat,DOpak,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych o ilociach opakowania: '+stat
            dane.append(stat)
        elif len(DOpak)>0:
            Opak=DOpak[0][0]
            
    dane=[Opak,Proc]
    
    
#-------------------------------------------------------------------------------
# Pobranie listy uprawnionych i uprawnie do tras
#-------------------------------------------------------------------------------

if Funkcja in [1,5] and stat=='OK':
    UprTrasy = [False,False,False]
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        LWyzn=rsglobal.rseval(wyzn[0][0])[1]

    if stat == 'OK':
        SQL = "SELECT rsf_podaj_uprawnienia_do_zamowienia_wzgledem_tras('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+")"
        stat,DTras,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = u"Wystpiy bdy sprawdzania uprawnie operatora do tras : "+stat
        else:
            UprTrasy = eval(DTras[0][0])

if Funkcja in [1,5] and stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrzeg=True
        UprEdy=True
        UprDod=True
        UprDel=True
        LPrzeg=LWyzn
        LEdy=LWyzn
        LDod=LWyzn
        LDel=LWyzn
    else:
        UprPrzeg = (self.oddzial_id,'024050') in self.uprawnienia
        LPrzeg=[]

        if UprPrzeg and (Funkcja in [1,3,5]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+\
                  "','[]','[True,False,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]
        
        UprEdy = ((self.oddzial_id,'024052') in self.uprawnienia) and UprTrasy[2]
        LEdy=[]

        if UprEdy and (Funkcja in [3,4]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+\
                  "','[]','[False,False,True,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]
        
        UprDel = ((self.oddzial_id,'024054') in self.uprawnienia)
        LDel=[]
        
        if UprDel and (Funkcja in [6]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+\
                  "','[]','[False,False,False,True,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LDod=rsglobal.rseval(wyzn[0][0])[1]

        UprDod = ((self.oddzial_id,'024053') in self.uprawnienia) and UprTrasy[1]
        LDod=[]

        if UprDod and (Funkcja in [1,2]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+\
                  "','[]','[False,True,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LDod=rsglobal.rseval(wyzn[0][0])[1]


#-------------------------------------------------------------------------------
# Edycja grida edytowalnego (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK':
    from funkcje import fs_artykuly_pom
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

    if stat == "OK":
        if len(Update) > 0:
            if not UprEdy:
                stat = u'Brak uprawnie do modyfikacji pozycji staych'

    if stat == "OK":
        if len(Insert) > 0:
            if not UprDod:
                stat = u'Brak uprawnie do dodawania pozycji staych'

    if stat == "OK":
        if len(Delete) > 0:
            if not UprDel:
                stat = u'Brak uprawnie do usuwania pozycji staych'


    SPozGrOdb = {} # lista pozycji, ktre powinny by sprawdzone pod ktem danych z rs_grupy_odbiorcow_asortyment.
                   # klucz to (tryb, artykul, data od) , a wartoc to [typ i wiersz]

    Kontr = ''
    Platnik = ''
    if stat=='OK':
        SELECT="SELECT czy_stale,COALESCE(kontrahent_id,''),COALESCE(platnik_id,'') FROM rs_zamowienia_odbiorcy WHERE firma_id='"+\
               self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat<>'OK':
            stat= u'Zamwienie nie jest zamwieniem staym: ' + stat
            dane.append(stat)            
        if stat=='OK':
            if len(d)>0:
                if not d[0][0]:
                    stat='ZAM BL'
                    dane.append(stat) 
                else:
                    Kontr = d[0][1]
                    Platnik = d[0][2]
            
    if stat=='OK': #sprawdzanie danych
        for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
            ZmianaIlosci = False
            JakiArtykul = None

            if stat == 'OK':
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]

                    if pole=='artykul_id': 
                        JakiArtykul = wart
                        if wart in (None,'None') and wart.strip()=='':
                            dane.append('ART BR$'+str(Update[-1][i]))
                            wyn2.append([Update[-1][i],0]) 
                        else:                            
                            Sql="SELECT artykul_id,aktywny,"
                            Sql+="rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+wart+"','"+Kontr+"','"+Platnik+"','"+Data+"') "
                            Sql+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                            if stat<>'OK':
                                stat=u'Bd sprawdzenia artykulu: ' + stat
                                dane.append(stat)                            
                            if stat=='OK':
                                if len(d)==0:
                                    dane.append('ART BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],0])       
                                                                 
                                elif not d[0][1]:
                                    dane.append('ART AKT BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],0])       
                             
                                elif Data > d[0][2]:
                                    dane.append('ART LIMIT BL$'+str(Update[-1][i])+' dla kontrahenta '+Kontr+'.')
                                    wyn2.append([Update[-1][i],0])                           
                                                    
                    elif pole=='tryb_dostawy':
                        if  wart in (None,'None') and wart.strip()=='':
                            dane.append('TRYB BR$'+str(Update[-1][i]))
                            wyn2.append([Update[-1][i],3])
                        else:
                            Sql="Select kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                            if stat<>'OK':                                
                                stat=u'Bd sprawdzenia trybu dostawy: '+stat
                                dane.append(stat)                                
                            if stat=='OK':
                                if len(d)==0:
                                    dane.append('TRYB BL$'+str(Update[-1][i]))
                                    wyn2.append([Update[-1][i],4])
                                    
                    elif pole=='data_od':
                        if wart not in (None,'None') and wart.strip()<>'':
                            if not rsglobal.SprawdzCzyToData(wart.strip()):
                                stat='DAT OD BL$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],4])
                        else:
                            dane.append('DAT OD BR$'+str(Update[-1][i]))
                            wyn2.append([Update[-1][i],4])
                            
                    elif pole=='data_do':
                        if  wart not in (None,'None') and wart.strip()<>'':
                            if not rsglobal.SprawdzCzyToData(wart.strip()):
                                dane.append('DAT DO BL$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],5])
                                
                    elif pole in ['dz_00','dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']:
                        ZmianaIlosci = True


            # zmiana ilosci bez zmiany artykulu -> kontrola aktywnosci artykulu
            # artykul pobieramy z klucza pozycji

            if stat == 'OK' and ZmianaIlosci and JakiArtykul == None:
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=Update[2][i][j]
                    
                    if pole == 'artykul_id':
                        Sql ="SELECT artykul_id,aktywny FROM rs_artykuly"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"';"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat=u'Bd sprawdzenia artykulu: ' + stat 
                            dane.append(stat)                            
                        if stat=='OK':
                            if len(d)==0:
                                dane.append('ART BL$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])
                                
                            elif not d[0][1]:
                                dane.append('ART MODYF BL$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])
                           
                                    
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if stat == 'OK' and pole=='artykul_id':         
                    if  wart in (None,'None') and wart.strip()=='':
                        dane.append('ART BR$'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],0])
                    else:            
                        Sql="SELECT artykul_id,aktywny,"
                        Sql+="rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+wart+"','"+Kontr+"','"+Platnik+"','"+Data+"') "
                        Sql+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='Bd sprawdzenia artykuu: ' + stat 
                            dane.append(stat)                            
                        if stat=='OK':
                            if len(d)==0:
                                dane.append('ART BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],0])                                
                            elif not d[0][1]:
                                dane.append('ART AKT BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],0])                                
                            elif Data > d[0][2]:
                                dane.append('ART LIMIT BL$'+str(Insert[-1][i])+' dla kontrahenta '+Kontr+'.')
                                wyn2.append([Insert[-1][i],0])                            
                                            
                elif pole=='tryb_dostawy':
                    if  wart in (None,'None') and wart.strip()=='':
                        dane.append('TRYB BR$'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],3]) 
                    else:   
                        Sql="Select kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='Bd sprawdzenia trybu dostawy: ' + stat
                            dane.append(stat)
                        if stat=='OK':
                            if len(d)==0:
                                dane.append('TRYB BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],4])
                            
                elif pole=='data_od':
                    if  wart not in (None,'None') and wart.strip()<>'':
                        if not rsglobal.SprawdzCzyToData(wart.strip()):
                            dane.append('DAT OD BL$'+str(Insert[-1][i]))
                            wyn2.append([Insert[-1][i],4])
                    else:
                        dane.append('DAT OD BR$'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],4])
                        
                elif pole=='data_do':
                    if  wart not in (None,'None') and wart.strip()<>'':
                        if not rsglobal.SprawdzCzyToData(wart.strip()):
                            dane.append('DAT DO BL$'+str(Insert[-1][i]))
                            wyn2.append([Insert[-1][i],5])
                              
        if stat == 'OK' and len(dane)>0:
            stat=dane[-1]
    
    #Sprawdzenie czy zgadza si ilo z opakowaniami
    if stat == 'OK':
        Dni = {'dz_00':'Codz.','dz_01':'Ndz.','dz_02':'Pn.','dz_03':'Wt.','dz_04':u'r','dz_05':'Czw.','dz_06':'Pt.','dz_07':'Sob.'}
        DArt = []
        d = []
        ArtykulId= ''
        CzySprawdzamy = False  
        for i in xrange(len(Update[0])):    # petla po ilosci wierszy updatowanych
            ArtykulId = Update[2][i][0].strip()
            CzySprawdzamy = True
            for j in xrange(len(Update[0][i])): # petla po pozycjach
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole=='artykul_id': 
                    ArtykulId = wart.strip()
                if pole in ['dz_00','dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']:
                    if wart <> 0:
                        DArt.append([ArtykulId,wart,Dni[pole]])
                             
        for i in xrange(len(Insert[0])):    # petla po ilosci wierszy dodawanych
            CzySprawdzamy = True
            for j in xrange(len(Insert[0][i])): # petla po pozycjach
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole=='artykul_id': 
                    ArtykulId=wart.strip()
                if pole in ['dz_00','dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']:
                    if wart <> 0:
                        DArt.append([ArtykulId,wart,Dni[pole]])  
            
        if stat == 'OK' and CzySprawdzamy: 
            SQL ="SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_zamowienia_odbiorcy "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
            SQL+="AND data='"+Data+"' AND numer="+Numer+" "
            stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd przy pobieraniu kontrahenta do sprawdzenia opakowa: ' + stat 
                 
        if stat == 'OK' and CzySprawdzamy:        
            for poz in DArt:     
                stat,SOpakArt = fs_artykuly_pom.PodajOpakowaniaDlaArtykulu(self,poz[0],poz[1],DKontr[0][0],'',poz[2],2)
                if stat <> 'OK':
                    dane.append(stat)
            if len(dane)>0:
                stat=dane[0]
        
    if stat == 'OK':
        #sprawdzam stan zamwienia przed UPDATE i blokuje wiersze
        sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        sprSql +=" AND stan='W' AND numer='"+Numer+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)
        if stat<>'OK':
            stat="Bdy zapytania sprawdzajcego stan zamwienia przed aktualizacj danych: " + stat
            dane.append(stat)
        elif len(d)==0:
            dane.append('STAN BL')
        elif stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_zamowienia_odbiorcy_pozycje_stale "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat=u'Nie mona wykona operacji: ' + stat
                    dane.append(stat)

#MK 2020-03-17 - poczatek
    if stat == 'OK':
        #sprawdzam unikalnosc pozycji do update z baz danych
        tryb = ''
        artykul = ''
        data = ''
        sqlK="SELECT * FROM rs_zamowienia_odbiorcy_pozycje_stale WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        for i in xrange(len(Update[0])):
            sqlKFiltry = ' '
            tryb = Update[2][i][Update[3].index('tryb_dostawy')]
            artykul = Update[2][i][Update[3].index('artykul_id')]
            data = Update[2][i][Update[3].index('data_od')]
            if 'tryb_dostawy' in Update[0][i] or 'artykul_id' in Update[0][i] or 'data_od' in Update[0][i]:
                for j in xrange(len(Update[0][i])):  # petla po pozycjach do zmiany
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'tryb_dostawy':
                        tryb=wart
                    if pole == 'artykul_id':
                        artykul=wart
                    if pole == 'data_od':
                        data=wart
                sqlKFiltry+=" AND tryb_dostawy='"+tryb+"'"
                sqlKFiltry+=" AND artykul_id='"+artykul+"'"
                sqlKFiltry+=" AND data_od='"+data+"'"
                sqlKFiltry+=";"
                stat, podwojne, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sqlK+sqlKFiltry), 3)
                if stat != 'OK':
                    stat = 'Bd sprawdzania pozycji.' + stat
                    dane.append(stat)
                    break
                else:
                    if len(podwojne) > 0:
                        stat = "Na podanym zamwieniu istnieje ju pozycja o tych samych wartociach. Nie mona zmodyfikowa "
                        if len(tryb) > 0:
                           stat+= "Tryb na: " +tryb
                        if len(artykul) > 0:
                           stat+=" Artyku na: " +artykul
                        if len(data) > 0:
                           stat+=" Data od na: " +data
                        stat+=" w wybranej pozycji."
                        dane.append(stat)
                        break
#MK 2020-03-17 - koniec

    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
            UPDATE="UPDATE rs_zamowienia_odbiorcy_pozycje_stale "
            SET='SET '
            # takie s wartoci jeli nie ulegy zmianie
            ArtTmp = 'artykul_id'
            DataTmp = 'data_reczna'
            
            for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['dz_00','dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']: 
                    SET+=pole+"="+str(wart)+","
                elif pole in ['op_00','op_01','op_02','op_03','op_04','op_05','op_06','op_07']:
                    SET+=pole+"='"+wart+"',"
                elif pole in ['artykul_id','tryb_dostawy']:
                    if wart<>'':
                        SET+=pole+"='"+wart+"',"
                        if pole == 'artykul_id':
                            ArtTmp = "'"+wart+"'"
                elif pole in ['data_od',]:
                    if  wart not in (None,'None') and wart.strip()<>'':
                        SET+=pole+"='"+wart+"',"
                    else:
                        SET+=pole+"=NULL,"
   
                elif pole in ['data_do',]:
                    if  wart in (None,'None') or wart.strip()=='':
                        SET+="data_reczna = NULL,"
                        DataTmp = 'NULL'
                    else:
                        SET+="data_reczna = '"+wart+"',"
                        DataTmp = "'"+wart+"'"
                    
            if stat =='OK':
                if ArtTmp <> 'artykul_id' or DataTmp <> 'data_reczna':
                    SET+="data_do = rsf_podaj_date_limitu_zamowien('"+self.firma_id+"',"+ArtTmp+",'"+Kontr+"','"+Platnik+"',"+DataTmp+"),"
                    
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            bufkl = ['','','']
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=Update[2][i][j]
                WHERE+=" AND "+pole+"='"+wart+"'"
                # obsuga grup odbiorcw asortyment
                if pole == 'tryb_dostawy':
                    bufkl[0] = wart.strip()
                elif pole == 'artykul_id':
                    bufkl[1] = wart.strip()
                elif pole == 'data_od':
                    bufkl[2] = wart

            if not (bufkl[0],bufkl[1],bufkl[2]) in SPozGrOdb:
                SPozGrOdb[(bufkl[0],bufkl[1],bufkl[2])] = ['U',i]

            sql+=UPDATE+SET+WHERE+";"
        if sql<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat!='OK':
                stat='Nie zostaa wykonana aktualizacja numeru pozycji: ' + stat
                dane.append(stat)

    if stat=='OK':    
        sql=''
        ArtTmp = ''
        DataTmp = 'NULL'
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_zamowienia_odbiorcy_pozycje_stale "
            KOLUMNY="(firma_id,wyznacznik_id,data,numer"
            VALUES=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer
            bufkl = ['','','']
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]

                # obsuga grup odbiorcw asortyment
                if pole == 'tryb_dostawy':
                    bufkl[0] = wart.strip()
                elif pole == 'artykul_id':
                    bufkl[1] = wart.strip()
                elif pole == 'data_od':
                    bufkl[2] = wart


                if pole in ['dz_00','dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']:
                    KOLUMNY+=","+pole
                    VALUES+=","+str(wart)
                    
                elif pole in ['data_do']:
                    if  wart in (None,'None') or wart.strip()=='':
                        KOLUMNY+=",data_reczna"
                        VALUES+=",NULL"
                        DataTmp = 'NULL'
                    else:
                        KOLUMNY+=",data_reczna"
                        VALUES+=",'"+wart+"'"
                        DataTmp = "'"+wart+"'"
                        
                elif pole in ['artykul_id','data_od','tryb_dostawy']:
                    if wart=='':
                        stat= u'Wystpiy bdy przy wstawianiu danych klucza'
                        dane.append(stat)
                    else:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                        if pole =='artykul_id':
                            ArtTmp = wart
                            
                elif pole in ['op_00','op_01','op_02','op_03','op_04','op_05','op_06','op_07']:
                    KOLUMNY+=","+pole
                    VALUES+=",'"+wart+"'"
            # wyliczamy dat do
            if stat == 'OK':
                KOLUMNY+=",data_do"
                VALUES+=",rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+ArtTmp+"','"+Kontr+"','"+Platnik+"',"+DataTmp+") "

            # uwzgldniamy klucz pozycji w tecie na grupy odbiorcw
            if not (bufkl[0],bufkl[1],bufkl[2]) in SPozGrOdb:
                SPozGrOdb[(bufkl[0],bufkl[1],bufkl[2])] = ['I',i]
            
            KOLUMNY+=")"
            VALUES+=");"
            sql+=INSERT+KOLUMNY+VALUES
            rsglobal.ZapiszDoLogow('sql '+sql,1)
        if sql<>'':
            if stat=='OK':     
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat=u'Wystpiy bdy przy wstawianiu danych: '+stat
                    dane.append(stat)            

    #------------------------------------------
    # sprawdzenie czy zmieniane pozycje sdopuszczone do zapisu ze wzgldu na ograniczenia dla grup odbiorcw
    #------------------------------------------
    if stat=='OK' and len(SPozGrOdb) > 0:
        # pobieramy artykuy z odpowiednich pozycji
        SQL="SELECT TRIM(tryb_dostawy),TRIM(artykul_id),data_od FROM rs_zamowienia_odbiorcy_pozycje_stale " \
            " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer +" " \
            " AND (tryb_dostawy,artykul_id,data_od) IN ("
        for kl in SPozGrOdb.keys():
            SQL+="('"+kl[0]+"','"+kl[1]+"','"+kl[2]+"'),"
        SQL = SQL.strip(',')
        SQL+= ")"
        stat,DPozGr,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobrania pozycji dowodu do analizy grup odbiorcw: '+stat
            dane.append(stat)
        if stat=='OK':
            for poz in DPozGr:
                SQL = "SELECT rsf_sprawdz_wydanie_dla_kontr_z_grupy_odb('"+self.firma_id+"','"+Kontr+"','"+poz[1]+"','"+rsglobal.PodajDzis()+"')"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd analizy grup odbiorcw dla trybu '+poz[0]+' artykuu '+poz[1]+' i daty od '+poz[2]+': '+stat
                    dane.append(stat)
                elif DTest[0][0] <> 'OK':
                    # pozycja pochodzi z Update
                    if SPozGrOdb[(poz[0],poz[1],poz[2])][0] == 'U':
                        dane.append('GR ODB AS$'+str(Update[-1][SPozGrOdb[(poz[0],poz[1],poz[2])][1]])+': '+DTest[0][0])
                        wyn2.append([Update[-1][SPozGrOdb[(poz[0],poz[1],poz[2])][1]],-1])
                    else:
                        dane.append('GR ODB AS$'+str(Insert[-1][SPozGrOdb[(poz[0],poz[1],poz[2])][1]])+': '+DTest[0][0])
                        wyn2.append([Insert[-1][SPozGrOdb[(poz[0],poz[1],poz[2])][1]],-1])
            if stat == 'OK':
                if len(dane)>0:
                    stat=dane[-1]


#-------------------------------------------------------------------------------
# Pobranie danych do grida (5)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:    #JR (11346)
    # sprawdzenie limitw dostaw po zapisie
    SELECT ="SELECT rsf_zamowienie_odbiorcy_sprawdz_limity("
    SELECT+=" '"+self.firma_id+"', '"+Wyznacznik+"',"
    SELECT+=" '"+Data+"', "+str(Numer)+")"
    stat,d,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat != "OK":
        stat = u"Wystpiy bdy podczas sprawdzania limitw dostaw."
    elif eval(d[0][0]) != []:
        p = eval(d[0][0])
        stat =  u"Przekroczenie limitw dostaw"
        dane = []
        dane.append( u"Przekroczenie limitw dostaw dla:")
        for w in p:
            dane.append("Artyku:"+str(w[0])+", "+str(w[1])+", Limit:"+str(w[2])+", Zam.:"+str(w[3]))

if Funkcja in [1, 5] and stat == 'OK':
    Sel ="SELECT fp.artykul_id,art.nazwa,"
    Sel+="(SELECT ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
    Sel+=" AND artykul_id=fp.artykul_id ORDER BY opakowanie_id LIMIT 1),"
    Sel+="kazi.procent,"
    Sel+=" tryb_dostawy,data_od,COALESCE(data_do::TEXT,''),"
    Sel+=" rsf_znajdz_minimum_logistyczne(fp.firma_id, fp.artykul_id, zo.kontrahent_id) AS minimum_logistyczne,"
    Sel+=" dz_02,dz_03,dz_04,dz_05,dz_06,dz_07,dz_01,dz_00,"
    Sel+=" op_02,op_03,op_04,op_05,op_06,op_07,op_01,op_00,"
    Sel+=" fp.z_op_id||'-'||o.login, fp.z_czas "
    Sel+=" FROM rs_zamowienia_odbiorcy_pozycje_stale fp"
    Sel+=" INNER JOIN rs_artykuly art USING(firma_id,artykul_id)"
    Sel+=" INNER JOIN rs_zamowienia_odbiorcy zo USING(firma_id,wyznacznik_id,data,numer)"
    Sel+=" LEFT OUTER JOIN rs_kontrahenci_artykuly_zwroty_ilosciowe kazi"
    Sel+=" ON (kazi.firma_id=fp.firma_id"
    Sel+="     AND kazi.oddzial_id=zo.oddzial_id"
    Sel+="     AND kazi.kontrahent_id=zo.kontrahent_id"
    Sel+="     AND kazi.artykul_id=fp.artykul_id)"
    Sel+=" INNER JOIN rs_operatorzy o ON fp.z_op_id = o.operator_id"
    Sel+=" WHERE fp.firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    Sel+=" AND data='"+Data+"' AND numer="+Numer 
    if Artykul<>"":
        Sel+=" AND fp.artykul_id LIKE '"+Artykul.strip()+"%' "
    if TrybDostawy<>"":
        Sel+=" AND tryb_dostawy='"+TrybDostawy+"'"
    Sel+=" ORDER BY tryb_dostawy,artykul_id;"
    stat,dane,wyn,dump=self.PolSQL.Execute(Sel,3)
        
    if stat<>"OK":
        stat=u'Nie mona pobra danych'

    if stat == 'OK':
        SELECT ="SELECT czy_stale"
        SELECT+=" FROM rs_zamowienia_odbiorcy"
        SELECT+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        SELECT+=" AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat <> 'OK':
            stat=u'Nie mona pobra danych o stanie zamwienia'
        if stat =='OK':
            wyn2=[False]
            if len(d)>0:
                if d[0][0]:
                    wyn2=[True]

        if stat =='OK':
            # pobranie informacji o uprawnieniach do trasy (1)
            SQL = "SELECT rsf_podaj_uprawnienia_do_zamowienia_wzgledem_tras('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+")"
            stat,DTras,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = u"Wystpiy bdy sprawdzania uprawnie operatora do tras : "+stat
            else:
                wyn2.append(eval(DTras[0][0]))


