#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje_zlecenia.py
# Purpose:		dodaje/pobiera/usuwa zlecenia pozycji zamwienia odbiorcy
# Author:		Micha Raburski
# Created:		2014/09/08
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje_zlecenia.py $
# Copyright:	(c) 2014 RecordSystem
#-------------------------------------------------------------------------------

# FUNKCJE 
# 1  - zmiana iloci pozycji
# 3  - dodanie pozycji (rekurencyjnie - pocztkowe)
# 4  - dodanie pozycji ze wzoru (na skutek potrzeby podania parametrw)
# 5  - pobranie danych
# 6  - usuwanie pozycji
# 7  - pobranie opisu cechy
# 9  - sprawdzenie uzupenienia surowcw
# 11 - pobranie informacji o artykule

from funkcje import fs_zamowienia_odbiorcy_pozycje_zlecenia_pom
from funkcje import fs_zamowienia_odbiorcy_pom

stat='OK'
dane = []
wyn1 = []
wyn2 = []
LDoZmiany = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    rsglobal.ZapiszDoLogow('klucze '+str(klucze),1)
    SlPar={'Wyznacznik':[1,3,4,5,6,9,12], 'Data':[1,3,4,5,6,9,12],'Numer':[1,3,4,5,6,9,12], 'NrPoz':[1,3,4,5,6,9,12], 'NrPpoz':[1,3,4,5,6,9,12],
           'Artykul':[3,11], 'Rodzic':[3], 'CechaWart':[3,7], 'Ilosc':[3], 'Zlecenie':[4,6,12],'Cecha':[7],'Parametry':[3,4,12]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_pozycje_zlecenia z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    Parametry = ''
    
    if Funkcja in [1,3,4,5,6,9,12]:
        Wyznacznik = rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = str(klucze['Numer'])
        NrPoz = str(klucze['NrPoz'])
        NrPpoz = str(klucze['NrPpoz'])
    if Funkcja in [3,11]:
        Artykul = rsglobal.Dekoduj(klucze['Artykul'])
    if Funkcja == 3:
        Rodzic = rsglobal.Dekoduj(klucze['Rodzic'])
        CechaWart = rsglobal.Dekoduj(klucze['CechaWart'])
        Ilosc = klucze['Ilosc']
    if Funkcja in [3,4,12]:
        Parametry = klucze['Parametry']
    if Funkcja in [4,6,12]:
        Zlecenie = klucze['Zlecenie']
    if Funkcja == 1:
        Update = klucze['Update']
    if Funkcja == 7:
        Cecha = rsglobal.Dekoduj(klucze['Cecha'])
        CechaWart = rsglobal.Dekoduj(klucze['CechaWart'])
        
        
if stat=='OK':
    UprModyfikacja = (((self.oddzial_id,'124021') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))        
    PoczatekZlecenia = ''

#-------------------------------------------------------------------------------
#-------- WYCZYSZCZENIE POZYCJI ZLECENIA (12)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 12: 
    SQL = "DELETE FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    SQL+=" AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz
    SQL+=" AND nr_zlec LIKE '"+Zlecenie+".%';"
    SQL+=" UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET parametry = ''"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    SQL+=" AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz
    SQL+=" AND nr_zlec = '"+Zlecenie+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        stat = 'Bdy czyszczenia pozycji zlecenia '+Zlecenie+' : '+stat
    
    Funkcja = 4
    
#-------------------------------------------------------------------------------
#-------- POBRANIE OPISU CECHY (7)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 7: 
    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','poprawna'),"
    SQL+="rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','opis');"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bdy pobierania danych artykuu : '+stat

#-------------------------------------------------------------------------------
#    pobranie informacji o artykule (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat == 'OK':
    from funkcje import fs_artykuly_pom
    stat, dane = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self,Artykul,'','',0,'','','',0,'')

#-------------------------------------------------------------------------------
#    dodanie pozycji (3) LUB z parametrami (bez dodania tylko podpozycje) (4)
#-------------------------------------------------------------------------------

if Funkcja in [3,4] and stat == 'OK':
    rsglobal.ZapiszDoLogow('!!! ZACZYNAM '+str(Funkcja),1)                    
    if not UprModyfikacja:
        stat = 'Brak uprawnie do modyfikacji zlece'
        
    if stat == 'OK':
        LRodzicow =[]
        # pobranie stanu i kontrahenta z zamwienia
        SQL="SELECT stan, kontrahent_id FROM rs_zamowienia_odbiorcy"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        SQL+=" AND numer="+Numer
        stat,DZam,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat= u'Bd pobierania danych zamwienia :'+stat
        elif len(DZam) == 0:
            stat = u'Brak zamwienia o podanych parametrach'
        else:
            Stan = DZam[0][0]
            Kontrahent = DZam[0][1]
           
    if Funkcja == 3 and stat =='OK':
        # sprawdzenie czy artyku istnieje i pobranie typu i przelicznika
        if stat == 'OK':
            SQL="SELECT typ_artykulu,przelicznik,COALESCE(cecha1_opis,''),jm_zlecen FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
            stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat= u'Bd pobierania typu artykuu :'+stat
            
        if stat=='OK':
            if len(DArt) == 0:
                stat=u'Brak artykuu o podanym symbolu :'+Artykul
            
        if stat=='OK':
            Typ = DArt[0][0]
            
            if Typ == '31':
                stat = u' Typ USUGA nie moe by elementem zlecenia'
                
        if stat=='OK':
            Przel = DArt[0][1]
            if DArt[0][2] == '':
                CechaOpis = 'NULL'
            else:
                CechaOpis = "'"+DArt[0][2]+"'"
            JmZlec = DArt[0][3]
            
        rsglobal.ZapiszDoLogow('3 ',1)
        # sprawdzenie czy artyku nie wystpuje na pozycji "wyej" i czy pozycja rodzic nie jest surowcem
        NrRodzica = str(Rodzic)
        IloscRodzica = 1
        while NrRodzica <> '' and stat =='OK':
            SQL= "SELECT zl.artykul_id,COALESCE(zl.cecha1_wartosc,''),a.typ_artykulu,zl.ilosc_calk FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zl"
            SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+=" WHERE zl.firma_id='"+self.firma_id+"' AND zl.wyznacznik_id='"+Wyznacznik+"' AND zl.data='"+Data+"'"
            SQL+=" AND zl.numer="+Numer+" AND zl.nr_poz="+NrPoz+" AND zl.nr_ppoz="+NrPpoz
            SQL+=" AND zl.nr_zlec='"+NrRodzica+"';"
            stat,DRodzica,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat= u'Bd pobierania danych rodzica zlecenia :'+stat
            
            if stat == 'OK':
                if len(DRodzica) == 0:
                    stat= 'Brak poredniej pozycji w zleceniu:'+NrRodzica
            
            if stat == 'OK':
                if DRodzica[0][0] == Artykul and DRodzica[0][1] == CechaWart:
                    stat= "Dodawany artyku z cech wystpuje w pozycji "+NrRodzica+'. Nie mona doda pozycji w celu uniknicia rekurencji danych.'
            
            if stat == 'OK':
                # jeli surowiec
                if DRodzica[0][2] == '04':
                    stat='Nie mona doda pozycji poniewa w pozycji wyszego poziomu ('+NrRodzica+') wystpuje surowiec'
            
            if stat == 'OK' and NrRodzica == Rodzic:
                IloscRodzica = DRodzica[0][3]
                
            if stat == 'OK':                
                NrRodzica = NrRodzica[:-3]
        
        # sprawdzenie czy jeli artyku nie jest surowcem to ma ilo cakowit bdc wielokrotnoci jego rodzica
        if stat == 'OK' and Typ <> '04':
            if Ilosc <> rsglobal.RSRound(Ilosc,0):
                stat = 'Ilo skadnika nie bdcego surowcem powinna by wartoci cakowit'

        # pobranie pierwszego wolnego numeru 
        if stat =='OK':
            if Rodzic =='':
                FRodzic = " AND COALESCE(nr_zlec_rodzic,'') = ''"
            else:
                FRodzic = "AND nr_zlec_rodzic = '"+Rodzic+"'"
                
            SQL = "SELECT TRIM(nr_zlec) FROM rs_zamowienia_odbiorcy_pozycje_zlecenia WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            SQL+=" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+FRodzic+" ORDER BY nr_zlec DESC LIMIT 1"
            stat,DNumeru,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat= u'Bd pobierania danych o wolnym numerze zlecenia :'+stat
            
            if stat == 'OK':
                if Rodzic == '':
                    if len(DNumeru) == 0:
                        WolnyNr='01'
                    else:
                        WolnyNr = int(DNumeru[0][0][-2:])+1
                        if WolnyNr > 9:
                            WolnyNr = str(WolnyNr)
                        else:
                            WolnyNr = '0'+str(WolnyNr)
                elif len(DNumeru) == 0:        
                    WolnyNr = Rodzic+'.01'
                else:
                    WolnyNr = int(DNumeru[0][0][-2:])+1
                    if WolnyNr > 9:
                        WolnyNr = Rodzic+'.'+str(WolnyNr)
                    else:
                        WolnyNr = Rodzic+'.0'+str(WolnyNr)
            
                PoczatekZlecenia = WolnyNr[:2]
                LDoZmiany = [WolnyNr]
    
        # dodanie pozycji do zlecenia
        if stat=='OK':
            if Rodzic == '':
                NrRodzica = 'NULL'
            else:
                NrRodzica = "'"+Rodzic+"'"
                
            if Typ == '04':
                Masa = str(Przel)
            else:
                Masa = '0'
                
            SQL="INSERT INTO rs_zamowienia_odbiorcy_pozycje_zlecenia "
            SQL+=" (firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,nr_zlec,nr_zlec_rodzic,"
            SQL+="artykul_id,cecha1_opis,cecha1_wartosc,ilosc1,masa1,automat,"
            SQL+="ilosc_calk,masa_calk) "
            SQL+=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","+NrPoz+","+NrPpoz+",'"+WolnyNr+"',"+NrRodzica+","
            if Masa <> 0 and JmZlec == '2':
                SQL+="'"+Artykul+"',"+CechaOpis+",'"+CechaWart+"',"+str(Ilosc)+"/"+Masa+","+Masa+",FALSE,"
                SQL+="ROUND("+str(Ilosc*IloscRodzica)+"/"+Masa+",4),"+str(Ilosc*IloscRodzica)+")"
            else:
                SQL+="'"+Artykul+"',"+CechaOpis+",'"+CechaWart+"',"+str(Ilosc)+","+Masa+",FALSE,"
                SQL+=str(Ilosc*IloscRodzica)+","+Masa+"*"+str(Ilosc*IloscRodzica)+")"
                
            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                stat= u'Bd wstawienia pozycji podstawowej :'+stat
            
    # tu zaczynamy prb rozbijania artykuu z parametrami
    if stat == 'OK' and Funkcja == 4:
        SQL="SELECT artykul_id,cecha1_wartosc,ilosc1 FROM rs_zamowienia_odbiorcy_pozycje_zlecenia"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        SQL+=" AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec='"+Zlecenie+"';"
        stat,DZlec,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat= u'Bd pobierania pozycji podstawowej :'+stat
        elif len(DZlec) ==0:
            stat= u'Podano bdny numer pozycji podstawowej :'+Zlecenie
        else:
            WolnyNr = Zlecenie
            Artykul = DZlec[0][0]
            CechaWart = DZlec[0][1]
            Ilosc = DZlec[0][2]
            IloscRodzica = 1
                
    if stat =='OK':
        LRodzicow = [(WolnyNr,Artykul,CechaWart,Ilosc*IloscRodzica,Parametry)]
        rsglobal.ZapiszDoLogow('5 LRodzicow '+str(LRodzicow),1) 
    # ptla pseudorekurencyjna - jeli jest zestaw/zlecenie z zamwienia to tworzymy kolejne pozycje 
    # przy okazji pobierajc dalsze zestawy
    
    LDoPodaniaParam = [] # lista pozycji, ktre wymagaj podania parametrw do wzorw
    while stat == 'OK' and len(LRodzicow) > 0:
        rsglobal.ZapiszDoLogow('6 '+str(LRodzicow),1)
        LRodzicowN =[]
        for poz in LRodzicow:
            if stat == 'OK':
                WylaczycOdswiezanie = True
                rsglobal.ZapiszDoLogow('poz '+str(poz),1)
                stat,DaneZest = fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.PodajZestawDlaArtykuluWZleceniach(self,poz[1],poz[2],Kontrahent,Data,[Wyznacznik,Data,Numer,NrPoz,NrPpoz],poz[0],poz[4])
                rsglobal.ZapiszDoLogow('stat!! '+str(stat),1)
                rsglobal.ZapiszDoLogow('DaneZest '+str(DaneZest),1)                    
                if stat <> 'OK':
                    if stat[:4] == 'BLWZ'  and Parametry == '': # zakadamy, e to przez puste parametry, ktre trzeba poda
                        LDoPodaniaParam.append(poz[0])
                        stat = 'OK'
                        DaneZest = []
                    elif stat[:4] == 'BLWZ':
                        stat = stat[4:]
                        self.PolSQL.Rollback()
                    WylaczycOdswiezanie = False
                    SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET do_odswiezenia = TRUE "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                    SQL+=" AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec='"+str(poz[0])+"';"
                    rsglobal.ZapiszDoLogow('SQLODSW '+SQL,1)
                    statpom,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    rsglobal.ZapiszDoLogow('statpom '+statpom,1)
                    if statpom <> 'OK':
                        if stat == 'OK':
                            stat= u'Bd ustawiania pozycji na "do odwieenia" :'+stat
                        else:
                            stat+= u'\nBd ustawiania pozycji na "do odwieenia" :'+stat
                    rsglobal.ZapiszDoLogow('stat po blad'+stat,1)
                
            if stat == 'OK' and WylaczycOdswiezanie:
                SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET do_odswiezenia = FALSE "
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                SQL+=" AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec='"+str(poz[0])+"' AND do_odswiezenia;"
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat <> 'OK':
                    stat= u'Bd ustawiania pozycji na "nie do odwieenia" :'+stat
                    
            if stat == 'OK':
                NrDod =1
                rsglobal.ZapiszDoLogow('DaneZest2 '+str(DaneZest),1)                    
                for skladnik in DaneZest:
                    if stat=='OK':
                        if NrDod > 9:
                            KolejnyNr = poz[0]+'.'+str(NrDod)
                        else:
                            KolejnyNr = poz[0]+'.0'+str(NrDod)
                        
                        #sprawdzenie czy skadnik jest surowcem
                        SQLSur = "SELECT typ_artykulu,przelicznik,jm_zlecen FROM rs_artykuly"
                        SQLSur+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+skladnik[0]+"'"
                        stat,DSur,dump,dump=self.PolSQL.Execute(SQLSur,3)
                        if stat <> 'OK':
                            stat= u'Bd pobierania danych skadnika :'+stat
                    
                    if stat=='OK':
                        if DSur[0][0] == '04':
                            MasaSkl = DSur[0][1]
                        else:
                            MasaSkl = 0
                            
                        # wstawienie skadnika
                        SQL="INSERT INTO rs_zamowienia_odbiorcy_pozycje_zlecenia "
                        SQL+=" (firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,nr_zlec,nr_zlec_rodzic,"
                        SQL+="artykul_id,cecha1_opis,cecha1_wartosc,ilosc1,masa1,automat,"
                        SQL+="ilosc_calk,masa_calk,zrodlo) "
                        SQL+=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","+NrPoz+","+NrPpoz+",'"+KolejnyNr+"','"+poz[0]+"',"
                        if MasaSkl <> 0 and DSur[0][2] == '2':
                            SQL+="'"+skladnik[0]+"','"+skladnik[1]+"','"+skladnik[2]+"',"+str(skladnik[3])+"/"+str(MasaSkl)+","+str(MasaSkl)+",TRUE,"
                            SQL+="ROUND("+str(skladnik[3])+"*"+str(poz[3])+"/"+str(MasaSkl)+",4),"+str(skladnik[3])+"*"+str(poz[3])
                        else:
                            SQL+="'"+skladnik[0]+"','"+skladnik[1]+"','"+skladnik[2]+"',"+str(skladnik[3])+","+str(MasaSkl)+",TRUE,"
                            SQL+=str(skladnik[3])+"*"+str(poz[3])+","+str(MasaSkl)+"*"+str(skladnik[3])+"*"+str(poz[3])
                        SQL+=",'"+skladnik[4]+"');"
                        
                        # automat rodzica na TRUE
                        SQL+="UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia "
                        SQL+=" SET automat=TRUE"
                        SQL+=" WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
                        SQL+=" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec = '"+poz[0]+"'"
                        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                        if stat <> 'OK':
                            stat= u'Bd wstawienia pozycji skadnika :'+stat
                        else:
                            LRodzicowN.append((KolejnyNr,skladnik[0],skladnik[2],skladnik[3]*poz[3],''))
                            
                        NrDod+=1
                        
        if stat=='OK':
            LRodzicow = eval(str(LRodzicowN))
            wyn2 = LDoPodaniaParam

#-------------------------------------------------------------------------------
#    usuwanie pozycji (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprModyfikacja:
        stat = 'Brak uprawnie do modyfikacji zlece'
    
    if stat == 'OK':
        stat = fs_zamowienia_odbiorcy_pom.UsunPlikiZamowienia(self,Wyznacznik,Data,Numer,NrPoz,NrPpoz,Zlecenie)

    if stat == 'OK':    
        # usunicie poddrzewa
        SQL="DELETE FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        SQL+=" AND numer ="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec LIKE '"+Zlecenie+"%';"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        
        if Zlecenie <> '':
            PoczatekZlecenia = Zlecenie[:2]
            LDoZmiany = [Zlecenie[:-3]]
            
    if stat =='OK':
        # przenumerowanie kolejnych poddrzew
        Rodzic = Zlecenie[:-3]
        if Rodzic =='':
            RodzicF = 'IS NULL'
        else:
            RodzicF = " = '"+Rodzic+"'"
            
        SQL="SELECT TRIM(nr_zlec) FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        SQL+=" AND numer ="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz
        SQL+=" AND nr_zlec_rodzic "+RodzicF+" AND nr_zlec > '"+Zlecenie+"' ORDER BY nr_zlec;"
        stat,DZlecen,dump,dump=self.PolSQL.Execute(SQL,3)
        
    if stat =='OK':    
        for poz in DZlecen:
            if stat == 'OK':
                SQL="UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia "
                SQL+=" SET nr_zlec = '"+Zlecenie+"'||SUBSTRING(nr_zlec FROM LENGTH('"+Zlecenie+"')+1)"
                SQL+="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                SQL+=" AND numer ="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz
                SQL+=" AND nr_zlec LIKE '"+poz[0]+"%';"
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            
            if stat=='OK':
                WolnyNr = int(Zlecenie[-2:])+1
                if Zlecenie.find('.')> -1:
                    if WolnyNr > 9:
                        Zlecenie = Zlecenie[:-3]+'.'+str(WolnyNr)
                    else:
                        Zlecenie = Zlecenie[:-3]+'.0'+str(WolnyNr)
                else:
                    if WolnyNr > 9:
                        Zlecenie = str(WolnyNr)
                    else:
                        Zlecenie = '0'+str(WolnyNr)

#-------------------------------------------------------------------------------
#    zmiana iloci pozycji (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if not UprModyfikacja:
        stat = 'Brak uprawnie do modyfikacji zlece'
        
    if stat == 'OK':
        SPrzel = {}
        WierszeNr = Update[-1]
        
        for i in xrange(len(Update[0])):
            if stat =='OK':
                # pobranie informacji o pozycji - typ artykuu i dotychczasowa ilo
                SQL="SELECT a.typ_artykulu,zl.ilosc1,COALESCE(zl.nr_zlec_rodzic,''),jm1.calkowita"
                SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zl"
                SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
                SQL+=" INNER JOIN rs_jednostki_miar jm1 ON (jm1.firma_id=a.firma_id AND jm1.kod = a.jm1)"
                SQL+="WHERE zl.firma_id='"+self.firma_id+"'" 
                SQL+=" AND zl.wyznacznik_id='"+Wyznacznik+"' AND zl.data='"+Data+"' AND zl.numer ="+Numer
                SQL+=" AND zl.nr_poz="+NrPoz+" AND zl.nr_ppoz="+NrPpoz
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['nr_zlec']:
                        SQL+= " AND "+pole+"='"+wart+"'"
                        Zlec = wart
                
                stat,DZlec,dump,dump = self.PolSQL.Execute(SQL,3)
            
            if stat =='OK':
                Typ = DZlec[0][0]
                IloscS = DZlec[0][1]
                Rodzic = DZlec[0][2]
                Calkowita = DZlec[0][3]
                IloscRodzica = 1
                
                
                # jeli ma rodzica i typ jest nie surowiec (04) to sprawdzamy jego ilo w celu
                # sprawdzenia czy w pozycji jest wielokrotno iloci rodzica
                if Typ <> '04' and Rodzic <> '':
                    SQL="SELECT ilosc1 FROM rs_zamowienia_odbiorcy_pozycje_zlecenia"
                    SQL+=" WHERE firma_id='"+self.firma_id+"'" 
                    SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer ="+Numer
                    SQL+=" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec='"+Rodzic+"'"
                    stat,DRodzic,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat == 'OK':
                        if len(DRodzic) == 0:
                            stat = 'Niespjno zlecenia - brak zlecenia '+Rodzic
                    if stat == 'OK':
                        IloscRodzica = DRodzic[0][0]
                
            if stat =='OK':
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
        
                    if pole == 'artykul_id':
                        if wart.strip() == '':
                            wyn2.append((WierszeNr[i],1))
                            dane.append('BR ART')
                        else:
                            SQL="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"';"
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat =='OK':
                                if len(DTest) == 0:
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append('BL ART')    
                        
                    elif pole == 'ilosc1':
                        # sprawdzenie czy ilo > 0
                        if wart <= 0:
                            wyn2.append((WierszeNr[i],6))
                            dane.append('BL ILOSC 0')
                    
                        # sprawdzenie czy liczba cakowita jeli cakowita w jednostce miar
                        if Calkowita:
                            if wart <> rsglobal.RSRound(wart,0):
                                wyn2.append((WierszeNr[i],6))
                                dane.append('BL ILOSC C')
                        SPrzel[Zlec] = "*"+str(wart)+'/'+str(IloscS)
                                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['ilosc1','ilosc_calk']:
                        SET+=pole+"="+str(wart)+","
                    if pole in ['artykul_id','cecha1_opis','cecha1_wartosc']:
                        SET+=pole+"='"+str(wart)+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                WHERE+=" AND data='"+Data+"' AND numer ="+Numer
                WHERE+=" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['nr_zlec']:
                        WHERE+= " AND "+pole+"='"+wart+"'"
                        Zlec=wart
                        PoczatekZlecenia = Zlec[:2]
                        LDoZmiany.append(Zlec)

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE
                
                # update na potencjalnych podpozycjach - masowy ( jeli zmieniono ilo)
                if Zlec in SPrzel:
                    sql+="UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET ilosc_calk = ilosc_calk"+SPrzel[Zlec]
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                    sql+=" AND data='"+Data+"' AND numer ="+Numer
                    sql+=" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND nr_zlec LIKE '"+Zlec+".%';"
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)

    if stat=="OK":
        # sprawdzenie czy wszystkie pary cecha1_opis i cecha1_wartosc s zgodne i poprawne
        SQL="SELECT zz.nr_zlec,zz.artykul_id,zz.cecha1_opis,zz.cecha1_wartosc"
        SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zz "
        SQL+=" WHERE zz.firma_id='"+self.firma_id+"' AND zz.wyznacznik_id='"+Wyznacznik+"'"
        SQL+=" AND zz.data='"+Data+"' AND zz.numer ="+Numer
        SQL+=" AND zz.nr_poz="+NrPoz+" AND zz.nr_ppoz="+NrPpoz
        SQL+=" AND rsf_podaj_parametry_cechy(zz.firma_id,zz.cecha1_opis,zz.cecha1_wartosc,'poprtech') = 'FALSE'"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if len(DTest)>0:
            stat='Bdne pary cecha/warto w zleceniach w wybranej pozycji:\n'
            for poz in DTest:
                stat+="("+poz[0].strip()+") "+poz[1].strip()+" / "+poz[2].strip()+"\n"

#-------------------------------------------------------------------------------
#    przeliczenie masy i zaznaczenie zmiany (1,3,6)
#-------------------------------------------------------------------------------

if Funkcja in [1,3,6] and stat == 'OK':
    stat = fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.PrzeliczMasyZlecen(self,[Wyznacznik,Data,Numer,NrPoz,NrPpoz],PoczatekZlecenia)
    if stat == 'OK':
        for ZlecZm in LDoZmiany:
            stat = fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.UstawZmienioneNaZleceniach(self,ZlecZm,[Wyznacznik,Data,Numer,NrPoz,NrPpoz])        

#-------------------------------------------------------------------------------
#    sprawdzenie uzupenienia surowcw (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == 'OK':
    stat,dane = fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.SprawdzSurowceWPozycji(self,[Wyznacznik,Data,Numer,NrPoz,NrPpoz])

#-------------------------------------------------------------------------------
# -- pobranie danych (1,3,4,5,6)
#-------------------------------------------------------------------------------

if (Funkcja in [1,3,4,5,6]) and (stat=='OK'):
    SQL="SELECT TRIM(zl.nr_zlec),COALESCE(TRIM(zl.nr_zlec_rodzic),''),TRIM(zl.artykul_id),TRIM(a.nazwa)," # 0 - 3
    SQL+="COALESCE(TRIM(zl.cecha1_opis),''),COALESCE(TRIM(zl.cecha1_wartosc),''),"   # 4 - 5
    SQL+=" rsf_podaj_parametry_cechy(zl.firma_id,zl.cecha1_opis,zl.cecha1_wartosc,'opis')," # 6
    SQL+="zl.ilosc1,zl.masa1,zl.automat,zl.zmieniony,a.typ_artykulu," # 7 - 11
    SQL+=" zl.ilosc_calk, zl.masa_calk, COALESCE(TRIM(zl.zrodlo),''),COALESCE(TRIM(zl.parametry),'')," # 12 - 15
    SQL+=" COALESCE(zl.do_odswiezenia,FALSE) " # 16
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zl "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+="WHERE zl.firma_id='"+self.firma_id+"'" 
    SQL+=" AND zl.wyznacznik_id='"+Wyznacznik+"' AND zl.data='"+Data+"' AND zl.numer ="+Numer
    SQL+=" AND zl.nr_poz="+NrPoz+" AND zl.nr_ppoz="+NrPpoz+"ORDER BY zl.nr_zlec;"
		
    stat,DaneZlec,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        dane = [DaneZlec,'Z']
    
    # sprawdzenie stanu zamwienia
    if stat=='OK':
        SQL = "SELECT stan FROM rs_zamowienia_odbiorcy "
        SQL+="WHERE firma_id='"+self.firma_id+"'" 
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer ="+Numer
        stat,DZamow,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DZamow)>0:
            dane[1] = DZamow[0][0]
            
    if stat == 'OK':
        if Funkcja == 1:
            dane =dane[0]
            
rsglobal.ZapiszDoLogow('stat koncowy '+stat,1)