#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.py
# Purpose:		funkcje pomocnicze do zlece w pozycjach zamwie odbiorcw
# Author:		Micha Raburski
# Created:		2014/09/09
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje_zlecenia_pom.py $
# Copyright:	(c) 2014 RecordSystem
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Sprawdza, czy dla wybranych parametrw (w kolejnoci wanoci):
# - artyku ma wzr - jeli tak, to ma on pierwszestwo przed innymi metodami wyznaczania podzestawu
# - istnieje zestaw (najpierw dla kontrahenta, potem oglny)
# - czy istnieje ten artyku w innych zamwieniach i czy nie byo ju takiego zestawu w zamwieniach 
# (najpierw w zamwieniach dla kontrahenta a potem we wszystkich)
#-------------------------------------------------------------------------------

def PodajZestawDlaArtykuluWZleceniach(self,Artykul,Cecha,Kontrahent,Data,KlPozZam,Zlec,Parametry):
    import rsglobal
    from funkcje import fs_artykuly_wzory_parametry_pom
    
    # sprawdzenie czy artyku ma wzr
    SQL = "SELECT COALESCE(wzor_zlecenia,'') FROM rs_artykuly "
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Artykul+"';"
    stat,DWzor,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania wzoru z artykuu :'+stat,[]

    if DWzor[0][0] <> '':
        stat,DaneZest = fs_artykuly_wzory_parametry_pom.PodajPodzleceniaDlaArtykuluZeWzorem(self,KlPozZam,Zlec,Artykul,Cecha,Parametry,False)
        if stat <> 'OK':
            return stat,DaneZest
        if len(DaneZest) > 0:
            return stat,DaneZest
    
    # sprawdzenie czy jest definicja w zestawach z uzwgldnieniem kontrahenta
    SQL = " SELECT artykul_id,COALESCE(cecha1_opis_a,''),COALESCE(cecha1_wartosc_a,''), ilosc1,"
    SQL+="zestaw_id||' / '||COALESCE(cecha1_opis_z,'')||' / '||kontrahent_id"
    SQL+= " FROM rs_artykuly_zestawy WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Artykul+"' "
    if Cecha <> '':
        SQL+=" AND TRIM(cecha1_wartosc_z)=TRIM('"+Cecha+"')"
    SQL+=" AND kontrahent_id='"+Kontrahent+"' ORDER BY artykul_id,cecha1_wartosc_a"
    stat,DaneZest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania zestawu z kontrahentem :'+stat,[]
    rsglobal.ZapiszDoLogow('DZ1SQL '+str(SQL),1)
    rsglobal.ZapiszDoLogow('DZ1 '+str(DaneZest),1)
    if len(DaneZest) > 0:
        return 'OK',DaneZest
    
    # sprawdzenie czy jest definicja w zestawach bez kontrahenta
    SQL = " SELECT artykul_id,COALESCE(cecha1_opis_a,''),COALESCE(cecha1_wartosc_a,''), ilosc1,"
    SQL+="zestaw_id||' / '||COALESCE(cecha1_opis_z,'')||' / '||kontrahent_id"
    SQL+= " FROM rs_artykuly_zestawy WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Artykul+"' "
    if Cecha <> '':
        SQL+=" AND TRIM(cecha1_wartosc_z)=TRIM('"+Cecha+"')"
    SQL+=" AND kontrahent_id ='ZS' ORDER BY artykul_id,cecha1_wartosc_a"
    stat,DaneZest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania zestawu bez kontrahenta :'+stat,[]
    rsglobal.ZapiszDoLogow('DZ2SQL '+str(SQL),1)
    rsglobal.ZapiszDoLogow('DZ2 '+str(DaneZest),1)
    if len(DaneZest) > 0:
        return 'OK',DaneZest
    
    # sprawdzenie czy jest definicja w innym zleceniu w zamwieniach z uwzgldnieniem kontrahenta
    SQL= " SELECT zl.wyznacznik_id,zl.data,zl.numer,zl.nr_poz,zl.nr_ppoz,zl.nr_zlec,ilosc1 "
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zl"
    SQL+=" INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer)"
    SQL+=" WHERE zl.firma_id='"+self.firma_id+"' AND zl.data<='"+Data+"' AND zl.artykul_id='"+Artykul+"'"
    if Cecha <> '':
        SQL+=" AND zl.cecha1_wartosc='"+Cecha+"'"
    if KlPozZam <> []:
        SQL+=" AND NOT (zl.wyznacznik_id='"+KlPozZam[0]+"' AND zl.data='"+KlPozZam[1]+"'"
        SQL+=" AND zl.numer="+str(KlPozZam[2])+" AND zl.nr_poz="+str(KlPozZam[3])+" AND zl.nr_ppoz="+str(KlPozZam[4])+")"
    SQL+=" AND zo.kontrahent_id='"+Kontrahent+"' ORDER BY zl.data DESC, zl.numer DESC" 
    stat,DPozZam,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania pozycji zamwienia z kontrahentem :'+stat,[]
    rsglobal.ZapiszDoLogow('DPZ1 '+str(DPozZam),1)
    
    for poz in DPozZam:
        SQL = " SELECT artykul_id,COALESCE(cecha1_opis,''),COALESCE(cecha1_wartosc,''), ilosc1,"
        SQL+="wyznacznik_id||'/'||data||'/'||numer||'/'||nr_poz||'/'||nr_ppoz||'/'||nr_zlec"
        SQL+= " FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+poz[0]+"' "
        SQL+=" AND data='"+poz[1]+"' AND numer="+str(poz[2])+" AND nr_poz="+str(poz[3])
        SQL+=" AND nr_ppoz="+str(poz[4])+" AND nr_zlec_rodzic='"+poz[5]+"' ORDER BY nr_zlec"
        stat,DaneZest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return u'Bd pobierania zestawu z zamwienia z kontrahentem :'+stat,[]
        rsglobal.ZapiszDoLogow('DZ3 '+str(DaneZest),1)
        if len(DaneZest) > 0:
            return 'OK',DaneZest
    
    # sprawdzenie czy jest definicja w innym zleceniu w zamwieniach bez kontrahenta
    SQL= " SELECT zl.wyznacznik_id,zl.data,zl.numer,zl.nr_poz,zl.nr_ppoz,zl.nr_zlec, ilosc1 "
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zl"
    SQL+=" INNER JOIN rs_zamowienia_odbiorcy zo USING (firma_id,wyznacznik_id,data,numer)"
    SQL+=" WHERE zl.firma_id='"+self.firma_id+"' AND zl.data<='"+Data+"' AND zl.artykul_id='"+Artykul+"'"
    if Cecha <> '':
        SQL+=" AND zl.cecha1_wartosc='"+Cecha+"'"
    if KlPozZam <> []:
        SQL+=" AND NOT (zl.wyznacznik_id='"+KlPozZam[0]+"' AND zl.data='"+KlPozZam[1]+"'"
        SQL+=" AND zl.numer="+str(KlPozZam[2])+" AND zl.nr_poz="+str(KlPozZam[3])+" AND zl.nr_ppoz="+str(KlPozZam[4])+")"        
    SQL+=" AND NOT zo.kontrahent_id='"+Kontrahent+"' ORDER BY zl.data DESC, zl.numer DESC" 
    stat,DPozZam,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania pozycji zamwienia bez kontrahenta :'+stat,[]
    
    for poz in DPozZam:
        SQL = " SELECT artykul_id,COALESCE(cecha1_opis,''),COALESCE(cecha1_wartosc,''), ilosc1,"
        SQL+="wyznacznik_id||'/'||data||'/'||numer||'/'||nr_poz||'/'||nr_ppoz||'/'||nr_zlec"
        SQL+= " FROM rs_zamowienia_odbiorcy_pozycje_zlecenia "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+poz[0]+"' "
        SQL+=" AND data='"+poz[1]+"' AND numer="+str(poz[2])+" AND nr_poz="+str(poz[3])
        SQL+=" AND nr_ppoz="+str(poz[4])+" AND nr_zlec_rodzic='"+poz[5]+"' ORDER BY nr_zlec"
        stat,DaneZest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            return u'Bd pobierania zestawu z zamwienia bez kontrahenta :'+stat,[]
        rsglobal.ZapiszDoLogow('DZ4 '+str(DaneZest),1)
        if len(DaneZest) > 0:
            return 'OK',DaneZest
    
    return 'OK',[]

#-------------------------------------------------------------------------------
# Przelicza masy zlecen. Czasem dla caej pozycji zamwienia, a czasem dla wybranego zlecenia
#-------------------------------------------------------------------------------

def PrzeliczMasyZlecen(self,KlPozZam,Zlecenie=''):
    import rsglobal
    # pobranie pozycji zlece w kolejnoci od najduszych do najkrtszych
    SQL ="SELECT TRIM(nr_zlec),COALESCE(TRIM(nr_zlec_rodzic),''),ilosc1,masa1,ilosc_calk FROM rs_zamowienia_odbiorcy_pozycje_zlecenia"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"' AND data='"+KlPozZam[1]+"'"
    SQL+=" AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])+" AND nr_ppoz="+str(KlPozZam[4])
    if Zlecenie <> '':
        SQL+=" AND nr_zlec LIKE '"+Zlecenie[:2]+"%'"    
    SQL+=" ORDER BY nr_zlec DESC"
    stat,DaneZlec,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania danych o zleceniach w celu zliczenia masy : '+stat
    
    # sprawdzamy w ptli. Jeli artyku jest ostatni (nie byo duszego od niego do tej pory)
    # to bierzemy jego mas z bazy (zakadamy, e to surowiec)
    # jeli ju byy jego skadowe to je dodajemy wyliczajc wspln mas, dzielimy przez ilo w pozycji
    # i tak rekurencyjnie w gr

    # sownik z kluczem - nr zlecenia, wynik to [ilosc,masa,[dzieci]]
    SZlecen = {}
    for poz in DaneZlec:
        # jeli go nie ma to nie mia dzieci = surowiec
        if not poz[0] in SZlecen:
            SZlecen[poz[0]] = [poz[2],poz[3],[]]
            
        else:
            # jest czyli mia dzieci. Wstawiamy ilo i wyliczamy now mas
            SZlecen[poz[0]][0] = poz[2]
            
            Masa = 0
            for dziecko in SZlecen[poz[0]][2]:
                Masa+=SZlecen[dziecko][0]*SZlecen[dziecko][1]
                        
            SZlecen[poz[0]][1] = Masa
        
        # do rodzica dodajemy dziecko
        if poz[1] <> '':
            if not poz[1] in SZlecen:
                SZlecen[poz[1]] = [0,0,[poz[0]]]
            else:
                SZlecen[poz[1]][2].append(poz[0])
    
    # na koniec robimy update'y dla nieostatnich wierszy
    for kl in SZlecen.keys():
        if len(SZlecen[kl][2]) > 0:
            SQL = "UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia "
            SQL+=" SET masa1="+str(SZlecen[kl][1])+", masa_calk=ilosc_calk*"+str(SZlecen[kl][1])
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"' AND data='"+KlPozZam[1]+"'"
            SQL+=" AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])+" AND nr_ppoz="+str(KlPozZam[4])
            SQL+=" AND nr_zlec='"+kl+"';"
            rsglobal.ZapiszDoLogow('SQL '+SQL,1)
            stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                return u'Bd zmiany masy w zleceniach : '+stat
    return 'OK'

#-------------------------------------------------------------------------------
# Sprawdza czy dla wszystkich pozycji na najniszym poziomie s surowce
#-------------------------------------------------------------------------------

def SprawdzSurowceWPozycji(self,KlPozZam):
    SQL ="SELECT TRIM(zl.nr_zlec),COALESCE(TRIM(zl.nr_zlec_rodzic),''),a.typ_artykulu "
    SQL+=" FROM rs_zamowienia_odbiorcy_pozycje_zlecenia zl INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"' AND data='"+KlPozZam[1]+"'"
    SQL+=" AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])+" AND nr_ppoz="+str(KlPozZam[4])
    SQL+=" ORDER BY nr_zlec DESC"
    stat,DaneZlec,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobierania danych o zleceniach w celu sprawdzenia surowcw : '+stat,[]
    
    # sprawdzamy w ptli. Jeli artyku jest ostatni (nie byo duszego od niego do tej pory)
    # to sprawdzamy jego typ i jeli nie surowiec to dodajemy do listy bdnych zlece
    # jeli ju byy jego skadowe to dodajemy go do listy i nic nie sprawdzamy
    # i tak rekurencyjnie w gr

    # sownik z kluczem - nr zlecenia, wynik to [dzieci]
    SZlecen = {}
    LNiesurowcow = []
    for poz in DaneZlec:
        # jeli go nie ma to nie mia dzieci = surowiec
        if not poz[0] in SZlecen:
            if poz[2] <> '04':
                LNiesurowcow.append(poz[0])
        
        # do rodzica dodajemy dziecko (wystarczy jedno)
        if poz[1] <> '':
            if not poz[1] in SZlecen:
                SZlecen[poz[1]] = [poz[0]]
    
    LNiesurowcow.sort()
    
    return 'OK',LNiesurowcow

#-------------------------------------------------------------------------------
# Ustawia zmienione dla analizowanego zlecenia
#-------------------------------------------------------------------------------

def UstawZmienioneNaZleceniach(self,Zlec,KlPozZam):
    import rsglobal
    # jeli zlecenie jest najwyszego poziomu to nie ma co sprawdza
    if Zlec.find('.') == -1:
        return 'OK'
    
    # sprawdzamy, czy podane zlecenie lub jego rodzice maj gdzie wczony automat
    Automat = False
    LZmiana = []
    while Zlec <> '': 
        if not Automat:
            SQL='SELECT automat FROM rs_zamowienia_odbiorcy_pozycje_zlecenia'
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"' AND data='"+KlPozZam[1]+"'"
            SQL+=" AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])+" AND nr_ppoz="+str(KlPozZam[4])
            SQL+=" AND nr_zlec='"+Zlec+"'"
            stat,DaneZlec,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                return u'Bd pobierania danych o zleceniach w celu sprawdzenia automatu : '+stat
            if len(DaneZlec) > 0:
                if DaneZlec[0][0]:
                    Automat=True
        
        LZmiana.append(str(Zlec))
        if Zlec.find('.') == -1:
            Zlec = ''
        else:
            Zlec = Zlec[:-3]
        
    # jeli tak, to robimy zmienione = TRUE
    if Automat:
        SQL="UPDATE rs_zamowienia_odbiorcy_pozycje_zlecenia SET zmieniony = TRUE "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+KlPozZam[0]+"' AND data='"+KlPozZam[1]+"'"
        SQL+=" AND numer="+str(KlPozZam[2])+" AND nr_poz="+str(KlPozZam[3])+" AND nr_ppoz="+str(KlPozZam[4])
        SQL+=" AND nr_zlec IN ("+str(LZmiana)[1:-1]+")"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            return u'Bd zmiany wiersza na zmienione : '+stat
        
    return 'OK'


#-------------------------------------------------------------------------------
# Sprawdza poprawno pozycji zlece ( dla poddrzewa wynikajcego z parametrw):
# - czy ilo cakowita < ilo zrealizowana + (ilo do produkcji - ilo wyprodukowana)
# - czy wszystkie iloci s >=0
# - czy ilo zaakceptowana do produkcji jest <= iloci zleconej do produkcji
# - czy ilo w produkcji jest <= iloci zaakceptowanej do produkcji
#-------------------------------------------------------------------------------

def SprawdzPoprawnoscZlecen(self,Wyzn,Data,Numer,NrPoz,NrPPoz,NrZlec=''):
    import rsglobal
    SQL = "SELECT wyznacznik_id||'/'||data||'/'||numer||'/'||numer||'/'||nr_poz||'/'||nr_ppoz||'/'||nr_zlec,"
    SQL+= " artykul_id,ilosc_calk,ilosc_do_produkcji,ilosc_produkowana,ilosc_wykonana,ilosc_braki,ilosc_rezerwacja,ilosc_zrealizowana "
    SQL+= " FROM rs_zamowienia_odbiorcy_pozycje_zlecenia WHERE firma_id = '"+self.firma_id+"'"
    if Wyzn <> '':
        SQL+=" AND wyznacznik_id = '"+Wyzn+"'"
    if Data <> '':
        SQL+=" AND data = '"+Data+"'"
    if Numer <> -1:
        SQL+=" AND numer = '"+str(Numer)+"'"
    if NrPoz <> -1:
        SQL+=" AND nr_poz = '"+str(NrPoz)+"'"
    if NrPPoz <> -1:
        SQL+=" AND nr_ppoz = '"+str(NrPPoz)+"'"
    if NrZlec <> '':
        SQL+=" AND nr_zlec LIKE '"+NrZlec.strip()+"%'"
    stat,Dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd pobrania zlecen zapytaniem \n : '+SQL+'\n\n'+stat
    
    
    for poz in Dane:
        Zlec = poz[0].strip();  Art = poz[1].strip();  IlCalk = poz[2];    IlZlec = poz[3];  IlProd = poz[4]
        IlWykon = poz[5];       IlBraki = poz[6];      IlRezerw = poz[7];  IlZreal = poz[8]
    
        PoczKom = 'Dla zlecenia '+Zlec+' z artykuem '+Art+' '
        
        # sprawdzenie czy wszystkie iloci s >=0
        if IlCalk < 0:
            return PoczKom+'ilo cakowita jest mniejsza od 0'
        if IlZlec < 0:
            return PoczKom+'ilo zlecona do produkcji jest mniejsza od 0'
        if IlProd < 0:
            return PoczKom+'ilo zaakceptowana do produkcji jest mniejsza od 0'
        if IlWykon < 0:
            return PoczKom+'ilo wyprodukowana jest mniejsza od 0'
        if IlBraki < 0:
            return PoczKom+'ilo brakw jest mniejsza od 0'
        if IlRezerw < 0:
            return PoczKom+'ilo zarezerwowana jest mniejsza od 0'
        if IlZreal < 0:
            return PoczKom+'ilo zrealizowana jest mniejsza od 0'
        
        # sprawdzenie czy ilo cakowita < ilo zrealizowana + (ilo do produkcji - ilo wyprodukowana)
        if IlCalk < IlZreal + (IlZlec - IlWykon):
            return PoczKom+'ilo cakowita mniejsza od iloci zrealizowanej i w produkcji'
        
        # sprawdzenie czy ilo zaakceptowana do produkcji jest > iloci zleconej do produkcji
        if IlZlec < IlProd:
            return PoczKom+'ilo produkowana jest wiksza od zleconej'
        
        # sprawdzenie czy ilo w produkcji jest < iloci wyprodukowanej
        if IlProd < IlWykon:
            return PoczKom+'ilo produkowana jest mniejsza od wykonanej'

    return 'OK'