# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_sumy.py
# Purpose:     zwraca list artykuw do wyprodukowania/ktre dla nas zostan wyprodukowane wybranego dnia
#
# Author:      Micha Raburski
#
# Created:     2009/08/02
# RCS-ID:      $Id: fs_zamowienia_sumy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-12-28 Mariusz Rajfura (5331) pobranie sum z dow.dost na pdst rs_boksy_trasy_dni
# 2016-01-11 Piotr Witkowski (9502) refaktoryzacja zamowien sumy (sprzedaz) i zamowien produkcja (produkcja)
# 2020-09-19 Jan Raburski (12128) 'tylko produkty' w pobieraniu danych

# 5  - przegladanie
# 10 - sprawdzenie operatora
# 11 - pobierz menu
# 16 - zamknij
# 17 - otworz
# 18 - sprawdzenie stanu przed otwarciem
# 19 - sprawdzenie stanu przed zamkniciem

import time

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'OddzialF': [5,11,16,17,18,19], 'DataF': [5,11,16,17,18,19], 'ZmianaF': [5,11,16,17],
           'ZmianaProdF': [5,11,16,17], 'TypOdbF': [5,11,16,17,18,19], 'FunkcjaOkna': [5,10,11,16,17],
           'DataPorF': [5,11,16,17], 'HalaF': [5,11,16,17,18,19], 'BezHaliF': [5,10,11,16,17], 'TylkoProdukty': [5,11,16,17]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_sumy z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    DodF = []
    if Funkcja in [5,11,16,17,18,19]:
        OddzialF = str(klucze['OddzialF'])
        DataF = str(klucze['DataF'])
        ZmianaF = str(klucze['ZmianaF'])
        ZmianaProdF = str(klucze['ZmianaProdF'])
        TypOdbF = str(klucze['TypOdbF'])
        DataPorF = str(klucze['DataPorF'])
        HalaF = str(klucze['HalaF'])
    if Funkcja in [5,10,11,16,17,18,19]:
        FunkcjaOkna = klucze['FunkcjaOkna']
        BezHaliF = klucze['BezHaliF']
    if Funkcja in [5,11,16,17]:
        TylkoProdukty = klucze['TylkoProdukty']

dane = [[]]
# wyn 2 skada si z listy uwag po imporcie oraz ze sownika do 5%-owych porwna na gridzie
wyn2=[[],{}]

UprPrz= (self.operator_id == STANDARD_OPERATOR_ID) or \
        (((self.oddzial_id,'121000') in self.uprawnienia and FunkcjaOkna==1) or \
        ((self.oddzial_id,'045000') in self.uprawnienia and FunkcjaOkna==2))

UprEdy= (self.operator_id == STANDARD_OPERATOR_ID) or \
        ((self.oddzial_id,'121000') in self.uprawnienia and FunkcjaOkna==1) 
        
UprZam= (self.operator_id == STANDARD_OPERATOR_ID) or \
        ((self.oddzial_id,'045016') in self.uprawnienia and FunkcjaOkna==2) 

UprOtw= (self.operator_id == STANDARD_OPERATOR_ID) or \
        ((self.oddzial_id,'045017') in self.uprawnienia and FunkcjaOkna==2) 
        
UprTworz= (self.operator_id == STANDARD_OPERATOR_ID) or \
        ((self.oddzial_id,'121013') in self.uprawnienia and FunkcjaOkna==1) 


#-------------------------------------------------------------------------------
# ewentualne pobranie pojedynczego oddziau
#-------------------------------------------------------------------------------

if Funkcja==10 and stat=='OK' and self.operator_id <> STANDARD_OPERATOR_ID:
    sql="SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND operator_id IN ("+self.operatorzy[1:-1]+")"
    stat,DOddz,dump,dump = self.PolSQL.Execute(sql,3)

    if stat=='OK' and len(DOddz)==1 and DOddz[0][0] <> '**':
        dane=[[DOddz[0][0]]]


#-------------------------------------------------------------------------------
# pobranie wszystkich oddzialow, ktre bdzie wida w gridzie
#-------------------------------------------------------------------------------

if Funkcja in [5,10,16,17] and stat=='OK' and FunkcjaOkna==2:
    sql="SELECT DISTINCT oddzial_zam FROM rs_produkcja_sumy "
    sql+=" WHERE firma_id='"+self.firma_id+"' ORDER BY oddzial_zam;"
    stat,DOddz,dump,dump = self.PolSQL.Execute(sql,3)

    if stat=='OK':
        dane.append(DOddz)


#-------------------------------------------------------------------------------
# sprawdzenie poprawnoci filtra i uprawnie do oddziau (5,11,16,17)
#-------------------------------------------------------------------------------

if Funkcja in [5,11,16,17] and stat=='OK':
    if not UprPrz:
        stat='Brak uprawnie do przegldania sum zamwie'  
    if OddzialF=='' and stat=='OK':
        stat='W filtrze naley poda konkretny oddzia'
    if DataF in ['','    -  -  '] and stat=='OK':
        stat='W filtrze naley poda konkretn dat'
    if stat=='OK' and not rsglobal.SprawdzCzyToData(DataF):
        stat='W filtrze podano bdn dat'

    #sprawdzenie uprawnie do oddziau    
    if stat=='OK':
        if self.operator_id <> STANDARD_OPERATOR_ID:
            sql="SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial WHERE firma_id='"+self.firma_id+"'"
            sql+=" AND oddzial_id IN ('"+OddzialF+"','**') AND operator_id IN ("+self.operatorzy[1:-1]+")"
            stat,DOddz,dump,dump = self.PolSQL.Execute(sql,3)
            if stat=='OK':
                if len(DOddz)==0:
                    stat='Nieprawidowy oddzia lub brak uprawnie do podanego oddziau'


#-------------------------------------------------------------------------------
# pobranie danych z konkretnego dnia (11)
#-------------------------------------------------------------------------------

if Funkcja==11 and stat=='OK':
    from funkcje import fs_artykuly_pom
    if not UprTworz:
        stat='Brak uprawnie do dodawania pozycji do sum zamwie'  

    # blokujemy dowody dostaw by tylko jeden operator na raz mgtworzy sumy zamwie
    # dla jednego oddziau
    if stat=='OK':
        SQL = "SELECT firma_id FROM rs_dowody_dostaw "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+OddzialF+"'"
        SQL+=" AND data='"+DataF+"' FOR UPDATE NOWAIT;"
        stat,DBlokada,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Proces tworzenia pozycji sum zamowie dla oddziau "+OddzialF+" dla dnia "+DataF+" jest juuruchomiony"
            
    if stat=='OK':
        # pobieramy zamknite hale dla oddziau
        sql="SELECT DISTINCT oddzial_prod,hala_id FROM rs_produkcja_sumy "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND data='"+DataF+"'"
        sql+=" AND oddzial_zam='"+OddzialF+"' AND typ_odbiorcy IS NULL AND stan='Z' ORDER BY oddzial_prod,hala_id;"
        stat,DHal,dump,dump = self.PolSQL.Execute(sql,3)
        
    if stat=='OK':    
        # usunicie starych danych (nie usuwamy zamknitych par oddzia/hala)
        sql="DELETE FROM rs_produkcja_sumy WHERE firma_id='"+self.firma_id+"' AND data='"+DataF+"'"
        sql+=" AND oddzial_zam='"+OddzialF+"' AND typ_odbiorcy IS NULL"
        if len (DHal) > 0:
            sql+=" AND NOT ("
            for para in DHal:
                sql+="(oddzial_prod = '"+para[0]+"' AND hala_id='"+para[1]+"') OR "
            sql= sql[:-3]
            sql+=")"
        
        sql+=";"
        
        # insert nowych danych
        Producent="rsf_podaj_oddzial_producenta(ddp.firma_id,"
        Producent+="rsf_podaj_oddzial_ekspedycji(ddp.firma_id,ddp.oddzial_id,ddp.trasa,ddp.data,ddp.tryb_dostawy),"
        Producent+="ddp.artykul_id,ddp.data,COALESCE(td.rzut,''))"
        
        HalaFun = "rsf_podaj_hale_produkcyjna(ddp.firma_id,"
        HalaFun+="rsf_podaj_oddzial_ekspedycji(ddp.firma_id,ddp.oddzial_id,ddp.trasa,ddp.data,ddp.tryb_dostawy),"
        HalaFun+="ddp.artykul_id,ddp.data,COALESCE(td.rzut,''))"
        
        Hala =" CASE WHEN "+HalaFun+" = '' THEN '00' ELSE "+HalaFun+" END"
        
        sql+="INSERT INTO rs_produkcja_sumy (firma_id,data,oddzial_zam,oddzial_prod,zmiana,zmiana_p,artykul_id,"
        sql+=" zamowione1,zamowione2,wyprodukowane1,wyprodukowane2,braki1,braki2,czas_wprowadzenia,stan,opis,hala_id)"
        sql+=" SELECT '"+self.firma_id+"','"+DataF+"','"+OddzialF+"',"+Producent+","
        sql+=" COALESCE(td.zmiana,'0'),COALESCE(td.zmiana,'0'),ddp.artykul_id,"
        sql+=" ROUND(SUM(ddp.ilosc_zam1),2),ROUND(SUM(ddp.ilosc_zam1)*a.przelicznik,2),"
        sql+=" 0,0,0,0,NOW(),'W','',"+Hala
        sql+=" FROM rs_dowody_dostaw_pozycje ddp "
        sql+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer) "
        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        sql+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (ddp.firma_id=td.firma_id AND ddp.tryb_dostawy=td.kod) "
        sql+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+OddzialF+"'"
        sql+=" AND ddp.data='"+DataF+"'"
        # uwzgldnienie zamknitych par oddzia/hala
        if len (DHal) > 0:
            sql+=" AND NOT ("
            for para in DHal:
                sql+="("+Producent+" = '"+para[0]+"' AND "+Hala+"='"+para[1]+"') OR "
            sql= sql[:-3]
            sql+=")"
        sql+=" GROUP BY "+Producent+",td.zmiana,ddp.artykul_id,a.przelicznik,a.typ_artykulu,"+HalaFun
        sql+=" HAVING  SUM(ddp.ilosc_zam1)<>0;"
        stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
        if stat <> 'OK':
            stat = 'Bd wstawiania danych do sum produkcji: '+stat
            
    if stat=='OK':
        # pobranie danych z dowodw dostaw (tylko dla artykuw z zaznaczonymi opakowaniami)
        SQL = "SELECT COALESCE(td.zmiana::TEXT,'0'),"+Producent+",ddp.artykul_id,ddp.ilosc_zam1,COALESCE(dd.platnik_id,''),"+Hala
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
        SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer) "
        SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (ddp.firma_id=td.firma_id AND ddp.tryb_dostawy=td.kod) "
        SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+OddzialF+"'"
        SQL+=" AND ddp.data='"+DataF+"' AND ddp.ilosc_zam1 > 0 AND a.tylko_w_opakowaniach;"
        stat,DArtOpak,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = 'Bd pobierania danych do wstawienia opakowa sum produkcji: '+stat
        
    if stat == 'OK':
        # stworzenie sownika z wyliczonymi opakowaniami
        SOpak = {} # klucz to zmiana, producent, artykul, opakowanie;  wynik to liczba opakowa
        
        for poz in DArtOpak:
            if stat == 'OK':
                Licz22=0
                # wyznaczenie podziau na opakowania
                stat,SOpakArt = fs_artykuly_pom.PodajOpakowaniaDlaArtykulu(self,poz[2],poz[3],poz[4],'','',0)
            if stat == 'OK':
                for opak in SOpakArt:
                    # odrzucamy te z zamknitych hal
                    if [poz[1],poz[5]] not in DHal:
                        kl = (poz[0],poz[1],poz[2],opak,poz[5]) # zmiana, producent, artykul,opakowanie, hala
                
                        if not kl in SOpak:
                            SOpak[kl] = SOpakArt[opak]
                        else:
                            SOpak[kl] += SOpakArt[opak]
    
    if stat == 'OK':                    
        # wstawienie pozycji ze sownika do rs_produkcja_sumy_opakowania 
        for kl in SOpak:
            if stat == 'OK' and SOpak[kl] >0:
                # pole czas wprowadzenia jest nieznane i potrzebne do klucza obcego.
                CzasWprow = "(SELECT czas_wprowadzenia FROM rs_produkcja_sumy WHERE firma_id='"+self.firma_id+"'"
                CzasWprow+= " AND data='"+DataF+"' AND oddzial_zam='"+OddzialF+"' AND oddzial_prod='"+kl[1]+"'"
                CzasWprow+= " AND zmiana='"+kl[0]+"' AND artykul_id='"+kl[2]+"'  AND typ_odbiorcy IS NULL)"

                SQL = "INSERT INTO rs_produkcja_sumy_opakowania (firma_id,data,oddzial_zam,oddzial_prod,zmiana,artykul_id,"
                SQL+=" czas_wprowadzenia,hala_id,opakowanie_id,ilosc) "
                SQL+=" VALUES ('"+self.firma_id+"','"+DataF+"','"+OddzialF+"','"+kl[1]+"','"+kl[0]+"','"+kl[2]+"',"
                SQL+= CzasWprow+",'"+kl[4]+"','"+kl[3]+"',"+str(SOpak[kl])+");"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat <> 'OK':
                    stat = 'Bdy wstawiania danych do opakowa sum produkcji : '+stat

    # jeli podana jest data porwnawcza to sprawdzamy czy nie ma nowych artykuw lub czy nie zabrako artykuw 
    # z dnia porwnania
    if stat=='OK':
        ListaUwag=[[],[]]
        if DataPorF <> '    -  -  ' and rsglobal.SprawdzCzyToData(DataPorF):
            #pobranie artykuw dla pobieranego dnia
            SQL="SELECT DISTINCT artykul_id FROM rs_produkcja_sumy "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_zam='"+OddzialF+"'"
            SQL1=SQL+" AND data='"+DataF+"' ORDER BY artykul_id;"
            stat,DDzis,dump,dump = self.PolSQL.Execute(SQL1,3)
            if stat=='OK':
                #pobranie artykuw dla porwnywanego dnia
                SQL2=SQL+" AND data='"+DataPorF+"' ORDER BY artykul_id;"
                stat,DPor,dump,dump = self.PolSQL.Execute(SQL2,3)
        
                for w in DDzis:
                    if not w in DPor:
                        ListaUwag[0].append('Artyku '+w[0].strip()+" nie by produkowany w porwnywanym dniu "+DataPorF+", a dzi zosta pobrany")
                
                for w in DPor:
                    if not w in DDzis:
                        ListaUwag[0].append('Artyku '+w[0].strip()+" by produkowany w porwnywanym dniu "+DataPorF+", a dzi nie zosta pobrany")
                
                ListaUwag[0].sort()
        
        # tworzymy list niepobranych hal dla oddziau
        for para in DHal:
            ListaUwag[1].append('Nie pobrano danych dla pary oddzia: '+para[0]+' i hala: '+para[1])
        
        wyn2[0]=ListaUwag
        

#-------------------------------------------------------------------------------
# sprawdzenie stanu przed otwarciem(18)
#-------------------------------------------------------------------------------

if Funkcja == 18 and stat=='OK':
    SQL = "SELECT 1 FROM rs_produkcja_sumy ps WHERE firma_id='"+self.firma_id+"'"
    SQL +=" AND oddzial_prod='"+OddzialF+"' AND data='"+DataF+"' AND stan='W'"
    if HalaF <> '':
        SQL+="AND hala_id = '"+HalaF+"'"
    SQL += ";"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(dane)>0:
            dane = 'W'
        else:
            dane = 'Z'
    else:
        stat = 'Bd pobrania stanu zamwie produkcji: '+stat

#-------------------------------------------------------------------------------
# sprawdzenie stanu przed zamkniciem(19)
#-------------------------------------------------------------------------------

if Funkcja == 19 and stat=='OK':
    dane = 'W'
    #if False:
    #    SQL = "SELECT 1 FROM rs_produkcja_sumy ps WHERE firma_id='"+self.firma_id+"'"
    #    SQL +=" AND oddzial_prod='"+OddzialF+"' AND data='"+DataF+"' AND stan='Z'"
    #    if HalaF <> '':
    #        SQL+="AND hala_id = '"+HalaF+"'"
    #    SQL+=";"
    #    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    #    if stat == 'OK':
    #        if len(dane)>0:
    #            dane = 'Z'
    #        else:
    #            dane = 'W'
    #    else:
    #        stat = 'Bd pobrania stanu zamwie produkcji: '+stat

#-------------------------------------------------------------------------------
# zmiana stanu pozycji dla dnia i oddziau produkcyjnego (16,17)
#-------------------------------------------------------------------------------

if Funkcja in [16,17] and stat == 'OK':
    if Funkcja == 16 and not UprZam:
        stat = 'Brak uprawnie do zamykania sum zamwie'
    elif Funkcja == 17 and not UprOtw:
        stat = 'Brak uprawnie do otwierania sum zamwie'
    
    if stat == 'OK':
        Stan = 'Z'
        if Funkcja == 17:
            Stan='W'

        SQL = "UPDATE rs_produkcja_sumy SET stan='"+Stan+"' WHERE firma_id='"+self.firma_id+"'"
        SQL += " AND oddzial_prod='"+OddzialF+"' AND data='"+DataF+"'"
        if HalaF != '':
            SQL += "AND hala_id = '"+HalaF+"'"
        stat, dump, dump, dump = self.PolSQL.Execute(SQL,1)

#-------------------------------------------------------------------------------
# pobranie danych - 5
#-------------------------------------------------------------------------------

if Funkcja in [5,11,16,17] and stat=='OK':
    if not UprPrz:
        stat='Brak uprawnie do przegldania sum zamwie'  

    if stat=='OK':
        SQLOpak="(SELECT ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
        SQLOpak+=" AND artykul_id=ps.artykul_id ORDER BY opakowanie_id LIMIT 1)"

        # widok w sprzeday
        if FunkcjaOkna == 1:
            sql="SELECT ps.oddzial_prod,ps.zmiana,ps.zmiana_p,a.kateg_artykulu,ps.artykul_id,a.nazwa,"
            sql+=SQLOpak+",SUM(ps.zamowione1),SUM(ps.zamowione2),0,0,0,0 FROM rs_produkcja_sumy ps "
            sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            sql+=" WHERE ps.firma_id = '"+self.firma_id+"' AND ps.oddzial_zam = '"+OddzialF+"'"
            sql+=" AND ps.data= '"+DataF+"'"
        
            if ZmianaF <> '':
                sql+=" AND ps.zmiana ='"+ZmianaF+"'"
            if ZmianaProdF <> '':
                sql+=" AND ps.zmiana_p ='"+ZmianaProdF+"'"
            if TypOdbF <> '':
                sql+=" AND ps.typ_odbiorcy ='"+TypOdbF+"'"
            if TylkoProdukty:
                sql += " AND a.typ_artykulu IN ('02','03','11','12')"
            sql+=" GROUP BY ps.oddzial_prod,ps.zmiana,ps.zmiana_p,a.kateg_artykulu,ps.artykul_id,a.nazwa"
            sql+=" ORDER BY a.kateg_artykulu,ps.artykul_id,ps.oddzial_prod,ps.zmiana;"
        # widok w produkcji    
        elif FunkcjaOkna == 2:
            SQLOddzialy = ''
            for oddz in dane[1]:
                SQLOddzialy+=",SUM(CASE WHEN ps.oddzial_zam='"+rsglobal.Dekoduj(oddz[0])+"' THEN ps.zamowione1 ELSE 0 END)"
                
            sql="SELECT ps.zmiana,ps.zmiana_p,a.kateg_artykulu,ps.artykul_id,a.nazwa,"+SQLOpak+","
            sql+=" SUM(ps.zamowione1)"+SQLOddzialy+",ps.artykul_id,a.nazwa,COALESCE(ps.hala_id,'')"
            sql+=" FROM rs_produkcja_sumy ps INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            sql+=" WHERE ps.firma_id = '"+self.firma_id+"' AND ps.oddzial_prod = '"+OddzialF+"' "
            sql+=" AND ps.data= '"+DataF+"'"

            if ZmianaF <> '':
                sql+=" AND ps.zmiana ='"+ZmianaF+"'"
            if ZmianaProdF <> '':
                sql+=" AND ps.zmiana_p ='"+ZmianaProdF+"'"
            if TypOdbF <> '':
                sql+=" AND ps.typ_odbiorcy ='"+TypOdbF+"'"
            if HalaF <> '':
                sql+=" AND ps.hala_id ='"+HalaF+"'"
            if BezHaliF:
                sql+=" AND ps.hala_id = '00'"
            if TylkoProdukty:
                sql += " AND a.typ_artykulu IN ('02','03','11','12')"
            sql+=" GROUP BY ps.artykul_id,a.nazwa,ps.zmiana,ps.zmiana_p,a.kateg_artykulu,ps.hala_id"
            sql+=" ORDER BY a.kateg_artykulu,ps.artykul_id;"
        #pobranie danych do grida
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        SlPor={}
        # jeli podana jest data porwnawcza to sprawdzamy te czy rnica pomidzy dniami nie wynosi 5%         
        if DataPorF <> '    -  -  ' and rsglobal.SprawdzCzyToData(DataPorF):
            stat,DanePor,dump,dump = self.PolSQL.Execute(sql.replace(DataF,DataPorF),3)
            if stat=='OK':
                for w in DanePor:
                    if FunkcjaOkna==1:
                        SlPor[(w[0],w[1],w[2],w[4])]=w
                    else:
                        SlPor[(w[0],w[1],w[3])]=w
                        
            wyn2[1]=SlPor
    
    # uzupenienie kolumn porwnawczych
    if stat == 'OK' and DataPorF <> '    -  -  ' and FunkcjaOkna == 1:
        for d in dane:
            if (d[0],d[1],d[2],d[4]) in SlPor:
                d[9] = SlPor[(d[0],d[1],d[2],d[4])][7]
                d[10] = SlPor[(d[0],d[1],d[2],d[4])][8]
            d[11] = d[9] - d[7]
            d[12] = d[10] - d[8]