# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_sumy_pozycje.py
# Purpose:     wczytuje/dodaje dane pozycji do produkcji
#
# Author:      Micha Raburski
# Created:     2009/08/26
# RCS-ID:      $Id: fs_zamowienia_sumy_pozycje.py $
# Copyright:   (c) 2006-2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_artykuly_pom

Data=rsglobal.Dekoduj(klucze[0])
OddzialZam=rsglobal.Dekoduj(klucze[1])
OddzialProd=rsglobal.Dekoduj(klucze[2])
ZmianaProd=rsglobal.Dekoduj(klucze[3])
ZmianaSprzed=rsglobal.Dekoduj(klucze[4])
Artykul=rsglobal.Dekoduj(klucze[5])
TypOdb=rsglobal.Dekoduj(klucze[6])
Ilosc=rsglobal.Dekoduj(klucze[7])
FunkcjaOkna=klucze[8]
StaraZmianaProd=rsglobal.Dekoduj(klucze[9])
Opakowanie=rsglobal.Dekoduj(klucze[10])
IloscWOpak=rsglobal.Dekoduj(klucze[11])
Fun=klucze[-1]

stat = "OK"
dane = []

UprEdy= (self.operator_id == STANDARD_OPERATOR_ID) or \
        (((self.oddzial_id,'121012') in self.uprawnienia and FunkcjaOkna==1) or
        ((self.oddzial_id,'045012') in self.uprawnienia and FunkcjaOkna==2)) 

if not UprEdy:
    stat='BR UPR EDY'

#-------------------------------------------------------------------------------
#---   POBRANIE OPISU OPAKOWANIA
#-------------------------------------------------------------------------------

if Fun == 8 and stat == 'OK':
    SQL ="SELECT oz.opis, a.ilosc1 FROM rs_artykuly_opakowania_zbiorcze a "
    SQL+="INNER JOIN rs_opakowania_zbiorcze oz on (a.firma_id=oz.firma_id AND a.opakowanie_id=oz.kod) "
    SQL+="WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+Artykul+"' AND a.opakowanie_id='"+Opakowanie+"'"
    SQL+="AND a.kontrahent_id IS NULL AND COALESCE(TRIM(a.cecha1_wartosc),'')= ''"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd podczas pobierania opisu opakowania'+stat
    
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH KTRE PRZYSZY DO DODAWANIA LUB ZMIANY ZMIANY (1,2,4)
#-------------------------------------------------------------------------------

if (Fun in [1,2,4]) and stat=='OK':
    if Data in ['','    -  -  ',None]:
        stat='BR DATY'

    if stat=='OK':
        if not rsglobal.SprawdzCzyToData(Data):
            stat='BL DATA'

    if Fun <>4:
        if stat=='OK':
            if OddzialZam in ['',None]:
                stat='BR ODDZ ZAM'
                
        if stat=='OK':
            SQL="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+OddzialZam+"';"
            stat,DOddz,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DOddz)==0:
                    stat='BL ODDZ ZAM'
                
    if stat=='OK':
        if OddzialProd in ['',None]:
            stat='BR ODDZ PROD'
            
    if stat=='OK':
        SQL="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+OddzialProd+"';"
        stat,DOddz,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DOddz)==0:
                stat='BL ODDZ PROD'

    if stat=='OK':
        if ZmianaProd in ['',None]:
            stat='BR ZMIANY PROD'

    if stat=='OK':
        if ZmianaSprzed in ['',None]:
            stat='BR ZMIANY SPRZED'
    
    if stat=='OK':
        if Artykul in ['',None]:
            stat='BR ART'
            
    if stat=='OK':
        SQL="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DArt)==0:
                stat='BL ART'
    if Fun <>4:
        if stat=='OK':
            if TypOdb.strip()=='':
                stat='BR TYP'
    
        if stat=='OK':
            SQL="SELECT kod FROM rs_typy_odbiorcow_produkcji WHERE firma_id='"+self.firma_id+"' AND kod='"+TypOdb+"';"
            stat,DTypu,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if len(DTypu)==0:
                    stat='BL TYP'
                        
        if stat=='OK':
            if Ilosc==0:
                stat='BL ILOSC'
    
        if stat=='OK':  
            Stan='W'  
            #sprawdzenie stanu - przy okazji sprawdzamy, czy nie jest 'Z' w sprzeday dla hali
            HalaFun = " rsf_podaj_hale_produkcyjna('"+self.firma_id+"','"+OddzialProd+"','"+Artykul+"','"+Data+"','')"
            Hala = " CASE WHEN "+HalaFun+" = '' THEN '00' ELSE "+HalaFun+" END"
            
            sql="SELECT stan FROM rs_produkcja_sumy WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
            sql+=" AND oddzial_prod='"+OddzialProd+"' AND hala_id="+Hala+" LIMIT 1;"
            stat,DStanu,dump,dump = self.PolSQL.Execute(sql,3)
            if stat=='OK':
                if len(DStanu)>0:
                    Stan=rsglobal.Dekoduj(DStanu[0][0])
           
        if stat=='OK':
            if FunkcjaOkna==1 and Stan=='Z':
                stat='BL ZAM'
                
    if stat == 'OK':
        SOpakArt = {}
        SQL ="SELECT artykul_id FROM rs_artykuly "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' "
        SQL+="AND tylko_w_opakowaniach"
        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(DArt) > 0:
            
            SQL ="SELECT ilosc1 FROM rs_artykuly_opakowania_zbiorcze "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' "
            SQL+="AND opakowanie_id='"+Opakowanie+"'"
            stat,DIlosc,dump,dump = self.PolSQL.Execute(SQL,3)
            if len(DIlosc) > 0:
                IloscWOpak = DIlosc[0][0]
                if IloscWOpak > 0:
                    if Ilosc%IloscWOpak <> 0:
                        stat = u'Ilo zamawianego towaru nie moe by zapakowana w opakowania o pojemnoci '+str(IloscWOpak)
                    else:
                        Opak=Ilosc/IloscWOpak
                        SOpakArt[Opakowanie]=Opak
            else:
                stat,SOpakArt = fs_artykuly_pom.PodajOpakowaniaDlaArtykulu(self,Artykul,Ilosc,'','','',3)
                if stat <> 'OK':
                    dane.append(stat)
                    
                        
#-------------------------------------------------------------------------------
#---   DODANIE WIERSZA (1,2)
#-------------------------------------------------------------------------------

if (Fun in [1,2]) and stat=='OK':
    przelicznik="(SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"')"
    HalaFun = " rsf_podaj_hale_produkcyjna('"+self.firma_id+"','"+OddzialProd+"','"+Artykul+"','"+Data+"','')"
    Hala = " CASE WHEN "+HalaFun+" = '' THEN '00' ELSE "+HalaFun+" END"
    
    SQL="INSERT INTO rs_produkcja_sumy (firma_id,data,oddzial_zam,oddzial_prod,zmiana,"
    SQL+="zmiana_p,typ_odbiorcy,artykul_id,zamowione1,zamowione2,"
    SQL+="wyprodukowane1, wyprodukowane2,braki1,braki2,czas_wprowadzenia,stan,hala_id)"
    SQL+=" VALUES ('"+self.firma_id+"','"+Data+"','"+OddzialZam+"','"+OddzialProd+"','"+ZmianaSprzed+"'"
    SQL+=",'"+ZmianaProd+"','"+TypOdb+"','"+Artykul+"',"+str(Ilosc)+",ROUND("+str(Ilosc)+"*"+przelicznik+",2),"
    SQL+="0,0,0,0,now(),'"+Stan+"',"+Hala+");"        
        
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    
#-------------------------------------------------------------------------------
#---   EDYCJA ZMIANY PRODUKCJI (4)
#-------------------------------------------------------------------------------

if Fun ==4 and stat=='OK':    
    SQL="UPDATE rs_produkcja_sumy SET zmiana_p='"+ZmianaProd+"' WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"'"
    SQL+=" AND oddzial_prod='"+OddzialProd+"' AND zmiana_p='"+StaraZmianaProd+"' "
    SQL+=" AND zmiana='"+ZmianaSprzed+"' AND artykul_id='"+Artykul+"';"
    
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    
#-------------------------------------------------------------------------------
#---  Dodanie do rs_produkcja_sumy_opakowania
#-------------------------------------------------------------------------------

if (Fun in [1,2,4]) and stat == 'OK' and SOpakArt <> {}:
        
    CzasWprow = "(SELECT czas_wprowadzenia FROM rs_produkcja_sumy WHERE firma_id='"+self.firma_id+"'"
    CzasWprow+= " AND data='"+Data+"' AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
    CzasWprow+= " AND zmiana='"+ZmianaSprzed+"' AND artykul_id='"+Artykul+"'  AND typ_odbiorcy='"+TypOdb+"'"
    CzasWprow+= " ORDER BY czas_wprowadzenia DESC LIMIT 1)"
    
    # bierzemy ostatnio dodany wiersz i bierzemy jego hal. Na razie to zawsze 00
    HalaFun = " rsf_podaj_hale_produkcyjna('"+self.firma_id+"','"+OddzialProd+"','"+Artykul+"','"+Data+"','')"
    Hala = " CASE WHEN "+HalaFun+" = '' THEN '00' ELSE "+HalaFun+" END"

    for kl in SOpakArt: 
        if SOpakArt[kl] > 0:
            znak = 1
            if Ilosc < 0 and stat == 'OK':
                znak = -1
                SQL ="SELECT SUM(ilosc) FROM rs_produkcja_sumy_opakowania WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND data='"+Data+"' AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
                SQL+=" AND zmiana='"+ZmianaSprzed+"' AND artykul_id='"+Artykul+"' AND opakowanie_id='"+kl+"'"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat == 'OK':
                    if len(d)>0:
                        if d[0][0]<SOpakArt[kl]:
                            stat = 'Nie mona odj podanej liczby sztuk artykuu, poniewa nie zgadza si ona z iloci opakowa zamwionych.'
                            dane.append(stat)
            if stat == 'OK':  
                SQL ="INSERT INTO rs_produkcja_sumy_opakowania (firma_id, data, oddzial_zam, "
                SQL+="oddzial_prod, zmiana, artykul_id, hala_id,czas_wprowadzenia, opakowanie_id, ilosc) "
                SQL+="VALUES ('"+self.firma_id+"','"+Data+"','"+OddzialZam+"',"
                SQL+="'"+OddzialProd+"','"+ZmianaSprzed+"','"+Artykul+"',"+Hala+"',"+CzasWprow+",'"+kl+"',"+str(znak)+"*"+str(SOpakArt[kl])+");"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)