# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zestawy_pom.py
# Purpose:     funkcje pomocnicze zestaww
#
# Author:      Micha Raburski
# Created:     2014/07/04
# RCS-ID:      $Id: fs_zestawy_pom.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_global_faktury
import rsglobal

#-------------------------------------------------------------------------------
# funkcja pomocnicza rozbijajca pozycj faktury bdc zestawem na skadniki
#-------------------------------------------------------------------------------

def RozbijZestawNaFakturze(self,Wyznacznik,Data,Numer,NrPoz):
    import rsglobal
    Numer=str(Numer)
    NrPoz=str(NrPoz)
    
    # sprawdzenie, e pozycja istnieje i nie ma podpozycji (nie jest ju rozbita) i e jest zestawem
    # przy okazji pobranie typu artykuu,artykuu, cechy, iloci i upustu
    SQL="SELECT a.typ_artykulu,fp.artykul_id,fp.cecha1_wartosc,"
    SQL+=" CASE WHEN a.jm_kalk='1' THEN fp.ilosc1 ELSE fp.ilosc2 END,fp.upust"
    SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+=" WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyznacznik+"'"
    SQL+=" AND fp.data='"+Data+"' AND fp.numer="+Numer+" AND fp.nr_poz="+NrPoz
    SQL+=" ORDER BY nr_ppoz FOR UPDATE"
    stat,DPoz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return "Bd pobierania informacji o zestawie na wybranej pozycji: "+stat
    if len(DPoz)==0:
        return "Brak pozycji na fakturze, ktra miaa by rozbita"
    if len(DPoz) > 1:
        return "Na wybranej pozycji zestaw jest ju rozbity"
    if DPoz[0][0] not in ['11','12']:
        return "Artyku wybrany do rozbicia nie jest zestawem"
    
    ArtZ = DPoz[0][1]
    CechaZ = DPoz[0][2]
    IloscZ = DPoz[0][3]
    UpustZ = DPoz[0][4]
    
    if rsglobal.RSRound(IloscZ,2) <> rsglobal.RSRound(IloscZ,0):
        return "Nie mona rozbi zestawu o niecakowitej iloci kalkulacyjnej"
    
    # sprawdzenie, e faktura jest w stanie W i nie jest z paragonu
    # przy okazji pobranie kontrahenta 
    
    SQL="SELECT stan,z_paragonow,kontrahent_id FROM rs_faktury"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    SQL+=" AND data='"+Data+"' AND numer='"+Numer+"' FOR UPDATE"
    stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return "Bd pobierania informacji o fakturze: "+stat
    if len(DPoz)==0:
        return "Brak podanej faktury"
    if DFakt[0][0] <> "W":
        return "Nie mona rozbija zestawu na fakturze w stanie innym ni W"
    if DFakt[0][1]:
        return "Nie mona rozbija zestawu na fakturze utworzonej z paragonw"
    
    Kontr = DFakt[0][2]
    
    # pobranie zestawu do pobranych parametrw 
    # dla kontrahenta
    SQL="SELECT az.artykul_id,COALESCE(az.cecha1_opis_a,''),COALESCE(az.cecha1_wartosc_a,''),"
    SQL+=" az.ilosc1,a.jm_kalk,a.przelicznik "
    SQL+=" FROM rs_artykuly_zestawy az INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" WHERE az.firma_id='"+self.firma_id+"' AND az.zestaw_id='"+ArtZ+"' AND TRIM(az.cecha1_wartosc_z)='"+CechaZ.strip()+"'"
    
    rsglobal.ZapiszDoLogow(SQL+" AND kontrahent_id='"+Kontr+"' ORDER BY az.artykul_id",1)
    stat,DZest,dump,dump = self.PolSQL.Execute(SQL+" AND kontrahent_id='"+Kontr+"' ORDER BY az.artykul_id",3)
    if stat <> 'OK':
        return "Bd pobierania informacji o zestawie z podanym kontrahentem: "+stat
    
    # jeli nie ma to dla kontrahenta standardowego
    if len(DZest)==0:
        stat,DZest,dump,dump = self.PolSQL.Execute(SQL+" AND COALESCE(kontrahent_id,'ZS')='ZS' ORDER BY az.artykul_id",3)
        rsglobal.ZapiszDoLogow(SQL+" AND COALESCE(kontrahent_id,'ZS')='ZS' ORDER BY az.artykul_id",1)
        if stat <> 'OK':
            return "Bd pobierania informacji o zestawie bez podanego kontrahenta: "+stat
        
    if len(DZest)==0:
        return "Brak skadnikw dla wybranego do rozbicia zestawu"
    
    # stworzenie pozycji ze skadnikami
    PPoz = 1
    for poz in DZest:
        ArtS = poz[0]
        CechaSO = poz[1]
        CechaSW = poz[2]
        IloscS = poz[3]
        JmKalk = poz[4]
        Przel = poz[5]
        if JmKalk == '1':
            Ilosc1 = str(IloscS*IloscZ)
            Ilosc2 = str(rsglobal.RSRound(IloscS*Przel*IloscZ,4))
        else:
            Ilosc1 = str(rsglobal.RSRound(IloscS/Przel*IloscZ,4))
            Ilosc2 = str(IloscS*IloscZ)
            
        SQL = "INSERT INTO rs_faktury_pozycje (firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"
        SQL+=" artykul_id,cecha1_opis,cecha1_wartosc,ilosc1,ilosc2,upust,stawka_vat,"
        SQL+=" cena_netto1,cena_netto2,cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
        SQL+=" cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,wartosc_netto,wartosc_vat,wartosc_brutto,"
        SQL+=" wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto,upust_wartosc,zestaw) "
        SQL+=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","+NrPoz+","+str(PPoz)+","
        SQL+=" '"+ArtS+"','"+CechaSO+"','"+CechaSW+"',"+Ilosc1+","+Ilosc2+","+str(UpustZ)+","
        SQL+=" rsf_podaj_vat_artykulu('"+self.firma_id+"','"+ArtS+"','"+Data+"'),"
        SQL+=" 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,TRUE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            return "Bd wstawienia pozycji ze skadnikiem '"+ArtS+"' : "+stat
        PPoz += 1
    
    # przeliczenie cen na pozycji
    stat = fs_global_faktury.PobierzCenyDoPozycji(self,self.firma_id,Wyznacznik,Data,Numer,0,NrPoz)
    if stat == 'BL SQL POZ':
        return "Bdy pobierania cen na pozycje ze skadnikami"
    elif stat <> 'OK':
        return "Bdy pobierania cen na pozycje ze skadnikami: "+stat
        
    # wyzerowanie pozycji zestawu
    SQL="UPDATE rs_faktury_pozycje SET cena_netto1=0,cena_netto2=0, cena_upust1=0,cena_upust2=0,"
    SQL+=" cena_brutto1=0,cena_brutto2=0,upust_wartosc=0,wartosc_netto=0,wartosc_vat=0, wartosc_brutto=0,"
    SQL+=" cena_wal1=0,cena_wal2=0,cena_upust_wal1=0,cena_upust_wal2=0,wartosc_wal_netto=0,"
    SQL+=" wartosc_wal_vat=0,wartosc_wal_brutto=0, zestaw=TRUE"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    SQL+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz=0"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        return "Bd czyszczenia pozycji z zestawem: "+stat

    return 'OK'

#-------------------------------------------------------------------------------
# funkcja pomocnicza scalajca pozycj faktury bdc zestawem rozbitym na skadniki
#-------------------------------------------------------------------------------

def ScalZestawNaFakturze(self,Wyznacznik,Data,Numer,NrPoz):
    import rsglobal
    Numer=str(Numer)
    NrPoz=str(NrPoz)
    
    # sprawdzenie, e pozycja istnieje i ma podpozycje (jest rozbita) i e jest zestawem
    # przy okazji pobranie typu artykuu,artykuu, cechy, iloci i upustu
    SQL="SELECT a.typ_artykulu,fp.artykul_id"
    SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+=" WHERE fp.firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyznacznik+"'"
    SQL+=" AND fp.data='"+Data+"' AND fp.numer="+Numer+" AND fp.nr_poz="+NrPoz
    SQL+=" ORDER BY nr_ppoz FOR UPDATE"
    stat,DPoz,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return "Bd pobierania informacji o zestawie na wybranej pozycji: "+stat
    if len(DPoz)==0:
        return "Brak pozycji na fakturze, ktra miaa by scalona"
    if len(DPoz) == 1:
        return "Na wybranej pozycji zestaw nie jest rozbity"
    if DPoz[0][0] not in ['11','12']:
        return "Artyku wybrany do scalenia nie jest zestawem"
    
    # sprawdzenie, e faktura jest w stanie W i nie jest z paragonu
    
    SQL="SELECT stan,z_paragonow FROM rs_faktury"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    SQL+=" AND data='"+Data+"' AND numer='"+Numer+"' FOR UPDATE"
    stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return "Bd pobierania informacji o fakturze: "+stat
    if len(DPoz)==0:
        return "Brak podanej faktury"
    if DFakt[0][0] <> "W":
        return "Nie mona scala zestawu na fakturze w stanie innym ni W"
    if DFakt[0][1]:
        return "Nie mona scala zestawu na fakturze utworzonej z paragonw"
    
    # usunicie pozycji ze skadnikami
    SQL = "DELETE FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"'"
    SQL+= " AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    SQL+= " AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz >0;"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        return "Bd czyszczenia pozycji ze skadnikami zestawu : "+stat
    
    # wyczenie zestawu na nagwkowej pozycji
    SQL = "UPDATE rs_faktury_pozycje SET zestaw=FALSE WHERE firma_id='"+self.firma_id+"'"
    SQL+= " AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    SQL+= " AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz = 0;"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        return "Bd czyszczenia pozycji z nagwkiem zestawu : "+stat
    
    # przeliczenie cen na pozostaej pozycji
    stat = fs_global_faktury.PobierzCenyDoPozycji(self,self.firma_id,Wyznacznik,Data,Numer,0,NrPoz)
    if stat == 'BL SQL POZ':
        return "Bdy pobierania cen na pozycj zestawu"
    elif stat <> 'OK':
        return "Bdy pobierania cen na pozycj zestawu: "+stat
        
    return 'OK'

#-------------------------------------------------------------------------------

def PrzeliczZestawNaFakturze(self,Wyznacznik,Data,Numer,NrPoz,StaraIlosc,NowaIlosc):
    # sprawdzenie czy pozycja ma podpozycje zestawu
    FiltrPPoz = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    FiltrPPoz+=" AND data='"+Data+"' AND numer="+str(Numer)
    FiltrPPoz+=" AND nr_poz="+str(NrPoz)+" AND nr_ppoz >0 AND zestaw"
    
    SQL="SELECT nr_ppoz FROM rs_faktury_pozycje WHERE "+FiltrPPoz
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bd sprawdzania czy pozycja faktury ma podpozycje : '+stat
    if len(DTest) == 0:
        return 'OK'
    
    # sprawdzenie czy nowa ilo jest cekowita (bo tylko na takich pracujemy na zestawach)
    if NowaIlosc <> int(NowaIlosc):
        return 'Nowa ilo na fakturze musi by cakowita, poniewa dotyczy rozbitego zestawu'
    
    # zmiana potencjalnych podpozycji
    WspIlosc = " / "+str(StaraIlosc)+" * "+str(NowaIlosc)
    SQL="UPDATE rs_faktury_pozycje SET ilosc1=ilosc1"+WspIlosc+",ilosc2=ilosc2"+WspIlosc
    SQL+=" WHERE "+FiltrPPoz
    rsglobal.ZapiszDoLogow('SQL Zmiana ppoz '+SQL,1)
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        return u'Bd przeliczenia podpozycji faktury : '+stat
    
    # przeliczenie wartoci podpozycji
    stat= fs_global_faktury.PrzeliczWartosciNaPozycji(self,Wyznacznik,Data,Numer,0,0,NrPoz,-1)
    
    return stat