# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_zlecenia_transportowe.py
# Purpose:     Obsuga zelec transportowych
# Author:      Aleksander Bargie
# Created:     2022/11/29
# RCS-ID:      $Id: fs_zlecenia_transportowe.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
""" INSERT INTO rs_menu VALUES ('104000','100000','Zlecenia transportowe');
    INSERT INTO rs_menu VALUES ('104010','104000','Przegldanie');
    INSERT INTO rs_menu VALUES ('104020','104000','Modyfikacja');
    INSERT INTO rs_menu VALUES ('104030','104000','Akceptacja wykonania');
    INSERT INTO rs_menu VALUES ('104040','104000','Anulowanie');
    INSERT INTO rs_menu VALUES ('104050','104000','Wystawianie faktur');"""

stat = 'OK'
firma_id = self.firma_id
oddzial_id = self.oddzial_id
Puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'StanF': [5, 6, 7, 8], 'OddzialF': [5, 6, 7, 8], 'DataOdF': [5, 6, 7, 8], 'DataDoF': [5, 6, 7, 8],
             'KontrahentF': [5, 6, 7, 8], 'Numer': [6, 7, 8]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [6, 7, 8]:
        Numer = klucze['Numer']
    if Fun in [7, ]:
        Powod = klucze['Powod']
    if Fun in [5, 6, 7, 8]:
        StanF       = klucze['StanF']
        OddzialF    = klucze['OddzialF']
        DataOdF     = klucze['DataOdF']
        DataDoF     = klucze['DataDoF']
        KontrahentF = klucze['KontrahentF']

if stat == 'OK':
    UprMod  = ((oddzial_id, '104020') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    UprAkc  = ((oddzial_id, '104030') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    UprAnul = ((oddzial_id, '104040') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    UprFakt = ((oddzial_id, '104050') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))


dane = []
wyn1 = []
wyn2 = []

# -------------------------------------------------------------------------------
# ---   USUWANIE DANYCH (6)
# -------------------------------------------------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun == 6:
    if not UprMod:
        stat = "Brak uprawnie do modyfikacji zlece"
    else:
        DEL = """DELETE
                 FROM rs_tr_zlecenia_transportowe
                 WHERE numer=%s;"""
        zmienne = [Numer]
        rsglobal.ZapiszDoLogow('SQL DEL rs_zlecenia_transportowe: ' + self.PolSQL.Mogrify(DEL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1, zmienne)
        if stat != 'OK':
            stat = 'Bd usuwanie zlecenia: ' + stat

# -------------------------------------------------------------------------------
# ---   ANULOWANIE ZLECENIA (7)
# -------------------------------------------------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun == 7:
    if not UprMod:
        stat = "Brak uprawnie do anulowania zlece"
    else:
        ANUL = """UPDATE rs_tr_zlecenia_transportowe
                  SET stan='A', operator_anulujacy=rsf_getuserid(), data_godzina_anulowania=NOW(), powod_anulowania = %s
                  WHERE numer=%s;"""
        zmienne = [Powod, Numer]
        rsglobal.ZapiszDoLogow('SQL ANUL rs_zlecenia_transportowe: ' + self.PolSQL.Mogrify(ANUL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(ANUL, 1, zmienne)
        if stat != 'OK':
            stat = 'Bd anulowania zlecenia: ' + stat

# -------------------------------------------------------------------------------
# ---   POTWIERDZANIE WYKONANIA ZLECENIA (8)
# -------------------------------------------------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun == 8:
    if not UprMod:
        stat = "Brak uprawnie do potwierdzania zlece"
    else:
        POTW = """UPDATE rs_tr_zlecenia_transportowe
                  SET stan='Z', operator_potwierdzajacy_wykonanie=rsf_getuserid(), data_godzina_potwierdzenia_wykonania=NOW()
                  WHERE numer=%s;"""
        zmienne = [Numer]
        rsglobal.ZapiszDoLogow('SQL POTW rs_zlecenia_transportowe: ' + self.PolSQL.Mogrify(POTW, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(POTW, 1, zmienne)
        if stat != 'OK':
            stat = 'Bd potwierdzenia zlecenia: ' + stat

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5-odczyt, 6-Usuwanie, 7-anulowanie + odczyt, 8-akceptacja + odczyt)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (5, 6, 7, 8):
    SEL = """SELECT stan, oddzial_id, data_zlecenia, godzina_zlecenia, kontrahent_id||' '||k.nazwa AS kontrahent,
                    artykul_id||' '||a.nazwa AS artykul, numer
             FROM rs_tr_zlecenia_transportowe
             LEFT JOIN rs_kontrahenci k USING(firma_id, kontrahent_id)
             LEFT JOIN rs_artykuly a USING(firma_id, artykul_id)
             WHERE firma_id=%s """
    zmienne = [firma_id]
    if StanF not in Puste:
        zmienne.append(StanF)
        SEL = SEL + " AND stan=%s"
    if OddzialF not in Puste:
        zmienne.append(OddzialF)
        SEL = SEL + " AND oddzial_id=%s"
    if DataOdF not in Puste:
        zmienne.append(DataOdF)
        SEL = SEL + " AND data_zlecenia>=%s"
    if DataDoF not in Puste:
        zmienne.append(DataDoF)
        SEL = SEL + " AND data_zlecenia<=%s"
    if KontrahentF not in Puste:
        zmienne.append(KontrahentF)
        SEL = SEL + " AND kontrahent_id=%s"
    SEL = SEL + " ORDER BY data_zlecenia DESC, godzina_zlecenia DESC;"
    rsglobal.ZapiszDoLogow('SQL rs_zlecenia_transportowe: '+self.PolSQL.Mogrify(SEL, zmienne))
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
    if stat != 'OK':
        stat = 'Bd pobrania listy zlece transportowych: '+stat

if dane is None:
    dane = []
