# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_zlecenia_transportowe.py
# Purpose:     Obsuga zelec transportowych
# Author:      Aleksander Bargie
# Created:     2022/11/29
# RCS-ID:      $Id: fs_zlecenia_transportowe.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2023-04-13 (13403) Aleksander Bargie | Zdj wymagalno wersji cenowej w zleceniach transportowych
""" INSERT INTO rs_menu VALUES ('104000','100000','Zlecenia transportowe');
    INSERT INTO rs_menu VALUES ('104010','104000','Przegldanie');
    INSERT INTO rs_menu VALUES ('104020','104000','Modyfikacja');"""

stat = 'OK'
firma_id = self.firma_id
oddzial_id = self.oddzial_id
Puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Numer': [1, 3, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [1, 3, 5]:
        Numer = klucze['Numer']

if stat == 'OK':
    if Fun in [12, 13]:
        Data       = klucze['Data']
        Kontrahent = klucze['Kontrahent']

if stat == 'OK':
    if Fun in [13, ]:
        Artykul = klucze['Artykul']
        Wersja  = klucze['Wersja']
        Oddzial = klucze['Oddzial']
        Kurs    = klucze['Kurs'] if 'Kurs' in klucze else 1.0  #zaslepka jakby mial sie pojawic


if stat == 'OK':
    UprMod  = ((oddzial_id, '104020') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

pola_edytowalne = ['oddzial_id', 'data_zlecenia', 'godzina_zlecenia', 'kontrahent_id', 'kierowca_id', 'artykul_id',
                   'ilosc', 'wersja_cenowa', 'cena', 'powod_anulowania']


dane = []
wyn1 = []
wyn2 = []

# ---------------------------------------------------------------------------------------------------------------------
#                                          1, 3 - Sprawdzanie danych
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3):
    if 'oddzial_id' in klucze:
        wart = klucze['oddzial_id']
        if wart != '':
            SPR ="SELECT oddzial_id FROM rs_oddzialy "
            SPR+="WHERE firma_id='"+firma_id+"' AND oddzial_id='"+wart+"';"
            dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
            if stat != 'OK':
                stat = 'ODDZ SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'ODDZ BL'
                dane.append(stat)
    elif Fun == 1:
        stat = 'ODDZ BR'
        dane.append(stat)

    if 'kontrahent_id' in klucze:
        wart = klucze['kontrahent_id']
        wart = wart.strip()
        if wart == '':
            stat = 'KONTR BR'
            dane.append(stat)
        else:
            sql = "SELECT kontrahent_id FROM rs_kontrahenci "
            sql += " WHERE firma_id='" + firma_id + "' AND kontrahent_id = '" + str(wart) + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'KONTR SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'KONTR BL'
                dane.append(stat)
    elif Fun == 1:
        stat = 'KONTR BR'
        dane.append(stat)

    if 'kierowca_id' in klucze:
        wart = klucze['kierowca_id']
        wart = wart.strip()
        if wart != '':
            sql = "SELECT kod FROM rs_kierowcy "
            sql += " WHERE firma_id='" + firma_id + "' AND kod = '" + str(wart) + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'KIER SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'KIER BL'
                dane.append(stat)

    if 'artykul_id' in klucze:
        wart = klucze['artykul_id']
        wart = wart.strip()
        if wart == '':
            stat = 'ART BR'
            dane.append(stat)
        else:
            sql = "SELECT artykul_id FROM rs_artykuly "
            sql += " WHERE firma_id='" + firma_id + "' AND artykul_id = '" + str(wart) + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'ART SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'ART BL'
                dane.append(stat)
    elif Fun == 1:
        stat = 'ART BR'
        dane.append(stat)

    if 'wersja_cenowa' in klucze:
        wart = klucze['wersja_cenowa']
        wart = wart.strip()
        if wart != '':  #AB 13.04.23r usuniety blad dla pustej wersji
            sql = "SELECT kod FROM rs_wersje_cenowe "
            sql += " WHERE firma_id='" + firma_id + "' AND kod = '" + str(wart) + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'WER_CEN SQL BL'
                dane.append(stat)
            elif len(d) == 0:
                stat = 'WER_CEN BL'
                dane.append(stat)
if len(dane) > 0:
    stat = dane[0]


# ---------------------------------------------------------------------------------------------------------------------
#                                          1 - Dodawanie zlecenia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, ):
    pola = []
    args = []
    for pole in pola_edytowalne:
        if pole in klucze:
            pola.append(pole)
            args.append(klucze[pole])
    wartosci = ['%s' for x in pola]
    pola.append('operator_wprowadzajacy')
    wartosci.append('rsf_getuserid()')
    pola.append('stan')
    wartosci.append("'W'")
    pola.append('firma_id')
    wartosci.append('%s')
    args.append(firma_id)

    INS = """INSERT INTO rs_tr_zlecenia_transportowe 
              ({})
              VALUES({});""".format(', '.join(pola), ', '.join(wartosci))

    rsglobal.ZapiszDoLogow(INS)
    rsglobal.ZapiszDoLogow(args)
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(INS, args))
    stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd podczas dodawania pozycji: " + stat

    if stat == 'OK':
        SEL = """SELECT MAX(numer)
                 FROM rs_tr_zlecenia_transportowe;"""
        rsglobal.ZapiszDoLogow('SQL rs_zlecenia_transportowe numer: '+SEL)
        stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3)
        if stat != 'OK':
            stat = 'Bd pobrania numeru nowego zlecenia: '+stat
        else:
            Numer = dane[0][0]


# ---------------------------------------------------------------------------------------------------------------------
#                                          3 - Aktualizacja danych zlecenia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (3, ):
    SET  = []
    args = []
    for pole in pola_edytowalne:
        if pole in klucze:
            SET.append(pole + "=%s")
            args.append(klucze[pole])

    args.append(Numer)

    UPD = """UPDATE rs_tr_zlecenia_transportowe 
              SET {}
              WHERE numer = %s;""".format(', '.join(SET))

    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(UPD, args))
    stat, dump, dump, dump = self.PolSQL.Execute(UPD, 1, args, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = "Bd podczas edycji pozycji: " + stat

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5-odczyt, 6-Usuwanie, 7-anulowanie + odczyt, 8-akceptacja + odczyt)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (1, 3, 5):
    SEL = """SELECT numer, oddzial_id, o.opis AS oddzial_opis, stan, data_zlecenia, godzina_zlecenia, 
                    operator_wprowadzajacy, wpr.login as wprowadzajacy_opis, tr.kontrahent_id, k.nazwa AS kontrahent_opis,
                    kierowca_id, kier.opis as kierowca_opis, data_godzina_przyjecia_zlecenia, artykul_id, a
                    .nazwa AS artykul_opis, ilosc, wersja_cenowa, wer.opis as wersja_cenowa_opis, cena,
                     data_godzina_potwierdzenia_wykonania, operator_potwierdzajacy_wykonanie, 
                     potw.login AS operator_potwierdzajacy_wykonanie_opis, operator_anulujacy, 
                     anul.login AS operator_anulujacy_opis, powod_anulowania, data_godzina_anulowania,
                     f_wyznacznik||'/'||f_data||'/'||f_numer AS faktura
             FROM rs_tr_zlecenia_transportowe tr
             LEFT JOIN rs_kontrahenci k USING(firma_id, kontrahent_id)
             LEFT JOIN rs_artykuly a USING(firma_id, artykul_id)
             LEFT JOIN rs_oddzialy o USING(firma_id, oddzial_id)
             LEFT JOIN rs_kierowcy kier ON (tr.firma_id, tr.kierowca_id) = (kier.firma_id, kier.kod)
             LEFT JOIN rs_wersje_cenowe wer ON (tr.firma_id, tr.wersja_cenowa) = (wer.firma_id, wer.kod)
             LEFT JOIN rs_operatorzy wpr ON tr.operator_wprowadzajacy = wpr.operator_id
             LEFT JOIN rs_operatorzy potw ON tr.operator_potwierdzajacy_wykonanie = potw.operator_id
             LEFT JOIN rs_operatorzy anul ON tr.operator_anulujacy = anul.operator_id
             WHERE tr.firma_id=%s AND numer=%s"""
    zmienne = [firma_id, Numer]
    rsglobal.ZapiszDoLogow('SQL rs_zlecenia_transportowe: '+self.PolSQL.Mogrify(SEL, zmienne))
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
    if stat != 'OK':
        stat = 'Bd pobrania listy zlece transportowych: '+stat

if dane is None:
    dane = []


# ---------------------------------------------------------------------------------------------------------------------
#                                          11 - Pobranie przewidywanego numeru zlecenia
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (11, ):
    SEL = """SELECT COALESCE(MAX(numer), 0) + 1
             FROM rs_tr_zlecenia_transportowe;"""
    rsglobal.ZapiszDoLogow('SQL rs_zlecenia_transportowe numer: '+SEL)
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania numeru nowego zlecenia: '+stat


# ---------------------------------------------------------------------------------------------------------------------
#                                          12 - Pobranie wersji cenowej dla kontrahenta
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (12, ):
    SEL = """SELECT kod, opis FROM rs_wersje_cenowe 
             WHERE firma_id = %s AND kod = rsf_podaj_pole_z_danych_do_fakturowania(%s, %s, %s, 'wersja');"""
    zmienne = [firma_id, firma_id, Kontrahent, Data]
    rsglobal.ZapiszDoLogow('SQL rsf_podaj_pole_z_danych_do_fakturowania: '+self.PolSQL.Mogrify(SEL, zmienne))
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
    if stat != 'OK':
        stat = 'Bd pobrania wersji cenowej: '+stat


# ---------------------------------------------------------------------------------------------------------------------
#                                          13 - Pobranie cen
# ---------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Fun in (13, ):
    LCeny = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

    from funkcje import fs_global_ceny_kontrahenta
    ceny = fs_global_ceny_kontrahenta.PodajCenyDlaKontrahenta(self, firma_id, Kontrahent, 'PLN', Data, Artykul, Wersja,
                                                              '0', Oddzial)  #AB 09.02.21r
    if ceny is not None:
        Upust=ceny[8]
        CenaN1=rsglobal.RSRound(ceny[0]*Kurs,2)
        CenaN2=rsglobal.RSRound(ceny[1]*Kurs,2)
        CenaB1=rsglobal.RSRound(ceny[2]*Kurs,2)
        CenaB2=rsglobal.RSRound(ceny[3]*Kurs,2)
        CenaWN1=rsglobal.RSRound(ceny[0],2)
        CenaWN2=rsglobal.RSRound(ceny[1],2)
        CenaWB1=rsglobal.RSRound(ceny[2],2)
        CenaWB2=rsglobal.RSRound(ceny[3],2)

        CenaN1U=rsglobal.RSRound(CenaN1*((100-Upust)*0.01),2)
        CenaN2U=rsglobal.RSRound(CenaN2*((100-Upust)*0.01),2)
        CenaB1U=rsglobal.RSRound(CenaB1*((100-Upust)*0.01),2)
        CenaB2U=rsglobal.RSRound(CenaB2*((100-Upust)*0.01),2)
        CenaWN1U=rsglobal.RSRound(CenaWN1*((100-Upust)*0.01),2)
        CenaWN2U=rsglobal.RSRound(CenaWN2*((100-Upust)*0.01),2)
        CenaWB1U=rsglobal.RSRound(CenaWB1*((100-Upust)*0.01),2)
        CenaWB2U=rsglobal.RSRound(CenaWB2*((100-Upust)*0.01),2)

        dane = [Upust,CenaN1,CenaN2,CenaB1,CenaB2,CenaWN1,CenaWN2,
                CenaWB1,CenaWB2,CenaN1U,CenaN2U,CenaB1U,CenaB2U,CenaWN1U,CenaWN2U,CenaWB1U,CenaWB2U]
