# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_zlecenia_transportowe_raporty_zbiorcze.py
# Purpose:     Pobranie danych do raportu zbiorczego
# Author:      Wojciech Skowron
# Created:     2023/02/23
# RCS-ID:      $Id: fs_zlecenia_transportowe_raporty_zbiorcze.py $
# Copyright:   (c) 2023 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

from funkcje import fs_pliki_office

import calendar
import datetime
import rs_anakonda_daty
import rsglobal
import tempfile
import string
import traceback

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Oddzial': [1, 2], 'DataOd': [1, 2], 'DataDo': [1, 2],
             'Przewoznik': [1], 'DoKg': [1], 'Koszt': [1], 'KosztPowyzej': [1],
             'Transport': [1], 'TransportWC': [1], 'Roboczogodzina': [1], 'RoboczogodzinaWC': [1],
             'Paliwo': [1], 'Wspolczynnik': [1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = u'Uwaga : wywoanie funkcji fs_zlecenia_transportowe_raporty_zbiorcze z numerem '+str(Funkcja)+u' bez parametrw: '+Lista

# Upr = (((self.oddzial_id, '104010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
# if not Upr:
#     stat = 'BR_UPR'

if stat == 'OK':
    if Funkcja in (1,):
        Przewoznik = rsglobal.Dekoduj(klucze['Przewoznik'])
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])
        DoKg = rsglobal.Dekoduj(klucze['DoKg'])
        Koszt = rsglobal.Dekoduj(klucze['Koszt'])
        KosztPowyzej = rsglobal.Dekoduj(klucze['KosztPowyzej'])
        Transport = rsglobal.Dekoduj(klucze['Transport'])
        TransportWC = rsglobal.Dekoduj(klucze['TransportWC'])
        Roboczogodzina = rsglobal.Dekoduj(klucze['Roboczogodzina'])
        RoboczogodzinaWC = rsglobal.Dekoduj(klucze['RoboczogodzinaWC'])
        Paliwo = rsglobal.Dekoduj(klucze['Paliwo'])
        Wspolczynnik = rsglobal.Dekoduj(klucze['Wspolczynnik'])

    if Funkcja in (2,):
        Oddzial = rsglobal.Dekoduj(klucze['Oddzial'])
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])


if stat == 'OK' and Funkcja == 2:
    zapytanie = """SELECT DISTINCT r.przewoznik_id, k.nazwa
                   FROM rs_dowody_dostaw_rentownosc_rzut r
                   JOIN rs_kontrahenci k ON r.firma_id=k.firma_id AND r.przewoznik_id=k.kontrahent_id
                   WHERE r.firma_id=%s AND r.oddzial_id=%s AND r.data >= %s AND r.data <= %s;"""
    zmienne = [self.firma_id, Oddzial, DataOd, DataDo]
    rsglobal.ZapiszDoLogow('Pobranie listy przewoznikow: '+self.PolSQL.Mogrify(zapytanie, zmienne))
    stat, dane, wyn1, dump = self.PolSQL.Execute(zapytanie, 3, zmienne)
    if stat != 'OK':
        stat = u"Bd pobrania listy przewoznikow: "+stat
    elif len(dane) == 0:
        stat = 'Brak danych dla ktrych mona by utworzy zestawienie'


if stat == 'OK' and Funkcja == 1:
    liczba_dni_pracujacych = rs_anakonda_daty.LiczbaDniPracujacych(datetime.datetime(int(DataOd[:4]),int(DataOd[5:7]),int(DataOd[8:10])).date(), datetime.datetime(int(DataDo[:4]),int(DataDo[5:7]),int(DataDo[8:10])).date())

    start = datetime.datetime(int(DataOd[:4]),int(DataOd[5:7]),1).date()
    end = datetime.datetime(int(DataDo[:4]),int(DataDo[5:7]),calendar.monthrange(int(DataDo[:4]), int(DataDo[5:7]))[1]).date()
    daydiff = end.weekday() - start.weekday()
    liczba_dni_miesiac = ((end-start).days - daydiff) / 7 * 6 + min(daydiff,6) - (max(end.weekday() - 5, 0) % 6)

    zapytanie = """SELECT cena_netto1, cena_brutto1 
                   FROM rs_artykuly_ceny 
                   WHERE firma_id = %s AND artykul_id = %s AND wersja = %s AND data_od <= %s ORDER BY data_od DESC LIMIT 1;"""
    zmienne = [self.firma_id, Transport, TransportWC, DataOd]
    rsglobal.ZapiszDoLogow('Pobranie kosztu transportu '+self.PolSQL.Mogrify(zapytanie, zmienne))
    stat, dane_transport, wyn1, dump = self.PolSQL.Execute(zapytanie, 3, zmienne)
    if stat != 'OK':
        stat = u"Bad pobrania danych do raportu: " + stat
    elif len(dane_transport) == 0:
        stat = 'Brak ceny dla artykuu '+Transport+' i wersji cenowej '+TransportWC+' w podanym okresie'

    if stat == 'OK':
        zapytanie = """SELECT cena_netto1, cena_brutto1 
                       FROM rs_artykuly_ceny 
                       WHERE firma_id = %s AND artykul_id = %s AND wersja = %s AND data_od <= %s ORDER BY data_od DESC LIMIT 1;"""
        zmienne = [self.firma_id, Roboczogodzina, RoboczogodzinaWC, DataOd]
        rsglobal.ZapiszDoLogow('Pobranie kosztu roboczogodziny '+self.PolSQL.Mogrify(zapytanie, zmienne))
        stat, dane_roboczogodzina, wyn1, dump = self.PolSQL.Execute(zapytanie, 3, zmienne)
        if stat != 'OK':
            stat = u"Bad pobrania danych do raportu: " + stat
        elif len(dane_roboczogodzina) == 0:
            stat = 'Brak ceny dla artykuu '+Roboczogodzina+' i wersji cenowej '+RoboczogodzinaWC+' w podanym okresie'

    if stat == 'OK':
        zapytanie = """SELECT trasa, opis, SUM(sprzedaz) AS sprzedaz, waga, premia, dystans_godz, dystans_km, SUM(rzut::int) AS suma_rzut
                       FROM (
                             SELECT r.trasa, t.opis, SUM(COALESCE(r.sprzedaz,0)-COALESCE(r.zwroty,0)) as sprzedaz, rtt.dystans_godz, rtt.dystans_km, r.rzut, rddp.waga, SUM(r.dod_got) AS premia
                             FROM rs_dowody_dostaw_rentownosc_rzut r 
                             JOIN rs_trasy t ON r.firma_id=t.firma_id AND r.oddzial_id=t.oddzial_id AND r.trasa=t.kod
                             LEFT OUTER JOIN (SELECT firma_id, oddzial_id, trasa, SUM(ilosc_dost2) AS waga FROM rs_dowody_dostaw_pozycje rddp WHERE rddp.data >= %s AND rddp.data <= %s  GROUP BY firma_id, oddzial_id, trasa) rddp ON rddp.firma_id=r.firma_id AND rddp.oddzial_id=r.oddzial_id AND rddp.trasa=r.trasa
                             JOIN (SELECT DISTINCT ON (firma_id, kod) firma_id, kod, od_dnia, dystans_godz, dystans_km, inne FROM rs_trasy_transport rtt WHERE rtt.od_dnia <= %s ORDER BY firma_id, kod, od_dnia DESC) rtt ON rtt.firma_id=r.firma_id AND rtt.kod=r.trasa AND rtt.inne IS FALSE
                             WHERE r.firma_id = %s AND r.oddzial_id = %s AND r.przewoznik_id = %s AND r.data >= %s  AND r.data <= %s
                             GROUP BY r.firma_id, r.oddzial_id, r.trasa,t.opis, rtt.dystans_godz, rtt.dystans_km, r.rzut, rddp.waga
                             ORDER BY r.oddzial_id, r.trasa) podzap 
                       GROUP BY trasa, opis, dystans_godz, dystans_km, waga, premia;"""
        zmienne = [DataOd, DataDo, DataOd, self.firma_id, Oddzial, Przewoznik, DataOd, DataDo]
        rsglobal.ZapiszDoLogow('Pobranie danych do raportu przew '+Przewoznik.strip()+': '+self.PolSQL.Mogrify(zapytanie, zmienne))
        stat, dane_trasy, wyn1_trasy, dump = self.PolSQL.Execute(zapytanie, 3, zmienne)
        if stat != 'OK':
            stat = u"Bad pobrania danych do raportu: "+stat
            dane = []
        elif len(dane_trasy) == 0:
            stat = 'Brak danych dla ktrych mona by utworzy zestawienie dla przewonika '+str(Przewoznik)

    if stat == 'OK':
        kompletna_ramka = fs_pliki_office.RSRamka(lewa='thin', prawa='thin', gora='thin', dol='thin')
        s_zwykly = fs_pliki_office.RSStyl(ramka=kompletna_ramka, zawijac_tekst=True, rozmiar_tekstu=9)
        s_waga_premia_r1 = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="fbe5d6")
        s_waga_premia_r2 = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="f4b183")
        s_40proc_waga_r1 = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="ffff00")
        s_40proc_waga_r1_czerwony = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="ffff00", kolor_tekstu="ff0000", pogrubienie=True)
        s_40proc_waga_r2 = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="f4b183")
        s_40proc_waga_r2_czerwony = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="f4b183", kolor_tekstu="ff0000", pogrubienie=True)
        s_10proc = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="dae3f3")
        s_10proc_czerwony = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="dae3f3", kolor_tekstu="ff0000", pogrubienie=True)
        s_km_vat =  fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="fff2cc")
        s_wspolczynnik = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="e2f0d9")
        s_netto = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="dae3f3")
        s_brutto = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="c5e0b4")
        s_suma_waga = fs_pliki_office.RSStyl(wzor=s_zwykly, ramka=kompletna_ramka, kolor_tla="00b0f0")

        Okres = ''
        if DataOd[5:7] == DataDo[5:7] and DataOd[2:4] == DataDo[2:4]:
            Okres = str(int(DataOd[8:]))+'-'+str(int(DataDo[8:]))+'.'+DataDo[5:7]+'.'+DataDo[2:4]
        elif DataOd[5:7] != DataDo[5:7] and DataOd[2:4] == DataDo[2:4]:
            Okres = str(int(DataOd[8:]))+'.'+DataOd[5:7]+'-'+str(int(DataDo[8:]))+'.'+DataDo[5:7]+'.'+DataDo[2:4]
        else:
            Okres = str(int(DataOd[8:]))+'.'+DataOd[5:7]+'.'+DataOd[2:4]+'-'+str(int(DataDo[8:]))+'.'+DataDo[5:7]+'.'+DataDo[2:4]

        naglowek_tabela = [[10, 0+1,  "Trasa",                                's', s_zwykly],
                           [10, 1+1,  "Opis",                                 's', s_zwykly],
                           [10, 2+1,  "Sprzeda z anakondy",                  's', s_zwykly],
                           [10, 3+1,  "WAGA",                                 's', s_waga_premia_r1],
                           [10, 4+1,  "PREMIA",                               's', s_waga_premia_r1],
                           [10, 5+1,  '=L10',                                 's', s_40proc_waga_r1],
                           [10, 6+1,  '=I10',                                 's', s_10proc_czerwony],
                           [10, 7+1,  '',                                     's', s_10proc],
                           [10, 8+1,  "ilo godzin",                         's', s_zwykly],
                           [10, 9+1,  "wynagrodzenie",                        's', s_zwykly],
                           [10, 10+1, "waga",                                 's', s_40proc_waga_r1_czerwony],
                           [10, 11+1, "km",                                   's', s_km_vat],
                           [10, 12+1, "wspczynnik paliwowy+eksploatacyjny", 's', s_wspolczynnik],
                           [10, 13+1, "NETTO",                                's', s_netto],
                           [10, 14+1, "VAT",                                  's', s_km_vat],
                           [10, 15+1, "BRUTTO",                               's', s_brutto]]

        szerokosci_tabela = [85, 400, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85]
        wys_wierszy = [[11, 80]]

        tresc_tabela = []

        s_dni = fs_pliki_office.RSStyl(kolor_tla="ffff00", rozmiar_tekstu=9)
        s_dni_czerwony_pogr = fs_pliki_office.RSStyl(wzor=s_dni, kolor_tekstu="ff0000", pogrubienie=True)

        komorka = [3, 1, '=D9', 'n', s_dni]
        tresc_tabela.append(komorka)

        komorka = [4, 1, liczba_dni_miesiac, 'n', s_dni]
        tresc_tabela.append(komorka)

        komorka = [1, 3, '=C5/B5', 'n_0.0', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [3, 2, '=D2*B4', 'n', s_dni]
        tresc_tabela.append(komorka)

        komorka = [4, 2, DoKg, 'n', s_dni]
        tresc_tabela.append(komorka)

        # ---

        s_paliwo_wspolczynnik = fs_pliki_office.RSStyl(kolor_tla="dae3f3", rozmiar_tekstu=9, kolor_tekstu="ff0000")
        s_paliwo_wspolczynnik_pogr = fs_pliki_office.RSStyl(wzor=s_paliwo_wspolczynnik, pogrubienie=True)

        komorka = [6, 1, 'paliwo', 's', s_paliwo_wspolczynnik]
        tresc_tabela.append(komorka)

        komorka = [7, 1, '', 's', s_paliwo_wspolczynnik]
        tresc_tabela.append(komorka)

        komorka = [8, 1, 'wspczynnik', 's', s_paliwo_wspolczynnik]
        tresc_tabela.append(komorka)

        komorka = [9, 1, '', 's', s_paliwo_wspolczynnik]
        tresc_tabela.append(komorka)

        komorka = [6, 2, '='+str(Paliwo), 'n_00', s_paliwo_wspolczynnik_pogr]
        tresc_tabela.append(komorka)

        komorka = [7, 2, '', 's', s_paliwo_wspolczynnik_pogr]
        tresc_tabela.append(komorka)

        komorka = [8, 2, '='+str(Wspolczynnik), 'n_00', s_paliwo_wspolczynnik_pogr]
        tresc_tabela.append(komorka)

        komorka = [9, 2, Okres, 's', s_dni]
        tresc_tabela.append(komorka)

        s_dni_obok_paliwa = fs_pliki_office.RSStyl(kolor_tla="e2f0d9", rozmiar_tekstu=9, kolor_tekstu="ff0000", pogrubienie=True)

        komorka = [6, 3, 'DNI', 's', s_dni_obok_paliwa]
        tresc_tabela.append(komorka)

        komorka = [7, 3, '', 's', s_dni_obok_paliwa]
        tresc_tabela.append(komorka)

        komorka = [8, 3, str(liczba_dni_pracujacych), 'n', s_dni_obok_paliwa]
        tresc_tabela.append(komorka)

        komorka = [9, 3, '', 's', s_dni_obok_paliwa]
        tresc_tabela.append(komorka)

        # ---

        s_zwykly_bez_ramki = fs_pliki_office.RSStyl(rozmiar_tekstu=9)
        ramka_lewo_gora = fs_pliki_office.RSRamka(lewa='thick', gora='thick')
        ramka_prawo_gora = fs_pliki_office.RSRamka(prawa='thick', gora='thick')
        s_zwykly_lewo_gora = fs_pliki_office.RSStyl(ramka=ramka_lewo_gora, zawijac_tekst=True, rozmiar_tekstu=9)
        s_zwykly_prawo_gora = fs_pliki_office.RSStyl(ramka=ramka_prawo_gora, zawijac_tekst=True, rozmiar_tekstu=9)

        komorka = [9, 7, '', 's', s_paliwo_wspolczynnik_pogr]
        tresc_tabela.append(komorka)

        komorka = [9, 8, '10%', 's', s_paliwo_wspolczynnik_pogr]
        tresc_tabela.append(komorka)

        komorka = [9, 9, str(dane_roboczogodzina[0][0]), 'n', s_zwykly_lewo_gora]
        tresc_tabela.append(komorka)

        komorka = [9, 10, 'KIEROWCA', 's', s_zwykly_prawo_gora]
        tresc_tabela.append(komorka)

        komorka = [9, 11, '40%', 's', s_dni_czerwony_pogr]
        tresc_tabela.append(komorka)

        komorka = [7, 9, 'pierwszy rzut', 's', s_zwykly_bez_ramki]
        tresc_tabela.append(komorka)

        komorka = [8, 9, '=D9', 'n', s_zwykly_bez_ramki]
        tresc_tabela.append(komorka)

        s_drugi_rzut = fs_pliki_office.RSStyl(wzor=s_zwykly_bez_ramki, kolor_tla="f4b183", kolor_tekstu="ff0000", pogrubienie=True)

        komorka = [5, 7, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [5, 8, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [5, 9, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [5, 10, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [5, 11, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [6, 7, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [6, 8, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [6, 9, 'drugi rzut', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [6, 10, '', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        komorka = [6, 11, '10%', 's', s_drugi_rzut]
        tresc_tabela.append(komorka)

        # --- tabela inne=False

        tr_trasy = rssql.RSTableRowset2(dane_trasy, wyn1_trasy)
        for nr_wiersza in range(len(dane_trasy)):
            for nr_kol in range(16):
                wart = ''
                typ_kom = 's'
                styl = s_zwykly
                if nr_kol == 0:  # B Trasa
                    typ_kom = 's'
                    wart = tr_trasy[nr_wiersza]['trasa']
                elif nr_kol == 1:  # C Opis
                    typ_kom = 's'
                    wart = tr_trasy[nr_wiersza]['opis']
                elif nr_kol == 2:  # D Sprzeda z anakondy
                    typ_kom = 'n'
                    wart = tr_trasy[nr_wiersza]['sprzedaz']
                elif nr_kol == 3:  # E WAGA
                    typ_kom = 'n'
                    wart = tr_trasy[nr_wiersza]['waga']
                    if tr_trasy[nr_wiersza]['suma_rzut'] in (1, 3):
                        styl = s_waga_premia_r1
                    else:
                        styl = s_waga_premia_r2
                elif nr_kol == 4:  # F PREMIA
                    typ_kom = 'n'
                    wart = tr_trasy[nr_wiersza]['premia']
                    if tr_trasy[nr_wiersza]['suma_rzut'] in (1, 3):
                        styl = s_waga_premia_r1
                    else:
                        styl = s_waga_premia_r2
                elif nr_kol == 5 and tr_trasy[nr_wiersza]['suma_rzut'] in (1, 3):  # G
                    typ_kom = 'n'
                    wart = '=C4'
                    styl = s_40proc_waga_r1
                elif nr_kol == 6 and tr_trasy[nr_wiersza]['suma_rzut'] in (1, 3):  # H
                    typ_kom = 'n'
                    wart = '=E'+str(nr_wiersza+12)+'-G'+str(nr_wiersza+12)
                    styl = s_10proc
                elif nr_kol == 7 and tr_trasy[nr_wiersza]['suma_rzut'] in (1, 3):  # I
                    typ_kom = 'n'
                    wart = '=H'+str(nr_wiersza+12)+'*$H$11'
                    styl = s_10proc_czerwony
                elif nr_kol == 8:   # J ilo godzin
                    typ_kom = 'n_0.0'
                    wart = '='+str(tr_trasy[nr_wiersza]['dystans_godz'])
                elif nr_kol == 9:  # K wynagrodzenie
                    typ_kom = 'n'
                    wart = '=J'+str(nr_wiersza+12)+'*$J$10*$J$9'
                elif nr_kol == 10:  # L waga
                    typ_kom = 'n'
                    if tr_trasy[nr_wiersza]['suma_rzut'] in (1, 3):
                        wart = '=G'+str(nr_wiersza+12)+'*$L$10'
                        styl = s_40proc_waga_r1_czerwony
                    else:
                        wart = '=E'+str(nr_wiersza+12)+'*$L$7'
                        styl = s_40proc_waga_r2_czerwony
                elif nr_kol == 11:  # M km
                    typ_kom = 'n'
                    wart = tr_trasy[nr_wiersza]['dystans_km']
                    styl = s_km_vat
                elif nr_kol == 12:  # N wspczynnik paliwowy+eksploatacyjny
                    typ_kom = 'n'
                    wart = '=M'+str(nr_wiersza+12)+'*$D$9*$C$9'
                    styl = s_wspolczynnik
                elif nr_kol == 13:  # O NETTO
                    typ_kom = 'n_00'
                    wart = '=I'+str(nr_wiersza+12)+'+K'+str(nr_wiersza+12)+'+L'+str(nr_wiersza+12)+'+N'+str(nr_wiersza+12)+'+F'+str(nr_wiersza+12)
                    styl = s_netto
                elif nr_kol == 14:  # P VAT
                    typ_kom = 'n_00'
                    wart = '=Q'+str(nr_wiersza+12)+'-O'+str(nr_wiersza+12)
                    styl = s_km_vat
                elif nr_kol == 15:  # Q BRUTTO
                    typ_kom = 'n_00'
                    wart = '=O'+str(nr_wiersza+12)+'*1.23'
                    styl = s_brutto

                if wart != '':
                    komorka = [nr_wiersza+11, nr_kol+1, wart, typ_kom, styl]
                    tresc_tabela.append(komorka)

        # --- sumy

        komorka = [len(dane_trasy)+12, 3, '=SUM(D12:D'+str(len(dane_trasy)+12)+')', 'n', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+12, 4, '=SUM(E12:E'+str(len(dane_trasy)+12)+')', 'n', s_suma_waga]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+12, 14, '=SUM(O12:O'+str(len(dane_trasy)+12)+')', 'n_00', s_netto]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+12, 15, '=SUM(P12:P'+str(len(dane_trasy)+12)+')', 'n_00', s_km_vat]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+12, 16, '=SUM(Q12:Q'+str(len(dane_trasy)+12)+')', 'n_00', s_brutto]
        tresc_tabela.append(komorka)

        # --- pod tabel

        komorka = [len(dane_trasy)+13, 2, 'rednie zuycie paliwa na 100 km', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+13, 1, '', 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+14, 2, 'REDNIA CENA NETTO ZA OKRES / ZA 1 LITR ON', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+14, 1, '=C7', 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+15, 2, 'Koszt na 100 km wg ceny za 1 litr z', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+15, 1, '=B'+str(len(dane_trasy)+15)+'*B'+str(len(dane_trasy)+14)+'', 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+16, 2, 'Koszt na 1 km wg ceny za 1 litr z', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+16, 1, '=B'+str(len(dane_trasy)+16)+'/100', 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        s_zwykly_pogr = fs_pliki_office.RSStyl(wzor=s_zwykly, pogrubienie=True)
        s_zwykly_czerwony = fs_pliki_office.RSStyl(wzor=s_zwykly, kolor_tekstu="ff0000")

        komorka = [len(dane_trasy)+17, 2, 'Koszt na 1 km wg ceny za 1 litr z NETTO', 's', s_zwykly_pogr]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+17, 1, '=B'+str(len(dane_trasy)+17), 'n_0.000', s_zwykly_czerwony]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+18, 2, 'Pozostae koszty/opony, olej, filtry/ na 1 km netto', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+18, 1, '', 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+19, 2, '', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+19, 1, '', 's', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+20, 2, 'suma', 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        komorka = [len(dane_trasy)+20, 1, '=B'+str(len(dane_trasy)+19)+'+B'+str(len(dane_trasy)+18), 'n_00', s_zwykly]
        tresc_tabela.append(komorka)

        wszystkie_dane = [Okres, naglowek_tabela+tresc_tabela, szerokosci_tabela, wys_wierszy]
        tresc = [wszystkie_dane]

        rsglobal.ZapiszDoLogow(str(tresc))

        plik = tempfile.mktemp('.xlsx')

        stat_xls, book = fs_pliki_office.UtworzXLS2(tresc)
        if stat_xls == 'OK' and book is not None:
            try:
                book.save(plik)
                with open(plik, 'rb') as p:
                    dane = [p.read()]
            except Exception, e:
                stat = 'Bd tworzenia arkusza: '+traceback.format_exc()
        else:
            stat = 'Bd tworzenia arkusza'
            if stat_xls != 'OK':
                stat += ': '+stat_xls
