# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_aktualizuj_stawki_vat.py
# Purpose:     Aktualizacja danych VAT w rs_artykuly w oparciu o rs_artykuly_stawki_vat
# Authors:     Aleksander Bargie
# Created:     2021/11/08
# Copyright:   (c) 2021 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

SQL = """UPDATE rs_artykuly a SET stawka_vat=v.stawka_vat, sww_pkwiu = v.sww_pkwiu, nazwa_skrocona=v.nazwa_skrocona, kod_cn=v.kod_cn, stawka_vat_import=v.stawka_vat_import
FROM
(SELECT v.stawka_vat, v.sww_pkwiu, v.nazwa_skrocona, v.kod_cn, v.stawka_vat_import, v.artykul_id, v.firma_id
 FROM rs_artykuly_stawki_vat v (firma_id, artykul_id)
 WHERE v.firma_id=%s 
 AND v.od_dnia=(SELECT max(od_dnia) FROM rs_artykuly_stawki_vat tmp WHERE (firma_id, artykul_id) = (v.firma_id, v.artykul_id) AND od_dnia <= NOW()::DATE)) AS v
 WHERE a.firma_id=v.firma_id AND v.artykul_id=a.artykul_id AND (a.stawka_vat, a.sww_pkwiu, a.nazwa_skrocona, a.kod_cn, a.stawka_vat_import) != (v.stawka_vat, v.sww_pkwiu, v.nazwa_skrocona, v.kod_cn, v.stawka_vat_import)"""
stat, dump, dump, dump = PolSQL.Execute(SQL, 1, [firma_id])
KonczJesliBlad(stat, 'Bd aktualizacji stawek VAT: '+stat)
