# -*- coding: iso8859_2 -*-

# 2022-11-12 Jan Raburski (13246) maile do kontrahentow o blokadzie

import rsglobal
from funkcje import fs_blokada_kontr_pom

SprawdzArgumenty(['dni_dyspensy', 'operator'])

stat = 'OK'

# pobranie listy kontrahentow, ktrzy bd zablokowani
stat, LKontr = fs_blokada_kontr_pom.PodajListeKontrahentowDoBlokady(PolSQL, firma_id, '', True, 0, '', dni_dyspensy,
                                                                    True)
KonczJesliBlad(stat)

# podzielenie kontrahentow na oddzialy
SOddz = {}
for kontr in LKontr:
    fs_blokada_kontr_pom.ZalozBlokadeNaKontrahenta(PolSQL, firma_id, kontr[0], '')

    # przegrupowanie danych dla maili
    for oddz in kontr[3]:
        if not oddz in SOddz:
            SOddz[oddz] = []
        SOddz[oddz].append(kontr[0:3] + [kontr[4]])

# wysanie odpowiednich maili do oddziaw
ZapiszLog('Prognozowane wysanie maili : ' + str(len(SOddz)))
ListaWyslanych = []
for oddz in SOddz:
    ZapiszLog('Mail do oddziau ' + str(oddz))
    Temat = "Informacja o blokadach kontrahentw wygenerowane dnia " + rsglobal.PodajDzis() + " dla oddziau " + oddz

    Tresc = "KONTRAHENCI, KTRZY ZOSTALI ZABLOKOWANI\n\n"

    SposZapl = ''
    for kontr in SOddz[oddz]:
        # sprawdzamy sposb zapaty kontrahenta. Jeli si zmienia to dodajemy sekcje
        if SposZapl != kontr[3]:
            if kontr[3] == 'G':
                Tresc += "\n PACCY GOTWK \n\n"
            elif kontr[3] == 'P':
                Tresc += "\n PACCY PRZELEWEM \n\n"
            else:
                Tresc += "\n INNI \n\n"
            SposZapl = kontr[3]

        # pobranie danych kontrahenta
        SQL = "SELECT TRIM(nazwa), TRIM(adr_kod)||' '||TRIM(adr_miej)||' ,'||TRIM(adr_ulica)||' '||TRIM(adr_nry),"
        SQL += "TRIM(tel1)||CASE WHEN tel2<>'' THEN ', '||tel2 ELSE '' END "
        SQL += " FROM rs_kontrahenci WHERE firma_id='" + firma_id + "' AND kontrahent_id='" + kontr[0] + "';"
        stat, DKontr, dump, dump = PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
        if stat != 'OK':
            stat = "Bd pobierania danych podstawowych kontrahenta " + kontr[0] + " : " + stat
        KonczJesliBlad(stat)
        if len(DKontr) == 0:
            KonczJesliBlad("Brak kontrahenta " + kontr[0])

        if kontr[1] == 'P':
            Tresc += " PATNIK  "
            if kontr[0] not in ListaWyslanych:
                #JR 2022-11-16 (13246) wysanie maila do platnika
                ListaWyslanych.append(kontr[0])
                stat = fs_blokada_kontr_pom.WyslijMailSmsOPrzewidywanejBlokadzie(PolSQL, firma_id, kontr[0], kontr[2][1], kontr[2][0], operator, True)
                if stat != 'OK':
                    #KonczJesliBlad("Bd wysyania maila o blokadzie do " + kontr[0] + stat)
                    rsglobal.ZapiszDoLogow("Bd wysyania maila o blokadzie do " + kontr[0] + stat)
        else:
            Tresc += "   KONTR. "

        Tresc += kontr[0].strip() + ' - ' + DKontr[0][0] + '\n                     Adres : ' + DKontr[0][
            1] + ' ,     Tel: ' + DKontr[0][2] + '\n\n'

    # pobranie adresw na ktre ma to pj dla konkretnego oddziau
    SQL = "SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='" + firma_id + "'"
    SQL += " AND powiadomienie='B0002' AND oddzial_id IN ('" + oddz + "','**');"
    stat, DPoczta, dump, dump = PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
    if stat != 'OK':
        stat = "Bd pobierania listy kont pocztowych dla oddziau " + oddz + " : " + stat
    KonczJesliBlad(stat)

    # wysanie maili
    rsglobal.ZapiszDoLogow('Tresc ' + str(Tresc), 1)
    ZapiszLog('\nTEMAT ' + str(Temat))
    ZapiszLog('\nTRE ' + str(Tresc) + '\n\n')
    for mail in DPoczta:
        ZapiszLog('Mail do ' + mail[0])
        stat = rsglobal.RSWyslijEmail(mail[0], Temat, Tresc, [], 0, PolSQL)
        if stat != 'OK':
            ZapiszLog(stat)

    ZapiszLog('Wysano maile dla oddziau ' + oddz)
