# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_import_paragonow_z_pc_market.py
# Purpose:     Import paragonw fiskalnych z PC Market
# Author:      Wojciech Skowron
# Created:     2020/02/13
# RCS-ID:      $Id: fs_import_paragonow_z_pc_market.py $
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2020-05-12 Wojciech Skowron - (11973) Poprawki

from funkcje import fs_hd_paragony_import_pom
import rsglobal
import rsmssql

from datetime import datetime, timedelta

# Parametry dni_od i dni_do podawane s jako cakowite liczby ujemne,
# np. wywoanie z parametrami "dni_od":-2,"dni_do":-1 uruchomi import wszystkich paragonw z przedwczoraj i wczoraj
SprawdzArgumenty(['dni_od', 'dni_do'])

self = rsglobal.StworzAtrapeSelfa(firma_id, PolSQL)

# Pobranie wszystkich sklepw ze zdefiniowanym id dla PC Market

SEL = """SELECT sklep_id, pcmarket FROM rs_hd_sklepy
         WHERE firma_id='{firma_id}' AND pcmarket != 0
         ORDER BY sklep_id ASC;"""
SEL = SEL.format(firma_id=self.firma_id)

stat, Sklepy, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
KonczJesliBlad(stat)

if len(Sklepy) == 0:
    ZapiszLog("Brak placwek handlowych ze zdefiniowanym id dla PC Market")
else:
    od = min(dni_od, dni_do)
    do = max(dni_od, dni_do)

    # Utworzenie listy zawierajcej wszystkie daty z zakresu
    Daty = []
    for liczbaDni in range(od, do+1):
        Daty.append((datetime.today() + timedelta(days=liczbaDni)).strftime("%Y-%m-%d"))

    # Poczenie z baz PC Market i wykonanie importu dla kadego sklepu i dnia osobno
    # Niepowodzenie ktorego z wywoa nie powoduje wyjcia z caej funkcji z bdem - ptla idzie dalej,
    # a bdy zapisywane s do logw (wewntrz funkcji ImportujParagony)
    self.RSPCMarketSQL = rsmssql.RSPCMarketSQL()
    stat = self.RSPCMarketSQL.Polacz()
    KonczJesliBlad(stat)

    for sklep in Sklepy:
        for data in Daty:
            try:
                stat = fs_hd_paragony_import_pom.ImportujParagony(self, data, sklep, FunkcjaZapisuDoLogow=ZapiszLog)
                if stat == 'OK':
                    self.PolSQL.CommitCzysty()
                else:
                    self.PolSQL.Rollback()

                    #WS 2020-05-12 - jeeli brak trjki placwka/stoisko/kasa - przejcie do nastpnej placwki
                    if 'BL_PRZERW' in stat:
                        break
            except:
                self.PolSQL.Rollback()

    stat = 'OK'
    self.RSPCMarketSQL.Rozlacz()
