# -*- coding: iso8859_2 -*-
# wczytuje dane z plikw i wykonuje opisane operacje

import os
import errno
import rs_anakonda_server_komser as komser
import traceback
from const import STANDARD_OPERATOR_ID

IN = "in"
STARE = os.path.join(IN, "stare")
wystapilBlad = False

try:
    conf = filter(None, [x.strip().startswith("komser") and x.strip() or "" for x in open("rs-and.conf")])
    opcje = dict.fromkeys(["komserwer", "komserkatalog", "komsernazwa", "komserklienci"])
    opcje.update(dict([(x[0].rstrip(), x[1].lstrip()) for x in [y.split("=",1) for y in conf]]))
    komser.zarzadcaTransportu.opcje = {}
    for nazwa in ["komserwer", "komsernazwa", "komserklienci", "komserkatalog"]:
        assert opcje[nazwa], "brak %s" % nazwa
        komser.zarzadcaTransportu.opcje[nazwa] = opcje[nazwa]
    komserkatalog = opcje["komserkatalog"]
    klienci = [x.strip() for x in opcje["komserklienci"].split(",")]
except Exception, exc:
    stat = "BLAD"
    KonczJesliBlad(stat, "Niekompletna konfiguracja: %s" % exc)


for klient in klienci:
    if klient == opcje["komsernazwa"]:
        continue
    kdir = os.path.join(komserkatalog, klient, IN)
    if not os.path.isdir(kdir):
        ZapiszLog("brak katalogu: %r" % kdir)
    else:
        pliki = os.walk(kdir).next()[2]
        poukladane = []
        for plik in pliki:
            if plik.startswith(".") or plik.startswith("_"):
                continue
            try:
                base = os.path.splitext(plik)[0]
                nr = base.split("_")[-1]
                nr = int(nr)
            except Exception, exc:
                continue
            plik = os.path.join(kdir, plik)
            poukladane.append((nr, plik))
        poukladane.sort()

        for nr, plik in poukladane:
            # wczytanie pliku i podzielenie go liniami nie zaczynajacymi sie od spacji
            ZapiszLog("PLIK: %s" % plik)
            plik_w_archiwum = os.path.join(komserkatalog, klient, STARE, os.path.basename(plik))
            if os.path.exists(plik_w_archiwum):
                st = "OK"
                try:
                    tresc_starego = open(plik_w_archiwum).read()
                    if tresc_starego != open(plik).read():
                        st = "pliki roznia sie"
                except IOError, exc:
                    st = "nie mozna otworzyc pliku (%s)" % exc

                if st == "OK":
                    ZapiszLog("Ignoruje. Ten sam plik juz jest w archiwum - zostal juz wczesniej przetworzony.")
                    os.unlink(plik)
                    continue
                else:
                    ZapiszLog("BLAD: W archiwum ten plik juz wystepuje, zostal przetworzony, ale %s" % st)
                    wystapilBlad = True
                    break

            czesci = [[]]
            for linia in open(plik):
                if linia.startswith("#") or not linia.strip():
                    continue
                elif not (linia.startswith(" ") or linia.startswith("\t")):
                    czesci.append([])
                czesci[-1].append(linia.rstrip())
            if not czesci[0]:
                czesci.pop(0)

            #print czesci
            # interpretowanie poszczeglnych czesci
            try:
                przetworzonaPoprawnie = True
                przekazujDalej = False
                for czesc in czesci:
                    #print czesc
                    cznaglowka = czesc[0].split()
                    dane = dict.fromkeys(("KLUCZE", "POLA", "WARTOSCI"), [])
                    dodatkoweDane = []
                    for linia in czesc[1:]:
                        if not ":" in linia:
                            continue
                        nazwa, reszta = linia.split(":", 1)
                        nazwa = nazwa.strip().upper()
                        wartosc = eval(reszta.rstrip())
                        if nazwa in ("OPERATOR", "KLUCZE", "POLA", "WARTOSCI"):
                            dane[nazwa] = wartosc
                        else:
                            dodatkoweDane.append((nazwa, wartosc))
                    #print "nagl:", cznaglowka
                    if cznaglowka[0].upper() == "WYKONAJ":
                        funkcja = cznaglowka[1]
                        dane_operatora = dane["OPERATOR"][:4]
                        dane_operatora[0] = STANDARD_OPERATOR_ID
                        dane_klucze, dane_pola, dane_wartosci = dane["KLUCZE"], dane["POLA"], dane["WARTOSCI"]
                        rsglobal.ZapiszDoLogow("zdalna: %r" % (dane_operatora + [True, None],), 5)
                        if dodatkoweDane and funkcja.startswith("fs_komser"):
                            print "K", dane_klucze 
                            print "P", dane_pola
                            print "W", dane_wartosci 
                            print "DD", dodatkoweDane
                            if isinstance(dane_klucze,dict):
                                dane_klucze_tmp = eval(str(dane_klucze))
                                dane_klucze_tmp["dodatkoweDane"] = dodatkoweDane
                                funstat, fdane, fwyn1, przekazujDalej = WykonajFunkcje(funkcja,
                                    dane_klucze_tmp, dane_pola, dane_wartosci,
                                    daneSrodowiska=dane_operatora + [True, True, None])
                            else:
                                funstat, fdane, fwyn1, przekazujDalej = WykonajFunkcje(funkcja,
                                    dane_klucze + ["dodatkoweDane"], dane_pola, dane_wartosci + [dodatkoweDane],
                                    daneSrodowiska=dane_operatora + [True, True, None])
                        else:
                            funstat, fdane, fwyn1, przekazujDalej = WykonajFunkcje(funkcja,
                                dane_klucze, dane_pola, dane_wartosci,
                                daneSrodowiska=dane_operatora + [True, True, None])
                        if funstat != "OK":
                            #PolSQL.Rollback()
                            if len(stat) <= 15:
                                ZapiszLog("po wykonaniu %s status: %s" % (funkcja, funstat))
                            przetworzonaPoprawnie = False
                            break
                # przeniesienie wykonanego pliku
                if przetworzonaPoprawnie:
                    PolSQL.Commit()
                    #print "Zapisz:", repr(przekazujDalej), os.path.basename(plik), None, "-"+klient, plik
                    if przekazujDalej is not False:
                        komser.Zapisz(os.path.basename(plik), None, adresaci="-"+klient, sciezkaPliku=plik)
                    try:
                        os.rename(plik, plik_w_archiwum)
                    except OSError, exc:
                        # z brakujcym katalogiem to system moe sobie sam poradzi
                        if exc.errno == errno.ENOENT and not os.path.isdir(os.path.join(komserkatalog, klient, STARE)):
                            os.mkdir(os.path.join(komserkatalog, klient, STARE))
                            os.rename(plik, plik_w_archiwum)
                        else:
                            # a innymi problemami niech sie zajmuje op
                            raise
                else:
                    wystapilBlad = True
                    break
                # moe by czyci znacznik commitowania z fn.zdalne_zlecenie?
                #     - nie trzeba, fn.zdalne_zlecenie jest ustawiane z daneSrodowiska przekazywanym za kazdym razem
            except Exception, exc:
                ZapiszLog(" <czesci> EXCEPTION:\n %s\n" % traceback.format_exc())
                break

if wystapilBlad:
    stat = "BLAD"
