# -*- coding: iso8859_2 -*-

# Autor: Mariusz Rajfura  2011-07-15  (4751)
# Funkcja harmonogramu: fs_oblicz_procent_zwrotow_ilosc
# Funkcja zlicza ilosci dostarczone i zwroty z dowodow dostaw dla kontrahentow
# z dokladnoscia do artykulu z 30 dni lub ilosci dni podanej w tabeli
# 'rs_kontrahenci_artykuly_poziom_zwrotow'

# 2020-01-28 Jan Raburski       (12269) - zwroty_dni = 1 - oblicza od pierwszego dnia miesiaca
# 2022-03-01 Aleksander Bargie (12908) - Obliczanie procentu zwrotw - poprawa dobieranego okresu

import datetime

DataDo = fs_time
DniOdPierwszego = int(DataDo.strftime("%F")[8:10]) - 1  #AB 01.03.22r
# ile dni si cofac
sql = "SELECT max(liczba_dni)"
sql += " FROM rs_kontrahenci_artykuly_poziom_zwrotow"
sql += " WHERE firma_id='" + firma_id + "';"
stat, dml, dump, dump = PolSQL.Execute(sql, 2)
if stat != 'OK':
    stat = 'Bd pobrania danych o maksymalnej liczbie dni zwrotw dla kontrahentw: '+stat
    KonczJesliBlad(stat)
DataOd = DataDo - datetime.timedelta(days=max(dml[0][0], 30))

sql = "SELECT TRIM(kontrahent_id),TRIM(oddzial_id),TRIM(COALESCE(artykul_id,''::TEXT)),liczba_dni"
sql += " FROM rs_kontrahenci_artykuly_poziom_zwrotow"
sql += " WHERE firma_id='"+firma_id+"' AND kontrahent_id IS NOT NULL"
sql += " ORDER BY kontrahent_id,oddzial_id,artykul_id;"

stat, dPoziomy, dump, dump = PolSQL.Execute(sql, 2)
if stat != 'OK':
    stat = 'Bd pobrania danych o poziomach zwrotw dla kontrahentw: '+stat
    KonczJesliBlad(stat)

# sPoziomy: [kontrahent_id,oddzial_id,artykul_id] = [liczba_dni]
sPoziomy = {}

# slownik zdefiniowanych oddzialow dla kontrahenta z artykulem
# sKontrOddzArt: [kontrahent_id,oddzial_id,artykul_id] = 0
sKontrOddzArt = {}

for i in xrange(len(dPoziomy)):
    sPoziomy[(dPoziomy[i][0], dPoziomy[i][1], dPoziomy[i][2])] = [dPoziomy[i][3]]

    if dPoziomy[i][1] != '**' and dPoziomy[i][2] != '':
        if not (dPoziomy[i][0], dPoziomy[i][1], dPoziomy[i][2]) in sKontrOddzArt:
            sKontrOddzArt[(dPoziomy[i][0],dPoziomy[i][1]),dPoziomy[i][2]] = 0


sIlosci = {}
# slownik naliczonych pozycji
# sIlosci[kontrahent,oddzial,artykul] = [il_zwr, ilosc_dost]

while DataOd <= DataDo:
    sql ="SELECT TRIM(dd.kontrahent_id),TRIM(dd.oddzial_id),TRIM(ddp.artykul_id),"
    sql += " SUM(ddp.ilosc_zwr1),SUM(ddp.ilosc_dost1)"
    sql += " FROM rs_dowody_dostaw_pozycje ddp"
    sql += " INNER JOIN rs_dowody_dostaw dd USING(firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
    sql += " WHERE ddp.firma_id='"+firma_id+"' AND ddp.data='"+DataOd.strftime("%F")+"'"
    sql += " GROUP BY dd.kontrahent_id,dd.oddzial_id,ddp.artykul_id;"

    stad, dDDPoz, dumo, dump = PolSQL.Execute(sql,2)
    KonczJesliBlad(stat)
    
    IleDni = (DataDo-DataOd).days
    
    for i in xrange(len(dDDPoz)):
        Kontrah = dDDPoz[i][0]
        Oddzial = dDDPoz[i][1] 
        Artykul = dDDPoz[i][2]
        IlZwroc = dDDPoz[i][3]
        IlDost = dDDPoz[i][4]
        
        LiczbaDni = 0
        # szukamy 'liczba_dni', aby sprawdzic, czy sumowac dane dla tego dnia
        # dla kontrahenta,oddzialu,artykulu
        
        if (Kontrah,Oddzial,Artykul) in sPoziomy:
            # jest zapis dokladnie dla kontrah,oddzial,artykul
            LiczbaDni = sPoziomy[(Kontrah,Oddzial,Artykul)][0]

        elif (Kontrah,Oddzial,'') in sPoziomy and not (Kontrah,Oddzial,Artykul) in sKontrOddzArt:
            # dla kontrah,oddzial,artykul==''
            LiczbaDni = sPoziomy[(Kontrah,Oddzial,'')][0]
            
        elif (Kontrah,'**',Artykul) in sPoziomy:
            # dla kontrah,oddzial=='**',artykul
            LiczbaDni = sPoziomy[(Kontrah,'**',Artykul)][0]

        elif (Kontrah,'**','') in sPoziomy:
            # dla kontrah,oddzial=='**',artykul==''
            LiczbaDni = sPoziomy[(Kontrah,'**','')][0]

        if LiczbaDni == 1:
            # liczymy od pierwszego dnia miesiaca
            LiczbaDni = DniOdPierwszego

        if LiczbaDni == 0:
            # jesli nie znaleziono lub byla zerowa,
            # to domyslna liczba dni do zliczania zwrotow
            LiczbaDni = 30

        if IleDni <= LiczbaDni:
            if not (Kontrah,Oddzial,Artykul) in sIlosci:
                sIlosci[(Kontrah,Oddzial,Artykul)] = [IlZwroc, IlDost]
            else:
                sIlosci[(Kontrah,Oddzial,Artykul)][0] += IlZwroc
                sIlosci[(Kontrah,Oddzial,Artykul)][1] += IlDost

    DataOd += datetime.timedelta(days=1)

# zerowanie istniejacych zapisow
UPD ="UPDATE rs_kontrahenci_artykuly_zwroty_ilosciowe"
UPD+=" SET zwrocone=0,dostarczone=0,procent=0, z_czas=NOW()"
UPD+=" WHERE firma_id='"+firma_id+"';"

stat,d,dump,dump = PolSQL.Execute(UPD,1)
KonczJesliBlad(stat)

# obliczanie wartosci zwrotow i aktualizacja tabeli
# 'rs_kontrahenci_artykuly_zwroty_ilosciowe'

lKluczeIlosci = sIlosci.keys()

for k in lKluczeIlosci:
    IlZwroc = sIlosci[k][0]
    IlDost = sIlosci[k][1]
    Kontrah = rsglobal.Dekoduj(k[0])
    Oddzial = rsglobal.Dekoduj(k[1])
    Artykul = rsglobal.Dekoduj(k[2])
    
    Procent = 0
    if IlDost > 0:
        Procent = rsglobal.RSRound(100*IlZwroc/IlDost,2)
        if Procent > 9999.99:
            Procent = 0
            
    sql ="SELECT kontrahent_id,oddzial_id,artykul_id"
    sql+=" FROM rs_kontrahenci_artykuly_zwroty_ilosciowe"
    sql+=" WHERE firma_id='"+firma_id+"' AND oddzial_id='"+Oddzial+"'"
    sql+=" AND kontrahent_id='"+Kontrah+"' AND artykul_id='"+Artykul+"' FOR UPDATE;"
    
    stat,d,dump,dump = PolSQL.Execute(sql,2)
    KonczJesliBlad(stat)
    
    if len(d) == 1:
        UPD ="UPDATE rs_kontrahenci_artykuly_zwroty_ilosciowe"
        UPD+=" SET zwrocone="+str(IlZwroc)+", z_czas=NOW(), dostarczone="+str(IlDost)+",procent="+str(Procent)
        UPD+=" WHERE firma_id='"+firma_id+"' AND oddzial_id='"+Oddzial+"'"
        UPD+=" AND kontrahent_id='"+Kontrah+"' AND artykul_id='"+Artykul+"';"
    else:
        UPD ="INSERT INTO rs_kontrahenci_artykuly_zwroty_ilosciowe"
        UPD+=" (firma_id,oddzial_id,kontrahent_id,artykul_id,"
        UPD+="  zwrocone,dostarczone,procent, z_czas)"
        UPD+=" VALUES"
        UPD+=" ('"+firma_id+"','"+Oddzial+"','"+Kontrah+"','"+Artykul+"',"
        UPD+="  "+str(IlZwroc)+","+str(IlDost)+","+str(Procent)+", NOW());"
        
    stat,d,dump,dump = PolSQL.Execute(UPD,1)
    KonczJesliBlad(stat)