# -*- coding: iso8859_2 -*-

# Autor: Mariusz Rajfura  2011-07-08  (4747)
# Funkcja harmonogramu: fs_oblicz_procent_zwrotow_wartosc
# Funkcja liczy procentowo wartosci zwrotow z dowodow dostaw dla kontrahentow
# ktorzy maja zapisy w tabeli 'rs_kontrahenci_artykuly_poziom_zwrotow'
# w zakresie od 1 dnia miesiaca do daty biezacej wlacznie.

# 2011-07-14 Mariusz Rajfura  literowka (4775)
# 2011-08-24 Mariusz Rajfura  liczenie wg cena_upust1 (4918)
# 2011-08-31 Mariusz Rajfura  popr.petli naliczania dni (4941)

import datetime

DataDo = fs_time
DataOd = datetime.datetime(DataDo.year, DataDo.month, 1)

sql ="SELECT TRIM(kontrahent_id),TRIM(oddzial_id),TRIM(COALESCE(artykul_id,''::TEXT)),numer_id"
sql+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
sql+=" WHERE firma_id='"+firma_id+"' AND kontrahent_id IS NOT NULL"
sql+=" ORDER BY kontrahent_id,oddzial_id,artykul_id;"

stat,dPoziomy,none,none = PolSQL.Execute(sql,2)
if stat <> 'OK':
    stat = 'Bd pobrania danych o poziomach zwrotw dla kontrahentw: '+stat
    KonczJesliBlad(stat)

# sPoziomy: [kontrahent_id,oddzial_id,artykul_id] = [numer_id,wart_zwr1,wart_dost1]
sPoziomy = {}

# slownik zdefiniowanych oddzialow dla kontrahenta 
# sKontrOddz: [kontrahent,oddzial_id] = 0
sKontrOddz = {}
for i in xrange(len(dPoziomy)):
    sPoziomy[(dPoziomy[i][0],dPoziomy[i][1],dPoziomy[i][2])] = [dPoziomy[i][3],0,0]
    if dPoziomy[i][1] <> '**':
        if not (dPoziomy[i][0],dPoziomy[i][1]) in sKontrOddz:
            sKontrOddz[(dPoziomy[i][0],dPoziomy[i][1])] = 0

while DataOd <= DataDo:
    sql ="SELECT TRIM(dd.kontrahent_id),TRIM(dd.oddzial_id),TRIM(ddp.artykul_id),"
    sql+=" SUM(ddp.ilosc_zwr1*ddp.cena_upust1),SUM(ddp.ilosc_dost1*ddp.cena_upust1)"
    sql+=" FROM rs_dowody_dostaw_pozycje ddp"
    sql+=" INNER JOIN rs_dowody_dostaw dd USING(firma_id,oddzial_id,trasa,data,tryb_dostawy,numer)"
    sql+=" WHERE ddp.firma_id='"+firma_id+"' AND ddp.data='"+DataOd.strftime("%F")+"'"
    sql+=" GROUP BY dd.kontrahent_id,dd.oddzial_id,ddp.artykul_id;"

    stad,dDDPoz,none,none = PolSQL.Execute(sql,2)
    KonczJesliBlad(stat)
    
    for i in xrange(len(dDDPoz)):
        Kontrah = dDDPoz[i][0]
        Oddzial = dDDPoz[i][1] 
        Artykul = dDDPoz[i][2]
        WaZwroc = dDDPoz[i][3]
        WaDost = dDDPoz[i][4]
        
        # dokladnie dla kontrah,oddzial,artykul
        if (Kontrah,Oddzial,Artykul) in sPoziomy:
            sPoziomy[(Kontrah,Oddzial,Artykul)][1] += WaZwroc
            sPoziomy[(Kontrah,Oddzial,Artykul)][2] += WaDost
        
        # dla kontrah,oddzial=='**',artykul
        if (Kontrah,'**',Artykul) in sPoziomy and not (Kontrah,Oddzial) in sKontrOddz:
            sPoziomy[(Kontrah,'**',Artykul)][1] += WaZwroc
            sPoziomy[(Kontrah,'**',Artykul)][2] += WaDost

        # dla kontrah,oddzial,artykul==''
        if (Kontrah,Oddzial,'') in sPoziomy:
            sPoziomy[(Kontrah,Oddzial,'')][1] += WaZwroc
            sPoziomy[(Kontrah,Oddzial,'')][2] += WaDost

        # dla kontrah,oddzial=='**',artykul==''
        if (Kontrah,'**','') in sPoziomy and not (Kontrah,Oddzial) in sKontrOddz:
            sPoziomy[(Kontrah,'**','')][1] += WaZwroc
            sPoziomy[(Kontrah,'**','')][2] += WaDost

    DataOd += datetime.timedelta(days=1)

# obliczanie wartosci zwrotow i przygotowanie aktualizacji tabeli
lPoziomy = sPoziomy.values()

SQLU = ''
for i in xrange(len(lPoziomy)):
    WartZwroc = lPoziomy[i][1]
    WartDost = lPoziomy[i][2]
    WartProcZwrot = 0
    
    if WartDost > 0:
        WartProcZwrot = rsglobal.RSRound(100*WartZwroc/WartDost,2)
        
    SQLU+="UPDATE rs_kontrahenci_artykuly_poziom_zwrotow"
    SQLU+=" SET procent_zwrotow_wartosc="+str(WartProcZwrot)
    SQLU+=" WHERE numer_id="+str(lPoziomy[i][0])+"; "

if SQLU <> '':
    stat,d,none,none = PolSQL.Execute(SQLU,1)