# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_obroty_magazynowe_sumy.py
# Purpose:     naliczenie miesiecznych obrotow magazynowych dla artykulow
#              do dnia biezacego
# Author:      Mariusz Rajfura
# Created:     2011/11/02
# RCS-ID:      $Id: funkcje_harmonogramu/fs_obroty_magazynowe_sumy.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

TerazRok = fs_time.year
TerazMiesiac = fs_time.month

# pobieramy pierwszy zapis z rs_obroty_magazynowe
sql ="SELECT data FROM rs_obroty_magazynowe WHERE firma_id='"+firma_id+"'"
sql+=" ORDER BY data LIMIT 1;"

stat,dOdKiedyObroty,dump,dump = PolSQL.Execute(sql,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania danych pierwszego zapisu z obrotw magazynowych: '+stat)

if len(dOdKiedyObroty) == 0:
    # tabela rs_obroty_magazynowe jest pusta
    # czyscimy tabele sum obrotow magazynowych z zapisow aby byla
    # "w synchronizacji" z obrotami magazynowymi i koniec pracy
    # (przypadek rzadki ale mozliwy)
    DEL ="DELETE FROM rs_obroty_magazynowe_sumy WHERE firma_id='"+firma_id+"';"

    stat,dump,dump,dump = PolSQL.Execute(DEL,1)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd czyszczenia tabeli sum obrotw magazynowych: '+stat)
    else:
        exit(stat)

OdKiedyRok = None
OdKiedyMiesiac = None

sql ="SELECT rok,miesiac FROM rs_obroty_magazynowe_sumy WHERE firma_id='"+firma_id+"'"
sql+=" ORDER BY rok DESC, miesiac DESC LIMIT 1;"

stat,dOdKiedy, dump,dump = PolSQL.Execute(sql,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania ostatniego okresu z sum obrotw magazynowych: '+stat)
elif len(dOdKiedy) == 1:
    OdKiedyRok = dOdKiedy[0][0]
    OdKiedyMiesiac = dOdKiedy[0][1]
else:
    # pusta tabela rs_obroty_magazynowe_sumy
    # okres startowy przyjmujemy z rs_obroty_magazynowe
    Data = dOdKiedyObroty[0][0]
    OdKiedyRok = int(Data[:4])
    OdKiedyMiesiac = int(Data[5:7])
     

# PoprzRok, PoprzMiesiac dla pobrania sum z poprzedniego okresu
PoprzedniRok = OdKiedyRok
PoprzedniMiesiac = OdKiedyMiesiac - 1
if OdKiedyMiesiac < 1:
    PoprzedniRok -= 1
    PoprzedniMiesiac = 12

# zalogowanie parametrow do wynikow dzialania funkcji - bedzie widoczne na gridzie
print 'Naliczenie od',OdKiedyRok,'/',OdKiedyMiesiac,'do',TerazRok,'/',TerazMiesiac

# naliczamy obroty dla kazdego miesiaca
while (OdKiedyRok,OdKiedyMiesiac) <= (TerazRok,TerazMiesiac):
    print ' Okres', OdKiedyRok,'/',OdKiedyMiesiac
    
    # szukanie wg daty wykorzystuje indeksy na tabeli rs_obroty_magazynowe
    # obliczenie daty konca miesiaca
    DataPoczatkuMiesiaca = str(int(OdKiedyRok))+"-"+str(int(OdKiedyMiesiac)).zfill(2)+'-01'
    
    sql ="SELECT ('"+DataPoczatkuMiesiaca+"'::DATE"
    sql+=" + INTERVAL '1 MONTH' - INTERVAL '1 DAY')::DATE;"

    stat,DataKoncaMiesiaca,dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd obliczenia daty koca miesica: '+stat)
    
    # zablokowanie dokumentow z naliczanego okresu -> blokada trigerow
    SqlBlokadaDok ="SELECT stan FROM rs_dokumenty_magazynowe"
    SqlBlokadaDok+=" WHERE firma_id='"+firma_id+"'"
    SqlBlokadaDok+=" AND data BETWEEN '"+DataPoczatkuMiesiaca+"'"
    SqlBlokadaDok+="  AND '"+rsglobal.Dekoduj(DataKoncaMiesiaca[0][0])+"'"
    SqlBlokadaDok+=" FOR UPDATE;"
    
    stat,dDokNag,dump,dump = PolSQL.Execute(SqlBlokadaDok,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd zablokowania naliczanych dokumentw magazynowych: '+stat)

    # obroty naliczanego miesiaca
    SqlObrotyBiez ="SELECT magazyn_id,artykul_id,"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN ilosc1 ELSE 0 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN ilosc2 ELSE 0 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN wartosc ELSE 0 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN 0 ELSE ilosc1 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN 0 ELSE ilosc2 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN 0 ELSE wartosc END)"
    SqlObrotyBiez+=" FROM rs_obroty_magazynowe"
    SqlObrotyBiez+=" WHERE firma_id='"+firma_id+"'"
    SqlObrotyBiez+=" AND data BETWEEN '"+DataPoczatkuMiesiaca+"'"
    SqlObrotyBiez+="  AND '"+rsglobal.Dekoduj(DataKoncaMiesiaca[0][0])+"'"
    SqlObrotyBiez+=" GROUP BY magazyn_id,artykul_id;"

    stat,dObroty,dump,dump = PolSQL.Execute(SqlObrotyBiez,3)
    if stat <> 'OK':
        msg = 'Bd naliczenia sum z okresu '+str(OdKiedyRok)+'/'+str(OdKiedyMiesiac)+': '+stat
        KonczJesliBlad(stat, msg)

    # usuniecie zapisow dla naliczanego okresu
    DelUsunBiez ="DELETE FROM rs_obroty_magazynowe_sumy"
    DelUsunBiez+=" WHERE firma_id='"+firma_id+"'"
    DelUsunBiez+=" AND rok="+str(OdKiedyRok)+" AND miesiac="+str(OdKiedyMiesiac)+";"

    stat,UsunBiez,dump,dump = PolSQL.Execute(DelUsunBiez,1)
    if stat <> 'OK':
        msg = 'Bd usuwania sum z okresu '+str(OdKiedyRok)+'/'+str(OdKiedyMiesiac)+': '+stat
        KonczJesliBlad(stat, msg)

    # zapisy w naliczanym miesiacu dla poszczegolnych artykulow
    for i in xrange(len(dObroty)):
        Magazyn = rsglobal.Dekoduj(dObroty[i][0])
        Artykul = rsglobal.Dekoduj(dObroty[i][1])

        Przychody1 = dObroty[i][2]
        Przychody2 = dObroty[i][3]
        PrzychodyWart = dObroty[i][4]

        Rozchody1 = dObroty[i][5]
        Rozchody2 = dObroty[i][6]
        RozchodyWart = dObroty[i][7]

        PStanKonc1 = 0
        PStanKonc2 = 0
        PStanKoncWart = 0

        # pobranie stanu koncowego z poprzedniego okresu
        sql ="SELECT stan_konc1,stan_konc2,stan_konc_wart"
        sql+=" FROM rs_obroty_magazynowe_sumy"
        sql+=" WHERE firma_id='"+firma_id+"'"
        sql+=" AND magazyn_id='"+Magazyn+"' AND artykul_id='"+Artykul+"'"
        sql+=" ORDER BY rok DESC, miesiac DESC LIMIT 1;"
        
        stat,dPoprzedni,dump,dump = PolSQL.Execute(sql,3)
        if stat <> 'OK':
            KonczJesliBlad(stat, 'Bd pobrania stanu z poprzedniego okresu: '+stat)
        elif len(dPoprzedni) == 1:
            PStanKonc1 = dPoprzedni[0][0]
            PStanKonc2 = dPoprzedni[0][1]
            PStanKoncWart = dPoprzedni[0][2]

        Ins ="INSERT INTO rs_obroty_magazynowe_sumy"
        Ins+=" (firma_id,magazyn_id,artykul_id,rok,miesiac,"
        Ins+="  stan_pocz1,przychody1,rozchody1,stan_konc1,"
        Ins+="  stan_pocz2,przychody2,rozchody2,stan_konc2,"
        Ins+="  stan_pocz_wart,przychody_wart,rozchody_wart,stan_konc_wart)"
        Ins+=" VALUES"
        Ins+=" ('"+firma_id+"','"+Magazyn+"','"+Artykul+"',"+str(OdKiedyRok)+","+str(OdKiedyMiesiac)+","
        Ins+="  "+str(PStanKonc1)+","+str(Przychody1)+","+str(Rozchody1)+","+str(PStanKonc1+Przychody1-Rozchody1)+","
        Ins+="  "+str(PStanKonc2)+","+str(Przychody2)+","+str(Rozchody2)+","+str(PStanKonc2+Przychody2-Rozchody2)+","
        Ins+="  "+str(PStanKoncWart)+","+str(PrzychodyWart)+","+str(RozchodyWart)+","+str(PStanKoncWart+PrzychodyWart-RozchodyWart)+");"
        
        stat,dump,dump,dump = PolSQL.Execute(Ins,1)
        if stat <> 'OK':
            KonczJesliBlad(stat, 'Bd dodawania sumy obrotw miesica: '+stat+'  '+str(Ins))

    # zachowanie obliczen dla naliczonego miesiaca
    PolSQL.Commit()
    # jaki jest stat po nieudanym commicie?
    KonczJesliBlad(stat)
    
    # po nastepny miesiac
    PoprzedniRok = OdKiedyRok
    PoprzedniMiesiac = OdKiedyMiesiac
    
    OdKiedyMiesiac += 1
    if OdKiedyMiesiac > 12:
        OdKiedyRok += 1
        OdKiedyMiesiac = 1
