# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_obroty_magazynowe_sumy.py
# Purpose:     naliczenie dziennych obrotow magazynowych dla artykulow
#              do dnia biezacego
# Author:      Mariusz Rajfura
# Created:     2011/11/18
# RCS-ID:      $Id: funkcje_harmonogramu/fs_obroty_magazynowe_sumy_dni.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

import time
lista = ['Data']
SprawdzArgumenty(lista)

TerazRok = fs_time.year
TerazMiesiac = fs_time.month


# pobieramy pierwszy zapis z rs_obroty_magazynowe
sql ="SELECT data FROM rs_obroty_magazynowe WHERE firma_id='"+firma_id+"'"
sql+=" ORDER BY data LIMIT 1;"

stat,dOdKiedyObroty,dump,dump = PolSQL.Execute(sql,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania danych pierwszego zapisu z obrotw magazynowych: '+stat)

if len(dOdKiedyObroty) == 0:
    # tabela rs_obroty_magazynowe jest pusta
    # czyscimy tabele sum obrotow magazynowych dni z zapisow aby byla
    # "w synchronizacji" z obrotami magazynowymi i koniec pracy
    # (przypadek rzadki ale mozliwy)
    DEL ="DELETE FROM rs_obroty_magazynowe_sumy_dni WHERE firma_id='"+firma_id+"';"

    stat,dump,dump,dump = PolSQL.Execute(DEL,1)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd czyszczenia tabeli sum obrotw magazynowych za dzie: '+stat)
    else:
        exit(stat)

OdKiedyRok = None
OdKiedyMiesiac = None
if Data <> '':
    OdKiedyRok = int(Data[:4])
    OdKiedyMiesiac = int(Data[5:7])
else:
    sql ="SELECT EXTRACT(YEAR FROM data)::INTEGER, EXTRACT(MONTH FROM data)::INTEGER"
    sql+=" FROM rs_obroty_magazynowe_sumy_dni WHERE firma_id='"+firma_id+"'"
    sql+=" ORDER BY data DESC LIMIT 1;"

    stat,dOdKiedy, dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        msg = 'Bd pobrania ostatniego okresu z sum obrotw magazynowych za dzie: '+stat
        msg+= '\n'+sql
        KonczJesliBlad(stat, msg)
    elif len(dOdKiedy) == 1:
        OdKiedyRok = dOdKiedy[0][0]
        OdKiedyMiesiac = dOdKiedy[0][1]
    else:
        # pusta tabela rs_obroty_magazynowe_sumy
        # okres startowy przyjmujemy z rs_obroty_magazynowe
        DataObr = dOdKiedyObroty[0][0]
        OdKiedyRok = int(DataObr[:4])
        OdKiedyMiesiac = int(DataObr[5:7])


# PoprzRok, PoprzMiesiac dla pobrania sum z poprzedniego okresu
PoprzedniRok = OdKiedyRok
PoprzedniMiesiac = OdKiedyMiesiac - 1
if OdKiedyMiesiac < 1:
    PoprzedniRok -= 1
    PoprzedniMiesiac = 12

# zalogowanie parametrow do wynikow dzialania funkcji - bedzie widoczne na gridzie
ZapiszLog(time.strftime("%Y-%m-%d %T")+
          ' Naliczenie od '+str(OdKiedyRok)+'-'+str(OdKiedyMiesiac).zfill(2)+
          ' do '+str(TerazRok)+'-'+str(TerazMiesiac).zfill(2))

# naliczamy obroty dla kazdego miesiaca
while (OdKiedyRok,OdKiedyMiesiac) <= (TerazRok,TerazMiesiac):
    # szukanie wg daty wykorzystuje indeksy na tabeli rs_obroty_magazynowe
    # obliczenie daty konca miesiaca
    DataPoczatkuMiesiaca = str(int(OdKiedyRok))+"-"+str(int(OdKiedyMiesiac)).zfill(2)+'-01'
    
    sql ="SELECT ('"+DataPoczatkuMiesiaca+"'::DATE"
    sql+=" + INTERVAL '1 MONTH' - INTERVAL '1 DAY')::DATE;"

    stat,d,dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        msg = 'Bd obliczenia daty koca miesica: '+stat
        msg+= '\n'+sql
        KonczJesliBlad(stat, msg)
    
    DataKoncaMiesiaca = rsglobal.Dekoduj(d[0][0])
    
    # zablokowanie dokumentow z naliczanego okresu -> blokada trigerow
    SqlBlokadaDok ="SELECT stan FROM rs_dokumenty_magazynowe"
    SqlBlokadaDok+=" WHERE firma_id='"+firma_id+"'"
    SqlBlokadaDok+=" AND data BETWEEN '"+DataPoczatkuMiesiaca+"'"
    SqlBlokadaDok+="  AND '"+DataKoncaMiesiaca+"'"
    SqlBlokadaDok+=" FOR UPDATE;"
    
    stat,dDokNag,dump,dump = PolSQL.Execute(SqlBlokadaDok,3)
    if stat <> 'OK':
        msg = 'Bd zablokowania naliczanych dokumentw magazynowych: '+stat
        msg += '\n'+SqlBlokadaDok
        KonczJesliBlad(stat, msg)

    # obroty naliczanego miesiaca
    SqlObrotyBiez ="SELECT magazyn_id,artykul_id,data,"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN ilosc1 ELSE 0 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN ilosc2 ELSE 0 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN wartosc ELSE 0 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN 0 ELSE ilosc1 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN 0 ELSE ilosc2 END),"
    SqlObrotyBiez+=" SUM(CASE WHEN typ_znak=1 THEN 0 ELSE wartosc END)"
    SqlObrotyBiez+=" FROM rs_obroty_magazynowe"
    SqlObrotyBiez+=" WHERE firma_id='"+firma_id+"'"
    SqlObrotyBiez+=" AND data BETWEEN '"+DataPoczatkuMiesiaca+"'"
    SqlObrotyBiez+="  AND '"+DataKoncaMiesiaca+"'"
    SqlObrotyBiez+=" GROUP BY magazyn_id,artykul_id,data"
    SqlObrotyBiez+=" ORDER BY magazyn_id,artykul_id,data;"

    stat,dObroty,dump,dump = PolSQL.Execute(SqlObrotyBiez,3)
    if stat <> 'OK':
        msg = 'Bd naliczenia sum z okresu: '+stat
        msg+= '\n'+SqlObrotyBiez
        KonczJesliBlad(stat, msg)

    # usuniecie zapisow dla naliczanego okresu
    DelUsunBiez ="DELETE FROM rs_obroty_magazynowe_sumy_dni"
    DelUsunBiez+=" WHERE firma_id='"+firma_id+"'"
    DelUsunBiez+=" AND data BETWEEN '"+DataPoczatkuMiesiaca+"'"
    DelUsunBiez+="  AND '"+DataKoncaMiesiaca+"';"

    stat,UsunBiez,dump,dump = PolSQL.Execute(DelUsunBiez,1)
    if stat <> 'OK':
        msg = 'Bd usuwania sum z okresu od-do:'+stat
        msg+= '\n'+DelUsunBiez
        KonczJesliBlad(stat, msg)

    # zapisy w naliczanym miesiacu dla poszczegolnych artykulow
    for i in xrange(len(dObroty)):
        Magazyn = rsglobal.Dekoduj(dObroty[i][0])
        Artykul = rsglobal.Dekoduj(dObroty[i][1])
        Data = rsglobal.Dekoduj(dObroty[i][2])

        Przychody1 = dObroty[i][3]
        Przychody2 = dObroty[i][4]
        PrzychodyWart = dObroty[i][5]

        Rozchody1 = dObroty[i][6]
        Rozchody2 = dObroty[i][7]
        RozchodyWart = dObroty[i][8]

        PStanKonc1 = 0
        PStanKonc2 = 0
        PStanKoncWart = 0

        # pobranie stanu koncowego z poprzedniego dnia
        sql ="SELECT stan_konc1,stan_konc2,stan_konc_wart"
        sql+=" FROM rs_obroty_magazynowe_sumy_dni"
        sql+=" WHERE firma_id='"+firma_id+"'"
        sql+=" AND magazyn_id='"+Magazyn+"' AND artykul_id='"+Artykul+"'"
        sql+=" AND data<'"+Data+"'"
        sql+=" ORDER BY data DESC LIMIT 1;"
        
        stat,dPoprzedni,dump,dump = PolSQL.Execute(sql,3)
        if stat <> 'OK':
            msg = 'Bd pobrania stanu z poprzedniej daty: '+stat
            msg+= '\n'+sql
            KonczJesliBlad(stat, msg)
        elif len(dPoprzedni) == 1:
            PStanKonc1 = dPoprzedni[0][0]
            PStanKonc2 = dPoprzedni[0][1]
            PStanKoncWart = dPoprzedni[0][2]

        Ins ="INSERT INTO rs_obroty_magazynowe_sumy_dni"
        Ins+=" (firma_id,magazyn_id,artykul_id,data,"
        Ins+="  stan_pocz1,przychody1,rozchody1,stan_konc1,"
        Ins+="  stan_pocz2,przychody2,rozchody2,stan_konc2,"
        Ins+="  stan_pocz_wart,przychody_wart,rozchody_wart,stan_konc_wart)"
        Ins+=" VALUES"
        Ins+=" ('"+firma_id+"','"+Magazyn+"','"+Artykul+"','"+Data+"',"
        Ins+="  "+str(PStanKonc1)+","+str(Przychody1)+","+str(Rozchody1)+","+str(PStanKonc1+Przychody1-Rozchody1)+","
        Ins+="  "+str(PStanKonc2)+","+str(Przychody2)+","+str(Rozchody2)+","+str(PStanKonc2+Przychody2-Rozchody2)+","
        Ins+="  "+str(PStanKoncWart)+","+str(PrzychodyWart)+","+str(RozchodyWart)+","+str(PStanKoncWart+PrzychodyWart-RozchodyWart)+");"
        
        stat,dump,dump,dump = PolSQL.Execute(Ins,1)
        if stat <> 'OK':
            msg = 'Bd dodawania sumy obrotw za dzien: '+stat
            msg+= '\n'+Ins
            KonczJesliBlad(stat, msg)

    # zachowanie obliczen dla naliczonego miesiaca
    PolSQL.Commit()
    
    Log = 'ObrMagSumyDni: Przetworzono okres '+str(OdKiedyRok)+'-'+str(OdKiedyMiesiac).zfill(2)
    ZapiszLog(time.strftime("%Y-%m-%d %T ")+Log)
    rsglobal.ZapiszDoLogow(Log,2)
    
    # jaki jest stat po nieudanym commicie?
    KonczJesliBlad(stat)
    
    # po nastepny miesiac
    PoprzedniRok = OdKiedyRok
    PoprzedniMiesiac = OdKiedyMiesiac
    
    OdKiedyMiesiac += 1
    if OdKiedyMiesiac > 12:
        OdKiedyRok += 1
        OdKiedyMiesiac = 1
