# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_przypomnij_o_zagadnieniach.py
# Purpose:     Przypominanie o otwartych zagadfnieniach w ktrych nie dzia osi nic od x dni
# Authors:     Aleksander Bargie
# Created:     2023/02/14
# Copyright:   (c) 2023 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

stat = 'OK'

SprawdzArgumenty(['dni', 'operator'])

SQL = """SELECT operator_id, COALESCE(o.email, 'Brak operatora'), zagadnienie_id
FROM rs_wf_zagadnienia 
LEFT JOIN (SELECT operator_id, COALESCE(email, 'Brak maila') AS email FROM rs_operatorzy) o USING (operator_id)
WHERE firma_id = %s AND NOT zamkniete AND modyfikacja_czas < NOW() - %s * INTERVAL '1 DAYS';
;"""
args = [firma_id, dni]
stat, zagadnienia, dump, dump = PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
if stat != 'OK':
    KonczJesliBlad(stat)
else:
    bledy = {}
    bledy_wysylki = {}
    maile = {}
    for zagadnienie in zagadnienia:
        op, odbiorca, zagadnienie_id = zagadnienie
        if odbiorca in ('Brak operatora', 'Brak maila'):
            if odbiorca in bledy:
                bledy[odbiorca].append(str(zagadnienie_id))
            else:
                bledy[odbiorca] = [str(zagadnienie_id)]
        else:
            if odbiorca in maile:
                maile[odbiorca].append(str(zagadnienie_id))
            else:
                maile[odbiorca] = [str(zagadnienie_id)]

    for odbiorca in maile:
        Temat = "Przypomnienie o przypisanych zagadnieniach"
        Tresc = "Przypominamy o przypisanych zagadnieniach czekajcych na rozpatrzenie. Numery zagadnie: {}".format(", ".join(maile[odbiorca]))
        stat = rsglobal.RSWyslijEmail(odbiorca, Temat, Tresc, [], operator, PolSQL)
        if stat != 'OK':
            if odbiorca in bledy_wysylki:
                bledy_wysylki[odbiorca].append("{} - {}".format(zagadnienie_id, stat))
            else:
                bledy_wysylki[odbiorca] = ["{} - {}".format(zagadnienie_id, stat)]

    ZapiszLog("Do wysyki {} przypomnie".format(len(maile)))
    if u'Brak operatora' in bledy:
        ZapiszLog("{} zagadnie bez operatora: {}".format(len(bledy['Brak operatora']), ", ".join(bledy['Brak operatora'])))
    if u'Brak maila' in bledy:
        ZapiszLog("{} zagadnie z operatorem bez adresu email: {}".format(len(bledy['Brak maila']), ", ".join(bledy['Brak maila'])))
    if bledy_wysylki:
        ZapiszLog("{} bdw podczas wysyki".format(len(bledy_wysylki)))
    if bledy_wysylki:
        KonczJesliBlad("Podczas wysyania przypomnie wystpiy bdy")
