# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_reklamacje_klientow_przypomnienia.py
# Purpose:     Przypominanie o rozpatrywanych reklamacjach w ktrych nic si nie dziao od 2 dni
# Authors:     Aleksander Bargie
# Created:     2019/11/21
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2020-07-20 Aleksander Bargie - (11870) Uwagi do reklamacji klientw po spotkaniu
# 2021-09-03 Aleksander Bargie - (12634) fs_reklamacje_klientow_przypomnienia wysya tylko maila na pierwszy adres z lewej

from funkcje import fs_reklamacje_klientow_pdf as pdf

stat = 'OK'

SQL = """SELECT z.zgloszenie_id, array_to_string(array( -- 6. ten kawalek przerabia wielowierszowe podzapytanie w maile rozdzielone przecinkami
                             SELECT DISTINCT email --
                             FROM (SELECT email, oddzial_id, inne, transport, obsluga, produkt, operator_id, FALSE AS dodawanie  -- 4. pierwsze podzapytanie pobiera maile osob obslugujacych dane zgloszenie i poprawnym adresem email
                                    FROM rs_rodo_reklamacje_osoby WHERE firma_id = p.firma_id AND aktywny AND email ~'[^@]+@[^@]+\\\\.[^@]+' 
                                          AND (p.oddzial_id = oddzial_id OR oddzial_id IN ('', '**') OR p.oddzial_id='') -- zgodny oddzial lub obsluguja wszystkie lub nie podano oddzialu w przebiegu
                                          AND (p.transport AND transport OR p.inne AND inne OR p.obsluga AND obsluga OR p.produkt AND produkt) -- co najmniej 1 checkbox sie zgadza
                                    ) AS maile
                              ),
                         ',') AS maile
FROM rs_rodo_reklamacje_zgloszenia z -- 1. zapytanie na zgoszenia
LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p ON p.firma_id='{firma_id}' AND p.zgloszenie_id=z.zgloszenie_id  -- 2. gdzie sie da, pobranie danych z najnowszego wpisu w przebiegu
                                                             AND p.wprowadzone=(SELECT max(wprowadzone) 
                                                                                FROM rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji 
                                                                                WHERE firma_id='{firma_id}' AND zgloszenie_id=z.zgloszenie_id)
WHERE z.firma_id='{firma_id}' AND ostatnia_aktywnosc + INTERVAL '2 DAYS' < NOW() AND stan='W' -- 3. niezamkniete, nieaktywne od 2 dni lub dluzej
;""".format(**locals())
SQL = SQL.format(firma_id)
stat, zgloszenia, dump, dump = PolSQL.Execute(SQL, 3)
if stat != 'OK':
    KonczJesliBlad(stat)
else:
    bledy = {}
    for zgloszenie in zgloszenia:
        zgloszenie_id = zgloszenie[0]
        maile = zgloszenie[1]
        if maile:
            SQLDANE = """SELECT *
                FROM rs_rodo_reklamacje_zgloszenia z
                LEFT JOIN rs_rodo_reklamacje_zgloszenia_przebieg_reklamacji p USING(firma_id, zgloszenie_id)
                WHERE firma_id='{firma_id}' AND zgloszenie_id={zgloszenie_id}
                ORDER BY informacja_kiedy DESC;""".format(**locals())

            stat, dane_zgl, dane_zgl_wyn1, dump = PolSQL.Execute(SQLDANE, 3, CzyDodawacBlad=True)
            if stat != 'OK':
                stat = "Bd pobierania danych zgoszenia: {stat}".format(**locals())
                bledy[zgloszenie_id] = stat
            else:
                for mail in maile.split(','):  #AB 03.09.21r
                    data_zgloszenia = dane_zgl[0][[w[0] for w in dane_zgl_wyn1].index('data_zgloszenia')]
                    nazwa = "Reklamacja_{zgloszenie_id}_{data_zgloszenia}.pdf".format(**locals())
                    Atrapa = rsglobal.StworzAtrapeSelfa(firma_id, PolSQL)
                    Atrapa.KatalogPlikow = KatalogPlikow
                    PDF = pdf.ReklamacjeKilentowPDF(selfSerwera=Atrapa, ZgloszenieID=zgloszenie_id, NazwaPliku=nazwa)
                    stat, plik = PDF.GenerujPDFZeStanemZgloszenia()
                    if stat != ['OK']:
                        stat = "\n".join(stat)
                    else:
                        stat = 'OK'
                    if stat == 'OK':
                        Temat = "Reklamacja nr {zgloszenie_id} z {data_zgloszenia} nie bya modyfikowana od ponad 2 dni".format(
                                **locals())
                        Tresc = "W zaczniku PDF z przebiegiem reklamacji."
                        stat = rsglobal.RSWyslijEmail(mail, Temat, Tresc, [plik], 0, PolSQL)
            if stat != 'OK':
                bledy[zgloszenie_id] = stat

    if bledy:
        KonczJesliBlad("Podczas wysyania przypomnie wystpiy bdy: \n" + '\n'.join(["zgoszenie: {}, bd: {}".format(zgloszenie, blad) for zgloszenie, blad in bledy.iteritems()]))
