# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_sprawdz_konta_kontahentow_na_bialej_liscie.py .py
# Purpose:     Kontrola zgodnoci kont i NIPw kontrahentw z bia list udostpnion przez rzd
# Authors:     Aleksander Bargie
# Created:     2019/11/24
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
#2019-12-16 Aleksander Bargie (11791)  Nie sprawdza biaej listy w danych kontrahenta
#2020-12-28 Wojciech Skowron   (12231)  Symbol i nazwa firmy w nagwku maila
import re
import rsglobal
from time import sleep

"""Wykonuje sprawdzenie nipu i numeru rachunku na biaej licie dla aktywnych kontrahentw ktrzy s dostawcami, 
s z Polski i maj uzupeniony nr konta oraz NIP, a nastpnie wysya powiadomienie na maile przypisane do id 
powiadomienia B0008"""
stat = 'OK'


#WS 2020-12-28 - opis (nazwa_firmy)
sql = "SELECT sprawdzac_biala_liste, opis FROM rs_firmy WHERE firma_id = '" + firma_id + "';"
stat, d, dump, dump = PolSQL.Execute(sql, 3)
if stat != 'OK':
    stat = 'Bd pobrania danych firmy: ' + stat
    KonczJesliBlad(stat)
elif not d[0][0]:
    KonczJesliBlad("Funkcja nieaktywna. W celu aktywacji prosimy o kontakt z Dziaem Obsugi Klienta.")
else:  #WS 2020-12-28
    nazwa_firmy = d[0][1]

Sel = "SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='{}' AND powiadomienie = 'B0008';".format(firma_id)
stat, maile, dump, dump = PolSQL.Execute(Sel, 3)
if stat != 'OK':
    stat = 'Bd pobrania adresw email z tabeli rs_powiadomienia_pozycje: ' + stat
    KonczJesliBlad(stat)
if len(maile) == 0:
    KonczJesliBlad("Nie odnaleziono adresw email dla powiadomienia B0008")

#AB 16.12.19r
SQL = """SELECT kontrahent_id, nazwa, bank_konto, nip
FROM rs_kontrahenci
WHERE firma_id='{}' AND aktywny AND dostawca AND kraj='PL' 
AND bank_konto IS NOT NULL AND TRIM(bank_konto) != ''
AND nip IS NOT NULL AND TRIM(nip) != '' AND NOT nie_sprawdzac_bialej_listy
;"""
SQL = SQL.format(firma_id)
stat, kontrahenci, dump, dump = PolSQL.Execute(SQL, 3)
if stat != 'OK':
    KonczJesliBlad(stat)
bledy = []
zrobiono = 0
for kontrahent in kontrahenci:
    kontrahent_id = kontrahent[0]
    nazwa         = kontrahent[1]
    konto         = re.sub('[^0-9]', '', kontrahent[2])
    nip           = re.sub('[^0-9]', '', kontrahent[3])
    problemy      = []

    wyn = rsglobal.SprNip(nip)
    if wyn == 'BL_NIP_DLUG':
        problemy.append('NIP ma dugo inn ni 10 znakw')
    elif wyn == 'BL_NIP_CRC':
        problemy.append('NIP jest niepoprawny')

    wyn = rsglobal.SprIBAN(konto)
    if wyn == 'BL_IBAN_DLUG':
        problemy.append('numer konta ma dugo inn ni 26 znakw')
    elif wyn == 'BL_IBAN_CRC':
        problemy.append("numer konta jest niepoprawny")

    if len(problemy) == 0:
        sleep(0.1)
        try:
            wyn = rsglobal.SprawdzNaBialejLiscie(konto, nip, verbose=True, liczba_prob=5)
        except Exception, e:
            wyn = None, e
        if wyn[0] is None:
            problemy.append("bd sprawdzania biaej listy: {}".format(wyn[1]))
        if wyn[0] is False:
            problemy.append("pary NIP - numer konta nie odnaleziono na licie, id potwierdzenia: {}".format(wyn[1]))

    if len(problemy) > 0:
        bledy.append("Kontrahent: {} - {}, NIP: {}, konto: {}, problemy: {}".format(kontrahent_id, nazwa, nip, konto, ', '.join(problemy)))
    zrobiono += 1
    if zrobiono % 50 == 0:
        rsglobal.ZapiszDoLogow("fs_sprawdz_konta_kontahentow_na_bialej_liscie postep "+str(zrobiono)+"/"+str(len(kontrahenci)))


if stat == 'OK' and len(bledy) > 0:
    Tresc = "\n".join(bledy)
    #WS 2020-12-28
    Temat = "Podczas sprawdzania numerw kont na biaej liscie napotkano problemy (firma {id} - {nazwa})".format(id=firma_id, nazwa=nazwa_firmy)
    # Temat = "Podczas sprawdzania numerw kont na biaej liscie napotkano problemy."
    ZapiszLog("Napotkano problemy u {bledy} z {kontrahenci} kontrahentw.\n wysano powiadomienia dla {adresy}".format(adresy=','.join([mail[0] for mail in maile]), bledy=len(bledy), kontrahenci=len(kontrahenci)))
    stat = rsglobal.RSWyslijEmail('', Temat, Tresc, [], 0, PolSQL, bcc=','.join([mail[0] for mail in maile]))
elif stat == 'OK':
    ZapiszLog("Sprawdzono {} kontrahentw i nie napotkano bdw".format(len(kontrahenci)))
