# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_sprawdz_kontrahentow_czy_vat.py
# Purpose:     Sprawdzanie czy kontrahenci na dowodach ksigowych z rejestrw zakupowych s aktywnymi patnikami VAT
# Authors:     Aleksander Bargie
# Created:     2018/11/26
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

from funkcje import fs_sprawdz_czy_aktywny_vat_pom as vat
from datetime import datetime, timedelta
import rsglobal

lista = ['liczba_dni']
SprawdzArgumenty(lista)
liczba_dni = rsglobal.Dekoduj(argumenty['liczba_dni'])
SprawdzacNaDate = False

#Pobranie pozycji z rozrachunkw pochodzcych z odpowiednich dowodw dostaw
SQL = """SELECT DISTINCT k.nip, k.kontrahent_id
FROM rs_dowody_ksiegowe dk 
    JOIN rs_kontrahenci k USING(firma_id, kontrahent_id) 
WHERE dk.firma_id='{}' AND dk."data" >= NOW() - INTERVAL '1 month' 
    AND dk.rejestr IN (SELECT kod 
                       FROM rs_rejestry_vat rv 
                       WHERE rv.firma_id = dk.firma_id AND rv.typ = 'Z');""".format(firma_id)
stat, nipy, dump, dump = PolSQL.Execute(SQL, 3)
ZapiszLog('SPRAWDZANE NIPY:  ' + str(nipy))
KonczJesliBlad(stat,'Bd pobierania NIPw kontrahentw: '+stat)

if len(nipy) == 0:
    KonczJesliBlad("BLAD", "Brak NIPw do sprawdzenia")

data = None
bledy = []
if SprawdzacNaDate and liczba_dni > 1:
    data = str(datetime.now()-timedelta(days=liczba_dni))[:10]
for nip in nipy:
        platnik, komunikat = vat.SprAktywnychPlatnikowVAT(nip[0], data)
        SQL = ''
        if platnik is None:
            bledy.append(komunikat)
        elif platnik:
            SQL = """UPDATE rs_kontrahenci
SET aktywny_vat=TRUE, aktywny_vat_data=NOW()::DATE
WHERE firma_id='{}' AND kontrahent_id='{}';""".format(firma_id, nip[1])
        elif not platnik:
            SQL = """UPDATE rs_kontrahenci
            SET aktywny_vat=FALSE, aktywny_vat_data=NOW()::DATE
            WHERE firma_id='{}' AND kontrahent_id='{}';""".format(firma_id, nip[1])
        if SQL != '':
            stat, dump, dump, dump = PolSQL.Execute(SQL, 1)
            if stat != 'OK':
                bledy.append(stat)
if len(bledy) > 0:
    stat = 'BD: ' + str(bledy)
