# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_sprawdz_obroty_i_salda_harmonogram.py
# Purpose:     Sprawdzanie czy w podanym okresie wystpuja
#              jakie niezgodnosci w kontach , wyslanie maila z opisem sytuacji.
# Authors:     Rafa Woniak
# Created:     2018/01/10
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2018-02-13 Aleksander Bargie 10938 - dodanie numerw w {} korzystajc z .format
# 2020-03-11 Jan Raburski - napisanie od pocztku
# 2022-02-22 Jan Raburski - uzwgldnienie przeomw okresu (12860)

import rsglobal

lista = ["Email", "okres_id"]
SprawdzArgumenty(lista)

Email = rsglobal.Dekoduj(argumenty['Email']).split(',')
okres_id = rsglobal.Dekoduj(argumenty['okres_id'])
okres_poprz = okres_id  # dla kosztow z poprzedniego okresu
okres_nast = okres_id  # dla kosztow z nastepnego okresu

stat = "OK"

# pobranie opisu firmy
SQL = "SELECT opis FROM rs_firmy WHERE firma_id ='"+firma_id+"';"
stat, dane, dump, dump = PolSQL.Execute(SQL, 3)
if stat != 'OK':
    stat="BLADFIR"
    KonczJesliBlad(stat,u"Bd pobrania opisu firmy" + stat)
if len(dane) == 1:
    opisfirmy = rsglobal.Dekoduj(dane[0][0])
else:
    opisfirmy = '??????????????????'
Temat = "Kontrola stanw kont dla firmy " + opisfirmy.strip() + " okres: " + okres_id
Tresc = ""

# sprawdzenie istnienia okresu
SQL = "SELECT data_do FROM rs_definicje_okresow WHERE firma_id ='"+firma_id+"' AND okres_id='"+okres_id+"';"
stat, dane, dump, dump = PolSQL.Execute(SQL,3)
if stat != "OK":
    stat = "BLADOKR"
    KonczJesliBlad(stat, u"Bd pobierania okresu " + stat)
if len(dane) == 0:
    stat = "BLADOKR"
    KonczJesliBlad(stat, u"Podano bdny okres" + stat)
DataDo = dane[0][0]

# pobranie poprzedniego i nastepnego okresu dla kosztow
SQL = "SELECT okres_id FROM rs_definicje_okresow WHERE firma_id ='"+firma_id+"' AND data_do<'"+DataDo+"' ORDER BY data_do DESC LIMIT 1;"
stat, dane, dump, dump = PolSQL.Execute(SQL,3)
if stat != "OK":
    stat = "BLADOKR"
    KonczJesliBlad(stat, u"Bd pobierania okresu " + stat)
if len(dane) > 0:
    okres_poprz = dane[0][0]  # jesli nie ma to jest okres_id
SQL = "SELECT okres_id FROM rs_definicje_okresow WHERE firma_id ='"+firma_id+"' AND data_do>'"+DataDo+"' ORDER BY data_do LIMIT 1;"
stat, dane, dump, dump = PolSQL.Execute(SQL,3)
if stat != "OK":
    stat = "BLADOKR"
    KonczJesliBlad(stat, u"Bd pobierania okresu " + stat)
if len(dane) > 0:
    okres_nast = dane[0][0]  # jesli nie ma to jest okres_id

# sprawdzenie czy jest B.O.
SQL = "SELECT count(*) FROM rs_stany_kont sk"
SQL += " WHERE sk.firma_id='" + firma_id + "' and sk.okres_id='" + okres_id + "' and miesiac='00';"
stat, dane, dump, dump = PolSQL.Execute(SQL,3)
if stat != "OK":
    stat = "BLADANYCH"
    KonczJesliBlad(stat, u"Bd pobierania stanw B.O. " + stat)

if dane[0][0] == 0:  # Brak B.O.
    Temat += " - Brak B.O."
    Tresc = "Brak Bilansu Otwarcia w sprawdzanym okresie"
else:
    # jest B.O. - sprawdzenie obrotow i sald w stanach kont
    SQL = "SELECT sk.konto, rok, miesiac, sum(kwota_wn), sum(kwota_ma), sum(saldo_wn), sum(saldo_ma)"
    SQL += " FROM rs_stany_kont sk"
    SQL += " INNER JOIN rs_plan_kont pk ON (sk.firma_id=pk.firma_id AND sk.okres_id=pk.okres_id AND substr(sk.konto,1,3)=pk.kontos_id)"
    SQL += " WHERE sk.firma_id='" + firma_id + "' and sk.okres_id='" + okres_id + "' and not pozabilansowe and pk.konto_id=''"
    SQL += " GROUP BY sk.konto, rok, miesiac"
    SQL += " ORDER BY sk.konto, rok, miesiac;"
    stat, dane, dump, dump = PolSQL.Execute(SQL,3)
    if stat != "OK":
        stat = "BLADANYCH"
        KonczJesliBlad(stat, u"Bd pobierania stanw kont " + stat)

    # sprawdzenie czy zgodne s strony Wn i Ma z BO
    # ponadto dla kazdego konta i  miesiaca sprawdzane jest, czy roznica sum obrotow po stronie Wn i Ma
    # jest rowna roznicy sald Wn i Ma
    BOWn = BOMa = 0
    Konto = '???'
    BladKonto = 'xxx'
    ObrotyWn = ObrotyMa = 0

    # dla kazdego konta obroty sa sumowane w caym okresie, salda sa pobierane w ramach miesiaca
    for w in dane:
        if w[0] == BladKonto:  # pominiecie kolejnych miesiecy jesli byl blad na koncie
            continue

        if w[0] != Konto:   # zmiana konta
            Konto = w[0]
            BladKonto = 'xxx'
            ObrotyWn = ObrotyMa = 0

        ObrotyWn += w[3]
        ObrotyMa += w[4]
        if w[2] == '00':  # B.O. sumy
            BOWn += w[3]
            BOMa += w[4]

        if rsglobal.RSRound(ObrotyWn - ObrotyMa, 2) != rsglobal.RSRound(w[5] - w[6], 2):  # porownanie rznic
            Tresc += "Konto:" + str(Konto) + " Miesic:" + w[1] + "/" + w[2]
            Tresc += " Obroty: "+ str(ObrotyWn) + " / " + str(ObrotyMa)
            Tresc += " Salda:" + str(w[5]) + " / " + str(w[6])
            Tresc += " Rnica:" + str((ObrotyWn - ObrotyMa) - (w[5] - w[6]) ) + "\n"
            BladKonto = Konto

    # sprawdzenie obrotow w stanach konto i operacjach
    SQL = "SELECT sk.konto, rok, miesiac, sum(kwota_wn), sum(kwota_ma),"
    SQL += " COALESCE ( (SELECT SUM(kwota_wn) FROM rs_operacje op"
    #SQL += " WHERE op.firma_id = '" + firma_id + "' AND op.okres_id = '" + okres_id + "' AND op.konto = sk.konto"
    SQL += " WHERE op.firma_id = '" + firma_id + "' AND op.okres_id = '" + okres_id +"' AND op.konto = sk.konto"
    SQL += " AND EXTRACT(YEAR FROM COALESCE(op.data_ksieg_kosztow,op.data))=CAST(sk.rok AS INTEGER) AND EXTRACT(MONTH FROM COALESCE(op.data_ksieg_kosztow,op.data)) = CAST(sk.miesiac AS INTEGER)"
    SQL += " AND NOT dowod_id IN ('BO','BK') ), 0),"
    SQL += " COALESCE ( (SELECT SUM(kwota_ma) FROM rs_operacje op"
    SQL += " WHERE op.firma_id = '" + firma_id + "' AND op.okres_id = '" + okres_id +"' AND op.konto = sk.konto"
    #SQL += " AND okres_id IN ('" + okres_id + "','" + okres_nast + "','" + okres_poprz +"')"
    #SQL += " WHERE op.firma_id = '" + firma_id + "' AND op.okres_id = '" + okres_id + "' AND op.konto = sk.konto"
    SQL += " AND EXTRACT(YEAR FROM COALESCE(op.data_ksieg_kosztow,op.data))=CAST(sk.rok AS INTEGER) AND EXTRACT(MONTH FROM COALESCE(op.data_ksieg_kosztow,op.data)) = CAST(sk.miesiac AS INTEGER)"
    SQL += " AND NOT dowod_id IN ('BO','BK') ), 0)"
    SQL += " FROM rs_stany_kont sk"
    SQL += " WHERE sk.firma_id='" + firma_id + "' and sk.okres_id='" + okres_id + "' AND miesiac <> '00'"
    SQL += " GROUP BY sk.konto, rok, miesiac"
    SQL += " ORDER BY sk.konto, rok, miesiac;"
    stat, dane, dump, dump = PolSQL.Execute(SQL,3)
    if stat != "OK":
        stat = "BLADANYCH"
        KonczJesliBlad(stat, u"Bd pobierania stanw kont i operacji " + stat)

    # ponadto dla kazdego konta i  miesiaca sprawdzane jest, czy suma obrotow po stronie Wn i Ma
    # jest rowna sumie operacji Wn i Ma
    for w in dane:
        if rsglobal.RSRound(w[3], 2) != rsglobal.RSRound(w[5], 2) or rsglobal.RSRound(w[4], 2) != rsglobal.RSRound(w[6], 2):
            Tresc += "Konto:" + str(w[0]) + " Miesic:" + w[1] + "/" + w[2]
            Tresc += " Stany kont: "+ str(w[3]) + " / " + str(w[4])
            Tresc += " Operacje:" + str(w[5]) + " / " + str(w[6])
            Tresc += " Rnica Wn:" + str(w[3] - w[5])
            Tresc += " Rnica Ma:" + str(w[4] - w[6]) + "\n"

    if rsglobal.RSRound(BOWn, 2) != rsglobal.RSRound(BOMa, 2):  # niezgodne BO
        Tresc += "Niezgodne B.O.:" + str(BOWn) + " / " + str(BOMa) + " Rnica:" + str(BOWn - BOMa) + "\n"

if Tresc == "":
    Temat += " - dane poprawne."

Bledy = ''  # ewentualne bledy w wysylaniu zapisywane w harmonogramie
for mail in Email:
    stat = rsglobal.RSWyslijEmail(mail, Temat,Tresc, [], 0, PolSQL)
    if stat != "OK":
        Bledy += stat
if Bledy != '':
    stat = Bledy

#if stat == "OK":
#    SQL = "SELECT * FROM( SELECT rok, miesiac, "
#    SQL += "(SELECT SUM(CASE WHEN miesiac = '00' THEN saldo_wn ELSE kwota_wn END) FROM rs_stany_kont k2 "
#    SQL += "WHERE k2.okres_id = '"+okres_id+"' AND k2.firma_id = '"+firma_id+"' AND (k2.rok < k.rok or (k2.rok = k.rok AND k2.miesiac <= k.miesiac))) AS wn_razem, "
#    SQL += "(SELECT SUM(CASE WHEN miesiac = '00' THEN saldo_ma ELSE kwota_ma END) FROM rs_stany_kont k2 "
#    SQL += "WHERE k2.okres_id = '"+okres_id+"' AND k2.firma_id = '"+firma_id+"' AND (k2.rok < k.rok or (k2.rok = k.rok AND k2.miesiac <= k.miesiac))) AS ma_razem, "
#    SQL += "SUM(saldo_wn) as saldo_wn, "
#    SQL += "SUM(saldo_ma) as saldo_ma "
#    SQL += "FROM rs_stany_kont k WHERE okres_id = '"+okres_id+"' AND firma_id = '"+firma_id+"' "
#    SQL += "GROUP BY rok, miesiac) as x WHERE x.wn_razem - x.ma_razem <> x.saldo_wn - x.saldo_ma "
#    SQL += "ORDER BY rok, miesiac ;"
#    #rsglobal.ZapiszDoLogow(SQL, 1)
#    stat, dane, dump, dump = PolSQL.Execute(SQL, 3)
#if stat == "OK":
#    blad_na_kontach = (len(dane) != 0)
#    SQL = "SELECT SUM(CASE WHEN miesiac = '00' THEN saldo_wn ELSE 0 END) as wn_bo, "
#    SQL += "SUM(CASE WHEN miesiac = '00' THEN saldo_ma ELSE 0 END) as ma_bo, "
#    SQL += "SUM(CASE WHEN miesiac = '00' THEN 0 ELSE kwota_wn END) as wn_razem, "
#    SQL += "SUM(CASE WHEN miesiac = '00' THEN 0 ELSE kwota_ma END) as ma_razem, "
#    SQL += "SUM(CASE WHEN miesiac = '"+str(miesiac)+"' and rok ='"+str(rok)+"' THEN saldo_wn ELSE 0 END) as saldo_wn, "
#    SQL += "SUM(CASE WHEN miesiac = '"+str(miesiac)+"' and rok ='"+str(rok)+"' THEN saldo_ma ELSE 0 END) as saldo_ma "
#    SQL += "FROM rs_stany_kont "
#    SQL += "WHERE firma_id = '" + firma_id + "' AND okres_id = '" + okres_id + "' and substring(konto from 1 for 3) not in "
#    SQL += "(SELECT DISTINCT substring(kontos_id from 1 for 3) FROM rs_plan_kont WHERE firma_id='"+firma_id+"' "
#    SQL += "and okres_id='"+okres_id+"' and pozabilansowe)"
#    stat, dane2, dump, dump = PolSQL.Execute(SQL, 3)
#if stat == "OK":
#    if len(dane2) != 0:
#        blad_w_sumach = dane2[0][0] != dane2[0][1] or dane2[0][2] != dane2[0][3] or dane2[0][4] != dane2[0][5]
#if blad_na_kontach or blad_w_sumach:
#    #AB
#    Tresc += u"Wystpia niezgodno w obrotwce z okresu {0} w firmie {1}\n".format(okres_id, firma)
#if blad_w_sumach:
#    Temat = u"Niezgodno w sumach w obrotwce"
#    SQL1 = "SELECT SUM(CASE WHEN miesiac = '00' THEN saldo_wn ELSE 0 END) as wn_bo, "
#    SQL1 += "SUM(CASE WHEN miesiac = '00' THEN saldo_ma ELSE 0 END) as ma_bo, "
#    SQL1 += "SUM(CASE WHEN miesiac = '00' THEN 0 ELSE kwota_wn END) as wn_razem, "
#    SQL1 += "SUM(CASE WHEN miesiac = '00' THEN 0 ELSE kwota_ma END) as ma_razem, "
#    SQL1 += "SUM(CASE WHEN miesiac = '"+str(miesiac)+"' and rok ='"+str(rok)+"' THEN saldo_wn ELSE 0 END) as saldo_wn, "
#    SQL1 += "SUM(CASE WHEN miesiac = '"+str(miesiac)+"' and rok ='"+str(rok)+"' THEN saldo_ma ELSE 0 END) as saldo_ma, miesiac, rok "
#    SQL1 += "FROM rs_stany_kont "
#    SQL1 += "WHERE firma_id = '" + firma_id + "' AND okres_id = '" + okres_id + "' and substring(konto from 1 for 3) not in "
#    SQL1 += "(SELECT DISTINCT substring(kontos_id from 1 for 3) FROM rs_plan_kont WHERE firma_id='"+firma_id+"' "
#    SQL1 += "and okres_id='"+okres_id+"' and pozabilansowe) \n"
#    SQL1 += "GROUP BY miesiac, rok\n"
#    SQL1 += "ORDER BY rok, miesiac;"
#    stat, dane4, dump, dump = PolSQL.Execute(SQL1, 3)
#    if stat == "OK":
#        for miesiac_konta in dane4:
#            if miesiac_konta[0] != miesiac_konta[1] or miesiac_konta[2] != miesiac_konta[3] or miesiac_konta[4] != miesiac_konta[5]:
#                #AB
#                Tresc += u"W miesicu {0}/{1}: ".format(miesiac_konta[6], miesiac_konta[7])
#                Tresc += u"wn_bo = {0}, ma_bo = {1}\n".format(miesiac_konta[0], miesiac_konta[1])
#                Tresc += u"\t\t\t\trazem_bo = {0}, razem_bo = {1}\n".format(miesiac_konta[2], miesiac_konta[3])
#                Tresc += u"\t\t\t\tsaldo_wn = {0}, saldo_ma = {1}\n".format(miesiac_konta[4], miesiac_konta[5])

#if blad_na_kontach:
#    if len(Temat) > 0:
#        Temat += u" i na kontach"
#    else:
#        Temat = u"Niezgodno na kontach"

#    for bledny_mies in dane:
#        #AB
#        Tresc += u"W miesicu {0}/{1} :\n".format(bledny_mies[1],bledny_mies[0])
#        SQL = "SELECT * FROM (SELECT konto,"
#        SQL += "(SELECT SUM(CASE WHEN miesiac = '00' THEN saldo_wn ELSE kwota_wn END) FROM rs_stany_kont k2 "
#        SQL += "WHERE k2.okres_id = '"+okres_id+"' AND k2.firma_id = '"+firma_id+"' AND (k2.rok < k.rok OR k2.rok = k.rok "
#        SQL += " AND k2.miesiac <= k.miesiac) AND k2.konto = k.konto) as wn_razem, "
#        SQL += "(SELECT SUM(CASE WHEN miesiac = '00' THEN saldo_ma ELSE kwota_ma END) "
#        SQL += "FROM rs_stany_kont k2 WHERE k2.okres_id = '"+okres_id+"' AND k2.firma_id = '"+firma_id+"' "
#        SQL += "AND (k2.rok < k.rok OR k2.rok = k.rok AND k2.miesiac <= k.miesiac) "
#        SQL += "AND k2.konto = k.konto) AS ma_razem, saldo_wn, saldo_ma "
#        SQL += "FROM rs_stany_kont AS k WHERE  firma_id = '"+firma_id+"' AND okres_id = '"+okres_id+"' AND miesiac = '"+bledny_mies[1]+"' "
#        SQL += "AND rok = '"+bledny_mies[0]+"' AND waluta = 'PLN' GROUP BY konto, saldo_wn, saldo_ma, rok, miesiac) AS x "
#        SQL += "WHERE wn_razem - ma_razem != saldo_wn - saldo_ma ORDER BY konto ;"
#        stat, dane3, dump, dump = PolSQL.Execute(SQL, 3)
#        if stat == "OK":
#            wn_razem = 0
#            ma_razem = 0
#            saldo_wn = 0
#            saldo_ma = 0
#            for miesiac_konta in dane3:
#                wn_razem += miesiac_konta[1]
#                ma_razem += miesiac_konta[2]
#                saldo_wn = miesiac_konta[3]
#                saldo_ma = miesiac_konta[4]
#                if wn_razem + ma_razem != saldo_wn + saldo_ma:
#                    #AB
#                    Tresc += u" \t{0} {1} {2} {3} wystpuje niezgodno na koncie {4} \n".format(wn_razem,ma_razem,saldo_wn,saldo_ma,miesiac_konta[0])


#CzyBO = True
#if stat == "OK":
#    # sprawdzenie czy jest BO
#    Select = "SELECT * FROM rs_stany_kont WHERE firma_id ='"+firma_id+"' AND okres_id='"+okres_id+"' AND miesiac='00';"
#    stat, dane, dump, dump = PolSQL.Execute(Select,3)
#    if stat == "OK":
#        CzyBO = (len(dane) > 0)

#if not CzyBO:
#    #JR
#    Temat = u"Zestawienie obrotw i sald w firmie: {0} i okresie : {1} - Brak B.O.".format(firma,okres_id)
#    Tresc = u""
#elif len(Temat) == 0:
#    #AB
#    Temat = u"Zestawienie obrotw i sald w firmie: {0} i okresie : {1} jest poprawne".format(firma,okres_id)
#    Tresc = u""
#else:
#    #AB
#    Temat += u" w obrotwce w firmie: {0} i okresie : {1}".format(firma,okres_id)
#if stat == "OK":
#    for mail in Email:
#        stat = rsglobal.RSWyslijEmail(mail, Temat,Tresc, [], 0, PolSQL)
#else:
#    stat += "\n\n\n sql:\n"+ SQL + "\n\n\nsql1:\n" + SQL1
