# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_sprawdz_polaczenia.py
# Purpose:     Sprawdzanie zbyt dugo otwartych transakcji, wysyanie meili z 
#              powiadomieniami o przekroczeniach.
# Authors:     Piotr Witkowski
# Created:     2015/10/12
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-02-19 Aleksander Bargie (11413) Poprawka w fs_sprawdz_polaczenia -> dodanie pidu
# 2021-06-09 Aleksander Bargie (12522) Dostawy - zmiana sposobu sprawdzania wersji postgresq na dziaajc z wersjami
#                                                 10 i pniej
import rsglobal

lista = ["Email", "Godziny"]
SprawdzArgumenty(lista)
Email = rsglobal.Dekoduj(argumenty['Email']).split(',')
Godziny = rsglobal.Dekoduj(argumenty['Godziny'])
#pobieramy wersj postgresa
SQL="SHOW server_version_num;;"
sql=''
stat,wersja,dump,dump=PolSQL.Execute(SQL,3)


#zmianiamy nazwe kolumny w zaleznosci od wersji, pole procpid na pid zmienio si od wersji 9.2 postgresa
#AB 09.06.21r
numer_wersji = wersja[0][0]
if numer_wersji < 90200:
    kolumna = 'procpid'
    warunek = 'current_query'
    idle = '<IDLE>'
else:
    kolumna = 'pid'
    warunek = 'state'
    idle = 'idle'

SQL1="SELECT distinct l.pid FROM pg_stat_activity a JOIN pg_locks l ON l.pid=a."+kolumna+" "
#RW zamiana minut na hour
SQL1+="WHERE transaction_timestamp() > (query_start + interval '"+str(Godziny)+"' hour) AND l.database > 0  AND "+warunek+" <>'"+idle+"';"
stat,dane,dump,dump=PolSQL.Execute(SQL1,3)
dlugo = 0
Tabele = u''
if stat == 'OK' and len(dane)>0:
    for x in xrange(len(dane)):
        #AB 19.02.19r
        sql="SELECT relname, locktype, mode, granted "
        sql+= " FROM pg_locks l JOIN pg_class c ON c.oid = l.relation WHERE database > 0 and pid = '"+ str(dane[x][0])
        sql+= "' AND (relname like 'rs_%' or relname like 'rsa_%'); "
        stat,DANE,dump,dump=PolSQL.Execute(sql,3)
        Tabele += 'PID: {}\n'.format(dane[x][0])
        if len(DANE)>0:
            dl = [1,1,1]
            for y in xrange(len(DANE)):
                dl = [dl[0] if dl[0] > len(DANE[y][0]) else len(DANE[y][0]),
                      dl[1] if dl[1] > len(DANE[y][1]) else len(DANE[y][1]),
                      dl[2] if dl[2] > len(DANE[y][2]) else len(DANE[y][2])]
            Tabele += u'\t{: <{}}  {: <{}}  {: <{}}  {}\n'.format('relname', dl[0], 'locktype', dl[1], 'mode', dl[2], 'granted')
            for y in xrange(len(DANE)):
                Tabele += u'\t{: <{}}  {: <{}}  {: <{}}  {}\n'.format(DANE[y][0], dl[0], DANE[y][1], dl[1], DANE[y][2], dl[2], DANE[y][3])
        else:
            Tabele += '\tBrak zablokowanych tabel\n'


if stat == 'OK' and len(dane)>0:      #jeeli maj to by tylko tabele to jeszcze: and dlugo==1 
    SQL="SELECT current_database(), opis FROM rs_firmy WHERE firma_id = '"+str(firma_id)+"';"
    stat,Dane,dump,dump=PolSQL.Execute(SQL,3)
    Temat =  u'W bazie danych '+ Dane[0][0]+u' w firmie ' + Dane[0][1]
    Temat += u' stwierdzono dugo otwart transakcj. '
    Tresc = Temat
    if Tabele <> '':
        Tresc += '\n\n' + Tabele
    Tresc = Tresc + u'\n Zaleca si zresetowa poczenie. '
  
    # wysanie maili     
    for mail in Email:       
        rsglobal.ZapiszDoLogow('Mail do '+mail, 1)
        stat = rsglobal.RSWyslijEmail(mail, Temat,str(Tresc), [], 0, PolSQL)
        if stat <> 'OK':
            rsglobal.ZapiszDoLogow(stat + u'Nie wysano maili',1)
        else:
            rsglobal.ZapiszDoLogow(u'Wysano maile do osb z informacj o dugo otwartej transakcji', 1)



