# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_sprawdz_uzupelnienie_generatora.py
# Purpose:     funkcja porwnujca uzupenienie tabel generatora z ich normalnymi odpowiednikami
#              w podanym zakresie dat
# Author:      Micha Raburski
# Created:     2013/01/27
# RCS-ID:      $Id: funkcje_harmonogramu/fs_sprawdz_uzupelnienie_generatora.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
StatTmp = 'OK'

SprawdzArgumenty(['Tabele','DataOd','DataDo'])

LTabel=Tabele.replace(' ','').split(',')

#-------------------------------------------------------------------------------
#--- RS_GR_DOWODY_DOSTAW
#-------------------------------------------------------------------------------

if 'rs_gr_dowody_dostaw' in LTabel:
    SQLGen="SELECT COUNT(*) FROM rs_gr_dowody_dostaw WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLGen+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLGen+=" AND data<='"+DataDo+"';"
        
    SQLTab="SELECT COUNT(*) FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLTab+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLTab+=" AND data<='"+DataDo+"';"

    stat,DaneGen,dump,dump = PolSQL.Execute(SQLGen,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_gr_dowody_dostaw: '+stat)
        
    stat,DaneTab,dump,dump = PolSQL.Execute(SQLTab,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_dowody_dostaw_pozycje: '+stat)
    
    if DaneGen[0][0]<>DaneTab[0][0]:
        StatTmp='BD - w podanym okresie tabele rs_gr_dowody_dostaw i rs_dowody_dostaw_pozycje maj odpowiednio '+str(DaneGen[0][0])+' i '+str(DaneTab[0][0])+' pozycji'
        ZapiszLog(StatTmp)
    else:
        ZapiszLog('Tabela generatora rs_gr_dowody_dostaw - OK')
        

#-------------------------------------------------------------------------------
#--- RS_GR_OBROTY_MAGAZYNOWE
#-------------------------------------------------------------------------------

if 'rs_gr_obroty_magazynowe' in LTabel:
    SQLGen="SELECT COUNT(*) FROM rs_gr_obroty_magazynowe WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLGen+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLGen+=" AND data<='"+DataDo+"';"
        
    SQLTab="SELECT COUNT(*) FROM rs_obroty_magazynowe WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLTab+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLTab+=" AND data<='"+DataDo+"';"

    stat,DaneGen,dump,dump = PolSQL.Execute(SQLGen,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_gr_obroty_magazynowe: '+stat)
        
    stat,DaneTab,dump,dump = PolSQL.Execute(SQLTab,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_obroty_magazynowe: '+stat)
    
    if DaneGen[0][0]<>DaneTab[0][0]:
        StatTmp='BD - w podanym okresie tabele rs_gr_obroty_magazynowe i rs_obroty_magazynowe maj odpowiednio '+str(DaneGen[0][0])+' i '+str(DaneTab[0][0])+' pozycji'
        ZapiszLog(StatTmp)
    else:
        ZapiszLog('Tabela generatora rs_gr_obroty_magazynowe - OK')


#-------------------------------------------------------------------------------
#--- RS_GR_OPERACJE
#-------------------------------------------------------------------------------

if 'rs_gr_operacje' in LTabel:
    SQLGen="SELECT COUNT(*) FROM rs_gr_operacje WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLGen+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLGen+=" AND data<='"+DataDo+"';"
        
    SQLTab="SELECT COUNT(*) FROM rs_operacje WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLTab+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLTab+=" AND data<='"+DataDo+"';"

    stat,DaneGen,dump,dump = PolSQL.Execute(SQLGen,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_gr_operacje: '+stat)
        
    stat,DaneTab,dump,dump = PolSQL.Execute(SQLTab,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_operacje: '+stat)
    
    if DaneGen[0][0]<>DaneTab[0][0]:
        StatTmp='BD - w podanym okresie tabele rs_gr_operacje i rs_operacje maj odpowiednio '+str(DaneGen[0][0])+' i '+str(DaneTab[0][0])+' pozycji'
        ZapiszLog(StatTmp)
    else:
        ZapiszLog('Tabela generatora rs_gr_operacje - OK')


#-------------------------------------------------------------------------------
#--- RS_GR_PROJEKTY
#-------------------------------------------------------------------------------

if 'rs_gr_projekty' in LTabel:
    SQLGen="SELECT COUNT(*) FROM rs_gr_projekty WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLGen+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLGen+=" AND data<='"+DataDo+"';"
        
    SQLTab="SELECT COUNT(*) FROM rs_dowody_ksiegowe_projekty WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLTab+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLTab+=" AND data<='"+DataDo+"';"

    stat,DaneGen,dump,dump = PolSQL.Execute(SQLGen,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_gr_projekty: '+stat)
        
    stat,DaneTab,dump,dump = PolSQL.Execute(SQLTab,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_dowody_ksiegowe_projekty: '+stat)
    
    if DaneGen[0][0]<>DaneTab[0][0]:
        StatTmp='BD - w podanym okresie tabele rs_gr_projekty i rs_dowody_ksiegowe_projekty maj odpowiednio '+str(DaneGen[0][0])+' i '+str(DaneTab[0][0])+' pozycji'
        ZapiszLog(StatTmp)
    else:
        ZapiszLog('Tabela generatora rs_gr_projekty - OK')


#-------------------------------------------------------------------------------
#--- RS_GR_SPRZEDAZ
#-------------------------------------------------------------------------------

if 'rs_gr_sprzedaz' in LTabel:
    SQLGen="SELECT COUNT(*) FROM rs_gr_sprzedaz WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLGen+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLGen+=" AND data<='"+DataDo+"';"
        
    SQLTab1="SELECT COUNT(*) FROM rs_faktury WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLTab1+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLTab1+=" AND data<='"+DataDo+"';"

    SQLTab2="SELECT COUNT(*) FROM rs_korekty WHERE firma_id='"+firma_id+"'"
    if DataOd<>'':
        SQLTab2+=" AND data>='"+DataOd+"'"
    if DataDo<>'':
        SQLTab2+=" AND data<='"+DataDo+"';"
        
    stat,DaneGen,dump,dump = PolSQL.Execute(SQLGen,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_gr_sprzedaz: '+stat)
        
    stat,DaneTab1,dump,dump = PolSQL.Execute(SQLTab1,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_faktury: '+stat)
        
    stat,DaneTab2,dump,dump = PolSQL.Execute(SQLTab2,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd sprawdzania danych w tabeli rs_korekty: '+stat)
    
    
    if DaneGen[0][0]<>DaneTab1[0][0]+DaneTab2[0][0]:
        StatTmp='BD - w podanym okresie tabele rs_gr_sprzedaz i suma tabel rs_faktury i rs_korekty maj odpowiednio '+str(DaneGen[0][0])+' i '+str(DaneTab1[0][0]+DaneTab2[0][0])+' pozycji'
        ZapiszLog(StatTmp)
    else:
        ZapiszLog('Tabela generatora rs_gr_sprzedaz - OK')

if StatTmp<>'OK':
    KonczJesliBlad('UWAGA! Niektre tabele generatora nie s aktualne!')