# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_usun_pliki_komser.py
# Purpose:     Usuwanie archiwalnych plikow komsera starszych niz podana liczba dni
# Authors:     Wojciech Skowron
# Created:     2019/01/07
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

import rsglobal
from os.path import isdir
global usuwanie


def usuwanie(katalog, liczbaDni):
    from os import listdir, remove
    from os.path import isfile, getmtime, isdir
    from datetime import datetime

    for plik in listdir(katalog):
        sciezka = katalog + '/' + plik
        if isfile(sciezka):
            dataModPliku = datetime.fromtimestamp(getmtime(sciezka))
            teraz = datetime.now()
            roznica = teraz - dataModPliku
            if (roznica.days > liczbaDni) or (roznica.days == liczbaDni and roznica.seconds > 0):
                ZapiszLog('Usuwam plik: ' + sciezka + ', ma ' + str(roznica.days) + ' dni.')
                remove(sciezka)

lista = ['liczba_dni']
SprawdzArgumenty(lista)
liczbaDni = rsglobal.Dekoduj(argumenty['liczba_dni'])

stat = 'OK'

plikKonf = "rs-and.conf"
param    = ('komserwer', 'komserkatalog', 'komserklienci')
lista    = rsglobal.PodajZKonf(plikKonf, param)

czySerwer = lista[0]
katalog   = lista[1]
klienci   = lista[2].split(',')

# sprawdzenie parametrow sekcji komser z konfigu

if czySerwer != '1':
    stat = 'Nie jest to wezel serwerowy'
elif katalog == '':
    stat = 'Brak ' + param[1] + 'w konfigu'
elif klienci == '':
    stat = 'Brak ' + param[2] + 'w konfigu'

if stat != 'OK':
    KonczJesliBlad(stat)

# stworzenie listy katalogow, z ktorych beda usuwane pliki

katalogi = []
for kl in klienci:
    katalogKlienta    = katalog + '/' + kl.strip()
    katalogKlientaIn  = katalogKlienta + '/in/stare'
    katalogKlientaOut = katalogKlienta + '/out/stare'

    if isdir(katalogKlientaIn):
        katalogi.append(katalogKlientaIn)
    if isdir(katalogKlientaOut):
        katalogi.append(katalogKlientaOut)

# usuwanie plikow z kolejnych katalogow

for kat in katalogi:
    usuwanie(kat, liczbaDni)

