#
# -*- coding: iso8859_2 -*-
# Funkcja harmonogramu: fs_wczytaj_dane_z_od01_z_foxa
#  Wczytanie danych z plikow generowanych przez fox
# raportw: rs_gr_sprzedaz
#

import datetime
import os
import os.path

query = "SELECT funkcja FROM rs_tabele_generatora WHERE tabela = 'rs_gr_sprzedaz'"
stat, funkcja, none, none = PolSQL.Execute(query, 5)

if stat == "OK":
    funkcja = rsglobal.Dekoduj(funkcja)

    data = fs_time
    for ile in range(14):
        sdata = data.strftime("%F")
        query = "SELECT " + funkcja + "('" + firma_id + "', '" + sdata + "', '" + sdata + "')"
        stat, none, none, none = PolSQL.Execute(query, 1)

        KonczJesliBlad(stat)

        data -= datetime.timedelta(days=1)

    if not os.path.isfile('./fox'):
        #----- powrot - nie ma pliku fox -powrot z bledem ze jest uruchomiona w harmonogramie funkcja
        KonczJesliBlad(u'Brak pliku fox - niepotrzebnie uruchomiona funkcja')

    try:
        f=file('./fox','r')
    except:
        #---- powrot z bledem - blad otwarcia pliku fox
        KonczJesliBlad(u'Bd otwarcia pliku fox')
    parametry=f.read()
    f.close()
    parametry=parametry.splitlines()
    if len(parametry)==0:
        #--- pusty plik - powrot z bledem o pustym pliku fox
        KonczJesliBlad(u'Pusty plik fox')

    katalog=parametry[0].strip()
    if not os.path.isdir(katalog):
        #---- bledna sciezka lub brak mapowania - napisac jaka 
        KonczJesliBlad(u'Bdny katalog : '+katalog)

    pliktxt=katalog+'od01.txt'
    plikana=katalog+'od01.ana'
    plikerr=katalog+'od01.err'
    if os.path.isfile(plikana):
        #--- powrot z bledem sie nie zakonczylo poprzednie wykonanie
        KonczJesliBlad(u'Poprzednie wykonanie funkcji w toku')

    if not os.path.isfile(pliktxt):
        #--- powrot z info ze nie bylo zmian do wczytania
        KonczJesliBlad(stat,u'Brak nowych danych do wczytania')
        #KonczJesliBlad(u'OK')
    
    try:
        os.rename(pliktxt, plikana)
    except:
        #--- powrot z bledem - brak dostepu do pliku albo plik zajety przez foxa
        KonczJesliBlad(u'Brak dostpu do pliku lub plik zajty przez foxa')
    
    try:
        f=file(plikana,'r')
    except:
        #--- powrot z bledem - brak dostepu do pliku
        KonczJesliBlad(u'Brak dostpu do pliku')
        
    wiersze=f.read()
    f.close()
    bledy=[]
    try:
        os.remove(plikana)
    except:
        #--- zapamietac blad, ale obsluzyc wczytane wiersze- brak dostepu do pliku
        bledy.append(u'Brak dostpu do pliku - nie mona go usun')
    wiersze=wiersze.splitlines()
    # w petli obslugiwac wiersze i tworzyc liste bledow
    
    pierwszy=True
    for w in wiersze:
        w=w.decode('cp1250').encode('iso-8859-2')
        if pierwszy:
            #---- obrobka pierwszego
            SymbPl=w[0:5]
            Nip=w[6:21]
            Regon=w[21:30]
            Pesel=w[31:42]
            AdrKod=w[42:48]
            AdrMiej=w[48:78]
            AdrUlica=w[78:118]
            AdrNr=w[118:124]
            Tel=w[124:139]
            Fax=w[139:154]
            Nazwa=w[154:204]
            NazwaF1=w[204:254]
            NazwaF2=w[254:304]
        else:
            #obrobka drugiego (insert lub update)
            BankNazwa=w[1:51]
            BankKonto=w[51:96]
            Email=w[96:146]
            Nowy=(w[146]=='T')
            Kraj=w[147:149]

            query="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+firma_id+"' AND kontrahent_id='"+SymbPl+"';"
            stat, DaneK, none, none = PolSQL.Execute(query, 3)
            KonczJesliBlad(stat)

            if Nowy and (len(DaneK)>0):
                bledy.append(u'Nie mozna doda kontrahenta '+SymbPl.strip()+' bo znajduje si on ju w bazie danych.')
            elif (not Nowy) and (len(DaneK)==0):
                bledy.append(u'Nie mozna zmieni kontrahenta '+SymbPl.strip()+' bo nie ma go w bazie danych.')
            else:
                if Nowy:
                    SQL="INSERT INTO rs_kontrahenci (firma_id,kontrahent_id,nip,regon,pesel,adr_kod,adr_miej,adr_ulica,adr_nry,tel1,fax,nazwa,"
                    SQL+="nazwa_f1,nazwa_f2,bank_nazwa,bank_konto,email, kraj, odbiorca, dostawca) VALUES"
                    SQL+="('"+firma_id+"','"+SymbPl+"','"+Nip+"','"+Regon+"','"+Pesel+"','"+AdrKod+"','"+AdrMiej+"','"+AdrUlica+"','"+AdrNr+"',"
                    SQL+="'"+Tel+"','"+Fax+"','"+Nazwa+"','"+NazwaF1+"','"+NazwaF2+"','"+BankNazwa+"','"+BankKonto+"','"+Email+"','"+Kraj+"', True, True);"
                else:
                    SQL="UPDATE rs_kontrahenci SET nip='"+Nip+"',regon='"+Regon+"',pesel='"+Pesel+"',adr_kod='"+AdrKod+"',adr_miej='"+AdrMiej+"',"
                    SQL+="adr_ulica='"+AdrUlica+"',adr_nry='"+AdrNr+"',tel1='"+Tel+"',fax='"+Fax+"',nazwa='"+Nazwa+"',"
                    SQL+="nazwa_f1='"+NazwaF1+"',nazwa_f2='"+NazwaF2+"',bank_nazwa='"+BankNazwa+"',bank_konto='"+BankKonto+"',email='"+Email+"',kraj='"+Kraj+"'"
                    SQL+=" WHERE firma_id='"+firma_id+"' AND kontrahent_id='"+SymbPl+"';"
                
                stat, none, none, none = PolSQL.Execute(SQL, 1)
                if stat <> 'OK':
                    bledy.append(SymbPl.strip()+' : '+stat)
                KonczJesliBlad(stat)
                
        pierwszy=not pierwszy
    
    
    if len(bledy)>0:
        #---- zapis bledow
        try:
            f=file(plikerr,'a+')
        except:
            #--- powrot z bledem - wystapily bledy ale nie udalo sie zapisac
            KonczJesliBlad(u'Brak dostpu do pliku z bdami')
        
        for b in bledy:
            f.write(rsglobal.Dekoduj(b)+chr(13)+chr(10))
        f.close()

else:
    ZapiszLog(stat + " funkcja:" + funkcja)

