#
# -*- coding: iso8859_2 -*-
# Funkcja harmonogramu: fs_wczytaj_dane_z_platnosci_z_foxa
#  Wczytanie danych z plikow generowanych przez fox
#
SprawdzArgumenty(['EMail'])

import datetime
import rsglobal
import os
import os.path

stat='OK'
Blad=False

if stat == "OK":
    if not os.path.isfile('./fox'):
        stat='KONIEC'
        #----- powrot - nie ma pliku fox -powrot z bledem ze jest uruchomiona w harmonogramie funkcja
        #Blad=True
        #stat=u'Brak pliku fox - niepotrzebnie uruchomiona funkcja'

if stat == "OK":
    try:
        f=file('./fox','r')
    except:
        #---- powrot z bledem - blad otwarcia pliku fox
        Blad=True
        stat=u'Bd otwarcia pliku fox'
        
if stat == "OK":
    parametry=f.read()
    f.close()
    parametry=parametry.splitlines()
    if len(parametry)==0:
        #--- pusty plik - powrot z bledem o pustym pliku fox
        Blad=True
        stat=u'Pusty plik fox'

if stat == "OK":
    katalog=parametry[0].strip()
    if not os.path.isdir(katalog):
        #---- bledna sciezka lub brak mapowania - napisac jaka 
        Blad=True
        stat=u'Bdny katalog z plikami do wczytania patnoci : '+katalog

if stat == "OK":
    pliktxt=katalog+'przel.txt'
    plikana=katalog+'przel.ana'
    plikerr=katalog+'przel.err'
    if os.path.isfile(plikana):
        #--- powrot z bledem sie nie zakonczylo poprzednie wykonanie
        stat=u'Poprzednie wykonanie funkcji w toku - plik '+plikana+' cigle istnieje'

if stat == "OK":
    if not os.path.isfile(pliktxt):
        stat='KONIEC'
        #--- powrot z info ze nie bylo zmian do wczytania
        #stat=u'Brak nowych danych do wczytania'
    
if stat == "OK":
    try:
        os.rename(pliktxt, plikana)
    except:
        #--- powrot z bledem - brak dostepu do pliku albo plik zajety przez foxa
        Blad=True
        stat=u'Brak dostpu do pliku lub plik zajty przez foxa'
    
if stat == "OK":
    try:
        f=file(plikana,'r')
    except:
        #--- powrot z bledem - brak dostepu do pliku
        Blad=True
        stat=u'Brak dostpu do pliku'
        
if stat == "OK":
    wiersze=f.read()
    f.close()

if stat == "OK":        
    wiersze=wiersze.splitlines()
    # w petli obslugiwac wiersze i tworzyc liste bledow
    
    for w in wiersze:
        if stat=='OK':
            NrFakt=w[0:7]
            NrFaktD=w[7:37]
            DataD=w[37:41]+'-'+w[41:43]+'-'+w[43:45]
            DataWplywu=w[45:49]+'-'+w[49:51]+'-'+w[51:53]
            TerminPlat=w[53:57]+'-'+w[57:59]+'-'+w[59:61]
            DoZapl=w[61:73]
            Zaokr=w[73:85]
            SymbKontr=w[85:90]
            if len(w) > 90:
                # dodatkowa kwota vat dl MPP
                KwotaVat = w[90:]
            else:
                KwotaVat = '0.0'
            WierszBlad='Wiersz '+str(w)+'\n'
            
            # sprawdzenie czy kontrahent istnieje
            SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+firma_id+"' AND kontrahent_id='"+SymbKontr+"'"
            stat, DaneKontr, none, none = PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                Blad=True
                stat=WierszBlad+u'Bd pobierania danych kontrahenta : '+stat
            elif len(DaneKontr)==0:
                Blad=True
                stat=WierszBlad+u'Brak podanego kontrahenta : '+SymbKontr
    	
    	if stat == "OK":
            SQL="SELECT konto_id FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+firma_id+"' "
            SQL+=" AND kontrahent_id='"+SymbKontr+"' AND data_od <='"+TerminPlat+"' ORDER BY data_od DESC LIMIT 1;"
            stat, DaneKonta, none, none = PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                Blad=True
                stat=WierszBlad+u'Bd pobierania danych konta : '+stat
                
        if stat == "OK":
            Konto='NULL'
            if len(DaneKonta)>0:
                Konto=rsglobal.Dekoduj(DaneKonta[0][0])
                if Konto in ['',None,'None']:
                    Konto='NULL'
                else:
                    Konto="'"+Konto+"'"
    	
            if Konto=='NULL':
                SQL="SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+firma_id+"' ORDER BY konto_id LIMIT 1;"
                stat, DaneKonta, none, none = PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    Blad=True
                    stat=WierszBlad+u'Bd pobierania danych konta z kont bankowych : '+stat
                elif len(DaneKonta)>0:
                    Konto=rsglobal.Dekoduj(DaneKonta[0][0])
                    Konto="'"+Konto+"'"
    	    
    	if stat=='OK':   	
    	    SQL="INSERT INTO rs_platnosci (firma_id,kontrahent_id,stan,nr_faktury,termin_plat,kwota_oryg,kwota_platnosci,konto_id,kwota_vat)"
            SQL+=" VALUES ('"+firma_id+"','"+SymbKontr+"','W','"+NrFaktD+"','"+TerminPlat+"',"+DoZapl+","+DoZapl+","+Konto+","+KwotaVat+");"
            stat, none, none, none = PolSQL.Execute(SQL, 1)
            if stat <> 'OK':
                Blad=True
                stat=WierszBlad+u'Bd wstawienia danych : '+stat
if stat=='OK':
    try:
        os.remove(plikana)
    except:
        Blad=True
        stat=u'Brak dostpu do pliku - nie mona go usun'
else:
    try:
        os.rename(plikana, plikerr)
    except:
        pass
    
if stat=='KONIEC':
    stat='OK'
    
if stat <> "OK":
    # prba wysania maila na podany w parametrach adres
    if ('@' in EMail) and Blad:
        Temat='Bdy wykonania wczytania danych z patnoci FOXA'
        Tresc=' W wykonaniu funkcji harmonogramu wystpi nastpujcy bd :\n\n'+stat
        try:
            rsglobal.RSWyslijEmail(EMail, Temat,Tresc,[],0,PolSQL)
        except:
            stat=' Bd wysyania pliku do '+EMail+' z bdem '+stat

    KonczJesliBlad(stat)