# -*- coding: iso8859_2 -*-

# 2022-10-04 Wojciech Skowron - (12174) Poprawiona obsuga pliku
# 2024-02-20 Wojciech Skowron - (13695) Przyjmowany stat z ZmienCSVwXLS

SprawdzArgumenty(['Testy'])

import os.path
import tempfile

import rsglobal
from funkcje import fs_testy_kompletnosci_pom
from funkcje import fs_pliki_office

stat='OK'
Atrapa = rsglobal.StworzAtrapeSelfa(firma_id,PolSQL)

# pobranie testw do wykonania
SQL="SELECT raport_id FROM rs_testy_kompletnosci"
SQL+=" WHERE firma_id='"+firma_id+"'" 
if Testy != '':
    SQL+=" AND raport_id IN ("+Testy+")"

stat,DTesty,dump,dump=PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
if stat != 'OK':    
    stat="Bd pobierania listy testw do wykonania : "+stat

KonczJesliBlad(stat)

# PTLA PO TESTACH
for test in DTesty:
    Nr = test[0]
    ZapiszLog('\nWYKONANIE TESTU NR '+str(Nr)+'\n')
    
    # pobranie treci testu
    stat,Tresc,LPowiad,Nazwa = fs_testy_kompletnosci_pom.WykonajTestKompletnosci(Atrapa,Nr)
    if stat != 'OK':
        ZapiszLog('Bd pobrania treci testu :'+str(stat))
        stat = 'OK'
        continue
    
    # brak wynikw
    if len(Tresc) < 3:
        ZapiszLog('Test nie zgasza danych do zaraportowania ')
        continue
    
    # brak powiadomie
    if len(LPowiad) == 0:
        ZapiszLog('Brak adresatw wykonywanego testu ')
        continue
    
    # utworzenie pliku CSV
    PlikCSV = tempfile.mktemp('.csv')
    PlikXLS = os.path.dirname(PlikCSV)+'/Raport'+str(Nr)+'.xlsx'
    #WS 2022-10-04
    with open(PlikCSV, 'wb') as p:
        p.write(Tresc)
    # open(PlikCSV, 'wb').write(Tresc)
    
    # utworzenie pliku XLSX
    stat = fs_pliki_office.ZmienCSVwXLS(PlikCSV,PlikXLS,'iso8859_2',True)  #WS 2024-02-20 - stat=
    if not os.path.exists(PlikXLS):
        ZapiszLog('Wystpiy bdy z utworzeniem pliku XLSX: '+stat)  #WS 2024-02-20 - +stat
        continue

    # pobranie adresatw dla testu
    SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+firma_id+"'"
    SQL+=" AND powiadomienie IN ("
    for grupa in LPowiad:
        SQL+="'"+grupa+"',"
    SQL = SQL.strip(',')
    SQL+=");"
    
    stat,DPoczta,dump,dump=PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
    if stat != 'OK':    
        ZapiszLog("Bd pobierania listy kont pocztowych dla testu : "+stat)
        stat= 'OK'
        continue

    # wysanie maila do odpowiednich adresatw
    Temat="TEST NR "+str(Nr)+" - "+Nazwa
    Tresc="W zaczniku wyniki testu nr "+str(Nr)+" wykonanego dnia "+rsglobal.PodajDzis()

    # wysanie maili
    Ile = 0
    for mail in DPoczta:
        ZapiszLog('Mail do '+mail[0])
        stat = rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[PlikXLS],0,PolSQL)
        if stat != 'OK':
            ZapiszLog(stat)
        else:
            Ile += 1
            
    ZapiszLog('Wysano maile dla testu : '+str(Ile))