# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_wyslij_dokumenty.py .py
# Purpose:     Wysyka faktur, korekt i dd w formacie xml
# Authors:     Aleksander Bargie
# Created:     2020/10/27
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2020-11-05 Aleksander Bargie (12177) - Wysyanie dokumentw do Doroty - wyczy wyznaczniki korekt wartociowych

from funkcje import fs_ftp_obsluga, fs_xml_dowod_dostawy, fs_xml_faktura, fs_xml_korekta
stat = 'OK'
lista = ['dni_wstecz']
SprawdzArgumenty(lista)
dni_wstecz = rsglobal.Dekoduj(argumenty['dni_wstecz'])

try:
    fs_ftp_obsluga.inicjujKatalogi(firma_id=firma_id)
except Exception, e:
    import traceback
    ZapiszLog(traceback.format_exc())
    stat = str(e)

#  faktury - XML CzyStandard=True
# pobranie danych
if stat == 'OK':
    SQLFaktury = """SELECT wyznacznik_id, data, numer
                    FROM rs_faktury f
                    JOIN rs_kontrahenci k ON (k.firma_id, k.kontrahent_id) = (f.firma_id, f.kontrahent_id) 
                    JOIN rs_kontrahenci p ON (p.firma_id, p.kontrahent_id) = (f.firma_id, f.platnik_id) 
                    WHERE f.firma_id = '{firma_id}' AND "data" <= NOW()::DATE - INTERVAL '{dni_wstecz} DAY' 
                       AND "data" >= NOW()::DATE - INTERVAL '30 DAY' 
                       AND stan IN ('Z', 'K') AND (character_length(k.ftp_nazwa)>0 OR  character_length(p.ftp_nazwa)>0)
                       AND data_exportu IS NULL
                       ;""".format(firma_id=firma_id, dni_wstecz=dni_wstecz)

    statF, Faktury, PolaFaktur, dump = PolSQL.Execute(SQLFaktury, 3)
    PolaFaktur = [d[0] for d in PolaFaktur]
    if statF != 'OK':
        statF = 'Bd pobrania listy faktur: ' + statF
    else:
        fxml = fs_xml_faktura.RSFakturaXml()
    for faktura in Faktury:
        wyznacznik_id   = faktura[PolaFaktur.index('wyznacznik_id')]
        data            = faktura[PolaFaktur.index('data')]
        numer           = faktura[PolaFaktur.index('numer')]
        Symbol          = wyznacznik_id.strip() + "/" + data + "/" + str(numer)
        typ             = 'oryginal'
        CzyStandard     = True  # jest true dla xml - standard
        TylkoZamowienia = False  # eksportowaloby tylko faktury z zamowien
        CzyWszystko     = True   # dla true sprawdza, czy faktura nei zostala wczesniej wyeksportowana i ja wtedy pomija
        try:
            OK = fxml.ZapiszFakture(wyznacznik_id, data, numer, typ, CzyStandard, TylkoZamowienia, CzyWszystko,
                                    firma_id, WykonajFunkcje)
        except Exception, e:
            OK = 'Faktura ' + Symbol + " " + ': Bd tworzenia pliku XML: ' + str(e)
        else:
            if isinstance(OK, tuple):
                OK = OK[0]
            else:
                ftp = False
        if OK != 'OK':
            ZapiszLog('Faktura ' + Symbol + " " + OK)
            statF = 'blad'
    if statF == 'OK':
        Klucze = {'Funkcja': 8}
        statF, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', Klucze, [], [], [0, firma_id, '', ''])
        if statF != 'OK':
            ZapiszLog(statF)
            dane = [[], []]

        if len(dane[0]) > 0 or len(dane[1]) > 0:
            for blad in dane[0] + dane[1]:
                ZapiszLog(blad)
#  Korekty
    if stat == 'OK':  #AB 05.11.20r Dopisany join na rs_wyznaczniki i warunek w.typ_faktury !='KW'
        SQLKorekty = """SELECT wyznacznik_id, data, numer
                        FROM rs_korekty fk
                        JOIN rs_wyznaczniki w USING (firma_id, wyznacznik_id)
                        JOIN rs_kontrahenci k ON (k.firma_id, k.kontrahent_id) = (fk.firma_id, fk.kontrahent_id)
                        JOIN rs_kontrahenci p ON (p.firma_id, p.kontrahent_id) = (fk.firma_id, fk.platnik_id) 
                        WHERE fk.firma_id = '{firma_id}' AND "data" <= NOW()::DATE - INTERVAL '{dni_wstecz} DAY' 
                         AND "data" >= NOW()::DATE - INTERVAL '30 DAY'  AND w.typ_faktury !='KW'
                         AND stan IN ('Z','K') AND (character_length(k.ftp_nazwa)>0 OR  character_length(p.ftp_nazwa)>0)
                         AND data_exportu IS NULL AND COALESCE(fk.opis, '') != '' 
                        ;""".format(firma_id=firma_id, dni_wstecz=dni_wstecz)

        statK, Korekty, PolaKorekt, dump = PolSQL.Execute(SQLKorekty, 3)
        PolaKorekt = [d[0] for d in PolaKorekt]
        if statK != 'OK':
            statK = 'Bd pobrania listy korekt: ' + statK
        else:
            kxml = fs_xml_korekta.RSKorektaXml()
        for korekta in Korekty:
            wyznacznik_id = korekta[PolaKorekt.index('wyznacznik_id')]
            data          = korekta[PolaKorekt.index('data')]
            numer         = korekta[PolaKorekt.index('numer')]
            Symbol        = wyznacznik_id.strip() + "/" + data + "/" + str(numer)
            typ = 'oryginal'
            CzyStandard  = True   # jest true dla xml - standard
            CzyCarrefour = True   # wydruk xml - Carrefour
            CzyTesco     = False  # jak Carrefour, to nie Tesco
            CzyWszystko  = True   # dla true sprawdza, czy korekta nie zostala wczesniej wyeksportowana i ja pomija
            try:
                OK = kxml.ZapiszKorekte(wyznacznik_id, data, numer, typ, CzyStandard, CzyWszystko, CzyTesco,
                                        CzyCarrefour, firma_id, WykonajFunkcje)
            except Exception, e:
                OK = 'Korekta ' + Symbol + " " + ': Bd tworzenia pliku XML: ' + str(e)
            else:
                if isinstance(OK, tuple):
                    OK = OK[0]
                else:
                    ftp = False
            if OK != 'OK':
                ZapiszLog('Korekta ' + Symbol + " " + OK)
                statK = 'blad'
        if statK == 'OK':
            Klucze = {'Funkcja': 8}
            statK, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', Klucze, [], [], [0, firma_id, '', ''])
            if statK != 'OK':
                ZapiszLog(statK)
                dane = [[], []]

            if len(dane[0]) > 0 or len(dane[1]) > 0:
                for blad in dane[0] + dane[1]:
                    ZapiszLog(blad)
#  DD
    if stat == 'OK':
        SQLDowody = """SELECT oddzial_id, trasa, data, tryb_dostawy, numer 
                       FROM rs_dowody_dostaw dd
                       JOIN rs_kontrahenci k ON (k.firma_id, k.kontrahent_id) = (dd.firma_id, dd.kontrahent_id) 
                       JOIN rs_kontrahenci p ON (p.firma_id, p.kontrahent_id) = (dd.firma_id, dd.platnik_id) 
                       WHERE dd.firma_id = '{firma_id}' AND "data" <= NOW()::DATE - INTERVAL '{dni_wstecz} DAY' 
                        AND "data" >= NOW()::DATE - INTERVAL '30 DAY'  
                        AND stan != '0' AND (character_length(k.ftp_nazwa)>0 OR  character_length(p.ftp_nazwa)>0)
                        AND data_eksportu IS NULL
                        ;""".format(firma_id=firma_id, dni_wstecz=dni_wstecz)
        statDD, Dowody, PolaDowodow, dump = PolSQL.Execute(SQLDowody, 3)
        PolaDowodow = [d[0] for d in PolaDowodow]
        if statDD != 'OK':
            statDD = 'Bd pobrania listy dowodw: ' + statDD
        else:
            ddxml = fs_xml_dowod_dostawy.RSDowodDostawyXml()
        for dowod in Dowody:
            oddzial      = dowod[PolaDowodow.index('oddzial_id')]
            trasa        = dowod[PolaDowodow.index('trasa')]
            data         = dowod[PolaDowodow.index('data')]
            tryb_dostawy = dowod[PolaDowodow.index('tryb_dostawy')]
            numer        = dowod[PolaDowodow.index('numer')]
            Symbol       = '{}/{}/{}/{}'.format(trasa, data, tryb_dostawy, numer)
            CzyWszystko  = True   # dla true sprawdza, czy dd nie zostal wczesniej wyeksportowany i go pomija
            try:
                OK = ddxml.ZapiszDowodDostawy(trasa, data, tryb_dostawy, numer, CzyWszystko, firma_id, oddzial, WykonajFunkcje)
            except Exception, e:
                OK = 'Dowd ' + Symbol + " " + ': Bd tworzenia pliku XML: ' + str(e)
            else:
                if isinstance(OK, tuple):
                    OK = OK[0]
                else:
                    ftp = False
            if OK != 'OK':
                ZapiszLog('Dowd ' + Symbol + " " + OK)
                statDD = 'blad'
        if statDD == 'OK':
            Klucze = {'Funkcja': 8}
            statDD, dane, dump, dump = WykonajFunkcje('fs_ftp_obsluga', Klucze, [], [], [0, firma_id, '', ''])
            if statDD != 'OK':
                ZapiszLog(statDD)
                dane = [[], []]

            if len(dane[0]) > 0 or len(dane[1]) > 0:
                for blad in dane[0] + dane[1]:
                    ZapiszLog(blad)

# Pobranie raportow z serwera FTP
Klucze = {'Funkcja': 9}
stat_raporty, raporty, dump, dump = WykonajFunkcje('fs_ftp_obsluga', Klucze, [], [], [0, firma_id, '', ''])
if stat_raporty != "OK":
    ZapiszLog("Bd pobierania raportw z ftp: " + stat_raporty)
if stat == 'OK':
    if statF != 'OK':
        stat = statF
    elif statK != 'OK':
        stat = statK
    elif statDD != 'OK':
        stat = statDD
    elif stat_raporty != 'OK':
        stat = stat_raporty
KonczJesliBlad(stat)
