# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_wysylanie_pdf_z_rotacji_opakowan_przewoznikom .py
# Purpose:     wysyanie maili z zestawieniami z rotacji opakowa dla przewonikw
# Authors:     Rafa Woniak, Aleksander Bargie
# Created:     2018/01/31
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

#2019-01-08 11352 - Aleksander Bargie - optymalizacja zapyta w harmonogramie - wysyanie maili z rotacji
#2022-07-13 12989 - Aleksander Bargie Komunikat gdy tworzenie raportu pdf nie powiedzie si

import os
import tempfile
import rsglobal
import datetime
import time
from funkcje import fs_generator_pdf_html

wczoraj = datetime.datetime.today() - datetime.timedelta(1)
dzien = wczoraj.weekday()
wczoraj = datetime.datetime.strftime(wczoraj, '%Y-%m-%d')
Atrapa = rsglobal.StworzAtrapeSelfa(firma_id,PolSQL)

SQLOpis = "SELECT opis FROM rs_firmy WHERE firma_id = '"+firma_id+"';"
stat, OpisFirmy, dump, dump = PolSQL.Execute(SQLOpis, 3)

if stat == "OK":
    OpisFirmy = rsglobal.Dekoduj(OpisFirmy[0][0])
    SQLPrzewoznicy = "SELECT DISTINCT CASE WHEN przewoznik_0" + str(dzien) + " IS NULL THEN przewoznik_00 ELSE przewoznik_0"
    SQLPrzewoznicy += str(dzien) + " END, email, true "
    SQLPrzewoznicy += "FROM rs_kierowcy_przewoznicy p  JOIN rs_kontrahenci k ON p.firma_id = k.firma_id "
    SQLPrzewoznicy += "AND CASE WHEN przewoznik_01 IS NULL THEN przewoznik_00 ELSE przewoznik_01 END = k.kontrahent_id "
    SQLPrzewoznicy += "WHERE p.firma_id= '" + firma_id + "' AND data_od=(SELECT max(pp.data_od) "
    SQLPrzewoznicy += "FROM rs_kierowcy_przewoznicy pp "
    SQLPrzewoznicy += "WHERE p.firma_id=pp.firma_id AND p.kierowca_id=pp.kierowca_id "
    SQLPrzewoznicy += "AND pp.data_od<='" + str(wczoraj) + "') "
    SQLPrzewoznicy += "AND (przewoznik_00 IS NOT NULL OR przewoznik_0" + str(dzien) + " IS NOT NULL) AND TRIM(email) !='';"
    stat, Przewoznicy, dump, dump = PolSQL.Execute(SQLPrzewoznicy, 3)
else:
    stat = u"Bdy w pobieraniu opisu firmy" + str(stat)

if stat != 'OK':
    stat = u'Bdy pobierania danych o przewonikach: ' + stat
else:
    if len(Przewoznicy) == 0:
        stat = u'Brak przewonikw na ' + str(wczoraj) + u'.'
    else:
        Folder = tempfile.gettempdir()
        x = 0
        for Przewoznik in Przewoznicy:
            Plik = Przewoznik[0].strip() + "_" + str(wczoraj) + ".pdf"
            if Folder != '':
                Plik = Folder + '/' + Plik
            naglowek = u"</para><para font='DejaVu' fontSize = 18 align='center' color=black>Stan opakowa na dzie "
            naglowek += u"{}:</para><para font='DejaVu' fontSize = 6.475 align=left color=black>".format(wczoraj)
            nag = u'Program:Anakonda, Firma:' + firma_id + u', Wykonano dnia: ' + time.strftime("%Y.%m.%d %H:%M")
            Naglowek = [nag, naglowek]  # Jeeli chcemy doda kolejne wiersze do nagwka dodajemy do listy
            Nazwa = [u'Oddzia', u'Kierowca/Trasa', u'Opakowanie', u'Stan pocz.', u'Pobrano', u'Zdano', u'Stan koc.']# Nazwy kolumn
            Typ = [u's', u's', u's', u'n', u'n', u'n', u'n'] # Typy kolumn
            Dlugosc = [0, 40, 45, 13, 13, 13, 13]  # Dugoci kolumn
            PoPrzecinku = [0, 0, 0, 0, 0, 0, 0]  # Iloci miejsc po przecinku
            Podsumowanie = [1, 0, 0, 0, 0, 0, 0]  # Kolumny wypinane do podgrup
            Srednia = [u'F', u'F', u'F', u'F', u'F', u'F', u'F']
            Sumowac = Srednia
            Cechy = [Nazwa, Typ, Dlugosc, PoPrzecinku, Podsumowanie, Sumowac, Srednia]
            IleKolumn = [1, 2, 3, 4, 5, 6]  # indeksy wszystkich kolumn ktre nie s wypite

            SQLRotacje = "SELECT x.oddzial_id ||' - '|| o.opis, x.kierowca_id ||' - '|| k.opis, x.opakowanie_id ||' - '|| a.nazwa, "
            SQLRotacje += "stan_pocz, pobrania, zdania, stan_konc FROM (SELECT r.oddzial_id, r.kierowca_id, r.opakowanie_id, "
            SQLRotacje += "COALESCE((SELECT kz.stan_konc FROM rs_opakowania_rotacja kz WHERE kz.firma_id=r.firma_id AND "
            SQLRotacje += "kz.oddzial_id=r.oddzial_id AND kz.opakowanie_id=r.opakowanie_id AND kz.kierowca_id = r.kierowca_id "
            SQLRotacje += "AND kz.czas_zapisu::date<'" + str(wczoraj) + "' ORDER BY czas_zapisu DESC LIMIT 1),0) as stan_pocz, "
            SQLRotacje += " SUM(r.wydania) as pobrania,SUM(r.przyjecia) as zdania, (SELECT k2.stan_konc FROM rs_opakowania_rotacja k2 "
            SQLRotacje += "WHERE k2.firma_id=r.firma_id AND k2.oddzial_id=r.oddzial_id AND k2.opakowanie_id=r.opakowanie_id "
            SQLRotacje += "AND k2.kierowca_id = r.kierowca_id AND k2.czas_zapisu::date<='" + str(wczoraj) + "' "
            SQLRotacje += "ORDER BY czas_zapisu DESC LIMIT 1) as stan_konc FROM rs_opakowania_rotacja r "
            SQLRotacje += "WHERE r.firma_id='" + firma_id + "' AND r.czas_zapisu::date>='" + str(wczoraj) + "'  "
            SQLRotacje += "AND r.czas_zapisu::Date<='" + str(wczoraj) + "' AND r.przewoznik_id = '" + str(Przewoznik[0]) + "' "
            SQLRotacje += "GROUP BY r.kierowca_id, r.opakowanie_id, r.firma_id, r.oddzial_id, r.kierowca_id, r.opakowanie_id "
            SQLRotacje += " UNION "
            SQLRotacje += "SELECT r.oddzial_id,r.kierowca_id,r.opakowanie_id, COALESCE((SELECT kk.stan_konc   FROM rs_opakowania_rotacja kk "
            SQLRotacje += "WHERE kk.firma_id=r.firma_id AND kk.oddzial_id=r.oddzial_id AND kk.opakowanie_id=r.opakowanie_id "
            SQLRotacje += "AND kk.kierowca_id = r.kierowca_id AND kk.czas_zapisu::date<'" + str(wczoraj) + "' "
            SQLRotacje += "ORDER BY czas_zapisu DESC LIMIT 1),0) as stan_pocz, 0 as pobrania, 0 as zdania, (SELECT k2.stan_konc "
            SQLRotacje += "FROM rs_opakowania_rotacja k2  WHERE k2.firma_id=r.firma_id AND k2.oddzial_id=r.oddzial_id "
            SQLRotacje += "AND k2.opakowanie_id=r.opakowanie_id AND k2.kierowca_id = r.kierowca_id "
            SQLRotacje += "AND k2.czas_zapisu::date<='" + str(wczoraj) + "' ORDER BY czas_zapisu DESC LIMIT 1) as stan_konc "
            SQLRotacje += "FROM rs_opakowania_rotacja r WHERE r.firma_id='" + firma_id + "' AND r.czas_zapisu::date<'" + str(wczoraj) + "' "
            #AB 08.01.19r
            SQLRotacje += "AND NOT EXISTS (SELECT 1 FROM rs_opakowania_rotacja rr "
            SQLRotacje += "WHERE rr.firma_id=r.firma_id AND rr.oddzial_id=r.oddzial_id AND rr.opakowanie_id = r.opakowanie_id  AND rr.czas_zapisu::date>='" + str(wczoraj) + "' "
            SQLRotacje += "AND rr.czas_zapisu::Date<='" + str(wczoraj) + "' AND r.przewoznik_id=rr.przewoznik_id) AND r.przewoznik_id = '" + str(Przewoznik[0]) + "' "
            SQLRotacje += "GROUP BY r.kierowca_id, r.opakowanie_id, r.firma_id, r.oddzial_id, r.kierowca_id, r.opakowanie_id) x "
            SQLRotacje += "JOIN rs_kierowcy k ON k.firma_id = '" + firma_id + "' AND k.kod = x.kierowca_id JOIN rs_artykuly a "
            SQLRotacje += "ON a.firma_id = '" + firma_id + "' AND x.opakowanie_id = a.artykul_id JOIN rs_oddzialy o "
            SQLRotacje += "ON x.oddzial_id = o.oddzial_id AND o.firma_id = '" + firma_id + "'"
            SQLRotacje += "WHERE stan_pocz !=0 OR pobrania !=0 OR  zdania !=0 OR  stan_konc !=0 "
            SQLRotacje += "ORDER BY  x.oddzial_id ||' - '|| o.opis, x.kierowca_id ||' - '|| k.opis, x.opakowanie_id ||' - '|| a.nazwa"
            stat, Rotacje, wyn1, tr = PolSQL.Execute(SQLRotacje, 3)
            if stat != 'OK':
                stat = u'Bd podczas pobierania danych z rotacji przewonika {}'.format(str(Przewoznik[0]))
            elif len(Rotacje) == 0:
                Przewoznicy[x][2] = False
            x += 1
            if stat == 'OK':
                sprT = []
                for i in range(len(wyn1)):
                    if stat == 'OK' and Typ[i].upper() == 'S' and wyn1[i][1][0].upper().strip() != 'S':
                        stat = u'Bdnie zdefiniowany typ S ' + str(i + 1) + u' kolumny'
                    if stat == 'OK' and Typ[i].upper() == 'N' and wyn1[i][1][0].upper() not in ['N', 'I']:
                        stat = u'Bdnie zdefiniowany typ N ' + str(i + 1) + u' kolumny'
                    if stat == 'OK' and Typ[i].upper() == 'D' and wyn1[i][1][0].upper() not in ['S', 'D']:
                        stat = u'Bdnie zdefiniowany typ D ' + str(i + 1) + u' kolumny'
                    if stat == 'OK' and Typ[i].upper() == 'B' and wyn1[i][1][0].upper() != 'B':
                        stat = u'Bdnie zdefiniowany typ B ' + str(i + 1) + u' kolumny'
# -------------------------------------------------------------------------------
# ---   Funkcja tworzca PDF (13)
# -------------------------------------------------------------------------------
            if stat == 'OK':
                if len(Rotacje) > 0:
                    pdf = fs_generator_pdf_html.RSGeneratorPDF(Atrapa, Plik=Plik, naglowek=Naglowek, dane=Rotacje, Cechy=Cechy,
                                                               IleKolumn=IleKolumn, kol=[1], stare=[1])
                    #AB 13.07.22r dodana zwrotka obslugiwana przez stat
                    stat = pdf.UtworzPDFGeneratora()
                    if stat == 'OK':
                        temat = u"{} - stan opakowa na {}".format(OpisFirmy, wczoraj)
                        tresc = u"Informacje o stanie opakowa znajduj si w zaczonym pliku PDF."
                        stat = rsglobal.RSWyslijEmail(Przewoznik[1], str(temat), str(tresc), [Plik], 0, PolSQL)
                        os.remove(Plik)
                    else:
                        stat = "Wystpi problem podczas generowania pliku w formacie PDF"

                if stat != 'OK':
                    stat = u'Bd wysyania zestawie z rotacji dla przewonikw:' + stat
