# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_zmiany_miejsc_uzytkowania_przypomnienia.py
# Purpose:     Przypominanie o niezaakceptowanych zmianach miejsc uytkowania rodkw trwaych
# Authors:     Aleksander Bargie
# Created:     2022/06/13
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

stat = 'OK'
puste = ["", "    -  -  ", None, 'None', 'NULL']

wzor_akcept = "{srodek_id} - {srodek_nazwa} oczekuje na akceptacj przekazania z {uz_skad}({miejsce_id}), do " \
              "{uz_dokad}({przekazanie_miejsce}).\r\n\t\t\tDodano {przekazanie_kiedy} przez {przek_imie} " \
              "{przek_nazwisko}({przek_login}).\r\n"
wzor_nadawca = "{srodek_id} - {srodek_nazwa} oczekuje na akceptacj przekazania z {uz_skad}({miejsce_id}), do " \
               "{uz_dokad}({przekazanie_miejsce}).\r\n\t\t\tDodano {przekazanie_kiedy}. Akceptujcy {akcept_imie} " \
               "{akcept_nazwisko}({akcept_login}).\r\n"

SQL = """SELECT mu.srodek_id, st.nazwa, mu.miejsce_id, uz_skad.opis, mu.przekazanie_kto, mu.przekazanie_miejsce, 
                uz_dokad.opis, to_char(mu.przekazanie_kiedy, 'YYYY-MM-DD HH24:MI') AS przekazanie_kiedy, przek.login,
                przek.imie, przek.nazwisko, przek.email, mu.przyjecie_kto, akcept.login, akcept.imie, akcept.nazwisko, 
                akcept.email
         FROM rs_srodki_trwale_miejsca_uzytkowania mu
         JOIN rs_srodki_trwale st ON (st.firma_id, st.srodek_id) = (mu.firma_id, mu.srodek_id)
         JOIN rs_miejsca_uzytkowania uz_skad ON (uz_skad.firma_id, uz_skad.kod) = (mu.firma_id, mu.miejsce_id)
         JOIN rs_miejsca_uzytkowania uz_dokad ON (uz_dokad.firma_id, uz_dokad.kod) = (mu.firma_id, mu.miejsce_id)
         LEFT JOIN rs_operatorzy przek ON przek.operator_id = przekazanie_kto 
         LEFT JOIN rs_operatorzy akcept ON akcept.operator_id = przyjecie_kto 
         WHERE mu.firma_id = %s AND przyjecie_kiedy IS NULL AND przekazanie_kiedy IS NOT NULL
         ORDER BY przekazanie_kiedy ASC
;
;"""
args = [firma_id]
rsglobal.ZapiszDoLogow(PolSQL.Mogrify(SQL, args))
stat, zmiany, dump, dump = PolSQL.Execute(SQL, 3, args, CzyDodawacBlad=True)
if stat != 'OK':
    KonczJesliBlad(stat)
else:
    bledy = {}
    maile = {}
    for zmiana in zmiany:
        srodek_id           = zmiana[0].strip() if isinstance(zmiana[0], basestring) else zmiana[0]
        srodek_nazwa        = zmiana[1].strip() if isinstance(zmiana[1], basestring) else zmiana[1]
        miejsce_id          = zmiana[2].strip() if isinstance(zmiana[2], basestring) else zmiana[2]
        uz_skad             = zmiana[3].strip() if isinstance(zmiana[3], basestring) else zmiana[3]
        przekazanie_kto     = zmiana[4].strip() if isinstance(zmiana[4], basestring) else zmiana[4]
        przekazanie_miejsce = zmiana[5].strip() if isinstance(zmiana[5], basestring) else zmiana[5]
        uz_dokad            = zmiana[6].strip() if isinstance(zmiana[6], basestring) else zmiana[6]
        przekazanie_kiedy   = zmiana[7].strip() if isinstance(zmiana[7], basestring) else zmiana[7]
        przek_login         = zmiana[8].strip() if isinstance(zmiana[8], basestring) else zmiana[8]
        przek_imie          = zmiana[9].strip() if isinstance(zmiana[9], basestring) else zmiana[9]
        przek_nazwisko      = zmiana[10].strip() if isinstance(zmiana[10], basestring) else zmiana[10]
        przek_email         = zmiana[11].strip() if isinstance(zmiana[11], basestring) else zmiana[11]
        przyjecie_kto       = zmiana[12].strip() if isinstance(zmiana[12], basestring) else zmiana[12]
        akcept_login        = zmiana[13].strip() if isinstance(zmiana[13], basestring) else zmiana[13]
        akcept_imie         = zmiana[14].strip() if isinstance(zmiana[14], basestring) else zmiana[14]
        akcept_nazwisko     = zmiana[15].strip() if isinstance(zmiana[15], basestring) else zmiana[15]
        akcept_email        = zmiana[16].strip() if isinstance(zmiana[16], basestring) else zmiana[16]

        if przek_email not in puste:
            if przek_email not in maile:
                maile[przek_email] = [[], []]
            maile[przek_email][0].append(wzor_nadawca.format(**locals()))
        if akcept_email not in puste:
            if akcept_email not in maile:
                maile[akcept_email] = [[], []]
            maile[akcept_email][1].append(wzor_akcept.format(**locals()))

    for mail in maile:
        Temat = "Informacja o zmianie miejsc uytkowania rodkw trwaych oczekujcych na akceptacj."
        Tresc = []
        if maile[mail][1]:
            Tresc.append("Zmiany miejsc uytkowania oczekujce na Twoj akceptacj:")
            Tresc += maile[mail][1]
        if maile[mail][0]:
            Tresc.append("Zmiany miejsc uytkowania oczekujce na akceptacj przez innych operatorw:")
            Tresc += maile[mail][0]
            if maile[mail][1]:
                Tresc.append('\r\n\r\n')

        stat = rsglobal.RSWyslijEmail(mail, Temat, '\r\n'.join(Tresc), [], 0, PolSQL)
        if stat != 'OK':
            bledy[mail] = stat

    if bledy:
        KonczJesliBlad("Podczas wysyania przypomnie wystpiy bdy: \n" + '\n'.join(["mail: {}, bd: {}".format(mail, blad) for mail, blad in bledy.iteritems()]))
