# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_zmien_zakresy_dat.py
# Purpose:     zmiana zakresow dat dla faktur, dok.mag, dow.ksiegowych
# Author:      Mariusz Rajfura
# Created:     2011/04/15
# RCS-ID:      $Id: funkcje_harmonogramu/fs_zmien_zakresy_dat.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-11-07 Mariusz Rajfura  uwzglednienie pola 'data_minimum' (5159)
# 2011-11-16 Mariusz Rajfura  blad w kodzie (5206)

stat = 'OK'

SprawdzArgumenty(['od_faktury','do_faktury',
                 'do_dokumenty','do_dokumenty',
                 'od_dowody','do_dowody'])

NieZmieniac = (9999,-9999,'9999','-9999')

print
print 'parametry:'
print 'od_faktury=', od_faktury, '   do_faktury=', do_faktury
print 'od_dokumenty=', od_dokumenty, '   do_dokumenty=', do_dokumenty
print 'od_dowody=', od_dowody, '  do_dowody=', do_dowody


# pobieramy date_minimum
sql ="SELECT COALESCE(data_minimum::TEXT,''::TEXT)"
sql+=" FROM rs_zakresy_dat WHERE firma_id='"+firma_id+"' FOR UPDATE;"

stat,ZakresyDat, dump,dump = PolSQL.Execute(sql,3)

print
print 'pobranie daty minimum:'
print sql
print stat
print ZakresyDat

if stat <> 'OK':
    stat = 'Bd pobrania biecych zakresw dat: '+stat
    KonczJesliBlad(stat)
elif len(ZakresyDat) <> 1:
    stat = 'Brak zakresw dat dla firmy: '+firma_id
    KonczJesliBlad(stat)

DataMinimum = rsglobal.Dekoduj(ZakresyDat[0][0])
if DataMinimum == '':
    DataMinimum = '1980-01-01'
    print 'przyjeto date minimum', DataMinimum

# wyliczamy proponowane daty poczatkowe dla faktur, dok.mag i dow.ksieg.
# z uwzglednieniem, ze data poczatkowa + przesuniecie nie moze byc mniejsza od
# 'data_minimum'
sql ="SELECT "

if od_faktury in NieZmieniac:
    sql+=" '"+DataMinimum+"'::DATE,"
else:
    sql+=" CASE WHEN data_minimum > NOW()::DATE+"+rsglobal.UsunKropkaZero(od_faktury)
    sql+=" THEN data_minimum::DATE ELSE NOW()::DATE+"+rsglobal.UsunKropkaZero(od_faktury)+" END,"

if od_dokumenty in NieZmieniac:
    sql+=" '"+DataMinimum+"'::DATE,"
else:
    sql+=" CASE WHEN data_minimum > NOW()::DATE+"+rsglobal.UsunKropkaZero(od_dokumenty)
    sql+=" THEN data_minimum::DATE ELSE NOW()::DATE+"+rsglobal.UsunKropkaZero(od_dokumenty)+" END,"

if od_dowody in NieZmieniac:
    sql+=" '"+DataMinimum+"'::DATE"
else:
    sql+=" CASE WHEN data_minimum > NOW()::DATE+"+rsglobal.UsunKropkaZero(od_dowody)
    sql+=" THEN data_minimum::DATE ELSE NOW()::DATE+"+rsglobal.UsunKropkaZero(od_dowody)+" END"

sql+=" FROM rs_zakresy_dat WHERE firma_id='"+firma_id+"';"

stat,DatyPoczatkowe,dump,dump = PolSQL.Execute(sql,3)

print
print 'wybor dat poczatkowych:'
print sql
print stat
print DatyPoczatkowe

if stat <> 'OK':
    stat = 'Bd obliczenia dat pocztkowych: '+firma_id
    KonczJesliBlad(stat)

FakturyDataOd = rsglobal.Dekoduj(DatyPoczatkowe[0][0])
DokumentyDataOd = rsglobal.Dekoduj(DatyPoczatkowe[0][1])
DowodyDataOd = rsglobal.Dekoduj(DatyPoczatkowe[0][2])


UPD ="UPDATE rs_zakresy_dat SET"
Przecinek = False

if not od_faktury in NieZmieniac:
    UPD+=" sprzedaz_od='"+FakturyDataOd+"'::DATE"
    Przecinek = True

if not do_faktury in NieZmieniac:
    if Przecinek:
        UPD+=","
        Przecinek = False
    UPD+=" sprzedaz_do='"+FakturyDataOd+"'::DATE+"+rsglobal.UsunKropkaZero(do_faktury)
    if not od_faktury in NieZmieniac:
        UPD+="+ABS("+rsglobal.UsunKropkaZero(od_faktury)+")"
    Przecinek = True

if not od_dokumenty in NieZmieniac:
    if Przecinek:
        UPD+=","
        Przecinek = False
    UPD+=" magazyn_od='"+DokumentyDataOd+"'::DATE"
    Przecinek = True

if not do_dokumenty in NieZmieniac:
    if Przecinek:
        UPD+=","
        Przecinek = False
    UPD+=" magazyn_do='"+DokumentyDataOd+"'::DATE+"+rsglobal.UsunKropkaZero(do_dokumenty)
    if not od_dokumenty in NieZmieniac:
        UPD+="+ABS("+rsglobal.UsunKropkaZero(od_dokumenty)+")"
    Przecinek = True

if not od_dowody in NieZmieniac:
    if Przecinek:
        UPD+=","
        Przecinek = False
    UPD+=" fk_od='"+DowodyDataOd+"'::DATE"
    Przecinek = True

if not do_dowody in NieZmieniac:
    if Przecinek:
        UPD+=","
    UPD+=" fk_do='"+DowodyDataOd+"'::DATE+"+rsglobal.UsunKropkaZero(do_dowody)
    if not od_dowody in NieZmieniac:
        UPD+="+ABS("+rsglobal.UsunKropkaZero(od_dowody)+")"

UPD+=" WHERE firma_id='"+firma_id+"';"

stat,d,dump,dump = PolSQL.Execute(UPD,1)

print
print 'aktualizacja:'
print UPD
print stat
print

if stat <> 'OK':
    stat = 'Bd modyfikacji zakresw dat: '+stat
    ZapiszLog(sql)
    KonczJesliBlad(stat)

# sprawdzenie, czy ustawione daty spelniaja warunek od-do
sql ="SELECT"
sql+=" (CASE WHEN sprzedaz_od IS NULL OR sprzedaz_do IS NULL"
sql+="  THEN TRUE ELSE sprzedaz_od <= sprzedaz_do END)"
sql+=" AND"
sql+=" (CASE WHEN magazyn_od IS NULL OR magazyn_do IS NULL"
sql+="  THEN TRUE ELSE magazyn_od <= magazyn_do END)"
sql+=" AND"
sql+=" (CASE WHEN fk_od IS NULL OR fk_do IS NULL"
sql+="  THEN TRUE ELSE fk_od <= fk_do END)"
sql+=" FROM rs_zakresy_dat WHERE firma_id='"+firma_id+"';"

stat,dane,dump,dump = PolSQL.Execute(sql,3)

print
print 'sprawdzenie:'
print sql
print stat
print dane


sql ="SELECT sprzedaz_od, sprzedaz_do, magazyn_od, magazyn_do, fk_od, fk_do"
sql+=" FROM rs_zakresy_dat WHERE firma_id='"+firma_id+"';"
stat,d,dump,dump = PolSQL.Execute(sql,3)

print
print 'po zmianie:'
print sql
print stat
print str(d)
print
print 'koniec.'
print 

if stat <> 'OK':
    stat = 'Bd pobrania zmodyfikowanych zakresw dat: '+stat
elif not dane[0][0]:
    stat = 'BD'
    ZapiszLog('Bdne parametry:\n'+
              'od_faktury='+str(od_faktury)+'\n'+
              'do_faktury='+str(do_faktury)+'\n'+
              'od_dokumenty='+str(od_dokumenty)+'\n'+
              'do_dokumenty='+str(do_dokumenty)+'\n'+
              'od_dowody='+str(od_dowody)+'\n'+
              'do_dowody='+str(do_dowody))