# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_zmien_zakresy_dat_dla_oddzialu.py
# Purpose:     zmiana zakresow dat dla faktur, dok.mag, w ramach oddzialu
# Author:      Jan Raburski
# Created:     2018/05/23
# RCS-ID:      $Id: funkcje_harmonogramu/fs_zmien_zakresy_dat_dla_oddzialu.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from datetime import datetime
import rs_anakonda_daty

stat = 'OK'

SprawdzArgumenty(['od_faktury','do_faktury',
                 'do_dokumenty','do_dokumenty',
                 'oddzial'])

NieZmieniac = (9999,-9999,'9999','-9999')

dzisiaj=str(datetime.now())[0:10]

# pobieramy date_minimum
sql ="SELECT COALESCE(data_minimum::TEXT,''::TEXT)"
sql+=" FROM rs_zakresy_dat WHERE firma_id='"+firma_id+"' FOR UPDATE;"

stat,ZakresyDat, dump,dump = PolSQL.Execute(sql,3)

if stat <> 'OK':
    stat = 'Bd pobrania biecych zakresw dat: '+stat
    KonczJesliBlad(stat)
elif len(ZakresyDat) <> 1:
    stat = 'Brak zakresw dat dla firmy: '+firma_id
    KonczJesliBlad(stat)

DataMinimum = rsglobal.Dekoduj(ZakresyDat[0][0])
if DataMinimum == '':
    DataMinimum = '1980-01-01'


# wyliczamy proponowane daty poczatkowe dla faktur, dok.mag
# z uwzglednieniem, ze data poczatkowa + przesuniecie nie moze byc mniejsza od
# 'data_minimum'

UPD ="UPDATE rs_oddzialy SET "

if not od_faktury in NieZmieniac:
    dataodf=str(rs_anakonda_daty.DodajKilkaDni(dzisiaj,int(od_faktury)))
    if dataodf<DataMinimum:
        dataodf=DataMinimum
    datadof=str(rs_anakonda_daty.DodajKilkaDni(dzisiaj,int(do_faktury)))
    UPD+=" sprzedaz_od='"+dataodf+"', sprzedaz_do='"+datadof+"'"

if not od_dokumenty in NieZmieniac:
    dataodd=str(rs_anakonda_daty.DodajKilkaDni(dzisiaj,int(od_dokumenty)))
    if dataodd<DataMinimum:
        dataodd=DataMinimum
    datadod=str(rs_anakonda_daty.DodajKilkaDni(dzisiaj,int(do_dokumenty)))
    if not od_faktury in NieZmieniac:
        UPD+=", "
    UPD+=" magazyn_od='"+dataodd+"', magazyn_do='"+datadod+"'"

UPD+=" WHERE firma_id='"+firma_id+"' AND oddzial_id='"+oddzial+"'"

stat,d,dump,dump = PolSQL.Execute(UPD,1)

if stat <> 'OK':
    stat = 'Bd modyfikacji zakresw dat: '+stat+UPD
    ZapiszLog(UPD)
    KonczJesliBlad(stat)

