
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        rs_anakonda_server_fn.py
# Purpose:     klasa obslugi funkcji wewnetrznych serwera
#
# Authors:     Jan Raburski
# Created:     2005/10/28
# RCS-ID:      $Id: rs_anakonda_server_fn.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# dodanie tracebacka do lepszego debugowania - Jan Kaliszewski, 2009-06-19
# PolSQL2 - raporty z serwera zapas. (mantis: 0002191) - Jan Kaliszewski, 2009-07-09
# dodanie kolejnego tracebacka do lepszego debugowania - Jan Kaliszewski, 2009-10-24
# [...]
# drobne poprawki ze wzgldu na PAN (mantis: 0003424) - Jan Kaliszewski, 2010-04-30


import os		# operations on files (special files - pipes)
import sys
import re
import rsglobal		# rsglobal.ZapiszDoLogow(), rsglobal.PodajZKonf()
import rssql
from const import *	# configuration as well as operations' constants
import time
import string
import traceback
import rs_anakonda_server_komser

#-------------------------------------------------------------------------------

class RSFunkcje:
    # klasa obslugujaca ladowanie i wykonywanie funkcji zdefiniowanych 
    # po stronie serwera RS-Anakonda

    # *** UWAGA: z tej klasy dziedziczy rs_anakonda_server_pan.RSFunkcjePAN ***

    KATALOG_FUNKCJI = "./funkcje"
    
    def __init__(self, operator_id, PolSQL, adres_ip, Operatorzy, PolSQL2=None, Enterprise=False):
        self.operator_id = operator_id  # id zalogowanego operatora
        self.operatorzy =  Operatorzy   # lista zastpstw operatora (wcznie z nim)
        self.PolSQL = PolSQL            # poczenie z baz

        # poczenie do wykonywania raportw:
        if PolSQL2 and PolSQL2 is not PolSQL:
            self.PolSQL2 = PolSQL2      # (osobne, jeeli podano osobne;
            self.osobne_pol_rap = True
        else:                           #  w przeciwnym wypadku
            self.PolSQL2 = PolSQL       #  to samo)
            self.osobne_pol_rap = False

        self.adres_ip = adres_ip        # adres IP klienta
        self.firma_id = None            # id firmy
        self.pozdokmagraz = None        # zmienna czy mozna dodawac pozyjce dokum mag o tym samym symbolu
        self.oddzial_id = None          # id oddzialu
        self.okres_id = None            # id okresu
        self.funkcje = {}
        self.uprawnienia=[]             # inicjacja uprawnien
        self.automat_numery = False     # czy automatyczne numery
        #self.operatorzy=[]              # lista zastepowanych operatorow + biezacy operator
        self.handlowiec_id=None         # zmienna wykozystywana do ograniczania widoku
        self.zdalne_zlecenie=None       # dane uzywane przy wyk. funkcji ktore przyszly z innego serwera
        self.lokacje_jm = '2'           # jednostka miary (1,2) na ktrej pracuj lokacje
        self.KatalogPlikow = os.getcwd()+'/pliki'         # katalog gdzie naley trzyma pliki
        self.ListaStawekZn=['np','zw','oo','0E','0P']    # lista stawek nietypowych. Jeli bdzie nowa to trzeba j te doda w rsglobal
        self.ListaDzialow=''
        self.Enterprise = Enterprise

        self._czas_uruchomienia = time.time()

#---------------------------------------

    def SetFirma(self, firma_id):
        ## firme mozna ustawic tylko raz
        ## w przeciwnym wypadku - prba wamu 
        #if self.firma_id<>None:
        #    rsglobal.ZapiszDoLogow('UWAGA: ZMIANA FIRMY BEZ ROZLACZENIA z '+str(self.adres_ip),1)
        #    self.PolSQL.RozlaczZSQL()
        #    if self.osobne_pol_rap:
        #        self.PolSQL2.RozlaczZSQL()
        #    sys.exit()
        self.firma_id = firma_id
        #ustawienie zmiennej czy mozna dodawac pozyjce dokum mag o tym samym symbolu
        stat, dane, dump, dump = self.PolSQL.Execute("SELECT pozdokmagraz,automat_numery,lokacje_jm,dwie_jedn_miar FROM rs_firmy WHERE firma_id='%s';" % (firma_id),2)        
        self.pozdokmagraz = dane[0][0]
        self.automat_numery = dane[0][1]
        self.lokacje_jm = rsglobal.Dekoduj(dane[0][2])
        self.dwie_jm = rsglobal.Dekoduj(dane[0][3])

#---------------------------------------
        
    def SetOddzial(self, oddzial_id):
        if self.firma_id == None:
            rsglobal.ZapiszDoLogow('UWAGA: WYBOR ODDZIALU PRZED FIRMA z '+str(self.adres_ip),1)
            self.PolSQL.RozlaczZSQL()
            if self.osobne_pol_rap:
                self.PolSQL2.RozlaczZSQL()
            sys.exit()
        self.oddzial_id = oddzial_id
        
#---------------------------------------
        
    def SetUprawnienia(self, uprawnienia):
        if self.firma_id == None:
            rsglobal.ZapiszDoLogow('UWAGA: WYBOR ODDZIALU PRZED FIRMA z '+str(self.adres_ip),1)
            self.PolSQL.RozlaczZSQL()
            if self.osobne_pol_rap:
                self.PolSQL2.RozlaczZSQL()
            sys.exit()
        self.uprawnienia = uprawnienia
        
#---------------------------------------
        
    def SetOperatorzy(self, operatorzy):
        if self.firma_id == None:
            rsglobal.ZapiszDoLogow('UWAGA: WYBOR ODDZIALU PRZED FIRMA z '+str(self.adres_ip),1)
            self.PolSQL.RozlaczZSQL()
            if self.osobne_pol_rap:
                self.PolSQL2.RozlaczZSQL()
            sys.exit()
        #self.operatorzy = operatorzy
        
#-------------------------------------------------------------------------------
    
    def SetHandlowiec(self, handlowiec):
        if self.firma_id == None:
            rsglobal.ZapiszDoLogow('UWAGA: WYBOR ODDZIALU PRZED FIRMA z '+str(self.adres_ip),1)
            self.PolSQL.RozlaczZSQL()
            if self.osobne_pol_rap:
                self.PolSQL2.RozlaczZSQL()
            sys.exit()
        self.handlowiec_id = handlowiec
            
#-------------------------------------------------------------------------------

    def SetOkres(self, okres_id):
        self.okres_id = okres_id
        
#-------------------------------------------------------------------------------

    def SetListaDzialow(self, ListaDzialow):
        self.ListaDzialow = ListaDzialow
    
#-------------------------------------------------------------------------------

    def SetKatalogPlikow(self, katalog_plikow):
        if katalog_plikow<>None:
            if not katalog_plikow.strip() in ['None','']:
                self.KatalogPlikow = katalog_plikow
        
#-------------------------------------------------------------------------------

    def SetKatalogEdeklaracji(self, katalog_edeklaracji):
        if katalog_edeklaracji<>None:
            if not katalog_edeklaracji.strip() in ['None','']:
                self.KatalogDeklaracji = katalog_edeklaracji
        
#-------------------------------------------------------------------------------

    def _wczytaj_funkcje(self, nazwa_funkcji, ladowanie_hurtem=False):
        nazwa_pliku = os.path.join(self.KATALOG_FUNKCJI, nazwa_funkcji + ".py")
        if not ladowanie_hurtem:
            rsglobal.ZapiszDoLogow("Wczytanie funkcji z pliku %s" % nazwa_pliku, 5)

        if not os.path.isfile(nazwa_pliku):
            kom = "Nie mozna wczytac funkcji %s. Brak pliku." % nazwa_funkcji
            rsglobal.ZapiszDoLogow("BLAD: " + kom, 1)
            raise Exception(kom)

        plik_funkcji = open(nazwa_pliku)
        tresc_funkcji = plik_funkcji.read()
        # wczytywanie plikw zmodyfikowanych ju po poczeniu klienta moe prowadzi do rozbienoci
        if os.fstat(plik_funkcji.fileno()).st_mtime > self._czas_uruchomienia:
            rsglobal.ZapiszDoLogow("Plik funkcji %s nowszy niz polaczenie uzytkownika" % nazwa_pliku, 1)
        plik_funkcji.close()

        # spacje w ostatniej linijce bez entra powodowaly blad
        if tresc_funkcji and tresc_funkcji[-1] != "\n":
            tresc_funkcji += "\n"

        kod_funkcji = compile(tresc_funkcji, nazwa_pliku, 'exec')

        return kod_funkcji

#---------------------------------------

    def DajFunkcje(self, nazwa_funkcji):
        # zwraca tresc (skompilowan) funkcji o nazwie @nazwa_funkcji
        #   za pierwszym razem wczytuje funkcj z dysku i kompiluje

        if nazwa_funkcji not in self.funkcje:
            self.funkcje[nazwa_funkcji] = self._wczytaj_funkcje(nazwa_funkcji)

        return self.funkcje[nazwa_funkcji]

#---------------------------------------

    def WyczyscFunkcje(self):
        # czyci cache funkcji, wszystkie zostan potem wczytane
        # mogoby si przyda w czasie pracy nad funkcjami
        self.funkcje = {}

        # znacznik czasu uruchomienia te wyczy
        self._czas_uruchomienia = time.time()

#---------------------------------------

    def ImportujFunkcje(self):
        # wczytaj z dysku lub z bazy funkcje
        rsglobal.ZapiszDoLogow('Import funkcji', 3)
        lista = os.listdir(self.KATALOG_FUNKCJI)
        lista.sort()
        self.WyczyscFunkcje()
        for nazwa_pliku in lista:
            sciezka = os.path.join(self.KATALOG_FUNKCJI, nazwa_pliku)
            # pomin nie pliki, te zaczynajce si na _ oraz te nie koczce si na .py
            if nazwa_pliku[0] != '_' and nazwa_pliku.endswith('.py') and os.path.isfile(sciezka):
                nazwa_funkcji, ext = os.path.splitext(nazwa_pliku)
                rsglobal.ZapiszDoLogow('\t' + nazwa_pliku, 5)
                try:
                    self.funkcje[nazwa_funkcji] = self._wczytaj_funkcje(nazwa_funkcji, ladowanie_hurtem=True)
                except Exception:
                    rsglobal.ZapiszDoLogow(traceback.format_exc(limit=1), 1)
                    pass
            else:
                rsglobal.ZapiszDoLogow('Ignoruje ' + sciezka, 5)
        rsglobal.ZapiszDoLogow('Koniec importu funkcji', 5)

#---------------------------------------
    
    def WykonajFunkcje(self,funkcja,klucze=None,pola=None,wartosci=None,RobicCommit=True):
        #zamiana parametrow na iso-8859-2
        # FIXME/TODO: kontrola na SQL-Injection nie dziala rekursywnie
        #
        # propozycja: klucze w slownikach tylko 'porzadne znaki ASCII (a-zA-Z0-9_)
        # rekursywne sprawdzanie i zamiana wartosci dla typu unicode,str
        if klucze is None:
            klucze = []
        if pola is None:
            pola = []
        if wartosci is None:
            wartosci = []

        if isinstance(klucze, dict):
            klucze_slownika = klucze.keys()
            for k in klucze_slownika:
                
                if re.match('^\w*$',k) is None:
                    return 'NIEDOZWOLONY ZNAK W KLUCZU SLOWNIKA: '+repr(k) ,[],[],[]
                
                
                if str(type(klucze[k]))=="<type 'unicode'>":
                    #AB 06.06.19r
                    #klucze[k]=klucze[k].encode('iso-8859-2')
                    klucze[k]=rsglobal.Dekoduj(klucze[k])
                if str(type(klucze[k])) in ["<type 'unicode'>","<type 'str'>"]:
                    klucze[k]=klucze[k].replace("\\","\\\\")
                    klucze[k]=klucze[k].replace("'","\\\'")
        elif klucze<>[]:
            for i in range(len(klucze)):
                if str(type(klucze[i]))=="<type 'unicode'>":
                    #AB 06.06.19r
                    #klucze[i]=klucze[i].encode('iso-8859-2')
                    klucze[i]=rsglobal.Dekoduj(klucze[i])
                if str(type(klucze[i])) in ["<type 'unicode'>","<type 'str'>"]:
                    klucze[i]=klucze[i].replace("\\","\\\\")
                    klucze[i]=klucze[i].replace("'","\\\'")

                    
        if pola<>[]:
            for i in range(len(pola)):
                if str(type(pola[i]))=="<type 'unicode'>":
                    #AB 06.06.19r
                    # pola[i]=pola[i].encode('iso-8859-2')
                    pola[i]=rsglobal.Dekoduj(pola[i])
                if str(type(pola[i])) in ["<type 'unicode'>","<type 'str'>"]:
                    pola[i]=pola[i].replace("\\","\\\\")
                    pola[i]=pola[i].replace("'","\\\'")
                    
                
        if wartosci<>[]:
            for i in range(len(wartosci)):
                if str(type(wartosci[i]))=="<type 'unicode'>":
                    #AB 06.06.19r
                    # wartosci[i]=wartosci[i].encode('iso-8859-2')
                    wartosci[i]=rsglobal.Dekoduj(wartosci[i])
                if str(type(wartosci[i])) in ["<type 'unicode'>","<type 'str'>"]:
                    wartosci[i]=wartosci[i].replace("\\","\\\\")
                    wartosci[i]=wartosci[i].replace("'","\\\'")
                    
        stat='BLAD'
        dane = []
        wyn1 = []
        wyn2 = []
        #wez ze slownika tresc funkcji i wykonaj
        try:
            kod_funkcji = self.DajFunkcje(funkcja)
            exec kod_funkcji
        except Exception, e:
            if stat=='OK':
                #rsglobal.ZapiszDoLogow("Blad wykonania funkcji wewnetrznej "+funkcja+":"+str(e), 1)
                rsglobal.ZapiszDoLogow("Blad wykonania funkcji wewnetrznej "+funkcja+":"+str(e)+traceback.format_exc(), 1)

                if self.PolSQL.bylo_cos_robione:
                    try:
                        self.PolSQL.Rollback()            
                    except:
                        pass
                        
                    self.PolSQL.bylo_cos_robione = False

                if self.osobne_pol_rap and self.PolSQL2.bylo_cos_robione:
                    try:
                        self.PolSQL2.Rollback()            
                    except:
                        pass
                    self.PolSQL2.bylo_cos_robione = False

                stat=u"Bd wykonania funkcji wewntrznej "+funkcja+":"+str(e)

            else:
                rsglobal.ZapiszDoLogow("Funkcja wewntrzna "+funkcja+" przerwana automatycznie z bdem : %s (%s)." % (stat, traceback.format_exc()), 1)
        else:
            if stat<>'OK':
                if len(stat)>15:
                    rsglobal.ZapiszDoLogow("Funkcja wewnetrzna "+funkcja+":"+str(stat), 1)

                if self.PolSQL.bylo_cos_robione:
                    try:
                        self.PolSQL.Rollback()            
                    except:
                        pass          
                    self.PolSQL.bylo_cos_robione = False

                if self.osobne_pol_rap and self.PolSQL2.bylo_cos_robione:
                    try:
                        self.PolSQL2.Rollback()            
                    except:
                        pass
                    self.PolSQL2.bylo_cos_robione = False

            elif (self.zdalne_zlecenie and not self.zdalne_zlecenie[1]) or not RobicCommit:
                # ustawiono self.zdalne_zlecenie i wyczono commit po wykonaniu funkcji
                pass
            else:
                if self.PolSQL.bylo_cos_robione:
                    stat=self.PolSQL.Commit()            
                    self.PolSQL.bylo_cos_robione = False

                if self.osobne_pol_rap and self.PolSQL2.bylo_cos_robione:
                    stat=self.PolSQL2.Commit()            
                    self.PolSQL2.bylo_cos_robione = False

        return stat, dane, wyn1, wyn2
    
#---------------------------------------
    
