
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        rs_anakonda_server_ra.py
# Purpose:     klasa obslugi raportow w Agata Report
#
# Authors:     Jan Raburski
# Created:     2005/10/28
# RCS-ID:      $Id: rs_anakonda_server_ra.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# Jan Kaliszewski, 2009-06-25:
# * usuwanie procesow zwizanych z przerwanym poczeniem (mantis: 1904)


import os		# operations on files (special files - pipes)
import sys
import rsglobal		# rsglobal.ZapiszDoLogow(), rsglobal.PodajZKonf()
import rssql
from const import *	# configuration as well as operations' constants
import time
import string
from funkcje import fs_pliki_office
from funkcje import fs_rozrachunki_pom

#-------------------------------------------------------------------------------

class RSAgata:
    # klasa obslugujaca wykonywanie raportow zdefiniowanych 
    # po stronie serwera RS-Anakonda w formacie Agata Report
    
    def __init__(self,operator_id,PolSQL,adres_ip,operator,phpProgram,Baza='anakonda',dod_serwer_rap=False):
        self.operator_id = operator_id  # id zalogowanego operatora
        self.operator = operator        # imie i nazwisko zalogowanego operatora
        self.PolSQL = PolSQL            # poczenie z baz
        self.adres_ip = adres_ip        # adres IP klienta
        self.firma_id = None            # id firmy
        self.oddzial_id = None          # id oddzialu
        self.okres_id = ''              # id okresu
        self.handlowiec = ''            # handlowiec
        self.uprawnienia=[]             # inicjalizacja uprawnien
        self.phpProgram= phpProgram
        self.Baza=Baza
        self.dod_serwer_rap = dod_serwer_rap    # czy ustawiono gen-nie raportw na innym serwerze
        self.ListaDzialow=''
    
#---------------------------------------

    def SetFirma(self, firma_id):
        ## firme mozna ustawic tylko raz
        ## w przeciwnym wypadku - prba wamu 
        #if self.firma_id<>None:
        #    rsglobal.ZapiszDoLogow('UWAGA: ZMIANA FIRMY BEZ ROZLACZENIA z '+str(self.adres_ip),1)
        #    self.PolSQL.RozlaczZSQL()
        #    sys.exit()
        self.firma_id = firma_id

#---------------------------------------
        
    def SetOddzial(self, oddzial_id):
        if self.firma_id == None:
            rsglobal.ZapiszDoLogow('UWAGA: WYBOR ODDZIALU PRZED FIRMA z '+str(self.adres_ip),1)
            self.PolSQL.RozlaczZSQL()
            sys.exit()
        self.oddzial_id = oddzial_id
       
#-------------------------------------------------------------------------------
        
    def SetUprawnienia(self, uprawnienia):
        if self.firma_id == None:
            rsglobal.ZapiszDoLogow('UWAGA: WYBOR ODDZIALU PRZED FIRMA z '+str(self.adres_ip),1)
            self.PolSQL.RozlaczZSQL()
            sys.exit()
        self.uprawnienia = uprawnienia
        
#-------------------------------------------------------------------------------

    def SetOkres(self, okres_id):
        self.okres_id = okres_id

#-------------------------------------------------------------------------------

    def SetListaDzialow(self, ListaDzialow):
        self.ListaDzialow = ListaDzialow
   
#-------------------------------------------------------------------------------
    
    def SetHandlowiec(self, handlowiec):
        if handlowiec==None:
            self.handlowiec =''
        else:
            self.handlowiec = handlowiec

#-------------------------------------------------------------------------------
    
    def WykonajRaport(self, raport, klucze=[], typ='txt', komunikacja=None):
        # zamiana parametrow na iso-8859-2
        if klucze<>[]:
            for i in range(len(klucze)):
                if str(type(klucze[i][1]))=="<type 'unicode'>":
                    klucze[i][1]=klucze[i][1].encode('iso-8859-2')
        stat='OK'
        dane = ''

        # pobranie okresu/w ksigowych z uwzgldnieniem uwolnienia rozrachunkw
        if not self.okres_id in ('',None,'None'):
            stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,self.okres_id)
            if stat <> 'OK':
                return 'Bdy pobierania okresu dla uwolnienia rozrachunkw: '+stat,''
            LOkr=LOkr[0].replace("'",'').replace(' ','')
        else:
            LOkr=self.okres_id
        
        TypPom=typ
        if typ=='xls':
            typ='csv'
        #pobranie nazwy definicji raportu
        raport=string.strip(raport.encode('iso_8859-2'))
        sql="SELECT tabela,czcionka_pdf,produkcyjny FROM rs_raporty WHERE (firma_id='%s') AND (raport_id='%s');"%(self.firma_id,raport)
        stat,d,wyn1,wyn2=self.PolSQL.Execute(sql,2)
        if stat<>'OK':
            return stat,''
        if len(d)>0:
            raport=string.rstrip(d[0][0])
            czcionka=string.rstrip(d[0][1])
            zawsze_produkcyjny=d[0][2]
        else:
            czcionka='4'
            zawsze_produkcyjny = False
            
        nazwa_firmy = None
        sql="SELECT opis FROM rs_firmy WHERE firma_id='%s'" % (self.firma_id)
        stat,d,wyn1,wyn2=self.PolSQL.Execute(sql,5)
        if stat == "OK" and d:
            nazwa_firmy = d
        try:
            katalog=os.getcwd()
            os.chdir(katalog+'/agata/anakonda')
            nazwaout=str(self.operator_id)+'_'+raport+'.'+typ
            nazwarap=str(self.operator_id)+'_'+raport+'.php'
            projekt = self.Baza
            if zawsze_produkcyjny and self.dod_serwer_rap:
                projekt += "p"
            tresc="<?"+chr(10)
            tresc=tresc+"include_once '../classes/core/AgataAPI.class';"+chr(10)
            tresc=tresc+"$api = new AgataAPI;"+chr(10)
            tresc=tresc+"$api->setLanguage('pl');"+chr(10)
            tresc=tresc+"$api->setReportPath('"+katalog+"/agata/anakonda/def/"+raport+".agt');"+chr(10)
            tresc=tresc+"$api->setProject("+projekt+");"+chr(10)
            tresc=tresc+"$api->setFormat('"+typ+"');"+chr(10)
            tresc=tresc+"$api->setOutputPath('"+katalog+'/agata/anakonda/out/'+nazwaout+"');"+chr(10)
            if typ=='pdf':
                tresc=tresc+"$api->setLayout('default-PDF"+czcionka+"');"+chr(10)
            elif typ=='html':
                tresc=tresc+"$api->setLayout('default-HTML"+czcionka+"');"+chr(10)
            elif typ=='sxw':
                tresc=tresc+"$api->setLayout('default-SXW');"+chr(10)
            tresc=tresc+"$api->setParameter('$firma', '"+self.firma_id+"');"+chr(10)
            tresc=tresc+"$api->setParameter('$oddzial', '"+self.oddzial_id+"');"+chr(10)
            tresc=tresc+"$api->setParameter('$okres', '"+self.okres_id+"');"+chr(10)
            tresc=tresc+"$api->setParameter('$okresrozr', '"+LOkr+"');"+chr(10)
            tresc=tresc+"$api->setParameter('$se_handlowiec', '"+self.handlowiec+"');"+chr(10)
            tresc=tresc+"$api->setParameter('$lista_dzialow', '"+self.ListaDzialow+"');"+chr(10)
            if nazwa_firmy:
                tresc=tresc+"$api->setParameter('$znacznikAnakonda', 'Dokument wygenerowany przez system Anakonda, firma: %s');\n" % nazwa_firmy
            if klucze<>[]:
                for i in range(len(klucze)):
                    param=str(klucze[i][1])
                    param=param.replace('"','\\\"')
                    tresc=tresc+"$api->setParameter('$"+klucze[i][0]+"',"+'"'+param+'");'+chr(10)
            if raport[3]=='r':
                tresc=tresc+"$ok = $api->generateReport();"
            elif raport[3]=='l':
                tresc=tresc+"$ok = $api->generateLabel();"
            else:
                tresc=tresc+"$ok = $api->generateDocument();"
            tresc=tresc+chr(10)+"?>"+chr(10)
            open(nazwarap, 'wb').write(tresc)
            try:
                os.remove(katalog+'/agata/anakonda/out/'+nazwaout)
            except:
                pass
            #os.spawnlp(os.P_WAIT, self.phpProgram, self.phpProgram, nazwarap)
            pid = os.spawnlp(os.P_NOWAIT, self.phpProgram, self.phpProgram, nazwarap)
            # ^ fixme: powinno by wykrywanie i wywalanie do logw bdw z Agaty! [JK]
            
            if komunikacja:
                potomkowie, zatrzymaj_po = komunikacja  # 2 obiekty collections.deque()
                potomkowie.append(pid)
                os.waitpid(pid, 0)
                potomkowie.remove(pid)
                if zatrzymaj_po:
                    # (jeli niepusta, id spa)
                    while True: time.sleep(10)
            else:
                os.waitpid(pid, 0)
                
            if TypPom=='xls':
                nazwaout=nazwaout.replace('.csv','.xlsx')
                wyn=fs_pliki_office.ZmienCSVwXLS(katalog+'/agata/anakonda/out/'+nazwaout.replace('.xlsx','.csv'),katalog+'/agata/anakonda/out/'+nazwaout,'iso-8859-2',True,True)

            dane=open(katalog+'/agata/anakonda/out/'+nazwaout, 'rb').read()
            
        except Exception, e:
            rsglobal.ZapiszDoLogow("Blad wykonania raportu "+raport+":"+str(e), 1)
        os.chdir(katalog)
        return stat, dane
    
#---------------------------------------
    
