
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        rs_anakonda_server_se.py
# Purpose:     proces serwera poredniczacego pomiedzy PostgreSQL a klientam RSAnakonda do obslugi polaczenia serwisowego
#
# Authors:      Michal Raburski, Aleksandra Kaminska
#
# Created:     2004/08/22
# RCS-ID:      $Id: rs_anakonda_server_se.py $
# Copyright:   (c) 2004 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# Jan Kaliszewski, 2009-08-19:
# * zmiany dot. RELOAD-u serwera (mantis: 2109)

import time
import socket		# socket objects and SSS objects
import os		# operations on files (special files - pipes)
import os.path
import sys
import rsglobal		# rsglobal.ZapiszDoLogow(), rsglobal.PodajZKonf()
import rs_process_killer  # rs_process_killer.zalozBlokade()
# import pyPgSQL
from rs_anakonda_socket	import *	# dedykowana obsluga socketow TCP

from const import *	# configuration as well as opertions' constants
from signal import *	# SIG*, signal


########################################################################
#								       #
#			Obsluga sygnalow     			       #
#								       #
########################################################################

##############################################
# 	rejestracja handlerow sygnalow	     #
##############################################

def RegisterHandlers():
  # przechwycenie sygnalu SIGUSR1 - poprawne STOP serwera
  signal(SIGUSR1, StopTerminationHandler)
  # przechwycenie sygnalu SIGUSR2 - poprawne FORCE serwera
  signal(SIGUSR2, ForceTerminationHandler)
  # przechwycenie sygnalu SIGALRM - niezaplanowane zabicie serwera
  signal(SIGALRM, TerminationHandler)

  # obsluga innych sygnalow ktore zazwyczaj powoduja zakonczenie procesu
  for sig in terminatingSigs:
    signal(sig, TerminationHandler)
  
  return

##############################################
# 	handlery sygnalow             	     #
##############################################

def TerminationHandler(signum, stackFrame):
  #handler do oblugi sygnalow powodujacych nieprzewidziany koniec
  global connection 

  rsglobal.ZapiszDoLogow("TerminationHandler",3)
  rsglobal.ZapiszDoLogow('Proces obslugujacy polaczenie serwisowe przechwycil sygnal, konczy sie', 3)
  connection.shutdown(2)
  sys.exit() 


def StopTerminationHandler(signum, stackFrame):
  global connection

  rsglobal.ZapiszDoLogow('Proces obslugujacy polaczenie serwisowe przechwycil sygnal SIGUSR1, konczy sie', 3)
  connection.send('Brak poacze do serwera. Serwer zatrzymany.')
  sys.exit()
 

def ForceTerminationHandler(signum, stackFrame):
  global connection

  rsglobal.ZapiszDoLogow("Proces obslugujacy polaczenie serwisowe przechwycil sygnal SIGUSR2, konczy sie", 3)

  connection.send('Wszystkie procesy zabite. Serwer wyczony.')
  sys.exit()
   
########################################################################
###	      Zwolnienie zasobow systemowych 			       #
########################################################################

def Exit():
    "Funkcja wykonywana przy sys.exit()"
    
    plik_blokady = rs_process_killer.zalozBlokade()
    try:
        try:
            global connection
            global readPipe
            global writePipe
            rsglobal.ZapiszDoLogow("Zamykanie polaczenia w serwisie "
                                   + str(time.time()), 3)
            connection.shutdown(1)
            #os.close(readPipe)
            #os.close(writePipe)
        except Exception, e:
            rsglobal.ZapiszDoLogow("Proces potomny przechwycil wyjatek "
                                   + str(e), 1)
    finally:
        rs_process_killer.zdejmijBlokade(plik_blokady)

########################################################################
#								       #
#			Wlasciwe cialo  procesu			       #
#								       #
########################################################################

##if len(sys.argv) < 5:
##  rsglobal.ZapiszDoLogow("Internal server error",1)
##  # inny blad - tylko sanity check (nie zajdzie), wiec nie ma bicia serwera
##  os._exit(1)
##
### pobranie polaczenia serwisowego
##con = int(sys.argv[1])
##connection = AnakondaSocket(socket.AF_INET, socket.SOCK_STREAM)
##connection.socket = socket.fromfd(con, socket.AF_INET, socket.SOCK_STREAM)
##
### pobranie pidu procesu glownego
##mainPid = int(sys.argv[2])
##
### pobranie deskryptora do czytania z procesu glownego
##readPipe = int(sys.argv[3])
##
### pobranie deskryptora do pisania do procesu glownego
##writePipe = int(sys.argv[4])
##
##
### funkcja wywolywana m.in. przy sys.exit()
##sys.exitfunc = Exit
##
### konfiguracja
##fileName = "rs-and.conf"
##params = ('logfile','loglevel','logtype')
##list = rsglobal.PodajZKonf(fileName, params)
##rsglobal.LogFile = list[0]
##rsglobal.LogLevel = int(list[1])
##rsglobal.LogType = list[2]
##
### synchronizacja poprzez sygnaly
##RegisterHandlers()
##
##rsglobal.ZapiszDoLogow('Rozpoczecie obslugi polaczenia serwisowego.',3)
### rsglobal.ZapiszDoLogow('Polaczenie serwisowe z '+str(addr),1)
##data = connection.recv()
##rsglobal.ZapiszDoLogow('polecenie z polaczenia serwisowego'+data,5)
##os.write(writePipe,data)
##data = os.read(readPipe,OPTION_LEN)
##len = os.read(readPipe, TCP_LEN_LEN)
##intLen = int(len)
##comment = os.read(readPipe, intLen)
##connection.send(comment)
##
##rsglobal.ZapiszDoLogow('Zamykanie polaczenia serwisowego ',1)#z '+str(addr),1)
##sys.exit()


def Wykonaj(con,mainPid,readPipe,writePipe):

    global connection

    #if len(sys.argv) < 5:
    #  rsglobal.ZapiszDoLogow("Internal server error",1)
    #  # inny blad - tylko sanity check (nie zajdzie), wiec nie ma bicia serwera
    #  os._exit(1)

    # pobranie polaczenia serwisowego
    #con = int(sys.argv[1])
    connection = socket.fromfd(con, socket.AF_INET, socket.SOCK_STREAM)
    connection = AnakondaSocket(socket_obj=connection)

    # pobranie pidu procesu glownego
    #mainPid = int(sys.argv[2])

    # pobranie deskryptora do czytania z procesu glownego
    #readPipe = int(sys.argv[3])

    # pobranie deskryptora do pisania do procesu glownego
    #writePipe = int(sys.argv[4])

    # funkcja wywolywana m.in. przy sys.exit()
    sys.exitfunc = Exit

    # konfiguracja
    fileName = "rs-and.conf"
    params = ('logfile','loglevel','logtype')
    list = rsglobal.PodajZKonf(fileName, params)
    rsglobal.LogFile = list[0]
    rsglobal.LogLevel = int(list[1])
    rsglobal.LogType = list[2]

    # synchronizacja poprzez sygnaly
    RegisterHandlers()

    rsglobal.ZapiszDoLogow('Rozpoczecie obslugi polaczenia serwisowego.', 3)
    # rsglobal.ZapiszDoLogow('Polaczenie serwisowe z '+str(addr),1)
    try:
        data = connection.recv()
        blad_polaczenia = False
        rsglobal.ZapiszDoLogow('polecenie z polaczenia serwisowego'+data, 5)
    except socket.error, exc:
        rsglobal.ZapiszDoLogow(
              'Bd przy prbie pobrania polecenia z poczenia serwisowego:'
              ' "%r"' % exc,
              2
        )
        data = 'BL'
        blad_polaczenia = True
    os.write(writePipe, data)
    if not blad_polaczenia:
        data = os.read(readPipe, OPTION_LEN)
        len = os.read(readPipe, TCP_LEN_LEN)
        intLen = int(len)
        comment = os.read(readPipe, intLen)
        try:
            connection.send(comment)
        except socket.error, exc:
            rsglobal.ZapiszDoLogow(
                  'Bd przy wysyaniu tekstu komunikatu na poczenie'
                  ' serwisowe: "%r"' % exc,
                  2
            )

    rsglobal.ZapiszDoLogow('Zamykanie polaczenia serwisowego ', 1)#z '+str(addr),1)
    sys.exit()
