
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        rs_anakonda_service.py
# Purpose:     program serwisowy - obsluga rs_anakonda_server
#              wywolanie: python rs_anakonda_service.py KOMENDA
#
# Author:      Michal Raburski
#
# Created:     2004/03/06
# RCS-ID:      $Id: rs_anakonda_service.py $
# Copyright:   (c) 2004 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

import sys
import socket
import time
import os
import rsglobal
from const import *
from rs_anakonda_socket import *

try:
    dostepneKomendy = ['HELP'] + service_options.keys()
    if len(sys.argv)==1:
        print 'Uzycie z opcjami HELP lub', ', '.join(dostepneKomendy[1:])
        os._exit(0)
    ZamykacSocket = False
    KOMENDA = sys.argv[1]
    if not KOMENDA in dostepneKomendy:
        print 'Uzycie z opcjami:', ', '.join(dostepneKomendy)
        os._exit(0)
    if KOMENDA == 'HELP':
        print 'Lista polecen programu rs_anakonda_service:'
        print '    STOP         - zatrzymuje rs_anakonda_server jesli nie jest on polaczony'
        print '                   z zadnym klientem'
        print '    FORCE        - wymusza zerwanie polaczen i zatrzymanie rs_anakonda_server'
        print '    LIST         - wyswietla liste aktualnych polaczen klientow'
        print '                   z rs_anakonda_server'
        print '    RELOAD       - przeladowuje caly serwer (zrodla programu i konfiguracje)'
        print '                   bez ruszania juz istniejacych procesow polaczen klienckich'
        print '    HZRELOAD     - odswieza funkcje harmonogramu (nie przeladowuje zrodel'
        print '                   programu samego serwera)'
        print '    KOMSERRELOAD - przeladowuje konfiguracje transportu miedzyserwerowego'
        print '                   (nie przeladowuje zrodel)'
        print '    HELP         - wyswietla te pomoc'
        os._exit(0)
    Lista = rsglobal.PodajZKonf('rs-and.conf',('port',))[0]
    PORT = int(Lista[Lista.find(',')+1:len(Lista)])
    HOST = 'localhost'
    print 'port:'+str(PORT)+' host:'+HOST
    
    try:
        print 'laczenie z serwerem'
        #sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        sock = AnakondaSocket(socket.AF_INET, socket.SOCK_STREAM)
        sock.connect((HOST, PORT))
    except Exception, e:
        print e
        print 'Brak polaczenia. Host:',HOST,' , Port:',PORT
        os._exit(0)
        
    print 'polaczony - wysylane polecenie :',KOMENDA
    ZamykacSocket =True
    
    try:
        print service_options[KOMENDA]
        sock.send(service_options[KOMENDA]) # korzystamy ze slownika
        #sock.send(KOMENDA) # korzystamy ze slownika
    except Exception, e:
        print e
        print 'Bledy polaczenia. Host:',HOST,' , Port:',PORT
        os._exit(0)

    data = sock.recv()
    print "Wynik: "+data
    sock.close()
    ZamykacSocket = False
    if KOMENDA in ('STOP','FORCE'):
        print 'W wypadku zatrzymania serwera przed ponownym uruchomieniem '
        print 'poczekaj 2 minuty na zwolnienie gniazd.'
except Exception,e:
    print 'BLAD POLACZENIA:',e
    if ZamykacSocket:
        sock.close()
    os._exit(0)
