# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        conn.RSAnakondaSocketSSL.py
# Purpose:     Obsuga socketw dedykowana dla programu Anakonda
#              (kod przeznaczony dla serwera [tylko przyjmowanie pocze],
#               oparty na pyOpenSSL).
#
# Author:      ?? (autor poprzedniej wersji kodu), zmiany Jan Kaliszewski
#
# Created:     2009/05/28
# RCS-ID:      $Id: conn.RSAnakondaSocketSSL.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# Jan Kaliszewski, 2009-06-25:
# * drobiazgi (w zwizku z mantis: 1904)
# * atrybut 'lokal' (w zwizku z now implementacji aktualizacji klienta)


import socket

import rsglobal
from OpenSSL import SSL
import rs_anakonda_socket


class AnakondaSocketSSL(rs_anakonda_socket.AnakondaSocket):

    def __init__(self, asocket, SSLContext):

        self.base_socket = asocket.socket
        self.socket = None
        self.SSLContext = SSLContext
        self.warunek_buforowania = rsglobal.SSL_BUF_DLA_KLIENTA
        self._ustaw_reszte()


    @property
    def lokal(self):
        return self.base_socket.lokal


    def connect(self, address):
        raise NotImplementedError


    def accept(self):
        "Czekamy na inicjalizacj poczenia SSL ze strony klienta."
        
        try: ## a upewni si, e poprz zamk?
            self.socket = SSL.Connection(self.SSLContext, self.base_socket)
            self.socket.set_accept_state()
        except Exception, exc:
            rsglobal.ZapiszDoLogow('BD AnakondaSocketSSL.accept(): ' + str(exc), 1)
            self.socket = None
            return False
        else:
            rsglobal.ZapiszDoLogow('AnakondaSocketSSL.accept() - OK', 3)
            return True


    def shutdown(self, how=socket.SHUT_RDWR):
        self.czy_sprawdzac = False  # koczymy ew. wtek sprawdzajcy poczenie
        self.socket.shutdown()
        self.socket.sock_shutdown(how)
